/*!
MICROSOFT SOFTWARE LICENSE TERMS
MICROSOFT AZURE MAPS WEB SDK
These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW.  BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS.
1. INSTALLATION AND USE RIGHTS.
  a) General. You may install and use any number of copies of the software to develop and test your applications.
  b) User Region Parameters. The software will allow you to select from a View list to set the map view within your application for a given customer. By default the View parameter (also referred to as “user region parameter” is set to “Unified”.  Countries/Regions that are not on the View list will default to the “Unified” View. It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter must be used in compliance with applicable laws, including those regarding mapping, of the country where maps, images and other data and third party content that You are authorized to access via the software is made available. 
  c) Third Party Software. The software may include third party applications that Microsoft, not the third party, licenses to you under this agreement. Any included notices for third party applications are for your information only.
  d) Microsoft Online Subscription Agreement. Some features of the software provide access to, or rely on, Microsoft Azure Services. The use of those services (but not the software) is governed by the separate terms and privacy policies associated with your Microsoft Azure subscription. The services may not be available in all regions. For more information see https://go.microsoft.com/fwLink/?LinkID=522330&amp;clcid=0x9.
2. DISTRIBUTABLE CODE. The software is comprised of “Distributable Code”. “Distributable Code” is code that you are permitted to distribute in applications you develop if you comply with the terms below and otherwise set forth in these license terms. 
  a) Distribution Rights. 
    i. You may copy and distribute the object code form of the software.
    i. Third Party Distribution. You may permit distributors of your applications to copy and distribute any of this distributable code you elect to distribute with your applications.
  b) Distribution Requirements. For any code you distribute, you must:
    i. add significant primary functionality to it in your applications;
    ii. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
    iii. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  c) Distribution Restrictions. You may not:
    i. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
    ii. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.
3. DATA COLLECTION. The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at https://go.microsoft.com/fwlink/?LinkId=512132. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.
4. SCOPE OF LICENSE. The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
  a) work around any technical limitations in the software that only allow you to use it in certain ways;
  b) reverse engineer, decompile, or disassemble the software, or attempt to do so, except and only to the extent permitted by licensing terms governing the use of open-source components that may be included with the software;
  c) remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
  d) use the software in any way that is against the law or to create or propagate malware; or
  e) share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.
5. EXPORT RESTRICTIONS. You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.
6. SUPPORT SERVICES. Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.
7. UPDATES. The software may periodically check for updates, and download and install them for you. You may obtain updates only from Microsoft or authorized sources. Microsoft may need to update your system to provide you with updates. You agree to receive these automatic updates without any additional notice. Updates may not include or support all existing software features, services, or peripheral devices.
8. ENTIRE AGREEMENT. This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.
9. APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES. If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.
10. CONSUMER RIGHTS; REGIONAL VARIATIONS. This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
  a) Australia. You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
  b) Canada. If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
  c) Germany and Austria.
    i. Warranty. The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.
    ii. Limitation of Liability. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.
  Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.
11. DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
12. LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT, OR INCIDENTAL DAMAGES.
This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.
It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.
Please note: As this software is distributed in Canada, some of the clauses in this agreement are provided below in French.
Remarque: Ce logiciel étant distribué au Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.
EXONÉRATION DE GARANTIE. Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.
LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES. Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.
Cette limitation concerne:
• tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers; et
• les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.
Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.
EFFET JURIDIQUE. Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.
*/

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("azuremaps-maplibre-gl")):"function"==typeof define&&define.amd?define(["exports","azuremaps-maplibre-gl"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).atlas=e.atlas||{},e.maplibregl)}(this,function(l,D){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function q(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}function U(o){var t,r;return o.__esModule?o:("function"==typeof(t=o.default)?(r=function e(){return this instanceof e?Reflect.construct(t,arguments,this.constructor):t.apply(this,arguments)}).prototype=t.prototype:r={},Object.defineProperty(r,"__esModule",{value:!0}),Object.keys(o).forEach(function(e){var t=Object.getOwnPropertyDescriptor(o,e);Object.defineProperty(r,e,t.get?t:{enumerable:!0,get:function(){return o[e]}})}),r)}for(var j,H,t={exports:{}},o=U(Object.freeze({__proto__:null,default:{}})),B=t,F=0,z=[],K=0;K<256;K++)z[K]=(K+256).toString(16).substr(1);function G(){e=16,(!j||Y.BUFFER_SIZE<F+e)&&(F=0,j=Y.randomBytes(Y.BUFFER_SIZE));var e=j.slice(F,F+=e);return e[6]=15&e[6]|64,e[8]=63&e[8]|128,e}function Y(){var e=G();return z[e[0]]+z[e[1]]+z[e[2]]+z[e[3]]+"-"+z[e[4]]+z[e[5]]+"-"+z[e[6]]+z[e[7]]+"-"+z[e[8]]+z[e[9]]+"-"+z[e[10]]+z[e[11]]+z[e[12]]+z[e[13]]+z[e[14]]+z[e[15]]}Y.BUFFER_SIZE=4096,Y.bin=G,Y.clearBuffer=function(){j=null,F=0},Y.test=function(e){return"string"==typeof e&&/^[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(e)},"undefined"!=typeof crypto?H=crypto:"undefined"!=typeof window&&void 0!==window.msCrypto&&(H=window.msCrypto),H=H||o,(B.exports=Y).randomBytes=function(){if(H){if(H.randomBytes)return H.randomBytes;if(H.getRandomValues)return"function"!=typeof Uint8Array.prototype.slice?function(e){e=new Uint8Array(e);return H.getRandomValues(e),Array.from(e)}:function(e){e=new Uint8Array(e);return H.getRandomValues(e),e}}return function(e){for(var t=[],o=0;o<e;o++)t.push(Math.floor(256*Math.random()));return t}}();var W=q(t.exports),Z="atlas.microsoft.com",Q="atlas.microsoft.com",o="styling",B="2023-01-01",V="https://login.microsoftonline.com/",J="api-version",X="Authorization",$="Bearer ",ee="jwt-sas ",te="{{azMapsDomain}}",oe="{azMapsDomain}",re="{{azMapsView}}",ne="view",ie="{{azMapsLanguage}}",ae="{{azMapsStylingPath}}",se="{{azMapsStylePath}}",ce="styling",ue="styles",t="2.0",le="Map-Agent",he="x-ms-client-id",de="Ms-Am-Request-Origin",pe="MapControl",fe="https://atlas.microsoft.com/.default",ge="Session-Id",me=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},ye=(ve.prototype.merge=function(){for(var t,e,o,r=[],n=0;n<arguments.length;n++)r[n]=arguments[n];try{for(var i=me(r),a=i.next();!a.done;a=i.next()){var s=a.value;if(s)for(var c in s)s.hasOwnProperty(c)&&this.hasOwnProperty(c)&&(void 0!==s[c]&&null!=s[c]?this[c]instanceof ve?this[c].merge(s[c]):this[c]=s[c]:(o=o||new(Object.getPrototypeOf(this).constructor),this[c]=o[c]))}}catch(e){t={error:e}}finally{try{a&&!a.done&&(e=i.return)&&e.call(i)}finally{if(t)throw t.error}}return this},ve);function ve(){}var _e,we,be=window&&window.__extends||(_e=function(e,t){return(_e=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}_e(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),Ce=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},Se=(be(Ee,we=ye),Ee);function Ee(){var e=null!==we&&we.apply(this,arguments)||this;return e.domain=void 0,e.headers={},e.path="",e.protocol="https",e.queryParams={},e.subdomain="",e}Ie.prototype.get=function(){return fetch(this.toString(),{method:"GET",mode:"cors",headers:new Headers(this.options.headers)}).then(function(e){if(e.ok)return e.json();throw new Error("HTTP ".concat(e.status,": ").concat(e.statusText))})},Ie.prototype.toString=function(){var e=this,t=Object.entries(e.options.queryParams).map(function(e){var e=Ce(e,2),t=e[0],e=e[1];return"".concat(t,"=").concat(e)}).join("&"),o=[],r=e.options.path||"";return Ie.protoRegEx.test(r)?o.push(r):(e.options.domain&&(Ie.protoRegEx.test(e.options.domain)||(o.push("".concat(e.options.protocol,"://")),o.push(e.options.subdomain?"".concat(e.options.subdomain,"."):"")),o.push(e.options.domain)),o.push(e.options.path?"/".concat(r):"")),o.push(t?"?".concat(t):""),o.join("")},Ie.protoRegEx=new RegExp(/^(((file|http|https):\/\/)|blob:)/i);var Te=Ie;function Ie(e){this.options=(new Se).merge(e)}Ae.parse=function(e){var t=(e=e.toLowerCase()).lastIndexOf("-");return-1!==t?{code:e,language:e.substring(0,t),region:e.substring(t+1)}:{code:e,language:e}};var ke=Ae;function Ae(){}var Pe={localizationsPath:"locs/mapcontrol/2019-3-12",sensitiveUserRegions:["il","kr","pk","in","cn","ar","bh","eg","jo","sa","kw","om","qa","ma","ae"],locales:{defaultLanguage:{defaultRegion:{code:"NGT",strings:"en/resource.json"},latn:{code:"NGT-Latn",strings:"en/resource.json"}},ar:{defaultRegion:{code:"ar",strings:"ar-sa/resource.json"}},bg:{defaultRegion:{code:"bg-BG",strings:"bg-bg/resource.json"}},cs:{defaultRegion:{code:"cs-CZ",strings:"cs-cz/resource.json"}},da:{defaultRegion:{code:"da-DK",strings:"da-dk/resource.json"}},de:{defaultRegion:{code:"de-DE",strings:"de-de/resource.json"}},el:{defaultRegion:{code:"el-GR",strings:"el-gr/resource.json"}},en:{defaultRegion:{code:"en",strings:"en/resource.json"},us:{code:"en-US",strings:"en/resource.json"},au:{code:"en-AU",strings:"en/resource.json"},gb:{code:"en-GB",strings:"en/resource.json"},nz:{code:"en-NZ",strings:"en/resource.json"}},es:{defaultRegion:{code:"es-ES",strings:"es-es/resource.json"},mx:{code:"es-MX",strings:"es-mx/resource.json"}},fi:{defaultRegion:{code:"fi-FI",strings:"fi-fi/resource.json"}},fr:{defaultRegion:{code:"fr-FR",strings:"fr-fr/resource.json"}},hu:{defaultRegion:{code:"hu-HU",strings:"hu-hu/resource.json"}},id:{defaultRegion:{code:"id-ID",strings:"id-id/resource.json"}},it:{defaultRegion:{code:"it-IT",strings:"it-it/resource.json"}},ko:{defaultRegion:{code:"ko-KR",strings:"ko-kr/resource.json"}},lt:{defaultRegion:{code:"lt-LT",strings:"lt-lt/resource.json"}},ms:{defaultRegion:{code:"ms-MY",strings:"ms-my/resource.json"}},nb:{defaultRegion:{code:"nb-NO",strings:"nb-no/resource.json"}},nl:{defaultRegion:{code:"nl-NL",strings:"nl-nl/resource.json"}},pl:{defaultRegion:{code:"pl-PL",strings:"pl-pl/resource.json"}},pt:{defaultRegion:{code:"pt-PT",strings:"pt-pt/resource.json"},br:{code:"pt-BR",strings:"pt-br/resource.json"}},ru:{defaultRegion:{code:"ru-RU",strings:"ru-ru/resource.json"}},sk:{defaultRegion:{code:"sk-SK",strings:"sk-sk/resource.json"}},sl:{defaultRegion:{code:"sl-SL",strings:"sl-sl/resource.json"}},sv:{defaultRegion:{code:"sv-SE",strings:"sv-se/resource.json"}},th:{defaultRegion:{code:"th-TH",strings:"th-th/resource.json"}},tr:{defaultRegion:{code:"tr-TR",strings:"tr-tr/resource.json"}},zh:{defaultRegion:{code:"zh",strings:"en/resource.json"}},"zh-hans":{defaultRegion:{code:"zh-Hans",strings:"zh-cn/resource.json"},cn:{code:"zh-Hans-CN",strings:"zh-cn/resource.json"}},"zh-hant":{defaultRegion:{code:"zh-Hant",strings:"en/resource.json"},tw:{code:"zh-Hant-TW",strings:"zh-tw/resource.json"}}}},Oe=function(){this.Unknown="Unknown",this.Accident="Accident",this.Fog="Fog",this.Danger="Danger",this.Rain="Rain",this.Ice="Ice",this.Jam="Jam",this.LaneClosed="Lane Closed",this.RoadClosed="Road Closed",this.RoadWorks="Road Works",this.Wind="Wind",this.Flood="Flood",this.Detour="Detour"},Re=(xe.getCode=function(e){0===e.localeCompare("auto",void 0,{sensitivity:"base"})&&(e=navigator.language);var t=ke.parse(e);return-1===Pe.sensitiveUserRegions.indexOf(t.region)?this.getLocaleData(t).code:e},xe.getStrings=function(e){e=this.getLocaleData(e);return Pe.locales.defaultLanguage.defaultRegion.code===e.code?new Promise(function(e){e(new Oe)}):new Te({domain:Q,path:"".concat(Pe.localizationsPath,"/").concat(e.strings)}).get().then(function(e){return e},function(){return new Oe})},xe.getLocaleData=function(e){if("string"==typeof e&&(e=ke.parse(e)),Pe.locales[e.code])return Pe.locales[e.code].defaultRegion;var t;if(Pe.locales[e.language])t=Pe.locales[e.language];else{if(-1!==e.language.indexOf("-"))return this.getLocaleData(e.language);t=Pe.locales.defaultLanguage}return e.region&&t[e.region]?t[e.region]:t.defaultRegion},xe);function xe(){}Ne.getEdgeOrIEVersion=function(){var e=window.navigator.userAgent,t=e.indexOf("MSIE ");return 0<t?parseInt(e.substring(t+5,e.indexOf(".",t)),10):0<e.indexOf("Trident/")?(t=e.indexOf("rv:"),parseInt(e.substring(t+3,e.indexOf(".",t)),10)):0<(t=e.indexOf("Edge/"))?parseInt(e.substring(t+5,e.indexOf(".",t)),10):-1},Ne.isEdgeOrIE=function(){return-1!==this.getEdgeOrIEVersion()},Ne.isIE=function(){var e=this.getEdgeOrIEVersion();return-1!==e&&e<=11};var Me=Ne;function Ne(){}var Le="3.6.1",De=(qe.getFullVersion=function(){return Le},qe.getEndpointVersion=function(){var e=Le.indexOf(".");return-1===(e=Le.indexOf(".",e+1))?Le:Le.substring(0,e)},qe);function qe(){}var Ue,je,be=window&&window.__extends||(Ue=function(e,t){return(Ue=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ue(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),He=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},Be=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},Fe=(l.AuthenticationType=void 0,(Kt=l.AuthenticationType||(l.AuthenticationType={})).subscriptionKey="subscriptionKey",Kt.aad="aad",Kt.anonymous="anonymous",Kt.sas="sas",be(ze,je=ye),ze.prototype.setSubscriptionKey=function(e){this.authType=l.AuthenticationType.subscriptionKey,this.subscriptionKey=e},ze.prototype.setAadProperties=function(e,t,o,r,n){this.authType=l.AuthenticationType.aad,this.authContext=n||this.authContext,this.aadInstance=r||this.aadInstance,this.clientId=e,this.aadAppId=t,this.aadTenant=o},ze.prototype.setTokenCallbackFunction=function(e){this.authType=l.AuthenticationType.anonymous,this.getToken=e},ze.prototype.setSasCallbackFunction=function(e){this.authType=l.AuthenticationType.sas,this.getToken=e},ze.prototype.merge=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var o=je.prototype.merge.apply(this,Be([],He(e),!1));return o.authType===l.AuthenticationType.subscriptionKey?o.authContext=o.aadAppId=o.getToken=void 0:o.authType===l.AuthenticationType.aad?o.subscriptionKey=o.getToken=void 0:o.authType===l.AuthenticationType.anonymous?o.subscriptionKey=o.authContext=o.aadAppId=void 0:o.authType===l.AuthenticationType.sas&&(o.authContext=o.subscriptionKey=o.aadAppId=void 0),o},ze);function ze(){var e=null!==je&&je.apply(this,arguments)||this;return e.authType=void 0,e.subscriptionKey=void 0,e.clientId=void 0,e.aadAppId=void 0,e.aadTenant=void 0,e.aadInstance=void 0,e.getToken=void 0,e.sasToken=void 0,e.authContext=void 0,e}var Ke;var Ge="NGT",Ye=W(),We=Z,Ze=Q,Qe=o,Ve=B,Je=t,Xe=new Fe,$e=!1,et=!1,tt=!1,ot=!1,rt=!1,nt=!1,it=!1,at=!1,st=!1;function ct(){return Object.assign({},Xe)}function ut(){return Ze}function lt(){return We}function ht(){return Qe}function dt(){return Ve}function pt(){return Je}function ft(){return D.getWorkerCount()}function gt(){return D.getMaxParallelImageRequests()}function mt(){return Ge}function yt(){return Ye}function vt(){return Xe.authType===l.AuthenticationType.subscriptionKey?Xe.subscriptionKey:void 0}function _t(){return Ke}function wt(e){Xe=(new Fe).merge(Xe,e),st=!0}function bt(e){We=e,et=!0}function Ct(e){Qe=e,tt=!0}function St(e){0<e&&(D.setWorkerCount(e),rt=!0)}function Et(e){0<e&&(D.setMaxParallelImageRequests(e),nt=!0)}function Tt(e){Ge=Re.getCode(e),it=!0}function It(e){Ye=e,at=!0}function kt(e){Xe.setSubscriptionKey(e),st=!0}function At(e){Ke=e,$e=!0}function Pt(e,t){if(t=Math.abs(t||1),"string"==typeof e&&zt[e.toLowerCase()]){for(var o=zt[e.toLowerCase()],r=/calc\(([0-9.]+)[px]*\s*\*\s*\{scale\}\)/gi,n=o,i=r.exec(o);i;)n=n.replace(i[0],parseFloat(i[1])*t+""),i=r.exec(o);return n=n.replace("{scale}",t+"")}throw new Error("Invalid templateName.")}function Ot(){return st}function Rt(){return et}function xt(){return tt}function Mt(){return rt}function Nt(){return nt}function Lt(){return it}function Dt(){return at}function qt(){return $e}function Ut(){var e=new Te({domain:Q,path:"sdk/javascript/mapcontrol/".concat(De.getEndpointVersion(),"/mapbox-gl-rtl-text.min.js")});D.setRTLTextPlugin(e.toString(),!0).catch(function(e){e&&console.warn(e)})}function jt(e){var t=document.createElement("span");return t.innerText=e,t.classList.add("tooltiptext"),-1!=navigator.userAgent.indexOf("Edg")?t.classList.add("edge"):-1!=navigator.userAgent.indexOf("Chrome")?t.classList.add("chrome"):-1!=navigator.userAgent.indexOf("Safari")?t.classList.add("safari"):-1!=navigator.userAgent.indexOf("Firefox")&&t.classList.add("firefox"),-1!=navigator.userAgent.indexOf("Windows")?t.classList.add("win"):-1!=navigator.userAgent.indexOf("Macintosh")&&t.classList.add("mac"),t}function Ht(n,i,a){function e(e){var t=i.getBoundingClientRect(),o=n.getBoundingClientRect(),r=t.x+o.width>window.innerWidth?window.innerWidth-o.width:t.x,o=t.y+t.height+o.height+4>window.innerHeight?t.y-o.height-4:t.y+t.height+4;a&&i.parentElement&&(t=i.parentElement?i.parentElement.getBoundingClientRect():null,n.style.position="absolute",r-=t.x,o-=t.y),n.style.transform="translate(".concat(r,"px, ").concat(o,"px)"),n.style.display="block"}void 0===a&&(a=!1),i.addEventListener("mouseover",e),i.addEventListener("focusin",e),i.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||"block"!==n.style.display||(e.stopPropagation(),n.style.display="none")})}var Bt,Ft,zt={marker:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 26 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:1"/><text x="12.5" y="17.5" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 27 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:2"/><text x="12.5" y="18.5" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-circle":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 27 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:1"/><circle cx="12.5" cy="12.5" r="9" fill="{secondaryColor}"/><text x="12" y="17.5" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',pin:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(24 * {scale})" height="calc(28 * {scale})" viewBox="0 0 24 28"><path d="m11.988 16.615a5.15 5.15 0 0 1-2.268-.525 4.909 4.909 0 0 1-2.805-4.442 5.019 5.019 0 0 1 5.072-4.936h.012a5.03 5.03 0 0 1 5.085 4.961 4.907 4.907 0 0 1-.549 2.224 5.114 5.114 0 0 1-4.548 2.718zm0-8.06a3.173 3.173 0 0 0-3.226 3.099 3.081 3.081 0 0 0 1.77 2.782 3.299 3.299 0 0 0 4.365-1.386 3.049 3.049 0 0 0 .342-1.381 3.184 3.184 0 0 0-3.239-3.114h-.012z" fill="{secondaryColor}"/><path d="m11.999.922a10.908 10.908 0 0 0-11.076 10.732 10.639 10.639 0 0 0 4.418 8.598l6.658 6.464 6.658-6.463a10.537 10.537 0 0 0 2.198-15.041 11.182 11.182 0 0 0-8.856-4.289zm1.873 14.341a4.221 4.221 0 0 1-5.589-1.789 3.945 3.945 0 0 1-.445-1.8 4.164 4.164 0 0 1 8.323-.037 4.028 4.028 0 0 1-2.289 3.626Z" fill="{color}"/><path d="m11.999 28-7.256-7.044a11.611 11.611 0 0 1-4.743-9.303 11.844 11.844 0 0 1 11.988-11.652.102 .102 0 0 1 .02 0 12.164 12.164 0 0 1 9.577 4.647 11.357 11.357 0 0 1 2.299 8.614 11.521 11.521 0 0 1-4.63 7.695zm-.01-26.157a9.997 9.997 0 0 0-10.143 9.812 9.769 9.769 0 0 0 4.04 7.853l.099.083 6.014 5.838 6.113-5.922a9.7 9.7 0 0 0 3.945-6.505 9.533 9.533 0 0 0-1.933-7.229 10.305 10.305 0 0 0-8.116-3.931h-.021zm.021 14.772a5.11 5.11 0 0 1-4.547-2.718 4.868 4.868 0 0 1 .932-5.743 5.118 5.118 0 0 1 3.58-1.46h.024a5.031 5.031 0 0 1 5.084 4.938 4.92 4.92 0 0 1-2.805 4.457h0a5.152 5.152 0 0 1-2.269.525zm-.011-8.079h-.015a3.277 3.277 0 0 0-2.295.933 3.029 3.029 0 0 0-.587 3.58 3.297 3.297 0 0 0 4.364 1.386h0a3.092 3.092 0 0 0 1.772-2.795 3.185 3.185 0 0 0-3.239-3.105z" fill="{secondaryColor}"/><text x="12" y="17" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',"pin-round":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(25 * {scale})" height="calc(25 * {scale})" viewBox="0 0 25 25"><g transform="translate(0 1)"><circle cx="12.25" cy="11.5833" r="11" fill="{color}"/><path d="m12.25 23.583a12 12 0 1 1 12-12 12 12 0 0 1-12 12zm0-22a10 10 0 1 0 10 10 10 10 0 0 0-10-10z" fill="{secondaryColor}"/><circle cx="12.25" cy="11.5833" r="4.2386" fill="{secondaryColor}"/></g><text x="12.5" y="17" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',"marker-flat":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(42.8 * {scale})"  viewBox="0 0 1600 2570"><g fill="{color}"><path d="M691 2419c-409-575-641-1086-683-1504-10-106-10-136 5-224 31-188 105-330 241-458 129-124 270-190 453-214 69-9 113-10 182-1 373 46 655 326 703 698 40 308-120 801-424 1309-134 224-348 535-369 535-4 0-53-63-108-141z"/></g><g fill="rgba(0,0,0,0.15)" style="transform:scale(-1,1);transform-origin:center"><path d="M691 2419c-407-571-639-1083-682-1498-14-139-3-249 37-371 69-208 254-402 459-481 68-27 217-59 271-59h24v160 180 940 635c0 349-2 635-5 635-2 0-49-63-104-141z"/></g><circle cx="800" cy="800" r="600" fill="{secondaryColor}"/><text x="800" y="1100" style="font-size:800px;fill:#000;text-anchor:middle">{text}</text></svg>',"marker-arrow":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(25.47 * {scale})" height="calc(35.18 * {scale})" viewBox="0 0 4330 5980"><g fill="{color}"><path d="m2080 5969c-49-20-93-63-115-113-25-55-1928-5486-1953-5573-40-138 67-282 210-283 36 0 246 73 987 345 518 190 947 345 955 345 8 0 438-155 955-345 615-226 954-345 979-345 87 0 165 47 204 123 46 91 107-95-957 2942-537 1535-986 2805-997 2823-11 18-43 46-72 62-41 24-62 30-111 29-33 0-71-5-85-10z"/></g><g fill="{secondaryColor}"><path d="m2200 1600c-36 10-83 2-484-84-243-53-451-94-461-91-11 4-22 18-25 31-5 19 114 371 436 1292 244 697 448 1273 454 1281 19 24 50 30 71 12z"/><path d="m2200 1600c-36 10-83 2-484-84-243-53-451-94-461-91-11 4-22 18-25 31-5 19 114 371 436 1292 244 697 448 1273 454 1281 19 24 50 30 71 12z" style="transform:scale(-1,1);transform-origin:center"/></g><g fill="rgba(0,0,0,0.2)" ><path d="m2165 685c8 0 438-155 955-345 615-226 954-345 979-345 87 0 165 47 204 123 46 91 107-95-957 2942-537 1535-986 2805-997 2823-11 18-43 46-72 62-41 24-62 30-111 29z"/></g><text x="2165" y="3300" style="font-size:2500px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-ball-pin":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(15.67 * {scale})" height="calc(33.33 * {scale})" viewBox="0 0 235 452"><g transform="translate(-135 10)"><path fill="{secondaryColor}" d="m256 442 0 0c-13 0-18-11-18-24l-6-323c0-13 11-24 24-24h0c13 0 24 11 24 24l-6 323c0 13-5 24-18 24z"/><circle style="fill:{color};stroke-width:10;stroke:{secondaryColor}" cx="256" cy="112" r="111"/><ellipse transform="matrix(0.834 0.5518 -0.5518 0.834 65.7916 -97.18)" fill="rgba(255,255,255,0.3)" cx="194.399" cy="60.749" rx="19.076" ry="32.428"/></g><text x="117.5" y="160" style="font-size:160px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(26.67 * {scale})" height="calc(32.27 * {scale})" viewBox="0 0 2000 2420"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="M845 2152c-22-37-58-95-80-129-22-35-62-99-90-143l-50-80-312 0-313 0 0-900 0-900 900 0 900 0 0 900 0 900-313 0-313 0-34 58c-19 31-38 59-42 60-5 2-8 8-8 12 0 9-69 123-88 145-5 6-11 15-13 21-16 39-77 123-89 124-8 0-33-31-55-68z"/></g><text x="1000" y="1300" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square-cluster":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(33.33 * {scale})" height="calc(38.8 * {scale})" viewBox="0 0 2500 2910"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="m866 2652c-17-31-37-68-46-82-9-14-32-54-51-90-19-36-50-92-70-125l-36-60-332-3-331-2 0-905 0-905 660 0 660 0 0-38c0-71 50-196 102-258 71-85 189-164 244-164 12 0 26-4 29-10 8-13 222-13 230 0 3 6 17 10 30 10 25 0 117 45 154 76 130 107 191 232 191 392 0 155-63 284-190 386-36 29-129 76-150 76-11 0-22 5-25 10-3 6-31 10-61 10l-54 0 0 660 0 660-332 2-332 3-29 50c-17 28-48 84-70 125-22 41-47 86-56 100-9 14-30 51-46 83-17 32-36 57-45 57-8 0-28-25-44-58z"/></g><text x="1650" y="900" style="font-size:1000px;fill:#fff">+</text><text x="1000" y="1800" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square-rounded":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(26.8 * {scale})" height="calc(32.27 * {scale})" viewBox="0 0 2010 2410"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="M856 2155c-20-30-36-59-36-65 0-5-4-10-10-10-5 0-10-5-10-11 0-5-18-37-40-69-22-32-40-64-40-69 0-6-4-11-10-11-5 0-10-5-10-10 0-6-15-33-32-60l-33-50-127 0c-74 0-129-4-133-10-3-5-17-10-30-10-25 0-116-45-155-76-87-69-142-151-178-265-15-46-17-1075-2-1084 5-3 10-17 10-30 0-13 5-27 10-30 6-3 10-13 10-22 0-22 83-135 122-168 57-46 62-50 112-75l50-25 585 0 586 0 63 34c84 46 169 133 212 218l35 68 0 565 0 565-28 59c-32 69-100 157-139 180-15 9-33 22-40 29-23 22-99 57-123 57-13 0-27 5-30 10-4 6-60 10-135 10l-128 0-128 205c-84 136-133 205-144 205-10 0-33-24-54-55z"/></g><text x="1000" y="1300" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square-rounded-cluster":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(33.33 * {scale})" height="calc(32.13 * {scale})" viewBox="0 0 2500 2900"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="m874 2669c-9-18-26-49-37-68-11-20-30-55-43-78-13-24-36-64-51-90-14-27-38-69-52-95l-26-48-142 0c-84 0-144-4-148-10-3-5-17-10-30-10-25 0-118-46-154-76-91-76-136-142-175-254-13-38-16-119-16-554 0-358 3-520 12-545 40-125 106-219 195-278 127-84 116-83 646-83l467 0 0-42c0-46 11-87 45-163 54-121 169-220 306-264 46-14 232-14 278 0 165 53 284 175 340 350 19 61 14 204-10 273-32 91-94 178-169 240-38 31-130 76-155 76-13 0-27 5-30 10-3 6-28 10-56 10l-49 0 0 462c0 446-1 464-21 522-32 91-94 178-169 240-38 31-130 76-155 76-13 0-27 5-30 10-4 6-65 10-149 10-138 0-143 1-154 23-12 23-62 114-112 202-16 28-44 79-63 115-42 77-67 88-93 39z"/></g><text x="1650" y="900" style="font-size:1000px;fill:#fff">+</text><text x="1000" y="1800" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',flag:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(23.5 * {scale})" height="calc(40 * {scale})" viewBox="34 28 198 308"><path style="stroke:{secondaryColor};stroke-width:15;stroke-linecap:round;" d="M42 327l0 -291"/><path style="fill:{color};stroke:{secondaryColor};stroke-width:10;stroke-linejoin:round;" d="M49 50c70 30 104 28 178 2-21 42-21 74 0 116-72 25-101 25-178 0l0-118z"/><text x="130" y="165" style="font-size:100px;fill:#fff;text-anchor:middle">{text}</text></svg>',"flag-triangle":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(35.33 * {scale})" viewBox="0 0 40.5 53"><g transform="translate(-31 -20)"><path fill="{secondaryColor}" d="M34.7,73.3V48.4l34.6-10.1c0.7-0.2,1.2-0.8,1.2-1.5s-0.4-1.4-1-1.7L33.7,20.5c-0.5-0.2-1.1-0.2-1.6,0.2 c-0.5,0.3-0.7,0.8-0.7,1.4v51.2H34.7z"/><polygon points="34.7,24.5 66,36.5 34.7,45 34.7,10" fill="{color}"/></g><text x="11" y="21" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"rounded-square":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(34 * {scale})" height="calc(34 * {scale})" viewBox="0 0 34 34"><g transform="translate(2 2)"><rect x="0" y="0" rx="8" ry="8" width="30" height="30" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17" y="22" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"rounded-square-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(38 * {scale})" height="calc(38 * {scale})" viewBox="0 0 38 38"><g transform="translate(4 4)"><rect x="0" y="0" rx="8" ry="8" width="30" height="30" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19" y="24" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',triangle:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(36 * {scale})" height="calc(36 * {scale})" viewBox="0 0 36 36"><g transform="translate(2 2)"><polygon points="16,0 32,32 0,32 16,0" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17.5" y="30" style="font-size:12px;fill:#fff;text-anchor:middle">{text}</text></svg>',"triangle-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 40 40"><g transform="translate(4 4)"><polygon points="16,0 32,32 0,32 16,0" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19.5" y="32" style="font-size:12px;fill:#fff;text-anchor:middle">{text}</text></svg>',hexagon:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(35 * {scale})" height="calc(40 * {scale})" viewBox="0 0 35 40"><g transform="translate(2 2)"><path d="M31 9 15.5 0 0 9 0 27 15.5 36 31 27 31 9Z" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17.5" y="25" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"hexagon-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(39 * {scale})" height="calc(44 * {scale})" viewBox="0 0 39 44"><g transform="translate(4 4)"><path d="M31 9 15.5 0 0 9 0 27 15.5 36 31 27 31 9Z" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19.5" y="27" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"hexagon-rounded":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 1100 1100"><g transform="translate(50 50)"><path style="stroke:{secondaryColor};stroke-width:50;fill:{color}" d="M881 210 561 25c-33-19-88-19-121 0L119 210c-33 19-61 67-61 105v370c0 39 27 86 61 105l321 185c33 19 88 19 122 0l321-185c33-19 61-67 61-105V315C942 276 915 229 881 210z"/></g><text x="550" y="700" style="font-size:400px;fill:#fff;text-anchor:middle">{text}</text></svg>',"hexagon-rounded-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 1200 1200"><g transform="translate(100 100)"><path style="stroke:{secondaryColor};stroke-width:100;fill:{color}" d="M881 210 561 25c-33-19-88-19-121 0L119 210c-33 19-61 67-61 105v370c0 39 27 86 61 105l321 185c33 19 88 19 122 0l321-185c33-19 61-67 61-105V315C942 276 915 229 881 210z"/></g><text x="600" y="750" style="font-size:400px;fill:#fff;text-anchor:middle">{text}</text></svg>',"triangle-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(28 * {scale})" viewBox="0 0 28 28"><g transform="translate(2 2)"><polygon points="12,0 0,24 12,17 24,24" stroke-width="2" stroke="{secondaryColor}" fill="{color}"/></g><text x="14" y="17" style="font-size:8px;fill:#fff;text-anchor:middle">{text}</text></svg>',"triangle-arrow-left":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(28 * {scale})" viewBox="0 0 28 28"><g transform="translate(2 2)"><polygon points="24,12 0,0 7,12 0,24" stroke-width="2" stroke="{secondaryColor}" fill="{color}"/></g><text x="14" y="16.5" style="font-size:8px;fill:#fff;text-anchor:middle">{text}</text></svg>',"arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(12.16 * {scale})" height="calc(30.1 * {scale})" viewBox="0 0 902 364"><g fill="{color}" transform="matrix(0,2.4,-2.4,0,897,-930)"><polygon points="902,222 233,222 233,364 0,182 233,0 233,141 902,141 902,222"/></g><text x="450" y="700" style="font-size:900px;fill:#000;text-anchor:middle">{text}</text></svg>',"arrow-up-thin":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(33.33 * {scale})" viewBox="0 0 12 25"><g transform="translate(-136.91823 -751.91998)"><path fill="{color}" d="m148.271 760.71c-1.641-.547-3.186-1.47-4.633-2.769l0 18.07-1.675 0 0-18.07c-1.447 1.299-2.986 2.222-4.616 2.769l0-1.231c2.325-1.596 4.006-3.812 5.043-6.65l.838 0c1.037 2.838 2.718 5.055 5.043 6.65l0 1.231z"/></g><text x="6" y="20" style="font-size:10px;fill:#000;text-anchor:middle">{text}</text></svg>',car:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(21.93 * {scale})" height="calc(40.9 * {scale})" viewBox="0 0 6580 12270"><g transform="translate(0 12270) rotate(-90)"><path fill="{secondaryColor}" d="M7045 6566c-42-13-105-44-105-51 0-2 23-105 50-228 28-123 50-230 50-236 0-8-241-11-907-11-855 0-1145 6-1513 30-85 6-189 13-230 15-41 3-133 10-205 15-286 21-430 32-705 50-953 63-1459 18-2335-205-304-77-746-209-799-238-131-72-221-408-285-1062-34-345-42-532-48-1130-16-1557 108-2532 336-2649 32-17 469-149 676-205 409-110 819-191 1205-238 116-14 224-18 540-18 395 1 494 5 1140 50 1124 79 1224 82 2496 78l641-3-53-237c-29-131-52-238-51-239 1-1 31-14 66-29 56-23 76-26 142-23 67 3 83 7 120 33 23 17 50 41 61 55 10 14 51 117 91 230l73 205 674 3 675 2 90-39c98-43 198-72 315-93 122-21 829-18 990 5 321 45 626 143 849 270 293 168 516 378 704 662 266 402 416 893 467 1527 15 174 8 882-9 998-6 41-18 127-27 190-69 502-253 969-523 1325-79 105-262 284-381 374-189 142-355 229-574 300-336 110-526 139-952 148-457 9-685-23-887-124l-47-24-678-6-678-6-64 179c-79 224-92 253-121 284-67 70-177 97-274 66zm-2752-5073c-23-2-64-2-90 0-26 2-7 3 42 3 50 0 71-1 48-3zm395 0c-21-2-55-2-75 0-21 2-4 4 37 4 41 0 58-2 38-4z"/><path fill="{color}" d="M7043 6498c-13-6-23-19-23-28 0-9 23-117 50-240 28-123 50-230 50-237 0-22-2126-13-2465 10-132 10-400 28-595 42-661 47-824 55-1160 62-435 7-656-8-1040-73-415-70-865-183-1447-365-168-53-272-556-325-1569-16-319-16-1311 0-1630 45-872 129-1366 257-1518 22-26 51-39 172-77 557-177 1122-310 1563-369 271-36 351-40 690-40 361 1 463 6 1165 54 1122 78 1288 83 2337 79 460-2 840-7 843-11 4-4-17-117-47-252l-55-245 39-16c76-30 180-8 224 47 10 13 54 124 98 246l79 222 709 0 709 0 47-24c74-37 219-83 322-101 122-22 606-32 802-16 374 29 658 102 933 238 124 62 271 155 361 230l61 51 6 100c19 278 103 497 247 643 88 89 173 136 278 152l70 11 41 131c116 369 159 673 168 1170 10 584-38 984-167 1397l-40 126-70 12c-193 33-348 175-441 405-56 139-89 302-89 445 0 43-3 47-58 91-290 235-644 384-1068 450-191 29-796 39-974 16-135-18-263-54-368-102l-75-35-701 0-701 0-79 223c-82 232-102 267-163 293-38 16-138 17-170 2zm-2023-820c332-15 1155-12 1835 6 308 8 563 12 566 8 4-4 10-21 13-38 7-30 6-31-92-77-518-244-1197-396-2112-474-295-25-1282-25-1579 0-231 20-473 46-479 51-6 7 49 110 93 171 160 226 416 335 855 365 142 10 539 5 900-12zm3304-263c525-111 899-887 934-1935 19-557-37-1023-172-1435-186-563-521-900-896-899-81 0-158 14-525 92-426 91-431 92-540 146-195 96-287 207-306 368-12 104-11 2985 1 3078 22 170 135 291 365 389 49 21 191 55 480 115 226 47 419 87 430 89 45 10 164 6 229-8zm-5570-485c112-43 197-156 216-291 12-83 13-2623 1-2706-23-158-125-273-270-304-44-9-100-1-542 75-272 47-514 91-539 98-266 68-487 424-594 958-56 280-70 548-40 800 56 484 207 878 414 1081 115 114 122 116 702 218 277 49 524 90 550 90 26 1 72-8 102-19zm2111-3440c1023-44 1884-213 2462-486l113-53-7-33c-3-18-8-35-10-37-2-3-236 1-521 7-993 24-1271 26-1708 11-541-18-1128-18-1249-1-377 56-588 181-734 437-32 55-41 79-32 84 12 8 246 32 491 51 356 28 815 36 1195 20z"/></g><text x="3250" y="8250" style="font-size:3000px;fill:#fff;text-anchor:middle">{text}</text></svg>',checker:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(16 * {scale})" viewBox="0 0 16 16"><pattern id="p" x="0" y="0" width="16" height="16" patternUnits="userSpaceOnUse"><rect fill="{color}" x="0" width="8" height="8" y="0"/><rect fill="{color}" x="8" width="8" height="8" y="8"/></pattern><rect x="0" y="0" width="16" height="16" fill="{secondaryColor}"/><rect x="0" y="0" width="16" height="16" fill="url(#p)"/></svg>',"checker-rotated":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(16 * {scale})" viewBox="0 0 60 60"><rect width="60" height="60" fill="{secondaryColor}"/><rect width="42.42" height="42.42" transform="translate(30 0) rotate(45)" fill="{color}"/></svg>',"zig-zag":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(15 * {scale})" height="calc(15 * {scale})" viewBox="0 0 120 120"><rect x="0" y="0" width="120" height="120" fill="{secondaryColor}"/><polygon fill="{color}" points="120 120 60 120 90 90 120 60 120 0 120 0 60 60 0 0 0 60 30 90 60 120 120 120"/></svg>',"zig-zag-vertical":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(15 * {scale})" height="calc(15 * {scale})" viewBox="0 0 120 120"><rect x="0" y="0" width="120" height="120" fill="{secondaryColor}"/><polygon fill="{color}" points="120 0 120 60 90 30 60 0 0 0 0 0 60 60 0 120 60 120 90 90 120 60 120 0"/></svg>',"circles-spaced":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 20 20"><defs><pattern id="p" x="0" y="0" width="20" height="20" patternUnits="userSpaceOnUse"><circle cx="10" cy="10" r="2" stroke="none" fill="{color}"/></pattern></defs><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><rect x="0" y="0" width="100" height="100" fill="url(#p)"/></svg>',circles:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(7 * {scale})" height="calc(7 * {scale})" viewBox="0 0 20 20"><defs><pattern id="p" x="0" y="0" width="20" height="20" patternUnits="userSpaceOnUse"><circle cx="10" cy="10" r="6" stroke="none" fill="{color}"/></pattern></defs><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><rect x="0" y="0" width="100" height="100" fill="url(#p)"/></svg>',"diagonal-lines-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"diagonal-lines-down":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(90 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"diagonal-stripes-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',"diagonal-stripes-down":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g transform="rotate(90 20 20)" fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',"grid-lines":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(14 * {scale})" height="calc(14 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(45 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g><g fill="{color}" transform="rotate(-45 3 3)"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"rotated-grid-lines":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(90 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g><g fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"rotated-grid-stripes":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g transform="rotate(90 20 20)" fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g><g fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',"x-fill":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="45.3" height="45.3" fill="{secondaryColor}"/><g fill="{color}"><path d="M0 38.59l2.83-2.83 1.41 1.41L1.41 40H0v-1.41zM0 1.4l2.83 2.83 1.41-1.41L1.41 0H0v1.41zM38.59 40l-2.83-2.83 1.41-1.41L40 38.59V40h-1.41zM40 1.41l-2.83 2.83-1.41-1.41L38.59 0H40v1.41zM20 18.6l2.83-2.83 1.41 1.41L21.41 20l2.83 2.83-1.41 1.41L20 21.41l-2.83 2.83-1.41-1.41L18.59 20l-2.83-2.83 1.41-1.41L20 18.59z"/></g></svg>',dots:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(13 * {scale})" height="calc(13 * {scale})" viewBox="0 0 20 20"><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><g fill="{color}"><circle cx="3" cy="3" r="3"/><circle cx="13" cy="13" r="3"/></g></svg>'},Kt=window&&window.__extends||(Bt=function(e,t){return(Bt=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Bt(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),Gt=(l.ControlPosition=void 0,(be=l.ControlPosition||(l.ControlPosition={})).TopLeft="top-left",be.TopRight="top-right",be.BottomLeft="bottom-left",be.BottomRight="bottom-right",be.NonFixed="non-fixed",Kt(Yt,Ft=ye),Yt);function Yt(){var e=null!==Ft&&Ft.apply(this,arguments)||this;return e.position=l.ControlPosition.NonFixed,e}Zt.prototype.getLuminosity=function(){for(var e=[this.r,this.g,this.b],t=[],o=0;o<e.length;o++){var r=e[o]/255;t[o]=r<=.03928?r/12.92:Math.pow((.055+r)/1.055,2.4)}return.2126*t[0]+.7152*t[1]+.0722*t[2]},Zt.prototype.getRBGA=function(e){var t=document.createElement("canvas").getContext("2d"),e=(t.globalAlpha=1,t.fillStyle=e,t.fillRect(0,0,1,1),t.getImageData(0,0,1,1).data);return[e[0],e[1],e[2],e[3]]};var Wt=Zt;function Zt(e){var t;e&&(t=void 0,3<=(t="string"==typeof e?this.getRBGA(e):e).length)&&(this.r=t[0],this.g=t[1],this.b=t[2],3<t.length)&&(this.a=t[3])}l.ControlStyle=void 0,(o=l.ControlStyle||(l.ControlStyle={})).light="light",o.dark="dark",o.auto="auto";var Qt=Map,Vt=(Jt.prototype._addEventListener=function(e,t,o){this.listeners.has(e)||this.listeners.set(e,new Qt),this.listeners.get(e).set(t,o)},Jt.prototype._removeEventListener=function(e,t){this.listeners.has(e)&&this.listeners.get(e).delete(t)},Jt.prototype._invokeEvent=function(o,r){var n=this;this.listeners.has(o)&&this.listeners.get(o).forEach(function(e,t){e&&n._removeEventListener(o,t);try{t(r)}catch(e){console.error(e)}})},Jt);function Jt(){this.listeners=new Qt}var Xt,$t,B=Object.freeze({__proto__:null,EventEmitter:Vt}),eo=((window&&window.__extends||(Xt=function(e,t){return(Xt=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Xt(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(to,$t=Vt),to.prototype.onRemove=function(){this._container&&(this._container.remove(),delete this._container),this._map&&(this._map.events.remove("stylechanged",this._onStyleChange),delete this._map),this._observer&&(this._observer.disconnect(),delete this._observer),delete this._theme},to.prototype.buildContainer=function(e,t,o,r){return this._map=e,this._container=document.createElement(r||"div"),this._container.classList.add("azure-maps-control-container"),"string"==typeof o&&this._container.setAttribute("aria-label",o),t.toLowerCase()===l.ControlStyle.auto?this._map&&this._map.events.add("stylechanged",this._onStyleChange):this._container.classList.add(t),this._container},to.prototype._setTheme=function(e){this._theme!==e&&(this._container.classList.remove(this._theme),this._container.classList.add(e),this._theme=e)},to.activateClickDelay=100,to);function to(){var t=null!==$t&&$t.apply(this,arguments)||this;return t._onStyleChange=function(){t._map.getStyle().style.toLowerCase().startsWith("blank")?t._observer||(t._onBackgroundChange(),t._observer=new MutationObserver(t._onBackgroundChange),t._observer.observe(t._map.getMapContainer(),{attributes:!0,attributeFilter:["style"]})):(t._observer&&(t._observer.disconnect(),delete t._observer),t._map.styles.getThemeAsync(t._map.getStyle()).then(function(e){t._setTheme(e)}))},t._onBackgroundChange=function(){var e=new Wt(t._map.getMapContainer().style.backgroundColor).getLuminosity(),e=isNaN(e)||.5<e?l.ControlStyle.light:l.ControlStyle.dark;t._setTheme(e)},t}(window&&window.__extends||(oo=function(e,t){return(oo=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}oo(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(io,ro=ye);var oo,ro,no=io;function io(){var e=null!==ro&&ro.apply(this,arguments)||this;return e.rotationDegreesDelta=15,e.style=l.ControlStyle.light,e.inverted=!1,e}(window&&window.__extends||(ao=function(e,t){return(ao=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ao(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(uo,so=eo),uo.prototype.onAdd=function(e,t){function o(e){e?(n.classList.add("in-use"),a.classList.remove("hidden-accessible-element")):(n.classList.remove("in-use"),a.classList.add("hidden-accessible-element"))}var r=this,n=this.buildContainer(e,this.options.style,"Rotation Control"),i=this.constructRotationButton(e),a=this.constructRotationGrid(e,t),s=jt("Reset to Default Rotation");return n.addEventListener("mouseover",function(e){r.lastActiveTime=r.lastActiveTime||e.timeStamp,r.hasMouse=!0,o(!0)}),n.addEventListener("focusin",function(e){r.lastActiveTime=r.lastActiveTime||e.timeStamp,r.hasFocus=!0,o(!0)}),n.addEventListener("mouseleave",function(){r.hasMouse=!1,r.hasFocus||(delete r.lastActiveTime,o(!1))}),n.addEventListener("focusout",function(e){e.relatedTarget instanceof Node&&n.contains(e.relatedTarget)||(r.hasFocus=!1,r.hasMouse)||(delete r.lastActiveTime,o(!1))}),a.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||(e.stopPropagation(),i.focus(),o(!1))}),i.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||null==n||!n.classList.contains("in-use")||"none"!==(null==s?void 0:s.style.display)||(e.stopPropagation(),o(!1))}),t&&uo.InvertOrderPositions.includes(t.position)?(n.appendChild(a),n.appendChild(i),n.appendChild(s),Ht(s,i)):(n.appendChild(i),n.appendChild(s),Ht(s,i),n.appendChild(a)),n},uo.prototype.constructRotationGrid=function(e,t){var o=document.createElement("div"),r=(o.classList.add("sub-container"),o.classList.add("hidden-accessible-element"),this.constructRightRotationButton(e)),e=this.constructLeftRotationButton(e),n=jt("Rotate Left"),i=jt("Rotate Right");return t&&uo.InvertOrderPositions.includes(t.position)?(o.appendChild(r),o.appendChild(i),Ht(i,r),o.appendChild(e),o.appendChild(n),Ht(n,e)):(o.appendChild(e),o.appendChild(n),Ht(n,e),o.appendChild(r),o.appendChild(i),Ht(i,r)),o},uo.prototype.constructRotationButton=function(t){var o=this,e=document.createElement("button"),r=(e.classList.add("azure-maps-control-button"),e.classList.add("rotation"),e.setAttribute("aria-label","Reset to Default Rotation"),e.setAttribute("alt","Reset to Default Rotation"),e.setAttribute("type","button"),document.createElement("div"));return e.appendChild(r),e.addEventListener("click",function(e){e.timeStamp-o.lastActiveTime>eo.activateClickDelay&&t.setCamera({bearing:uo.DefaultRotation},!0)}),t.events.add("rotate",function(e){r.style.transform="rotate(".concat(-e.map.getCamera().bearing,"deg)")}),e},uo.prototype.constructRightRotationButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("rotation-right"),o.setAttribute("aria-label","Rotate Right"),o.setAttribute("alt","Rotate Right"),o.setAttribute("type","button"),o.addEventListener("click",function(){e.setCamera({bearing:e.getCamera().bearing-(t.options.inverted?-1:1)*t.options.rotationDegreesDelta,duration:uo.RotationDuration,type:"ease"},!0)}),o},uo.prototype.constructLeftRotationButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("rotation-left"),o.setAttribute("aria-label","Rotate Left"),o.setAttribute("alt","Rotate Left"),o.setAttribute("type","button"),o.addEventListener("click",function(){e.setCamera({bearing:e.getCamera().bearing+(t.options.inverted?-1:1)*t.options.rotationDegreesDelta,duration:uo.RotationDuration,type:"ease"},!0)}),o},uo.DefaultRotation=0,uo.RotationDuration=100,uo.InvertOrderPositions=[l.ControlPosition.BottomRight,l.ControlPosition.TopRight];var ao,so,co=uo;function uo(e){var t=so.call(this)||this;return t.hasMouse=!1,t.hasFocus=!1,t.options=(new no).merge(e),t}(window&&window.__extends||(lo=function(e,t){return(lo=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}lo(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(fo,ho=ye);var lo,ho,po=fo;function fo(){var e=null!==ho&&ho.apply(this,arguments)||this;return e.pitchDegreesDelta=10,e.style=l.ControlStyle.light,e.inverted=!1,e}(window&&window.__extends||(go=function(e,t){return(go=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}go(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(yo,mo=eo),yo.prototype.onAdd=function(e,t){function o(e){e?(n.classList.add("in-use"),a.classList.remove("hidden-accessible-element")):(n.classList.remove("in-use"),a.classList.add("hidden-accessible-element"))}var r=this,n=this.buildContainer(e,this.options.style,"Pitch Control"),i=this.constructPitchButton(e),a=this.constructPitchGrid(e,t),s=jt("Reset to Default Pitch");return n.addEventListener("mouseover",function(e){r.lastActiveTime=r.lastActiveTime||e.timeStamp,r.hasMouse=!0,o(!0)}),n.addEventListener("focusin",function(e){r.lastActiveTime=r.lastActiveTime||e.timeStamp,r.hasFocus=!0,o(!0)}),n.addEventListener("mouseleave",function(){r.hasMouse=!1,r.hasFocus||(delete r.lastActiveTime,o(!1))}),n.addEventListener("focusout",function(e){e.relatedTarget instanceof Node&&n.contains(e.relatedTarget)||(r.hasFocus=!1,r.hasMouse)||(delete r.lastActiveTime,o(!1))}),a.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||(e.stopPropagation(),i.focus(),o(!1))}),i.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||null==n||!n.classList.contains("in-use")||"none"!==(null==s?void 0:s.style.display)||(e.stopPropagation(),o(!1))}),t&&yo.INVERT_ORDER_POSITIONS.includes(t.position)?(n.appendChild(a),n.appendChild(i),n.appendChild(s),Ht(s,n)):(n.appendChild(i),n.appendChild(s),Ht(s,n),n.appendChild(a)),this.map=e,this.container=n,this.pitchButton=i,e.events.add("pitch",this.pitchChanged),this.updatePitchButtonsState(),n},yo.prototype.onRemove=function(){this.container&&(this.container.remove(),this.container=null,this.pitchButton=null,this.pitchIncrementButton=null,this.pitchDecrementButton=null),this.map&&(this.map.events.remove("pitch",this.pitchChanged),this.map=null)},yo.prototype.constructPitchGrid=function(e,t){var o=document.createElement("div"),e=(o.classList.add("sub-container"),o.classList.add("hidden-accessible-element"),this.pitchIncrementButton=this.constructPitchIncrementButton(e),this.pitchDecrementButton=this.constructPitchDecrementButton(e),jt("Increase Pitch")),r=jt("Decrease Pitch");return t&&yo.INVERT_ORDER_POSITIONS.includes(t.position)?(o.appendChild(this.pitchDecrementButton),o.appendChild(r),Ht(r,this.pitchDecrementButton),o.appendChild(this.pitchIncrementButton),o.appendChild(e),Ht(e,this.pitchIncrementButton)):(o.appendChild(this.pitchIncrementButton),o.appendChild(e),Ht(e,this.pitchIncrementButton),o.appendChild(this.pitchDecrementButton),o.appendChild(r),Ht(r,this.pitchDecrementButton)),o},yo.prototype.constructPitchButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("pitch"),o.setAttribute("aria-label","Reset to Default Pitch"),o.setAttribute("alt","Reset to Default Pitch"),o.setAttribute("type","button"),o.addEventListener("click",function(){event.timeStamp-t.lastActiveTime>eo.activateClickDelay&&e.setCamera({pitch:yo.DEFAULT_PITCH},!0)}),o},yo.prototype.constructPitchDecrementButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("pitch-down"),o.setAttribute("aria-label","Decrease Pitch"),o.setAttribute("alt","Decrease Pitch"),o.setAttribute("type","button"),o.addEventListener("click",function(){e.setCamera({pitch:e.getCamera().pitch-(t.options.inverted?-1:1)*t.options.pitchDegreesDelta,duration:yo.PITCH_DURATION_MS,type:"ease"},!0)}),o},yo.prototype.constructPitchIncrementButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("pitch-up"),o.setAttribute("aria-label","Increase Pitch"),o.setAttribute("alt","Increase Pitch"),o.setAttribute("type","button"),o.addEventListener("click",function(){e.setCamera({pitch:e.getCamera().pitch+(t.options.inverted?-1:1)*t.options.pitchDegreesDelta,duration:yo.PITCH_DURATION_MS,type:"ease"},!0)}),o},yo.PITCH_DURATION_MS=100,yo.DEFAULT_PITCH=0,yo.INVERT_ORDER_POSITIONS=[l.ControlPosition.BottomRight,l.ControlPosition.TopRight];var go,mo,t=yo;function yo(e){var o=mo.call(this)||this;return o.container=null,o.map=null,o.pitchButton=null,o.pitchIncrementButton=null,o.pitchDecrementButton=null,o.hasMouse=!1,o.hasFocus=!1,o.pitchChanged=function(e){return o.updatePitchButtonsState()},o.updatePitchButtonsState=function(){var e=o.map.getCamera().pitch<=0,t=60<=o.map.getCamera().pitch;o.hasFocus&&o.pitchButton&&(e||t)&&o.pitchButton.focus(),o.options.inverted?(o.pitchIncrementButton&&o.pitchIncrementButton.disabled!=e&&(o.pitchIncrementButton.disabled=e),o.pitchDecrementButton&&o.pitchDecrementButton.disabled!=t&&(o.pitchDecrementButton.disabled=t)):(o.pitchIncrementButton&&o.pitchIncrementButton.disabled!=t&&(o.pitchIncrementButton.disabled=t),o.pitchDecrementButton&&o.pitchDecrementButton.disabled!=e&&(o.pitchDecrementButton.disabled=e))},o.options=(new po).merge(e),o}(window&&window.__extends||(vo=function(e,t){return(vo=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}vo(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(wo,_o=eo),wo.prototype.onAdd=function(e,t){this.map=e,null!=(o=null==(o=this.map)?void 0:o._getMap())&&o.addControl(this.control);var o=this.buildContainer(e,l.ControlStyle.auto,"Scale Bar");return o.appendChild(null==(e=this.control)?void 0:e._container),o},wo.prototype.onRemove=function(){var e;_o.prototype.onRemove.call(this),null!=(e=null==(e=this.map)?void 0:e._getMap())&&e.removeControl(this.control),this.map=null},wo.prototype.setUnit=function(e){var t;null!=(t=this.control)&&t.setUnit(e)};var vo,_o,be=wo;function wo(e){var t=_o.call(this)||this;return t.map=null,t.control=new D.ScaleControl({maxWidth:null==e?void 0:e.maxWidth,unit:null==e?void 0:e.unit}),t}function bo(e,t){return e===t||e!=e&&t!=t}var Co=bo;function So(e,t){for(var o=e.length;o--;)if(Co(e[o][0],t))return o;return-1}var Eo=So,To=Array.prototype.splice;var Io=So;var ko=So;var Ao=So;function Po(e){var t=this.__data__;return!((e=Eo(t,e))<0||(e==t.length-1?t.pop():To.call(t,e,1),--this.size,0))}function Oo(e){var t=this.__data__;return(e=Io(t,e))<0?void 0:t[e][1]}function Ro(e){return-1<ko(this.__data__,e)}function xo(e,t){var o=this.__data__,r=Ao(o,e);return r<0?(++this.size,o.push([e,t])):o[r][1]=t,this}function Mo(e){var t=-1,o=null==e?0:e.length;for(this.clear();++t<o;){var r=e[t];this.set(r[0],r[1])}}Mo.prototype.clear=function(){this.__data__=[],this.size=0},Mo.prototype.delete=Po,Mo.prototype.get=Oo,Mo.prototype.has=Ro,Mo.prototype.set=xo;var Kt=Mo,No=Kt;function Lo(){this.__data__=new No,this.size=0}function Do(e){var t=this.__data__,e=t.delete(e);return this.size=t.size,e}function qo(e){return this.__data__.get(e)}function Uo(e){return this.__data__.has(e)}var o="object"==typeof e&&e&&e.Object===Object&&e,e="object"==typeof self&&self&&self.Object===Object&&self,e=o||e||Function("return this")(),jo=e.Symbol,Ho=Object.prototype,Bo=Ho.hasOwnProperty,Fo=Ho.toString,zo=jo?jo.toStringTag:void 0;var Ko=Object.prototype.toString;var Go=function(e){var t=Bo.call(e,zo),o=e[zo];try{var r=!(e[zo]=void 0)}catch(e){}var n=Fo.call(e);return r&&(t?e[zo]=o:delete e[zo]),n},Yo=function(e){return Ko.call(e)},Wo=jo?jo.toStringTag:void 0;function Zo(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":(Wo&&Wo in Object(e)?Go:Yo)(e)}function Qo(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}var Vo=Zo,Jo=Qo;function Xo(e){return!!Jo(e)&&("[object Function]"==(e=Vo(e))||"[object GeneratorFunction]"==e||"[object AsyncFunction]"==e||"[object Proxy]"==e)}var Ho=e["__core-js_shared__"],$o=(Ho=/[^.]+$/.exec(Ho&&Ho.keys&&Ho.keys.IE_PROTO||""))?"Symbol(src)_1."+Ho:"";var er=Function.prototype.toString;function tr(e){if(null!=e){try{return er.call(e)}catch(e){}try{return e+""}catch(e){}}return""}var or=Xo,rr=function(e){return!!$o&&$o in e},nr=Qo,ir=tr,ar=/^\[object .+?Constructor\]$/,Ho=Function.prototype,sr=Object.prototype,Ho=Ho.toString,sr=sr.hasOwnProperty,cr=RegExp("^"+Ho.call(sr).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");var ur=function(e){return!(!nr(e)||rr(e))&&(or(e)?cr:ar).test(ir(e))},lr=function(e,t){return null==e?void 0:e[t]};function hr(e,t){return e=lr(e,t),ur(e)?e:void 0}var Ho=hr(e,"Map"),sr=hr(Object,"create"),dr=sr;var pr=sr,fr=Object.prototype.hasOwnProperty;var gr=sr,mr=Object.prototype.hasOwnProperty;var yr=sr;function vr(e){return e=this.has(e)&&delete this.__data__[e],this.size-=e?1:0,e}function _r(e){var t,o=this.__data__;return pr?"__lodash_hash_undefined__"===(t=o[e])?void 0:t:fr.call(o,e)?o[e]:void 0}function wr(e){var t=this.__data__;return gr?void 0!==t[e]:mr.call(t,e)}function br(e,t){var o=this.__data__;return this.size+=this.has(e)?0:1,o[e]=yr&&void 0===t?"__lodash_hash_undefined__":t,this}function Cr(e){var t=-1,o=null==e?0:e.length;for(this.clear();++t<o;){var r=e[t];this.set(r[0],r[1])}}Cr.prototype.clear=function(){this.__data__=dr?dr(null):{},this.size=0},Cr.prototype.delete=vr,Cr.prototype.get=_r,Cr.prototype.has=wr,Cr.prototype.set=br;var Sr=Cr,Er=Kt,Tr=Ho;var Ir=function(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e};function kr(e,t){return e=e.__data__,Ir(t)?e["string"==typeof t?"string":"hash"]:e.map}var Ar=kr;var Pr=kr;var Or=kr;var Rr=kr;function xr(e){return e=Ar(this,e).delete(e),this.size-=e?1:0,e}function Mr(e){return Pr(this,e).get(e)}function Nr(e){return Or(this,e).has(e)}function Lr(e,t){var o=Rr(this,e),r=o.size;return o.set(e,t),this.size+=o.size==r?0:1,this}function Dr(e){var t=-1,o=null==e?0:e.length;for(this.clear();++t<o;){var r=e[t];this.set(r[0],r[1])}}Dr.prototype.clear=function(){this.size=0,this.__data__={hash:new Sr,map:new(Tr||Er),string:new Sr}},Dr.prototype.delete=xr,Dr.prototype.get=Mr,Dr.prototype.has=Nr,Dr.prototype.set=Lr;var sr=Dr,qr=Kt,Ur=Ho,jr=sr;function Hr(e,t){var o=this.__data__;if(o instanceof qr){var r=o.__data__;if(!Ur||r.length<199)return r.push([e,t]),this.size=++o.size,this;o=this.__data__=new jr(r)}return o.set(e,t),this.size=o.size,this}var Br=Kt,Kt=Do,r=qo,Fr=Uo;function zr(e){e=this.__data__=new Br(e);this.size=e.size}zr.prototype.clear=Lo,zr.prototype.delete=Kt,zr.prototype.get=r,zr.prototype.has=Fr,zr.prototype.set=Hr;Kt=zr;function Kr(e,t){for(var o=-1,r=null==e?0:e.length;++o<r&&!1!==t(e[o],o,e););return e}var Gr=hr,r=function(){try{var e=Gr(Object,"defineProperty");return e({},"",{}),e}catch(e){}}(),Yr=r;function Wr(e,t,o){"__proto__"==t&&Yr?Yr(e,t,{configurable:!0,enumerable:!0,value:o,writable:!0}):e[t]=o}var Zr=Wr,Qr=bo,Vr=Object.prototype.hasOwnProperty;function Jr(e,t,o){var r=e[t];Vr.call(e,t)&&Qr(r,o)&&(void 0!==o||t in e)||Zr(e,t,o)}var Xr=Jr,$r=Wr;function en(e,t,o,r){for(var n=!o,i=(o=o||{},-1),a=t.length;++i<a;){var s=t[i],c=r?r(o[s],e[s],s,o,e):void 0;void 0===c&&(c=e[s]),(n?$r:Xr)(o,s,c)}return o}function tn(e,t){for(var o=-1,r=Array(e);++o<e;)r[o]=t(o);return r}function on(e){return null!=e&&"object"==typeof e}var rn=Zo,nn=on;var Fr=function(e){return nn(e)&&"[object Arguments]"==rn(e)},an=on,sn=Object.prototype,cn=sn.hasOwnProperty,un=sn.propertyIsEnumerable,sn=Fr(function(){return arguments}())?Fr:function(e){return an(e)&&cn.call(e,"callee")&&!un.call(e,"callee")},Fr=Array.isArray,ln={exports:{}};i=(i=(n=ln).exports)&&!i.nodeType&&i,hn=(hn=i&&n&&!n.nodeType&&n)&&hn.exports===i?e.Buffer:void 0,i=hn?hn.isBuffer:void 0,n.exports=i||function(){return!1};var hn=ln.exports,dn=/^(?:0|[1-9]\d*)$/;function pn(e,t){var o=typeof e;return!!(t=null==t?9007199254740991:t)&&("number"==o||"symbol"!=o&&dn.test(e))&&-1<e&&e%1==0&&e<t}function fn(e){return"number"==typeof e&&-1<e&&e%1==0&&e<=9007199254740991}var gn=Zo,mn=fn,yn=on,vn={};vn["[object Float32Array]"]=vn["[object Float64Array]"]=vn["[object Int8Array]"]=vn["[object Int16Array]"]=vn["[object Int32Array]"]=vn["[object Uint8Array]"]=vn["[object Uint8ClampedArray]"]=vn["[object Uint16Array]"]=vn["[object Uint32Array]"]=!0,vn["[object Arguments]"]=vn["[object Array]"]=vn["[object ArrayBuffer]"]=vn["[object Boolean]"]=vn["[object DataView]"]=vn["[object Date]"]=vn["[object Error]"]=vn["[object Function]"]=vn["[object Map]"]=vn["[object Number]"]=vn["[object Object]"]=vn["[object RegExp]"]=vn["[object Set]"]=vn["[object String]"]=vn["[object WeakMap]"]=!1;function _n(e){return yn(e)&&mn(e.length)&&!!vn[gn(e)]}function wn(t){return function(e){return t(e)}}var bn,Cn,n={exports:{}},o=(ln=(ln=(i=n).exports)&&!ln.nodeType&&ln,bn=ln&&i&&!i.nodeType&&i,Cn=bn&&bn.exports===ln&&o.process,ln=function(){try{var e=bn&&bn.require&&bn.require("util").types;return e?e:Cn&&Cn.binding&&Cn.binding("util")}catch(e){}}(),i.exports=ln,n.exports),i=_n,ln=wn,n=o&&o.isTypedArray,ln=n?ln(n):i,Sn=tn,En=sn,Tn=Fr,In=hn,kn=pn,An=ln,Pn=Object.prototype.hasOwnProperty;function On(e,t){var o,r=Tn(e),n=!r&&En(e),i=!r&&!n&&In(e),a=!r&&!n&&!i&&An(e),s=r||n||i||a,c=s?Sn(e.length,String):[],u=c.length;for(o in e)!t&&!Pn.call(e,o)||s&&("length"==o||i&&("offset"==o||"parent"==o)||a&&("buffer"==o||"byteLength"==o||"byteOffset"==o)||kn(o,u))||c.push(o);return c}var Rn=Object.prototype;function xn(e){var t=e&&e.constructor;return e===("function"==typeof t&&t.prototype||Rn)}function Mn(t,o){return function(e){return t(o(e))}}var n=Mn(Object.keys,Object),Nn=xn,Ln=n,Dn=Object.prototype.hasOwnProperty;var qn=Xo,Un=fn;function jn(e){return null!=e&&Un(e.length)&&!qn(e)}var Hn=On,Bn=function(e){if(!Nn(e))return Ln(e);var t,o=[];for(t in Object(e))Dn.call(e,t)&&"constructor"!=t&&o.push(t);return o},Fn=jn;function zn(e){return(Fn(e)?Hn:Bn)(e)}var Kn=en,Gn=zn;function Yn(e,t){return e&&Kn(t,Gn(t),e)}var Wn=Qo,Zn=xn,Qn=function(e){var t=[];if(null!=e)for(var o in Object(e))t.push(o);return t},Vn=Object.prototype.hasOwnProperty;var Jn=On,Xn=function(e){if(!Wn(e))return Qn(e);var t,o=Zn(e),r=[];for(t in e)("constructor"!=t||!o&&Vn.call(e,t))&&r.push(t);return r},$n=jn;function ei(e){return $n(e)?Jn(e,!0):Xn(e)}var ti=en,oi=ei;function ri(e,t){return e&&ti(t,oi(t),e)}var ni,i={exports:{}},ii=(ii=(ii=(n=i).exports)&&!ii.nodeType&&ii,a=(a=ii&&n&&!n.nodeType&&n)&&a.exports===ii?e.Buffer:void 0,ni=a?a.allocUnsafe:void 0,n.exports=function(e,t){return t?e.slice():(t=e.length,t=ni?ni(t):new e.constructor(t),e.copy(t),t)},i.exports);function ai(e,t){var o=-1,r=e.length;for(t=t||Array(r);++o<r;)t[o]=e[o];return t}function si(){return[]}var ci=function(e,t){for(var o=-1,r=null==e?0:e.length,n=0,i=[];++o<r;){var a=e[o];t(a,o,e)&&(i[n++]=a)}return i},ui=Object.prototype.propertyIsEnumerable,li=Object.getOwnPropertySymbols,a=li?function(t){return null==t?[]:(t=Object(t),ci(li(t),function(e){return ui.call(t,e)}))}:si,hi=en,di=a;function pi(e,t){return hi(e,di(e),t)}function fi(e,t){for(var o=-1,r=t.length,n=e.length;++o<r;)e[n+o]=t[o];return e}var n=Mn(Object.getPrototypeOf,Object),gi=fi,mi=n,yi=a,i=Object.getOwnPropertySymbols?function(e){for(var t=[];e;)gi(t,yi(e)),e=mi(e);return t}:si,vi=en,_i=i;function wi(e,t){return vi(e,_i(e),t)}var bi=fi,Ci=Fr;function Si(e,t,o){return t=t(e),Ci(e)?t:bi(t,o(e))}var Ei=Si,Ti=a,Ii=zn;function ki(e){return Ei(e,Ii,Ti)}var Ai=Si,Pi=i,Oi=ei;function Ri(e){return Ai(e,Oi,Pi)}var a=hr(e,"DataView"),i=Ho,Ho=hr(e,"Promise"),xi=hr(e,"Set"),Mi=hr(e,"WeakMap"),Ni=Zo,Li=tr,Di="[object Map]",qi="[object Promise]",Ui="[object Set]",ji="[object WeakMap]",Hi="[object DataView]",Bi=Li(a),Fi=Li(i),zi=Li(Ho),Ki=Li(xi),Gi=Li(Mi),s=Ni,a=s=a&&s(new a(new ArrayBuffer(1)))!=Hi||i&&s(new i)!=Di||Ho&&s(Ho.resolve())!=qi||xi&&s(new xi)!=Ui||Mi&&s(new Mi)!=ji?function(e){var t=Ni(e),e="[object Object]"==t?e.constructor:void 0,e=e?Li(e):"";if(e)switch(e){case Bi:return Hi;case Fi:return Di;case zi:return qi;case Ki:return Ui;case Gi:return ji}return t}:s,Yi=Object.prototype.hasOwnProperty;function Wi(e){var t=e.length,o=new e.constructor(t);return t&&"string"==typeof e[0]&&Yi.call(e,"index")&&(o.index=e.index,o.input=e.input),o}var i=e.Uint8Array,Zi=i;function Qi(e){var t=new e.constructor(e.byteLength);return new Zi(t).set(new Zi(e)),t}var Vi=Qi;var Ji=/\w*$/;var Ho=jo?jo.prototype:void 0,Xi=Ho?Ho.valueOf:void 0;var $i=Qi;function ea(e,t){return t=t?$i(e.buffer):e.buffer,new e.constructor(t,e.byteOffset,e.length)}var ta=Qi,oa=function(e,t){return t=t?Vi(e.buffer):e.buffer,new e.constructor(t,e.byteOffset,e.byteLength)},ra=function(e){var t=new e.constructor(e.source,Ji.exec(e));return t.lastIndex=e.lastIndex,t},na=function(e){return Xi?Object(Xi.call(e)):{}},ia=ea;function aa(e,t,o){var r=e.constructor;switch(t){case"[object ArrayBuffer]":return ta(e);case"[object Boolean]":case"[object Date]":return new r(+e);case"[object DataView]":return oa(e,o);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return ia(e,o);case"[object Map]":return new r;case"[object Number]":case"[object String]":return new r(e);case"[object RegExp]":return ra(e);case"[object Set]":return new r;case"[object Symbol]":return na(e)}}var sa=Qo,ca=Object.create;function ua(){}var la=function(e){if(!sa(e))return{};if(ca)return ca(e);ua.prototype=e;e=new ua;return ua.prototype=void 0,e},ha=n,da=xn;function pa(e){return"function"!=typeof e.constructor||da(e)?{}:la(ha(e))}var fa=a,ga=on;function ma(e){return ga(e)&&"[object Map]"==fa(e)}var xi=wn,Mi=o&&o.isMap,s=Mi?xi(Mi):ma,ya=a,va=on;function _a(e){return va(e)&&"[object Set]"==ya(e)}var e=wn,Ho=o&&o.isSet,xi=Ho?e(Ho):_a,wa=Kt,ba=Kr,Ca=Jr,Sa=Yn,Ea=ri,Ta=ii,Ia=ai,ka=pi,Aa=wi,Pa=ki,Oa=Ri,Ra=a,xa=Wi,Ma=aa,Na=pa,La=Fr,Da=hn,qa=s,Ua=Qo,ja=xi,Ha=zn,Ba=ei,Fa="[object Arguments]",za="[object Function]",Ka="[object Object]",Ga={};Ga[Fa]=Ga["[object Array]"]=Ga["[object ArrayBuffer]"]=Ga["[object DataView]"]=Ga["[object Boolean]"]=Ga["[object Date]"]=Ga["[object Float32Array]"]=Ga["[object Float64Array]"]=Ga["[object Int8Array]"]=Ga["[object Int16Array]"]=Ga["[object Int32Array]"]=Ga["[object Map]"]=Ga["[object Number]"]=Ga[Ka]=Ga["[object RegExp]"]=Ga["[object Set]"]=Ga["[object String]"]=Ga["[object Symbol]"]=Ga["[object Uint8Array]"]=Ga["[object Uint8ClampedArray]"]=Ga["[object Uint16Array]"]=Ga["[object Uint32Array]"]=!0,Ga["[object Error]"]=Ga[za]=Ga["[object WeakMap]"]=!1;function Ya(o,r,n,e,t,i){var a,s=1&r,c=2&r,u=4&r;if(void 0===(a=n?t?n(o,e,t,i):n(o):a)){if(!Ua(o))return o;if(e=La(o)){if(a=xa(o),!s)return Ia(o,a)}else{var l=Ra(o),h=l==za||"[object GeneratorFunction]"==l;if(Da(o))return Ta(o,s);if(l==Ka||l==Fa||h&&!t){if(a=c||h?{}:Na(o),!s)return c?Aa(o,Ea(a,o)):ka(o,Sa(a,o))}else{if(!Ga[l])return t?o:{};a=Ma(o,l,s)}}if(h=(i=i||new wa).get(o))return h;i.set(o,a),ja(o)?o.forEach(function(e){a.add(Ya(e,r,n,e,o,i))}):qa(o)&&o.forEach(function(e,t){a.set(t,Ya(e,r,n,t,o,i))});var d=e?void 0:(u?c?Oa:Pa:c?Ba:Ha)(o);ba(d||o,function(e,t){d&&(e=o[t=e]),Ca(a,t,Ya(e,r,n,t,o,i))})}return a}var Wa=Ya;var Za=q(function(e){return Wa(e,5)}),Qa=Wr,Va=bo;function Ja(e,t,o){(void 0===o||Va(e[t],o))&&(void 0!==o||t in e)||Qa(e,t,o)}var Mi=function(c){return function(e,t,o){for(var r=-1,n=Object(e),i=o(e),a=i.length;a--;){var s=i[c?a:++r];if(!1===t(n[s],s,n))break}return e}}(),Xa=jn,$a=on;function es(e){return $a(e)&&Xa(e)}var ts=Zo,os=n,rs=on,o=Function.prototype,e=Object.prototype,ns=o.toString,is=e.hasOwnProperty,as=ns.call(Object);function ss(e){return!(!rs(e)||"[object Object]"!=ts(e))&&(null===(e=os(e))||"function"==typeof(e=is.call(e,"constructor")&&e.constructor)&&e instanceof e&&ns.call(e)==as)}function cs(e,t){if(("constructor"!==t||"function"!=typeof e[t])&&"__proto__"!=t)return e[t]}var us=en,ls=ei;var hs=Ja,ds=ii,ps=ea,fs=ai,gs=pa,ms=sn,ys=Fr,vs=es,_s=hn,ws=Xo,bs=Qo,Cs=ss,Ss=ln,Es=cs,Ts=function(e){return us(e,ls(e))};var Is=Kt,ks=Ja,As=Mi,Ps=function(e,t,o,r,n,i,a){var s,c,u,l=Es(e,o),h=Es(t,o),d=a.get(h);d||((t=void 0===(d=i?i(l,h,o+"",e,t,a):void 0))&&(c=!(s=ys(h))&&_s(h),u=!s&&!c&&Ss(h),d=h,s||c||u?d=ys(l)?l:vs(l)?fs(l):c?ds(h,!(t=!1)):u?ps(h,!(t=!1)):[]:Cs(h)||ms(h)?ms(d=l)?d=Ts(l):bs(l)&&!ws(l)||(d=gs(h)):t=!1),t&&(a.set(h,d),n(d,h,r,i,a),a.delete(h))),hs(e,o,d)},Os=Qo,Rs=ei,xs=cs;function Ms(e){return e}var Ns=function(e,t,o){switch(o.length){case 0:return e.call(t);case 1:return e.call(t,o[0]);case 2:return e.call(t,o[0],o[1]);case 3:return e.call(t,o[0],o[1],o[2])}return e.apply(t,o)},Ls=Math.max;var Ds=function(e){return function(){return e}},qs=r,Us=Date.now;var Ho=function(o){var r=0,n=0;return function(){var e=Us(),t=16-(e-n);if(n=e,0<t){if(800<=++r)return arguments[0]}else r=0;return o.apply(void 0,arguments)}}(qs?function(e,t){return qs(e,"toString",{configurable:!0,enumerable:!1,value:Ds(t),writable:!0})}:Ms),js=Ms,Hs=function(i,a,s){return a=Ls(void 0===a?i.length-1:a,0),function(){for(var e=arguments,t=-1,o=Ls(e.length-a,0),r=Array(o);++t<o;)r[t]=e[a+t];for(var t=-1,n=Array(a+1);++t<a;)n[t]=e[t];return n[a]=s(r),Ns(i,this,n)}},Bs=Ho;var Fs=bo,zs=jn,Ks=pn,Gs=Qo;var Ys=function(e,t){return Bs(Hs(e,t,js),e+"")},Ws=function(e,t,o){var r;return!!Gs(o)&&!!("number"==(r=typeof t)?zs(o)&&Ks(t,o.length):"string"==r&&t in o)&&Fs(o[t],e)};var Zs,Qs,Vs=function r(n,i,a,s,c){n!==i&&As(i,function(e,t){var o;c=c||new Is,Os(e)?Ps(n,i,t,a,r,s,c):(o=s?s(xs(n,t),e,t+"",n,i,c):void 0,ks(n,t,o=void 0===o?e:o))},Rs)},Js=q(function(s){return Ys(function(e,t){var o=-1,r=t.length,n=1<r?t[r-1]:void 0,i=2<r?t[2]:void 0,n=3<s.length&&"function"==typeof n?(r--,n):void 0;for(i&&Ws(t[0],t[1],i)&&(n=r<3?void 0:n,r=1),e=Object(e);++o<r;){var a=t[o];a&&s(e,a,o,n)}return e})}(function(e,t,o){Vs(e,t,o)})),Xs=((window&&window.__extends||(Zs=function(e,t){return(Zs=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Zs(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))($s,Qs=ye),$s);function $s(){var e=null!==Qs&&Qs.apply(this,arguments)||this;return e.layout="icons",e.mapStyles=["road","grayscale_light","grayscale_dark","night","road_shaded_relief"],e.style=l.ControlStyle.light,e.autoSelectionMode=!0,e}var ec,tc,s=window&&window.__extends||(ec=function(e,t){return(ec=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ec(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),oc=window&&window.__awaiter||function(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})},rc=window&&window.__generator||function(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},u={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function e(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c=u&&t[u=0]?0:c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},nc=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},xi=(s(ic,tc=eo),ic.prototype.onAdd=function(e,t){function o(e){e?(n.classList.add(ic.Css.inUse),i.classList.remove("hidden-accessible-element")):(n.classList.remove(ic.Css.inUse),i.classList.add("hidden-accessible-element"))}var r=this,n=(this.map=e,this.buildContainer(e,this.options.style,"Map Style Control")),i=this.buildStyleOpsGrid(),a=(this.styleOpsGrid=i,this.buildCurrStyleBtn()),e=jt("Select Style");return i.classList.add(t&&t.position||"top-right"),n.addEventListener("mouseover",function(){r.hasMouse=!0,o(!0)}),n.addEventListener("focusin",function(){r.hasFocus=!0,o(!0)}),n.addEventListener("mouseleave",function(){r.hasMouse=!1,r.hasFocus||o(!1)}),n.addEventListener("focusout",function(e){e.target===a&&Array.from(i.children).forEach(function(e){return e.removeAttribute("tabIndex")}),e.relatedTarget instanceof Node&&n.contains(e.relatedTarget)||(r.hasFocus=!1,r.hasMouse)||o(!1)}),i.addEventListener("keydown",function(e){27===e.keyCode&&(e.stopPropagation(),a.focus(),Array.from(i.children).forEach(function(e){return e.setAttribute("tabIndex","-1")}),n.classList.contains(ic.Css.inUse))&&o(!1)}),a.addEventListener("click",function(e){n.classList.contains(ic.Css.inUse)?o(!1):(o(!0),i.firstElementChild&&i.firstElementChild.focus())}),t&&ic.InvertOrderPositions.includes(t.position)?(n.appendChild(i),n.appendChild(a),n.appendChild(e),Ht(e,a)):(n.appendChild(a),n.appendChild(e),Ht(e,a),n.appendChild(i)),n},ic.prototype.onRemove=function(){tc.prototype.onRemove.call(this),this.styleOpsGrid=null,this.styleButtons.clear(),this.thumbnailCache.response.clear(),this.thumbnailCache.blob.clear(),this.thumbnailCache.assumedConfiguration=void 0,this.map.events.remove("stylechanged",this.onStyleChange),this.map.events.remove("mapconfigurationchanged",this.onMapConfigurationChange)},ic.prototype.setSelectedStyle=function(o){var t,e,r=this;this.styleIcons.has(o)&&(t=this.currStyleImage,e=this.styleIcons.get(o),t.src!==e&&(t.src=e),Object.entries(this.styleButtons).forEach(function(e){var e=nc(e,2),t=e[0];return e[1].setAttribute("aria-current",t===o?"true":"false")}),this.map.styles.definitions().then(function(e){e=r.mapToFriendlyStyleName(o,e);t.alt!==e&&(t.alt=e),t.parentElement.lastChild instanceof Text&&(t.parentElement.lastChild.textContent=e)}))},ic.prototype.disableStyle=function(e){e=this.styleButtons[e];e&&e.setAttribute("disabled","true")},ic.prototype.enableStyle=function(e){e=this.styleButtons[e];e&&e.removeAttribute("disabled")},ic.prototype.buildSelectStyleBtn=function(o,e,t){var r=this,n=document.createElement("button"),i=this.mapToFriendlyStyleName(o,e),a=(n.setAttribute("aria-label",i),n.setAttribute("type","button"),new Image),e=(t.then(function(e){var t;return r.thumbnailCache.blob.has(e.url)?r.thumbnailCache.blob.get(e.url):(t=e.clone().blob(),r.thumbnailCache.blob.set(e.url,t),t)}).then(function(e){e=URL.createObjectURL(e);a.src=e,o===r.map.getStyle().style&&(r.currStyleImage.src=e,r.currStyleImage.alt=i,r.currStyleImage.parentElement.lastChild.nodeType==Node.TEXT_NODE?r.currStyleImage.parentElement.lastChild.textContent=i:r.currStyleImage.parentElement.appendChild(document.createTextNode(i))),r.styleIcons.set(o,e)}),a.setAttribute("aria-hidden","true"),n.appendChild(a),"icons"===this.options.layout?n.classList.add(ic.Css.button):(n.classList.add(ic.Css.listButton),n.classList.add(ic.Css.expanded),n.appendChild(document.createTextNode(i))),n.addEventListener("click",function(){r.hasMouse=!1,r.hasFocus=!1;var e=r.styleButtons[o];e&&!e.hasAttribute("disabled")&&(r._invokeEvent("styleselected",o),r.options.autoSelectionMode&&r.map.setStyle({style:o}),Object.entries(r.styleButtons).forEach(function(e){var e=nc(e,2),t=e[0];return e[1].setAttribute("aria-current",t===o?"true":"false")}))}),document.createElement("div"));return e.classList.add("selected-icon"),n.appendChild(e),n},ic.prototype.buildCurrStyleBtn=function(){var e=document.createElement("button"),t=("icons"==this.options.layout?e.classList.add(ic.Css.button):e.classList.add(ic.Css.listButton),e.classList.add(ic.Css.currentStyle),e.setAttribute("aria-label","Select Style"),e.setAttribute("tabindex","-1"),this.currStyleImage=new Image,e.appendChild(this.currStyleImage),document.createElement("div"));return t.classList.add("icon"),e.appendChild(t),e},ic.prototype.buildStyleOpsGrid=function(){var e=this,t=document.createElement("div");return t.classList.add(ic.Css.styleOptions),"icons"===this.options.layout?t.classList.add(this.options.layout):t.classList.add(ic.Css.dropdown),t.setAttribute("aria-label","Style Options"),t.classList.add("hidden-accessible-element"),this.map.styles.definitions().then(function(t){return oc(e,void 0,void 0,function(){return rc(this,function(e){return this.onMapConfigurationChange(t),this.map.events.add("stylechanged",this.onStyleChange),[2]})})}),this.map.events.add("mapconfigurationchanged",this.onMapConfigurationChange),t},ic.prototype.populateOpsGridFromDefinitions=function(n){var e,o,i=this;this.styleOpsGrid&&(e=n.configurations,(e=Array.isArray(this.options.mapStyles)?e.filter(function(e){return i.options.mapStyles.includes(e.name.split("_indoor")[0])}):e).forEach(function(e){var t,o={url:e.thumbnail},r=(e.thumbnail&&i.map.styles._transformStyleRequest(e.thumbnail,o),i.map.getServiceOptions()),r=(r.transformRequest&&Js(o,r.transformRequest(o.url,"Thumbnail")),i.thumbnailCache.response.has(o.url)?t=Promise.resolve(i.thumbnailCache.response.get(o.url)):(t=fetch(o.url,{headers:o.headers}),i.thumbnailCache.response.set(o.url,t)),i.buildSelectStyleBtn(e.name,n,t));i.styleOpsGrid.appendChild(r),i.styleButtons[e.name]=r,"icons"===i.options.layout&&(o=jt(i.mapToFriendlyStyleName(e.name,n)),i.styleOpsGrid.appendChild(o),Ht(o,r))}),o=this.map.getStyle().style,Object.entries(this.styleButtons).forEach(function(e){var e=nc(e,2),t=e[0];return e[1].setAttribute("aria-current",t===o?"true":"false")}))},ic.InvertOrderPositions=[l.ControlPosition.TopRight,l.ControlPosition.BottomRight],ic.Css={button:"azure-maps-control-button",listButton:"azure-maps-control-list-button",expanded:"expanded",currentStyle:"curr-style",inUse:"in-use",styleOptions:"style-options",dropdown:"azure-maps-control-dropdown"},ic);function ic(e){var t=tc.call(this)||this;return t.styleOpsGrid=null,t.hasMouse=!1,t.hasFocus=!1,t.styleButtons=new Qt,t.styleIcons=new Qt,t.thumbnailCache={assumedConfiguration:void 0,response:new Qt,blob:new Qt},t.onStyleChange=function(){var e;t.options.autoSelectionMode&&(e=t.map.getStyle().style,t.setSelectedStyle(e))},t.onMapConfigurationChange=function(e){!t.styleOpsGrid||0<t.styleOpsGrid.children.length&&t.thumbnailCache.assumedConfiguration===e||(t.thumbnailCache.assumedConfiguration=e,Array.from(t.styleOpsGrid.children).forEach(function(e){return e.remove()}),t.styleButtons.clear(),t.populateOpsGridFromDefinitions(e))},t.mapToFriendlyStyleName=function(t,e){e=e.configurations.find(function(e){return e.name===t});return(null==e?void 0:e.displayName)||t},t.options=(new Xs).merge(Za(e)),t}(window&&window.__extends||(ac=function(e,t){return(ac=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ac(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(uc,sc=ye);var ac,sc,cc=uc;function uc(){var e=null!==sc&&sc.apply(this,arguments)||this;return e.flow="none",e.incidents=!1,e}(window&&window.__extends||(lc=function(e,t){return(lc=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}lc(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(pc,hc=cc);var lc,hc,dc=pc;function pc(){var e=null!==hc&&hc.apply(this,arguments)||this;return e.isActive=!1,e.style=l.ControlStyle.light,e}(window&&window.__extends||(fc=function(e,t){return(fc=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}fc(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(yc,gc=eo),Object.defineProperty(yc.prototype,"isActive",{get:function(){var e;return!!this.map&&("none"!==(e=this.map.getTraffic()).flow||e.incidents)},set:function(e){this.map&&this.map.setTraffic({flow:e?this.options.flow:"none",incidents:!!e&&this.options.incidents})},enumerable:!1,configurable:!0}),yc.prototype.onAdd=function(e){(this.map=e).getTraffic(),void 0!==this.initIsActive&&(this.isActive=this.initIsActive),this.container=this.buildContainer(e,this.style,"Traffic Control"),this.container.style.flexDirection="column";var e=this.constructTrafficButton(e),t=(this.container.appendChild(e),jt("Toggle Traffic Display"));return this.container.appendChild(t),Ht(t,e),this.container},yc.prototype.onRemove=function(){gc.prototype.onRemove.call(this),this.map=null},yc.prototype.getOptions=function(){return(new dc).merge({isActive:this.isActive,flow:this.options.flow,incidents:this.options.incidents,style:this.style})},yc.prototype.updateButtonState=function(){this.trafficButton&&(this.isActive?(this.container.classList.add("in-use"),this.trafficButton.setAttribute("aria-description","Traffic is displayed")):(this.container.classList.remove("in-use"),this.trafficButton.removeAttribute("aria-description")),this.trafficButton.setAttribute("aria-pressed",this.isActive?"true":"false"))},yc.prototype.constructTrafficButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("traffic"),o.setAttribute("aria-label","Toggle Traffic Display"),o.setAttribute("alt","Toggle Traffic Display"),o.setAttribute("type","button"),this.trafficButton=o,this.updateButtonState(),o.addEventListener("click",function(){t.isActive=!t.isActive}),o};var fc,gc,mc=yc;function yc(e){var t,o=this;return(o=gc.call(this)||this).hasMouse=!1,o.hasFocus=!1,o.options=(new cc).merge({flow:"relative",incidents:!0}),o.style=l.ControlStyle.light,o.container=null,o.trafficButton=null,o.map=null,e&&(o.initIsActive=null!=(t=e.isActive)&&t,o.options.flow=e.flow||"relative",o.options.incidents=null==(t=e.incidents)||t,o.style=e.style||l.ControlStyle.light),o}var vc,_c,n=window&&window.__extends||(vc=function(e,t){return(vc=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}vc(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),wc=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},o=(n(bc,_c=eo),bc.prototype.onAdd=function(e){this.map=e;var t=this.buildContainer(e,l.ControlStyle.auto,"Traffic Legend"),e=this.buildTrafficLegendDiv(e);return t.setAttribute("role","definition"),t.appendChild(e),t},bc.prototype.onRemove=function(){_c.prototype.onRemove.call(this),this.syncHiddenState&&(this.map.events.remove("styledata",this.syncHiddenState),this.syncHiddenState=null),this.map=null},bc.prototype.buildTrafficLegendDiv=function(t){var o,e,r,n,i=document.createElement("div"),a=(i.classList.add("traffic-legend","hidden"),i.setAttribute("alt","Traffic Legend"),document.createElement("table")),s=document.createElement("tr"),c=document.createElement("td"),u=(c.setAttribute("alt","Traffic"),c.appendChild(document.createTextNode("Traffic")),jt("Traffic")),l=(c.classList.add("traffic-legend-title"),c.colSpan=6,s.appendChild(c),s.appendChild(u),Ht(u,c),a.appendChild(s),document.createElement("tr"));try{for(var h=wc(this.table),d=h.next();!d.done;d=h.next()){var p=d.value,f=document.createElement("td");if("Fast"===p||"Slow"===p)f.setAttribute("alt",p),f.appendChild(document.createTextNode(p)),f.classList.add("traffic-legend-text");else{f.classList.add("traffic-legend-colors"),f.setAttribute("aria-label","Traffic Legend"),f.setAttribute("role","img");try{r=void 0;for(var g=wc(p),m=g.next();!m.done;m=g.next()){var y=m.value,v=document.createElement("div");v.classList.add(y),f.appendChild(v)}}catch(e){r={error:e}}finally{try{m&&!m.done&&(n=g.return)&&n.call(g)}finally{if(r)throw r.error}}}l.appendChild(f);var _=jt(p instanceof Array?"Traffic Legend":p);l.appendChild(_),Ht(_,f)}}catch(e){o={error:e}}finally{try{d&&!d.done&&(e=h.return)&&e.call(h)}finally{if(o)throw o.error}}return a.appendChild(l),i.appendChild(a),this.syncHiddenState=function(e){"style"===e.dataType&&((e=t.getTraffic()).flow&&"none"!==e.flow?i.classList.remove("hidden"):i.classList.add("hidden"))},this.syncHiddenState({dataType:"style"}),t.events.add("styledata",this.syncHiddenState),i},bc);function bc(){var e=_c.call(this)||this;return e.table=["Fast",["green","yellow","red","dark-red"],"Slow"],e.map=null,e.syncHiddenState=null,e}function Cc(e){return this.__data__.has(e)}var Sc=sr;function Ec(e){var t=-1,o=null==e?0:e.length;for(this.__data__=new Sc;++t<o;)this.add(e[t])}Ec.prototype.add=Ec.prototype.push=function(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this},Ec.prototype.has=Cc;var Tc=Ec,Ic=function(e,t){for(var o=-1,r=null==e?0:e.length;++o<r;)if(t(e[o],o,e))return!0;return!1},kc=function(e,t){return e.has(t)};function Ac(e,t,o,r,n,i){var a=1&o,s=e.length,c=t.length;if(s!=c&&!(a&&s<c))return!1;var c=i.get(e),u=i.get(t);if(c&&u)return c==t&&u==e;var l=-1,h=!0,d=2&o?new Tc:void 0;for(i.set(e,t),i.set(t,e);++l<s;){var p,f=e[l],g=t[l];if(void 0!==(p=r?a?r(g,f,l,t,e,i):r(f,g,l,e,t,i):p)){if(p)continue;h=!1;break}if(d){if(!Ic(t,function(e,t){if(!kc(d,t)&&(f===e||n(f,e,o,r,i)))return d.push(t)})){h=!1;break}}else if(f!==g&&!n(f,g,o,r,i)){h=!1;break}}return i.delete(e),i.delete(t),h}function Pc(e){var o=-1,r=Array(e.size);return e.forEach(function(e,t){r[++o]=[t,e]}),r}function Oc(e){var t=-1,o=Array(e.size);return e.forEach(function(e){o[++t]=e}),o}var Rc=i,xc=bo,Mc=Ac,e=jo?jo.prototype:void 0,Nc=e?e.valueOf:void 0;var Lc=ki,Dc=Object.prototype.hasOwnProperty;var qc=Kt,Uc=Ac,jc=function(e,t,o,r,n,i,a){switch(o){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return e.byteLength==t.byteLength&&i(new Rc(e),new Rc(t))?!0:!1;case"[object Boolean]":case"[object Date]":case"[object Number]":return xc(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var s=Pc;case"[object Set]":s=s||Oc;if(e.size!=t.size&&!(1&r))return!1;var c=a.get(e);if(c)return c==t;r|=2,a.set(e,t);c=Mc(s(e),s(t),r,n,i,a);return a.delete(e),c;case"[object Symbol]":if(Nc)return Nc.call(e)==Nc.call(t)}return!1},Hc=function(e,t,o,r,n,i){var a=1&o,s=Lc(e),c=s.length;if(c!=Lc(t).length&&!a)return!1;for(var u=c;u--;){var l=s[u];if(!(a?l in t:Dc.call(t,l)))return!1}var h=i.get(e),d=i.get(t);if(h&&d)return h==t&&d==e;for(var p=!0,f=(i.set(e,t),i.set(t,e),a);++u<c;){var g,m=e[l=s[u]],y=t[l];if(!(void 0===(g=r?a?r(y,m,l,t,e,i):r(m,y,l,e,t,i):g)?m===y||n(m,y,o,r,i):g)){p=!1;break}f=f||"constructor"==l}return p&&!f&&(h=e.constructor)!=(d=t.constructor)&&"constructor"in e&&"constructor"in t&&!("function"==typeof h&&h instanceof h&&"function"==typeof d&&d instanceof d)&&(p=!1),i.delete(e),i.delete(t),p},Bc=a,Fc=Fr,zc=hn,Kc=ln,Gc="[object Arguments]",Yc="[object Array]",Wc="[object Object]",Zc=Object.prototype.hasOwnProperty;var Qc=function(e,t,o,r,n,i){var a=Fc(e),s=Fc(t),c=a?Yc:Bc(e),s=s?Yc:Bc(t),u=(c=c==Gc?Wc:c)==Wc,l=(s=s==Gc?Wc:s)==Wc;if((s=c==s)&&zc(e)){if(!zc(t))return!1;u=!(a=!0)}if(s&&!u)return i=i||new qc,a||Kc(e)?Uc(e,t,o,r,n,i):jc(e,t,c,o,r,n,i);if(!(1&o)){a=u&&Zc.call(e,"__wrapped__"),c=l&&Zc.call(t,"__wrapped__");if(a||c)return n(a?e.value():e,c?t.value():t,o,r,i=i||new qc)}return s&&(i=i||new qc,Hc(e,t,o,r,n,i))},Vc=on;var Jc=function e(t,o,r,n,i){return t===o||(null==t||null==o||!Vc(t)&&!Vc(o)?t!=t&&o!=o:Qc(t,o,r,n,e,i))};var Xc=q(function(e,t){return Jc(e,t)}),$c=(eu.TYPE="Feature",eu);function eu(e,t,o,r){this.type="Feature",this.type=eu.TYPE,this.properties=t||{},this.id=o,this.geometry=e,this.bbox=r}var tu,ou,ii=window&&window.__extends||(tu=function(e,t){return(tu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}tu(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),ru=(ou=Array,ii(nu,ou),nu.fromData=function(o){var r=NaN,n=NaN,i=new Set(["y"]),a=new Set(["x"]);return Object.keys(o).forEach(function(e){var t=e.toLowerCase();isNaN(r)&&i.has(t)&&"number"==typeof o[e]?r=o[e]:isNaN(n)&&a.has(t)&&"number"==typeof o[e]&&(n=o[e])}),isNaN(r)||isNaN(n)?null:new nu(r,n)},nu.getX=function(e){return 0<e.length?e[0]:NaN},nu.getY=function(e){return 1<e.length?e[1]:NaN},nu.getDestination=function(e,t,o){return new nu(nu.getX(e)+o*Math.cos((t+270)*Math.PI/180),nu.getY(e)+o*Math.sin((t+270)*Math.PI/180))},nu.getDistance=function(e,t){var o=nu.getX(e)-nu.getX(t),e=nu.getY(e)-nu.getY(t);return Math.sqrt(o*o+e*e)},nu.getHeading=function(e,t){var o=nu.getX(t)-nu.getX(e),e=nu.getY(e)-nu.getY(t);return 180*(2.5*Math.PI-Math.atan2(e,o))/Math.PI%360},nu);function nu(e,t){return ou.call(this,e,t)||this}au.TYPE="Point";var iu=au;function au(e){this.type="Point",this.type=au.TYPE,this.coordinates=e}var su,cu,uu,lu,hu,du=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},pu=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},fu=6378137,gu=Math.PI/180,mu=180/Math.PI,yu=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9],vu=85.0511;function _u(e){return e*gu}function wu(e){return e*mu}function bu(e,t,o){return Math.min(Math.max(e,t),o)}function Cu(e,t){var o=_u(t[1]-e[1]),r=_u(t[0]-e[0]),o=Math.pow(Math.sin(o/2),2)+Math.cos(_u(e[1]))*Math.cos(_u(t[1]))*Math.pow(Math.sin(r/2),2),e=2*Math.atan2(Math.sqrt(o),Math.sqrt(1-o));return Math.round(fu*e*100)/100}function Su(e){if(e)switch(e.toLowerCase()){case"feet":case"foot":case"ft":return cu.feet;case"kilometers":case"kilometer":case"kilometres":case"kilometre":case"km":case"kms":return cu.kilometers;case"miles":case"mile":case"mi":return cu.miles;case"nauticalmiles":case"nauticalmile":case"nms":case"nm":return cu.nauticalMiles;case"yards":case"yard":case"yds":case"yrd":case"yrds":return cu.yards;default:return cu.meters}return cu.meters}function Eu(e){if(e)switch(e.toLowerCase()){case"milespersecondsquared":case"milepersecondsquared":case"mi/s^2":case"mi/s2":return hu.milesPerSecondSquared;case"kilometerspersecondsquared":case"kilometrespersecondsquared":case"kilometerpersecondsquared":case"kilometrepersecondsquared":case"km/s^2":case"km/s2":return hu.kilometersPerSecondSquared;case"knotspersecond":case"knotpersecond":case"knts/s":case"kn/s":case"kt/s":return hu.knotsPerSecond;case"standardgravity":case"g":return hu.standardGravity;case"feetpersecondsquared":case"footpersecondsquared":case"ft/s^2":case"ft/s2":return hu.feetPerSecondSquared;case"yardspersecondsquared":case"yardpersecondsquared":case"yds/s^2":case"yds/s2":case"yd/s^2":case"yd/s2":return hu.yardsPerSecondSquared;case"milesperhoursecond":case"mileperhoursecond":case"milesperhourseconds":case"mileperhourseconds":case"mi/h/s":return hu.milesPerHourSecond;case"kilometersperhoursecond":case"kilometrespersoursecond":case"kilometerperhoursecond":case"kilometrepersoursecond":case"kilometersperhourssecond":case"kilometrespersourssecond":case"kilometerperhourssecond":case"kilometrepersourssecond":case"kmhs":case"km/h/s":return hu.kilometersPerHourSecond;default:return hu.metersPerSecondSquared}return hu.metersPerSecondSquared}function Tu(e){if(e)switch(e){case"acres":case"ac":return su.acres;case"hectares":case"ha":return su.hectares;case"squareFeet":case"ft^2":case"ft2":return su.squareFeet;case"squareYards":case"squareYard":case"yds^2":case"yds2":case"yd^2":case"yd2":return su.squareYards;case"squareKilometers":case"squareKilometres":case"squareKilometer":case"squareKilometre":case"km^2":case"km2":return su.squareKilometers;case"squareMiles":case"squareMile":case"mi^2":case"mi2":return su.squareMiles;default:return su.squareMeters}return su.squareMeters}function Iu(e){if(e)switch(e.toLowerCase()){case"feetpersecond":case"footsecond":case"ftps":case"ft/s":return lu.feetPerSecond;case"milesperhour":case"mileperhour":case"mph":case"mi/hr":case"mi/h":return lu.milesPerHour;case"knots":case"knot":case"knts":case"knt":case"kn":case"kt":return lu.knots;case"mach":case"m":return lu.mach;case"kilometersperhour":case"kilometresperhour":case"kmperhour":case"kmph":case"km/hr":case"km/h":return lu.kilometersPerHour;default:return lu.metersPerSecond}return lu.metersPerSecond}function ku(e){if(e)switch(e.toLowerCase()){case"milliseconds":case"ms":return uu.ms;case"minutes":case"minute":case"mins":case"min":return uu.minutes;case"hours":case"hour":case"hr":case"h":return uu.hours;case"days":case"day":case"d":return uu.days;default:return uu.seconds}return uu.seconds}function Au(e){var t=0;if(e&&0<e.length)for(var t=Math.abs(Pu(e[0])),o=1,r=e.length;o<r;o++)t-=Math.abs(Pu(e[o]));return t}function Pu(e){var t=0;if(3<=e.length){for(var o=void 0,r=void 0,n=0,i=e.length;n<i;n++)t+=(_u(e[n===i-2?(o=i-2,r=i-1,0):n===i-1?(o=i-1,r=0,1):(r=(o=n)+1,n+2)][0])-_u(e[o][0]))*Math.sin(_u(e[r][1]));t=t*fu*fu/2}return t}function Ou(e,t,o){return(e[0]-o[0])*(t[1]-o[1])-(e[1]-o[1])*(t[0]-o[0])}function Ru(e,t,o){if(2<=o.length){for(var r,n,i,a=1/0,s=null,c=Vu(o,22),u=0,l=c.length-1;u<l;u++)n=function(e,t,o){if(t[0]===o[0]&&t[1]===o[1])return t;var r=e[0]-t[0],e=e[1]-t[1],n=o[0]-t[0],i=o[1]-t[1],r=(n*r+i*e)/(n*n+i*i);return r<0?t:1<r?o:[t[0]+n*r,t[1]+i*r]}(t,c[u],c[u+1]),(r=ru.getDistance(t,n))<a&&(a=r,s=n);if(s)return i=Qu([s],22)[0],new $c(new iu(i),{distance:Lu(e,i)})}else if(1===o.length)return new $c(new iu(o[0]),{distance:Lu(e,o[0])});return null}function xu(e,t){var o;return!isNaN(e)&&"number"==typeof t&&0<=t&&(o=void 0,o=t<yu.length?yu[t]:Math.pow(10,t),e=Math.round(e*o)/o),e}function Mu(e,t,o,r){switch(Su(t)){case cu.meters:e/=1e3;break;case cu.feet:e/=3280.8399;break;case cu.miles:e/=.62137119;break;case cu.yards:e/=1093.6133;break;case cu.nauticalMiles:e/=.5399568;break;case cu.kilometers:}switch(Su(o)){case cu.meters:e*=1e3;break;case cu.feet:e*=3280.8399;break;case cu.miles:e*=.62137119;break;case cu.yards:e*=1093.6133;break;case cu.nauticalMiles:e*=.5399568;break;case cu.kilometers:}return"number"==typeof r&&0<=r&&(t=Math.pow(10,r),e=Math.round(e*t)/t),e}function Nu(e,t,o,r){r=r||"meters",e=al(e);var r=Du(r),n=_u(e[1]),e=_u(e[0]),t=t*gu,o=o/r,r=Math.asin(Math.sin(n)*Math.cos(o)+Math.cos(n)*Math.sin(o)*Math.cos(t)),e=e+Math.atan2(Math.sin(t)*Math.sin(o)*Math.cos(n),Math.cos(o)-Math.sin(n)*Math.sin(r)),t=bu(Yu(r*mu),-85,85);return[Wu(e*mu),t]}function Lu(e,t,o){e=Cu(e=al(e),t=al(t));return"meters"===o?e:Mu(e,"meters",o||"meters")}function Du(e){e=Su(e);return Mu(fu,cu.meters,e)}function qu(e,t,o){for(var r=[],n=_u(e[1]),i=_u(e[0]),a=_u(t[1]),s=_u(t[0]),c=2*Math.asin(Math.sqrt(Math.pow(Math.sin((n-a)/2),2)+Math.cos(n)*Math.cos(a)*Math.pow(Math.sin((i-s)/2),2))),u=0;u<=o;u++){var l=u/o,h=Math.sin((1-l)*c)/Math.sin(c),l=Math.sin(l*c)/Math.sin(c),d=h*Math.cos(n)*Math.cos(i)+l*Math.cos(a)*Math.cos(s),p=h*Math.cos(n)*Math.sin(i)+l*Math.cos(a)*Math.sin(s),h=h*Math.sin(n)+l*Math.sin(a),l=Math.atan2(h,Math.sqrt(Math.pow(d,2)+Math.pow(p,2))),h=Math.atan2(p,d),l=bu(l*mu,-85,85);r.push([h*=mu,l])}return r}function Uu(e){return(Array.isArray(e)?e:e.coordinates).reduce(function(e,t){var o=0<e.length?e[e.length-1]:null;return o&&180<Math.abs(t[0]-o[0])?(o=o[0]<0?t[0]-360:t[0]+360,e.push([o,t[1]])):e.push(t),e},[])}function ju(e){for(var t,o,r,n,i,a=Array.isArray(e)?e:e.coordinates,s=[],c=[],u=0;u<a.length;u++)s.push(a[u]),u+1>=a.length||(t=(o=du(a[u],2))[0],o=o[1],n=(i=du(a[u+1],2))[0],i=i[1],180<Math.abs(n-t)&&(r=0<t?180:-180,n=Math.abs((0<t?n+360:n-360)-t),i=o+(i-o)*(Math.abs(r-t)/n),s.push([r,i]),c.push(s),s=[[-r,i]]));return c.push(s),c}function Hu(e,t){var o,r;return e=al(e),t=al(t),e&&2<=e.length&&t&&2<=t.length?(r=_u(e[1]),o=_u(t[1]),t=_u(t[0]-e[0]),e=Math.sin(t)*Math.cos(o),r=Math.cos(r)*Math.sin(o)-Math.sin(r)*Math.cos(o)*Math.cos(t),(wu(Math.atan2(e,r))+360)%360):NaN}function Bu(e,t){var o,r=0;Array.isArray(e)?o=e:e.type&&"LineString"===e.type&&(o=e.coordinates);for(var n=0,i=o.length-1;n<i;n++)r+=Cu(o[n],o[n+1]);return Mu(r,"meters",t||"meters")}function Fu(e,t,o){o=o||"meters";var r,n=0;if(Array.isArray(e)?r=e:e.type&&"LineString"===e.type&&(r=e.coordinates),2<=r.length){for(var i,a,s=r.length,c=1;c<s;c++){if(t<=n+(a=Lu(r[c-1],r[c],o)))return i=Hu(r[c-1],r[c]),Nu(r[c-1],i,t-n,o);n+=a}return n<=t?r[s-1]:r[0]}return null}function zu(e,t,o,r,n){r=r||"meters",n=n||0,e=al(e);for(var i=[],a=360/o,s=0;s<=o;s++)i.push(Nu(e,(s*a+n)%360,t,r));return i}function Ku(e,t,o,r,n){return Uu(zu(e,t,o,r,n))}function Gu(e,t,o){o=void 0===o?.5:o;var r=Lu(e=al(e),t=al(t),"kilometers");return Nu(e,Hu(e,t),r*o,"kilometers")}function Yu(e){return 90<e?180<(e=(e+90)%360)?90-(e-180):e-90:e<-90?(e=(e-90)%360)<-180?-90-(e+180):e+90:e}function Wu(e){return 180<e?(e+180)%360-180:e<-180?(e-180)%360+180:e}function Zu(e,t,o){if(0===o)return Object.assign({},e);t=al(t);for(var r,n,i=[],a=0,s=e.length;a<s;a++)r=Lu(t,e[a]),n=Hu(t,e[a]),i.push(Nu(t,n+o,r));return i}function Qu(e,t){for(var o,r,n=512*Math.pow(2,t),i=[],a=0,s=e.length;a<s;a++)o=e[a][0]/n-.5,r=.5-e[a][1]/n,i.push([360*o,90-360*Math.atan(Math.exp(2*-r*Math.PI))/Math.PI]);return i}function Vu(e,t){for(var o,r,n=512*Math.pow(2,t),i=[],a=0,s=e.length;a<s;a++)r=Math.sin(e[a][1]*Math.PI/180),o=(e[a][0]+180)/360,r=.5-Math.log((1+r)/(1-r))/(4*Math.PI),i.push([Math.round(o*n),Math.round(r*n)]);return i}function Ju(e,t,o,r){switch(Eu(t)){case hu.kilometersPerHourSecond:e/=3.6;break;case hu.milesPerHourSecond:e/=2.236936292054;break;case hu.knotsPerSecond:e/=1.943844492441;break;case hu.standardGravity:e/=.1019716212978;break;case hu.kilometersPerSecondSquared:e/=.001;break;case hu.milesPerSecondSquared:e/=.000621371192;break;case hu.feetPerSecondSquared:e/=3.280839895012;break;case hu.yardsPerSecondSquared:e/=1.093613298338;break;case hu.metersPerSecondSquared:}switch(Eu(o)){case hu.kilometersPerHourSecond:e*=3.6;break;case hu.milesPerHourSecond:e*=2.236936292054;break;case hu.knotsPerSecond:e*=1.943844492441;break;case hu.standardGravity:e*=.1019716212978;break;case hu.kilometersPerSecondSquared:e*=.001;break;case hu.milesPerSecondSquared:e*=.000621371192;break;case hu.feetPerSecondSquared:e*=3.280839895012;break;case hu.yardsPerSecondSquared:e*=1.093613298338;break;case hu.metersPerSecondSquared:}return xu(e,r)}function Xu(e,t,o,r){switch(Tu(t)){case su.acres:e*=4046.8564224;break;case su.hectares:e*=1e4;break;case su.squareFeet:e*=.09290304;break;case su.squareKilometers:e*=1e6;break;case su.squareMiles:e*=259e4;break;case su.squareYards:e*=.83612736;break;case su.squareMeters:}switch(Tu(o)){case su.acres:e/=4046.8564224;break;case su.hectares:e/=1e4;break;case su.squareFeet:e/=.09290304;break;case su.squareKilometers:e/=1e6;break;case su.squareMiles:e/=259e4;break;case su.squareYards:e/=.83612736;break;case su.squareMeters:}return xu(e,r)}function $u(e,t,o,r){switch(Iu(t)){case lu.feetPerSecond:e*=1.09728;break;case lu.milesPerHour:e*=1.6093;break;case lu.knots:e*=1.852;break;case lu.metersPerSecond:e*=3.6;break;case lu.mach:e*=1234.8;break;case lu.kilometersPerHour:}switch(Iu(o)){case lu.feetPerSecond:e/=1.09728;break;case lu.milesPerHour:e/=1.6093;break;case lu.knots:e/=1.852;break;case lu.metersPerSecond:e/=3.6;break;case lu.mach:e/=1234.8;break;case lu.kilometersPerHour:}return xu(e,r)}function el(e,t,o,r){switch(ku(t)){case uu.ms:e/=1e3;break;case uu.hours:e*=3600;break;case uu.minutes:e*=60;break;case uu.days:e*=86400;break;case uu.seconds:}switch(ku(o)){case uu.ms:e*=1e3;break;case uu.hours:e/=3600;break;case uu.minutes:e/=60;break;case uu.days:e/=86400;break;case uu.seconds:}return xu(e,r)}function tl(e,t,o,r,n,i,a,s){t=Mu(t,n,cu.meters),n=el(o,i,uu.seconds);return Ju(2*(t-$u(e,r,lu.metersPerSecond)*n)/(n*n),hu.metersPerSecondSquared,a,s)}function ol(e,t,o,r,n,i,a){e=$u(e,r,lu.metersPerSecond);return Ju(($u(t,r,lu.metersPerSecond)-e)/el(o,n,uu.seconds),hu.metersPerSecondSquared,i,a)}function rl(e,t,o,r){e=nl(e),t=nl(t);return null!=e&&null!=t?el(t.getTime()-e.getTime(),uu.ms,o,r):NaN}function nl(e){if("[object Date]"===Object.prototype.toString.call(e))return e;if("string"==typeof e){var t=Date.parse(e);if(!isNaN(t))return new Date(t);if(0<=e.indexOf("Date("))return t=(t=0)<(e=e.replace("/Date(","").replace(")/","")).indexOf("+")?parseInt(e.substr(0,e.indexOf("+")),10):0<e.indexOf("-")?parseInt(e.substr(0,e.indexOf("-")),10):parseInt(e,10),new Date(t)}else if("number"==typeof e)return new Date(e);return null}function il(e){var t=[],o=null,r=null;if(Array.isArray(e)&&0<e.length)if(Array.isArray(e[0])&&"number"==typeof e[0][0])t=e;else for(var n=e.length,i=0;i<n;i++)t=t.concat(il(e[i]));else if(e.type)switch(e.type){case"Point":t=[e.coordinates];break;case"LineString":t=e.coordinates;break;case"Polygon":o=e.coordinates;break;case"MultiPoint":t=e.coordinates;break;case"MultiLineString":o=e.coordinates;break;case"MultiPolygon":r=e.coordinates;break;case"Feature":var a=e,t=vl._isCircle(a)?vl._getCirclePositions(a):il(a.geometry);break;case"FeatureCollection":t=il(e.features);break;case"GeometryCollection":t=il(e.geometries)}else if(e instanceof vl)return il(e.toJson());if(o)for(n=o.length,i=0;i<n;i++)t=t.concat(o[i]);else if(r)for(var s=r.length,i=0;i<s;i++)for(var c=r[i].length,u=0;u<c;u++)t=t.concat(r[i][u]);return t}function al(e){if(Array.isArray(e)&&"number"==typeof e[0])return e;if(e.type){if("Point"===e.type)return e.coordinates;if("Feature"===e.type&&"Point"===e.geometry.type)return e.geometry.coordinates}else if(e instanceof vl&&"Point"===e.getType())return e.getCoordinates();return null}function sl(e,t,o){o=o||"meters";var r,n=0;if(Array.isArray(e)?r=e:e.type&&"LineString"===e.type&&(r=e.coordinates),2<=r.length){for(var i,a,s,c=r.length,u=1;u<c;u++){if(t<=n+(s=Lu(r[u-1],r[u],o)))return i=Hu(r[u-1],r[u]),a=Nu(r[u-1],i,t-n,o),new $c(new iu(a),{heading:i});n+=s}return n<=t?new $c(new iu(r[c-1]),{heading:Hu(r[c-2],r[c-1])}):new $c(new iu(r[0]),{heading:Hu(r[0],r[1])})}return null}function cl(e,t,o,r){var n=al(e),i=Vu([n],22)[0],a=null,s=1/0;switch((t=t instanceof vl?t.toJson():t).type){case"Feature":return cl(e,t.geometry,o);case"Point":p=[[t.coordinates]];break;case"MultiPoint":for(var c,u=t.coordinates,l=0,h=u.length;l<h;l++)(c=Lu(n,u[l]))<s&&(s=c,a=new $c(new iu(u[l]),{distance:c}));break;case"LineString":p=[t.coordinates];break;case"Polygon":case"MultiLineString":p=t.coordinates;break;case"MultiPolygon":var d=t.coordinates;if(0<d.length)for(var p=d[0],l=1,h=d.length;l<h;l++)p=p.concat(d[l])}if(p)for(var f,l=0,h=p.length;l<h;l++)(f=Ru(n,i,p[l]))&&f.properties.distance<s&&(s=f.properties.distance,a=f);return a&&(a.properties.distance=Mu(a.properties.distance,"meters",o,r)),a}(sn=su=su||{}).squareMeters="squareMeters",sn.acres="acres",sn.hectares="hectares",sn.squareFeet="squareFeet",sn.squareKilometers="squareKilometers",sn.squareMiles="squareMiles",sn.squareYards="squareYards",(Mi=cu=cu||{}).meters="meters",Mi.kilometers="kilometers",Mi.feet="feet",Mi.miles="miles",Mi.nauticalMiles="nauticalMiles",Mi.yards="yards",(r=uu=uu||{}).seconds="seconds",r.hours="hours",r.ms="ms",r.minutes="minutes",r.days="days",(Ho=lu=lu||{}).metersPerSecond="metersPerSecond",Ho.kilometersPerHour="kilometersPerHour",Ho.feetPerSecond="feetPerSecond",Ho.milesPerHour="milesPerHour",Ho.knots="knots",Ho.mach="mach",(s=hu=hu||{}).milesPerSecondSquared="milesPerSecondSquared",s.kilometersPerSecondSquared="kilometersPerSecondSquared",s.knotsPerSecond="knotsPerSecond",s.standardGravity="standardGravity",s.feetPerSecondSquared="feetPerSecondSquared",s.yardsPerSecondSquared="yardsPerSecondSquared",s.milesPerHourSecond="milesPerHourSecond",s.kilometersPerHourSecond="kilometersPerHourSecond",s.metersPerSecondSquared="metersPerSecondSquared";var ul,ll,n=window&&window.__extends||(ul=function(e,t){return(ul=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ul(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),hl=(ll=Array,n(dl,ll),dl.fromPosition=function(e){return 2===e.length?new dl(e[0],e[1]):2<e.length?new dl(e[0],e[1],e[2]):null},dl.areEqual=function(e,t,o){var r,n;return void 0===o&&(o=6),!!(e&&2<=e.length&&t&&2<=t.length)&&(o=Math.pow(10,o),n=Yu(e[1]),r=Yu(t[1]),e=Wu(e[0]),t=Wu(t[0]),0==Math.round((n-r)*o)/o)&&(0==(n=Math.round((e-t)*o)/o)||360==n)},dl.fromLatLng=function(n,e,t){var i,a,s,c,u,l,o=[];return"number"==typeof n?("number"==typeof e&&o.push(e),o.push(n),"number"==typeof t&&o.push(t)):Array.isArray(n)?2<=n.length&&"number"==typeof n[0]&&"number"==typeof n[1]&&(3<=n.length&&"number"==typeof n[2]?o.push(n[1],n[0],n[2]):o.push(n[1],n[0])):"object"==typeof n&&(i=["lat","latitude","y"],a=["lng","longitude","lon","x"],s=["elv","elevation","alt","altitude","z"],l=u=c=NaN,Object.keys(n).forEach(function(e,t,o){var r=e.toLowerCase();isNaN(c)&&0<=i.indexOf(r)&&"number"==typeof n[e]?c=n[e]:isNaN(u)&&0<=a.indexOf(r)&&"number"==typeof n[e]?u=n[e]:isNaN(l)&&0<=s.indexOf(r)&&"number"==typeof n[e]&&(l=n[e])}),isNaN(c)||isNaN(u)||(o.push(u,c),isNaN(l))||o.push(l)),2<=o.length?o:null},dl.fromLatLngs=function(e){var t=[];if(Array.isArray(e))for(var o=0,r=e.length;o<r;o++){var n=dl.fromLatLng(e[o]);n&&t.push(n)}return t},dl._getDimensions=function(e){for(var t=0;Array.isArray(e);)e=e[0],t++;return"number"==typeof e&&t--,t},dl);function dl(e,t,o){return o?ll.call(this,e,t,o)||this:ll.call(this,e,t)||this}fl.TYPE="Polygon";var pl=fl;function fl(e,t){this.type="Polygon",this.type=fl.TYPE,1===hl._getDimensions(e)?this.coordinates=[e]:this.coordinates=e,this.bbox=t}var gl,ml,sr=window&&window.__extends||(gl=function(e,t){return(gl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}gl(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),yl=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},vl=(sr(_l,ml=Vt),_l.prototype.addProperty=function(e,t){Xc(this.data.properties[e],t)||(this.data.properties[e]=Za(t),"subType"!==e&&"radius"!==e||this._handleCircle(),this.dataSource&&this.dataSource._updateSource(),this._invokeEvent("shapechanged",this))},_l.prototype.getBounds=function(){var t,e,o,r,n,i=this.getCoordinates(),a=this.getType();if("Point"===a)n=this.circlePolygon?(s=this.circlePolygon.geometry.coordinates,f.fromPositions(s[0])):new f(s=i,s);else if("MultiPoint"===a||"LineString"===a){var s=i;n=f.fromPositions(s)}else if("Polygon"===a){s=i;n=f.fromPositions(s[0])}else if("MultiLineString"===a){s=i;try{for(var c=yl(s),u=c.next();!u.done;u=c.next()){var l=u.value;n=f.merge(n,f.fromPositions(l))}}catch(e){t={error:e}}finally{try{u&&!u.done&&(e=c.return)&&e.call(c)}finally{if(t)throw t.error}}}else if("MultiPolygon"===a){s=i;try{for(var h=yl(s),d=h.next();!d.done;d=h.next()){var p=d.value;n=f.merge(n,f.fromPositions(p[0]))}}catch(e){o={error:e}}finally{try{d&&!d.done&&(r=h.return)&&r.call(h)}finally{if(o)throw o.error}}}return n},_l.prototype.getCoordinates=function(){return Za(this.data.geometry.coordinates)},_l.prototype.getCircleCoordinates=function(){return this.circlePolygon?Za(this.circlePolygon.geometry.coordinates[0]):null},_l.prototype.getId=function(){return this.data.id},_l.prototype.getProperties=function(){return Za(this.data.properties)},_l.prototype.getType=function(){return this.data.geometry.type},_l.prototype.isCircle=function(){return _l._isCircle(this.data)},_l.prototype.isRectangle=function(){return _l._isRectangle(this.data)},_l.prototype.setCoordinates=function(e){e="Polygon"===this.getType()&&1===hl._getDimensions(e)?[e]:e;Xc(this.data.geometry.coordinates,e)||(this.data.geometry.coordinates=Za(e),this._handleCircle(),this.dataSource&&this.dataSource._updateSource(),this._invokeEvent("shapechanged",this))},_l.prototype.setProperties=function(e){e[_l._shapeIdPropName]=this.data.id,Xc(this.data.properties,e)||(this.data.properties=Za(e),this._handleCircle(),this.dataSource&&this.dataSource._updateSource(),this._invokeEvent("shapechanged",this))},_l.prototype.toJson=function(){return JSON.parse(JSON.stringify(this.data))},_l.prototype._toJson=function(){return this.circlePolygon||this.data},_l.prototype._setDataSource=function(e){void 0===e||null==e?delete this.dataSource:this.dataSource=e},_l.prototype._handleCircle=function(){var e;this.isCircle()?(e=_l._getCirclePositions(this.data),this.circlePolygon=new $c(new pl([e]),this.data.properties,this.data.id),this.data.properties.subType="Circle"):delete this.circlePolygon},_l._isCircle=function(e){return e&&e.geometry&&"Point"===e.geometry.type&&e.geometry.coordinates&&e.properties&&"string"==typeof e.properties.subType&&"circle"===e.properties.subType.toLowerCase()&&"number"==typeof e.properties.radius},_l._isRectangle=function(e){if("Polygon"===e.geometry.type&&e.geometry.coordinates&&"string"==typeof e.properties.subType&&"rectangle"===e.properties.subType.toLowerCase()){e=e.geometry.coordinates;if(1===e.length){e=e[0];if(5===e.length)return e[0][0]===e[4][0]&&e[0][1]===e[4][1];if(4===e.length)return!0}}return!1},_l._getCirclePositions=function(e){return Ku(e.geometry.coordinates,e.properties.radius,72,"meters")},_l._shapeIdPropName="_azureMapsShapeId",_l);function _l(e,t,o){var r,n,i=ml.call(this)||this;return"Feature"===e.type?(n=Za((r=e).geometry),o=r.properties?Za(r.properties):{},t=null==r.id||""===r.id?W():r.id):(n=Za(e),t=null==t||""===t?W():t,o=o?Za(o):{}),o[_l._shapeIdPropName]=t,i.data=new $c(n,o,t),i._handleCircle(),i}var wl,bl,i=window&&window.__extends||(wl=function(e,t){return(wl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}wl(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),Cl=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},f=(bl=Array,i(y,bl),y.fromBoundingBox=function(e){var t=y.getWest(e),o=y.getSouth(e),r=y.getEast(e),e=y.getNorth(e);return new y([t,o,r,e])},y.fromDimensions=function(e,t,o){var r=e[0],e=e[1],n=Math.min(Math.max(e+o/2,-85.5),85.5),e=Math.min(Math.max(e-o/2,-85.5),85.5),o=Wu(r+t/2);return new y([Wu(r-t/2),e,o,n])},y.fromEdges=function(e,t,o,r){return new y([e,t,o,r])},y.containsPosition=function(e,t){var o=y.getCenter(e),r=Math.abs(o[1]-t[1]),o=Math.abs(o[0]-t[0]),t=(180<o&&(o=360-o),y.getHeight(e)),e=y.getWidth(e);return r<=t/2+1e-8&&o<=e/2+1e-8},y.containsBoundingBox=function(e,t){var o=e&&4===e.length,r=t&&4===t.length;return!(!o||!r)&&y.getWest(e)<y.getWest(t)&&y.getWest(t)<y.getEast(e)&&y.getWest(e)<y.getEast(t)&&y.getEast(t)<y.getEast(e)&&y.getSouth(e)<y.getSouth(t)&&y.getSouth(t)<y.getNorth(e)&&y.getSouth(e)<y.getNorth(t)&&y.getNorth(t)<y.getNorth(e)},y.crossesAntimeridian=function(e){return Wu(y.getEast(e))-Wu(y.getWest(e))<0||y.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe(e)||y.isBoundingBoxWithLessThanSixElementsLargerThanGlobe(e)},y.getCenter=function(e){var t=Wu(y.getEast(e)),o=Wu(y.getWest(e)),o=(t<o&&(t+=360),Wu((o+t)/2)),t=Yu(y.getSouth(e)),e=Yu(y.getNorth(e));return[o,Yu((t+e)/2)]},y.getHeight=function(e){e=Yu(y.getNorth(e))-Yu(y.getSouth(e));return isNaN(e)?0:e},y.getWidth=function(e){e=Wu(y.getEast(e))-Wu(y.getWest(e));return isNaN(e)?0:e<0?e+360:e},y.getSouthWest=function(e){var t=this.getSouth(e),e=this.getWest(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getNorthEast=function(e){var t=this.getNorth(e),e=this.getEast(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getNorthWest=function(e){var t=this.getNorth(e),e=this.getWest(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getSouthEast=function(e){var t=this.getSouth(e),e=this.getEast(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getSouth=function(e){return e&&4<=e.length?Number(e[1]):NaN},y.getWest=function(e){return e&&4<=e.length?Number(e[0]):NaN},y.getNorth=function(e){if(e){if(4===e.length)return Number(e[3]);if(6===e.length)return Number(e[4])}return NaN},y.getEast=function(e){if(e){if(4===e.length)return Number(e[2]);if(6===e.length)return Number(e[3])}return NaN},y.intersect=function(e,t){var o=y.getCenter(e),r=y.getCenter(t),n=Math.abs(o[1]-r[1]),o=Math.abs(o[0]-r[0]),r=(180<o&&(o=360-o),y.getHeight(e)),e=y.getWidth(e),i=y.getHeight(t),t=y.getWidth(t);return n<=r/2+i/2&&o<=e/2+t/2},y.merge=function(e,t){var o=e&&4===e.length,r=t&&4===t.length;if(o&&!r)return e;if(r&&!o)return t;if(!o&&!r)return null;for(var o=Math.max(Yu(y.getNorth(e)),Yu(y.getNorth(t))),r=Math.min(Yu(y.getSouth(e)),Yu(y.getSouth(t))),n=[e,t],i=[],a=0,a=0;a<n.length;a++){var s=n[a],c=Wu(y.getWest(s)),u=Wu(y.getEast(s));y.crossesAntimeridian(s)?(i.push([c,180]),i.push([-180,u])):i.push([c,u])}i.sort(function(e,t){return e[0]===t[0]?e[1]-t[1]:e[0]-t[0]});var l=[],h=i[0];for(a=1;a<i.length;){var d=i[a];h[1]>=d[0]?h[1]=Math.max(h[1],d[1]):(l.push(h),h=d),a++}l.push(h);var p=l.length,f=l[0][0]+360-l[p-1][1],g=[l[p-1][1],l[0][0]];for(a=1;a<p;a++){var m=l[a][0]-l[a-1][1];f<m&&(f=m,g=[l[a-1][1],l[a][0]])}return new y([g[1],r],[g[0],o])},y.fromPositions=function(e){for(var t,o,r=NaN,n=NaN,i=NaN,a=NaN,s=e.length,c=new Array(s),u=0;s--;)(o=e[s])&&2<=o.length&&(t=Yu(o[1]),r=isNaN(r)?t:Math.max(r,t),n=isNaN(n)?t:Math.min(n,t),c[u++]=Wu(o[0]));if(u){c.length=u,c.sort(function(e,t){return e-t});for(var l=c[0]+360-c[u-1],h=0,s=1;s<u;s++){var d=c[s]-c[s-1];l<d&&(l=d,h=s)}i=c[h],a=c[(h||u)-1]}return isNaN(i)||isNaN(n)||isNaN(a)||isNaN(r)?null:new y([i,n,a,r])},y.fromLatLngs=function(e){return y.fromPositions(hl.fromLatLngs(e))},y.fromData=function(e){var t,o,r=null;if(Array.isArray(e)&&0<e.length){try{for(var n=Cl(e),i=n.next();!i.done;i=n.next()){var a,s=i.value;null!=(a=y.fromData(s))&&(r=null===r?a:y.merge(r,a))}}catch(e){t={error:e}}finally{try{i&&!i.done&&(o=n.return)&&o.call(n)}finally{if(t)throw t.error}}return r}if(e instanceof vl)return e.getBounds();if(e&&e.type){var c=e;if(c.bbox&&4===c.bbox.length)return c.bbox;switch(c.type){case"FeatureCollection":return y.fromData(c.features);case"Feature":return vl._isCircle(c)?y.fromPositions(vl._getCirclePositions(c)):y.fromData(c.geometry);case"GeometryCollection":return y.fromData(c.geometries);case"Point":var u=c.coordinates;if(u&&2<=u.length)return[u[0],u[1],u[0],u[1]];break;case"LineString":case"MultiPoint":return y.fromPositions(c.coordinates);case"Polygon":case"MultiLineString":var l=c.coordinates;if(l&&0<l.length){for(var h=0,d=l.length;h<d;h++)null!=(a=y.fromPositions(l[h]))&&(r=null===r?a:y.merge(r,a));if(null!=r)return r}break;case"MultiPolygon":var p=c.coordinates;if(p&&0<p.length){for(h=0,d=p.length;h<d;h++)for(var f=0,g=p[h].length;f<g;f++)null!=(a=y.fromPositions(p[h][f]))&&(r=null===r?a:y.merge(r,a));return r}}}return null},y.splitOnAntimeridian=function(e){var t,o,r,n,i,a,s=[];return y.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe(e)?[[-180,e[1],e[2],180,e[4],e[5]]]:y.isBoundingBoxWithLessThanSixElementsLargerThanGlobe(e)?[[-180,e[1],180,e[3]]]:(y.crossesAntimeridian(e)?(a=t=void 0,o=Wu(y.getWest(e)),r=Wu(y.getEast(e)),n=Yu(y.getNorth(e)),i=Yu(y.getSouth(e)),a=6<=e.length?(t=[o,i,e[2],180,n,e[5]],[-180,i,e[2],r,n,e[5]]):(t=[o,i,180,n],[-180,i,r,n]),s.push(t,a)):s.push(e),s)},y.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe=function(e){return 6<=e.length&&360<e[3]-e[0]},y.isBoundingBoxWithLessThanSixElementsLargerThanGlobe=function(e){return e.length<6&&360<e[2]-e[0]},y);function y(e,t){var o,r=this;return e&&t?r=(o=e)[2]&&t[2]?bl.call(this,o[0],o[1],o[2]||0,t[0],t[1],t[2]||0)||this:bl.call(this,o[0],o[1],t[0],t[1])||this:e&&(o=e)&&(4===o.length?r=bl.call(this,o[0],o[1],o[2],o[3])||this:6<=o.length&&(r=bl.call(this,o[0],o[1],o[2],o[3],o[4],o[5])||this)),r}El.TYPE="FeatureCollection";var Sl=El;function El(e,t){this.type="FeatureCollection",this.type=El.TYPE,this.features=e,this.bbox=t}Tl.TYPE="GeometryCollection";jo=Tl;function Tl(e){this.type="GeometryCollection",this.type=Tl.TYPE,this.geometries=e}Il.TYPE="LineString";e=Il;function Il(e,t){this.type="LineString",this.type=Il.TYPE,this.coordinates=e,this.bbox=t}kl.TYPE="MultiLineString";Kt=kl;function kl(e,t){this.type="MultiLineString",this.type=kl.TYPE,this.coordinates=e,this.bbox=t}Al.TYPE="MultiPoint";a=Al;function Al(e,t){this.type="MultiPoint",this.type=Al.TYPE,this.coordinates=e,this.bbox=t}Pl.TYPE="MultiPolygon";Fr=Pl;function Pl(e,t){this.type="MultiPolygon",this.type=Pl.TYPE,this.coordinates=e,this.bbox=t}var Ol,Rl,hn=window&&window.__extends||(Ol=function(e,t){return(Ol=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ol(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),ln=(Rl=Array,hn(xl,Rl),xl.fromPosition=function(e){return 2<=e.length?new xl((180+e[0])/360,xl._latToMercatorY(e[1]),3<=e.length?xl._altitudeToMercatorZ(e[2],e[1]):0):[0,0,0]},xl.fromPositions=function(e){for(var t=[],o=0,r=e.length;o<r;o++)t.push(this.fromPosition(e[o]));return t},xl.toFloat32Array=function(e){for(var t=new Float32Array(3*e.length),o=0,r=e.length;o<r;o++){var n=3*o,i=e[o];t[n]=(180+i[0])/360,t[1+n]=xl._latToMercatorY(i[1]),t[2+n]=3<=i.length?xl._altitudeToMercatorZ(i[2],i[1]):0}return t},xl.toPosition=function(e){var t;return 2<=e.length?(t=360/Math.PI*Math.atan(Math.exp((180-360*e[1])*Math.PI/180))-90,new hl(360*e[0]-180,t,3<=e.length?xl._mercatorZToAltitude(e[2],e[1]):0)):[0,0,0]},xl.toPositions=function(e){for(var t=[],o=0,r=e.length;o<r;o++)t.push(this.toPosition(e[o]));return t},xl.mercatorScale=function(e){return 1/Math.cos(e*Math.PI/180)},xl.meterInMercatorUnits=function(e){return 1/xl.earthCircumference*xl.mercatorScale(xl._latToMercatorY(e))},xl._circumferenceAtLatitude=function(e){return xl.earthCircumference*Math.cos(e*Math.PI/180)},xl._altitudeToMercatorZ=function(e,t){return e/xl._circumferenceAtLatitude(t)},xl._mercatorZToAltitude=function(e,t){return e*xl._circumferenceAtLatitude(xl._latToMercatorY(t))},xl._latToMercatorY=function(e){return(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+e*Math.PI/360)))/360},xl.earthCircumference=2*Math.PI*Du(),xl);function xl(e,t,o){return Rl.call(this,e,t,o||0)||this}var ii=Object.freeze({__proto__:null,BoundingBox:f,Feature:$c,FeatureCollection:Sl,GeometryCollection:jo,LineString:e,MercatorPoint:ln,MultiLineString:Kt,MultiPoint:a,MultiPolygon:Fr,Point:iu,Polygon:pl,Position:hl});function Ml(e,t){return e*e+t*t}function Nl(e,t){for(var o,r,n,i=e[0],a=[i],s=1,c=e.length;s<c;s++)o=e[s],n=i,Ml((r=o)[0]-n[0],r[1]-n[1])>t&&(a.push(o),i=o);return i!==o&&a.push(o),a}function Ll(e,t,o,r,n){for(var i,a,s,c,u,l,h,d=r,p=t+1;p<o;p++){a=e[p],s=e[t],f=e[o],h=l=u=c=void 0,u=s[0],s=s[1],l=f[0]-u,h=f[1]-s,0==l&&0==h||(1<(c=((a[0]-u)*l+(a[1]-s)*h)/Ml(l,h))?(u=f[0],s=f[1]):0<c&&(u+=l*c,s+=h*c));var f=Ml(a[0]-u,a[1]-s);d<f&&(i=p,d=f)}r<d&&(1<i-t&&Ll(e,t,i,r,n),n.push(e[i]),1<o-i)&&Ll(e,i,o,r,n)}var Dl=function(e,t,o){var r,n;return void 0===t&&(t=1),void 0===o&&(o=!1),e.length<=2||(t=t*t,e=o?e:Nl(e,t),r=(o=e).length-1,n=[o[0]],Ll(o,0,r,t,n),n.push(o[r]),e=n),e};var ql=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Ul=(jl.prototype.toTarget=function(e,t){return this.transformArray(e,this.M,t)},jl.prototype.toSource=function(e,t){return this.transformArray(e,this.inverseM,t)},jl.prototype.transformArray=function(e,t,o){var r,n;if(e&&Array.isArray(e)&&Array.isArray(e[0])){var i=[];try{for(var a=ql(e),s=a.next();!s.done;s=a.next()){var c=s.value;i.push(this.transform(c,t,o))}}catch(e){r={error:e}}finally{try{s&&!s.done&&(n=a.return)&&n.call(a)}finally{if(r)throw r.error}}return i}return null},jl.prototype.transform=function(e,t,o){var r=e[0]*t[0][3]+e[1]*t[1][3]+t[2][3],e=e[0]*t[0][4]+e[1]*t[1][4]+t[2][4];return"number"==typeof o&&0<=o?[xu(r,o),xu(e,o)]:[xu(r,6),xu(e,6)]},jl._calculateAffineTransform=function(e,t){if(e.length!==t.length||e.length<1)throw new Error("Error: source and target arrays must have the same length.");var o=Math.min(e[0].length,t[0].length),r=o+1;if(e.length<o)throw new Error("Erorr: At least "+o+" reference points required.");for(var n=[],i=[],a=0;a<r;a++){i[a]=[];for(var s=0;s<r;s++){s<o&&(n[s]=0);for(var c=i[a][s]=0;c<e.length;c++)s<o&&(n[s]+=a<o?e[c][a]*t[c][s]:t[c][s]),i[a][s]+=o<=a&&o<=s?1:o<=a?e[c][s]:o<=s?e[c][a]:e[c][a]*e[c][s]}i[a]=i[a].concat(n)}if(this._gaussJordanElimination(i))return i;throw new Error("Error: Singular matrix. Points are likely coplanar.")},jl._gaussJordanElimination=function(e){for(var t,o=e.length,r=2*o-1,n=0;n<o;n++){for(var i=n,a=n+1;a<o;a++)Math.abs(e[a][n])>Math.abs(e[i][n])&&(i=a);if(t=e[i],e[i]=e[n],e[n]=t,Math.abs(e[n][n])<=1e-12)return!1;for(var s=n+1;s<o;s++)for(var c=e[s][n]/e[n][n],u=n;u<r;u++)e[s][u]-=e[n][u]*c}for(n=o-1;-1<n;n--){c=e[n][n];for(a=0;a<n;a++)for(var l=r-1;n-1<l;l--)e[a][l]-=e[n][l]*e[a][n]/c;e[n][n]/=c;for(var h=o;h<r;h++)e[n][h]/=c}return!0},jl);function jl(e,t){this.M=jl._calculateAffineTransform(e,t),this.inverseM=jl._calculateAffineTransform(t,e)}var Hl,Bl,sn=Object.freeze({__proto__:null,get AccelerationUnits(){return hu},AffineTransform:Ul,get AreaUnits(){return su},get DistanceUnits(){return cu},get SpeedUnits(){return lu},get TimeUnits(){return uu},WEBMERCATOR_MAXLAT:vu,_precision:xu,boundingBoxToPolygon:function(e){var t=Wu(f.getWest(e)),o=Wu(f.getEast(e)),r=Yu(f.getNorth(e)),n=Yu(f.getSouth(e)),e=f.getCenter(e),n=[[t,r],[t,n],[e[0],n],[o,n],[o,r],[e[0],r],[t,r]];return new pl([n])},convertAcceleration:Ju,convertArea:Xu,convertDistance:Mu,convertSpeed:$u,convertTimespan:el,getAcceleration:tl,getAccelerationFromFeatures:function(e,t,o,r,n,i,a){if("string"==typeof o&&"Feature"===e.type&&"Point"===e.geometry.type&&"Feature"===t.type&&"Point"===t.geometry.type){o=rl(e.properties[o],t.properties[o],uu.seconds);if(!isNaN(o)){var s=0;if(r&&"string"==typeof r){var c=e.properties[r],r=t.properties[r];if("number"==typeof c&&(s=c,"number"==typeof r))return ol(c,r,o,n,uu.seconds,i,a)}return tl(s,Lu(e.geometry.coordinates,t.geometry.coordinates,cu.meters),o,n,cu.meters,uu.seconds,i,a)}}return NaN},getAccelerationFromSpeeds:ol,getArea:function e(t,o,r){if(t){var n=0;switch((t=t instanceof vl?t.toJson():t).type){case"Feature":var i=t;if(i.geometry)return e(i.geometry,o,r);break;case"Polygon":(i=t).coordinates&&(n=Au(i.coordinates));break;case"MultiPolygon":var a=t;if(a.coordinates)for(var s=0,c=a.coordinates.length;s<c;s++)n+=Au(a.coordinates[s])}return Xu(n,su.squareMeters,o,r)}return 0},getCardinalSpline:function(e,t,o,r){if(!e||e.length<=2)return c;"number"!=typeof t&&(t=.5),("number"!=typeof o||o<=0)&&(o=15);var n,i,a,s=e.length,c=e.slice(0),u=(r?(hl.areEqual(c[0],c[s-1])&&(c.pop(),s--),c.unshift(e[s-1]),c.push(e[0]),c.push(e[1]),s++):(c.unshift(e[0]),c.push(e[s-1])),[]);u.push([1,0,0,0]);for(var l=1;l<o-1;l++)u.push([2*(a=(n=l/o)*(i=n*n))-3*i+1,-2*a+3*i,a-2*i+n,a-i]);u.push([0,1,0,0]);for(var h,d,p,f,g,m,y=[],l=1;l<s;l++)for(h=t*(c[l+1][0]-c[l-1][0]),d=t*(c[l+1][1]-c[l-1][1]),p=t*(c[l+2][0]-c[l][0]),f=t*(c[l+2][1]-c[l][1]),n=0;n<o;n++)m=(g=u[n])[0]*c[l][0]+g[1]*c[l+1][0]+g[2]*h+g[3]*p,g=bu(g[0]*c[l][1]+g[1]*c[l+1][1]+g[2]*d+g[3]*f,-85,85),y.push([m,g]);return y},getClosestPointOnGeometry:cl,getConvexHull:function(e){var t,o,r=il(e).map(function(e){return[Wu(e[0]),Yu(e[1])]}),n=(r.sort(function(e,t){return e[0]===t[0]?e[1]-t[1]:e[0]-t[0]}),[]);try{for(var i=pu(r),a=i.next();!a.done;a=i.next()){for(var s=a.value;2<=n.length&&Ou(n[n.length-2],n[n.length-1],s)<=0;)n.pop();n.push(s)}}catch(e){t={error:e}}finally{try{a&&!a.done&&(o=i.return)&&o.call(i)}finally{if(t)throw t.error}}for(var c=[],u=r.length-1;0<=u;u--){for(;2<=c.length&&Ou(c[c.length-2],c[c.length-1],r[u])<=0;)c.pop();c.push(r[u])}return new pl([n.concat(c)])},getDestination:Nu,getDistanceTo:Lu,getEarthRadius:Du,getGeodesicPath:function(e,t){(!t||t<=0)&&(t=15),Array.isArray(e)?o=e:e.type&&"LineString"===e.type&&(o=e.coordinates);for(var o,r=o.length-1,n=[],i=0;i<r;i++)n=n.concat(qu(o[i],o[i+1],t));return Uu(n)},getGeodesicPaths:function(e,t){(!t||t<=0)&&(t=15),Array.isArray(e)?o=e:e.type&&"LineString"===e.type&&(o=e.coordinates);for(var o,r=o.length-1,n=[],i=[],a=0;a<r;a++)for(var s,c,u,l,h,d=qu(o[a],o[a+1],t),p=0;p<d.length;p++)n.push(d[p]),p+1>=d.length||(s=(c=du(d[p],2))[0],c=c[1],l=(h=du(d[p+1],2))[0],h=h[1],180<Math.abs(l-s)&&(u=0<s?180:-180,l=Math.abs((0<s?l+360:l-360)-s),h=c+(h-c)*(Math.abs(u-s)/l),n.push([u,h]),i.push(n),n=[[-u,h]]));return i.push(n),i},getHeading:Hu,getLengthOfPath:Bu,getPathDenormalizedAtAntimerian:Uu,getPathSplitByAntimeridian:ju,getPixelHeading:function(e,t){e=al(e),t=al(t);var t=(e=du(Vu([e,t],21),2))[0],o=(e=e[1])[0]-t[0],t=t[1]-e[1];return(2.5*Math.PI-Math.atan2(t,o))*mu%360},getPointWithHeadingAlongPath:sl,getPointsWithHeadingsAlongPath:function(e,t){if(t<=0)return[];for(var o=[],r=Bu(e,cu.meters)/(t-1),n=0;n<t;n++){var i=sl(e,r*n,cu.meters);null!=i&&o.push(i)}return o},getPosition:al,getPositionAlongPath:Fu,getPositions:il,getPositionsAlongPath:function(e,t){if(t<2)return[];for(var o=[],r=Bu(e,cu.meters)/(t-1),n=0;n<t;n++){var i=Fu(e,r*n,cu.meters);null!=i&&o.push(i)}return o},getRegularPolygonPath:Ku,getRegularPolygonPaths:function(e,t,o,r,n){return ju(zu(e,t,o,r,n))},getSpeed:function(e,t,o,r,n,i){return e=al(e),t=al(t),e&&t?(o=el(o,r,uu.seconds),$u(Lu(e,t,cu.meters)/o,lu.metersPerSecond,n,i)):0},getSpeedFromFeatures:function(e,t,o,r,n){if("string"==typeof o&&"Feature"===e.type&&"Point"===e.geometry.type&&"Feature"===t.type&&"Point"===t.geometry.type){o=rl(e.properties[o],t.properties[o],uu.seconds);if(!isNaN(o))return $u(Lu(e.geometry.coordinates,t.geometry.coordinates,cu.meters)/o,lu.metersPerSecond,r,n)}return NaN},getTimespan:rl,getTravelDistance:function(e,t,o,r,n,i,a,s){return t=el(t,n,uu.seconds),n=(o=$u(o,i,lu.metersPerSecond))*t,"number"==typeof r&&(n+=.5*Ju(r,a,hu.metersPerSecondSquared)*t*t),Mu(n,cu.meters,e,s)},interpolate:Gu,mercatorPixelsToPositions:Qu,mercatorPositionsToPixels:Vu,normalizeLatitude:Yu,normalizeLongitude:Wu,parseTimestamp:nl,rotatePositions:Zu,simplify:function(e,t){return Dl(e,t,!0)}}),Fl=((window&&window.__extends||(Hl=function(e,t){return(Hl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Hl(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(zl,Bl=ye),zl);function zl(){var e=null!==Bl&&Bl.apply(this,arguments)||this;return e.zoomDelta=1,e.style=l.ControlStyle.light,e}(window&&window.__extends||(Kl=function(e,t){return(Kl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Kl(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Yl,Gl=eo),Yl.prototype.onAdd=function(e){this.container=this.buildContainer(e,this.options.style,"Zoom Control"),this.container.style.flexDirection="column",this.zoomInButton=this.constructZoomInButton(e),this.zoomOutButton=this.constructZoomOutButton(e);var t=jt("Zoom In"),o=jt("Zoom Out");return this.container.appendChild(this.zoomInButton),this.container.appendChild(t),this.container.appendChild(this.zoomOutButton),this.container.appendChild(o),Ht(t,this.zoomInButton),Ht(o,this.zoomOutButton),e.events.add("zoom",this.zoomChanged),e.events.add("minzoomchanged",this.minZoomChanged),e.events.add("maxzoomchanged",this.maxZoomChanged),this.map=e,this.container},Yl.prototype.onRemove=function(){Gl.prototype.onRemove.call(this),this.map&&(this.map.events.remove("zoom",this.zoomChanged),this.map.events.remove("minzoomchanged",this.minZoomChanged),this.map.events.remove("maxzoomchanged",this.maxZoomChanged),this.map=null),this.container&&(this.container.remove(),this.container=null,this.zoomInButton=null,this.zoomOutButton=null)},Yl.prototype.updateZoomButtonsState=function(){var e=this.map.getCamera().zoom>=this.map._getMap().getMaxZoom(),t=f.getSouth(this.map.getCamera().bounds)<=-vu&&f.getNorth(this.map.getCamera().bounds)>=vu,t=this.map.getCamera().zoom<=this.map._getMap().getMinZoom()||t;this.zoomInButton&&this.zoomInButton.disabled!=e&&(this.zoomInButton.disabled=e,this.zoomInButton.setAttribute("aria-label",e?"Zoom In disabled":"Zoom In")),this.zoomOutButton&&this.zoomOutButton.disabled!=t&&(this.zoomOutButton.disabled=t,this.zoomOutButton.setAttribute("aria-label",e?"Zoom Out disabled":"Zoom Out"))},Yl.prototype.constructZoomInButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("zoom-in"),o.setAttribute("aria-label","Zoom In"),o.setAttribute("alt","Zoom In"),o.setAttribute("type","button"),o.addEventListener("click",function(){e.setCamera({zoom:e.getCamera().zoom+t.options.zoomDelta,duration:Yl.ZOOM_DURATION_MS,type:"ease"},!0)}),o},Yl.prototype.constructZoomOutButton=function(e){var t=this,o=document.createElement("button");return o.classList.add("azure-maps-control-button"),o.classList.add("zoom-out"),o.setAttribute("aria-label","Zoom Out"),o.setAttribute("alt","Zoom Out"),o.setAttribute("type","button"),o.addEventListener("click",function(){e.setCamera({zoom:e.getCamera().zoom-t.options.zoomDelta,duration:Yl.ZOOM_DURATION_MS,type:"ease"},!0)}),o},Yl.ZOOM_DURATION_MS=200;var Kl,Gl,Mi=Yl;function Yl(e){var t=Gl.call(this)||this;return t.container=null,t.zoomInButton=null,t.zoomOutButton=null,t.zoomChanged=function(e){return t.updateZoomButtonsState()},t.minZoomChanged=function(e){return t.updateZoomButtonsState()},t.maxZoomChanged=function(e){return t.updateZoomButtonsState()},t.options=(new Fl).merge(e),t}(window&&window.__extends||(Wl=function(e,t){return(Wl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Wl(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Vl,Zl=ye);var Wl,Zl,Ql=Vl;function Vl(){var e=null!==Zl&&Zl.apply(this,arguments)||this;return e.style=l.ControlStyle.light,e.hideIfUnsupported=!1,e.container=void 0,e}(window&&window.__extends||(Jl=function(e,t){return(Jl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Jl(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))($l,Xl=eo),$l.prototype.onAdd=function(e){var t,o,r=this,n=(this.map=e,null!=(n=null==(n=this.map)?void 0:n._getMap())&&n.addControl(this.control),this.buildContainer(e,this.options.style,"Fullscreen Control")),i=this.control._fullscreenButton;return i&&(t=i.querySelector("span"))&&(o=jt("Enter Fullscreen"),n.appendChild(i),i.classList.add("azure-maps-control-button","fullscreen"),t.classList.add("fullscreen-icon","fullscreen-end"),i.removeAttribute("title"),n.appendChild(o),Ht(o,i),this.control.on("fullscreenstart",function(){i.removeAttribute("title"),t.classList.remove("fullscreen-end"),t.classList.add("fullscreen-start"),o.innerText="Exit Fullscreen",r.isFullscreenState=!0}),this.control.on("fullscreenend",function(){i.removeAttribute("title"),t.classList.remove("fullscreen-start"),t.classList.add("fullscreen-end"),o.innerText="Enter Fullscreen",r.isFullscreenState=!1})),this.options.hideIfUnsupported&&!$l.isSupported()&&(n.style.display="none"),n},$l.prototype.onRemove=function(){var e;Xl.prototype.onRemove.call(this),null!=(e=null==(e=this.map)?void 0:e._getMap())&&e.removeControl(this.control),this.map=null},$l.prototype.isFullscreen=function(){return this.isFullscreenState},$l.isSupported=function(){var e=document;return e.fullscreenEnabled||e.msFullscreenEnabled||e.mozFullScreenEnabled||e.webkitFullscreenEnabled};var Jl,Xl,r=$l;function $l(e){var t=Xl.call(this)||this;return t.map=null,t.isFullscreenState=!1,t.options=(new Ql).merge(e),t.control=new D.FullscreenControl({container:t.options.container}),t}var Ho=Object.freeze({__proto__:null,CompassControl:co,ControlBase:eo,FullscreenControl:r,PitchControl:t,ScaleControl:be,StyleControl:xi,TrafficControl:mc,TrafficLegendControl:o,ZoomControl:Mi}),eh=Ya;var th=q(function(e,t){return eh(e,5,t="function"==typeof t?t:void 0)}),oh=(rh.Css={hidden:"hidden-accessible-element"},rh);function rh(e){var t=this;this.attach=function(e){t.map!==e&&(t.map&&t.detachFromCurrentMap(),t.map=e,t.map.indicators._getCollectionDiv().appendChild(t.element),t.map.indicators.add(t))},this.remove=function(){t.detachFromCurrentMap(),t.element.remove()},this.getElement=function(){return t.element},this.detachFromCurrentMap=function(){t.map&&(t.map.indicators.remove(t),delete t.map)},this.element=document.createElement("div"),this.element.setAttribute("tabindex","0"),this.element.setAttribute("role","option"),null!=e&&e.setSize&&this.element.setAttribute("aria-setsize",e.setSize.toString()),null!=e&&e.positionInSet&&this.element.setAttribute("aria-posinset",e.positionInSet.toString()),this.element.setAttribute("aria-label","data point"),this.element.classList.add(rh.Css.hidden)}(window&&window.__extends||(nh=function(e,t){return(nh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}nh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(sh,ih=ye);var nh,ih,ah=sh;function sh(){var e=null!==ih&&ih.apply(this,arguments)||this;return e.buffer=128,e.maxZoom=18,e.cluster=!1,e.clusterRadius=50,e.clusterMaxZoom=void 0,e.clusterProperties=void 0,e.lineMetrics=!1,e.tolerance=.375,e.clusterMinPoints=2,e.generateId=!1,e.promoteId=void 0,e.filter=void 0,e}(window&&window.__extends||(ch=function(e,t){return(ch=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ch(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(hh,uh=Vt),hh.prototype.getId=function(){return this.id},hh.prototype._setMap=function(e,t){var o;void 0===t&&(t=!0),null==e||void 0===e?(o=this.map,delete this.map,t&&(this._invokeEvent("sourceremoved",this),o)&&o.events.invoke("sourceremoved",this)):(this.map=e,t&&(this._invokeEvent("sourceadded",this),this.map.events.invoke("sourceadded",this)))};var ch,uh,lh=hh;function hh(e){var t=uh.call(this)||this;return t.id=e||W(),t}var dh,ph,s=window&&window.__extends||(dh=function(e,t){return(dh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}dh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),fh=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},gh=(s(mh,ph=lh),mh.prototype.add=function(e,t){this._addNoUpdate(e,t),this._updateSource()},mh.prototype.clear=function(){this._clearNoUpdate(),this._updateSource()},mh.prototype.dispose=function(){this.options=null,this.shapes=null,this.shapesMap=null,this.map=null},mh.prototype.getClusterExpansionZoom=function(r){var n=this;return new Promise(function(t,o){var e;n.map?(e=n.map._getMap().getSource(n.getId()))&&"geojson"===e.type&&e.getClusterExpansionZoom(r).then(function(e){"number"==typeof e&&t(e)}).catch(function(e){e&&o(e)}):o("The DataSource hasn't been added to a map.")})},mh.prototype.getClusterChildren=function(r){var n=this;return new Promise(function(t,o){var e;n.map?(e=n.map._getMap().getSource(n.getId()))&&"geojson"===e.type&&e.getClusterChildren(r).then(function(e){e&&t(n.map.sources._mapFeaturesToShapes(e,!1,n))}).catch(function(e){e&&o(e)}):o("The DataSource hasn't been added to a map.")})},mh.prototype.getClusterLeaves=function(r,n,i){var a=this;return new Promise(function(t,o){var e;a.map?(e=a.map._getMap().getSource(a.getId()))&&"geojson"===e.type&&e.getClusterLeaves(r,n,i).then(function(e){e&&t(a.map.sources._mapFeaturesToShapes(e,!1,a))}).catch(function(e){e&&o(e)}):o("The DataSource hasn't been added to a map.")})},mh.prototype.getOptions=function(){return Za(this.options)},mh.prototype.getShapes=function(){return Array.from(this.shapes)},mh.prototype.importDataFromUrl=function(e){var t=this;return fetch(e,{method:"GET",mode:"cors"}).then(function(e){if(e.ok)return e.json();throw new Error("HTTP ".concat(e.status,": ").concat(e.statusText))}).then(function(e){t.add(e)})},mh.prototype.getShapeById=function(e){return this.shapes[this.shapesMap.get(e)]||null},mh.prototype.remove=function(e){var t,o,e=Array.isArray(e)?e:[e];try{for(var r=fh(e),n=r.next();!n.done;n=r.next()){var i=n.value;"number"==typeof i?this._removeByIndex(i):this._removeById(i)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}this._updateSource()},mh.prototype.removeById=function(e){var t,o,e=Array.isArray(e)?e:[e];try{for(var r=fh(e),n=r.next();!n.done;n=r.next()){var i=n.value;this._removeById(i)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}this._updateSource()},mh.prototype.setOptions=function(e){e=(new ah).merge(this.options,Za(e));Xc(this.options,e)||(this._invokeEvent("datasourceupdated",this),this.options=e,this.map&&this.map._rebuildStyle())},mh.prototype.setShapes=function(e){this._clearNoUpdate(),this.add(e)},mh.prototype.toJson=function(){return new Sl(this.shapes.map(function(e){return e.toJson()}))},mh.prototype._toJson=function(){return new Sl(this.shapes.map(function(e){return e._toJson()}))},mh.prototype._buildSource=function(){var e={type:"geojson",data:this._toJson(),maxzoom:this.options.maxZoom,cluster:this.options.cluster,clusterRadius:this.options.clusterRadius,tolerance:this.options.tolerance,lineMetrics:this.options.lineMetrics,clusterProperties:this.options.clusterProperties,buffer:this.options.buffer,clusterMinPoints:this.options.clusterMinPoints,generateId:this.options.generateId,promoteId:this.options.promoteId,filter:this.options.filter};return"number"==typeof this.options.clusterMaxZoom&&(e.clusterMaxZoom=this.options.clusterMaxZoom),e},mh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this._buildSource(),e=e._buildSource(),t.type===e.type)&&t.maxzoom===e.maxzoom&&t.cluster===e.cluster&&t.clusterRadius===e.clusterRadius&&t.tolerance===e.tolerance&&t.lineMetrics===e.lineMetrics&&JSON.stringify(t.clusterProperties)===JSON.stringify(e.clusterProperties)&&t.buffer===e.buffer&&t.clusterMinPoints===e.clusterMinPoints&&t.generateId===e.generateId&&t.promoteId===e.promoteId&&t.filter===e.filter},mh.prototype._addNoUpdate=function(e,t){var o;e instanceof vl?(this._addToSources(e,t),o=[e]):Array.isArray(e)?(o=e.map(function(e){return e instanceof vl?e:new vl(e)}),this._addToSources(o,t)):"FeatureCollection"===e.type?(o=e.features.map(function(e){return new vl(e)}),this._addToSources(o,t)):"GeometryCollection"===e.type?(o=e.geometries.map(function(e){return new vl(e)}),this._addToSources(o,t)):(e=new vl(e),this._addToSources(e,t),o=[e]),this._invokeEvent("dataadded",o)},mh.prototype._clearNoUpdate=function(){var e=this.shapes;this.shapes=[],this.shapesMap=new Qt,e&&0<e.length&&this._invokeEvent("dataremoved",e)},mh.prototype._updateSource=function(){var e=this;void 0===this.requestId&&(this.requestId=requestAnimationFrame(function(){e._updateMboxSource(),e.requestId=void 0}))},mh.prototype._addToSources=function(e,t){var o,r,n,i;if(e=Array.isArray(e)?e:[e],"number"!=typeof t)try{for(var a=fh(e),s=a.next();!s.done;s=a.next()){var c=s.value;this.shapes.push(c),this.shapesMap.set(c.getId(),this.shapes.length-1)}}catch(e){o={error:e}}finally{try{s&&!s.done&&(r=a.return)&&r.call(a)}finally{if(o)throw o.error}}else for(var u=e.length-1;0<=u;u--)this.shapes.splice(t,0,e[u]),this._updateShapesMap(t);try{for(var l=fh(e),h=l.next();!h.done;h=l.next())(c=h.value)._setDataSource(this)}catch(e){n={error:e}}finally{try{h&&!h.done&&(i=l.return)&&i.call(l)}finally{if(n)throw n.error}}},mh.prototype._removeById=function(e){var e=e instanceof vl?e.getId():"string"==typeof e||"number"==typeof e?e:e.id,t=this.shapes[this.shapesMap.get(e)];t&&(t._setDataSource(null),this.shapes.splice(this.shapesMap.get(e),1),this._updateShapesMap(this.shapesMap.get(e)),this.shapesMap.delete(e),this._invokeEvent("dataremoved",[t]))},mh.prototype._removeByIndex=function(e){var t;if(e>=this.shapes.length)throw new Error("The specified remove index '".concat(e,"' ")+"is greater than the maximum possible index '".concat(this.shapes.length-1,"'"));t=this.shapes[e],this.shapesMap.delete(t.getId()),t._setDataSource(null),this.shapes.splice(e,1),this._updateShapesMap(e),this._invokeEvent("dataremoved",[t])},mh.prototype._updateShapesMap=function(e){for(var t=e;t<this.shapes.length;t++)this.shapesMap.set(this.shapes[t].getId(),t)},mh.prototype._updateMboxSource=function(){var e;this.map&&this.map._getMap()&&(e=this.map._getMap().getSource(this.getId()))&&"geojson"===e.type&&e.setData(this._toJson())},mh);function mh(e,t){e=ph.call(this,e)||this;return e.requestId=void 0,e.options=(new ah).merge(Za(t)),e.shapes=[],e.shapesMap=new Qt,e}(window&&window.__extends||(yh=function(e,t){return(yh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}yh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(wh,vh=ye);var yh,vh,_h=wh;function wh(){var e=null!==vh&&vh.apply(this,arguments)||this;return e.bounds=void 0,e.minZoom=0,e.maxZoom=22,e.isTMS=!1,e.tiles=void 0,e.url=void 0,e}(window&&window.__extends||(bh=function(e,t){return(bh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}bh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Eh,Ch=lh),Eh.prototype.getOptions=function(){return Za(this.options)},Eh.prototype.getShape=function(e,t){return this.map._getMap().querySourceFeatures(this.getId(),{sourceLayer:e,filter:t})},Eh.prototype._buildSource=function(){var e={type:"vector"};return this.options.bounds&&(e.bounds=this.options.bounds),this.options.tiles?(e.tiles=this.options.tiles,e.minzoom=this.options.minZoom,e.maxzoom=this.options.maxZoom):this.options.url&&(e.url=this.options.url),this.options.isTMS&&(e.scheme="tms"),e},Eh.prototype._isDeepEqual=function(e){var t,o;return this.constructor===e.constructor&&(t=this._buildSource(),o=e._buildSource(),t.type===o.type)&&t.url===o.url&&(void 0===t.tiles&&void 0===o.tiles||t.tiles&&o.tiles&&t.tiles.length===o.tiles.length&&t.tiles.every(function(e,t){return e===o.tiles[t]}))&&t.minzoom===o.minzoom&&t.maxzoom===o.maxzoom&&t.bounds===o.bounds&&t.attribution===o.attribution&&t.promoteId===o.promoteId&&t.scheme===o.scheme};var bh,Ch,Sh=Eh;function Eh(e,t){e=Ch.call(this,e)||this;return e.options=(new _h).merge(Za(t)),e}(window&&window.__extends||(Th=function(e,t){return(Th=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Th(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Ah,Ih=lh),Ah.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)&&t.canvas===e.canvas&&JSON.stringify(t.coordinates)===JSON.stringify(e.coordinates)&&t.animate===e.animate},Ah.prototype._buildSource=function(){return this.source};var Th,Ih,kh=Ah;function Ah(e,t,o){e=Ih.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(Ph=function(e,t){return(Ph=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ph(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(xh,Oh=lh),xh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)},xh.prototype._buildSource=function(){return this.source};var Ph,Oh,Rh=xh;function xh(e,t,o){e=Oh.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(Mh=function(e,t){return(Mh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Mh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Dh,Nh=lh),Dh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)&&JSON.stringify(t.coordinates)===JSON.stringify(e.coordinates)&&t.url===e.url},Dh.prototype._buildSource=function(){return this.source};var Mh,Nh,Lh=Dh;function Dh(e,t,o){e=Nh.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(qh=function(e,t){return(qh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}qh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Hh,Uh=lh),Hh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)&&JSON.stringify(t.coordinates)===JSON.stringify(e.coordinates)&&t.urls===e.urls},Hh.prototype._buildSource=function(){return this.source};var qh,Uh,jh=Hh;function Hh(e,t,o){e=Uh.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(Bh=function(e,t){return(Bh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Bh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(zh,Fh=_h);var Bh,Fh,n=zh;function zh(){var e=null!==Fh&&Fh.apply(this,arguments)||this;return e.tileSize=512,e}(window&&window.__extends||(Kh=function(e,t){return(Kh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Kh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Wh,Gh=n);var Kh,Gh,Yh=Wh;function Wh(){var e=null!==Gh&&Gh.apply(this,arguments)||this;return e.encoding=void 0,e}var Zh,Qh,sr=window&&window.__extends||(Zh=function(e,t){return(Zh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Zh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),Vh=window&&window.__assign||function(){return(Vh=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},i=(sr(Jh,Qh=lh),Jh.prototype.getOptions=function(){return Za(this.options)},Jh.prototype._buildSource=function(){return Vh({type:"raster-dem",bounds:this.options.bounds,minzoom:this.options.minZoom,maxzoom:this.options.maxZoom,tileSize:this.options.tileSize,encoding:this.options.encoding},this.options.tiles?{tiles:this.options.tiles}:{url:this.options.url})},Jh.prototype._isDeepEqual=function(e){return this.constructor===e.constructor&&(e=e.getOptions(),this.options.url===e.url)&&this.options.tiles===e.tiles&&this.options.bounds===e.bounds&&this.options.minZoom===e.minZoom&&this.options.maxZoom===e.maxZoom&&this.options.tileSize===e.tileSize&&this.options.encoding===e.encoding},Jh);function Jh(e,t){e=Qh.call(this,e)||this;return e.options=(new Yh).merge(Za(t)),e}var Xh,$h,hn=Object.freeze({__proto__:null,CanvasSource:kh,DataSource:gh,ElevationTileSource:i,ImageSource:Lh,Source:lh,UnknownSource:Rh,VectorTileSource:Sh,VideoSource:jh}),ed=((window&&window.__extends||(Xh=function(e,t){return(Xh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Xh(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(td,$h=Vt),td.prototype.getId=function(){return this.id},td.prototype.getMap=function(){return this.map||null},td.prototype.onAdd=function(e){this.map=e,this._invokeEvent("layeradded",this),this.map.events.invoke("layeradded",this)},td.prototype.onRemove=function(){var e=this.map;delete this.map,this._invokeEvent("layerremoved",this),e&&e.events.invoke("layerremoved",this)},td._isMBoxEvent=function(e){return!this.LayerEvents.hasOwnProperty(e)},td.prototype._updateBaseProperties=function(e,t){this._updateFilter(e.filter,t.filter),this._updateZoomRange(e.minZoom,t.minZoom,e.maxZoom,t.maxZoom),this._updateLayoutProperty("visibility",e.visible,t.visible,e.visible?"visible":"none")},td.prototype._updateFilter=function(e,t){Xc(e,t)||this.map._getMap().setFilter(this.id,e)},td.prototype._updatePaintProperty=function(e,t,o,r){Xc(t,o)||this.map._getMap().setPaintProperty(this.id,e,r||t)},td.prototype._updateLayoutProperty=function(e,t,o,r){Xc(t,o)||this.map._getMap().setLayoutProperty(this.id,e,r||t)},td.prototype._updateZoomRange=function(e,t,o,r){e===t&&r===o||this.map._getMap().setLayerZoomRange(this.id,e,o)},td.LayerEvents={layeradded:void 0,layerremoved:void 0,focusin:void 0,focusout:void 0},td);function td(e){var t=$h.call(this)||this;return t.id=e||W(),t}(window&&window.__extends||(od=function(e,t){return(od=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}od(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(nd,rd=ye),nd._cloneCustomizer=function(e){if(e instanceof lh)return e};var od,rd,jo=nd;function nd(){var e=null!==rd&&rd.apply(this,arguments)||this;return e.filter=void 0,e.minZoom=0,e.maxZoom=24,e.visible=!0,e}(window&&window.__extends||(id=function(e,t){return(id=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}id(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(cd,ad=jo);var id,ad,sd=cd;function cd(){var e=null!==ad&&ad.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.color="#1A73AA",e.blur=0,e.opacity=1,e.strokeColor="#FFFFFF",e.strokeOpacity=1,e.strokeWidth=2,e.pitchAlignment="viewport",e.radius=8,e.createIndicators=!1,e.accessibilityIdKey=void 0,e}var ud,ld,e=window&&window.__extends||(ud=function(e,t){return(ud=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ud(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),hd=window&&window.__awaiter||function(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})},dd=window&&window.__generator||function(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},u={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function e(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c=u&&t[u=0]?0:c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},pd=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},fd=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},gd=(e(md,ld=ed),md.prototype.getOptions=function(){return th(this.options,sd._cloneCustomizer)},md.prototype.getSource=function(){return this.options.source},md.prototype.setOptions=function(e){e=(new sd).merge(this.options,th(e,sd._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("circle-blur",e.blur,this.options.blur),this._updatePaintProperty("circle-color",e.color,this.options.color),this._updatePaintProperty("circle-opacity",e.opacity,this.options.opacity),this._updatePaintProperty("circle-radius",e.radius,this.options.radius),this._updatePaintProperty("circle-stroke-color",e.strokeColor,this.options.strokeColor),this._updatePaintProperty("circle-stroke-opacity",e.strokeOpacity,this.options.strokeOpacity),this._updatePaintProperty("circle-stroke-width",e.strokeWidth,this.options.strokeWidth),this._updatePaintProperty("circle-pitch-alignment",e.pitchAlignment,this.options.pitchAlignment)}this.options=e},md.prototype.onAdd=function(t){var e,o,r=this;ld.prototype.onAdd.call(this,t),this.options.createIndicators&&(t.events.addOnce("idle",this._setAccessibleIndicator),t.events.add("moveend",this._setAccessibleIndicator),(e=this._getDataSource())?t.events.add("dataadded",e,function(){t.events.addOnce("idle",r._setAccessibleIndicator)}):(o="string"==typeof this.options.source?this.options.source:this.options.source.getId(),t.events.add("sourcedata",function(e){(null==(e=e.source)?void 0:e.getId())===o&&t._getMap().isSourceLoaded(o)&&(e=r._getSourceDataEventCacheKey())!==r.sourceDataEventCacheKey&&(r._setAccessibleIndicator(),r.sourceDataEventCacheKey=e)})))},md.prototype.onRemove=function(){var e;this.options.createIndicators&&(this.map.events.remove("idle",this._setAccessibleIndicator),this.map.events.remove("moveend",this._setAccessibleIndicator),(e=this._getDataSource())?this.map.events.remove("dataadded",e,this._setAccessibleIndicator):this.map.events.remove("sourcedata",this._setAccessibleIndicator)),ld.prototype.onRemove.call(this)},md.prototype._getSourceDataEventCacheKey=function(){var e;if(this.map)return e=this.map.getServiceOptions().mapConfiguration,fd(fd([],pd(this.map.getCamera().bounds),!1),[this.map.getCamera().zoom,this.map.getCamera().pitch,this.map.getStyle().style,e instanceof Object?e.id:e],!1).join(",")},md.prototype._getDataSource=function(){var e="string"==typeof this.options.source?this.map.sources.getById(this.options.source):this.options.source;if(e instanceof gh)return e},md.prototype._buildLayers=function(){var e={id:this.id,type:"circle",source:this.options.source instanceof lh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:{"circle-color":this.options.color,"circle-blur":this.options.blur,"circle-opacity":this.options.opacity,"circle-stroke-color":this.options.strokeColor,"circle-stroke-opacity":this.options.strokeOpacity,"circle-stroke-width":this.options.strokeWidth,"circle-pitch-alignment":this.options.pitchAlignment,"circle-radius":this.options.radius},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),this.options.sourceLayer&&(e["source-layer"]=this.options.sourceLayer),[e]},md.prototype._getLayerIds=function(){return[this.id]},md.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof lh?e.add(this.options.source.getId()):e.add(this.options.source),e},md.prototype.getFirstCoordinate=function(e){return Array.isArray(e[0])?this.getFirstCoordinate(e[0]):e},md);function md(e,t,o){var r=ld.call(this,t)||this;return r.accessibleIndicator=[],r._setAccessibleIndicator=function(){return hd(r,void 0,void 0,function(){var t,c,u,l,h,d,p=this;return dd(this,function(e){return this.accessibleIndicator.forEach(function(e){return e.remove()}),this.accessibleIndicator=[],t=this.map.layers.getRenderedShapes(this.map.getCamera().bounds,this),c=this.options.accessibilityIdKey||(this._getDataSource()?vl._shapeIdPropName:void 0),u=function(t,o){var r=t[o],n=r instanceof vl?r.toJson():r,i=new oh({positionInSet:o+1,setSize:t.length}),a=i.getElement(),s=pd(p.map.positionsToPixels([p.getFirstCoordinate(n.geometry.coordinates)]),1)[0];return a.addEventListener("focusin",function(e){p.accessibleIndicator.filter(function(e){return e!==i}).forEach(function(e){return e.remove()}),0<=o-1&&l(i,u(t,o-1)),o+1<t.length&&d(u(t,o+1)),2<=o&&o==t.length-1&&h(u(t,0)),0==o&&2<=t.length&&d(u(t,t.length-1)),void 0!==c&&p.map._getMap().setPaintProperty(p.id,"circle-stroke-color",["case",["==",["get",c],n.properties[c]],"#000000",p.options.strokeColor]);e={target:a,type:"focusin",map:p.map,shape:r,originalEvent:e,pixel:s};p._invokeEvent("focusin",e)}),a.addEventListener("focusout",function(e){void 0!==c&&p.map._getMap().setPaintProperty(p.id,"circle-stroke-color",["case",["==",["get",c],n.properties[c]],p.options.strokeColor,p.options.strokeColor]);e={target:a,type:"focusout",map:p.map,shape:r,originalEvent:e,pixel:s};p._invokeEvent("focusout",e)}),p.accessibleIndicator.push(i),i},l=function(e,t){t.attach(p.map);t=t.getElement(),e=e.getElement();e.parentElement.insertBefore(t,e)},h=function(e){e.attach(p.map);var e=e.getElement(),t=e.parentElement;t.insertBefore(e,t.firstElementChild)},d=function(e){e.attach(p.map)},0<t.length&&d(u(t,0)),1<t.length&&d(u(t,t.length-1)),[2]})})},r.options=(new sd).merge(th(o,sd._cloneCustomizer)),r.options.source=e||r.options.source,r}(window&&window.__extends||(yd=function(e,t){return(yd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}yd(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(wd,vd=jo),wd._cloneCustomizer=function(e){if(e instanceof lh)return e};var yd,vd,_d=wd;function wd(){var e=null!==vd&&vd.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.color=["interpolate",["linear"],["heatmap-density"],0,"rgba(0,0, 255,0)",.1,"royalblue",.3,"cyan",.5,"lime",.7,"yellow",1,"red"],e.intensity=1,e.opacity=1,e.radius=30,e.weight=1,e}(window&&window.__extends||(bd=function(e,t){return(bd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}bd(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Sd,Cd=ed),Sd.prototype.getOptions=function(){return th(this.options,_d._cloneCustomizer)},Sd.prototype.getSource=function(){return this.options.source},Sd.prototype.setOptions=function(e){e=(new _d).merge(this.options,th(e,_d._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("heatmap-color",e.color,this.options.color),this._updatePaintProperty("heatmap-intensity",e.intensity,this.options.intensity),this._updatePaintProperty("heatmap-opacity",e.opacity,this.options.opacity),this._updatePaintProperty("heatmap-radius",e.radius,this.options.radius),this._updatePaintProperty("heatmap-weight",e.weight,this.options.weight)}this.options=e},Sd.prototype._buildLayers=function(){var e={id:this.id,type:"heatmap",source:this.options.source instanceof lh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:{"heatmap-color":this.options.color,"heatmap-intensity":this.options.intensity,"heatmap-opacity":this.options.opacity,"heatmap-radius":this.options.radius,"heatmap-weight":this.options.weight},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),this.options.sourceLayer&&(e["source-layer"]=this.options.sourceLayer),[e]},Sd.prototype._getLayerIds=function(){return[this.id]},Sd.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof lh?e.add(this.options.source.getId()):e.add(this.options.source),e};var bd,Cd,ln=Sd;function Sd(e,t,o){t=Cd.call(this,t)||this;return t.options=(new _d).merge(th(o,_d._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(Ed=function(e,t){return(Ed=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ed(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Id,Td=jo);var Ed,Td,Kt=Id;function Id(){var e=null!==Td&&Td.apply(this,arguments)||this;return e.contrast=0,e.fadeDuration=300,e.hueRotation=0,e.maxBrightness=1,e.minBrightness=0,e.opacity=1,e.saturation=0,e}(window&&window.__extends||(kd=function(e,t){return(kd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}kd(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Od,Ad=Kt),Od._cloneCustomizer=function(e){if(e instanceof lh)return e};var kd,Ad,Pd=Od;function Od(){var e=null!==Ad&&Ad.apply(this,arguments)||this;return e.url=void 0,e.coordinates=void 0,e}(window&&window.__extends||(Rd=function(e,t){return(Rd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Rd(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Nd,xd=ed),Nd.prototype._getSourceIds=function(){var e=new Set;return e.add(this._getSourceId()),e},Nd.prototype.onAdd=function(e){xd.prototype.onAdd.call(this,e)};var Rd,xd,Md=Nd;function Nd(){return null!==xd&&xd.apply(this,arguments)||this}(window&&window.__extends||(Ld=function(e,t){return(Ld=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ld(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(qd,Dd=Md),qd.prototype.getOptions=function(){return th(this.options,Pd._cloneCustomizer)},qd.prototype.setOptions=function(e){var t,o=(new Pd).merge(this.options,th(e,Pd._cloneCustomizer)),r="string"==typeof e.url&&e.url!==this.getOptions().url,e=void 0!==e.coordinates&&e.coordinates!==this.getOptions().coordinates;this.map&&(this._updateBaseProperties(o,this.options),this._updatePaintProperty("raster-contrast",o.contrast,this.options.contrast),this._updatePaintProperty("raster-fade-duration",o.fadeDuration,this.options.fadeDuration),this._updatePaintProperty("raster-hue-rotate",o.hueRotation,this.options.hueRotation),this._updatePaintProperty("raster-brightness-max",o.maxBrightness,this.options.maxBrightness),this._updatePaintProperty("raster-opacity",o.opacity,this.options.opacity),this._updatePaintProperty("raster-saturation",o.saturation,this.options.saturation),t=this.map._getMap().getSource(this._getSourceId()))&&(r||e)&&t.updateImage(o),this.options=o,r?this.reloadImage():e&&this.updateTransform()},qd.prototype.getPositions=function(t){return this.transform.then(function(e){return e.toTarget(t)})},qd.prototype.getPixels=function(t){return this.transform.then(function(e){return e.toSource(t)})},qd.getCoordinatesFromRefPoints=function(e,t,o,r){return new Ul(o,r).toTarget([[0,0],[e,0],[e,t],[0,t]])},qd.getCoordinatesFromEdges=function(e,t,o,r,n){"number"!=typeof n&&(n=0);t=[Math.min(r,o),t,Math.max(r,o),e],r=f.getCenter(t);return Zu([f.getNorthWest(t),f.getNorthEast(t),f.getSouthEast(t),f.getSouthWest(t)],r,n)},qd.prototype._buildLayers=function(){var e={id:this.id,type:"raster",source:this._getSourceId(),layout:{visibility:this.options.visible?"visible":"none"},paint:{"raster-opacity":this.options.opacity,"raster-hue-rotate":this.options.hueRotation,"raster-brightness-min":this.options.minBrightness,"raster-brightness-max":this.options.maxBrightness,"raster-saturation":this.options.saturation,"raster-contrast":this.options.contrast,"raster-fade-duration":this.options.fadeDuration},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),[e]},qd.prototype._getLayerIds=function(){return[this.id]},qd.prototype._buildSource=function(){return{type:"image",url:this.options.url,coordinates:this.options.coordinates}},qd.prototype._getSourceId=function(){return"".concat(this.getId(),"-ImageSource")},qd.prototype.reloadImage=function(){var o=this;this.options.url&&(this.transform=new Promise(function(t,e){o.img.onload=function(){var e=[[0,0],[o.img.width,0],[o.img.width,o.img.height],[0,o.img.height]];t(new Ul(e,o.options.coordinates)),o.isLoading=!1},o.img.onerror=o.img.onabort=function(){e("Failed to load image")},o.isLoading=!0,o.img.src=o.options.url}))},qd.prototype.updateTransform=function(){var e;this.isLoading||(e=[[0,0],[this.img.width,0],[this.img.width,this.img.height],[0,this.img.height]],this.transform=Promise.resolve(new Ul(e,this.options.coordinates)))},qd.prototype._getSourceWrapper=function(){var e=this._getSourceId(),t=this._buildSource();return new Lh(e,t)};var Ld,Dd,a=qd;function qd(e,t){t=Dd.call(this,t)||this;return t.isLoading=!1,t.options=(new Pd).merge(th(e,Pd._cloneCustomizer)),t.img=new Image,t.reloadImage(),t}(window&&window.__extends||(Ud=function(e,t){return(Ud=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ud(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Bd,jd=jo);var Ud,jd,Hd=Bd;function Bd(){var e=null!==jd&&jd.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.lineCap="round",e.lineJoin="round",e.blur=0,e.strokeColor="#1E90FF",e.strokeDashArray=void 0,e.strokeGradient=void 0,e.offset=0,e.strokeOpacity=1,e.translate=new ru(0,0),e.translateAnchor="map",e.strokeWidth=2,e}var Fd,zd,Fr=window&&window.__extends||(Fd=function(e,t){return(Fd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Fd(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),Kd=window&&window.__assign||function(){return(Kd=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Gd=(Fr(Yd,zd=ed),Yd.prototype.getOptions=function(){return th(this.options,Hd._cloneCustomizer)},Yd.prototype.getSource=function(){return this.options.source},Yd.prototype.setOptions=function(e){e=(new Hd).merge(this.options,th(e,Hd._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("line-blur",e.blur,this.options.blur),this._updateLayoutProperty("line-cap",e.lineCap,this.options.lineCap),this._updateLayoutProperty("line-join",e.lineJoin,this.options.lineJoin),this._updatePaintProperty("line-offset",e.offset,this.options.offset),this._updatePaintProperty("line-color",e.strokeColor,this.options.strokeColor),this._updatePaintProperty("line-dasharray",e.strokeDashArray,this.options.strokeDashArray),this._updatePaintProperty("line-gradient",e.strokeGradient,this.options.strokeGradient),this._updatePaintProperty("line-opacity",e.strokeOpacity,this.options.strokeOpacity),this._updatePaintProperty("line-width",e.strokeWidth,this.options.strokeWidth),this._updatePaintProperty("line-translate",e.translate,this.options.translate),this._updatePaintProperty("line-translate-anchor",e.translateAnchor,this.options.translateAnchor)}this.options=e},Yd.prototype._buildLayers=function(){return[Kd(Kd(Kd(Kd({id:this.id,type:"line"},this.options.sourceLayer&&{"source-layer":this.options.sourceLayer}),{source:this.options.source instanceof lh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none","line-cap":this.options.lineCap,"line-join":this.options.lineJoin},paint:Kd(Kd(Kd({"line-blur":this.options.blur,"line-color":this.options.strokeColor},this.options.strokeDashArray?{"line-dasharray":this.options.strokeDashArray}:{}),this.options.strokeGradient?{"line-gradient":this.options.strokeGradient}:{}),{"line-offset":this.options.offset,"line-opacity":this.options.strokeOpacity,"line-translate":this.options.translate,"line-translate-anchor":this.options.translateAnchor,"line-width":this.options.strokeWidth})}),this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom})]},Yd.prototype._getLayerIds=function(){return[this.id]},Yd.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof lh?e.add(this.options.source.getId()):e.add(this.options.source),e},Yd);function Yd(e,t,o){t=zd.call(this,t)||this;return t.options=(new Hd).merge(th(o,Hd._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(Wd=function(e,t){return(Wd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Wd(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Vd,Zd=jo);var Wd,Zd,Qd=Vd;function Vd(){var e=null!==Zd&&Zd.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.base=0,e.fillColor="#1E90FF",e.height=0,e.fillOpacity=1,e.fillPattern=void 0,e.translate=new ru(0,0),e.translateAnchor="map",e.verticalGradient=!0,e}var Jd,Xd,r=window&&window.__extends||(Jd=function(e,t){return(Jd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Jd(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),$d=window&&window.__assign||function(){return($d=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},t=(r(ep,Xd=ed),ep.prototype.getOptions=function(){return th(this.options,Qd._cloneCustomizer)},ep.prototype.getSource=function(){return this.options.source},ep.prototype.setOptions=function(e){e=(new Qd).merge(this.options,th(e,Qd._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("fill-extrusion-base",e.base,this.options.base),this._updatePaintProperty("fill-extrusion-color",e.fillColor,this.options.fillColor),this._updatePaintProperty("fill-extrusion-height",e.height,this.options.height),this._updatePaintProperty("fill-extrusion-opacity",e.fillOpacity,this.options.fillOpacity),this._updatePaintProperty("fill-extrusion-pattern",e.fillPattern,this.options.fillPattern),this._updatePaintProperty("fill-extrusion-translate",e.translate,this.options.translate),this._updatePaintProperty("fill-extrusion-translate-anchor",e.translateAnchor,this.options.translateAnchor),this._updatePaintProperty("fill-extrusion-vertical-gradient",e.verticalGradient,this.options.verticalGradient)}this.options=e},ep.prototype._buildLayers=function(){return[$d($d($d($d({id:this.id,type:"fill-extrusion"},this.options.sourceLayer&&{"source-layer":this.options.sourceLayer}),{source:this.options.source instanceof lh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:$d($d({"fill-extrusion-base":this.options.base,"fill-extrusion-height":this.options.height,"fill-extrusion-opacity":this.options.fillOpacity},this.options.fillPattern?{"fill-extrusion-pattern":this.options.fillPattern}:{"fill-extrusion-color":this.options.fillColor}),{"fill-extrusion-translate":this.options.translate,"fill-extrusion-translate-anchor":this.options.translateAnchor,"fill-extrusion-vertical-gradient":this.options.verticalGradient})}),this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom})]},ep.prototype._getLayerIds=function(){return[this.id]},ep.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof lh?e.add(this.options.source.getId()):e.add(this.options.source),e},ep);function ep(e,t,o){t=Xd.call(this,t)||this;return t.options=(new Qd).merge(th(o,Qd._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(tp=function(e,t){return(tp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}tp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(np,op=jo);var tp,op,rp=np;function np(){var e=null!==op&&op.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.fillColor="#1E90FF",e.fillOpacity=.5,e.fillPattern=void 0,e.fillAntialias=!0,e}(window&&window.__extends||(ip=function(e,t){return(ip=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ip(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(cp,ap=ed),cp.prototype.getOptions=function(){return th(this.options,rp._cloneCustomizer)},cp.prototype.getSource=function(){return this.options.source},cp.prototype.setOptions=function(e){e=(new rp).merge(this.options,th(e,rp._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("fill-color",e.fillColor,this.options.fillColor),this._updatePaintProperty("fill-opacity",e.fillOpacity,this.options.fillOpacity),this._updatePaintProperty("fill-pattern",e.fillPattern,this.options.fillPattern),this._updatePaintProperty("fill-antialias",e.fillAntialias,this.options.fillAntialias)}this.options=e},cp.prototype._buildLayers=function(){var e={id:this.id,type:"fill",source:this.options.source instanceof lh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:{"fill-opacity":this.options.fillOpacity,"fill-antialias":this.options.fillAntialias},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),this.options.sourceLayer&&(e["source-layer"]=this.options.sourceLayer),this.options.fillPattern?e.paint["fill-pattern"]=this.options.fillPattern:e.paint["fill-color"]=this.options.fillColor,[e]},cp.prototype._getLayerIds=function(){return[this.id]},cp.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof lh?e.add(this.options.source.getId()):e.add(this.options.source),e};var ip,ap,sp=cp;function cp(e,t,o){t=ap.call(this,t)||this;return t.options=(new rp).merge(th(o,rp._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(up=function(e,t){return(up=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}up(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(dp,lp=ye);var up,lp,hp=dp;function dp(){var e=null!==lp&&lp.apply(this,arguments)||this;return e.allowOverlap=!1,e.anchor="bottom",e.ignorePlacement=!1,e.image="marker-blue",e.offset=new ru(0,0),e.optional=!1,e.padding=2,e.pitchAlignment="auto",e.rotation=0,e.rotationAlignment="auto",e.size=1,e.opacity=1,e}(window&&window.__extends||(pp=function(e,t){return(pp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}pp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(mp,fp=ye);var pp,fp,gp=mp;function mp(){var e=null!==fp&&fp.apply(this,arguments)||this;return e.allowOverlap=!1,e.anchor="center",e.textField=void 0,e.font=["StandardFont-Regular"],e.ignorePlacement=!1,e.justify="center",e.offset=new ru(0,0),e.optional=!1,e.padding=2,e.pitchAlignment="auto",e.radialOffset=void 0,e.rotation=0,e.rotationAlignment="auto",e.variableAnchor=void 0,e.size=16,e.color="#000000",e.haloBlur=0,e.haloColor="rgba(0,0,0,0)",e.haloWidth=0,e.opacity=1,e}(window&&window.__extends||(yp=function(e,t){return(yp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}yp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(wp,vp=jo);var yp,vp,_p=wp;function wp(){var e=null!==vp&&vp.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.iconOptions=new hp,e.textOptions=new gp,e.placement="point",e.sortKey=void 0,e.zOrder="auto",e.lineSpacing=250,e}var bp,Cp,be=window&&window.__extends||(bp=function(e,t){return(bp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}bp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),Sp=window&&window.__assign||function(){return(Sp=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Ep=(be(Tp,Cp=ed),Tp.prototype.getOptions=function(){return th(this.options,_p._cloneCustomizer)},Tp.prototype.getSource=function(){return this.options.source},Tp.prototype.setOptions=function(e){e=(new _p).merge(this.options,th(e,_p._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);var t=this.options,o=e.iconOptions,r=t.iconOptions,n=e.textOptions,i=t.textOptions;this._updateBaseProperties(e,t),this._updateLayoutProperty("symbol-spacing",e.lineSpacing,t.lineSpacing),this._updateLayoutProperty("symbol-placement",e.placement,t.placement),this._updateLayoutProperty("symbol-sort-key",e.sortKey,t.sortKey),this._updateLayoutProperty("symbol-z-order",e.zOrder,t.zOrder),this._updateLayoutProperty("icon-allow-overlap",o.allowOverlap,r.allowOverlap),this._updateLayoutProperty("icon-anchor",o.anchor,r.anchor),this._updateLayoutProperty("icon-ignore-placement",o.ignorePlacement,r.ignorePlacement),this._updateLayoutProperty("icon-image",o.image,r.image),this._updateLayoutProperty("icon-offset",o.offset,r.offset),this._updatePaintProperty("icon-opacity",o.opacity,r.opacity),this._updateLayoutProperty("icon-optional",o.optional,r.optional),this._updateLayoutProperty("icon-padding",o.padding,r.padding),this._updateLayoutProperty("icon-pitch-alignment",o.pitchAlignment,r.pitchAlignment),this._updateLayoutProperty("icon-rotate",o.rotation,r.rotation),this._updateLayoutProperty("icon-rotation-alignment",o.rotationAlignment,r.rotationAlignment),this._updateLayoutProperty("icon-size",o.size,r.size),this._updateLayoutProperty("text-allow-overlap",n.allowOverlap,i.allowOverlap),this._updateLayoutProperty("text-anchor",n.anchor,i.anchor),this._updatePaintProperty("text-color",n.color,i.color),this._updateLayoutProperty("text-font",n.font,i.font),this._updateLayoutProperty("text-ignore-placement",n.ignorePlacement,i.ignorePlacement),this._updateLayoutProperty("text-justify",n.justify,i.justify),this._updatePaintProperty("text-halo-blur",n.haloBlur,i.haloBlur),this._updatePaintProperty("text-halo-color",n.haloColor,i.haloColor),this._updatePaintProperty("text-halo-width",n.haloWidth,i.haloWidth),this._updateLayoutProperty("text-offset",n.offset,i.offset),this._updatePaintProperty("text-opacity",n.opacity,i.opacity),this._updateLayoutProperty("text-optional",n.optional,i.optional),this._updateLayoutProperty("text-padding",n.padding,i.padding),this._updateLayoutProperty("text-pitch-alignment",n.pitchAlignment,i.pitchAlignment),this._updateLayoutProperty("text-radial-offset",n.radialOffset,i.radialOffset),this._updateLayoutProperty("text-rotate",n.rotation,i.rotation),this._updateLayoutProperty("text-rotation-alignment",n.rotationAlignment,i.rotationAlignment),this._updateLayoutProperty("text-size",n.size,i.size),this._updateLayoutProperty("text-variable-anchor",n.variableAnchor,i.variableAnchor),this._updateLayoutProperty("text-field",n.textField,i.textField)}this.options=e},Tp.prototype._buildLayers=function(){var e=Sp(Sp(Sp(Sp({id:this.id,type:"symbol"},this.options.sourceLayer&&{"source-layer":this.options.sourceLayer}),{source:this.options.source instanceof lh?this.options.source.getId():this.options.source,layout:Sp(Sp({visibility:this.options.visible?"visible":"none","symbol-placement":this.options.placement,"symbol-spacing":this.options.lineSpacing,"symbol-z-order":this.options.zOrder,"text-allow-overlap":this.options.textOptions.allowOverlap,"text-anchor":this.options.textOptions.anchor},this.options.textOptions.textField&&{"text-field":this.options.textOptions.textField}),{"text-font":this.options.textOptions.font,"text-ignore-placement":this.options.textOptions.ignorePlacement,"text-justify":this.options.textOptions.justify,"text-offset":this.options.textOptions.offset,"text-optional":this.options.textOptions.optional,"text-padding":this.options.textOptions.padding,"text-pitch-alignment":this.options.textOptions.pitchAlignment,"text-rotate":this.options.textOptions.rotation,"text-rotation-alignment":this.options.textOptions.rotationAlignment,"text-size":this.options.textOptions.size,"icon-allow-overlap":this.options.iconOptions.allowOverlap,"icon-anchor":this.options.iconOptions.anchor,"icon-ignore-placement":this.options.iconOptions.ignorePlacement,"icon-image":this.options.iconOptions.image,"icon-offset":this.options.iconOptions.offset,"icon-optional":this.options.iconOptions.optional,"icon-padding":this.options.iconOptions.padding,"icon-pitch-alignment":this.options.iconOptions.pitchAlignment,"icon-rotate":this.options.iconOptions.rotation,"icon-rotation-alignment":this.options.iconOptions.rotationAlignment,"icon-size":this.options.iconOptions.size}),paint:{"text-color":this.options.textOptions.color,"text-halo-blur":this.options.textOptions.haloBlur,"text-halo-color":this.options.textOptions.haloColor,"text-halo-width":this.options.textOptions.haloWidth,"text-opacity":this.options.textOptions.opacity,"icon-opacity":this.options.iconOptions.opacity}}),this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom});return void 0!==this.options.sortKey&&(e.layout["symbol-sort-key"]=this.options.sortKey),void 0!==this.options.textOptions.radialOffset&&(e.layout["text-radial-offset"]=this.options.textOptions.radialOffset),void 0!==this.options.textOptions.variableAnchor&&(e.layout["text-variable-anchor"]=this.options.textOptions.variableAnchor),[e]},Tp.prototype._getLayerIds=function(){return[this.id]},Tp.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof lh?e.add(this.options.source.getId()):e.add(this.options.source),e},Tp);function Tp(e,t,o){t=Cp.call(this,t)||this;return t.options=(new _p).merge(th(o,_p._cloneCustomizer)),t.options.source=e||t.options.source,t}var Ip,kp,xi=window&&window.__extends||(Ip=function(e,t){return(Ip=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ip(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),Ap=window&&window.__assign||function(){return(Ap=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Pp=(xi(Op,kp=lh),Op.prototype._buildSource=function(){return this.source},Op.prototype._isDeepEqual=function(e){var o,t,r,n;return this.constructor===e.constructor&&(n=this.source,o=e.source,e=n.type===o.type&&n.url===o.url&&(void 0===n.tiles&&void 0===o.tiles||n.tiles&&o.tiles&&n.tiles.length===o.tiles.length&&n.tiles.every(function(e,t){return e===o.tiles[t]}))&&n.minzoom===o.minzoom&&n.maxzoom===o.maxzoom&&n.bounds===o.bounds&&n.attribution===o.attribution,t="raster"!==n.type||"raster"===n.type&&n.type===o.type&&n.tileSize===o.tileSize&&n.scheme===o.scheme,r="raster-dem"!==n.type||"raster-dem"===n.type&&n.type===o.type&&n.tileSize===o.tileSize&&n.encoding===o.encoding,n="vector"!==n.type||"vector"===n.type&&n.type===o.type&&n.promoteId===o.promoteId&&n.scheme===o.scheme,e)&&t&&r&&n},Op.prototype._modifySource=function(e,t){if("raster"!==e.type&&"raster-dem"!==e.type&&"vector"!==e.type||!e.tiles){if("raster"!==e.type&&"raster-dem"!==e.type&&"vector"!==e.type||!e.url)throw new Error("Source definition must define a TileJSON 'url' or a 'tiles' array.");e.url="string"==typeof e.url?e.url:new Te({domain:te,path:e.url.path,queryParams:Ap(Ap({},t),e.url.queryParams)}).toString()}else{var o=e.tiles.map(function(e){return"string"==typeof e?e:new Te({domain:te,path:e.path,queryParams:Ap(Ap({},t),e.queryParams)}).toString()});e.tiles=o}return e},Op);function Op(e,t,o){e=kp.call(this,e)||this;return e.source=e._modifySource(t,o),e}(window&&window.__extends||(Rp=function(e,t){return(Rp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Rp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Np,xp=Kt);var Rp,xp,Mp=Np;function Np(){var e=null!==xp&&xp.apply(this,arguments)||this;return e.bounds=[-180,-85.0511,180,85.0511],e.minSourceZoom=0,e.maxSourceZoom=22,e.tileSize=512,e.isTMS=!1,e.subdomains=void 0,e.tileUrl=void 0,e}var Lp,Dp,o=window&&window.__extends||(Lp=function(e,t){return(Lp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Lp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),qp=window&&window.__assign||function(){return(qp=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Up=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},jp=(o(Hp,Dp=Md),Hp.prototype.getOptions=function(){return th(this.options,Mp._cloneCustomizer)},Hp.prototype.setOptions=function(e){e=(new Mp).merge(this.options,th(e,Mp._cloneCustomizer));if(this.map){if(!Xc(e.bounds,this.options.bounds)||e.isTMS!==this.options.isTMS||e.maxSourceZoom!==this.options.maxSourceZoom||e.minSourceZoom!==this.options.minSourceZoom||!Xc(e.subdomains,this.options.subdomains)||e.tileSize!==this.options.tileSize||e.tileUrl!==this.options.tileUrl)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("raster-contrast",e.contrast,this.options.contrast),this._updatePaintProperty("raster-fade-duration",e.fadeDuration,this.options.fadeDuration),this._updatePaintProperty("raster-hue-rotate",e.hueRotation,this.options.hueRotation),this._updatePaintProperty("raster-brightness-max",e.maxBrightness,this.options.maxBrightness),this._updatePaintProperty("raster-opacity",e.opacity,this.options.opacity),this._updatePaintProperty("raster-saturation",e.saturation,this.options.saturation)}this.options=e},Hp.prototype._setOptionsNoUpdate=function(e){this.options=(new Mp).merge(this.options,th(e,Mp._cloneCustomizer))},Hp.prototype._buildLayers=function(){return[qp(qp({id:this.id,type:"raster",source:this._getSourceId(),layout:{visibility:this.options.visible?"visible":"none"},paint:{"raster-contrast":this.options.contrast,"raster-fade-duration":this.options.fadeDuration,"raster-hue-rotate":this.options.hueRotation,"raster-brightness-max":this.options.maxBrightness,"raster-brightness-min":this.options.minBrightness,"raster-opacity":this.options.opacity,"raster-saturation":this.options.saturation}},this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom})]},Hp.prototype._getLayerIds=function(){return[this.id]},Hp.prototype._buildSource=function(){var t,e;if(this.options.tileUrl){if(-1===this.options.tileUrl.indexOf("{"))return{type:"raster",url:this.options.tileUrl};if(-1!==this.options.tileUrl.indexOf("{subdomain}")){if(!(this.options.subdomains&&0<this.options.subdomains.length))throw new Error("The {subdomain} placeholder was included in the tileUrl but no subdomains were specified");var o=[];try{for(var r=Up(this.options.subdomains),n=r.next();!n.done;n=r.next()){var i=n.value;o.push(this.options.tileUrl.replace(/{subdomain}/g,i))}}catch(e){t={error:e}}finally{try{n&&!n.done&&(e=r.return)&&e.call(r)}finally{if(t)throw t.error}}e=o}else e=[this.options.tileUrl]}return qp({type:"raster",bounds:this.options.bounds,maxzoom:this.options.maxSourceZoom,minzoom:this.options.minSourceZoom,scheme:this.options.isTMS?"tms":"xyz",tileSize:this.options.tileSize},e&&{tiles:e})},Hp.prototype._getSourceId=function(){return"".concat(this.getId(),"-RasterSource")},Hp.prototype._getSourceWrapper=function(){var e=this._getSourceId(),t=this._buildSource();return new Pp(e,{name:e,tiles:t.tiles,type:t.type,url:t.url})},Hp);function Hp(e,t){t=Dp.call(this,t)||this;return e&&t.setOptions(e),t}(window&&window.__extends||(Bp=function(e,t){return(Bp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Bp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Kp,Fp=jo);var Bp,Fp,zp=Kp;function Kp(){var e=null!==Fp&&Fp.apply(this,arguments)||this;return e.renderer=void 0,e}(window&&window.__extends||(Gp=function(e,t){return(Gp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Gp(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Zp,Yp=ed),Zp.prototype.getOptions=function(){return th(this.options,zp._cloneCustomizer)},Zp.prototype.setOptions=function(e){e=(new zp).merge(this.options,th(e,zp._cloneCustomizer));this.map&&this.map.triggerRepaint(),this.options=e},Zp.prototype.onAdd=function(e){var t,o;Yp.prototype.onAdd.call(this,e),this.map.events.add("stylechanged",this._onStyleChange),this.options.renderer&&this.glContext&&null!=(o=(t=this.options.renderer).onAdd)&&o.call(t,e,this.glContext)},Zp.prototype.onRemove=function(){var e,t;this.options.renderer&&this.glContext&&null!=(t=(e=this.options.renderer).onRemove)&&t.call(e,this.map,this.glContext),this.map.events.remove("stylechanged",this._onStyleChange),this.glContext=null,Yp.prototype.onRemove.call(this)},Zp.prototype._buildLayers=function(){var n=this;if(this.options.renderer)return[{id:this.id,type:"custom",renderingMode:this.options.renderer.renderingMode,onAdd:function(e,t){n.glContext=t},onRemove:function(e,t){},prerender:function(e,t){var o,r;n._shouldRender()&&null!=(r=(o=n.options.renderer).prerender)&&r.call(o,e,t)},render:function(e,t){n._shouldRender()&&n.options.renderer.render(e,t)}}];throw new Error("Cannot build the WebGL layer because renderer was not set.")},Zp.prototype._getLayerIds=function(){return[this.id]},Zp.prototype._getSourceIds=function(){return(new Set).add(this.source.getId())},Zp.prototype._shouldRender=function(){var e;return!!this.map&&(e=this.map.getCamera().zoom,this.options.visible)&&this.options.minZoom<=e&&this.options.maxZoom>e};var Gp,Yp,Wp=Zp;function Zp(e,t){var o=Yp.call(this,e)||this;return o._onStyleChange=function(){var e,t;o.map._getMap().getLayer(o.id)||(e=o.map,t=null==(t=o.map.layers._getUserLayers().find(function(e){return e.layer.getId()==o.id}))?void 0:t.before,e.layers.remove(o),e.layers.add(o,t))},o.options=(new zp).merge(th(t,zp._cloneCustomizer)),o.source=new gh,o}var Mi=Object.freeze({__proto__:null,BubbleLayer:gd,HeatMapLayer:ln,ImageLayer:a,Layer:ed,LineLayer:Gd,PolygonExtrusionLayer:t,PolygonLayer:sp,SymbolLayer:Ep,TileLayer:jp,WebGLLayer:Wp}),Qp=(Vp.convertHtmlString=function(e){var t;return"string"==typeof e?((t=document.createElement("div")).innerHTML=e,t):e},Vp.parseWithFilter=function(e,t,o,r){var n=this;if(void 0===t&&(t=function(e){return!0}),void 0===o&&(o=function(e){return e}),void 0===r&&(r=function(){return document.createElement("div")}),"string"==typeof e){var i=(new DOMParser).parseFromString(e,"text/html").body;if(0==i.children.length)return o(i.innerHTML);var a,i=1==i.children.length&&1==i.childNodes.length?i.children[0]:(a=r(),Array.from(i.childNodes).map(function(e){return a.append(e)}),a)}else i=e;return Array.from(i.children).forEach(function(e){return n.parseWithFilter(e,t,o)}),t(i)?o(i):(i.parentNode&&i.parentNode.removeChild(i),null)},Vp);function Vp(){}var Jp=on,Xp=ss;var $p,ef,tf=q(function(e){return Jp(e)&&1===e.nodeType&&!Xp(e)}),of=((window&&window.__extends||($p=function(e,t){return($p=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}$p(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(rf,ef=ye),rf._cloneCustomizer=function(e){if(tf(e))return e},rf);function rf(){var e=null!==ef&&ef.apply(this,arguments)||this;return e.anchor="none",e.draggable=!1,e.closeButton=!0,e.content=document.createElement("span"),e.fillColor="#FFFFFF",e.pixelOffset=new ru(0,0),e.position=new hl(0,0),e.showPointer=!0,e}var nf,af,s=window&&window.__extends||(nf=function(e,t){return(nf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}nf(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),sf=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},cf=(s(uf,af=Vt),uf.prototype.setPopupOptions=function(e){this.setOptions(e)},uf.prototype.setOptions=function(e){var t,e=(new of).merge(this.options,th(e,of._cloneCustomizer));e.content!==this.options.content?(this.htmlContent.remove(),this.htmlContent=this._createHtmlContent(e),this.contentDiv.prepend(this.htmlContent)):e.draggable!==this.options.draggable&&this._setDraggable(this.htmlContent,e.draggable),e.closeButton&&!this.closeBtn?(this.closeBtn=this._createCloseButton(),this.contentDiv.appendChild(this.closeBtn),t=jt("close"),this.contentDiv.appendChild(t),Ht(t,this.closeBtn,!0)):!e.closeButton&&this.closeBtn&&(this.contentDiv.removeChild(this.closeBtn),delete this.closeBtn),e.showPointer&&!this.arrowDiv?(this.arrowDiv=this._createArrowDiv(),this.containerDiv.appendChild(this.arrowDiv)):!e.showPointer&&this.arrowDiv&&(this.containerDiv.removeChild(this.arrowDiv),delete this.arrowDiv),e.fillColor!==this.options.fillColor&&(this.containerDiv.style.borderColor=e.fillColor,this.contentDiv.style.backgroundColor=e.fillColor),this.marker&&(e.anchor!==this.options.anchor?"none"===this.options.anchor?(this.autoAnchor!==e.anchor&&this._replaceMarker(this.map,e),this.map.events.remove("move",this._onMove),delete this.autoAnchor):(this._replaceMarker(this.map,e),"none"===e.anchor&&this.map.events.add("move",this._onMove)):(Xc(e.position,this.options.position)||this.marker.setLngLat(e.position),Xc(e.pixelOffset,this.options.pixelOffset)||this.marker.setOffset(e.pixelOffset))),this.options=e},uf.prototype.getPopupOptions=function(){return this.getOptions()},uf.prototype.getOptions=function(){return th(this.options,of._cloneCustomizer)},uf.prototype.getPopupContainer=function(){return this.containerDiv},uf.prototype._dragToPixel=function(e){this.dragging||(this.dragging=!0,this.contentDiv.style.pointerEvents="none",this._invokeEvent("dragstart",{type:"dragstart",target:this}));e=[e[0]+this.dragOffset[0],e[1]+this.dragOffset[1]],e=sf(this.map.pixelsToPositions([e]),1)[0];this.options.position=e,this.marker.setLngLat(this.options.position),this._invokeEvent("drag",{type:"drag",target:this})},uf.prototype._onUp=function(){this.dragging&&(this.contentDiv.style.pointerEvents="",this._invokeEvent("dragend",{type:"dragend",target:this}),"none"===this.options.anchor)&&this._onMove(),delete this.dragOffset,delete this.dragging},uf.prototype._createContainerDiv=function(e){var t=this,o=document.createElement("div"),r=(o.classList.add(uf.Css.container),o.classList.add(uf.Css.hidden),o.style.borderColor=e.fillColor,o.setAttribute("role","dialog"),o.setAttribute("aria-label","Map Information Window"),!1);return o.addEventListener("keydown",function(e){"Tab"!==e.key&&"Escape"!==e.key&&"Esc"!==e.key||(r=!0)}),o.addEventListener("keyup",function(e){"Tab"!==e.key&&"Escape"!==e.key&&"Esc"!==e.key||(r=!1)}),o.addEventListener("focusin",function(e){t.map&&!t.isOpen()&&(t.open(t.map),e.target instanceof HTMLElement)&&e.target.focus()}),o.addEventListener("focusout",function(e){r&&e.relatedTarget instanceof Node&&!o.contains(e.relatedTarget)&&(r=!1,t.isOpen())&&t.close()}),o},uf.prototype._createContentDiv=function(e){var t=document.createElement("div");return t.classList.add(uf.Css.content),t.style.backgroundColor=e.fillColor,t.setAttribute("tabindex","0"),this.htmlContent=this._createHtmlContent(e),t.appendChild(this.htmlContent),t},uf.prototype._createArrowDiv=function(){var e=document.createElement("div");return e.classList.add(uf.Css.arrow),e},uf.prototype._createCloseButton=function(){var e=document.createElement("button");return e.addEventListener("click",this.close),e.classList.add(uf.Css.close),e.setAttribute("aria-label","close"),e.setAttribute("type","button"),e.setAttribute("tabindex","0"),e.innerHTML="&times;",e},uf.prototype._createHtmlContent=function(e){var t=Qp.convertHtmlString(e.content);return e.draggable&&this._setDraggable(t,e.draggable),t},uf.prototype._createMarker=function(e,t){var o=this.marker?this.marker.getLngLat():e.position,t=("none"===e.anchor?(this.autoAnchor=t||"bottom",this.containerDiv.classList.add(this.autoAnchor),new D.Marker({anchor:this.autoAnchor,element:this.containerDiv,offset:e.pixelOffset})):(this.containerDiv.classList.add(e.anchor),new D.Marker({anchor:e.anchor,element:this.containerDiv,offset:e.pixelOffset}))).setLngLat(o);return t},uf.prototype._getAutoAnchor=function(e,t){var o,r,n=this.containerDiv.offsetWidth,i=this.containerDiv.offsetHeight,a=[];return(r=this.marker?(o=(r=e._getMap().project(this.marker.getLngLat())).x,r.y):(r=sf(e.positionsToPixels([t.position]),1),o=(t=sf(r[0],2))[0],t[1]))<i?a.push("top"):r>e.getCanvas().offsetHeight-i&&a.push("bottom"),o<n/2?a.push("left"):o>e.getCanvas().offsetWidth-n/2&&a.push("right"),0<a.length?a.join("-"):"bottom"},uf.prototype._replaceMarker=function(e,t,o){var r=this.containerDiv.nextElementSibling;this.marker.remove(),this.containerDiv.classList.remove(this.autoAnchor||this.options.anchor),this.marker=this._createMarker(t,o),this.marker.addTo(e._getMap()),e.popups._getCollectionDiv().insertBefore(this.containerDiv,r||null)},uf.prototype._setDraggable=function(e,t){t?(e.addEventListener("mousedown",this._onDown),e.addEventListener("touchstart",this._onDown),e.addEventListener("dragstart",this._onDragStart)):(e.removeEventListener("mousedown",this._onDown),e.removeEventListener("touchstart",this._onDown),e.removeEventListener("dragstart",this._onDragStart))},uf.Css={arrow:"popup-arrow",close:"popup-close",container:"popup-container",content:"popup-content-container",hidden:"hidden-accessible-element"},uf);function uf(e){var o=af.call(this)||this;return o.attach=function(e){o.map!==e&&(o.map&&o.remove(),o.map=e,o.marker=o._createMarker(o.options),o.marker.addTo(o.map._getMap()),o.map.popups._getCollectionDiv().appendChild(o.containerDiv),o.map.popups.add(o))},o.open=function(e){if(!e&&!o.map)throw new Error("Must specify a map to open on or attach to a map in advance");o.attach(e||o.map),o.containerDiv.classList.remove(uf.Css.hidden),o.map.events.add("move",o._onMove),o._onMove(),o._invokeEvent("open",{target:o,type:"open"})},o.close=function(){o.map&&o.map.events.remove("move",o._onMove),o.containerDiv.classList.add(uf.Css.hidden),o._invokeEvent("close",{target:o,type:"close"})},o.remove=function(){o.map&&(o.marker.remove(),o.containerDiv.classList.remove(o.autoAnchor||o.options.anchor),o.map.events.remove("move",o._onMove),o.map.popups.remove(o),delete o.map,delete o.marker,delete o.autoAnchor)},o.isOpen=function(){return o.map&&!o.containerDiv.classList.contains(uf.Css.hidden)},o._onMove=function(){var e=o._getAutoAnchor(o.map,o.options);e!==o.autoAnchor&&(o._replaceMarker(o.map,o.options,e),o.map.events.add("move",o._onMove))},o._onDown=function(e){o.map.popups._addDraggedPopup(o);var t=sf(o.map.positionsToPixels([o.options.position]),1)[0];"mousedown"===e.type?o.dragOffset=[t[0]-e.clientX,t[1]-e.clientY]:"touchstart"===e.type&&(o.dragOffset=[t[0]-e.touches[0].clientX,t[1]-e.touches[0].clientY])},o._onDragStart=function(e){e.preventDefault()},o.options=(new of).merge(th(e,of._cloneCustomizer)),o.containerDiv=o._createContainerDiv(o.options),o.contentDiv=o._createContentDiv(o.options),o.containerDiv.appendChild(o.contentDiv),o.options.showPointer&&(o.arrowDiv=o._createArrowDiv(),o.containerDiv.appendChild(o.arrowDiv)),o.options.closeButton&&(o.closeBtn=o._createCloseButton(),o.contentDiv.appendChild(o.closeBtn),e=jt("close"),o.contentDiv.appendChild(e),Ht(e,o.closeBtn,!0)),o}(window&&window.__extends||(lf=function(e,t){return(lf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}lf(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(pf,hf=ye),pf._cloneCustomizer=function(e){if(e instanceof cf||tf(e))return e};var lf,hf,df=pf;function pf(){var e=null!==hf&&hf.apply(this,arguments)||this;return e.anchor="bottom",e.color="#1A73AA",e.draggable=!1,e.htmlContent='<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24.5 36.5" id="marker_'.concat(W(),'" width="24.5" height="36.5" display="block"><path d="M12.25.25a12.2543,12.2543,0,0,0-12,12.4937c0,6.4436,6.4879,12.1093,11.059,22.5641.5493,1.2563,1.3327,1.2563,1.882,0C17.7621,24.8529,24.25,19.1857,24.25,12.7437A12.2543,12.2543,0,0,0,12.25.25Z"   fill="{color}" stroke="{secondaryColor}" stroke-width="0.5"/><text style="font-family: Arial, Helvetica, sans-serif; font-size: 14px; fill: white;" text-anchor="middle" x="12" y="18">{text}</text></svg>'),e.pixelOffset=new ru(0,0),e.position=new hl(0,0),e.popup=void 0,e.secondaryColor="white",e.text=void 0,e.visible=!0,e}(window&&window.__extends||(ff=function(e,t){return(ff=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ff(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(yf,gf=Vt),yf.prototype.getOptions=function(){return th(this.options,df._cloneCustomizer)},yf.prototype.getElement=function(){return this.marker.getElement()},yf.prototype.setOptions=function(e){e=(new df).merge(this.options,th(e,df._cloneCustomizer));Xc(e.htmlContent,this.options.htmlContent)&&e.anchor===this.options.anchor?("string"!=typeof e.htmlContent||e.color===this.options.color&&e.text===this.options.text&&e.secondaryColor===this.options.secondaryColor||(this.element.innerHTML=this._getSubbedHtmlString(e)||""),e.draggable!==this.options.draggable&&(this._setDraggable(e.draggable),this.marker.setDraggable(e.draggable)),Xc(e.pixelOffset,this.options.pixelOffset)||this.marker.setOffset(e.pixelOffset),Xc(e.position,this.options.position)||this.marker.setLngLat(e.position),e.visible!==this.options.visible&&(e.visible?this.element.classList.remove(yf.hiddenClass):this.element.classList.add(yf.hiddenClass))):(this.marker.remove(),this._buildMarker(e),this.map&&(this.marker.addTo(this.map._getMap()),this._getCollectionContainer().appendChild(this.element))),this.options=e},yf.prototype.togglePopup=function(){if(this.options.popup)if(this.options.popup.isOpen())this.options.popup.close();else{if(!this.map)throw new Error("The marker must be added to a map before calling togglePopup().");this.options.popup.setOptions({position:this.options.position}),this.options.popup.open(this.map)}},yf.prototype._addToMap=function(e,t){this.map&&this.map!==e&&this._removeFromMap(),t&&(this.options.position=Za(t),this.marker.setLngLat(this.options.position)),this.map!==e&&(this.map=e,this.marker.addTo(e._getMap()),this._getCollectionContainer().appendChild(this.element))},yf.prototype._removeFromMap=function(){this.map&&(this.marker.remove(),delete this.map)},yf.prototype._getId=function(){if(this.element)return("string"==typeof this.options.htmlContent?this.element.firstChild:this.element).id},yf.prototype._buildMarker=function(e){var t;"string"==typeof e.htmlContent?(t=this._getSubbedHtmlString(e)||"",this.element=Qp.convertHtmlString(t)):this.element=e.htmlContent,this.element.classList.add(yf.containerClass),e.draggable&&this._setDraggable(!0),e.visible||this.element.classList.add(yf.hiddenClass),this.marker=new D.Marker({element:this.element,offset:e.pixelOffset,draggable:e.draggable,anchor:e.anchor}).setLngLat(e.position),this.marker.on("drag",this._onDrag),this.marker.on("dragstart",this._onDragStart),this.marker.on("dragend",this._onDragEnd),this.element.addEventListener("click",this._bubbleElementEvent),this.element.addEventListener("dblclick",this._bubbleElementEvent),this.element.addEventListener("contextmenu",this._bubbleElementEvent),this.element.addEventListener("keydown",this._bubbleElementEvent),this.element.addEventListener("keypress",this._bubbleElementEvent),this.element.addEventListener("keyup",this._bubbleElementEvent),this.element.addEventListener("mousedown",this._bubbleElementEvent),this.element.addEventListener("mouseenter",this._bubbleElementEvent),this.element.addEventListener("mouseleave",this._bubbleElementEvent),this.element.addEventListener("mousemove",this._bubbleElementEvent),this.element.addEventListener("mouseout",this._bubbleElementEvent),this.element.addEventListener("mouseover",this._bubbleElementEvent),this.element.addEventListener("mouseup",this._bubbleElementEvent)},yf.prototype._getSubbedHtmlString=function(e){return"string"==typeof e.htmlContent?e.htmlContent.replace(/{color}/gi,e.color||"").replace(/{secondaryColor}/gi,e.secondaryColor||"").replace(/{text}/gi,e.text||""):null},yf.prototype._getCollectionContainer=function(){var e=this.map.getCanvasContainer().querySelector(".".concat(yf.collectionContainerClass));return e||((e=document.createElement("div")).classList.add(yf.collectionContainerClass),this.map.getCanvasContainer().appendChild(e)),e},yf.prototype._setDraggable=function(e){e?this.element.addEventListener("dragstart",this._onEleDragStart):this.element.removeEventListener("dragstart",this._onEleDragStart)},yf.collectionContainerClass="marker-collection-container",yf.hiddenClass="hidden-accessible-element",yf.containerClass="marker-container";var ff,gf,mf=yf;function yf(e){var t=gf.call(this)||this;return t._onDrag=function(){var e=t.marker.getLngLat().wrap();t.options.position=new hl(e.lng,e.lat),t._invokeEvent("drag",{type:"drag",target:t})},t._onDragStart=function(){t._invokeEvent("dragstart",{type:"dragstart",target:t})},t._onDragEnd=function(){t._invokeEvent("dragend",{type:"dragend",target:t})},t._bubbleElementEvent=function(e){t._invokeEvent(e.type,{type:e.type,target:t})},t._onEleDragStart=function(e){e.preventDefault()},t.options=(new df).merge(th(e,df._cloneCustomizer)),t._buildMarker(t.options),t}_f.getHighContrastMode=function(){return matchMedia("(-ms-high-contrast: white-on-black)").matches?"dark":matchMedia("(-ms-high-contrast: black-on-white)").matches?"light":matchMedia("(-ms-high-contrast: active)").matches?"dark":matchMedia("(inverted-colors: inverted)").matches?"invert":null};var vf=_f;function _f(){}(window&&window.__extends||(wf=function(e,t){return(wf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}wf(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Sf,bf=ye);var wf,bf,Cf=Sf;function Sf(){var e=null!==bf&&bf.apply(this,arguments)||this;return e.copyrightMessage=void 0,e.copyrightContent=void 0,e.customAttribution=void 0,e.showFeedbackLink=!0,e.showLogo=!0,e}(window&&window.__extends||(Ef=function(e,t){return(Ef=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Ef(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(kf,Tf=eo),kf.prototype.onAdd=function(e){return this.map=e,this.container=this.buildContainer(e,l.ControlStyle.auto),this.container.className="map-copyright without-bg",this.copyrightDiv=this.buildCopyrightDiv(),this.copyrightDiv.className="azure-map-copyright",this.container.appendChild(this.copyrightDiv),this.options.showFeedbackLink&&this.addRemoveFeedbackDiv(!0),this.container},kf.prototype.onRemove=function(){Tf.prototype.onRemove.call(this),delete this.container},kf.prototype.setOptions=function(e){var t,o=this,e=(new Cf).merge(this.options,e);e.copyrightMessage===this.options.copyrightMessage&&e.customAttribution===this.options.customAttribution||(this.copyrightDiv.innerText=this.textAttribution(e)),e.copyrightContent!==this.options.copyrightContent&&(this.options.copyrightContent&&(t=Array.from(this.copyrightDiv.children).find(function(e){return e===o.options.copyrightContent}),this.copyrightDiv.removeChild(t)),0<this.copyrightDiv.childNodes.length?this.copyrightDiv.insertBefore(e.copyrightContent,this.copyrightDiv.childNodes[0]):this.copyrightDiv.appendChild(e.copyrightContent),this.options.copyrightContent=e.copyrightContent),!e.showFeedbackLink&&this.feedbackAnchor?this.addRemoveFeedbackDiv(!1):e.showFeedbackLink&&!this.feedbackAnchor&&this.addRemoveFeedbackDiv(!0),this.options=e},kf.prototype.getDefaultAttributions=function(){var e=(new Date).getFullYear(),t=["©".concat(e," TomTom")];return this.options.showLogo||t.push("©".concat(e," Microsoft")),t},kf.prototype.buildCopyrightDiv=function(){var e=document.createElement("div");return e.innerText=this.textAttribution(this.options)||"",e},kf.prototype.buildFeedbackLink=function(){var e=document.createElement("a");return e.setAttribute("alt","Provide Map Data Feedback"),e.setAttribute("aria-label","Provide Map Data Feedback"),e.innerText="Feedback",e.href=kf.feedbackLink,e.target="_blank",e.rel="noopener",e.className="azure-map-feedback-text",e},kf.prototype.addRemoveFeedbackDiv=function(e){e?(this.feedbackAnchor=this.buildFeedbackLink(),this.feedbackTooltip=jt("Provide Map Data Feedback"),this.container.appendChild(this.feedbackAnchor),this.container.appendChild(this.feedbackTooltip),Ht(this.feedbackTooltip,this.feedbackAnchor),null!=(e=null==(e=this.map)?void 0:e.events)&&e.add("moveend",this.updateFeedbackLink)):(this.feedbackAnchor.remove(),this.feedbackTooltip.remove(),delete this.feedbackTooltip,delete this.feedbackAnchor,null!=(e=null==(e=this.map)?void 0:e.events)&&e.remove("moveend",this.updateFeedbackLink))},kf.feedbackLink="https://aka.ms/azuremaps-feedback?feedbackep=UrlAzureMapsWebSdk";var Ef,Tf,If=kf;function kf(e){var o=Tf.call(this)||this;return o.textAttribution=function(e){return[o.options.copyrightMessage,o.options.customAttribution].filter(function(e){return e}).join("")},o.updateFeedbackLink=function(){var e,t;o.feedbackAnchor&&o.map&&(e=(t=o.map.getCamera()).center,t=t.zoom,o.feedbackAnchor.href="".concat(kf.feedbackLink,"&cp=").concat(e[1],"~").concat(e[0],"&lvl=").concat(t+1))},o.options=(new Cf).merge(e),o}(window&&window.__extends||(Af=function(e,t){return(Af=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Af(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Rf,Pf=ye);var Af,Pf,Of=Rf;function Rf(){var e=null!==Pf&&Pf.apply(this,arguments)||this;return e.showLogo=!0,e}(window&&window.__extends||(xf=function(e,t){return(xf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}xf(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(Lf,Mf=eo),Lf.prototype.onAdd=function(e){return this.map=e,this.container=this.buildContainer(e,l.ControlStyle.auto),this.container.className="map-logo-control",null!=(e=this.map)&&e.events.add("resize",this._onResize),this._addRemoveLogo(this.options.showLogo),this.container},Lf.prototype.onRemove=function(){var e;Mf.prototype.onRemove.call(this),null!=(e=this.map)&&e.events.remove("resize",this._onResize),this.map=null,delete this.container},Lf.prototype.setOptions=function(e){e=(new Of).merge(this.options,e);!e.showLogo&&this.logoAnchor?this._addRemoveLogo(!1):e.showLogo&&!this.logoAnchor&&this._addRemoveLogo(!0),this.options=e},Lf.prototype._addRemoveLogo=function(e){e?(this.logoAnchor=document.createElement("a"),this.logoAnchor.className="azure-map-logo",this.logoAnchor.href="https://aka.ms/azuremaps",this.logoAnchor.setAttribute("aria-label","Visit azure.microsoft.com"),this.logoAnchor.setAttribute("target","_blank"),this.container.appendChild(this.logoAnchor),this.logoTooltip=jt("Visit azure.microsoft.com"),this.container.appendChild(this.logoTooltip),Ht(this.logoTooltip,this.logoAnchor),this._setVisiblity(!0)):(null!=(e=this.logoAnchor)&&e.remove(),null!=(e=this.logoTooltip)&&e.remove(),delete this.logoAnchor,this._setVisiblity(!1))},Lf.prototype._setVisiblity=function(e){this.container&&(this.container.style.display=e?"flex":"none")},Lf.CONTAINER_MIN_WIDTH=480;var xf,Mf,Nf=Lf;function Lf(e){var t=Mf.call(this)||this;return t.map=null,t._onResize=function(){var e=(null==(e=null==(e=t.map)?void 0:e.getMapContainer())?void 0:e.clientWidth)||0;t._setVisiblity(t.options.showLogo&&Lf.CONTAINER_MIN_WIDTH<=e)},t.options=(new Of).merge(e),t}qf.throwOnError=function(e,t){function o(e){throw r.off("error",o),e.error}var r=e instanceof RE?e._getMap():e,e=(r.on("error",o),t());return r.off("error",o),e},qf.tryCatch=function(e,t,o,r){try{return this.throwOnError(e,t)}catch(e){return o(e)}finally{"function"==typeof r&&r()}},qf.tryFinally=function(e,t,o){try{return this.throwOnError(e,t)}finally{o()}};var Df=qf;function qf(){}var Uf=window&&window.__assign||function(){return(Uf=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},jf=(Hf.prototype.request=function(e){var t,e={domain:this.map.getServiceOptions().domain,path:"reverseGeocode",queryParams:Uf({"api-version":"2023-06-01",coordinates:"".concat(Wu(e.position[0]),",").concat(Yu(e.position[1]))},e.style.view&&{view:e.style.view}),headers:{"Accept-Language":e.style.language}};return new Te((null==(t=this.map.authentication)?void 0:t.signRequest(e))||e).get()},Hf);function Hf(e){this.map=e}Ff.prototype.cache=function(e,t,o,r){r="".concat(e,"_").concat(o[0],"_").concat(o[1],"_").concat(r);this._labelIdx[t.labelType]||(this._labelIdx[t.labelType]=[],this._labelCache[t.labelType]=[]),-1===this._labelIdx[t.labelType].indexOf(r)&&(this._labelCache[t.labelType].push({name:e,radius:t.radius,minZoom:t.minZoom,maxZoom:t.maxZoom||24,position:o}),this._labelIdx[t.labelType].push(r))},Ff.prototype.getNearestLabel=function(e,t,o){var r=null,n=this._labelCache[e];if(n)for(var i,a=1/0,s=0,c=n.length;s<c;s++)o>=n[s].minZoom&&o<=n[s].maxZoom&&(i=Lu(n[s].position,t))<=n[s].radius&&i<=a&&(a=i,r=n[s]);return r},Ff.prototype._preloadCache=function(e){if(!this._preloadedCache.has(e)){this._preloadedCache.add(e);var t={source:[],labelType:"water",minZoom:0,radius:395e4,polygonSources:[]},o=e,r=o.indexOf("-");switch(o=-1!==r?o.substr(0,r):o){case"fr":this.cache("Océan Pacifique",t,[-170,32],e),this.cache("Océan Pacifique",t,[-138,-27],e),this.cache("Océan Atlantique",t,[-40,32],e),this.cache("Océan Atlantique",t,[-17,-29],e);break;case"es":this.cache("Océan Pacifique",t,[-170,32],e),this.cache("Océan Pacifique",t,[-138,-27],e),this.cache("Océano Atlántico",t,[-40,32],e),this.cache("Océano Atlántico",t,[-17,-29],e);break;case"pt":this.cache("Oceano Pacífico",t,[-170,32],e),this.cache("Oceano Pacífico",t,[-138,-27],e),this.cache("Oceano Atlântico",t,[-40,32],e),this.cache("Oceano Atlântico",t,[-17,-29],e);break;case"ja":this.cache("太平洋",t,[-170,32],e),this.cache("太平洋",t,[-138,-27],e);break;case"en":this.cache("Pacific Ocean",t,[-170,32],e),this.cache("Pacific Ocean",t,[-138,-27],e),this.cache("Atlantic Ocean",t,[-40,32],e),this.cache("Atlantic Ocean",t,[-17,-29],e),this.cache("Indian Ocean",t,[77,-26],e)}}};var Bf=Ff;function Ff(){this._labelCache={},this._labelIdx={},this._preloadedCache=new Set}var zf=window&&window.__awaiter||function(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})},Kf=window&&window.__generator||function(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},u={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function e(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c=u&&t[u=0]?0:c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},Gf=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},Yf=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},Wf=(Zf.prototype.dispose=function(){this._disposed=!0;var e=this._map._getMap(),e=(e.off("move",this._onMove),e.off("moveend",this._onMoveEnd),e.off("styledata",this._onStyleData),e.off("rotate",this._onRotate),this._map.getCanvas());e.removeEventListener("mousedown",this._onPointerDown),e.removeEventListener("touchstart",this._onPointerDown),this._map.getMapContainer().removeEventListener("keydown",this._shortcutListener)},Zf.prototype._getEventPos=function(e){var t,o;return"touches"in e?(t=e.touches[0],o=e.target.getBoundingClientRect(),[t.pageX-o.left,t.pageY-o.top]):[e.offsetX,e.offsetY]},Zf.prototype._checkThresholds=function(e,t){return this._checkZoomThreshold(e.zoom,t.zoom)||this._checkPitchThreshold(e.pitch,t.pitch)||this._checkLocThreshold(e.center,t.center)||this._checkHeadingThreshold(e.bearing,t.bearing)},Zf.prototype._checkZoomThreshold=function(e,t){return this._round(e)!==this._round(t)},Zf.prototype._checkPitchThreshold=function(e,t){return Math.abs(e-t)>=this._pitchThreshold},Zf.prototype._checkLocThreshold=function(e,t){e=(t=Gf(this._map.positionsToPixels([t,e]),2))[0],t=t[1];return ru.getDistance(e,t)>=this._moveThreshold},Zf.prototype._checkHeadingThreshold=function(e,t){e<0&&(e+=360),t<0&&(t+=360);e=Math.abs(e-t);return(e=180<e?360-e:e)>=this._headingThreshold},Zf.prototype._getLocDesc=function(h,d,p){return zf(this,void 0,void 0,function(){var t,o,r,n,i,a,s,c,u,l=this;return Kf(this,function(e){switch(e.label){case 0:return"blank"===p?[3,3]:this._map._getMap().loaded()?[3,2]:[4,new Promise(function(e){return l._map._getMap().once("idle",e)})];case 1:e.sent(),e.label=2;case 2:for(t={},o=this._map.positionsToPixels([h.center])[0],Df.tryCatch(this._map,function(){var t=l._map._getMap();r=t.queryRenderedFeatures(o,{layers:l._polygonStyleLayer.filter(function(e){return t.getLayer(e)}),filter:["==",["geometry-type"],"Polygon"]})},function(){}),n=null,r&&0<r.length&&(n=r[0]),i=null,a=0,s=this._labelConfig.length;a<s;a++)c=this._labelConfig[a],h.zoom>=c.minZoom?c.polygonSources?n&&-1!==c.polygonSources.indexOf(n.layer["source-layer"])?(i=c.labelType,this._getClosestLabel(c,h,d,t,!1)):this._getClosestLabel(c,h,d,t,!0):this._getClosestLabel(c,h,d,t,!1):this._getClosestLabel(c,h,d,t,!0);return 8<=h.zoom&&this._processRoads(t,h,d),this._labelCache.forEach(function(e){!t[e]&&(u=null,u="water"!==e&&"majorPoi"!==e||e===i?Zf._labelCache.getNearestLabel(e,h.center,h.zoom):u)&&(t[e]=u.name)}),[2,this._processLocInfo(h,i,t,!0,this._restFallback)];case 3:return[2,this._processLocInfo(h,null,null,!1,!1)]}})})},Zf.prototype._getHeadingDesc=function(e){var t=e.bearing;switch(t<0&&(t+=360),t=this._round(t,this._headingThreshold)){case 0:case 360:return"north";case 45:return"north east";case 90:return"east";case 135:return"south east";case 180:return"south";case 225:return"south west";case 270:return"west";case 315:return"north west";default:return"".concat(t," degrees")}},Zf.prototype._getClosestLabel=function(e,t,o,r,n){for(var i=e.radius,a=0,s=e.source.length;a<s;a++){var c={sourceLayer:e.source[a],filter:["has","name"]},u=this._map._getMap().querySourceFeatures(this._baseVectorTileSourceId,c),l=null,h=1/0,d=this._labelCache.has(e.labelType);if(!n||d)for(var p=0,f=u.length;p<f;p++){var g,m="Point"===u[p].geometry.type?u[p]:cl(t.center,u[p].geometry);n||(g="Point"===u[p].geometry.type?Lu(t.center,m.geometry.coordinates):m.properties.distance)<h&&(h=g,l=u[p]),d&&Zf._labelCache.cache(u[p].properties.name,e,m.geometry.coordinates,o)}n||(c=e.labelType+"Dis",l&&h<=i&&("number"!=typeof r[c]||h<=r[c])&&(r[e.labelType]=l.properties.name,r[c]=h))}},Zf.prototype._processRoads=function(e,t,o,r){var n=this._map._getMap().queryRenderedFeatures(r,{filter:["==",["geometry-type"],"LineString"]});if(n){for(var i,a=void 0,s=void 0,c=void 0,u=void 0,l=0,h=n.length;l<h;l++)this._roadLayers.has(n[l].layer["source-layer"])&&n[l].properties.name&&""!==n[l].properties.name&&(i=cl(t.center,n[l]),!c||i.properties.distance<c.properties.distance)&&(a&&n[l].properties.name===a.properties.name?c=i:a&&n[l].properties.name===a.properties.name?(!u||i.properties.distance<u.properties.distance)&&(u=i,s=n[l]):(u=c,s=a,c=i,a=n[l]));a&&(!e.country&&a.properties.country_code&&(e.country=a.properties.country_code,e.countryDis=0,Zf._labelCache.cache(e.country,{source:[],labelType:"country",radius:5e3,minZoom:0},c.geometry.coordinates,o)),!e.state&&a.properties.country_subdivision&&(e.state=a.properties.country_subdivision,e.stateDis=0,Zf._labelCache.cache(e.state,{source:[],labelType:"state",radius:5e3,minZoom:4},c.geometry.coordinates,o)),15<=t.zoom)&&(r=this._map.positionsToPixels([t.center,c.geometry.coordinates]),(ru.getDistance(r[0],r[1])<this._roadPixelRadius||c.properties.distance<this._minRoadDistance)&&(e.road=a.properties.name),s)&&(o=this._map.positionsToPixels([u.geometry.coordinates]),ru.getDistance(r[0],o[0])<this._minIntersectionPixelDistance||u.properties.distance<this._minRoadDistance)&&(e.secondRoad=s.properties.name,e.secondRoadDis=u.properties.distance)}},Zf.prototype._getActionDesc=function(e){var t,o,r;return this._lastCam&&(t=[],this._checkLocThreshold(e.center,this._lastCam.center)&&(r=["panned"],0===(o=Math.round(Hu(this._lastCam.center,e.center)))||360===o?r.push("north"):o<90?r.push("north east"):90===o?r.push("east"):o<180?r.push("south east"):180===o?r.push("south"):o<270?r.push("south west"):270===o?r.push("west"):o<360&&r.push("north west"),o=Lu(this._lastCam.center,e.center,cu.meters),r.push(1e3<o?"".concat(xu(o/1e3,2)," kilometers"):"".concat(xu(o,2)," meters")),t.push(r.join(" "))),this._checkZoomThreshold(e.zoom,this._lastCam.zoom)&&((r=["zoomed"]).push(this._lastCam.zoom<e.zoom?"in":"out"),1<=(o=Math.abs(this._lastCam.zoom-e.zoom))&&(o=Math.ceil(o),r.push("".concat(o,1<o?" levels":" level"))),this._getCanonicalZoom(this._lastCam.zoom)!==this._getCanonicalZoom(e.zoom)&&r.push("to ".concat(this._getCanonicalZoom(e.zoom)," level")),e.zoom>=e.maxZoom&&r.push("Zoom In button disabled, maximum zoom level reached"),o=f.getSouth(e.bounds)<=-vu&&f.getNorth(e.bounds)>=vu,(e.zoom<=e.minZoom||o)&&r.push("Zoom Out button disabled, minimum zoom level reached"),t.push(r.join(" "))),this._checkPitchThreshold(e.pitch,this._lastCam.pitch)&&(o=this._round(e.pitch,this._pitchThreshold),t.push("pitched to ".concat(o," degrees")),60!==e.pitch&&0!==e.pitch||(r=60===e.pitch?"maximum":"minimum",t.push("reached ".concat(r," of ").concat(e.pitch," degrees")))),this._checkHeadingThreshold(this._lastCam.bearing,e.bearing)&&t.push("rotated to ".concat(this._getHeadingDesc(e))),t.join(" and "))||null},Zf.prototype._getCanonicalZoom=function(e){return(e=this._round(e))<2?"world":e<5?"country":e<11?"state province":e<15?"city":"street"},Zf.prototype._processLocInfo=function(n,i,a,s,c){var u=this;return new Promise(function(t,e){var o=[];if(s){var r=[];if(a&&(i&&("water"===i&&a.water?r.push(a.water):"majorPoi"===i&&a.majorPoi&&r.push(a.majorPoi)),0===r.length)&&(a.majorPoi&&8<=n.zoom?r.push(a.majorPoi):(a.poi&&14<=n.zoom?r.push(a.poi):a.road&&15<=n.zoom&&(a.secondRoad?r.push(a.road+" & "+a.secondRoad):r.push(a.road)),a.neighbourhood&&12<=n.zoom&&r.push(a.neighbourhood),a.city&&6<=n.zoom&&r.push(a.city)),a.state&&4<=n.zoom&&r.push(a.state),0===r.length?a.water?r.push(a.water):a.country&&r.push(a.country):1===r.length&&a.state&&4<=n.zoom&&a.country&&r.push(a.country)),0<r.length)o.push("<p>Location: ",r.join(", "),".</p>");else if(c&&"water"!==i)return void u._reverseGeocodeDescription(n).then(function(e){t(e)},function(){e("<p>Location: unknown</p>")})}u._returnDetailedDescriptions&&(o.push("<p>Zoom: ",xu(n.zoom,2),".</p>"),o.push("<p>Latitude: ",xu(n.center[1],5),".</p>"),o.push("<p>Longitude: ",xu(n.center[0],5),".</p>")),t(o.join(""))})},Zf.prototype._reverseGeocodeDescription=function(i){var a=this;return new Promise(function(r){var n=a._map.getStyle();a._reverseSearch.request({position:i.center,style:n}).then(function(e){var t,o={};e&&e.features&&0<e.features.length&&null!=(t=null==(t=e.features[0])?void 0:t.properties)&&t.address&&((t=e.features[0].properties.address).countryRegion&&(o.country=t.countryRegion.name,Zf._labelCache.cache(o.country,{source:[],labelType:"country",radius:5e3,minZoom:0},i.center,n.language)),t.adminDistricts&&(o.state=null==(e=t.adminDistricts[0])?void 0:e.shortName,Zf._labelCache.cache(o.state,{source:[],labelType:"state",radius:5e3,minZoom:4},i.center,n.language)),t.locality&&(o.city=t.locality,Zf._labelCache.cache(o.city,{source:[],labelType:"city",radius:1e3,minZoom:10},i.center,n.language)),t.addressLine)&&(o.road=t.addressLine),a._processLocInfo(i,null,o,!0,!1).then(function(e){r(e)})},function(e){a._processLocInfo(i,null,null,!0,!1).then(function(e){r(e)})}).catch(function(e){a._processLocInfo(i,null,null,!0,!1).then(function(e){r(e)})})})},Zf.prototype._round=function(e,t){return void 0===t&&(t=1),Math.round(e/t)*t},Zf._baseVectorTileSourceIds=["microsoft.base","vectorTiles","bing-mvt"],Zf._labelConfigBing=[{source:["water_feature"],labelType:"water",minZoom:0,radius:395e4,polygonSources:["generic_water_fill"]},{source:["water_feature"],labelType:"water",minZoom:3,radius:1e6,polygonSources:["generic_water_fill"]},{source:["country_region"],labelType:"country",minZoom:0,maxZoom:5,radius:3e5},{source:["admin_division1"],labelType:"state",minZoom:4,maxZoom:7,radius:3e5},{source:["populated_place"],labelType:"city",minZoom:8,radius:4e4},{source:["neighborhood"],labelType:"neighbourhood",minZoom:12,radius:6e3},{source:["amusement_park"],labelType:"poi",minZoom:14,radius:2e3,polygonSources:["amusement_park_fill"]},{source:["hospital"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["hospital_fill"]},{source:["shopping_center"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["shopping_center_fill"]},{source:["stadium"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["stadium_fill"]},{source:["higher_education_facility","school"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["higher_education_facility_fill","school_fill"]},{source:["zoo"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["zoo_fill"]},{source:["airport","airport_terminal"],labelType:"majorPoi",minZoom:11,radius:3e3,polygonSources:["airport_terminal_fill","airport_fill-merged7","airport_runway_fill"]},{source:["reserve"],labelType:"majorPoi",minZoom:7,radius:15e3,polygonSources:["generic_reserve_fill","land_cover_forest_fill"]}],Zf._roadLayersBing=new Set(["road"]),Zf);function Zf(e,t){var i=this;this._disposed=!1,this._lastHeadingTime=0,this._actionQueue=[],this._pointerUpdateDelay=3e3,this._camUpdateDelay=1e3,this._headUpdateLimit=1e3,this._controlEventDelay=500,this._moveThreshold=25,this._headingThreshold=5,this._pitchThreshold=5,this._roadPixelRadius=120,this._minRoadDistance=25,this._minIntersectionPixelDistance=50,this._labelConfig=[{source:["Ocean label","Ocean name"],labelType:"water",minZoom:0,radius:395e4,polygonSources:["Ocean","Ocean or sea"]},{source:["Sea label"],labelType:"water",minZoom:3,radius:1e6,polygonSources:["Sea","Ocean or sea"]},{source:["Country name"],labelType:"country",minZoom:0,maxZoom:5,radius:3e5},{source:["State name","State name short"],labelType:"state",minZoom:4,maxZoom:7,radius:3e5},{source:["Capital city","Large city"],labelType:"city",minZoom:8,radius:4e4},{source:["Medium city"],labelType:"city",minZoom:8,radius:3e4},{source:["Small city"],labelType:"city",minZoom:8,radius:2e4},{source:["Island label"],labelType:"city",minZoom:8,radius:1e4},{source:["Town"],labelType:"city",minZoom:10,radius:1e4},{source:["Village"],labelType:"neighbourhood",minZoom:12,radius:6e3},{source:["Amusement area label"],labelType:"poi",minZoom:14,radius:2e3,polygonSources:["Amusement park"]},{source:["Hospital label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Hospital"]},{source:["Shopping centre label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Shopping"]},{source:["Stadium label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Stadium"]},{source:["University/School label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["University"]},{source:["Zoo label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Zoo"]},{source:["Airport Label","Airport name","Airport POI"],labelType:"majorPoi",minZoom:11,radius:3e3,polygonSources:["Airport","Runway"]},{source:["National park label"],labelType:"majorPoi",minZoom:7,radius:15e3,polygonSources:["National or state park","National park","Forest"]},{source:["Reservation label"],labelType:"majorPoi",minZoom:7,radius:15e3,polygonSources:["Reservation"]}],this._labelCache=new Set(["city","state","country","water","majorPoi"]),this._roadLayers=new Set(["Connecting road","Connecting road tunnel","International road","International road tunnel","Local road","Local road tunnel","Major local road","Major local road tunnel","Major road","Major road tunnel","Minor local road","Minor local road tunnel","Motorway","Motorway tunnel","Secondary road","Secondary road tunnel","Toll connecting road","Toll connecting road tunnel","Toll international road","Toll international road tunnel","Toll local road","Toll local road tunnel","Toll major local road","Toll major local road tunnel","Toll major road","Toll major road tunnel","Toll minor local road","Toll minor local road tunnel","Toll motorway","Toll motorway tunnel","Toll secondary road","Toll secondary road tunnel"]),this._returnDetailedDescriptions=!1,this._shortcutListener=function(n){return zf(i,void 0,void 0,function(){var t,o,r;return Kf(this,function(e){switch(e.label){case 0:return n.altKey&&n.ctrlKey&&68===n.keyCode?(this._returnDetailedDescriptions=!this._returnDetailedDescriptions,r=this._map.getCamera(),o=this._map.getStyle(),t=o.language.toLowerCase(),o=o.style.toLowerCase(),[4,this._getLocDesc(r,t,o)]):[3,2];case 1:r=e.sent(),this._descCallback(r),e.label=2;case 2:return[2]}})})},this._onRotate=function(){i._rotateTimeout||(Date.now()-i._lastHeadingTime>=i._headUpdateLimit?i._rotateTimeout=setTimeout(i._updateHeading,co.RotationDuration+25):i._rotateTimeout=setTimeout(i._updateHeading,i._headUpdateLimit-(Date.now()-i._lastHeadingTime)))},this._onMove=function(){i._moveTimeout&&(clearTimeout(i._moveTimeout),delete i._moveTimeout),i._controlTimeout&&(clearTimeout(i._controlTimeout),delete i._controlTimeout)},this._onMoveEnd=function(e){e.fromControl?i._controlTimeout=setTimeout(i._updateCam,i._controlEventDelay):i._updateCam()},this._onStyleData=function(){setTimeout(i._updateStyle)},this._onPointerDown=function(e){i._lastPointerPos=i._getEventPos(e),i._pointerTimeout=setTimeout(function(){return zf(i,void 0,void 0,function(){var t,o,r;return Kf(this,function(e){switch(e.label){case 0:return o=this._map.getStyle(),t=o.language.toLowerCase(),o=o.style.toLowerCase(),(r=this._map.getCamera()).center=this._map.pixelsToPositions([this._lastPointerPos])[0],[4,this._getLocDesc(r,t,o)];case 1:return r=e.sent(),this._descCallback(r),this._onPointerUp(),[2]}})})},i._pointerUpdateDelay),i._map.getCanvas().addEventListener("mousemove",i._onPointerMove),i._map.getCanvas().addEventListener("touchmove",i._onPointerMove),i._map.getCanvas().addEventListener("mouseup",i._onPointerUp),i._map.getCanvas().addEventListener("touchend",i._onPointerUp)},this._onPointerMove=function(e){var e=i._getEventPos(e),t=i._lastPointerPos[0]-e[0],e=i._lastPointerPos[1]-e[1];Math.sqrt(t*t+e*e)>i._moveThreshold&&i._onPointerUp()},this._onPointerUp=function(){clearTimeout(i._pointerTimeout),delete i._pointerTimeout,i._map.getCanvas().removeEventListener("mousemove",i._onPointerMove),i._map.getCanvas().removeEventListener("touchmove",i._onPointerMove),i._map.getCanvas().removeEventListener("mouseup",i._onPointerUp),i._map.getCanvas().removeEventListener("touchend",i._onPointerUp)},this._updateHeading=function(){var e,t=i._map.getCamera();i._lastHead&&!i._checkHeadingThreshold(t.bearing,i._lastHead)||(e=i._getHeadingDesc(t),i._lastHead=t.bearing,i._descCallback("<p>Map heading ".concat(e,".</p>")),i._lastHeadingTime=Date.now()),delete i._rotateTimeout},this._updateStyle=function(){return zf(i,void 0,void 0,function(){var t,o,r,n;return Kf(this,function(e){switch(e.label){case 0:return(t=this._map.getCamera(),r=this._map.getStyle(),o=r.language.toLowerCase(),r=r.style.toLowerCase(),this._lastLang===o)?[3,2]:(Zf._labelCache._preloadCache(o),[4,this._getLocDesc(t,o,r)]);case 1:return n=e.sent(),[3,4];case 2:return this._lastStyle===r||"blank"!==this._lastStyle?[3,4]:[4,this._getLocDesc(t,o,r)];case 3:n=e.sent(),e.label=4;case 4:return this._lastLang=o,this._lastStyle=r,n&&this._descCallback(n),[2]}})})},this._updateCam=function(e){void 0===e&&(e=!1);var o,r,t,n=i._map.getCamera();(!i._lastCam||0<i._actionQueue.length||i._checkThresholds(n,i._lastCam))&&(t=i._map.getStyle(),o=t.language.toLowerCase(),r=t.style.toLowerCase(),(t=i._getActionDesc(n))&&i._actionQueue.push(t),i._lastCam=n,i._moveTimeout&&(clearTimeout(i._moveTimeout),delete i._moveTimeout),i._moveTimeout=setTimeout(function(){return zf(i,void 0,void 0,function(){var t;return Kf(this,function(e){switch(e.label){case 0:return clearTimeout(this._rotateTimeout),delete this._rotateTimeout,[4,this._getLocDesc(n,o,r)];case 1:return t=e.sent(),0<this._actionQueue.length?(this._descCallback("<p>Map ".concat(this._actionQueue.join(", then "),".</p>").concat(t)),this._actionQueue=[]):this._descCallback(t),[2]}})})},e?0:i._camUpdateDelay))},this._map=e,this._restFallback=e.getServiceOptions().enableAccessibilityLocationFallback,this._descCallback=t,this._reverseSearch=new jf(e),Zf._labelCache||(Zf._labelCache=new Bf),this._lastLang=this._map.getStyle().language.toLowerCase(),Zf._labelCache._preloadCache(this._lastLang),this._map.events.addOnce("idle",function(){var e;i._disposed||(i._updateCam(!0),i._baseVectorTileSourceId=Zf._baseVectorTileSourceIds.find(function(e){return i._map.sources.getById(e)}),"bing-mvt"===i._baseVectorTileSourceId&&(i._labelConfig=Zf._labelConfigBing,i._roadLayers=Zf._roadLayersBing),i._polygonStyleLayer=i._labelConfig.reduce(function(e,t){return t.polygonSources&&e.push.apply(e,Yf([],Gf(t.polygonSources),!1)),e},[]),(e=i._map._getMap()).on("move",i._onMove),e.on("moveend",i._onMoveEnd),e.on("styledata",i._onStyleData),e.on("rotate",i._onRotate),(e=i._map.getCanvas()).addEventListener("mousedown",i._onPointerDown),e.addEventListener("touchstart",i._onPointerDown))}),this._map.getMapContainer().addEventListener("keydown",this._shortcutListener)}var Qf,Vf,Jf,Xf=function(e){var o=this;this.addToMap=function(){null==o.mapViewDesc&&(o.initializeMapLiveStateInfo(),o.initializeMapStyleInfo(),o.createMapKeyBindingInfo(),o.map.getMapContainer().setAttribute("role","application"),o.map.getMapContainer().setAttribute("aria-label","Map Application"),o.map.getCanvasContainer().setAttribute("aria-live","polite"),o.map.getCanvasContainer().setAttribute("aria-describedby","atlas-map-state atlas-map-style"),o.map.getCanvas().setAttribute("aria-label","Interactive Map"),o.map.getCanvas().setAttribute("aria-describedby","atlas-map-shortcuts"),o.map.getCanvas().setAttribute("alt","Interactive Map"))},this.removeFromMap=function(){null!=o.mapViewDesc&&o.mapViewDesc.dispose(),delete o.mapViewDesc,null!=o.atlasMapKeyBindings&&o.map.getCanvasContainer().removeChild(o.atlasMapKeyBindings),delete o.atlasMapKeyBindings,null!=o.atlasMapLiveStateInfo&&o.map.getCanvasContainer().removeChild(o.atlasMapLiveStateInfo),delete o.atlasMapLiveStateInfo,null!=o.atlasMapStyleInfo&&o.map.getCanvasContainer().removeChild(o.atlasMapStyleInfo),delete o.atlasMapStyleInfo,o.map.getMapContainer().removeAttribute("role"),o.map.getMapContainer().removeAttribute("aria-label"),o.map.getCanvasContainer().removeAttribute("aria-live"),o.map.getCanvasContainer().removeAttribute("aria-describedby"),o.map.getCanvas().removeAttribute("aria-label"),o.map.getCanvas().removeAttribute("aria-describedby"),o.map.getCanvas().removeAttribute("alt"),o.map.events.remove("stylechanged",o.updateMapStyle)},this.createMapKeyBindingInfo=function(){o.atlasMapKeyBindings=document.createElement("div"),o.atlasMapKeyBindings.setAttribute("tabindex","-1"),o.atlasMapKeyBindings.setAttribute("aria-hidden","true"),o.atlasMapKeyBindings.id="atlas-map-shortcuts",o.atlasMapKeyBindings.classList.add("hidden-accessible-element"),o.atlasMapKeyBindings.innerHTML=["Map shortcuts:","Zoom out: hyphen.","Zoom in: plus.","Pan right 100 pixels: right arrow.","Pan left 100 pixels: left arrow.","Pan up 100 pixels: up arrow.","Pan down 100 pixels: down arrow.","Rotate 15 degrees clockwise: shift + right arrow.","Rotate 15 degrees counter clockwise: shift + left arrow.","Increase pitch 10 degrees: shift + up arrow.","Decrease pitch 10 degrees: shift + down arrow.","Jump focus to the map: Escape."].join("\n"),o.map.getCanvasContainer().appendChild(o.atlasMapKeyBindings);var e=[189,187,38,37,39,40],t=o.map._getMap()._canvas;null!=t&&t.addEventListener("keyup",function(t){e.find(function(e){return t.keyCode===e})&&(o.atlasMapKeyBindings.innerHTML="")})},this.initializeMapLiveStateInfo=function(){o.mapViewDesc=new Wf(o.map,o.updateMapState),o.atlasMapLiveStateInfo=document.createElement("div"),o.atlasMapLiveStateInfo.setAttribute("tabindex","-1"),o.atlasMapLiveStateInfo.setAttribute("aria-hidden","true"),o.atlasMapLiveStateInfo.id="atlas-map-state",o.atlasMapLiveStateInfo.classList.add("hidden-accessible-element"),o.map.getCanvasContainer().appendChild(o.atlasMapLiveStateInfo)},this.initializeMapStyleInfo=function(){o.atlasMapStyleInfo=document.createElement("div"),o.atlasMapStyleInfo.setAttribute("tabindex","-1"),o.atlasMapStyleInfo.setAttribute("aria-hidden","true"),o.atlasMapStyleInfo.id="atlas-map-style",o.atlasMapStyleInfo.classList.add("hidden-accessible-element"),o.map.events.add("stylechanged",o.updateMapStyle),o.map.getCanvasContainer().appendChild(o.atlasMapStyleInfo)},this.updateMapStyle=function(){o.atlasMapStyleInfo.innerHTML="<p>Map style: ".concat(o.map.getStyle().style,".</p>")},this.updateMapState=function(e){o.atlasMapLiveStateInfo.innerHTML=e},this.map=e},$f=function(e){var o=this;this.listenerEnabled=!1,this.lastFlowMode="none",this.addToMap=function(){if(!o.map._isReady())throw new Error("Traffic flow could not be added to the map because the map is not ready. Please use a ready event listener to guarantee the map is ready before enabling traffic flow.");o.listenerEnabled||(o.map.events.add("styledata",o.addToMap),o.listenerEnabled=!0);var e,t=o.map.getTraffic();"none"!==t.flow&&(e=o.map.layers.getLayerById("traffic_".concat(t.flow)))&&(o.lastFlowMode=t.flow,e._updateLayoutProperty("visibility","visible","none"))},this.removeFromMap=function(){var e;o.map.getTraffic(),"none"!=o.lastFlowMode&&((e=o.map.layers.getLayerById("traffic_".concat(o.lastFlowMode)))&&e._updateLayoutProperty("visibility","none","visible"),o.lastFlowMode="none"),o.listenerEnabled&&(o.map.events.remove("styledata",o.addToMap),o.listenerEnabled=!1)},this.map=e},eg=((window&&window.__extends||(Qf=function(e,t){return(Qf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}Qf(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(tg,Vf=$c),tg.getIncidentTypeName=function(e,t){switch(e){case 0:return t.Unknown;case 1:return t.Accident;case 2:return t.Fog;case 3:return t.Danger;case 4:return t.Rain;case 5:return t.Ice;case 6:return t.Jam;case 7:return t.LaneClosed;case 8:return t.RoadClosed;case 9:return t.RoadWorks;case 10:return t.Wind;case 11:return t.Flood;case 12:return t.Detour;default:return t.Unknown}},tg.getIncidentTypeIconName=function(e){switch(e){case 0:return"unknown";case 1:return"accident";case 2:return"fog";case 3:return"danger";case 4:return"rain";case 5:return"ice";case 6:return"jam";case 7:return"lane-closed";case 8:return"road-closed";case 9:return"road-work";case 10:return"wind";case 11:return"flood";case 12:return"detour";default:return"unknown"}},tg.getSeverityColorName=function(e){switch(e){case 0:return"grey";case 1:return"yellow";case 2:return"orange";case 3:return"red";default:return"grey"}},tg.getSeverityColorHexCode=function(e){switch(e){case 0:return"#B5B6B7";case 1:return"#F4C951";case 2:return"#F4873F";case 3:return"#F04F4E";default:return"#B5B6B7"}},tg);function tg(e,t,o){var r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=null!=(r=e.icon_category_12)?r:e.icon_category_11)?r:e.icon_category_10)?r:e.icon_category_9)?r:e.icon_category_8)?r:e.icon_category_7)?r:e.icon_category_6)?r:e.icon_category_5)?r:e.icon_category_4)?r:e.icon_category_3)?r:e.icon_category_2)?r:e.icon_category_1)?r:e.icon_category_0)?r:e.icon_category,n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=e.description_12)?n:e.description_11)?n:e.description_10)?n:e.description_9)?n:e.description_8)?n:e.description_7)?n:e.description_6)?n:e.description_5)?n:e.description_4)?n:e.description_3)?n:e.description_2)?n:e.description_1)?n:e.description_0)?n:e.description,r={icon:"".concat(tg.getSeverityColorName(e.magnitude),"-").concat(tg.getIncidentTypeIconName(r)),incidentType:tg.getIncidentTypeName(r,o),description:n,delay:e.delay,color:tg.getSeverityColorHexCode(e.magnitude),id:e.id};return Vf.call(this,t,r)||this}(n=Jf=Jf||{}).DELAY="delay",n.LENGTH="length",n.FROM="from",n.TO="to";rg.build=function(e,t){void 0===t&&(t="en-US");var o,r=document.createElement("div"),n=(r.classList.add("incident-popup-title"),r.classList.add("font-segoeui-b"),r.innerText=e.properties.incidentType,r.setAttribute("aria-label","Incident Type ".concat(e.properties.incidentType)),document.createElement("div")),i=(n.classList.add("incident-popup-subtitle"),n.classList.add("font-segoeui-b"),n.setAttribute("aria-label","Incident Description ".concat(e.properties.description)),n.innerText=e.properties.description,document.createElement("div")),r=(i.classList.add("incident-popup-header"),i.style.backgroundColor=e.properties.color,i.appendChild(r),i.appendChild(n),document.createElement("div")),n=(r.classList.add("incident-popup-body"),e.properties.delay&&(n="".concat(Math.floor(e.properties.delay/60)," min"),n=this.createInfoSection(n,Jf.DELAY),r.appendChild(n)),e.properties.length&&(n=new Intl.NumberFormat([t,"en-US"],{maximumFractionDigits:2}),o=void 0,o="en-US"===t?(t=Mu(e.properties.length,"meters","miles"),"".concat(n.format(t)," miles")):(t=Mu(e.properties.length,"meters","kilometers"),"".concat(n.format(t)," km")),n=this.createInfoSection(o,Jf.LENGTH),r.appendChild(n)),e.properties.from&&(t=this.createInfoSection(e.properties.from,Jf.FROM),r.appendChild(t)),e.properties.to&&(o=this.createInfoSection(e.properties.to,Jf.TO),r.appendChild(o)),document.createElement("div"));return n.classList.add("incident-popup-content"),n.appendChild(i),n.appendChild(r),new cf({content:n,position:e.geometry.coordinates})},rg.createInfoSection=function(e,t){var o=document.createElement("div"),r=(o.classList.add("incident-popup-info"),document.createElement("div")),n=(r.classList.add("icon"),r.classList.add(t),document.createElement("span"));return n.classList.add("message"),n.classList.add("font-segoeui"),n.setAttribute("aria-label","Incident ".concat(t," ").concat(e)),n.innerText=e,o.appendChild(r),o.appendChild(n),o};var og=rg;function rg(){}var ng=window&&window.__awaiter||function(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})},ig=window&&window.__generator||function(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},u={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function e(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c=u&&t[u=0]?0:c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},ag=(sg.prototype.getIncidentIconImageExpression=function(){return["concat",["let","magnitude",["get","magnitude"],["case",["==",["var","magnitude"],0],"grey",["==",["var","magnitude"],1],"yellow",["==",["var","magnitude"],2],"orange",["==",["var","magnitude"],3],"red",["==",["var","magnitude"],4],"grey","grey"]],"-",["let","category",["coalesce",["get","icon_category_12"],["get","icon_category_11"],["get","icon_category_10"],["get","icon_category_9"],["get","icon_category_8"],["get","icon_category_7"],["get","icon_category_6"],["get","icon_category_5"],["get","icon_category_4"],["get","icon_category_3"],["get","icon_category_2"],["get","icon_category_0"],["get","icon_category"],0],["case",["==",["var","category"],0],"unknown",["==",["var","category"],1],"accident",["==",["var","category"],2],"fog",["==",["var","category"],3],"danger",["==",["var","category"],4],"rain",["==",["var","category"],5],"ice",["==",["var","category"],6],"jam",["==",["var","category"],7],"lane-closed",["==",["var","category"],8],"road-closed",["==",["var","category"],9],"road-work",["==",["var","category"],10],"wind",["==",["var","category"],11],"flood",["==",["var","category"],12],"detour","unknown"]]]},sg);function sg(e){var n=this,e=(this.incidentLayerName="incidents",this.incidentSourceName="mapcontrol_traffic_incident",this.addToMap=function(){n.map.sources.getById(n.incidentSourceName)||n.map.sources.add(n.vectorTileSource),n.map.layers.getLayerById(n.incidentLayerName)||n.map.layers.add(n.incidentLayer,"labels"),n.clickPopup=new cf({position:[0,0],pixelOffset:[0,-18]}),n.map.addEventListener("mouseover",n.incidentLayerName,n.cursorToPointer),n.map.addEventListener("mouseleave",n.incidentLayerName,n.cursorToDefault),n.map.addEventListener("click",n.incidentLayerName,n.openIncidentPopup),n.map.events.addOnce("idle",n.setAccessiblePopups),n.map.events.add("moveend",n.setAccessiblePopups)},this.accessiblePopups=[],this.setAccessiblePopups=function(){return ng(n,void 0,void 0,function(){var t,i,a,s,c,u,l=this;return ig(this,function(e){switch(e.label){case 0:return this.accessiblePopups.forEach(function(e){return e.remove()}),this.accessiblePopups=[],t=this.map.layers.getRenderedShapes(this.map.getCamera().bounds,this.incidentLayer),[4,this.map._getLocalizedStrings()];case 1:return i=e.sent(),a=function(t,o){var e=t[o],r=e.geometry.coordinates,r=new iu(new hl(r[0],r[1])),e=new eg(e.properties,r,i),n=og.build(e,l.incidentLanguage),r=n.getPopupContainer();return r.addEventListener("focusin",function(e){l.clickPopup.remove(),l.accessiblePopups.filter(function(e){return e!==n}).forEach(function(e){return e.remove()}),0<=o-1&&s(n,a(t,o-1)),o+1<t.length&&u(a(t,o+1)),2<=o&&o==t.length-1&&c(a(t,0)),0==o&&2<=t.length&&u(a(t,t.length-1))}),o==t.length-1&&r.addEventListener("focusout",function(e){null===e.relatedTarget&&n.close()}),l.accessiblePopups.push(n),n},s=function(e,t){t.open(l.map),t.close();t=t.getPopupContainer(),e=e.getPopupContainer();e.parentElement.insertBefore(t,e)},c=function(e){e.open(l.map),e.close();var e=e.getPopupContainer(),t=e.parentElement;t.insertBefore(e,t.firstElementChild)},u=function(e){e.open(l.map),e.close()},0<t.length&&u(a(t,0)),1<t.length&&u(a(t,t.length-1)),[2]}})})},this.removeFromMap=function(){var e;n.map.removeEventListener("mouseover",n.incidentLayerName,n.cursorToPointer),n.map.removeEventListener("mouseleave",n.incidentLayerName,n.cursorToDefault),n.map.removeEventListener("click",n.incidentLayerName,n.openIncidentPopup),n.map.events.remove("idle",n.setAccessiblePopups),n.map.events.remove("moveend",n.setAccessiblePopups),n.accessiblePopups.forEach(function(e){return e.remove()}),n.accessiblePopups=[],null!=(e=n.clickPopup)&&e.remove(),null!=n.map.layers.getLayerById(n.incidentLayerName)&&n.map.layers.remove(n.incidentLayerName),null!=n.map.sources.getById(n.incidentSourceName)&&n.map.sources.remove(n.incidentSourceName)},this.cursorToPointer=function(e){n.map.getCanvas().style.cursor="pointer"},this.cursorToDefault=function(e){n.map.getCanvas().style.cursor=""},this.openIncidentPopup=function(e){n.clickPopup.remove(),n.accessiblePopups.forEach(function(e){return e.close()});var o=e.position,r=e.features[0];n.map._getLocalizedStrings().then(function(e){var t=new iu(new hl(o[0],o[1])),t=new eg(r.properties,t,e);n.clickPopup=og.build(t,n.incidentLanguage),n.clickPopup.open(n.map),n.clickPopup.getPopupContainer().addEventListener("focusout",function(e){null===e.relatedTarget&&n.clickPopup.close()})})},this.map=e,this.vectorTileSource=new Sh(this.incidentSourceName,{maxZoom:22,tiles:["https://".concat(te,"/traffic/incident/tile/pbf?api-version=1.0&zoom={z}&x={x}&y={y}")]}),this.getIncidentIconImageExpression());this.incidentLayer=new Ep(this.incidentSourceName,this.incidentLayerName,{sourceLayer:"Traffic incident POI",iconOptions:{ignorePlacement:!0,allowOverlap:!0,image:e,size:.75}})}(window&&window.__extends||(cg=function(e,t){return(cg=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}cg(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(hg,ug=ye);var cg,ug,lg=hg;function hg(){var e=null!==ug&&ug.apply(this,arguments)||this;return e.interactive=!0,e.scrollZoomInteraction=!0,e.boxZoomInteraction=!0,e.dragRotateInteraction=!0,e.dragPanInteraction=!0,e.keyboardInteraction=!0,e.dblClickZoomInteraction=!0,e.touchInteraction=!0,e.touchRotate=!0,e.wheelZoomRate=1/450,e}pg.prototype.enable=function(){this.map.getMapContainer().addEventListener("keydown",this._onKeyDown)},pg.prototype.disable=function(){this.map.getMapContainer().removeEventListener("keydown",this._onKeyDown)};var dg=pg;function pg(e){var t=this;this._onKeyDown=function(e){27===e.keyCode&&t.map.getCanvas().focus()},this.map=e}gg.prototype.enable=function(){this.map.getCanvasContainer().addEventListener("gesturestart",this._onGestureStart),this.map.getCanvasContainer().addEventListener("gesturechange",this._onGestureChange),this.map.getCanvasContainer().addEventListener("touchstart",this._onTouchStart),this.map.getCanvasContainer().addEventListener("touchend",this._onTouchEnd)},gg.prototype.disable=function(){this.map.getCanvasContainer().removeEventListener("gesturestart",this._onGestureStart),this.map.getCanvasContainer().removeEventListener("gesturechange",this._onGestureChange),this.map.getCanvasContainer().removeEventListener("touchstart",this._onTouchStart),this.map.getCanvasContainer().removeEventListener("touchend",this._onTouchEnd)};var fg=gg;function gg(e){var t=this;this._onGestureStart=function(e){t.hasTouch||(e.preventDefault(),t.initZoom=t.map.getCamera().zoom)},this._onGestureChange=function(e){t.hasTouch||(e.preventDefault(),t.map.setCamera({zoom:t.initZoom+e.scale-1}))},this._onTouchStart=function(e){t.hasTouch=!0},this._onTouchEnd=function(e){0===e.touches.length&&(t.hasTouch=!1)},this.map=e}yg.prototype.addToMap=function(){this.added||(this.added=!0,this._setInteractions(this.options))},yg.prototype.removeFromMap=function(){this.added&&(this.added=!1,this._setInteractions({interactive:!1}))},yg.prototype.setOptions=function(e){this.options=(new lg).merge(this.options,e),this.added&&this._setInteractions(this.options)},yg.prototype.getOptions=function(){return Object.assign({},this.options)},yg.prototype._setInteractions=function(e){var t;e.interactive?(e.boxZoomInteraction?this.map._getMap().boxZoom.enable():this.map._getMap().boxZoom.disable(),e.dblClickZoomInteraction?this.map._getMap().doubleClickZoom.enable():this.map._getMap().doubleClickZoom.disable(),e.dragPanInteraction?this.map._getMap().dragPan.enable():this.map._getMap().dragPan.disable(),e.dragRotateInteraction?this.map._getMap().dragRotate.enable():this.map._getMap().dragRotate.disable(),e.keyboardInteraction?(this.map._getMap().keyboard.enable(),this.focusShortcut.enable()):(this.map._getMap().keyboard.disable(),this.focusShortcut.disable()),e.scrollZoomInteraction?(this.map._getMap().scrollZoom.enable(),this.map._getMap().scrollZoom.setWheelZoomRate(e.wheelZoomRate)):this.map._getMap().scrollZoom.disable(),t=this.map._getMap().touchZoomRotate,e.touchInteraction?(t.enable(),e.touchRotate?t.enableRotation():t.disableRotation()):t.disable(),this.pinchZoom.enable()):(this.map._getMap().boxZoom.disable(),this.map._getMap().doubleClickZoom.disable(),this.map._getMap().dragPan.disable(),this.map._getMap().dragRotate.disable(),this.map._getMap().keyboard.disable(),this.focusShortcut.disable(),this.map._getMap().scrollZoom.disable(),this.map._getMap().touchZoomRotate.disable(),this.pinchZoom.disable())};var mg=yg;function yg(e,t){this.added=!1,this.map=e,this.focusShortcut=new dg(e),this.pinchZoom=new fg(e),this.options=(new lg).merge(t)}function vg(e,t,o){var r={type:"Feature"};return 0!==(o=void 0===o?{}:o).id&&!o.id||(r.id=o.id),o.bbox&&(r.bbox=o.bbox),r.properties=t||{},r.geometry=e,r}function _g(e){return"Feature"===e.type?e.geometry:e}var wg=q(function(){function u(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function r(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(e,r.key,r)}}function a(e,t,o){if(t)r(e.prototype,t);if(o)r(e,o);return e}var l=function(){function e(e,t){this.next=null;this.key=e;this.data=t;this.left=null;this.right=null}return e}();function t(e,t){return e>t?1:e<t?-1:0}function s(e,t,o){var r=new l(null,null);var n=r;var i=r;while(true){var a=o(e,t.key);if(a<0){if(t.left===null)break;if(o(e,t.left.key)<0){var s=t.left;t.left=s.right;s.right=t;t=s;if(t.left===null)break}i.left=t;i=t;t=t.left}else if(a>0){if(t.right===null)break;if(o(e,t.right.key)>0){var s=t.right;t.right=s.left;s.left=t;t=s;if(t.right===null)break}n.right=t;n=t;t=t.right}else break}n.right=t.left;i.left=t.right;t.left=r.right;t.right=r.left;return t}function c(e,t,o,r){var n=new l(e,t);if(o===null){n.left=n.right=null;return n}o=s(e,o,r);var i=r(e,o.key);if(i<0){n.left=o.left;n.right=o;o.left=null}else if(i>=0){n.right=o.right;n.left=o;o.right=null}return n}function h(e,t,o){var r=null;var n=null;if(t){t=s(e,t,o);var i=o(t.key,e);if(i===0){r=t.left;n=t.right}else if(i<0){n=t.right;t.right=null;r=t}else{r=t.left;t.left=null;n=t}}return{left:r,right:n}}function d(e,t,o){if(t===null)return e;if(e===null)return t;t=s(e.key,t,o);t.left=e;return t}function p(e,t,o,r,n){if(e){r(""+t+(o?"└── ":"├── ")+n(e)+"\n");var i=t+(o?"    ":"│   ");if(e.left)p(e.left,i,false,r,n);if(e.right)p(e.right,i,true,r,n)}}var R=function(){function e(e){if(e===void 0)e=t;this._root=null;this._size=0;this._comparator=e}e.prototype.insert=function(e,t){this._size++;return this._root=c(e,t,this._root,this._comparator)};e.prototype.add=function(e,t){var o=new l(e,t);if(this._root===null){o.left=o.right=null;this._size++;this._root=o}var r=this._comparator;var n=s(e,this._root,r);var i=r(e,n.key);if(i===0)this._root=n;else{if(i<0){o.left=n.left;o.right=n;n.left=null}else if(i>0){o.right=n.right;o.left=n;n.right=null}this._size++;this._root=o}return this._root};e.prototype.remove=function(e){this._root=this._remove(e,this._root,this._comparator)};e.prototype._remove=function(e,t,o){var r;if(t===null)return null;t=s(e,t,o);var n=o(e,t.key);if(n===0){if(t.left===null)r=t.right;else{r=s(e,t.left,o);r.right=t.right}this._size--;return r}return t};e.prototype.pop=function(){var e=this._root;if(e){while(e.left)e=e.left;this._root=s(e.key,this._root,this._comparator);this._root=this._remove(e.key,this._root,this._comparator);return{key:e.key,data:e.data}}return null};e.prototype.findStatic=function(e){var t=this._root;var o=this._comparator;while(t){var r=o(e,t.key);if(r===0)return t;else if(r<0)t=t.left;else t=t.right}return null};e.prototype.find=function(e){if(this._root){this._root=s(e,this._root,this._comparator);if(this._comparator(e,this._root.key)!==0)return null}return this._root};e.prototype.contains=function(e){var t=this._root;var o=this._comparator;while(t){var r=o(e,t.key);if(r===0)return true;else if(r<0)t=t.left;else t=t.right}return false};e.prototype.forEach=function(e,t){var o=this._root;var r=[];var n=false;while(!n)if(o!==null){r.push(o);o=o.left}else if(r.length!==0){o=r.pop();e.call(t,o);o=o.right}else n=true;return this};e.prototype.range=function(e,t,o,r){var n=[];var i=this._comparator;var a=this._root;var s;while(n.length!==0||a)if(a){n.push(a);a=a.left}else{a=n.pop();s=i(a.key,t);if(s>0)break;else if(i(a.key,e)>=0)if(o.call(r,a))return this;a=a.right}return this};e.prototype.keys=function(){var o=[];this.forEach(function(e){var t=e.key;return o.push(t)});return o};e.prototype.values=function(){var o=[];this.forEach(function(e){var t=e.data;return o.push(t)});return o};e.prototype.min=function(){if(this._root)return this.minNode(this._root).key;return null};e.prototype.max=function(){if(this._root)return this.maxNode(this._root).key;return null};e.prototype.minNode=function(e){if(e===void 0)e=this._root;if(e)while(e.left)e=e.left;return e};e.prototype.maxNode=function(e){if(e===void 0)e=this._root;if(e)while(e.right)e=e.right;return e};e.prototype.at=function(e){var t=this._root;var o=false;var r=0;var n=[];while(!o)if(t){n.push(t);t=t.left}else if(n.length>0){t=n.pop();if(r===e)return t;r++;t=t.right}else o=true;return null};e.prototype.next=function(e){var t=this._root;var o=null;if(e.right){o=e.right;while(o.left)o=o.left;return o}var r=this._comparator;while(t){var n=r(e.key,t.key);if(n===0)break;else if(n<0){o=t;t=t.left}else t=t.right}return o};e.prototype.prev=function(e){var t=this._root;var o=null;if(e.left!==null){o=e.left;while(o.right)o=o.right;return o}var r=this._comparator;while(t){var n=r(e.key,t.key);if(n===0)break;else if(n<0)t=t.left;else{o=t;t=t.right}}return o};e.prototype.clear=function(){this._root=null;this._size=0;return this};e.prototype.toList=function(){return o(this._root)};e.prototype.load=function(e,t,o){if(t===void 0)t=[];if(o===void 0)o=false;var r=e.length;var n=this._comparator;if(o)v(e,t,0,r-1,n);if(this._root===null){this._root=f(e,t,0,r);this._size=r}else{var i=y(this.toList(),g(e,t),n);r=this._size+r;this._root=m({head:i},0,r)}return this};e.prototype.isEmpty=function(){return this._root===null};Object.defineProperty(e.prototype,"size",{get:function e(){return this._size},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"root",{get:function e(){return this._root},enumerable:true,configurable:true});e.prototype.toString=function(e){if(e===void 0)e=function e(t){return String(t.key)};var t=[];p(this._root,"",true,function(e){return t.push(e)},e);return t.join("")};e.prototype.update=function(e,t,o){var r=this._comparator;var n=h(e,this._root,r),i=n.left,a=n.right;if(r(e,t)<0)a=c(t,o,a,r);else i=c(t,o,i,r);this._root=d(i,a,r)};e.prototype.split=function(e){return h(e,this._root,this._comparator)};return e}();function f(e,t,o,r){var n=r-o;if(n>0){var i=o+Math.floor(n/2);var a=e[i];var s=t[i];var c=new l(a,s);c.left=f(e,t,o,i);c.right=f(e,t,i+1,r);return c}return null}function g(e,t){var o=new l(null,null);var r=o;for(var n=0;n<e.length;n++)r=r.next=new l(e[n],t[n]);r.next=null;return o.next}function o(e){var t=e;var o=[];var r=false;var n=new l(null,null);var i=n;while(!r)if(t){o.push(t);t=t.left}else if(o.length>0){t=i=i.next=o.pop();t=t.right}else r=true;i.next=null;return n.next}function m(e,t,o){var r=o-t;if(r>0){var n=t+Math.floor(r/2);var i=m(e,t,n);var a=e.head;a.left=i;e.head=e.head.next;a.right=m(e,n+1,o);return a}return null}function y(e,t,o){var r=new l(null,null);var n=r;var i=e;var a=t;while(i!==null&&a!==null){if(o(i.key,a.key)<0){n.next=i;i=i.next}else{n.next=a;a=a.next}n=n.next}if(i!==null)n.next=i;else if(a!==null)n.next=a;return r.next}function v(e,t,o,r,n){if(o>=r)return;var i=e[o+r>>1];var a=o-1;var s=r+1;while(true){do{a++}while(n(e[a],i)<0);do{s--}while(n(e[s],i)>0);if(a>=s)break;var c=e[a];e[a]=e[s];e[s]=c;c=t[a];t[a]=t[s];t[s]=c}v(e,t,o,s,n);v(e,t,s+1,r,n)}var _=function e(t,o){return t.ll.x<=o.x&&o.x<=t.ur.x&&t.ll.y<=o.y&&o.y<=t.ur.y},x=function e(t,o){if(o.ur.x<t.ll.x||t.ur.x<o.ll.x||o.ur.y<t.ll.y||t.ur.y<o.ll.y)return null;var r=t.ll.x<o.ll.x?o.ll.x:t.ll.x;var n=t.ur.x<o.ur.x?t.ur.x:o.ur.x;var i=t.ll.y<o.ll.y?o.ll.y:t.ll.y;var a=t.ur.y<o.ur.y?t.ur.y:o.ur.y;return{ll:{x:r,y:i},ur:{x:n,y:a}}},n=Number.EPSILON;if(n===undefined)n=Math.pow(2,-52);var O=n*n,w=function e(t,o){if(-n<t&&t<n)if(-n<o&&o<n)return 0;var r=t-o;if(r*r<O*t*o)return 0;return t<o?-1:1},e=function(){function e(){u(this,e);this.reset()}a(e,[{key:"reset",value:function e(){this.xRounder=new i;this.yRounder=new i}},{key:"round",value:function e(t,o){return{x:this.xRounder.round(t),y:this.yRounder.round(o)}}}]);return e}(),i=function(){function e(){u(this,e);this.tree=new R;this.round(0)}a(e,[{key:"round",value:function e(t){var o=this.tree.add(t);var r=this.tree.prev(o);if(r!==null&&w(o.key,r.key)===0){this.tree.remove(t);return r.key}var n=this.tree.next(o);if(n!==null&&w(o.key,n.key)===0){this.tree.remove(t);return n.key}return t}}]);return e}(),M=new e,b=function e(t,o){return t.x*o.y-t.y*o.x},C=function e(t,o){return t.x*o.x+t.y*o.y},S=function e(t,o,r){var n={x:o.x-t.x,y:o.y-t.y};var i={x:r.x-t.x,y:r.y-t.y};var a=b(n,i);return w(a,0)},E=function e(t){return Math.sqrt(C(t,t))},U=function e(t,o,r){var n={x:o.x-t.x,y:o.y-t.y};var i={x:r.x-t.x,y:r.y-t.y};return b(i,n)/E(i)/E(n)},j=function e(t,o,r){var n={x:o.x-t.x,y:o.y-t.y};var i={x:r.x-t.x,y:r.y-t.y};return C(i,n)/E(i)/E(n)},T=function e(t,o,r){if(o.y===0)return null;return{x:t.x+o.x/o.y*(r-t.y),y:r}},I=function e(t,o,r){if(o.x===0)return null;return{x:r,y:t.y+o.y/o.x*(r-t.x)}},H=function e(t,o,r,n){if(o.x===0)return I(r,n,t.x);if(n.x===0)return I(t,o,r.x);if(o.y===0)return T(r,n,t.y);if(n.y===0)return T(t,o,r.y);var i=b(o,n);if(i==0)return null;var a={x:r.x-t.x,y:r.y-t.y};var s=b(a,o)/i;var c=b(a,n)/i;var u=t.x+c*o.x,l=r.x+s*n.x;var h=t.y+c*o.y,d=r.y+s*n.y;var p=(u+l)/2;var f=(h+d)/2;return{x:p,y:f}},N=function(){a(n,null,[{key:"compare",value:function e(t,o){var r=n.comparePoints(t.point,o.point);if(r!==0)return r;if(t.point!==o.point)t.link(o);if(t.isLeft!==o.isLeft)return t.isLeft?1:-1;return k.compare(t.segment,o.segment)}},{key:"comparePoints",value:function e(t,o){if(t.x<o.x)return-1;if(t.x>o.x)return 1;if(t.y<o.y)return-1;if(t.y>o.y)return 1;return 0}}]);function n(e,t){u(this,n);if(e.events===undefined)e.events=[this];else e.events.push(this);this.point=e;this.isLeft=t}a(n,[{key:"link",value:function e(t){if(t.point===this.point)throw new Error("Tried to link already linked events");var o=t.point.events;for(var r=0,n=o.length;r<n;r++){var i=o[r];this.point.events.push(i);i.point=this.point}this.checkForConsuming()}},{key:"checkForConsuming",value:function e(){var t=this.point.events.length;for(var o=0;o<t;o++){var r=this.point.events[o];if(r.segment.consumedBy!==undefined)continue;for(var n=o+1;n<t;n++){var i=this.point.events[n];if(i.consumedBy!==undefined)continue;if(r.otherSE.point.events!==i.otherSE.point.events)continue;r.segment.consume(i.segment)}}}},{key:"getAvailableLinkedEvents",value:function e(){var t=[];for(var o=0,r=this.point.events.length;o<r;o++){var n=this.point.events[o];if(n!==this&&!n.segment.ringOut&&n.segment.isInResult())t.push(n)}return t}},{key:"getLeftmostComparator",value:function e(r){var n=this;var c=new Map;var u=function e(t){var o=t.otherSE;c.set(t,{sine:U(n.point,r.point,o.point),cosine:j(n.point,r.point,o.point)})};return function(e,t){if(!c.has(e))u(e);if(!c.has(t))u(t);var o=c.get(e),r=o.sine,n=o.cosine;var i=c.get(t),a=i.sine,s=i.cosine;if(r>=0&&a>=0){if(n<s)return 1;if(n>s)return-1;return 0}if(r<0&&a<0){if(n<s)return-1;if(n>s)return 1;return 0}if(a<r)return-1;if(a>r)return 1;return 0}}}]);return n}(),B=0,k=function(){a(d,null,[{key:"compare",value:function e(t,o){var r=t.leftSE.point.x;var n=o.leftSE.point.x;var i=t.rightSE.point.x;var a=o.rightSE.point.x;if(a<r)return 1;if(i<n)return-1;var s=t.leftSE.point.y;var c=o.leftSE.point.y;var u=t.rightSE.point.y;var l=o.rightSE.point.y;if(r<n){if(c<s&&c<u)return 1;if(c>s&&c>u)return-1;var h=t.comparePoint(o.leftSE.point);if(h<0)return 1;if(h>0)return-1;var d=o.comparePoint(t.rightSE.point);if(d!==0)return d;return-1}if(r>n){if(s<c&&s<l)return-1;if(s>c&&s>l)return 1;var p=o.comparePoint(t.leftSE.point);if(p!==0)return p;var f=t.comparePoint(o.rightSE.point);if(f<0)return 1;if(f>0)return-1;return 1}if(s<c)return-1;if(s>c)return 1;if(i<a){var g=o.comparePoint(t.rightSE.point);if(g!==0)return g}if(i>a){var m=t.comparePoint(o.rightSE.point);if(m<0)return 1;if(m>0)return-1}if(i!==a){var y=u-s;var v=i-r;var _=l-c;var w=a-n;if(y>v&&_<w)return 1;if(y<v&&_>w)return-1}if(i>a)return 1;if(i<a)return-1;if(u<l)return-1;if(u>l)return 1;if(t.id<o.id)return-1;if(t.id>o.id)return 1;return 0}}]);function d(e,t,o,r){u(this,d);this.id=++B;this.leftSE=e;e.segment=this;e.otherSE=t;this.rightSE=t;t.segment=this;t.otherSE=e;this.rings=o;this.windings=r}a(d,[{key:"replaceRightSE",value:function e(t){this.rightSE=t;this.rightSE.segment=this;this.rightSE.otherSE=this.leftSE;this.leftSE.otherSE=this.rightSE}},{key:"bbox",value:function e(){var t=this.leftSE.point.y;var o=this.rightSE.point.y;return{ll:{x:this.leftSE.point.x,y:t<o?t:o},ur:{x:this.rightSE.point.x,y:t>o?t:o}}}},{key:"vector",value:function e(){return{x:this.rightSE.point.x-this.leftSE.point.x,y:this.rightSE.point.y-this.leftSE.point.y}}},{key:"isAnEndpoint",value:function e(t){return t.x===this.leftSE.point.x&&t.y===this.leftSE.point.y||t.x===this.rightSE.point.x&&t.y===this.rightSE.point.y}},{key:"comparePoint",value:function e(t){if(this.isAnEndpoint(t))return 0;var o=this.leftSE.point;var r=this.rightSE.point;var n=this.vector();if(o.x===r.x){if(t.x===o.x)return 0;return t.x<o.x?1:-1}var i=(t.y-o.y)/n.y;var a=o.x+i*n.x;if(t.x===a)return 0;var s=(t.x-o.x)/n.x;var c=o.y+s*n.y;if(t.y===c)return 0;return t.y<c?-1:1}},{key:"getIntersection",value:function e(t){var o=this.bbox();var r=t.bbox();var n=x(o,r);if(n===null)return null;var i=this.leftSE.point;var a=this.rightSE.point;var s=t.leftSE.point;var c=t.rightSE.point;var u=_(o,s)&&this.comparePoint(s)===0;var l=_(r,i)&&t.comparePoint(i)===0;var h=_(o,c)&&this.comparePoint(c)===0;var d=_(r,a)&&t.comparePoint(a)===0;if(l&&u){if(d&&!h)return a;if(!d&&h)return c;return null}if(l){if(h)if(i.x===c.x&&i.y===c.y)return null;return i}if(u){if(d)if(a.x===s.x&&a.y===s.y)return null;return s}if(d&&h)return null;if(d)return a;if(h)return c;var p=H(i,this.vector(),s,t.vector());if(p===null)return null;if(!_(n,p))return null;return M.round(p.x,p.y)}},{key:"split",value:function e(t){var o=[];var r=t.events!==undefined;var n=new N(t,true);var i=new N(t,false);var a=this.rightSE;this.replaceRightSE(i);o.push(i);o.push(n);var s=new d(n,a,this.rings.slice(),this.windings.slice());if(N.comparePoints(s.leftSE.point,s.rightSE.point)>0)s.swapEvents();if(N.comparePoints(this.leftSE.point,this.rightSE.point)>0)this.swapEvents();if(r){n.checkForConsuming();i.checkForConsuming()}return o}},{key:"swapEvents",value:function e(){var t=this.rightSE;this.rightSE=this.leftSE;this.leftSE=t;this.leftSE.isLeft=true;this.rightSE.isLeft=false;for(var o=0,r=this.windings.length;o<r;o++)this.windings[o]*=-1}},{key:"consume",value:function e(t){var o=this;var r=t;while(o.consumedBy)o=o.consumedBy;while(r.consumedBy)r=r.consumedBy;var n=d.compare(o,r);if(n===0)return;if(n>0){var i=o;o=r;r=i}if(o.prev===r){var a=o;o=r;r=a}for(var s=0,c=r.rings.length;s<c;s++){var u=r.rings[s];var l=r.windings[s];var h=o.rings.indexOf(u);if(h===-1){o.rings.push(u);o.windings.push(l)}else o.windings[h]+=l}r.rings=null;r.windings=null;r.consumedBy=o;r.leftSE.consumedBy=o.leftSE;r.rightSE.consumedBy=o.rightSE}},{key:"prevInResult",value:function e(){if(this._prevInResult!==undefined)return this._prevInResult;if(!this.prev)this._prevInResult=null;else if(this.prev.isInResult())this._prevInResult=this.prev;else this._prevInResult=this.prev.prevInResult();return this._prevInResult}},{key:"beforeState",value:function e(){if(this._beforeState!==undefined)return this._beforeState;if(!this.prev)this._beforeState={rings:[],windings:[],multiPolys:[]};else{var t=this.prev.consumedBy||this.prev;this._beforeState=t.afterState()}return this._beforeState}},{key:"afterState",value:function e(){if(this._afterState!==undefined)return this._afterState;var t=this.beforeState();this._afterState={rings:t.rings.slice(0),windings:t.windings.slice(0),multiPolys:[]};var o=this._afterState.rings;var r=this._afterState.windings;var n=this._afterState.multiPolys;for(var i=0,a=this.rings.length;i<a;i++){var s=this.rings[i];var c=this.windings[i];var u=o.indexOf(s);if(u===-1){o.push(s);r.push(c)}else r[u]+=c}var l=[];var h=[];for(var d=0,p=o.length;d<p;d++){if(r[d]===0)continue;var f=o[d];var g=f.poly;if(h.indexOf(g)!==-1)continue;if(f.isExterior)l.push(g);else{if(h.indexOf(g)===-1)h.push(g);var m=l.indexOf(f.poly);if(m!==-1)l.splice(m,1)}}for(var y=0,v=l.length;y<v;y++){var _=l[y].multiPoly;if(n.indexOf(_)===-1)n.push(_)}return this._afterState}},{key:"isInResult",value:function e(){if(this.consumedBy)return false;if(this._isInResult!==undefined)return this._isInResult;var t=this.beforeState().multiPolys;var o=this.afterState().multiPolys;switch(q.type){case"union":{var r=t.length===0;var n=o.length===0;this._isInResult=r!==n;break}case"intersection":{var i;var a;if(t.length<o.length){i=t.length;a=o.length}else{i=o.length;a=t.length}this._isInResult=a===q.numMultiPolys&&i<a;break}case"xor":{var s=Math.abs(t.length-o.length);this._isInResult=s%2===1;break}case"difference":{var c=function e(t){return t.length===1&&t[0].isSubject};this._isInResult=c(t)!==c(o);break}default:throw new Error("Unrecognized operation type found ".concat(q.type))}return this._isInResult}}],[{key:"fromRing",value:function e(t,o,r){var n,i,a;var s=N.comparePoints(t,o);if(s<0){n=t;i=o;a=1}else if(s>0){n=o;i=t;a=-1}else throw new Error("Tried to create degenerate segment at [".concat(t.x,", ").concat(t.y,"]"));var c=new N(n,true);var u=new N(i,false);return new d(c,u,[r],[a])}}]);return d}(),A=function(){function c(e,t,o){u(this,c);if(!Array.isArray(e)||e.length===0)throw new Error("Input geometry is not a valid Polygon or MultiPolygon");this.poly=t;this.isExterior=o;this.segments=[];if(typeof e[0][0]!=="number"||typeof e[0][1]!=="number")throw new Error("Input geometry is not a valid Polygon or MultiPolygon");var r=M.round(e[0][0],e[0][1]);this.bbox={ll:{x:r.x,y:r.y},ur:{x:r.x,y:r.y}};var n=r;for(var i=1,a=e.length;i<a;i++){if(typeof e[i][0]!=="number"||typeof e[i][1]!=="number")throw new Error("Input geometry is not a valid Polygon or MultiPolygon");var s=M.round(e[i][0],e[i][1]);if(s.x===n.x&&s.y===n.y)continue;this.segments.push(k.fromRing(n,s,this));if(s.x<this.bbox.ll.x)this.bbox.ll.x=s.x;if(s.y<this.bbox.ll.y)this.bbox.ll.y=s.y;if(s.x>this.bbox.ur.x)this.bbox.ur.x=s.x;if(s.y>this.bbox.ur.y)this.bbox.ur.y=s.y;n=s}if(r.x!==n.x||r.y!==n.y)this.segments.push(k.fromRing(n,r,this))}a(c,[{key:"getSweepEvents",value:function e(){var t=[];for(var o=0,r=this.segments.length;o<r;o++){var n=this.segments[o];t.push(n.leftSE);t.push(n.rightSE)}return t}}]);return c}(),F=function(){function i(e,t){u(this,i);if(!Array.isArray(e))throw new Error("Input geometry is not a valid Polygon or MultiPolygon");this.exteriorRing=new A(e[0],this,true);this.bbox={ll:{x:this.exteriorRing.bbox.ll.x,y:this.exteriorRing.bbox.ll.y},ur:{x:this.exteriorRing.bbox.ur.x,y:this.exteriorRing.bbox.ur.y}};this.interiorRings=[];for(var o=1,r=e.length;o<r;o++){var n=new A(e[o],this,false);if(n.bbox.ll.x<this.bbox.ll.x)this.bbox.ll.x=n.bbox.ll.x;if(n.bbox.ll.y<this.bbox.ll.y)this.bbox.ll.y=n.bbox.ll.y;if(n.bbox.ur.x>this.bbox.ur.x)this.bbox.ur.x=n.bbox.ur.x;if(n.bbox.ur.y>this.bbox.ur.y)this.bbox.ur.y=n.bbox.ur.y;this.interiorRings.push(n)}this.multiPoly=t}a(i,[{key:"getSweepEvents",value:function e(){var t=this.exteriorRing.getSweepEvents();for(var o=0,r=this.interiorRings.length;o<r;o++){var n=this.interiorRings[o].getSweepEvents();for(var i=0,a=n.length;i<a;i++)t.push(n[i])}return t}}]);return i}(),L=function(){function i(e,t){u(this,i);if(!Array.isArray(e))throw new Error("Input geometry is not a valid Polygon or MultiPolygon");try{if(typeof e[0][0][0]==="number")e=[e]}catch(e){}this.polys=[];this.bbox={ll:{x:Number.POSITIVE_INFINITY,y:Number.POSITIVE_INFINITY},ur:{x:Number.NEGATIVE_INFINITY,y:Number.NEGATIVE_INFINITY}};for(var o=0,r=e.length;o<r;o++){var n=new F(e[o],this);if(n.bbox.ll.x<this.bbox.ll.x)this.bbox.ll.x=n.bbox.ll.x;if(n.bbox.ll.y<this.bbox.ll.y)this.bbox.ll.y=n.bbox.ll.y;if(n.bbox.ur.x>this.bbox.ur.x)this.bbox.ur.x=n.bbox.ur.x;if(n.bbox.ur.y>this.bbox.ur.y)this.bbox.ur.y=n.bbox.ur.y;this.polys.push(n)}this.isSubject=t}a(i,[{key:"getSweepEvents",value:function e(){var t=[];for(var o=0,r=this.polys.length;o<r;o++){var n=this.polys[o].getSweepEvents();for(var i=0,a=n.length;i<a;i++)t.push(n[i])}return t}}]);return i}(),z=function(){a(b,null,[{key:"factory",value:function e(t){var o=[];for(var r=0,n=t.length;r<n;r++){var i=t[r];if(!i.isInResult()||i.ringOut)continue;var a=null;var s=i.leftSE;var c=i.rightSE;var u=[s];var l=s.point;var h=[];while(true){a=s;s=c;u.push(s);if(s.point===l)break;while(true){var d=s.getAvailableLinkedEvents();if(d.length===0){var p=u[0].point;var f=u[u.length-1].point;throw new Error("Unable to complete output ring starting at [".concat(p.x,",")+" ".concat(p.y,"]. Last matching segment found ends at")+" [".concat(f.x,", ").concat(f.y,"]."))}if(d.length===1){c=d[0].otherSE;break}var g=null;for(var m=0,y=h.length;m<y;m++)if(h[m].point===s.point){g=m;break}if(g!==null){var v=h.splice(g)[0];var _=u.splice(v.index);_.unshift(_[0].otherSE);o.push(new b(_.reverse()));continue}h.push({index:u.length,point:s.point});var w=s.getLeftmostComparator(a);c=d.sort(w)[0].otherSE;break}}o.push(new b(u))}return o}}]);function b(e){u(this,b);this.events=e;for(var t=0,o=e.length;t<o;t++)e[t].segment.ringOut=this;this.poly=null}a(b,[{key:"getGeom",value:function e(){var t=this.events[0].point;var o=[t];for(var r=1,n=this.events.length-1;r<n;r++){var i=this.events[r].point;var a=this.events[r+1].point;if(S(i,t,a)===0)continue;o.push(i);t=i}if(o.length===1)return null;var s=o[0];var c=o[1];if(S(s,t,c)===0)o.shift();o.push(o[0]);var u=this.isExteriorRing()?1:-1;var l=this.isExteriorRing()?0:o.length-1;var h=this.isExteriorRing()?o.length:-1;var d=[];for(var p=l;p!=h;p+=u)d.push([o[p].x,o[p].y]);return d}},{key:"isExteriorRing",value:function e(){if(this._isExteriorRing===undefined){var t=this.enclosingRing();this._isExteriorRing=t?!t.isExteriorRing():true}return this._isExteriorRing}},{key:"enclosingRing",value:function e(){if(this._enclosingRing===undefined)this._enclosingRing=this._calcEnclosingRing();return this._enclosingRing}},{key:"_calcEnclosingRing",value:function e(){var t=this.events[0];for(var o=1,r=this.events.length;o<r;o++){var n=this.events[o];if(N.compare(t,n)>0)t=n}var i=t.segment.prevInResult();var a=i?i.prevInResult():null;while(true){if(!i)return null;if(!a)return i.ringOut;if(a.ringOut!==i.ringOut)if(a.ringOut.enclosingRing()!==i.ringOut)return i.ringOut;else return i.ringOut.enclosingRing();i=a.prevInResult();a=i?i.prevInResult():null}}}]);return b}(),P=function(){function t(e){u(this,t);this.exteriorRing=e;e.poly=this;this.interiorRings=[]}a(t,[{key:"addInterior",value:function e(t){this.interiorRings.push(t);t.poly=this}},{key:"getGeom",value:function e(){var t=[this.exteriorRing.getGeom()];if(t[0]===null)return null;for(var o=0,r=this.interiorRings.length;o<r;o++){var n=this.interiorRings[o].getGeom();if(n===null)continue;t.push(n)}return t}}]);return t}(),K=function(){function t(e){u(this,t);this.rings=e;this.polys=this._composePolys(e)}a(t,[{key:"getGeom",value:function e(){var t=[];for(var o=0,r=this.polys.length;o<r;o++){var n=this.polys[o].getGeom();if(n===null)continue;t.push(n)}return t}},{key:"_composePolys",value:function e(t){var o=[];for(var r=0,n=t.length;r<n;r++){var i=t[r];if(i.poly)continue;if(i.isExteriorRing())o.push(new P(i));else{var a=i.enclosingRing();if(!a.poly)o.push(new P(a));a.poly.addInterior(i)}}return o}}]);return t}(),G=function(){function o(e){var t=arguments.length>1&&arguments[1]!==undefined?arguments[1]:k.compare;u(this,o);this.queue=e;this.tree=new R(t);this.segments=[]}a(o,[{key:"process",value:function e(t){var o=t.segment;var r=[];if(t.consumedBy){if(t.isLeft)this.queue.remove(t.otherSE);else this.tree.remove(o);return r}var n=t.isLeft?this.tree.insert(o):this.tree.find(o);if(!n)throw new Error("Unable to find segment #".concat(o.id," ")+"[".concat(o.leftSE.point.x,", ").concat(o.leftSE.point.y,"] -> ")+"[".concat(o.rightSE.point.x,", ").concat(o.rightSE.point.y,"] ")+"in SweepLine tree. Please submit a bug report.");var i=n;var a=n;var s=undefined;var c=undefined;while(s===undefined){i=this.tree.prev(i);if(i===null)s=null;else if(i.key.consumedBy===undefined)s=i.key}while(c===undefined){a=this.tree.next(a);if(a===null)c=null;else if(a.key.consumedBy===undefined)c=a.key}if(t.isLeft){var u=null;if(s){var l=s.getIntersection(o);if(l!==null){if(!o.isAnEndpoint(l))u=l;if(!s.isAnEndpoint(l)){var h=this._splitSafely(s,l);for(var d=0,p=h.length;d<p;d++)r.push(h[d])}}}var f=null;if(c){var g=c.getIntersection(o);if(g!==null){if(!o.isAnEndpoint(g))f=g;if(!c.isAnEndpoint(g)){var m=this._splitSafely(c,g);for(var y=0,v=m.length;y<v;y++)r.push(m[y])}}}if(u!==null||f!==null){var _=null;if(u===null)_=f;else if(f===null)_=u;else{var w=N.comparePoints(u,f);_=w<=0?u:f}this.queue.remove(o.rightSE);r.push(o.rightSE);var b=o.split(_);for(var C=0,S=b.length;C<S;C++)r.push(b[C])}if(r.length>0){this.tree.remove(o);r.push(t)}else{this.segments.push(o);o.prev=s}}else{if(s&&c){var E=s.getIntersection(c);if(E!==null){if(!s.isAnEndpoint(E)){var T=this._splitSafely(s,E);for(var I=0,k=T.length;I<k;I++)r.push(T[I])}if(!c.isAnEndpoint(E)){var A=this._splitSafely(c,E);for(var P=0,O=A.length;P<O;P++)r.push(A[P])}}}this.tree.remove(o)}return r}},{key:"_splitSafely",value:function e(t,o){this.tree.remove(t);var r=t.rightSE;this.queue.remove(r);var n=t.split(o);n.push(r);if(t.consumedBy===undefined)this.tree.insert(t);return n}}]);return o}(),D=typeof process!=="undefined"&&process.env.POLYGON_CLIPPING_MAX_QUEUE_SIZE||1e6,Y=typeof process!=="undefined"&&process.env.POLYGON_CLIPPING_MAX_SWEEPLINE_SEGMENTS||1e6,W,q=new(function(){function e(){u(this,e)}a(e,[{key:"run",value:function e(t,o,r){q.type=t;M.reset();var n=[new L(o,true)];for(var i=0,a=r.length;i<a;i++)n.push(new L(r[i],false));q.numMultiPolys=n.length;if(q.type==="difference"){var s=n[0];var c=1;while(c<n.length)if(x(n[c].bbox,s.bbox)!==null)c++;else n.splice(c,1)}if(q.type==="intersection")for(var u=0,l=n.length;u<l;u++){var h=n[u];for(var d=u+1,p=n.length;d<p;d++)if(x(h.bbox,n[d].bbox)===null)return[]}var f=new R(N.compare);for(var g=0,m=n.length;g<m;g++){var y=n[g].getSweepEvents();for(var v=0,_=y.length;v<_;v++){f.insert(y[v]);if(f.size>D)throw new Error("Infinite loop when putting segment endpoints in a priority queue "+"(queue size too big). Please file a bug report.")}}var w=new G(f);var b=f.size;var C=f.pop();while(C){var S=C.key;if(f.size===b){var E=S.segment;throw new Error("Unable to pop() ".concat(S.isLeft?"left":"right"," SweepEvent ")+"[".concat(S.point.x,", ").concat(S.point.y,"] from segment #").concat(E.id," ")+"[".concat(E.leftSE.point.x,", ").concat(E.leftSE.point.y,"] -> ")+"[".concat(E.rightSE.point.x,", ").concat(E.rightSE.point.y,"] from queue. ")+"Please file a bug report.")}if(f.size>D)throw new Error("Infinite loop when passing sweep line over endpoints "+"(queue size too big). Please file a bug report.");if(w.segments.length>Y)throw new Error("Infinite loop when passing sweep line over endpoints "+"(too many sweep line segments). Please file a bug report.");var T=w.process(S);for(var I=0,k=T.length;I<k;I++){var A=T[I];if(A.consumedBy===undefined)f.insert(A)}b=f.size;C=f.pop()}M.reset();var P=z.factory(w.segments);var O=new K(P);return O.getGeom()}}]);return e}()),Z,Q,V,J,X;return{union:function e(t){for(var o=arguments.length,r=new Array(o>1?o-1:0),n=1;n<o;n++)r[n-1]=arguments[n];return q.run("union",t,r)},intersection:function e(t){for(var o=arguments.length,r=new Array(o>1?o-1:0),n=1;n<o;n++)r[n-1]=arguments[n];return q.run("intersection",t,r)},xor:function e(t){for(var o=arguments.length,r=new Array(o>1?o-1:0),n=1;n<o;n++)r[n-1]=arguments[n];return q.run("xor",t,r)},difference:function e(t){for(var o=arguments.length,r=new Array(o>1?o-1:0),n=1;n<o;n++)r[n-1]=arguments[n];return q.run("difference",t,r)}}}());function bg(e,t,o){void 0===o&&(o={});var e=_g(e),t=_g(t),e=wg.intersection(e.coordinates,t.coordinates);if(0===e.length)return null;if(1!==e.length)return t=o.properties,vg({type:"MultiPolygon",coordinates:e},t,r=void 0===r?{}:r);var t=e[0],r=o.properties,e=void 0;void 0===e&&(e={});for(var n=0,i=t;n<i.length;n++){var a=i[n];if(a.length<4)throw new Error("Each LinearRing of a Polygon must have 4 or more Positions.");for(var s=0;s<a[a.length-1].length;s++)if(a[a.length-1][s]!==a[0][s])throw new Error("First and last Position are not equivalent.")}return vg({type:"Polygon",coordinates:t},r,e)}var Cg,sr=window&&window.__decorate||function(e,t,o,r){var n,i=arguments.length,a=i<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,o):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,o,r);else for(var s=e.length-1;0<=s;s--)(n=e[s])&&(a=(i<3?n(a):3<i?n(t,o,a):n(t,o))||a);return 3<i&&a&&Object.defineProperty(t,o,a),a},Sg=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},Eg=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},Tg=["DIV","SPAN","A"],Ig=["data-azure-maps-attribution-minzoom","data-azure-maps-attribution-maxzoom","data-azure-maps-attribution-geometry","data-azure-maps-attribution-tileset","data-azure-maps-attribution-order","data-azure-maps-attribution-dynamic"],kg=Eg(["href"],Sg(Ig),!1),Ag=(Pg.prototype.equals=function(e){return this.stringRepresentation===e.stringRepresentation},Object.defineProperty(Pg.prototype,"stringRepresentation",{get:function(){return[void 0!==this.minZoom?"minzoom=".concat(this.minZoom):"",void 0!==this.maxZoom?"maxzoom=".concat(this.maxZoom):"",void 0!==this.geometry?this.element.attributes.getNamedItem("data-azure-maps-attribution-geometry").value:"",void 0!==this.tilesetId?"tilesetId=".concat(this.tilesetId):"",this.dynamic?"dynamic":""].filter(function(e){return 0<e.length}).join(";")},enumerable:!1,configurable:!0}),Pg.applicable=function(e){return Array.from(e.attributes).map(function(e){return Ig.includes(e.name)}).reduce(function(e,t){return e||t},!1)},Object.defineProperty(Pg.prototype,"minZoom",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-minzoom");return e&&!isNaN(e.value)?parseInt(e.value):void 0},enumerable:!1,configurable:!0}),Object.defineProperty(Pg.prototype,"maxZoom",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-maxzoom");return e&&!isNaN(e.value)?parseInt(e.value):void 0},enumerable:!1,configurable:!0}),Object.defineProperty(Pg.prototype,"geometry",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-geometry");if(e&&e.value)try{return JSON.parse(e.value)}catch(e){}},enumerable:!1,configurable:!0}),Object.defineProperty(Pg.prototype,"tilesetId",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-tileset");return e&&e.value?e.value:void 0},enumerable:!1,configurable:!0}),Object.defineProperty(Pg.prototype,"order",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-order");return e&&!isNaN(e.value)?parseInt(e.value):void 0},enumerable:!1,configurable:!0}),Object.defineProperty(Pg.prototype,"dynamic",{get:function(){return null!==this.element.attributes.getNamedItem("data-azure-maps-attribution-dynamic")},enumerable:!1,configurable:!0}),Object.defineProperty(Pg.prototype,"hidesElement",{get:function(){return"none"==this.element.style.display},enumerable:!1,configurable:!0}),Pg.prototype.forceHide=function(){this.element.style.display="none"},Pg.prototype.satisfied=function(e){var t=!this.minZoom||!e.zoom||e.zoom>=this.minZoom,o=!this.maxZoom||!e.zoom||e.zoom<=this.maxZoom,r=!0;return this.geometry&&e.bounds&&(r=null!==bg({type:"Feature",geometry:this.geometry,properties:{}},{type:"Feature",geometry:{type:"Polygon",coordinates:[[f.getNorthWest(e.bounds),f.getNorthEast(e.bounds),f.getSouthEast(e.bounds),f.getSouthWest(e.bounds),f.getNorthWest(e.bounds)]]},properties:{}})),t&&o&&r},Pg.prototype.apply=function(t,e){var o=this,r=(void 0===e&&(e=null),this.satisfied(t.getCamera())),n=this.dynamic&&this.tilesetId,i=this.hidesElement,e=e&&["dragend","zoomend","pitchend"].includes(e.type);return r||i?r&&(i||n)&&(r&&i&&this.element.style.removeProperty("display"),n)&&(e?t.events.addOnce("idle",function(e){return o.fetchAndApplyDynamicAttribution(t)}):this.fetchAndApplyDynamicAttribution(t)):this.element.style.display="none",r===i},Pg.prototype.fetchAndApplyDynamicAttribution=function(r){var t,o,e,n=this,i=r.getCamera();this.lastFetchState&&f.containsBoundingBox(this.lastFetchState.bounds,i.bounds)&&Math.floor(this.lastFetchState.zoom)==Math.floor(i.zoom)||(t=Gu(i.center,f.getSouthWest(i.bounds),Pg.viewportBufferExpansionRatio),e=((o=Gu(i.center,f.getNorthEast(i.bounds),Pg.viewportBufferExpansionRatio))[0]<t[0]?[[t[0],t[1],180,o[1]],[-180,t[1],o[0],o[1]]]:[[t[0],t[1],o[0],o[1]]]).map(function(e){var e=new URLSearchParams({"api-version":"2.1",tilesetId:n.tilesetId,zoom:void 0!==i.zoom?"".concat(Math.floor(i.zoom)):void 0,bounds:e.join(",")}),t="".concat("https://{{azMapsDomain}}","/map/attribution"),o={url:t,headers:{}},t=(r._substituteDomainLanguageViewAndSignInRequest(t,o),"".concat(o.url).concat(o.url.includes("?")?"&":"?").concat(e.toString()));return r._sendRequest(t,"Attribution",o.headers).then(function(e){return e.json()})}),Promise.all(e).then(function(e){n.applyAttributionResponse(e),n.lastFetchState={bounds:new f([t[0],t[1],o[0],o[1]]),zoom:i.zoom}}).catch(function(e){return console.error(e)}))},Pg.prototype.applyAttributionResponse=function(e){var t,o,r,n=this,e=e.map(function(e){return e.copyrights||[]}).reduce(function(e,t){return Eg(Eg([],Sg(e),!1),Sg(t),!1)},[]);0!=e.length&&(null===(e=Qp.parseWithFilter(e.join(""),function(e){return!0},function(e){return e},function(){return n.element.innerHTML="",n.element}))?console.warn("Dynamic attribution is empty after filtering"):(t="string"==typeof e?((t=document.createElement("span")).innerHTML=e,t):e,r=t===this.element?(o=document.createElement("span"),Array.from(this.element.childNodes).forEach(function(e){return o.appendChild(e)}),o):t,Array.from(this.element.attributes).filter(function(e){return Ig.includes(e.name)}).forEach(function(e){return r.attributes.setNamedItem(e.cloneNode())}),r.style.display=this.element.style.display,e=this.element.parentElement,this.element.remove(),e.append(r),this.element=r,this.attributionChangeCallback(this)))},Pg.viewportBufferExpansionRatio=2,sr([(Cg=1e3,function(e,t,o){var r=o.value,n=new Map;return o.value=function(){var e=this,t=arguments;!n.get(e)&&1&&(r.apply(e,t),n.set(e,!0),setTimeout(function(){return n.delete(e)},Cg))},o})],Pg.prototype,"fetchAndApplyDynamicAttribution",null),Pg);function Pg(e,t){var o=this;this.lastFetchState={bounds:null,zoom:null},this.getElement=function(){return o.element},this.element=e,this.attributionChangeCallback=t}var Og=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},Rg=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},xg=[/all rights reserved/gi],Mg=(Ng.prototype.addToMap=function(){this.map.events.add("stylechanged",this.loadAttributionOnceSourcesLoaded),this.map.events.add("dragend",this.applyRules),this.map.events.add("zoomend",this.applyRules),this.map.events.add("pitchend",this.applyRules)},Ng.prototype.removeFromMap=function(){this.map.events.remove("stylechanged",this.loadAttributionOnceSourcesLoaded),this.map.events.remove("dragend",this.applyRules),this.map.events.remove("zoomend",this.applyRules),this.map.events.remove("pitchend",this.applyRules)},Ng.prototype.getDefaultAttribution=function(){return this.copyrightControl.getDefaultAttributions().map(function(e){return e=e,(t=document.createElement("a")).textContent=e,t;var t})},Ng);function Ng(e,t,o){var r,s=this;this.rules=[],this.virtualContext=((r=document.createElement("span")).className="azure-map-copyright-context",r),this.renderContext=this.virtualContext.cloneNode(!1),this.addAttributionFromSource=function(e){},this.removeAttributionFromSource=function(e){},this.getMapStyleVisibleSources=function(){var t=s.map._getMap(),o=t.getStyle();return Object.entries(o.sources).filter(function(e){var t=Og(e,1)[0];return o.layers.filter(function(e){return e&&e.source==t}).reduce(function(e,t){return!(t.layout&&"none"===t.layout.visibility||t.paint&&0===t.paint["icon-opacity"]&&0===t.paint["text-opacity"])||e},!1)}).map(function(e){e=Og(e,1)[0];return t.getSource(e)})},this.loadAttributionOnceSourcesLoaded=function(){var e=s.getMapStyleVisibleSources();Promise.all(e.map(function(i){return new Promise(function(o,r){var n;"tiles"in i||"geojson"===(null==i?void 0:i.type)?o(i):((n=i).on("data",function e(t){"metadata"==t.sourceDataType&&(n.off("data",e),o(i))}),n.on("error",function e(t){n.off("error",e),r(t)}))}).then(function(e){return{status:"fulfilled",value:e}}).catch(function(e){return{status:"rejected",reason:e}})})).then(function(e){s.reloadAttribution()})},this.reloadAttribution=function(){var e=s.getMapStyleVisibleSources(),r=new Set,n={},e=e.filter(function(e){return"attribution"in e&&e.attribution&&"tiles"in e&&e.tiles instanceof Array&&0<e.tiles.length}).map(function(e){return Qp.parseWithFilter(null!=(e=e.attribution)?e:"",function(e){return Tg.includes(e.tagName)&&Array.from(e.attributes).map(function(e){return kg.includes(e.name)}).reduce(function(e,t){return e&&t},!0)},function(e){var t,o=null;return e instanceof HTMLElement&&Ag.applicable(e)&&(o=new Ag(e,function(){return s.renderAttribution()}),r.add(o),void 0!==o.order)&&(e.style.order="".concat(o.order)),o&&e instanceof HTMLElement&&(!((t=o.stringRepresentation)in n)||void 0!==o.order&&void 0!==n[t].order&&o.order<n[t].order||void 0!==o.order&&void 0===n[t].order)&&(n[t]=o),e},function(){return document.createElement("span")})}),t=new Set(Object.values(n)),o=new Set(Rg([],Og(r),!1).filter(function(e){return!t.has(e)})),i=new Set(Rg([],Og(o),!1).map(function(e){return e.getElement()})),o=(Rg([],Og(i),!1).filter(function(e){return null!==e.parentElement}).forEach(function(e){return e.parentElement.removeChild(e)}),s.rules=Object.values(n),e.filter(function(e){return"string"==typeof e||!i.has(e)}).map(function(e){return"string"==typeof e?new Text(e):e})),a=document.createElement("span");0<o.length?o.forEach(function(e){return a.appendChild(e)}):s.getDefaultAttribution().forEach(function(e){return a.appendChild(e)}),s.virtualContext=a,s.copyrightControl.setOptions({copyrightContent:s.renderContext}),s.applyRules(),s.renderAttribution()},this.applyRules=function(o){void 0===o&&(o=null),s.rules.reduce(function(e,t){t=t.apply(s.map,o);return e||t},!1)&&s.renderAttribution()},this.renderAttribution=function(){var t=function(e){return Array.from("none"!=e.style.display?e.children:[]).map(function(e){return t(e)}).reduce(function(e,t){return Rg(Rg([],Og(e),!1),Og(t),!1)},Array.from("none"!=e.style.display?e.childNodes:[]).filter(function(e){return e.nodeType==e.TEXT_NODE}))},e=s.virtualContext.cloneNode(!0),o=t(e);o.forEach(function(e){return e.textContent=Rg([],Og(xg),!1).reduce(function(e,t){return e.replace(t,"").trim()},e.textContent)}),o.reduce(function(e,t){return e.has(t.textContent)?(t.textContent="",t.parentElement&&t.parentElement.removeChild(t)):e.add(t.textContent),e},new Set),s.renderContext.innerHTML="",Array.from(e.childNodes).forEach(function(e){return s.renderContext.appendChild(e)})},this.map=e,this.copyrightControl=t,this.options=o}var Lg=function(e,t){return(Lg=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)};function Dg(e,t){function o(){this.constructor=e}Lg(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}var v=function(){return(v=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)};function qg(e,t){var o={};for(n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(o[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols)for(var r=0,n=Object.getOwnPropertySymbols(e);r<n.length;r++)t.indexOf(n[r])<0&&Object.prototype.propertyIsEnumerable.call(e,n[r])&&(o[n[r]]=e[n[r]]);return o}function _(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})}function w(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},e={next:t(0),throw:t(1),return:t(2)};return"function"==typeof Symbol&&(e[Symbol.iterator]=function(){return this}),e;function t(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}}function Ug(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a}(arguments[t]));return e}var jg=function(e,t){return(jg=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)};function Hg(e,t){function o(){this.constructor=e}jg(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}var Bg=function(){return(Bg=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)};function b(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})}function C(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},e={next:t(0),throw:t(1),return:t(2)};return"function"==typeof Symbol&&(e[Symbol.iterator]=function(){return this}),e;function t(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}}function Fg(){for(var e=0,t=0,o=arguments.length;t<o;t++)e+=arguments[t].length;for(var r=Array(e),n=0,t=0;t<o;t++)for(var i=arguments[t],a=0,s=i.length;a<s;a++,n++)r[n]=i[a];return r}var zg,Kg,Gg,u,Yg,Wg,Zg,Qg,Vg,Jg,S,Xg,$g,em,E={LIBRARY_NAME:"MSAL.JS",SKU:"msal.js.common",CACHE_PREFIX:"msal",DEFAULT_AUTHORITY:"https://login.microsoftonline.com/common/",DEFAULT_AUTHORITY_HOST:"login.microsoftonline.com",DEFAULT_COMMON_TENANT:"common",ADFS:"adfs",DSTS:"dstsv2",AAD_INSTANCE_DISCOVERY_ENDPT:"https://login.microsoftonline.com/common/discovery/instance?api-version=1.1&authorization_endpoint=",CIAM_AUTH_URL:".ciamlogin.com",AAD_TENANT_DOMAIN_SUFFIX:".onmicrosoft.com",RESOURCE_DELIM:"|",NO_ACCOUNT:"NO_ACCOUNT",CLAIMS:"claims",CONSUMER_UTID:"9188040d-6c67-4c5b-b112-36a304b66dad",OPENID_SCOPE:"openid",PROFILE_SCOPE:"profile",OFFLINE_ACCESS_SCOPE:"offline_access",EMAIL_SCOPE:"email",CODE_RESPONSE_TYPE:"code",CODE_GRANT_TYPE:"authorization_code",RT_GRANT_TYPE:"refresh_token",FRAGMENT_RESPONSE_MODE:"fragment",S256_CODE_CHALLENGE_METHOD:"S256",URL_FORM_CONTENT_TYPE:"application/x-www-form-urlencoded;charset=utf-8",AUTHORIZATION_PENDING:"authorization_pending",NOT_DEFINED:"not_defined",EMPTY_STRING:"",NOT_APPLICABLE:"N/A",FORWARD_SLASH:"/",IMDS_ENDPOINT:"http://169.254.169.254/metadata/instance/compute/location",IMDS_VERSION:"2020-06-01",IMDS_TIMEOUT:2e3,AZURE_REGION_AUTO_DISCOVER_FLAG:"TryAutoDetect",REGIONAL_AUTH_PUBLIC_CLOUD_SUFFIX:"login.microsoft.com",REGIONAL_AUTH_NON_MSI_QUERY_STRING:"allowestsrnonmsi=true",KNOWN_PUBLIC_CLOUDS:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"],TOKEN_RESPONSE_TYPE:"token",ID_TOKEN_RESPONSE_TYPE:"id_token",SHR_NONCE_VALIDITY:240,INVALID_INSTANCE:"invalid_instance"},tm=[E.OPENID_SCOPE,E.PROFILE_SCOPE,E.OFFLINE_ACCESS_SCOPE],om=Fg(tm,[E.EMAIL_SCOPE]),rm=((i=zg=zg||{}).CONTENT_TYPE="Content-Type",i.RETRY_AFTER="Retry-After",i.CCS_HEADER="X-AnchorMailbox",i.WWWAuthenticate="WWW-Authenticate",i.AuthenticationInfo="Authentication-Info",i.X_MS_REQUEST_ID="x-ms-request-id",i.X_MS_HTTP_VERSION="x-ms-httpver",(e=Kg=Kg||{}).ID_TOKEN="idtoken",e.CLIENT_INFO="client.info",e.ADAL_ID_TOKEN="adal.idtoken",e.ERROR="error",e.ERROR_DESC="error.description",e.ACTIVE_ACCOUNT="active-account",e.ACTIVE_ACCOUNT_FILTERS="active-account-filters",(Fr=Gg=Gg||{}).COMMON="common",Fr.ORGANIZATIONS="organizations",Fr.CONSUMERS="consumers",(r=u=u||{}).CLIENT_ID="client_id",r.REDIRECT_URI="redirect_uri",r.RESPONSE_TYPE="response_type",r.RESPONSE_MODE="response_mode",r.GRANT_TYPE="grant_type",r.CLAIMS="claims",r.SCOPE="scope",r.ERROR="error",r.ERROR_DESCRIPTION="error_description",r.ACCESS_TOKEN="access_token",r.ID_TOKEN="id_token",r.REFRESH_TOKEN="refresh_token",r.EXPIRES_IN="expires_in",r.STATE="state",r.NONCE="nonce",r.PROMPT="prompt",r.SESSION_STATE="session_state",r.CLIENT_INFO="client_info",r.CODE="code",r.CODE_CHALLENGE="code_challenge",r.CODE_CHALLENGE_METHOD="code_challenge_method",r.CODE_VERIFIER="code_verifier",r.CLIENT_REQUEST_ID="client-request-id",r.X_CLIENT_SKU="x-client-SKU",r.X_CLIENT_VER="x-client-VER",r.X_CLIENT_OS="x-client-OS",r.X_CLIENT_CPU="x-client-CPU",r.X_CLIENT_CURR_TELEM="x-client-current-telemetry",r.X_CLIENT_LAST_TELEM="x-client-last-telemetry",r.X_MS_LIB_CAPABILITY="x-ms-lib-capability",r.X_APP_NAME="x-app-name",r.X_APP_VER="x-app-ver",r.POST_LOGOUT_URI="post_logout_redirect_uri",r.ID_TOKEN_HINT="id_token_hint",r.DEVICE_CODE="device_code",r.CLIENT_SECRET="client_secret",r.CLIENT_ASSERTION="client_assertion",r.CLIENT_ASSERTION_TYPE="client_assertion_type",r.TOKEN_TYPE="token_type",r.REQ_CNF="req_cnf",r.OBO_ASSERTION="assertion",r.REQUESTED_TOKEN_USE="requested_token_use",r.ON_BEHALF_OF="on_behalf_of",r.FOCI="foci",r.CCS_HEADER="X-AnchorMailbox",r.RETURN_SPA_CODE="return_spa_code",r.NATIVE_BROKER="nativebroker",r.LOGOUT_HINT="logout_hint",(be=Yg=Yg||{}).ACCESS_TOKEN="access_token",be.XMS_CC="xms_cc",{LOGIN:"login",SELECT_ACCOUNT:"select_account",CONSENT:"consent",NONE:"none",CREATE:"create",NO_SESSION:"no_session"}),nm=((xi=Wg=Wg||{}).ACCOUNT="account",xi.SID="sid",xi.LOGIN_HINT="login_hint",xi.ID_TOKEN="id_token",xi.DOMAIN_HINT="domain_hint",xi.ORGANIZATIONS="organizations",xi.CONSUMERS="consumers",xi.ACCOUNT_ID="accountIdentifier",xi.HOMEACCOUNT_ID="homeAccountIdentifier",{PLAIN:"plain",S256:"S256"}),im=((Kt=Zg=Zg||{}).QUERY="query",Kt.FRAGMENT="fragment",Kt.FORM_POST="form_post",(o=Qg=Qg||{}).IMPLICIT_GRANT="implicit",o.AUTHORIZATION_CODE_GRANT="authorization_code",o.CLIENT_CREDENTIALS_GRANT="client_credentials",o.RESOURCE_OWNER_PASSWORD_GRANT="password",o.REFRESH_TOKEN_GRANT="refresh_token",o.DEVICE_CODE_GRANT="device_code",o.JWT_BEARER="urn:ietf:params:oauth:grant-type:jwt-bearer",(jo=Vg=Vg||{}).MSSTS_ACCOUNT_TYPE="MSSTS",jo.ADFS_ACCOUNT_TYPE="ADFS",jo.MSAV1_ACCOUNT_TYPE="MSA",jo.GENERIC_ACCOUNT_TYPE="Generic",(ln=Jg=Jg||{}).CACHE_KEY_SEPARATOR="-",ln.CLIENT_INFO_SEPARATOR=".",(a=S=S||{}).ID_TOKEN="IdToken",a.ACCESS_TOKEN="AccessToken",a.ACCESS_TOKEN_WITH_AUTH_SCHEME="AccessToken_With_AuthScheme",a.REFRESH_TOKEN="RefreshToken",(t=Xg=Xg||{})[t.ADFS=1001]="ADFS",t[t.MSA=1002]="MSA",t[t.MSSTS=1003]="MSSTS",t[t.GENERIC=1004]="GENERIC",t[t.ACCESS_TOKEN=2001]="ACCESS_TOKEN",t[t.REFRESH_TOKEN=2002]="REFRESH_TOKEN",t[t.ID_TOKEN=2003]="ID_TOKEN",t[t.APP_METADATA=3001]="APP_METADATA",t[t.UNDEFINED=9999]="UNDEFINED","appmetadata"),am="authority-metadata",sm=86400,cm=((s=$g=$g||{}).CONFIG="config",s.CACHE="cache",s.NETWORK="network",s.HARDCODED_VALUES="hardcoded_values",{SCHEMA_VERSION:5,MAX_CUR_HEADER_BYTES:80,MAX_LAST_HEADER_BYTES:330,MAX_CACHED_ERRORS:50,CACHE_KEY:"server-telemetry",CATEGORY_SEPARATOR:"|",VALUE_SEPARATOR:",",OVERFLOW_TRUE:"1",OVERFLOW_FALSE:"0",UNKNOWN_ERROR:"unknown_error"});(n=em=em||{}).BEARER="Bearer",n.POP="pop",n.SSH="ssh-cert";var um,lm,hm,dm,pm,fm,gm=60,mm=3600,ym="throttling",vm="retry-after, h429",_m="invalid_grant",wm="client_mismatch";(sr=um=um||{}).username="username",sr.password="password",(i=lm=lm||{})[i.httpSuccess=200]="httpSuccess",i[i.httpBadRequest=400]="httpBadRequest",(e=hm=hm||{}).FAILED_AUTO_DETECTION="1",e.INTERNAL_CACHE="2",e.ENVIRONMENT_VARIABLE="3",e.IMDS="4",(Fr=dm=dm||{}).CONFIGURED_MATCHES_DETECTED="1",Fr.CONFIGURED_NO_AUTO_DETECTION="2",Fr.CONFIGURED_NOT_DETECTED="3",Fr.AUTO_DETECTION_REQUESTED_SUCCESSFUL="4",Fr.AUTO_DETECTION_REQUESTED_FAILED="5",(r=pm=pm||{}).NO_CACHE_HIT="0",r.FORCE_REFRESH="1",r.NO_CACHED_ACCESS_TOKEN="2",r.CACHED_ACCESS_TOKEN_EXPIRED="3",r.REFRESH_CACHED_ACCESS_TOKEN="4",r.CLAIMS_REQUESTED_CACHE_SKIPPED="5",(be=fm=fm||{}).Jwt="JWT",be.Jwk="JWK",be.Pop="pop";var bm,Cm={code:"unexpected_error",desc:"Unexpected error in authentication."},Sm={code:"post_request_failed",desc:"Post request failed from the network, could be a 4xx/5xx or a network unavailability. Please check the exact error code for details."},T=(Hg(Em,bm=Error),Em.prototype.setCorrelationId=function(e){this.correlationId=e},Em.createUnexpectedError=function(e){return new Em(Cm.code,Cm.desc+": "+e)},Em.createPostRequestFailed=function(e){return new Em(Sm.code,Sm.desc+": "+e)},Em);function Em(e,t,o){var r=this,r=bm.call(this,t?e+": "+t:e)||this;return Object.setPrototypeOf(r,Em.prototype),r.errorCode=e||E.EMPTY_STRING,r.errorMessage=t||E.EMPTY_STRING,r.subError=o||E.EMPTY_STRING,r.name="AuthError",r}var Tm,Im={createNewGuid:function(){throw T.createUnexpectedError("Crypto interface - createNewGuid() has not been implemented")},base64Decode:function(){throw T.createUnexpectedError("Crypto interface - base64Decode() has not been implemented")},base64Encode:function(){throw T.createUnexpectedError("Crypto interface - base64Encode() has not been implemented")},generatePkceCodes:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Crypto interface - generatePkceCodes() has not been implemented")})})},getPublicKeyThumbprint:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Crypto interface - getPublicKeyThumbprint() has not been implemented")})})},removeTokenBindingKey:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Crypto interface - removeTokenBindingKey() has not been implemented")})})},clearKeystore:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Crypto interface - clearKeystore() has not been implemented")})})},signJwt:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Crypto interface - signJwt() has not been implemented")})})},hashString:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Crypto interface - hashString() has not been implemented")})})}},km={code:"client_info_decoding_error",desc:"The client info could not be parsed/decoded correctly. Please review the trace to determine the root cause."},Am={code:"client_info_empty_error",desc:"The client info was empty. Please review the trace to determine the root cause."},Pm={code:"token_parsing_error",desc:"Token cannot be parsed. Please review stack trace to determine root cause."},Om={code:"null_or_empty_token",desc:"The token is null or empty. Please review the trace to determine the root cause."},Rm={code:"endpoints_resolution_error",desc:"Error: could not resolve endpoints. Please check network and try again."},xm={code:"network_error",desc:"Network request failed. Please check network trace to determine root cause."},Mm={code:"openid_config_error",desc:"Could not retrieve endpoints. Check your authority and verify the .well-known/openid-configuration endpoint returns the required endpoints."},Nm={code:"hash_not_deserialized",desc:"The hash parameters could not be deserialized. Please review the trace to determine the root cause."},Lm={code:"invalid_state",desc:"State was not the expected format. Please check the logs to determine whether the request was sent using ProtocolUtils.setRequestState()."},Dm={code:"state_mismatch",desc:"State mismatch error. Please check your network. Continued requests may cause cache overflow."},qm={code:"state_not_found",desc:"State not found"},Um={code:"nonce_mismatch",desc:"Nonce mismatch error. This may be caused by a race condition in concurrent requests."},jm={code:"nonce_not_found",desc:"nonce not found"},Hm={code:"auth_time_not_found",desc:"Max Age was requested and the ID token is missing the auth_time variable. auth_time is an optional claim and is not enabled by default - it must be enabled. See https://aka.ms/msaljs/optional-claims for more information."},Bm={code:"max_age_transpired",desc:"Max Age is set to 0, or too much time has elapsed since the last end-user authentication."},Fm={code:"multiple_matching_tokens",desc:"The cache contains multiple tokens satisfying the requirements. Call AcquireToken again providing more requirements such as authority or account."},zm={code:"multiple_matching_accounts",desc:"The cache contains multiple accounts satisfying the given parameters. Please pass more info to obtain the correct account"},Km={code:"multiple_matching_appMetadata",desc:"The cache contains multiple appMetadata satisfying the given parameters. Please pass more info to obtain the correct appMetadata"},Gm={code:"request_cannot_be_made",desc:"Token request cannot be made without authorization code or refresh token."},Ym={code:"cannot_append_empty_scope",desc:"Cannot append null or empty scope to ScopeSet. Please check the stack trace for more info."},Wm={code:"cannot_remove_empty_scope",desc:"Cannot remove null or empty scope from ScopeSet. Please check the stack trace for more info."},Zm={code:"cannot_append_scopeset",desc:"Cannot append ScopeSet due to error."},Qm={code:"empty_input_scopeset",desc:"Empty input ScopeSet cannot be processed."},Vm={code:"device_code_polling_cancelled",desc:"Caller has cancelled token endpoint polling during device code flow by setting DeviceCodeRequest.cancel = true."},Jm={code:"device_code_expired",desc:"Device code is expired."},Xm={code:"device_code_unknown_error",desc:"Device code stopped polling for unknown reasons."},$m={code:"no_account_in_silent_request",desc:"Please pass an account object, silent flow is not supported without account information"},ey={code:"invalid_cache_record",desc:"Cache record object was null or undefined."},ty={code:"invalid_cache_environment",desc:"Invalid environment when attempting to create cache entry"},oy={code:"no_account_found",desc:"No account found in cache for given key."},ry={code:"no cache plugin set on CacheManager",desc:"ICachePlugin needs to be set before using readFromStorage or writeFromStorage"},ny={code:"no_crypto_object",desc:"No crypto object detected. This is required for the following operation: "},iy={code:"invalid_cache_type",desc:"Invalid cache type"},ay={code:"unexpected_account_type",desc:"Unexpected account type."},sy={code:"unexpected_credential_type",desc:"Unexpected credential type."},cy={code:"invalid_assertion",desc:"Client assertion must meet requirements described in https://tools.ietf.org/html/rfc7515"},uy={code:"invalid_client_credential",desc:"Client credential (secret, certificate, or assertion) must not be empty when creating a confidential client. An application should at most have one credential"},ly={code:"token_refresh_required",desc:"Cannot return token from cache because it must be refreshed. This may be due to one of the following reasons: forceRefresh parameter is set to true, claims have been requested, there is no cached access token or it is expired."},hy={code:"user_timeout_reached",desc:"User defined timeout for device code polling reached"},dy={code:"token_claims_cnf_required_for_signedjwt",desc:"Cannot generate a POP jwt if the token_claims are not populated"},py={code:"authorization_code_missing_from_server_response",desc:"Server response does not contain an authorization code to proceed"},fy={code:"binding_key_not_removed",desc:"Could not remove the credential's binding key from storage."},gy={code:"end_session_endpoint_not_supported",desc:"Provided authority does not support logout."},my={code:"key_id_missing",desc:"A keyId value is missing from the requested bound token's cache record and is required to match the token to it's stored binding key."},yy={code:"no_network_connectivity",desc:"No network connectivity. Check your internet connection."},vy={code:"user_canceled",desc:"User canceled the flow."},I=(Hg(c,Tm=T),c.createClientInfoDecodingError=function(e){return new c(km.code,km.desc+" Failed with error: "+e)},c.createClientInfoEmptyError=function(){return new c(Am.code,""+Am.desc)},c.createTokenParsingError=function(e){return new c(Pm.code,Pm.desc+" Failed with error: "+e)},c.createTokenNullOrEmptyError=function(e){return new c(Om.code,Om.desc+" Raw Token Value: "+e)},c.createEndpointDiscoveryIncompleteError=function(e){return new c(Rm.code,Rm.desc+" Detail: "+e)},c.createNetworkError=function(e,t){return new c(xm.code,xm.desc+" | Fetch client threw: "+t+" | Attempted to reach: "+e.split("?")[0])},c.createUnableToGetOpenidConfigError=function(e){return new c(Mm.code,Mm.desc+" Attempted to retrieve endpoints from: "+e)},c.createHashNotDeserializedError=function(e){return new c(Nm.code,Nm.desc+" Given Object: "+e)},c.createInvalidStateError=function(e,t){return new c(Lm.code,Lm.desc+" Invalid State: "+e+", Root Err: "+t)},c.createStateMismatchError=function(){return new c(Dm.code,Dm.desc)},c.createStateNotFoundError=function(e){return new c(qm.code,qm.desc+":  "+e)},c.createNonceMismatchError=function(){return new c(Um.code,Um.desc)},c.createAuthTimeNotFoundError=function(){return new c(Hm.code,Hm.desc)},c.createMaxAgeTranspiredError=function(){return new c(Bm.code,Bm.desc)},c.createNonceNotFoundError=function(e){return new c(jm.code,jm.desc+":  "+e)},c.createMultipleMatchingTokensInCacheError=function(){return new c(Fm.code,Fm.desc+".")},c.createMultipleMatchingAccountsInCacheError=function(){return new c(zm.code,zm.desc)},c.createMultipleMatchingAppMetadataInCacheError=function(){return new c(Km.code,Km.desc)},c.createTokenRequestCannotBeMadeError=function(){return new c(Gm.code,Gm.desc)},c.createAppendEmptyScopeToSetError=function(e){return new c(Ym.code,Ym.desc+" Given Scope: "+e)},c.createRemoveEmptyScopeFromSetError=function(e){return new c(Wm.code,Wm.desc+" Given Scope: "+e)},c.createAppendScopeSetError=function(e){return new c(Zm.code,Zm.desc+" Detail Error: "+e)},c.createEmptyInputScopeSetError=function(){return new c(Qm.code,""+Qm.desc)},c.createDeviceCodeCancelledError=function(){return new c(Vm.code,""+Vm.desc)},c.createDeviceCodeExpiredError=function(){return new c(Jm.code,""+Jm.desc)},c.createDeviceCodeUnknownError=function(){return new c(Xm.code,""+Xm.desc)},c.createNoAccountInSilentRequestError=function(){return new c($m.code,""+$m.desc)},c.createNullOrUndefinedCacheRecord=function(){return new c(ey.code,ey.desc)},c.createInvalidCacheEnvironmentError=function(){return new c(ty.code,ty.desc)},c.createNoAccountFoundError=function(){return new c(oy.code,oy.desc)},c.createCachePluginError=function(){return new c(ry.code,""+ry.desc)},c.createNoCryptoObjectError=function(e){return new c(ny.code,""+ny.desc+e)},c.createInvalidCacheTypeError=function(){return new c(iy.code,""+iy.desc)},c.createUnexpectedAccountTypeError=function(){return new c(ay.code,""+ay.desc)},c.createUnexpectedCredentialTypeError=function(){return new c(sy.code,""+sy.desc)},c.createInvalidAssertionError=function(){return new c(cy.code,""+cy.desc)},c.createInvalidCredentialError=function(){return new c(uy.code,""+uy.desc)},c.createRefreshRequiredError=function(){return new c(ly.code,ly.desc)},c.createUserTimeoutReachedError=function(){return new c(hy.code,hy.desc)},c.createTokenClaimsRequiredError=function(){return new c(dy.code,dy.desc)},c.createNoAuthCodeInServerResponseError=function(){return new c(py.code,py.desc)},c.createBindingKeyNotRemovedError=function(){return new c(fy.code,fy.desc)},c.createLogoutNotSupportedError=function(){return new c(gy.code,gy.desc)},c.createKeyIdMissingError=function(){return new c(my.code,my.desc)},c.createNoNetworkConnectivityError=function(){return new c(yy.code,yy.desc)},c.createUserCanceledError=function(){return new c(vy.code,vy.desc)},c);function c(e,t){e=Tm.call(this,e,t)||this;return e.name="ClientAuthError",Object.setPrototypeOf(e,c.prototype),e}wy.decodeAuthToken=function(e){if(wy.isEmpty(e))throw I.createTokenNullOrEmptyError(e);var t=/^([^\.\s]*)\.([^\.\s]+)\.([^\.\s]*)$/.exec(e);if(!t||t.length<4)throw I.createTokenParsingError("Given token is malformed: "+JSON.stringify(e));return{header:t[1],JWSPayload:t[2],JWSSig:t[3]}},wy.isEmpty=function(e){return void 0===e||!e||0===e.length},wy.isEmptyObj=function(e){if(e&&!wy.isEmpty(e))try{var t=JSON.parse(e);return 0===Object.keys(t).length}catch(e){}return!0},wy.startsWith=function(e,t){return 0===e.indexOf(t)},wy.endsWith=function(e,t){return e.length>=t.length&&e.lastIndexOf(t)===e.length-t.length},wy.queryStringToObject=function(e){function o(e){return decodeURIComponent(e.replace(/\+/g," "))}var r={},e=e.split("&");return e.forEach(function(e){var t;e.trim()&&(t=(e=e.split(/=(.+)/g,2))[0],e=e[1],t)&&e&&(r[o(t)]=o(e))}),r},wy.trimArrayEntries=function(e){return e.map(function(e){return e.trim()})},wy.removeEmptyStringsFromArray=function(e){return e.filter(function(e){return!wy.isEmpty(e)})},wy.jsonParseHelper=function(e){try{return JSON.parse(e)}catch(e){return null}},wy.matchPattern=function(e,t){return new RegExp(e.replace(/\\/g,"\\\\").replace(/\*/g,"[^ ]*").replace(/\?/g,"\\?")).test(t)};var _y,k=wy;function wy(){}(xi=_y=_y||{})[xi.Error=0]="Error",xi[xi.Warning=1]="Warning",xi[xi.Info=2]="Info",xi[xi.Verbose=3]="Verbose",xi[xi.Trace=4]="Trace";Cy.createDefaultLoggerOptions=function(){return{loggerCallback:function(){},piiLoggingEnabled:!1,logLevel:_y.Info}},Cy.prototype.clone=function(e,t,o){return new Cy({loggerCallback:this.localCallback,piiLoggingEnabled:this.piiLoggingEnabled,logLevel:this.level,correlationId:o||this.correlationId},e,t)},Cy.prototype.logMessage=function(e,t){var o;t.logLevel>this.level||!this.piiLoggingEnabled&&t.containsPii||(o=(new Date).toUTCString(),o=(k.isEmpty(t.correlationId)?k.isEmpty(this.correlationId)?"["+o+"]":"["+o+"] : ["+this.correlationId+"]":"["+o+"] : ["+t.correlationId+"]")+" : "+this.packageName+"@"+this.packageVersion+" : "+_y[t.logLevel]+" - "+e,this.executeCallback(t.logLevel,o,t.containsPii||!1))},Cy.prototype.executeCallback=function(e,t,o){this.localCallback&&this.localCallback(e,t,o)},Cy.prototype.error=function(e,t){this.logMessage(e,{logLevel:_y.Error,containsPii:!1,correlationId:t||E.EMPTY_STRING})},Cy.prototype.errorPii=function(e,t){this.logMessage(e,{logLevel:_y.Error,containsPii:!0,correlationId:t||E.EMPTY_STRING})},Cy.prototype.warning=function(e,t){this.logMessage(e,{logLevel:_y.Warning,containsPii:!1,correlationId:t||E.EMPTY_STRING})},Cy.prototype.warningPii=function(e,t){this.logMessage(e,{logLevel:_y.Warning,containsPii:!0,correlationId:t||E.EMPTY_STRING})},Cy.prototype.info=function(e,t){this.logMessage(e,{logLevel:_y.Info,containsPii:!1,correlationId:t||E.EMPTY_STRING})},Cy.prototype.infoPii=function(e,t){this.logMessage(e,{logLevel:_y.Info,containsPii:!0,correlationId:t||E.EMPTY_STRING})},Cy.prototype.verbose=function(e,t){this.logMessage(e,{logLevel:_y.Verbose,containsPii:!1,correlationId:t||E.EMPTY_STRING})},Cy.prototype.verbosePii=function(e,t){this.logMessage(e,{logLevel:_y.Verbose,containsPii:!0,correlationId:t||E.EMPTY_STRING})},Cy.prototype.trace=function(e,t){this.logMessage(e,{logLevel:_y.Trace,containsPii:!1,correlationId:t||E.EMPTY_STRING})},Cy.prototype.tracePii=function(e,t){this.logMessage(e,{logLevel:_y.Trace,containsPii:!0,correlationId:t||E.EMPTY_STRING})},Cy.prototype.isPiiLoggingEnabled=function(){return this.piiLoggingEnabled||!1};var by=Cy;function Cy(e,t,o){this.level=_y.Info;e=e||Cy.createDefaultLoggerOptions();this.localCallback=e.loggerCallback||function(){},this.piiLoggingEnabled=e.piiLoggingEnabled||!1,this.level="number"==typeof e.logLevel?e.logLevel:_y.Info,this.correlationId=e.correlationId||E.EMPTY_STRING,this.packageName=t||E.EMPTY_STRING,this.packageVersion=o||E.EMPTY_STRING}var Sy,Ey="@azure/msal-common",Ty="13.3.1";(Kt=Sy=Sy||{})[Kt.None=0]="None",Kt.AzurePublic="https://login.microsoftonline.com",Kt.AzurePpe="https://login.windows-ppe.net",Kt.AzureChina="https://login.chinacloudapi.cn",Kt.AzureGermany="https://login.microsoftonline.de",Kt.AzureUsGovernment="https://login.microsoftonline.us";var Iy,ky={code:"redirect_uri_empty",desc:"A redirect URI is required for all calls, and none has been set."},Ay={code:"post_logout_uri_empty",desc:"A post logout redirect has not been set."},Py={code:"claims_request_parsing_error",desc:"Could not parse the given claims request object."},Oy={code:"authority_uri_insecure",desc:"Authority URIs must use https.  Please see here for valid authority configuration options: https://docs.microsoft.com/en-us/azure/active-directory/develop/msal-js-initializing-client-applications#configuration-options"},Ry={code:"url_parse_error",desc:"URL could not be parsed into appropriate segments."},xy={code:"empty_url_error",desc:"URL was empty or null."},My={code:"empty_input_scopes_error",desc:"Scopes cannot be passed as null, undefined or empty array because they are required to obtain an access token."},Ny={code:"clientid_input_scopes_error",desc:"Client ID can only be provided as a single scope."},Ly={code:"invalid_prompt_value",desc:"Supported prompt values are 'login', 'select_account', 'consent', 'create', 'none' and 'no_session'.  Please see here for valid configuration options: https://azuread.github.io/microsoft-authentication-library-for-js/ref/modules/_azure_msal_common.html#commonauthorizationurlrequest"},Dy={code:"invalid_claims",desc:"Given claims parameter must be a stringified JSON object."},qy={code:"token_request_empty",desc:"Token request was empty and not found in cache."},Uy={code:"logout_request_empty",desc:"The logout request was null or undefined."},jy={code:"invalid_code_challenge_method",desc:'code_challenge_method passed is invalid. Valid values are "plain" and "S256".'},Hy={code:"pkce_params_missing",desc:"Both params: code_challenge and code_challenge_method are to be passed if to be sent in the request"},By={code:"invalid_cloud_discovery_metadata",desc:"Invalid cloudDiscoveryMetadata provided. Must be a stringified JSON object containing tenant_discovery_endpoint and metadata fields"},Fy={code:"invalid_authority_metadata",desc:"Invalid authorityMetadata provided. Must by a stringified JSON object containing authorization_endpoint, token_endpoint, issuer fields."},zy={code:"untrusted_authority",desc:"The provided authority is not a trusted authority. Please include this authority in the knownAuthorities config parameter."},Ky={code:"invalid_azure_cloud_instance",desc:"Invalid AzureCloudInstance provided. Please refer MSAL JS docs: aks.ms/msaljs/azure_cloud_instance for valid values"},Gy={code:"missing_ssh_jwk",desc:"Missing sshJwk in SSH certificate request. A stringified JSON Web Key is required when using the SSH authentication scheme."},Yy={code:"missing_ssh_kid",desc:"Missing sshKid in SSH certificate request. A string that uniquely identifies the public SSH key is required when using the SSH authentication scheme."},Wy={code:"missing_nonce_authentication_header",desc:"Unable to find an authentication header containing server nonce. Either the Authentication-Info or WWW-Authenticate headers must be present in order to obtain a server nonce."},Zy={code:"invalid_authentication_header",desc:"Invalid authentication header provided"},Qy={code:"authority_mismatch",desc:"Authority mismatch error. Authority provided in login request or PublicClientApplication config does not match the environment of the provided account. Please use a matching account or make an interactive request to login to this authority."},Vy=(Hg(h,Iy=I),h.createRedirectUriEmptyError=function(){return new h(ky.code,ky.desc)},h.createPostLogoutRedirectUriEmptyError=function(){return new h(Ay.code,Ay.desc)},h.createClaimsRequestParsingError=function(e){return new h(Py.code,Py.desc+" Given value: "+e)},h.createInsecureAuthorityUriError=function(e){return new h(Oy.code,Oy.desc+" Given URI: "+e)},h.createUrlParseError=function(e){return new h(Ry.code,Ry.desc+" Given Error: "+e)},h.createUrlEmptyError=function(){return new h(xy.code,xy.desc)},h.createEmptyScopesArrayError=function(){return new h(My.code,""+My.desc)},h.createClientIdSingleScopeError=function(e){return new h(Ny.code,Ny.desc+" Given Scopes: "+e)},h.createInvalidPromptError=function(e){return new h(Ly.code,Ly.desc+" Given value: "+e)},h.createInvalidClaimsRequestError=function(){return new h(Dy.code,Dy.desc)},h.createEmptyLogoutRequestError=function(){return new h(Uy.code,Uy.desc)},h.createEmptyTokenRequestError=function(){return new h(qy.code,qy.desc)},h.createInvalidCodeChallengeMethodError=function(){return new h(jy.code,jy.desc)},h.createInvalidCodeChallengeParamsError=function(){return new h(Hy.code,Hy.desc)},h.createInvalidCloudDiscoveryMetadataError=function(){return new h(By.code,By.desc)},h.createInvalidAuthorityMetadataError=function(){return new h(Fy.code,Fy.desc)},h.createUntrustedAuthorityError=function(){return new h(zy.code,zy.desc)},h.createInvalidAzureCloudInstanceError=function(){return new h(Ky.code,Ky.desc)},h.createMissingSshJwkError=function(){return new h(Gy.code,Gy.desc)},h.createMissingSshKidError=function(){return new h(Yy.code,Yy.desc)},h.createMissingNonceAuthenticationHeadersError=function(){return new h(Wy.code,Wy.desc)},h.createInvalidAuthenticationHeaderError=function(e,t){return new h(Zy.code,Zy.desc+". Invalid header: "+e+". Details: "+t)},h.createAuthorityMismatchError=function(){return new h(Qy.code,Qy.desc)},h);function h(e,t){e=Iy.call(this,e,t)||this;return e.name="ClientConfigurationError",Object.setPrototypeOf(e,h.prototype),e}$y.fromString=function(e){return new $y((e||E.EMPTY_STRING).split(" "))},$y.createSearchScopes=function(e){e=new $y(e);return e.containsOnlyOIDCScopes()?e.removeScope(E.OFFLINE_ACCESS_SCOPE):e.removeOIDCScopes(),e},$y.prototype.validateInputScopes=function(e){if(!e||e.length<1)throw Vy.createEmptyScopesArrayError()},$y.prototype.containsScope=function(e){var t=new $y(this.printScopesLowerCase().split(" "));return!k.isEmpty(e)&&t.scopes.has(e.toLowerCase())},$y.prototype.containsScopeSet=function(e){var t=this;return!(!e||e.scopes.size<=0)&&this.scopes.size>=e.scopes.size&&e.asArray().every(function(e){return t.containsScope(e)})},$y.prototype.containsOnlyOIDCScopes=function(){var t=this,o=0;return om.forEach(function(e){t.containsScope(e)&&(o+=1)}),this.scopes.size===o},$y.prototype.appendScope=function(e){k.isEmpty(e)||this.scopes.add(e.trim())},$y.prototype.appendScopes=function(e){var t=this;try{e.forEach(function(e){return t.appendScope(e)})}catch(e){throw I.createAppendScopeSetError(e)}},$y.prototype.removeScope=function(e){if(k.isEmpty(e))throw I.createRemoveEmptyScopeFromSetError(e);this.scopes.delete(e.trim())},$y.prototype.removeOIDCScopes=function(){var t=this;om.forEach(function(e){t.scopes.delete(e)})},$y.prototype.unionScopeSets=function(e){var t;if(e)return t=new Set,e.scopes.forEach(function(e){return t.add(e.toLowerCase())}),this.scopes.forEach(function(e){return t.add(e.toLowerCase())}),t;throw I.createEmptyInputScopeSetError()},$y.prototype.intersectingScopeSets=function(e){if(!e)throw I.createEmptyInputScopeSetError();e.containsOnlyOIDCScopes()||e.removeOIDCScopes();var t=this.unionScopeSets(e),e=e.getScopeCount(),o=this.getScopeCount();return t.size<o+e},$y.prototype.getScopeCount=function(){return this.scopes.size},$y.prototype.asArray=function(){var t=[];return this.scopes.forEach(function(e){return t.push(e)}),t},$y.prototype.printScopes=function(){return this.scopes?this.asArray().join(" "):E.EMPTY_STRING},$y.prototype.printScopesLowerCase=function(){return this.printScopes().toLowerCase()};var Jy,Xy=$y;function $y(e){var t=this,e=e?k.trimArrayEntries(Fg(e)):[],e=e?k.removeEmptyStringsFromArray(e):[];this.validateInputScopes(e),this.scopes=new Set,e.forEach(function(e){return t.scopes.add(e)})}function ev(e,t){if(k.isEmpty(e))throw I.createClientInfoEmptyError();try{var o=t.base64Decode(e);return JSON.parse(o)}catch(e){throw I.createClientInfoDecodingError(e.message)}}function tv(e){if(k.isEmpty(e))throw I.createClientInfoDecodingError("Home account ID was empty.");e=e.split(Jg.CLIENT_INFO_SEPARATOR,2);return{uid:e[0],utid:e.length<2?E.EMPTY_STRING:e[1]}}(o=Jy=Jy||{})[o.Default=0]="Default",o[o.Adfs=1]="Adfs",o[o.Dsts=2]="Dsts",o[o.Ciam=3]="Ciam";rv.prototype.generateAccountId=function(){return[this.homeAccountId,this.environment].join(Jg.CACHE_KEY_SEPARATOR).toLowerCase()},rv.prototype.generateAccountKey=function(){return rv.generateAccountCacheKey({homeAccountId:this.homeAccountId,environment:this.environment,tenantId:this.realm,username:this.username,localAccountId:this.localAccountId})},rv.prototype.generateType=function(){switch(this.authorityType){case Vg.ADFS_ACCOUNT_TYPE:return Xg.ADFS;case Vg.MSAV1_ACCOUNT_TYPE:return Xg.MSA;case Vg.MSSTS_ACCOUNT_TYPE:return Xg.MSSTS;case Vg.GENERIC_ACCOUNT_TYPE:return Xg.GENERIC;default:throw I.createUnexpectedAccountTypeError()}},rv.prototype.getAccountInfo=function(){return{homeAccountId:this.homeAccountId,environment:this.environment,tenantId:this.realm,username:this.username,localAccountId:this.localAccountId,name:this.name,idTokenClaims:this.idTokenClaims,nativeAccountId:this.nativeAccountId}},rv.generateAccountCacheKey=function(e){return[e.homeAccountId,e.environment||E.EMPTY_STRING,e.tenantId||E.EMPTY_STRING].join(Jg.CACHE_KEY_SEPARATOR).toLowerCase()},rv.createAccount=function(e,t,o,r,n,i,a,s){var c=new rv,e=(c.authorityType=Vg.MSSTS_ACCOUNT_TYPE,c.clientInfo=e,c.homeAccountId=t,c.nativeAccountId=s,a||r&&r.getPreferredCache());if(e)return c.environment=e,c.realm=(null==(t=null==o?void 0:o.claims)?void 0:t.tid)||E.EMPTY_STRING,o&&(c.idTokenClaims=o.claims,c.localAccountId=(null==(s=null==o?void 0:o.claims)?void 0:s.oid)||(null==(a=null==o?void 0:o.claims)?void 0:a.sub)||E.EMPTY_STRING,e=null==(r=null==o?void 0:o.claims)?void 0:r.preferred_username,s=null!=(t=null==o?void 0:o.claims)&&t.emails?o.claims.emails[0]:null,c.username=e||s||E.EMPTY_STRING,c.name=null==(a=null==o?void 0:o.claims)?void 0:a.name),c.cloudGraphHostName=n,c.msGraphHost=i,c;throw I.createInvalidCacheEnvironmentError()},rv.createGenericAccount=function(e,t,o,r,n,i){var a=new rv,e=(a.authorityType=o&&o.authorityType===Jy.Adfs?Vg.ADFS_ACCOUNT_TYPE:Vg.GENERIC_ACCOUNT_TYPE,a.homeAccountId=e,a.realm=E.EMPTY_STRING,i||o&&o.getPreferredCache());if(e)return t&&(a.localAccountId=(null==(i=null==t?void 0:t.claims)?void 0:i.oid)||(null==(o=null==t?void 0:t.claims)?void 0:o.sub)||E.EMPTY_STRING,a.username=(null==(i=null==t?void 0:t.claims)?void 0:i.upn)||E.EMPTY_STRING,a.name=(null==(o=null==t?void 0:t.claims)?void 0:o.name)||E.EMPTY_STRING,a.idTokenClaims=null==t?void 0:t.claims),a.environment=e,a.cloudGraphHostName=r,a.msGraphHost=n,a;throw I.createInvalidCacheEnvironmentError()},rv.generateHomeAccountId=function(e,t,o,r,n){var i=null!=(i=null==n?void 0:n.claims)&&i.sub?n.claims.sub:E.EMPTY_STRING;if(t!==Jy.Adfs&&t!==Jy.Dsts){if(e)try{var a=ev(e,r);if(!k.isEmpty(a.uid)&&!k.isEmpty(a.utid))return""+a.uid+Jg.CLIENT_INFO_SEPARATOR+a.utid}catch(e){}o.verbose("No client info in response")}return i},rv.isAccountEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("realm")&&e.hasOwnProperty("localAccountId")&&e.hasOwnProperty("username")&&e.hasOwnProperty("authorityType")},rv.accountInfoIsEqual=function(e,t,o){var r,n;return!(!e||!t)&&(n=!0,o&&(o=e.idTokenClaims||{},r=t.idTokenClaims||{},n=o.iat===r.iat&&o.nonce===r.nonce),e.homeAccountId===t.homeAccountId)&&e.localAccountId===t.localAccountId&&e.username===t.username&&e.tenantId===t.tenantId&&e.environment===t.environment&&e.nativeAccountId===t.nativeAccountId&&n};var ov=rv;function rv(){}iv.extractTokenClaims=function(e,t){e=k.decodeAuthToken(e);try{var o=e.JWSPayload,r=t.base64Decode(o);return JSON.parse(r)}catch(e){throw I.createTokenParsingError(e)}},iv.checkMaxAge=function(e,t){if(0===t||Date.now()-3e5>e+t)throw I.createMaxAgeTranspiredError()};var nv=iv;function iv(e,t){if(k.isEmpty(e))throw I.createTokenNullOrEmptyError(e);this.rawToken=e,this.claims=iv.extractTokenClaims(e,t)}d.prototype.getAllAccounts=function(){var o=this,e=this.getAccountKeys();return e.length<1||(e=e.reduce(function(e,t){t=o.getAccount(t);return t&&e.push(t),e},[])).length<1?[]:e.map(function(e){return o.getAccountInfoFromEntity(e)})},d.prototype.getAccountInfoFilteredBy=function(e){e=this.getAccountsFilteredBy(e);return 0<e.length?this.getAccountInfoFromEntity(e[0]):null},d.prototype.getAccountInfoFromEntity=function(e){var e=e.getAccountInfo(),t=this.getIdToken(e);return t&&(e.idToken=t.secret,e.idTokenClaims=new nv(t.secret,this.cryptoImpl).claims),e},d.prototype.saveCacheRecord=function(t){return b(this,void 0,void 0,function(){return C(this,function(e){switch(e.label){case 0:if(t)return t.account&&this.setAccount(t.account),t.idToken&&this.setIdTokenCredential(t.idToken),t.accessToken?[4,this.saveAccessToken(t.accessToken)]:[3,2];throw I.createNullOrUndefinedCacheRecord();case 1:e.sent(),e.label=2;case 2:return t.refreshToken&&this.setRefreshTokenCredential(t.refreshToken),t.appMetadata&&this.setAppMetadata(t.appMetadata),[2]}})})},d.prototype.saveAccessToken=function(a){return b(this,void 0,void 0,function(){var o,t,r,n,i=this;return C(this,function(e){switch(e.label){case 0:return o={clientId:a.clientId,credentialType:a.credentialType,environment:a.environment,homeAccountId:a.homeAccountId,realm:a.realm,tokenType:a.tokenType,requestedClaimsHash:a.requestedClaimsHash},t=this.getTokenKeys(),r=Xy.fromString(a.target),n=[],t.accessToken.forEach(function(e){var t;i.accessTokenKeyMatchesFilter(e,o,!1)&&(t=i.getAccessTokenCredential(e))&&i.credentialMatchesFilter(t,o)&&Xy.fromString(t.target).intersectingScopeSets(r)&&n.push(i.removeAccessToken(e))}),[4,Promise.all(n)];case 1:return e.sent(),this.setAccessTokenCredential(a),[2]}})})},d.prototype.getAccountsFilteredBy=function(t){var o=this,e=this.getAccountKeys(),r=[];return e.forEach(function(e){!o.isAccountKey(e,t.homeAccountId,t.realm)||!(e=o.getAccount(e))||t.homeAccountId&&!o.matchHomeAccountId(e,t.homeAccountId)||t.localAccountId&&!o.matchLocalAccountId(e,t.localAccountId)||t.username&&!o.matchUsername(e,t.username)||t.environment&&!o.matchEnvironment(e,t.environment)||t.realm&&!o.matchRealm(e,t.realm)||t.nativeAccountId&&!o.matchNativeAccountId(e,t.nativeAccountId)||r.push(e)}),r},d.prototype.isAccountKey=function(e,t,o){return!(e.split(Jg.CACHE_KEY_SEPARATOR).length<3||t&&!e.toLowerCase().includes(t.toLowerCase())||o&&!e.toLowerCase().includes(o.toLowerCase()))},d.prototype.isCredentialKey=function(e){if(e.split(Jg.CACHE_KEY_SEPARATOR).length<6)return!1;e=e.toLowerCase();if(-1===e.indexOf(S.ID_TOKEN.toLowerCase())&&-1===e.indexOf(S.ACCESS_TOKEN.toLowerCase())&&-1===e.indexOf(S.ACCESS_TOKEN_WITH_AUTH_SCHEME.toLowerCase())&&-1===e.indexOf(S.REFRESH_TOKEN.toLowerCase()))return!1;if(-1<e.indexOf(S.REFRESH_TOKEN.toLowerCase())){var t=""+S.REFRESH_TOKEN+Jg.CACHE_KEY_SEPARATOR+this.clientId+Jg.CACHE_KEY_SEPARATOR,o=""+S.REFRESH_TOKEN+Jg.CACHE_KEY_SEPARATOR+"1"+Jg.CACHE_KEY_SEPARATOR;if(-1===e.indexOf(t.toLowerCase())&&-1===e.indexOf(o.toLowerCase()))return!1}else if(-1===e.indexOf(this.clientId.toLowerCase()))return!1;return!0},d.prototype.credentialMatchesFilter=function(e,t){if(t.clientId&&!this.matchClientId(e,t.clientId))return!1;if(t.userAssertionHash&&!this.matchUserAssertionHash(e,t.userAssertionHash))return!1;if("string"==typeof t.homeAccountId&&!this.matchHomeAccountId(e,t.homeAccountId))return!1;if(t.environment&&!this.matchEnvironment(e,t.environment))return!1;if(t.realm&&!this.matchRealm(e,t.realm))return!1;if(t.credentialType&&!this.matchCredentialType(e,t.credentialType))return!1;if(t.familyId&&!this.matchFamilyId(e,t.familyId))return!1;if(t.target&&!this.matchTarget(e,t.target))return!1;if((t.requestedClaimsHash||e.requestedClaimsHash)&&e.requestedClaimsHash!==t.requestedClaimsHash)return!1;if(e.credentialType===S.ACCESS_TOKEN_WITH_AUTH_SCHEME){if(t.tokenType&&!this.matchTokenType(e,t.tokenType))return!1;if(t.tokenType===em.SSH&&t.keyId&&!this.matchKeyId(e,t.keyId))return!1}return!0},d.prototype.getAppMetadataFilteredBy=function(e){return this.getAppMetadataFilteredByInternal(e.environment,e.clientId)},d.prototype.getAppMetadataFilteredByInternal=function(o,r){var n=this,e=this.getKeys(),i={};return e.forEach(function(e){var t;!n.isAppMetadata(e)||!(t=n.getAppMetadata(e))||o&&!n.matchEnvironment(t,o)||r&&!n.matchClientId(t,r)||(i[e]=t)}),i},d.prototype.getAuthorityMetadataByAlias=function(t){var o=this,e=this.getAuthorityMetadataKeys(),r=null;return e.forEach(function(e){o.isAuthorityMetadata(e)&&-1!==e.indexOf(o.clientId)&&(e=o.getAuthorityMetadata(e))&&-1!==e.aliases.indexOf(t)&&(r=e)}),r},d.prototype.removeAllAccounts=function(){return b(this,void 0,void 0,function(){var t,o,r=this;return C(this,function(e){switch(e.label){case 0:return t=this.getAccountKeys(),o=[],t.forEach(function(e){o.push(r.removeAccount(e))}),[4,Promise.all(o)];case 1:return e.sent(),[2]}})})},d.prototype.removeAccount=function(o){return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:if(t=this.getAccount(o))return[4,this.removeAccountContext(t)];throw I.createNoAccountFoundError();case 1:return e.sent(),this.removeItem(o),[2]}})})},d.prototype.removeAccountContext=function(i){return b(this,void 0,void 0,function(){var t,o,r,n=this;return C(this,function(e){switch(e.label){case 0:return t=this.getTokenKeys(),o=i.generateAccountId(),r=[],t.idToken.forEach(function(e){0===e.indexOf(o)&&n.removeIdToken(e)}),t.accessToken.forEach(function(e){0===e.indexOf(o)&&r.push(n.removeAccessToken(e))}),t.refreshToken.forEach(function(e){0===e.indexOf(o)&&n.removeRefreshToken(e)}),[4,Promise.all(r)];case 1:return e.sent(),[2]}})})},d.prototype.removeAccessToken=function(o){return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:if(!(t=this.getAccessTokenCredential(o)))return[2];if(t.credentialType.toLowerCase()!==S.ACCESS_TOKEN_WITH_AUTH_SCHEME.toLowerCase())return[3,4];if(t.tokenType!==em.POP)return[3,4];if(!(t=t.keyId))return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.cryptoImpl.removeTokenBindingKey(t)];case 2:return e.sent(),[3,4];case 3:throw e.sent(),I.createBindingKeyNotRemovedError();case 4:return[2,this.removeItem(o)]}})})},d.prototype.removeAppMetadata=function(){var t=this;return this.getKeys().forEach(function(e){t.isAppMetadata(e)&&t.removeItem(e)}),!0},d.prototype.readCacheRecord=function(e,t,o){var r=this.getTokenKeys(),n=this.readAccountFromCache(e),i=this.getIdToken(e,r),t=this.getAccessToken(e,t,r),e=this.getRefreshToken(e,!1,r),r=this.readAppMetadataFromCache(o);return n&&i&&(n.idTokenClaims=new nv(i.secret,this.cryptoImpl).claims),{account:n,idToken:i,accessToken:t,refreshToken:e,appMetadata:r}},d.prototype.readAccountFromCache=function(e){e=ov.generateAccountCacheKey(e);return this.getAccount(e)},d.prototype.getIdToken=function(e,t){var o=this,e=(this.commonLogger.trace("CacheManager - getIdToken called"),{homeAccountId:e.homeAccountId,environment:e.environment,credentialType:S.ID_TOKEN,clientId:this.clientId,realm:e.tenantId}),e=this.getIdTokensByFilter(e,t),t=e.length;return t<1?(this.commonLogger.info("CacheManager:getIdToken - No token found"),null):1<t?(this.commonLogger.info("CacheManager:getIdToken - Multiple id tokens found, clearing them"),e.forEach(function(e){o.removeIdToken(e.generateCredentialKey())}),null):(this.commonLogger.info("CacheManager:getIdToken - Returning id token"),e[0])},d.prototype.getIdTokensByFilter=function(t,e){var o=this,e=e&&e.idToken||this.getTokenKeys().idToken,r=[];return e.forEach(function(e){o.idTokenKeyMatchesFilter(e,Bg({clientId:o.clientId},t))&&(e=o.getIdTokenCredential(e))&&o.credentialMatchesFilter(e,t)&&r.push(e)}),r},d.prototype.idTokenKeyMatchesFilter=function(e,t){e=e.toLowerCase();return!(t.clientId&&-1===e.indexOf(t.clientId.toLowerCase())||t.homeAccountId&&-1===e.indexOf(t.homeAccountId.toLowerCase()))},d.prototype.removeIdToken=function(e){this.removeItem(e)},d.prototype.removeRefreshToken=function(e){this.removeItem(e)},d.prototype.getAccessToken=function(e,t,o){var r=this,n=(this.commonLogger.trace("CacheManager - getAccessToken called"),Xy.createSearchScopes(t.scopes)),i=t.authenticationScheme||em.BEARER,a=i&&i.toLowerCase()!==em.BEARER.toLowerCase()?S.ACCESS_TOKEN_WITH_AUTH_SCHEME:S.ACCESS_TOKEN,s={homeAccountId:e.homeAccountId,environment:e.environment,credentialType:a,clientId:this.clientId,realm:e.tenantId,target:n,tokenType:i,keyId:t.sshKid,requestedClaimsHash:t.requestedClaimsHash},a=o&&o.accessToken||this.getTokenKeys().accessToken,c=[],e=(a.forEach(function(e){r.accessTokenKeyMatchesFilter(e,s,!0)&&(e=r.getAccessTokenCredential(e))&&r.credentialMatchesFilter(e,s)&&c.push(e)}),c.length);return e<1?(this.commonLogger.info("CacheManager:getAccessToken - No token found"),null):1<e?(this.commonLogger.info("CacheManager:getAccessToken - Multiple access tokens found, clearing them"),c.forEach(function(e){r.removeAccessToken(e.generateCredentialKey())}),null):(this.commonLogger.info("CacheManager:getAccessToken - Returning access token"),c[0])},d.prototype.accessTokenKeyMatchesFilter=function(e,t,o){var r=e.toLowerCase();if(t.clientId&&-1===r.indexOf(t.clientId.toLowerCase()))return!1;if(t.homeAccountId&&-1===r.indexOf(t.homeAccountId.toLowerCase()))return!1;if(t.realm&&-1===r.indexOf(t.realm.toLowerCase()))return!1;if(t.requestedClaimsHash&&-1===r.indexOf(t.requestedClaimsHash.toLowerCase()))return!1;if(t.target)for(var n=t.target.asArray(),i=0;i<n.length;i++){if(o&&!r.includes(n[i].toLowerCase()))return!1;if(!o&&r.includes(n[i].toLowerCase()))return!0}return!0},d.prototype.getAccessTokensByFilter=function(t){var o=this,e=this.getTokenKeys(),r=[];return e.accessToken.forEach(function(e){o.accessTokenKeyMatchesFilter(e,t,!0)&&(e=o.getAccessTokenCredential(e))&&o.credentialMatchesFilter(e,t)&&r.push(e)}),r},d.prototype.getRefreshToken=function(e,t,o){var r=this,t=(this.commonLogger.trace("CacheManager - getRefreshToken called"),t?"1":void 0),n={homeAccountId:e.homeAccountId,environment:e.environment,credentialType:S.REFRESH_TOKEN,clientId:this.clientId,familyId:t},e=o&&o.refreshToken||this.getTokenKeys().refreshToken,i=[];return e.forEach(function(e){r.refreshTokenKeyMatchesFilter(e,n)&&(e=r.getRefreshTokenCredential(e))&&r.credentialMatchesFilter(e,n)&&i.push(e)}),i.length<1?(this.commonLogger.info("CacheManager:getRefreshToken - No refresh token found."),null):(this.commonLogger.info("CacheManager:getRefreshToken - returning refresh token"),i[0])},d.prototype.refreshTokenKeyMatchesFilter=function(e,t){e=e.toLowerCase();return!(t.familyId&&-1===e.indexOf(t.familyId.toLowerCase())||!t.familyId&&t.clientId&&-1===e.indexOf(t.clientId.toLowerCase())||t.homeAccountId&&-1===e.indexOf(t.homeAccountId.toLowerCase()))},d.prototype.readAppMetadataFromCache=function(e){var e={environment:e,clientId:this.clientId},t=this.getAppMetadataFilteredBy(e),e=Object.keys(t).map(function(e){return t[e]}),o=e.length;if(o<1)return null;if(1<o)throw I.createMultipleMatchingAppMetadataInCacheError();return e[0]},d.prototype.isAppMetadataFOCI=function(e){e=this.readAppMetadataFromCache(e);return!(!e||"1"!==e.familyId)},d.prototype.matchHomeAccountId=function(e,t){return!("string"!=typeof e.homeAccountId||t!==e.homeAccountId)},d.prototype.matchLocalAccountId=function(e,t){return!("string"!=typeof e.localAccountId||t!==e.localAccountId)},d.prototype.matchUsername=function(e,t){return!("string"!=typeof e.username||t.toLowerCase()!==e.username.toLowerCase())},d.prototype.matchUserAssertionHash=function(e,t){return!(!e.userAssertionHash||t!==e.userAssertionHash)},d.prototype.matchEnvironment=function(e,t){t=this.getAuthorityMetadataByAlias(t);return!!(t&&-1<t.aliases.indexOf(e.environment))},d.prototype.matchCredentialType=function(e,t){return e.credentialType&&t.toLowerCase()===e.credentialType.toLowerCase()},d.prototype.matchClientId=function(e,t){return!(!e.clientId||t!==e.clientId)},d.prototype.matchFamilyId=function(e,t){return!(!e.familyId||t!==e.familyId)},d.prototype.matchRealm=function(e,t){return!(!e.realm||t!==e.realm)},d.prototype.matchNativeAccountId=function(e,t){return!(!e.nativeAccountId||t!==e.nativeAccountId)},d.prototype.matchTarget=function(e,t){return!(e.credentialType!==S.ACCESS_TOKEN&&e.credentialType!==S.ACCESS_TOKEN_WITH_AUTH_SCHEME||!e.target)&&Xy.fromString(e.target).containsScopeSet(t)},d.prototype.matchTokenType=function(e,t){return!(!e.tokenType||e.tokenType!==t)},d.prototype.matchKeyId=function(e,t){return!(!e.keyId||e.keyId!==t)},d.prototype.isAppMetadata=function(e){return-1!==e.indexOf(im)},d.prototype.isAuthorityMetadata=function(e){return-1!==e.indexOf(am)},d.prototype.generateAuthorityMetadataCacheKey=function(e){return am+"-"+this.clientId+"-"+e},d.toObject=function(e,t){for(var o in t)e[o]=t[o];return e};var av=d;function d(e,t,o){this.clientId=e,this.cryptoImpl=t,this.commonLogger=o.clone(Ey,Ty)}Hg(uv,sv=av),uv.prototype.setAccount=function(){throw T.createUnexpectedError("Storage interface - setAccount() has not been implemented for the cacheStorage interface.")},uv.prototype.getAccount=function(){throw T.createUnexpectedError("Storage interface - getAccount() has not been implemented for the cacheStorage interface.")},uv.prototype.setIdTokenCredential=function(){throw T.createUnexpectedError("Storage interface - setIdTokenCredential() has not been implemented for the cacheStorage interface.")},uv.prototype.getIdTokenCredential=function(){throw T.createUnexpectedError("Storage interface - getIdTokenCredential() has not been implemented for the cacheStorage interface.")},uv.prototype.setAccessTokenCredential=function(){throw T.createUnexpectedError("Storage interface - setAccessTokenCredential() has not been implemented for the cacheStorage interface.")},uv.prototype.getAccessTokenCredential=function(){throw T.createUnexpectedError("Storage interface - getAccessTokenCredential() has not been implemented for the cacheStorage interface.")},uv.prototype.setRefreshTokenCredential=function(){throw T.createUnexpectedError("Storage interface - setRefreshTokenCredential() has not been implemented for the cacheStorage interface.")},uv.prototype.getRefreshTokenCredential=function(){throw T.createUnexpectedError("Storage interface - getRefreshTokenCredential() has not been implemented for the cacheStorage interface.")},uv.prototype.setAppMetadata=function(){throw T.createUnexpectedError("Storage interface - setAppMetadata() has not been implemented for the cacheStorage interface.")},uv.prototype.getAppMetadata=function(){throw T.createUnexpectedError("Storage interface - getAppMetadata() has not been implemented for the cacheStorage interface.")},uv.prototype.setServerTelemetry=function(){throw T.createUnexpectedError("Storage interface - setServerTelemetry() has not been implemented for the cacheStorage interface.")},uv.prototype.getServerTelemetry=function(){throw T.createUnexpectedError("Storage interface - getServerTelemetry() has not been implemented for the cacheStorage interface.")},uv.prototype.setAuthorityMetadata=function(){throw T.createUnexpectedError("Storage interface - setAuthorityMetadata() has not been implemented for the cacheStorage interface.")},uv.prototype.getAuthorityMetadata=function(){throw T.createUnexpectedError("Storage interface - getAuthorityMetadata() has not been implemented for the cacheStorage interface.")},uv.prototype.getAuthorityMetadataKeys=function(){throw T.createUnexpectedError("Storage interface - getAuthorityMetadataKeys() has not been implemented for the cacheStorage interface.")},uv.prototype.setThrottlingCache=function(){throw T.createUnexpectedError("Storage interface - setThrottlingCache() has not been implemented for the cacheStorage interface.")},uv.prototype.getThrottlingCache=function(){throw T.createUnexpectedError("Storage interface - getThrottlingCache() has not been implemented for the cacheStorage interface.")},uv.prototype.removeItem=function(){throw T.createUnexpectedError("Storage interface - removeItem() has not been implemented for the cacheStorage interface.")},uv.prototype.containsKey=function(){throw T.createUnexpectedError("Storage interface - containsKey() has not been implemented for the cacheStorage interface.")},uv.prototype.getKeys=function(){throw T.createUnexpectedError("Storage interface - getKeys() has not been implemented for the cacheStorage interface.")},uv.prototype.getAccountKeys=function(){throw T.createUnexpectedError("Storage interface - getAccountKeys() has not been implemented for the cacheStorage interface.")},uv.prototype.getTokenKeys=function(){throw T.createUnexpectedError("Storage interface - getTokenKeys() has not been implemented for the cacheStorage interface.")},uv.prototype.clear=function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Storage interface - clear() has not been implemented for the cacheStorage interface.")})})},uv.prototype.updateCredentialCacheKey=function(){throw T.createUnexpectedError("Storage interface - updateCredentialCacheKey() has not been implemented for the cacheStorage interface.")};var sv,cv=uv;function uv(){return null!==sv&&sv.apply(this,arguments)||this}var lv={tokenRenewalOffsetSeconds:300,preventCorsPreflight:!1},hv={loggerCallback:function(){},piiLoggingEnabled:!1,logLevel:_y.Info,correlationId:E.EMPTY_STRING},dv={claimsBasedCachingEnabled:!0},pv={sendGetRequestAsync:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Network interface - sendGetRequestAsync() has not been implemented")})})},sendPostRequestAsync:function(){return b(this,void 0,void 0,function(){return C(this,function(e){throw T.createUnexpectedError("Network interface - sendPostRequestAsync() has not been implemented")})})}},fv={sku:E.SKU,version:Ty,cpu:E.EMPTY_STRING,os:E.EMPTY_STRING},gv={clientSecret:E.EMPTY_STRING,clientAssertion:void 0},mv={azureCloudInstance:Sy.None,tenant:""+E.DEFAULT_COMMON_TENANT},yv={application:{appName:"",appVersion:""}};function vv(e){var t=e.authOptions,o=e.systemOptions,r=e.loggerOptions,n=e.cacheOptions,i=e.storageInterface,a=e.networkInterface,s=e.cryptoInterface,c=e.clientCredentials,u=e.libraryInfo,l=e.telemetry,h=e.serverTelemetryManager,d=e.persistencePlugin,e=e.serializableCache,r=Bg(Bg({},hv),r);return{authOptions:Bg({clientCapabilities:[],azureCloudOptions:mv,skipAuthorityMetadataCache:!1},t),systemOptions:Bg(Bg({},lv),o),loggerOptions:r,cacheOptions:Bg(Bg({},dv),n),storageInterface:i||new cv(t.clientId,Im,new by(r)),networkInterface:a||pv,cryptoInterface:s||Im,clientCredentials:c||gv,libraryInfo:Bg(Bg({},fv),u),telemetry:Bg(Bg({},yv),l),serverTelemetryManager:h||null,persistencePlugin:d||null,serializableCache:e||null}}Hg(bv,_v=T);var _v,wv=bv;function bv(e,t,o){e=_v.call(this,e,t,o)||this;return e.name="ServerError",Object.setPrototypeOf(e,bv.prototype),e}Sv.generateThrottlingStorageKey=function(e){return ym+"."+JSON.stringify(e)},Sv.preProcess=function(e,t){var o,t=Sv.generateThrottlingStorageKey(t),r=e.getThrottlingCache(t);if(r){if(!(r.throttleTime<Date.now()))throw new wv((null==(o=r.errorCodes)?void 0:o.join(" "))||E.EMPTY_STRING,r.errorMessage,r.subError);e.removeItem(t)}},Sv.postProcess=function(e,t,o){(Sv.checkResponseStatus(o)||Sv.checkResponseForRetryAfter(o))&&(o={throttleTime:Sv.calculateThrottleTime(parseInt(o.headers[zg.RETRY_AFTER])),error:o.body.error,errorCodes:o.body.error_codes,errorMessage:o.body.error_description,subError:o.body.suberror},e.setThrottlingCache(Sv.generateThrottlingStorageKey(t),o))},Sv.checkResponseStatus=function(e){return 429===e.status||500<=e.status&&e.status<600},Sv.checkResponseForRetryAfter=function(e){return!!e.headers&&e.headers.hasOwnProperty(zg.RETRY_AFTER)&&(e.status<200||300<=e.status)},Sv.calculateThrottleTime=function(e){var e=e<=0?0:e,t=Date.now()/1e3;return Math.floor(1e3*Math.min(t+(e||gm),t+mm))},Sv.removeThrottle=function(e,t,o,r){t={clientId:t,authority:o.authority,scopes:o.scopes,homeAccountIdentifier:r,claims:o.claims,authenticationScheme:o.authenticationScheme,resourceRequestMethod:o.resourceRequestMethod,resourceRequestUri:o.resourceRequestUri,shrClaims:o.shrClaims,sshKid:o.sshKid},r=this.generateThrottlingStorageKey(t);e.removeItem(r)};var Cv=Sv;function Sv(){}Iv.prototype.sendPostRequest=function(r,n,i){return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){switch(e.label){case 0:Cv.preProcess(this.cacheManager,r),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkClient.sendPostRequestAsync(n,i)];case 2:return t=e.sent(),[3,4];case 3:throw(o=e.sent())instanceof T?o:I.createNetworkError(n,o);case 4:return Cv.postProcess(this.cacheManager,r,t),[2,t]}})})};var Ev,Tv=Iv;function Iv(e,t){this.networkClient=e,this.cacheManager=t}(jo=Ev=Ev||{}).HOME_ACCOUNT_ID="home_account_id",jo.UPN="UPN";Av.validateRedirectUri=function(e){if(k.isEmpty(e))throw Vy.createRedirectUriEmptyError()},Av.validatePrompt=function(e){var t,o=[];for(t in rm)o.push(rm[t]);if(o.indexOf(e)<0)throw Vy.createInvalidPromptError(e)},Av.validateClaims=function(e){try{JSON.parse(e)}catch(e){throw Vy.createInvalidClaimsRequestError()}},Av.validateCodeChallengeParams=function(e,t){if(k.isEmpty(e)||k.isEmpty(t))throw Vy.createInvalidCodeChallengeParamsError();this.validateCodeChallengeMethod(t)},Av.validateCodeChallengeMethod=function(e){if([nm.PLAIN,nm.S256].indexOf(e)<0)throw Vy.createInvalidCodeChallengeMethodError()},Av.sanitizeEQParams=function(o,e){return o?(e.forEach(function(e,t){o[t]&&delete o[t]}),Object.fromEntries(Object.entries(o).filter(function(e){return""!==e[1]}))):{}};var kv=Av;function Av(){}p.prototype.addResponseTypeCode=function(){this.parameters.set(u.RESPONSE_TYPE,encodeURIComponent(E.CODE_RESPONSE_TYPE))},p.prototype.addResponseTypeForTokenAndIdToken=function(){this.parameters.set(u.RESPONSE_TYPE,encodeURIComponent(E.TOKEN_RESPONSE_TYPE+" "+E.ID_TOKEN_RESPONSE_TYPE))},p.prototype.addResponseMode=function(e){this.parameters.set(u.RESPONSE_MODE,encodeURIComponent(e||Zg.QUERY))},p.prototype.addNativeBroker=function(){this.parameters.set(u.NATIVE_BROKER,encodeURIComponent("1"))},p.prototype.addScopes=function(e,t){t=(t=void 0===t?!0:t)?Fg(e||[],tm):e||[],e=new Xy(t);this.parameters.set(u.SCOPE,encodeURIComponent(e.printScopes()))},p.prototype.addClientId=function(e){this.parameters.set(u.CLIENT_ID,encodeURIComponent(e))},p.prototype.addRedirectUri=function(e){kv.validateRedirectUri(e),this.parameters.set(u.REDIRECT_URI,encodeURIComponent(e))},p.prototype.addPostLogoutRedirectUri=function(e){kv.validateRedirectUri(e),this.parameters.set(u.POST_LOGOUT_URI,encodeURIComponent(e))},p.prototype.addIdTokenHint=function(e){this.parameters.set(u.ID_TOKEN_HINT,encodeURIComponent(e))},p.prototype.addDomainHint=function(e){this.parameters.set(Wg.DOMAIN_HINT,encodeURIComponent(e))},p.prototype.addLoginHint=function(e){this.parameters.set(Wg.LOGIN_HINT,encodeURIComponent(e))},p.prototype.addCcsUpn=function(e){this.parameters.set(zg.CCS_HEADER,encodeURIComponent("UPN:"+e))},p.prototype.addCcsOid=function(e){this.parameters.set(zg.CCS_HEADER,encodeURIComponent("Oid:"+e.uid+"@"+e.utid))},p.prototype.addSid=function(e){this.parameters.set(Wg.SID,encodeURIComponent(e))},p.prototype.addClaims=function(e,t){e=this.addClientCapabilitiesToClaims(e,t);kv.validateClaims(e),this.parameters.set(u.CLAIMS,encodeURIComponent(e))},p.prototype.addCorrelationId=function(e){this.parameters.set(u.CLIENT_REQUEST_ID,encodeURIComponent(e))},p.prototype.addLibraryInfo=function(e){this.parameters.set(u.X_CLIENT_SKU,e.sku),this.parameters.set(u.X_CLIENT_VER,e.version),e.os&&this.parameters.set(u.X_CLIENT_OS,e.os),e.cpu&&this.parameters.set(u.X_CLIENT_CPU,e.cpu)},p.prototype.addApplicationTelemetry=function(e){null!=e&&e.appName&&this.parameters.set(u.X_APP_NAME,e.appName),null!=e&&e.appVersion&&this.parameters.set(u.X_APP_VER,e.appVersion)},p.prototype.addPrompt=function(e){kv.validatePrompt(e),this.parameters.set(""+u.PROMPT,encodeURIComponent(e))},p.prototype.addState=function(e){k.isEmpty(e)||this.parameters.set(u.STATE,encodeURIComponent(e))},p.prototype.addNonce=function(e){this.parameters.set(u.NONCE,encodeURIComponent(e))},p.prototype.addCodeChallengeParams=function(e,t){if(kv.validateCodeChallengeParams(e,t),!e||!t)throw Vy.createInvalidCodeChallengeParamsError();this.parameters.set(u.CODE_CHALLENGE,encodeURIComponent(e)),this.parameters.set(u.CODE_CHALLENGE_METHOD,encodeURIComponent(t))},p.prototype.addAuthorizationCode=function(e){this.parameters.set(u.CODE,encodeURIComponent(e))},p.prototype.addDeviceCode=function(e){this.parameters.set(u.DEVICE_CODE,encodeURIComponent(e))},p.prototype.addRefreshToken=function(e){this.parameters.set(u.REFRESH_TOKEN,encodeURIComponent(e))},p.prototype.addCodeVerifier=function(e){this.parameters.set(u.CODE_VERIFIER,encodeURIComponent(e))},p.prototype.addClientSecret=function(e){this.parameters.set(u.CLIENT_SECRET,encodeURIComponent(e))},p.prototype.addClientAssertion=function(e){k.isEmpty(e)||this.parameters.set(u.CLIENT_ASSERTION,encodeURIComponent(e))},p.prototype.addClientAssertionType=function(e){k.isEmpty(e)||this.parameters.set(u.CLIENT_ASSERTION_TYPE,encodeURIComponent(e))},p.prototype.addOboAssertion=function(e){this.parameters.set(u.OBO_ASSERTION,encodeURIComponent(e))},p.prototype.addRequestTokenUse=function(e){this.parameters.set(u.REQUESTED_TOKEN_USE,encodeURIComponent(e))},p.prototype.addGrantType=function(e){this.parameters.set(u.GRANT_TYPE,encodeURIComponent(e))},p.prototype.addClientInfo=function(){this.parameters.set("client_info","1")},p.prototype.addExtraQueryParameters=function(t){var o=this,e=kv.sanitizeEQParams(t,this.parameters);Object.keys(e).forEach(function(e){o.parameters.set(e,t[e])})},p.prototype.addClientCapabilitiesToClaims=function(e,t){var o;if(e)try{o=JSON.parse(e)}catch(e){throw Vy.createInvalidClaimsRequestError()}else o={};return t&&0<t.length&&(o.hasOwnProperty(Yg.ACCESS_TOKEN)||(o[Yg.ACCESS_TOKEN]={}),o[Yg.ACCESS_TOKEN][Yg.XMS_CC]={values:t}),JSON.stringify(o)},p.prototype.addUsername=function(e){this.parameters.set(um.username,encodeURIComponent(e))},p.prototype.addPassword=function(e){this.parameters.set(um.password,encodeURIComponent(e))},p.prototype.addPopToken=function(e){k.isEmpty(e)||(this.parameters.set(u.TOKEN_TYPE,em.POP),this.parameters.set(u.REQ_CNF,encodeURIComponent(e)))},p.prototype.addSshJwk=function(e){k.isEmpty(e)||(this.parameters.set(u.TOKEN_TYPE,em.SSH),this.parameters.set(u.REQ_CNF,encodeURIComponent(e)))},p.prototype.addServerTelemetry=function(e){this.parameters.set(u.X_CLIENT_CURR_TELEM,e.generateCurrentRequestHeaderValue()),this.parameters.set(u.X_CLIENT_LAST_TELEM,e.generateLastRequestHeaderValue())},p.prototype.addThrottling=function(){this.parameters.set(u.X_MS_LIB_CAPABILITY,vm)},p.prototype.addLogoutHint=function(e){this.parameters.set(u.LOGOUT_HINT,encodeURIComponent(e))},p.prototype.createQueryString=function(){var o=new Array;return this.parameters.forEach(function(e,t){o.push(t+"="+e)}),o.join("&")};var Pv=p;function p(){this.parameters=new Map}Ov.prototype.createTokenRequestHeaders=function(e){var t={};if(t[zg.CONTENT_TYPE]=E.URL_FORM_CONTENT_TYPE,!this.config.systemOptions.preventCorsPreflight&&e)switch(e.type){case Ev.HOME_ACCOUNT_ID:try{var o=tv(e.credential);t[zg.CCS_HEADER]="Oid:"+o.uid+"@"+o.utid}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case Ev.UPN:t[zg.CCS_HEADER]="UPN: "+e.credential}return t},Ov.prototype.executePostToTokenEndpoint=function(o,r,n,i){return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:return[4,this.networkManager.sendPostRequest(i,o,{body:r,headers:n})];case 1:return t=e.sent(),this.config.serverTelemetryManager&&t.status<500&&429!==t.status&&this.config.serverTelemetryManager.clearTelemetryCache(),[2,t]}})})},Ov.prototype.updateAuthority=function(e){if(!e.discoveryComplete())throw I.createEndpointDiscoveryIncompleteError("Updated authority has not completed endpoint discovery.");this.authority=e},Ov.prototype.createTokenQueryParameters=function(e){var t=new Pv;return e.tokenQueryParameters&&t.addExtraQueryParameters(e.tokenQueryParameters),t.createQueryString()};ln=Ov;function Ov(e,t){this.config=vv(e),this.logger=new by(this.config.loggerOptions,Ey,Ty),this.cryptoUtils=this.config.cryptoInterface,this.cacheManager=this.config.storageInterface,this.networkClient=this.config.networkInterface,this.networkManager=new Tv(this.networkClient,this.cacheManager),this.serverTelemetryManager=this.config.serverTelemetryManager,this.authority=this.config.authOptions.authority,this.performanceClient=t}Rv.prototype.generateAccountId=function(){return Rv.generateAccountIdForCacheKey(this.homeAccountId,this.environment)},Rv.prototype.generateCredentialId=function(){return Rv.generateCredentialIdForCacheKey(this.credentialType,this.clientId,this.realm,this.familyId)},Rv.prototype.generateTarget=function(){return Rv.generateTargetForCacheKey(this.target)},Rv.prototype.generateCredentialKey=function(){return Rv.generateCredentialCacheKey(this.homeAccountId,this.environment,this.credentialType,this.clientId,this.realm,this.target,this.familyId,this.tokenType,this.requestedClaimsHash)},Rv.prototype.generateType=function(){switch(this.credentialType){case S.ID_TOKEN:return Xg.ID_TOKEN;case S.ACCESS_TOKEN:case S.ACCESS_TOKEN_WITH_AUTH_SCHEME:return Xg.ACCESS_TOKEN;case S.REFRESH_TOKEN:return Xg.REFRESH_TOKEN;default:throw I.createUnexpectedCredentialTypeError()}},Rv.generateCredentialCacheKey=function(e,t,o,r,n,i,a,s,c){return[this.generateAccountIdForCacheKey(e,t),this.generateCredentialIdForCacheKey(o,r,n,a),this.generateTargetForCacheKey(i),this.generateClaimsHashForCacheKey(c),this.generateSchemeForCacheKey(s)].join(Jg.CACHE_KEY_SEPARATOR).toLowerCase()},Rv.generateAccountIdForCacheKey=function(e,t){return[e,t].join(Jg.CACHE_KEY_SEPARATOR).toLowerCase()},Rv.generateCredentialIdForCacheKey=function(e,t,o,r){return[e,e===S.REFRESH_TOKEN&&r||t,o||E.EMPTY_STRING].join(Jg.CACHE_KEY_SEPARATOR).toLowerCase()},Rv.generateTargetForCacheKey=function(e){return(e||E.EMPTY_STRING).toLowerCase()},Rv.generateClaimsHashForCacheKey=function(e){return(e||E.EMPTY_STRING).toLowerCase()},Rv.generateSchemeForCacheKey=function(e){return e&&e.toLowerCase()!==em.BEARER.toLowerCase()?e.toLowerCase():E.EMPTY_STRING};a=Rv;function Rv(){}Hg(Nv,xv=a),Nv.createIdTokenEntity=function(e,t,o,r,n){var i=new Nv;return i.credentialType=S.ID_TOKEN,i.homeAccountId=e,i.environment=t,i.clientId=r,i.secret=o,i.realm=n,i},Nv.isIdTokenEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("credentialType")&&e.hasOwnProperty("realm")&&e.hasOwnProperty("clientId")&&e.hasOwnProperty("secret")&&e.credentialType===S.ID_TOKEN};var xv,Mv=Nv;function Nv(){return null!==xv&&xv.apply(this,arguments)||this}Dv.nowSeconds=function(){return Math.round((new Date).getTime()/1e3)},Dv.isTokenExpired=function(e,t){return(Number(e)||0)<Dv.nowSeconds()+t},Dv.wasClockTurnedBack=function(e){return Number(e)>Dv.nowSeconds()},Dv.delay=function(t,o){return new Promise(function(e){return setTimeout(function(){return e(o)},t)})};var Lv=Dv;function Dv(){}Hg(jv,qv=a),jv.createAccessTokenEntity=function(e,t,o,r,n,i,a,s,c,u,l,h,d,p,f){var g,m=new jv,e=(m.homeAccountId=e,m.credentialType=S.ACCESS_TOKEN,m.secret=o,Lv.nowSeconds());if(m.cachedAt=e.toString(),m.expiresOn=a.toString(),m.extendedExpiresOn=s.toString(),u&&(m.refreshOn=u.toString()),m.environment=t,m.clientId=r,m.realm=n,m.target=i,m.userAssertionHash=h,m.tokenType=k.isEmpty(l)?em.BEARER:l,p&&(m.requestedClaims=p,m.requestedClaimsHash=f),(null==(e=m.tokenType)?void 0:e.toLowerCase())!==em.BEARER.toLowerCase())switch(m.credentialType=S.ACCESS_TOKEN_WITH_AUTH_SCHEME,m.tokenType){case em.POP:var y=nv.extractTokenClaims(o,c);if(null==(g=null==y?void 0:y.cnf)||!g.kid)throw I.createTokenClaimsRequiredError();m.keyId=y.cnf.kid;break;case em.SSH:m.keyId=d}return m},jv.isAccessTokenEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("credentialType")&&e.hasOwnProperty("realm")&&e.hasOwnProperty("clientId")&&e.hasOwnProperty("secret")&&e.hasOwnProperty("target")&&(e.credentialType===S.ACCESS_TOKEN||e.credentialType===S.ACCESS_TOKEN_WITH_AUTH_SCHEME)};var qv,Uv=jv;function jv(){return null!==qv&&qv.apply(this,arguments)||this}Hg(Fv,Hv=a),Fv.createRefreshTokenEntity=function(e,t,o,r,n,i){var a=new Fv;return a.clientId=r,a.credentialType=S.REFRESH_TOKEN,a.environment=t,a.homeAccountId=e,a.secret=o,a.userAssertionHash=i,n&&(a.familyId=n),a},Fv.isRefreshTokenEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("credentialType")&&e.hasOwnProperty("clientId")&&e.hasOwnProperty("secret")&&e.credentialType===S.REFRESH_TOKEN};var Hv,Bv=Fv;function Fv(){return null!==Hv&&Hv.apply(this,arguments)||this}var zv,Kv=["interaction_required","consent_required","login_required"],Gv=["message_only","additional_action","basic_action","user_password_expired","consent_required"],Yv={code:"no_tokens_found",desc:"No refresh token found in the cache. Please sign-in."},Wv={code:"native_account_unavailable",desc:"The requested account is not available in the native broker. It may have been deleted or logged out. Please sign-in again using an interactive API."},Zv=(Hg(Qv,zv=T),Qv.isInteractionRequiredError=function(e,t,o){var e=!!e&&-1<Kv.indexOf(e),o=!!o&&-1<Gv.indexOf(o),r=!!t&&Kv.some(function(e){return-1<t.indexOf(e)});return e||r||o},Qv.createNoTokensFoundError=function(){return new Qv(Yv.code,Yv.desc)},Qv.createNativeAccountUnavailableError=function(){return new Qv(Wv.code,Wv.desc)},Qv);function Qv(e,t,o,r,n,i,a){e=zv.call(this,e,t,o)||this;return Object.setPrototypeOf(e,Qv.prototype),e.timestamp=r||E.EMPTY_STRING,e.traceId=n||E.EMPTY_STRING,e.correlationId=i||E.EMPTY_STRING,e.claims=a||E.EMPTY_STRING,e.name="InteractionRequiredAuthError",e}var Vv=function(e,t,o,r,n){this.account=e||null,this.idToken=t||null,this.accessToken=o||null,this.refreshToken=r||null,this.appMetadata=n||null},Jv=(Xv.setRequestState=function(e,t,o){e=Xv.generateLibraryState(e,o);return k.isEmpty(t)?e:""+e+E.RESOURCE_DELIM+t},Xv.generateLibraryState=function(e,t){var o;if(e)return o={id:e.createNewGuid()},t&&(o.meta=t),t=JSON.stringify(o),e.base64Encode(t);throw I.createNoCryptoObjectError("generateLibraryState")},Xv.parseRequestState=function(e,t){if(!e)throw I.createNoCryptoObjectError("parseRequestState");if(k.isEmpty(t))throw I.createInvalidStateError(t,"Null, undefined or empty state");try{var o=t.split(E.RESOURCE_DELIM),r=o[0],n=1<o.length?o.slice(1).join(E.RESOURCE_DELIM):E.EMPTY_STRING,i=e.base64Decode(r),a=JSON.parse(i);return{userRequestState:k.isEmpty(n)?E.EMPTY_STRING:n,libraryState:a}}catch(e){throw I.createInvalidStateError(t,e)}},Xv);function Xv(){}Object.defineProperty(t_.prototype,"urlString",{get:function(){return this._urlString},enumerable:!1,configurable:!0}),t_.canonicalizeUri=function(e){var t;return e&&(t=e.toLowerCase(),k.endsWith(t,"?")?t=t.slice(0,-1):k.endsWith(t,"?/")&&(t=t.slice(0,-2)),k.endsWith(t,"/")||(t+="/"),t)},t_.prototype.validateAsUri=function(){var e;try{e=this.getUrlComponents()}catch(e){throw Vy.createUrlParseError(e)}if(!e.HostNameAndPort||!e.PathSegments)throw Vy.createUrlParseError("Given url string: "+this.urlString);if(!e.Protocol||"https:"!==e.Protocol.toLowerCase())throw Vy.createInsecureAuthorityUriError(this.urlString)},t_.appendQueryString=function(e,t){return k.isEmpty(t)?e:e.indexOf("?")<0?e+"?"+t:e+"&"+t},t_.removeHashFromUrl=function(e){return t_.canonicalizeUri(e.split("#")[0])},t_.prototype.replaceTenantPath=function(e){var t=this.getUrlComponents(),o=t.PathSegments;return!e||0===o.length||o[0]!==Gg.COMMON&&o[0]!==Gg.ORGANIZATIONS||(o[0]=e),t_.constructAuthorityUriFromObject(t)},t_.prototype.getHash=function(){return t_.parseHash(this.urlString)},t_.prototype.getUrlComponents=function(){var e,t=RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?"),t=this.urlString.match(t);if(t)return e=(e=(t={Protocol:t[1],HostNameAndPort:t[4],AbsolutePath:t[5],QueryString:t[7]}).AbsolutePath.split("/")).filter(function(e){return e&&0<e.length}),t.PathSegments=e,!k.isEmpty(t.QueryString)&&t.QueryString.endsWith("/")&&(t.QueryString=t.QueryString.substring(0,t.QueryString.length-1)),t;throw Vy.createUrlParseError("Given url string: "+this.urlString)},t_.getDomainFromUrl=function(e){var t=RegExp("^([^:/?#]+://)?([^/?#]*)"),t=e.match(t);if(t)return t[2];throw Vy.createUrlParseError("Given url string: "+e)},t_.getAbsoluteUrl=function(e,t){return e[0]===E.FORWARD_SLASH?(t=new t_(t).getUrlComponents()).Protocol+"//"+t.HostNameAndPort+e:e},t_.parseHash=function(e){var t=e.indexOf("#"),o=e.indexOf("#/");return-1<o?e.substring(o+2):-1<t?e.substring(t+1):E.EMPTY_STRING},t_.parseQueryString=function(e){var t=e.indexOf("?"),o=e.indexOf("/?");return-1<o?e.substring(o+2):-1<t?e.substring(t+1):E.EMPTY_STRING},t_.constructAuthorityUriFromObject=function(e){return new t_(e.Protocol+"//"+e.HostNameAndPort+"/"+e.PathSegments.join("/"))},t_.getDeserializedHash=function(e){if(k.isEmpty(e))return{};var t=t_.parseHash(e),e=k.queryStringToObject(k.isEmpty(t)?e:t);if(e)return e;throw I.createHashNotDeserializedError(JSON.stringify(e))},t_.getDeserializedQueryString=function(e){if(k.isEmpty(e))return{};var t=t_.parseQueryString(e),e=k.queryStringToObject(k.isEmpty(t)?e:t);if(e)return e;throw I.createHashNotDeserializedError(JSON.stringify(e))},t_.hashContainsKnownProperties=function(e){return!(k.isEmpty(e)||e.indexOf("=")<0||!((e=t_.getDeserializedHash(e)).code||e.error_description||e.error||e.state))};var A,$v,e_=t_;function t_(e){if(this._urlString=e,k.isEmpty(this._urlString))throw Vy.createUrlEmptyError();k.isEmpty(this.getHash())&&(this._urlString=t_.canonicalizeUri(e))}(t=A=A||{}).AcquireTokenByCode="acquireTokenByCode",t.AcquireTokenByRefreshToken="acquireTokenByRefreshToken",t.AcquireTokenSilent="acquireTokenSilent",t.AcquireTokenSilentAsync="acquireTokenSilentAsync",t.AcquireTokenPopup="acquireTokenPopup",t.CryptoOptsGetPublicKeyThumbprint="cryptoOptsGetPublicKeyThumbprint",t.CryptoOptsSignJwt="cryptoOptsSignJwt",t.SilentCacheClientAcquireToken="silentCacheClientAcquireToken",t.SilentIframeClientAcquireToken="silentIframeClientAcquireToken",t.SilentRefreshClientAcquireToken="silentRefreshClientAcquireToken",t.SsoSilent="ssoSilent",t.StandardInteractionClientGetDiscoveredAuthority="standardInteractionClientGetDiscoveredAuthority",t.FetchAccountIdWithNativeBroker="fetchAccountIdWithNativeBroker",t.NativeInteractionClientAcquireToken="nativeInteractionClientAcquireToken",t.BaseClientCreateTokenRequestHeaders="baseClientCreateTokenRequestHeaders",t.BrokerHandhshake="brokerHandshake",t.AcquireTokenByRefreshTokenInBroker="acquireTokenByRefreshTokenInBroker",t.AcquireTokenByBroker="acquireTokenByBroker",t.RefreshTokenClientExecuteTokenRequest="refreshTokenClientExecuteTokenRequest",t.RefreshTokenClientAcquireToken="refreshTokenClientAcquireToken",t.RefreshTokenClientAcquireTokenWithCachedRefreshToken="refreshTokenClientAcquireTokenWithCachedRefreshToken",t.RefreshTokenClientAcquireTokenByRefreshToken="refreshTokenClientAcquireTokenByRefreshToken",t.RefreshTokenClientCreateTokenRequestBody="refreshTokenClientCreateTokenRequestBody",t.AcquireTokenFromCache="acquireTokenFromCache",t.AcquireTokenBySilentIframe="acquireTokenBySilentIframe",t.InitializeBaseRequest="initializeBaseRequest",t.InitializeSilentRequest="initializeSilentRequest",t.InitializeClientApplication="initializeClientApplication",t.SilentIframeClientTokenHelper="silentIframeClientTokenHelper",t.SilentHandlerInitiateAuthRequest="silentHandlerInitiateAuthRequest",t.SilentHandlerMonitorIframeForHash="silentHandlerMonitorIframeForHash",t.SilentHandlerLoadFrame="silentHandlerLoadFrame",t.StandardInteractionClientCreateAuthCodeClient="standardInteractionClientCreateAuthCodeClient",t.StandardInteractionClientGetClientConfiguration="standardInteractionClientGetClientConfiguration",t.StandardInteractionClientInitializeAuthorizationRequest="standardInteractionClientInitializeAuthorizationRequest",t.StandardInteractionClientInitializeAuthorizationCodeRequest="standardInteractionClientInitializeAuthorizationCodeRequest",t.GetAuthCodeUrl="getAuthCodeUrl",t.HandleCodeResponseFromServer="handleCodeResponseFromServer",t.HandleCodeResponseFromHash="handleCodeResponseFromHash",t.UpdateTokenEndpointAuthority="updateTokenEndpointAuthority",t.AuthClientAcquireToken="authClientAcquireToken",t.AuthClientExecuteTokenRequest="authClientExecuteTokenRequest",t.AuthClientCreateTokenRequestBody="authClientCreateTokenRequestBody",t.AuthClientCreateQueryString="authClientCreateQueryString",t.PopTokenGenerateCnf="popTokenGenerateCnf",t.PopTokenGenerateKid="popTokenGenerateKid",t.HandleServerTokenResponse="handleServerTokenResponse",t.AuthorityFactoryCreateDiscoveredInstance="authorityFactoryCreateDiscoveredInstance",t.AuthorityResolveEndpointsAsync="authorityResolveEndpointsAsync",t.AuthorityGetCloudDiscoveryMetadataFromNetwork="authorityGetCloudDiscoveryMetadataFromNetwork",t.AuthorityUpdateCloudDiscoveryMetadata="authorityUpdateCloudDiscoveryMetadata",t.AuthorityGetEndpointMetadataFromNetwork="authorityGetEndpointMetadataFromNetwork",t.AuthorityUpdateEndpointMetadata="authorityUpdateEndpointMetadata",t.AuthorityUpdateMetadataWithRegionalInformation="authorityUpdateMetadataWithRegionalInformation",t.RegionDiscoveryDetectRegion="regionDiscoveryDetectRegion",t.RegionDiscoveryGetRegionFromIMDS="regionDiscoveryGetRegionFromIMDS",t.RegionDiscoveryGetCurrentVersion="regionDiscoveryGetCurrentVersion",t.AcquireTokenByCodeAsync="acquireTokenByCodeAsync",t.GetEndpointMetadataFromNetwork="getEndpointMetadataFromNetwork",t.GetCloudDiscoveryMetadataFromNetworkMeasurement="getCloudDiscoveryMetadataFromNetworkMeasurement",t.HandleRedirectPromiseMeasurement="handleRedirectPromiseMeasurement",t.UpdateCloudDiscoveryMetadataMeasurement="updateCloudDiscoveryMetadataMeasurement",t.UsernamePasswordClientAcquireToken="usernamePasswordClientAcquireToken",t.NativeMessageHandlerHandshake="nativeMessageHandlerHandshake",t.ClearTokensAndKeysWithClaims="clearTokensAndKeysWithClaims",(s=$v=$v||{})[s.NotStarted=0]="NotStarted",s[s.InProgress=1]="InProgress",s[s.Completed=2]="Completed";var o_,r_=new Set(["accessTokenSize","durationMs","idTokenSize","matsSilentStatus","matsHttpStatus","refreshTokenSize","queuedTimeMs","startTimeMs","status"]),n_=((n=o_=o_||{}).SW="sw",n.UHW="uhw",i_.prototype.generateCnf=function(r){var n;return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){switch(e.label){case 0:return null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.PopTokenGenerateCnf,r.correlationId),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.PopTokenGenerateKid,r.correlationId),[4,this.generateKid(r)];case 1:return o=e.sent(),t=this.cryptoUtils.base64Encode(JSON.stringify(o)),o={kid:o.kid,reqCnfString:t},[4,this.cryptoUtils.hashString(t)];case 2:return[2,(o.reqCnfHash=e.sent(),o)]}})})},i_.prototype.generateKid=function(t){var o;return b(this,void 0,void 0,function(){return C(this,function(e){switch(e.label){case 0:return null!=(o=this.performanceClient)&&o.addQueueMeasurement(A.PopTokenGenerateKid,t.correlationId),[4,this.cryptoUtils.getPublicKeyThumbprint(t)];case 1:return[2,{kid:e.sent(),xms_ksl:o_.SW}]}})})},i_.prototype.signPopToken=function(t,o,r){return b(this,void 0,void 0,function(){return C(this,function(e){return[2,this.signPayload(t,o,r)]})})},i_.prototype.signPayload=function(i,a,s,c){return b(this,void 0,void 0,function(){var t,o,r,n;return C(this,function(e){switch(e.label){case 0:return t=s.resourceRequestMethod,n=s.resourceRequestUri,o=s.shrClaims,r=s.shrNonce,n=n?new e_(n):void 0,n=null==n?void 0:n.getUrlComponents(),[4,this.cryptoUtils.signJwt(Bg({at:i,ts:Lv.nowSeconds(),m:null==t?void 0:t.toUpperCase(),u:null==n?void 0:n.HostNameAndPort,nonce:r||this.cryptoUtils.createNewGuid(),p:null==n?void 0:n.AbsolutePath,q:null!=n&&n.QueryString?[[],n.QueryString]:void 0,client_claims:o||void 0},c),a,s.correlationId)];case 1:return[2,e.sent()]}})})},i_);function i_(e,t){this.cryptoUtils=e,this.performanceClient=t}s_.prototype.generateAppMetadataKey=function(){return s_.generateAppMetadataCacheKey(this.environment,this.clientId)},s_.generateAppMetadataCacheKey=function(e,t){return[im,e,t].join(Jg.CACHE_KEY_SEPARATOR).toLowerCase()},s_.createAppMetadataEntity=function(e,t,o){var r=new s_;return r.clientId=e,r.environment=t,o&&(r.familyId=o),r},s_.isAppMetadataEntity=function(e,t){return!!t&&0===e.indexOf(im)&&t.hasOwnProperty("clientId")&&t.hasOwnProperty("environment")};var a_=s_;function s_(){}Object.defineProperty(u_.prototype,"cacheHasChanged",{get:function(){return this.hasChanged},enumerable:!1,configurable:!0}),Object.defineProperty(u_.prototype,"tokenCache",{get:function(){return this.cache},enumerable:!1,configurable:!0});var c_=u_;function u_(e,t){this.cache=e,this.hasChanged=t}h_.prototype.validateServerAuthorizationCodeResponse=function(e,t,o){if(!e.state||!t)throw e.state?I.createStateNotFoundError("Cached State"):I.createStateNotFoundError("Server State");if(decodeURIComponent(e.state)!==decodeURIComponent(t))throw I.createStateMismatchError();if(e.error||e.error_description||e.suberror){if(Zv.isInteractionRequiredError(e.error,e.error_description,e.suberror))throw new Zv(e.error||E.EMPTY_STRING,e.error_description,e.suberror,e.timestamp||E.EMPTY_STRING,e.trace_id||E.EMPTY_STRING,e.correlation_id||E.EMPTY_STRING,e.claims||E.EMPTY_STRING);throw new wv(e.error||E.EMPTY_STRING,e.error_description,e.suberror)}e.client_info&&ev(e.client_info,o)},h_.prototype.validateTokenResponse=function(e){if(e.error||e.error_description||e.suberror){if(Zv.isInteractionRequiredError(e.error,e.error_description,e.suberror))throw new Zv(e.error,e.error_description,e.suberror,e.timestamp||E.EMPTY_STRING,e.trace_id||E.EMPTY_STRING,e.correlation_id||E.EMPTY_STRING,e.claims||E.EMPTY_STRING);var t=e.error_codes+" - ["+e.timestamp+"]: "+e.error_description+" - Correlation ID: "+e.correlation_id+" - Trace ID: "+e.trace_id;throw new wv(e.error,t,e.suberror)}},h_.prototype.handleServerTokenResponse=function(a,s,c,u,l,h,d,p,f){var g;return b(this,void 0,void 0,function(){var t,o,r,n,i;return C(this,function(e){switch(e.label){case 0:if(null!=(g=this.performanceClient)&&g.addQueueMeasurement(A.HandleServerTokenResponse,a.correlation_id),a.id_token){if(t=new nv(a.id_token||E.EMPTY_STRING,this.cryptoObj),l&&!k.isEmpty(l.nonce)&&t.claims.nonce!==l.nonce)throw I.createNonceMismatchError();if(u.maxAge||0===u.maxAge){if(!(r=t.claims.auth_time))throw I.createAuthTimeNotFoundError();nv.checkMaxAge(r,u.maxAge)}}this.homeAccountIdentifier=ov.generateHomeAccountId(a.client_info||E.EMPTY_STRING,s.authorityType,this.logger,this.cryptoObj,t),l&&l.state&&(o=Jv.parseRequestState(this.cryptoObj,l.state)),a.key_id=a.key_id||u.sshKid||void 0,r=this.generateCacheRecord(a,s,c,u,t,h,l),e.label=1;case 1:return(e.trys.push([1,,5,8]),this.persistencePlugin&&this.serializableCache)?(this.logger.verbose("Persistence enabled, calling beforeCacheAccess"),n=new c_(this.serializableCache,!0),[4,this.persistencePlugin.beforeCacheAccess(n)]):[3,3];case 2:e.sent(),e.label=3;case 3:return!d||p||!r.account||(i=r.account.generateAccountKey(),this.cacheStorage.getAccount(i))?[4,this.cacheStorage.saveCacheRecord(r)]:(this.logger.warning("Account used to refresh tokens not in persistence, refreshed tokens will not be stored in the cache"),[2,h_.generateAuthenticationResult(this.cryptoObj,s,r,!1,u,t,o,void 0,f)]);case 4:return e.sent(),[3,8];case 5:return this.persistencePlugin&&this.serializableCache&&n?(this.logger.verbose("Persistence enabled, calling afterCacheAccess"),[4,this.persistencePlugin.afterCacheAccess(n)]):[3,7];case 6:e.sent(),e.label=7;case 7:return[7];case 8:return[2,h_.generateAuthenticationResult(this.cryptoObj,s,r,!1,u,t,o,a,f)]}})})},h_.prototype.generateCacheRecord=function(e,t,o,r,n,i,a){var s,c,u=t.getPreferredCache();if(k.isEmpty(u))throw I.createInvalidCacheEnvironmentError();!k.isEmpty(e.id_token)&&n&&(s=Mv.createIdTokenEntity(this.homeAccountIdentifier,u,e.id_token||E.EMPTY_STRING,this.clientId,n.claims.tid||E.EMPTY_STRING),c=this.generateAccountEntity(e,n,t,a));var l,h,d,a=null,p=(k.isEmpty(e.access_token)||(l=e.scope?Xy.fromString(e.scope):new Xy(r.scopes||[]),d=(h=o+(("string"==typeof e.expires_in?parseInt(e.expires_in,10):e.expires_in)||0))+(("string"==typeof e.ext_expires_in?parseInt(e.ext_expires_in,10):e.ext_expires_in)||0),o=(p=("string"==typeof e.refresh_in?parseInt(e.refresh_in,10):e.refresh_in)||void 0)&&0<p?o+p:void 0,a=Uv.createAccessTokenEntity(this.homeAccountIdentifier,u,e.access_token||E.EMPTY_STRING,this.clientId,n?n.claims.tid||E.EMPTY_STRING:t.tenant,l.printScopes(),h,d,this.cryptoObj,o,e.token_type,i,e.key_id,r.claims,r.requestedClaimsHash)),null),n=(k.isEmpty(e.refresh_token)||(p=Bv.createRefreshTokenEntity(this.homeAccountIdentifier,u,e.refresh_token||E.EMPTY_STRING,this.clientId,e.foci,i)),null);return k.isEmpty(e.foci)||(n=a_.createAppMetadataEntity(this.clientId,u,e.foci)),new Vv(c,s,a,p,n)},h_.prototype.generateAccountEntity=function(e,t,o,r){var n=o.authorityType,i=r?r.cloud_graph_host_name:E.EMPTY_STRING,r=r?r.msgraph_host:E.EMPTY_STRING;if(n===Jy.Adfs)return this.logger.verbose("Authority type is ADFS, creating ADFS account"),ov.createGenericAccount(this.homeAccountIdentifier,t,o,i,r);if(k.isEmpty(e.client_info)&&"AAD"===o.protocolMode)throw I.createClientInfoEmptyError();return e.client_info?ov.createAccount(e.client_info,this.homeAccountIdentifier,t,o,i,r):ov.createGenericAccount(this.homeAccountIdentifier,t,o,i,r)},h_.generateAuthenticationResult=function(u,l,h,d,p,f,g,m,y){var v;return b(this,void 0,void 0,function(){var t,o,r,n,i,a,s,c;return C(this,function(e){switch(e.label){case 0:if(t=E.EMPTY_STRING,o=[],r=null,i=E.EMPTY_STRING,!h.accessToken)return[3,4];if(h.accessToken.tokenType!==em.POP)return[3,2];if(s=new n_(u),a=h.accessToken,c=a.secret,a=a.keyId)return[4,s.signPopToken(c,a,p)];throw I.createKeyIdMissingError();case 1:return t=e.sent(),[3,3];case 2:t=h.accessToken.secret,e.label=3;case 3:o=Xy.fromString(h.accessToken.target).asArray(),r=new Date(1e3*Number(h.accessToken.expiresOn)),n=new Date(1e3*Number(h.accessToken.extendedExpiresOn)),e.label=4;case 4:return h.appMetadata&&(i="1"===h.appMetadata.familyId?"1":E.EMPTY_STRING),s=(null==f?void 0:f.claims.oid)||(null==f?void 0:f.claims.sub)||E.EMPTY_STRING,c=(null==f?void 0:f.claims.tid)||E.EMPTY_STRING,null!=m&&m.spa_accountid&&h.account&&(h.account.nativeAccountId=null==m?void 0:m.spa_accountid),[2,{authority:l.canonicalAuthority,uniqueId:s,tenantId:c,scopes:o,account:h.account?h.account.getAccountInfo():null,idToken:f?f.rawToken:E.EMPTY_STRING,idTokenClaims:f?f.claims:{},accessToken:t,fromCache:d,expiresOn:r,correlationId:p.correlationId,requestId:y||E.EMPTY_STRING,extExpiresOn:n,familyId:i,tokenType:(null==(v=h.accessToken)?void 0:v.tokenType)||E.EMPTY_STRING,state:g?g.userRequestState:E.EMPTY_STRING,cloudGraphHostName:(null==(v=h.account)?void 0:v.cloudGraphHostName)||E.EMPTY_STRING,msGraphHost:(null==(v=h.account)?void 0:v.msGraphHost)||E.EMPTY_STRING,code:null==m?void 0:m.spa_code,fromNativeBroker:!1}]}})})};var l_=h_;function h_(e,t,o,r,n,i,a){this.clientId=e,this.cacheStorage=t,this.cryptoObj=o,this.logger=r,this.serializableCache=n,this.persistencePlugin=i,this.performanceClient=a}Hg(f_,d_=ln),f_.prototype.getAuthCodeUrl=function(o){var r;return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:return null!=(r=this.performanceClient)&&r.addQueueMeasurement(A.GetAuthCodeUrl,o.correlationId),null!=(r=this.performanceClient)&&r.setPreQueueTime(A.AuthClientCreateQueryString,o.correlationId),[4,this.createAuthCodeUrlQueryString(o)];case 1:return t=e.sent(),[2,e_.appendQueryString(this.authority.authorizationEndpoint,t)]}})})},f_.prototype.acquireToken=function(s,c){var u,l;return b(this,void 0,void 0,function(){var t,o,r,n,i,a=this;return C(this,function(e){switch(e.label){case 0:if(s&&s.code)return null!=(u=this.performanceClient)&&u.addQueueMeasurement(A.AuthClientAcquireToken,s.correlationId),t=null==(u=this.performanceClient)?void 0:u.startMeasurement("AuthCodeClientAcquireToken",s.correlationId),this.logger.info("in acquireToken call in auth-code client"),o=Lv.nowSeconds(),null!=(u=this.performanceClient)&&u.setPreQueueTime(A.AuthClientExecuteTokenRequest,s.correlationId),[4,this.executeTokenRequest(this.authority,s)];throw I.createTokenRequestCannotBeMadeError();case 1:return r=e.sent(),n=null==(u=r.headers)?void 0:u[zg.X_MS_REQUEST_ID],(i=null==(l=r.headers)?void 0:l[zg.X_MS_HTTP_VERSION])&&null!=t&&t.addStaticFields({httpVerAuthority:i}),(i=new l_(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin,this.performanceClient)).validateTokenResponse(r.body),null!=(l=this.performanceClient)&&l.setPreQueueTime(A.HandleServerTokenResponse,s.correlationId),[2,i.handleServerTokenResponse(r.body,this.authority,o,s,c,void 0,void 0,void 0,n).then(function(e){return null!=t&&t.endMeasurement({success:!0}),e}).catch(function(e){throw a.logger.verbose("Error in fetching token in ACC",s.correlationId),null!=t&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})]}})})},f_.prototype.handleFragmentResponse=function(e,t){var o=new l_(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,null,null),e=new e_(e),e=e_.getDeserializedHash(e.getHash());if(o.validateServerAuthorizationCodeResponse(e,t,this.cryptoUtils),e.code)return Bg(Bg({},e),{code:e.code});throw I.createNoAuthCodeInServerResponseError()},f_.prototype.getLogoutUri=function(e){if(e)return e=this.createLogoutUrlQueryString(e),e_.appendQueryString(this.authority.endSessionEndpoint,e);throw Vy.createEmptyLogoutRequestError()},f_.prototype.executeTokenRequest=function(a,s){var c;return b(this,void 0,void 0,function(){var t,o,r,n,i;return C(this,function(e){switch(e.label){case 0:return null!=(c=this.performanceClient)&&c.addQueueMeasurement(A.AuthClientExecuteTokenRequest,s.correlationId),null!=(c=this.performanceClient)&&c.setPreQueueTime(A.AuthClientCreateTokenRequestBody,s.correlationId),t=this.createTokenQueryParameters(s),t=e_.appendQueryString(a.tokenEndpoint,t),[4,this.createTokenRequestBody(s)];case 1:if(o=e.sent(),n=void 0,s.clientInfo)try{r=ev(s.clientInfo,this.cryptoUtils),n={credential:""+r.uid+Jg.CLIENT_INFO_SEPARATOR+r.utid,type:Ev.HOME_ACCOUNT_ID}}catch(e){this.logger.verbose("Could not parse client info for CCS Header: "+e)}return n=this.createTokenRequestHeaders(n||s.ccsCredential),i={clientId:this.config.authOptions.clientId,authority:a.canonicalAuthority,scopes:s.scopes,claims:s.claims,authenticationScheme:s.authenticationScheme,resourceRequestMethod:s.resourceRequestMethod,resourceRequestUri:s.resourceRequestUri,shrClaims:s.shrClaims,sshKid:s.sshKid},[2,this.executePostToTokenEndpoint(t,o,n,i)]}})})},f_.prototype.createTokenRequestBody=function(s){var c;return b(this,void 0,void 0,function(){var t,o,r,n,i,a;return C(this,function(e){switch(e.label){case 0:return(null!=(c=this.performanceClient)&&c.addQueueMeasurement(A.AuthClientCreateTokenRequestBody,s.correlationId),(t=new Pv).addClientId(this.config.authOptions.clientId),this.includeRedirectUri?t.addRedirectUri(s.redirectUri):kv.validateRedirectUri(s.redirectUri),t.addScopes(s.scopes),t.addAuthorizationCode(s.code),t.addLibraryInfo(this.config.libraryInfo),t.addApplicationTelemetry(this.config.telemetry.application),t.addThrottling(),this.serverTelemetryManager&&t.addServerTelemetry(this.serverTelemetryManager),s.codeVerifier&&t.addCodeVerifier(s.codeVerifier),this.config.clientCredentials.clientSecret&&t.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion&&(o=this.config.clientCredentials.clientAssertion,t.addClientAssertion(o.assertion),t.addClientAssertionType(o.assertionType)),t.addGrantType(Qg.AUTHORIZATION_CODE_GRANT),t.addClientInfo(),s.authenticationScheme!==em.POP)?[3,2]:(o=new n_(this.cryptoUtils,this.performanceClient),null!=(c=this.performanceClient)&&c.setPreQueueTime(A.PopTokenGenerateCnf,s.correlationId),[4,o.generateCnf(s)]);case 1:return r=e.sent(),t.addPopToken(r.reqCnfString),[3,3];case 2:if(s.authenticationScheme===em.SSH){if(!s.sshJwk)throw Vy.createMissingSshJwkError();t.addSshJwk(s.sshJwk)}e.label=3;case 3:if(r=s.correlationId||this.config.cryptoInterface.createNewGuid(),t.addCorrelationId(r),(!k.isEmptyObj(s.claims)||this.config.authOptions.clientCapabilities&&0<this.config.authOptions.clientCapabilities.length)&&t.addClaims(s.claims,this.config.authOptions.clientCapabilities),n=void 0,s.clientInfo)try{i=ev(s.clientInfo,this.cryptoUtils),n={credential:""+i.uid+Jg.CLIENT_INFO_SEPARATOR+i.utid,type:Ev.HOME_ACCOUNT_ID}}catch(e){this.logger.verbose("Could not parse client info for CCS Header: "+e)}else n=s.ccsCredential;if(this.config.systemOptions.preventCorsPreflight&&n)switch(n.type){case Ev.HOME_ACCOUNT_ID:try{i=tv(n.credential),t.addCcsOid(i)}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case Ev.UPN:t.addCcsUpn(n.credential)}return s.tokenBodyParameters&&t.addExtraQueryParameters(s.tokenBodyParameters),!s.enableSpaAuthorizationCode||s.tokenBodyParameters&&s.tokenBodyParameters[u.RETURN_SPA_CODE]||t.addExtraQueryParameters(((a={})[u.RETURN_SPA_CODE]="1",a)),[2,t.createQueryString()]}})})},f_.prototype.createAuthCodeUrlQueryString=function(i){var a;return b(this,void 0,void 0,function(){var t,o,r,n;return C(this,function(e){switch(e.label){case 0:if(null!=(a=this.performanceClient)&&a.addQueueMeasurement(A.AuthClientCreateQueryString,i.correlationId),(t=new Pv).addClientId(this.config.authOptions.clientId),o=Fg(i.scopes||[],i.extraScopesToConsent||[]),t.addScopes(o),t.addRedirectUri(i.redirectUri),o=i.correlationId||this.config.cryptoInterface.createNewGuid(),t.addCorrelationId(o),t.addResponseMode(i.responseMode),t.addResponseTypeCode(),t.addLibraryInfo(this.config.libraryInfo),t.addApplicationTelemetry(this.config.telemetry.application),t.addClientInfo(),i.codeChallenge&&i.codeChallengeMethod&&t.addCodeChallengeParams(i.codeChallenge,i.codeChallengeMethod),i.prompt&&t.addPrompt(i.prompt),i.domainHint&&t.addDomainHint(i.domainHint),i.prompt!==rm.SELECT_ACCOUNT)if(i.sid&&i.prompt===rm.NONE)this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from request"),t.addSid(i.sid);else if(i.account){if(o=this.extractAccountSid(i.account),n=this.extractLoginHint(i.account)){this.logger.verbose("createAuthCodeUrlQueryString: login_hint claim present on account"),t.addLoginHint(n);try{r=tv(i.account.homeAccountId),t.addCcsOid(r)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}else if(o&&i.prompt===rm.NONE){this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from account"),t.addSid(o);try{r=tv(i.account.homeAccountId),t.addCcsOid(r)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}else if(i.loginHint)this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from request"),t.addLoginHint(i.loginHint),t.addCcsUpn(i.loginHint);else if(i.account.username){this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from account"),t.addLoginHint(i.account.username);try{r=tv(i.account.homeAccountId),t.addCcsOid(r)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}}else i.loginHint&&(this.logger.verbose("createAuthCodeUrlQueryString: No account, adding login_hint from request"),t.addLoginHint(i.loginHint),t.addCcsUpn(i.loginHint));else this.logger.verbose("createAuthCodeUrlQueryString: Prompt is select_account, ignoring account hints");return(i.nonce&&t.addNonce(i.nonce),i.state&&t.addState(i.state),(!k.isEmpty(i.claims)||this.config.authOptions.clientCapabilities&&0<this.config.authOptions.clientCapabilities.length)&&t.addClaims(i.claims,this.config.authOptions.clientCapabilities),i.extraQueryParameters&&t.addExtraQueryParameters(i.extraQueryParameters),i.nativeBroker)?(t.addNativeBroker(),i.authenticationScheme!==em.POP?[3,2]:[4,new n_(this.cryptoUtils).generateCnf(i)]):[3,2];case 1:n=e.sent(),t.addPopToken(n.reqCnfString),e.label=2;case 2:return[2,t.createQueryString()]}})})},f_.prototype.createLogoutUrlQueryString=function(e){var t=new Pv;return e.postLogoutRedirectUri&&t.addPostLogoutRedirectUri(e.postLogoutRedirectUri),e.correlationId&&t.addCorrelationId(e.correlationId),e.idTokenHint&&t.addIdTokenHint(e.idTokenHint),e.state&&t.addState(e.state),e.logoutHint&&t.addLogoutHint(e.logoutHint),e.extraQueryParameters&&t.addExtraQueryParameters(e.extraQueryParameters),t.createQueryString()},f_.prototype.extractAccountSid=function(e){return(null==(e=e.idTokenClaims)?void 0:e.sid)||null},f_.prototype.extractLoginHint=function(e){return(null==(e=e.idTokenClaims)?void 0:e.login_hint)||null};var d_,p_=f_;function f_(e,t){e=d_.call(this,e,t)||this;return e.includeRedirectUri=!0,e}Hg(y_,g_=ln),y_.prototype.acquireToken=function(s){var c,u,l;return b(this,void 0,void 0,function(){var t,o,r,n,i,a=this;return C(this,function(e){switch(e.label){case 0:return null!=(c=this.performanceClient)&&c.addQueueMeasurement(A.RefreshTokenClientAcquireToken,s.correlationId),t=null==(c=this.performanceClient)?void 0:c.startMeasurement(A.RefreshTokenClientAcquireToken,s.correlationId),this.logger.verbose("RefreshTokenClientAcquireToken called",s.correlationId),o=Lv.nowSeconds(),null!=(c=this.performanceClient)&&c.setPreQueueTime(A.RefreshTokenClientExecuteTokenRequest,s.correlationId),[4,this.executeTokenRequest(s,this.authority)];case 1:return r=e.sent(),n=null==(c=r.headers)?void 0:c[zg.X_MS_HTTP_VERSION],null!=t&&t.addStaticFields({refreshTokenSize:(null==(u=r.body.refresh_token)?void 0:u.length)||0}),n&&null!=t&&t.addStaticFields({httpVerToken:n}),n=null==(u=r.headers)?void 0:u[zg.X_MS_REQUEST_ID],(i=new l_(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin)).validateTokenResponse(r.body),null!=(l=this.performanceClient)&&l.setPreQueueTime(A.HandleServerTokenResponse,s.correlationId),[2,i.handleServerTokenResponse(r.body,this.authority,o,s,void 0,void 0,!0,s.forceCache,n).then(function(e){return null!=t&&t.endMeasurement({success:!0}),e}).catch(function(e){throw a.logger.verbose("Error in fetching refresh token",s.correlationId),null!=t&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})]}})})},y_.prototype.acquireTokenByRefreshToken=function(r){var n,i;return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){if(!r)throw Vy.createEmptyTokenRequestError();if(null!=(i=this.performanceClient)&&i.addQueueMeasurement(A.RefreshTokenClientAcquireTokenByRefreshToken,r.correlationId),!r.account)throw I.createNoAccountInSilentRequestError();if(this.cacheManager.isAppMetadataFOCI(r.account.environment))try{return null!=(n=this.performanceClient)&&n.setPreQueueTime(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,r.correlationId),[2,this.acquireTokenWithCachedRefreshToken(r,!0)]}catch(e){if(t=e instanceof Zv&&e.errorCode===Yv.code,o=e instanceof wv&&e.errorCode===_m&&e.subError===wm,t||o)return null!=(i=this.performanceClient)&&i.setPreQueueTime(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,r.correlationId),[2,this.acquireTokenWithCachedRefreshToken(r,!1)];throw e}return null!=(i=this.performanceClient)&&i.setPreQueueTime(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,r.correlationId),[2,this.acquireTokenWithCachedRefreshToken(r,!1)]})})},y_.prototype.acquireTokenWithCachedRefreshToken=function(r,n){var i;return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){if(null!=(i=this.performanceClient)&&i.addQueueMeasurement(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,r.correlationId),t=null==(i=this.performanceClient)?void 0:i.startMeasurement(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,r.correlationId),this.logger.verbose("RefreshTokenClientAcquireTokenWithCachedRefreshToken called",r.correlationId),o=this.cacheManager.getRefreshToken(r.account,n))return null!=t&&t.endMeasurement({success:!0}),o=Bg(Bg({},r),{refreshToken:o.secret,authenticationScheme:r.authenticationScheme||em.BEARER,ccsCredential:{credential:r.account.homeAccountId,type:Ev.HOME_ACCOUNT_ID}}),null!=(i=this.performanceClient)&&i.setPreQueueTime(A.RefreshTokenClientAcquireToken,r.correlationId),[2,this.acquireToken(o)];throw null!=t&&t.discardMeasurement(),Zv.createNoTokensFoundError()})})},y_.prototype.executeTokenRequest=function(a,s){var c;return b(this,void 0,void 0,function(){var t,o,r,n,i;return C(this,function(e){switch(e.label){case 0:return null!=(c=this.performanceClient)&&c.addQueueMeasurement(A.RefreshTokenClientExecuteTokenRequest,a.correlationId),t=null==(c=this.performanceClient)?void 0:c.startMeasurement(A.RefreshTokenClientExecuteTokenRequest,a.correlationId),null!=(c=this.performanceClient)&&c.setPreQueueTime(A.RefreshTokenClientCreateTokenRequestBody,a.correlationId),o=this.createTokenQueryParameters(a),o=e_.appendQueryString(s.tokenEndpoint,o),[4,this.createTokenRequestBody(a)];case 1:return r=e.sent(),n=this.createTokenRequestHeaders(a.ccsCredential),i={clientId:this.config.authOptions.clientId,authority:s.canonicalAuthority,scopes:a.scopes,claims:a.claims,authenticationScheme:a.authenticationScheme,resourceRequestMethod:a.resourceRequestMethod,resourceRequestUri:a.resourceRequestUri,shrClaims:a.shrClaims,sshKid:a.sshKid},[2,this.executePostToTokenEndpoint(o,r,n,i).then(function(e){return null!=t&&t.endMeasurement({success:!0}),e}).catch(function(e){throw null!=t&&t.endMeasurement({success:!1}),e})]}})})},y_.prototype.createTokenRequestBody=function(i){var a;return b(this,void 0,void 0,function(){var t,o,r,n;return C(this,function(e){switch(e.label){case 0:return(null!=(a=this.performanceClient)&&a.addQueueMeasurement(A.RefreshTokenClientCreateTokenRequestBody,i.correlationId),r=i.correlationId,t=null==(a=this.performanceClient)?void 0:a.startMeasurement(A.BaseClientCreateTokenRequestHeaders,r),(o=new Pv).addClientId(this.config.authOptions.clientId),o.addScopes(i.scopes),o.addGrantType(Qg.REFRESH_TOKEN_GRANT),o.addClientInfo(),o.addLibraryInfo(this.config.libraryInfo),o.addApplicationTelemetry(this.config.telemetry.application),o.addThrottling(),this.serverTelemetryManager&&o.addServerTelemetry(this.serverTelemetryManager),o.addCorrelationId(r),o.addRefreshToken(i.refreshToken),this.config.clientCredentials.clientSecret&&o.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion&&(r=this.config.clientCredentials.clientAssertion,o.addClientAssertion(r.assertion),o.addClientAssertionType(r.assertionType)),i.authenticationScheme!==em.POP)?[3,2]:(r=new n_(this.cryptoUtils,this.performanceClient),null!=(a=this.performanceClient)&&a.setPreQueueTime(A.PopTokenGenerateCnf,i.correlationId),[4,r.generateCnf(i)]);case 1:return r=e.sent(),o.addPopToken(r.reqCnfString),[3,3];case 2:if(i.authenticationScheme===em.SSH){if(!i.sshJwk)throw null!=t&&t.endMeasurement({success:!1}),Vy.createMissingSshJwkError();o.addSshJwk(i.sshJwk)}e.label=3;case 3:if((!k.isEmptyObj(i.claims)||this.config.authOptions.clientCapabilities&&0<this.config.authOptions.clientCapabilities.length)&&o.addClaims(i.claims,this.config.authOptions.clientCapabilities),this.config.systemOptions.preventCorsPreflight&&i.ccsCredential)switch(i.ccsCredential.type){case Ev.HOME_ACCOUNT_ID:try{n=tv(i.ccsCredential.credential),o.addCcsOid(n)}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case Ev.UPN:o.addCcsUpn(i.ccsCredential.credential)}return null!=t&&t.endMeasurement({success:!0}),[2,o.createQueryString()]}})})};var g_,m_=y_;function y_(e,t){return g_.call(this,e,t)||this}Hg(w_,v_=ln),w_.prototype.acquireToken=function(o){return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),[4,this.acquireCachedToken(o)];case 1:return[2,e.sent()];case 2:if((t=e.sent())instanceof I&&t.errorCode===ly.code)return[2,new m_(this.config,this.performanceClient).acquireTokenByRefreshToken(o)];throw t;case 3:return[2]}})})},w_.prototype.acquireCachedToken=function(o){var r,n,i;return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:if(!o)throw Vy.createEmptyTokenRequestError();if(o.forceRefresh)throw null!=(r=this.serverTelemetryManager)&&r.setCacheOutcome(pm.FORCE_REFRESH),this.logger.info("SilentFlowClient:acquireCachedToken - Skipping cache because forceRefresh is true."),I.createRefreshRequiredError();if(!this.config.cacheOptions.claimsBasedCachingEnabled&&!k.isEmptyObj(o.claims))throw null!=(r=this.serverTelemetryManager)&&r.setCacheOutcome(pm.CLAIMS_REQUESTED_CACHE_SKIPPED),this.logger.info("SilentFlowClient:acquireCachedToken - Skipping cache because claims-based caching is disabled and claims were requested."),I.createRefreshRequiredError();if(!o.account)throw I.createNoAccountInSilentRequestError();if(t=o.authority||this.authority.getPreferredCache(),!(t=this.cacheManager.readCacheRecord(o.account,o,t)).accessToken)throw null!=(n=this.serverTelemetryManager)&&n.setCacheOutcome(pm.NO_CACHED_ACCESS_TOKEN),this.logger.info("SilentFlowClient:acquireCachedToken - No access token found in cache for the given properties."),I.createRefreshRequiredError();if(Lv.wasClockTurnedBack(t.accessToken.cachedAt)||Lv.isTokenExpired(t.accessToken.expiresOn,this.config.systemOptions.tokenRenewalOffsetSeconds))throw null!=(n=this.serverTelemetryManager)&&n.setCacheOutcome(pm.CACHED_ACCESS_TOKEN_EXPIRED),this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token is expired or will expire within "+this.config.systemOptions.tokenRenewalOffsetSeconds+" seconds."),I.createRefreshRequiredError();if(t.accessToken.refreshOn&&Lv.isTokenExpired(t.accessToken.refreshOn,0))throw null!=(i=this.serverTelemetryManager)&&i.setCacheOutcome(pm.REFRESH_CACHED_ACCESS_TOKEN),this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token's refreshOn property has been exceeded'."),I.createRefreshRequiredError();return this.config.serverTelemetryManager&&this.config.serverTelemetryManager.incrementCacheHits(),[4,this.generateResultFromCacheRecord(t,o)];case 1:return[2,e.sent()]}})})},w_.prototype.generateResultFromCacheRecord=function(r,n){return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){switch(e.label){case 0:if(r.idToken&&(t=new nv(r.idToken.secret,this.config.cryptoInterface)),n.maxAge||0===n.maxAge){if(!(o=null==t?void 0:t.claims.auth_time))throw I.createAuthTimeNotFoundError();nv.checkMaxAge(o,n.maxAge)}return[4,l_.generateAuthenticationResult(this.cryptoUtils,this.authority,r,!0,n,t)];case 1:return[2,e.sent()]}})})};var v_,__=w_;function w_(e,t){return v_.call(this,e,t)||this}var b_,C_={"https://login.microsoftonline.com/common/":{token_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.com/common/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.com/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.com/common/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.com",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pas.windows.net"},"https://login.chinacloudapi.cn/common/":{token_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.chinacloudapi.cn/common/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.partner.microsoftonline.cn/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://microsoftgraph.chinacloudapi.cn/oidc/userinfo",authorization_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.chinacloudapi.cn/common/kerberos",tenant_region_scope:null,cloud_instance_name:"partner.microsoftonline.cn",cloud_graph_host_name:"graph.chinacloudapi.cn",msgraph_host:"microsoftgraph.chinacloudapi.cn",rbac_url:"https://pas.chinacloudapi.cn"},"https://login.microsoftonline.us/common/":{token_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.us/common/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.us/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.us/common/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.us",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pasff.usgovcloudapi.net"},"https://login.microsoftonline.com/consumers/":{token_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.com/consumers/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.com/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.com/consumers/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.com",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pas.windows.net"},"https://login.chinacloudapi.cn/consumers/":{token_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.chinacloudapi.cn/consumers/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.partner.microsoftonline.cn/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://microsoftgraph.chinacloudapi.cn/oidc/userinfo",authorization_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.chinacloudapi.cn/consumers/kerberos",tenant_region_scope:null,cloud_instance_name:"partner.microsoftonline.cn",cloud_graph_host_name:"graph.chinacloudapi.cn",msgraph_host:"microsoftgraph.chinacloudapi.cn",rbac_url:"https://pas.chinacloudapi.cn"},"https://login.microsoftonline.us/consumers/":{token_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.us/consumers/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.us/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.us/consumers/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.us",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pasff.usgovcloudapi.net"},"https://login.microsoftonline.com/organizations/":{token_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.com/organizations/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.com/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.com/organizations/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.com",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pas.windows.net"},"https://login.chinacloudapi.cn/organizations/":{token_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.chinacloudapi.cn/organizations/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.partner.microsoftonline.cn/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://microsoftgraph.chinacloudapi.cn/oidc/userinfo",authorization_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.chinacloudapi.cn/organizations/kerberos",tenant_region_scope:null,cloud_instance_name:"partner.microsoftonline.cn",cloud_graph_host_name:"graph.chinacloudapi.cn",msgraph_host:"microsoftgraph.chinacloudapi.cn",rbac_url:"https://pas.chinacloudapi.cn"},"https://login.microsoftonline.us/organizations/":{token_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.us/organizations/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.us/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.us/organizations/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.us",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pasff.usgovcloudapi.net"}},S_={"https://login.microsoftonline.com/common/":{tenant_discovery_endpoint:"https://login.microsoftonline.com/common/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.chinacloudapi.cn/common/":{tenant_discovery_endpoint:"https://login.chinacloudapi.cn/common/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.us/common/":{tenant_discovery_endpoint:"https://login.microsoftonline.us/common/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.com/consumers/":{tenant_discovery_endpoint:"https://login.microsoftonline.com/consumers/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.chinacloudapi.cn/consumers/":{tenant_discovery_endpoint:"https://login.chinacloudapi.cn/consumers/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.us/consumers/":{tenant_discovery_endpoint:"https://login.microsoftonline.us/consumers/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.com/organizations/":{tenant_discovery_endpoint:"https://login.microsoftonline.com/organizations/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.chinacloudapi.cn/organizations/":{tenant_discovery_endpoint:"https://login.chinacloudapi.cn/organizations/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.us/organizations/":{tenant_discovery_endpoint:"https://login.microsoftonline.us/organizations/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]}},E_=((sr=b_=b_||{}).AAD="AAD",sr.OIDC="OIDC",T_.prototype.updateCloudDiscoveryMetadata=function(e,t){this.aliases=e.aliases,this.preferred_cache=e.preferred_cache,this.preferred_network=e.preferred_network,this.aliasesFromNetwork=t},T_.prototype.updateEndpointMetadata=function(e,t){this.authorization_endpoint=e.authorization_endpoint,this.token_endpoint=e.token_endpoint,this.end_session_endpoint=e.end_session_endpoint,this.issuer=e.issuer,this.endpointsFromNetwork=t,this.jwks_uri=e.jwks_uri},T_.prototype.updateCanonicalAuthority=function(e){this.canonical_authority=e},T_.prototype.resetExpiresAt=function(){this.expiresAt=Lv.nowSeconds()+sm},T_.prototype.isExpired=function(){return this.expiresAt<=Lv.nowSeconds()},T_.isAuthorityMetadataEntity=function(e,t){return!!t&&0===e.indexOf(am)&&t.hasOwnProperty("aliases")&&t.hasOwnProperty("preferred_cache")&&t.hasOwnProperty("preferred_network")&&t.hasOwnProperty("canonical_authority")&&t.hasOwnProperty("authorization_endpoint")&&t.hasOwnProperty("token_endpoint")&&t.hasOwnProperty("issuer")&&t.hasOwnProperty("aliasesFromNetwork")&&t.hasOwnProperty("endpointsFromNetwork")&&t.hasOwnProperty("expiresAt")&&t.hasOwnProperty("jwks_uri")},T_);function T_(){this.expiresAt=Lv.nowSeconds()+sm}k_.prototype.detectRegion=function(i,a){var s,c;return b(this,void 0,void 0,function(){var t,o,r,n;return C(this,function(e){switch(e.label){case 0:if(null!=(s=this.performanceClient)&&s.addQueueMeasurement(A.RegionDiscoveryDetectRegion,this.correlationId),t=i)return[3,8];o=k_.IMDS_OPTIONS,e.label=1;case 1:return e.trys.push([1,6,,7]),null!=(s=this.performanceClient)&&s.setPreQueueTime(A.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[4,this.getRegionFromIMDS(E.IMDS_VERSION,o)];case 2:return((r=e.sent()).status===lm.httpSuccess&&(t=r.body,a.region_source=hm.IMDS),r.status!==lm.httpBadRequest)?[3,5]:(null!=(c=this.performanceClient)&&c.setPreQueueTime(A.RegionDiscoveryGetCurrentVersion,this.correlationId),[4,this.getCurrentVersion(o)]);case 3:return(r=e.sent())?(null!=(c=this.performanceClient)&&c.setPreQueueTime(A.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[4,this.getRegionFromIMDS(r,o)]):(a.region_source=hm.FAILED_AUTO_DETECTION,[2,null]);case 4:(n=e.sent()).status===lm.httpSuccess&&(t=n.body,a.region_source=hm.IMDS),e.label=5;case 5:return[3,7];case 6:return e.sent(),a.region_source=hm.FAILED_AUTO_DETECTION,[2,null];case 7:return[3,9];case 8:a.region_source=hm.ENVIRONMENT_VARIABLE,e.label=9;case 9:return t||(a.region_source=hm.FAILED_AUTO_DETECTION),[2,t||null]}})})},k_.prototype.getRegionFromIMDS=function(t,o){var r;return b(this,void 0,void 0,function(){return C(this,function(e){return null!=(r=this.performanceClient)&&r.addQueueMeasurement(A.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[2,this.networkInterface.sendGetRequestAsync(E.IMDS_ENDPOINT+"?api-version="+t+"&format=text",o,E.IMDS_TIMEOUT)]})})},k_.prototype.getCurrentVersion=function(o){var r;return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:null!=(r=this.performanceClient)&&r.addQueueMeasurement(A.RegionDiscoveryGetCurrentVersion,this.correlationId),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(E.IMDS_ENDPOINT+"?format=json",o)];case 2:return(t=e.sent()).status===lm.httpBadRequest&&t.body&&t.body["newest-versions"]&&0<t.body["newest-versions"].length?[2,t.body["newest-versions"][0]]:[2,null];case 3:return e.sent(),[2,null];case 4:return[2]}})})},k_.IMDS_OPTIONS={headers:{Metadata:"true"}};var I_=k_;function k_(e,t,o){this.networkInterface=e,this.performanceClient=t,this.correlationId=o}g.prototype.getAuthorityType=function(e){if(e.HostNameAndPort.endsWith(E.CIAM_AUTH_URL))return Jy.Ciam;e=e.PathSegments;if(e.length)switch(e[0].toLowerCase()){case E.ADFS:return Jy.Adfs;case E.DSTS:return Jy.Dsts}return Jy.Default},Object.defineProperty(g.prototype,"authorityType",{get:function(){return this.getAuthorityType(this.canonicalAuthorityUrlComponents)},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"protocolMode",{get:function(){return this.authorityOptions.protocolMode},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"options",{get:function(){return this.authorityOptions},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"canonicalAuthority",{get:function(){return this._canonicalAuthority.urlString},set:function(e){this._canonicalAuthority=new e_(e),this._canonicalAuthority.validateAsUri(),this._canonicalAuthorityUrlComponents=null},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"canonicalAuthorityUrlComponents",{get:function(){return this._canonicalAuthorityUrlComponents||(this._canonicalAuthorityUrlComponents=this._canonicalAuthority.getUrlComponents()),this._canonicalAuthorityUrlComponents},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"hostnameAndPort",{get:function(){return this.canonicalAuthorityUrlComponents.HostNameAndPort.toLowerCase()},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"tenant",{get:function(){return this.canonicalAuthorityUrlComponents.PathSegments[0]},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"authorizationEndpoint",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.authorization_endpoint);throw I.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"tokenEndpoint",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.token_endpoint);throw I.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"deviceCodeEndpoint",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.token_endpoint.replace("/token","/devicecode"));throw I.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"endSessionEndpoint",{get:function(){if(this.discoveryComplete()){if(this.metadata.end_session_endpoint)return this.replacePath(this.metadata.end_session_endpoint);throw I.createLogoutNotSupportedError()}throw I.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"selfSignedJwtAudience",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.issuer);throw I.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(g.prototype,"jwksUri",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.jwks_uri);throw I.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),g.prototype.canReplaceTenant=function(e){return 1===e.PathSegments.length&&!g.reservedTenantDomains.has(e.PathSegments[0])&&this.getAuthorityType(e)===Jy.Default&&this.protocolMode===b_.AAD},g.prototype.replaceTenant=function(e){return e.replace(/{tenant}|{tenantid}/g,this.tenant)},g.prototype.replacePath=function(e){var r=this,n=e,i=new e_(this.metadata.canonical_authority).getUrlComponents(),a=i.PathSegments;return this.canonicalAuthorityUrlComponents.PathSegments.forEach(function(e,t){var o=a[t];0===t&&r.canReplaceTenant(i)&&o!==(t=new e_(r.metadata.authorization_endpoint).getUrlComponents().PathSegments[0])&&(r.logger.verbose("Replacing tenant domain name "+o+" with id "+t),o=t),e!==o&&(n=n.replace("/"+o+"/","/"+e+"/"))}),this.replaceTenant(n)},Object.defineProperty(g.prototype,"defaultOpenIdConfigurationEndpoint",{get:function(){return this.authorityType===Jy.Adfs||this.authorityType===Jy.Dsts||this.protocolMode===b_.OIDC?this.canonicalAuthority+".well-known/openid-configuration":this.canonicalAuthority+"v2.0/.well-known/openid-configuration"},enumerable:!1,configurable:!0}),g.prototype.discoveryComplete=function(){return!!this.metadata},g.prototype.resolveEndpointsAsync=function(){var n;return b(this,void 0,void 0,function(){var t,o,r;return C(this,function(e){switch(e.label){case 0:return null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityResolveEndpointsAsync,this.correlationId),(t=this.cacheManager.getAuthorityMetadataByAlias(this.hostnameAndPort))||(t=new E_).updateCanonicalAuthority(this.canonicalAuthority),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityUpdateCloudDiscoveryMetadata,this.correlationId),[4,this.updateCloudDiscoveryMetadata(t)];case 1:return o=e.sent(),this.canonicalAuthority=this.canonicalAuthority.replace(this.hostnameAndPort,t.preferred_network),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityUpdateEndpointMetadata,this.correlationId),[4,this.updateEndpointMetadata(t)];case 2:return r=e.sent(),o!==$g.CACHE&&r!==$g.CACHE&&(t.resetExpiresAt(),t.updateCanonicalAuthority(this.canonicalAuthority)),r=this.cacheManager.generateAuthorityMetadataCacheKey(t.preferred_cache),this.cacheManager.setAuthorityMetadata(r,t),this.metadata=t,[2]}})})},g.prototype.updateEndpointMetadata=function(r){var n,i,a;return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){switch(e.label){case 0:return(null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityUpdateEndpointMetadata,this.correlationId),t=this.getEndpointMetadataFromConfig())?(r.updateEndpointMetadata(t,!1),[2,$g.CONFIG]):this.isAuthoritySameType(r)&&r.endpointsFromNetwork&&!r.isExpired()?[2,$g.CACHE]:(null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityGetEndpointMetadataFromNetwork,this.correlationId),[4,this.getEndpointMetadataFromNetwork()]);case 1:return(t=e.sent())?null!=(n=this.authorityOptions.azureRegionConfiguration)&&n.azureRegion?(null!=(i=this.performanceClient)&&i.setPreQueueTime(A.AuthorityUpdateMetadataWithRegionalInformation,this.correlationId),[4,this.updateMetadataWithRegionalInformation(t)]):[3,3]:[3,4];case 2:t=e.sent(),e.label=3;case 3:return r.updateEndpointMetadata(t,!0),[2,$g.NETWORK];case 4:return!(o=this.getEndpointMetadataFromHardcodedValues())||this.authorityOptions.skipAuthorityMetadataCache?[3,7]:null!=(i=this.authorityOptions.azureRegionConfiguration)&&i.azureRegion?(null!=(a=this.performanceClient)&&a.setPreQueueTime(A.AuthorityUpdateMetadataWithRegionalInformation,this.correlationId),[4,this.updateMetadataWithRegionalInformation(o)]):[3,6];case 5:o=e.sent(),e.label=6;case 6:return r.updateEndpointMetadata(o,!1),[2,$g.HARDCODED_VALUES];case 7:throw I.createUnableToGetOpenidConfigError(this.defaultOpenIdConfigurationEndpoint)}})})},g.prototype.isAuthoritySameType=function(e){return new e_(e.canonical_authority).getUrlComponents().PathSegments.length===this.canonicalAuthorityUrlComponents.PathSegments.length},g.prototype.getEndpointMetadataFromConfig=function(){if(this.authorityOptions.authorityMetadata)try{return JSON.parse(this.authorityOptions.authorityMetadata)}catch(e){throw Vy.createInvalidAuthorityMetadataError()}return null},g.prototype.getEndpointMetadataFromNetwork=function(){var n;return b(this,void 0,void 0,function(){var o,r;return C(this,function(e){switch(e.label){case 0:null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityGetEndpointMetadataFromNetwork,this.correlationId),o={},e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(this.defaultOpenIdConfigurationEndpoint,o)];case 2:return r=e.sent(),[2,(t=r.body).hasOwnProperty("authorization_endpoint")&&t.hasOwnProperty("token_endpoint")&&t.hasOwnProperty("issuer")&&t.hasOwnProperty("jwks_uri")?r.body:null];case 3:return e.sent(),[2,null];case 4:return[2]}var t})})},g.prototype.getEndpointMetadataFromHardcodedValues=function(){return this.canonicalAuthority in C_?C_[this.canonicalAuthority]:null},g.prototype.updateMetadataWithRegionalInformation=function(o){var r;return b(this,void 0,void 0,function(){var t;return C(this,function(e){switch(e.label){case 0:return(null!=(r=this.performanceClient)&&r.addQueueMeasurement(A.AuthorityUpdateMetadataWithRegionalInformation,this.correlationId),t=null==(r=this.authorityOptions.azureRegionConfiguration)?void 0:r.azureRegion)?t!==E.AZURE_REGION_AUTO_DISCOVER_FLAG?(this.regionDiscoveryMetadata.region_outcome=dm.CONFIGURED_NO_AUTO_DETECTION,this.regionDiscoveryMetadata.region_used=t,[2,g.replaceWithRegionalInformation(o,t)]):(null!=(r=this.performanceClient)&&r.setPreQueueTime(A.RegionDiscoveryDetectRegion,this.correlationId),[4,this.regionDiscovery.detectRegion(null==(r=this.authorityOptions.azureRegionConfiguration)?void 0:r.environmentRegion,this.regionDiscoveryMetadata)]):[3,2];case 1:if(t=e.sent())return this.regionDiscoveryMetadata.region_outcome=dm.AUTO_DETECTION_REQUESTED_SUCCESSFUL,this.regionDiscoveryMetadata.region_used=t,[2,g.replaceWithRegionalInformation(o,t)];this.regionDiscoveryMetadata.region_outcome=dm.AUTO_DETECTION_REQUESTED_FAILED,e.label=2;case 2:return[2,o]}})})},g.prototype.updateCloudDiscoveryMetadata=function(r){var n;return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){switch(e.label){case 0:return(null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityUpdateCloudDiscoveryMetadata,this.correlationId),this.logger.verbose("Attempting to get cloud discovery metadata in the config"),this.logger.verbosePii("Known Authorities: "+(this.authorityOptions.knownAuthorities||E.NOT_APPLICABLE)),this.logger.verbosePii("Authority Metadata: "+(this.authorityOptions.authorityMetadata||E.NOT_APPLICABLE)),this.logger.verbosePii("Canonical Authority: "+(r.canonical_authority||E.NOT_APPLICABLE)),t=this.getCloudDiscoveryMetadataFromConfig())?(this.logger.verbose("Found cloud discovery metadata in the config."),r.updateCloudDiscoveryMetadata(t,!1),[2,$g.CONFIG]):(this.logger.verbose("Did not find cloud discovery metadata in the config... Attempting to get cloud discovery metadata from the cache."),o=r.isExpired(),this.isAuthoritySameType(r)&&r.aliasesFromNetwork&&!o?(this.logger.verbose("Found metadata in the cache."),[2,$g.CACHE]):(o&&this.logger.verbose("The metadata entity is expired."),this.logger.verbose("Did not find cloud discovery metadata in the cache... Attempting to get cloud discovery metadata from the network."),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityGetCloudDiscoveryMetadataFromNetwork,this.correlationId),[4,this.getCloudDiscoveryMetadataFromNetwork()]));case 1:if(t=e.sent())return this.logger.verbose("cloud discovery metadata was successfully returned from getCloudDiscoveryMetadataFromNetwork()"),r.updateCloudDiscoveryMetadata(t,!0),[2,$g.NETWORK];if(this.logger.verbose("Did not find cloud discovery metadata from the network... Attempting to get cloud discovery metadata from hardcoded values."),(o=this.getCloudDiscoveryMetadataFromHarcodedValues())&&!this.options.skipAuthorityMetadataCache)return this.logger.verbose("Found cloud discovery metadata from hardcoded values."),r.updateCloudDiscoveryMetadata(o,!1),[2,$g.HARDCODED_VALUES];throw this.logger.error("Did not find cloud discovery metadata from hardcoded values... Metadata could not be obtained from config, cache, network or hardcoded values. Throwing Untrusted Authority Error."),Vy.createUntrustedAuthorityError()}})})},g.prototype.getCloudDiscoveryMetadataFromConfig=function(){if(this.authorityType===Jy.Ciam)return this.logger.verbose("CIAM authorities do not support cloud discovery metadata, generate the aliases from authority host."),g.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort);if(this.authorityOptions.cloudDiscoveryMetadata){this.logger.verbose("The cloud discovery metadata has been provided as a network response, in the config.");try{this.logger.verbose("Attempting to parse the cloud discovery metadata.");var e=JSON.parse(this.authorityOptions.cloudDiscoveryMetadata),t=g.getCloudDiscoveryMetadataFromNetworkResponse(e.metadata,this.hostnameAndPort);if(this.logger.verbose("Parsed the cloud discovery metadata."),t)return this.logger.verbose("There is returnable metadata attached to the parsed cloud discovery metadata."),t;this.logger.verbose("There is no metadata attached to the parsed cloud discovery metadata.")}catch(e){throw this.logger.verbose("Unable to parse the cloud discovery metadata. Throwing Invalid Cloud Discovery Metadata Error."),Vy.createInvalidCloudDiscoveryMetadataError()}}return this.isInKnownAuthorities()?(this.logger.verbose("The host is included in knownAuthorities. Creating new cloud discovery metadata from the host."),g.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort)):null},g.prototype.getCloudDiscoveryMetadataFromNetwork=function(){var c;return b(this,void 0,void 0,function(){var o,r,n,i,a,s;return C(this,function(e){switch(e.label){case 0:null!=(c=this.performanceClient)&&c.addQueueMeasurement(A.AuthorityGetCloudDiscoveryMetadataFromNetwork,this.correlationId),o=""+E.AAD_INSTANCE_DISCOVERY_ENDPT+this.canonicalAuthority+"oauth2/v2.0/authorize",r={},n=null,e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(o,r)];case 2:if(s=e.sent(),a=i=void 0,(t=s.body).hasOwnProperty("tenant_discovery_endpoint")&&t.hasOwnProperty("metadata"))i=s.body,a=i.metadata,this.logger.verbosePii("tenant_discovery_endpoint is: "+i.tenant_discovery_endpoint);else{if(!(t=s.body).hasOwnProperty("error")||!t.hasOwnProperty("error_description"))return this.logger.error("AAD did not return a CloudInstanceDiscoveryResponse or CloudInstanceDiscoveryErrorResponse"),[2,null];if(this.logger.warning("A CloudInstanceDiscoveryErrorResponse was returned. The cloud instance discovery network request's status code is: "+s.status),(i=s.body).error===E.INVALID_INSTANCE)return this.logger.error("The CloudInstanceDiscoveryErrorResponse error is invalid_instance."),[2,null];this.logger.warning("The CloudInstanceDiscoveryErrorResponse error is "+i.error),this.logger.warning("The CloudInstanceDiscoveryErrorResponse error description is "+i.error_description),this.logger.warning("Setting the value of the CloudInstanceDiscoveryMetadata (returned from the network) to []"),a=[]}return this.logger.verbose("Attempting to find a match between the developer's authority and the CloudInstanceDiscoveryMetadata returned from the network request."),n=g.getCloudDiscoveryMetadataFromNetworkResponse(a,this.hostnameAndPort),[3,4];case 3:return(s=e.sent())instanceof T?this.logger.error("There was a network error while attempting to get the cloud discovery instance metadata.\nError: "+s.errorCode+"\nError Description: "+s.errorMessage):this.logger.error("A non-MSALJS error was thrown while attempting to get the cloud instance discovery metadata.\nError: "+s.name+"\nError Description: "+s.message),[2,null];case 4:return n||(this.logger.warning("The developer's authority was not found within the CloudInstanceDiscoveryMetadata returned from the network request."),this.logger.verbose("Creating custom Authority for custom domain scenario."),n=g.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort)),[2,n]}var t})})},g.prototype.getCloudDiscoveryMetadataFromHarcodedValues=function(){return this.canonicalAuthority in S_?S_[this.canonicalAuthority]:null},g.prototype.isInKnownAuthorities=function(){var t=this;return 0<this.authorityOptions.knownAuthorities.filter(function(e){return e_.getDomainFromUrl(e).toLowerCase()===t.hostnameAndPort}).length},g.generateAuthority=function(e,t){var o;return t&&t.azureCloudInstance!==Sy.None&&(o=t.tenant||E.DEFAULT_COMMON_TENANT,o=t.azureCloudInstance+"/"+o+"/"),o||e},g.createCloudDiscoveryMetadataFromHost=function(e){return{preferred_network:e,preferred_cache:e,aliases:[e]}},g.getCloudDiscoveryMetadataFromNetworkResponse=function(e,t){for(var o=0;o<e.length;o++){var r=e[o];if(-1<r.aliases.indexOf(t))return r}return null},g.prototype.getPreferredCache=function(){if(this.discoveryComplete())return this.metadata.preferred_cache;throw I.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},g.prototype.isAlias=function(e){return-1<this.metadata.aliases.indexOf(e)},g.isPublicCloudAuthority=function(e){return 0<=E.KNOWN_PUBLIC_CLOUDS.indexOf(e)},g.buildRegionalAuthorityString=function(e,t,o){var e=new e_(e),r=(e.validateAsUri(),e.getUrlComponents()),n=t+"."+r.HostNameAndPort,r=(this.isPublicCloudAuthority(r.HostNameAndPort)&&(n=t+"."+E.REGIONAL_AUTH_PUBLIC_CLOUD_SUFFIX),e_.constructAuthorityUriFromObject(Bg(Bg({},e.getUrlComponents()),{HostNameAndPort:n})).urlString);return o?r+"?"+o:r},g.replaceWithRegionalInformation=function(e,t){return e.authorization_endpoint=g.buildRegionalAuthorityString(e.authorization_endpoint,t),e.token_endpoint=g.buildRegionalAuthorityString(e.token_endpoint,t,E.REGIONAL_AUTH_NON_MSI_QUERY_STRING),e.end_session_endpoint&&(e.end_session_endpoint=g.buildRegionalAuthorityString(e.end_session_endpoint,t)),e},g.transformCIAMAuthority=function(e){var t=e.endsWith(E.FORWARD_SLASH)?e:""+e+E.FORWARD_SLASH,e=new e_(e).getUrlComponents();return t=0===e.PathSegments.length&&e.HostNameAndPort.endsWith(E.CIAM_AUTH_URL)?""+t+e.HostNameAndPort.split(".")[0]+E.AAD_TENANT_DOMAIN_SUFFIX:t},g.reservedTenantDomains=new Set(["{tenant}","{tenantid}",Gg.COMMON,Gg.CONSUMERS,Gg.ORGANIZATIONS]);var A_=g;function g(e,t,o,r,n,i,a){this.canonicalAuthority=e,this._canonicalAuthority.validateAsUri(),this.networkInterface=t,this.cacheManager=o,this.authorityOptions=r,this.regionDiscoveryMetadata={region_used:void 0,region_source:void 0,region_outcome:void 0},this.logger=n,this.performanceClient=i,this.correlationId=a,this.regionDiscovery=new I_(t,this.performanceClient,this.correlationId)}O_.createDiscoveredInstance=function(r,n,i,a,s,c,u){return b(this,void 0,void 0,function(){var t,o;return C(this,function(e){switch(e.label){case 0:null!=c&&c.addQueueMeasurement(A.AuthorityFactoryCreateDiscoveredInstance,u),t=A_.transformCIAMAuthority(r),t=O_.createInstance(t,n,i,a,s,c,u),e.label=1;case 1:return e.trys.push([1,3,,4]),null!=c&&c.setPreQueueTime(A.AuthorityResolveEndpointsAsync,u),[4,t.resolveEndpointsAsync()];case 2:return e.sent(),[2,t];case 3:throw o=e.sent(),I.createEndpointDiscoveryIncompleteError(o);case 4:return[2]}})})},O_.createInstance=function(e,t,o,r,n,i,a){if(k.isEmpty(e))throw Vy.createUrlEmptyError();return new A_(e,t,o,r,n,i,a)};var P_=O_;function O_(){}x_.isServerTelemetryEntity=function(e,t){var e=0===e.indexOf(cm.CACHE_KEY),o=!0;return t&&(o=t.hasOwnProperty("failedRequests")&&t.hasOwnProperty("errors")&&t.hasOwnProperty("cacheHits")),e&&o};var R_=x_;function x_(){this.failedRequests=[],this.errors=[],this.cacheHits=0}N_.isThrottlingEntity=function(e,t){var o=!1,e=(e&&(o=0===e.indexOf(ym)),!0);return t&&(e=t.hasOwnProperty("throttleTime")),o&&e};var M_=N_;function N_(){}var L_,D_={sendGetRequestAsync:function(){return Promise.reject(T.createUnexpectedError("Network interface - sendGetRequestAsync() has not been implemented for the Network interface."))},sendPostRequestAsync:function(){return Promise.reject(T.createUnexpectedError("Network interface - sendPostRequestAsync() has not been implemented for the Network interface."))}},q_={code:"missing_kid_error",desc:"The JOSE Header for the requested JWT, JWS or JWK object requires a keyId to be configured as the 'kid' header claim. No 'kid' value was provided."},U_={code:"missing_alg_error",desc:"The JOSE Header for the requested JWT, JWS or JWK object requires an algorithm to be specified as the 'alg' header claim. No 'alg' value was provided."},j_=(Hg(H_,L_=T),H_.createMissingKidError=function(){return new H_(q_.code,q_.desc)},H_.createMissingAlgError=function(){return new H_(U_.code,U_.desc)},H_);function H_(e,t){e=L_.call(this,e,t)||this;return e.name="JoseHeaderError",Object.setPrototypeOf(e,H_.prototype),e}F_.getShrHeaderString=function(e){if(!e.kid)throw j_.createMissingKidError();if(e.alg)return e=new F_({typ:e.typ||fm.Pop,kid:e.kid,alg:e.alg}),JSON.stringify(e);throw j_.createMissingAlgError()};var B_=F_;function F_(e){this.typ=e.typ,this.alg=e.alg,this.kid=e.kid}K_.prototype.generateCurrentRequestHeaderValue=function(){var e=""+this.apiId+cm.VALUE_SEPARATOR+this.cacheOutcome,t=[this.wrapperSKU,this.wrapperVer].join(cm.VALUE_SEPARATOR),e=[e,this.getRegionDiscoveryFields()].join(cm.VALUE_SEPARATOR);return[cm.SCHEMA_VERSION,e,t].join(cm.CATEGORY_SEPARATOR)},K_.prototype.generateLastRequestHeaderValue=function(){var e=this.getLastRequests(),t=K_.maxErrorsToSend(e),o=e.failedRequests.slice(0,2*t).join(cm.VALUE_SEPARATOR),r=e.errors.slice(0,t).join(cm.VALUE_SEPARATOR),n=e.errors.length,t=[n,t<n?cm.OVERFLOW_TRUE:cm.OVERFLOW_FALSE].join(cm.VALUE_SEPARATOR);return[cm.SCHEMA_VERSION,e.cacheHits,o,r,t].join(cm.CATEGORY_SEPARATOR)},K_.prototype.cacheFailedRequest=function(e){var t=this.getLastRequests();t.errors.length>=cm.MAX_CACHED_ERRORS&&(t.failedRequests.shift(),t.failedRequests.shift(),t.errors.shift()),t.failedRequests.push(this.apiId,this.correlationId),k.isEmpty(e.subError)?k.isEmpty(e.errorCode)?e&&e.toString()?t.errors.push(e.toString()):t.errors.push(cm.UNKNOWN_ERROR):t.errors.push(e.errorCode):t.errors.push(e.subError),this.cacheManager.setServerTelemetry(this.telemetryCacheKey,t)},K_.prototype.incrementCacheHits=function(){var e=this.getLastRequests();return e.cacheHits+=1,this.cacheManager.setServerTelemetry(this.telemetryCacheKey,e),e.cacheHits},K_.prototype.getLastRequests=function(){var e=new R_;return this.cacheManager.getServerTelemetry(this.telemetryCacheKey)||e},K_.prototype.clearTelemetryCache=function(){var e,t=this.getLastRequests(),o=K_.maxErrorsToSend(t);o===t.errors.length?this.cacheManager.removeItem(this.telemetryCacheKey):((e=new R_).failedRequests=t.failedRequests.slice(2*o),e.errors=t.errors.slice(o),this.cacheManager.setServerTelemetry(this.telemetryCacheKey,e))},K_.maxErrorsToSend=function(e){for(var t=0,o=0,r=e.errors.length,n=0;n<r;n++){var i=e.failedRequests[2*n]||E.EMPTY_STRING,a=e.failedRequests[2*n+1]||E.EMPTY_STRING,s=e.errors[n]||E.EMPTY_STRING;if(!((o+=i.toString().length+a.toString().length+s.length+3)<cm.MAX_LAST_HEADER_BYTES))break;t+=1}return t},K_.prototype.getRegionDiscoveryFields=function(){var e=[];return e.push(this.regionUsed||E.EMPTY_STRING),e.push(this.regionSource||E.EMPTY_STRING),e.push(this.regionOutcome||E.EMPTY_STRING),e.join(",")},K_.prototype.updateRegionDiscoveryMetadata=function(e){this.regionUsed=e.region_used,this.regionSource=e.region_source,this.regionOutcome=e.region_outcome},K_.prototype.setCacheOutcome=function(e){this.cacheOutcome=e};var z_=K_;function K_(e,t){this.cacheOutcome=pm.NO_CACHE_HIT,this.cacheManager=t,this.apiId=e.apiId,this.correlationId=e.correlationId,this.wrapperSKU=e.wrapperSKU||E.EMPTY_STRING,this.wrapperVer=e.wrapperVer||E.EMPTY_STRING,this.telemetryCacheKey=cm.CACHE_KEY+Jg.CACHE_KEY_SEPARATOR+e.clientId}G_.prototype.startPerformanceMeasurement=function(e,t){return{}},G_.prototype.startPerformanceMeasuremeant=function(e,t){return{}},G_.prototype.getIntFields=function(){return r_},G_.prototype.getPreQueueTime=function(e,t){var o=this.preQueueTimeByCorrelationId.get(t);if(o){if(o.name===e)return o.time;this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue time found for "+e+", unable to add queue measurement")}else this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue times found for correlationId: "+t+", unable to add queue measurement")},G_.prototype.calculateQueuedTime=function(e,t){return e<1?(this.logger.trace("PerformanceClient: preQueueTime should be a positive integer and not "+e),0):t<1?(this.logger.trace("PerformanceClient: currentTime should be a positive integer and not "+t),0):t<e?(this.logger.trace("PerformanceClient: currentTime is less than preQueueTime, check how time is being retrieved"),0):t-e},G_.prototype.addQueueMeasurement=function(e,t,o,r){if(t){if(0===o)this.logger.trace("PerformanceClient.addQueueMeasurement: queue time provided for "+e+" is "+o);else if(!o)return void this.logger.trace("PerformanceClient.addQueueMeasurement: no queue time provided for "+e);o={eventName:e,queueTime:o,manuallyCompleted:r},r=this.queueMeasurements.get(t);r?(r.push(o),this.queueMeasurements.set(t,r)):(this.logger.trace("PerformanceClient.addQueueMeasurement: adding correlationId "+t+" to queue measurements"),this.queueMeasurements.set(t,[o])),this.preQueueTimeByCorrelationId.delete(t)}else this.logger.trace("PerformanceClient.addQueueMeasurement: correlationId not provided for "+e+", cannot add queue measurement")},G_.prototype.startMeasurement=function(e,t){var o=this,r=t||this.generateId(),n=(t||this.logger.info("PerformanceClient: No correlation id provided for "+e+", generating",r),this.logger.trace("PerformanceClient: Performance measurement started for "+e,r),this.startPerformanceMeasuremeant(e,r)),i=(n.startMeasurement(),{eventId:this.generateId(),status:$v.InProgress,authority:this.authority,libraryName:this.libraryName,libraryVersion:this.libraryVersion,clientId:this.clientId,name:e,startTimeMs:Date.now(),correlationId:r,appName:null==(t=this.applicationTelemetry)?void 0:t.appName,appVersion:null==(e=this.applicationTelemetry)?void 0:e.appVersion});return this.cacheEventByCorrelationId(i),{endMeasurement:function(e){return o.endMeasurement(Bg(Bg({},i),e),n)},discardMeasurement:function(){return o.discardMeasurements(i.correlationId)},addStaticFields:function(e){return o.addStaticFields(e,i.correlationId)},increment:function(e){return o.increment(e,i.correlationId)},measurement:n,event:i}},G_.prototype.endMeasurement=function(t,e){var o,r,n,i,a,s=this,c=this.eventsByCorrelationId.get(t.correlationId);return c?(r={totalQueueTime:0,totalQueueCount:0,manuallyCompletedCount:0},(o=t.eventId===c.eventId)?(r=this.getQueueInfo(t.correlationId),this.discardCache(c.correlationId)):null!=(n=c.incompleteSubMeasurements)&&n.delete(t.eventId),null!=e&&e.endMeasurement(),(n=null==e?void 0:e.flushMeasurement())?(this.logger.trace("PerformanceClient: Performance measurement ended for "+t.name+": "+n+" ms",t.correlationId),o?(i=Bg(Bg({},c),t),a=0,null!=(e=i.incompleteSubMeasurements)&&e.forEach(function(e){s.logger.trace("PerformanceClient: Incomplete submeasurement "+e.name+" found for "+t.name,i.correlationId),a++}),i.incompleteSubMeasurements=void 0,i=Bg(Bg({},i),{durationMs:Math.round(n),queuedTimeMs:r.totalQueueTime,queuedCount:r.totalQueueCount,queuedManuallyCompletedCount:r.manuallyCompletedCount,status:$v.Completed,incompleteSubsCount:a}),this.truncateIntegralFields(i,this.getIntFields()),this.emitEvents([i],t.correlationId),i):(c[t.name+"DurationMs"]=Math.floor(n),Bg({},c))):(this.logger.trace("PerformanceClient: Performance measurement not taken",c.correlationId),null)):(this.logger.trace("PerformanceClient: Measurement not found for "+t.eventId,t.correlationId),null)},G_.prototype.addStaticFields=function(e,t){this.logger.trace("PerformanceClient: Updating static fields");var o=this.eventsByCorrelationId.get(t);o?this.eventsByCorrelationId.set(t,Bg(Bg({},o),e)):this.logger.trace("PerformanceClient: Event not found for",t)},G_.prototype.increment=function(e,t){this.logger.trace("PerformanceClient: Updating counters");var o=this.eventsByCorrelationId.get(t);if(o)for(var r in e)o.hasOwnProperty(r)||(o[r]=0),o[r]+=e[r];else this.logger.trace("PerformanceClient: Event not found for",t)},G_.prototype.cacheEventByCorrelationId=function(e){var t=this.eventsByCorrelationId.get(e.correlationId);t?(this.logger.trace("PerformanceClient: Performance measurement for "+e.name+" added/updated",e.correlationId),t.incompleteSubMeasurements=t.incompleteSubMeasurements||new Map,t.incompleteSubMeasurements.set(e.eventId,{name:e.name,startTimeMs:e.startTimeMs})):(this.logger.trace("PerformanceClient: Performance measurement for "+e.name+" started",e.correlationId),this.eventsByCorrelationId.set(e.correlationId,Bg({},e)))},G_.prototype.getQueueInfo=function(e){var t=this.queueMeasurements.get(e),o=(t||this.logger.trace("PerformanceClient: no queue measurements found for for correlationId: "+e),0),r=0,n=0;return null!=t&&t.forEach(function(e){o+=e.queueTime,r++,n+=e.manuallyCompleted?1:0}),{totalQueueTime:o,totalQueueCount:r,manuallyCompletedCount:n}},G_.prototype.discardMeasurements=function(e){this.logger.trace("PerformanceClient: Performance measurements discarded",e),this.eventsByCorrelationId.delete(e)},G_.prototype.discardCache=function(e){this.discardMeasurements(e),this.logger.trace("PerformanceClient: QueueMeasurements discarded",e),this.queueMeasurements.delete(e),this.logger.trace("PerformanceClient: Pre-queue times discarded",e),this.preQueueTimeByCorrelationId.delete(e)},G_.prototype.addPerformanceCallback=function(e){var t=this.generateId();return this.callbacks.set(t,e),this.logger.verbose("PerformanceClient: Performance callback registered with id: "+t),t},G_.prototype.removePerformanceCallback=function(e){var t=this.callbacks.delete(e);return t?this.logger.verbose("PerformanceClient: Performance callback "+e+" removed."):this.logger.verbose("PerformanceClient: Performance callback "+e+" not removed."),t},G_.prototype.emitEvents=function(o,r){var n=this;this.logger.verbose("PerformanceClient: Emitting performance events",r),this.callbacks.forEach(function(e,t){n.logger.trace("PerformanceClient: Emitting event to callback "+t,r),e.apply(null,[o])})},G_.prototype.truncateIntegralFields=function(t,e){e.forEach(function(e){e in t&&"number"==typeof t[e]&&(t[e]=Math.floor(t[e]))})};var i=G_;function G_(e,t,o,r,n,i){this.authority=t,this.libraryName=r,this.libraryVersion=n,this.applicationTelemetry=i,this.clientId=e,this.logger=o,this.callbacks=new Map,this.eventsByCorrelationId=new Map,this.queueMeasurements=new Map,this.preQueueTimeByCorrelationId=new Map}W_.prototype.startMeasurement=function(){},W_.prototype.endMeasurement=function(){},W_.prototype.flushMeasurement=function(){return null};var Y_=W_;function W_(){}Hg(V_,Z_=i),V_.prototype.generateId=function(){return"callback-id"},V_.prototype.startPerformanceMeasuremeant=function(){return new Y_},V_.prototype.startPerformanceMeasurement=function(){return new Y_},V_.prototype.calculateQueuedTime=function(e,t){return 0},V_.prototype.addQueueMeasurement=function(e,t,o){},V_.prototype.setPreQueueTime=function(e,t){};var Z_,Q_=V_;function V_(){return null!==Z_&&Z_.apply(this,arguments)||this}var J_,X_={code:"pkce_not_created",desc:"The PKCE code challenge and verifier could not be generated."},$_={code:"crypto_nonexistent",desc:"The crypto object or function is not available."},ew={code:"http_method_not_implemented",desc:"The HTTP method given has not been implemented in this library."},tw={code:"empty_navigate_uri",desc:"Navigation URI is empty. Please check stack trace for more info."},ow={code:"hash_empty_error",desc:"Hash value cannot be processed because it is empty. Please verify that your redirectUri is not clearing the hash. For more visit: aka.ms/msaljs/browser-errors."},rw={code:"no_state_in_hash",desc:"Hash does not contain state. Please verify that the request originated from msal."},nw={code:"hash_does_not_contain_known_properties",desc:"Hash does not contain known properites. Please verify that your redirectUri is not changing the hash. For more visit: aka.ms/msaljs/browser-errors."},iw={code:"unable_to_parse_state",desc:"Unable to parse state. Please verify that the request originated from msal."},aw={code:"state_interaction_type_mismatch",desc:"Hash contains state but the interaction type does not match the caller."},sw={code:"interaction_in_progress",desc:"Interaction is currently in progress. Please ensure that this interaction has been completed before calling an interactive API.  For more visit: aka.ms/msaljs/browser-errors."},cw={code:"popup_window_error",desc:"Error opening popup window. This can happen if you are using IE or if popups are blocked in the browser."},uw={code:"empty_window_error",desc:"window.open returned null or undefined window object."},lw={code:"user_cancelled",desc:"User cancelled the flow."},hw={code:"monitor_window_timeout",desc:"Token acquisition in popup failed due to timeout. For more visit: aka.ms/msaljs/browser-errors."},dw={code:"monitor_window_timeout",desc:"Token acquisition in iframe failed due to timeout. For more visit: aka.ms/msaljs/browser-errors."},pw={code:"redirect_in_iframe",desc:"Redirects are not supported for iframed or brokered applications. Please ensure you are using MSAL.js in a top frame of the window if using the redirect APIs, or use the popup APIs."},fw={code:"block_iframe_reload",desc:"Request was blocked inside an iframe because MSAL detected an authentication response. For more visit: aka.ms/msaljs/browser-errors"},gw={code:"block_nested_popups",desc:"Request was blocked inside a popup because MSAL detected it was running in a popup."},mw={code:"iframe_closed_prematurely",desc:"The iframe being monitored was closed prematurely."},yw={code:"silent_logout_unsupported",desc:"Silent logout not supported. Please call logoutRedirect or logoutPopup instead."},vw={code:"no_account_error",desc:"No account object provided to acquireTokenSilent and no active account has been set. Please call setActiveAccount or provide an account on the request."},_w={code:"silent_prompt_value_error",desc:"The value given for the prompt value is not valid for silent requests - must be set to 'none' or 'no_session'."},ww={code:"no_token_request_cache_error",desc:"No token request found in cache."},bw={code:"unable_to_parse_token_request_cache_error",desc:"The cached token request could not be parsed."},Cw={code:"no_cached_authority_error",desc:"No cached authority found."},Sw={code:"auth_request_not_set_error",desc:"Auth Request not set. Please ensure initiateAuthRequest was called from the InteractionHandler"},Ew={code:"invalid_cache_type",desc:"Invalid cache type"},Tw={code:"non_browser_environment",desc:"Login and token requests are not supported in non-browser environments."},Iw={code:"database_not_open",desc:"Database is not open!"},kw={code:"no_network_connectivity",desc:"No network connectivity. Check your internet connection."},Aw={code:"post_request_failed",desc:"Network request failed: If the browser threw a CORS error, check that the redirectUri is registered in the Azure App Portal as type 'SPA'"},Pw={code:"get_request_failed",desc:"Network request failed. Please check the network trace to determine root cause."},Ow={code:"failed_to_parse_response",desc:"Failed to parse network response. Check network trace."},Rw={code:"unable_to_load_token",desc:"Error loading token to cache."},xw={code:"crypto_key_not_found",desc:"Cryptographic Key or Keypair not found in browser storage."},Mw={code:"auth_code_required",desc:"An authorization code must be provided (as the `code` property on the request) to this flow."},Nw={code:"auth_code_or_nativeAccountId_required",desc:"An authorization code or nativeAccountId must be provided to this flow."},Lw={code:"spa_code_and_nativeAccountId_present",desc:"Request cannot contain both spa code and native account id."},Dw={code:"database_unavailable",desc:"IndexedDB, which is required for persistent cryptographic key storage, is unavailable. This may be caused by browser privacy features which block persistent storage in third-party contexts."},qw={code:"unable_to_acquire_token_from_native_platform",desc:"Unable to acquire token from native platform. For a list of possible reasons visit aka.ms/msaljs/browser-errors."},Uw={code:"native_handshake_timeout",desc:"Timed out while attempting to establish connection to browser extension"},jw={code:"native_extension_not_installed",desc:"Native extension is not installed. If you think this is a mistake call the initialize function."},Hw={code:"native_connection_not_established",desc:"Connection to native platform has not been established. Please install a compatible browser extension and run initialize(). For more please visit aka.ms/msaljs/browser-errors."},Bw={code:"native_broker_called_before_initialize",desc:"You must call and await the initialize function before attempting to call any other MSAL API when native brokering is enabled. For more please visit aka.ms/msaljs/browser-errors."},Fw={code:"native_prompt_not_supported",desc:"The provided prompt is not supported by the native platform. This request should be routed to the web based flow."},P=(Dg(m,J_=T),m.createPkceNotGeneratedError=function(e){return new m(X_.code,X_.desc+" Detail:"+e)},m.createCryptoNotAvailableError=function(e){return new m($_.code,$_.desc+" Detail:"+e)},m.createHttpMethodNotImplementedError=function(e){return new m(ew.code,ew.desc+" Given Method: "+e)},m.createEmptyNavigationUriError=function(){return new m(tw.code,tw.desc)},m.createEmptyHashError=function(e){return new m(ow.code,ow.desc+" Given Url: "+e)},m.createHashDoesNotContainStateError=function(){return new m(rw.code,rw.desc)},m.createHashDoesNotContainKnownPropertiesError=function(){return new m(nw.code,nw.desc)},m.createUnableToParseStateError=function(){return new m(iw.code,iw.desc)},m.createStateInteractionTypeMismatchError=function(){return new m(aw.code,aw.desc)},m.createInteractionInProgressError=function(){return new m(sw.code,sw.desc)},m.createPopupWindowError=function(e){var t=cw.desc,t=k.isEmpty(e)?t:t+" Details: "+e;return new m(cw.code,t)},m.createEmptyWindowCreatedError=function(){return new m(uw.code,uw.desc)},m.createUserCancelledError=function(){return new m(lw.code,lw.desc)},m.createMonitorPopupTimeoutError=function(){return new m(hw.code,hw.desc)},m.createMonitorIframeTimeoutError=function(){return new m(dw.code,dw.desc)},m.createRedirectInIframeError=function(e){return new m(pw.code,pw.desc+" (window.parent !== window) => "+e)},m.createBlockReloadInHiddenIframeError=function(){return new m(fw.code,fw.desc)},m.createBlockAcquireTokenInPopupsError=function(){return new m(gw.code,gw.desc)},m.createIframeClosedPrematurelyError=function(){return new m(mw.code,mw.desc)},m.createSilentLogoutUnsupportedError=function(){return new m(yw.code,yw.desc)},m.createNoAccountError=function(){return new m(vw.code,vw.desc)},m.createSilentPromptValueError=function(e){return new m(_w.code,_w.desc+" Given value: "+e)},m.createUnableToParseTokenRequestCacheError=function(){return new m(bw.code,bw.desc)},m.createNoTokenRequestCacheError=function(){return new m(ww.code,ww.desc)},m.createAuthRequestNotSetError=function(){return new m(Sw.code,Sw.desc)},m.createNoCachedAuthorityError=function(){return new m(Cw.code,Cw.desc)},m.createInvalidCacheTypeError=function(){return new m(Ew.code,""+Ew.desc)},m.createNonBrowserEnvironmentError=function(){return new m(Tw.code,Tw.desc)},m.createDatabaseNotOpenError=function(){return new m(Iw.code,Iw.desc)},m.createNoNetworkConnectivityError=function(){return new m(kw.code,kw.desc)},m.createPostRequestFailedError=function(e,t){return new m(Aw.code,Aw.desc+" | Network client threw: "+e+" | Attempted to reach: "+t.split("?")[0])},m.createGetRequestFailedError=function(e,t){return new m(Pw.code,Pw.desc+" | Network client threw: "+e+" | Attempted to reach: "+t.split("?")[0])},m.createFailedToParseNetworkResponseError=function(e){return new m(Ow.code,Ow.desc+" | Attempted to reach: "+e.split("?")[0])},m.createUnableToLoadTokenError=function(e){return new m(Rw.code,Rw.desc+" | "+e)},m.createSigningKeyNotFoundInStorageError=function(e){return new m(xw.code,xw.desc+" | No match found for KeyId: "+e)},m.createAuthCodeRequiredError=function(){return new m(Mw.code,Mw.desc)},m.createAuthCodeOrNativeAccountIdRequiredError=function(){return new m(Nw.code,Nw.desc)},m.createSpaCodeAndNativeAccountIdPresentError=function(){return new m(Lw.code,Lw.desc)},m.createDatabaseUnavailableError=function(){return new m(Dw.code,Dw.desc)},m.createUnableToAcquireTokenFromNativePlatformError=function(){return new m(qw.code,qw.desc)},m.createNativeHandshakeTimeoutError=function(){return new m(Uw.code,Uw.desc)},m.createNativeExtensionNotInstalledError=function(){return new m(jw.code,jw.desc)},m.createNativeConnectionNotEstablishedError=function(){return new m(Hw.code,Hw.desc)},m.createNativeBrokerCalledBeforeInitialize=function(){return new m(Bw.code,Bw.desc)},m.createNativePromptParameterNotSupportedError=function(){return new m(Fw.code,Fw.desc)},m);function m(e,t){e=J_.call(this,e,t)||this;return Object.setPrototypeOf(e,m.prototype),e.name="BrowserAuthError",e}var zw,Kw,Gw,Yw,Ww,Zw,Qw,O,Vw,a,Jw={INTERACTION_IN_PROGRESS_VALUE:"interaction_in_progress",INVALID_GRANT_ERROR:"invalid_grant",POPUP_WIDTH:483,POPUP_HEIGHT:600,POPUP_NAME_PREFIX:"msal",DEFAULT_POLL_INTERVAL_MS:30,MSAL_SKU:"msal.js.browser"},Xw="53ee284d-920a-4b59-9d30-a60315b26836",$w="ppnbnpeolgkicgegkbkbjmhlideopiji",e0="MATS",t0=((e=zw=zw||{}).HandshakeRequest="Handshake",e.HandshakeResponse="HandshakeResponse",e.GetToken="GetToken",e.Response="Response",(Fr=Kw=Kw||{}).LocalStorage="localStorage",Fr.SessionStorage="sessionStorage",Fr.MemoryStorage="memoryStorage",(r=Gw=Gw||{}).GET="GET",r.POST="POST",(be=Yw=Yw||{}).AUTHORITY="authority",be.ACQUIRE_TOKEN_ACCOUNT="acquireToken.account",be.SESSION_STATE="session.state",be.REQUEST_STATE="request.state",be.NONCE_IDTOKEN="nonce.id_token",be.ORIGIN_URI="request.origin",be.RENEW_STATUS="token.renew.status",be.URL_HASH="urlHash",be.REQUEST_PARAMS="request.params",be.SCOPES="scopes",be.INTERACTION_STATUS_KEY="interaction.status",be.CCS_CREDENTIAL="ccs.credential",be.CORRELATION_ID="request.correlationId",be.NATIVE_REQUEST="request.native",be.REDIRECT_CONTEXT="request.redirect.context",(xi=Ww=Ww||{}).ACCOUNT_KEYS="msal.account.keys",xi.TOKEN_KEYS="msal.token.keys",(Kt=Zw=Zw||{}).WRAPPER_SKU="wrapper.sku",Kt.WRAPPER_VER="wrapper.version",(o=Qw=Qw||{})[o.acquireTokenRedirect=861]="acquireTokenRedirect",o[o.acquireTokenPopup=862]="acquireTokenPopup",o[o.ssoSilent=863]="ssoSilent",o[o.acquireTokenSilent_authCode=864]="acquireTokenSilent_authCode",o[o.handleRedirectPromise=865]="handleRedirectPromise",o[o.acquireTokenByCode=866]="acquireTokenByCode",o[o.acquireTokenSilent_silentFlow=61]="acquireTokenSilent_silentFlow",o[o.logout=961]="logout",o[o.logoutPopup=962]="logoutPopup",(jo=O=O||{}).Redirect="redirect",jo.Popup="popup",jo.Silent="silent",jo.None="none",0,{scopes:tm}),o0="jwk",r0=(0,"msal.db");(a=Vw=Vw||{})[a.Default=0]="Default",a[a.AccessToken=1]="AccessToken",a[a.AccessTokenAndRefreshToken=2]="AccessTokenAndRefreshToken",a[a.RefreshToken=3]="RefreshToken",a[a.RefreshTokenAndNetwork=4]="RefreshTokenAndNetwork",a[a.Skip=5]="Skip";var n0,i0={code:"redirect_uri_empty",desc:"A redirect URI is required for all calls, and none has been set."},a0={code:"post_logout_uri_empty",desc:"A post logout redirect has not been set."},s0={code:"storage_not_supported",desc:"Given storage configuration option was not supported."},c0={code:"no_redirect_callbacks",desc:"No redirect callbacks have been set. Please call setRedirectCallbacks() with the appropriate function arguments before continuing. More information is available here: https://github.com/AzureAD/microsoft-authentication-library-for-js/wiki/MSAL-basics."},u0={code:"stubbed_public_client_application_called",desc:"Stub instance of Public Client Application was called. If using msal-react, please ensure context is not used without a provider. For more visit: aka.ms/msaljs/browser-errors"},l0={code:"in_mem_redirect_unavailable",desc:"Redirect cannot be supported. In-memory storage was selected and storeAuthStateInCookie=false, which would cause the library to be unable to handle the incoming hash. If you would like to use the redirect API, please use session/localStorage or set storeAuthStateInCookie=true."},h0={code:"entropy_not_provided",desc:"The available browser crypto interface requires entropy set via system.cryptoOptions.entropy configuration option."},d0=(Dg(p0,n0=T),p0.createRedirectUriEmptyError=function(){return new p0(i0.code,i0.desc)},p0.createPostLogoutRedirectUriEmptyError=function(){return new p0(a0.code,a0.desc)},p0.createStorageNotSupportedError=function(e){return new p0(s0.code,s0.desc+" Given Location: "+e)},p0.createRedirectCallbacksNotSetError=function(){return new p0(c0.code,c0.desc)},p0.createStubPcaInstanceCalledError=function(){return new p0(u0.code,u0.desc)},p0.createInMemoryRedirectUnavailableError=function(){return new p0(l0.code,l0.desc)},p0.createEntropyNotProvided=function(){return new p0(h0.code,h0.desc)},p0);function p0(e,t){e=n0.call(this,e,t)||this;return e.name="BrowserConfigurationAuthError",Object.setPrototypeOf(e,p0.prototype),e}g0.prototype.validateWindowStorage=function(e){if(e!==Kw.LocalStorage&&e!==Kw.SessionStorage)throw d0.createStorageNotSupportedError(e);if(!!!window[e])throw d0.createStorageNotSupportedError(e)},g0.prototype.getItem=function(e){return this.windowStorage.getItem(e)},g0.prototype.setItem=function(e,t){this.windowStorage.setItem(e,t)},g0.prototype.removeItem=function(e){this.windowStorage.removeItem(e)},g0.prototype.getKeys=function(){return Object.keys(this.windowStorage)},g0.prototype.containsKey=function(e){return this.windowStorage.hasOwnProperty(e)};var f0=g0;function g0(e){this.validateWindowStorage(e),this.windowStorage=window[e]}y0.prototype.getItem=function(e){return this.cache.get(e)||null},y0.prototype.setItem=function(e,t){this.cache.set(e,t)},y0.prototype.removeItem=function(e){this.cache.delete(e)},y0.prototype.getKeys=function(){var o=[];return this.cache.forEach(function(e,t){o.push(t)}),o},y0.prototype.containsKey=function(e){return this.cache.has(e)},y0.prototype.clear=function(){this.cache.clear()};var m0=y0;function y0(){this.cache=new Map}_0.extractBrowserRequestState=function(e,t){if(k.isEmpty(t))return null;try{return Jv.parseRequestState(e,t).libraryState.meta}catch(e){throw I.createInvalidStateError(t,e)}},_0.parseServerResponseFromHash=function(e){return e?(e=new e_(e),e_.getDeserializedHash(e.getHash())):{}};var v0=_0;function _0(){}Dg(R,w0=av),R.prototype.setupBrowserStorage=function(e){switch(e){case Kw.LocalStorage:case Kw.SessionStorage:try{return new f0(e)}catch(e){this.logger.verbose(e);break}}return this.cacheConfig.cacheLocation=Kw.MemoryStorage,new m0},R.prototype.setupTemporaryCacheStorage=function(e,t){switch(t){case Kw.LocalStorage:case Kw.SessionStorage:try{return new f0(e||Kw.SessionStorage)}catch(e){return this.logger.verbose(e),this.internalStorage}case Kw.MemoryStorage:default:return this.internalStorage}},R.prototype.migrateCacheEntries=function(){var o=this,e=E.CACHE_PREFIX+"."+Kg.ID_TOKEN,t=E.CACHE_PREFIX+"."+Kg.CLIENT_INFO,r=E.CACHE_PREFIX+"."+Kg.ERROR,n=E.CACHE_PREFIX+"."+Kg.ERROR_DESC,i=[this.browserStorage.getItem(e),this.browserStorage.getItem(t),this.browserStorage.getItem(r),this.browserStorage.getItem(n)];[Kg.ID_TOKEN,Kg.CLIENT_INFO,Kg.ERROR,Kg.ERROR_DESC].forEach(function(e,t){return o.migrateCacheEntry(e,i[t])})},R.prototype.migrateCacheEntry=function(e,t){t&&this.setTemporaryCache(e,t,!0)},R.prototype.createKeyMaps=function(){var i=this,e=(this.logger.trace("BrowserCacheManager - createKeyMaps called."),this.getItem(Ww.ACCOUNT_KEYS)),t=this.getItem(Ww.TOKEN_KEYS+"."+this.clientId);e&&t?this.logger.verbose("BrowserCacheManager:createKeyMaps - account and token key maps already exist, skipping migration."):this.browserStorage.getKeys().forEach(function(e){var t;if(i.isCredentialKey(e)&&(t=i.getItem(e))){var o,r,n=i.validateAndParseJson(t);if(n&&n.hasOwnProperty("credentialType"))switch(n.credentialType){case S.ID_TOKEN:if(Mv.isIdTokenEntity(n))return i.logger.trace("BrowserCacheManager:createKeyMaps - idToken found, saving key to token key map"),i.logger.tracePii("BrowserCacheManager:createKeyMaps - idToken with key: "+e+" found, saving key to token key map"),r=av.toObject(new Mv,n),r=i.updateCredentialCacheKey(e,r),void i.addTokenKey(r,S.ID_TOKEN);i.logger.trace("BrowserCacheManager:createKeyMaps - key found matching idToken schema with value containing idToken credentialType field but value failed IdTokenEntity validation, skipping."),i.logger.tracePii("BrowserCacheManager:createKeyMaps - failed idToken validation on key: "+e);break;case S.ACCESS_TOKEN:case S.ACCESS_TOKEN_WITH_AUTH_SCHEME:if(Uv.isAccessTokenEntity(n))return i.logger.trace("BrowserCacheManager:createKeyMaps - accessToken found, saving key to token key map"),i.logger.tracePii("BrowserCacheManager:createKeyMaps - accessToken with key: "+e+" found, saving key to token key map"),o=av.toObject(new Uv,n),r=i.updateCredentialCacheKey(e,o),void i.addTokenKey(r,S.ACCESS_TOKEN);i.logger.trace("BrowserCacheManager:createKeyMaps - key found matching accessToken schema with value containing accessToken credentialType field but value failed AccessTokenEntity validation, skipping."),i.logger.tracePii("BrowserCacheManager:createKeyMaps - failed accessToken validation on key: "+e);break;case S.REFRESH_TOKEN:if(Bv.isRefreshTokenEntity(n))return i.logger.trace("BrowserCacheManager:createKeyMaps - refreshToken found, saving key to token key map"),i.logger.tracePii("BrowserCacheManager:createKeyMaps - refreshToken with key: "+e+" found, saving key to token key map"),o=av.toObject(new Bv,n),r=i.updateCredentialCacheKey(e,o),void i.addTokenKey(r,S.REFRESH_TOKEN);i.logger.trace("BrowserCacheManager:createKeyMaps - key found matching refreshToken schema with value containing refreshToken credentialType field but value failed RefreshTokenEntity validation, skipping."),i.logger.tracePii("BrowserCacheManager:createKeyMaps - failed refreshToken validation on key: "+e)}}i.isAccountKey(e)&&(t=i.getItem(e))&&(t=i.validateAndParseJson(t))&&ov.isAccountEntity(t)&&(i.logger.trace("BrowserCacheManager:createKeyMaps - account found, saving key to account key map"),i.logger.tracePii("BrowserCacheManager:createKeyMaps - account with key: "+e+" found, saving key to account key map"),i.addAccountKeyToMap(e))})},R.prototype.validateAndParseJson=function(e){try{var t=JSON.parse(e);return t&&"object"==typeof t?t:null}catch(e){return null}},R.prototype.getItem=function(e){return this.browserStorage.getItem(e)},R.prototype.setItem=function(e,t){this.browserStorage.setItem(e,t)},R.prototype.getAccount=function(e){this.logger.trace("BrowserCacheManager.getAccount called");var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&ov.isAccountEntity(t)?av.toObject(new ov,t):(this.removeAccountKeyFromMap(e),null)},R.prototype.setAccount=function(e){this.logger.trace("BrowserCacheManager.setAccount called");var t=e.generateAccountKey();this.setItem(t,JSON.stringify(e)),this.addAccountKeyToMap(t)},R.prototype.getAccountKeys=function(){this.logger.trace("BrowserCacheManager.getAccountKeys called");var e=this.getItem(Ww.ACCOUNT_KEYS);return e?JSON.parse(e):(this.logger.verbose("BrowserCacheManager.getAccountKeys - No account keys found"),[])},R.prototype.addAccountKeyToMap=function(e){this.logger.trace("BrowserCacheManager.addAccountKeyToMap called"),this.logger.tracePii("BrowserCacheManager.addAccountKeyToMap called with key: "+e);var t=this.getAccountKeys();-1===t.indexOf(e)?(t.push(e),this.setItem(Ww.ACCOUNT_KEYS,JSON.stringify(t)),this.logger.verbose("BrowserCacheManager.addAccountKeyToMap account key added")):this.logger.verbose("BrowserCacheManager.addAccountKeyToMap account key already exists in map")},R.prototype.removeAccountKeyFromMap=function(e){this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap called"),this.logger.tracePii("BrowserCacheManager.removeAccountKeyFromMap called with key: "+e);var t=this.getAccountKeys(),e=t.indexOf(e);-1<e?(t.splice(e,1),this.setItem(Ww.ACCOUNT_KEYS,JSON.stringify(t)),this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap account key removed")):this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap key not found in existing map")},R.prototype.removeAccount=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){return w0.prototype.removeAccount.call(this,t),this.removeAccountKeyFromMap(t),[2]})})},R.prototype.removeIdToken=function(e){w0.prototype.removeIdToken.call(this,e),this.removeTokenKey(e,S.ID_TOKEN)},R.prototype.removeAccessToken=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){return w0.prototype.removeAccessToken.call(this,t),this.removeTokenKey(t,S.ACCESS_TOKEN),[2]})})},R.prototype.removeRefreshToken=function(e){w0.prototype.removeRefreshToken.call(this,e),this.removeTokenKey(e,S.REFRESH_TOKEN)},R.prototype.getTokenKeys=function(){this.logger.trace("BrowserCacheManager.getTokenKeys called");var e=this.getItem(Ww.TOKEN_KEYS+"."+this.clientId);if(e){e=this.validateAndParseJson(e);if(e&&e.hasOwnProperty("idToken")&&e.hasOwnProperty("accessToken")&&e.hasOwnProperty("refreshToken"))return e;this.logger.error("BrowserCacheManager.getTokenKeys - Token keys found but in an unknown format. Returning empty key map.")}else this.logger.verbose("BrowserCacheManager.getTokenKeys - No token keys found");return{idToken:[],accessToken:[],refreshToken:[]}},R.prototype.addTokenKey=function(e,t){this.logger.trace("BrowserCacheManager addTokenKey called");var o=this.getTokenKeys();switch(t){case S.ID_TOKEN:-1===o.idToken.indexOf(e)&&(this.logger.info("BrowserCacheManager: addTokenKey - idToken added to map"),o.idToken.push(e));break;case S.ACCESS_TOKEN:-1===o.accessToken.indexOf(e)&&(this.logger.info("BrowserCacheManager: addTokenKey - accessToken added to map"),o.accessToken.push(e));break;case S.REFRESH_TOKEN:-1===o.refreshToken.indexOf(e)&&(this.logger.info("BrowserCacheManager: addTokenKey - refreshToken added to map"),o.refreshToken.push(e));break;default:this.logger.error("BrowserCacheManager:addTokenKey - CredentialType provided invalid. CredentialType: "+t),I.createUnexpectedCredentialTypeError()}this.setItem(Ww.TOKEN_KEYS+"."+this.clientId,JSON.stringify(o))},R.prototype.removeTokenKey=function(e,t){this.logger.trace("BrowserCacheManager removeTokenKey called");var o=this.getTokenKeys();switch(t){case S.ID_TOKEN:this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove idToken with key: "+e+" from map");var r=o.idToken.indexOf(e);-1<r?(this.logger.info("BrowserCacheManager: removeTokenKey - idToken removed from map"),o.idToken.splice(r,1)):this.logger.info("BrowserCacheManager: removeTokenKey - idToken does not exist in map. Either it was previously removed or it was never added.");break;case S.ACCESS_TOKEN:this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove accessToken with key: "+e+" from map");r=o.accessToken.indexOf(e);-1<r?(this.logger.info("BrowserCacheManager: removeTokenKey - accessToken removed from map"),o.accessToken.splice(r,1)):this.logger.info("BrowserCacheManager: removeTokenKey - accessToken does not exist in map. Either it was previously removed or it was never added.");break;case S.REFRESH_TOKEN:this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove refreshToken with key: "+e+" from map");r=o.refreshToken.indexOf(e);-1<r?(this.logger.info("BrowserCacheManager: removeTokenKey - refreshToken removed from map"),o.refreshToken.splice(r,1)):this.logger.info("BrowserCacheManager: removeTokenKey - refreshToken does not exist in map. Either it was previously removed or it was never added.");break;default:this.logger.error("BrowserCacheManager:removeTokenKey - CredentialType provided invalid. CredentialType: "+t),I.createUnexpectedCredentialTypeError()}this.setItem(Ww.TOKEN_KEYS+"."+this.clientId,JSON.stringify(o))},R.prototype.getIdTokenCredential=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&Mv.isIdTokenEntity(t)?(this.logger.trace("BrowserCacheManager.getIdTokenCredential: cache hit"),av.toObject(new Mv,t)):(this.logger.trace("BrowserCacheManager.getIdTokenCredential: called, no cache hit"),this.removeTokenKey(e,S.ID_TOKEN),null)},R.prototype.setIdTokenCredential=function(e){this.logger.trace("BrowserCacheManager.setIdTokenCredential called");var t=e.generateCredentialKey();this.setItem(t,JSON.stringify(e)),this.addTokenKey(t,S.ID_TOKEN)},R.prototype.getAccessTokenCredential=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&Uv.isAccessTokenEntity(t)?(this.logger.trace("BrowserCacheManager.getAccessTokenCredential: cache hit"),av.toObject(new Uv,t)):(this.logger.trace("BrowserCacheManager.getAccessTokenCredential: called, no cache hit"),this.removeTokenKey(e,S.ACCESS_TOKEN),null)},R.prototype.setAccessTokenCredential=function(e){this.logger.trace("BrowserCacheManager.setAccessTokenCredential called");var t=e.generateCredentialKey();this.setItem(t,JSON.stringify(e)),this.addTokenKey(t,S.ACCESS_TOKEN)},R.prototype.getRefreshTokenCredential=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&Bv.isRefreshTokenEntity(t)?(this.logger.trace("BrowserCacheManager.getRefreshTokenCredential: cache hit"),av.toObject(new Bv,t)):(this.logger.trace("BrowserCacheManager.getRefreshTokenCredential: called, no cache hit"),this.removeTokenKey(e,S.REFRESH_TOKEN),null)},R.prototype.setRefreshTokenCredential=function(e){this.logger.trace("BrowserCacheManager.setRefreshTokenCredential called");var t=e.generateCredentialKey();this.setItem(t,JSON.stringify(e)),this.addTokenKey(t,S.REFRESH_TOKEN)},R.prototype.getAppMetadata=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&a_.isAppMetadataEntity(e,t)?(this.logger.trace("BrowserCacheManager.getAppMetadata: cache hit"),av.toObject(new a_,t)):(this.logger.trace("BrowserCacheManager.getAppMetadata: called, no cache hit"),null)},R.prototype.setAppMetadata=function(e){this.logger.trace("BrowserCacheManager.setAppMetadata called");var t=e.generateAppMetadataKey();this.setItem(t,JSON.stringify(e))},R.prototype.getServerTelemetry=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&R_.isServerTelemetryEntity(e,t)?(this.logger.trace("BrowserCacheManager.getServerTelemetry: cache hit"),av.toObject(new R_,t)):(this.logger.trace("BrowserCacheManager.getServerTelemetry: called, no cache hit"),null)},R.prototype.setServerTelemetry=function(e,t){this.logger.trace("BrowserCacheManager.setServerTelemetry called"),this.setItem(e,JSON.stringify(t))},R.prototype.getAuthorityMetadata=function(e){var t=this.internalStorage.getItem(e);return t?(t=this.validateAndParseJson(t))&&E_.isAuthorityMetadataEntity(e,t)?(this.logger.trace("BrowserCacheManager.getAuthorityMetadata: cache hit"),av.toObject(new E_,t)):null:(this.logger.trace("BrowserCacheManager.getAuthorityMetadata: called, no cache hit"),null)},R.prototype.getAuthorityMetadataKeys=function(){var t=this;return this.internalStorage.getKeys().filter(function(e){return t.isAuthorityMetadata(e)})},R.prototype.setWrapperMetadata=function(e,t){this.internalStorage.setItem(Zw.WRAPPER_SKU,e),this.internalStorage.setItem(Zw.WRAPPER_VER,t)},R.prototype.getWrapperMetadata=function(){return[this.internalStorage.getItem(Zw.WRAPPER_SKU)||E.EMPTY_STRING,this.internalStorage.getItem(Zw.WRAPPER_VER)||E.EMPTY_STRING]},R.prototype.setAuthorityMetadata=function(e,t){this.logger.trace("BrowserCacheManager.setAuthorityMetadata called"),this.internalStorage.setItem(e,JSON.stringify(t))},R.prototype.getActiveAccount=function(){var e=this.generateCacheKey(Kg.ACTIVE_ACCOUNT_FILTERS),e=this.getItem(e);return e?(e=this.validateAndParseJson(e))?(this.logger.trace("BrowserCacheManager.getActiveAccount: Active account filters schema found"),this.getAccountInfoByFilter({homeAccountId:e.homeAccountId,localAccountId:e.localAccountId})[0]||null):(this.logger.trace("BrowserCacheManager.getActiveAccount: No active account found"),null):(this.logger.trace("BrowserCacheManager.getActiveAccount: No active account filters cache schema found, looking for legacy schema"),e=this.generateCacheKey(Kg.ACTIVE_ACCOUNT),(e=this.getItem(e))?(e=this.getAccountInfoByFilter({localAccountId:e})[0]||null)?(this.logger.trace("BrowserCacheManager.getActiveAccount: Legacy active account cache schema found"),this.logger.trace("BrowserCacheManager.getActiveAccount: Adding active account filters cache schema"),this.setActiveAccount(e),e):null:(this.logger.trace("BrowserCacheManager.getActiveAccount: No active account found"),null))},R.prototype.setActiveAccount=function(e){var t,o=this.generateCacheKey(Kg.ACTIVE_ACCOUNT_FILTERS),r=this.generateCacheKey(Kg.ACTIVE_ACCOUNT);e?(this.logger.verbose("setActiveAccount: Active account set"),t={homeAccountId:e.homeAccountId,localAccountId:e.localAccountId},this.browserStorage.setItem(o,JSON.stringify(t)),this.browserStorage.setItem(r,e.localAccountId)):(this.logger.verbose("setActiveAccount: No account passed, active account not set"),this.browserStorage.removeItem(o),this.browserStorage.removeItem(r))},R.prototype.getAccountInfoByFilter=function(t){var e=this.getAllAccounts();return this.logger.trace("BrowserCacheManager.getAccountInfoByFilter: total "+e.length+" accounts found"),e.filter(function(e){return!(t.username&&t.username.toLowerCase()!==e.username.toLowerCase()||t.homeAccountId&&t.homeAccountId!==e.homeAccountId||t.localAccountId&&t.localAccountId!==e.localAccountId||t.tenantId&&t.tenantId!==e.tenantId||t.environment&&t.environment!==e.environment)})},R.prototype.getAccountInfoByHints=function(o,r){var e=this.getAllAccounts().filter(function(e){var t;return r?(t=e.idTokenClaims&&e.idTokenClaims.sid,r===t):!!o&&o===e.username});if(1===e.length)return e[0];if(1<e.length)throw I.createMultipleMatchingAccountsInCacheError();return null},R.prototype.getThrottlingCache=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&M_.isThrottlingEntity(e,t)?(this.logger.trace("BrowserCacheManager.getThrottlingCache: cache hit"),av.toObject(new M_,t)):(this.logger.trace("BrowserCacheManager.getThrottlingCache: called, no cache hit"),null)},R.prototype.setThrottlingCache=function(e,t){this.logger.trace("BrowserCacheManager.setThrottlingCache called"),this.setItem(e,JSON.stringify(t))},R.prototype.getTemporaryCache=function(e,t){t=t?this.generateCacheKey(e):e;if(this.cacheConfig.storeAuthStateInCookie){e=this.getItemCookie(t);if(e)return this.logger.trace("BrowserCacheManager.getTemporaryCache: storeAuthStateInCookies set to true, retrieving from cookies"),e}e=this.temporaryCacheStorage.getItem(t);if(e)return this.logger.trace("BrowserCacheManager.getTemporaryCache: Temporary cache item returned"),e;if(this.cacheConfig.cacheLocation===Kw.LocalStorage){e=this.browserStorage.getItem(t);if(e)return this.logger.trace("BrowserCacheManager.getTemporaryCache: Temporary cache item found in local storage"),e}return this.logger.trace("BrowserCacheManager.getTemporaryCache: No cache item found in local storage"),null},R.prototype.setTemporaryCache=function(e,t,o){o=o?this.generateCacheKey(e):e;this.temporaryCacheStorage.setItem(o,t),this.cacheConfig.storeAuthStateInCookie&&(this.logger.trace("BrowserCacheManager.setTemporaryCache: storeAuthStateInCookie set to true, setting item cookie"),this.setItemCookie(o,t))},R.prototype.removeItem=function(e){this.browserStorage.removeItem(e),this.temporaryCacheStorage.removeItem(e),this.cacheConfig.storeAuthStateInCookie&&(this.logger.trace("BrowserCacheManager.removeItem: storeAuthStateInCookie is true, clearing item cookie"),this.clearItemCookie(e))},R.prototype.containsKey=function(e){return this.browserStorage.containsKey(e)||this.temporaryCacheStorage.containsKey(e)},R.prototype.getKeys=function(){return Ug(this.browserStorage.getKeys(),this.temporaryCacheStorage.getKeys())},R.prototype.clear=function(){return _(this,void 0,void 0,function(){var t=this;return w(this,function(e){switch(e.label){case 0:return[4,this.removeAllAccounts()];case 1:return e.sent(),this.removeAppMetadata(),this.getKeys().forEach(function(e){!t.browserStorage.containsKey(e)&&!t.temporaryCacheStorage.containsKey(e)||-1===e.indexOf(E.CACHE_PREFIX)&&-1===e.indexOf(t.clientId)||t.removeItem(e)}),this.internalStorage.clear(),[2]}})})},R.prototype.clearTokensAndKeysWithClaims=function(){return _(this,void 0,void 0,function(){var t,o,r=this;return w(this,function(e){switch(e.label){case 0:return this.logger.trace("BrowserCacheManager.clearTokensAndKeysWithClaims called"),t=this.getTokenKeys(),o=[],t.accessToken.forEach(function(e){var t=r.getAccessTokenCredential(e);null!=t&&t.requestedClaimsHash&&e.includes(t.requestedClaimsHash.toLowerCase())&&o.push(r.removeAccessToken(e))}),[4,Promise.all(o)];case 1:return e.sent(),0<o.length&&this.logger.warning(o.length+" access tokens with claims in the cache keys have been removed from the cache."),[2]}})})},R.prototype.setItemCookie=function(e,t,o){e=encodeURIComponent(e)+"="+encodeURIComponent(t)+";path=/;SameSite=Lax;";o&&(e+="expires="+this.getCookieExpirationTime(o)+";"),this.cacheConfig.secureCookies&&(e+="Secure;"),document.cookie=e},R.prototype.getItemCookie=function(e){for(var t=encodeURIComponent(e)+"=",o=document.cookie.split(";"),r=0;r<o.length;r++){for(var n=o[r];" "===n.charAt(0);)n=n.substring(1);if(0===n.indexOf(t))return decodeURIComponent(n.substring(t.length,n.length))}return E.EMPTY_STRING},R.prototype.clearMsalCookies=function(){var o=this,r=E.CACHE_PREFIX+"."+this.clientId;document.cookie.split(";").forEach(function(e){for(;" "===e.charAt(0);)e=e.substring(1);var t;0===e.indexOf(r)&&(t=e.split("=")[0],o.clearItemCookie(t))})},R.prototype.clearItemCookie=function(e){this.setItemCookie(e,E.EMPTY_STRING,-1)},R.prototype.getCookieExpirationTime=function(e){var t=new Date;return new Date(t.getTime()+e*this.COOKIE_LIFE_MULTIPLIER).toUTCString()},R.prototype.getCache=function(){return this.browserStorage},R.prototype.setCache=function(){},R.prototype.generateCacheKey=function(e){return this.validateAndParseJson(e)?JSON.stringify(e):k.startsWith(e,E.CACHE_PREFIX)||k.startsWith(e,Kg.ADAL_ID_TOKEN)?e:E.CACHE_PREFIX+"."+this.clientId+"."+e},R.prototype.generateAuthorityKey=function(e){e=Jv.parseRequestState(this.cryptoImpl,e).libraryState.id;return this.generateCacheKey(Yw.AUTHORITY+"."+e)},R.prototype.generateNonceKey=function(e){e=Jv.parseRequestState(this.cryptoImpl,e).libraryState.id;return this.generateCacheKey(Yw.NONCE_IDTOKEN+"."+e)},R.prototype.generateStateKey=function(e){e=Jv.parseRequestState(this.cryptoImpl,e).libraryState.id;return this.generateCacheKey(Yw.REQUEST_STATE+"."+e)},R.prototype.getCachedAuthority=function(e){var e=this.generateStateKey(e),e=this.getTemporaryCache(e);return e?(e=this.generateAuthorityKey(e),this.getTemporaryCache(e)):null},R.prototype.updateCacheEntries=function(e,t,o,r,n){this.logger.trace("BrowserCacheManager.updateCacheEntries called");var i,a=this.generateStateKey(e),a=(this.setTemporaryCache(a,e,!1),this.generateNonceKey(e)),a=(this.setTemporaryCache(a,t,!1),this.generateAuthorityKey(e));this.setTemporaryCache(a,o,!1),n?(i={credential:n.homeAccountId,type:Ev.HOME_ACCOUNT_ID},this.setTemporaryCache(Yw.CCS_CREDENTIAL,JSON.stringify(i),!0)):k.isEmpty(r)||(i={credential:r,type:Ev.UPN},this.setTemporaryCache(Yw.CCS_CREDENTIAL,JSON.stringify(i),!0))},R.prototype.resetRequestCache=function(t){var o=this;this.logger.trace("BrowserCacheManager.resetRequestCache called"),k.isEmpty(t)||this.getKeys().forEach(function(e){-1!==e.indexOf(t)&&o.removeItem(e)}),t&&(this.removeItem(this.generateStateKey(t)),this.removeItem(this.generateNonceKey(t)),this.removeItem(this.generateAuthorityKey(t))),this.removeItem(this.generateCacheKey(Yw.REQUEST_PARAMS)),this.removeItem(this.generateCacheKey(Yw.ORIGIN_URI)),this.removeItem(this.generateCacheKey(Yw.URL_HASH)),this.removeItem(this.generateCacheKey(Yw.CORRELATION_ID)),this.removeItem(this.generateCacheKey(Yw.CCS_CREDENTIAL)),this.removeItem(this.generateCacheKey(Yw.NATIVE_REQUEST)),this.setInteractionInProgress(!1)},R.prototype.cleanRequestByState=function(e){this.logger.trace("BrowserCacheManager.cleanRequestByState called"),e&&(e=this.generateStateKey(e),e=this.temporaryCacheStorage.getItem(e),this.logger.infoPii("BrowserCacheManager.cleanRequestByState: Removing temporary cache items for state: "+e),this.resetRequestCache(e||E.EMPTY_STRING)),this.clearMsalCookies()},R.prototype.cleanRequestByInteractionType=function(o){var r=this;this.logger.trace("BrowserCacheManager.cleanRequestByInteractionType called"),this.getKeys().forEach(function(e){var t;-1!==e.indexOf(Yw.REQUEST_STATE)&&(e=r.temporaryCacheStorage.getItem(e))&&(t=v0.extractBrowserRequestState(r.cryptoImpl,e))&&t.interactionType===o&&(r.logger.infoPii("BrowserCacheManager.cleanRequestByInteractionType: Removing temporary cache items for state: "+e),r.resetRequestCache(e))}),this.clearMsalCookies(),this.setInteractionInProgress(!1)},R.prototype.cacheCodeRequest=function(e,t){this.logger.trace("BrowserCacheManager.cacheCodeRequest called");t=t.base64Encode(JSON.stringify(e));this.setTemporaryCache(Yw.REQUEST_PARAMS,t,!0)},R.prototype.getCachedRequest=function(e,t){this.logger.trace("BrowserCacheManager.getCachedRequest called");var o=this.getTemporaryCache(Yw.REQUEST_PARAMS,!0);if(!o)throw P.createNoTokenRequestCacheError();t=this.validateAndParseJson(t.base64Decode(o));if(!t)throw P.createUnableToParseTokenRequestCacheError();if(this.removeItem(this.generateCacheKey(Yw.REQUEST_PARAMS)),k.isEmpty(t.authority)){o=this.generateAuthorityKey(e),e=this.getTemporaryCache(o);if(!e)throw P.createNoCachedAuthorityError();t.authority=e}return t},R.prototype.getCachedNativeRequest=function(){this.logger.trace("BrowserCacheManager.getCachedNativeRequest called");var e=this.getTemporaryCache(Yw.NATIVE_REQUEST,!0);return e?this.validateAndParseJson(e)||(this.logger.error("BrowserCacheManager.getCachedNativeRequest: Unable to parse native request"),null):(this.logger.trace("BrowserCacheManager.getCachedNativeRequest: No cached native request found"),null)},R.prototype.isInteractionInProgress=function(e){var t=this.getInteractionInProgress();return e?t===this.clientId:!!t},R.prototype.getInteractionInProgress=function(){var e=E.CACHE_PREFIX+"."+Yw.INTERACTION_STATUS_KEY;return this.getTemporaryCache(e,!1)},R.prototype.setInteractionInProgress=function(e){var t=E.CACHE_PREFIX+"."+Yw.INTERACTION_STATUS_KEY;if(e){if(this.getInteractionInProgress())throw P.createInteractionInProgressError();this.setTemporaryCache(t,this.clientId,!1)}else this.getInteractionInProgress()===this.clientId&&this.removeItem(t)},R.prototype.getLegacyLoginHint=function(){var e=this.getTemporaryCache(Kg.ADAL_ID_TOKEN),t=(e&&(this.browserStorage.removeItem(Kg.ADAL_ID_TOKEN),this.logger.verbose("Cached ADAL id token retrieved.")),this.getTemporaryCache(Kg.ID_TOKEN,!0)),t=(t&&(this.removeItem(this.generateCacheKey(Kg.ID_TOKEN)),this.logger.verbose("Cached MSAL.js v1 id token retrieved")),t||e);if(t){e=new nv(t,this.cryptoImpl);if(e.claims&&e.claims.preferred_username)return this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, setting ADAL/MSAL v1 preferred_username as loginHint"),e.claims.preferred_username;if(e.claims&&e.claims.upn)return this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, setting ADAL/MSAL v1 upn as loginHint"),e.claims.upn;this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, however, no account hint claim found. Enable preferred_username or upn id token claim to get SSO.")}return null},R.prototype.updateCredentialCacheKey=function(e,t){var o=t.generateCredentialKey();if(e!==o){var r=this.getItem(e);if(r)return this.removeItem(e),this.setItem(o,r),this.logger.verbose("Updated an outdated "+t.credentialType+" cache key"),o;this.logger.error("Attempted to update an outdated "+t.credentialType+" cache key but no item matching the outdated key was found in storage")}return e},R.prototype.getRedirectRequestContext=function(){return this.getTemporaryCache(Yw.REDIRECT_CONTEXT,!0)},R.prototype.setRedirectRequestContext=function(e){this.setTemporaryCache(Yw.REDIRECT_CONTEXT,e,!0)};var w0,b0=R;function R(e,t,o,r){e=w0.call(this,e,o,r)||this;return e.COOKIE_LIFE_MULTIPLIER=864e5,e.cacheConfig=t,e.logger=r,e.internalStorage=new m0,e.browserStorage=e.setupBrowserStorage(e.cacheConfig.cacheLocation),e.temporaryCacheStorage=e.setupTemporaryCacheStorage(e.cacheConfig.temporaryCacheLocation,e.cacheConfig.cacheLocation),t.cacheMigrationEnabled&&(e.migrateCacheEntries(),e.createKeyMaps()),e}var C0="@azure/msal-browser",S0="2.38.3",E0=(T0.prototype.sendGetRequestAsync=function(n,i){return _(this,void 0,void 0,function(){var t,o,r;return w(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),[4,fetch(n,{method:Gw.GET,headers:this.getFetchHeaders(i)})];case 1:return t=e.sent(),[3,3];case 2:throw o=e.sent(),window.navigator.onLine?P.createGetRequestFailedError(o,n):P.createNoNetworkConnectivityError();case 3:return e.trys.push([3,5,,6]),r={headers:this.getHeaderDict(t.headers)},[4,t.json()];case 4:return[2,(r.body=e.sent(),r.status=t.status,r)];case 5:throw e.sent(),P.createFailedToParseNetworkResponseError(n);case 6:return[2]}})})},T0.prototype.sendPostRequestAsync=function(i,a){return _(this,void 0,void 0,function(){var t,o,r,n;return w(this,function(e){switch(e.label){case 0:t=a&&a.body||E.EMPTY_STRING,e.label=1;case 1:return e.trys.push([1,3,,4]),[4,fetch(i,{method:Gw.POST,headers:this.getFetchHeaders(a),body:t})];case 2:return o=e.sent(),[3,4];case 3:throw r=e.sent(),window.navigator.onLine?P.createPostRequestFailedError(r,i):P.createNoNetworkConnectivityError();case 4:return e.trys.push([4,6,,7]),n={headers:this.getHeaderDict(o.headers)},[4,o.json()];case 5:return[2,(n.body=e.sent(),n.status=o.status,n)];case 6:throw e.sent(),P.createFailedToParseNetworkResponseError(i);case 7:return[2]}})})},T0.prototype.getFetchHeaders=function(e){var t,o=new Headers;return e&&e.headers&&(t=e.headers,Object.keys(t).forEach(function(e){o.append(e,t[e])})),o},T0.prototype.getHeaderDict=function(e){var o={};return e.forEach(function(e,t){o[t]=e}),o},T0);function T0(){}k0.prototype.sendGetRequestAsync=function(t,o){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,this.sendRequestAsync(t,Gw.GET,o)]})})},k0.prototype.sendPostRequestAsync=function(t,o){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,this.sendRequestAsync(t,Gw.POST,o)]})})},k0.prototype.sendRequestAsync=function(i,a,e){var s=this;return new Promise(function(o,r){var n=new XMLHttpRequest;if(n.open(a,i,!0),s.setXhrHeaders(n,e),n.onload=function(){(n.status<200||300<=n.status)&&(a===Gw.POST?r(P.createPostRequestFailedError("Failed with status "+n.status,i)):r(P.createGetRequestFailedError("Failed with status "+n.status,i)));try{var e=JSON.parse(n.responseText),t={headers:s.getHeaderDict(n),body:e,status:n.status};o(t)}catch(e){r(P.createFailedToParseNetworkResponseError(i))}},n.onerror=function(){window.navigator.onLine?a===Gw.POST?r(P.createPostRequestFailedError("Failed with status "+n.status,i)):r(P.createGetRequestFailedError("Failed with status "+n.status,i)):r(P.createNoNetworkConnectivityError())},a===Gw.POST&&e&&e.body)n.send(e.body);else{if(a!==Gw.GET)throw P.createHttpMethodNotImplementedError(a);n.send()}})},k0.prototype.setXhrHeaders=function(t,e){var o;e&&e.headers&&(o=e.headers,Object.keys(o).forEach(function(e){t.setRequestHeader(e,o[e])}))},k0.prototype.getHeaderDict=function(e){var e=e.getAllResponseHeaders().trim().split(/[\r\n]+/),o={};return e.forEach(function(e){var e=e.split(": "),t=e.shift(),e=e.join(": ");t&&e&&(o[t]=e)}),o};var I0=k0;function k0(){}P0.clearHash=function(e){e.location.hash=E.EMPTY_STRING,"function"==typeof e.history.replaceState&&e.history.replaceState(null,E.EMPTY_STRING,""+e.location.origin+e.location.pathname+e.location.search)},P0.replaceHash=function(e){e=e.split("#");e.shift(),window.location.hash=0<e.length?e.join("#"):E.EMPTY_STRING},P0.isInIframe=function(){return window.parent!==window},P0.isInPopup=function(){return"undefined"!=typeof window&&!!window.opener&&window.opener!==window&&"string"==typeof window.name&&0===window.name.indexOf(Jw.POPUP_NAME_PREFIX+".")},P0.getCurrentUri=function(){return window.location.href.split("?")[0].split("#")[0]},P0.getHomepage=function(){var e=new e_(window.location.href).getUrlComponents();return e.Protocol+"//"+e.HostNameAndPort+"/"},P0.getBrowserNetworkClient=function(){return new(window.fetch&&window.Headers?E0:I0)},P0.blockReloadInHiddenIframes=function(){if(e_.hashContainsKnownProperties(window.location.hash)&&P0.isInIframe())throw P.createBlockReloadInHiddenIframeError()},P0.blockRedirectInIframe=function(e,t){var o=P0.isInIframe();if(e===O.Redirect&&o&&!t)throw P.createRedirectInIframeError(o)},P0.blockAcquireTokenInPopups=function(){if(P0.isInPopup())throw P.createBlockAcquireTokenInPopupsError()},P0.blockNonBrowserEnvironment=function(e){if(!e)throw P.createNonBrowserEnvironmentError()},P0.blockNativeBrokerCalledBeforeInitialized=function(e,t){if(e&&!t)throw P.createNativeBrokerCalledBeforeInitialize()},P0.detectIEOrEdge=function(){var e=window.navigator.userAgent,t=e.indexOf("MSIE "),o=e.indexOf("Trident/"),e=e.indexOf("Edge/");return 0<t||0<o||0<e};var A0=P0;function P0(){}O0.prototype.clearCacheOnLogout=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){switch(e.label){case 0:if(!t)return[3,5];ov.accountInfoIsEqual(t,this.browserStorage.getActiveAccount(),!1)&&(this.logger.verbose("Setting active account to null"),this.browserStorage.setActiveAccount(null)),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.browserStorage.removeAccount(ov.generateAccountCacheKey(t))];case 2:return e.sent(),this.logger.verbose("Cleared cache items belonging to the account provided in the logout request."),[3,4];case 3:return e.sent(),this.logger.error("Account provided in logout request was not found. Local cache unchanged."),[3,4];case 4:return[3,9];case 5:return e.trys.push([5,8,,9]),this.logger.verbose("No account provided in logout request, clearing all cache items.",this.correlationId),[4,this.browserStorage.clear()];case 6:return e.sent(),[4,this.browserCrypto.clearKeystore()];case 7:return e.sent(),[3,9];case 8:return e.sent(),this.logger.error("Attempted to clear all MSAL cache items and failed. Local cache unchanged."),[3,9];case 9:return[2]}})})},O0.prototype.initializeBaseRequest=function(n,i){return _(this,void 0,void 0,function(){var t,o,r;return w(this,function(e){switch(e.label){case 0:return(this.performanceClient.addQueueMeasurement(A.InitializeBaseRequest,n.correlationId),this.logger.verbose("Initializing BaseAuthRequest"),t=n.authority||this.config.auth.authority,i)?[4,this.validateRequestAuthority(t,i)]:[3,2];case 1:e.sent(),e.label=2;case 2:if(o=Ug(n&&n.scopes||[]),(o=v(v({},n),{correlationId:this.correlationId,authority:t,scopes:o})).authenticationScheme){if(o.authenticationScheme===em.SSH){if(!n.sshJwk)throw Vy.createMissingSshJwkError();if(!n.sshKid)throw Vy.createMissingSshKidError()}this.logger.verbose('Authentication Scheme set to "'+o.authenticationScheme+'" as configured in Auth request')}else o.authenticationScheme=em.BEARER,this.logger.verbose('Authentication Scheme wasn\'t explicitly set in request, defaulting to "Bearer" request');return this.config.cache.claimsBasedCachingEnabled&&n.claims&&!k.isEmptyObj(n.claims)?(r=o,[4,this.browserCrypto.hashString(n.claims)]):[3,4];case 3:r.requestedClaimsHash=e.sent(),e.label=4;case 4:return[2,o]}})})},O0.prototype.getRedirectUri=function(e){this.logger.verbose("getRedirectUri called");e=e||this.config.auth.redirectUri||A0.getCurrentUri();return e_.getAbsoluteUrl(e,A0.getCurrentUri())},O0.prototype.validateRequestAuthority=function(t,o){return _(this,void 0,void 0,function(){return w(this,function(e){switch(e.label){case 0:return[4,this.getDiscoveredAuthority(t)];case 1:if(e.sent().isAlias(o.environment))return[2];throw Vy.createAuthorityMismatchError()}})})},O0.prototype.initializeServerTelemetryManager=function(e,t){this.logger.verbose("initializeServerTelemetryManager called");e={clientId:this.config.auth.clientId,correlationId:this.correlationId,apiId:e,forceRefresh:t||!1,wrapperSKU:this.browserStorage.getWrapperMetadata()[0],wrapperVer:this.browserStorage.getWrapperMetadata()[1]};return new z_(e,this.browserStorage)},O0.prototype.getDiscoveredAuthority=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return(this.logger.verbose("getDiscoveredAuthority called"),t={protocolMode:this.config.auth.protocolMode,knownAuthorities:this.config.auth.knownAuthorities,cloudDiscoveryMetadata:this.config.auth.cloudDiscoveryMetadata,authorityMetadata:this.config.auth.authorityMetadata},o)?(this.logger.verbose("Creating discovered authority with request authority"),[4,P_.createDiscoveredInstance(o,this.config.system.networkClient,this.browserStorage,t,this.logger)]):[3,2];case 1:return[2,e.sent()];case 2:return this.logger.verbose("Creating discovered authority with configured authority"),[4,P_.createDiscoveredInstance(this.config.auth.authority,this.config.system.networkClient,this.browserStorage,t,this.logger)];case 3:return[2,e.sent()]}})})};t=O0;function O0(e,t,o,r,n,i,a,s,c){this.config=e,this.browserStorage=t,this.browserCrypto=o,this.networkClient=this.config.system.networkClient,this.eventHandler=n,this.navigationClient=i,this.nativeMessageHandler=s,this.correlationId=c||this.browserCrypto.createNewGuid(),this.logger=r.clone(Jw.MSAL_SKU,S0,this.correlationId),this.performanceClient=a}Dg(x0,R0=t),x0.prototype.initializeAuthorizationCodeRequest=function(r){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientInitializeAuthorizationCodeRequest,r.correlationId),this.logger.verbose("initializeAuthorizationRequest called",r.correlationId),[4,this.browserCrypto.generatePkceCodes()];case 1:return t=e.sent(),o=v(v({},r),{redirectUri:r.redirectUri,code:E.EMPTY_STRING,codeVerifier:t.verifier}),r.codeChallenge=t.challenge,r.codeChallengeMethod=E.S256_CODE_CHALLENGE_METHOD,[2,o]}})})},x0.prototype.initializeLogoutRequest=function(e){this.logger.verbose("initializeLogoutRequest called",null==e?void 0:e.correlationId);var t,o=v({correlationId:this.correlationId||this.browserCrypto.createNewGuid()},e);return e?e.logoutHint?this.logger.verbose("logoutHint has already been set in logoutRequest"):e.account?(t=this.getLogoutHintFromIdTokenClaims(e.account))&&(this.logger.verbose("Setting logoutHint to login_hint ID Token Claim value for the account provided"),o.logoutHint=t):this.logger.verbose("logoutHint was not set and account was not passed into logout request, logoutHint will not be set"):this.logger.verbose("logoutHint will not be set since no logout request was configured"),e&&null===e.postLogoutRedirectUri?this.logger.verbose("postLogoutRedirectUri passed as null, not setting post logout redirect uri",o.correlationId):e&&e.postLogoutRedirectUri?(this.logger.verbose("Setting postLogoutRedirectUri to uri set on logout request",o.correlationId),o.postLogoutRedirectUri=e_.getAbsoluteUrl(e.postLogoutRedirectUri,A0.getCurrentUri())):null===this.config.auth.postLogoutRedirectUri?this.logger.verbose("postLogoutRedirectUri configured as null and no uri set on request, not passing post logout redirect",o.correlationId):this.config.auth.postLogoutRedirectUri?(this.logger.verbose("Setting postLogoutRedirectUri to configured uri",o.correlationId),o.postLogoutRedirectUri=e_.getAbsoluteUrl(this.config.auth.postLogoutRedirectUri,A0.getCurrentUri())):(this.logger.verbose("Setting postLogoutRedirectUri to current page",o.correlationId),o.postLogoutRedirectUri=e_.getAbsoluteUrl(A0.getCurrentUri(),A0.getCurrentUri())),o},x0.prototype.getLogoutHintFromIdTokenClaims=function(e){e=e.idTokenClaims;if(e){if(e.login_hint)return e.login_hint;this.logger.verbose("The ID Token Claims tied to the provided account do not contain a login_hint claim, logoutHint will not be added to logout request")}else this.logger.verbose("The provided account does not contain ID Token Claims, logoutHint will not be added to logout request");return null},x0.prototype.createAuthCodeClient=function(o,r,n){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientCreateAuthCodeClient,this.correlationId),this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(o,r,n)];case 1:return t=e.sent(),[2,new p_(t,this.performanceClient)]}})})},x0.prototype.getClientConfiguration=function(r,n,i){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientGetClientConfiguration,this.correlationId),this.logger.verbose("getClientConfiguration called",this.correlationId),this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetDiscoveredAuthority,this.correlationId),[4,this.getDiscoveredAuthority(n,i)];case 1:return t=e.sent(),o=this.config.system.loggerOptions,[2,{authOptions:{clientId:this.config.auth.clientId,authority:t,clientCapabilities:this.config.auth.clientCapabilities},systemOptions:{tokenRenewalOffsetSeconds:this.config.system.tokenRenewalOffsetSeconds,preventCorsPreflight:!0},loggerOptions:{loggerCallback:o.loggerCallback,piiLoggingEnabled:o.piiLoggingEnabled,logLevel:o.logLevel,correlationId:this.correlationId},cacheOptions:{claimsBasedCachingEnabled:this.config.cache.claimsBasedCachingEnabled},cryptoInterface:this.browserCrypto,networkInterface:this.networkClient,storageInterface:this.browserStorage,serverTelemetryManager:r,libraryInfo:{sku:Jw.MSAL_SKU,version:S0,cpu:E.EMPTY_STRING,os:E.EMPTY_STRING},telemetry:this.config.telemetry}]}})})},x0.prototype.validateAndExtractStateFromHash=function(e,t,o){if(this.logger.verbose("validateAndExtractStateFromHash called",o),!e.state)throw P.createHashDoesNotContainStateError();var r=v0.extractBrowserRequestState(this.browserCrypto,e.state);if(!r)throw P.createUnableToParseStateError();if(r.interactionType!==t)throw P.createStateInteractionTypeMismatchError();return this.logger.verbose("Returning state from hash",o),e.state},x0.prototype.getDiscoveredAuthority=function(n,i){var a;return _(this,void 0,void 0,function(){var t,o,r;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientGetDiscoveredAuthority,this.correlationId),this.logger.verbose("getDiscoveredAuthority called",this.correlationId),t=null==(a=this.performanceClient)?void 0:a.startMeasurement(A.StandardInteractionClientGetDiscoveredAuthority,this.correlationId),o={protocolMode:this.config.auth.protocolMode,knownAuthorities:this.config.auth.knownAuthorities,cloudDiscoveryMetadata:this.config.auth.cloudDiscoveryMetadata,authorityMetadata:this.config.auth.authorityMetadata,skipAuthorityMetadataCache:this.config.auth.skipAuthorityMetadataCache},r=n||this.config.auth.authority,r=A_.generateAuthority(r,i||this.config.auth.azureCloudOptions),this.logger.verbose("Creating discovered authority with configured authority",this.correlationId),this.performanceClient.setPreQueueTime(A.AuthorityFactoryCreateDiscoveredInstance,this.correlationId),[4,P_.createDiscoveredInstance(r,this.config.system.networkClient,this.browserStorage,o,this.logger,this.performanceClient,this.correlationId).then(function(e){return t.endMeasurement({success:!0}),e}).catch(function(e){throw t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})];case 1:return[2,e.sent()]}})})},x0.prototype.initializeAuthorizationRequest=function(a,s){return _(this,void 0,void 0,function(){var t,o,r,n,i;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientInitializeAuthorizationRequest,this.correlationId),this.logger.verbose("initializeAuthorizationRequest called",this.correlationId),t=this.getRedirectUri(a.redirectUri),o={interactionType:s},o=Jv.setRequestState(this.browserCrypto,a&&a.state||E.EMPTY_STRING,o),this.performanceClient.setPreQueueTime(A.InitializeBaseRequest,this.correlationId),n=[{}],[4,this.initializeBaseRequest(a)];case 1:return r=v.apply(void 0,[v.apply(void 0,n.concat([e.sent()])),{redirectUri:t,state:o,nonce:a.nonce||this.browserCrypto.createNewGuid(),responseMode:Zg.FRAGMENT}]),(i=a.account||this.browserStorage.getActiveAccount())&&(this.logger.verbose("Setting validated request account",this.correlationId),this.logger.verbosePii("Setting validated request account: "+i.homeAccountId,this.correlationId),r.account=i),k.isEmpty(r.loginHint)&&!i&&(i=this.browserStorage.getLegacyLoginHint())&&(r.loginHint=i),[2,r]}})})};var R0,s=x0;function x0(){return null!==R0&&R0.apply(this,arguments)||this}N0.prototype.handleCodeResponseFromHash=function(r,n,i,a){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){if(this.performanceClient.addQueueMeasurement(A.HandleCodeResponseFromHash,this.authCodeRequest.correlationId),this.logger.verbose("InteractionHandler.handleCodeResponse called"),k.isEmpty(r))throw P.createEmptyHashError(r);if(t=this.browserStorage.generateStateKey(n),!(t=this.browserStorage.getTemporaryCache(t)))throw I.createStateNotFoundError("Cached State");try{o=this.authModule.handleFragmentResponse(r,t)}catch(e){throw e instanceof wv&&e.subError===lw.code?P.createUserCancelledError():e}return this.performanceClient.setPreQueueTime(A.HandleCodeResponseFromServer,this.authCodeRequest.correlationId),[2,this.handleCodeResponseFromServer(o,n,i,a)]})})},N0.prototype.handleCodeResponseFromServer=function(n,i,a,s,c){return void 0===c&&(c=!0),_(this,void 0,void 0,function(){var t,o,r;return w(this,function(e){switch(e.label){case 0:if(this.performanceClient.addQueueMeasurement(A.HandleCodeResponseFromServer,this.authCodeRequest.correlationId),this.logger.trace("InteractionHandler.handleCodeResponseFromServer called"),t=this.browserStorage.generateStateKey(i),t=this.browserStorage.getTemporaryCache(t))return o=this.browserStorage.generateNonceKey(t),o=this.browserStorage.getTemporaryCache(o),this.authCodeRequest.code=n.code,n.cloud_instance_host_name?(this.performanceClient.setPreQueueTime(A.UpdateTokenEndpointAuthority,this.authCodeRequest.correlationId),[4,this.updateTokenEndpointAuthority(n.cloud_instance_host_name,a,s)]):[3,2];throw I.createStateNotFoundError("Cached State");case 1:e.sent(),e.label=2;case 2:return c&&(n.nonce=o||void 0),n.state=t,n.client_info?this.authCodeRequest.clientInfo=n.client_info:(r=this.checkCcsCredentials())&&(this.authCodeRequest.ccsCredential=r),this.performanceClient.setPreQueueTime(A.AuthClientAcquireToken,this.authCodeRequest.correlationId),[4,this.authModule.acquireToken(this.authCodeRequest,n)];case 3:return r=e.sent(),this.browserStorage.cleanRequestByState(i),[2,r]}})})},N0.prototype.updateTokenEndpointAuthority=function(o,r,n){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.UpdateTokenEndpointAuthority,this.authCodeRequest.correlationId),t="https://"+o+"/"+r.tenant+"/",[4,P_.createDiscoveredInstance(t,n,this.browserStorage,r.options,this.logger,this.performanceClient,this.authCodeRequest.correlationId)];case 1:return t=e.sent(),this.authModule.updateAuthority(t),[2]}})})},N0.prototype.checkCcsCredentials=function(){var t=this.browserStorage.getTemporaryCache(Yw.CCS_CREDENTIAL,!0);if(t)try{return JSON.parse(t)}catch(e){this.authModule.logger.error("Cache credential could not be parsed"),this.authModule.logger.errorPii("Cache credential could not be parsed: "+t)}return null};var M0=N0;function N0(e,t,o,r,n){this.authModule=e,this.browserStorage=t,this.authCodeRequest=o,this.logger=r,this.performanceClient=n}Dg(U0,L0=M0),U0.prototype.initiateAuthRequest=function(o,r){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return(this.logger.verbose("RedirectHandler.initiateAuthRequest called"),k.isEmpty(o))?[3,7]:(r.redirectStartPage&&(this.logger.verbose("RedirectHandler.initiateAuthRequest: redirectStartPage set, caching start page"),this.browserStorage.setTemporaryCache(Yw.ORIGIN_URI,r.redirectStartPage,!0)),this.browserStorage.setTemporaryCache(Yw.CORRELATION_ID,this.authCodeRequest.correlationId,!0),this.browserStorage.cacheCodeRequest(this.authCodeRequest,this.browserCrypto),this.logger.infoPii("RedirectHandler.initiateAuthRequest: Navigate to: "+o),t={apiId:Qw.acquireTokenRedirect,timeout:r.redirectTimeout,noHistory:!1},"function"!=typeof r.onRedirectNavigate?[3,4]:(this.logger.verbose("RedirectHandler.initiateAuthRequest: Invoking onRedirectNavigate callback"),!1===r.onRedirectNavigate(o)?[3,2]:(this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate did not return false, navigating"),[4,r.navigationClient.navigateExternal(o,t)])));case 1:return e.sent(),[2];case 2:return this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate returned false, stopping navigation"),[2];case 3:return[3,6];case 4:return this.logger.verbose("RedirectHandler.initiateAuthRequest: Navigating window to navigate url"),[4,r.navigationClient.navigateExternal(o,t)];case 5:return e.sent(),[2];case 6:return[3,8];case 7:throw this.logger.info("RedirectHandler.initiateAuthRequest: Navigate url is empty"),P.createEmptyNavigationUriError();case 8:return[2]}})})},U0.prototype.handleCodeResponseFromHash=function(i,a,s,c){return _(this,void 0,void 0,function(){var t,o,r,n;return w(this,function(e){switch(e.label){case 0:if(this.logger.verbose("RedirectHandler.handleCodeResponse called"),k.isEmpty(i))throw P.createEmptyHashError(i);if(this.browserStorage.setInteractionInProgress(!1),t=this.browserStorage.generateStateKey(a),!(t=this.browserStorage.getTemporaryCache(t)))throw I.createStateNotFoundError("Cached State");try{o=this.authModule.handleFragmentResponse(i,t)}catch(e){throw e instanceof wv&&e.subError===lw.code?P.createUserCancelledError():e}return(r=this.browserStorage.generateNonceKey(t),r=this.browserStorage.getTemporaryCache(r),this.authCodeRequest.code=o.code,o.cloud_instance_host_name)?[4,this.updateTokenEndpointAuthority(o.cloud_instance_host_name,s,c)]:[3,2];case 1:e.sent(),e.label=2;case 2:return o.nonce=r||void 0,o.state=t,o.client_info?this.authCodeRequest.clientInfo=o.client_info:(n=this.checkCcsCredentials())&&(this.authCodeRequest.ccsCredential=n),[4,this.authModule.acquireToken(this.authCodeRequest,o)];case 3:return n=e.sent(),this.browserStorage.cleanRequestByState(a),[2,n]}})})};var L0,x,D0,q0=U0;function U0(e,t,o,r,n,i){e=L0.call(this,e,t,o,r,i)||this;return e.browserCrypto=n,e}(n=x=x||{}).INITIALIZE_START="msal:initializeStart",n.INITIALIZE_END="msal:initializeEnd",n.ACCOUNT_ADDED="msal:accountAdded",n.ACCOUNT_REMOVED="msal:accountRemoved",n.LOGIN_START="msal:loginStart",n.LOGIN_SUCCESS="msal:loginSuccess",n.LOGIN_FAILURE="msal:loginFailure",n.ACQUIRE_TOKEN_START="msal:acquireTokenStart",n.ACQUIRE_TOKEN_SUCCESS="msal:acquireTokenSuccess",n.ACQUIRE_TOKEN_FAILURE="msal:acquireTokenFailure",n.ACQUIRE_TOKEN_NETWORK_START="msal:acquireTokenFromNetworkStart",n.SSO_SILENT_START="msal:ssoSilentStart",n.SSO_SILENT_SUCCESS="msal:ssoSilentSuccess",n.SSO_SILENT_FAILURE="msal:ssoSilentFailure",n.ACQUIRE_TOKEN_BY_CODE_START="msal:acquireTokenByCodeStart",n.ACQUIRE_TOKEN_BY_CODE_SUCCESS="msal:acquireTokenByCodeSuccess",n.ACQUIRE_TOKEN_BY_CODE_FAILURE="msal:acquireTokenByCodeFailure",n.HANDLE_REDIRECT_START="msal:handleRedirectStart",n.HANDLE_REDIRECT_END="msal:handleRedirectEnd",n.POPUP_OPENED="msal:popupOpened",n.LOGOUT_START="msal:logoutStart",n.LOGOUT_SUCCESS="msal:logoutSuccess",n.LOGOUT_FAILURE="msal:logoutFailure",n.LOGOUT_END="msal:logoutEnd",n.RESTORE_FROM_BFCACHE="msal:restoreFromBFCache",(ln=D0=D0||{}).USER_INTERACTION_REQUIRED="USER_INTERACTION_REQUIRED",ln.USER_CANCEL="USER_CANCEL",ln.NO_NETWORK="NO_NETWORK",ln.TRANSIENT_ERROR="TRANSIENT_ERROR",ln.PERSISTENT_ERROR="PERSISTENT_ERROR",ln.DISABLED="DISABLED",ln.ACCOUNT_UNAVAILABLE="ACCOUNT_UNAVAILABLE";var j0,H0={code:"ContentError"},B0={code:"user_switch",desc:"User attempted to switch accounts in the native broker, which is not allowed. All new accounts must sign-in through the standard web flow first, please try again."},F0={code:"tokens_not_found_in_internal_memory_cache",desc:"Tokens not cached in MSAL JS internal memory, please make the WAM request"},z0=(Dg(K0,j0=T),K0.prototype.isFatal=function(){return!(!this.ext||!this.ext.status||this.ext.status!==D0.PERSISTENT_ERROR&&this.ext.status!==D0.DISABLED)||this.errorCode===H0.code},K0.createError=function(e,t,o){if(o&&o.status)switch(o.status){case D0.ACCOUNT_UNAVAILABLE:return Zv.createNativeAccountUnavailableError();case D0.USER_INTERACTION_REQUIRED:return new Zv(e,t);case D0.USER_CANCEL:return P.createUserCancelledError();case D0.NO_NETWORK:return P.createNoNetworkConnectivityError()}return new K0(e,t,o)},K0.createUserSwitchError=function(){return new K0(B0.code,B0.desc)},K0.createTokensNotFoundInCacheError=function(){return new K0(F0.code,F0.desc)},K0);function K0(e,t,o){e=j0.call(this,e,t)||this;return Object.setPrototypeOf(e,K0.prototype),e.name="NativeAuthError",e.ext=o,e}Dg(W0,G0=s),W0.prototype.acquireToken=function(i){return _(this,void 0,void 0,function(){var t,o,r,n;return w(this,function(e){switch(e.label){case 0:return t=this.performanceClient.startMeasurement(A.SilentCacheClientAcquireToken,i.correlationId),r=this.initializeServerTelemetryManager(Qw.acquireTokenSilent_silentFlow),[4,this.createSilentFlowClient(r,i.authority,i.azureCloudOptions)];case 1:o=e.sent(),this.logger.verbose("Silent auth client created"),e.label=2;case 2:return e.trys.push([2,4,,5]),[4,o.acquireCachedToken(i)];case 3:return r=e.sent(),t.endMeasurement({success:!0,fromCache:!0}),[2,r];case 4:throw(n=e.sent())instanceof P&&n.errorCode===xw.code&&this.logger.verbose("Signing keypair for bound access token not found. Refreshing bound access token and generating a new crypto keypair."),t.endMeasurement({errorCode:n instanceof T&&n.errorCode||void 0,subErrorCode:n instanceof T&&n.subError||void 0,success:!1}),n;case 5:return[2]}})})},W0.prototype.logout=function(){return Promise.reject(P.createSilentLogoutUnsupportedError())},W0.prototype.createSilentFlowClient=function(o,r,n){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(o,r,n)];case 1:return t=e.sent(),[2,new __(t,this.performanceClient)]}})})},W0.prototype.initializeSilentRequest=function(o,r){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.InitializeSilentRequest,this.correlationId),this.performanceClient.setPreQueueTime(A.InitializeBaseRequest,this.correlationId),t=[v({},o)],[4,this.initializeBaseRequest(o,r)];case 1:return[2,v.apply(void 0,[v.apply(void 0,t.concat([e.sent()])),{account:r,forceRefresh:o.forceRefresh||!1}])]}})})};var G0,Y0=W0;function W0(){return null!==G0&&G0.apply(this,arguments)||this}Dg(V0,Z0=t),V0.prototype.acquireToken=function(a){return _(this,void 0,void 0,function(){var t,o,r,n,i;return w(this,function(e){switch(e.label){case 0:return this.logger.trace("NativeInteractionClient - acquireToken called."),t=this.performanceClient.startMeasurement(A.NativeInteractionClientAcquireToken,a.correlationId),o=Lv.nowSeconds(),[4,this.initializeNativeRequest(a)];case 1:r=e.sent(),e.label=2;case 2:return e.trys.push([2,4,,5]),[4,this.acquireTokensFromCache(this.accountId,r)];case 3:return n=e.sent(),t.endMeasurement({success:!0,isNativeBroker:!1,fromCache:!0}),[2,n];case 4:return e.sent(),this.logger.info("MSAL internal Cache does not contain tokens, proceed to make a native call"),[3,5];case 5:return n={method:zw.GetToken,request:r},[4,this.nativeMessageHandler.sendMessage(n)];case 6:return i=e.sent(),i=this.validateNativeResponse(i),[2,this.handleNativeResponse(i,r,o).then(function(e){return t.endMeasurement({success:!0,isNativeBroker:!0,requestId:e.requestId}),e}).catch(function(e){throw t.endMeasurement({success:!1,errorCode:e.errorCode,subErrorCode:e.subError,isNativeBroker:!0}),e})]}})})},V0.prototype.createSilentCacheRequest=function(e,t){return{authority:e.authority,correlationId:this.correlationId,scopes:Xy.fromString(e.scope).asArray(),account:t,forceRefresh:!1}},V0.prototype.acquireTokensFromCache=function(r,n){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:if(!r)throw this.logger.warning("NativeInteractionClient:acquireTokensFromCache - No nativeAccountId provided"),I.createNoAccountFoundError();if(!(t=this.browserStorage.getAccountInfoFilteredBy({nativeAccountId:r})))throw I.createNoAccountFoundError();e.label=1;case 1:return e.trys.push([1,3,,4]),o=this.createSilentCacheRequest(n,t),[4,this.silentCacheClient.acquireToken(o)];case 2:return[2,e.sent()];case 3:throw e.sent();case 4:return[2]}})})},V0.prototype.acquireTokenRedirect=function(a){return _(this,void 0,void 0,function(){var t,o,r,n,i;return w(this,function(e){switch(e.label){case 0:return this.logger.trace("NativeInteractionClient - acquireTokenRedirect called."),[4,this.initializeNativeRequest(a)];case 1:t=e.sent(),o={method:zw.GetToken,request:t},e.label=2;case 2:return e.trys.push([2,4,,5]),[4,this.nativeMessageHandler.sendMessage(o)];case 3:return r=e.sent(),this.validateNativeResponse(r),[3,5];case 4:if((r=e.sent())instanceof z0&&r.isFatal())throw r;return[3,5];case 5:return this.browserStorage.setTemporaryCache(Yw.NATIVE_REQUEST,JSON.stringify(t),!0),n={apiId:Qw.acquireTokenRedirect,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},i=this.config.auth.navigateToLoginRequestUrl?window.location.href:this.getRedirectUri(a.redirectUri),[4,this.navigationClient.navigateExternal(i,n)];case 6:return e.sent(),[2]}})})},V0.prototype.handleRedirectPromise=function(){return _(this,void 0,void 0,function(){var t,o,r,n;return w(this,function(e){switch(e.label){case 0:if(this.logger.trace("NativeInteractionClient - handleRedirectPromise called."),!this.browserStorage.isInteractionInProgress(!0))return this.logger.info("handleRedirectPromise called but there is no interaction in progress, returning null."),[2,null];if(!(t=this.browserStorage.getCachedNativeRequest()))return this.logger.verbose("NativeInteractionClient - handleRedirectPromise called but there is no cached request, returning null."),[2,null];o=t.prompt,t=qg(t,["prompt"]),o&&this.logger.verbose("NativeInteractionClient - handleRedirectPromise called and prompt was included in the original request, removing prompt from cached request to prevent second interaction with native broker window."),this.browserStorage.removeItem(this.browserStorage.generateCacheKey(Yw.NATIVE_REQUEST)),o={method:zw.GetToken,request:t},r=Lv.nowSeconds(),e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("NativeInteractionClient - handleRedirectPromise sending message to native broker."),[4,this.nativeMessageHandler.sendMessage(o)];case 2:return n=e.sent(),this.validateNativeResponse(n),n=this.handleNativeResponse(n,t,r),this.browserStorage.setInteractionInProgress(!1),[2,n];case 3:throw n=e.sent(),this.browserStorage.setInteractionInProgress(!1),n;case 4:return[2]}})})},V0.prototype.logout=function(){return this.logger.trace("NativeInteractionClient - logout called."),Promise.reject("Logout not implemented yet")},V0.prototype.handleNativeResponse=function(i,a,s){return _(this,void 0,void 0,function(){var t,o,r,n;return w(this,function(e){switch(e.label){case 0:if(this.logger.trace("NativeInteractionClient - handleNativeResponse called."),i.account.id!==a.accountId)throw z0.createUserSwitchError();return[4,this.getDiscoveredAuthority(a.authority)];case 1:return n=e.sent(),r=n.getPreferredCache(),t=this.createIdTokenObj(i),o=this.createHomeAccountIdentifier(i,t),r=this.createAccountEntity(i,o,t,r),[4,this.generateAuthenticationResult(i,a,t,r,n.canonicalAuthority,s)];case 2:return n=e.sent(),this.cacheAccount(r),this.cacheNativeTokens(i,a,o,r,t,n.accessToken,n.tenantId,s),[2,n]}})})},V0.prototype.createIdTokenObj=function(e){return new nv(e.id_token||E.EMPTY_STRING,this.browserCrypto)},V0.prototype.createHomeAccountIdentifier=function(e,t){return ov.generateHomeAccountId(e.client_info||E.EMPTY_STRING,Jy.Default,this.logger,this.browserCrypto,t)},V0.prototype.createAccountEntity=function(e,t,o,r){return ov.createAccount(e.client_info,t,o,void 0,void 0,void 0,r,e.account.id)},V0.prototype.generateScopes=function(e,t){return e.scope?Xy.fromString(e.scope):Xy.fromString(t.scope)},V0.prototype.generatePopAccessToken=function(r,n){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:if(n.tokenType!==em.POP)return[3,2];if(r.shr)return this.logger.trace("handleNativeServerResponse: SHR is enabled in native layer"),[2,r.shr];if(t=new n_(this.browserCrypto),o={resourceRequestMethod:n.resourceRequestMethod,resourceRequestUri:n.resourceRequestUri,shrClaims:n.shrClaims,shrNonce:n.shrNonce},n.keyId)return[4,t.signPopToken(r.access_token,n.keyId,o)];throw I.createKeyIdMissingError();case 1:return[2,e.sent()];case 2:return[2,r.access_token]}})})},V0.prototype.generateAuthenticationResult=function(s,c,u,l,h,d){return _(this,void 0,void 0,function(){var t,o,r,n,i,a;return w(this,function(e){switch(e.label){case 0:return t=this.addTelemetryFromNativeResponse(s),o=s.scope?Xy.fromString(s.scope):Xy.fromString(c.scope),n=s.account.properties||{},r=n.UID||u.claims.oid||u.claims.sub||E.EMPTY_STRING,n=n.TenantId||u.claims.tid||E.EMPTY_STRING,[4,this.generatePopAccessToken(s,c)];case 1:return i=e.sent(),a=c.tokenType===em.POP?em.POP:em.BEARER,[2,{authority:h,uniqueId:r,tenantId:n,scopes:o.asArray(),account:l.getAccountInfo(),idToken:s.id_token,idTokenClaims:u.claims,accessToken:i,fromCache:!!t&&this.isResponseFromCache(t),expiresOn:new Date(1e3*Number(d+s.expires_in)),tokenType:a,correlationId:this.correlationId,state:s.state,fromNativeBroker:!0}]}})})},V0.prototype.cacheAccount=function(e){var t=this;this.browserStorage.setAccount(e),this.browserStorage.removeAccountContext(e).catch(function(e){t.logger.error("Error occurred while removing account context from browser storage. "+e)})},V0.prototype.cacheNativeTokens=function(e,t,o,r,n,i,a,s){var c=Mv.createIdTokenEntity(o,t.authority,e.id_token||E.EMPTY_STRING,t.clientId,n.claims.tid||E.EMPTY_STRING),s=s+(t.tokenType===em.POP?E.SHR_NONCE_VALIDITY:("string"==typeof e.expires_in?parseInt(e.expires_in,10):e.expires_in)||0),e=this.generateScopes(e,t),o=Uv.createAccessTokenEntity(o,t.authority,i,t.clientId,n?n.claims.tid||E.EMPTY_STRING:a,e.printScopes(),s,0,this.browserCrypto),i=new Vv(r,c,o);this.nativeStorageManager.saveCacheRecord(i)},V0.prototype.addTelemetryFromNativeResponse=function(e){e=this.getMATSFromResponse(e);return e?(this.performanceClient.addStaticFields({extensionId:this.nativeMessageHandler.getExtensionId(),extensionVersion:this.nativeMessageHandler.getExtensionVersion(),matsBrokerVersion:e.broker_version,matsAccountJoinOnStart:e.account_join_on_start,matsAccountJoinOnEnd:e.account_join_on_end,matsDeviceJoin:e.device_join,matsPromptBehavior:e.prompt_behavior,matsApiErrorCode:e.api_error_code,matsUiVisible:e.ui_visible,matsSilentCode:e.silent_code,matsSilentBiSubCode:e.silent_bi_sub_code,matsSilentMessage:e.silent_message,matsSilentStatus:e.silent_status,matsHttpStatus:e.http_status,matsHttpEventCount:e.http_event_count},this.correlationId),e):null},V0.prototype.validateNativeResponse=function(e){if(e.hasOwnProperty("access_token")&&e.hasOwnProperty("id_token")&&e.hasOwnProperty("client_info")&&e.hasOwnProperty("account")&&e.hasOwnProperty("scope")&&e.hasOwnProperty("expires_in"))return e;throw z0.createUnexpectedError("Response missing expected properties.")},V0.prototype.getMATSFromResponse=function(e){if(e.properties.MATS)try{return JSON.parse(e.properties.MATS)}catch(e){this.logger.error("NativeInteractionClient - Error parsing MATS telemetry, returning null instead")}return null},V0.prototype.isResponseFromCache=function(e){return void 0===e.is_cached?(this.logger.verbose("NativeInteractionClient - MATS telemetry does not contain field indicating if response was served from cache. Returning false."),!1):!!e.is_cached},V0.prototype.initializeNativeRequest=function(s){return _(this,void 0,void 0,function(){var t,o,r,n,i,a=this;return w(this,function(e){switch(e.label){case 0:return(this.logger.trace("NativeInteractionClient - initializeNativeRequest called"),t=s.authority||this.config.auth.authority,s.account)?[4,this.validateRequestAuthority(t,s.account)]:[3,2];case 1:e.sent(),e.label=2;case 2:return((n=new e_(t)).validateAsUri(),i=s.scopes,r=qg(s,["scopes"]),(i=new Xy(i||[])).appendScopes(tm),o=function(){switch(a.apiId){case Qw.ssoSilent:case Qw.acquireTokenSilent_silentFlow:return a.logger.trace("initializeNativeRequest: silent request sets prompt to none"),rm.NONE}if(s.prompt)switch(s.prompt){case rm.NONE:case rm.CONSENT:case rm.LOGIN:return a.logger.trace("initializeNativeRequest: prompt is compatible with native flow"),s.prompt;default:throw a.logger.trace("initializeNativeRequest: prompt = "+s.prompt+" is not compatible with native flow"),P.createNativePromptParameterNotSupportedError()}else a.logger.trace("initializeNativeRequest: prompt was not provided")},r=v(v({},r),{accountId:this.accountId,clientId:this.config.auth.clientId,authority:n.urlString,scope:i.printScopes(),redirectUri:this.getRedirectUri(s.redirectUri),prompt:o(),correlationId:this.correlationId,tokenType:s.authenticationScheme,windowTitleSubstring:document.title,extraParameters:v(v(v({},s.extraQueryParameters),s.tokenQueryParameters),{telemetry:e0}),extendedExpiryToken:!1}),s.authenticationScheme!==em.POP)?[3,4]:(n={resourceRequestUri:s.resourceRequestUri,resourceRequestMethod:s.resourceRequestMethod,shrClaims:s.shrClaims,shrNonce:s.shrNonce},[4,new n_(this.browserCrypto).generateCnf(n)]);case 3:i=e.sent(),r.reqCnf=i.reqCnfString,r.keyId=i.kid,e.label=4;case 4:return[2,r]}})})};var Z0,Q0=V0;function V0(e,t,o,r,n,i,a,s,c,u,l,h){t=Z0.call(this,e,t,o,r,n,i,s,c,h)||this;return t.apiId=a,t.accountId=u,t.nativeMessageHandler=c,t.nativeStorageManager=l,t.silentCacheClient=new Y0(e,t.nativeStorageManager,o,r,n,i,s,c,h),t}X0.prototype.sendMessage=function(t){return _(this,void 0,void 0,function(){var o,r=this;return w(this,function(e){return this.logger.trace("NativeMessageHandler - sendMessage called."),o={channel:Xw,extensionId:this.extensionId,responseId:this.responseId++,body:t},this.logger.trace("NativeMessageHandler - Sending request to browser extension"),this.logger.tracePii("NativeMessageHandler - Sending request to browser extension: "+JSON.stringify(o)),this.messageChannel.port1.postMessage(o),[2,new Promise(function(e,t){r.resolvers.set(o.responseId,{resolve:e,reject:t})})]})})},X0.createProvider=function(r,n,i){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:r.trace("NativeMessageHandler - createProvider called."),e.label=1;case 1:return e.trys.push([1,3,,5]),[4,(t=new X0(r,n,i,$w)).sendHandshakeRequest()];case 2:return e.sent(),[2,t];case 3:return e.sent(),[4,(o=new X0(r,n,i)).sendHandshakeRequest()];case 4:return e.sent(),[2,o];case 5:return[2]}})})},X0.prototype.sendHandshakeRequest=function(){return _(this,void 0,void 0,function(){var o,r=this;return w(this,function(e){return this.logger.trace("NativeMessageHandler - sendHandshakeRequest called."),window.addEventListener("message",this.windowListener,!1),o={channel:Xw,extensionId:this.extensionId,responseId:this.responseId++,body:{method:zw.HandshakeRequest}},this.handshakeEvent.addStaticFields({extensionId:this.extensionId,extensionHandshakeTimeoutMs:this.handshakeTimeoutMs}),this.messageChannel.port1.onmessage=function(e){r.onChannelMessage(e)},window.postMessage(o,window.origin,[this.messageChannel.port2]),[2,new Promise(function(e,t){r.handshakeResolvers.set(o.responseId,{resolve:e,reject:t}),r.timeoutId=window.setTimeout(function(){window.removeEventListener("message",r.windowListener,!1),r.messageChannel.port1.close(),r.messageChannel.port2.close(),r.handshakeEvent.endMeasurement({extensionHandshakeTimedOut:!0,success:!1}),t(P.createNativeHandshakeTimeoutError()),r.handshakeResolvers.delete(o.responseId)},r.handshakeTimeoutMs)})]})})},X0.prototype.onWindowMessage=function(e){this.logger.trace("NativeMessageHandler - onWindowMessage called"),e.source!==window||!(e=e.data).channel||e.channel!==Xw||e.extensionId&&e.extensionId!==this.extensionId||e.body.method===zw.HandshakeRequest&&(this.logger.verbose(e.extensionId?"Extension with id: "+e.extensionId+" not installed":"No extension installed"),clearTimeout(this.timeoutId),this.messageChannel.port1.close(),this.messageChannel.port2.close(),window.removeEventListener("message",this.windowListener,!1),e=this.handshakeResolvers.get(e.responseId))&&(this.handshakeEvent.endMeasurement({success:!1,extensionInstalled:!1}),e.reject(P.createNativeExtensionNotInstalledError()))},X0.prototype.onChannelMessage=function(t){this.logger.trace("NativeMessageHandler - onChannelMessage called.");var e=t.data,o=this.resolvers.get(e.responseId),r=this.handshakeResolvers.get(e.responseId);try{var n=e.body.method;if(n===zw.Response){if(o){var i=e.body.response;if(this.logger.trace("NativeMessageHandler - Received response from browser extension"),this.logger.tracePii("NativeMessageHandler - Received response from browser extension: "+JSON.stringify(i)),"Success"!==i.status)o.reject(z0.createError(i.code,i.description,i.ext));else{if(!i.result)throw T.createUnexpectedError("Event does not contain result.");i.result.code&&i.result.description?o.reject(z0.createError(i.result.code,i.result.description,i.result.ext)):o.resolve(i.result)}this.resolvers.delete(e.responseId)}}else n===zw.HandshakeResponse&&r&&(clearTimeout(this.timeoutId),window.removeEventListener("message",this.windowListener,!1),this.extensionId=e.extensionId,this.extensionVersion=e.body.version,this.logger.verbose("NativeMessageHandler - Received HandshakeResponse from extension: "+this.extensionId),this.handshakeEvent.endMeasurement({extensionInstalled:!0,success:!0}),r.resolve(),this.handshakeResolvers.delete(e.responseId))}catch(e){this.logger.error("Error parsing response from WAM Extension"),this.logger.errorPii("Error parsing response from WAM Extension: "+e.toString()),this.logger.errorPii("Unable to parse "+t),o?o.reject(e):r&&r.reject(e)}},X0.prototype.getExtensionId=function(){return this.extensionId},X0.prototype.getExtensionVersion=function(){return this.extensionVersion},X0.isNativeAvailable=function(e,t,o,r){if(t.trace("isNativeAvailable called"),!e.system.allowNativeBroker)return t.trace("isNativeAvailable: allowNativeBroker is not enabled, returning false"),!1;if(!o)return t.trace("isNativeAvailable: WAM extension provider is not initialized, returning false"),!1;if(r)switch(r){case em.BEARER:case em.POP:return t.trace("isNativeAvailable: authenticationScheme is supported, returning true"),!0;default:return t.trace("isNativeAvailable: authenticationScheme is not supported, returning false"),!1}return!0};var J0=X0;function X0(e,t,o,r){this.logger=e,this.handshakeTimeoutMs=t,this.extensionId=r,this.resolvers=new Map,this.handshakeResolvers=new Map,this.responseId=0,this.messageChannel=new MessageChannel,this.windowListener=this.onWindowMessage.bind(this),this.performanceClient=o,this.handshakeEvent=o.startMeasurement(A.NativeMessageHandlerHandshake)}Dg(tb,$0=s),tb.prototype.acquireToken=function(u){return _(this,void 0,void 0,function(){var t,o,r,n,i,a,s,c=this;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,u.correlationId),[4,this.initializeAuthorizationRequest(u,O.Redirect)];case 1:t=e.sent(),this.browserStorage.updateCacheEntries(t.state,t.nonce,t.authority,t.loginHint||E.EMPTY_STRING,t.account||null),o=this.initializeServerTelemetryManager(Qw.acquireTokenRedirect),r=function(e){e.persisted&&(c.logger.verbose("Page was restored from back/forward cache. Clearing temporary cache."),c.browserStorage.cleanRequestByState(t.state),c.eventHandler.emitEvent(x.RESTORE_FROM_BFCACHE,O.Redirect))},e.label=2;case 2:return e.trys.push([2,7,,8]),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationCodeRequest,u.correlationId),[4,this.initializeAuthorizationCodeRequest(t)];case 3:return n=e.sent(),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,u.correlationId),[4,this.createAuthCodeClient(o,t.authority,t.azureCloudOptions)];case 4:return a=e.sent(),this.logger.verbose("Auth code client created"),i=new q0(a,this.browserStorage,n,this.logger,this.browserCrypto,this.performanceClient),[4,a.getAuthCodeUrl(v(v({},t),{nativeBroker:J0.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,u.authenticationScheme)}))];case 5:return a=e.sent(),s=this.getRedirectStartPage(u.redirectStartPage),this.logger.verbosePii("Redirect start page: "+s),window.addEventListener("pageshow",r),[4,i.initiateAuthRequest(a,{navigationClient:this.navigationClient,redirectTimeout:this.config.system.redirectNavigationTimeout,redirectStartPage:s,onRedirectNavigate:u.onRedirectNavigate})];case 6:return[2,e.sent()];case 7:throw(s=e.sent())instanceof T&&s.setCorrelationId(this.correlationId),window.removeEventListener("pageshow",r),o.cacheFailedRequest(s),this.browserStorage.cleanRequestByState(t.state),s;case 8:return[2]}})})},tb.prototype.handleRedirectPromise=function(h){return _(this,void 0,void 0,function(){var t,o,r,n,i,a,s,c,u,l;return w(this,function(e){switch(e.label){case 0:t=this.initializeServerTelemetryManager(Qw.handleRedirectPromise),e.label=1;case 1:if(e.trys.push([1,10,,11]),!this.browserStorage.isInteractionInProgress(!0))return this.logger.info("handleRedirectPromise called but there is no interaction in progress, returning null."),[2,null];if(!(o=this.getRedirectResponseHash(h||window.location.hash)))return this.logger.info("handleRedirectPromise did not detect a response hash as a result of a redirect. Cleaning temporary cache."),this.browserStorage.cleanRequestByInteractionType(O.Redirect),[2,null];r=void 0;try{n=e_.getDeserializedHash(o),r=this.validateAndExtractStateFromHash(n,O.Redirect),this.logger.verbose("State extracted from hash")}catch(e){return this.logger.info("handleRedirectPromise was unable to extract state due to: "+e),this.browserStorage.cleanRequestByInteractionType(O.Redirect),[2,null]}return(i=this.browserStorage.getTemporaryCache(Yw.ORIGIN_URI,!0)||E.EMPTY_STRING,a=e_.removeHashFromUrl(i),u=e_.removeHashFromUrl(window.location.href),a===u&&this.config.auth.navigateToLoginRequestUrl)?(this.logger.verbose("Current page is loginRequestUrl, handling hash"),[4,this.handleHash(o,r,t)]):[3,3];case 2:return a=e.sent(),-1<i.indexOf("#")&&A0.replaceHash(i),[2,a];case 3:return this.config.auth.navigateToLoginRequestUrl?[3,4]:(this.logger.verbose("NavigateToLoginRequestUrl set to false, handling hash"),[2,this.handleHash(o,r,t)]);case 4:return A0.isInIframe()&&!this.config.system.allowRedirectInIframe?[3,9]:(this.browserStorage.setTemporaryCache(Yw.URL_HASH,o,!0),s={apiId:Qw.handleRedirectPromise,timeout:this.config.system.redirectNavigationTimeout,noHistory:!0},c=!0,i&&"null"!==i?[3,6]:(u=A0.getHomepage(),this.browserStorage.setTemporaryCache(Yw.ORIGIN_URI,u,!0),this.logger.warning("Unable to get valid login request url from cache, redirecting to home page"),[4,this.navigationClient.navigateInternal(u,s)]));case 5:return c=e.sent(),[3,8];case 6:return this.logger.verbose("Navigating to loginRequestUrl: "+i),[4,this.navigationClient.navigateInternal(i,s)];case 7:c=e.sent(),e.label=8;case 8:if(!c)return[2,this.handleHash(o,r,t)];e.label=9;case 9:return[2,null];case 10:throw(l=e.sent())instanceof T&&l.setCorrelationId(this.correlationId),t.cacheFailedRequest(l),this.browserStorage.cleanRequestByInteractionType(O.Redirect),l;case 11:return[2]}})})},tb.prototype.getRedirectResponseHash=function(e){return this.logger.verbose("getRedirectResponseHash called"),e_.hashContainsKnownProperties(e)?(A0.clearHash(window),this.logger.verbose("Hash contains known properties, returning response hash")):(e=this.browserStorage.getTemporaryCache(Yw.URL_HASH,!0),this.browserStorage.removeItem(this.browserStorage.generateCacheKey(Yw.URL_HASH)),this.logger.verbose("Hash does not contain known properties, returning cached hash")),e},tb.prototype.handleHash=function(i,a,s){return _(this,void 0,void 0,function(){var t,o,r,n=this;return w(this,function(e){switch(e.label){case 0:if(t=this.browserStorage.getCachedRequest(a,this.browserCrypto),this.logger.verbose("handleHash called, retrieved cached request"),(o=e_.getDeserializedHash(i)).accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),this.nativeMessageHandler)return o=new Q0(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Qw.acquireTokenPopup,this.performanceClient,this.nativeMessageHandler,o.accountId,this.nativeStorage,t.correlationId),r=Jv.parseRequestState(this.browserCrypto,a).userRequestState,[2,o.acquireToken(v(v({},t),{state:r,prompt:void 0})).finally(function(){n.browserStorage.cleanRequestByState(a)})];throw P.createNativeConnectionNotEstablishedError()}if(o=this.browserStorage.getCachedAuthority(a))return this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,t.correlationId),[4,this.createAuthCodeClient(s,o)];throw P.createNoCachedAuthorityError();case 1:return r=e.sent(),this.logger.verbose("Auth code client created"),Cv.removeThrottle(this.browserStorage,this.config.auth.clientId,t),[4,new q0(r,this.browserStorage,t,this.logger,this.browserCrypto,this.performanceClient).handleCodeResponseFromHash(i,a,r.authority,this.networkClient)];case 2:return[2,e.sent()]}})})},tb.prototype.logout=function(a){return _(this,void 0,void 0,function(){var t,o,r,n,i;return w(this,function(e){switch(e.label){case 0:this.logger.verbose("logoutRedirect called"),t=this.initializeLogoutRequest(a),o=this.initializeServerTelemetryManager(Qw.logout),e.label=1;case 1:return e.trys.push([1,10,,11]),this.eventHandler.emitEvent(x.LOGOUT_START,O.Redirect,a),[4,this.clearCacheOnLogout(t.account)];case 2:return e.sent(),r={apiId:Qw.logout,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,t.correlationId),[4,this.createAuthCodeClient(o,a&&a.authority)];case 3:return(n=e.sent(),this.logger.verbose("Auth code client created"),n=n.getLogoutUri(t),this.eventHandler.emitEvent(x.LOGOUT_SUCCESS,O.Redirect,t),a&&"function"==typeof a.onRedirectNavigate)?!1===a.onRedirectNavigate(n)?[3,5]:(this.logger.verbose("Logout onRedirectNavigate did not return false, navigating"),this.browserStorage.getInteractionInProgress()||this.browserStorage.setInteractionInProgress(!0),[4,this.navigationClient.navigateExternal(n,r)]):[3,7];case 4:return e.sent(),[2];case 5:this.browserStorage.setInteractionInProgress(!1),this.logger.verbose("Logout onRedirectNavigate returned false, stopping navigation"),e.label=6;case 6:return[3,9];case 7:return this.browserStorage.getInteractionInProgress()||this.browserStorage.setInteractionInProgress(!0),[4,this.navigationClient.navigateExternal(n,r)];case 8:return e.sent(),[2];case 9:return[3,11];case 10:throw(i=e.sent())instanceof T&&i.setCorrelationId(this.correlationId),o.cacheFailedRequest(i),this.eventHandler.emitEvent(x.LOGOUT_FAILURE,O.Redirect,null,i),this.eventHandler.emitEvent(x.LOGOUT_END,O.Redirect),i;case 11:return this.eventHandler.emitEvent(x.LOGOUT_END,O.Redirect),[2]}})})},tb.prototype.getRedirectStartPage=function(e){e=e||window.location.href;return e_.getAbsoluteUrl(e,A0.getCurrentUri())};var $0,eb=tb;function tb(e,t,o,r,n,i,a,s,c,u){e=$0.call(this,e,t,o,r,n,i,a,c,u)||this;return e.nativeStorage=s,e}Dg(nb,ob=s),nb.prototype.acquireToken=function(e){try{var t,o=this.generatePopupName(e.scopes||tm,e.authority||this.config.auth.authority),r=e.popupWindowAttributes||{};return this.config.system.asyncPopups?(this.logger.verbose("asyncPopups set to true, acquiring token"),this.acquireTokenPopupAsync(e,o,r)):(this.logger.verbose("asyncPopup set to false, opening popup before acquiring token"),t=this.openSizedPopup("about:blank",o,r),this.acquireTokenPopupAsync(e,o,r,t))}catch(e){return Promise.reject(e)}},nb.prototype.logout=function(e){try{this.logger.verbose("logoutPopup called");var t,o=this.initializeLogoutRequest(e),r=this.generateLogoutPopupName(o),n=e&&e.authority,i=e&&e.mainWindowRedirectUri,a=(null==e?void 0:e.popupWindowAttributes)||{};return this.config.system.asyncPopups?(this.logger.verbose("asyncPopups set to true"),this.logoutPopupAsync(o,r,a,n,void 0,i)):(this.logger.verbose("asyncPopup set to false, opening popup"),t=this.openSizedPopup("about:blank",r,a),this.logoutPopupAsync(o,r,a,n,t,i))}catch(e){return Promise.reject(e)}},nb.prototype.acquireTokenPopupAsync=function(p,f,g,m){return _(this,void 0,void 0,function(){var t,o,r,n,i,a,s,c,u,l,h,d=this;return w(this,function(e){switch(e.label){case 0:return this.logger.verbose("acquireTokenPopupAsync called"),t=this.initializeServerTelemetryManager(Qw.acquireTokenPopup),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,p.correlationId),[4,this.initializeAuthorizationRequest(p,O.Popup)];case 1:o=e.sent(),this.browserStorage.updateCacheEntries(o.state,o.nonce,o.authority,o.loginHint||E.EMPTY_STRING,o.account||null),e.label=2;case 2:return e.trys.push([2,8,,9]),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationCodeRequest,p.correlationId),[4,this.initializeAuthorizationCodeRequest(o)];case 3:return r=e.sent(),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,p.correlationId),[4,this.createAuthCodeClient(t,o.authority,o.azureCloudOptions)];case 4:return n=e.sent(),this.logger.verbose("Auth code client created"),a=J0.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,p.authenticationScheme),i=void 0,a&&(i=this.performanceClient.startMeasurement(A.FetchAccountIdWithNativeBroker,p.correlationId)),[4,n.getAuthCodeUrl(v(v({},o),{nativeBroker:a}))];case 5:return a=e.sent(),s=new M0(n,this.browserStorage,r,this.logger,this.performanceClient),c={popup:m,popupName:f,popupWindowAttributes:g},c=this.initiateAuthRequest(a,c),this.eventHandler.emitEvent(x.POPUP_OPENED,O.Popup,{popupWindow:c},null),[4,this.monitorPopupForHash(c)];case 6:if(c=e.sent(),h=e_.getDeserializedHash(c),u=this.validateAndExtractStateFromHash(h,O.Popup,o.correlationId),Cv.removeThrottle(this.browserStorage,this.config.auth.clientId,r),h.accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),i&&i.endMeasurement({success:!0,isNativeBroker:!0}),this.nativeMessageHandler)return h=new Q0(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Qw.acquireTokenPopup,this.performanceClient,this.nativeMessageHandler,h.accountId,this.nativeStorage,o.correlationId),l=Jv.parseRequestState(this.browserCrypto,u).userRequestState,[2,h.acquireToken(v(v({},o),{state:l,prompt:void 0})).finally(function(){d.browserStorage.cleanRequestByState(u)})];throw P.createNativeConnectionNotEstablishedError()}return[4,s.handleCodeResponseFromHash(c,u,n.authority,this.networkClient)];case 7:return[2,e.sent()];case 8:throw h=e.sent(),m&&m.close(),h instanceof T&&h.setCorrelationId(this.correlationId),t.cacheFailedRequest(h),this.browserStorage.cleanRequestByState(o.state),h;case 9:return[2]}})})},nb.prototype.logoutPopupAsync=function(n,i,a,s,c,u){return _(this,void 0,void 0,function(){var t,o,r;return w(this,function(e){switch(e.label){case 0:this.logger.verbose("logoutPopupAsync called"),this.eventHandler.emitEvent(x.LOGOUT_START,O.Popup,n),t=this.initializeServerTelemetryManager(Qw.logoutPopup),e.label=1;case 1:return e.trys.push([1,5,,6]),[4,this.clearCacheOnLogout(n.account)];case 2:return e.sent(),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,n.correlationId),[4,this.createAuthCodeClient(t,s)];case 3:return o=e.sent(),this.logger.verbose("Auth code client created"),o=o.getLogoutUri(n),this.eventHandler.emitEvent(x.LOGOUT_SUCCESS,O.Popup,n),o=this.openPopup(o,{popupName:i,popupWindowAttributes:a,popup:c}),this.eventHandler.emitEvent(x.POPUP_OPENED,O.Popup,{popupWindow:o},null),[4,this.waitForLogoutPopup(o)];case 4:return e.sent(),u?(o={apiId:Qw.logoutPopup,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},r=e_.getAbsoluteUrl(u,A0.getCurrentUri()),this.logger.verbose("Redirecting main window to url specified in the request"),this.logger.verbosePii("Redirecting main window to: "+r),this.navigationClient.navigateInternal(r,o)):this.logger.verbose("No main window navigation requested"),[3,6];case 5:throw r=e.sent(),c&&c.close(),r instanceof T&&r.setCorrelationId(this.correlationId),this.browserStorage.setInteractionInProgress(!1),this.eventHandler.emitEvent(x.LOGOUT_FAILURE,O.Popup,null,r),this.eventHandler.emitEvent(x.LOGOUT_END,O.Popup),t.cacheFailedRequest(r),r;case 6:return this.eventHandler.emitEvent(x.LOGOUT_END,O.Popup),[2]}})})},nb.prototype.initiateAuthRequest=function(e,t){if(k.isEmpty(e))throw this.logger.error("Navigate url is empty"),P.createEmptyNavigationUriError();return this.logger.infoPii("Navigate to: "+e),this.openPopup(e,t)},nb.prototype.monitorPopupForHash=function(s){var c=this;return new Promise(function(o,r){var n=c.config.system.windowHashTimeout/c.config.system.pollIntervalMilliseconds,i=0,a=(c.logger.verbose("PopupHandler.monitorPopupForHash - polling started"),setInterval(function(){if(s.closed)c.logger.error("PopupHandler.monitorPopupForHash - window closed"),c.cleanPopup(),clearInterval(a),r(P.createUserCancelledError());else{var e=E.EMPTY_STRING,t=E.EMPTY_STRING;try{e=s.location.href,t=s.location.hash}catch(e){}k.isEmpty(e)||"about:blank"===e||(c.logger.verbose("PopupHandler.monitorPopupForHash - popup window is on same origin as caller"),i++,t?(c.logger.verbose("PopupHandler.monitorPopupForHash - found hash in url"),clearInterval(a),c.cleanPopup(s),e_.hashContainsKnownProperties(t)?(c.logger.verbose("PopupHandler.monitorPopupForHash - hash contains known properties, returning."),o(t)):(c.logger.error("PopupHandler.monitorPopupForHash - found hash in url but it does not contain known properties. Check that your router is not changing the hash prematurely."),c.logger.errorPii("PopupHandler.monitorPopupForHash - hash found: "+t),r(P.createHashDoesNotContainKnownPropertiesError()))):n<i&&(c.logger.error("PopupHandler.monitorPopupForHash - unable to find hash in url, timing out"),clearInterval(a),r(P.createMonitorPopupTimeoutError())))}},c.config.system.pollIntervalMilliseconds))})},nb.prototype.waitForLogoutPopup=function(r){var n=this;return new Promise(function(t){n.logger.verbose("PopupHandler.waitForLogoutPopup - polling started");var o=setInterval(function(){r.closed&&(n.logger.error("PopupHandler.waitForLogoutPopup - window closed"),n.cleanPopup(),clearInterval(o),t());var e=E.EMPTY_STRING;try{e=r.location.href}catch(e){}k.isEmpty(e)||"about:blank"===e||(n.logger.verbose("PopupHandler.waitForLogoutPopup - popup window is on same origin as caller, closing."),clearInterval(o),n.cleanPopup(r),t())},n.config.system.pollIntervalMilliseconds)})},nb.prototype.openPopup=function(e,t){try{var o=void 0;if(t.popup?(o=t.popup,this.logger.verbosePii("Navigating popup window to: "+e),o.location.assign(e)):void 0===t.popup&&(this.logger.verbosePii("Opening popup window to: "+e),o=this.openSizedPopup(e,t.popupName,t.popupWindowAttributes)),o)return o.focus&&o.focus(),this.currentWindow=o,window.addEventListener("beforeunload",this.unloadWindow),o;throw P.createEmptyWindowCreatedError()}catch(e){throw this.logger.error("error opening popup "+e.message),this.browserStorage.setInteractionInProgress(!1),P.createPopupWindowError(e.toString())}},nb.prototype.openSizedPopup=function(e,t,o){var r=window.screenLeft||window.screenX,n=window.screenTop||window.screenY,i=window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth,a=window.innerHeight||document.documentElement.clientHeight||document.body.clientHeight,s=null==(s=o.popupSize)?void 0:s.width,c=null==(c=o.popupSize)?void 0:c.height,u=null==(u=o.popupPosition)?void 0:u.top,o=null==(o=o.popupPosition)?void 0:o.left;return(!s||s<0||i<s)&&(this.logger.verbose("Default popup window width used. Window width not configured or invalid."),s=Jw.POPUP_WIDTH),(!c||c<0||a<c)&&(this.logger.verbose("Default popup window height used. Window height not configured or invalid."),c=Jw.POPUP_HEIGHT),(!u||u<0||a<u)&&(this.logger.verbose("Default popup window top position used. Window top not configured or invalid."),u=Math.max(0,a/2-Jw.POPUP_HEIGHT/2+n)),(!o||o<0||i<o)&&(this.logger.verbose("Default popup window left position used. Window left not configured or invalid."),o=Math.max(0,i/2-Jw.POPUP_WIDTH/2+r)),window.open(e,t,"width="+s+", height="+c+", top="+u+", left="+o+", scrollbars=yes")},nb.prototype.unloadWindow=function(e){this.browserStorage.cleanRequestByInteractionType(O.Popup),this.currentWindow&&this.currentWindow.close(),e.preventDefault()},nb.prototype.cleanPopup=function(e){e&&e.close(),window.removeEventListener("beforeunload",this.unloadWindow),this.browserStorage.setInteractionInProgress(!1)},nb.prototype.generatePopupName=function(e,t){return Jw.POPUP_NAME_PREFIX+"."+this.config.auth.clientId+"."+e.join("-")+"."+t+"."+this.correlationId},nb.prototype.generateLogoutPopupName=function(e){e=e.account&&e.account.homeAccountId;return Jw.POPUP_NAME_PREFIX+"."+this.config.auth.clientId+"."+e+"."+this.correlationId};var ob,rb=nb;function nb(e,t,o,r,n,i,a,s,c,u){e=ob.call(this,e,t,o,r,n,i,a,c,u)||this;return e.unloadWindow=e.unloadWindow.bind(e),e.nativeStorage=s,e}ab.prototype.navigateInternal=function(e,t){return ab.defaultNavigateWindow(e,t)},ab.prototype.navigateExternal=function(e,t){return ab.defaultNavigateWindow(e,t)},ab.defaultNavigateWindow=function(e,t){return t.noHistory?window.location.replace(e):window.location.assign(e),new Promise(function(e){setTimeout(function(){e(!0)},t.timeout)})};var ib=ab;function ab(){}var sb=6e4,cb=6e3,ub=3e4,lb=2e3;Dg(pb,hb=M0),pb.prototype.initiateAuthRequest=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){switch(e.label){case 0:if(this.performanceClient.addQueueMeasurement(A.SilentHandlerInitiateAuthRequest,this.authCodeRequest.correlationId),k.isEmpty(t))throw this.logger.info("Navigate url is empty"),P.createEmptyNavigationUriError();return this.navigateFrameWait?(this.performanceClient.setPreQueueTime(A.SilentHandlerLoadFrame,this.authCodeRequest.correlationId),[4,this.loadFrame(t)]):[3,2];case 1:return[2,e.sent()];case 2:return[2,this.loadFrameSync(t)]}})})},pb.prototype.monitorIframeForHash=function(a,e){var s=this;return this.performanceClient.addQueueMeasurement(A.SilentHandlerMonitorIframeForHash,this.authCodeRequest.correlationId),new Promise(function(o,r){e<cb&&s.logger.warning("system.loadFrameTimeout or system.iframeHashTimeout set to lower ("+e+"ms) than the default ("+cb+"ms). This may result in timeouts.");var n=window.performance.now()+e,i=setInterval(function(){if(window.performance.now()>n)s.removeHiddenIframe(a),clearInterval(i),r(P.createMonitorIframeTimeoutError());else{var e=E.EMPTY_STRING,t=a.contentWindow;try{e=t?t.location.href:E.EMPTY_STRING}catch(e){}k.isEmpty(e)||(e=t?t.location.hash:E.EMPTY_STRING,e_.hashContainsKnownProperties(e)&&(s.removeHiddenIframe(a),clearInterval(i),o(e)))}},s.pollIntervalMilliseconds)})},pb.prototype.loadFrame=function(r){var n=this;return this.performanceClient.addQueueMeasurement(A.SilentHandlerLoadFrame,this.authCodeRequest.correlationId),new Promise(function(e,t){var o=n.createHiddenIframe();setTimeout(function(){o?(o.src=r,e(o)):t("Unable to load iframe")},n.navigateFrameWait)})},pb.prototype.loadFrameSync=function(e){var t=this.createHiddenIframe();return t.src=e,t},pb.prototype.createHiddenIframe=function(){var e=document.createElement("iframe");return e.style.visibility="hidden",e.style.position="absolute",e.style.width=e.style.height="0",e.style.border="0",e.setAttribute("sandbox","allow-scripts allow-same-origin allow-forms"),document.getElementsByTagName("body")[0].appendChild(e),e},pb.prototype.removeHiddenIframe=function(e){document.body===e.parentNode&&document.body.removeChild(e)};var hb,db=pb;function pb(e,t,o,r,n,i){e=hb.call(this,e,t,o,r,i)||this;return e.navigateFrameWait=n.navigateFrameWait,e.pollIntervalMilliseconds=n.pollIntervalMilliseconds,e}Dg(mb,fb=s),mb.prototype.acquireToken=function(i){return _(this,void 0,void 0,function(){var t,o,r,n;return w(this,function(e){switch(e.label){case 0:if(this.performanceClient.addQueueMeasurement(A.SilentIframeClientAcquireToken,i.correlationId),this.logger.verbose("acquireTokenByIframe called"),t=this.performanceClient.startMeasurement(A.SilentIframeClientAcquireToken,i.correlationId),k.isEmpty(i.loginHint)&&k.isEmpty(i.sid)&&(!i.account||k.isEmpty(i.account.username))&&this.logger.warning("No user hint provided. The authorization server may need more information to complete this request."),i.prompt&&i.prompt!==rm.NONE&&i.prompt!==rm.NO_SESSION)throw t.endMeasurement({success:!1}),P.createSilentPromptValueError(i.prompt);return this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,i.correlationId),[4,this.initializeAuthorizationRequest(v(v({},i),{prompt:i.prompt||rm.NONE}),O.Silent)];case 1:o=e.sent(),this.browserStorage.updateCacheEntries(o.state,o.nonce,o.authority,o.loginHint||E.EMPTY_STRING,o.account||null),r=this.initializeServerTelemetryManager(this.apiId),e.label=2;case 2:return e.trys.push([2,5,,6]),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,i.correlationId),[4,this.createAuthCodeClient(r,o.authority,o.azureCloudOptions)];case 3:return n=e.sent(),this.logger.verbose("Auth code client created"),this.performanceClient.setPreQueueTime(A.SilentIframeClientTokenHelper,i.correlationId),[4,this.silentTokenHelper(n,o).then(function(e){return t.endMeasurement({success:!0,fromCache:!1,requestId:e.requestId}),e})];case 4:return[2,e.sent()];case 5:throw(n=e.sent())instanceof T&&n.setCorrelationId(this.correlationId),r.cacheFailedRequest(n),this.browserStorage.cleanRequestByState(o.state),t.endMeasurement({errorCode:n instanceof T&&n.errorCode||void 0,subErrorCode:n instanceof T&&n.subError||void 0,success:!1}),n;case 6:return[2]}})})},mb.prototype.logout=function(){return Promise.reject(P.createSilentLogoutUnsupportedError())},mb.prototype.silentTokenHelper=function(u,l){return _(this,void 0,void 0,function(){var t,o,r,n,i,a,s,c=this;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.SilentIframeClientTokenHelper,l.correlationId),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationCodeRequest,l.correlationId),[4,this.initializeAuthorizationCodeRequest(l)];case 1:return t=e.sent(),this.performanceClient.setPreQueueTime(A.GetAuthCodeUrl,l.correlationId),[4,u.getAuthCodeUrl(v(v({},l),{nativeBroker:J0.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,l.authenticationScheme)}))];case 2:return r=e.sent(),o=new db(u,this.browserStorage,t,this.logger,this.config.system,this.performanceClient),this.performanceClient.setPreQueueTime(A.SilentHandlerInitiateAuthRequest,l.correlationId),[4,o.initiateAuthRequest(r)];case 3:return r=e.sent(),this.performanceClient.setPreQueueTime(A.SilentHandlerMonitorIframeForHash,l.correlationId),[4,o.monitorIframeForHash(r,this.config.system.iframeHashTimeout)];case 4:if(n=e.sent(),a=e_.getDeserializedHash(n),i=this.validateAndExtractStateFromHash(a,O.Silent,t.correlationId),a.accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),this.nativeMessageHandler)return a=new Q0(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.apiId,this.performanceClient,this.nativeMessageHandler,a.accountId,this.browserStorage,this.correlationId),s=Jv.parseRequestState(this.browserCrypto,i).userRequestState,[2,a.acquireToken(v(v({},l),{state:s,prompt:l.prompt||rm.NONE})).finally(function(){c.browserStorage.cleanRequestByState(i)})];throw P.createNativeConnectionNotEstablishedError()}return this.performanceClient.setPreQueueTime(A.HandleCodeResponseFromHash,l.correlationId),[2,o.handleCodeResponseFromHash(n,i,u.authority,this.networkClient)]}})})};var fb,gb=mb;function mb(e,t,o,r,n,i,a,s,c,u,l){e=fb.call(this,e,t,o,r,n,i,s,u,l)||this;return e.apiId=a,e.nativeStorage=c,e}Dg(_b,yb=s),_b.prototype.acquireToken=function(s){return _(this,void 0,void 0,function(){var t,o,r,n,i,a=this;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.SilentRefreshClientAcquireToken,s.correlationId),this.performanceClient.setPreQueueTime(A.InitializeBaseRequest,s.correlationId),o=[v({},s)],[4,this.initializeBaseRequest(s,s.account)];case 1:return t=v.apply(void 0,o.concat([e.sent()])),r=this.performanceClient.startMeasurement(A.SilentRefreshClientAcquireToken,t.correlationId),n=this.initializeServerTelemetryManager(Qw.acquireTokenSilent_silentFlow),[4,this.createRefreshTokenClient(n,t.authority,t.azureCloudOptions)];case 2:return i=e.sent(),this.logger.verbose("Refresh token client created"),this.performanceClient.setPreQueueTime(A.RefreshTokenClientAcquireTokenByRefreshToken,s.correlationId),[2,i.acquireTokenByRefreshToken(t).then(function(e){return r.endMeasurement({success:!0,fromCache:e.fromCache,requestId:e.requestId}),e}).catch(function(e){throw e instanceof T&&e.setCorrelationId(a.correlationId),n.cacheFailedRequest(e),r.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})]}})})},_b.prototype.logout=function(){return Promise.reject(P.createSilentLogoutUnsupportedError())},_b.prototype.createRefreshTokenClient=function(o,r,n){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(o,r,n)];case 1:return t=e.sent(),[2,new m_(t,this.performanceClient)]}})})};var yb,vb=_b;function _b(){return null!==yb&&yb.apply(this,arguments)||this}bb.prototype.addEventCallback=function(e){var t;return"undefined"!=typeof window?(t=this.browserCrypto.createNewGuid(),this.eventCallbacks.set(t,e),this.logger.verbose("Event callback registered with id: "+t),t):null},bb.prototype.removeEventCallback=function(e){this.eventCallbacks.delete(e),this.logger.verbose("Event callback "+e+" removed.")},bb.prototype.enableAccountStorageEvents=function(){"undefined"!=typeof window&&(this.listeningToStorageEvents?this.logger.verbose("Account storage listener already registered."):(this.logger.verbose("Adding account storage listener."),this.listeningToStorageEvents=!0,window.addEventListener("storage",this.handleAccountCacheChange)))},bb.prototype.disableAccountStorageEvents=function(){"undefined"!=typeof window&&(this.listeningToStorageEvents?(this.logger.verbose("Removing account storage listener."),window.removeEventListener("storage",this.handleAccountCacheChange),this.listeningToStorageEvents=!1):this.logger.verbose("No account storage listener registered."))},bb.prototype.emitEvent=function(o,e,t,r){var n,i=this;"undefined"!=typeof window&&(n={eventType:o,interactionType:e||null,payload:t||null,error:r||null,timestamp:Date.now()},this.logger.info("Emitting event: "+o),this.eventCallbacks.forEach(function(e,t){i.logger.verbose("Emitting event to callback "+t+": "+o),e.apply(null,[n])}))},bb.prototype.handleAccountCacheChange=function(e){try{var t,o,r=e.newValue||e.oldValue;r&&"object"==typeof(t=JSON.parse(r))&&ov.isAccountEntity(t)&&(o=av.toObject(new ov,t).getAccountInfo(),!e.oldValue&&e.newValue?(this.logger.info("Account was added to cache in a different window"),this.emitEvent(x.ACCOUNT_ADDED,void 0,o)):!e.newValue&&e.oldValue&&(this.logger.info("Account was removed from cache in a different window"),this.emitEvent(x.ACCOUNT_REMOVED,void 0,o)))}catch(e){}};var wb=bb;function bb(e,t){this.eventCallbacks=new Map,this.logger=e,this.browserCrypto=t,this.listeningToStorageEvents=!1,this.handleAccountCacheChange=this.handleAccountCacheChange.bind(this)}Sb.decimalToHex=function(e){for(var t=e.toString(16);t.length<2;)t="0"+t;return t};var Cb=Sb;function Sb(){}Tb.prototype.generateGuid=function(){try{var e=new Uint8Array(16);return this.cryptoObj.getRandomValues(e),e[6]|=64,e[6]&=79,e[8]|=128,e[8]&=191,Cb.decimalToHex(e[0])+Cb.decimalToHex(e[1])+Cb.decimalToHex(e[2])+Cb.decimalToHex(e[3])+"-"+Cb.decimalToHex(e[4])+Cb.decimalToHex(e[5])+"-"+Cb.decimalToHex(e[6])+Cb.decimalToHex(e[7])+"-"+Cb.decimalToHex(e[8])+Cb.decimalToHex(e[9])+"-"+Cb.decimalToHex(e[10])+Cb.decimalToHex(e[11])+Cb.decimalToHex(e[12])+Cb.decimalToHex(e[13])+Cb.decimalToHex(e[14])+Cb.decimalToHex(e[15])}catch(e){for(var t="xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx",o="0123456789abcdef",r=0,n=E.EMPTY_STRING,i=0;i<36;i++)"-"!==t[i]&&"4"!==t[i]&&(r=16*Math.random()|0),n+="x"===t[i]?o[r]:"y"===t[i]?o[r=r&3|8]:t[i];return n}},Tb.prototype.isGuid=function(e){return/^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(e)};var Eb=Tb;function Tb(e){this.cryptoObj=e}kb.stringToUtf8Arr=function(e){for(var t,o=0,r=e.length,n=0;n<r;n++)o+=(t=e.charCodeAt(n))<128?1:t<2048?2:t<65536?3:t<2097152?4:t<67108864?5:6;for(var i=new Uint8Array(o),a=0,s=0;a<o;s++)(t=e.charCodeAt(s))<128?i[a++]=t:(t<2048?i[a++]=192+(t>>>6):(t<65536?i[a++]=224+(t>>>12):(t<2097152?i[a++]=240+(t>>>18):(t<67108864?i[a++]=248+(t>>>24):(i[a++]=252+(t>>>30),i[a++]=128+(t>>>24&63)),i[a++]=128+(t>>>18&63)),i[a++]=128+(t>>>12&63)),i[a++]=128+(t>>>6&63)),i[a++]=128+(63&t));return i},kb.stringToArrayBuffer=function(e){for(var t=new ArrayBuffer(e.length),o=new Uint8Array(t),r=0;r<e.length;r++)o[r]=e.charCodeAt(r);return t},kb.utf8ArrToString=function(e){for(var t,o=E.EMPTY_STRING,r=e.length,n=0;n<r;n++)t=e[n],o+=String.fromCharCode(251<t&&t<254&&n+5<r?1073741824*(t-252)+(e[++n]-128<<24)+(e[++n]-128<<18)+(e[++n]-128<<12)+(e[++n]-128<<6)+e[++n]-128:247<t&&t<252&&n+4<r?(t-248<<24)+(e[++n]-128<<18)+(e[++n]-128<<12)+(e[++n]-128<<6)+e[++n]-128:239<t&&t<248&&n+3<r?(t-240<<18)+(e[++n]-128<<12)+(e[++n]-128<<6)+e[++n]-128:223<t&&t<240&&n+2<r?(t-224<<12)+(e[++n]-128<<6)+e[++n]-128:191<t&&t<224&&n+1<r?(t-192<<6)+e[++n]-128:t);return o},kb.getSortedObjectString=function(e){return JSON.stringify(e,Object.keys(e).sort())};var Ib=kb;function kb(){}Pb.prototype.urlEncode=function(e){return encodeURIComponent(this.encode(e).replace(/=/g,E.EMPTY_STRING).replace(/\+/g,"-").replace(/\//g,"_"))},Pb.prototype.urlEncodeArr=function(e){return this.base64EncArr(e).replace(/=/g,E.EMPTY_STRING).replace(/\+/g,"-").replace(/\//g,"_")},Pb.prototype.encode=function(e){e=Ib.stringToUtf8Arr(e);return this.base64EncArr(e)},Pb.prototype.base64EncArr=function(e){for(var t,o=(3-e.length%3)%3,r=E.EMPTY_STRING,n=e.length,i=0,a=0;a<n;a++)i|=e[a]<<(16>>>(t=a%3)&24),2!=t&&e.length-a!=1||(r+=String.fromCharCode(this.uint6ToB64(i>>>18&63),this.uint6ToB64(i>>>12&63),this.uint6ToB64(i>>>6&63),this.uint6ToB64(63&i)),i=0);return 0==o?r:r.substring(0,r.length-o)+(1==o?"=":"==")},Pb.prototype.uint6ToB64=function(e){return e<26?e+65:e<52?e+71:e<62?e-4:62===e?43:63===e?47:65};var Ab=Pb;function Pb(){}Rb.prototype.decode=function(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw new Error("Invalid base64 string")}e=this.base64DecToArr(t);return Ib.utf8ArrToString(e)},Rb.prototype.base64DecToArr=function(e,t){for(var o,r=e.replace(/[^A-Za-z0-9\+\/]/g,E.EMPTY_STRING),n=r.length,i=t?Math.ceil((3*n+1>>>2)/t)*t:3*n+1>>>2,a=new Uint8Array(i),s=void 0,c=0,u=0,l=0;l<n;l++)if(o=3&l,c|=this.b64ToUint6(r.charCodeAt(l))<<18-6*o,3==o||n-l==1){for(s=0;s<3&&u<i;s++,u++)a[u]=c>>>(16>>>s&24)&255;c=0}return a},Rb.prototype.b64ToUint6=function(e){return 64<e&&e<91?e-65:96<e&&e<123?e-71:47<e&&e<58?e+4:43===e?62:47===e?63:0};var Ob=Rb;function Rb(){}Mb.prototype.generateCodes=function(){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:return t=this.generateCodeVerifier(),[4,this.generateCodeChallengeFromVerifier(t)];case 1:return o=e.sent(),[2,{verifier:t,challenge:o}]}})})},Mb.prototype.generateCodeVerifier=function(){try{var e=new Uint8Array(32);return this.cryptoObj.getRandomValues(e),this.base64Encode.urlEncodeArr(e)}catch(e){throw P.createPkceNotGeneratedError(e)}},Mb.prototype.generateCodeChallengeFromVerifier=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),[4,this.cryptoObj.sha256Digest(o)];case 1:return t=e.sent(),[2,this.base64Encode.urlEncodeArr(new Uint8Array(t))];case 2:throw t=e.sent(),P.createPkceNotGeneratedError(t);case 3:return[2]}})})};var xb=Mb;function Mb(e){this.base64Encode=new Ab,this.cryptoObj=e}Lb.prototype.getRandomValues=function(e){return window.crypto.getRandomValues(e)},Lb.prototype.generateKey=function(t,o,r){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.crypto.subtle.generateKey(t,o,r)]})})},Lb.prototype.exportKey=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.crypto.subtle.exportKey(o0,t)]})})},Lb.prototype.importKey=function(t,o,r,n){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.crypto.subtle.importKey(o0,t,o,r,n)]})})},Lb.prototype.sign=function(t,o,r){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.crypto.subtle.sign(t,o,r)]})})},Lb.prototype.digest=function(t,o){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.crypto.subtle.digest(t,o)]})})};var Nb=Lb;function Lb(){}qb.prototype.initPrng=function(e){return window.msrCrypto.initPrng(Ug(e))},qb.prototype.getRandomValues=function(e){return window.msrCrypto.getRandomValues(e)},qb.prototype.generateKey=function(t,o,r){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.msrCrypto.subtle.generateKey(t,o,r)]})})},qb.prototype.exportKey=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.msrCrypto.subtle.exportKey(o0,t)]})})},qb.prototype.importKey=function(t,o,r,n){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.msrCrypto.subtle.importKey(o0,t,o,r,n)]})})},qb.prototype.sign=function(t,o,r){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.msrCrypto.subtle.sign(t,o,r)]})})},qb.prototype.digest=function(t,o){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,window.msrCrypto.subtle.digest(t,o)]})})};var Db=qb;function qb(){}jb.prototype.getRandomValues=function(e){return window.msCrypto.getRandomValues(e)},jb.prototype.generateKey=function(r,n,i){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,new Promise(function(t,o){var e=window.msCrypto.subtle.generateKey(r,n,i);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){o(e)})})]})})},jb.prototype.exportKey=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,new Promise(function(o,r){var e=window.msCrypto.subtle.exportKey(o0,t);e.addEventListener("complete",function(e){var t=e.target.result,t=Ib.utf8ArrToString(new Uint8Array(t)).replace(/\r/g,E.EMPTY_STRING).replace(/\n/g,E.EMPTY_STRING).replace(/\t/g,E.EMPTY_STRING).split(" ").join(E.EMPTY_STRING).replace("\0",E.EMPTY_STRING);try{o(JSON.parse(t))}catch(e){r(e)}}),e.addEventListener("error",function(e){r(e)})})]})})},jb.prototype.importKey=function(o,n,i,a){return _(this,void 0,void 0,function(){var t,r;return w(this,function(e){return t=Ib.getSortedObjectString(o),r=Ib.stringToArrayBuffer(t),[2,new Promise(function(t,o){var e=window.msCrypto.subtle.importKey(o0,r,n,i,a);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){o(e)})})]})})},jb.prototype.sign=function(r,n,i){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,new Promise(function(t,o){var e=window.msCrypto.subtle.sign(r,n,i);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){o(e)})})]})})},jb.prototype.digest=function(r,n){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,new Promise(function(t,o){var e=window.msCrypto.subtle.digest(r,n.buffer);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){o(e)})})]})})};var Ub=jb;function jb(){}var Hb="SHA-256",Bb=new Uint8Array([1,0,1]),Fb=(zb.prototype.hasIECrypto=function(){return"msCrypto"in window},zb.prototype.hasBrowserCrypto=function(){return"crypto"in window},zb.prototype.hasMsrCrypto=function(){return"msrCrypto"in window},zb.prototype.sha256Digest=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){return t=Ib.stringToUtf8Arr(o),[2,this.subtleCrypto.digest({name:Hb},t)]})})},zb.prototype.getRandomValues=function(e){return this.subtleCrypto.getRandomValues(e)},zb.prototype.generateKeyPair=function(t,o){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,this.subtleCrypto.generateKey(this.keygenAlgorithmOptions,t,o)]})})},zb.prototype.exportJwk=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,this.subtleCrypto.exportKey(t)]})})},zb.prototype.importJwk=function(t,o,r){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,this.subtleCrypto.importKey(t,this.keygenAlgorithmOptions,o,r)]})})},zb.prototype.sign=function(t,o){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,this.subtleCrypto.sign(this.keygenAlgorithmOptions,t,o)]})})},zb);function zb(e,t){if(this.logger=e,this.cryptoOptions=t,this.hasBrowserCrypto())this.logger.verbose("BrowserCrypto: modern crypto interface available"),this.subtleCrypto=new Nb;else if(this.hasIECrypto())this.logger.verbose("BrowserCrypto: MS crypto interface available"),this.subtleCrypto=new Ub;else{if(!this.hasMsrCrypto()||null==(e=this.cryptoOptions)||!e.useMsrCrypto)throw this.hasMsrCrypto()&&this.logger.info("BrowserCrypto: MSR Crypto interface available but system.cryptoOptions.useMsrCrypto not enabled"),this.logger.error("BrowserCrypto: No crypto interfaces available."),P.createCryptoNotAvailableError("Browser crypto, msCrypto, or msrCrypto interfaces not available.");this.logger.verbose("BrowserCrypto: MSR crypto interface available"),this.subtleCrypto=new Db}if(this.subtleCrypto.initPrng){if(this.logger.verbose("BrowserCrypto: Interface requires entropy"),null==(t=this.cryptoOptions)||!t.entropy)throw this.logger.error("BrowserCrypto: Interface requires entropy but none provided."),d0.createEntropyNotProvided();this.logger.verbose("BrowserCrypto: Entropy provided"),this.subtleCrypto.initPrng(this.cryptoOptions.entropy)}this.keygenAlgorithmOptions={name:"RSASSA-PKCS1-v1_5",hash:Hb,modulusLength:2048,publicExponent:Bb}}Gb.prototype.open=function(){return _(this,void 0,void 0,function(){var r=this;return w(this,function(e){return[2,new Promise(function(t,e){var o=window.indexedDB.open(r.dbName,r.version);o.addEventListener("upgradeneeded",function(e){e.target.result.createObjectStore(r.tableName)}),o.addEventListener("success",function(e){r.db=e.target.result,r.dbOpen=!0,t()}),o.addEventListener("error",function(){return e(P.createDatabaseUnavailableError())})})]})})},Gb.prototype.closeConnection=function(){var e=this.db;e&&this.dbOpen&&(e.close(),this.dbOpen=!1)},Gb.prototype.validateDbIsOpen=function(){return _(this,void 0,void 0,function(){return w(this,function(e){switch(e.label){case 0:return this.dbOpen?[3,2]:[4,this.open()];case 1:return[2,e.sent()];case 2:return[2]}})})},Gb.prototype.getItem=function(n){return _(this,void 0,void 0,function(){var r=this;return w(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(t,o){if(!r.db)return o(P.createDatabaseNotOpenError());var e=r.db.transaction([r.tableName],"readonly").objectStore(r.tableName).get(n);e.addEventListener("success",function(e){r.closeConnection(),t(e.target.result)}),e.addEventListener("error",function(e){r.closeConnection(),o(e)})})]}})})},Gb.prototype.setItem=function(n,i){return _(this,void 0,void 0,function(){var r=this;return w(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(e,t){if(!r.db)return t(P.createDatabaseNotOpenError());var o=r.db.transaction([r.tableName],"readwrite").objectStore(r.tableName).put(i,n);o.addEventListener("success",function(){r.closeConnection(),e()}),o.addEventListener("error",function(e){r.closeConnection(),t(e)})})]}})})},Gb.prototype.removeItem=function(n){return _(this,void 0,void 0,function(){var r=this;return w(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(e,t){if(!r.db)return t(P.createDatabaseNotOpenError());var o=r.db.transaction([r.tableName],"readwrite").objectStore(r.tableName).delete(n);o.addEventListener("success",function(){r.closeConnection(),e()}),o.addEventListener("error",function(e){r.closeConnection(),t(e)})})]}})})},Gb.prototype.getKeys=function(){return _(this,void 0,void 0,function(){var r=this;return w(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(t,o){if(!r.db)return o(P.createDatabaseNotOpenError());var e=r.db.transaction([r.tableName],"readonly").objectStore(r.tableName).getAllKeys();e.addEventListener("success",function(e){r.closeConnection(),t(e.target.result)}),e.addEventListener("error",function(e){r.closeConnection(),o(e)})})]}})})},Gb.prototype.containsKey=function(n){return _(this,void 0,void 0,function(){var r=this;return w(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(t,o){if(!r.db)return o(P.createDatabaseNotOpenError());var e=r.db.transaction([r.tableName],"readonly").objectStore(r.tableName).count(n);e.addEventListener("success",function(e){r.closeConnection(),t(1===e.target.result)}),e.addEventListener("error",function(e){r.closeConnection(),o(e)})})]}})})},Gb.prototype.deleteDatabase=function(){return _(this,void 0,void 0,function(){return w(this,function(e){return this.db&&this.dbOpen&&this.closeConnection(),[2,new Promise(function(e,t){var o=window.indexedDB.deleteDatabase(r0);o.addEventListener("success",function(){return e(!0)}),o.addEventListener("blocked",function(){return e(!0)}),o.addEventListener("error",function(){return t(!1)})})]})})};var Kb=Gb;function Gb(){this.dbName=r0,this.version=1,this.tableName="msal.db.keys",this.dbOpen=!1}Zb.prototype.handleDatabaseAccessError=function(e){if(!(e instanceof P&&e.errorCode===Dw.code))throw e;this.logger.error("Could not access persistent storage. This may be caused by browser privacy features which block persistent storage in third-party contexts.")},Zb.prototype.getItem=function(r){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:if(t=this.inMemoryCache.getItem(r))return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("Queried item not found in in-memory cache, now querying persistent storage."),[4,this.indexedDBCache.getItem(r)];case 2:return[2,e.sent()];case 3:return o=e.sent(),this.handleDatabaseAccessError(o),[3,4];case 4:return[2,t]}})})},Zb.prototype.setItem=function(o,r){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:this.inMemoryCache.setItem(o,r),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.indexedDBCache.setItem(o,r)];case 2:return e.sent(),[3,4];case 3:return t=e.sent(),this.handleDatabaseAccessError(t),[3,4];case 4:return[2]}})})},Zb.prototype.removeItem=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:this.inMemoryCache.removeItem(o),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.indexedDBCache.removeItem(o)];case 2:return e.sent(),[3,4];case 3:return t=e.sent(),this.handleDatabaseAccessError(t),[3,4];case 4:return[2]}})})},Zb.prototype.getKeys=function(){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:if(0!==(t=this.inMemoryCache.getKeys()).length)return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("In-memory cache is empty, now querying persistent storage."),[4,this.indexedDBCache.getKeys()];case 2:return[2,e.sent()];case 3:return o=e.sent(),this.handleDatabaseAccessError(o),[3,4];case 4:return[2,t]}})})},Zb.prototype.containsKey=function(r){return _(this,void 0,void 0,function(){var t,o;return w(this,function(e){switch(e.label){case 0:if(t=this.inMemoryCache.containsKey(r))return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("Key not found in in-memory cache, now querying persistent storage."),[4,this.indexedDBCache.containsKey(r)];case 2:return[2,e.sent()];case 3:return o=e.sent(),this.handleDatabaseAccessError(o),[3,4];case 4:return[2,t]}})})},Zb.prototype.clearInMemory=function(){this.logger.verbose("Deleting in-memory keystore "+this.storeName),this.inMemoryCache.clear(),this.logger.verbose("In-memory keystore "+this.storeName+" deleted")},Zb.prototype.clearPersistent=function(){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),this.logger.verbose("Deleting persistent keystore"),[4,this.indexedDBCache.deleteDatabase()];case 1:return(t=e.sent())&&this.logger.verbose("Persistent keystore deleted"),[2,t];case 2:return t=e.sent(),this.handleDatabaseAccessError(t),[2,!1];case 3:return[2]}})})};var Yb,Wb=Zb;function Zb(e,t){this.inMemoryCache=new m0,this.indexedDBCache=new Kb,this.logger=e,this.storeName=t}(sr=Yb=Yb||{}).asymmetricKeys="asymmetricKeys",sr.symmetricKeys="symmetricKeys";Vb.prototype.clear=function(){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:this.asymmetricKeys.clearInMemory(),this.symmetricKeys.clearInMemory(),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.asymmetricKeys.clearPersistent()];case 2:return e.sent(),[2,!0];case 3:return(t=e.sent())instanceof Error?this.logger.error("Clearing keystore failed with error: "+t.message):this.logger.error("Clearing keystore failed with unknown error"),[2,!1];case 4:return[2]}})})};var Qb=Vb;function Vb(e){this.logger=e,this.asymmetricKeys=new Wb(this.logger,Yb.asymmetricKeys),this.symmetricKeys=new Wb(this.logger,Yb.symmetricKeys)}Xb.prototype.createNewGuid=function(){return this.guidGenerator.generateGuid()},Xb.prototype.base64Encode=function(e){return this.b64Encode.encode(e)},Xb.prototype.base64Decode=function(e){return this.b64Decode.decode(e)},Xb.prototype.generatePkceCodes=function(){return _(this,void 0,void 0,function(){return w(this,function(e){return[2,this.pkceGenerator.generateCodes()]})})},Xb.prototype.getPublicKeyThumbprint=function(a){var s;return _(this,void 0,void 0,function(){var t,o,r,n,i;return w(this,function(e){switch(e.label){case 0:return t=null==(s=this.performanceClient)?void 0:s.startMeasurement(A.CryptoOptsGetPublicKeyThumbprint,a.correlationId),[4,this.browserCrypto.generateKeyPair(Xb.EXTRACTABLE,Xb.POP_KEY_USAGES)];case 1:return o=e.sent(),[4,this.browserCrypto.exportJwk(o.publicKey)];case 2:return n=e.sent(),n={e:n.e,kty:n.kty,n:n.n},n=Ib.getSortedObjectString(n),[4,this.hashString(n)];case 3:return r=e.sent(),[4,this.browserCrypto.exportJwk(o.privateKey)];case 4:return n=e.sent(),[4,this.browserCrypto.importJwk(n,!1,["sign"])];case 5:return i=e.sent(),[4,this.cache.asymmetricKeys.setItem(r,{privateKey:i,publicKey:o.publicKey,requestMethod:a.resourceRequestMethod,requestUri:a.resourceRequestUri})];case 6:return e.sent(),t&&t.endMeasurement({success:!0}),[2,r]}})})},Xb.prototype.removeTokenBindingKey=function(t){return _(this,void 0,void 0,function(){return w(this,function(e){switch(e.label){case 0:return[4,this.cache.asymmetricKeys.removeItem(t)];case 1:return e.sent(),[4,this.cache.asymmetricKeys.containsKey(t)];case 2:return[2,!e.sent()]}})})},Xb.prototype.clearKeystore=function(){return _(this,void 0,void 0,function(){return w(this,function(e){switch(e.label){case 0:return[4,this.cache.clear()];case 1:return[2,e.sent()]}})})},Xb.prototype.signJwt=function(s,c,u){var l;return _(this,void 0,void 0,function(){var t,o,r,n,i,a;return w(this,function(e){switch(e.label){case 0:return t=null==(l=this.performanceClient)?void 0:l.startMeasurement(A.CryptoOptsSignJwt,u),[4,this.cache.asymmetricKeys.getItem(c)];case 1:if(o=e.sent())return[4,this.browserCrypto.exportJwk(o.publicKey)];throw P.createSigningKeyNotFoundInStorageError(c);case 2:return i=e.sent(),r=Ib.getSortedObjectString(i),n=this.b64Encode.urlEncode(JSON.stringify({kid:c})),n=B_.getShrHeaderString({kid:n,alg:i.alg}),i=this.b64Encode.urlEncode(n),s.cnf={jwk:JSON.parse(r)},n=this.b64Encode.urlEncode(JSON.stringify(s)),r=i+"."+n,i=Ib.stringToArrayBuffer(r),[4,this.browserCrypto.sign(o.privateKey,i)];case 3:return n=e.sent(),i=this.b64Encode.urlEncodeArr(new Uint8Array(n)),a=r+"."+i,t&&t.endMeasurement({success:!0}),[2,a]}})})},Xb.prototype.hashString=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(e.label){case 0:return[4,this.browserCrypto.sha256Digest(o)];case 1:return t=e.sent(),t=new Uint8Array(t),[2,this.b64Encode.urlEncodeArr(t)]}})})},Xb.POP_KEY_USAGES=["sign","verify"],Xb.EXTRACTABLE=!0;var Jb=Xb;function Xb(e,t,o){this.logger=e,this.browserCrypto=new Fb(this.logger,o),this.b64Encode=new Ab,this.b64Decode=new Ob,this.guidGenerator=new Eb(this.browserCrypto),this.pkceGenerator=new xb(this.browserCrypto),this.cache=new Qb(this.logger),this.performanceClient=t}eC.makeMeasureName=function(e,t){return"msal.measure."+e+"."+t},eC.makeStartMark=function(e,t){return"msal.start."+e+"."+t},eC.makeEndMark=function(e,t){return"msal.end."+e+"."+t},eC.supportsBrowserPerformance=function(){return"undefined"!=typeof window&&void 0!==window.performance&&"function"==typeof window.performance.mark&&"function"==typeof window.performance.measure&&"function"==typeof window.performance.clearMarks&&"function"==typeof window.performance.clearMeasures&&"function"==typeof window.performance.getEntriesByName},eC.flushMeasurements=function(t,e){if(eC.supportsBrowserPerformance())try{e.forEach(function(e){e=eC.makeMeasureName(e.name,t);0<window.performance.getEntriesByName(e,"measure").length&&(window.performance.clearMeasures(e),window.performance.clearMarks(eC.makeStartMark(e,t)),window.performance.clearMarks(eC.makeEndMark(e,t)))})}catch(e){}},eC.prototype.startMeasurement=function(){if(eC.supportsBrowserPerformance())try{window.performance.mark(this.startMark)}catch(e){}},eC.prototype.endMeasurement=function(){if(eC.supportsBrowserPerformance())try{window.performance.mark(this.endMark),window.performance.measure(this.measureName,this.startMark,this.endMark)}catch(e){}},eC.prototype.flushMeasurement=function(){if(eC.supportsBrowserPerformance())try{var e,t=window.performance.getEntriesByName(this.measureName,"measure");if(0<t.length)return e=t[0].duration,window.performance.clearMeasures(this.measureName),window.performance.clearMarks(this.startMark),window.performance.clearMarks(this.endMark),e}catch(e){}return null};var $b=eC;function eC(e,t){this.correlationId=t,this.measureName=eC.makeMeasureName(e,t),this.startMark=eC.makeStartMark(e,t),this.endMark=eC.makeEndMark(e,t)}Dg(rC,tC=i),rC.prototype.startPerformanceMeasuremeant=function(e,t){return new $b(e,t)},rC.prototype.generateId=function(){return this.guidGenerator.generateGuid()},rC.prototype.getPageVisibility=function(){var e;return(null==(e=document.visibilityState)?void 0:e.toString())||null},rC.prototype.deleteIncompleteSubMeasurements=function(e){var t=this.eventsByCorrelationId.get(e.event.correlationId),o=t&&t.eventId===e.event.eventId,r=[];o&&null!=t&&t.incompleteSubMeasurements&&t.incompleteSubMeasurements.forEach(function(e){r.push(v({},e))}),0<r.length&&$b.flushMeasurements(e.event.correlationId,r)},rC.prototype.supportsBrowserPerformanceNow=function(){return"undefined"!=typeof window&&void 0!==window.performance&&"function"==typeof window.performance.now},rC.prototype.startMeasurement=function(e,t){var o=this,r=this.getPageVisibility(),n=tC.prototype.startMeasurement.call(this,e,t);return v(v({},n),{endMeasurement:function(e){e=n.endMeasurement(v({startPageVisibility:r,endPageVisibility:o.getPageVisibility()},e));return o.deleteIncompleteSubMeasurements(n),e},discardMeasurement:function(){n.discardMeasurement(),o.deleteIncompleteSubMeasurements(n),n.measurement.flushMeasurement()}})},rC.prototype.setPreQueueTime=function(e,t){var o;this.supportsBrowserPerformanceNow()?t?((o=this.preQueueTimeByCorrelationId.get(t))&&(this.logger.trace("BrowserPerformanceClient: Incomplete pre-queue "+o.name+" found",t),this.addQueueMeasurement(o.name,t,void 0,!0)),this.preQueueTimeByCorrelationId.set(t,{name:e,time:window.performance.now()})):this.logger.trace("BrowserPerformanceClient: correlationId for "+e+" not provided, unable to set telemetry queue time"):this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to set telemetry queue time for "+e)},rC.prototype.addQueueMeasurement=function(e,t,o,r){if(this.supportsBrowserPerformanceNow())if(t){var n,i=tC.prototype.getPreQueueTime.call(this,e,t);if(i)return n=window.performance.now(),o=o||tC.prototype.calculateQueuedTime.call(this,i,n),tC.prototype.addQueueMeasurement.call(this,e,t,o,r)}else this.logger.trace("BrowserPerformanceClient: correlationId for "+e+" not provided, unable to add queue measurement");else this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to add queue measurement for "+e)};var tC,oC=rC;function rC(e,t,o,r,n,i,a){e=tC.call(this,e,t,o,r,n,i)||this;return e.browserCrypto=new Fb(e.logger,a),e.guidGenerator=new Eb(e.browserCrypto),e}iC.prototype.loadExternalTokens=function(e,t,o){if(this.logger.info("TokenCache - loadExternalTokens called"),!t.id_token)throw P.createUnableToLoadTokenError("Please ensure server response includes id token.");var r=new nv(t.id_token,this.cryptoObj);if(e.account)var n=this.loadAccount(r,e.account.environment,void 0,void 0,e.account.homeAccountId),i=new Vv(n,this.loadIdToken(r,n.homeAccountId,e.account.environment,e.account.tenantId),this.loadAccessToken(e,t,n.homeAccountId,e.account.environment,e.account.tenantId,o),this.loadRefreshToken(e,t,n.homeAccountId,e.account.environment));else{if(!e.authority)throw P.createUnableToLoadTokenError("Please provide a request with an account or a request with authority.");var a=A_.generateAuthority(e.authority,e.azureCloudOptions),s={protocolMode:this.config.auth.protocolMode,knownAuthorities:this.config.auth.knownAuthorities,cloudDiscoveryMetadata:this.config.auth.cloudDiscoveryMetadata,authorityMetadata:this.config.auth.authorityMetadata,skipAuthorityMetadataCache:this.config.auth.skipAuthorityMetadataCache},a=new A_(a,this.config.system.networkClient,this.storage,s,this.logger);if(o.clientInfo){this.logger.trace("TokenCache - homeAccountId from options");n=this.loadAccount(r,a.hostnameAndPort,o.clientInfo,a.authorityType)}else{if(!t.client_info)throw P.createUnableToLoadTokenError("Please provide clientInfo in the response or options.");this.logger.trace("TokenCache - homeAccountId from response");n=this.loadAccount(r,a.hostnameAndPort,t.client_info,a.authorityType)}i=new Vv(n,this.loadIdToken(r,n.homeAccountId,a.hostnameAndPort,a.tenant),this.loadAccessToken(e,t,n.homeAccountId,a.hostnameAndPort,a.tenant,o),this.loadRefreshToken(e,t,n.homeAccountId,a.hostnameAndPort))}return this.generateAuthenticationResult(e,r,i,a)},iC.prototype.loadAccount=function(e,t,o,r,n){var i;if(n?i=n:void 0!==r&&o&&(i=ov.generateHomeAccountId(o,r,this.logger,this.cryptoObj,e)),!i)throw P.createUnableToLoadTokenError("Unexpected missing homeAccountId");n=o?ov.createAccount(o,i,e,void 0,void 0,void 0,t):ov.createGenericAccount(i,e,void 0,void 0,void 0,t);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading account"),this.storage.setAccount(n),n;throw P.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},iC.prototype.loadIdToken=function(e,t,o,r){t=Mv.createIdTokenEntity(t,o,e.rawToken,this.config.auth.clientId,r);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading id token"),this.storage.setIdTokenCredential(t),t;throw P.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},iC.prototype.loadAccessToken=function(e,t,o,r,n,i){if(!t.access_token)return this.logger.verbose("TokenCache - No access token provided for caching"),null;if(!t.expires_in)throw P.createUnableToLoadTokenError("Please ensure server response includes expires_in value.");if(!i.extendedExpiresOn)throw P.createUnableToLoadTokenError("Please provide an extendedExpiresOn value in the options.");var e=new Xy(e.scopes).printScopes(),a=i.expiresOn||t.expires_in+(new Date).getTime()/1e3,i=i.extendedExpiresOn,o=Uv.createAccessTokenEntity(o,r,t.access_token,this.config.auth.clientId,n,e,a,i,this.cryptoObj);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading access token"),this.storage.setAccessTokenCredential(o),o;throw P.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},iC.prototype.loadRefreshToken=function(e,t,o,r){if(!t.refresh_token)return this.logger.verbose("TokenCache - No refresh token provided for caching"),null;o=Bv.createRefreshTokenEntity(o,r,t.refresh_token,this.config.auth.clientId);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading refresh token"),this.storage.setRefreshTokenCredential(o),o;throw P.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},iC.prototype.generateAuthenticationResult=function(e,t,o,r){var n,i=E.EMPTY_STRING,a=[],s=null,c=(null!=o&&o.accessToken&&(i=o.accessToken.secret,a=Xy.fromString(o.accessToken.target).asArray(),s=new Date(1e3*Number(o.accessToken.expiresOn)),n=new Date(1e3*Number(o.accessToken.extendedExpiresOn))),(null==t?void 0:t.claims.oid)||(null==t?void 0:t.claims.sub)||E.EMPTY_STRING),u=(null==t?void 0:t.claims.tid)||E.EMPTY_STRING;return{authority:r?r.canonicalAuthority:E.EMPTY_STRING,uniqueId:c,tenantId:u,scopes:a,account:null!=o&&o.account?o.account.getAccountInfo():null,idToken:t?t.rawToken:E.EMPTY_STRING,idTokenClaims:t?t.claims:{},accessToken:i,fromCache:!0,expiresOn:s,correlationId:e.correlationId||E.EMPTY_STRING,requestId:E.EMPTY_STRING,extExpiresOn:n,familyId:E.EMPTY_STRING,tokenType:(null==(r=null==o?void 0:o.accessToken)?void 0:r.tokenType)||E.EMPTY_STRING,state:E.EMPTY_STRING,cloudGraphHostName:(null==(c=null==o?void 0:o.account)?void 0:c.cloudGraphHostName)||E.EMPTY_STRING,msGraphHost:(null==(u=null==o?void 0:o.account)?void 0:u.msGraphHost)||E.EMPTY_STRING,code:void 0,fromNativeBroker:!1}};var nC=iC;function iC(e,t,o,r){this.isBrowserEnvironment="undefined"!=typeof window,this.config=e,this.storage=t,this.logger=o,this.cryptoObj=r}Dg(cC,aC=p_);var aC,sC=cC;function cC(e){e=aC.call(this,e)||this;return e.includeRedirectUri=!1,e}Dg(hC,uC=s),hC.prototype.acquireToken=function(i){return _(this,void 0,void 0,function(){var t,o,r,n;return w(this,function(e){switch(e.label){case 0:if(this.logger.trace("SilentAuthCodeClient.acquireToken called"),i.code)return this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,i.correlationId),[4,this.initializeAuthorizationRequest(i,O.Silent)];throw P.createAuthCodeRequiredError();case 1:t=e.sent(),this.browserStorage.updateCacheEntries(t.state,t.nonce,t.authority,t.loginHint||E.EMPTY_STRING,t.account||null),o=this.initializeServerTelemetryManager(this.apiId),e.label=2;case 2:return e.trys.push([2,4,,5]),r=v(v({},t),{code:i.code}),this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,i.correlationId),[4,this.getClientConfiguration(o,t.authority)];case 3:return n=e.sent(),n=new sC(n),this.logger.verbose("Auth code client created"),[2,new db(n,this.browserStorage,r,this.logger,this.config.system,this.performanceClient).handleCodeResponseFromServer({code:i.code,msgraph_host:i.msGraphHost,cloud_graph_host_name:i.cloudGraphHostName,cloud_instance_host_name:i.cloudInstanceHostName},t.state,n.authority,this.networkClient,!1)];case 4:throw(n=e.sent())instanceof T&&n.setCorrelationId(this.correlationId),o.cacheFailedRequest(n),this.browserStorage.cleanRequestByState(t.state),n;case 5:return[2]}})})},hC.prototype.logout=function(){return Promise.reject(P.createSilentLogoutUnsupportedError())};var uC,lC=hC;function hC(e,t,o,r,n,i,a,s,c,u){e=uC.call(this,e,t,o,r,n,i,s,c,u)||this;return e.apiId=a,e}function M(e){this.isBrowserEnvironment="undefined"!=typeof window,this.config=(t=e,o=this.isBrowserEnvironment,i=e.auth,s=e.cache,r=e.system,t=e.telemetry,e={clientId:E.EMPTY_STRING,authority:""+E.DEFAULT_AUTHORITY,knownAuthorities:[],cloudDiscoveryMetadata:E.EMPTY_STRING,authorityMetadata:E.EMPTY_STRING,redirectUri:E.EMPTY_STRING,postLogoutRedirectUri:E.EMPTY_STRING,navigateToLoginRequestUrl:!0,clientCapabilities:[],protocolMode:b_.AAD,azureCloudOptions:{azureCloudInstance:Sy.None,tenant:E.EMPTY_STRING},skipAuthorityMetadataCache:!1},a={cacheLocation:Kw.SessionStorage,temporaryCacheLocation:Kw.SessionStorage,storeAuthStateInCookie:!1,secureCookies:!1,cacheMigrationEnabled:!(!s||s.cacheLocation!==Kw.LocalStorage),claimsBasedCachingEnabled:!0},n={loggerCallback:function(){},logLevel:_y.Info,piiLoggingEnabled:!1},o=v(v({},lv),{loggerOptions:n,networkClient:o?A0.getBrowserNetworkClient():D_,navigationClient:new ib,loadFrameTimeout:0,windowHashTimeout:(null==r?void 0:r.loadFrameTimeout)||sb,iframeHashTimeout:(null==r?void 0:r.loadFrameTimeout)||cb,navigateFrameWait:o&&A0.detectIEOrEdge()?500:0,redirectNavigationTimeout:ub,asyncPopups:!1,allowRedirectInIframe:!1,allowNativeBroker:!1,nativeBrokerHandshakeTimeout:(null==r?void 0:r.nativeBrokerHandshakeTimeout)||lb,pollIntervalMilliseconds:Jw.DEFAULT_POLL_INTERVAL_MS,cryptoOptions:{useMsrCrypto:!1,entropy:void 0}}),r=v(v({},r),{loggerOptions:(null==r?void 0:r.loggerOptions)||n}),n={application:{appName:E.EMPTY_STRING,appVersion:E.EMPTY_STRING}},{auth:v(v({},e),i),cache:v(v({},a),s),system:v(v({},o),r),telemetry:v(v({},n),t)}),this.initialized=!1,this.logger=new by(this.config.system.loggerOptions,C0,S0),this.networkClient=this.config.system.networkClient,this.navigationClient=this.config.system.navigationClient,this.redirectResponse=new Map,this.hybridAuthCodeResponses=new Map,this.performanceClient=this.isBrowserEnvironment?new oC(this.config.auth.clientId,this.config.auth.authority,this.logger,C0,S0,this.config.telemetry.application,this.config.system.cryptoOptions):new Q_(this.config.auth.clientId,this.config.auth.authority,this.logger,C0,S0,this.config.telemetry.application),this.browserCrypto=this.isBrowserEnvironment?new Jb(this.logger,this.performanceClient,this.config.system.cryptoOptions):Im,this.eventHandler=new wb(this.logger,this.browserCrypto),this.browserStorage=this.isBrowserEnvironment?new b0(this.config.auth.clientId,this.config.cache,this.browserCrypto,this.logger):(e=this.config.auth.clientId,i=this.logger,a={cacheLocation:Kw.MemoryStorage,temporaryCacheLocation:Kw.MemoryStorage,storeAuthStateInCookie:!1,secureCookies:!1,cacheMigrationEnabled:!1,claimsBasedCachingEnabled:!0},new b0(e,a,Im,i));var t,o,r,n,i,a,s={cacheLocation:Kw.MemoryStorage,temporaryCacheLocation:Kw.MemoryStorage,storeAuthStateInCookie:!1,secureCookies:!1,cacheMigrationEnabled:!1,claimsBasedCachingEnabled:!0};this.nativeInternalStorage=new b0(this.config.auth.clientId,s,this.browserCrypto,this.logger),this.tokenCache=new nC(this.config,this.browserStorage,this.logger,this.browserCrypto),this.trackPageVisibilityWithMeasurement=this.trackPageVisibilityWithMeasurement.bind(this)}M.prototype.initialize=function(){return _(this,void 0,void 0,function(){var t,o,r,n,i;return w(this,function(e){switch(e.label){case 0:if(this.logger.trace("initialize called"),this.initialized)return this.logger.info("initialize has already been called, exiting early."),[2];if(t=this.config.system.allowNativeBroker,o=this.performanceClient.startMeasurement(A.InitializeClientApplication),this.eventHandler.emitEvent(x.INITIALIZE_START),!t)return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),r=this,[4,J0.createProvider(this.logger,this.config.system.nativeBrokerHandshakeTimeout,this.performanceClient)];case 2:return r.nativeExtensionProvider=e.sent(),[3,4];case 3:return n=e.sent(),this.logger.verbose(n),[3,4];case 4:return this.config.cache.claimsBasedCachingEnabled?[3,6]:(this.logger.verbose("Claims-based caching is disabled. Clearing the previous cache with claims"),i=this.performanceClient.startMeasurement(A.ClearTokensAndKeysWithClaims),[4,this.browserStorage.clearTokensAndKeysWithClaims()]);case 5:e.sent(),i.endMeasurement({success:!0}),e.label=6;case 6:return this.initialized=!0,this.eventHandler.emitEvent(x.INITIALIZE_END),o.endMeasurement({allowNativeBroker:t,success:!0}),[2]}})})},M.prototype.handleRedirectPromise=function(s){return _(this,void 0,void 0,function(){var t,o,r,n,i,a=this;return w(this,function(e){return this.logger.verbose("handleRedirectPromise called"),A0.blockNativeBrokerCalledBeforeInitialized(this.config.system.allowNativeBroker,this.initialized),t=this.getAllAccounts(),this.isBrowserEnvironment?(o=s||E.EMPTY_STRING,void 0===(r=this.redirectResponse.get(o))?(this.eventHandler.emitEvent(x.HANDLE_REDIRECT_START,O.Redirect),this.logger.verbose("handleRedirectPromise has been called for the first time, storing the promise"),i=this.browserStorage.getCachedNativeRequest(),n=void 0,n=i&&J0.isNativeAvailable(this.config,this.logger,this.nativeExtensionProvider)&&this.nativeExtensionProvider&&!s?(this.logger.trace("handleRedirectPromise - acquiring token from native platform"),new Q0(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Qw.handleRedirectPromise,this.performanceClient,this.nativeExtensionProvider,i.accountId,this.nativeInternalStorage,i.correlationId).handleRedirectPromise()):(this.logger.trace("handleRedirectPromise - acquiring token from web flow"),i=this.browserStorage.getTemporaryCache(Yw.CORRELATION_ID,!0)||E.EMPTY_STRING,this.createRedirectClient(i).handleRedirectPromise(s)),r=n.then(function(e){return e&&(t.length<a.getAllAccounts().length?(a.eventHandler.emitEvent(x.LOGIN_SUCCESS,O.Redirect,e),a.logger.verbose("handleRedirectResponse returned result, login success")):(a.eventHandler.emitEvent(x.ACQUIRE_TOKEN_SUCCESS,O.Redirect,e),a.logger.verbose("handleRedirectResponse returned result, acquire token success"))),a.eventHandler.emitEvent(x.HANDLE_REDIRECT_END,O.Redirect),e}).catch(function(e){throw 0<t.length?a.eventHandler.emitEvent(x.ACQUIRE_TOKEN_FAILURE,O.Redirect,null,e):a.eventHandler.emitEvent(x.LOGIN_FAILURE,O.Redirect,null,e),a.eventHandler.emitEvent(x.HANDLE_REDIRECT_END,O.Redirect),e}),this.redirectResponse.set(o,r)):this.logger.verbose("handleRedirectPromise has been called previously, returning the result from the first call"),[2,r]):(this.logger.verbose("handleRedirectPromise returns null, not browser environment"),[2,null])})})},M.prototype.acquireTokenRedirect=function(n){return _(this,void 0,void 0,function(){var t,o,r=this;return w(this,function(e){return t=this.getRequestCorrelationId(n),this.logger.verbose("acquireTokenRedirect called",t),this.preflightBrowserEnvironmentCheck(O.Redirect),(o=0<this.getAllAccounts().length)?this.eventHandler.emitEvent(x.ACQUIRE_TOKEN_START,O.Redirect,n):this.eventHandler.emitEvent(x.LOGIN_START,O.Redirect,n),[2,(this.nativeExtensionProvider&&this.canUseNative(n)?new Q0(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Qw.acquireTokenRedirect,this.performanceClient,this.nativeExtensionProvider,this.getNativeAccountId(n),this.nativeInternalStorage,n.correlationId).acquireTokenRedirect(n).catch(function(e){if(e instanceof z0&&e.isFatal())return r.nativeExtensionProvider=void 0,r.createRedirectClient(n.correlationId).acquireToken(n);if(e instanceof Zv)return r.logger.verbose("acquireTokenRedirect - Resolving interaction required error thrown by native broker by falling back to web flow"),r.createRedirectClient(n.correlationId).acquireToken(n);throw r.browserStorage.setInteractionInProgress(!1),e}):this.createRedirectClient(n.correlationId).acquireToken(n)).catch(function(e){throw o?r.eventHandler.emitEvent(x.ACQUIRE_TOKEN_FAILURE,O.Redirect,null,e):r.eventHandler.emitEvent(x.LOGIN_FAILURE,O.Redirect,null,e),e})]})})},M.prototype.acquireTokenPopup=function(t){var o=this,e=this.getRequestCorrelationId(t),r=this.performanceClient.startMeasurement(A.AcquireTokenPopup,e);try{this.logger.verbose("acquireTokenPopup called",e),this.preflightBrowserEnvironmentCheck(O.Popup)}catch(e){return Promise.reject(e)}var n=this.getAllAccounts();return 0<n.length?this.eventHandler.emitEvent(x.ACQUIRE_TOKEN_START,O.Popup,t):this.eventHandler.emitEvent(x.LOGIN_START,O.Popup,t),(this.canUseNative(t)?this.acquireTokenNative(t,Qw.acquireTokenPopup).then(function(e){return o.browserStorage.setInteractionInProgress(!1),r.endMeasurement({success:!0,isNativeBroker:!0,requestId:e.requestId}),e}).catch(function(e){if(e instanceof z0&&e.isFatal())return o.nativeExtensionProvider=void 0,o.createPopupClient(t.correlationId).acquireToken(t);if(e instanceof Zv)return o.logger.verbose("acquireTokenPopup - Resolving interaction required error thrown by native broker by falling back to web flow"),o.createPopupClient(t.correlationId).acquireToken(t);throw o.browserStorage.setInteractionInProgress(!1),e}):this.createPopupClient(t.correlationId).acquireToken(t)).then(function(e){return n.length<o.getAllAccounts().length?o.eventHandler.emitEvent(x.LOGIN_SUCCESS,O.Popup,e):o.eventHandler.emitEvent(x.ACQUIRE_TOKEN_SUCCESS,O.Popup,e),r.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),r.endMeasurement({success:!0,requestId:e.requestId}),e}).catch(function(e){return 0<n.length?o.eventHandler.emitEvent(x.ACQUIRE_TOKEN_FAILURE,O.Popup,null,e):o.eventHandler.emitEvent(x.LOGIN_FAILURE,O.Popup,null,e),r.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),Promise.reject(e)})},M.prototype.trackPageVisibilityWithMeasurement=function(){var e=this.ssoSilentMeasurement||this.acquireTokenByCodeAsyncMeasurement;e&&(this.logger.info("Perf: Visibility change detected in ",e.event.name),e.increment({visibilityChangeCount:1}))},M.prototype.ssoSilent=function(n){var i;return _(this,void 0,void 0,function(){var t,o,r=this;return w(this,function(e){return t=this.getRequestCorrelationId(n),o=v(v({},n),{prompt:n.prompt,correlationId:t}),this.preflightBrowserEnvironmentCheck(O.Silent),this.ssoSilentMeasurement=this.performanceClient.startMeasurement(A.SsoSilent,t),null!=(i=this.ssoSilentMeasurement)&&i.increment({visibilityChangeCount:0}),document.addEventListener("visibilitychange",this.trackPageVisibilityWithMeasurement),this.logger.verbose("ssoSilent called",t),this.eventHandler.emitEvent(x.SSO_SILENT_START,O.Silent,o),[2,(this.canUseNative(o)?this.acquireTokenNative(o,Qw.ssoSilent).catch(function(e){if(e instanceof z0&&e.isFatal())return r.nativeExtensionProvider=void 0,r.createSilentIframeClient(o.correlationId).acquireToken(o);throw e}):this.createSilentIframeClient(o.correlationId).acquireToken(o)).then(function(e){var t;return r.eventHandler.emitEvent(x.SSO_SILENT_SUCCESS,O.Silent,e),null!=(t=r.ssoSilentMeasurement)&&t.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),null!=(t=r.ssoSilentMeasurement)&&t.endMeasurement({success:!0,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){var t;throw r.eventHandler.emitEvent(x.SSO_SILENT_FAILURE,O.Silent,null,e),null!=(t=r.ssoSilentMeasurement)&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}).finally(function(){document.removeEventListener("visibilitychange",r.trackPageVisibilityWithMeasurement)})]})})},M.prototype.acquireTokenByCode=function(a){return _(this,void 0,void 0,function(){var t,o,r,n,i=this;return w(this,function(e){t=this.getRequestCorrelationId(a),this.preflightBrowserEnvironmentCheck(O.Silent),this.logger.trace("acquireTokenByCode called",t),this.eventHandler.emitEvent(x.ACQUIRE_TOKEN_BY_CODE_START,O.Silent,a),o=this.performanceClient.startMeasurement(A.AcquireTokenByCode,a.correlationId);try{if(a.code&&a.nativeAccountId)throw P.createSpaCodeAndNativeAccountIdPresentError();if(a.code)return r=a.code,(n=this.hybridAuthCodeResponses.get(r))?(this.logger.verbose("Existing acquireTokenByCode request found",a.correlationId),o.discardMeasurement()):(this.logger.verbose("Initiating new acquireTokenByCode request",t),n=this.acquireTokenByCodeAsync(v(v({},a),{correlationId:t})).then(function(e){return i.eventHandler.emitEvent(x.ACQUIRE_TOKEN_BY_CODE_SUCCESS,O.Silent,e),i.hybridAuthCodeResponses.delete(r),o.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),o.endMeasurement({success:!0,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){throw i.hybridAuthCodeResponses.delete(r),i.eventHandler.emitEvent(x.ACQUIRE_TOKEN_BY_CODE_FAILURE,O.Silent,null,e),o.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}),this.hybridAuthCodeResponses.set(r,n)),[2,n];if(a.nativeAccountId){if(this.canUseNative(a,a.nativeAccountId))return[2,this.acquireTokenNative(a,Qw.acquireTokenByCode,a.nativeAccountId).catch(function(e){throw e instanceof z0&&e.isFatal()&&(i.nativeExtensionProvider=void 0),e})];throw P.createUnableToAcquireTokenFromNativePlatformError()}throw P.createAuthCodeOrNativeAccountIdRequiredError()}catch(e){throw this.eventHandler.emitEvent(x.ACQUIRE_TOKEN_BY_CODE_FAILURE,O.Silent,null,e),o.endMeasurement({errorCode:e instanceof T&&e.errorCode||void 0,subErrorCode:e instanceof T&&e.subError||void 0,success:!1}),e}return[2]})})},M.prototype.acquireTokenByCodeAsync=function(t){var r;return _(this,void 0,void 0,function(){var o=this;return w(this,function(e){switch(e.label){case 0:return this.logger.trace("acquireTokenByCodeAsync called",t.correlationId),this.acquireTokenByCodeAsyncMeasurement=this.performanceClient.startMeasurement(A.AcquireTokenByCodeAsync,t.correlationId),null!=(r=this.acquireTokenByCodeAsyncMeasurement)&&r.increment({visibilityChangeCount:0}),document.addEventListener("visibilitychange",this.trackPageVisibilityWithMeasurement),[4,this.createSilentAuthCodeClient(t.correlationId).acquireToken(t).then(function(e){var t;return null!=(t=o.acquireTokenByCodeAsyncMeasurement)&&t.endMeasurement({success:!0,fromCache:e.fromCache,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){var t;throw null!=(t=o.acquireTokenByCodeAsyncMeasurement)&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}).finally(function(){document.removeEventListener("visibilitychange",o.trackPageVisibilityWithMeasurement)})];case 1:return[2,e.sent()]}})})},M.prototype.acquireTokenFromCache=function(t,o,r){return _(this,void 0,void 0,function(){return w(this,function(e){switch(this.performanceClient.addQueueMeasurement(A.AcquireTokenFromCache,o.correlationId),r.cacheLookupPolicy){case Vw.Default:case Vw.AccessToken:case Vw.AccessTokenAndRefreshToken:return[2,t.acquireToken(o)];default:throw I.createRefreshRequiredError()}return[2]})})},M.prototype.acquireTokenByRefreshToken=function(o,r){return _(this,void 0,void 0,function(){var t;return w(this,function(e){switch(this.performanceClient.addQueueMeasurement(A.AcquireTokenByRefreshToken,o.correlationId),r.cacheLookupPolicy){case Vw.Default:case Vw.AccessTokenAndRefreshToken:case Vw.RefreshToken:case Vw.RefreshTokenAndNetwork:return t=this.createSilentRefreshClient(o.correlationId),this.performanceClient.setPreQueueTime(A.SilentRefreshClientAcquireToken,o.correlationId),[2,t.acquireToken(o)];default:throw I.createRefreshRequiredError()}return[2]})})},M.prototype.acquireTokenBySilentIframe=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){return this.performanceClient.addQueueMeasurement(A.AcquireTokenBySilentIframe,o.correlationId),t=this.createSilentIframeClient(o.correlationId),this.performanceClient.setPreQueueTime(A.SilentIframeClientAcquireToken,o.correlationId),[2,t.acquireToken(o)]})})},M.prototype.logout=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){return t=this.getRequestCorrelationId(o),this.logger.warning("logout API is deprecated and will be removed in msal-browser v3.0.0. Use logoutRedirect instead.",t),[2,this.logoutRedirect(v({correlationId:t},o))]})})},M.prototype.logoutRedirect=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){return t=this.getRequestCorrelationId(o),this.preflightBrowserEnvironmentCheck(O.Redirect),[2,this.createRedirectClient(t).logout(o)]})})},M.prototype.logoutPopup=function(e){try{var t=this.getRequestCorrelationId(e);return this.preflightBrowserEnvironmentCheck(O.Popup),this.createPopupClient(t).logout(e)}catch(e){return Promise.reject(e)}},M.prototype.getAllAccounts=function(){return this.logger.verbose("getAllAccounts called"),this.isBrowserEnvironment?this.browserStorage.getAllAccounts():[]},M.prototype.getAccountByUsername=function(e){var t;return this.logger.trace("getAccountByUsername called"),e?(t=this.browserStorage.getAccountInfoFilteredBy({username:e}))?(this.logger.verbose("getAccountByUsername: Account matching username found, returning"),this.logger.verbosePii("getAccountByUsername: Returning signed-in accounts matching username: "+e),t):(this.logger.verbose("getAccountByUsername: No matching account found, returning null"),null):(this.logger.warning("getAccountByUsername: No username provided"),null)},M.prototype.getAccountByHomeId=function(e){var t;return this.logger.trace("getAccountByHomeId called"),e?(t=this.browserStorage.getAccountInfoFilteredBy({homeAccountId:e}))?(this.logger.verbose("getAccountByHomeId: Account matching homeAccountId found, returning"),this.logger.verbosePii("getAccountByHomeId: Returning signed-in accounts matching homeAccountId: "+e),t):(this.logger.verbose("getAccountByHomeId: No matching account found, returning null"),null):(this.logger.warning("getAccountByHomeId: No homeAccountId provided"),null)},M.prototype.getAccountByLocalId=function(e){var t;return this.logger.trace("getAccountByLocalId called"),e?(t=this.browserStorage.getAccountInfoFilteredBy({localAccountId:e}))?(this.logger.verbose("getAccountByLocalId: Account matching localAccountId found, returning"),this.logger.verbosePii("getAccountByLocalId: Returning signed-in accounts matching localAccountId: "+e),t):(this.logger.verbose("getAccountByLocalId: No matching account found, returning null"),null):(this.logger.warning("getAccountByLocalId: No localAccountId provided"),null)},M.prototype.setActiveAccount=function(e){this.browserStorage.setActiveAccount(e)},M.prototype.getActiveAccount=function(){return this.browserStorage.getActiveAccount()},M.prototype.preflightBrowserEnvironmentCheck=function(e,t){if(void 0===t&&(t=!0),this.logger.verbose("preflightBrowserEnvironmentCheck started"),A0.blockNonBrowserEnvironment(this.isBrowserEnvironment),A0.blockRedirectInIframe(e,this.config.system.allowRedirectInIframe),A0.blockReloadInHiddenIframes(),A0.blockAcquireTokenInPopups(),A0.blockNativeBrokerCalledBeforeInitialized(this.config.system.allowNativeBroker,this.initialized),e===O.Redirect&&this.config.cache.cacheLocation===Kw.MemoryStorage&&!this.config.cache.storeAuthStateInCookie)throw d0.createInMemoryRedirectUnavailableError();e!==O.Redirect&&e!==O.Popup||this.preflightInteractiveRequest(t)},M.prototype.preflightInteractiveRequest=function(e){this.logger.verbose("preflightInteractiveRequest called, validating app environment"),A0.blockReloadInHiddenIframes(),e&&this.browserStorage.setInteractionInProgress(!0)},M.prototype.acquireTokenNative=function(t,o,r){return _(this,void 0,void 0,function(){return w(this,function(e){if(this.logger.trace("acquireTokenNative called"),this.nativeExtensionProvider)return[2,new Q0(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,o,this.performanceClient,this.nativeExtensionProvider,r||this.getNativeAccountId(t),this.nativeInternalStorage,t.correlationId).acquireToken(t)];throw P.createNativeConnectionNotEstablishedError()})})},M.prototype.canUseNative=function(e,t){if(this.logger.trace("canUseNative called"),!J0.isNativeAvailable(this.config,this.logger,this.nativeExtensionProvider,e.authenticationScheme))return this.logger.trace("canUseNative: isNativeAvailable returned false, returning false"),!1;if(e.prompt)switch(e.prompt){case rm.NONE:case rm.CONSENT:case rm.LOGIN:this.logger.trace("canUseNative: prompt is compatible with native flow");break;default:return this.logger.trace("canUseNative: prompt = "+e.prompt+" is not compatible with native flow, returning false"),!1}return!(!t&&!this.getNativeAccountId(e)&&(this.logger.trace("canUseNative: nativeAccountId is not available, returning false"),1))},M.prototype.getNativeAccountId=function(e){e=e.account||this.browserStorage.getAccountInfoByHints(e.loginHint,e.sid)||this.getActiveAccount();return e&&e.nativeAccountId||""},M.prototype.createPopupClient=function(e){return new rb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeInternalStorage,this.nativeExtensionProvider,e)},M.prototype.createRedirectClient=function(e){return new eb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeInternalStorage,this.nativeExtensionProvider,e)},M.prototype.createSilentIframeClient=function(e){return new gb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Qw.ssoSilent,this.performanceClient,this.nativeInternalStorage,this.nativeExtensionProvider,e)},M.prototype.createSilentCacheClient=function(e){return new Y0(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeExtensionProvider,e)},M.prototype.createSilentRefreshClient=function(e){return new vb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeExtensionProvider,e)},M.prototype.createSilentAuthCodeClient=function(e){return new lC(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Qw.acquireTokenByCode,this.performanceClient,this.nativeExtensionProvider,e)},M.prototype.addEventCallback=function(e){return this.eventHandler.addEventCallback(e)},M.prototype.removeEventCallback=function(e){this.eventHandler.removeEventCallback(e)},M.prototype.addPerformanceCallback=function(e){return this.performanceClient.addPerformanceCallback(e)},M.prototype.removePerformanceCallback=function(e){return this.performanceClient.removePerformanceCallback(e)},M.prototype.enableAccountStorageEvents=function(){this.eventHandler.enableAccountStorageEvents()},M.prototype.disableAccountStorageEvents=function(){this.eventHandler.disableAccountStorageEvents()},M.prototype.getTokenCache=function(){return this.tokenCache},M.prototype.getLogger=function(){return this.logger},M.prototype.setLogger=function(e){this.logger=e},M.prototype.initializeWrapperLibrary=function(e,t){this.browserStorage.setWrapperMetadata(e,t)},M.prototype.setNavigationClient=function(e){this.navigationClient=e},M.prototype.getConfiguration=function(){return this.config},M.prototype.getRequestCorrelationId=function(e){return null!=e&&e.correlationId?e.correlationId:this.isBrowserEnvironment?this.browserCrypto.createNewGuid():E.EMPTY_STRING};Dg(fC,dC=M),fC.prototype.loginRedirect=function(o){return _(this,void 0,void 0,function(){var t;return w(this,function(e){return t=this.getRequestCorrelationId(o),this.logger.verbose("loginRedirect called",t),[2,this.acquireTokenRedirect(v({correlationId:t},o||t0))]})})},fC.prototype.loginPopup=function(e){var t=this.getRequestCorrelationId(e);return this.logger.verbose("loginPopup called",t),this.acquireTokenPopup(v({correlationId:t},e||t0))},fC.prototype.acquireTokenSilent=function(s){return _(this,void 0,void 0,function(){var t,o,r,n,i,a=this;return w(this,function(e){if(t=this.getRequestCorrelationId(s),(o=this.performanceClient.startMeasurement(A.AcquireTokenSilent,t)).addStaticFields({cacheLookupPolicy:s.cacheLookupPolicy}),this.preflightBrowserEnvironmentCheck(O.Silent),this.logger.verbose("acquireTokenSilent called",t),i=s.account||this.getActiveAccount())return n={clientId:this.config.auth.clientId,authority:s.authority||E.EMPTY_STRING,scopes:s.scopes,homeAccountIdentifier:i.homeAccountId,claims:s.claims,authenticationScheme:s.authenticationScheme,resourceRequestMethod:s.resourceRequestMethod,resourceRequestUri:s.resourceRequestUri,shrClaims:s.shrClaims,sshKid:s.sshKid},r=JSON.stringify(n),void 0===(n=this.activeSilentTokenRequests.get(r))?(this.logger.verbose("acquireTokenSilent called for the first time, storing active request",t),this.performanceClient.setPreQueueTime(A.AcquireTokenSilentAsync,t),i=this.acquireTokenSilentAsync(v(v({},s),{correlationId:t}),i).then(function(e){return a.activeSilentTokenRequests.delete(r),o.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),o.endMeasurement({success:!0,fromCache:e.fromCache,isNativeBroker:e.fromNativeBroker,cacheLookupPolicy:s.cacheLookupPolicy,requestId:e.requestId}),e}).catch(function(e){throw a.activeSilentTokenRequests.delete(r),o.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}),this.activeSilentTokenRequests.set(r,i),[2,i]):(this.logger.verbose("acquireTokenSilent has been called previously, returning the result from the first call",t),o.discardMeasurement(),[2,n]);throw P.createNoAccountError()})})},fC.prototype.trackPageVisibility=function(){this.astsAsyncMeasurement&&(this.logger.info("Perf: Visibility change detected"),this.astsAsyncMeasurement.increment({visibilityChangeCount:1}))},fC.prototype.acquireTokenSilentAsync=function(c,r){var n;return _(this,void 0,void 0,function(){var t,o,i,a,s=this;return w(this,function(e){switch(e.label){case 0:return(this.performanceClient.addQueueMeasurement(A.AcquireTokenSilentAsync,c.correlationId),this.eventHandler.emitEvent(x.ACQUIRE_TOKEN_START,O.Silent,c),this.astsAsyncMeasurement=this.performanceClient.startMeasurement(A.AcquireTokenSilentAsync,c.correlationId),null!=(n=this.astsAsyncMeasurement)&&n.increment({visibilityChangeCount:0}),document.addEventListener("visibilitychange",this.trackPageVisibility),J0.isNativeAvailable(this.config,this.logger,this.nativeExtensionProvider,c.authenticationScheme)&&r.nativeAccountId)?(this.logger.verbose("acquireTokenSilent - attempting to acquire token from native platform"),t=v(v({},c),{account:r}),t=this.acquireTokenNative(t,Qw.acquireTokenSilent_silentFlow).catch(function(t){return _(s,void 0,void 0,function(){return w(this,function(e){if(t instanceof z0&&t.isFatal())return this.logger.verbose("acquireTokenSilent - native platform unavailable, falling back to web flow"),this.nativeExtensionProvider=void 0,[2,this.createSilentIframeClient(c.correlationId).acquireToken(c)];throw t})})}),[3,3]):[3,1];case 1:return this.logger.verbose("acquireTokenSilent - attempting to acquire token from web flow"),o=this.createSilentCacheClient(c.correlationId),this.performanceClient.setPreQueueTime(A.InitializeSilentRequest,c.correlationId),[4,o.initializeSilentRequest(c,r)];case 2:i=e.sent(),a=v(v({},c),{cacheLookupPolicy:c.cacheLookupPolicy||Vw.Default}),this.performanceClient.setPreQueueTime(A.AcquireTokenFromCache,i.correlationId),t=this.acquireTokenFromCache(o,i,a).catch(function(e){if(a.cacheLookupPolicy===Vw.AccessToken)throw e;return A0.blockReloadInHiddenIframes(),s.eventHandler.emitEvent(x.ACQUIRE_TOKEN_NETWORK_START,O.Silent,i),s.performanceClient.setPreQueueTime(A.AcquireTokenByRefreshToken,i.correlationId),s.acquireTokenByRefreshToken(i,a).catch(function(e){var t=e instanceof wv,o=e instanceof Zv,r=e.errorCode===Yv.code,n=e.errorCode===Jw.INVALID_GRANT_ERROR;if(t&&n&&!o&&a.cacheLookupPolicy!==Vw.AccessTokenAndRefreshToken&&a.cacheLookupPolicy!==Vw.RefreshToken||a.cacheLookupPolicy===Vw.Skip||r)return s.logger.verbose("Refresh token expired/invalid or CacheLookupPolicy is set to Skip, attempting acquire token by iframe.",c.correlationId),s.performanceClient.setPreQueueTime(A.AcquireTokenBySilentIframe,i.correlationId),s.acquireTokenBySilentIframe(i);throw e})}),e.label=3;case 3:return[2,t.then(function(e){var t;return s.eventHandler.emitEvent(x.ACQUIRE_TOKEN_SUCCESS,O.Silent,e),null!=(t=s.astsAsyncMeasurement)&&t.endMeasurement({success:!0,fromCache:e.fromCache,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){var t;throw s.eventHandler.emitEvent(x.ACQUIRE_TOKEN_FAILURE,O.Silent,null,e),null!=(t=s.astsAsyncMeasurement)&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}).finally(function(){document.removeEventListener("visibilitychange",s.trackPageVisibility)})]}})})};var dC,pC=fC;function fC(e){e=dC.call(this,e)||this;return e.astsAsyncMeasurement=void 0,e.activeSilentTokenRequests=new Map,e.trackPageVisibility=e.trackPageVisibility.bind(e),e}function gC(e){this.message=e}(gC.prototype=new Error).name="InvalidCharacterError";var mC="undefined"!=typeof window&&window.atob&&window.atob.bind(window)||function(e){var t=String(e).replace(/=+$/,"");if(t.length%4==1)throw new gC("'atob' failed: The string to be decoded is not correctly encoded.");for(var o,r,n=0,i=0,a="";r=t.charAt(i++);~r&&(o=n%4?64*o+r:r,n++%4)&&(a+=String.fromCharCode(255&o>>(-2*n&6))))r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(r);return a};function yC(e){this.message=e}function vC(e,t){if("string"!=typeof e)throw new yC("Invalid token specified");t=!0===(t=t||{}).header?0:1;try{return JSON.parse(function(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw"Illegal base64url string!"}try{return decodeURIComponent(mC(t).replace(/(.)/g,function(e,t){t=t.charCodeAt(0).toString(16).toUpperCase();return"%"+(t=t.length<2?"0"+t:t)}))}catch(e){return mC(t)}}(e.split(".")[t]))}catch(e){throw new yC("Invalid token specified: "+e.message)}}(yC.prototype=new Error).name="InvalidTokenError";N.prototype.initialize=function(){var r=this;return this.initPromise||(this.initPromise=new Promise(function(e,t){if(r.options.authType===l.AuthenticationType.subscriptionKey)e();else if(r.options.authType===l.AuthenticationType.aad)r.options.authContext=r.options.authContext||N.getDefaultAuthContext(r.options),r.options.authContext.handleRedirectPromise().then(function(){setTimeout(function(){return r._loginAndAcquireTokenForAAD(e,t)})}).catch(function(e){t(new Error("Error logging in the AAD users: "+e))});else if(r.options.authType===l.AuthenticationType.anonymous)e(r._triggerTokenFetch(!0));else if(r.options.authType===l.AuthenticationType.sas){if(r.options.sasToken){var o=-1;try{o=r._getTokenExpiry(r.options.sasToken)}catch(e){return void t(new Error("An invalid sasToken was provided."))}if(o>N.constants.tokenRefreshClockSkew)return r._storeToken(r.options.sasToken),r._setTimeoutTokenFetch(o-N.constants.tokenRefreshClockSkew),void e()}e(r._triggerTokenFetch())}else t(new Error("An invalid authentication type was specified."))})),this.initPromise},N.prototype.dispose=function(){this.tokenTimeOutHandle&&(clearTimeout(this.tokenTimeOutHandle),this.tokenTimeOutHandle=null)},N.getDefaultAuthContext=function(e){if(!e.aadAppId)throw new Error("No AAD app ID was specified.");if(e.aadTenant)return this.defaultAuthContext||(this.defaultAuthContext=new pC({auth:{authority:"".concat(e.aadInstance||V).concat(e.aadTenant),clientId:e.aadAppId},cache:{cacheLocation:this.constants.preferredCacheLocation}})),this.defaultAuthContext;throw new Error("No AAD tenant was specified.")},N.prototype._loginAndAcquireTokenForAAD=function(e,t){var o=(null==(o=this.options.authContext)?void 0:o.getAllAccounts())||[];0===o.length?(this.options.authContext.loginRedirect(),e()):(this.options.authContext.setActiveAccount(o[0]),this._acquireTokenForAAD(e,t))},N.prototype._acquireTokenForAAD=function(o,t){var r=this,n={scopes:[fe]};this.options.authContext.acquireTokenSilent(n).then(function(e){r._saveItem(N.constants.storage.tokenKey,e.accessToken);var t={map:r.map,type:N.constants.events.tokenAcquired},t=(r.map.events.invoke(N.constants.events.tokenAcquired,t),clearTimeout(r.tokenTimeOutHandle),new Date(e.expiresOn).getTime()-Date.now());r.tokenTimeOutHandle=setTimeout(function(){return r._acquireTokenForAAD()},t),null!=o&&o()}).catch(function(e){if(e instanceof Zv)return r.options.authContext.acquireTokenRedirect(n),null==o?void 0:o();null!=t&&t(e)})},N.prototype.getAuthType=function(){return this.options.authType},N.prototype.getClientId=function(){return this.options.clientId},N.prototype.getToken=function(){if(this.options.authType===l.AuthenticationType.aad)return this._getItem(N.constants.storage.tokenKey);if(this.options.authType!==l.AuthenticationType.anonymous&&this.options.authType!==l.AuthenticationType.sas)return this.options.authType===l.AuthenticationType.subscriptionKey?this.options.subscriptionKey:void 0;var e=this._getItem(N.constants.storage.tokenKey);if(e){var t=this._getTokenExpiry(e);if(t<300&&0<t)this._triggerTokenFetch();else if(t<=0)throw this._saveItem(N.constants.storage.tokenKey,""),new Error(N.constants.errors.tokenExpired)}else this._triggerTokenFetch();return e},N.prototype._getTokenExpiry=function(e){var e=vC(e).exp,t=this._getCurrentTime();return 0<e-t?e-t:-1},N.prototype._storeToken=function(e){this._saveItem(N.constants.storage.tokenKey,e);e={map:this.map,type:N.constants.events.tokenAcquired};this.map.events.invoke(N.constants.events.tokenAcquired,e)},N.prototype._saveItem=function(e,t){return this._supportsLocalStorage()?localStorage.setItem(e,t):this._supportsSessionStorage()?sessionStorage.setItem(e,t):this.fallbackStorage[e]=t,!0},N.prototype._getItem=function(e){return this._supportsLocalStorage()?localStorage.getItem(e):this._supportsSessionStorage()?sessionStorage.getItem(e):e in this.fallbackStorage?this.fallbackStorage[e]:null},N.prototype._supportsLocalStorage=function(){try{return window.localStorage?(window.localStorage.setItem(N.constants.storage.testStorageKey,"A"),"A"===window.localStorage.getItem(N.constants.storage.testStorageKey)&&(window.localStorage.removeItem(N.constants.storage.testStorageKey),!window.localStorage.getItem(N.constants.storage.testStorageKey))):!1}catch(e){return!1}},N.prototype._supportsSessionStorage=function(){try{return window.sessionStorage?(window.sessionStorage.setItem(N.constants.storage.testStorageKey,"A"),"A"===window.sessionStorage.getItem(N.constants.storage.testStorageKey)&&(window.sessionStorage.removeItem(N.constants.storage.testStorageKey),!window.sessionStorage.getItem(N.constants.storage.testStorageKey))):!1}catch(e){return!1}},N.prototype._getCurrentTime=function(){return Math.round((new Date).getTime()/1e3)},N.prototype.signRequest=function(e){e.headers=e.headers||{},e.headers[ge]=this.sessionId,e.headers[de]=pe,e.headers[le]="MapControl/".concat(Le," (Web)");var t=this.getToken();switch(this.options.authType){case l.AuthenticationType.aad:case l.AuthenticationType.anonymous:e.headers[he]=this.options.clientId,e.headers[X]=$+t;break;case l.AuthenticationType.sas:e.headers[X]=ee+t;break;case l.AuthenticationType.subscriptionKey:e.headers["subscription-key"]=t;break;default:throw new Error("An invalid authentication type was specified")}return e},N.constants={preferredCacheLocation:"localStorage",storage:{tokenKey:"access.token.key",testStorageKey:"testStorage"},events:{tokenAcquired:"tokenacquired"},tokenExpiresIn:3599,tokenRefreshClockSkew:300,errors:{tokenExpired:"Token Expired, Try again"}};var _C=N;function N(e){var n=this,t=(this.fallbackStorage={},this._triggerTokenFetch=function(e){return void 0===e&&(e=!1),new Promise(function(o,r){"function"!=typeof n.options.getToken?r(new Error("Token cannot be ".concat(e?"fetched":"renewed"," because getToken was not set or is not a function."))):n.options.getToken(function(e){try{var t=n._getTokenExpiry(e)-N.constants.tokenRefreshClockSkew;n._storeToken(e),n._setTimeoutTokenFetch(t),o()}catch(e){r(new Error("Invalid token returned by getToken function"))}},function(e){r(e)},n.map)})},this._setTimeoutTokenFetch=function(e){clearTimeout(n.tokenTimeOutHandle),n.tokenTimeOutHandle=setTimeout(n._triggerTokenFetch,Math.min(1e3*e,2147483647))},e.getServiceOptions());this.options=t.authOptions,this.sessionId=t.sessionId,this.map=e}var wC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},bC=(CC.prototype.add=function(e,t){var o,r;if(Array.isArray(e))try{for(var n=wC(e),i=n.next();!i.done;i=n.next()){var a=i.value;this._add(a,t)}}catch(e){o={error:e}}finally{try{i&&!i.done&&(r=n.return)&&r.call(n)}finally{if(o)throw o.error}}else this._add(e,t)},CC.prototype.getControls=function(){return Array.from(this.controls)},CC.prototype.remove=function(e){var t,o;if(Array.isArray(e))try{for(var r=wC(e),n=r.next();!n.done;n=r.next()){var i=n.value;this._remove(i)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}else this._remove(e)},CC.prototype._add=function(e,t){this.controls.add(e);var o=(new Gt).merge(t),e=e.onAdd(this.map,t),t=this.controlContainer.getElementsByClassName(o.position);if(!(0<t.length))throw new Error("Control position ".concat(o.position," does not exist."));t.item(0).appendChild(e)},CC.prototype._remove=function(e){e.onRemove(),this.controls.delete(e)},CC);function CC(e){for(var t in this.map=e,this.controlContainer=document.createElement("div"),this.controlContainer.classList.add("atlas-control-container"),l.ControlPosition){var o;l.ControlPosition.hasOwnProperty(t)&&((o=document.createElement("div")).classList.add(l.ControlPosition[t]),o.classList.add("subcontrol-container"),this.controlContainer.appendChild(o))}this.map.getMapContainer().appendChild(this.controlContainer),this.controls=new Set}var SC=window&&window.__assign||function(){return(SC=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},EC=(TC.prototype.addCallback=function(a,s,c,e,u){var t,l,h=this;if(e)t=function(e){var t=e.lngLat?new hl(e.lngLat.lng,e.lngLat.lat):void 0,o=e.point?[e.point.x,e.point.y]:void 0,r=e.features?e.features.map(function(e){return new $c(e.geometry,e.properties,e.id)}):[],e={type:e.type,originalEvent:e.originalEvent,position:t,coordinate:o,features:r};c(e)};else switch(a){case"data":case"sourcedata":case"styledata":t=function(e){e=SC(SC({dataType:e.dataType},"source"===e.dataType&&SC(SC(SC({isSourceLoaded:e.isSourceLoaded},e.sourceDataType&&{sourceDataType:e.sourceDataType}),{source:h.map.sources.getById(e.sourceId)}),e.tile&&{tile:{id:{x:e.tile.tileID.canonical.x,y:e.tile.tileID.canonical.y,z:e.tile.tileID.canonical.z},size:e.tile.tileSize,state:e.tile.state}})),{map:h.map,type:e.type});u&&h.map.events._removeListener(a,s,c),c(e)};break;case"error":t=function(e){e={error:e.error,map:h.map,type:e.type};u&&h.map.events._removeListener(a,s,c),c(e)};break;case"touchstart":case"touchend":case"touchmove":case"touchcancel":t=function(e){if(e.originalEvent){if(e.originalEvent===l)return;l=e.originalEvent}var t=e.point?new ru(e.point.x,e.point.y):void 0,o=e.points?e.points.map(function(e){return new ru(e.x,e.y)}):[],r=e.lngLat?new hl(e.lngLat.lng,e.lngLat.lat):void 0,n=e.lngLats?e.lngLats.map(function(e){return new hl(e.lng,e.lat)}):[],i=r?h.map.layers.getRenderedShapes(new iu(r),s?[s]:void 0):[],t={map:h.map,originalEvent:e.originalEvent,pixel:t,pixels:o,position:r,positions:n,shapes:i,layerId:s||void 0,preventDefault:function(){return e.preventDefault()},type:e.type};u&&h.map.events._removeListener(a,s,c),c(t)};break;case"mousedown":case"mouseup":case"mouseover":case"mousemove":case"click":case"dblclick":case"mouseout":case"mouseenter":case"mouseleave":case"contextmenu":t=function(e){if(e.originalEvent){if(e.originalEvent===l)return;l=e.originalEvent}var t=e.lngLat?new hl(e.lngLat.lng,e.lngLat.lat):void 0,o=e.point?new ru(e.point.x,e.point.y):void 0,r=t?h.map.layers.getRenderedShapes(new iu(t),s?[s]:void 0):[],t={map:h.map,originalEvent:e.originalEvent,position:t,pixel:o,preventDefault:function(){return e.preventDefault()},shapes:r,layerId:s||void 0,type:e.type};u&&h.map.events._removeListener(a,s,c),c(t)};break;case"styleimagemissing":t=function(e){u&&h.map.events._removeListener(a,s,c),c(e.id)};break;case"wheel":t=function(e){if(e.originalEvent){if(e.originalEvent===l)return;l=e.originalEvent}var t={map:h.map,originalEvent:e.originalEvent,preventDefault:function(){return e.preventDefault()},type:e.type};u&&h.map.events._removeListener(a,s,c),c(t)};break;case"resize":t=function(e){var t,o={map:h.map,type:e.type};for(t in e)"type"!==t&&"target"!==t&&(o[t]=e[t]);u&&h.map.events._removeListener(a,s,c),c(o)};break;default:t=function(e){var t={map:h.map,type:e.type};e.originalEvent&&(t.originalEvent=e.originalEvent),u&&h.map.events._removeListener(a,s,c),c(t)}}this.callbacks.has(s)||this.callbacks.set(s,new Qt),this.callbacks.get(s).has(a)||this.callbacks.get(s).set(a,new Map),this.callbacks.get(s).get(a).set(c,[t,u])},TC.prototype.removeCallback=function(e,t,o){this.callbacks.has(t)&&this.callbacks.get(t).has(e)&&this.callbacks.get(t).get(e).has(o)&&this.callbacks.get(t).get(e).delete(o)},TC.prototype.getModifiedCallback=function(e,t,o){if(this.callbacks.has(t)&&this.callbacks.get(t).has(e)&&this.callbacks.get(t).get(e).has(o))return this.callbacks.get(t).get(e).get(o)[0]},TC.prototype.getLayerCallbacks=function(e){if(this.callbacks.has(e))return this.callbacks.get(e)},TC.prototype.getEventCallbacks=function(e,t){if(this.callbacks.has(t)){t=this.callbacks.get(t);if(t.has(e))return t.get(e)}},TC);function TC(e){this.callbacks=new Qt,this.map=e}var IC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},kC=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},AC=["maxzoomchanged","minzoomchanged","mapconfigurationchanged"],PC=(OC.prototype.add=function(e,t,o){var r,n;if("function"==typeof t)this._addGlobalListener(e,t,!1,!1);else{t=Array.isArray(t)?t:[t];try{for(var i=IC(t),a=i.next();!a.done;a=i.next()){var s=a.value;s instanceof ed&&ed._isMBoxEvent(e)?this._addLayerListener(e,s,o,!1,!1):s._addEventListener(e,o,!1)}}catch(e){r={error:e}}finally{try{a&&!a.done&&(n=i.return)&&n.call(i)}finally{if(r)throw r.error}}}},OC.prototype.addOnce=function(e,t,o){"function"==typeof t?this._addGlobalListener(e,t,!1,!0):t instanceof ed&&ed._isMBoxEvent(e)?this._addLayerListener(e,t,o,!1,!0):t._addEventListener(e,o,!0)},OC.prototype._addLegacy=function(e,t,o){"function"==typeof t?this._addGlobalListener(e,t,!0,!1):this._addLayerListener(e,t,o,!0,!1)},OC.prototype._addLayerListener=function(e,t,o,r,n){var i,a,s,c,t=t instanceof ed?t.getId():t,u=this.map.layers.getLayerById(t),l=this.mapCallbackHandler.getModifiedCallback(e,t,o);if(l&&u)try{for(var h=IC(u._getLayerIds()),d=h.next();!d.done;d=h.next()){var p=d.value;this.map._getMap().off(e,p,l)}}catch(e){i={error:e}}finally{try{d&&!d.done&&(a=h.return)&&a.call(h)}finally{if(i)throw i.error}}if(this.mapCallbackHandler.addCallback(e,t,o,r,n),u){l=this.mapCallbackHandler.getModifiedCallback(e,t,o);try{for(var f=IC(u._getLayerIds()),g=f.next();!g.done;g=f.next()){p=g.value;this.map._getMap().on(e,p,l)}}catch(e){s={error:e}}finally{try{g&&!g.done&&(c=f.return)&&c.call(f)}finally{if(s)throw s.error}}}},OC.prototype._addGlobalListener=function(e,t,o,r){var n,i,a,s;AC.includes(e)?this.map._addEventListener(e,t,r):(n=this.mapCallbackHandler.getModifiedCallback(e,"",t),this.mapCallbackHandler.addCallback(e,"",t,o,r),i=this.mapCallbackHandler.getModifiedCallback(e,"",t),"load"===e&&this.map._isLoaded()?(a={type:"load",map:this.map},setTimeout(function(){return i(a)})):"ready"===e?this.map._isReady()&&(s={type:"ready",map:this.map},setTimeout(function(){return i(s)})):(n&&this.map._getMap().off(e,n),this.map._getMap().on(e,i)))},OC.prototype.invoke=function(e,t,o){if(void 0===o)this._invokeListeners(e,"",t);else if(t instanceof ed&&ed._isMBoxEvent(e))this._invokeListeners(e,t.getId(),o);else{if(!(t instanceof Vt))throw new Error("The invoke target is invalid.");t._invokeEvent(e,o)}},OC.prototype._invokeListeners=function(o,r,n){var i=this,e=new Qt(this.mapCallbackHandler.getEventCallbacks(o,r));e?e.forEach(function(e,t){e=kC(e,2);e[0],e[1]&&i._removeListener(o,r,t),t(n)}):"error"===o&&console.error("error"in n?n.error:n)},OC.prototype.remove=function(e,t,o){var r,n;if("function"==typeof t)this._removeListener(e,"",t);else{t=Array.isArray(t)?t:[t];try{for(var i=IC(t),a=i.next();!a.done;a=i.next()){var s=a.value;s instanceof ed&&ed._isMBoxEvent(e)?this._removeListener(e,s,o):null!=s&&s._removeEventListener(e,o)}}catch(e){r={error:e}}finally{try{a&&!a.done&&(n=i.return)&&n.call(i)}finally{if(r)throw r.error}}}},OC.prototype._removeLegacy=function(e,t,o){"function"==typeof t?this._removeListener(e,"",t):this._removeListener(e,t,o)},OC.prototype._removeListener=function(e,t,o){var r,n;if(AC.includes(e))this.map._removeEventListener(e,o);else{var t=t instanceof ed?t.getId():t,i=this.mapCallbackHandler.getModifiedCallback(e,t,o);if(i)if(t){var a=this.map.layers.getLayerById(t);if(a)try{for(var s=IC(a._getLayerIds()),c=s.next();!c.done;c=s.next()){var u=c.value;this.map._getMap().off(e,u,i)}}catch(e){r={error:e}}finally{try{c&&!c.done&&(n=s.return)&&n.call(s)}finally{if(r)throw r.error}}}else this.map._getMap().off(e,i);this.mapCallbackHandler.removeCallback(e,t,o)}},OC.prototype._enableLayerEvents=function(c){var u=this,e=this.mapCallbackHandler.getLayerCallbacks(c.getId());e&&e.forEach(function(e,s){e.forEach(function(e){var t,o,r=kC(e,1)[0];try{for(var n=IC(c._getLayerIds()),i=n.next();!i.done;i=n.next()){var a=i.value;u.map._getMap().on(s,a,r)}}catch(e){t={error:e}}finally{try{i&&!i.done&&(o=n.return)&&o.call(n)}finally{if(t)throw t.error}}})})},OC.prototype._disableLayerEvents=function(c){var u=this,e=this.mapCallbackHandler.getLayerCallbacks(c.getId());e&&e.forEach(function(e,s){e.forEach(function(e){var t,o,r=kC(e,1)[0];try{for(var n=IC(c._getLayerIds()),i=n.next();!i.done;i=n.next()){var a=i.value;u.map._getMap().off(s,a,r)}}catch(e){t={error:e}}finally{try{i&&!i.done&&(o=n.return)&&o.call(n)}finally{if(t)throw t.error}}})})},OC);function OC(e){this.map=e,this.mapCallbackHandler=new EC(this.map)}var RC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},xC=(MC.prototype.add=function(e,t){var o,r;if(Array.isArray(e))try{for(var n=RC(e),i=n.next();!i.done;i=n.next()){var a=i.value;this._addMarker(a,t)}}catch(e){o={error:e}}finally{try{i&&!i.done&&(r=n.return)&&r.call(n)}finally{if(o)throw o.error}}else this._addMarker(e,t)},MC.prototype._addMarker=function(e,t){e._addToMap(this.map,t),this.markers.add(e)},MC.prototype.getMarkers=function(){return Array.from(this.markers)},MC.prototype.remove=function(e){var t,o;if(Array.isArray(e))try{for(var r=RC(e),n=r.next();!n.done;n=r.next()){var i=n.value;this._removeMarker(i)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}else this._removeMarker(e)},MC.prototype._removeMarker=function(t){var o=this;t instanceof mf?(t._removeFromMap(),this.markers.delete(t)):this.markers.forEach(function(e){e._getId()===t&&(e._removeFromMap(),o.markers.delete(e))})},MC.prototype.clear=function(){var t=this;this.markers.forEach(function(e){e._removeFromMap(),t.markers.delete(e)})},MC);function MC(e){this.markers=new Set,this.map=e}LC.prototype.add=function(a,t,s){var c=this;return new Promise(function(o,r){var n,e,i;c.userImages.has(a)?o():t instanceof HTMLImageElement||t instanceof ImageData?(c.map._getMap().addImage(a,t,s),c.userImages.set(a,{image:t,meta:s}),o()):"string"==typeof t&&(e=void 0,e=/<svg/i.test(t)&&!/^data:/i.test(t)?"data:image/svg+xml;base64,"+window.btoa(t):t,i=!1,c.map._sendRequest(e,"Image").then(function(e){return i?void 0:e.blob()}).then(function(e){var t;!i&&e&&(clearTimeout(n),(t=new Image).onload=function(){c.map._getMap().addImage(a,t,s),c.userImages.set(a,{image:t,meta:s}),o()},t.onerror=t.onabort=function(){r("Failed to load image into HTML element.")},t.src=URL.createObjectURL(e))}).catch(function(){i||(clearTimeout(n),r("Failed to load image into HTML element."))}),n=setTimeout(function(){i=!0,r("Failed to load image within specified timeout: ".concat(c.imageLoadTimeout," ms."))},c.imageLoadTimeout))})},LC.prototype.clear=function(){var o=this;this.userImages.forEach(function(e,t){o.map._getMap().removeImage(t)}),this.userImages.clear()},LC.prototype.getImageIds=function(){var o=[];return this.userImages.forEach(function(e,t){o.push(t)}),o},LC.prototype.createFromTemplate=function(e,t,o,r,n){o=o||"#1A73AA",r=r||"#fff";t=(t=Pt(t,n)).replace(/{color}/g,o).replace(/{secondaryColor}/g,r).replace(/{text}/g,"");return this.add(e,t)},LC.prototype.hasImage=function(e){return this.userImages.has(e)},LC.prototype.remove=function(e){this.map._getMap().removeImage(e),this.userImages.delete(e)},LC.prototype._restoreImages=function(){var o=this;this.userImages.forEach(function(e,t){o.map._getMap().hasImage(t)||o.map._getMap().addImage(t,e.image,e.meta)})};var NC=LC;function LC(e){this.userImages=new Qt,this.imageLoadTimeout=5e3,this.map=e}var DC,qC,e=window&&window.__extends||(DC=function(e,t){return(DC=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}DC(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),UC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},jC=(e(HC,qC=ed),HC.prototype.getOptions=function(){return{}},HC.prototype.setOptions=function(e){},HC.prototype._buildLayers=function(){return this.layers},HC.prototype._getLayerIds=function(){return this.layers.map(function(e){return e.id})},HC.prototype._getSourceIds=function(){var t,e,o=new Set;try{for(var r=UC(this.layers),n=r.next();!n.done;n=r.next()){var i=n.value;"source"in i&&"string"==typeof i.source?o.add(i.source):"source"in i&&i.source&&o.add(i.id)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(e=r.return)&&e.call(r)}finally{if(t)throw t.error}}return o},HC.prototype._updateLayoutProperty=function(t,o,e,r){var n;Xc(o,e)||(n=this.map._getMap(),this.layers.forEach(function(e){n.getLayer(e.id)?n.setLayoutProperty(e.id,t,r||o):console.warn("Could not update layout property ".concat(t," for layer ").concat(e.id," to ").concat(r||o))}))},HC);function HC(e,t){t=qC.call(this,t)||this;return t.layers=e,t}var BC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},FC=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},zC=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},KC=(GC.prototype.add=function(e,t){var o,r,n=t instanceof ed?t.getId():t;if(Array.isArray(e))try{for(var i=BC(e),a=i.next();!a.done;a=i.next()){var s=a.value;this._addLayer(s,n)}}catch(e){o={error:e}}finally{try{a&&!a.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}else this._addLayer(e,n)},GC.prototype._addLayer=function(t,o){if(!(this.map._isReady()||t instanceof jC))throw new Error("The layer '".concat(t.getId(),"' could not be added to the map because ")+"the map is not ready. Please use a ready event listener to guarantee the map is ready before adding a layer to it.");var e,r,n,i;o!==t.getId()&&this.layerIndex.find(function(e){return o===e.getId()})?this._getMapboxLayerExists(t)?(r=this.layerIndex.findIndex(function(e){return e.getId()===t.getId()}),n=this.userLayers.findIndex(function(e){return e.layer.getId()===t.getId()}),this._removeMapboxLayers(t),this._addMapboxLayers(t,o),(i=this.layerIndex[r])&&this.map.events._disableLayerEvents(i),this.map.events._enableLayerEvents(t),this.layerIndex.splice(r,1),e=this.layerIndex.findIndex(function(e){return e.getId()===o}),this.layerIndex.splice(e,0,t),t instanceof jC||(this.userLayers[n]={layer:t,before:o}),i&&i.onRemove()):(this._addMapboxLayers(t,o),this.map.events._enableLayerEvents(t),e=this.layerIndex.findIndex(function(e){return e.getId()===o}),this.layerIndex.splice(e,0,t),t instanceof jC||this.userLayers.push({layer:t,before:o})):(r=this.layerIndex.findIndex(function(e){return e.getId()===t.getId()}),n=this.userLayers.findIndex(function(e){return e.layer.getId()===t.getId()}),0<=r&&0<=n?(i=this.layerIndex[r],this._removeMapboxLayers(i),this._addMapboxLayers(t,r+1),this.map.events._disableLayerEvents(i),this.map.events._enableLayerEvents(t),(this.layerIndex[r]=t)instanceof jC||(this.userLayers[n]={layer:t,before:void 0}),i.onRemove()):(this._addMapboxLayers(t),this.map.events._enableLayerEvents(t),this.layerIndex.push(t),t instanceof jC||this.userLayers.push({layer:t,before:o}))),t.onAdd(this.map)},GC.prototype._addMapboxLayers=function(e,t){var o,r;if(!(e instanceof jp)||e.getOptions().tileUrl){if(!(e instanceof jC)){e instanceof Md&&(this.map._getMap().addSource(e._getSourceId(),e._buildSource()),this.map.sources.setSourceState(e._getSourceWrapper()));var n=this._getMapboxBefore(t);try{for(var i=BC(e._buildLayers()),a=i.next();!a.done;a=i.next()){var s=a.value;this.map._getMap().addLayer(s,n)}}catch(e){o={error:e}}finally{try{a&&!a.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}}this.map.events._enableLayerEvents(e)}},GC.prototype._removeMapboxLayers=function(e,t){var o,r;if(e instanceof jC&&!t)this.map.events._disableLayerEvents(e);else{try{for(var n=BC(e._getLayerIds()),i=n.next();!i.done;i=n.next()){var a=i.value;this.map._getMap().getLayer(a)&&this.map._getMap().removeLayer(a)}}catch(e){o={error:e}}finally{try{i&&!i.done&&(r=n.return)&&r.call(n)}finally{if(o)throw o.error}}this.map.events._disableLayerEvents(e),e instanceof Md&&this.map._getMap().getSource(e._getSourceId())&&this.map._getMap().removeSource(e._getSourceId())}},GC.prototype._getMapboxLayerExists=function(t){var o=this,r=!1;return"string"==typeof t?!!(t=this.layerIndex.find(function(e){return e.getId()===t})):(t._getLayerIds().forEach(function(e){o.map._getMap().getLayer(e)&&(r=!0)}),r)},GC.prototype._getMapboxBefore=function(t){var o,e,r,n;if("string"==typeof t){var i=this.layerIndex.find(function(e){return e.getId()===t});if(!i)return;try{for(var a=BC(i._getLayerIds()),s=a.next();!s.done;s=a.next()){var c=s.value;if(this.map._getMap().getLayer(c))return c}}catch(e){o={error:e}}finally{try{s&&!s.done&&(e=a.return)&&e.call(a)}finally{if(o)throw o.error}}t=this.layerIndex.findIndex(function(e){return e.getId()===t})+1}for(var u=t;u<this.layerIndex.length;u++)try{r=void 0;for(var l=BC(this.layerIndex[u]._getLayerIds()),h=l.next();!h.done;h=l.next()){c=h.value;if(this.map._getMap().getLayer(c))return c}}catch(e){r={error:e}}finally{try{h&&!h.done&&(n=l.return)&&n.call(l)}finally{if(r)throw r.error}}},GC.prototype.clear=function(){for(var e=this.layerIndex.length-1;0<=e;e--){var t=this.layerIndex[e];t&&(this._removeMapboxLayers(t,!0),this.layerIndex.splice(e,1),t.onRemove())}this.userLayers=[]},GC.prototype.getLayerById=function(t){var e=this.layerIndex.find(function(e){return e.getId()===t});if(e)return e},GC.prototype.getLayers=function(){return this.layerIndex.slice(0)},GC.prototype._getSourceIds=function(){var t,e,o=new Set;try{for(var r=BC(this.layerIndex),n=r.next();!n.done;n=r.next())n.value._getSourceIds().forEach(function(e){return o.add(e)})}catch(e){t={error:e}}finally{try{n&&!n.done&&(e=r.return)&&e.call(r)}finally{if(t)throw t.error}}return o},GC.prototype._getUserLayers=function(){return Array.from(this.userLayers)},GC.prototype.move=function(e,t){var o=e instanceof ed?e.getId():e,r=t instanceof ed?t.getId():t;if(!this.layerIndex.find(function(e){return e.getId()===o}))throw new Error("The layer '".concat(o,"' has not been added to the map and cannot be moved."));t=this.layerIndex.findIndex(function(e){return e.getId()===o}),this._moveMapboxLayers(this.layerIndex[t],r),e=this.layerIndex[t],this.layerIndex.splice(t,1),t=this.layerIndex.findIndex(function(e){return e.getId()===r}),-1<t?this.layerIndex.splice(t,0,e):this.layerIndex.push(e),t=this.userLayers.find(function(e){return e.layer.getId()===o});t&&(t.before=r)},GC.prototype._moveMapboxLayers=function(e,t){var o,r,n=this._getMapboxBefore(t);try{for(var i=BC(e._getLayerIds()),a=i.next();!a.done;a=i.next()){var s=a.value;this.map._getMap().moveLayer(s,n)}}catch(e){o={error:e}}finally{try{a&&!a.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}},GC.prototype.getRenderedShapes=function(e,t,o){var r,n,i,a=this;if(e=e||[-180,-85.0511,180,85.0511],Array.isArray(e)?4===e.length||6===e.length?i=this.map.positionsToPixels([f.getSouthWest(e),f.getNorthEast(e)]):2!==e.length&&3!==e.length||(i=this.map.positionsToPixels([e])[0]):i=this.map.positionsToPixels([e.coordinates])[0],t){t=Array.isArray(t)?t:[t];var s=[],c=this;try{for(var u=BC(t),l=u.next();!l.done;l=u.next())!function(e){var t=e instanceof ed?e.getId():e,e=c.layerIndex.findIndex(function(e){return e.getId()===t});if(!(-1<e))throw new Error("The layer '".concat(t,"' has not been added to the map ")+"and its rendered features cannot be retrieved.");s.push.apply(s,zC([],FC(c.layerIndex[e]._getLayerIds().filter(function(e){return!!a.map._getMap().getLayer(e)})),!1))}(l.value)}catch(e){r={error:e}}finally{try{l&&!l.done&&(n=u.return)&&n.call(u)}finally{if(r)throw r.error}}}e=this.map._getMap().queryRenderedFeatures(i,{layers:s,filter:o});return this.map.sources._mapFeaturesToShapes(e)},GC.prototype.remove=function(e){var t,o;if(Array.isArray(e))try{for(var r=BC(e),n=r.next();!n.done;n=r.next()){var i=n.value;this._removeLayer(i)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}else this._removeLayer(e)},GC.prototype._removeLayer=function(e){var t=e instanceof ed?e.getId():e,o=this.layerIndex.findIndex(function(e){return e.getId()===t});if(-1==o)throw new Error("The layer '".concat(t,"' has not been added to the map and cannot be removed."));var r=this.layerIndex[o],o=(this._removeMapboxLayers(r),this.layerIndex.splice(o,1),this.userLayers.findIndex(function(e){return e.layer.getId()===t}));-1!=o&&this.userLayers.splice(o,1),e instanceof Md&&this.map.sources.unsetSourceState(e._getSourceId()),r.onRemove()},GC);function GC(e){this.layerIndex=[],this.userLayers=[],this.map=e}var YC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},WC=(ZC.prototype.add=function(e){var t,o;e=Array.isArray(e)?e:[e];try{for(var r=YC(e),n=r.next();!n.done;n=r.next()){var i=n.value;this.popups.has(i)||(this.popups.add(i),i.attach(this.map))}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}},ZC.prototype.clear=function(){var t=this;this.popups.forEach(function(e){t.popups.delete(e),e.remove()})},ZC.prototype.remove=function(e){var t,o;e=Array.isArray(e)?e:[e];try{for(var r=YC(e),n=r.next();!n.done;n=r.next()){var i=n.value;this.popups.has(i)&&(this.popups.delete(i),i.remove())}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}},ZC.prototype.getPopups=function(){return Array.from(this.popups)},ZC.prototype._getCollectionDiv=function(){var e=this.map.getMapContainer().querySelector(".".concat(ZC.Css.collection));return e||((e=document.createElement("div")).classList.add(ZC.Css.collection),e.setAttribute("aria-label","Map Information"),this.map.getMapContainer().appendChild(e)),e},ZC.prototype._addDraggedPopup=function(e){0===this.draggedPopups.size&&(this.map.getMapContainer().addEventListener("mousemove",this._onDrag),this.map.getMapContainer().addEventListener("touchmove",this._onDrag),this.map.getMapContainer().addEventListener("mouseup",this._onUp),this.map.getMapContainer().addEventListener("touchend",this._onUp)),this.draggedPopups.add(e)},ZC.Css={collection:"popup-collection-container"},ZC);function ZC(e){var r=this;this._onDrag=function(e){var t,o;"mousemove"===e.type?(t=e.clientX,o=e.clientY):"touchmove"===e.type&&(t=e.touches[0].clientX,o=e.touches[0].clientY),r.draggedPopups.forEach(function(e){e._dragToPixel([t,o])})},this._onUp=function(){r.map.getMapContainer().removeEventListener("mousemove",r._onDrag),r.map.getMapContainer().removeEventListener("touchmove",r._onDrag),r.map.getMapContainer().removeEventListener("mouseup",r._onUp),r.map.getMapContainer().removeEventListener("touchend",r._onUp),r.draggedPopups.forEach(function(e){r.draggedPopups.delete(e),e._onUp()})},this.map=e,this.popups=new Set,this.draggedPopups=new Set}var QC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},VC=(JC.prototype.add=function(e,t){var o,r;if(void 0===t&&(t=!0),Array.isArray(e))try{for(var n=QC(e),i=n.next();!i.done;i=n.next()){var a=i.value;this._addSource(a,t)}}catch(e){o={error:e}}finally{try{i&&!i.done&&(r=n.return)&&r.call(n)}finally{if(o)throw o.error}}else this._addSource(e,t)},JC.prototype.getRenderedShapes=function(e,t,o){e="string"==typeof e?e:e.getId(),o=this.map._getMap().querySourceFeatures(e,{sourceLayer:o,filter:t});return this.map.sources._mapFeaturesToShapes(o,!0,this.sources.get(e))},JC.prototype.getFeatureState=function(e,t,o){e="string"==typeof e?e:e instanceof vl?e.getId():e.id,t="string"==typeof t?t:t.getId();return this.map._getMap().getFeatureState({id:e,source:t,sourceLayer:o})},JC.prototype.removeFeatureState=function(e,t,o,r){e="string"==typeof e?e:e instanceof vl?e.getId():e.id,t="string"==typeof t?t:t.getId();this.map._getMap().removeFeatureState({id:e,source:t,sourceLayer:o},r)},JC.prototype.setFeatureState=function(e,t,o,r){e="string"==typeof e?e:e instanceof vl?e.getId():e.id,t="string"==typeof t?t:t.getId();this.map._getMap().setFeatureState({id:e,source:t,sourceLayer:r},o)},JC.prototype._buildSources=function(){var t={};return this.sources.forEach(function(e){t[e.getId()]=e._buildSource()}),t},JC.prototype.clear=function(){var t=this;this.sources.forEach(function(e){t.remove(e)})},JC.prototype.getById=function(e){return this.sources.get(e)},JC.prototype.getSources=function(){return Array.from(this.sources.values())},JC.prototype.isSourceLoaded=function(e){e=e instanceof lh?e.getId():e;return this.map._getMap().isSourceLoaded(e)},JC.prototype.remove=function(e,t){var o,r;if(void 0===t&&(t=!0),Array.isArray(e))try{for(var n=QC(e),i=n.next();!i.done;i=n.next()){var a=i.value;this._removeSource(a,t)}}catch(e){o={error:e}}finally{try{i&&!i.done&&(r=n.return)&&r.call(n)}finally{if(o)throw o.error}}else this._removeSource(e,t)},JC.prototype.setSourceState=function(e,t){void 0===t&&(t=!0),this.sources.set(e.getId(),e),e._setMap(this.map,t)},JC.prototype.unsetSourceState=function(e){this.sources.has(e)&&(this.sources.get(e)._setMap(null),this.sources.delete(e))},JC.prototype._removeSource=function(e,t){e=e instanceof lh?e.getId():e;if(!this.sources.has(e))throw new Error("'".concat(e,"' is not added to the map"));if(this.map._getMap().getSource(e)&&t&&this.map._getMap().removeSource(e),this.map._getMap().getSource(e)&&t)throw new Error("One or more layers have a dependency on the source '".concat(e,"'"));this.unsetSourceState(e)},JC.prototype._addSource=function(e,t){if(this.sources.has(e.getId())){if(t)throw new Error("'".concat(e.getId(),"' is already added to the map"));this.unsetSourceState(e.getId())}if(t){if(!this.map._isReady())throw new Error("The source '".concat(e.getId(),"' could not be added to the map because ")+"the map is not ready. Please use a ready event listener to guarantee the map is ready before adding a source to it.");this.map._getMap().addSource(e.getId(),e._buildSource())}this.setSourceState(e)},JC.prototype._mapFeaturesToShapes=function(e,t,o){var r,n,i=[];try{for(var a=QC(e),s=a.next();!s.done;s=a.next()){var c=s.value;if((o||"string"==typeof c.source)&&"string"==typeof c.properties[vl._shapeIdPropName]){var u=o||this.sources.get(c.source);if(u instanceof gh){var l=u.getShapeById(c.properties[vl._shapeIdPropName]);if(l instanceof vl){i.push(l);continue}}}t||i.push(c)}}catch(e){r={error:e}}finally{try{s&&!s.done&&(n=a.return)&&n.call(a)}finally{if(r)throw r.error}}return i},JC.prototype._syncSources=function(n){var r=this;n?(Object.keys(n).map(function(e){var t,o=n[e];switch(o.type){case"vector":case"raster":case"raster-dem":t=new Pp(e,{name:e,tiles:o.tiles,type:o.type,url:o.url,tileSize:"tileSize"in o?o.tileSize:void 0});break;case"canvas":t=new kh(e,o);break;case"geojson":var r=new gh(e,{maxZoom:o.maxzoom,cluster:o.cluster,clusterRadius:o.clusterRadius,tolerance:o.tolerance,lineMetrics:o.lineMetrics,clusterProperties:o.clusterProperties,buffer:o.buffer,clusterMinPoints:o.clusterMinPoints,generateId:o.generateId,promoteId:o.promoteId,filter:o.filter});"string"!=typeof o.data&&void 0!==o.data&&r._addNoUpdate(o.data),t=r;break;case"image":t=new Lh(e,o);break;case"video":t=new jh(e,o);break;default:t=new Rh(e,o)}return t}).forEach(function(e){var t=r.sources.get(e.getId()),o=t&&e._isDeepEqual(t);!o&&t&&r.unsetSourceState(t.getId()),r.setSourceState(e,!o)}),Array.from(this.sources.keys()).filter(function(e){return!(e in n)}).forEach(function(e){return r.unsetSourceState(e)})):console.warn("syncSources called with no style sources which is unexpected.")},JC);function JC(e){this.map=e,this.sources=new Qt}(window&&window.__extends||(XC=function(e,t){return(XC=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}XC(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(tS,$C=ye);var XC,$C,eS=tS;function tS(){var e=null!==$C&&$C.apply(this,arguments)||this;return e.duration=1e3,e.type="jump",e}(window&&window.__extends||(oS=function(e,t){return(oS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}oS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(iS,rS=ye);var oS,rS,nS=iS;function iS(){var e=null!==rS&&rS.apply(this,arguments)||this;return e.bottom=0,e.left=0,e.right=0,e.top=0,e}var aS,sS,Fr=window&&window.__extends||(aS=function(e,t){return(aS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}aS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),cS=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},uS=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},lS=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},hS=(Fr(dS,sS=ye),dS.prototype.merge=function(){for(var t,e,o=[],r=0;r<arguments.length;r++)o[r]=arguments[r];try{for(var n=cS(o),i=n.next();!i.done;i=n.next()){var a=i.value;a&&"number"==typeof a.padding&&(a.padding={top:a.padding,bottom:a.padding,left:a.padding,right:a.padding})}}catch(e){t={error:e}}finally{try{i&&!i.done&&(e=n.return)&&e.call(n)}finally{if(t)throw t.error}}return sS.prototype.merge.apply(this,lS([],uS(o),!1))},dS);function dS(){var e=null!==sS&&sS.apply(this,arguments)||this;return e.bounds=[-180,-89,180,90],e.maxBounds=void 0,e.maxZoom=20,e.offset=new ru(0,0),e.padding=new nS,e}(window&&window.__extends||(pS=function(e,t){return(pS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}pS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(mS,fS=ye);var pS,fS,gS=mS;function mS(){var e=null!==fS&&fS.apply(this,arguments)||this;return e.zoom=1,e.center=new hl(0,0),e.centerOffset=new ru(0,0),e.bearing=0,e.pitch=0,e.minZoom=1,e.maxZoom=20,e.minPitch=0,e.maxPitch=60,e.maxBounds=void 0,e}(window&&window.__extends||(yS=function(e,t){return(yS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}yS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(_S,vS=ye);var yS,vS,r=_S;function _S(){var e=null!==vS&&vS.apply(this,arguments)||this;return e.name=void 0,e.before=void 0,e.minZoom=1,e.maxZoom=20,e.overwrite=!1,e.opacity=1,e}(window&&window.__extends||(wS=function(e,t){return(wS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}wS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(SS,bS=r);var wS,bS,CS=SS;function SS(){var e=null!==bS&&bS.apply(this,arguments)||this;return e.color="rgba(0,0,0,.5)",e.outlineColor="#000",e.radius=1,e.outlineWidth=5,e.name="default-circles",e}(window&&window.__extends||(ES=function(e,t){return(ES=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}ES(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(kS,TS=r);var ES,TS,IS=kS;function kS(){var e=null!==TS&&TS.apply(this,arguments)||this;return e.cap="butt",e.join="miter",e.name="default-linestrings",e.color="#000",e.width=1,e}(window&&window.__extends||(AS=function(e,t){return(AS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}AS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(RS,PS=r);var AS,PS,OS=RS;function RS(){var e=null!==PS&&PS.apply(this,arguments)||this;return e.iconSize=1,e.fontSize=14,e.fontColor="#000",e.textFont="SegoeUi-Regular",e.cluster=!0,e.clusterIcon=void 0,e.textOffset=[0,0],e.name="default-pins",e.icon="pin-darkblue",e.title="",e}(window&&window.__extends||(xS=function(e,t){return(xS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}xS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(LS,MS=r);var xS,MS,NS=LS;function LS(){var e=null!==MS&&MS.apply(this,arguments)||this;return e.color="rgba(0,0,0,.5)",e.outlineColor="#000",e.name="default-polygons",e}(window&&window.__extends||(DS=function(e,t){return(DS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}DS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(jS,qS=r);var DS,qS,US=jS;function jS(){var e=null!==qS&&qS.apply(this,arguments)||this;return e.name="default-raster",e}(window&&window.__extends||(HS=function(e,t){return(HS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}HS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}))(zS,BS=ye);var HS,BS,FS=zS;function zS(){var e=null!==BS&&BS.apply(this,arguments)||this;return e.anchor="map",e.color="#FFFFFF",e.intensity=.5,e.position=[1.15,210,30],e}var KS,GS,be=window&&window.__extends||(KS=function(e,t){return(KS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}KS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),YS=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},WS=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},ZS=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},QS=(be(VS,GS=ye),VS.prototype.merge=function(){for(var t,e,o=[],r=0;r<arguments.length;r++)o[r]=arguments[r];try{for(var n=YS(o),i=n.next();!i.done;i=n.next()){var a=i.value;a&&(a.hasOwnProperty("view")?a.userRegion=a.view:a.hasOwnProperty("userRegion")&&(a.view=a.userRegion),"string"==typeof a.language)&&(a.language=Re.getCode(a.language))}}catch(e){t={error:e}}finally{try{i&&!i.done&&(e=n.return)&&e.call(n)}finally{if(t)throw t.error}}return GS.prototype.merge.apply(this,ZS([],WS(o),!1))},VS);function VS(){var e=null!==GS&&GS.apply(this,arguments)||this;return e.antialias=void 0,e.autoResize=!0,e.language=Ge,e.light=new FS,e.preserveDrawingBuffer=!1,e.progressiveLoading=!1,e.progressiveLoadingInitialLayerGroups=["base"],e.renderWorldCopies=!0,e.showBuildingModels=!1,e.showFeedbackLink=!0,e.showLogo=!0,e.showLabels=!0,e.customAttribution=void 0,e.showTileBoundaries=!1,e.style=void 0,e.view=Ke,e.userRegion=e.view,e.styleOverrides=void 0,e.customStyleTransform=void 0,e}function JS(e){return 0==e.length?void 0:e.slice(1).reduce(function(o,r){return function(e,t){e=o(e,t);return eE(eE({},e),r(e.url,t))}},e[0])}var XS,$S,xi=window&&window.__extends||(XS=function(e,t){return(XS=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}XS(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),eE=window&&window.__assign||function(){return(eE=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},tE=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},oE=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},rE=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},nE=(xi(iE,$S=ye),iE.prototype.merge=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var o=this.styleDefinitionsVersion;try{for(var r=tE(e),n=r.next();!n.done;n=r.next()){var i=n.value;i&&(i.authOptions?"string"==typeof i.authOptions.subscriptionKey&&(i.subscriptionKey=i["subscription-key"]=i.authOptions.subscriptionKey):"string"==typeof i.subscriptionKey?(i["subscription-key"]=i.subscriptionKey,i.authOptions={authType:l.AuthenticationType.subscriptionKey,subscriptionKey:i.subscriptionKey}):"string"==typeof i["subscription-key"]&&(i.subscriptionKey=i["subscription-key"],i.authOptions={authType:l.AuthenticationType.subscriptionKey,subscriptionKey:i["subscription-key"]}),"string"==typeof i.sessionId?i["session-id"]=i.sessionId:"string"==typeof i["session-id"]&&(i.sessionId=i["session-id"]),"boolean"==typeof i.disableTelemetry?i["disable-telemetry"]=i.disableTelemetry:"boolean"==typeof i["disable-telemetry"]&&(i.disableTelemetry=i["disable-telemetry"]),"boolean"==typeof i.enableAccessibility?i["enable-accessibility"]=i.enableAccessibility:"boolean"==typeof i["enable-accessibility"]&&(i.enableAccessibility=i["enable-accessibility"]))}}catch(e){c={error:e}}finally{try{n&&!n.done&&(s=r.return)&&s.call(r)}finally{if(c)throw c.error}}var a=this._transformers,s=e?e.filter(function(e){return void 0!==e}).reduce(function(e,t){return rE(rE([],oE(e),!1),oE(t._transformers||[]),!1)},[]):[],c=$S.prototype.merge.apply(this,rE([],oE(e),!1)),s=(c.authOptions.authType!==l.AuthenticationType.subscriptionKey&&(c["subscription-key"]=c.subscriptionKey=void 0),void 0!==c.styleSet&&void 0===c.mapConfiguration&&(c.mapConfiguration=c.styleSet),c.mapConfiguration&&"string"!=typeof c.mapConfiguration&&(c.mapConfiguration=eE(eE({},c.mapConfiguration),{defaultConfiguration:c.mapConfiguration.defaultConfiguration||c.mapConfiguration.defaultStyle,configurations:c.mapConfiguration.configurations||c.mapConfiguration.styles})),this._transformers=rE(rE([],oE(a||[]),!1),oE(s.filter(function(e){return!a.includes(e)})),!1),this.transformRequest&&!this._transformers.includes(this.transformRequest)&&this._transformers.push(this.transformRequest),new Date(Date.UTC(2023,0))),u=new Date(this.styleDefinitionsVersion);return(isNaN(u.getTime())||u.getTime()<s.getTime())&&(console.warn("Style definition version ".concat(this.styleDefinitionsVersion," is invalid or deprecated, style definition version is unchanged (").concat(o,")")),this.styleDefinitionsVersion=o),this.transformRequest=JS(this._transformers),c},iE.prototype.addTransformer=function(e){this._transformers||(this._transformers=[]),this._transformers.push(e),this.transformRequest=JS(this._transformers)},iE.prototype.removeTransformer=function(t){this._transformers&&(this._transformers=this._transformers.filter(function(e){return t!==e}),this.transformRequest=JS(this._transformers))},iE._cloneCustomizer=function(e){if("object"==typeof e)return Object.assign({},e)},iE);function iE(){var e=null!==$S&&$S.apply(this,arguments)||this;return e.authOptions=ct(),e.disableTelemetry=!0,e["disable-telemetry"]=e.disableTelemetry,e.domain=We,e.staticAssetsDomain=Ze,e.styleDefinitionsPath=Qe,e.styleDefinitionsVersion=Ve,e.styleAPIVersion=Je,e.mapConfiguration=void 0,e.styleSet=void 0,e.enableAccessibility=!0,e["enable-accessibility"]=e.enableAccessibility,e.enableAccessibilityLocationFallback=!0,e.maxParallelImageRequests=gt(),e.refreshExpiredTiles=!0,e.subscriptionKey=vt(),e["subscription-key"]=e.subscriptionKey,e.sessionId=Ye,e["session-id"]=e.sessionId,e._transformers=[],e.transformRequest=void 0,e.workerCount=ft(),e.fadeDuration=300,e.localIdeographFontFamily="sans-serif",e.validateStyle=!1,e}sE.getLayerGroup=function(e){return"string"!=typeof e&&e.metadata&&e.metadata["microsoft.maps:layerGroup"]?e.metadata["microsoft.maps:layerGroup"]:(e="string"!=typeof e?e.id:e).startsWith("microsoft.")&&4<=(e=e.split(".")).length?e[3]:void 0};var aE=sE;function sE(){}uE.resolve=function(e){return new uE(Promise.resolve(e))},uE.reject=function(e){return new uE(Promise.reject(e))},uE.prototype.then=function(e,t){var o=this;return new Promise(function(e,t){o._resolve=e,o._reject=t,o._thenResolver(e,t)}).then(e,t)},uE.prototype.catch=function(e){var o=this;return new Promise(function(e,t){o._resolve=e,o._reject=t,o._thenResolver(e,t)}).catch(e)},uE.prototype.finally=function(e){var o=this;return new Promise(function(e,t){o._resolve=e,o._reject=t,o._thenResolver(e,t)}).finally(e)},uE.prototype.hijackAndResolve=function(e){this._hijackedToResolve=e,this._resolve&&this._resolve(e)},uE.prototype.hijackAndReject=function(e){this._hijackedToReject=e,this._reject&&this._reject(e)},uE.prototype.switchWith=function(e){this.origin=e,this._toResolve=void 0,this._toReject=void 0};var cE=uE;function uE(e){var n=this;this.isHijacked=function(){return void 0!==n._hijackedToResolve||void 0!==n._hijackedToReject},this.isResolved=function(){return void 0!==n._hijackedToResolve||void 0!==n._toResolve},this.isRejected=function(){return void 0!==n._hijackedToReject||void 0!==n._toReject},this.resultIfResolved=function(){return n._hijackedToResolve||n._toResolve},this.errorIfRejected=function(){return n._hijackedToReject||n._toReject},this._thenResolver=function(t,o){var r;n._hijackedToResolve?t(n._hijackedToResolve):n._hijackedToReject?o(n._hijackedToReject):(r=n.origin,n.origin.then(function(e){n.isHijacked()||(r!==n.origin?n._thenResolver(t,o):(n._toResolve=e,t(e)))}).catch(function(e){n.isHijacked()||(r!==n.origin?n._thenResolver(t,o):(n._toReject=e,o(e)))}))},this.origin=e,this[Symbol.toStringTag]=this.origin[Symbol.toStringTag]}var lE={road:"Road",satellite:"Satellite",satellite_road_labels:"Hybrid",grayscale_dark:"Grayscale (Dark)",grayscale_light:"Grayscale (Light)",night:"Night",road_shaded_relief:"Terra",blank:"Blank",blank_accessible:"Blank (Accessible)",high_contrast_dark:"High contrast (Dark)",high_contrast_light:"High contrast (Light)"},hE=window&&window.__assign||function(){return(hE=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},dE=window&&window.__awaiter||function(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})},pE=window&&window.__generator||function(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},u={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function e(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c=u&&t[u=0]?0:c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},fE=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},gE=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},mE=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},yE={countryRegion:"cr|bv:0",adminDistrict:"ad|bv:0",adminDistrict2:"ds|bv:0",buildingFootprint:"bld|v:0_adr|lv:0",roadDetails:"g|rasterDetailsVisible:0"},vE=(_E.prototype.updateIndoorState=function(e,t){var o,r,n=this,i=this.map.styles.getMapConfiguration();i?(this.preservedPreindoorMapConfiguration=i,o=this.map.getStyle().style?"".concat(this.map.getStyle().style,"_indoor").concat("dark"===e?"_dark":"","_tileset_").concat(t):void 0,this.map.styles.setMapConfiguration("defaultIndoor_".concat(t),"microsoft-maps:default"===i?o:void 0)):(r=(null==(i=this.indoorState)?void 0:i.tilesetId)!==t,this.indoorState={tilesetId:t,theme:e},this.initStyleset(),this.definitions().then(function(e){var t=(n.map.getStyle().style||e.defaultConfiguration).replace("_indoor_dark","").replace("_indoor",""),o="".concat(t,"_indoor"),t=e.configurations.find(function(e){return e.name.startsWith(o)});t&&n.map.setStyle({style:t.name},!r)}))},_E.prototype.unsetIndoorState=function(){var o=this,e=this.preservedPreindoorMapConfiguration;e?this.map.styles.setMapConfiguration(e):(this.indoorState=void 0,this.initStyleset(),this.definitions().then(function(e){var t=o.map.getStyle().style;t.includes("_indoor")&&t.split("_indoor")[0]?o.map.setStyle({style:t.split("_indoor")[0]}):o.map.setStyle({style:void 0})}))},_E.prototype.initStyleset=function(){var e,o=this;return e=this.serviceOptions.mapConfiguration?"string"==typeof this.serviceOptions.mapConfiguration?(e=this.map.authentication?this.map.authentication.initialize():Promise.resolve(),new cE(e.then(function(){return o._request(o.serviceOptions.domain,"".concat(ue,"/mapconfigurations/metadata/").concat(o.serviceOptions.mapConfiguration),"StyleDefinitions").then(function(e){return hE(hE({},e),{defaultConfiguration:e.defaultConfiguration||e.defaultStyle,configurations:e.configurations||e.styles})})}))):cE.resolve(this.serviceOptions.mapConfiguration):(e=this.map.authentication?this.map.authentication.initialize():Promise.resolve(),new cE(e.then(function(){return o._request(o.serviceOptions.staticAssetsDomain,"".concat(ce,"/").concat(ue),"StyleDefinitions",{version:o.serviceOptions.styleDefinitionsVersion,mcv:Le.replace(/\./g,"")}).then(function(t){return{version:isNaN(t.version)?0:parseFloat(t.version),defaultConfiguration:t.defaultStyle,configurations:t.styles.filter(function(e){return o.indoorState?"auto"===o.indoorState.theme?e.name.endsWith("dark"===e.theme?"_indoor_dark":"_indoor"):e.name.endsWith("dark"===o.indoorState.theme?"_indoor_dark":"_indoor"):!e.name.includes("indoor")}).map(function(e){return{copyright:e.copyright.join(" "),name:e.name,displayName:function(e){e=o.indoorState&&e.includes("_indoor")?e.split("_indoor")[0]:e;return e in lE?lE[e]:e}(e.name),theme:e.theme,thumbnail:new Te({domain:o.serviceOptions.staticAssetsDomain,path:e.thumbnail,protocol:"https"}).toString(),url:new Te({domain:o.serviceOptions.staticAssetsDomain,path:"".concat(ce,"/").concat(ue,"/").concat(e.name),queryParams:{styleVersion:void 0!==t.version&&null!==t.version?t.version:o.serviceOptions.styleDefinitionsVersion,mcv:Le.replace(/\./g,"")},protocol:"https"}).toString()}})}})}))),this.initPromise&&this.initPromise.switchWith(e),this.initPromise=e,this.initPromise.then(function(e){return o.map._invokeEvent("mapconfigurationchanged",e)}),this.initPromise},_E.prototype.getStyle=function(e){e=this._lookUp(e);if(!e)throw Error("Style definition is not available.");if(e.url)return e.url;if(e.style)return e.style;throw Error("Style definition neither contains URL nor style object.")},_E.prototype.deriveNewStyleAndLayerGroups=function(e,t){for(var o,r,n=this.map.getStyle(),i=this.map.getTraffic(),a={},s=0;s<t.layers.length;s++){var c=t.layers[s],u=aE.getLayerGroup(c);u?(a[u]||(a[u]=[]),a[u].push(c),n.showBuildingModels||"fill-extrusion"!==c.type?"fill-extrusion"===c.type&&(c.layout=null!=(o=c.layout)?o:{},c.layout.visibility="visible"):(c.layout=null!=(o=c.layout)?o:{},c.layout.visibility="none"),"none"!==i.flow&&u&&u==="traffic_".concat(i.flow)&&"line"==c.type&&(c.layout=null!=(r=c.layout)?r:{},c.layout.visibility="visible"),"labels"!==u&&"labels_places"!==u&&"labels_indoor"!==u||"symbol"!==c.type||(n.showLabels&&"none"!==(null==(r=c.layout)?void 0:r.visibility)?(c.layout=null!=(u=c.layout)?u:{},c.layout.visibility="visible"):(c.layout=null!=(u=c.layout)?u:{},c.layout.visibility="none"))):a[c.id]=[c]}return[t,a]},_E.prototype.injectUserLayersIntoStyle=function(a,s,c){return a?this.map.layers._getUserLayers().reduce(function(o,t){var r,e,n,i;return t.layer instanceof Wp||(r=(null==(e=null==(e=null==c?void 0:c[t.before])?void 0:e[0])?void 0:e.id)||t.before,e=a.layers.find(function(e){return e.id===t.layer.getId()}),-1<(n=s.layers.findIndex(function(e){return e.id===t.layer.getId()}))&&s.layers.splice(n,1),e&&(n=new Set(Array.from(t.layer._getSourceIds()).map(function(e){var t;return!o.sources[e]&&(t=a.sources[e])?{source:t,id:e}:void 0}).filter(function(e){return void 0!==e})),-1<(i=r?o.layers.findIndex(function(e){return e.id===r}):-1)?o.layers.splice(i,0,e):o.layers.push(e),n.forEach(function(e){var t=e.source,e=e.id;o.sources[e]=t}))),o},hE({},s)):s},_E.prototype.setStyle=function(n,e){var i=this,t=(void 0===e&&(e=!0),this._lookUp(n));if(!t)throw Error("Style definition ".concat(n.style," is not available."));if(!t.url&&!t.style)throw Error("Style definition neither contains URL nor style object.");var o,r,a,s=function(){return i._onStyleData(t)},c=function(){i.map.events.remove("styledata",s),i.map.events.addOnce("styledata",s)},u=n&&n.customStyleTransform?function(e,t){e=n.customStyleTransform(e,t);return c(),e}:function(e,t){var o=hE(hE({},t),{layers:gE([],fE(t.layers),!1),sources:hE({},t.sources)}),r=n.progressiveLoading&&!i.map._isLoaded(),t=(r&&Array.isArray(null==t?void 0:t.layers)&&((o=hE({},t)).layers=o.layers.map(function(e){var t=hE({},e);return e.layout&&(t.layout=hE({},e.layout)),t})),fE(i.deriveNewStyleAndLayerGroups(e,o),2)),o=t[0],t=t[1],r=(r&&(r=n.progressiveLoadingInitialLayerGroups,Array.isArray(r))&&0<r.length&&i._deferLayerGroupVisibilities(t,r),i.injectUserLayersIntoStyle(e,o,t)),e=Object.entries(t).map(function(e){var e=fE(e,2),t=e[0],e=e[1];return i._buildFundamentalLayerFrom(e,t)}),o=i.map.layers._getUserLayers().reduce(function(e,t){var o=t.before?e.findIndex(function(e){return e.getId()===t.before}):-1;return-1<o?e.splice(o,0,t.layer):e.push(t.layer),e},e);return i.map.layers.layerIndex=o,i.map.sources._syncSources(r.sources),c(),r},l=t.url;l&&null!=n&&n.styleOverrides&&(o=new URL(l),r=new URLSearchParams(o.search),0<(a=Object.entries(null==n?void 0:n.styleOverrides).filter(function(e){var e=fE(e,2),t=e[0],e=e[1];return t in yE&&(yE[t].includes("bv")&&!1===(null==e?void 0:e.borderVisible)||!yE[t].includes("bv")&&!1===(null==e?void 0:e.visible))}).map(function(e){var e=fE(e,2),t=e[0];return e[1],yE[t]})).length)&&(r.set("st",a.join("_")),o.search=r.toString(),l=o.toString()),this.map._getMap().setStyle(l||t.style,{diff:e,validate:this.serviceOptions.validateStyle,transformStyle:u})},_E.prototype.getTheme=function(e){e=this._lookUp(e);if(e)return e.theme.toLowerCase()},_E.prototype.getThemeAsync=function(t){return dE(this,void 0,void 0,function(){return pE(this,function(e){switch(e.label){case 0:return[4,this._lookUpAsync(t)];case 1:return[2,e.sent().theme]}})})},_E.prototype.setMapConfiguration=function(e,o){var r=this;"string"==typeof(this.serviceOptions.mapConfiguration=e)?this.initStyleset():this.initPromise?this.initPromise.hijackAndResolve(e):this.initPromise=cE.resolve(e),this.definitions().then(function(e){var t=e.defaultConfiguration;e.configurations.find(function(e){return e.name===o})&&(t=o),r.map.setStyle({style:t})})},_E.prototype.getMapConfiguration=function(){return this.serviceOptions.mapConfiguration},_E.prototype.setStyleSet=function(e){this.updateIndoorState("indoor_dark"===e?"dark":"light",null)},_E.prototype.getStyleSet=function(){return void 0!==this.indoorState?"dark"===this.indoorState.theme?"indoor_dark":"indoor":"base"},_E.prototype.clearStyleSet=function(){this.unsetIndoorState()},_E.prototype._buildFundamentalLayerFrom=function(e,t){if(e&&0<e.length)return(e=new jC(e,t)).onAdd(this.map),e;throw new Error("Unable to construct fundamental map layer for ID: ".concat(t,"."))},_E.prototype._transformStyleRequest=function(e,t){e.includes(te)&&(t.url=t.url.replace(te,this.serviceOptions.domain)),e.includes(ae)&&(t.url=t.url.replace(ae,ce)),e.includes(se)&&(t.url=t.url.replace(se,ue)),(t.url.toLocaleLowerCase().includes(this.serviceOptions.domain.toLocaleLowerCase())||t.url.toLocaleLowerCase().includes(this.serviceOptions.staticAssetsDomain.toLocaleLowerCase()))&&((e=new URL(t.url)).searchParams.get(J)||(e.searchParams.set(J,this.serviceOptions.styleAPIVersion),t.url=e.href),null!=(e=this.map.authentication)&&e.signRequest(t),this._deleteAuthTokenForStaticAssets(t))},_E.prototype._request=function(r,n,i,a){var s;return void 0===a&&(a={}),dE(this,void 0,void 0,function(){var t,o;return pE(this,function(e){switch(e.label){case 0:return o={url:new Te({protocol:"https",domain:r,path:n,queryParams:hE(((o={})[J]=this.serviceOptions.styleAPIVersion,o),a)}).toString()},"function"==typeof this.serviceOptions.transformRequest&&i&&(o=this.serviceOptions.transformRequest(o.url,i)),null!=(s=this.map.authentication)&&s.signRequest(o),this._deleteAuthTokenForStaticAssets(o),t={method:"GET",mode:"cors"},o.credentials&&(t.credentials=o.credentials),o.headers&&(t.headers=o.headers),[4,fetch(o.url,t).then(function(e){if(e.ok)return e.json();throw new Error("HTTP ".concat(e.status,": ").concat(e.statusText," "))})];case 1:return[2,e.sent()]}})})},_E.prototype._deleteAuthTokenForStaticAssets=function(e){e.url.startsWith("https://".concat(this.serviceOptions.staticAssetsDomain,"/").concat(ce))&&(delete e.headers[he],delete e.headers[X])},_E);function _E(e,t){var l=this;this.definitions=function(){var e=l.initPromise||l.initStyleset();return e},this.indoorState=void 0,this.preservedPreindoorMapConfiguration=void 0,this._progressiveLoadingState={mapStyle:void 0,pendingVisibilityChange:void 0},this._deferLayerGroupVisibilities=function(t,e){var o,n,r,i,a=e.filter(function(e){return e in t});0!==a.length&&(o=l.map._getMap(),n=o.getZoom(),r=l.map.getStyle().style,l._progressiveLoadingState.pendingVisibilityChange&&(l.map.events.remove("load",l._progressiveLoadingState.pendingVisibilityChange),l._progressiveLoadingState.pendingVisibilityChange=null),l._progressiveLoadingState.mapStyle=r,(i=Object.entries(t).reduce(function(e,t){var t=fE(t,2),o=t[0],t=t[1],r=a.includes(o);return gE(gE([],fE(e),!1),fE(t.filter(function(e){if("custom"===e.type)return!1;if(r)if("number"==typeof e.maxzoom&&"number"==typeof e.minzoom){if(n<=e.maxzoom&&n>=e.minzoom)return!1}else if("number"==typeof e.minzoom){if(n>=e.minzoom)return!1}else{if("number"!=typeof e.maxzoom)return!1;if(n<=e.maxzoom)return!1}return"none"!==(null==(e=e.layout)?void 0:e.visibility)})),!1)},[])).forEach(function(e){e.layout=e.layout||{},e.layout.visibility="none"}),l._progressiveLoadingState.pendingVisibilityChange=function(){l._progressiveLoadingState.pendingVisibilityChange=null;var e=l.map.getStyle().style;r===e&&(i.forEach(function(e){e.layout.visibility="visible",o.setLayoutProperty(e.id,"visibility","visible")}),null!=(e=l.map.copyrightDelegate))&&e.reloadAttribution()},l.map.events.addOnce("load",l._progressiveLoadingState.pendingVisibilityChange))},this._onStyleData=function(e){l.map.events.invoke("stylechanged",{style:e.name,map:l.map,type:"stylechanged"})},this._lookUp=function(e){var t,o,r=l.definitions(),n=r.errorIfRejected(),i=r.resultIfResolved();if(n||!i)return null;var r=i.configurations,a=void 0;try{for(var s=mE(r),c=s.next();!c.done;c=s.next()){var u=c.value;if(u.name===e.style)return u;u.name===i.defaultConfiguration&&(a=a||u)}}catch(e){t={error:e}}finally{try{c&&!c.done&&(o=s.return)&&o.call(s)}finally{if(t)throw t.error}}return a=a||r[0]},this._lookUpAsync=function(o){return dE(l,void 0,void 0,function(){var t;return pE(this,function(e){switch(e.label){case 0:return[4,this.definitions()];case 1:return t=e.sent(),[2,t.configurations.find(function(e){return e.name===(o.style||t.defaultConfiguration)})||t.configurations.find(function(e){return e.name===t.defaultConfiguration})||t.configurations[0]]}})})},this.map=e,this.serviceOptions=t}var wE=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},bE=(CE.prototype.add=function(e){var t,o;e=Array.isArray(e)?e:[e];try{for(var r=wE(e),n=r.next();!n.done;n=r.next()){var i=n.value;this.indicators.has(i)||(this.indicators.add(i),i.attach(this.map))}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}},CE.prototype.clear=function(){var t=this;this.indicators.forEach(function(e){t.indicators.delete(e),e.remove()})},CE.prototype.remove=function(e){var t,o;e=Array.isArray(e)?e:[e];try{for(var r=wE(e),n=r.next();!n.done;n=r.next()){var i=n.value;this.indicators.has(i)&&(this.indicators.delete(i),i.remove())}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}},CE.prototype.getIndicators=function(){return Array.from(this.indicators)},CE.prototype._getCollectionDiv=function(){var e=this.map.getMapContainer().querySelector(".".concat(CE.Css.collection));return e||((e=document.createElement("div")).setAttribute("aria-label","map data"),e.setAttribute("role","listbox"),e.classList.add(CE.Css.collection),this.map.getMapContainer().appendChild(e)),e},CE.Css={collection:"accessible-indicator-collection-container"},CE);function CE(e){this.map=e,this.indicators=new Set}var SE,EE,Kt=window&&window.__extends||(SE=function(e,t){return(SE=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function o(){this.constructor=e}SE(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),TE=window&&window.__assign||function(){return(TE=Object.assign||function(e){for(var t,o=1,r=arguments.length;o<r;o++)for(var n in t=arguments[o])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},IE=window&&window.__awaiter||function(e,a,s,c){return new(s=s||Promise)(function(o,t){function r(e){try{i(c.next(e))}catch(e){t(e)}}function n(e){try{i(c.throw(e))}catch(e){t(e)}}function i(e){var t;e.done?o(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(r,n)}i((c=c.apply(e,a||[])).next())})},kE=window&&window.__generator||function(r,n){var i,a,s,c={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},u={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function e(o){return function(e){var t=[o,e];if(i)throw new TypeError("Generator is already executing.");for(;c=u&&t[u=0]?0:c;)try{if(i=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return c.label++,{value:t[1],done:!1};case 5:c.label++,a=t[1],t=[0];continue;case 7:t=c.ops.pop(),c.trys.pop();continue;default:if(!(s=0<(s=c.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){c=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))c.label=t[1];else if(6===t[0]&&c.label<s[1])c.label=s[1],s=t;else{if(!(s&&c.label<s[2])){s[2]&&c.ops.pop(),c.trys.pop();continue}c.label=s[2],c.ops.push(t)}}t=n.call(r,c)}catch(e){t=[6,e],a=0}finally{i=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},AE=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},PE=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},OE=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,o=t&&e[t],r=0;if(o)return o.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&r>=e.length?void 0:e)&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},RE=(Kt(L,EE=Vt),Object.defineProperty(L.prototype,"isDisposed",{get:function(){return this.removed},enumerable:!1,configurable:!0}),L.prototype.getCanvas=function(){return this.map.getCanvas()},L.prototype.getCanvasContainer=function(){return this.map.getCanvasContainer()},L.prototype.getMapContainer=function(){return this.map.getContainer()},L.prototype.getServiceOptions=function(){return th(this.serviceOptions,nE._cloneCustomizer)},L.prototype.setServiceOptions=function(e){this.serviceOptions=(new nE).merge(this.serviceOptions,e),this.serviceOptions["enable-accessibility"]?this.accessibleMapDelegate.addToMap():this.accessibleMapDelegate.removeFromMap();e=this.styles.serviceOptions.mapConfiguration!==this.serviceOptions.mapConfiguration||this.styles.serviceOptions.staticAssetsDomain!==this.serviceOptions.staticAssetsDomain||this.styles.serviceOptions.styleDefinitionsVersion!==this.serviceOptions.styleDefinitionsVersion||this.styles.serviceOptions.domain!==this.serviceOptions.domain||this.styles.serviceOptions.styleAPIVersion!==this.serviceOptions.styleAPIVersion;this.styles.serviceOptions=this.serviceOptions,e&&(this.styles.initPromise=null,this.setStyle({}))},L.prototype.addRequestTransformer=function(e){this.serviceOptions.addTransformer(e)},L.prototype.removeRequestTransformer=function(e){this.serviceOptions.removeTransformer(e)},L.prototype.setCamera=function(e,t){if(void 0===t&&(t=!1),"padding"in e||"offset"in e||"bounds"in e){var o,r=(new hS).merge({maxZoom:this.getCamera().maxZoom},e),n=this._generateSafeBounds(r.bounds),i={padding:r.padding,offset:r.offset,maxZoom:r.maxZoom};if(!(o=this.map.cameraForBounds(n,i)))throw a={message:"The map cannot be fit to the current canvas with the given CameraBoundsOptions.",containerWidth:null==(a=null==(a=this.map)?void 0:a.getContainer())?void 0:a.clientWidth,containerHeight:null==a?void 0:a.clientHeight,safeBounds:n,cameraForBoundsOptions:i},new Error(JSON.stringify(a));"pitch"in e&&(o.pitch=e.pitch),"bearing"in e&&(o.bearing=e.bearing),"minPitch"in e&&this.map.setMinPitch(e.minPitch),"maxPitch"in e&&this.map.setMaxPitch(e.maxPitch),"minZoom"in e&&this.map.setMinZoom(e.minZoom),n=this._generateSafeBounds(r.maxBounds)}else{i=(new gS).merge(this.getCamera(),e);i.centerOffset&&2<=i.centerOffset.length&&(a=i.centerOffset,(r=Vu([i.center],i.zoom))[0][0]+=a[0],r[0][1]+=a[1],i.center=Qu(r,i.zoom)[0]),o={center:i.center,zoom:i.zoom,bearing:i.bearing,pitch:i.pitch,around:void 0},i.minZoom<1&&console.warn("Setting minZoom below 1 may result in an empty map when the zoom level is less than 1."),this.map.setMinZoom(i.minZoom),this.map.setMaxZoom(i.maxZoom),i.minPitch&&this.map.setMinPitch(i.minPitch),i.maxPitch&&this.map.setMaxPitch(i.maxPitch),this._invokeEvent("minzoomchanged",this.map.getMinZoom()),this._invokeEvent("maxzoomchanged",this.map.getMaxZoom()),n=this._generateSafeBounds(i.maxBounds)}n?this.map.setMaxBounds(n):this.map.setMaxBounds(null);var a=(new eS).merge(e),r={duration:a.duration,easing:function(e){return e},offset:[0,0],animate:!0},i={fromControl:t};"jump"===a.type?this.map.jumpTo(o,i):"ease"===a.type?this.map.easeTo(TE(TE({},o),r),i):"fly"===a.type&&this.map.flyTo(TE(TE({},o),r),i)},L.prototype.setCameraBounds=function(e){this.setCamera(e)},L.prototype.getCamera=function(){var e=this.map.getBounds().getSouthWest().toArray(),t=this.map.getBounds().getNorthEast().toArray();return{zoom:this.map.getZoom(),center:this.map.getCenter().toArray(),bearing:this.map.getBearing(),pitch:this.map.getPitch(),bounds:new f(e,t),minZoom:this.map.getMinZoom(),maxZoom:this.map.getMaxZoom(),maxBounds:null==(e=this.map.getMaxBounds())?void 0:e.toArray().flat()}},L.prototype.setStyle=function(e,t){void 0===t&&(t=!0),delete e.preserveDrawingBuffer;e=(new QS).merge(this.styleOptions,e),e.autoResize!==this.styleOptions.autoResize&&this._setAutoResize(e.autoResize),e.language!==this.styleOptions.language&&(this.localizedStringsPromise=Re.getStrings(e.language)),e.renderWorldCopies!==this.styleOptions.renderWorldCopies&&this.map.setRenderWorldCopies(e.renderWorldCopies),e.showFeedbackLink!==this.styleOptions.showFeedbackLink&&this.copyrightControl.setOptions({showFeedbackLink:e.showFeedbackLink}),e.customAttribution!==this.styleOptions.customAttribution&&this.copyrightControl.setOptions({customAttribution:e.customAttribution}),e.showLogo!==this.styleOptions.showLogo&&(this.copyrightControl.setOptions({showLogo:e.showLogo}),this.logoControl.setOptions({showLogo:e.showLogo})),e.showTileBoundaries!==this.styleOptions.showTileBoundaries&&(this.map.showTileBoundaries=e.showTileBoundaries),e.showBuildingModels&&console.warn("showBuildingModels is deprecated."),t=t&&this.styleOptions.language===e.language&&this.styleOptions.view===e.view;this.styleOptions=e,this._setStyleComponents(e,t)},L.prototype.getStyle=function(){return Za(this.styleOptions)},L.prototype.addIcon=function(e,t){this.imageSprite.add(e,t)},L.prototype.addPins=function(e,t){var t=(new OS).merge(t),o=this.layers.getLayerById(t.name),r=!1;if(o||(r=!0,o=new Ep("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,iconOptions:{anchor:"center",size:t.iconSize,image:["case",["has","icon"],["get","icon"],t.icon],ignorePlacement:!t.cluster,opacity:t.opacity},textOptions:{anchor:"center",textField:["case",["has","point_count"],["to-string",["get","point_count"]],["has","title"],["to-string",["get","title"]],t.title],font:["case",["has","point_count"],["literal",["StandardFontCondensed-Bold"]],["literal",[t.textFont]]],size:["case",["has","point_count"],20,t.fontSize],ignorePlacement:!t.cluster,opacity:t.opacity,offset:["case",["has","point_count"],["literal",[.5,-.45]],["literal",[t.textOffset[0]/16,t.textOffset[1]/16]]],color:t.fontColor}})),!(o instanceof Ep))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a SymbolLayer.")+"A SymbolLayer should be used for rendering pins.");var n=o.getSource(),i=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(i=!0,n=new gh(a,{cluster:t.cluster})),!(n instanceof gh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");i&&this.sources.add(n),r&&this.layers.add(o,t.before);var a=new Sl(e);t.overwrite?n.setShapes(a):n.add(a)},L.prototype.addCircles=function(e,t){var t=(new CS).merge(t),o=this.layers.getLayerById(t.name),r=!1;if(o||(r=!0,o=new gd("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,opacity:t.opacity,radius:["case",["has","radius"],["get","radius"],t.radius],color:["case",["has","color"],["get","color"],t.color],strokeColor:["case",["has","outlineColor"],["get","outlineColor"],t.outlineColor],strokeWidth:["case",["has","outlineWidth"],["get","outlineWidth"],t.outlineWidth]})),!(o instanceof gd))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a BubbleLayer.")+"A BubbleLayer should be used for rendering circles.");var n=o.getSource(),i=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(i=!0,n=new gh(a)),!(n instanceof gh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");i&&this.sources.add(n),r&&this.layers.add(o,t.before);var a=new Sl(e);t.overwrite?n.setShapes(a):n.add(a)},L.prototype.addLinestrings=function(e,t){var t=(new IS).merge(t),o=this.layers.getLayerById(t.name),r=!1;if(o||(r=!0,o=new Gd("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,lineCap:t.cap,lineJoin:t.join,strokeOpacity:t.opacity,strokeColor:["case",["has","color"],["get","color"],t.color],strokeWidth:["case",["has","width"],["get","width"],t.width]})),!(o instanceof Gd))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a LineLayer.")+"A LineLayer should be used for rendering linestrings.");var n=o.getSource(),i=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(i=!0,n=new gh(a)),!(n instanceof gh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");i&&this.sources.add(n),r&&this.layers.add(o,t.before);var a=new Sl(e);t.overwrite?n.setShapes(a):n.add(a)},L.prototype.addPolygons=function(e,t){var t=(new NS).merge(t),o=this.layers.getLayerById(t.name),r=!1;if(o||(r=!0,o=new sp("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,fillOpacity:t.opacity,fillColor:["case",["has","color"],["get","color"],t.color]})),!(o instanceof sp))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a PolygonLayer.")+"A PolygonLayer should be used for rendering linestrings.");var n=o.getSource(),i=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(i=!0,n=new gh(a)),!(n instanceof gh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");i&&this.sources.add(n),r&&this.layers.add(o,t.before);var a=new Sl(e);t.overwrite?n.setShapes(a):n.add(a)},L.prototype.addRaster=function(e,t){var o,t=(new US).merge(t),r=this.layers.getLayerById(t.name);if(!((r=r||new jp({maxZoom:t.maxZoom,minZoom:t.minZoom,opacity:t.opacity,tileSize:256,tileUrl:"{subdomain}"},t.name))instanceof jp))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a TileLayer.")+"A TileLayer should be used for rendering raster images.");if("{subdomain}"!==r.getOptions().tileUrl)throw new Error("A TileLayer with name '".concat(t.name,"' already exists but was configured ")+"for a single tile url [default for new TileLayer(...)].");(o=!t.overwrite&&r.getOptions().subdomains||[]).push.apply(o,PE([],AE(e),!1)),r._setOptionsNoUpdate({subdomains:o}),this.layers.add(r,t.before)},L.prototype.getLayers=function(){return this.layers.getLayers().map(function(e){return e.getId()})},L.prototype.removeLayers=function(e){var t,o;try{for(var r=OE(e),n=r.next();!n.done;n=r.next()){var i,a=n.value;this.layers.getLayerById(a)&&(this.layers.remove(a),i="".concat(a,"-source"),this.sources.getById(i))&&this.sources.remove(i)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(o=r.return)&&o.call(r)}finally{if(t)throw t.error}}},L.prototype.addHtml=function(e,t){e.id||(e.id="marker_".concat(W()));var o=new mf({htmlContent:e});return this.markers.add(o,t),e.id},L.prototype.removeHtml=function(e){this.markers.remove(e)},L.prototype.addEventListener=function(e,t,o){this.events._addLegacy(e,t,o)},L.prototype.removeEventListener=function(e,t,o){this.events._removeLegacy(e,t,o)},L.prototype.setUserInteraction=function(e){this.userInteractionDelegate.setOptions(e)},L.prototype.getUserInteraction=function(){return this.userInteractionDelegate.getOptions()},L.prototype.addControl=function(e,t){this.controls.add(e,t)},L.prototype.removeControl=function(e){this.controls.remove(e)},L.prototype.setTraffic=function(e){var t=this.trafficOptions.incidents,o=this.trafficOptions.flow;if(this.trafficOptions=(new cc).merge(this.trafficOptions,e),this.controls.getControls().filter(function(e){return e instanceof mc}).forEach(function(e){return e.updateButtonState()}),this.incidentDelegate&&(this.trafficOptions.incidents?t||this.incidentDelegate.addToMap():this.incidentDelegate.removeFromMap()),this.trafficOptions.flow&&"none"!==this.trafficOptions.flow){["absolute","relative-delay"].includes(this.trafficOptions.flow)&&console.warn("The 'absolute' and 'relative-delay' flow options are deprecated. Please use 'relative' instead.");try{this.trafficOptions.flow!==o&&this.flowDelegate.addToMap()}catch(e){throw this.trafficOptions.flow=o,e}}else this.flowDelegate.removeFromMap()},L.prototype.getTraffic=function(){return Za(this.trafficOptions)},L.prototype.remove=function(){this.dispose()},L.prototype.clear=function(){this.popups.clear(),this.layers.clear(),this.sources.clear(),this.markers.clear(),this.indicators.clear()},L.prototype.dispose=function(){var e;for(this.clear(),this.map.remove(),null!=(e=this.authentication)&&e.dispose(),this.removed=!0,null!=(e=this.resizeObserver)&&e.disconnect(),this.resizeObserver=null;this.getMapContainer().firstChild;){var t=this.getMapContainer().firstChild;this.getMapContainer().removeChild(t)}},L.prototype.resize=function(e,t,o){"number"!=typeof e&&"string"!=typeof e||"number"!=typeof t&&"string"!=typeof t?o=e:(e=e,this.getMapContainer().style.height="number"==typeof e?"".concat(e,"px"):e,this.getMapContainer().style.width="number"==typeof t?"".concat(t,"px"):t);e=this.getMapContainer().style.overflow;this.getMapContainer().style.overflow="hidden",this.map.resize(o),this.getMapContainer().style.overflow=e},L.prototype.pixelsToPositions=function(e){var t,o,r=[];try{for(var n=OE(e),i=n.next();!i.done;i=n.next()){var a=i.value,s=this.map.unproject(a);r.push(new hl(s.lng,s.lat))}}catch(e){t={error:e}}finally{try{i&&!i.done&&(o=n.return)&&o.call(n)}finally{if(t)throw t.error}}return r},L.prototype.positionsToPixels=function(e){var t,o,r=[];try{for(var n=OE(e),i=n.next();!i.done;i=n.next()){var a=i.value,s=this.map.project(a);r.push(new ru(s.x,s.y))}}catch(e){t={error:e}}finally{try{i&&!i.done&&(o=n.return)&&o.call(n)}finally{if(t)throw t.error}}return r},L.prototype.areTilesLoaded=function(){return this.map.areTilesLoaded()},L.prototype.stop=function(){this.map.stop()},L.prototype.triggerRepaint=function(){this.map.triggerRepaint()},L.prototype.enableElevation=function(e,t){this.map.setTerrain("string"==typeof e?{source:e,exaggeration:t}:{source:e.getId(),exaggeration:t})},L.prototype.disableElevation=function(){this.map.setTerrain(null)},L.prototype._getMap=function(){return this.map},L.prototype._rebuildStyle=function(t){return void 0===t&&(t=!0),IE(this,void 0,void 0,function(){return kE(this,function(e){return this.styles.setStyle(this.styleOptions,t),this.imageSprite._restoreImages(),[2]})})},L.prototype._isLoaded=function(){return this.loaded},L.prototype._isReady=function(){return this.ready},L.prototype._getLocalizedStrings=function(){return this.localizedStringsPromise},L.prototype._sendRequest=function(e,t,o){var r;return(r="function"==typeof this.serviceOptions.transformRequest?this.serviceOptions.transformRequest(e,t):r)?fetch(r.url||e,{credentials:r.credentials,headers:TE(TE({},o),r.headers),method:"GET",mode:"cors"}):fetch(e,{headers:o,method:"GET",mode:"cors"})},L.prototype._substituteDomainLanguageViewAndSignInRequest=function(e,t){var o;(e.includes(oe)||e.includes(te))&&(o=new RegExp("[^{]".concat(oe,"[^}]")),e.match(o)&&(t.url=t.url.replace(oe,te)),Te.protoRegEx.test(this.serviceOptions.domain)?(o=t.url.indexOf(te),t.url=this.serviceOptions.domain+t.url.substring(o+te.length)):t.url=t.url.replace(te,this.serviceOptions.domain)),(t.url.toLocaleLowerCase().includes(this.serviceOptions.domain.toLocaleLowerCase())||t.url.toLocaleLowerCase().includes(this.serviceOptions.staticAssetsDomain.toLocaleLowerCase()))&&null!=(o=this.authentication)&&o.signRequest(t),e.includes(ie)&&(t.url=t.url.replace(ie,this.styleOptions.language)),e.includes(re)&&(t.url=this.styleOptions.view?t.url.replace(re,this.styleOptions.view):t.url.replace(re,"").replace("&".concat(ne,"="),""))},L.prototype._setAutoResize=function(e){e?(this.resizeObserver||(this.resizeObserver=new ResizeObserver(this._resizeCallback)),this.resizeObserver.observe(this.map.getContainer())):this.resizeObserver&&this.resizeObserver.unobserve(this.map.getContainer())},L.prototype._setStyleComponents=function(s,c){var u=this;void 0===c&&(c=!0),this.removed||this.styles.definitions().then(function(e){var t,o,r=!0;if(u.styleOptions.style)try{for(var n=OE(e.configurations),i=n.next();!i.done;i=n.next()){var a=i.value;if(u.styleOptions.style===a.name){r=!1;break}}}catch(e){t={error:e}}finally{try{i&&!i.done&&(o=n.return)&&o.call(n)}finally{if(t)throw t.error}}r&&(u.styleOptions.style=e.defaultConfiguration),u.styleOptions=s,u._rebuildStyle(c)})},L.prototype._updateGlobalDefaults=function(e){e&&(e.authOptions&&!st&&wt(e.authOptions),e.domain&&!et&&bt(e.domain),e.styleDefinitionsPath&&!tt&&Ct(e.styleDefinitionsPath),e.workerCount&&!rt&&St(e.workerCount),e.maxParallelImageRequests&&!nt&&Et(e.maxParallelImageRequests),!e.subscriptionKey&&!e["subscription-key"]||st||kt(e.subscriptionKey||e["subscription-key"]),!e.sessionId&&!e["session-id"]||at||It(e.sessionId||e["session-id"]),e.language&&!it&&Tt(e.language),!e.userRegion&&!e.view||$e||At(e.userRegion||e.view))},L.prototype._generateSafeBounds=function(e){if(e){var t=f.getSouth(e),o=f.getWest(e),r=f.getNorth(e),n=f.getEast(e);if(!(isFinite(t)&&isFinite(o)&&isFinite(r)&&isFinite(n)))throw new Error("The bounds specified are invalid: [".concat(e,"]"));for(;n<o;)n+=360;return new f([o,t,n,r])}return e},L.prototype._detectHighContrast=function(){var e,t;switch(vf.getHighContrastMode()){case"invert":case"light":e=L.Css.hcLight,t="high_contrast_light";break;case"dark":e=L.Css.hcDark,t="high_contrast_dark"}e&&this.map.getContainer().classList.add(e),t&&"road"===this.styleOptions.style&&(this.styleOptions.style=t)},L.Css={canvasContainer:"atlas-map-canvas-container",canvas:"atlas-map-canvas",container:"atlas-map",hcDark:"high-contrast-dark",hcLight:"high-contrast-light"},L);function L(e,t){var o,r,n=EE.call(this)||this;n.removed=!1,n.loaded=!1,n.ready=!1,n._resizeCallback=function(){return n.resize()},n._updateGlobalDefaults(t),n.serviceOptions=(new nE).merge(t),n.styleOptions=(new QS).merge(t),n.trafficOptions=new cc,n.styles=new vE(n,n.serviceOptions),n.serviceOptions.authOptions.subscriptionKey&&(n.serviceOptions.authOptions.subscriptionKey=encodeURIComponent(n.serviceOptions.authOptions.subscriptionKey)),o=n.serviceOptions.authOptions.clientId||(n.serviceOptions.authOptions.subscriptionKey?n.serviceOptions.authOptions.subscriptionKey.replace(/.(?=.{3,}$)/g,"*"):"invalid-setting"),n.insights&&n.insights.setAuthenticatedUserContext(n.serviceOptions.sessionId,o),arguments[2]&&"ENVIRONMENT"in window&&window.ENVIRONMENT.hmr?(r=arguments[2],n.ready=!0,n.loaded=!0):(o={antialias:n.styleOptions.antialias,attributionControl:!1,container:e,fadeDuration:n.serviceOptions.fadeDuration,localIdeographFontFamily:n.serviceOptions.localIdeographFontFamily,preserveDrawingBuffer:n.styleOptions.preserveDrawingBuffer,refreshExpiredTiles:n.serviceOptions.refreshExpiredTiles,renderWorldCopies:n.styleOptions.renderWorldCopies,trackResize:!1,transformRequest:function(e,t){var o={url:e};return"Tile"===t||"Source"===t?(e.includes(oe)&&n.insights&&n.insights.trackEvent({name:"TileLoad"}),n._substituteDomainLanguageViewAndSignInRequest(e,o)):"Style"!==t&&"SpriteJSON"!==t&&"SpriteImage"!==t&&"Glyphs"!==t||n.styles._transformStyleRequest(e,o),n.serviceOptions.transformRequest&&Js(o,n.serviceOptions.transformRequest(o.url,t)),o}},r=new D.Map(o));try{n.map=r,n.authentication=new _C(n),n.controls=new bC(n),n.events=new PC(n),n.imageSprite=new NC(n),n.layers=new KC(n),n.markers=new xC(n),n.sources=new VC(n),n.popups=new WC(n),n.indicators=new bE(n),n.map.getContainer().classList.add(L.Css.container),n.map.getCanvasContainer().classList.add(L.Css.canvasContainer),n.map.getCanvas().classList.add(L.Css.canvas),n._detectHighContrast(),n.copyrightControl=new If({showFeedbackLink:n.styleOptions.showFeedbackLink,showLogo:n.styleOptions.showLogo,customAttribution:n.styleOptions.customAttribution}),n.controls.add(n.copyrightControl,{position:l.ControlPosition.NonFixed}),n.logoControl=new Nf({showLogo:n.styleOptions.showLogo}),n.controls.add(n.logoControl,{position:l.ControlPosition.BottomLeft});var i=n.authentication?n.authentication.initialize():Promise.resolve();if(n.removed)return n;var a=function(){n.loaded=!0,n.map.off("load",a)},s=(n.map.on("load",a),function(){n.ready=!0,n.map.off("styledata",s),n.events.invoke("ready",{map:n,type:"ready"})});n.map.on("styledata",s),n._setAutoResize(n.styleOptions.autoResize),n.map.showTileBoundaries=n.styleOptions.showTileBoundaries,n.localizedStringsPromise=Re.getStrings(n.styleOptions.language),i.then(function(){return n.styles.definitions()}).then(function(e){if(!n.removed){if(n.authentication&&!n.authentication.getToken())throw new Error("AuthenticationManager finished initializing, but no token is available");n.serviceOptions["enable-accessibility"]&&n.accessibleMapDelegate.addToMap(),n._setStyleComponents(n.styleOptions),n.copyrightDelegate&&n.copyrightDelegate.addToMap()}}).catch(function(e){e=e instanceof Error?e:new Error(e);n.events.invoke("error",{map:n,type:"error",error:e})}),n.setCamera(TE(TE({minZoom:1},t),{type:"jump",duration:0})),n.incidentDelegate=new ag(n),n.flowDelegate=new $f(n),n.accessibleMapDelegate=new Xf(n),n.userInteractionDelegate=new mg(n,t),n.userInteractionDelegate.addToMap(),n.copyrightDelegate=new Mg(n,n.copyrightControl,n.styleOptions)}catch(e){throw e}return n}var xE=window&&window.__read||function(e,t){var o="function"==typeof Symbol&&e[Symbol.iterator];if(!o)return e;var r,n,i=o.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(r=i.next()).done;)a.push(r.value)}catch(e){n={error:e}}finally{try{r&&!r.done&&(o=i.return)&&o.call(i)}finally{if(n)throw n.error}}return a},ME=window&&window.__spreadArray||function(e,t,o){if(o||2===arguments.length)for(var r,n=0,i=t.length;n<i;n++)!r&&n in t||((r=r||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(r||Array.prototype.slice.call(t))},o=(NE.applyTemplate=function(t,o){var r,n,e,i=this,a=document.createElement("div");return a.classList.add(NE.Css.template),t&&("boolean"!=typeof(o=o||{}).singleDescription&&(o.singleDescription=!0),o.sandboxContent="boolean"!=typeof o.sandboxContent||o.sandboxContent,o.title&&"string"==typeof o.content&&(o.content.includes("{title}")||o.content.includes("{name}"))||(t.title?o.title="{title}":t.name&&(o.title="{name}")),"boolean"!=typeof o.detectHyperlinks&&(o.detectHyperlinks=!0),"boolean"!=typeof o.parsePropertyPaths&&(o.parsePropertyPaths=!0),o.textColor&&(a.style.color=o.textColor),o.fillColor&&(a.style.backgroundColor=o.fillColor),o.title&&((e=this._applyStringTemplate(t,o.title,o)).innerText=e.textContent||e.innerText||"",this._appendChild(a,e,NE.Css.title)),(r=document.createElement("div")).classList.add(NE.Css.content),Array.isArray(o.content)?0<o.content.length&&o.content[0].propertyPath?this._appendChild(r,this._generateContent(t,o.content,o),NE.Css.item):o.content.forEach(function(e){i._appendChild(r,i._generateContent(t,e,o),NE.Css.item)}):(n=0,e=void(t.description&&Object.keys(t).forEach(function(e){i._ignoreProperty(e,t[e])||n++})),1===n||o.singleDescription&&t.description||2===n&&t.Snippet?(e=document.createElement("div")).innerHTML=t.description:e=this._generateContent(t,o.content,o),this._appendChild(r,e,NE.Css.item)),""!==r.innerHTML)&&(o.sandboxContent?a.appendChild(NE._createSandboxedIframe(r,o)):a.appendChild(r)),a},NE._createSandboxedIframe=function(e,t){var o=document.createElement("iframe"),e=(o.sandbox.add("allow-popups"),e.innerHTML),r=!1,n=100,i=550,a=10,s=(document.body.scrollWidth<=340&&(i=300,n=50),e.split(/<(tr|div|br|li|h[0-9]|p>)/)),c=Math.max.apply(Math,ME([],xE(s.map(function(e){return e.replace(/<[a-zA-Z0-9\s=\/]+>/g,"").length})),!1))-1,u=Math.ceil(3.5*c),c=(u<i&&(i=u,n=c),e.includes("<img")||e.includes("<video")?(r=!0,o.width="550px"):(u=-1<e.indexOf(NE.Css.table)?25:20,a+=Math.max(.5*s.length*u,Math.ceil(e.replace(/<[a-zA-Z0-9\s=\/]+>/g,"").length/n)*u)),o.width=i+"px",o.height=r||280<a?"280px":a+"px",t.textColor?"color:".concat(t.textColor,";"):""),s=t.fillColor?"background-color:".concat(t.fillColor,";"):"",n='<html><head><title></title><meta charset="utf-8" /><meta http-equiv="x-ua-compatible" content="IE=Edge" />'+'<link rel="stylesheet" href="'.concat(NE._cssUrl,'" type="text/css"/>')+"<style>html, body{margin:0;padding:0;".concat(c).concat(s,"}</style></head>")+'<body><div class="'.concat(NE.Css.template,'" style="padding:0;width:').concat(i-20,'px">').concat(e,"</div></body></html>");return void 0===o.srcdoc?o.src="data:text/html;charset=utf-8,"+encodeURI(n):o.srcdoc=n,o},NE._appendChild=function(e,t,o){t&&(o&&(t.className=(t.className?t.className+" ":"")+o),e.appendChild(t))},NE._generateContent=function(e,t,o){return t?Array.isArray(t)?this._generatePropertyInfoTable(e,t,o):this._applyStringTemplate(e,t,o):(t=this._generateDynamicTableHtml(e,null,o))?((e=document.createElement("div")).innerHTML=t,e):null},NE._applyStringTemplate=function(e,t,o){if(t){for(var r,n,i=t,a=this._placeholderRx.exec(t);a;)2<=a.length&&(r=this._getPropertyValue(e,a[1],o),i=i.replace(a[0],r)),a=this._placeholderRx.exec(t);if(i)return(i=i.trim()).includes("<")&&(i=i.replace(/[\r\n]+/g,"<br/>")),(n=document.createElement("div")).innerHTML=i,n}return null},NE._getPropertyValue=function(e,t,o,r){var n=o.parsePropertyPaths?t.split("/"):[t],i=n.length;if(0<i&&e){var a=n[0],s=e[a];if(o.detectHyperlinks&&"link"===t&&(!r||r.hyperlinkFormat)){var c,u,l,h=[];if(Array.isArray(s)?s.forEach(function(e){e.href?h.push(e):"string"==typeof e&&h.push({href:e})}):s.href&&h.push(s),0<h.length)return r&&r.hyperlinkFormat?c=r.hyperlinkFormat:o&&o.hyperlinkFormat&&(c=o.hyperlinkFormat),u=c&&c.target?c.target:"_blank",l=[],h.forEach(function(e){e.title||c&&c.label||!e.rel||l.push(e.rel," - "),l.push('<a href="',e.href,'" target="',u,'">'),e.title?l.push(e.title):c&&c.label?l.push(c.label):l.push(e.href),l.push("</a>","<br/>")}),l.pop(),l.join("")}if(null!=s){for(var d=void 0,d=1;d<i&&(s=s[n[d]],a=n[d],null!=s);d++);if(d===i&&null!=s){e=void 0;if((e=void 0!==s.value?s.value:s)instanceof Date)return r&&r.dateFormat?e.toLocaleString(void 0,r.dateFormat):o.dateFormat?e.toLocaleString(void 0,o.dateFormat):e.toISOString();if("object"==typeof e)return(p=this._generateDynamicTableHtml(e,n.slice(1),o))||"";if("number"==typeof e){if(r){if(r.dateFormat)return new Date(e).toLocaleString(void 0,r.dateFormat);if(r.numberFormat)return e.toLocaleString(void 0,r.numberFormat)}else if(/(timestamp|date)/gi.test(a))return new Date(e).toISOString();return e.toLocaleString(void 0,o.numberFormat)}if("string"==typeof e&&""!==e&&!/[\n\r<>\s]/g.test(e)&&(o.detectHyperlinks||r&&r.hyperlinkFormat)){var p,e=e.trim(),t=this._isUrlRx.test(e)||r&&r.hyperlinkFormat,f=this._isImageUrlRx.test(e)&&(t||e.startsWith("data:image")),g=this._emailRx.test(e);if(t||f||g)return t=void 0,p=void(r&&r.hyperlinkFormat?t=r.hyperlinkFormat:o&&o.hyperlinkFormat&&(t=o.hyperlinkFormat)),p=t&&t.target?' target="'.concat(t.target,'"'):' target="_blank"',r="".concat(t&&t.label?t.label:e),t&&t.scheme?e=t.scheme+e:g&&(e="mailto:"+e),o=t&&t.label?' alt="'.concat(t.label,'"'):"",(t&&t.isImage||f)&&(r='<img src="'.concat(e,'" style="max-width:100%"').concat(o,'"/>')),'<a href="'.concat(e,'"').concat(p,">").concat(r,"</a>")}return e.toString()}}}return""},NE._generatePropertyInfoTable=function(o,e,r){var n,i;return o&&e&&0<e.length?((n=[]).push('<table class="'.concat((i=this).Css.table,'">')),e.forEach(function(e){var t=i._getPropertyValue(o,e.propertyPath,r,e);e.hideLabel?n.push('<tr><td colspan="2">',t,"</td></tr>"):(e=e.label||e.propertyPath.split("/")[0],n.push("<tr><th>",e,"</th><td>",t,"</td></tr>"))}),n.push("</table>"),(e=document.createElement("div")).innerHTML=n.join(""),e):null},NE._generateDynamicTableHtml=function(t,e,o){var r,n,i,a,s=this;return!t||((r=[]).push('<table class="'.concat((n=this).Css.table,'">')),i=e&&0<e.length?e.join("/")+"/":"",a=0,Object.keys(t).forEach(function(e){s._ignoreProperty(e,t[e])||(r.push("<tr><th>",e,"</th><td>",n._getPropertyValue(t,i+e,o),"</td></tr>"),a++)}),0===a)?null:(r.push("</table>"),r.join(""))},NE._ignoreProperty=function(e,t){switch(e){case"title":case"name":case"base":case"popupTemplate":case"anchor":case"icon":case"image":case"imageUrl":case"rotation":case"color":case"size":case"offset":case"strokeColor":case"strokeWidth":case"strokeOpacity":case"subType":case"fillColor":case"fillOpacity":case"visibility":case"visible":return!0;default:if(0===e.indexOf("_")||null==t||""===t)return!0}return!1},NE._placeholderRx=/\{([a-zA-Z0-9_\/\s]+)\}/gi,NE._isUrlRx=/^(http|https|ftp|tel|mailto):\/\//i,NE._isImageUrlRx=/(^data:image|.png$|.jpg$|.jpeg$|.gif$|.bmp$|.svg|.tif|.tiff$)/i,NE._emailRx=/^[^\.\s@:](?:[^\s@:]*[^\s@:\.])?@[^\.\s@]+(?:\.[^\.\s@]+)*$/,NE._cssUrl=new Te({domain:Q,path:"sdk/javascript/mapcontrol/".concat(De.getEndpointVersion(),"/atlas.min.css")}).toString(),NE.Css={template:"azure-maps-control-popup-template",title:"azure-maps-control-popup-template-title",content:"azure-maps-control-popup-template-content",item:"azure-maps-control-popup-template-content-item",table:"azure-maps-control-popup-template-table"},NE);function NE(){this.detectHyperlinks=!0,this.parsePropertyPaths=!0}Ut(),l.HtmlMarker=mf,l.Map=RE,l.Pixel=ru,l.Popup=cf,l.PopupTemplate=o,l.Shape=vl,l._enableRTLTextPlugin=Ut,l._getAssetDomain=function(){return Z},l._getDomain=function(){return We},l._hasMaxParallelImageRequests=Nt,l._hasSetAuthenticationOptions=Ot,l._hasSetDomain=Rt,l._hasSetLanguage=Lt,l._hasSetSessionId=Dt,l._hasSetStyleDefinitionsPath=xt,l._hasSetStyleDefinitionsVersion=function(){return ot},l._hasSetView=qt,l._hasWorkerCount=Mt,l.addImageTemplate=function(e,t,o){!o&&zt[e.toLowerCase()]||(zt[e.toLowerCase()]=t)},l.addProtocol=function(e,t){D.addProtocol(e,t)},l.clearPrewarmedResources=function(){D.clearPrewarmedResources()},l.control=Ho,l.data=ii,l.getAllImageTemplateNames=function(){return Object.keys(zt)},l.getAuthenticationOptions=ct,l.getDomain=lt,l.getImageTemplate=Pt,l.getLanguage=mt,l.getMaxParallelImageRequests=gt,l.getSessionId=yt,l.getStaticAssetsDomain=ut,l.getStyleAPIVersion=pt,l.getStyleDefinitionsPath=ht,l.getStyleDefinitionsVersion=dt,l.getSubscriptionKey=vt,l.getUserRegion=function(){return Ke},l.getVersion=function(){return De.getFullVersion()},l.getView=_t,l.getWorkerCount=ft,l.internal=B,l.isSupported=function(e){return!Me.isIE()},l.layer=Mi,l.math=sn,l.prewarm=function(){D.prewarm()},l.removeProtocol=function(e){D.removeProtocol(e)},l.setAuthenticationOptions=wt,l.setDomain=bt,l.setLanguage=Tt,l.setMaxParallelImageRequests=Et,l.setSessionId=It,l.setStyleAPIVersion=function(e){Je=e},l.setStyleDefinitionsPath=Ct,l.setStyleDefinitionsVersion=function(e){Ve=e,ot=!0},l.setSubscriptionKey=kt,l.setUserRegion=At,l.setView=function(e){Ke=e,$e=!0},l.setWorkerCount=St,l.source=hn});
