/*!
MICROSOFT SOFTWARE LICENSE TERMS
MICROSOFT AZURE MAPS WEB SDK
These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW.  BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS.
1. INSTALLATION AND USE RIGHTS.
  a) General. You may install and use any number of copies of the software to develop and test your applications.
  b) User Region Parameters. The software will allow you to select from a View list to set the map view within your application for a given customer. By default the View parameter (also referred to as “user region parameter” is set to “Unified”.  Countries/Regions that are not on the View list will default to the “Unified” View. It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter must be used in compliance with applicable laws, including those regarding mapping, of the country where maps, images and other data and third party content that You are authorized to access via the software is made available. 
  c) Third Party Software. The software may include third party applications that Microsoft, not the third party, licenses to you under this agreement. Any included notices for third party applications are for your information only.
  d) Microsoft Online Subscription Agreement. Some features of the software provide access to, or rely on, Microsoft Azure Services. The use of those services (but not the software) is governed by the separate terms and privacy policies associated with your Microsoft Azure subscription. The services may not be available in all regions. For more information see https://go.microsoft.com/fwLink/?LinkID=522330&amp;clcid=0x9.
2. DISTRIBUTABLE CODE. The software is comprised of “Distributable Code”. “Distributable Code” is code that you are permitted to distribute in applications you develop if you comply with the terms below and otherwise set forth in these license terms. 
  a) Distribution Rights. 
    i. You may copy and distribute the object code form of the software.
    i. Third Party Distribution. You may permit distributors of your applications to copy and distribute any of this distributable code you elect to distribute with your applications.
  b) Distribution Requirements. For any code you distribute, you must:
    i. add significant primary functionality to it in your applications;
    ii. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
    iii. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  c) Distribution Restrictions. You may not:
    i. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
    ii. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.
3. DATA COLLECTION. The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at https://go.microsoft.com/fwlink/?LinkId=512132. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.
4. SCOPE OF LICENSE. The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
  a) work around any technical limitations in the software that only allow you to use it in certain ways;
  b) reverse engineer, decompile, or disassemble the software, or attempt to do so, except and only to the extent permitted by licensing terms governing the use of open-source components that may be included with the software;
  c) remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
  d) use the software in any way that is against the law or to create or propagate malware; or
  e) share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.
5. EXPORT RESTRICTIONS. You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.
6. SUPPORT SERVICES. Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.
7. UPDATES. The software may periodically check for updates, and download and install them for you. You may obtain updates only from Microsoft or authorized sources. Microsoft may need to update your system to provide you with updates. You agree to receive these automatic updates without any additional notice. Updates may not include or support all existing software features, services, or peripheral devices.
8. ENTIRE AGREEMENT. This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.
9. APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES. If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.
10. CONSUMER RIGHTS; REGIONAL VARIATIONS. This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
  a) Australia. You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
  b) Canada. If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
  c) Germany and Austria.
    i. Warranty. The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.
    ii. Limitation of Liability. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.
  Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.
11. DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
12. LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT, OR INCIDENTAL DAMAGES.
This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.
It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.
Please note: As this software is distributed in Canada, some of the clauses in this agreement are provided below in French.
Remarque: Ce logiciel étant distribué au Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.
EXONÉRATION DE GARANTIE. Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.
LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES. Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.
Cette limitation concerne:
• tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers; et
• les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.
Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.
EFFET JURIDIQUE. Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.
*/

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).atlas=e.atlas||{})}(this,function(u){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function z(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}function N(r){var t,i;return r.__esModule?r:("function"==typeof(t=r.default)?(i=function e(){return this instanceof e?Reflect.construct(t,arguments,this.constructor):t.apply(this,arguments)}).prototype=t.prototype:i={},Object.defineProperty(i,"__esModule",{value:!0}),Object.keys(r).forEach(function(e){var t=Object.getOwnPropertyDescriptor(r,e);Object.defineProperty(i,e,t.get?t:{enumerable:!0,get:function(){return r[e]}})}),i)}var B=z(function(){var i={},n={};function e(e,t,r){n[e]=r,"index"===e&&(r="var sharedModule = {}; ("+n.shared+")(sharedModule); ("+n.worker+")(sharedModule);",n.shared(e={}),n.index(i,e),"undefined"!=typeof window)&&i.setWorkerUrl(window.URL.createObjectURL(new Blob([r],{type:"text/javascript"})))}return e("shared",0,function(ue){function E(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})}function I(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}var A=M;function M(e,t){this.x=e,this.y=t}M.prototype={clone:function(){return new M(this.x,this.y)},add:function(e){return this.clone()._add(e)},sub:function(e){return this.clone()._sub(e)},multByPoint:function(e){return this.clone()._multByPoint(e)},divByPoint:function(e){return this.clone()._divByPoint(e)},mult:function(e){return this.clone()._mult(e)},div:function(e){return this.clone()._div(e)},rotate:function(e){return this.clone()._rotate(e)},rotateAround:function(e,t){return this.clone()._rotateAround(e,t)},matMult:function(e){return this.clone()._matMult(e)},unit:function(){return this.clone()._unit()},perp:function(){return this.clone()._perp()},round:function(){return this.clone()._round()},mag:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},equals:function(e){return this.x===e.x&&this.y===e.y},dist:function(e){return Math.sqrt(this.distSqr(e))},distSqr:function(e){var t=e.x-this.x,e=e.y-this.y;return t*t+e*e},angle:function(){return Math.atan2(this.y,this.x)},angleTo:function(e){return Math.atan2(this.y-e.y,this.x-e.x)},angleWith:function(e){return this.angleWithSep(e.x,e.y)},angleWithSep:function(e,t){return Math.atan2(this.x*t-this.y*e,this.x*e+this.y*t)},_matMult:function(e){var t=e[0]*this.x+e[1]*this.y,e=e[2]*this.x+e[3]*this.y;return this.x=t,this.y=e,this},_add:function(e){return this.x+=e.x,this.y+=e.y,this},_sub:function(e){return this.x-=e.x,this.y-=e.y,this},_mult:function(e){return this.x*=e,this.y*=e,this},_div:function(e){return this.x/=e,this.y/=e,this},_multByPoint:function(e){return this.x*=e.x,this.y*=e.y,this},_divByPoint:function(e){return this.x/=e.x,this.y/=e.y,this},_unit:function(){return this._div(this.mag()),this},_perp:function(){var e=this.y;return this.y=this.x,this.x=-e,this},_rotate:function(e){var t=Math.cos(e),e=Math.sin(e),r=t*this.x-e*this.y,e=e*this.x+t*this.y;return this.x=r,this.y=e,this},_rotateAround:function(e,t){var r=Math.cos(e),e=Math.sin(e),i=t.x+r*(this.x-t.x)-e*(this.y-t.y),e=t.y+e*(this.x-t.x)+r*(this.y-t.y);return this.x=i,this.y=e,this},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}},M.convert=function(e){return!(e instanceof M)&&Array.isArray(e)?new M(e[0],e[1]):e};var B=I(A),O=L;function L(e,t,r,i){this.cx=3*e,this.bx=3*(r-e)-this.cx,this.ax=1-this.cx-this.bx,this.cy=3*t,this.by=3*(i-t)-this.cy,this.ay=1-this.cy-this.by,this.p1x=e,this.p1y=t,this.p2x=r,this.p2y=i}L.prototype={sampleCurveX:function(e){return((this.ax*e+this.bx)*e+this.cx)*e},sampleCurveY:function(e){return((this.ay*e+this.by)*e+this.cy)*e},sampleCurveDerivativeX:function(e){return(3*this.ax*e+2*this.bx)*e+this.cx},solveCurveX:function(e,t){if(void 0===t&&(t=1e-6),e<0)return 0;if(1<e)return 1;for(var r=e,i=0;i<8;i++){var n=this.sampleCurveX(r)-e;if(Math.abs(n)<t)return r;var o=this.sampleCurveDerivativeX(r);if(Math.abs(o)<1e-6)break;r-=n/o}for(var a=0,s=1,r=e,i=0;i<20&&(n=this.sampleCurveX(r),!(Math.abs(n-e)<t));i++)n<e?a=r:s=r,r=.5*(s-a)+a;return r},solve:function(e,t){return this.sampleCurveY(this.solveCurveX(e,t))}};var D=I(O);let z;function N(){return z=null==z?"undefined"!=typeof OffscreenCanvas&&new OffscreenCanvas(1,1).getContext("2d")&&"function"==typeof createImageBitmap:z}let F;function U(){if(null==F&&(F=!1,N())){var t=new OffscreenCanvas(5,5).getContext("2d",{willReadFrequently:!0});if(t){for(let e=0;e<25;e++){var r=4*e;t.fillStyle=`rgb(${r},${1+r},${2+r})`,t.fillRect(e%5,Math.floor(e/5),1,1)}var i=t.getImageData(0,0,5,5).data;for(let e=0;e<100;e++)if(e%4!=3&&i[e]!==e){F=!0;break}}}return F||!1}function q(e,t,r,i){const n=new D(e,t,r,i);return function(e){return n.solve(e)}}O=q(.25,.1,.25,1);function j(e,t,r){return Math.min(r,Math.max(t,e))}function H(e,t,r){var i=r-t,e=((e-t)%i+i)%i+t;return e===t?r:e}function V(e,...t){for(const r of t)for(const i in r)e[i]=r[i];return e}let G=1;function K(e,t,r){var i={};for(const n in e)i[n]=t.call(r||this,e[n],n,e);return i}function Z(e,t,r){var i={};for(const n in e)t.call(r||this,e[n],n,e)&&(i[n]=e[n]);return i}function W(e){return Array.isArray(e)?e.map(W):"object"==typeof e&&e?K(e,W):e}const Y={};function he(e){Y[e]||("undefined"!=typeof console&&console.warn(e),Y[e]=!0)}function $(e,t,r){return(r.y-e.y)*(t.x-e.x)>(t.y-e.y)*(r.x-e.x)}function X(e){return"undefined"!=typeof WorkerGlobalScope&&void 0!==e&&e instanceof WorkerGlobalScope}let J=null;function Q(e){return"undefined"!=typeof ImageBitmap&&e instanceof ImageBitmap}const ee="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=";function te(f,m,g,y,v){return E(this,void 0,void 0,function*(){if("undefined"==typeof VideoFrame)throw new Error("VideoFrame not supported");var e,t,r,i,n,o,a,s,l,c=new VideoFrame(f,{timestamp:0});try{var u=null==c?void 0:c.format;if(!u||!u.startsWith("BGR")&&!u.startsWith("RGB"))throw new Error("Unrecognized format "+u);var h=u.startsWith("BGR"),d=new Uint8ClampedArray(y*v*4);if(yield c.copyTo(d,(e=f,t=m,r=g,i=y,n=v,o=4*Math.max(-t,0),o=(Math.max(0,r)-r)*i*4+o,a=4*i,s=Math.max(0,t),l=Math.max(0,r),{rect:{x:s,y:l,width:Math.min(e.width,t+i)-s,height:Math.min(e.height,r+n)-l},layout:[{offset:o,stride:a}]})),h)for(let e=0;e<d.length;e+=4){var p=d[e];d[e]=d[e+2],d[e+2]=p}return d}finally{c.close()}})}let re,oe;const ae="AbortError";function se(){return new Error(ae)}const le={MAX_PARALLEL_IMAGE_REQUESTS:16,MAX_PARALLEL_IMAGE_REQUESTS_PER_FRAME:8,MAX_TILE_CACHE_ZOOM_LEVELS:5,REGISTERED_PROTOCOLS:{},WORKER_URL:""};function ce(e){return le.REGISTERED_PROTOCOLS[e.substring(0,e.indexOf("://"))]}const fe="global-dispatcher";class me extends Error{constructor(e,t,r,i){super(`AJAXError: ${t} (${e}): `+r),this.status=e,this.statusText=t,this.url=r,this.body=i}}const ge=()=>X(self)?self.worker&&self.worker.referrer:("blob:"===window.location.protocol?window.parent:window).location.href,ye=e=>/^file:/.test(e)||/^file:/.test(ge())&&!/^\w+:/.test(e);function ve(e,t){if(/:\/\//.test(e.url)&&!/^https?:|^file:/.test(e.url)){var r=ce(e.url);if(r)return r(e,t);if(X(self)&&self.worker&&self.worker.actor)return self.worker.actor.sendAsync({type:"GR",data:e,targetMapId:fe},t)}if(!ye(e.url)){if(fetch&&Request&&AbortController&&Object.prototype.hasOwnProperty.call(Request.prototype,"signal"))return function(i,n){return E(this,void 0,void 0,function*(){var e=new Request(i.url,{method:i.method||"GET",body:i.body,credentials:i.credentials,headers:i.headers,cache:i.cache,referrer:ge(),signal:n.signal}),e=("json"===i.type&&e.headers.set("Accept","application/json"),yield fetch(e));if(!e.ok)throw r=yield e.blob(),new me(e.status,e.statusText,i.url,r);let t;var r=yield t="arrayBuffer"===i.type||"image"===i.type?e.arrayBuffer():"json"===i.type?e.json():e.text();if(n.signal.aborted)throw se();return{data:r,cacheControl:e.headers.get("Cache-Control"),expires:e.headers.get("Expires")}})}(e,t);if(X(self)&&self.worker&&self.worker.actor)return self.worker.actor.sendAsync({type:"GR",data:e,mustQueue:!0,targetMapId:fe},t)}return n=e,o=t,new Promise((t,r)=>{const i=new XMLHttpRequest;i.open(n.method||"GET",n.url,!0),"arrayBuffer"!==n.type&&"image"!==n.type||(i.responseType="arraybuffer");for(const e in n.headers)i.setRequestHeader(e,n.headers[e]);"json"===n.type&&(i.responseType="text",i.setRequestHeader("Accept","application/json")),i.withCredentials="include"===n.credentials,i.onerror=()=>{r(new Error(i.statusText))},i.onload=()=>{if(!o.signal.aborted)if((200<=i.status&&i.status<300||0===i.status)&&null!==i.response){let e=i.response;if("json"===n.type)try{e=JSON.parse(i.response)}catch(e){return void r(e)}t({data:e,cacheControl:i.getResponseHeader("Cache-Control"),expires:i.getResponseHeader("Expires")})}else{var e=new Blob([i.response],{type:i.getResponseHeader("Content-Type")});r(new me(i.status,i.statusText,n.url,e))}},o.signal.addEventListener("abort",()=>{i.abort(),r(se())}),i.send(n.body)});var n,o}function _e(e){var t;return!e||e.indexOf("://")<=0||0===e.indexOf("data:image/")||0===e.indexOf("blob:")||(e=new URL(e),t=window.location,e.protocol===t.protocol&&e.host===t.host)}function be(e,t,r){r[e]&&-1!==r[e].indexOf(t)||(r[e]=r[e]||[],r[e].push(t))}function we(e,t,r){r&&r[e]&&-1!==(t=r[e].indexOf(t))&&r[e].splice(t,1)}class xe{constructor(e,t={}){V(this,t),this.type=e}}class Ce extends xe{constructor(e,t={}){super("error",V({error:e},t))}}class Te{on(e,t){return this._listeners=this._listeners||{},be(e,t,this._listeners),this}off(e,t){return we(e,t,this._listeners),we(e,t,this._oneTimeListeners),this}once(t,e){return e?(this._oneTimeListeners=this._oneTimeListeners||{},be(t,e,this._oneTimeListeners),this):new Promise(e=>this.once(t,e))}fire(e,t){var r=(e="string"==typeof e?new xe(e,t||{}):e).type;if(this.listens(r)){for(const i of(e.target=this)._listeners&&this._listeners[r]?this._listeners[r].slice():[])i.call(this,e);for(const n of this._oneTimeListeners&&this._oneTimeListeners[r]?this._oneTimeListeners[r].slice():[])we(r,n,this._oneTimeListeners),n.call(this,e);t=this._eventedParent;t&&(V(e,"function"==typeof this._eventedParentData?this._eventedParentData():this._eventedParentData),t.fire(e))}else e instanceof Ce&&console.error(e.error);return this}listens(e){return this._listeners&&this._listeners[e]&&0<this._listeners[e].length||this._oneTimeListeners&&this._oneTimeListeners[e]&&0<this._oneTimeListeners[e].length||this._eventedParent&&this._eventedParent.listens(e)}setEventedParent(e,t){return this._eventedParent=e,this._eventedParentData=t,this}}var o={$version:8,$root:{version:{required:!0,type:"enum",values:[8]},name:{type:"string"},metadata:{type:"*"},center:{type:"array",value:"number"},zoom:{type:"number"},bearing:{type:"number",default:0,period:360,units:"degrees"},pitch:{type:"number",default:0,units:"degrees"},light:{type:"light"},sky:{type:"sky"},terrain:{type:"terrain"},sources:{required:!0,type:"sources"},sprite:{type:"sprite"},glyphs:{type:"string"},transition:{type:"transition"},layers:{required:!0,type:"array",value:"layer"}},sources:{"*":{type:"source"}},source:["source_vector","source_raster","source_raster_dem","source_geojson","source_video","source_image"],source_vector:{type:{required:!0,type:"enum",values:{vector:{}}},url:{type:"string"},tiles:{type:"array",value:"string"},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129]},scheme:{type:"enum",values:{xyz:{},tms:{}},default:"xyz"},minzoom:{type:"number",default:0},maxzoom:{type:"number",default:22},attribution:{type:"string"},promoteId:{type:"promoteId"},volatile:{type:"boolean",default:!1},"*":{type:"*"}},source_raster:{type:{required:!0,type:"enum",values:{raster:{}}},url:{type:"string"},tiles:{type:"array",value:"string"},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129]},minzoom:{type:"number",default:0},maxzoom:{type:"number",default:22},tileSize:{type:"number",default:512,units:"pixels"},scheme:{type:"enum",values:{xyz:{},tms:{}},default:"xyz"},attribution:{type:"string"},volatile:{type:"boolean",default:!1},"*":{type:"*"}},source_raster_dem:{type:{required:!0,type:"enum",values:{"raster-dem":{}}},url:{type:"string"},tiles:{type:"array",value:"string"},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129]},minzoom:{type:"number",default:0},maxzoom:{type:"number",default:22},tileSize:{type:"number",default:512,units:"pixels"},attribution:{type:"string"},encoding:{type:"enum",values:{terrarium:{},mapbox:{},custom:{}},default:"mapbox"},redFactor:{type:"number",default:1},blueFactor:{type:"number",default:1},greenFactor:{type:"number",default:1},baseShift:{type:"number",default:0},volatile:{type:"boolean",default:!1},"*":{type:"*"}},source_geojson:{type:{required:!0,type:"enum",values:{geojson:{}}},data:{required:!0,type:"*"},maxzoom:{type:"number",default:18},attribution:{type:"string"},buffer:{type:"number",default:128,maximum:512,minimum:0},filter:{type:"*"},tolerance:{type:"number",default:.375},cluster:{type:"boolean",default:!1},clusterRadius:{type:"number",default:50,minimum:0},clusterMaxZoom:{type:"number"},clusterMinPoints:{type:"number"},clusterProperties:{type:"*"},lineMetrics:{type:"boolean",default:!1},generateId:{type:"boolean",default:!1},promoteId:{type:"promoteId"}},source_video:{type:{required:!0,type:"enum",values:{video:{}}},urls:{required:!0,type:"array",value:"string"},coordinates:{required:!0,type:"array",length:4,value:{type:"array",length:2,value:"number"}}},source_image:{type:{required:!0,type:"enum",values:{image:{}}},url:{required:!0,type:"string"},coordinates:{required:!0,type:"array",length:4,value:{type:"array",length:2,value:"number"}}},layer:{id:{type:"string",required:!0},type:{type:"enum",values:{fill:{},line:{},symbol:{},circle:{},heatmap:{},"fill-extrusion":{},raster:{},hillshade:{},background:{}},required:!0},metadata:{type:"*"},source:{type:"string"},"source-layer":{type:"string"},minzoom:{type:"number",minimum:0,maximum:24},maxzoom:{type:"number",minimum:0,maximum:24},filter:{type:"filter"},layout:{type:"layout"},paint:{type:"paint"}},layout:["layout_fill","layout_line","layout_circle","layout_heatmap","layout_fill-extrusion","layout_symbol","layout_raster","layout_hillshade","layout_background"],layout_background:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_fill:{"fill-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_circle:{"circle-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_heatmap:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},"layout_fill-extrusion":{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_line:{"line-cap":{type:"enum",values:{butt:{},round:{},square:{}},default:"butt",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"line-join":{type:"enum",values:{bevel:{},round:{},miter:{}},default:"miter",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"line-miter-limit":{type:"number",default:2,requires:[{"line-join":"miter"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-round-limit":{type:"number",default:1.05,requires:[{"line-join":"round"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_symbol:{"symbol-placement":{type:"enum",values:{point:{},line:{},"line-center":{}},default:"point",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"symbol-spacing":{type:"number",default:250,minimum:1,units:"pixels",requires:[{"symbol-placement":"line"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"symbol-avoid-edges":{type:"boolean",default:!1,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"symbol-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"symbol-z-order":{type:"enum",values:{auto:{},"viewport-y":{},source:{}},default:"auto",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-allow-overlap":{type:"boolean",default:!1,requires:["icon-image",{"!":"icon-overlap"}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-overlap":{type:"enum",values:{never:{},always:{},cooperative:{}},requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-ignore-placement":{type:"boolean",default:!1,requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-optional":{type:"boolean",default:!1,requires:["icon-image","text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-rotation-alignment":{type:"enum",values:{map:{},viewport:{},auto:{}},default:"auto",requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-size":{type:"number",default:1,minimum:0,units:"factor of the original icon size",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-text-fit":{type:"enum",values:{none:{},width:{},height:{},both:{}},default:"none",requires:["icon-image","text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-text-fit-padding":{type:"array",value:"number",length:4,default:[0,0,0,0],units:"pixels",requires:["icon-image","text-field",{"icon-text-fit":["both","width","height"]}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-image":{type:"resolvedImage",tokens:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-rotate":{type:"number",default:0,period:360,units:"degrees",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-padding":{type:"padding",default:[2],units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-keep-upright":{type:"boolean",default:!1,requires:["icon-image",{"icon-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-offset":{type:"array",value:"number",length:2,default:[0,0],requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-anchor":{type:"enum",values:{center:{},left:{},right:{},top:{},bottom:{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},default:"center",requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-pitch-alignment":{type:"enum",values:{map:{},viewport:{},auto:{}},default:"auto",requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-pitch-alignment":{type:"enum",values:{map:{},viewport:{},auto:{}},default:"auto",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-rotation-alignment":{type:"enum",values:{map:{},viewport:{},"viewport-glyph":{},auto:{}},default:"auto",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-field":{type:"formatted",default:"",tokens:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-font":{type:"array",value:"string",default:["Open Sans Regular","Arial Unicode MS Regular"],requires:["text-field"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-size":{type:"number",default:16,minimum:0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-max-width":{type:"number",default:10,minimum:0,units:"ems",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-line-height":{type:"number",default:1.2,units:"ems",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-letter-spacing":{type:"number",default:0,units:"ems",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-justify":{type:"enum",values:{auto:{},left:{},center:{},right:{}},default:"center",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-radial-offset":{type:"number",units:"ems",default:0,requires:["text-field"],"property-type":"data-driven",expression:{interpolated:!0,parameters:["zoom","feature"]}},"text-variable-anchor":{type:"array",value:"enum",values:{center:{},left:{},right:{},top:{},bottom:{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},requires:["text-field",{"symbol-placement":["point"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-variable-anchor-offset":{type:"variableAnchorOffsetCollection",requires:["text-field",{"symbol-placement":["point"]}],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-anchor":{type:"enum",values:{center:{},left:{},right:{},top:{},bottom:{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},default:"center",requires:["text-field",{"!":"text-variable-anchor"}],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-max-angle":{type:"number",default:45,units:"degrees",requires:["text-field",{"symbol-placement":["line","line-center"]}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-writing-mode":{type:"array",value:"enum",values:{horizontal:{},vertical:{}},requires:["text-field",{"symbol-placement":["point"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-rotate":{type:"number",default:0,period:360,units:"degrees",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-padding":{type:"number",default:2,minimum:0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-keep-upright":{type:"boolean",default:!0,requires:["text-field",{"text-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-transform":{type:"enum",values:{none:{},uppercase:{},lowercase:{}},default:"none",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-offset":{type:"array",value:"number",units:"ems",length:2,default:[0,0],requires:["text-field",{"!":"text-radial-offset"}],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-allow-overlap":{type:"boolean",default:!1,requires:["text-field",{"!":"text-overlap"}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-overlap":{type:"enum",values:{never:{},always:{},cooperative:{}},requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-ignore-placement":{type:"boolean",default:!1,requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-optional":{type:"boolean",default:!1,requires:["text-field","icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_raster:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_hillshade:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},filter:{type:"array",value:"*"},filter_operator:{type:"enum",values:{"==":{},"!=":{},">":{},">=":{},"<":{},"<=":{},in:{},"!in":{},all:{},any:{},none:{},has:{},"!has":{},within:{}}},geometry_type:{type:"enum",values:{Point:{},LineString:{},Polygon:{}}},function:{expression:{type:"expression"},stops:{type:"array",value:"function_stop"},base:{type:"number",default:1,minimum:0},property:{type:"string",default:"$zoom"},type:{type:"enum",values:{identity:{},exponential:{},interval:{},categorical:{}},default:"exponential"},colorSpace:{type:"enum",values:{rgb:{},lab:{},hcl:{}},default:"rgb"},default:{type:"*",required:!1}},function_stop:{type:"array",minimum:0,maximum:24,value:["number","color"],length:2},expression:{type:"array",value:"*",minimum:1},light:{anchor:{type:"enum",default:"viewport",values:{map:{},viewport:{}},"property-type":"data-constant",transition:!1,expression:{interpolated:!1,parameters:["zoom"]}},position:{type:"array",default:[1.15,210,30],length:3,value:"number","property-type":"data-constant",transition:!0,expression:{interpolated:!0,parameters:["zoom"]}},color:{type:"color","property-type":"data-constant",default:"#ffffff",expression:{interpolated:!0,parameters:["zoom"]},transition:!0},intensity:{type:"number","property-type":"data-constant",default:.5,minimum:0,maximum:1,expression:{interpolated:!0,parameters:["zoom"]},transition:!0}},sky:{"sky-color":{type:"color","property-type":"data-constant",default:"#88C6FC",expression:{interpolated:!0,parameters:["zoom"]},transition:!0},"fog-color":{type:"color","property-type":"data-constant",default:"#ffffff",expression:{interpolated:!0,parameters:["zoom"]},transition:!0},"fog-blend":{type:"number","property-type":"data-constant",default:.5,minimum:0,maximum:1,expression:{interpolated:!0,parameters:["zoom"]},transition:!0},"horizon-blend":{type:"number","property-type":"data-constant",default:.8,minimum:0,maximum:1,expression:{interpolated:!0,parameters:["zoom"]},transition:!0}},terrain:{source:{type:"string",required:!0},exaggeration:{type:"number",minimum:0,default:1}},paint:["paint_fill","paint_line","paint_circle","paint_heatmap","paint_fill-extrusion","paint_symbol","paint_raster","paint_hillshade","paint_background"],paint_fill:{"fill-antialias":{type:"boolean",default:!0,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"fill-pattern"}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-outline-color":{type:"color",transition:!0,requires:[{"!":"fill-pattern"},{"fill-antialias":!0}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["fill-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"}},"paint_fill-extrusion":{"fill-extrusion-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"fill-extrusion-pattern"}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["fill-extrusion-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"},"fill-extrusion-height":{type:"number",default:0,minimum:0,units:"meters",transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-base":{type:"number",default:0,minimum:0,units:"meters",transition:!0,requires:["fill-extrusion-height"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-vertical-gradient":{type:"boolean",default:!0,transition:!1,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"}},paint_line:{"line-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"line-pattern"}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["line-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"line-width":{type:"number",default:1,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-gap-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-offset":{type:"number",default:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-dasharray":{type:"array",value:"number",minimum:0,transition:!0,units:"line widths",requires:[{"!":"line-pattern"}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"cross-faded"},"line-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"},"line-gradient":{type:"color",transition:!1,requires:[{"!":"line-dasharray"},{"!":"line-pattern"},{source:"geojson",has:{lineMetrics:!0}}],expression:{interpolated:!0,parameters:["line-progress"]},"property-type":"color-ramp"}},paint_circle:{"circle-radius":{type:"number",default:5,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-blur":{type:"number",default:0,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"circle-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["circle-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-pitch-scale":{type:"enum",values:{map:{},viewport:{}},default:"map",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-pitch-alignment":{type:"enum",values:{map:{},viewport:{}},default:"viewport",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-stroke-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"}},paint_heatmap:{"heatmap-radius":{type:"number",default:30,minimum:1,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-weight":{type:"number",default:1,minimum:0,transition:!1,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-intensity":{type:"number",default:1,minimum:0,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"heatmap-color":{type:"color",default:["interpolate",["linear"],["heatmap-density"],0,"rgba(0, 0, 255, 0)",.1,"royalblue",.3,"cyan",.5,"lime",.7,"yellow",1,"red"],transition:!1,expression:{interpolated:!0,parameters:["heatmap-density"]},"property-type":"color-ramp"},"heatmap-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_symbol:{"icon-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-color":{type:"color",default:"#000000",transition:!0,requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-color":{type:"color",default:"rgba(0, 0, 0, 0)",transition:!0,requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["icon-image","icon-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-color":{type:"color",default:"#000000",transition:!0,overridable:!0,requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-color":{type:"color",default:"rgba(0, 0, 0, 0)",transition:!0,requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["text-field","text-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"}},paint_raster:{"raster-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-hue-rotate":{type:"number",default:0,period:360,transition:!0,units:"degrees",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-brightness-min":{type:"number",default:0,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-brightness-max":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-saturation":{type:"number",default:0,minimum:-1,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-contrast":{type:"number",default:0,minimum:-1,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-resampling":{type:"enum",values:{linear:{},nearest:{}},default:"linear",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"raster-fade-duration":{type:"number",default:300,minimum:0,transition:!1,units:"milliseconds",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_hillshade:{"hillshade-illumination-direction":{type:"number",default:335,minimum:0,maximum:359,transition:!1,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-illumination-anchor":{type:"enum",values:{map:{},viewport:{}},default:"viewport",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-exaggeration":{type:"number",default:.5,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-shadow-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-highlight-color":{type:"color",default:"#FFFFFF",transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-accent-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_background:{"background-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"background-pattern"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"background-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"cross-faded"},"background-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},transition:{duration:{type:"number",default:300,minimum:0,units:"milliseconds"},delay:{type:"number",default:0,minimum:0,units:"milliseconds"}},"property-type":{"data-driven":{type:"property-type"},"cross-faded":{type:"property-type"},"cross-faded-data-driven":{type:"property-type"},"color-ramp":{type:"property-type"},"data-constant":{type:"property-type"},constant:{type:"property-type"}},promoteId:{"*":{type:"string"}}};const Se=["type","source","source-layer","minzoom","maxzoom","filter","layout"];function v(t,r){if(Array.isArray(t)){if(!Array.isArray(r)||t.length!==r.length)return;for(let e=0;e<t.length;e++)if(!v(t[e],r[e]))return;return 1}if("object"!=typeof t||null===t||null===r)return t===r;if("object"==typeof r&&Object.keys(t).length===Object.keys(r).length){for(const e in t)if(!v(t[e],r[e]))return;return 1}}function Ee(e,t){e.push(t)}function Ie(e,t,r){Ee(r,{command:"addSource",args:[e,t[e]]})}function Ae(e,t,r){Ee(t,{command:"removeSource",args:[e]}),r[e]=!0}function ke(e,t,r,i){t=t||{};let n;for(n in e=e||{})!Object.prototype.hasOwnProperty.call(e,n)||Object.prototype.hasOwnProperty.call(t,n)||Ae(n,r,i);for(n in t)Object.prototype.hasOwnProperty.call(t,n)&&(Object.prototype.hasOwnProperty.call(e,n)?v(e[n],t[n])||("geojson"===e[n].type&&"geojson"===t[n].type&&function(e,t,r){let i;for(i in e[r])if(Object.prototype.hasOwnProperty.call(e[r],i)&&"data"!==i&&!v(e[r][i],t[r][i]))return;for(i in t[r])if(Object.prototype.hasOwnProperty.call(t[r],i)&&"data"!==i&&!v(e[r][i],t[r][i]))return;return 1}(e,t,n)?Ee(r,{command:"setGeoJSONSourceData",args:[n,t[n].data]}):(o=n,a=t,Ae(o,s=r,i),Ie(o,a,s))):Ie(n,t,r));var o,a,s}function Pe(e,t,r,i,n,o){t=t||{};for(const a in e=e||{})!Object.prototype.hasOwnProperty.call(e,a)||v(e[a],t[a])||r.push({command:o,args:[i,a,t[a],n]});for(const s in t)!Object.prototype.hasOwnProperty.call(t,s)||Object.prototype.hasOwnProperty.call(e,s)||v(e[s],t[s])||r.push({command:o,args:[i,s,t[s],n]})}function Me(e){return e.id}function Re(e,t){return e[t.id]=t,e}class p{constructor(e,t,r,i){this.message=(e?e+": ":"")+r,i&&(this.identifier=i),null!=t&&t.__line__&&(this.line=t.__line__)}}function Oe(e,...t){for(const r of t)for(const i in r)e[i]=r[i];return e}class Le extends Error{constructor(e,t){super(t),this.message=t,this.key=e}}class De{constructor(e,t=[]){this.parent=e,this.bindings={};for(var[r,i]of t)this.bindings[r]=i}concat(e){return new De(this,e)}get(e){if(this.bindings[e])return this.bindings[e];if(this.parent)return this.parent.get(e);throw new Error(e+" not found in scope.")}has(e){return!!this.bindings[e]||!!this.parent&&this.parent.has(e)}}const ze={kind:"null"},f={kind:"number"},s={kind:"string"},u={kind:"boolean"},Ne={kind:"color"},Be={kind:"object"},h={kind:"value"};const Fe={kind:"collator"},Ue={kind:"formatted"},qe={kind:"padding"},je={kind:"resolvedImage"},He={kind:"variableAnchorOffsetCollection"};function m(e,t){return{kind:"array",itemType:e,N:t}}function g(e){var t;return"array"===e.kind?(t=g(e.itemType),"number"==typeof e.N?`array<${t}, ${e.N}>`:"value"===e.itemType.kind?"array":`array<${t}>`):e.kind}const Ve=[ze,f,s,u,Ne,Ue,Be,m(h),qe,je,He];function Ge(e,t){if("error"===t.kind)return null;if("array"===e.kind){if("array"===t.kind&&(0===t.N&&"value"===t.itemType.kind||!Ge(e.itemType,t.itemType))&&("number"!=typeof e.N||e.N===t.N))return null}else{if(e.kind===t.kind)return null;if("value"===e.kind)for(const r of Ve)if(!Ge(r,t))return null}return`Expected ${g(e)} but found ${g(t)} instead.`}function Ke(t,e){return e.some(e=>e.kind===t.kind)}function Ze(t,e){return e.some(e=>"null"===e?null===t:"array"===e?Array.isArray(t):"object"===e?t&&!Array.isArray(t)&&"object"==typeof t:e===typeof t)}function We(e,t){return"array"===e.kind&&"array"===t.kind?e.itemType.kind===t.itemType.kind&&"number"==typeof e.N:e.kind===t.kind}const Ye=.96422,$e=1,Xe=.82521,Je=4/29,Qe=6/29,et=3*Qe*Qe,tt=Qe*Qe*Qe,rt=Math.PI/180,it=180/Math.PI;function nt(e){return(e%=360)<0&&(e+=360),e}function ot([e,t,r,i]){let n,o;var a=st((.2225045*(e=at(e))+.7168786*(t=at(t))+.0606169*(r=at(r)))/$e),e=(e===t&&t===r?n=o=a:(n=st((.4360747*e+.3850649*t+.1430804*r)/Ye),o=st((.0139322*e+.0971045*t+.7141733*r)/Xe)),116*a-16);return[e<0?0:e,500*(n-a),200*(a-o),i]}function at(e){return e<=.04045?e/12.92:Math.pow((e+.055)/1.055,2.4)}function st(e){return e>tt?Math.pow(e,1/3):e/et+Je}function lt([e,t,r,i]){e=(e+16)/116,t=isNaN(t)?e:e+t/500,r=isNaN(r)?e:e-r/200,e=$e*ut(e);return[ct(3.1338561*(t=Ye*ut(t))-1.6168667*e-.4906146*(r=Xe*ut(r))),ct(-.9787684*t+1.9161415*e+.033454*r),ct(.0719453*t-.2289914*e+1.4052427*r),i]}function ct(e){return(e=e<=.00304?12.92*e:1.055*Math.pow(e,1/2.4)-.055)<0?0:1<e?1:e}function ut(e){return e>Qe?e*e*e:et*(e-Je)}function ht(e){if("transparent"===(e=e.toLowerCase().trim()))return[0,0,0,0];var t=gt[e];if(t)return[t,i,r]=t,[t/255,i/255,r/255,1];if(e.startsWith("#")&&/^#(?:[0-9a-f]{3,4}|[0-9a-f]{6}|[0-9a-f]{8})$/.test(e))return t=e.length<6?1:2,[dt(e.slice(i=1,i+=t)),dt(e.slice(i,i+=t)),dt(e.slice(i,i+=t)),dt(e.slice(i,i+t)||"ff")];if(e.startsWith("rgb")){var r=e.match(/^rgba?\(\s*([\de.+-]+)(%)?(?:\s+|\s*(,)\s*)([\de.+-]+)(%)?(?:\s+|\s*(,)\s*)([\de.+-]+)(%)?(?:\s*([,\/])\s*([\de.+-]+)(%)?)?\s*\)$/);if(r){var[,i,t,r,n,o,a,s,l,c,u,h]=r,r=[r||" ",a||" ",c].join("");if("  "===r||"  /"===r||",,"===r||",,,"===r){a=[t,o,l].join(""),c="%%%"===a?100:""===a?255:0;if(c){r=[ft(+i/c,0,1),ft(+n/c,0,1),ft(+s/c,0,1),u?pt(+u,h):1];if(mt(r))return r}}return}}var d,p,f,t=e.match(/^hsla?\(\s*([\de.+-]+)(?:deg)?(?:\s+|\s*(,)\s*)([\de.+-]+)%(?:\s+|\s*(,)\s*)([\de.+-]+)%(?:\s*([,\/])\s*([\de.+-]+)(%)?)?\s*\)$/);if(t){var[,o,l,a,i,n,s,c,u]=t,h=[l||" ",i||" ",s].join("");if("  "===h||"  /"===h||",,"===h||",,,"===h){r=[+o,ft(+a,0,100),ft(+n,0,100),c?pt(+c,u):1];if(mt(r))return[d,p,f,e]=[r][0],d=nt(d),p/=100,f/=100,[m(0),m(8),m(4),e]}}function m(e){var e=(e+d/30)%12,t=p*Math.min(f,1-f);return f-t*Math.max(-1,Math.min(e-3,9-e,1))}}function dt(e){return parseInt(e.padEnd(2,e),16)/255}function pt(e,t){return ft(t?e/100:e,0,1)}function ft(e,t,r){return Math.min(Math.max(t,e),r)}function mt(e){return!e.some(Number.isNaN)}const gt={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]};class _{constructor(e,t,r,i=1,n=!0){this.r=e,this.g=t,this.b=r,this.a=i,n||(this.r*=i,this.g*=i,this.b*=i,i)||this.overwriteGetter("rgb",[e,t,r,i])}static parse(e){return e instanceof _?e:"string"==typeof e&&(e=ht(e))?new _(...e,!1):void 0}get rgb(){var{r:e,g:t,b:r,a:i}=this,n=i||1/0;return this.overwriteGetter("rgb",[e/n,t/n,r/n,i])}get hcl(){return this.overwriteGetter("hcl",function(e){var[e,t,r,i]=ot(e),n=Math.sqrt(t*t+r*r);return[Math.round(1e4*n)?nt(Math.atan2(r,t)*it):NaN,n,e,i]}(this.rgb))}get lab(){return this.overwriteGetter("lab",ot(this.rgb))}overwriteGetter(e,t){return Object.defineProperty(this,e,{value:t}),t}toString(){var[e,t,r,i]=this.rgb;return`rgba(${[e,t,r].map(e=>Math.round(255*e)).join(",")},${i})`}}_.black=new _(0,0,0,1),_.white=new _(1,1,1,1),_.transparent=new _(0,0,0,0),_.red=new _(1,0,0,1);class yt{constructor(e,t,r){this.sensitivity=e?t?"variant":"case":t?"accent":"base",this.locale=r,this.collator=new Intl.Collator(this.locale||[],{sensitivity:this.sensitivity,usage:"search"})}compare(e,t){return this.collator.compare(e,t)}resolvedLocale(){return new Intl.Collator(this.locale||[]).resolvedOptions().locale}}class vt{constructor(e,t,r,i,n){this.text=e,this.image=t,this.scale=r,this.fontStack=i,this.textColor=n}}class _t{constructor(e){this.sections=e}static fromString(e){return new _t([new vt(e,null,null,null,null)])}isEmpty(){return 0===this.sections.length||!this.sections.some(e=>0!==e.text.length||e.image&&0!==e.image.name.length)}static factory(e){return e instanceof _t?e:_t.fromString(e)}toString(){return 0===this.sections.length?"":this.sections.map(e=>e.text).join("")}}class bt{constructor(e){this.values=e.slice()}static parse(e){if(e instanceof bt)return e;if("number"==typeof e)return new bt([e,e,e,e]);if(Array.isArray(e)&&!(e.length<1||4<e.length)){for(const t of e)if("number"!=typeof t)return;switch(e.length){case 1:e=[e[0],e[0],e[0],e[0]];break;case 2:e=[e[0],e[1],e[0],e[1]];break;case 3:e=[e[0],e[1],e[2],e[1]]}return new bt(e)}}toString(){return JSON.stringify(this.values)}}const wt=new Set(["center","left","right","top","bottom","top-left","top-right","bottom-left","bottom-right"]);class xt{constructor(e){this.values=e.slice()}static parse(t){if(t instanceof xt)return t;if(Array.isArray(t)&&!(t.length<1)&&t.length%2==0){for(let e=0;e<t.length;e+=2){var r=t[e],i=t[e+1];if("string"!=typeof r||!wt.has(r))return;if(!Array.isArray(i)||2!==i.length||"number"!=typeof i[0]||"number"!=typeof i[1])return}return new xt(t)}}toString(){return JSON.stringify(this.values)}}class Ct{constructor(e){this.name=e.name,this.available=e.available}toString(){return this.name}static fromString(e){return e?new Ct({name:e,available:!1}):null}}function Tt(e,t,r,i){return"number"==typeof e&&0<=e&&e<=255&&"number"==typeof t&&0<=t&&t<=255&&"number"==typeof r&&0<=r&&r<=255?void 0===i||"number"==typeof i&&0<=i&&i<=1?null:`Invalid rgba value [${[e,t,r,i].join(", ")}]: 'a' must be between 0 and 1.`:`Invalid rgba value [${("number"==typeof i?[e,t,r,i]:[e,t,r]).join(", ")}]: 'r', 'g', and 'b' must be between 0 and 255.`}function St(e){if(null===e||"string"==typeof e||"boolean"==typeof e||"number"==typeof e||e instanceof _||e instanceof yt||e instanceof _t||e instanceof bt||e instanceof xt||e instanceof Ct)return 1;if(Array.isArray(e)){for(const t of e)if(!St(t))return;return 1}if("object"==typeof e){for(const r in e)if(!St(e[r]))return;return 1}}function d(t){if(null===t)return ze;if("string"==typeof t)return s;if("boolean"==typeof t)return u;if("number"==typeof t)return f;if(t instanceof _)return Ne;if(t instanceof yt)return Fe;if(t instanceof _t)return Ue;if(t instanceof bt)return qe;if(t instanceof xt)return He;if(t instanceof Ct)return je;if(Array.isArray(t)){var r=t.length;let e;for(const n of t){var i=d(n);if(e){if(e!==i){e=h;break}}else e=i}return m(e||h,r)}return Be}function Et(e){var t=typeof e;return null===e?"":"string"==t||"number"==t||"boolean"==t?String(e):e instanceof _||e instanceof _t||e instanceof bt||e instanceof xt||e instanceof Ct?e.toString():JSON.stringify(e)}class It{constructor(e,t){this.type=e,this.value=t}static parse(e,t){if(2!==e.length)return t.error(`'literal' expression requires exactly one argument, but found ${e.length-1} instead.`);if(!St(e[1]))return t.error("invalid value");e=e[1];let r=d(e);t=t.expectedType;return"array"!==r.kind||0!==r.N||!t||"array"!==t.kind||"number"==typeof t.N&&0!==t.N||(r=t),new It(r,e)}evaluate(){return this.value}eachChild(){}outputDefined(){return!0}}class y{constructor(e){this.name="ExpressionEvaluationError",this.message=e}toJSON(){return this.message}}const At={string:s,number:f,boolean:u,object:Be};class kt{constructor(e,t){this.type=e,this.args=t}static parse(r,i){if(r.length<2)return i.error("Expected at least one argument.");let n=1,o;var e=r[0];if("array"===e){let e;if(2<r.length){const o=r[1];if("string"!=typeof o||!(o in At)||"object"===o)return i.error('The item type argument of "array" must be one of string, number, boolean',1);e=At[o],n++}else e=h;let t;if(3<r.length){if(null!==r[2]&&("number"!=typeof r[2]||r[2]<0||r[2]!==Math.floor(r[2])))return i.error('The length argument to "array" must be a positive integer literal',2);t=r[2],n++}o=m(e,t)}else{if(!At[e])throw new Error("Types doesn't contain name = "+e);o=At[e]}for(var t=[];n<r.length;n++){var a=i.parse(r[n],n,h);if(!a)return null;t.push(a)}return new kt(o,t)}evaluate(t){for(let e=0;e<this.args.length;e++){var r=this.args[e].evaluate(t);if(!Ge(this.type,d(r)))return r;if(e===this.args.length-1)throw new y(`Expected value to be of type ${g(this.type)}, but found ${g(d(r))} instead.`)}throw new Error}eachChild(e){this.args.forEach(e)}outputDefined(){return this.args.every(e=>e.outputDefined())}}const Pt={"to-boolean":u,"to-color":Ne,"to-number":f,"to-string":s};class Mt{constructor(e,t){this.type=e,this.args=t}static parse(t,r){if(t.length<2)return r.error("Expected at least one argument.");var e=t[0];if(!Pt[e])throw new Error(`Can't parse ${e} as it is not part of the known types`);if(("to-boolean"===e||"to-string"===e)&&2!==t.length)return r.error("Expected one argument.");var e=Pt[e],i=[];for(let e=1;e<t.length;e++){var n=r.parse(t[e],e,h);if(!n)return null;i.push(n)}return new Mt(e,i)}evaluate(r){switch(this.type.kind){case"boolean":return Boolean(this.args[0].evaluate(r));case"color":{let e,t;for(const a of this.args){if(e=a.evaluate(r),t=null,e instanceof _)return e;if("string"==typeof e){var i=r.parseColor(e);if(i)return i}else if(Array.isArray(e)&&!(t=e.length<3||4<e.length?`Invalid rbga value ${JSON.stringify(e)}: expected an array containing either three or four numeric values.`:Tt(e[0],e[1],e[2],e[3])))return new _(e[0]/255,e[1]/255,e[2]/255,e[3])}throw new y(t||`Could not parse color from value '${"string"==typeof e?e:JSON.stringify(e)}'`)}case"padding":{let e;for(const s of this.args){e=s.evaluate(r);var t=bt.parse(e);if(t)return t}throw new y(`Could not parse padding from value '${"string"==typeof e?e:JSON.stringify(e)}'`)}case"variableAnchorOffsetCollection":{let e;for(const l of this.args){e=l.evaluate(r);var n=xt.parse(e);if(n)return n}throw new y(`Could not parse variableAnchorOffsetCollection from value '${"string"==typeof e?e:JSON.stringify(e)}'`)}case"number":{let e=null;for(const c of this.args){if(null===(e=c.evaluate(r)))return 0;var o=Number(e);if(!isNaN(o))return o}throw new y(`Could not convert ${JSON.stringify(e)} to number.`)}case"formatted":return _t.fromString(Et(this.args[0].evaluate(r)));case"resolvedImage":return Ct.fromString(Et(this.args[0].evaluate(r)));default:return Et(this.args[0].evaluate(r))}}eachChild(e){this.args.forEach(e)}outputDefined(){return this.args.every(e=>e.outputDefined())}}const Rt=["Unknown","Point","LineString","Polygon"];class Ot{constructor(){this.globals=null,this.feature=null,this.featureState=null,this.formattedSection=null,this._parseColorCache={},this.availableImages=null,this.canonical=null}id(){return this.feature&&"id"in this.feature?this.feature.id:null}geometryType(){return this.feature?"number"==typeof this.feature.type?Rt[this.feature.type]:this.feature.type:null}geometry(){return this.feature&&"geometry"in this.feature?this.feature.geometry:null}canonicalID(){return this.canonical}properties(){return this.feature&&this.feature.properties||{}}parseColor(e){let t=this._parseColorCache[e];return t=t||(this._parseColorCache[e]=_.parse(e))}}class Lt{constructor(e,t,r=[],i,n=new De,o=[]){this.registry=e,this.path=r,this.key=r.map(e=>`[${e}]`).join(""),this.scope=n,this.errors=o,this.expectedType=i,this._isConstant=t}parse(e,t,r,i,n={}){return(t?this.concat(t,r,i):this)._parse(e,n)}_parse(t,r){function i(e,t,r){return"assert"===r?new kt(t,[e]):"coerce"===r?new Mt(t,[e]):e}if(null!==t&&"string"!=typeof t&&"boolean"!=typeof t&&"number"!=typeof t||(t=["literal",t]),Array.isArray(t)){if(0===t.length)return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');var e=t[0];if("string"!=typeof e)return this.error(`Expression name must be a string, but found ${typeof e} instead. If you wanted a literal array, use ["literal", [...]].`,0),null;var n=this.registry[e];if(n){let e=n.parse(t,this);if(!e)return null;if(this.expectedType){var n=this.expectedType,o=e.type;if("string"!==n.kind&&"number"!==n.kind&&"boolean"!==n.kind&&"object"!==n.kind&&"array"!==n.kind||"value"!==o.kind)if("color"!==n.kind&&"formatted"!==n.kind&&"resolvedImage"!==n.kind||"value"!==o.kind&&"string"!==o.kind)if("padding"!==n.kind||"value"!==o.kind&&"number"!==o.kind&&"array"!==o.kind)if("variableAnchorOffsetCollection"!==n.kind||"value"!==o.kind&&"array"!==o.kind){if(this.checkSubtype(n,o))return null}else e=i(e,n,r.typeAnnotation||"coerce");else e=i(e,n,r.typeAnnotation||"coerce");else e=i(e,n,r.typeAnnotation||"coerce");else e=i(e,n,r.typeAnnotation||"assert")}if(!(e instanceof It)&&"resolvedImage"!==e.type.kind&&this._isConstant(e)){o=new Ot;try{e=new It(e.type,e.evaluate(o))}catch(e){return this.error(e.message),null}}return e}return this.error(`Unknown expression "${e}". If you wanted a literal array, use ["literal", [...]].`,0)}return void 0===t?this.error("'undefined' value invalid. Use null instead."):"object"==typeof t?this.error('Bare objects invalid. Use ["literal", {...}] instead.'):this.error(`Expected an array, but found ${typeof t} instead.`)}concat(e,t,r){e="number"==typeof e?this.path.concat(e):this.path,r=r?this.scope.concat(r):this.scope;return new Lt(this.registry,this._isConstant,e,t||null,r,this.errors)}error(e,...t){t=""+this.key+t.map(e=>`[${e}]`).join("");this.errors.push(new Le(t,e))}checkSubtype(e,t){e=Ge(e,t);return e&&this.error(e),e}}class Dt{constructor(e,t,r){this.type=Fe,this.locale=r,this.caseSensitive=e,this.diacriticSensitive=t}static parse(e,t){if(2!==e.length)return t.error("Expected one argument.");e=e[1];if("object"!=typeof e||Array.isArray(e))return t.error("Collator options argument must be an object.");var r=t.parse(void 0!==e["case-sensitive"]&&e["case-sensitive"],1,u);if(!r)return null;var i=t.parse(void 0!==e["diacritic-sensitive"]&&e["diacritic-sensitive"],1,u);if(!i)return null;let n=null;return e.locale&&!(n=t.parse(e.locale,1,s))?null:new Dt(r,i,n)}evaluate(e){return new yt(this.caseSensitive.evaluate(e),this.diacriticSensitive.evaluate(e),this.locale?this.locale.evaluate(e):null)}eachChild(e){e(this.caseSensitive),e(this.diacriticSensitive),this.locale&&e(this.locale)}outputDefined(){return!1}}const zt=8192;function Nt(e,t){e[0]=Math.min(e[0],t[0]),e[1]=Math.min(e[1],t[1]),e[2]=Math.max(e[2],t[0]),e[3]=Math.max(e[3],t[1])}function Bt(e,t){return!(e[0]<=t[0]||e[2]>=t[2]||e[1]<=t[1]||e[3]>=t[3])}function Ft(e,t){var r=(180+e[0])/360,e=(e=e[1],(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+e*Math.PI/360)))/360),t=Math.pow(2,t.z);return[Math.round(r*t*zt),Math.round(e*t*zt)]}function Ut(r,i){let n=!1;for(let e=0,t=i.length;e<t;e++){var o=i[e];for(let e=0,t=o.length;e<t-1;e++){if(a=r,s=o[e],l=o[e+1],u=c=void 0,c=a[0]-s[0],s=a[1]-s[1],u=a[0]-l[0],a=a[1]-l[1],c*a-u*s==0&&c*u<=0&&s*a<=0)return;l=r,c=o[e],u=o[e+1],c[1]>l[1]!=u[1]>l[1]&&l[0]<(u[0]-c[0])*(l[1]-c[1])/(u[1]-c[1])+c[0]&&(n=!n)}}var a,s,l,c,u;return n}function qt(e,t,r,i){var n=e[0]-r[0],e=e[1]-r[1],o=t[0]-r[0],t=t[1]-r[1],a=i[0]-r[0],i=i[1]-r[1],r=n*i-a*e,n=o*i-a*t;return 0<r&&n<0||r<0&&0<n}function jt(t,r,e){for(const c of e)for(let e=0;e<c.length-1;++e)if(i=t,n=r,o=c[e],a=c[e+1],l=s=void 0,s=[n[0]-i[0],n[1]-i[1]],0!=(l=[a[0]-o[0],a[1]-o[1]])[0]*s[1]-l[1]*s[0]&&!(!qt(i,n,o,a)||!qt(o,a,i,n)))return 1;var i,n,o,a,s,l}function Ht(t,r){for(let e=0;e<t.length;++e)if(!Ut(t[e],r))return;for(let e=0;e<t.length-1;++e)if(jt(t[e],t[e+1],r))return;return 1}function Vt(r,i,n){var e=[];for(let t=0;t<r.length;t++){var o=[];for(let e=0;e<r[t].length;e++){var a=Ft(r[t][e],n);Nt(i,a),o.push(a)}e.push(o)}return e}function Gt(t,r,i){var n=[];for(let e=0;e<t.length;e++){var o=Vt(t[e],r,i);n.push(o)}return n}function Kt(t,e,r,i){if(t[0]<r[0]||t[0]>r[2]){var n=.5*i;let e=t[0]-r[0]>n?-i:r[0]-t[0]>n?i:0;0===e&&(e=t[0]-r[2]>n?-i:r[2]-t[0]>n?i:0),t[0]+=e}Nt(e,t)}function Zt(e,t,r,i){var n=Math.pow(2,i.z)*zt,o=[i.x*zt,i.y*zt],a=[];for(const l of e)for(const c of l){var s=[c.x+o[0],c.y+o[1]];Kt(s,t,r,n),a.push(s)}return a}function Wt(e,t,r,i){var n=Math.pow(2,i.z)*zt,o=[i.x*zt,i.y*zt],a=[];for(const c of e){var s=[];for(const u of c){var l=[u.x+o[0],u.y+o[1]];Nt(t,l),s.push(l)}a.push(s)}if(t[2]-t[0]<=n/2){(i=t)[0]=i[1]=1/0,i[2]=i[3]=-1/0;for(const h of a)for(const d of h)Kt(d,t,r,n)}return a}function Yt(e,t){var r=[1/0,1/0,-1/0,-1/0],i=[1/0,1/0,-1/0,-1/0],n=e.canonicalID();if("Polygon"===t.type){var o=Vt(t.coordinates,i,n),a=Zt(e.geometry(),r,i,n);if(!Bt(r,i))return!1;for(const l of a)if(!Ut(l,o))return!1}if("MultiPolygon"===t.type){var s=Gt(t.coordinates,i,n),a=Zt(e.geometry(),r,i,n);if(!Bt(r,i))return!1;for(const c of a)if(!function(t,r){for(let e=0;e<r.length;e++)if(Ut(t,r[e]))return 1}(c,s))return!1}return!0}function $t(e,t){var r=[1/0,1/0,-1/0,-1/0],i=[1/0,1/0,-1/0,-1/0],n=e.canonicalID();if("Polygon"===t.type){var o=Vt(t.coordinates,i,n),a=Wt(e.geometry(),r,i,n);if(!Bt(r,i))return!1;for(const l of a)if(!Ht(l,o))return!1}if("MultiPolygon"===t.type){var s=Gt(t.coordinates,i,n),a=Wt(e.geometry(),r,i,n);if(!Bt(r,i))return!1;for(const c of a)if(!function(t,r){for(let e=0;e<r.length;e++)if(Ht(t,r[e]))return 1}(c,s))return!1}return!0}class Xt{constructor(e,t){this.type=u,this.geojson=e,this.geometries=t}static parse(e,t){if(2!==e.length)return t.error(`'within' expression requires exactly one argument, but found ${e.length-1} instead.`);if(St(e[1])){e=e[1];if("FeatureCollection"===e.type){var r=[];for(const a of e.features){var{type:i,coordinates:n}=a.geometry;"Polygon"===i&&r.push(n),"MultiPolygon"===i&&r.push(...n)}if(r.length)return o={type:"MultiPolygon",coordinates:r},new Xt(e,o)}else if("Feature"===e.type){var o=e.geometry.type;if("Polygon"===o||"MultiPolygon"===o)return new Xt(e,e.geometry)}else if("Polygon"===e.type||"MultiPolygon"===e.type)return new Xt(e,e)}return t.error("'within' expression requires valid geojson object that contains polygon geometry type.")}evaluate(e){if(null!=e.geometry()&&null!=e.canonicalID()){if("Point"===e.geometryType())return Yt(e,this.geometries);if("LineString"===e.geometryType())return $t(e,this.geometries)}return!1}eachChild(){}outputDefined(){return!0}}class Jt{constructor(e,t){this.type=t.type,this.name=e,this.boundExpression=t}static parse(e,t){return 2!==e.length||"string"!=typeof e[1]?t.error("'var' expression requires exactly one string literal argument."):(e=e[1],t.scope.has(e)?new Jt(e,t.scope.get(e)):t.error(`Unknown variable "${e}". Make sure "${e}" has been bound in an enclosing "let" expression before using it.`,1))}evaluate(e){return this.boundExpression.evaluate(e)}eachChild(){}outputDefined(){return!1}}class Qt{constructor(e,t,r,i){this.name=e,this.type=t,this._evaluate=r,this.args=i}evaluate(e){return this._evaluate(e,this.args)}eachChild(e){this.args.forEach(e)}outputDefined(){return!1}static parse(r,i){var e=r[0],t=Qt.definitions[e];if(!t)return i.error(`Unknown expression "${e}". If you wanted a literal array, use ["literal", [...]].`,0);var n,o,a=Array.isArray(t)?t[0]:t.type,t=Array.isArray(t)?[[t[1],t[2]]]:t.overloads,s=t.filter(([e])=>!Array.isArray(e)||e.length===r.length-1);let l=null;for([n,o]of s){l=new Lt(i.registry,er,i.path,null,i.scope);var c=[];let t=!1;for(let e=1;e<r.length;e++){var u=r[e],h=Array.isArray(n)?n[e-1]:n.type,u=l.parse(u,1+c.length,h);if(!u){t=!0;break}c.push(u)}if(!t)if(Array.isArray(n)&&n.length!==c.length)l.error(`Expected ${n.length} arguments, but found ${c.length} instead.`);else{for(let e=0;e<c.length;e++){var d=Array.isArray(n)?n[e]:n.type,p=c[e];l.concat(e+1).checkSubtype(d,p.type)}if(0===l.errors.length)return new Qt(e,a,o,c)}}if(1===s.length)i.errors.push(...l.errors);else{var s=(s.length?s:t).map(([e])=>{return e=e,Array.isArray(e)?`(${e.map(g).join(", ")})`:`(${g(e.type)}...)`}).join(" | "),f=[];for(let e=1;e<r.length;e++){var m=i.parse(r[e],1+f.length);if(!m)return null;f.push(g(m.type))}i.error(`Expected arguments of type ${s}, but found (${f.join(", ")}) instead.`)}return null}static register(e,t){for(const r in Qt.definitions=t)e[r]=Qt}}function er(e){if(e instanceof Jt)return er(e.boundExpression);if(e instanceof Qt&&"error"===e.name)return!1;if(e instanceof Dt)return!1;if(e instanceof Xt)return!1;const t=e instanceof Mt||e instanceof kt;let r=!0;return e.eachChild(e=>{r=t?r&&er(e):r&&e instanceof It}),!!r&&tr(e)&&ir(e,["zoom","heatmap-density","line-progress","accumulated","is-supported-script"])}function tr(e){if(e instanceof Qt){if("get"===e.name&&1===e.args.length)return!1;if("feature-state"===e.name)return!1;if("has"===e.name&&1===e.args.length)return!1;if("properties"===e.name||"geometry-type"===e.name||"id"===e.name)return!1;if(/^filter-/.test(e.name))return!1}if(e instanceof Xt)return!1;let t=!0;return e.eachChild(e=>{t&&!tr(e)&&(t=!1)}),t}function rr(e){if(!(e instanceof Qt&&"feature-state"===e.name)){let t=!0;return e.eachChild(e=>{t&&!rr(e)&&(t=!1)}),t}}function ir(e,t){if(e instanceof Qt&&0<=t.indexOf(e.name))return!1;let r=!0;return e.eachChild(e=>{r&&!ir(e,t)&&(r=!1)}),r}function nr(e,t){var r=e.length-1;let i=0,n=r;for(var o,a,s;i<=n;)if(a=e[o=Math.floor((i+n)/2)],s=e[o+1],a<=t){if(o===r||t<s)return o;i=o+1}else{if(!(t<a))throw new y("Input is not a number.");n=o-1}return 0}class or{constructor(e,t,r){this.type=e,this.input=t,this.labels=[],this.outputs=[];for(var[i,n]of r)this.labels.push(i),this.outputs.push(n)}static parse(t,r){if(t.length-1<4)return r.error(`Expected at least 4 arguments, but found only ${t.length-1}.`);if((t.length-1)%2!=0)return r.error("Expected an even number of arguments.");var e=r.parse(t[1],1,f);if(!e)return null;var i=[];let n=null;r.expectedType&&"value"!==r.expectedType.kind&&(n=r.expectedType);for(let e=1;e<t.length;e+=2){var o=1===e?-1/0:t[e],a=t[e+1],s=e,l=e+1;if("number"!=typeof o)return r.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.',s);if(i.length&&i[i.length-1][0]>=o)return r.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.',s);s=r.parse(a,l,n);if(!s)return null;n=n||s.type,i.push([o,s])}return new or(n,e,i)}evaluate(e){var t,r,i=this.labels,n=this.outputs;return(1===i.length||(t=this.input.evaluate(e))<=i[0]?n[0]:t>=i[(r=i.length)-1]?n[r-1]:n[nr(i,t)]).evaluate(e)}eachChild(e){e(this.input);for(const t of this.outputs)e(t)}outputDefined(){return this.outputs.every(e=>e.outputDefined())}}function ar(e){return e&&e.__esModule&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e}var sr=lr;function lr(e,t,r,i){this.cx=3*e,this.bx=3*(r-e)-this.cx,this.ax=1-this.cx-this.bx,this.cy=3*t,this.by=3*(i-t)-this.cy,this.ay=1-this.cy-this.by,this.p1x=e,this.p1y=t,this.p2x=r,this.p2y=i}lr.prototype={sampleCurveX:function(e){return((this.ax*e+this.bx)*e+this.cx)*e},sampleCurveY:function(e){return((this.ay*e+this.by)*e+this.cy)*e},sampleCurveDerivativeX:function(e){return(3*this.ax*e+2*this.bx)*e+this.cx},solveCurveX:function(e,t){if(void 0===t&&(t=1e-6),e<0)return 0;if(1<e)return 1;for(var r=e,i=0;i<8;i++){var n=this.sampleCurveX(r)-e;if(Math.abs(n)<t)return r;var o=this.sampleCurveDerivativeX(r);if(Math.abs(o)<1e-6)break;r-=n/o}for(var a=0,s=1,r=e,i=0;i<20&&(n=this.sampleCurveX(r),!(Math.abs(n-e)<t));i++)n<e?a=r:s=r,r=.5*(s-a)+a;return r},solve:function(e,t){return this.sampleCurveY(this.solveCurveX(e,t))}};var cr=ar(sr);function ur(e,t,r){return e+r*(t-e)}function hr(e,r,i){return e.map((e,t)=>ur(e,r[t],i))}const k={number:ur,color:function(r,i,n,e="rgb"){switch(e){case"rgb":var[o,a,s,l]=hr(r.rgb,i.rgb,n);return new _(o,a,s,l,!1);case"hcl":{var[o,a,s,l]=r.hcl,[c,u,h,d]=i.hcl;let t,e;if(isNaN(o)||isNaN(c))isNaN(o)?isNaN(c)?t=NaN:(t=c,1!==s&&0!==s||(e=u)):(t=o,1!==h&&0!==h||(e=a));else{let e=c-o;o<c&&180<e?e-=360:c<o&&180<o-c&&(e+=360),t=o+n*e}[c,o,a,u]=[[t,null!==e&&void 0!==e?e:ur(a,u,n),ur(s,h,n),ur(l,d,n)]][0],c=isNaN(c)?0:c*rt;var[s,h,l,d]=lt([a,Math.cos(c)*o,Math.sin(c)*o,u]);return new _(s,h,l,d,!1)}case"lab":var[c,u,s,h]=lt(hr(r.lab,i.lab,n));return new _(c,u,s,h,!1)}},array:hr,padding:function(e,t,r){return new bt(hr(e.values,t.values,r))},variableAnchorOffsetCollection:function(e,t,r){var i=e.values,n=t.values;if(i.length!==n.length)throw new y(`Cannot interpolate values of different length. from: ${e.toString()}, to: `+t.toString());var o=[];for(let e=0;e<i.length;e+=2){if(i[e]!==n[e])throw new y(`Cannot interpolate values containing mismatched anchors. from[${e}]: ${i[e]}, to[${e}]: `+n[e]);o.push(i[e]);var[a,s]=i[e+1],[l,c]=n[e+1];o.push([ur(a,l,r),ur(s,c,r)])}return new xt(o)}};class dr{constructor(e,t,r,i,n){this.type=e,this.operator=t,this.interpolation=r,this.input=i,this.labels=[],this.outputs=[];for(var[o,a]of n)this.labels.push(o),this.outputs.push(a)}static interpolationFactor(e,t,r,i){let n=0;return"exponential"===e.name?n=pr(t,e.base,r,i):"linear"===e.name?n=pr(t,1,r,i):"cubic-bezier"===e.name&&(e=e.controlPoints,e=new cr(e[0],e[1],e[2],e[3]),n=e.solve(pr(t,1,r,i))),n}static parse(e,t){let[r,i,n,...o]=e;if(!Array.isArray(i)||0===i.length)return t.error("Expected an interpolation type expression.",1);if("linear"===i[0])i={name:"linear"};else if("exponential"===i[0]){var a=i[1];if("number"!=typeof a)return t.error("Exponential interpolation requires a numeric base.",1,1);i={name:"exponential",base:a}}else{if("cubic-bezier"!==i[0])return t.error("Unknown interpolation type "+String(i[0]),1,0);a=i.slice(1);if(4!==a.length||a.some(e=>"number"!=typeof e||e<0||1<e))return t.error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.",1);i={name:"cubic-bezier",controlPoints:a}}if(e.length-1<4)return t.error(`Expected at least 4 arguments, but found only ${e.length-1}.`);if((e.length-1)%2!=0)return t.error("Expected an even number of arguments.");if(!(n=t.parse(n,2,f)))return null;var s=[];let l=null;"interpolate-hcl"===r||"interpolate-lab"===r?l=Ne:t.expectedType&&"value"!==t.expectedType.kind&&(l=t.expectedType);for(let e=0;e<o.length;e+=2){var c=o[e],u=o[e+1],h=e+3,d=e+4;if("number"!=typeof c)return t.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.',h);if(s.length&&s[s.length-1][0]>=c)return t.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.',h);h=t.parse(u,d,l);if(!h)return null;l=l||h.type,s.push([c,h])}return We(l,f)||We(l,Ne)||We(l,qe)||We(l,He)||We(l,m(f))?new dr(l,r,i,n,s):t.error(`Type ${g(l)} is not interpolatable.`)}evaluate(e){var t=this.labels,r=this.outputs;if(1===t.length)return r[0].evaluate(e);var i=this.input.evaluate(e);if(i<=t[0])return r[0].evaluate(e);var n=t.length;if(i>=t[n-1])return r[n-1].evaluate(e);var n=nr(t,i),o=t[n],t=t[n+1],a=dr.interpolationFactor(this.interpolation,i,o,t),s=r[n].evaluate(e),l=r[n+1].evaluate(e);switch(this.operator){case"interpolate":return k[this.type.kind](s,l,a);case"interpolate-hcl":return k.color(s,l,a,"hcl");case"interpolate-lab":return k.color(s,l,a,"lab")}}eachChild(e){e(this.input);for(const t of this.outputs)e(t)}outputDefined(){return this.outputs.every(e=>e.outputDefined())}}function pr(e,t,r,i){i-=r,e-=r;return 0==i?0:1===t?e/i:(Math.pow(t,e)-1)/(Math.pow(t,i)-1)}class fr{constructor(e,t){this.type=e,this.args=t}static parse(e,t){if(e.length<2)return t.error("Expectected at least one argument.");let r=null;const i=t.expectedType;i&&"value"!==i.kind&&(r=i);var n=[];for(const a of e.slice(1)){var o=t.parse(a,1+n.length,r,void 0,{typeAnnotation:"omit"});if(!o)return null;r=r||o.type,n.push(o)}if(r)return i&&n.some(e=>Ge(i,e.type))?new fr(h,n):new fr(r,n);throw new Error("No output type")}evaluate(e){let t=null,r=0,i;for(const n of this.args)if(r++,null!==(t=(t=n.evaluate(e))&&t instanceof Ct&&!t.available&&(i=i||t.name,t=null,r===this.args.length)?i:t))break;return t}eachChild(e){this.args.forEach(e)}outputDefined(){return this.args.every(e=>e.outputDefined())}}class mr{constructor(e,t){this.type=t.type,this.bindings=[].concat(e),this.result=t}evaluate(e){return this.result.evaluate(e)}eachChild(e){for(const t of this.bindings)e(t[1]);e(this.result)}static parse(t,r){if(t.length<4)return r.error(`Expected at least 3 arguments, but found ${t.length-1} instead.`);var i=[];for(let e=1;e<t.length-1;e+=2){var n=t[e];if("string"!=typeof n)return r.error(`Expected string, but found ${typeof n} instead.`,e);if(/[^a-zA-Z0-9_]/.test(n))return r.error("Variable names must contain only alphanumeric characters or '_'.",e);var o=r.parse(t[e+1],e+1);if(!o)return null;i.push([n,o])}var e=r.parse(t[t.length-1],t.length-1,r.expectedType,i);return e?new mr(i,e):null}outputDefined(){return this.result.outputDefined()}}function gr(e,t){return"=="===e||"!="===e?"boolean"===t.kind||"string"===t.kind||"number"===t.kind||"null"===t.kind||"value"===t.kind:"string"===t.kind||"number"===t.kind||"value"===t.kind}function yr(e,t,r,i){return 0===i.compare(t,r)}function vr(o,a,s){const l="=="!==o&&"!="!==o;return class c{constructor(e,t,r){this.type=u,this.lhs=e,this.rhs=t,this.collator=r,this.hasUntypedArgument="value"===e.type.kind||"value"===t.type.kind}static parse(e,t){if(3!==e.length&&4!==e.length)return t.error("Expected two or three arguments.");var r=e[0];let i=t.parse(e[1],1,h);if(!i)return null;if(!gr(r,i.type))return t.concat(1).error(`"${r}" comparisons are not supported for type '${g(i.type)}'.`);let n=t.parse(e[2],2,h);if(!n)return null;if(!gr(r,n.type))return t.concat(2).error(`"${r}" comparisons are not supported for type '${g(n.type)}'.`);if(i.type.kind!==n.type.kind&&"value"!==i.type.kind&&"value"!==n.type.kind)return t.error(`Cannot compare types '${g(i.type)}' and '${g(n.type)}'.`);l&&("value"===i.type.kind&&"value"!==n.type.kind?i=new kt(n.type,[i]):"value"!==i.type.kind&&"value"===n.type.kind&&(n=new kt(i.type,[n])));let o=null;if(4===e.length){if("string"!==i.type.kind&&"string"!==n.type.kind&&"value"!==i.type.kind&&"value"!==n.type.kind)return t.error("Cannot use collator to compare non-string types.");if(!(o=t.parse(e[3],3,Fe)))return null}return new c(i,n,o)}evaluate(e){var t=this.lhs.evaluate(e),r=this.rhs.evaluate(e);if(l&&this.hasUntypedArgument){var i=d(t),n=d(r);if(i.kind!==n.kind||"string"!==i.kind&&"number"!==i.kind)throw new y(`Expected arguments for "${o}" to be (string, string) or (number, number), but found (${i.kind}, ${n.kind}) instead.`)}if(this.collator&&!l&&this.hasUntypedArgument){i=d(t),n=d(r);if("string"!==i.kind||"string"!==n.kind)return a(e,t,r)}return this.collator?s(e,t,r,this.collator.evaluate(e)):a(e,t,r)}eachChild(e){e(this.lhs),e(this.rhs),this.collator&&e(this.collator)}outputDefined(){return!0}}}var sr=vr("==",function(e,t,r){return t===r},yr),e=vr("!=",function(e,t,r){return t!==r},function(e,t,r,i){return!yr(0,t,r,i)}),_r=vr("<",function(e,t,r){return t<r},function(e,t,r,i){return i.compare(t,r)<0}),br=vr(">",function(e,t,r){return r<t},function(e,t,r,i){return 0<i.compare(t,r)}),t=vr("<=",function(e,t,r){return t<=r},function(e,t,r,i){return i.compare(t,r)<=0});class wr{constructor(e){this.type=Ue,this.sections=e}static parse(t,i){if(t.length<2)return i.error("Expected at least one argument.");var e=t[1];if(!Array.isArray(e)&&"object"==typeof e)return i.error("First argument must be an image or text section.");var n=[];let o=!1;for(let e=1;e<=t.length-1;++e){var a=t[e];if(o&&"object"==typeof a&&!Array.isArray(a)){o=!1;let e=null;if(a["font-scale"]&&!(e=i.parse(a["font-scale"],1,f)))return null;let t=null;if(a["text-font"]&&!(t=i.parse(a["text-font"],1,m(s))))return null;let r=null;if(a["text-color"]&&!(r=i.parse(a["text-color"],1,Ne)))return null;a=n[n.length-1];a.scale=e,a.font=t,a.textColor=r}else{a=i.parse(t[e],1,h);if(!a)return null;var r=a.type.kind;if("string"!==r&&"value"!==r&&"null"!==r&&"resolvedImage"!==r)return i.error("Formatted text type must be 'string', 'value', 'image' or 'null'.");o=!0,n.push({content:a,scale:null,font:null,textColor:null})}}return new wr(n)}evaluate(r){return new _t(this.sections.map(e=>{var t=e.content.evaluate(r);return d(t)===je?new vt("",t,null,null,null):new vt(Et(t),null,e.scale?e.scale.evaluate(r):null,e.font?e.font.evaluate(r).join(","):null,e.textColor?e.textColor.evaluate(r):null)}))}eachChild(e){for(const t of this.sections)e(t.content),t.scale&&e(t.scale),t.font&&e(t.font),t.textColor&&e(t.textColor)}outputDefined(){return!1}}const xr={"==":sr,"!=":e,">":br,"<":_r,">=":vr(">=",function(e,t,r){return r<=t},function(e,t,r,i){return 0<=i.compare(t,r)}),"<=":t,array:kt,at:class tu{constructor(e,t,r){this.type=e,this.index=t,this.input=r}static parse(e,t){var r;return 3!==e.length?t.error(`Expected 2 arguments, but found ${e.length-1} instead.`):(r=t.parse(e[1],1,f),e=t.parse(e[2],2,m(t.expectedType||h)),r&&e?(t=e.type,new tu(t.itemType,r,e)):null)}evaluate(e){var t=this.index.evaluate(e),e=this.input.evaluate(e);if(t<0)throw new y(`Array index out of bounds: ${t} < 0.`);if(t>=e.length)throw new y(`Array index out of bounds: ${t} > ${e.length-1}.`);if(t!==Math.floor(t))throw new y(`Array index must be an integer, but found ${t} instead.`);return e[t]}eachChild(e){e(this.index),e(this.input)}outputDefined(){return!1}},boolean:kt,case:class ru{constructor(e,t,r){this.type=e,this.branches=t,this.otherwise=r}static parse(t,r){if(t.length<4)return r.error(`Expected at least 3 arguments, but found only ${t.length-1}.`);if(t.length%2!=0)return r.error("Expected an odd number of arguments.");let i;r.expectedType&&"value"!==r.expectedType.kind&&(i=r.expectedType);var n=[];for(let e=1;e<t.length-1;e+=2){var o=r.parse(t[e],e,u);if(!o)return null;var a=r.parse(t[e+1],e+1,i);if(!a)return null;n.push([o,a]),i=i||a.type}var e=r.parse(t[t.length-1],t.length-1,i);if(!e)return null;if(i)return new ru(i,n,e);throw new Error("Can't infer output type")}evaluate(e){for(var[t,r]of this.branches)if(t.evaluate(e))return r.evaluate(e);return this.otherwise.evaluate(e)}eachChild(e){for(var[t,r]of this.branches)e(t),e(r);e(this.otherwise)}outputDefined(){return this.branches.every(([,e])=>e.outputDefined())&&this.otherwise.outputDefined()}},coalesce:fr,collator:Dt,format:wr,image:class iu{constructor(e){this.type=je,this.input=e}static parse(e,t){return 2!==e.length?t.error("Expected two arguments."):(e=t.parse(e[1],1,s))?new iu(e):t.error("No image name provided.")}evaluate(e){var t=this.input.evaluate(e),r=Ct.fromString(t);return r&&e.availableImages&&(r.available=-1<e.availableImages.indexOf(t)),r}eachChild(e){e(this.input)}outputDefined(){return!1}},in:class nu{constructor(e,t){this.type=u,this.needle=e,this.haystack=t}static parse(e,t){var r;return 3!==e.length?t.error(`Expected 2 arguments, but found ${e.length-1} instead.`):(r=t.parse(e[1],1,h),e=t.parse(e[2],2,h),r&&e?Ke(r.type,[u,s,f,ze,h])?new nu(r,e):t.error(`Expected first argument to be of type boolean, string, number or null, but found ${g(r.type)} instead`):null)}evaluate(e){var t=this.needle.evaluate(e);if(!(e=this.haystack.evaluate(e)))return!1;if(!Ze(t,["boolean","string","number","null"]))throw new y(`Expected first argument to be of type boolean, string, number or null, but found ${g(d(t))} instead.`);if(Ze(e,["string","array"]))return 0<=e.indexOf(t);throw new y(`Expected second argument to be of type array or string, but found ${g(d(e))} instead.`)}eachChild(e){e(this.needle),e(this.haystack)}outputDefined(){return!0}},"index-of":class ou{constructor(e,t,r){this.type=f,this.needle=e,this.haystack=t,this.fromIndex=r}static parse(e,t){var r,i;return e.length<=2||5<=e.length?t.error(`Expected 3 or 4 arguments, but found ${e.length-1} instead.`):(r=t.parse(e[1],1,h),i=t.parse(e[2],2,h),r&&i?Ke(r.type,[u,s,f,ze,h])?4===e.length?(e=t.parse(e[3],3,f))?new ou(r,i,e):null:new ou(r,i):t.error(`Expected first argument to be of type boolean, string, number or null, but found ${g(r.type)} instead`):null)}evaluate(e){var t=this.needle.evaluate(e),r=this.haystack.evaluate(e);if(!Ze(t,["boolean","string","number","null"]))throw new y(`Expected first argument to be of type boolean, string, number or null, but found ${g(d(t))} instead.`);if(Ze(r,["string","array"]))return this.fromIndex?(e=this.fromIndex.evaluate(e),r.indexOf(t,e)):r.indexOf(t);throw new y(`Expected second argument to be of type array or string, but found ${g(d(r))} instead.`)}eachChild(e){e(this.needle),e(this.haystack),this.fromIndex&&e(this.fromIndex)}outputDefined(){return!1}},interpolate:dr,"interpolate-hcl":dr,"interpolate-lab":dr,length:class au{constructor(e){this.type=f,this.input=e}static parse(e,t){return 2!==e.length?t.error(`Expected 1 argument, but found ${e.length-1} instead.`):(e=t.parse(e[1],1))?"array"!==e.type.kind&&"string"!==e.type.kind&&"value"!==e.type.kind?t.error(`Expected argument of type string or array, but found ${g(e.type)} instead.`):new au(e):null}evaluate(e){if("string"==typeof(e=this.input.evaluate(e)))return e.length;if(Array.isArray(e))return e.length;throw new y(`Expected value to be of type string or array, but found ${g(d(e))} instead.`)}eachChild(e){e(this.input)}outputDefined(){return!1}},let:mr,literal:It,match:class su{constructor(e,t,r,i,n,o){this.inputType=e,this.type=t,this.input=r,this.cases=i,this.outputs=n,this.otherwise=o}static parse(r,i){if(r.length<5)return i.error(`Expected at least 4 arguments, but found only ${r.length-1}.`);if(r.length%2!=1)return i.error("Expected an even number of arguments.");let n,o;i.expectedType&&"value"!==i.expectedType.kind&&(o=i.expectedType);var a={},s=[];for(let t=2;t<r.length-1;t+=2){let e=r[t];var l=r[t+1],c=(Array.isArray(e)||(e=[e]),i.concat(t));if(0===e.length)return c.error("Expected at least one branch label.");for(const u of e){if("number"!=typeof u&&"string"!=typeof u)return c.error("Branch labels must be numbers or strings.");if("number"==typeof u&&Math.abs(u)>Number.MAX_SAFE_INTEGER)return c.error(`Branch labels must be integers no larger than ${Number.MAX_SAFE_INTEGER}.`);if("number"==typeof u&&Math.floor(u)!==u)return c.error("Numeric branch labels must be integer values.");if(n){if(c.checkSubtype(n,d(u)))return null}else n=d(u);if(void 0!==a[String(u)])return c.error("Branch labels must be unique.");a[String(u)]=s.length}if(!(l=i.parse(l,t,o)))return null;o=o||l.type,s.push(l)}var e,t=i.parse(r[1],1,h);return!t||!(e=i.parse(r[r.length-1],r.length-1,o))||"value"!==t.type.kind&&i.concat(1).checkSubtype(n,t.type)?null:new su(n,o,t,a,s,e)}evaluate(e){var t=this.input.evaluate(e);return(d(t)===this.inputType&&this.outputs[this.cases[t]]||this.otherwise).evaluate(e)}eachChild(e){e(this.input),this.outputs.forEach(e),e(this.otherwise)}outputDefined(){return this.outputs.every(e=>e.outputDefined())&&this.otherwise.outputDefined()}},number:kt,"number-format":class lu{constructor(e,t,r,i,n){this.type=s,this.number=e,this.locale=t,this.currency=r,this.minFractionDigits=i,this.maxFractionDigits=n}static parse(e,t){if(3!==e.length)return t.error("Expected two arguments.");var r=t.parse(e[1],1,f);if(!r)return null;if("object"!=typeof(e=e[2])||Array.isArray(e))return t.error("NumberFormat options argument must be an object.");let i=null;if(e.locale&&!(i=t.parse(e.locale,1,s)))return null;let n=null;if(e.currency&&!(n=t.parse(e.currency,1,s)))return null;let o=null;if(e["min-fraction-digits"]&&!(o=t.parse(e["min-fraction-digits"],1,f)))return null;let a=null;return e["max-fraction-digits"]&&!(a=t.parse(e["max-fraction-digits"],1,f))?null:new lu(r,i,n,o,a)}evaluate(e){return new Intl.NumberFormat(this.locale?this.locale.evaluate(e):[],{style:this.currency?"currency":"decimal",currency:this.currency?this.currency.evaluate(e):void 0,minimumFractionDigits:this.minFractionDigits?this.minFractionDigits.evaluate(e):void 0,maximumFractionDigits:this.maxFractionDigits?this.maxFractionDigits.evaluate(e):void 0}).format(this.number.evaluate(e))}eachChild(e){e(this.number),this.locale&&e(this.locale),this.currency&&e(this.currency),this.minFractionDigits&&e(this.minFractionDigits),this.maxFractionDigits&&e(this.maxFractionDigits)}outputDefined(){return!1}},object:kt,slice:class cu{constructor(e,t,r,i){this.type=e,this.input=t,this.beginIndex=r,this.endIndex=i}static parse(e,t){var r,i;return e.length<=2||5<=e.length?t.error(`Expected 3 or 4 arguments, but found ${e.length-1} instead.`):(r=t.parse(e[1],1,h),i=t.parse(e[2],2,f),r&&i?Ke(r.type,[m(h),s,h])?4===e.length?(e=t.parse(e[3],3,f))?new cu(r.type,r,i,e):null:new cu(r.type,r,i):t.error(`Expected first argument to be of type array or string, but found ${g(r.type)} instead`):null)}evaluate(e){var t=this.input.evaluate(e),r=this.beginIndex.evaluate(e);if(Ze(t,["string","array"]))return this.endIndex?(e=this.endIndex.evaluate(e),t.slice(r,e)):t.slice(r);throw new y(`Expected first argument to be of type array or string, but found ${g(d(t))} instead.`)}eachChild(e){e(this.input),e(this.beginIndex),this.endIndex&&e(this.endIndex)}outputDefined(){return!1}},step:or,string:kt,"to-boolean":Mt,"to-color":Mt,"to-number":Mt,"to-string":Mt,var:Jt,within:Xt};function Cr(e,[t,r,i,n]){t=t.evaluate(e),r=r.evaluate(e),i=i.evaluate(e);n=n?n.evaluate(e):1,e=Tt(t,r,i,n);if(e)throw new y(e);return new _(t/255,r/255,i/255,n,!1)}function Tr(e,t){t=t[e];return void 0===t?null:t}function Sr(e){return{type:e}}function Er(e){return{result:"success",value:e}}function Ir(e){return{result:"error",value:e}}function Ar(e){return"data-driven"===e["property-type"]||"cross-faded-data-driven"===e["property-type"]}function kr(e){return e.expression&&-1<e.expression.parameters.indexOf("zoom")}function Pr(e){return e.expression&&e.expression.interpolated}function b(e){return e instanceof Number?"number":e instanceof String?"string":e instanceof Boolean?"boolean":Array.isArray(e)?"array":null===e?"null":typeof e}function Mr(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)}function Rr(e){return e}function Or(e,t,r){return void 0!==e?e:void 0!==t?t:void 0!==r?r:void 0}function Lr(e,t,r,i,n){return Or(typeof r===n?i[r]:void 0,e.default,t.default)}function Dr(e,t,r){return"number"!==b(r)?Or(e.default,t.default):(1===(t=e.stops.length)||r<=e.stops[0][0]?e.stops[0]:r>=e.stops[t-1][0]?e.stops[t-1]:(t=nr(e.stops.map(e=>e[0]),r),e.stops[t]))[1]}function zr(r,e,t){var i=void 0!==r.base?r.base:1;if("number"!==b(t))return Or(r.default,e.default);var n=r.stops.length;if(1===n)return r.stops[0][1];if(t<=r.stops[0][0])return r.stops[0][1];if(t>=r.stops[n-1][0])return r.stops[n-1][1];n=nr(r.stops.map(e=>e[0]),t);const o=function(e,t,r,i){i-=r,e-=r;return 0==i?0:1===t?e/i:(Math.pow(t,e)-1)/(Math.pow(t,i)-1)}(t,i,r.stops[n][0],r.stops[n+1][0]),a=r.stops[n][1],s=r.stops[n+1][1],l=k[e.type]||Rr;return"function"==typeof a.evaluate?{evaluate(...e){var t=a.evaluate.apply(void 0,e),e=s.evaluate.apply(void 0,e);if(void 0!==t&&void 0!==e)return l(t,e,o,r.colorSpace)}}:l(a,s,o,r.colorSpace)}function Nr(e,t,r){switch(t.type){case"color":r=_.parse(r);break;case"formatted":r=_t.fromString(r.toString());break;case"resolvedImage":r=Ct.fromString(r.toString());break;case"padding":r=bt.parse(r);break;default:b(r)===t.type||"enum"===t.type&&t.values[r]||(r=void 0)}return Or(r,e.default,t.default)}Qt.register(xr,{error:[{kind:"error"},[s],(e,[t])=>{throw new y(t.evaluate(e))}],typeof:[s,[h],(e,[t])=>g(d(t.evaluate(e)))],"to-rgba":[m(f,4),[Ne],(e,[t])=>{var[t,e,r,i]=t.evaluate(e).rgb;return[255*t,255*e,255*r,i]}],rgb:[Ne,[f,f,f],Cr],rgba:[Ne,[f,f,f,f],Cr],has:{type:u,overloads:[[[s],(e,[t])=>t.evaluate(e)in e.properties()],[[s,Be],(e,[t,r])=>t.evaluate(e)in r.evaluate(e)]]},get:{type:h,overloads:[[[s],(e,[t])=>Tr(t.evaluate(e),e.properties())],[[s,Be],(e,[t,r])=>Tr(t.evaluate(e),r.evaluate(e))]]},"feature-state":[h,[s],(e,[t])=>Tr(t.evaluate(e),e.featureState||{})],properties:[Be,[],e=>e.properties()],"geometry-type":[s,[],e=>e.geometryType()],id:[h,[],e=>e.id()],zoom:[f,[],e=>e.globals.zoom],"heatmap-density":[f,[],e=>e.globals.heatmapDensity||0],"line-progress":[f,[],e=>e.globals.lineProgress||0],accumulated:[h,[],e=>void 0===e.globals.accumulated?null:e.globals.accumulated],"+":[f,Sr(f),(e,t)=>{let r=0;for(const i of t)r+=i.evaluate(e);return r}],"*":[f,Sr(f),(e,t)=>{let r=1;for(const i of t)r*=i.evaluate(e);return r}],"-":{type:f,overloads:[[[f,f],(e,[t,r])=>t.evaluate(e)-r.evaluate(e)],[[f],(e,[t])=>-t.evaluate(e)]]},"/":[f,[f,f],(e,[t,r])=>t.evaluate(e)/r.evaluate(e)],"%":[f,[f,f],(e,[t,r])=>t.evaluate(e)%r.evaluate(e)],ln2:[f,[],()=>Math.LN2],pi:[f,[],()=>Math.PI],e:[f,[],()=>Math.E],"^":[f,[f,f],(e,[t,r])=>Math.pow(t.evaluate(e),r.evaluate(e))],sqrt:[f,[f],(e,[t])=>Math.sqrt(t.evaluate(e))],log10:[f,[f],(e,[t])=>Math.log(t.evaluate(e))/Math.LN10],ln:[f,[f],(e,[t])=>Math.log(t.evaluate(e))],log2:[f,[f],(e,[t])=>Math.log(t.evaluate(e))/Math.LN2],sin:[f,[f],(e,[t])=>Math.sin(t.evaluate(e))],cos:[f,[f],(e,[t])=>Math.cos(t.evaluate(e))],tan:[f,[f],(e,[t])=>Math.tan(t.evaluate(e))],asin:[f,[f],(e,[t])=>Math.asin(t.evaluate(e))],acos:[f,[f],(e,[t])=>Math.acos(t.evaluate(e))],atan:[f,[f],(e,[t])=>Math.atan(t.evaluate(e))],min:[f,Sr(f),(t,e)=>Math.min(...e.map(e=>e.evaluate(t)))],max:[f,Sr(f),(t,e)=>Math.max(...e.map(e=>e.evaluate(t)))],abs:[f,[f],(e,[t])=>Math.abs(t.evaluate(e))],round:[f,[f],(e,[t])=>{t=t.evaluate(e);return t<0?-Math.round(-t):Math.round(t)}],floor:[f,[f],(e,[t])=>Math.floor(t.evaluate(e))],ceil:[f,[f],(e,[t])=>Math.ceil(t.evaluate(e))],"filter-==":[u,[s,h],(e,[t,r])=>e.properties()[t.value]===r.value],"filter-id-==":[u,[h],(e,[t])=>e.id()===t.value],"filter-type-==":[u,[s],(e,[t])=>e.geometryType()===t.value],"filter-<":[u,[s,h],(e,[t,r])=>{e=e.properties()[t.value],t=r.value;return typeof e==typeof t&&e<t}],"filter-id-<":[u,[h],(e,[t])=>{e=e.id(),t=t.value;return typeof e==typeof t&&e<t}],"filter->":[u,[s,h],(e,[t,r])=>{e=e.properties()[t.value],t=r.value;return typeof e==typeof t&&t<e}],"filter-id->":[u,[h],(e,[t])=>{e=e.id(),t=t.value;return typeof e==typeof t&&t<e}],"filter-<=":[u,[s,h],(e,[t,r])=>{e=e.properties()[t.value],t=r.value;return typeof e==typeof t&&e<=t}],"filter-id-<=":[u,[h],(e,[t])=>{e=e.id(),t=t.value;return typeof e==typeof t&&e<=t}],"filter->=":[u,[s,h],(e,[t,r])=>{e=e.properties()[t.value],t=r.value;return typeof e==typeof t&&t<=e}],"filter-id->=":[u,[h],(e,[t])=>{e=e.id(),t=t.value;return typeof e==typeof t&&t<=e}],"filter-has":[u,[h],(e,[t])=>t.value in e.properties()],"filter-has-id":[u,[],e=>null!==e.id()&&void 0!==e.id()],"filter-type-in":[u,[m(s)],(e,[t])=>0<=t.value.indexOf(e.geometryType())],"filter-id-in":[u,[m(h)],(e,[t])=>0<=t.value.indexOf(e.id())],"filter-in-small":[u,[s,m(h)],(e,[t,r])=>0<=r.value.indexOf(e.properties()[t.value])],"filter-in-large":[u,[s,m(h)],(e,[t,r])=>{for(var i=e.properties()[t.value],n=r.value,o=0,a=r.value.length-1;o<=a;){var s=o+a>>1;if(n[s]===i)return!0;n[s]>i?a=s-1:o=1+s}return!1}],all:{type:u,overloads:[[[u,u],(e,[t,r])=>t.evaluate(e)&&r.evaluate(e)],[Sr(u),(e,t)=>{for(const r of t)if(!r.evaluate(e))return!1;return!0}]]},any:{type:u,overloads:[[[u,u],(e,[t,r])=>t.evaluate(e)||r.evaluate(e)],[Sr(u),(e,t)=>{for(const r of t)if(r.evaluate(e))return!0;return!1}]]},"!":[u,[u],(e,[t])=>!t.evaluate(e)],"is-supported-script":[u,[s],(e,[t])=>{var r=e.globals&&e.globals.isSupportedScript;return!r||r(t.evaluate(e))}],upcase:[s,[s],(e,[t])=>t.evaluate(e).toUpperCase()],downcase:[s,[s],(e,[t])=>t.evaluate(e).toLowerCase()],concat:[s,Sr(h),(t,e)=>e.map(e=>Et(e.evaluate(t))).join("")],"resolved-locale":[s,[Fe],(e,[t])=>t.evaluate(e).resolvedLocale()]});class Br{constructor(e,t){this.expression=e,this._warningHistory={},this._evaluator=new Ot,this._defaultValue=t?"color"===(e=t).type&&Mr(e.default)?new _(0,0,0,0):"color"===e.type?_.parse(e.default)||null:"padding"===e.type?bt.parse(e.default)||null:"variableAnchorOffsetCollection"===e.type?xt.parse(e.default)||null:void 0===e.default?null:e.default:null,this._enumValues=t&&"enum"===t.type?t.values:null}evaluateWithoutErrorHandling(e,t,r,i,n,o){return this._evaluator.globals=e,this._evaluator.feature=t,this._evaluator.featureState=r,this._evaluator.canonical=i,this._evaluator.availableImages=n||null,this._evaluator.formattedSection=o,this.expression.evaluate(this._evaluator)}evaluate(e,t,r,i,n,o){this._evaluator.globals=e,this._evaluator.feature=t||null,this._evaluator.featureState=r||null,this._evaluator.canonical=i,this._evaluator.availableImages=n||null,this._evaluator.formattedSection=o||null;try{var a=this.expression.evaluate(this._evaluator);if(null==a||"number"==typeof a&&a!=a)return this._defaultValue;if(!this._enumValues||a in this._enumValues)return a;throw new y(`Expected value to be one of ${Object.keys(this._enumValues).map(e=>JSON.stringify(e)).join(", ")}, but found ${JSON.stringify(a)} instead.`)}catch(e){return this._warningHistory[e.message]||(this._warningHistory[e.message]=!0,"undefined"!=typeof console&&console.warn(e.message)),this._defaultValue}}}function Fr(e){return Array.isArray(e)&&0<e.length&&"string"==typeof e[0]&&e[0]in xr}function Ur(e,t){var r=new Lt(xr,er,[],t?(i=t,r={color:Ne,string:s,number:f,enum:s,boolean:u,formatted:Ue,padding:qe,resolvedImage:je,variableAnchorOffsetCollection:He},"array"!==i.type?r[i.type]:m(r[i.value]||h,i.length)):void 0),i=r.parse(e,void 0,void 0,void 0,t&&"string"===t.type?{typeAnnotation:"coerce"}:void 0);return i?Er(new Br(i,t)):Ir(r.errors)}class qr{constructor(e,t){this.kind=e,this._styleExpression=t,this.isStateDependent="constant"!==e&&!rr(t.expression)}evaluateWithoutErrorHandling(e,t,r,i,n,o){return this._styleExpression.evaluateWithoutErrorHandling(e,t,r,i,n,o)}evaluate(e,t,r,i,n,o){return this._styleExpression.evaluate(e,t,r,i,n,o)}}class jr{constructor(e,t,r,i){this.kind=e,this.zoomStops=r,this._styleExpression=t,this.isStateDependent="camera"!==e&&!rr(t.expression),this.interpolationType=i}evaluateWithoutErrorHandling(e,t,r,i,n,o){return this._styleExpression.evaluateWithoutErrorHandling(e,t,r,i,n,o)}evaluate(e,t,r,i,n,o){return this._styleExpression.evaluate(e,t,r,i,n,o)}interpolationFactor(e,t,r){return this.interpolationType?dr.interpolationFactor(this.interpolationType,e,t,r):0}}function Hr(e,t){var r,i,n,e=Ur(e,t);return"error"===e.result?e:(r=tr(i=e.value.expression))||Ar(t)?(n=ir(i,["zoom"]))||kr(t)?(i=function r(e){let i=null;if(e instanceof mr)i=r(e.result);else if(e instanceof fr){for(const t of e.args)if(i=r(t))break}else(e instanceof or||e instanceof dr)&&e.input instanceof Qt&&"zoom"===e.input.name&&(i=e);if(i instanceof Le)return i;e.eachChild(e=>{const t=r(e);t instanceof Le?i=t:!i&&t?i=new Le("",'"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.'):i&&t&&i!==t&&(i=new Le("",'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.'))});return i}(i))||n?i instanceof Le?Ir([i]):i instanceof dr&&!Pr(t)?Ir([new Le("",'"interpolate" expressions cannot be used with this property')]):i?(n=i instanceof dr?i.interpolation:void 0,Er(r?new jr("camera",e.value,i.labels,n):new jr("composite",e.value,i.labels,n))):Er(r?new qr("constant",e.value):new qr("source",e.value)):Ir([new Le("",'"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.')]):Ir([new Le("","zoom expressions not supported")]):Ir([new Le("","data expressions not supported")])}class Vr{constructor(e,t){this._parameters=e,this._specification=t,Oe(this,function e(r,i){var t="color"===i.type,n=r.stops&&"object"==typeof r.stops[0][0],o=n||void 0!==r.property,o=n||!o,a=r.type||(Pr(i)?"exponential":"interval");if(t||"padding"===i.type){const f=(t?_:bt).parse;(r=Oe({},r)).stops&&(r.stops=r.stops.map(e=>[e[0],f(e[1])])),r.default?r.default=f(r.default):r.default=f(i.default)}if(r.colorSpace&&"rgb"!==(t=r.colorSpace)&&"hcl"!==t&&"lab"!==t)throw new Error(`Unknown color space: "${r.colorSpace}"`);let s,l,c;if("exponential"===a)s=zr;else if("interval"===a)s=Dr;else if("categorical"===a){s=Lr,l=Object.create(null);for(const m of r.stops)l[m[0]]=m[1];c=typeof r.stops[0][0]}else{if("identity"!==a)throw new Error(`Unknown function type "${a}"`);s=Nr}if(n){var u={},h=[];for(let e=0;e<r.stops.length;e++){var d=r.stops[e],p=d[0].zoom;void 0===u[p]&&(u[p]={zoom:p,type:r.type,property:r.property,default:r.default,stops:[]},h.push(p)),u[p].stops.push([d[0].value,d[1]])}const g=[];for(const y of h)g.push([u[y].zoom,e(u[y],i)]);return{kind:"composite",interpolationType:t={name:"linear"},interpolationFactor:dr.interpolationFactor.bind(void 0,t),zoomStops:g.map(e=>e[0]),evaluate({zoom:e},t){return zr({stops:g,base:r.base},i,e).evaluate(e,t)}}}return o?{kind:"camera",interpolationType:n="exponential"===a?{name:"exponential",base:void 0!==r.base?r.base:1}:null,interpolationFactor:dr.interpolationFactor.bind(void 0,n),zoomStops:r.stops.map(e=>e[0]),evaluate:({zoom:e})=>s(r,i,e,l,c)}:{kind:"source",evaluate(e,t){return void 0===(t=t&&t.properties?t.properties[r.property]:void 0)?Or(r.default,i.default):s(r,i,t,l,c)}}}(this._parameters,this._specification))}static deserialize(e){return new Vr(e._parameters,e._specification)}static serialize(e){return{_parameters:e._parameters,_specification:e._specification}}}function Gr(e){if(!0===e||!1===e)return 1;if(Array.isArray(e)&&0!==e.length)switch(e[0]){case"has":return 2<=e.length&&"$id"!==e[1]&&"$type"!==e[1];case"in":return 3<=e.length&&("string"!=typeof e[1]||Array.isArray(e[2]));case"!in":case"!has":case"none":return;case"==":case"!=":case">":case">=":case"<":case"<=":return 3!==e.length||Array.isArray(e[1])||Array.isArray(e[2]);case"any":case"all":for(const t of e.slice(1))if(!Gr(t)&&"boolean"!=typeof t)return;return 1;default:return 1}}const Kr={type:"boolean",default:!1,transition:!1,"property-type":"data-driven",expression:{interpolated:!1,parameters:["zoom","feature"]}};function Zr(e){if(null==e)return{filter:()=>!0,needGeometry:!1};const i=Ur(e=Gr(e)?e:Yr(e),Kr);if("error"===i.result)throw new Error(i.value.map(e=>e.key+": "+e.message).join(", "));return{filter:(e,t,r)=>i.value.evaluate(e,t,{},r),needGeometry:function t(r){if(!Array.isArray(r))return!1;if("within"===r[0])return!0;for(let e=1;e<r.length;e++)if(t(r[e]))return!0;return!1}(e)}}function Wr(e,t){return e<t?-1:t<e?1:0}function Yr(e){var t,r;return!e||(t=e[0],e.length<=1?"any"!==t:"=="===t?$r(e[1],e[2],"=="):"!="===t?Qr($r(e[1],e[2],"==")):"<"===t||">"===t||"<="===t||">="===t?$r(e[1],e[2],t):"any"===t?(r=e.slice(1),["any"].concat(r.map(Yr))):"all"===t?["all"].concat(e.slice(1).map(Yr)):"none"===t?["all"].concat(e.slice(1).map(Yr).map(Qr)):"in"===t?Xr(e[1],e.slice(2)):"!in"===t?Qr(Xr(e[1],e.slice(2))):"has"===t?Jr(e[1]):"!has"===t?Qr(Jr(e[1])):"within"!==t||e)}function $r(e,t,r){switch(e){case"$type":return["filter-type-"+r,t];case"$id":return["filter-id-"+r,t];default:return["filter-"+r,e,t]}}function Xr(e,t){if(0===t.length)return!1;switch(e){case"$type":return["filter-type-in",["literal",t]];case"$id":return["filter-id-in",["literal",t]];default:return 200<t.length&&!t.some(e=>typeof e!=typeof t[0])?["filter-in-large",e,["literal",t.sort(Wr)]]:["filter-in-small",e,["literal",t]]}}function Jr(e){switch(e){case"$type":return!0;case"$id":return["filter-has-id"];default:return["filter-has",e]}}function Qr(e){return["!",e]}function ei(e){let t="";for(const r of Se)t+="/"+function t(r){var e=typeof r;if("number"==e||"boolean"==e||"string"==e||null==r)return JSON.stringify(r);if(Array.isArray(r)){let e="[";for(const o of r)e+=t(o)+",";return e+"]"}var i=Object.keys(r).sort();let n="{";for(let e=0;e<i.length;e++)n+=`${JSON.stringify(i[e])}:${t(r[i[e]])},`;return n+"}"}(e[r]);return t}function ti(e){var t=e.key,e=e.value;return e?[new p(t,e,"constants have been deprecated as of v8")]:[]}function w(e){return e instanceof Number||e instanceof String||e instanceof Boolean?e.valueOf():e}function ri(e){if(Array.isArray(e))return e.map(ri);if(e instanceof Object&&!(e instanceof Number||e instanceof String||e instanceof Boolean)){var t={};for(const r in e)t[r]=ri(e[r]);return t}return w(e)}function ii(e){var t=e.key,r=e.value,i=e.valueSpec||{},n=e.objectElementValidators||{},o=e.style,a=e.styleSpec,s=e.validateSpec;let l=[];e=b(r);if("object"!==e)return[new p(t,r,`object expected, ${e} found`)];for(const h in r){var c=h.split(".")[0],u=i[c]||i["*"];let e;if(n[c])e=n[c];else if(i[c])e=s;else if(n["*"])e=n["*"];else{if(!i["*"]){l.push(new p(t,r[h],`unknown property "${h}"`));continue}e=s}l=l.concat(e({key:(t&&t+".")+h,value:r[h],valueSpec:u,style:o,styleSpec:a,object:r,objectKey:h,validateSpec:s},r))}for(const d in i)n[d]||i[d].required&&void 0===i[d].default&&void 0===r[d]&&l.push(new p(t,r,`missing required property "${d}"`));return l}function ni(t){var r=t.value,e=t.valueSpec,i=t.validateSpec,n=t.style,o=t.styleSpec,a=t.key,s=t.arrayElementValidator||i;if("array"!==b(r))return[new p(a,r,`array expected, ${b(r)} found`)];if(e.length&&r.length!==e.length)return[new p(a,r,`array length ${e.length} expected, length ${r.length} found`)];if(e["min-length"]&&r.length<e["min-length"])return[new p(a,r,`array length at least ${e["min-length"]} expected, length ${r.length} found`)];let l={type:e.value,values:e.values},c=(o.$version<7&&(l.function=e.function),"object"===b(e.value)&&(l=e.value),[]);for(let e=0;e<r.length;e++)c=c.concat(s({array:r,arrayIndex:e,value:r[e],valueSpec:l,validateSpec:t.validateSpec,style:n,styleSpec:o,key:`${a}[${e}]`}));return c}function oi(e){var t=e.key,r=e.value,e=e.valueSpec;let i=b(r);return"number"!==(i="number"===i&&r!=r?"NaN":i)?[new p(t,r,`number expected, ${i} found`)]:"minimum"in e&&r<e.minimum?[new p(t,r,r+" is less than the minimum value "+e.minimum)]:"maximum"in e&&r>e.maximum?[new p(t,r,r+" is greater than the maximum value "+e.maximum)]:[]}function ai(e){const n=e.valueSpec,o=w(e.value.type);let a,s={},l,c;var t="categorical"!==o&&void 0===e.value.property,r=!t;const u="array"===b(e.value.stops)&&"array"===b(e.value.stops[0])&&"object"===b(e.value.stops[0][0]);var i=ii({key:e.key,value:e.value,valueSpec:e.styleSpec.function,validateSpec:e.validateSpec,style:e.style,styleSpec:e.styleSpec,objectElementValidators:{stops:function(e){if("identity"===o)return[new p(e.key,e.value,'identity function may not have a "stops" property')];let t=[];var r=e.value;t=t.concat(ni({key:e.key,value:r,valueSpec:e.valueSpec,validateSpec:e.validateSpec,style:e.style,styleSpec:e.styleSpec,arrayElementValidator:h})),"array"===b(r)&&0===r.length&&t.push(new p(e.key,r,"array must have at least one stop"));return t},default:function(e){return e.validateSpec({key:e.key,value:e.value,valueSpec:n,validateSpec:e.validateSpec,style:e.style,styleSpec:e.styleSpec})}}});return"identity"===o&&t&&i.push(new p(e.key,e.value,'missing required property "property"')),"identity"===o||e.value.stops||i.push(new p(e.key,e.value,'missing required property "stops"')),"exponential"===o&&e.valueSpec.expression&&!Pr(e.valueSpec)&&i.push(new p(e.key,e.value,"exponential functions not supported")),8<=e.styleSpec.$version&&(r&&!Ar(e.valueSpec)?i.push(new p(e.key,e.value,"property functions not supported")):t&&!kr(e.valueSpec)&&i.push(new p(e.key,e.value,"zoom functions not supported"))),"categorical"!==o&&!u||void 0!==e.value.property||i.push(new p(e.key,e.value,'"property" property is required')),i;function h(e){let t=[];var r=e.value,i=e.key;if("array"!==b(r))return[new p(i,r,`array expected, ${b(r)} found`)];if(2!==r.length)return[new p(i,r,`array length 2 expected, length ${r.length} found`)];if(u){if("object"!==b(r[0]))return[new p(i,r,`object expected, ${b(r[0])} found`)];if(void 0===r[0].zoom)return[new p(i,r,"object stop key must have zoom")];if(void 0===r[0].value)return[new p(i,r,"object stop key must have value")];if(c&&c>w(r[0].zoom))return[new p(i,r[0].zoom,"stop zoom values must appear in ascending order")];w(r[0].zoom)!==c&&(c=w(r[0].zoom),l=void 0,s={}),t=t.concat(ii({key:i+"[0]",value:r[0],valueSpec:{zoom:{}},validateSpec:e.validateSpec,style:e.style,styleSpec:e.styleSpec,objectElementValidators:{zoom:oi,value:d}}))}else t=t.concat(d({key:i+"[0]",value:r[0],valueSpec:{},validateSpec:e.validateSpec,style:e.style,styleSpec:e.styleSpec},r));return Fr(ri(r[1]))?t.concat([new p(i+"[1]",r[1],"expressions are not allowed in function stops.")]):t.concat(e.validateSpec({key:i+"[1]",value:r[1],valueSpec:n,validateSpec:e.validateSpec,style:e.style,styleSpec:e.styleSpec}))}function d(t,r){var i=b(t.value),e=w(t.value),r=null!==t.value?t.value:r;if(a){if(i!==a)return[new p(t.key,r,i+" stop domain type must match previous stop domain type "+a)]}else a=i;if("number"!==i&&"string"!==i&&"boolean"!==i)return[new p(t.key,r,"stop domain value must be a number, string, or boolean")];if("number"===i||"categorical"===o)return"categorical"!==o||"number"!==i||isFinite(e)&&Math.floor(e)===e?"categorical"!==o&&"number"===i&&void 0!==l&&e<l?[new p(t.key,r,"stop domain values must appear in ascending order")]:(l=e,"categorical"===o&&e in s?[new p(t.key,r,"stop domain values must be unique")]:(s[e]=!0,[])):[new p(t.key,r,"integer expected, found "+e)];{let e=`number expected, ${i} found`;return Ar(n)&&void 0===o&&(e+='\nIf you intended to use a categorical function, specify `"type": "categorical"`.'),[new p(t.key,r,e)]}}}function si(t){var e=("property"===t.expressionContext?Hr:Ur)(ri(t.value),t.valueSpec);if("error"===e.result)return e.value.map(e=>new p(""+t.key+e.key,t.value,e.message));e=e.value.expression||e.value._styleExpression.expression;if("property"===t.expressionContext&&"text-font"===t.propertyKey&&!e.outputDefined())return[new p(t.key,t.value,`Invalid data expression for "${t.propertyKey}". Output values must be contained as literals within the expression.`)];if("property"===t.expressionContext&&"layout"===t.propertyType&&!rr(e))return[new p(t.key,t.value,'"feature-state" data expressions are not supported with layout properties.')];if("filter"===t.expressionContext&&!rr(e))return[new p(t.key,t.value,'"feature-state" data expressions are not supported with filters.')];if(t.expressionContext&&0===t.expressionContext.indexOf("cluster")){if(!ir(e,["zoom","feature-state"]))return[new p(t.key,t.value,'"zoom" and "feature-state" expressions are not supported with cluster properties.')];if("cluster-initial"===t.expressionContext&&!tr(e))return[new p(t.key,t.value,"Feature data expressions are not supported with initial expression part of cluster properties.")]}return[]}function li(e){var t=e.key,r=e.value,e=e.valueSpec,i=[];return Array.isArray(e.values)?-1===e.values.indexOf(w(r))&&i.push(new p(t,r,`expected one of [${e.values.join(", ")}], ${JSON.stringify(r)} found`)):-1===Object.keys(e.values).indexOf(w(r))&&i.push(new p(t,r,`expected one of [${Object.keys(e.values).join(", ")}], ${JSON.stringify(r)} found`)),i}function ci(e){return Gr(ri(e.value))?si(Oe({},e,{expressionContext:"filter",valueSpec:{value:"boolean"}})):function t(r){const i=r.value;const n=r.key;if("array"!==b(i))return[new p(n,i,`array expected, ${b(i)} found`)];const o=r.styleSpec;let a;let s=[];if(i.length<1)return[new p(n,i,"filter array must have at least 1 element")];s=s.concat(li({key:n+"[0]",value:i[0],valueSpec:o.filter_operator,style:r.style,styleSpec:r.styleSpec}));switch(w(i[0])){case"<":case"<=":case">":case">=":2<=i.length&&"$type"===w(i[1])&&s.push(new p(n,i,`"$type" cannot be use with operator "${i[0]}"`));case"==":case"!=":3!==i.length&&s.push(new p(n,i,`filter array for operator "${i[0]}" must have 3 elements`));case"in":case"!in":2<=i.length&&"string"!==(a=b(i[1]))&&s.push(new p(n+"[1]",i[1],`string expected, ${a} found`));for(let e=2;e<i.length;e++)a=b(i[e]),"$type"===w(i[1])?s=s.concat(li({key:`${n}[${e}]`,value:i[e],valueSpec:o.geometry_type,style:r.style,styleSpec:r.styleSpec})):"string"!==a&&"number"!==a&&"boolean"!==a&&s.push(new p(`${n}[${e}]`,i[e],`string, number, or boolean expected, ${a} found`));break;case"any":case"all":case"none":for(let e=1;e<i.length;e++)s=s.concat(t({key:`${n}[${e}]`,value:i[e],style:r.style,styleSpec:r.styleSpec}));break;case"has":case"!has":a=b(i[1]),2!==i.length?s.push(new p(n,i,`filter array for "${i[0]}" operator must have 2 elements`)):"string"!==a&&s.push(new p(n+"[1]",i[1],`string expected, ${a} found`));break;case"within":a=b(i[1]),2!==i.length?s.push(new p(n,i,`filter array for "${i[0]}" operator must have 2 elements`)):"object"!==a&&s.push(new p(n+"[1]",i[1],`object expected, ${a} found`))}return s}(e)}function ui(e,t){var r=e.key,i=e.validateSpec,n=e.style,o=e.styleSpec,a=e.value,s=e.objectKey,l=o[t+"_"+e.layerType];if(!l)return[];var c=s.match(/^(.*)-transition$/);if("paint"===t&&c&&l[c[1]]&&l[c[1]].transition)return i({key:r,value:a,valueSpec:o.transition,style:n,styleSpec:o});c=e.valueSpec||l[s];if(!c)return[new p(r,a,`unknown property "${s}"`)];let u;return"string"===b(a)&&Ar(c)&&!c.tokens&&(u=/^{([^}]+)}$/.exec(a))?[new p(r,a,`"${s}" does not support interpolation syntax
`+`Use an identity property function instead: \`{ "type": "identity", "property": ${JSON.stringify(u[1])} }\`.`)]:(l=[],"symbol"===e.layerType&&("text-field"===s&&n&&!n.glyphs&&l.push(new p(r,a,'use of "text-field" requires a style "glyphs" property')),"text-font"===s)&&Mr(ri(a))&&"identity"===w(a.type)&&l.push(new p(r,a,'"text-font" does not support identity functions')),l.concat(i({key:e.key,value:a,valueSpec:c,style:n,styleSpec:o,expressionContext:"property",propertyType:t,propertyKey:s})))}function hi(e){return ui(e,"paint")}function di(e){return ui(e,"layout")}function pi(t){let r=[];const i=t.value,n=t.key;var e,o,a=t.style;const s=t.styleSpec;i.type||i.ref||r.push(new p(n,i,'either "type" or "ref" is required'));let l=w(i.type);const c=w(i.ref);if(i.id){var u=w(i.id);for(let e=0;e<t.arrayIndex;e++){var h=a.layers[e];w(h.id)===u&&r.push(new p(n,i.id,`duplicate layer id "${i.id}", previously used at line `+h.id.__line__))}}if("ref"in i){["type","source","source-layer","filter","layout"].forEach(e=>{e in i&&r.push(new p(n,i[e],`"${e}" is prohibited for ref layers`))});let t;a.layers.forEach(e=>{w(e.id)===c&&(t=e)}),t?t.ref?r.push(new p(n,i.ref,"ref cannot reference another ref layer")):l=w(t.type):r.push(new p(n,i.ref,`ref layer "${c}" not found`))}else"background"!==l&&(i.source?(o=(e=a.sources&&a.sources[i.source])&&w(e.type),e?"vector"===o&&"raster"===l?r.push(new p(n,i.source,`layer "${i.id}" requires a raster source`)):"raster-dem"!==o&&"hillshade"===l?r.push(new p(n,i.source,`layer "${i.id}" requires a raster-dem source`)):"raster"===o&&"raster"!==l?r.push(new p(n,i.source,`layer "${i.id}" requires a vector source`)):"vector"!==o||i["source-layer"]?"raster-dem"===o&&"hillshade"!==l?r.push(new p(n,i.source,"raster-dem source can only be used with layer type 'hillshade'.")):"line"!==l||!i.paint||!i.paint["line-gradient"]||"geojson"===o&&e.lineMetrics||r.push(new p(n,i,`layer "${i.id}" specifies a line-gradient, which requires a GeoJSON source with \`lineMetrics\` enabled.`)):r.push(new p(n,i,`layer "${i.id}" must specify a "source-layer"`)):r.push(new p(n,i.source,`source "${i.source}" not found`))):r.push(new p(n,i,'missing required property "source"')));return r=r.concat(ii({key:n,value:i,valueSpec:s.layer,style:t.style,styleSpec:t.styleSpec,validateSpec:t.validateSpec,objectElementValidators:{"*"(){return[]},type(){return t.validateSpec({key:n+".type",value:i.type,valueSpec:s.layer.type,style:t.style,styleSpec:t.styleSpec,validateSpec:t.validateSpec,object:i,objectKey:"type"})},filter:ci,layout(e){return ii({layer:i,key:e.key,value:e.value,style:e.style,styleSpec:e.styleSpec,validateSpec:e.validateSpec,objectElementValidators:{"*"(e){return di(Oe({layerType:l},e))}}})},paint(e){return ii({layer:i,key:e.key,value:e.value,style:e.style,styleSpec:e.styleSpec,validateSpec:e.validateSpec,objectElementValidators:{"*"(e){return hi(Oe({layerType:l},e))}}})}}}))}function fi(e){var t=e.value,e=e.key,r=b(t);return"string"!==r?[new p(e,t,`string expected, ${r} found`)]:[]}const mi={promoteId:function({key:e,value:t}){{if("string"===b(t))return fi({key:e,value:t});var r=[];for(const i in t)r.push(...fi({key:e+"."+i,value:t[i]}));return r}}};function gi(e){var t=e.value,r=e.key,i=e.styleSpec,n=e.style,o=e.validateSpec;if(!t.type)return[new p(r,t,'"type" is required')];var a=w(t.type);let s;switch(a){case"vector":case"raster":return s=ii({key:r,value:t,valueSpec:i["source_"+a.replace("-","_")],style:e.style,styleSpec:i,objectElementValidators:mi,validateSpec:o});case"raster-dem":return s=function(e){var t=null!=(s=e.sourceName)?s:"",r=e.value,i=e.styleSpec,n=i.source_raster_dem,o=e.style;let a=[];var s=b(r);if(void 0!==r)if("object"!==s)a.push(new p("source_raster_dem",r,`object expected, ${s} found`));else{var l="custom"===w(r.encoding),c=["redFactor","greenFactor","blueFactor","baseShift"],u=e.value.encoding?`"${e.value.encoding}"`:"Default";for(const h in r)!l&&c.includes(h)?a.push(new p(h,r[h],`In "${t}": "${h}" is only valid when "encoding" is set to "custom". ${u} encoding found`)):n[h]?a=a.concat(e.validateSpec({key:h,value:r[h],valueSpec:n[h],validateSpec:e.validateSpec,style:o,styleSpec:i})):a.push(new p(h,r[h],`unknown property "${h}"`))}return a}({sourceName:r,value:t,style:e.style,styleSpec:i,validateSpec:o});case"geojson":if(s=ii({key:r,value:t,valueSpec:i.source_geojson,style:n,styleSpec:i,validateSpec:o,objectElementValidators:mi}),t.cluster)for(const u in t.clusterProperties){var[l,c]=t.clusterProperties[u],l="string"==typeof l?[l,["accumulated"],["get",u]]:l;s.push(...si({key:`${r}.${u}.map`,value:c,validateSpec:o,expressionContext:"cluster-map"})),s.push(...si({key:`${r}.${u}.reduce`,value:l,validateSpec:o,expressionContext:"cluster-reduce"}))}return s;case"video":return ii({key:r,value:t,valueSpec:i.source_video,style:n,validateSpec:o,styleSpec:i});case"image":return ii({key:r,value:t,valueSpec:i.source_image,style:n,validateSpec:o,styleSpec:i});case"canvas":return[new p(r,null,"Please use runtime APIs to add canvas sources, rather than including them in stylesheets.","source.canvas")];default:return li({key:r+".type",value:t.type,valueSpec:{values:["vector","raster","raster-dem","geojson","video","image"]},style:n,validateSpec:o,styleSpec:i})}}function yi(e){var t=e.value,r=e.styleSpec,i=r.light,n=e.style;let o=[];var a=b(t);if(void 0!==t){if("object"!==a)return o=o.concat([new p("light",t,`object expected, ${a} found`)]);for(const l in t){var s=l.match(/^(.*)-transition$/);o=s&&i[s[1]]&&i[s[1]].transition?o.concat(e.validateSpec({key:l,value:t[l],valueSpec:r.transition,validateSpec:e.validateSpec,style:n,styleSpec:r})):i[l]?o.concat(e.validateSpec({key:l,value:t[l],valueSpec:i[l],validateSpec:e.validateSpec,style:n,styleSpec:r})):o.concat([new p(l,t[l],`unknown property "${l}"`)])}}return o}function vi(e){var t=e.value,r=e.styleSpec,i=r.sky,n=e.style,e=b(t);if(void 0===t)return[];if("object"!==e)return[new p("sky",t,`object expected, ${e} found`)];let o=[];for(const a in t)o=i[a]?o.concat(xi({key:a,value:t[a],valueSpec:i[a],style:n,styleSpec:r})):o.concat([new p(a,t[a],`unknown property "${a}"`)]);return o}function _i(e){var t=e.value,r=e.styleSpec,i=r.terrain,n=e.style;let o=[];var a=b(t);if(void 0!==t){if("object"!==a)return o=o.concat([new p("terrain",t,`object expected, ${a} found`)]);for(const s in t)o=i[s]?o.concat(e.validateSpec({key:s,value:t[s],valueSpec:i[s],validateSpec:e.validateSpec,style:n,styleSpec:r})):o.concat([new p(s,t[s],`unknown property "${s}"`)])}return o}function bi(e){let t=[];var r=e.value,i=e.key;if(Array.isArray(r)){var n=[],o=[];for(const a in r)r[a].id&&n.includes(r[a].id)&&t.push(new p(i,r,`all the sprites' ids must be unique, but ${r[a].id} is duplicated`)),n.push(r[a].id),r[a].url&&o.includes(r[a].url)&&t.push(new p(i,r,`all the sprites' URLs must be unique, but ${r[a].url} is duplicated`)),o.push(r[a].url),t=t.concat(ii({key:`${i}[${a}]`,value:r[a],valueSpec:{id:{type:"string",required:!0},url:{type:"string",required:!0}},validateSpec:e.validateSpec}));return t}return fi({key:i,value:r})}const wi={"*"(){return[]},array:ni,boolean:function(e){var t=e.value,e=e.key,r=b(t);return"boolean"!==r?[new p(e,t,`boolean expected, ${r} found`)]:[]},number:oi,color:function(e){var t=e.key,r=b(e=e.value);return"string"!==r?[new p(t,e,`color expected, ${r} found`)]:_.parse(String(e))?[]:[new p(t,e,`color expected, "${e}" found`)]},constants:ti,enum:li,filter:ci,function:ai,layer:pi,object:ii,source:gi,light:yi,sky:vi,terrain:_i,string:fi,formatted:function(e){return 0===fi(e).length?[]:si(e)},resolvedImage:function(e){return 0===fi(e).length?[]:si(e)},padding:function(r){var i=r.key,n=r.value;if("array"!==b(n))return oi({key:i,value:n,valueSpec:{}});{if(n.length<1||4<n.length)return[new p(i,n,`padding requires 1 to 4 values; ${n.length} values found`)];var o={type:"number"};let t=[];for(let e=0;e<n.length;e++)t=t.concat(r.validateSpec({key:`${i}[${e}]`,value:n[e],validateSpec:r.validateSpec,valueSpec:o}));return t}},variableAnchorOffsetCollection:function(t){var r=t.key,i=t.value,e=b(i),n=t.styleSpec;if("array"!==e||i.length<1||i.length%2!=0)return[new p(r,i,"variableAnchorOffsetCollection requires a non-empty array of even length")];let o=[];for(let e=0;e<i.length;e+=2)o=(o=o.concat(li({key:`${r}[${e}]`,value:i[e],valueSpec:n.layout_symbol["text-anchor"]}))).concat(ni({key:`${r}[${e+1}]`,value:i[e+1],valueSpec:{length:2,value:"number"},validateSpec:t.validateSpec,style:t.style,styleSpec:n}));return o},sprite:bi};function xi(e){var t=e.value,r=e.valueSpec,i=e.styleSpec;return e.validateSpec=xi,r.expression&&Mr(w(t))?ai(e):r.expression&&Fr(ri(t))?si(e):r.type&&wi[r.type]?wi[r.type](e):ii(Oe({},e,{valueSpec:r.type?i[r.type]:r}))}function Ci(e){var t=e.value,r=e.key,e=fi(e);return e.length||(-1===t.indexOf("{fontstack}")&&e.push(new p(r,t,'"glyphs" url must include a "{fontstack}" token')),-1===t.indexOf("{range}")&&e.push(new p(r,t,'"glyphs" url must include a "{range}" token'))),e}function Ti(e,t=o){let r=[];return r=r.concat(xi({key:"",value:e,valueSpec:t.$root,styleSpec:t,style:e,validateSpec:xi,objectElementValidators:{glyphs:Ci,"*"(){return[]}}})),Ei(r=e.constants?r.concat(ti({key:"constants",value:e.constants,style:e,styleSpec:t,validateSpec:xi})):r)}function Si(t){return function(e){return t({...e,validateSpec:xi})}}function Ei(e){return[].concat(e).sort((e,t)=>e.line-t.line)}function Ii(t){return function(...e){return Ei(t.apply(this,e))}}Ti.source=Ii(Si(gi)),Ti.sprite=Ii(Si(bi)),Ti.glyphs=Ii(Si(Ci)),Ti.light=Ii(Si(yi)),Ti.sky=Ii(Si(vi)),Ti.terrain=Ii(Si(_i)),Ti.layer=Ii(Si(pi)),Ti.filter=Ii(Si(ci)),Ti.paintProperty=Ii(Si(hi)),Ti.layoutProperty=Ii(Si(di));const Ai=Ti;Ai;sr=Ai.light;Ai,Ai;const ki=Ai.paintProperty,Pi=Ai.layoutProperty;function Mi(e,t){let r=!1;if(t&&t.length)for(const i of t)e.fire(new Ce(new Error(i.message))),r=!0;return r}class Ri{constructor(e,t,r){var i=this.cells=[];if(e instanceof ArrayBuffer){this.arrayBuffer=e;var n=new Int32Array(this.arrayBuffer);e=n[0],t=n[1],r=n[2],this.d=t+2*r;for(let e=0;e<this.d*this.d;e++){var o=n[3+e],a=n[3+e+1];i.push(o===a?null:n.subarray(o,a))}var s=n[3+i.length],l=n[3+i.length+1];this.keys=n.subarray(s,l),this.bboxes=n.subarray(l),this.insert=this._insertReadonly}else{this.d=t+2*r;for(let e=0;e<this.d*this.d;e++)i.push([]);this.keys=[],this.bboxes=[]}this.n=t,this.extent=e,this.padding=r,this.scale=t/e,this.uid=0;s=r/t*e;this.min=-s,this.max=e+s}insert(e,t,r,i,n){this._forEachCell(t,r,i,n,this._insertCell,this.uid++,void 0,void 0),this.keys.push(e),this.bboxes.push(t),this.bboxes.push(r),this.bboxes.push(i),this.bboxes.push(n)}_insertReadonly(){throw new Error("Cannot insert into a GridIndex created from an ArrayBuffer.")}_insertCell(e,t,r,i,n,o){this.cells[n].push(o)}query(e,t,r,i,n){var o=this.min,a=this.max;return e<=o&&t<=o&&a<=r&&a<=i&&!n?Array.prototype.slice.call(this.keys):(this._forEachCell(e,t,r,i,this._queryCell,o=[],{},n),o)}_queryCell(t,r,i,n,e,o,a,s){var l=this.cells[e];if(null!==l){var c=this.keys,u=this.bboxes;for(let e=0;e<l.length;e++){var h,d=l[e];void 0===a[d]&&(h=4*d,(s?s(u[0+h],u[1+h],u[2+h],u[3+h]):t<=u[2+h]&&r<=u[3+h]&&i>=u[0+h]&&n>=u[1+h])?(a[d]=!0,o.push(c[d])):a[d]=!1)}}}_forEachCell(r,i,n,o,a,s,l,c){var e=this._convertToCellCoord(r),u=this._convertToCellCoord(i),h=this._convertToCellCoord(n),d=this._convertToCellCoord(o);for(let t=e;t<=h;t++)for(let e=u;e<=d;e++){var p=this.d*e+t;if((!c||c(this._convertFromCellCoord(t),this._convertFromCellCoord(e),this._convertFromCellCoord(t+1),this._convertFromCellCoord(e+1)))&&a.call(this,r,i,n,o,p,s,l,c))return}}_convertFromCellCoord(e){return(e-this.padding)/this.scale}_convertToCellCoord(e){return Math.max(0,Math.min(this.d-1,Math.floor(e*this.scale)+this.padding))}toArrayBuffer(){if(this.arrayBuffer)return this.arrayBuffer;var t=this.cells,e=3+this.cells.length+1+1;let r=0;for(let e=0;e<this.cells.length;e++)r+=this.cells[e].length;var i=new Int32Array(e+r+this.keys.length+this.bboxes.length);i[0]=this.extent,i[1]=this.n,i[2]=this.padding;let n=e;for(let e=0;e<t.length;e++){var o=t[e];i[3+e]=n,i.set(o,n),n+=o.length}return i[3+t.length]=n,i.set(this.keys,n),n+=this.keys.length,i[3+t.length+1]=n,i.set(this.bboxes,n),n+=this.bboxes.length,i.buffer}static serialize(e,t){e=e.toArrayBuffer();return t&&t.push(e),{buffer:e}}static deserialize(e){return new Ri(e.buffer)}}const Oi={};function r(e,t,r={}){if(Oi[e])throw new Error(e+" is already registered.");Object.defineProperty(t,"_classRegistryKey",{value:e,writeable:!1}),Oi[e]={klass:t,omit:r.omit||[],shallow:r.shallow||[]}}r("Object",Object),r("TransferableGridIndex",Ri),r("Color",_),r("Error",Error),r("AJAXError",me),r("ResolvedImage",Ct),r("StylePropertyFunction",Vr),r("StyleExpression",Br,{omit:["_evaluator"]}),r("ZoomDependentExpression",jr),r("ZoomConstantExpression",qr),r("CompoundExpression",Qt,{omit:["_evaluate"]});for(const uu in xr)xr[uu]._classRegistryKey||r("Expression_"+uu,xr[uu]);function Li(e){return e&&"undefined"!=typeof ArrayBuffer&&(e instanceof ArrayBuffer||e.constructor&&"ArrayBuffer"===e.constructor.name)}function Di(e,t){if(null==e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||e instanceof Boolean||e instanceof Number||e instanceof String||e instanceof Date||e instanceof RegExp||e instanceof Blob||e instanceof Error)return e;if(Li(e))return t&&t.push(e),e;if(Q(e))return t&&t.push(e),e;if(ArrayBuffer.isView(e))return i=e,t&&t.push(i.buffer),i;if(e instanceof ImageData)return t&&t.push(e.data.buffer),e;if(Array.isArray(e)){var r=[];for(const s of e)r.push(Di(s,t));return r}if("object"!=typeof e)throw new Error("can't serialize object of type "+typeof e);var i=e.constructor,n=i._classRegistryKey;if(!n)throw new Error("can't serialize object of unregistered class "+i.name);if(!Oi[n])throw new Error(n+" is not registered.");var o,a=i.serialize?i.serialize(e,t):{};if(i.serialize){if(t&&a===t[t.length-1])throw new Error("statically serialized object won't survive transfer of $name property")}else{for(const l in e)!e.hasOwnProperty(l)||0<=Oi[n].omit.indexOf(l)||(o=e[l],a[l]=0<=Oi[n].shallow.indexOf(l)?o:Di(o,t));e instanceof Error&&(a.message=e.message)}if(a.$name)throw new Error("$name property is reserved for worker serialization logic.");return"Object"!==n&&(a.$name=n),a}function zi(e){if(null==e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||e instanceof Boolean||e instanceof Number||e instanceof String||e instanceof Date||e instanceof RegExp||e instanceof Blob||e instanceof Error||Li(e)||Q(e)||ArrayBuffer.isView(e)||e instanceof ImageData)return e;if(Array.isArray(e))return e.map(zi);if("object"!=typeof e)throw new Error("can't deserialize object of type "+typeof e);var t=e.$name||"Object";if(!Oi[t])throw new Error("can't deserialize unregistered class "+t);var r=Oi[t]["klass"];if(!r)throw new Error("can't deserialize unregistered class "+t);if(r.deserialize)return r.deserialize(e);var i,n=Object.create(r.prototype);for(const o of Object.keys(e))"$name"!==o&&(i=e[o],n[o]=0<=Oi[t].shallow.indexOf(o)?i:zi(i));return n}class Ni{constructor(){this.first=!0}update(e,t){var r=Math.floor(e);return this.first?(this.first=!1,this.lastIntegerZoom=r,this.lastIntegerZoomTime=0,this.lastZoom=e,this.lastFloorZoom=r,!0):(this.lastFloorZoom>r?(this.lastIntegerZoom=r+1,this.lastIntegerZoomTime=t):this.lastFloorZoom<r&&(this.lastIntegerZoom=r,this.lastIntegerZoomTime=t),e!==this.lastZoom&&(this.lastZoom=e,this.lastFloorZoom=r,!0))}}const ie={"Latin-1 Supplement":e=>128<=e&&e<=255,Arabic:e=>1536<=e&&e<=1791,"Arabic Supplement":e=>1872<=e&&e<=1919,"Arabic Extended-A":e=>2208<=e&&e<=2303,"Hangul Jamo":e=>4352<=e&&e<=4607,"Unified Canadian Aboriginal Syllabics":e=>5120<=e&&e<=5759,Khmer:e=>6016<=e&&e<=6143,"Unified Canadian Aboriginal Syllabics Extended":e=>6320<=e&&e<=6399,"General Punctuation":e=>8192<=e&&e<=8303,"Letterlike Symbols":e=>8448<=e&&e<=8527,"Number Forms":e=>8528<=e&&e<=8591,"Miscellaneous Technical":e=>8960<=e&&e<=9215,"Control Pictures":e=>9216<=e&&e<=9279,"Optical Character Recognition":e=>9280<=e&&e<=9311,"Enclosed Alphanumerics":e=>9312<=e&&e<=9471,"Geometric Shapes":e=>9632<=e&&e<=9727,"Miscellaneous Symbols":e=>9728<=e&&e<=9983,"Miscellaneous Symbols and Arrows":e=>11008<=e&&e<=11263,"CJK Radicals Supplement":e=>11904<=e&&e<=12031,"Kangxi Radicals":e=>12032<=e&&e<=12255,"Ideographic Description Characters":e=>12272<=e&&e<=12287,"CJK Symbols and Punctuation":e=>12288<=e&&e<=12351,Hiragana:e=>12352<=e&&e<=12447,Katakana:e=>12448<=e&&e<=12543,Bopomofo:e=>12544<=e&&e<=12591,"Hangul Compatibility Jamo":e=>12592<=e&&e<=12687,Kanbun:e=>12688<=e&&e<=12703,"Bopomofo Extended":e=>12704<=e&&e<=12735,"CJK Strokes":e=>12736<=e&&e<=12783,"Katakana Phonetic Extensions":e=>12784<=e&&e<=12799,"Enclosed CJK Letters and Months":e=>12800<=e&&e<=13055,"CJK Compatibility":e=>13056<=e&&e<=13311,"CJK Unified Ideographs Extension A":e=>13312<=e&&e<=19903,"Yijing Hexagram Symbols":e=>19904<=e&&e<=19967,"CJK Unified Ideographs":e=>19968<=e&&e<=40959,"Yi Syllables":e=>40960<=e&&e<=42127,"Yi Radicals":e=>42128<=e&&e<=42191,"Hangul Jamo Extended-A":e=>43360<=e&&e<=43391,"Hangul Syllables":e=>44032<=e&&e<=55215,"Hangul Jamo Extended-B":e=>55216<=e&&e<=55295,"Private Use Area":e=>57344<=e&&e<=63743,"CJK Compatibility Ideographs":e=>63744<=e&&e<=64255,"Arabic Presentation Forms-A":e=>64336<=e&&e<=65023,"Vertical Forms":e=>65040<=e&&e<=65055,"CJK Compatibility Forms":e=>65072<=e&&e<=65103,"Small Form Variants":e=>65104<=e&&e<=65135,"Arabic Presentation Forms-B":e=>65136<=e&&e<=65279,"Halfwidth and Fullwidth Forms":e=>65280<=e&&e<=65519};function Bi(e){for(const t of e)if(Ui(t.charCodeAt(0)))return!0;return!1}function Fi(e){for(const r of e)if(t=r.charCodeAt(0),ie.Arabic(t)||(ie["Arabic Supplement"](t)||ie["Arabic Extended-A"](t)||ie["Arabic Presentation Forms-A"](t)||ie["Arabic Presentation Forms-B"](t)))return;var t;return 1}function Ui(e){return 746===e||747===e||!(e<4352)&&(ie["Bopomofo Extended"](e)||ie.Bopomofo(e)||ie["CJK Compatibility Forms"](e)&&!(65097<=e&&e<=65103)||ie["CJK Compatibility Ideographs"](e)||ie["CJK Compatibility"](e)||ie["CJK Radicals Supplement"](e)||ie["CJK Strokes"](e)||!(!ie["CJK Symbols and Punctuation"](e)||12296<=e&&e<=12305||12308<=e&&e<=12319||12336===e)||ie["CJK Unified Ideographs Extension A"](e)||ie["CJK Unified Ideographs"](e)||ie["Enclosed CJK Letters and Months"](e)||ie["Hangul Compatibility Jamo"](e)||ie["Hangul Jamo Extended-A"](e)||ie["Hangul Jamo Extended-B"](e)||ie["Hangul Jamo"](e)||ie["Hangul Syllables"](e)||ie.Hiragana(e)||ie["Ideographic Description Characters"](e)||ie.Kanbun(e)||ie["Kangxi Radicals"](e)||ie["Katakana Phonetic Extensions"](e)||ie.Katakana(e)&&12540!==e||!(!ie["Halfwidth and Fullwidth Forms"](e)||65288===e||65289===e||65293===e||65306<=e&&e<=65310||65339===e||65341===e||65343===e||65371<=e&&e<=65503||65507===e||65512<=e&&e<=65519)||!(!ie["Small Form Variants"](e)||65112<=e&&e<=65118||65123<=e&&e<=65126)||ie["Unified Canadian Aboriginal Syllabics"](e)||ie["Unified Canadian Aboriginal Syllabics Extended"](e)||ie["Vertical Forms"](e)||ie["Yijing Hexagram Symbols"](e)||ie["Yi Syllables"](e)||!!ie["Yi Radicals"](e))}function qi(e){return!(Ui(e)||(e=e,ie["Latin-1 Supplement"](e)&&(167===e||169===e||174===e||177===e||188===e||189===e||190===e||215===e||247===e))||ie["General Punctuation"](e)&&(8214===e||8224===e||8225===e||8240===e||8241===e||8251===e||8252===e||8258===e||8263===e||8264===e||8265===e||8273===e)||ie["Letterlike Symbols"](e)||ie["Number Forms"](e)||ie["Miscellaneous Technical"](e)&&(8960<=e&&e<=8967||8972<=e&&e<=8991||8996<=e&&e<=9e3||9003===e||9085<=e&&e<=9114||9150<=e&&e<=9165||9167===e||9169<=e&&e<=9179||9186<=e&&e<=9215)||ie["Control Pictures"](e)&&9251!==e||ie["Optical Character Recognition"](e)||ie["Enclosed Alphanumerics"](e)||ie["Geometric Shapes"](e)||ie["Miscellaneous Symbols"](e)&&!(9754<=e&&e<=9759)||ie["Miscellaneous Symbols and Arrows"](e)&&(11026<=e&&e<=11055||11088<=e&&e<=11097||11192<=e&&e<=11243)||ie["CJK Symbols and Punctuation"](e)||ie.Katakana(e)||ie["Private Use Area"](e)||ie["CJK Compatibility Forms"](e)||ie["Small Form Variants"](e)||ie["Halfwidth and Fullwidth Forms"](e)||8734===e||8756===e||8757===e||9984<=e&&e<=10087||10102<=e&&e<=10131||65532===e||65533===e)}function ji(e){return 1424<=e&&e<=2303||ie["Arabic Presentation Forms-A"](e)||ie["Arabic Presentation Forms-B"](e)}function Hi(e,t){for(const i of e)if(r=i.charCodeAt(0),!t&&ji(r)||2304<=r&&r<=3583||3840<=r&&r<=4255||ie.Khmer(r))return!1;var r;return!0}const Vi=new class{constructor(){this.applyArabicShaping=null,this.processBidirectionalText=null,this.processStyledBidirectionalText=null,this.pluginStatus="unavailable",this.pluginURL=null}setState(e){this.pluginStatus=e.pluginStatus,this.pluginURL=e.pluginURL}getState(){return{pluginStatus:this.pluginStatus,pluginURL:this.pluginURL}}setMethods(e){this.applyArabicShaping=e.applyArabicShaping,this.processBidirectionalText=e.processBidirectionalText,this.processStyledBidirectionalText=e.processStyledBidirectionalText}isParsed(){return null!=this.applyArabicShaping&&null!=this.processBidirectionalText&&null!=this.processStyledBidirectionalText}getPluginURL(){return this.pluginURL}getRTLTextPluginStatus(){return this.pluginStatus}};class P{constructor(e,t){this.zoom=e,t?(this.now=t.now,this.fadeDuration=t.fadeDuration,this.zoomHistory=t.zoomHistory,this.transition=t.transition):(this.now=0,this.fadeDuration=0,this.zoomHistory=new Ni,this.transition={})}isSupportedScript(e){return Hi(e,"loaded"===Vi.getRTLTextPluginStatus())}crossFadingFactor(){return 0===this.fadeDuration?1:Math.min((this.now-this.zoomHistory.lastIntegerZoomTime)/this.fadeDuration,1)}getCrossfadeParameters(){var e=this.zoom,t=e-Math.floor(e),r=this.crossFadingFactor();return e>this.zoomHistory.lastIntegerZoom?{fromScale:2,toScale:1,t:t+(1-t)*r}:{fromScale:.5,toScale:1,t:1-(1-r)*t}}}class Gi{constructor(e,t){this.property=e,this.value=t,this.expression=function(t,r){if(Mr(t))return new Vr(t,r);if(Fr(t)){var e=Hr(t,r);if("error"===e.result)throw new Error(e.value.map(e=>e.key+": "+e.message).join(", "));return e.value}{let e=t;return"color"===r.type&&"string"==typeof t?e=_.parse(t):"padding"!==r.type||"number"!=typeof t&&!Array.isArray(t)?"variableAnchorOffsetCollection"===r.type&&Array.isArray(t)&&(e=xt.parse(t)):e=bt.parse(t),{kind:"constant",evaluate:()=>e}}}(void 0===t?e.specification.default:t,e.specification)}isDataDriven(){return"source"===this.expression.kind||"composite"===this.expression.kind}possiblyEvaluate(e,t,r){return this.property.possiblyEvaluate(this,e,t,r)}}class Ki{constructor(e){this.property=e,this.value=new Gi(e,void 0)}transitioned(e,t){return new Wi(this.property,this.value,t,V({},e.transition,this.transition),e.now)}untransitioned(){return new Wi(this.property,this.value,null,{},0)}}class Zi{constructor(e){this._properties=e,this._values=Object.create(e.defaultTransitionablePropertyValues)}getValue(e){return W(this._values[e].value.value)}setValue(e,t){Object.prototype.hasOwnProperty.call(this._values,e)||(this._values[e]=new Ki(this._values[e].property)),this._values[e].value=new Gi(this._values[e].property,null===t?void 0:W(t))}getTransition(e){return W(this._values[e].transition)}setTransition(e,t){Object.prototype.hasOwnProperty.call(this._values,e)||(this._values[e]=new Ki(this._values[e].property)),this._values[e].transition=W(t)||void 0}serialize(){var e={};for(const r of Object.keys(this._values)){var t=this.getValue(r),t=(void 0!==t&&(e[r]=t),this.getTransition(r));void 0!==t&&(e[r+"-transition"]=t)}return e}transitioned(e,t){var r=new Yi(this._properties);for(const i of Object.keys(this._values))r._values[i]=this._values[i].transitioned(e,t._values[i]);return r}untransitioned(){var e=new Yi(this._properties);for(const t of Object.keys(this._values))e._values[t]=this._values[t].untransitioned();return e}}class Wi{constructor(e,t,r,i,n){this.property=e,this.value=t,this.begin=n+i.delay||0,this.end=this.begin+i.duration||0,e.specification.transition&&(i.delay||i.duration)&&(this.prior=r)}possiblyEvaluate(e,t,r){var i=e.now||0,n=this.value.possiblyEvaluate(e,t,r),o=this.prior;return o?i>this.end||this.value.isDataDriven()?(this.prior=null,n):i<this.begin?o.possiblyEvaluate(e,t,r):(i=(i-this.begin)/(this.end-this.begin),this.property.interpolate(o.possiblyEvaluate(e,t,r),n,(o=i)<=0?0:1<=o?1:(t=(e=o*o)*o,4*(o<.5?t:3*(o-e)+t-.75)))):n}}class Yi{constructor(e){this._properties=e,this._values=Object.create(e.defaultTransitioningPropertyValues)}possiblyEvaluate(e,t,r){var i=new Ji(this._properties);for(const n of Object.keys(this._values))i._values[n]=this._values[n].possiblyEvaluate(e,t,r);return i}hasTransition(){for(const e of Object.keys(this._values))if(this._values[e].prior)return!0;return!1}}class $i{constructor(e){this._properties=e,this._values=Object.create(e.defaultPropertyValues)}hasValue(e){return void 0!==this._values[e].value}getValue(e){return W(this._values[e].value)}setValue(e,t){this._values[e]=new Gi(this._values[e].property,null===t?void 0:W(t))}serialize(){var e={};for(const r of Object.keys(this._values)){var t=this.getValue(r);void 0!==t&&(e[r]=t)}return e}possiblyEvaluate(e,t,r){var i=new Ji(this._properties);for(const n of Object.keys(this._values))i._values[n]=this._values[n].possiblyEvaluate(e,t,r);return i}}class Xi{constructor(e,t,r){this.property=e,this.value=t,this.parameters=r}isConstant(){return"constant"===this.value.kind}constantOr(e){return"constant"===this.value.kind?this.value.value:e}evaluate(e,t,r,i){return this.property.evaluate(this.value,this.parameters,e,t,r,i)}}class Ji{constructor(e){this._properties=e,this._values=Object.create(e.defaultPossiblyEvaluatedValues)}get(e){return this._values[e]}}class i{constructor(e){this.specification=e}possiblyEvaluate(e,t){if(e.isDataDriven())throw new Error("Value should not be data driven");return e.expression.evaluate(t)}interpolate(e,t,r){var i=this.specification.type,i=k[i];return i?i(e,t,r):e}}class n{constructor(e,t){this.specification=e,this.overrides=t}possiblyEvaluate(e,t,r,i){return"constant"===e.expression.kind||"camera"===e.expression.kind?new Xi(this,{kind:"constant",value:e.expression.evaluate(t,null,{},r,i)},t):new Xi(this,e.expression,t)}interpolate(e,t,r){var i;return"constant"!==e.value.kind||"constant"!==t.value.kind?e:void 0===e.value.value||void 0===t.value.value?new Xi(this,{kind:"constant",value:void 0},e.parameters):(i=this.specification.type,(i=k[i])?(i=i(e.value.value,t.value.value,r),new Xi(this,{kind:"constant",value:i},e.parameters)):e)}evaluate(e,t,r,i,n,o){return"constant"===e.kind?e.value:e.evaluate(t,r,i,n,o)}}class Qi extends n{possiblyEvaluate(e,t,r,i){return void 0===e.value?new Xi(this,{kind:"constant",value:void 0},t):"constant"===e.expression.kind?(r=e.expression.evaluate(t,null,{},r,i),i="resolvedImage"===e.property.specification.type&&"string"!=typeof r?r.name:r,r=this._calculate(i,i,i,t),new Xi(this,{kind:"constant",value:r},t)):"camera"===e.expression.kind?(i=this._calculate(e.expression.evaluate({zoom:t.zoom-1}),e.expression.evaluate({zoom:t.zoom}),e.expression.evaluate({zoom:t.zoom+1}),t),new Xi(this,{kind:"constant",value:i},t)):new Xi(this,e.expression,t)}evaluate(e,t,r,i,n,o){return"source"===e.kind?(n=e.evaluate(t,r,i,n,o),this._calculate(n,n,n,t)):"composite"===e.kind?this._calculate(e.evaluate({zoom:Math.floor(t.zoom)-1},r,i),e.evaluate({zoom:Math.floor(t.zoom)},r,i),e.evaluate({zoom:Math.floor(t.zoom)+1},r,i),t):e.value}_calculate(e,t,r,i){return i.zoom>i.zoomHistory.lastIntegerZoom?{from:e,to:t}:{from:r,to:t}}interpolate(e){return e}}class en{constructor(e){this.specification=e}possiblyEvaluate(e,t,r,i){if(void 0!==e.value)return"constant"===e.expression.kind?(r=e.expression.evaluate(t,null,{},r,i),this._calculate(r,r,r,t)):this._calculate(e.expression.evaluate(new P(Math.floor(t.zoom-1),t)),e.expression.evaluate(new P(Math.floor(t.zoom),t)),e.expression.evaluate(new P(Math.floor(t.zoom+1),t)),t)}_calculate(e,t,r,i){return i.zoom>i.zoomHistory.lastIntegerZoom?{from:e,to:t}:{from:r,to:t}}interpolate(e){return e}}class tn{constructor(e){this.specification=e}possiblyEvaluate(e,t,r,i){return!!e.expression.evaluate(t,null,{},r,i)}interpolate(){return!1}}class a{constructor(e){this.properties=e,this.defaultPropertyValues={},this.defaultTransitionablePropertyValues={},this.defaultTransitioningPropertyValues={},this.defaultPossiblyEvaluatedValues={},this.overridableProperties=[];for(const i in e){var t=e[i],r=(t.specification.overridable&&this.overridableProperties.push(i),this.defaultPropertyValues[i]=new Gi(t,void 0)),t=this.defaultTransitionablePropertyValues[i]=new Ki(t);this.defaultTransitioningPropertyValues[i]=t.untransitioned(),this.defaultPossiblyEvaluatedValues[i]=r.possiblyEvaluate({})}}}r("DataDrivenProperty",n),r("DataConstantProperty",i),r("CrossFadedDataDrivenProperty",Qi),r("CrossFadedProperty",en),r("ColorRampProperty",tn);const rn="-transition";class nn extends Te{constructor(e,t){if(super(),this.id=e.id,this.type=e.type,this._featureFilter={filter:()=>!0,needGeometry:!1},"custom"!==e.type&&(this.metadata=e.metadata,this.minzoom=e.minzoom,this.maxzoom=e.maxzoom,"background"!==e.type&&(this.source=e.source,this.sourceLayer=e["source-layer"],this.filter=e.filter),t.layout&&(this._unevaluatedLayout=new $i(t.layout)),t.paint)){this._transitionablePaint=new Zi(t.paint);for(const r in e.paint)this.setPaintProperty(r,e.paint[r],{validate:!1});for(const i in e.layout)this.setLayoutProperty(i,e.layout[i],{validate:!1});this._transitioningPaint=this._transitionablePaint.untransitioned(),this.paint=new Ji(t.paint)}}getCrossfadeParameters(){return this._crossfadeParameters}getLayoutProperty(e){return"visibility"===e?this.visibility:this._unevaluatedLayout.getValue(e)}setLayoutProperty(e,t,r={}){if(null!=t){var i=`layers.${this.id}.layout.`+e;if(this._validate(Pi,i,e,t,r))return}"visibility"===e?this.visibility=t:this._unevaluatedLayout.setValue(e,t)}getPaintProperty(e){return e.endsWith(rn)?this._transitionablePaint.getTransition(e.slice(0,-rn.length)):this._transitionablePaint.getValue(e)}setPaintProperty(e,t,r={}){if(null!=t){var i=`layers.${this.id}.paint.`+e;if(this._validate(ki,i,e,t,r))return!1}var n;return e.endsWith(rn)?(this._transitionablePaint.setTransition(e.slice(0,-rn.length),t||void 0),!1):(r="cross-faded-data-driven"===(i=this._transitionablePaint._values[e]).property.specification["property-type"],n=i.value.isDataDriven(),i=i.value,this._transitionablePaint.setValue(e,t),this._handleSpecialPaintPropertyUpdate(e),(t=this._transitionablePaint._values[e].value).isDataDriven()||n||r||this._handleOverridablePaintPropertyUpdate(e,i,t))}_handleSpecialPaintPropertyUpdate(e){}_handleOverridablePaintPropertyUpdate(e,t,r){return!1}isHidden(e){return!!(this.minzoom&&e<this.minzoom)||!!(this.maxzoom&&e>=this.maxzoom)||"none"===this.visibility}updateTransitions(e){this._transitioningPaint=this._transitionablePaint.transitioned(e,this._transitioningPaint)}hasTransition(){return this._transitioningPaint.hasTransition()}recalculate(e,t){e.getCrossfadeParameters&&(this._crossfadeParameters=e.getCrossfadeParameters()),this._unevaluatedLayout&&(this.layout=this._unevaluatedLayout.possiblyEvaluate(e,void 0,t)),this.paint=this._transitioningPaint.possiblyEvaluate(e,void 0,t)}serialize(){var e={id:this.id,type:this.type,source:this.source,"source-layer":this.sourceLayer,metadata:this.metadata,minzoom:this.minzoom,maxzoom:this.maxzoom,filter:this.filter,layout:this._unevaluatedLayout&&this._unevaluatedLayout.serialize(),paint:this._transitionablePaint&&this._transitionablePaint.serialize()};return this.visibility&&(e.layout=e.layout||{},e.layout.visibility=this.visibility),Z(e,(e,t)=>!(void 0===e||"layout"===t&&!Object.keys(e).length||"paint"===t&&!Object.keys(e).length))}_validate(e,t,r,i,n={}){return(!n||!1!==n.validate)&&Mi(this,e.call(Ai,{key:t,layerType:this.type,objectKey:r,value:i,styleSpec:o,style:{glyphs:!0,sprite:!0}}))}is3D(){return!1}isTileClipped(){return!1}hasOffscreenPass(){return!1}resize(){}isStateDependent(){for(const t in this.paint._values){var e=this.paint.get(t);if(e instanceof Xi&&Ar(e.property.specification)&&(("source"===e.value.kind||"composite"===e.value.kind)&&e.value.isStateDependent))return!0}return!1}}const on={Int8:Int8Array,Uint8:Uint8Array,Int16:Int16Array,Uint16:Uint16Array,Int32:Int32Array,Uint32:Uint32Array,Float32:Float32Array};class an{constructor(e,t){this._structArray=e,this._pos1=t*this.size,this._pos2=this._pos1/2,this._pos4=this._pos1/4,this._pos8=this._pos1/8}}class l{constructor(){this.isTransferred=!1,this.capacity=-1,this.resize(0)}static serialize(e,t){return e._trim(),t&&(e.isTransferred=!0,t.push(e.arrayBuffer)),{length:e.length,arrayBuffer:e.arrayBuffer}}static deserialize(e){var t=Object.create(this.prototype);return t.arrayBuffer=e.arrayBuffer,t.length=e.length,t.capacity=e.arrayBuffer.byteLength/t.bytesPerElement,t._refreshViews(),t}_trim(){this.length!==this.capacity&&(this.capacity=this.length,this.arrayBuffer=this.arrayBuffer.slice(0,this.length*this.bytesPerElement),this._refreshViews())}clear(){this.length=0}resize(e){this.reserve(e),this.length=e}reserve(e){e>this.capacity&&(this.capacity=Math.max(e,Math.floor(5*this.capacity),128),this.arrayBuffer=new ArrayBuffer(this.capacity*this.bytesPerElement),e=this.uint8,this._refreshViews(),e)&&this.uint8.set(e)}_refreshViews(){throw new Error("_refreshViews() must be implemented by each concrete StructArray layout")}}function c(e,n=1){let o=0,a=0;return{members:e.map(e=>{t=e.type;var t=on[t].BYTES_PER_ELEMENT,r=o=sn(o,Math.max(n,t)),i=e.components||1;return a=Math.max(a,t),o+=t*i,{name:e.name,type:e.type,components:i,offset:r}}),size:sn(o,Math.max(a,n)),alignment:n}}function sn(e,t){return Math.ceil(e/t)*t}class ln extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer)}emplaceBack(e,t){var r=this.length;return this.resize(r+1),this.emplace(r,e,t)}emplace(e,t,r){var i=2*e;return this.int16[0+i]=t,this.int16[1+i]=r,e}}ln.prototype.bytesPerElement=4,r("StructArrayLayout2i4",ln);class cn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer)}emplaceBack(e,t,r){var i=this.length;return this.resize(i+1),this.emplace(i,e,t,r)}emplace(e,t,r,i){var n=3*e;return this.int16[0+n]=t,this.int16[1+n]=r,this.int16[2+n]=i,e}}cn.prototype.bytesPerElement=6,r("StructArrayLayout3i6",cn);class un extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer)}emplaceBack(e,t,r,i){var n=this.length;return this.resize(n+1),this.emplace(n,e,t,r,i)}emplace(e,t,r,i,n){var o=4*e;return this.int16[0+o]=t,this.int16[1+o]=r,this.int16[2+o]=i,this.int16[3+o]=n,e}}un.prototype.bytesPerElement=8,r("StructArrayLayout4i8",un);class hn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o){var a=this.length;return this.resize(a+1),this.emplace(a,e,t,r,i,n,o)}emplace(e,t,r,i,n,o,a){var s=6*e;return this.int16[0+s]=t,this.int16[1+s]=r,this.int16[2+s]=i,this.int16[3+s]=n,this.int16[4+s]=o,this.int16[5+s]=a,e}}hn.prototype.bytesPerElement=12,r("StructArrayLayout2i4i12",hn);class dn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o){var a=this.length;return this.resize(a+1),this.emplace(a,e,t,r,i,n,o)}emplace(e,t,r,i,n,o,a){var s=4*e,l=8*e;return this.int16[0+s]=t,this.int16[1+s]=r,this.uint8[4+l]=i,this.uint8[5+l]=n,this.uint8[6+l]=o,this.uint8[7+l]=a,e}}dn.prototype.bytesPerElement=8,r("StructArrayLayout2i4ub8",dn);class pn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e,t){var r=this.length;return this.resize(r+1),this.emplace(r,e,t)}emplace(e,t,r){var i=2*e;return this.float32[0+i]=t,this.float32[1+i]=r,e}}pn.prototype.bytesPerElement=8,r("StructArrayLayout2f8",pn);class fn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o,a,s,l,c){var u=this.length;return this.resize(u+1),this.emplace(u,e,t,r,i,n,o,a,s,l,c)}emplace(e,t,r,i,n,o,a,s,l,c,u){var h=10*e;return this.uint16[0+h]=t,this.uint16[1+h]=r,this.uint16[2+h]=i,this.uint16[3+h]=n,this.uint16[4+h]=o,this.uint16[5+h]=a,this.uint16[6+h]=s,this.uint16[7+h]=l,this.uint16[8+h]=c,this.uint16[9+h]=u,e}}fn.prototype.bytesPerElement=20,r("StructArrayLayout10ui20",fn);class mn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o,a,s,l,c,u,h){var d=this.length;return this.resize(d+1),this.emplace(d,e,t,r,i,n,o,a,s,l,c,u,h)}emplace(e,t,r,i,n,o,a,s,l,c,u,h,d){var p=12*e;return this.int16[0+p]=t,this.int16[1+p]=r,this.int16[2+p]=i,this.int16[3+p]=n,this.uint16[4+p]=o,this.uint16[5+p]=a,this.uint16[6+p]=s,this.uint16[7+p]=l,this.int16[8+p]=c,this.int16[9+p]=u,this.int16[10+p]=h,this.int16[11+p]=d,e}}mn.prototype.bytesPerElement=24,r("StructArrayLayout4i4ui4i24",mn);class gn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e,t,r){var i=this.length;return this.resize(i+1),this.emplace(i,e,t,r)}emplace(e,t,r,i){var n=3*e;return this.float32[0+n]=t,this.float32[1+n]=r,this.float32[2+n]=i,e}}gn.prototype.bytesPerElement=12,r("StructArrayLayout3f12",gn);class yn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer)}emplaceBack(e){var t=this.length;return this.resize(t+1),this.emplace(t,e)}emplace(e,t){return this.uint32[0+ +e]=t,e}}yn.prototype.bytesPerElement=4,r("StructArrayLayout1ul4",yn);class vn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o,a,s,l){var c=this.length;return this.resize(c+1),this.emplace(c,e,t,r,i,n,o,a,s,l)}emplace(e,t,r,i,n,o,a,s,l,c){var u=10*e,h=5*e;return this.int16[0+u]=t,this.int16[1+u]=r,this.int16[2+u]=i,this.int16[3+u]=n,this.int16[4+u]=o,this.int16[5+u]=a,this.uint32[3+h]=s,this.uint16[8+u]=l,this.uint16[9+u]=c,e}}vn.prototype.bytesPerElement=20,r("StructArrayLayout6i1ul2ui20",vn);class _n extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o){var a=this.length;return this.resize(a+1),this.emplace(a,e,t,r,i,n,o)}emplace(e,t,r,i,n,o,a){var s=6*e;return this.int16[0+s]=t,this.int16[1+s]=r,this.int16[2+s]=i,this.int16[3+s]=n,this.int16[4+s]=o,this.int16[5+s]=a,e}}_n.prototype.bytesPerElement=12,r("StructArrayLayout2i2i2i12",_n);class bn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n){var o=this.length;return this.resize(o+1),this.emplace(o,e,t,r,i,n)}emplace(e,t,r,i,n,o){var a=4*e,s=8*e;return this.float32[0+a]=t,this.float32[1+a]=r,this.float32[2+a]=i,this.int16[6+s]=n,this.int16[7+s]=o,e}}bn.prototype.bytesPerElement=16,r("StructArrayLayout2f1f2i16",bn);class wn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e,t,r,i){var n=this.length;return this.resize(n+1),this.emplace(n,e,t,r,i)}emplace(e,t,r,i,n){var o=12*e,a=3*e;return this.uint8[0+o]=t,this.uint8[1+o]=r,this.float32[1+a]=i,this.float32[2+a]=n,e}}wn.prototype.bytesPerElement=12,r("StructArrayLayout2ub2f12",wn);class xn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer)}emplaceBack(e,t,r){var i=this.length;return this.resize(i+1),this.emplace(i,e,t,r)}emplace(e,t,r,i){var n=3*e;return this.uint16[0+n]=t,this.uint16[1+n]=r,this.uint16[2+n]=i,e}}xn.prototype.bytesPerElement=6,r("StructArrayLayout3ui6",xn);class Cn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o,a,s,l,c,u,h,d,p,f,m,g){var y=this.length;return this.resize(y+1),this.emplace(y,e,t,r,i,n,o,a,s,l,c,u,h,d,p,f,m,g)}emplace(e,t,r,i,n,o,a,s,l,c,u,h,d,p,f,m,g,y){var v=24*e,_=12*e,b=48*e;return this.int16[0+v]=t,this.int16[1+v]=r,this.uint16[2+v]=i,this.uint16[3+v]=n,this.uint32[2+_]=o,this.uint32[3+_]=a,this.uint32[4+_]=s,this.uint16[10+v]=l,this.uint16[11+v]=c,this.uint16[12+v]=u,this.float32[7+_]=h,this.float32[8+_]=d,this.uint8[36+b]=p,this.uint8[37+b]=f,this.uint8[38+b]=m,this.uint32[10+_]=g,this.int16[22+v]=y,e}}Cn.prototype.bytesPerElement=48,r("StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48",Cn);class Tn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e,t,r,i,n,o,a,s,l,c,u,h,d,p,f,m,g,y,v,_,b,w,x,C,T,S,E,I){var A=this.length;return this.resize(A+1),this.emplace(A,e,t,r,i,n,o,a,s,l,c,u,h,d,p,f,m,g,y,v,_,b,w,x,C,T,S,E,I)}emplace(e,t,r,i,n,o,a,s,l,c,u,h,d,p,f,m,g,y,v,_,b,w,x,C,T,S,E,I,A){var k=32*e,P=16*e;return this.int16[0+k]=t,this.int16[1+k]=r,this.int16[2+k]=i,this.int16[3+k]=n,this.int16[4+k]=o,this.int16[5+k]=a,this.int16[6+k]=s,this.int16[7+k]=l,this.uint16[8+k]=c,this.uint16[9+k]=u,this.uint16[10+k]=h,this.uint16[11+k]=d,this.uint16[12+k]=p,this.uint16[13+k]=f,this.uint16[14+k]=m,this.uint16[15+k]=g,this.uint16[16+k]=y,this.uint16[17+k]=v,this.uint16[18+k]=_,this.uint16[19+k]=b,this.uint16[20+k]=w,this.uint16[21+k]=x,this.uint16[22+k]=C,this.uint32[12+P]=T,this.float32[13+P]=S,this.float32[14+P]=E,this.uint16[30+k]=I,this.uint16[31+k]=A,e}}Tn.prototype.bytesPerElement=64,r("StructArrayLayout8i15ui1ul2f2ui64",Tn);class Sn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e){var t=this.length;return this.resize(t+1),this.emplace(t,e)}emplace(e,t){return this.float32[0+ +e]=t,e}}Sn.prototype.bytesPerElement=4,r("StructArrayLayout1f4",Sn);class En extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e,t,r){var i=this.length;return this.resize(i+1),this.emplace(i,e,t,r)}emplace(e,t,r,i){var n=3*e;return this.uint16[0+6*e]=t,this.float32[1+n]=r,this.float32[2+n]=i,e}}En.prototype.bytesPerElement=12,r("StructArrayLayout1ui2f12",En);class In extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer)}emplaceBack(e,t,r){var i=this.length;return this.resize(i+1),this.emplace(i,e,t,r)}emplace(e,t,r,i){var n=4*e;return this.uint32[0+2*e]=t,this.uint16[2+n]=r,this.uint16[3+n]=i,e}}In.prototype.bytesPerElement=8,r("StructArrayLayout1ul2ui8",In);class An extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer)}emplaceBack(e,t){var r=this.length;return this.resize(r+1),this.emplace(r,e,t)}emplace(e,t,r){var i=2*e;return this.uint16[0+i]=t,this.uint16[1+i]=r,e}}An.prototype.bytesPerElement=4,r("StructArrayLayout2ui4",An);class kn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer)}emplaceBack(e){var t=this.length;return this.resize(t+1),this.emplace(t,e)}emplace(e,t){return this.uint16[0+ +e]=t,e}}kn.prototype.bytesPerElement=2,r("StructArrayLayout1ui2",kn);class Pn extends l{_refreshViews(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer)}emplaceBack(e,t,r,i){var n=this.length;return this.resize(n+1),this.emplace(n,e,t,r,i)}emplace(e,t,r,i,n){var o=4*e;return this.float32[0+o]=t,this.float32[1+o]=r,this.float32[2+o]=i,this.float32[3+o]=n,e}}Pn.prototype.bytesPerElement=16,r("StructArrayLayout4f16",Pn);class Mn extends an{get anchorPointX(){return this._structArray.int16[this._pos2+0]}get anchorPointY(){return this._structArray.int16[this._pos2+1]}get x1(){return this._structArray.int16[this._pos2+2]}get y1(){return this._structArray.int16[this._pos2+3]}get x2(){return this._structArray.int16[this._pos2+4]}get y2(){return this._structArray.int16[this._pos2+5]}get featureIndex(){return this._structArray.uint32[this._pos4+3]}get sourceLayerIndex(){return this._structArray.uint16[this._pos2+8]}get bucketIndex(){return this._structArray.uint16[this._pos2+9]}get anchorPoint(){return new B(this.anchorPointX,this.anchorPointY)}}Mn.prototype.size=20;class Rn extends vn{get(e){return new Mn(this,e)}}r("CollisionBoxArray",Rn);class On extends an{get anchorX(){return this._structArray.int16[this._pos2+0]}get anchorY(){return this._structArray.int16[this._pos2+1]}get glyphStartIndex(){return this._structArray.uint16[this._pos2+2]}get numGlyphs(){return this._structArray.uint16[this._pos2+3]}get vertexStartIndex(){return this._structArray.uint32[this._pos4+2]}get lineStartIndex(){return this._structArray.uint32[this._pos4+3]}get lineLength(){return this._structArray.uint32[this._pos4+4]}get segment(){return this._structArray.uint16[this._pos2+10]}get lowerSize(){return this._structArray.uint16[this._pos2+11]}get upperSize(){return this._structArray.uint16[this._pos2+12]}get lineOffsetX(){return this._structArray.float32[this._pos4+7]}get lineOffsetY(){return this._structArray.float32[this._pos4+8]}get writingMode(){return this._structArray.uint8[this._pos1+36]}get placedOrientation(){return this._structArray.uint8[this._pos1+37]}set placedOrientation(e){this._structArray.uint8[this._pos1+37]=e}get hidden(){return this._structArray.uint8[this._pos1+38]}set hidden(e){this._structArray.uint8[this._pos1+38]=e}get crossTileID(){return this._structArray.uint32[this._pos4+10]}set crossTileID(e){this._structArray.uint32[this._pos4+10]=e}get associatedIconIndex(){return this._structArray.int16[this._pos2+22]}}On.prototype.size=48;class Ln extends Cn{get(e){return new On(this,e)}}r("PlacedSymbolArray",Ln);class Dn extends an{get anchorX(){return this._structArray.int16[this._pos2+0]}get anchorY(){return this._structArray.int16[this._pos2+1]}get rightJustifiedTextSymbolIndex(){return this._structArray.int16[this._pos2+2]}get centerJustifiedTextSymbolIndex(){return this._structArray.int16[this._pos2+3]}get leftJustifiedTextSymbolIndex(){return this._structArray.int16[this._pos2+4]}get verticalPlacedTextSymbolIndex(){return this._structArray.int16[this._pos2+5]}get placedIconSymbolIndex(){return this._structArray.int16[this._pos2+6]}get verticalPlacedIconSymbolIndex(){return this._structArray.int16[this._pos2+7]}get key(){return this._structArray.uint16[this._pos2+8]}get textBoxStartIndex(){return this._structArray.uint16[this._pos2+9]}get textBoxEndIndex(){return this._structArray.uint16[this._pos2+10]}get verticalTextBoxStartIndex(){return this._structArray.uint16[this._pos2+11]}get verticalTextBoxEndIndex(){return this._structArray.uint16[this._pos2+12]}get iconBoxStartIndex(){return this._structArray.uint16[this._pos2+13]}get iconBoxEndIndex(){return this._structArray.uint16[this._pos2+14]}get verticalIconBoxStartIndex(){return this._structArray.uint16[this._pos2+15]}get verticalIconBoxEndIndex(){return this._structArray.uint16[this._pos2+16]}get featureIndex(){return this._structArray.uint16[this._pos2+17]}get numHorizontalGlyphVertices(){return this._structArray.uint16[this._pos2+18]}get numVerticalGlyphVertices(){return this._structArray.uint16[this._pos2+19]}get numIconVertices(){return this._structArray.uint16[this._pos2+20]}get numVerticalIconVertices(){return this._structArray.uint16[this._pos2+21]}get useRuntimeCollisionCircles(){return this._structArray.uint16[this._pos2+22]}get crossTileID(){return this._structArray.uint32[this._pos4+12]}set crossTileID(e){this._structArray.uint32[this._pos4+12]=e}get textBoxScale(){return this._structArray.float32[this._pos4+13]}get collisionCircleDiameter(){return this._structArray.float32[this._pos4+14]}get textAnchorOffsetStartIndex(){return this._structArray.uint16[this._pos2+30]}get textAnchorOffsetEndIndex(){return this._structArray.uint16[this._pos2+31]}}Dn.prototype.size=64;class zn extends Tn{get(e){return new Dn(this,e)}}r("SymbolInstanceArray",zn);class Nn extends Sn{getoffsetX(e){return this.float32[+e+0]}}r("GlyphOffsetArray",Nn);class Bn extends cn{getx(e){return this.int16[3*e+0]}gety(e){return this.int16[3*e+1]}gettileUnitDistanceFromAnchor(e){return this.int16[3*e+2]}}r("SymbolLineVertexArray",Bn);class Fn extends an{get textAnchor(){return this._structArray.uint16[this._pos2+0]}get textOffset0(){return this._structArray.float32[this._pos4+1]}get textOffset1(){return this._structArray.float32[this._pos4+2]}}Fn.prototype.size=12;class Un extends En{get(e){return new Fn(this,e)}}r("TextAnchorOffsetArray",Un);class qn extends an{get featureIndex(){return this._structArray.uint32[this._pos4+0]}get sourceLayerIndex(){return this._structArray.uint16[this._pos2+2]}get bucketIndex(){return this._structArray.uint16[this._pos2+3]}}qn.prototype.size=8;class jn extends In{get(e){return new qn(this,e)}}r("FeatureIndexArray",jn);class Hn extends ln{}class Vn extends ln{}class Gn extends ln{}class Kn extends hn{}class Zn extends dn{}class Wn extends pn{}class Yn extends fn{}class $n extends mn{}class Xn extends gn{}class Jn extends yn{}class Qn extends _n{}class eo extends wn{}class to extends xn{}class ro extends An{}const io=c([{name:"a_pos",components:2,type:"Int16"}],4)["members"];class x{constructor(e=[]){this.segments=e}prepareSegment(e,t,r,i){let n=this.segments[this.segments.length-1];return e>x.MAX_VERTEX_ARRAY_LENGTH&&he(`Max vertices per segment is ${x.MAX_VERTEX_ARRAY_LENGTH}: bucket requested `+e),(!n||n.vertexLength+e>x.MAX_VERTEX_ARRAY_LENGTH||n.sortKey!==i)&&(n={vertexOffset:t.length,primitiveOffset:r.length,vertexLength:0,primitiveLength:0},void 0!==i&&(n.sortKey=i),this.segments.push(n)),n}get(){return this.segments}destroy(){for(const e of this.segments)for(const t in e.vaos)e.vaos[t].destroy()}static simpleSegment(e,t,r,i){return new x([{vertexOffset:e,primitiveOffset:t,vertexLength:r,primitiveLength:i,vaos:{},sortKey:0}])}}function no(e,t){return 256*(e=j(Math.floor(e),0,255))+(t=j(Math.floor(t),0,255))}x.MAX_VERTEX_ARRAY_LENGTH=Math.pow(2,16)-1,r("SegmentVector",x);const oo=c([{name:"a_pattern_from",components:4,type:"Uint16"},{name:"a_pattern_to",components:4,type:"Uint16"},{name:"a_pixel_ratio_from",components:1,type:"Uint16"},{name:"a_pixel_ratio_to",components:1,type:"Uint16"}]);function ao(e,t){for(var r,i,n=3&e.length,o=e.length-n,a=t,s=3432918353,l=461845907,c=0;c<o;)i=255&e.charCodeAt(c)|(255&e.charCodeAt(++c))<<8|(255&e.charCodeAt(++c))<<16|(255&e.charCodeAt(++c))<<24,++c,a=27492+(65535&(r=5*(65535&(a=(a^=i=(65535&(i=(i=(65535&i)*s+(((i>>>16)*s&65535)<<16)&4294967295)<<15|i>>>17))*l+(((i>>>16)*l&65535)<<16)&4294967295)<<13|a>>>19))+((5*(a>>>16)&65535)<<16)&4294967295))+((58964+(r>>>16)&65535)<<16);switch(i=0,n){case 3:i^=(255&e.charCodeAt(c+2))<<16;case 2:i^=(255&e.charCodeAt(c+1))<<8;case 1:a^=i=(65535&(i=(i=(65535&(i^=255&e.charCodeAt(c)))*s+(((i>>>16)*s&65535)<<16)&4294967295)<<15|i>>>17))*l+(((i>>>16)*l&65535)<<16)&4294967295}return a=2246822507*(65535&(a=(a^=e.length)^a>>>16))+((2246822507*(a>>>16)&65535)<<16)&4294967295,a=3266489909*(65535&(a^=a>>>13))+((3266489909*(a>>>16)&65535)<<16)&4294967295,(a^=a>>>16)>>>0}function so(e,t){for(var r,i=e.length,n=t^i,o=0;4<=i;)r=1540483477*(65535&(r=255&e.charCodeAt(o)|(255&e.charCodeAt(++o))<<8|(255&e.charCodeAt(++o))<<16|(255&e.charCodeAt(++o))<<24))+((1540483477*(r>>>16)&65535)<<16),n=1540483477*(65535&n)+((1540483477*(n>>>16)&65535)<<16)^1540483477*(65535&(r^=r>>>24))+((1540483477*(r>>>16)&65535)<<16),i-=4,++o;switch(i){case 3:n^=(255&e.charCodeAt(o+2))<<16;case 2:n^=(255&e.charCodeAt(o+1))<<8;case 1:n=1540483477*(65535&(n^=255&e.charCodeAt(o)))+((1540483477*(n>>>16)&65535)<<16)}return n=1540483477*(65535&(n^=n>>>13))+((1540483477*(n>>>16)&65535)<<16),(n^=n>>>15)>>>0}e={exports:{}};e.exports=ao,e.exports.murmur3=ao,e.exports.murmur2=so;var lo=I(e.exports);class co{constructor(){this.ids=[],this.positions=[],this.indexed=!1}add(e,t,r,i){this.ids.push(uo(e)),this.positions.push(t,r,i)}getPositions(e){if(!this.indexed)throw new Error("Trying to get index, but feature positions are not indexed");var t=uo(e);let r=0,i=this.ids.length-1;for(;r<i;){var n=r+i>>1;this.ids[n]>=t?i=n:r=1+n}for(var o=[];this.ids[r]===t;){var a=this.positions[3*r],s=this.positions[3*r+1],l=this.positions[3*r+2];o.push({index:a,start:s,end:l}),r++}return o}static serialize(e,t){var r=new Float64Array(e.ids),e=new Uint32Array(e.positions);return function r(i,n,o,a){for(;o<a;){const s=i[o+a>>1];let e=o-1,t=a+1;for(;;){for(;e++,i[e]<s;);for(;t--,i[t]>s;);if(e>=t)break;ho(i,e,t),ho(n,3*e,3*t),ho(n,3*e+1,3*t+1),ho(n,3*e+2,3*t+2)}t-o<a-t?(r(i,n,o,t),o=t+1):(r(i,n,t+1,a),a=t)}}(r,e,0,r.length-1),t&&t.push(r.buffer,e.buffer),{ids:r,positions:e}}static deserialize(e){var t=new co;return t.ids=e.ids,t.positions=e.positions,t.indexed=!0,t}}function uo(e){var t=+e;return!isNaN(t)&&t<=Number.MAX_SAFE_INTEGER?t:lo(String(e))}function ho(e,t,r){var i=e[t];e[t]=e[r],e[r]=i}r("FeaturePositionMap",co);class po{constructor(e,t){this.gl=e.gl,this.location=t}}class fo extends po{constructor(e,t){super(e,t),this.current=0}set(e){this.current!==e&&(this.current=e,this.gl.uniform1f(this.location,e))}}class mo extends po{constructor(e,t){super(e,t),this.current=[0,0,0,0]}set(e){e[0]===this.current[0]&&e[1]===this.current[1]&&e[2]===this.current[2]&&e[3]===this.current[3]||(this.current=e,this.gl.uniform4f(this.location,e[0],e[1],e[2],e[3]))}}class go extends po{constructor(e,t){super(e,t),this.current=_.transparent}set(e){e.r===this.current.r&&e.g===this.current.g&&e.b===this.current.b&&e.a===this.current.a||(this.current=e,this.gl.uniform4f(this.location,e.r,e.g,e.b,e.a))}}const yo=new Float32Array(16);function vo(e){return[no(255*e.r,255*e.g),no(255*e.b,255*e.a)]}class _o{constructor(e,t,r){this.value=e,this.uniformNames=t.map(e=>"u_"+e),this.type=r}setUniform(e,t,r){e.set(r.constantOr(this.value))}getBinding(e,t,r){return new("color"===this.type?go:fo)(e,t)}}class bo{constructor(e,t){this.uniformNames=t.map(e=>"u_"+e),this.patternFrom=null,this.patternTo=null,this.pixelRatioFrom=1,this.pixelRatioTo=1}setConstantPatternPositions(e,t){this.pixelRatioFrom=t.pixelRatio,this.pixelRatioTo=e.pixelRatio,this.patternFrom=t.tlbr,this.patternTo=e.tlbr}setUniform(e,t,r,i){i="u_pattern_to"===i?this.patternTo:"u_pattern_from"===i?this.patternFrom:"u_pixel_ratio_to"===i?this.pixelRatioTo:"u_pixel_ratio_from"===i?this.pixelRatioFrom:null;i&&e.set(i)}getBinding(e,t,r){return new("u_pattern"===r.substr(0,9)?mo:fo)(e,t)}}class wo{constructor(e,t,r,i){this.expression=e,this.type=r,this.maxValue=0,this.paintVertexAttributes=t.map(e=>({name:"a_"+e,type:"Float32",components:"color"===r?2:1,offset:0})),this.paintVertexArray=new i}populatePaintArray(e,t,r,i,n){var o=this.paintVertexArray.length,t=this.expression.evaluate(new P(0),t,{},i,[],n);this.paintVertexArray.resize(e),this._setPaintValue(o,e,t)}updatePaintArray(e,t,r,i){r=this.expression.evaluate({zoom:0},r,i);this._setPaintValue(e,t,r)}_setPaintValue(t,r,i){if("color"===this.type){var n=vo(i);for(let e=t;e<r;e++)this.paintVertexArray.emplace(e,n[0],n[1])}else{for(let e=t;e<r;e++)this.paintVertexArray.emplace(e,i);this.maxValue=Math.max(this.maxValue,Math.abs(i))}}upload(e){this.paintVertexArray&&this.paintVertexArray.arrayBuffer&&(this.paintVertexBuffer&&this.paintVertexBuffer.buffer?this.paintVertexBuffer.updateData(this.paintVertexArray):this.paintVertexBuffer=e.createVertexBuffer(this.paintVertexArray,this.paintVertexAttributes,this.expression.isStateDependent))}destroy(){this.paintVertexBuffer&&this.paintVertexBuffer.destroy()}}class xo{constructor(e,t,r,i,n,o){this.expression=e,this.uniformNames=t.map(e=>`u_${e}_t`),this.type=r,this.useIntegerZoom=i,this.zoom=n,this.maxValue=0,this.paintVertexAttributes=t.map(e=>({name:"a_"+e,type:"Float32",components:"color"===r?4:2,offset:0})),this.paintVertexArray=new o}populatePaintArray(e,t,r,i,n){var o=this.expression.evaluate(new P(this.zoom),t,{},i,[],n),t=this.expression.evaluate(new P(this.zoom+1),t,{},i,[],n),i=this.paintVertexArray.length;this.paintVertexArray.resize(e),this._setPaintValue(i,e,o,t)}updatePaintArray(e,t,r,i){var n=this.expression.evaluate({zoom:this.zoom},r,i),r=this.expression.evaluate({zoom:this.zoom+1},r,i);this._setPaintValue(e,t,n,r)}_setPaintValue(t,r,i,n){if("color"===this.type){var o=vo(i),a=vo(n);for(let e=t;e<r;e++)this.paintVertexArray.emplace(e,o[0],o[1],a[0],a[1])}else{for(let e=t;e<r;e++)this.paintVertexArray.emplace(e,i,n);this.maxValue=Math.max(this.maxValue,Math.abs(i),Math.abs(n))}}upload(e){this.paintVertexArray&&this.paintVertexArray.arrayBuffer&&(this.paintVertexBuffer&&this.paintVertexBuffer.buffer?this.paintVertexBuffer.updateData(this.paintVertexArray):this.paintVertexBuffer=e.createVertexBuffer(this.paintVertexArray,this.paintVertexAttributes,this.expression.isStateDependent))}destroy(){this.paintVertexBuffer&&this.paintVertexBuffer.destroy()}setUniform(e,t){t=this.useIntegerZoom?Math.floor(t.zoom):t.zoom,t=j(this.expression.interpolationFactor(t,this.zoom,this.zoom+1),0,1);e.set(t)}getBinding(e,t,r){return new fo(e,t)}}class Co{constructor(e,t,r,i,n,o){this.expression=e,this.type=t,this.useIntegerZoom=r,this.zoom=i,this.layerId=o,this.zoomInPaintVertexArray=new n,this.zoomOutPaintVertexArray=new n}populatePaintArray(e,t,r){var i=this.zoomInPaintVertexArray.length;this.zoomInPaintVertexArray.resize(e),this.zoomOutPaintVertexArray.resize(e),this._setPaintValues(i,e,t.patterns&&t.patterns[this.layerId],r)}updatePaintArray(e,t,r,i,n){this._setPaintValues(e,t,r.patterns&&r.patterns[this.layerId],n)}_setPaintValues(t,r,e,i){if(i&&e){var{min:e,mid:n,max:o}=e,a=i[e],s=i[n],l=i[o];if(a&&s&&l)for(let e=t;e<r;e++)this.zoomInPaintVertexArray.emplace(e,s.tl[0],s.tl[1],s.br[0],s.br[1],a.tl[0],a.tl[1],a.br[0],a.br[1],s.pixelRatio,a.pixelRatio),this.zoomOutPaintVertexArray.emplace(e,s.tl[0],s.tl[1],s.br[0],s.br[1],l.tl[0],l.tl[1],l.br[0],l.br[1],s.pixelRatio,l.pixelRatio)}}upload(e){this.zoomInPaintVertexArray&&this.zoomInPaintVertexArray.arrayBuffer&&this.zoomOutPaintVertexArray&&this.zoomOutPaintVertexArray.arrayBuffer&&(this.zoomInPaintVertexBuffer=e.createVertexBuffer(this.zoomInPaintVertexArray,oo.members,this.expression.isStateDependent),this.zoomOutPaintVertexBuffer=e.createVertexBuffer(this.zoomOutPaintVertexArray,oo.members,this.expression.isStateDependent))}destroy(){this.zoomOutPaintVertexBuffer&&this.zoomOutPaintVertexBuffer.destroy(),this.zoomInPaintVertexBuffer&&this.zoomInPaintVertexBuffer.destroy()}}class To{constructor(e,t,r){this.binders={},this._buffers=[];var i,n,o,a,s,l,c=[];for(const u in e.paint._values)r(u)&&(a=e.paint.get(u))instanceof Xi&&Ar(a.property.specification)&&(s=u,l=e.type,s={"text-opacity":["opacity"],"icon-opacity":["opacity"],"text-color":["fill_color"],"icon-color":["fill_color"],"text-halo-color":["halo_color"],"icon-halo-color":["halo_color"],"text-halo-blur":["halo_blur"],"icon-halo-blur":["halo_blur"],"text-halo-width":["halo_width"],"icon-halo-width":["halo_width"],"line-gap-width":["gapwidth"],"line-pattern":["pattern_to","pattern_from","pixel_ratio_to","pixel_ratio_from"],"fill-pattern":["pattern_to","pattern_from","pixel_ratio_to","pixel_ratio_from"],"fill-extrusion-pattern":["pattern_to","pattern_from","pixel_ratio_to","pixel_ratio_from"]}[s]||[s.replace(l+"-","").replace(/-/g,"_")],l=a.value,i=a.property.specification.type,n=a.property.useIntegerZoom,a="cross-faded"===(a=a.property.specification["property-type"])||"cross-faded-data-driven"===a,"constant"===l.kind?(this.binders[u]=a?new bo(l.value,s):new _o(l.value,s,i),c.push("/u_"+u)):"source"===l.kind||a?(o=Eo(u,i,"source"),this.binders[u]=a?new Co(l,i,n,t,o,e.id):new wo(l,s,i,o),c.push("/a_"+u)):(a=Eo(u,i,"composite"),this.binders[u]=new xo(l,s,i,n,t,a),c.push("/z_"+u)));this.cacheKey=c.sort().join("")}getMaxValue(e){e=this.binders[e];return e instanceof wo||e instanceof xo?e.maxValue:0}populatePaintArrays(e,t,r,i,n){for(const a in this.binders){var o=this.binders[a];(o instanceof wo||o instanceof xo||o instanceof Co)&&o.populatePaintArray(e,t,r,i,n)}}setConstantPatternPositions(e,t){for(const i in this.binders){var r=this.binders[i];r instanceof bo&&r.setConstantPatternPositions(e,t)}}updatePaintArrays(e,t,r,i,n){let o=!1;for(const c in e)for(const u of t.getPositions(c)){var a=r.feature(u.index);for(const h in this.binders){var s,l=this.binders[h];(l instanceof wo||l instanceof xo||l instanceof Co)&&!0===l.expression.isStateDependent&&(s=i.paint.get(h),l.expression=s.value,l.updatePaintArray(u.start,u.end,a,e[c],n),o=!0)}}return o}defines(){var e=[];for(const r in this.binders){var t=this.binders[r];(t instanceof _o||t instanceof bo)&&e.push(...t.uniformNames.map(e=>"#define HAS_UNIFORM_"+e))}return e}getBinderAttributes(){var t=[];for(const e in this.binders){var r=this.binders[e];if(r instanceof wo||r instanceof xo)for(let e=0;e<r.paintVertexAttributes.length;e++)t.push(r.paintVertexAttributes[e].name);else if(r instanceof Co)for(let e=0;e<oo.members.length;e++)t.push(oo.members[e].name)}return t}getBinderUniforms(){var e=[];for(const r in this.binders){var t=this.binders[r];if(t instanceof _o||t instanceof bo||t instanceof xo)for(const i of t.uniformNames)e.push(i)}return e}getPaintVertexBuffers(){return this._buffers}getUniforms(e,t){var r=[];for(const o in this.binders){var i,n=this.binders[o];if(n instanceof _o||n instanceof bo||n instanceof xo)for(const a of n.uniformNames)t[a]&&(i=n.getBinding(e,t[a],a),r.push({name:a,property:o,binding:i}))}return r}setUniforms(e,t,r,i){for(var{name:n,property:o,binding:a}of t)this.binders[o].setUniform(a,i,r.get(o),n)}updatePaintBuffers(e){this._buffers=[];for(const i in this.binders){var t,r=this.binders[i];e&&r instanceof Co?(t=2===e.fromScale?r.zoomInPaintVertexBuffer:r.zoomOutPaintVertexBuffer)&&this._buffers.push(t):(r instanceof wo||r instanceof xo)&&r.paintVertexBuffer&&this._buffers.push(r.paintVertexBuffer)}}upload(e){for(const r in this.binders){var t=this.binders[r];(t instanceof wo||t instanceof xo||t instanceof Co)&&t.upload(e)}this.updatePaintBuffers()}destroy(){for(const t in this.binders){var e=this.binders[t];(e instanceof wo||e instanceof xo||e instanceof Co)&&e.destroy()}}}class So{constructor(e,t,r=()=>!0){this.programConfigurations={};for(const i of e)this.programConfigurations[i.id]=new To(i,t,r);this.needsUpload=!1,this._featureMap=new co,this._bufferOffset=0}populatePaintArrays(e,t,r,i,n,o){for(const a in this.programConfigurations)this.programConfigurations[a].populatePaintArrays(e,t,i,n,o);void 0!==t.id&&this._featureMap.add(t.id,r,this._bufferOffset,e),this._bufferOffset=e,this.needsUpload=!0}updatePaintArrays(e,t,r,i){for(const n of r)this.needsUpload=this.programConfigurations[n.id].updatePaintArrays(e,this._featureMap,t,n,i)||this.needsUpload}get(e){return this.programConfigurations[e]}upload(e){if(this.needsUpload){for(const t in this.programConfigurations)this.programConfigurations[t].upload(e);this.needsUpload=!1}}destroy(){for(const e in this.programConfigurations)this.programConfigurations[e].destroy()}}function Eo(e,t,r){var i={color:{source:pn,composite:Pn},number:{source:Sn,composite:pn}},e=(e=e,{"line-pattern":{source:Yn,composite:Yn},"fill-pattern":{source:Yn,composite:Yn},"fill-extrusion-pattern":{source:Yn,composite:Yn}}[e]);return e&&e[r]||i[t][r]}r("ConstantBinder",_o),r("CrossFadedConstantBinder",bo),r("SourceExpressionBinder",wo),r("CrossFadedCompositeBinder",Co),r("CompositeExpressionBinder",xo),r("ProgramConfiguration",To,{omit:["_buffers"]}),r("ProgramConfigurationSet",So);const de=8192;const Io=Math.pow(2,14)-1,Ao=-Io-1;function ko(e){var t=de/e.extent,r=e.loadGeometry();for(let e=0;e<r.length;e++){var i=r[e];for(let e=0;e<i.length;e++){var n=i[e],o=Math.round(n.x*t),a=Math.round(n.y*t);n.x=j(o,Ao,Io),n.y=j(a,Ao,Io),(o<n.x||o>n.x+1||a<n.y||a>n.y+1)&&he("Geometry exceeds allowed extent, reduce your vector tile buffer size")}}return r}function Po(e,t){return{type:e.type,id:e.id,properties:e.properties,geometry:t?ko(e):[]}}function Mo(e,t,r,i,n){e.emplaceBack(2*t+(i+1)/2,2*r+(n+1)/2)}class Ro{constructor(e){this.zoom=e.zoom,this.overscaling=e.overscaling,this.layers=e.layers,this.layerIds=this.layers.map(e=>e.id),this.index=e.index,this.hasPattern=!1,this.layoutVertexArray=new Vn,this.indexArray=new to,this.segments=new x,this.programConfigurations=new So(e.layers,e.zoom),this.stateDependentLayerIds=this.layers.filter(e=>e.isStateDependent()).map(e=>e.id)}populate(e,t,r){var i,n,o,a,s=this.layers[0],l=[];let c=null,u=!1;"circle"===s.type&&(c=s.layout.get("circle-sort-key"),u=!c.isConstant());for({feature:i,id:n,index:o,sourceLayerIndex:a}of e){var h,d=this.layers[0]._featureFilter.needGeometry,p=Po(i,d);this.layers[0]._featureFilter.filter(new P(this.zoom),p,r)&&(h=u?c.evaluate(p,{},r):void 0,d={id:n,properties:i.properties,type:i.type,sourceLayerIndex:a,index:o,geometry:d?p.geometry:ko(i),patterns:{},sortKey:h},l.push(d))}u&&l.sort((e,t)=>e.sortKey-t.sortKey);for(const v of l){var{geometry:f,index:m,sourceLayerIndex:g}=v,y=e[m].feature;this.addFeature(v,f,m,r),t.featureIndex.insert(y,f,m,g,this.index)}}update(e,t,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(e,t,this.stateDependentLayers,r)}isEmpty(){return 0===this.layoutVertexArray.length}uploadPending(){return!this.uploaded||this.programConfigurations.needsUpload}upload(e){this.uploaded||(this.layoutVertexBuffer=e.createVertexBuffer(this.layoutVertexArray,io),this.indexBuffer=e.createIndexBuffer(this.indexArray)),this.programConfigurations.upload(e),this.uploaded=!0}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy())}addFeature(e,t,r,i){for(const s of t)for(const l of s){var n=l.x,o=l.y;if(!(n<0||n>=de||o<0||o>=de)){var a=this.segments.prepareSegment(4,this.layoutVertexArray,this.indexArray,e.sortKey);const r=a.vertexLength;Mo(this.layoutVertexArray,n,o,-1,-1),Mo(this.layoutVertexArray,n,o,1,-1),Mo(this.layoutVertexArray,n,o,1,1),Mo(this.layoutVertexArray,n,o,-1,1),this.indexArray.emplaceBack(r,r+1,r+2),this.indexArray.emplaceBack(r,r+3,r+2),a.vertexLength+=4,a.primitiveLength+=2}}this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,e,r,{},i)}}function Oo(t,r){for(let e=0;e<t.length;e++)if(Uo(r,t[e]))return!0;for(let e=0;e<r.length;e++)if(Uo(t,r[e]))return!0;return!!zo(t,r)}function Lo(t,r){if(1===t.length)return Fo(r,t[0]);for(let e=0;e<r.length;e++){var i=r[e];for(let e=0;e<i.length;e++)if(Uo(t,i[e]))return!0}for(let e=0;e<t.length;e++)if(Fo(r,t[e]))return!0;for(let e=0;e<r.length;e++)if(zo(t,r[e]))return!0;return!1}function Do(t,r,i){for(let e=0;e<r.length;e++){var n=r[e];if(3<=t.length)for(let e=0;e<n.length;e++)if(Uo(t,n[e]))return!0;if(function(t,r,i){if(1<t.length){if(zo(t,r))return 1;for(let e=0;e<r.length;e++)if(No(r[e],t,i))return 1}for(let e=0;e<t.length;e++)if(No(t[e],r,i))return 1;return}(t,n,i))return!0}return!1}function zo(t,r){var i,n;if(0!==t.length&&0!==r.length)for(let e=0;e<t.length-1;e++){var o=t[e],a=t[e+1];for(let e=0;e<r.length-1;e++){var s=r[e],l=r[e+1];if(n=a,$(i=o,s=s,l=l)!==$(n,s,l)&&$(i,n,s)!==$(i,n,l))return 1}}}function No(t,r,e){var i=e*e;if(1===r.length)return t.distSqr(r[0])<i;for(let e=1;e<r.length;e++)if(Bo(t,r[e-1],r[e])<i)return 1}function Bo(e,t,r){var i=t.distSqr(r);return 0===i||(i=((e.x-t.x)*(r.x-t.x)+(e.y-t.y)*(r.y-t.y))/i)<0?e.distSqr(t):1<i?e.distSqr(r):e.distSqr(r.sub(t)._mult(i)._add(t))}function Fo(i,n){let o=!1,a,s,l;for(let r=0;r<i.length;r++)for(let e=0,t=(a=i[r]).length-1;e<a.length;t=e++)s=a[e],l=a[t],s.y>n.y!=l.y>n.y&&n.x<(l.x-s.x)*(n.y-s.y)/(l.y-s.y)+s.x&&(o=!o);return o}function Uo(r,i){let n=!1;for(let e=0,t=r.length-1;e<r.length;t=e++){var o=r[e],a=r[t];o.y>i.y!=a.y>i.y&&i.x<(a.x-o.x)*(i.y-o.y)/(a.y-o.y)+o.x&&(n=!n)}return n}function qo(t,e,r,i,n){for(const a of t)if(e<=a.x&&r<=a.y&&i>=a.x&&n>=a.y)return!0;var o=[new B(e,r),new B(e,n),new B(i,n),new B(i,r)];if(2<t.length)for(const s of o)if(Uo(t,s))return!0;for(let e=0;e<t.length-1;e++)if(function(e,t,r){var i=r[0],n=r[2];if(e.x<i.x&&t.x<i.x||e.x>n.x&&t.x>n.x||e.y<i.y&&t.y<i.y||e.y>n.y&&t.y>n.y)return;i=$(e,t,r[0]);return i!==$(e,t,r[1])||i!==$(e,t,r[2])||i!==$(e,t,r[3])}(t[e],t[e+1],o))return!0;return!1}function jo(e,t,r){var i=t.paint.get(e).value;return"constant"===i.kind?i.value:r.programConfigurations.get(t.id).getMaxValue(e)}function Ho(e){return Math.sqrt(e[0]*e[0]+e[1]*e[1])}function Vo(t,e,r,i,n){if(!e[0]&&!e[1])return t;var o=B.convert(e)._mult(n),a=("viewport"===r&&o._rotate(-i),[]);for(let e=0;e<t.length;e++){var s=t[e];a.push(s.sub(o))}return a}r("CircleBucket",Ro,{omit:["layers"]});let Go;let Ko;var Zo={get paint(){return Ko=Ko||new a({"circle-radius":new n(o.paint_circle["circle-radius"]),"circle-color":new n(o.paint_circle["circle-color"]),"circle-blur":new n(o.paint_circle["circle-blur"]),"circle-opacity":new n(o.paint_circle["circle-opacity"]),"circle-translate":new i(o.paint_circle["circle-translate"]),"circle-translate-anchor":new i(o.paint_circle["circle-translate-anchor"]),"circle-pitch-scale":new i(o.paint_circle["circle-pitch-scale"]),"circle-pitch-alignment":new i(o.paint_circle["circle-pitch-alignment"]),"circle-stroke-width":new n(o.paint_circle["circle-stroke-width"]),"circle-stroke-color":new n(o.paint_circle["circle-stroke-color"]),"circle-stroke-opacity":new n(o.paint_circle["circle-stroke-opacity"])})},get layout(){return Go=Go||new a({"circle-sort-key":new n(o.layout_circle["circle-sort-key"])})}},R=1e-6,C="undefined"!=typeof Float32Array?Float32Array:Array;function Wo(){var e=new C(9);return C!=Float32Array&&(e[1]=0,e[2]=0,e[3]=0,e[5]=0,e[6]=0,e[7]=0),e[0]=1,e[4]=1,e[8]=1,e}function Yo(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e}function $o(e,t,r){var i=t[0],n=t[1],o=t[2],a=t[3],s=t[4],l=t[5],c=t[6],u=t[7],h=t[8],d=t[9],p=t[10],f=t[11],m=t[12],g=t[13],y=t[14],t=t[15],v=r[0],_=r[1],b=r[2],w=r[3];return e[0]=v*i+_*s+b*h+w*m,e[1]=v*n+_*l+b*d+w*g,e[2]=v*o+_*c+b*p+w*y,e[3]=v*a+_*u+b*f+w*t,v=r[4],_=r[5],b=r[6],w=r[7],e[4]=v*i+_*s+b*h+w*m,e[5]=v*n+_*l+b*d+w*g,e[6]=v*o+_*c+b*p+w*y,e[7]=v*a+_*u+b*f+w*t,v=r[8],_=r[9],b=r[10],w=r[11],e[8]=v*i+_*s+b*h+w*m,e[9]=v*n+_*l+b*d+w*g,e[10]=v*o+_*c+b*p+w*y,e[11]=v*a+_*u+b*f+w*t,v=r[12],_=r[13],b=r[14],w=r[15],e[12]=v*i+_*s+b*h+w*m,e[13]=v*n+_*l+b*d+w*g,e[14]=v*o+_*c+b*p+w*y,e[15]=v*a+_*u+b*f+w*t,e}Math.hypot||(Math.hypot=function(){for(var e=0,t=arguments.length;t--;)e+=arguments[t]*arguments[t];return Math.sqrt(e)});function Xo(e,t,r,i,n){return t=1/Math.tan(t/2),e[0]=t/r,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=t,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[11]=-1,e[12]=0,e[13]=0,e[15]=0,null!=n&&n!==1/0?(e[10]=(n+i)*(r=1/(i-n)),e[14]=2*n*i*r):(e[10]=-1,e[14]=-2*i),e}function Jo(e,t,r,i,n,o,a){var s=1/(t-r),l=1/(i-n),c=1/(o-a);return e[0]=-2*s,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=-2*l,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=2*c,e[11]=0,e[12]=(t+r)*s,e[13]=(n+i)*l,e[14]=(a+o)*c,e[15]=1,e}br=$o;function Qo(){var e=new C(3);return C!=Float32Array&&(e[0]=0,e[1]=0,e[2]=0),e}function ea(e,t,r){var i=new C(3);return i[0]=e,i[1]=t,i[2]=r,i}function ta(e,t){var r=t[0],i=t[1],n=t[2],r=r*r+i*i+n*n;return 0<r&&(r=1/Math.sqrt(r)),e[0]=t[0]*r,e[1]=t[1]*r,e[2]=t[2]*r,e}function ra(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]}function ia(e,t,r){var i=t[0],n=t[1],t=t[2],o=r[0],a=r[1],r=r[2];return e[0]=n*r-t*a,e[1]=t*o-i*r,e[2]=i*a-n*o,e}function na(e,t,r){return e[0]=t[0]-r[0],e[1]=t[1]-r[1],e[2]=t[2]-r[2],e}function oa(e,t,r){var i=t[0],n=t[1],o=t[2],t=t[3];return e[0]=r[0]*i+r[4]*n+r[8]*o+r[12]*t,e[1]=r[1]*i+r[5]*n+r[9]*o+r[13]*t,e[2]=r[2]*i+r[6]*n+r[10]*o+r[14]*t,e[3]=r[3]*i+r[7]*n+r[11]*o+r[15]*t,e}Qo();function aa(e,t,r){return e[0]=t[0]*r[0],e[1]=t[1]*r[1],e[2]=t[2]*r[2],e[3]=t[3]*r[3],e}function sa(){var e=new C(4);return C!=Float32Array&&(e[0]=0,e[1]=0,e[2]=0),e[3]=1,e}_r=new C(4),C!=Float32Array&&(_r[0]=0,_r[1]=0,_r[2]=0,_r[3]=0);Qo(),ea(1,0,0),ea(0,1,0),sa(),sa(),Wo();function la(e){var t=e[0],e=e[1];return t*t+e*e}t=new C(2),C!=Float32Array&&(t[0]=0,t[1]=0);class ca extends nn{constructor(e){super(e,Zo)}createBucket(e){return new Ro(e)}queryRadius(e){return jo("circle-radius",this,e)+jo("circle-stroke-width",this,e)+Ho(this.paint.get("circle-translate"))}queryIntersectsFeature(e,t,r,i,n,o,a,s){var l,c,e=Vo(e,this.paint.get("circle-translate"),this.paint.get("circle-translate-anchor"),o.angle,a),t=this.paint.get("circle-radius").evaluate(t,r)+this.paint.get("circle-stroke-width").evaluate(t,r),u="map"===this.paint.get("circle-pitch-alignment"),h=u?e:(l=s,e.map(e=>ua(e,l))),d=u?t*a:t;for(const m of i)for(const g of m){var p=u?g:ua(g,s);let e=d;var f=oa([],[g.x,g.y,0,1],s);if("viewport"===this.paint.get("circle-pitch-scale")&&"map"===this.paint.get("circle-pitch-alignment")?e*=f[3]/o.cameraToCenterDistance:"map"===this.paint.get("circle-pitch-scale")&&"viewport"===this.paint.get("circle-pitch-alignment")&&(e*=o.cameraToCenterDistance/f[3]),f=h,p=p,c=e,Uo(f,p)||!!No(p,f,c))return!0}return!1}}function ua(e,t){e=oa([],[e.x,e.y,0,1],t);return new B(e[0]/e[3],e[1]/e[3])}class ha extends Ro{}r("HeatmapBucket",ha,{omit:["layers"]});let da;var pa={get paint(){return da=da||new a({"heatmap-radius":new n(o.paint_heatmap["heatmap-radius"]),"heatmap-weight":new n(o.paint_heatmap["heatmap-weight"]),"heatmap-intensity":new i(o.paint_heatmap["heatmap-intensity"]),"heatmap-color":new tn(o.paint_heatmap["heatmap-color"]),"heatmap-opacity":new i(o.paint_heatmap["heatmap-opacity"])})}};function fa(e,{width:t,height:r},i,n){if(n){if(n instanceof Uint8ClampedArray)n=new Uint8Array(n.buffer);else if(n.length!==t*r*i)throw new RangeError(`mismatched image size. expected: ${n.length} but got: `+t*r*i)}else n=new Uint8Array(t*r*i);return e.width=t,e.height=r,e.data=n,e}function ma(e,{width:t,height:r},i){var n;t===e.width&&r===e.height||(ga(e,n=fa({},{width:t,height:r},i),{x:0,y:0},{x:0,y:0},{width:Math.min(e.width,t),height:Math.min(e.height,r)},i),e.width=t,e.height=r,e.data=n.data)}function ga(t,r,i,n,o,a){if(0!==o.width&&0!==o.height){if(o.width>t.width||o.height>t.height||i.x>t.width-o.width||i.y>t.height-o.height)throw new RangeError("out of range source coordinates for image copy");if(o.width>r.width||o.height>r.height||n.x>r.width-o.width||n.y>r.height-o.height)throw new RangeError("out of range destination coordinates for image copy");var s=t.data,l=r.data;if(s===l)throw new Error("srcData equals dstData, so image is already copied");for(let e=0;e<o.height;e++){var c=((i.y+e)*t.width+i.x)*a,u=((n.y+e)*r.width+n.x)*a;for(let e=0;e<o.width*a;e++)l[u+e]=s[c+e]}}}class ya{constructor(e,t){fa(this,e,1,t)}resize(e){ma(this,e,1)}clone(){return new ya({width:this.width,height:this.height},new Uint8Array(this.data))}static copy(e,t,r,i,n){ga(e,t,r,i,n,1)}}class va{constructor(e,t){fa(this,e,4,t)}resize(e){ma(this,e,4)}replace(e,t){t?this.data.set(e):e instanceof Uint8ClampedArray?this.data=new Uint8Array(e.buffer):this.data=e}clone(){return new va({width:this.width,height:this.height},new Uint8Array(this.data))}static copy(e,t,r,i,n){ga(e,t,r,i,n,4)}}function _a(n){const i={};var o=n.resolution||256,e=n.clips?n.clips.length:1;const a=n.image||new va({width:o,height:e});if(Math.log(o)/Math.LN2%1!=0)throw new Error("width is not a power of 2 - "+o);var s=(e,t,r)=>{i[n.evaluationKey]=r;r=n.expression.evaluate(i);a.data[e+t+0]=Math.floor(255*r.r/r.a),a.data[e+t+1]=Math.floor(255*r.g/r.a),a.data[e+t+2]=Math.floor(255*r.b/r.a),a.data[e+t+3]=Math.floor(255*r.a)};if(n.clips)for(let r=0,i=0;r<e;++r,i+=4*o)for(let e=0,t=0;e<o;e++,t+=4){var l=e/(o-1),{start:c,end:u}=n.clips[r];s(i,t,c*(1-l)+u*l)}else for(let e=0,t=0;e<o;e++,t+=4){var r=e/(o-1);s(0,t,r)}return a}r("AlphaImage",ya),r("RGBAImage",va);class ba extends nn{createBucket(e){return new ha(e)}constructor(e){super(e,pa),this._updateColorRamp()}_handleSpecialPaintPropertyUpdate(e){"heatmap-color"===e&&this._updateColorRamp()}_updateColorRamp(){var e=this._transitionablePaint._values["heatmap-color"].value.expression;this.colorRamp=_a({expression:e,evaluationKey:"heatmapDensity",image:this.colorRamp}),this.colorRampTexture=null}resize(){this.heatmapFbo&&(this.heatmapFbo.destroy(),this.heatmapFbo=null)}queryRadius(){return 0}queryIntersectsFeature(){return!1}hasOffscreenPass(){return 0!==this.paint.get("heatmap-opacity")&&"none"!==this.visibility}}let wa;var xa={get paint(){return wa=wa||new a({"hillshade-illumination-direction":new i(o.paint_hillshade["hillshade-illumination-direction"]),"hillshade-illumination-anchor":new i(o.paint_hillshade["hillshade-illumination-anchor"]),"hillshade-exaggeration":new i(o.paint_hillshade["hillshade-exaggeration"]),"hillshade-shadow-color":new i(o.paint_hillshade["hillshade-shadow-color"]),"hillshade-highlight-color":new i(o.paint_hillshade["hillshade-highlight-color"]),"hillshade-accent-color":new i(o.paint_hillshade["hillshade-accent-color"])})}};class Ca extends nn{constructor(e){super(e,xa)}hasOffscreenPass(){return 0!==this.paint.get("hillshade-exaggeration")&&"none"!==this.visibility}}const Ta=c([{name:"a_pos",components:2,type:"Int16"}],4)["members"];e={exports:{}};function Sa(e,t,r){r=r||2;var i,n,o,a,s,l=t&&t.length,c=l?t[0]*r:e.length,u=Ea(e,0,c,r,!0),h=[];if(u&&u.next!==u.prev){if(l&&(u=function(e,t,r,i){var n,o,a,s,l=[];for(n=0,o=t.length;n<o;n++)s=t[n]*i,a=n<o-1?t[n+1]*i:e.length,(s=Ea(e,s,a,i,!1))===s.next&&(s.steiner=!0),l.push(function(e){var t=e,r=e;for(;(t.x<r.x||t.x===r.x&&t.y<r.y)&&(r=t),t=t.next,t!==e;);return r}(s));for(l.sort(ka),n=0;n<l.length;n++)r=function(e,t){var r=function(e,t){var r,i=t,n=e.x,o=e.y,a=-1/0;do{if(o<=i.y&&o>=i.next.y&&i.next.y!==i.y){var s=i.x+(o-i.y)*(i.next.x-i.x)/(i.next.y-i.y);if(s<=n&&a<s&&(a=s,r=i.x<i.next.x?i:i.next,s===n))return r}}while(i=i.next,i!==t);if(!r)return null;var l,c=r,u=r.x,h=r.y,d=1/0;i=r;for(;n>=i.x&&i.x>=u&&n!==i.x&&Ma(o<h?n:a,o,u,h,o<h?a:n,o,i.x,i.y)&&(l=Math.abs(o-i.y)/(n-i.x),za(i,e))&&(l<d||l===d&&(i.x>r.x||i.x===r.x&&function(e,t){return S(e.prev,e,t.prev)<0&&S(t.next,e,e.next)<0}(r,i)))&&(r=i,d=l),i=i.next,i!==c;);return r}(e,t);return r?(Ia(e=Na(r,e),e.next),Ia(r,r.next)):t}(l[n],r);return r}(e,t,u,r)),e.length>80*r){for(var d=i=e[0],p=n=e[1],f=r;f<c;f+=r)(o=e[f])<d&&(d=o),(a=e[f+1])<p&&(p=a),i<o&&(i=o),n<a&&(n=a);s=0!==(s=Math.max(i-d,n-p))?32767/s:0}Aa(u,h,r,d,p,s,0)}return h}function Ea(e,t,r,i,n){var o,a;if(n===0<qa(e,t,r,i))for(o=t;o<r;o+=i)a=Ba(o,e[o],e[o+1],a);else for(o=r-i;t<=o;o-=i)a=Ba(o,e[o],e[o+1],a);return a&&Ra(a,a.next)&&(Fa(a),a=a.next),a}function Ia(e,t){if(!e)return e;t=t||e;var r,i=e;do{if(r=!1,i.steiner||!Ra(i,i.next)&&0!==S(i.prev,i,i.next))i=i.next;else{if(Fa(i),(i=t=i.prev)===i.next)break;r=!0}}while(r||i!==t);return t}function Aa(e,t,r,i,n,o,a){if(e){if(!a&&o){for(var s=e,l=i,c=n,u=o,h=s;0===h.z&&(h.z=Pa(h.x,h.y,l,c,u)),h.prevZ=h.prev,h.nextZ=h.next,(h=h.next)!==s;);h.prevZ.nextZ=null,h.prevZ=null;var d,p,f,m,g,y,v,_,b=h,w=1;do{for(p=b,g=b=null,y=0;p;){for(y++,f=p,d=v=0;d<w&&(v++,f=f.nextZ);d++);for(_=w;0<v||0<_&&f;)0!==v&&(0===_||!f||p.z<=f.z)?(p=(m=p).nextZ,v--):(f=(m=f).nextZ,_--),g?g.nextZ=m:b=m,m.prevZ=g,g=m;p=f}}while(g.nextZ=null,w*=2,1<y)}for(var x,C,T=e;e.prev!==e.next;)if(x=e.prev,C=e.next,o?function(e,t,r,i){var n=e.prev,o=e,a=e.next;if(0<=S(n,o,a))return;var s=n.x,l=o.x,c=a.x,u=n.y,h=o.y,d=a.y,p=s<l?s<c?s:c:l<c?l:c,f=u<h?u<d?u:d:h<d?h:d,m=l<s?c<s?s:c:c<l?l:c,g=h<u?d<u?u:d:d<h?h:d,y=Pa(p,f,t,r,i),v=Pa(m,g,t,r,i),_=e.prevZ,b=e.nextZ;for(;_&&_.z>=y&&b&&b.z<=v;){if(_.x>=p&&_.x<=m&&_.y>=f&&_.y<=g&&_!==n&&_!==a&&Ma(s,u,l,h,c,d,_.x,_.y)&&0<=S(_.prev,_,_.next))return;if(_=_.prevZ,b.x>=p&&b.x<=m&&b.y>=f&&b.y<=g&&b!==n&&b!==a&&Ma(s,u,l,h,c,d,b.x,b.y)&&0<=S(b.prev,b,b.next))return;b=b.nextZ}for(;_&&_.z>=y;){if(_.x>=p&&_.x<=m&&_.y>=f&&_.y<=g&&_!==n&&_!==a&&Ma(s,u,l,h,c,d,_.x,_.y)&&0<=S(_.prev,_,_.next))return;_=_.prevZ}for(;b&&b.z<=v;){if(b.x>=p&&b.x<=m&&b.y>=f&&b.y<=g&&b!==n&&b!==a&&Ma(s,u,l,h,c,d,b.x,b.y)&&0<=S(b.prev,b,b.next))return;b=b.nextZ}return 1}(e,i,n,o):function(e){var t=e.prev,r=e,e=e.next;if(0<=S(t,r,e))return;var i=t.x,n=r.x,o=e.x,a=t.y,s=r.y,l=e.y,c=i<n?i<o?i:o:n<o?n:o,u=a<s?a<l?a:l:s<l?s:l,h=n<i?o<i?i:o:o<n?n:o,d=s<a?l<a?a:l:l<s?s:l,p=e.next;for(;p!==t;){if(p.x>=c&&p.x<=h&&p.y>=u&&p.y<=d&&Ma(i,a,n,s,o,l,p.x,p.y)&&0<=S(p.prev,p,p.next))return;p=p.next}return 1}(e))t.push(x.i/r|0),t.push(e.i/r|0),t.push(C.i/r|0),Fa(e),e=C.next,T=C.next;else if((e=C)===T){a?1===a?Aa(e=function(e,t,r){var i=e;do{var n=i.prev,o=i.next.next}while(!Ra(n,o)&&Oa(n,i,i.next,o)&&za(n,o)&&za(o,n)&&(t.push(n.i/r|0),t.push(i.i/r|0),t.push(o.i/r|0),Fa(i),Fa(i.next),i=e=o),i=i.next,i!==e);return Ia(i)}(Ia(e),t,r),t,r,i,n,o,2):2===a&&function(e,t,r,i,n,o){var a=e;do{for(var s,l=a.next.next;l!==a.prev;){if(a.i!==l.i&&function(e,t){return e.next.i!==t.i&&e.prev.i!==t.i&&!function(e,t){var r=e;do{if(r.i!==e.i&&r.next.i!==e.i&&r.i!==t.i&&r.next.i!==t.i&&Oa(r,r.next,e,t))return 1}while(r=r.next,r!==e);return}(e,t)&&(za(e,t)&&za(t,e)&&function(e,t){var r=e,i=!1,n=(e.x+t.x)/2,o=(e.y+t.y)/2;for(;r.y>o!=r.next.y>o&&r.next.y!==r.y&&n<(r.next.x-r.x)*(o-r.y)/(r.next.y-r.y)+r.x&&(i=!i),r=r.next,r!==e;);return i}(e,t)&&(S(e.prev,e,t.prev)||S(e,t.prev,t))||Ra(e,t)&&0<S(e.prev,e,e.next)&&0<S(t.prev,t,t.next))}(a,l))return s=Na(a,l),a=Ia(a,a.next),s=Ia(s,s.next),Aa(a,t,r,i,n,o,0),Aa(s,t,r,i,n,o,0);l=l.next}}while(a=a.next,a!==e)}(e,t,r,i,n,o):Aa(Ia(e),t,r,i,n,o,1);break}}}function ka(e,t){return e.x-t.x}function Pa(e,t,r,i,n){return(e=1431655765&((e=858993459&((e=252645135&((e=16711935&((e=(e-r)*n|0)|e<<8))|e<<4))|e<<2))|e<<1))|(t=1431655765&((t=858993459&((t=252645135&((t=16711935&((t=(t-i)*n|0)|t<<8))|t<<4))|t<<2))|t<<1))<<1}function Ma(e,t,r,i,n,o,a,s){return(e-a)*(o-s)<=(n-a)*(t-s)&&(r-a)*(t-s)<=(e-a)*(i-s)&&(n-a)*(i-s)<=(r-a)*(o-s)}function S(e,t,r){return(t.y-e.y)*(r.x-t.x)-(t.x-e.x)*(r.y-t.y)}function Ra(e,t){return e.x===t.x&&e.y===t.y}function Oa(e,t,r,i){var n=Da(S(e,t,r)),o=Da(S(e,t,i)),a=Da(S(r,i,e)),s=Da(S(r,i,t));return n!==o&&a!==s||0===n&&La(e,r,t)||0===o&&La(e,i,t)||0===a&&La(r,e,i)||!(0!==s||!La(r,t,i))}function La(e,t,r){return t.x<=Math.max(e.x,r.x)&&t.x>=Math.min(e.x,r.x)&&t.y<=Math.max(e.y,r.y)&&t.y>=Math.min(e.y,r.y)}function Da(e){return 0<e?1:e<0?-1:0}function za(e,t){return S(e.prev,e,e.next)<0?0<=S(e,t,e.next)&&0<=S(e,e.prev,t):S(e,t,e.prev)<0||S(e,e.next,t)<0}function Na(e,t){var r=new Ua(e.i,e.x,e.y),i=new Ua(t.i,t.x,t.y),n=e.next,o=t.prev;return(e.next=t).prev=e,(r.next=n).prev=r,(i.next=r).prev=i,(o.next=i).prev=o,i}function Ba(e,t,r,i){e=new Ua(e,t,r);return i?(e.next=i.next,(e.prev=i).next.prev=e,i.next=e):(e.prev=e).next=e,e}function Fa(e){e.next.prev=e.prev,e.prev.next=e.next,e.prevZ&&(e.prevZ.nextZ=e.nextZ),e.nextZ&&(e.nextZ.prevZ=e.prevZ)}function Ua(e,t,r){this.i=e,this.x=t,this.y=r,this.prev=null,this.next=null,this.z=0,this.prevZ=null,this.nextZ=null,this.steiner=!1}function qa(e,t,r,i){for(var n=0,o=t,a=r-i;o<r;o+=i)n+=(e[a]-e[o])*(e[o+1]+e[a+1]),a=o;return n}e.exports=Sa,(e.exports.default=Sa).deviation=function(e,t,r,i){var n=t&&t.length,o=n?t[0]*r:e.length,a=Math.abs(qa(e,0,o,r));if(n)for(var s=0,l=t.length;s<l;s++){var c=t[s]*r,u=s<l-1?t[s+1]*r:e.length;a-=Math.abs(qa(e,c,u,r))}for(var h=0,s=0;s<i.length;s+=3){var d=i[s]*r,p=i[s+1]*r,f=i[s+2]*r;h+=Math.abs((e[d]-e[f])*(e[1+p]-e[1+d])-(e[d]-e[p])*(e[1+f]-e[1+d]))}return 0===a&&0===h?0:Math.abs((h-a)/a)},Sa.flatten=function(e){for(var t=e[0][0].length,r={vertices:[],holes:[],dimensions:t},i=0,n=0;n<e.length;n++){for(var o=0;o<e[n].length;o++)for(var a=0;a<t;a++)r.vertices.push(e[n][o][a]);0<n&&(i+=e[n-1].length,r.holes.push(i))}return r};var ja=I(e.exports);function Ha(e,t,r,i,n){!function e(t,r,i,n,o){for(;i<n;){600<n-i&&(a=n-i+1,u=r-i+1,l=Math.log(a),s=.5*Math.exp(2*l/3),l=.5*Math.sqrt(l*s*(a-s)/a)*(u-a/2<0?-1:1),c=Math.max(i,Math.floor(r-u*s/a+l)),u=Math.min(n,Math.floor(r+(a-u)*s/a+l)),e(t,r,c,u,o));var a,s,l,c,u,h=t[r],d=i,p=n;for(Va(t,i,r),0<o(t[n],h)&&Va(t,i,n);d<p;){for(Va(t,d,p),d++,p--;o(t[d],h)<0;)d++;for(;0<o(t[p],h);)p--}0===o(t[i],h)?Va(t,i,p):Va(t,++p,n),p<=r&&(i=p+1),r<=p&&(n=p-1)}}(e,t,r||0,i||e.length-1,n||Ga)}function Va(e,t,r){var i=e[t];e[t]=e[r],e[r]=i}function Ga(e,t){return e<t?-1:t<e?1:0}function Ka(t,r){var i=t.length;if(i<=1)return[t];var n=[];let o,a;for(let e=0;e<i;e++){var s=function(o){let a=0;for(let e=0,t=o.length,r=t-1,i,n;e<t;r=e++)i=o[e],n=o[r],a+=(n.x-i.x)*(i.y+n.y);return a}(t[e]);0!==s&&(t[e].area=Math.abs(s),(a=void 0===a?s<0:a)===s<0?(o&&n.push(o),o=[t[e]]):o.push(t[e]))}if(o&&n.push(o),1<r)for(let e=0;e<n.length;e++)n[e].length<=r||(Ha(n[e],r,1,n[e].length-1,Za),n[e]=n[e].slice(0,r));return n}function Za(e,t){return t.area-e.area}function Wa(e,t,r){var i=r.patternDependencies;let n=!1;for(const a of t){var o=a.paint.get(e+"-pattern"),o=(o.isConstant()||(n=!0),o.constantOr(null));o&&(n=!0,i[o.to]=!0,i[o.from]=!0)}return n}function Ya(e,t,r,i,n){var o=n.patternDependencies;for(const c of t){var a,s,l=c.paint.get(e+"-pattern").value;"constant"!==l.kind&&(a=l.evaluate({zoom:i-1},r,{},n.availableImages),s=l.evaluate({zoom:i},r,{},n.availableImages),l=l.evaluate({zoom:i+1},r,{},n.availableImages),a=a&&a.name?a.name:a,s=s&&s.name?s.name:s,l=l&&l.name?l.name:l,o[a]=!0,o[s]=!0,o[l]=!0,r.patterns[c.id]={min:a,mid:s,max:l})}return r}class $a{constructor(e){this.zoom=e.zoom,this.overscaling=e.overscaling,this.layers=e.layers,this.layerIds=this.layers.map(e=>e.id),this.index=e.index,this.hasPattern=!1,this.patternFeatures=[],this.layoutVertexArray=new Gn,this.indexArray=new to,this.indexArray2=new ro,this.programConfigurations=new So(e.layers,e.zoom),this.segments=new x,this.segments2=new x,this.stateDependentLayerIds=this.layers.filter(e=>e.isStateDependent()).map(e=>e.id)}populate(e,t,r){this.hasPattern=Wa("fill",this.layers,t);var i,n,o,a,s=this.layers[0].layout.get("fill-sort-key"),l=!s.isConstant(),c=[];for({feature:i,id:n,index:o,sourceLayerIndex:a}of e){var u,h=this.layers[0]._featureFilter.needGeometry,d=Po(i,h);this.layers[0]._featureFilter.filter(new P(this.zoom),d,r)&&(u=l?s.evaluate(d,{},r,t.availableImages):void 0,h={id:n,properties:i.properties,type:i.type,sourceLayerIndex:a,index:o,geometry:h?d.geometry:ko(i),patterns:{},sortKey:u},c.push(h))}l&&c.sort((e,t)=>e.sortKey-t.sortKey);for(const y of c){var{geometry:p,index:f,sourceLayerIndex:m}=y,g=(this.hasPattern?(g=Ya("fill",this.layers,y,this.zoom,t),this.patternFeatures.push(g)):this.addFeature(y,p,f,r,{}),e[f].feature);t.featureIndex.insert(g,p,f,m,this.index)}}update(e,t,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(e,t,this.stateDependentLayers,r)}addFeatures(e,t,r){for(const i of this.patternFeatures)this.addFeature(i,i.geometry,i.index,t,r)}isEmpty(){return 0===this.layoutVertexArray.length}uploadPending(){return!this.uploaded||this.programConfigurations.needsUpload}upload(e){this.uploaded||(this.layoutVertexBuffer=e.createVertexBuffer(this.layoutVertexArray,Ta),this.indexBuffer=e.createIndexBuffer(this.indexArray),this.indexBuffer2=e.createIndexBuffer(this.indexArray2)),this.programConfigurations.upload(e),this.uploaded=!0}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.indexBuffer2.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.segments2.destroy())}addFeature(e,t,r,i,n){for(const d of Ka(t,500)){let e=0;for(const p of d)e+=p.length;var o=this.segments.prepareSegment(e,this.layoutVertexArray,this.indexArray),a=o.vertexLength,s=[],l=[];for(const f of d)if(0!==f.length){f!==d[0]&&l.push(s.length/2);var c=this.segments2.prepareSegment(f.length,this.layoutVertexArray,this.indexArray2),u=c.vertexLength;this.layoutVertexArray.emplaceBack(f[0].x,f[0].y),this.indexArray2.emplaceBack(u+f.length-1,u),s.push(f[0].x),s.push(f[0].y);for(let e=1;e<f.length;e++)this.layoutVertexArray.emplaceBack(f[e].x,f[e].y),this.indexArray2.emplaceBack(u+e-1,u+e),s.push(f[e].x),s.push(f[e].y);c.vertexLength+=f.length,c.primitiveLength+=f.length}var h=ja(s,l);for(let e=0;e<h.length;e+=3)this.indexArray.emplaceBack(a+h[e],a+h[e+1],a+h[e+2]);o.vertexLength+=e,o.primitiveLength+=h.length/3}this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,e,r,n,i)}}r("FillBucket",$a,{omit:["layers","patternFeatures"]});let Xa;let Ja;var Qa={get paint(){return Ja=Ja||new a({"fill-antialias":new i(o.paint_fill["fill-antialias"]),"fill-opacity":new n(o.paint_fill["fill-opacity"]),"fill-color":new n(o.paint_fill["fill-color"]),"fill-outline-color":new n(o.paint_fill["fill-outline-color"]),"fill-translate":new i(o.paint_fill["fill-translate"]),"fill-translate-anchor":new i(o.paint_fill["fill-translate-anchor"]),"fill-pattern":new Qi(o.paint_fill["fill-pattern"])})},get layout(){return Xa=Xa||new a({"fill-sort-key":new n(o.layout_fill["fill-sort-key"])})}};class es extends nn{constructor(e){super(e,Qa)}recalculate(e,t){super.recalculate(e,t);e=this.paint._values["fill-outline-color"];"constant"===e.value.kind&&void 0===e.value.value&&(this.paint._values["fill-outline-color"]=this.paint._values["fill-color"])}createBucket(e){return new $a(e)}queryRadius(){return Ho(this.paint.get("fill-translate"))}queryIntersectsFeature(e,t,r,i,n,o,a){return Lo(Vo(e,this.paint.get("fill-translate"),this.paint.get("fill-translate-anchor"),o.angle,a),i)}isTileClipped(){return!0}}_r=c([{name:"a_pos",components:2,type:"Int16"},{name:"a_normal_ed",components:4,type:"Int16"}],4);const ts=c([{name:"a_centroid",components:2,type:"Int16"}],4),rs=_r["members"];var is={},ns=A,t=os;function os(e,t,r,i,n){this.properties={},this.extent=r,this.type=0,this._pbf=e,this._geometry=-1,this._keys=i,this._values=n,e.readFields(as,this,t)}function as(e,t,r){if(1==e)t.id=r.readVarint();else if(2==e)for(var i=r,n=t,o=i.readVarint()+i.pos;i.pos<o;){var a=n._keys[i.readVarint()],s=n._values[i.readVarint()];n.properties[a]=s}else 3==e?t.type=r.readVarint():4==e&&(t._geometry=r.pos)}os.types=["Unknown","Point","LineString","Polygon"],os.prototype.loadGeometry=function(){for(var e,t,r=this._pbf,i=(r.pos=this._geometry,r.readVarint()+r.pos),n=1,o=0,a=0,s=0,l=[];r.pos<i;)if(o<=0&&(n=7&(t=r.readVarint()),o=t>>3),o--,1===n||2===n)a+=r.readSVarint(),s+=r.readSVarint(),1===n&&(e&&l.push(e),e=[]),e.push(new ns(a,s));else{if(7!==n)throw new Error("unknown command "+n);e&&e.push(e[0].clone())}return e&&l.push(e),l},os.prototype.bbox=function(){for(var e,t=this._pbf,r=(t.pos=this._geometry,t.readVarint()+t.pos),i=1,n=0,o=0,a=0,s=1/0,l=-1/0,c=1/0,u=-1/0;t.pos<r;)if(n<=0&&(i=7&(e=t.readVarint()),n=e>>3),n--,1===i||2===i)(o+=t.readSVarint())<s&&(s=o),l<o&&(l=o),(a+=t.readSVarint())<c&&(c=a),u<a&&(u=a);else if(7!==i)throw new Error("unknown command "+i);return[s,c,l,u]},os.prototype.toGeoJSON=function(e,t,r){var i,n=this.extent*Math.pow(2,r),o=this.extent*e,a=this.extent*t,s=this.loadGeometry(),r=os.types[this.type];function l(e){for(var t=0;t<e.length;t++){var r=e[t],i=180-360*(r.y+a)/n;e[t]=[360*(r.x+o)/n-180,360/Math.PI*Math.atan(Math.exp(i*Math.PI/180))-90]}}switch(this.type){case 1:for(var c=[],u=0;u<s.length;u++)c[u]=s[u][0];l(s=c);break;case 2:for(u=0;u<s.length;u++)l(s[u]);break;case 3:for(s=function(e){var t=e.length;if(t<=1)return[e];for(var r,i,n=[],o=0;o<t;o++){var a=function(e){for(var t,r,i=0,n=0,o=e.length,a=o-1;n<o;a=n++)t=e[n],r=e[a],i+=(r.x-t.x)*(t.y+r.y);return i}(e[o]);0!==a&&((i=void 0===i?a<0:i)===a<0?(r&&n.push(r),r=[e[o]]):r.push(e[o]))}r&&n.push(r);return n}(s),u=0;u<s.length;u++)for(i=0;i<s[u].length;i++)l(s[u][i])}1===s.length?s=s[0]:r="Multi"+r;e={type:"Feature",geometry:{type:r,coordinates:s},properties:this.properties};return"id"in this&&(e.id=this.id),e};var ss=t,e=ls;function ls(e,t){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=e,this._keys=[],this._values=[],this._features=[],e.readFields(cs,this,t),this.length=this._features.length}function cs(e,t,r){15===e?t.version=r.readVarint():1===e?t.name=r.readString():5===e?t.extent=r.readVarint():2===e?t._features.push(r.pos):3===e?t._keys.push(r.readString()):4===e&&t._values.push(function(e){var t=null,r=e.readVarint()+e.pos;for(;e.pos<r;){var i=e.readVarint()>>3;t=1==i?e.readString():2==i?e.readFloat():3==i?e.readDouble():4==i?e.readVarint64():5==i?e.readVarint():6==i?e.readSVarint():7==i?e.readBoolean():null}return t}(r))}ls.prototype.feature=function(e){if(e<0||e>=this._features.length)throw new Error("feature index out of bounds");this._pbf.pos=this._features[e];e=this._pbf.readVarint()+this._pbf.pos;return new ss(this._pbf,e,this.extent,this._keys,this._values)};var us=e;function hs(e,t,r){3===e&&(e=new us(r,r.readVarint()+r.pos)).length&&(t[e.name]=e)}is.VectorTile=function(e,t){this.layers=e.readFields(hs,{},t)},is.VectorTileFeature=t,is.VectorTileLayer=e;const ds=is.VectorTileFeature.types,ps=Math.pow(2,13);function fs(e,t,r,i,n,o,a,s){e.emplaceBack(t,r,2*Math.floor(i*ps)+a,n*ps*2,o*ps*2,Math.round(s))}class ms{constructor(e){this.zoom=e.zoom,this.overscaling=e.overscaling,this.layers=e.layers,this.layerIds=this.layers.map(e=>e.id),this.index=e.index,this.hasPattern=!1,this.layoutVertexArray=new Kn,this.centroidVertexArray=new Hn,this.indexArray=new to,this.programConfigurations=new So(e.layers,e.zoom),this.segments=new x,this.stateDependentLayerIds=this.layers.filter(e=>e.isStateDependent()).map(e=>e.id)}populate(e,t,r){this.features=[],this.hasPattern=Wa("fill-extrusion",this.layers,t);for(var{feature:i,id:n,index:o,sourceLayerIndex:a}of e){var s=this.layers[0]._featureFilter.needGeometry,l=Po(i,s);this.layers[0]._featureFilter.filter(new P(this.zoom),l,r)&&(n={id:n,sourceLayerIndex:a,index:o,geometry:s?l.geometry:ko(i),properties:i.properties,type:i.type,patterns:{}},this.hasPattern?this.features.push(Ya("fill-extrusion",this.layers,n,this.zoom,t)):this.addFeature(n,n.geometry,o,r,{}),t.featureIndex.insert(i,n.geometry,o,a,this.index,!0))}}addFeatures(e,t,r){for(const n of this.features){var i=n["geometry"];this.addFeature(n,i,n.index,t,r)}}update(e,t,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(e,t,this.stateDependentLayers,r)}isEmpty(){return 0===this.layoutVertexArray.length&&0===this.centroidVertexArray.length}uploadPending(){return!this.uploaded||this.programConfigurations.needsUpload}upload(e){this.uploaded||(this.layoutVertexBuffer=e.createVertexBuffer(this.layoutVertexArray,rs),this.centroidVertexBuffer=e.createVertexBuffer(this.centroidVertexArray,ts.members,!0),this.indexBuffer=e.createIndexBuffer(this.indexArray)),this.programConfigurations.upload(e),this.uploaded=!0}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.centroidVertexBuffer.destroy())}addFeature(t,e,r,i,n){var o,a={x:0,y:0,vertexCount:0};for(const g of Ka(e,500)){let e=0;for(const y of g)e+=y.length;let r=this.segments.prepareSegment(4,this.layoutVertexArray,this.indexArray);for(const v of g)if(0!==v.length&&!((o=v).every(e=>e.x<0)||o.every(e=>e.x>de)||o.every(e=>e.y<0)||o.every(e=>e.y>de))){let t=0;for(let e=0;e<v.length;e++){var s,l,c,u=v[e];1<=e&&(s=v[e-1],l=s,(c=u).x===l.x&&(c.x<0||c.x>de)||c.y===l.y&&(c.y<0||c.y>de)||(r.vertexLength+4>x.MAX_VERTEX_ARRAY_LENGTH&&(r=this.segments.prepareSegment(4,this.layoutVertexArray,this.indexArray)),l=u.sub(s)._perp()._unit(),c=s.dist(u),32768<t+c&&(t=0),fs(this.layoutVertexArray,u.x,u.y,l.x,l.y,0,0,t),fs(this.layoutVertexArray,u.x,u.y,l.x,l.y,0,1,t),a.x+=2*u.x,a.y+=2*u.y,a.vertexCount+=2,t+=c,fs(this.layoutVertexArray,s.x,s.y,l.x,l.y,0,0,t),fs(this.layoutVertexArray,s.x,s.y,l.x,l.y,0,1,t),a.x+=2*s.x,a.y+=2*s.y,a.vertexCount+=2,u=r.vertexLength,this.indexArray.emplaceBack(u,u+2,u+1),this.indexArray.emplaceBack(u+1,u+2,u+3),r.vertexLength+=4,r.primitiveLength+=2))}}if(r.vertexLength+e>x.MAX_VERTEX_ARRAY_LENGTH&&(r=this.segments.prepareSegment(e,this.layoutVertexArray,this.indexArray)),"Polygon"===ds[t.type]){var h=[],d=[],p=r.vertexLength;for(const _ of g)if(0!==_.length){_!==g[0]&&d.push(h.length/2);for(let e=0;e<_.length;e++){var f=_[e];fs(this.layoutVertexArray,f.x,f.y,0,0,1,1,0),a.x+=f.x,a.y+=f.y,a.vertexCount+=1,h.push(f.x),h.push(f.y)}}var m=ja(h,d);for(let e=0;e<m.length;e+=3)this.indexArray.emplaceBack(p+m[e],p+m[e+2],p+m[e+1]);r.primitiveLength+=m.length/3,r.vertexLength+=e}}for(let e=0;e<a.vertexCount;e++)this.centroidVertexArray.emplaceBack(Math.floor(a.x/a.vertexCount),Math.floor(a.y/a.vertexCount));this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,r,n,i)}}r("FillExtrusionBucket",ms,{omit:["layers","features"]});let gs;var ys={get paint(){return gs=gs||new a({"fill-extrusion-opacity":new i(o["paint_fill-extrusion"]["fill-extrusion-opacity"]),"fill-extrusion-color":new n(o["paint_fill-extrusion"]["fill-extrusion-color"]),"fill-extrusion-translate":new i(o["paint_fill-extrusion"]["fill-extrusion-translate"]),"fill-extrusion-translate-anchor":new i(o["paint_fill-extrusion"]["fill-extrusion-translate-anchor"]),"fill-extrusion-pattern":new Qi(o["paint_fill-extrusion"]["fill-extrusion-pattern"]),"fill-extrusion-height":new n(o["paint_fill-extrusion"]["fill-extrusion-height"]),"fill-extrusion-base":new n(o["paint_fill-extrusion"]["fill-extrusion-base"]),"fill-extrusion-vertical-gradient":new i(o["paint_fill-extrusion"]["fill-extrusion-vertical-gradient"])})}};class vs extends nn{constructor(e){super(e,ys)}createBucket(e){return new ms(e)}queryRadius(){return Ho(this.paint.get("fill-extrusion-translate"))}is3D(){return!0}queryIntersectsFeature(e,r,t,i,n,o,a,s){e=Vo(e,this.paint.get("fill-extrusion-translate"),this.paint.get("fill-extrusion-translate-anchor"),o.angle,a),o=this.paint.get("fill-extrusion-height").evaluate(r,t),a=this.paint.get("fill-extrusion-base").evaluate(r,t),r=function(e,t,r){var i=[];for(const o of e){var n=[o.x,o.y,r,1];oa(n,n,t),i.push(new B(n[0]/n[3],n[1]/n[3]))}return i}(e,s,0),t=function(e,t,r,i){var n=[],o=[],a=i[8]*t,s=i[9]*t,l=i[10]*t,c=i[11]*t,u=i[8]*r,h=i[9]*r,d=i[10]*r,p=i[11]*r;for(const T of e){var f=[],m=[];for(const S of T){var g=S.x,y=S.y,v=i[0]*g+i[4]*y+i[12],_=i[1]*g+i[5]*y+i[13],b=i[2]*g+i[6]*y+i[14],g=i[3]*g+i[7]*y+i[15],y=b+l,w=g+c,x=v+u,C=_+h,b=b+d,g=g+p,v=new B((v+a)/w,(_+s)/w),_=(v.z=y/w,f.push(v),new B(x/g,C/g));_.z=b/g,m.push(_)}n.push(f),o.push(m)}return[n,o]}(i,a,o,s),e=t[0],i=t[1];{var l=e,c=i,u=r;let t=1/0;Lo(u,c)&&(t=bs(u,c[0]));for(let e=0;e<c.length;e++){var h=c[e],d=l[e];for(let e=0;e<h.length-1;e++){var p=h[e],f=h[e+1],m=d[e],g=d[e+1],f=[p,f,g,m,p];Oo(u,f)&&(t=Math.min(t,bs(u,f)))}}return t!==1/0&&t}}}function _s(e,t){return e.x*t.x+e.y*t.y}function bs(r,i){if(1===r.length){let e=0;var n=i[e++];let t;for(;!t||n.equals(t);)if(!(t=i[e++]))return 1/0;for(;e<i.length;e++){var o=i[e],a=r[0],s=t.sub(n),l=o.sub(n),a=a.sub(n),c=_s(s,s),u=_s(s,l),h=_s(l,l),s=_s(a,s),a=_s(a,l),l=c*h-u*u,h=(h*s-u*a)/l,c=(c*a-u*s)/l,a=n.z*(1-h-c)+t.z*h+o.z*c;if(isFinite(a))return a}return 1/0}{let e=1/0;for(const t of i)e=Math.min(e,t.z);return e}}const ws=c([{name:"a_pos_normal",components:2,type:"Int16"},{name:"a_data",components:4,type:"Uint8"}],4)["members"],xs=c([{name:"a_uv_x",components:1,type:"Float32"},{name:"a_split_index",components:1,type:"Float32"}])["members"],Cs=is.VectorTileFeature.types,Ts=Math.cos(Math.PI/180*37.5);const Ss=Math.pow(2,14)/.5;class Es{constructor(e){this.zoom=e.zoom,this.overscaling=e.overscaling,this.layers=e.layers,this.layerIds=this.layers.map(e=>e.id),this.index=e.index,this.hasPattern=!1,this.patternFeatures=[],this.lineClipsArray=[],this.gradients={},this.layers.forEach(e=>{this.gradients[e.id]={}}),this.layoutVertexArray=new Zn,this.layoutVertexArray2=new Wn,this.indexArray=new to,this.programConfigurations=new So(e.layers,e.zoom),this.segments=new x,this.maxLineLength=0,this.stateDependentLayerIds=this.layers.filter(e=>e.isStateDependent()).map(e=>e.id)}populate(e,t,r){this.hasPattern=Wa("line",this.layers,t);var i,n,o,a,s=this.layers[0].layout.get("line-sort-key"),l=!s.isConstant(),c=[];for({feature:i,id:n,index:o,sourceLayerIndex:a}of e){var u,h=this.layers[0]._featureFilter.needGeometry,d=Po(i,h);this.layers[0]._featureFilter.filter(new P(this.zoom),d,r)&&(u=l?s.evaluate(d,{},r):void 0,h={id:n,properties:i.properties,type:i.type,sourceLayerIndex:a,index:o,geometry:h?d.geometry:ko(i),patterns:{},sortKey:u},c.push(h))}l&&c.sort((e,t)=>e.sortKey-t.sortKey);for(const y of c){var{geometry:p,index:f,sourceLayerIndex:m}=y,g=(this.hasPattern?(g=Ya("line",this.layers,y,this.zoom,t),this.patternFeatures.push(g)):this.addFeature(y,p,f,r,{}),e[f].feature);t.featureIndex.insert(g,p,f,m,this.index)}}update(e,t,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(e,t,this.stateDependentLayers,r)}addFeatures(e,t,r){for(const i of this.patternFeatures)this.addFeature(i,i.geometry,i.index,t,r)}isEmpty(){return 0===this.layoutVertexArray.length}uploadPending(){return!this.uploaded||this.programConfigurations.needsUpload}upload(e){this.uploaded||(0!==this.layoutVertexArray2.length&&(this.layoutVertexBuffer2=e.createVertexBuffer(this.layoutVertexArray2,xs)),this.layoutVertexBuffer=e.createVertexBuffer(this.layoutVertexArray,ws),this.indexBuffer=e.createIndexBuffer(this.indexArray)),this.programConfigurations.upload(e),this.uploaded=!0}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy())}lineFeatureClips(e){if(e.properties&&Object.prototype.hasOwnProperty.call(e.properties,"mapbox_clip_start")&&Object.prototype.hasOwnProperty.call(e.properties,"mapbox_clip_end"))return{start:+e.properties.mapbox_clip_start,end:+e.properties.mapbox_clip_end}}addFeature(e,t,r,i,n){var o=this.layers[0].layout,a=o.get("line-join").evaluate(e,{}),s=o.get("line-cap"),l=o.get("line-miter-limit"),c=o.get("line-round-limit");this.lineClips=this.lineFeatureClips(e);for(const u of t)this.addLine(u,e,a,s,l,c);this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,e,r,n,i)}addLine(s,e,l,c,u,h){if(this.distance=0,this.scaledDistance=0,this.totalDistance=0,this.lineClips){this.lineClipsArray.push(this.lineClips);for(let e=0;e<s.length-1;e++)this.totalDistance+=s[e].dist(s[e+1]);this.updateScaledDistance(),this.maxLineLength=Math.max(this.maxLineLength,this.totalDistance)}var d="Polygon"===Cs[e.type];let p=s.length;for(;2<=p&&s[p-1].equals(s[p-2]);)p--;let f=0;for(;f<p-1&&s[f].equals(s[f+1]);)f++;if(!(p<(d?3:2))){"bevel"===l&&(u=1.05);var m,g=this.overscaling<=16?15*de/(512*this.overscaling):0,y=this.segments.prepareSegment(10*p,this.layoutVertexArray,this.indexArray);let i,n,o,a;this.e1=this.e2=-1,d&&(i=s[p-2],a=s[f].sub(i)._unit()._perp());for(let r=f;r<p;r++)if(!(m=r===p-1?d?s[f+1]:void 0:s[r+1])||!s[r].equals(m)){a&&(o=a),i&&(n=i),i=s[r],a=m?m.sub(i)._unit()._perp():o;let e=(o=o||a).add(a);0===e.x&&0===e.y||e._unit();var v=o.x*a.x+o.y*a.y,_=e.x*a.x+e.y*a.y,b=0!=_?1/_:1/0,w=2*Math.sqrt(2-2*_),_=_<Ts&&n&&m,x=0<o.x*a.y-o.y*a.x,C=(_&&r>f&&2*g<(C=i.dist(n))&&(C=i.sub(i.sub(n)._mult(g/C)._round()),this.updateDistance(n,C),this.addCurrentVertex(C,o,0,0,y),n=C),n&&m);let t=C?l:d?"butt":c;if(C&&"round"===t&&(b<h?t="miter":b<=2&&(t="fakeround")),"bevel"===(t="miter"===t&&u<b?"bevel":t)&&(2<b&&(t="flipbevel"),b<u)&&(t="miter"),n&&this.updateDistance(n,i),"miter"===t)e._mult(b),this.addCurrentVertex(i,e,0,0,y);else if("flipbevel"===t)100<b?e=a.mult(-1):(T=b*o.add(a).mag()/o.sub(a).mag(),e._perp()._mult(T*(x?-1:1))),this.addCurrentVertex(i,e,0,0,y),this.addCurrentVertex(i,e.mult(-1),0,0,y);else if("bevel"===t||"fakeround"===t){var T=-Math.sqrt(b*b-1),b=x?T:0,S=x?0:T;if(n&&this.addCurrentVertex(i,o,b,S,y),"fakeround"===t){var E=Math.round(180*w/Math.PI/20);for(let t=1;t<E;t++){let e=t/E;.5!==e&&(I=e-.5,e+=e*I*(e-1)*((1.0904+v*(v*(3.55645-1.43519*v)-3.2452))*I*I+(.848013+v*(.215638*v-1.06021))));var I=a.sub(o)._mult(e)._add(o)._unit()._mult(x?-1:1);this.addHalfVertex(i,I.x,I.y,!1,x,0,y)}}m&&this.addCurrentVertex(i,a,-b,-S,y)}else"butt"===t?this.addCurrentVertex(i,e,0,0,y):"square"===t?(w=n?1:-1,this.addCurrentVertex(i,e,w,w,y)):"round"===t&&(n&&(this.addCurrentVertex(i,o,0,0,y),this.addCurrentVertex(i,o,1,1,y,!0)),m)&&(this.addCurrentVertex(i,a,-1,-1,y,!0),this.addCurrentVertex(i,a,0,0,y));_&&r<p-1&&2*g<(b=i.dist(m))&&(S=i.add(m.sub(i)._mult(g/b)._round()),this.updateDistance(i,S),this.addCurrentVertex(S,a,0,0,y),i=S)}}}addCurrentVertex(e,t,r,i,n,o=!1){var a=t.x+t.y*r,s=t.y-t.x*r,l=-t.x+t.y*i,c=-t.y-t.x*i;this.addHalfVertex(e,a,s,o,!1,r,n),this.addHalfVertex(e,l,c,o,!0,-i,n),this.distance>Ss/2&&0===this.totalDistance&&(this.distance=0,this.updateScaledDistance(),this.addCurrentVertex(e,t,r,i,n,o))}addHalfVertex({x:e,y:t},r,i,n,o,a,s){var l=.5*(this.lineClips?this.scaledDistance*(Ss-1):this.scaledDistance),t=(this.layoutVertexArray.emplaceBack((e<<1)+(n?1:0),(t<<1)+(o?1:0),Math.round(63*r)+128,Math.round(63*i)+128,1+(0===a?0:a<0?-1:1)|(63&l)<<2,l>>6),this.lineClips&&(e=this.scaledDistance-this.lineClips.start,n=this.lineClips.end-this.lineClips.start,this.layoutVertexArray2.emplaceBack(e/n,this.lineClipsArray.length)),s.vertexLength++);0<=this.e1&&0<=this.e2&&(this.indexArray.emplaceBack(this.e1,this.e2,t),s.primitiveLength++),o?this.e2=t:this.e1=t}updateScaledDistance(){this.scaledDistance=this.lineClips?this.lineClips.start+(this.lineClips.end-this.lineClips.start)*this.distance/this.totalDistance:this.distance}updateDistance(e,t){this.distance+=e.dist(t),this.updateScaledDistance()}}r("LineBucket",Es,{omit:["layers","patternFeatures"]});let Is;let As;var ks={get paint(){return As=As||new a({"line-opacity":new n(o.paint_line["line-opacity"]),"line-color":new n(o.paint_line["line-color"]),"line-translate":new i(o.paint_line["line-translate"]),"line-translate-anchor":new i(o.paint_line["line-translate-anchor"]),"line-width":new n(o.paint_line["line-width"]),"line-gap-width":new n(o.paint_line["line-gap-width"]),"line-offset":new n(o.paint_line["line-offset"]),"line-blur":new n(o.paint_line["line-blur"]),"line-dasharray":new en(o.paint_line["line-dasharray"]),"line-pattern":new Qi(o.paint_line["line-pattern"]),"line-gradient":new tn(o.paint_line["line-gradient"])})},get layout(){return Is=Is||new a({"line-cap":new i(o.layout_line["line-cap"]),"line-join":new n(o.layout_line["line-join"]),"line-miter-limit":new i(o.layout_line["line-miter-limit"]),"line-round-limit":new i(o.layout_line["line-round-limit"]),"line-sort-key":new n(o.layout_line["line-sort-key"])})}};class Ps extends n{possiblyEvaluate(e,t){return t=new P(Math.floor(t.zoom),{now:t.now,fadeDuration:t.fadeDuration,zoomHistory:t.zoomHistory,transition:t.transition}),super.possiblyEvaluate(e,t)}evaluate(e,t,r,i){return t=V({},t,{zoom:Math.floor(t.zoom)}),super.evaluate(e,t,r,i)}}let Ms;class Rs extends nn{constructor(e){super(e,ks),this.gradientVersion=0,Ms||((Ms=new Ps(ks.paint.properties["line-width"].specification)).useIntegerZoom=!0)}_handleSpecialPaintPropertyUpdate(e){"line-gradient"===e&&(void 0!==(e=this.gradientExpression())._styleExpression?this.stepInterpolant=e._styleExpression.expression instanceof or:this.stepInterpolant=!1,this.gradientVersion=(this.gradientVersion+1)%Number.MAX_SAFE_INTEGER)}gradientExpression(){return this._transitionablePaint._values["line-gradient"].value.expression}recalculate(e,t){super.recalculate(e,t),this.paint._values["line-floorwidth"]=Ms.possiblyEvaluate(this._transitioningPaint._values["line-width"].value,e)}createBucket(e){return new Es(e)}queryRadius(e){var t=Os(jo("line-width",this,e),jo("line-gap-width",this,e)),e=jo("line-offset",this,e);return t/2+Math.abs(e)+Ho(this.paint.get("line-translate"))}queryIntersectsFeature(e,t,r,i,n,o,a){e=Vo(e,this.paint.get("line-translate"),this.paint.get("line-translate-anchor"),o.angle,a),o=a/2*Os(this.paint.get("line-width").evaluate(t,r),this.paint.get("line-gap-width").evaluate(t,r)),t=this.paint.get("line-offset").evaluate(t,r);return Do(e,i=t?function(t,r){var i=[];for(let e=0;e<t.length;e++){var n=t[e],o=[];for(let e=0;e<n.length;e++){var a=n[e-1],s=n[e],l=n[e+1],a=0===e?new B(0,0):s.sub(a)._unit()._perp(),l=e===n.length-1?new B(0,0):l.sub(s)._unit()._perp(),a=a._add(l)._unit(),l=a.x*l.x+a.y*l.y;0!=l&&a._mult(1/l),o.push(a._mult(r)._add(s))}i.push(o)}return i}(i,t*a):i,o)}isTileClipped(){return!0}}function Os(e,t){return 0<t?t+2*e:e}const Ls=c([{name:"a_pos_offset",components:4,type:"Int16"},{name:"a_data",components:4,type:"Uint16"},{name:"a_pixeloffset",components:4,type:"Int16"}],4),Ds=c([{name:"a_projected_pos",components:3,type:"Float32"}],4),zs=(c([{name:"a_fade_opacity",components:1,type:"Uint32"}],4),c([{name:"a_placed",components:2,type:"Uint8"},{name:"a_shift",components:2,type:"Float32"}])),Ns=(c([{type:"Int16",name:"anchorPointX"},{type:"Int16",name:"anchorPointY"},{type:"Int16",name:"x1"},{type:"Int16",name:"y1"},{type:"Int16",name:"x2"},{type:"Int16",name:"y2"},{type:"Uint32",name:"featureIndex"},{type:"Uint16",name:"sourceLayerIndex"},{type:"Uint16",name:"bucketIndex"}]),c([{name:"a_pos",components:2,type:"Int16"},{name:"a_anchor_pos",components:2,type:"Int16"},{name:"a_extrude",components:2,type:"Int16"}],4));_r=c([{name:"a_pos",components:2,type:"Float32"},{name:"a_radius",components:1,type:"Float32"},{name:"a_flags",components:2,type:"Int16"}],4);function Bs(e,i,n){return e.sections.forEach(e=>{var t,r;e.text=(e=e.text,r=n,"uppercase"===(t=(t=i).layout.get("text-transform").evaluate(r,{}))?e=e.toLocaleUpperCase():"lowercase"===t&&(e=e.toLocaleLowerCase()),e=Vi.applyArabicShaping?Vi.applyArabicShaping(e):e)}),e}c([{name:"triangle",components:3,type:"Uint16"}]),c([{type:"Int16",name:"anchorX"},{type:"Int16",name:"anchorY"},{type:"Uint16",name:"glyphStartIndex"},{type:"Uint16",name:"numGlyphs"},{type:"Uint32",name:"vertexStartIndex"},{type:"Uint32",name:"lineStartIndex"},{type:"Uint32",name:"lineLength"},{type:"Uint16",name:"segment"},{type:"Uint16",name:"lowerSize"},{type:"Uint16",name:"upperSize"},{type:"Float32",name:"lineOffsetX"},{type:"Float32",name:"lineOffsetY"},{type:"Uint8",name:"writingMode"},{type:"Uint8",name:"placedOrientation"},{type:"Uint8",name:"hidden"},{type:"Uint32",name:"crossTileID"},{type:"Int16",name:"associatedIconIndex"}]),c([{type:"Int16",name:"anchorX"},{type:"Int16",name:"anchorY"},{type:"Int16",name:"rightJustifiedTextSymbolIndex"},{type:"Int16",name:"centerJustifiedTextSymbolIndex"},{type:"Int16",name:"leftJustifiedTextSymbolIndex"},{type:"Int16",name:"verticalPlacedTextSymbolIndex"},{type:"Int16",name:"placedIconSymbolIndex"},{type:"Int16",name:"verticalPlacedIconSymbolIndex"},{type:"Uint16",name:"key"},{type:"Uint16",name:"textBoxStartIndex"},{type:"Uint16",name:"textBoxEndIndex"},{type:"Uint16",name:"verticalTextBoxStartIndex"},{type:"Uint16",name:"verticalTextBoxEndIndex"},{type:"Uint16",name:"iconBoxStartIndex"},{type:"Uint16",name:"iconBoxEndIndex"},{type:"Uint16",name:"verticalIconBoxStartIndex"},{type:"Uint16",name:"verticalIconBoxEndIndex"},{type:"Uint16",name:"featureIndex"},{type:"Uint16",name:"numHorizontalGlyphVertices"},{type:"Uint16",name:"numVerticalGlyphVertices"},{type:"Uint16",name:"numIconVertices"},{type:"Uint16",name:"numVerticalIconVertices"},{type:"Uint16",name:"useRuntimeCollisionCircles"},{type:"Uint32",name:"crossTileID"},{type:"Float32",name:"textBoxScale"},{type:"Float32",name:"collisionCircleDiameter"},{type:"Uint16",name:"textAnchorOffsetStartIndex"},{type:"Uint16",name:"textAnchorOffsetEndIndex"}]),c([{type:"Float32",name:"offsetX"}]),c([{type:"Int16",name:"x"},{type:"Int16",name:"y"},{type:"Int16",name:"tileUnitDistanceFromAnchor"}]),c([{type:"Uint16",name:"textAnchor"},{type:"Float32",components:2,name:"textOffset"}]);const Fs={"!":"︕","#":"＃",$:"＄","%":"％","&":"＆","(":"︵",")":"︶","*":"＊","+":"＋",",":"︐","-":"︲",".":"・","/":"／",":":"︓",";":"︔","<":"︿","=":"＝",">":"﹀","?":"︖","@":"＠","[":"﹇","\\":"＼","]":"﹈","^":"＾",_:"︳","`":"｀","{":"︷","|":"―","}":"︸","~":"～","¢":"￠","£":"￡","¥":"￥","¦":"￤","¬":"￢","¯":"￣","–":"︲","—":"︱","‘":"﹃","’":"﹄","“":"﹁","”":"﹂","…":"︙","‧":"・","₩":"￦","、":"︑","。":"︒","〈":"︿","〉":"﹀","《":"︽","》":"︾","「":"﹁","」":"﹂","『":"﹃","』":"﹄","【":"︻","】":"︼","〔":"︹","〕":"︺","〖":"︗","〗":"︘","！":"︕","（":"︵","）":"︶","，":"︐","－":"︲","．":"・","：":"︓","；":"︔","＜":"︿","＞":"﹀","？":"︖","［":"﹇","］":"﹈","＿":"︳","｛":"︷","｜":"―","｝":"︸","｟":"︵","｠":"︶","｡":"︒","｢":"﹁","｣":"﹂"};var pe=24,t={read:function(e,t,r,i,n){var o,a,s=8*n-i-1,l=(1<<s)-1,c=l>>1,u=-7,h=r?n-1:0,d=r?-1:1,n=e[t+h];for(h+=d,o=n&(1<<-u)-1,n>>=-u,u+=s;0<u;o=256*o+e[t+h],h+=d,u-=8);for(a=o&(1<<-u)-1,o>>=-u,u+=i;0<u;a=256*a+e[t+h],h+=d,u-=8);if(0===o)o=1-c;else{if(o===l)return a?NaN:1/0*(n?-1:1);a+=Math.pow(2,i),o-=c}return(n?-1:1)*a*Math.pow(2,o-i)},write:function(e,t,r,i,n,o){var a,s,l=8*o-n-1,c=(1<<l)-1,u=c>>1,h=23===n?Math.pow(2,-24)-Math.pow(2,-77):0,d=i?0:o-1,p=i?1:-1,o=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(s=isNaN(t)?1:0,a=c):(a=Math.floor(Math.log(t)/Math.LN2),t*(i=Math.pow(2,-a))<1&&(a--,i*=2),2<=(t+=1<=a+u?h/i:h*Math.pow(2,1-u))*i&&(a++,i/=2),c<=a+u?(s=0,a=c):1<=a+u?(s=(t*i-1)*Math.pow(2,n),a+=u):(s=t*Math.pow(2,u-1)*Math.pow(2,n),a=0));8<=n;e[r+d]=255&s,d+=p,s/=256,n-=8);for(a=a<<n|s,l+=n;0<l;e[r+d]=255&a,d+=p,a/=256,l-=8);e[r+d-p]|=128*o}},e=T,Us=t;function T(e){this.buf=ArrayBuffer.isView&&ArrayBuffer.isView(e)?e:new Uint8Array(e||0),this.pos=0,this.type=0,this.length=this.buf.length}T.Varint=0,T.Fixed64=1,T.Bytes=2,T.Fixed32=5;var qs=4294967296,js=1/qs,Hs="undefined"==typeof TextDecoder?null:new TextDecoder("utf8");function Vs(e){return e.type===T.Bytes?e.readVarint()+e.pos:e.pos+1}function Gs(e,t,r){return r?4294967296*t+(e>>>0):4294967296*(t>>>0)+(e>>>0)}function Ks(e,t,r){var i=t<=16383?1:t<=2097151?2:t<=268435455?3:Math.floor(Math.log(t)/(7*Math.LN2));r.realloc(i);for(var n=r.pos-1;e<=n;n--)r.buf[n+i]=r.buf[n]}function Zs(e,t){for(var r=0;r<e.length;r++)t.writeVarint(e[r])}function Ws(e,t){for(var r=0;r<e.length;r++)t.writeSVarint(e[r])}function Ys(e,t){for(var r=0;r<e.length;r++)t.writeFloat(e[r])}function $s(e,t){for(var r=0;r<e.length;r++)t.writeDouble(e[r])}function Xs(e,t){for(var r=0;r<e.length;r++)t.writeBoolean(e[r])}function Js(e,t){for(var r=0;r<e.length;r++)t.writeFixed32(e[r])}function Qs(e,t){for(var r=0;r<e.length;r++)t.writeSFixed32(e[r])}function el(e,t){for(var r=0;r<e.length;r++)t.writeFixed64(e[r])}function tl(e,t){for(var r=0;r<e.length;r++)t.writeSFixed64(e[r])}function rl(e,t){return(e[t]|e[t+1]<<8|e[t+2]<<16)+16777216*e[t+3]}function il(e,t,r){e[r]=t,e[r+1]=t>>>8,e[r+2]=t>>>16,e[r+3]=t>>>24}function nl(e,t){return(e[t]|e[t+1]<<8|e[t+2]<<16)+(e[t+3]<<24)}T.prototype={destroy:function(){this.buf=null},readFields:function(e,t,r){for(r=r||this.length;this.pos<r;){var i=this.readVarint(),n=i>>3,o=this.pos;this.type=7&i,e(n,t,this),this.pos===o&&this.skip(i)}return t},readMessage:function(e,t){return this.readFields(e,t,this.readVarint()+this.pos)},readFixed32:function(){var e=rl(this.buf,this.pos);return this.pos+=4,e},readSFixed32:function(){var e=nl(this.buf,this.pos);return this.pos+=4,e},readFixed64:function(){var e=rl(this.buf,this.pos)+rl(this.buf,this.pos+4)*qs;return this.pos+=8,e},readSFixed64:function(){var e=rl(this.buf,this.pos)+nl(this.buf,this.pos+4)*qs;return this.pos+=8,e},readFloat:function(){var e=Us.read(this.buf,this.pos,!0,23,4);return this.pos+=4,e},readDouble:function(){var e=Us.read(this.buf,this.pos,!0,52,8);return this.pos+=8,e},readVarint:function(e){var t=this.buf,r=t[this.pos++],i=127&r;if(r<128)return i;if(i|=(127&(r=t[this.pos++]))<<7,r<128)return i;if(i|=(127&(r=t[this.pos++]))<<14,r<128)return i;if(i|=(127&(r=t[this.pos++]))<<21,r<128)return i;var n,o,r=i|=(15&t[this.pos])<<28,t=e,i=this,e=i.buf;if(o=e[i.pos++],n=(112&o)>>4,o<128)return Gs(r,n,t);if(o=e[i.pos++],n|=(127&o)<<3,o<128)return Gs(r,n,t);if(o=e[i.pos++],n|=(127&o)<<10,o<128)return Gs(r,n,t);if(o=e[i.pos++],n|=(127&o)<<17,o<128)return Gs(r,n,t);if(o=e[i.pos++],n|=(127&o)<<24,o<128)return Gs(r,n,t);if(o=e[i.pos++],n|=(1&o)<<31,o<128)return Gs(r,n,t);throw new Error("Expected varint not more than 10 bytes")},readVarint64:function(){return this.readVarint(!0)},readSVarint:function(){var e=this.readVarint();return e%2==1?(e+1)/-2:e/2},readBoolean:function(){return Boolean(this.readVarint())},readString:function(){var e=this.readVarint()+this.pos,t=this.pos;if(12<=(this.pos=e)-t&&Hs)return r=this.buf,Hs.decode(r.subarray(t,e));for(var r,i,n,o,a=this.buf,s=e,l="",c=t;c<s;){var u=a[c],h=null,d=239<u?4:223<u?3:191<u?2:1;if(s<c+d)break;1===d?u<128&&(h=u):2===d?128==(192&(i=a[c+1]))&&(h=(31&u)<<6|63&i)<=127&&(h=null):3===d?(i=a[c+1],n=a[c+2],128==(192&i)&&128==(192&n)&&((h=(15&u)<<12|(63&i)<<6|63&n)<=2047||55296<=h&&h<=57343)&&(h=null)):4===d&&(i=a[c+1],n=a[c+2],o=a[c+3],128==(192&i))&&128==(192&n)&&128==(192&o)&&((h=(15&u)<<18|(63&i)<<12|(63&n)<<6|63&o)<=65535||1114112<=h)&&(h=null),null===h?(h=65533,d=1):65535<h&&(h-=65536,l+=String.fromCharCode(h>>>10&1023|55296),h=56320|1023&h),l+=String.fromCharCode(h),c+=d}return l},readBytes:function(){var e=this.readVarint()+this.pos,t=this.buf.subarray(this.pos,e);return this.pos=e,t},readPackedVarint:function(e,t){if(this.type!==T.Bytes)return e.push(this.readVarint(t));var r=Vs(this);for(e=e||[];this.pos<r;)e.push(this.readVarint(t));return e},readPackedSVarint:function(e){if(this.type!==T.Bytes)return e.push(this.readSVarint());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readSVarint());return e},readPackedBoolean:function(e){if(this.type!==T.Bytes)return e.push(this.readBoolean());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readBoolean());return e},readPackedFloat:function(e){if(this.type!==T.Bytes)return e.push(this.readFloat());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readFloat());return e},readPackedDouble:function(e){if(this.type!==T.Bytes)return e.push(this.readDouble());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readDouble());return e},readPackedFixed32:function(e){if(this.type!==T.Bytes)return e.push(this.readFixed32());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readFixed32());return e},readPackedSFixed32:function(e){if(this.type!==T.Bytes)return e.push(this.readSFixed32());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readSFixed32());return e},readPackedFixed64:function(e){if(this.type!==T.Bytes)return e.push(this.readFixed64());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readFixed64());return e},readPackedSFixed64:function(e){if(this.type!==T.Bytes)return e.push(this.readSFixed64());var t=Vs(this);for(e=e||[];this.pos<t;)e.push(this.readSFixed64());return e},skip:function(e){e&=7;if(e===T.Varint)for(;127<this.buf[this.pos++];);else if(e===T.Bytes)this.pos=this.readVarint()+this.pos;else if(e===T.Fixed32)this.pos+=4;else{if(e!==T.Fixed64)throw new Error("Unimplemented type: "+e);this.pos+=8}},writeTag:function(e,t){this.writeVarint(e<<3|t)},realloc:function(e){for(var t,r=this.length||16;r<this.pos+e;)r*=2;r!==this.length&&((t=new Uint8Array(r)).set(this.buf),this.buf=t,this.length=r)},finish:function(){return this.length=this.pos,this.pos=0,this.buf.subarray(0,this.length)},writeFixed32:function(e){this.realloc(4),il(this.buf,e,this.pos),this.pos+=4},writeSFixed32:function(e){this.realloc(4),il(this.buf,e,this.pos),this.pos+=4},writeFixed64:function(e){this.realloc(8),il(this.buf,-1&e,this.pos),il(this.buf,Math.floor(e*js),this.pos+4),this.pos+=8},writeSFixed64:function(e){this.realloc(8),il(this.buf,-1&e,this.pos),il(this.buf,Math.floor(e*js),this.pos+4),this.pos+=8},writeVarint:function(e){if(268435455<(e=+e||0)||e<0){var t=e,r=this;if(0<=t?(i=t%4294967296|0,n=t/4294967296|0):(n=~(-t/4294967296),4294967295^(i=~(-t%4294967296))?i=i+1|0:n=n+1|(i=0)),0x10000000000000000<=t||t<-0x10000000000000000)throw new Error("Given varint doesn't fit into 10 bytes");r.realloc(10);var t=i,i=r,t=(i.buf[i.pos++]=127&t|128,t>>>=7,i.buf[i.pos++]=127&t|128,t>>>=7,i.buf[i.pos++]=127&t|128,t>>>=7,i.buf[i.pos++]=127&t|128,t>>>=7,i.buf[i.pos]=127&t,n),n=r,r=(7&t)<<4;n.buf[n.pos++]|=r|((t>>>=3)?128:0),t&&(n.buf[n.pos++]=127&t|((t>>>=7)?128:0),t)&&(n.buf[n.pos++]=127&t|((t>>>=7)?128:0),t)&&(n.buf[n.pos++]=127&t|((t>>>=7)?128:0),t)&&(n.buf[n.pos++]=127&t|((t>>>=7)?128:0),t)&&(n.buf[n.pos++]=127&t)}else this.realloc(4),this.buf[this.pos++]=127&e|(127<e?128:0),e<=127||(this.buf[this.pos++]=127&(e>>>=7)|(127<e?128:0),e<=127)||(this.buf[this.pos++]=127&(e>>>=7)|(127<e?128:0),e<=127)||(this.buf[this.pos++]=e>>>7&127)},writeSVarint:function(e){this.writeVarint(e<0?2*-e-1:2*e)},writeBoolean:function(e){this.writeVarint(Boolean(e))},writeString:function(e){e=String(e),this.realloc(4*e.length),this.pos++;var t=this.pos,e=(this.pos=function(e,t,r){for(var i,n,o=0;o<t.length;o++){if(55295<(i=t.charCodeAt(o))&&i<57344){if(!n){56319<i||o+1===t.length?(e[r++]=239,e[r++]=191,e[r++]=189):n=i;continue}if(i<56320){e[r++]=239,e[r++]=191,e[r++]=189,n=i;continue}i=n-55296<<10|i-56320|65536,n=null}else n&&(e[r++]=239,e[r++]=191,e[r++]=189,n=null);i<128?e[r++]=i:(i<2048?e[r++]=i>>6|192:(i<65536?e[r++]=i>>12|224:(e[r++]=i>>18|240,e[r++]=i>>12&63|128),e[r++]=i>>6&63|128),e[r++]=63&i|128)}return r}(this.buf,e,this.pos),this.pos-t);128<=e&&Ks(t,e,this),this.pos=t-1,this.writeVarint(e),this.pos+=e},writeFloat:function(e){this.realloc(4),Us.write(this.buf,e,this.pos,!0,23,4),this.pos+=4},writeDouble:function(e){this.realloc(8),Us.write(this.buf,e,this.pos,!0,52,8),this.pos+=8},writeBytes:function(e){var t=e.length;this.writeVarint(t),this.realloc(t);for(var r=0;r<t;r++)this.buf[this.pos++]=e[r]},writeRawMessage:function(e,t){this.pos++;var r=this.pos,e=(e(t,this),this.pos-r);128<=e&&Ks(r,e,this),this.pos=r-1,this.writeVarint(e),this.pos+=e},writeMessage:function(e,t,r){this.writeTag(e,T.Bytes),this.writeRawMessage(t,r)},writePackedVarint:function(e,t){t.length&&this.writeMessage(e,Zs,t)},writePackedSVarint:function(e,t){t.length&&this.writeMessage(e,Ws,t)},writePackedBoolean:function(e,t){t.length&&this.writeMessage(e,Xs,t)},writePackedFloat:function(e,t){t.length&&this.writeMessage(e,Ys,t)},writePackedDouble:function(e,t){t.length&&this.writeMessage(e,$s,t)},writePackedFixed32:function(e,t){t.length&&this.writeMessage(e,Js,t)},writePackedSFixed32:function(e,t){t.length&&this.writeMessage(e,Qs,t)},writePackedFixed64:function(e,t){t.length&&this.writeMessage(e,el,t)},writePackedSFixed64:function(e,t){t.length&&this.writeMessage(e,tl,t)},writeBytesField:function(e,t){this.writeTag(e,T.Bytes),this.writeBytes(t)},writeFixed32Field:function(e,t){this.writeTag(e,T.Fixed32),this.writeFixed32(t)},writeSFixed32Field:function(e,t){this.writeTag(e,T.Fixed32),this.writeSFixed32(t)},writeFixed64Field:function(e,t){this.writeTag(e,T.Fixed64),this.writeFixed64(t)},writeSFixed64Field:function(e,t){this.writeTag(e,T.Fixed64),this.writeSFixed64(t)},writeVarintField:function(e,t){this.writeTag(e,T.Varint),this.writeVarint(t)},writeSVarintField:function(e,t){this.writeTag(e,T.Varint),this.writeSVarint(t)},writeStringField:function(e,t){this.writeTag(e,T.Bytes),this.writeString(t)},writeFloatField:function(e,t){this.writeTag(e,T.Fixed32),this.writeFloat(t)},writeDoubleField:function(e,t){this.writeTag(e,T.Fixed64),this.writeDouble(t)},writeBooleanField:function(e,t){this.writeVarintField(e,Boolean(t))}};var ol,al=I(e);const sl=3;function ll(e,t,r){1===e&&r.readMessage(cl,t)}function cl(e,t,r){var i,n,o,a,s;3===e&&({id:e,bitmap:r,width:i,height:n,left:o,top:a,advance:s}=r.readMessage(ul,{}),t.push({id:e,bitmap:new ya({width:i+2*sl,height:n+2*sl},r),metrics:{width:i,height:n,left:o,top:a,advance:s}}))}function ul(e,t,r){1===e?t.id=r.readVarint():2===e?t.bitmap=r.readBytes():3===e?t.width=r.readVarint():4===e?t.height=r.readVarint():5===e?t.left=r.readSVarint():6===e?t.top=r.readSVarint():7===e&&(t.advance=r.readVarint())}const hl=sl;function dl(e){let t=0,r=0;for(const l of e)t+=l.w*l.h,r=Math.max(r,l.w);e.sort((e,t)=>t.h-e.h);var i=[{x:0,y:0,w:Math.max(Math.ceil(Math.sqrt(t/.95)),r),h:1/0}];let n=0,o=0;for(const c of e)for(let e=i.length-1;0<=e;e--){var a,s=i[e];if(!(c.w>s.w||c.h>s.h)){c.x=s.x,c.y=s.y,o=Math.max(o,c.y+c.h),n=Math.max(n,c.x+c.w),c.w===s.w&&c.h===s.h?(a=i.pop(),e<i.length&&(i[e]=a)):c.h===s.h?(s.x+=c.w,s.w-=c.w):(c.w!==s.w&&i.push({x:s.x+c.w,y:s.y,w:s.w-c.w,h:c.h}),s.y+=c.h,s.h-=c.h);break}}return{w:n,h:o,fill:t/(n*o)||0}}(t=ol=ol||{}).none="none",t.height="height",t.width="width";const ne=1;class pl{constructor(e,{pixelRatio:t,version:r,stretchX:i,stretchY:n,content:o,contentMatch:a}){this.paddedRect=e,this.pixelRatio=t,this.stretchX=i,this.stretchY=n,this.content=o,this.version=r,this.contentMatch=a}get tl(){return[this.paddedRect.x+ne,this.paddedRect.y+ne]}get br(){return[this.paddedRect.x+this.paddedRect.w-ne,this.paddedRect.y+this.paddedRect.h-ne]}get tlbr(){return this.tl.concat(this.br)}get displaySize(){return[(this.paddedRect.w-2*ne)/this.pixelRatio,(this.paddedRect.h-2*ne)/this.pixelRatio]}}class fl{constructor(e,t){var r={},i={},n=(this.haveRenderCallbacks=[],[]);this.addImages(e,r,n),this.addImages(t,i,n);const{w:o,h:a}=dl(n);var s=new va({width:o||1,height:a||1});for(const d in e){var l=e[d],c=r[d].paddedRect;va.copy(l.data,s,{x:0,y:0},{x:c.x+ne,y:c.y+ne},l.data)}for(const p in t){var u=t[p],h=i[p].paddedRect;const f=h.x+ne,m=h.y+ne,o=u.data.width,a=u.data.height;va.copy(u.data,s,{x:0,y:0},{x:f,y:m},u.data),va.copy(u.data,s,{x:0,y:a-1},{x:f,y:m-1},{width:o,height:1}),va.copy(u.data,s,{x:0,y:0},{x:f,y:m+a},{width:o,height:1}),va.copy(u.data,s,{x:o-1,y:0},{x:f-1,y:m},{width:1,height:a}),va.copy(u.data,s,{x:0,y:0},{x:f+o,y:m},{width:1,height:a})}this.image=s,this.iconPositions=r,this.patternPositions=i}addImages(e,t,r){for(const o in e){var i=e[o],n={x:0,y:0,w:i.data.width+2*ne,h:i.data.height+2*ne};r.push(n),t[o]=new pl(n,i),i.hasRenderCallback&&this.haveRenderCallbacks.push(o)}}patchUpdatedImages(e,t){e.dispatchRenderCallbacks(this.haveRenderCallbacks);for(const r in e.updatedImages)this.patchUpdatedImage(this.iconPositions[r],e.getImage(r),t),this.patchUpdatedImage(this.patternPositions[r],e.getImage(r),t)}patchUpdatedImage(e,t,r){var i;e&&t&&e.version!==t.version&&(e.version=t.version,[e,i]=e.tl,r.update(t.data,void 0,{x:e,y:i}))}}r("ImagePosition",pl),r("ImageAtlas",fl),ue.WritingMode=void 0,(t=ue.WritingMode||(ue.WritingMode={}))[t.none=0]="none",t[t.horizontal=1]="horizontal",t[t.vertical=2]="vertical",t[t.horizontalOnly=3]="horizontalOnly";const ml=-17;class gl{constructor(){this.scale=1,this.fontStack="",this.imageName=null}static forText(e,t){var r=new gl;return r.scale=e||1,r.fontStack=t,r}static forImage(e){var t=new gl;return t.imageName=e,t}}class yl{constructor(){this.text="",this.sectionIndex=[],this.sections=[],this.imageSectionID=null}static fromFeature(t,r){var i=new yl;for(let e=0;e<t.sections.length;e++){var n=t.sections[e];n.image?i.addImageSection(n):i.addTextSection(n,r)}return i}length(){return this.text.length}getSection(e){return this.sections[this.sectionIndex[e]]}getSectionIndex(e){return this.sectionIndex[e]}getCharCode(e){return this.text.charCodeAt(e)}verticalizePunctuation(){this.text=function(t){let r="";for(let e=0;e<t.length;e++){var i=t.charCodeAt(e+1)||null,n=t.charCodeAt(e-1)||null;(!i||!qi(i)||Fs[t[e+1]])&&(!n||!qi(n)||Fs[t[e-1]])&&Fs[t[e]]?r+=Fs[t[e]]:r+=t[e]}return r}(this.text)}trim(){let t=0;for(let e=0;e<this.text.length&&_l[this.text.charCodeAt(e)];e++)t++;let r=this.text.length;for(let e=this.text.length-1;0<=e&&e>=t&&_l[this.text.charCodeAt(e)];e--)r--;this.text=this.text.substring(t,r),this.sectionIndex=this.sectionIndex.slice(t,r)}substring(e,t){var r=new yl;return r.text=this.text.substring(e,t),r.sectionIndex=this.sectionIndex.slice(e,t),r.sections=this.sections,r}toString(){return this.text}getMaxScale(){return this.sectionIndex.reduce((e,t)=>Math.max(e,this.sections[t].scale),0)}addTextSection(t,e){this.text+=t.text,this.sections.push(gl.forText(t.scale,t.fontStack||e));var r=this.sections.length-1;for(let e=0;e<t.text.length;++e)this.sectionIndex.push(r)}addImageSection(e){var t,e=e.image?e.image.name:"";0===e.length?he("Can't add FormattedSection with an empty image."):(t=this.getNextImageSectionCharCode())?(this.text+=String.fromCharCode(t),this.sections.push(gl.forImage(e)),this.sectionIndex.push(this.sections.length-1)):he("Reached maximum number of images 6401")}getNextImageSectionCharCode(){return this.imageSectionID?63743<=this.imageSectionID?null:++this.imageSectionID:(this.imageSectionID=57344,this.imageSectionID)}}function vl(e,i,z,n,o,a,N,B,F,c,u,h,U,d,p,q){var t=yl.fromFeature(e,o);h===ue.WritingMode.vertical&&t.verticalizePunctuation();let f;var{processBidirectionalText:e,processStyledBidirectionalText:o}=Vi;if(e&&1===t.sections.length){f=[];for(const l of e(t.toString(),Tl(t,c,a,i,n,d,p))){var r=new yl;r.text=l,r.sections=t.sections;for(let e=0;e<l.length;e++)r.sectionIndex.push(0);f.push(r)}}else if(o){f=[];for(const O of o(t.text,t.sectionIndex,Tl(t,c,a,i,n,d,p))){var s=new yl;s.text=O[0],s.sectionIndex=O[1],s.sections=t.sections,f.push(s)}}else f=function(e,t){var r=[],i=e.text;let n=0;for(const o of t)r.push(e.substring(n,o)),n=o;return n<i.length&&r.push(e.substring(n,i.length)),r}(t,Tl(t,c,a,i,n,d,p));e=[],o={positionedLines:e,text:t.toString(),top:u[1],bottom:u[1],left:u[0],right:u[0],writingMode:h,iconsInText:!1,verticalizable:!1};{var m=o,j=i,H=z,V=n,g=(a=f,N),G=(d=B,p=F,h),y=c,v=U,K=q;let s=0,l=ml,t=0,r=0;var _="right"===p?1:"left"===p?0:.5;let e=0;for(const L of a){L.trim();var b=L.getMaxScale(),w=(b-1)*pe,x={positionedGlyphs:[],lineOffset:0},C=(m.positionedLines[e]=x).positionedGlyphs;let a=0;if(L.length()){for(let o=0;o<L.length();o++){var T=L.getSection(o),S=L.getSectionIndex(o),E=L.getCharCode(o);let e=0,t=null,r=null,i=null,n=pe;var I=!(G===ue.WritingMode.horizontal||!v&&!Ui(E)||v&&(_l[E]||function(e){return ie.Arabic(e)||ie["Arabic Supplement"](e)||ie["Arabic Extended-A"](e)||ie["Arabic Presentation Forms-A"](e)||ie["Arabic Presentation Forms-B"](e)}(E)));if(T.imageName){var A=V[T.imageName];if(!A)continue;i=T.imageName,m.iconsInText=m.iconsInText||!0,r=A.paddedRect;var A=A.displaySize,k=(T.scale=T.scale*pe/K,t={width:A[0],height:A[1],left:ne,top:-hl,advance:I?A[1]:A[0]},pe-A[1]*T.scale),k=(e=w+k,n=t.advance,I?A[0]*T.scale-pe*b:A[1]*T.scale-pe*b);0<k&&k>a&&(a=k)}else{A=H[T.fontStack],k=A&&A[E];if(k&&k.rect)r=k.rect,t=k.metrics;else{var P=j[T.fontStack],P=P&&P[E];if(!P)continue;t=P.metrics}e=(b-T.scale)*pe}I?(m.verticalizable=!0,C.push({glyph:E,imageName:i,x:s,y:l+e,vertical:I,scale:T.scale,fontStack:T.fontStack,sectionIndex:S,metrics:t,rect:r}),s+=n*T.scale+y):(C.push({glyph:E,imageName:i,x:s,y:l+e,vertical:I,scale:T.scale,fontStack:T.fontStack,sectionIndex:S,metrics:t,rect:r}),s+=t.advance*T.scale+y)}0!==C.length&&(M=s-y,t=Math.max(M,t),function(t,r,i,e,n){if(e||n){var o=t[i],o=o.metrics.advance*o.scale,a=(t[i].x+o)*e;for(let e=r;e<=i;e++)t[e].x-=a,t[e].y+=n}}(C,0,C.length-1,_,a)),s=0;var M=g*b+a;x.lineOffset=Math.max(a,w),l+=M,r=Math.max(M,r)}else l+=g;++e}var p=l-ml,{horizontalAlign:d,verticalAlign:u}=Sl(d);{var Z=m.positionedLines;var W=_;var Y=d;var R=u;var $=t;var X=r;var J=g;var Q=p;var ee=a.length;var te=(W-Y)*$;let e=0;e=X!==J?-Q*R-ml:(-R*ee+.5)*J;for(const re of Z)for(const D of re.positionedGlyphs)D.x+=te,D.y+=e}m.top+=-u*p,m.bottom=m.top+p,m.left+=-d*t,m.right=m.left+t}return!function(e){for(const t of e)if(0!==t.positionedGlyphs.length)return;return 1}(e)&&o}const _l={[9]:!0,10:!0,11:!0,12:!0,13:!0,32:!0},bl={[10]:!0,32:!0,38:!0,40:!0,41:!0,43:!0,45:!0,47:!0,173:!0,183:!0,8203:!0,8208:!0,8211:!0,8231:!0};function wl(e,t,r,i,n,o){return t.imageName?(i=i[t.imageName])?i.displaySize[0]*t.scale*pe/o+n:0:(o=(i=r[t.fontStack])&&i[e])?o.metrics.advance*t.scale+n:0}function xl(e,t,r,i){var n=Math.pow(e-t,2);return i?e<t?n/2:2*n:n+Math.abs(r)*r}function Cl(e,t,r,i,n,o){let a=null,s=xl(t,r,n,o);for(const c of i){var l=xl(t-c.x,r,n,o)+c.badness;l<=s&&(a=c,s=l)}return{index:e,x:t,priorBreak:a,badness:s}}function Tl(t,r,e,i,n,o,a){if("point"!==o)return[];if(!t)return[];var s=[],l=function(t,r,e,i,n,o){let a=0;for(let e=0;e<t.length();e++){var s=t.getSection(e);a+=wl(t.getCharCode(e),s,i,n,r,o)}return e=Math.max(1,Math.ceil(a/e)),a/e}(t,r,e,i,n,a),c=0<=t.text.indexOf("​");let u=0;for(let e=0;e<t.length();e++){var h,d=t.getSection(e),p=t.getCharCode(e);_l[p]||(u+=wl(p,d,i,n,r,a)),e<t.length()-1&&(h=!((h=p)<11904||!ie["Bopomofo Extended"](h)&&!(ie.Bopomofo(h)||ie["CJK Compatibility Forms"](h)||ie["CJK Compatibility Ideographs"](h)||ie["CJK Compatibility"](h)||ie["CJK Radicals Supplement"](h)||ie["CJK Strokes"](h)||ie["CJK Symbols and Punctuation"](h)||ie["CJK Unified Ideographs Extension A"](h)||ie["CJK Unified Ideographs"](h)||ie["Enclosed CJK Letters and Months"](h)||ie["Halfwidth and Fullwidth Forms"](h)||ie.Hiragana(h)||ie["Ideographic Description Characters"](h)||ie["Kangxi Radicals"](h)||ie["Katakana Phonetic Extensions"](h)||ie.Katakana(h)||ie["Vertical Forms"](h)||ie["Yi Radicals"](h)||ie["Yi Syllables"](h))),bl[p]||h||d.imageName)&&s.push(Cl(e+1,u,l,s,function(e,t,r){let i=0;return 10===e&&(i-=1e4),r&&(i+=150),40!==e&&65288!==e||(i+=50),41!==t&&65289!==t||(i+=50),i}(p,t.getCharCode(e+1),h&&c),!1))}return function e(t){return t?e(t.priorBreak).concat(t.index):[]}(Cl(t.length(),u,l,s,0,!0))}function Sl(e){let t=.5,r=.5;switch(e){case"right":case"top-right":case"bottom-right":t=1;break;case"left":case"top-left":case"bottom-left":t=0}switch(e){case"bottom":case"bottom-right":case"bottom-left":r=1;break;case"top":case"top-right":case"top-left":r=0}return{horizontalAlign:t,verticalAlign:r}}function El(e){let t=e.left,r=e.top,i=e.right-t,n=e.bottom-r;var o=e.image.content[2]-e.image.content[0],a=e.image.content[3]-e.image.content[1];return 0!=a&&0!==i&&0!==n&&(o=o/a,e.image.contentMatch===ol.height?i/n<o&&(a=n*o,t*=a/i,i=a):e.image.contentMatch===ol.width&&0!=o&&i/n>o&&(a=i/o,r*=a/a,n=a)),{x1:t,y1:r,x2:t+i,y2:r+n}}function Il(e,t,r,i,n,o){e=e.image;let a;e.content&&(s=e.content,l=e.pixelRatio||1,a=[s[0]/l,s[1]/l,e.displaySize[0]-s[2]/l,e.displaySize[1]-s[3]/l]);var s=t.left*o,l=t.right*o;let c,u,h,d;u="width"===r||"both"===r?(d=n[0]+s-i[3],n[0]+l+i[1]):(d=n[0]+(s+l-e.displaySize[0])/2)+e.displaySize[0];s=t.top*o,l=t.bottom*o;return h="height"===r||"both"===r?(c=n[1]+s-i[0],n[1]+l+i[2]):(c=n[1]+(s+l-e.displaySize[1])/2)+e.displaySize[1],{image:e,top:c,right:u,bottom:h,left:d,collisionPadding:a}}const Al=255,kl=128,Pl=Al*kl;function Ml(r,i){i=i.expression;if("constant"===i.kind)return{kind:"constant",layoutSize:i.evaluate(new P(r+1))};if("source"===i.kind)return{kind:"source"};{var{zoomStops:n,interpolationType:o}=i;let e=0;for(;e<n.length&&n[e]<=r;)e++;let t=e=Math.max(0,e-1);for(;t<n.length&&n[t]<r+1;)t++;t=Math.min(n.length-1,t);var a=n[e],s=n[t];return"composite"===i.kind?{kind:"composite",minZoom:a,maxZoom:s,interpolationType:o}:{kind:"camera",minZoom:a,maxZoom:s,minSize:i.evaluate(new P(a)),maxSize:i.evaluate(new P(s)),interpolationType:o}}}function Rl(e,t,r){let i="never";t=e.get(t);return t?i=t:e.get(r)&&(i="always"),i}const Ol=is.VectorTileFeature.types,Ll=[{name:"a_fade_opacity",components:1,type:"Uint8",offset:0}];function Dl(e,t,r,i,n,o,a,s,l,c,u,h,d){var p=s?Math.min(Pl,Math.round(s[0])):0,s=s?Math.min(Pl,Math.round(s[1])):0;e.emplaceBack(t,r,Math.round(32*i),Math.round(32*n),o,a,(p<<1)+(l?1:0),s,16*c,16*u,256*h,256*d)}function zl(e,t,r){e.emplaceBack(t.x,t.y,r),e.emplaceBack(t.x,t.y,r),e.emplaceBack(t.x,t.y,r),e.emplaceBack(t.x,t.y,r)}function Nl(e){for(const t of e.sections)if(function(e){for(const t of e)if(ji(t.charCodeAt(0)))return 1}(t.text))return!0;return!1}class Bl{constructor(e){this.layoutVertexArray=new $n,this.indexArray=new to,this.programConfigurations=e,this.segments=new x,this.dynamicLayoutVertexArray=new Xn,this.opacityVertexArray=new Jn,this.hasVisibleVertices=!1,this.placedSymbolArray=new Ln}isEmpty(){return 0===this.layoutVertexArray.length&&0===this.indexArray.length&&0===this.dynamicLayoutVertexArray.length&&0===this.opacityVertexArray.length}upload(e,t,r,i){!this.isEmpty()&&(r&&(this.layoutVertexBuffer=e.createVertexBuffer(this.layoutVertexArray,Ls.members),this.indexBuffer=e.createIndexBuffer(this.indexArray,t),this.dynamicLayoutVertexBuffer=e.createVertexBuffer(this.dynamicLayoutVertexArray,Ds.members,!0),this.opacityVertexBuffer=e.createVertexBuffer(this.opacityVertexArray,Ll,!0),this.opacityVertexBuffer.itemSize=1),r||i)&&this.programConfigurations.upload(e)}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.dynamicLayoutVertexBuffer.destroy(),this.opacityVertexBuffer.destroy())}}r("SymbolBuffers",Bl);class Fl{constructor(e,t,r){this.layoutVertexArray=new e,this.layoutAttributes=t,this.indexArray=new r,this.segments=new x,this.collisionVertexArray=new eo}upload(e){this.layoutVertexBuffer=e.createVertexBuffer(this.layoutVertexArray,this.layoutAttributes),this.indexBuffer=e.createIndexBuffer(this.indexArray),this.collisionVertexBuffer=e.createVertexBuffer(this.collisionVertexArray,zs.members,!0)}destroy(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.segments.destroy(),this.collisionVertexBuffer.destroy())}}r("CollisionBuffers",Fl);class Ul{constructor(e){this.collisionBoxArray=e.collisionBoxArray,this.zoom=e.zoom,this.overscaling=e.overscaling,this.layers=e.layers,this.layerIds=this.layers.map(e=>e.id),this.index=e.index,this.pixelRatio=e.pixelRatio,this.sourceLayerIndex=e.sourceLayerIndex,this.hasPattern=!1,this.hasRTLText=!1,this.sortKeyRanges=[],this.collisionCircleArray=[],this.placementInvProjMatrix=Yo([]),this.placementViewportMatrix=Yo([]);var t=this.layers[0]._unevaluatedLayout._values,t=(this.textSizeData=Ml(this.zoom,t["text-size"]),this.iconSizeData=Ml(this.zoom,t["icon-size"]),this.layers[0].layout),r=t.get("symbol-sort-key"),i=t.get("symbol-z-order"),r=(this.canOverlap="never"!==Rl(t,"text-overlap","text-allow-overlap")||"never"!==Rl(t,"icon-overlap","icon-allow-overlap")||t.get("text-ignore-placement")||t.get("icon-ignore-placement"),this.sortFeaturesByKey="viewport-y"!==i&&!r.isConstant(),"viewport-y"===i||"auto"===i&&!this.sortFeaturesByKey);this.sortFeaturesByY=r&&this.canOverlap,"point"===t.get("symbol-placement")&&(this.writingModes=t.get("text-writing-mode").map(e=>ue.WritingMode[e])),this.stateDependentLayerIds=this.layers.filter(e=>e.isStateDependent()).map(e=>e.id),this.sourceID=e.sourceID}createArrays(){this.text=new Bl(new So(this.layers,this.zoom,e=>/^text/.test(e))),this.icon=new Bl(new So(this.layers,this.zoom,e=>/^icon/.test(e))),this.glyphOffsetArray=new Nn,this.lineVertexArray=new Bn,this.symbolInstances=new zn,this.textAnchorOffsets=new Un}calculateGlyphDependencies(t,r,i,n,o){for(let e=0;e<t.length;e++){var a;r[t.charCodeAt(e)]=!0,(i||n)&&o&&(a=Fs[t.charAt(e)])&&(r[a.charCodeAt(0)]=!0)}}populate(e,t,r){var i=this.layers[0],n=i.layout,o=n.get("text-font"),a=n.get("text-field"),s=n.get("icon-image"),l=("constant"!==a.value.kind||a.value.value instanceof _t&&!a.value.value.isEmpty()||0<a.value.value.toString().length)&&("constant"!==o.value.kind||0<o.value.value.length),c="constant"!==s.value.kind||!!s.value.value||0<Object.keys(s.parameters).length,u=n.get("symbol-sort-key");if(this.features=[],l||c){var h,d,p,f,m=t.iconDependencies,g=t.glyphDependencies,y=t.availableImages,v=new P(this.zoom);for({feature:h,id:d,index:p,sourceLayerIndex:f}of e){var _,b=i._featureFilter.needGeometry,w=Po(h,b);if(i._featureFilter.filter(v,w,r)){b||(w.geometry=ko(h));let e;l&&(b=i.getValueAndResolveTokens("text-field",w,r,y),b=_t.factory(b),!(_=this.hasRTLText=this.hasRTLText||Nl(b))||"unavailable"===Vi.getRTLTextPluginStatus()||_&&Vi.isParsed())&&(e=Bs(b,i,w));let t;if(c&&(_=i.getValueAndResolveTokens("icon-image",w,r,y),t=_ instanceof Ct?_:Ct.fromString(_)),e||t){b=this.sortFeaturesByKey?u.evaluate(w,{},r):void 0,b={id:d,text:e,icon:t,index:p,sourceLayerIndex:f,geometry:w.geometry,properties:h.properties,type:Ol[h.type],sortKey:b};if(this.features.push(b),t&&(m[t.name]=!0),e){var x,C,T=o.evaluate(w,{},r).join(","),S="viewport"!==n.get("text-rotation-alignment")&&"point"!==n.get("symbol-placement");this.allowVerticalPlacement=this.writingModes&&0<=this.writingModes.indexOf(ue.WritingMode.vertical);for(const E of e.sections)E.image?m[E.image.name]=!0:(x=Bi(e.toString()),C=g[C=E.fontStack||T]=g[C]||{},this.calculateGlyphDependencies(E.text,C,S,this.allowVerticalPlacement,x))}}}}"line"===n.get("symbol-placement")&&(this.features=function(t){const n={},o={},a=[];let r=0;function i(e){a.push(t[e]),r++}function s(e,t,r){var i=o[e];return delete o[e],o[t]=i,a[i].geometry[0].pop(),a[i].geometry[0]=a[i].geometry[0].concat(r[0]),i}function l(e,t,r){var i=n[t];return delete n[t],n[e]=i,a[i].geometry[0].shift(),a[i].geometry[0]=r[0].concat(a[i].geometry[0]),i}function c(e,t,r){r=r?t[0][t[0].length-1]:t[0][0];return`${e}:${r.x}:`+r.y}for(let e=0;e<t.length;e++){var u,h,d,p,f=t[e],m=f.geometry,f=f.text?f.text.toString():null;f?(u=c(f,m),h=c(f,m,!0),u in o&&h in n&&o[u]!==n[h]?(d=l(u,h,m),p=s(u,h,a[d].geometry),delete n[u],delete o[h],o[c(f,a[p].geometry,!0)]=p,a[d].geometry=null):u in o?s(u,h,m):h in n?l(u,h,m):(i(e),n[u]=r-1,o[h]=r-1)):i(e)}return a.filter(e=>e.geometry)}(this.features)),this.sortFeaturesByKey&&this.features.sort((e,t)=>e.sortKey-t.sortKey)}}update(e,t,r){this.stateDependentLayers.length&&(this.text.programConfigurations.updatePaintArrays(e,t,this.layers,r),this.icon.programConfigurations.updatePaintArrays(e,t,this.layers,r))}isEmpty(){return 0===this.symbolInstances.length&&!this.hasRTLText}uploadPending(){return!this.uploaded||this.text.programConfigurations.needsUpload||this.icon.programConfigurations.needsUpload}upload(e){!this.uploaded&&this.hasDebugData()&&(this.textCollisionBox.upload(e),this.iconCollisionBox.upload(e)),this.text.upload(e,this.sortFeaturesByY,!this.uploaded,this.text.programConfigurations.needsUpload),this.icon.upload(e,this.sortFeaturesByY,!this.uploaded,this.icon.programConfigurations.needsUpload),this.uploaded=!0}destroyDebugData(){this.textCollisionBox.destroy(),this.iconCollisionBox.destroy()}destroy(){this.text.destroy(),this.icon.destroy(),this.hasDebugData()&&this.destroyDebugData()}addToLineVertexArray(i,n){var e=this.lineVertexArray.length;if(void 0!==i.segment){let t=i.dist(n[i.segment+1]),r=i.dist(n[i.segment]);var o={};for(let e=i.segment+1;e<n.length;e++)o[e]={x:n[e].x,y:n[e].y,tileUnitDistanceFromAnchor:t},e<n.length-1&&(t+=n[e+1].dist(n[e]));for(let e=i.segment||0;0<=e;e--)o[e]={x:n[e].x,y:n[e].y,tileUnitDistanceFromAnchor:r},0<e&&(r+=n[e-1].dist(n[e]));for(let e=0;e<n.length;e++){var a=o[e];this.lineVertexArray.emplaceBack(a.x,a.y,a.tileUnitDistanceFromAnchor)}}return{lineStartIndex:e,lineLength:this.lineVertexArray.length-e}}addSymbols(t,r,i,e,n,o,a,s,l,c,u,h){var d=t.indexArray,p=t.layoutVertexArray,f=t.segments.prepareSegment(4*r.length,p,d,this.canOverlap?o.sortKey:void 0),m=this.glyphOffsetArray.length,g=f.vertexLength,y=this.allowVerticalPlacement&&a===ue.WritingMode.vertical?Math.PI/2:0,v=o.text&&o.text.sections;for(let e=0;e<r.length;e++){var{tl:_,tr:b,bl:w,br:x,tex:C,pixelOffsetTL:T,pixelOffsetBR:S,minFontScaleX:E,minFontScaleY:I,glyphOffset:A,isSDF:k,sectionIndex:P}=r[e],M=f.vertexLength,R=A[1];Dl(p,s.x,s.y,_.x,R+_.y,C.x,C.y,i,k,T.x,T.y,E,I),Dl(p,s.x,s.y,b.x,R+b.y,C.x+C.w,C.y,i,k,S.x,T.y,E,I),Dl(p,s.x,s.y,w.x,R+w.y,C.x,C.y+C.h,i,k,T.x,S.y,E,I),Dl(p,s.x,s.y,x.x,R+x.y,C.x+C.w,C.y+C.h,i,k,S.x,S.y,E,I),zl(t.dynamicLayoutVertexArray,s,y),d.emplaceBack(M,M+1,M+2),d.emplaceBack(M+1,M+2,M+3),f.vertexLength+=4,f.primitiveLength+=2,this.glyphOffsetArray.emplaceBack(A[0]),e!==r.length-1&&P===r[e+1].sectionIndex||t.programConfigurations.populatePaintArrays(p.length,o,o.index,{},h,v&&v[P])}t.placedSymbolArray.emplaceBack(s.x,s.y,m,this.glyphOffsetArray.length-m,g,l,c,s.segment,i?i[0]:0,i?i[1]:0,e[0],e[1],a,0,!1,0,u)}_addCollisionDebugVertex(e,t,r,i,n,o){return t.emplaceBack(0,0),e.emplaceBack(r.x,r.y,i,n,Math.round(o.x),Math.round(o.y))}addCollisionDebugVertices(e,t,r,i,n,o,a){var s=n.segments.prepareSegment(4,n.layoutVertexArray,n.indexArray),l=s.vertexLength,c=n.layoutVertexArray,u=n.collisionVertexArray,h=a.anchorX,a=a.anchorY,t=(this._addCollisionDebugVertex(c,u,o,h,a,new B(e,t)),this._addCollisionDebugVertex(c,u,o,h,a,new B(r,t)),this._addCollisionDebugVertex(c,u,o,h,a,new B(r,i)),this._addCollisionDebugVertex(c,u,o,h,a,new B(e,i)),s.vertexLength+=4,n.indexArray);t.emplaceBack(l,l+1),t.emplaceBack(l+1,l+2),t.emplaceBack(l+2,l+3),t.emplaceBack(l+3,l),s.primitiveLength+=4}addDebugCollisionBoxes(t,r,i,n){for(let e=t;e<r;e++){var o=this.collisionBoxArray.get(e),a=o.x1,s=o.y1,l=o.x2,c=o.y2;this.addCollisionDebugVertices(a,s,l,c,n?this.textCollisionBox:this.iconCollisionBox,o.anchorPoint,i)}}generateCollisionDebugBuffers(){this.hasDebugData()&&this.destroyDebugData(),this.textCollisionBox=new Fl(Qn,Ns.members,ro),this.iconCollisionBox=new Fl(Qn,Ns.members,ro);for(let e=0;e<this.symbolInstances.length;e++){var t=this.symbolInstances.get(e);this.addDebugCollisionBoxes(t.textBoxStartIndex,t.textBoxEndIndex,t,!0),this.addDebugCollisionBoxes(t.verticalTextBoxStartIndex,t.verticalTextBoxEndIndex,t,!0),this.addDebugCollisionBoxes(t.iconBoxStartIndex,t.iconBoxEndIndex,t,!1),this.addDebugCollisionBoxes(t.verticalIconBoxStartIndex,t.verticalIconBoxEndIndex,t,!1)}}_deserializeCollisionBoxesForSymbol(t,r,i,n,o,a,s,l,c){var u={};for(let e=r;e<i;e++){var h=t.get(e);u.textBox={x1:h.x1,y1:h.y1,x2:h.x2,y2:h.y2,anchorPointX:h.anchorPointX,anchorPointY:h.anchorPointY},u.textFeatureIndex=h.featureIndex;break}for(let e=n;e<o;e++){var d=t.get(e);u.verticalTextBox={x1:d.x1,y1:d.y1,x2:d.x2,y2:d.y2,anchorPointX:d.anchorPointX,anchorPointY:d.anchorPointY},u.verticalTextFeatureIndex=d.featureIndex;break}for(let e=a;e<s;e++){var p=t.get(e);u.iconBox={x1:p.x1,y1:p.y1,x2:p.x2,y2:p.y2,anchorPointX:p.anchorPointX,anchorPointY:p.anchorPointY},u.iconFeatureIndex=p.featureIndex;break}for(let e=l;e<c;e++){var f=t.get(e);u.verticalIconBox={x1:f.x1,y1:f.y1,x2:f.x2,y2:f.y2,anchorPointX:f.anchorPointX,anchorPointY:f.anchorPointY},u.verticalIconFeatureIndex=f.featureIndex;break}return u}deserializeCollisionBoxes(t){this.collisionArrays=[];for(let e=0;e<this.symbolInstances.length;e++){var r=this.symbolInstances.get(e);this.collisionArrays.push(this._deserializeCollisionBoxesForSymbol(t,r.textBoxStartIndex,r.textBoxEndIndex,r.verticalTextBoxStartIndex,r.verticalTextBoxEndIndex,r.iconBoxStartIndex,r.iconBoxEndIndex,r.verticalIconBoxStartIndex,r.verticalIconBoxEndIndex))}}hasTextData(){return 0<this.text.segments.get().length}hasIconData(){return 0<this.icon.segments.get().length}hasDebugData(){return this.textCollisionBox&&this.iconCollisionBox}hasTextCollisionBoxData(){return this.hasDebugData()&&0<this.textCollisionBox.segments.get().length}hasIconCollisionBoxData(){return this.hasDebugData()&&0<this.iconCollisionBox.segments.get().length}addIndicesForPlacedSymbol(t,r){var r=t.placedSymbolArray.get(r),i=r.vertexStartIndex+4*r.numGlyphs;for(let e=r.vertexStartIndex;e<i;e+=4)t.indexArray.emplaceBack(e,e+1,e+2),t.indexArray.emplaceBack(e+1,e+2,e+3)}getSortedSymbolIndexes(e){if(this.sortedAngle===e&&void 0!==this.symbolInstanceIndexes)return this.symbolInstanceIndexes;var t=Math.sin(e),r=Math.cos(e);const i=[],n=[];var o=[];for(let e=0;e<this.symbolInstances.length;++e){o.push(e);var a=this.symbolInstances.get(e);i.push(0|Math.round(t*a.anchorX+r*a.anchorY)),n.push(a.featureIndex)}return o.sort((e,t)=>i[e]-i[t]||n[t]-n[e]),o}addToSortKeyRanges(e,t){var r=this.sortKeyRanges[this.sortKeyRanges.length-1];r&&r.sortKey===t?r.symbolInstanceEnd=e+1:this.sortKeyRanges.push({sortKey:t,symbolInstanceStart:e,symbolInstanceEnd:e+1})}sortFeatures(e){if(this.sortFeaturesByY&&this.sortedAngle!==e&&!(1<this.text.segments.get().length||1<this.icon.segments.get().length)){this.symbolInstanceIndexes=this.getSortedSymbolIndexes(e),this.sortedAngle=e,this.text.indexArray.clear(),this.icon.indexArray.clear(),this.featureSortOrder=[];for(const r of this.symbolInstanceIndexes){var t=this.symbolInstances.get(r);this.featureSortOrder.push(t.featureIndex),[t.rightJustifiedTextSymbolIndex,t.centerJustifiedTextSymbolIndex,t.leftJustifiedTextSymbolIndex].forEach((e,t,r)=>{0<=e&&r.indexOf(e)===t&&this.addIndicesForPlacedSymbol(this.text,e)}),0<=t.verticalPlacedTextSymbolIndex&&this.addIndicesForPlacedSymbol(this.text,t.verticalPlacedTextSymbolIndex),0<=t.placedIconSymbolIndex&&this.addIndicesForPlacedSymbol(this.icon,t.placedIconSymbolIndex),0<=t.verticalPlacedIconSymbolIndex&&this.addIndicesForPlacedSymbol(this.icon,t.verticalPlacedIconSymbolIndex)}this.text.indexBuffer&&this.text.indexBuffer.updateData(this.text.indexArray),this.icon.indexBuffer&&this.icon.indexBuffer.updateData(this.icon.indexArray)}}}r("SymbolBucket",Ul,{omit:["layers","collisionBoxArray","features","compareText"]}),Ul.MAX_GLYPHS=65535,Ul.addDynamicAttributes=zl;let ql;let jl;var Hl={get paint(){return jl=jl||new a({"icon-opacity":new n(o.paint_symbol["icon-opacity"]),"icon-color":new n(o.paint_symbol["icon-color"]),"icon-halo-color":new n(o.paint_symbol["icon-halo-color"]),"icon-halo-width":new n(o.paint_symbol["icon-halo-width"]),"icon-halo-blur":new n(o.paint_symbol["icon-halo-blur"]),"icon-translate":new i(o.paint_symbol["icon-translate"]),"icon-translate-anchor":new i(o.paint_symbol["icon-translate-anchor"]),"text-opacity":new n(o.paint_symbol["text-opacity"]),"text-color":new n(o.paint_symbol["text-color"],{runtimeType:Ne,getOverride:e=>e.textColor,hasOverride:e=>!!e.textColor}),"text-halo-color":new n(o.paint_symbol["text-halo-color"]),"text-halo-width":new n(o.paint_symbol["text-halo-width"]),"text-halo-blur":new n(o.paint_symbol["text-halo-blur"]),"text-translate":new i(o.paint_symbol["text-translate"]),"text-translate-anchor":new i(o.paint_symbol["text-translate-anchor"])})},get layout(){return ql=ql||new a({"symbol-placement":new i(o.layout_symbol["symbol-placement"]),"symbol-spacing":new i(o.layout_symbol["symbol-spacing"]),"symbol-avoid-edges":new i(o.layout_symbol["symbol-avoid-edges"]),"symbol-sort-key":new n(o.layout_symbol["symbol-sort-key"]),"symbol-z-order":new i(o.layout_symbol["symbol-z-order"]),"icon-allow-overlap":new i(o.layout_symbol["icon-allow-overlap"]),"icon-overlap":new i(o.layout_symbol["icon-overlap"]),"icon-ignore-placement":new i(o.layout_symbol["icon-ignore-placement"]),"icon-optional":new i(o.layout_symbol["icon-optional"]),"icon-rotation-alignment":new i(o.layout_symbol["icon-rotation-alignment"]),"icon-size":new n(o.layout_symbol["icon-size"]),"icon-text-fit":new i(o.layout_symbol["icon-text-fit"]),"icon-text-fit-padding":new i(o.layout_symbol["icon-text-fit-padding"]),"icon-image":new n(o.layout_symbol["icon-image"]),"icon-rotate":new n(o.layout_symbol["icon-rotate"]),"icon-padding":new n(o.layout_symbol["icon-padding"]),"icon-keep-upright":new i(o.layout_symbol["icon-keep-upright"]),"icon-offset":new n(o.layout_symbol["icon-offset"]),"icon-anchor":new n(o.layout_symbol["icon-anchor"]),"icon-pitch-alignment":new i(o.layout_symbol["icon-pitch-alignment"]),"text-pitch-alignment":new i(o.layout_symbol["text-pitch-alignment"]),"text-rotation-alignment":new i(o.layout_symbol["text-rotation-alignment"]),"text-field":new n(o.layout_symbol["text-field"]),"text-font":new n(o.layout_symbol["text-font"]),"text-size":new n(o.layout_symbol["text-size"]),"text-max-width":new n(o.layout_symbol["text-max-width"]),"text-line-height":new i(o.layout_symbol["text-line-height"]),"text-letter-spacing":new n(o.layout_symbol["text-letter-spacing"]),"text-justify":new n(o.layout_symbol["text-justify"]),"text-radial-offset":new n(o.layout_symbol["text-radial-offset"]),"text-variable-anchor":new i(o.layout_symbol["text-variable-anchor"]),"text-variable-anchor-offset":new n(o.layout_symbol["text-variable-anchor-offset"]),"text-anchor":new n(o.layout_symbol["text-anchor"]),"text-max-angle":new i(o.layout_symbol["text-max-angle"]),"text-writing-mode":new i(o.layout_symbol["text-writing-mode"]),"text-rotate":new n(o.layout_symbol["text-rotate"]),"text-padding":new i(o.layout_symbol["text-padding"]),"text-keep-upright":new i(o.layout_symbol["text-keep-upright"]),"text-transform":new n(o.layout_symbol["text-transform"]),"text-offset":new n(o.layout_symbol["text-offset"]),"text-allow-overlap":new i(o.layout_symbol["text-allow-overlap"]),"text-overlap":new i(o.layout_symbol["text-overlap"]),"text-ignore-placement":new i(o.layout_symbol["text-ignore-placement"]),"text-optional":new i(o.layout_symbol["text-optional"])})}};class Vl{constructor(e){if(void 0===e.property.overrides)throw new Error("overrides must be provided to instantiate FormatSectionOverride class");this.type=e.property.overrides?e.property.overrides.runtimeType:ze,this.defaultValue=e}evaluate(e){if(e.formattedSection){var t=this.defaultValue.property.overrides;if(t&&t.hasOverride(e.formattedSection))return t.getOverride(e.formattedSection)}return e.feature&&e.featureState?this.defaultValue.evaluate(e.feature,e.featureState):this.defaultValue.property.specification.default}eachChild(e){this.defaultValue.isConstant()||e(this.defaultValue.value._styleExpression.expression)}outputDefined(){return!1}serialize(){return null}}r("FormatSectionOverride",Vl,{omit:["defaultValue"]});class Gl extends nn{constructor(e){super(e,Hl)}recalculate(e,t){if(super.recalculate(e,t),"auto"===this.layout.get("icon-rotation-alignment")&&("point"!==this.layout.get("symbol-placement")?this.layout._values["icon-rotation-alignment"]="map":this.layout._values["icon-rotation-alignment"]="viewport"),"auto"===this.layout.get("text-rotation-alignment")&&("point"!==this.layout.get("symbol-placement")?this.layout._values["text-rotation-alignment"]="map":this.layout._values["text-rotation-alignment"]="viewport"),"auto"===this.layout.get("text-pitch-alignment")&&(this.layout._values["text-pitch-alignment"]="map"===this.layout.get("text-rotation-alignment")?"map":"viewport"),"auto"===this.layout.get("icon-pitch-alignment")&&(this.layout._values["icon-pitch-alignment"]=this.layout.get("icon-rotation-alignment")),"point"===this.layout.get("symbol-placement")){e=this.layout.get("text-writing-mode");if(e){var r=[];for(const i of e)r.indexOf(i)<0&&r.push(i);this.layout._values["text-writing-mode"]=r}else this.layout._values["text-writing-mode"]=["horizontal"]}this._setPaintOverrides()}getValueAndResolveTokens(e,t,r,i){var n,r=this.layout.get(e).evaluate(t,{},r,i),i=this._unevaluatedLayout._values[e];return i.isDataDriven()||Fr(i.value)||!r?r:(n=t.properties,r.replace(/{([^{}]+)}/g,(e,t)=>n&&t in n?String(n[t]):""))}createBucket(e){return new Ul(e)}queryRadius(){return 0}queryIntersectsFeature(){throw new Error("Should take a different path in FeatureIndex")}_setPaintOverrides(){for(const i of Hl.paint.overridableProperties)if(Gl.hasPaintOverride(this.layout,i)){var t=this.paint.get(i),r=new Vl(t),r=new Br(r,t.property.specification);let e=null;e="constant"===t.value.kind||"source"===t.value.kind?new qr("source",r):new jr("composite",r,t.value.zoomStops),this.paint._values[i]=new Xi(t.property,e,t.parameters)}}_handleOverridablePaintPropertyUpdate(e,t,r){return!(!this.layout||t.isDataDriven()||r.isDataDriven())&&Gl.hasPaintOverride(this.layout,e)}static hasPaintOverride(e,t){e=e.get("text-field");const r=Hl.paint.properties[t];let i=!1;const n=e=>{for(const t of e)if(r.overrides&&r.overrides.hasOverride(t))return void(i=!0)};if("constant"===e.value.kind&&e.value.value instanceof _t)n(e.value.value.sections);else if("source"===e.value.kind){const o=e=>{var t;i||(e instanceof It&&d(e.value)===Ue?(t=e.value,n(t.sections)):e instanceof wr?n(e.sections):e.eachChild(o))};t=e.value;t._styleExpression&&o(t._styleExpression.expression)}return i}}let Kl;var Zl={get paint(){return Kl=Kl||new a({"background-color":new i(o.paint_background["background-color"]),"background-pattern":new en(o.paint_background["background-pattern"]),"background-opacity":new i(o.paint_background["background-opacity"])})}};class Wl extends nn{constructor(e){super(e,Zl)}}let Yl;var $l={get paint(){return Yl=Yl||new a({"raster-opacity":new i(o.paint_raster["raster-opacity"]),"raster-hue-rotate":new i(o.paint_raster["raster-hue-rotate"]),"raster-brightness-min":new i(o.paint_raster["raster-brightness-min"]),"raster-brightness-max":new i(o.paint_raster["raster-brightness-max"]),"raster-saturation":new i(o.paint_raster["raster-saturation"]),"raster-contrast":new i(o.paint_raster["raster-contrast"]),"raster-resampling":new i(o.paint_raster["raster-resampling"]),"raster-fade-duration":new i(o.paint_raster["raster-fade-duration"])})}};class Xl extends nn{constructor(e){super(e,$l)}}class Jl extends nn{constructor(e){super(e,{}),this.onAdd=e=>{this.implementation.onAdd&&this.implementation.onAdd(e,e.painter.context.gl)},this.onRemove=e=>{this.implementation.onRemove&&this.implementation.onRemove(e,e.painter.context.gl)},this.implementation=e}is3D(){return"3d"===this.implementation.renderingMode}hasOffscreenPass(){return void 0!==this.implementation.prerender}recalculate(){}updateTransitions(){}hasTransition(){return!1}serialize(){throw new Error("Custom layers cannot be serialized")}}class Ql{constructor(e){this._methodToThrottle=e,this._triggered=!1,"undefined"!=typeof MessageChannel&&(this._channel=new MessageChannel,this._channel.port2.onmessage=()=>{this._triggered=!1,this._methodToThrottle()})}trigger(){this._triggered||(this._triggered=!0,this._channel?this._channel.port1.postMessage(!0):setTimeout(()=>{this._triggered=!1,this._methodToThrottle()},0))}remove(){delete this._channel,this._methodToThrottle=()=>{}}}const ec=6371008.8;class tc{constructor(e,t){if(isNaN(e)||isNaN(t))throw new Error(`Invalid LngLat object: (${e}, ${t})`);if(this.lng=+e,this.lat=+t,90<this.lat||this.lat<-90)throw new Error("Invalid LngLat latitude value: must be between -90 and 90")}wrap(){return new tc(H(this.lng,-180,180),this.lat)}toArray(){return[this.lng,this.lat]}toString(){return`LngLat(${this.lng}, ${this.lat})`}distanceTo(e){var t=Math.PI/180,r=this.lat*t,i=e.lat*t,r=Math.sin(r)*Math.sin(i)+Math.cos(r)*Math.cos(i)*Math.cos((e.lng-this.lng)*t);return ec*Math.acos(Math.min(r,1))}static convert(e){if(e instanceof tc)return e;if(Array.isArray(e)&&(2===e.length||3===e.length))return new tc(Number(e[0]),Number(e[1]));if(Array.isArray(e)||"object"!=typeof e||null===e)throw new Error("`LngLatLike` argument must be specified as a LngLat instance, an object {lng: <lng>, lat: <lat>}, an object {lon: <lng>, lat: <lat>}, or an array of [<lng>, <lat>]");return new tc(Number("lng"in e?e.lng:e.lon),Number(e.lat))}}const rc=2*Math.PI*ec;function ic(e){return rc*Math.cos(e*Math.PI/180)}function nc(e){return(180+e)/360}function oc(e){return(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+e*Math.PI/360)))/360}function ac(e,t){return e/ic(t)}function sc(e){return 360/Math.PI*Math.atan(Math.exp((180-360*e)*Math.PI/180))-90}class lc{constructor(e,t,r=0){this.x=+e,this.y=+t,this.z=+r}static fromLngLat(e,t=0){e=tc.convert(e);return new lc(nc(e.lng),oc(e.lat),ac(t,e.lat))}toLngLat(){return new tc(360*this.x-180,sc(this.y))}toAltitude(){return e=this.z,t=this.y,e*ic(sc(t));var e,t}meterInMercatorCoordinateUnits(){return 1/rc*(e=sc(this.y),1/Math.cos(e*Math.PI/180));var e}}function cc(e,t,r){r=2*Math.PI*6378137/256/Math.pow(2,r);return[e*r-2*Math.PI*6378137/2,t*r-2*Math.PI*6378137/2]}class uc{constructor(e,t,r){if(e<0||25<e||r<0||r>=Math.pow(2,e)||t<0||t>=Math.pow(2,e))throw new Error(`x=${t}, y=${r}, z=${e} outside of bounds. 0<=x<${Math.pow(2,e)}, 0<=y<${Math.pow(2,e)} 0<=z<=25 `);this.z=e,this.x=t,this.y=r,this.key=pc(0,e,e,t,r)}equals(e){return this.z===e.z&&this.x===e.x&&this.y===e.y}url(e,t,r){i=this.x,o=this.y,a=this.z,n=cc(256*i,256*(o=Math.pow(2,a)-o-1),a),i=cc(256*(i+1),256*(o+1),a);var i,n,o=n[0]+","+n[1]+","+i[0]+","+i[1],a=function(t,r,i){let n="",o;for(let e=t;0<e;e--)o=1<<e-1,n+=(r&o?1:0)+(i&o?2:0);return n}(this.z,this.x,this.y);return e[(this.x+this.y)%e.length].replace(/{prefix}/g,(this.x%16).toString(16)+(this.y%16).toString(16)).replace(/{z}/g,String(this.z)).replace(/{x}/g,String(this.x)).replace(/{y}/g,String("tms"===r?Math.pow(2,this.z)-this.y-1:this.y)).replace(/{ratio}/g,1<t?"@2x":"").replace(/{quadkey}/g,a).replace(/{bbox-epsg-3857}/g,o)}isChildOf(e){var t=this.z-e.z;return 0<t&&e.x===this.x>>t&&e.y===this.y>>t}getTilePoint(e){var t=Math.pow(2,this.z);return new B((e.x*t-this.x)*de,(e.y*t-this.y)*de)}toString(){return`${this.z}/${this.x}/`+this.y}}class hc{constructor(e,t){this.wrap=e,this.canonical=t,this.key=pc(e,t.z,t.z,t.x,t.y)}}class dc{constructor(e,t,r,i,n){if(e<r)throw new Error(`overscaledZ should be >= z; overscaledZ = ${e}; z = `+r);this.overscaledZ=e,this.wrap=t,this.canonical=new uc(r,+i,+n),this.key=pc(t,e,r,i,n)}clone(){return new dc(this.overscaledZ,this.wrap,this.canonical.z,this.canonical.x,this.canonical.y)}equals(e){return this.overscaledZ===e.overscaledZ&&this.wrap===e.wrap&&this.canonical.equals(e.canonical)}scaledTo(e){if(e>this.overscaledZ)throw new Error(`targetZ > this.overscaledZ; targetZ = ${e}; overscaledZ = `+this.overscaledZ);var t=this.canonical.z-e;return e>this.canonical.z?new dc(e,this.wrap,this.canonical.z,this.canonical.x,this.canonical.y):new dc(e,this.wrap,e,this.canonical.x>>t,this.canonical.y>>t)}calculateScaledKey(e,t){if(e>this.overscaledZ)throw new Error(`targetZ > this.overscaledZ; targetZ = ${e}; overscaledZ = `+this.overscaledZ);var r=this.canonical.z-e;return e>this.canonical.z?pc(this.wrap*+t,e,this.canonical.z,this.canonical.x,this.canonical.y):pc(this.wrap*+t,e,e,this.canonical.x>>r,this.canonical.y>>r)}isChildOf(e){var t;return e.wrap===this.wrap&&(t=this.canonical.z-e.canonical.z,0===e.overscaledZ||e.overscaledZ<this.overscaledZ&&e.canonical.x===this.canonical.x>>t&&e.canonical.y===this.canonical.y>>t)}children(e){var t,r;return this.overscaledZ>=e?[new dc(this.overscaledZ+1,this.wrap,this.canonical.z,this.canonical.x,this.canonical.y)]:(e=this.canonical.z+1,t=2*this.canonical.x,r=2*this.canonical.y,[new dc(e,this.wrap,e,t,r),new dc(e,this.wrap,e,1+t,r),new dc(e,this.wrap,e,t,1+r),new dc(e,this.wrap,e,1+t,1+r)])}isLessThan(e){return this.wrap<e.wrap||!(this.wrap>e.wrap)&&(this.overscaledZ<e.overscaledZ||!(this.overscaledZ>e.overscaledZ)&&(this.canonical.x<e.canonical.x||!(this.canonical.x>e.canonical.x)&&this.canonical.y<e.canonical.y))}wrapped(){return new dc(this.overscaledZ,0,this.canonical.z,this.canonical.x,this.canonical.y)}unwrapTo(e){return new dc(this.overscaledZ,e,this.canonical.z,this.canonical.x,this.canonical.y)}overscaleFactor(){return Math.pow(2,this.overscaledZ-this.canonical.z)}toUnwrapped(){return new hc(this.wrap,this.canonical)}toString(){return`${this.overscaledZ}/${this.canonical.x}/`+this.canonical.y}getTilePoint(e){return this.canonical.getTilePoint(new lc(e.x-this.wrap,e.y))}}function pc(e,t,r,i,n){var o=1<<r;return(o*o*(e=(e*=2)<0?-1*e-1:e)+o*n+i).toString(36)+r.toString(36)+t.toString(36)}r("CanonicalTileID",uc),r("OverscaledTileID",dc,{omit:["posMatrix"]});class fc{constructor(e,t,r,i=1,n=1,o=1,a=0){if(this.uid=e,t.height!==t.width)throw new RangeError("DEM tiles must be square");if(r&&!["mapbox","terrarium","custom"].includes(r))he(`"${r}" is not a valid encoding type. Valid types include "mapbox", "terrarium" and "custom".`);else{this.stride=t.height;var s=this.dim=t.height-2;switch(this.data=new Uint32Array(t.data.buffer),r){case"terrarium":this.redFactor=256,this.greenFactor=1,this.blueFactor=1/256,this.baseShift=32768;break;case"custom":this.redFactor=i,this.greenFactor=n,this.blueFactor=o,this.baseShift=a;break;default:this.redFactor=6553.6,this.greenFactor=25.6,this.blueFactor=.1,this.baseShift=1e4}for(let e=0;e<s;e++)this.data[this._idx(-1,e)]=this.data[this._idx(0,e)],this.data[this._idx(s,e)]=this.data[this._idx(s-1,e)],this.data[this._idx(e,-1)]=this.data[this._idx(e,0)],this.data[this._idx(e,s)]=this.data[this._idx(e,s-1)];this.data[this._idx(-1,-1)]=this.data[this._idx(0,0)],this.data[this._idx(s,-1)]=this.data[this._idx(s-1,0)],this.data[this._idx(-1,s)]=this.data[this._idx(0,s-1)],this.data[this._idx(s,s)]=this.data[this._idx(s-1,s-1)],this.min=Number.MAX_SAFE_INTEGER,this.max=Number.MIN_SAFE_INTEGER;for(let t=0;t<s;t++)for(let e=0;e<s;e++){var l=this.get(t,e);l>this.max&&(this.max=l),l<this.min&&(this.min=l)}}}get(e,t){var r=new Uint8Array(this.data.buffer),e=4*this._idx(e,t);return this.unpack(r[e],r[1+e],r[2+e])}getUnpackVector(){return[this.redFactor,this.greenFactor,this.blueFactor,this.baseShift]}_idx(e,t){if(e<-1||e>=this.dim+1||t<-1||t>=this.dim+1)throw new RangeError("out of range source coordinates for DEM data");return(t+1)*this.stride+(e+1)}unpack(e,t,r){return e*this.redFactor+t*this.greenFactor+r*this.blueFactor-this.baseShift}getPixels(){return new va({width:this.stride,height:this.stride},new Uint8Array(this.data.buffer))}backfillBorder(r,e,t){if(this.dim!==r.dim)throw new Error("dem dimension mismatch");let i=e*this.dim,n=e*this.dim+this.dim,o=t*this.dim,a=t*this.dim+this.dim;switch(e){case-1:i=n-1;break;case 1:n=i+1}switch(t){case-1:o=a-1;break;case 1:a=o+1}var s=-e*this.dim,l=-t*this.dim;for(let t=o;t<a;t++)for(let e=i;e<n;e++)this.data[this._idx(e,t)]=r.data[this._idx(e+s,t+l)]}}r("DEMData",fc);class mc{constructor(t){this._stringToNumber={},this._numberToString=[];for(let e=0;e<t.length;e++){var r=t[e];this._stringToNumber[r]=e,this._numberToString[e]=r}}encode(e){return this._stringToNumber[e]}decode(e){if(e>=this._numberToString.length)throw new Error(`Out of bounds. Index requested n=${e} can't be >= this._numberToString.length `+this._numberToString.length);return this._numberToString[e]}}class gc{constructor(e,t,r,i,n){this.type="Feature",(this._vectorTileFeature=e)._z=t,e._x=r,e._y=i,this.properties=e.properties,this.id=n}get geometry(){return void 0===this._geometry&&(this._geometry=this._vectorTileFeature.toGeoJSON(this._vectorTileFeature._x,this._vectorTileFeature._y,this._vectorTileFeature._z).geometry),this._geometry}set geometry(e){this._geometry=e}toJSON(){var e={geometry:this.geometry};for(const t in this)"_geometry"!==t&&"_vectorTileFeature"!==t&&(e[t]=this[t]);return e}}class yc{constructor(e,t){this.tileID=e,this.x=e.canonical.x,this.y=e.canonical.y,this.z=e.canonical.z,this.grid=new Ri(de,16,0),this.grid3D=new Ri(de,16,0),this.featureIndexArray=new jn,this.promoteId=t}insert(e,t,r,i,n,o){var a=this.featureIndexArray.length,s=(this.featureIndexArray.emplaceBack(r,i,n),o?this.grid3D:this.grid);for(let e=0;e<t.length;e++){var l=t[e],c=[1/0,1/0,-1/0,-1/0];for(let e=0;e<l.length;e++){var u=l[e];c[0]=Math.min(c[0],u.x),c[1]=Math.min(c[1],u.y),c[2]=Math.max(c[2],u.x),c[3]=Math.max(c[3],u.y)}c[0]<de&&c[1]<de&&0<=c[2]&&0<=c[3]&&s.insert(a,c[0],c[1],c[2],c[3])}}loadVTLayers(){return this.vtLayers||(this.vtLayers=new is.VectorTile(new al(this.rawTileData)).layers,this.sourceLayerCoder=new mc(this.vtLayers?Object.keys(this.vtLayers).sort():["_geojsonTileLayer"])),this.vtLayers}query(n,t,r,o){this.loadVTLayers();const a=n.params||{},s=de/n.tileSize/n.scale,l=Zr(a.filter),c=n.queryGeometry,u=n.queryPadding*s;var e=_c(c),i=this.grid.query(e.minX-u,e.minY-u,e.maxX+u,e.maxY+u),e=_c(n.cameraQueryGeometry);for(const f of this.grid3D.query(e.minX-u,e.minY-u,e.maxX+u,e.maxY+u,(e,t,r,i)=>qo(n.cameraQueryGeometry,e-u,t-u,r+u,i+u)))i.push(f);i.sort(bc);var h={};let d;for(let e=0;e<i.length;e++){var p=i[e];if(p!==d){d=p;p=this.featureIndexArray.get(p);let i=null;this.loadMatchingFeature(h,p.bucketIndex,p.sourceLayerIndex,p.featureIndex,l,a.layers,a.availableImages,t,r,o,(e,t,r)=>(i=i||ko(e),t.queryIntersectsFeature(c,e,r,i,this.z,n.transform,s,n.pixelPosMatrix)))}}return h}loadMatchingFeature(t,e,r,i,n,o,a,s,l,c,u){var h=this.bucketLayerIDs[e];if(!o||function(t,r){for(let e=0;e<t.length;e++)if(0<=r.indexOf(t[e]))return 1}(o,h)){var e=this.sourceLayerCoder.decode(r),d=this.vtLayers[e].feature(i);if(n.needGeometry){r=Po(d,!0);if(!n.filter(new P(this.tileID.overscaledZ),r,this.tileID.canonical))return}else if(!n.filter(new P(this.tileID.overscaledZ),d))return;var p=this.getId(d,e);for(let e=0;e<h.length;e++){var f=h[e];if(!(o&&o.indexOf(f)<0)){var m=s[f];if(m){let e={};p&&c&&(e=c.getState(m.sourceLayer||"_geojsonTileLayer",p));var g=V({},l[f]),m=(g.paint=vc(g.paint,m.paint,d,e,a),g.layout=vc(g.layout,m.layout,d,e,a),!u||u(d,m,e));if(m){var y=new gc(d,this.z,this.x,this.y,p);y.layer=g;let e=t[f];(e=void 0===e?t[f]=[]:e).push({featureIndex:i,feature:y,intersectionZ:m})}}}}}}lookupSymbolFeatures(e,t,r,i,n,o,a,s){var l={},c=(this.loadVTLayers(),Zr(n));for(const u of e)this.loadMatchingFeature(l,r,i,u,c,o,a,s,t);return l}hasLayer(e){for(const t of this.bucketLayerIDs)for(const r of t)if(e===r)return!0;return!1}getId(e,t){let r=e.id;return r=this.promoteId&&(t="string"==typeof this.promoteId?this.promoteId:this.promoteId[t],"boolean"==typeof(r=e.properties[t]))?Number(r):r}}function vc(e,r,i,n,o){return K(e,(e,t)=>{t=r instanceof Ji?r.get(t):null;return t&&t.evaluate?t.evaluate(i,n,o):t})}function _c(e){let t=1/0,r=1/0,i=-1/0,n=-1/0;for(const o of e)t=Math.min(t,o.x),r=Math.min(r,o.y),i=Math.max(i,o.x),n=Math.max(n,o.y);return{minX:t,minY:r,maxX:i,maxY:n}}function bc(e,t){return t-e}function wc(t,n,o,a,s){var l=[];for(let e=0;e<t.length;e++){var c=t[e];let i;for(let r=0;r<c.length-1;r++){let e=c[r],t=c[r+1];e.x<n&&t.x<n||(e.x<n?e=new B(n,e.y+(t.y-e.y)*((n-e.x)/(t.x-e.x)))._round():t.x<n&&(t=new B(n,e.y+(t.y-e.y)*((n-e.x)/(t.x-e.x)))._round()),e.y<o&&t.y<o)||(e.y<o?e=new B(e.x+(t.x-e.x)*((o-e.y)/(t.y-e.y)),o)._round():t.y<o&&(t=new B(e.x+(t.x-e.x)*((o-e.y)/(t.y-e.y)),o)._round()),e.x>=a&&t.x>=a)||(e.x>=a?e=new B(a,e.y+(t.y-e.y)*((a-e.x)/(t.x-e.x)))._round():t.x>=a&&(t=new B(a,e.y+(t.y-e.y)*((a-e.x)/(t.x-e.x)))._round()),e.y>=s&&t.y>=s)||(e.y>=s?e=new B(e.x+(t.x-e.x)*((s-e.y)/(t.y-e.y)),s)._round():t.y>=s&&(t=new B(e.x+(t.x-e.x)*((s-e.y)/(t.y-e.y)),s)._round()),i&&e.equals(i[i.length-1])||(i=[e],l.push(i)),i.push(t))}}return l}r("FeatureIndex",yc,{omit:["rawTileData","sourceLayerCoder"]});class xc extends B{constructor(e,t,r,i){super(e,t),this.angle=r,void 0!==i&&(this.segment=i)}clone(){return new xc(this.x,this.y,this.angle,this.segment)}}function Cc(n,o,a,s,l){if(void 0!==o.segment&&0!==a){let e=o,t=o.segment+1,r=0;for(;r>-a/2;){if(--t<0)return;r-=n[t].dist(e),e=n[t]}r+=n[t].dist(n[t+1]),t++;var c=[];let i=0;for(;r<a/2;){var u=n[t-1],h=n[t],d=n[t+1];if(!d)return;u=u.angleTo(h)-h.angleTo(d),u=Math.abs((u+3*Math.PI)%(2*Math.PI)-Math.PI);for(c.push({distance:r,angleDelta:u}),i+=u;r-c[0].distance>s;)i-=c.shift().angleDelta;if(i>l)return;t++,r+=h.dist(d)}}return 1}function Tc(t){let r=0;for(let e=0;e<t.length-1;e++)r+=t[e].dist(t[e+1]);return r}function Sc(e,t,r){return e?.6*t*r:0}function Ec(e,t){return Math.max(e?e.right-e.left:0,t?t.right-t.left:0)}function Ic(e,t,r,i,n,o,a,s,l){var c=Sc(i,o,a),i=Ec(i,n),n=i*a,u=0===e[0].x||e[0].x===l||0===e[0].y||e[0].y===l,o=(t-n<t/4&&(t=n+t/4),2*o);return function e(t,r,i,n,o,a,s,l,c){const u=a/2;const h=Tc(t);let d=0,p=r-i;let f=[];for(let e=0;e<t.length-1;e++){const m=t[e],g=t[e+1],y=m.dist(g),v=g.angleTo(m);for(;p+i<d+y;){const _=((p+=i)-d)/y,b=k.number(m.x,g.x,_),w=k.number(m.y,g.y,_);if(0<=b&&b<c&&0<=w&&w<c&&0<=p-u&&p+u<=h){const x=new xc(b,w,v,e);x._round(),n&&!Cc(t,x,a,n,o)||f.push(x)}}d+=y}l||f.length||s||(f=e(t,d/2,i,n,o,a,s,!0,c));return f}(e,u?t/2*s%t:(i/2+o)*a*s%t,t,c,r,n,u,!1,l)}r("Anchor",xc);const Ac=ne;function kc(e,p,f,t){var r=[];const m=e.image,g=m.pixelRatio;var i=m.paddedRect.w-2*Ac,n=m.paddedRect.h-2*Ac;let o={x1:e.left,y1:e.top,x2:e.right,y2:e.bottom};var a=m.stretchX||[[0,i]],s=m.stretchY||[[0,n]],l=(e,t)=>e+t[1]-t[0];const y=a.reduce(l,0),v=s.reduce(l,0);var c,u,h,l=i-y,d=n-v;let _=0,b=y,w=0,x=v,C=0,T=l,S=0,E=d;m.content&&t&&(u=(c=m.content)[2]-c[0],h=c[3]-c[1],m.contentMatch&&m.content&&(o=El(e)),_=Pc(a,0,c[0]),w=Pc(s,0,c[1]),b=Pc(a,c[0],c[2]),x=Pc(s,c[1],c[3]),C=c[0]-_,S=c[1]-w,T=u-b,E=h-x);const I=o.x1,A=o.y1,k=o.x2-I,P=o.y2-A;var M=(e,t,r,i)=>{var n=(e.stretch-_)/b*k+I,o=e.fixed-C-T*e.stretch/y,a=(t.stretch-w)/x*P+A,s=t.fixed-S-E*t.stretch/v,l=(r.stretch-_)/b*k+I,c=r.fixed-C-T*r.stretch/y,u=(i.stretch-w)/x*P+A,h=i.fixed-S-E*i.stretch/v,d=new B(n,a),a=new B(l,a),l=new B(l,u),n=new B(n,u),u=new B(o/g,s/g),o=new B(c/g,h/g),s=p*Math.PI/180,c=(s&&(c=Math.sin(s),h=Math.cos(s),d._matMult(s=[h,-c,c,h]),a._matMult(s),n._matMult(s),l._matMult(s)),e.stretch+e.fixed),h=r.stretch+r.fixed,s=t.stretch+t.fixed,e=i.stretch+i.fixed;return{tl:d,tr:a,bl:n,br:l,tex:{x:m.paddedRect.x+Ac+c,y:m.paddedRect.y+Ac+s,w:h-c,h:e-s},writingMode:void 0,glyphOffset:[0,0],sectionIndex:0,pixelOffsetTL:u,pixelOffsetBR:o,minFontScaleX:T/g/k,minFontScaleY:E/g/P,isSDF:f}};if(t&&(m.stretchX||m.stretchY)){var R=Mc(a,l,y),O=Mc(s,d,v);for(let e=0;e<R.length-1;e++){var L=R[e],D=R[e+1];for(let e=0;e<O.length-1;e++){var z=O[e],N=O[e+1];r.push(M(L,z,D,N))}}}else r.push(M({fixed:0,stretch:-1},{fixed:0,stretch:-1},{fixed:0,stretch:1+i},{fixed:0,stretch:1+n}));return r}function Pc(e,t,r){let i=0;for(const n of e)i+=Math.max(t,Math.min(r,n[1]))-Math.max(t,Math.min(r,n[0]));return i}function Mc(e,t,r){var i,n,o=[{fixed:-Ac,stretch:0}];for([i,n]of e){var a=o[o.length-1];o.push({fixed:i-a.stretch,stretch:a.stretch}),o.push({fixed:i-a.stretch,stretch:a.stretch+(n-i)})}return o.push({fixed:t+Ac,stretch:r}),o}function Rc(e,a,s,t,l,r,c,u){var h=t.layout.get("text-rotate").evaluate(r,{})*Math.PI/180,d=[];for(const T of a.positionedLines)for(const S of T.positionedGlyphs)if(S.rect){var p=S.rect||{};let e=hl+1,t=!0,r=1,i=0;var f,m=(l||u)&&S.vertical,g=S.metrics.advance*S.scale/2,y=(u&&a.verticalizable&&(y=(S.scale-1)*pe,f=(pe-S.metrics.width*S.scale)/2,i=T.lineOffset/2-(S.imageName?-f:y)),S.imageName&&(f=c[S.imageName],t=f.sdf,r=f.pixelRatio,e=ne/r),l?[S.x+g,S.y]:[0,0]);let n=l?[0,0]:[S.x+g+s[0],S.y+s[1]-i],o=[0,0];m&&(o=n,n=[0,0]);var v=S.metrics.isDoubleResolution?2:1,_=(S.metrics.left-e)*S.scale-g+n[0],b=(-S.metrics.top-e)*S.scale+n[1],w=_+p.w/v*S.scale/r,v=b+p.h/v*S.scale/r,x=new B(_,b),b=new B(w,b),_=new B(_,v),w=new B(w,v),C=(m&&(v=new B(-g,g-ml),m=-Math.PI/2,g=pe/2-g,C=S.imageName?g:0,g=new B(5-ml-g,-C),C=new B(...o),x._rotateAround(m,v)._add(g)._add(C),b._rotateAround(m,v)._add(g)._add(C),_._rotateAround(m,v)._add(g)._add(C),w._rotateAround(m,v)._add(g)._add(C)),h&&(m=Math.sin(h),v=Math.cos(h),x._matMult(g=[v,-m,m,v]),b._matMult(g),_._matMult(g),w._matMult(g)),new B(0,0)),m=new B(0,0);d.push({tl:x,tr:b,bl:_,br:w,tex:p,writingMode:a.writingMode,glyphOffset:y,sectionIndex:S.sectionIndex,isSDF:t,pixelOffsetTL:C,pixelOffsetBR:m,minFontScaleX:0,minFontScaleY:0})}return d}class Oc{constructor(e,t,r,i,n,o,a,s,l,c){if(this.boxStartIndex=e.length,l){let e=o.top,t=o.bottom;var l=o.collisionPadding,l=(l&&(e-=l[1],t+=l[3]),t-e);0<l&&(l=Math.max(10,l),this.circleDiameter=l)}else{var u,l=null!=(l=o.image)&&l.contentMatch&&o.image.content?El(o):{x1:o.left,y1:o.top,x2:o.right,y2:o.bottom},s=(l.y1=l.y1*a-s[0],l.x2=l.x2*a+s[1],l.y2=l.y2*a+s[2],l.x1=l.x1*a-s[3],o.collisionPadding);s&&(l.x1-=s[0]*a,l.y1-=s[1]*a,l.x2+=s[2]*a,l.y2+=s[3]*a),c&&(o=new B(l.x1,l.y1),s=new B(l.x2,l.y1),a=new B(l.x1,l.y2),u=new B(l.x2,l.y2),c=c*Math.PI/180,o._rotate(c),s._rotate(c),a._rotate(c),u._rotate(c),l.x1=Math.min(o.x,s.x,a.x,u.x),l.x2=Math.max(o.x,s.x,a.x,u.x),l.y1=Math.min(o.y,s.y,a.y,u.y),l.y2=Math.max(o.y,s.y,a.y,u.y)),e.emplaceBack(t.x,t.y,l.x1,l.y1,l.x2,l.y2,r,i,n)}this.boxEndIndex=e.length}}class Lc{constructor(e=[],t=function(e,t){return e<t?-1:t<e?1:0}){if(this.data=e,this.length=this.data.length,this.compare=t,0<this.length)for(let e=(this.length>>1)-1;0<=e;e--)this._down(e)}push(e){this.data.push(e),this.length++,this._up(this.length-1)}pop(){var e,t;if(0!==this.length)return e=this.data[0],t=this.data.pop(),this.length--,0<this.length&&(this.data[0]=t,this._down(0)),e}peek(){return this.data[0]}_up(e){for(var{data:t,compare:r}=this,i=t[e];0<e;){var n=e-1>>1,o=t[n];if(0<=r(i,o))break;t[e]=o,e=n}t[e]=i}_down(r){for(var{data:i,compare:n}=this,e=this.length>>1,o=i[r];r<e;){let e=1+(r<<1),t=i[e];var a=e+1;if(a<this.length&&n(i[a],t)<0&&(e=a,t=i[a]),0<=n(t,o))break;i[r]=t,r=e}i[r]=o}}function Dc(r,e=1,t=!1){let i=1/0,n=1/0,o=-1/0,a=-1/0;var s=r[0];for(let e=0;e<s.length;e++){var l=s[e];(!e||l.x<i)&&(i=l.x),(!e||l.y<n)&&(n=l.y),(!e||l.x>o)&&(o=l.x),(!e||l.y>a)&&(a=l.y)}var c=o-i,u=a-n,h=Math.min(c,u);let d=h/2;var p=new Lc([],zc);if(0===h)return new B(i,n);for(let t=i;t<o;t+=h)for(let e=n;e<a;e+=h)p.push(new Nc(t+d,e+d,d,r));let f=function(e){let i=0,n=0,o=0;var a=e[0];for(let e=0,t=a.length,r=t-1;e<t;r=e++){var s=a[e],l=a[r],c=s.x*l.y-l.x*s.y;n+=(s.x+l.x)*c,o+=(s.y+l.y)*c,i+=3*c}return new Nc(n/i,o/i,0,e)}(r),m=p.length;for(;p.length;){var g=p.pop();(g.d>f.d||!f.d)&&(f=g,t)&&console.log("found best %d after %d probes",Math.round(1e4*g.d)/1e4,m),g.max-f.d<=e||(d=g.h/2,p.push(new Nc(g.p.x-d,g.p.y-d,d,r)),p.push(new Nc(g.p.x+d,g.p.y-d,d,r)),p.push(new Nc(g.p.x-d,g.p.y+d,d,r)),p.push(new Nc(g.p.x+d,g.p.y+d,d,r)),m+=4)}return t&&(console.log("num probes: "+m),console.log("best distance: "+f.d)),f.p}function zc(e,t){return t.max-e.max}function Nc(e,t,r,i){this.p=new B(e,t),this.h=r,this.d=function(i,t){let n=!1,o=1/0;for(let e=0;e<t.length;e++){var a=t[e];for(let e=0,t=a.length,r=t-1;e<t;r=e++){var s=a[e],l=a[r];s.y>i.y!=l.y>i.y&&i.x<(l.x-s.x)*(i.y-s.y)/(l.y-s.y)+s.x&&(n=!n),o=Math.min(o,Bo(i,s,l))}}return(n?1:-1)*Math.sqrt(o)}(this.p,i),this.max=this.d+this.h*Math.SQRT2}ue.TextAnchorEnum=void 0,(t=ue.TextAnchorEnum||(ue.TextAnchorEnum={}))[t.center=1]="center",t[t.left=2]="left",t[t.right=3]="right",t[t.top=4]="top",t[t.bottom=5]="bottom",t[t["top-left"]=6]="top-left",t[t["top-right"]=7]="top-right",t[t["bottom-left"]=8]="bottom-left",t[t["bottom-right"]=9]="bottom-right";const Bc=7,Fc=Number.POSITIVE_INFINITY;function Uc(r,i){if(i[1]!==Fc){var n=r,o=i[0],a=i[1];let e=0,t=0;switch(o=Math.abs(o),a=Math.abs(a),n){case"top-right":case"top-left":case"top":t=a-Bc;break;case"bottom-right":case"bottom-left":case"bottom":t=-a+Bc}switch(n){case"top-right":case"bottom-right":case"right":e=-o;break;case"top-left":case"bottom-left":case"left":e=o}return[e,t]}{var n=r,s=i[0];let e=0,t=0;var l=(s=s<0?0:s)/Math.SQRT2;switch(n){case"top-right":case"top-left":t=l-Bc;break;case"bottom-right":case"bottom-left":t=-l+Bc;break;case"bottom":t=-s+Bc;break;case"top":t=s-Bc}switch(n){case"top-right":case"bottom-right":e=-l;break;case"top-left":case"bottom-left":e=l;break;case"left":e=s;break;case"right":e=-s}return[e,t]}}function qc(t,r,i){var n=t.layout,o=null==(o=n.get("text-variable-anchor-offset"))?void 0:o.evaluate(r,{},i);if(o){var a=o.values,s=[];for(let e=0;e<a.length;e+=2){var l=s[e]=a[e],c=a[e+1].map(e=>e*pe);l.startsWith("top")?c[1]-=Bc:l.startsWith("bottom")&&(c[1]+=Bc),s[e+1]=c}return new xt(s)}o=n.get("text-variable-anchor");if(o){let e;var t=t._unevaluatedLayout,u=(e=void 0!==t.getValue("text-radial-offset")?[n.get("text-radial-offset").evaluate(r,{},i)*pe,Fc]:n.get("text-offset").evaluate(r,{},i).map(e=>e*pe),[]);for(const h of o)u.push(h,Uc(h,e));return new xt(u)}return null}function jc(e){switch(e){case"right":case"top-right":case"bottom-right":return"right";case"left":case"top-left":case"bottom-left":return"left"}return"center"}function Hc(e,t,r,i,n,o,a,s,l,c,u,h,d,p,f){r=Rc(0,r,s,n,o,a,i,e.allowVerticalPlacement),i=e.textSizeData;let m=null;"source"===i.kind?(m=[kl*n.layout.get("text-size").evaluate(a,{})])[0]>Pl&&he(`${e.layerIds[0]}: Value for "text-size" is >= ${Al}. Reduce your "text-size".`):"composite"===i.kind&&((m=[kl*p.compositeTextSizes[0].evaluate(a,{},f),kl*p.compositeTextSizes[1].evaluate(a,{},f)])[0]>Pl||m[1]>Pl)&&he(`${e.layerIds[0]}: Value for "text-size" is >= ${Al}. Reduce your "text-size".`),e.addSymbols(e.text,r,m,s,o,a,c,t,l.lineStartIndex,l.lineLength,d,f);for(const g of u)h[g]=e.text.placedSymbolArray.length-1;return 4*r.length}function Vc(e){for(const t in e)return e[t];return null}const Gc=[Int8Array,Uint8Array,Uint8ClampedArray,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];function Kc(r,i,n,o,a,s){for(;o<a;){600<a-o&&(l=a-o+1,c=n-o+1,h=Math.log(l),u=.5*Math.exp(2*h/3),h=.5*Math.sqrt(h*u*(l-u)/l)*(c-l/2<0?-1:1),Kc(r,i,n,Math.max(o,Math.floor(n-c*u/l+h)),Math.min(a,Math.floor(n+(l-c)*u/l+h)),s));var l,c,u,h,d=i[2*n+s];let e=o,t=a;for(Zc(r,i,o,n),i[2*a+s]>d&&Zc(r,i,o,a);e<t;){for(Zc(r,i,e,t),e++,t--;i[2*e+s]<d;)e++;for(;i[2*t+s]>d;)t--}i[2*o+s]===d?Zc(r,i,o,t):Zc(r,i,++t,a),t<=n&&(o=t+1),n<=t&&(a=t-1)}}function Zc(e,t,r,i){Wc(e,r,i),Wc(t,2*r,2*i),Wc(t,2*r+1,2*i+1)}function Wc(e,t,r){var i=e[t];e[t]=e[r],e[r]=i}function Yc(e,t,r,i){e-=r,r=t-i;return e*e+r*r}ue.PerformanceMarkers=void 0,(t=ue.PerformanceMarkers||(ue.PerformanceMarkers={})).create="create",t.load="load",t.fullLoad="fullLoad";let $c=null,Xc=[];const Jc=1e3/60,Qc="loadTime",eu="fullLoadTime";t={mark(e){performance.mark(e)},frame(e){var t;null!=$c&&(t=e-$c,Xc.push(t)),$c=e},clearMetrics(){$c=null,Xc=[],performance.clearMeasures(Qc),performance.clearMeasures(eu);for(const e in ue.PerformanceMarkers)performance.clearMarks(ue.PerformanceMarkers[e])},getPerformanceMetrics(){performance.measure(Qc,ue.PerformanceMarkers.create,ue.PerformanceMarkers.load),performance.measure(eu,ue.PerformanceMarkers.create,ue.PerformanceMarkers.fullLoad);var e=performance.getEntriesByName(Qc)[0].duration,t=performance.getEntriesByName(eu)[0].duration,r=Xc.length,i=1/(Xc.reduce((e,t)=>e+t,0)/r/1e3),n=Xc.filter(e=>e>Jc).reduce((e,t)=>e+(t-Jc)/Jc,0);return{loadTime:e,fullLoadTime:t,fps:i,percentDroppedFrames:n/(r+n)*100,totalFrames:r}}};ue.AJAXError=me,ue.Actor=class{constructor(e,t){var r,i,n,o;this.target=e,this.mapId=t,this.resolveRejects={},this.tasks={},this.taskQueue=[],this.abortControllers={},this.messageHandlers={},this.invoker=new Ql(()=>this.process()),this.subscription=(r=this.target,i="message",o=!(n=e=>this.receive(e)),r.addEventListener(i,n,o),{unsubscribe:()=>{r.removeEventListener(i,n,o)}}),this.globalScope=X(self)?e:window}registerMessageHandler(e,t){this.messageHandlers[e]=t}sendAsync(i,n){return new Promise((e,t)=>{const r=Math.round(1e18*Math.random()).toString(36).substring(0,10);this.resolveRejects[r]={resolve:e,reject:t},n&&n.signal.addEventListener("abort",()=>{delete this.resolveRejects[r];var e={id:r,type:"<cancel>",origin:location.origin,targetMapId:i.targetMapId,sourceMapId:this.mapId};this.target.postMessage(e)},{once:!0});e=[],t=Object.assign(Object.assign({},i),{id:r,sourceMapId:this.mapId,origin:location.origin,data:Di(i.data,e)});this.target.postMessage(t,{transfer:e})})}receive(e){var t,e=e.data,r=e.id;"file://"!==e.origin&&"file://"!==location.origin&&e.origin!==location.origin||e.targetMapId&&this.mapId!==e.targetMapId||("<cancel>"===e.type?(delete this.tasks[r],t=this.abortControllers[r],delete this.abortControllers[r],t&&t.abort()):X(self)||e.mustQueue?(this.tasks[r]=e,this.taskQueue.push(r),this.invoker.trigger()):this.processTask(r,e))}process(){var e,t;0!==this.taskQueue.length&&(e=this.taskQueue.shift(),t=this.tasks[e],delete this.tasks[e],0<this.taskQueue.length&&this.invoker.trigger(),t)&&this.processTask(e,t)}processTask(i,n){return E(this,void 0,void 0,function*(){if("<response>"===n.type)return e=this.resolveRejects[i],delete this.resolveRejects[i],e?void(n.error?e.reject(zi(n.error)):e.resolve(zi(n.data))):void 0;if(this.messageHandlers[n.type]){var e=zi(n.data),t=new AbortController;this.abortControllers[i]=t;try{var r=yield this.messageHandlers[n.type](n.sourceMapId,e,t);this.completeTask(i,null,r)}catch(e){this.completeTask(i,e)}}else this.completeTask(i,new Error(`Could not find a registered handler for ${n.type}, map ID: ${this.mapId}, available handlers: `+Object.keys(this.messageHandlers).join(", ")))})}completeTask(e,t,r){var i=[],e=(delete this.abortControllers[e],{id:e,type:"<response>",sourceMapId:this.mapId,origin:location.origin,error:t?Di(t):null,data:Di(r,i)});this.target.postMessage(e,{transfer:i})}remove(){this.invoker.remove(),this.subscription.unsubscribe()}},ue.AlphaImage=ya,ue.CanonicalTileID=uc,ue.CollisionBoxArray=Rn,ue.CollisionCircleLayoutArray=class extends bn{},ue.Color=_,ue.DEMData=fc,ue.DataConstantProperty=i,ue.DictionaryCoder=mc,ue.EXTENT=de,ue.ErrorEvent=Ce,ue.EvaluationParameters=P,ue.Event=xe,ue.Evented=Te,ue.FeatureIndex=yc,ue.FillBucket=$a,ue.FillExtrusionBucket=ms,ue.GLOBAL_DISPATCHER_ID=fe,ue.GeoJSONFeature=gc,ue.ImageAtlas=fl,ue.ImagePosition=pl,ue.KDBush=class hu{static from(e){if(!(e instanceof ArrayBuffer))throw new Error("Data must be an instance of ArrayBuffer.");var t,[r,i]=new Uint8Array(e,0,2);if(219!==r)throw new Error("Data does not appear to be in a KDBush format.");if(1!=(r=i>>4))throw new Error(`Got v${r} data when expected v1.`);if(r=Gc[15&i])return[i]=new Uint16Array(e,2,1),[t]=new Uint32Array(e,4,1),new hu(t,i,r,e);throw new Error("Unrecognized array type.")}constructor(e,t=64,r=Float64Array,i){if(isNaN(e)||e<0)throw new Error(`Unpexpected numItems value: ${e}.`);this.numItems=+e,this.nodeSize=Math.min(Math.max(+t,2),65535),this.ArrayType=r,this.IndexArrayType=e<65536?Uint16Array:Uint32Array;var n=Gc.indexOf(this.ArrayType),o=2*e*this.ArrayType.BYTES_PER_ELEMENT,a=e*this.IndexArrayType.BYTES_PER_ELEMENT,s=(8-a%8)%8;if(n<0)throw new Error(`Unexpected typed array class: ${r}.`);i&&i instanceof ArrayBuffer?(this.data=i,this.ids=new this.IndexArrayType(this.data,8,e),this.coords=new this.ArrayType(this.data,8+a+s,2*e),this._pos=2*e,this._finished=!0):(this.data=new ArrayBuffer(8+o+a+s),this.ids=new this.IndexArrayType(this.data,8,e),this.coords=new this.ArrayType(this.data,8+a+s,2*e),this._pos=0,this._finished=!1,new Uint8Array(this.data,0,2).set([219,16+n]),new Uint16Array(this.data,2,1)[0]=t,new Uint32Array(this.data,4,1)[0]=e)}add(e,t){var r=this._pos>>1;return this.ids[r]=r,this.coords[this._pos++]=e,this.coords[this._pos++]=t,r}finish(){var e=this._pos>>1;if(e!==this.numItems)throw new Error(`Added ${e} items when expected ${this.numItems}.`);return function e(t,r,i,n,o,a){if(!(o-n<=i)){const s=n+o>>1;Kc(t,r,s,n,o,a),e(t,r,i,n,s-1,1-a),e(t,r,i,1+s,o,1-a)}}(this.ids,this.coords,this.nodeSize,0,this.numItems-1,0),this._finished=!0,this}range(t,r,i,n){if(!this._finished)throw new Error("Data not yet indexed - call index.finish().");for(var{ids:o,coords:a,nodeSize:e}=this,s=[0,o.length-1,0],l=[];s.length;){var c=s.pop()||0,u=s.pop()||0,h=s.pop()||0;if(u-h<=e)for(let e=h;e<=u;e++){var d=a[2*e],p=a[2*e+1];t<=d&&d<=i&&r<=p&&p<=n&&l.push(o[e])}else{var f=h+u>>1,m=a[2*f],g=a[2*f+1];t<=m&&m<=i&&r<=g&&g<=n&&l.push(o[f]),(0===c?t<=m:r<=g)&&(s.push(h),s.push(f-1),s.push(1-c)),(0===c?m<=i:g<=n)&&(s.push(1+f),s.push(u),s.push(1-c))}}return l}within(t,r,e){if(!this._finished)throw new Error("Data not yet indexed - call index.finish().");for(var{ids:i,coords:n,nodeSize:o}=this,a=[0,i.length-1,0],s=[],l=e*e;a.length;){var c=a.pop()||0,u=a.pop()||0,h=a.pop()||0;if(u-h<=o)for(let e=h;e<=u;e++)Yc(n[2*e],n[2*e+1],t,r)<=l&&s.push(i[e]);else{var d=h+u>>1,p=n[2*d],f=n[2*d+1];Yc(p,f,t,r)<=l&&s.push(i[d]),(0===c?t-e<=p:r-e<=f)&&(a.push(h),a.push(d-1),a.push(1-c)),(0===c?p<=t+e:f<=r+e)&&(a.push(1+d),a.push(u),a.push(1-c))}}return s}},ue.LineBucket=Es,ue.LineStripIndexArray=class extends kn{},ue.LngLat=tc,ue.MercatorCoordinate=lc,ue.ONE_EM=pe,ue.OverscaledTileID=dc,ue.PerformanceUtils=t,ue.Point=B,ue.Pos3dArray=class extends cn{},ue.PosArray=Hn,ue.Properties=a,ue.Protobuf=al,ue.QuadTriangleArray=class extends xn{},ue.RGBAImage=va,ue.RasterBoundsArray=class extends un{},ue.RequestPerformance=class{constructor(e){this._marks={start:[e.url,"start"].join("#"),end:[e.url,"end"].join("#"),measure:e.url.toString()},performance.mark(this._marks.start)}finish(){performance.mark(this._marks.end);let e=performance.getEntriesByName(this._marks.measure);return 0===e.length&&(performance.measure(this._marks.measure,this._marks.start,this._marks.end),e=performance.getEntriesByName(this._marks.measure),performance.clearMarks(this._marks.start),performance.clearMarks(this._marks.end),performance.clearMeasures(this._marks.measure)),e}},ue.SegmentVector=x,ue.SymbolBucket=Ul,ue.Transitionable=Zi,ue.TriangleIndexArray=to,ue.Uniform1f=fo,ue.Uniform1i=class extends po{constructor(e,t){super(e,t),this.current=0}set(e){this.current!==e&&(this.current=e,this.gl.uniform1i(this.location,e))}},ue.Uniform2f=class extends po{constructor(e,t){super(e,t),this.current=[0,0]}set(e){e[0]===this.current[0]&&e[1]===this.current[1]||(this.current=e,this.gl.uniform2f(this.location,e[0],e[1]))}},ue.Uniform3f=class extends po{constructor(e,t){super(e,t),this.current=[0,0,0]}set(e){e[0]===this.current[0]&&e[1]===this.current[1]&&e[2]===this.current[2]||(this.current=e,this.gl.uniform3f(this.location,e[0],e[1],e[2]))}},ue.Uniform4f=mo,ue.UniformColor=go,ue.UniformMatrix4f=class extends po{constructor(e,t){super(e,t),this.current=yo}set(t){if(t[12]!==this.current[12]||t[0]!==this.current[0])this.current=t,this.gl.uniformMatrix4fv(this.location,!1,t);else for(let e=1;e<16;e++)if(t[e]!==this.current[e]){this.current=t,this.gl.uniformMatrix4fv(this.location,!1,t);break}}},ue.UnwrappedTileID=hc,ue.ValidationError=p,ue.ZoomHistory=Ni,ue.__awaiter=E,ue.add=function(e,t,r){return e[0]=t[0]+r[0],e[1]=t[1]+r[1],e[2]=t[2]+r[2],e},ue.addDynamicAttributes=zl,ue.addProtocol=function(e,t){le.REGISTERED_PROTOCOLS[e]=t},ue.arrayBufferToImage=n=>new Promise((e,t)=>{const r=new Image;r.onload=()=>{e(r),URL.revokeObjectURL(r.src),r.onload=null,window.requestAnimationFrame(()=>{r.src=ee})},r.onerror=()=>t(new Error("Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."));var i=new Blob([new Uint8Array(n)],{type:"image/png"});r.src=n.byteLength?URL.createObjectURL(i):ee}),ue.arrayBufferToImageBitmap=t=>E(void 0,void 0,void 0,function*(){if(0===t.byteLength)return createImageBitmap(new ImageData(1,1));var e=new Blob([new Uint8Array(t)],{type:"image/png"});try{return createImageBitmap(e)}catch(e){throw new Error(`Could not load image because of ${e.message}. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported.`)}}),ue.bezier=q,ue.clamp=j,ue.clipLine=wc,ue.clone=function(e){var t=new C(16);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},ue.clone$1=W,ue.clone$2=function(e){var t=new C(3);return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},ue.collisionCircleLayout=_r,ue.config=le,ue.copy=function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},ue.create=function(){var e=new C(16);return C!=Float32Array&&(e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[11]=0,e[12]=0,e[13]=0,e[14]=0),e[0]=1,e[5]=1,e[10]=1,e[15]=1,e},ue.create$1=Wo,ue.create$2=function(){var e=new C(4);return C!=Float32Array&&(e[1]=0,e[2]=0),e[0]=1,e[3]=1,e},ue.createAbortError=se,ue.createExpression=Ur,ue.createFilter=Zr,ue.createLayout=c,ue.createStyleLayer=function(e){if("custom"===e.type)return new Jl(e);switch(e.type){case"background":return new Wl(e);case"circle":return new ca(e);case"fill":return new es(e);case"fill-extrusion":return new vs(e);case"heatmap":return new ba(e);case"hillshade":return new Ca(e);case"line":return new Rs(e);case"raster":return new Xl(e);case"symbol":return new Gl(e)}},ue.cross=ia,ue.deepEqual=function t(r,i){if(Array.isArray(r)){if(!Array.isArray(i)||r.length!==i.length)return!1;for(let e=0;e<r.length;e++)if(!t(r[e],i[e]))return!1}else{if("object"!=typeof r||null===r||null===i)return r===i;if("object"!=typeof i)return!1;if(Object.keys(r).length!==Object.keys(i).length)return!1;for(const e in r)if(!t(r[e],i[e]))return!1}return!0},ue.defaultEasing=O,ue.degreesToRadians=function(e){return e*Math.PI/180},ue.derefLayers=function(t){t=t.slice();var r=Object.create(null);for(let e=0;e<t.length;e++)r[t[e].id]=t[e];for(let e=0;e<t.length;e++)"ref"in t[e]&&(t[e]=function(e,t){const r={};for(const i in e)"ref"!==i&&(r[i]=e[i]);return Se.forEach(e=>{e in t&&(r[e]=t[e])}),r}(t[e],r[t[e].ref]));return t},ue.diffStyles=function(e,n){if(!e)return[{command:"setStyle",args:[n]}];let o=[];try{if(!v(e.version,n.version))return[{command:"setStyle",args:[n]}];v(e.center,n.center)||o.push({command:"setCenter",args:[n.center]}),v(e.zoom,n.zoom)||o.push({command:"setZoom",args:[n.zoom]}),v(e.bearing,n.bearing)||o.push({command:"setBearing",args:[n.bearing]}),v(e.pitch,n.pitch)||o.push({command:"setPitch",args:[n.pitch]}),v(e.sprite,n.sprite)||o.push({command:"setSprite",args:[n.sprite]}),v(e.glyphs,n.glyphs)||o.push({command:"setGlyphs",args:[n.glyphs]}),v(e.transition,n.transition)||o.push({command:"setTransition",args:[n.transition]}),v(e.light,n.light)||o.push({command:"setLight",args:[n.light]}),v(e.terrain,n.terrain)||o.push({command:"setTerrain",args:[n.terrain]}),v(e.sky,n.sky)||o.push({command:"setSky",args:[n.sky]});const r={};var t=[];ke(e.sources,n.sources,t,r);const y=[];e.layers&&e.layers.forEach(e=>{"source"in e&&r[e.source]?o.push({command:"removeLayer",args:[e.id]}):y.push(e)}),o=o.concat(t);{var a=y;var s=n.layers;var l=o;s=s||[];var c,u,h=(a=a||[]).map(Me),d=s.map(Me),p=a.reduce(Re,{}),f=s.reduce(Re,{}),m=h.slice(),g=Object.create(null);let r,i,t;for(let e=0,t=0;e<h.length;e++)r=h[e],Object.prototype.hasOwnProperty.call(f,r)?t++:(Ee(l,{command:"removeLayer",args:[r]}),m.splice(m.indexOf(r,t),1));for(let e=0,t=0;e<d.length;e++)r=d[d.length-1-e],m[m.length-1-e]!==r&&(Object.prototype.hasOwnProperty.call(p,r)?(Ee(l,{command:"removeLayer",args:[r]}),m.splice(m.lastIndexOf(r,m.length-t),1)):t++,i=m[m.length-e],Ee(l,{command:"addLayer",args:[f[r],i]}),m.splice(m.length-e,0,r),g[r]=!0);for(let e=0;e<d.length;e++)if(c=p[r=d[e]],u=f[r],!g[r]&&!v(c,u))if(v(c.source,u.source)&&v(c["source-layer"],u["source-layer"])&&v(c.type,u.type)){for(t in Pe(c.layout,u.layout,l,r,null,"setLayoutProperty"),Pe(c.paint,u.paint,l,r,null,"setPaintProperty"),v(c.filter,u.filter)||Ee(l,{command:"setFilter",args:[r,u.filter]}),v(c.minzoom,u.minzoom)&&v(c.maxzoom,u.maxzoom)||Ee(l,{command:"setLayerZoomRange",args:[r,u.minzoom,u.maxzoom]}),c)Object.prototype.hasOwnProperty.call(c,t)&&"layout"!==t&&"paint"!==t&&"filter"!==t&&"metadata"!==t&&"minzoom"!==t&&"maxzoom"!==t&&(0===t.indexOf("paint.")?Pe(c[t],u[t],l,r,t.slice(6),"setPaintProperty"):v(c[t],u[t])||Ee(l,{command:"setLayerProperty",args:[r,t,u[t]]}));for(t in u)Object.prototype.hasOwnProperty.call(u,t)&&!Object.prototype.hasOwnProperty.call(c,t)&&"layout"!==t&&"paint"!==t&&"filter"!==t&&"metadata"!==t&&"minzoom"!==t&&"maxzoom"!==t&&(0===t.indexOf("paint.")?Pe(c[t],u[t],l,r,t.slice(6),"setPaintProperty"):v(c[t],u[t])||Ee(l,{command:"setLayerProperty",args:[r,t,u[t]]}))}else Ee(l,{command:"removeLayer",args:[r]}),Ee(l,{command:"addLayer",args:[u,i=m[m.lastIndexOf(r)+1]]})}}catch(e){console.warn("Unable to compute style diff:",e),o=[{command:"setStyle",args:[n]}]}return o},ue.dot=ra,ue.dot$1=function(e,t){return e[0]*t[0]+e[1]*t[1]+e[2]*t[2]+e[3]*t[3]},ue.earthRadius=ec,ue.emitValidationErrors=Mi,ue.emptyStyle=function(){var t={},r=o.$version;for(const n in o.$root){var i=o.$root[n];if(i.required){let e=null;null!=(e="version"===n?r:"array"===i.type?[]:{})&&(t[n]=e)}}return t},ue.equals=function(e,t){var r=e[0],i=e[1],n=e[2],o=e[3],a=e[4],s=e[5],l=e[6],c=e[7],u=e[8],h=e[9],d=e[10],p=e[11],f=e[12],m=e[13],g=e[14],e=e[15],y=t[0],v=t[1],_=t[2],b=t[3],w=t[4],x=t[5],C=t[6],T=t[7],S=t[8],E=t[9],I=t[10],A=t[11],k=t[12],P=t[13],M=t[14],t=t[15];return Math.abs(r-y)<=R*Math.max(1,Math.abs(r),Math.abs(y))&&Math.abs(i-v)<=R*Math.max(1,Math.abs(i),Math.abs(v))&&Math.abs(n-_)<=R*Math.max(1,Math.abs(n),Math.abs(_))&&Math.abs(o-b)<=R*Math.max(1,Math.abs(o),Math.abs(b))&&Math.abs(a-w)<=R*Math.max(1,Math.abs(a),Math.abs(w))&&Math.abs(s-x)<=R*Math.max(1,Math.abs(s),Math.abs(x))&&Math.abs(l-C)<=R*Math.max(1,Math.abs(l),Math.abs(C))&&Math.abs(c-T)<=R*Math.max(1,Math.abs(c),Math.abs(T))&&Math.abs(u-S)<=R*Math.max(1,Math.abs(u),Math.abs(S))&&Math.abs(h-E)<=R*Math.max(1,Math.abs(h),Math.abs(E))&&Math.abs(d-I)<=R*Math.max(1,Math.abs(d),Math.abs(I))&&Math.abs(p-A)<=R*Math.max(1,Math.abs(p),Math.abs(A))&&Math.abs(f-k)<=R*Math.max(1,Math.abs(f),Math.abs(k))&&Math.abs(m-P)<=R*Math.max(1,Math.abs(m),Math.abs(P))&&Math.abs(g-M)<=R*Math.max(1,Math.abs(g),Math.abs(M))&&Math.abs(e-t)<=R*Math.max(1,Math.abs(e),Math.abs(t))},ue.evaluateSizeForFeature=function(e,{uSize:t,uSizeT:r},{lowerSize:i,upperSize:n}){return"source"===e.kind?i/kl:"composite"===e.kind?k.number(i/kl,n/kl,r):t},ue.evaluateSizeForZoom=function(e,t){let r=0,i=0;var n,o,a;return"constant"===e.kind?i=e.layoutSize:"source"!==e.kind&&({interpolationType:a,minZoom:n,maxZoom:o}=e,a=a?j(dr.interpolationFactor(a,t,n,o),0,1):0,"camera"===e.kind?i=k.number(e.minSize,e.maxSize,a):r=a),{uSizeT:r,uSize:i}},ue.exactEquals=function(e,t){return e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]&&e[9]===t[9]&&e[10]===t[10]&&e[11]===t[11]&&e[12]===t[12]&&e[13]===t[13]&&e[14]===t[14]&&e[15]===t[15]},ue.extend=V,ue.filterObject=Z,ue.findLineIntersection=function(e,t,r,i){var n=t.y-e.y,t=t.x-e.x,o=i.y-r.y,i=i.x-r.x,a=o*t-i*n;return 0==a?null:(i=(i*(e.y-r.y)-o*(e.x-r.x))/a,new B(e.x+i*t,e.y+i*n))},ue.fromRotation=function(e,t){var r=Math.sin(t),t=Math.cos(t);return e[0]=t,e[1]=r,e[2]=0,e[3]=-r,e[4]=t,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e},ue.fromScaling=function(e,t){return e[0]=t[0],e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=t[1],e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=t[2],e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e},ue.getAnchorAlignment=Sl,ue.getAnchorJustification=jc,ue.getArrayBuffer=(e,t)=>ve(V(e,{type:"arrayBuffer"}),t),ue.getDefaultExportFromCjs=I,ue.getImageData=function(s,l,c,u,h){return E(this,void 0,void 0,function*(){if(U())try{return yield te(s,l,c,u,h)}catch(e){}return t=l,r=c,i=u,n=h,o=(e=s).width,a=e.height,re&&oe||(re=new OffscreenCanvas(o,a),oe=re.getContext("2d",{willReadFrequently:!0})),re.width=o,re.height=a,oe.drawImage(e,0,0,o,a),e=oe.getImageData(t,r,i,n),oe.clearRect(0,0,o,a),e.data;var e,t,r,i,n,o,a})},ue.getJSON=(e,t)=>ve(V(e,{type:"json"}),t),ue.getOverlapMode=Rl,ue.getProtocol=ce,ue.getReferrer=ge,ue.getVideo=i=>{const n=window.document.createElement("video");return n.muted=!0,new Promise(e=>{n.onloadstart=()=>{e(n)};for(const r of i){var t=window.document.createElement("source");_e(r)||(n.crossOrigin="Anonymous"),t.src=r,n.appendChild(t)}})},ue.groupByLayout=function(r,i){var n={};for(let t=0;t<r.length;t++){var o=i&&i[r[t].id]||ei(r[t]);i&&(i[r[t].id]=o);let e=n[o];(e=e||(n[o]=[])).push(r[t])}var e=[];for(const t in n)e.push(n[t]);return e},ue.identity=Yo,ue.interpolate=k,ue.invert=function(e,t){var r=t[0],i=t[1],n=t[2],o=t[3],a=t[4],s=t[5],l=t[6],c=t[7],u=t[8],h=t[9],d=t[10],p=t[11],f=t[12],m=t[13],g=t[14],t=t[15],y=r*s-i*a,v=r*l-n*a,_=r*c-o*a,b=i*l-n*s,w=i*c-o*s,x=n*c-o*l,C=u*m-h*f,T=u*g-d*f,S=u*t-p*f,E=h*g-d*m,I=h*t-p*m,A=d*t-p*g,k=y*A-v*I+_*E+b*S-w*T+x*C;return k?(e[0]=(s*A-l*I+c*E)*(k=1/k),e[1]=(n*I-i*A-o*E)*k,e[2]=(m*x-g*w+t*b)*k,e[3]=(d*w-h*x-p*b)*k,e[4]=(l*S-a*A-c*T)*k,e[5]=(r*A-n*S+o*T)*k,e[6]=(g*_-f*x-t*v)*k,e[7]=(u*x-d*_+p*v)*k,e[8]=(a*I-s*S+c*C)*k,e[9]=(i*S-r*I-o*C)*k,e[10]=(f*w-m*_+t*y)*k,e[11]=(h*_-u*w-p*y)*k,e[12]=(s*T-a*E-l*C)*k,e[13]=(r*E-i*T+n*C)*k,e[14]=(m*v-f*b-g*y)*k,e[15]=(u*b-h*v+d*y)*k,e):null},ue.isAbortError=function(e){return e.message===ae},ue.isImageBitmap=Q,ue.isOffscreenCanvasDistorted=U,ue.isSafari=function(e){var t;return null==J&&(t=e.navigator?e.navigator.userAgent:null,J=!!e.safari||!(!t||!(/\b(iPad|iPhone|iPod)\b/.test(t)||t.match("Safari")&&!t.match("Chrome")))),J},ue.isWorker=X,ue.keysDifference=function(e,t){var r=[];for(const i in e)i in t||r.push(i);return r},ue.makeRequest=ve,ue.mapObject=K,ue.mercatorXfromLng=nc,ue.mercatorYfromLat=oc,ue.mercatorZfromAltitude=ac,ue.mul=br,ue.mul$1=aa,ue.multiply=$o,ue.nextPowerOfTwo=function(e){return e<=1?1:Math.pow(2,Math.ceil(Math.log(e)/Math.LN2))},ue.normalize=ta,ue.offscreenCanvasSupported=N,ue.ortho=Jo,ue.parseCacheControl=function(e){const n={};return e.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g,(e,t,r,i)=>{r=r||i;return n[t]=!r||r.toLowerCase(),""}),n["max-age"]&&(e=parseInt(n["max-age"],10),isNaN(e)?delete n["max-age"]:n["max-age"]=e),n},ue.parseGlyphPbf=function(e){return new al(e).readFields(ll,[])},ue.pbf=e,ue.performSymbolLayout=function(i){i.bucket.createArrays();var e,t,r=512*i.bucket.overscaling,n=(i.bucket.tilePixelRatio=de/r,i.bucket.compareText={},i.bucket.iconsNeedLinear=!1,i.bucket.layers[0]),o=n.layout,a={layoutIconSize:(r=n._unevaluatedLayout._values)["icon-size"].possiblyEvaluate(new P(i.bucket.zoom+1),i.canonical),layoutTextSize:r["text-size"].possiblyEvaluate(new P(i.bucket.zoom+1),i.canonical),textMaxSize:r["text-size"].possiblyEvaluate(new P(18))};"composite"===i.bucket.textSizeData.kind&&({minZoom:e,maxZoom:t}=i.bucket.textSizeData,a.compositeTextSizes=[r["text-size"].possiblyEvaluate(new P(e),i.canonical),r["text-size"].possiblyEvaluate(new P(t),i.canonical)]),"composite"===i.bucket.iconSizeData.kind&&({minZoom:e,maxZoom:t}=i.bucket.iconSizeData,a.compositeIconSizes=[r["icon-size"].possiblyEvaluate(new P(e),i.canonical),r["icon-size"].possiblyEvaluate(new P(t),i.canonical)]);const s=o.get("text-line-height")*pe;var l="viewport"!==o.get("text-rotation-alignment")&&"point"!==o.get("symbol-placement"),c=o.get("text-keep-upright"),u=o.get("text-size");for(const y of i.bucket.features){const v=o.get("text-font").evaluate(y,{},i.canonical).join(","),_=u.evaluate(y,{},i.canonical),b=a.layoutTextSize.evaluate(y,{},i.canonical);var h=a.layoutIconSize.evaluate(y,{},i.canonical);const w={horizontal:{},vertical:void 0},x=y.text;let r=[0,0];if(x){const C=x.toString();var d=o.get("text-letter-spacing").evaluate(y,{},i.canonical)*pe;const T=Fi(C)?d:0,S=o.get("text-anchor").evaluate(y,{},i.canonical);var p=qc(n,y,i.canonical);p||(d=o.get("text-radial-offset").evaluate(y,{},i.canonical),r=d?Uc(S,[d*pe,Fc]):o.get("text-offset").evaluate(y,{},i.canonical).map(e=>e*pe));let t=l?"center":o.get("text-justify").evaluate(y,{},i.canonical);const E=o.get("symbol-placement"),I="point"===E?o.get("text-max-width").evaluate(y,{},i.canonical)*pe:0;d=()=>{i.bucket.allowVerticalPlacement&&Bi(C)&&(w.vertical=vl(x,i.glyphMap,i.glyphPositions,i.imagePositions,v,I,s,S,"left",T,r,ue.WritingMode.vertical,!0,E,b,_))};if(!l&&p){var f,m=new Set;if("auto"===t)for(let e=0;e<p.values.length;e+=2)m.add(jc(p.values[e]));else m.add(t);let e=!1;for(const A of m)w.horizontal[A]||(e?w.horizontal[A]=w.horizontal[0]:(f=vl(x,i.glyphMap,i.glyphPositions,i.imagePositions,v,I,s,"center",A,T,r,ue.WritingMode.horizontal,!1,E,b,_))&&(w.horizontal[A]=f,e=1===f.positionedLines.length));d()}else{"auto"===t&&(t=jc(S));var g=vl(x,i.glyphMap,i.glyphPositions,i.imagePositions,v,I,s,S,t,T,r,ue.WritingMode.horizontal,!1,E,b,_);g&&(w.horizontal[t]=g),d(),Bi(C)&&l&&c&&(w.vertical=vl(x,i.glyphMap,i.glyphPositions,i.imagePositions,v,I,s,S,t,T,r,ue.WritingMode.vertical,!1,E,b,_))}}let e,t=!1;y.icon&&y.icon.name&&(g=i.imageMap[y.icon.name])&&(e=function(e,t,r){var{horizontalAlign:r,verticalAlign:i}=Sl(r),n=t[0],t=t[1],r=(n=n-e.displaySize[0]*r)+e.displaySize[0],t=t-e.displaySize[1]*i;return{image:e,top:t,bottom:t+e.displaySize[1],left:n,right:r}}(i.imagePositions[y.icon.name],o.get("icon-offset").evaluate(y,{},i.canonical),o.get("icon-anchor").evaluate(y,{},i.canonical)),t=!!g.sdf,void 0===i.bucket.sdfIcons?i.bucket.sdfIcons=t:i.bucket.sdfIcons!==t&&he("Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer"),g.pixelRatio!==i.bucket.pixelRatio||0!==o.get("icon-rotate").constantOr(1))&&(i.bucket.iconsNeedLinear=!0);d=Vc(w.horizontal)||w.vertical;i.bucket.iconsInText=!!d&&d.iconsInText,(d||e)&&!function(K,Z,W,Y,$,X,J,e,Q,ee,te){let t=X.textMaxSize.evaluate(Z,{});void 0===t&&(t=J);const r=K.layers[0].layout,re=r.get("icon-offset").evaluate(Z,{},te),i=Vc(W.horizontal),n=J/24,ie=K.tilePixelRatio*n,o=K.tilePixelRatio*t/24,ne=K.tilePixelRatio*e,a=K.tilePixelRatio*r.get("symbol-spacing"),oe=r.get("text-padding")*K.tilePixelRatio,ae=function(e,t,r,i=1){return e=e.get("icon-padding").evaluate(t,{},r),[(t=e&&e.values)[0]*i,t[1]*i,t[2]*i,t[3]*i]}(r,Z,te,K.tilePixelRatio),s=r.get("text-max-angle")/180*Math.PI,le="viewport"!==r.get("text-rotation-alignment")&&"point"!==r.get("symbol-placement"),ce="map"===r.get("icon-rotation-alignment")&&"point"!==r.get("symbol-placement"),l=r.get("symbol-placement"),b=a/2,c=r.get("icon-text-fit");let se;Y&&"none"!==c&&(K.allowVerticalPlacement&&W.vertical&&(se=Il(Y,W.vertical,c,r.get("icon-text-fit-padding"),re,n)),i)&&(Y=Il(Y,i,c,r.get("icon-text-fit-padding"),re,n));var u=(d,p)=>{if(!(p.x<0||p.x>=de||p.y<0||p.y>=de)){var f=K;var m=p;p=d;var g=W;d=Y;var y=$;var v=se;var _=K.layers[0];var b=K.collisionBoxArray;var w=Z.index;var x=Z.sourceLayerIndex;var C=K.index;var T=ie;var S=[oe,oe,oe,oe];var E=le;var I=Q;var A=ne;var k=ae;var P=ce;var M=re;var R=Z;var O=X;var L=ee;var D=te;var z=J;var N=f.addToLineVertexArray(m,p);let e,t,r,i,n=0,o=0,a=0,s=0,l=-1,c=-1;var B={};let u=lo("");f.allowVerticalPlacement&&g.vertical&&(p=_.layout.get("text-rotate").evaluate(R,{},D)+90,F=g.vertical,r=new Oc(b,m,w,x,C,F,T,S,E,p),v)&&(i=new Oc(b,m,w,x,C,v,A,k,E,p));if(d){var F=_.layout.get("icon-rotate").evaluate(R,{}),p="none"!==_.layout.get("icon-text-fit"),U=kc(d,F,L,p),v=v?kc(v,F,L,p):void 0,L=(t=new Oc(b,m,w,x,C,d,A,k,!1,F),n=4*U.length,f.iconSizeData);let e=null;"source"===L.kind?(e=[kl*_.layout.get("icon-size").evaluate(R,{})])[0]>Pl&&he(`${f.layerIds[0]}: Value for "icon-size" is >= ${Al}. Reduce your "icon-size".`):"composite"===L.kind&&((e=[kl*O.compositeIconSizes[0].evaluate(R,{},D),kl*O.compositeIconSizes[1].evaluate(R,{},D)])[0]>Pl||e[1]>Pl)&&he(`${f.layerIds[0]}: Value for "icon-size" is >= ${Al}. Reduce your "icon-size".`),f.addSymbols(f.icon,U,e,M,P,R,ue.WritingMode.none,m,N.lineStartIndex,N.lineLength,-1,D),l=f.icon.placedSymbolArray.length-1,v&&(o=4*v.length,f.addSymbols(f.icon,v,e,M,P,R,ue.WritingMode.vertical,m,N.lineStartIndex,N.lineLength,-1,D),c=f.icon.placedSymbolArray.length-1)}var q=Object.keys(g.horizontal);for(const G of q){var j=g.horizontal[G],H=(e||(u=lo(j.text),H=_.layout.get("text-rotate").evaluate(R,{},D),e=new Oc(b,m,w,x,C,j,T,S,E,H)),1===j.positionedLines.length);if(a+=Hc(f,m,j,y,_,E,R,I,N,g.vertical?ue.WritingMode.horizontal:ue.WritingMode.horizontalOnly,H?q:[G],B,l,O,D),H)break}g.vertical&&(s+=Hc(f,m,g.vertical,y,_,E,R,I,N,ue.WritingMode.vertical,["vertical"],B,c,O,D));p=e?e.boxStartIndex:f.collisionBoxArray.length,d=e?e.boxEndIndex:f.collisionBoxArray.length,A=r?r.boxStartIndex:f.collisionBoxArray.length,k=r?r.boxEndIndex:f.collisionBoxArray.length,L=t?t.boxStartIndex:f.collisionBoxArray.length,U=t?t.boxEndIndex:f.collisionBoxArray.length,v=i?i.boxStartIndex:f.collisionBoxArray.length,M=i?i.boxEndIndex:f.collisionBoxArray.length;let h=-1;P=(e,t)=>e&&e.circleDiameter?Math.max(e.circleDiameter,t):t,h=P(e,h),h=P(r,h),h=P(t,h),P=-1<(h=P(i,h))?1:0;P&&(h*=z/pe);f.glyphOffsetArray.length>=Ul.MAX_GLYPHS&&he("Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907");void 0!==R.sortKey&&f.addToSortKeyRanges(f.symbolInstances.length,R.sortKey);var z=qc(_,R,D),[z,V]=function(t,e){var r=t.length,i=null==e?void 0:e.values;if(0<(null==i?void 0:i.length))for(let e=0;e<i.length;e+=2){var n=ue.TextAnchorEnum[i[e]],o=i[e+1];t.emplaceBack(n,o[0],o[1])}return[r,t.length]}(f.textAnchorOffsets,z);f.symbolInstances.emplaceBack(m.x,m.y,0<=B.right?B.right:-1,0<=B.center?B.center:-1,0<=B.left?B.left:-1,B.vertical||-1,l,c,u,p,d,A,k,L,U,v,M,w,a,s,n,o,P,0,T,h,z,V)}};if("line"===l)for(const p of wc(Z.geometry,0,0,de,de))for(const f of Ic(p,a,s,W.vertical||i,Y,24,o,K.overscaling,de))i&&function(e,t,r,i){e=e.compareText;if(t in e){var n=e[t];for(let e=n.length-1;0<=e;e--)if(i.dist(n[e])<r)return 1}else e[t]=[];return e[t].push(i),0}(K,i.text,b,f)||u(p,f);else if("line-center"===l)for(const m of Z.geometry){var h;1<m.length&&(h=function(t,r,e,i,n,o){var a=Sc(e,n,o),s=Ec(e,i)*o;let l=0;var c=Tc(t)/2;for(let e=0;e<t.length-1;e++){var u,h,d=t[e],p=t[e+1],f=d.dist(p);if(l+f>c)return u=(c-l)/f,h=k.number(d.x,p.x,u),u=k.number(d.y,p.y,u),(h=new xc(h,u,p.angleTo(d),e))._round(),!a||Cc(t,h,s,a,r)?h:void 0;l+=f}}(m,s,W.vertical||i,Y,24,o))&&u(m,h)}else if("Polygon"===Z.type)for(const g of Ka(Z.geometry,0)){var d=Dc(g,16);u(g[0],new xc(d.x,d.y,0))}else if("LineString"===Z.type)for(const y of Z.geometry)u(y,new xc(y[0].x,y[0].y,0));else if("Point"===Z.type)for(const v of Z.geometry)for(const _ of v)u([_],new xc(_.x,_.y,0))}(i.bucket,y,w,e,i.imageMap,a,b,h,r,t,i.canonical)}i.showCollisionBoxes&&i.bucket.generateCollisionDebugBuffers()},ue.perspective=Xo,ue.pick=function(t,r){var i={};for(let e=0;e<r.length;e++){var n=r[e];n in t&&(i[n]=t[n])}return i},ue.pointGeometry=A,ue.polygonIntersectsPolygon=Oo,ue.potpack=dl,ue.readImageUsingVideoFrame=te,ue.register=r,ue.removeProtocol=function(e){delete le.REGISTERED_PROTOCOLS[e]},ue.renderColorRamp=_a,ue.renderStyleImage=function(e){var t=e["userImage"];return!!(t&&t.render&&t.render())&&(e.data.replace(new Uint8Array(t.data.buffer)),!0)},ue.rotate=function(e,t,r){var i=t[0],n=t[1],o=t[2],t=t[3],a=Math.sin(r),r=Math.cos(r);return e[0]=i*r+o*a,e[1]=n*r+t*a,e[2]=i*-a+o*r,e[3]=n*-a+t*r,e},ue.rotateX=function(e,t,r){var i=Math.sin(r),r=Math.cos(r),n=t[4],o=t[5],a=t[6],s=t[7],l=t[8],c=t[9],u=t[10],h=t[11];return t!==e&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[4]=n*r+l*i,e[5]=o*r+c*i,e[6]=a*r+u*i,e[7]=s*r+h*i,e[8]=l*r-n*i,e[9]=c*r-o*i,e[10]=u*r-a*i,e[11]=h*r-s*i,e},ue.rotateZ=function(e,t,r){var i=Math.sin(r),r=Math.cos(r),n=t[0],o=t[1],a=t[2],s=t[3],l=t[4],c=t[5],u=t[6],h=t[7];return t!==e&&(e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15]),e[0]=n*r+l*i,e[1]=o*r+c*i,e[2]=a*r+u*i,e[3]=s*r+h*i,e[4]=l*r-n*i,e[5]=c*r-o*i,e[6]=u*r-a*i,e[7]=h*r-s*i,e},ue.rtlWorkerPlugin=Vi,ue.sameOrigin=_e,ue.scale=function(e,t,r){var i=r[0],n=r[1],r=r[2];return e[0]=t[0]*i,e[1]=t[1]*i,e[2]=t[2]*i,e[3]=t[3]*i,e[4]=t[4]*n,e[5]=t[5]*n,e[6]=t[6]*n,e[7]=t[7]*n,e[8]=t[8]*r,e[9]=t[9]*r,e[10]=t[10]*r,e[11]=t[11]*r,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},ue.scale$1=function(e,t,r){return e[0]=t[0]*r,e[1]=t[1]*r,e[2]=t[2]*r,e},ue.sphericalToCartesian=function([e,t,r]){return t=(t+=90)*(Math.PI/180),r*=Math.PI/180,{x:e*Math.cos(t)*Math.sin(r),y:e*Math.sin(t)*Math.sin(r),z:e*Math.cos(r)}},ue.sqrLen=la,ue.sub=na,ue.toEvaluationFeature=Po,ue.transformMat3=function(e,t,r){var i=t[0],n=t[1],t=t[2];return e[0]=i*r[0]+n*r[3]+t*r[6],e[1]=i*r[1]+n*r[4]+t*r[7],e[2]=i*r[2]+n*r[5]+t*r[8],e},ue.transformMat4=oa,ue.transformMat4$1=function(e,t,r){var i=t[0],t=t[1];return e[0]=r[0]*i+r[4]*t+r[12],e[1]=r[1]*i+r[5]*t+r[13],e},ue.translate=function(e,t,r){var i,n,o,a,s,l,c,u,h,d,p,f,m=r[0],g=r[1],r=r[2];return t===e?(e[12]=t[0]*m+t[4]*g+t[8]*r+t[12],e[13]=t[1]*m+t[5]*g+t[9]*r+t[13],e[14]=t[2]*m+t[6]*g+t[10]*r+t[14],e[15]=t[3]*m+t[7]*g+t[11]*r+t[15]):(i=t[0],n=t[1],o=t[2],a=t[3],s=t[4],l=t[5],c=t[6],u=t[7],h=t[8],d=t[9],p=t[10],f=t[11],e[0]=i,e[1]=n,e[2]=o,e[3]=a,e[4]=s,e[5]=l,e[6]=c,e[7]=u,e[8]=h,e[9]=d,e[10]=p,e[11]=f,e[12]=i*m+s*g+h*r+t[12],e[13]=n*m+l*g+d*r+t[13],e[14]=o*m+c*g+p*r+t[14],e[15]=a*m+u*g+f*r+t[15]),e},ue.unicodeBlockLookup=ie,ue.uniqueId=function(){return G++},ue.v8Spec=o,ue.validateCustomStyleLayer=function(e){var t=[],r=e.id;return void 0===r&&t.push({message:`layers.${r}: missing required property "id"`}),void 0===e.render&&t.push({message:`layers.${r}: missing required method "render"`}),e.renderingMode&&"2d"!==e.renderingMode&&"3d"!==e.renderingMode&&t.push({message:`layers.${r}: property "renderingMode" must be either "2d" or "3d"`}),t},ue.validateLight=sr,ue.validateStyle=Ai,ue.vectorTile=is,ue.warnOnce=he,ue.wrap=H}),e("worker",0,function(A){class z{constructor(e){this.keyCache={},e&&this.replace(e)}replace(e){this._layerConfigs={},this._layers={},this.update(e,[])}update(e,t){for(const a of e){this._layerConfigs[a.id]=a;var r=this._layers[a.id]=A.createStyleLayer(a);r._featureFilter=A.createFilter(r.filter),this.keyCache[a.id]&&delete this.keyCache[a.id]}for(const s of t)delete this.keyCache[s],delete this._layerConfigs[s],delete this._layers[s];this.familiesBySource={};for(const e of A.groupByLayout(Object.values(this._layerConfigs),this.keyCache)){var i=e.map(e=>this._layers[e.id]),n=i[0];if("none"!==n.visibility){var o=n.source||"";let e=this.familiesBySource[o];e=e||(this.familiesBySource[o]={});o=n.sourceLayer||"_geojsonTileLayer";let t=e[o];(t=t||(e[o]=[])).push(i)}}}}class k{constructor(e){var t={},r=[];for(const p in e){var i=e[p],n=t[p]={};for(const f in i){var o,a=i[+f];a&&0!==a.bitmap.width&&0!==a.bitmap.height&&(o={x:0,y:0,w:a.bitmap.width+2,h:a.bitmap.height+2},r.push(o),n[f]={rect:o,metrics:a.metrics})}}var{w:s,h:l}=A.potpack(r),c=new A.AlphaImage({width:s||1,height:l||1});for(const m in e){var u=e[m];for(const g in u){var h,d=u[+g];d&&0!==d.bitmap.width&&0!==d.bitmap.height&&(h=t[m][g].rect,A.AlphaImage.copy(d.bitmap,c,{x:0,y:0},{x:h.x+1,y:h.y+1},d.bitmap))}}this.image=c,this.positions=t}}A.register("GlyphAtlas",k);class N{constructor(e){this.tileID=new A.OverscaledTileID(e.tileID.overscaledZ,e.tileID.wrap,e.tileID.canonical.z,e.tileID.canonical.x,e.tileID.canonical.y),this.uid=e.uid,this.zoom=e.zoom,this.pixelRatio=e.pixelRatio,this.tileSize=e.tileSize,this.source=e.source,this.overscaling=this.tileID.overscaleFactor(),this.showCollisionBoxes=e.showCollisionBoxes,this.collectResourceTiming=!!e.collectResourceTiming,this.returnDependencies=!!e.returnDependencies,this.promoteId=e.promoteId,this.inFlightDependencies=[]}parse(T,S,E,I){return A.__awaiter(this,void 0,void 0,function*(){this.status="parsing",this.data=T,this.collisionBoxArray=new A.CollisionBoxArray;var e=new A.DictionaryCoder(Object.keys(T.layers).sort()),t=new A.FeatureIndex(this.tileID,this.promoteId),r=(t.bucketLayerIDs=[],{}),i={featureIndex:t,iconDependencies:{},patternDependencies:{},glyphDependencies:{},availableImages:E},n=S.familiesBySource[this.source];for(const w in n){var o=T.layers[w];if(o){1===o.version&&A.warnOnce(`Vector tile source "${this.source}" layer "${w}" `+"does not use vector tile spec v2 and therefore may have some rendering errors.");var a=e.encode(w),s=[];for(let e=0;e<o.length;e++){var l=o.feature(e),c=t.getId(l,w);s.push({feature:l,id:c,index:e,sourceLayerIndex:a})}for(const x of n[w]){var u=x[0];u.source!==this.source&&A.warnOnce(`layer.source = ${u.source} does not equal this.source = `+this.source),u.minzoom&&this.zoom<Math.floor(u.minzoom)||u.maxzoom&&this.zoom>=u.maxzoom||"none"!==u.visibility&&(P(x,this.zoom,E),(r[u.id]=u.createBucket({index:t.bucketLayerIDs.length,layers:x,zoom:this.zoom,pixelRatio:this.pixelRatio,overscaling:this.overscaling,collisionBoxArray:this.collisionBoxArray,sourceLayerIndex:a,sourceID:this.source})).populate(s,i,this.tileID.canonical),t.bucketLayerIDs.push(x.map(e=>e.id)))}}}var h=A.mapObject(i.glyphDependencies,e=>Object.keys(e).map(Number));this.inFlightDependencies.forEach(e=>null==e?void 0:e.abort()),this.inFlightDependencies=[];let d=Promise.resolve({});Object.keys(h).length&&(f=new AbortController,this.inFlightDependencies.push(f),d=I.sendAsync({type:"GG",data:{stacks:h,source:this.source,tileID:this.tileID,type:"glyphs"}},f));h=Object.keys(i.iconDependencies);let p=Promise.resolve({});h.length&&(f=new AbortController,this.inFlightDependencies.push(f),p=I.sendAsync({type:"GI",data:{icons:h,source:this.source,tileID:this.tileID,type:"icons"}},f));var f,h=Object.keys(i.patternDependencies);let m=Promise.resolve({});h.length&&(f=new AbortController,this.inFlightDependencies.push(f),m=I.sendAsync({type:"GI",data:{icons:h,source:this.source,tileID:this.tileID,type:"patterns"}},f));var[g,y,h]=yield Promise.all([d,p,m]),v=new k(g),_=new A.ImageAtlas(y,h);for(const C in r){var b=r[C];b instanceof A.SymbolBucket?(P(b.layers,this.zoom,E),A.performSymbolLayout({bucket:b,glyphMap:g,glyphPositions:v.positions,imageMap:y,imagePositions:_.iconPositions,showCollisionBoxes:this.showCollisionBoxes,canonical:this.tileID.canonical})):b.hasPattern&&(b instanceof A.LineBucket||b instanceof A.FillBucket||b instanceof A.FillExtrusionBucket)&&(P(b.layers,this.zoom,E),b.addFeatures(i,this.tileID.canonical,_.patternPositions))}return this.status="done",{buckets:Object.values(r).filter(e=>!e.isEmpty()),featureIndex:t,collisionBoxArray:this.collisionBoxArray,glyphAtlasImage:v.image,imageAtlas:_,glyphMap:this.returnDependencies?g:null,iconMap:this.returnDependencies?y:null,glyphPositions:this.returnDependencies?v.positions:null}})}}function P(e,t,r){var i=new A.EvaluationParameters(t);for(const n of e)n.recalculate(i,r)}class n{constructor(e,t,r){this.actor=e,this.layerIndex=t,this.availableImages=r,this.fetching={},this.loading={},this.loaded={}}loadVectorTile(i,e){return A.__awaiter(this,void 0,void 0,function*(){var r=yield A.getArrayBuffer(i.request,e);try{return{vectorTile:new A.vectorTile.VectorTile(new A.Protobuf(r.data)),rawData:r.data,cacheControl:r.cacheControl,expires:r.expires}}catch(e){r=new Uint8Array(r.data),r=31===r[0]&&139===r[1];let t=`Unable to parse the tile at ${i.request.url}, `;throw t+=r?"please make sure the data is not gzipped and that you have configured the relevant header in the server":"got error: "+e.messge,new Error(t)}})}loadTile(h){return A.__awaiter(this,void 0,void 0,function*(){var t=h.uid,e=!!(h&&h.request&&h.request.collectResourceTiming)&&new A.RequestPerformance(h.request),r=new N(h),i=(this.loading[t]=r,new AbortController);r.abort=i;try{var n=yield this.loadVectorTile(h,i);if(delete this.loading[t],!n)return null;var o,a=n.rawData,s={},l=(n.expires&&(s.expires=n.expires),n.cacheControl&&(s.cacheControl=n.cacheControl),{}),c=(e&&(o=e.finish())&&(l.resourceTiming=JSON.parse(JSON.stringify(o))),r.vectorTile=n.vectorTile,r.parse(n.vectorTile,this.layerIndex,this.availableImages,this.actor));this.loaded[t]=r,this.fetching[t]={rawTileData:a,cacheControl:s,resourceTiming:l};try{var u=yield c;return A.extend({rawTileData:a.slice(0)},u,s,l)}finally{delete this.fetching[t]}}catch(e){throw delete this.loading[t],r.status="done",this.loaded[t]=r,e}})}reloadTile(e){return A.__awaiter(this,void 0,void 0,function*(){var t=e.uid;if(!this.loaded||!this.loaded[t])throw new Error("Should not be trying to reload a tile that was never loaded or has been removed");var r=this.loaded[t];if(r.showCollisionBoxes=e.showCollisionBoxes,"parsing"===r.status){var i,n,o,a=yield r.parse(r.vectorTile,this.layerIndex,this.availableImages,this.actor);let e;return e=this.fetching[t]?({rawTileData:i,cacheControl:n,resourceTiming:o}=this.fetching[t],delete this.fetching[t],A.extend({rawTileData:i.slice(0)},a,n,o)):a}if("done"===r.status&&r.vectorTile)return r.parse(r.vectorTile,this.layerIndex,this.availableImages,this.actor)})}abortTile(r){return A.__awaiter(this,void 0,void 0,function*(){var e=this.loading,t=r.uid;e&&e[t]&&e[t].abort&&(e[t].abort.abort(),delete e[t])})}removeTile(e){return A.__awaiter(this,void 0,void 0,function*(){this.loaded&&this.loaded[e.uid]&&delete this.loaded[e.uid]})}}class B{constructor(){this.loaded={}}loadTile(c){return A.__awaiter(this,void 0,void 0,function*(){var{uid:e,encoding:t,rawImageData:r,redFactor:i,greenFactor:n,blueFactor:o,baseShift:a}=c,s=r.width+2,l=r.height+2,s=A.isImageBitmap(r)?new A.RGBAImage({width:s,height:l},yield A.getImageData(r,-1,-1,s,l)):r,l=new A.DEMData(e,s,t,i,n,o,a);return this.loaded=this.loaded||{},this.loaded[e]=l})}removeTile(e){var t=this.loaded,e=e.uid;t&&t[e]&&delete t[e]}}function o(e,t){if(0!==e.length){i(e[0],t);for(var r=1;r<e.length;r++)i(e[r],!t)}}function i(e,t){for(var r=0,i=0,n=0,o=e.length,a=o-1;n<o;a=n++){var s=(e[n][0]-e[a][0])*(e[a][1]+e[n][1]),l=r+s;i+=Math.abs(r)>=Math.abs(s)?r-l+s:s-l+r,r=l}0<=r+i!=!!t&&e.reverse()}var F=A.getDefaultExportFromCjs(function e(t,r){var i,n=t&&t.type;if("FeatureCollection"===n)for(i=0;i<t.features.length;i++)e(t.features[i],r);else if("GeometryCollection"===n)for(i=0;i<t.geometries.length;i++)e(t.geometries[i],r);else if("Feature"===n)e(t.geometry,r);else if("Polygon"===n)o(t.coordinates,r);else if("MultiPolygon"===n)for(i=0;i<t.coordinates.length;i++)o(t.coordinates[i],r);return t});const U=A.vectorTile.VectorTileFeature.prototype.toGeoJSON;let q=class{constructor(e){this._feature=e,this.extent=A.EXTENT,this.type=e.type,this.properties=e.tags,"id"in e&&!isNaN(e.id)&&(this.id=parseInt(e.id,10))}loadGeometry(){if(1===this._feature.type){var e=[];for(const i of this._feature.geometry)e.push([new A.Point(i[0],i[1])]);return e}var t=[];for(const n of this._feature.geometry){var r=[];for(const o of n)r.push(new A.Point(o[0],o[1]));t.push(r)}return t}toGeoJSON(e,t,r){return U.call(this,e,t,r)}},j=class{constructor(e){this.layers={_geojsonTileLayer:this},this.name="_geojsonTileLayer",this.extent=A.EXTENT,this.length=e.length,this._features=e}feature(e){return new q(this._features[e])}};var e={exports:{}},H=A.pointGeometry,V=A.vectorTile.VectorTileFeature,G=t;function t(e,t){this.options=t||{},this.features=e,this.length=e.length}function r(e,t){this.id="number"==typeof e.id?e.id:void 0,this.type=e.type,this.rawGeometry=1===e.type?[e.geometry]:e.geometry,this.properties=e.tags,this.extent=t||4096}t.prototype.feature=function(e){return new r(this.features[e],this.options.extent)},r.prototype.loadGeometry=function(){var e=this.rawGeometry;this.geometry=[];for(var t=0;t<e.length;t++){for(var r=e[t],i=[],n=0;n<r.length;n++)i.push(new H(r[n][0],r[n][1]));this.geometry.push(i)}return this.geometry},r.prototype.bbox=function(){this.geometry||this.loadGeometry();for(var e=this.geometry,t=1/0,r=-1/0,i=1/0,n=-1/0,o=0;o<e.length;o++)for(var a=e[o],s=0;s<a.length;s++)var l=a[s],t=Math.min(t,l.x),r=Math.max(r,l.x),i=Math.min(i,l.y),n=Math.max(n,l.y);return[t,i,r,n]},r.prototype.toGeoJSON=V.prototype.toGeoJSON;var K=A.pbf,a=G;function s(e){var t,r=new K,i=e,n=r;for(t in i.layers)n.writeMessage(3,Z,i.layers[t]);return r.finish()}function Z(e,t){t.writeVarintField(15,e.version||1),t.writeStringField(1,e.name||""),t.writeVarintField(5,e.extent||4096);for(var r={keys:[],values:[],keycache:{},valuecache:{}},i=0;i<e.length;i++)r.feature=e.feature(i),t.writeMessage(2,W,r);var n=r.keys;for(i=0;i<n.length;i++)t.writeStringField(3,n[i]);var o=r.values;for(i=0;i<o.length;i++)t.writeMessage(4,X,o[i])}function W(e,t){var r=e.feature;void 0!==r.id&&t.writeVarintField(1,r.id),t.writeMessage(2,Y,e),t.writeVarintField(3,r.type),t.writeMessage(4,$,r)}function Y(e,t){var r,i=e.feature,n=e.keys,o=e.values,a=e.keycache,s=e.valuecache;for(r in i.properties){var l,c=i.properties[r],u=a[r];null!==c&&(void 0===u&&(n.push(r),u=n.length-1,a[r]=u),t.writeVarint(u),void 0===(l=s[u=(u=typeof c)+":"+(c="string"!=u&&"boolean"!=u&&"number"!=u?JSON.stringify(c):c)])&&(o.push(c),l=o.length-1,s[u]=l),t.writeVarint(l))}}function f(e,t){return(t<<3)+(7&e)}function m(e){return e<<1^e>>31}function $(e,t){for(var r=e.loadGeometry(),i=e.type,n=0,o=0,a=r.length,s=0;s<a;s++){for(var l=r[s],c=1,u=(1===i&&(c=l.length),t.writeVarint(f(1,c)),3===i?l.length-1:l.length),h=0;h<u;h++){1===h&&1!==i&&t.writeVarint(f(2,u-1));var d=l[h].x-n,p=l[h].y-o;t.writeVarint(m(d)),t.writeVarint(m(p)),n+=d,o+=p}3===i&&t.writeVarint(15)}}function X(e,t){var r=typeof e;"string"==r?t.writeStringField(1,e):"boolean"==r?t.writeBooleanField(7,e):"number"==r&&(e%1!=0?t.writeDoubleField(3,e):e<0?t.writeSVarintField(6,e):t.writeVarintField(5,e))}e.exports=s,e.exports.fromVectorTileJs=s,e.exports.fromGeojsonVt=function(e,t){t=t||{};var r,i={};for(r in e)i[r]=new a(e[r].features,t),i[r].name=r,i[r].version=t.version,i[r].extent=t.extent;return s({layers:i})},e.exports.GeoJSONWrapper=a;var l,J=A.getDefaultExportFromCjs(e.exports);const Q={minZoom:0,maxZoom:16,minPoints:2,radius:40,extent:512,nodeSize:64,log:!1,generateId:!1,reduce:null,map:e=>e},u=Math.fround||(l=new Float32Array(1),e=>(l[0]=+e,l[0])),g=3,T=5,c=6;class ee{constructor(e){this.options=Object.assign(Object.create(Q),e),this.trees=new Array(this.options.maxZoom+1),this.stride=this.options.reduce?7:6,this.clusterProps=[]}load(t){var{log:r,minZoom:i,maxZoom:n}=this.options,e=(r&&console.time("total time"),`prepare ${t.length} points`),o=(r&&console.time(e),this.points=t,[]);for(let e=0;e<t.length;e++){var a,s=t[e];s.geometry&&([s,a]=s.geometry.coordinates,s=u(v(s)),a=u(_(a)),o.push(s,a,1/0,e,-1,1),this.options.reduce)&&o.push(0)}let l=this.trees[n+1]=this._createTree(o);r&&console.timeEnd(e);for(let e=n;e>=i;e--){var c=+Date.now();l=this.trees[e]=this._createTree(this._cluster(l,e)),r&&console.log("z%d: %d clusters in %dms",e,l.numItems,+Date.now()-c)}return r&&console.timeEnd("total time"),this}getClusters(e,t){let r=((e[0]+180)%360+360)%360-180;var i=Math.max(-90,Math.min(90,e[1]));let n=180===e[2]?180:((e[2]+180)%360+360)%360-180;var o=Math.max(-90,Math.min(90,e[3]));if(360<=e[2]-e[0])r=-180,n=180;else if(r>n)return e=this.getClusters([r,i,180,o],t),a=this.getClusters([-180,i,n,o],t),e.concat(a);var e=this.trees[this._limitZoom(t)],a=e.range(v(r),_(o),v(n),_(i)),s=e.data,l=[];for(const u of a){var c=this.stride*u;l.push(1<s[c+T]?h(s,c,this.clusterProps):this.points[s[c+g]])}return l}getChildren(e){var t=this._getOriginId(e),r=this._getOriginZoom(e),i="No cluster with the specified id.",n=this.trees[r];if(!n)throw new Error(i);var o=n.data;if(t*this.stride>=o.length)throw new Error(i);var r=this.options.radius/(this.options.extent*Math.pow(2,r-1)),a=o[t*this.stride],t=o[t*this.stride+1],s=[];for(const c of n.within(a,t,r)){var l=c*this.stride;o[4+l]===e&&s.push(1<o[l+T]?h(o,l,this.clusterProps):this.points[o[l+g]])}if(0===s.length)throw new Error(i);return s}getLeaves(e,t,r){var i=[];return this._appendLeaves(i,e,t=t||10,r=r||0,0),i}getTile(e,t,r){var i=this.trees[this._limitZoom(e)],e=Math.pow(2,e),{extent:n,radius:o}=this.options,o=o/n,n=(r-o)/e,a=(r+1+o)/e,s={features:[]};return this._addTileFeatures(i.range((t-o)/e,n,(t+1+o)/e,a),i.data,t,r,e,s),0===t&&this._addTileFeatures(i.range(1-o/e,n,1,a),i.data,e,r,e,s),t===e-1&&this._addTileFeatures(i.range(0,n,o/e,a),i.data,-1,r,e,s),s.features.length?s:null}getClusterExpansionZoom(e){let t=this._getOriginZoom(e)-1;for(;t<=this.options.maxZoom;){var r=this.getChildren(e);if(t++,1!==r.length)break;e=r[0].properties.cluster_id}return t}_appendLeaves(e,t,r,i,n){for(const a of this.getChildren(t)){var o=a.properties;if(o&&o.cluster?n+o.point_count<=i?n+=o.point_count:n=this._appendLeaves(e,o.cluster_id,r,i,n):n<i?n++:e.push(a),e.length===r)break}return n}_createTree(t){var r=new A.KDBush(t.length/this.stride|0,this.options.nodeSize,Float32Array);for(let e=0;e<t.length;e+=this.stride)r.add(t[e],t[e+1]);return r.finish(),r.data=t,r}_addTileFeatures(e,n,o,a,s,l){for(const p of e){var c,u=p*this.stride,h=1<n[u+T];let e,t,r;r=h?(e=y(n,u,this.clusterProps),t=n[u],n[1+u]):(d=this.points[n[u+g]],[d,c]=(e=d.properties,d.geometry.coordinates),t=v(d),_(c));var d={type:1,geometry:[[Math.round(this.options.extent*(t*s-o)),Math.round(this.options.extent*(r*s-a))]],tags:e};let i;void 0!==(i=h||this.options.generateId?n[u+g]:this.points[n[u+g]].id)&&(d.id=i),l.features.push(d)}}_limitZoom(e){return Math.max(this.options.minZoom,Math.min(Math.floor(+e),this.options.maxZoom+1))}_cluster(e,a){var{radius:t,extent:r,reduce:s,minPoints:i}=this.options,l=t/(r*Math.pow(2,a)),c=e.data,u=[],h=this.stride;for(let o=0;o<c.length;o+=h)if(!(c[o+2]<=a)){c[o+2]=a;var d=c[o],p=c[o+1],f=e.within(c[o],c[o+1],l),m=c[o+T];let n=m;for(const w of f){var g=w*h;c[2+g]>a&&(n+=c[g+T])}if(n>m&&n>=i){let e=d*m,t=p*m,r,i=-1;var y=((o/h|0)<<5)+(a+1)+this.points.length;for(const x of f){var v,_=x*h;c[2+_]<=a||(c[2+_]=a,v=c[_+T],e+=c[_]*v,t+=c[1+_]*v,c[4+_]=y,s&&(r||(r=this._map(c,o,!0),i=this.clusterProps.length,this.clusterProps.push(r)),s(r,this._map(c,_))))}c[o+4]=y,u.push(e/n,t/n,1/0,y,-1,n),s&&u.push(i)}else{for(let e=0;e<h;e++)u.push(c[o+e]);if(1<n)for(const C of f){var b=C*h;if(!(c[2+b]<=a)){c[2+b]=a;for(let e=0;e<h;e++)u.push(c[b+e])}}}}return u}_getOriginId(e){return e-this.points.length>>5}_getOriginZoom(e){return(e-this.points.length)%32}_map(e,t,r){var i;return 1<e[t+T]?(i=this.clusterProps[e[t+c]],r?Object.assign({},i):i):(i=this.points[e[t+g]].properties,e=this.options.map(i),r&&e===i?Object.assign({},e):e)}}function h(e,t,r){return{type:"Feature",id:e[t+g],properties:y(e,t,r),geometry:{type:"Point",coordinates:[360*(e[t]-.5),function(e){e=(180-360*e)*Math.PI/180;return 360*Math.atan(Math.exp(e))/Math.PI-90}(e[t+1])]}}}function y(e,t,r){var i=e[t+T],n=1e4<=i?Math.round(i/1e3)+"k":1e3<=i?Math.round(i/100)/10+"k":i,o=e[t+c],r=-1===o?{}:Object.assign({},r[o]);return Object.assign(r,{cluster:!0,cluster_id:e[t+g],point_count:i,point_count_abbreviated:n})}function v(e){return e/360+.5}function _(e){e=Math.sin(e*Math.PI/180),e=.5-.25*Math.log((1+e)/(1-e))/Math.PI;return e<0?0:1<e?1:e}function b(e,t,r,i){for(var n,o=i,a=r-t>>1,s=r-t,l=e[t],c=e[t+1],u=e[r],h=e[r+1],d=t+3;d<r;d+=3){var p=function(e,t,r,i,n,o){var a=n-r,s=o-i;{var l;0==a&&0==s||(1<(l=((e-r)*a+(t-i)*s)/(a*a+s*s))?(r=n,i=o):0<l&&(r+=a*l,i+=s*l))}return(a=e-r)*a+(s=t-i)*s}(e[d],e[d+1],l,c,u,h);o<p?(n=d,o=p):p===o&&(p=Math.abs(d-a))<s&&(n=d,s=p)}i<o&&(3<n-t&&b(e,t,n,i),e[n+2]=o,3<r-n)&&b(e,n,r,i)}function S(e,t,r,i){var e={id:void 0===e?null:e,type:t,geometry:r,tags:i,minX:1/0,minY:1/0,maxX:-1/0,maxY:-1/0},n=e,o=n.geometry,t=n.type;if("Point"===t||"MultiPoint"===t||"LineString"===t)d(n,o);else if("Polygon"===t||"MultiLineString"===t)for(var a=0;a<o.length;a++)d(n,o[a]);else if("MultiPolygon"===t)for(a=0;a<o.length;a++)for(var s=0;s<o[a].length;s++)d(n,o[a][s]);return e}function d(e,t){for(var r=0;r<t.length;r+=3)e.minX=Math.min(e.minX,t[r]),e.minY=Math.min(e.minY,t[r+1]),e.maxX=Math.max(e.maxX,t[r]),e.maxY=Math.max(e.maxY,t[r+1])}function p(e,t,r,i){if(t.geometry){var n=t.geometry.coordinates,o=t.geometry.type,a=Math.pow(r.tolerance/((1<<r.maxZoom)*r.extent),2),s=[],l=t.id;if(r.promoteId?l=t.properties[r.promoteId]:r.generateId&&(l=i||0),"Point"===o)te(n,s);else if("MultiPoint"===o)for(var c=0;c<n.length;c++)te(n[c],s);else if("LineString"===o)w(n,s,a,!1);else if("MultiLineString"===o){if(r.lineMetrics){for(c=0;c<n.length;c++)w(n[c],s=[],a,!1),e.push(S(l,"LineString",s,t.properties));return}x(n,s,a,!1)}else if("Polygon"===o)x(n,s,a,!0);else{if("MultiPolygon"!==o){if("GeometryCollection"!==o)throw new Error("Input data is not a valid GeoJSON object.");for(c=0;c<t.geometry.geometries.length;c++)p(e,{id:l,geometry:t.geometry.geometries[c],properties:t.properties},r,i);return}for(c=0;c<n.length;c++){var u=[];x(n[c],u,a,!0),s.push(u)}}e.push(S(l,o,s,t.properties))}}function te(e,t){t.push(re(e[0])),t.push(ie(e[1])),t.push(0)}function w(e,t,r,i){for(var n,o,a=0,s=0;s<e.length;s++){var l=re(e[s][0]),c=ie(e[s][1]);t.push(l),t.push(c),t.push(0),0<s&&(a+=i?(n*c-l*o)/2:Math.sqrt(Math.pow(l-n,2)+Math.pow(c-o,2))),n=l,o=c}var u=t.length-3;t[2]=1,b(t,0,u,r),t[2+u]=1,t.size=Math.abs(a),t.start=0,t.end=t.size}function x(e,t,r,i){for(var n=0;n<e.length;n++){var o=[];w(e[n],o,r,i),t.push(o)}}function re(e){return e/360+.5}function ie(e){e=Math.sin(e*Math.PI/180),e=.5-.25*Math.log((1+e)/(1-e))/Math.PI;return e<0?0:1<e?1:e}function C(e,t,r,i,n,o,a,s){if(i/=t,(r/=t)<=o&&a<i)return e;if(a<r||i<=o)return null;for(var l=[],c=0;c<e.length;c++){var u=e[c],h=u.geometry,d=u.type,p=0===n?u.minX:u.minY,f=0===n?u.maxX:u.maxY;if(r<=p&&f<i)l.push(u);else if(!(f<r||i<=p)){var m=[];if("Point"===d||"MultiPoint"===d){x=w=b=_=v=y=g=void 0;for(var g=h,y=m,v=r,_=i,b=n,w=0;w<g.length;w+=3){var x=g[w+b];v<=x&&x<=_&&(y.push(g[w]),y.push(g[w+1]),y.push(g[w+2]))}}else if("LineString"===d)ne(h,m,r,i,n,!1,s.lineMetrics);else if("MultiLineString"===d)E(h,m,r,i,n,!1);else if("Polygon"===d)E(h,m,r,i,n,!0);else if("MultiPolygon"===d)for(var C=0;C<h.length;C++){var T=[];E(h[C],T,r,i,n,!0),T.length&&m.push(T)}if(m.length)if(s.lineMetrics&&"LineString"===d)for(C=0;C<m.length;C++)l.push(S(u.id,d,m[C],u.tags));else"LineString"!==d&&"MultiLineString"!==d||(1===m.length?(d="LineString",m=m[0]):d="MultiLineString"),"Point"!==d&&"MultiPoint"!==d||(d=3===m.length?"Point":"MultiPoint"),l.push(S(u.id,d,m,u.tags))}}return l.length?l:null}function ne(e,t,r,i,n,o,a){for(var s,l,c=oe(e),u=0===n?ae:se,h=e.start,d=0;d<e.length-3;d+=3){var p=e[d],f=e[d+1],m=e[d+2],g=e[d+3],y=e[d+4],v=0===n?p:f,_=0===n?g:y,b=!1;a&&(s=Math.sqrt(Math.pow(p-g,2)+Math.pow(f-y,2))),v<r?r<_&&(l=u(c,p,f,g,y,r),a)&&(c.start=h+s*l):i<v?_<i&&(l=u(c,p,f,g,y,i),a)&&(c.start=h+s*l):I(c,p,f,m),_<r&&r<=v&&(l=u(c,p,f,g,y,r),b=!0),i<_&&v<=i&&(l=u(c,p,f,g,y,i),b=!0),!o&&b&&(a&&(c.end=h+s*l),t.push(c),c=oe(e)),a&&(h+=s)}var w=e.length-3,p=e[w],f=e[1+w],m=e[2+w];r<=(v=0===n?p:f)&&v<=i&&I(c,p,f,m),w=c.length-3,o&&3<=w&&(c[w]!==c[0]||c[1+w]!==c[1])&&I(c,c[0],c[1],c[2]),c.length&&t.push(c)}function oe(e){var t=[];return t.size=e.size,t.start=e.start,t.end=e.end,t}function E(e,t,r,i,n,o){for(var a=0;a<e.length;a++)ne(e[a],t,r,i,n,o,!1)}function I(e,t,r,i){e.push(t),e.push(r),e.push(i)}function ae(e,t,r,i,n,o){i=(o-t)/(i-t);return e.push(o),e.push(r+(n-r)*i),e.push(1),i}function se(e,t,r,i,n,o){n=(o-r)/(n-r);return e.push(t+(i-t)*n),e.push(o),e.push(1),n}function le(e,t){for(var r=[],i=0;i<e.length;i++){var n=e[i],o=n.type;if("Point"===o||"MultiPoint"===o||"LineString"===o)a=M(n.geometry,t);else if("MultiLineString"===o||"Polygon"===o)for(var a=[],s=0;s<n.geometry.length;s++)a.push(M(n.geometry[s],t));else if("MultiPolygon"===o)for(a=[],s=0;s<n.geometry.length;s++){for(var l=[],c=0;c<n.geometry[s].length;c++)l.push(M(n.geometry[s][c],t));a.push(l)}r.push(S(n.id,o,a,n.tags))}return r}function M(e,t){var r=[];r.size=e.size,void 0!==e.start&&(r.start=e.start,r.end=e.end);for(var i=0;i<e.length;i+=3)r.push(e[i]+t,e[i+1],e[i+2]);return r}function ce(e,t){if(!e.transformed){for(var r,i=1<<e.z,n=e.x,o=e.y,a=0;a<e.features.length;a++){var s=e.features[a],l=s.geometry,c=s.type;if(s.geometry=[],1===c)for(r=0;r<l.length;r+=2)s.geometry.push(ue(l[r],l[r+1],t,i,n,o));else for(r=0;r<l.length;r++){for(var u=[],h=0;h<l[r].length;h+=2)u.push(ue(l[r][h],l[r][h+1],t,i,n,o));s.geometry.push(u)}}e.transformed=!0}return e}function ue(e,t,r,i,n,o){return[Math.round(r*(e*i-n)),Math.round(r*(t*i-o))]}function he(e,t,r,i,n){for(var o=t===n.maxZoom?0:n.tolerance/((1<<t)*n.extent),a={features:[],numPoints:0,numSimplified:0,numFeatures:0,source:null,x:r,y:i,z:t,transformed:!1,minX:2,minY:1,maxX:-1,maxY:0},s=0;s<e.length;s++){a.numFeatures++,_=v=y=g=m=f=p=d=h=u=c=l=void 0;var l=a,c=e[s],u=o,h=n,d=c.geometry,p=c.type,f=[];if("Point"===p||"MultiPoint"===p)for(var m=0;m<d.length;m+=3)f.push(d[m]),f.push(d[m+1]),l.numPoints++,l.numSimplified++;else if("LineString"===p)R(f,d,l,u,!1,!1);else if("MultiLineString"===p||"Polygon"===p)for(m=0;m<d.length;m++)R(f,d[m],l,u,"Polygon"===p,0===m);else if("MultiPolygon"===p)for(var g=0;g<d.length;g++){var y=d[g];for(m=0;m<y.length;m++)R(f,y[m],l,u,!0,0===m)}if(f.length){var v=c.tags||null;if("LineString"===p&&h.lineMetrics){for(var _ in v={},c.tags)v[_]=c.tags[_];v.mapbox_clip_start=d.start/d.size,v.mapbox_clip_end=d.end/d.size}h={geometry:f,type:"Polygon"===p||"MultiPolygon"===p?3:"LineString"===p||"MultiLineString"===p?2:1,tags:v};null!==c.id&&(h.id=c.id),l.features.push(h)}var h=e[s].minX,b=e[s].minY,w=e[s].maxX,x=e[s].maxY;h<a.minX&&(a.minX=h),b<a.minY&&(a.minY=b),a.maxX<w&&(a.maxX=w),a.maxY<x&&(a.maxY=x)}return a}function R(e,t,r,i,n,o){var a=i*i;if(0<i&&t.size<(n?a:i))r.numPoints+=t.length/3;else{for(var s=[],l=0;l<t.length;l+=3)(0===i||t[l+2]>a)&&(r.numSimplified++,s.push(t[l]),s.push(t[l+1])),r.numPoints++;if(n){for(var c=s,n=o,u=0,h=0,d=c.length,p=d-2;h<d;p=h,h+=2)u+=(c[h]-c[p])*(c[h+1]+c[p+1]);if(0<u===n)for(h=0,d=c.length;h<d/2;h+=2){var f=c[h],m=c[h+1];c[h]=c[d-2-h],c[h+1]=c[d-1-h],c[d-2-h]=f,c[d-1-h]=m}}e.push(s)}}function O(e,t){var r=(t=this.options=function(e,t){for(var r in t)e[r]=t[r];return e}(Object.create(this.options),t)).debug;if(r&&console.time("preprocess data"),t.maxZoom<0||24<t.maxZoom)throw new Error("maxZoom should be in the 0-24 range");if(t.promoteId&&t.generateId)throw new Error("promoteId and generateId cannot be used together.");var i,n,o,a,s,e=function(e,t){var r=[];if("FeatureCollection"===e.type)for(var i=0;i<e.features.length;i++)p(r,e.features[i],t,i);else"Feature"===e.type?p(r,e,t):p(r,{geometry:e},t);return r}(e,t);this.tiles={},this.tileCoords=[],r&&(console.timeEnd("preprocess data"),console.log("index: maxZoom: %d, maxPoints: %d",t.indexMaxZoom,t.indexMaxPoints),console.time("generate tiles"),this.stats={},this.total=0),i=e,n=(t=t).buffer/t.extent,a=C(o=i,1,-1-n,n,0,-1,2,t),s=C(i,1,1-n,2+n,0,-1,2,t),(e=o=(a||s)&&(o=C(i,1,-n,1+n,0,-1,2,t)||[],a&&(o=le(a,1).concat(o)),s)?o.concat(le(s,-1)):o).length&&this.splitTile(e,0,0,0),r&&(e.length&&console.log("features: %d, points: %d",this.tiles[0].numFeatures,this.tiles[0].numPoints),console.timeEnd("generate tiles"),console.log("tiles generated:",this.total,JSON.stringify(this.stats)))}function L(e,t,r){return 32*((1<<e)*r+t)+e}function D(e,t){return t?e.properties[t]:e.id}function de(e,t){if(null==e)return 1;if("Feature"===e.type)return null!=D(e,t);if("FeatureCollection"===e.type){var r=new Set;for(const n of e.features){var i=D(n,t);if(null==i)return;if(r.has(i))return;r.add(i)}return 1}}function pe(e,t){var r=new Map;if(null!=e)if("Feature"===e.type)r.set(D(e,t),e);else for(const i of e.features)r.set(D(i,t),i);return r}O.prototype.options={maxZoom:14,indexMaxZoom:5,indexMaxPoints:1e5,tolerance:3,extent:4096,buffer:64,lineMetrics:!1,promoteId:null,generateId:!1,debug:0},O.prototype.splitTile=function(e,t,r,i,n,o,a){for(var s=[e,t,r,i],l=this.options,c=l.debug;s.length;){i=s.pop(),r=s.pop(),t=s.pop(),e=s.pop();var u,h,d,p,f,m,g,y,v,_=1<<t,b=L(t,r,i),w=this.tiles[b];if(w||(1<c&&console.time("creation"),w=this.tiles[b]=he(e,t,r,i,l),this.tileCoords.push({z:t,x:r,y:i}),c&&(1<c&&(console.log("tile z%d-%d-%d (features: %d, points: %d, simplified: %d)",t,r,i,w.numFeatures,w.numPoints,w.numSimplified),console.timeEnd("creation")),this.stats[b="z"+t]=(this.stats[b]||0)+1,this.total++)),w.source=e,n){if(t===l.maxZoom||t===n)continue;var b=1<<n-t;if(r!==Math.floor(o/b)||i!==Math.floor(a/b))continue}else if(t===l.indexMaxZoom||w.numPoints<=l.indexMaxPoints)continue;w.source=null,0!==e.length&&(1<c&&console.time("clipping"),u=.5-(b=.5*l.buffer/l.extent),d=1+b,g=p=f=m=null,y=C(e,_,r-b,r+(h=.5+b),0,w.minX,w.maxX,l),v=C(e,_,r+u,r+d,0,w.minX,w.maxX,l),e=null,y&&(g=C(y,_,i-b,i+h,1,w.minY,w.maxY,l),p=C(y,_,i+u,i+d,1,w.minY,w.maxY,l),y=null),v&&(f=C(v,_,i-b,i+h,1,w.minY,w.maxY,l),m=C(v,_,i+u,i+d,1,w.minY,w.maxY,l),v=null),1<c&&console.timeEnd("clipping"),s.push(g||[],t+1,2*r,2*i),s.push(p||[],t+1,2*r,2*i+1),s.push(f||[],t+1,2*r+1,2*i),s.push(m||[],t+1,2*r+1,2*i+1))}},O.prototype.getTile=function(e,t,r){var i=this.options,n=i.extent,i=i.debug;if(e<0||24<e)return null;var o=1<<e,o=L(e,t=(t%o+o)%o,r);if(this.tiles[o])return ce(this.tiles[o],n);1<i&&console.log("drilling down to z%d-%d-%d",e,t,r);for(var a,s=e,l=t,c=r;!a&&0<s;)s--,l=Math.floor(l/2),c=Math.floor(c/2),a=this.tiles[L(s,l,c)];return a&&a.source&&(1<i&&console.log("found parent tile z%d-%d-%d",s,l,c),1<i&&console.time("drilling down"),this.splitTile(a.source,s,l,c,e,t,r),1<i&&console.timeEnd("drilling down"),this.tiles[o])?ce(this.tiles[o],n):null};class fe extends n{constructor(){super(...arguments),this._dataUpdateable=new Map}loadVectorTile(r,e){return A.__awaiter(this,void 0,void 0,function*(){var e=r.tileID.canonical;if(!this._geoJSONIndex)throw new Error("Unable to parse the data into a cluster or geojson");e=this._geoJSONIndex.getTile(e.z,e.x,e.y);if(!e)return null;e=new j(e.features);let t=J(e);return{vectorTile:e,rawData:(t=0===t.byteOffset&&t.byteLength===t.buffer.byteLength?t:new Uint8Array(t)).buffer}})}loadData(l){return A.__awaiter(this,void 0,void 0,function*(){null!=(i=this._pendingRequest)&&i.abort();var t,r,i=!!(l&&l.request&&l.request.collectResourceTiming)&&new A.RequestPerformance(l.request);this._pendingRequest=new AbortController;try{let e=yield this.loadGeoJSON(l,this._pendingRequest);if(delete this._pendingRequest,"object"!=typeof e)throw new Error(`Input data given to '${l.source}' is not a valid GeoJSON object.`);if(F(e,!0),l.filter){const s=A.createExpression(l.filter,{type:"boolean","property-type":"data-driven",overridable:!1,transition:!1});if("error"===s.result)throw new Error(s.value.map(e=>e.key+": "+e.message).join(", "));var n=e.features.filter(e=>s.value.evaluate({zoom:0},e));e={type:"FeatureCollection",features:n}}this._geoJSONIndex=l.cluster?new ee(function({superclusterOptions:e,clusterProperties:t}){if(t&&e){const n={},o={},a={accumulated:null,zoom:0},s={properties:null},l=Object.keys(t);for(const c of l){var[r,i]=t[c],i=A.createExpression(i),r=A.createExpression("string"==typeof r?[r,["accumulated"],["get",c]]:r);n[c]=i.value,o[c]=r.value}e.map=e=>{s.properties=e;var t={};for(const r of l)t[r]=n[r].evaluate(a,s);return t},e.reduce=(e,t)=>{s.properties=t;for(const r of l)a.accumulated=e[r],e[r]=o[r].evaluate(a,s)}}return e}(l)).load(e.features):(t=e,r=l.geojsonVtOptions,new O(t,r)),this.loaded={};var o,a={};return i&&(o=i.finish())&&(a.resourceTiming={},a.resourceTiming[l.source]=JSON.parse(JSON.stringify(o))),a}catch(e){if(delete this._pendingRequest,A.isAbortError(e))return{abandoned:!0};throw e}})}reloadTile(e){var t=this.loaded,r=e.uid;return t&&t[r]?super.reloadTile(e):this.loadTile(e)}loadGeoJSON(f,m){return A.__awaiter(this,void 0,void 0,function*(){var e=f["promoteId"];if(f.request)return i=yield A.getJSON(f.request,m),this._dataUpdateable=de(i.data,e)?pe(i.data,e):void 0,i.data;if("string"==typeof f.data)try{var t=JSON.parse(f.data);return this._dataUpdateable=de(t,e)?pe(t,e):void 0,t}catch(e){throw new Error(`Input data given to '${f.source}' is not a valid GeoJSON object.`)}if(!f.dataDiff)throw new Error(`Input data given to '${f.source}' is not a valid GeoJSON object.`);if(!this._dataUpdateable)throw new Error("Cannot update existing geojson data in "+f.source);var r=this._dataUpdateable,i=f.dataDiff,n=e;if(i.removeAll&&r.clear(),i.remove)for(const u of i.remove)r.delete(u);if(i.add)for(const h of i.add){var o=D(h,n);null!=o&&r.set(o,h)}if(i.update)for(const d of i.update){let e=r.get(d.id);if(null!=e){var a=d.newGeometry||d.removeAllProperties,s=!d.removeAllProperties&&(0<(null==(s=d.removeProperties)?void 0:s.length)||0<(null==(s=d.addOrUpdateProperties)?void 0:s.length));if((a||s)&&(e=Object.assign({},e),r.set(d.id,e),s)&&(e.properties=Object.assign({},e.properties)),d.newGeometry&&(e.geometry=d.newGeometry),d.removeAllProperties)e.properties={};else if(0<(null==(a=d.removeProperties)?void 0:a.length))for(const p of d.removeProperties)Object.prototype.hasOwnProperty.call(e.properties,p)&&delete e.properties[p];if(0<(null==(a=d.addOrUpdateProperties)?void 0:a.length))for(var{key:l,value:c}of d.addOrUpdateProperties)e.properties[l]=c}}return{type:"FeatureCollection",features:Array.from(this._dataUpdateable.values())}})}removeSource(e){return A.__awaiter(this,void 0,void 0,function*(){this._pendingRequest&&this._pendingRequest.abort()})}getClusterExpansionZoom(e){return this._geoJSONIndex.getClusterExpansionZoom(e.clusterId)}getClusterChildren(e){return this._geoJSONIndex.getChildren(e.clusterId)}getClusterLeaves(e){return this._geoJSONIndex.getLeaves(e.clusterId,e.limit,e.offset)}}class me{constructor(e){this.self=e,this.actor=new A.Actor(e),this.layerIndexes={},this.availableImages={},this.workerSources={},this.demWorkerSources={},this.externalWorkerSourceTypes={},this.self.registerWorkerSource=(e,t)=>{if(this.externalWorkerSourceTypes[e])throw new Error(`Worker source with name "${e}" already registered.`);this.externalWorkerSourceTypes[e]=t},this.self.addProtocol=A.addProtocol,this.self.removeProtocol=A.removeProtocol,this.self.registerRTLTextPlugin=e=>{if(A.rtlWorkerPlugin.isParsed())throw new Error("RTL text plugin already registered.");A.rtlWorkerPlugin.setMethods(e)},this.actor.registerMessageHandler("LDT",(e,t)=>this._getDEMWorkerSource(e,t.source).loadTile(t)),this.actor.registerMessageHandler("RDT",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){this._getDEMWorkerSource(e,t.source).removeTile(t)})),this.actor.registerMessageHandler("GCEZ",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){return this._getWorkerSource(e,t.type,t.source).getClusterExpansionZoom(t)})),this.actor.registerMessageHandler("GCC",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){return this._getWorkerSource(e,t.type,t.source).getClusterChildren(t)})),this.actor.registerMessageHandler("GCL",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){return this._getWorkerSource(e,t.type,t.source).getClusterLeaves(t)})),this.actor.registerMessageHandler("LD",(e,t)=>this._getWorkerSource(e,t.type,t.source).loadData(t)),this.actor.registerMessageHandler("LT",(e,t)=>this._getWorkerSource(e,t.type,t.source).loadTile(t)),this.actor.registerMessageHandler("RT",(e,t)=>this._getWorkerSource(e,t.type,t.source).reloadTile(t)),this.actor.registerMessageHandler("AT",(e,t)=>this._getWorkerSource(e,t.type,t.source).abortTile(t)),this.actor.registerMessageHandler("RMT",(e,t)=>this._getWorkerSource(e,t.type,t.source).removeTile(t)),this.actor.registerMessageHandler("RS",(t,r)=>A.__awaiter(this,void 0,void 0,function*(){var e;this.workerSources[t]&&this.workerSources[t][r.type]&&this.workerSources[t][r.type][r.source]&&(e=this.workerSources[t][r.type][r.source],delete this.workerSources[t][r.type][r.source],void 0!==e.removeSource)&&e.removeSource(r)})),this.actor.registerMessageHandler("RM",e=>A.__awaiter(this,void 0,void 0,function*(){delete this.layerIndexes[e],delete this.availableImages[e],delete this.workerSources[e],delete this.demWorkerSources[e]})),this.actor.registerMessageHandler("SR",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){this.referrer=t})),this.actor.registerMessageHandler("SRPS",(e,t)=>this._syncRTLPluginState(e,t)),this.actor.registerMessageHandler("IS",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){this.self.importScripts(t)})),this.actor.registerMessageHandler("SI",(e,t)=>this._setImages(e,t)),this.actor.registerMessageHandler("UL",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){this._getLayerIndex(e).update(t.layers,t.removedIds)})),this.actor.registerMessageHandler("SL",(e,t)=>A.__awaiter(this,void 0,void 0,function*(){this._getLayerIndex(e).replace(t)}))}_setImages(i,n){return A.__awaiter(this,void 0,void 0,function*(){this.availableImages[i]=n;for(const t in this.workerSources[i]){var e=this.workerSources[i][t];for(const r in e)e[r].availableImages=n}})}_syncRTLPluginState(e,r){return A.__awaiter(this,void 0,void 0,function*(){if(A.rtlWorkerPlugin.isParsed())return A.rtlWorkerPlugin.getState();if("loading"!==r.pluginStatus)return A.rtlWorkerPlugin.setState(r),r;var e=r.pluginURL,t=(this.self.importScripts(e),A.rtlWorkerPlugin.isParsed());if(t)return A.rtlWorkerPlugin.setState(t={pluginStatus:"loaded",pluginURL:e}),t;throw A.rtlWorkerPlugin.setState({pluginStatus:"error",pluginURL:""}),new Error("RTL Text Plugin failed to import scripts from "+e)})}_getAvailableImages(e){let t=this.availableImages[e];return t=t||[]}_getLayerIndex(e){let t=this.layerIndexes[e];return t=t||(this.layerIndexes[e]=new z)}_getWorkerSource(r,e,t){if(this.workerSources[r]||(this.workerSources[r]={}),this.workerSources[r][e]||(this.workerSources[r][e]={}),!this.workerSources[r][e][t]){var i={sendAsync:(e,t)=>(e.targetMapId=r,this.actor.sendAsync(e,t))};switch(e){case"vector":this.workerSources[r][e][t]=new n(i,this._getLayerIndex(r),this._getAvailableImages(r));break;case"geojson":this.workerSources[r][e][t]=new fe(i,this._getLayerIndex(r),this._getAvailableImages(r));break;default:this.workerSources[r][e][t]=new this.externalWorkerSourceTypes[e](i,this._getLayerIndex(r),this._getAvailableImages(r))}}return this.workerSources[r][e][t]}_getDEMWorkerSource(e,t){return this.demWorkerSources[e]||(this.demWorkerSources[e]={}),this.demWorkerSources[e][t]||(this.demWorkerSources[e][t]=new B),this.demWorkerSources[e][t]}}return A.isWorker(self)&&(self.worker=new me(self)),me}),e("index",0,function(e,de){var h,C="4.1.2",t="undefined"!=typeof performance&&performance&&performance.now?performance.now.bind(performance):Date.now.bind(Date);let T,I;const M={now:t,frameAsync(i){return new Promise((e,t)=>{const r=requestAnimationFrame(e);i.signal.addEventListener("abort",()=>{cancelAnimationFrame(r),t(de.createAbortError())})})},getImageData(e,t=0){return this.getImageCanvasContext(e).getImageData(-t,-t,e.width+2*t,e.height+2*t)},getImageCanvasContext(e){var t=window.document.createElement("canvas"),r=t.getContext("2d",{willReadFrequently:!0});if(r)return t.width=e.width,t.height=e.height,r.drawImage(e,0,0,e.width,e.height),r;throw new Error("failed to create canvas 2d context")},resolveURL(e){return(T=T||document.createElement("a")).href=e,T.href},hardwareConcurrency:"undefined"!=typeof navigator&&navigator.hardwareConcurrency||4,get prefersReducedMotion(){return!!matchMedia&&(I=null==I?matchMedia("(prefers-reduced-motion: reduce)"):I).matches}};class f{static testProp(t){if(f.docStyle)for(let e=0;e<t.length;e++)if(t[e]in f.docStyle)return t[e];return t[0]}static create(e,t,r){e=window.document.createElement(e);return void 0!==t&&(e.className=t),r&&r.appendChild(e),e}static createNS(e,t){return window.document.createElementNS(e,t)}static disableDrag(){f.docStyle&&f.selectProp&&(f.userSelect=f.docStyle[f.selectProp],f.docStyle[f.selectProp]="none")}static enableDrag(){f.docStyle&&f.selectProp&&(f.docStyle[f.selectProp]=f.userSelect)}static setTransform(e,t){e.style[f.transformProp]=t}static addEventListener(e,t,r,i={}){"passive"in i?e.addEventListener(t,r,i):e.addEventListener(t,r,i.capture)}static removeEventListener(e,t,r,i={}){"passive"in i?e.removeEventListener(t,r,i):e.removeEventListener(t,r,i.capture)}static suppressClickInternal(e){e.preventDefault(),e.stopPropagation(),window.removeEventListener("click",f.suppressClickInternal,!0)}static suppressClick(){window.addEventListener("click",f.suppressClickInternal,!0),window.setTimeout(()=>{window.removeEventListener("click",f.suppressClickInternal,!0)},0)}static getScale(e){var t=e.getBoundingClientRect();return{x:t.width/e.offsetWidth||1,y:t.height/e.offsetHeight||1,boundingClientRect:t}}static getPoint(e,t,r){var i=t.boundingClientRect;return new de.Point((r.clientX-i.left)/t.x-e.clientLeft,(r.clientY-i.top)/t.y-e.clientTop)}static mousePos(e,t){var r=f.getScale(e);return f.getPoint(e,r,t)}static touchPos(t,r){var i=[],n=f.getScale(t);for(let e=0;e<r.length;e++)i.push(f.getPoint(t,n,r[e]));return i}static mouseButton(e){return e.button}static remove(e){e.parentNode&&e.parentNode.removeChild(e)}}f.docStyle="undefined"!=typeof window&&window.document&&window.document.documentElement.style,f.selectProp=f.testProp(["userSelect","MozUserSelect","WebkitUserSelect","msUserSelect"]),f.transformProp=f.testProp(["transform","WebkitTransform"]);const A={supported:!1,testSupport:function(e){!P&&i&&(R?D(e):r=e)}};let r,P=!1,i,R=!1;function D(e){var t=e.createTexture();e.bindTexture(e.TEXTURE_2D,t);try{if(e.texImage2D(e.TEXTURE_2D,0,e.RGBA,e.RGBA,e.UNSIGNED_BYTE,i),e.isContextLost())return;A.supported=!0}catch(e){}e.deleteTexture(t),P=!0}"undefined"!=typeof document&&((i=document.createElement("img")).onload=function(){r&&D(r),r=null,R=!0},i.onerror=function(){P=!0,r=null},i.src="data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA="),function(e){let a,s,r,i;e.resetRequestQueue=()=>{a=[],s=0,r=0,i={}},e.addThrottleControl=e=>{var t=r++;return i[t]=e,t},e.removeThrottleControl=e=>{delete i[e],c()};e.getImage=(i,n,o=!0)=>new Promise((t,r)=>{A.supported&&(i.headers||(i.headers={}),i.headers.accept="image/webp,*/*"),de.extend(i,{type:"image"});var e={abortController:n,requestParameters:i,supportImageRefresh:o,state:"queued",onError:e=>{r(e)},onSuccess:e=>{t(e)}};a.push(e),c()});const l=e=>{return"function"==typeof createImageBitmap?de.arrayBufferToImageBitmap(e):de.arrayBufferToImage(e)},n=a=>de.__awaiter(this,void 0,void 0,function*(){a.state="running";var{requestParameters:e,supportImageRefresh:t,onError:r,onSuccess:i,abortController:n}=a,t=!1===t&&!de.isWorker(self)&&!de.getProtocol(e.url)&&(!e.headers||Object.keys(e.headers).reduce((e,t)=>e&&"accept"===t,!0)),t=(s++,t?u(e,n):de.makeRequest(e,n));try{var o=yield t;delete a.abortController,a.state="completed",o.data instanceof HTMLImageElement||de.isImageBitmap(o.data)?i(o):o.data&&i({data:yield l(o.data),cacheControl:o.cacheControl,expires:o.expires})}catch(e){delete a.abortController,r(e)}finally{s--,c()}}),c=()=>{var t=(()=>{for(const e of Object.keys(i))if(i[e]())return!0;return!1})()?de.config.MAX_PARALLEL_IMAGE_REQUESTS_PER_FRAME:de.config.MAX_PARALLEL_IMAGE_REQUESTS;for(let e=s;e<t&&0<a.length;e++){var r=a.shift();r.abortController.signal.aborted?e--:n(r)}},u=(o,a)=>new Promise((e,t)=>{const r=new Image;var i=o.url,n=o.credentials;n&&"include"===n?r.crossOrigin="use-credentials":(n&&"same-origin"===n||!de.sameOrigin(i))&&(r.crossOrigin="anonymous"),a.signal.addEventListener("abort",()=>{r.src="",t(de.createAbortError())}),r.fetchPriority="high",r.onload=()=>{r.onerror=r.onload=null,e({data:r})},r.onerror=()=>{r.onerror=r.onload=null,a.signal.aborted||t(new Error("Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."))},r.src=i})}(h=h||{}),h.resetRequestQueue();class z{constructor(e){this._transformRequestFn=e}transformRequest(e,t){return this._transformRequestFn&&this._transformRequestFn(e,t)||{url:e}}normalizeSpriteURL(e,t,r){e=function(e){var t=e.match(F);if(t)return{protocol:t[1],authority:t[2],path:t[3]||"/",params:t[4]?t[4].split("&"):[]};throw new Error(`Unable to parse URL "${e}"`)}(e);return e.path+=""+t+r,r=(t=e).params.length?"?"+t.params.join("&"):"",t.protocol+"://"+t.authority+t.path+r}setTransformRequest(e){this._transformRequestFn=e}}const F=/^(\w+):\/\/([^/?]*)(\/[^?]+)?\??(.+)?/;function U(e){var t=[];if("string"==typeof e)t.push({id:"default",url:e});else if(e&&0<e.length){var r,i,n=[];for({id:r,url:i}of e){var o=""+r+i;-1===n.indexOf(o)&&(n.push(o),t.push({id:r,url:i}))}}return t}function q(s,l,c,u){return de.__awaiter(this,void 0,void 0,function*(){var e,t,r=U(s),i=1<c?"@2x":"",n={},o={};for({id:e,url:t}of r){var a=l.transformRequest(l.normalizeSpriteURL(t,i,".json"),"SpriteJSON"),a=(n[e]=de.getJSON(a,u),l.transformRequest(l.normalizeSpriteURL(t,i,".png"),"SpriteImage"));o[e]=h.getImage(a,u)}return yield Promise.all([...Object.values(n),...Object.values(o)]),function(m,g){return de.__awaiter(this,void 0,void 0,function*(){var e={};for(const p in m){e[p]={};var t=M.getImageCanvasContext((yield g[p]).data),r=(yield m[p]).data;for(const f in r){var{width:i,height:n,x:o,y:a,sdf:s,pixelRatio:l,stretchX:c,stretchY:u,content:h,contentMatch:d}=r[f];e[p][f]={data:null,pixelRatio:l,sdf:s,stretchX:c,stretchY:u,content:h,spriteData:{width:i,height:n,x:o,y:a,context:t},contentMatch:d}}}return e})}(n,o)})}class N{constructor(e,t,r,i){this.context=e,this.format=r,this.texture=e.gl.createTexture(),this.update(t,i)}update(e,t,r){var{width:i,height:n}=e,o=!(this.size&&this.size[0]===i&&this.size[1]===n||r),a=this["context"],s=a["gl"];this.useMipmap=Boolean(t&&t.useMipmap),s.bindTexture(s.TEXTURE_2D,this.texture),a.pixelStoreUnpackFlipY.set(!1),a.pixelStoreUnpack.set(1),a.pixelStoreUnpackPremultiplyAlpha.set(this.format===s.RGBA&&(!t||!1!==t.premultiply)),o?(this.size=[i,n],e instanceof HTMLImageElement||e instanceof HTMLCanvasElement||e instanceof HTMLVideoElement||e instanceof ImageData||de.isImageBitmap(e)?s.texImage2D(s.TEXTURE_2D,0,this.format,this.format,s.UNSIGNED_BYTE,e):s.texImage2D(s.TEXTURE_2D,0,this.format,i,n,0,this.format,s.UNSIGNED_BYTE,e.data)):({x:a,y:t}=r||{x:0,y:0},e instanceof HTMLImageElement||e instanceof HTMLCanvasElement||e instanceof HTMLVideoElement||e instanceof ImageData||de.isImageBitmap(e)?s.texSubImage2D(s.TEXTURE_2D,0,a,t,s.RGBA,s.UNSIGNED_BYTE,e):s.texSubImage2D(s.TEXTURE_2D,0,a,t,i,n,s.RGBA,s.UNSIGNED_BYTE,e.data)),this.useMipmap&&this.isSizePowerOfTwo()&&s.generateMipmap(s.TEXTURE_2D)}bind(e,t,r){var i=this["context"],i=i["gl"];i.bindTexture(i.TEXTURE_2D,this.texture),r!==i.LINEAR_MIPMAP_NEAREST||this.isSizePowerOfTwo()||(r=i.LINEAR),e!==this.filter&&(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,e),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,r||e),this.filter=e),t!==this.wrap&&(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,t),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,t),this.wrap=t)}isSizePowerOfTwo(){return this.size[0]===this.size[1]&&Math.log(this.size[0])/Math.LN2%1==0}destroy(){var e=this.context["gl"];e.deleteTexture(this.texture),this.texture=null}}class j extends de.Evented{constructor(){super(),this.images={},this.updatedImages={},this.callbackDispatchedThisFrame={},this.loaded=!1,this.requestors=[],this.patterns={},this.atlasImage=new de.RGBAImage({width:1,height:1}),this.dirty=!0}isLoaded(){return this.loaded}setLoaded(e){if(this.loaded!==e&&(this.loaded=e)){for(var{ids:t,promiseResolve:r}of this.requestors)r(this._getImagesForIds(t));this.requestors=[]}}getImage(e){var t,e=this.images[e];return e&&!e.data&&e.spriteData&&(t=e.spriteData,e.data=new de.RGBAImage({width:t.width,height:t.height},t.context.getImageData(t.x,t.y,t.width,t.height).data),e.spriteData=null),e}addImage(e,t){if(this.images[e])throw new Error(`Image id ${e} already exist, use updateImage instead`);this._validate(e,t)&&(this.images[e]=t)}_validate(e,t){let r=!0;var i=t.data||t.spriteData;return this._validateStretch(t.stretchX,i&&i.width)||(this.fire(new de.ErrorEvent(new Error(`Image "${e}" has invalid "stretchX" value`))),r=!1),this._validateStretch(t.stretchY,i&&i.height)||(this.fire(new de.ErrorEvent(new Error(`Image "${e}" has invalid "stretchY" value`))),r=!1),this._validateContent(t.content,t)||(this.fire(new de.ErrorEvent(new Error(`Image "${e}" has invalid "content" value`))),r=!1),r}_validateStretch(t,r){if(t){let e=0;for(const i of t){if(i[0]<e||i[1]<i[0]||r<i[1])return!1;e=i[1]}}return!0}_validateContent(e,t){var r,i;return!e||4===e.length&&(r=(i=t.spriteData)&&i.width||t.data.width,i=i&&i.height||t.data.height,!(e[0]<0||r<e[0]||e[1]<0||i<e[1]||e[2]<0||r<e[2]||e[3]<0||i<e[3]||e[2]<e[0]||e[3]<e[1]))}updateImage(e,t,r=!0){var i=this.getImage(e);if(r&&(i.data.width!==t.data.width||i.data.height!==t.data.height))throw new Error(`size mismatch between old image (${i.data.width}x${i.data.height}) and new image (${t.data.width}x${t.data.height}).`);t.version=i.version+1,this.images[e]=t,this.updatedImages[e]=!0}removeImage(e){var t=this.images[e];delete this.images[e],delete this.patterns[e],t.userImage&&t.userImage.onRemove&&t.userImage.onRemove()}listImages(){return Object.keys(this.images)}getImages(n){return new Promise((e,t)=>{let r=!0;if(!this.isLoaded())for(const i of n)this.images[i]||(r=!1);this.isLoaded()||r?e(this._getImagesForIds(n)):this.requestors.push({ids:n,promiseResolve:e})})}_getImagesForIds(e){var t={};for(const r of e){let e=this.getImage(r);e||(this.fire(new de.Event("styleimagemissing",{id:r})),e=this.getImage(r)),e?t[r]={data:e.data.clone(),pixelRatio:e.pixelRatio,sdf:e.sdf,version:e.version,stretchX:e.stretchX,stretchY:e.stretchY,content:e.content,contentMatch:e.contentMatch,hasRenderCallback:Boolean(e.userImage&&e.userImage.render)}:de.warnOnce(`Image "${r}" could not be loaded. Please make sure you have added the image with map.addImage() or a "sprite" property in your style. You can provide missing images by listening for the "styleimagemissing" map event.`)}return t}getPixelSize(){var{width:e,height:t}=this.atlasImage;return{width:e,height:t}}getPattern(e){var t=this.patterns[e],r=this.getImage(e);return r?(t&&t.position.version===r.version?t:(t?t.position.version=r.version:(t={w:r.data.width+2,h:r.data.height+2,x:0,y:0},r=new de.ImagePosition(t,r),this.patterns[e]={bin:t,position:r}),this._updatePatternAtlas(),this.patterns[e])).position:null}bind(e){var t=e.gl;this.atlasTexture?this.dirty&&(this.atlasTexture.update(this.atlasImage),this.dirty=!1):this.atlasTexture=new N(e,this.atlasImage,t.RGBA),this.atlasTexture.bind(t.LINEAR,t.CLAMP_TO_EDGE)}_updatePatternAtlas(){var e=[];for(const s in this.patterns)e.push(this.patterns[s].bin);const{w:t,h:r}=de.potpack(e);var i=this.atlasImage;i.resize({width:t||1,height:r||1});for(const l in this.patterns){var n=this.patterns[l]["bin"],o=n.x+1,n=n.y+1,a=this.getImage(l).data;const t=a.width,r=a.height;de.RGBAImage.copy(a,i,{x:0,y:0},{x:o,y:n},{width:t,height:r}),de.RGBAImage.copy(a,i,{x:0,y:r-1},{x:o,y:n-1},{width:t,height:1}),de.RGBAImage.copy(a,i,{x:0,y:0},{x:o,y:n+r},{width:t,height:1}),de.RGBAImage.copy(a,i,{x:t-1,y:0},{x:o-1,y:n},{width:1,height:r}),de.RGBAImage.copy(a,i,{x:0,y:0},{x:o+t,y:n},{width:1,height:r})}this.dirty=!0}beginFrame(){this.callbackDispatchedThisFrame={}}dispatchRenderCallbacks(e){for(const r of e){var t;this.callbackDispatchedThisFrame[r]||(this.callbackDispatchedThisFrame[r]=!0,(t=this.getImage(r))||de.warnOnce(`Image with ID: "${r}" was not found`),de.renderStyleImage(t)&&this.updateImage(r,t))}}}const v=1e20;function H(t,r,i,n,o,a,s,l,c){for(let e=r;e<r+n;e++)V(t,i*a+e,a,o,s,l,c);for(let e=i;e<i+o;e++)V(t,e*a+r,1,n,s,l,c)}function V(i,n,o,a,s,l,c){c[l[0]=0]=-v,c[1]=v,s[0]=i[n];for(let e=1,t=0,r=0;e<a;e++){s[e]=i[n+e*o];var u=e*e;do{var h=l[t];r=(s[e]-s[h]+u-h*h)/(e-h)/2}while(r<=c[t]&&-1<--t);l[++t]=e,c[t]=r,c[t+1]=v}for(let e=0,t=0;e<a;e++){for(;c[t+1]<e;)t++;var r=l[t],d=e-r;i[n+e*o]=s[r]+d*d}}class a{constructor(e,t){this.requestManager=e,this.localIdeographFontFamily=t,this.entries={}}setURL(e){this.url=e}getGlyphs(s){return de.__awaiter(this,void 0,void 0,function*(){var e=[];for(const o in s)for(const a of s[o])e.push(this._getAndCacheGlyphsPromise(o,a));var t,r,i,n={};for({stack:t,id:r,glyph:i}of yield Promise.all(e))n[t]||(n[t]={}),n[t][r]=i&&{id:i.id,bitmap:i.bitmap.clone(),metrics:i.metrics};return n})}_getAndCacheGlyphsPromise(n,o){return de.__awaiter(this,void 0,void 0,function*(){let e=this.entries[n];var t=(e=e||(this.entries[n]={glyphs:{},requests:{},ranges:{}})).glyphs[o];if(void 0!==t)return{stack:n,id:o,glyph:t};if(t=this._tinySDF(e,n,o))return e.glyphs[o]=t,{stack:n,id:o,glyph:t};var r=Math.floor(o/256);if(65535<256*r)throw new Error("glyphs > 65535 not supported");if(e.ranges[r])return{stack:n,id:o,glyph:t};if(!this.url)throw new Error("glyphsUrl is not set");e.requests[r]||(t=a.loadGlyphRange(n,r,this.url,this.requestManager),e.requests[r]=t);var i=yield e.requests[r];for(const o in i)this._doesCharSupportLocalGlyph(+o)||(e.glyphs[+o]=i[+o]);return e.ranges[r]=!0,{stack:n,id:o,glyph:i[o]||null}})}_doesCharSupportLocalGlyph(e){return!!this.localIdeographFontFamily&&(de.unicodeBlockLookup["CJK Unified Ideographs"](e)||de.unicodeBlockLookup["Hangul Syllables"](e)||de.unicodeBlockLookup.Hiragana(e)||de.unicodeBlockLookup.Katakana(e))}_tinySDF(r,i,e){var n=this.localIdeographFontFamily;if(n&&this._doesCharSupportLocalGlyph(e)){let t=r.tinySDF;if(!t){let e="400";/bold/i.test(i)?e="900":/medium/i.test(i)?e="500":/light/i.test(i)&&(e="200"),t=r.tinySDF=new a.TinySDF({fontSize:48,buffer:6,radius:16,cutoff:.25,fontFamily:n,fontWeight:e})}i=t.draw(String.fromCharCode(e));return{id:e,bitmap:new de.AlphaImage({width:i.width||60,height:i.height||60},i.data),metrics:{width:i.glyphWidth/2||24,height:i.glyphHeight/2||24,left:i.glyphLeft/2+.5||0,top:i.glyphTop/2-27.5||-8,advance:i.glyphAdvance/2||24,isDoubleResolution:!0}}}}}a.loadGlyphRange=function(o,a,s,l){return de.__awaiter(this,void 0,void 0,function*(){var e=256*a,t=255+e,r=l.transformRequest(s.replace("{fontstack}",o).replace("{range}",e+"-"+t),"Glyphs"),r=yield de.getArrayBuffer(r,new AbortController);if(!r||!r.data)throw new Error(`Could not load glyph range. range: ${a}, ${e}-`+t);var i={};for(const n of de.parseGlyphPbf(r.data))i[n.id]=n;return i})},a.TinySDF=class{constructor({fontSize:e=24,buffer:t=3,radius:r=8,cutoff:i=.25,fontFamily:n="sans-serif",fontWeight:o="normal",fontStyle:a="normal"}={}){this.buffer=t,this.cutoff=i,this.radius=r;i=this.size=e+4*t,r=this._createCanvas(i),t=this.ctx=r.getContext("2d",{willReadFrequently:!0});t.font=a+` ${o} ${e}px `+n,t.textBaseline="alphabetic",t.textAlign="left",t.fillStyle="black",this.gridOuter=new Float64Array(i*i),this.gridInner=new Float64Array(i*i),this.f=new Float64Array(i),this.z=new Float64Array(i+1),this.v=new Uint16Array(i)}_createCanvas(e){var t=document.createElement("canvas");return t.width=t.height=e,t}draw(e){var{width:t,actualBoundingBoxAscent:r,actualBoundingBoxDescent:i,actualBoundingBoxLeft:n,actualBoundingBoxRight:o}=this.ctx.measureText(e),r=Math.ceil(r),a=Math.max(0,Math.min(this.size-this.buffer,Math.ceil(o-n))),s=Math.min(this.size-this.buffer,r+Math.ceil(i)),l=a+2*this.buffer,o=s+2*this.buffer,c=Math.max(l*o,0),u=new Uint8ClampedArray(c),n={data:u,width:l,height:o,glyphWidth:a,glyphHeight:s,glyphTop:r,glyphLeft:0,glyphAdvance:t};if(0!==a&&0!==s){var{ctx:i,buffer:h,gridInner:d,gridOuter:p}=this,f=(i.clearRect(h,h,a,s),i.fillText(e,h,h+r),i.getImageData(h,h,a,s));p.fill(v,0,c),d.fill(0,0,c);for(let t=0;t<s;t++)for(let e=0;e<a;e++){var m,g=f.data[4*(t*a+e)+3]/255;0!=g&&(m=(t+h)*l+e+h,1==g?(p[m]=0,d[m]=v):(p[m]=0<(g=.5-g)?g*g:0,d[m]=g<0?g*g:0))}H(p,0,0,l,o,l,this.f,this.v,this.z),H(d,h,h,a,s,l,this.f,this.v,this.z);for(let e=0;e<c;e++){var y=Math.sqrt(p[e])-Math.sqrt(d[e]);u[e]=Math.round(255-255*(y/this.radius+this.cutoff))}}return n}};class G{constructor(){this.specification=de.v8Spec.light.position}possiblyEvaluate(e,t){return de.sphericalToCartesian(e.expression.evaluate(t))}interpolate(e,t,r){return{x:de.interpolate.number(e.x,t.x,r),y:de.interpolate.number(e.y,t.y,r),z:de.interpolate.number(e.z,t.z,r)}}}const K="-transition";let Z;class W extends de.Evented{constructor(e){super(),Z=Z||new de.Properties({anchor:new de.DataConstantProperty(de.v8Spec.light.anchor),position:new G,color:new de.DataConstantProperty(de.v8Spec.light.color),intensity:new de.DataConstantProperty(de.v8Spec.light.intensity)}),this._transitionable=new de.Transitionable(Z),this.setLight(e),this._transitioning=this._transitionable.untransitioned()}getLight(){return this._transitionable.serialize()}setLight(e,t={}){if(!this._validate(de.validateLight,e,t))for(const i in e){var r=e[i];i.endsWith(K)?this._transitionable.setTransition(i.slice(0,-K.length),r):this._transitionable.setValue(i,r)}}updateTransitions(e){this._transitioning=this._transitionable.transitioned(e,this._transitioning)}hasTransition(){return this._transitioning.hasTransition()}recalculate(e){this.properties=this._transitioning.possiblyEvaluate(e)}_validate(e,t,r){return(!r||!1!==r.validate)&&de.emitValidationErrors(this,e.call(de.validateStyle,{value:t,style:{glyphs:!0,sprite:!0},styleSpec:de.v8Spec}))}}class Y{constructor(e,t){this.width=e,this.height=t,this.nextRow=0,this.data=new Uint8Array(this.width*this.height),this.dashEntry={}}getDash(e,t){var r=e.join(",")+String(t);return this.dashEntry[r]||(this.dashEntry[r]=this.addDash(e,t)),this.dashEntry[r]}getDashRanges(t,e,r){var i=[],n=t.length%2==1?-t[t.length-1]*r:0,o=t[0]*r;let a=!0,s=(i.push({left:n,right:o,isDash:a,zeroLength:0===t[0]}),t[0]);for(let e=1;e<t.length;e++){a=!a;var l=t[e],n=s*r,o=(s+=l)*r;i.push({left:n,right:o,isDash:a,zeroLength:0===l})}return i}addRoundDash(o,e,a){var s=e/2;for(let n=-a;n<=a;n++){var t=this.nextRow+a+n,l=this.width*t;let r=0,i=o[r];for(let t=0;t<this.width;t++){1<t/i.right&&(i=o[++r]);var c=Math.abs(t-i.left),u=Math.abs(t-i.right),c=Math.min(c,u);let e;var h,u=n/a*(1+s);e=i.isDash?(h=s-Math.abs(u),Math.sqrt(c*c+h*h)):s-Math.sqrt(c*c+u*u),this.data[l+t]=Math.max(0,Math.min(255,e+128))}}}addRegularDash(t){for(let e=t.length-1;0<=e;--e){var r=t[e],i=t[e+1];r.zeroLength?t.splice(e,1):i&&i.isDash===r.isDash&&(i.left=r.left,t.splice(e,1))}var e=t[0],n=t[t.length-1],o=(e.isDash===n.isDash&&(e.left=n.left-this.width,n.right=e.right+this.width),this.width*this.nextRow);let a=0,s=t[a];for(let e=0;e<this.width;e++){1<e/s.right&&(s=t[++a]);var l=Math.abs(e-s.left),c=Math.abs(e-s.right),l=Math.min(l,c),c=s.isDash?l:-l;this.data[o+e]=Math.max(0,Math.min(255,c+128))}}addDash(t,e){var r,i,n=e?7:0,o=2*n+1;if(this.nextRow+o>this.height)return de.warnOnce("LineAtlas out of space"),null;let a=0;for(let e=0;e<t.length;e++)a+=t[e];0!==a&&(r=this.width/a,i=this.getDashRanges(t,this.width,r),e?this.addRoundDash(i,r,n):this.addRegularDash(i));e={y:(this.nextRow+n+.5)/this.height,height:2*n/this.height,width:a};return this.nextRow+=o,this.dirty=!0,e}bind(e){e=e.gl;this.texture?(e.bindTexture(e.TEXTURE_2D,this.texture),this.dirty&&(this.dirty=!1,e.texSubImage2D(e.TEXTURE_2D,0,0,0,this.width,this.height,e.ALPHA,e.UNSIGNED_BYTE,this.data))):(this.texture=e.createTexture(),e.bindTexture(e.TEXTURE_2D,this.texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.REPEAT),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.REPEAT),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.LINEAR),e.texImage2D(e.TEXTURE_2D,0,e.ALPHA,this.width,this.height,0,e.ALPHA,e.UNSIGNED_BYTE,this.data))}}const $="maplibre_preloaded_worker_pool";class n{constructor(){this.active={}}acquire(e){if(!this.workers)for(this.workers=[];this.workers.length<n.workerCount;)this.workers.push(new Worker(de.config.WORKER_URL));return this.active[e]=!0,this.workers.slice()}release(e){delete this.active[e],0===this.numActive()&&(this.workers.forEach(e=>{e.terminate()}),this.workers=null)}isPreloaded(){return!!this.active[$]}numActive(){return Object.keys(this.active).length}}t=Math.floor(M.hardwareConcurrency/2);n.workerCount=de.isSafari(globalThis)?Math.max(Math.min(t,3),1):1;let X;function J(){return X=X||new n}class Q{constructor(e,t){this.workerPool=e,this.actors=[],this.currentActor=0,this.id=t;var r=this.workerPool.acquire(t);for(let e=0;e<r.length;e++){var i=r[e],i=new de.Actor(i,t);i.name="Worker "+e,this.actors.push(i)}if(!this.actors.length)throw new Error("No actors found")}broadcast(e,t){var r=[];for(const i of this.actors)r.push(i.sendAsync({type:e,data:t}));return Promise.all(r)}getActor(){return this.currentActor=(this.currentActor+1)%this.actors.length,this.actors[this.currentActor]}remove(e=!0){this.actors.forEach(e=>{e.remove()}),this.actors=[],e&&this.workerPool.release(this.id)}registerMessageHandler(e,t){for(const r of this.actors)r.registerMessageHandler(e,t)}}let ee;function te(){return ee||(ee=new Q(J(),de.GLOBAL_DISPATCHER_ID)).registerMessageHandler("GR",(e,t,r)=>de.makeRequest(t,r)),ee}function re(r,e,t,i,n,o){var a,s,l,c=function(e,t,r){if(e)for(const o of e){var i=t[o];if(i&&i.source===r&&"fill-extrusion"===i.type)return!0}else for(const a in t){var n=t[a];if(n.source===r&&"fill-extrusion"===n.type)return!0}return!1}(n&&n.layers,e,r.id),u=o.maxPitchScaleFactor(),i=r.tilesIn(i,u,c),h=(i.sort(ie),[]);for(const p of i)h.push({wrappedTileID:p.tileID.wrapped().key,queryResults:p.tile.queryRenderedFeatures(e,t,r._state,p.queryGeometry,p.cameraQueryGeometry,p.scale,n,o,u,(a=r.transform,s=p.tileID,l=void 0,l=de.create(),de.translate(l,l,[1,1,0]),de.scale(l,l,[.5*a.width,.5*a.height,1]),de.multiply(l,l,a.calculatePosMatrix(s.toUnwrapped()))))});var d=function(e){var t={},r={};for(const c of e){var i=c.queryResults,n=c.wrappedTileID,o=r[n]=r[n]||{};for(const u in i){var a=i[u],s=o[u]=o[u]||{},l=t[u]=t[u]||[];for(const h of a)s[h.featureIndex]||(s[h.featureIndex]=!0,l.push(h))}}return t}(h);for(const f in d)d[f].forEach(e=>{var e=e.feature,t=r.getFeatureState(e.layer["source-layer"],e.id);e.source=e.layer.source,e.layer["source-layer"]&&(e.sourceLayer=e.layer["source-layer"]),e.state=t});return d}function ie(e,t){e=e.tileID,t=t.tileID;return e.overscaledZ-t.overscaledZ||e.canonical.y-t.canonical.y||e.wrap-t.wrap||e.canonical.x-t.canonical.x}function ne(r,i,n){return de.__awaiter(this,void 0,void 0,function*(){let e=r;var t;return r.url?(t=yield de.getJSON(i.transformRequest(r.url,"Source"),n),e=t.data):yield M.frameAsync(n),e?(t=de.pick(de.extend(e,r),["tiles","minzoom","maxzoom","attribution","bounds","scheme","tileSize","encoding"]),"vector_layers"in e&&e.vector_layers&&(t.vectorLayerIds=e.vector_layers.map(e=>e.id)),t):null})}class d{constructor(e,t){e&&(t?this.setSouthWest(e).setNorthEast(t):Array.isArray(e)&&(4===e.length?this.setSouthWest([e[0],e[1]]).setNorthEast([e[2],e[3]]):this.setSouthWest(e[0]).setNorthEast(e[1])))}setNorthEast(e){return this._ne=e instanceof de.LngLat?new de.LngLat(e.lng,e.lat):de.LngLat.convert(e),this}setSouthWest(e){return this._sw=e instanceof de.LngLat?new de.LngLat(e.lng,e.lat):de.LngLat.convert(e),this}extend(e){var t,r=this._sw,i=this._ne;let n,o;if(e instanceof de.LngLat)n=e,o=e;else{if(!(e instanceof d))return Array.isArray(e)?4===e.length||e.every(Array.isArray)?(t=e,this.extend(d.convert(t))):this.extend(de.LngLat.convert(e)):e&&("lng"in e||"lon"in e)&&"lat"in e?this.extend(de.LngLat.convert(e)):this;if(n=e._sw,o=e._ne,!n||!o)return this}return r||i?(r.lng=Math.min(n.lng,r.lng),r.lat=Math.min(n.lat,r.lat),i.lng=Math.max(o.lng,i.lng),i.lat=Math.max(o.lat,i.lat)):(this._sw=new de.LngLat(n.lng,n.lat),this._ne=new de.LngLat(o.lng,o.lat)),this}getCenter(){return new de.LngLat((this._sw.lng+this._ne.lng)/2,(this._sw.lat+this._ne.lat)/2)}getSouthWest(){return this._sw}getNorthEast(){return this._ne}getNorthWest(){return new de.LngLat(this.getWest(),this.getNorth())}getSouthEast(){return new de.LngLat(this.getEast(),this.getSouth())}getWest(){return this._sw.lng}getSouth(){return this._sw.lat}getEast(){return this._ne.lng}getNorth(){return this._ne.lat}toArray(){return[this._sw.toArray(),this._ne.toArray()]}toString(){return`LngLatBounds(${this._sw.toString()}, ${this._ne.toString()})`}isEmpty(){return!(this._sw&&this._ne)}contains(e){var{lng:e,lat:t}=de.LngLat.convert(e),t=this._sw.lat<=t&&t<=this._ne.lat;let r=this._sw.lng<=e&&e<=this._ne.lng;return this._sw.lng>this._ne.lng&&(r=this._sw.lng>=e&&e>=this._ne.lng),t&&r}static convert(e){return e instanceof d?e:e&&new d(e)}static fromLngLat(e,t=0){var t=360*t/40075017,r=t/Math.cos(Math.PI/180*e.lat);return new d(new de.LngLat(e.lng-r,e.lat-t),new de.LngLat(e.lng+r,e.lat+t))}}class oe{constructor(e,t,r){this.bounds=d.convert(this.validateBounds(e)),this.minzoom=t||0,this.maxzoom=r||24}validateBounds(e){return Array.isArray(e)&&4===e.length?[Math.max(-180,e[0]),Math.max(-90,e[1]),Math.min(180,e[2]),Math.min(90,e[3])]:[-180,-90,180,90]}contains(e){var t=Math.pow(2,e.z);const r=Math.floor(de.mercatorXfromLng(this.bounds.getWest())*t),i=Math.floor(de.mercatorYfromLat(this.bounds.getNorth())*t),n=Math.ceil(de.mercatorXfromLng(this.bounds.getEast())*t),o=Math.ceil(de.mercatorYfromLat(this.bounds.getSouth())*t);return e.x>=r&&e.x<n&&e.y>=i&&e.y<o}}class ae extends de.Evented{constructor(e,t,r,i){if(super(),this.id=e,this.dispatcher=r,this.type="vector",this.minzoom=0,this.maxzoom=22,this.scheme="xyz",this.tileSize=512,this.reparseOverscaled=!0,this.isTileClipped=!0,this._loaded=!1,de.extend(this,de.pick(t,["url","scheme","tileSize","promoteId"])),this._options=de.extend({type:"vector"},t),this._collectResourceTiming=t.collectResourceTiming,512!==this.tileSize)throw new Error("vector tile sources must have a tileSize of 512");this.setEventedParent(i)}load(){return de.__awaiter(this,void 0,void 0,function*(){this._loaded=!1,this.fire(new de.Event("dataloading",{dataType:"source"})),this._tileJSONRequest=new AbortController;try{var e=yield ne(this._options,this.map._requestManager,this._tileJSONRequest);this._tileJSONRequest=null,this._loaded=!0,this.map.style.sourceCaches[this.id].clearTiles(),e&&(de.extend(this,e),e.bounds&&(this.tileBounds=new oe(e.bounds,this.minzoom,this.maxzoom)),this.fire(new de.Event("data",{dataType:"source",sourceDataType:"metadata"})),this.fire(new de.Event("data",{dataType:"source",sourceDataType:"content"})))}catch(e){this._tileJSONRequest=null,this.fire(new de.ErrorEvent(e))}})}loaded(){return this._loaded}hasTile(e){return!this.tileBounds||this.tileBounds.contains(e.canonical)}onAdd(e){this.map=e,this.load()}setSourceProperty(e){this._tileJSONRequest&&this._tileJSONRequest.abort(),e(),this.load()}setTiles(e){return this.setSourceProperty(()=>{this._options.tiles=e}),this}setUrl(e){return this.setSourceProperty(()=>{this.url=e,this._options.url=e}),this}onRemove(){this._tileJSONRequest&&(this._tileJSONRequest.abort(),this._tileJSONRequest=null)}serialize(){return de.extend({},this._options)}loadTile(i){return de.__awaiter(this,void 0,void 0,function*(){var e=i.tileID.canonical.url(this.tiles,this.map.getPixelRatio(),this.scheme),e={request:this.map._requestManager.transformRequest(e,"Tile"),uid:i.uid,tileID:i.tileID,zoom:i.tileID.overscaledZ,tileSize:this.tileSize*i.tileID.overscaleFactor(),type:this.type,source:this.id,pixelRatio:this.map.getPixelRatio(),showCollisionBoxes:this.map.showCollisionBoxes,promoteId:this.promoteId};e.request.collectResourceTiming=this._collectResourceTiming;let t="RT";if(i.actor&&"expired"!==i.state){if("loading"===i.state)return new Promise((e,t)=>{i.reloadPromise={resolve:e,reject:t}})}else i.actor=this.dispatcher.getActor(),t="LT";i.abortController=new AbortController;try{var r=yield i.actor.sendAsync({type:t,data:e},i.abortController);delete i.abortController,i.aborted||this._afterTileLoadWorkerResponse(i,r)}catch(e){if(delete i.abortController,!i.aborted){if(e&&404!==e.status)throw e;this._afterTileLoadWorkerResponse(i,null)}}})}_afterTileLoadWorkerResponse(e,t){t&&t.resourceTiming&&(e.resourceTiming=t.resourceTiming),t&&this.map._refreshExpiredTiles&&e.setExpiryData(t),e.loadVectorData(t,this.map.painter),e.reloadPromise&&(t=e.reloadPromise,e.reloadPromise=null,this.loadTile(e).then(t.resolve).catch(t.reject))}abortTile(e){return de.__awaiter(this,void 0,void 0,function*(){e.abortController&&(e.abortController.abort(),delete e.abortController),e.actor&&(yield e.actor.sendAsync({type:"AT",data:{uid:e.uid,type:this.type,source:this.id}}))})}unloadTile(e){return de.__awaiter(this,void 0,void 0,function*(){e.unloadVectorData(),e.actor&&(yield e.actor.sendAsync({type:"RMT",data:{uid:e.uid,type:this.type,source:this.id}}))})}hasTransition(){return!1}}class se extends de.Evented{constructor(e,t,r,i){super(),this.id=e,this.dispatcher=r,this.setEventedParent(i),this.type="raster",this.minzoom=0,this.maxzoom=22,this.roundZoom=!0,this.scheme="xyz",this.tileSize=512,this._loaded=!1,this._options=de.extend({type:"raster"},t),de.extend(this,de.pick(t,["url","scheme","tileSize"]))}load(){return de.__awaiter(this,void 0,void 0,function*(){this._loaded=!1,this.fire(new de.Event("dataloading",{dataType:"source"})),this._tileJSONRequest=new AbortController;try{var e=yield ne(this._options,this.map._requestManager,this._tileJSONRequest);this._tileJSONRequest=null,this._loaded=!0,e&&(de.extend(this,e),e.bounds&&(this.tileBounds=new oe(e.bounds,this.minzoom,this.maxzoom)),this.fire(new de.Event("data",{dataType:"source",sourceDataType:"metadata"})),this.fire(new de.Event("data",{dataType:"source",sourceDataType:"content"})))}catch(e){this._tileJSONRequest=null,this.fire(new de.ErrorEvent(e))}})}loaded(){return this._loaded}onAdd(e){this.map=e,this.load()}onRemove(){this._tileJSONRequest&&(this._tileJSONRequest.abort(),this._tileJSONRequest=null)}setSourceProperty(e){this._tileJSONRequest&&(this._tileJSONRequest.abort(),this._tileJSONRequest=null),e(),this.load()}setTiles(e){return this.setSourceProperty(()=>{this._options.tiles=e}),this}setUrl(e){return this.setSourceProperty(()=>{this.url=e,this._options.url=e}),this}serialize(){return de.extend({},this._options)}hasTile(e){return!this.tileBounds||this.tileBounds.contains(e.canonical)}loadTile(o){return de.__awaiter(this,void 0,void 0,function*(){var e=o.tileID.canonical.url(this.tiles,this.map.getPixelRatio(),this.scheme);o.abortController=new AbortController;try{var t,r,i,n=yield h.getImage(this.map._requestManager.transformRequest(e,"Tile"),o.abortController,this.map._refreshExpiredTiles);delete o.abortController,o.aborted?o.state="unloaded":n&&n.data&&(this.map._refreshExpiredTiles&&n.cacheControl&&n.expires&&o.setExpiryData({cacheControl:n.cacheControl,expires:n.expires}),r=(t=this.map.painter.context).gl,i=n.data,o.texture=this.map.painter.getTileTexture(i.width),o.texture?o.texture.update(i,{useMipmap:!0}):(o.texture=new N(t,i,r.RGBA,{useMipmap:!0}),o.texture.bind(r.LINEAR,r.CLAMP_TO_EDGE,r.LINEAR_MIPMAP_NEAREST),t.extTextureFilterAnisotropic&&r.texParameterf(r.TEXTURE_2D,t.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT,t.extTextureFilterAnisotropicMax)),o.state="loaded")}catch(e){if(delete o.abortController,o.aborted)o.state="unloaded";else if(e)throw o.state="errored",e}})}abortTile(e){return de.__awaiter(this,void 0,void 0,function*(){e.abortController&&(e.abortController.abort(),delete e.abortController)})}unloadTile(e){return de.__awaiter(this,void 0,void 0,function*(){e.texture&&this.map.painter.saveTileTexture(e.texture)})}hasTransition(){return!1}}class le extends se{constructor(e,t,r,i){super(e,t,r,i),this.type="raster-dem",this.maxzoom=22,this._options=de.extend({type:"raster-dem"},t),this.encoding=t.encoding||"mapbox",this.redFactor=t.redFactor,this.greenFactor=t.greenFactor,this.blueFactor=t.blueFactor,this.baseShift=t.baseShift}loadTile(a){return de.__awaiter(this,void 0,void 0,function*(){var e=a.tileID.canonical.url(this.tiles,this.map.getPixelRatio(),this.scheme),e=this.map._requestManager.transformRequest(e,"Tile");a.neighboringTiles=this._getNeighboringTiles(a.tileID),a.abortController=new AbortController;try{var t,r,i,n,o=yield h.getImage(e,a.abortController,this.map._refreshExpiredTiles);delete a.abortController,a.aborted?a.state="unloaded":o&&o.data&&(t=o.data,this.map._refreshExpiredTiles&&o.cacheControl&&o.expires&&a.setExpiryData({cacheControl:o.cacheControl,expires:o.expires}),r=de.isImageBitmap(t)&&de.offscreenCanvasSupported()?t:yield this.readImageNow(t),i={type:this.type,uid:a.uid,source:this.id,rawImageData:r,encoding:this.encoding,redFactor:this.redFactor,greenFactor:this.greenFactor,blueFactor:this.blueFactor,baseShift:this.baseShift},a.actor&&"expired"!==a.state||(a.actor=this.dispatcher.getActor(),n=yield a.actor.sendAsync({type:"LDT",data:i}),a.dem=n,a.needsHillshadePrepare=!0,a.needsTerrainPrepare=!0,a.state="loaded"))}catch(e){if(delete a.abortController,a.aborted)a.state="unloaded";else if(e)throw a.state="errored",e}})}readImageNow(r){return de.__awaiter(this,void 0,void 0,function*(){if("undefined"!=typeof VideoFrame&&de.isOffscreenCanvasDistorted()){var e=r.width+2,t=r.height+2;try{return new de.RGBAImage({width:e,height:t},yield de.readImageUsingVideoFrame(r,-1,-1,e,t))}catch(e){}}return M.getImageData(r,1)})}_getNeighboringTiles(e){var t=e.canonical,r=Math.pow(2,t.z),i=(t.x-1+r)%r,n=0===t.x?e.wrap-1:e.wrap,o=(t.x+1+r)%r,a=t.x+1===r?e.wrap+1:e.wrap,s={};return s[new de.OverscaledTileID(e.overscaledZ,n,t.z,i,t.y).key]={backfilled:!1},s[new de.OverscaledTileID(e.overscaledZ,a,t.z,o,t.y).key]={backfilled:!1},0<t.y&&(s[new de.OverscaledTileID(e.overscaledZ,n,t.z,i,t.y-1).key]={backfilled:!1},s[new de.OverscaledTileID(e.overscaledZ,e.wrap,t.z,t.x,t.y-1).key]={backfilled:!1},s[new de.OverscaledTileID(e.overscaledZ,a,t.z,o,t.y-1).key]={backfilled:!1}),t.y+1<r&&(s[new de.OverscaledTileID(e.overscaledZ,n,t.z,i,t.y+1).key]={backfilled:!1},s[new de.OverscaledTileID(e.overscaledZ,e.wrap,t.z,t.x,t.y+1).key]={backfilled:!1},s[new de.OverscaledTileID(e.overscaledZ,a,t.z,o,t.y+1).key]={backfilled:!1}),s}unloadTile(e){return de.__awaiter(this,void 0,void 0,function*(){e.demTexture&&this.map.painter.saveTileTexture(e.demTexture),e.fbo&&(e.fbo.destroy(),delete e.fbo),e.dem&&delete e.dem,delete e.neighboringTiles,e.state="unloaded",e.actor&&(yield e.actor.sendAsync({type:"RDT",data:{type:this.type,uid:e.uid,source:this.id}}))})}}class ce extends de.Evented{constructor(e,t,r,i){super(),this.id=e,this.type="geojson",this.minzoom=0,this.maxzoom=18,this.tileSize=512,this.isTileClipped=!0,this.reparseOverscaled=!0,this._removed=!1,this._pendingLoads=0,this.actor=r.getActor(),this.setEventedParent(i),this._data=t.data,this._options=de.extend({},t),this._collectResourceTiming=t.collectResourceTiming,void 0!==t.maxzoom&&(this.maxzoom=t.maxzoom),t.type&&(this.type=t.type),t.attribution&&(this.attribution=t.attribution),this.promoteId=t.promoteId;e=de.EXTENT/this.tileSize;this.workerOptions=de.extend({source:this.id,cluster:t.cluster||!1,geojsonVtOptions:{buffer:(void 0!==t.buffer?t.buffer:128)*e,tolerance:(void 0!==t.tolerance?t.tolerance:.375)*e,extent:de.EXTENT,maxZoom:this.maxzoom,lineMetrics:t.lineMetrics||!1,generateId:t.generateId||!1},superclusterOptions:{maxZoom:void 0!==t.clusterMaxZoom?t.clusterMaxZoom:this.maxzoom-1,minPoints:Math.max(2,t.clusterMinPoints||2),extent:de.EXTENT,radius:(t.clusterRadius||50)*e,log:!1,generateId:t.generateId||!1},clusterProperties:t.clusterProperties,filter:t.filter},t.workerOptions),"string"==typeof this.promoteId&&(this.workerOptions.promoteId=this.promoteId)}load(){return de.__awaiter(this,void 0,void 0,function*(){yield this._updateWorkerData()})}onAdd(e){this.map=e,this.load()}setData(e){return this._data=e,this._updateWorkerData(),this}updateData(e){return this._updateWorkerData(e),this}setClusterOptions(e){return this.workerOptions.cluster=e.cluster,e&&(void 0!==e.clusterRadius&&(this.workerOptions.superclusterOptions.radius=e.clusterRadius),void 0!==e.clusterMaxZoom)&&(this.workerOptions.superclusterOptions.maxZoom=e.clusterMaxZoom),this._updateWorkerData(),this}getClusterExpansionZoom(e){return this.actor.sendAsync({type:"GCEZ",data:{type:this.type,clusterId:e,source:this.id}})}getClusterChildren(e){return this.actor.sendAsync({type:"GCC",data:{type:this.type,clusterId:e,source:this.id}})}getClusterLeaves(e,t,r){return this.actor.sendAsync({type:"GCL",data:{type:this.type,source:this.id,clusterId:e,limit:t,offset:r}})}_updateWorkerData(i){return de.__awaiter(this,void 0,void 0,function*(){var e=de.extend({type:this.type},this.workerOptions);i?e.dataDiff=i:"string"==typeof this._data?(e.request=this.map._requestManager.transformRequest(M.resolveURL(this._data),"Source"),e.request.collectResourceTiming=this._collectResourceTiming):e.data=JSON.stringify(this._data),this._pendingLoads++,this.fire(new de.Event("dataloading",{dataType:"source"}));try{var t=yield this.actor.sendAsync({type:"LD",data:e});if(this._pendingLoads--,this._removed||t.abandoned)this.fire(new de.Event("dataabort",{dataType:"source"}));else{let e=null;t.resourceTiming&&t.resourceTiming[this.id]&&(e=t.resourceTiming[this.id].slice(0));var r={dataType:"source"};this._collectResourceTiming&&e&&0<e.length&&de.extend(r,{resourceTiming:e}),this.fire(new de.Event("data",Object.assign(Object.assign({},r),{sourceDataType:"metadata"}))),this.fire(new de.Event("data",Object.assign(Object.assign({},r),{sourceDataType:"content"})))}}catch(e){this._pendingLoads--,this._removed?this.fire(new de.Event("dataabort",{dataType:"source"})):this.fire(new de.ErrorEvent(e))}})}loaded(){return 0===this._pendingLoads}loadTile(r){return de.__awaiter(this,void 0,void 0,function*(){var e=r.actor?"RT":"LT",t=(r.actor=this.actor,{type:this.type,uid:r.uid,tileID:r.tileID,zoom:r.tileID.overscaledZ,maxZoom:this.maxzoom,tileSize:this.tileSize,source:this.id,pixelRatio:this.map.getPixelRatio(),showCollisionBoxes:this.map.showCollisionBoxes,promoteId:this.promoteId}),t=(r.abortController=new AbortController,yield this.actor.sendAsync({type:e,data:t},r.abortController));delete r.abortController,r.unloadVectorData(),r.aborted||r.loadVectorData(t,this.map.painter,"RT"==e)})}abortTile(e){return de.__awaiter(this,void 0,void 0,function*(){e.abortController&&(e.abortController.abort(),delete e.abortController),e.aborted=!0})}unloadTile(e){return de.__awaiter(this,void 0,void 0,function*(){e.unloadVectorData(),yield this.actor.sendAsync({type:"RMT",data:{uid:e.uid,type:this.type,source:this.id}})})}onRemove(){this._removed=!0,this.actor.sendAsync({type:"RS",data:{type:this.type,source:this.id}})}serialize(){return de.extend({},this._options,{type:this.type,data:this._data})}hasTransition(){return!1}}var ue=de.createLayout([{name:"a_pos",type:"Int16",components:2},{name:"a_texture_pos",type:"Int16",components:2}]);class _ extends de.Evented{constructor(e,t,r,i){super(),this.id=e,this.dispatcher=r,this.coordinates=t.coordinates,this.type="image",this.minzoom=0,this.maxzoom=22,this.tileSize=512,this.tiles={},this._loaded=!1,this.setEventedParent(i),this.options=t}load(t){return de.__awaiter(this,void 0,void 0,function*(){this._loaded=!1,this.fire(new de.Event("dataloading",{dataType:"source"})),this.url=this.options.url,this._request=new AbortController;try{var e=yield h.getImage(this.map._requestManager.transformRequest(this.url,"Image"),this._request);this._request=null,this._loaded=!0,e&&e.data&&(this.image=e.data,t&&(this.coordinates=t),this._finishLoading())}catch(e){this._request=null,this.fire(new de.ErrorEvent(e))}})}loaded(){return this._loaded}updateImage(e){return e.url&&(this._request&&(this._request.abort(),this._request=null),this.options.url=e.url,this.load(e.coordinates).finally(()=>{this.texture=null})),this}_finishLoading(){this.map&&(this.setCoordinates(this.coordinates),this.fire(new de.Event("data",{dataType:"source",sourceDataType:"metadata"})))}onAdd(e){this.map=e,this.load()}onRemove(){this._request&&(this._request.abort(),this._request=null)}setCoordinates(e){e=(this.coordinates=e).map(de.MercatorCoordinate.fromLngLat),this.tileID=function(e){let t=1/0,r=1/0,i=-1/0,n=-1/0;for(const a of e)t=Math.min(t,a.x),r=Math.min(r,a.y),i=Math.max(i,a.x),n=Math.max(n,a.y);var e=i-t,o=n-r,e=Math.max(e,o),o=Math.max(0,Math.floor(-Math.log(e)/Math.LN2)),e=Math.pow(2,o);return new de.CanonicalTileID(o,Math.floor((t+i)/2*e),Math.floor((r+n)/2*e))}(e),this.minzoom=this.maxzoom=this.tileID.z,e=e.map(e=>this.tileID.getTilePoint(e)._round());return this._boundsArray=new de.RasterBoundsArray,this._boundsArray.emplaceBack(e[0].x,e[0].y,0,0),this._boundsArray.emplaceBack(e[1].x,e[1].y,de.EXTENT,0),this._boundsArray.emplaceBack(e[3].x,e[3].y,0,de.EXTENT),this._boundsArray.emplaceBack(e[2].x,e[2].y,de.EXTENT,de.EXTENT),this.boundsBuffer&&(this.boundsBuffer.destroy(),delete this.boundsBuffer),this.fire(new de.Event("data",{dataType:"source",sourceDataType:"content"})),this}prepare(){if(0!==Object.keys(this.tiles).length&&this.image){var t=this.map.painter.context,r=t.gl;this.boundsBuffer||(this.boundsBuffer=t.createVertexBuffer(this._boundsArray,ue.members)),this.boundsSegments||(this.boundsSegments=de.SegmentVector.simpleSegment(0,0,4,2)),this.texture||(this.texture=new N(t,this.image,r.RGBA),this.texture.bind(r.LINEAR,r.CLAMP_TO_EDGE));let e=!1;for(const n in this.tiles){var i=this.tiles[n];"loaded"!==i.state&&(i.state="loaded",i.texture=this.texture,e=!0)}e&&this.fire(new de.Event("data",{dataType:"source",sourceDataType:"idle",sourceId:this.id}))}}loadTile(e){return de.__awaiter(this,void 0,void 0,function*(){this.tileID&&this.tileID.equals(e.tileID.canonical)?(this.tiles[String(e.tileID.wrap)]=e).buckets={}:e.state="errored"})}serialize(){return{type:"image",url:this.options.url,coordinates:this.coordinates}}hasTransition(){return!1}}class he extends _{constructor(e,t,r,i){super(e,t,r,i),this.roundZoom=!0,this.type="video",this.options=t}load(){return de.__awaiter(this,void 0,void 0,function*(){this._loaded=!1;var e=this.options;this.urls=[];for(const r of e.urls)this.urls.push(this.map._requestManager.transformRequest(r,"Source").url);try{var t=yield de.getVideo(this.urls);this._loaded=!0,t&&(this.video=t,this.video.loop=!0,this.video.addEventListener("playing",()=>{this.map.triggerRepaint()}),this.map&&this.video.play(),this._finishLoading())}catch(e){this.fire(new de.ErrorEvent(e))}})}pause(){this.video&&this.video.pause()}play(){this.video&&this.video.play()}seek(e){var t;this.video&&(e<(t=this.video.seekable).start(0)||e>t.end(0)?this.fire(new de.ErrorEvent(new de.ValidationError("sources."+this.id,null,`Playback for this video can be set only between the ${t.start(0)} and ${t.end(0)}-second mark.`))):this.video.currentTime=e)}getVideo(){return this.video}onAdd(e){this.map||(this.map=e,this.load(),this.video&&(this.video.play(),this.setCoordinates(this.coordinates)))}prepare(){if(!(0===Object.keys(this.tiles).length||this.video.readyState<2)){var t=this.map.painter.context,r=t.gl;this.boundsBuffer||(this.boundsBuffer=t.createVertexBuffer(this._boundsArray,ue.members)),this.boundsSegments||(this.boundsSegments=de.SegmentVector.simpleSegment(0,0,4,2)),this.texture?this.video.paused||(this.texture.bind(r.LINEAR,r.CLAMP_TO_EDGE),r.texSubImage2D(r.TEXTURE_2D,0,0,0,r.RGBA,r.UNSIGNED_BYTE,this.video)):(this.texture=new N(t,this.video,r.RGBA),this.texture.bind(r.LINEAR,r.CLAMP_TO_EDGE));let e=!1;for(const n in this.tiles){var i=this.tiles[n];"loaded"!==i.state&&(i.state="loaded",i.texture=this.texture,e=!0)}e&&this.fire(new de.Event("data",{dataType:"source",sourceDataType:"idle",sourceId:this.id}))}}serialize(){return{type:"video",urls:this.urls,coordinates:this.coordinates}}hasTransition(){return this.video&&!this.video.paused}}class ye extends _{constructor(e,t,r,i){super(e,t,r,i),t.coordinates?Array.isArray(t.coordinates)&&4===t.coordinates.length&&!t.coordinates.some(e=>!Array.isArray(e)||2!==e.length||e.some(e=>"number"!=typeof e))||this.fire(new de.ErrorEvent(new de.ValidationError("sources."+e,null,'"coordinates" property must be an array of 4 longitude/latitude array pairs'))):this.fire(new de.ErrorEvent(new de.ValidationError("sources."+e,null,'missing required property "coordinates"'))),t.animate&&"boolean"!=typeof t.animate&&this.fire(new de.ErrorEvent(new de.ValidationError("sources."+e,null,'optional "animate" property must be a boolean value'))),t.canvas?"string"==typeof t.canvas||t.canvas instanceof HTMLCanvasElement||this.fire(new de.ErrorEvent(new de.ValidationError("sources."+e,null,'"canvas" must be either a string representing the ID of the canvas element from which to read, or an HTMLCanvasElement instance'))):this.fire(new de.ErrorEvent(new de.ValidationError("sources."+e,null,'missing required property "canvas"'))),this.options=t,this.animate=void 0===t.animate||t.animate}load(){return de.__awaiter(this,void 0,void 0,function*(){this._loaded=!0,this.canvas||(this.canvas=this.options.canvas instanceof HTMLCanvasElement?this.options.canvas:document.getElementById(this.options.canvas)),this.width=this.canvas.width,this.height=this.canvas.height,this._hasInvalidDimensions()?this.fire(new de.ErrorEvent(new Error("Canvas dimensions cannot be less than or equal to zero."))):(this.play=function(){this._playing=!0,this.map.triggerRepaint()},this.pause=function(){this._playing&&(this.prepare(),this._playing=!1)},this._finishLoading())})}getCanvas(){return this.canvas}onAdd(e){this.map=e,this.load(),this.canvas&&this.animate&&this.play()}onRemove(){this.pause()}prepare(){let t=!1;if(this.canvas.width!==this.width&&(this.width=this.canvas.width,t=!0),this.canvas.height!==this.height&&(this.height=this.canvas.height,t=!0),!this._hasInvalidDimensions()&&0!==Object.keys(this.tiles).length){var r=this.map.painter.context,i=r.gl;this.boundsBuffer||(this.boundsBuffer=r.createVertexBuffer(this._boundsArray,ue.members)),this.boundsSegments||(this.boundsSegments=de.SegmentVector.simpleSegment(0,0,4,2)),this.texture?(t||this._playing)&&this.texture.update(this.canvas,{premultiply:!0}):this.texture=new N(r,this.canvas,i.RGBA,{premultiply:!0});let e=!1;for(const o in this.tiles){var n=this.tiles[o];"loaded"!==n.state&&(n.state="loaded",n.texture=this.texture,e=!0)}e&&this.fire(new de.Event("data",{dataType:"source",sourceDataType:"idle",sourceId:this.id}))}}serialize(){return{type:"canvas",coordinates:this.coordinates}}hasTransition(){return this._playing}_hasInvalidDimensions(){for(const e of[this.canvas.width,this.canvas.height])if(isNaN(e)||e<=0)return!0;return!1}}const ve={},_e=e=>{switch(e){case"geojson":return ce;case"image":return _;case"raster":return se;case"raster-dem":return le;case"vector":return ae;case"video":return he;case"canvas":return ye}return ve[e]};const be="RTLPluginLoaded";class we extends de.Evented{constructor(){super(...arguments),this.status="unavailable",this.url=null,this.dispatcher=te()}_syncState(e){return this.status=e,this.dispatcher.broadcast("SRPS",{pluginStatus:e,pluginURL:this.url}).catch(e=>{throw this.status="error",e})}getRTLTextPluginStatus(){return this.status}clearRTLTextPlugin(){this.status="unavailable",this.url=null}setRTLTextPlugin(e){return de.__awaiter(this,arguments,void 0,function*(e,t=!1){if(this.url)throw new Error("setRTLTextPlugin cannot be called multiple times.");if(this.url=M.resolveURL(e),!this.url)throw new Error(`requested url ${e} is invalid`);if("unavailable"===this.status){if(!t)return this._requestImport();this.status="deferred",this._syncState(this.status)}else if("requested"===this.status)return this._requestImport()})}_requestImport(){return de.__awaiter(this,void 0,void 0,function*(){yield this._syncState("loading"),this.status="loaded",this.fire(new de.Event(be))})}lazyLoad(){"unavailable"===this.status?this.status="requested":"deferred"===this.status&&this._requestImport()}}let xe=null;function c(){return xe=xe||new we}class Ce{constructor(e,t){this.timeAdded=0,this.fadeEndTime=0,this.tileID=e,this.uid=de.uniqueId(),this.uses=0,this.tileSize=t,this.buckets={},this.expirationTime=null,this.queryPadding=0,this.hasSymbolBuckets=!1,this.hasRTLText=!1,this.dependencies={},this.rtt=[],this.rttCoords={},this.expiredRequestCount=0,this.state="loading"}registerFadeDuration(e){e+=this.timeAdded;e<this.fadeEndTime||(this.fadeEndTime=e)}wasRequested(){return"errored"===this.state||"loaded"===this.state||"reloading"===this.state}clearTextures(e){this.demTexture&&e.saveTileTexture(this.demTexture),this.demTexture=null}loadVectorData(e,t,r){if(this.hasData()&&this.unloadVectorData(),this.state="loaded",e){e.featureIndex&&(this.latestFeatureIndex=e.featureIndex,e.rawTileData?(this.latestRawTileData=e.rawTileData,this.latestFeatureIndex.rawTileData=e.rawTileData):this.latestRawTileData&&(this.latestFeatureIndex.rawTileData=this.latestRawTileData)),this.collisionBoxArray=e.collisionBoxArray,this.buckets=function(e,t){var r={};if(t)for(const i of e){const n=i.layerIds.map(e=>t.getLayer(e)).filter(Boolean);if(0!==n.length){i.layers=n,i.stateDependentLayerIds&&(i.stateDependentLayers=i.stateDependentLayerIds.map(t=>n.filter(e=>e.id===t)[0]));for(const o of n)r[o.id]=i}}return r}(e.buckets,t.style),this.hasSymbolBuckets=!1;for(const a in this.buckets){var i=this.buckets[a];if(i instanceof de.SymbolBucket){if(this.hasSymbolBuckets=!0,!r)break;i.justReloaded=!0}}if(this.hasRTLText=!1,this.hasSymbolBuckets)for(const s in this.buckets){var n=this.buckets[s];if(n instanceof de.SymbolBucket&&n.hasRTLText){this.hasRTLText=!0,c().lazyLoad();break}}this.queryPadding=0;for(const l in this.buckets){var o=this.buckets[l];this.queryPadding=Math.max(this.queryPadding,t.style.getLayer(l).queryRadius(o))}e.imageAtlas&&(this.imageAtlas=e.imageAtlas),e.glyphAtlasImage&&(this.glyphAtlasImage=e.glyphAtlasImage)}else this.collisionBoxArray=new de.CollisionBoxArray}unloadVectorData(){for(const e in this.buckets)this.buckets[e].destroy();this.buckets={},this.imageAtlasTexture&&this.imageAtlasTexture.destroy(),this.imageAtlas&&(this.imageAtlas=null),this.glyphAtlasTexture&&this.glyphAtlasTexture.destroy(),this.latestFeatureIndex=null,this.state="unloaded"}getBucket(e){return this.buckets[e.id]}upload(e){for(const i in this.buckets){var t=this.buckets[i];t.uploadPending()&&t.upload(e)}var r=e.gl;this.imageAtlas&&!this.imageAtlas.uploaded&&(this.imageAtlasTexture=new N(e,this.imageAtlas.image,r.RGBA),this.imageAtlas.uploaded=!0),this.glyphAtlasImage&&(this.glyphAtlasTexture=new N(e,this.glyphAtlasImage,r.ALPHA),this.glyphAtlasImage=null)}prepare(e){this.imageAtlas&&this.imageAtlas.patchUpdatedImages(e,this.imageAtlasTexture)}queryRenderedFeatures(e,t,r,i,n,o,a,s,l,c){return this.latestFeatureIndex&&this.latestFeatureIndex.rawTileData?this.latestFeatureIndex.query({queryGeometry:i,cameraQueryGeometry:n,scale:o,tileSize:this.tileSize,pixelPosMatrix:c,transform:s,params:a,queryPadding:this.queryPadding*l},e,t,r):{}}querySourceFeatures(t,e){var r=this.latestFeatureIndex;if(r&&r.rawTileData){var i=r.loadVTLayers(),n=e&&e.sourceLayer?e.sourceLayer:"",o=i._geojsonTileLayer||i[n];if(o){var a=de.createFilter(e&&e.filter),{z:s,x:l,y:c}=this.tileID.canonical,u={z:s,x:l,y:c};for(let e=0;e<o.length;e++){var h=o.feature(e);if(a.needGeometry){var d=de.toEvaluationFeature(h,!0);if(!a.filter(new de.EvaluationParameters(this.tileID.overscaledZ),d,this.tileID.canonical))continue}else if(!a.filter(new de.EvaluationParameters(this.tileID.overscaledZ),h))continue;d=r.getId(h,n),h=new de.GeoJSONFeature(h,s,l,c,d);h.tile=u,t.push(h)}}}}hasData(){return"loaded"===this.state||"reloading"===this.state||"expired"===this.state}patternsLoaded(){return this.imageAtlas&&!!Object.keys(this.imageAtlas.patternPositions).length}setExpiryData(t){var r=this.expirationTime;if(t.cacheControl?(i=de.parseCacheControl(t.cacheControl))["max-age"]&&(this.expirationTime=Date.now()+1e3*i["max-age"]):t.expires&&(this.expirationTime=new Date(t.expires).getTime()),this.expirationTime){var i=Date.now();let e=!1;this.expirationTime>i?e=!1:r&&!(this.expirationTime<r)&&(t=this.expirationTime-r)?this.expirationTime=i+Math.max(t,3e4):e=!0,e?(this.expiredRequestCount++,this.state="expired"):this.expiredRequestCount=0}}getExpiryTimeout(){if(this.expirationTime)return this.expiredRequestCount?1e3*(1<<Math.min(this.expiredRequestCount-1,31)):Math.min(this.expirationTime-(new Date).getTime(),Math.pow(2,31)-1)}setFeatureState(e,t){if(this.latestFeatureIndex&&this.latestFeatureIndex.rawTileData&&0!==Object.keys(e).length){var r,i,n,o=this.latestFeatureIndex.loadVTLayers();for(const a in this.buckets)t.style.hasLayer(a)&&(i=o[n=(r=this.buckets[a]).layers[0].sourceLayer||"_geojsonTileLayer"],n=e[n],i)&&n&&0!==Object.keys(n).length&&(r.update(n,i,this.imageAtlas&&this.imageAtlas.patternPositions||{}),n=t&&t.style&&t.style.getLayer(a))&&(this.queryPadding=Math.max(this.queryPadding,n.queryRadius(r)))}}holdingForFade(){return void 0!==this.symbolFadeHoldUntil}symbolFadeFinished(){return!this.symbolFadeHoldUntil||this.symbolFadeHoldUntil<M.now()}clearFadeHold(){this.symbolFadeHoldUntil=void 0}setHoldDuration(e){this.symbolFadeHoldUntil=M.now()+e}setDependencies(e,t){var r={};for(const i of t)r[i]=!0;this.dependencies[e]=r}hasDependency(e,t){for(const i of e){var r=this.dependencies[i];if(r)for(const n of t)if(r[n])return!0}return!1}}class Te{constructor(e,t){this.max=e,this.onRemove=t,this.reset()}reset(){for(const e in this.data)for(const t of this.data[e])t.timeout&&clearTimeout(t.timeout),this.onRemove(t.value);return this.data={},this.order=[],this}add(e,t,r){var i=e.wrapped().key;void 0===this.data[i]&&(this.data[i]=[]);const n={value:t,timeout:void 0};return void 0!==r&&(n.timeout=setTimeout(()=>{this.remove(e,n)},r)),this.data[i].push(n),this.order.push(i),this.order.length>this.max&&(t=this._getAndRemoveByKey(this.order[0]))&&this.onRemove(t),this}has(e){return e.wrapped().key in this.data}getAndRemove(e){return this.has(e)?this._getAndRemoveByKey(e.wrapped().key):null}_getAndRemoveByKey(e){var t=this.data[e].shift();return t.timeout&&clearTimeout(t.timeout),0===this.data[e].length&&delete this.data[e],this.order.splice(this.order.indexOf(e),1),t.value}getByKey(e){e=this.data[e];return e?e[0].value:null}get(e){return this.has(e)?this.data[e.wrapped().key][0].value:null}remove(e,t){var r;return this.has(e)&&(e=e.wrapped().key,t=void 0===t?0:this.data[e].indexOf(t),r=this.data[e][t],this.data[e].splice(t,1),r.timeout&&clearTimeout(r.timeout),0===this.data[e].length&&delete this.data[e],this.onRemove(r.value),this.order.splice(this.order.indexOf(e),1)),this}setMaxSize(e){for(this.max=e;this.order.length>this.max;){var t=this._getAndRemoveByKey(this.order[0]);t&&this.onRemove(t)}return this}filter(e){var t=[];for(const r in this.data)for(const i of this.data[r])e(i.value)||t.push(i);for(const n of t)this.remove(n.value.tileID,n)}}class Se{constructor(){this.state={},this.stateChanges={},this.deletedStates={}}updateState(e,t,r){var i=String(t);if(this.stateChanges[e]=this.stateChanges[e]||{},this.stateChanges[e][i]=this.stateChanges[e][i]||{},de.extend(this.stateChanges[e][i],r),null===this.deletedStates[e]){this.deletedStates[e]={};for(const n in this.state[e])n!==i&&(this.deletedStates[e][n]=null)}else if(this.deletedStates[e]&&null===this.deletedStates[e][i]){this.deletedStates[e][i]={};for(const o in this.state[e][i])r[o]||(this.deletedStates[e][i][o]=null)}else for(const a in r)this.deletedStates[e]&&this.deletedStates[e][i]&&null===this.deletedStates[e][i][a]&&delete this.deletedStates[e][i][a]}removeFeatureState(e,t,r){var i=null===this.deletedStates[e];if(!i){var n=String(t);if(this.deletedStates[e]=this.deletedStates[e]||{},r&&void 0!==t)null!==this.deletedStates[e][n]&&(this.deletedStates[e][n]=this.deletedStates[e][n]||{},this.deletedStates[e][n][r]=null);else if(void 0!==t)if(this.stateChanges[e]&&this.stateChanges[e][n])for(r in this.deletedStates[e][n]={},this.stateChanges[e][n])this.deletedStates[e][n][r]=null;else this.deletedStates[e][n]=null;else this.deletedStates[e]=null}}getState(e,t){var r=String(t),i=this.state[e]||{},n=this.stateChanges[e]||{},o=de.extend({},i[r],n[r]);if(null===this.deletedStates[e])return{};if(this.deletedStates[e]){i=this.deletedStates[e][t];if(null===i)return{};for(const a in i)delete o[a]}return o}initializeTileState(e,t){e.setFeatureState(this.state,t)}coalesceChanges(e,t){var r={};for(const o in this.stateChanges){this.state[o]=this.state[o]||{};var i={};for(const a in this.stateChanges[o])this.state[o][a]||(this.state[o][a]={}),de.extend(this.state[o][a],this.stateChanges[o][a]),i[a]=this.state[o][a];r[o]=i}for(const s in this.deletedStates){this.state[s]=this.state[s]||{};var n={};if(null===this.deletedStates[s])for(const l in this.state[s])n[l]={},this.state[s][l]={};else for(const c in this.deletedStates[s]){if(null===this.deletedStates[s][c])this.state[s][c]={};else for(const u of Object.keys(this.deletedStates[s][c]))delete this.state[s][c][u];n[c]=this.state[s][c]}r[s]=r[s]||{},de.extend(r[s],n)}if(this.stateChanges={},this.deletedStates={},0!==Object.keys(r).length)for(const h in e)e[h].setFeatureState(r,t)}}class k extends de.Evented{constructor(e,t,r){super(),this.id=e,this.dispatcher=r,this.on("data",e=>{"source"===e.dataType&&"metadata"===e.sourceDataType&&(this._sourceLoaded=!0),this._sourceLoaded&&!this._paused&&"source"===e.dataType&&"content"===e.sourceDataType&&(this.reload(),this.transform&&this.update(this.transform,this.terrain),this._didEmitContent=!0)}),this.on("dataloading",()=>{this._sourceErrored=!1}),this.on("error",()=>{this._sourceErrored=this._source.loaded()}),this._source=((e,t,r,i)=>{t=new(_e(t.type))(e,t,r,i);if(t.id!==e)throw new Error(`Expected Source id to be ${e} instead of `+t.id);return t})(e,t,r,this),this._tiles={},this._cache=new Te(0,e=>this._unloadTile(e)),this._timers={},this._cacheTimers={},this._maxTileCacheSize=null,this._maxTileCacheZoomLevels=null,this._loadedParentTiles={},this._coveredTiles={},this._state=new Se,this._didEmitContent=!1,this._updated=!1}onAdd(e){this.map=e,this._maxTileCacheSize=e?e._maxTileCacheSize:null,this._maxTileCacheZoomLevels=e?e._maxTileCacheZoomLevels:null,this._source&&this._source.onAdd&&this._source.onAdd(e)}onRemove(e){this.clearTiles(),this._source&&this._source.onRemove&&this._source.onRemove(e)}loaded(){if(!this._sourceErrored){if(!this._sourceLoaded)return!1;if(!this._source.loaded())return!1;if(void 0===this.used&&void 0===this.usedForTerrain||this.used||this.usedForTerrain){if(!this._updated)return!1;for(const t in this._tiles){var e=this._tiles[t];if("loaded"!==e.state&&"errored"!==e.state)return!1}}}return!0}getSource(){return this._source}pause(){this._paused=!0}resume(){var e;this._paused&&(e=this._shouldReloadOnResume,this._paused=!1,this._shouldReloadOnResume=!1,e&&this.reload(),this.transform)&&this.update(this.transform,this.terrain)}_loadTile(t,e,r){return de.__awaiter(this,void 0,void 0,function*(){try{yield this._source.loadTile(t),this._tileLoaded(t,e,r)}catch(e){t.state="errored",404!==e.status?this._source.fire(new de.ErrorEvent(e,{tile:t})):this.update(this.transform,this.terrain)}})}_unloadTile(e){this._source.unloadTile&&this._source.unloadTile(e)}_abortTile(e){this._source.abortTile&&this._source.abortTile(e),this._source.fire(new de.Event("dataabort",{tile:e,coord:e.tileID,dataType:"source"}))}serialize(){return this._source.serialize()}prepare(e){this._source.prepare&&this._source.prepare(),this._state.coalesceChanges(this._tiles,this.map?this.map.painter:null);for(const r in this._tiles){var t=this._tiles[r];t.upload(e),t.prepare(this.map.style.imageManager)}}getIds(){return Object.values(this._tiles).map(e=>e.tileID).sort(Ee).map(e=>e.key)}getRenderableIds(e){var t=[];for(const r in this._tiles)this._isIdRenderable(r,e)&&t.push(this._tiles[r]);return e?t.sort((e,t)=>{var e=e.tileID,t=t.tileID,r=new de.Point(e.canonical.x,e.canonical.y)._rotate(this.transform.angle),i=new de.Point(t.canonical.x,t.canonical.y)._rotate(this.transform.angle);return e.overscaledZ-t.overscaledZ||i.y-r.y||i.x-r.x}).map(e=>e.tileID.key):t.map(e=>e.tileID).sort(Ee).map(e=>e.key)}hasRenderableParent(e){e=this.findLoadedParent(e,0);return!!e&&this._isIdRenderable(e.tileID.key)}_isIdRenderable(e,t){return this._tiles[e]&&this._tiles[e].hasData()&&!this._coveredTiles[e]&&(t||!this._tiles[e].holdingForFade())}reload(){if(this._paused)this._shouldReloadOnResume=!0;else{this._cache.reset();for(const e in this._tiles)"errored"!==this._tiles[e].state&&this._reloadTile(e,"reloading")}}_reloadTile(t,r){return de.__awaiter(this,void 0,void 0,function*(){var e=this._tiles[t];e&&("loading"!==e.state&&(e.state=r),yield this._loadTile(e,t,r))})}_tileLoaded(e,t,r){e.timeAdded=M.now(),"expired"===r&&(e.refreshedUponExpiration=!0),this._setTileReloadTimer(t,e),"raster-dem"===this.getSource().type&&e.dem&&this._backfillDEM(e),this._state.initializeTileState(e,this.map?this.map.painter:null),e.aborted||this._source.fire(new de.Event("data",{dataType:"source",tile:e,coord:e.tileID}))}_backfillDEM(t){var r=this.getRenderableIds();for(let e=0;e<r.length;e++){var i=r[e];t.neighboringTiles&&t.neighboringTiles[i]&&(n(t,i=this.getTileByID(i)),n(i,t))}function n(e,t){e.needsHillshadePrepare=!0,e.needsTerrainPrepare=!0;let r=t.tileID.canonical.x-e.tileID.canonical.x;var i=t.tileID.canonical.y-e.tileID.canonical.y,n=Math.pow(2,e.tileID.canonical.z),o=t.tileID.key;0===r&&0==i||1<Math.abs(i)||(1<Math.abs(r)&&(1===Math.abs(r+n)?r+=n:1===Math.abs(r-n)&&(r-=n)),t.dem&&e.dem&&(e.dem.backfillBorder(t.dem,r,i),e.neighboringTiles)&&e.neighboringTiles[o]&&(e.neighboringTiles[o].backfilled=!0))}}getTile(e){return this.getTileByID(e.key)}getTileByID(e){return this._tiles[e]}_retainLoadedChildren(i,n,e,o){for(const t in this._tiles){let r=this._tiles[t];if(!(o[t]||!r.hasData()||r.tileID.overscaledZ<=n||r.tileID.overscaledZ>e)){let e=r.tileID;for(;r&&r.tileID.overscaledZ>n+1;){var a=r.tileID.scaledTo(r.tileID.overscaledZ-1);(r=this._tiles[a.key])&&r.hasData()&&(e=a)}let t=e;for(;t.overscaledZ>n;)if(i[(t=t.scaledTo(t.overscaledZ-1)).key]){o[e.key]=e;break}}}}findLoadedParent(t,r){var e;if(t.key in this._loadedParentTiles)return(e=this._loadedParentTiles[t.key])&&e.tileID.overscaledZ>=r?e:null;for(let e=t.overscaledZ-1;e>=r;e--){var i=t.scaledTo(e),i=this._getLoadedTile(i);if(i)return i}}_getLoadedTile(e){var t=this._tiles[e.key];return t&&t.hasData()?t:this._cache.getByKey(e.wrapped().key)}updateCacheSize(e){var t=Math.ceil(e.width/this._source.tileSize)+1,e=Math.ceil(e.height/this._source.tileSize)+1,r=null===this._maxTileCacheZoomLevels?de.config.MAX_TILE_CACHE_ZOOM_LEVELS:this._maxTileCacheZoomLevels,t=Math.floor(t*e*r),e="number"==typeof this._maxTileCacheSize?Math.min(this._maxTileCacheSize,t):t;this._cache.setMaxSize(e)}handleWrapJump(e){var t=void 0===this._prevLng?e:this._prevLng,r=Math.round((e-t)/360);if(this._prevLng=e,r){var i={};for(const a in this._tiles){var n=this._tiles[a];n.tileID=n.tileID.unwrapTo(n.tileID.wrap+r),i[n.tileID.key]=n}this._tiles=i;for(const s in this._timers)clearTimeout(this._timers[s]),delete this._timers[s];for(const l in this._tiles){var o=this._tiles[l];this._setTileReloadTimer(l,o)}}}update(t,r){if(this.transform=t,this.terrain=r,this._sourceLoaded&&!this._paused){this.updateCacheSize(t),this.handleWrapJump(this.transform.center.lng),this._coveredTiles={};let e;this.used||this.usedForTerrain?this._source.tileID?e=t.getVisibleUnwrappedCoordinates(this._source.tileID).map(e=>new de.OverscaledTileID(e.canonical.z,e.wrap,e.canonical.z,e.canonical.x,e.canonical.y)):(e=t.coveringTiles({tileSize:(this.usedForTerrain?this:this._source).tileSize,minzoom:this._source.minzoom,maxzoom:this._source.maxzoom,roundZoom:!this.usedForTerrain&&this._source.roundZoom,reparseOverscaled:this._source.reparseOverscaled,terrain:r}),this._source.hasTile&&(e=e.filter(e=>this._source.hasTile(e)))):e=[];var t=t.coveringZoomLevel(this._source),i=Math.max(t-k.maxOverzooming,this._source.minzoom),n=Math.max(t+k.maxUnderzooming,this._source.minzoom);if(this.usedForTerrain){var o,a={};for(const _ of e)_.canonical.z>this._source.minzoom&&(a[(o=_.scaledTo(_.canonical.z-1)).key]=o,a[(o=_.scaledTo(Math.max(this._source.minzoom,Math.min(_.canonical.z,5)))).key]=o);e=e.concat(Object.values(a))}var s=0===e.length&&!this._updated&&this._didEmitContent,l=(this._updated=!0,s&&this.fire(new de.Event("data",{sourceDataType:"idle",dataType:"source",sourceId:this.id})),this._updateRetainedTiles(e,t));if(Ie(this._source.type)){var c={},u={},s=Object.keys(l),h=M.now();for(const b of s){var d=l[b],p=this._tiles[b];!p||0!==p.fadeEndTime&&p.fadeEndTime<=h||((p=this.findLoadedParent(d,i))&&(this._addTile(p.tileID),c[p.tileID.key]=p.tileID),u[b]=d)}this._retainLoadedChildren(u,t,n,l);for(const w in c)l[w]||(this._coveredTiles[w]=!0,l[w]=c[w]);if(r){var f={},m={};for(const x of e)this._tiles[x.key].hasData()?f[x.key]=x:m[x.key]=x;for(const C in m){var g=m[C].children(this._source.maxzoom);this._tiles[g[0].key]&&this._tiles[g[1].key]&&this._tiles[g[2].key]&&this._tiles[g[3].key]&&(f[g[0].key]=l[g[0].key]=g[0],f[g[1].key]=l[g[1].key]=g[1],f[g[2].key]=l[g[2].key]=g[2],f[g[3].key]=l[g[3].key]=g[3],delete m[C])}for(const T in m){var y=this.findLoadedParent(m[T],this._source.minzoom);if(y){f[y.tileID.key]=l[y.tileID.key]=y.tileID;for(const S in f)f[S].isChildOf(y.tileID)&&delete f[S]}}for(const E in this._tiles)f[E]||(this._coveredTiles[E]=!0)}}for(const I in l)this._tiles[I].clearFadeHold();for(const A of de.keysDifference(this._tiles,l)){var v=this._tiles[A];v.hasSymbolBuckets&&!v.holdingForFade()?v.setHoldDuration(this.map._fadeDuration):v.hasSymbolBuckets&&!v.symbolFadeFinished()||this._removeTile(A)}this._updateLoadedParentTileCache()}}releaseSymbolFadeTiles(){for(const e in this._tiles)this._tiles[e].holdingForFade()&&this._removeTile(e)}_updateRetainedTiles(e,i){var n={},o={},a=Math.max(i-k.maxOverzooming,this._source.minzoom),t=Math.max(i+k.maxUnderzooming,this._source.minzoom),r={};for(const d of e){var s=this._addTile(d);n[d.key]=d,s.hasData()||i<this._source.maxzoom&&(r[d.key]=d)}this._retainLoadedChildren(r,i,t,n);for(const p of e){let r=this._tiles[p.key];if(!r.hasData()){if(i+1>this._source.maxzoom){var l=p.children(this._source.maxzoom)[0],c=this.getTile(l);if(c&&c.hasData()){n[l.key]=l;continue}}else{c=p.children(this._source.maxzoom);if(n[c[0].key]&&n[c[1].key]&&n[c[2].key]&&n[c[3].key])continue}let t=r.wasRequested();for(let e=p.overscaledZ-1;e>=a;--e){var u=p.scaledTo(e);if(o[u.key])break;if(o[u.key]=!0,r=!(r=this.getTile(u))&&t?this._addTile(u):r){var h=r.hasData();if((t||h)&&(n[u.key]=u),t=r.wasRequested(),h)break}}}}return n}_updateLoadedParentTileCache(){this._loadedParentTiles={};for(const n in this._tiles){var r=[];let e,t=this._tiles[n].tileID;for(;0<t.overscaledZ;){if(t.key in this._loadedParentTiles){e=this._loadedParentTiles[t.key];break}r.push(t.key);var i=t.scaledTo(t.overscaledZ-1);if(e=this._getLoadedTile(i))break;t=i}for(const o of r)this._loadedParentTiles[o]=e}}_addTile(e){let t=this._tiles[e.key];var r;return t||((t=this._cache.getAndRemove(e))&&(this._setTileReloadTimer(e.key,t),t.tileID=e,this._state.initializeTileState(t,this.map?this.map.painter:null),this._cacheTimers[e.key])&&(clearTimeout(this._cacheTimers[e.key]),delete this._cacheTimers[e.key],this._setTileReloadTimer(e.key,t)),(r=t)||(t=new Ce(e,this._source.tileSize*e.overscaleFactor()),this._loadTile(t,e.key,t.state)),t.uses++,this._tiles[e.key]=t,r)||this._source.fire(new de.Event("dataloading",{tile:t,coord:t.tileID,dataType:"source"})),t}_setTileReloadTimer(e,t){e in this._timers&&(clearTimeout(this._timers[e]),delete this._timers[e]);t=t.getExpiryTimeout();t&&(this._timers[e]=setTimeout(()=>{this._reloadTile(e,"expired"),delete this._timers[e]},t))}_removeTile(e){var t=this._tiles[e];t&&(t.uses--,delete this._tiles[e],this._timers[e]&&(clearTimeout(this._timers[e]),delete this._timers[e]),0<t.uses||(t.hasData()&&"reloading"!==t.state?this._cache.add(t.tileID,t,t.getExpiryTimeout()):(t.aborted=!0,this._abortTile(t),this._unloadTile(t))))}clearTiles(){this._shouldReloadOnResume=!1,this._paused=!1;for(const e in this._tiles)this._removeTile(e);this._cache.reset()}tilesIn(e,o,a){var s=[];const l=this.transform;if(l){var a=a?l.getCameraQueryGeometry(e):e,c=e.map(e=>l.pointCoordinate(e,this.terrain)),u=a.map(e=>l.pointCoordinate(e,this.terrain)),h=this.getIds();let t=1/0,r=1/0,i=-1/0,n=-1/0;for(const g of u)t=Math.min(t,g.x),r=Math.min(r,g.y),i=Math.max(i,g.x),n=Math.max(n,g.y);for(let e=0;e<h.length;e++){var d=this._tiles[h[e]];if(!d.holdingForFade()){const y=d.tileID;var p=Math.pow(2,l.zoom-d.tileID.overscaledZ),f=o*d.queryPadding*de.EXTENT/d.tileSize/p,m=[y.getTilePoint(new de.MercatorCoordinate(t,r)),y.getTilePoint(new de.MercatorCoordinate(i,n))];m[0].x-f<de.EXTENT&&m[0].y-f<de.EXTENT&&0<=m[1].x+f&&0<=m[1].y+f&&(m=c.map(e=>y.getTilePoint(e)),f=u.map(e=>y.getTilePoint(e)),s.push({tile:d,tileID:y,queryGeometry:m,cameraQueryGeometry:f,scale:p}))}}}return s}getVisibleCoordinates(e){e=this.getRenderableIds(e).map(e=>this._tiles[e].tileID);for(const t of e)t.posMatrix=this.transform.calculatePosMatrix(t.toUnwrapped());return e}hasTransition(){if(this._source.hasTransition())return!0;if(Ie(this._source.type)){var e=M.now();for(const t in this._tiles)if(this._tiles[t].fadeEndTime>=e)return!0}return!1}setFeatureState(e,t,r){this._state.updateState(e=e||"_geojsonTileLayer",t,r)}removeFeatureState(e,t,r){this._state.removeFeatureState(e=e||"_geojsonTileLayer",t,r)}getFeatureState(e,t){return this._state.getState(e=e||"_geojsonTileLayer",t)}setDependencies(e,t,r){e=this._tiles[e];e&&e.setDependencies(t,r)}reloadTilesForDependencies(t,r){for(const e in this._tiles)this._tiles[e].hasDependency(t,r)&&this._reloadTile(e,"reloading");this._cache.filter(e=>!e.hasDependency(t,r))}}function Ee(e,t){var r=Math.abs(2*e.wrap)-(e.wrap<0),i=Math.abs(2*t.wrap)-(t.wrap<0);return e.overscaledZ-t.overscaledZ||i-r||t.canonical.y-e.canonical.y||t.canonical.x-e.canonical.x}function Ie(e){return"raster"===e||"image"===e||"video"===e}k.maxOverzooming=10,k.maxUnderzooming=3;class Ae{constructor(e,t){this.reset(e,t)}reset(e,t){this.points=e||[],this._distances=[0];for(let e=1;e<this.points.length;e++)this._distances[e]=this._distances[e-1]+this.points[e].dist(this.points[e-1]);this.length=this._distances[this._distances.length-1],this.padding=Math.min(t||0,.5*this.length),this.paddedLength=this.length-2*this.padding}lerp(e){if(1===this.points.length)return this.points[0];e=de.clamp(e,0,1);let t=1,r=this._distances[t];for(var i=e*this.paddedLength+this.padding;r<i&&t<this._distances.length;)r=this._distances[++t];var e=t-1,n=this._distances[e],o=r-n,n=0<o?(i-n)/o:0;return this.points[e].mult(1-n).add(this.points[t].mult(n))}}function ke(e,t){let r="always"===e||"never"!==e&&"never"!==t?!0:!1;return r}class Pe{constructor(e,t,r){var i=this.boxCells=[],n=this.circleCells=[];this.xCellCount=Math.ceil(e/r),this.yCellCount=Math.ceil(t/r);for(let e=0;e<this.xCellCount*this.yCellCount;e++)i.push([]),n.push([]);this.circleKeys=[],this.boxKeys=[],this.bboxes=[],this.circles=[],this.width=e,this.height=t,this.xScale=this.xCellCount/e,this.yScale=this.yCellCount/t,this.boxUid=0,this.circleUid=0}keysLength(){return this.boxKeys.length+this.circleKeys.length}insert(e,t,r,i,n){this._forEachCell(t,r,i,n,this._insertBoxCell,this.boxUid++),this.boxKeys.push(e),this.bboxes.push(t),this.bboxes.push(r),this.bboxes.push(i),this.bboxes.push(n)}insertCircle(e,t,r,i){this._forEachCell(t-i,r-i,t+i,r+i,this._insertCircleCell,this.circleUid++),this.circleKeys.push(e),this.circles.push(t),this.circles.push(r),this.circles.push(i)}_insertBoxCell(e,t,r,i,n,o){this.boxCells[n].push(o)}_insertCircleCell(e,t,r,i,n,o){this.circleCells[n].push(o)}_query(e,t,r,i,n,o,a){if(r<0||e>this.width||i<0||t>this.height)return[];var s=[];if(e<=0&&t<=0&&this.width<=r&&this.height<=i){if(n)return[{key:null,x1:e,y1:t,x2:r,y2:i}];for(let e=0;e<this.boxKeys.length;e++)s.push({key:this.boxKeys[e],x1:this.bboxes[4*e],y1:this.bboxes[4*e+1],x2:this.bboxes[4*e+2],y2:this.bboxes[4*e+3]});for(let e=0;e<this.circleKeys.length;e++){var l=this.circles[3*e],c=this.circles[3*e+1],u=this.circles[3*e+2];s.push({key:this.circleKeys[e],x1:l-u,y1:c-u,x2:l+u,y2:c+u})}}else this._forEachCell(e,t,r,i,this._queryCell,s,{hitTest:n,overlapMode:o,seenUids:{box:{},circle:{}}},a);return s}query(e,t,r,i){return this._query(e,t,r,i,!1,null)}hitTest(e,t,r,i,n,o){return 0<this._query(e,t,r,i,!0,n,o).length}hitTestCircle(e,t,r,i,n){var o=e-r,a=e+r,s=t-r,l=t+r;return!(a<0||o>this.width||l<0||s>this.height)&&(this._forEachCell(o,s,a,l,this._queryCellCircle,o=[],{hitTest:!0,overlapMode:i,circle:{x:e,y:t,radius:r},seenUids:{box:{},circle:{}}},n),0<o.length)}_queryCell(e,t,r,i,n,o,a,s){var{seenUids:l,hitTest:c,overlapMode:u}=a,a=this.boxCells[n];if(null!==a){var h=this.bboxes;for(const _ of a)if(!l.box[_]){l.box[_]=!0;var d=4*_,p=this.boxKeys[_];if(e<=h[2+d]&&t<=h[3+d]&&r>=h[0+d]&&i>=h[1+d]&&(!s||s(p))&&(!c||!ke(u,p.overlapMode))&&(o.push({key:p,x1:h[d],y1:h[1+d],x2:h[2+d],y2:h[3+d]}),c))return!0}}a=this.circleCells[n];if(null!==a){var f=this.circles;for(const b of a)if(!l.circle[b]){l.circle[b]=!0;var m=3*b,g=this.circleKeys[b];if(this._circleAndRectCollide(f[m],f[1+m],f[2+m],e,t,r,i)&&(!s||s(g))&&(!c||!ke(u,g.overlapMode))){var y=f[m],v=f[1+m],m=f[2+m];if(o.push({key:g,x1:y-m,y1:v-m,x2:y+m,y2:v+m}),c)return!0}}}return!1}_queryCellCircle(e,t,r,i,n,o,a,s){var{circle:l,seenUids:c,overlapMode:u}=a,a=this.boxCells[n];if(null!==a){var h=this.bboxes;for(const y of a)if(!c.box[y]){c.box[y]=!0;var d=4*y,p=this.boxKeys[y];if(this._circleAndRectCollide(l.x,l.y,l.radius,h[0+d],h[1+d],h[2+d],h[3+d])&&(!s||s(p))&&!ke(u,p.overlapMode))return o.push(!0),!0}}a=this.circleCells[n];if(null!==a){var f=this.circles;for(const v of a)if(!c.circle[v]){c.circle[v]=!0;var m=3*v,g=this.circleKeys[v];if(this._circlesCollide(f[m],f[1+m],f[2+m],l.x,l.y,l.radius)&&(!s||s(g))&&!ke(u,g.overlapMode))return o.push(!0),!0}}}_forEachCell(r,i,n,o,a,s,l,c){var e=this._convertToXCellCoord(r),u=this._convertToYCellCoord(i),h=this._convertToXCellCoord(n),d=this._convertToYCellCoord(o);for(let t=e;t<=h;t++)for(let e=u;e<=d;e++){var p=this.xCellCount*e+t;if(a.call(this,r,i,n,o,p,s,l,c))return}}_convertToXCellCoord(e){return Math.max(0,Math.min(this.xCellCount-1,Math.floor(e*this.xScale)))}_convertToYCellCoord(e){return Math.max(0,Math.min(this.yCellCount-1,Math.floor(e*this.yScale)))}_circlesCollide(e,t,r,i,n,o){i-=e,e=n-t,n=r+o;return i*i+e*e<n*n}_circleAndRectCollide(e,t,r,i,n,o,a){o=(o-i)/2,e=Math.abs(e-(i+o));return!(o+r<e||(i=(a-n)/2)+r<(a=Math.abs(t-(n+i)))||!(e<=o||a<=i||(t=e-o)*t+(n=a-i)*n<=r*r))}}function Me(e,t,r,i,n){var o=de.create();return t?(de.scale(o,o,[1/n,1/n,1]),r||de.rotateZ(o,o,i.angle)):de.multiply(o,i.labelPlaneMatrix,e),o}function Re(e,t,r,i,n){return t?(t=de.clone(e),de.scale(t,t,[n,n,1]),r||de.rotateZ(t,t,-i.angle),t):i.glCoordMatrix}function pe(e,t,r){let i;r?(i=[e.x,e.y,r(e.x,e.y),1],de.transformMat4(i,i,t)):je(i=[e.x,e.y,0,1],i,t);r=i[3];return{point:new de.Point(i[0]/r,i[1]/r),signedDistanceFromCamera:r}}function Oe(e,t){return.5+e/t*.5}function Le(e,t,r,i,n,o,a,s,l,c,u,h,d){var p=s.glyphStartIndex+s.numGlyphs,f=s.lineStartIndex,m=s.lineStartIndex+s.lineLength,g=t.getoffsetX(s.glyphStartIndex),t=t.getoffsetX(p-1),p=Ue(e*g,r,i,n,o,a,s.segment,f,m,l,c,u,h,d);return p&&(g=Ue(e*t,r,i,n,o,a,s.segment,f,m,l,c,u,h,d))?{first:p,last:g}:null}function De(e,t,r,i){if(e===de.WritingMode.horizontal){var n=Math.abs(r.y-t.y);if(Math.abs(r.x-t.x)*i<n)return{useVertical:!0}}return(e===de.WritingMode.vertical?t.y<r.y:t.x>r.x)?{needsFlipping:!0}:null}function ze(t,e,r,i,n,o,a,s,l,c,u,h,d,p,f,m){var g=e/24,y=t.lineOffsetX*g,v=t.lineOffsetY*g;let _;if(1<t.numGlyphs){var b=t.glyphStartIndex+t.numGlyphs,w=t.lineStartIndex,x=t.lineStartIndex+t.lineLength,e=Le(g,s,y,v,r,u,h,t,l,o,d,f,m);if(!e)return{notEnoughRoom:!0};var C=pe(e.first.point,a,m).point,a=pe(e.last.point,a,m).point;if(i&&!r){C=De(t.writingMode,C,a,p);if(C)return C}_=[e.first];for(let e=t.glyphStartIndex+1;e<b-1;e++)_.push(Ue(g*s.getoffsetX(e),y,v,r,u,h,t.segment,w,x,l,o,d,f,m));_.push(e.last)}else{if(i&&!r){a=pe(h,n,m).point,C=t.lineStartIndex+t.segment+1,e=new de.Point(l.getx(C),l.gety(C)),i=pe(e,n,m),C=0<i.signedDistanceFromCamera?i.point:Ne(h,e,a,1,n,m),i=De(t.writingMode,a,C,p);if(i)return i}e=Ue(g*s.getoffsetX(t.glyphStartIndex),y,v,r,u,h,t.segment,t.lineStartIndex,t.lineStartIndex+t.lineLength,l,o,d,f,m);if(!e)return{notEnoughRoom:!0};_=[e]}for(const T of _)de.addDynamicAttributes(c,T.point,T.angle);return{}}function Ne(e,t,r,i,n,o){e=pe(e.add(e.sub(t)._unit()),n,o).point,t=r.sub(e);return r.add(t._mult(i/t.mag()))}function Be(e,t){var r,i,{projectionCache:t,lineVertexArray:n,labelPlaneMatrix:o,tileAnchorPoint:a,distanceFromAnchor:s,getElevation:l,previousVertex:c,direction:u,absOffsetX:h}=t;return t.projections[e]||(0<(i=pe(r=new de.Point(n.getx(e),n.gety(e)),o,l)).signedDistanceFromCamera?(t.projections[e]=i.point,i.point):(t=e-u,Ne(0===s?a:new de.Point(n.getx(t),n.gety(t)),r,c,h-s+1,o,l)))}function Fe(e,t,r){return e._unit()._perp()._mult(t*r)}function Ue(e,t,r,i,n,o,a,s,l,c,u,h,d,p){e=i?e-t:e+t;let f=0<e?1:-1,m=0,g=(i&&(f*=-1,m=Math.PI),f<0&&(m+=Math.PI),0<f?s+a:s+a+1),y=n,v=n,_,b,w=0,x=0;var C=Math.abs(e),T=[];let S;for(;w+x<=C;){if((g+=f)<s||g>=l)return null;w+=x,v=y,b=_;var E={projectionCache:h,lineVertexArray:c,labelPlaneMatrix:u,tileAnchorPoint:o,distanceFromAnchor:w,getElevation:p,previousVertex:v,direction:f,absOffsetX:C};if(y=Be(g,E),0===r)T.push(v),S=y.sub(v);else{let e;var I=y.sub(v);e=0===I.mag()?Fe(Be(g+f,E).sub(y),r,f):Fe(I,r,f),b=b||v.add(e),_=function(e,t,r,i,n,o,a,s){var{projectionCache:l,direction:c}=s;if(!l.offsets[e]){t=r.add(t);if(e+c<i||n<=e+c)return l.offsets[e]=t;i=Be(e+c,s),n=Fe(i.sub(r),a,c),s=r.add(n),a=i.add(n);l.offsets[e]=de.findLineIntersection(o,t,s,a)||t}return l.offsets[e]}(g,e,y,s,l,b,r,E),T.push(b),S=_.sub(b)}x=S.mag()}t=(C-w)/x,i=S._mult(t)._add(b||v),a=m+Math.atan2(y.y-v.y,y.x-v.x);return T.push(i),{point:i,angle:d?a:0,path:T}}const qe=new Float32Array([-1/0,-1/0,0,-1/0,-1/0,0,-1/0,-1/0,0,-1/0,-1/0,0]);function fe(t,r){for(let e=0;e<t;e++){var i=r.length;r.resize(i+4),r.float32.set(qe,3*i)}}function je(e,t,r){var i=t[0],t=t[1];e[0]=r[0]*i+r[4]*t+r[12],e[1]=r[1]*i+r[5]*t+r[13],e[3]=r[3]*i+r[7]*t+r[15]}class He{constructor(e,t=new Pe(e.width+200,e.height+200,25),r=new Pe(e.width+200,e.height+200,25)){this.transform=e,this.grid=t,this.ignoredGrid=r,this.pitchfactor=Math.cos(e._pitch)*e.cameraToCenterDistance,this.screenRightBoundary=e.width+100,this.screenBottomBoundary=e.height+100,this.gridRightBoundary=e.width+200,this.gridBottomBoundary=e.height+200,this.perspectiveRatioCutoff=.6}placeCollisionBox(e,t,r,i,n,o){var i=this.projectAndGetPerspectiveRatio(i,e.anchorPointX,e.anchorPointY,o),o=r*i.perspectiveRatio,r=e.x1*o+i.point.x,a=e.y1*o+i.point.y,s=e.x2*o+i.point.x,e=e.y2*o+i.point.y;return!this.isInsideGrid(r,a,s,e)||"always"!==t&&this.grid.hitTest(r,a,s,e,t,n)||i.perspectiveRatio<this.perspectiveRatioCutoff?{box:[],offscreen:!1}:{box:[r,a,s,e],offscreen:this.isOffscreen(r,a,s,e)}}placeCollisionCircles(r,e,t,i,n,o,a,s,l,c,u,h,d,p){var f=[],m=new de.Point(e.anchorX,e.anchorY),o=pe(m,o,p),o=Oe(this.transform.cameraToCenterDistance,o.signedDistanceFromCamera),c=(c?n/o:n*o)/de.ONE_EM,n=pe(m,a,p).point,i=Le(c,i,e.lineOffsetX*c,e.lineOffsetY*c,!1,n,m,e,t,a,{projections:{},offsets:{}},!1,p);let g=!1,y=!1,v=!0;if(i){var _=.5*h*o+d,c=new de.Point(-100,-100),n=new de.Point(this.screenRightBoundary,this.screenBottomBoundary),b=new Ae,w=i.first,x=i.last;let t=[];for(let e=w.path.length-1;1<=e;e--)t.push(w.path[e]);for(let e=1;e<x.path.length;e++)t.push(x.path[e]);var C=2.5*_;s&&(m=t.map(e=>pe(e,s,p)),t=m.some(e=>e.signedDistanceFromCamera<=0)?[]:m.map(e=>e.point));let e=[];if(0<t.length){var T=t[0].clone(),S=t[0].clone();for(let e=1;e<t.length;e++)T.x=Math.min(T.x,t[e].x),T.y=Math.min(T.y,t[e].y),S.x=Math.max(S.x,t[e].x),S.y=Math.max(S.y,t[e].y);e=T.x>=c.x&&S.x<=n.x&&T.y>=c.y&&S.y<=n.y?[t]:S.x<c.x||T.x>n.x||S.y<c.y||T.y>n.y?[]:de.clipLine([t],c.x,c.y,n.x,n.y)}for(const R of e){b.reset(R,.25*_);let t=0;t=b.length<=.5*_?1:Math.ceil(b.paddedLength/C)+1;for(let e=0;e<t;e++){var E=e/Math.max(t-1,1),E=b.lerp(E),I=E.x+100,E=E.y+100,A=(f.push(I,E,_,0),I-_),k=E-_,P=I+_,M=E+_;if(v=v&&this.isOffscreen(A,k,P,M),y=y||this.isInsideGrid(A,k,P,M),"always"!==r&&this.grid.hitTestCircle(I,E,_,r,u)&&(g=!0,!l))return{circles:[],offscreen:!1,collisionDetected:g}}}}return{circles:!l&&g||!y||o<this.perspectiveRatioCutoff?[]:f,offscreen:v,collisionDetected:g}}queryRenderedSymbols(e){if(0===e.length||0===this.grid.keysLength()&&0===this.ignoredGrid.keysLength())return{};var t=[];let r=1/0,i=1/0,n=-1/0,o=-1/0;for(const h of e){var a=new de.Point(h.x+100,h.y+100);r=Math.min(r,a.x),i=Math.min(i,a.y),n=Math.max(n,a.x),o=Math.max(o,a.y),t.push(a)}var s={},l={};for(const d of this.grid.query(r,i,n,o).concat(this.ignoredGrid.query(r,i,n,o))){var c,u=d.key;void 0===s[u.bucketInstanceId]&&(s[u.bucketInstanceId]={}),s[u.bucketInstanceId][u.featureIndex]||(c=[new de.Point(d.x1,d.y1),new de.Point(d.x2,d.y1),new de.Point(d.x2,d.y2),new de.Point(d.x1,d.y2)],de.polygonIntersectsPolygon(t,c)&&(s[u.bucketInstanceId][u.featureIndex]=!0,void 0===l[u.bucketInstanceId]&&(l[u.bucketInstanceId]=[]),l[u.bucketInstanceId].push(u.featureIndex)))}return l}insertCollisionBox(e,t,r,i,n,o){(r?this.ignoredGrid:this.grid).insert({bucketInstanceId:i,featureIndex:n,collisionGroupID:o,overlapMode:t},e[0],e[1],e[2],e[3])}insertCollisionCircles(t,e,r,i,n,o){var a=r?this.ignoredGrid:this.grid,s={bucketInstanceId:i,featureIndex:n,collisionGroupID:o,overlapMode:e};for(let e=0;e<t.length;e+=4)a.insertCircle(s,t[e],t[e+1],t[e+2])}projectAndGetPerspectiveRatio(e,t,r,i){let n;return i?(n=[t,r,i(t,r),1],de.transformMat4(n,n,e)):je(n=[t,r,0,1],n,e),{point:new de.Point((n[0]/n[3]+1)/2*this.transform.width+100,(-n[1]/n[3]+1)/2*this.transform.height+100),perspectiveRatio:.5+this.transform.cameraToCenterDistance/n[3]*.5}}isOffscreen(e,t,r,i){return r<100||e>=this.screenRightBoundary||i<100||t>this.screenBottomBoundary}isInsideGrid(e,t,r,i){return 0<=r&&e<this.gridRightBoundary&&0<=i&&t<this.gridBottomBoundary}getViewportMatrix(){var e=de.identity([]);return de.translate(e,e,[-100,-100,0]),e}}function me(e,t,r){return t*(de.EXTENT/(e.tileSize*Math.pow(2,r-e.tileID.overscaledZ)))}class Ve{constructor(e,t,r,i){this.opacity=e?Math.max(0,Math.min(1,e.opacity+(e.placed?t:-t))):i&&r?1:0,this.placed=r}isHidden(){return 0===this.opacity&&!this.placed}}class S{constructor(e,t,r,i,n){this.text=new Ve(e?e.text:null,t,r,n),this.icon=new Ve(e?e.icon:null,t,i,n)}isHidden(){return this.text.isHidden()&&this.icon.isHidden()}}class Ge{constructor(e,t,r){this.text=e,this.icon=t,this.skipFade=r}}class Ke{constructor(){this.invProjMatrix=de.create(),this.viewportMatrix=de.create(),this.circles=[]}}class Ze{constructor(e,t,r,i,n){this.bucketInstanceId=e,this.featureIndex=t,this.sourceLayerIndex=r,this.bucketIndex=i,this.tileID=n}}class We{constructor(e){this.crossSourceCollisions=e,this.maxGroupID=0,this.collisionGroups={}}get(e){if(this.crossSourceCollisions)return{ID:0,predicate:null};if(!this.collisionGroups[e]){const t=++this.maxGroupID;this.collisionGroups[e]={ID:t,predicate:e=>e.collisionGroupID===t}}return this.collisionGroups[e]}}function Ye(e,t,r,i,n){var{horizontalAlign:e,verticalAlign:o}=de.getAnchorAlignment(e);return new de.Point(-(e-.5)*t+i[0]*n,-(o-.5)*r+i[1]*n)}function $e(e,t,r,i,n,o){var{x1:e,x2:a,y1:s,y2:l,anchorPointX:c,anchorPointY:u}=e,t=new de.Point(t,r);return i&&t._rotate(n?o:-o),{x1:e+t.x,y1:s+t.y,x2:a+t.x,y2:l+t.y,anchorPointX:c,anchorPointY:u}}class Xe{constructor(e,t,r,i,n){this.transform=e.clone(),this.terrain=t,this.collisionIndex=new He(this.transform),this.placements={},this.opacities={},this.variableOffsets={},this.stale=!1,this.commitTime=0,this.fadeDuration=r,this.retainedQueryData={},this.collisionGroups=new We(i),this.collisionCircleArrays={},(this.prevPlacement=n)&&(n.prevPlacement=void 0),this.placedOrientations={}}getBucketParts(t,r,i,n){var o=i.getBucket(r),a=i.latestFeatureIndex;if(o&&a&&r.id===o.layerIds[0]){var r=i.collisionBoxArray,s=o.layers[0].layout,l=Math.pow(2,this.transform.zoom-i.tileID.overscaledZ),c=i.tileSize/de.EXTENT,u=this.transform.calculatePosMatrix(i.tileID.toUnwrapped()),h="map"===s.get("text-pitch-alignment"),d="map"===s.get("text-rotation-alignment"),p=me(i,1,this.transform.zoom),f=Me(u,h,d,this.transform,p);let e=null;h&&(h=Re(u,h,d,this.transform,p),e=de.multiply([],this.transform.labelPlaneMatrix,h)),this.retainedQueryData[o.bucketInstanceId]=new Ze(o.bucketInstanceId,a,o.sourceLayerIndex,o.index,i.tileID);var m={bucket:o,layout:s,posMatrix:u,textLabelPlaneMatrix:f,labelToScreenMatrix:e,scale:l,textPixelRatio:c,holdingForFade:i.holdingForFade(),collisionBoxArray:r,partiallyEvaluatedTextSize:de.evaluateSizeForZoom(o.textSizeData,this.transform.zoom),collisionGroup:this.collisionGroups.get(o.sourceID)};if(n)for(const _ of o.sortKeyRanges){var{sortKey:g,symbolInstanceStart:y,symbolInstanceEnd:v}=_;t.push({sortKey:g,symbolInstanceStart:y,symbolInstanceEnd:v,parameters:m})}else t.push({symbolInstanceStart:0,symbolInstanceEnd:o.symbolInstances.length,parameters:m})}}attemptAnchorPlacement(t,r,i,n,o,e,a,s,l,c,u,h,d,p,f,m){var g=de.TextAnchorEnum[t.textAnchor],t=[t.textOffset0,t.textOffset1],y=Ye(g,i,n,t,o),r=this.collisionIndex.placeCollisionBox($e(r,y.x,y.y,e,a,this.transform.angle),u,s,l,c.predicate,m);if(f&&0===this.collisionIndex.placeCollisionBox($e(f,y.x,y.y,e,a,this.transform.angle),u,s,l,c.predicate,m).box.length)return;if(0<r.box.length){let e;if(this.prevPlacement&&this.prevPlacement.variableOffsets[h.crossTileID]&&this.prevPlacement.placements[h.crossTileID]&&this.prevPlacement.placements[h.crossTileID].text&&(e=this.prevPlacement.variableOffsets[h.crossTileID].anchor),0===h.crossTileID)throw new Error("symbolInstance.crossTileID can't be 0");return this.variableOffsets[h.crossTileID]={textOffset:t,width:i,height:n,anchor:g,textBoxScale:o,prevAnchor:e},this.markUsedJustification(d,g,h,p),d.allowVerticalPlacement&&(this.markUsedOrientation(d,p,h),this.placedOrientations[h.crossTileID]=p),{shift:y,placedGlyphBoxes:r}}}placeLayerBucketPart(t,C,T){const{bucket:S,layout:E,posMatrix:I,textLabelPlaneMatrix:A,labelToScreenMatrix:k,textPixelRatio:P,holdingForFade:e,collisionBoxArray:r,partiallyEvaluatedTextSize:M,collisionGroup:R}=t.parameters,O=E.get("text-optional"),L=E.get("icon-optional"),D=de.getOverlapMode(E,"text-overlap","text-allow-overlap"),z="always"===D,N=de.getOverlapMode(E,"icon-overlap","icon-allow-overlap");var i="always"===N;const B="map"===E.get("text-rotation-alignment"),F="map"===E.get("text-pitch-alignment"),U="none"!==E.get("icon-text-fit");var n="viewport-y"===E.get("symbol-z-order");const q=z&&(i||!S.hasIconData()||L),j=i&&(z||!S.hasTextData()||O),o=(!S.collisionArrays&&r&&S.deserializeCollisionBoxes(r),this.retainedQueryData[S.bucketInstanceId].tileID),H=this.terrain?(e,t)=>this.terrain.getElevation(o,e,t):null;var a=(f,c)=>{if(!C[f.crossTileID])if(e)this.placements[f.crossTileID]=new Ge(!1,!1,!1);else{let d=!1,e=!1,t=!0,p=null,i={box:null,offscreen:null},n={box:null,offscreen:null};let r=null,o=null,a=0,s=0,l=0;c.textFeatureIndex?a=c.textFeatureIndex:f.useRuntimeCollisionCircles&&(a=f.featureIndex),c.verticalTextFeatureIndex&&(s=c.verticalTextFeatureIndex);const v=c.textBox;if(v){var u=e=>{let t=de.WritingMode.horizontal;return S.allowVerticalPlacement&&!e&&this.prevPlacement&&(e=this.prevPlacement.placedOrientations[f.crossTileID])&&(this.placedOrientations[f.crossTileID]=e,t=e,this.markUsedOrientation(S,t,f)),t},m=(e,t)=>{if(S.allowVerticalPlacement&&0<f.numVerticalGlyphVertices&&c.verticalTextBox){for(const r of S.writingModes)if(r===de.WritingMode.vertical?(i=t(),n=i):i=e(),i&&i.box&&i.box.length)break}else i=e()};const _=f.textAnchorOffsetStartIndex,b=f.textAnchorOffsetEndIndex;if(b===_){const w=(e,t)=>{e=this.collisionIndex.placeCollisionBox(e,D,P,I,R.predicate,H);return e&&e.box&&e.box.length&&(this.markUsedOrientation(S,t,f),this.placedOrientations[f.crossTileID]=t),e};m(()=>w(v,de.WritingMode.horizontal),()=>{var e=c.verticalTextBox;return S.allowVerticalPlacement&&0<f.numVerticalGlyphVertices&&e?w(e,de.WritingMode.vertical):{box:null,offscreen:null}}),u(i&&i.box&&i.box.length)}else{let h=de.TextAnchorEnum[null==(g=null==(g=this.prevPlacement)?void 0:g.variableOffsets[f.crossTileID])?void 0:g.anchor];const x=(t,e,r)=>{var i=t.x2-t.x1,n=t.y2-t.y1,o=f.textBoxScale,a=U&&"never"===N?e:null;let s={box:[],offscreen:!1},l="never"===D?1:2,c="never";h&&l++;for(let e=0;e<l;e++){for(let e=_;e<b;e++){var u=S.textAnchorOffsets.get(e);if(!h||u.textAnchor===h){u=this.attemptAnchorPlacement(u,t,i,n,o,B,F,P,I,R,c,f,S,r,a,H);if(u&&(s=u.placedGlyphBoxes)&&s.box&&s.box.length)return d=!0,p=u.shift,s}}h?h=null:c=D}return s};m(()=>x(v,c.iconBox,de.WritingMode.horizontal),()=>{var e=c.verticalTextBox,t=i&&i.box&&i.box.length;return S.allowVerticalPlacement&&!t&&0<f.numVerticalGlyphVertices&&e?x(e,c.verticalIconBox,de.WritingMode.vertical):{box:null,offscreen:null}}),i&&(d=i.box,t=i.offscreen);var g=u(i&&i.box);!d&&this.prevPlacement&&(m=this.prevPlacement.variableOffsets[f.crossTileID])&&(this.variableOffsets[f.crossTileID]=m,this.markUsedJustification(S,m.anchor,f,g))}}u=i,d=u&&u.box&&0<u.box.length,t=u&&u.offscreen,f.useRuntimeCollisionCircles&&(m=S.text.placedSymbolArray.get(f.centerJustifiedTextSymbolIndex),g=de.evaluateSizeForFeature(S.textSizeData,M,m),y=E.get("text-padding"),h=f.collisionCircleDiameter,(r=this.collisionIndex.placeCollisionCircles(D,m,S.lineVertexArray,S.glyphOffsetArray,g,I,A,k,T,F,R.predicate,h,y,H)).circles.length&&r.collisionDetected&&!T&&de.warnOnce("Collisions detected, but collision boxes are not shown"),d=z||0<r.circles.length&&!r.collisionDetected,t=t&&r.offscreen),c.iconFeatureIndex&&(l=c.iconFeatureIndex),c.iconBox&&(m=e=>{e=U&&p?$e(e,p.x,p.y,B,F,this.transform.angle):e;return this.collisionIndex.placeCollisionBox(e,N,P,I,R.predicate,H)},e=0<(o=n&&n.box&&n.box.length&&c.verticalIconBox?m(c.verticalIconBox):m(c.iconBox)).box.length,t=t&&o.offscreen);var g=O||0===f.numHorizontalGlyphVertices&&0===f.numVerticalGlyphVertices,h=L||0===f.numIconVertices;if(g||h?h?g||(e=e&&d):d=e&&d:e=d=e&&d,d&&u&&u.box&&(n&&n.box&&s?this.collisionIndex.insertCollisionBox(u.box,D,E.get("text-ignore-placement"),S.bucketInstanceId,s,R.ID):this.collisionIndex.insertCollisionBox(u.box,D,E.get("text-ignore-placement"),S.bucketInstanceId,a,R.ID)),e&&o&&this.collisionIndex.insertCollisionBox(o.box,N,E.get("icon-ignore-placement"),S.bucketInstanceId,l,R.ID),r&&(d&&this.collisionIndex.insertCollisionCircles(r.circles,D,E.get("text-ignore-placement"),S.bucketInstanceId,a,R.ID),T)){var y=S.bucketInstanceId;let t=this.collisionCircleArrays[y];void 0===t&&(t=this.collisionCircleArrays[y]=new Ke);for(let e=0;e<r.circles.length;e+=4)t.circles.push(r.circles[e+0]),t.circles.push(r.circles[e+1]),t.circles.push(r.circles[e+2]),t.circles.push(r.collisionDetected?1:0)}if(0===f.crossTileID)throw new Error("symbolInstance.crossTileID can't be 0");if(0===S.bucketInstanceId)throw new Error("bucket.bucketInstanceId can't be 0");this.placements[f.crossTileID]=new Ge(d||q,e||j,t||S.justReloaded),C[f.crossTileID]=!0}};if(n){if(0!==t.symbolInstanceStart)throw new Error("bucket.bucketInstanceId should be 0");var s=S.getSortedSymbolIndexes(this.transform.angle);for(let e=s.length-1;0<=e;--e){var l=s[e];a(S.symbolInstances.get(l),S.collisionArrays[l])}}else for(let e=t.symbolInstanceStart;e<t.symbolInstanceEnd;e++)a(S.symbolInstances.get(e),S.collisionArrays[e]);T&&S.bucketInstanceId in this.collisionCircleArrays&&(i=this.collisionCircleArrays[S.bucketInstanceId],de.invert(i.invProjMatrix,I),i.viewportMatrix=this.collisionIndex.getViewportMatrix()),S.justReloaded=!1}markUsedJustification(e,t,r,i){var n={left:r.leftJustifiedTextSymbolIndex,center:r.centerJustifiedTextSymbolIndex,right:r.rightJustifiedTextSymbolIndex};let o;o=i===de.WritingMode.vertical?r.verticalPlacedTextSymbolIndex:n[de.getAnchorJustification(t)];for(const a of[r.leftJustifiedTextSymbolIndex,r.centerJustifiedTextSymbolIndex,r.rightJustifiedTextSymbolIndex,r.verticalPlacedTextSymbolIndex])0<=a&&(0<=o&&a!==o?e.text.placedSymbolArray.get(a).crossTileID=0:e.text.placedSymbolArray.get(a).crossTileID=r.crossTileID)}markUsedOrientation(e,t,r){var i=t===de.WritingMode.horizontal||t===de.WritingMode.horizontalOnly?t:0,t=t===de.WritingMode.vertical?t:0;for(const n of[r.leftJustifiedTextSymbolIndex,r.centerJustifiedTextSymbolIndex,r.rightJustifiedTextSymbolIndex])e.text.placedSymbolArray.get(n).placedOrientation=i;r.verticalPlacedTextSymbolIndex&&(e.text.placedSymbolArray.get(r.verticalPlacedTextSymbolIndex).placedOrientation=t)}commit(e){this.commitTime=e,this.zoomAtLastRecencyCheck=this.transform.zoom;var t=this.prevPlacement;let r=!1;this.prevZoomAdjustment=t?t.zoomAdjustment(this.transform.zoom):0;var i=t?t.symbolFadeChange(e):1,n=t?t.opacities:{},o=t?t.variableOffsets:{},a=t?t.placedOrientations:{};for(const h in this.placements){var s=this.placements[h],l=n[h];r=l?(this.opacities[h]=new S(l,i,s.text,s.icon),r||s.text!==l.text.placed||s.icon!==l.icon.placed):(this.opacities[h]=new S(null,i,s.text,s.icon,s.skipFade),r||s.text||s.icon)}for(const d in n){var c,u=n[d];this.opacities[d]||(c=new S(u,i,!1,!1)).isHidden()||(this.opacities[d]=c,r=r||u.text.placed||u.icon.placed)}for(const p in o)this.variableOffsets[p]||!this.opacities[p]||this.opacities[p].isHidden()||(this.variableOffsets[p]=o[p]);for(const f in a)this.placedOrientations[f]||!this.opacities[f]||this.opacities[f].isHidden()||(this.placedOrientations[f]=a[f]);if(t&&void 0===t.lastPlacementChangeTime)throw new Error("Last placement time for previous placement is not defined");r?this.lastPlacementChangeTime=e:"number"!=typeof this.lastPlacementChangeTime&&(this.lastPlacementChangeTime=t?t.lastPlacementChangeTime:e)}updateLayerOpacities(e,t){var r={};for(const n of t){var i=n.getBucket(e);i&&n.latestFeatureIndex&&e.id===i.layerIds[0]&&this.updateBucketOpacities(i,r,n.collisionBoxArray)}}updateBucketOpacities(i,t,e){i.hasTextData()&&(i.text.opacityVertexArray.clear(),i.text.hasVisibleVertices=!1),i.hasIconData()&&(i.icon.opacityVertexArray.clear(),i.icon.hasVisibleVertices=!1),i.hasIconCollisionBoxData()&&i.iconCollisionBox.collisionVertexArray.clear(),i.hasTextCollisionBoxData()&&i.textCollisionBox.collisionVertexArray.clear();var r=i.layers[0],n=r.layout,o=new S(null,0,!1,!1,!0),a=n.get("text-allow-overlap"),s=n.get("icon-allow-overlap"),l=r._unevaluatedLayout.hasValue("text-variable-anchor")||r._unevaluatedLayout.hasValue("text-variable-anchor-offset"),c="map"===n.get("text-rotation-alignment"),u="map"===n.get("text-pitch-alignment"),h="none"!==n.get("icon-text-fit"),d=new S(null,0,a&&(s||!i.hasIconData()||n.get("icon-optional")),s&&(a||!i.hasTextData()||n.get("text-optional")),!0),p=(!i.collisionArrays&&e&&(i.hasIconCollisionBoxData()||i.hasTextCollisionBoxData())&&i.deserializeCollisionBoxes(e),(t,r,i)=>{for(let e=0;e<r/4;e++)t.opacityVertexArray.emplaceBack(i);t.hasVisibleVertices=t.hasVisibleVertices||i!==E});for(let e=0;e<i.symbolInstances.length;e++){var f=i.symbolInstances.get(e),{numHorizontalGlyphVertices:m,numVerticalGlyphVertices:g,crossTileID:y}=f,v=t[y];let r=this.opacities[y];v?r=o:r||(r=d,this.opacities[y]=r),t[y]=!0;var v=0<f.numIconVertices,_=this.placedOrientations[f.crossTileID];const C=_===de.WritingMode.vertical;var b=_===de.WritingMode.horizontal||_===de.WritingMode.horizontalOnly;if(0<m||0<g){var w=at(r.text),x=C?E:w,m=(p(i.text,m,x),b?E:w);p(i.text,g,m);const T=r.text.isHidden();[f.rightJustifiedTextSymbolIndex,f.centerJustifiedTextSymbolIndex,f.leftJustifiedTextSymbolIndex].forEach(e=>{0<=e&&(i.text.placedSymbolArray.get(e).hidden=T||C?1:0)}),0<=f.verticalPlacedTextSymbolIndex&&(i.text.placedSymbolArray.get(f.verticalPlacedTextSymbolIndex).hidden=T||b?1:0);var x=this.variableOffsets[f.crossTileID],w=(x&&this.markUsedJustification(i,x.anchor,f,_),this.placedOrientations[f.crossTileID]);w&&(this.markUsedJustification(i,"left",f,w),this.markUsedOrientation(i,w,f))}if(v&&(g=at(r.icon),m=!(h&&f.verticalPlacedIconSymbolIndex&&C),0<=f.placedIconSymbolIndex&&(x=m?g:E,p(i.icon,f.numIconVertices,x),i.icon.placedSymbolArray.get(f.placedIconSymbolIndex).hidden=r.icon.isHidden()),0<=f.verticalPlacedIconSymbolIndex)&&(_=m?E:g,p(i.icon,f.numVerticalIconVertices,_),i.icon.placedSymbolArray.get(f.verticalPlacedIconSymbolIndex).hidden=r.icon.isHidden()),i.hasIconCollisionBoxData()||i.hasTextCollisionBoxData()){w=i.collisionArrays[e];if(w){let t=new de.Point(0,0);if(w.textBox||w.verticalTextBox){let e=!0;l&&((v=this.variableOffsets[y])?(t=Ye(v.anchor,v.width,v.height,v.textOffset,v.textBoxScale),c&&t._rotate(u?this.transform.angle:-this.transform.angle)):e=!1),w.textBox&&Je(i.textCollisionBox.collisionVertexArray,r.text.placed,!e||C,t.x,t.y),w.verticalTextBox&&Je(i.textCollisionBox.collisionVertexArray,r.text.placed,!e||b,t.x,t.y)}m=Boolean(!b&&w.verticalIconBox);w.iconBox&&Je(i.iconCollisionBox.collisionVertexArray,r.icon.placed,m,h?t.x:0,h?t.y:0),w.verticalIconBox&&Je(i.iconCollisionBox.collisionVertexArray,r.icon.placed,!m,h?t.x:0,h?t.y:0)}}}if(i.sortFeatures(this.transform.angle),this.retainedQueryData[i.bucketInstanceId]&&(this.retainedQueryData[i.bucketInstanceId].featureSortOrder=i.featureSortOrder),i.hasTextData()&&i.text.opacityVertexBuffer&&i.text.opacityVertexBuffer.updateData(i.text.opacityVertexArray),i.hasIconData()&&i.icon.opacityVertexBuffer&&i.icon.opacityVertexBuffer.updateData(i.icon.opacityVertexArray),i.hasIconCollisionBoxData()&&i.iconCollisionBox.collisionVertexBuffer&&i.iconCollisionBox.collisionVertexBuffer.updateData(i.iconCollisionBox.collisionVertexArray),i.hasTextCollisionBoxData()&&i.textCollisionBox.collisionVertexBuffer&&i.textCollisionBox.collisionVertexBuffer.updateData(i.textCollisionBox.collisionVertexArray),i.text.opacityVertexArray.length!==i.text.layoutVertexArray.length/4)throw new Error(`bucket.text.opacityVertexArray.length (= ${i.text.opacityVertexArray.length}) !== bucket.text.layoutVertexArray.length (= ${i.text.layoutVertexArray.length}) / 4`);if(i.icon.opacityVertexArray.length!==i.icon.layoutVertexArray.length/4)throw new Error(`bucket.icon.opacityVertexArray.length (= ${i.icon.opacityVertexArray.length}) !== bucket.icon.layoutVertexArray.length (= ${i.icon.layoutVertexArray.length}) / 4`);i.bucketInstanceId in this.collisionCircleArrays&&(r=this.collisionCircleArrays[i.bucketInstanceId],i.placementInvProjMatrix=r.invProjMatrix,i.placementViewportMatrix=r.viewportMatrix,i.collisionCircleArray=r.circles,delete this.collisionCircleArrays[i.bucketInstanceId])}symbolFadeChange(e){return 0===this.fadeDuration?1:(e-this.commitTime)/this.fadeDuration+this.prevZoomAdjustment}zoomAdjustment(e){return Math.max(0,(this.transform.zoom-e)/1.5)}hasTransitions(e){return this.stale||e-this.lastPlacementChangeTime<this.fadeDuration}stillRecent(e,t){var r=this.zoomAtLastRecencyCheck===t?1-this.zoomAdjustment(t):1;return this.zoomAtLastRecencyCheck=t,this.commitTime+this.fadeDuration*r>e}setStale(){this.stale=!0}}function Je(e,t,r,i,n){e.emplaceBack(t?1:0,r?1:0,i||0,n||0),e.emplaceBack(t?1:0,r?1:0,i||0,n||0),e.emplaceBack(t?1:0,r?1:0,i||0,n||0),e.emplaceBack(t?1:0,r?1:0,i||0,n||0)}const Qe=Math.pow(2,25),et=Math.pow(2,24),tt=Math.pow(2,17),rt=Math.pow(2,16),it=Math.pow(2,9),nt=Math.pow(2,8),ot=Math.pow(2,1);function at(e){var t;return 0!==e.opacity||e.placed?1===e.opacity&&e.placed?4294967295:(t=e.placed?1:0,(e=Math.floor(127*e.opacity))*Qe+t*et+e*tt+t*rt+e*it+t*nt+e*ot+t):0}const E=0;class st{constructor(e){this._sortAcrossTiles="viewport-y"!==e.layout.get("symbol-z-order")&&!e.layout.get("symbol-sort-key").isConstant(),this._currentTileIndex=0,this._currentPartIndex=0,this._seenCrossTileIDs={},this._bucketParts=[]}continuePlacement(e,t,r,i,n){for(var o=this._bucketParts;this._currentTileIndex<e.length;){var a=e[this._currentTileIndex];if(t.getBucketParts(o,i,a,this._sortAcrossTiles),this._currentTileIndex++,n())return!0}for(this._sortAcrossTiles&&(this._sortAcrossTiles=!1,o.sort((e,t)=>e.sortKey-t.sortKey));this._currentPartIndex<o.length;){var s=o[this._currentPartIndex];if(t.placeLayerBucketPart(s,this._seenCrossTileIDs,r),this._currentPartIndex++,n())return!0}return!1}}class lt{constructor(e,t,r,i,n,o,a,s){this.placement=new Xe(e,t,o,a,s),this._currentPlacementIndex=r.length-1,this._forceFullPlacement=i,this._showCollisionBoxes=n,this._done=!1}isDone(){return this._done}continuePlacement(e,t,r){const i=M.now();for(var n=()=>!this._forceFullPlacement&&2<M.now()-i;0<=this._currentPlacementIndex;){var o=t[e[this._currentPlacementIndex]],a=this.placement.collisionIndex.transform.zoom;if("symbol"===o.type&&(!o.minzoom||o.minzoom<=a)&&(!o.maxzoom||o.maxzoom>a)){if(this._inProgressLayer||(this._inProgressLayer=new st(o)),this._inProgressLayer.continuePlacement(r[o.source],this.placement,this._showCollisionBoxes,o,n))return;delete this._inProgressLayer}this._currentPlacementIndex--}this._done=!0}commit(e){return this.placement.commit(e),this.placement}}const p=512/de.EXTENT/2;class ct{constructor(e,t,r){this.tileID=e,this.bucketInstanceId=r,this._symbolsByKey={};var i,n,o=new Map;for(let e=0;e<t.length;e++){var a=t.get(e),s=a.key,l=o.get(s);l?l.push(a):o.set(s,[a])}for([i,n]of o){var c={positions:n.map(e=>({x:Math.floor(e.anchorX*p),y:Math.floor(e.anchorY*p)})),crossTileIDs:n.map(e=>e.crossTileID)};if(128<c.positions.length){var u,h,d=new de.KDBush(c.positions.length,16,Uint16Array);for({x:u,y:h}of c.positions)d.add(u,h);d.finish(),delete c.positions,c.index=d}this._symbolsByKey[i]=c}}getScaledCoordinates(e,t){var{x:r,y:i,z:n}=this.tileID.canonical,{x:t,y:o,z:a}=t.canonical,a=a-n,n=p/Math.pow(2,a),a=(t*de.EXTENT+e.anchorX)*n,t=(o*de.EXTENT+e.anchorY)*n,o=r*de.EXTENT*p,e=i*de.EXTENT*p;return{x:Math.floor(a-o),y:Math.floor(t-e)}}findMatches(t,r,i){var n=this.tileID.canonical.z<r.canonical.z?1:Math.pow(2,this.tileID.canonical.z-r.canonical.z);for(let e=0;e<t.length;e++){var o=t.get(e);if(!o.crossTileID){var a=this._symbolsByKey[o.key];if(a){var s=this.getScaledCoordinates(o,r);if(a.index)for(const h of a.index.range(s.x-n,s.y-n,s.x+n,s.y+n).sort()){var l=a.crossTileIDs[h];if(!i[l]){i[l]=!0,o.crossTileID=l;break}}else if(a.positions)for(let e=0;e<a.positions.length;e++){var c=a.positions[e],u=a.crossTileIDs[e];if(Math.abs(c.x-s.x)<=n&&Math.abs(c.y-s.y)<=n&&!i[u]){i[u]=!0,o.crossTileID=u;break}}}}}}getCrossTileIDsLists(){return Object.values(this._symbolsByKey).map(({crossTileIDs:e})=>e)}}class ut{constructor(){this.maxCrossTileID=0}generate(){return++this.maxCrossTileID}}class ht{constructor(){this.indexes={},this.usedCrossTileIDs={},this.lng=0}handleWrapJump(e){var t=Math.round((e-this.lng)/360);if(0!==t)for(const o in this.indexes){var r=this.indexes[o],i={};for(const a in r){var n=r[a];n.tileID=n.tileID.unwrapTo(n.tileID.wrap+t),i[n.tileID.key]=n}this.indexes[o]=i}this.lng=e}addBucket(e,t,r){if(this.indexes[e.overscaledZ]&&this.indexes[e.overscaledZ][e.key]){if(this.indexes[e.overscaledZ][e.key].bucketInstanceId===t.bucketInstanceId)return!1;this.removeBucketCrossTileIDs(e.overscaledZ,this.indexes[e.overscaledZ][e.key])}for(let e=0;e<t.symbolInstances.length;e++)t.symbolInstances.get(e).crossTileID=0;this.usedCrossTileIDs[e.overscaledZ]||(this.usedCrossTileIDs[e.overscaledZ]={});var i=this.usedCrossTileIDs[e.overscaledZ];for(const l in this.indexes){var n=this.indexes[l];if(Number(l)>e.overscaledZ)for(const c in n){var o=n[c];o.tileID.isChildOf(e)&&o.findMatches(t.symbolInstances,e,i)}else{var a=n[e.scaledTo(Number(l)).key];a&&a.findMatches(t.symbolInstances,e,i)}}for(let e=0;e<t.symbolInstances.length;e++){var s=t.symbolInstances.get(e);s.crossTileID||(s.crossTileID=r.generate(),i[s.crossTileID]=!0)}return void 0===this.indexes[e.overscaledZ]&&(this.indexes[e.overscaledZ]={}),this.indexes[e.overscaledZ][e.key]=new ct(e,t.symbolInstances,t.bucketInstanceId),!0}removeBucketCrossTileIDs(e,t){for(const r of t.getCrossTileIDsLists())for(const i of r)delete this.usedCrossTileIDs[e][i]}removeStaleBuckets(e){let t=!1;for(const i in this.indexes){var r=this.indexes[i];for(const n in r)e[r[n].bucketInstanceId]||(this.removeBucketCrossTileIDs(i,r[n]),delete r[n],t=!0)}return t}}class dt{constructor(){this.layerIndexes={},this.crossTileIDs=new ut,this.maxBucketInstanceId=0,this.bucketsInCurrentPlacement={}}addLayer(e,t,r){let i=this.layerIndexes[e.id],n=!1;var o={};(i=void 0===i?this.layerIndexes[e.id]=new ht:i).handleWrapJump(r);for(const s of t){var a=s.getBucket(e);a&&e.id===a.layerIds[0]&&(a.bucketInstanceId||(a.bucketInstanceId=++this.maxBucketInstanceId),i.addBucket(s.tileID,a,this.crossTileIDs)&&(n=!0),o[a.bucketInstanceId]=!0)}return n=i.removeStaleBuckets(o)?!0:n}pruneUnusedLayers(e){const t={};e.forEach(e=>{t[e]=!0});for(const r in this.layerIndexes)t[r]||delete this.layerIndexes[r]}}const pt=(e,t)=>de.emitValidationErrors(e,t&&t.filter(e=>"source.canvas"!==e.identifier)),ft=de.emptyStyle();class mt extends de.Evented{constructor(e,t={}){super(),this._rtlPluginLoaded=()=>{for(const t in this.sourceCaches){var e=this.sourceCaches[t].getSource().type;"vector"!==e&&"geojson"!==e||this.sourceCaches[t].reload()}},this.map=e,this.dispatcher=new Q(J(),e._getMapId()),this.dispatcher.registerMessageHandler("GG",(e,t)=>this.getGlyphs(e,t)),this.dispatcher.registerMessageHandler("GI",(e,t)=>this.getImages(e,t)),this.imageManager=new j,this.imageManager.setEventedParent(this),this.glyphManager=new a(e._requestManager,t.localIdeographFontFamily),this.lineAtlas=new Y(256,512),this.crossTileSymbolIndex=new dt,this._spritesImagesIds={},this._layers={},this._order=[],this.sourceCaches={},this.zoomHistory=new de.ZoomHistory,this._loaded=!1,this._availableImages=[],this._resetUpdates(),this.dispatcher.broadcast("SR",de.getReferrer()),c().on(be,this._rtlPluginLoaded),this.on("data",e=>{if("source"===e.dataType&&"metadata"===e.sourceDataType){e=this.sourceCaches[e.sourceId];if(e){var t=e.getSource();if(t&&t.vectorLayerIds)for(const i in this._layers){var r=this._layers[i];r.source===t.id&&this._validateLayer(r)}}}})}loadURL(e,t={},r){this.fire(new de.Event("dataloading",{dataType:"style"})),t.validate="boolean"!=typeof t.validate||t.validate;e=this.map._requestManager.transformRequest(e,"Style");this._loadStyleRequest=new AbortController,de.getJSON(e,this._loadStyleRequest).then(e=>{this._loadStyleRequest=null,this._load(e.data,t,r)}).catch(e=>{this._loadStyleRequest=null,e&&this.fire(new de.ErrorEvent(e))})}loadJSON(e,t={},r){this.fire(new de.Event("dataloading",{dataType:"style"})),this._frameRequest=new AbortController,M.frameAsync(this._frameRequest).then(()=>{this._frameRequest=null,t.validate=!1!==t.validate,this._load(e,t,r)}).catch(()=>{})}loadEmpty(){this.fire(new de.Event("dataloading",{dataType:"style"})),this._load(ft,{validate:!1})}_load(e,t,r){var i=t.transformStyle?t.transformStyle(r,e):e;if(!t.validate||!pt(this,de.validateStyle(i))){this._loaded=!0;for(const n in(this.stylesheet=i).sources)this.addSource(n,i.sources[n],{validate:!1});i.sprite?this._loadSprite(i.sprite):this.imageManager.setLoaded(!0),this.glyphManager.setURL(i.glyphs),this._createLayers(),this.light=new W(this.stylesheet.light),this.map.setTerrain(null!=(r=this.stylesheet.terrain)?r:null),this.fire(new de.Event("data",{dataType:"style"})),this.fire(new de.Event("style.load"))}}_createLayers(){var e=de.derefLayers(this.stylesheet.layers);this.dispatcher.broadcast("SL",e),this._order=e.map(e=>e.id),this._layers={},this._serializedLayers=null;for(const r of e){var t=de.createStyleLayer(r);t.setEventedParent(this,{layer:{id:r.id}}),this._layers[r.id]=t}}_loadSprite(e,o=!1,t=void 0){this.imageManager.setLoaded(!1),this._spriteRequest=new AbortController;let r;q(e,this.map._requestManager,this.map.getPixelRatio(),this._spriteRequest).then(t=>{if(this._spriteRequest=null,t)for(const r in t){this._spritesImagesIds[r]=[];for(const i of this._spritesImagesIds[r]?this._spritesImagesIds[r].filter(e=>!(e in t)):[])this.imageManager.removeImage(i),this._changedImages[i]=!0;for(const n in t[r]){var e="default"===r?n:r+":"+n;this._spritesImagesIds[r].push(e),e in this.imageManager.images?this.imageManager.updateImage(e,t[r][n],!1):this.imageManager.addImage(e,t[r][n]),o&&(this._changedImages[e]=!0)}}}).catch(e=>{this._spriteRequest=null,r=e,this.fire(new de.ErrorEvent(r))}).finally(()=>{this.imageManager.setLoaded(!0),this._availableImages=this.imageManager.listImages(),o&&(this._changed=!0),this.dispatcher.broadcast("SI",this._availableImages),this.fire(new de.Event("data",{dataType:"style"})),t&&t(r)})}_unloadSprite(){for(const e of Object.values(this._spritesImagesIds).flat())this.imageManager.removeImage(e),this._changedImages[e]=!0;this._spritesImagesIds={},this._availableImages=this.imageManager.listImages(),this._changed=!0,this.dispatcher.broadcast("SI",this._availableImages),this.fire(new de.Event("data",{dataType:"style"}))}_validateLayer(e){var t,r=this.sourceCaches[e.source];r&&(t=e.sourceLayer)&&("geojson"===(r=r.getSource()).type||r.vectorLayerIds&&-1===r.vectorLayerIds.indexOf(t))&&this.fire(new de.ErrorEvent(new Error(`Source layer "${t}" `+`does not exist on source "${r.id}" `+`as specified by style layer "${e.id}".`)))}loaded(){if(!this._loaded)return!1;if(Object.keys(this._updatedSources).length)return!1;for(const e in this.sourceCaches)if(!this.sourceCaches[e].loaded())return!1;return!!this.imageManager.isLoaded()}_serializeByIds(e){var t=this._serializedAllLayers();if(!e||0===e.length)return Object.values(t);var r=[];for(const i of e)t[i]&&r.push(t[i]);return r}_serializedAllLayers(){var e=this._serializedLayers;if(!e){e=this._serializedLayers={};for(const r of Object.keys(this._layers)){var t=this._layers[r];"custom"!==t.type&&(e[r]=t.serialize())}}return e}hasTransitions(){if(this.light&&this.light.hasTransition())return!0;for(const e in this.sourceCaches)if(this.sourceCaches[e].hasTransition())return!0;for(const t in this._layers)if(this._layers[t].hasTransition())return!0;return!1}_checkLoaded(){if(!this._loaded)throw new Error("Style is not done loading.")}update(e){if(this._loaded){var t=this._changed;if(this._changed){var r=Object.keys(this._updatedLayers),i=Object.keys(this._removedLayers);(r.length||i.length)&&this._updateWorkerLayers(r,i);for(const c in this._updatedSources){var n=this._updatedSources[c];if("reload"===n)this._reloadSource(c);else{if("clear"!==n)throw new Error("Invalid action "+n);this._clearSource(c)}}this._updateTilesForChangedImages(),this._updateTilesForChangedGlyphs();for(const u in this._updatedPaintProps)this._layers[u].updateTransitions(e);this.light.updateTransitions(e),this._resetUpdates()}var o={};for(const h in this.sourceCaches){var a=this.sourceCaches[h];o[h]=a.used,a.used=!1}for(const d of this._order){var s=this._layers[d];s.recalculate(e,this._availableImages),!s.isHidden(e.zoom)&&s.source&&(this.sourceCaches[s.source].used=!0)}for(const p in o){var l=this.sourceCaches[p];o[p]!==l.used&&l.fire(new de.Event("data",{sourceDataType:"visibility",dataType:"source",sourceId:p}))}this.light.recalculate(e),this.z=e.zoom,t&&this.fire(new de.Event("data",{dataType:"style"}))}}_updateTilesForChangedImages(){var e=Object.keys(this._changedImages);if(e.length){for(const t in this.sourceCaches)this.sourceCaches[t].reloadTilesForDependencies(["icons","patterns"],e);this._changedImages={}}}_updateTilesForChangedGlyphs(){if(this._glyphsDidChange){for(const e in this.sourceCaches)this.sourceCaches[e].reloadTilesForDependencies(["glyphs"],[""]);this._glyphsDidChange=!1}}_updateWorkerLayers(e,t){this.dispatcher.broadcast("UL",{layers:this._serializeByIds(e),removedIds:t})}_resetUpdates(){this._changed=!1,this._updatedLayers={},this._removedLayers={},this._updatedSources={},this._updatedPaintProps={},this._changedImages={},this._glyphsDidChange=!1}setState(e,t={}){this._checkLoaded();var r=this.serialize(),t=(e=t.transformStyle?t.transformStyle(r,e):e,null==(t=t.validate)||t);if(t&&pt(this,de.validateStyle(e)))return!1;(e=de.clone$1(e)).layers=de.derefLayers(e.layers);t=de.diffStyles(r,e),r=this._getOperationsToPerform(t);if(0<r.unimplemented.length)throw new Error(`Unimplemented: ${r.unimplemented.join(", ")}.`);if(0===r.operations.length)return!1;for(const i of r.operations)i();return this.stylesheet=e,!(this._serializedLayers=null)}_getOperationsToPerform(e){var t=[],r=[];for(const i of e)switch(i.command){case"setCenter":case"setZoom":case"setBearing":case"setPitch":continue;case"addLayer":t.push(()=>this.addLayer.apply(this,i.args));break;case"removeLayer":t.push(()=>this.removeLayer.apply(this,i.args));break;case"setPaintProperty":t.push(()=>this.setPaintProperty.apply(this,i.args));break;case"setLayoutProperty":t.push(()=>this.setLayoutProperty.apply(this,i.args));break;case"setFilter":t.push(()=>this.setFilter.apply(this,i.args));break;case"addSource":t.push(()=>this.addSource.apply(this,i.args));break;case"removeSource":t.push(()=>this.removeSource.apply(this,i.args));break;case"setLayerZoomRange":t.push(()=>this.setLayerZoomRange.apply(this,i.args));break;case"setLight":t.push(()=>this.setLight.apply(this,i.args));break;case"setGeoJSONSourceData":t.push(()=>this.setGeoJSONSourceData.apply(this,i.args));break;case"setGlyphs":t.push(()=>this.setGlyphs.apply(this,i.args));break;case"setSprite":t.push(()=>this.setSprite.apply(this,i.args));break;case"setTerrain":t.push(()=>this.map.setTerrain.apply(this,i.args));break;case"setTransition":t.push(()=>{});break;default:r.push(i.command)}return{operations:t,unimplemented:r}}addImage(e,t){if(this.getImage(e))return this.fire(new de.ErrorEvent(new Error(`An image named "${e}" already exists.`)));this.imageManager.addImage(e,t),this._afterImageUpdated(e)}updateImage(e,t){this.imageManager.updateImage(e,t)}getImage(e){return this.imageManager.getImage(e)}removeImage(e){if(!this.getImage(e))return this.fire(new de.ErrorEvent(new Error(`An image named "${e}" does not exist.`)));this.imageManager.removeImage(e),this._afterImageUpdated(e)}_afterImageUpdated(e){this._availableImages=this.imageManager.listImages(),this._changedImages[e]=!0,this._changed=!0,this.dispatcher.broadcast("SI",this._availableImages),this.fire(new de.Event("data",{dataType:"style"}))}listImages(){return this._checkLoaded(),this.imageManager.listImages()}addSource(e,t,r={}){if(this._checkLoaded(),void 0!==this.sourceCaches[e])throw new Error(`Source "${e}" already exists.`);if(!t.type)throw new Error(`The type property must be defined, but only the following properties were given: ${Object.keys(t).join(", ")}.`);var i=0<=["vector","raster","geojson","video","image"].indexOf(t.type);if(!i||!this._validate(de.validateStyle.source,"sources."+e,t,null,r)){this.map&&this.map._collectResourceTiming&&(t.collectResourceTiming=!0);const n=this.sourceCaches[e]=new k(e,t,this.dispatcher);n.style=this,n.setEventedParent(this,()=>({isSourceLoaded:n.loaded(),source:n.serialize(),sourceId:e})),n.onAdd(this.map),this._changed=!0}}removeSource(e){if(this._checkLoaded(),void 0===this.sourceCaches[e])throw new Error("There is no source with this ID");for(const r in this._layers)if(this._layers[r].source===e)return this.fire(new de.ErrorEvent(new Error(`Source "${e}" cannot be removed while layer "${r}" is using it.`)));var t=this.sourceCaches[e];delete this.sourceCaches[e],delete this._updatedSources[e],t.fire(new de.Event("data",{sourceDataType:"metadata",dataType:"source",sourceId:e})),t.setEventedParent(null),t.onRemove(this.map),this._changed=!0}setGeoJSONSourceData(e,t){if(this._checkLoaded(),void 0===this.sourceCaches[e])throw new Error("There is no source with this ID="+e);e=this.sourceCaches[e].getSource();if("geojson"!==e.type)throw new Error(`geojsonSource.type is ${e.type}, which is !== 'geojson`);e.setData(t),this._changed=!0}getSource(e){return this.sourceCaches[e]&&this.sourceCaches[e].getSource()}addLayer(t,r,i={}){this._checkLoaded();var n=t.id;if(this.getLayer(n))this.fire(new de.ErrorEvent(new Error(`Layer "${n}" already exists on this map.`)));else{let e;if("custom"===t.type){if(pt(this,de.validateCustomStyleLayer(t)))return;e=de.createStyleLayer(t)}else{if("source"in t&&"object"==typeof t.source&&(this.addSource(n,t.source),t=de.clone$1(t),t=de.extend(t,{source:n})),this._validate(de.validateStyle.layer,"layers."+n,t,{arrayIndex:-1},i))return;e=de.createStyleLayer(t),this._validateLayer(e),e.setEventedParent(this,{layer:{id:n}})}i=r?this._order.indexOf(r):this._order.length;r&&-1===i?this.fire(new de.ErrorEvent(new Error(`Cannot add layer "${n}" before non-existing layer "${r}".`))):(this._order.splice(i,0,n),this._layerOrderChanged=!0,this._layers[n]=e,this._removedLayers[n]&&e.source&&"custom"!==e.type&&(t=this._removedLayers[n],delete this._removedLayers[n],t.type!==e.type?this._updatedSources[e.source]="clear":(this._updatedSources[e.source]="reload",this.sourceCaches[e.source].pause())),this._updateLayer(e),e.onAdd&&e.onAdd(this.map))}}moveLayer(e,t){var r;this._checkLoaded(),this._changed=!0,this._layers[e]?e!==t&&(r=this._order.indexOf(e),this._order.splice(r,1),r=t?this._order.indexOf(t):this._order.length,t&&-1===r?this.fire(new de.ErrorEvent(new Error(`Cannot move layer "${e}" before non-existing layer "${t}".`))):(this._order.splice(r,0,e),this._layerOrderChanged=!0)):this.fire(new de.ErrorEvent(new Error(`The layer '${e}' does not exist in the map's style and cannot be moved.`)))}removeLayer(e){this._checkLoaded();var t,r=this._layers[e];r?(r.setEventedParent(null),t=this._order.indexOf(e),this._order.splice(t,1),this._layerOrderChanged=!0,this._changed=!0,this._removedLayers[e]=r,delete this._layers[e],this._serializedLayers&&delete this._serializedLayers[e],delete this._updatedLayers[e],delete this._updatedPaintProps[e],r.onRemove&&r.onRemove(this.map)):this.fire(new de.ErrorEvent(new Error(`Cannot remove non-existing layer "${e}".`)))}getLayer(e){return this._layers[e]}getLayersOrder(){return[...this._order]}hasLayer(e){return e in this._layers}setLayerZoomRange(e,t,r){this._checkLoaded();var i=this.getLayer(e);i?i.minzoom===t&&i.maxzoom===r||(null!=t&&(i.minzoom=t),null!=r&&(i.maxzoom=r),this._updateLayer(i)):this.fire(new de.ErrorEvent(new Error(`Cannot set the zoom range of non-existing layer "${e}".`)))}setFilter(e,t,r={}){this._checkLoaded();var i=this.getLayer(e);i?de.deepEqual(i.filter,t)||(null==t?(i.filter=void 0,this._updateLayer(i)):this._validate(de.validateStyle.filter,`layers.${i.id}.filter`,t,null,r)||(i.filter=de.clone$1(t),this._updateLayer(i))):this.fire(new de.ErrorEvent(new Error(`Cannot filter non-existing layer "${e}".`)))}getFilter(e){return de.clone$1(this.getLayer(e).filter)}setLayoutProperty(e,t,r,i={}){this._checkLoaded();var n=this.getLayer(e);n?de.deepEqual(n.getLayoutProperty(t),r)||(n.setLayoutProperty(t,r,i),this._updateLayer(n)):this.fire(new de.ErrorEvent(new Error(`Cannot style non-existing layer "${e}".`)))}getLayoutProperty(e,t){var r=this.getLayer(e);if(r)return r.getLayoutProperty(t);this.fire(new de.ErrorEvent(new Error(`Cannot get style of non-existing layer "${e}".`)))}setPaintProperty(e,t,r,i={}){this._checkLoaded();var n=this.getLayer(e);n?de.deepEqual(n.getPaintProperty(t),r)||(n.setPaintProperty(t,r,i)&&this._updateLayer(n),this._changed=!0,this._updatedPaintProps[e]=!0):this.fire(new de.ErrorEvent(new Error(`Cannot style non-existing layer "${e}".`)))}getPaintProperty(e,t){return this.getLayer(e).getPaintProperty(t)}setFeatureState(e,t){this._checkLoaded();var r=e.source,i=e.sourceLayer,n=this.sourceCaches[r];void 0===n?this.fire(new de.ErrorEvent(new Error(`The source '${r}' does not exist in the map's style.`))):"geojson"===(r=n.getSource().type)&&i?this.fire(new de.ErrorEvent(new Error("GeoJSON sources cannot have a sourceLayer parameter."))):"vector"!==r||i?(void 0===e.id&&this.fire(new de.ErrorEvent(new Error("The feature id parameter must be provided."))),n.setFeatureState(i,e.id,t)):this.fire(new de.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")))}removeFeatureState(e,t){this._checkLoaded();var r,i=e.source,n=this.sourceCaches[i];void 0===n?this.fire(new de.ErrorEvent(new Error(`The source '${i}' does not exist in the map's style.`))):(r="vector"===(i=n.getSource().type)?e.sourceLayer:void 0,"vector"!==i||r?t&&"string"!=typeof e.id&&"number"!=typeof e.id?this.fire(new de.ErrorEvent(new Error("A feature id is required to remove its specific state property."))):n.removeFeatureState(r,e.id,t):this.fire(new de.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types."))))}getFeatureState(e){this._checkLoaded();var t=e.source,r=e.sourceLayer,i=this.sourceCaches[t];if(void 0===i)this.fire(new de.ErrorEvent(new Error(`The source '${t}' does not exist in the map's style.`)));else{if("vector"!==i.getSource().type||r)return void 0===e.id&&this.fire(new de.ErrorEvent(new Error("The feature id parameter must be provided."))),i.getFeatureState(r,e.id);this.fire(new de.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")))}}getTransition(){return de.extend({duration:300,delay:0},this.stylesheet&&this.stylesheet.transition)}serialize(){var e,t,r,i;if(this._loaded)return e=de.mapObject(this.sourceCaches,e=>e.serialize()),t=this._serializeByIds(this._order),r=this.map.getTerrain()||void 0,i=this.stylesheet,de.filterObject({version:i.version,name:i.name,metadata:i.metadata,light:i.light,center:i.center,zoom:i.zoom,bearing:i.bearing,pitch:i.pitch,sprite:i.sprite,glyphs:i.glyphs,transition:i.transition,sources:e,layers:t,terrain:r},e=>void 0!==e)}_updateLayer(e){this._updatedLayers[e.id]=!0,e.source&&!this._updatedSources[e.source]&&"raster"!==this.sourceCaches[e.source].getSource().type&&(this._updatedSources[e.source]="reload",this.sourceCaches[e.source].pause()),this._serializedLayers=null,this._changed=!0}_flattenAndSortRenderedFeatures(r){var i=e=>"fill-extrusion"===this._layers[e].type,n={},o=[];for(let e=this._order.length-1;0<=e;e--){var t=this._order[e];if(i(t)){n[t]=e;for(const u of r){var a=u[t];if(a)for(const h of a)o.push(h)}}}o.sort((e,t)=>t.intersectionZ-e.intersectionZ);var s=[];for(let t=this._order.length-1;0<=t;t--){var e=this._order[t];if(i(e))for(let e=o.length-1;0<=e;e--){var l=o[e].feature;if(n[l.layer.id]<t)break;s.push(l),o.pop()}else for(const d of r){var c=d[e];if(c)for(const p of c)s.push(p.feature)}}return s}queryRenderedFeatures(e,t,r){t&&t.filter&&this._validate(de.validateStyle.filter,"queryRenderedFeatures.filter",t.filter,null,t);var i={};if(t&&t.layers){if(!Array.isArray(t.layers))return this.fire(new de.ErrorEvent(new Error("parameters.layers must be an Array."))),[];for(const s of t.layers){var n=this._layers[s];if(!n)return this.fire(new de.ErrorEvent(new Error(`The layer '${s}' does not exist in the map's style and cannot be queried for features.`))),[];i[n.source]=!0}}var o=[],a=(t.availableImages=this._availableImages,this._serializedAllLayers());for(const l in this.sourceCaches)t.layers&&!i[l]||o.push(re(this.sourceCaches[l],this._layers,a,e,t,r));return this.placement&&o.push(function(r,e,i,t,n,o,a){var s={},l=o.queryRenderedSymbols(t),c=[];for(const p of Object.keys(l).map(Number))c.push(a[p]);c.sort(ie);for(const f of c){var u=f.featureIndex.lookupSymbolFeatures(l[f.bucketInstanceId],e,f.bucketIndex,f.sourceLayerIndex,n.filter,n.layers,n.availableImages,r);for(const m in u){var h=s[m]=s[m]||[],d=u[m];d.sort((e,t)=>{var r,i=f.featureSortOrder;return i?(r=i.indexOf(e.featureIndex),i.indexOf(t.featureIndex)-r):t.featureIndex-e.featureIndex});for(const g of d)h.push(g)}}for(const y in s)s[y].forEach(e=>{var e=e.feature,t=r[y],t=i[t.source].getFeatureState(e.layer["source-layer"],e.id);e.source=e.layer.source,e.layer["source-layer"]&&(e.sourceLayer=e.layer["source-layer"]),e.state=t});return s}(this._layers,a,this.sourceCaches,e,t,this.placement.collisionIndex,this.placement.retainedQueryData)),this._flattenAndSortRenderedFeatures(o)}querySourceFeatures(e,t){t&&t.filter&&this._validate(de.validateStyle.filter,"querySourceFeatures.filter",t.filter,null,t);e=this.sourceCaches[e];if(e){var r=e,i=t,n=r.getRenderableIds().map(e=>r.getTileByID(e)),o=[],a={};for(let e=0;e<n.length;e++){var s=n[e],l=s.tileID.canonical.key;a[l]||(a[l]=!0,s.querySourceFeatures(o,i))}return o}return[]}getLight(){return this.light.getLight()}setLight(e,t={}){this._checkLoaded();var r,i=this.light.getLight();let n=!1;for(const o in e)if(!de.deepEqual(e[o],i[o])){n=!0;break}n&&(r={now:M.now(),transition:de.extend({duration:300,delay:0},this.stylesheet.transition)},this.light.setLight(e,t),this.light.updateTransitions(r))}_validate(e,t,r,i,n={}){return(!n||!1!==n.validate)&&pt(this,e.call(de.validateStyle,de.extend({key:t,style:this.serialize(),value:r,styleSpec:de.v8Spec},i)))}_remove(e=!0){this._frameRequest&&(this._frameRequest.abort(),this._frameRequest=null),this._loadStyleRequest&&(this._loadStyleRequest.abort(),this._loadStyleRequest=null),this._spriteRequest&&(this._spriteRequest.abort(),this._spriteRequest=null),c().off(be,this._rtlPluginLoaded);for(const r in this._layers)this._layers[r].setEventedParent(null);for(const i in this.sourceCaches){var t=this.sourceCaches[i];t.setEventedParent(null),t.onRemove(this.map)}this.imageManager.setEventedParent(null),this.setEventedParent(null),e&&this.dispatcher.broadcast("RM",void 0),this.dispatcher.remove(e)}_clearSource(e){this.sourceCaches[e].clearTiles()}_reloadSource(e){this.sourceCaches[e].resume(),this.sourceCaches[e].reload()}_updateSources(e){for(const t in this.sourceCaches)this.sourceCaches[t].update(e,this.map.terrain)}_generateCollisionBoxes(){for(const e in this.sourceCaches)this._reloadSource(e)}_updatePlacement(e,t,r,i,n=!1){let o=!1,a=!1;var s={};for(const u of this._order){var l=this._layers[u];if("symbol"===l.type){if(!s[l.source]){const h=this.sourceCaches[l.source];s[l.source]=h.getRenderableIds(!0).map(e=>h.getTileByID(e)).sort((e,t)=>t.tileID.overscaledZ-e.tileID.overscaledZ||(e.tileID.isLessThan(t.tileID)?-1:1))}l=this.crossTileSymbolIndex.addLayer(l,s[l.source],e.center.lng);o=o||l}}if(this.crossTileSymbolIndex.pruneUnusedLayers(this._order),((n=n||this._layerOrderChanged||0===r)||!this.pauseablePlacement||this.pauseablePlacement.isDone()&&!this.placement.stillRecent(M.now(),e.zoom))&&(this.pauseablePlacement=new lt(e,this.map.terrain,this._order,n,t,r,i,this.placement),this._layerOrderChanged=!1),this.pauseablePlacement.isDone()?this.placement.setStale():(this.pauseablePlacement.continuePlacement(this._order,this._layers,s),this.pauseablePlacement.isDone()&&(this.placement=this.pauseablePlacement.commit(M.now()),a=!0),o&&this.pauseablePlacement.placement.setStale()),a||o)for(const d of this._order){var c=this._layers[d];"symbol"===c.type&&this.placement.updateLayerOpacities(c,s[c.source])}return!this.pauseablePlacement.isDone()||this.placement.hasTransitions(M.now())}_releaseSymbolFadeTiles(){for(const e in this.sourceCaches)this.sourceCaches[e].releaseSymbolFadeTiles()}getImages(e,r){return de.__awaiter(this,void 0,void 0,function*(){var e=yield this.imageManager.getImages(r.icons),t=(this._updateTilesForChangedImages(),this.sourceCaches[r.source]);return t&&t.setDependencies(r.tileID.key,r.type,r.icons),e})}getGlyphs(e,r){return de.__awaiter(this,void 0,void 0,function*(){var e=yield this.glyphManager.getGlyphs(r.stacks),t=this.sourceCaches[r.source];return t&&t.setDependencies(r.tileID.key,r.type,[""]),e})}getGlyphsUrl(){return this.stylesheet.glyphs||null}setGlyphs(e,t={}){this._checkLoaded(),e&&this._validate(de.validateStyle.glyphs,"glyphs",e,null,t)||(this._glyphsDidChange=!0,this.stylesheet.glyphs=e,this.glyphManager.entries={},this.glyphManager.setURL(e))}addSprite(e,t,r={},i){this._checkLoaded();e=[{id:e,url:t}],t=[...U(this.stylesheet.sprite),...e];this._validate(de.validateStyle.sprite,"sprite",t,null,r)||(this.stylesheet.sprite=t,this._loadSprite(e,!0,i))}removeSprite(t){this._checkLoaded();var e=U(this.stylesheet.sprite);if(e.find(e=>e.id===t)){if(this._spritesImagesIds[t])for(const r of this._spritesImagesIds[t])this.imageManager.removeImage(r),this._changedImages[r]=!0;e.splice(e.findIndex(e=>e.id===t),1),this.stylesheet.sprite=0<e.length?e:void 0,delete this._spritesImagesIds[t],this._availableImages=this.imageManager.listImages(),this._changed=!0,this.dispatcher.broadcast("SI",this._availableImages),this.fire(new de.Event("data",{dataType:"style"}))}else this.fire(new de.ErrorEvent(new Error(`Sprite "${t}" doesn't exists on this map.`)))}getSprite(){return U(this.stylesheet.sprite)}setSprite(e,t={},r){this._checkLoaded(),e&&this._validate(de.validateStyle.sprite,"sprite",e,null,t)||((this.stylesheet.sprite=e)?this._loadSprite(e,!0,r):(this._unloadSprite(),r&&r(null)))}}var gt=de.createLayout([{name:"a_pos",type:"Int16",components:2}]),t="attribute vec3 a_pos3d;uniform mat4 u_matrix;uniform float u_ele_delta;varying vec2 v_texture_pos;varying float v_depth;void main() {float extent=8192.0;float ele_delta=a_pos3d.z==1.0 ? u_ele_delta : 0.0;v_texture_pos=a_pos3d.xy/extent;gl_Position=u_matrix*vec4(a_pos3d.xy,get_elevation(a_pos3d.xy)-ele_delta,1.0);v_depth=gl_Position.z/gl_Position.w;}";const g={prelude:o("#ifdef GL_ES\nprecision mediump float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif\n","#ifdef GL_ES\nprecision highp float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec2 unpack_opacity(const float packedOpacity) {int intOpacity=int(packedOpacity)/2;return vec2(float(intOpacity)/127.0,mod(packedOpacity,2.0));}vec4 decode_color(const vec2 encodedColor) {return vec4(unpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}float unpack_mix_vec2(const vec2 packedValue,const float t) {return mix(packedValue[0],packedValue[1],t);}vec4 unpack_mix_color(const vec4 packedColors,const float t) {vec4 minColor=decode_color(vec2(packedColors[0],packedColors[1]));vec4 maxColor=decode_color(vec2(packedColors[2],packedColors[3]));return mix(minColor,maxColor,t);}vec2 get_pattern_pos(const vec2 pixel_coord_upper,const vec2 pixel_coord_lower,const vec2 pattern_size,const float tile_units_to_pixels,const vec2 pos) {vec2 offset=mod(mod(mod(pixel_coord_upper,pattern_size)*256.0,pattern_size)*256.0+pixel_coord_lower,pattern_size);return (tile_units_to_pixels*pos+offset)/pattern_size;}\n#ifdef TERRAIN3D\nuniform sampler2D u_terrain;uniform float u_terrain_dim;uniform mat4 u_terrain_matrix;uniform vec4 u_terrain_unpack;uniform float u_terrain_exaggeration;uniform highp sampler2D u_depth;\n#endif\nconst highp vec4 bitSh=vec4(256.*256.*256.,256.*256.,256.,1.);const highp vec4 bitShifts=vec4(1.)/bitSh;highp float unpack(highp vec4 color) {return dot(color,bitShifts);}highp float depthOpacity(vec3 frag) {\n#ifdef TERRAIN3D\nhighp float d=unpack(texture2D(u_depth,frag.xy*0.5+0.5))+0.0001-frag.z;return 1.0-max(0.0,min(1.0,-d*500.0));\n#else\nreturn 1.0;\n#endif\n}float calculate_visibility(vec4 pos) {\n#ifdef TERRAIN3D\nvec3 frag=pos.xyz/pos.w;highp float d=depthOpacity(frag);if (d > 0.95) return 1.0;return (d+depthOpacity(frag+vec3(0.0,0.01,0.0)))/2.0;\n#else\nreturn 1.0;\n#endif\n}float ele(vec2 pos) {\n#ifdef TERRAIN3D\nvec4 rgb=(texture2D(u_terrain,pos)*255.0)*u_terrain_unpack;return rgb.r+rgb.g+rgb.b-u_terrain_unpack.a;\n#else\nreturn 0.0;\n#endif\n}float get_elevation(vec2 pos) {\n#ifdef TERRAIN3D\nvec2 coord=(u_terrain_matrix*vec4(pos,0.0,1.0)).xy*u_terrain_dim+1.0;vec2 f=fract(coord);vec2 c=(floor(coord)+0.5)/(u_terrain_dim+2.0);float d=1.0/(u_terrain_dim+2.0);float tl=ele(c);float tr=ele(c+vec2(d,0.0));float bl=ele(c+vec2(0.0,d));float br=ele(c+vec2(d,d));float elevation=mix(mix(tl,tr,f.x),mix(bl,br,f.x),f.y);return elevation*u_terrain_exaggeration;\n#else\nreturn 0.0;\n#endif\n}"),background:o("uniform vec4 u_color;uniform float u_opacity;void main() {gl_FragColor=u_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),backgroundPattern:o("uniform vec2 u_pattern_tl_a;uniform vec2 u_pattern_br_a;uniform vec2 u_pattern_tl_b;uniform vec2 u_pattern_br_b;uniform vec2 u_texsize;uniform float u_mix;uniform float u_opacity;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(u_pattern_tl_a/u_texsize,u_pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(u_pattern_tl_b/u_texsize,u_pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_mix)*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_pattern_size_a;uniform vec2 u_pattern_size_b;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_scale_a;uniform float u_scale_b;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_a*u_pattern_size_a,u_tile_units_to_pixels,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_b*u_pattern_size_b,u_tile_units_to_pixels,a_pos);}"),circle:o("varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=v_data.xy;float extrude_length=length(extrude);lowp float antialiasblur=v_data.z;float antialiased_blur=-max(blur,antialiasblur);float opacity_t=smoothstep(0.0,antialiased_blur,extrude_length-1.0);float color_t=stroke_width < 0.01 ? 0.0 : smoothstep(antialiased_blur,0.0,extrude_length-radius/(radius+stroke_width));gl_FragColor=v_visibility*opacity_t*mix(color*opacity,stroke_color*stroke_opacity,color_t);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform bool u_scale_with_map;uniform bool u_pitch_with_map;uniform vec2 u_extrude_scale;uniform lowp float u_device_pixel_ratio;uniform highp float u_camera_to_center_distance;attribute vec2 a_pos;varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main(void) {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=vec2(mod(a_pos,2.0)*2.0-1.0);vec2 circle_center=floor(a_pos*0.5);float ele=get_elevation(circle_center);v_visibility=calculate_visibility(u_matrix*vec4(circle_center,ele,1.0));if (u_pitch_with_map) {vec2 corner_position=circle_center;if (u_scale_with_map) {corner_position+=extrude*(radius+stroke_width)*u_extrude_scale;} else {vec4 projected_center=u_matrix*vec4(circle_center,0,1);corner_position+=extrude*(radius+stroke_width)*u_extrude_scale*(projected_center.w/u_camera_to_center_distance);}gl_Position=u_matrix*vec4(corner_position,ele,1);} else {gl_Position=u_matrix*vec4(circle_center,ele,1);if (u_scale_with_map) {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*u_camera_to_center_distance;} else {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*gl_Position.w;}}lowp float antialiasblur=1.0/u_device_pixel_ratio/(radius+stroke_width);v_data=vec3(extrude.x,extrude.y,antialiasblur);}"),clippingMask:o("void main() {gl_FragColor=vec4(1.0);}","attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),heatmap:o("uniform highp float u_intensity;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#define GAUSS_COEF 0.3989422804014327\nvoid main() {\n#pragma mapbox: initialize highp float weight\nfloat d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,1.0,1.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform float u_extrude_scale;uniform float u_opacity;uniform float u_intensity;attribute vec2 a_pos;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#pragma mapbox: define mediump float radius\nconst highp float ZERO=1.0/255.0/16.0;\n#define GAUSS_COEF 0.3989422804014327\nvoid main(void) {\n#pragma mapbox: initialize highp float weight\n#pragma mapbox: initialize mediump float radius\nvec2 unscaled_extrude=vec2(mod(a_pos,2.0)*2.0-1.0);float S=sqrt(-2.0*log(ZERO/weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=S*unscaled_extrude;vec2 extrude=v_extrude*radius*u_extrude_scale;vec4 pos=vec4(floor(a_pos*0.5)+extrude,0,1);gl_Position=u_matrix*pos;}"),heatmapTexture:o("uniform sampler2D u_image;uniform sampler2D u_color_ramp;uniform float u_opacity;varying vec2 v_pos;void main() {float t=texture2D(u_image,v_pos).r;vec4 color=texture2D(u_color_ramp,vec2(t,0.5));gl_FragColor=color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(0.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_world;attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos*u_world,0,1);v_pos.x=a_pos.x;v_pos.y=1.0-a_pos.y;}"),collisionBox:o("varying float v_placed;varying float v_notUsed;void main() {float alpha=0.5;gl_FragColor=vec4(1.0,0.0,0.0,1.0)*alpha;if (v_placed > 0.5) {gl_FragColor=vec4(0.0,0.0,1.0,0.5)*alpha;}if (v_notUsed > 0.5) {gl_FragColor*=.1;}}","attribute vec2 a_pos;attribute vec2 a_anchor_pos;attribute vec2 a_extrude;attribute vec2 a_placed;attribute vec2 a_shift;uniform mat4 u_matrix;uniform vec2 u_extrude_scale;uniform float u_camera_to_center_distance;varying float v_placed;varying float v_notUsed;void main() {vec4 projectedPoint=u_matrix*vec4(a_anchor_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);gl_Position=u_matrix*vec4(a_pos,get_elevation(a_pos),1.0);gl_Position.xy+=(a_extrude+a_shift)*u_extrude_scale*gl_Position.w*collision_perspective_ratio;v_placed=a_placed.x;v_notUsed=a_placed.y;}"),collisionCircle:o("varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;void main() {float alpha=0.5*min(v_perspective_ratio,1.0);float stroke_radius=0.9*max(v_perspective_ratio,1.0);float distance_to_center=length(v_extrude);float distance_to_edge=abs(distance_to_center-v_radius);float opacity_t=smoothstep(-stroke_radius,0.0,-distance_to_edge);vec4 color=mix(vec4(0.0,0.0,1.0,0.5),vec4(1.0,0.0,0.0,1.0),v_collision);gl_FragColor=color*alpha*opacity_t;}","attribute vec2 a_pos;attribute float a_radius;attribute vec2 a_flags;uniform mat4 u_matrix;uniform mat4 u_inv_matrix;uniform vec2 u_viewport_size;uniform float u_camera_to_center_distance;varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;vec3 toTilePosition(vec2 screenPos) {vec4 rayStart=u_inv_matrix*vec4(screenPos,-1.0,1.0);vec4 rayEnd  =u_inv_matrix*vec4(screenPos, 1.0,1.0);rayStart.xyz/=rayStart.w;rayEnd.xyz  /=rayEnd.w;highp float t=(0.0-rayStart.z)/(rayEnd.z-rayStart.z);return mix(rayStart.xyz,rayEnd.xyz,t);}void main() {vec2 quadCenterPos=a_pos;float radius=a_radius;float collision=a_flags.x;float vertexIdx=a_flags.y;vec2 quadVertexOffset=vec2(mix(-1.0,1.0,float(vertexIdx >=2.0)),mix(-1.0,1.0,float(vertexIdx >=1.0 && vertexIdx <=2.0)));vec2 quadVertexExtent=quadVertexOffset*radius;vec3 tilePos=toTilePosition(quadCenterPos);vec4 clipPos=u_matrix*vec4(tilePos,1.0);highp float camera_to_anchor_distance=clipPos.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);float padding_factor=1.2;v_radius=radius;v_extrude=quadVertexExtent*padding_factor;v_perspective_ratio=collision_perspective_ratio;v_collision=collision;gl_Position=vec4(clipPos.xyz/clipPos.w,1.0)+vec4(quadVertexExtent*padding_factor/u_viewport_size*2.0,0.0,0.0);}"),debug:o("uniform highp vec4 u_color;uniform sampler2D u_overlay;varying vec2 v_uv;void main() {vec4 overlay_color=texture2D(u_overlay,v_uv);gl_FragColor=mix(u_color,overlay_color,overlay_color.a);}","attribute vec2 a_pos;varying vec2 v_uv;uniform mat4 u_matrix;uniform float u_overlay_scale;void main() {v_uv=a_pos/8192.0;gl_Position=u_matrix*vec4(a_pos*u_overlay_scale,get_elevation(a_pos),1);}"),fill:o("#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_FragColor=color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","attribute vec2 a_pos;uniform mat4 u_matrix;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);}"),fillOutline:o("varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=outline_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","attribute vec2 a_pos;uniform mat4 u_matrix;uniform vec2 u_world;varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"),fillOutlinePattern:o("uniform vec2 u_texsize;uniform sampler2D u_image;uniform float u_fade;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);float dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=mix(color1,color2,u_fade)*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_world;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;gl_Position=u_matrix*vec4(a_pos,0,1);vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,a_pos);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"),fillPattern:o("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_fade)*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileZoomRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileZoomRatio,a_pos);}"),fillExtrusion:o("varying vec4 v_color;void main() {gl_FragColor=v_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;uniform float u_vertical_gradient;uniform lowp float u_opacity;attribute vec2 a_pos;attribute vec4 a_normal_ed;\n#ifdef TERRAIN3D\nattribute vec2 a_centroid;\n#endif\nvarying vec4 v_color;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define highp vec4 color\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize highp vec4 color\nvec3 normal=a_normal_ed.xyz;\n#ifdef TERRAIN3D\nfloat height_terrain3d_offset=get_elevation(a_centroid);float base_terrain3d_offset=height_terrain3d_offset-(base > 0.0 ? 0.0 : 10.0);\n#else\nfloat height_terrain3d_offset=0.0;float base_terrain3d_offset=0.0;\n#endif\nbase=max(0.0,base)+base_terrain3d_offset;height=max(0.0,height)+height_terrain3d_offset;float t=mod(normal.x,2.0);gl_Position=u_matrix*vec4(a_pos,t > 0.0 ? height : base,1);float colorvalue=color.r*0.2126+color.g*0.7152+color.b*0.0722;v_color=vec4(0.0,0.0,0.0,1.0);vec4 ambientlight=vec4(0.03,0.03,0.03,1.0);color+=ambientlight;float directional=clamp(dot(normal/16384.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_color.r+=clamp(color.r*directional*u_lightcolor.r,mix(0.0,0.3,1.0-u_lightcolor.r),1.0);v_color.g+=clamp(color.g*directional*u_lightcolor.g,mix(0.0,0.3,1.0-u_lightcolor.g),1.0);v_color.b+=clamp(color.b*directional*u_lightcolor.b,mix(0.0,0.3,1.0-u_lightcolor.b),1.0);v_color*=u_opacity;}"),fillExtrusionPattern:o("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 mixedColor=mix(color1,color2,u_fade);gl_FragColor=mixedColor*v_lighting;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_height_factor;uniform vec3 u_scale;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;attribute vec2 a_pos;attribute vec4 a_normal_ed;\n#ifdef TERRAIN3D\nattribute vec2 a_centroid;\n#endif\nvarying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec3 normal=a_normal_ed.xyz;float edgedistance=a_normal_ed.w;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;\n#ifdef TERRAIN3D\nfloat height_terrain3d_offset=get_elevation(a_centroid);float base_terrain3d_offset=height_terrain3d_offset-(base > 0.0 ? 0.0 : 10.0);\n#else\nfloat height_terrain3d_offset=0.0;float base_terrain3d_offset=0.0;\n#endif\nbase=max(0.0,base)+base_terrain3d_offset;height=max(0.0,height)+height_terrain3d_offset;float t=mod(normal.x,2.0);float z=t > 0.0 ? height : base;gl_Position=u_matrix*vec4(a_pos,z,1);vec2 pos=normal.x==1.0 && normal.y==0.0 && normal.z==16384.0\n? a_pos\n: vec2(edgedistance,z*u_height_factor);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,pos);v_lighting=vec4(0.0,0.0,0.0,1.0);float directional=clamp(dot(normal/16383.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((0.5+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_lighting.rgb+=clamp(directional*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_lighting*=u_opacity;}"),hillshadePrepare:o("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_dimension;uniform float u_zoom;uniform vec4 u_unpack;float getElevation(vec2 coord,float bias) {vec4 data=texture2D(u_image,coord)*255.0;data.a=-1.0;return dot(data,u_unpack)/4.0;}void main() {vec2 epsilon=1.0/u_dimension;float a=getElevation(v_pos+vec2(-epsilon.x,-epsilon.y),0.0);float b=getElevation(v_pos+vec2(0,-epsilon.y),0.0);float c=getElevation(v_pos+vec2(epsilon.x,-epsilon.y),0.0);float d=getElevation(v_pos+vec2(-epsilon.x,0),0.0);float e=getElevation(v_pos,0.0);float f=getElevation(v_pos+vec2(epsilon.x,0),0.0);float g=getElevation(v_pos+vec2(-epsilon.x,epsilon.y),0.0);float h=getElevation(v_pos+vec2(0,epsilon.y),0.0);float i=getElevation(v_pos+vec2(epsilon.x,epsilon.y),0.0);float exaggerationFactor=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;float exaggeration=u_zoom < 15.0 ? (u_zoom-15.0)*exaggerationFactor : 0.0;vec2 deriv=vec2((c+f+f+i)-(a+d+d+g),(g+h+h+i)-(a+b+b+c))/pow(2.0,exaggeration+(19.2562-u_zoom));gl_FragColor=clamp(vec4(deriv.x/2.0+0.5,deriv.y/2.0+0.5,1.0,1.0),0.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_dimension;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);highp vec2 epsilon=1.0/u_dimension;float scale=(u_dimension.x-2.0)/u_dimension.x;v_pos=(a_texture_pos/8192.0)*scale+epsilon;}"),hillshade:o("uniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_latrange;uniform vec2 u_light;uniform vec4 u_shadow;uniform vec4 u_highlight;uniform vec4 u_accent;\n#define PI 3.141592653589793\nvoid main() {vec4 pixel=texture2D(u_image,v_pos);vec2 deriv=((pixel.rg*2.0)-1.0);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_pos.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*u_accent*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=accent_color*(1.0-shade_color.a)+shade_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=a_texture_pos/8192.0;}"),line:o("uniform lowp float u_device_pixel_ratio;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform vec2 u_units_to_pixels;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp float v_linesofar;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;v_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*2.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_width2=vec2(outset,inset);}"),lineGradient:o("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);vec4 color=texture2D(u_image,v_uv);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;attribute float a_uv_x;attribute float a_split_index;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_units_to_pixels;uniform float u_image_height;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;highp float texel_height=1.0/u_image_height;highp float half_texel_height=0.5*texel_height;v_uv=vec2(a_uv_x,a_split_index*texel_height-half_texel_height);vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_width2=vec2(outset,inset);}"),linePattern:o("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform lowp float u_device_pixel_ratio;uniform vec2 u_texsize;uniform float u_fade;uniform mediump vec3 u_scale;uniform sampler2D u_image;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;vec2 pattern_size_a=vec2(display_size_a.x*fromScale/tileZoomRatio,display_size_a.y);vec2 pattern_size_b=vec2(display_size_b.x*toScale/tileZoomRatio,display_size_b.y);float aspect_a=display_size_a.y/v_width;float aspect_b=display_size_b.y/v_width;float dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float x_a=mod(v_linesofar/pattern_size_a.x*aspect_a,1.0);float x_b=mod(v_linesofar/pattern_size_b.x*aspect_b,1.0);float y=0.5*v_normal.y+0.5;vec2 texel_size=1.0/u_texsize;vec2 pos_a=mix(pattern_tl_a*texel_size-texel_size,pattern_br_a*texel_size+texel_size,vec2(x_a,y));vec2 pos_b=mix(pattern_tl_b*texel_size-texel_size,pattern_br_b*texel_size+texel_size,vec2(x_b,y));vec4 color=mix(texture2D(u_image,pos_a),texture2D(u_image,pos_b),u_fade);gl_FragColor=color*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform vec2 u_units_to_pixels;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_linesofar=a_linesofar;v_width2=vec2(outset,inset);v_width=floorwidth;}"),lineSDF:o("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;uniform float u_sdfgamma;uniform float u_mix;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float sdfdist_a=texture2D(u_image,v_tex_a).a;float sdfdist_b=texture2D(u_image,v_tex_b).a;float sdfdist=mix(sdfdist_a,sdfdist_b,u_mix);alpha*=smoothstep(0.5-u_sdfgamma/floorwidth,0.5+u_sdfgamma/floorwidth,sdfdist);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_patternscale_a;uniform float u_tex_y_a;uniform vec2 u_patternscale_b;uniform float u_tex_y_b;uniform vec2 u_units_to_pixels;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_tex_a=vec2(a_linesofar*u_patternscale_a.x/floorwidth,normal.y*u_patternscale_a.y+u_tex_y_a);v_tex_b=vec2(a_linesofar*u_patternscale_b.x/floorwidth,normal.y*u_patternscale_b.y+u_tex_y_b);v_width2=vec2(outset,inset);}"),raster:o("uniform float u_fade_t;uniform float u_opacity;uniform sampler2D u_image0;uniform sampler2D u_image1;varying vec2 v_pos0;varying vec2 v_pos1;uniform float u_brightness_low;uniform float u_brightness_high;uniform float u_saturation_factor;uniform float u_contrast_factor;uniform vec3 u_spin_weights;void main() {vec4 color0=texture2D(u_image0,v_pos0);vec4 color1=texture2D(u_image1,v_pos1);if (color0.a > 0.0) {color0.rgb=color0.rgb/color0.a;}if (color1.a > 0.0) {color1.rgb=color1.rgb/color1.a;}vec4 color=mix(color0,color1,u_fade_t);color.a*=u_opacity;vec3 rgb=color.rgb;rgb=vec3(dot(rgb,u_spin_weights.xyz),dot(rgb,u_spin_weights.zxy),dot(rgb,u_spin_weights.yzx));float average=(color.r+color.g+color.b)/3.0;rgb+=(average-rgb)*u_saturation_factor;rgb=(rgb-0.5)*u_contrast_factor+0.5;vec3 u_high_vec=vec3(u_brightness_low,u_brightness_low,u_brightness_low);vec3 u_low_vec=vec3(u_brightness_high,u_brightness_high,u_brightness_high);gl_FragColor=vec4(mix(u_high_vec,u_low_vec,rgb)*color.a,color.a);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_tl_parent;uniform float u_scale_parent;uniform float u_buffer_scale;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;varying vec2 v_pos1;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos0=(((a_texture_pos/8192.0)-0.5)/u_buffer_scale )+0.5;v_pos1=(v_pos0*u_scale_parent)+u_tl_parent;}"),symbolIcon:o("uniform sampler2D u_texture;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nlowp float alpha=opacity*v_fade_opacity;gl_FragColor=texture2D(u_texture,v_tex)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform highp float u_camera_to_center_distance;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform float u_fade_change;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform vec2 u_texsize;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;vec2 a_minFontScale=a_pixeloffset.zw/256.0;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*max(a_minFontScale,fontScale)+a_pxoffset/16.0),z,1.0);v_tex=a_tex/u_texsize;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float visibility=calculate_visibility(projectedPoint);v_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));}"),symbolSDF:o("#define SDF_PX 8.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_text;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat EDGE_GAMMA=0.105/u_device_pixel_ratio;vec2 tex=v_data0.xy;float gamma_scale=v_data1.x;float size=v_data1.y;float fade_opacity=v_data1[2];float fontScale=u_is_text ? size/24.0 : size;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float inner_edge=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);inner_edge=inner_edge+gamma*gamma_scale;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(inner_edge-gamma_scaled,inner_edge+gamma_scaled,dist);if (u_is_halo) {lowp float halo_edge=(6.0-halo_width/fontScale)/SDF_PX;alpha=min(smoothstep(halo_edge-gamma_scaled,halo_edge+gamma_scaled,dist),1.0-alpha);}gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale+a_pxoffset),z,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float visibility=calculate_visibility(projectedPoint);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));v_data0=a_tex/u_texsize;v_data1=vec3(gamma_scale,size,interpolated_fade_opacity);}"),symbolTextAndIcon:o("#define SDF_PX 8.0\n#define SDF 1.0\n#define ICON 0.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform sampler2D u_texture_icon;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat fade_opacity=v_data1[2];if (v_data1.w==ICON) {vec2 tex_icon=v_data0.zw;lowp float alpha=opacity*fade_opacity;gl_FragColor=texture2D(u_texture_icon,tex_icon)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nreturn;}vec2 tex=v_data0.xy;float EDGE_GAMMA=0.105/u_device_pixel_ratio;float gamma_scale=v_data1.x;float size=v_data1.y;float fontScale=size/24.0;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec2 u_texsize_icon;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);float is_sdf=a_size[0]-2.0*a_size_min;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=size/24.0;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale),z,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float visibility=calculate_visibility(projectedPoint);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));v_data0.xy=a_tex/u_texsize;v_data0.zw=a_tex/u_texsize_icon;v_data1=vec4(gamma_scale,size,interpolated_fade_opacity,is_sdf);}"),terrain:o("uniform sampler2D u_texture;varying vec2 v_texture_pos;void main() {gl_FragColor=texture2D(u_texture,v_texture_pos);}",t),terrainDepth:o("varying float v_depth;const highp vec4 bitSh=vec4(256.*256.*256.,256.*256.,256.,1.);const highp vec4 bitMsk=vec4(0.,vec3(1./256.0));highp vec4 pack(highp float value) {highp vec4 comp=fract(value*bitSh);comp-=comp.xxyz*bitMsk;return comp;}void main() {gl_FragColor=pack(v_depth);}",t),terrainCoords:o("precision mediump float;uniform sampler2D u_texture;uniform float u_terrain_coords_id;varying vec2 v_texture_pos;void main() {vec4 rgba=texture2D(u_texture,v_texture_pos);gl_FragColor=vec4(rgba.r,rgba.g,rgba.b,u_terrain_coords_id);}",t)};function o(e,t){var r=/#pragma mapbox: ([\w]+) ([\w]+) ([\w]+) ([\w]+)/g,i=t.match(/attribute ([\w]+) ([\w]+)/g),n=e.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g),o=t.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g),o=o?o.concat(n):n;const s={};return{fragmentSource:e=e.replace(r,(e,t,r,i,n)=>(s[n]=!0,"define"===t?`
#ifndef HAS_UNIFORM_u_${n}
varying ${r} ${i} ${n};
#else
uniform ${r} ${i} u_${n};
#endif
`:`
#ifdef HAS_UNIFORM_u_${n}
    ${r} ${i} ${n} = u_${n};
#endif
`)),vertexSource:t=t.replace(r,(e,t,r,i,n)=>{var o="float"===i?"vec2":"vec4",a=n.match(/color/)?"color":o;return s[n]?"define"===t?`
#ifndef HAS_UNIFORM_u_${n}
uniform lowp float u_${n}_t;
attribute ${r} ${o} a_${n};
varying ${r} ${i} ${n};
#else
uniform ${r} ${i} u_${n};
#endif
`:"vec4"==a?`
#ifndef HAS_UNIFORM_u_${n}
    ${n} = a_${n};
#else
    ${r} ${i} ${n} = u_${n};
#endif
`:`
#ifndef HAS_UNIFORM_u_${n}
    ${n} = unpack_mix_${a}(a_${n}, u_${n}_t);
#else
    ${r} ${i} ${n} = u_${n};
#endif
`:"define"===t?`
#ifndef HAS_UNIFORM_u_${n}
uniform lowp float u_${n}_t;
attribute ${r} ${o} a_${n};
#else
uniform ${r} ${i} u_${n};
#endif
`:"vec4"==a?`
#ifndef HAS_UNIFORM_u_${n}
    ${r} ${i} ${n} = a_${n};
#else
    ${r} ${i} ${n} = u_${n};
#endif
`:`
#ifndef HAS_UNIFORM_u_${n}
    ${r} ${i} ${n} = unpack_mix_${a}(a_${n}, u_${n}_t);
#else
    ${r} ${i} ${n} = u_${n};
#endif
`}),staticAttributes:i,staticUniforms:o}}class yt{constructor(){this.boundProgram=null,this.boundLayoutVertexBuffer=null,this.boundPaintVertexBuffers=[],this.boundIndexBuffer=null,this.boundVertexOffset=null,this.boundDynamicVertexBuffer=null,this.vao=null}bind(e,t,r,i,n,o,a,s,l){this.context=e;let c=this.boundPaintVertexBuffers.length!==i.length;for(let e=0;!c&&e<i.length;e++)this.boundPaintVertexBuffers[e]!==i[e]&&(c=!0);!this.vao||this.boundProgram!==t||this.boundLayoutVertexBuffer!==r||c||this.boundIndexBuffer!==n||this.boundVertexOffset!==o||this.boundDynamicVertexBuffer!==a||this.boundDynamicVertexBuffer2!==s||this.boundDynamicVertexBuffer3!==l?this.freshBind(t,r,i,n,o,a,s,l):(e.bindVertexArray.set(this.vao),a&&a.bind(),n&&n.dynamicDraw&&n.bind(),s&&s.bind(),l&&l.bind())}freshBind(e,t,r,i,n,o,a,s){var l=e.numAttributes,c=this.context,u=c.gl;this.vao&&this.destroy(),this.vao=c.createVertexArray(),c.bindVertexArray.set(this.vao),this.boundProgram=e,this.boundLayoutVertexBuffer=t,this.boundPaintVertexBuffers=r,this.boundIndexBuffer=i,this.boundVertexOffset=n,this.boundDynamicVertexBuffer=o,this.boundDynamicVertexBuffer2=a,this.boundDynamicVertexBuffer3=s,t.enableAttributes(u,e);for(const h of r)h.enableAttributes(u,e);o&&o.enableAttributes(u,e),a&&a.enableAttributes(u,e),s&&s.enableAttributes(u,e),t.bind(),t.setVertexAttribPointers(u,e,n);for(const d of r)d.bind(),d.setVertexAttribPointers(u,e,n);o&&(o.bind(),o.setVertexAttribPointers(u,e,n)),i&&i.bind(),a&&(a.bind(),a.setVertexAttribPointers(u,e,n)),s&&(s.bind(),s.setVertexAttribPointers(u,e,n)),c.currentNumAttributes=l}destroy(){this.vao&&(this.context.deleteVertexArray(this.vao),this.vao=null)}}function vt(t){var r,i=[];for(let e=0;e<t.length;e++)null!==t[e]&&(r=t[e].split(" "),i.push(r.pop()));return i}class _t{constructor(e,t,r,i,n,o){var a=e.gl,s=(this.program=a.createProgram(),vt(t.staticAttributes)),l=r?r.getBinderAttributes():[],c=s.concat(l),s=g.prelude.staticUniforms?vt(g.prelude.staticUniforms):[],l=t.staticUniforms?vt(t.staticUniforms):[],u=r?r.getBinderUniforms():[],h=[];for(const m of s.concat(l).concat(u))h.indexOf(m)<0&&h.push(m);s=r?r.defines():[],n&&s.push("#define OVERDRAW_INSPECTOR;"),o&&s.push("#define TERRAIN3D;"),l=s.concat(g.prelude.fragmentSource,t.fragmentSource).join("\n"),u=s.concat(g.prelude.vertexSource,t.vertexSource).join("\n"),n=a.createShader(a.FRAGMENT_SHADER);if(a.isContextLost())this.failedToCreate=!0;else{if(a.shaderSource(n,l),a.compileShader(n),!a.getShaderParameter(n,a.COMPILE_STATUS))throw new Error("Could not compile fragment shader: "+a.getShaderInfoLog(n));a.attachShader(this.program,n);o=a.createShader(a.VERTEX_SHADER);if(a.isContextLost())this.failedToCreate=!0;else{if(a.shaderSource(o,u),a.compileShader(o),!a.getShaderParameter(o,a.COMPILE_STATUS))throw new Error("Could not compile vertex shader: "+a.getShaderInfoLog(o));a.attachShader(this.program,o),this.attributes={};var d={};this.numAttributes=c.length;for(let e=0;e<this.numAttributes;e++)c[e]&&(a.bindAttribLocation(this.program,e,c[e]),this.attributes[c[e]]=e);if(a.linkProgram(this.program),!a.getProgramParameter(this.program,a.LINK_STATUS))throw new Error("Program failed to link: "+a.getProgramInfoLog(this.program));a.deleteShader(o),a.deleteShader(n);for(let e=0;e<h.length;e++){var p,f=h[e];f&&!d[f]&&(p=a.getUniformLocation(this.program,f))&&(d[f]=p)}this.fixedUniforms=i(e,d),this.terrainUniforms=(s=e,t=d,{u_depth:new de.Uniform1i(s,t.u_depth),u_terrain:new de.Uniform1i(s,t.u_terrain),u_terrain_dim:new de.Uniform1f(s,t.u_terrain_dim),u_terrain_matrix:new de.UniformMatrix4f(s,t.u_terrain_matrix),u_terrain_unpack:new de.Uniform4f(s,t.u_terrain_unpack),u_terrain_exaggeration:new de.Uniform1f(s,t.u_terrain_exaggeration)}),this.binderUniforms=r?r.getUniforms(e,d):[]}}}draw(t,r,i,n,o,a,s,l,c,u,h,d,p,f,m,g,y,v){var _=t.gl;if(!this.failedToCreate){if(t.program.set(this.program),t.setDepthMode(i),t.setStencilMode(n),t.setColorMode(o),t.setCullFace(a),l){t.activeTexture.set(_.TEXTURE2),_.bindTexture(_.TEXTURE_2D,l.depthTexture),t.activeTexture.set(_.TEXTURE3),_.bindTexture(_.TEXTURE_2D,l.texture);for(const w in this.terrainUniforms)this.terrainUniforms[w].set(l[w])}for(const x in this.fixedUniforms)this.fixedUniforms[x].set(s[x]);m&&m.setUniforms(t,this.binderUniforms,p,{zoom:f});let e=0;switch(r){case _.LINES:e=2;break;case _.TRIANGLES:e=3;break;case _.LINE_STRIP:e=1}for(const C of d.get()){var b=C.vaos||(C.vaos={});(b[c]||(b[c]=new yt)).bind(t,this,u,m?m.getPaintVertexBuffers():[],h,C.vertexOffset,g,y,v),_.drawElements(r,C.primitiveLength*e,_.UNSIGNED_SHORT,C.primitiveOffset*e*2)}}}}function bt(e,t,r){var i=1/me(r,1,t.transform.tileZoom),n=Math.pow(2,r.tileID.overscaledZ),t=r.tileSize*Math.pow(2,t.transform.tileZoom)/n,n=t*(r.tileID.canonical.x+r.tileID.wrap*n),t=t*r.tileID.canonical.y;return{u_image:0,u_texsize:r.imageAtlasTexture.size,u_scale:[i,e.fromScale,e.toScale],u_fade:e.t,u_pixel_coord_upper:[n>>16,t>>16],u_pixel_coord_lower:[65535&n,65535&t]}}const wt=(e,t,r,i)=>{var n=t.style.light,o=n.properties.get("position"),o=[o.x,o.y,o.z],a=de.create$1(),t=("viewport"===n.properties.get("anchor")&&de.fromRotation(a,-t.transform.angle),de.transformMat3(o,o,a),n.properties.get("color"));return{u_matrix:e,u_lightpos:o,u_lightintensity:n.properties.get("intensity"),u_lightcolor:[t.r,t.g,t.b],u_vertical_gradient:+r,u_opacity:i}},xt=(e,t,r,i,n,o,a)=>de.extend(wt(e,t,r,i),bt(o,t,a),{u_height_factor:-Math.pow(2,n.overscaledZ)/a.tileSize/8});const Ct=e=>({u_matrix:e}),Tt=(e,t,r,i)=>de.extend(Ct(e),bt(r,t,i)),St=(e,t)=>({u_matrix:e,u_world:t}),Et=(e,t,r,i,n)=>de.extend(Tt(e,t,r,i),{u_world:n});const It=(e,t,r)=>{var i=me(r,1,t.zoom),n=Math.pow(2,t.zoom-r.tileID.overscaledZ),r=r.tileID.overscaleFactor();return{u_matrix:e,u_camera_to_center_distance:t.cameraToCenterDistance,u_pixels_to_tile_units:i,u_extrude_scale:[t.pixelsToGLUnits[0]/(i*n),t.pixelsToGLUnits[1]/(i*n)],u_overscale_factor:r}},At=(e,t,r)=>({u_matrix:e,u_inv_matrix:t,u_camera_to_center_distance:r.cameraToCenterDistance,u_viewport_size:[r.width,r.height]});const kt=(e,t,r=1)=>({u_matrix:e,u_color:t,u_overlay:0,u_overlay_scale:r});const Pt=e=>({u_matrix:e});const Mt=(e,t,r,i)=>{var n=de.create(),e=(de.ortho(n,0,e.width,e.height,0,0,1),e.context.gl);return{u_matrix:n,u_world:[e.drawingBufferWidth,e.drawingBufferHeight],u_image:r,u_color_ramp:i,u_opacity:t.paint.get("heatmap-opacity")}};const Rt=(e,t,r,i)=>{var n=r.paint.get("hillshade-shadow-color"),o=r.paint.get("hillshade-highlight-color"),a=r.paint.get("hillshade-accent-color");let s=r.paint.get("hillshade-illumination-direction")*(Math.PI/180);"viewport"===r.paint.get("hillshade-illumination-anchor")&&(s-=e.transform.angle);var l=!e.options.moving;return{u_matrix:i?i.posMatrix:e.transform.calculatePosMatrix(t.tileID.toUnwrapped(),l),u_image:0,u_latrange:(i=t.tileID,e=Math.pow(2,i.canonical.z),i=i.canonical.y,[new de.MercatorCoordinate(0,i/e).toLngLat().lat,new de.MercatorCoordinate(0,(i+1)/e).toLngLat().lat]),u_light:[r.paint.get("hillshade-exaggeration"),s],u_shadow:n,u_highlight:o,u_accent:a}},Ot=(e,t)=>{var r=t.stride,i=de.create();return de.ortho(i,0,de.EXTENT,-de.EXTENT,0,0,1),de.translate(i,i,[0,-de.EXTENT,0]),{u_matrix:i,u_image:1,u_dimension:[r,r],u_zoom:e.overscaledZ,u_unpack:t.getUnpackVector()}};const Lt=(e,t,r,i)=>{var n=e.transform;return{u_matrix:zt(e,t,r,i),u_ratio:1/me(t,1,n.zoom),u_device_pixel_ratio:e.pixelRatio,u_units_to_pixels:[1/n.pixelsToGLUnits[0],1/n.pixelsToGLUnits[1]]}};function Dt(e,t){return 1/me(e,1,t.tileZoom)}function zt(e,t,r,i){return e.translatePosMatrix((i||t.tileID).posMatrix,t,r.paint.get("line-translate"),r.paint.get("line-translate-anchor"))}const Nt=(e,t,r,i,n)=>{return{u_matrix:e,u_tl_parent:t,u_scale_parent:r,u_buffer_scale:1,u_fade_t:i.mix,u_opacity:i.opacity*n.paint.get("raster-opacity"),u_image0:0,u_image1:1,u_brightness_low:n.paint.get("raster-brightness-min"),u_brightness_high:n.paint.get("raster-brightness-max"),u_saturation_factor:0<(e=n.paint.get("raster-saturation"))?1-1/(1.001-e):-e,u_contrast_factor:0<(t=n.paint.get("raster-contrast"))?1/(1-t):1+t,u_spin_weights:(r=n.paint.get("raster-hue-rotate"),r*=Math.PI/180,i=Math.sin(r),[(2*(r=Math.cos(r))+1)/3,(-Math.sqrt(3)*i-r+1)/3,(Math.sqrt(3)*i-r+1)/3])}};const Bt=(e,t,r,i,n,o,a,s,l,c)=>{var u=n.transform;return{u_is_size_zoom_constant:+("constant"===e||"source"===e),u_is_size_feature_constant:+("constant"===e||"camera"===e),u_size_t:t?t.uSizeT:0,u_size:t?t.uSize:0,u_camera_to_center_distance:u.cameraToCenterDistance,u_pitch:u.pitch/360*2*Math.PI,u_rotate_symbol:+r,u_aspect_ratio:u.width/u.height,u_fade_change:n.options.fadeDuration?n.symbolFadeChange:1,u_matrix:o,u_label_plane_matrix:a,u_coord_matrix:s,u_is_text:+l,u_pitch_with_map:+i,u_texsize:c,u_texture:0}},Ft=(e,t,r,i,n,o,a,s,l,c,u)=>{var h=n.transform;return de.extend(Bt(e,t,r,i,n,o,a,s,l,c),{u_gamma_scale:i?Math.cos(h._pitch)*h.cameraToCenterDistance:1,u_device_pixel_ratio:n.pixelRatio,u_is_halo:+u})},Ut=(e,t,r,i,n,o,a,s,l,c)=>de.extend(Ft(e,t,r,i,n,o,a,s,!0,l,!0),{u_texsize_icon:c,u_texture_icon:1});const qt=(e,t,r,i,n,o)=>de.extend(function(e,t,r,i){var n=r.imageManager.getPattern(e.from.toString()),e=r.imageManager.getPattern(e.to.toString()),{width:o,height:a}=r.imageManager.getPixelSize(),s=Math.pow(2,i.tileID.overscaledZ),s=(l=i.tileSize*Math.pow(2,r.transform.tileZoom)/s)*(i.tileID.canonical.x+i.tileID.wrap*s),l=l*i.tileID.canonical.y;return{u_image:0,u_pattern_tl_a:n.tl,u_pattern_br_a:n.br,u_pattern_tl_b:e.tl,u_pattern_br_b:e.br,u_texsize:[o,a],u_mix:t.t,u_pattern_size_a:n.displaySize,u_pattern_size_b:e.displaySize,u_scale_a:t.fromScale,u_scale_b:t.toScale,u_tile_units_to_pixels:1/me(i,1,r.transform.tileZoom),u_pixel_coord_upper:[s>>16,l>>16],u_pixel_coord_lower:[65535&s,65535&l]}}(i,o,r,n),{u_matrix:e,u_opacity:t}),jt={fillExtrusion:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_lightpos:new de.Uniform3f(e,t.u_lightpos),u_lightintensity:new de.Uniform1f(e,t.u_lightintensity),u_lightcolor:new de.Uniform3f(e,t.u_lightcolor),u_vertical_gradient:new de.Uniform1f(e,t.u_vertical_gradient),u_opacity:new de.Uniform1f(e,t.u_opacity)}),fillExtrusionPattern:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_lightpos:new de.Uniform3f(e,t.u_lightpos),u_lightintensity:new de.Uniform1f(e,t.u_lightintensity),u_lightcolor:new de.Uniform3f(e,t.u_lightcolor),u_vertical_gradient:new de.Uniform1f(e,t.u_vertical_gradient),u_height_factor:new de.Uniform1f(e,t.u_height_factor),u_image:new de.Uniform1i(e,t.u_image),u_texsize:new de.Uniform2f(e,t.u_texsize),u_pixel_coord_upper:new de.Uniform2f(e,t.u_pixel_coord_upper),u_pixel_coord_lower:new de.Uniform2f(e,t.u_pixel_coord_lower),u_scale:new de.Uniform3f(e,t.u_scale),u_fade:new de.Uniform1f(e,t.u_fade),u_opacity:new de.Uniform1f(e,t.u_opacity)}),fill:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix)}),fillPattern:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_image:new de.Uniform1i(e,t.u_image),u_texsize:new de.Uniform2f(e,t.u_texsize),u_pixel_coord_upper:new de.Uniform2f(e,t.u_pixel_coord_upper),u_pixel_coord_lower:new de.Uniform2f(e,t.u_pixel_coord_lower),u_scale:new de.Uniform3f(e,t.u_scale),u_fade:new de.Uniform1f(e,t.u_fade)}),fillOutline:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_world:new de.Uniform2f(e,t.u_world)}),fillOutlinePattern:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_world:new de.Uniform2f(e,t.u_world),u_image:new de.Uniform1i(e,t.u_image),u_texsize:new de.Uniform2f(e,t.u_texsize),u_pixel_coord_upper:new de.Uniform2f(e,t.u_pixel_coord_upper),u_pixel_coord_lower:new de.Uniform2f(e,t.u_pixel_coord_lower),u_scale:new de.Uniform3f(e,t.u_scale),u_fade:new de.Uniform1f(e,t.u_fade)}),circle:(e,t)=>({u_camera_to_center_distance:new de.Uniform1f(e,t.u_camera_to_center_distance),u_scale_with_map:new de.Uniform1i(e,t.u_scale_with_map),u_pitch_with_map:new de.Uniform1i(e,t.u_pitch_with_map),u_extrude_scale:new de.Uniform2f(e,t.u_extrude_scale),u_device_pixel_ratio:new de.Uniform1f(e,t.u_device_pixel_ratio),u_matrix:new de.UniformMatrix4f(e,t.u_matrix)}),collisionBox:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_camera_to_center_distance:new de.Uniform1f(e,t.u_camera_to_center_distance),u_pixels_to_tile_units:new de.Uniform1f(e,t.u_pixels_to_tile_units),u_extrude_scale:new de.Uniform2f(e,t.u_extrude_scale),u_overscale_factor:new de.Uniform1f(e,t.u_overscale_factor)}),collisionCircle:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_inv_matrix:new de.UniformMatrix4f(e,t.u_inv_matrix),u_camera_to_center_distance:new de.Uniform1f(e,t.u_camera_to_center_distance),u_viewport_size:new de.Uniform2f(e,t.u_viewport_size)}),debug:(e,t)=>({u_color:new de.UniformColor(e,t.u_color),u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_overlay:new de.Uniform1i(e,t.u_overlay),u_overlay_scale:new de.Uniform1f(e,t.u_overlay_scale)}),clippingMask:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix)}),heatmap:(e,t)=>({u_extrude_scale:new de.Uniform1f(e,t.u_extrude_scale),u_intensity:new de.Uniform1f(e,t.u_intensity),u_matrix:new de.UniformMatrix4f(e,t.u_matrix)}),heatmapTexture:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_world:new de.Uniform2f(e,t.u_world),u_image:new de.Uniform1i(e,t.u_image),u_color_ramp:new de.Uniform1i(e,t.u_color_ramp),u_opacity:new de.Uniform1f(e,t.u_opacity)}),hillshade:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_image:new de.Uniform1i(e,t.u_image),u_latrange:new de.Uniform2f(e,t.u_latrange),u_light:new de.Uniform2f(e,t.u_light),u_shadow:new de.UniformColor(e,t.u_shadow),u_highlight:new de.UniformColor(e,t.u_highlight),u_accent:new de.UniformColor(e,t.u_accent)}),hillshadePrepare:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_image:new de.Uniform1i(e,t.u_image),u_dimension:new de.Uniform2f(e,t.u_dimension),u_zoom:new de.Uniform1f(e,t.u_zoom),u_unpack:new de.Uniform4f(e,t.u_unpack)}),line:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_ratio:new de.Uniform1f(e,t.u_ratio),u_device_pixel_ratio:new de.Uniform1f(e,t.u_device_pixel_ratio),u_units_to_pixels:new de.Uniform2f(e,t.u_units_to_pixels)}),lineGradient:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_ratio:new de.Uniform1f(e,t.u_ratio),u_device_pixel_ratio:new de.Uniform1f(e,t.u_device_pixel_ratio),u_units_to_pixels:new de.Uniform2f(e,t.u_units_to_pixels),u_image:new de.Uniform1i(e,t.u_image),u_image_height:new de.Uniform1f(e,t.u_image_height)}),linePattern:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_texsize:new de.Uniform2f(e,t.u_texsize),u_ratio:new de.Uniform1f(e,t.u_ratio),u_device_pixel_ratio:new de.Uniform1f(e,t.u_device_pixel_ratio),u_image:new de.Uniform1i(e,t.u_image),u_units_to_pixels:new de.Uniform2f(e,t.u_units_to_pixels),u_scale:new de.Uniform3f(e,t.u_scale),u_fade:new de.Uniform1f(e,t.u_fade)}),lineSDF:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_ratio:new de.Uniform1f(e,t.u_ratio),u_device_pixel_ratio:new de.Uniform1f(e,t.u_device_pixel_ratio),u_units_to_pixels:new de.Uniform2f(e,t.u_units_to_pixels),u_patternscale_a:new de.Uniform2f(e,t.u_patternscale_a),u_patternscale_b:new de.Uniform2f(e,t.u_patternscale_b),u_sdfgamma:new de.Uniform1f(e,t.u_sdfgamma),u_image:new de.Uniform1i(e,t.u_image),u_tex_y_a:new de.Uniform1f(e,t.u_tex_y_a),u_tex_y_b:new de.Uniform1f(e,t.u_tex_y_b),u_mix:new de.Uniform1f(e,t.u_mix)}),raster:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_tl_parent:new de.Uniform2f(e,t.u_tl_parent),u_scale_parent:new de.Uniform1f(e,t.u_scale_parent),u_buffer_scale:new de.Uniform1f(e,t.u_buffer_scale),u_fade_t:new de.Uniform1f(e,t.u_fade_t),u_opacity:new de.Uniform1f(e,t.u_opacity),u_image0:new de.Uniform1i(e,t.u_image0),u_image1:new de.Uniform1i(e,t.u_image1),u_brightness_low:new de.Uniform1f(e,t.u_brightness_low),u_brightness_high:new de.Uniform1f(e,t.u_brightness_high),u_saturation_factor:new de.Uniform1f(e,t.u_saturation_factor),u_contrast_factor:new de.Uniform1f(e,t.u_contrast_factor),u_spin_weights:new de.Uniform3f(e,t.u_spin_weights)}),symbolIcon:(e,t)=>({u_is_size_zoom_constant:new de.Uniform1i(e,t.u_is_size_zoom_constant),u_is_size_feature_constant:new de.Uniform1i(e,t.u_is_size_feature_constant),u_size_t:new de.Uniform1f(e,t.u_size_t),u_size:new de.Uniform1f(e,t.u_size),u_camera_to_center_distance:new de.Uniform1f(e,t.u_camera_to_center_distance),u_pitch:new de.Uniform1f(e,t.u_pitch),u_rotate_symbol:new de.Uniform1i(e,t.u_rotate_symbol),u_aspect_ratio:new de.Uniform1f(e,t.u_aspect_ratio),u_fade_change:new de.Uniform1f(e,t.u_fade_change),u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_label_plane_matrix:new de.UniformMatrix4f(e,t.u_label_plane_matrix),u_coord_matrix:new de.UniformMatrix4f(e,t.u_coord_matrix),u_is_text:new de.Uniform1i(e,t.u_is_text),u_pitch_with_map:new de.Uniform1i(e,t.u_pitch_with_map),u_texsize:new de.Uniform2f(e,t.u_texsize),u_texture:new de.Uniform1i(e,t.u_texture)}),symbolSDF:(e,t)=>({u_is_size_zoom_constant:new de.Uniform1i(e,t.u_is_size_zoom_constant),u_is_size_feature_constant:new de.Uniform1i(e,t.u_is_size_feature_constant),u_size_t:new de.Uniform1f(e,t.u_size_t),u_size:new de.Uniform1f(e,t.u_size),u_camera_to_center_distance:new de.Uniform1f(e,t.u_camera_to_center_distance),u_pitch:new de.Uniform1f(e,t.u_pitch),u_rotate_symbol:new de.Uniform1i(e,t.u_rotate_symbol),u_aspect_ratio:new de.Uniform1f(e,t.u_aspect_ratio),u_fade_change:new de.Uniform1f(e,t.u_fade_change),u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_label_plane_matrix:new de.UniformMatrix4f(e,t.u_label_plane_matrix),u_coord_matrix:new de.UniformMatrix4f(e,t.u_coord_matrix),u_is_text:new de.Uniform1i(e,t.u_is_text),u_pitch_with_map:new de.Uniform1i(e,t.u_pitch_with_map),u_texsize:new de.Uniform2f(e,t.u_texsize),u_texture:new de.Uniform1i(e,t.u_texture),u_gamma_scale:new de.Uniform1f(e,t.u_gamma_scale),u_device_pixel_ratio:new de.Uniform1f(e,t.u_device_pixel_ratio),u_is_halo:new de.Uniform1i(e,t.u_is_halo)}),symbolTextAndIcon:(e,t)=>({u_is_size_zoom_constant:new de.Uniform1i(e,t.u_is_size_zoom_constant),u_is_size_feature_constant:new de.Uniform1i(e,t.u_is_size_feature_constant),u_size_t:new de.Uniform1f(e,t.u_size_t),u_size:new de.Uniform1f(e,t.u_size),u_camera_to_center_distance:new de.Uniform1f(e,t.u_camera_to_center_distance),u_pitch:new de.Uniform1f(e,t.u_pitch),u_rotate_symbol:new de.Uniform1i(e,t.u_rotate_symbol),u_aspect_ratio:new de.Uniform1f(e,t.u_aspect_ratio),u_fade_change:new de.Uniform1f(e,t.u_fade_change),u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_label_plane_matrix:new de.UniformMatrix4f(e,t.u_label_plane_matrix),u_coord_matrix:new de.UniformMatrix4f(e,t.u_coord_matrix),u_is_text:new de.Uniform1i(e,t.u_is_text),u_pitch_with_map:new de.Uniform1i(e,t.u_pitch_with_map),u_texsize:new de.Uniform2f(e,t.u_texsize),u_texsize_icon:new de.Uniform2f(e,t.u_texsize_icon),u_texture:new de.Uniform1i(e,t.u_texture),u_texture_icon:new de.Uniform1i(e,t.u_texture_icon),u_gamma_scale:new de.Uniform1f(e,t.u_gamma_scale),u_device_pixel_ratio:new de.Uniform1f(e,t.u_device_pixel_ratio),u_is_halo:new de.Uniform1i(e,t.u_is_halo)}),background:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_opacity:new de.Uniform1f(e,t.u_opacity),u_color:new de.UniformColor(e,t.u_color)}),backgroundPattern:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_opacity:new de.Uniform1f(e,t.u_opacity),u_image:new de.Uniform1i(e,t.u_image),u_pattern_tl_a:new de.Uniform2f(e,t.u_pattern_tl_a),u_pattern_br_a:new de.Uniform2f(e,t.u_pattern_br_a),u_pattern_tl_b:new de.Uniform2f(e,t.u_pattern_tl_b),u_pattern_br_b:new de.Uniform2f(e,t.u_pattern_br_b),u_texsize:new de.Uniform2f(e,t.u_texsize),u_mix:new de.Uniform1f(e,t.u_mix),u_pattern_size_a:new de.Uniform2f(e,t.u_pattern_size_a),u_pattern_size_b:new de.Uniform2f(e,t.u_pattern_size_b),u_scale_a:new de.Uniform1f(e,t.u_scale_a),u_scale_b:new de.Uniform1f(e,t.u_scale_b),u_pixel_coord_upper:new de.Uniform2f(e,t.u_pixel_coord_upper),u_pixel_coord_lower:new de.Uniform2f(e,t.u_pixel_coord_lower),u_tile_units_to_pixels:new de.Uniform1f(e,t.u_tile_units_to_pixels)}),terrain:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_texture:new de.Uniform1i(e,t.u_texture),u_ele_delta:new de.Uniform1f(e,t.u_ele_delta)}),terrainDepth:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_ele_delta:new de.Uniform1f(e,t.u_ele_delta)}),terrainCoords:(e,t)=>({u_matrix:new de.UniformMatrix4f(e,t.u_matrix),u_texture:new de.Uniform1i(e,t.u_texture),u_terrain_coords_id:new de.Uniform1f(e,t.u_terrain_coords_id),u_ele_delta:new de.Uniform1f(e,t.u_ele_delta)})};class Ht{constructor(e,t,r){var i=(this.context=e).gl;this.buffer=i.createBuffer(),this.dynamicDraw=Boolean(r),this.context.unbindVAO(),e.bindElementBuffer.set(this.buffer),i.bufferData(i.ELEMENT_ARRAY_BUFFER,t.arrayBuffer,this.dynamicDraw?i.DYNAMIC_DRAW:i.STATIC_DRAW),this.dynamicDraw||delete t.arrayBuffer}bind(){this.context.bindElementBuffer.set(this.buffer)}updateData(e){var t=this.context.gl;if(!this.dynamicDraw)throw new Error("Attempted to update data while not in dynamic mode.");this.context.unbindVAO(),this.bind(),t.bufferSubData(t.ELEMENT_ARRAY_BUFFER,0,e.arrayBuffer)}destroy(){var e=this.context.gl;this.buffer&&(e.deleteBuffer(this.buffer),delete this.buffer)}}const Vt={Int8:"BYTE",Uint8:"UNSIGNED_BYTE",Int16:"SHORT",Uint16:"UNSIGNED_SHORT",Int32:"INT",Uint32:"UNSIGNED_INT",Float32:"FLOAT"};class Gt{constructor(e,t,r,i){this.length=t.length,this.attributes=r,this.itemSize=t.bytesPerElement,this.dynamicDraw=i;r=(this.context=e).gl;this.buffer=r.createBuffer(),e.bindVertexBuffer.set(this.buffer),r.bufferData(r.ARRAY_BUFFER,t.arrayBuffer,this.dynamicDraw?r.DYNAMIC_DRAW:r.STATIC_DRAW),this.dynamicDraw||delete t.arrayBuffer}bind(){this.context.bindVertexBuffer.set(this.buffer)}updateData(e){if(e.length!==this.length)throw new Error(`Length of new data is ${e.length}, which doesn't match current length of `+this.length);var t=this.context.gl;this.bind(),t.bufferSubData(t.ARRAY_BUFFER,0,e.arrayBuffer)}enableAttributes(t,r){for(let e=0;e<this.attributes.length;e++){var i=this.attributes[e],i=r.attributes[i.name];void 0!==i&&t.enableVertexAttribArray(i)}}setVertexAttribPointers(t,r,i){for(let e=0;e<this.attributes.length;e++){var n=this.attributes[e],o=r.attributes[n.name];void 0!==o&&t.vertexAttribPointer(o,n.components,t[Vt[n.type]],!1,this.itemSize,n.offset+this.itemSize*(i||0))}}destroy(){var e=this.context.gl;this.buffer&&(e.deleteBuffer(this.buffer),delete this.buffer)}}const Kt=new WeakMap;function Zt(e){var t;return Kt.has(e)?Kt.get(e):(t=null==(t=e.getParameter(e.VERSION))?void 0:t.startsWith("WebGL 2.0"),Kt.set(e,t),t)}class s{constructor(e){this.gl=e.gl,this.default=this.getDefault(),this.current=this.default,this.dirty=!1}get(){return this.current}set(e){}getDefault(){return this.default}setDefault(){this.set(this.default)}}class Wt extends s{getDefault(){return de.Color.transparent}set(e){var t=this.current;e.r===t.r&&e.g===t.g&&e.b===t.b&&e.a===t.a&&!this.dirty||(this.gl.clearColor(e.r,e.g,e.b,e.a),this.current=e,this.dirty=!1)}}class Yt extends s{getDefault(){return 1}set(e){e===this.current&&!this.dirty||(this.gl.clearDepth(e),this.current=e,this.dirty=!1)}}class $t extends s{getDefault(){return 0}set(e){e===this.current&&!this.dirty||(this.gl.clearStencil(e),this.current=e,this.dirty=!1)}}class Xt extends s{getDefault(){return[!0,!0,!0,!0]}set(e){var t=this.current;e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&!this.dirty||(this.gl.colorMask(e[0],e[1],e[2],e[3]),this.current=e,this.dirty=!1)}}class Jt extends s{getDefault(){return!0}set(e){e===this.current&&!this.dirty||(this.gl.depthMask(e),this.current=e,this.dirty=!1)}}class Qt extends s{getDefault(){return 255}set(e){e===this.current&&!this.dirty||(this.gl.stencilMask(e),this.current=e,this.dirty=!1)}}class er extends s{getDefault(){return{func:this.gl.ALWAYS,ref:0,mask:255}}set(e){var t=this.current;e.func===t.func&&e.ref===t.ref&&e.mask===t.mask&&!this.dirty||(this.gl.stencilFunc(e.func,e.ref,e.mask),this.current=e,this.dirty=!1)}}class tr extends s{getDefault(){var e=this.gl;return[e.KEEP,e.KEEP,e.KEEP]}set(e){var t=this.current;e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&!this.dirty||(this.gl.stencilOp(e[0],e[1],e[2]),this.current=e,this.dirty=!1)}}class rr extends s{getDefault(){return!1}set(e){var t;e===this.current&&!this.dirty||(t=this.gl,e?t.enable(t.STENCIL_TEST):t.disable(t.STENCIL_TEST),this.current=e,this.dirty=!1)}}class ir extends s{getDefault(){return[0,1]}set(e){var t=this.current;e[0]===t[0]&&e[1]===t[1]&&!this.dirty||(this.gl.depthRange(e[0],e[1]),this.current=e,this.dirty=!1)}}class nr extends s{getDefault(){return!1}set(e){var t;e===this.current&&!this.dirty||(t=this.gl,e?t.enable(t.DEPTH_TEST):t.disable(t.DEPTH_TEST),this.current=e,this.dirty=!1)}}class or extends s{getDefault(){return this.gl.LESS}set(e){e===this.current&&!this.dirty||(this.gl.depthFunc(e),this.current=e,this.dirty=!1)}}class ar extends s{getDefault(){return!1}set(e){var t;e===this.current&&!this.dirty||(t=this.gl,e?t.enable(t.BLEND):t.disable(t.BLEND),this.current=e,this.dirty=!1)}}class sr extends s{getDefault(){var e=this.gl;return[e.ONE,e.ZERO]}set(e){var t=this.current;e[0]===t[0]&&e[1]===t[1]&&!this.dirty||(this.gl.blendFunc(e[0],e[1]),this.current=e,this.dirty=!1)}}class lr extends s{getDefault(){return de.Color.transparent}set(e){var t=this.current;e.r===t.r&&e.g===t.g&&e.b===t.b&&e.a===t.a&&!this.dirty||(this.gl.blendColor(e.r,e.g,e.b,e.a),this.current=e,this.dirty=!1)}}class cr extends s{getDefault(){return this.gl.FUNC_ADD}set(e){e===this.current&&!this.dirty||(this.gl.blendEquation(e),this.current=e,this.dirty=!1)}}class ur extends s{getDefault(){return!1}set(e){var t;e===this.current&&!this.dirty||(t=this.gl,e?t.enable(t.CULL_FACE):t.disable(t.CULL_FACE),this.current=e,this.dirty=!1)}}class hr extends s{getDefault(){return this.gl.BACK}set(e){e===this.current&&!this.dirty||(this.gl.cullFace(e),this.current=e,this.dirty=!1)}}class dr extends s{getDefault(){return this.gl.CCW}set(e){e===this.current&&!this.dirty||(this.gl.frontFace(e),this.current=e,this.dirty=!1)}}class pr extends s{getDefault(){return null}set(e){e===this.current&&!this.dirty||(this.gl.useProgram(e),this.current=e,this.dirty=!1)}}class fr extends s{getDefault(){return this.gl.TEXTURE0}set(e){e===this.current&&!this.dirty||(this.gl.activeTexture(e),this.current=e,this.dirty=!1)}}class mr extends s{getDefault(){var e=this.gl;return[0,0,e.drawingBufferWidth,e.drawingBufferHeight]}set(e){var t=this.current;e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&!this.dirty||(this.gl.viewport(e[0],e[1],e[2],e[3]),this.current=e,this.dirty=!1)}}class gr extends s{getDefault(){return null}set(e){var t;e===this.current&&!this.dirty||((t=this.gl).bindFramebuffer(t.FRAMEBUFFER,e),this.current=e,this.dirty=!1)}}class yr extends s{getDefault(){return null}set(e){var t;e===this.current&&!this.dirty||((t=this.gl).bindRenderbuffer(t.RENDERBUFFER,e),this.current=e,this.dirty=!1)}}class vr extends s{getDefault(){return null}set(e){var t;e===this.current&&!this.dirty||((t=this.gl).bindTexture(t.TEXTURE_2D,e),this.current=e,this.dirty=!1)}}class _r extends s{getDefault(){return null}set(e){var t;e===this.current&&!this.dirty||((t=this.gl).bindBuffer(t.ARRAY_BUFFER,e),this.current=e,this.dirty=!1)}}class br extends s{getDefault(){return null}set(e){var t=this.gl;t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,e),this.current=e,this.dirty=!1}}class wr extends s{getDefault(){return null}set(e){var t;e===this.current&&!this.dirty||(Zt(t=this.gl)?t.bindVertexArray(e):null!=(t=t.getExtension("OES_vertex_array_object"))&&t.bindVertexArrayOES(e),this.current=e,this.dirty=!1)}}class xr extends s{getDefault(){return 4}set(e){var t;e===this.current&&!this.dirty||((t=this.gl).pixelStorei(t.UNPACK_ALIGNMENT,e),this.current=e,this.dirty=!1)}}class Cr extends s{getDefault(){return!1}set(e){var t;e===this.current&&!this.dirty||((t=this.gl).pixelStorei(t.UNPACK_PREMULTIPLY_ALPHA_WEBGL,e),this.current=e,this.dirty=!1)}}class Tr extends s{getDefault(){return!1}set(e){var t;e===this.current&&!this.dirty||((t=this.gl).pixelStorei(t.UNPACK_FLIP_Y_WEBGL,e),this.current=e,this.dirty=!1)}}class Sr extends s{constructor(e,t){super(e),this.context=e,this.parent=t}getDefault(){return null}}class Er extends Sr{setDirty(){this.dirty=!0}set(e){var t;e===this.current&&!this.dirty||(this.context.bindFramebuffer.set(this.parent),(t=this.gl).framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,e,0),this.current=e,this.dirty=!1)}}class Ir extends Sr{set(e){var t;e===this.current&&!this.dirty||(this.context.bindFramebuffer.set(this.parent),(t=this.gl).framebufferRenderbuffer(t.FRAMEBUFFER,t.DEPTH_ATTACHMENT,t.RENDERBUFFER,e),this.current=e,this.dirty=!1)}}class Ar extends Sr{set(e){var t;e===this.current&&!this.dirty||(this.context.bindFramebuffer.set(this.parent),(t=this.gl).framebufferRenderbuffer(t.FRAMEBUFFER,t.DEPTH_STENCIL_ATTACHMENT,t.RENDERBUFFER,e),this.current=e,this.dirty=!1)}}class kr{constructor(e,t,r,i,n){this.context=e,this.width=t,this.height=r;t=e.gl,r=this.framebuffer=t.createFramebuffer();if(this.colorAttachment=new Er(e,r),i)this.depthAttachment=new(n?Ar:Ir)(e,r);else if(n)throw new Error("Stencil cannot be set without depth");if(t.checkFramebufferStatus(t.FRAMEBUFFER)!==t.FRAMEBUFFER_COMPLETE)throw new Error("Framebuffer is not complete")}destroy(){var e=this.context.gl,t=this.colorAttachment.get();t&&e.deleteTexture(t),this.depthAttachment&&(t=this.depthAttachment.get())&&e.deleteRenderbuffer(t),e.deleteFramebuffer(this.framebuffer)}}class O{constructor(e,t,r){this.blendFunction=e,this.blendColor=t,this.mask=r}}O.Replace=[1,0],O.disabled=new O(O.Replace,de.Color.transparent,[!1,!1,!1,!1]),O.unblended=new O(O.Replace,de.Color.transparent,[!0,!0,!0,!0]),O.alphaBlended=new O([1,771],de.Color.transparent,[!0,!0,!0,!0]);class Pr{constructor(e){var t,r;this.gl=e,this.clearColor=new Wt(this),this.clearDepth=new Yt(this),this.clearStencil=new $t(this),this.colorMask=new Xt(this),this.depthMask=new Jt(this),this.stencilMask=new Qt(this),this.stencilFunc=new er(this),this.stencilOp=new tr(this),this.stencilTest=new rr(this),this.depthRange=new ir(this),this.depthTest=new nr(this),this.depthFunc=new or(this),this.blend=new ar(this),this.blendFunc=new sr(this),this.blendColor=new lr(this),this.blendEquation=new cr(this),this.cullFace=new ur(this),this.cullFaceSide=new hr(this),this.frontFace=new dr(this),this.program=new pr(this),this.activeTexture=new fr(this),this.viewport=new mr(this),this.bindFramebuffer=new gr(this),this.bindRenderbuffer=new yr(this),this.bindTexture=new vr(this),this.bindVertexBuffer=new _r(this),this.bindElementBuffer=new br(this),this.bindVertexArray=new wr(this),this.pixelStoreUnpack=new xr(this),this.pixelStoreUnpackPremultiplyAlpha=new Cr(this),this.pixelStoreUnpackFlipY=new Tr(this),this.extTextureFilterAnisotropic=e.getExtension("EXT_texture_filter_anisotropic")||e.getExtension("MOZ_EXT_texture_filter_anisotropic")||e.getExtension("WEBKIT_EXT_texture_filter_anisotropic"),this.extTextureFilterAnisotropic&&(this.extTextureFilterAnisotropicMax=e.getParameter(this.extTextureFilterAnisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT)),this.maxTextureSize=e.getParameter(e.MAX_TEXTURE_SIZE),Zt(e)?(this.HALF_FLOAT=e.HALF_FLOAT,t=e.getExtension("EXT_color_buffer_half_float"),this.RGBA16F=null!=(r=e.RGBA16F)?r:null==t?void 0:t.RGBA16F_EXT,this.RGB16F=null!=(r=e.RGB16F)?r:null==t?void 0:t.RGB16F_EXT,e.getExtension("EXT_color_buffer_float")):(e.getExtension("EXT_color_buffer_half_float"),e.getExtension("OES_texture_half_float_linear"),r=e.getExtension("OES_texture_half_float"),this.HALF_FLOAT=null==r?void 0:r.HALF_FLOAT_OES)}setDefault(){this.unbindVAO(),this.clearColor.setDefault(),this.clearDepth.setDefault(),this.clearStencil.setDefault(),this.colorMask.setDefault(),this.depthMask.setDefault(),this.stencilMask.setDefault(),this.stencilFunc.setDefault(),this.stencilOp.setDefault(),this.stencilTest.setDefault(),this.depthRange.setDefault(),this.depthTest.setDefault(),this.depthFunc.setDefault(),this.blend.setDefault(),this.blendFunc.setDefault(),this.blendColor.setDefault(),this.blendEquation.setDefault(),this.cullFace.setDefault(),this.cullFaceSide.setDefault(),this.frontFace.setDefault(),this.program.setDefault(),this.activeTexture.setDefault(),this.bindFramebuffer.setDefault(),this.pixelStoreUnpack.setDefault(),this.pixelStoreUnpackPremultiplyAlpha.setDefault(),this.pixelStoreUnpackFlipY.setDefault()}setDirty(){this.clearColor.dirty=!0,this.clearDepth.dirty=!0,this.clearStencil.dirty=!0,this.colorMask.dirty=!0,this.depthMask.dirty=!0,this.stencilMask.dirty=!0,this.stencilFunc.dirty=!0,this.stencilOp.dirty=!0,this.stencilTest.dirty=!0,this.depthRange.dirty=!0,this.depthTest.dirty=!0,this.depthFunc.dirty=!0,this.blend.dirty=!0,this.blendFunc.dirty=!0,this.blendColor.dirty=!0,this.blendEquation.dirty=!0,this.cullFace.dirty=!0,this.cullFaceSide.dirty=!0,this.frontFace.dirty=!0,this.program.dirty=!0,this.activeTexture.dirty=!0,this.viewport.dirty=!0,this.bindFramebuffer.dirty=!0,this.bindRenderbuffer.dirty=!0,this.bindTexture.dirty=!0,this.bindVertexBuffer.dirty=!0,this.bindElementBuffer.dirty=!0,this.bindVertexArray.dirty=!0,this.pixelStoreUnpack.dirty=!0,this.pixelStoreUnpackPremultiplyAlpha.dirty=!0,this.pixelStoreUnpackFlipY.dirty=!0}createIndexBuffer(e,t){return new Ht(this,e,t)}createVertexBuffer(e,t,r){return new Gt(this,e,t,r)}createRenderbuffer(e,t,r){var i=this.gl,n=i.createRenderbuffer();return this.bindRenderbuffer.set(n),i.renderbufferStorage(i.RENDERBUFFER,e,t,r),this.bindRenderbuffer.set(null),n}createFramebuffer(e,t,r,i){return new kr(this,e,t,r,i)}clear({color:e,depth:t,stencil:r}){var i=this.gl;let n=0;e&&(n|=i.COLOR_BUFFER_BIT,this.clearColor.set(e),this.colorMask.set([!0,!0,!0,!0])),void 0!==t&&(n|=i.DEPTH_BUFFER_BIT,this.depthRange.set([0,1]),this.clearDepth.set(t),this.depthMask.set(!0)),void 0!==r&&(n|=i.STENCIL_BUFFER_BIT,this.clearStencil.set(r),this.stencilMask.set(255)),i.clear(n)}setCullFace(e){!1===e.enable?this.cullFace.set(!1):(this.cullFace.set(!0),this.cullFaceSide.set(e.mode),this.frontFace.set(e.frontFace))}setDepthMode(e){e.func!==this.gl.ALWAYS||e.mask?(this.depthTest.set(!0),this.depthFunc.set(e.func),this.depthMask.set(e.mask),this.depthRange.set(e.range)):this.depthTest.set(!1)}setStencilMode(e){e.test.func!==this.gl.ALWAYS||e.mask?(this.stencilTest.set(!0),this.stencilMask.set(e.mask),this.stencilOp.set([e.fail,e.depthFail,e.pass]),this.stencilFunc.set({func:e.test.func,ref:e.ref,mask:e.test.mask})):this.stencilTest.set(!1)}setColorMode(e){de.deepEqual(e.blendFunction,O.Replace)?this.blend.set(!1):(this.blend.set(!0),this.blendFunc.set(e.blendFunction),this.blendColor.set(e.blendColor)),this.colorMask.set(e.mask)}createVertexArray(){var e;return Zt(this.gl)?this.gl.createVertexArray():null==(e=this.gl.getExtension("OES_vertex_array_object"))?void 0:e.createVertexArrayOES()}deleteVertexArray(e){var t;return Zt(this.gl)?this.gl.deleteVertexArray(e):null==(t=this.gl.getExtension("OES_vertex_array_object"))?void 0:t.deleteVertexArrayOES(e)}unbindVAO(){this.bindVertexArray.set(null)}}class ge{constructor(e,t,r){this.func=e,this.mask=t,this.range=r}}ge.ReadOnly=!1,ge.ReadWrite=!0,ge.disabled=new ge(519,ge.ReadOnly,[0,1]);class L{constructor(e,t,r,i,n,o){this.test=e,this.ref=t,this.mask=r,this.fail=i,this.depthFail=n,this.pass=o}}L.disabled=new L({func:519,mask:0},0,0,7680,7680,7680);class B{constructor(e,t,r){this.enable=e,this.mode=t,this.frontFace=r}}B.disabled=new B(!1,1029,2305),B.backCCW=new B(!0,1029,2305);let Mr;function Rr(r,t,i,n,o,a,s){var l=r.context,c=l.gl,u=r.useProgram("collisionBox"),h=[];let d=0,p=0;for(let e=0;e<n.length;e++){var f=n[e],m=t.getTile(f),g=m.getBucket(i);if(g){let e=f.posMatrix;0===o[0]&&0===o[1]||(e=r.translatePosMatrix(f.posMatrix,m,o,a));var y,v,_=s?g.textCollisionBox:g.iconCollisionBox,b=g.collisionCircleArray;0<b.length&&(y=de.create(),v=e,de.mul(y,g.placementInvProjMatrix,r.transform.glCoordMatrix),de.mul(y,y,g.placementViewportMatrix),h.push({circleArray:b,circleOffset:p,transform:v,invTransform:y,coord:f}),d+=b.length/4,p=d),_&&u.draw(l,c.LINES,ge.disabled,L.disabled,r.colorModeForRenderPass(),B.disabled,It(e,r.transform,m),r.style.map.terrain&&r.style.map.terrain.getTerrainData(f),i.id,_.layoutVertexBuffer,_.indexBuffer,_.segments,null,r.transform.zoom,null,null,_.collisionVertexBuffer)}}if(s&&h.length){var e=r.useProgram("collisionCircle"),w=new de.CollisionCircleLayoutArray;w.resize(4*d),w._trim();let t=0;for(const k of h)for(let e=0;e<k.circleArray.length/4;e++){var x=4*e,C=k.circleArray[0+x],T=k.circleArray[1+x],S=k.circleArray[2+x],x=k.circleArray[3+x];w.emplace(t++,C,T,S,x,0),w.emplace(t++,C,T,S,x,1),w.emplace(t++,C,T,S,x,2),w.emplace(t++,C,T,S,x,3)}(!Mr||Mr.length<2*d)&&(Mr=function(e){var t=2*e,r=new de.QuadTriangleArray;r.resize(t),r._trim();for(let e=0;e<t;e++){var i=6*e;r.uint16[0+i]=4*e+0,r.uint16[1+i]=4*e+1,r.uint16[2+i]=4*e+2,r.uint16[3+i]=4*e+2,r.uint16[4+i]=4*e+3,r.uint16[5+i]=4*e+0}return r}(d));var E=l.createIndexBuffer(Mr,!0),I=l.createVertexBuffer(w,de.collisionCircleLayout.members,!0);for(const P of h){var A=At(P.transform,P.invTransform,r.transform);e.draw(l,c.TRIANGLES,ge.disabled,L.disabled,r.colorModeForRenderPass(),B.disabled,A,r.style.map.terrain&&r.style.map.terrain.getTerrainData(P.coord),i.id,I,E,de.SegmentVector.simpleSegment(0,2*P.circleOffset,P.circleArray.length,P.circleArray.length/2),null,r.transform.zoom,null,null,null)}I.destroy(),E.destroy()}}const Or=de.identity(new Float32Array(16));function Lr(e,t,r,i,n){if("translucent"===e.renderPass){var o=L.disabled,a=e.colorModeForRenderPass();if(r._unevaluatedLayout.hasValue("text-variable-anchor")||r._unevaluatedLayout.hasValue("text-variable-anchor-offset")){var s=i,l=e,c=r,u=t,h=r.layout.get("text-rotation-alignment"),d=r.layout.get("text-pitch-alignment"),p=n,f=l.transform,m="map"===h,g="map"===d;for(const C of s){var y,v,_,b,w=u.getTile(C),x=w.getBucket(c);x&&x.text&&x.text.segments.get().length&&(y=x.textSizeData,y=de.evaluateSizeForZoom(y,f.zoom),v=me(w,1,l.transform.zoom),v=Me(C.posMatrix,g,m,l.transform,v),_="none"!==c.layout.get("icon-text-fit")&&x.hasIconData(),y)&&(w=Math.pow(2,f.zoom-w.tileID.overscaledZ),b=l.style.map.terrain?(e,t)=>l.style.map.terrain.getElevation(C,e,t):null,function(t,r,i,n,o,a,s,l,c,u,h){var d=t.text.placedSymbolArray,p=t.text.dynamicLayoutVertexArray,f=t.icon.dynamicLayoutVertexArray,m={};p.clear();for(let e=0;e<d.length;e++){var g=d.get(e),y=t.allowVerticalPlacement&&!g.placedOrientation,y=g.hidden||!g.crossTileID||y?null:n[g.crossTileID];if(y){var v=new de.Point(g.anchorX,g.anchorY),_=pe(v,i?s:a,h),b=Oe(o.cameraToCenterDistance,_.signedDistanceFromCamera);let e=de.evaluateSizeForFeature(t.textSizeData,c,g)*b/de.ONE_EM;i&&(e*=t.tilePixelRatio/l);var{width:b,height:y,anchor:w,textOffset:x,textBoxScale:C}=y,w=function(e,t,r,i,n,o){var{horizontalAlign:e,verticalAlign:a}=de.getAnchorAlignment(e),e=-(e-.5)*t,t=-(a-.5)*r;return new de.Point((e/n+i[0])*o,(t/n+i[1])*o)}(w,b,y,x,C,e),T=i?pe(v.add(w),a,h).point:_.point.add(r?w.rotate(-o.angle):w),S=t.allowVerticalPlacement&&g.placedOrientation===de.WritingMode.vertical?Math.PI/2:0;for(let e=0;e<g.numGlyphs;e++)de.addDynamicAttributes(p,T,S);u&&0<=g.associatedIconIndex&&(m[g.associatedIconIndex]={shiftedAnchor:T,angle:S})}else fe(g.numGlyphs,p)}if(u){f.clear();var E=t.icon.placedSymbolArray;for(let e=0;e<E.length;e++){var I=E.get(e);if(I.hidden)fe(I.numGlyphs,f);else{var A=m[e];if(A)for(let e=0;e<I.numGlyphs;e++)de.addDynamicAttributes(f,A.shiftedAnchor,A.angle);else fe(I.numGlyphs,f)}}t.icon.dynamicLayoutVertexBuffer.updateData(f)}t.text.dynamicLayoutVertexBuffer.updateData(p)}(x,m,g,p,f,v,C.posMatrix,w,y,_,b))}}0!==r.paint.get("icon-opacity").constantOr(1)&&Dr(e,t,r,i,!1,r.paint.get("icon-translate"),r.paint.get("icon-translate-anchor"),r.layout.get("icon-rotation-alignment"),r.layout.get("icon-pitch-alignment"),r.layout.get("icon-keep-upright"),o,a),0!==r.paint.get("text-opacity").constantOr(1)&&Dr(e,t,r,i,!0,r.paint.get("text-translate"),r.paint.get("text-translate-anchor"),r.layout.get("text-rotation-alignment"),r.layout.get("text-pitch-alignment"),r.layout.get("text-keep-upright"),o,a),t.map.showCollisionBoxes&&(Rr(e,t,r,i,r.paint.get("text-translate"),r.paint.get("text-translate-anchor"),!0),Rr(e,t,r,i,r.paint.get("icon-translate"),r.paint.get("icon-translate-anchor"),!1))}}function Dr(s,n,l,o,c,F,U,a,q,j,H,V){var e=s.context,u=e.gl,G=s.transform,h="map"===a,d="map"===q,K="viewport"!==a&&"point"!==l.layout.get("symbol-placement"),Z=h&&!d&&!K,W=!l.layout.get("symbol-sort-key").isConstant();let Y=!1;var $=s.depthModeForSublayer(0,ge.ReadOnly),X=l._unevaluatedLayout.hasValue("text-variable-anchor")||l._unevaluatedLayout.hasValue("text-variable-anchor-offset"),p=[];for(const B of o){var f=n.getTile(B),m=f.getBucket(l);if(m){var g=c?m.text:m.icon;if(g&&g.segments.get().length&&g.hasVisibleVertices){var y=g.programConfigurations.get(l.id),v=c||m.sdfIcons,_=c?m.textSizeData:m.iconSizeData,b=d||0!==G.pitch,J=s.useProgram((w=v,J=c,m.iconsInText&&J?"symbolTextAndIcon":w?"symbolSDF":"symbolIcon"),y),w=de.evaluateSizeForZoom(_,G.zoom),Q=s.style.map.terrain&&s.style.map.terrain.getTerrainData(B);let e,t=[0,0],r,i,n=null,o;c?(r=f.glyphAtlasTexture,i=u.LINEAR,e=f.glyphAtlasTexture.size,m.iconsInText&&(t=f.imageAtlasTexture.size,n=f.imageAtlasTexture,y="composite"===_.kind||"camera"===_.kind,o=b||s.options.rotating||s.options.zooming||y?u.LINEAR:u.NEAREST)):(y=1!==l.layout.get("icon-size").constantOr(0)||m.iconsNeedLinear,r=f.imageAtlasTexture,i=v||s.options.rotating||s.options.zooming||y||b?u.LINEAR:u.NEAREST,e=f.imageAtlasTexture.size);var y=me(f,1,s.transform.zoom),b=Me(B.posMatrix,d,h,s.transform,y),y=Re(B.posMatrix,d,h,s.transform,y),x=X&&m.hasTextData(),x="none"!==l.layout.get("icon-text-fit")&&x&&m.hasIconData();if(K){var C=s.style.map.terrain?(e,t)=>s.style.map.terrain.getElevation(B,e,t):null,T="map"===l.layout.get("text-rotation-alignment");{S=void 0;E=void 0;I=void 0;A=void 0;k=void 0;ee=void 0;te=void 0;re=void 0;ie=void 0;P=void 0;ne=void 0;oe=void 0;ae=void 0;M=void 0;se=void 0;le=void 0;ce=void 0;N=void 0;O=void 0;L=void 0;R=void 0;D=void 0;z=void 0;var S=m;var E=B.posMatrix;var I=s;var A=c;var k=b;var ee=y;var te=d;var re=j;var ie=T;var P=C;var ne=A?S.textSizeData:S.iconSizeData,oe=de.evaluateSizeForZoom(ne,I.transform.zoom),ae=[256/I.width*2+1,256/I.height*2+1],M=(A?S.text:S.icon).dynamicLayoutVertexArray,se=(M.clear(),S.lineVertexArray),le=(A?S.text:S.icon).placedSymbolArray,ce=I.transform.width/I.transform.height;let t=!1;for(let e=0;e<le.length;e++){var R,O,L,D,z,N=le.get(e);if(N.hidden||N.writingMode===de.WritingMode.vertical&&!t)fe(N.numGlyphs,M);else{t=!1;let e;P?(e=[N.anchorX,N.anchorY,P(N.anchorX,N.anchorY),1],de.transformMat4(e,e,E)):je(e=[N.anchorX,N.anchorY,0,1],e,E),L=e,O=ae,R=void 0,R=L[0]/L[3],L=L[1]/L[3],(!(R>=-O[0]&&R<=O[0]&&L>=-O[1]&&L<=O[1])||(R=e[3],L=Oe(I.transform.cameraToCenterDistance,R),O=de.evaluateSizeForFeature(ne,oe,N),R=te?O/L:O*L,L=pe(O=new de.Point(N.anchorX,N.anchorY),k,P).point,z=ze(N,R,!(D={projections:{},offsets:{}}),re,E,k,ee,S.glyphOffsetArray,se,M,L,O,D,ce,ie,P),t=z.useVertical,z.notEnoughRoom)||t||z.needsFlipping&&ze(N,R,!0,re,E,k,ee,S.glyphOffsetArray,se,M,L,O,D,ce,ie,P).notEnoughRoom)&&fe(N.numGlyphs,M)}}(A?S.text:S.icon).dynamicLayoutVertexBuffer.updateData(M)}}T=s.translatePosMatrix(B.posMatrix,f,F,U),C=K||c&&X||x?Or:b,A=s.translatePosMatrix(y,f,F,U,!0),x=v&&0!==l.paint.get(c?"text-halo-width":"icon-halo-width").constantOr(1);let a;var ue={program:J,buffers:g,uniformValues:a=v?m.iconsInText?Ut(_.kind,w,Z,d,s,T,C,A,e,t):Ft(_.kind,w,Z,d,s,T,C,A,c,e,!0):Bt(_.kind,w,Z,d,s,T,C,A,c,e),atlasTexture:r,atlasTextureIcon:n,atlasInterpolation:i,atlasInterpolationIcon:o,isSDF:v,hasHalo:x};if(W&&m.canOverlap){Y=!0;for(const he of g.segments.get())p.push({segments:new de.SegmentVector([he]),sortKey:he.sortKey,state:ue,terrainData:Q})}else p.push({segments:g.segments,sortKey:0,state:ue,terrainData:Q})}}}Y&&p.sort((e,t)=>e.sortKey-t.sortKey);for(const i of p){var t,r=i.state;e.activeTexture.set(u.TEXTURE0),r.atlasTexture.bind(r.atlasInterpolation,u.CLAMP_TO_EDGE),r.atlasTextureIcon&&(e.activeTexture.set(u.TEXTURE1),r.atlasTextureIcon)&&r.atlasTextureIcon.bind(r.atlasInterpolationIcon,u.CLAMP_TO_EDGE),r.isSDF&&(t=r.uniformValues,r.hasHalo&&(t.u_is_halo=1,zr(r.buffers,i.segments,l,s,r.program,$,H,V,t,i.terrainData)),t.u_is_halo=0),zr(r.buffers,i.segments,l,s,r.program,$,H,V,r.uniformValues,i.terrainData)}}function zr(e,t,r,i,n,o,a,s,l,c){var u=i.context,h=u.gl;n.draw(u,h.TRIANGLES,o,a,s,B.disabled,l,c,r.id,e.layoutVertexBuffer,e.indexBuffer,t,r.paint,i.transform.zoom,e.programConfigurations.get(r.id),e.dynamicLayoutVertexBuffer,e.opacityVertexBuffer)}function Nr(t,r,i,n){if("translucent"===t.renderPass){var e=i.paint.get("circle-opacity"),o=i.paint.get("circle-stroke-width"),a=i.paint.get("circle-stroke-opacity"),s=!i.layout.get("circle-sort-key").isConstant();if(0!==e.constantOr(1)||0!==o.constantOr(1)&&0!==a.constantOr(1)){var l=t.context,c=l.gl,u=t.depthModeForSublayer(0,ge.ReadOnly),h=L.disabled,d=t.colorModeForRenderPass(),p=[];for(let e=0;e<n.length;e++){var f=n[e],m=r.getTile(f),g=m.getBucket(i);if(g){var y=g.programConfigurations.get(i.id),v=t.useProgram("circle",y),_=g.layoutVertexBuffer,b=g.indexBuffer,w=t.style.map.terrain&&t.style.map.terrain.getTerrainData(f),x={programConfiguration:y,program:v,layoutVertexBuffer:_,indexBuffer:b,uniformValues:((e,t,r,i)=>{var n,o=e.transform;let a,s;return s="map"===i.paint.get("circle-pitch-alignment")?(n=me(r,1,o.zoom),a=!0,[n,n]):(a=!1,o.pixelsToGLUnits),{u_camera_to_center_distance:o.cameraToCenterDistance,u_scale_with_map:+("map"===i.paint.get("circle-pitch-scale")),u_matrix:e.translatePosMatrix(t.posMatrix,r,i.paint.get("circle-translate"),i.paint.get("circle-translate-anchor")),u_pitch_with_map:+a,u_device_pixel_ratio:e.pixelRatio,u_extrude_scale:s}})(t,f,m,i),terrainData:w};if(s)for(const P of g.segments.get())p.push({segments:new de.SegmentVector([P]),sortKey:P.sortKey,state:x});else p.push({segments:g.segments,sortKey:0,state:x})}}s&&p.sort((e,t)=>e.sortKey-t.sortKey);for(const M of p){var{programConfiguration:C,program:T,layoutVertexBuffer:S,indexBuffer:E,uniformValues:I,terrainData:A}=M.state,k=M.segments;T.draw(l,c.TRIANGLES,u,h,d,B.disabled,I,A,i.id,S,E,k,i.paint,t.transform.zoom,C)}}}}function Br(t,r,i,n){if(0!==i.paint.get("heatmap-opacity"))if("offscreen"===t.renderPass){var o=t.context,a=o.gl,s=L.disabled,l=new O([a.ONE,a.ONE],de.Color.transparent,[!0,!0,!0,!0]);{var c=o;var u=t;var h=i;var d=c.gl;c.activeTexture.set(d.TEXTURE1),c.viewport.set([0,0,u.width/4,u.height/4]);let e=h.heatmapFbo;e?(d.bindTexture(d.TEXTURE_2D,e.colorAttachment.get()),c.bindFramebuffer.set(e.framebuffer)):(_=d.createTexture(),d.bindTexture(d.TEXTURE_2D,_),d.texParameteri(d.TEXTURE_2D,d.TEXTURE_WRAP_S,d.CLAMP_TO_EDGE),d.texParameteri(d.TEXTURE_2D,d.TEXTURE_WRAP_T,d.CLAMP_TO_EDGE),d.texParameteri(d.TEXTURE_2D,d.TEXTURE_MIN_FILTER,d.LINEAR),d.texParameteri(d.TEXTURE_2D,d.TEXTURE_MAG_FILTER,d.LINEAR),e=h.heatmapFbo=c.createFramebuffer(u.width/4,u.height/4,!1,!1),function(e,t,r,i){var n=e.gl,o=null!=(o=e.HALF_FLOAT)?o:n.UNSIGNED_BYTE,e=null!=(e=e.RGBA16F)?e:n.RGBA;n.texImage2D(n.TEXTURE_2D,0,e,t.width/4,t.height/4,0,n.RGBA,o,null),i.colorAttachment.set(r)}(c,u,_,e))}o.clear({color:de.Color.transparent});for(let e=0;e<n.length;e++){var p,f,m,g,y,v=n[e];r.hasRenderableParent(v)||(f=(p=r.getTile(v)).getBucket(i))&&(m=f.programConfigurations.get(i.id),g=t.useProgram("heatmap",m),y=t.transform["zoom"],g.draw(o,a.TRIANGLES,ge.disabled,s,l,B.disabled,(g=v.posMatrix,v=p,p=y,y=i.paint.get("heatmap-intensity"),{u_matrix:g,u_extrude_scale:me(v,1,p),u_intensity:y}),null,i.id,f.layoutVertexBuffer,f.indexBuffer,f.segments,i.paint,t.transform.zoom,m))}o.viewport.set([0,0,t.width,t.height])}else if("translucent"===t.renderPass){t.context.setColorMode(t.colorModeForRenderPass());var d=t,h=i,c=d.context,u=c.gl,_=h.heatmapFbo;if(_){c.activeTexture.set(u.TEXTURE0),u.bindTexture(u.TEXTURE_2D,_.colorAttachment.get()),c.activeTexture.set(u.TEXTURE1);let e=h.colorRampTexture;(e=e||(h.colorRampTexture=new N(c,h.colorRamp,u.RGBA))).bind(u.LINEAR,u.CLAMP_TO_EDGE),d.useProgram("heatmapTexture").draw(c,u.TRIANGLES,ge.disabled,L.disabled,d.colorModeForRenderPass(),B.disabled,Mt(d,h,0,1),null,h.id,d.viewportBuffer,d.quadTriangleIndexBuffer,d.viewportSegments,h.paint,d.transform.zoom)}}}function Fr(r,i,n,t){if("translucent"===r.renderPass){var e=n.paint.get("line-opacity"),o=n.paint.get("line-width");if(0!==e.constantOr(1)&&0!==o.constantOr(1)){var a,s,l,c,u,h,d,p,f,m,g=r.depthModeForSublayer(0,ge.ReadOnly),y=r.colorModeForRenderPass(),v=n.paint.get("line-dasharray"),_=n.paint.get("line-pattern"),b=_.constantOr(1),w=n.paint.get("line-gradient"),x=n.getCrossfadeParameters(),z=b?"linePattern":v?"lineSDF":w?"lineGradient":"line",C=r.context,T=C.gl;let e=!0;for(const D of t){var S=i.getTile(D);if(!b||S.patternsLoaded()){var E=S.getBucket(n);if(E){var I,A,k=E.programConfigurations.get(n.id),P=r.context.program.get(),M=r.useProgram(z,k),P=e||M.program!==P,R=r.style.map.terrain&&r.style.map.terrain.getTerrainData(D),O=_.constantOr(null),O=(O&&S.imageAtlas&&(I=(A=S.imageAtlas).patternPositions[O.to.toString()],A=A.patternPositions[O.from.toString()],I)&&A&&k.setConstantPatternPositions(I,A),R?D:null),L=b?(I=S,A=n,d=x,p=O,m=f=void 0,f=(h=r).transform,m=Dt(I,f),{u_matrix:zt(h,I,A,p),u_texsize:I.imageAtlasTexture.size,u_ratio:1/me(I,1,f.zoom),u_device_pixel_ratio:h.pixelRatio,u_image:0,u_scale:[m,d.fromScale,d.toScale],u_fade:d.t,u_units_to_pixels:[1/f.pixelsToGLUnits[0],1/f.pixelsToGLUnits[1]]}):v?(p=S,h=n,m=v,d=x,f=O,u=c=L=c=s=l=s=void 0,s=(a=r).transform,l=a.lineAtlas,s=Dt(p,s),c="round"===h.layout.get("line-cap"),L=l.getDash(m.from,c),m=l.getDash(m.to,c),c=L.width*d.fromScale,u=m.width*d.toScale,de.extend(Lt(a,p,h,f),{u_patternscale_a:[s/c,-L.height/2],u_patternscale_b:[s/u,-m.height/2],u_sdfgamma:l.width/(256*Math.min(c,u)*a.pixelRatio)/2,u_image:0,u_tex_y_a:L.y,u_tex_y_b:m.y,u_mix:d.t})):w?(s=r,l=S,c=n,u=E.lineClipsArray.length,a=O,de.extend(Lt(s,l,c,a),{u_image:0,u_image_height:u})):Lt(r,S,n,O);if(b)C.activeTexture.set(T.TEXTURE0),S.imageAtlasTexture.bind(T.LINEAR,T.CLAMP_TO_EDGE),k.updatePaintBuffers(x);else if(v&&(P||r.lineAtlas.dirty))C.activeTexture.set(T.TEXTURE0),r.lineAtlas.bind(C);else if(w){O=E.gradients[n.id];let t=O.texture;if(n.gradientVersion!==O.version){let e=256;n.stepInterpolant&&(S=i.getSource().maxzoom,P=D.canonical.z===S?Math.ceil(1<<r.transform.maxZoom-D.canonical.z):1,S=E.maxLineLength/de.EXTENT,e=de.clamp(de.nextPowerOfTwo(1024*S*P),256,C.maxTextureSize)),O.gradient=de.renderColorRamp({expression:n.gradientExpression(),evaluationKey:"lineProgress",resolution:e,image:O.gradient||void 0,clips:E.lineClipsArray}),O.texture?O.texture.update(O.gradient):O.texture=new N(C,O.gradient,T.RGBA),O.version=n.gradientVersion,t=O.texture}C.activeTexture.set(T.TEXTURE0),t.bind(n.stepInterpolant?T.NEAREST:T.LINEAR,T.CLAMP_TO_EDGE)}M.draw(C,T.TRIANGLES,g,r.stencilModeForClipping(D),y,B.disabled,L,R,n.id,E.layoutVertexBuffer,E.indexBuffer,E.segments,n.paint,r.transform.zoom,k,E.layoutVertexBuffer2),e=!1}}}}}}function Ur(r,i,n,o,a){if(n&&o&&o.imageAtlas){o=o.imageAtlas.patternPositions;let e=o[n.to.toString()],t=o[n.from.toString()];!e&&t&&(e=t),!t&&e&&(t=e),e&&t||(n=a.getPaintProperty(i),e=o[n],t=o[n]),e&&t&&r.setConstantPatternPositions(e,t)}}function qr(e,t,r,i,n,o,a){var s=e.context.gl,l="fill-pattern",c=r.paint.get(l),u=c&&c.constantOr(1),h=r.getCrossfadeParameters();let d,p,f,m,g;d=a?(p=u&&!r.getPaintProperty("fill-outline-color")?"fillOutlinePattern":"fillOutline",s.LINES):(p=u?"fillPattern":"fill",s.TRIANGLES);var y=c.constantOr(null);for(const S of i){var v,_,b,w,x,C,T=t.getTile(S);u&&!T.patternsLoaded()||(v=T.getBucket(r))&&(_=v.programConfigurations.get(r.id),b=e.useProgram(p,_),w=e.style.map.terrain&&e.style.map.terrain.getTerrainData(S),u&&(e.context.activeTexture.set(s.TEXTURE0),T.imageAtlasTexture.bind(s.LINEAR,s.CLAMP_TO_EDGE),_.updatePaintBuffers(h)),Ur(_,l,y,T,r),x=((w?S:null)||S).posMatrix,x=e.translatePosMatrix(x,T,r.paint.get("fill-translate"),r.paint.get("fill-translate-anchor")),f=a?(m=v.indexBuffer2,g=v.segments2,C=[s.drawingBufferWidth,s.drawingBufferHeight],"fillOutlinePattern"===p&&u?Et(x,e,h,T,C):St(x,C)):(m=v.indexBuffer,g=v.segments,u?Tt(x,e,h,T):Ct(x)),b.draw(e.context,d,n,e.stencilModeForClipping(S),o,B.disabled,f,w,r.id,v.layoutVertexBuffer,m,g,r.paint,e.transform.zoom,_))}}function jr(e,t,r,i,n,o,a){var s=e.context,l=s.gl,c="fill-extrusion-pattern",u=r.paint.get(c),h=u.constantOr(1),d=r.getCrossfadeParameters(),p=r.paint.get("fill-extrusion-opacity"),f=u.constantOr(null);for(const x of i){var m,g,y,v,_,b=t.getTile(x),w=b.getBucket(r);w&&(m=e.style.map.terrain&&e.style.map.terrain.getTerrainData(x),g=w.programConfigurations.get(r.id),y=e.useProgram(h?"fillExtrusionPattern":"fillExtrusion",g),h&&(e.context.activeTexture.set(l.TEXTURE0),b.imageAtlasTexture.bind(l.LINEAR,l.CLAMP_TO_EDGE),g.updatePaintBuffers(d)),Ur(g,c,f,b,r),v=e.translatePosMatrix(x.posMatrix,b,r.paint.get("fill-extrusion-translate"),r.paint.get("fill-extrusion-translate-anchor")),_=r.paint.get("fill-extrusion-vertical-gradient"),b=h?xt(v,e,_,p,x,d,b):wt(v,e,_,p),y.draw(s,s.gl.TRIANGLES,n,o,a,B.backCCW,b,m,r.id,w.layoutVertexBuffer,w.indexBuffer,w.segments,r.paint,e.transform.zoom,g,e.style.map.terrain&&w.centroidVertexBuffer))}}function Hr(e,t,r,i){if("offscreen"===e.renderPass||"translucent"===e.renderPass){var n=e.context,o=e.depthModeForSublayer(0,ge.ReadOnly),a=e.colorModeForRenderPass(),[s,i]="translucent"===e.renderPass?e.stencilConfigForOverlap(i):[{},i];for(const w of i){var l=t.getTile(w);if(void 0!==l.needsHillshadePrepare&&l.needsHillshadePrepare&&"offscreen"===e.renderPass){b=_=v=y=g=m=f=p=d=h=u=c=void 0;var c=e,u=l,h=r,d=o,p=L.disabled,f=a,m=c.context,g=m.gl,y=u.dem;if(y&&y.data){var v=y.dim,_=y.stride,b=y.getPixels();m.activeTexture.set(g.TEXTURE1),m.pixelStoreUnpackPremultiplyAlpha.set(!1),u.demTexture=u.demTexture||c.getTileTexture(_),(u.demTexture?((_=u.demTexture).update(b,{premultiply:!1}),_):(u.demTexture=new N(m,b,g.RGBA,{premultiply:!1}),u.demTexture)).bind(g.NEAREST,g.CLAMP_TO_EDGE),m.activeTexture.set(g.TEXTURE0);let e=u.fbo;e||((_=new N(m,{width:v,height:v,data:null},g.RGBA)).bind(g.LINEAR,g.CLAMP_TO_EDGE),(e=u.fbo=m.createFramebuffer(v,v,!0,!1)).colorAttachment.set(_.texture)),m.bindFramebuffer.set(e.framebuffer),m.viewport.set([0,0,v,v]),c.useProgram("hillshadePrepare").draw(m,g.TRIANGLES,d,p,f,B.disabled,Ot(u.tileID,y),null,h.id,c.rasterBoundsBuffer,c.quadTriangleIndexBuffer,c.rasterBoundsSegments),u.needsHillshadePrepare=!1}}else"translucent"===e.renderPass&&(b=e,_=w,v=l,m=r,g=o,d=s[w.overscaledZ],p=a,u=c=h=y=f=void 0,f=b.context,y=f.gl,h=v.fbo)&&(c=b.useProgram("hillshade"),u=b.style.map.terrain&&b.style.map.terrain.getTerrainData(_),f.activeTexture.set(y.TEXTURE0),y.bindTexture(y.TEXTURE_2D,h.colorAttachment.get()),h=u?_:null,c.draw(f,y.TRIANGLES,g,d,p,B.disabled,Rt(b,v,m,h),u,m.id,b.rasterBoundsBuffer,b.quadTriangleIndexBuffer,b.rasterBoundsSegments))}n.viewport.set([0,0,e.width,e.height])}}function Vr(r,i,n,e){if("translucent"===r.renderPass&&0!==n.paint.get("raster-opacity")&&e.length){var o=r.context,a=o.gl,s=i.getSource(),l=r.useProgram("raster"),c=r.colorModeForRenderPass(),[u,e]=s instanceof _?[{},e]:r.stencilConfigForOverlap(e),h=e[e.length-1].overscaledZ,d=!r.options.moving;for(const v of e){var p=r.depthModeForSublayer(v.overscaledZ-h,1===n.paint.get("raster-opacity")?ge.ReadWrite:ge.ReadOnly,a.LESS),f=i.getTile(v),m=(f.registerFadeDuration(n.paint.get("raster-fade-duration")),i.findLoadedParent(v,0)),g=function(e,t,r,i,n,o){i=i.paint.get("raster-fade-duration");{var a;return!o&&0<i?(o=M.now(),a=(o-e.timeAdded)/i,o=t?(o-t.timeAdded)/i:-1,i=r.getSource(),r=n.coveringZoomLevel({tileSize:i.tileSize,roundZoom:i.roundZoom}),n=!t||Math.abs(t.tileID.overscaledZ-r)>Math.abs(e.tileID.overscaledZ-r),i=n&&e.refreshedUponExpiration?1:de.clamp(n?a:1-o,0,1),e.refreshedUponExpiration&&1<=a&&(e.refreshedUponExpiration=!1),t?{opacity:1,mix:1-i}:{opacity:i,mix:0}):{opacity:1,mix:0}}}(f,m,i,n,r.transform,r.style.map.terrain);let e,t;var y="nearest"===n.paint.get("raster-resampling")?a.NEAREST:a.LINEAR,m=(o.activeTexture.set(a.TEXTURE0),f.texture.bind(y,a.CLAMP_TO_EDGE,a.LINEAR_MIPMAP_NEAREST),o.activeTexture.set(a.TEXTURE1),m?(m.texture.bind(y,a.CLAMP_TO_EDGE,a.LINEAR_MIPMAP_NEAREST),e=Math.pow(2,m.tileID.overscaledZ-f.tileID.overscaledZ),t=[f.tileID.canonical.x*e%1,f.tileID.canonical.y*e%1]):f.texture.bind(y,a.CLAMP_TO_EDGE,a.LINEAR_MIPMAP_NEAREST),r.style.map.terrain&&r.style.map.terrain.getTerrainData(v)),f=m?v:null,y=f?f.posMatrix:r.transform.calculatePosMatrix(v.toUnwrapped(),d),f=Nt(y,t||[0,0],e||1,g,n);s instanceof _?l.draw(o,a.TRIANGLES,p,L.disabled,c,B.disabled,f,m,n.id,s.boundsBuffer,r.quadTriangleIndexBuffer,s.boundsSegments):l.draw(o,a.TRIANGLES,p,u[v.overscaledZ],c,B.disabled,f,m,n.id,r.rasterBoundsBuffer,r.quadTriangleIndexBuffer,r.rasterBoundsSegments)}}}const Gr=new de.Color(1,0,0,1),Kr=new de.Color(0,1,0,1),Zr=new de.Color(0,0,1,1),Wr=new de.Color(1,0,1,1),Yr=new de.Color(0,1,1,1);function $r(e){var t,r,i=e.transform.padding,i=(Xr(e,e.transform.height-(i.top||0),3,Gr),Xr(e,i.bottom||0,3,Kr),Jr(e,i.left||0,3,Zr),Jr(e,e.transform.width-(i.right||0),3,Wr),e.transform.centerPoint);t=e,r=i.x,e=e.transform.height-i.y,i=Yr,Qr(t,r-1,e-10,2,20,i),Qr(t,r-10,e-1,20,2,i)}function Xr(e,t,r,i){Qr(e,0,t+r/2,e.transform.width,r,i)}function Jr(e,t,r,i){Qr(e,t-r/2,0,r,e.transform.height,i)}function Qr(e,t,r,i,n,o){var a=e.context,s=a.gl;s.enable(s.SCISSOR_TEST),s.scissor(t*e.pixelRatio,r*e.pixelRatio,i*e.pixelRatio,n*e.pixelRatio),a.clear({color:o}),s.disable(s.SCISSOR_TEST)}function ei(r,i,n){for(let t=0;t<n.length;t++){o=void 0;a=void 0;s=void 0;l=void 0;c=void 0;u=void 0;h=void 0;d=void 0;p=void 0;f=void 0;m=void 0;g=void 0;var o=r;var a=i;var s=n[t];var l=o.context,c=l.gl,u=s.posMatrix,h=o.useProgram("debug"),d=ge.disabled,p=L.disabled,f=o.colorModeForRenderPass(),m=o.style.map.terrain&&o.style.map.terrain.getTerrainData(s),g=(l.activeTexture.set(c.TEXTURE0),a.getTileByID(s.key).latestRawTileData),g=g&&g.byteLength||0,g=Math.floor(g/1024),a=a.getTile(s).tileSize,a=512/Math.min(a,512)*(s.overscaledZ/o.transform.zoom)*.5;let e=s.canonical.toString();s.overscaledZ!==s.canonical.z&&(e+=" => "+s.overscaledZ);s=e+` ${g}kB`;(function(e,t){e.initDebugOverlayCanvas();var r=e.debugOverlayCanvas,i=e.context.gl,n=e.debugOverlayCanvas.getContext("2d");n.clearRect(0,0,r.width,r.height),n.shadowColor="white",n.shadowBlur=2,n.lineWidth=1.5,n.strokeStyle="white",n.textBaseline="top",n.font="bold 36px Open Sans, sans-serif",n.fillText(t,5,5),n.strokeText(t,5,5),e.debugOverlayTexture.update(r),e.debugOverlayTexture.bind(i.LINEAR,i.CLAMP_TO_EDGE)})(o,s),h.draw(l,c.TRIANGLES,d,p,O.alphaBlended,B.disabled,kt(u,de.Color.transparent,a),null,"$debug",o.debugBuffer,o.quadTriangleIndexBuffer,o.debugSegments),h.draw(l,c.LINE_STRIP,d,p,f,B.disabled,kt(u,de.Color.red),m,"$debug",o.debugBuffer,o.tileBorderIndexBuffer,o.debugSegments)}}function ti(e,t,r){var i=e.context,n=i.gl,o=e.colorModeForRenderPass(),a=new ge(n.LEQUAL,ge.ReadWrite,e.depthRangeFor3D),s=e.useProgram("terrain"),l=t.getTerrainMesh();i.bindFramebuffer.set(null),i.viewport.set([0,0,e.width,e.height]);for(const h of r){var c=e.renderToTexture.getTexture(h),u=t.getTerrainData(h.tileID),c=(i.activeTexture.set(n.TEXTURE0),n.bindTexture(n.TEXTURE_2D,c.texture),e.transform.calculatePosMatrix(h.tileID.toUnwrapped())),c={u_matrix:c,u_texture:0,u_ele_delta:t.getMeshFrameDelta(e.transform.zoom)};s.draw(i,n.TRIANGLES,a,L.disabled,o,B.backCCW,c,u,"terrain",l.vertexBuffer,l.indexBuffer,l.segments)}}class ri{constructor(e,t){this.context=new Pr(e),this.transform=t,this._tileTextures={},this.terrainFacilitator={dirty:!0,matrix:de.identity(new Float64Array(16)),renderTime:0},this.setup(),this.numSublayers=k.maxUnderzooming+k.maxOverzooming+1,this.depthEpsilon=1/Math.pow(2,16),this.crossTileSymbolIndex=new dt}resize(e,t,r){if(this.width=Math.floor(e*r),this.height=Math.floor(t*r),this.pixelRatio=r,this.context.viewport.set([0,0,this.width,this.height]),this.style)for(const i of this.style._order)this.style._layers[i].resize()}setup(){var e=this.context,t=new de.PosArray,t=(t.emplaceBack(0,0),t.emplaceBack(de.EXTENT,0),t.emplaceBack(0,de.EXTENT),t.emplaceBack(de.EXTENT,de.EXTENT),this.tileExtentBuffer=e.createVertexBuffer(t,gt.members),this.tileExtentSegments=de.SegmentVector.simpleSegment(0,0,4,2),new de.PosArray),t=(t.emplaceBack(0,0),t.emplaceBack(de.EXTENT,0),t.emplaceBack(0,de.EXTENT),t.emplaceBack(de.EXTENT,de.EXTENT),this.debugBuffer=e.createVertexBuffer(t,gt.members),this.debugSegments=de.SegmentVector.simpleSegment(0,0,4,5),new de.RasterBoundsArray),t=(t.emplaceBack(0,0,0,0),t.emplaceBack(de.EXTENT,0,de.EXTENT,0),t.emplaceBack(0,de.EXTENT,0,de.EXTENT),t.emplaceBack(de.EXTENT,de.EXTENT,de.EXTENT,de.EXTENT),this.rasterBoundsBuffer=e.createVertexBuffer(t,ue.members),this.rasterBoundsSegments=de.SegmentVector.simpleSegment(0,0,4,2),new de.PosArray),t=(t.emplaceBack(0,0),t.emplaceBack(1,0),t.emplaceBack(0,1),t.emplaceBack(1,1),this.viewportBuffer=e.createVertexBuffer(t,gt.members),this.viewportSegments=de.SegmentVector.simpleSegment(0,0,4,2),new de.LineStripIndexArray),t=(t.emplaceBack(0),t.emplaceBack(1),t.emplaceBack(3),t.emplaceBack(2),t.emplaceBack(0),this.tileBorderIndexBuffer=e.createIndexBuffer(t),new de.TriangleIndexArray),e=(t.emplaceBack(0,1,2),t.emplaceBack(2,1,3),this.quadTriangleIndexBuffer=e.createIndexBuffer(t),this.context.gl);this.stencilClearMode=new L({func:e.ALWAYS,mask:0},0,255,e.ZERO,e.ZERO,e.ZERO)}clearStencil(){var e=this.context,t=e.gl,r=(this.nextStencilID=1,this.currentStencilSource=void 0,de.create());de.ortho(r,0,this.width,this.height,0,0,1),de.scale(r,r,[t.drawingBufferWidth,t.drawingBufferHeight,0]),this.useProgram("clippingMask").draw(e,t.TRIANGLES,ge.disabled,this.stencilClearMode,O.disabled,B.disabled,Pt(r),null,"$clipping",this.viewportBuffer,this.quadTriangleIndexBuffer,this.viewportSegments)}_renderTileClippingMasks(e,t){if(this.currentStencilSource!==e.source&&e.isTileClipped()&&t&&t.length){this.currentStencilSource=e.source;var r=this.context,i=r.gl,n=(256<this.nextStencilID+t.length&&this.clearStencil(),r.setColorMode(O.disabled),r.setDepthMode(ge.disabled),this.useProgram("clippingMask"));this._tileClippingMaskIDs={};for(const s of t){var o=this._tileClippingMaskIDs[s.key]=this.nextStencilID++,a=this.style.map.terrain&&this.style.map.terrain.getTerrainData(s);n.draw(r,i.TRIANGLES,ge.disabled,new L({func:i.ALWAYS,mask:0},o,255,i.KEEP,i.KEEP,i.REPLACE),O.disabled,B.disabled,Pt(s.posMatrix),a,"$clipping",this.tileExtentBuffer,this.quadTriangleIndexBuffer,this.tileExtentSegments)}}}stencilModeFor3D(){this.currentStencilSource=void 0,256<this.nextStencilID+1&&this.clearStencil();var e=this.nextStencilID++,t=this.context.gl;return new L({func:t.NOTEQUAL,mask:255},e,255,t.KEEP,t.KEEP,t.REPLACE)}stencilModeForClipping(e){var t=this.context.gl;return new L({func:t.EQUAL,mask:255},this._tileClippingMaskIDs[e.key],0,t.KEEP,t.KEEP,t.REPLACE)}stencilConfigForOverlap(e){var t=this.context.gl,e=e.sort((e,t)=>t.overscaledZ-e.overscaledZ),r=e[e.length-1].overscaledZ,i=e[0].overscaledZ-r+1;if(1<i){this.currentStencilSource=void 0,256<this.nextStencilID+i&&this.clearStencil();var n={};for(let e=0;e<i;e++)n[e+r]=new L({func:t.GEQUAL,mask:255},e+this.nextStencilID,255,t.KEEP,t.KEEP,t.REPLACE);return this.nextStencilID+=i,[n,e]}return[{[r]:L.disabled},e]}colorModeForRenderPass(){var e=this.context.gl;return this._showOverdrawInspector?(0,new O([e.CONSTANT_COLOR,e.ONE],new de.Color(1/8,1/8,1/8,0),[!0,!0,!0,!0])):"opaque"===this.renderPass?O.unblended:O.alphaBlended}depthModeForSublayer(e,t,r){return this.opaquePassEnabledForLayer()?(e=1-((1+this.currentLayer)*this.numSublayers+e)*this.depthEpsilon,new ge(r||this.context.gl.LEQUAL,t,[e,e])):ge.disabled}opaquePassEnabledForLayer(){return this.currentLayer<this.opaquePassCutoff}render(e,t){this.style=e,this.options=t,this.lineAtlas=e.lineAtlas,this.imageManager=e.imageManager,this.glyphManager=e.glyphManager,this.symbolFadeChange=e.placement.symbolFadeChange(M.now()),this.imageManager.beginFrame();var r=this.style._order,i=this.style.sourceCaches,n={},o={},a={};for(const y in i){var s=i[y];s.used&&s.prepare(this.context),n[y]=s.getVisibleCoordinates(),o[y]=n[y].slice().reverse(),a[y]=s.getVisibleCoordinates(!0).reverse()}this.opaquePassCutoff=1/0;for(let e=0;e<r.length;e++){var l=r[e];if(this.style._layers[l].is3D()){this.opaquePassCutoff=e;break}}this.maybeDrawDepthAndCoords(!1),this.renderToTexture&&(this.renderToTexture.prepareForRender(this.style,this.transform.zoom),this.opaquePassCutoff=0),this.renderPass="offscreen";for(const v of r){var c,u=this.style._layers[v];u.hasOffscreenPass()&&!u.isHidden(this.transform.zoom)&&(c=o[u.source],"custom"===u.type||c.length)&&this.renderLayer(this,i[u.source],u,c)}if(this.context.bindFramebuffer.set(null),this.context.clear({color:t.showOverdrawInspector?de.Color.black:de.Color.transparent,depth:1}),this.clearStencil(),this._showOverdrawInspector=t.showOverdrawInspector,this.depthRangeFor3D=[0,1-(e._order.length+2)*this.numSublayers*this.depthEpsilon],!this.renderToTexture)for(this.renderPass="opaque",this.currentLayer=r.length-1;0<=this.currentLayer;this.currentLayer--){var h=this.style._layers[r[this.currentLayer]],d=i[h.source],p=n[h.source];this._renderTileClippingMasks(h,p),this.renderLayer(this,d,h,p)}for(this.renderPass="translucent",this.currentLayer=0;this.currentLayer<r.length;this.currentLayer++){var f,m=this.style._layers[r[this.currentLayer]],g=i[m.source];this.renderToTexture&&this.renderToTexture.renderLayer(m)||(f=("symbol"===m.type?a:o)[m.source],this._renderTileClippingMasks(m,n[m.source]),this.renderLayer(this,g,m,f))}this.options.showTileBoundaries&&(t=function(t,r){let i=null;var e=(n=Object.values(t._layers).flatMap(e=>{return e.source&&!e.isHidden(r)?[t.sourceCaches[e.source]]:[]})).filter(e=>"vector"===e.getSource().type),n=n.filter(e=>"vector"!==e.getSource().type);const o=e=>{(!i||i.getSource().maxzoom<e.getSource().maxzoom)&&(i=e)};return e.forEach(e=>o(e)),i||n.forEach(e=>o(e)),i}(this.style,this.transform.zoom))&&ei(this,t,t.getVisibleCoordinates()),this.options.showPadding&&$r(this),this.context.setDefault()}maybeDrawDepthAndCoords(t){if(this.style&&this.style.map&&this.style.map.terrain){var r=this.terrainFacilitator.matrix,i=this.transform.projMatrix;let e=this.terrainFacilitator.dirty;if(e=(e=e||(t?!de.exactEquals(r,i):!de.equals(r,i)))||0<this.style.map.terrain.sourceCache.tilesAfterTime(this.terrainFacilitator.renderTime).length){de.copy(r,i),this.terrainFacilitator.renderTime=Date.now(),this.terrainFacilitator.dirty=!1;var n=this,o=this.style.map.terrain,a=n.context,s=a.gl,l=O.unblended,c=new ge(s.LEQUAL,ge.ReadWrite,[0,1]),u=o.getTerrainMesh(),t=o.sourceCache.getRenderableTiles(),h=n.useProgram("terrainDepth");a.bindFramebuffer.set(o.getFramebuffer("depth").framebuffer),a.viewport.set([0,0,n.width/devicePixelRatio,n.height/devicePixelRatio]),a.clear({color:de.Color.transparent,depth:1});for(const S of t){var d=o.getTerrainData(S.tileID),p={u_matrix:n.transform.calculatePosMatrix(S.tileID.toUnwrapped()),u_ele_delta:o.getMeshFrameDelta(n.transform.zoom)};h.draw(a,s.TRIANGLES,c,L.disabled,l,B.backCCW,p,d,"terrain",u.vertexBuffer,u.indexBuffer,u.segments)}a.bindFramebuffer.set(null),a.viewport.set([0,0,n.width,n.height]);var f=this,m=this.style.map.terrain,g=f.context,y=g.gl,v=O.unblended,_=new ge(y.LEQUAL,ge.ReadWrite,[0,1]),b=m.getTerrainMesh(),w=m.getCoordsTexture(),r=m.sourceCache.getRenderableTiles(),x=f.useProgram("terrainCoords");g.bindFramebuffer.set(m.getFramebuffer("coords").framebuffer),g.viewport.set([0,0,f.width/devicePixelRatio,f.height/devicePixelRatio]),g.clear({color:de.Color.transparent,depth:1}),m.coordsIndex=[];for(const E of r){var C=m.getTerrainData(E.tileID),T=(g.activeTexture.set(y.TEXTURE0),y.bindTexture(y.TEXTURE_2D,w.texture),f.transform.calculatePosMatrix(E.tileID.toUnwrapped())),T={u_matrix:T,u_terrain_coords_id:(255-m.coordsIndex.length)/255,u_texture:0,u_ele_delta:m.getMeshFrameDelta(f.transform.zoom)};x.draw(g,y.TRIANGLES,_,L.disabled,v,B.backCCW,T,C,"terrain",b.vertexBuffer,b.indexBuffer,b.segments),m.coordsIndex.push(E.tileID.key)}g.bindFramebuffer.set(null),g.viewport.set([0,0,f.width,f.height])}}}renderLayer(e,t,r,i){var n,o,a,s,l,c,u,h,d,p;if(!r.isHidden(this.transform.zoom)&&("background"===r.type||"custom"===r.type||(i||[]).length))switch(this.id=r.id,r.type){case"symbol":Lr(e,t,r,i,this.style.placement.variableOffsets);break;case"circle":Nr(e,t,r,i);break;case"heatmap":Br(e,t,r,i);break;case"line":Fr(e,t,r,i);break;case"fill":l=e,c=t,h=i,p=(u=r).paint.get("fill-color"),0!==(w=u.paint.get("fill-opacity")).constantOr(1)&&(T=l.colorModeForRenderPass(),d=u.paint.get("fill-pattern"),d=l.opaquePassEnabledForLayer()&&!d.constantOr(1)&&1===p.constantOr(de.Color.transparent).a&&1===w.constantOr(0)?"opaque":"translucent",l.renderPass===d&&(p=l.depthModeForSublayer(1,"opaque"===l.renderPass?ge.ReadWrite:ge.ReadOnly),qr(l,c,u,h,p,T,!1)),"translucent"===l.renderPass)&&u.paint.get("fill-antialias")&&(w=l.depthModeForSublayer(u.getPaintProperty("fill-outline-color")?2:0,ge.ReadOnly),qr(l,c,u,h,w,T,!0));break;case"fill-extrusion":d=e,p=t,l=i,0!==(u=(c=r).paint.get("fill-extrusion-opacity"))&&"translucent"===d.renderPass&&(h=new ge(d.context.gl.LEQUAL,ge.ReadWrite,d.depthRangeFor3D),1!==u||c.paint.get("fill-extrusion-pattern").constantOr(1)?(jr(d,p,c,l,h,L.disabled,O.disabled),jr(d,p,c,l,h,d.stencilModeFor3D(),d.colorModeForRenderPass())):(u=d.colorModeForRenderPass(),jr(d,p,c,l,h,L.disabled,u)));break;case"hillshade":Hr(e,t,r,i);break;case"raster":Vr(e,t,r,i);break;case"background":var f=e,m=r,g=i,y=m.paint.get("background-color"),v=m.paint.get("background-opacity");if(0!==v){var _=f.context,b=_.gl,w=f.transform,x=w.tileSize,C=m.paint.get("background-pattern");if(!f.isPatternMissing(C)){var T=!C&&1===y.a&&1===v&&f.opaquePassEnabledForLayer()?"opaque":"translucent";if(f.renderPass===T){var S=L.disabled,E=f.depthModeForSublayer(0,"opaque"==T?ge.ReadWrite:ge.ReadOnly),I=f.colorModeForRenderPass(),A=f.useProgram(C?"backgroundPattern":"background"),T=g||w.coveringTiles({tileSize:x,terrain:f.style.map.terrain}),k=(C&&(_.activeTexture.set(b.TEXTURE0),f.imageManager.bind(f.context)),m.getCrossfadeParameters());for(const R of T){var P=g?R.posMatrix:f.transform.calculatePosMatrix(R.toUnwrapped()),P=C?qt(P,v,f,C,{tileID:R,tileSize:x},k):{u_matrix:P,u_opacity:v,u_color:y},M=f.style.map.terrain&&f.style.map.terrain.getTerrainData(R);A.draw(_,b.TRIANGLES,E,S,I,B.disabled,P,M,m.id,f.tileExtentBuffer,f.quadTriangleIndexBuffer,f.tileExtentSegments)}}}}break;case"custom":o=r,s=(n=e).context,o=o.implementation,"offscreen"===n.renderPass?(a=o.prerender)&&(n.setCustomLayerDefaults(),s.setColorMode(n.colorModeForRenderPass()),a.call(o,s.gl,n.transform.customLayerMatrix()),s.setDirty(),n.setBaseState()):"translucent"===n.renderPass&&(n.setCustomLayerDefaults(),s.setColorMode(n.colorModeForRenderPass()),s.setStencilMode(L.disabled),a="3d"===o.renderingMode?new ge(n.context.gl.LEQUAL,ge.ReadWrite,n.depthRangeFor3D):n.depthModeForSublayer(0,ge.ReadOnly),s.setDepthMode(a),o.render(s.gl,n.transform.customLayerMatrix()),s.setDirty(),n.setBaseState(),s.bindFramebuffer.set(null))}}translatePosMatrix(e,t,r,i,n){var o;return r[0]||r[1]?((i=n?"map"===i?this.transform.angle:0:"viewport"===i?-this.transform.angle:0)&&(o=Math.sin(i),i=Math.cos(i),r=[r[0]*i-r[1]*o,r[0]*o+r[1]*i]),o=[n?r[0]:me(t,r[0],this.transform.zoom),n?r[1]:me(t,r[1],this.transform.zoom),0],i=new Float32Array(16),de.translate(i,e,o),i):e}saveTileTexture(e){var t=this._tileTextures[e.size[0]];t?t.push(e):this._tileTextures[e.size[0]]=[e]}getTileTexture(e){e=this._tileTextures[e];return e&&0<e.length?e.pop():null}isPatternMissing(e){var t;return!(!e||e.from&&e.to&&(t=this.imageManager.getPattern(e.from.toString()),e=this.imageManager.getPattern(e.to.toString()),t)&&e)}useProgram(e,t){this.cache=this.cache||{};var r=e+(t?t.cacheKey:"")+(this._showOverdrawInspector?"/overdraw":"")+(this.style.map.terrain?"/terrain":"");return this.cache[r]||(this.cache[r]=new _t(this.context,g[e],t,jt[e],this._showOverdrawInspector,this.style.map.terrain)),this.cache[r]}setCustomLayerDefaults(){this.context.unbindVAO(),this.context.cullFace.setDefault(),this.context.activeTexture.setDefault(),this.context.pixelStoreUnpack.setDefault(),this.context.pixelStoreUnpackPremultiplyAlpha.setDefault(),this.context.pixelStoreUnpackFlipY.setDefault()}setBaseState(){var e=this.context.gl;this.context.cullFace.set(!1),this.context.viewport.set([0,0,this.width,this.height]),this.context.blendEquation.set(e.FUNC_ADD)}initDebugOverlayCanvas(){var e;null==this.debugOverlayCanvas&&(this.debugOverlayCanvas=document.createElement("canvas"),this.debugOverlayCanvas.width=512,this.debugOverlayCanvas.height=512,e=this.context.gl,this.debugOverlayTexture=new N(this.context,this.debugOverlayCanvas,e.RGBA))}destroy(){this.debugOverlayTexture&&this.debugOverlayTexture.destroy()}overLimit(){var{drawingBufferWidth:e,drawingBufferHeight:t}=this.context.gl;return this.width!==e||this.height!==t}}class ii{constructor(e,t){this.points=e,this.planes=t}static fromInvProjectionMatrix(r,i,e){const n=Math.pow(2,e),o=[[-1,1,-1,1],[1,1,-1,1],[1,-1,-1,1],[-1,-1,-1,1],[-1,1,1,1],[1,1,1,1],[1,-1,1,1],[-1,-1,1,1]].map(e=>{var t=1/(e=de.transformMat4([],e,r))[3]/i*n;return de.mul$1(e,e,[t,t,1/e[3],t])});e=[[0,1,2],[6,5,4],[0,3,7],[2,1,5],[3,2,6],[0,4,5]].map(e=>{var t=de.sub([],o[e[0]],o[e[1]]),r=de.sub([],o[e[2]],o[e[1]]),t=de.normalize([],de.cross([],t,r)),r=-de.dot(t,o[e[1]]);return t.concat(r)});return new ii(o,e)}}class ni{constructor(e,t){this.min=e,this.max=t,this.center=de.scale$1([],de.add([],this.min,this.max),.5)}quadrant(e){var t=[e%2==0,e<2],r=de.clone$2(this.min),i=de.clone$2(this.max);for(let e=0;e<t.length;e++)r[e]=(t[e]?this.min:this.center)[e],i[e]=(t[e]?this.center:this.max)[e];return i[2]=this.max[2],new ni(r,i)}distanceX(e){return Math.max(Math.min(this.max[0],e[0]),this.min[0])-e[0]}distanceY(e){return Math.max(Math.min(this.max[1],e[1]),this.min[1])-e[1]}intersects(n){var r=[[this.min[0],this.min[1],this.min[2],1],[this.max[0],this.min[1],this.min[2],1],[this.max[0],this.max[1],this.min[2],1],[this.min[0],this.max[1],this.min[2],1],[this.min[0],this.min[1],this.max[2],1],[this.max[0],this.min[1],this.max[2],1],[this.max[0],this.max[1],this.max[2],1],[this.min[0],this.max[1],this.max[2],1]];let i=!0;for(let e=0;e<n.planes.length;e++){var o=n.planes[e];let t=0;for(let e=0;e<r.length;e++)0<=de.dot$1(o,r[e])&&t++;if(0===t)return 0;t!==r.length&&(i=!1)}if(i)return 2;for(let i=0;i<3;i++){let t=Number.MAX_VALUE,r=-Number.MAX_VALUE;for(let e=0;e<n.points.length;e++){var a=n.points[e][i]-this.min[i];t=Math.min(t,a),r=Math.max(r,a)}if(r<0||t>this.max[i]-this.min[i])return 0}return 1}}class oi{constructor(e=0,t=0,r=0,i=0){if(isNaN(e)||e<0||isNaN(t)||t<0||isNaN(r)||r<0||isNaN(i)||i<0)throw new Error("Invalid value for edge-insets, top, bottom, left and right must all be numbers");this.top=e,this.bottom=t,this.left=r,this.right=i}interpolate(e,t,r){return null!=t.top&&null!=e.top&&(this.top=de.interpolate.number(e.top,t.top,r)),null!=t.bottom&&null!=e.bottom&&(this.bottom=de.interpolate.number(e.bottom,t.bottom,r)),null!=t.left&&null!=e.left&&(this.left=de.interpolate.number(e.left,t.left,r)),null!=t.right&&null!=e.right&&(this.right=de.interpolate.number(e.right,t.right,r)),this}getCenter(e,t){e=de.clamp((this.left+e-this.right)/2,0,e),t=de.clamp((this.top+t-this.bottom)/2,0,t);return new de.Point(e,t)}equals(e){return this.top===e.top&&this.bottom===e.bottom&&this.left===e.left&&this.right===e.right}clone(){return new oi(this.top,this.bottom,this.left,this.right)}toJSON(){return{top:this.top,bottom:this.bottom,left:this.left,right:this.right}}}const ai=85.051129;class si{constructor(e,t,r,i,n){this.tileSize=512,this._renderWorldCopies=void 0===n||!!n,this._minZoom=e||0,this._maxZoom=t||22,this._minPitch=null==r?0:r,this._maxPitch=null==i?60:i,this.setMaxBounds(),this.width=0,this.height=0,this._center=new de.LngLat(0,0),this._elevation=0,this.zoom=0,this.angle=0,this._fov=.6435011087932844,this._pitch=0,this._unmodified=!0,this._edgeInsets=new oi,this._posMatrixCache={},this._alignedPosMatrixCache={},this.minElevationForCurrentTile=0}clone(){var e=new si(this._minZoom,this._maxZoom,this._minPitch,this.maxPitch,this._renderWorldCopies);return e.apply(this),e}apply(e){this.tileSize=e.tileSize,this.latRange=e.latRange,this.width=e.width,this.height=e.height,this._center=e._center,this._elevation=e._elevation,this.minElevationForCurrentTile=e.minElevationForCurrentTile,this.zoom=e.zoom,this.angle=e.angle,this._fov=e._fov,this._pitch=e._pitch,this._unmodified=e._unmodified,this._edgeInsets=e._edgeInsets.clone(),this._calcMatrices()}get minZoom(){return this._minZoom}set minZoom(e){this._minZoom!==e&&(this._minZoom=e,this.zoom=Math.max(this.zoom,e))}get maxZoom(){return this._maxZoom}set maxZoom(e){this._maxZoom!==e&&(this._maxZoom=e,this.zoom=Math.min(this.zoom,e))}get minPitch(){return this._minPitch}set minPitch(e){this._minPitch!==e&&(this._minPitch=e,this.pitch=Math.max(this.pitch,e))}get maxPitch(){return this._maxPitch}set maxPitch(e){this._maxPitch!==e&&(this._maxPitch=e,this.pitch=Math.min(this.pitch,e))}get renderWorldCopies(){return this._renderWorldCopies}set renderWorldCopies(e){void 0===e?e=!0:null===e&&(e=!1),this._renderWorldCopies=e}get worldSize(){return this.tileSize*this.scale}get centerOffset(){return this.centerPoint._sub(this.size._div(2))}get size(){return new de.Point(this.width,this.height)}get bearing(){return-this.angle/Math.PI*180}set bearing(e){e=-de.wrap(e,-180,180)*Math.PI/180;this.angle!==e&&(this._unmodified=!1,this.angle=e,this._calcMatrices(),this.rotationMatrix=de.create$2(),de.rotate(this.rotationMatrix,this.rotationMatrix,this.angle))}get pitch(){return this._pitch/Math.PI*180}set pitch(e){e=de.clamp(e,this.minPitch,this.maxPitch)/180*Math.PI;this._pitch!==e&&(this._unmodified=!1,this._pitch=e,this._calcMatrices())}get fov(){return this._fov/Math.PI*180}set fov(e){e=Math.max(.01,Math.min(60,e)),this._fov!==e&&(this._unmodified=!1,this._fov=e/180*Math.PI,this._calcMatrices())}get zoom(){return this._zoom}set zoom(e){e=Math.min(Math.max(e,this.minZoom),this.maxZoom);this._zoom!==e&&(this._unmodified=!1,this._zoom=e,this.tileZoom=Math.max(0,Math.floor(e)),this.scale=this.zoomScale(e),this._constrain(),this._calcMatrices())}get center(){return this._center}set center(e){e.lat===this._center.lat&&e.lng===this._center.lng||(this._unmodified=!1,this._center=e,this._constrain(),this._calcMatrices())}get elevation(){return this._elevation}set elevation(e){e!==this._elevation&&(this._elevation=e,this._constrain(),this._calcMatrices())}get padding(){return this._edgeInsets.toJSON()}set padding(e){this._edgeInsets.equals(e)||(this._unmodified=!1,this._edgeInsets.interpolate(this._edgeInsets,e,1),this._calcMatrices())}get centerPoint(){return this._edgeInsets.getCenter(this.width,this.height)}isPaddingEqual(e){return this._edgeInsets.equals(e)}interpolatePadding(e,t,r){this._unmodified=!1,this._edgeInsets.interpolate(e,t,r),this._constrain(),this._calcMatrices()}coveringZoomLevel(e){e=(e.roundZoom?Math.round:Math.floor)(this.zoom+this.scaleZoom(this.tileSize/e.tileSize));return Math.max(0,e)}getVisibleUnwrappedCoordinates(t){var r=[new de.UnwrappedTileID(0,t)];if(this._renderWorldCopies){var e=this.pointCoordinate(new de.Point(0,0)),i=this.pointCoordinate(new de.Point(this.width,0)),n=this.pointCoordinate(new de.Point(this.width,this.height)),o=this.pointCoordinate(new de.Point(0,this.height)),a=Math.floor(Math.min(e.x,i.x,n.x,o.x)),s=Math.floor(Math.max(e.x,i.x,n.x,o.x));for(let e=a-1;e<=s+1;e++)0!==e&&r.push(new de.UnwrappedTileID(e,t))}return r}coveringTiles(i){let e=this.coveringZoomLevel(i);var t=e;if(void 0!==i.minzoom&&e<i.minzoom)return[];void 0!==i.maxzoom&&e>i.maxzoom&&(e=i.maxzoom);var r=this.pointCoordinate(this.getCameraPoint()),n=de.MercatorCoordinate.fromLngLat(this.center);const o=Math.pow(2,e);var a=[o*r.x,o*r.y,0],s=[o*n.x,o*n.y,0],l=ii.fromInvProjectionMatrix(this.invProjMatrix,this.worldSize,e);let c=i.minzoom||0;!i.terrain&&this.pitch<=60&&this._edgeInsets.top<.1&&(c=e);var u=i.terrain?2/Math.min(this.tileSize,i.tileSize)*this.tileSize:3,h=e=>({aabb:new ni([e*o,0,0],[(e+1)*o,o,0]),zoom:0,x:0,y:0,wrap:e,fullyVisible:!1}),d=[],p=[],f=e,m=i.reparseOverscaled?t:e;if(this._renderWorldCopies)for(let e=1;e<=3;e++)d.push(h(-e)),d.push(h(e));for(d.push(h(0));0<d.length;){var g=d.pop(),y=g.x,v=g.y;let r=g.fullyVisible;if(!r){var _=g.aabb.intersects(l);if(0===_)continue;r=2===_}var _=i.terrain?a:s,b=g.aabb.distanceX(_),w=g.aabb.distanceY(_),b=Math.max(Math.abs(b),Math.abs(w)),w=u+(1<<f-g.zoom)-2;if(g.zoom===f||w<b&&g.zoom>=c){w=f-g.zoom,b=a[0]-.5-(y<<w),w=a[1]-.5-(v<<w);p.push({tileID:new de.OverscaledTileID(g.zoom===f?m:g.zoom,g.wrap,g.zoom,y,v),distanceSq:de.sqrLen([s[0]-.5-y,s[1]-.5-v]),tileDistanceToCamera:Math.sqrt(b*b+w*w)})}else for(let t=0;t<4;t++){var x,C,T=(y<<1)+t%2,S=(v<<1)+(t>>1),E=g.zoom+1;let e=g.aabb.quadrant(t);i.terrain&&(C=new de.OverscaledTileID(E,g.wrap,E,T,S),x=null!=(x=(C=i.terrain.getMinMaxElevation(C)).minElevation)?x:this.elevation,C=null!=(C=C.maxElevation)?C:this.elevation,e=new ni([e.min[0],e.min[1],x],[e.max[0],e.max[1],C])),d.push({aabb:e,zoom:E,x:T,y:S,wrap:g.wrap,fullyVisible:r})}}return p.sort((e,t)=>e.distanceSq-t.distanceSq).map(e=>e.tileID)}resize(e,t){this.width=e,this.height=t,this.pixelsToGLUnits=[2/e,-2/t],this._constrain(),this._calcMatrices()}get unmodified(){return this._unmodified}zoomScale(e){return Math.pow(2,e)}scaleZoom(e){return Math.log(e)/Math.LN2}project(e){var t=de.clamp(e.lat,-ai,ai);return new de.Point(de.mercatorXfromLng(e.lng)*this.worldSize,de.mercatorYfromLat(t)*this.worldSize)}unproject(e){return new de.MercatorCoordinate(e.x/this.worldSize,e.y/this.worldSize).toLngLat()}get point(){return this.project(this.center)}getCameraPosition(){return{lngLat:this.pointLocation(this.getCameraPoint()),altitude:Math.cos(this._pitch)*this.cameraToCenterDistance/this._pixelPerMeter+this.elevation}}recalculateZoom(e){var t=this.elevation,r=Math.cos(this._pitch)*this.cameraToCenterDistance/this._pixelPerMeter,i=this.pointLocation(this.centerPoint,e),e=e.getElevationForLngLatZoom(i,this.tileZoom);this.elevation-e&&(r=r+t-e,t=Math.cos(this._pitch)*this.cameraToCenterDistance/r/de.mercatorZfromAltitude(1,i.lat)/this.tileSize,r=this.scaleZoom(t),this._elevation=e,this._center=i,this.zoom=r)}setLocationAtPoint(e,t){var t=this.pointCoordinate(t),r=this.pointCoordinate(this.centerPoint),e=this.locationCoordinate(e),e=new de.MercatorCoordinate(e.x-(t.x-r.x),e.y-(t.y-r.y));this.center=this.coordinateLocation(e),this._renderWorldCopies&&(this.center=this.center.wrap())}locationPoint(e,t){return t?this.coordinatePoint(this.locationCoordinate(e),t.getElevationForLngLatZoom(e,this.tileZoom),this.pixelMatrix3D):this.coordinatePoint(this.locationCoordinate(e))}pointLocation(e,t){return this.coordinateLocation(this.pointCoordinate(e,t))}locationCoordinate(e){return de.MercatorCoordinate.fromLngLat(e)}coordinateLocation(e){return e&&e.toLngLat()}pointCoordinate(e,t){if(t){t=t.pointCoordinate(e);if(null!=t)return t}var t=[e.x,e.y,0,1],e=[e.x,e.y,1,1],r=(de.transformMat4(t,t,this.pixelMatrixInverse),de.transformMat4(e,e,this.pixelMatrixInverse),t[3]),i=e[3],n=t[1]/r,o=e[1]/i,a=t[2]/r,s=e[2]/i,s=a==s?0:(0-a)/(s-a);return new de.MercatorCoordinate(de.interpolate.number(t[0]/r,e[0]/i,s)/this.worldSize,de.interpolate.number(n,o,s)/this.worldSize)}coordinatePoint(e,t=0,r=this.pixelMatrix){e=[e.x*this.worldSize,e.y*this.worldSize,t,1];return de.transformMat4(e,e,r),new de.Point(e[0]/e[3],e[1]/e[3])}getBounds(){var e=Math.max(0,this.height/2-this.getHorizon());return(new d).extend(this.pointLocation(new de.Point(0,e))).extend(this.pointLocation(new de.Point(this.width,e))).extend(this.pointLocation(new de.Point(this.width,this.height))).extend(this.pointLocation(new de.Point(0,this.height)))}getMaxBounds(){return this.latRange&&2===this.latRange.length&&this.lngRange&&2===this.lngRange.length?new d([this.lngRange[0],this.latRange[0]],[this.lngRange[1],this.latRange[1]]):null}getHorizon(){return Math.tan(Math.PI/2-this._pitch)*this.cameraToCenterDistance*.85}setMaxBounds(e){e?(this.lngRange=[e.getWest(),e.getEast()],this.latRange=[e.getSouth(),e.getNorth()],this._constrain()):(this.lngRange=null,this.latRange=[-ai,ai])}calculatePosMatrix(e,t=!1){var r,i,n,o=e.key,a=t?this._alignedPosMatrixCache:this._posMatrixCache;return a[o]||(r=e.canonical,i=this.worldSize/this.zoomScale(r.z),e=r.x+Math.pow(2,r.z)*e.wrap,n=de.identity(new Float64Array(16)),de.translate(n,n,[e*i,r.y*i,0]),de.scale(n,n,[i/de.EXTENT,i/de.EXTENT,1]),de.multiply(n,t?this.alignedProjMatrix:this.projMatrix,n),a[o]=new Float32Array(n)),a[o]}customLayerMatrix(){return this.mercatorMatrix.slice()}getConstrained(e,t){t=de.clamp(+t,this.minZoom,this.maxZoom);t={center:new de.LngLat(e.lng,e.lat),zoom:t};let r=this.lngRange;this._renderWorldCopies||null!==r||(r=[-(180-1e-10),180-1e-10]);var i=this.tileSize*this.zoomScale(t.zoom);let n=0,o=i,a=0,s=i,l=0,c=0;var{x:u,y:h}=this.size,{x:d,y:e}=(this.latRange&&(d=this.latRange,n=de.mercatorYfromLat(d[1])*i,(o=de.mercatorYfromLat(d[0])*i)-n<h)&&(l=h/(o-n)),r&&(a=de.wrap(de.mercatorXfromLng(r[0])*i,0,i),(s=de.wrap(de.mercatorXfromLng(r[1])*i,0,i))<a&&(s+=i),s-a<u)&&(c=u/(s-a)),this.project.call({worldSize:i},e));let p,f;var m,g=Math.max(c||0,l||0);if(g)m=new de.Point(c?(s+a)/2:d,l?(o+n)/2:e),t.center=this.unproject.call({worldSize:i},m).wrap(),t.zoom+=this.scaleZoom(g);else{if(this.latRange&&(e-(m=h/2)<n&&(f=n+m),e+m>o)&&(f=o-m),r){g=(a+s)/2;let e=d;h=u/2;(e=this._renderWorldCopies?de.wrap(d,g-i/2,g+i/2):e)-h<a&&(p=a+h),e+h>s&&(p=s-h)}void 0===p&&void 0===f||(m=new de.Point(null!==p&&void 0!==p?p:d,null!==f&&void 0!==f?f:e),t.center=this.unproject.call({worldSize:i},m).wrap())}return t}_constrain(){var e,t,r;this.center&&this.width&&this.height&&!this._constraining&&(this._constraining=!0,e=this._unmodified,{center:t,zoom:r}=this.getConstrained(this.center,this.zoom),this.center=t,this.zoom=r,this._unmodified=e,this._constraining=!1)}_calcMatrices(){if(this.height){var t=this._fov/2,r=this.centerOffset,i=this.point.x,n=this.point.y;this.cameraToCenterDistance=.5/Math.tan(t)*this.height,this._pixelPerMeter=de.mercatorZfromAltitude(1,this.center.lat)*this.worldSize;let e=de.identity(new Float64Array(16));de.scale(e,e,[this.width/2,-this.height/2,1]),de.translate(e,e,[1,-1,0]),this.labelPlaneMatrix=e,e=de.identity(new Float64Array(16)),de.scale(e,e,[1,-1,1]),de.translate(e,e,[-1,-1,0]),de.scale(e,e,[2/this.width,2/this.height,1]),this.glCoordMatrix=e;var t=this.cameraToCenterDistance+this._elevation*this._pixelPerMeter/Math.cos(this._pitch),o=Math.min(this.elevation,this.minElevationForCurrentTile),a=t-o*this._pixelPerMeter/Math.cos(this._pitch),o=o<0?a:t,a=Math.PI/2+this._pitch,t=this._fov*(.5+r.y/this.height),t=Math.sin(t)*o/Math.sin(de.clamp(Math.PI-a-t,.01,Math.PI-.01)),s=this.getHorizon(),s=2*Math.atan(s/this.cameraToCenterDistance)*(.5+r.y/(2*s)),a=Math.sin(s)*o/Math.sin(de.clamp(Math.PI-a-s,.01,Math.PI-.01)),s=Math.min(t,a),t=1.01*(Math.cos(Math.PI/2-this._pitch)*s+o),a=this.height/50,s=(e=new Float64Array(16),de.perspective(e,this._fov,this.width/this.height,a,t),e[8]=2*-r.x/this.width,e[9]=2*r.y/this.height,de.scale(e,e,[1,-1,1]),de.translate(e,e,[0,0,-this.cameraToCenterDistance]),de.rotateX(e,e,this._pitch),de.rotateZ(e,e,this.angle),de.translate(e,e,[-i,-n,0]),this.mercatorMatrix=de.scale([],e,[this.worldSize,this.worldSize,this.worldSize]),de.scale(e,e,[1,1,this._pixelPerMeter]),this.pixelMatrix=de.multiply(new Float64Array(16),this.labelPlaneMatrix,e),de.translate(e,e,[0,0,-this.elevation]),this.projMatrix=e,this.invProjMatrix=de.invert([],e),this.pixelMatrix3D=de.multiply(new Float64Array(16),this.labelPlaneMatrix,e),this.width%2/2),o=this.height%2/2,a=Math.cos(this.angle),t=Math.sin(this.angle),r=i-Math.round(i)+a*s+t*o,i=n-Math.round(n)+a*o+t*s,n=new Float64Array(e);if(de.translate(n,n,[.5<r?r-1:r,.5<i?i-1:i,0]),this.alignedProjMatrix=n,!(e=de.invert(new Float64Array(16),this.pixelMatrix)))throw new Error("failed to invert matrix");this.pixelMatrixInverse=e,this._posMatrixCache={},this._alignedPosMatrixCache={}}}maxPitchScaleFactor(){var e;return this.pixelMatrixInverse?(e=[(e=this.pointCoordinate(new de.Point(0,0))).x*this.worldSize,e.y*this.worldSize,0,1],de.transformMat4(e,e,this.pixelMatrix)[3]/this.cameraToCenterDistance):1}getCameraPoint(){var e=this._pitch,e=Math.tan(e)*(this.cameraToCenterDistance||1);return this.centerPoint.add(new de.Point(0,e))}getCameraQueryGeometry(n){var o=this.getCameraPoint();if(1===n.length)return[n[0],o];{let e=o.x,t=o.y,r=o.x,i=o.y;for(const a of n)e=Math.min(e,a.x),t=Math.min(t,a.y),r=Math.max(r,a.x),i=Math.max(i,a.y);return[new de.Point(e,t),new de.Point(r,t),new de.Point(r,i),new de.Point(e,i),new de.Point(e,t)]}}lngLatToCameraDepth(e,t){e=this.locationCoordinate(e),e=[e.x*this.worldSize,e.y*this.worldSize,t,1];return de.transformMat4(e,e,this.projMatrix),e[2]/e[3]}}function li(e,t){let r=!1,i=null,n,o;const a=()=>{i=null,r&&(e.apply(n,o),i=setTimeout(a,t),r=!1)};return(...e)=>(r=!0,n=this,o=e,i||a(),i)}class ci{constructor(e){this._getCurrentHash=()=>{var e=window.location.hash.replace("#","");if(this._hashName){let t;return e.split("&").map(e=>e.split("=")).forEach(e=>{e[0]===this._hashName&&(t=e)}),(t&&t[1]||"").split("/")}return e.split("/")},this._onHashChange=()=>{var e,t=this._getCurrentHash();return 3<=t.length&&!t.some(e=>isNaN(e))&&(e=this._map.dragRotate.isEnabled()&&this._map.touchZoomRotate.isEnabled()?+(t[3]||0):this._map.getBearing(),this._map.jumpTo({center:[+t[2],+t[1]],zoom:+t[0],bearing:e,pitch:+(t[4]||0)}),!0)},this._updateHashUnthrottled=()=>{var e=window.location.href.replace(/(#.+)?$/,this.getHashString());try{window.history.replaceState(window.history.state,null,e)}catch(e){}},this._updateHash=li(this._updateHashUnthrottled,300),this._hashName=e&&encodeURIComponent(e)}addTo(e){return this._map=e,addEventListener("hashchange",this._onHashChange,!1),this._map.on("moveend",this._updateHash),this}remove(){return removeEventListener("hashchange",this._onHashChange,!1),this._map.off("moveend",this._updateHash),clearTimeout(this._updateHash()),delete this._map,this}getHashString(e){var t=this._map.getCenter(),r=Math.round(100*this._map.getZoom())/100,i=Math.ceil((r*Math.LN2+Math.log(512/360/.5))/Math.LN10),i=Math.pow(10,i),n=Math.round(t.lng*i)/i,t=Math.round(t.lat*i)/i,i=this._map.getBearing(),o=this._map.getPitch();let a="";if(a+=e?`/${n}/${t}/`+r:r+`/${t}/`+n,(i||o)&&(a+="/"+Math.round(10*i)/10),o&&(a+="/"+Math.round(o)),this._hashName){const s=this._hashName;let r=!1;e=window.location.hash.slice(1).split("&").map(e=>{var t=e.split("=")[0];return t===s?(r=!0,t+"="+a):e}).filter(e=>e);return r||e.push(s+"="+a),"#"+e.join("&")}return"#"+a}}t={linearity:.3,easing:de.bezier(0,0,.3,1)};const ui=de.extend({deceleration:2500,maxSpeed:1400},t),hi=de.extend({deceleration:20,maxSpeed:1400},t),di=de.extend({deceleration:1e3,maxSpeed:360},t),pi=de.extend({deceleration:1e3,maxSpeed:90},t);class fi{constructor(e){this._map=e,this.clear()}clear(){this._inertiaBuffer=[]}record(e){this._drainInertiaBuffer(),this._inertiaBuffer.push({time:M.now(),settings:e})}_drainInertiaBuffer(){for(var e=this._inertiaBuffer,t=M.now();0<e.length&&160<t-e[0].time;)e.shift()}_onMoveEnd(e){if(this._drainInertiaBuffer(),!(this._inertiaBuffer.length<2)){var t,r={zoom:0,bearing:0,pitch:0,pan:new de.Point(0,0),pinchAround:void 0,around:void 0};for({settings:t}of this._inertiaBuffer)r.zoom+=t.zoomDelta||0,r.bearing+=t.bearingDelta||0,r.pitch+=t.pitchDelta||0,t.panDelta&&r.pan._add(t.panDelta),t.around&&(r.around=t.around),t.pinchAround&&(r.pinchAround=t.pinchAround);var i=this._inertiaBuffer[this._inertiaBuffer.length-1].time-this._inertiaBuffer[0].time,n={};return r.pan.mag()&&(e=gi(r.pan.mag(),i,de.extend({},ui,e||{})),n.offset=r.pan.mult(e.amount/r.pan.mag()),n.center=this._map.transform.center,mi(n,e)),r.zoom&&(e=gi(r.zoom,i,hi),n.zoom=this._map.transform.zoom+e.amount,mi(n,e)),r.bearing&&(e=gi(r.bearing,i,di),n.bearing=this._map.transform.bearing+de.clamp(e.amount,-179,179),mi(n,e)),r.pitch&&(e=gi(r.pitch,i,pi),n.pitch=this._map.transform.pitch+e.amount,mi(n,e)),(n.zoom||n.bearing)&&(n.around=(i=void 0===r.pinchAround?r.around:r.pinchAround)?this._map.unproject(i):this._map.getCenter()),this.clear(),de.extend(n,{noMoveStart:!0})}}}function mi(e,t){(!e.duration||e.duration<t.duration)&&(e.duration=t.duration,e.easing=t.easing)}function gi(e,t,r){var{maxSpeed:i,linearity:n,deceleration:o}=r,e=de.clamp(e*n/(t/1e3),-i,i),t=Math.abs(e)/(o*n);return{easing:r.easing,duration:1e3*t,amount:e*(t/2)}}class l extends de.Event{preventDefault(){this._defaultPrevented=!0}get defaultPrevented(){return this._defaultPrevented}constructor(e,t,r,i={}){var n=f.mousePos(t.getCanvas(),r),o=t.unproject(n);super(e,de.extend({point:n,lngLat:o,originalEvent:r},i)),this._defaultPrevented=!1,this.target=t}}class u extends de.Event{preventDefault(){this._defaultPrevented=!0}get defaultPrevented(){return this._defaultPrevented}constructor(e,t,r){var i="touchend"===e?r.changedTouches:r.touches,i=f.touchPos(t.getCanvasContainer(),i),n=i.map(e=>t.unproject(e)),o=i.reduce((e,t,r,i)=>e.add(t.div(i.length)),new de.Point(0,0));super(e,{points:i,point:o,lngLats:n,lngLat:t.unproject(o),originalEvent:r}),this._defaultPrevented=!1}}class yi extends de.Event{preventDefault(){this._defaultPrevented=!0}get defaultPrevented(){return this._defaultPrevented}constructor(e,t,r){super(e,{originalEvent:r}),this._defaultPrevented=!1}}class vi{constructor(e,t){this._map=e,this._clickTolerance=t.clickTolerance}reset(){delete this._mousedownPos}wheel(e){return this._firePreventable(new yi(e.type,this._map,e))}mousedown(e,t){return this._mousedownPos=t,this._firePreventable(new l(e.type,this._map,e))}mouseup(e){this._map.fire(new l(e.type,this._map,e))}click(e,t){this._mousedownPos&&this._mousedownPos.dist(t)>=this._clickTolerance||this._map.fire(new l(e.type,this._map,e))}dblclick(e){return this._firePreventable(new l(e.type,this._map,e))}mouseover(e){this._map.fire(new l(e.type,this._map,e))}mouseout(e){this._map.fire(new l(e.type,this._map,e))}touchstart(e){return this._firePreventable(new u(e.type,this._map,e))}touchmove(e){this._map.fire(new u(e.type,this._map,e))}touchend(e){this._map.fire(new u(e.type,this._map,e))}touchcancel(e){this._map.fire(new u(e.type,this._map,e))}_firePreventable(e){if(this._map.fire(e),e.defaultPrevented)return{}}isEnabled(){return!0}isActive(){return!1}enable(){}disable(){}}class _i{constructor(e){this._map=e}reset(){this._delayContextMenu=!1,this._ignoreContextMenu=!0,delete this._contextMenuEvent}mousemove(e){this._map.fire(new l(e.type,this._map,e))}mousedown(){this._delayContextMenu=!0,this._ignoreContextMenu=!1}mouseup(){this._delayContextMenu=!1,this._contextMenuEvent&&(this._map.fire(new l("contextmenu",this._map,this._contextMenuEvent)),delete this._contextMenuEvent)}contextmenu(e){this._delayContextMenu?this._contextMenuEvent=e:this._ignoreContextMenu||this._map.fire(new l(e.type,this._map,e)),this._map.listens("contextmenu")&&e.preventDefault()}isEnabled(){return!0}isActive(){return!1}enable(){}disable(){}}class m{constructor(e){this._map=e}get transform(){return this._map._requestedCameraState||this._map.transform}get center(){return{lng:this.transform.center.lng,lat:this.transform.center.lat}}get zoom(){return this.transform.zoom}get pitch(){return this.transform.pitch}get bearing(){return this.transform.bearing}unproject(e){return this.transform.pointLocation(de.Point.convert(e),this._map.terrain)}}class bi{constructor(e,t){this._map=e,this._tr=new m(e),this._el=e.getCanvasContainer(),this._container=e.getContainer(),this._clickTolerance=t.clickTolerance||1}isEnabled(){return!!this._enabled}isActive(){return!!this._active}enable(){this.isEnabled()||(this._enabled=!0)}disable(){this.isEnabled()&&(this._enabled=!1)}mousedown(e,t){this.isEnabled()&&e.shiftKey&&0===e.button&&(f.disableDrag(),this._startPos=this._lastPos=t,this._active=!0)}mousemoveWindow(e,t){var r,i,n;!this._active||this._lastPos.equals(t=t)||!this._box&&t.dist(this._startPos)<this._clickTolerance||(n=this._startPos,this._lastPos=t,this._box||(this._box=f.create("div","maplibregl-boxzoom",this._container),this._container.classList.add("maplibregl-crosshair"),this._fireEvent("boxzoomstart",e)),e=Math.min(n.x,t.x),r=Math.max(n.x,t.x),i=Math.min(n.y,t.y),n=Math.max(n.y,t.y),f.setTransform(this._box,`translate(${e}px,${i}px)`),this._box.style.width=r-e+"px",this._box.style.height=n-i+"px")}mouseupWindow(e,t){if(this._active&&0===e.button){const r=this._startPos,i=t;if(this.reset(),f.suppressClick(),r.x!==i.x||r.y!==i.y)return this._map.fire(new de.Event("boxzoomend",{originalEvent:e})),{cameraAnimation:e=>e.fitScreenCoordinates(r,i,this._tr.bearing,{linear:!0})};this._fireEvent("boxzoomcancel",e)}}keydown(e){this._active&&27===e.keyCode&&(this.reset(),this._fireEvent("boxzoomcancel",e))}reset(){this._active=!1,this._container.classList.remove("maplibregl-crosshair"),this._box&&(f.remove(this._box),this._box=null),f.enableDrag(),delete this._startPos,delete this._lastPos}_fireEvent(e,t){return this._map.fire(new de.Event(e,{originalEvent:t}))}}function wi(t,r){if(t.length!==r.length)throw new Error(`The number of touches and points are not equal - touches ${t.length}, points `+r.length);var i={};for(let e=0;e<t.length;e++)i[t[e].identifier]=r[e];return i}class xi{constructor(e){this.reset(),this.numTouches=e.numTouches}reset(){delete this.centroid,delete this.startTime,delete this.touches,this.aborted=!1}touchstart(e,t,r){(this.centroid||r.length>this.numTouches)&&(this.aborted=!0),this.aborted||(void 0===this.startTime&&(this.startTime=e.timeStamp),r.length===this.numTouches&&(this.centroid=function(e){var t=new de.Point(0,0);for(const r of e)t._add(r);return t.div(e.length)}(t),this.touches=wi(r,t)))}touchmove(e,t,r){if(!this.aborted&&this.centroid){var i=wi(r,t);for(const a in this.touches){var n=this.touches[a],o=i[a];(!o||30<o.dist(n))&&(this.aborted=!0)}}}touchend(e,t,r){if((!this.centroid||500<e.timeStamp-this.startTime)&&(this.aborted=!0),0===r.length){e=!this.aborted&&this.centroid;if(this.reset(),e)return e}}}class Ci{constructor(e){this.singleTap=new xi(e),this.numTaps=e.numTaps,this.reset()}reset(){this.lastTime=1/0,delete this.lastTap,this.count=0,this.singleTap.reset()}touchstart(e,t,r){this.singleTap.touchstart(e,t,r)}touchmove(e,t,r){this.singleTap.touchmove(e,t,r)}touchend(e,t,r){t=this.singleTap.touchend(e,t,r);if(t){var r=e.timeStamp-this.lastTime<500,i=!this.lastTap||this.lastTap.dist(t)<30;if(r&&i||this.reset(),this.count++,this.lastTime=e.timeStamp,this.lastTap=t,this.count===this.numTaps)return this.reset(),t}}}class Ti{constructor(e){this._tr=new m(e),this._zoomIn=new Ci({numTouches:1,numTaps:2}),this._zoomOut=new Ci({numTouches:2,numTaps:1}),this.reset()}reset(){this._active=!1,this._zoomIn.reset(),this._zoomOut.reset()}touchstart(e,t,r){this._zoomIn.touchstart(e,t,r),this._zoomOut.touchstart(e,t,r)}touchmove(e,t,r){this._zoomIn.touchmove(e,t,r),this._zoomOut.touchmove(e,t,r)}touchend(t,e,r){const i=this._zoomIn.touchend(t,e,r),n=this._zoomOut.touchend(t,e,r),o=this._tr;return i?(this._active=!0,t.preventDefault(),setTimeout(()=>this.reset(),0),{cameraAnimation:e=>e.easeTo({duration:300,zoom:o.zoom+1,around:o.unproject(i)},{originalEvent:t})}):n?(this._active=!0,t.preventDefault(),setTimeout(()=>this.reset(),0),{cameraAnimation:e=>e.easeTo({duration:300,zoom:o.zoom-1,around:o.unproject(n)},{originalEvent:t})}):void 0}touchcancel(){this.reset()}enable(){this._enabled=!0}disable(){this._enabled=!1,this.reset()}isEnabled(){return this._enabled}isActive(){return this._active}}class y{constructor(e){this._enabled=!!e.enable,this._moveStateManager=e.moveStateManager,this._clickTolerance=e.clickTolerance||1,this._moveFunction=e.move,this._activateOnStart=!!e.activateOnStart,e.assignEvents(this),this.reset()}reset(e){this._active=!1,this._moved=!1,delete this._lastPoint,this._moveStateManager.endMove(e)}_move(...e){e=this._moveFunction(...e);if(e.bearingDelta||e.pitchDelta||e.around||e.panDelta)return this._active=!0,e}dragStart(e,t){this.isEnabled()&&!this._lastPoint&&this._moveStateManager.isValidStartEvent(e)&&(this._moveStateManager.startMove(e),this._lastPoint=t.length?t[0]:t,this._activateOnStart)&&this._lastPoint&&(this._active=!0)}dragMove(e,t){if(this.isEnabled()){var r=this._lastPoint;if(r)if(e.preventDefault(),this._moveStateManager.isValidMoveEvent(e)){t=t.length?t[0]:t;if(this._moved||!(t.dist(r)<this._clickTolerance))return this._moved=!0,this._lastPoint=t,this._move(r,t)}else this.reset(e)}}dragEnd(e){this.isEnabled()&&this._lastPoint&&this._moveStateManager.isValidEndEvent(e)&&(this._moved&&f.suppressClick(),this.reset(e))}enable(){this._enabled=!0}disable(){this._enabled=!1,this.reset()}isEnabled(){return this._enabled}isActive(){return this._active}getClickTolerance(){return this._clickTolerance}}const Si={[0]:1,2:2};class Ei{constructor(e){this._correctEvent=e.checkCorrectEvent}startMove(e){e=f.mouseButton(e);this._eventButton=e}endMove(e){delete this._eventButton}isValidStartEvent(e){return this._correctEvent(e)}isValidMoveEvent(e){return e=e,t=this._eventButton,t=Si[t],!(void 0===e.buttons||(e.buttons&t)!==t);var t}isValidEndEvent(e){return f.mouseButton(e)===this._eventButton}}class Ii{constructor(){this._firstTouch=void 0}_isOneFingerTouch(e){return 1===e.targetTouches.length}_isSameTouchEvent(e){return e.targetTouches[0].identifier===this._firstTouch}startMove(e){e=e.targetTouches[0].identifier;this._firstTouch=e}endMove(e){delete this._firstTouch}isValidStartEvent(e){return this._isOneFingerTouch(e)}isValidMoveEvent(e){return this._isOneFingerTouch(e)&&this._isSameTouchEvent(e)}isValidEndEvent(e){return this._isOneFingerTouch(e)&&this._isSameTouchEvent(e)}}const Ai=e=>{e.mousedown=e.dragStart,e.mousemoveWindow=e.dragMove,e.mouseup=e.dragEnd,e.contextmenu=function(e){e.preventDefault()}},ki=({enable:e,clickTolerance:t,bearingDegreesPerPixelMoved:r=.8})=>{var i=new Ei({checkCorrectEvent:e=>0===f.mouseButton(e)&&e.ctrlKey||2===f.mouseButton(e)});return new y({clickTolerance:t,move:(e,t)=>({bearingDelta:(t.x-e.x)*r}),moveStateManager:i,enable:e,assignEvents:Ai})},Pi=({enable:e,clickTolerance:t,pitchDegreesPerPixelMoved:r=-.5})=>{var i=new Ei({checkCorrectEvent:e=>0===f.mouseButton(e)&&e.ctrlKey||2===f.mouseButton(e)});return new y({clickTolerance:t,move:(e,t)=>({pitchDelta:(t.y-e.y)*r}),moveStateManager:i,enable:e,assignEvents:Ai})};class Mi{constructor(e,t){this._clickTolerance=e.clickTolerance||1,this._map=t,this.reset()}reset(){this._active=!1,this._touches={},this._sum=new de.Point(0,0)}minTouchs(){return this._map.cooperativeGestures.isEnabled()?2:1}touchstart(e,t,r){return this._calculateTransform(e,t,r)}touchmove(e,t,r){if(this._active&&!(r.length<this.minTouchs()))return e.preventDefault(),this._calculateTransform(e,t,r)}touchend(e,t,r){this._calculateTransform(e,t,r),this._active&&r.length<this.minTouchs()&&this.reset()}touchcancel(){this.reset()}_calculateTransform(e,t,r){0<r.length&&(this._active=!0);var i=wi(r,t),n=new de.Point(0,0),o=new de.Point(0,0);let a=0;for(const c in i){var s=i[c],l=this._touches[c];l&&(n._add(s),o._add(s.sub(l)),a++,i[c]=s)}if(this._touches=i,!(a<this.minTouchs())&&o.mag()){r=o.div(a);if(this._sum._add(r),!(this._sum.mag()<this._clickTolerance))return{around:n.div(a),panDelta:r}}}enable(){this._enabled=!0}disable(){this._enabled=!1,this.reset()}isEnabled(){return this._enabled}isActive(){return this._active}}class Ri{constructor(){this.reset()}reset(){this._active=!1,delete this._firstTwoTouches}touchstart(e,t,r){this._firstTwoTouches||r.length<2||(this._firstTwoTouches=[r[0].identifier,r[1].identifier],this._start([t[0],t[1]]))}touchmove(e,t,r){if(this._firstTwoTouches){e.preventDefault();var[i,n]=this._firstTwoTouches,i=Oi(r,t,i),r=Oi(r,t,n);if(i&&r)return t=this._aroundCenter?null:i.add(r).div(2),this._move([i,r],t,e)}}touchend(e,t,r){var i,n;this._firstTwoTouches&&([n,i]=this._firstTwoTouches,n=Oi(r,t,n),r=Oi(r,t,i),n&&r||(this._active&&f.suppressClick(),this.reset()))}touchcancel(){this.reset()}enable(e){this._enabled=!0,this._aroundCenter=!!e&&"center"===e.around}disable(){this._enabled=!1,this.reset()}isEnabled(){return!!this._enabled}isActive(){return!!this._active}}function Oi(t,r,i){for(let e=0;e<t.length;e++)if(t[e].identifier===i)return r[e]}function Li(e,t){return Math.log(e/t)/Math.LN2}class Di extends Ri{reset(){super.reset(),delete this._distance,delete this._startDistance}_start(e){this._startDistance=this._distance=e[0].dist(e[1])}_move(e,t){var r=this._distance;if(this._distance=e[0].dist(e[1]),this._active||!(Math.abs(Li(this._distance,this._startDistance))<.1))return this._active=!0,{zoomDelta:Li(this._distance,r),pinchAround:t}}}function zi(e,t){return 180*e.angleWith(t)/Math.PI}class Ni extends Ri{reset(){super.reset(),delete this._minDiameter,delete this._startVector,delete this._vector}_start(e){this._startVector=this._vector=e[0].sub(e[1]),this._minDiameter=e[0].dist(e[1])}_move(e,t,r){var i=this._vector;if(this._vector=e[0].sub(e[1]),this._active||!this._isBelowThreshold(this._vector))return this._active=!0,{bearingDelta:zi(this._vector,i),pinchAround:t}}_isBelowThreshold(e){this._minDiameter=Math.min(this._minDiameter,e.mag());var t=25/(Math.PI*this._minDiameter)*360,e=zi(e,this._startVector);return Math.abs(e)<t}}function Bi(e){return Math.abs(e.y)>Math.abs(e.x)}class Fi extends Ri{constructor(e){super(),this._currentTouchCount=0,this._map=e}reset(){super.reset(),this._valid=void 0,delete this._firstMove,delete this._lastPoints}touchstart(e,t,r){super.touchstart(e,t,r),this._currentTouchCount=r.length}_start(e){Bi((this._lastPoints=e)[0].sub(e[1]))&&(this._valid=!1)}_move(e,t,r){if(!(this._map.cooperativeGestures.isEnabled()&&this._currentTouchCount<3)){var i=e[0].sub(this._lastPoints[0]),n=e[1].sub(this._lastPoints[1]);if(this._valid=this.gestureBeginsVertically(i,n,r.timeStamp),this._valid)return this._lastPoints=e,this._active=!0,{pitchDelta:-.5*((i.y+n.y)/2)}}}gestureBeginsVertically(e,t,r){var i,n;return void 0!==this._valid?this._valid:(n=2<=e.mag(),i=2<=t.mag(),n||i?n&&i?(n=0<e.y==0<t.y,Bi(e)&&Bi(t)&&n):(void 0===this._firstMove&&(this._firstMove=r),r-this._firstMove<100&&void 0):void 0)}}const Ui={panStep:100,bearingStep:15,pitchStep:10};class qi{constructor(e){this._tr=new m(e);e=Ui;this._panStep=e.panStep,this._bearingStep=e.bearingStep,this._pitchStep=e.pitchStep,this._rotationDisabled=!1}reset(){this._active=!1}keydown(s){if(!(s.altKey||s.ctrlKey||s.metaKey)){let r=0,i=0,n=0,o=0,a=0;switch(s.keyCode){case 61:case 107:case 171:case 187:r=1;break;case 189:case 109:case 173:r=-1;break;case 37:s.shiftKey?i=-1:(s.preventDefault(),o=-1);break;case 39:s.shiftKey?i=1:(s.preventDefault(),o=1);break;case 38:s.shiftKey?n=1:(s.preventDefault(),a=-1);break;case 40:s.shiftKey?n=-1:(s.preventDefault(),a=1);break;default:return}return this._rotationDisabled&&(i=0,n=0),{cameraAnimation:e=>{var t=this._tr;e.easeTo({duration:300,easeId:"keyboardHandler",easing:ji,zoom:r?Math.round(t.zoom)+r*(s.shiftKey?2:1):t.zoom,bearing:t.bearing+i*this._bearingStep,pitch:t.pitch+n*this._pitchStep,offset:[-o*this._panStep,-a*this._panStep],center:t.center},{originalEvent:s})}}}}enable(){this._enabled=!0}disable(){this._enabled=!1,this.reset()}isEnabled(){return this._enabled}isActive(){return this._active}disableRotation(){this._rotationDisabled=!0}enableRotation(){this._rotationDisabled=!1}}function ji(e){return e*(2-e)}const Hi=4.000244140625;class Vi{constructor(e,t){this._onTimeout=e=>{this._type="wheel",this._delta-=this._lastValue,this._active||this._start(e)},this._map=e,this._tr=new m(e),this._triggerRenderFrame=t,this._delta=0,this._defaultZoomRate=.01,this._wheelZoomRate=1/450}setZoomRate(e){this._defaultZoomRate=e}setWheelZoomRate(e){this._wheelZoomRate=e}isEnabled(){return!!this._enabled}isActive(){return!!this._active||void 0!==this._finishTimeout}isZooming(){return!!this._zooming}enable(e){this.isEnabled()||(this._enabled=!0,this._aroundCenter=!!e&&"center"===e.around)}disable(){this.isEnabled()&&(this._enabled=!1)}wheel(t){if(this.isEnabled()&&(!this._map.cooperativeGestures.isEnabled()||t[this._map.cooperativeGestures._bypassKey])){let e=t.deltaMode===WheelEvent.DOM_DELTA_LINE?40*t.deltaY:t.deltaY;var r=M.now(),i=r-(this._lastWheelEventTime||0);this._lastWheelEventTime=r,0!==e&&e%Hi==0?this._type="wheel":0!==e&&Math.abs(e)<4?this._type="trackpad":400<i?(this._type=null,this._lastValue=e,this._timeout=setTimeout(this._onTimeout,40,t)):this._type||(this._type=Math.abs(i*e)<200?"trackpad":"wheel",this._timeout&&(clearTimeout(this._timeout),this._timeout=null,e+=this._lastValue)),t.shiftKey&&e&&(e/=4),this._type&&(this._lastWheelEvent=t,this._delta-=e,this._active||this._start(t)),t.preventDefault()}}_start(e){var t;this._delta&&(this._frameId&&(this._frameId=null),this._active=!0,this.isZooming()||(this._zooming=!0),this._finishTimeout&&(clearTimeout(this._finishTimeout),delete this._finishTimeout),e=f.mousePos(this._map.getCanvas(),e),t=this._tr,e.y>t.transform.height/2-t.transform.getHorizon()?this._around=de.LngLat.convert(this._aroundCenter?t.center:t.unproject(e)):this._around=de.LngLat.convert(t.center),this._aroundPoint=t.transform.locationPoint(this._around),this._frameId||(this._frameId=!0,this._triggerRenderFrame()))}renderFrame(){if(this._frameId&&(this._frameId=null,this.isActive())){var r=this._tr.transform;if(0!==this._delta){var i="wheel"===this._type&&Math.abs(this._delta)>Hi?this._wheelZoomRate:this._defaultZoomRate;let e=2/(1+Math.exp(-Math.abs(this._delta*i)));this._delta<0&&0!==e&&(e=1/e);i="number"==typeof this._targetZoom?r.zoomScale(this._targetZoom):r.scale;this._targetZoom=Math.min(r.maxZoom,Math.max(r.minZoom,r.scaleZoom(i*e))),"wheel"===this._type&&(this._startZoom=r.zoom,this._easing=this._smoothOutEasing(200)),this._delta=0}var n,i="number"==typeof this._targetZoom?this._targetZoom:r.zoom,o=this._startZoom,a=this._easing;let e=!1,t;return"wheel"===this._type&&o&&a?(n=a(a=Math.min((M.now()-this._lastWheelEventTime)/200,1)),t=de.interpolate.number(o,i,n),a<1?this._frameId||(this._frameId=!0):e=!0):(t=i,e=!0),this._active=!0,e&&(this._active=!1,this._finishTimeout=setTimeout(()=>{this._zooming=!1,this._triggerRenderFrame(),delete this._targetZoom,delete this._finishTimeout},200)),{noInertia:!0,needsRenderFrame:!e,zoomDelta:t-r.zoom,around:this._aroundPoint,originalEvent:this._lastWheelEvent}}}_smoothOutEasing(e){let t=de.defaultEasing;var r,i;return this._prevEase&&(i=this._prevEase,r=(M.now()-i.start)/i.duration,i=i.easing(.01+r)-i.easing(r),r=.27/Math.sqrt(i*i+1e-4)*.01,i=Math.sqrt(.0729-r*r),t=de.bezier(r,i,.25,1)),this._prevEase={start:M.now(),duration:e,easing:t},t}reset(){this._active=!1,this._zooming=!1,delete this._targetZoom,this._finishTimeout&&(clearTimeout(this._finishTimeout),delete this._finishTimeout)}}class Gi{constructor(e,t){this._clickZoom=e,this._tapZoom=t}enable(){this._clickZoom.enable(),this._tapZoom.enable()}disable(){this._clickZoom.disable(),this._tapZoom.disable()}isEnabled(){return this._clickZoom.isEnabled()&&this._tapZoom.isEnabled()}isActive(){return this._clickZoom.isActive()||this._tapZoom.isActive()}}class Ki{constructor(e){this._tr=new m(e),this.reset()}reset(){this._active=!1}dblclick(t,r){return t.preventDefault(),{cameraAnimation:e=>{e.easeTo({duration:300,zoom:this._tr.zoom+(t.shiftKey?-1:1),around:this._tr.unproject(r)},{originalEvent:t})}}}enable(){this._enabled=!0}disable(){this._enabled=!1,this.reset()}isEnabled(){return this._enabled}isActive(){return this._active}}class Zi{constructor(){this._tap=new Ci({numTouches:1,numTaps:1}),this.reset()}reset(){this._active=!1,delete this._swipePoint,delete this._swipeTouch,delete this._tapTime,delete this._tapPoint,this._tap.reset()}touchstart(e,t,r){var i,n,o;this._swipePoint||(this._tapTime?(i=t[0],n=e.timeStamp-this._tapTime<500,o=this._tapPoint.dist(i)<30,n&&o?0<r.length&&(this._swipePoint=i,this._swipeTouch=r[0].identifier):this.reset()):this._tap.touchstart(e,t,r))}touchmove(e,t,r){if(this._tapTime){if(this._swipePoint){var i,n;if(r[0].identifier===this._swipeTouch)return n=(i=t[0]).y-this._swipePoint.y,this._swipePoint=i,e.preventDefault(),this._active=!0,{zoomDelta:n/128}}}else this._tap.touchmove(e,t,r)}touchend(e,t,r){this._tapTime?this._swipePoint&&0===r.length&&this.reset():(t=this._tap.touchend(e,t,r))&&(this._tapTime=e.timeStamp,this._tapPoint=t)}touchcancel(){this.reset()}enable(){this._enabled=!0}disable(){this._enabled=!1,this.reset()}isEnabled(){return this._enabled}isActive(){return this._active}}class Wi{constructor(e,t,r){this._el=e,this._mousePan=t,this._touchPan=r}enable(e){this._inertiaOptions=e||{},this._mousePan.enable(),this._touchPan.enable(),this._el.classList.add("maplibregl-touch-drag-pan")}disable(){this._mousePan.disable(),this._touchPan.disable(),this._el.classList.remove("maplibregl-touch-drag-pan")}isEnabled(){return this._mousePan.isEnabled()&&this._touchPan.isEnabled()}isActive(){return this._mousePan.isActive()||this._touchPan.isActive()}}class Yi{constructor(e,t,r){this._pitchWithRotate=e.pitchWithRotate,this._mouseRotate=t,this._mousePitch=r}enable(){this._mouseRotate.enable(),this._pitchWithRotate&&this._mousePitch.enable()}disable(){this._mouseRotate.disable(),this._mousePitch.disable()}isEnabled(){return this._mouseRotate.isEnabled()&&(!this._pitchWithRotate||this._mousePitch.isEnabled())}isActive(){return this._mouseRotate.isActive()||this._mousePitch.isActive()}}class $i{constructor(e,t,r,i){this._el=e,this._touchZoom=t,this._touchRotate=r,this._tapDragZoom=i,this._rotationDisabled=!1,this._enabled=!0}enable(e){this._touchZoom.enable(e),this._rotationDisabled||this._touchRotate.enable(e),this._tapDragZoom.enable(),this._el.classList.add("maplibregl-touch-zoom-rotate")}disable(){this._touchZoom.disable(),this._touchRotate.disable(),this._tapDragZoom.disable(),this._el.classList.remove("maplibregl-touch-zoom-rotate")}isEnabled(){return this._touchZoom.isEnabled()&&(this._rotationDisabled||this._touchRotate.isEnabled())&&this._tapDragZoom.isEnabled()}isActive(){return this._touchZoom.isActive()||this._touchRotate.isActive()||this._tapDragZoom.isActive()}disableRotation(){this._rotationDisabled=!0,this._touchRotate.disable()}enableRotation(){this._rotationDisabled=!1,this._touchZoom.isEnabled()&&this._touchRotate.enable()}}class Xi{constructor(e,t){this._bypassKey=-1!==navigator.userAgent.indexOf("Mac")?"metaKey":"ctrlKey",this._map=e,this._options=t,this._enabled=!1}isActive(){return!1}reset(){}_setupUI(){if(!this._container){var t=this._map.getCanvasContainer();t.classList.add("maplibregl-cooperative-gestures"),this._container=f.create("div","maplibregl-cooperative-gesture-screen",t);let e=this._map._getUIString("CooperativeGesturesHandler.WindowsHelpText");"metaKey"===this._bypassKey&&(e=this._map._getUIString("CooperativeGesturesHandler.MacHelpText"));var t=this._map._getUIString("CooperativeGesturesHandler.MobileHelpText"),r=document.createElement("div"),r=(r.className="maplibregl-desktop-message",r.textContent=e,this._container.appendChild(r),document.createElement("div"));r.className="maplibregl-mobile-message",r.textContent=t,this._container.appendChild(r),this._container.setAttribute("aria-hidden","true")}}_destoryUI(){this._container&&(f.remove(this._container),this._map.getCanvasContainer().classList.remove("maplibregl-cooperative-gestures")),delete this._container}enable(){this._setupUI(),this._enabled=!0}disable(){this._enabled=!1,this._destoryUI()}isEnabled(){return this._enabled}touchmove(e){this._onCooperativeGesture(1===e.touches.length)}wheel(e){this._map.scrollZoom.isEnabled()&&this._onCooperativeGesture(!e[this._bypassKey])}_onCooperativeGesture(e){this._enabled&&e&&(this._container.classList.add("maplibregl-show"),setTimeout(()=>{this._container.classList.remove("maplibregl-show")},100))}}const Ji=e=>e.zoom||e.drag||e.pitch||e.rotate;class Qi extends de.Event{}function en(e){return e.panDelta&&e.panDelta.mag()||e.zoomDelta||e.bearingDelta||e.pitchDelta}class tn{constructor(e,t){this.handleWindowEvent=e=>{this.handleEvent(e,e.type+"Window")},this.handleEvent=(t,r)=>{if("blur"===t.type)this.stop(!0);else{this._updatingCamera=!0;var i,n,o,a="renderFrame"===t.type?void 0:t,s={needsRenderFrame:!1},l={},c={},e=t.touches,u=e?this._getMapTouches(e):void 0,h=u?f.touchPos(this._map.getCanvas(),u):f.mousePos(this._map.getCanvas(),t);for({handlerName:i,handler:n,allowed:o}of this._handlers)if(n.isEnabled()){let e;this._blockedByActive(c,o,i)?n.reset():n[r||t.type]&&(e=n[r||t.type](t,h,u),this.mergeHandlerResult(s,l,e,i,a),e)&&e.needsRenderFrame&&this._triggerRenderFrame(),(e||n.isActive())&&(c[i]=n)}var d={};for(const p in this._previousActiveHandlers)c[p]||(d[p]=a);this._previousActiveHandlers=c,(Object.keys(d).length||en(s))&&(this._changes.push([s,l,d]),this._triggerRenderFrame()),(Object.keys(c).length||en(s))&&this._map._stop(!0),this._updatingCamera=!1;e=s["cameraAnimation"];e&&(this._inertia.clear(),this._fireEvents({},{},!0),this._changes=[],e(this._map))}},this._map=e,this._el=this._map.getCanvasContainer(),this._handlers=[],this._handlersById={},this._changes=[],this._inertia=new fi(e),this._bearingSnap=t.bearingSnap,this._previousActiveHandlers={},this._eventsInProgress={},this._addDefaultHandlers(t);var r,i,n,e=this._el;this._listeners=[[e,"touchstart",{passive:!0}],[e,"touchmove",{passive:!1}],[e,"touchend",void 0],[e,"touchcancel",void 0],[e,"mousedown",void 0],[e,"mousemove",void 0],[e,"mouseup",void 0],[document,"mousemove",{capture:!0}],[document,"mouseup",void 0],[e,"mouseover",void 0],[e,"mouseout",void 0],[e,"dblclick",void 0],[e,"click",void 0],[e,"keydown",{capture:!1}],[e,"keyup",void 0],[e,"wheel",{passive:!1}],[e,"contextmenu",void 0],[window,"blur",void 0]];for([r,i,n]of this._listeners)f.addEventListener(r,i,r===document?this.handleWindowEvent:this.handleEvent,n)}destroy(){for(var[e,t,r]of this._listeners)f.removeEventListener(e,t,e===document?this.handleWindowEvent:this.handleEvent,r)}_addDefaultHandlers(e){var t=this._map,r=t.getCanvasContainer(),i=(this._add("mapEvent",new vi(t,e)),t.boxZoom=new bi(t,e)),i=(this._add("boxZoom",i),e.interactive&&e.boxZoom&&i.enable(),t.cooperativeGestures=new Xi(t,e.cooperativeGestures)),i=(this._add("cooperativeGestures",i),e.cooperativeGestures&&i.enable(),new Ti(t)),n=new Ki(t),i=(t.doubleClickZoom=new Gi(n,i),this._add("tapZoom",i),this._add("clickZoom",n),e.interactive&&e.doubleClickZoom&&t.doubleClickZoom.enable(),new Zi),n=(this._add("tapDragZoom",i),t.touchPitch=new Fi(t)),n=(this._add("touchPitch",n),e.interactive&&e.touchPitch&&t.touchPitch.enable(e.touchPitch),ki(e)),o=Pi(e),o=(t.dragRotate=new Yi(e,n,o),this._add("mouseRotate",n,["mousePitch"]),this._add("mousePitch",o,["mouseRotate"]),e.interactive&&e.dragRotate&&t.dragRotate.enable(),{enable:n,clickTolerance:o}=[e][0],a=new Ei({checkCorrectEvent:e=>0===f.mouseButton(e)&&!e.ctrlKey}),new y({clickTolerance:o,move:(e,t)=>({around:t,panDelta:t.sub(e)}),activateOnStart:!0,moveStateManager:a,enable:n,assignEvents:Ai})),a=new Mi(e,t),n=(t.dragPan=new Wi(r,o,a),this._add("mousePan",o),this._add("touchPan",a,["touchZoom","touchRotate"]),e.interactive&&e.dragPan&&t.dragPan.enable(e.dragPan),new Ni),o=new Di,a=(t.touchZoomRotate=new $i(r,o,n,i),this._add("touchRotate",n,["touchPan","touchZoom"]),this._add("touchZoom",o,["touchPan","touchRotate"]),e.interactive&&e.touchZoomRotate&&t.touchZoomRotate.enable(e.touchZoomRotate),t.scrollZoom=new Vi(t,()=>this._triggerRenderFrame())),r=(this._add("scrollZoom",a,["mousePan"]),e.interactive&&e.scrollZoom&&t.scrollZoom.enable(e.scrollZoom),t.keyboard=new qi(t));this._add("keyboard",r),e.interactive&&e.keyboard&&t.keyboard.enable(),this._add("blockableMapEvent",new _i(t))}_add(e,t,r){this._handlers.push({handlerName:e,handler:t,allowed:r}),this._handlersById[e]=t}stop(e){if(!this._updatingCamera){for(var{handler:t}of this._handlers)t.reset();this._inertia.clear(),this._fireEvents({},{},e),this._changes=[]}}isActive(){for(var{handler:e}of this._handlers)if(e.isActive())return!0;return!1}isZooming(){return!!this._eventsInProgress.zoom||this._map.scrollZoom.isZooming()}isRotating(){return!!this._eventsInProgress.rotate}isMoving(){return Boolean(Ji(this._eventsInProgress))||this.isZooming()}_blockedByActive(e,t,r){for(const i in e)if(i!==r&&(!t||t.indexOf(i)<0))return!0;return!1}_getMapTouches(e){var t=[];for(const i of e){var r=i.target;this._el.contains(r)&&t.push(i)}return t}mergeHandlerResult(e,t,r,i,n){r&&(de.extend(e,r),e={handlerName:i,originalEvent:r.originalEvent||n},void 0!==r.zoomDelta&&(t.zoom=e),void 0!==r.panDelta&&(t.drag=e),void 0!==r.pitchDelta&&(t.pitch=e),void 0!==r.bearingDelta)&&(t.rotate=e)}_applyChanges(){var e,t,r,i={},n={},o={};for([e,t,r]of this._changes)e.panDelta&&(i.panDelta=(i.panDelta||new de.Point(0,0))._add(e.panDelta)),e.zoomDelta&&(i.zoomDelta=(i.zoomDelta||0)+e.zoomDelta),e.bearingDelta&&(i.bearingDelta=(i.bearingDelta||0)+e.bearingDelta),e.pitchDelta&&(i.pitchDelta=(i.pitchDelta||0)+e.pitchDelta),void 0!==e.around&&(i.around=e.around),void 0!==e.pinchAround&&(i.pinchAround=e.pinchAround),e.noInertia&&(i.noInertia=e.noInertia),de.extend(n,t),de.extend(o,r);this._updateMapTransform(i,n,o),this._changes=[]}_updateMapTransform(e,t,r){const i=this._map,n=i._getTransformForUpdate();var o=i.terrain;if(!(en(e)||o&&this._terrainMovement))return this._fireEvents(t,r,!0);let{panDelta:a,zoomDelta:s,bearingDelta:l,pitchDelta:c,around:u,pinchAround:h}=e;void 0!==h&&(u=h),i._stop(!0),u=u||i.transform.centerPoint;var d=n.pointLocation(a?u.sub(a):u);l&&(n.bearing+=l),c&&(n.pitch+=c),s&&(n.zoom+=s),o?this._terrainMovement||!t.drag&&!t.zoom?t.drag&&this._terrainMovement?n.center=n.pointLocation(n.centerPoint.sub(a)):n.setLocationAtPoint(d,u):(this._terrainMovement=!0,this._map._elevationFreeze=!0,n.setLocationAtPoint(d,u),this._map.once("moveend",()=>{this._map._elevationFreeze=!1,this._terrainMovement=!1,n.recalculateZoom(i.terrain)})):n.setLocationAtPoint(d,u),i._applyUpdatedTransform(n),this._map._update(),e.noInertia||this._inertia.record(e),this._fireEvents(t,r,!0)}_fireEvents(e,t,r){var i=Ji(this._eventsInProgress),n=Ji(e),o={};for(const p in e){var a=e[p]["originalEvent"];this._eventsInProgress[p]||(o[p+"start"]=a),this._eventsInProgress[p]=e[p]}!i&&n&&this._fireEvent("movestart",n.originalEvent);for(const f in o)this._fireEvent(f,o[f]);n&&this._fireEvent("move",n.originalEvent);for(const m in e){var s=e[m]["originalEvent"];this._fireEvent(m,s)}var l={};let c;for(const g in this._eventsInProgress){var{handlerName:u,originalEvent:h}=this._eventsInProgress[g];this._handlersById[u].isActive()||(delete this._eventsInProgress[g],c=t[u]||h,l[g+"end"]=c)}for(const y in l)this._fireEvent(y,l[y]);var d=Ji(this._eventsInProgress);r&&(i||n)&&!d&&(this._updatingCamera=!0,r=e=>0!==e&&-this._bearingSnap<e&&e<this._bearingSnap,!(i=this._inertia._onMoveEnd(this._map.dragPan._inertiaOptions))||!i.essential&&M.prefersReducedMotion?(this._map.fire(new de.Event("moveend",{originalEvent:c})),r(this._map.getBearing())&&this._map.resetNorth()):(r(i.bearing||this._map.getBearing())&&(i.bearing=0),i.freezeElevation=!0,this._map.easeTo(i,{originalEvent:c})),this._updatingCamera=!1)}_fireEvent(e,t){this._map.fire(new de.Event(e,t?{originalEvent:t}:{}))}_requestFrame(){return this._map.triggerRepaint(),this._map._renderTaskQueue.add(e=>{delete this._frameId,this.handleEvent(new Qi("renderFrame",{timeStamp:e})),this._applyChanges()})}_triggerRenderFrame(){void 0===this._frameId&&(this._frameId=this._requestFrame())}}class rn extends de.Evented{constructor(e,t){super(),this._renderFrameCallback=()=>{var e=Math.min((M.now()-this._easeStart)/this._easeOptions.duration,1);this._onEaseFrame(this._easeOptions.easing(e)),e<1&&this._easeFrameId?this._easeFrameId=this._requestRenderFrame(this._renderFrameCallback):this.stop()},this._moving=!1,this._zooming=!1,this.transform=e,this._bearingSnap=t.bearingSnap,this.on("moveend",()=>{delete this._requestedCameraState})}getCenter(){return new de.LngLat(this.transform.center.lng,this.transform.center.lat)}setCenter(e,t){return this.jumpTo({center:e},t)}panBy(e,t,r){return e=de.Point.convert(e).mult(-1),this.panTo(this.transform.center,de.extend({offset:e},t),r)}panTo(e,t,r){return this.easeTo(de.extend({center:e},t),r)}getZoom(){return this.transform.zoom}setZoom(e,t){return this.jumpTo({zoom:e},t),this}zoomTo(e,t,r){return this.easeTo(de.extend({zoom:e},t),r)}zoomIn(e,t){return this.zoomTo(this.getZoom()+1,e,t),this}zoomOut(e,t){return this.zoomTo(this.getZoom()-1,e,t),this}getBearing(){return this.transform.bearing}setBearing(e,t){return this.jumpTo({bearing:e},t),this}getPadding(){return this.transform.padding}setPadding(e,t){return this.jumpTo({padding:e},t),this}rotateTo(e,t,r){return this.easeTo(de.extend({bearing:e},t),r)}resetNorth(e,t){return this.rotateTo(0,de.extend({duration:1e3},e),t),this}resetNorthPitch(e,t){return this.easeTo(de.extend({bearing:0,pitch:0,duration:1e3},e),t),this}snapToNorth(e,t){return Math.abs(this.getBearing())<this._bearingSnap?this.resetNorth(e,t):this}getPitch(){return this.transform.pitch}setPitch(e,t){return this.jumpTo({pitch:e},t),this}cameraForBounds(e,t){e=d.convert(e);var r=t&&t.bearing||0;return this._cameraForBoxAndBearing(e.getNorthWest(),e.getSouthEast(),r,t)}_cameraForBoxAndBearing(e,t,r,i){var n={top:0,bottom:0,right:0,left:0},o=("number"==typeof(i=de.extend({padding:n,offset:[0,0],maxZoom:this.transform.maxZoom},i)).padding&&(o=i.padding,i.padding={top:o,bottom:o,right:o,left:o}),i.padding=de.extend(n,i.padding),this.transform),n=o.padding,e=new d(e,t),t=o.project(e.getNorthWest()),a=o.project(e.getNorthEast()),s=o.project(e.getSouthEast()),e=o.project(e.getSouthWest()),l=de.degreesToRadians(-r),c=t.rotate(l),a=a.rotate(l),u=s.rotate(l),e=e.rotate(l),l=new de.Point(Math.max(c.x,a.x,e.x,u.x),Math.max(c.y,a.y,e.y,u.y)),c=new de.Point(Math.min(c.x,a.x,e.x,u.x),Math.min(c.y,a.y,e.y,u.y)),a=l.sub(c),e=(o.width-(n.left+n.right+i.padding.left+i.padding.right))/a.x,u=(o.height-(n.top+n.bottom+i.padding.top+i.padding.bottom))/a.y;if(!(u<0||e<0))return l=Math.min(o.scaleZoom(o.scale*Math.min(e,u)),i.maxZoom),c=de.Point.convert(i.offset),n=(i.padding.left-i.padding.right)/2,a=(i.padding.top-i.padding.bottom)/2,e=new de.Point(n,a).rotate(de.degreesToRadians(r)),u=c.add(e).mult(o.scale/o.zoomScale(l)),{center:o.unproject(t.add(s).div(2).sub(u)),zoom:l,bearing:r};de.warnOnce("Map cannot fit within canvas with the given bounds, padding, and/or offset.")}fitBounds(e,t,r){return this._fitInternal(this.cameraForBounds(e,t),t,r)}fitScreenCoordinates(e,t,r,i,n){return this._fitInternal(this._cameraForBoxAndBearing(this.transform.pointLocation(de.Point.convert(e)),this.transform.pointLocation(de.Point.convert(t)),r,i),i,n)}_fitInternal(e,t,r){return e?(delete(t=de.extend(e,t)).padding,t.linear?this.easeTo(t,r):this.flyTo(t,r)):this}jumpTo(e,t){this.stop();var r=this._getTransformForUpdate();let i=!1,n=!1,o=!1;return"zoom"in e&&r.zoom!==+e.zoom&&(i=!0,r.zoom=+e.zoom),void 0!==e.center&&(r.center=de.LngLat.convert(e.center)),"bearing"in e&&r.bearing!==+e.bearing&&(n=!0,r.bearing=+e.bearing),"pitch"in e&&r.pitch!==+e.pitch&&(o=!0,r.pitch=+e.pitch),null==e.padding||r.isPaddingEqual(e.padding)||(r.padding=e.padding),this._applyUpdatedTransform(r),this.fire(new de.Event("movestart",t)).fire(new de.Event("move",t)),i&&this.fire(new de.Event("zoomstart",t)).fire(new de.Event("zoom",t)).fire(new de.Event("zoomend",t)),n&&this.fire(new de.Event("rotatestart",t)).fire(new de.Event("rotate",t)).fire(new de.Event("rotateend",t)),o&&this.fire(new de.Event("pitchstart",t)).fire(new de.Event("pitch",t)).fire(new de.Event("pitchend",t)),this.fire(new de.Event("moveend",t))}calculateCameraOptionsFromTo(e,t,r,i=0){var e=de.MercatorCoordinate.fromLngLat(e,t),t=de.MercatorCoordinate.fromLngLat(r,i),r=t.x-e.x,i=t.y-e.y,e=t.z-e.z,n=Math.hypot(r,i,e);if(0===n)throw new Error("Can't calculate camera options with same From and To");var o=Math.hypot(r,i),a=this.transform.scaleZoom(this.transform.cameraToCenterDistance/n/this.transform.tileSize),r=180*Math.atan2(r,-i)/Math.PI,i=180*Math.acos(o/n)/Math.PI,i=e<0?90-i:90+i;return{center:t.toLngLat(),zoom:a,pitch:i,bearing:r}}easeTo(i,n){this._stop(!1,i.easeId),(!1===(i=de.extend({offset:[0,0],duration:500,easing:de.defaultEasing},i)).animate||!i.essential&&M.prefersReducedMotion)&&(i.duration=0);const o=this._getTransformForUpdate(),a=this.getZoom(),s=this.getBearing(),l=this.getPitch(),c=this.getPadding(),u="bearing"in i?this._normalizeBearing(i.bearing,s):s,h="pitch"in i?+i.pitch:l,d=("padding"in i?i:o).padding,p=de.Point.convert(i.offset);let f=o.centerPoint.add(p);var e=o.pointLocation(f);const{center:t,zoom:m}=o.getConstrained(de.LngLat.convert(i.center||e),null!=(r=i.zoom)?r:a),g=(this._normalizeCenter(t),o.project(e)),y=o.project(t).sub(g),v=o.zoomScale(m-a);let _,b;i.around&&(_=de.LngLat.convert(i.around),b=o.locationPoint(_));var r={moving:this._moving,zooming:this._zooming,rotating:this._rotating,pitching:this._pitching};return this._zooming=this._zooming||m!==a,this._rotating=this._rotating||s!==u,this._pitching=this._pitching||h!==l,this._padding=!o.isPaddingEqual(d),this._easeId=i.easeId,this._prepareEase(n,i.noMoveStart,r),this.terrain&&this._prepareElevation(t),this._ease(e=>{var t,r;this._zooming&&(o.zoom=de.interpolate.number(a,m,e)),this._rotating&&(o.bearing=de.interpolate.number(s,u,e)),this._pitching&&(o.pitch=de.interpolate.number(l,h,e)),this._padding&&(o.interpolatePadding(c,d,e),f=o.centerPoint.add(p)),this.terrain&&!i.freezeElevation&&this._updateElevation(e),_?o.setLocationAtPoint(_,b):(t=o.zoomScale(o.zoom-a),r=m>a?Math.min(2,v):Math.max(.5,v),r=Math.pow(r,1-e),e=o.unproject(g.add(y.mult(e*r)).mult(t)),o.setLocationAtPoint(o.renderWorldCopies?e.wrap():e,f)),this._applyUpdatedTransform(o),this._fireMoveEvents(n)},e=>{this.terrain&&this._finalizeElevation(),this._afterEase(n,e)},i),this}_prepareEase(e,t,r={}){this._moving=!0,t||r.moving||this.fire(new de.Event("movestart",e)),this._zooming&&!r.zooming&&this.fire(new de.Event("zoomstart",e)),this._rotating&&!r.rotating&&this.fire(new de.Event("rotatestart",e)),this._pitching&&!r.pitching&&this.fire(new de.Event("pitchstart",e))}_prepareElevation(e){this._elevationCenter=e,this._elevationStart=this.transform.elevation,this._elevationTarget=this.terrain.getElevationForLngLatZoom(e,this.transform.tileZoom),this._elevationFreeze=!0}_updateElevation(e){this.transform.minElevationForCurrentTile=this.terrain.getMinTileElevationForLngLatZoom(this._elevationCenter,this.transform.tileZoom);var t,r,i=this.terrain.getElevationForLngLatZoom(this._elevationCenter,this.transform.tileZoom);e<1&&i!==this._elevationTarget&&(r=(i-((t=this._elevationTarget-this._elevationStart)*e+this._elevationStart))/(1-e),this._elevationStart+=e*(t-r),this._elevationTarget=i),this.transform.elevation=de.interpolate.number(this._elevationStart,this._elevationTarget,e)}_finalizeElevation(){this._elevationFreeze=!1,this.transform.recalculateZoom(this.terrain)}_getTransformForUpdate(){return this.transformCameraUpdate?(this._requestedCameraState||(this._requestedCameraState=this.transform.clone()),this._requestedCameraState):this.transform}_applyUpdatedTransform(e){var t,r,i,n,o;this.transformCameraUpdate&&(e=e.clone(),{center:t,zoom:r,pitch:i,bearing:n,elevation:o}=this.transformCameraUpdate(e),t&&(e.center=t),void 0!==r&&(e.zoom=r),void 0!==i&&(e.pitch=i),void 0!==n&&(e.bearing=n),void 0!==o&&(e.elevation=o),this.transform.apply(e))}_fireMoveEvents(e){this.fire(new de.Event("move",e)),this._zooming&&this.fire(new de.Event("zoom",e)),this._rotating&&this.fire(new de.Event("rotate",e)),this._pitching&&this.fire(new de.Event("pitch",e))}_afterEase(e,t){var r,i;this._easeId&&t&&this._easeId===t||(delete this._easeId,this.fire(new de.Event("freezeElevation",{freeze:!1})),t=this._zooming,r=this._rotating,i=this._pitching,this._moving=!1,this._zooming=!1,this._rotating=!1,this._pitching=!1,this._padding=!1,t&&this.fire(new de.Event("zoomend",e)),r&&this.fire(new de.Event("rotateend",e)),i&&this.fire(new de.Event("pitchend",e)),this.fire(new de.Event("moveend",e)))}flyTo(i,n){if(!i.essential&&M.prefersReducedMotion)return e=de.pick(i,["center","zoom","bearing","pitch","around"]),this.jumpTo(e,n);this.stop(),i=de.extend({offset:[0,0],speed:1.2,curve:1.42,easing:de.defaultEasing},i);const o=this._getTransformForUpdate(),a=this.getZoom(),s=this.getBearing(),l=this.getPitch(),c=this.getPadding(),u="bearing"in i?this._normalizeBearing(i.bearing,s):s,h="pitch"in i?+i.pitch:l,d=("padding"in i?i:o).padding,p=de.Point.convert(i.offset);let f=o.centerPoint.add(p);var e=o.pointLocation(f);const{center:m,zoom:g}=o.getConstrained(de.LngLat.convert(i.center||e),null!=(t=i.zoom)?t:a);this._normalizeCenter(m);var t=o.zoomScale(g-a);const y=o.project(e),v=o.project(m).sub(y);let r=i.curve;const _=Math.max(o.width,o.height),b=_/t,w=v.mag(),x=("minZoom"in i&&(e=de.clamp(Math.min(i.minZoom,a,g),o.minZoom,o.maxZoom),t=_/o.zoomScale(e-a),r=Math.sqrt(t/w*2)),r*r);function C(e){e=(b*b-_*_+(e?-1:1)*x*x*w*w)/(2*(e?b:_)*x*w);return Math.log(Math.sqrt(e*e+1)-e)}function T(e){return(Math.exp(e)-Math.exp(-e))/2}function S(e){return(Math.exp(e)+Math.exp(-e))/2}const E=C(!1);let I=function(e){return S(E)/S(E+r*e)},A=function(e){return _*((S(E)*(T(e=E+r*e)/S(e))-T(E))/x)/w},k=(C(!0)-E)/r;if(Math.abs(w)<1e-6||!isFinite(k)){if(Math.abs(_-b)<1e-6)return this.easeTo(i,n);const P=b<_?-1:1;k=Math.abs(Math.log(b/_))/r,A=function(){return 0},I=function(e){return Math.exp(P*r*e)}}return"duration"in i?i.duration=+i.duration:(e="screenSpeed"in i?+i.screenSpeed/r:+i.speed,i.duration=1e3*k/e),i.maxDuration&&i.duration>i.maxDuration&&(i.duration=0),this._zooming=!0,this._rotating=s!==u,this._pitching=h!==l,this._padding=!o.isPaddingEqual(d),this._prepareEase(n,!1),this.terrain&&this._prepareElevation(m),this._ease(e=>{var t=e*k,r=1/I(t),e=(o.zoom=1===e?g:a+o.scaleZoom(r),this._rotating&&(o.bearing=de.interpolate.number(s,u,e)),this._pitching&&(o.pitch=de.interpolate.number(l,h,e)),this._padding&&(o.interpolatePadding(c,d,e),f=o.centerPoint.add(p)),this.terrain&&!i.freezeElevation&&this._updateElevation(e),1===e?m:o.unproject(y.add(v.mult(A(t))).mult(r)));o.setLocationAtPoint(o.renderWorldCopies?e.wrap():e,f),this._applyUpdatedTransform(o),this._fireMoveEvents(n)},()=>{this.terrain&&this._finalizeElevation(),this._afterEase(n)},i),this}isEasing(){return!!this._easeFrameId}stop(){return this._stop()}_stop(e,t){var r;return this._easeFrameId&&(this._cancelRenderFrame(this._easeFrameId),delete this._easeFrameId,delete this._onEaseFrame),this._onEaseEnd&&(r=this._onEaseEnd,delete this._onEaseEnd,r.call(this,t)),e||(r=this.handlers)&&r.stop(!1),this}_ease(e,t,r){!1===r.animate||0===r.duration?(e(1),t()):(this._easeStart=M.now(),this._easeOptions=r,this._onEaseFrame=e,this._onEaseEnd=t,this._easeFrameId=this._requestRenderFrame(this._renderFrameCallback))}_normalizeBearing(e,t){e=de.wrap(e,-180,180);var r=Math.abs(e-t);return Math.abs(e-360-t)<r&&(e-=360),Math.abs(e+360-t)<r&&(e+=360),e}_normalizeCenter(e){var t=this.transform;t.renderWorldCopies&&!t.lngRange&&(t=e.lng-t.center.lng,e.lng+=180<t?-360:t<-180?360:0)}queryTerrainElevation(e){return this.terrain?this.terrain.getElevationForLngLatZoom(de.LngLat.convert(e),this.transform.tileZoom)-this.transform.elevation:null}}const nn={compact:!0,customAttribution:'<a href="https://maplibre.org/" target="_blank">MapLibre</a>'};class on{constructor(e=nn){this._toggleAttribution=()=>{this._container.classList.contains("maplibregl-compact")&&(this._container.classList.contains("maplibregl-compact-show")?(this._container.setAttribute("open",""),this._container.classList.remove("maplibregl-compact-show")):(this._container.classList.add("maplibregl-compact-show"),this._container.removeAttribute("open")))},this._updateData=e=>{!e||"metadata"!==e.sourceDataType&&"visibility"!==e.sourceDataType&&"style"!==e.dataType&&"terrain"!==e.type||this._updateAttributions()},this._updateCompact=()=>{this._map.getCanvasContainer().offsetWidth<=640||this._compact?!1===this._compact?this._container.setAttribute("open",""):this._container.classList.contains("maplibregl-compact")||this._container.classList.contains("maplibregl-attrib-empty")||(this._container.setAttribute("open",""),this._container.classList.add("maplibregl-compact","maplibregl-compact-show")):(this._container.setAttribute("open",""),this._container.classList.contains("maplibregl-compact")&&this._container.classList.remove("maplibregl-compact","maplibregl-compact-show"))},this._updateCompactMinimize=()=>{this._container.classList.contains("maplibregl-compact")&&this._container.classList.contains("maplibregl-compact-show")&&this._container.classList.remove("maplibregl-compact-show")},this.options=e}getDefaultPosition(){return"bottom-right"}onAdd(e){return this._map=e,this._compact=this.options.compact,this._container=f.create("details","maplibregl-ctrl maplibregl-ctrl-attrib"),this._compactButton=f.create("summary","maplibregl-ctrl-attrib-button",this._container),this._compactButton.addEventListener("click",this._toggleAttribution),this._setElementTitle(this._compactButton,"ToggleAttribution"),this._innerContainer=f.create("div","maplibregl-ctrl-attrib-inner",this._container),this._updateAttributions(),this._updateCompact(),this._map.on("styledata",this._updateData),this._map.on("sourcedata",this._updateData),this._map.on("terrain",this._updateData),this._map.on("resize",this._updateCompact),this._map.on("drag",this._updateCompactMinimize),this._container}onRemove(){f.remove(this._container),this._map.off("styledata",this._updateData),this._map.off("sourcedata",this._updateData),this._map.off("terrain",this._updateData),this._map.off("resize",this._updateCompact),this._map.off("drag",this._updateCompactMinimize),this._map=void 0,this._compact=void 0,this._attribHTML=void 0}_setElementTitle(e,t){t=this._map._getUIString("AttributionControl."+t);e.title=t,e.setAttribute("aria-label",t)}_updateAttributions(){if(this._map.style){let i=[];this.options.customAttribution&&(Array.isArray(this.options.customAttribution)?i=i.concat(this.options.customAttribution.map(e=>"string"!=typeof e?"":e)):"string"==typeof this.options.customAttribution&&i.push(this.options.customAttribution)),this._map.style.stylesheet&&(r=this._map.style.stylesheet,this.styleOwner=r.owner,this.styleId=r.id);var e=this._map.style.sourceCaches;for(const n in e){var t=e[n];(t.used||t.usedForTerrain)&&(t=t.getSource()).attribution&&i.indexOf(t.attribution)<0&&i.push(t.attribution)}(i=i.filter(e=>String(e).trim())).sort((e,t)=>e.length-t.length);var r=(i=i.filter((t,r)=>{for(let e=r+1;e<i.length;e++)if(0<=i[e].indexOf(t))return!1;return!0})).join(" | ");r!==this._attribHTML&&(this._attribHTML=r,i.length?(this._innerContainer.innerHTML=r,this._container.classList.remove("maplibregl-attrib-empty")):this._container.classList.add("maplibregl-attrib-empty"),this._updateCompact(),this._editLink=null)}}}class an{constructor(e={}){this._updateCompact=()=>{var e=this._container.children;e.length&&(e=e[0],this._map.getCanvasContainer().offsetWidth<=640||this._compact?!1!==this._compact&&e.classList.add("maplibregl-compact"):e.classList.remove("maplibregl-compact"))},this.options=e}getDefaultPosition(){return"bottom-left"}onAdd(e){this._map=e,this._compact=this.options&&this.options.compact,this._container=f.create("div","maplibregl-ctrl");e=f.create("a","maplibregl-ctrl-logo");return e.target="_blank",e.rel="noopener nofollow",e.href="https://maplibre.org/",e.setAttribute("aria-label",this._map._getUIString("LogoControl.Title")),e.setAttribute("rel","noopener nofollow"),this._container.appendChild(e),this._container.style.display="block",this._map.on("resize",this._updateCompact),this._updateCompact(),this._container}onRemove(){f.remove(this._container),this._map.off("resize",this._updateCompact),this._map=void 0,this._compact=void 0}}class sn{constructor(){this._queue=[],this._id=0,this._cleared=!1,this._currentlyRunning=!1}add(e){var t=++this._id;return this._queue.push({callback:e,id:t,cancelled:!1}),t}remove(e){var t=this._currentlyRunning;for(const r of t?this._queue.concat(t):this._queue)if(r.id===e)return void(r.cancelled=!0)}run(e=0){if(this._currentlyRunning)throw new Error("Attempting to run(), but is already running.");var t=this._currentlyRunning=this._queue;this._queue=[];for(const r of t)if(!r.cancelled&&(r.callback(e),this._cleared))break;this._cleared=!1,this._currentlyRunning=!1}clear(){this._currentlyRunning&&(this._cleared=!0),this._queue=[]}}var ln=de.createLayout([{name:"a_pos3d",type:"Int16",components:3}]);class cn extends de.Evented{constructor(e){super(),this.sourceCache=e,this._tiles={},this._renderableTilesKeys=[],this._sourceTileCache={},this.minzoom=0,this.maxzoom=22,this.tileSize=512,this.deltaZoom=1,e.usedForTerrain=!0,e.tileSize=this.tileSize*2**this.deltaZoom}destruct(){this.sourceCache.usedForTerrain=!1,this.sourceCache.tileSize=null}update(e,t){this.sourceCache.update(e,t),this._renderableTilesKeys=[];var r={};for(const i of e.coveringTiles({tileSize:this.tileSize,minzoom:this.minzoom,maxzoom:this.maxzoom,reparseOverscaled:!1,terrain:t}))r[i.key]=!0,this._renderableTilesKeys.push(i.key),this._tiles[i.key]||(i.posMatrix=new Float64Array(16),de.ortho(i.posMatrix,0,de.EXTENT,0,de.EXTENT,0,1),this._tiles[i.key]=new Ce(i,this.tileSize));for(const n in this._tiles)r[n]||delete this._tiles[n]}freeRtt(e){for(const r in this._tiles){var t=this._tiles[r];(!e||t.tileID.equals(e)||t.tileID.isChildOf(e)||e.isChildOf(t.tileID))&&(t.rtt=[])}}getRenderableTiles(){return this._renderableTilesKeys.map(e=>this.getTileByID(e))}getTileByID(e){return this._tiles[e]}getTerrainCoords(e){var t={};for(const l of this._renderableTilesKeys){var r,i,n,o,a,s=this._tiles[l].tileID;s.canonical.equals(e.canonical)?((r=e.clone()).posMatrix=new Float64Array(16),de.ortho(r.posMatrix,0,de.EXTENT,0,de.EXTENT,0,1),t[l]=r):s.canonical.isChildOf(e.canonical)?((r=e.clone()).posMatrix=new Float64Array(16),o=s.canonical.z-e.canonical.z,i=s.canonical.x-(s.canonical.x>>o<<o),n=s.canonical.y-(s.canonical.y>>o<<o),o=de.EXTENT>>o,de.ortho(r.posMatrix,0,o,0,o,0,1),de.translate(r.posMatrix,r.posMatrix,[-i*o,-n*o,0]),t[l]=r):e.canonical.isChildOf(s.canonical)&&((i=e.clone()).posMatrix=new Float64Array(16),n=e.canonical.z-s.canonical.z,o=e.canonical.x-(e.canonical.x>>n<<n),s=e.canonical.y-(e.canonical.y>>n<<n),a=de.EXTENT>>n,de.ortho(i.posMatrix,0,de.EXTENT,0,de.EXTENT,0,1),de.translate(i.posMatrix,i.posMatrix,[o*a,s*a,0]),de.scale(i.posMatrix,i.posMatrix,[1/2**n,1/2**n,0]),t[l]=i)}return t}getSourceTile(e,t){var r=this.sourceCache._source;let i=e.overscaledZ-this.deltaZoom;if((i=i>r.maxzoom?r.maxzoom:i)<r.minzoom)return null;this._sourceTileCache[e.key]||(this._sourceTileCache[e.key]=e.scaledTo(i).key);let n=this.sourceCache.getTileByID(this._sourceTileCache[e.key]);if((!n||!n.dem)&&t)for(;i>=r.minzoom&&(!n||!n.dem);)n=this.sourceCache.getTileByID(e.scaledTo(i--).key);return n}tilesAfterTime(t=Date.now()){return Object.values(this._tiles).filter(e=>e.timeAdded>=t)}}class un{constructor(e,t,r){this.painter=e,this.sourceCache=new cn(t),this.options=r,this.exaggeration="number"==typeof r.exaggeration?r.exaggeration:1,this.qualityFactor=2,this.meshSize=128,this._demMatrixCache={},this.coordsIndex=[],this._coordsTextureSize=1024}getDEMElevation(e,t,r,i=de.EXTENT){var n;return 0<=t&&t<i&&0<=r&&r<i&&(n=null==(n=(e=this.getTerrainData(e)).tile)?void 0:n.dem)?(r=[(t=de.transformMat4$1([],[t/i*de.EXTENT,r/i*de.EXTENT],e.u_terrain_matrix))[0]*n.dim,t[1]*n.dim],i=Math.floor(r[0]),e=Math.floor(r[1]),t=r[0]-i,r=r[1]-e,n.get(i,e)*(1-t)*(1-r)+n.get(i+1,e)*t*(1-r)+n.get(i,e+1)*(1-t)*r+n.get(i+1,e+1)*t*r):0}getElevationForLngLatZoom(e,t){var{tileID:e,mercatorX:t,mercatorY:r}=this._getOverscaledTileIDFromLngLatZoom(e,t);return this.getElevation(e,t%de.EXTENT,r%de.EXTENT,de.EXTENT)}getElevation(e,t,r,i=de.EXTENT){return this.getDEMElevation(e,t,r,i)*this.exaggeration}getTerrainData(t){this._emptyDemTexture||(e=this.painter.context,r=new de.RGBAImage({width:1,height:1},new Uint8Array(4)),this._emptyDepthTexture=new N(e,r,e.gl.RGBA,{premultiply:!1}),this._emptyDemUnpack=[0,0,0,0],this._emptyDemTexture=new N(e,new de.RGBAImage({width:1,height:1}),e.gl.RGBA,{premultiply:!1}),this._emptyDemTexture.bind(e.gl.NEAREST,e.gl.CLAMP_TO_EDGE),this._emptyDemMatrix=de.identity([]));var r=this.sourceCache.getSourceTile(t,!0),e=(r&&r.dem&&(!r.demTexture||r.needsTerrainPrepare)&&(e=this.painter.context,r.demTexture=this.painter.getTileTexture(r.dem.stride),r.demTexture?r.demTexture.update(r.dem.getPixels(),{premultiply:!1}):r.demTexture=new N(e,r.dem.getPixels(),e.gl.RGBA,{premultiply:!1}),r.demTexture.bind(e.gl.NEAREST,e.gl.CLAMP_TO_EDGE),r.needsTerrainPrepare=!1),r&&r+r.tileID.key+t.key);if(e&&!this._demMatrixCache[e]){var i=this.sourceCache.sourceCache._source.maxzoom;let e=t.canonical.z-r.tileID.canonical.z;t.overscaledZ>t.canonical.z&&(t.canonical.z>=i?e=t.canonical.z-i:de.warnOnce("cannot calculate elevation if elevation maxzoom > source.maxzoom"));var i=t.canonical.x-(t.canonical.x>>e<<e),n=t.canonical.y-(t.canonical.y>>e<<e),o=de.fromScaling(new Float64Array(16),[1/(de.EXTENT<<e),1/(de.EXTENT<<e),0]);de.translate(o,o,[i*de.EXTENT,n*de.EXTENT,0]),this._demMatrixCache[t.key]={matrix:o,coord:t}}return{u_depth:2,u_terrain:3,u_terrain_dim:r&&r.dem&&r.dem.dim||1,u_terrain_matrix:e?this._demMatrixCache[t.key].matrix:this._emptyDemMatrix,u_terrain_unpack:r&&r.dem&&r.dem.getUnpackVector()||this._emptyDemUnpack,u_terrain_exaggeration:this.exaggeration,texture:(r&&r.demTexture||this._emptyDemTexture).texture,depthTexture:(this._fboDepthTexture||this._emptyDepthTexture).texture,tile:r}}getFramebuffer(e){var t=this.painter,r=t.width/devicePixelRatio,i=t.height/devicePixelRatio;return!this._fbo||this._fbo.width===r&&this._fbo.height===i||(this._fbo.destroy(),this._fboCoordsTexture.destroy(),this._fboDepthTexture.destroy(),delete this._fbo,delete this._fboDepthTexture,delete this._fboCoordsTexture),this._fboCoordsTexture||(this._fboCoordsTexture=new N(t.context,{width:r,height:i,data:null},t.context.gl.RGBA,{premultiply:!1}),this._fboCoordsTexture.bind(t.context.gl.NEAREST,t.context.gl.CLAMP_TO_EDGE)),this._fboDepthTexture||(this._fboDepthTexture=new N(t.context,{width:r,height:i,data:null},t.context.gl.RGBA,{premultiply:!1}),this._fboDepthTexture.bind(t.context.gl.NEAREST,t.context.gl.CLAMP_TO_EDGE)),this._fbo||(this._fbo=t.context.createFramebuffer(r,i,!0,!1),this._fbo.depthAttachment.set(t.context.createRenderbuffer(t.context.gl.DEPTH_COMPONENT16,r,i))),this._fbo.colorAttachment.set(("coords"===e?this._fboCoordsTexture:this._fboDepthTexture).texture),this._fbo}getCoordsTexture(){var e=this.painter.context;if(this._coordsTexture)return this._coordsTexture;var i=new Uint8Array(this._coordsTextureSize*this._coordsTextureSize*4);for(let t=0,r=0;t<this._coordsTextureSize;t++)for(let e=0;e<this._coordsTextureSize;e++,r+=4)i[r+0]=255&e,i[r+1]=255&t,i[r+2]=e>>8<<4|t>>8,i[r+3]=0;var t=new de.RGBAImage({width:this._coordsTextureSize,height:this._coordsTextureSize},new Uint8Array(i.buffer)),t=new N(e,t,e.gl.RGBA,{premultiply:!1});return t.bind(e.gl.NEAREST,e.gl.CLAMP_TO_EDGE),this._coordsTexture=t}pointCoordinate(e){this.painter.maybeDrawDepthAndCoords(!0);var t=new Uint8Array(4),r=this.painter.context,i=r.gl,n=Math.round(e.x*this.painter.pixelRatio/devicePixelRatio),e=Math.round(e.y*this.painter.pixelRatio/devicePixelRatio),o=Math.round(this.painter.height/devicePixelRatio),n=(r.bindFramebuffer.set(this.getFramebuffer("coords").framebuffer),i.readPixels(n,o-e-1,1,1,i.RGBA,i.UNSIGNED_BYTE,t),r.bindFramebuffer.set(null),t[0]+(t[2]>>4<<8)),o=t[1]+((15&t[2])<<8),e=this.coordsIndex[255-t[3]],i=e&&this.sourceCache.getTileByID(e);return i?(r=this._coordsTextureSize,t=(1<<i.tileID.canonical.z)*r,new de.MercatorCoordinate((i.tileID.canonical.x*r+n)/t+i.tileID.wrap,(i.tileID.canonical.y*r+o)/t,this.getElevation(i.tileID,n,o,r))):null}depthAtPoint(e){var t=new Uint8Array(4),r=this.painter.context,i=r.gl,e=(r.bindFramebuffer.set(this.getFramebuffer("depth").framebuffer),i.readPixels(e.x,this.painter.height/devicePixelRatio-e.y-1,1,1,i.RGBA,i.UNSIGNED_BYTE,t),r.bindFramebuffer.set(null),(t[0]/16777216+t[1]/65536+t[2]/256+t[3])/256);return e}getTerrainMesh(){if(!this._mesh){var e=this.painter.context,r=new de.Pos3dArray,i=new de.TriangleIndexArray,n=this.meshSize,o=de.EXTENT/n,a=n*n;for(let t=0;t<=n;t++)for(let e=0;e<=n;e++)r.emplaceBack(e*o,t*o,0);for(let t=0;t<a;t+=n+1)for(let e=0;e<n;e++)i.emplaceBack(e+t,n+e+t+1,n+e+t+2),i.emplaceBack(e+t,n+e+t+2,e+t+1);var t=r.length,s=t+2*(n+1);for(const u of[0,1])for(let e=0;e<=n;e++)for(const h of[0,1])r.emplaceBack(e*o,u*de.EXTENT,h);for(let e=0;e<2*n;e+=2)i.emplaceBack(s+e,s+e+1,s+e+3),i.emplaceBack(s+e,s+e+3,s+e+2),i.emplaceBack(t+e,t+e+3,t+e+1),i.emplaceBack(t+e,t+e+2,t+e+3);var l=r.length,c=l+2*(n+1);for(const d of[0,1])for(let e=0;e<=n;e++)for(const p of[0,1])r.emplaceBack(d*de.EXTENT,e*o,p);for(let e=0;e<2*n;e+=2)i.emplaceBack(l+e,l+e+1,l+e+3),i.emplaceBack(l+e,l+e+3,l+e+2),i.emplaceBack(c+e,c+e+3,c+e+1),i.emplaceBack(c+e,c+e+2,c+e+3);this._mesh={indexBuffer:e.createIndexBuffer(i),vertexBuffer:e.createVertexBuffer(r,ln.members),segments:de.SegmentVector.simpleSegment(0,0,r.length,i.length)}}return this._mesh}getMeshFrameDelta(e){return 2*Math.PI*de.earthRadius/Math.pow(2,e)/5}getMinTileElevationForLngLatZoom(e,t){e=this._getOverscaledTileIDFromLngLatZoom(e,t).tileID;return null!=(t=this.getMinMaxElevation(e).minElevation)?t:0}getMinMaxElevation(e){var e=this.getTerrainData(e).tile,t={minElevation:null,maxElevation:null};return e&&e.dem&&(t.minElevation=e.dem.min*this.exaggeration,t.maxElevation=e.dem.max*this.exaggeration),t}_getOverscaledTileIDFromLngLatZoom(e,t){var e=de.MercatorCoordinate.fromLngLat(e.wrap()),r=(1<<t)*de.EXTENT,i=e.x*r,e=e.y*r,r=Math.floor(i/de.EXTENT),n=Math.floor(e/de.EXTENT);return{tileID:new de.OverscaledTileID(t,0,t,r,n),mercatorX:i,mercatorY:e}}}class hn{constructor(e,t,r){this._context=e,this._size=t,this._tileSize=r,this._objects=[],this._recentlyUsed=[],this._stamp=0}destruct(){for(const e of this._objects)e.texture.destroy(),e.fbo.destroy()}_createObject(e){var t=this._context.createFramebuffer(this._tileSize,this._tileSize,!0,!0),r=new N(this._context,{width:this._tileSize,height:this._tileSize,data:null},this._context.gl.RGBA);return r.bind(this._context.gl.LINEAR,this._context.gl.CLAMP_TO_EDGE),t.depthAttachment.set(this._context.createRenderbuffer(this._context.gl.DEPTH_STENCIL,this._tileSize,this._tileSize)),t.colorAttachment.set(r.texture),{id:e,fbo:t,texture:r,stamp:-1,inUse:!1}}getObjectForId(e){return this._objects[e]}useObject(t){t.inUse=!0,this._recentlyUsed=this._recentlyUsed.filter(e=>t.id!==e),this._recentlyUsed.push(t.id)}stampObject(e){e.stamp=++this._stamp}getOrCreateFreeObject(){for(const t of this._recentlyUsed)if(!this._objects[t].inUse)return this._objects[t];if(this._objects.length>=this._size)throw new Error("No free RenderPool available, call freeAllObjects() required!");var e=this._createObject(this._objects.length);return this._objects.push(e),e}freeObject(e){e.inUse=!1}freeAllObjects(){for(const e of this._objects)this.freeObject(e)}isFull(){return!(this._objects.length<this._size)&&!1===this._objects.some(e=>!e.inUse)}}const b={background:!0,fill:!0,line:!0,raster:!0,hillshade:!0};class dn{constructor(e,t){this.painter=e,this.terrain=t,this.pool=new hn(e.context,30,t.sourceCache.tileSize*t.qualityFactor)}destruct(){this.pool.destruct()}getTexture(e){return this.pool.getObjectForId(e.rtt[this._stacks.length-1].id).texture}prepareForRender(t,r){this._stacks=[],this._prevType=null,this._rttTiles=[],this._renderableTiles=this.terrain.sourceCache.getRenderableTiles(),this._renderableLayerIds=t._order.filter(e=>!t._layers[e].isHidden(r)),this._coordsDescendingInv={};for(const a in t.sourceCaches){this._coordsDescendingInv[a]={};for(const s of t.sourceCaches[a].getVisibleCoordinates()){var e=this.terrain.sourceCache.getTerrainCoords(s);for(const l in e)this._coordsDescendingInv[a][l]||(this._coordsDescendingInv[a][l]=[]),this._coordsDescendingInv[a][l].push(e[l])}}this._coordsDescendingInvStr={};for(const c of t._order){var i=t._layers[c],n=i.source;if(b[i.type]&&!this._coordsDescendingInvStr[n]){this._coordsDescendingInvStr[n]={};for(const u in this._coordsDescendingInv[n])this._coordsDescendingInvStr[n][u]=this._coordsDescendingInv[n][u].map(e=>e.key).sort().join()}}for(const h of this._renderableTiles)for(const d in this._coordsDescendingInvStr){var o=this._coordsDescendingInvStr[d][h.tileID.key];o&&o!==h.rttCoords[d]&&(h.rtt=[])}}renderLayer(t){if(!t.isHidden(this.painter.transform.zoom)){var e=t.type,r=this.painter,i=this._renderableLayerIds[this._renderableLayerIds.length-1]===t.id;if(b[e]&&(this._prevType&&b[this._prevType]||this._stacks.push([]),this._prevType=e,this._stacks[this._stacks.length-1].push(t.id),!i))return!0;if(b[this._prevType]||b[e]&&i){this._prevType=e;var n=this._stacks.length-1,o=this._stacks[n]||[];for(const c of this._renderableTiles){if(this.pool.isFull()&&(ti(this.painter,this.terrain,this._rttTiles),this._rttTiles=[],this.pool.freeAllObjects()),this._rttTiles.push(c),c.rtt[n]){var a=this.pool.getObjectForId(c.rtt[n].id);if(a.stamp===c.rtt[n].stamp){this.pool.useObject(a);continue}}var s=this.pool.getOrCreateFreeObject();this.pool.useObject(s),this.pool.stampObject(s),c.rtt[n]={id:s.id,stamp:s.stamp},r.context.bindFramebuffer.set(s.fbo.framebuffer),r.context.clear({color:de.Color.transparent,stencil:0}),r.currentStencilSource=void 0;for(let e=0;e<o.length;e++){const t=r.style._layers[o[e]];var l=t.source?this._coordsDescendingInv[t.source][c.tileID.key]:[c.tileID];r.context.viewport.set([0,0,s.fbo.width,s.fbo.height]),r._renderTileClippingMasks(t,l),r.renderLayer(r,r.style.sourceCaches[t.source],t,l),t.source&&(c.rttCoords[t.source]=this._coordsDescendingInvStr[t.source][c.tileID.key])}}return ti(this.painter,this.terrain,this._rttTiles),this._rttTiles=[],this.pool.freeAllObjects(),b[e]}}return!1}}const pn={"AttributionControl.ToggleAttribution":"Toggle attribution","AttributionControl.MapFeedback":"Map feedback","FullscreenControl.Enter":"Enter fullscreen","FullscreenControl.Exit":"Exit fullscreen","GeolocateControl.FindMyLocation":"Find my location","GeolocateControl.LocationNotAvailable":"Location not available","LogoControl.Title":"MapLibre logo","NavigationControl.ResetBearing":"Reset bearing to north","NavigationControl.ZoomIn":"Zoom in","NavigationControl.ZoomOut":"Zoom out","ScaleControl.Feet":"ft","ScaleControl.Meters":"m","ScaleControl.Kilometers":"km","ScaleControl.Miles":"mi","ScaleControl.NauticalMiles":"nm","TerrainControl.Enable":"Enable terrain","TerrainControl.Disable":"Disable terrain","CooperativeGesturesHandler.WindowsHelpText":"Use Ctrl + scroll to zoom the map","CooperativeGesturesHandler.MacHelpText":"Use ⌘ + scroll to zoom the map","CooperativeGesturesHandler.MobileHelpText":"Use two fingers to move the map"},fn=C,mn={center:[0,0],zoom:0,bearing:0,pitch:0,minZoom:-2,maxZoom:22,minPitch:0,maxPitch:60,interactive:!0,scrollZoom:!0,boxZoom:!0,dragRotate:!0,dragPan:!0,keyboard:!0,doubleClickZoom:!0,touchZoomRotate:!0,touchPitch:!0,cooperativeGestures:!1,bearingSnap:7,clickTolerance:3,pitchWithRotate:!0,hash:!1,attributionControl:nn,maplibreLogo:!1,failIfMajorPerformanceCaveat:!1,preserveDrawingBuffer:!1,trackResize:!0,renderWorldCopies:!0,refreshExpiredTiles:!0,maxTileCacheSize:null,maxTileCacheZoomLevels:de.config.MAX_TILE_CACHE_ZOOM_LEVELS,localIdeographFontFamily:"sans-serif",transformRequest:null,transformCameraUpdate:null,fadeDuration:300,crossSourceCollisions:!0,validateStyle:!0,maxCanvasSize:[4096,4096]};t=class extends rn{constructor(e){if(de.PerformanceUtils.mark(de.PerformanceMarkers.create),null!=(e=de.extend({},mn,e)).minZoom&&null!=e.maxZoom&&e.minZoom>e.maxZoom)throw new Error("maxZoom must be greater than or equal to minZoom");if(null!=e.minPitch&&null!=e.maxPitch&&e.minPitch>e.maxPitch)throw new Error("maxPitch must be greater than or equal to minPitch");if(null!=e.minPitch&&e.minPitch<0)throw new Error("minPitch must be greater than or equal to 0");if(null!=e.maxPitch&&85<e.maxPitch)throw new Error("maxPitch must be less than or equal to 85");if(super(new si(e.minZoom,e.maxZoom,e.minPitch,e.maxPitch,e.renderWorldCopies),{bearingSnap:e.bearingSnap}),this._contextLost=e=>{e.preventDefault(),this._frameRequest&&(this._frameRequest.abort(),this._frameRequest=null),this.fire(new de.Event("webglcontextlost",{originalEvent:e}))},this._contextRestored=e=>{this._setupPainter(),this.resize(),this._update(),this.fire(new de.Event("webglcontextrestored",{originalEvent:e}))},this._onMapScroll=e=>{if(e.target===this._container)return this._container.scrollTop=0,this._container.scrollLeft=0,!1},this._onWindowOnline=()=>{this._update()},this._interactive=e.interactive,this._maxTileCacheSize=e.maxTileCacheSize,this._maxTileCacheZoomLevels=e.maxTileCacheZoomLevels,this._failIfMajorPerformanceCaveat=e.failIfMajorPerformanceCaveat,this._preserveDrawingBuffer=e.preserveDrawingBuffer,this._antialias=e.antialias,this._trackResize=e.trackResize,this._bearingSnap=e.bearingSnap,this._refreshExpiredTiles=e.refreshExpiredTiles,this._fadeDuration=e.fadeDuration,this._crossSourceCollisions=e.crossSourceCollisions,this._crossFadingFactor=1,this._collectResourceTiming=e.collectResourceTiming,this._renderTaskQueue=new sn,this._controls=[],this._mapId=de.uniqueId(),this._locale=de.extend({},pn,e.locale),this._clickTolerance=e.clickTolerance,this._overridePixelRatio=e.pixelRatio,this._maxCanvasSize=e.maxCanvasSize,this.transformCameraUpdate=e.transformCameraUpdate,this._imageQueueHandle=h.addThrottleControl(()=>this.isMoving()),this._requestManager=new z(e.transformRequest),"string"==typeof e.container){if(this._container=document.getElementById(e.container),!this._container)throw new Error(`Container '${e.container}' not found.`)}else{if(!(e.container instanceof HTMLElement))throw new Error("Invalid type: 'container' must be a String or HTMLElement.");this._container=e.container}if(e.maxBounds&&this.setMaxBounds(e.maxBounds),this._setupContainer(),this._setupPainter(),this.on("move",()=>this._update(!1)),this.on("moveend",()=>this._update(!1)),this.on("zoom",()=>this._update(!0)),this.on("terrain",()=>{this.painter.terrainFacilitator.dirty=!0,this._update(!0)}),this.once("idle",()=>{this._idleTriggered=!0}),"undefined"!=typeof window){addEventListener("online",this._onWindowOnline,!1);let t=!1;const r=li(e=>{this._trackResize&&!this._removed&&this.resize(e)._update()},50);this._resizeObserver=new ResizeObserver(e=>{t?r(e):t=!0}),this._resizeObserver.observe(this._container)}this.handlers=new tn(this,e);var t="string"==typeof e.hash&&e.hash||void 0;this._hash=e.hash&&new ci(t).addTo(this),this._hash&&this._hash._onHashChange()||(this.jumpTo({center:e.center,zoom:e.zoom,bearing:e.bearing,pitch:e.pitch}),e.bounds&&(this.resize(),this.fitBounds(e.bounds,de.extend({},e.fitBoundsOptions,{duration:0})))),this.resize(),this._localIdeographFontFamily=e.localIdeographFontFamily,this._validateStyle=e.validateStyle,e.style&&this.setStyle(e.style,{localIdeographFontFamily:e.localIdeographFontFamily}),e.attributionControl&&this.addControl(new on("boolean"==typeof e.attributionControl?void 0:e.attributionControl)),e.maplibreLogo&&this.addControl(new an,e.logoPosition),this.on("style.load",()=>{this.transform.unmodified&&this.jumpTo(this.style.stylesheet)}),this.on("data",e=>{this._update("style"===e.dataType),this.fire(new de.Event(e.dataType+"data",e))}),this.on("dataloading",e=>{this.fire(new de.Event(e.dataType+"dataloading",e))}),this.on("dataabort",e=>{this.fire(new de.Event("sourcedataabort",e))})}_getMapId(){return this._mapId}addControl(e,t){var r;return void 0===t&&(t=e.getDefaultPosition?e.getDefaultPosition():"top-right"),e&&e.onAdd?(r=e.onAdd(this),this._controls.push(e),e=this._controlPositions[t],-1!==t.indexOf("bottom")?e.insertBefore(r,e.firstChild):e.appendChild(r),this):this.fire(new de.ErrorEvent(new Error("Invalid argument to map.addControl(). Argument must be a control with onAdd and onRemove methods.")))}removeControl(e){var t;return e&&e.onRemove?(-1<(t=this._controls.indexOf(e))&&this._controls.splice(t,1),e.onRemove(this),this):this.fire(new de.ErrorEvent(new Error("Invalid argument to map.removeControl(). Argument must be a control with onAdd and onRemove methods.")))}hasControl(e){return-1<this._controls.indexOf(e)}calculateCameraOptionsFromTo(e,t,r,i){return null==i&&this.terrain&&(i=this.terrain.getElevationForLngLatZoom(r,this.transform.tileZoom)),super.calculateCameraOptionsFromTo(e,t,r,i)}resize(e){var t=this._containerDimensions(),r=t[0],t=t[1];const i=this._getClampedPixelRatio(r,t);if(this._resizeCanvas(r,t,i),this.painter.resize(r,t,i),this.painter.overLimit()){var n=this.painter.context.gl;this._maxCanvasSize=[n.drawingBufferWidth,n.drawingBufferHeight];const i=this._getClampedPixelRatio(r,t);this._resizeCanvas(r,t,i),this.painter.resize(r,t,i)}this.transform.resize(r,t),null!=(n=this._requestedCameraState)&&n.resize(r,t);n=!this._moving;return n&&(this.stop(),this.fire(new de.Event("movestart",e)).fire(new de.Event("move",e))),this.fire(new de.Event("resize",e)),n&&this.fire(new de.Event("moveend",e)),this}_getClampedPixelRatio(e,t){var{0:r,1:i}=this._maxCanvasSize,n=this.getPixelRatio(),e=e*n,t=t*n;return Math.min(r<e?r/e:1,i<t?i/t:1)*n}getPixelRatio(){var e;return null!=(e=this._overridePixelRatio)?e:devicePixelRatio}setPixelRatio(e){this._overridePixelRatio=e,this.resize()}getBounds(){return this.transform.getBounds()}getMaxBounds(){return this.transform.getMaxBounds()}setMaxBounds(e){return this.transform.setMaxBounds(d.convert(e)),this._update()}setMinZoom(e){if(-2<=(e=null==e?-2:e)&&e<=this.transform.maxZoom)return this.transform.minZoom=e,this._update(),this.getZoom()<e&&this.setZoom(e),this;throw new Error("minZoom must be between -2 and the current maxZoom, inclusive")}getMinZoom(){return this.transform.minZoom}setMaxZoom(e){if((e=null==e?22:e)>=this.transform.minZoom)return this.transform.maxZoom=e,this._update(),this.getZoom()>e&&this.setZoom(e),this;throw new Error("maxZoom must be greater than the current minZoom")}getMaxZoom(){return this.transform.maxZoom}setMinPitch(e){if((e=null==e?0:e)<0)throw new Error("minPitch must be greater than or equal to 0");if(0<=e&&e<=this.transform.maxPitch)return this.transform.minPitch=e,this._update(),this.getPitch()<e&&this.setPitch(e),this;throw new Error("minPitch must be between 0 and the current maxPitch, inclusive")}getMinPitch(){return this.transform.minPitch}setMaxPitch(e){if(85<(e=null==e?60:e))throw new Error("maxPitch must be less than or equal to 85");if(e>=this.transform.minPitch)return this.transform.maxPitch=e,this._update(),this.getPitch()>e&&this.setPitch(e),this;throw new Error("maxPitch must be greater than the current minPitch")}getMaxPitch(){return this.transform.maxPitch}getRenderWorldCopies(){return this.transform.renderWorldCopies}setRenderWorldCopies(e){return this.transform.renderWorldCopies=e,this._update()}project(e){return this.transform.locationPoint(de.LngLat.convert(e),this.style&&this.terrain)}unproject(e){return this.transform.pointLocation(de.Point.convert(e),this.terrain)}isMoving(){var e;return this._moving||(null==(e=this.handlers)?void 0:e.isMoving())}isZooming(){var e;return this._zooming||(null==(e=this.handlers)?void 0:e.isZooming())}isRotating(){var e;return this._rotating||(null==(e=this.handlers)?void 0:e.isRotating())}_createDelegatedListener(i,n,o){if("mouseenter"===i||"mouseover"===i){let r=!1;return{layer:n,listener:o,delegates:{mousemove:e=>{var t=this.getLayer(n)?this.queryRenderedFeatures(e.point,{layers:[n]}):[];t.length?r||(r=!0,o.call(this,new l(i,this,e.originalEvent,{features:t}))):r=!1},mouseout:()=>{r=!1}}}}if("mouseleave"!==i&&"mouseout"!==i)return{layer:n,listener:o,delegates:{[i]:e=>{var t=this.getLayer(n)?this.queryRenderedFeatures(e.point,{layers:[n]}):[];t.length&&(e.features=t,o.call(this,e),delete e.features)}}};{let t=!1;return{layer:n,listener:o,delegates:{mousemove:e=>{(this.getLayer(n)?this.queryRenderedFeatures(e.point,{layers:[n]}):[]).length?t=!0:t&&(t=!1,o.call(this,new l(i,this,e.originalEvent)))},mouseout:e=>{t&&(t=!1,o.call(this,new l(i,this,e.originalEvent)))}}}}}on(e,t,r){if(void 0===r)return super.on(e,t);var i=this._createDelegatedListener(e,t,r);this._delegatedListeners=this._delegatedListeners||{},this._delegatedListeners[e]=this._delegatedListeners[e]||[],this._delegatedListeners[e].push(i);for(const n in i.delegates)this.on(n,i.delegates[n]);return this}once(e,t,r){if(void 0===r)return super.once(e,t);var i=this._createDelegatedListener(e,t,r);for(const n in i.delegates)this.once(n,i.delegates[n]);return this}off(n,o,a){return void 0===a?super.off(n,o):(this._delegatedListeners&&this._delegatedListeners[n]&&(e=>{var t=e[n];for(let e=0;e<t.length;e++){var r=t[e];if(r.layer===o&&r.listener===a){for(const i in r.delegates)this.off(i,r.delegates[i]);return t.splice(e,1),this}}})(this._delegatedListeners),this)}queryRenderedFeatures(e,t){if(!this.style)return[];let r;var i=e instanceof de.Point||Array.isArray(e),n=i?e:[[0,0],[this.transform.width,this.transform.height]];return t=t||(i?{}:e)||{},r=n instanceof de.Point||"number"==typeof n[0]?[de.Point.convert(n)]:(i=de.Point.convert(n[0]),e=de.Point.convert(n[1]),[i,new de.Point(e.x,i.y),e,new de.Point(i.x,e.y),i]),this.style.queryRenderedFeatures(r,t,this.transform)}querySourceFeatures(e,t){return this.style.querySourceFeatures(e,t)}setStyle(e,t){return!1!==(t=de.extend({},{localIdeographFontFamily:this._localIdeographFontFamily,validate:this._validateStyle},t)).diff&&t.localIdeographFontFamily===this._localIdeographFontFamily&&this.style&&e?(this._diffStyle(e,t),this):(this._localIdeographFontFamily=t.localIdeographFontFamily,this._updateStyle(e,t))}setTransformRequest(e){return this._requestManager.setTransformRequest(e),this}_getUIString(e){var t=this._locale[e];if(null==t)throw new Error(`Missing UI string '${e}'`);return t}_updateStyle(e,t){var r;if(!t.transformStyle||!this.style||this.style._loaded)return r=this.style&&t.transformStyle?this.style.serialize():void 0,this.style&&(this.style.setEventedParent(null),this.style._remove(!e)),e?(this.style=new mt(this,t||{}),this.style.setEventedParent(this,{style:this.style}),"string"==typeof e?this.style.loadURL(e,t,r):this.style.loadJSON(e,t,r)):delete this.style,this;this.style.once("style.load",()=>this._updateStyle(e,t))}_lazyInitEmptyStyle(){this.style||(this.style=new mt(this,{}),this.style.setEventedParent(this,{style:this.style}),this.style.loadEmpty())}_diffStyle(e,t){var r;"string"==typeof e?(r=this._requestManager.transformRequest(e,"Style"),de.getJSON(r,new AbortController).then(e=>{this._updateDiff(e.data,t)}).catch(e=>{e&&this.fire(new de.ErrorEvent(e))})):"object"==typeof e&&this._updateDiff(e,t)}_updateDiff(t,r){try{this.style.setState(t,r)&&this._update(!0)}catch(e){de.warnOnce(`Unable to perform style diff: ${e.message||e.error||e}.  Rebuilding the style from scratch.`),this._updateStyle(t,r)}}getStyle(){if(this.style)return this.style.serialize()}isStyleLoaded(){return this.style?this.style.loaded():de.warnOnce("There is no style added to the map.")}addSource(e,t){return this._lazyInitEmptyStyle(),this.style.addSource(e,t),this._update(!0)}isSourceLoaded(e){var t=this.style&&this.style.sourceCaches[e];if(void 0!==t)return t.loaded();this.fire(new de.ErrorEvent(new Error(`There is no source with ID '${e}'`)))}setTerrain(t){if(this.style._checkLoaded(),this._terrainDataCallback&&this.style.off("data",this._terrainDataCallback),t){var e=this.style.sourceCaches[t.source];if(!e)throw new Error("cannot load terrain, because there exists no source with ID: "+t.source);null===this.terrain&&e.reload();for(const i in this.style._layers){var r=this.style._layers[i];"hillshade"===r.type&&r.source===t.source&&de.warnOnce("You are using the same source for a hillshade layer and for 3D terrain. Please consider using two separate sources to improve rendering quality.")}this.terrain=new un(this.painter,e,t),this.painter.renderToTexture=new dn(this.painter,this.terrain),this.transform.minElevationForCurrentTile=this.terrain.getMinTileElevationForLngLatZoom(this.transform.center,this.transform.tileZoom),this.transform.elevation=this.terrain.getElevationForLngLatZoom(this.transform.center,this.transform.tileZoom),this._terrainDataCallback=e=>{"style"===e.dataType?this.terrain.sourceCache.freeRtt():"source"===e.dataType&&e.tile&&(e.sourceId!==t.source||this._elevationFreeze||(this.transform.minElevationForCurrentTile=this.terrain.getMinTileElevationForLngLatZoom(this.transform.center,this.transform.tileZoom),this.transform.elevation=this.terrain.getElevationForLngLatZoom(this.transform.center,this.transform.tileZoom)),this.terrain.sourceCache.freeRtt(e.tile.tileID))},this.style.on("data",this._terrainDataCallback)}else this.terrain&&this.terrain.sourceCache.destruct(),this.terrain=null,this.painter.renderToTexture&&this.painter.renderToTexture.destruct(),this.painter.renderToTexture=null,this.transform.minElevationForCurrentTile=0,this.transform.elevation=0;return this.fire(new de.Event("terrain",{terrain:t})),this}getTerrain(){var e;return null!=(e=null==(e=this.terrain)?void 0:e.options)?e:null}areTilesLoaded(){var e=this.style&&this.style.sourceCaches;for(const i in e){var t=e[i]._tiles;for(const n in t){var r=t[n];if("loaded"!==r.state&&"errored"!==r.state)return!1}}return!0}removeSource(e){return this.style.removeSource(e),this._update(!0)}getSource(e){return this.style.getSource(e)}addImage(e,t,r={}){var i,n,o,a,{pixelRatio:r=1,sdf:s=!1,stretchX:l,stretchY:c,content:u,contentMatch:h}=r;this._lazyInitEmptyStyle();if(!(t instanceof HTMLImageElement||de.isImageBitmap(t)))return void 0===t.width||void 0===t.height?this.fire(new de.ErrorEvent(new Error("Invalid arguments to map.addImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`"))):({width:i,height:n,data:o}=t,a=t,this.style.addImage(e,{data:new de.RGBAImage({width:i,height:n},new Uint8Array(o)),pixelRatio:r,stretchX:l,stretchY:c,content:u,contentMatch:h,sdf:s,version:0,userImage:a}),a.onAdd&&a.onAdd(this,e),this);({width:i,height:n,data:o}=M.getImageData(t)),this.style.addImage(e,{data:new de.RGBAImage({width:i,height:n},o),pixelRatio:r,stretchX:l,stretchY:c,content:u,contentMatch:h,sdf:s,version:0})}updateImage(e,t){var r,i,n,o=this.style.getImage(e);return o?({width:n,height:r,data:i}=t instanceof HTMLImageElement||de.isImageBitmap(t)?M.getImageData(t):t,void 0===n||void 0===r?this.fire(new de.ErrorEvent(new Error("Invalid arguments to map.updateImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`"))):n!==o.data.width||r!==o.data.height?this.fire(new de.ErrorEvent(new Error("The width and height of the updated image must be that same as the previous version of the image"))):(n=!(t instanceof HTMLImageElement||de.isImageBitmap(t)),o.data.replace(i,n),this.style.updateImage(e,o),this)):this.fire(new de.ErrorEvent(new Error("The map has no image with that id. If you are adding a new image use `map.addImage(...)` instead.")))}getImage(e){return this.style.getImage(e)}hasImage(e){return e?!!this.style.getImage(e):(this.fire(new de.ErrorEvent(new Error("Missing required image id"))),!1)}removeImage(e){this.style.removeImage(e)}loadImage(e){return h.getImage(this._requestManager.transformRequest(e,"Image"),new AbortController)}listImages(){return this.style.listImages()}addLayer(e,t){return this._lazyInitEmptyStyle(),this.style.addLayer(e,t),this._update(!0)}moveLayer(e,t){return this.style.moveLayer(e,t),this._update(!0)}removeLayer(e){return this.style.removeLayer(e),this._update(!0)}getLayer(e){return this.style.getLayer(e)}getLayersOrder(){return this.style.getLayersOrder()}setLayerZoomRange(e,t,r){return this.style.setLayerZoomRange(e,t,r),this._update(!0)}setFilter(e,t,r={}){return this.style.setFilter(e,t,r),this._update(!0)}getFilter(e){return this.style.getFilter(e)}setPaintProperty(e,t,r,i={}){return this.style.setPaintProperty(e,t,r,i),this._update(!0)}getPaintProperty(e,t){return this.style.getPaintProperty(e,t)}setLayoutProperty(e,t,r,i={}){return this.style.setLayoutProperty(e,t,r,i),this._update(!0)}getLayoutProperty(e,t){return this.style.getLayoutProperty(e,t)}setGlyphs(e,t={}){return this._lazyInitEmptyStyle(),this.style.setGlyphs(e,t),this._update(!0)}getGlyphs(){return this.style.getGlyphsUrl()}addSprite(e,t,r={}){return this._lazyInitEmptyStyle(),this.style.addSprite(e,t,r,e=>{e||this._update(!0)}),this}removeSprite(e){return this._lazyInitEmptyStyle(),this.style.removeSprite(e),this._update(!0)}getSprite(){return this.style.getSprite()}setSprite(e,t={}){return this._lazyInitEmptyStyle(),this.style.setSprite(e,t,e=>{e||this._update(!0)}),this}setLight(e,t={}){return this._lazyInitEmptyStyle(),this.style.setLight(e,t),this._update(!0)}getLight(){return this.style.getLight()}setFeatureState(e,t){return this.style.setFeatureState(e,t),this._update()}removeFeatureState(e,t){return this.style.removeFeatureState(e,t),this._update()}getFeatureState(e){return this.style.getFeatureState(e)}getContainer(){return this._container}getCanvasContainer(){return this._canvasContainer}getCanvas(){return this._canvas}_containerDimensions(){let e=0,t=0;return this._container&&(e=this._container.clientWidth||400,t=this._container.clientHeight||300),[e,t]}_setupContainer(){var e=this._container,t=(e.classList.add("maplibregl-map"),this._canvasContainer=f.create("div","maplibregl-canvas-container",e)),t=(this._interactive&&t.classList.add("maplibregl-interactive"),this._canvas=f.create("canvas","maplibregl-canvas",t),this._canvas.addEventListener("webglcontextlost",this._contextLost,!1),this._canvas.addEventListener("webglcontextrestored",this._contextRestored,!1),this._canvas.setAttribute("tabindex","0"),this._canvas.setAttribute("aria-label","Map"),this._canvas.setAttribute("role","region"),this._containerDimensions()),r=this._getClampedPixelRatio(t[0],t[1]);this._resizeCanvas(t[0],t[1],r);const i=this._controlContainer=f.create("div","maplibregl-control-container",e),n=this._controlPositions={};["top-left","top-right","bottom-left","bottom-right"].forEach(e=>{n[e]=f.create("div",`maplibregl-ctrl-${e} `,i)}),this._container.addEventListener("scroll",this._onMapScroll,!1)}_resizeCanvas(e,t,r){this._canvas.width=Math.floor(r*e),this._canvas.height=Math.floor(r*t),this._canvas.style.width=e+"px",this._canvas.style.height=t+"px"}_setupPainter(){const t={alpha:!0,stencil:!0,depth:!0,failIfMajorPerformanceCaveat:this._failIfMajorPerformanceCaveat,preserveDrawingBuffer:this._preserveDrawingBuffer,antialias:this._antialias||!1};let r=null;this._canvas.addEventListener("webglcontextcreationerror",e=>{r={requestedAttributes:t},e&&(r.statusMessage=e.statusMessage,r.type=e.type)},{once:!0});var e,i=this._canvas.getContext("webgl2",t)||this._canvas.getContext("webgl",t);if(!i)throw e="Failed to initialize WebGL",r?(r.message=e,new Error(JSON.stringify(r))):new Error(e);this.painter=new ri(i,this.transform),A.testSupport(i)}loaded(){return!this._styleDirty&&!this._sourcesDirty&&!!this.style&&this.style.loaded()}_update(e){return this.style&&this.style._loaded&&(this._styleDirty=this._styleDirty||e,this._sourcesDirty=!0,this.triggerRepaint()),this}_requestRenderFrame(e){return this._update(),this._renderTaskQueue.add(e)}_cancelRenderFrame(e){this._renderTaskQueue.remove(e)}_render(t){var r=this._idleTriggered?this._fadeDuration:0;if(this.painter.context.setDirty(),this.painter.setBaseState(),this._renderTaskQueue.run(t),!this._removed){let e=!1;this.style&&this._styleDirty&&(this._styleDirty=!1,t=this.transform.zoom,i=M.now(),this.style.zoomHistory.update(t,i),1===(i=(t=new de.EvaluationParameters(t,{now:i,fadeDuration:r,zoomHistory:this.style.zoomHistory,transition:this.style.getTransition()})).crossFadingFactor())&&i===this._crossFadingFactor||(e=!0,this._crossFadingFactor=i),this.style.update(t)),this.style&&this._sourcesDirty&&(this._sourcesDirty=!1,this.style._updateSources(this.transform)),this.terrain?(this.terrain.sourceCache.update(this.transform,this.terrain),this.transform.minElevationForCurrentTile=this.terrain.getMinTileElevationForLngLatZoom(this.transform.center,this.transform.tileZoom),this._elevationFreeze||(this.transform.elevation=this.terrain.getElevationForLngLatZoom(this.transform.center,this.transform.tileZoom))):(this.transform.minElevationForCurrentTile=0,this.transform.elevation=0),this._placementDirty=this.style&&this.style._updatePlacement(this.painter.transform,this.showCollisionBoxes,r,this._crossSourceCollisions),this.painter.render(this.style,{showTileBoundaries:this.showTileBoundaries,showOverdrawInspector:this._showOverdrawInspector,rotating:this.isRotating(),zooming:this.isZooming(),moving:this.isMoving(),fadeDuration:r,showPadding:this.showPadding}),this.fire(new de.Event("render")),this.loaded()&&!this._loaded&&(this._loaded=!0,de.PerformanceUtils.mark(de.PerformanceMarkers.load),this.fire(new de.Event("load"))),this.style&&(this.style.hasTransitions()||e)&&(this._styleDirty=!0),this.style&&!this._placementDirty&&this.style._releaseSymbolFadeTiles();var i=this._sourcesDirty||this._styleDirty||this._placementDirty;return i||this._repaint?this.triggerRepaint():!this.isMoving()&&this.loaded()&&this.fire(new de.Event("idle")),!this._loaded||this._fullyLoaded||i||(this._fullyLoaded=!0,de.PerformanceUtils.mark(de.PerformanceMarkers.fullLoad)),this}}redraw(){return this.style&&(this._frameRequest&&(this._frameRequest.abort(),this._frameRequest=null),this._render(0)),this}remove(){this._hash&&this._hash.remove();for(const t of this._controls)t.onRemove(this);this._controls=[],this._frameRequest&&(this._frameRequest.abort(),this._frameRequest=null),this._renderTaskQueue.clear(),this.painter.destroy(),this.handlers.destroy(),delete this.handlers,this.setStyle(null),"undefined"!=typeof window&&removeEventListener("online",this._onWindowOnline,!1),h.removeThrottleControl(this._imageQueueHandle),null!=(e=this._resizeObserver)&&e.disconnect();var e=this.painter.context.gl.getExtension("WEBGL_lose_context");e&&e.loseContext(),this._canvas.removeEventListener("webglcontextrestored",this._contextRestored,!1),this._canvas.removeEventListener("webglcontextlost",this._contextLost,!1),f.remove(this._canvasContainer),f.remove(this._controlContainer),this._container.classList.remove("maplibregl-map"),de.PerformanceUtils.clearMetrics(),this._removed=!0,this.fire(new de.Event("remove"))}triggerRepaint(){this.style&&!this._frameRequest&&(this._frameRequest=new AbortController,M.frameAsync(this._frameRequest).then(e=>{de.PerformanceUtils.frame(e),this._frameRequest=null,this._render(e)}).catch(()=>{}))}get showTileBoundaries(){return!!this._showTileBoundaries}set showTileBoundaries(e){this._showTileBoundaries!==e&&(this._showTileBoundaries=e,this._update())}get showPadding(){return!!this._showPadding}set showPadding(e){this._showPadding!==e&&(this._showPadding=e,this._update())}get showCollisionBoxes(){return!!this._showCollisionBoxes}set showCollisionBoxes(e){this._showCollisionBoxes!==e&&((this._showCollisionBoxes=e)?this.style._generateCollisionBoxes():this._update())}get showOverdrawInspector(){return!!this._showOverdrawInspector}set showOverdrawInspector(e){this._showOverdrawInspector!==e&&(this._showOverdrawInspector=e,this._update())}get repaint(){return!!this._repaint}set repaint(e){this._repaint!==e&&(this._repaint=e,this.triggerRepaint())}get vertices(){return!!this._vertices}set vertices(e){this._vertices=e,this._update()}get version(){return fn}getCameraTargetElevation(){return this.transform.elevation}};const gn=e=>{e.touchstart=e.dragStart,e.touchmoveWindow=e.dragMove,e.touchend=e.dragEnd},yn={showCompass:!0,showZoom:!0,visualizePitch:!1};class vn{constructor(e,t,r=!1){this.mousedown=e=>{this.startMouse(de.extend({},e,{ctrlKey:!0,preventDefault:()=>e.preventDefault()}),f.mousePos(this.element,e)),f.addEventListener(window,"mousemove",this.mousemove),f.addEventListener(window,"mouseup",this.mouseup)},this.mousemove=e=>{this.moveMouse(e,f.mousePos(this.element,e))},this.mouseup=e=>{this.mouseRotate.dragEnd(e),this.mousePitch&&this.mousePitch.dragEnd(e),this.offTemp()},this.touchstart=e=>{1!==e.targetTouches.length?this.reset():(this._startPos=this._lastPos=f.touchPos(this.element,e.targetTouches)[0],this.startTouch(e,this._startPos),f.addEventListener(window,"touchmove",this.touchmove,{passive:!1}),f.addEventListener(window,"touchend",this.touchend))},this.touchmove=e=>{1!==e.targetTouches.length?this.reset():(this._lastPos=f.touchPos(this.element,e.targetTouches)[0],this.moveTouch(e,this._lastPos))},this.touchend=e=>{0===e.targetTouches.length&&this._startPos&&this._lastPos&&this._startPos.dist(this._lastPos)<this._clickTolerance&&this.element.click(),delete this._startPos,delete this._lastPos,this.offTemp()},this.reset=()=>{this.mouseRotate.reset(),this.mousePitch&&this.mousePitch.reset(),this.touchRotate.reset(),this.touchPitch&&this.touchPitch.reset(),delete this._startPos,delete this._lastPos,this.offTemp()},this._clickTolerance=10;var i,n,o,a,s=e.dragRotate._mouseRotate.getClickTolerance(),l=e.dragRotate._mousePitch.getClickTolerance();this.element=t,this.mouseRotate=ki({clickTolerance:s,enable:!0}),this.touchRotate=([{enable:s,clickTolerance:n,bearingDegreesPerPixelMoved:i=.8}]=[{clickTolerance:s,enable:!0}],o=new Ii,new y({clickTolerance:n,move:(e,t)=>({bearingDelta:(t.x-e.x)*i}),moveStateManager:o,enable:s,assignEvents:gn})),this.map=e,r&&(this.mousePitch=Pi({clickTolerance:l,enable:!0}),this.touchPitch=([{enable:n,clickTolerance:o,pitchDegreesPerPixelMoved:a=-.5}]=[{clickTolerance:l,enable:!0}],s=new Ii,new y({clickTolerance:o,move:(e,t)=>({pitchDelta:(t.y-e.y)*a}),moveStateManager:s,enable:n,assignEvents:gn}))),f.addEventListener(t,"mousedown",this.mousedown),f.addEventListener(t,"touchstart",this.touchstart,{passive:!1}),f.addEventListener(t,"touchcancel",this.reset)}startMouse(e,t){this.mouseRotate.dragStart(e,t),this.mousePitch&&this.mousePitch.dragStart(e,t),f.disableDrag()}startTouch(e,t){this.touchRotate.dragStart(e,t),this.touchPitch&&this.touchPitch.dragStart(e,t),f.disableDrag()}moveMouse(e,t){var r=this.map,i=(this.mouseRotate.dragMove(e,t)||{})["bearingDelta"];i&&r.setBearing(r.getBearing()+i),this.mousePitch&&(i=(this.mousePitch.dragMove(e,t)||{})["pitchDelta"],i)&&r.setPitch(r.getPitch()+i)}moveTouch(e,t){var r=this.map,i=(this.touchRotate.dragMove(e,t)||{})["bearingDelta"];i&&r.setBearing(r.getBearing()+i),this.touchPitch&&(i=(this.touchPitch.dragMove(e,t)||{})["pitchDelta"],i)&&r.setPitch(r.getPitch()+i)}off(){var e=this.element;f.removeEventListener(e,"mousedown",this.mousedown),f.removeEventListener(e,"touchstart",this.touchstart,{passive:!1}),f.removeEventListener(window,"touchmove",this.touchmove,{passive:!1}),f.removeEventListener(window,"touchend",this.touchend),f.removeEventListener(e,"touchcancel",this.reset),this.offTemp()}offTemp(){f.enableDrag(),f.removeEventListener(window,"mousemove",this.mousemove),f.removeEventListener(window,"mouseup",this.mouseup),f.removeEventListener(window,"touchmove",this.touchmove,{passive:!1}),f.removeEventListener(window,"touchend",this.touchend)}}let w;function _n(e,t,r){var i,n,o,a=new de.LngLat(e.lng,e.lat);for(e=new de.LngLat(e.lng,e.lat),t&&(i=new de.LngLat(e.lng-360,e.lat),n=new de.LngLat(e.lng+360,e.lat),o=r.locationPoint(e).distSqr(t),r.locationPoint(i).distSqr(t)<o?e=i:r.locationPoint(n).distSqr(t)<o&&(e=n));180<Math.abs(e.lng-r.center.lng);){var s=r.locationPoint(e);if(0<=s.x&&0<=s.y&&s.x<=r.width&&s.y<=r.height)break;e.lng>r.center.lng?e.lng-=360:e.lng+=360}return e.lng!==a.lng&&r.locationPoint(e).y>r.height/2-r.getHorizon()?e:a}const bn={center:"translate(-50%,-50%)",top:"translate(-50%,0)","top-left":"translate(0,0)","top-right":"translate(-100%,0)",bottom:"translate(-50%,-100%)","bottom-left":"translate(0,-100%)","bottom-right":"translate(-100%,-100%)",left:"translate(0,-50%)",right:"translate(-100%,-50%)"};function wn(e,t,r){var i=e.classList;for(const n in bn)i.remove(`maplibregl-${r}-anchor-`+n);i.add(`maplibregl-${r}-anchor-`+t)}class xn extends de.Evented{constructor(e){if(super(),this._onKeyPress=e=>{var t=e.code,e=e.charCode||e.keyCode;"Space"!==t&&"Enter"!==t&&32!==e&&13!==e||this.togglePopup()},this._onMapClick=e=>{var e=e.originalEvent.target,t=this._element;this._popup&&(e===t||t.contains(e))&&this.togglePopup()},this._update=r=>{if(this._map){var i=this._map.loaded()&&!this._map.isMoving();"terrain"!==(null==r?void 0:r.type)&&("render"!==(null==r?void 0:r.type)||i)||this._map.once("render",this._update),this._map.transform.renderWorldCopies?this._lngLat=_n(this._lngLat,this._flatPos,this._map.transform):this._lngLat=null==(i=this._lngLat)?void 0:i.wrap(),this._flatPos=this._pos=this._map.project(this._lngLat)._add(this._offset),this._map.terrain&&(this._flatPos=this._map.transform.locationPoint(this._lngLat)._add(this._offset));let e="",t=("viewport"===this._rotationAlignment||"auto"===this._rotationAlignment?e=`rotateZ(${this._rotation}deg)`:"map"===this._rotationAlignment&&(e=`rotateZ(${this._rotation-this._map.getBearing()}deg)`),"");"viewport"===this._pitchAlignment||"auto"===this._pitchAlignment?t="rotateX(0deg)":"map"===this._pitchAlignment&&(t=`rotateX(${this._map.getPitch()}deg)`),r&&"moveend"!==r.type||(this._pos=this._pos.round()),f.setTransform(this._element,`${bn[this._anchor]} translate(${this._pos.x}px, ${this._pos.y}px) ${t} `+e),M.frameAsync(new AbortController).then(()=>{this._updateOpacity(r&&"moveend"===r.type)}).catch(()=>{})}},this._onMove=e=>{var t;this._isDragging||(t=this._clickTolerance||this._map._clickTolerance,this._isDragging=e.point.dist(this._pointerdownPos)>=t),this._isDragging&&(this._pos=e.point.sub(this._positionDelta),this._lngLat=this._map.unproject(this._pos),this.setLngLat(this._lngLat),this._element.style.pointerEvents="none","pending"===this._state&&(this._state="active",this.fire(new de.Event("dragstart"))),this.fire(new de.Event("drag")))},this._onUp=()=>{this._element.style.pointerEvents="auto",this._positionDelta=null,this._pointerdownPos=null,this._isDragging=!1,this._map.off("mousemove",this._onMove),this._map.off("touchmove",this._onMove),"active"===this._state&&this.fire(new de.Event("dragend")),this._state="inactive"},this._addDragHandler=e=>{this._element.contains(e.originalEvent.target)&&(e.preventDefault(),this._positionDelta=e.point.sub(this._pos).add(this._offset),this._pointerdownPos=e.point,this._state="pending",this._map.on("mousemove",this._onMove),this._map.on("touchmove",this._onMove),this._map.once("mouseup",this._onUp),this._map.once("touchend",this._onUp))},this._anchor=e&&e.anchor||"center",this._color=e&&e.color||"#3FB1CE",this._scale=e&&e.scale||1,this._draggable=e&&e.draggable||!1,this._clickTolerance=e&&e.clickTolerance||0,this._isDragging=!1,this._state="inactive",this._rotation=e&&e.rotation||0,this._rotationAlignment=e&&e.rotationAlignment||"auto",this._pitchAlignment=e&&e.pitchAlignment&&"auto"!==e.pitchAlignment?e.pitchAlignment:this._rotationAlignment,this.setOpacity(),this.setOpacity(null==e?void 0:e.opacity,null==e?void 0:e.opacityWhenCovered),e&&e.element)this._element=e.element,this._offset=de.Point.convert(e&&e.offset||[0,0]);else{this._defaultMarker=!0,this._element=f.create("div"),this._element.setAttribute("aria-label","Map marker");var t=f.createNS("http://www.w3.org/2000/svg","svg"),r=(t.setAttributeNS(null,"display","block"),t.setAttributeNS(null,"height","41px"),t.setAttributeNS(null,"width","27px"),t.setAttributeNS(null,"viewBox","0 0 27 41"),f.createNS("http://www.w3.org/2000/svg","g")),r=(r.setAttributeNS(null,"stroke","none"),r.setAttributeNS(null,"stroke-width","1"),r.setAttributeNS(null,"fill","none"),r.setAttributeNS(null,"fill-rule","evenodd"),f.createNS("http://www.w3.org/2000/svg","g")),i=(r.setAttributeNS(null,"fill-rule","nonzero"),f.createNS("http://www.w3.org/2000/svg","g")),n=(i.setAttributeNS(null,"transform","translate(3.0, 29.0)"),i.setAttributeNS(null,"fill","#000000"),[{rx:"10.5",ry:"5.25002273"},{rx:"10.5",ry:"5.25002273"},{rx:"9.5",ry:"4.77275007"},{rx:"8.5",ry:"4.29549936"},{rx:"7.5",ry:"3.81822308"},{rx:"6.5",ry:"3.34094679"},{rx:"5.5",ry:"2.86367051"},{rx:"4.5",ry:"2.38636864"}]);for(const h of n){var o=f.createNS("http://www.w3.org/2000/svg","ellipse");o.setAttributeNS(null,"opacity","0.04"),o.setAttributeNS(null,"cx","10.5"),o.setAttributeNS(null,"cy","5.80029008"),o.setAttributeNS(null,"rx",h.rx),o.setAttributeNS(null,"ry",h.ry),i.appendChild(o)}var n=f.createNS("http://www.w3.org/2000/svg","g"),a=(n.setAttributeNS(null,"fill",this._color),f.createNS("http://www.w3.org/2000/svg","path")),a=(a.setAttributeNS(null,"d","M27,13.5 C27,19.074644 20.250001,27.000002 14.75,34.500002 C14.016665,35.500004 12.983335,35.500004 12.25,34.500002 C6.7499993,27.000002 0,19.222562 0,13.5 C0,6.0441559 6.0441559,0 13.5,0 C20.955844,0 27,6.0441559 27,13.5 Z"),n.appendChild(a),f.createNS("http://www.w3.org/2000/svg","g")),s=(a.setAttributeNS(null,"opacity","0.25"),a.setAttributeNS(null,"fill","#000000"),f.createNS("http://www.w3.org/2000/svg","path")),s=(s.setAttributeNS(null,"d","M13.5,0 C6.0441559,0 0,6.0441559 0,13.5 C0,19.222562 6.7499993,27 12.25,34.5 C13,35.522727 14.016664,35.500004 14.75,34.5 C20.250001,27 27,19.074644 27,13.5 C27,6.0441559 20.955844,0 13.5,0 Z M13.5,1 C20.415404,1 26,6.584596 26,13.5 C26,15.898657 24.495584,19.181431 22.220703,22.738281 C19.945823,26.295132 16.705119,30.142167 13.943359,33.908203 C13.743445,34.180814 13.612715,34.322738 13.5,34.441406 C13.387285,34.322738 13.256555,34.180814 13.056641,33.908203 C10.284481,30.127985 7.4148684,26.314159 5.015625,22.773438 C2.6163816,19.232715 1,15.953538 1,13.5 C1,6.584596 6.584596,1 13.5,1 Z"),a.appendChild(s),f.createNS("http://www.w3.org/2000/svg","g")),l=(s.setAttributeNS(null,"transform","translate(6.0, 7.0)"),s.setAttributeNS(null,"fill","#FFFFFF"),f.createNS("http://www.w3.org/2000/svg","g")),c=(l.setAttributeNS(null,"transform","translate(8.0, 8.0)"),f.createNS("http://www.w3.org/2000/svg","circle")),u=(c.setAttributeNS(null,"fill","#000000"),c.setAttributeNS(null,"opacity","0.25"),c.setAttributeNS(null,"cx","5.5"),c.setAttributeNS(null,"cy","5.5"),c.setAttributeNS(null,"r","5.4999962"),f.createNS("http://www.w3.org/2000/svg","circle"));u.setAttributeNS(null,"fill","#FFFFFF"),u.setAttributeNS(null,"cx","5.5"),u.setAttributeNS(null,"cy","5.5"),u.setAttributeNS(null,"r","5.4999962"),l.appendChild(c),l.appendChild(u),r.appendChild(i),r.appendChild(n),r.appendChild(a),r.appendChild(s),r.appendChild(l),t.appendChild(r),t.setAttributeNS(null,"height",41*this._scale+"px"),t.setAttributeNS(null,"width",27*this._scale+"px"),this._element.appendChild(t),this._offset=de.Point.convert(e&&e.offset||[0,-14])}if(this._element.classList.add("maplibregl-marker"),this._element.addEventListener("dragstart",e=>{e.preventDefault()}),this._element.addEventListener("mousedown",e=>{e.preventDefault()}),wn(this._element,this._anchor,"marker"),e&&e.className)for(const d of e.className.split(" "))this._element.classList.add(d);this._popup=null}addTo(e){return this.remove(),(this._map=e).getCanvasContainer().appendChild(this._element),e.on("move",this._update),e.on("moveend",this._update),e.on("terrain",this._update),this.setDraggable(this._draggable),this._update(),this._map.on("click",this._onMapClick),this}remove(){return this._opacityTimeout&&(clearTimeout(this._opacityTimeout),delete this._opacityTimeout),this._map&&(this._map.off("click",this._onMapClick),this._map.off("move",this._update),this._map.off("moveend",this._update),this._map.off("mousedown",this._addDragHandler),this._map.off("touchstart",this._addDragHandler),this._map.off("mouseup",this._onUp),this._map.off("touchend",this._onUp),this._map.off("mousemove",this._onMove),this._map.off("touchmove",this._onMove),delete this._map),f.remove(this._element),this._popup&&this._popup.remove(),this}getLngLat(){return this._lngLat}setLngLat(e){return this._lngLat=de.LngLat.convert(e),this._pos=null,this._popup&&this._popup.setLngLat(this._lngLat),this._update(),this}getElement(){return this._element}setPopup(e){var t;return this._popup&&(this._popup.remove(),this._popup=null,this._element.removeEventListener("keypress",this._onKeyPress),this._originalTabIndex||this._element.removeAttribute("tabindex")),e&&("offset"in e.options||(t=Math.abs(13.5)/Math.SQRT2,e.options.offset=this._defaultMarker?{top:[0,0],"top-left":[0,0],"top-right":[0,0],bottom:[0,-38.1],"bottom-left":[t,-1*(24.6+t)],"bottom-right":[-t,-1*(24.6+t)],left:[13.5,-24.6],right:[-13.5,-24.6]}:this._offset),this._popup=e,this._originalTabIndex=this._element.getAttribute("tabindex"),this._originalTabIndex||this._element.setAttribute("tabindex","0"),this._element.addEventListener("keypress",this._onKeyPress)),this}getPopup(){return this._popup}togglePopup(){var e=this._popup;return this._element.style.opacity!==this._opacityWhenCovered&&e&&(e.isOpen()?e.remove():(e.setLngLat(this._lngLat),e.addTo(this._map))),this}_updateOpacity(e=!1){if(null==(r=this._map)?void 0:r.terrain){if(e)this._opacityTimeout=null;else{if(this._opacityTimeout)return;this._opacityTimeout=setTimeout(()=>{this._opacityTimeout=null},100)}var t,r=this._map,e=r.terrain.depthAtPoint(this._pos),i=r.terrain.getElevationForLngLatZoom(this._lngLat,r.transform.tileZoom);r.transform.lngLatToCameraDepth(this._lngLat,i)-e<.006?this._element.style.opacity=this._opacity:(e=-this._offset.y/r.transform._pixelPerMeter,e=Math.sin(r.getPitch()*Math.PI/180)*e,t=r.terrain.depthAtPoint(new de.Point(this._pos.x,this._pos.y-this._offset.y)),r=.006<r.transform.lngLatToCameraDepth(this._lngLat,i+e)-t,null!=(i=this._popup)&&i.isOpen()&&r&&this._popup.remove(),this._element.style.opacity=r?this._opacityWhenCovered:this._opacity)}else this._element.style.opacity!==this._opacity&&(this._element.style.opacity=this._opacity)}getOffset(){return this._offset}setOffset(e){return this._offset=de.Point.convert(e),this._update(),this}addClassName(e){this._element.classList.add(e)}removeClassName(e){this._element.classList.remove(e)}toggleClassName(e){return this._element.classList.toggle(e)}setDraggable(e){return this._draggable=!!e,this._map&&(e?(this._map.on("mousedown",this._addDragHandler),this._map.on("touchstart",this._addDragHandler)):(this._map.off("mousedown",this._addDragHandler),this._map.off("touchstart",this._addDragHandler))),this}isDraggable(){return this._draggable}setRotation(e){return this._rotation=e||0,this._update(),this}getRotation(){return this._rotation}setRotationAlignment(e){return this._rotationAlignment=e||"auto",this._update(),this}getRotationAlignment(){return this._rotationAlignment}setPitchAlignment(e){return this._pitchAlignment=e&&"auto"!==e?e:this._rotationAlignment,this._update(),this}getPitchAlignment(){return this._pitchAlignment}setOpacity(e,t){return void 0===e&&void 0===t&&(this._opacity="1",this._opacityWhenCovered="0.2"),void 0!==e&&(this._opacity=e),void 0!==t&&(this._opacityWhenCovered=t),this._map&&this._updateOpacity(!0),this}}const Cn={positionOptions:{enableHighAccuracy:!1,maximumAge:0,timeout:6e3},fitBoundsOptions:{maxZoom:15},trackUserLocation:!1,showAccuracyCircle:!0,showUserLocation:!0};let Tn=0,Sn=!1;class En extends de.Evented{constructor(e){super(),this._onSuccess=e=>{if(this._map){if(this._isOutOfMapMaxBounds(e))this._setErrorState(),this.fire(new de.Event("outofmaxbounds",e)),this._updateMarker();else{if(this.options.trackUserLocation)switch(this._lastKnownPosition=e,this._watchState){case"WAITING_ACTIVE":case"ACTIVE_LOCK":case"ACTIVE_ERROR":this._watchState="ACTIVE_LOCK",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active-error"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active");break;case"BACKGROUND":case"BACKGROUND_ERROR":this._watchState="BACKGROUND",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background-error"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-background");break;default:throw new Error("Unexpected watchState "+this._watchState)}this.options.showUserLocation&&"OFF"!==this._watchState&&this._updateMarker(e),this.options.trackUserLocation&&"ACTIVE_LOCK"!==this._watchState||this._updateCamera(e),this.options.showUserLocation&&this._dotElement.classList.remove("maplibregl-user-location-dot-stale"),this.fire(new de.Event("geolocate",e))}this._finish()}},this._updateCamera=e=>{var t=new de.LngLat(e.coords.longitude,e.coords.latitude),e=e.coords.accuracy,r=this._map.getBearing(),r=de.extend({bearing:r},this.options.fitBoundsOptions),t=d.fromLngLat(t,e);this._map.fitBounds(t,r,{geolocateSource:!0})},this._updateMarker=e=>{var t;e?(t=new de.LngLat(e.coords.longitude,e.coords.latitude),this._accuracyCircleMarker.setLngLat(t).addTo(this._map),this._userLocationDotMarker.setLngLat(t).addTo(this._map),this._accuracy=e.coords.accuracy,this.options.showUserLocation&&this.options.showAccuracyCircle&&this._updateCircleRadius()):(this._userLocationDotMarker.remove(),this._accuracyCircleMarker.remove())},this._onZoom=()=>{this.options.showUserLocation&&this.options.showAccuracyCircle&&this._updateCircleRadius()},this._onError=e=>{if(this._map){if(this.options.trackUserLocation)if(1===e.code){this._watchState="OFF",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active-error"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background-error"),this._geolocateButton.disabled=!0;var t=this._map._getUIString("GeolocateControl.LocationNotAvailable");this._geolocateButton.title=t,this._geolocateButton.setAttribute("aria-label",t),void 0!==this._geolocationWatchID&&this._clearWatch()}else{if(3===e.code&&Sn)return;this._setErrorState()}"OFF"!==this._watchState&&this.options.showUserLocation&&this._dotElement.classList.add("maplibregl-user-location-dot-stale"),this.fire(new de.Event("error",e)),this._finish()}},this._finish=()=>{this._timeoutId&&clearTimeout(this._timeoutId),this._timeoutId=void 0},this._setupUI=e=>{this._map&&(this._container.addEventListener("contextmenu",e=>e.preventDefault()),this._geolocateButton=f.create("button","maplibregl-ctrl-geolocate",this._container),f.create("span","maplibregl-ctrl-icon",this._geolocateButton).setAttribute("aria-hidden","true"),!(this._geolocateButton.type="button")===e?(de.warnOnce("Geolocation support is not available so the GeolocateControl will be disabled."),e=this._map._getUIString("GeolocateControl.LocationNotAvailable"),this._geolocateButton.disabled=!0,this._geolocateButton.title=e,this._geolocateButton.setAttribute("aria-label",e)):(e=this._map._getUIString("GeolocateControl.FindMyLocation"),this._geolocateButton.title=e,this._geolocateButton.setAttribute("aria-label",e)),this.options.trackUserLocation&&(this._geolocateButton.setAttribute("aria-pressed","false"),this._watchState="OFF"),this.options.showUserLocation&&(this._dotElement=f.create("div","maplibregl-user-location-dot"),this._userLocationDotMarker=new xn({element:this._dotElement}),this._circleElement=f.create("div","maplibregl-user-location-accuracy-circle"),this._accuracyCircleMarker=new xn({element:this._circleElement,pitchAlignment:"map"}),this.options.trackUserLocation&&(this._watchState="OFF"),this._map.on("zoom",this._onZoom)),this._geolocateButton.addEventListener("click",()=>this.trigger()),this._setup=!0,this.options.trackUserLocation)&&this._map.on("movestart",e=>{var t=e.originalEvent&&"resize"===e.originalEvent.type;e.geolocateSource||"ACTIVE_LOCK"!==this._watchState||t||(this._watchState="BACKGROUND",this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active"),this.fire(new de.Event("trackuserlocationend")))})},this.options=de.extend({},Cn,e)}onAdd(e){return this._map=e,this._container=f.create("div","maplibregl-ctrl maplibregl-ctrl-group"),function(){return de.__awaiter(this,arguments,void 0,function*(e=!1){if(void 0===w||e){if(void 0===window.navigator.permissions)return w=!!window.navigator.geolocation;try{var t=yield window.navigator.permissions.query({name:"geolocation"});w="denied"!==t.state}catch(e){w=!!window.navigator.geolocation}}return w})}().then(e=>this._setupUI(e)),this._container}onRemove(){void 0!==this._geolocationWatchID&&(window.navigator.geolocation.clearWatch(this._geolocationWatchID),this._geolocationWatchID=void 0),this.options.showUserLocation&&this._userLocationDotMarker&&this._userLocationDotMarker.remove(),this.options.showAccuracyCircle&&this._accuracyCircleMarker&&this._accuracyCircleMarker.remove(),f.remove(this._container),this._map.off("zoom",this._onZoom),this._map=void 0,Tn=0,Sn=!1}_isOutOfMapMaxBounds(e){var t=this._map.getMaxBounds(),e=e.coords;return t&&(e.longitude<t.getWest()||e.longitude>t.getEast()||e.latitude<t.getSouth()||e.latitude>t.getNorth())}_setErrorState(){switch(this._watchState){case"WAITING_ACTIVE":this._watchState="ACTIVE_ERROR",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active-error");break;case"ACTIVE_LOCK":this._watchState="ACTIVE_ERROR",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active-error"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting");break;case"BACKGROUND":this._watchState="BACKGROUND_ERROR",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-background-error"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting");break;case"ACTIVE_ERROR":break;default:throw new Error("Unexpected watchState "+this._watchState)}}_updateCircleRadius(){var e=this._map.getBounds(),t=e.getSouthEast(),e=e.getNorthEast(),t=t.distanceTo(e),e=this._map._container.clientHeight,t=Math.ceil(this._accuracy/(t/e)*2);this._circleElement.style.width=t+"px",this._circleElement.style.height=t+"px"}trigger(){if(!this._setup)return de.warnOnce("Geolocate control triggered before added to a map"),!1;if(this.options.trackUserLocation){switch(this._watchState){case"OFF":this._watchState="WAITING_ACTIVE",this.fire(new de.Event("trackuserlocationstart"));break;case"WAITING_ACTIVE":case"ACTIVE_LOCK":case"ACTIVE_ERROR":case"BACKGROUND_ERROR":Tn--,Sn=!1,this._watchState="OFF",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active-error"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background-error"),this.fire(new de.Event("trackuserlocationend"));break;case"BACKGROUND":this._watchState="ACTIVE_LOCK",this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background"),this._lastKnownPosition&&this._updateCamera(this._lastKnownPosition),this.fire(new de.Event("trackuserlocationstart"));break;default:throw new Error("Unexpected watchState "+this._watchState)}switch(this._watchState){case"WAITING_ACTIVE":this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting"),this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active");break;case"ACTIVE_LOCK":this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active");break;case"OFF":break;default:throw new Error("Unexpected watchState "+this._watchState)}if("OFF"===this._watchState&&void 0!==this._geolocationWatchID)this._clearWatch();else if(void 0===this._geolocationWatchID){this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting"),this._geolocateButton.setAttribute("aria-pressed","true"),Tn++;let e;Sn=1<Tn?(e={maximumAge:6e5,timeout:0},!0):(e=this.options.positionOptions,!1),this._geolocationWatchID=window.navigator.geolocation.watchPosition(this._onSuccess,this._onError,e)}}else window.navigator.geolocation.getCurrentPosition(this._onSuccess,this._onError,this.options.positionOptions),this._timeoutId=setTimeout(this._finish,1e4);return!0}_clearWatch(){window.navigator.geolocation.clearWatch(this._geolocationWatchID),this._geolocationWatchID=void 0,this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting"),this._geolocateButton.setAttribute("aria-pressed","false"),this.options.showUserLocation&&this._updateMarker(null)}}const In={maxWidth:100,unit:"metric"};function An(e,t,r){var i=r&&r.maxWidth||100,n=e._container.clientHeight/2,o=e.unproject([0,n]),n=e.unproject([i,n]),o=o.distanceTo(n);r&&"imperial"===r.unit?5280<(n=3.2808*o)?x(t,i,n/5280,e._getUIString("ScaleControl.Miles")):x(t,i,n,e._getUIString("ScaleControl.Feet")):r&&"nautical"===r.unit?x(t,i,o/1852,e._getUIString("ScaleControl.NauticalMiles")):1e3<=o?x(t,i,o/1e3,e._getUIString("ScaleControl.Kilometers")):x(t,i,o,e._getUIString("ScaleControl.Meters"))}function x(e,t,r,i){var n=function(e){var t=Math.pow(10,(""+Math.floor(e)).length-1);e/=t;return e=10<=e?10:5<=e?5:3<=e?3:2<=e?2:1<=e?1:function(e){var t=Math.pow(10,Math.ceil(-Math.log(e)/Math.LN10));return Math.round(e*t)/t}(e),t*e}(r);e.style.width=t*(n/r)+"px",e.innerHTML=n+"&nbsp;"+i}class kn extends de.Evented{constructor(e={}){super(),this._onFullscreenChange=()=>{var e;let t=window.document.fullscreenElement||window.document.mozFullScreenElement||window.document.webkitFullscreenElement||window.document.msFullscreenElement;for(;null!=(e=null===t||void 0===t?void 0:t.shadowRoot)&&e.fullscreenElement;)t=t.shadowRoot.fullscreenElement;t===this._container!==this._fullscreen&&this._handleFullscreenChange()},this._onClickFullscreen=()=>{this._isFullscreen()?this._exitFullscreen():this._requestFullscreen()},this._fullscreen=!1,e&&e.container&&(e.container instanceof HTMLElement?this._container=e.container:de.warnOnce("Full screen control 'container' must be a DOM element.")),"onfullscreenchange"in document?this._fullscreenchange="fullscreenchange":"onmozfullscreenchange"in document?this._fullscreenchange="mozfullscreenchange":"onwebkitfullscreenchange"in document?this._fullscreenchange="webkitfullscreenchange":"onmsfullscreenchange"in document&&(this._fullscreenchange="MSFullscreenChange")}onAdd(e){return this._map=e,this._container||(this._container=this._map.getContainer()),this._controlContainer=f.create("div","maplibregl-ctrl maplibregl-ctrl-group"),this._setupUI(),this._controlContainer}onRemove(){f.remove(this._controlContainer),this._map=null,window.document.removeEventListener(this._fullscreenchange,this._onFullscreenChange)}_setupUI(){var e=this._fullscreenButton=f.create("button","maplibregl-ctrl-fullscreen",this._controlContainer);f.create("span","maplibregl-ctrl-icon",e).setAttribute("aria-hidden","true"),e.type="button",this._updateTitle(),this._fullscreenButton.addEventListener("click",this._onClickFullscreen),window.document.addEventListener(this._fullscreenchange,this._onFullscreenChange)}_updateTitle(){var e=this._getTitle();this._fullscreenButton.setAttribute("aria-label",e),this._fullscreenButton.title=e}_getTitle(){return this._map._getUIString(this._isFullscreen()?"FullscreenControl.Exit":"FullscreenControl.Enter")}_isFullscreen(){return this._fullscreen}_handleFullscreenChange(){this._fullscreen=!this._fullscreen,this._fullscreenButton.classList.toggle("maplibregl-ctrl-shrink"),this._fullscreenButton.classList.toggle("maplibregl-ctrl-fullscreen"),this._updateTitle(),this._fullscreen?(this.fire(new de.Event("fullscreenstart")),this._prevCooperativeGesturesEnabled=this._map.cooperativeGestures.isEnabled(),this._map.cooperativeGestures.disable()):(this.fire(new de.Event("fullscreenend")),this._prevCooperativeGesturesEnabled&&this._map.cooperativeGestures.enable())}_exitFullscreen(){window.document.exitFullscreen?window.document.exitFullscreen():window.document.mozCancelFullScreen?window.document.mozCancelFullScreen():window.document.msExitFullscreen?window.document.msExitFullscreen():window.document.webkitCancelFullScreen?window.document.webkitCancelFullScreen():this._togglePseudoFullScreen()}_requestFullscreen(){this._container.requestFullscreen?this._container.requestFullscreen():this._container.mozRequestFullScreen?this._container.mozRequestFullScreen():this._container.msRequestFullscreen?this._container.msRequestFullscreen():this._container.webkitRequestFullscreen?this._container.webkitRequestFullscreen():this._togglePseudoFullScreen()}_togglePseudoFullScreen(){this._container.classList.toggle("maplibregl-pseudo-fullscreen"),this._handleFullscreenChange(),this._map.resize()}}const Pn={closeButton:!0,closeOnClick:!0,focusAfterOpen:!0,className:"",maxWidth:"240px",subpixelPositioning:!1},Mn=["a[href]","[tabindex]:not([tabindex='-1'])","[contenteditable]:not([contenteditable='false'])","button:not([disabled])","input:not([disabled])","select:not([disabled])","textarea:not([disabled])"].join(", ");class Rn extends de.Evented{constructor(e){super(),this.remove=()=>(this._content&&f.remove(this._content),this._container&&(f.remove(this._container),delete this._container),this._map&&(this._map.off("move",this._update),this._map.off("move",this._onClose),this._map.off("click",this._onClose),this._map.off("remove",this.remove),this._map.off("mousemove",this._onMouseMove),this._map.off("mouseup",this._onMouseUp),this._map.off("drag",this._onDrag),this._map._canvasContainer.classList.remove("maplibregl-track-pointer"),delete this._map,this.fire(new de.Event("close"))),this),this._onMouseUp=e=>{this._update(e.point)},this._onMouseMove=e=>{this._update(e.point)},this._onDrag=e=>{this._update(e.point)},this._update=r=>{var i=this._lngLat||this._trackPointer;if(this._map&&i&&this._content){if(!this._container){if(this._container=f.create("div","maplibregl-popup",this._map.getContainer()),this._tip=f.create("div","maplibregl-popup-tip",this._container),this._container.appendChild(this._content),this.options.className)for(const e of this.options.className.split(" "))this._container.classList.add(e);this._trackPointer&&this._container.classList.add("maplibregl-popup-track-pointer")}if(this.options.maxWidth&&this._container.style.maxWidth!==this.options.maxWidth&&(this._container.style.maxWidth=this.options.maxWidth),this._map.transform.renderWorldCopies&&!this._trackPointer?this._lngLat=_n(this._lngLat,this._flatPos,this._map.transform):this._lngLat=null==(i=this._lngLat)?void 0:i.wrap(),!this._trackPointer||r){i=this._flatPos=this._pos=this._trackPointer&&r?r:this._map.project(this._lngLat);this._map.terrain&&(this._flatPos=this._trackPointer&&r?r:this._map.transform.locationPoint(this._lngLat));let t=this.options.anchor;r=function e(t){{if(t){if("number"==typeof t){const r=Math.round(Math.abs(t)/Math.SQRT2);return{center:new de.Point(0,0),top:new de.Point(0,t),"top-left":new de.Point(r,r),"top-right":new de.Point(-r,r),bottom:new de.Point(0,-t),"bottom-left":new de.Point(r,-r),"bottom-right":new de.Point(-r,-r),left:new de.Point(t,0),right:new de.Point(-t,0)}}if(t instanceof de.Point||Array.isArray(t)){const i=de.Point.convert(t);return{center:i,top:i,"top-left":i,"top-right":i,bottom:i,"bottom-left":i,"bottom-right":i,left:i,right:i}}return{center:de.Point.convert(t.center||[0,0]),top:de.Point.convert(t.top||[0,0]),"top-left":de.Point.convert(t["top-left"]||[0,0]),"top-right":de.Point.convert(t["top-right"]||[0,0]),bottom:de.Point.convert(t.bottom||[0,0]),"bottom-left":de.Point.convert(t["bottom-left"]||[0,0]),"bottom-right":de.Point.convert(t["bottom-right"]||[0,0]),left:de.Point.convert(t.left||[0,0]),right:de.Point.convert(t.right||[0,0])}}return e(new de.Point(0,0))}}(this.options.offset);if(!t){var n=this._container.offsetWidth,o=this._container.offsetHeight;let e;e=i.y+r.bottom.y<o?["top"]:i.y>this._map.transform.height-o?["bottom"]:[],i.x<n/2?e.push("left"):i.x>this._map.transform.width-n/2&&e.push("right"),t=0===e.length?"bottom":e.join("-")}let e=i.add(r[t]);this.options.subpixelPositioning||(e=e.round()),f.setTransform(this._container,`${bn[t]} translate(${e.x}px,${e.y}px)`),wn(this._container,t,"popup")}}},this._onClose=()=>{this.remove()},this.options=de.extend(Object.create(Pn),e)}addTo(e){return this._map&&this.remove(),this._map=e,this.options.closeOnClick&&this._map.on("click",this._onClose),this.options.closeOnMove&&this._map.on("move",this._onClose),this._map.on("remove",this.remove),this._update(),this._focusFirstElement(),this._trackPointer?(this._map.on("mousemove",this._onMouseMove),this._map.on("mouseup",this._onMouseUp),this._container&&this._container.classList.add("maplibregl-popup-track-pointer"),this._map._canvasContainer.classList.add("maplibregl-track-pointer")):this._map.on("move",this._update),this.fire(new de.Event("open")),this}isOpen(){return!!this._map}getLngLat(){return this._lngLat}setLngLat(e){return this._lngLat=de.LngLat.convert(e),this._pos=null,this._flatPos=null,this._trackPointer=!1,this._update(),this._map&&(this._map.on("move",this._update),this._map.off("mousemove",this._onMouseMove),this._container&&this._container.classList.remove("maplibregl-popup-track-pointer"),this._map._canvasContainer.classList.remove("maplibregl-track-pointer")),this}trackPointer(){return this._trackPointer=!0,this._pos=null,this._flatPos=null,this._update(),this._map&&(this._map.off("move",this._update),this._map.on("mousemove",this._onMouseMove),this._map.on("drag",this._onDrag),this._container&&this._container.classList.add("maplibregl-popup-track-pointer"),this._map._canvasContainer.classList.add("maplibregl-track-pointer")),this}getElement(){return this._container}setText(e){return this.setDOMContent(document.createTextNode(e))}setHTML(e){var t,r=document.createDocumentFragment(),i=document.createElement("body");for(i.innerHTML=e;;){if(!(t=i.firstChild))break;r.appendChild(t)}return this.setDOMContent(r)}getMaxWidth(){var e;return null==(e=this._container)?void 0:e.style.maxWidth}setMaxWidth(e){return this.options.maxWidth=e,this._update(),this}setDOMContent(e){if(this._content)for(;this._content.hasChildNodes();)this._content.firstChild&&this._content.removeChild(this._content.firstChild);else this._content=f.create("div","maplibregl-popup-content",this._container);return this._content.appendChild(e),this._createCloseButton(),this._update(),this._focusFirstElement(),this}addClassName(e){this._container&&this._container.classList.add(e)}removeClassName(e){this._container&&this._container.classList.remove(e)}setOffset(e){return this.options.offset=e,this._update(),this}toggleClassName(e){if(this._container)return this._container.classList.toggle(e)}setSubpixelPositioning(e){this.options.subpixelPositioning=e}_createCloseButton(){this.options.closeButton&&(this._closeButton=f.create("button","maplibregl-popup-close-button",this._content),this._closeButton.type="button",this._closeButton.setAttribute("aria-label","Close popup"),this._closeButton.innerHTML="&#215;",this._closeButton.addEventListener("click",this._onClose))}_focusFirstElement(){var e;this.options.focusAfterOpen&&this._container&&(e=this._container.querySelector(Mn))&&e.focus()}}const On=C;e.AJAXError=de.AJAXError,e.Evented=de.Evented,e.LngLat=de.LngLat,e.MercatorCoordinate=de.MercatorCoordinate,e.Point=de.Point,e.addProtocol=de.addProtocol,e.config=de.config,e.removeProtocol=de.removeProtocol,e.AttributionControl=on,e.BoxZoomHandler=bi,e.CanvasSource=ye,e.CooperativeGesturesHandler=Xi,e.DoubleClickZoomHandler=Gi,e.DragPanHandler=Wi,e.DragRotateHandler=Yi,e.EdgeInsets=oi,e.FullscreenControl=kn,e.GeoJSONSource=ce,e.GeolocateControl=En,e.Hash=ci,e.ImageSource=_,e.KeyboardHandler=qi,e.LngLatBounds=d,e.LogoControl=an,e.Map=t,e.MapMouseEvent=l,e.MapTouchEvent=u,e.MapWheelEvent=yi,e.Marker=xn,e.NavigationControl=class{constructor(e){this._updateZoomButtons=()=>{var e=this._map.getZoom(),t=e===this._map.getMaxZoom(),e=e===this._map.getMinZoom();this._zoomInButton.disabled=t,this._zoomOutButton.disabled=e,this._zoomInButton.setAttribute("aria-disabled",t.toString()),this._zoomOutButton.setAttribute("aria-disabled",e.toString())},this._rotateCompassArrow=()=>{var e=this.options.visualizePitch?`scale(${1/Math.pow(Math.cos(this._map.transform.pitch*(Math.PI/180)),.5)}) rotateX(${this._map.transform.pitch}deg) rotateZ(${this._map.transform.angle*(180/Math.PI)}deg)`:`rotate(${this._map.transform.angle*(180/Math.PI)}deg)`;this._compassIcon.style.transform=e},this._setButtonTitle=(e,t)=>{t=this._map._getUIString("NavigationControl."+t);e.title=t,e.setAttribute("aria-label",t)},this.options=de.extend({},yn,e),this._container=f.create("div","maplibregl-ctrl maplibregl-ctrl-group"),this._container.addEventListener("contextmenu",e=>e.preventDefault()),this.options.showZoom&&(this._zoomInButton=this._createButton("maplibregl-ctrl-zoom-in",e=>this._map.zoomIn({},{originalEvent:e})),f.create("span","maplibregl-ctrl-icon",this._zoomInButton).setAttribute("aria-hidden","true"),this._zoomOutButton=this._createButton("maplibregl-ctrl-zoom-out",e=>this._map.zoomOut({},{originalEvent:e})),f.create("span","maplibregl-ctrl-icon",this._zoomOutButton).setAttribute("aria-hidden","true")),this.options.showCompass&&(this._compass=this._createButton("maplibregl-ctrl-compass",e=>{this.options.visualizePitch?this._map.resetNorthPitch({},{originalEvent:e}):this._map.resetNorth({},{originalEvent:e})}),this._compassIcon=f.create("span","maplibregl-ctrl-icon",this._compass),this._compassIcon.setAttribute("aria-hidden","true"))}onAdd(e){return this._map=e,this.options.showZoom&&(this._setButtonTitle(this._zoomInButton,"ZoomIn"),this._setButtonTitle(this._zoomOutButton,"ZoomOut"),this._map.on("zoom",this._updateZoomButtons),this._updateZoomButtons()),this.options.showCompass&&(this._setButtonTitle(this._compass,"ResetBearing"),this.options.visualizePitch&&this._map.on("pitch",this._rotateCompassArrow),this._map.on("rotate",this._rotateCompassArrow),this._rotateCompassArrow(),this._handler=new vn(this._map,this._compass,this.options.visualizePitch)),this._container}onRemove(){f.remove(this._container),this.options.showZoom&&this._map.off("zoom",this._updateZoomButtons),this.options.showCompass&&(this.options.visualizePitch&&this._map.off("pitch",this._rotateCompassArrow),this._map.off("rotate",this._rotateCompassArrow),this._handler.off(),delete this._handler),delete this._map}_createButton(e,t){e=f.create("button",e,this._container);return e.type="button",e.addEventListener("click",t),e}},e.Popup=Rn,e.RasterDEMTileSource=le,e.RasterTileSource=se,e.ScaleControl=class{constructor(e){this._onMove=()=>{An(this._map,this._container,this.options)},this.setUnit=e=>{this.options.unit=e,An(this._map,this._container,this.options)},this.options=de.extend({},In,e)}getDefaultPosition(){return"bottom-left"}onAdd(e){return this._map=e,this._container=f.create("div","maplibregl-ctrl maplibregl-ctrl-scale",e.getContainer()),this._map.on("move",this._onMove),this._onMove(),this._container}onRemove(){f.remove(this._container),this._map.off("move",this._onMove),this._map=void 0}},e.ScrollZoomHandler=Vi,e.Style=mt,e.TerrainControl=class{constructor(e){this._toggleTerrain=()=>{this._map.getTerrain()?this._map.setTerrain(null):this._map.setTerrain(this.options),this._updateTerrainIcon()},this._updateTerrainIcon=()=>{this._terrainButton.classList.remove("maplibregl-ctrl-terrain"),this._terrainButton.classList.remove("maplibregl-ctrl-terrain-enabled"),this._map.terrain?(this._terrainButton.classList.add("maplibregl-ctrl-terrain-enabled"),this._terrainButton.title=this._map._getUIString("TerrainControl.Disable")):(this._terrainButton.classList.add("maplibregl-ctrl-terrain"),this._terrainButton.title=this._map._getUIString("TerrainControl.Enable"))},this.options=e}onAdd(e){return this._map=e,this._container=f.create("div","maplibregl-ctrl maplibregl-ctrl-group"),this._terrainButton=f.create("button","maplibregl-ctrl-terrain",this._container),f.create("span","maplibregl-ctrl-icon",this._terrainButton).setAttribute("aria-hidden","true"),this._terrainButton.type="button",this._terrainButton.addEventListener("click",this._toggleTerrain),this._updateTerrainIcon(),this._map.on("terrain",this._updateTerrainIcon),this._container}onRemove(){f.remove(this._container),this._map.off("terrain",this._updateTerrainIcon),this._map=void 0}},e.TwoFingersTouchPitchHandler=Fi,e.TwoFingersTouchRotateHandler=Ni,e.TwoFingersTouchZoomHandler=Di,e.TwoFingersTouchZoomRotateHandler=$i,e.VectorTileSource=ae,e.VideoSource=he,e.addSourceType=(r,i)=>de.__awaiter(void 0,void 0,void 0,function*(){if(_e(r))throw new Error(`A source type called "${r}" already exists.`);var e,t;e=r,t=i,ve[e]=t}),e.clearPrewarmedResources=function(){var e=X;e&&(e.isPreloaded()&&1===e.numActive()?(e.release($),X=null):console.warn("Could not clear WebWorkers since there are active Map instances that still reference it. The pre-warmed WebWorker pool can only be cleared when all map instances have been removed with map.remove()"))},e.getMaxParallelImageRequests=function(){return de.config.MAX_PARALLEL_IMAGE_REQUESTS},e.getRTLTextPluginStatus=function(){return c().getRTLTextPluginStatus()},e.getVersion=function(){return On},e.getWorkerCount=function(){return n.workerCount},e.getWorkerUrl=function(){return de.config.WORKER_URL},e.importScriptInWorkers=function(e){return te().broadcast("IS",e)},e.prewarm=function(){J().acquire($)},e.setMaxParallelImageRequests=function(e){de.config.MAX_PARALLEL_IMAGE_REQUESTS=e},e.setRTLTextPlugin=function(e,t){return c().setRTLTextPlugin(e,t)},e.setWorkerCount=function(e){n.workerCount=e},e.setWorkerUrl=function(e){de.config.WORKER_URL=e}}),i}());for(var F,U,t={exports:{}},r=N(Object.freeze({__proto__:null,default:{}})),q=t,j=0,H=[],V=0;V<256;V++)H[V]=(V+256).toString(16).substr(1);function G(){e=16,(!F||K.BUFFER_SIZE<j+e)&&(j=0,F=K.randomBytes(K.BUFFER_SIZE));var e=F.slice(j,j+=e);return e[6]=15&e[6]|64,e[8]=63&e[8]|128,e}function K(){var e=G();return H[e[0]]+H[e[1]]+H[e[2]]+H[e[3]]+"-"+H[e[4]]+H[e[5]]+"-"+H[e[6]]+H[e[7]]+"-"+H[e[8]]+H[e[9]]+"-"+H[e[10]]+H[e[11]]+H[e[12]]+H[e[13]]+H[e[14]]+H[e[15]]}K.BUFFER_SIZE=4096,K.bin=G,K.clearBuffer=function(){F=null,j=0},K.test=function(e){return"string"==typeof e&&/^[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(e)},"undefined"!=typeof crypto?U=crypto:"undefined"!=typeof window&&void 0!==window.msCrypto&&(U=window.msCrypto),U=U||r,(q.exports=K).randomBytes=function(){if(U){if(U.randomBytes)return U.randomBytes;if(U.getRandomValues)return"function"!=typeof Uint8Array.prototype.slice?function(e){e=new Uint8Array(e);return U.getRandomValues(e),Array.from(e)}:function(e){e=new Uint8Array(e);return U.getRandomValues(e),e}}return function(e){for(var t=[],r=0;r<e;r++)t.push(Math.floor(256*Math.random()));return t}}();var Z=z(t.exports),W="atlas.microsoft.com",Y="atlas.microsoft.com",r="styling",q="2023-01-01",$="https://login.microsoftonline.com/",X="api-version",J="Authorization",Q="Bearer ",ee="jwt-sas ",te="{{azMapsDomain}}",re="{azMapsDomain}",ie="{{azMapsView}}",ne="view",oe="{{azMapsLanguage}}",ae="{{azMapsStylingPath}}",se="{{azMapsStylePath}}",le="styling",ce="styles",t="2.0",ue="Map-Agent",he="x-ms-client-id",de="Ms-Am-Request-Origin",pe="MapControl",fe="https://atlas.microsoft.com/.default",me="Session-Id",ge=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},ye=(ve.prototype.merge=function(){for(var t,e,r,i=[],n=0;n<arguments.length;n++)i[n]=arguments[n];try{for(var o=ge(i),a=o.next();!a.done;a=o.next()){var s=a.value;if(s)for(var l in s)s.hasOwnProperty(l)&&this.hasOwnProperty(l)&&(void 0!==s[l]&&null!=s[l]?this[l]instanceof ve?this[l].merge(s[l]):this[l]=s[l]:(r=r||new(Object.getPrototypeOf(this).constructor),this[l]=r[l]))}}catch(e){t={error:e}}finally{try{a&&!a.done&&(e=o.return)&&e.call(o)}finally{if(t)throw t.error}}return this},ve);function ve(){}var _e,be,we=window&&window.__extends||(_e=function(e,t){return(_e=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}_e(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),xe=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},Ce=(we(Te,be=ye),Te);function Te(){var e=null!==be&&be.apply(this,arguments)||this;return e.domain=void 0,e.headers={},e.path="",e.protocol="https",e.queryParams={},e.subdomain="",e}Ee.prototype.get=function(){return fetch(this.toString(),{method:"GET",mode:"cors",headers:new Headers(this.options.headers)}).then(function(e){if(e.ok)return e.json();throw new Error("HTTP ".concat(e.status,": ").concat(e.statusText))})},Ee.prototype.toString=function(){var e=Object.entries(this.options.queryParams).map(function(e){var e=xe(e,2),t=e[0],e=e[1];return"".concat(t,"=").concat(e)}).join("&"),t=[],r=this.options.path||"";return Ee.protoRegEx.test(r)?t.push(r):(this.options.domain&&(Ee.protoRegEx.test(this.options.domain)||(t.push("".concat(this.options.protocol,"://")),t.push(this.options.subdomain?"".concat(this.options.subdomain,"."):"")),t.push(this.options.domain)),t.push(this.options.path?"/".concat(r):"")),t.push(e?"?".concat(e):""),t.join("")},Ee.protoRegEx=new RegExp(/^(((file|http|https):\/\/)|blob:)/i);var Se=Ee;function Ee(e){this.options=(new Ce).merge(e)}Ae.parse=function(e){var t=(e=e.toLowerCase()).lastIndexOf("-");return-1!==t?{code:e,language:e.substring(0,t),region:e.substring(t+1)}:{code:e,language:e}};var Ie=Ae;function Ae(){}var ke={localizationsPath:"locs/mapcontrol/2019-3-12",sensitiveUserRegions:["il","kr","pk","in","cn","ar","bh","eg","jo","sa","kw","om","qa","ma","ae"],locales:{defaultLanguage:{defaultRegion:{code:"NGT",strings:"en/resource.json"},latn:{code:"NGT-Latn",strings:"en/resource.json"}},ar:{defaultRegion:{code:"ar",strings:"ar-sa/resource.json"}},bg:{defaultRegion:{code:"bg-BG",strings:"bg-bg/resource.json"}},cs:{defaultRegion:{code:"cs-CZ",strings:"cs-cz/resource.json"}},da:{defaultRegion:{code:"da-DK",strings:"da-dk/resource.json"}},de:{defaultRegion:{code:"de-DE",strings:"de-de/resource.json"}},el:{defaultRegion:{code:"el-GR",strings:"el-gr/resource.json"}},en:{defaultRegion:{code:"en",strings:"en/resource.json"},us:{code:"en-US",strings:"en/resource.json"},au:{code:"en-AU",strings:"en/resource.json"},gb:{code:"en-GB",strings:"en/resource.json"},nz:{code:"en-NZ",strings:"en/resource.json"}},es:{defaultRegion:{code:"es-ES",strings:"es-es/resource.json"},mx:{code:"es-MX",strings:"es-mx/resource.json"}},fi:{defaultRegion:{code:"fi-FI",strings:"fi-fi/resource.json"}},fr:{defaultRegion:{code:"fr-FR",strings:"fr-fr/resource.json"}},hu:{defaultRegion:{code:"hu-HU",strings:"hu-hu/resource.json"}},id:{defaultRegion:{code:"id-ID",strings:"id-id/resource.json"}},it:{defaultRegion:{code:"it-IT",strings:"it-it/resource.json"}},ko:{defaultRegion:{code:"ko-KR",strings:"ko-kr/resource.json"}},lt:{defaultRegion:{code:"lt-LT",strings:"lt-lt/resource.json"}},ms:{defaultRegion:{code:"ms-MY",strings:"ms-my/resource.json"}},nb:{defaultRegion:{code:"nb-NO",strings:"nb-no/resource.json"}},nl:{defaultRegion:{code:"nl-NL",strings:"nl-nl/resource.json"}},pl:{defaultRegion:{code:"pl-PL",strings:"pl-pl/resource.json"}},pt:{defaultRegion:{code:"pt-PT",strings:"pt-pt/resource.json"},br:{code:"pt-BR",strings:"pt-br/resource.json"}},ru:{defaultRegion:{code:"ru-RU",strings:"ru-ru/resource.json"}},sk:{defaultRegion:{code:"sk-SK",strings:"sk-sk/resource.json"}},sl:{defaultRegion:{code:"sl-SL",strings:"sl-sl/resource.json"}},sv:{defaultRegion:{code:"sv-SE",strings:"sv-se/resource.json"}},th:{defaultRegion:{code:"th-TH",strings:"th-th/resource.json"}},tr:{defaultRegion:{code:"tr-TR",strings:"tr-tr/resource.json"}},zh:{defaultRegion:{code:"zh",strings:"en/resource.json"}},"zh-hans":{defaultRegion:{code:"zh-Hans",strings:"zh-cn/resource.json"},cn:{code:"zh-Hans-CN",strings:"zh-cn/resource.json"}},"zh-hant":{defaultRegion:{code:"zh-Hant",strings:"en/resource.json"},tw:{code:"zh-Hant-TW",strings:"zh-tw/resource.json"}}}},Pe=function(){this.Unknown="Unknown",this.Accident="Accident",this.Fog="Fog",this.Danger="Danger",this.Rain="Rain",this.Ice="Ice",this.Jam="Jam",this.LaneClosed="Lane Closed",this.RoadClosed="Road Closed",this.RoadWorks="Road Works",this.Wind="Wind",this.Flood="Flood",this.Detour="Detour"},Me=(Re.getCode=function(e){0===e.localeCompare("auto",void 0,{sensitivity:"base"})&&(e=navigator.language);var t=Ie.parse(e);return-1===ke.sensitiveUserRegions.indexOf(t.region)?this.getLocaleData(t).code:e},Re.getStrings=function(e){e=this.getLocaleData(e);return ke.locales.defaultLanguage.defaultRegion.code===e.code?new Promise(function(e){e(new Pe)}):new Se({domain:Y,path:"".concat(ke.localizationsPath,"/").concat(e.strings)}).get().then(function(e){return e},function(){return new Pe})},Re.getLocaleData=function(e){if("string"==typeof e&&(e=Ie.parse(e)),ke.locales[e.code])return ke.locales[e.code].defaultRegion;var t;if(ke.locales[e.language])t=ke.locales[e.language];else{if(-1!==e.language.indexOf("-"))return this.getLocaleData(e.language);t=ke.locales.defaultLanguage}return e.region&&t[e.region]?t[e.region]:t.defaultRegion},Re);function Re(){}Le.getEdgeOrIEVersion=function(){var e=window.navigator.userAgent,t=e.indexOf("MSIE ");return 0<t?parseInt(e.substring(t+5,e.indexOf(".",t)),10):0<e.indexOf("Trident/")?(t=e.indexOf("rv:"),parseInt(e.substring(t+3,e.indexOf(".",t)),10)):0<(t=e.indexOf("Edge/"))?parseInt(e.substring(t+5,e.indexOf(".",t)),10):-1},Le.isEdgeOrIE=function(){return-1!==this.getEdgeOrIEVersion()},Le.isIE=function(){var e=this.getEdgeOrIEVersion();return-1!==e&&e<=11};var Oe=Le;function Le(){}var De="3.6.1",ze=(Ne.getFullVersion=function(){return De},Ne.getEndpointVersion=function(){var e=De.indexOf(".");return-1===(e=De.indexOf(".",e+1))?De:De.substring(0,e)},Ne);function Ne(){}var Be,Fe,we=window&&window.__extends||(Be=function(e,t){return(Be=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Be(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Ue=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},qe=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},je=(u.AuthenticationType=void 0,(Vt=u.AuthenticationType||(u.AuthenticationType={})).subscriptionKey="subscriptionKey",Vt.aad="aad",Vt.anonymous="anonymous",Vt.sas="sas",we(He,Fe=ye),He.prototype.setSubscriptionKey=function(e){this.authType=u.AuthenticationType.subscriptionKey,this.subscriptionKey=e},He.prototype.setAadProperties=function(e,t,r,i,n){this.authType=u.AuthenticationType.aad,this.authContext=n||this.authContext,this.aadInstance=i||this.aadInstance,this.clientId=e,this.aadAppId=t,this.aadTenant=r},He.prototype.setTokenCallbackFunction=function(e){this.authType=u.AuthenticationType.anonymous,this.getToken=e},He.prototype.setSasCallbackFunction=function(e){this.authType=u.AuthenticationType.sas,this.getToken=e},He.prototype.merge=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=Fe.prototype.merge.apply(this,qe([],Ue(e),!1));return r.authType===u.AuthenticationType.subscriptionKey?r.authContext=r.aadAppId=r.getToken=void 0:r.authType===u.AuthenticationType.aad?r.subscriptionKey=r.getToken=void 0:r.authType===u.AuthenticationType.anonymous?r.subscriptionKey=r.authContext=r.aadAppId=void 0:r.authType===u.AuthenticationType.sas&&(r.authContext=r.subscriptionKey=r.aadAppId=void 0),r},He);function He(){var e=null!==Fe&&Fe.apply(this,arguments)||this;return e.authType=void 0,e.subscriptionKey=void 0,e.clientId=void 0,e.aadAppId=void 0,e.aadTenant=void 0,e.aadInstance=void 0,e.getToken=void 0,e.sasToken=void 0,e.authContext=void 0,e}var Ve;var Ge="NGT",Ke=Z(),Ze=W,We=Y,Ye=r,$e=q,Xe=t,Je=new je,Qe=!1,et=!1,tt=!1,rt=!1,it=!1,nt=!1,ot=!1,at=!1,st=!1;function lt(){return Object.assign({},Je)}function ct(){return We}function ut(){return Ze}function ht(){return Ye}function dt(){return $e}function pt(){return Xe}function ft(){return B.getWorkerCount()}function mt(){return B.getMaxParallelImageRequests()}function gt(){return Ge}function yt(){return Ke}function vt(){return Je.authType===u.AuthenticationType.subscriptionKey?Je.subscriptionKey:void 0}function _t(){return Ve}function bt(e){Je=(new je).merge(Je,e),st=!0}function wt(e){Ze=e,et=!0}function xt(e){Ye=e,tt=!0}function Ct(e){0<e&&(B.setWorkerCount(e),it=!0)}function Tt(e){0<e&&(B.setMaxParallelImageRequests(e),nt=!0)}function St(e){Ge=Me.getCode(e),ot=!0}function Et(e){Ke=e,at=!0}function It(e){Je.setSubscriptionKey(e),st=!0}function At(e){Ve=e,Qe=!0}function kt(e,t){if(t=Math.abs(t||1),"string"==typeof e&&Ht[e.toLowerCase()]){for(var r=Ht[e.toLowerCase()],i=/calc\(([0-9.]+)[px]*\s*\*\s*\{scale\}\)/gi,n=r,o=i.exec(r);o;)n=n.replace(o[0],parseFloat(o[1])*t+""),o=i.exec(r);return n=n.replace("{scale}",t+"")}throw new Error("Invalid templateName.")}function Pt(){return st}function Mt(){return et}function Rt(){return tt}function Ot(){return it}function Lt(){return nt}function Dt(){return ot}function zt(){return at}function Nt(){return Qe}function Bt(){var e=new Se({domain:Y,path:"sdk/javascript/mapcontrol/".concat(ze.getEndpointVersion(),"/mapbox-gl-rtl-text.min.js")});B.setRTLTextPlugin(e.toString(),!0).catch(function(e){e&&console.warn(e)})}function Ft(e){var t=document.createElement("span");return t.innerText=e,t.classList.add("tooltiptext"),-1!=navigator.userAgent.indexOf("Edg")?t.classList.add("edge"):-1!=navigator.userAgent.indexOf("Chrome")?t.classList.add("chrome"):-1!=navigator.userAgent.indexOf("Safari")?t.classList.add("safari"):-1!=navigator.userAgent.indexOf("Firefox")&&t.classList.add("firefox"),-1!=navigator.userAgent.indexOf("Windows")?t.classList.add("win"):-1!=navigator.userAgent.indexOf("Macintosh")&&t.classList.add("mac"),t}function Ut(n,o,a){function e(e){var t=o.getBoundingClientRect(),r=n.getBoundingClientRect(),i=t.x+r.width>window.innerWidth?window.innerWidth-r.width:t.x,r=t.y+t.height+r.height+4>window.innerHeight?t.y-r.height-4:t.y+t.height+4;a&&o.parentElement&&(t=o.parentElement?o.parentElement.getBoundingClientRect():null,n.style.position="absolute",i-=t.x,r-=t.y),n.style.transform="translate(".concat(i,"px, ").concat(r,"px)"),n.style.display="block"}void 0===a&&(a=!1),o.addEventListener("mouseover",e),o.addEventListener("focusin",e),o.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||"block"!==n.style.display||(e.stopPropagation(),n.style.display="none")})}var qt,jt,Ht={marker:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 26 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:1"/><text x="12.5" y="17.5" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 27 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:2"/><text x="12.5" y="18.5" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-circle":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 27 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:1"/><circle cx="12.5" cy="12.5" r="9" fill="{secondaryColor}"/><text x="12" y="17.5" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',pin:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(24 * {scale})" height="calc(28 * {scale})" viewBox="0 0 24 28"><path d="m11.988 16.615a5.15 5.15 0 0 1-2.268-.525 4.909 4.909 0 0 1-2.805-4.442 5.019 5.019 0 0 1 5.072-4.936h.012a5.03 5.03 0 0 1 5.085 4.961 4.907 4.907 0 0 1-.549 2.224 5.114 5.114 0 0 1-4.548 2.718zm0-8.06a3.173 3.173 0 0 0-3.226 3.099 3.081 3.081 0 0 0 1.77 2.782 3.299 3.299 0 0 0 4.365-1.386 3.049 3.049 0 0 0 .342-1.381 3.184 3.184 0 0 0-3.239-3.114h-.012z" fill="{secondaryColor}"/><path d="m11.999.922a10.908 10.908 0 0 0-11.076 10.732 10.639 10.639 0 0 0 4.418 8.598l6.658 6.464 6.658-6.463a10.537 10.537 0 0 0 2.198-15.041 11.182 11.182 0 0 0-8.856-4.289zm1.873 14.341a4.221 4.221 0 0 1-5.589-1.789 3.945 3.945 0 0 1-.445-1.8 4.164 4.164 0 0 1 8.323-.037 4.028 4.028 0 0 1-2.289 3.626Z" fill="{color}"/><path d="m11.999 28-7.256-7.044a11.611 11.611 0 0 1-4.743-9.303 11.844 11.844 0 0 1 11.988-11.652.102 .102 0 0 1 .02 0 12.164 12.164 0 0 1 9.577 4.647 11.357 11.357 0 0 1 2.299 8.614 11.521 11.521 0 0 1-4.63 7.695zm-.01-26.157a9.997 9.997 0 0 0-10.143 9.812 9.769 9.769 0 0 0 4.04 7.853l.099.083 6.014 5.838 6.113-5.922a9.7 9.7 0 0 0 3.945-6.505 9.533 9.533 0 0 0-1.933-7.229 10.305 10.305 0 0 0-8.116-3.931h-.021zm.021 14.772a5.11 5.11 0 0 1-4.547-2.718 4.868 4.868 0 0 1 .932-5.743 5.118 5.118 0 0 1 3.58-1.46h.024a5.031 5.031 0 0 1 5.084 4.938 4.92 4.92 0 0 1-2.805 4.457h0a5.152 5.152 0 0 1-2.269.525zm-.011-8.079h-.015a3.277 3.277 0 0 0-2.295.933 3.029 3.029 0 0 0-.587 3.58 3.297 3.297 0 0 0 4.364 1.386h0a3.092 3.092 0 0 0 1.772-2.795 3.185 3.185 0 0 0-3.239-3.105z" fill="{secondaryColor}"/><text x="12" y="17" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',"pin-round":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(25 * {scale})" height="calc(25 * {scale})" viewBox="0 0 25 25"><g transform="translate(0 1)"><circle cx="12.25" cy="11.5833" r="11" fill="{color}"/><path d="m12.25 23.583a12 12 0 1 1 12-12 12 12 0 0 1-12 12zm0-22a10 10 0 1 0 10 10 10 10 0 0 0-10-10z" fill="{secondaryColor}"/><circle cx="12.25" cy="11.5833" r="4.2386" fill="{secondaryColor}"/></g><text x="12.5" y="17" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',"marker-flat":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(42.8 * {scale})"  viewBox="0 0 1600 2570"><g fill="{color}"><path d="M691 2419c-409-575-641-1086-683-1504-10-106-10-136 5-224 31-188 105-330 241-458 129-124 270-190 453-214 69-9 113-10 182-1 373 46 655 326 703 698 40 308-120 801-424 1309-134 224-348 535-369 535-4 0-53-63-108-141z"/></g><g fill="rgba(0,0,0,0.15)" style="transform:scale(-1,1);transform-origin:center"><path d="M691 2419c-407-571-639-1083-682-1498-14-139-3-249 37-371 69-208 254-402 459-481 68-27 217-59 271-59h24v160 180 940 635c0 349-2 635-5 635-2 0-49-63-104-141z"/></g><circle cx="800" cy="800" r="600" fill="{secondaryColor}"/><text x="800" y="1100" style="font-size:800px;fill:#000;text-anchor:middle">{text}</text></svg>',"marker-arrow":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(25.47 * {scale})" height="calc(35.18 * {scale})" viewBox="0 0 4330 5980"><g fill="{color}"><path d="m2080 5969c-49-20-93-63-115-113-25-55-1928-5486-1953-5573-40-138 67-282 210-283 36 0 246 73 987 345 518 190 947 345 955 345 8 0 438-155 955-345 615-226 954-345 979-345 87 0 165 47 204 123 46 91 107-95-957 2942-537 1535-986 2805-997 2823-11 18-43 46-72 62-41 24-62 30-111 29-33 0-71-5-85-10z"/></g><g fill="{secondaryColor}"><path d="m2200 1600c-36 10-83 2-484-84-243-53-451-94-461-91-11 4-22 18-25 31-5 19 114 371 436 1292 244 697 448 1273 454 1281 19 24 50 30 71 12z"/><path d="m2200 1600c-36 10-83 2-484-84-243-53-451-94-461-91-11 4-22 18-25 31-5 19 114 371 436 1292 244 697 448 1273 454 1281 19 24 50 30 71 12z" style="transform:scale(-1,1);transform-origin:center"/></g><g fill="rgba(0,0,0,0.2)" ><path d="m2165 685c8 0 438-155 955-345 615-226 954-345 979-345 87 0 165 47 204 123 46 91 107-95-957 2942-537 1535-986 2805-997 2823-11 18-43 46-72 62-41 24-62 30-111 29z"/></g><text x="2165" y="3300" style="font-size:2500px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-ball-pin":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(15.67 * {scale})" height="calc(33.33 * {scale})" viewBox="0 0 235 452"><g transform="translate(-135 10)"><path fill="{secondaryColor}" d="m256 442 0 0c-13 0-18-11-18-24l-6-323c0-13 11-24 24-24h0c13 0 24 11 24 24l-6 323c0 13-5 24-18 24z"/><circle style="fill:{color};stroke-width:10;stroke:{secondaryColor}" cx="256" cy="112" r="111"/><ellipse transform="matrix(0.834 0.5518 -0.5518 0.834 65.7916 -97.18)" fill="rgba(255,255,255,0.3)" cx="194.399" cy="60.749" rx="19.076" ry="32.428"/></g><text x="117.5" y="160" style="font-size:160px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(26.67 * {scale})" height="calc(32.27 * {scale})" viewBox="0 0 2000 2420"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="M845 2152c-22-37-58-95-80-129-22-35-62-99-90-143l-50-80-312 0-313 0 0-900 0-900 900 0 900 0 0 900 0 900-313 0-313 0-34 58c-19 31-38 59-42 60-5 2-8 8-8 12 0 9-69 123-88 145-5 6-11 15-13 21-16 39-77 123-89 124-8 0-33-31-55-68z"/></g><text x="1000" y="1300" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square-cluster":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(33.33 * {scale})" height="calc(38.8 * {scale})" viewBox="0 0 2500 2910"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="m866 2652c-17-31-37-68-46-82-9-14-32-54-51-90-19-36-50-92-70-125l-36-60-332-3-331-2 0-905 0-905 660 0 660 0 0-38c0-71 50-196 102-258 71-85 189-164 244-164 12 0 26-4 29-10 8-13 222-13 230 0 3 6 17 10 30 10 25 0 117 45 154 76 130 107 191 232 191 392 0 155-63 284-190 386-36 29-129 76-150 76-11 0-22 5-25 10-3 6-31 10-61 10l-54 0 0 660 0 660-332 2-332 3-29 50c-17 28-48 84-70 125-22 41-47 86-56 100-9 14-30 51-46 83-17 32-36 57-45 57-8 0-28-25-44-58z"/></g><text x="1650" y="900" style="font-size:1000px;fill:#fff">+</text><text x="1000" y="1800" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square-rounded":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(26.8 * {scale})" height="calc(32.27 * {scale})" viewBox="0 0 2010 2410"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="M856 2155c-20-30-36-59-36-65 0-5-4-10-10-10-5 0-10-5-10-11 0-5-18-37-40-69-22-32-40-64-40-69 0-6-4-11-10-11-5 0-10-5-10-10 0-6-15-33-32-60l-33-50-127 0c-74 0-129-4-133-10-3-5-17-10-30-10-25 0-116-45-155-76-87-69-142-151-178-265-15-46-17-1075-2-1084 5-3 10-17 10-30 0-13 5-27 10-30 6-3 10-13 10-22 0-22 83-135 122-168 57-46 62-50 112-75l50-25 585 0 586 0 63 34c84 46 169 133 212 218l35 68 0 565 0 565-28 59c-32 69-100 157-139 180-15 9-33 22-40 29-23 22-99 57-123 57-13 0-27 5-30 10-4 6-60 10-135 10l-128 0-128 205c-84 136-133 205-144 205-10 0-33-24-54-55z"/></g><text x="1000" y="1300" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',"marker-square-rounded-cluster":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(33.33 * {scale})" height="calc(32.13 * {scale})" viewBox="0 0 2500 2900"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="m874 2669c-9-18-26-49-37-68-11-20-30-55-43-78-13-24-36-64-51-90-14-27-38-69-52-95l-26-48-142 0c-84 0-144-4-148-10-3-5-17-10-30-10-25 0-118-46-154-76-91-76-136-142-175-254-13-38-16-119-16-554 0-358 3-520 12-545 40-125 106-219 195-278 127-84 116-83 646-83l467 0 0-42c0-46 11-87 45-163 54-121 169-220 306-264 46-14 232-14 278 0 165 53 284 175 340 350 19 61 14 204-10 273-32 91-94 178-169 240-38 31-130 76-155 76-13 0-27 5-30 10-3 6-28 10-56 10l-49 0 0 462c0 446-1 464-21 522-32 91-94 178-169 240-38 31-130 76-155 76-13 0-27 5-30 10-4 6-65 10-149 10-138 0-143 1-154 23-12 23-62 114-112 202-16 28-44 79-63 115-42 77-67 88-93 39z"/></g><text x="1650" y="900" style="font-size:1000px;fill:#fff">+</text><text x="1000" y="1800" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',flag:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(23.5 * {scale})" height="calc(40 * {scale})" viewBox="34 28 198 308"><path style="stroke:{secondaryColor};stroke-width:15;stroke-linecap:round;" d="M42 327l0 -291"/><path style="fill:{color};stroke:{secondaryColor};stroke-width:10;stroke-linejoin:round;" d="M49 50c70 30 104 28 178 2-21 42-21 74 0 116-72 25-101 25-178 0l0-118z"/><text x="130" y="165" style="font-size:100px;fill:#fff;text-anchor:middle">{text}</text></svg>',"flag-triangle":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(35.33 * {scale})" viewBox="0 0 40.5 53"><g transform="translate(-31 -20)"><path fill="{secondaryColor}" d="M34.7,73.3V48.4l34.6-10.1c0.7-0.2,1.2-0.8,1.2-1.5s-0.4-1.4-1-1.7L33.7,20.5c-0.5-0.2-1.1-0.2-1.6,0.2 c-0.5,0.3-0.7,0.8-0.7,1.4v51.2H34.7z"/><polygon points="34.7,24.5 66,36.5 34.7,45 34.7,10" fill="{color}"/></g><text x="11" y="21" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"rounded-square":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(34 * {scale})" height="calc(34 * {scale})" viewBox="0 0 34 34"><g transform="translate(2 2)"><rect x="0" y="0" rx="8" ry="8" width="30" height="30" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17" y="22" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"rounded-square-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(38 * {scale})" height="calc(38 * {scale})" viewBox="0 0 38 38"><g transform="translate(4 4)"><rect x="0" y="0" rx="8" ry="8" width="30" height="30" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19" y="24" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',triangle:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(36 * {scale})" height="calc(36 * {scale})" viewBox="0 0 36 36"><g transform="translate(2 2)"><polygon points="16,0 32,32 0,32 16,0" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17.5" y="30" style="font-size:12px;fill:#fff;text-anchor:middle">{text}</text></svg>',"triangle-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 40 40"><g transform="translate(4 4)"><polygon points="16,0 32,32 0,32 16,0" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19.5" y="32" style="font-size:12px;fill:#fff;text-anchor:middle">{text}</text></svg>',hexagon:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(35 * {scale})" height="calc(40 * {scale})" viewBox="0 0 35 40"><g transform="translate(2 2)"><path d="M31 9 15.5 0 0 9 0 27 15.5 36 31 27 31 9Z" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17.5" y="25" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"hexagon-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(39 * {scale})" height="calc(44 * {scale})" viewBox="0 0 39 44"><g transform="translate(4 4)"><path d="M31 9 15.5 0 0 9 0 27 15.5 36 31 27 31 9Z" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19.5" y="27" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',"hexagon-rounded":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 1100 1100"><g transform="translate(50 50)"><path style="stroke:{secondaryColor};stroke-width:50;fill:{color}" d="M881 210 561 25c-33-19-88-19-121 0L119 210c-33 19-61 67-61 105v370c0 39 27 86 61 105l321 185c33 19 88 19 122 0l321-185c33-19 61-67 61-105V315C942 276 915 229 881 210z"/></g><text x="550" y="700" style="font-size:400px;fill:#fff;text-anchor:middle">{text}</text></svg>',"hexagon-rounded-thick":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 1200 1200"><g transform="translate(100 100)"><path style="stroke:{secondaryColor};stroke-width:100;fill:{color}" d="M881 210 561 25c-33-19-88-19-121 0L119 210c-33 19-61 67-61 105v370c0 39 27 86 61 105l321 185c33 19 88 19 122 0l321-185c33-19 61-67 61-105V315C942 276 915 229 881 210z"/></g><text x="600" y="750" style="font-size:400px;fill:#fff;text-anchor:middle">{text}</text></svg>',"triangle-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(28 * {scale})" viewBox="0 0 28 28"><g transform="translate(2 2)"><polygon points="12,0 0,24 12,17 24,24" stroke-width="2" stroke="{secondaryColor}" fill="{color}"/></g><text x="14" y="17" style="font-size:8px;fill:#fff;text-anchor:middle">{text}</text></svg>',"triangle-arrow-left":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(28 * {scale})" viewBox="0 0 28 28"><g transform="translate(2 2)"><polygon points="24,12 0,0 7,12 0,24" stroke-width="2" stroke="{secondaryColor}" fill="{color}"/></g><text x="14" y="16.5" style="font-size:8px;fill:#fff;text-anchor:middle">{text}</text></svg>',"arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(12.16 * {scale})" height="calc(30.1 * {scale})" viewBox="0 0 902 364"><g fill="{color}" transform="matrix(0,2.4,-2.4,0,897,-930)"><polygon points="902,222 233,222 233,364 0,182 233,0 233,141 902,141 902,222"/></g><text x="450" y="700" style="font-size:900px;fill:#000;text-anchor:middle">{text}</text></svg>',"arrow-up-thin":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(33.33 * {scale})" viewBox="0 0 12 25"><g transform="translate(-136.91823 -751.91998)"><path fill="{color}" d="m148.271 760.71c-1.641-.547-3.186-1.47-4.633-2.769l0 18.07-1.675 0 0-18.07c-1.447 1.299-2.986 2.222-4.616 2.769l0-1.231c2.325-1.596 4.006-3.812 5.043-6.65l.838 0c1.037 2.838 2.718 5.055 5.043 6.65l0 1.231z"/></g><text x="6" y="20" style="font-size:10px;fill:#000;text-anchor:middle">{text}</text></svg>',car:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(21.93 * {scale})" height="calc(40.9 * {scale})" viewBox="0 0 6580 12270"><g transform="translate(0 12270) rotate(-90)"><path fill="{secondaryColor}" d="M7045 6566c-42-13-105-44-105-51 0-2 23-105 50-228 28-123 50-230 50-236 0-8-241-11-907-11-855 0-1145 6-1513 30-85 6-189 13-230 15-41 3-133 10-205 15-286 21-430 32-705 50-953 63-1459 18-2335-205-304-77-746-209-799-238-131-72-221-408-285-1062-34-345-42-532-48-1130-16-1557 108-2532 336-2649 32-17 469-149 676-205 409-110 819-191 1205-238 116-14 224-18 540-18 395 1 494 5 1140 50 1124 79 1224 82 2496 78l641-3-53-237c-29-131-52-238-51-239 1-1 31-14 66-29 56-23 76-26 142-23 67 3 83 7 120 33 23 17 50 41 61 55 10 14 51 117 91 230l73 205 674 3 675 2 90-39c98-43 198-72 315-93 122-21 829-18 990 5 321 45 626 143 849 270 293 168 516 378 704 662 266 402 416 893 467 1527 15 174 8 882-9 998-6 41-18 127-27 190-69 502-253 969-523 1325-79 105-262 284-381 374-189 142-355 229-574 300-336 110-526 139-952 148-457 9-685-23-887-124l-47-24-678-6-678-6-64 179c-79 224-92 253-121 284-67 70-177 97-274 66zm-2752-5073c-23-2-64-2-90 0-26 2-7 3 42 3 50 0 71-1 48-3zm395 0c-21-2-55-2-75 0-21 2-4 4 37 4 41 0 58-2 38-4z"/><path fill="{color}" d="M7043 6498c-13-6-23-19-23-28 0-9 23-117 50-240 28-123 50-230 50-237 0-22-2126-13-2465 10-132 10-400 28-595 42-661 47-824 55-1160 62-435 7-656-8-1040-73-415-70-865-183-1447-365-168-53-272-556-325-1569-16-319-16-1311 0-1630 45-872 129-1366 257-1518 22-26 51-39 172-77 557-177 1122-310 1563-369 271-36 351-40 690-40 361 1 463 6 1165 54 1122 78 1288 83 2337 79 460-2 840-7 843-11 4-4-17-117-47-252l-55-245 39-16c76-30 180-8 224 47 10 13 54 124 98 246l79 222 709 0 709 0 47-24c74-37 219-83 322-101 122-22 606-32 802-16 374 29 658 102 933 238 124 62 271 155 361 230l61 51 6 100c19 278 103 497 247 643 88 89 173 136 278 152l70 11 41 131c116 369 159 673 168 1170 10 584-38 984-167 1397l-40 126-70 12c-193 33-348 175-441 405-56 139-89 302-89 445 0 43-3 47-58 91-290 235-644 384-1068 450-191 29-796 39-974 16-135-18-263-54-368-102l-75-35-701 0-701 0-79 223c-82 232-102 267-163 293-38 16-138 17-170 2zm-2023-820c332-15 1155-12 1835 6 308 8 563 12 566 8 4-4 10-21 13-38 7-30 6-31-92-77-518-244-1197-396-2112-474-295-25-1282-25-1579 0-231 20-473 46-479 51-6 7 49 110 93 171 160 226 416 335 855 365 142 10 539 5 900-12zm3304-263c525-111 899-887 934-1935 19-557-37-1023-172-1435-186-563-521-900-896-899-81 0-158 14-525 92-426 91-431 92-540 146-195 96-287 207-306 368-12 104-11 2985 1 3078 22 170 135 291 365 389 49 21 191 55 480 115 226 47 419 87 430 89 45 10 164 6 229-8zm-5570-485c112-43 197-156 216-291 12-83 13-2623 1-2706-23-158-125-273-270-304-44-9-100-1-542 75-272 47-514 91-539 98-266 68-487 424-594 958-56 280-70 548-40 800 56 484 207 878 414 1081 115 114 122 116 702 218 277 49 524 90 550 90 26 1 72-8 102-19zm2111-3440c1023-44 1884-213 2462-486l113-53-7-33c-3-18-8-35-10-37-2-3-236 1-521 7-993 24-1271 26-1708 11-541-18-1128-18-1249-1-377 56-588 181-734 437-32 55-41 79-32 84 12 8 246 32 491 51 356 28 815 36 1195 20z"/></g><text x="3250" y="8250" style="font-size:3000px;fill:#fff;text-anchor:middle">{text}</text></svg>',checker:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(16 * {scale})" viewBox="0 0 16 16"><pattern id="p" x="0" y="0" width="16" height="16" patternUnits="userSpaceOnUse"><rect fill="{color}" x="0" width="8" height="8" y="0"/><rect fill="{color}" x="8" width="8" height="8" y="8"/></pattern><rect x="0" y="0" width="16" height="16" fill="{secondaryColor}"/><rect x="0" y="0" width="16" height="16" fill="url(#p)"/></svg>',"checker-rotated":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(16 * {scale})" viewBox="0 0 60 60"><rect width="60" height="60" fill="{secondaryColor}"/><rect width="42.42" height="42.42" transform="translate(30 0) rotate(45)" fill="{color}"/></svg>',"zig-zag":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(15 * {scale})" height="calc(15 * {scale})" viewBox="0 0 120 120"><rect x="0" y="0" width="120" height="120" fill="{secondaryColor}"/><polygon fill="{color}" points="120 120 60 120 90 90 120 60 120 0 120 0 60 60 0 0 0 60 30 90 60 120 120 120"/></svg>',"zig-zag-vertical":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(15 * {scale})" height="calc(15 * {scale})" viewBox="0 0 120 120"><rect x="0" y="0" width="120" height="120" fill="{secondaryColor}"/><polygon fill="{color}" points="120 0 120 60 90 30 60 0 0 0 0 0 60 60 0 120 60 120 90 90 120 60 120 0"/></svg>',"circles-spaced":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 20 20"><defs><pattern id="p" x="0" y="0" width="20" height="20" patternUnits="userSpaceOnUse"><circle cx="10" cy="10" r="2" stroke="none" fill="{color}"/></pattern></defs><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><rect x="0" y="0" width="100" height="100" fill="url(#p)"/></svg>',circles:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(7 * {scale})" height="calc(7 * {scale})" viewBox="0 0 20 20"><defs><pattern id="p" x="0" y="0" width="20" height="20" patternUnits="userSpaceOnUse"><circle cx="10" cy="10" r="6" stroke="none" fill="{color}"/></pattern></defs><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><rect x="0" y="0" width="100" height="100" fill="url(#p)"/></svg>',"diagonal-lines-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"diagonal-lines-down":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(90 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"diagonal-stripes-up":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',"diagonal-stripes-down":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g transform="rotate(90 20 20)" fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',"grid-lines":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(14 * {scale})" height="calc(14 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(45 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g><g fill="{color}" transform="rotate(-45 3 3)"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"rotated-grid-lines":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(90 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g><g fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',"rotated-grid-stripes":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g transform="rotate(90 20 20)" fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g><g fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',"x-fill":'<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="45.3" height="45.3" fill="{secondaryColor}"/><g fill="{color}"><path d="M0 38.59l2.83-2.83 1.41 1.41L1.41 40H0v-1.41zM0 1.4l2.83 2.83 1.41-1.41L1.41 0H0v1.41zM38.59 40l-2.83-2.83 1.41-1.41L40 38.59V40h-1.41zM40 1.41l-2.83 2.83-1.41-1.41L38.59 0H40v1.41zM20 18.6l2.83-2.83 1.41 1.41L21.41 20l2.83 2.83-1.41 1.41L20 21.41l-2.83 2.83-1.41-1.41L18.59 20l-2.83-2.83 1.41-1.41L20 18.59z"/></g></svg>',dots:'<svg xmlns="http://www.w3.org/2000/svg" width="calc(13 * {scale})" height="calc(13 * {scale})" viewBox="0 0 20 20"><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><g fill="{color}"><circle cx="3" cy="3" r="3"/><circle cx="13" cy="13" r="3"/></g></svg>'},Vt=window&&window.__extends||(qt=function(e,t){return(qt=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}qt(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Gt=(u.ControlPosition=void 0,(we=u.ControlPosition||(u.ControlPosition={})).TopLeft="top-left",we.TopRight="top-right",we.BottomLeft="bottom-left",we.BottomRight="bottom-right",we.NonFixed="non-fixed",Vt(Kt,jt=ye),Kt);function Kt(){var e=null!==jt&&jt.apply(this,arguments)||this;return e.position=u.ControlPosition.NonFixed,e}Wt.prototype.getLuminosity=function(){for(var e=[this.r,this.g,this.b],t=[],r=0;r<e.length;r++){var i=e[r]/255;t[r]=i<=.03928?i/12.92:Math.pow((.055+i)/1.055,2.4)}return.2126*t[0]+.7152*t[1]+.0722*t[2]},Wt.prototype.getRBGA=function(e){var t=document.createElement("canvas").getContext("2d"),e=(t.globalAlpha=1,t.fillStyle=e,t.fillRect(0,0,1,1),t.getImageData(0,0,1,1).data);return[e[0],e[1],e[2],e[3]]};var Zt=Wt;function Wt(e){var t;e&&(t=void 0,3<=(t="string"==typeof e?this.getRBGA(e):e).length)&&(this.r=t[0],this.g=t[1],this.b=t[2],3<t.length)&&(this.a=t[3])}u.ControlStyle=void 0,(r=u.ControlStyle||(u.ControlStyle={})).light="light",r.dark="dark",r.auto="auto";var Yt=Map,$t=(Xt.prototype._addEventListener=function(e,t,r){this.listeners.has(e)||this.listeners.set(e,new Yt),this.listeners.get(e).set(t,r)},Xt.prototype._removeEventListener=function(e,t){this.listeners.has(e)&&this.listeners.get(e).delete(t)},Xt.prototype._invokeEvent=function(r,i){var n=this;this.listeners.has(r)&&this.listeners.get(r).forEach(function(e,t){e&&n._removeEventListener(r,t);try{t(i)}catch(e){console.error(e)}})},Xt);function Xt(){this.listeners=new Yt}var Jt,Qt,q=Object.freeze({__proto__:null,EventEmitter:$t}),er=((window&&window.__extends||(Jt=function(e,t){return(Jt=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Jt(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(tr,Qt=$t),tr.prototype.onRemove=function(){this._container&&(this._container.remove(),delete this._container),this._map&&(this._map.events.remove("stylechanged",this._onStyleChange),delete this._map),this._observer&&(this._observer.disconnect(),delete this._observer),delete this._theme},tr.prototype.buildContainer=function(e,t,r,i){return this._map=e,this._container=document.createElement(i||"div"),this._container.classList.add("azure-maps-control-container"),"string"==typeof r&&this._container.setAttribute("aria-label",r),t.toLowerCase()===u.ControlStyle.auto?this._map&&this._map.events.add("stylechanged",this._onStyleChange):this._container.classList.add(t),this._container},tr.prototype._setTheme=function(e){this._theme!==e&&(this._container.classList.remove(this._theme),this._container.classList.add(e),this._theme=e)},tr.activateClickDelay=100,tr);function tr(){var t=null!==Qt&&Qt.apply(this,arguments)||this;return t._onStyleChange=function(){t._map.getStyle().style.toLowerCase().startsWith("blank")?t._observer||(t._onBackgroundChange(),t._observer=new MutationObserver(t._onBackgroundChange),t._observer.observe(t._map.getMapContainer(),{attributes:!0,attributeFilter:["style"]})):(t._observer&&(t._observer.disconnect(),delete t._observer),t._map.styles.getThemeAsync(t._map.getStyle()).then(function(e){t._setTheme(e)}))},t._onBackgroundChange=function(){var e=new Zt(t._map.getMapContainer().style.backgroundColor).getLuminosity(),e=isNaN(e)||.5<e?u.ControlStyle.light:u.ControlStyle.dark;t._setTheme(e)},t}(window&&window.__extends||(rr=function(e,t){return(rr=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}rr(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(or,ir=ye);var rr,ir,nr=or;function or(){var e=null!==ir&&ir.apply(this,arguments)||this;return e.rotationDegreesDelta=15,e.style=u.ControlStyle.light,e.inverted=!1,e}(window&&window.__extends||(ar=function(e,t){return(ar=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}ar(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(cr,sr=er),cr.prototype.onAdd=function(e,t){function r(e){e?(n.classList.add("in-use"),a.classList.remove("hidden-accessible-element")):(n.classList.remove("in-use"),a.classList.add("hidden-accessible-element"))}var i=this,n=this.buildContainer(e,this.options.style,"Rotation Control"),o=this.constructRotationButton(e),a=this.constructRotationGrid(e,t),s=Ft("Reset to Default Rotation");return n.addEventListener("mouseover",function(e){i.lastActiveTime=i.lastActiveTime||e.timeStamp,i.hasMouse=!0,r(!0)}),n.addEventListener("focusin",function(e){i.lastActiveTime=i.lastActiveTime||e.timeStamp,i.hasFocus=!0,r(!0)}),n.addEventListener("mouseleave",function(){i.hasMouse=!1,i.hasFocus||(delete i.lastActiveTime,r(!1))}),n.addEventListener("focusout",function(e){e.relatedTarget instanceof Node&&n.contains(e.relatedTarget)||(i.hasFocus=!1,i.hasMouse)||(delete i.lastActiveTime,r(!1))}),a.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||(e.stopPropagation(),o.focus(),r(!1))}),o.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||null==n||!n.classList.contains("in-use")||"none"!==(null==s?void 0:s.style.display)||(e.stopPropagation(),r(!1))}),t&&cr.InvertOrderPositions.includes(t.position)?(n.appendChild(a),n.appendChild(o),n.appendChild(s),Ut(s,o)):(n.appendChild(o),n.appendChild(s),Ut(s,o),n.appendChild(a)),n},cr.prototype.constructRotationGrid=function(e,t){var r=document.createElement("div"),i=(r.classList.add("sub-container"),r.classList.add("hidden-accessible-element"),this.constructRightRotationButton(e)),e=this.constructLeftRotationButton(e),n=Ft("Rotate Left"),o=Ft("Rotate Right");return t&&cr.InvertOrderPositions.includes(t.position)?(r.appendChild(i),r.appendChild(o),Ut(o,i),r.appendChild(e),r.appendChild(n),Ut(n,e)):(r.appendChild(e),r.appendChild(n),Ut(n,e),r.appendChild(i),r.appendChild(o),Ut(o,i)),r},cr.prototype.constructRotationButton=function(t){var r=this,e=document.createElement("button"),i=(e.classList.add("azure-maps-control-button"),e.classList.add("rotation"),e.setAttribute("aria-label","Reset to Default Rotation"),e.setAttribute("alt","Reset to Default Rotation"),e.setAttribute("type","button"),document.createElement("div"));return e.appendChild(i),e.addEventListener("click",function(e){e.timeStamp-r.lastActiveTime>er.activateClickDelay&&t.setCamera({bearing:cr.DefaultRotation},!0)}),t.events.add("rotate",function(e){i.style.transform="rotate(".concat(-e.map.getCamera().bearing,"deg)")}),e},cr.prototype.constructRightRotationButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("rotation-right"),r.setAttribute("aria-label","Rotate Right"),r.setAttribute("alt","Rotate Right"),r.setAttribute("type","button"),r.addEventListener("click",function(){e.setCamera({bearing:e.getCamera().bearing-(t.options.inverted?-1:1)*t.options.rotationDegreesDelta,duration:cr.RotationDuration,type:"ease"},!0)}),r},cr.prototype.constructLeftRotationButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("rotation-left"),r.setAttribute("aria-label","Rotate Left"),r.setAttribute("alt","Rotate Left"),r.setAttribute("type","button"),r.addEventListener("click",function(){e.setCamera({bearing:e.getCamera().bearing+(t.options.inverted?-1:1)*t.options.rotationDegreesDelta,duration:cr.RotationDuration,type:"ease"},!0)}),r},cr.DefaultRotation=0,cr.RotationDuration=100,cr.InvertOrderPositions=[u.ControlPosition.BottomRight,u.ControlPosition.TopRight];var ar,sr,lr=cr;function cr(e){var t=sr.call(this)||this;return t.hasMouse=!1,t.hasFocus=!1,t.options=(new nr).merge(e),t}(window&&window.__extends||(ur=function(e,t){return(ur=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}ur(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(pr,hr=ye);var ur,hr,dr=pr;function pr(){var e=null!==hr&&hr.apply(this,arguments)||this;return e.pitchDegreesDelta=10,e.style=u.ControlStyle.light,e.inverted=!1,e}(window&&window.__extends||(fr=function(e,t){return(fr=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}fr(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(gr,mr=er),gr.prototype.onAdd=function(e,t){function r(e){e?(n.classList.add("in-use"),a.classList.remove("hidden-accessible-element")):(n.classList.remove("in-use"),a.classList.add("hidden-accessible-element"))}var i=this,n=this.buildContainer(e,this.options.style,"Pitch Control"),o=this.constructPitchButton(e),a=this.constructPitchGrid(e,t),s=Ft("Reset to Default Pitch");return n.addEventListener("mouseover",function(e){i.lastActiveTime=i.lastActiveTime||e.timeStamp,i.hasMouse=!0,r(!0)}),n.addEventListener("focusin",function(e){i.lastActiveTime=i.lastActiveTime||e.timeStamp,i.hasFocus=!0,r(!0)}),n.addEventListener("mouseleave",function(){i.hasMouse=!1,i.hasFocus||(delete i.lastActiveTime,r(!1))}),n.addEventListener("focusout",function(e){e.relatedTarget instanceof Node&&n.contains(e.relatedTarget)||(i.hasFocus=!1,i.hasMouse)||(delete i.lastActiveTime,r(!1))}),a.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||(e.stopPropagation(),o.focus(),r(!1))}),o.addEventListener("keydown",function(e){"Escape"!==e.key&&"Esc"!==e.key||null==n||!n.classList.contains("in-use")||"none"!==(null==s?void 0:s.style.display)||(e.stopPropagation(),r(!1))}),t&&gr.INVERT_ORDER_POSITIONS.includes(t.position)?(n.appendChild(a),n.appendChild(o),n.appendChild(s),Ut(s,n)):(n.appendChild(o),n.appendChild(s),Ut(s,n),n.appendChild(a)),this.map=e,this.container=n,this.pitchButton=o,e.events.add("pitch",this.pitchChanged),this.updatePitchButtonsState(),n},gr.prototype.onRemove=function(){this.container&&(this.container.remove(),this.container=null,this.pitchButton=null,this.pitchIncrementButton=null,this.pitchDecrementButton=null),this.map&&(this.map.events.remove("pitch",this.pitchChanged),this.map=null)},gr.prototype.constructPitchGrid=function(e,t){var r=document.createElement("div"),e=(r.classList.add("sub-container"),r.classList.add("hidden-accessible-element"),this.pitchIncrementButton=this.constructPitchIncrementButton(e),this.pitchDecrementButton=this.constructPitchDecrementButton(e),Ft("Increase Pitch")),i=Ft("Decrease Pitch");return t&&gr.INVERT_ORDER_POSITIONS.includes(t.position)?(r.appendChild(this.pitchDecrementButton),r.appendChild(i),Ut(i,this.pitchDecrementButton),r.appendChild(this.pitchIncrementButton),r.appendChild(e),Ut(e,this.pitchIncrementButton)):(r.appendChild(this.pitchIncrementButton),r.appendChild(e),Ut(e,this.pitchIncrementButton),r.appendChild(this.pitchDecrementButton),r.appendChild(i),Ut(i,this.pitchDecrementButton)),r},gr.prototype.constructPitchButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("pitch"),r.setAttribute("aria-label","Reset to Default Pitch"),r.setAttribute("alt","Reset to Default Pitch"),r.setAttribute("type","button"),r.addEventListener("click",function(){event.timeStamp-t.lastActiveTime>er.activateClickDelay&&e.setCamera({pitch:gr.DEFAULT_PITCH},!0)}),r},gr.prototype.constructPitchDecrementButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("pitch-down"),r.setAttribute("aria-label","Decrease Pitch"),r.setAttribute("alt","Decrease Pitch"),r.setAttribute("type","button"),r.addEventListener("click",function(){e.setCamera({pitch:e.getCamera().pitch-(t.options.inverted?-1:1)*t.options.pitchDegreesDelta,duration:gr.PITCH_DURATION_MS,type:"ease"},!0)}),r},gr.prototype.constructPitchIncrementButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("pitch-up"),r.setAttribute("aria-label","Increase Pitch"),r.setAttribute("alt","Increase Pitch"),r.setAttribute("type","button"),r.addEventListener("click",function(){e.setCamera({pitch:e.getCamera().pitch+(t.options.inverted?-1:1)*t.options.pitchDegreesDelta,duration:gr.PITCH_DURATION_MS,type:"ease"},!0)}),r},gr.PITCH_DURATION_MS=100,gr.DEFAULT_PITCH=0,gr.INVERT_ORDER_POSITIONS=[u.ControlPosition.BottomRight,u.ControlPosition.TopRight];var fr,mr,t=gr;function gr(e){var r=mr.call(this)||this;return r.container=null,r.map=null,r.pitchButton=null,r.pitchIncrementButton=null,r.pitchDecrementButton=null,r.hasMouse=!1,r.hasFocus=!1,r.pitchChanged=function(e){return r.updatePitchButtonsState()},r.updatePitchButtonsState=function(){var e=r.map.getCamera().pitch<=0,t=60<=r.map.getCamera().pitch;r.hasFocus&&r.pitchButton&&(e||t)&&r.pitchButton.focus(),r.options.inverted?(r.pitchIncrementButton&&r.pitchIncrementButton.disabled!=e&&(r.pitchIncrementButton.disabled=e),r.pitchDecrementButton&&r.pitchDecrementButton.disabled!=t&&(r.pitchDecrementButton.disabled=t)):(r.pitchIncrementButton&&r.pitchIncrementButton.disabled!=t&&(r.pitchIncrementButton.disabled=t),r.pitchDecrementButton&&r.pitchDecrementButton.disabled!=e&&(r.pitchDecrementButton.disabled=e))},r.options=(new dr).merge(e),r}(window&&window.__extends||(yr=function(e,t){return(yr=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}yr(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(_r,vr=er),_r.prototype.onAdd=function(e,t){this.map=e,null!=(r=null==(r=this.map)?void 0:r._getMap())&&r.addControl(this.control);var r=this.buildContainer(e,u.ControlStyle.auto,"Scale Bar");return r.appendChild(null==(e=this.control)?void 0:e._container),r},_r.prototype.onRemove=function(){var e;vr.prototype.onRemove.call(this),null!=(e=null==(e=this.map)?void 0:e._getMap())&&e.removeControl(this.control),this.map=null},_r.prototype.setUnit=function(e){var t;null!=(t=this.control)&&t.setUnit(e)};var yr,vr,we=_r;function _r(e){var t=vr.call(this)||this;return t.map=null,t.control=new B.ScaleControl({maxWidth:null==e?void 0:e.maxWidth,unit:null==e?void 0:e.unit}),t}function br(e,t){return e===t||e!=e&&t!=t}var wr=br;function xr(e,t){for(var r=e.length;r--;)if(wr(e[r][0],t))return r;return-1}var Cr=xr,Tr=Array.prototype.splice;var Sr=xr;var Er=xr;var Ir=xr;function Ar(e){var t=this.__data__;return!((e=Cr(t,e))<0||(e==t.length-1?t.pop():Tr.call(t,e,1),--this.size,0))}function kr(e){var t=this.__data__;return(e=Sr(t,e))<0?void 0:t[e][1]}function Pr(e){return-1<Er(this.__data__,e)}function Mr(e,t){var r=this.__data__,i=Ir(r,e);return i<0?(++this.size,r.push([e,t])):r[i][1]=t,this}function Rr(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var i=e[t];this.set(i[0],i[1])}}Rr.prototype.clear=function(){this.__data__=[],this.size=0},Rr.prototype.delete=Ar,Rr.prototype.get=kr,Rr.prototype.has=Pr,Rr.prototype.set=Mr;var Vt=Rr,Or=Vt;function Lr(){this.__data__=new Or,this.size=0}function Dr(e){var t=this.__data__,e=t.delete(e);return this.size=t.size,e}function zr(e){return this.__data__.get(e)}function Nr(e){return this.__data__.has(e)}var r="object"==typeof e&&e&&e.Object===Object&&e,e="object"==typeof self&&self&&self.Object===Object&&self,e=r||e||Function("return this")(),Br=e.Symbol,Fr=Object.prototype,Ur=Fr.hasOwnProperty,qr=Fr.toString,jr=Br?Br.toStringTag:void 0;var Hr=Object.prototype.toString;var Vr=function(e){var t=Ur.call(e,jr),r=e[jr];try{var i=!(e[jr]=void 0)}catch(e){}var n=qr.call(e);return i&&(t?e[jr]=r:delete e[jr]),n},Gr=function(e){return Hr.call(e)},Kr=Br?Br.toStringTag:void 0;function Zr(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":(Kr&&Kr in Object(e)?Vr:Gr)(e)}function Wr(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}var Yr=Zr,$r=Wr;function Xr(e){return!!$r(e)&&("[object Function]"==(e=Yr(e))||"[object GeneratorFunction]"==e||"[object AsyncFunction]"==e||"[object Proxy]"==e)}var Fr=e["__core-js_shared__"],Jr=(Fr=/[^.]+$/.exec(Fr&&Fr.keys&&Fr.keys.IE_PROTO||""))?"Symbol(src)_1."+Fr:"";var Qr=Function.prototype.toString;function ei(e){if(null!=e){try{return Qr.call(e)}catch(e){}try{return e+""}catch(e){}}return""}var ti=Xr,ri=function(e){return!!Jr&&Jr in e},ii=Wr,ni=ei,oi=/^\[object .+?Constructor\]$/,Fr=Function.prototype,ai=Object.prototype,Fr=Fr.toString,ai=ai.hasOwnProperty,si=RegExp("^"+Fr.call(ai).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");var li=function(e){return!(!ii(e)||ri(e))&&(ti(e)?si:oi).test(ni(e))},ci=function(e,t){return null==e?void 0:e[t]};function ui(e,t){return e=ci(e,t),li(e)?e:void 0}var Fr=ui(e,"Map"),ai=ui(Object,"create"),hi=ai;var di=ai,pi=Object.prototype.hasOwnProperty;var fi=ai,mi=Object.prototype.hasOwnProperty;var gi=ai;function yi(e){return e=this.has(e)&&delete this.__data__[e],this.size-=e?1:0,e}function vi(e){var t,r=this.__data__;return di?"__lodash_hash_undefined__"===(t=r[e])?void 0:t:pi.call(r,e)?r[e]:void 0}function _i(e){var t=this.__data__;return fi?void 0!==t[e]:mi.call(t,e)}function bi(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=gi&&void 0===t?"__lodash_hash_undefined__":t,this}function wi(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var i=e[t];this.set(i[0],i[1])}}wi.prototype.clear=function(){this.__data__=hi?hi(null):{},this.size=0},wi.prototype.delete=yi,wi.prototype.get=vi,wi.prototype.has=_i,wi.prototype.set=bi;var xi=wi,Ci=Vt,Ti=Fr;var Si=function(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e};function Ei(e,t){return e=e.__data__,Si(t)?e["string"==typeof t?"string":"hash"]:e.map}var Ii=Ei;var Ai=Ei;var ki=Ei;var Pi=Ei;function Mi(e){return e=Ii(this,e).delete(e),this.size-=e?1:0,e}function Ri(e){return Ai(this,e).get(e)}function Oi(e){return ki(this,e).has(e)}function Li(e,t){var r=Pi(this,e),i=r.size;return r.set(e,t),this.size+=r.size==i?0:1,this}function Di(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var i=e[t];this.set(i[0],i[1])}}Di.prototype.clear=function(){this.size=0,this.__data__={hash:new xi,map:new(Ti||Ci),string:new xi}},Di.prototype.delete=Mi,Di.prototype.get=Ri,Di.prototype.has=Oi,Di.prototype.set=Li;var ai=Di,zi=Vt,Ni=Fr,Bi=ai;function Fi(e,t){var r=this.__data__;if(r instanceof zi){var i=r.__data__;if(!Ni||i.length<199)return i.push([e,t]),this.size=++r.size,this;r=this.__data__=new Bi(i)}return r.set(e,t),this.size=r.size,this}var Ui=Vt,Vt=Dr,i=zr,qi=Nr;function ji(e){e=this.__data__=new Ui(e);this.size=e.size}ji.prototype.clear=Lr,ji.prototype.delete=Vt,ji.prototype.get=i,ji.prototype.has=qi,ji.prototype.set=Fi;Vt=ji;function Hi(e,t){for(var r=-1,i=null==e?0:e.length;++r<i&&!1!==t(e[r],r,e););return e}var Vi=ui,i=function(){try{var e=Vi(Object,"defineProperty");return e({},"",{}),e}catch(e){}}(),Gi=i;function Ki(e,t,r){"__proto__"==t&&Gi?Gi(e,t,{configurable:!0,enumerable:!0,value:r,writable:!0}):e[t]=r}var Zi=Ki,Wi=br,Yi=Object.prototype.hasOwnProperty;function $i(e,t,r){var i=e[t];Yi.call(e,t)&&Wi(i,r)&&(void 0!==r||t in e)||Zi(e,t,r)}var Xi=$i,Ji=Ki;function Qi(e,t,r,i){for(var n=!r,o=(r=r||{},-1),a=t.length;++o<a;){var s=t[o],l=i?i(r[s],e[s],s,r,e):void 0;void 0===l&&(l=e[s]),(n?Ji:Xi)(r,s,l)}return r}function en(e,t){for(var r=-1,i=Array(e);++r<e;)i[r]=t(r);return i}function tn(e){return null!=e&&"object"==typeof e}var rn=Zr,nn=tn;var qi=function(e){return nn(e)&&"[object Arguments]"==rn(e)},on=tn,an=Object.prototype,sn=an.hasOwnProperty,ln=an.propertyIsEnumerable,an=qi(function(){return arguments}())?qi:function(e){return on(e)&&sn.call(e,"callee")&&!ln.call(e,"callee")},qi=Array.isArray,cn={exports:{}};o=(o=(n=cn).exports)&&!o.nodeType&&o,un=(un=o&&n&&!n.nodeType&&n)&&un.exports===o?e.Buffer:void 0,o=un?un.isBuffer:void 0,n.exports=o||function(){return!1};var un=cn.exports,hn=/^(?:0|[1-9]\d*)$/;function dn(e,t){var r=typeof e;return!!(t=null==t?9007199254740991:t)&&("number"==r||"symbol"!=r&&hn.test(e))&&-1<e&&e%1==0&&e<t}function pn(e){return"number"==typeof e&&-1<e&&e%1==0&&e<=9007199254740991}var fn=Zr,mn=pn,gn=tn,yn={};yn["[object Float32Array]"]=yn["[object Float64Array]"]=yn["[object Int8Array]"]=yn["[object Int16Array]"]=yn["[object Int32Array]"]=yn["[object Uint8Array]"]=yn["[object Uint8ClampedArray]"]=yn["[object Uint16Array]"]=yn["[object Uint32Array]"]=!0,yn["[object Arguments]"]=yn["[object Array]"]=yn["[object ArrayBuffer]"]=yn["[object Boolean]"]=yn["[object DataView]"]=yn["[object Date]"]=yn["[object Error]"]=yn["[object Function]"]=yn["[object Map]"]=yn["[object Number]"]=yn["[object Object]"]=yn["[object RegExp]"]=yn["[object Set]"]=yn["[object String]"]=yn["[object WeakMap]"]=!1;function vn(e){return gn(e)&&mn(e.length)&&!!yn[fn(e)]}function _n(t){return function(e){return t(e)}}var bn,wn,n={exports:{}},r=(cn=(cn=(o=n).exports)&&!cn.nodeType&&cn,bn=cn&&o&&!o.nodeType&&o,wn=bn&&bn.exports===cn&&r.process,cn=function(){try{var e=bn&&bn.require&&bn.require("util").types;return e?e:wn&&wn.binding&&wn.binding("util")}catch(e){}}(),o.exports=cn,n.exports),o=vn,cn=_n,n=r&&r.isTypedArray,cn=n?cn(n):o,xn=en,Cn=an,Tn=qi,Sn=un,En=dn,In=cn,An=Object.prototype.hasOwnProperty;function kn(e,t){var r,i=Tn(e),n=!i&&Cn(e),o=!i&&!n&&Sn(e),a=!i&&!n&&!o&&In(e),s=i||n||o||a,l=s?xn(e.length,String):[],c=l.length;for(r in e)!t&&!An.call(e,r)||s&&("length"==r||o&&("offset"==r||"parent"==r)||a&&("buffer"==r||"byteLength"==r||"byteOffset"==r)||En(r,c))||l.push(r);return l}var Pn=Object.prototype;function Mn(e){var t=e&&e.constructor;return e===("function"==typeof t&&t.prototype||Pn)}function Rn(t,r){return function(e){return t(r(e))}}var n=Rn(Object.keys,Object),On=Mn,Ln=n,Dn=Object.prototype.hasOwnProperty;var zn=Xr,Nn=pn;function Bn(e){return null!=e&&Nn(e.length)&&!zn(e)}var Fn=kn,Un=function(e){if(!On(e))return Ln(e);var t,r=[];for(t in Object(e))Dn.call(e,t)&&"constructor"!=t&&r.push(t);return r},qn=Bn;function jn(e){return(qn(e)?Fn:Un)(e)}var Hn=Qi,Vn=jn;function Gn(e,t){return e&&Hn(t,Vn(t),e)}var Kn=Wr,Zn=Mn,Wn=function(e){var t=[];if(null!=e)for(var r in Object(e))t.push(r);return t},Yn=Object.prototype.hasOwnProperty;var $n=kn,Xn=function(e){if(!Kn(e))return Wn(e);var t,r=Zn(e),i=[];for(t in e)("constructor"!=t||!r&&Yn.call(e,t))&&i.push(t);return i},Jn=Bn;function Qn(e){return Jn(e)?$n(e,!0):Xn(e)}var eo=Qi,to=Qn;function ro(e,t){return e&&eo(t,to(t),e)}var io,o={exports:{}},no=(no=(no=(n=o).exports)&&!no.nodeType&&no,a=(a=no&&n&&!n.nodeType&&n)&&a.exports===no?e.Buffer:void 0,io=a?a.allocUnsafe:void 0,n.exports=function(e,t){return t?e.slice():(t=e.length,t=io?io(t):new e.constructor(t),e.copy(t),t)},o.exports);function oo(e,t){var r=-1,i=e.length;for(t=t||Array(i);++r<i;)t[r]=e[r];return t}function ao(){return[]}var so=function(e,t){for(var r=-1,i=null==e?0:e.length,n=0,o=[];++r<i;){var a=e[r];t(a,r,e)&&(o[n++]=a)}return o},lo=Object.prototype.propertyIsEnumerable,co=Object.getOwnPropertySymbols,a=co?function(t){return null==t?[]:(t=Object(t),so(co(t),function(e){return lo.call(t,e)}))}:ao,uo=Qi,ho=a;function po(e,t){return uo(e,ho(e),t)}function fo(e,t){for(var r=-1,i=t.length,n=e.length;++r<i;)e[n+r]=t[r];return e}var n=Rn(Object.getPrototypeOf,Object),mo=fo,go=n,yo=a,o=Object.getOwnPropertySymbols?function(e){for(var t=[];e;)mo(t,yo(e)),e=go(e);return t}:ao,vo=Qi,_o=o;function bo(e,t){return vo(e,_o(e),t)}var wo=fo,xo=qi;function Co(e,t,r){return t=t(e),xo(e)?t:wo(t,r(e))}var To=Co,So=a,Eo=jn;function Io(e){return To(e,Eo,So)}var Ao=Co,ko=o,Po=Qn;function Mo(e){return Ao(e,Po,ko)}var a=ui(e,"DataView"),o=Fr,Fr=ui(e,"Promise"),Ro=ui(e,"Set"),Oo=ui(e,"WeakMap"),Lo=Zr,Do=ei,zo="[object Map]",No="[object Promise]",Bo="[object Set]",Fo="[object WeakMap]",Uo="[object DataView]",qo=Do(a),jo=Do(o),Ho=Do(Fr),Vo=Do(Ro),Go=Do(Oo),s=Lo,a=s=a&&s(new a(new ArrayBuffer(1)))!=Uo||o&&s(new o)!=zo||Fr&&s(Fr.resolve())!=No||Ro&&s(new Ro)!=Bo||Oo&&s(new Oo)!=Fo?function(e){var t=Lo(e),e="[object Object]"==t?e.constructor:void 0,e=e?Do(e):"";if(e)switch(e){case qo:return Uo;case jo:return zo;case Ho:return No;case Vo:return Bo;case Go:return Fo}return t}:s,Ko=Object.prototype.hasOwnProperty;function Zo(e){var t=e.length,r=new e.constructor(t);return t&&"string"==typeof e[0]&&Ko.call(e,"index")&&(r.index=e.index,r.input=e.input),r}var o=e.Uint8Array,Wo=o;function Yo(e){var t=new e.constructor(e.byteLength);return new Wo(t).set(new Wo(e)),t}var $o=Yo;var Xo=/\w*$/;var Fr=Br?Br.prototype:void 0,Jo=Fr?Fr.valueOf:void 0;var Qo=Yo;function ea(e,t){return t=t?Qo(e.buffer):e.buffer,new e.constructor(t,e.byteOffset,e.length)}var ta=Yo,ra=function(e,t){return t=t?$o(e.buffer):e.buffer,new e.constructor(t,e.byteOffset,e.byteLength)},ia=function(e){var t=new e.constructor(e.source,Xo.exec(e));return t.lastIndex=e.lastIndex,t},na=function(e){return Jo?Object(Jo.call(e)):{}},oa=ea;function aa(e,t,r){var i=e.constructor;switch(t){case"[object ArrayBuffer]":return ta(e);case"[object Boolean]":case"[object Date]":return new i(+e);case"[object DataView]":return ra(e,r);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return oa(e,r);case"[object Map]":return new i;case"[object Number]":case"[object String]":return new i(e);case"[object RegExp]":return ia(e);case"[object Set]":return new i;case"[object Symbol]":return na(e)}}var sa=Wr,la=Object.create;function ca(){}var ua=function(e){if(!sa(e))return{};if(la)return la(e);ca.prototype=e;e=new ca;return ca.prototype=void 0,e},ha=n,da=Mn;function pa(e){return"function"!=typeof e.constructor||da(e)?{}:ua(ha(e))}var fa=a,ma=tn;function ga(e){return ma(e)&&"[object Map]"==fa(e)}var Ro=_n,Oo=r&&r.isMap,s=Oo?Ro(Oo):ga,ya=a,va=tn;function _a(e){return va(e)&&"[object Set]"==ya(e)}var e=_n,Fr=r&&r.isSet,Ro=Fr?e(Fr):_a,ba=Vt,wa=Hi,xa=$i,Ca=Gn,Ta=ro,Sa=no,Ea=oo,Ia=po,Aa=bo,ka=Io,Pa=Mo,Ma=a,Ra=Zo,Oa=aa,La=pa,Da=qi,za=un,Na=s,Ba=Wr,Fa=Ro,Ua=jn,qa=Qn,ja="[object Arguments]",Ha="[object Function]",Va="[object Object]",Ga={};Ga[ja]=Ga["[object Array]"]=Ga["[object ArrayBuffer]"]=Ga["[object DataView]"]=Ga["[object Boolean]"]=Ga["[object Date]"]=Ga["[object Float32Array]"]=Ga["[object Float64Array]"]=Ga["[object Int8Array]"]=Ga["[object Int16Array]"]=Ga["[object Int32Array]"]=Ga["[object Map]"]=Ga["[object Number]"]=Ga[Va]=Ga["[object RegExp]"]=Ga["[object Set]"]=Ga["[object String]"]=Ga["[object Symbol]"]=Ga["[object Uint8Array]"]=Ga["[object Uint8ClampedArray]"]=Ga["[object Uint16Array]"]=Ga["[object Uint32Array]"]=!0,Ga["[object Error]"]=Ga[Ha]=Ga["[object WeakMap]"]=!1;function Ka(r,i,n,e,t,o){var a,s=1&i,l=2&i,c=4&i;if(void 0===(a=n?t?n(r,e,t,o):n(r):a)){if(!Ba(r))return r;if(e=Da(r)){if(a=Ra(r),!s)return Ea(r,a)}else{var u=Ma(r),h=u==Ha||"[object GeneratorFunction]"==u;if(za(r))return Sa(r,s);if(u==Va||u==ja||h&&!t){if(a=l||h?{}:La(r),!s)return l?Aa(r,Ta(a,r)):Ia(r,Ca(a,r))}else{if(!Ga[u])return t?r:{};a=Oa(r,u,s)}}if(h=(o=o||new ba).get(r))return h;o.set(r,a),Fa(r)?r.forEach(function(e){a.add(Ka(e,i,n,e,r,o))}):Na(r)&&r.forEach(function(e,t){a.set(t,Ka(e,i,n,t,r,o))});var d=e?void 0:(c?l?Pa:ka:l?qa:Ua)(r);wa(d||r,function(e,t){d&&(e=r[t=e]),xa(a,t,Ka(e,i,n,t,r,o))})}return a}var Za=Ka;var Wa=z(function(e){return Za(e,5)}),Ya=Ki,$a=br;function Xa(e,t,r){(void 0===r||$a(e[t],r))&&(void 0!==r||t in e)||Ya(e,t,r)}var Oo=function(l){return function(e,t,r){for(var i=-1,n=Object(e),o=r(e),a=o.length;a--;){var s=o[l?a:++i];if(!1===t(n[s],s,n))break}return e}}(),Ja=Bn,Qa=tn;function es(e){return Qa(e)&&Ja(e)}var ts=Zr,rs=n,is=tn,r=Function.prototype,e=Object.prototype,ns=r.toString,os=e.hasOwnProperty,as=ns.call(Object);function ss(e){return!(!is(e)||"[object Object]"!=ts(e))&&(null===(e=rs(e))||"function"==typeof(e=os.call(e,"constructor")&&e.constructor)&&e instanceof e&&ns.call(e)==as)}function ls(e,t){if(("constructor"!==t||"function"!=typeof e[t])&&"__proto__"!=t)return e[t]}var cs=Qi,us=Qn;var hs=Xa,ds=no,ps=ea,fs=oo,ms=pa,gs=an,ys=qi,vs=es,_s=un,bs=Xr,ws=Wr,xs=ss,Cs=cn,Ts=ls,Ss=function(e){return cs(e,us(e))};var Es=Vt,Is=Xa,As=Oo,ks=function(e,t,r,i,n,o,a){var s,l,c,u=Ts(e,r),h=Ts(t,r),d=a.get(h);d||((t=void 0===(d=o?o(u,h,r+"",e,t,a):void 0))&&(l=!(s=ys(h))&&_s(h),c=!s&&!l&&Cs(h),d=h,s||l||c?d=ys(u)?u:vs(u)?fs(u):l?ds(h,!(t=!1)):c?ps(h,!(t=!1)):[]:xs(h)||gs(h)?gs(d=u)?d=Ss(u):ws(u)&&!bs(u)||(d=ms(h)):t=!1),t&&(a.set(h,d),n(d,h,i,o,a),a.delete(h))),hs(e,r,d)},Ps=Wr,Ms=Qn,Rs=ls;function Os(e){return e}var Ls=function(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)},Ds=Math.max;var zs=function(e){return function(){return e}},Ns=i,Bs=Date.now;var Fr=function(r){var i=0,n=0;return function(){var e=Bs(),t=16-(e-n);if(n=e,0<t){if(800<=++i)return arguments[0]}else i=0;return r.apply(void 0,arguments)}}(Ns?function(e,t){return Ns(e,"toString",{configurable:!0,enumerable:!1,value:zs(t),writable:!0})}:Os),Fs=Os,Us=function(o,a,s){return a=Ds(void 0===a?o.length-1:a,0),function(){for(var e=arguments,t=-1,r=Ds(e.length-a,0),i=Array(r);++t<r;)i[t]=e[a+t];for(var t=-1,n=Array(a+1);++t<a;)n[t]=e[t];return n[a]=s(i),Ls(o,this,n)}},qs=Fr;var js=br,Hs=Bn,Vs=dn,Gs=Wr;var Ks=function(e,t){return qs(Us(e,t,Fs),e+"")},Zs=function(e,t,r){var i;return!!Gs(r)&&!!("number"==(i=typeof t)?Hs(r)&&Vs(t,r.length):"string"==i&&t in r)&&js(r[t],e)};var Ws,Ys,$s=function i(n,o,a,s,l){n!==o&&As(o,function(e,t){var r;l=l||new Es,Ps(e)?ks(n,o,t,a,i,s,l):(r=s?s(Rs(n,t),e,t+"",n,o,l):void 0,Is(n,t,r=void 0===r?e:r))},Ms)},Xs=z(function(s){return Ks(function(e,t){var r=-1,i=t.length,n=1<i?t[i-1]:void 0,o=2<i?t[2]:void 0,n=3<s.length&&"function"==typeof n?(i--,n):void 0;for(o&&Zs(t[0],t[1],o)&&(n=i<3?void 0:n,i=1),e=Object(e);++r<i;){var a=t[r];a&&s(e,a,r,n)}return e})}(function(e,t,r){$s(e,t,r)})),Js=((window&&window.__extends||(Ws=function(e,t){return(Ws=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Ws(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Qs,Ys=ye),Qs);function Qs(){var e=null!==Ys&&Ys.apply(this,arguments)||this;return e.layout="icons",e.mapStyles=["road","grayscale_light","grayscale_dark","night","road_shaded_relief"],e.style=u.ControlStyle.light,e.autoSelectionMode=!0,e}var el,tl,s=window&&window.__extends||(el=function(e,t){return(el=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}el(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),rl=window&&window.__awaiter||function(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})},il=window&&window.__generator||function(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},c={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c;function e(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l=c&&t[c=0]?0:l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},nl=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},Ro=(s(ol,tl=er),ol.prototype.onAdd=function(e,t){function r(e){e?(n.classList.add(ol.Css.inUse),o.classList.remove("hidden-accessible-element")):(n.classList.remove(ol.Css.inUse),o.classList.add("hidden-accessible-element"))}var i=this,n=(this.map=e,this.buildContainer(e,this.options.style,"Map Style Control")),o=this.buildStyleOpsGrid(),a=(this.styleOpsGrid=o,this.buildCurrStyleBtn()),e=Ft("Select Style");return o.classList.add(t&&t.position||"top-right"),n.addEventListener("mouseover",function(){i.hasMouse=!0,r(!0)}),n.addEventListener("focusin",function(){i.hasFocus=!0,r(!0)}),n.addEventListener("mouseleave",function(){i.hasMouse=!1,i.hasFocus||r(!1)}),n.addEventListener("focusout",function(e){e.target===a&&Array.from(o.children).forEach(function(e){return e.removeAttribute("tabIndex")}),e.relatedTarget instanceof Node&&n.contains(e.relatedTarget)||(i.hasFocus=!1,i.hasMouse)||r(!1)}),o.addEventListener("keydown",function(e){27===e.keyCode&&(e.stopPropagation(),a.focus(),Array.from(o.children).forEach(function(e){return e.setAttribute("tabIndex","-1")}),n.classList.contains(ol.Css.inUse))&&r(!1)}),a.addEventListener("click",function(e){n.classList.contains(ol.Css.inUse)?r(!1):(r(!0),o.firstElementChild&&o.firstElementChild.focus())}),t&&ol.InvertOrderPositions.includes(t.position)?(n.appendChild(o),n.appendChild(a),n.appendChild(e),Ut(e,a)):(n.appendChild(a),n.appendChild(e),Ut(e,a),n.appendChild(o)),n},ol.prototype.onRemove=function(){tl.prototype.onRemove.call(this),this.styleOpsGrid=null,this.styleButtons.clear(),this.thumbnailCache.response.clear(),this.thumbnailCache.blob.clear(),this.thumbnailCache.assumedConfiguration=void 0,this.map.events.remove("stylechanged",this.onStyleChange),this.map.events.remove("mapconfigurationchanged",this.onMapConfigurationChange)},ol.prototype.setSelectedStyle=function(r){var t,e,i=this;this.styleIcons.has(r)&&(t=this.currStyleImage,e=this.styleIcons.get(r),t.src!==e&&(t.src=e),Object.entries(this.styleButtons).forEach(function(e){var e=nl(e,2),t=e[0];return e[1].setAttribute("aria-current",t===r?"true":"false")}),this.map.styles.definitions().then(function(e){e=i.mapToFriendlyStyleName(r,e);t.alt!==e&&(t.alt=e),t.parentElement.lastChild instanceof Text&&(t.parentElement.lastChild.textContent=e)}))},ol.prototype.disableStyle=function(e){e=this.styleButtons[e];e&&e.setAttribute("disabled","true")},ol.prototype.enableStyle=function(e){e=this.styleButtons[e];e&&e.removeAttribute("disabled")},ol.prototype.buildSelectStyleBtn=function(r,e,t){var i=this,n=document.createElement("button"),o=this.mapToFriendlyStyleName(r,e),a=(n.setAttribute("aria-label",o),n.setAttribute("type","button"),new Image),e=(t.then(function(e){var t;return i.thumbnailCache.blob.has(e.url)?i.thumbnailCache.blob.get(e.url):(t=e.clone().blob(),i.thumbnailCache.blob.set(e.url,t),t)}).then(function(e){e=URL.createObjectURL(e);a.src=e,r===i.map.getStyle().style&&(i.currStyleImage.src=e,i.currStyleImage.alt=o,i.currStyleImage.parentElement.lastChild.nodeType==Node.TEXT_NODE?i.currStyleImage.parentElement.lastChild.textContent=o:i.currStyleImage.parentElement.appendChild(document.createTextNode(o))),i.styleIcons.set(r,e)}),a.setAttribute("aria-hidden","true"),n.appendChild(a),"icons"===this.options.layout?n.classList.add(ol.Css.button):(n.classList.add(ol.Css.listButton),n.classList.add(ol.Css.expanded),n.appendChild(document.createTextNode(o))),n.addEventListener("click",function(){i.hasMouse=!1,i.hasFocus=!1;var e=i.styleButtons[r];e&&!e.hasAttribute("disabled")&&(i._invokeEvent("styleselected",r),i.options.autoSelectionMode&&i.map.setStyle({style:r}),Object.entries(i.styleButtons).forEach(function(e){var e=nl(e,2),t=e[0];return e[1].setAttribute("aria-current",t===r?"true":"false")}))}),document.createElement("div"));return e.classList.add("selected-icon"),n.appendChild(e),n},ol.prototype.buildCurrStyleBtn=function(){var e=document.createElement("button"),t=("icons"==this.options.layout?e.classList.add(ol.Css.button):e.classList.add(ol.Css.listButton),e.classList.add(ol.Css.currentStyle),e.setAttribute("aria-label","Select Style"),e.setAttribute("tabindex","-1"),this.currStyleImage=new Image,e.appendChild(this.currStyleImage),document.createElement("div"));return t.classList.add("icon"),e.appendChild(t),e},ol.prototype.buildStyleOpsGrid=function(){var e=this,t=document.createElement("div");return t.classList.add(ol.Css.styleOptions),"icons"===this.options.layout?t.classList.add(this.options.layout):t.classList.add(ol.Css.dropdown),t.setAttribute("aria-label","Style Options"),t.classList.add("hidden-accessible-element"),this.map.styles.definitions().then(function(t){return rl(e,void 0,void 0,function(){return il(this,function(e){return this.onMapConfigurationChange(t),this.map.events.add("stylechanged",this.onStyleChange),[2]})})}),this.map.events.add("mapconfigurationchanged",this.onMapConfigurationChange),t},ol.prototype.populateOpsGridFromDefinitions=function(n){var e,r,o=this;this.styleOpsGrid&&(e=n.configurations,(e=Array.isArray(this.options.mapStyles)?e.filter(function(e){return o.options.mapStyles.includes(e.name.split("_indoor")[0])}):e).forEach(function(e){var t,r={url:e.thumbnail},i=(e.thumbnail&&o.map.styles._transformStyleRequest(e.thumbnail,r),o.map.getServiceOptions()),i=(i.transformRequest&&Xs(r,i.transformRequest(r.url,"Thumbnail")),o.thumbnailCache.response.has(r.url)?t=Promise.resolve(o.thumbnailCache.response.get(r.url)):(t=fetch(r.url,{headers:r.headers}),o.thumbnailCache.response.set(r.url,t)),o.buildSelectStyleBtn(e.name,n,t));o.styleOpsGrid.appendChild(i),o.styleButtons[e.name]=i,"icons"===o.options.layout&&(r=Ft(o.mapToFriendlyStyleName(e.name,n)),o.styleOpsGrid.appendChild(r),Ut(r,i))}),r=this.map.getStyle().style,Object.entries(this.styleButtons).forEach(function(e){var e=nl(e,2),t=e[0];return e[1].setAttribute("aria-current",t===r?"true":"false")}))},ol.InvertOrderPositions=[u.ControlPosition.TopRight,u.ControlPosition.BottomRight],ol.Css={button:"azure-maps-control-button",listButton:"azure-maps-control-list-button",expanded:"expanded",currentStyle:"curr-style",inUse:"in-use",styleOptions:"style-options",dropdown:"azure-maps-control-dropdown"},ol);function ol(e){var t=tl.call(this)||this;return t.styleOpsGrid=null,t.hasMouse=!1,t.hasFocus=!1,t.styleButtons=new Yt,t.styleIcons=new Yt,t.thumbnailCache={assumedConfiguration:void 0,response:new Yt,blob:new Yt},t.onStyleChange=function(){var e;t.options.autoSelectionMode&&(e=t.map.getStyle().style,t.setSelectedStyle(e))},t.onMapConfigurationChange=function(e){!t.styleOpsGrid||0<t.styleOpsGrid.children.length&&t.thumbnailCache.assumedConfiguration===e||(t.thumbnailCache.assumedConfiguration=e,Array.from(t.styleOpsGrid.children).forEach(function(e){return e.remove()}),t.styleButtons.clear(),t.populateOpsGridFromDefinitions(e))},t.mapToFriendlyStyleName=function(t,e){e=e.configurations.find(function(e){return e.name===t});return(null==e?void 0:e.displayName)||t},t.options=(new Js).merge(Wa(e)),t}(window&&window.__extends||(al=function(e,t){return(al=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}al(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(cl,sl=ye);var al,sl,ll=cl;function cl(){var e=null!==sl&&sl.apply(this,arguments)||this;return e.flow="none",e.incidents=!1,e}(window&&window.__extends||(ul=function(e,t){return(ul=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}ul(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(pl,hl=ll);var ul,hl,dl=pl;function pl(){var e=null!==hl&&hl.apply(this,arguments)||this;return e.isActive=!1,e.style=u.ControlStyle.light,e}(window&&window.__extends||(fl=function(e,t){return(fl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}fl(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(yl,ml=er),Object.defineProperty(yl.prototype,"isActive",{get:function(){var e;return!!this.map&&("none"!==(e=this.map.getTraffic()).flow||e.incidents)},set:function(e){this.map&&this.map.setTraffic({flow:e?this.options.flow:"none",incidents:!!e&&this.options.incidents})},enumerable:!1,configurable:!0}),yl.prototype.onAdd=function(e){(this.map=e).getTraffic(),void 0!==this.initIsActive&&(this.isActive=this.initIsActive),this.container=this.buildContainer(e,this.style,"Traffic Control"),this.container.style.flexDirection="column";var e=this.constructTrafficButton(e),t=(this.container.appendChild(e),Ft("Toggle Traffic Display"));return this.container.appendChild(t),Ut(t,e),this.container},yl.prototype.onRemove=function(){ml.prototype.onRemove.call(this),this.map=null},yl.prototype.getOptions=function(){return(new dl).merge({isActive:this.isActive,flow:this.options.flow,incidents:this.options.incidents,style:this.style})},yl.prototype.updateButtonState=function(){this.trafficButton&&(this.isActive?(this.container.classList.add("in-use"),this.trafficButton.setAttribute("aria-description","Traffic is displayed")):(this.container.classList.remove("in-use"),this.trafficButton.removeAttribute("aria-description")),this.trafficButton.setAttribute("aria-pressed",this.isActive?"true":"false"))},yl.prototype.constructTrafficButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("traffic"),r.setAttribute("aria-label","Toggle Traffic Display"),r.setAttribute("alt","Toggle Traffic Display"),r.setAttribute("type","button"),this.trafficButton=r,this.updateButtonState(),r.addEventListener("click",function(){t.isActive=!t.isActive}),r};var fl,ml,gl=yl;function yl(e){var t,r=this;return(r=ml.call(this)||this).hasMouse=!1,r.hasFocus=!1,r.options=(new ll).merge({flow:"relative",incidents:!0}),r.style=u.ControlStyle.light,r.container=null,r.trafficButton=null,r.map=null,e&&(r.initIsActive=null!=(t=e.isActive)&&t,r.options.flow=e.flow||"relative",r.options.incidents=null==(t=e.incidents)||t,r.style=e.style||u.ControlStyle.light),r}var vl,_l,n=window&&window.__extends||(vl=function(e,t){return(vl=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}vl(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),bl=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},r=(n(wl,_l=er),wl.prototype.onAdd=function(e){this.map=e;var t=this.buildContainer(e,u.ControlStyle.auto,"Traffic Legend"),e=this.buildTrafficLegendDiv(e);return t.setAttribute("role","definition"),t.appendChild(e),t},wl.prototype.onRemove=function(){_l.prototype.onRemove.call(this),this.syncHiddenState&&(this.map.events.remove("styledata",this.syncHiddenState),this.syncHiddenState=null),this.map=null},wl.prototype.buildTrafficLegendDiv=function(t){var r,e,i,n,o=document.createElement("div"),a=(o.classList.add("traffic-legend","hidden"),o.setAttribute("alt","Traffic Legend"),document.createElement("table")),s=document.createElement("tr"),l=document.createElement("td"),c=(l.setAttribute("alt","Traffic"),l.appendChild(document.createTextNode("Traffic")),Ft("Traffic")),u=(l.classList.add("traffic-legend-title"),l.colSpan=6,s.appendChild(l),s.appendChild(c),Ut(c,l),a.appendChild(s),document.createElement("tr"));try{for(var h=bl(this.table),d=h.next();!d.done;d=h.next()){var p=d.value,f=document.createElement("td");if("Fast"===p||"Slow"===p)f.setAttribute("alt",p),f.appendChild(document.createTextNode(p)),f.classList.add("traffic-legend-text");else{f.classList.add("traffic-legend-colors"),f.setAttribute("aria-label","Traffic Legend"),f.setAttribute("role","img");try{i=void 0;for(var m=bl(p),g=m.next();!g.done;g=m.next()){var y=g.value,v=document.createElement("div");v.classList.add(y),f.appendChild(v)}}catch(e){i={error:e}}finally{try{g&&!g.done&&(n=m.return)&&n.call(m)}finally{if(i)throw i.error}}}u.appendChild(f);var _=Ft(p instanceof Array?"Traffic Legend":p);u.appendChild(_),Ut(_,f)}}catch(e){r={error:e}}finally{try{d&&!d.done&&(e=h.return)&&e.call(h)}finally{if(r)throw r.error}}return a.appendChild(u),o.appendChild(a),this.syncHiddenState=function(e){"style"===e.dataType&&((e=t.getTraffic()).flow&&"none"!==e.flow?o.classList.remove("hidden"):o.classList.add("hidden"))},this.syncHiddenState({dataType:"style"}),t.events.add("styledata",this.syncHiddenState),o},wl);function wl(){var e=_l.call(this)||this;return e.table=["Fast",["green","yellow","red","dark-red"],"Slow"],e.map=null,e.syncHiddenState=null,e}function xl(e){return this.__data__.has(e)}var Cl=ai;function Tl(e){var t=-1,r=null==e?0:e.length;for(this.__data__=new Cl;++t<r;)this.add(e[t])}Tl.prototype.add=Tl.prototype.push=function(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this},Tl.prototype.has=xl;var Sl=Tl,El=function(e,t){for(var r=-1,i=null==e?0:e.length;++r<i;)if(t(e[r],r,e))return!0;return!1},Il=function(e,t){return e.has(t)};function Al(e,t,r,i,n,o){var a=1&r,s=e.length,l=t.length;if(s!=l&&!(a&&s<l))return!1;var l=o.get(e),c=o.get(t);if(l&&c)return l==t&&c==e;var u=-1,h=!0,d=2&r?new Sl:void 0;for(o.set(e,t),o.set(t,e);++u<s;){var p,f=e[u],m=t[u];if(void 0!==(p=i?a?i(m,f,u,t,e,o):i(f,m,u,e,t,o):p)){if(p)continue;h=!1;break}if(d){if(!El(t,function(e,t){if(!Il(d,t)&&(f===e||n(f,e,r,i,o)))return d.push(t)})){h=!1;break}}else if(f!==m&&!n(f,m,r,i,o)){h=!1;break}}return o.delete(e),o.delete(t),h}function kl(e){var r=-1,i=Array(e.size);return e.forEach(function(e,t){i[++r]=[t,e]}),i}function Pl(e){var t=-1,r=Array(e.size);return e.forEach(function(e){r[++t]=e}),r}var Ml=o,Rl=br,Ol=Al,e=Br?Br.prototype:void 0,Ll=e?e.valueOf:void 0;var Dl=Io,zl=Object.prototype.hasOwnProperty;var Nl=Vt,Bl=Al,Fl=function(e,t,r,i,n,o,a){switch(r){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return e.byteLength==t.byteLength&&o(new Ml(e),new Ml(t))?!0:!1;case"[object Boolean]":case"[object Date]":case"[object Number]":return Rl(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var s=kl;case"[object Set]":s=s||Pl;if(e.size!=t.size&&!(1&i))return!1;var l=a.get(e);if(l)return l==t;i|=2,a.set(e,t);l=Ol(s(e),s(t),i,n,o,a);return a.delete(e),l;case"[object Symbol]":if(Ll)return Ll.call(e)==Ll.call(t)}return!1},Ul=function(e,t,r,i,n,o){var a=1&r,s=Dl(e),l=s.length;if(l!=Dl(t).length&&!a)return!1;for(var c=l;c--;){var u=s[c];if(!(a?u in t:zl.call(t,u)))return!1}var h=o.get(e),d=o.get(t);if(h&&d)return h==t&&d==e;for(var p=!0,f=(o.set(e,t),o.set(t,e),a);++c<l;){var m,g=e[u=s[c]],y=t[u];if(!(void 0===(m=i?a?i(y,g,u,t,e,o):i(g,y,u,e,t,o):m)?g===y||n(g,y,r,i,o):m)){p=!1;break}f=f||"constructor"==u}return p&&!f&&(h=e.constructor)!=(d=t.constructor)&&"constructor"in e&&"constructor"in t&&!("function"==typeof h&&h instanceof h&&"function"==typeof d&&d instanceof d)&&(p=!1),o.delete(e),o.delete(t),p},ql=a,jl=qi,Hl=un,Vl=cn,Gl="[object Arguments]",Kl="[object Array]",Zl="[object Object]",Wl=Object.prototype.hasOwnProperty;var Yl=function(e,t,r,i,n,o){var a=jl(e),s=jl(t),l=a?Kl:ql(e),s=s?Kl:ql(t),c=(l=l==Gl?Zl:l)==Zl,u=(s=s==Gl?Zl:s)==Zl;if((s=l==s)&&Hl(e)){if(!Hl(t))return!1;c=!(a=!0)}if(s&&!c)return o=o||new Nl,a||Vl(e)?Bl(e,t,r,i,n,o):Fl(e,t,l,r,i,n,o);if(!(1&r)){a=c&&Wl.call(e,"__wrapped__"),l=u&&Wl.call(t,"__wrapped__");if(a||l)return n(a?e.value():e,l?t.value():t,r,i,o=o||new Nl)}return s&&(o=o||new Nl,Ul(e,t,r,i,n,o))},$l=tn;var Xl=function e(t,r,i,n,o){return t===r||(null==t||null==r||!$l(t)&&!$l(r)?t!=t&&r!=r:Yl(t,r,i,n,e,o))};var Jl=z(function(e,t){return Xl(e,t)}),Ql=(ec.TYPE="Feature",ec);function ec(e,t,r,i){this.type="Feature",this.type=ec.TYPE,this.properties=t||{},this.id=r,this.geometry=e,this.bbox=i}var tc,rc,no=window&&window.__extends||(tc=function(e,t){return(tc=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}tc(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),ic=(rc=Array,no(nc,rc),nc.fromData=function(r){var i=NaN,n=NaN,o=new Set(["y"]),a=new Set(["x"]);return Object.keys(r).forEach(function(e){var t=e.toLowerCase();isNaN(i)&&o.has(t)&&"number"==typeof r[e]?i=r[e]:isNaN(n)&&a.has(t)&&"number"==typeof r[e]&&(n=r[e])}),isNaN(i)||isNaN(n)?null:new nc(i,n)},nc.getX=function(e){return 0<e.length?e[0]:NaN},nc.getY=function(e){return 1<e.length?e[1]:NaN},nc.getDestination=function(e,t,r){return new nc(nc.getX(e)+r*Math.cos((t+270)*Math.PI/180),nc.getY(e)+r*Math.sin((t+270)*Math.PI/180))},nc.getDistance=function(e,t){var r=nc.getX(e)-nc.getX(t),e=nc.getY(e)-nc.getY(t);return Math.sqrt(r*r+e*e)},nc.getHeading=function(e,t){var r=nc.getX(t)-nc.getX(e),e=nc.getY(e)-nc.getY(t);return 180*(2.5*Math.PI-Math.atan2(e,r))/Math.PI%360},nc);function nc(e,t){return rc.call(this,e,t)||this}ac.TYPE="Point";var oc=ac;function ac(e){this.type="Point",this.type=ac.TYPE,this.coordinates=e}var sc,lc,cc,uc,hc,dc=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},pc=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},fc=6378137,mc=Math.PI/180,gc=180/Math.PI,yc=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9],vc=85.0511;function _c(e){return e*mc}function bc(e){return e*gc}function wc(e,t,r){return Math.min(Math.max(e,t),r)}function xc(e,t){var r=_c(t[1]-e[1]),i=_c(t[0]-e[0]),r=Math.pow(Math.sin(r/2),2)+Math.cos(_c(e[1]))*Math.cos(_c(t[1]))*Math.pow(Math.sin(i/2),2),e=2*Math.atan2(Math.sqrt(r),Math.sqrt(1-r));return Math.round(fc*e*100)/100}function Cc(e){if(e)switch(e.toLowerCase()){case"feet":case"foot":case"ft":return lc.feet;case"kilometers":case"kilometer":case"kilometres":case"kilometre":case"km":case"kms":return lc.kilometers;case"miles":case"mile":case"mi":return lc.miles;case"nauticalmiles":case"nauticalmile":case"nms":case"nm":return lc.nauticalMiles;case"yards":case"yard":case"yds":case"yrd":case"yrds":return lc.yards;default:return lc.meters}return lc.meters}function Tc(e){if(e)switch(e.toLowerCase()){case"milespersecondsquared":case"milepersecondsquared":case"mi/s^2":case"mi/s2":return hc.milesPerSecondSquared;case"kilometerspersecondsquared":case"kilometrespersecondsquared":case"kilometerpersecondsquared":case"kilometrepersecondsquared":case"km/s^2":case"km/s2":return hc.kilometersPerSecondSquared;case"knotspersecond":case"knotpersecond":case"knts/s":case"kn/s":case"kt/s":return hc.knotsPerSecond;case"standardgravity":case"g":return hc.standardGravity;case"feetpersecondsquared":case"footpersecondsquared":case"ft/s^2":case"ft/s2":return hc.feetPerSecondSquared;case"yardspersecondsquared":case"yardpersecondsquared":case"yds/s^2":case"yds/s2":case"yd/s^2":case"yd/s2":return hc.yardsPerSecondSquared;case"milesperhoursecond":case"mileperhoursecond":case"milesperhourseconds":case"mileperhourseconds":case"mi/h/s":return hc.milesPerHourSecond;case"kilometersperhoursecond":case"kilometrespersoursecond":case"kilometerperhoursecond":case"kilometrepersoursecond":case"kilometersperhourssecond":case"kilometrespersourssecond":case"kilometerperhourssecond":case"kilometrepersourssecond":case"kmhs":case"km/h/s":return hc.kilometersPerHourSecond;default:return hc.metersPerSecondSquared}return hc.metersPerSecondSquared}function Sc(e){if(e)switch(e){case"acres":case"ac":return sc.acres;case"hectares":case"ha":return sc.hectares;case"squareFeet":case"ft^2":case"ft2":return sc.squareFeet;case"squareYards":case"squareYard":case"yds^2":case"yds2":case"yd^2":case"yd2":return sc.squareYards;case"squareKilometers":case"squareKilometres":case"squareKilometer":case"squareKilometre":case"km^2":case"km2":return sc.squareKilometers;case"squareMiles":case"squareMile":case"mi^2":case"mi2":return sc.squareMiles;default:return sc.squareMeters}return sc.squareMeters}function Ec(e){if(e)switch(e.toLowerCase()){case"feetpersecond":case"footsecond":case"ftps":case"ft/s":return uc.feetPerSecond;case"milesperhour":case"mileperhour":case"mph":case"mi/hr":case"mi/h":return uc.milesPerHour;case"knots":case"knot":case"knts":case"knt":case"kn":case"kt":return uc.knots;case"mach":case"m":return uc.mach;case"kilometersperhour":case"kilometresperhour":case"kmperhour":case"kmph":case"km/hr":case"km/h":return uc.kilometersPerHour;default:return uc.metersPerSecond}return uc.metersPerSecond}function Ic(e){if(e)switch(e.toLowerCase()){case"milliseconds":case"ms":return cc.ms;case"minutes":case"minute":case"mins":case"min":return cc.minutes;case"hours":case"hour":case"hr":case"h":return cc.hours;case"days":case"day":case"d":return cc.days;default:return cc.seconds}return cc.seconds}function Ac(e){var t=0;if(e&&0<e.length)for(var t=Math.abs(kc(e[0])),r=1,i=e.length;r<i;r++)t-=Math.abs(kc(e[r]));return t}function kc(e){var t=0;if(3<=e.length){for(var r=void 0,i=void 0,n=0,o=e.length;n<o;n++)t+=(_c(e[n===o-2?(r=o-2,i=o-1,0):n===o-1?(r=o-1,i=0,1):(i=(r=n)+1,n+2)][0])-_c(e[r][0]))*Math.sin(_c(e[i][1]));t=t*fc*fc/2}return t}function Pc(e,t,r){return(e[0]-r[0])*(t[1]-r[1])-(e[1]-r[1])*(t[0]-r[0])}function Mc(e,t,r){if(2<=r.length){for(var i,n,o,a=1/0,s=null,l=$c(r,22),c=0,u=l.length-1;c<u;c++)n=function(e,t,r){if(t[0]===r[0]&&t[1]===r[1])return t;var i=e[0]-t[0],e=e[1]-t[1],n=r[0]-t[0],o=r[1]-t[1],i=(n*i+o*e)/(n*n+o*o);return i<0?t:1<i?r:[t[0]+n*i,t[1]+o*i]}(t,l[c],l[c+1]),(i=ic.getDistance(t,n))<a&&(a=i,s=n);if(s)return o=Yc([s],22)[0],new Ql(new oc(o),{distance:Dc(e,o)})}else if(1===r.length)return new Ql(new oc(r[0]),{distance:Dc(e,r[0])});return null}function Rc(e,t){var r;return!isNaN(e)&&"number"==typeof t&&0<=t&&(r=void 0,r=t<yc.length?yc[t]:Math.pow(10,t),e=Math.round(e*r)/r),e}function Oc(e,t,r,i){switch(Cc(t)){case lc.meters:e/=1e3;break;case lc.feet:e/=3280.8399;break;case lc.miles:e/=.62137119;break;case lc.yards:e/=1093.6133;break;case lc.nauticalMiles:e/=.5399568;break;case lc.kilometers:}switch(Cc(r)){case lc.meters:e*=1e3;break;case lc.feet:e*=3280.8399;break;case lc.miles:e*=.62137119;break;case lc.yards:e*=1093.6133;break;case lc.nauticalMiles:e*=.5399568;break;case lc.kilometers:}return"number"==typeof i&&0<=i&&(t=Math.pow(10,i),e=Math.round(e*t)/t),e}function Lc(e,t,r,i){i=i||"meters",e=au(e);var i=zc(i),n=_c(e[1]),e=_c(e[0]),t=t*mc,r=r/i,i=Math.asin(Math.sin(n)*Math.cos(r)+Math.cos(n)*Math.sin(r)*Math.cos(t)),e=e+Math.atan2(Math.sin(t)*Math.sin(r)*Math.cos(n),Math.cos(r)-Math.sin(n)*Math.sin(i)),t=wc(Kc(i*gc),-85,85);return[Zc(e*gc),t]}function Dc(e,t,r){e=xc(e=au(e),t=au(t));return"meters"===r?e:Oc(e,"meters",r||"meters")}function zc(e){e=Cc(e);return Oc(fc,lc.meters,e)}function Nc(e,t,r){for(var i=[],n=_c(e[1]),o=_c(e[0]),a=_c(t[1]),s=_c(t[0]),l=2*Math.asin(Math.sqrt(Math.pow(Math.sin((n-a)/2),2)+Math.cos(n)*Math.cos(a)*Math.pow(Math.sin((o-s)/2),2))),c=0;c<=r;c++){var u=c/r,h=Math.sin((1-u)*l)/Math.sin(l),u=Math.sin(u*l)/Math.sin(l),d=h*Math.cos(n)*Math.cos(o)+u*Math.cos(a)*Math.cos(s),p=h*Math.cos(n)*Math.sin(o)+u*Math.cos(a)*Math.sin(s),h=h*Math.sin(n)+u*Math.sin(a),u=Math.atan2(h,Math.sqrt(Math.pow(d,2)+Math.pow(p,2))),h=Math.atan2(p,d),u=wc(u*gc,-85,85);i.push([h*=gc,u])}return i}function Bc(e){return(Array.isArray(e)?e:e.coordinates).reduce(function(e,t){var r=0<e.length?e[e.length-1]:null;return r&&180<Math.abs(t[0]-r[0])?(r=r[0]<0?t[0]-360:t[0]+360,e.push([r,t[1]])):e.push(t),e},[])}function Fc(e){for(var t,r,i,n,o,a=Array.isArray(e)?e:e.coordinates,s=[],l=[],c=0;c<a.length;c++)s.push(a[c]),c+1>=a.length||(t=(r=dc(a[c],2))[0],r=r[1],n=(o=dc(a[c+1],2))[0],o=o[1],180<Math.abs(n-t)&&(i=0<t?180:-180,n=Math.abs((0<t?n+360:n-360)-t),o=r+(o-r)*(Math.abs(i-t)/n),s.push([i,o]),l.push(s),s=[[-i,o]]));return l.push(s),l}function Uc(e,t){var r,i;return e=au(e),t=au(t),e&&2<=e.length&&t&&2<=t.length?(i=_c(e[1]),r=_c(t[1]),t=_c(t[0]-e[0]),e=Math.sin(t)*Math.cos(r),i=Math.cos(i)*Math.sin(r)-Math.sin(i)*Math.cos(r)*Math.cos(t),(bc(Math.atan2(e,i))+360)%360):NaN}function qc(e,t){var r,i=0;Array.isArray(e)?r=e:e.type&&"LineString"===e.type&&(r=e.coordinates);for(var n=0,o=r.length-1;n<o;n++)i+=xc(r[n],r[n+1]);return Oc(i,"meters",t||"meters")}function jc(e,t,r){r=r||"meters";var i,n=0;if(Array.isArray(e)?i=e:e.type&&"LineString"===e.type&&(i=e.coordinates),2<=i.length){for(var o,a,s=i.length,l=1;l<s;l++){if(t<=n+(a=Dc(i[l-1],i[l],r)))return o=Uc(i[l-1],i[l]),Lc(i[l-1],o,t-n,r);n+=a}return n<=t?i[s-1]:i[0]}return null}function Hc(e,t,r,i,n){i=i||"meters",n=n||0,e=au(e);for(var o=[],a=360/r,s=0;s<=r;s++)o.push(Lc(e,(s*a+n)%360,t,i));return o}function Vc(e,t,r,i,n){return Bc(Hc(e,t,r,i,n))}function Gc(e,t,r){r=void 0===r?.5:r;var i=Dc(e=au(e),t=au(t),"kilometers");return Lc(e,Uc(e,t),i*r,"kilometers")}function Kc(e){return 90<e?180<(e=(e+90)%360)?90-(e-180):e-90:e<-90?(e=(e-90)%360)<-180?-90-(e+180):e+90:e}function Zc(e){return 180<e?(e+180)%360-180:e<-180?(e-180)%360+180:e}function Wc(e,t,r){if(0===r)return Object.assign({},e);t=au(t);for(var i,n,o=[],a=0,s=e.length;a<s;a++)i=Dc(t,e[a]),n=Uc(t,e[a]),o.push(Lc(t,n+r,i));return o}function Yc(e,t){for(var r,i,n=512*Math.pow(2,t),o=[],a=0,s=e.length;a<s;a++)r=e[a][0]/n-.5,i=.5-e[a][1]/n,o.push([360*r,90-360*Math.atan(Math.exp(2*-i*Math.PI))/Math.PI]);return o}function $c(e,t){for(var r,i,n=512*Math.pow(2,t),o=[],a=0,s=e.length;a<s;a++)i=Math.sin(e[a][1]*Math.PI/180),r=(e[a][0]+180)/360,i=.5-Math.log((1+i)/(1-i))/(4*Math.PI),o.push([Math.round(r*n),Math.round(i*n)]);return o}function Xc(e,t,r,i){switch(Tc(t)){case hc.kilometersPerHourSecond:e/=3.6;break;case hc.milesPerHourSecond:e/=2.236936292054;break;case hc.knotsPerSecond:e/=1.943844492441;break;case hc.standardGravity:e/=.1019716212978;break;case hc.kilometersPerSecondSquared:e/=.001;break;case hc.milesPerSecondSquared:e/=.000621371192;break;case hc.feetPerSecondSquared:e/=3.280839895012;break;case hc.yardsPerSecondSquared:e/=1.093613298338;break;case hc.metersPerSecondSquared:}switch(Tc(r)){case hc.kilometersPerHourSecond:e*=3.6;break;case hc.milesPerHourSecond:e*=2.236936292054;break;case hc.knotsPerSecond:e*=1.943844492441;break;case hc.standardGravity:e*=.1019716212978;break;case hc.kilometersPerSecondSquared:e*=.001;break;case hc.milesPerSecondSquared:e*=.000621371192;break;case hc.feetPerSecondSquared:e*=3.280839895012;break;case hc.yardsPerSecondSquared:e*=1.093613298338;break;case hc.metersPerSecondSquared:}return Rc(e,i)}function Jc(e,t,r,i){switch(Sc(t)){case sc.acres:e*=4046.8564224;break;case sc.hectares:e*=1e4;break;case sc.squareFeet:e*=.09290304;break;case sc.squareKilometers:e*=1e6;break;case sc.squareMiles:e*=259e4;break;case sc.squareYards:e*=.83612736;break;case sc.squareMeters:}switch(Sc(r)){case sc.acres:e/=4046.8564224;break;case sc.hectares:e/=1e4;break;case sc.squareFeet:e/=.09290304;break;case sc.squareKilometers:e/=1e6;break;case sc.squareMiles:e/=259e4;break;case sc.squareYards:e/=.83612736;break;case sc.squareMeters:}return Rc(e,i)}function Qc(e,t,r,i){switch(Ec(t)){case uc.feetPerSecond:e*=1.09728;break;case uc.milesPerHour:e*=1.6093;break;case uc.knots:e*=1.852;break;case uc.metersPerSecond:e*=3.6;break;case uc.mach:e*=1234.8;break;case uc.kilometersPerHour:}switch(Ec(r)){case uc.feetPerSecond:e/=1.09728;break;case uc.milesPerHour:e/=1.6093;break;case uc.knots:e/=1.852;break;case uc.metersPerSecond:e/=3.6;break;case uc.mach:e/=1234.8;break;case uc.kilometersPerHour:}return Rc(e,i)}function eu(e,t,r,i){switch(Ic(t)){case cc.ms:e/=1e3;break;case cc.hours:e*=3600;break;case cc.minutes:e*=60;break;case cc.days:e*=86400;break;case cc.seconds:}switch(Ic(r)){case cc.ms:e*=1e3;break;case cc.hours:e/=3600;break;case cc.minutes:e/=60;break;case cc.days:e/=86400;break;case cc.seconds:}return Rc(e,i)}function tu(e,t,r,i,n,o,a,s){t=Oc(t,n,lc.meters),n=eu(r,o,cc.seconds);return Xc(2*(t-Qc(e,i,uc.metersPerSecond)*n)/(n*n),hc.metersPerSecondSquared,a,s)}function ru(e,t,r,i,n,o,a){e=Qc(e,i,uc.metersPerSecond);return Xc((Qc(t,i,uc.metersPerSecond)-e)/eu(r,n,cc.seconds),hc.metersPerSecondSquared,o,a)}function iu(e,t,r,i){e=nu(e),t=nu(t);return null!=e&&null!=t?eu(t.getTime()-e.getTime(),cc.ms,r,i):NaN}function nu(e){if("[object Date]"===Object.prototype.toString.call(e))return e;if("string"==typeof e){var t=Date.parse(e);if(!isNaN(t))return new Date(t);if(0<=e.indexOf("Date("))return t=(t=0)<(e=e.replace("/Date(","").replace(")/","")).indexOf("+")?parseInt(e.substr(0,e.indexOf("+")),10):0<e.indexOf("-")?parseInt(e.substr(0,e.indexOf("-")),10):parseInt(e,10),new Date(t)}else if("number"==typeof e)return new Date(e);return null}function ou(e){var t=[],r=null,i=null;if(Array.isArray(e)&&0<e.length)if(Array.isArray(e[0])&&"number"==typeof e[0][0])t=e;else for(var n=e.length,o=0;o<n;o++)t=t.concat(ou(e[o]));else if(e.type)switch(e.type){case"Point":t=[e.coordinates];break;case"LineString":t=e.coordinates;break;case"Polygon":r=e.coordinates;break;case"MultiPoint":t=e.coordinates;break;case"MultiLineString":r=e.coordinates;break;case"MultiPolygon":i=e.coordinates;break;case"Feature":var a=e,t=vu._isCircle(a)?vu._getCirclePositions(a):ou(a.geometry);break;case"FeatureCollection":t=ou(e.features);break;case"GeometryCollection":t=ou(e.geometries)}else if(e instanceof vu)return ou(e.toJson());if(r)for(n=r.length,o=0;o<n;o++)t=t.concat(r[o]);else if(i)for(var s=i.length,o=0;o<s;o++)for(var l=i[o].length,c=0;c<l;c++)t=t.concat(i[o][c]);return t}function au(e){if(Array.isArray(e)&&"number"==typeof e[0])return e;if(e.type){if("Point"===e.type)return e.coordinates;if("Feature"===e.type&&"Point"===e.geometry.type)return e.geometry.coordinates}else if(e instanceof vu&&"Point"===e.getType())return e.getCoordinates();return null}function su(e,t,r){r=r||"meters";var i,n=0;if(Array.isArray(e)?i=e:e.type&&"LineString"===e.type&&(i=e.coordinates),2<=i.length){for(var o,a,s,l=i.length,c=1;c<l;c++){if(t<=n+(s=Dc(i[c-1],i[c],r)))return o=Uc(i[c-1],i[c]),a=Lc(i[c-1],o,t-n,r),new Ql(new oc(a),{heading:o});n+=s}return n<=t?new Ql(new oc(i[l-1]),{heading:Uc(i[l-2],i[l-1])}):new Ql(new oc(i[0]),{heading:Uc(i[0],i[1])})}return null}function lu(e,t,r,i){var n=au(e),o=$c([n],22)[0],a=null,s=1/0;switch((t=t instanceof vu?t.toJson():t).type){case"Feature":return lu(e,t.geometry,r);case"Point":p=[[t.coordinates]];break;case"MultiPoint":for(var l,c=t.coordinates,u=0,h=c.length;u<h;u++)(l=Dc(n,c[u]))<s&&(s=l,a=new Ql(new oc(c[u]),{distance:l}));break;case"LineString":p=[t.coordinates];break;case"Polygon":case"MultiLineString":p=t.coordinates;break;case"MultiPolygon":var d=t.coordinates;if(0<d.length)for(var p=d[0],u=1,h=d.length;u<h;u++)p=p.concat(d[u])}if(p)for(var f,u=0,h=p.length;u<h;u++)(f=Mc(n,o,p[u]))&&f.properties.distance<s&&(s=f.properties.distance,a=f);return a&&(a.properties.distance=Oc(a.properties.distance,"meters",r,i)),a}(an=sc=sc||{}).squareMeters="squareMeters",an.acres="acres",an.hectares="hectares",an.squareFeet="squareFeet",an.squareKilometers="squareKilometers",an.squareMiles="squareMiles",an.squareYards="squareYards",(Oo=lc=lc||{}).meters="meters",Oo.kilometers="kilometers",Oo.feet="feet",Oo.miles="miles",Oo.nauticalMiles="nauticalMiles",Oo.yards="yards",(i=cc=cc||{}).seconds="seconds",i.hours="hours",i.ms="ms",i.minutes="minutes",i.days="days",(Fr=uc=uc||{}).metersPerSecond="metersPerSecond",Fr.kilometersPerHour="kilometersPerHour",Fr.feetPerSecond="feetPerSecond",Fr.milesPerHour="milesPerHour",Fr.knots="knots",Fr.mach="mach",(s=hc=hc||{}).milesPerSecondSquared="milesPerSecondSquared",s.kilometersPerSecondSquared="kilometersPerSecondSquared",s.knotsPerSecond="knotsPerSecond",s.standardGravity="standardGravity",s.feetPerSecondSquared="feetPerSecondSquared",s.yardsPerSecondSquared="yardsPerSecondSquared",s.milesPerHourSecond="milesPerHourSecond",s.kilometersPerHourSecond="kilometersPerHourSecond",s.metersPerSecondSquared="metersPerSecondSquared";var cu,uu,n=window&&window.__extends||(cu=function(e,t){return(cu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}cu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),hu=(uu=Array,n(du,uu),du.fromPosition=function(e){return 2===e.length?new du(e[0],e[1]):2<e.length?new du(e[0],e[1],e[2]):null},du.areEqual=function(e,t,r){var i,n;return void 0===r&&(r=6),!!(e&&2<=e.length&&t&&2<=t.length)&&(r=Math.pow(10,r),n=Kc(e[1]),i=Kc(t[1]),e=Zc(e[0]),t=Zc(t[0]),0==Math.round((n-i)*r)/r)&&(0==(n=Math.round((e-t)*r)/r)||360==n)},du.fromLatLng=function(n,e,t){var o,a,s,l,c,u,r=[];return"number"==typeof n?("number"==typeof e&&r.push(e),r.push(n),"number"==typeof t&&r.push(t)):Array.isArray(n)?2<=n.length&&"number"==typeof n[0]&&"number"==typeof n[1]&&(3<=n.length&&"number"==typeof n[2]?r.push(n[1],n[0],n[2]):r.push(n[1],n[0])):"object"==typeof n&&(o=["lat","latitude","y"],a=["lng","longitude","lon","x"],s=["elv","elevation","alt","altitude","z"],u=c=l=NaN,Object.keys(n).forEach(function(e,t,r){var i=e.toLowerCase();isNaN(l)&&0<=o.indexOf(i)&&"number"==typeof n[e]?l=n[e]:isNaN(c)&&0<=a.indexOf(i)&&"number"==typeof n[e]?c=n[e]:isNaN(u)&&0<=s.indexOf(i)&&"number"==typeof n[e]&&(u=n[e])}),isNaN(l)||isNaN(c)||(r.push(c,l),isNaN(u))||r.push(u)),2<=r.length?r:null},du.fromLatLngs=function(e){var t=[];if(Array.isArray(e))for(var r=0,i=e.length;r<i;r++){var n=du.fromLatLng(e[r]);n&&t.push(n)}return t},du._getDimensions=function(e){for(var t=0;Array.isArray(e);)e=e[0],t++;return"number"==typeof e&&t--,t},du);function du(e,t,r){return r?uu.call(this,e,t,r)||this:uu.call(this,e,t)||this}fu.TYPE="Polygon";var pu=fu;function fu(e,t){this.type="Polygon",this.type=fu.TYPE,1===hu._getDimensions(e)?this.coordinates=[e]:this.coordinates=e,this.bbox=t}var mu,gu,ai=window&&window.__extends||(mu=function(e,t){return(mu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}mu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),yu=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},vu=(ai(_u,gu=$t),_u.prototype.addProperty=function(e,t){Jl(this.data.properties[e],t)||(this.data.properties[e]=Wa(t),"subType"!==e&&"radius"!==e||this._handleCircle(),this.dataSource&&this.dataSource._updateSource(),this._invokeEvent("shapechanged",this))},_u.prototype.getBounds=function(){var t,e,r,i,n,o=this.getCoordinates(),a=this.getType();if("Point"===a)n=this.circlePolygon?(s=this.circlePolygon.geometry.coordinates,f.fromPositions(s[0])):new f(s=o,s);else if("MultiPoint"===a||"LineString"===a){var s=o;n=f.fromPositions(s)}else if("Polygon"===a){s=o;n=f.fromPositions(s[0])}else if("MultiLineString"===a){s=o;try{for(var l=yu(s),c=l.next();!c.done;c=l.next()){var u=c.value;n=f.merge(n,f.fromPositions(u))}}catch(e){t={error:e}}finally{try{c&&!c.done&&(e=l.return)&&e.call(l)}finally{if(t)throw t.error}}}else if("MultiPolygon"===a){s=o;try{for(var h=yu(s),d=h.next();!d.done;d=h.next()){var p=d.value;n=f.merge(n,f.fromPositions(p[0]))}}catch(e){r={error:e}}finally{try{d&&!d.done&&(i=h.return)&&i.call(h)}finally{if(r)throw r.error}}}return n},_u.prototype.getCoordinates=function(){return Wa(this.data.geometry.coordinates)},_u.prototype.getCircleCoordinates=function(){return this.circlePolygon?Wa(this.circlePolygon.geometry.coordinates[0]):null},_u.prototype.getId=function(){return this.data.id},_u.prototype.getProperties=function(){return Wa(this.data.properties)},_u.prototype.getType=function(){return this.data.geometry.type},_u.prototype.isCircle=function(){return _u._isCircle(this.data)},_u.prototype.isRectangle=function(){return _u._isRectangle(this.data)},_u.prototype.setCoordinates=function(e){e="Polygon"===this.getType()&&1===hu._getDimensions(e)?[e]:e;Jl(this.data.geometry.coordinates,e)||(this.data.geometry.coordinates=Wa(e),this._handleCircle(),this.dataSource&&this.dataSource._updateSource(),this._invokeEvent("shapechanged",this))},_u.prototype.setProperties=function(e){e[_u._shapeIdPropName]=this.data.id,Jl(this.data.properties,e)||(this.data.properties=Wa(e),this._handleCircle(),this.dataSource&&this.dataSource._updateSource(),this._invokeEvent("shapechanged",this))},_u.prototype.toJson=function(){return JSON.parse(JSON.stringify(this.data))},_u.prototype._toJson=function(){return this.circlePolygon||this.data},_u.prototype._setDataSource=function(e){void 0===e||null==e?delete this.dataSource:this.dataSource=e},_u.prototype._handleCircle=function(){var e;this.isCircle()?(e=_u._getCirclePositions(this.data),this.circlePolygon=new Ql(new pu([e]),this.data.properties,this.data.id),this.data.properties.subType="Circle"):delete this.circlePolygon},_u._isCircle=function(e){return e&&e.geometry&&"Point"===e.geometry.type&&e.geometry.coordinates&&e.properties&&"string"==typeof e.properties.subType&&"circle"===e.properties.subType.toLowerCase()&&"number"==typeof e.properties.radius},_u._isRectangle=function(e){if("Polygon"===e.geometry.type&&e.geometry.coordinates&&"string"==typeof e.properties.subType&&"rectangle"===e.properties.subType.toLowerCase()){e=e.geometry.coordinates;if(1===e.length){e=e[0];if(5===e.length)return e[0][0]===e[4][0]&&e[0][1]===e[4][1];if(4===e.length)return!0}}return!1},_u._getCirclePositions=function(e){return Vc(e.geometry.coordinates,e.properties.radius,72,"meters")},_u._shapeIdPropName="_azureMapsShapeId",_u);function _u(e,t,r){var i,n,o=gu.call(this)||this;return"Feature"===e.type?(n=Wa((i=e).geometry),r=i.properties?Wa(i.properties):{},t=null==i.id||""===i.id?Z():i.id):(n=Wa(e),t=null==t||""===t?Z():t,r=r?Wa(r):{}),r[_u._shapeIdPropName]=t,o.data=new Ql(n,r,t),o._handleCircle(),o}var bu,wu,o=window&&window.__extends||(bu=function(e,t){return(bu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}bu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),xu=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},f=(wu=Array,o(y,wu),y.fromBoundingBox=function(e){var t=y.getWest(e),r=y.getSouth(e),i=y.getEast(e),e=y.getNorth(e);return new y([t,r,i,e])},y.fromDimensions=function(e,t,r){var i=e[0],e=e[1],n=Math.min(Math.max(e+r/2,-85.5),85.5),e=Math.min(Math.max(e-r/2,-85.5),85.5),r=Zc(i+t/2);return new y([Zc(i-t/2),e,r,n])},y.fromEdges=function(e,t,r,i){return new y([e,t,r,i])},y.containsPosition=function(e,t){var r=y.getCenter(e),i=Math.abs(r[1]-t[1]),r=Math.abs(r[0]-t[0]),t=(180<r&&(r=360-r),y.getHeight(e)),e=y.getWidth(e);return i<=t/2+1e-8&&r<=e/2+1e-8},y.containsBoundingBox=function(e,t){var r=e&&4===e.length,i=t&&4===t.length;return!(!r||!i)&&y.getWest(e)<y.getWest(t)&&y.getWest(t)<y.getEast(e)&&y.getWest(e)<y.getEast(t)&&y.getEast(t)<y.getEast(e)&&y.getSouth(e)<y.getSouth(t)&&y.getSouth(t)<y.getNorth(e)&&y.getSouth(e)<y.getNorth(t)&&y.getNorth(t)<y.getNorth(e)},y.crossesAntimeridian=function(e){return Zc(y.getEast(e))-Zc(y.getWest(e))<0||y.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe(e)||y.isBoundingBoxWithLessThanSixElementsLargerThanGlobe(e)},y.getCenter=function(e){var t=Zc(y.getEast(e)),r=Zc(y.getWest(e)),r=(t<r&&(t+=360),Zc((r+t)/2)),t=Kc(y.getSouth(e)),e=Kc(y.getNorth(e));return[r,Kc((t+e)/2)]},y.getHeight=function(e){e=Kc(y.getNorth(e))-Kc(y.getSouth(e));return isNaN(e)?0:e},y.getWidth=function(e){e=Zc(y.getEast(e))-Zc(y.getWest(e));return isNaN(e)?0:e<0?e+360:e},y.getSouthWest=function(e){var t=this.getSouth(e),e=this.getWest(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getNorthEast=function(e){var t=this.getNorth(e),e=this.getEast(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getNorthWest=function(e){var t=this.getNorth(e),e=this.getWest(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getSouthEast=function(e){var t=this.getSouth(e),e=this.getEast(e);return isNaN(t)||isNaN(e)?null:[e,t]},y.getSouth=function(e){return e&&4<=e.length?Number(e[1]):NaN},y.getWest=function(e){return e&&4<=e.length?Number(e[0]):NaN},y.getNorth=function(e){if(e){if(4===e.length)return Number(e[3]);if(6===e.length)return Number(e[4])}return NaN},y.getEast=function(e){if(e){if(4===e.length)return Number(e[2]);if(6===e.length)return Number(e[3])}return NaN},y.intersect=function(e,t){var r=y.getCenter(e),i=y.getCenter(t),n=Math.abs(r[1]-i[1]),r=Math.abs(r[0]-i[0]),i=(180<r&&(r=360-r),y.getHeight(e)),e=y.getWidth(e),o=y.getHeight(t),t=y.getWidth(t);return n<=i/2+o/2&&r<=e/2+t/2},y.merge=function(e,t){var r=e&&4===e.length,i=t&&4===t.length;if(r&&!i)return e;if(i&&!r)return t;if(!r&&!i)return null;for(var r=Math.max(Kc(y.getNorth(e)),Kc(y.getNorth(t))),i=Math.min(Kc(y.getSouth(e)),Kc(y.getSouth(t))),n=[e,t],o=[],a=0,a=0;a<n.length;a++){var s=n[a],l=Zc(y.getWest(s)),c=Zc(y.getEast(s));y.crossesAntimeridian(s)?(o.push([l,180]),o.push([-180,c])):o.push([l,c])}o.sort(function(e,t){return e[0]===t[0]?e[1]-t[1]:e[0]-t[0]});var u=[],h=o[0];for(a=1;a<o.length;){var d=o[a];h[1]>=d[0]?h[1]=Math.max(h[1],d[1]):(u.push(h),h=d),a++}u.push(h);var p=u.length,f=u[0][0]+360-u[p-1][1],m=[u[p-1][1],u[0][0]];for(a=1;a<p;a++){var g=u[a][0]-u[a-1][1];f<g&&(f=g,m=[u[a-1][1],u[a][0]])}return new y([m[1],i],[m[0],r])},y.fromPositions=function(e){for(var t,r,i=NaN,n=NaN,o=NaN,a=NaN,s=e.length,l=new Array(s),c=0;s--;)(r=e[s])&&2<=r.length&&(t=Kc(r[1]),i=isNaN(i)?t:Math.max(i,t),n=isNaN(n)?t:Math.min(n,t),l[c++]=Zc(r[0]));if(c){l.length=c,l.sort(function(e,t){return e-t});for(var u=l[0]+360-l[c-1],h=0,s=1;s<c;s++){var d=l[s]-l[s-1];u<d&&(u=d,h=s)}o=l[h],a=l[(h||c)-1]}return isNaN(o)||isNaN(n)||isNaN(a)||isNaN(i)?null:new y([o,n,a,i])},y.fromLatLngs=function(e){return y.fromPositions(hu.fromLatLngs(e))},y.fromData=function(e){var t,r,i=null;if(Array.isArray(e)&&0<e.length){try{for(var n=xu(e),o=n.next();!o.done;o=n.next()){var a,s=o.value;null!=(a=y.fromData(s))&&(i=null===i?a:y.merge(i,a))}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}return i}if(e instanceof vu)return e.getBounds();if(e&&e.type){var l=e;if(l.bbox&&4===l.bbox.length)return l.bbox;switch(l.type){case"FeatureCollection":return y.fromData(l.features);case"Feature":return vu._isCircle(l)?y.fromPositions(vu._getCirclePositions(l)):y.fromData(l.geometry);case"GeometryCollection":return y.fromData(l.geometries);case"Point":var c=l.coordinates;if(c&&2<=c.length)return[c[0],c[1],c[0],c[1]];break;case"LineString":case"MultiPoint":return y.fromPositions(l.coordinates);case"Polygon":case"MultiLineString":var u=l.coordinates;if(u&&0<u.length){for(var h=0,d=u.length;h<d;h++)null!=(a=y.fromPositions(u[h]))&&(i=null===i?a:y.merge(i,a));if(null!=i)return i}break;case"MultiPolygon":var p=l.coordinates;if(p&&0<p.length){for(h=0,d=p.length;h<d;h++)for(var f=0,m=p[h].length;f<m;f++)null!=(a=y.fromPositions(p[h][f]))&&(i=null===i?a:y.merge(i,a));return i}}}return null},y.splitOnAntimeridian=function(e){var t,r,i,n,o,a,s=[];return y.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe(e)?[[-180,e[1],e[2],180,e[4],e[5]]]:y.isBoundingBoxWithLessThanSixElementsLargerThanGlobe(e)?[[-180,e[1],180,e[3]]]:(y.crossesAntimeridian(e)?(a=t=void 0,r=Zc(y.getWest(e)),i=Zc(y.getEast(e)),n=Kc(y.getNorth(e)),o=Kc(y.getSouth(e)),a=6<=e.length?(t=[r,o,e[2],180,n,e[5]],[-180,o,e[2],i,n,e[5]]):(t=[r,o,180,n],[-180,o,i,n]),s.push(t,a)):s.push(e),s)},y.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe=function(e){return 6<=e.length&&360<e[3]-e[0]},y.isBoundingBoxWithLessThanSixElementsLargerThanGlobe=function(e){return e.length<6&&360<e[2]-e[0]},y);function y(e,t){var r,i=this;return e&&t?i=(r=e)[2]&&t[2]?wu.call(this,r[0],r[1],r[2]||0,t[0],t[1],t[2]||0)||this:wu.call(this,r[0],r[1],t[0],t[1])||this:e&&(r=e)&&(4===r.length?i=wu.call(this,r[0],r[1],r[2],r[3])||this:6<=r.length&&(i=wu.call(this,r[0],r[1],r[2],r[3],r[4],r[5])||this)),i}Tu.TYPE="FeatureCollection";var Cu=Tu;function Tu(e,t){this.type="FeatureCollection",this.type=Tu.TYPE,this.features=e,this.bbox=t}Su.TYPE="GeometryCollection";Br=Su;function Su(e){this.type="GeometryCollection",this.type=Su.TYPE,this.geometries=e}Eu.TYPE="LineString";e=Eu;function Eu(e,t){this.type="LineString",this.type=Eu.TYPE,this.coordinates=e,this.bbox=t}Iu.TYPE="MultiLineString";Vt=Iu;function Iu(e,t){this.type="MultiLineString",this.type=Iu.TYPE,this.coordinates=e,this.bbox=t}Au.TYPE="MultiPoint";a=Au;function Au(e,t){this.type="MultiPoint",this.type=Au.TYPE,this.coordinates=e,this.bbox=t}ku.TYPE="MultiPolygon";qi=ku;function ku(e,t){this.type="MultiPolygon",this.type=ku.TYPE,this.coordinates=e,this.bbox=t}var Pu,Mu,un=window&&window.__extends||(Pu=function(e,t){return(Pu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Pu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),cn=(Mu=Array,un(Ru,Mu),Ru.fromPosition=function(e){return 2<=e.length?new Ru((180+e[0])/360,Ru._latToMercatorY(e[1]),3<=e.length?Ru._altitudeToMercatorZ(e[2],e[1]):0):[0,0,0]},Ru.fromPositions=function(e){for(var t=[],r=0,i=e.length;r<i;r++)t.push(this.fromPosition(e[r]));return t},Ru.toFloat32Array=function(e){for(var t=new Float32Array(3*e.length),r=0,i=e.length;r<i;r++){var n=3*r,o=e[r];t[n]=(180+o[0])/360,t[1+n]=Ru._latToMercatorY(o[1]),t[2+n]=3<=o.length?Ru._altitudeToMercatorZ(o[2],o[1]):0}return t},Ru.toPosition=function(e){var t;return 2<=e.length?(t=360/Math.PI*Math.atan(Math.exp((180-360*e[1])*Math.PI/180))-90,new hu(360*e[0]-180,t,3<=e.length?Ru._mercatorZToAltitude(e[2],e[1]):0)):[0,0,0]},Ru.toPositions=function(e){for(var t=[],r=0,i=e.length;r<i;r++)t.push(this.toPosition(e[r]));return t},Ru.mercatorScale=function(e){return 1/Math.cos(e*Math.PI/180)},Ru.meterInMercatorUnits=function(e){return 1/Ru.earthCircumference*Ru.mercatorScale(Ru._latToMercatorY(e))},Ru._circumferenceAtLatitude=function(e){return Ru.earthCircumference*Math.cos(e*Math.PI/180)},Ru._altitudeToMercatorZ=function(e,t){return e/Ru._circumferenceAtLatitude(t)},Ru._mercatorZToAltitude=function(e,t){return e*Ru._circumferenceAtLatitude(Ru._latToMercatorY(t))},Ru._latToMercatorY=function(e){return(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+e*Math.PI/360)))/360},Ru.earthCircumference=2*Math.PI*zc(),Ru);function Ru(e,t,r){return Mu.call(this,e,t,r||0)||this}var no=Object.freeze({__proto__:null,BoundingBox:f,Feature:Ql,FeatureCollection:Cu,GeometryCollection:Br,LineString:e,MercatorPoint:cn,MultiLineString:Vt,MultiPoint:a,MultiPolygon:qi,Point:oc,Polygon:pu,Position:hu});function Ou(e,t){return e*e+t*t}function Lu(e,t){for(var r,i,n,o=e[0],a=[o],s=1,l=e.length;s<l;s++)r=e[s],n=o,Ou((i=r)[0]-n[0],i[1]-n[1])>t&&(a.push(r),o=r);return o!==r&&a.push(r),a}function Du(e,t,r,i,n){for(var o,a,s,l,c,u,h,d=i,p=t+1;p<r;p++){a=e[p],s=e[t],f=e[r],h=u=c=l=void 0,c=s[0],s=s[1],u=f[0]-c,h=f[1]-s,0==u&&0==h||(1<(l=((a[0]-c)*u+(a[1]-s)*h)/Ou(u,h))?(c=f[0],s=f[1]):0<l&&(c+=u*l,s+=h*l));var f=Ou(a[0]-c,a[1]-s);d<f&&(o=p,d=f)}i<d&&(1<o-t&&Du(e,t,o,i,n),n.push(e[o]),1<r-o)&&Du(e,o,r,i,n)}var zu=function(e,t,r){var i,n;return void 0===t&&(t=1),void 0===r&&(r=!1),e.length<=2||(t=t*t,e=r?e:Lu(e,t),i=(r=e).length-1,n=[r[0]],Du(r,0,i,t,n),n.push(r[i]),e=n),e};var Nu=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Bu=(Fu.prototype.toTarget=function(e,t){return this.transformArray(e,this.M,t)},Fu.prototype.toSource=function(e,t){return this.transformArray(e,this.inverseM,t)},Fu.prototype.transformArray=function(e,t,r){var i,n;if(e&&Array.isArray(e)&&Array.isArray(e[0])){var o=[];try{for(var a=Nu(e),s=a.next();!s.done;s=a.next()){var l=s.value;o.push(this.transform(l,t,r))}}catch(e){i={error:e}}finally{try{s&&!s.done&&(n=a.return)&&n.call(a)}finally{if(i)throw i.error}}return o}return null},Fu.prototype.transform=function(e,t,r){var i=e[0]*t[0][3]+e[1]*t[1][3]+t[2][3],e=e[0]*t[0][4]+e[1]*t[1][4]+t[2][4];return"number"==typeof r&&0<=r?[Rc(i,r),Rc(e,r)]:[Rc(i,6),Rc(e,6)]},Fu._calculateAffineTransform=function(e,t){if(e.length!==t.length||e.length<1)throw new Error("Error: source and target arrays must have the same length.");var r=Math.min(e[0].length,t[0].length),i=r+1;if(e.length<r)throw new Error("Erorr: At least "+r+" reference points required.");for(var n=[],o=[],a=0;a<i;a++){o[a]=[];for(var s=0;s<i;s++){s<r&&(n[s]=0);for(var l=o[a][s]=0;l<e.length;l++)s<r&&(n[s]+=a<r?e[l][a]*t[l][s]:t[l][s]),o[a][s]+=r<=a&&r<=s?1:r<=a?e[l][s]:r<=s?e[l][a]:e[l][a]*e[l][s]}o[a]=o[a].concat(n)}if(this._gaussJordanElimination(o))return o;throw new Error("Error: Singular matrix. Points are likely coplanar.")},Fu._gaussJordanElimination=function(e){for(var t,r=e.length,i=2*r-1,n=0;n<r;n++){for(var o=n,a=n+1;a<r;a++)Math.abs(e[a][n])>Math.abs(e[o][n])&&(o=a);if(t=e[o],e[o]=e[n],e[n]=t,Math.abs(e[n][n])<=1e-12)return!1;for(var s=n+1;s<r;s++)for(var l=e[s][n]/e[n][n],c=n;c<i;c++)e[s][c]-=e[n][c]*l}for(n=r-1;-1<n;n--){l=e[n][n];for(a=0;a<n;a++)for(var u=i-1;n-1<u;u--)e[a][u]-=e[n][u]*e[a][n]/l;e[n][n]/=l;for(var h=r;h<i;h++)e[n][h]/=l}return!0},Fu);function Fu(e,t){this.M=Fu._calculateAffineTransform(e,t),this.inverseM=Fu._calculateAffineTransform(t,e)}var Uu,qu,an=Object.freeze({__proto__:null,get AccelerationUnits(){return hc},AffineTransform:Bu,get AreaUnits(){return sc},get DistanceUnits(){return lc},get SpeedUnits(){return uc},get TimeUnits(){return cc},WEBMERCATOR_MAXLAT:vc,_precision:Rc,boundingBoxToPolygon:function(e){var t=Zc(f.getWest(e)),r=Zc(f.getEast(e)),i=Kc(f.getNorth(e)),n=Kc(f.getSouth(e)),e=f.getCenter(e),n=[[t,i],[t,n],[e[0],n],[r,n],[r,i],[e[0],i],[t,i]];return new pu([n])},convertAcceleration:Xc,convertArea:Jc,convertDistance:Oc,convertSpeed:Qc,convertTimespan:eu,getAcceleration:tu,getAccelerationFromFeatures:function(e,t,r,i,n,o,a){if("string"==typeof r&&"Feature"===e.type&&"Point"===e.geometry.type&&"Feature"===t.type&&"Point"===t.geometry.type){r=iu(e.properties[r],t.properties[r],cc.seconds);if(!isNaN(r)){var s=0;if(i&&"string"==typeof i){var l=e.properties[i],i=t.properties[i];if("number"==typeof l&&(s=l,"number"==typeof i))return ru(l,i,r,n,cc.seconds,o,a)}return tu(s,Dc(e.geometry.coordinates,t.geometry.coordinates,lc.meters),r,n,lc.meters,cc.seconds,o,a)}}return NaN},getAccelerationFromSpeeds:ru,getArea:function e(t,r,i){if(t){var n=0;switch((t=t instanceof vu?t.toJson():t).type){case"Feature":var o=t;if(o.geometry)return e(o.geometry,r,i);break;case"Polygon":(o=t).coordinates&&(n=Ac(o.coordinates));break;case"MultiPolygon":var a=t;if(a.coordinates)for(var s=0,l=a.coordinates.length;s<l;s++)n+=Ac(a.coordinates[s])}return Jc(n,sc.squareMeters,r,i)}return 0},getCardinalSpline:function(e,t,r,i){if(!e||e.length<=2)return l;"number"!=typeof t&&(t=.5),("number"!=typeof r||r<=0)&&(r=15);var n,o,a,s=e.length,l=e.slice(0),c=(i?(hu.areEqual(l[0],l[s-1])&&(l.pop(),s--),l.unshift(e[s-1]),l.push(e[0]),l.push(e[1]),s++):(l.unshift(e[0]),l.push(e[s-1])),[]);c.push([1,0,0,0]);for(var u=1;u<r-1;u++)c.push([2*(a=(n=u/r)*(o=n*n))-3*o+1,-2*a+3*o,a-2*o+n,a-o]);c.push([0,1,0,0]);for(var h,d,p,f,m,g,y=[],u=1;u<s;u++)for(h=t*(l[u+1][0]-l[u-1][0]),d=t*(l[u+1][1]-l[u-1][1]),p=t*(l[u+2][0]-l[u][0]),f=t*(l[u+2][1]-l[u][1]),n=0;n<r;n++)g=(m=c[n])[0]*l[u][0]+m[1]*l[u+1][0]+m[2]*h+m[3]*p,m=wc(m[0]*l[u][1]+m[1]*l[u+1][1]+m[2]*d+m[3]*f,-85,85),y.push([g,m]);return y},getClosestPointOnGeometry:lu,getConvexHull:function(e){var t,r,i=ou(e).map(function(e){return[Zc(e[0]),Kc(e[1])]}),n=(i.sort(function(e,t){return e[0]===t[0]?e[1]-t[1]:e[0]-t[0]}),[]);try{for(var o=pc(i),a=o.next();!a.done;a=o.next()){for(var s=a.value;2<=n.length&&Pc(n[n.length-2],n[n.length-1],s)<=0;)n.pop();n.push(s)}}catch(e){t={error:e}}finally{try{a&&!a.done&&(r=o.return)&&r.call(o)}finally{if(t)throw t.error}}for(var l=[],c=i.length-1;0<=c;c--){for(;2<=l.length&&Pc(l[l.length-2],l[l.length-1],i[c])<=0;)l.pop();l.push(i[c])}return new pu([n.concat(l)])},getDestination:Lc,getDistanceTo:Dc,getEarthRadius:zc,getGeodesicPath:function(e,t){(!t||t<=0)&&(t=15),Array.isArray(e)?r=e:e.type&&"LineString"===e.type&&(r=e.coordinates);for(var r,i=r.length-1,n=[],o=0;o<i;o++)n=n.concat(Nc(r[o],r[o+1],t));return Bc(n)},getGeodesicPaths:function(e,t){(!t||t<=0)&&(t=15),Array.isArray(e)?r=e:e.type&&"LineString"===e.type&&(r=e.coordinates);for(var r,i=r.length-1,n=[],o=[],a=0;a<i;a++)for(var s,l,c,u,h,d=Nc(r[a],r[a+1],t),p=0;p<d.length;p++)n.push(d[p]),p+1>=d.length||(s=(l=dc(d[p],2))[0],l=l[1],u=(h=dc(d[p+1],2))[0],h=h[1],180<Math.abs(u-s)&&(c=0<s?180:-180,u=Math.abs((0<s?u+360:u-360)-s),h=l+(h-l)*(Math.abs(c-s)/u),n.push([c,h]),o.push(n),n=[[-c,h]]));return o.push(n),o},getHeading:Uc,getLengthOfPath:qc,getPathDenormalizedAtAntimerian:Bc,getPathSplitByAntimeridian:Fc,getPixelHeading:function(e,t){e=au(e),t=au(t);var t=(e=dc($c([e,t],21),2))[0],r=(e=e[1])[0]-t[0],t=t[1]-e[1];return(2.5*Math.PI-Math.atan2(t,r))*gc%360},getPointWithHeadingAlongPath:su,getPointsWithHeadingsAlongPath:function(e,t){if(t<=0)return[];for(var r=[],i=qc(e,lc.meters)/(t-1),n=0;n<t;n++){var o=su(e,i*n,lc.meters);null!=o&&r.push(o)}return r},getPosition:au,getPositionAlongPath:jc,getPositions:ou,getPositionsAlongPath:function(e,t){if(t<2)return[];for(var r=[],i=qc(e,lc.meters)/(t-1),n=0;n<t;n++){var o=jc(e,i*n,lc.meters);null!=o&&r.push(o)}return r},getRegularPolygonPath:Vc,getRegularPolygonPaths:function(e,t,r,i,n){return Fc(Hc(e,t,r,i,n))},getSpeed:function(e,t,r,i,n,o){return e=au(e),t=au(t),e&&t?(r=eu(r,i,cc.seconds),Qc(Dc(e,t,lc.meters)/r,uc.metersPerSecond,n,o)):0},getSpeedFromFeatures:function(e,t,r,i,n){if("string"==typeof r&&"Feature"===e.type&&"Point"===e.geometry.type&&"Feature"===t.type&&"Point"===t.geometry.type){r=iu(e.properties[r],t.properties[r],cc.seconds);if(!isNaN(r))return Qc(Dc(e.geometry.coordinates,t.geometry.coordinates,lc.meters)/r,uc.metersPerSecond,i,n)}return NaN},getTimespan:iu,getTravelDistance:function(e,t,r,i,n,o,a,s){return t=eu(t,n,cc.seconds),n=(r=Qc(r,o,uc.metersPerSecond))*t,"number"==typeof i&&(n+=.5*Xc(i,a,hc.metersPerSecondSquared)*t*t),Oc(n,lc.meters,e,s)},interpolate:Gc,mercatorPixelsToPositions:Yc,mercatorPositionsToPixels:$c,normalizeLatitude:Kc,normalizeLongitude:Zc,parseTimestamp:nu,rotatePositions:Wc,simplify:function(e,t){return zu(e,t,!0)}}),ju=((window&&window.__extends||(Uu=function(e,t){return(Uu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Uu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Hu,qu=ye),Hu);function Hu(){var e=null!==qu&&qu.apply(this,arguments)||this;return e.zoomDelta=1,e.style=u.ControlStyle.light,e}(window&&window.__extends||(Vu=function(e,t){return(Vu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Vu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Ku,Gu=er),Ku.prototype.onAdd=function(e){this.container=this.buildContainer(e,this.options.style,"Zoom Control"),this.container.style.flexDirection="column",this.zoomInButton=this.constructZoomInButton(e),this.zoomOutButton=this.constructZoomOutButton(e);var t=Ft("Zoom In"),r=Ft("Zoom Out");return this.container.appendChild(this.zoomInButton),this.container.appendChild(t),this.container.appendChild(this.zoomOutButton),this.container.appendChild(r),Ut(t,this.zoomInButton),Ut(r,this.zoomOutButton),e.events.add("zoom",this.zoomChanged),e.events.add("minzoomchanged",this.minZoomChanged),e.events.add("maxzoomchanged",this.maxZoomChanged),this.map=e,this.container},Ku.prototype.onRemove=function(){Gu.prototype.onRemove.call(this),this.map&&(this.map.events.remove("zoom",this.zoomChanged),this.map.events.remove("minzoomchanged",this.minZoomChanged),this.map.events.remove("maxzoomchanged",this.maxZoomChanged),this.map=null),this.container&&(this.container.remove(),this.container=null,this.zoomInButton=null,this.zoomOutButton=null)},Ku.prototype.updateZoomButtonsState=function(){var e=this.map.getCamera().zoom>=this.map._getMap().getMaxZoom(),t=f.getSouth(this.map.getCamera().bounds)<=-vc&&f.getNorth(this.map.getCamera().bounds)>=vc,t=this.map.getCamera().zoom<=this.map._getMap().getMinZoom()||t;this.zoomInButton&&this.zoomInButton.disabled!=e&&(this.zoomInButton.disabled=e,this.zoomInButton.setAttribute("aria-label",e?"Zoom In disabled":"Zoom In")),this.zoomOutButton&&this.zoomOutButton.disabled!=t&&(this.zoomOutButton.disabled=t,this.zoomOutButton.setAttribute("aria-label",e?"Zoom Out disabled":"Zoom Out"))},Ku.prototype.constructZoomInButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("zoom-in"),r.setAttribute("aria-label","Zoom In"),r.setAttribute("alt","Zoom In"),r.setAttribute("type","button"),r.addEventListener("click",function(){e.setCamera({zoom:e.getCamera().zoom+t.options.zoomDelta,duration:Ku.ZOOM_DURATION_MS,type:"ease"},!0)}),r},Ku.prototype.constructZoomOutButton=function(e){var t=this,r=document.createElement("button");return r.classList.add("azure-maps-control-button"),r.classList.add("zoom-out"),r.setAttribute("aria-label","Zoom Out"),r.setAttribute("alt","Zoom Out"),r.setAttribute("type","button"),r.addEventListener("click",function(){e.setCamera({zoom:e.getCamera().zoom-t.options.zoomDelta,duration:Ku.ZOOM_DURATION_MS,type:"ease"},!0)}),r},Ku.ZOOM_DURATION_MS=200;var Vu,Gu,Oo=Ku;function Ku(e){var t=Gu.call(this)||this;return t.container=null,t.zoomInButton=null,t.zoomOutButton=null,t.zoomChanged=function(e){return t.updateZoomButtonsState()},t.minZoomChanged=function(e){return t.updateZoomButtonsState()},t.maxZoomChanged=function(e){return t.updateZoomButtonsState()},t.options=(new ju).merge(e),t}(window&&window.__extends||(Zu=function(e,t){return(Zu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Zu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))($u,Wu=ye);var Zu,Wu,Yu=$u;function $u(){var e=null!==Wu&&Wu.apply(this,arguments)||this;return e.style=u.ControlStyle.light,e.hideIfUnsupported=!1,e.container=void 0,e}(window&&window.__extends||(Xu=function(e,t){return(Xu=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Xu(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Qu,Ju=er),Qu.prototype.onAdd=function(e){var t,r,i=this,n=(this.map=e,null!=(n=null==(n=this.map)?void 0:n._getMap())&&n.addControl(this.control),this.buildContainer(e,this.options.style,"Fullscreen Control")),o=this.control._fullscreenButton;return o&&(t=o.querySelector("span"))&&(r=Ft("Enter Fullscreen"),n.appendChild(o),o.classList.add("azure-maps-control-button","fullscreen"),t.classList.add("fullscreen-icon","fullscreen-end"),o.removeAttribute("title"),n.appendChild(r),Ut(r,o),this.control.on("fullscreenstart",function(){o.removeAttribute("title"),t.classList.remove("fullscreen-end"),t.classList.add("fullscreen-start"),r.innerText="Exit Fullscreen",i.isFullscreenState=!0}),this.control.on("fullscreenend",function(){o.removeAttribute("title"),t.classList.remove("fullscreen-start"),t.classList.add("fullscreen-end"),r.innerText="Enter Fullscreen",i.isFullscreenState=!1})),this.options.hideIfUnsupported&&!Qu.isSupported()&&(n.style.display="none"),n},Qu.prototype.onRemove=function(){var e;Ju.prototype.onRemove.call(this),null!=(e=null==(e=this.map)?void 0:e._getMap())&&e.removeControl(this.control),this.map=null},Qu.prototype.isFullscreen=function(){return this.isFullscreenState},Qu.isSupported=function(){var e=document;return e.fullscreenEnabled||e.msFullscreenEnabled||e.mozFullScreenEnabled||e.webkitFullscreenEnabled};var Xu,Ju,i=Qu;function Qu(e){var t=Ju.call(this)||this;return t.map=null,t.isFullscreenState=!1,t.options=(new Yu).merge(e),t.control=new B.FullscreenControl({container:t.options.container}),t}var Fr=Object.freeze({__proto__:null,CompassControl:lr,ControlBase:er,FullscreenControl:i,PitchControl:t,ScaleControl:we,StyleControl:Ro,TrafficControl:gl,TrafficLegendControl:r,ZoomControl:Oo}),eh=Ka;var th=z(function(e,t){return eh(e,5,t="function"==typeof t?t:void 0)}),rh=(ih.Css={hidden:"hidden-accessible-element"},ih);function ih(e){var t=this;this.attach=function(e){t.map!==e&&(t.map&&t.detachFromCurrentMap(),t.map=e,t.map.indicators._getCollectionDiv().appendChild(t.element),t.map.indicators.add(t))},this.remove=function(){t.detachFromCurrentMap(),t.element.remove()},this.getElement=function(){return t.element},this.detachFromCurrentMap=function(){t.map&&(t.map.indicators.remove(t),delete t.map)},this.element=document.createElement("div"),this.element.setAttribute("tabindex","0"),this.element.setAttribute("role","option"),null!=e&&e.setSize&&this.element.setAttribute("aria-setsize",e.setSize.toString()),null!=e&&e.positionInSet&&this.element.setAttribute("aria-posinset",e.positionInSet.toString()),this.element.setAttribute("aria-label","data point"),this.element.classList.add(ih.Css.hidden)}(window&&window.__extends||(nh=function(e,t){return(nh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}nh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(sh,oh=ye);var nh,oh,ah=sh;function sh(){var e=null!==oh&&oh.apply(this,arguments)||this;return e.buffer=128,e.maxZoom=18,e.cluster=!1,e.clusterRadius=50,e.clusterMaxZoom=void 0,e.clusterProperties=void 0,e.lineMetrics=!1,e.tolerance=.375,e.clusterMinPoints=2,e.generateId=!1,e.promoteId=void 0,e.filter=void 0,e}(window&&window.__extends||(lh=function(e,t){return(lh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}lh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(hh,ch=$t),hh.prototype.getId=function(){return this.id},hh.prototype._setMap=function(e,t){var r;void 0===t&&(t=!0),null==e||void 0===e?(r=this.map,delete this.map,t&&(this._invokeEvent("sourceremoved",this),r)&&r.events.invoke("sourceremoved",this)):(this.map=e,t&&(this._invokeEvent("sourceadded",this),this.map.events.invoke("sourceadded",this)))};var lh,ch,uh=hh;function hh(e){var t=ch.call(this)||this;return t.id=e||Z(),t}var dh,ph,s=window&&window.__extends||(dh=function(e,t){return(dh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}dh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),fh=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},mh=(s(gh,ph=uh),gh.prototype.add=function(e,t){this._addNoUpdate(e,t),this._updateSource()},gh.prototype.clear=function(){this._clearNoUpdate(),this._updateSource()},gh.prototype.dispose=function(){this.options=null,this.shapes=null,this.shapesMap=null,this.map=null},gh.prototype.getClusterExpansionZoom=function(i){var n=this;return new Promise(function(t,r){var e;n.map?(e=n.map._getMap().getSource(n.getId()))&&"geojson"===e.type&&e.getClusterExpansionZoom(i).then(function(e){"number"==typeof e&&t(e)}).catch(function(e){e&&r(e)}):r("The DataSource hasn't been added to a map.")})},gh.prototype.getClusterChildren=function(i){var n=this;return new Promise(function(t,r){var e;n.map?(e=n.map._getMap().getSource(n.getId()))&&"geojson"===e.type&&e.getClusterChildren(i).then(function(e){e&&t(n.map.sources._mapFeaturesToShapes(e,!1,n))}).catch(function(e){e&&r(e)}):r("The DataSource hasn't been added to a map.")})},gh.prototype.getClusterLeaves=function(i,n,o){var a=this;return new Promise(function(t,r){var e;a.map?(e=a.map._getMap().getSource(a.getId()))&&"geojson"===e.type&&e.getClusterLeaves(i,n,o).then(function(e){e&&t(a.map.sources._mapFeaturesToShapes(e,!1,a))}).catch(function(e){e&&r(e)}):r("The DataSource hasn't been added to a map.")})},gh.prototype.getOptions=function(){return Wa(this.options)},gh.prototype.getShapes=function(){return Array.from(this.shapes)},gh.prototype.importDataFromUrl=function(e){var t=this;return fetch(e,{method:"GET",mode:"cors"}).then(function(e){if(e.ok)return e.json();throw new Error("HTTP ".concat(e.status,": ").concat(e.statusText))}).then(function(e){t.add(e)})},gh.prototype.getShapeById=function(e){return this.shapes[this.shapesMap.get(e)]||null},gh.prototype.remove=function(e){var t,r,e=Array.isArray(e)?e:[e];try{for(var i=fh(e),n=i.next();!n.done;n=i.next()){var o=n.value;"number"==typeof o?this._removeByIndex(o):this._removeById(o)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}this._updateSource()},gh.prototype.removeById=function(e){var t,r,e=Array.isArray(e)?e:[e];try{for(var i=fh(e),n=i.next();!n.done;n=i.next()){var o=n.value;this._removeById(o)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}this._updateSource()},gh.prototype.setOptions=function(e){e=(new ah).merge(this.options,Wa(e));Jl(this.options,e)||(this._invokeEvent("datasourceupdated",this),this.options=e,this.map&&this.map._rebuildStyle())},gh.prototype.setShapes=function(e){this._clearNoUpdate(),this.add(e)},gh.prototype.toJson=function(){return new Cu(this.shapes.map(function(e){return e.toJson()}))},gh.prototype._toJson=function(){return new Cu(this.shapes.map(function(e){return e._toJson()}))},gh.prototype._buildSource=function(){var e={type:"geojson",data:this._toJson(),maxzoom:this.options.maxZoom,cluster:this.options.cluster,clusterRadius:this.options.clusterRadius,tolerance:this.options.tolerance,lineMetrics:this.options.lineMetrics,clusterProperties:this.options.clusterProperties,buffer:this.options.buffer,clusterMinPoints:this.options.clusterMinPoints,generateId:this.options.generateId,promoteId:this.options.promoteId,filter:this.options.filter};return"number"==typeof this.options.clusterMaxZoom&&(e.clusterMaxZoom=this.options.clusterMaxZoom),e},gh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this._buildSource(),e=e._buildSource(),t.type===e.type)&&t.maxzoom===e.maxzoom&&t.cluster===e.cluster&&t.clusterRadius===e.clusterRadius&&t.tolerance===e.tolerance&&t.lineMetrics===e.lineMetrics&&JSON.stringify(t.clusterProperties)===JSON.stringify(e.clusterProperties)&&t.buffer===e.buffer&&t.clusterMinPoints===e.clusterMinPoints&&t.generateId===e.generateId&&t.promoteId===e.promoteId&&t.filter===e.filter},gh.prototype._addNoUpdate=function(e,t){var r;e instanceof vu?(this._addToSources(e,t),r=[e]):Array.isArray(e)?(r=e.map(function(e){return e instanceof vu?e:new vu(e)}),this._addToSources(r,t)):"FeatureCollection"===e.type?(r=e.features.map(function(e){return new vu(e)}),this._addToSources(r,t)):"GeometryCollection"===e.type?(r=e.geometries.map(function(e){return new vu(e)}),this._addToSources(r,t)):(e=new vu(e),this._addToSources(e,t),r=[e]),this._invokeEvent("dataadded",r)},gh.prototype._clearNoUpdate=function(){var e=this.shapes;this.shapes=[],this.shapesMap=new Yt,e&&0<e.length&&this._invokeEvent("dataremoved",e)},gh.prototype._updateSource=function(){var e=this;void 0===this.requestId&&(this.requestId=requestAnimationFrame(function(){e._updateMboxSource(),e.requestId=void 0}))},gh.prototype._addToSources=function(e,t){var r,i,n,o;if(e=Array.isArray(e)?e:[e],"number"!=typeof t)try{for(var a=fh(e),s=a.next();!s.done;s=a.next()){var l=s.value;this.shapes.push(l),this.shapesMap.set(l.getId(),this.shapes.length-1)}}catch(e){r={error:e}}finally{try{s&&!s.done&&(i=a.return)&&i.call(a)}finally{if(r)throw r.error}}else for(var c=e.length-1;0<=c;c--)this.shapes.splice(t,0,e[c]),this._updateShapesMap(t);try{for(var u=fh(e),h=u.next();!h.done;h=u.next())(l=h.value)._setDataSource(this)}catch(e){n={error:e}}finally{try{h&&!h.done&&(o=u.return)&&o.call(u)}finally{if(n)throw n.error}}},gh.prototype._removeById=function(e){var e=e instanceof vu?e.getId():"string"==typeof e||"number"==typeof e?e:e.id,t=this.shapes[this.shapesMap.get(e)];t&&(t._setDataSource(null),this.shapes.splice(this.shapesMap.get(e),1),this._updateShapesMap(this.shapesMap.get(e)),this.shapesMap.delete(e),this._invokeEvent("dataremoved",[t]))},gh.prototype._removeByIndex=function(e){var t;if(e>=this.shapes.length)throw new Error("The specified remove index '".concat(e,"' ")+"is greater than the maximum possible index '".concat(this.shapes.length-1,"'"));t=this.shapes[e],this.shapesMap.delete(t.getId()),t._setDataSource(null),this.shapes.splice(e,1),this._updateShapesMap(e),this._invokeEvent("dataremoved",[t])},gh.prototype._updateShapesMap=function(e){for(var t=e;t<this.shapes.length;t++)this.shapesMap.set(this.shapes[t].getId(),t)},gh.prototype._updateMboxSource=function(){var e;this.map&&this.map._getMap()&&(e=this.map._getMap().getSource(this.getId()))&&"geojson"===e.type&&e.setData(this._toJson())},gh);function gh(e,t){e=ph.call(this,e)||this;return e.requestId=void 0,e.options=(new ah).merge(Wa(t)),e.shapes=[],e.shapesMap=new Yt,e}(window&&window.__extends||(yh=function(e,t){return(yh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}yh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(bh,vh=ye);var yh,vh,_h=bh;function bh(){var e=null!==vh&&vh.apply(this,arguments)||this;return e.bounds=void 0,e.minZoom=0,e.maxZoom=22,e.isTMS=!1,e.tiles=void 0,e.url=void 0,e}(window&&window.__extends||(wh=function(e,t){return(wh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}wh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Th,xh=uh),Th.prototype.getOptions=function(){return Wa(this.options)},Th.prototype.getShape=function(e,t){return this.map._getMap().querySourceFeatures(this.getId(),{sourceLayer:e,filter:t})},Th.prototype._buildSource=function(){var e={type:"vector"};return this.options.bounds&&(e.bounds=this.options.bounds),this.options.tiles?(e.tiles=this.options.tiles,e.minzoom=this.options.minZoom,e.maxzoom=this.options.maxZoom):this.options.url&&(e.url=this.options.url),this.options.isTMS&&(e.scheme="tms"),e},Th.prototype._isDeepEqual=function(e){var t,r;return this.constructor===e.constructor&&(t=this._buildSource(),r=e._buildSource(),t.type===r.type)&&t.url===r.url&&(void 0===t.tiles&&void 0===r.tiles||t.tiles&&r.tiles&&t.tiles.length===r.tiles.length&&t.tiles.every(function(e,t){return e===r.tiles[t]}))&&t.minzoom===r.minzoom&&t.maxzoom===r.maxzoom&&t.bounds===r.bounds&&t.attribution===r.attribution&&t.promoteId===r.promoteId&&t.scheme===r.scheme};var wh,xh,Ch=Th;function Th(e,t){e=xh.call(this,e)||this;return e.options=(new _h).merge(Wa(t)),e}(window&&window.__extends||(Sh=function(e,t){return(Sh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Sh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Ah,Eh=uh),Ah.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)&&t.canvas===e.canvas&&JSON.stringify(t.coordinates)===JSON.stringify(e.coordinates)&&t.animate===e.animate},Ah.prototype._buildSource=function(){return this.source};var Sh,Eh,Ih=Ah;function Ah(e,t,r){e=Eh.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(kh=function(e,t){return(kh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}kh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Rh,Ph=uh),Rh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)},Rh.prototype._buildSource=function(){return this.source};var kh,Ph,Mh=Rh;function Rh(e,t,r){e=Ph.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(Oh=function(e,t){return(Oh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Oh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(zh,Lh=uh),zh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)&&JSON.stringify(t.coordinates)===JSON.stringify(e.coordinates)&&t.url===e.url},zh.prototype._buildSource=function(){return this.source};var Oh,Lh,Dh=zh;function zh(e,t,r){e=Lh.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(Nh=function(e,t){return(Nh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Nh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Uh,Bh=uh),Uh.prototype._isDeepEqual=function(e){var t;return this.constructor===e.constructor&&(t=this.source,e=e.source,t.type===e.type)&&JSON.stringify(t.coordinates)===JSON.stringify(e.coordinates)&&t.urls===e.urls},Uh.prototype._buildSource=function(){return this.source};var Nh,Bh,Fh=Uh;function Uh(e,t,r){e=Bh.call(this,e)||this;return e.source=t,e}(window&&window.__extends||(qh=function(e,t){return(qh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}qh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Hh,jh=_h);var qh,jh,n=Hh;function Hh(){var e=null!==jh&&jh.apply(this,arguments)||this;return e.tileSize=512,e}(window&&window.__extends||(Vh=function(e,t){return(Vh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Vh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Zh,Gh=n);var Vh,Gh,Kh=Zh;function Zh(){var e=null!==Gh&&Gh.apply(this,arguments)||this;return e.encoding=void 0,e}var Wh,Yh,ai=window&&window.__extends||(Wh=function(e,t){return(Wh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Wh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),$h=window&&window.__assign||function(){return($h=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},o=(ai(Xh,Yh=uh),Xh.prototype.getOptions=function(){return Wa(this.options)},Xh.prototype._buildSource=function(){return $h({type:"raster-dem",bounds:this.options.bounds,minzoom:this.options.minZoom,maxzoom:this.options.maxZoom,tileSize:this.options.tileSize,encoding:this.options.encoding},this.options.tiles?{tiles:this.options.tiles}:{url:this.options.url})},Xh.prototype._isDeepEqual=function(e){return this.constructor===e.constructor&&(e=e.getOptions(),this.options.url===e.url)&&this.options.tiles===e.tiles&&this.options.bounds===e.bounds&&this.options.minZoom===e.minZoom&&this.options.maxZoom===e.maxZoom&&this.options.tileSize===e.tileSize&&this.options.encoding===e.encoding},Xh);function Xh(e,t){e=Yh.call(this,e)||this;return e.options=(new Kh).merge(Wa(t)),e}var Jh,Qh,un=Object.freeze({__proto__:null,CanvasSource:Ih,DataSource:mh,ElevationTileSource:o,ImageSource:Dh,Source:uh,UnknownSource:Mh,VectorTileSource:Ch,VideoSource:Fh}),ed=((window&&window.__extends||(Jh=function(e,t){return(Jh=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Jh(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(td,Qh=$t),td.prototype.getId=function(){return this.id},td.prototype.getMap=function(){return this.map||null},td.prototype.onAdd=function(e){this.map=e,this._invokeEvent("layeradded",this),this.map.events.invoke("layeradded",this)},td.prototype.onRemove=function(){var e=this.map;delete this.map,this._invokeEvent("layerremoved",this),e&&e.events.invoke("layerremoved",this)},td._isMBoxEvent=function(e){return!this.LayerEvents.hasOwnProperty(e)},td.prototype._updateBaseProperties=function(e,t){this._updateFilter(e.filter,t.filter),this._updateZoomRange(e.minZoom,t.minZoom,e.maxZoom,t.maxZoom),this._updateLayoutProperty("visibility",e.visible,t.visible,e.visible?"visible":"none")},td.prototype._updateFilter=function(e,t){Jl(e,t)||this.map._getMap().setFilter(this.id,e)},td.prototype._updatePaintProperty=function(e,t,r,i){Jl(t,r)||this.map._getMap().setPaintProperty(this.id,e,i||t)},td.prototype._updateLayoutProperty=function(e,t,r,i){Jl(t,r)||this.map._getMap().setLayoutProperty(this.id,e,i||t)},td.prototype._updateZoomRange=function(e,t,r,i){e===t&&i===r||this.map._getMap().setLayerZoomRange(this.id,e,r)},td.LayerEvents={layeradded:void 0,layerremoved:void 0,focusin:void 0,focusout:void 0},td);function td(e){var t=Qh.call(this)||this;return t.id=e||Z(),t}(window&&window.__extends||(rd=function(e,t){return(rd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}rd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(nd,id=ye),nd._cloneCustomizer=function(e){if(e instanceof uh)return e};var rd,id,Br=nd;function nd(){var e=null!==id&&id.apply(this,arguments)||this;return e.filter=void 0,e.minZoom=0,e.maxZoom=24,e.visible=!0,e}(window&&window.__extends||(od=function(e,t){return(od=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}od(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(ld,ad=Br);var od,ad,sd=ld;function ld(){var e=null!==ad&&ad.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.color="#1A73AA",e.blur=0,e.opacity=1,e.strokeColor="#FFFFFF",e.strokeOpacity=1,e.strokeWidth=2,e.pitchAlignment="viewport",e.radius=8,e.createIndicators=!1,e.accessibilityIdKey=void 0,e}var cd,ud,e=window&&window.__extends||(cd=function(e,t){return(cd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}cd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),hd=window&&window.__awaiter||function(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})},dd=window&&window.__generator||function(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},c={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c;function e(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l=c&&t[c=0]?0:l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},pd=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},fd=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},md=(e(gd,ud=ed),gd.prototype.getOptions=function(){return th(this.options,sd._cloneCustomizer)},gd.prototype.getSource=function(){return this.options.source},gd.prototype.setOptions=function(e){e=(new sd).merge(this.options,th(e,sd._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("circle-blur",e.blur,this.options.blur),this._updatePaintProperty("circle-color",e.color,this.options.color),this._updatePaintProperty("circle-opacity",e.opacity,this.options.opacity),this._updatePaintProperty("circle-radius",e.radius,this.options.radius),this._updatePaintProperty("circle-stroke-color",e.strokeColor,this.options.strokeColor),this._updatePaintProperty("circle-stroke-opacity",e.strokeOpacity,this.options.strokeOpacity),this._updatePaintProperty("circle-stroke-width",e.strokeWidth,this.options.strokeWidth),this._updatePaintProperty("circle-pitch-alignment",e.pitchAlignment,this.options.pitchAlignment)}this.options=e},gd.prototype.onAdd=function(t){var e,r,i=this;ud.prototype.onAdd.call(this,t),this.options.createIndicators&&(t.events.addOnce("idle",this._setAccessibleIndicator),t.events.add("moveend",this._setAccessibleIndicator),(e=this._getDataSource())?t.events.add("dataadded",e,function(){t.events.addOnce("idle",i._setAccessibleIndicator)}):(r="string"==typeof this.options.source?this.options.source:this.options.source.getId(),t.events.add("sourcedata",function(e){(null==(e=e.source)?void 0:e.getId())===r&&t._getMap().isSourceLoaded(r)&&(e=i._getSourceDataEventCacheKey())!==i.sourceDataEventCacheKey&&(i._setAccessibleIndicator(),i.sourceDataEventCacheKey=e)})))},gd.prototype.onRemove=function(){var e;this.options.createIndicators&&(this.map.events.remove("idle",this._setAccessibleIndicator),this.map.events.remove("moveend",this._setAccessibleIndicator),(e=this._getDataSource())?this.map.events.remove("dataadded",e,this._setAccessibleIndicator):this.map.events.remove("sourcedata",this._setAccessibleIndicator)),ud.prototype.onRemove.call(this)},gd.prototype._getSourceDataEventCacheKey=function(){var e;if(this.map)return e=this.map.getServiceOptions().mapConfiguration,fd(fd([],pd(this.map.getCamera().bounds),!1),[this.map.getCamera().zoom,this.map.getCamera().pitch,this.map.getStyle().style,e instanceof Object?e.id:e],!1).join(",")},gd.prototype._getDataSource=function(){var e="string"==typeof this.options.source?this.map.sources.getById(this.options.source):this.options.source;if(e instanceof mh)return e},gd.prototype._buildLayers=function(){var e={id:this.id,type:"circle",source:this.options.source instanceof uh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:{"circle-color":this.options.color,"circle-blur":this.options.blur,"circle-opacity":this.options.opacity,"circle-stroke-color":this.options.strokeColor,"circle-stroke-opacity":this.options.strokeOpacity,"circle-stroke-width":this.options.strokeWidth,"circle-pitch-alignment":this.options.pitchAlignment,"circle-radius":this.options.radius},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),this.options.sourceLayer&&(e["source-layer"]=this.options.sourceLayer),[e]},gd.prototype._getLayerIds=function(){return[this.id]},gd.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof uh?e.add(this.options.source.getId()):e.add(this.options.source),e},gd.prototype.getFirstCoordinate=function(e){return Array.isArray(e[0])?this.getFirstCoordinate(e[0]):e},gd);function gd(e,t,r){var i=ud.call(this,t)||this;return i.accessibleIndicator=[],i._setAccessibleIndicator=function(){return hd(i,void 0,void 0,function(){var t,l,c,u,h,d,p=this;return dd(this,function(e){return this.accessibleIndicator.forEach(function(e){return e.remove()}),this.accessibleIndicator=[],t=this.map.layers.getRenderedShapes(this.map.getCamera().bounds,this),l=this.options.accessibilityIdKey||(this._getDataSource()?vu._shapeIdPropName:void 0),c=function(t,r){var i=t[r],n=i instanceof vu?i.toJson():i,o=new rh({positionInSet:r+1,setSize:t.length}),a=o.getElement(),s=pd(p.map.positionsToPixels([p.getFirstCoordinate(n.geometry.coordinates)]),1)[0];return a.addEventListener("focusin",function(e){p.accessibleIndicator.filter(function(e){return e!==o}).forEach(function(e){return e.remove()}),0<=r-1&&u(o,c(t,r-1)),r+1<t.length&&d(c(t,r+1)),2<=r&&r==t.length-1&&h(c(t,0)),0==r&&2<=t.length&&d(c(t,t.length-1)),void 0!==l&&p.map._getMap().setPaintProperty(p.id,"circle-stroke-color",["case",["==",["get",l],n.properties[l]],"#000000",p.options.strokeColor]);e={target:a,type:"focusin",map:p.map,shape:i,originalEvent:e,pixel:s};p._invokeEvent("focusin",e)}),a.addEventListener("focusout",function(e){void 0!==l&&p.map._getMap().setPaintProperty(p.id,"circle-stroke-color",["case",["==",["get",l],n.properties[l]],p.options.strokeColor,p.options.strokeColor]);e={target:a,type:"focusout",map:p.map,shape:i,originalEvent:e,pixel:s};p._invokeEvent("focusout",e)}),p.accessibleIndicator.push(o),o},u=function(e,t){t.attach(p.map);t=t.getElement(),e=e.getElement();e.parentElement.insertBefore(t,e)},h=function(e){e.attach(p.map);var e=e.getElement(),t=e.parentElement;t.insertBefore(e,t.firstElementChild)},d=function(e){e.attach(p.map)},0<t.length&&d(c(t,0)),1<t.length&&d(c(t,t.length-1)),[2]})})},i.options=(new sd).merge(th(r,sd._cloneCustomizer)),i.options.source=e||i.options.source,i}(window&&window.__extends||(yd=function(e,t){return(yd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}yd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(bd,vd=Br),bd._cloneCustomizer=function(e){if(e instanceof uh)return e};var yd,vd,_d=bd;function bd(){var e=null!==vd&&vd.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.color=["interpolate",["linear"],["heatmap-density"],0,"rgba(0,0, 255,0)",.1,"royalblue",.3,"cyan",.5,"lime",.7,"yellow",1,"red"],e.intensity=1,e.opacity=1,e.radius=30,e.weight=1,e}(window&&window.__extends||(wd=function(e,t){return(wd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}wd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Cd,xd=ed),Cd.prototype.getOptions=function(){return th(this.options,_d._cloneCustomizer)},Cd.prototype.getSource=function(){return this.options.source},Cd.prototype.setOptions=function(e){e=(new _d).merge(this.options,th(e,_d._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("heatmap-color",e.color,this.options.color),this._updatePaintProperty("heatmap-intensity",e.intensity,this.options.intensity),this._updatePaintProperty("heatmap-opacity",e.opacity,this.options.opacity),this._updatePaintProperty("heatmap-radius",e.radius,this.options.radius),this._updatePaintProperty("heatmap-weight",e.weight,this.options.weight)}this.options=e},Cd.prototype._buildLayers=function(){var e={id:this.id,type:"heatmap",source:this.options.source instanceof uh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:{"heatmap-color":this.options.color,"heatmap-intensity":this.options.intensity,"heatmap-opacity":this.options.opacity,"heatmap-radius":this.options.radius,"heatmap-weight":this.options.weight},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),this.options.sourceLayer&&(e["source-layer"]=this.options.sourceLayer),[e]},Cd.prototype._getLayerIds=function(){return[this.id]},Cd.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof uh?e.add(this.options.source.getId()):e.add(this.options.source),e};var wd,xd,cn=Cd;function Cd(e,t,r){t=xd.call(this,t)||this;return t.options=(new _d).merge(th(r,_d._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(Td=function(e,t){return(Td=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Td(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Ed,Sd=Br);var Td,Sd,Vt=Ed;function Ed(){var e=null!==Sd&&Sd.apply(this,arguments)||this;return e.contrast=0,e.fadeDuration=300,e.hueRotation=0,e.maxBrightness=1,e.minBrightness=0,e.opacity=1,e.saturation=0,e}(window&&window.__extends||(Id=function(e,t){return(Id=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Id(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Pd,Ad=Vt),Pd._cloneCustomizer=function(e){if(e instanceof uh)return e};var Id,Ad,kd=Pd;function Pd(){var e=null!==Ad&&Ad.apply(this,arguments)||this;return e.url=void 0,e.coordinates=void 0,e}(window&&window.__extends||(Md=function(e,t){return(Md=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Md(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Ld,Rd=ed),Ld.prototype._getSourceIds=function(){var e=new Set;return e.add(this._getSourceId()),e},Ld.prototype.onAdd=function(e){Rd.prototype.onAdd.call(this,e)};var Md,Rd,Od=Ld;function Ld(){return null!==Rd&&Rd.apply(this,arguments)||this}(window&&window.__extends||(Dd=function(e,t){return(Dd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Dd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Nd,zd=Od),Nd.prototype.getOptions=function(){return th(this.options,kd._cloneCustomizer)},Nd.prototype.setOptions=function(e){var t,r=(new kd).merge(this.options,th(e,kd._cloneCustomizer)),i="string"==typeof e.url&&e.url!==this.getOptions().url,e=void 0!==e.coordinates&&e.coordinates!==this.getOptions().coordinates;this.map&&(this._updateBaseProperties(r,this.options),this._updatePaintProperty("raster-contrast",r.contrast,this.options.contrast),this._updatePaintProperty("raster-fade-duration",r.fadeDuration,this.options.fadeDuration),this._updatePaintProperty("raster-hue-rotate",r.hueRotation,this.options.hueRotation),this._updatePaintProperty("raster-brightness-max",r.maxBrightness,this.options.maxBrightness),this._updatePaintProperty("raster-opacity",r.opacity,this.options.opacity),this._updatePaintProperty("raster-saturation",r.saturation,this.options.saturation),t=this.map._getMap().getSource(this._getSourceId()))&&(i||e)&&t.updateImage(r),this.options=r,i?this.reloadImage():e&&this.updateTransform()},Nd.prototype.getPositions=function(t){return this.transform.then(function(e){return e.toTarget(t)})},Nd.prototype.getPixels=function(t){return this.transform.then(function(e){return e.toSource(t)})},Nd.getCoordinatesFromRefPoints=function(e,t,r,i){return new Bu(r,i).toTarget([[0,0],[e,0],[e,t],[0,t]])},Nd.getCoordinatesFromEdges=function(e,t,r,i,n){"number"!=typeof n&&(n=0);t=[Math.min(i,r),t,Math.max(i,r),e],i=f.getCenter(t);return Wc([f.getNorthWest(t),f.getNorthEast(t),f.getSouthEast(t),f.getSouthWest(t)],i,n)},Nd.prototype._buildLayers=function(){var e={id:this.id,type:"raster",source:this._getSourceId(),layout:{visibility:this.options.visible?"visible":"none"},paint:{"raster-opacity":this.options.opacity,"raster-hue-rotate":this.options.hueRotation,"raster-brightness-min":this.options.minBrightness,"raster-brightness-max":this.options.maxBrightness,"raster-saturation":this.options.saturation,"raster-contrast":this.options.contrast,"raster-fade-duration":this.options.fadeDuration},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),[e]},Nd.prototype._getLayerIds=function(){return[this.id]},Nd.prototype._buildSource=function(){return{type:"image",url:this.options.url,coordinates:this.options.coordinates}},Nd.prototype._getSourceId=function(){return"".concat(this.getId(),"-ImageSource")},Nd.prototype.reloadImage=function(){var r=this;this.options.url&&(this.transform=new Promise(function(t,e){r.img.onload=function(){var e=[[0,0],[r.img.width,0],[r.img.width,r.img.height],[0,r.img.height]];t(new Bu(e,r.options.coordinates)),r.isLoading=!1},r.img.onerror=r.img.onabort=function(){e("Failed to load image")},r.isLoading=!0,r.img.src=r.options.url}))},Nd.prototype.updateTransform=function(){var e;this.isLoading||(e=[[0,0],[this.img.width,0],[this.img.width,this.img.height],[0,this.img.height]],this.transform=Promise.resolve(new Bu(e,this.options.coordinates)))},Nd.prototype._getSourceWrapper=function(){var e=this._getSourceId(),t=this._buildSource();return new Dh(e,t)};var Dd,zd,a=Nd;function Nd(e,t){t=zd.call(this,t)||this;return t.isLoading=!1,t.options=(new kd).merge(th(e,kd._cloneCustomizer)),t.img=new Image,t.reloadImage(),t}(window&&window.__extends||(Bd=function(e,t){return(Bd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Bd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(qd,Fd=Br);var Bd,Fd,Ud=qd;function qd(){var e=null!==Fd&&Fd.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.lineCap="round",e.lineJoin="round",e.blur=0,e.strokeColor="#1E90FF",e.strokeDashArray=void 0,e.strokeGradient=void 0,e.offset=0,e.strokeOpacity=1,e.translate=new ic(0,0),e.translateAnchor="map",e.strokeWidth=2,e}var jd,Hd,qi=window&&window.__extends||(jd=function(e,t){return(jd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}jd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Vd=window&&window.__assign||function(){return(Vd=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Gd=(qi(Kd,Hd=ed),Kd.prototype.getOptions=function(){return th(this.options,Ud._cloneCustomizer)},Kd.prototype.getSource=function(){return this.options.source},Kd.prototype.setOptions=function(e){e=(new Ud).merge(this.options,th(e,Ud._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("line-blur",e.blur,this.options.blur),this._updateLayoutProperty("line-cap",e.lineCap,this.options.lineCap),this._updateLayoutProperty("line-join",e.lineJoin,this.options.lineJoin),this._updatePaintProperty("line-offset",e.offset,this.options.offset),this._updatePaintProperty("line-color",e.strokeColor,this.options.strokeColor),this._updatePaintProperty("line-dasharray",e.strokeDashArray,this.options.strokeDashArray),this._updatePaintProperty("line-gradient",e.strokeGradient,this.options.strokeGradient),this._updatePaintProperty("line-opacity",e.strokeOpacity,this.options.strokeOpacity),this._updatePaintProperty("line-width",e.strokeWidth,this.options.strokeWidth),this._updatePaintProperty("line-translate",e.translate,this.options.translate),this._updatePaintProperty("line-translate-anchor",e.translateAnchor,this.options.translateAnchor)}this.options=e},Kd.prototype._buildLayers=function(){return[Vd(Vd(Vd(Vd({id:this.id,type:"line"},this.options.sourceLayer&&{"source-layer":this.options.sourceLayer}),{source:this.options.source instanceof uh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none","line-cap":this.options.lineCap,"line-join":this.options.lineJoin},paint:Vd(Vd(Vd({"line-blur":this.options.blur,"line-color":this.options.strokeColor},this.options.strokeDashArray?{"line-dasharray":this.options.strokeDashArray}:{}),this.options.strokeGradient?{"line-gradient":this.options.strokeGradient}:{}),{"line-offset":this.options.offset,"line-opacity":this.options.strokeOpacity,"line-translate":this.options.translate,"line-translate-anchor":this.options.translateAnchor,"line-width":this.options.strokeWidth})}),this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom})]},Kd.prototype._getLayerIds=function(){return[this.id]},Kd.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof uh?e.add(this.options.source.getId()):e.add(this.options.source),e},Kd);function Kd(e,t,r){t=Hd.call(this,t)||this;return t.options=(new Ud).merge(th(r,Ud._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(Zd=function(e,t){return(Zd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Zd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))($d,Wd=Br);var Zd,Wd,Yd=$d;function $d(){var e=null!==Wd&&Wd.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.base=0,e.fillColor="#1E90FF",e.height=0,e.fillOpacity=1,e.fillPattern=void 0,e.translate=new ic(0,0),e.translateAnchor="map",e.verticalGradient=!0,e}var Xd,Jd,i=window&&window.__extends||(Xd=function(e,t){return(Xd=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Xd(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Qd=window&&window.__assign||function(){return(Qd=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},t=(i(ep,Jd=ed),ep.prototype.getOptions=function(){return th(this.options,Yd._cloneCustomizer)},ep.prototype.getSource=function(){return this.options.source},ep.prototype.setOptions=function(e){e=(new Yd).merge(this.options,th(e,Yd._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("fill-extrusion-base",e.base,this.options.base),this._updatePaintProperty("fill-extrusion-color",e.fillColor,this.options.fillColor),this._updatePaintProperty("fill-extrusion-height",e.height,this.options.height),this._updatePaintProperty("fill-extrusion-opacity",e.fillOpacity,this.options.fillOpacity),this._updatePaintProperty("fill-extrusion-pattern",e.fillPattern,this.options.fillPattern),this._updatePaintProperty("fill-extrusion-translate",e.translate,this.options.translate),this._updatePaintProperty("fill-extrusion-translate-anchor",e.translateAnchor,this.options.translateAnchor),this._updatePaintProperty("fill-extrusion-vertical-gradient",e.verticalGradient,this.options.verticalGradient)}this.options=e},ep.prototype._buildLayers=function(){return[Qd(Qd(Qd(Qd({id:this.id,type:"fill-extrusion"},this.options.sourceLayer&&{"source-layer":this.options.sourceLayer}),{source:this.options.source instanceof uh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:Qd(Qd({"fill-extrusion-base":this.options.base,"fill-extrusion-height":this.options.height,"fill-extrusion-opacity":this.options.fillOpacity},this.options.fillPattern?{"fill-extrusion-pattern":this.options.fillPattern}:{"fill-extrusion-color":this.options.fillColor}),{"fill-extrusion-translate":this.options.translate,"fill-extrusion-translate-anchor":this.options.translateAnchor,"fill-extrusion-vertical-gradient":this.options.verticalGradient})}),this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom})]},ep.prototype._getLayerIds=function(){return[this.id]},ep.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof uh?e.add(this.options.source.getId()):e.add(this.options.source),e},ep);function ep(e,t,r){t=Jd.call(this,t)||this;return t.options=(new Yd).merge(th(r,Yd._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(tp=function(e,t){return(tp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}tp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(np,rp=Br);var tp,rp,ip=np;function np(){var e=null!==rp&&rp.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.fillColor="#1E90FF",e.fillOpacity=.5,e.fillPattern=void 0,e.fillAntialias=!0,e}(window&&window.__extends||(op=function(e,t){return(op=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}op(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(lp,ap=ed),lp.prototype.getOptions=function(){return th(this.options,ip._cloneCustomizer)},lp.prototype.getSource=function(){return this.options.source},lp.prototype.setOptions=function(e){e=(new ip).merge(this.options,th(e,ip._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("fill-color",e.fillColor,this.options.fillColor),this._updatePaintProperty("fill-opacity",e.fillOpacity,this.options.fillOpacity),this._updatePaintProperty("fill-pattern",e.fillPattern,this.options.fillPattern),this._updatePaintProperty("fill-antialias",e.fillAntialias,this.options.fillAntialias)}this.options=e},lp.prototype._buildLayers=function(){var e={id:this.id,type:"fill",source:this.options.source instanceof uh?this.options.source.getId():this.options.source,layout:{visibility:this.options.visible?"visible":"none"},paint:{"fill-opacity":this.options.fillOpacity,"fill-antialias":this.options.fillAntialias},minzoom:this.options.minZoom,maxzoom:this.options.maxZoom};return this.options.filter&&(e.filter=this.options.filter),this.options.sourceLayer&&(e["source-layer"]=this.options.sourceLayer),this.options.fillPattern?e.paint["fill-pattern"]=this.options.fillPattern:e.paint["fill-color"]=this.options.fillColor,[e]},lp.prototype._getLayerIds=function(){return[this.id]},lp.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof uh?e.add(this.options.source.getId()):e.add(this.options.source),e};var op,ap,sp=lp;function lp(e,t,r){t=ap.call(this,t)||this;return t.options=(new ip).merge(th(r,ip._cloneCustomizer)),t.options.source=e||t.options.source,t}(window&&window.__extends||(cp=function(e,t){return(cp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}cp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(dp,up=ye);var cp,up,hp=dp;function dp(){var e=null!==up&&up.apply(this,arguments)||this;return e.allowOverlap=!1,e.anchor="bottom",e.ignorePlacement=!1,e.image="marker-blue",e.offset=new ic(0,0),e.optional=!1,e.padding=2,e.pitchAlignment="auto",e.rotation=0,e.rotationAlignment="auto",e.size=1,e.opacity=1,e}(window&&window.__extends||(pp=function(e,t){return(pp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}pp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(gp,fp=ye);var pp,fp,mp=gp;function gp(){var e=null!==fp&&fp.apply(this,arguments)||this;return e.allowOverlap=!1,e.anchor="center",e.textField=void 0,e.font=["StandardFont-Regular"],e.ignorePlacement=!1,e.justify="center",e.offset=new ic(0,0),e.optional=!1,e.padding=2,e.pitchAlignment="auto",e.radialOffset=void 0,e.rotation=0,e.rotationAlignment="auto",e.variableAnchor=void 0,e.size=16,e.color="#000000",e.haloBlur=0,e.haloColor="rgba(0,0,0,0)",e.haloWidth=0,e.opacity=1,e}(window&&window.__extends||(yp=function(e,t){return(yp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}yp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(bp,vp=Br);var yp,vp,_p=bp;function bp(){var e=null!==vp&&vp.apply(this,arguments)||this;return e.source=void 0,e.sourceLayer=void 0,e.iconOptions=new hp,e.textOptions=new mp,e.placement="point",e.sortKey=void 0,e.zOrder="auto",e.lineSpacing=250,e}var wp,xp,we=window&&window.__extends||(wp=function(e,t){return(wp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}wp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Cp=window&&window.__assign||function(){return(Cp=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Tp=(we(Sp,xp=ed),Sp.prototype.getOptions=function(){return th(this.options,_p._cloneCustomizer)},Sp.prototype.getSource=function(){return this.options.source},Sp.prototype.setOptions=function(e){e=(new _p).merge(this.options,th(e,_p._cloneCustomizer));if(this.map){if(e.source!==this.options.source||e.sourceLayer!==this.options.sourceLayer)return this.options=e,void this.map.layers.add(this);var t=this.options,r=e.iconOptions,i=t.iconOptions,n=e.textOptions,o=t.textOptions;this._updateBaseProperties(e,t),this._updateLayoutProperty("symbol-spacing",e.lineSpacing,t.lineSpacing),this._updateLayoutProperty("symbol-placement",e.placement,t.placement),this._updateLayoutProperty("symbol-sort-key",e.sortKey,t.sortKey),this._updateLayoutProperty("symbol-z-order",e.zOrder,t.zOrder),this._updateLayoutProperty("icon-allow-overlap",r.allowOverlap,i.allowOverlap),this._updateLayoutProperty("icon-anchor",r.anchor,i.anchor),this._updateLayoutProperty("icon-ignore-placement",r.ignorePlacement,i.ignorePlacement),this._updateLayoutProperty("icon-image",r.image,i.image),this._updateLayoutProperty("icon-offset",r.offset,i.offset),this._updatePaintProperty("icon-opacity",r.opacity,i.opacity),this._updateLayoutProperty("icon-optional",r.optional,i.optional),this._updateLayoutProperty("icon-padding",r.padding,i.padding),this._updateLayoutProperty("icon-pitch-alignment",r.pitchAlignment,i.pitchAlignment),this._updateLayoutProperty("icon-rotate",r.rotation,i.rotation),this._updateLayoutProperty("icon-rotation-alignment",r.rotationAlignment,i.rotationAlignment),this._updateLayoutProperty("icon-size",r.size,i.size),this._updateLayoutProperty("text-allow-overlap",n.allowOverlap,o.allowOverlap),this._updateLayoutProperty("text-anchor",n.anchor,o.anchor),this._updatePaintProperty("text-color",n.color,o.color),this._updateLayoutProperty("text-font",n.font,o.font),this._updateLayoutProperty("text-ignore-placement",n.ignorePlacement,o.ignorePlacement),this._updateLayoutProperty("text-justify",n.justify,o.justify),this._updatePaintProperty("text-halo-blur",n.haloBlur,o.haloBlur),this._updatePaintProperty("text-halo-color",n.haloColor,o.haloColor),this._updatePaintProperty("text-halo-width",n.haloWidth,o.haloWidth),this._updateLayoutProperty("text-offset",n.offset,o.offset),this._updatePaintProperty("text-opacity",n.opacity,o.opacity),this._updateLayoutProperty("text-optional",n.optional,o.optional),this._updateLayoutProperty("text-padding",n.padding,o.padding),this._updateLayoutProperty("text-pitch-alignment",n.pitchAlignment,o.pitchAlignment),this._updateLayoutProperty("text-radial-offset",n.radialOffset,o.radialOffset),this._updateLayoutProperty("text-rotate",n.rotation,o.rotation),this._updateLayoutProperty("text-rotation-alignment",n.rotationAlignment,o.rotationAlignment),this._updateLayoutProperty("text-size",n.size,o.size),this._updateLayoutProperty("text-variable-anchor",n.variableAnchor,o.variableAnchor),this._updateLayoutProperty("text-field",n.textField,o.textField)}this.options=e},Sp.prototype._buildLayers=function(){var e=Cp(Cp(Cp(Cp({id:this.id,type:"symbol"},this.options.sourceLayer&&{"source-layer":this.options.sourceLayer}),{source:this.options.source instanceof uh?this.options.source.getId():this.options.source,layout:Cp(Cp({visibility:this.options.visible?"visible":"none","symbol-placement":this.options.placement,"symbol-spacing":this.options.lineSpacing,"symbol-z-order":this.options.zOrder,"text-allow-overlap":this.options.textOptions.allowOverlap,"text-anchor":this.options.textOptions.anchor},this.options.textOptions.textField&&{"text-field":this.options.textOptions.textField}),{"text-font":this.options.textOptions.font,"text-ignore-placement":this.options.textOptions.ignorePlacement,"text-justify":this.options.textOptions.justify,"text-offset":this.options.textOptions.offset,"text-optional":this.options.textOptions.optional,"text-padding":this.options.textOptions.padding,"text-pitch-alignment":this.options.textOptions.pitchAlignment,"text-rotate":this.options.textOptions.rotation,"text-rotation-alignment":this.options.textOptions.rotationAlignment,"text-size":this.options.textOptions.size,"icon-allow-overlap":this.options.iconOptions.allowOverlap,"icon-anchor":this.options.iconOptions.anchor,"icon-ignore-placement":this.options.iconOptions.ignorePlacement,"icon-image":this.options.iconOptions.image,"icon-offset":this.options.iconOptions.offset,"icon-optional":this.options.iconOptions.optional,"icon-padding":this.options.iconOptions.padding,"icon-pitch-alignment":this.options.iconOptions.pitchAlignment,"icon-rotate":this.options.iconOptions.rotation,"icon-rotation-alignment":this.options.iconOptions.rotationAlignment,"icon-size":this.options.iconOptions.size}),paint:{"text-color":this.options.textOptions.color,"text-halo-blur":this.options.textOptions.haloBlur,"text-halo-color":this.options.textOptions.haloColor,"text-halo-width":this.options.textOptions.haloWidth,"text-opacity":this.options.textOptions.opacity,"icon-opacity":this.options.iconOptions.opacity}}),this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom});return void 0!==this.options.sortKey&&(e.layout["symbol-sort-key"]=this.options.sortKey),void 0!==this.options.textOptions.radialOffset&&(e.layout["text-radial-offset"]=this.options.textOptions.radialOffset),void 0!==this.options.textOptions.variableAnchor&&(e.layout["text-variable-anchor"]=this.options.textOptions.variableAnchor),[e]},Sp.prototype._getLayerIds=function(){return[this.id]},Sp.prototype._getSourceIds=function(){var e=new Set;return this.options.source instanceof uh?e.add(this.options.source.getId()):e.add(this.options.source),e},Sp);function Sp(e,t,r){t=xp.call(this,t)||this;return t.options=(new _p).merge(th(r,_p._cloneCustomizer)),t.options.source=e||t.options.source,t}var Ep,Ip,Ro=window&&window.__extends||(Ep=function(e,t){return(Ep=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Ep(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Ap=window&&window.__assign||function(){return(Ap=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},kp=(Ro(Pp,Ip=uh),Pp.prototype._buildSource=function(){return this.source},Pp.prototype._isDeepEqual=function(e){var r,t,i,n;return this.constructor===e.constructor&&(n=this.source,r=e.source,e=n.type===r.type&&n.url===r.url&&(void 0===n.tiles&&void 0===r.tiles||n.tiles&&r.tiles&&n.tiles.length===r.tiles.length&&n.tiles.every(function(e,t){return e===r.tiles[t]}))&&n.minzoom===r.minzoom&&n.maxzoom===r.maxzoom&&n.bounds===r.bounds&&n.attribution===r.attribution,t="raster"!==n.type||"raster"===n.type&&n.type===r.type&&n.tileSize===r.tileSize&&n.scheme===r.scheme,i="raster-dem"!==n.type||"raster-dem"===n.type&&n.type===r.type&&n.tileSize===r.tileSize&&n.encoding===r.encoding,n="vector"!==n.type||"vector"===n.type&&n.type===r.type&&n.promoteId===r.promoteId&&n.scheme===r.scheme,e)&&t&&i&&n},Pp.prototype._modifySource=function(e,t){if("raster"!==e.type&&"raster-dem"!==e.type&&"vector"!==e.type||!e.tiles){if("raster"!==e.type&&"raster-dem"!==e.type&&"vector"!==e.type||!e.url)throw new Error("Source definition must define a TileJSON 'url' or a 'tiles' array.");e.url="string"==typeof e.url?e.url:new Se({domain:te,path:e.url.path,queryParams:Ap(Ap({},t),e.url.queryParams)}).toString()}else{var r=e.tiles.map(function(e){return"string"==typeof e?e:new Se({domain:te,path:e.path,queryParams:Ap(Ap({},t),e.queryParams)}).toString()});e.tiles=r}return e},Pp);function Pp(e,t,r){e=Ip.call(this,e)||this;return e.source=e._modifySource(t,r),e}(window&&window.__extends||(Mp=function(e,t){return(Mp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Mp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Lp,Rp=Vt);var Mp,Rp,Op=Lp;function Lp(){var e=null!==Rp&&Rp.apply(this,arguments)||this;return e.bounds=[-180,-85.0511,180,85.0511],e.minSourceZoom=0,e.maxSourceZoom=22,e.tileSize=512,e.isTMS=!1,e.subdomains=void 0,e.tileUrl=void 0,e}var Dp,zp,r=window&&window.__extends||(Dp=function(e,t){return(Dp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Dp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Np=window&&window.__assign||function(){return(Np=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Bp=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Fp=(r(Up,zp=Od),Up.prototype.getOptions=function(){return th(this.options,Op._cloneCustomizer)},Up.prototype.setOptions=function(e){e=(new Op).merge(this.options,th(e,Op._cloneCustomizer));if(this.map){if(!Jl(e.bounds,this.options.bounds)||e.isTMS!==this.options.isTMS||e.maxSourceZoom!==this.options.maxSourceZoom||e.minSourceZoom!==this.options.minSourceZoom||!Jl(e.subdomains,this.options.subdomains)||e.tileSize!==this.options.tileSize||e.tileUrl!==this.options.tileUrl)return this.options=e,void this.map.layers.add(this);this._updateBaseProperties(e,this.options),this._updatePaintProperty("raster-contrast",e.contrast,this.options.contrast),this._updatePaintProperty("raster-fade-duration",e.fadeDuration,this.options.fadeDuration),this._updatePaintProperty("raster-hue-rotate",e.hueRotation,this.options.hueRotation),this._updatePaintProperty("raster-brightness-max",e.maxBrightness,this.options.maxBrightness),this._updatePaintProperty("raster-opacity",e.opacity,this.options.opacity),this._updatePaintProperty("raster-saturation",e.saturation,this.options.saturation)}this.options=e},Up.prototype._setOptionsNoUpdate=function(e){this.options=(new Op).merge(this.options,th(e,Op._cloneCustomizer))},Up.prototype._buildLayers=function(){return[Np(Np({id:this.id,type:"raster",source:this._getSourceId(),layout:{visibility:this.options.visible?"visible":"none"},paint:{"raster-contrast":this.options.contrast,"raster-fade-duration":this.options.fadeDuration,"raster-hue-rotate":this.options.hueRotation,"raster-brightness-max":this.options.maxBrightness,"raster-brightness-min":this.options.minBrightness,"raster-opacity":this.options.opacity,"raster-saturation":this.options.saturation}},this.options.filter&&{filter:this.options.filter}),{minzoom:this.options.minZoom,maxzoom:this.options.maxZoom})]},Up.prototype._getLayerIds=function(){return[this.id]},Up.prototype._buildSource=function(){var t,e;if(this.options.tileUrl){if(-1===this.options.tileUrl.indexOf("{"))return{type:"raster",url:this.options.tileUrl};if(-1!==this.options.tileUrl.indexOf("{subdomain}")){if(!(this.options.subdomains&&0<this.options.subdomains.length))throw new Error("The {subdomain} placeholder was included in the tileUrl but no subdomains were specified");var r=[];try{for(var i=Bp(this.options.subdomains),n=i.next();!n.done;n=i.next()){var o=n.value;r.push(this.options.tileUrl.replace(/{subdomain}/g,o))}}catch(e){t={error:e}}finally{try{n&&!n.done&&(e=i.return)&&e.call(i)}finally{if(t)throw t.error}}e=r}else e=[this.options.tileUrl]}return Np({type:"raster",bounds:this.options.bounds,maxzoom:this.options.maxSourceZoom,minzoom:this.options.minSourceZoom,scheme:this.options.isTMS?"tms":"xyz",tileSize:this.options.tileSize},e&&{tiles:e})},Up.prototype._getSourceId=function(){return"".concat(this.getId(),"-RasterSource")},Up.prototype._getSourceWrapper=function(){var e=this._getSourceId(),t=this._buildSource();return new kp(e,{name:e,tiles:t.tiles,type:t.type,url:t.url})},Up);function Up(e,t){t=zp.call(this,t)||this;return e&&t.setOptions(e),t}(window&&window.__extends||(qp=function(e,t){return(qp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}qp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Vp,jp=Br);var qp,jp,Hp=Vp;function Vp(){var e=null!==jp&&jp.apply(this,arguments)||this;return e.renderer=void 0,e}(window&&window.__extends||(Gp=function(e,t){return(Gp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Gp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Wp,Kp=ed),Wp.prototype.getOptions=function(){return th(this.options,Hp._cloneCustomizer)},Wp.prototype.setOptions=function(e){e=(new Hp).merge(this.options,th(e,Hp._cloneCustomizer));this.map&&this.map.triggerRepaint(),this.options=e},Wp.prototype.onAdd=function(e){var t,r;Kp.prototype.onAdd.call(this,e),this.map.events.add("stylechanged",this._onStyleChange),this.options.renderer&&this.glContext&&null!=(r=(t=this.options.renderer).onAdd)&&r.call(t,e,this.glContext)},Wp.prototype.onRemove=function(){var e,t;this.options.renderer&&this.glContext&&null!=(t=(e=this.options.renderer).onRemove)&&t.call(e,this.map,this.glContext),this.map.events.remove("stylechanged",this._onStyleChange),this.glContext=null,Kp.prototype.onRemove.call(this)},Wp.prototype._buildLayers=function(){var n=this;if(this.options.renderer)return[{id:this.id,type:"custom",renderingMode:this.options.renderer.renderingMode,onAdd:function(e,t){n.glContext=t},onRemove:function(e,t){},prerender:function(e,t){var r,i;n._shouldRender()&&null!=(i=(r=n.options.renderer).prerender)&&i.call(r,e,t)},render:function(e,t){n._shouldRender()&&n.options.renderer.render(e,t)}}];throw new Error("Cannot build the WebGL layer because renderer was not set.")},Wp.prototype._getLayerIds=function(){return[this.id]},Wp.prototype._getSourceIds=function(){return(new Set).add(this.source.getId())},Wp.prototype._shouldRender=function(){var e;return!!this.map&&(e=this.map.getCamera().zoom,this.options.visible)&&this.options.minZoom<=e&&this.options.maxZoom>e};var Gp,Kp,Zp=Wp;function Wp(e,t){var r=Kp.call(this,e)||this;return r._onStyleChange=function(){var e,t;r.map._getMap().getLayer(r.id)||(e=r.map,t=null==(t=r.map.layers._getUserLayers().find(function(e){return e.layer.getId()==r.id}))?void 0:t.before,e.layers.remove(r),e.layers.add(r,t))},r.options=(new Hp).merge(th(t,Hp._cloneCustomizer)),r.source=new mh,r}var Oo=Object.freeze({__proto__:null,BubbleLayer:md,HeatMapLayer:cn,ImageLayer:a,Layer:ed,LineLayer:Gd,PolygonExtrusionLayer:t,PolygonLayer:sp,SymbolLayer:Tp,TileLayer:Fp,WebGLLayer:Zp}),Yp=($p.convertHtmlString=function(e){var t;return"string"==typeof e?((t=document.createElement("div")).innerHTML=e,t):e},$p.parseWithFilter=function(e,t,r,i){var n=this;if(void 0===t&&(t=function(e){return!0}),void 0===r&&(r=function(e){return e}),void 0===i&&(i=function(){return document.createElement("div")}),"string"==typeof e){var o=(new DOMParser).parseFromString(e,"text/html").body;if(0==o.children.length)return r(o.innerHTML);var a,o=1==o.children.length&&1==o.childNodes.length?o.children[0]:(a=i(),Array.from(o.childNodes).map(function(e){return a.append(e)}),a)}else o=e;return Array.from(o.children).forEach(function(e){return n.parseWithFilter(e,t,r)}),t(o)?r(o):(o.parentNode&&o.parentNode.removeChild(o),null)},$p);function $p(){}var Xp=tn,Jp=ss;var Qp,ef,tf=z(function(e){return Xp(e)&&1===e.nodeType&&!Jp(e)}),rf=((window&&window.__extends||(Qp=function(e,t){return(Qp=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Qp(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(nf,ef=ye),nf._cloneCustomizer=function(e){if(tf(e))return e},nf);function nf(){var e=null!==ef&&ef.apply(this,arguments)||this;return e.anchor="none",e.draggable=!1,e.closeButton=!0,e.content=document.createElement("span"),e.fillColor="#FFFFFF",e.pixelOffset=new ic(0,0),e.position=new hu(0,0),e.showPointer=!0,e}var of,af,s=window&&window.__extends||(of=function(e,t){return(of=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}of(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),sf=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},lf=(s(cf,af=$t),cf.prototype.setPopupOptions=function(e){this.setOptions(e)},cf.prototype.setOptions=function(e){var t,e=(new rf).merge(this.options,th(e,rf._cloneCustomizer));e.content!==this.options.content?(this.htmlContent.remove(),this.htmlContent=this._createHtmlContent(e),this.contentDiv.prepend(this.htmlContent)):e.draggable!==this.options.draggable&&this._setDraggable(this.htmlContent,e.draggable),e.closeButton&&!this.closeBtn?(this.closeBtn=this._createCloseButton(),this.contentDiv.appendChild(this.closeBtn),t=Ft("close"),this.contentDiv.appendChild(t),Ut(t,this.closeBtn,!0)):!e.closeButton&&this.closeBtn&&(this.contentDiv.removeChild(this.closeBtn),delete this.closeBtn),e.showPointer&&!this.arrowDiv?(this.arrowDiv=this._createArrowDiv(),this.containerDiv.appendChild(this.arrowDiv)):!e.showPointer&&this.arrowDiv&&(this.containerDiv.removeChild(this.arrowDiv),delete this.arrowDiv),e.fillColor!==this.options.fillColor&&(this.containerDiv.style.borderColor=e.fillColor,this.contentDiv.style.backgroundColor=e.fillColor),this.marker&&(e.anchor!==this.options.anchor?"none"===this.options.anchor?(this.autoAnchor!==e.anchor&&this._replaceMarker(this.map,e),this.map.events.remove("move",this._onMove),delete this.autoAnchor):(this._replaceMarker(this.map,e),"none"===e.anchor&&this.map.events.add("move",this._onMove)):(Jl(e.position,this.options.position)||this.marker.setLngLat(e.position),Jl(e.pixelOffset,this.options.pixelOffset)||this.marker.setOffset(e.pixelOffset))),this.options=e},cf.prototype.getPopupOptions=function(){return this.getOptions()},cf.prototype.getOptions=function(){return th(this.options,rf._cloneCustomizer)},cf.prototype.getPopupContainer=function(){return this.containerDiv},cf.prototype._dragToPixel=function(e){this.dragging||(this.dragging=!0,this.contentDiv.style.pointerEvents="none",this._invokeEvent("dragstart",{type:"dragstart",target:this}));e=[e[0]+this.dragOffset[0],e[1]+this.dragOffset[1]],e=sf(this.map.pixelsToPositions([e]),1)[0];this.options.position=e,this.marker.setLngLat(this.options.position),this._invokeEvent("drag",{type:"drag",target:this})},cf.prototype._onUp=function(){this.dragging&&(this.contentDiv.style.pointerEvents="",this._invokeEvent("dragend",{type:"dragend",target:this}),"none"===this.options.anchor)&&this._onMove(),delete this.dragOffset,delete this.dragging},cf.prototype._createContainerDiv=function(e){var t=this,r=document.createElement("div"),i=(r.classList.add(cf.Css.container),r.classList.add(cf.Css.hidden),r.style.borderColor=e.fillColor,r.setAttribute("role","dialog"),r.setAttribute("aria-label","Map Information Window"),!1);return r.addEventListener("keydown",function(e){"Tab"!==e.key&&"Escape"!==e.key&&"Esc"!==e.key||(i=!0)}),r.addEventListener("keyup",function(e){"Tab"!==e.key&&"Escape"!==e.key&&"Esc"!==e.key||(i=!1)}),r.addEventListener("focusin",function(e){t.map&&!t.isOpen()&&(t.open(t.map),e.target instanceof HTMLElement)&&e.target.focus()}),r.addEventListener("focusout",function(e){i&&e.relatedTarget instanceof Node&&!r.contains(e.relatedTarget)&&(i=!1,t.isOpen())&&t.close()}),r},cf.prototype._createContentDiv=function(e){var t=document.createElement("div");return t.classList.add(cf.Css.content),t.style.backgroundColor=e.fillColor,t.setAttribute("tabindex","0"),this.htmlContent=this._createHtmlContent(e),t.appendChild(this.htmlContent),t},cf.prototype._createArrowDiv=function(){var e=document.createElement("div");return e.classList.add(cf.Css.arrow),e},cf.prototype._createCloseButton=function(){var e=document.createElement("button");return e.addEventListener("click",this.close),e.classList.add(cf.Css.close),e.setAttribute("aria-label","close"),e.setAttribute("type","button"),e.setAttribute("tabindex","0"),e.innerHTML="&times;",e},cf.prototype._createHtmlContent=function(e){var t=Yp.convertHtmlString(e.content);return e.draggable&&this._setDraggable(t,e.draggable),t},cf.prototype._createMarker=function(e,t){var r=this.marker?this.marker.getLngLat():e.position,t=("none"===e.anchor?(this.autoAnchor=t||"bottom",this.containerDiv.classList.add(this.autoAnchor),new B.Marker({anchor:this.autoAnchor,element:this.containerDiv,offset:e.pixelOffset})):(this.containerDiv.classList.add(e.anchor),new B.Marker({anchor:e.anchor,element:this.containerDiv,offset:e.pixelOffset}))).setLngLat(r);return t},cf.prototype._getAutoAnchor=function(e,t){var r,i,n=this.containerDiv.offsetWidth,o=this.containerDiv.offsetHeight,a=[];return(i=this.marker?(r=(i=e._getMap().project(this.marker.getLngLat())).x,i.y):(i=sf(e.positionsToPixels([t.position]),1),r=(t=sf(i[0],2))[0],t[1]))<o?a.push("top"):i>e.getCanvas().offsetHeight-o&&a.push("bottom"),r<n/2?a.push("left"):r>e.getCanvas().offsetWidth-n/2&&a.push("right"),0<a.length?a.join("-"):"bottom"},cf.prototype._replaceMarker=function(e,t,r){var i=this.containerDiv.nextElementSibling;this.marker.remove(),this.containerDiv.classList.remove(this.autoAnchor||this.options.anchor),this.marker=this._createMarker(t,r),this.marker.addTo(e._getMap()),e.popups._getCollectionDiv().insertBefore(this.containerDiv,i||null)},cf.prototype._setDraggable=function(e,t){t?(e.addEventListener("mousedown",this._onDown),e.addEventListener("touchstart",this._onDown),e.addEventListener("dragstart",this._onDragStart)):(e.removeEventListener("mousedown",this._onDown),e.removeEventListener("touchstart",this._onDown),e.removeEventListener("dragstart",this._onDragStart))},cf.Css={arrow:"popup-arrow",close:"popup-close",container:"popup-container",content:"popup-content-container",hidden:"hidden-accessible-element"},cf);function cf(e){var r=af.call(this)||this;return r.attach=function(e){r.map!==e&&(r.map&&r.remove(),r.map=e,r.marker=r._createMarker(r.options),r.marker.addTo(r.map._getMap()),r.map.popups._getCollectionDiv().appendChild(r.containerDiv),r.map.popups.add(r))},r.open=function(e){if(!e&&!r.map)throw new Error("Must specify a map to open on or attach to a map in advance");r.attach(e||r.map),r.containerDiv.classList.remove(cf.Css.hidden),r.map.events.add("move",r._onMove),r._onMove(),r._invokeEvent("open",{target:r,type:"open"})},r.close=function(){r.map&&r.map.events.remove("move",r._onMove),r.containerDiv.classList.add(cf.Css.hidden),r._invokeEvent("close",{target:r,type:"close"})},r.remove=function(){r.map&&(r.marker.remove(),r.containerDiv.classList.remove(r.autoAnchor||r.options.anchor),r.map.events.remove("move",r._onMove),r.map.popups.remove(r),delete r.map,delete r.marker,delete r.autoAnchor)},r.isOpen=function(){return r.map&&!r.containerDiv.classList.contains(cf.Css.hidden)},r._onMove=function(){var e=r._getAutoAnchor(r.map,r.options);e!==r.autoAnchor&&(r._replaceMarker(r.map,r.options,e),r.map.events.add("move",r._onMove))},r._onDown=function(e){r.map.popups._addDraggedPopup(r);var t=sf(r.map.positionsToPixels([r.options.position]),1)[0];"mousedown"===e.type?r.dragOffset=[t[0]-e.clientX,t[1]-e.clientY]:"touchstart"===e.type&&(r.dragOffset=[t[0]-e.touches[0].clientX,t[1]-e.touches[0].clientY])},r._onDragStart=function(e){e.preventDefault()},r.options=(new rf).merge(th(e,rf._cloneCustomizer)),r.containerDiv=r._createContainerDiv(r.options),r.contentDiv=r._createContentDiv(r.options),r.containerDiv.appendChild(r.contentDiv),r.options.showPointer&&(r.arrowDiv=r._createArrowDiv(),r.containerDiv.appendChild(r.arrowDiv)),r.options.closeButton&&(r.closeBtn=r._createCloseButton(),r.contentDiv.appendChild(r.closeBtn),e=Ft("close"),r.contentDiv.appendChild(e),Ut(e,r.closeBtn,!0)),r}(window&&window.__extends||(uf=function(e,t){return(uf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}uf(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(pf,hf=ye),pf._cloneCustomizer=function(e){if(e instanceof lf||tf(e))return e};var uf,hf,df=pf;function pf(){var e=null!==hf&&hf.apply(this,arguments)||this;return e.anchor="bottom",e.color="#1A73AA",e.draggable=!1,e.htmlContent='<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24.5 36.5" id="marker_'.concat(Z(),'" width="24.5" height="36.5" display="block"><path d="M12.25.25a12.2543,12.2543,0,0,0-12,12.4937c0,6.4436,6.4879,12.1093,11.059,22.5641.5493,1.2563,1.3327,1.2563,1.882,0C17.7621,24.8529,24.25,19.1857,24.25,12.7437A12.2543,12.2543,0,0,0,12.25.25Z"   fill="{color}" stroke="{secondaryColor}" stroke-width="0.5"/><text style="font-family: Arial, Helvetica, sans-serif; font-size: 14px; fill: white;" text-anchor="middle" x="12" y="18">{text}</text></svg>'),e.pixelOffset=new ic(0,0),e.position=new hu(0,0),e.popup=void 0,e.secondaryColor="white",e.text=void 0,e.visible=!0,e}(window&&window.__extends||(ff=function(e,t){return(ff=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}ff(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(yf,mf=$t),yf.prototype.getOptions=function(){return th(this.options,df._cloneCustomizer)},yf.prototype.getElement=function(){return this.marker.getElement()},yf.prototype.setOptions=function(e){e=(new df).merge(this.options,th(e,df._cloneCustomizer));Jl(e.htmlContent,this.options.htmlContent)&&e.anchor===this.options.anchor?("string"!=typeof e.htmlContent||e.color===this.options.color&&e.text===this.options.text&&e.secondaryColor===this.options.secondaryColor||(this.element.innerHTML=this._getSubbedHtmlString(e)||""),e.draggable!==this.options.draggable&&(this._setDraggable(e.draggable),this.marker.setDraggable(e.draggable)),Jl(e.pixelOffset,this.options.pixelOffset)||this.marker.setOffset(e.pixelOffset),Jl(e.position,this.options.position)||this.marker.setLngLat(e.position),e.visible!==this.options.visible&&(e.visible?this.element.classList.remove(yf.hiddenClass):this.element.classList.add(yf.hiddenClass))):(this.marker.remove(),this._buildMarker(e),this.map&&(this.marker.addTo(this.map._getMap()),this._getCollectionContainer().appendChild(this.element))),this.options=e},yf.prototype.togglePopup=function(){if(this.options.popup)if(this.options.popup.isOpen())this.options.popup.close();else{if(!this.map)throw new Error("The marker must be added to a map before calling togglePopup().");this.options.popup.setOptions({position:this.options.position}),this.options.popup.open(this.map)}},yf.prototype._addToMap=function(e,t){this.map&&this.map!==e&&this._removeFromMap(),t&&(this.options.position=Wa(t),this.marker.setLngLat(this.options.position)),this.map!==e&&(this.map=e,this.marker.addTo(e._getMap()),this._getCollectionContainer().appendChild(this.element))},yf.prototype._removeFromMap=function(){this.map&&(this.marker.remove(),delete this.map)},yf.prototype._getId=function(){if(this.element)return("string"==typeof this.options.htmlContent?this.element.firstChild:this.element).id},yf.prototype._buildMarker=function(e){var t;"string"==typeof e.htmlContent?(t=this._getSubbedHtmlString(e)||"",this.element=Yp.convertHtmlString(t)):this.element=e.htmlContent,this.element.classList.add(yf.containerClass),e.draggable&&this._setDraggable(!0),e.visible||this.element.classList.add(yf.hiddenClass),this.marker=new B.Marker({element:this.element,offset:e.pixelOffset,draggable:e.draggable,anchor:e.anchor}).setLngLat(e.position),this.marker.on("drag",this._onDrag),this.marker.on("dragstart",this._onDragStart),this.marker.on("dragend",this._onDragEnd),this.element.addEventListener("click",this._bubbleElementEvent),this.element.addEventListener("dblclick",this._bubbleElementEvent),this.element.addEventListener("contextmenu",this._bubbleElementEvent),this.element.addEventListener("keydown",this._bubbleElementEvent),this.element.addEventListener("keypress",this._bubbleElementEvent),this.element.addEventListener("keyup",this._bubbleElementEvent),this.element.addEventListener("mousedown",this._bubbleElementEvent),this.element.addEventListener("mouseenter",this._bubbleElementEvent),this.element.addEventListener("mouseleave",this._bubbleElementEvent),this.element.addEventListener("mousemove",this._bubbleElementEvent),this.element.addEventListener("mouseout",this._bubbleElementEvent),this.element.addEventListener("mouseover",this._bubbleElementEvent),this.element.addEventListener("mouseup",this._bubbleElementEvent)},yf.prototype._getSubbedHtmlString=function(e){return"string"==typeof e.htmlContent?e.htmlContent.replace(/{color}/gi,e.color||"").replace(/{secondaryColor}/gi,e.secondaryColor||"").replace(/{text}/gi,e.text||""):null},yf.prototype._getCollectionContainer=function(){var e=this.map.getCanvasContainer().querySelector(".".concat(yf.collectionContainerClass));return e||((e=document.createElement("div")).classList.add(yf.collectionContainerClass),this.map.getCanvasContainer().appendChild(e)),e},yf.prototype._setDraggable=function(e){e?this.element.addEventListener("dragstart",this._onEleDragStart):this.element.removeEventListener("dragstart",this._onEleDragStart)},yf.collectionContainerClass="marker-collection-container",yf.hiddenClass="hidden-accessible-element",yf.containerClass="marker-container";var ff,mf,gf=yf;function yf(e){var t=mf.call(this)||this;return t._onDrag=function(){var e=t.marker.getLngLat().wrap();t.options.position=new hu(e.lng,e.lat),t._invokeEvent("drag",{type:"drag",target:t})},t._onDragStart=function(){t._invokeEvent("dragstart",{type:"dragstart",target:t})},t._onDragEnd=function(){t._invokeEvent("dragend",{type:"dragend",target:t})},t._bubbleElementEvent=function(e){t._invokeEvent(e.type,{type:e.type,target:t})},t._onEleDragStart=function(e){e.preventDefault()},t.options=(new df).merge(th(e,df._cloneCustomizer)),t._buildMarker(t.options),t}_f.getHighContrastMode=function(){return matchMedia("(-ms-high-contrast: white-on-black)").matches?"dark":matchMedia("(-ms-high-contrast: black-on-white)").matches?"light":matchMedia("(-ms-high-contrast: active)").matches?"dark":matchMedia("(inverted-colors: inverted)").matches?"invert":null};var vf=_f;function _f(){}(window&&window.__extends||(bf=function(e,t){return(bf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}bf(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Cf,wf=ye);var bf,wf,xf=Cf;function Cf(){var e=null!==wf&&wf.apply(this,arguments)||this;return e.copyrightMessage=void 0,e.copyrightContent=void 0,e.customAttribution=void 0,e.showFeedbackLink=!0,e.showLogo=!0,e}(window&&window.__extends||(Tf=function(e,t){return(Tf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Tf(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(If,Sf=er),If.prototype.onAdd=function(e){return this.map=e,this.container=this.buildContainer(e,u.ControlStyle.auto),this.container.className="map-copyright without-bg",this.copyrightDiv=this.buildCopyrightDiv(),this.copyrightDiv.className="azure-map-copyright",this.container.appendChild(this.copyrightDiv),this.options.showFeedbackLink&&this.addRemoveFeedbackDiv(!0),this.container},If.prototype.onRemove=function(){Sf.prototype.onRemove.call(this),delete this.container},If.prototype.setOptions=function(e){var t,r=this,e=(new xf).merge(this.options,e);e.copyrightMessage===this.options.copyrightMessage&&e.customAttribution===this.options.customAttribution||(this.copyrightDiv.innerText=this.textAttribution(e)),e.copyrightContent!==this.options.copyrightContent&&(this.options.copyrightContent&&(t=Array.from(this.copyrightDiv.children).find(function(e){return e===r.options.copyrightContent}),this.copyrightDiv.removeChild(t)),0<this.copyrightDiv.childNodes.length?this.copyrightDiv.insertBefore(e.copyrightContent,this.copyrightDiv.childNodes[0]):this.copyrightDiv.appendChild(e.copyrightContent),this.options.copyrightContent=e.copyrightContent),!e.showFeedbackLink&&this.feedbackAnchor?this.addRemoveFeedbackDiv(!1):e.showFeedbackLink&&!this.feedbackAnchor&&this.addRemoveFeedbackDiv(!0),this.options=e},If.prototype.getDefaultAttributions=function(){var e=(new Date).getFullYear(),t=["©".concat(e," TomTom")];return this.options.showLogo||t.push("©".concat(e," Microsoft")),t},If.prototype.buildCopyrightDiv=function(){var e=document.createElement("div");return e.innerText=this.textAttribution(this.options)||"",e},If.prototype.buildFeedbackLink=function(){var e=document.createElement("a");return e.setAttribute("alt","Provide Map Data Feedback"),e.setAttribute("aria-label","Provide Map Data Feedback"),e.innerText="Feedback",e.href=If.feedbackLink,e.target="_blank",e.rel="noopener",e.className="azure-map-feedback-text",e},If.prototype.addRemoveFeedbackDiv=function(e){e?(this.feedbackAnchor=this.buildFeedbackLink(),this.feedbackTooltip=Ft("Provide Map Data Feedback"),this.container.appendChild(this.feedbackAnchor),this.container.appendChild(this.feedbackTooltip),Ut(this.feedbackTooltip,this.feedbackAnchor),null!=(e=null==(e=this.map)?void 0:e.events)&&e.add("moveend",this.updateFeedbackLink)):(this.feedbackAnchor.remove(),this.feedbackTooltip.remove(),delete this.feedbackTooltip,delete this.feedbackAnchor,null!=(e=null==(e=this.map)?void 0:e.events)&&e.remove("moveend",this.updateFeedbackLink))},If.feedbackLink="https://aka.ms/azuremaps-feedback?feedbackep=UrlAzureMapsWebSdk";var Tf,Sf,Ef=If;function If(e){var r=Sf.call(this)||this;return r.textAttribution=function(e){return[r.options.copyrightMessage,r.options.customAttribution].filter(function(e){return e}).join("")},r.updateFeedbackLink=function(){var e,t;r.feedbackAnchor&&r.map&&(e=(t=r.map.getCamera()).center,t=t.zoom,r.feedbackAnchor.href="".concat(If.feedbackLink,"&cp=").concat(e[1],"~").concat(e[0],"&lvl=").concat(t+1))},r.options=(new xf).merge(e),r}(window&&window.__extends||(Af=function(e,t){return(Af=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Af(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Mf,kf=ye);var Af,kf,Pf=Mf;function Mf(){var e=null!==kf&&kf.apply(this,arguments)||this;return e.showLogo=!0,e}(window&&window.__extends||(Rf=function(e,t){return(Rf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Rf(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(Df,Of=er),Df.prototype.onAdd=function(e){return this.map=e,this.container=this.buildContainer(e,u.ControlStyle.auto),this.container.className="map-logo-control",null!=(e=this.map)&&e.events.add("resize",this._onResize),this._addRemoveLogo(this.options.showLogo),this.container},Df.prototype.onRemove=function(){var e;Of.prototype.onRemove.call(this),null!=(e=this.map)&&e.events.remove("resize",this._onResize),this.map=null,delete this.container},Df.prototype.setOptions=function(e){e=(new Pf).merge(this.options,e);!e.showLogo&&this.logoAnchor?this._addRemoveLogo(!1):e.showLogo&&!this.logoAnchor&&this._addRemoveLogo(!0),this.options=e},Df.prototype._addRemoveLogo=function(e){e?(this.logoAnchor=document.createElement("a"),this.logoAnchor.className="azure-map-logo",this.logoAnchor.href="https://aka.ms/azuremaps",this.logoAnchor.setAttribute("aria-label","Visit azure.microsoft.com"),this.logoAnchor.setAttribute("target","_blank"),this.container.appendChild(this.logoAnchor),this.logoTooltip=Ft("Visit azure.microsoft.com"),this.container.appendChild(this.logoTooltip),Ut(this.logoTooltip,this.logoAnchor),this._setVisiblity(!0)):(null!=(e=this.logoAnchor)&&e.remove(),null!=(e=this.logoTooltip)&&e.remove(),delete this.logoAnchor,this._setVisiblity(!1))},Df.prototype._setVisiblity=function(e){this.container&&(this.container.style.display=e?"flex":"none")},Df.CONTAINER_MIN_WIDTH=480;var Rf,Of,Lf=Df;function Df(e){var t=Of.call(this)||this;return t.map=null,t._onResize=function(){var e=(null==(e=null==(e=t.map)?void 0:e.getMapContainer())?void 0:e.clientWidth)||0;t._setVisiblity(t.options.showLogo&&Df.CONTAINER_MIN_WIDTH<=e)},t.options=(new Pf).merge(e),t}Nf.throwOnError=function(e,t){function r(e){throw i.off("error",r),e.error}var i=e instanceof MC?e._getMap():e,e=(i.on("error",r),t());return i.off("error",r),e},Nf.tryCatch=function(e,t,r,i){try{return this.throwOnError(e,t)}catch(e){return r(e)}finally{"function"==typeof i&&i()}},Nf.tryFinally=function(e,t,r){try{return this.throwOnError(e,t)}finally{r()}};var zf=Nf;function Nf(){}var Bf=window&&window.__assign||function(){return(Bf=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Ff=(Uf.prototype.request=function(e){var t,e={domain:this.map.getServiceOptions().domain,path:"reverseGeocode",queryParams:Bf({"api-version":"2023-06-01",coordinates:"".concat(Zc(e.position[0]),",").concat(Kc(e.position[1]))},e.style.view&&{view:e.style.view}),headers:{"Accept-Language":e.style.language}};return new Se((null==(t=this.map.authentication)?void 0:t.signRequest(e))||e).get()},Uf);function Uf(e){this.map=e}jf.prototype.cache=function(e,t,r,i){i="".concat(e,"_").concat(r[0],"_").concat(r[1],"_").concat(i);this._labelIdx[t.labelType]||(this._labelIdx[t.labelType]=[],this._labelCache[t.labelType]=[]),-1===this._labelIdx[t.labelType].indexOf(i)&&(this._labelCache[t.labelType].push({name:e,radius:t.radius,minZoom:t.minZoom,maxZoom:t.maxZoom||24,position:r}),this._labelIdx[t.labelType].push(i))},jf.prototype.getNearestLabel=function(e,t,r){var i=null,n=this._labelCache[e];if(n)for(var o,a=1/0,s=0,l=n.length;s<l;s++)r>=n[s].minZoom&&r<=n[s].maxZoom&&(o=Dc(n[s].position,t))<=n[s].radius&&o<=a&&(a=o,i=n[s]);return i},jf.prototype._preloadCache=function(e){if(!this._preloadedCache.has(e)){this._preloadedCache.add(e);var t={source:[],labelType:"water",minZoom:0,radius:395e4,polygonSources:[]},r=e,i=r.indexOf("-");switch(r=-1!==i?r.substr(0,i):r){case"fr":this.cache("Océan Pacifique",t,[-170,32],e),this.cache("Océan Pacifique",t,[-138,-27],e),this.cache("Océan Atlantique",t,[-40,32],e),this.cache("Océan Atlantique",t,[-17,-29],e);break;case"es":this.cache("Océan Pacifique",t,[-170,32],e),this.cache("Océan Pacifique",t,[-138,-27],e),this.cache("Océano Atlántico",t,[-40,32],e),this.cache("Océano Atlántico",t,[-17,-29],e);break;case"pt":this.cache("Oceano Pacífico",t,[-170,32],e),this.cache("Oceano Pacífico",t,[-138,-27],e),this.cache("Oceano Atlântico",t,[-40,32],e),this.cache("Oceano Atlântico",t,[-17,-29],e);break;case"ja":this.cache("太平洋",t,[-170,32],e),this.cache("太平洋",t,[-138,-27],e);break;case"en":this.cache("Pacific Ocean",t,[-170,32],e),this.cache("Pacific Ocean",t,[-138,-27],e),this.cache("Atlantic Ocean",t,[-40,32],e),this.cache("Atlantic Ocean",t,[-17,-29],e),this.cache("Indian Ocean",t,[77,-26],e)}}};var qf=jf;function jf(){this._labelCache={},this._labelIdx={},this._preloadedCache=new Set}var Hf=window&&window.__awaiter||function(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})},Vf=window&&window.__generator||function(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},c={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c;function e(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l=c&&t[c=0]?0:l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},Gf=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},Kf=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},Zf=(Wf.prototype.dispose=function(){this._disposed=!0;var e=this._map._getMap(),e=(e.off("move",this._onMove),e.off("moveend",this._onMoveEnd),e.off("styledata",this._onStyleData),e.off("rotate",this._onRotate),this._map.getCanvas());e.removeEventListener("mousedown",this._onPointerDown),e.removeEventListener("touchstart",this._onPointerDown),this._map.getMapContainer().removeEventListener("keydown",this._shortcutListener)},Wf.prototype._getEventPos=function(e){var t,r;return"touches"in e?(t=e.touches[0],r=e.target.getBoundingClientRect(),[t.pageX-r.left,t.pageY-r.top]):[e.offsetX,e.offsetY]},Wf.prototype._checkThresholds=function(e,t){return this._checkZoomThreshold(e.zoom,t.zoom)||this._checkPitchThreshold(e.pitch,t.pitch)||this._checkLocThreshold(e.center,t.center)||this._checkHeadingThreshold(e.bearing,t.bearing)},Wf.prototype._checkZoomThreshold=function(e,t){return this._round(e)!==this._round(t)},Wf.prototype._checkPitchThreshold=function(e,t){return Math.abs(e-t)>=this._pitchThreshold},Wf.prototype._checkLocThreshold=function(e,t){e=(t=Gf(this._map.positionsToPixels([t,e]),2))[0],t=t[1];return ic.getDistance(e,t)>=this._moveThreshold},Wf.prototype._checkHeadingThreshold=function(e,t){e<0&&(e+=360),t<0&&(t+=360);e=Math.abs(e-t);return(e=180<e?360-e:e)>=this._headingThreshold},Wf.prototype._getLocDesc=function(h,d,p){return Hf(this,void 0,void 0,function(){var t,r,i,n,o,a,s,l,c,u=this;return Vf(this,function(e){switch(e.label){case 0:return"blank"===p?[3,3]:this._map._getMap().loaded()?[3,2]:[4,new Promise(function(e){return u._map._getMap().once("idle",e)})];case 1:e.sent(),e.label=2;case 2:for(t={},r=this._map.positionsToPixels([h.center])[0],zf.tryCatch(this._map,function(){var t=u._map._getMap();i=t.queryRenderedFeatures(r,{layers:u._polygonStyleLayer.filter(function(e){return t.getLayer(e)}),filter:["==",["geometry-type"],"Polygon"]})},function(){}),n=null,i&&0<i.length&&(n=i[0]),o=null,a=0,s=this._labelConfig.length;a<s;a++)l=this._labelConfig[a],h.zoom>=l.minZoom?l.polygonSources?n&&-1!==l.polygonSources.indexOf(n.layer["source-layer"])?(o=l.labelType,this._getClosestLabel(l,h,d,t,!1)):this._getClosestLabel(l,h,d,t,!0):this._getClosestLabel(l,h,d,t,!1):this._getClosestLabel(l,h,d,t,!0);return 8<=h.zoom&&this._processRoads(t,h,d),this._labelCache.forEach(function(e){!t[e]&&(c=null,c="water"!==e&&"majorPoi"!==e||e===o?Wf._labelCache.getNearestLabel(e,h.center,h.zoom):c)&&(t[e]=c.name)}),[2,this._processLocInfo(h,o,t,!0,this._restFallback)];case 3:return[2,this._processLocInfo(h,null,null,!1,!1)]}})})},Wf.prototype._getHeadingDesc=function(e){var t=e.bearing;switch(t<0&&(t+=360),t=this._round(t,this._headingThreshold)){case 0:case 360:return"north";case 45:return"north east";case 90:return"east";case 135:return"south east";case 180:return"south";case 225:return"south west";case 270:return"west";case 315:return"north west";default:return"".concat(t," degrees")}},Wf.prototype._getClosestLabel=function(e,t,r,i,n){for(var o=e.radius,a=0,s=e.source.length;a<s;a++){var l={sourceLayer:e.source[a],filter:["has","name"]},c=this._map._getMap().querySourceFeatures(this._baseVectorTileSourceId,l),u=null,h=1/0,d=this._labelCache.has(e.labelType);if(!n||d)for(var p=0,f=c.length;p<f;p++){var m,g="Point"===c[p].geometry.type?c[p]:lu(t.center,c[p].geometry);n||(m="Point"===c[p].geometry.type?Dc(t.center,g.geometry.coordinates):g.properties.distance)<h&&(h=m,u=c[p]),d&&Wf._labelCache.cache(c[p].properties.name,e,g.geometry.coordinates,r)}n||(l=e.labelType+"Dis",u&&h<=o&&("number"!=typeof i[l]||h<=i[l])&&(i[e.labelType]=u.properties.name,i[l]=h))}},Wf.prototype._processRoads=function(e,t,r,i){var n=this._map._getMap().queryRenderedFeatures(i,{filter:["==",["geometry-type"],"LineString"]});if(n){for(var o,a=void 0,s=void 0,l=void 0,c=void 0,u=0,h=n.length;u<h;u++)this._roadLayers.has(n[u].layer["source-layer"])&&n[u].properties.name&&""!==n[u].properties.name&&(o=lu(t.center,n[u]),!l||o.properties.distance<l.properties.distance)&&(a&&n[u].properties.name===a.properties.name?l=o:a&&n[u].properties.name===a.properties.name?(!c||o.properties.distance<c.properties.distance)&&(c=o,s=n[u]):(c=l,s=a,l=o,a=n[u]));a&&(!e.country&&a.properties.country_code&&(e.country=a.properties.country_code,e.countryDis=0,Wf._labelCache.cache(e.country,{source:[],labelType:"country",radius:5e3,minZoom:0},l.geometry.coordinates,r)),!e.state&&a.properties.country_subdivision&&(e.state=a.properties.country_subdivision,e.stateDis=0,Wf._labelCache.cache(e.state,{source:[],labelType:"state",radius:5e3,minZoom:4},l.geometry.coordinates,r)),15<=t.zoom)&&(i=this._map.positionsToPixels([t.center,l.geometry.coordinates]),(ic.getDistance(i[0],i[1])<this._roadPixelRadius||l.properties.distance<this._minRoadDistance)&&(e.road=a.properties.name),s)&&(r=this._map.positionsToPixels([c.geometry.coordinates]),ic.getDistance(i[0],r[0])<this._minIntersectionPixelDistance||c.properties.distance<this._minRoadDistance)&&(e.secondRoad=s.properties.name,e.secondRoadDis=c.properties.distance)}},Wf.prototype._getActionDesc=function(e){var t,r,i;return this._lastCam&&(t=[],this._checkLocThreshold(e.center,this._lastCam.center)&&(i=["panned"],0===(r=Math.round(Uc(this._lastCam.center,e.center)))||360===r?i.push("north"):r<90?i.push("north east"):90===r?i.push("east"):r<180?i.push("south east"):180===r?i.push("south"):r<270?i.push("south west"):270===r?i.push("west"):r<360&&i.push("north west"),r=Dc(this._lastCam.center,e.center,lc.meters),i.push(1e3<r?"".concat(Rc(r/1e3,2)," kilometers"):"".concat(Rc(r,2)," meters")),t.push(i.join(" "))),this._checkZoomThreshold(e.zoom,this._lastCam.zoom)&&((i=["zoomed"]).push(this._lastCam.zoom<e.zoom?"in":"out"),1<=(r=Math.abs(this._lastCam.zoom-e.zoom))&&(r=Math.ceil(r),i.push("".concat(r,1<r?" levels":" level"))),this._getCanonicalZoom(this._lastCam.zoom)!==this._getCanonicalZoom(e.zoom)&&i.push("to ".concat(this._getCanonicalZoom(e.zoom)," level")),e.zoom>=e.maxZoom&&i.push("Zoom In button disabled, maximum zoom level reached"),r=f.getSouth(e.bounds)<=-vc&&f.getNorth(e.bounds)>=vc,(e.zoom<=e.minZoom||r)&&i.push("Zoom Out button disabled, minimum zoom level reached"),t.push(i.join(" "))),this._checkPitchThreshold(e.pitch,this._lastCam.pitch)&&(r=this._round(e.pitch,this._pitchThreshold),t.push("pitched to ".concat(r," degrees")),60!==e.pitch&&0!==e.pitch||(i=60===e.pitch?"maximum":"minimum",t.push("reached ".concat(i," of ").concat(e.pitch," degrees")))),this._checkHeadingThreshold(this._lastCam.bearing,e.bearing)&&t.push("rotated to ".concat(this._getHeadingDesc(e))),t.join(" and "))||null},Wf.prototype._getCanonicalZoom=function(e){return(e=this._round(e))<2?"world":e<5?"country":e<11?"state province":e<15?"city":"street"},Wf.prototype._processLocInfo=function(n,o,a,s,l){var c=this;return new Promise(function(t,e){var r=[];if(s){var i=[];if(a&&(o&&("water"===o&&a.water?i.push(a.water):"majorPoi"===o&&a.majorPoi&&i.push(a.majorPoi)),0===i.length)&&(a.majorPoi&&8<=n.zoom?i.push(a.majorPoi):(a.poi&&14<=n.zoom?i.push(a.poi):a.road&&15<=n.zoom&&(a.secondRoad?i.push(a.road+" & "+a.secondRoad):i.push(a.road)),a.neighbourhood&&12<=n.zoom&&i.push(a.neighbourhood),a.city&&6<=n.zoom&&i.push(a.city)),a.state&&4<=n.zoom&&i.push(a.state),0===i.length?a.water?i.push(a.water):a.country&&i.push(a.country):1===i.length&&a.state&&4<=n.zoom&&a.country&&i.push(a.country)),0<i.length)r.push("<p>Location: ",i.join(", "),".</p>");else if(l&&"water"!==o)return void c._reverseGeocodeDescription(n).then(function(e){t(e)},function(){e("<p>Location: unknown</p>")})}c._returnDetailedDescriptions&&(r.push("<p>Zoom: ",Rc(n.zoom,2),".</p>"),r.push("<p>Latitude: ",Rc(n.center[1],5),".</p>"),r.push("<p>Longitude: ",Rc(n.center[0],5),".</p>")),t(r.join(""))})},Wf.prototype._reverseGeocodeDescription=function(o){var a=this;return new Promise(function(i){var n=a._map.getStyle();a._reverseSearch.request({position:o.center,style:n}).then(function(e){var t,r={};e&&e.features&&0<e.features.length&&null!=(t=null==(t=e.features[0])?void 0:t.properties)&&t.address&&((t=e.features[0].properties.address).countryRegion&&(r.country=t.countryRegion.name,Wf._labelCache.cache(r.country,{source:[],labelType:"country",radius:5e3,minZoom:0},o.center,n.language)),t.adminDistricts&&(r.state=null==(e=t.adminDistricts[0])?void 0:e.shortName,Wf._labelCache.cache(r.state,{source:[],labelType:"state",radius:5e3,minZoom:4},o.center,n.language)),t.locality&&(r.city=t.locality,Wf._labelCache.cache(r.city,{source:[],labelType:"city",radius:1e3,minZoom:10},o.center,n.language)),t.addressLine)&&(r.road=t.addressLine),a._processLocInfo(o,null,r,!0,!1).then(function(e){i(e)})},function(e){a._processLocInfo(o,null,null,!0,!1).then(function(e){i(e)})}).catch(function(e){a._processLocInfo(o,null,null,!0,!1).then(function(e){i(e)})})})},Wf.prototype._round=function(e,t){return void 0===t&&(t=1),Math.round(e/t)*t},Wf._baseVectorTileSourceIds=["microsoft.base","vectorTiles","bing-mvt"],Wf._labelConfigBing=[{source:["water_feature"],labelType:"water",minZoom:0,radius:395e4,polygonSources:["generic_water_fill"]},{source:["water_feature"],labelType:"water",minZoom:3,radius:1e6,polygonSources:["generic_water_fill"]},{source:["country_region"],labelType:"country",minZoom:0,maxZoom:5,radius:3e5},{source:["admin_division1"],labelType:"state",minZoom:4,maxZoom:7,radius:3e5},{source:["populated_place"],labelType:"city",minZoom:8,radius:4e4},{source:["neighborhood"],labelType:"neighbourhood",minZoom:12,radius:6e3},{source:["amusement_park"],labelType:"poi",minZoom:14,radius:2e3,polygonSources:["amusement_park_fill"]},{source:["hospital"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["hospital_fill"]},{source:["shopping_center"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["shopping_center_fill"]},{source:["stadium"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["stadium_fill"]},{source:["higher_education_facility","school"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["higher_education_facility_fill","school_fill"]},{source:["zoo"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["zoo_fill"]},{source:["airport","airport_terminal"],labelType:"majorPoi",minZoom:11,radius:3e3,polygonSources:["airport_terminal_fill","airport_fill-merged7","airport_runway_fill"]},{source:["reserve"],labelType:"majorPoi",minZoom:7,radius:15e3,polygonSources:["generic_reserve_fill","land_cover_forest_fill"]}],Wf._roadLayersBing=new Set(["road"]),Wf);function Wf(e,t){var o=this;this._disposed=!1,this._lastHeadingTime=0,this._actionQueue=[],this._pointerUpdateDelay=3e3,this._camUpdateDelay=1e3,this._headUpdateLimit=1e3,this._controlEventDelay=500,this._moveThreshold=25,this._headingThreshold=5,this._pitchThreshold=5,this._roadPixelRadius=120,this._minRoadDistance=25,this._minIntersectionPixelDistance=50,this._labelConfig=[{source:["Ocean label","Ocean name"],labelType:"water",minZoom:0,radius:395e4,polygonSources:["Ocean","Ocean or sea"]},{source:["Sea label"],labelType:"water",minZoom:3,radius:1e6,polygonSources:["Sea","Ocean or sea"]},{source:["Country name"],labelType:"country",minZoom:0,maxZoom:5,radius:3e5},{source:["State name","State name short"],labelType:"state",minZoom:4,maxZoom:7,radius:3e5},{source:["Capital city","Large city"],labelType:"city",minZoom:8,radius:4e4},{source:["Medium city"],labelType:"city",minZoom:8,radius:3e4},{source:["Small city"],labelType:"city",minZoom:8,radius:2e4},{source:["Island label"],labelType:"city",minZoom:8,radius:1e4},{source:["Town"],labelType:"city",minZoom:10,radius:1e4},{source:["Village"],labelType:"neighbourhood",minZoom:12,radius:6e3},{source:["Amusement area label"],labelType:"poi",minZoom:14,radius:2e3,polygonSources:["Amusement park"]},{source:["Hospital label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Hospital"]},{source:["Shopping centre label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Shopping"]},{source:["Stadium label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Stadium"]},{source:["University/School label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["University"]},{source:["Zoo label"],labelType:"poi",minZoom:14,radius:1e3,polygonSources:["Zoo"]},{source:["Airport Label","Airport name","Airport POI"],labelType:"majorPoi",minZoom:11,radius:3e3,polygonSources:["Airport","Runway"]},{source:["National park label"],labelType:"majorPoi",minZoom:7,radius:15e3,polygonSources:["National or state park","National park","Forest"]},{source:["Reservation label"],labelType:"majorPoi",minZoom:7,radius:15e3,polygonSources:["Reservation"]}],this._labelCache=new Set(["city","state","country","water","majorPoi"]),this._roadLayers=new Set(["Connecting road","Connecting road tunnel","International road","International road tunnel","Local road","Local road tunnel","Major local road","Major local road tunnel","Major road","Major road tunnel","Minor local road","Minor local road tunnel","Motorway","Motorway tunnel","Secondary road","Secondary road tunnel","Toll connecting road","Toll connecting road tunnel","Toll international road","Toll international road tunnel","Toll local road","Toll local road tunnel","Toll major local road","Toll major local road tunnel","Toll major road","Toll major road tunnel","Toll minor local road","Toll minor local road tunnel","Toll motorway","Toll motorway tunnel","Toll secondary road","Toll secondary road tunnel"]),this._returnDetailedDescriptions=!1,this._shortcutListener=function(n){return Hf(o,void 0,void 0,function(){var t,r,i;return Vf(this,function(e){switch(e.label){case 0:return n.altKey&&n.ctrlKey&&68===n.keyCode?(this._returnDetailedDescriptions=!this._returnDetailedDescriptions,i=this._map.getCamera(),r=this._map.getStyle(),t=r.language.toLowerCase(),r=r.style.toLowerCase(),[4,this._getLocDesc(i,t,r)]):[3,2];case 1:i=e.sent(),this._descCallback(i),e.label=2;case 2:return[2]}})})},this._onRotate=function(){o._rotateTimeout||(Date.now()-o._lastHeadingTime>=o._headUpdateLimit?o._rotateTimeout=setTimeout(o._updateHeading,lr.RotationDuration+25):o._rotateTimeout=setTimeout(o._updateHeading,o._headUpdateLimit-(Date.now()-o._lastHeadingTime)))},this._onMove=function(){o._moveTimeout&&(clearTimeout(o._moveTimeout),delete o._moveTimeout),o._controlTimeout&&(clearTimeout(o._controlTimeout),delete o._controlTimeout)},this._onMoveEnd=function(e){e.fromControl?o._controlTimeout=setTimeout(o._updateCam,o._controlEventDelay):o._updateCam()},this._onStyleData=function(){setTimeout(o._updateStyle)},this._onPointerDown=function(e){o._lastPointerPos=o._getEventPos(e),o._pointerTimeout=setTimeout(function(){return Hf(o,void 0,void 0,function(){var t,r,i;return Vf(this,function(e){switch(e.label){case 0:return r=this._map.getStyle(),t=r.language.toLowerCase(),r=r.style.toLowerCase(),(i=this._map.getCamera()).center=this._map.pixelsToPositions([this._lastPointerPos])[0],[4,this._getLocDesc(i,t,r)];case 1:return i=e.sent(),this._descCallback(i),this._onPointerUp(),[2]}})})},o._pointerUpdateDelay),o._map.getCanvas().addEventListener("mousemove",o._onPointerMove),o._map.getCanvas().addEventListener("touchmove",o._onPointerMove),o._map.getCanvas().addEventListener("mouseup",o._onPointerUp),o._map.getCanvas().addEventListener("touchend",o._onPointerUp)},this._onPointerMove=function(e){var e=o._getEventPos(e),t=o._lastPointerPos[0]-e[0],e=o._lastPointerPos[1]-e[1];Math.sqrt(t*t+e*e)>o._moveThreshold&&o._onPointerUp()},this._onPointerUp=function(){clearTimeout(o._pointerTimeout),delete o._pointerTimeout,o._map.getCanvas().removeEventListener("mousemove",o._onPointerMove),o._map.getCanvas().removeEventListener("touchmove",o._onPointerMove),o._map.getCanvas().removeEventListener("mouseup",o._onPointerUp),o._map.getCanvas().removeEventListener("touchend",o._onPointerUp)},this._updateHeading=function(){var e,t=o._map.getCamera();o._lastHead&&!o._checkHeadingThreshold(t.bearing,o._lastHead)||(e=o._getHeadingDesc(t),o._lastHead=t.bearing,o._descCallback("<p>Map heading ".concat(e,".</p>")),o._lastHeadingTime=Date.now()),delete o._rotateTimeout},this._updateStyle=function(){return Hf(o,void 0,void 0,function(){var t,r,i,n;return Vf(this,function(e){switch(e.label){case 0:return(t=this._map.getCamera(),i=this._map.getStyle(),r=i.language.toLowerCase(),i=i.style.toLowerCase(),this._lastLang===r)?[3,2]:(Wf._labelCache._preloadCache(r),[4,this._getLocDesc(t,r,i)]);case 1:return n=e.sent(),[3,4];case 2:return this._lastStyle===i||"blank"!==this._lastStyle?[3,4]:[4,this._getLocDesc(t,r,i)];case 3:n=e.sent(),e.label=4;case 4:return this._lastLang=r,this._lastStyle=i,n&&this._descCallback(n),[2]}})})},this._updateCam=function(e){void 0===e&&(e=!1);var r,i,t,n=o._map.getCamera();(!o._lastCam||0<o._actionQueue.length||o._checkThresholds(n,o._lastCam))&&(t=o._map.getStyle(),r=t.language.toLowerCase(),i=t.style.toLowerCase(),(t=o._getActionDesc(n))&&o._actionQueue.push(t),o._lastCam=n,o._moveTimeout&&(clearTimeout(o._moveTimeout),delete o._moveTimeout),o._moveTimeout=setTimeout(function(){return Hf(o,void 0,void 0,function(){var t;return Vf(this,function(e){switch(e.label){case 0:return clearTimeout(this._rotateTimeout),delete this._rotateTimeout,[4,this._getLocDesc(n,r,i)];case 1:return t=e.sent(),0<this._actionQueue.length?(this._descCallback("<p>Map ".concat(this._actionQueue.join(", then "),".</p>").concat(t)),this._actionQueue=[]):this._descCallback(t),[2]}})})},e?0:o._camUpdateDelay))},this._map=e,this._restFallback=e.getServiceOptions().enableAccessibilityLocationFallback,this._descCallback=t,this._reverseSearch=new Ff(e),Wf._labelCache||(Wf._labelCache=new qf),this._lastLang=this._map.getStyle().language.toLowerCase(),Wf._labelCache._preloadCache(this._lastLang),this._map.events.addOnce("idle",function(){var e;o._disposed||(o._updateCam(!0),o._baseVectorTileSourceId=Wf._baseVectorTileSourceIds.find(function(e){return o._map.sources.getById(e)}),"bing-mvt"===o._baseVectorTileSourceId&&(o._labelConfig=Wf._labelConfigBing,o._roadLayers=Wf._roadLayersBing),o._polygonStyleLayer=o._labelConfig.reduce(function(e,t){return t.polygonSources&&e.push.apply(e,Kf([],Gf(t.polygonSources),!1)),e},[]),(e=o._map._getMap()).on("move",o._onMove),e.on("moveend",o._onMoveEnd),e.on("styledata",o._onStyleData),e.on("rotate",o._onRotate),(e=o._map.getCanvas()).addEventListener("mousedown",o._onPointerDown),e.addEventListener("touchstart",o._onPointerDown))}),this._map.getMapContainer().addEventListener("keydown",this._shortcutListener)}var Yf,$f,Xf,Jf=function(e){var r=this;this.addToMap=function(){null==r.mapViewDesc&&(r.initializeMapLiveStateInfo(),r.initializeMapStyleInfo(),r.createMapKeyBindingInfo(),r.map.getMapContainer().setAttribute("role","application"),r.map.getMapContainer().setAttribute("aria-label","Map Application"),r.map.getCanvasContainer().setAttribute("aria-live","polite"),r.map.getCanvasContainer().setAttribute("aria-describedby","atlas-map-state atlas-map-style"),r.map.getCanvas().setAttribute("aria-label","Interactive Map"),r.map.getCanvas().setAttribute("aria-describedby","atlas-map-shortcuts"),r.map.getCanvas().setAttribute("alt","Interactive Map"))},this.removeFromMap=function(){null!=r.mapViewDesc&&r.mapViewDesc.dispose(),delete r.mapViewDesc,null!=r.atlasMapKeyBindings&&r.map.getCanvasContainer().removeChild(r.atlasMapKeyBindings),delete r.atlasMapKeyBindings,null!=r.atlasMapLiveStateInfo&&r.map.getCanvasContainer().removeChild(r.atlasMapLiveStateInfo),delete r.atlasMapLiveStateInfo,null!=r.atlasMapStyleInfo&&r.map.getCanvasContainer().removeChild(r.atlasMapStyleInfo),delete r.atlasMapStyleInfo,r.map.getMapContainer().removeAttribute("role"),r.map.getMapContainer().removeAttribute("aria-label"),r.map.getCanvasContainer().removeAttribute("aria-live"),r.map.getCanvasContainer().removeAttribute("aria-describedby"),r.map.getCanvas().removeAttribute("aria-label"),r.map.getCanvas().removeAttribute("aria-describedby"),r.map.getCanvas().removeAttribute("alt"),r.map.events.remove("stylechanged",r.updateMapStyle)},this.createMapKeyBindingInfo=function(){r.atlasMapKeyBindings=document.createElement("div"),r.atlasMapKeyBindings.setAttribute("tabindex","-1"),r.atlasMapKeyBindings.setAttribute("aria-hidden","true"),r.atlasMapKeyBindings.id="atlas-map-shortcuts",r.atlasMapKeyBindings.classList.add("hidden-accessible-element"),r.atlasMapKeyBindings.innerHTML=["Map shortcuts:","Zoom out: hyphen.","Zoom in: plus.","Pan right 100 pixels: right arrow.","Pan left 100 pixels: left arrow.","Pan up 100 pixels: up arrow.","Pan down 100 pixels: down arrow.","Rotate 15 degrees clockwise: shift + right arrow.","Rotate 15 degrees counter clockwise: shift + left arrow.","Increase pitch 10 degrees: shift + up arrow.","Decrease pitch 10 degrees: shift + down arrow.","Jump focus to the map: Escape."].join("\n"),r.map.getCanvasContainer().appendChild(r.atlasMapKeyBindings);var e=[189,187,38,37,39,40],t=r.map._getMap()._canvas;null!=t&&t.addEventListener("keyup",function(t){e.find(function(e){return t.keyCode===e})&&(r.atlasMapKeyBindings.innerHTML="")})},this.initializeMapLiveStateInfo=function(){r.mapViewDesc=new Zf(r.map,r.updateMapState),r.atlasMapLiveStateInfo=document.createElement("div"),r.atlasMapLiveStateInfo.setAttribute("tabindex","-1"),r.atlasMapLiveStateInfo.setAttribute("aria-hidden","true"),r.atlasMapLiveStateInfo.id="atlas-map-state",r.atlasMapLiveStateInfo.classList.add("hidden-accessible-element"),r.map.getCanvasContainer().appendChild(r.atlasMapLiveStateInfo)},this.initializeMapStyleInfo=function(){r.atlasMapStyleInfo=document.createElement("div"),r.atlasMapStyleInfo.setAttribute("tabindex","-1"),r.atlasMapStyleInfo.setAttribute("aria-hidden","true"),r.atlasMapStyleInfo.id="atlas-map-style",r.atlasMapStyleInfo.classList.add("hidden-accessible-element"),r.map.events.add("stylechanged",r.updateMapStyle),r.map.getCanvasContainer().appendChild(r.atlasMapStyleInfo)},this.updateMapStyle=function(){r.atlasMapStyleInfo.innerHTML="<p>Map style: ".concat(r.map.getStyle().style,".</p>")},this.updateMapState=function(e){r.atlasMapLiveStateInfo.innerHTML=e},this.map=e},Qf=function(e){var r=this;this.listenerEnabled=!1,this.lastFlowMode="none",this.addToMap=function(){if(!r.map._isReady())throw new Error("Traffic flow could not be added to the map because the map is not ready. Please use a ready event listener to guarantee the map is ready before enabling traffic flow.");r.listenerEnabled||(r.map.events.add("styledata",r.addToMap),r.listenerEnabled=!0);var e,t=r.map.getTraffic();"none"!==t.flow&&(e=r.map.layers.getLayerById("traffic_".concat(t.flow)))&&(r.lastFlowMode=t.flow,e._updateLayoutProperty("visibility","visible","none"))},this.removeFromMap=function(){var e;r.map.getTraffic(),"none"!=r.lastFlowMode&&((e=r.map.layers.getLayerById("traffic_".concat(r.lastFlowMode)))&&e._updateLayoutProperty("visibility","none","visible"),r.lastFlowMode="none"),r.listenerEnabled&&(r.map.events.remove("styledata",r.addToMap),r.listenerEnabled=!1)},this.map=e},em=((window&&window.__extends||(Yf=function(e,t){return(Yf=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Yf(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(tm,$f=Ql),tm.getIncidentTypeName=function(e,t){switch(e){case 0:return t.Unknown;case 1:return t.Accident;case 2:return t.Fog;case 3:return t.Danger;case 4:return t.Rain;case 5:return t.Ice;case 6:return t.Jam;case 7:return t.LaneClosed;case 8:return t.RoadClosed;case 9:return t.RoadWorks;case 10:return t.Wind;case 11:return t.Flood;case 12:return t.Detour;default:return t.Unknown}},tm.getIncidentTypeIconName=function(e){switch(e){case 0:return"unknown";case 1:return"accident";case 2:return"fog";case 3:return"danger";case 4:return"rain";case 5:return"ice";case 6:return"jam";case 7:return"lane-closed";case 8:return"road-closed";case 9:return"road-work";case 10:return"wind";case 11:return"flood";case 12:return"detour";default:return"unknown"}},tm.getSeverityColorName=function(e){switch(e){case 0:return"grey";case 1:return"yellow";case 2:return"orange";case 3:return"red";default:return"grey"}},tm.getSeverityColorHexCode=function(e){switch(e){case 0:return"#B5B6B7";case 1:return"#F4C951";case 2:return"#F4873F";case 3:return"#F04F4E";default:return"#B5B6B7"}},tm);function tm(e,t,r){var i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=null!=(i=e.icon_category_12)?i:e.icon_category_11)?i:e.icon_category_10)?i:e.icon_category_9)?i:e.icon_category_8)?i:e.icon_category_7)?i:e.icon_category_6)?i:e.icon_category_5)?i:e.icon_category_4)?i:e.icon_category_3)?i:e.icon_category_2)?i:e.icon_category_1)?i:e.icon_category_0)?i:e.icon_category,n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=null!=(n=e.description_12)?n:e.description_11)?n:e.description_10)?n:e.description_9)?n:e.description_8)?n:e.description_7)?n:e.description_6)?n:e.description_5)?n:e.description_4)?n:e.description_3)?n:e.description_2)?n:e.description_1)?n:e.description_0)?n:e.description,i={icon:"".concat(tm.getSeverityColorName(e.magnitude),"-").concat(tm.getIncidentTypeIconName(i)),incidentType:tm.getIncidentTypeName(i,r),description:n,delay:e.delay,color:tm.getSeverityColorHexCode(e.magnitude),id:e.id};return $f.call(this,t,i)||this}(n=Xf=Xf||{}).DELAY="delay",n.LENGTH="length",n.FROM="from",n.TO="to";im.build=function(e,t){void 0===t&&(t="en-US");var r,i=document.createElement("div"),n=(i.classList.add("incident-popup-title"),i.classList.add("font-segoeui-b"),i.innerText=e.properties.incidentType,i.setAttribute("aria-label","Incident Type ".concat(e.properties.incidentType)),document.createElement("div")),o=(n.classList.add("incident-popup-subtitle"),n.classList.add("font-segoeui-b"),n.setAttribute("aria-label","Incident Description ".concat(e.properties.description)),n.innerText=e.properties.description,document.createElement("div")),i=(o.classList.add("incident-popup-header"),o.style.backgroundColor=e.properties.color,o.appendChild(i),o.appendChild(n),document.createElement("div")),n=(i.classList.add("incident-popup-body"),e.properties.delay&&(n="".concat(Math.floor(e.properties.delay/60)," min"),n=this.createInfoSection(n,Xf.DELAY),i.appendChild(n)),e.properties.length&&(n=new Intl.NumberFormat([t,"en-US"],{maximumFractionDigits:2}),r=void 0,r="en-US"===t?(t=Oc(e.properties.length,"meters","miles"),"".concat(n.format(t)," miles")):(t=Oc(e.properties.length,"meters","kilometers"),"".concat(n.format(t)," km")),n=this.createInfoSection(r,Xf.LENGTH),i.appendChild(n)),e.properties.from&&(t=this.createInfoSection(e.properties.from,Xf.FROM),i.appendChild(t)),e.properties.to&&(r=this.createInfoSection(e.properties.to,Xf.TO),i.appendChild(r)),document.createElement("div"));return n.classList.add("incident-popup-content"),n.appendChild(o),n.appendChild(i),new lf({content:n,position:e.geometry.coordinates})},im.createInfoSection=function(e,t){var r=document.createElement("div"),i=(r.classList.add("incident-popup-info"),document.createElement("div")),n=(i.classList.add("icon"),i.classList.add(t),document.createElement("span"));return n.classList.add("message"),n.classList.add("font-segoeui"),n.setAttribute("aria-label","Incident ".concat(t," ").concat(e)),n.innerText=e,r.appendChild(i),r.appendChild(n),r};var rm=im;function im(){}var nm=window&&window.__awaiter||function(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})},om=window&&window.__generator||function(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},c={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c;function e(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l=c&&t[c=0]?0:l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},am=(sm.prototype.getIncidentIconImageExpression=function(){return["concat",["let","magnitude",["get","magnitude"],["case",["==",["var","magnitude"],0],"grey",["==",["var","magnitude"],1],"yellow",["==",["var","magnitude"],2],"orange",["==",["var","magnitude"],3],"red",["==",["var","magnitude"],4],"grey","grey"]],"-",["let","category",["coalesce",["get","icon_category_12"],["get","icon_category_11"],["get","icon_category_10"],["get","icon_category_9"],["get","icon_category_8"],["get","icon_category_7"],["get","icon_category_6"],["get","icon_category_5"],["get","icon_category_4"],["get","icon_category_3"],["get","icon_category_2"],["get","icon_category_0"],["get","icon_category"],0],["case",["==",["var","category"],0],"unknown",["==",["var","category"],1],"accident",["==",["var","category"],2],"fog",["==",["var","category"],3],"danger",["==",["var","category"],4],"rain",["==",["var","category"],5],"ice",["==",["var","category"],6],"jam",["==",["var","category"],7],"lane-closed",["==",["var","category"],8],"road-closed",["==",["var","category"],9],"road-work",["==",["var","category"],10],"wind",["==",["var","category"],11],"flood",["==",["var","category"],12],"detour","unknown"]]]},sm);function sm(e){var n=this,e=(this.incidentLayerName="incidents",this.incidentSourceName="mapcontrol_traffic_incident",this.addToMap=function(){n.map.sources.getById(n.incidentSourceName)||n.map.sources.add(n.vectorTileSource),n.map.layers.getLayerById(n.incidentLayerName)||n.map.layers.add(n.incidentLayer,"labels"),n.clickPopup=new lf({position:[0,0],pixelOffset:[0,-18]}),n.map.addEventListener("mouseover",n.incidentLayerName,n.cursorToPointer),n.map.addEventListener("mouseleave",n.incidentLayerName,n.cursorToDefault),n.map.addEventListener("click",n.incidentLayerName,n.openIncidentPopup),n.map.events.addOnce("idle",n.setAccessiblePopups),n.map.events.add("moveend",n.setAccessiblePopups)},this.accessiblePopups=[],this.setAccessiblePopups=function(){return nm(n,void 0,void 0,function(){var t,o,a,s,l,c,u=this;return om(this,function(e){switch(e.label){case 0:return this.accessiblePopups.forEach(function(e){return e.remove()}),this.accessiblePopups=[],t=this.map.layers.getRenderedShapes(this.map.getCamera().bounds,this.incidentLayer),[4,this.map._getLocalizedStrings()];case 1:return o=e.sent(),a=function(t,r){var e=t[r],i=e.geometry.coordinates,i=new oc(new hu(i[0],i[1])),e=new em(e.properties,i,o),n=rm.build(e,u.incidentLanguage),i=n.getPopupContainer();return i.addEventListener("focusin",function(e){u.clickPopup.remove(),u.accessiblePopups.filter(function(e){return e!==n}).forEach(function(e){return e.remove()}),0<=r-1&&s(n,a(t,r-1)),r+1<t.length&&c(a(t,r+1)),2<=r&&r==t.length-1&&l(a(t,0)),0==r&&2<=t.length&&c(a(t,t.length-1))}),r==t.length-1&&i.addEventListener("focusout",function(e){null===e.relatedTarget&&n.close()}),u.accessiblePopups.push(n),n},s=function(e,t){t.open(u.map),t.close();t=t.getPopupContainer(),e=e.getPopupContainer();e.parentElement.insertBefore(t,e)},l=function(e){e.open(u.map),e.close();var e=e.getPopupContainer(),t=e.parentElement;t.insertBefore(e,t.firstElementChild)},c=function(e){e.open(u.map),e.close()},0<t.length&&c(a(t,0)),1<t.length&&c(a(t,t.length-1)),[2]}})})},this.removeFromMap=function(){var e;n.map.removeEventListener("mouseover",n.incidentLayerName,n.cursorToPointer),n.map.removeEventListener("mouseleave",n.incidentLayerName,n.cursorToDefault),n.map.removeEventListener("click",n.incidentLayerName,n.openIncidentPopup),n.map.events.remove("idle",n.setAccessiblePopups),n.map.events.remove("moveend",n.setAccessiblePopups),n.accessiblePopups.forEach(function(e){return e.remove()}),n.accessiblePopups=[],null!=(e=n.clickPopup)&&e.remove(),null!=n.map.layers.getLayerById(n.incidentLayerName)&&n.map.layers.remove(n.incidentLayerName),null!=n.map.sources.getById(n.incidentSourceName)&&n.map.sources.remove(n.incidentSourceName)},this.cursorToPointer=function(e){n.map.getCanvas().style.cursor="pointer"},this.cursorToDefault=function(e){n.map.getCanvas().style.cursor=""},this.openIncidentPopup=function(e){n.clickPopup.remove(),n.accessiblePopups.forEach(function(e){return e.close()});var r=e.position,i=e.features[0];n.map._getLocalizedStrings().then(function(e){var t=new oc(new hu(r[0],r[1])),t=new em(i.properties,t,e);n.clickPopup=rm.build(t,n.incidentLanguage),n.clickPopup.open(n.map),n.clickPopup.getPopupContainer().addEventListener("focusout",function(e){null===e.relatedTarget&&n.clickPopup.close()})})},this.map=e,this.vectorTileSource=new Ch(this.incidentSourceName,{maxZoom:22,tiles:["https://".concat(te,"/traffic/incident/tile/pbf?api-version=1.0&zoom={z}&x={x}&y={y}")]}),this.getIncidentIconImageExpression());this.incidentLayer=new Tp(this.incidentSourceName,this.incidentLayerName,{sourceLayer:"Traffic incident POI",iconOptions:{ignorePlacement:!0,allowOverlap:!0,image:e,size:.75}})}(window&&window.__extends||(lm=function(e,t){return(lm=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}lm(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(hm,cm=ye);var lm,cm,um=hm;function hm(){var e=null!==cm&&cm.apply(this,arguments)||this;return e.interactive=!0,e.scrollZoomInteraction=!0,e.boxZoomInteraction=!0,e.dragRotateInteraction=!0,e.dragPanInteraction=!0,e.keyboardInteraction=!0,e.dblClickZoomInteraction=!0,e.touchInteraction=!0,e.touchRotate=!0,e.wheelZoomRate=1/450,e}pm.prototype.enable=function(){this.map.getMapContainer().addEventListener("keydown",this._onKeyDown)},pm.prototype.disable=function(){this.map.getMapContainer().removeEventListener("keydown",this._onKeyDown)};var dm=pm;function pm(e){var t=this;this._onKeyDown=function(e){27===e.keyCode&&t.map.getCanvas().focus()},this.map=e}mm.prototype.enable=function(){this.map.getCanvasContainer().addEventListener("gesturestart",this._onGestureStart),this.map.getCanvasContainer().addEventListener("gesturechange",this._onGestureChange),this.map.getCanvasContainer().addEventListener("touchstart",this._onTouchStart),this.map.getCanvasContainer().addEventListener("touchend",this._onTouchEnd)},mm.prototype.disable=function(){this.map.getCanvasContainer().removeEventListener("gesturestart",this._onGestureStart),this.map.getCanvasContainer().removeEventListener("gesturechange",this._onGestureChange),this.map.getCanvasContainer().removeEventListener("touchstart",this._onTouchStart),this.map.getCanvasContainer().removeEventListener("touchend",this._onTouchEnd)};var fm=mm;function mm(e){var t=this;this._onGestureStart=function(e){t.hasTouch||(e.preventDefault(),t.initZoom=t.map.getCamera().zoom)},this._onGestureChange=function(e){t.hasTouch||(e.preventDefault(),t.map.setCamera({zoom:t.initZoom+e.scale-1}))},this._onTouchStart=function(e){t.hasTouch=!0},this._onTouchEnd=function(e){0===e.touches.length&&(t.hasTouch=!1)},this.map=e}ym.prototype.addToMap=function(){this.added||(this.added=!0,this._setInteractions(this.options))},ym.prototype.removeFromMap=function(){this.added&&(this.added=!1,this._setInteractions({interactive:!1}))},ym.prototype.setOptions=function(e){this.options=(new um).merge(this.options,e),this.added&&this._setInteractions(this.options)},ym.prototype.getOptions=function(){return Object.assign({},this.options)},ym.prototype._setInteractions=function(e){var t;e.interactive?(e.boxZoomInteraction?this.map._getMap().boxZoom.enable():this.map._getMap().boxZoom.disable(),e.dblClickZoomInteraction?this.map._getMap().doubleClickZoom.enable():this.map._getMap().doubleClickZoom.disable(),e.dragPanInteraction?this.map._getMap().dragPan.enable():this.map._getMap().dragPan.disable(),e.dragRotateInteraction?this.map._getMap().dragRotate.enable():this.map._getMap().dragRotate.disable(),e.keyboardInteraction?(this.map._getMap().keyboard.enable(),this.focusShortcut.enable()):(this.map._getMap().keyboard.disable(),this.focusShortcut.disable()),e.scrollZoomInteraction?(this.map._getMap().scrollZoom.enable(),this.map._getMap().scrollZoom.setWheelZoomRate(e.wheelZoomRate)):this.map._getMap().scrollZoom.disable(),t=this.map._getMap().touchZoomRotate,e.touchInteraction?(t.enable(),e.touchRotate?t.enableRotation():t.disableRotation()):t.disable(),this.pinchZoom.enable()):(this.map._getMap().boxZoom.disable(),this.map._getMap().doubleClickZoom.disable(),this.map._getMap().dragPan.disable(),this.map._getMap().dragRotate.disable(),this.map._getMap().keyboard.disable(),this.focusShortcut.disable(),this.map._getMap().scrollZoom.disable(),this.map._getMap().touchZoomRotate.disable(),this.pinchZoom.disable())};var gm=ym;function ym(e,t){this.added=!1,this.map=e,this.focusShortcut=new dm(e),this.pinchZoom=new fm(e),this.options=(new um).merge(t)}function vm(e,t,r){var i={type:"Feature"};return 0!==(r=void 0===r?{}:r).id&&!r.id||(i.id=r.id),r.bbox&&(i.bbox=r.bbox),i.properties=t||{},i.geometry=e,i}function _m(e){return"Feature"===e.type?e.geometry:e}var bm=z(function(){function c(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function i(e,t){for(var r=0;r<t.length;r++){var i=t[r];i.enumerable=i.enumerable||false;i.configurable=true;if("value"in i)i.writable=true;Object.defineProperty(e,i.key,i)}}function a(e,t,r){if(t)i(e.prototype,t);if(r)i(e,r);return e}var u=function(){function e(e,t){this.next=null;this.key=e;this.data=t;this.left=null;this.right=null}return e}();function t(e,t){return e>t?1:e<t?-1:0}function s(e,t,r){var i=new u(null,null);var n=i;var o=i;while(true){var a=r(e,t.key);if(a<0){if(t.left===null)break;if(r(e,t.left.key)<0){var s=t.left;t.left=s.right;s.right=t;t=s;if(t.left===null)break}o.left=t;o=t;t=t.left}else if(a>0){if(t.right===null)break;if(r(e,t.right.key)>0){var s=t.right;t.right=s.left;s.left=t;t=s;if(t.right===null)break}n.right=t;n=t;t=t.right}else break}n.right=t.left;o.left=t.right;t.left=i.right;t.right=i.left;return t}function l(e,t,r,i){var n=new u(e,t);if(r===null){n.left=n.right=null;return n}r=s(e,r,i);var o=i(e,r.key);if(o<0){n.left=r.left;n.right=r;r.left=null}else if(o>=0){n.right=r.right;n.left=r;r.right=null}return n}function h(e,t,r){var i=null;var n=null;if(t){t=s(e,t,r);var o=r(t.key,e);if(o===0){i=t.left;n=t.right}else if(o<0){n=t.right;t.right=null;i=t}else{i=t.left;t.left=null;n=t}}return{left:i,right:n}}function d(e,t,r){if(t===null)return e;if(e===null)return t;t=s(e.key,t,r);t.left=e;return t}function p(e,t,r,i,n){if(e){i(""+t+(r?"└── ":"├── ")+n(e)+"\n");var o=t+(r?"    ":"│   ");if(e.left)p(e.left,o,false,i,n);if(e.right)p(e.right,o,true,i,n)}}var M=function(){function e(e){if(e===void 0)e=t;this._root=null;this._size=0;this._comparator=e}e.prototype.insert=function(e,t){this._size++;return this._root=l(e,t,this._root,this._comparator)};e.prototype.add=function(e,t){var r=new u(e,t);if(this._root===null){r.left=r.right=null;this._size++;this._root=r}var i=this._comparator;var n=s(e,this._root,i);var o=i(e,n.key);if(o===0)this._root=n;else{if(o<0){r.left=n.left;r.right=n;n.left=null}else if(o>0){r.right=n.right;r.left=n;n.right=null}this._size++;this._root=r}return this._root};e.prototype.remove=function(e){this._root=this._remove(e,this._root,this._comparator)};e.prototype._remove=function(e,t,r){var i;if(t===null)return null;t=s(e,t,r);var n=r(e,t.key);if(n===0){if(t.left===null)i=t.right;else{i=s(e,t.left,r);i.right=t.right}this._size--;return i}return t};e.prototype.pop=function(){var e=this._root;if(e){while(e.left)e=e.left;this._root=s(e.key,this._root,this._comparator);this._root=this._remove(e.key,this._root,this._comparator);return{key:e.key,data:e.data}}return null};e.prototype.findStatic=function(e){var t=this._root;var r=this._comparator;while(t){var i=r(e,t.key);if(i===0)return t;else if(i<0)t=t.left;else t=t.right}return null};e.prototype.find=function(e){if(this._root){this._root=s(e,this._root,this._comparator);if(this._comparator(e,this._root.key)!==0)return null}return this._root};e.prototype.contains=function(e){var t=this._root;var r=this._comparator;while(t){var i=r(e,t.key);if(i===0)return true;else if(i<0)t=t.left;else t=t.right}return false};e.prototype.forEach=function(e,t){var r=this._root;var i=[];var n=false;while(!n)if(r!==null){i.push(r);r=r.left}else if(i.length!==0){r=i.pop();e.call(t,r);r=r.right}else n=true;return this};e.prototype.range=function(e,t,r,i){var n=[];var o=this._comparator;var a=this._root;var s;while(n.length!==0||a)if(a){n.push(a);a=a.left}else{a=n.pop();s=o(a.key,t);if(s>0)break;else if(o(a.key,e)>=0)if(r.call(i,a))return this;a=a.right}return this};e.prototype.keys=function(){var r=[];this.forEach(function(e){var t=e.key;return r.push(t)});return r};e.prototype.values=function(){var r=[];this.forEach(function(e){var t=e.data;return r.push(t)});return r};e.prototype.min=function(){if(this._root)return this.minNode(this._root).key;return null};e.prototype.max=function(){if(this._root)return this.maxNode(this._root).key;return null};e.prototype.minNode=function(e){if(e===void 0)e=this._root;if(e)while(e.left)e=e.left;return e};e.prototype.maxNode=function(e){if(e===void 0)e=this._root;if(e)while(e.right)e=e.right;return e};e.prototype.at=function(e){var t=this._root;var r=false;var i=0;var n=[];while(!r)if(t){n.push(t);t=t.left}else if(n.length>0){t=n.pop();if(i===e)return t;i++;t=t.right}else r=true;return null};e.prototype.next=function(e){var t=this._root;var r=null;if(e.right){r=e.right;while(r.left)r=r.left;return r}var i=this._comparator;while(t){var n=i(e.key,t.key);if(n===0)break;else if(n<0){r=t;t=t.left}else t=t.right}return r};e.prototype.prev=function(e){var t=this._root;var r=null;if(e.left!==null){r=e.left;while(r.right)r=r.right;return r}var i=this._comparator;while(t){var n=i(e.key,t.key);if(n===0)break;else if(n<0)t=t.left;else{r=t;t=t.right}}return r};e.prototype.clear=function(){this._root=null;this._size=0;return this};e.prototype.toList=function(){return r(this._root)};e.prototype.load=function(e,t,r){if(t===void 0)t=[];if(r===void 0)r=false;var i=e.length;var n=this._comparator;if(r)v(e,t,0,i-1,n);if(this._root===null){this._root=f(e,t,0,i);this._size=i}else{var o=y(this.toList(),m(e,t),n);i=this._size+i;this._root=g({head:o},0,i)}return this};e.prototype.isEmpty=function(){return this._root===null};Object.defineProperty(e.prototype,"size",{get:function e(){return this._size},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"root",{get:function e(){return this._root},enumerable:true,configurable:true});e.prototype.toString=function(e){if(e===void 0)e=function e(t){return String(t.key)};var t=[];p(this._root,"",true,function(e){return t.push(e)},e);return t.join("")};e.prototype.update=function(e,t,r){var i=this._comparator;var n=h(e,this._root,i),o=n.left,a=n.right;if(i(e,t)<0)a=l(t,r,a,i);else o=l(t,r,o,i);this._root=d(o,a,i)};e.prototype.split=function(e){return h(e,this._root,this._comparator)};return e}();function f(e,t,r,i){var n=i-r;if(n>0){var o=r+Math.floor(n/2);var a=e[o];var s=t[o];var l=new u(a,s);l.left=f(e,t,r,o);l.right=f(e,t,o+1,i);return l}return null}function m(e,t){var r=new u(null,null);var i=r;for(var n=0;n<e.length;n++)i=i.next=new u(e[n],t[n]);i.next=null;return r.next}function r(e){var t=e;var r=[];var i=false;var n=new u(null,null);var o=n;while(!i)if(t){r.push(t);t=t.left}else if(r.length>0){t=o=o.next=r.pop();t=t.right}else i=true;o.next=null;return n.next}function g(e,t,r){var i=r-t;if(i>0){var n=t+Math.floor(i/2);var o=g(e,t,n);var a=e.head;a.left=o;e.head=e.head.next;a.right=g(e,n+1,r);return a}return null}function y(e,t,r){var i=new u(null,null);var n=i;var o=e;var a=t;while(o!==null&&a!==null){if(r(o.key,a.key)<0){n.next=o;o=o.next}else{n.next=a;a=a.next}n=n.next}if(o!==null)n.next=o;else if(a!==null)n.next=a;return i.next}function v(e,t,r,i,n){if(r>=i)return;var o=e[r+i>>1];var a=r-1;var s=i+1;while(true){do{a++}while(n(e[a],o)<0);do{s--}while(n(e[s],o)>0);if(a>=s)break;var l=e[a];e[a]=e[s];e[s]=l;l=t[a];t[a]=t[s];t[s]=l}v(e,t,r,s,n);v(e,t,s+1,i,n)}var _=function e(t,r){return t.ll.x<=r.x&&r.x<=t.ur.x&&t.ll.y<=r.y&&r.y<=t.ur.y},R=function e(t,r){if(r.ur.x<t.ll.x||t.ur.x<r.ll.x||r.ur.y<t.ll.y||t.ur.y<r.ll.y)return null;var i=t.ll.x<r.ll.x?r.ll.x:t.ll.x;var n=t.ur.x<r.ur.x?t.ur.x:r.ur.x;var o=t.ll.y<r.ll.y?r.ll.y:t.ll.y;var a=t.ur.y<r.ur.y?t.ur.y:r.ur.y;return{ll:{x:i,y:o},ur:{x:n,y:a}}},n=Number.EPSILON;if(n===undefined)n=Math.pow(2,-52);var P=n*n,b=function e(t,r){if(-n<t&&t<n)if(-n<r&&r<n)return 0;var i=t-r;if(i*i<P*t*r)return 0;return t<r?-1:1},e=function(){function e(){c(this,e);this.reset()}a(e,[{key:"reset",value:function e(){this.xRounder=new o;this.yRounder=new o}},{key:"round",value:function e(t,r){return{x:this.xRounder.round(t),y:this.yRounder.round(r)}}}]);return e}(),o=function(){function e(){c(this,e);this.tree=new M;this.round(0)}a(e,[{key:"round",value:function e(t){var r=this.tree.add(t);var i=this.tree.prev(r);if(i!==null&&b(r.key,i.key)===0){this.tree.remove(t);return i.key}var n=this.tree.next(r);if(n!==null&&b(r.key,n.key)===0){this.tree.remove(t);return n.key}return t}}]);return e}(),O=new e,w=function e(t,r){return t.x*r.y-t.y*r.x},x=function e(t,r){return t.x*r.x+t.y*r.y},C=function e(t,r,i){var n={x:r.x-t.x,y:r.y-t.y};var o={x:i.x-t.x,y:i.y-t.y};var a=w(n,o);return b(a,0)},T=function e(t){return Math.sqrt(x(t,t))},B=function e(t,r,i){var n={x:r.x-t.x,y:r.y-t.y};var o={x:i.x-t.x,y:i.y-t.y};return w(o,n)/T(o)/T(n)},F=function e(t,r,i){var n={x:r.x-t.x,y:r.y-t.y};var o={x:i.x-t.x,y:i.y-t.y};return x(o,n)/T(o)/T(n)},S=function e(t,r,i){if(r.y===0)return null;return{x:t.x+r.x/r.y*(i-t.y),y:i}},E=function e(t,r,i){if(r.x===0)return null;return{x:i,y:t.y+r.y/r.x*(i-t.x)}},U=function e(t,r,i,n){if(r.x===0)return E(i,n,t.x);if(n.x===0)return E(t,r,i.x);if(r.y===0)return S(i,n,t.y);if(n.y===0)return S(t,r,i.y);var o=w(r,n);if(o==0)return null;var a={x:i.x-t.x,y:i.y-t.y};var s=w(a,r)/o;var l=w(a,n)/o;var c=t.x+l*r.x,u=i.x+s*n.x;var h=t.y+l*r.y,d=i.y+s*n.y;var p=(c+u)/2;var f=(h+d)/2;return{x:p,y:f}},L=function(){a(n,null,[{key:"compare",value:function e(t,r){var i=n.comparePoints(t.point,r.point);if(i!==0)return i;if(t.point!==r.point)t.link(r);if(t.isLeft!==r.isLeft)return t.isLeft?1:-1;return I.compare(t.segment,r.segment)}},{key:"comparePoints",value:function e(t,r){if(t.x<r.x)return-1;if(t.x>r.x)return 1;if(t.y<r.y)return-1;if(t.y>r.y)return 1;return 0}}]);function n(e,t){c(this,n);if(e.events===undefined)e.events=[this];else e.events.push(this);this.point=e;this.isLeft=t}a(n,[{key:"link",value:function e(t){if(t.point===this.point)throw new Error("Tried to link already linked events");var r=t.point.events;for(var i=0,n=r.length;i<n;i++){var o=r[i];this.point.events.push(o);o.point=this.point}this.checkForConsuming()}},{key:"checkForConsuming",value:function e(){var t=this.point.events.length;for(var r=0;r<t;r++){var i=this.point.events[r];if(i.segment.consumedBy!==undefined)continue;for(var n=r+1;n<t;n++){var o=this.point.events[n];if(o.consumedBy!==undefined)continue;if(i.otherSE.point.events!==o.otherSE.point.events)continue;i.segment.consume(o.segment)}}}},{key:"getAvailableLinkedEvents",value:function e(){var t=[];for(var r=0,i=this.point.events.length;r<i;r++){var n=this.point.events[r];if(n!==this&&!n.segment.ringOut&&n.segment.isInResult())t.push(n)}return t}},{key:"getLeftmostComparator",value:function e(i){var n=this;var l=new Map;var c=function e(t){var r=t.otherSE;l.set(t,{sine:B(n.point,i.point,r.point),cosine:F(n.point,i.point,r.point)})};return function(e,t){if(!l.has(e))c(e);if(!l.has(t))c(t);var r=l.get(e),i=r.sine,n=r.cosine;var o=l.get(t),a=o.sine,s=o.cosine;if(i>=0&&a>=0){if(n<s)return 1;if(n>s)return-1;return 0}if(i<0&&a<0){if(n<s)return-1;if(n>s)return 1;return 0}if(a<i)return-1;if(a>i)return 1;return 0}}}]);return n}(),q=0,I=function(){a(d,null,[{key:"compare",value:function e(t,r){var i=t.leftSE.point.x;var n=r.leftSE.point.x;var o=t.rightSE.point.x;var a=r.rightSE.point.x;if(a<i)return 1;if(o<n)return-1;var s=t.leftSE.point.y;var l=r.leftSE.point.y;var c=t.rightSE.point.y;var u=r.rightSE.point.y;if(i<n){if(l<s&&l<c)return 1;if(l>s&&l>c)return-1;var h=t.comparePoint(r.leftSE.point);if(h<0)return 1;if(h>0)return-1;var d=r.comparePoint(t.rightSE.point);if(d!==0)return d;return-1}if(i>n){if(s<l&&s<u)return-1;if(s>l&&s>u)return 1;var p=r.comparePoint(t.leftSE.point);if(p!==0)return p;var f=t.comparePoint(r.rightSE.point);if(f<0)return 1;if(f>0)return-1;return 1}if(s<l)return-1;if(s>l)return 1;if(o<a){var m=r.comparePoint(t.rightSE.point);if(m!==0)return m}if(o>a){var g=t.comparePoint(r.rightSE.point);if(g<0)return 1;if(g>0)return-1}if(o!==a){var y=c-s;var v=o-i;var _=u-l;var b=a-n;if(y>v&&_<b)return 1;if(y<v&&_>b)return-1}if(o>a)return 1;if(o<a)return-1;if(c<u)return-1;if(c>u)return 1;if(t.id<r.id)return-1;if(t.id>r.id)return 1;return 0}}]);function d(e,t,r,i){c(this,d);this.id=++q;this.leftSE=e;e.segment=this;e.otherSE=t;this.rightSE=t;t.segment=this;t.otherSE=e;this.rings=r;this.windings=i}a(d,[{key:"replaceRightSE",value:function e(t){this.rightSE=t;this.rightSE.segment=this;this.rightSE.otherSE=this.leftSE;this.leftSE.otherSE=this.rightSE}},{key:"bbox",value:function e(){var t=this.leftSE.point.y;var r=this.rightSE.point.y;return{ll:{x:this.leftSE.point.x,y:t<r?t:r},ur:{x:this.rightSE.point.x,y:t>r?t:r}}}},{key:"vector",value:function e(){return{x:this.rightSE.point.x-this.leftSE.point.x,y:this.rightSE.point.y-this.leftSE.point.y}}},{key:"isAnEndpoint",value:function e(t){return t.x===this.leftSE.point.x&&t.y===this.leftSE.point.y||t.x===this.rightSE.point.x&&t.y===this.rightSE.point.y}},{key:"comparePoint",value:function e(t){if(this.isAnEndpoint(t))return 0;var r=this.leftSE.point;var i=this.rightSE.point;var n=this.vector();if(r.x===i.x){if(t.x===r.x)return 0;return t.x<r.x?1:-1}var o=(t.y-r.y)/n.y;var a=r.x+o*n.x;if(t.x===a)return 0;var s=(t.x-r.x)/n.x;var l=r.y+s*n.y;if(t.y===l)return 0;return t.y<l?-1:1}},{key:"getIntersection",value:function e(t){var r=this.bbox();var i=t.bbox();var n=R(r,i);if(n===null)return null;var o=this.leftSE.point;var a=this.rightSE.point;var s=t.leftSE.point;var l=t.rightSE.point;var c=_(r,s)&&this.comparePoint(s)===0;var u=_(i,o)&&t.comparePoint(o)===0;var h=_(r,l)&&this.comparePoint(l)===0;var d=_(i,a)&&t.comparePoint(a)===0;if(u&&c){if(d&&!h)return a;if(!d&&h)return l;return null}if(u){if(h)if(o.x===l.x&&o.y===l.y)return null;return o}if(c){if(d)if(a.x===s.x&&a.y===s.y)return null;return s}if(d&&h)return null;if(d)return a;if(h)return l;var p=U(o,this.vector(),s,t.vector());if(p===null)return null;if(!_(n,p))return null;return O.round(p.x,p.y)}},{key:"split",value:function e(t){var r=[];var i=t.events!==undefined;var n=new L(t,true);var o=new L(t,false);var a=this.rightSE;this.replaceRightSE(o);r.push(o);r.push(n);var s=new d(n,a,this.rings.slice(),this.windings.slice());if(L.comparePoints(s.leftSE.point,s.rightSE.point)>0)s.swapEvents();if(L.comparePoints(this.leftSE.point,this.rightSE.point)>0)this.swapEvents();if(i){n.checkForConsuming();o.checkForConsuming()}return r}},{key:"swapEvents",value:function e(){var t=this.rightSE;this.rightSE=this.leftSE;this.leftSE=t;this.leftSE.isLeft=true;this.rightSE.isLeft=false;for(var r=0,i=this.windings.length;r<i;r++)this.windings[r]*=-1}},{key:"consume",value:function e(t){var r=this;var i=t;while(r.consumedBy)r=r.consumedBy;while(i.consumedBy)i=i.consumedBy;var n=d.compare(r,i);if(n===0)return;if(n>0){var o=r;r=i;i=o}if(r.prev===i){var a=r;r=i;i=a}for(var s=0,l=i.rings.length;s<l;s++){var c=i.rings[s];var u=i.windings[s];var h=r.rings.indexOf(c);if(h===-1){r.rings.push(c);r.windings.push(u)}else r.windings[h]+=u}i.rings=null;i.windings=null;i.consumedBy=r;i.leftSE.consumedBy=r.leftSE;i.rightSE.consumedBy=r.rightSE}},{key:"prevInResult",value:function e(){if(this._prevInResult!==undefined)return this._prevInResult;if(!this.prev)this._prevInResult=null;else if(this.prev.isInResult())this._prevInResult=this.prev;else this._prevInResult=this.prev.prevInResult();return this._prevInResult}},{key:"beforeState",value:function e(){if(this._beforeState!==undefined)return this._beforeState;if(!this.prev)this._beforeState={rings:[],windings:[],multiPolys:[]};else{var t=this.prev.consumedBy||this.prev;this._beforeState=t.afterState()}return this._beforeState}},{key:"afterState",value:function e(){if(this._afterState!==undefined)return this._afterState;var t=this.beforeState();this._afterState={rings:t.rings.slice(0),windings:t.windings.slice(0),multiPolys:[]};var r=this._afterState.rings;var i=this._afterState.windings;var n=this._afterState.multiPolys;for(var o=0,a=this.rings.length;o<a;o++){var s=this.rings[o];var l=this.windings[o];var c=r.indexOf(s);if(c===-1){r.push(s);i.push(l)}else i[c]+=l}var u=[];var h=[];for(var d=0,p=r.length;d<p;d++){if(i[d]===0)continue;var f=r[d];var m=f.poly;if(h.indexOf(m)!==-1)continue;if(f.isExterior)u.push(m);else{if(h.indexOf(m)===-1)h.push(m);var g=u.indexOf(f.poly);if(g!==-1)u.splice(g,1)}}for(var y=0,v=u.length;y<v;y++){var _=u[y].multiPoly;if(n.indexOf(_)===-1)n.push(_)}return this._afterState}},{key:"isInResult",value:function e(){if(this.consumedBy)return false;if(this._isInResult!==undefined)return this._isInResult;var t=this.beforeState().multiPolys;var r=this.afterState().multiPolys;switch(N.type){case"union":{var i=t.length===0;var n=r.length===0;this._isInResult=i!==n;break}case"intersection":{var o;var a;if(t.length<r.length){o=t.length;a=r.length}else{o=r.length;a=t.length}this._isInResult=a===N.numMultiPolys&&o<a;break}case"xor":{var s=Math.abs(t.length-r.length);this._isInResult=s%2===1;break}case"difference":{var l=function e(t){return t.length===1&&t[0].isSubject};this._isInResult=l(t)!==l(r);break}default:throw new Error("Unrecognized operation type found ".concat(N.type))}return this._isInResult}}],[{key:"fromRing",value:function e(t,r,i){var n,o,a;var s=L.comparePoints(t,r);if(s<0){n=t;o=r;a=1}else if(s>0){n=r;o=t;a=-1}else throw new Error("Tried to create degenerate segment at [".concat(t.x,", ").concat(t.y,"]"));var l=new L(n,true);var c=new L(o,false);return new d(l,c,[i],[a])}}]);return d}(),A=function(){function l(e,t,r){c(this,l);if(!Array.isArray(e)||e.length===0)throw new Error("Input geometry is not a valid Polygon or MultiPolygon");this.poly=t;this.isExterior=r;this.segments=[];if(typeof e[0][0]!=="number"||typeof e[0][1]!=="number")throw new Error("Input geometry is not a valid Polygon or MultiPolygon");var i=O.round(e[0][0],e[0][1]);this.bbox={ll:{x:i.x,y:i.y},ur:{x:i.x,y:i.y}};var n=i;for(var o=1,a=e.length;o<a;o++){if(typeof e[o][0]!=="number"||typeof e[o][1]!=="number")throw new Error("Input geometry is not a valid Polygon or MultiPolygon");var s=O.round(e[o][0],e[o][1]);if(s.x===n.x&&s.y===n.y)continue;this.segments.push(I.fromRing(n,s,this));if(s.x<this.bbox.ll.x)this.bbox.ll.x=s.x;if(s.y<this.bbox.ll.y)this.bbox.ll.y=s.y;if(s.x>this.bbox.ur.x)this.bbox.ur.x=s.x;if(s.y>this.bbox.ur.y)this.bbox.ur.y=s.y;n=s}if(i.x!==n.x||i.y!==n.y)this.segments.push(I.fromRing(n,i,this))}a(l,[{key:"getSweepEvents",value:function e(){var t=[];for(var r=0,i=this.segments.length;r<i;r++){var n=this.segments[r];t.push(n.leftSE);t.push(n.rightSE)}return t}}]);return l}(),j=function(){function o(e,t){c(this,o);if(!Array.isArray(e))throw new Error("Input geometry is not a valid Polygon or MultiPolygon");this.exteriorRing=new A(e[0],this,true);this.bbox={ll:{x:this.exteriorRing.bbox.ll.x,y:this.exteriorRing.bbox.ll.y},ur:{x:this.exteriorRing.bbox.ur.x,y:this.exteriorRing.bbox.ur.y}};this.interiorRings=[];for(var r=1,i=e.length;r<i;r++){var n=new A(e[r],this,false);if(n.bbox.ll.x<this.bbox.ll.x)this.bbox.ll.x=n.bbox.ll.x;if(n.bbox.ll.y<this.bbox.ll.y)this.bbox.ll.y=n.bbox.ll.y;if(n.bbox.ur.x>this.bbox.ur.x)this.bbox.ur.x=n.bbox.ur.x;if(n.bbox.ur.y>this.bbox.ur.y)this.bbox.ur.y=n.bbox.ur.y;this.interiorRings.push(n)}this.multiPoly=t}a(o,[{key:"getSweepEvents",value:function e(){var t=this.exteriorRing.getSweepEvents();for(var r=0,i=this.interiorRings.length;r<i;r++){var n=this.interiorRings[r].getSweepEvents();for(var o=0,a=n.length;o<a;o++)t.push(n[o])}return t}}]);return o}(),D=function(){function o(e,t){c(this,o);if(!Array.isArray(e))throw new Error("Input geometry is not a valid Polygon or MultiPolygon");try{if(typeof e[0][0][0]==="number")e=[e]}catch(e){}this.polys=[];this.bbox={ll:{x:Number.POSITIVE_INFINITY,y:Number.POSITIVE_INFINITY},ur:{x:Number.NEGATIVE_INFINITY,y:Number.NEGATIVE_INFINITY}};for(var r=0,i=e.length;r<i;r++){var n=new j(e[r],this);if(n.bbox.ll.x<this.bbox.ll.x)this.bbox.ll.x=n.bbox.ll.x;if(n.bbox.ll.y<this.bbox.ll.y)this.bbox.ll.y=n.bbox.ll.y;if(n.bbox.ur.x>this.bbox.ur.x)this.bbox.ur.x=n.bbox.ur.x;if(n.bbox.ur.y>this.bbox.ur.y)this.bbox.ur.y=n.bbox.ur.y;this.polys.push(n)}this.isSubject=t}a(o,[{key:"getSweepEvents",value:function e(){var t=[];for(var r=0,i=this.polys.length;r<i;r++){var n=this.polys[r].getSweepEvents();for(var o=0,a=n.length;o<a;o++)t.push(n[o])}return t}}]);return o}(),H=function(){a(w,null,[{key:"factory",value:function e(t){var r=[];for(var i=0,n=t.length;i<n;i++){var o=t[i];if(!o.isInResult()||o.ringOut)continue;var a=null;var s=o.leftSE;var l=o.rightSE;var c=[s];var u=s.point;var h=[];while(true){a=s;s=l;c.push(s);if(s.point===u)break;while(true){var d=s.getAvailableLinkedEvents();if(d.length===0){var p=c[0].point;var f=c[c.length-1].point;throw new Error("Unable to complete output ring starting at [".concat(p.x,",")+" ".concat(p.y,"]. Last matching segment found ends at")+" [".concat(f.x,", ").concat(f.y,"]."))}if(d.length===1){l=d[0].otherSE;break}var m=null;for(var g=0,y=h.length;g<y;g++)if(h[g].point===s.point){m=g;break}if(m!==null){var v=h.splice(m)[0];var _=c.splice(v.index);_.unshift(_[0].otherSE);r.push(new w(_.reverse()));continue}h.push({index:c.length,point:s.point});var b=s.getLeftmostComparator(a);l=d.sort(b)[0].otherSE;break}}r.push(new w(c))}return r}}]);function w(e){c(this,w);this.events=e;for(var t=0,r=e.length;t<r;t++)e[t].segment.ringOut=this;this.poly=null}a(w,[{key:"getGeom",value:function e(){var t=this.events[0].point;var r=[t];for(var i=1,n=this.events.length-1;i<n;i++){var o=this.events[i].point;var a=this.events[i+1].point;if(C(o,t,a)===0)continue;r.push(o);t=o}if(r.length===1)return null;var s=r[0];var l=r[1];if(C(s,t,l)===0)r.shift();r.push(r[0]);var c=this.isExteriorRing()?1:-1;var u=this.isExteriorRing()?0:r.length-1;var h=this.isExteriorRing()?r.length:-1;var d=[];for(var p=u;p!=h;p+=c)d.push([r[p].x,r[p].y]);return d}},{key:"isExteriorRing",value:function e(){if(this._isExteriorRing===undefined){var t=this.enclosingRing();this._isExteriorRing=t?!t.isExteriorRing():true}return this._isExteriorRing}},{key:"enclosingRing",value:function e(){if(this._enclosingRing===undefined)this._enclosingRing=this._calcEnclosingRing();return this._enclosingRing}},{key:"_calcEnclosingRing",value:function e(){var t=this.events[0];for(var r=1,i=this.events.length;r<i;r++){var n=this.events[r];if(L.compare(t,n)>0)t=n}var o=t.segment.prevInResult();var a=o?o.prevInResult():null;while(true){if(!o)return null;if(!a)return o.ringOut;if(a.ringOut!==o.ringOut)if(a.ringOut.enclosingRing()!==o.ringOut)return o.ringOut;else return o.ringOut.enclosingRing();o=a.prevInResult();a=o?o.prevInResult():null}}}]);return w}(),k=function(){function t(e){c(this,t);this.exteriorRing=e;e.poly=this;this.interiorRings=[]}a(t,[{key:"addInterior",value:function e(t){this.interiorRings.push(t);t.poly=this}},{key:"getGeom",value:function e(){var t=[this.exteriorRing.getGeom()];if(t[0]===null)return null;for(var r=0,i=this.interiorRings.length;r<i;r++){var n=this.interiorRings[r].getGeom();if(n===null)continue;t.push(n)}return t}}]);return t}(),V=function(){function t(e){c(this,t);this.rings=e;this.polys=this._composePolys(e)}a(t,[{key:"getGeom",value:function e(){var t=[];for(var r=0,i=this.polys.length;r<i;r++){var n=this.polys[r].getGeom();if(n===null)continue;t.push(n)}return t}},{key:"_composePolys",value:function e(t){var r=[];for(var i=0,n=t.length;i<n;i++){var o=t[i];if(o.poly)continue;if(o.isExteriorRing())r.push(new k(o));else{var a=o.enclosingRing();if(!a.poly)r.push(new k(a));a.poly.addInterior(o)}}return r}}]);return t}(),G=function(){function r(e){var t=arguments.length>1&&arguments[1]!==undefined?arguments[1]:I.compare;c(this,r);this.queue=e;this.tree=new M(t);this.segments=[]}a(r,[{key:"process",value:function e(t){var r=t.segment;var i=[];if(t.consumedBy){if(t.isLeft)this.queue.remove(t.otherSE);else this.tree.remove(r);return i}var n=t.isLeft?this.tree.insert(r):this.tree.find(r);if(!n)throw new Error("Unable to find segment #".concat(r.id," ")+"[".concat(r.leftSE.point.x,", ").concat(r.leftSE.point.y,"] -> ")+"[".concat(r.rightSE.point.x,", ").concat(r.rightSE.point.y,"] ")+"in SweepLine tree. Please submit a bug report.");var o=n;var a=n;var s=undefined;var l=undefined;while(s===undefined){o=this.tree.prev(o);if(o===null)s=null;else if(o.key.consumedBy===undefined)s=o.key}while(l===undefined){a=this.tree.next(a);if(a===null)l=null;else if(a.key.consumedBy===undefined)l=a.key}if(t.isLeft){var c=null;if(s){var u=s.getIntersection(r);if(u!==null){if(!r.isAnEndpoint(u))c=u;if(!s.isAnEndpoint(u)){var h=this._splitSafely(s,u);for(var d=0,p=h.length;d<p;d++)i.push(h[d])}}}var f=null;if(l){var m=l.getIntersection(r);if(m!==null){if(!r.isAnEndpoint(m))f=m;if(!l.isAnEndpoint(m)){var g=this._splitSafely(l,m);for(var y=0,v=g.length;y<v;y++)i.push(g[y])}}}if(c!==null||f!==null){var _=null;if(c===null)_=f;else if(f===null)_=c;else{var b=L.comparePoints(c,f);_=b<=0?c:f}this.queue.remove(r.rightSE);i.push(r.rightSE);var w=r.split(_);for(var x=0,C=w.length;x<C;x++)i.push(w[x])}if(i.length>0){this.tree.remove(r);i.push(t)}else{this.segments.push(r);r.prev=s}}else{if(s&&l){var T=s.getIntersection(l);if(T!==null){if(!s.isAnEndpoint(T)){var S=this._splitSafely(s,T);for(var E=0,I=S.length;E<I;E++)i.push(S[E])}if(!l.isAnEndpoint(T)){var A=this._splitSafely(l,T);for(var k=0,P=A.length;k<P;k++)i.push(A[k])}}}this.tree.remove(r)}return i}},{key:"_splitSafely",value:function e(t,r){this.tree.remove(t);var i=t.rightSE;this.queue.remove(i);var n=t.split(r);n.push(i);if(t.consumedBy===undefined)this.tree.insert(t);return n}}]);return r}(),z=typeof process!=="undefined"&&process.env.POLYGON_CLIPPING_MAX_QUEUE_SIZE||1e6,K=typeof process!=="undefined"&&process.env.POLYGON_CLIPPING_MAX_SWEEPLINE_SEGMENTS||1e6,Z,N=new(function(){function e(){c(this,e)}a(e,[{key:"run",value:function e(t,r,i){N.type=t;O.reset();var n=[new D(r,true)];for(var o=0,a=i.length;o<a;o++)n.push(new D(i[o],false));N.numMultiPolys=n.length;if(N.type==="difference"){var s=n[0];var l=1;while(l<n.length)if(R(n[l].bbox,s.bbox)!==null)l++;else n.splice(l,1)}if(N.type==="intersection")for(var c=0,u=n.length;c<u;c++){var h=n[c];for(var d=c+1,p=n.length;d<p;d++)if(R(h.bbox,n[d].bbox)===null)return[]}var f=new M(L.compare);for(var m=0,g=n.length;m<g;m++){var y=n[m].getSweepEvents();for(var v=0,_=y.length;v<_;v++){f.insert(y[v]);if(f.size>z)throw new Error("Infinite loop when putting segment endpoints in a priority queue "+"(queue size too big). Please file a bug report.")}}var b=new G(f);var w=f.size;var x=f.pop();while(x){var C=x.key;if(f.size===w){var T=C.segment;throw new Error("Unable to pop() ".concat(C.isLeft?"left":"right"," SweepEvent ")+"[".concat(C.point.x,", ").concat(C.point.y,"] from segment #").concat(T.id," ")+"[".concat(T.leftSE.point.x,", ").concat(T.leftSE.point.y,"] -> ")+"[".concat(T.rightSE.point.x,", ").concat(T.rightSE.point.y,"] from queue. ")+"Please file a bug report.")}if(f.size>z)throw new Error("Infinite loop when passing sweep line over endpoints "+"(queue size too big). Please file a bug report.");if(b.segments.length>K)throw new Error("Infinite loop when passing sweep line over endpoints "+"(too many sweep line segments). Please file a bug report.");var S=b.process(C);for(var E=0,I=S.length;E<I;E++){var A=S[E];if(A.consumedBy===undefined)f.insert(A)}w=f.size;x=f.pop()}O.reset();var k=H.factory(b.segments);var P=new V(k);return P.getGeom()}}]);return e}()),W,Y,$,X,J;return{union:function e(t){for(var r=arguments.length,i=new Array(r>1?r-1:0),n=1;n<r;n++)i[n-1]=arguments[n];return N.run("union",t,i)},intersection:function e(t){for(var r=arguments.length,i=new Array(r>1?r-1:0),n=1;n<r;n++)i[n-1]=arguments[n];return N.run("intersection",t,i)},xor:function e(t){for(var r=arguments.length,i=new Array(r>1?r-1:0),n=1;n<r;n++)i[n-1]=arguments[n];return N.run("xor",t,i)},difference:function e(t){for(var r=arguments.length,i=new Array(r>1?r-1:0),n=1;n<r;n++)i[n-1]=arguments[n];return N.run("difference",t,i)}}}());function wm(e,t,r){void 0===r&&(r={});var e=_m(e),t=_m(t),e=bm.intersection(e.coordinates,t.coordinates);if(0===e.length)return null;if(1!==e.length)return t=r.properties,vm({type:"MultiPolygon",coordinates:e},t,i=void 0===i?{}:i);var t=e[0],i=r.properties,e=void 0;void 0===e&&(e={});for(var n=0,o=t;n<o.length;n++){var a=o[n];if(a.length<4)throw new Error("Each LinearRing of a Polygon must have 4 or more Positions.");for(var s=0;s<a[a.length-1].length;s++)if(a[a.length-1][s]!==a[0][s])throw new Error("First and last Position are not equivalent.")}return vm({type:"Polygon",coordinates:t},i,e)}var xm,ai=window&&window.__decorate||function(e,t,r,i){var n,o=arguments.length,a=o<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,r):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,r,i);else for(var s=e.length-1;0<=s;s--)(n=e[s])&&(a=(o<3?n(a):3<o?n(t,r,a):n(t,r))||a);return 3<o&&a&&Object.defineProperty(t,r,a),a},Cm=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},Tm=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},Sm=["DIV","SPAN","A"],Em=["data-azure-maps-attribution-minzoom","data-azure-maps-attribution-maxzoom","data-azure-maps-attribution-geometry","data-azure-maps-attribution-tileset","data-azure-maps-attribution-order","data-azure-maps-attribution-dynamic"],Im=Tm(["href"],Cm(Em),!1),Am=(km.prototype.equals=function(e){return this.stringRepresentation===e.stringRepresentation},Object.defineProperty(km.prototype,"stringRepresentation",{get:function(){return[void 0!==this.minZoom?"minzoom=".concat(this.minZoom):"",void 0!==this.maxZoom?"maxzoom=".concat(this.maxZoom):"",void 0!==this.geometry?this.element.attributes.getNamedItem("data-azure-maps-attribution-geometry").value:"",void 0!==this.tilesetId?"tilesetId=".concat(this.tilesetId):"",this.dynamic?"dynamic":""].filter(function(e){return 0<e.length}).join(";")},enumerable:!1,configurable:!0}),km.applicable=function(e){return Array.from(e.attributes).map(function(e){return Em.includes(e.name)}).reduce(function(e,t){return e||t},!1)},Object.defineProperty(km.prototype,"minZoom",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-minzoom");return e&&!isNaN(e.value)?parseInt(e.value):void 0},enumerable:!1,configurable:!0}),Object.defineProperty(km.prototype,"maxZoom",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-maxzoom");return e&&!isNaN(e.value)?parseInt(e.value):void 0},enumerable:!1,configurable:!0}),Object.defineProperty(km.prototype,"geometry",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-geometry");if(e&&e.value)try{return JSON.parse(e.value)}catch(e){}},enumerable:!1,configurable:!0}),Object.defineProperty(km.prototype,"tilesetId",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-tileset");return e&&e.value?e.value:void 0},enumerable:!1,configurable:!0}),Object.defineProperty(km.prototype,"order",{get:function(){var e=this.element.attributes.getNamedItem("data-azure-maps-attribution-order");return e&&!isNaN(e.value)?parseInt(e.value):void 0},enumerable:!1,configurable:!0}),Object.defineProperty(km.prototype,"dynamic",{get:function(){return null!==this.element.attributes.getNamedItem("data-azure-maps-attribution-dynamic")},enumerable:!1,configurable:!0}),Object.defineProperty(km.prototype,"hidesElement",{get:function(){return"none"==this.element.style.display},enumerable:!1,configurable:!0}),km.prototype.forceHide=function(){this.element.style.display="none"},km.prototype.satisfied=function(e){var t=!this.minZoom||!e.zoom||e.zoom>=this.minZoom,r=!this.maxZoom||!e.zoom||e.zoom<=this.maxZoom,i=!0;return this.geometry&&e.bounds&&(i=null!==wm({type:"Feature",geometry:this.geometry,properties:{}},{type:"Feature",geometry:{type:"Polygon",coordinates:[[f.getNorthWest(e.bounds),f.getNorthEast(e.bounds),f.getSouthEast(e.bounds),f.getSouthWest(e.bounds),f.getNorthWest(e.bounds)]]},properties:{}})),t&&r&&i},km.prototype.apply=function(t,e){var r=this,i=(void 0===e&&(e=null),this.satisfied(t.getCamera())),n=this.dynamic&&this.tilesetId,o=this.hidesElement,e=e&&["dragend","zoomend","pitchend"].includes(e.type);return i||o?i&&(o||n)&&(i&&o&&this.element.style.removeProperty("display"),n)&&(e?t.events.addOnce("idle",function(e){return r.fetchAndApplyDynamicAttribution(t)}):this.fetchAndApplyDynamicAttribution(t)):this.element.style.display="none",i===o},km.prototype.fetchAndApplyDynamicAttribution=function(i){var t,r,e,n=this,o=i.getCamera();this.lastFetchState&&f.containsBoundingBox(this.lastFetchState.bounds,o.bounds)&&Math.floor(this.lastFetchState.zoom)==Math.floor(o.zoom)||(t=Gc(o.center,f.getSouthWest(o.bounds),km.viewportBufferExpansionRatio),e=((r=Gc(o.center,f.getNorthEast(o.bounds),km.viewportBufferExpansionRatio))[0]<t[0]?[[t[0],t[1],180,r[1]],[-180,t[1],r[0],r[1]]]:[[t[0],t[1],r[0],r[1]]]).map(function(e){var e=new URLSearchParams({"api-version":"2.1",tilesetId:n.tilesetId,zoom:void 0!==o.zoom?"".concat(Math.floor(o.zoom)):void 0,bounds:e.join(",")}),t="".concat("https://{{azMapsDomain}}","/map/attribution"),r={url:t,headers:{}},t=(i._substituteDomainLanguageViewAndSignInRequest(t,r),"".concat(r.url).concat(r.url.includes("?")?"&":"?").concat(e.toString()));return i._sendRequest(t,"Attribution",r.headers).then(function(e){return e.json()})}),Promise.all(e).then(function(e){n.applyAttributionResponse(e),n.lastFetchState={bounds:new f([t[0],t[1],r[0],r[1]]),zoom:o.zoom}}).catch(function(e){return console.error(e)}))},km.prototype.applyAttributionResponse=function(e){var t,r,i,n=this,e=e.map(function(e){return e.copyrights||[]}).reduce(function(e,t){return Tm(Tm([],Cm(e),!1),Cm(t),!1)},[]);0!=e.length&&(null===(e=Yp.parseWithFilter(e.join(""),function(e){return!0},function(e){return e},function(){return n.element.innerHTML="",n.element}))?console.warn("Dynamic attribution is empty after filtering"):(t="string"==typeof e?((t=document.createElement("span")).innerHTML=e,t):e,i=t===this.element?(r=document.createElement("span"),Array.from(this.element.childNodes).forEach(function(e){return r.appendChild(e)}),r):t,Array.from(this.element.attributes).filter(function(e){return Em.includes(e.name)}).forEach(function(e){return i.attributes.setNamedItem(e.cloneNode())}),i.style.display=this.element.style.display,e=this.element.parentElement,this.element.remove(),e.append(i),this.element=i,this.attributionChangeCallback(this)))},km.viewportBufferExpansionRatio=2,ai([(xm=1e3,function(e,t,r){var i=r.value,n=new Map;return r.value=function(){var e=this,t=arguments;!n.get(e)&&1&&(i.apply(e,t),n.set(e,!0),setTimeout(function(){return n.delete(e)},xm))},r})],km.prototype,"fetchAndApplyDynamicAttribution",null),km);function km(e,t){var r=this;this.lastFetchState={bounds:null,zoom:null},this.getElement=function(){return r.element},this.element=e,this.attributionChangeCallback=t}var Pm=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},Mm=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},Rm=[/all rights reserved/gi],Om=(Lm.prototype.addToMap=function(){this.map.events.add("stylechanged",this.loadAttributionOnceSourcesLoaded),this.map.events.add("dragend",this.applyRules),this.map.events.add("zoomend",this.applyRules),this.map.events.add("pitchend",this.applyRules)},Lm.prototype.removeFromMap=function(){this.map.events.remove("stylechanged",this.loadAttributionOnceSourcesLoaded),this.map.events.remove("dragend",this.applyRules),this.map.events.remove("zoomend",this.applyRules),this.map.events.remove("pitchend",this.applyRules)},Lm.prototype.getDefaultAttribution=function(){return this.copyrightControl.getDefaultAttributions().map(function(e){return e=e,(t=document.createElement("a")).textContent=e,t;var t})},Lm);function Lm(e,t,r){var i,s=this;this.rules=[],this.virtualContext=((i=document.createElement("span")).className="azure-map-copyright-context",i),this.renderContext=this.virtualContext.cloneNode(!1),this.addAttributionFromSource=function(e){},this.removeAttributionFromSource=function(e){},this.getMapStyleVisibleSources=function(){var t=s.map._getMap(),r=t.getStyle();return Object.entries(r.sources).filter(function(e){var t=Pm(e,1)[0];return r.layers.filter(function(e){return e&&e.source==t}).reduce(function(e,t){return!(t.layout&&"none"===t.layout.visibility||t.paint&&0===t.paint["icon-opacity"]&&0===t.paint["text-opacity"])||e},!1)}).map(function(e){e=Pm(e,1)[0];return t.getSource(e)})},this.loadAttributionOnceSourcesLoaded=function(){var e=s.getMapStyleVisibleSources();Promise.all(e.map(function(o){return new Promise(function(r,i){var n;"tiles"in o||"geojson"===(null==o?void 0:o.type)?r(o):((n=o).on("data",function e(t){"metadata"==t.sourceDataType&&(n.off("data",e),r(o))}),n.on("error",function e(t){n.off("error",e),i(t)}))}).then(function(e){return{status:"fulfilled",value:e}}).catch(function(e){return{status:"rejected",reason:e}})})).then(function(e){s.reloadAttribution()})},this.reloadAttribution=function(){var e=s.getMapStyleVisibleSources(),i=new Set,n={},e=e.filter(function(e){return"attribution"in e&&e.attribution&&"tiles"in e&&e.tiles instanceof Array&&0<e.tiles.length}).map(function(e){return Yp.parseWithFilter(null!=(e=e.attribution)?e:"",function(e){return Sm.includes(e.tagName)&&Array.from(e.attributes).map(function(e){return Im.includes(e.name)}).reduce(function(e,t){return e&&t},!0)},function(e){var t,r=null;return e instanceof HTMLElement&&Am.applicable(e)&&(r=new Am(e,function(){return s.renderAttribution()}),i.add(r),void 0!==r.order)&&(e.style.order="".concat(r.order)),r&&e instanceof HTMLElement&&(!((t=r.stringRepresentation)in n)||void 0!==r.order&&void 0!==n[t].order&&r.order<n[t].order||void 0!==r.order&&void 0===n[t].order)&&(n[t]=r),e},function(){return document.createElement("span")})}),t=new Set(Object.values(n)),r=new Set(Mm([],Pm(i),!1).filter(function(e){return!t.has(e)})),o=new Set(Mm([],Pm(r),!1).map(function(e){return e.getElement()})),r=(Mm([],Pm(o),!1).filter(function(e){return null!==e.parentElement}).forEach(function(e){return e.parentElement.removeChild(e)}),s.rules=Object.values(n),e.filter(function(e){return"string"==typeof e||!o.has(e)}).map(function(e){return"string"==typeof e?new Text(e):e})),a=document.createElement("span");0<r.length?r.forEach(function(e){return a.appendChild(e)}):s.getDefaultAttribution().forEach(function(e){return a.appendChild(e)}),s.virtualContext=a,s.copyrightControl.setOptions({copyrightContent:s.renderContext}),s.applyRules(),s.renderAttribution()},this.applyRules=function(r){void 0===r&&(r=null),s.rules.reduce(function(e,t){t=t.apply(s.map,r);return e||t},!1)&&s.renderAttribution()},this.renderAttribution=function(){var t=function(e){return Array.from("none"!=e.style.display?e.children:[]).map(function(e){return t(e)}).reduce(function(e,t){return Mm(Mm([],Pm(e),!1),Pm(t),!1)},Array.from("none"!=e.style.display?e.childNodes:[]).filter(function(e){return e.nodeType==e.TEXT_NODE}))},e=s.virtualContext.cloneNode(!0),r=t(e);r.forEach(function(e){return e.textContent=Mm([],Pm(Rm),!1).reduce(function(e,t){return e.replace(t,"").trim()},e.textContent)}),r.reduce(function(e,t){return e.has(t.textContent)?(t.textContent="",t.parentElement&&t.parentElement.removeChild(t)):e.add(t.textContent),e},new Set),s.renderContext.innerHTML="",Array.from(e.childNodes).forEach(function(e){return s.renderContext.appendChild(e)})},this.map=e,this.copyrightControl=t,this.options=r}var Dm=function(e,t){return(Dm=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)};function zm(e,t){function r(){this.constructor=e}Dm(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var v=function(){return(v=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)};function Nm(e,t){var r={};for(n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols)for(var i=0,n=Object.getOwnPropertySymbols(e);i<n.length;i++)t.indexOf(n[i])<0&&Object.prototype.propertyIsEnumerable.call(e,n[i])&&(r[n[i]]=e[n[i]]);return r}function _(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})}function b(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},e={next:t(0),throw:t(1),return:t(2)};return"function"==typeof Symbol&&(e[Symbol.iterator]=function(){return this}),e;function t(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}}function Bm(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a}(arguments[t]));return e}var Fm=function(e,t){return(Fm=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)};function Um(e,t){function r(){this.constructor=e}Fm(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var qm=function(){return(qm=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)};function w(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})}function x(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},e={next:t(0),throw:t(1),return:t(2)};return"function"==typeof Symbol&&(e[Symbol.iterator]=function(){return this}),e;function t(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}}function jm(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;for(var i=Array(e),n=0,t=0;t<r;t++)for(var o=arguments[t],a=0,s=o.length;a<s;a++,n++)i[n]=o[a];return i}var Hm,Vm,Gm,c,Km,Zm,Wm,Ym,$m,Xm,C,Jm,Qm,eg,T={LIBRARY_NAME:"MSAL.JS",SKU:"msal.js.common",CACHE_PREFIX:"msal",DEFAULT_AUTHORITY:"https://login.microsoftonline.com/common/",DEFAULT_AUTHORITY_HOST:"login.microsoftonline.com",DEFAULT_COMMON_TENANT:"common",ADFS:"adfs",DSTS:"dstsv2",AAD_INSTANCE_DISCOVERY_ENDPT:"https://login.microsoftonline.com/common/discovery/instance?api-version=1.1&authorization_endpoint=",CIAM_AUTH_URL:".ciamlogin.com",AAD_TENANT_DOMAIN_SUFFIX:".onmicrosoft.com",RESOURCE_DELIM:"|",NO_ACCOUNT:"NO_ACCOUNT",CLAIMS:"claims",CONSUMER_UTID:"9188040d-6c67-4c5b-b112-36a304b66dad",OPENID_SCOPE:"openid",PROFILE_SCOPE:"profile",OFFLINE_ACCESS_SCOPE:"offline_access",EMAIL_SCOPE:"email",CODE_RESPONSE_TYPE:"code",CODE_GRANT_TYPE:"authorization_code",RT_GRANT_TYPE:"refresh_token",FRAGMENT_RESPONSE_MODE:"fragment",S256_CODE_CHALLENGE_METHOD:"S256",URL_FORM_CONTENT_TYPE:"application/x-www-form-urlencoded;charset=utf-8",AUTHORIZATION_PENDING:"authorization_pending",NOT_DEFINED:"not_defined",EMPTY_STRING:"",NOT_APPLICABLE:"N/A",FORWARD_SLASH:"/",IMDS_ENDPOINT:"http://169.254.169.254/metadata/instance/compute/location",IMDS_VERSION:"2020-06-01",IMDS_TIMEOUT:2e3,AZURE_REGION_AUTO_DISCOVER_FLAG:"TryAutoDetect",REGIONAL_AUTH_PUBLIC_CLOUD_SUFFIX:"login.microsoft.com",REGIONAL_AUTH_NON_MSI_QUERY_STRING:"allowestsrnonmsi=true",KNOWN_PUBLIC_CLOUDS:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"],TOKEN_RESPONSE_TYPE:"token",ID_TOKEN_RESPONSE_TYPE:"id_token",SHR_NONCE_VALIDITY:240,INVALID_INSTANCE:"invalid_instance"},tg=[T.OPENID_SCOPE,T.PROFILE_SCOPE,T.OFFLINE_ACCESS_SCOPE],rg=jm(tg,[T.EMAIL_SCOPE]),ig=((o=Hm=Hm||{}).CONTENT_TYPE="Content-Type",o.RETRY_AFTER="Retry-After",o.CCS_HEADER="X-AnchorMailbox",o.WWWAuthenticate="WWW-Authenticate",o.AuthenticationInfo="Authentication-Info",o.X_MS_REQUEST_ID="x-ms-request-id",o.X_MS_HTTP_VERSION="x-ms-httpver",(e=Vm=Vm||{}).ID_TOKEN="idtoken",e.CLIENT_INFO="client.info",e.ADAL_ID_TOKEN="adal.idtoken",e.ERROR="error",e.ERROR_DESC="error.description",e.ACTIVE_ACCOUNT="active-account",e.ACTIVE_ACCOUNT_FILTERS="active-account-filters",(qi=Gm=Gm||{}).COMMON="common",qi.ORGANIZATIONS="organizations",qi.CONSUMERS="consumers",(i=c=c||{}).CLIENT_ID="client_id",i.REDIRECT_URI="redirect_uri",i.RESPONSE_TYPE="response_type",i.RESPONSE_MODE="response_mode",i.GRANT_TYPE="grant_type",i.CLAIMS="claims",i.SCOPE="scope",i.ERROR="error",i.ERROR_DESCRIPTION="error_description",i.ACCESS_TOKEN="access_token",i.ID_TOKEN="id_token",i.REFRESH_TOKEN="refresh_token",i.EXPIRES_IN="expires_in",i.STATE="state",i.NONCE="nonce",i.PROMPT="prompt",i.SESSION_STATE="session_state",i.CLIENT_INFO="client_info",i.CODE="code",i.CODE_CHALLENGE="code_challenge",i.CODE_CHALLENGE_METHOD="code_challenge_method",i.CODE_VERIFIER="code_verifier",i.CLIENT_REQUEST_ID="client-request-id",i.X_CLIENT_SKU="x-client-SKU",i.X_CLIENT_VER="x-client-VER",i.X_CLIENT_OS="x-client-OS",i.X_CLIENT_CPU="x-client-CPU",i.X_CLIENT_CURR_TELEM="x-client-current-telemetry",i.X_CLIENT_LAST_TELEM="x-client-last-telemetry",i.X_MS_LIB_CAPABILITY="x-ms-lib-capability",i.X_APP_NAME="x-app-name",i.X_APP_VER="x-app-ver",i.POST_LOGOUT_URI="post_logout_redirect_uri",i.ID_TOKEN_HINT="id_token_hint",i.DEVICE_CODE="device_code",i.CLIENT_SECRET="client_secret",i.CLIENT_ASSERTION="client_assertion",i.CLIENT_ASSERTION_TYPE="client_assertion_type",i.TOKEN_TYPE="token_type",i.REQ_CNF="req_cnf",i.OBO_ASSERTION="assertion",i.REQUESTED_TOKEN_USE="requested_token_use",i.ON_BEHALF_OF="on_behalf_of",i.FOCI="foci",i.CCS_HEADER="X-AnchorMailbox",i.RETURN_SPA_CODE="return_spa_code",i.NATIVE_BROKER="nativebroker",i.LOGOUT_HINT="logout_hint",(we=Km=Km||{}).ACCESS_TOKEN="access_token",we.XMS_CC="xms_cc",{LOGIN:"login",SELECT_ACCOUNT:"select_account",CONSENT:"consent",NONE:"none",CREATE:"create",NO_SESSION:"no_session"}),ng=((Ro=Zm=Zm||{}).ACCOUNT="account",Ro.SID="sid",Ro.LOGIN_HINT="login_hint",Ro.ID_TOKEN="id_token",Ro.DOMAIN_HINT="domain_hint",Ro.ORGANIZATIONS="organizations",Ro.CONSUMERS="consumers",Ro.ACCOUNT_ID="accountIdentifier",Ro.HOMEACCOUNT_ID="homeAccountIdentifier",{PLAIN:"plain",S256:"S256"}),og=((Vt=Wm=Wm||{}).QUERY="query",Vt.FRAGMENT="fragment",Vt.FORM_POST="form_post",(r=Ym=Ym||{}).IMPLICIT_GRANT="implicit",r.AUTHORIZATION_CODE_GRANT="authorization_code",r.CLIENT_CREDENTIALS_GRANT="client_credentials",r.RESOURCE_OWNER_PASSWORD_GRANT="password",r.REFRESH_TOKEN_GRANT="refresh_token",r.DEVICE_CODE_GRANT="device_code",r.JWT_BEARER="urn:ietf:params:oauth:grant-type:jwt-bearer",(Br=$m=$m||{}).MSSTS_ACCOUNT_TYPE="MSSTS",Br.ADFS_ACCOUNT_TYPE="ADFS",Br.MSAV1_ACCOUNT_TYPE="MSA",Br.GENERIC_ACCOUNT_TYPE="Generic",(cn=Xm=Xm||{}).CACHE_KEY_SEPARATOR="-",cn.CLIENT_INFO_SEPARATOR=".",(a=C=C||{}).ID_TOKEN="IdToken",a.ACCESS_TOKEN="AccessToken",a.ACCESS_TOKEN_WITH_AUTH_SCHEME="AccessToken_With_AuthScheme",a.REFRESH_TOKEN="RefreshToken",(t=Jm=Jm||{})[t.ADFS=1001]="ADFS",t[t.MSA=1002]="MSA",t[t.MSSTS=1003]="MSSTS",t[t.GENERIC=1004]="GENERIC",t[t.ACCESS_TOKEN=2001]="ACCESS_TOKEN",t[t.REFRESH_TOKEN=2002]="REFRESH_TOKEN",t[t.ID_TOKEN=2003]="ID_TOKEN",t[t.APP_METADATA=3001]="APP_METADATA",t[t.UNDEFINED=9999]="UNDEFINED","appmetadata"),ag="authority-metadata",sg=86400,lg=((s=Qm=Qm||{}).CONFIG="config",s.CACHE="cache",s.NETWORK="network",s.HARDCODED_VALUES="hardcoded_values",{SCHEMA_VERSION:5,MAX_CUR_HEADER_BYTES:80,MAX_LAST_HEADER_BYTES:330,MAX_CACHED_ERRORS:50,CACHE_KEY:"server-telemetry",CATEGORY_SEPARATOR:"|",VALUE_SEPARATOR:",",OVERFLOW_TRUE:"1",OVERFLOW_FALSE:"0",UNKNOWN_ERROR:"unknown_error"});(n=eg=eg||{}).BEARER="Bearer",n.POP="pop",n.SSH="ssh-cert";var cg,ug,hg,dg,pg,fg,mg=60,gg=3600,yg="throttling",vg="retry-after, h429",_g="invalid_grant",bg="client_mismatch";(ai=cg=cg||{}).username="username",ai.password="password",(o=ug=ug||{})[o.httpSuccess=200]="httpSuccess",o[o.httpBadRequest=400]="httpBadRequest",(e=hg=hg||{}).FAILED_AUTO_DETECTION="1",e.INTERNAL_CACHE="2",e.ENVIRONMENT_VARIABLE="3",e.IMDS="4",(qi=dg=dg||{}).CONFIGURED_MATCHES_DETECTED="1",qi.CONFIGURED_NO_AUTO_DETECTION="2",qi.CONFIGURED_NOT_DETECTED="3",qi.AUTO_DETECTION_REQUESTED_SUCCESSFUL="4",qi.AUTO_DETECTION_REQUESTED_FAILED="5",(i=pg=pg||{}).NO_CACHE_HIT="0",i.FORCE_REFRESH="1",i.NO_CACHED_ACCESS_TOKEN="2",i.CACHED_ACCESS_TOKEN_EXPIRED="3",i.REFRESH_CACHED_ACCESS_TOKEN="4",i.CLAIMS_REQUESTED_CACHE_SKIPPED="5",(we=fg=fg||{}).Jwt="JWT",we.Jwk="JWK",we.Pop="pop";var wg,xg={code:"unexpected_error",desc:"Unexpected error in authentication."},Cg={code:"post_request_failed",desc:"Post request failed from the network, could be a 4xx/5xx or a network unavailability. Please check the exact error code for details."},S=(Um(Tg,wg=Error),Tg.prototype.setCorrelationId=function(e){this.correlationId=e},Tg.createUnexpectedError=function(e){return new Tg(xg.code,xg.desc+": "+e)},Tg.createPostRequestFailed=function(e){return new Tg(Cg.code,Cg.desc+": "+e)},Tg);function Tg(e,t,r){var i=this,i=wg.call(this,t?e+": "+t:e)||this;return Object.setPrototypeOf(i,Tg.prototype),i.errorCode=e||T.EMPTY_STRING,i.errorMessage=t||T.EMPTY_STRING,i.subError=r||T.EMPTY_STRING,i.name="AuthError",i}var Sg,Eg={createNewGuid:function(){throw S.createUnexpectedError("Crypto interface - createNewGuid() has not been implemented")},base64Decode:function(){throw S.createUnexpectedError("Crypto interface - base64Decode() has not been implemented")},base64Encode:function(){throw S.createUnexpectedError("Crypto interface - base64Encode() has not been implemented")},generatePkceCodes:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Crypto interface - generatePkceCodes() has not been implemented")})})},getPublicKeyThumbprint:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Crypto interface - getPublicKeyThumbprint() has not been implemented")})})},removeTokenBindingKey:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Crypto interface - removeTokenBindingKey() has not been implemented")})})},clearKeystore:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Crypto interface - clearKeystore() has not been implemented")})})},signJwt:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Crypto interface - signJwt() has not been implemented")})})},hashString:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Crypto interface - hashString() has not been implemented")})})}},Ig={code:"client_info_decoding_error",desc:"The client info could not be parsed/decoded correctly. Please review the trace to determine the root cause."},Ag={code:"client_info_empty_error",desc:"The client info was empty. Please review the trace to determine the root cause."},kg={code:"token_parsing_error",desc:"Token cannot be parsed. Please review stack trace to determine root cause."},Pg={code:"null_or_empty_token",desc:"The token is null or empty. Please review the trace to determine the root cause."},Mg={code:"endpoints_resolution_error",desc:"Error: could not resolve endpoints. Please check network and try again."},Rg={code:"network_error",desc:"Network request failed. Please check network trace to determine root cause."},Og={code:"openid_config_error",desc:"Could not retrieve endpoints. Check your authority and verify the .well-known/openid-configuration endpoint returns the required endpoints."},Lg={code:"hash_not_deserialized",desc:"The hash parameters could not be deserialized. Please review the trace to determine the root cause."},Dg={code:"invalid_state",desc:"State was not the expected format. Please check the logs to determine whether the request was sent using ProtocolUtils.setRequestState()."},zg={code:"state_mismatch",desc:"State mismatch error. Please check your network. Continued requests may cause cache overflow."},Ng={code:"state_not_found",desc:"State not found"},Bg={code:"nonce_mismatch",desc:"Nonce mismatch error. This may be caused by a race condition in concurrent requests."},Fg={code:"nonce_not_found",desc:"nonce not found"},Ug={code:"auth_time_not_found",desc:"Max Age was requested and the ID token is missing the auth_time variable. auth_time is an optional claim and is not enabled by default - it must be enabled. See https://aka.ms/msaljs/optional-claims for more information."},qg={code:"max_age_transpired",desc:"Max Age is set to 0, or too much time has elapsed since the last end-user authentication."},jg={code:"multiple_matching_tokens",desc:"The cache contains multiple tokens satisfying the requirements. Call AcquireToken again providing more requirements such as authority or account."},Hg={code:"multiple_matching_accounts",desc:"The cache contains multiple accounts satisfying the given parameters. Please pass more info to obtain the correct account"},Vg={code:"multiple_matching_appMetadata",desc:"The cache contains multiple appMetadata satisfying the given parameters. Please pass more info to obtain the correct appMetadata"},Gg={code:"request_cannot_be_made",desc:"Token request cannot be made without authorization code or refresh token."},Kg={code:"cannot_append_empty_scope",desc:"Cannot append null or empty scope to ScopeSet. Please check the stack trace for more info."},Zg={code:"cannot_remove_empty_scope",desc:"Cannot remove null or empty scope from ScopeSet. Please check the stack trace for more info."},Wg={code:"cannot_append_scopeset",desc:"Cannot append ScopeSet due to error."},Yg={code:"empty_input_scopeset",desc:"Empty input ScopeSet cannot be processed."},$g={code:"device_code_polling_cancelled",desc:"Caller has cancelled token endpoint polling during device code flow by setting DeviceCodeRequest.cancel = true."},Xg={code:"device_code_expired",desc:"Device code is expired."},Jg={code:"device_code_unknown_error",desc:"Device code stopped polling for unknown reasons."},Qg={code:"no_account_in_silent_request",desc:"Please pass an account object, silent flow is not supported without account information"},ey={code:"invalid_cache_record",desc:"Cache record object was null or undefined."},ty={code:"invalid_cache_environment",desc:"Invalid environment when attempting to create cache entry"},ry={code:"no_account_found",desc:"No account found in cache for given key."},iy={code:"no cache plugin set on CacheManager",desc:"ICachePlugin needs to be set before using readFromStorage or writeFromStorage"},ny={code:"no_crypto_object",desc:"No crypto object detected. This is required for the following operation: "},oy={code:"invalid_cache_type",desc:"Invalid cache type"},ay={code:"unexpected_account_type",desc:"Unexpected account type."},sy={code:"unexpected_credential_type",desc:"Unexpected credential type."},ly={code:"invalid_assertion",desc:"Client assertion must meet requirements described in https://tools.ietf.org/html/rfc7515"},cy={code:"invalid_client_credential",desc:"Client credential (secret, certificate, or assertion) must not be empty when creating a confidential client. An application should at most have one credential"},uy={code:"token_refresh_required",desc:"Cannot return token from cache because it must be refreshed. This may be due to one of the following reasons: forceRefresh parameter is set to true, claims have been requested, there is no cached access token or it is expired."},hy={code:"user_timeout_reached",desc:"User defined timeout for device code polling reached"},dy={code:"token_claims_cnf_required_for_signedjwt",desc:"Cannot generate a POP jwt if the token_claims are not populated"},py={code:"authorization_code_missing_from_server_response",desc:"Server response does not contain an authorization code to proceed"},fy={code:"binding_key_not_removed",desc:"Could not remove the credential's binding key from storage."},my={code:"end_session_endpoint_not_supported",desc:"Provided authority does not support logout."},gy={code:"key_id_missing",desc:"A keyId value is missing from the requested bound token's cache record and is required to match the token to it's stored binding key."},yy={code:"no_network_connectivity",desc:"No network connectivity. Check your internet connection."},vy={code:"user_canceled",desc:"User canceled the flow."},E=(Um(l,Sg=S),l.createClientInfoDecodingError=function(e){return new l(Ig.code,Ig.desc+" Failed with error: "+e)},l.createClientInfoEmptyError=function(){return new l(Ag.code,""+Ag.desc)},l.createTokenParsingError=function(e){return new l(kg.code,kg.desc+" Failed with error: "+e)},l.createTokenNullOrEmptyError=function(e){return new l(Pg.code,Pg.desc+" Raw Token Value: "+e)},l.createEndpointDiscoveryIncompleteError=function(e){return new l(Mg.code,Mg.desc+" Detail: "+e)},l.createNetworkError=function(e,t){return new l(Rg.code,Rg.desc+" | Fetch client threw: "+t+" | Attempted to reach: "+e.split("?")[0])},l.createUnableToGetOpenidConfigError=function(e){return new l(Og.code,Og.desc+" Attempted to retrieve endpoints from: "+e)},l.createHashNotDeserializedError=function(e){return new l(Lg.code,Lg.desc+" Given Object: "+e)},l.createInvalidStateError=function(e,t){return new l(Dg.code,Dg.desc+" Invalid State: "+e+", Root Err: "+t)},l.createStateMismatchError=function(){return new l(zg.code,zg.desc)},l.createStateNotFoundError=function(e){return new l(Ng.code,Ng.desc+":  "+e)},l.createNonceMismatchError=function(){return new l(Bg.code,Bg.desc)},l.createAuthTimeNotFoundError=function(){return new l(Ug.code,Ug.desc)},l.createMaxAgeTranspiredError=function(){return new l(qg.code,qg.desc)},l.createNonceNotFoundError=function(e){return new l(Fg.code,Fg.desc+":  "+e)},l.createMultipleMatchingTokensInCacheError=function(){return new l(jg.code,jg.desc+".")},l.createMultipleMatchingAccountsInCacheError=function(){return new l(Hg.code,Hg.desc)},l.createMultipleMatchingAppMetadataInCacheError=function(){return new l(Vg.code,Vg.desc)},l.createTokenRequestCannotBeMadeError=function(){return new l(Gg.code,Gg.desc)},l.createAppendEmptyScopeToSetError=function(e){return new l(Kg.code,Kg.desc+" Given Scope: "+e)},l.createRemoveEmptyScopeFromSetError=function(e){return new l(Zg.code,Zg.desc+" Given Scope: "+e)},l.createAppendScopeSetError=function(e){return new l(Wg.code,Wg.desc+" Detail Error: "+e)},l.createEmptyInputScopeSetError=function(){return new l(Yg.code,""+Yg.desc)},l.createDeviceCodeCancelledError=function(){return new l($g.code,""+$g.desc)},l.createDeviceCodeExpiredError=function(){return new l(Xg.code,""+Xg.desc)},l.createDeviceCodeUnknownError=function(){return new l(Jg.code,""+Jg.desc)},l.createNoAccountInSilentRequestError=function(){return new l(Qg.code,""+Qg.desc)},l.createNullOrUndefinedCacheRecord=function(){return new l(ey.code,ey.desc)},l.createInvalidCacheEnvironmentError=function(){return new l(ty.code,ty.desc)},l.createNoAccountFoundError=function(){return new l(ry.code,ry.desc)},l.createCachePluginError=function(){return new l(iy.code,""+iy.desc)},l.createNoCryptoObjectError=function(e){return new l(ny.code,""+ny.desc+e)},l.createInvalidCacheTypeError=function(){return new l(oy.code,""+oy.desc)},l.createUnexpectedAccountTypeError=function(){return new l(ay.code,""+ay.desc)},l.createUnexpectedCredentialTypeError=function(){return new l(sy.code,""+sy.desc)},l.createInvalidAssertionError=function(){return new l(ly.code,""+ly.desc)},l.createInvalidCredentialError=function(){return new l(cy.code,""+cy.desc)},l.createRefreshRequiredError=function(){return new l(uy.code,uy.desc)},l.createUserTimeoutReachedError=function(){return new l(hy.code,hy.desc)},l.createTokenClaimsRequiredError=function(){return new l(dy.code,dy.desc)},l.createNoAuthCodeInServerResponseError=function(){return new l(py.code,py.desc)},l.createBindingKeyNotRemovedError=function(){return new l(fy.code,fy.desc)},l.createLogoutNotSupportedError=function(){return new l(my.code,my.desc)},l.createKeyIdMissingError=function(){return new l(gy.code,gy.desc)},l.createNoNetworkConnectivityError=function(){return new l(yy.code,yy.desc)},l.createUserCanceledError=function(){return new l(vy.code,vy.desc)},l);function l(e,t){e=Sg.call(this,e,t)||this;return e.name="ClientAuthError",Object.setPrototypeOf(e,l.prototype),e}by.decodeAuthToken=function(e){if(by.isEmpty(e))throw E.createTokenNullOrEmptyError(e);var t=/^([^\.\s]*)\.([^\.\s]+)\.([^\.\s]*)$/.exec(e);if(!t||t.length<4)throw E.createTokenParsingError("Given token is malformed: "+JSON.stringify(e));return{header:t[1],JWSPayload:t[2],JWSSig:t[3]}},by.isEmpty=function(e){return void 0===e||!e||0===e.length},by.isEmptyObj=function(e){if(e&&!by.isEmpty(e))try{var t=JSON.parse(e);return 0===Object.keys(t).length}catch(e){}return!0},by.startsWith=function(e,t){return 0===e.indexOf(t)},by.endsWith=function(e,t){return e.length>=t.length&&e.lastIndexOf(t)===e.length-t.length},by.queryStringToObject=function(e){function r(e){return decodeURIComponent(e.replace(/\+/g," "))}var i={},e=e.split("&");return e.forEach(function(e){var t;e.trim()&&(t=(e=e.split(/=(.+)/g,2))[0],e=e[1],t)&&e&&(i[r(t)]=r(e))}),i},by.trimArrayEntries=function(e){return e.map(function(e){return e.trim()})},by.removeEmptyStringsFromArray=function(e){return e.filter(function(e){return!by.isEmpty(e)})},by.jsonParseHelper=function(e){try{return JSON.parse(e)}catch(e){return null}},by.matchPattern=function(e,t){return new RegExp(e.replace(/\\/g,"\\\\").replace(/\*/g,"[^ ]*").replace(/\?/g,"\\?")).test(t)};var _y,I=by;function by(){}(Ro=_y=_y||{})[Ro.Error=0]="Error",Ro[Ro.Warning=1]="Warning",Ro[Ro.Info=2]="Info",Ro[Ro.Verbose=3]="Verbose",Ro[Ro.Trace=4]="Trace";xy.createDefaultLoggerOptions=function(){return{loggerCallback:function(){},piiLoggingEnabled:!1,logLevel:_y.Info}},xy.prototype.clone=function(e,t,r){return new xy({loggerCallback:this.localCallback,piiLoggingEnabled:this.piiLoggingEnabled,logLevel:this.level,correlationId:r||this.correlationId},e,t)},xy.prototype.logMessage=function(e,t){var r;t.logLevel>this.level||!this.piiLoggingEnabled&&t.containsPii||(r=(new Date).toUTCString(),r=(I.isEmpty(t.correlationId)?I.isEmpty(this.correlationId)?"["+r+"]":"["+r+"] : ["+this.correlationId+"]":"["+r+"] : ["+t.correlationId+"]")+" : "+this.packageName+"@"+this.packageVersion+" : "+_y[t.logLevel]+" - "+e,this.executeCallback(t.logLevel,r,t.containsPii||!1))},xy.prototype.executeCallback=function(e,t,r){this.localCallback&&this.localCallback(e,t,r)},xy.prototype.error=function(e,t){this.logMessage(e,{logLevel:_y.Error,containsPii:!1,correlationId:t||T.EMPTY_STRING})},xy.prototype.errorPii=function(e,t){this.logMessage(e,{logLevel:_y.Error,containsPii:!0,correlationId:t||T.EMPTY_STRING})},xy.prototype.warning=function(e,t){this.logMessage(e,{logLevel:_y.Warning,containsPii:!1,correlationId:t||T.EMPTY_STRING})},xy.prototype.warningPii=function(e,t){this.logMessage(e,{logLevel:_y.Warning,containsPii:!0,correlationId:t||T.EMPTY_STRING})},xy.prototype.info=function(e,t){this.logMessage(e,{logLevel:_y.Info,containsPii:!1,correlationId:t||T.EMPTY_STRING})},xy.prototype.infoPii=function(e,t){this.logMessage(e,{logLevel:_y.Info,containsPii:!0,correlationId:t||T.EMPTY_STRING})},xy.prototype.verbose=function(e,t){this.logMessage(e,{logLevel:_y.Verbose,containsPii:!1,correlationId:t||T.EMPTY_STRING})},xy.prototype.verbosePii=function(e,t){this.logMessage(e,{logLevel:_y.Verbose,containsPii:!0,correlationId:t||T.EMPTY_STRING})},xy.prototype.trace=function(e,t){this.logMessage(e,{logLevel:_y.Trace,containsPii:!1,correlationId:t||T.EMPTY_STRING})},xy.prototype.tracePii=function(e,t){this.logMessage(e,{logLevel:_y.Trace,containsPii:!0,correlationId:t||T.EMPTY_STRING})},xy.prototype.isPiiLoggingEnabled=function(){return this.piiLoggingEnabled||!1};var wy=xy;function xy(e,t,r){this.level=_y.Info;e=e||xy.createDefaultLoggerOptions();this.localCallback=e.loggerCallback||function(){},this.piiLoggingEnabled=e.piiLoggingEnabled||!1,this.level="number"==typeof e.logLevel?e.logLevel:_y.Info,this.correlationId=e.correlationId||T.EMPTY_STRING,this.packageName=t||T.EMPTY_STRING,this.packageVersion=r||T.EMPTY_STRING}var Cy,Ty="@azure/msal-common",Sy="13.3.1";(Vt=Cy=Cy||{})[Vt.None=0]="None",Vt.AzurePublic="https://login.microsoftonline.com",Vt.AzurePpe="https://login.windows-ppe.net",Vt.AzureChina="https://login.chinacloudapi.cn",Vt.AzureGermany="https://login.microsoftonline.de",Vt.AzureUsGovernment="https://login.microsoftonline.us";var Ey,Iy={code:"redirect_uri_empty",desc:"A redirect URI is required for all calls, and none has been set."},Ay={code:"post_logout_uri_empty",desc:"A post logout redirect has not been set."},ky={code:"claims_request_parsing_error",desc:"Could not parse the given claims request object."},Py={code:"authority_uri_insecure",desc:"Authority URIs must use https.  Please see here for valid authority configuration options: https://docs.microsoft.com/en-us/azure/active-directory/develop/msal-js-initializing-client-applications#configuration-options"},My={code:"url_parse_error",desc:"URL could not be parsed into appropriate segments."},Ry={code:"empty_url_error",desc:"URL was empty or null."},Oy={code:"empty_input_scopes_error",desc:"Scopes cannot be passed as null, undefined or empty array because they are required to obtain an access token."},Ly={code:"clientid_input_scopes_error",desc:"Client ID can only be provided as a single scope."},Dy={code:"invalid_prompt_value",desc:"Supported prompt values are 'login', 'select_account', 'consent', 'create', 'none' and 'no_session'.  Please see here for valid configuration options: https://azuread.github.io/microsoft-authentication-library-for-js/ref/modules/_azure_msal_common.html#commonauthorizationurlrequest"},zy={code:"invalid_claims",desc:"Given claims parameter must be a stringified JSON object."},Ny={code:"token_request_empty",desc:"Token request was empty and not found in cache."},By={code:"logout_request_empty",desc:"The logout request was null or undefined."},Fy={code:"invalid_code_challenge_method",desc:'code_challenge_method passed is invalid. Valid values are "plain" and "S256".'},Uy={code:"pkce_params_missing",desc:"Both params: code_challenge and code_challenge_method are to be passed if to be sent in the request"},qy={code:"invalid_cloud_discovery_metadata",desc:"Invalid cloudDiscoveryMetadata provided. Must be a stringified JSON object containing tenant_discovery_endpoint and metadata fields"},jy={code:"invalid_authority_metadata",desc:"Invalid authorityMetadata provided. Must by a stringified JSON object containing authorization_endpoint, token_endpoint, issuer fields."},Hy={code:"untrusted_authority",desc:"The provided authority is not a trusted authority. Please include this authority in the knownAuthorities config parameter."},Vy={code:"invalid_azure_cloud_instance",desc:"Invalid AzureCloudInstance provided. Please refer MSAL JS docs: aks.ms/msaljs/azure_cloud_instance for valid values"},Gy={code:"missing_ssh_jwk",desc:"Missing sshJwk in SSH certificate request. A stringified JSON Web Key is required when using the SSH authentication scheme."},Ky={code:"missing_ssh_kid",desc:"Missing sshKid in SSH certificate request. A string that uniquely identifies the public SSH key is required when using the SSH authentication scheme."},Zy={code:"missing_nonce_authentication_header",desc:"Unable to find an authentication header containing server nonce. Either the Authentication-Info or WWW-Authenticate headers must be present in order to obtain a server nonce."},Wy={code:"invalid_authentication_header",desc:"Invalid authentication header provided"},Yy={code:"authority_mismatch",desc:"Authority mismatch error. Authority provided in login request or PublicClientApplication config does not match the environment of the provided account. Please use a matching account or make an interactive request to login to this authority."},$y=(Um(h,Ey=E),h.createRedirectUriEmptyError=function(){return new h(Iy.code,Iy.desc)},h.createPostLogoutRedirectUriEmptyError=function(){return new h(Ay.code,Ay.desc)},h.createClaimsRequestParsingError=function(e){return new h(ky.code,ky.desc+" Given value: "+e)},h.createInsecureAuthorityUriError=function(e){return new h(Py.code,Py.desc+" Given URI: "+e)},h.createUrlParseError=function(e){return new h(My.code,My.desc+" Given Error: "+e)},h.createUrlEmptyError=function(){return new h(Ry.code,Ry.desc)},h.createEmptyScopesArrayError=function(){return new h(Oy.code,""+Oy.desc)},h.createClientIdSingleScopeError=function(e){return new h(Ly.code,Ly.desc+" Given Scopes: "+e)},h.createInvalidPromptError=function(e){return new h(Dy.code,Dy.desc+" Given value: "+e)},h.createInvalidClaimsRequestError=function(){return new h(zy.code,zy.desc)},h.createEmptyLogoutRequestError=function(){return new h(By.code,By.desc)},h.createEmptyTokenRequestError=function(){return new h(Ny.code,Ny.desc)},h.createInvalidCodeChallengeMethodError=function(){return new h(Fy.code,Fy.desc)},h.createInvalidCodeChallengeParamsError=function(){return new h(Uy.code,Uy.desc)},h.createInvalidCloudDiscoveryMetadataError=function(){return new h(qy.code,qy.desc)},h.createInvalidAuthorityMetadataError=function(){return new h(jy.code,jy.desc)},h.createUntrustedAuthorityError=function(){return new h(Hy.code,Hy.desc)},h.createInvalidAzureCloudInstanceError=function(){return new h(Vy.code,Vy.desc)},h.createMissingSshJwkError=function(){return new h(Gy.code,Gy.desc)},h.createMissingSshKidError=function(){return new h(Ky.code,Ky.desc)},h.createMissingNonceAuthenticationHeadersError=function(){return new h(Zy.code,Zy.desc)},h.createInvalidAuthenticationHeaderError=function(e,t){return new h(Wy.code,Wy.desc+". Invalid header: "+e+". Details: "+t)},h.createAuthorityMismatchError=function(){return new h(Yy.code,Yy.desc)},h);function h(e,t){e=Ey.call(this,e,t)||this;return e.name="ClientConfigurationError",Object.setPrototypeOf(e,h.prototype),e}Qy.fromString=function(e){return new Qy((e||T.EMPTY_STRING).split(" "))},Qy.createSearchScopes=function(e){e=new Qy(e);return e.containsOnlyOIDCScopes()?e.removeScope(T.OFFLINE_ACCESS_SCOPE):e.removeOIDCScopes(),e},Qy.prototype.validateInputScopes=function(e){if(!e||e.length<1)throw $y.createEmptyScopesArrayError()},Qy.prototype.containsScope=function(e){var t=new Qy(this.printScopesLowerCase().split(" "));return!I.isEmpty(e)&&t.scopes.has(e.toLowerCase())},Qy.prototype.containsScopeSet=function(e){var t=this;return!(!e||e.scopes.size<=0)&&this.scopes.size>=e.scopes.size&&e.asArray().every(function(e){return t.containsScope(e)})},Qy.prototype.containsOnlyOIDCScopes=function(){var t=this,r=0;return rg.forEach(function(e){t.containsScope(e)&&(r+=1)}),this.scopes.size===r},Qy.prototype.appendScope=function(e){I.isEmpty(e)||this.scopes.add(e.trim())},Qy.prototype.appendScopes=function(e){var t=this;try{e.forEach(function(e){return t.appendScope(e)})}catch(e){throw E.createAppendScopeSetError(e)}},Qy.prototype.removeScope=function(e){if(I.isEmpty(e))throw E.createRemoveEmptyScopeFromSetError(e);this.scopes.delete(e.trim())},Qy.prototype.removeOIDCScopes=function(){var t=this;rg.forEach(function(e){t.scopes.delete(e)})},Qy.prototype.unionScopeSets=function(e){var t;if(e)return t=new Set,e.scopes.forEach(function(e){return t.add(e.toLowerCase())}),this.scopes.forEach(function(e){return t.add(e.toLowerCase())}),t;throw E.createEmptyInputScopeSetError()},Qy.prototype.intersectingScopeSets=function(e){if(!e)throw E.createEmptyInputScopeSetError();e.containsOnlyOIDCScopes()||e.removeOIDCScopes();var t=this.unionScopeSets(e),e=e.getScopeCount(),r=this.getScopeCount();return t.size<r+e},Qy.prototype.getScopeCount=function(){return this.scopes.size},Qy.prototype.asArray=function(){var t=[];return this.scopes.forEach(function(e){return t.push(e)}),t},Qy.prototype.printScopes=function(){return this.scopes?this.asArray().join(" "):T.EMPTY_STRING},Qy.prototype.printScopesLowerCase=function(){return this.printScopes().toLowerCase()};var Xy,Jy=Qy;function Qy(e){var t=this,e=e?I.trimArrayEntries(jm(e)):[],e=e?I.removeEmptyStringsFromArray(e):[];this.validateInputScopes(e),this.scopes=new Set,e.forEach(function(e){return t.scopes.add(e)})}function ev(e,t){if(I.isEmpty(e))throw E.createClientInfoEmptyError();try{var r=t.base64Decode(e);return JSON.parse(r)}catch(e){throw E.createClientInfoDecodingError(e.message)}}function tv(e){if(I.isEmpty(e))throw E.createClientInfoDecodingError("Home account ID was empty.");e=e.split(Xm.CLIENT_INFO_SEPARATOR,2);return{uid:e[0],utid:e.length<2?T.EMPTY_STRING:e[1]}}(r=Xy=Xy||{})[r.Default=0]="Default",r[r.Adfs=1]="Adfs",r[r.Dsts=2]="Dsts",r[r.Ciam=3]="Ciam";iv.prototype.generateAccountId=function(){return[this.homeAccountId,this.environment].join(Xm.CACHE_KEY_SEPARATOR).toLowerCase()},iv.prototype.generateAccountKey=function(){return iv.generateAccountCacheKey({homeAccountId:this.homeAccountId,environment:this.environment,tenantId:this.realm,username:this.username,localAccountId:this.localAccountId})},iv.prototype.generateType=function(){switch(this.authorityType){case $m.ADFS_ACCOUNT_TYPE:return Jm.ADFS;case $m.MSAV1_ACCOUNT_TYPE:return Jm.MSA;case $m.MSSTS_ACCOUNT_TYPE:return Jm.MSSTS;case $m.GENERIC_ACCOUNT_TYPE:return Jm.GENERIC;default:throw E.createUnexpectedAccountTypeError()}},iv.prototype.getAccountInfo=function(){return{homeAccountId:this.homeAccountId,environment:this.environment,tenantId:this.realm,username:this.username,localAccountId:this.localAccountId,name:this.name,idTokenClaims:this.idTokenClaims,nativeAccountId:this.nativeAccountId}},iv.generateAccountCacheKey=function(e){return[e.homeAccountId,e.environment||T.EMPTY_STRING,e.tenantId||T.EMPTY_STRING].join(Xm.CACHE_KEY_SEPARATOR).toLowerCase()},iv.createAccount=function(e,t,r,i,n,o,a,s){var l=new iv,e=(l.authorityType=$m.MSSTS_ACCOUNT_TYPE,l.clientInfo=e,l.homeAccountId=t,l.nativeAccountId=s,a||i&&i.getPreferredCache());if(e)return l.environment=e,l.realm=(null==(t=null==r?void 0:r.claims)?void 0:t.tid)||T.EMPTY_STRING,r&&(l.idTokenClaims=r.claims,l.localAccountId=(null==(s=null==r?void 0:r.claims)?void 0:s.oid)||(null==(a=null==r?void 0:r.claims)?void 0:a.sub)||T.EMPTY_STRING,e=null==(i=null==r?void 0:r.claims)?void 0:i.preferred_username,s=null!=(t=null==r?void 0:r.claims)&&t.emails?r.claims.emails[0]:null,l.username=e||s||T.EMPTY_STRING,l.name=null==(a=null==r?void 0:r.claims)?void 0:a.name),l.cloudGraphHostName=n,l.msGraphHost=o,l;throw E.createInvalidCacheEnvironmentError()},iv.createGenericAccount=function(e,t,r,i,n,o){var a=new iv,e=(a.authorityType=r&&r.authorityType===Xy.Adfs?$m.ADFS_ACCOUNT_TYPE:$m.GENERIC_ACCOUNT_TYPE,a.homeAccountId=e,a.realm=T.EMPTY_STRING,o||r&&r.getPreferredCache());if(e)return t&&(a.localAccountId=(null==(o=null==t?void 0:t.claims)?void 0:o.oid)||(null==(r=null==t?void 0:t.claims)?void 0:r.sub)||T.EMPTY_STRING,a.username=(null==(o=null==t?void 0:t.claims)?void 0:o.upn)||T.EMPTY_STRING,a.name=(null==(r=null==t?void 0:t.claims)?void 0:r.name)||T.EMPTY_STRING,a.idTokenClaims=null==t?void 0:t.claims),a.environment=e,a.cloudGraphHostName=i,a.msGraphHost=n,a;throw E.createInvalidCacheEnvironmentError()},iv.generateHomeAccountId=function(e,t,r,i,n){var o=null!=(o=null==n?void 0:n.claims)&&o.sub?n.claims.sub:T.EMPTY_STRING;if(t!==Xy.Adfs&&t!==Xy.Dsts){if(e)try{var a=ev(e,i);if(!I.isEmpty(a.uid)&&!I.isEmpty(a.utid))return""+a.uid+Xm.CLIENT_INFO_SEPARATOR+a.utid}catch(e){}r.verbose("No client info in response")}return o},iv.isAccountEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("realm")&&e.hasOwnProperty("localAccountId")&&e.hasOwnProperty("username")&&e.hasOwnProperty("authorityType")},iv.accountInfoIsEqual=function(e,t,r){var i,n;return!(!e||!t)&&(n=!0,r&&(r=e.idTokenClaims||{},i=t.idTokenClaims||{},n=r.iat===i.iat&&r.nonce===i.nonce),e.homeAccountId===t.homeAccountId)&&e.localAccountId===t.localAccountId&&e.username===t.username&&e.tenantId===t.tenantId&&e.environment===t.environment&&e.nativeAccountId===t.nativeAccountId&&n};var rv=iv;function iv(){}ov.extractTokenClaims=function(e,t){e=I.decodeAuthToken(e);try{var r=e.JWSPayload,i=t.base64Decode(r);return JSON.parse(i)}catch(e){throw E.createTokenParsingError(e)}},ov.checkMaxAge=function(e,t){if(0===t||Date.now()-3e5>e+t)throw E.createMaxAgeTranspiredError()};var nv=ov;function ov(e,t){if(I.isEmpty(e))throw E.createTokenNullOrEmptyError(e);this.rawToken=e,this.claims=ov.extractTokenClaims(e,t)}d.prototype.getAllAccounts=function(){var r=this,e=this.getAccountKeys();return e.length<1||(e=e.reduce(function(e,t){t=r.getAccount(t);return t&&e.push(t),e},[])).length<1?[]:e.map(function(e){return r.getAccountInfoFromEntity(e)})},d.prototype.getAccountInfoFilteredBy=function(e){e=this.getAccountsFilteredBy(e);return 0<e.length?this.getAccountInfoFromEntity(e[0]):null},d.prototype.getAccountInfoFromEntity=function(e){var e=e.getAccountInfo(),t=this.getIdToken(e);return t&&(e.idToken=t.secret,e.idTokenClaims=new nv(t.secret,this.cryptoImpl).claims),e},d.prototype.saveCacheRecord=function(t){return w(this,void 0,void 0,function(){return x(this,function(e){switch(e.label){case 0:if(t)return t.account&&this.setAccount(t.account),t.idToken&&this.setIdTokenCredential(t.idToken),t.accessToken?[4,this.saveAccessToken(t.accessToken)]:[3,2];throw E.createNullOrUndefinedCacheRecord();case 1:e.sent(),e.label=2;case 2:return t.refreshToken&&this.setRefreshTokenCredential(t.refreshToken),t.appMetadata&&this.setAppMetadata(t.appMetadata),[2]}})})},d.prototype.saveAccessToken=function(a){return w(this,void 0,void 0,function(){var r,t,i,n,o=this;return x(this,function(e){switch(e.label){case 0:return r={clientId:a.clientId,credentialType:a.credentialType,environment:a.environment,homeAccountId:a.homeAccountId,realm:a.realm,tokenType:a.tokenType,requestedClaimsHash:a.requestedClaimsHash},t=this.getTokenKeys(),i=Jy.fromString(a.target),n=[],t.accessToken.forEach(function(e){var t;o.accessTokenKeyMatchesFilter(e,r,!1)&&(t=o.getAccessTokenCredential(e))&&o.credentialMatchesFilter(t,r)&&Jy.fromString(t.target).intersectingScopeSets(i)&&n.push(o.removeAccessToken(e))}),[4,Promise.all(n)];case 1:return e.sent(),this.setAccessTokenCredential(a),[2]}})})},d.prototype.getAccountsFilteredBy=function(t){var r=this,e=this.getAccountKeys(),i=[];return e.forEach(function(e){!r.isAccountKey(e,t.homeAccountId,t.realm)||!(e=r.getAccount(e))||t.homeAccountId&&!r.matchHomeAccountId(e,t.homeAccountId)||t.localAccountId&&!r.matchLocalAccountId(e,t.localAccountId)||t.username&&!r.matchUsername(e,t.username)||t.environment&&!r.matchEnvironment(e,t.environment)||t.realm&&!r.matchRealm(e,t.realm)||t.nativeAccountId&&!r.matchNativeAccountId(e,t.nativeAccountId)||i.push(e)}),i},d.prototype.isAccountKey=function(e,t,r){return!(e.split(Xm.CACHE_KEY_SEPARATOR).length<3||t&&!e.toLowerCase().includes(t.toLowerCase())||r&&!e.toLowerCase().includes(r.toLowerCase()))},d.prototype.isCredentialKey=function(e){if(e.split(Xm.CACHE_KEY_SEPARATOR).length<6)return!1;e=e.toLowerCase();if(-1===e.indexOf(C.ID_TOKEN.toLowerCase())&&-1===e.indexOf(C.ACCESS_TOKEN.toLowerCase())&&-1===e.indexOf(C.ACCESS_TOKEN_WITH_AUTH_SCHEME.toLowerCase())&&-1===e.indexOf(C.REFRESH_TOKEN.toLowerCase()))return!1;if(-1<e.indexOf(C.REFRESH_TOKEN.toLowerCase())){var t=""+C.REFRESH_TOKEN+Xm.CACHE_KEY_SEPARATOR+this.clientId+Xm.CACHE_KEY_SEPARATOR,r=""+C.REFRESH_TOKEN+Xm.CACHE_KEY_SEPARATOR+"1"+Xm.CACHE_KEY_SEPARATOR;if(-1===e.indexOf(t.toLowerCase())&&-1===e.indexOf(r.toLowerCase()))return!1}else if(-1===e.indexOf(this.clientId.toLowerCase()))return!1;return!0},d.prototype.credentialMatchesFilter=function(e,t){if(t.clientId&&!this.matchClientId(e,t.clientId))return!1;if(t.userAssertionHash&&!this.matchUserAssertionHash(e,t.userAssertionHash))return!1;if("string"==typeof t.homeAccountId&&!this.matchHomeAccountId(e,t.homeAccountId))return!1;if(t.environment&&!this.matchEnvironment(e,t.environment))return!1;if(t.realm&&!this.matchRealm(e,t.realm))return!1;if(t.credentialType&&!this.matchCredentialType(e,t.credentialType))return!1;if(t.familyId&&!this.matchFamilyId(e,t.familyId))return!1;if(t.target&&!this.matchTarget(e,t.target))return!1;if((t.requestedClaimsHash||e.requestedClaimsHash)&&e.requestedClaimsHash!==t.requestedClaimsHash)return!1;if(e.credentialType===C.ACCESS_TOKEN_WITH_AUTH_SCHEME){if(t.tokenType&&!this.matchTokenType(e,t.tokenType))return!1;if(t.tokenType===eg.SSH&&t.keyId&&!this.matchKeyId(e,t.keyId))return!1}return!0},d.prototype.getAppMetadataFilteredBy=function(e){return this.getAppMetadataFilteredByInternal(e.environment,e.clientId)},d.prototype.getAppMetadataFilteredByInternal=function(r,i){var n=this,e=this.getKeys(),o={};return e.forEach(function(e){var t;!n.isAppMetadata(e)||!(t=n.getAppMetadata(e))||r&&!n.matchEnvironment(t,r)||i&&!n.matchClientId(t,i)||(o[e]=t)}),o},d.prototype.getAuthorityMetadataByAlias=function(t){var r=this,e=this.getAuthorityMetadataKeys(),i=null;return e.forEach(function(e){r.isAuthorityMetadata(e)&&-1!==e.indexOf(r.clientId)&&(e=r.getAuthorityMetadata(e))&&-1!==e.aliases.indexOf(t)&&(i=e)}),i},d.prototype.removeAllAccounts=function(){return w(this,void 0,void 0,function(){var t,r,i=this;return x(this,function(e){switch(e.label){case 0:return t=this.getAccountKeys(),r=[],t.forEach(function(e){r.push(i.removeAccount(e))}),[4,Promise.all(r)];case 1:return e.sent(),[2]}})})},d.prototype.removeAccount=function(r){return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:if(t=this.getAccount(r))return[4,this.removeAccountContext(t)];throw E.createNoAccountFoundError();case 1:return e.sent(),this.removeItem(r),[2]}})})},d.prototype.removeAccountContext=function(o){return w(this,void 0,void 0,function(){var t,r,i,n=this;return x(this,function(e){switch(e.label){case 0:return t=this.getTokenKeys(),r=o.generateAccountId(),i=[],t.idToken.forEach(function(e){0===e.indexOf(r)&&n.removeIdToken(e)}),t.accessToken.forEach(function(e){0===e.indexOf(r)&&i.push(n.removeAccessToken(e))}),t.refreshToken.forEach(function(e){0===e.indexOf(r)&&n.removeRefreshToken(e)}),[4,Promise.all(i)];case 1:return e.sent(),[2]}})})},d.prototype.removeAccessToken=function(r){return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:if(!(t=this.getAccessTokenCredential(r)))return[2];if(t.credentialType.toLowerCase()!==C.ACCESS_TOKEN_WITH_AUTH_SCHEME.toLowerCase())return[3,4];if(t.tokenType!==eg.POP)return[3,4];if(!(t=t.keyId))return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.cryptoImpl.removeTokenBindingKey(t)];case 2:return e.sent(),[3,4];case 3:throw e.sent(),E.createBindingKeyNotRemovedError();case 4:return[2,this.removeItem(r)]}})})},d.prototype.removeAppMetadata=function(){var t=this;return this.getKeys().forEach(function(e){t.isAppMetadata(e)&&t.removeItem(e)}),!0},d.prototype.readCacheRecord=function(e,t,r){var i=this.getTokenKeys(),n=this.readAccountFromCache(e),o=this.getIdToken(e,i),t=this.getAccessToken(e,t,i),e=this.getRefreshToken(e,!1,i),i=this.readAppMetadataFromCache(r);return n&&o&&(n.idTokenClaims=new nv(o.secret,this.cryptoImpl).claims),{account:n,idToken:o,accessToken:t,refreshToken:e,appMetadata:i}},d.prototype.readAccountFromCache=function(e){e=rv.generateAccountCacheKey(e);return this.getAccount(e)},d.prototype.getIdToken=function(e,t){var r=this,e=(this.commonLogger.trace("CacheManager - getIdToken called"),{homeAccountId:e.homeAccountId,environment:e.environment,credentialType:C.ID_TOKEN,clientId:this.clientId,realm:e.tenantId}),e=this.getIdTokensByFilter(e,t),t=e.length;return t<1?(this.commonLogger.info("CacheManager:getIdToken - No token found"),null):1<t?(this.commonLogger.info("CacheManager:getIdToken - Multiple id tokens found, clearing them"),e.forEach(function(e){r.removeIdToken(e.generateCredentialKey())}),null):(this.commonLogger.info("CacheManager:getIdToken - Returning id token"),e[0])},d.prototype.getIdTokensByFilter=function(t,e){var r=this,e=e&&e.idToken||this.getTokenKeys().idToken,i=[];return e.forEach(function(e){r.idTokenKeyMatchesFilter(e,qm({clientId:r.clientId},t))&&(e=r.getIdTokenCredential(e))&&r.credentialMatchesFilter(e,t)&&i.push(e)}),i},d.prototype.idTokenKeyMatchesFilter=function(e,t){e=e.toLowerCase();return!(t.clientId&&-1===e.indexOf(t.clientId.toLowerCase())||t.homeAccountId&&-1===e.indexOf(t.homeAccountId.toLowerCase()))},d.prototype.removeIdToken=function(e){this.removeItem(e)},d.prototype.removeRefreshToken=function(e){this.removeItem(e)},d.prototype.getAccessToken=function(e,t,r){var i=this,n=(this.commonLogger.trace("CacheManager - getAccessToken called"),Jy.createSearchScopes(t.scopes)),o=t.authenticationScheme||eg.BEARER,a=o&&o.toLowerCase()!==eg.BEARER.toLowerCase()?C.ACCESS_TOKEN_WITH_AUTH_SCHEME:C.ACCESS_TOKEN,s={homeAccountId:e.homeAccountId,environment:e.environment,credentialType:a,clientId:this.clientId,realm:e.tenantId,target:n,tokenType:o,keyId:t.sshKid,requestedClaimsHash:t.requestedClaimsHash},a=r&&r.accessToken||this.getTokenKeys().accessToken,l=[],e=(a.forEach(function(e){i.accessTokenKeyMatchesFilter(e,s,!0)&&(e=i.getAccessTokenCredential(e))&&i.credentialMatchesFilter(e,s)&&l.push(e)}),l.length);return e<1?(this.commonLogger.info("CacheManager:getAccessToken - No token found"),null):1<e?(this.commonLogger.info("CacheManager:getAccessToken - Multiple access tokens found, clearing them"),l.forEach(function(e){i.removeAccessToken(e.generateCredentialKey())}),null):(this.commonLogger.info("CacheManager:getAccessToken - Returning access token"),l[0])},d.prototype.accessTokenKeyMatchesFilter=function(e,t,r){var i=e.toLowerCase();if(t.clientId&&-1===i.indexOf(t.clientId.toLowerCase()))return!1;if(t.homeAccountId&&-1===i.indexOf(t.homeAccountId.toLowerCase()))return!1;if(t.realm&&-1===i.indexOf(t.realm.toLowerCase()))return!1;if(t.requestedClaimsHash&&-1===i.indexOf(t.requestedClaimsHash.toLowerCase()))return!1;if(t.target)for(var n=t.target.asArray(),o=0;o<n.length;o++){if(r&&!i.includes(n[o].toLowerCase()))return!1;if(!r&&i.includes(n[o].toLowerCase()))return!0}return!0},d.prototype.getAccessTokensByFilter=function(t){var r=this,e=this.getTokenKeys(),i=[];return e.accessToken.forEach(function(e){r.accessTokenKeyMatchesFilter(e,t,!0)&&(e=r.getAccessTokenCredential(e))&&r.credentialMatchesFilter(e,t)&&i.push(e)}),i},d.prototype.getRefreshToken=function(e,t,r){var i=this,t=(this.commonLogger.trace("CacheManager - getRefreshToken called"),t?"1":void 0),n={homeAccountId:e.homeAccountId,environment:e.environment,credentialType:C.REFRESH_TOKEN,clientId:this.clientId,familyId:t},e=r&&r.refreshToken||this.getTokenKeys().refreshToken,o=[];return e.forEach(function(e){i.refreshTokenKeyMatchesFilter(e,n)&&(e=i.getRefreshTokenCredential(e))&&i.credentialMatchesFilter(e,n)&&o.push(e)}),o.length<1?(this.commonLogger.info("CacheManager:getRefreshToken - No refresh token found."),null):(this.commonLogger.info("CacheManager:getRefreshToken - returning refresh token"),o[0])},d.prototype.refreshTokenKeyMatchesFilter=function(e,t){e=e.toLowerCase();return!(t.familyId&&-1===e.indexOf(t.familyId.toLowerCase())||!t.familyId&&t.clientId&&-1===e.indexOf(t.clientId.toLowerCase())||t.homeAccountId&&-1===e.indexOf(t.homeAccountId.toLowerCase()))},d.prototype.readAppMetadataFromCache=function(e){var e={environment:e,clientId:this.clientId},t=this.getAppMetadataFilteredBy(e),e=Object.keys(t).map(function(e){return t[e]}),r=e.length;if(r<1)return null;if(1<r)throw E.createMultipleMatchingAppMetadataInCacheError();return e[0]},d.prototype.isAppMetadataFOCI=function(e){e=this.readAppMetadataFromCache(e);return!(!e||"1"!==e.familyId)},d.prototype.matchHomeAccountId=function(e,t){return!("string"!=typeof e.homeAccountId||t!==e.homeAccountId)},d.prototype.matchLocalAccountId=function(e,t){return!("string"!=typeof e.localAccountId||t!==e.localAccountId)},d.prototype.matchUsername=function(e,t){return!("string"!=typeof e.username||t.toLowerCase()!==e.username.toLowerCase())},d.prototype.matchUserAssertionHash=function(e,t){return!(!e.userAssertionHash||t!==e.userAssertionHash)},d.prototype.matchEnvironment=function(e,t){t=this.getAuthorityMetadataByAlias(t);return!!(t&&-1<t.aliases.indexOf(e.environment))},d.prototype.matchCredentialType=function(e,t){return e.credentialType&&t.toLowerCase()===e.credentialType.toLowerCase()},d.prototype.matchClientId=function(e,t){return!(!e.clientId||t!==e.clientId)},d.prototype.matchFamilyId=function(e,t){return!(!e.familyId||t!==e.familyId)},d.prototype.matchRealm=function(e,t){return!(!e.realm||t!==e.realm)},d.prototype.matchNativeAccountId=function(e,t){return!(!e.nativeAccountId||t!==e.nativeAccountId)},d.prototype.matchTarget=function(e,t){return!(e.credentialType!==C.ACCESS_TOKEN&&e.credentialType!==C.ACCESS_TOKEN_WITH_AUTH_SCHEME||!e.target)&&Jy.fromString(e.target).containsScopeSet(t)},d.prototype.matchTokenType=function(e,t){return!(!e.tokenType||e.tokenType!==t)},d.prototype.matchKeyId=function(e,t){return!(!e.keyId||e.keyId!==t)},d.prototype.isAppMetadata=function(e){return-1!==e.indexOf(og)},d.prototype.isAuthorityMetadata=function(e){return-1!==e.indexOf(ag)},d.prototype.generateAuthorityMetadataCacheKey=function(e){return ag+"-"+this.clientId+"-"+e},d.toObject=function(e,t){for(var r in t)e[r]=t[r];return e};var av=d;function d(e,t,r){this.clientId=e,this.cryptoImpl=t,this.commonLogger=r.clone(Ty,Sy)}Um(cv,sv=av),cv.prototype.setAccount=function(){throw S.createUnexpectedError("Storage interface - setAccount() has not been implemented for the cacheStorage interface.")},cv.prototype.getAccount=function(){throw S.createUnexpectedError("Storage interface - getAccount() has not been implemented for the cacheStorage interface.")},cv.prototype.setIdTokenCredential=function(){throw S.createUnexpectedError("Storage interface - setIdTokenCredential() has not been implemented for the cacheStorage interface.")},cv.prototype.getIdTokenCredential=function(){throw S.createUnexpectedError("Storage interface - getIdTokenCredential() has not been implemented for the cacheStorage interface.")},cv.prototype.setAccessTokenCredential=function(){throw S.createUnexpectedError("Storage interface - setAccessTokenCredential() has not been implemented for the cacheStorage interface.")},cv.prototype.getAccessTokenCredential=function(){throw S.createUnexpectedError("Storage interface - getAccessTokenCredential() has not been implemented for the cacheStorage interface.")},cv.prototype.setRefreshTokenCredential=function(){throw S.createUnexpectedError("Storage interface - setRefreshTokenCredential() has not been implemented for the cacheStorage interface.")},cv.prototype.getRefreshTokenCredential=function(){throw S.createUnexpectedError("Storage interface - getRefreshTokenCredential() has not been implemented for the cacheStorage interface.")},cv.prototype.setAppMetadata=function(){throw S.createUnexpectedError("Storage interface - setAppMetadata() has not been implemented for the cacheStorage interface.")},cv.prototype.getAppMetadata=function(){throw S.createUnexpectedError("Storage interface - getAppMetadata() has not been implemented for the cacheStorage interface.")},cv.prototype.setServerTelemetry=function(){throw S.createUnexpectedError("Storage interface - setServerTelemetry() has not been implemented for the cacheStorage interface.")},cv.prototype.getServerTelemetry=function(){throw S.createUnexpectedError("Storage interface - getServerTelemetry() has not been implemented for the cacheStorage interface.")},cv.prototype.setAuthorityMetadata=function(){throw S.createUnexpectedError("Storage interface - setAuthorityMetadata() has not been implemented for the cacheStorage interface.")},cv.prototype.getAuthorityMetadata=function(){throw S.createUnexpectedError("Storage interface - getAuthorityMetadata() has not been implemented for the cacheStorage interface.")},cv.prototype.getAuthorityMetadataKeys=function(){throw S.createUnexpectedError("Storage interface - getAuthorityMetadataKeys() has not been implemented for the cacheStorage interface.")},cv.prototype.setThrottlingCache=function(){throw S.createUnexpectedError("Storage interface - setThrottlingCache() has not been implemented for the cacheStorage interface.")},cv.prototype.getThrottlingCache=function(){throw S.createUnexpectedError("Storage interface - getThrottlingCache() has not been implemented for the cacheStorage interface.")},cv.prototype.removeItem=function(){throw S.createUnexpectedError("Storage interface - removeItem() has not been implemented for the cacheStorage interface.")},cv.prototype.containsKey=function(){throw S.createUnexpectedError("Storage interface - containsKey() has not been implemented for the cacheStorage interface.")},cv.prototype.getKeys=function(){throw S.createUnexpectedError("Storage interface - getKeys() has not been implemented for the cacheStorage interface.")},cv.prototype.getAccountKeys=function(){throw S.createUnexpectedError("Storage interface - getAccountKeys() has not been implemented for the cacheStorage interface.")},cv.prototype.getTokenKeys=function(){throw S.createUnexpectedError("Storage interface - getTokenKeys() has not been implemented for the cacheStorage interface.")},cv.prototype.clear=function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Storage interface - clear() has not been implemented for the cacheStorage interface.")})})},cv.prototype.updateCredentialCacheKey=function(){throw S.createUnexpectedError("Storage interface - updateCredentialCacheKey() has not been implemented for the cacheStorage interface.")};var sv,lv=cv;function cv(){return null!==sv&&sv.apply(this,arguments)||this}var uv={tokenRenewalOffsetSeconds:300,preventCorsPreflight:!1},hv={loggerCallback:function(){},piiLoggingEnabled:!1,logLevel:_y.Info,correlationId:T.EMPTY_STRING},dv={claimsBasedCachingEnabled:!0},pv={sendGetRequestAsync:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Network interface - sendGetRequestAsync() has not been implemented")})})},sendPostRequestAsync:function(){return w(this,void 0,void 0,function(){return x(this,function(e){throw S.createUnexpectedError("Network interface - sendPostRequestAsync() has not been implemented")})})}},fv={sku:T.SKU,version:Sy,cpu:T.EMPTY_STRING,os:T.EMPTY_STRING},mv={clientSecret:T.EMPTY_STRING,clientAssertion:void 0},gv={azureCloudInstance:Cy.None,tenant:""+T.DEFAULT_COMMON_TENANT},yv={application:{appName:"",appVersion:""}};function vv(e){var t=e.authOptions,r=e.systemOptions,i=e.loggerOptions,n=e.cacheOptions,o=e.storageInterface,a=e.networkInterface,s=e.cryptoInterface,l=e.clientCredentials,c=e.libraryInfo,u=e.telemetry,h=e.serverTelemetryManager,d=e.persistencePlugin,e=e.serializableCache,i=qm(qm({},hv),i);return{authOptions:qm({clientCapabilities:[],azureCloudOptions:gv,skipAuthorityMetadataCache:!1},t),systemOptions:qm(qm({},uv),r),loggerOptions:i,cacheOptions:qm(qm({},dv),n),storageInterface:o||new lv(t.clientId,Eg,new wy(i)),networkInterface:a||pv,cryptoInterface:s||Eg,clientCredentials:l||mv,libraryInfo:qm(qm({},fv),c),telemetry:qm(qm({},yv),u),serverTelemetryManager:h||null,persistencePlugin:d||null,serializableCache:e||null}}Um(wv,_v=S);var _v,bv=wv;function wv(e,t,r){e=_v.call(this,e,t,r)||this;return e.name="ServerError",Object.setPrototypeOf(e,wv.prototype),e}Cv.generateThrottlingStorageKey=function(e){return yg+"."+JSON.stringify(e)},Cv.preProcess=function(e,t){var r,t=Cv.generateThrottlingStorageKey(t),i=e.getThrottlingCache(t);if(i){if(!(i.throttleTime<Date.now()))throw new bv((null==(r=i.errorCodes)?void 0:r.join(" "))||T.EMPTY_STRING,i.errorMessage,i.subError);e.removeItem(t)}},Cv.postProcess=function(e,t,r){(Cv.checkResponseStatus(r)||Cv.checkResponseForRetryAfter(r))&&(r={throttleTime:Cv.calculateThrottleTime(parseInt(r.headers[Hm.RETRY_AFTER])),error:r.body.error,errorCodes:r.body.error_codes,errorMessage:r.body.error_description,subError:r.body.suberror},e.setThrottlingCache(Cv.generateThrottlingStorageKey(t),r))},Cv.checkResponseStatus=function(e){return 429===e.status||500<=e.status&&e.status<600},Cv.checkResponseForRetryAfter=function(e){return!!e.headers&&e.headers.hasOwnProperty(Hm.RETRY_AFTER)&&(e.status<200||300<=e.status)},Cv.calculateThrottleTime=function(e){var e=e<=0?0:e,t=Date.now()/1e3;return Math.floor(1e3*Math.min(t+(e||mg),t+gg))},Cv.removeThrottle=function(e,t,r,i){t={clientId:t,authority:r.authority,scopes:r.scopes,homeAccountIdentifier:i,claims:r.claims,authenticationScheme:r.authenticationScheme,resourceRequestMethod:r.resourceRequestMethod,resourceRequestUri:r.resourceRequestUri,shrClaims:r.shrClaims,sshKid:r.sshKid},i=this.generateThrottlingStorageKey(t);e.removeItem(i)};var xv=Cv;function Cv(){}Ev.prototype.sendPostRequest=function(i,n,o){return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){switch(e.label){case 0:xv.preProcess(this.cacheManager,i),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkClient.sendPostRequestAsync(n,o)];case 2:return t=e.sent(),[3,4];case 3:throw(r=e.sent())instanceof S?r:E.createNetworkError(n,r);case 4:return xv.postProcess(this.cacheManager,i,t),[2,t]}})})};var Tv,Sv=Ev;function Ev(e,t){this.networkClient=e,this.cacheManager=t}(Br=Tv=Tv||{}).HOME_ACCOUNT_ID="home_account_id",Br.UPN="UPN";Av.validateRedirectUri=function(e){if(I.isEmpty(e))throw $y.createRedirectUriEmptyError()},Av.validatePrompt=function(e){var t,r=[];for(t in ig)r.push(ig[t]);if(r.indexOf(e)<0)throw $y.createInvalidPromptError(e)},Av.validateClaims=function(e){try{JSON.parse(e)}catch(e){throw $y.createInvalidClaimsRequestError()}},Av.validateCodeChallengeParams=function(e,t){if(I.isEmpty(e)||I.isEmpty(t))throw $y.createInvalidCodeChallengeParamsError();this.validateCodeChallengeMethod(t)},Av.validateCodeChallengeMethod=function(e){if([ng.PLAIN,ng.S256].indexOf(e)<0)throw $y.createInvalidCodeChallengeMethodError()},Av.sanitizeEQParams=function(r,e){return r?(e.forEach(function(e,t){r[t]&&delete r[t]}),Object.fromEntries(Object.entries(r).filter(function(e){return""!==e[1]}))):{}};var Iv=Av;function Av(){}p.prototype.addResponseTypeCode=function(){this.parameters.set(c.RESPONSE_TYPE,encodeURIComponent(T.CODE_RESPONSE_TYPE))},p.prototype.addResponseTypeForTokenAndIdToken=function(){this.parameters.set(c.RESPONSE_TYPE,encodeURIComponent(T.TOKEN_RESPONSE_TYPE+" "+T.ID_TOKEN_RESPONSE_TYPE))},p.prototype.addResponseMode=function(e){this.parameters.set(c.RESPONSE_MODE,encodeURIComponent(e||Wm.QUERY))},p.prototype.addNativeBroker=function(){this.parameters.set(c.NATIVE_BROKER,encodeURIComponent("1"))},p.prototype.addScopes=function(e,t){t=(t=void 0===t?!0:t)?jm(e||[],tg):e||[],e=new Jy(t);this.parameters.set(c.SCOPE,encodeURIComponent(e.printScopes()))},p.prototype.addClientId=function(e){this.parameters.set(c.CLIENT_ID,encodeURIComponent(e))},p.prototype.addRedirectUri=function(e){Iv.validateRedirectUri(e),this.parameters.set(c.REDIRECT_URI,encodeURIComponent(e))},p.prototype.addPostLogoutRedirectUri=function(e){Iv.validateRedirectUri(e),this.parameters.set(c.POST_LOGOUT_URI,encodeURIComponent(e))},p.prototype.addIdTokenHint=function(e){this.parameters.set(c.ID_TOKEN_HINT,encodeURIComponent(e))},p.prototype.addDomainHint=function(e){this.parameters.set(Zm.DOMAIN_HINT,encodeURIComponent(e))},p.prototype.addLoginHint=function(e){this.parameters.set(Zm.LOGIN_HINT,encodeURIComponent(e))},p.prototype.addCcsUpn=function(e){this.parameters.set(Hm.CCS_HEADER,encodeURIComponent("UPN:"+e))},p.prototype.addCcsOid=function(e){this.parameters.set(Hm.CCS_HEADER,encodeURIComponent("Oid:"+e.uid+"@"+e.utid))},p.prototype.addSid=function(e){this.parameters.set(Zm.SID,encodeURIComponent(e))},p.prototype.addClaims=function(e,t){e=this.addClientCapabilitiesToClaims(e,t);Iv.validateClaims(e),this.parameters.set(c.CLAIMS,encodeURIComponent(e))},p.prototype.addCorrelationId=function(e){this.parameters.set(c.CLIENT_REQUEST_ID,encodeURIComponent(e))},p.prototype.addLibraryInfo=function(e){this.parameters.set(c.X_CLIENT_SKU,e.sku),this.parameters.set(c.X_CLIENT_VER,e.version),e.os&&this.parameters.set(c.X_CLIENT_OS,e.os),e.cpu&&this.parameters.set(c.X_CLIENT_CPU,e.cpu)},p.prototype.addApplicationTelemetry=function(e){null!=e&&e.appName&&this.parameters.set(c.X_APP_NAME,e.appName),null!=e&&e.appVersion&&this.parameters.set(c.X_APP_VER,e.appVersion)},p.prototype.addPrompt=function(e){Iv.validatePrompt(e),this.parameters.set(""+c.PROMPT,encodeURIComponent(e))},p.prototype.addState=function(e){I.isEmpty(e)||this.parameters.set(c.STATE,encodeURIComponent(e))},p.prototype.addNonce=function(e){this.parameters.set(c.NONCE,encodeURIComponent(e))},p.prototype.addCodeChallengeParams=function(e,t){if(Iv.validateCodeChallengeParams(e,t),!e||!t)throw $y.createInvalidCodeChallengeParamsError();this.parameters.set(c.CODE_CHALLENGE,encodeURIComponent(e)),this.parameters.set(c.CODE_CHALLENGE_METHOD,encodeURIComponent(t))},p.prototype.addAuthorizationCode=function(e){this.parameters.set(c.CODE,encodeURIComponent(e))},p.prototype.addDeviceCode=function(e){this.parameters.set(c.DEVICE_CODE,encodeURIComponent(e))},p.prototype.addRefreshToken=function(e){this.parameters.set(c.REFRESH_TOKEN,encodeURIComponent(e))},p.prototype.addCodeVerifier=function(e){this.parameters.set(c.CODE_VERIFIER,encodeURIComponent(e))},p.prototype.addClientSecret=function(e){this.parameters.set(c.CLIENT_SECRET,encodeURIComponent(e))},p.prototype.addClientAssertion=function(e){I.isEmpty(e)||this.parameters.set(c.CLIENT_ASSERTION,encodeURIComponent(e))},p.prototype.addClientAssertionType=function(e){I.isEmpty(e)||this.parameters.set(c.CLIENT_ASSERTION_TYPE,encodeURIComponent(e))},p.prototype.addOboAssertion=function(e){this.parameters.set(c.OBO_ASSERTION,encodeURIComponent(e))},p.prototype.addRequestTokenUse=function(e){this.parameters.set(c.REQUESTED_TOKEN_USE,encodeURIComponent(e))},p.prototype.addGrantType=function(e){this.parameters.set(c.GRANT_TYPE,encodeURIComponent(e))},p.prototype.addClientInfo=function(){this.parameters.set("client_info","1")},p.prototype.addExtraQueryParameters=function(t){var r=this,e=Iv.sanitizeEQParams(t,this.parameters);Object.keys(e).forEach(function(e){r.parameters.set(e,t[e])})},p.prototype.addClientCapabilitiesToClaims=function(e,t){var r;if(e)try{r=JSON.parse(e)}catch(e){throw $y.createInvalidClaimsRequestError()}else r={};return t&&0<t.length&&(r.hasOwnProperty(Km.ACCESS_TOKEN)||(r[Km.ACCESS_TOKEN]={}),r[Km.ACCESS_TOKEN][Km.XMS_CC]={values:t}),JSON.stringify(r)},p.prototype.addUsername=function(e){this.parameters.set(cg.username,encodeURIComponent(e))},p.prototype.addPassword=function(e){this.parameters.set(cg.password,encodeURIComponent(e))},p.prototype.addPopToken=function(e){I.isEmpty(e)||(this.parameters.set(c.TOKEN_TYPE,eg.POP),this.parameters.set(c.REQ_CNF,encodeURIComponent(e)))},p.prototype.addSshJwk=function(e){I.isEmpty(e)||(this.parameters.set(c.TOKEN_TYPE,eg.SSH),this.parameters.set(c.REQ_CNF,encodeURIComponent(e)))},p.prototype.addServerTelemetry=function(e){this.parameters.set(c.X_CLIENT_CURR_TELEM,e.generateCurrentRequestHeaderValue()),this.parameters.set(c.X_CLIENT_LAST_TELEM,e.generateLastRequestHeaderValue())},p.prototype.addThrottling=function(){this.parameters.set(c.X_MS_LIB_CAPABILITY,vg)},p.prototype.addLogoutHint=function(e){this.parameters.set(c.LOGOUT_HINT,encodeURIComponent(e))},p.prototype.createQueryString=function(){var r=new Array;return this.parameters.forEach(function(e,t){r.push(t+"="+e)}),r.join("&")};var kv=p;function p(){this.parameters=new Map}Pv.prototype.createTokenRequestHeaders=function(e){var t={};if(t[Hm.CONTENT_TYPE]=T.URL_FORM_CONTENT_TYPE,!this.config.systemOptions.preventCorsPreflight&&e)switch(e.type){case Tv.HOME_ACCOUNT_ID:try{var r=tv(e.credential);t[Hm.CCS_HEADER]="Oid:"+r.uid+"@"+r.utid}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case Tv.UPN:t[Hm.CCS_HEADER]="UPN: "+e.credential}return t},Pv.prototype.executePostToTokenEndpoint=function(r,i,n,o){return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:return[4,this.networkManager.sendPostRequest(o,r,{body:i,headers:n})];case 1:return t=e.sent(),this.config.serverTelemetryManager&&t.status<500&&429!==t.status&&this.config.serverTelemetryManager.clearTelemetryCache(),[2,t]}})})},Pv.prototype.updateAuthority=function(e){if(!e.discoveryComplete())throw E.createEndpointDiscoveryIncompleteError("Updated authority has not completed endpoint discovery.");this.authority=e},Pv.prototype.createTokenQueryParameters=function(e){var t=new kv;return e.tokenQueryParameters&&t.addExtraQueryParameters(e.tokenQueryParameters),t.createQueryString()};cn=Pv;function Pv(e,t){this.config=vv(e),this.logger=new wy(this.config.loggerOptions,Ty,Sy),this.cryptoUtils=this.config.cryptoInterface,this.cacheManager=this.config.storageInterface,this.networkClient=this.config.networkInterface,this.networkManager=new Sv(this.networkClient,this.cacheManager),this.serverTelemetryManager=this.config.serverTelemetryManager,this.authority=this.config.authOptions.authority,this.performanceClient=t}Mv.prototype.generateAccountId=function(){return Mv.generateAccountIdForCacheKey(this.homeAccountId,this.environment)},Mv.prototype.generateCredentialId=function(){return Mv.generateCredentialIdForCacheKey(this.credentialType,this.clientId,this.realm,this.familyId)},Mv.prototype.generateTarget=function(){return Mv.generateTargetForCacheKey(this.target)},Mv.prototype.generateCredentialKey=function(){return Mv.generateCredentialCacheKey(this.homeAccountId,this.environment,this.credentialType,this.clientId,this.realm,this.target,this.familyId,this.tokenType,this.requestedClaimsHash)},Mv.prototype.generateType=function(){switch(this.credentialType){case C.ID_TOKEN:return Jm.ID_TOKEN;case C.ACCESS_TOKEN:case C.ACCESS_TOKEN_WITH_AUTH_SCHEME:return Jm.ACCESS_TOKEN;case C.REFRESH_TOKEN:return Jm.REFRESH_TOKEN;default:throw E.createUnexpectedCredentialTypeError()}},Mv.generateCredentialCacheKey=function(e,t,r,i,n,o,a,s,l){return[this.generateAccountIdForCacheKey(e,t),this.generateCredentialIdForCacheKey(r,i,n,a),this.generateTargetForCacheKey(o),this.generateClaimsHashForCacheKey(l),this.generateSchemeForCacheKey(s)].join(Xm.CACHE_KEY_SEPARATOR).toLowerCase()},Mv.generateAccountIdForCacheKey=function(e,t){return[e,t].join(Xm.CACHE_KEY_SEPARATOR).toLowerCase()},Mv.generateCredentialIdForCacheKey=function(e,t,r,i){return[e,e===C.REFRESH_TOKEN&&i||t,r||T.EMPTY_STRING].join(Xm.CACHE_KEY_SEPARATOR).toLowerCase()},Mv.generateTargetForCacheKey=function(e){return(e||T.EMPTY_STRING).toLowerCase()},Mv.generateClaimsHashForCacheKey=function(e){return(e||T.EMPTY_STRING).toLowerCase()},Mv.generateSchemeForCacheKey=function(e){return e&&e.toLowerCase()!==eg.BEARER.toLowerCase()?e.toLowerCase():T.EMPTY_STRING};a=Mv;function Mv(){}Um(Lv,Rv=a),Lv.createIdTokenEntity=function(e,t,r,i,n){var o=new Lv;return o.credentialType=C.ID_TOKEN,o.homeAccountId=e,o.environment=t,o.clientId=i,o.secret=r,o.realm=n,o},Lv.isIdTokenEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("credentialType")&&e.hasOwnProperty("realm")&&e.hasOwnProperty("clientId")&&e.hasOwnProperty("secret")&&e.credentialType===C.ID_TOKEN};var Rv,Ov=Lv;function Lv(){return null!==Rv&&Rv.apply(this,arguments)||this}zv.nowSeconds=function(){return Math.round((new Date).getTime()/1e3)},zv.isTokenExpired=function(e,t){return(Number(e)||0)<zv.nowSeconds()+t},zv.wasClockTurnedBack=function(e){return Number(e)>zv.nowSeconds()},zv.delay=function(t,r){return new Promise(function(e){return setTimeout(function(){return e(r)},t)})};var Dv=zv;function zv(){}Um(Fv,Nv=a),Fv.createAccessTokenEntity=function(e,t,r,i,n,o,a,s,l,c,u,h,d,p,f){var m,g=new Fv,e=(g.homeAccountId=e,g.credentialType=C.ACCESS_TOKEN,g.secret=r,Dv.nowSeconds());if(g.cachedAt=e.toString(),g.expiresOn=a.toString(),g.extendedExpiresOn=s.toString(),c&&(g.refreshOn=c.toString()),g.environment=t,g.clientId=i,g.realm=n,g.target=o,g.userAssertionHash=h,g.tokenType=I.isEmpty(u)?eg.BEARER:u,p&&(g.requestedClaims=p,g.requestedClaimsHash=f),(null==(e=g.tokenType)?void 0:e.toLowerCase())!==eg.BEARER.toLowerCase())switch(g.credentialType=C.ACCESS_TOKEN_WITH_AUTH_SCHEME,g.tokenType){case eg.POP:var y=nv.extractTokenClaims(r,l);if(null==(m=null==y?void 0:y.cnf)||!m.kid)throw E.createTokenClaimsRequiredError();g.keyId=y.cnf.kid;break;case eg.SSH:g.keyId=d}return g},Fv.isAccessTokenEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("credentialType")&&e.hasOwnProperty("realm")&&e.hasOwnProperty("clientId")&&e.hasOwnProperty("secret")&&e.hasOwnProperty("target")&&(e.credentialType===C.ACCESS_TOKEN||e.credentialType===C.ACCESS_TOKEN_WITH_AUTH_SCHEME)};var Nv,Bv=Fv;function Fv(){return null!==Nv&&Nv.apply(this,arguments)||this}Um(jv,Uv=a),jv.createRefreshTokenEntity=function(e,t,r,i,n,o){var a=new jv;return a.clientId=i,a.credentialType=C.REFRESH_TOKEN,a.environment=t,a.homeAccountId=e,a.secret=r,a.userAssertionHash=o,n&&(a.familyId=n),a},jv.isRefreshTokenEntity=function(e){return!!e&&e.hasOwnProperty("homeAccountId")&&e.hasOwnProperty("environment")&&e.hasOwnProperty("credentialType")&&e.hasOwnProperty("clientId")&&e.hasOwnProperty("secret")&&e.credentialType===C.REFRESH_TOKEN};var Uv,qv=jv;function jv(){return null!==Uv&&Uv.apply(this,arguments)||this}var Hv,Vv=["interaction_required","consent_required","login_required"],Gv=["message_only","additional_action","basic_action","user_password_expired","consent_required"],Kv={code:"no_tokens_found",desc:"No refresh token found in the cache. Please sign-in."},Zv={code:"native_account_unavailable",desc:"The requested account is not available in the native broker. It may have been deleted or logged out. Please sign-in again using an interactive API."},Wv=(Um(Yv,Hv=S),Yv.isInteractionRequiredError=function(e,t,r){var e=!!e&&-1<Vv.indexOf(e),r=!!r&&-1<Gv.indexOf(r),i=!!t&&Vv.some(function(e){return-1<t.indexOf(e)});return e||i||r},Yv.createNoTokensFoundError=function(){return new Yv(Kv.code,Kv.desc)},Yv.createNativeAccountUnavailableError=function(){return new Yv(Zv.code,Zv.desc)},Yv);function Yv(e,t,r,i,n,o,a){e=Hv.call(this,e,t,r)||this;return Object.setPrototypeOf(e,Yv.prototype),e.timestamp=i||T.EMPTY_STRING,e.traceId=n||T.EMPTY_STRING,e.correlationId=o||T.EMPTY_STRING,e.claims=a||T.EMPTY_STRING,e.name="InteractionRequiredAuthError",e}var $v=function(e,t,r,i,n){this.account=e||null,this.idToken=t||null,this.accessToken=r||null,this.refreshToken=i||null,this.appMetadata=n||null},Xv=(Jv.setRequestState=function(e,t,r){e=Jv.generateLibraryState(e,r);return I.isEmpty(t)?e:""+e+T.RESOURCE_DELIM+t},Jv.generateLibraryState=function(e,t){var r;if(e)return r={id:e.createNewGuid()},t&&(r.meta=t),t=JSON.stringify(r),e.base64Encode(t);throw E.createNoCryptoObjectError("generateLibraryState")},Jv.parseRequestState=function(e,t){if(!e)throw E.createNoCryptoObjectError("parseRequestState");if(I.isEmpty(t))throw E.createInvalidStateError(t,"Null, undefined or empty state");try{var r=t.split(T.RESOURCE_DELIM),i=r[0],n=1<r.length?r.slice(1).join(T.RESOURCE_DELIM):T.EMPTY_STRING,o=e.base64Decode(i),a=JSON.parse(o);return{userRequestState:I.isEmpty(n)?T.EMPTY_STRING:n,libraryState:a}}catch(e){throw E.createInvalidStateError(t,e)}},Jv);function Jv(){}Object.defineProperty(t_.prototype,"urlString",{get:function(){return this._urlString},enumerable:!1,configurable:!0}),t_.canonicalizeUri=function(e){var t;return e&&(t=e.toLowerCase(),I.endsWith(t,"?")?t=t.slice(0,-1):I.endsWith(t,"?/")&&(t=t.slice(0,-2)),I.endsWith(t,"/")||(t+="/"),t)},t_.prototype.validateAsUri=function(){var e;try{e=this.getUrlComponents()}catch(e){throw $y.createUrlParseError(e)}if(!e.HostNameAndPort||!e.PathSegments)throw $y.createUrlParseError("Given url string: "+this.urlString);if(!e.Protocol||"https:"!==e.Protocol.toLowerCase())throw $y.createInsecureAuthorityUriError(this.urlString)},t_.appendQueryString=function(e,t){return I.isEmpty(t)?e:e.indexOf("?")<0?e+"?"+t:e+"&"+t},t_.removeHashFromUrl=function(e){return t_.canonicalizeUri(e.split("#")[0])},t_.prototype.replaceTenantPath=function(e){var t=this.getUrlComponents(),r=t.PathSegments;return!e||0===r.length||r[0]!==Gm.COMMON&&r[0]!==Gm.ORGANIZATIONS||(r[0]=e),t_.constructAuthorityUriFromObject(t)},t_.prototype.getHash=function(){return t_.parseHash(this.urlString)},t_.prototype.getUrlComponents=function(){var e,t=RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?"),t=this.urlString.match(t);if(t)return e=(e=(t={Protocol:t[1],HostNameAndPort:t[4],AbsolutePath:t[5],QueryString:t[7]}).AbsolutePath.split("/")).filter(function(e){return e&&0<e.length}),t.PathSegments=e,!I.isEmpty(t.QueryString)&&t.QueryString.endsWith("/")&&(t.QueryString=t.QueryString.substring(0,t.QueryString.length-1)),t;throw $y.createUrlParseError("Given url string: "+this.urlString)},t_.getDomainFromUrl=function(e){var t=RegExp("^([^:/?#]+://)?([^/?#]*)"),t=e.match(t);if(t)return t[2];throw $y.createUrlParseError("Given url string: "+e)},t_.getAbsoluteUrl=function(e,t){return e[0]===T.FORWARD_SLASH?(t=new t_(t).getUrlComponents()).Protocol+"//"+t.HostNameAndPort+e:e},t_.parseHash=function(e){var t=e.indexOf("#"),r=e.indexOf("#/");return-1<r?e.substring(r+2):-1<t?e.substring(t+1):T.EMPTY_STRING},t_.parseQueryString=function(e){var t=e.indexOf("?"),r=e.indexOf("/?");return-1<r?e.substring(r+2):-1<t?e.substring(t+1):T.EMPTY_STRING},t_.constructAuthorityUriFromObject=function(e){return new t_(e.Protocol+"//"+e.HostNameAndPort+"/"+e.PathSegments.join("/"))},t_.getDeserializedHash=function(e){if(I.isEmpty(e))return{};var t=t_.parseHash(e),e=I.queryStringToObject(I.isEmpty(t)?e:t);if(e)return e;throw E.createHashNotDeserializedError(JSON.stringify(e))},t_.getDeserializedQueryString=function(e){if(I.isEmpty(e))return{};var t=t_.parseQueryString(e),e=I.queryStringToObject(I.isEmpty(t)?e:t);if(e)return e;throw E.createHashNotDeserializedError(JSON.stringify(e))},t_.hashContainsKnownProperties=function(e){return!(I.isEmpty(e)||e.indexOf("=")<0||!((e=t_.getDeserializedHash(e)).code||e.error_description||e.error||e.state))};var A,Qv,e_=t_;function t_(e){if(this._urlString=e,I.isEmpty(this._urlString))throw $y.createUrlEmptyError();I.isEmpty(this.getHash())&&(this._urlString=t_.canonicalizeUri(e))}(t=A=A||{}).AcquireTokenByCode="acquireTokenByCode",t.AcquireTokenByRefreshToken="acquireTokenByRefreshToken",t.AcquireTokenSilent="acquireTokenSilent",t.AcquireTokenSilentAsync="acquireTokenSilentAsync",t.AcquireTokenPopup="acquireTokenPopup",t.CryptoOptsGetPublicKeyThumbprint="cryptoOptsGetPublicKeyThumbprint",t.CryptoOptsSignJwt="cryptoOptsSignJwt",t.SilentCacheClientAcquireToken="silentCacheClientAcquireToken",t.SilentIframeClientAcquireToken="silentIframeClientAcquireToken",t.SilentRefreshClientAcquireToken="silentRefreshClientAcquireToken",t.SsoSilent="ssoSilent",t.StandardInteractionClientGetDiscoveredAuthority="standardInteractionClientGetDiscoveredAuthority",t.FetchAccountIdWithNativeBroker="fetchAccountIdWithNativeBroker",t.NativeInteractionClientAcquireToken="nativeInteractionClientAcquireToken",t.BaseClientCreateTokenRequestHeaders="baseClientCreateTokenRequestHeaders",t.BrokerHandhshake="brokerHandshake",t.AcquireTokenByRefreshTokenInBroker="acquireTokenByRefreshTokenInBroker",t.AcquireTokenByBroker="acquireTokenByBroker",t.RefreshTokenClientExecuteTokenRequest="refreshTokenClientExecuteTokenRequest",t.RefreshTokenClientAcquireToken="refreshTokenClientAcquireToken",t.RefreshTokenClientAcquireTokenWithCachedRefreshToken="refreshTokenClientAcquireTokenWithCachedRefreshToken",t.RefreshTokenClientAcquireTokenByRefreshToken="refreshTokenClientAcquireTokenByRefreshToken",t.RefreshTokenClientCreateTokenRequestBody="refreshTokenClientCreateTokenRequestBody",t.AcquireTokenFromCache="acquireTokenFromCache",t.AcquireTokenBySilentIframe="acquireTokenBySilentIframe",t.InitializeBaseRequest="initializeBaseRequest",t.InitializeSilentRequest="initializeSilentRequest",t.InitializeClientApplication="initializeClientApplication",t.SilentIframeClientTokenHelper="silentIframeClientTokenHelper",t.SilentHandlerInitiateAuthRequest="silentHandlerInitiateAuthRequest",t.SilentHandlerMonitorIframeForHash="silentHandlerMonitorIframeForHash",t.SilentHandlerLoadFrame="silentHandlerLoadFrame",t.StandardInteractionClientCreateAuthCodeClient="standardInteractionClientCreateAuthCodeClient",t.StandardInteractionClientGetClientConfiguration="standardInteractionClientGetClientConfiguration",t.StandardInteractionClientInitializeAuthorizationRequest="standardInteractionClientInitializeAuthorizationRequest",t.StandardInteractionClientInitializeAuthorizationCodeRequest="standardInteractionClientInitializeAuthorizationCodeRequest",t.GetAuthCodeUrl="getAuthCodeUrl",t.HandleCodeResponseFromServer="handleCodeResponseFromServer",t.HandleCodeResponseFromHash="handleCodeResponseFromHash",t.UpdateTokenEndpointAuthority="updateTokenEndpointAuthority",t.AuthClientAcquireToken="authClientAcquireToken",t.AuthClientExecuteTokenRequest="authClientExecuteTokenRequest",t.AuthClientCreateTokenRequestBody="authClientCreateTokenRequestBody",t.AuthClientCreateQueryString="authClientCreateQueryString",t.PopTokenGenerateCnf="popTokenGenerateCnf",t.PopTokenGenerateKid="popTokenGenerateKid",t.HandleServerTokenResponse="handleServerTokenResponse",t.AuthorityFactoryCreateDiscoveredInstance="authorityFactoryCreateDiscoveredInstance",t.AuthorityResolveEndpointsAsync="authorityResolveEndpointsAsync",t.AuthorityGetCloudDiscoveryMetadataFromNetwork="authorityGetCloudDiscoveryMetadataFromNetwork",t.AuthorityUpdateCloudDiscoveryMetadata="authorityUpdateCloudDiscoveryMetadata",t.AuthorityGetEndpointMetadataFromNetwork="authorityGetEndpointMetadataFromNetwork",t.AuthorityUpdateEndpointMetadata="authorityUpdateEndpointMetadata",t.AuthorityUpdateMetadataWithRegionalInformation="authorityUpdateMetadataWithRegionalInformation",t.RegionDiscoveryDetectRegion="regionDiscoveryDetectRegion",t.RegionDiscoveryGetRegionFromIMDS="regionDiscoveryGetRegionFromIMDS",t.RegionDiscoveryGetCurrentVersion="regionDiscoveryGetCurrentVersion",t.AcquireTokenByCodeAsync="acquireTokenByCodeAsync",t.GetEndpointMetadataFromNetwork="getEndpointMetadataFromNetwork",t.GetCloudDiscoveryMetadataFromNetworkMeasurement="getCloudDiscoveryMetadataFromNetworkMeasurement",t.HandleRedirectPromiseMeasurement="handleRedirectPromiseMeasurement",t.UpdateCloudDiscoveryMetadataMeasurement="updateCloudDiscoveryMetadataMeasurement",t.UsernamePasswordClientAcquireToken="usernamePasswordClientAcquireToken",t.NativeMessageHandlerHandshake="nativeMessageHandlerHandshake",t.ClearTokensAndKeysWithClaims="clearTokensAndKeysWithClaims",(s=Qv=Qv||{})[s.NotStarted=0]="NotStarted",s[s.InProgress=1]="InProgress",s[s.Completed=2]="Completed";var r_,i_=new Set(["accessTokenSize","durationMs","idTokenSize","matsSilentStatus","matsHttpStatus","refreshTokenSize","queuedTimeMs","startTimeMs","status"]),n_=((n=r_=r_||{}).SW="sw",n.UHW="uhw",o_.prototype.generateCnf=function(i){var n;return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){switch(e.label){case 0:return null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.PopTokenGenerateCnf,i.correlationId),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.PopTokenGenerateKid,i.correlationId),[4,this.generateKid(i)];case 1:return r=e.sent(),t=this.cryptoUtils.base64Encode(JSON.stringify(r)),r={kid:r.kid,reqCnfString:t},[4,this.cryptoUtils.hashString(t)];case 2:return[2,(r.reqCnfHash=e.sent(),r)]}})})},o_.prototype.generateKid=function(t){var r;return w(this,void 0,void 0,function(){return x(this,function(e){switch(e.label){case 0:return null!=(r=this.performanceClient)&&r.addQueueMeasurement(A.PopTokenGenerateKid,t.correlationId),[4,this.cryptoUtils.getPublicKeyThumbprint(t)];case 1:return[2,{kid:e.sent(),xms_ksl:r_.SW}]}})})},o_.prototype.signPopToken=function(t,r,i){return w(this,void 0,void 0,function(){return x(this,function(e){return[2,this.signPayload(t,r,i)]})})},o_.prototype.signPayload=function(o,a,s,l){return w(this,void 0,void 0,function(){var t,r,i,n;return x(this,function(e){switch(e.label){case 0:return t=s.resourceRequestMethod,n=s.resourceRequestUri,r=s.shrClaims,i=s.shrNonce,n=n?new e_(n):void 0,n=null==n?void 0:n.getUrlComponents(),[4,this.cryptoUtils.signJwt(qm({at:o,ts:Dv.nowSeconds(),m:null==t?void 0:t.toUpperCase(),u:null==n?void 0:n.HostNameAndPort,nonce:i||this.cryptoUtils.createNewGuid(),p:null==n?void 0:n.AbsolutePath,q:null!=n&&n.QueryString?[[],n.QueryString]:void 0,client_claims:r||void 0},l),a,s.correlationId)];case 1:return[2,e.sent()]}})})},o_);function o_(e,t){this.cryptoUtils=e,this.performanceClient=t}s_.prototype.generateAppMetadataKey=function(){return s_.generateAppMetadataCacheKey(this.environment,this.clientId)},s_.generateAppMetadataCacheKey=function(e,t){return[og,e,t].join(Xm.CACHE_KEY_SEPARATOR).toLowerCase()},s_.createAppMetadataEntity=function(e,t,r){var i=new s_;return i.clientId=e,i.environment=t,r&&(i.familyId=r),i},s_.isAppMetadataEntity=function(e,t){return!!t&&0===e.indexOf(og)&&t.hasOwnProperty("clientId")&&t.hasOwnProperty("environment")};var a_=s_;function s_(){}Object.defineProperty(c_.prototype,"cacheHasChanged",{get:function(){return this.hasChanged},enumerable:!1,configurable:!0}),Object.defineProperty(c_.prototype,"tokenCache",{get:function(){return this.cache},enumerable:!1,configurable:!0});var l_=c_;function c_(e,t){this.cache=e,this.hasChanged=t}h_.prototype.validateServerAuthorizationCodeResponse=function(e,t,r){if(!e.state||!t)throw e.state?E.createStateNotFoundError("Cached State"):E.createStateNotFoundError("Server State");if(decodeURIComponent(e.state)!==decodeURIComponent(t))throw E.createStateMismatchError();if(e.error||e.error_description||e.suberror){if(Wv.isInteractionRequiredError(e.error,e.error_description,e.suberror))throw new Wv(e.error||T.EMPTY_STRING,e.error_description,e.suberror,e.timestamp||T.EMPTY_STRING,e.trace_id||T.EMPTY_STRING,e.correlation_id||T.EMPTY_STRING,e.claims||T.EMPTY_STRING);throw new bv(e.error||T.EMPTY_STRING,e.error_description,e.suberror)}e.client_info&&ev(e.client_info,r)},h_.prototype.validateTokenResponse=function(e){if(e.error||e.error_description||e.suberror){if(Wv.isInteractionRequiredError(e.error,e.error_description,e.suberror))throw new Wv(e.error,e.error_description,e.suberror,e.timestamp||T.EMPTY_STRING,e.trace_id||T.EMPTY_STRING,e.correlation_id||T.EMPTY_STRING,e.claims||T.EMPTY_STRING);var t=e.error_codes+" - ["+e.timestamp+"]: "+e.error_description+" - Correlation ID: "+e.correlation_id+" - Trace ID: "+e.trace_id;throw new bv(e.error,t,e.suberror)}},h_.prototype.handleServerTokenResponse=function(a,s,l,c,u,h,d,p,f){var m;return w(this,void 0,void 0,function(){var t,r,i,n,o;return x(this,function(e){switch(e.label){case 0:if(null!=(m=this.performanceClient)&&m.addQueueMeasurement(A.HandleServerTokenResponse,a.correlation_id),a.id_token){if(t=new nv(a.id_token||T.EMPTY_STRING,this.cryptoObj),u&&!I.isEmpty(u.nonce)&&t.claims.nonce!==u.nonce)throw E.createNonceMismatchError();if(c.maxAge||0===c.maxAge){if(!(i=t.claims.auth_time))throw E.createAuthTimeNotFoundError();nv.checkMaxAge(i,c.maxAge)}}this.homeAccountIdentifier=rv.generateHomeAccountId(a.client_info||T.EMPTY_STRING,s.authorityType,this.logger,this.cryptoObj,t),u&&u.state&&(r=Xv.parseRequestState(this.cryptoObj,u.state)),a.key_id=a.key_id||c.sshKid||void 0,i=this.generateCacheRecord(a,s,l,c,t,h,u),e.label=1;case 1:return(e.trys.push([1,,5,8]),this.persistencePlugin&&this.serializableCache)?(this.logger.verbose("Persistence enabled, calling beforeCacheAccess"),n=new l_(this.serializableCache,!0),[4,this.persistencePlugin.beforeCacheAccess(n)]):[3,3];case 2:e.sent(),e.label=3;case 3:return!d||p||!i.account||(o=i.account.generateAccountKey(),this.cacheStorage.getAccount(o))?[4,this.cacheStorage.saveCacheRecord(i)]:(this.logger.warning("Account used to refresh tokens not in persistence, refreshed tokens will not be stored in the cache"),[2,h_.generateAuthenticationResult(this.cryptoObj,s,i,!1,c,t,r,void 0,f)]);case 4:return e.sent(),[3,8];case 5:return this.persistencePlugin&&this.serializableCache&&n?(this.logger.verbose("Persistence enabled, calling afterCacheAccess"),[4,this.persistencePlugin.afterCacheAccess(n)]):[3,7];case 6:e.sent(),e.label=7;case 7:return[7];case 8:return[2,h_.generateAuthenticationResult(this.cryptoObj,s,i,!1,c,t,r,a,f)]}})})},h_.prototype.generateCacheRecord=function(e,t,r,i,n,o,a){var s,l,c=t.getPreferredCache();if(I.isEmpty(c))throw E.createInvalidCacheEnvironmentError();!I.isEmpty(e.id_token)&&n&&(s=Ov.createIdTokenEntity(this.homeAccountIdentifier,c,e.id_token||T.EMPTY_STRING,this.clientId,n.claims.tid||T.EMPTY_STRING),l=this.generateAccountEntity(e,n,t,a));var u,h,d,a=null,p=(I.isEmpty(e.access_token)||(u=e.scope?Jy.fromString(e.scope):new Jy(i.scopes||[]),d=(h=r+(("string"==typeof e.expires_in?parseInt(e.expires_in,10):e.expires_in)||0))+(("string"==typeof e.ext_expires_in?parseInt(e.ext_expires_in,10):e.ext_expires_in)||0),r=(p=("string"==typeof e.refresh_in?parseInt(e.refresh_in,10):e.refresh_in)||void 0)&&0<p?r+p:void 0,a=Bv.createAccessTokenEntity(this.homeAccountIdentifier,c,e.access_token||T.EMPTY_STRING,this.clientId,n?n.claims.tid||T.EMPTY_STRING:t.tenant,u.printScopes(),h,d,this.cryptoObj,r,e.token_type,o,e.key_id,i.claims,i.requestedClaimsHash)),null),n=(I.isEmpty(e.refresh_token)||(p=qv.createRefreshTokenEntity(this.homeAccountIdentifier,c,e.refresh_token||T.EMPTY_STRING,this.clientId,e.foci,o)),null);return I.isEmpty(e.foci)||(n=a_.createAppMetadataEntity(this.clientId,c,e.foci)),new $v(l,s,a,p,n)},h_.prototype.generateAccountEntity=function(e,t,r,i){var n=r.authorityType,o=i?i.cloud_graph_host_name:T.EMPTY_STRING,i=i?i.msgraph_host:T.EMPTY_STRING;if(n===Xy.Adfs)return this.logger.verbose("Authority type is ADFS, creating ADFS account"),rv.createGenericAccount(this.homeAccountIdentifier,t,r,o,i);if(I.isEmpty(e.client_info)&&"AAD"===r.protocolMode)throw E.createClientInfoEmptyError();return e.client_info?rv.createAccount(e.client_info,this.homeAccountIdentifier,t,r,o,i):rv.createGenericAccount(this.homeAccountIdentifier,t,r,o,i)},h_.generateAuthenticationResult=function(c,u,h,d,p,f,m,g,y){var v;return w(this,void 0,void 0,function(){var t,r,i,n,o,a,s,l;return x(this,function(e){switch(e.label){case 0:if(t=T.EMPTY_STRING,r=[],i=null,o=T.EMPTY_STRING,!h.accessToken)return[3,4];if(h.accessToken.tokenType!==eg.POP)return[3,2];if(s=new n_(c),a=h.accessToken,l=a.secret,a=a.keyId)return[4,s.signPopToken(l,a,p)];throw E.createKeyIdMissingError();case 1:return t=e.sent(),[3,3];case 2:t=h.accessToken.secret,e.label=3;case 3:r=Jy.fromString(h.accessToken.target).asArray(),i=new Date(1e3*Number(h.accessToken.expiresOn)),n=new Date(1e3*Number(h.accessToken.extendedExpiresOn)),e.label=4;case 4:return h.appMetadata&&(o="1"===h.appMetadata.familyId?"1":T.EMPTY_STRING),s=(null==f?void 0:f.claims.oid)||(null==f?void 0:f.claims.sub)||T.EMPTY_STRING,l=(null==f?void 0:f.claims.tid)||T.EMPTY_STRING,null!=g&&g.spa_accountid&&h.account&&(h.account.nativeAccountId=null==g?void 0:g.spa_accountid),[2,{authority:u.canonicalAuthority,uniqueId:s,tenantId:l,scopes:r,account:h.account?h.account.getAccountInfo():null,idToken:f?f.rawToken:T.EMPTY_STRING,idTokenClaims:f?f.claims:{},accessToken:t,fromCache:d,expiresOn:i,correlationId:p.correlationId,requestId:y||T.EMPTY_STRING,extExpiresOn:n,familyId:o,tokenType:(null==(v=h.accessToken)?void 0:v.tokenType)||T.EMPTY_STRING,state:m?m.userRequestState:T.EMPTY_STRING,cloudGraphHostName:(null==(v=h.account)?void 0:v.cloudGraphHostName)||T.EMPTY_STRING,msGraphHost:(null==(v=h.account)?void 0:v.msGraphHost)||T.EMPTY_STRING,code:null==g?void 0:g.spa_code,fromNativeBroker:!1}]}})})};var u_=h_;function h_(e,t,r,i,n,o,a){this.clientId=e,this.cacheStorage=t,this.cryptoObj=r,this.logger=i,this.serializableCache=n,this.persistencePlugin=o,this.performanceClient=a}Um(f_,d_=cn),f_.prototype.getAuthCodeUrl=function(r){var i;return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:return null!=(i=this.performanceClient)&&i.addQueueMeasurement(A.GetAuthCodeUrl,r.correlationId),null!=(i=this.performanceClient)&&i.setPreQueueTime(A.AuthClientCreateQueryString,r.correlationId),[4,this.createAuthCodeUrlQueryString(r)];case 1:return t=e.sent(),[2,e_.appendQueryString(this.authority.authorizationEndpoint,t)]}})})},f_.prototype.acquireToken=function(s,l){var c,u;return w(this,void 0,void 0,function(){var t,r,i,n,o,a=this;return x(this,function(e){switch(e.label){case 0:if(s&&s.code)return null!=(c=this.performanceClient)&&c.addQueueMeasurement(A.AuthClientAcquireToken,s.correlationId),t=null==(c=this.performanceClient)?void 0:c.startMeasurement("AuthCodeClientAcquireToken",s.correlationId),this.logger.info("in acquireToken call in auth-code client"),r=Dv.nowSeconds(),null!=(c=this.performanceClient)&&c.setPreQueueTime(A.AuthClientExecuteTokenRequest,s.correlationId),[4,this.executeTokenRequest(this.authority,s)];throw E.createTokenRequestCannotBeMadeError();case 1:return i=e.sent(),n=null==(c=i.headers)?void 0:c[Hm.X_MS_REQUEST_ID],(o=null==(u=i.headers)?void 0:u[Hm.X_MS_HTTP_VERSION])&&null!=t&&t.addStaticFields({httpVerAuthority:o}),(o=new u_(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin,this.performanceClient)).validateTokenResponse(i.body),null!=(u=this.performanceClient)&&u.setPreQueueTime(A.HandleServerTokenResponse,s.correlationId),[2,o.handleServerTokenResponse(i.body,this.authority,r,s,l,void 0,void 0,void 0,n).then(function(e){return null!=t&&t.endMeasurement({success:!0}),e}).catch(function(e){throw a.logger.verbose("Error in fetching token in ACC",s.correlationId),null!=t&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})]}})})},f_.prototype.handleFragmentResponse=function(e,t){var r=new u_(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,null,null),e=new e_(e),e=e_.getDeserializedHash(e.getHash());if(r.validateServerAuthorizationCodeResponse(e,t,this.cryptoUtils),e.code)return qm(qm({},e),{code:e.code});throw E.createNoAuthCodeInServerResponseError()},f_.prototype.getLogoutUri=function(e){if(e)return e=this.createLogoutUrlQueryString(e),e_.appendQueryString(this.authority.endSessionEndpoint,e);throw $y.createEmptyLogoutRequestError()},f_.prototype.executeTokenRequest=function(a,s){var l;return w(this,void 0,void 0,function(){var t,r,i,n,o;return x(this,function(e){switch(e.label){case 0:return null!=(l=this.performanceClient)&&l.addQueueMeasurement(A.AuthClientExecuteTokenRequest,s.correlationId),null!=(l=this.performanceClient)&&l.setPreQueueTime(A.AuthClientCreateTokenRequestBody,s.correlationId),t=this.createTokenQueryParameters(s),t=e_.appendQueryString(a.tokenEndpoint,t),[4,this.createTokenRequestBody(s)];case 1:if(r=e.sent(),n=void 0,s.clientInfo)try{i=ev(s.clientInfo,this.cryptoUtils),n={credential:""+i.uid+Xm.CLIENT_INFO_SEPARATOR+i.utid,type:Tv.HOME_ACCOUNT_ID}}catch(e){this.logger.verbose("Could not parse client info for CCS Header: "+e)}return n=this.createTokenRequestHeaders(n||s.ccsCredential),o={clientId:this.config.authOptions.clientId,authority:a.canonicalAuthority,scopes:s.scopes,claims:s.claims,authenticationScheme:s.authenticationScheme,resourceRequestMethod:s.resourceRequestMethod,resourceRequestUri:s.resourceRequestUri,shrClaims:s.shrClaims,sshKid:s.sshKid},[2,this.executePostToTokenEndpoint(t,r,n,o)]}})})},f_.prototype.createTokenRequestBody=function(s){var l;return w(this,void 0,void 0,function(){var t,r,i,n,o,a;return x(this,function(e){switch(e.label){case 0:return(null!=(l=this.performanceClient)&&l.addQueueMeasurement(A.AuthClientCreateTokenRequestBody,s.correlationId),(t=new kv).addClientId(this.config.authOptions.clientId),this.includeRedirectUri?t.addRedirectUri(s.redirectUri):Iv.validateRedirectUri(s.redirectUri),t.addScopes(s.scopes),t.addAuthorizationCode(s.code),t.addLibraryInfo(this.config.libraryInfo),t.addApplicationTelemetry(this.config.telemetry.application),t.addThrottling(),this.serverTelemetryManager&&t.addServerTelemetry(this.serverTelemetryManager),s.codeVerifier&&t.addCodeVerifier(s.codeVerifier),this.config.clientCredentials.clientSecret&&t.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion&&(r=this.config.clientCredentials.clientAssertion,t.addClientAssertion(r.assertion),t.addClientAssertionType(r.assertionType)),t.addGrantType(Ym.AUTHORIZATION_CODE_GRANT),t.addClientInfo(),s.authenticationScheme!==eg.POP)?[3,2]:(r=new n_(this.cryptoUtils,this.performanceClient),null!=(l=this.performanceClient)&&l.setPreQueueTime(A.PopTokenGenerateCnf,s.correlationId),[4,r.generateCnf(s)]);case 1:return i=e.sent(),t.addPopToken(i.reqCnfString),[3,3];case 2:if(s.authenticationScheme===eg.SSH){if(!s.sshJwk)throw $y.createMissingSshJwkError();t.addSshJwk(s.sshJwk)}e.label=3;case 3:if(i=s.correlationId||this.config.cryptoInterface.createNewGuid(),t.addCorrelationId(i),(!I.isEmptyObj(s.claims)||this.config.authOptions.clientCapabilities&&0<this.config.authOptions.clientCapabilities.length)&&t.addClaims(s.claims,this.config.authOptions.clientCapabilities),n=void 0,s.clientInfo)try{o=ev(s.clientInfo,this.cryptoUtils),n={credential:""+o.uid+Xm.CLIENT_INFO_SEPARATOR+o.utid,type:Tv.HOME_ACCOUNT_ID}}catch(e){this.logger.verbose("Could not parse client info for CCS Header: "+e)}else n=s.ccsCredential;if(this.config.systemOptions.preventCorsPreflight&&n)switch(n.type){case Tv.HOME_ACCOUNT_ID:try{o=tv(n.credential),t.addCcsOid(o)}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case Tv.UPN:t.addCcsUpn(n.credential)}return s.tokenBodyParameters&&t.addExtraQueryParameters(s.tokenBodyParameters),!s.enableSpaAuthorizationCode||s.tokenBodyParameters&&s.tokenBodyParameters[c.RETURN_SPA_CODE]||t.addExtraQueryParameters(((a={})[c.RETURN_SPA_CODE]="1",a)),[2,t.createQueryString()]}})})},f_.prototype.createAuthCodeUrlQueryString=function(o){var a;return w(this,void 0,void 0,function(){var t,r,i,n;return x(this,function(e){switch(e.label){case 0:if(null!=(a=this.performanceClient)&&a.addQueueMeasurement(A.AuthClientCreateQueryString,o.correlationId),(t=new kv).addClientId(this.config.authOptions.clientId),r=jm(o.scopes||[],o.extraScopesToConsent||[]),t.addScopes(r),t.addRedirectUri(o.redirectUri),r=o.correlationId||this.config.cryptoInterface.createNewGuid(),t.addCorrelationId(r),t.addResponseMode(o.responseMode),t.addResponseTypeCode(),t.addLibraryInfo(this.config.libraryInfo),t.addApplicationTelemetry(this.config.telemetry.application),t.addClientInfo(),o.codeChallenge&&o.codeChallengeMethod&&t.addCodeChallengeParams(o.codeChallenge,o.codeChallengeMethod),o.prompt&&t.addPrompt(o.prompt),o.domainHint&&t.addDomainHint(o.domainHint),o.prompt!==ig.SELECT_ACCOUNT)if(o.sid&&o.prompt===ig.NONE)this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from request"),t.addSid(o.sid);else if(o.account){if(r=this.extractAccountSid(o.account),n=this.extractLoginHint(o.account)){this.logger.verbose("createAuthCodeUrlQueryString: login_hint claim present on account"),t.addLoginHint(n);try{i=tv(o.account.homeAccountId),t.addCcsOid(i)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}else if(r&&o.prompt===ig.NONE){this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from account"),t.addSid(r);try{i=tv(o.account.homeAccountId),t.addCcsOid(i)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}else if(o.loginHint)this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from request"),t.addLoginHint(o.loginHint),t.addCcsUpn(o.loginHint);else if(o.account.username){this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from account"),t.addLoginHint(o.account.username);try{i=tv(o.account.homeAccountId),t.addCcsOid(i)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}}else o.loginHint&&(this.logger.verbose("createAuthCodeUrlQueryString: No account, adding login_hint from request"),t.addLoginHint(o.loginHint),t.addCcsUpn(o.loginHint));else this.logger.verbose("createAuthCodeUrlQueryString: Prompt is select_account, ignoring account hints");return(o.nonce&&t.addNonce(o.nonce),o.state&&t.addState(o.state),(!I.isEmpty(o.claims)||this.config.authOptions.clientCapabilities&&0<this.config.authOptions.clientCapabilities.length)&&t.addClaims(o.claims,this.config.authOptions.clientCapabilities),o.extraQueryParameters&&t.addExtraQueryParameters(o.extraQueryParameters),o.nativeBroker)?(t.addNativeBroker(),o.authenticationScheme!==eg.POP?[3,2]:[4,new n_(this.cryptoUtils).generateCnf(o)]):[3,2];case 1:n=e.sent(),t.addPopToken(n.reqCnfString),e.label=2;case 2:return[2,t.createQueryString()]}})})},f_.prototype.createLogoutUrlQueryString=function(e){var t=new kv;return e.postLogoutRedirectUri&&t.addPostLogoutRedirectUri(e.postLogoutRedirectUri),e.correlationId&&t.addCorrelationId(e.correlationId),e.idTokenHint&&t.addIdTokenHint(e.idTokenHint),e.state&&t.addState(e.state),e.logoutHint&&t.addLogoutHint(e.logoutHint),e.extraQueryParameters&&t.addExtraQueryParameters(e.extraQueryParameters),t.createQueryString()},f_.prototype.extractAccountSid=function(e){return(null==(e=e.idTokenClaims)?void 0:e.sid)||null},f_.prototype.extractLoginHint=function(e){return(null==(e=e.idTokenClaims)?void 0:e.login_hint)||null};var d_,p_=f_;function f_(e,t){e=d_.call(this,e,t)||this;return e.includeRedirectUri=!0,e}Um(y_,m_=cn),y_.prototype.acquireToken=function(s){var l,c,u;return w(this,void 0,void 0,function(){var t,r,i,n,o,a=this;return x(this,function(e){switch(e.label){case 0:return null!=(l=this.performanceClient)&&l.addQueueMeasurement(A.RefreshTokenClientAcquireToken,s.correlationId),t=null==(l=this.performanceClient)?void 0:l.startMeasurement(A.RefreshTokenClientAcquireToken,s.correlationId),this.logger.verbose("RefreshTokenClientAcquireToken called",s.correlationId),r=Dv.nowSeconds(),null!=(l=this.performanceClient)&&l.setPreQueueTime(A.RefreshTokenClientExecuteTokenRequest,s.correlationId),[4,this.executeTokenRequest(s,this.authority)];case 1:return i=e.sent(),n=null==(l=i.headers)?void 0:l[Hm.X_MS_HTTP_VERSION],null!=t&&t.addStaticFields({refreshTokenSize:(null==(c=i.body.refresh_token)?void 0:c.length)||0}),n&&null!=t&&t.addStaticFields({httpVerToken:n}),n=null==(c=i.headers)?void 0:c[Hm.X_MS_REQUEST_ID],(o=new u_(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin)).validateTokenResponse(i.body),null!=(u=this.performanceClient)&&u.setPreQueueTime(A.HandleServerTokenResponse,s.correlationId),[2,o.handleServerTokenResponse(i.body,this.authority,r,s,void 0,void 0,!0,s.forceCache,n).then(function(e){return null!=t&&t.endMeasurement({success:!0}),e}).catch(function(e){throw a.logger.verbose("Error in fetching refresh token",s.correlationId),null!=t&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})]}})})},y_.prototype.acquireTokenByRefreshToken=function(i){var n,o;return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){if(!i)throw $y.createEmptyTokenRequestError();if(null!=(o=this.performanceClient)&&o.addQueueMeasurement(A.RefreshTokenClientAcquireTokenByRefreshToken,i.correlationId),!i.account)throw E.createNoAccountInSilentRequestError();if(this.cacheManager.isAppMetadataFOCI(i.account.environment))try{return null!=(n=this.performanceClient)&&n.setPreQueueTime(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,i.correlationId),[2,this.acquireTokenWithCachedRefreshToken(i,!0)]}catch(e){if(t=e instanceof Wv&&e.errorCode===Kv.code,r=e instanceof bv&&e.errorCode===_g&&e.subError===bg,t||r)return null!=(o=this.performanceClient)&&o.setPreQueueTime(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,i.correlationId),[2,this.acquireTokenWithCachedRefreshToken(i,!1)];throw e}return null!=(o=this.performanceClient)&&o.setPreQueueTime(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,i.correlationId),[2,this.acquireTokenWithCachedRefreshToken(i,!1)]})})},y_.prototype.acquireTokenWithCachedRefreshToken=function(i,n){var o;return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){if(null!=(o=this.performanceClient)&&o.addQueueMeasurement(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,i.correlationId),t=null==(o=this.performanceClient)?void 0:o.startMeasurement(A.RefreshTokenClientAcquireTokenWithCachedRefreshToken,i.correlationId),this.logger.verbose("RefreshTokenClientAcquireTokenWithCachedRefreshToken called",i.correlationId),r=this.cacheManager.getRefreshToken(i.account,n))return null!=t&&t.endMeasurement({success:!0}),r=qm(qm({},i),{refreshToken:r.secret,authenticationScheme:i.authenticationScheme||eg.BEARER,ccsCredential:{credential:i.account.homeAccountId,type:Tv.HOME_ACCOUNT_ID}}),null!=(o=this.performanceClient)&&o.setPreQueueTime(A.RefreshTokenClientAcquireToken,i.correlationId),[2,this.acquireToken(r)];throw null!=t&&t.discardMeasurement(),Wv.createNoTokensFoundError()})})},y_.prototype.executeTokenRequest=function(a,s){var l;return w(this,void 0,void 0,function(){var t,r,i,n,o;return x(this,function(e){switch(e.label){case 0:return null!=(l=this.performanceClient)&&l.addQueueMeasurement(A.RefreshTokenClientExecuteTokenRequest,a.correlationId),t=null==(l=this.performanceClient)?void 0:l.startMeasurement(A.RefreshTokenClientExecuteTokenRequest,a.correlationId),null!=(l=this.performanceClient)&&l.setPreQueueTime(A.RefreshTokenClientCreateTokenRequestBody,a.correlationId),r=this.createTokenQueryParameters(a),r=e_.appendQueryString(s.tokenEndpoint,r),[4,this.createTokenRequestBody(a)];case 1:return i=e.sent(),n=this.createTokenRequestHeaders(a.ccsCredential),o={clientId:this.config.authOptions.clientId,authority:s.canonicalAuthority,scopes:a.scopes,claims:a.claims,authenticationScheme:a.authenticationScheme,resourceRequestMethod:a.resourceRequestMethod,resourceRequestUri:a.resourceRequestUri,shrClaims:a.shrClaims,sshKid:a.sshKid},[2,this.executePostToTokenEndpoint(r,i,n,o).then(function(e){return null!=t&&t.endMeasurement({success:!0}),e}).catch(function(e){throw null!=t&&t.endMeasurement({success:!1}),e})]}})})},y_.prototype.createTokenRequestBody=function(o){var a;return w(this,void 0,void 0,function(){var t,r,i,n;return x(this,function(e){switch(e.label){case 0:return(null!=(a=this.performanceClient)&&a.addQueueMeasurement(A.RefreshTokenClientCreateTokenRequestBody,o.correlationId),i=o.correlationId,t=null==(a=this.performanceClient)?void 0:a.startMeasurement(A.BaseClientCreateTokenRequestHeaders,i),(r=new kv).addClientId(this.config.authOptions.clientId),r.addScopes(o.scopes),r.addGrantType(Ym.REFRESH_TOKEN_GRANT),r.addClientInfo(),r.addLibraryInfo(this.config.libraryInfo),r.addApplicationTelemetry(this.config.telemetry.application),r.addThrottling(),this.serverTelemetryManager&&r.addServerTelemetry(this.serverTelemetryManager),r.addCorrelationId(i),r.addRefreshToken(o.refreshToken),this.config.clientCredentials.clientSecret&&r.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion&&(i=this.config.clientCredentials.clientAssertion,r.addClientAssertion(i.assertion),r.addClientAssertionType(i.assertionType)),o.authenticationScheme!==eg.POP)?[3,2]:(i=new n_(this.cryptoUtils,this.performanceClient),null!=(a=this.performanceClient)&&a.setPreQueueTime(A.PopTokenGenerateCnf,o.correlationId),[4,i.generateCnf(o)]);case 1:return i=e.sent(),r.addPopToken(i.reqCnfString),[3,3];case 2:if(o.authenticationScheme===eg.SSH){if(!o.sshJwk)throw null!=t&&t.endMeasurement({success:!1}),$y.createMissingSshJwkError();r.addSshJwk(o.sshJwk)}e.label=3;case 3:if((!I.isEmptyObj(o.claims)||this.config.authOptions.clientCapabilities&&0<this.config.authOptions.clientCapabilities.length)&&r.addClaims(o.claims,this.config.authOptions.clientCapabilities),this.config.systemOptions.preventCorsPreflight&&o.ccsCredential)switch(o.ccsCredential.type){case Tv.HOME_ACCOUNT_ID:try{n=tv(o.ccsCredential.credential),r.addCcsOid(n)}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case Tv.UPN:r.addCcsUpn(o.ccsCredential.credential)}return null!=t&&t.endMeasurement({success:!0}),[2,r.createQueryString()]}})})};var m_,g_=y_;function y_(e,t){return m_.call(this,e,t)||this}Um(b_,v_=cn),b_.prototype.acquireToken=function(r){return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),[4,this.acquireCachedToken(r)];case 1:return[2,e.sent()];case 2:if((t=e.sent())instanceof E&&t.errorCode===uy.code)return[2,new g_(this.config,this.performanceClient).acquireTokenByRefreshToken(r)];throw t;case 3:return[2]}})})},b_.prototype.acquireCachedToken=function(r){var i,n,o;return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:if(!r)throw $y.createEmptyTokenRequestError();if(r.forceRefresh)throw null!=(i=this.serverTelemetryManager)&&i.setCacheOutcome(pg.FORCE_REFRESH),this.logger.info("SilentFlowClient:acquireCachedToken - Skipping cache because forceRefresh is true."),E.createRefreshRequiredError();if(!this.config.cacheOptions.claimsBasedCachingEnabled&&!I.isEmptyObj(r.claims))throw null!=(i=this.serverTelemetryManager)&&i.setCacheOutcome(pg.CLAIMS_REQUESTED_CACHE_SKIPPED),this.logger.info("SilentFlowClient:acquireCachedToken - Skipping cache because claims-based caching is disabled and claims were requested."),E.createRefreshRequiredError();if(!r.account)throw E.createNoAccountInSilentRequestError();if(t=r.authority||this.authority.getPreferredCache(),!(t=this.cacheManager.readCacheRecord(r.account,r,t)).accessToken)throw null!=(n=this.serverTelemetryManager)&&n.setCacheOutcome(pg.NO_CACHED_ACCESS_TOKEN),this.logger.info("SilentFlowClient:acquireCachedToken - No access token found in cache for the given properties."),E.createRefreshRequiredError();if(Dv.wasClockTurnedBack(t.accessToken.cachedAt)||Dv.isTokenExpired(t.accessToken.expiresOn,this.config.systemOptions.tokenRenewalOffsetSeconds))throw null!=(n=this.serverTelemetryManager)&&n.setCacheOutcome(pg.CACHED_ACCESS_TOKEN_EXPIRED),this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token is expired or will expire within "+this.config.systemOptions.tokenRenewalOffsetSeconds+" seconds."),E.createRefreshRequiredError();if(t.accessToken.refreshOn&&Dv.isTokenExpired(t.accessToken.refreshOn,0))throw null!=(o=this.serverTelemetryManager)&&o.setCacheOutcome(pg.REFRESH_CACHED_ACCESS_TOKEN),this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token's refreshOn property has been exceeded'."),E.createRefreshRequiredError();return this.config.serverTelemetryManager&&this.config.serverTelemetryManager.incrementCacheHits(),[4,this.generateResultFromCacheRecord(t,r)];case 1:return[2,e.sent()]}})})},b_.prototype.generateResultFromCacheRecord=function(i,n){return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){switch(e.label){case 0:if(i.idToken&&(t=new nv(i.idToken.secret,this.config.cryptoInterface)),n.maxAge||0===n.maxAge){if(!(r=null==t?void 0:t.claims.auth_time))throw E.createAuthTimeNotFoundError();nv.checkMaxAge(r,n.maxAge)}return[4,u_.generateAuthenticationResult(this.cryptoUtils,this.authority,i,!0,n,t)];case 1:return[2,e.sent()]}})})};var v_,__=b_;function b_(e,t){return v_.call(this,e,t)||this}var w_,x_={"https://login.microsoftonline.com/common/":{token_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.com/common/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.com/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.com/common/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.com/common/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.com",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pas.windows.net"},"https://login.chinacloudapi.cn/common/":{token_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.chinacloudapi.cn/common/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.partner.microsoftonline.cn/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://microsoftgraph.chinacloudapi.cn/oidc/userinfo",authorization_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.chinacloudapi.cn/common/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.chinacloudapi.cn/common/kerberos",tenant_region_scope:null,cloud_instance_name:"partner.microsoftonline.cn",cloud_graph_host_name:"graph.chinacloudapi.cn",msgraph_host:"microsoftgraph.chinacloudapi.cn",rbac_url:"https://pas.chinacloudapi.cn"},"https://login.microsoftonline.us/common/":{token_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.us/common/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.us/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.us/common/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.us/common/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.us",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pasff.usgovcloudapi.net"},"https://login.microsoftonline.com/consumers/":{token_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.com/consumers/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.com/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.com/consumers/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.com/consumers/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.com",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pas.windows.net"},"https://login.chinacloudapi.cn/consumers/":{token_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.chinacloudapi.cn/consumers/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.partner.microsoftonline.cn/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://microsoftgraph.chinacloudapi.cn/oidc/userinfo",authorization_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.chinacloudapi.cn/consumers/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.chinacloudapi.cn/consumers/kerberos",tenant_region_scope:null,cloud_instance_name:"partner.microsoftonline.cn",cloud_graph_host_name:"graph.chinacloudapi.cn",msgraph_host:"microsoftgraph.chinacloudapi.cn",rbac_url:"https://pas.chinacloudapi.cn"},"https://login.microsoftonline.us/consumers/":{token_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.us/consumers/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.us/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.us/consumers/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.us/consumers/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.us",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pasff.usgovcloudapi.net"},"https://login.microsoftonline.com/organizations/":{token_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.com/organizations/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.com/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.com/organizations/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.com/organizations/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.com",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pas.windows.net"},"https://login.chinacloudapi.cn/organizations/":{token_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.chinacloudapi.cn/organizations/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.partner.microsoftonline.cn/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://microsoftgraph.chinacloudapi.cn/oidc/userinfo",authorization_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.chinacloudapi.cn/organizations/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.chinacloudapi.cn/organizations/kerberos",tenant_region_scope:null,cloud_instance_name:"partner.microsoftonline.cn",cloud_graph_host_name:"graph.chinacloudapi.cn",msgraph_host:"microsoftgraph.chinacloudapi.cn",rbac_url:"https://pas.chinacloudapi.cn"},"https://login.microsoftonline.us/organizations/":{token_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/token",token_endpoint_auth_methods_supported:["client_secret_post","private_key_jwt","client_secret_basic"],jwks_uri:"https://login.microsoftonline.us/organizations/discovery/v2.0/keys",response_modes_supported:["query","fragment","form_post"],subject_types_supported:["pairwise"],id_token_signing_alg_values_supported:["RS256"],response_types_supported:["code","id_token","code id_token","id_token token"],scopes_supported:["openid","profile","email","offline_access"],issuer:"https://login.microsoftonline.us/{tenantid}/v2.0",request_uri_parameter_supported:!1,userinfo_endpoint:"https://graph.microsoft.com/oidc/userinfo",authorization_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/authorize",device_authorization_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/devicecode",http_logout_supported:!0,frontchannel_logout_supported:!0,end_session_endpoint:"https://login.microsoftonline.us/organizations/oauth2/v2.0/logout",claims_supported:["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],kerberos_endpoint:"https://login.microsoftonline.us/organizations/kerberos",tenant_region_scope:null,cloud_instance_name:"microsoftonline.us",cloud_graph_host_name:"graph.windows.net",msgraph_host:"graph.microsoft.com",rbac_url:"https://pasff.usgovcloudapi.net"}},C_={"https://login.microsoftonline.com/common/":{tenant_discovery_endpoint:"https://login.microsoftonline.com/common/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.chinacloudapi.cn/common/":{tenant_discovery_endpoint:"https://login.chinacloudapi.cn/common/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.us/common/":{tenant_discovery_endpoint:"https://login.microsoftonline.us/common/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.com/consumers/":{tenant_discovery_endpoint:"https://login.microsoftonline.com/consumers/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.chinacloudapi.cn/consumers/":{tenant_discovery_endpoint:"https://login.chinacloudapi.cn/consumers/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.us/consumers/":{tenant_discovery_endpoint:"https://login.microsoftonline.us/consumers/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.com/organizations/":{tenant_discovery_endpoint:"https://login.microsoftonline.com/organizations/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.chinacloudapi.cn/organizations/":{tenant_discovery_endpoint:"https://login.chinacloudapi.cn/organizations/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]},"https://login.microsoftonline.us/organizations/":{tenant_discovery_endpoint:"https://login.microsoftonline.us/organizations/v2.0/.well-known/openid-configuration","api-version":"1.1",metadata:[{preferred_network:"login.microsoftonline.com",preferred_cache:"login.windows.net",aliases:["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{preferred_network:"login.partner.microsoftonline.cn",preferred_cache:"login.partner.microsoftonline.cn",aliases:["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{preferred_network:"login.microsoftonline.de",preferred_cache:"login.microsoftonline.de",aliases:["login.microsoftonline.de"]},{preferred_network:"login.microsoftonline.us",preferred_cache:"login.microsoftonline.us",aliases:["login.microsoftonline.us","login.usgovcloudapi.net"]},{preferred_network:"login-us.microsoftonline.com",preferred_cache:"login-us.microsoftonline.com",aliases:["login-us.microsoftonline.com"]}]}},T_=((ai=w_=w_||{}).AAD="AAD",ai.OIDC="OIDC",S_.prototype.updateCloudDiscoveryMetadata=function(e,t){this.aliases=e.aliases,this.preferred_cache=e.preferred_cache,this.preferred_network=e.preferred_network,this.aliasesFromNetwork=t},S_.prototype.updateEndpointMetadata=function(e,t){this.authorization_endpoint=e.authorization_endpoint,this.token_endpoint=e.token_endpoint,this.end_session_endpoint=e.end_session_endpoint,this.issuer=e.issuer,this.endpointsFromNetwork=t,this.jwks_uri=e.jwks_uri},S_.prototype.updateCanonicalAuthority=function(e){this.canonical_authority=e},S_.prototype.resetExpiresAt=function(){this.expiresAt=Dv.nowSeconds()+sg},S_.prototype.isExpired=function(){return this.expiresAt<=Dv.nowSeconds()},S_.isAuthorityMetadataEntity=function(e,t){return!!t&&0===e.indexOf(ag)&&t.hasOwnProperty("aliases")&&t.hasOwnProperty("preferred_cache")&&t.hasOwnProperty("preferred_network")&&t.hasOwnProperty("canonical_authority")&&t.hasOwnProperty("authorization_endpoint")&&t.hasOwnProperty("token_endpoint")&&t.hasOwnProperty("issuer")&&t.hasOwnProperty("aliasesFromNetwork")&&t.hasOwnProperty("endpointsFromNetwork")&&t.hasOwnProperty("expiresAt")&&t.hasOwnProperty("jwks_uri")},S_);function S_(){this.expiresAt=Dv.nowSeconds()+sg}I_.prototype.detectRegion=function(o,a){var s,l;return w(this,void 0,void 0,function(){var t,r,i,n;return x(this,function(e){switch(e.label){case 0:if(null!=(s=this.performanceClient)&&s.addQueueMeasurement(A.RegionDiscoveryDetectRegion,this.correlationId),t=o)return[3,8];r=I_.IMDS_OPTIONS,e.label=1;case 1:return e.trys.push([1,6,,7]),null!=(s=this.performanceClient)&&s.setPreQueueTime(A.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[4,this.getRegionFromIMDS(T.IMDS_VERSION,r)];case 2:return((i=e.sent()).status===ug.httpSuccess&&(t=i.body,a.region_source=hg.IMDS),i.status!==ug.httpBadRequest)?[3,5]:(null!=(l=this.performanceClient)&&l.setPreQueueTime(A.RegionDiscoveryGetCurrentVersion,this.correlationId),[4,this.getCurrentVersion(r)]);case 3:return(i=e.sent())?(null!=(l=this.performanceClient)&&l.setPreQueueTime(A.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[4,this.getRegionFromIMDS(i,r)]):(a.region_source=hg.FAILED_AUTO_DETECTION,[2,null]);case 4:(n=e.sent()).status===ug.httpSuccess&&(t=n.body,a.region_source=hg.IMDS),e.label=5;case 5:return[3,7];case 6:return e.sent(),a.region_source=hg.FAILED_AUTO_DETECTION,[2,null];case 7:return[3,9];case 8:a.region_source=hg.ENVIRONMENT_VARIABLE,e.label=9;case 9:return t||(a.region_source=hg.FAILED_AUTO_DETECTION),[2,t||null]}})})},I_.prototype.getRegionFromIMDS=function(t,r){var i;return w(this,void 0,void 0,function(){return x(this,function(e){return null!=(i=this.performanceClient)&&i.addQueueMeasurement(A.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[2,this.networkInterface.sendGetRequestAsync(T.IMDS_ENDPOINT+"?api-version="+t+"&format=text",r,T.IMDS_TIMEOUT)]})})},I_.prototype.getCurrentVersion=function(r){var i;return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:null!=(i=this.performanceClient)&&i.addQueueMeasurement(A.RegionDiscoveryGetCurrentVersion,this.correlationId),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(T.IMDS_ENDPOINT+"?format=json",r)];case 2:return(t=e.sent()).status===ug.httpBadRequest&&t.body&&t.body["newest-versions"]&&0<t.body["newest-versions"].length?[2,t.body["newest-versions"][0]]:[2,null];case 3:return e.sent(),[2,null];case 4:return[2]}})})},I_.IMDS_OPTIONS={headers:{Metadata:"true"}};var E_=I_;function I_(e,t,r){this.networkInterface=e,this.performanceClient=t,this.correlationId=r}m.prototype.getAuthorityType=function(e){if(e.HostNameAndPort.endsWith(T.CIAM_AUTH_URL))return Xy.Ciam;e=e.PathSegments;if(e.length)switch(e[0].toLowerCase()){case T.ADFS:return Xy.Adfs;case T.DSTS:return Xy.Dsts}return Xy.Default},Object.defineProperty(m.prototype,"authorityType",{get:function(){return this.getAuthorityType(this.canonicalAuthorityUrlComponents)},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"protocolMode",{get:function(){return this.authorityOptions.protocolMode},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"options",{get:function(){return this.authorityOptions},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"canonicalAuthority",{get:function(){return this._canonicalAuthority.urlString},set:function(e){this._canonicalAuthority=new e_(e),this._canonicalAuthority.validateAsUri(),this._canonicalAuthorityUrlComponents=null},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"canonicalAuthorityUrlComponents",{get:function(){return this._canonicalAuthorityUrlComponents||(this._canonicalAuthorityUrlComponents=this._canonicalAuthority.getUrlComponents()),this._canonicalAuthorityUrlComponents},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"hostnameAndPort",{get:function(){return this.canonicalAuthorityUrlComponents.HostNameAndPort.toLowerCase()},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"tenant",{get:function(){return this.canonicalAuthorityUrlComponents.PathSegments[0]},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"authorizationEndpoint",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.authorization_endpoint);throw E.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"tokenEndpoint",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.token_endpoint);throw E.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"deviceCodeEndpoint",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.token_endpoint.replace("/token","/devicecode"));throw E.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"endSessionEndpoint",{get:function(){if(this.discoveryComplete()){if(this.metadata.end_session_endpoint)return this.replacePath(this.metadata.end_session_endpoint);throw E.createLogoutNotSupportedError()}throw E.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"selfSignedJwtAudience",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.issuer);throw E.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(m.prototype,"jwksUri",{get:function(){if(this.discoveryComplete())return this.replacePath(this.metadata.jwks_uri);throw E.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),m.prototype.canReplaceTenant=function(e){return 1===e.PathSegments.length&&!m.reservedTenantDomains.has(e.PathSegments[0])&&this.getAuthorityType(e)===Xy.Default&&this.protocolMode===w_.AAD},m.prototype.replaceTenant=function(e){return e.replace(/{tenant}|{tenantid}/g,this.tenant)},m.prototype.replacePath=function(e){var i=this,n=e,o=new e_(this.metadata.canonical_authority).getUrlComponents(),a=o.PathSegments;return this.canonicalAuthorityUrlComponents.PathSegments.forEach(function(e,t){var r=a[t];0===t&&i.canReplaceTenant(o)&&r!==(t=new e_(i.metadata.authorization_endpoint).getUrlComponents().PathSegments[0])&&(i.logger.verbose("Replacing tenant domain name "+r+" with id "+t),r=t),e!==r&&(n=n.replace("/"+r+"/","/"+e+"/"))}),this.replaceTenant(n)},Object.defineProperty(m.prototype,"defaultOpenIdConfigurationEndpoint",{get:function(){return this.authorityType===Xy.Adfs||this.authorityType===Xy.Dsts||this.protocolMode===w_.OIDC?this.canonicalAuthority+".well-known/openid-configuration":this.canonicalAuthority+"v2.0/.well-known/openid-configuration"},enumerable:!1,configurable:!0}),m.prototype.discoveryComplete=function(){return!!this.metadata},m.prototype.resolveEndpointsAsync=function(){var n;return w(this,void 0,void 0,function(){var t,r,i;return x(this,function(e){switch(e.label){case 0:return null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityResolveEndpointsAsync,this.correlationId),(t=this.cacheManager.getAuthorityMetadataByAlias(this.hostnameAndPort))||(t=new T_).updateCanonicalAuthority(this.canonicalAuthority),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityUpdateCloudDiscoveryMetadata,this.correlationId),[4,this.updateCloudDiscoveryMetadata(t)];case 1:return r=e.sent(),this.canonicalAuthority=this.canonicalAuthority.replace(this.hostnameAndPort,t.preferred_network),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityUpdateEndpointMetadata,this.correlationId),[4,this.updateEndpointMetadata(t)];case 2:return i=e.sent(),r!==Qm.CACHE&&i!==Qm.CACHE&&(t.resetExpiresAt(),t.updateCanonicalAuthority(this.canonicalAuthority)),i=this.cacheManager.generateAuthorityMetadataCacheKey(t.preferred_cache),this.cacheManager.setAuthorityMetadata(i,t),this.metadata=t,[2]}})})},m.prototype.updateEndpointMetadata=function(i){var n,o,a;return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){switch(e.label){case 0:return(null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityUpdateEndpointMetadata,this.correlationId),t=this.getEndpointMetadataFromConfig())?(i.updateEndpointMetadata(t,!1),[2,Qm.CONFIG]):this.isAuthoritySameType(i)&&i.endpointsFromNetwork&&!i.isExpired()?[2,Qm.CACHE]:(null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityGetEndpointMetadataFromNetwork,this.correlationId),[4,this.getEndpointMetadataFromNetwork()]);case 1:return(t=e.sent())?null!=(n=this.authorityOptions.azureRegionConfiguration)&&n.azureRegion?(null!=(o=this.performanceClient)&&o.setPreQueueTime(A.AuthorityUpdateMetadataWithRegionalInformation,this.correlationId),[4,this.updateMetadataWithRegionalInformation(t)]):[3,3]:[3,4];case 2:t=e.sent(),e.label=3;case 3:return i.updateEndpointMetadata(t,!0),[2,Qm.NETWORK];case 4:return!(r=this.getEndpointMetadataFromHardcodedValues())||this.authorityOptions.skipAuthorityMetadataCache?[3,7]:null!=(o=this.authorityOptions.azureRegionConfiguration)&&o.azureRegion?(null!=(a=this.performanceClient)&&a.setPreQueueTime(A.AuthorityUpdateMetadataWithRegionalInformation,this.correlationId),[4,this.updateMetadataWithRegionalInformation(r)]):[3,6];case 5:r=e.sent(),e.label=6;case 6:return i.updateEndpointMetadata(r,!1),[2,Qm.HARDCODED_VALUES];case 7:throw E.createUnableToGetOpenidConfigError(this.defaultOpenIdConfigurationEndpoint)}})})},m.prototype.isAuthoritySameType=function(e){return new e_(e.canonical_authority).getUrlComponents().PathSegments.length===this.canonicalAuthorityUrlComponents.PathSegments.length},m.prototype.getEndpointMetadataFromConfig=function(){if(this.authorityOptions.authorityMetadata)try{return JSON.parse(this.authorityOptions.authorityMetadata)}catch(e){throw $y.createInvalidAuthorityMetadataError()}return null},m.prototype.getEndpointMetadataFromNetwork=function(){var n;return w(this,void 0,void 0,function(){var r,i;return x(this,function(e){switch(e.label){case 0:null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityGetEndpointMetadataFromNetwork,this.correlationId),r={},e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(this.defaultOpenIdConfigurationEndpoint,r)];case 2:return i=e.sent(),[2,(t=i.body).hasOwnProperty("authorization_endpoint")&&t.hasOwnProperty("token_endpoint")&&t.hasOwnProperty("issuer")&&t.hasOwnProperty("jwks_uri")?i.body:null];case 3:return e.sent(),[2,null];case 4:return[2]}var t})})},m.prototype.getEndpointMetadataFromHardcodedValues=function(){return this.canonicalAuthority in x_?x_[this.canonicalAuthority]:null},m.prototype.updateMetadataWithRegionalInformation=function(r){var i;return w(this,void 0,void 0,function(){var t;return x(this,function(e){switch(e.label){case 0:return(null!=(i=this.performanceClient)&&i.addQueueMeasurement(A.AuthorityUpdateMetadataWithRegionalInformation,this.correlationId),t=null==(i=this.authorityOptions.azureRegionConfiguration)?void 0:i.azureRegion)?t!==T.AZURE_REGION_AUTO_DISCOVER_FLAG?(this.regionDiscoveryMetadata.region_outcome=dg.CONFIGURED_NO_AUTO_DETECTION,this.regionDiscoveryMetadata.region_used=t,[2,m.replaceWithRegionalInformation(r,t)]):(null!=(i=this.performanceClient)&&i.setPreQueueTime(A.RegionDiscoveryDetectRegion,this.correlationId),[4,this.regionDiscovery.detectRegion(null==(i=this.authorityOptions.azureRegionConfiguration)?void 0:i.environmentRegion,this.regionDiscoveryMetadata)]):[3,2];case 1:if(t=e.sent())return this.regionDiscoveryMetadata.region_outcome=dg.AUTO_DETECTION_REQUESTED_SUCCESSFUL,this.regionDiscoveryMetadata.region_used=t,[2,m.replaceWithRegionalInformation(r,t)];this.regionDiscoveryMetadata.region_outcome=dg.AUTO_DETECTION_REQUESTED_FAILED,e.label=2;case 2:return[2,r]}})})},m.prototype.updateCloudDiscoveryMetadata=function(i){var n;return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){switch(e.label){case 0:return(null!=(n=this.performanceClient)&&n.addQueueMeasurement(A.AuthorityUpdateCloudDiscoveryMetadata,this.correlationId),this.logger.verbose("Attempting to get cloud discovery metadata in the config"),this.logger.verbosePii("Known Authorities: "+(this.authorityOptions.knownAuthorities||T.NOT_APPLICABLE)),this.logger.verbosePii("Authority Metadata: "+(this.authorityOptions.authorityMetadata||T.NOT_APPLICABLE)),this.logger.verbosePii("Canonical Authority: "+(i.canonical_authority||T.NOT_APPLICABLE)),t=this.getCloudDiscoveryMetadataFromConfig())?(this.logger.verbose("Found cloud discovery metadata in the config."),i.updateCloudDiscoveryMetadata(t,!1),[2,Qm.CONFIG]):(this.logger.verbose("Did not find cloud discovery metadata in the config... Attempting to get cloud discovery metadata from the cache."),r=i.isExpired(),this.isAuthoritySameType(i)&&i.aliasesFromNetwork&&!r?(this.logger.verbose("Found metadata in the cache."),[2,Qm.CACHE]):(r&&this.logger.verbose("The metadata entity is expired."),this.logger.verbose("Did not find cloud discovery metadata in the cache... Attempting to get cloud discovery metadata from the network."),null!=(n=this.performanceClient)&&n.setPreQueueTime(A.AuthorityGetCloudDiscoveryMetadataFromNetwork,this.correlationId),[4,this.getCloudDiscoveryMetadataFromNetwork()]));case 1:if(t=e.sent())return this.logger.verbose("cloud discovery metadata was successfully returned from getCloudDiscoveryMetadataFromNetwork()"),i.updateCloudDiscoveryMetadata(t,!0),[2,Qm.NETWORK];if(this.logger.verbose("Did not find cloud discovery metadata from the network... Attempting to get cloud discovery metadata from hardcoded values."),(r=this.getCloudDiscoveryMetadataFromHarcodedValues())&&!this.options.skipAuthorityMetadataCache)return this.logger.verbose("Found cloud discovery metadata from hardcoded values."),i.updateCloudDiscoveryMetadata(r,!1),[2,Qm.HARDCODED_VALUES];throw this.logger.error("Did not find cloud discovery metadata from hardcoded values... Metadata could not be obtained from config, cache, network or hardcoded values. Throwing Untrusted Authority Error."),$y.createUntrustedAuthorityError()}})})},m.prototype.getCloudDiscoveryMetadataFromConfig=function(){if(this.authorityType===Xy.Ciam)return this.logger.verbose("CIAM authorities do not support cloud discovery metadata, generate the aliases from authority host."),m.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort);if(this.authorityOptions.cloudDiscoveryMetadata){this.logger.verbose("The cloud discovery metadata has been provided as a network response, in the config.");try{this.logger.verbose("Attempting to parse the cloud discovery metadata.");var e=JSON.parse(this.authorityOptions.cloudDiscoveryMetadata),t=m.getCloudDiscoveryMetadataFromNetworkResponse(e.metadata,this.hostnameAndPort);if(this.logger.verbose("Parsed the cloud discovery metadata."),t)return this.logger.verbose("There is returnable metadata attached to the parsed cloud discovery metadata."),t;this.logger.verbose("There is no metadata attached to the parsed cloud discovery metadata.")}catch(e){throw this.logger.verbose("Unable to parse the cloud discovery metadata. Throwing Invalid Cloud Discovery Metadata Error."),$y.createInvalidCloudDiscoveryMetadataError()}}return this.isInKnownAuthorities()?(this.logger.verbose("The host is included in knownAuthorities. Creating new cloud discovery metadata from the host."),m.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort)):null},m.prototype.getCloudDiscoveryMetadataFromNetwork=function(){var l;return w(this,void 0,void 0,function(){var r,i,n,o,a,s;return x(this,function(e){switch(e.label){case 0:null!=(l=this.performanceClient)&&l.addQueueMeasurement(A.AuthorityGetCloudDiscoveryMetadataFromNetwork,this.correlationId),r=""+T.AAD_INSTANCE_DISCOVERY_ENDPT+this.canonicalAuthority+"oauth2/v2.0/authorize",i={},n=null,e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(r,i)];case 2:if(s=e.sent(),a=o=void 0,(t=s.body).hasOwnProperty("tenant_discovery_endpoint")&&t.hasOwnProperty("metadata"))o=s.body,a=o.metadata,this.logger.verbosePii("tenant_discovery_endpoint is: "+o.tenant_discovery_endpoint);else{if(!(t=s.body).hasOwnProperty("error")||!t.hasOwnProperty("error_description"))return this.logger.error("AAD did not return a CloudInstanceDiscoveryResponse or CloudInstanceDiscoveryErrorResponse"),[2,null];if(this.logger.warning("A CloudInstanceDiscoveryErrorResponse was returned. The cloud instance discovery network request's status code is: "+s.status),(o=s.body).error===T.INVALID_INSTANCE)return this.logger.error("The CloudInstanceDiscoveryErrorResponse error is invalid_instance."),[2,null];this.logger.warning("The CloudInstanceDiscoveryErrorResponse error is "+o.error),this.logger.warning("The CloudInstanceDiscoveryErrorResponse error description is "+o.error_description),this.logger.warning("Setting the value of the CloudInstanceDiscoveryMetadata (returned from the network) to []"),a=[]}return this.logger.verbose("Attempting to find a match between the developer's authority and the CloudInstanceDiscoveryMetadata returned from the network request."),n=m.getCloudDiscoveryMetadataFromNetworkResponse(a,this.hostnameAndPort),[3,4];case 3:return(s=e.sent())instanceof S?this.logger.error("There was a network error while attempting to get the cloud discovery instance metadata.\nError: "+s.errorCode+"\nError Description: "+s.errorMessage):this.logger.error("A non-MSALJS error was thrown while attempting to get the cloud instance discovery metadata.\nError: "+s.name+"\nError Description: "+s.message),[2,null];case 4:return n||(this.logger.warning("The developer's authority was not found within the CloudInstanceDiscoveryMetadata returned from the network request."),this.logger.verbose("Creating custom Authority for custom domain scenario."),n=m.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort)),[2,n]}var t})})},m.prototype.getCloudDiscoveryMetadataFromHarcodedValues=function(){return this.canonicalAuthority in C_?C_[this.canonicalAuthority]:null},m.prototype.isInKnownAuthorities=function(){var t=this;return 0<this.authorityOptions.knownAuthorities.filter(function(e){return e_.getDomainFromUrl(e).toLowerCase()===t.hostnameAndPort}).length},m.generateAuthority=function(e,t){var r;return t&&t.azureCloudInstance!==Cy.None&&(r=t.tenant||T.DEFAULT_COMMON_TENANT,r=t.azureCloudInstance+"/"+r+"/"),r||e},m.createCloudDiscoveryMetadataFromHost=function(e){return{preferred_network:e,preferred_cache:e,aliases:[e]}},m.getCloudDiscoveryMetadataFromNetworkResponse=function(e,t){for(var r=0;r<e.length;r++){var i=e[r];if(-1<i.aliases.indexOf(t))return i}return null},m.prototype.getPreferredCache=function(){if(this.discoveryComplete())return this.metadata.preferred_cache;throw E.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},m.prototype.isAlias=function(e){return-1<this.metadata.aliases.indexOf(e)},m.isPublicCloudAuthority=function(e){return 0<=T.KNOWN_PUBLIC_CLOUDS.indexOf(e)},m.buildRegionalAuthorityString=function(e,t,r){var e=new e_(e),i=(e.validateAsUri(),e.getUrlComponents()),n=t+"."+i.HostNameAndPort,i=(this.isPublicCloudAuthority(i.HostNameAndPort)&&(n=t+"."+T.REGIONAL_AUTH_PUBLIC_CLOUD_SUFFIX),e_.constructAuthorityUriFromObject(qm(qm({},e.getUrlComponents()),{HostNameAndPort:n})).urlString);return r?i+"?"+r:i},m.replaceWithRegionalInformation=function(e,t){return e.authorization_endpoint=m.buildRegionalAuthorityString(e.authorization_endpoint,t),e.token_endpoint=m.buildRegionalAuthorityString(e.token_endpoint,t,T.REGIONAL_AUTH_NON_MSI_QUERY_STRING),e.end_session_endpoint&&(e.end_session_endpoint=m.buildRegionalAuthorityString(e.end_session_endpoint,t)),e},m.transformCIAMAuthority=function(e){var t=e.endsWith(T.FORWARD_SLASH)?e:""+e+T.FORWARD_SLASH,e=new e_(e).getUrlComponents();return t=0===e.PathSegments.length&&e.HostNameAndPort.endsWith(T.CIAM_AUTH_URL)?""+t+e.HostNameAndPort.split(".")[0]+T.AAD_TENANT_DOMAIN_SUFFIX:t},m.reservedTenantDomains=new Set(["{tenant}","{tenantid}",Gm.COMMON,Gm.CONSUMERS,Gm.ORGANIZATIONS]);var A_=m;function m(e,t,r,i,n,o,a){this.canonicalAuthority=e,this._canonicalAuthority.validateAsUri(),this.networkInterface=t,this.cacheManager=r,this.authorityOptions=i,this.regionDiscoveryMetadata={region_used:void 0,region_source:void 0,region_outcome:void 0},this.logger=n,this.performanceClient=o,this.correlationId=a,this.regionDiscovery=new E_(t,this.performanceClient,this.correlationId)}P_.createDiscoveredInstance=function(i,n,o,a,s,l,c){return w(this,void 0,void 0,function(){var t,r;return x(this,function(e){switch(e.label){case 0:null!=l&&l.addQueueMeasurement(A.AuthorityFactoryCreateDiscoveredInstance,c),t=A_.transformCIAMAuthority(i),t=P_.createInstance(t,n,o,a,s,l,c),e.label=1;case 1:return e.trys.push([1,3,,4]),null!=l&&l.setPreQueueTime(A.AuthorityResolveEndpointsAsync,c),[4,t.resolveEndpointsAsync()];case 2:return e.sent(),[2,t];case 3:throw r=e.sent(),E.createEndpointDiscoveryIncompleteError(r);case 4:return[2]}})})},P_.createInstance=function(e,t,r,i,n,o,a){if(I.isEmpty(e))throw $y.createUrlEmptyError();return new A_(e,t,r,i,n,o,a)};var k_=P_;function P_(){}R_.isServerTelemetryEntity=function(e,t){var e=0===e.indexOf(lg.CACHE_KEY),r=!0;return t&&(r=t.hasOwnProperty("failedRequests")&&t.hasOwnProperty("errors")&&t.hasOwnProperty("cacheHits")),e&&r};var M_=R_;function R_(){this.failedRequests=[],this.errors=[],this.cacheHits=0}L_.isThrottlingEntity=function(e,t){var r=!1,e=(e&&(r=0===e.indexOf(yg)),!0);return t&&(e=t.hasOwnProperty("throttleTime")),r&&e};var O_=L_;function L_(){}var D_,z_={sendGetRequestAsync:function(){return Promise.reject(S.createUnexpectedError("Network interface - sendGetRequestAsync() has not been implemented for the Network interface."))},sendPostRequestAsync:function(){return Promise.reject(S.createUnexpectedError("Network interface - sendPostRequestAsync() has not been implemented for the Network interface."))}},N_={code:"missing_kid_error",desc:"The JOSE Header for the requested JWT, JWS or JWK object requires a keyId to be configured as the 'kid' header claim. No 'kid' value was provided."},B_={code:"missing_alg_error",desc:"The JOSE Header for the requested JWT, JWS or JWK object requires an algorithm to be specified as the 'alg' header claim. No 'alg' value was provided."},F_=(Um(U_,D_=S),U_.createMissingKidError=function(){return new U_(N_.code,N_.desc)},U_.createMissingAlgError=function(){return new U_(B_.code,B_.desc)},U_);function U_(e,t){e=D_.call(this,e,t)||this;return e.name="JoseHeaderError",Object.setPrototypeOf(e,U_.prototype),e}j_.getShrHeaderString=function(e){if(!e.kid)throw F_.createMissingKidError();if(e.alg)return e=new j_({typ:e.typ||fg.Pop,kid:e.kid,alg:e.alg}),JSON.stringify(e);throw F_.createMissingAlgError()};var q_=j_;function j_(e){this.typ=e.typ,this.alg=e.alg,this.kid=e.kid}V_.prototype.generateCurrentRequestHeaderValue=function(){var e=""+this.apiId+lg.VALUE_SEPARATOR+this.cacheOutcome,t=[this.wrapperSKU,this.wrapperVer].join(lg.VALUE_SEPARATOR),e=[e,this.getRegionDiscoveryFields()].join(lg.VALUE_SEPARATOR);return[lg.SCHEMA_VERSION,e,t].join(lg.CATEGORY_SEPARATOR)},V_.prototype.generateLastRequestHeaderValue=function(){var e=this.getLastRequests(),t=V_.maxErrorsToSend(e),r=e.failedRequests.slice(0,2*t).join(lg.VALUE_SEPARATOR),i=e.errors.slice(0,t).join(lg.VALUE_SEPARATOR),n=e.errors.length,t=[n,t<n?lg.OVERFLOW_TRUE:lg.OVERFLOW_FALSE].join(lg.VALUE_SEPARATOR);return[lg.SCHEMA_VERSION,e.cacheHits,r,i,t].join(lg.CATEGORY_SEPARATOR)},V_.prototype.cacheFailedRequest=function(e){var t=this.getLastRequests();t.errors.length>=lg.MAX_CACHED_ERRORS&&(t.failedRequests.shift(),t.failedRequests.shift(),t.errors.shift()),t.failedRequests.push(this.apiId,this.correlationId),I.isEmpty(e.subError)?I.isEmpty(e.errorCode)?e&&e.toString()?t.errors.push(e.toString()):t.errors.push(lg.UNKNOWN_ERROR):t.errors.push(e.errorCode):t.errors.push(e.subError),this.cacheManager.setServerTelemetry(this.telemetryCacheKey,t)},V_.prototype.incrementCacheHits=function(){var e=this.getLastRequests();return e.cacheHits+=1,this.cacheManager.setServerTelemetry(this.telemetryCacheKey,e),e.cacheHits},V_.prototype.getLastRequests=function(){var e=new M_;return this.cacheManager.getServerTelemetry(this.telemetryCacheKey)||e},V_.prototype.clearTelemetryCache=function(){var e,t=this.getLastRequests(),r=V_.maxErrorsToSend(t);r===t.errors.length?this.cacheManager.removeItem(this.telemetryCacheKey):((e=new M_).failedRequests=t.failedRequests.slice(2*r),e.errors=t.errors.slice(r),this.cacheManager.setServerTelemetry(this.telemetryCacheKey,e))},V_.maxErrorsToSend=function(e){for(var t=0,r=0,i=e.errors.length,n=0;n<i;n++){var o=e.failedRequests[2*n]||T.EMPTY_STRING,a=e.failedRequests[2*n+1]||T.EMPTY_STRING,s=e.errors[n]||T.EMPTY_STRING;if(!((r+=o.toString().length+a.toString().length+s.length+3)<lg.MAX_LAST_HEADER_BYTES))break;t+=1}return t},V_.prototype.getRegionDiscoveryFields=function(){var e=[];return e.push(this.regionUsed||T.EMPTY_STRING),e.push(this.regionSource||T.EMPTY_STRING),e.push(this.regionOutcome||T.EMPTY_STRING),e.join(",")},V_.prototype.updateRegionDiscoveryMetadata=function(e){this.regionUsed=e.region_used,this.regionSource=e.region_source,this.regionOutcome=e.region_outcome},V_.prototype.setCacheOutcome=function(e){this.cacheOutcome=e};var H_=V_;function V_(e,t){this.cacheOutcome=pg.NO_CACHE_HIT,this.cacheManager=t,this.apiId=e.apiId,this.correlationId=e.correlationId,this.wrapperSKU=e.wrapperSKU||T.EMPTY_STRING,this.wrapperVer=e.wrapperVer||T.EMPTY_STRING,this.telemetryCacheKey=lg.CACHE_KEY+Xm.CACHE_KEY_SEPARATOR+e.clientId}G_.prototype.startPerformanceMeasurement=function(e,t){return{}},G_.prototype.startPerformanceMeasuremeant=function(e,t){return{}},G_.prototype.getIntFields=function(){return i_},G_.prototype.getPreQueueTime=function(e,t){var r=this.preQueueTimeByCorrelationId.get(t);if(r){if(r.name===e)return r.time;this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue time found for "+e+", unable to add queue measurement")}else this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue times found for correlationId: "+t+", unable to add queue measurement")},G_.prototype.calculateQueuedTime=function(e,t){return e<1?(this.logger.trace("PerformanceClient: preQueueTime should be a positive integer and not "+e),0):t<1?(this.logger.trace("PerformanceClient: currentTime should be a positive integer and not "+t),0):t<e?(this.logger.trace("PerformanceClient: currentTime is less than preQueueTime, check how time is being retrieved"),0):t-e},G_.prototype.addQueueMeasurement=function(e,t,r,i){if(t){if(0===r)this.logger.trace("PerformanceClient.addQueueMeasurement: queue time provided for "+e+" is "+r);else if(!r)return void this.logger.trace("PerformanceClient.addQueueMeasurement: no queue time provided for "+e);r={eventName:e,queueTime:r,manuallyCompleted:i},i=this.queueMeasurements.get(t);i?(i.push(r),this.queueMeasurements.set(t,i)):(this.logger.trace("PerformanceClient.addQueueMeasurement: adding correlationId "+t+" to queue measurements"),this.queueMeasurements.set(t,[r])),this.preQueueTimeByCorrelationId.delete(t)}else this.logger.trace("PerformanceClient.addQueueMeasurement: correlationId not provided for "+e+", cannot add queue measurement")},G_.prototype.startMeasurement=function(e,t){var r=this,i=t||this.generateId(),n=(t||this.logger.info("PerformanceClient: No correlation id provided for "+e+", generating",i),this.logger.trace("PerformanceClient: Performance measurement started for "+e,i),this.startPerformanceMeasuremeant(e,i)),o=(n.startMeasurement(),{eventId:this.generateId(),status:Qv.InProgress,authority:this.authority,libraryName:this.libraryName,libraryVersion:this.libraryVersion,clientId:this.clientId,name:e,startTimeMs:Date.now(),correlationId:i,appName:null==(t=this.applicationTelemetry)?void 0:t.appName,appVersion:null==(e=this.applicationTelemetry)?void 0:e.appVersion});return this.cacheEventByCorrelationId(o),{endMeasurement:function(e){return r.endMeasurement(qm(qm({},o),e),n)},discardMeasurement:function(){return r.discardMeasurements(o.correlationId)},addStaticFields:function(e){return r.addStaticFields(e,o.correlationId)},increment:function(e){return r.increment(e,o.correlationId)},measurement:n,event:o}},G_.prototype.endMeasurement=function(t,e){var r,i,n,o,a,s=this,l=this.eventsByCorrelationId.get(t.correlationId);return l?(i={totalQueueTime:0,totalQueueCount:0,manuallyCompletedCount:0},(r=t.eventId===l.eventId)?(i=this.getQueueInfo(t.correlationId),this.discardCache(l.correlationId)):null!=(n=l.incompleteSubMeasurements)&&n.delete(t.eventId),null!=e&&e.endMeasurement(),(n=null==e?void 0:e.flushMeasurement())?(this.logger.trace("PerformanceClient: Performance measurement ended for "+t.name+": "+n+" ms",t.correlationId),r?(o=qm(qm({},l),t),a=0,null!=(e=o.incompleteSubMeasurements)&&e.forEach(function(e){s.logger.trace("PerformanceClient: Incomplete submeasurement "+e.name+" found for "+t.name,o.correlationId),a++}),o.incompleteSubMeasurements=void 0,o=qm(qm({},o),{durationMs:Math.round(n),queuedTimeMs:i.totalQueueTime,queuedCount:i.totalQueueCount,queuedManuallyCompletedCount:i.manuallyCompletedCount,status:Qv.Completed,incompleteSubsCount:a}),this.truncateIntegralFields(o,this.getIntFields()),this.emitEvents([o],t.correlationId),o):(l[t.name+"DurationMs"]=Math.floor(n),qm({},l))):(this.logger.trace("PerformanceClient: Performance measurement not taken",l.correlationId),null)):(this.logger.trace("PerformanceClient: Measurement not found for "+t.eventId,t.correlationId),null)},G_.prototype.addStaticFields=function(e,t){this.logger.trace("PerformanceClient: Updating static fields");var r=this.eventsByCorrelationId.get(t);r?this.eventsByCorrelationId.set(t,qm(qm({},r),e)):this.logger.trace("PerformanceClient: Event not found for",t)},G_.prototype.increment=function(e,t){this.logger.trace("PerformanceClient: Updating counters");var r=this.eventsByCorrelationId.get(t);if(r)for(var i in e)r.hasOwnProperty(i)||(r[i]=0),r[i]+=e[i];else this.logger.trace("PerformanceClient: Event not found for",t)},G_.prototype.cacheEventByCorrelationId=function(e){var t=this.eventsByCorrelationId.get(e.correlationId);t?(this.logger.trace("PerformanceClient: Performance measurement for "+e.name+" added/updated",e.correlationId),t.incompleteSubMeasurements=t.incompleteSubMeasurements||new Map,t.incompleteSubMeasurements.set(e.eventId,{name:e.name,startTimeMs:e.startTimeMs})):(this.logger.trace("PerformanceClient: Performance measurement for "+e.name+" started",e.correlationId),this.eventsByCorrelationId.set(e.correlationId,qm({},e)))},G_.prototype.getQueueInfo=function(e){var t=this.queueMeasurements.get(e),r=(t||this.logger.trace("PerformanceClient: no queue measurements found for for correlationId: "+e),0),i=0,n=0;return null!=t&&t.forEach(function(e){r+=e.queueTime,i++,n+=e.manuallyCompleted?1:0}),{totalQueueTime:r,totalQueueCount:i,manuallyCompletedCount:n}},G_.prototype.discardMeasurements=function(e){this.logger.trace("PerformanceClient: Performance measurements discarded",e),this.eventsByCorrelationId.delete(e)},G_.prototype.discardCache=function(e){this.discardMeasurements(e),this.logger.trace("PerformanceClient: QueueMeasurements discarded",e),this.queueMeasurements.delete(e),this.logger.trace("PerformanceClient: Pre-queue times discarded",e),this.preQueueTimeByCorrelationId.delete(e)},G_.prototype.addPerformanceCallback=function(e){var t=this.generateId();return this.callbacks.set(t,e),this.logger.verbose("PerformanceClient: Performance callback registered with id: "+t),t},G_.prototype.removePerformanceCallback=function(e){var t=this.callbacks.delete(e);return t?this.logger.verbose("PerformanceClient: Performance callback "+e+" removed."):this.logger.verbose("PerformanceClient: Performance callback "+e+" not removed."),t},G_.prototype.emitEvents=function(r,i){var n=this;this.logger.verbose("PerformanceClient: Emitting performance events",i),this.callbacks.forEach(function(e,t){n.logger.trace("PerformanceClient: Emitting event to callback "+t,i),e.apply(null,[r])})},G_.prototype.truncateIntegralFields=function(t,e){e.forEach(function(e){e in t&&"number"==typeof t[e]&&(t[e]=Math.floor(t[e]))})};var o=G_;function G_(e,t,r,i,n,o){this.authority=t,this.libraryName=i,this.libraryVersion=n,this.applicationTelemetry=o,this.clientId=e,this.logger=r,this.callbacks=new Map,this.eventsByCorrelationId=new Map,this.queueMeasurements=new Map,this.preQueueTimeByCorrelationId=new Map}Z_.prototype.startMeasurement=function(){},Z_.prototype.endMeasurement=function(){},Z_.prototype.flushMeasurement=function(){return null};var K_=Z_;function Z_(){}Um($_,W_=o),$_.prototype.generateId=function(){return"callback-id"},$_.prototype.startPerformanceMeasuremeant=function(){return new K_},$_.prototype.startPerformanceMeasurement=function(){return new K_},$_.prototype.calculateQueuedTime=function(e,t){return 0},$_.prototype.addQueueMeasurement=function(e,t,r){},$_.prototype.setPreQueueTime=function(e,t){};var W_,Y_=$_;function $_(){return null!==W_&&W_.apply(this,arguments)||this}var X_,J_={code:"pkce_not_created",desc:"The PKCE code challenge and verifier could not be generated."},Q_={code:"crypto_nonexistent",desc:"The crypto object or function is not available."},e0={code:"http_method_not_implemented",desc:"The HTTP method given has not been implemented in this library."},t0={code:"empty_navigate_uri",desc:"Navigation URI is empty. Please check stack trace for more info."},r0={code:"hash_empty_error",desc:"Hash value cannot be processed because it is empty. Please verify that your redirectUri is not clearing the hash. For more visit: aka.ms/msaljs/browser-errors."},i0={code:"no_state_in_hash",desc:"Hash does not contain state. Please verify that the request originated from msal."},n0={code:"hash_does_not_contain_known_properties",desc:"Hash does not contain known properites. Please verify that your redirectUri is not changing the hash. For more visit: aka.ms/msaljs/browser-errors."},o0={code:"unable_to_parse_state",desc:"Unable to parse state. Please verify that the request originated from msal."},a0={code:"state_interaction_type_mismatch",desc:"Hash contains state but the interaction type does not match the caller."},s0={code:"interaction_in_progress",desc:"Interaction is currently in progress. Please ensure that this interaction has been completed before calling an interactive API.  For more visit: aka.ms/msaljs/browser-errors."},l0={code:"popup_window_error",desc:"Error opening popup window. This can happen if you are using IE or if popups are blocked in the browser."},c0={code:"empty_window_error",desc:"window.open returned null or undefined window object."},u0={code:"user_cancelled",desc:"User cancelled the flow."},h0={code:"monitor_window_timeout",desc:"Token acquisition in popup failed due to timeout. For more visit: aka.ms/msaljs/browser-errors."},d0={code:"monitor_window_timeout",desc:"Token acquisition in iframe failed due to timeout. For more visit: aka.ms/msaljs/browser-errors."},p0={code:"redirect_in_iframe",desc:"Redirects are not supported for iframed or brokered applications. Please ensure you are using MSAL.js in a top frame of the window if using the redirect APIs, or use the popup APIs."},f0={code:"block_iframe_reload",desc:"Request was blocked inside an iframe because MSAL detected an authentication response. For more visit: aka.ms/msaljs/browser-errors"},m0={code:"block_nested_popups",desc:"Request was blocked inside a popup because MSAL detected it was running in a popup."},g0={code:"iframe_closed_prematurely",desc:"The iframe being monitored was closed prematurely."},y0={code:"silent_logout_unsupported",desc:"Silent logout not supported. Please call logoutRedirect or logoutPopup instead."},v0={code:"no_account_error",desc:"No account object provided to acquireTokenSilent and no active account has been set. Please call setActiveAccount or provide an account on the request."},_0={code:"silent_prompt_value_error",desc:"The value given for the prompt value is not valid for silent requests - must be set to 'none' or 'no_session'."},b0={code:"no_token_request_cache_error",desc:"No token request found in cache."},w0={code:"unable_to_parse_token_request_cache_error",desc:"The cached token request could not be parsed."},x0={code:"no_cached_authority_error",desc:"No cached authority found."},C0={code:"auth_request_not_set_error",desc:"Auth Request not set. Please ensure initiateAuthRequest was called from the InteractionHandler"},T0={code:"invalid_cache_type",desc:"Invalid cache type"},S0={code:"non_browser_environment",desc:"Login and token requests are not supported in non-browser environments."},E0={code:"database_not_open",desc:"Database is not open!"},I0={code:"no_network_connectivity",desc:"No network connectivity. Check your internet connection."},A0={code:"post_request_failed",desc:"Network request failed: If the browser threw a CORS error, check that the redirectUri is registered in the Azure App Portal as type 'SPA'"},k0={code:"get_request_failed",desc:"Network request failed. Please check the network trace to determine root cause."},P0={code:"failed_to_parse_response",desc:"Failed to parse network response. Check network trace."},M0={code:"unable_to_load_token",desc:"Error loading token to cache."},R0={code:"crypto_key_not_found",desc:"Cryptographic Key or Keypair not found in browser storage."},O0={code:"auth_code_required",desc:"An authorization code must be provided (as the `code` property on the request) to this flow."},L0={code:"auth_code_or_nativeAccountId_required",desc:"An authorization code or nativeAccountId must be provided to this flow."},D0={code:"spa_code_and_nativeAccountId_present",desc:"Request cannot contain both spa code and native account id."},z0={code:"database_unavailable",desc:"IndexedDB, which is required for persistent cryptographic key storage, is unavailable. This may be caused by browser privacy features which block persistent storage in third-party contexts."},N0={code:"unable_to_acquire_token_from_native_platform",desc:"Unable to acquire token from native platform. For a list of possible reasons visit aka.ms/msaljs/browser-errors."},B0={code:"native_handshake_timeout",desc:"Timed out while attempting to establish connection to browser extension"},F0={code:"native_extension_not_installed",desc:"Native extension is not installed. If you think this is a mistake call the initialize function."},U0={code:"native_connection_not_established",desc:"Connection to native platform has not been established. Please install a compatible browser extension and run initialize(). For more please visit aka.ms/msaljs/browser-errors."},q0={code:"native_broker_called_before_initialize",desc:"You must call and await the initialize function before attempting to call any other MSAL API when native brokering is enabled. For more please visit aka.ms/msaljs/browser-errors."},j0={code:"native_prompt_not_supported",desc:"The provided prompt is not supported by the native platform. This request should be routed to the web based flow."},k=(zm(g,X_=S),g.createPkceNotGeneratedError=function(e){return new g(J_.code,J_.desc+" Detail:"+e)},g.createCryptoNotAvailableError=function(e){return new g(Q_.code,Q_.desc+" Detail:"+e)},g.createHttpMethodNotImplementedError=function(e){return new g(e0.code,e0.desc+" Given Method: "+e)},g.createEmptyNavigationUriError=function(){return new g(t0.code,t0.desc)},g.createEmptyHashError=function(e){return new g(r0.code,r0.desc+" Given Url: "+e)},g.createHashDoesNotContainStateError=function(){return new g(i0.code,i0.desc)},g.createHashDoesNotContainKnownPropertiesError=function(){return new g(n0.code,n0.desc)},g.createUnableToParseStateError=function(){return new g(o0.code,o0.desc)},g.createStateInteractionTypeMismatchError=function(){return new g(a0.code,a0.desc)},g.createInteractionInProgressError=function(){return new g(s0.code,s0.desc)},g.createPopupWindowError=function(e){var t=l0.desc,t=I.isEmpty(e)?t:t+" Details: "+e;return new g(l0.code,t)},g.createEmptyWindowCreatedError=function(){return new g(c0.code,c0.desc)},g.createUserCancelledError=function(){return new g(u0.code,u0.desc)},g.createMonitorPopupTimeoutError=function(){return new g(h0.code,h0.desc)},g.createMonitorIframeTimeoutError=function(){return new g(d0.code,d0.desc)},g.createRedirectInIframeError=function(e){return new g(p0.code,p0.desc+" (window.parent !== window) => "+e)},g.createBlockReloadInHiddenIframeError=function(){return new g(f0.code,f0.desc)},g.createBlockAcquireTokenInPopupsError=function(){return new g(m0.code,m0.desc)},g.createIframeClosedPrematurelyError=function(){return new g(g0.code,g0.desc)},g.createSilentLogoutUnsupportedError=function(){return new g(y0.code,y0.desc)},g.createNoAccountError=function(){return new g(v0.code,v0.desc)},g.createSilentPromptValueError=function(e){return new g(_0.code,_0.desc+" Given value: "+e)},g.createUnableToParseTokenRequestCacheError=function(){return new g(w0.code,w0.desc)},g.createNoTokenRequestCacheError=function(){return new g(b0.code,b0.desc)},g.createAuthRequestNotSetError=function(){return new g(C0.code,C0.desc)},g.createNoCachedAuthorityError=function(){return new g(x0.code,x0.desc)},g.createInvalidCacheTypeError=function(){return new g(T0.code,""+T0.desc)},g.createNonBrowserEnvironmentError=function(){return new g(S0.code,S0.desc)},g.createDatabaseNotOpenError=function(){return new g(E0.code,E0.desc)},g.createNoNetworkConnectivityError=function(){return new g(I0.code,I0.desc)},g.createPostRequestFailedError=function(e,t){return new g(A0.code,A0.desc+" | Network client threw: "+e+" | Attempted to reach: "+t.split("?")[0])},g.createGetRequestFailedError=function(e,t){return new g(k0.code,k0.desc+" | Network client threw: "+e+" | Attempted to reach: "+t.split("?")[0])},g.createFailedToParseNetworkResponseError=function(e){return new g(P0.code,P0.desc+" | Attempted to reach: "+e.split("?")[0])},g.createUnableToLoadTokenError=function(e){return new g(M0.code,M0.desc+" | "+e)},g.createSigningKeyNotFoundInStorageError=function(e){return new g(R0.code,R0.desc+" | No match found for KeyId: "+e)},g.createAuthCodeRequiredError=function(){return new g(O0.code,O0.desc)},g.createAuthCodeOrNativeAccountIdRequiredError=function(){return new g(L0.code,L0.desc)},g.createSpaCodeAndNativeAccountIdPresentError=function(){return new g(D0.code,D0.desc)},g.createDatabaseUnavailableError=function(){return new g(z0.code,z0.desc)},g.createUnableToAcquireTokenFromNativePlatformError=function(){return new g(N0.code,N0.desc)},g.createNativeHandshakeTimeoutError=function(){return new g(B0.code,B0.desc)},g.createNativeExtensionNotInstalledError=function(){return new g(F0.code,F0.desc)},g.createNativeConnectionNotEstablishedError=function(){return new g(U0.code,U0.desc)},g.createNativeBrokerCalledBeforeInitialize=function(){return new g(q0.code,q0.desc)},g.createNativePromptParameterNotSupportedError=function(){return new g(j0.code,j0.desc)},g);function g(e,t){e=X_.call(this,e,t)||this;return Object.setPrototypeOf(e,g.prototype),e.name="BrowserAuthError",e}var H0,V0,G0,K0,Z0,W0,Y0,P,$0,a,X0={INTERACTION_IN_PROGRESS_VALUE:"interaction_in_progress",INVALID_GRANT_ERROR:"invalid_grant",POPUP_WIDTH:483,POPUP_HEIGHT:600,POPUP_NAME_PREFIX:"msal",DEFAULT_POLL_INTERVAL_MS:30,MSAL_SKU:"msal.js.browser"},J0="53ee284d-920a-4b59-9d30-a60315b26836",Q0="ppnbnpeolgkicgegkbkbjmhlideopiji",eb="MATS",tb=((e=H0=H0||{}).HandshakeRequest="Handshake",e.HandshakeResponse="HandshakeResponse",e.GetToken="GetToken",e.Response="Response",(qi=V0=V0||{}).LocalStorage="localStorage",qi.SessionStorage="sessionStorage",qi.MemoryStorage="memoryStorage",(i=G0=G0||{}).GET="GET",i.POST="POST",(we=K0=K0||{}).AUTHORITY="authority",we.ACQUIRE_TOKEN_ACCOUNT="acquireToken.account",we.SESSION_STATE="session.state",we.REQUEST_STATE="request.state",we.NONCE_IDTOKEN="nonce.id_token",we.ORIGIN_URI="request.origin",we.RENEW_STATUS="token.renew.status",we.URL_HASH="urlHash",we.REQUEST_PARAMS="request.params",we.SCOPES="scopes",we.INTERACTION_STATUS_KEY="interaction.status",we.CCS_CREDENTIAL="ccs.credential",we.CORRELATION_ID="request.correlationId",we.NATIVE_REQUEST="request.native",we.REDIRECT_CONTEXT="request.redirect.context",(Ro=Z0=Z0||{}).ACCOUNT_KEYS="msal.account.keys",Ro.TOKEN_KEYS="msal.token.keys",(Vt=W0=W0||{}).WRAPPER_SKU="wrapper.sku",Vt.WRAPPER_VER="wrapper.version",(r=Y0=Y0||{})[r.acquireTokenRedirect=861]="acquireTokenRedirect",r[r.acquireTokenPopup=862]="acquireTokenPopup",r[r.ssoSilent=863]="ssoSilent",r[r.acquireTokenSilent_authCode=864]="acquireTokenSilent_authCode",r[r.handleRedirectPromise=865]="handleRedirectPromise",r[r.acquireTokenByCode=866]="acquireTokenByCode",r[r.acquireTokenSilent_silentFlow=61]="acquireTokenSilent_silentFlow",r[r.logout=961]="logout",r[r.logoutPopup=962]="logoutPopup",(Br=P=P||{}).Redirect="redirect",Br.Popup="popup",Br.Silent="silent",Br.None="none",0,{scopes:tg}),rb="jwk",ib=(0,"msal.db");(a=$0=$0||{})[a.Default=0]="Default",a[a.AccessToken=1]="AccessToken",a[a.AccessTokenAndRefreshToken=2]="AccessTokenAndRefreshToken",a[a.RefreshToken=3]="RefreshToken",a[a.RefreshTokenAndNetwork=4]="RefreshTokenAndNetwork",a[a.Skip=5]="Skip";var nb,ob={code:"redirect_uri_empty",desc:"A redirect URI is required for all calls, and none has been set."},ab={code:"post_logout_uri_empty",desc:"A post logout redirect has not been set."},sb={code:"storage_not_supported",desc:"Given storage configuration option was not supported."},lb={code:"no_redirect_callbacks",desc:"No redirect callbacks have been set. Please call setRedirectCallbacks() with the appropriate function arguments before continuing. More information is available here: https://github.com/AzureAD/microsoft-authentication-library-for-js/wiki/MSAL-basics."},cb={code:"stubbed_public_client_application_called",desc:"Stub instance of Public Client Application was called. If using msal-react, please ensure context is not used without a provider. For more visit: aka.ms/msaljs/browser-errors"},ub={code:"in_mem_redirect_unavailable",desc:"Redirect cannot be supported. In-memory storage was selected and storeAuthStateInCookie=false, which would cause the library to be unable to handle the incoming hash. If you would like to use the redirect API, please use session/localStorage or set storeAuthStateInCookie=true."},hb={code:"entropy_not_provided",desc:"The available browser crypto interface requires entropy set via system.cryptoOptions.entropy configuration option."},db=(zm(pb,nb=S),pb.createRedirectUriEmptyError=function(){return new pb(ob.code,ob.desc)},pb.createPostLogoutRedirectUriEmptyError=function(){return new pb(ab.code,ab.desc)},pb.createStorageNotSupportedError=function(e){return new pb(sb.code,sb.desc+" Given Location: "+e)},pb.createRedirectCallbacksNotSetError=function(){return new pb(lb.code,lb.desc)},pb.createStubPcaInstanceCalledError=function(){return new pb(cb.code,cb.desc)},pb.createInMemoryRedirectUnavailableError=function(){return new pb(ub.code,ub.desc)},pb.createEntropyNotProvided=function(){return new pb(hb.code,hb.desc)},pb);function pb(e,t){e=nb.call(this,e,t)||this;return e.name="BrowserConfigurationAuthError",Object.setPrototypeOf(e,pb.prototype),e}mb.prototype.validateWindowStorage=function(e){if(e!==V0.LocalStorage&&e!==V0.SessionStorage)throw db.createStorageNotSupportedError(e);if(!!!window[e])throw db.createStorageNotSupportedError(e)},mb.prototype.getItem=function(e){return this.windowStorage.getItem(e)},mb.prototype.setItem=function(e,t){this.windowStorage.setItem(e,t)},mb.prototype.removeItem=function(e){this.windowStorage.removeItem(e)},mb.prototype.getKeys=function(){return Object.keys(this.windowStorage)},mb.prototype.containsKey=function(e){return this.windowStorage.hasOwnProperty(e)};var fb=mb;function mb(e){this.validateWindowStorage(e),this.windowStorage=window[e]}yb.prototype.getItem=function(e){return this.cache.get(e)||null},yb.prototype.setItem=function(e,t){this.cache.set(e,t)},yb.prototype.removeItem=function(e){this.cache.delete(e)},yb.prototype.getKeys=function(){var r=[];return this.cache.forEach(function(e,t){r.push(t)}),r},yb.prototype.containsKey=function(e){return this.cache.has(e)},yb.prototype.clear=function(){this.cache.clear()};var gb=yb;function yb(){this.cache=new Map}_b.extractBrowserRequestState=function(e,t){if(I.isEmpty(t))return null;try{return Xv.parseRequestState(e,t).libraryState.meta}catch(e){throw E.createInvalidStateError(t,e)}},_b.parseServerResponseFromHash=function(e){return e?(e=new e_(e),e_.getDeserializedHash(e.getHash())):{}};var vb=_b;function _b(){}zm(M,bb=av),M.prototype.setupBrowserStorage=function(e){switch(e){case V0.LocalStorage:case V0.SessionStorage:try{return new fb(e)}catch(e){this.logger.verbose(e);break}}return this.cacheConfig.cacheLocation=V0.MemoryStorage,new gb},M.prototype.setupTemporaryCacheStorage=function(e,t){switch(t){case V0.LocalStorage:case V0.SessionStorage:try{return new fb(e||V0.SessionStorage)}catch(e){return this.logger.verbose(e),this.internalStorage}case V0.MemoryStorage:default:return this.internalStorage}},M.prototype.migrateCacheEntries=function(){var r=this,e=T.CACHE_PREFIX+"."+Vm.ID_TOKEN,t=T.CACHE_PREFIX+"."+Vm.CLIENT_INFO,i=T.CACHE_PREFIX+"."+Vm.ERROR,n=T.CACHE_PREFIX+"."+Vm.ERROR_DESC,o=[this.browserStorage.getItem(e),this.browserStorage.getItem(t),this.browserStorage.getItem(i),this.browserStorage.getItem(n)];[Vm.ID_TOKEN,Vm.CLIENT_INFO,Vm.ERROR,Vm.ERROR_DESC].forEach(function(e,t){return r.migrateCacheEntry(e,o[t])})},M.prototype.migrateCacheEntry=function(e,t){t&&this.setTemporaryCache(e,t,!0)},M.prototype.createKeyMaps=function(){var o=this,e=(this.logger.trace("BrowserCacheManager - createKeyMaps called."),this.getItem(Z0.ACCOUNT_KEYS)),t=this.getItem(Z0.TOKEN_KEYS+"."+this.clientId);e&&t?this.logger.verbose("BrowserCacheManager:createKeyMaps - account and token key maps already exist, skipping migration."):this.browserStorage.getKeys().forEach(function(e){var t;if(o.isCredentialKey(e)&&(t=o.getItem(e))){var r,i,n=o.validateAndParseJson(t);if(n&&n.hasOwnProperty("credentialType"))switch(n.credentialType){case C.ID_TOKEN:if(Ov.isIdTokenEntity(n))return o.logger.trace("BrowserCacheManager:createKeyMaps - idToken found, saving key to token key map"),o.logger.tracePii("BrowserCacheManager:createKeyMaps - idToken with key: "+e+" found, saving key to token key map"),i=av.toObject(new Ov,n),i=o.updateCredentialCacheKey(e,i),void o.addTokenKey(i,C.ID_TOKEN);o.logger.trace("BrowserCacheManager:createKeyMaps - key found matching idToken schema with value containing idToken credentialType field but value failed IdTokenEntity validation, skipping."),o.logger.tracePii("BrowserCacheManager:createKeyMaps - failed idToken validation on key: "+e);break;case C.ACCESS_TOKEN:case C.ACCESS_TOKEN_WITH_AUTH_SCHEME:if(Bv.isAccessTokenEntity(n))return o.logger.trace("BrowserCacheManager:createKeyMaps - accessToken found, saving key to token key map"),o.logger.tracePii("BrowserCacheManager:createKeyMaps - accessToken with key: "+e+" found, saving key to token key map"),r=av.toObject(new Bv,n),i=o.updateCredentialCacheKey(e,r),void o.addTokenKey(i,C.ACCESS_TOKEN);o.logger.trace("BrowserCacheManager:createKeyMaps - key found matching accessToken schema with value containing accessToken credentialType field but value failed AccessTokenEntity validation, skipping."),o.logger.tracePii("BrowserCacheManager:createKeyMaps - failed accessToken validation on key: "+e);break;case C.REFRESH_TOKEN:if(qv.isRefreshTokenEntity(n))return o.logger.trace("BrowserCacheManager:createKeyMaps - refreshToken found, saving key to token key map"),o.logger.tracePii("BrowserCacheManager:createKeyMaps - refreshToken with key: "+e+" found, saving key to token key map"),r=av.toObject(new qv,n),i=o.updateCredentialCacheKey(e,r),void o.addTokenKey(i,C.REFRESH_TOKEN);o.logger.trace("BrowserCacheManager:createKeyMaps - key found matching refreshToken schema with value containing refreshToken credentialType field but value failed RefreshTokenEntity validation, skipping."),o.logger.tracePii("BrowserCacheManager:createKeyMaps - failed refreshToken validation on key: "+e)}}o.isAccountKey(e)&&(t=o.getItem(e))&&(t=o.validateAndParseJson(t))&&rv.isAccountEntity(t)&&(o.logger.trace("BrowserCacheManager:createKeyMaps - account found, saving key to account key map"),o.logger.tracePii("BrowserCacheManager:createKeyMaps - account with key: "+e+" found, saving key to account key map"),o.addAccountKeyToMap(e))})},M.prototype.validateAndParseJson=function(e){try{var t=JSON.parse(e);return t&&"object"==typeof t?t:null}catch(e){return null}},M.prototype.getItem=function(e){return this.browserStorage.getItem(e)},M.prototype.setItem=function(e,t){this.browserStorage.setItem(e,t)},M.prototype.getAccount=function(e){this.logger.trace("BrowserCacheManager.getAccount called");var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&rv.isAccountEntity(t)?av.toObject(new rv,t):(this.removeAccountKeyFromMap(e),null)},M.prototype.setAccount=function(e){this.logger.trace("BrowserCacheManager.setAccount called");var t=e.generateAccountKey();this.setItem(t,JSON.stringify(e)),this.addAccountKeyToMap(t)},M.prototype.getAccountKeys=function(){this.logger.trace("BrowserCacheManager.getAccountKeys called");var e=this.getItem(Z0.ACCOUNT_KEYS);return e?JSON.parse(e):(this.logger.verbose("BrowserCacheManager.getAccountKeys - No account keys found"),[])},M.prototype.addAccountKeyToMap=function(e){this.logger.trace("BrowserCacheManager.addAccountKeyToMap called"),this.logger.tracePii("BrowserCacheManager.addAccountKeyToMap called with key: "+e);var t=this.getAccountKeys();-1===t.indexOf(e)?(t.push(e),this.setItem(Z0.ACCOUNT_KEYS,JSON.stringify(t)),this.logger.verbose("BrowserCacheManager.addAccountKeyToMap account key added")):this.logger.verbose("BrowserCacheManager.addAccountKeyToMap account key already exists in map")},M.prototype.removeAccountKeyFromMap=function(e){this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap called"),this.logger.tracePii("BrowserCacheManager.removeAccountKeyFromMap called with key: "+e);var t=this.getAccountKeys(),e=t.indexOf(e);-1<e?(t.splice(e,1),this.setItem(Z0.ACCOUNT_KEYS,JSON.stringify(t)),this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap account key removed")):this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap key not found in existing map")},M.prototype.removeAccount=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){return bb.prototype.removeAccount.call(this,t),this.removeAccountKeyFromMap(t),[2]})})},M.prototype.removeIdToken=function(e){bb.prototype.removeIdToken.call(this,e),this.removeTokenKey(e,C.ID_TOKEN)},M.prototype.removeAccessToken=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){return bb.prototype.removeAccessToken.call(this,t),this.removeTokenKey(t,C.ACCESS_TOKEN),[2]})})},M.prototype.removeRefreshToken=function(e){bb.prototype.removeRefreshToken.call(this,e),this.removeTokenKey(e,C.REFRESH_TOKEN)},M.prototype.getTokenKeys=function(){this.logger.trace("BrowserCacheManager.getTokenKeys called");var e=this.getItem(Z0.TOKEN_KEYS+"."+this.clientId);if(e){e=this.validateAndParseJson(e);if(e&&e.hasOwnProperty("idToken")&&e.hasOwnProperty("accessToken")&&e.hasOwnProperty("refreshToken"))return e;this.logger.error("BrowserCacheManager.getTokenKeys - Token keys found but in an unknown format. Returning empty key map.")}else this.logger.verbose("BrowserCacheManager.getTokenKeys - No token keys found");return{idToken:[],accessToken:[],refreshToken:[]}},M.prototype.addTokenKey=function(e,t){this.logger.trace("BrowserCacheManager addTokenKey called");var r=this.getTokenKeys();switch(t){case C.ID_TOKEN:-1===r.idToken.indexOf(e)&&(this.logger.info("BrowserCacheManager: addTokenKey - idToken added to map"),r.idToken.push(e));break;case C.ACCESS_TOKEN:-1===r.accessToken.indexOf(e)&&(this.logger.info("BrowserCacheManager: addTokenKey - accessToken added to map"),r.accessToken.push(e));break;case C.REFRESH_TOKEN:-1===r.refreshToken.indexOf(e)&&(this.logger.info("BrowserCacheManager: addTokenKey - refreshToken added to map"),r.refreshToken.push(e));break;default:this.logger.error("BrowserCacheManager:addTokenKey - CredentialType provided invalid. CredentialType: "+t),E.createUnexpectedCredentialTypeError()}this.setItem(Z0.TOKEN_KEYS+"."+this.clientId,JSON.stringify(r))},M.prototype.removeTokenKey=function(e,t){this.logger.trace("BrowserCacheManager removeTokenKey called");var r=this.getTokenKeys();switch(t){case C.ID_TOKEN:this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove idToken with key: "+e+" from map");var i=r.idToken.indexOf(e);-1<i?(this.logger.info("BrowserCacheManager: removeTokenKey - idToken removed from map"),r.idToken.splice(i,1)):this.logger.info("BrowserCacheManager: removeTokenKey - idToken does not exist in map. Either it was previously removed or it was never added.");break;case C.ACCESS_TOKEN:this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove accessToken with key: "+e+" from map");i=r.accessToken.indexOf(e);-1<i?(this.logger.info("BrowserCacheManager: removeTokenKey - accessToken removed from map"),r.accessToken.splice(i,1)):this.logger.info("BrowserCacheManager: removeTokenKey - accessToken does not exist in map. Either it was previously removed or it was never added.");break;case C.REFRESH_TOKEN:this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove refreshToken with key: "+e+" from map");i=r.refreshToken.indexOf(e);-1<i?(this.logger.info("BrowserCacheManager: removeTokenKey - refreshToken removed from map"),r.refreshToken.splice(i,1)):this.logger.info("BrowserCacheManager: removeTokenKey - refreshToken does not exist in map. Either it was previously removed or it was never added.");break;default:this.logger.error("BrowserCacheManager:removeTokenKey - CredentialType provided invalid. CredentialType: "+t),E.createUnexpectedCredentialTypeError()}this.setItem(Z0.TOKEN_KEYS+"."+this.clientId,JSON.stringify(r))},M.prototype.getIdTokenCredential=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&Ov.isIdTokenEntity(t)?(this.logger.trace("BrowserCacheManager.getIdTokenCredential: cache hit"),av.toObject(new Ov,t)):(this.logger.trace("BrowserCacheManager.getIdTokenCredential: called, no cache hit"),this.removeTokenKey(e,C.ID_TOKEN),null)},M.prototype.setIdTokenCredential=function(e){this.logger.trace("BrowserCacheManager.setIdTokenCredential called");var t=e.generateCredentialKey();this.setItem(t,JSON.stringify(e)),this.addTokenKey(t,C.ID_TOKEN)},M.prototype.getAccessTokenCredential=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&Bv.isAccessTokenEntity(t)?(this.logger.trace("BrowserCacheManager.getAccessTokenCredential: cache hit"),av.toObject(new Bv,t)):(this.logger.trace("BrowserCacheManager.getAccessTokenCredential: called, no cache hit"),this.removeTokenKey(e,C.ACCESS_TOKEN),null)},M.prototype.setAccessTokenCredential=function(e){this.logger.trace("BrowserCacheManager.setAccessTokenCredential called");var t=e.generateCredentialKey();this.setItem(t,JSON.stringify(e)),this.addTokenKey(t,C.ACCESS_TOKEN)},M.prototype.getRefreshTokenCredential=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&qv.isRefreshTokenEntity(t)?(this.logger.trace("BrowserCacheManager.getRefreshTokenCredential: cache hit"),av.toObject(new qv,t)):(this.logger.trace("BrowserCacheManager.getRefreshTokenCredential: called, no cache hit"),this.removeTokenKey(e,C.REFRESH_TOKEN),null)},M.prototype.setRefreshTokenCredential=function(e){this.logger.trace("BrowserCacheManager.setRefreshTokenCredential called");var t=e.generateCredentialKey();this.setItem(t,JSON.stringify(e)),this.addTokenKey(t,C.REFRESH_TOKEN)},M.prototype.getAppMetadata=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&a_.isAppMetadataEntity(e,t)?(this.logger.trace("BrowserCacheManager.getAppMetadata: cache hit"),av.toObject(new a_,t)):(this.logger.trace("BrowserCacheManager.getAppMetadata: called, no cache hit"),null)},M.prototype.setAppMetadata=function(e){this.logger.trace("BrowserCacheManager.setAppMetadata called");var t=e.generateAppMetadataKey();this.setItem(t,JSON.stringify(e))},M.prototype.getServerTelemetry=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&M_.isServerTelemetryEntity(e,t)?(this.logger.trace("BrowserCacheManager.getServerTelemetry: cache hit"),av.toObject(new M_,t)):(this.logger.trace("BrowserCacheManager.getServerTelemetry: called, no cache hit"),null)},M.prototype.setServerTelemetry=function(e,t){this.logger.trace("BrowserCacheManager.setServerTelemetry called"),this.setItem(e,JSON.stringify(t))},M.prototype.getAuthorityMetadata=function(e){var t=this.internalStorage.getItem(e);return t?(t=this.validateAndParseJson(t))&&T_.isAuthorityMetadataEntity(e,t)?(this.logger.trace("BrowserCacheManager.getAuthorityMetadata: cache hit"),av.toObject(new T_,t)):null:(this.logger.trace("BrowserCacheManager.getAuthorityMetadata: called, no cache hit"),null)},M.prototype.getAuthorityMetadataKeys=function(){var t=this;return this.internalStorage.getKeys().filter(function(e){return t.isAuthorityMetadata(e)})},M.prototype.setWrapperMetadata=function(e,t){this.internalStorage.setItem(W0.WRAPPER_SKU,e),this.internalStorage.setItem(W0.WRAPPER_VER,t)},M.prototype.getWrapperMetadata=function(){return[this.internalStorage.getItem(W0.WRAPPER_SKU)||T.EMPTY_STRING,this.internalStorage.getItem(W0.WRAPPER_VER)||T.EMPTY_STRING]},M.prototype.setAuthorityMetadata=function(e,t){this.logger.trace("BrowserCacheManager.setAuthorityMetadata called"),this.internalStorage.setItem(e,JSON.stringify(t))},M.prototype.getActiveAccount=function(){var e=this.generateCacheKey(Vm.ACTIVE_ACCOUNT_FILTERS),e=this.getItem(e);return e?(e=this.validateAndParseJson(e))?(this.logger.trace("BrowserCacheManager.getActiveAccount: Active account filters schema found"),this.getAccountInfoByFilter({homeAccountId:e.homeAccountId,localAccountId:e.localAccountId})[0]||null):(this.logger.trace("BrowserCacheManager.getActiveAccount: No active account found"),null):(this.logger.trace("BrowserCacheManager.getActiveAccount: No active account filters cache schema found, looking for legacy schema"),e=this.generateCacheKey(Vm.ACTIVE_ACCOUNT),(e=this.getItem(e))?(e=this.getAccountInfoByFilter({localAccountId:e})[0]||null)?(this.logger.trace("BrowserCacheManager.getActiveAccount: Legacy active account cache schema found"),this.logger.trace("BrowserCacheManager.getActiveAccount: Adding active account filters cache schema"),this.setActiveAccount(e),e):null:(this.logger.trace("BrowserCacheManager.getActiveAccount: No active account found"),null))},M.prototype.setActiveAccount=function(e){var t,r=this.generateCacheKey(Vm.ACTIVE_ACCOUNT_FILTERS),i=this.generateCacheKey(Vm.ACTIVE_ACCOUNT);e?(this.logger.verbose("setActiveAccount: Active account set"),t={homeAccountId:e.homeAccountId,localAccountId:e.localAccountId},this.browserStorage.setItem(r,JSON.stringify(t)),this.browserStorage.setItem(i,e.localAccountId)):(this.logger.verbose("setActiveAccount: No account passed, active account not set"),this.browserStorage.removeItem(r),this.browserStorage.removeItem(i))},M.prototype.getAccountInfoByFilter=function(t){var e=this.getAllAccounts();return this.logger.trace("BrowserCacheManager.getAccountInfoByFilter: total "+e.length+" accounts found"),e.filter(function(e){return!(t.username&&t.username.toLowerCase()!==e.username.toLowerCase()||t.homeAccountId&&t.homeAccountId!==e.homeAccountId||t.localAccountId&&t.localAccountId!==e.localAccountId||t.tenantId&&t.tenantId!==e.tenantId||t.environment&&t.environment!==e.environment)})},M.prototype.getAccountInfoByHints=function(r,i){var e=this.getAllAccounts().filter(function(e){var t;return i?(t=e.idTokenClaims&&e.idTokenClaims.sid,i===t):!!r&&r===e.username});if(1===e.length)return e[0];if(1<e.length)throw E.createMultipleMatchingAccountsInCacheError();return null},M.prototype.getThrottlingCache=function(e){var t=this.getItem(e);return(t=t&&this.validateAndParseJson(t))&&O_.isThrottlingEntity(e,t)?(this.logger.trace("BrowserCacheManager.getThrottlingCache: cache hit"),av.toObject(new O_,t)):(this.logger.trace("BrowserCacheManager.getThrottlingCache: called, no cache hit"),null)},M.prototype.setThrottlingCache=function(e,t){this.logger.trace("BrowserCacheManager.setThrottlingCache called"),this.setItem(e,JSON.stringify(t))},M.prototype.getTemporaryCache=function(e,t){t=t?this.generateCacheKey(e):e;if(this.cacheConfig.storeAuthStateInCookie){e=this.getItemCookie(t);if(e)return this.logger.trace("BrowserCacheManager.getTemporaryCache: storeAuthStateInCookies set to true, retrieving from cookies"),e}e=this.temporaryCacheStorage.getItem(t);if(e)return this.logger.trace("BrowserCacheManager.getTemporaryCache: Temporary cache item returned"),e;if(this.cacheConfig.cacheLocation===V0.LocalStorage){e=this.browserStorage.getItem(t);if(e)return this.logger.trace("BrowserCacheManager.getTemporaryCache: Temporary cache item found in local storage"),e}return this.logger.trace("BrowserCacheManager.getTemporaryCache: No cache item found in local storage"),null},M.prototype.setTemporaryCache=function(e,t,r){r=r?this.generateCacheKey(e):e;this.temporaryCacheStorage.setItem(r,t),this.cacheConfig.storeAuthStateInCookie&&(this.logger.trace("BrowserCacheManager.setTemporaryCache: storeAuthStateInCookie set to true, setting item cookie"),this.setItemCookie(r,t))},M.prototype.removeItem=function(e){this.browserStorage.removeItem(e),this.temporaryCacheStorage.removeItem(e),this.cacheConfig.storeAuthStateInCookie&&(this.logger.trace("BrowserCacheManager.removeItem: storeAuthStateInCookie is true, clearing item cookie"),this.clearItemCookie(e))},M.prototype.containsKey=function(e){return this.browserStorage.containsKey(e)||this.temporaryCacheStorage.containsKey(e)},M.prototype.getKeys=function(){return Bm(this.browserStorage.getKeys(),this.temporaryCacheStorage.getKeys())},M.prototype.clear=function(){return _(this,void 0,void 0,function(){var t=this;return b(this,function(e){switch(e.label){case 0:return[4,this.removeAllAccounts()];case 1:return e.sent(),this.removeAppMetadata(),this.getKeys().forEach(function(e){!t.browserStorage.containsKey(e)&&!t.temporaryCacheStorage.containsKey(e)||-1===e.indexOf(T.CACHE_PREFIX)&&-1===e.indexOf(t.clientId)||t.removeItem(e)}),this.internalStorage.clear(),[2]}})})},M.prototype.clearTokensAndKeysWithClaims=function(){return _(this,void 0,void 0,function(){var t,r,i=this;return b(this,function(e){switch(e.label){case 0:return this.logger.trace("BrowserCacheManager.clearTokensAndKeysWithClaims called"),t=this.getTokenKeys(),r=[],t.accessToken.forEach(function(e){var t=i.getAccessTokenCredential(e);null!=t&&t.requestedClaimsHash&&e.includes(t.requestedClaimsHash.toLowerCase())&&r.push(i.removeAccessToken(e))}),[4,Promise.all(r)];case 1:return e.sent(),0<r.length&&this.logger.warning(r.length+" access tokens with claims in the cache keys have been removed from the cache."),[2]}})})},M.prototype.setItemCookie=function(e,t,r){e=encodeURIComponent(e)+"="+encodeURIComponent(t)+";path=/;SameSite=Lax;";r&&(e+="expires="+this.getCookieExpirationTime(r)+";"),this.cacheConfig.secureCookies&&(e+="Secure;"),document.cookie=e},M.prototype.getItemCookie=function(e){for(var t=encodeURIComponent(e)+"=",r=document.cookie.split(";"),i=0;i<r.length;i++){for(var n=r[i];" "===n.charAt(0);)n=n.substring(1);if(0===n.indexOf(t))return decodeURIComponent(n.substring(t.length,n.length))}return T.EMPTY_STRING},M.prototype.clearMsalCookies=function(){var r=this,i=T.CACHE_PREFIX+"."+this.clientId;document.cookie.split(";").forEach(function(e){for(;" "===e.charAt(0);)e=e.substring(1);var t;0===e.indexOf(i)&&(t=e.split("=")[0],r.clearItemCookie(t))})},M.prototype.clearItemCookie=function(e){this.setItemCookie(e,T.EMPTY_STRING,-1)},M.prototype.getCookieExpirationTime=function(e){var t=new Date;return new Date(t.getTime()+e*this.COOKIE_LIFE_MULTIPLIER).toUTCString()},M.prototype.getCache=function(){return this.browserStorage},M.prototype.setCache=function(){},M.prototype.generateCacheKey=function(e){return this.validateAndParseJson(e)?JSON.stringify(e):I.startsWith(e,T.CACHE_PREFIX)||I.startsWith(e,Vm.ADAL_ID_TOKEN)?e:T.CACHE_PREFIX+"."+this.clientId+"."+e},M.prototype.generateAuthorityKey=function(e){e=Xv.parseRequestState(this.cryptoImpl,e).libraryState.id;return this.generateCacheKey(K0.AUTHORITY+"."+e)},M.prototype.generateNonceKey=function(e){e=Xv.parseRequestState(this.cryptoImpl,e).libraryState.id;return this.generateCacheKey(K0.NONCE_IDTOKEN+"."+e)},M.prototype.generateStateKey=function(e){e=Xv.parseRequestState(this.cryptoImpl,e).libraryState.id;return this.generateCacheKey(K0.REQUEST_STATE+"."+e)},M.prototype.getCachedAuthority=function(e){var e=this.generateStateKey(e),e=this.getTemporaryCache(e);return e?(e=this.generateAuthorityKey(e),this.getTemporaryCache(e)):null},M.prototype.updateCacheEntries=function(e,t,r,i,n){this.logger.trace("BrowserCacheManager.updateCacheEntries called");var o,a=this.generateStateKey(e),a=(this.setTemporaryCache(a,e,!1),this.generateNonceKey(e)),a=(this.setTemporaryCache(a,t,!1),this.generateAuthorityKey(e));this.setTemporaryCache(a,r,!1),n?(o={credential:n.homeAccountId,type:Tv.HOME_ACCOUNT_ID},this.setTemporaryCache(K0.CCS_CREDENTIAL,JSON.stringify(o),!0)):I.isEmpty(i)||(o={credential:i,type:Tv.UPN},this.setTemporaryCache(K0.CCS_CREDENTIAL,JSON.stringify(o),!0))},M.prototype.resetRequestCache=function(t){var r=this;this.logger.trace("BrowserCacheManager.resetRequestCache called"),I.isEmpty(t)||this.getKeys().forEach(function(e){-1!==e.indexOf(t)&&r.removeItem(e)}),t&&(this.removeItem(this.generateStateKey(t)),this.removeItem(this.generateNonceKey(t)),this.removeItem(this.generateAuthorityKey(t))),this.removeItem(this.generateCacheKey(K0.REQUEST_PARAMS)),this.removeItem(this.generateCacheKey(K0.ORIGIN_URI)),this.removeItem(this.generateCacheKey(K0.URL_HASH)),this.removeItem(this.generateCacheKey(K0.CORRELATION_ID)),this.removeItem(this.generateCacheKey(K0.CCS_CREDENTIAL)),this.removeItem(this.generateCacheKey(K0.NATIVE_REQUEST)),this.setInteractionInProgress(!1)},M.prototype.cleanRequestByState=function(e){this.logger.trace("BrowserCacheManager.cleanRequestByState called"),e&&(e=this.generateStateKey(e),e=this.temporaryCacheStorage.getItem(e),this.logger.infoPii("BrowserCacheManager.cleanRequestByState: Removing temporary cache items for state: "+e),this.resetRequestCache(e||T.EMPTY_STRING)),this.clearMsalCookies()},M.prototype.cleanRequestByInteractionType=function(r){var i=this;this.logger.trace("BrowserCacheManager.cleanRequestByInteractionType called"),this.getKeys().forEach(function(e){var t;-1!==e.indexOf(K0.REQUEST_STATE)&&(e=i.temporaryCacheStorage.getItem(e))&&(t=vb.extractBrowserRequestState(i.cryptoImpl,e))&&t.interactionType===r&&(i.logger.infoPii("BrowserCacheManager.cleanRequestByInteractionType: Removing temporary cache items for state: "+e),i.resetRequestCache(e))}),this.clearMsalCookies(),this.setInteractionInProgress(!1)},M.prototype.cacheCodeRequest=function(e,t){this.logger.trace("BrowserCacheManager.cacheCodeRequest called");t=t.base64Encode(JSON.stringify(e));this.setTemporaryCache(K0.REQUEST_PARAMS,t,!0)},M.prototype.getCachedRequest=function(e,t){this.logger.trace("BrowserCacheManager.getCachedRequest called");var r=this.getTemporaryCache(K0.REQUEST_PARAMS,!0);if(!r)throw k.createNoTokenRequestCacheError();t=this.validateAndParseJson(t.base64Decode(r));if(!t)throw k.createUnableToParseTokenRequestCacheError();if(this.removeItem(this.generateCacheKey(K0.REQUEST_PARAMS)),I.isEmpty(t.authority)){r=this.generateAuthorityKey(e),e=this.getTemporaryCache(r);if(!e)throw k.createNoCachedAuthorityError();t.authority=e}return t},M.prototype.getCachedNativeRequest=function(){this.logger.trace("BrowserCacheManager.getCachedNativeRequest called");var e=this.getTemporaryCache(K0.NATIVE_REQUEST,!0);return e?this.validateAndParseJson(e)||(this.logger.error("BrowserCacheManager.getCachedNativeRequest: Unable to parse native request"),null):(this.logger.trace("BrowserCacheManager.getCachedNativeRequest: No cached native request found"),null)},M.prototype.isInteractionInProgress=function(e){var t=this.getInteractionInProgress();return e?t===this.clientId:!!t},M.prototype.getInteractionInProgress=function(){var e=T.CACHE_PREFIX+"."+K0.INTERACTION_STATUS_KEY;return this.getTemporaryCache(e,!1)},M.prototype.setInteractionInProgress=function(e){var t=T.CACHE_PREFIX+"."+K0.INTERACTION_STATUS_KEY;if(e){if(this.getInteractionInProgress())throw k.createInteractionInProgressError();this.setTemporaryCache(t,this.clientId,!1)}else this.getInteractionInProgress()===this.clientId&&this.removeItem(t)},M.prototype.getLegacyLoginHint=function(){var e=this.getTemporaryCache(Vm.ADAL_ID_TOKEN),t=(e&&(this.browserStorage.removeItem(Vm.ADAL_ID_TOKEN),this.logger.verbose("Cached ADAL id token retrieved.")),this.getTemporaryCache(Vm.ID_TOKEN,!0)),t=(t&&(this.removeItem(this.generateCacheKey(Vm.ID_TOKEN)),this.logger.verbose("Cached MSAL.js v1 id token retrieved")),t||e);if(t){e=new nv(t,this.cryptoImpl);if(e.claims&&e.claims.preferred_username)return this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, setting ADAL/MSAL v1 preferred_username as loginHint"),e.claims.preferred_username;if(e.claims&&e.claims.upn)return this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, setting ADAL/MSAL v1 upn as loginHint"),e.claims.upn;this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, however, no account hint claim found. Enable preferred_username or upn id token claim to get SSO.")}return null},M.prototype.updateCredentialCacheKey=function(e,t){var r=t.generateCredentialKey();if(e!==r){var i=this.getItem(e);if(i)return this.removeItem(e),this.setItem(r,i),this.logger.verbose("Updated an outdated "+t.credentialType+" cache key"),r;this.logger.error("Attempted to update an outdated "+t.credentialType+" cache key but no item matching the outdated key was found in storage")}return e},M.prototype.getRedirectRequestContext=function(){return this.getTemporaryCache(K0.REDIRECT_CONTEXT,!0)},M.prototype.setRedirectRequestContext=function(e){this.setTemporaryCache(K0.REDIRECT_CONTEXT,e,!0)};var bb,wb=M;function M(e,t,r,i){e=bb.call(this,e,r,i)||this;return e.COOKIE_LIFE_MULTIPLIER=864e5,e.cacheConfig=t,e.logger=i,e.internalStorage=new gb,e.browserStorage=e.setupBrowserStorage(e.cacheConfig.cacheLocation),e.temporaryCacheStorage=e.setupTemporaryCacheStorage(e.cacheConfig.temporaryCacheLocation,e.cacheConfig.cacheLocation),t.cacheMigrationEnabled&&(e.migrateCacheEntries(),e.createKeyMaps()),e}var xb="@azure/msal-browser",Cb="2.38.3",Tb=(Sb.prototype.sendGetRequestAsync=function(n,o){return _(this,void 0,void 0,function(){var t,r,i;return b(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),[4,fetch(n,{method:G0.GET,headers:this.getFetchHeaders(o)})];case 1:return t=e.sent(),[3,3];case 2:throw r=e.sent(),window.navigator.onLine?k.createGetRequestFailedError(r,n):k.createNoNetworkConnectivityError();case 3:return e.trys.push([3,5,,6]),i={headers:this.getHeaderDict(t.headers)},[4,t.json()];case 4:return[2,(i.body=e.sent(),i.status=t.status,i)];case 5:throw e.sent(),k.createFailedToParseNetworkResponseError(n);case 6:return[2]}})})},Sb.prototype.sendPostRequestAsync=function(o,a){return _(this,void 0,void 0,function(){var t,r,i,n;return b(this,function(e){switch(e.label){case 0:t=a&&a.body||T.EMPTY_STRING,e.label=1;case 1:return e.trys.push([1,3,,4]),[4,fetch(o,{method:G0.POST,headers:this.getFetchHeaders(a),body:t})];case 2:return r=e.sent(),[3,4];case 3:throw i=e.sent(),window.navigator.onLine?k.createPostRequestFailedError(i,o):k.createNoNetworkConnectivityError();case 4:return e.trys.push([4,6,,7]),n={headers:this.getHeaderDict(r.headers)},[4,r.json()];case 5:return[2,(n.body=e.sent(),n.status=r.status,n)];case 6:throw e.sent(),k.createFailedToParseNetworkResponseError(o);case 7:return[2]}})})},Sb.prototype.getFetchHeaders=function(e){var t,r=new Headers;return e&&e.headers&&(t=e.headers,Object.keys(t).forEach(function(e){r.append(e,t[e])})),r},Sb.prototype.getHeaderDict=function(e){var r={};return e.forEach(function(e,t){r[t]=e}),r},Sb);function Sb(){}Ib.prototype.sendGetRequestAsync=function(t,r){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,this.sendRequestAsync(t,G0.GET,r)]})})},Ib.prototype.sendPostRequestAsync=function(t,r){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,this.sendRequestAsync(t,G0.POST,r)]})})},Ib.prototype.sendRequestAsync=function(o,a,e){var s=this;return new Promise(function(r,i){var n=new XMLHttpRequest;if(n.open(a,o,!0),s.setXhrHeaders(n,e),n.onload=function(){(n.status<200||300<=n.status)&&(a===G0.POST?i(k.createPostRequestFailedError("Failed with status "+n.status,o)):i(k.createGetRequestFailedError("Failed with status "+n.status,o)));try{var e=JSON.parse(n.responseText),t={headers:s.getHeaderDict(n),body:e,status:n.status};r(t)}catch(e){i(k.createFailedToParseNetworkResponseError(o))}},n.onerror=function(){window.navigator.onLine?a===G0.POST?i(k.createPostRequestFailedError("Failed with status "+n.status,o)):i(k.createGetRequestFailedError("Failed with status "+n.status,o)):i(k.createNoNetworkConnectivityError())},a===G0.POST&&e&&e.body)n.send(e.body);else{if(a!==G0.GET)throw k.createHttpMethodNotImplementedError(a);n.send()}})},Ib.prototype.setXhrHeaders=function(t,e){var r;e&&e.headers&&(r=e.headers,Object.keys(r).forEach(function(e){t.setRequestHeader(e,r[e])}))},Ib.prototype.getHeaderDict=function(e){var e=e.getAllResponseHeaders().trim().split(/[\r\n]+/),r={};return e.forEach(function(e){var e=e.split(": "),t=e.shift(),e=e.join(": ");t&&e&&(r[t]=e)}),r};var Eb=Ib;function Ib(){}kb.clearHash=function(e){e.location.hash=T.EMPTY_STRING,"function"==typeof e.history.replaceState&&e.history.replaceState(null,T.EMPTY_STRING,""+e.location.origin+e.location.pathname+e.location.search)},kb.replaceHash=function(e){e=e.split("#");e.shift(),window.location.hash=0<e.length?e.join("#"):T.EMPTY_STRING},kb.isInIframe=function(){return window.parent!==window},kb.isInPopup=function(){return"undefined"!=typeof window&&!!window.opener&&window.opener!==window&&"string"==typeof window.name&&0===window.name.indexOf(X0.POPUP_NAME_PREFIX+".")},kb.getCurrentUri=function(){return window.location.href.split("?")[0].split("#")[0]},kb.getHomepage=function(){var e=new e_(window.location.href).getUrlComponents();return e.Protocol+"//"+e.HostNameAndPort+"/"},kb.getBrowserNetworkClient=function(){return new(window.fetch&&window.Headers?Tb:Eb)},kb.blockReloadInHiddenIframes=function(){if(e_.hashContainsKnownProperties(window.location.hash)&&kb.isInIframe())throw k.createBlockReloadInHiddenIframeError()},kb.blockRedirectInIframe=function(e,t){var r=kb.isInIframe();if(e===P.Redirect&&r&&!t)throw k.createRedirectInIframeError(r)},kb.blockAcquireTokenInPopups=function(){if(kb.isInPopup())throw k.createBlockAcquireTokenInPopupsError()},kb.blockNonBrowserEnvironment=function(e){if(!e)throw k.createNonBrowserEnvironmentError()},kb.blockNativeBrokerCalledBeforeInitialized=function(e,t){if(e&&!t)throw k.createNativeBrokerCalledBeforeInitialize()},kb.detectIEOrEdge=function(){var e=window.navigator.userAgent,t=e.indexOf("MSIE "),r=e.indexOf("Trident/"),e=e.indexOf("Edge/");return 0<t||0<r||0<e};var Ab=kb;function kb(){}Pb.prototype.clearCacheOnLogout=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){switch(e.label){case 0:if(!t)return[3,5];rv.accountInfoIsEqual(t,this.browserStorage.getActiveAccount(),!1)&&(this.logger.verbose("Setting active account to null"),this.browserStorage.setActiveAccount(null)),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.browserStorage.removeAccount(rv.generateAccountCacheKey(t))];case 2:return e.sent(),this.logger.verbose("Cleared cache items belonging to the account provided in the logout request."),[3,4];case 3:return e.sent(),this.logger.error("Account provided in logout request was not found. Local cache unchanged."),[3,4];case 4:return[3,9];case 5:return e.trys.push([5,8,,9]),this.logger.verbose("No account provided in logout request, clearing all cache items.",this.correlationId),[4,this.browserStorage.clear()];case 6:return e.sent(),[4,this.browserCrypto.clearKeystore()];case 7:return e.sent(),[3,9];case 8:return e.sent(),this.logger.error("Attempted to clear all MSAL cache items and failed. Local cache unchanged."),[3,9];case 9:return[2]}})})},Pb.prototype.initializeBaseRequest=function(n,o){return _(this,void 0,void 0,function(){var t,r,i;return b(this,function(e){switch(e.label){case 0:return(this.performanceClient.addQueueMeasurement(A.InitializeBaseRequest,n.correlationId),this.logger.verbose("Initializing BaseAuthRequest"),t=n.authority||this.config.auth.authority,o)?[4,this.validateRequestAuthority(t,o)]:[3,2];case 1:e.sent(),e.label=2;case 2:if(r=Bm(n&&n.scopes||[]),(r=v(v({},n),{correlationId:this.correlationId,authority:t,scopes:r})).authenticationScheme){if(r.authenticationScheme===eg.SSH){if(!n.sshJwk)throw $y.createMissingSshJwkError();if(!n.sshKid)throw $y.createMissingSshKidError()}this.logger.verbose('Authentication Scheme set to "'+r.authenticationScheme+'" as configured in Auth request')}else r.authenticationScheme=eg.BEARER,this.logger.verbose('Authentication Scheme wasn\'t explicitly set in request, defaulting to "Bearer" request');return this.config.cache.claimsBasedCachingEnabled&&n.claims&&!I.isEmptyObj(n.claims)?(i=r,[4,this.browserCrypto.hashString(n.claims)]):[3,4];case 3:i.requestedClaimsHash=e.sent(),e.label=4;case 4:return[2,r]}})})},Pb.prototype.getRedirectUri=function(e){this.logger.verbose("getRedirectUri called");e=e||this.config.auth.redirectUri||Ab.getCurrentUri();return e_.getAbsoluteUrl(e,Ab.getCurrentUri())},Pb.prototype.validateRequestAuthority=function(t,r){return _(this,void 0,void 0,function(){return b(this,function(e){switch(e.label){case 0:return[4,this.getDiscoveredAuthority(t)];case 1:if(e.sent().isAlias(r.environment))return[2];throw $y.createAuthorityMismatchError()}})})},Pb.prototype.initializeServerTelemetryManager=function(e,t){this.logger.verbose("initializeServerTelemetryManager called");e={clientId:this.config.auth.clientId,correlationId:this.correlationId,apiId:e,forceRefresh:t||!1,wrapperSKU:this.browserStorage.getWrapperMetadata()[0],wrapperVer:this.browserStorage.getWrapperMetadata()[1]};return new H_(e,this.browserStorage)},Pb.prototype.getDiscoveredAuthority=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return(this.logger.verbose("getDiscoveredAuthority called"),t={protocolMode:this.config.auth.protocolMode,knownAuthorities:this.config.auth.knownAuthorities,cloudDiscoveryMetadata:this.config.auth.cloudDiscoveryMetadata,authorityMetadata:this.config.auth.authorityMetadata},r)?(this.logger.verbose("Creating discovered authority with request authority"),[4,k_.createDiscoveredInstance(r,this.config.system.networkClient,this.browserStorage,t,this.logger)]):[3,2];case 1:return[2,e.sent()];case 2:return this.logger.verbose("Creating discovered authority with configured authority"),[4,k_.createDiscoveredInstance(this.config.auth.authority,this.config.system.networkClient,this.browserStorage,t,this.logger)];case 3:return[2,e.sent()]}})})};t=Pb;function Pb(e,t,r,i,n,o,a,s,l){this.config=e,this.browserStorage=t,this.browserCrypto=r,this.networkClient=this.config.system.networkClient,this.eventHandler=n,this.navigationClient=o,this.nativeMessageHandler=s,this.correlationId=l||this.browserCrypto.createNewGuid(),this.logger=i.clone(X0.MSAL_SKU,Cb,this.correlationId),this.performanceClient=a}zm(Rb,Mb=t),Rb.prototype.initializeAuthorizationCodeRequest=function(i){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientInitializeAuthorizationCodeRequest,i.correlationId),this.logger.verbose("initializeAuthorizationRequest called",i.correlationId),[4,this.browserCrypto.generatePkceCodes()];case 1:return t=e.sent(),r=v(v({},i),{redirectUri:i.redirectUri,code:T.EMPTY_STRING,codeVerifier:t.verifier}),i.codeChallenge=t.challenge,i.codeChallengeMethod=T.S256_CODE_CHALLENGE_METHOD,[2,r]}})})},Rb.prototype.initializeLogoutRequest=function(e){this.logger.verbose("initializeLogoutRequest called",null==e?void 0:e.correlationId);var t,r=v({correlationId:this.correlationId||this.browserCrypto.createNewGuid()},e);return e?e.logoutHint?this.logger.verbose("logoutHint has already been set in logoutRequest"):e.account?(t=this.getLogoutHintFromIdTokenClaims(e.account))&&(this.logger.verbose("Setting logoutHint to login_hint ID Token Claim value for the account provided"),r.logoutHint=t):this.logger.verbose("logoutHint was not set and account was not passed into logout request, logoutHint will not be set"):this.logger.verbose("logoutHint will not be set since no logout request was configured"),e&&null===e.postLogoutRedirectUri?this.logger.verbose("postLogoutRedirectUri passed as null, not setting post logout redirect uri",r.correlationId):e&&e.postLogoutRedirectUri?(this.logger.verbose("Setting postLogoutRedirectUri to uri set on logout request",r.correlationId),r.postLogoutRedirectUri=e_.getAbsoluteUrl(e.postLogoutRedirectUri,Ab.getCurrentUri())):null===this.config.auth.postLogoutRedirectUri?this.logger.verbose("postLogoutRedirectUri configured as null and no uri set on request, not passing post logout redirect",r.correlationId):this.config.auth.postLogoutRedirectUri?(this.logger.verbose("Setting postLogoutRedirectUri to configured uri",r.correlationId),r.postLogoutRedirectUri=e_.getAbsoluteUrl(this.config.auth.postLogoutRedirectUri,Ab.getCurrentUri())):(this.logger.verbose("Setting postLogoutRedirectUri to current page",r.correlationId),r.postLogoutRedirectUri=e_.getAbsoluteUrl(Ab.getCurrentUri(),Ab.getCurrentUri())),r},Rb.prototype.getLogoutHintFromIdTokenClaims=function(e){e=e.idTokenClaims;if(e){if(e.login_hint)return e.login_hint;this.logger.verbose("The ID Token Claims tied to the provided account do not contain a login_hint claim, logoutHint will not be added to logout request")}else this.logger.verbose("The provided account does not contain ID Token Claims, logoutHint will not be added to logout request");return null},Rb.prototype.createAuthCodeClient=function(r,i,n){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientCreateAuthCodeClient,this.correlationId),this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(r,i,n)];case 1:return t=e.sent(),[2,new p_(t,this.performanceClient)]}})})},Rb.prototype.getClientConfiguration=function(i,n,o){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientGetClientConfiguration,this.correlationId),this.logger.verbose("getClientConfiguration called",this.correlationId),this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetDiscoveredAuthority,this.correlationId),[4,this.getDiscoveredAuthority(n,o)];case 1:return t=e.sent(),r=this.config.system.loggerOptions,[2,{authOptions:{clientId:this.config.auth.clientId,authority:t,clientCapabilities:this.config.auth.clientCapabilities},systemOptions:{tokenRenewalOffsetSeconds:this.config.system.tokenRenewalOffsetSeconds,preventCorsPreflight:!0},loggerOptions:{loggerCallback:r.loggerCallback,piiLoggingEnabled:r.piiLoggingEnabled,logLevel:r.logLevel,correlationId:this.correlationId},cacheOptions:{claimsBasedCachingEnabled:this.config.cache.claimsBasedCachingEnabled},cryptoInterface:this.browserCrypto,networkInterface:this.networkClient,storageInterface:this.browserStorage,serverTelemetryManager:i,libraryInfo:{sku:X0.MSAL_SKU,version:Cb,cpu:T.EMPTY_STRING,os:T.EMPTY_STRING},telemetry:this.config.telemetry}]}})})},Rb.prototype.validateAndExtractStateFromHash=function(e,t,r){if(this.logger.verbose("validateAndExtractStateFromHash called",r),!e.state)throw k.createHashDoesNotContainStateError();var i=vb.extractBrowserRequestState(this.browserCrypto,e.state);if(!i)throw k.createUnableToParseStateError();if(i.interactionType!==t)throw k.createStateInteractionTypeMismatchError();return this.logger.verbose("Returning state from hash",r),e.state},Rb.prototype.getDiscoveredAuthority=function(n,o){var a;return _(this,void 0,void 0,function(){var t,r,i;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientGetDiscoveredAuthority,this.correlationId),this.logger.verbose("getDiscoveredAuthority called",this.correlationId),t=null==(a=this.performanceClient)?void 0:a.startMeasurement(A.StandardInteractionClientGetDiscoveredAuthority,this.correlationId),r={protocolMode:this.config.auth.protocolMode,knownAuthorities:this.config.auth.knownAuthorities,cloudDiscoveryMetadata:this.config.auth.cloudDiscoveryMetadata,authorityMetadata:this.config.auth.authorityMetadata,skipAuthorityMetadataCache:this.config.auth.skipAuthorityMetadataCache},i=n||this.config.auth.authority,i=A_.generateAuthority(i,o||this.config.auth.azureCloudOptions),this.logger.verbose("Creating discovered authority with configured authority",this.correlationId),this.performanceClient.setPreQueueTime(A.AuthorityFactoryCreateDiscoveredInstance,this.correlationId),[4,k_.createDiscoveredInstance(i,this.config.system.networkClient,this.browserStorage,r,this.logger,this.performanceClient,this.correlationId).then(function(e){return t.endMeasurement({success:!0}),e}).catch(function(e){throw t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})];case 1:return[2,e.sent()]}})})},Rb.prototype.initializeAuthorizationRequest=function(a,s){return _(this,void 0,void 0,function(){var t,r,i,n,o;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.StandardInteractionClientInitializeAuthorizationRequest,this.correlationId),this.logger.verbose("initializeAuthorizationRequest called",this.correlationId),t=this.getRedirectUri(a.redirectUri),r={interactionType:s},r=Xv.setRequestState(this.browserCrypto,a&&a.state||T.EMPTY_STRING,r),this.performanceClient.setPreQueueTime(A.InitializeBaseRequest,this.correlationId),n=[{}],[4,this.initializeBaseRequest(a)];case 1:return i=v.apply(void 0,[v.apply(void 0,n.concat([e.sent()])),{redirectUri:t,state:r,nonce:a.nonce||this.browserCrypto.createNewGuid(),responseMode:Wm.FRAGMENT}]),(o=a.account||this.browserStorage.getActiveAccount())&&(this.logger.verbose("Setting validated request account",this.correlationId),this.logger.verbosePii("Setting validated request account: "+o.homeAccountId,this.correlationId),i.account=o),I.isEmpty(i.loginHint)&&!o&&(o=this.browserStorage.getLegacyLoginHint())&&(i.loginHint=o),[2,i]}})})};var Mb,s=Rb;function Rb(){return null!==Mb&&Mb.apply(this,arguments)||this}Lb.prototype.handleCodeResponseFromHash=function(i,n,o,a){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){if(this.performanceClient.addQueueMeasurement(A.HandleCodeResponseFromHash,this.authCodeRequest.correlationId),this.logger.verbose("InteractionHandler.handleCodeResponse called"),I.isEmpty(i))throw k.createEmptyHashError(i);if(t=this.browserStorage.generateStateKey(n),!(t=this.browserStorage.getTemporaryCache(t)))throw E.createStateNotFoundError("Cached State");try{r=this.authModule.handleFragmentResponse(i,t)}catch(e){throw e instanceof bv&&e.subError===u0.code?k.createUserCancelledError():e}return this.performanceClient.setPreQueueTime(A.HandleCodeResponseFromServer,this.authCodeRequest.correlationId),[2,this.handleCodeResponseFromServer(r,n,o,a)]})})},Lb.prototype.handleCodeResponseFromServer=function(n,o,a,s,l){return void 0===l&&(l=!0),_(this,void 0,void 0,function(){var t,r,i;return b(this,function(e){switch(e.label){case 0:if(this.performanceClient.addQueueMeasurement(A.HandleCodeResponseFromServer,this.authCodeRequest.correlationId),this.logger.trace("InteractionHandler.handleCodeResponseFromServer called"),t=this.browserStorage.generateStateKey(o),t=this.browserStorage.getTemporaryCache(t))return r=this.browserStorage.generateNonceKey(t),r=this.browserStorage.getTemporaryCache(r),this.authCodeRequest.code=n.code,n.cloud_instance_host_name?(this.performanceClient.setPreQueueTime(A.UpdateTokenEndpointAuthority,this.authCodeRequest.correlationId),[4,this.updateTokenEndpointAuthority(n.cloud_instance_host_name,a,s)]):[3,2];throw E.createStateNotFoundError("Cached State");case 1:e.sent(),e.label=2;case 2:return l&&(n.nonce=r||void 0),n.state=t,n.client_info?this.authCodeRequest.clientInfo=n.client_info:(i=this.checkCcsCredentials())&&(this.authCodeRequest.ccsCredential=i),this.performanceClient.setPreQueueTime(A.AuthClientAcquireToken,this.authCodeRequest.correlationId),[4,this.authModule.acquireToken(this.authCodeRequest,n)];case 3:return i=e.sent(),this.browserStorage.cleanRequestByState(o),[2,i]}})})},Lb.prototype.updateTokenEndpointAuthority=function(r,i,n){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.UpdateTokenEndpointAuthority,this.authCodeRequest.correlationId),t="https://"+r+"/"+i.tenant+"/",[4,k_.createDiscoveredInstance(t,n,this.browserStorage,i.options,this.logger,this.performanceClient,this.authCodeRequest.correlationId)];case 1:return t=e.sent(),this.authModule.updateAuthority(t),[2]}})})},Lb.prototype.checkCcsCredentials=function(){var t=this.browserStorage.getTemporaryCache(K0.CCS_CREDENTIAL,!0);if(t)try{return JSON.parse(t)}catch(e){this.authModule.logger.error("Cache credential could not be parsed"),this.authModule.logger.errorPii("Cache credential could not be parsed: "+t)}return null};var Ob=Lb;function Lb(e,t,r,i,n){this.authModule=e,this.browserStorage=t,this.authCodeRequest=r,this.logger=i,this.performanceClient=n}zm(Bb,Db=Ob),Bb.prototype.initiateAuthRequest=function(r,i){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return(this.logger.verbose("RedirectHandler.initiateAuthRequest called"),I.isEmpty(r))?[3,7]:(i.redirectStartPage&&(this.logger.verbose("RedirectHandler.initiateAuthRequest: redirectStartPage set, caching start page"),this.browserStorage.setTemporaryCache(K0.ORIGIN_URI,i.redirectStartPage,!0)),this.browserStorage.setTemporaryCache(K0.CORRELATION_ID,this.authCodeRequest.correlationId,!0),this.browserStorage.cacheCodeRequest(this.authCodeRequest,this.browserCrypto),this.logger.infoPii("RedirectHandler.initiateAuthRequest: Navigate to: "+r),t={apiId:Y0.acquireTokenRedirect,timeout:i.redirectTimeout,noHistory:!1},"function"!=typeof i.onRedirectNavigate?[3,4]:(this.logger.verbose("RedirectHandler.initiateAuthRequest: Invoking onRedirectNavigate callback"),!1===i.onRedirectNavigate(r)?[3,2]:(this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate did not return false, navigating"),[4,i.navigationClient.navigateExternal(r,t)])));case 1:return e.sent(),[2];case 2:return this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate returned false, stopping navigation"),[2];case 3:return[3,6];case 4:return this.logger.verbose("RedirectHandler.initiateAuthRequest: Navigating window to navigate url"),[4,i.navigationClient.navigateExternal(r,t)];case 5:return e.sent(),[2];case 6:return[3,8];case 7:throw this.logger.info("RedirectHandler.initiateAuthRequest: Navigate url is empty"),k.createEmptyNavigationUriError();case 8:return[2]}})})},Bb.prototype.handleCodeResponseFromHash=function(o,a,s,l){return _(this,void 0,void 0,function(){var t,r,i,n;return b(this,function(e){switch(e.label){case 0:if(this.logger.verbose("RedirectHandler.handleCodeResponse called"),I.isEmpty(o))throw k.createEmptyHashError(o);if(this.browserStorage.setInteractionInProgress(!1),t=this.browserStorage.generateStateKey(a),!(t=this.browserStorage.getTemporaryCache(t)))throw E.createStateNotFoundError("Cached State");try{r=this.authModule.handleFragmentResponse(o,t)}catch(e){throw e instanceof bv&&e.subError===u0.code?k.createUserCancelledError():e}return(i=this.browserStorage.generateNonceKey(t),i=this.browserStorage.getTemporaryCache(i),this.authCodeRequest.code=r.code,r.cloud_instance_host_name)?[4,this.updateTokenEndpointAuthority(r.cloud_instance_host_name,s,l)]:[3,2];case 1:e.sent(),e.label=2;case 2:return r.nonce=i||void 0,r.state=t,r.client_info?this.authCodeRequest.clientInfo=r.client_info:(n=this.checkCcsCredentials())&&(this.authCodeRequest.ccsCredential=n),[4,this.authModule.acquireToken(this.authCodeRequest,r)];case 3:return n=e.sent(),this.browserStorage.cleanRequestByState(a),[2,n]}})})};var Db,R,zb,Nb=Bb;function Bb(e,t,r,i,n,o){e=Db.call(this,e,t,r,i,o)||this;return e.browserCrypto=n,e}(n=R=R||{}).INITIALIZE_START="msal:initializeStart",n.INITIALIZE_END="msal:initializeEnd",n.ACCOUNT_ADDED="msal:accountAdded",n.ACCOUNT_REMOVED="msal:accountRemoved",n.LOGIN_START="msal:loginStart",n.LOGIN_SUCCESS="msal:loginSuccess",n.LOGIN_FAILURE="msal:loginFailure",n.ACQUIRE_TOKEN_START="msal:acquireTokenStart",n.ACQUIRE_TOKEN_SUCCESS="msal:acquireTokenSuccess",n.ACQUIRE_TOKEN_FAILURE="msal:acquireTokenFailure",n.ACQUIRE_TOKEN_NETWORK_START="msal:acquireTokenFromNetworkStart",n.SSO_SILENT_START="msal:ssoSilentStart",n.SSO_SILENT_SUCCESS="msal:ssoSilentSuccess",n.SSO_SILENT_FAILURE="msal:ssoSilentFailure",n.ACQUIRE_TOKEN_BY_CODE_START="msal:acquireTokenByCodeStart",n.ACQUIRE_TOKEN_BY_CODE_SUCCESS="msal:acquireTokenByCodeSuccess",n.ACQUIRE_TOKEN_BY_CODE_FAILURE="msal:acquireTokenByCodeFailure",n.HANDLE_REDIRECT_START="msal:handleRedirectStart",n.HANDLE_REDIRECT_END="msal:handleRedirectEnd",n.POPUP_OPENED="msal:popupOpened",n.LOGOUT_START="msal:logoutStart",n.LOGOUT_SUCCESS="msal:logoutSuccess",n.LOGOUT_FAILURE="msal:logoutFailure",n.LOGOUT_END="msal:logoutEnd",n.RESTORE_FROM_BFCACHE="msal:restoreFromBFCache",(cn=zb=zb||{}).USER_INTERACTION_REQUIRED="USER_INTERACTION_REQUIRED",cn.USER_CANCEL="USER_CANCEL",cn.NO_NETWORK="NO_NETWORK",cn.TRANSIENT_ERROR="TRANSIENT_ERROR",cn.PERSISTENT_ERROR="PERSISTENT_ERROR",cn.DISABLED="DISABLED",cn.ACCOUNT_UNAVAILABLE="ACCOUNT_UNAVAILABLE";var Fb,Ub={code:"ContentError"},qb={code:"user_switch",desc:"User attempted to switch accounts in the native broker, which is not allowed. All new accounts must sign-in through the standard web flow first, please try again."},jb={code:"tokens_not_found_in_internal_memory_cache",desc:"Tokens not cached in MSAL JS internal memory, please make the WAM request"},Hb=(zm(Vb,Fb=S),Vb.prototype.isFatal=function(){return!(!this.ext||!this.ext.status||this.ext.status!==zb.PERSISTENT_ERROR&&this.ext.status!==zb.DISABLED)||this.errorCode===Ub.code},Vb.createError=function(e,t,r){if(r&&r.status)switch(r.status){case zb.ACCOUNT_UNAVAILABLE:return Wv.createNativeAccountUnavailableError();case zb.USER_INTERACTION_REQUIRED:return new Wv(e,t);case zb.USER_CANCEL:return k.createUserCancelledError();case zb.NO_NETWORK:return k.createNoNetworkConnectivityError()}return new Vb(e,t,r)},Vb.createUserSwitchError=function(){return new Vb(qb.code,qb.desc)},Vb.createTokensNotFoundInCacheError=function(){return new Vb(jb.code,jb.desc)},Vb);function Vb(e,t,r){e=Fb.call(this,e,t)||this;return Object.setPrototypeOf(e,Vb.prototype),e.name="NativeAuthError",e.ext=r,e}zm(Zb,Gb=s),Zb.prototype.acquireToken=function(o){return _(this,void 0,void 0,function(){var t,r,i,n;return b(this,function(e){switch(e.label){case 0:return t=this.performanceClient.startMeasurement(A.SilentCacheClientAcquireToken,o.correlationId),i=this.initializeServerTelemetryManager(Y0.acquireTokenSilent_silentFlow),[4,this.createSilentFlowClient(i,o.authority,o.azureCloudOptions)];case 1:r=e.sent(),this.logger.verbose("Silent auth client created"),e.label=2;case 2:return e.trys.push([2,4,,5]),[4,r.acquireCachedToken(o)];case 3:return i=e.sent(),t.endMeasurement({success:!0,fromCache:!0}),[2,i];case 4:throw(n=e.sent())instanceof k&&n.errorCode===R0.code&&this.logger.verbose("Signing keypair for bound access token not found. Refreshing bound access token and generating a new crypto keypair."),t.endMeasurement({errorCode:n instanceof S&&n.errorCode||void 0,subErrorCode:n instanceof S&&n.subError||void 0,success:!1}),n;case 5:return[2]}})})},Zb.prototype.logout=function(){return Promise.reject(k.createSilentLogoutUnsupportedError())},Zb.prototype.createSilentFlowClient=function(r,i,n){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(r,i,n)];case 1:return t=e.sent(),[2,new __(t,this.performanceClient)]}})})},Zb.prototype.initializeSilentRequest=function(r,i){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.InitializeSilentRequest,this.correlationId),this.performanceClient.setPreQueueTime(A.InitializeBaseRequest,this.correlationId),t=[v({},r)],[4,this.initializeBaseRequest(r,i)];case 1:return[2,v.apply(void 0,[v.apply(void 0,t.concat([e.sent()])),{account:i,forceRefresh:r.forceRefresh||!1}])]}})})};var Gb,Kb=Zb;function Zb(){return null!==Gb&&Gb.apply(this,arguments)||this}zm($b,Wb=t),$b.prototype.acquireToken=function(a){return _(this,void 0,void 0,function(){var t,r,i,n,o;return b(this,function(e){switch(e.label){case 0:return this.logger.trace("NativeInteractionClient - acquireToken called."),t=this.performanceClient.startMeasurement(A.NativeInteractionClientAcquireToken,a.correlationId),r=Dv.nowSeconds(),[4,this.initializeNativeRequest(a)];case 1:i=e.sent(),e.label=2;case 2:return e.trys.push([2,4,,5]),[4,this.acquireTokensFromCache(this.accountId,i)];case 3:return n=e.sent(),t.endMeasurement({success:!0,isNativeBroker:!1,fromCache:!0}),[2,n];case 4:return e.sent(),this.logger.info("MSAL internal Cache does not contain tokens, proceed to make a native call"),[3,5];case 5:return n={method:H0.GetToken,request:i},[4,this.nativeMessageHandler.sendMessage(n)];case 6:return o=e.sent(),o=this.validateNativeResponse(o),[2,this.handleNativeResponse(o,i,r).then(function(e){return t.endMeasurement({success:!0,isNativeBroker:!0,requestId:e.requestId}),e}).catch(function(e){throw t.endMeasurement({success:!1,errorCode:e.errorCode,subErrorCode:e.subError,isNativeBroker:!0}),e})]}})})},$b.prototype.createSilentCacheRequest=function(e,t){return{authority:e.authority,correlationId:this.correlationId,scopes:Jy.fromString(e.scope).asArray(),account:t,forceRefresh:!1}},$b.prototype.acquireTokensFromCache=function(i,n){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:if(!i)throw this.logger.warning("NativeInteractionClient:acquireTokensFromCache - No nativeAccountId provided"),E.createNoAccountFoundError();if(!(t=this.browserStorage.getAccountInfoFilteredBy({nativeAccountId:i})))throw E.createNoAccountFoundError();e.label=1;case 1:return e.trys.push([1,3,,4]),r=this.createSilentCacheRequest(n,t),[4,this.silentCacheClient.acquireToken(r)];case 2:return[2,e.sent()];case 3:throw e.sent();case 4:return[2]}})})},$b.prototype.acquireTokenRedirect=function(a){return _(this,void 0,void 0,function(){var t,r,i,n,o;return b(this,function(e){switch(e.label){case 0:return this.logger.trace("NativeInteractionClient - acquireTokenRedirect called."),[4,this.initializeNativeRequest(a)];case 1:t=e.sent(),r={method:H0.GetToken,request:t},e.label=2;case 2:return e.trys.push([2,4,,5]),[4,this.nativeMessageHandler.sendMessage(r)];case 3:return i=e.sent(),this.validateNativeResponse(i),[3,5];case 4:if((i=e.sent())instanceof Hb&&i.isFatal())throw i;return[3,5];case 5:return this.browserStorage.setTemporaryCache(K0.NATIVE_REQUEST,JSON.stringify(t),!0),n={apiId:Y0.acquireTokenRedirect,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},o=this.config.auth.navigateToLoginRequestUrl?window.location.href:this.getRedirectUri(a.redirectUri),[4,this.navigationClient.navigateExternal(o,n)];case 6:return e.sent(),[2]}})})},$b.prototype.handleRedirectPromise=function(){return _(this,void 0,void 0,function(){var t,r,i,n;return b(this,function(e){switch(e.label){case 0:if(this.logger.trace("NativeInteractionClient - handleRedirectPromise called."),!this.browserStorage.isInteractionInProgress(!0))return this.logger.info("handleRedirectPromise called but there is no interaction in progress, returning null."),[2,null];if(!(t=this.browserStorage.getCachedNativeRequest()))return this.logger.verbose("NativeInteractionClient - handleRedirectPromise called but there is no cached request, returning null."),[2,null];r=t.prompt,t=Nm(t,["prompt"]),r&&this.logger.verbose("NativeInteractionClient - handleRedirectPromise called and prompt was included in the original request, removing prompt from cached request to prevent second interaction with native broker window."),this.browserStorage.removeItem(this.browserStorage.generateCacheKey(K0.NATIVE_REQUEST)),r={method:H0.GetToken,request:t},i=Dv.nowSeconds(),e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("NativeInteractionClient - handleRedirectPromise sending message to native broker."),[4,this.nativeMessageHandler.sendMessage(r)];case 2:return n=e.sent(),this.validateNativeResponse(n),n=this.handleNativeResponse(n,t,i),this.browserStorage.setInteractionInProgress(!1),[2,n];case 3:throw n=e.sent(),this.browserStorage.setInteractionInProgress(!1),n;case 4:return[2]}})})},$b.prototype.logout=function(){return this.logger.trace("NativeInteractionClient - logout called."),Promise.reject("Logout not implemented yet")},$b.prototype.handleNativeResponse=function(o,a,s){return _(this,void 0,void 0,function(){var t,r,i,n;return b(this,function(e){switch(e.label){case 0:if(this.logger.trace("NativeInteractionClient - handleNativeResponse called."),o.account.id!==a.accountId)throw Hb.createUserSwitchError();return[4,this.getDiscoveredAuthority(a.authority)];case 1:return n=e.sent(),i=n.getPreferredCache(),t=this.createIdTokenObj(o),r=this.createHomeAccountIdentifier(o,t),i=this.createAccountEntity(o,r,t,i),[4,this.generateAuthenticationResult(o,a,t,i,n.canonicalAuthority,s)];case 2:return n=e.sent(),this.cacheAccount(i),this.cacheNativeTokens(o,a,r,i,t,n.accessToken,n.tenantId,s),[2,n]}})})},$b.prototype.createIdTokenObj=function(e){return new nv(e.id_token||T.EMPTY_STRING,this.browserCrypto)},$b.prototype.createHomeAccountIdentifier=function(e,t){return rv.generateHomeAccountId(e.client_info||T.EMPTY_STRING,Xy.Default,this.logger,this.browserCrypto,t)},$b.prototype.createAccountEntity=function(e,t,r,i){return rv.createAccount(e.client_info,t,r,void 0,void 0,void 0,i,e.account.id)},$b.prototype.generateScopes=function(e,t){return e.scope?Jy.fromString(e.scope):Jy.fromString(t.scope)},$b.prototype.generatePopAccessToken=function(i,n){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:if(n.tokenType!==eg.POP)return[3,2];if(i.shr)return this.logger.trace("handleNativeServerResponse: SHR is enabled in native layer"),[2,i.shr];if(t=new n_(this.browserCrypto),r={resourceRequestMethod:n.resourceRequestMethod,resourceRequestUri:n.resourceRequestUri,shrClaims:n.shrClaims,shrNonce:n.shrNonce},n.keyId)return[4,t.signPopToken(i.access_token,n.keyId,r)];throw E.createKeyIdMissingError();case 1:return[2,e.sent()];case 2:return[2,i.access_token]}})})},$b.prototype.generateAuthenticationResult=function(s,l,c,u,h,d){return _(this,void 0,void 0,function(){var t,r,i,n,o,a;return b(this,function(e){switch(e.label){case 0:return t=this.addTelemetryFromNativeResponse(s),r=s.scope?Jy.fromString(s.scope):Jy.fromString(l.scope),n=s.account.properties||{},i=n.UID||c.claims.oid||c.claims.sub||T.EMPTY_STRING,n=n.TenantId||c.claims.tid||T.EMPTY_STRING,[4,this.generatePopAccessToken(s,l)];case 1:return o=e.sent(),a=l.tokenType===eg.POP?eg.POP:eg.BEARER,[2,{authority:h,uniqueId:i,tenantId:n,scopes:r.asArray(),account:u.getAccountInfo(),idToken:s.id_token,idTokenClaims:c.claims,accessToken:o,fromCache:!!t&&this.isResponseFromCache(t),expiresOn:new Date(1e3*Number(d+s.expires_in)),tokenType:a,correlationId:this.correlationId,state:s.state,fromNativeBroker:!0}]}})})},$b.prototype.cacheAccount=function(e){var t=this;this.browserStorage.setAccount(e),this.browserStorage.removeAccountContext(e).catch(function(e){t.logger.error("Error occurred while removing account context from browser storage. "+e)})},$b.prototype.cacheNativeTokens=function(e,t,r,i,n,o,a,s){var l=Ov.createIdTokenEntity(r,t.authority,e.id_token||T.EMPTY_STRING,t.clientId,n.claims.tid||T.EMPTY_STRING),s=s+(t.tokenType===eg.POP?T.SHR_NONCE_VALIDITY:("string"==typeof e.expires_in?parseInt(e.expires_in,10):e.expires_in)||0),e=this.generateScopes(e,t),r=Bv.createAccessTokenEntity(r,t.authority,o,t.clientId,n?n.claims.tid||T.EMPTY_STRING:a,e.printScopes(),s,0,this.browserCrypto),o=new $v(i,l,r);this.nativeStorageManager.saveCacheRecord(o)},$b.prototype.addTelemetryFromNativeResponse=function(e){e=this.getMATSFromResponse(e);return e?(this.performanceClient.addStaticFields({extensionId:this.nativeMessageHandler.getExtensionId(),extensionVersion:this.nativeMessageHandler.getExtensionVersion(),matsBrokerVersion:e.broker_version,matsAccountJoinOnStart:e.account_join_on_start,matsAccountJoinOnEnd:e.account_join_on_end,matsDeviceJoin:e.device_join,matsPromptBehavior:e.prompt_behavior,matsApiErrorCode:e.api_error_code,matsUiVisible:e.ui_visible,matsSilentCode:e.silent_code,matsSilentBiSubCode:e.silent_bi_sub_code,matsSilentMessage:e.silent_message,matsSilentStatus:e.silent_status,matsHttpStatus:e.http_status,matsHttpEventCount:e.http_event_count},this.correlationId),e):null},$b.prototype.validateNativeResponse=function(e){if(e.hasOwnProperty("access_token")&&e.hasOwnProperty("id_token")&&e.hasOwnProperty("client_info")&&e.hasOwnProperty("account")&&e.hasOwnProperty("scope")&&e.hasOwnProperty("expires_in"))return e;throw Hb.createUnexpectedError("Response missing expected properties.")},$b.prototype.getMATSFromResponse=function(e){if(e.properties.MATS)try{return JSON.parse(e.properties.MATS)}catch(e){this.logger.error("NativeInteractionClient - Error parsing MATS telemetry, returning null instead")}return null},$b.prototype.isResponseFromCache=function(e){return void 0===e.is_cached?(this.logger.verbose("NativeInteractionClient - MATS telemetry does not contain field indicating if response was served from cache. Returning false."),!1):!!e.is_cached},$b.prototype.initializeNativeRequest=function(s){return _(this,void 0,void 0,function(){var t,r,i,n,o,a=this;return b(this,function(e){switch(e.label){case 0:return(this.logger.trace("NativeInteractionClient - initializeNativeRequest called"),t=s.authority||this.config.auth.authority,s.account)?[4,this.validateRequestAuthority(t,s.account)]:[3,2];case 1:e.sent(),e.label=2;case 2:return((n=new e_(t)).validateAsUri(),o=s.scopes,i=Nm(s,["scopes"]),(o=new Jy(o||[])).appendScopes(tg),r=function(){switch(a.apiId){case Y0.ssoSilent:case Y0.acquireTokenSilent_silentFlow:return a.logger.trace("initializeNativeRequest: silent request sets prompt to none"),ig.NONE}if(s.prompt)switch(s.prompt){case ig.NONE:case ig.CONSENT:case ig.LOGIN:return a.logger.trace("initializeNativeRequest: prompt is compatible with native flow"),s.prompt;default:throw a.logger.trace("initializeNativeRequest: prompt = "+s.prompt+" is not compatible with native flow"),k.createNativePromptParameterNotSupportedError()}else a.logger.trace("initializeNativeRequest: prompt was not provided")},i=v(v({},i),{accountId:this.accountId,clientId:this.config.auth.clientId,authority:n.urlString,scope:o.printScopes(),redirectUri:this.getRedirectUri(s.redirectUri),prompt:r(),correlationId:this.correlationId,tokenType:s.authenticationScheme,windowTitleSubstring:document.title,extraParameters:v(v(v({},s.extraQueryParameters),s.tokenQueryParameters),{telemetry:eb}),extendedExpiryToken:!1}),s.authenticationScheme!==eg.POP)?[3,4]:(n={resourceRequestUri:s.resourceRequestUri,resourceRequestMethod:s.resourceRequestMethod,shrClaims:s.shrClaims,shrNonce:s.shrNonce},[4,new n_(this.browserCrypto).generateCnf(n)]);case 3:o=e.sent(),i.reqCnf=o.reqCnfString,i.keyId=o.kid,e.label=4;case 4:return[2,i]}})})};var Wb,Yb=$b;function $b(e,t,r,i,n,o,a,s,l,c,u,h){t=Wb.call(this,e,t,r,i,n,o,s,l,h)||this;return t.apiId=a,t.accountId=c,t.nativeMessageHandler=l,t.nativeStorageManager=u,t.silentCacheClient=new Kb(e,t.nativeStorageManager,r,i,n,o,s,l,h),t}Jb.prototype.sendMessage=function(t){return _(this,void 0,void 0,function(){var r,i=this;return b(this,function(e){return this.logger.trace("NativeMessageHandler - sendMessage called."),r={channel:J0,extensionId:this.extensionId,responseId:this.responseId++,body:t},this.logger.trace("NativeMessageHandler - Sending request to browser extension"),this.logger.tracePii("NativeMessageHandler - Sending request to browser extension: "+JSON.stringify(r)),this.messageChannel.port1.postMessage(r),[2,new Promise(function(e,t){i.resolvers.set(r.responseId,{resolve:e,reject:t})})]})})},Jb.createProvider=function(i,n,o){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:i.trace("NativeMessageHandler - createProvider called."),e.label=1;case 1:return e.trys.push([1,3,,5]),[4,(t=new Jb(i,n,o,Q0)).sendHandshakeRequest()];case 2:return e.sent(),[2,t];case 3:return e.sent(),[4,(r=new Jb(i,n,o)).sendHandshakeRequest()];case 4:return e.sent(),[2,r];case 5:return[2]}})})},Jb.prototype.sendHandshakeRequest=function(){return _(this,void 0,void 0,function(){var r,i=this;return b(this,function(e){return this.logger.trace("NativeMessageHandler - sendHandshakeRequest called."),window.addEventListener("message",this.windowListener,!1),r={channel:J0,extensionId:this.extensionId,responseId:this.responseId++,body:{method:H0.HandshakeRequest}},this.handshakeEvent.addStaticFields({extensionId:this.extensionId,extensionHandshakeTimeoutMs:this.handshakeTimeoutMs}),this.messageChannel.port1.onmessage=function(e){i.onChannelMessage(e)},window.postMessage(r,window.origin,[this.messageChannel.port2]),[2,new Promise(function(e,t){i.handshakeResolvers.set(r.responseId,{resolve:e,reject:t}),i.timeoutId=window.setTimeout(function(){window.removeEventListener("message",i.windowListener,!1),i.messageChannel.port1.close(),i.messageChannel.port2.close(),i.handshakeEvent.endMeasurement({extensionHandshakeTimedOut:!0,success:!1}),t(k.createNativeHandshakeTimeoutError()),i.handshakeResolvers.delete(r.responseId)},i.handshakeTimeoutMs)})]})})},Jb.prototype.onWindowMessage=function(e){this.logger.trace("NativeMessageHandler - onWindowMessage called"),e.source!==window||!(e=e.data).channel||e.channel!==J0||e.extensionId&&e.extensionId!==this.extensionId||e.body.method===H0.HandshakeRequest&&(this.logger.verbose(e.extensionId?"Extension with id: "+e.extensionId+" not installed":"No extension installed"),clearTimeout(this.timeoutId),this.messageChannel.port1.close(),this.messageChannel.port2.close(),window.removeEventListener("message",this.windowListener,!1),e=this.handshakeResolvers.get(e.responseId))&&(this.handshakeEvent.endMeasurement({success:!1,extensionInstalled:!1}),e.reject(k.createNativeExtensionNotInstalledError()))},Jb.prototype.onChannelMessage=function(t){this.logger.trace("NativeMessageHandler - onChannelMessage called.");var e=t.data,r=this.resolvers.get(e.responseId),i=this.handshakeResolvers.get(e.responseId);try{var n=e.body.method;if(n===H0.Response){if(r){var o=e.body.response;if(this.logger.trace("NativeMessageHandler - Received response from browser extension"),this.logger.tracePii("NativeMessageHandler - Received response from browser extension: "+JSON.stringify(o)),"Success"!==o.status)r.reject(Hb.createError(o.code,o.description,o.ext));else{if(!o.result)throw S.createUnexpectedError("Event does not contain result.");o.result.code&&o.result.description?r.reject(Hb.createError(o.result.code,o.result.description,o.result.ext)):r.resolve(o.result)}this.resolvers.delete(e.responseId)}}else n===H0.HandshakeResponse&&i&&(clearTimeout(this.timeoutId),window.removeEventListener("message",this.windowListener,!1),this.extensionId=e.extensionId,this.extensionVersion=e.body.version,this.logger.verbose("NativeMessageHandler - Received HandshakeResponse from extension: "+this.extensionId),this.handshakeEvent.endMeasurement({extensionInstalled:!0,success:!0}),i.resolve(),this.handshakeResolvers.delete(e.responseId))}catch(e){this.logger.error("Error parsing response from WAM Extension"),this.logger.errorPii("Error parsing response from WAM Extension: "+e.toString()),this.logger.errorPii("Unable to parse "+t),r?r.reject(e):i&&i.reject(e)}},Jb.prototype.getExtensionId=function(){return this.extensionId},Jb.prototype.getExtensionVersion=function(){return this.extensionVersion},Jb.isNativeAvailable=function(e,t,r,i){if(t.trace("isNativeAvailable called"),!e.system.allowNativeBroker)return t.trace("isNativeAvailable: allowNativeBroker is not enabled, returning false"),!1;if(!r)return t.trace("isNativeAvailable: WAM extension provider is not initialized, returning false"),!1;if(i)switch(i){case eg.BEARER:case eg.POP:return t.trace("isNativeAvailable: authenticationScheme is supported, returning true"),!0;default:return t.trace("isNativeAvailable: authenticationScheme is not supported, returning false"),!1}return!0};var Xb=Jb;function Jb(e,t,r,i){this.logger=e,this.handshakeTimeoutMs=t,this.extensionId=i,this.resolvers=new Map,this.handshakeResolvers=new Map,this.responseId=0,this.messageChannel=new MessageChannel,this.windowListener=this.onWindowMessage.bind(this),this.performanceClient=r,this.handshakeEvent=r.startMeasurement(A.NativeMessageHandlerHandshake)}zm(tw,Qb=s),tw.prototype.acquireToken=function(c){return _(this,void 0,void 0,function(){var t,r,i,n,o,a,s,l=this;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,c.correlationId),[4,this.initializeAuthorizationRequest(c,P.Redirect)];case 1:t=e.sent(),this.browserStorage.updateCacheEntries(t.state,t.nonce,t.authority,t.loginHint||T.EMPTY_STRING,t.account||null),r=this.initializeServerTelemetryManager(Y0.acquireTokenRedirect),i=function(e){e.persisted&&(l.logger.verbose("Page was restored from back/forward cache. Clearing temporary cache."),l.browserStorage.cleanRequestByState(t.state),l.eventHandler.emitEvent(R.RESTORE_FROM_BFCACHE,P.Redirect))},e.label=2;case 2:return e.trys.push([2,7,,8]),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationCodeRequest,c.correlationId),[4,this.initializeAuthorizationCodeRequest(t)];case 3:return n=e.sent(),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,c.correlationId),[4,this.createAuthCodeClient(r,t.authority,t.azureCloudOptions)];case 4:return a=e.sent(),this.logger.verbose("Auth code client created"),o=new Nb(a,this.browserStorage,n,this.logger,this.browserCrypto,this.performanceClient),[4,a.getAuthCodeUrl(v(v({},t),{nativeBroker:Xb.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,c.authenticationScheme)}))];case 5:return a=e.sent(),s=this.getRedirectStartPage(c.redirectStartPage),this.logger.verbosePii("Redirect start page: "+s),window.addEventListener("pageshow",i),[4,o.initiateAuthRequest(a,{navigationClient:this.navigationClient,redirectTimeout:this.config.system.redirectNavigationTimeout,redirectStartPage:s,onRedirectNavigate:c.onRedirectNavigate})];case 6:return[2,e.sent()];case 7:throw(s=e.sent())instanceof S&&s.setCorrelationId(this.correlationId),window.removeEventListener("pageshow",i),r.cacheFailedRequest(s),this.browserStorage.cleanRequestByState(t.state),s;case 8:return[2]}})})},tw.prototype.handleRedirectPromise=function(h){return _(this,void 0,void 0,function(){var t,r,i,n,o,a,s,l,c,u;return b(this,function(e){switch(e.label){case 0:t=this.initializeServerTelemetryManager(Y0.handleRedirectPromise),e.label=1;case 1:if(e.trys.push([1,10,,11]),!this.browserStorage.isInteractionInProgress(!0))return this.logger.info("handleRedirectPromise called but there is no interaction in progress, returning null."),[2,null];if(!(r=this.getRedirectResponseHash(h||window.location.hash)))return this.logger.info("handleRedirectPromise did not detect a response hash as a result of a redirect. Cleaning temporary cache."),this.browserStorage.cleanRequestByInteractionType(P.Redirect),[2,null];i=void 0;try{n=e_.getDeserializedHash(r),i=this.validateAndExtractStateFromHash(n,P.Redirect),this.logger.verbose("State extracted from hash")}catch(e){return this.logger.info("handleRedirectPromise was unable to extract state due to: "+e),this.browserStorage.cleanRequestByInteractionType(P.Redirect),[2,null]}return(o=this.browserStorage.getTemporaryCache(K0.ORIGIN_URI,!0)||T.EMPTY_STRING,a=e_.removeHashFromUrl(o),c=e_.removeHashFromUrl(window.location.href),a===c&&this.config.auth.navigateToLoginRequestUrl)?(this.logger.verbose("Current page is loginRequestUrl, handling hash"),[4,this.handleHash(r,i,t)]):[3,3];case 2:return a=e.sent(),-1<o.indexOf("#")&&Ab.replaceHash(o),[2,a];case 3:return this.config.auth.navigateToLoginRequestUrl?[3,4]:(this.logger.verbose("NavigateToLoginRequestUrl set to false, handling hash"),[2,this.handleHash(r,i,t)]);case 4:return Ab.isInIframe()&&!this.config.system.allowRedirectInIframe?[3,9]:(this.browserStorage.setTemporaryCache(K0.URL_HASH,r,!0),s={apiId:Y0.handleRedirectPromise,timeout:this.config.system.redirectNavigationTimeout,noHistory:!0},l=!0,o&&"null"!==o?[3,6]:(c=Ab.getHomepage(),this.browserStorage.setTemporaryCache(K0.ORIGIN_URI,c,!0),this.logger.warning("Unable to get valid login request url from cache, redirecting to home page"),[4,this.navigationClient.navigateInternal(c,s)]));case 5:return l=e.sent(),[3,8];case 6:return this.logger.verbose("Navigating to loginRequestUrl: "+o),[4,this.navigationClient.navigateInternal(o,s)];case 7:l=e.sent(),e.label=8;case 8:if(!l)return[2,this.handleHash(r,i,t)];e.label=9;case 9:return[2,null];case 10:throw(u=e.sent())instanceof S&&u.setCorrelationId(this.correlationId),t.cacheFailedRequest(u),this.browserStorage.cleanRequestByInteractionType(P.Redirect),u;case 11:return[2]}})})},tw.prototype.getRedirectResponseHash=function(e){return this.logger.verbose("getRedirectResponseHash called"),e_.hashContainsKnownProperties(e)?(Ab.clearHash(window),this.logger.verbose("Hash contains known properties, returning response hash")):(e=this.browserStorage.getTemporaryCache(K0.URL_HASH,!0),this.browserStorage.removeItem(this.browserStorage.generateCacheKey(K0.URL_HASH)),this.logger.verbose("Hash does not contain known properties, returning cached hash")),e},tw.prototype.handleHash=function(o,a,s){return _(this,void 0,void 0,function(){var t,r,i,n=this;return b(this,function(e){switch(e.label){case 0:if(t=this.browserStorage.getCachedRequest(a,this.browserCrypto),this.logger.verbose("handleHash called, retrieved cached request"),(r=e_.getDeserializedHash(o)).accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),this.nativeMessageHandler)return r=new Yb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Y0.acquireTokenPopup,this.performanceClient,this.nativeMessageHandler,r.accountId,this.nativeStorage,t.correlationId),i=Xv.parseRequestState(this.browserCrypto,a).userRequestState,[2,r.acquireToken(v(v({},t),{state:i,prompt:void 0})).finally(function(){n.browserStorage.cleanRequestByState(a)})];throw k.createNativeConnectionNotEstablishedError()}if(r=this.browserStorage.getCachedAuthority(a))return this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,t.correlationId),[4,this.createAuthCodeClient(s,r)];throw k.createNoCachedAuthorityError();case 1:return i=e.sent(),this.logger.verbose("Auth code client created"),xv.removeThrottle(this.browserStorage,this.config.auth.clientId,t),[4,new Nb(i,this.browserStorage,t,this.logger,this.browserCrypto,this.performanceClient).handleCodeResponseFromHash(o,a,i.authority,this.networkClient)];case 2:return[2,e.sent()]}})})},tw.prototype.logout=function(a){return _(this,void 0,void 0,function(){var t,r,i,n,o;return b(this,function(e){switch(e.label){case 0:this.logger.verbose("logoutRedirect called"),t=this.initializeLogoutRequest(a),r=this.initializeServerTelemetryManager(Y0.logout),e.label=1;case 1:return e.trys.push([1,10,,11]),this.eventHandler.emitEvent(R.LOGOUT_START,P.Redirect,a),[4,this.clearCacheOnLogout(t.account)];case 2:return e.sent(),i={apiId:Y0.logout,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,t.correlationId),[4,this.createAuthCodeClient(r,a&&a.authority)];case 3:return(n=e.sent(),this.logger.verbose("Auth code client created"),n=n.getLogoutUri(t),this.eventHandler.emitEvent(R.LOGOUT_SUCCESS,P.Redirect,t),a&&"function"==typeof a.onRedirectNavigate)?!1===a.onRedirectNavigate(n)?[3,5]:(this.logger.verbose("Logout onRedirectNavigate did not return false, navigating"),this.browserStorage.getInteractionInProgress()||this.browserStorage.setInteractionInProgress(!0),[4,this.navigationClient.navigateExternal(n,i)]):[3,7];case 4:return e.sent(),[2];case 5:this.browserStorage.setInteractionInProgress(!1),this.logger.verbose("Logout onRedirectNavigate returned false, stopping navigation"),e.label=6;case 6:return[3,9];case 7:return this.browserStorage.getInteractionInProgress()||this.browserStorage.setInteractionInProgress(!0),[4,this.navigationClient.navigateExternal(n,i)];case 8:return e.sent(),[2];case 9:return[3,11];case 10:throw(o=e.sent())instanceof S&&o.setCorrelationId(this.correlationId),r.cacheFailedRequest(o),this.eventHandler.emitEvent(R.LOGOUT_FAILURE,P.Redirect,null,o),this.eventHandler.emitEvent(R.LOGOUT_END,P.Redirect),o;case 11:return this.eventHandler.emitEvent(R.LOGOUT_END,P.Redirect),[2]}})})},tw.prototype.getRedirectStartPage=function(e){e=e||window.location.href;return e_.getAbsoluteUrl(e,Ab.getCurrentUri())};var Qb,ew=tw;function tw(e,t,r,i,n,o,a,s,l,c){e=Qb.call(this,e,t,r,i,n,o,a,l,c)||this;return e.nativeStorage=s,e}zm(nw,rw=s),nw.prototype.acquireToken=function(e){try{var t,r=this.generatePopupName(e.scopes||tg,e.authority||this.config.auth.authority),i=e.popupWindowAttributes||{};return this.config.system.asyncPopups?(this.logger.verbose("asyncPopups set to true, acquiring token"),this.acquireTokenPopupAsync(e,r,i)):(this.logger.verbose("asyncPopup set to false, opening popup before acquiring token"),t=this.openSizedPopup("about:blank",r,i),this.acquireTokenPopupAsync(e,r,i,t))}catch(e){return Promise.reject(e)}},nw.prototype.logout=function(e){try{this.logger.verbose("logoutPopup called");var t,r=this.initializeLogoutRequest(e),i=this.generateLogoutPopupName(r),n=e&&e.authority,o=e&&e.mainWindowRedirectUri,a=(null==e?void 0:e.popupWindowAttributes)||{};return this.config.system.asyncPopups?(this.logger.verbose("asyncPopups set to true"),this.logoutPopupAsync(r,i,a,n,void 0,o)):(this.logger.verbose("asyncPopup set to false, opening popup"),t=this.openSizedPopup("about:blank",i,a),this.logoutPopupAsync(r,i,a,n,t,o))}catch(e){return Promise.reject(e)}},nw.prototype.acquireTokenPopupAsync=function(p,f,m,g){return _(this,void 0,void 0,function(){var t,r,i,n,o,a,s,l,c,u,h,d=this;return b(this,function(e){switch(e.label){case 0:return this.logger.verbose("acquireTokenPopupAsync called"),t=this.initializeServerTelemetryManager(Y0.acquireTokenPopup),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,p.correlationId),[4,this.initializeAuthorizationRequest(p,P.Popup)];case 1:r=e.sent(),this.browserStorage.updateCacheEntries(r.state,r.nonce,r.authority,r.loginHint||T.EMPTY_STRING,r.account||null),e.label=2;case 2:return e.trys.push([2,8,,9]),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationCodeRequest,p.correlationId),[4,this.initializeAuthorizationCodeRequest(r)];case 3:return i=e.sent(),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,p.correlationId),[4,this.createAuthCodeClient(t,r.authority,r.azureCloudOptions)];case 4:return n=e.sent(),this.logger.verbose("Auth code client created"),a=Xb.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,p.authenticationScheme),o=void 0,a&&(o=this.performanceClient.startMeasurement(A.FetchAccountIdWithNativeBroker,p.correlationId)),[4,n.getAuthCodeUrl(v(v({},r),{nativeBroker:a}))];case 5:return a=e.sent(),s=new Ob(n,this.browserStorage,i,this.logger,this.performanceClient),l={popup:g,popupName:f,popupWindowAttributes:m},l=this.initiateAuthRequest(a,l),this.eventHandler.emitEvent(R.POPUP_OPENED,P.Popup,{popupWindow:l},null),[4,this.monitorPopupForHash(l)];case 6:if(l=e.sent(),h=e_.getDeserializedHash(l),c=this.validateAndExtractStateFromHash(h,P.Popup,r.correlationId),xv.removeThrottle(this.browserStorage,this.config.auth.clientId,i),h.accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),o&&o.endMeasurement({success:!0,isNativeBroker:!0}),this.nativeMessageHandler)return h=new Yb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Y0.acquireTokenPopup,this.performanceClient,this.nativeMessageHandler,h.accountId,this.nativeStorage,r.correlationId),u=Xv.parseRequestState(this.browserCrypto,c).userRequestState,[2,h.acquireToken(v(v({},r),{state:u,prompt:void 0})).finally(function(){d.browserStorage.cleanRequestByState(c)})];throw k.createNativeConnectionNotEstablishedError()}return[4,s.handleCodeResponseFromHash(l,c,n.authority,this.networkClient)];case 7:return[2,e.sent()];case 8:throw h=e.sent(),g&&g.close(),h instanceof S&&h.setCorrelationId(this.correlationId),t.cacheFailedRequest(h),this.browserStorage.cleanRequestByState(r.state),h;case 9:return[2]}})})},nw.prototype.logoutPopupAsync=function(n,o,a,s,l,c){return _(this,void 0,void 0,function(){var t,r,i;return b(this,function(e){switch(e.label){case 0:this.logger.verbose("logoutPopupAsync called"),this.eventHandler.emitEvent(R.LOGOUT_START,P.Popup,n),t=this.initializeServerTelemetryManager(Y0.logoutPopup),e.label=1;case 1:return e.trys.push([1,5,,6]),[4,this.clearCacheOnLogout(n.account)];case 2:return e.sent(),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,n.correlationId),[4,this.createAuthCodeClient(t,s)];case 3:return r=e.sent(),this.logger.verbose("Auth code client created"),r=r.getLogoutUri(n),this.eventHandler.emitEvent(R.LOGOUT_SUCCESS,P.Popup,n),r=this.openPopup(r,{popupName:o,popupWindowAttributes:a,popup:l}),this.eventHandler.emitEvent(R.POPUP_OPENED,P.Popup,{popupWindow:r},null),[4,this.waitForLogoutPopup(r)];case 4:return e.sent(),c?(r={apiId:Y0.logoutPopup,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},i=e_.getAbsoluteUrl(c,Ab.getCurrentUri()),this.logger.verbose("Redirecting main window to url specified in the request"),this.logger.verbosePii("Redirecting main window to: "+i),this.navigationClient.navigateInternal(i,r)):this.logger.verbose("No main window navigation requested"),[3,6];case 5:throw i=e.sent(),l&&l.close(),i instanceof S&&i.setCorrelationId(this.correlationId),this.browserStorage.setInteractionInProgress(!1),this.eventHandler.emitEvent(R.LOGOUT_FAILURE,P.Popup,null,i),this.eventHandler.emitEvent(R.LOGOUT_END,P.Popup),t.cacheFailedRequest(i),i;case 6:return this.eventHandler.emitEvent(R.LOGOUT_END,P.Popup),[2]}})})},nw.prototype.initiateAuthRequest=function(e,t){if(I.isEmpty(e))throw this.logger.error("Navigate url is empty"),k.createEmptyNavigationUriError();return this.logger.infoPii("Navigate to: "+e),this.openPopup(e,t)},nw.prototype.monitorPopupForHash=function(s){var l=this;return new Promise(function(r,i){var n=l.config.system.windowHashTimeout/l.config.system.pollIntervalMilliseconds,o=0,a=(l.logger.verbose("PopupHandler.monitorPopupForHash - polling started"),setInterval(function(){if(s.closed)l.logger.error("PopupHandler.monitorPopupForHash - window closed"),l.cleanPopup(),clearInterval(a),i(k.createUserCancelledError());else{var e=T.EMPTY_STRING,t=T.EMPTY_STRING;try{e=s.location.href,t=s.location.hash}catch(e){}I.isEmpty(e)||"about:blank"===e||(l.logger.verbose("PopupHandler.monitorPopupForHash - popup window is on same origin as caller"),o++,t?(l.logger.verbose("PopupHandler.monitorPopupForHash - found hash in url"),clearInterval(a),l.cleanPopup(s),e_.hashContainsKnownProperties(t)?(l.logger.verbose("PopupHandler.monitorPopupForHash - hash contains known properties, returning."),r(t)):(l.logger.error("PopupHandler.monitorPopupForHash - found hash in url but it does not contain known properties. Check that your router is not changing the hash prematurely."),l.logger.errorPii("PopupHandler.monitorPopupForHash - hash found: "+t),i(k.createHashDoesNotContainKnownPropertiesError()))):n<o&&(l.logger.error("PopupHandler.monitorPopupForHash - unable to find hash in url, timing out"),clearInterval(a),i(k.createMonitorPopupTimeoutError())))}},l.config.system.pollIntervalMilliseconds))})},nw.prototype.waitForLogoutPopup=function(i){var n=this;return new Promise(function(t){n.logger.verbose("PopupHandler.waitForLogoutPopup - polling started");var r=setInterval(function(){i.closed&&(n.logger.error("PopupHandler.waitForLogoutPopup - window closed"),n.cleanPopup(),clearInterval(r),t());var e=T.EMPTY_STRING;try{e=i.location.href}catch(e){}I.isEmpty(e)||"about:blank"===e||(n.logger.verbose("PopupHandler.waitForLogoutPopup - popup window is on same origin as caller, closing."),clearInterval(r),n.cleanPopup(i),t())},n.config.system.pollIntervalMilliseconds)})},nw.prototype.openPopup=function(e,t){try{var r=void 0;if(t.popup?(r=t.popup,this.logger.verbosePii("Navigating popup window to: "+e),r.location.assign(e)):void 0===t.popup&&(this.logger.verbosePii("Opening popup window to: "+e),r=this.openSizedPopup(e,t.popupName,t.popupWindowAttributes)),r)return r.focus&&r.focus(),this.currentWindow=r,window.addEventListener("beforeunload",this.unloadWindow),r;throw k.createEmptyWindowCreatedError()}catch(e){throw this.logger.error("error opening popup "+e.message),this.browserStorage.setInteractionInProgress(!1),k.createPopupWindowError(e.toString())}},nw.prototype.openSizedPopup=function(e,t,r){var i=window.screenLeft||window.screenX,n=window.screenTop||window.screenY,o=window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth,a=window.innerHeight||document.documentElement.clientHeight||document.body.clientHeight,s=null==(s=r.popupSize)?void 0:s.width,l=null==(l=r.popupSize)?void 0:l.height,c=null==(c=r.popupPosition)?void 0:c.top,r=null==(r=r.popupPosition)?void 0:r.left;return(!s||s<0||o<s)&&(this.logger.verbose("Default popup window width used. Window width not configured or invalid."),s=X0.POPUP_WIDTH),(!l||l<0||a<l)&&(this.logger.verbose("Default popup window height used. Window height not configured or invalid."),l=X0.POPUP_HEIGHT),(!c||c<0||a<c)&&(this.logger.verbose("Default popup window top position used. Window top not configured or invalid."),c=Math.max(0,a/2-X0.POPUP_HEIGHT/2+n)),(!r||r<0||o<r)&&(this.logger.verbose("Default popup window left position used. Window left not configured or invalid."),r=Math.max(0,o/2-X0.POPUP_WIDTH/2+i)),window.open(e,t,"width="+s+", height="+l+", top="+c+", left="+r+", scrollbars=yes")},nw.prototype.unloadWindow=function(e){this.browserStorage.cleanRequestByInteractionType(P.Popup),this.currentWindow&&this.currentWindow.close(),e.preventDefault()},nw.prototype.cleanPopup=function(e){e&&e.close(),window.removeEventListener("beforeunload",this.unloadWindow),this.browserStorage.setInteractionInProgress(!1)},nw.prototype.generatePopupName=function(e,t){return X0.POPUP_NAME_PREFIX+"."+this.config.auth.clientId+"."+e.join("-")+"."+t+"."+this.correlationId},nw.prototype.generateLogoutPopupName=function(e){e=e.account&&e.account.homeAccountId;return X0.POPUP_NAME_PREFIX+"."+this.config.auth.clientId+"."+e+"."+this.correlationId};var rw,iw=nw;function nw(e,t,r,i,n,o,a,s,l,c){e=rw.call(this,e,t,r,i,n,o,a,l,c)||this;return e.unloadWindow=e.unloadWindow.bind(e),e.nativeStorage=s,e}aw.prototype.navigateInternal=function(e,t){return aw.defaultNavigateWindow(e,t)},aw.prototype.navigateExternal=function(e,t){return aw.defaultNavigateWindow(e,t)},aw.defaultNavigateWindow=function(e,t){return t.noHistory?window.location.replace(e):window.location.assign(e),new Promise(function(e){setTimeout(function(){e(!0)},t.timeout)})};var ow=aw;function aw(){}var sw=6e4,lw=6e3,cw=3e4,uw=2e3;zm(pw,hw=Ob),pw.prototype.initiateAuthRequest=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){switch(e.label){case 0:if(this.performanceClient.addQueueMeasurement(A.SilentHandlerInitiateAuthRequest,this.authCodeRequest.correlationId),I.isEmpty(t))throw this.logger.info("Navigate url is empty"),k.createEmptyNavigationUriError();return this.navigateFrameWait?(this.performanceClient.setPreQueueTime(A.SilentHandlerLoadFrame,this.authCodeRequest.correlationId),[4,this.loadFrame(t)]):[3,2];case 1:return[2,e.sent()];case 2:return[2,this.loadFrameSync(t)]}})})},pw.prototype.monitorIframeForHash=function(a,e){var s=this;return this.performanceClient.addQueueMeasurement(A.SilentHandlerMonitorIframeForHash,this.authCodeRequest.correlationId),new Promise(function(r,i){e<lw&&s.logger.warning("system.loadFrameTimeout or system.iframeHashTimeout set to lower ("+e+"ms) than the default ("+lw+"ms). This may result in timeouts.");var n=window.performance.now()+e,o=setInterval(function(){if(window.performance.now()>n)s.removeHiddenIframe(a),clearInterval(o),i(k.createMonitorIframeTimeoutError());else{var e=T.EMPTY_STRING,t=a.contentWindow;try{e=t?t.location.href:T.EMPTY_STRING}catch(e){}I.isEmpty(e)||(e=t?t.location.hash:T.EMPTY_STRING,e_.hashContainsKnownProperties(e)&&(s.removeHiddenIframe(a),clearInterval(o),r(e)))}},s.pollIntervalMilliseconds)})},pw.prototype.loadFrame=function(i){var n=this;return this.performanceClient.addQueueMeasurement(A.SilentHandlerLoadFrame,this.authCodeRequest.correlationId),new Promise(function(e,t){var r=n.createHiddenIframe();setTimeout(function(){r?(r.src=i,e(r)):t("Unable to load iframe")},n.navigateFrameWait)})},pw.prototype.loadFrameSync=function(e){var t=this.createHiddenIframe();return t.src=e,t},pw.prototype.createHiddenIframe=function(){var e=document.createElement("iframe");return e.style.visibility="hidden",e.style.position="absolute",e.style.width=e.style.height="0",e.style.border="0",e.setAttribute("sandbox","allow-scripts allow-same-origin allow-forms"),document.getElementsByTagName("body")[0].appendChild(e),e},pw.prototype.removeHiddenIframe=function(e){document.body===e.parentNode&&document.body.removeChild(e)};var hw,dw=pw;function pw(e,t,r,i,n,o){e=hw.call(this,e,t,r,i,o)||this;return e.navigateFrameWait=n.navigateFrameWait,e.pollIntervalMilliseconds=n.pollIntervalMilliseconds,e}zm(gw,fw=s),gw.prototype.acquireToken=function(o){return _(this,void 0,void 0,function(){var t,r,i,n;return b(this,function(e){switch(e.label){case 0:if(this.performanceClient.addQueueMeasurement(A.SilentIframeClientAcquireToken,o.correlationId),this.logger.verbose("acquireTokenByIframe called"),t=this.performanceClient.startMeasurement(A.SilentIframeClientAcquireToken,o.correlationId),I.isEmpty(o.loginHint)&&I.isEmpty(o.sid)&&(!o.account||I.isEmpty(o.account.username))&&this.logger.warning("No user hint provided. The authorization server may need more information to complete this request."),o.prompt&&o.prompt!==ig.NONE&&o.prompt!==ig.NO_SESSION)throw t.endMeasurement({success:!1}),k.createSilentPromptValueError(o.prompt);return this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,o.correlationId),[4,this.initializeAuthorizationRequest(v(v({},o),{prompt:o.prompt||ig.NONE}),P.Silent)];case 1:r=e.sent(),this.browserStorage.updateCacheEntries(r.state,r.nonce,r.authority,r.loginHint||T.EMPTY_STRING,r.account||null),i=this.initializeServerTelemetryManager(this.apiId),e.label=2;case 2:return e.trys.push([2,5,,6]),this.performanceClient.setPreQueueTime(A.StandardInteractionClientCreateAuthCodeClient,o.correlationId),[4,this.createAuthCodeClient(i,r.authority,r.azureCloudOptions)];case 3:return n=e.sent(),this.logger.verbose("Auth code client created"),this.performanceClient.setPreQueueTime(A.SilentIframeClientTokenHelper,o.correlationId),[4,this.silentTokenHelper(n,r).then(function(e){return t.endMeasurement({success:!0,fromCache:!1,requestId:e.requestId}),e})];case 4:return[2,e.sent()];case 5:throw(n=e.sent())instanceof S&&n.setCorrelationId(this.correlationId),i.cacheFailedRequest(n),this.browserStorage.cleanRequestByState(r.state),t.endMeasurement({errorCode:n instanceof S&&n.errorCode||void 0,subErrorCode:n instanceof S&&n.subError||void 0,success:!1}),n;case 6:return[2]}})})},gw.prototype.logout=function(){return Promise.reject(k.createSilentLogoutUnsupportedError())},gw.prototype.silentTokenHelper=function(c,u){return _(this,void 0,void 0,function(){var t,r,i,n,o,a,s,l=this;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.SilentIframeClientTokenHelper,u.correlationId),this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationCodeRequest,u.correlationId),[4,this.initializeAuthorizationCodeRequest(u)];case 1:return t=e.sent(),this.performanceClient.setPreQueueTime(A.GetAuthCodeUrl,u.correlationId),[4,c.getAuthCodeUrl(v(v({},u),{nativeBroker:Xb.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,u.authenticationScheme)}))];case 2:return i=e.sent(),r=new dw(c,this.browserStorage,t,this.logger,this.config.system,this.performanceClient),this.performanceClient.setPreQueueTime(A.SilentHandlerInitiateAuthRequest,u.correlationId),[4,r.initiateAuthRequest(i)];case 3:return i=e.sent(),this.performanceClient.setPreQueueTime(A.SilentHandlerMonitorIframeForHash,u.correlationId),[4,r.monitorIframeForHash(i,this.config.system.iframeHashTimeout)];case 4:if(n=e.sent(),a=e_.getDeserializedHash(n),o=this.validateAndExtractStateFromHash(a,P.Silent,t.correlationId),a.accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),this.nativeMessageHandler)return a=new Yb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.apiId,this.performanceClient,this.nativeMessageHandler,a.accountId,this.browserStorage,this.correlationId),s=Xv.parseRequestState(this.browserCrypto,o).userRequestState,[2,a.acquireToken(v(v({},u),{state:s,prompt:u.prompt||ig.NONE})).finally(function(){l.browserStorage.cleanRequestByState(o)})];throw k.createNativeConnectionNotEstablishedError()}return this.performanceClient.setPreQueueTime(A.HandleCodeResponseFromHash,u.correlationId),[2,r.handleCodeResponseFromHash(n,o,c.authority,this.networkClient)]}})})};var fw,mw=gw;function gw(e,t,r,i,n,o,a,s,l,c,u){e=fw.call(this,e,t,r,i,n,o,s,c,u)||this;return e.apiId=a,e.nativeStorage=l,e}zm(_w,yw=s),_w.prototype.acquireToken=function(s){return _(this,void 0,void 0,function(){var t,r,i,n,o,a=this;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.addQueueMeasurement(A.SilentRefreshClientAcquireToken,s.correlationId),this.performanceClient.setPreQueueTime(A.InitializeBaseRequest,s.correlationId),r=[v({},s)],[4,this.initializeBaseRequest(s,s.account)];case 1:return t=v.apply(void 0,r.concat([e.sent()])),i=this.performanceClient.startMeasurement(A.SilentRefreshClientAcquireToken,t.correlationId),n=this.initializeServerTelemetryManager(Y0.acquireTokenSilent_silentFlow),[4,this.createRefreshTokenClient(n,t.authority,t.azureCloudOptions)];case 2:return o=e.sent(),this.logger.verbose("Refresh token client created"),this.performanceClient.setPreQueueTime(A.RefreshTokenClientAcquireTokenByRefreshToken,s.correlationId),[2,o.acquireTokenByRefreshToken(t).then(function(e){return i.endMeasurement({success:!0,fromCache:e.fromCache,requestId:e.requestId}),e}).catch(function(e){throw e instanceof S&&e.setCorrelationId(a.correlationId),n.cacheFailedRequest(e),i.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e})]}})})},_w.prototype.logout=function(){return Promise.reject(k.createSilentLogoutUnsupportedError())},_w.prototype.createRefreshTokenClient=function(r,i,n){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(r,i,n)];case 1:return t=e.sent(),[2,new g_(t,this.performanceClient)]}})})};var yw,vw=_w;function _w(){return null!==yw&&yw.apply(this,arguments)||this}ww.prototype.addEventCallback=function(e){var t;return"undefined"!=typeof window?(t=this.browserCrypto.createNewGuid(),this.eventCallbacks.set(t,e),this.logger.verbose("Event callback registered with id: "+t),t):null},ww.prototype.removeEventCallback=function(e){this.eventCallbacks.delete(e),this.logger.verbose("Event callback "+e+" removed.")},ww.prototype.enableAccountStorageEvents=function(){"undefined"!=typeof window&&(this.listeningToStorageEvents?this.logger.verbose("Account storage listener already registered."):(this.logger.verbose("Adding account storage listener."),this.listeningToStorageEvents=!0,window.addEventListener("storage",this.handleAccountCacheChange)))},ww.prototype.disableAccountStorageEvents=function(){"undefined"!=typeof window&&(this.listeningToStorageEvents?(this.logger.verbose("Removing account storage listener."),window.removeEventListener("storage",this.handleAccountCacheChange),this.listeningToStorageEvents=!1):this.logger.verbose("No account storage listener registered."))},ww.prototype.emitEvent=function(r,e,t,i){var n,o=this;"undefined"!=typeof window&&(n={eventType:r,interactionType:e||null,payload:t||null,error:i||null,timestamp:Date.now()},this.logger.info("Emitting event: "+r),this.eventCallbacks.forEach(function(e,t){o.logger.verbose("Emitting event to callback "+t+": "+r),e.apply(null,[n])}))},ww.prototype.handleAccountCacheChange=function(e){try{var t,r,i=e.newValue||e.oldValue;i&&"object"==typeof(t=JSON.parse(i))&&rv.isAccountEntity(t)&&(r=av.toObject(new rv,t).getAccountInfo(),!e.oldValue&&e.newValue?(this.logger.info("Account was added to cache in a different window"),this.emitEvent(R.ACCOUNT_ADDED,void 0,r)):!e.newValue&&e.oldValue&&(this.logger.info("Account was removed from cache in a different window"),this.emitEvent(R.ACCOUNT_REMOVED,void 0,r)))}catch(e){}};var bw=ww;function ww(e,t){this.eventCallbacks=new Map,this.logger=e,this.browserCrypto=t,this.listeningToStorageEvents=!1,this.handleAccountCacheChange=this.handleAccountCacheChange.bind(this)}Cw.decimalToHex=function(e){for(var t=e.toString(16);t.length<2;)t="0"+t;return t};var xw=Cw;function Cw(){}Sw.prototype.generateGuid=function(){try{var e=new Uint8Array(16);return this.cryptoObj.getRandomValues(e),e[6]|=64,e[6]&=79,e[8]|=128,e[8]&=191,xw.decimalToHex(e[0])+xw.decimalToHex(e[1])+xw.decimalToHex(e[2])+xw.decimalToHex(e[3])+"-"+xw.decimalToHex(e[4])+xw.decimalToHex(e[5])+"-"+xw.decimalToHex(e[6])+xw.decimalToHex(e[7])+"-"+xw.decimalToHex(e[8])+xw.decimalToHex(e[9])+"-"+xw.decimalToHex(e[10])+xw.decimalToHex(e[11])+xw.decimalToHex(e[12])+xw.decimalToHex(e[13])+xw.decimalToHex(e[14])+xw.decimalToHex(e[15])}catch(e){for(var t="xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx",r="0123456789abcdef",i=0,n=T.EMPTY_STRING,o=0;o<36;o++)"-"!==t[o]&&"4"!==t[o]&&(i=16*Math.random()|0),n+="x"===t[o]?r[i]:"y"===t[o]?r[i=i&3|8]:t[o];return n}},Sw.prototype.isGuid=function(e){return/^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(e)};var Tw=Sw;function Sw(e){this.cryptoObj=e}Iw.stringToUtf8Arr=function(e){for(var t,r=0,i=e.length,n=0;n<i;n++)r+=(t=e.charCodeAt(n))<128?1:t<2048?2:t<65536?3:t<2097152?4:t<67108864?5:6;for(var o=new Uint8Array(r),a=0,s=0;a<r;s++)(t=e.charCodeAt(s))<128?o[a++]=t:(t<2048?o[a++]=192+(t>>>6):(t<65536?o[a++]=224+(t>>>12):(t<2097152?o[a++]=240+(t>>>18):(t<67108864?o[a++]=248+(t>>>24):(o[a++]=252+(t>>>30),o[a++]=128+(t>>>24&63)),o[a++]=128+(t>>>18&63)),o[a++]=128+(t>>>12&63)),o[a++]=128+(t>>>6&63)),o[a++]=128+(63&t));return o},Iw.stringToArrayBuffer=function(e){for(var t=new ArrayBuffer(e.length),r=new Uint8Array(t),i=0;i<e.length;i++)r[i]=e.charCodeAt(i);return t},Iw.utf8ArrToString=function(e){for(var t,r=T.EMPTY_STRING,i=e.length,n=0;n<i;n++)t=e[n],r+=String.fromCharCode(251<t&&t<254&&n+5<i?1073741824*(t-252)+(e[++n]-128<<24)+(e[++n]-128<<18)+(e[++n]-128<<12)+(e[++n]-128<<6)+e[++n]-128:247<t&&t<252&&n+4<i?(t-248<<24)+(e[++n]-128<<18)+(e[++n]-128<<12)+(e[++n]-128<<6)+e[++n]-128:239<t&&t<248&&n+3<i?(t-240<<18)+(e[++n]-128<<12)+(e[++n]-128<<6)+e[++n]-128:223<t&&t<240&&n+2<i?(t-224<<12)+(e[++n]-128<<6)+e[++n]-128:191<t&&t<224&&n+1<i?(t-192<<6)+e[++n]-128:t);return r},Iw.getSortedObjectString=function(e){return JSON.stringify(e,Object.keys(e).sort())};var Ew=Iw;function Iw(){}kw.prototype.urlEncode=function(e){return encodeURIComponent(this.encode(e).replace(/=/g,T.EMPTY_STRING).replace(/\+/g,"-").replace(/\//g,"_"))},kw.prototype.urlEncodeArr=function(e){return this.base64EncArr(e).replace(/=/g,T.EMPTY_STRING).replace(/\+/g,"-").replace(/\//g,"_")},kw.prototype.encode=function(e){e=Ew.stringToUtf8Arr(e);return this.base64EncArr(e)},kw.prototype.base64EncArr=function(e){for(var t,r=(3-e.length%3)%3,i=T.EMPTY_STRING,n=e.length,o=0,a=0;a<n;a++)o|=e[a]<<(16>>>(t=a%3)&24),2!=t&&e.length-a!=1||(i+=String.fromCharCode(this.uint6ToB64(o>>>18&63),this.uint6ToB64(o>>>12&63),this.uint6ToB64(o>>>6&63),this.uint6ToB64(63&o)),o=0);return 0==r?i:i.substring(0,i.length-r)+(1==r?"=":"==")},kw.prototype.uint6ToB64=function(e){return e<26?e+65:e<52?e+71:e<62?e-4:62===e?43:63===e?47:65};var Aw=kw;function kw(){}Mw.prototype.decode=function(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw new Error("Invalid base64 string")}e=this.base64DecToArr(t);return Ew.utf8ArrToString(e)},Mw.prototype.base64DecToArr=function(e,t){for(var r,i=e.replace(/[^A-Za-z0-9\+\/]/g,T.EMPTY_STRING),n=i.length,o=t?Math.ceil((3*n+1>>>2)/t)*t:3*n+1>>>2,a=new Uint8Array(o),s=void 0,l=0,c=0,u=0;u<n;u++)if(r=3&u,l|=this.b64ToUint6(i.charCodeAt(u))<<18-6*r,3==r||n-u==1){for(s=0;s<3&&c<o;s++,c++)a[c]=l>>>(16>>>s&24)&255;l=0}return a},Mw.prototype.b64ToUint6=function(e){return 64<e&&e<91?e-65:96<e&&e<123?e-71:47<e&&e<58?e+4:43===e?62:47===e?63:0};var Pw=Mw;function Mw(){}Ow.prototype.generateCodes=function(){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:return t=this.generateCodeVerifier(),[4,this.generateCodeChallengeFromVerifier(t)];case 1:return r=e.sent(),[2,{verifier:t,challenge:r}]}})})},Ow.prototype.generateCodeVerifier=function(){try{var e=new Uint8Array(32);return this.cryptoObj.getRandomValues(e),this.base64Encode.urlEncodeArr(e)}catch(e){throw k.createPkceNotGeneratedError(e)}},Ow.prototype.generateCodeChallengeFromVerifier=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),[4,this.cryptoObj.sha256Digest(r)];case 1:return t=e.sent(),[2,this.base64Encode.urlEncodeArr(new Uint8Array(t))];case 2:throw t=e.sent(),k.createPkceNotGeneratedError(t);case 3:return[2]}})})};var Rw=Ow;function Ow(e){this.base64Encode=new Aw,this.cryptoObj=e}Dw.prototype.getRandomValues=function(e){return window.crypto.getRandomValues(e)},Dw.prototype.generateKey=function(t,r,i){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.crypto.subtle.generateKey(t,r,i)]})})},Dw.prototype.exportKey=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.crypto.subtle.exportKey(rb,t)]})})},Dw.prototype.importKey=function(t,r,i,n){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.crypto.subtle.importKey(rb,t,r,i,n)]})})},Dw.prototype.sign=function(t,r,i){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.crypto.subtle.sign(t,r,i)]})})},Dw.prototype.digest=function(t,r){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.crypto.subtle.digest(t,r)]})})};var Lw=Dw;function Dw(){}Nw.prototype.initPrng=function(e){return window.msrCrypto.initPrng(Bm(e))},Nw.prototype.getRandomValues=function(e){return window.msrCrypto.getRandomValues(e)},Nw.prototype.generateKey=function(t,r,i){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.msrCrypto.subtle.generateKey(t,r,i)]})})},Nw.prototype.exportKey=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.msrCrypto.subtle.exportKey(rb,t)]})})},Nw.prototype.importKey=function(t,r,i,n){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.msrCrypto.subtle.importKey(rb,t,r,i,n)]})})},Nw.prototype.sign=function(t,r,i){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.msrCrypto.subtle.sign(t,r,i)]})})},Nw.prototype.digest=function(t,r){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,window.msrCrypto.subtle.digest(t,r)]})})};var zw=Nw;function Nw(){}Fw.prototype.getRandomValues=function(e){return window.msCrypto.getRandomValues(e)},Fw.prototype.generateKey=function(i,n,o){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,new Promise(function(t,r){var e=window.msCrypto.subtle.generateKey(i,n,o);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){r(e)})})]})})},Fw.prototype.exportKey=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,new Promise(function(r,i){var e=window.msCrypto.subtle.exportKey(rb,t);e.addEventListener("complete",function(e){var t=e.target.result,t=Ew.utf8ArrToString(new Uint8Array(t)).replace(/\r/g,T.EMPTY_STRING).replace(/\n/g,T.EMPTY_STRING).replace(/\t/g,T.EMPTY_STRING).split(" ").join(T.EMPTY_STRING).replace("\0",T.EMPTY_STRING);try{r(JSON.parse(t))}catch(e){i(e)}}),e.addEventListener("error",function(e){i(e)})})]})})},Fw.prototype.importKey=function(r,n,o,a){return _(this,void 0,void 0,function(){var t,i;return b(this,function(e){return t=Ew.getSortedObjectString(r),i=Ew.stringToArrayBuffer(t),[2,new Promise(function(t,r){var e=window.msCrypto.subtle.importKey(rb,i,n,o,a);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){r(e)})})]})})},Fw.prototype.sign=function(i,n,o){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,new Promise(function(t,r){var e=window.msCrypto.subtle.sign(i,n,o);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){r(e)})})]})})},Fw.prototype.digest=function(i,n){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,new Promise(function(t,r){var e=window.msCrypto.subtle.digest(i,n.buffer);e.addEventListener("complete",function(e){t(e.target.result)}),e.addEventListener("error",function(e){r(e)})})]})})};var Bw=Fw;function Fw(){}var Uw="SHA-256",qw=new Uint8Array([1,0,1]),jw=(Hw.prototype.hasIECrypto=function(){return"msCrypto"in window},Hw.prototype.hasBrowserCrypto=function(){return"crypto"in window},Hw.prototype.hasMsrCrypto=function(){return"msrCrypto"in window},Hw.prototype.sha256Digest=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){return t=Ew.stringToUtf8Arr(r),[2,this.subtleCrypto.digest({name:Uw},t)]})})},Hw.prototype.getRandomValues=function(e){return this.subtleCrypto.getRandomValues(e)},Hw.prototype.generateKeyPair=function(t,r){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,this.subtleCrypto.generateKey(this.keygenAlgorithmOptions,t,r)]})})},Hw.prototype.exportJwk=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,this.subtleCrypto.exportKey(t)]})})},Hw.prototype.importJwk=function(t,r,i){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,this.subtleCrypto.importKey(t,this.keygenAlgorithmOptions,r,i)]})})},Hw.prototype.sign=function(t,r){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,this.subtleCrypto.sign(this.keygenAlgorithmOptions,t,r)]})})},Hw);function Hw(e,t){if(this.logger=e,this.cryptoOptions=t,this.hasBrowserCrypto())this.logger.verbose("BrowserCrypto: modern crypto interface available"),this.subtleCrypto=new Lw;else if(this.hasIECrypto())this.logger.verbose("BrowserCrypto: MS crypto interface available"),this.subtleCrypto=new Bw;else{if(!this.hasMsrCrypto()||null==(e=this.cryptoOptions)||!e.useMsrCrypto)throw this.hasMsrCrypto()&&this.logger.info("BrowserCrypto: MSR Crypto interface available but system.cryptoOptions.useMsrCrypto not enabled"),this.logger.error("BrowserCrypto: No crypto interfaces available."),k.createCryptoNotAvailableError("Browser crypto, msCrypto, or msrCrypto interfaces not available.");this.logger.verbose("BrowserCrypto: MSR crypto interface available"),this.subtleCrypto=new zw}if(this.subtleCrypto.initPrng){if(this.logger.verbose("BrowserCrypto: Interface requires entropy"),null==(t=this.cryptoOptions)||!t.entropy)throw this.logger.error("BrowserCrypto: Interface requires entropy but none provided."),db.createEntropyNotProvided();this.logger.verbose("BrowserCrypto: Entropy provided"),this.subtleCrypto.initPrng(this.cryptoOptions.entropy)}this.keygenAlgorithmOptions={name:"RSASSA-PKCS1-v1_5",hash:Uw,modulusLength:2048,publicExponent:qw}}Gw.prototype.open=function(){return _(this,void 0,void 0,function(){var i=this;return b(this,function(e){return[2,new Promise(function(t,e){var r=window.indexedDB.open(i.dbName,i.version);r.addEventListener("upgradeneeded",function(e){e.target.result.createObjectStore(i.tableName)}),r.addEventListener("success",function(e){i.db=e.target.result,i.dbOpen=!0,t()}),r.addEventListener("error",function(){return e(k.createDatabaseUnavailableError())})})]})})},Gw.prototype.closeConnection=function(){var e=this.db;e&&this.dbOpen&&(e.close(),this.dbOpen=!1)},Gw.prototype.validateDbIsOpen=function(){return _(this,void 0,void 0,function(){return b(this,function(e){switch(e.label){case 0:return this.dbOpen?[3,2]:[4,this.open()];case 1:return[2,e.sent()];case 2:return[2]}})})},Gw.prototype.getItem=function(n){return _(this,void 0,void 0,function(){var i=this;return b(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(t,r){if(!i.db)return r(k.createDatabaseNotOpenError());var e=i.db.transaction([i.tableName],"readonly").objectStore(i.tableName).get(n);e.addEventListener("success",function(e){i.closeConnection(),t(e.target.result)}),e.addEventListener("error",function(e){i.closeConnection(),r(e)})})]}})})},Gw.prototype.setItem=function(n,o){return _(this,void 0,void 0,function(){var i=this;return b(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(e,t){if(!i.db)return t(k.createDatabaseNotOpenError());var r=i.db.transaction([i.tableName],"readwrite").objectStore(i.tableName).put(o,n);r.addEventListener("success",function(){i.closeConnection(),e()}),r.addEventListener("error",function(e){i.closeConnection(),t(e)})})]}})})},Gw.prototype.removeItem=function(n){return _(this,void 0,void 0,function(){var i=this;return b(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(e,t){if(!i.db)return t(k.createDatabaseNotOpenError());var r=i.db.transaction([i.tableName],"readwrite").objectStore(i.tableName).delete(n);r.addEventListener("success",function(){i.closeConnection(),e()}),r.addEventListener("error",function(e){i.closeConnection(),t(e)})})]}})})},Gw.prototype.getKeys=function(){return _(this,void 0,void 0,function(){var i=this;return b(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(t,r){if(!i.db)return r(k.createDatabaseNotOpenError());var e=i.db.transaction([i.tableName],"readonly").objectStore(i.tableName).getAllKeys();e.addEventListener("success",function(e){i.closeConnection(),t(e.target.result)}),e.addEventListener("error",function(e){i.closeConnection(),r(e)})})]}})})},Gw.prototype.containsKey=function(n){return _(this,void 0,void 0,function(){var i=this;return b(this,function(e){switch(e.label){case 0:return[4,this.validateDbIsOpen()];case 1:return e.sent(),[2,new Promise(function(t,r){if(!i.db)return r(k.createDatabaseNotOpenError());var e=i.db.transaction([i.tableName],"readonly").objectStore(i.tableName).count(n);e.addEventListener("success",function(e){i.closeConnection(),t(1===e.target.result)}),e.addEventListener("error",function(e){i.closeConnection(),r(e)})})]}})})},Gw.prototype.deleteDatabase=function(){return _(this,void 0,void 0,function(){return b(this,function(e){return this.db&&this.dbOpen&&this.closeConnection(),[2,new Promise(function(e,t){var r=window.indexedDB.deleteDatabase(ib);r.addEventListener("success",function(){return e(!0)}),r.addEventListener("blocked",function(){return e(!0)}),r.addEventListener("error",function(){return t(!1)})})]})})};var Vw=Gw;function Gw(){this.dbName=ib,this.version=1,this.tableName="msal.db.keys",this.dbOpen=!1}Ww.prototype.handleDatabaseAccessError=function(e){if(!(e instanceof k&&e.errorCode===z0.code))throw e;this.logger.error("Could not access persistent storage. This may be caused by browser privacy features which block persistent storage in third-party contexts.")},Ww.prototype.getItem=function(i){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:if(t=this.inMemoryCache.getItem(i))return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("Queried item not found in in-memory cache, now querying persistent storage."),[4,this.indexedDBCache.getItem(i)];case 2:return[2,e.sent()];case 3:return r=e.sent(),this.handleDatabaseAccessError(r),[3,4];case 4:return[2,t]}})})},Ww.prototype.setItem=function(r,i){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:this.inMemoryCache.setItem(r,i),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.indexedDBCache.setItem(r,i)];case 2:return e.sent(),[3,4];case 3:return t=e.sent(),this.handleDatabaseAccessError(t),[3,4];case 4:return[2]}})})},Ww.prototype.removeItem=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:this.inMemoryCache.removeItem(r),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.indexedDBCache.removeItem(r)];case 2:return e.sent(),[3,4];case 3:return t=e.sent(),this.handleDatabaseAccessError(t),[3,4];case 4:return[2]}})})},Ww.prototype.getKeys=function(){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:if(0!==(t=this.inMemoryCache.getKeys()).length)return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("In-memory cache is empty, now querying persistent storage."),[4,this.indexedDBCache.getKeys()];case 2:return[2,e.sent()];case 3:return r=e.sent(),this.handleDatabaseAccessError(r),[3,4];case 4:return[2,t]}})})},Ww.prototype.containsKey=function(i){return _(this,void 0,void 0,function(){var t,r;return b(this,function(e){switch(e.label){case 0:if(t=this.inMemoryCache.containsKey(i))return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),this.logger.verbose("Key not found in in-memory cache, now querying persistent storage."),[4,this.indexedDBCache.containsKey(i)];case 2:return[2,e.sent()];case 3:return r=e.sent(),this.handleDatabaseAccessError(r),[3,4];case 4:return[2,t]}})})},Ww.prototype.clearInMemory=function(){this.logger.verbose("Deleting in-memory keystore "+this.storeName),this.inMemoryCache.clear(),this.logger.verbose("In-memory keystore "+this.storeName+" deleted")},Ww.prototype.clearPersistent=function(){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return e.trys.push([0,2,,3]),this.logger.verbose("Deleting persistent keystore"),[4,this.indexedDBCache.deleteDatabase()];case 1:return(t=e.sent())&&this.logger.verbose("Persistent keystore deleted"),[2,t];case 2:return t=e.sent(),this.handleDatabaseAccessError(t),[2,!1];case 3:return[2]}})})};var Kw,Zw=Ww;function Ww(e,t){this.inMemoryCache=new gb,this.indexedDBCache=new Vw,this.logger=e,this.storeName=t}(ai=Kw=Kw||{}).asymmetricKeys="asymmetricKeys",ai.symmetricKeys="symmetricKeys";$w.prototype.clear=function(){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:this.asymmetricKeys.clearInMemory(),this.symmetricKeys.clearInMemory(),e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.asymmetricKeys.clearPersistent()];case 2:return e.sent(),[2,!0];case 3:return(t=e.sent())instanceof Error?this.logger.error("Clearing keystore failed with error: "+t.message):this.logger.error("Clearing keystore failed with unknown error"),[2,!1];case 4:return[2]}})})};var Yw=$w;function $w(e){this.logger=e,this.asymmetricKeys=new Zw(this.logger,Kw.asymmetricKeys),this.symmetricKeys=new Zw(this.logger,Kw.symmetricKeys)}Jw.prototype.createNewGuid=function(){return this.guidGenerator.generateGuid()},Jw.prototype.base64Encode=function(e){return this.b64Encode.encode(e)},Jw.prototype.base64Decode=function(e){return this.b64Decode.decode(e)},Jw.prototype.generatePkceCodes=function(){return _(this,void 0,void 0,function(){return b(this,function(e){return[2,this.pkceGenerator.generateCodes()]})})},Jw.prototype.getPublicKeyThumbprint=function(a){var s;return _(this,void 0,void 0,function(){var t,r,i,n,o;return b(this,function(e){switch(e.label){case 0:return t=null==(s=this.performanceClient)?void 0:s.startMeasurement(A.CryptoOptsGetPublicKeyThumbprint,a.correlationId),[4,this.browserCrypto.generateKeyPair(Jw.EXTRACTABLE,Jw.POP_KEY_USAGES)];case 1:return r=e.sent(),[4,this.browserCrypto.exportJwk(r.publicKey)];case 2:return n=e.sent(),n={e:n.e,kty:n.kty,n:n.n},n=Ew.getSortedObjectString(n),[4,this.hashString(n)];case 3:return i=e.sent(),[4,this.browserCrypto.exportJwk(r.privateKey)];case 4:return n=e.sent(),[4,this.browserCrypto.importJwk(n,!1,["sign"])];case 5:return o=e.sent(),[4,this.cache.asymmetricKeys.setItem(i,{privateKey:o,publicKey:r.publicKey,requestMethod:a.resourceRequestMethod,requestUri:a.resourceRequestUri})];case 6:return e.sent(),t&&t.endMeasurement({success:!0}),[2,i]}})})},Jw.prototype.removeTokenBindingKey=function(t){return _(this,void 0,void 0,function(){return b(this,function(e){switch(e.label){case 0:return[4,this.cache.asymmetricKeys.removeItem(t)];case 1:return e.sent(),[4,this.cache.asymmetricKeys.containsKey(t)];case 2:return[2,!e.sent()]}})})},Jw.prototype.clearKeystore=function(){return _(this,void 0,void 0,function(){return b(this,function(e){switch(e.label){case 0:return[4,this.cache.clear()];case 1:return[2,e.sent()]}})})},Jw.prototype.signJwt=function(s,l,c){var u;return _(this,void 0,void 0,function(){var t,r,i,n,o,a;return b(this,function(e){switch(e.label){case 0:return t=null==(u=this.performanceClient)?void 0:u.startMeasurement(A.CryptoOptsSignJwt,c),[4,this.cache.asymmetricKeys.getItem(l)];case 1:if(r=e.sent())return[4,this.browserCrypto.exportJwk(r.publicKey)];throw k.createSigningKeyNotFoundInStorageError(l);case 2:return o=e.sent(),i=Ew.getSortedObjectString(o),n=this.b64Encode.urlEncode(JSON.stringify({kid:l})),n=q_.getShrHeaderString({kid:n,alg:o.alg}),o=this.b64Encode.urlEncode(n),s.cnf={jwk:JSON.parse(i)},n=this.b64Encode.urlEncode(JSON.stringify(s)),i=o+"."+n,o=Ew.stringToArrayBuffer(i),[4,this.browserCrypto.sign(r.privateKey,o)];case 3:return n=e.sent(),o=this.b64Encode.urlEncodeArr(new Uint8Array(n)),a=i+"."+o,t&&t.endMeasurement({success:!0}),[2,a]}})})},Jw.prototype.hashString=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(e.label){case 0:return[4,this.browserCrypto.sha256Digest(r)];case 1:return t=e.sent(),t=new Uint8Array(t),[2,this.b64Encode.urlEncodeArr(t)]}})})},Jw.POP_KEY_USAGES=["sign","verify"],Jw.EXTRACTABLE=!0;var Xw=Jw;function Jw(e,t,r){this.logger=e,this.browserCrypto=new jw(this.logger,r),this.b64Encode=new Aw,this.b64Decode=new Pw,this.guidGenerator=new Tw(this.browserCrypto),this.pkceGenerator=new Rw(this.browserCrypto),this.cache=new Yw(this.logger),this.performanceClient=t}ex.makeMeasureName=function(e,t){return"msal.measure."+e+"."+t},ex.makeStartMark=function(e,t){return"msal.start."+e+"."+t},ex.makeEndMark=function(e,t){return"msal.end."+e+"."+t},ex.supportsBrowserPerformance=function(){return"undefined"!=typeof window&&void 0!==window.performance&&"function"==typeof window.performance.mark&&"function"==typeof window.performance.measure&&"function"==typeof window.performance.clearMarks&&"function"==typeof window.performance.clearMeasures&&"function"==typeof window.performance.getEntriesByName},ex.flushMeasurements=function(t,e){if(ex.supportsBrowserPerformance())try{e.forEach(function(e){e=ex.makeMeasureName(e.name,t);0<window.performance.getEntriesByName(e,"measure").length&&(window.performance.clearMeasures(e),window.performance.clearMarks(ex.makeStartMark(e,t)),window.performance.clearMarks(ex.makeEndMark(e,t)))})}catch(e){}},ex.prototype.startMeasurement=function(){if(ex.supportsBrowserPerformance())try{window.performance.mark(this.startMark)}catch(e){}},ex.prototype.endMeasurement=function(){if(ex.supportsBrowserPerformance())try{window.performance.mark(this.endMark),window.performance.measure(this.measureName,this.startMark,this.endMark)}catch(e){}},ex.prototype.flushMeasurement=function(){if(ex.supportsBrowserPerformance())try{var e,t=window.performance.getEntriesByName(this.measureName,"measure");if(0<t.length)return e=t[0].duration,window.performance.clearMeasures(this.measureName),window.performance.clearMarks(this.startMark),window.performance.clearMarks(this.endMark),e}catch(e){}return null};var Qw=ex;function ex(e,t){this.correlationId=t,this.measureName=ex.makeMeasureName(e,t),this.startMark=ex.makeStartMark(e,t),this.endMark=ex.makeEndMark(e,t)}zm(ix,tx=o),ix.prototype.startPerformanceMeasuremeant=function(e,t){return new Qw(e,t)},ix.prototype.generateId=function(){return this.guidGenerator.generateGuid()},ix.prototype.getPageVisibility=function(){var e;return(null==(e=document.visibilityState)?void 0:e.toString())||null},ix.prototype.deleteIncompleteSubMeasurements=function(e){var t=this.eventsByCorrelationId.get(e.event.correlationId),r=t&&t.eventId===e.event.eventId,i=[];r&&null!=t&&t.incompleteSubMeasurements&&t.incompleteSubMeasurements.forEach(function(e){i.push(v({},e))}),0<i.length&&Qw.flushMeasurements(e.event.correlationId,i)},ix.prototype.supportsBrowserPerformanceNow=function(){return"undefined"!=typeof window&&void 0!==window.performance&&"function"==typeof window.performance.now},ix.prototype.startMeasurement=function(e,t){var r=this,i=this.getPageVisibility(),n=tx.prototype.startMeasurement.call(this,e,t);return v(v({},n),{endMeasurement:function(e){e=n.endMeasurement(v({startPageVisibility:i,endPageVisibility:r.getPageVisibility()},e));return r.deleteIncompleteSubMeasurements(n),e},discardMeasurement:function(){n.discardMeasurement(),r.deleteIncompleteSubMeasurements(n),n.measurement.flushMeasurement()}})},ix.prototype.setPreQueueTime=function(e,t){var r;this.supportsBrowserPerformanceNow()?t?((r=this.preQueueTimeByCorrelationId.get(t))&&(this.logger.trace("BrowserPerformanceClient: Incomplete pre-queue "+r.name+" found",t),this.addQueueMeasurement(r.name,t,void 0,!0)),this.preQueueTimeByCorrelationId.set(t,{name:e,time:window.performance.now()})):this.logger.trace("BrowserPerformanceClient: correlationId for "+e+" not provided, unable to set telemetry queue time"):this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to set telemetry queue time for "+e)},ix.prototype.addQueueMeasurement=function(e,t,r,i){if(this.supportsBrowserPerformanceNow())if(t){var n,o=tx.prototype.getPreQueueTime.call(this,e,t);if(o)return n=window.performance.now(),r=r||tx.prototype.calculateQueuedTime.call(this,o,n),tx.prototype.addQueueMeasurement.call(this,e,t,r,i)}else this.logger.trace("BrowserPerformanceClient: correlationId for "+e+" not provided, unable to add queue measurement");else this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to add queue measurement for "+e)};var tx,rx=ix;function ix(e,t,r,i,n,o,a){e=tx.call(this,e,t,r,i,n,o)||this;return e.browserCrypto=new jw(e.logger,a),e.guidGenerator=new Tw(e.browserCrypto),e}ox.prototype.loadExternalTokens=function(e,t,r){if(this.logger.info("TokenCache - loadExternalTokens called"),!t.id_token)throw k.createUnableToLoadTokenError("Please ensure server response includes id token.");var i=new nv(t.id_token,this.cryptoObj);if(e.account)var n=this.loadAccount(i,e.account.environment,void 0,void 0,e.account.homeAccountId),o=new $v(n,this.loadIdToken(i,n.homeAccountId,e.account.environment,e.account.tenantId),this.loadAccessToken(e,t,n.homeAccountId,e.account.environment,e.account.tenantId,r),this.loadRefreshToken(e,t,n.homeAccountId,e.account.environment));else{if(!e.authority)throw k.createUnableToLoadTokenError("Please provide a request with an account or a request with authority.");var a=A_.generateAuthority(e.authority,e.azureCloudOptions),s={protocolMode:this.config.auth.protocolMode,knownAuthorities:this.config.auth.knownAuthorities,cloudDiscoveryMetadata:this.config.auth.cloudDiscoveryMetadata,authorityMetadata:this.config.auth.authorityMetadata,skipAuthorityMetadataCache:this.config.auth.skipAuthorityMetadataCache},a=new A_(a,this.config.system.networkClient,this.storage,s,this.logger);if(r.clientInfo){this.logger.trace("TokenCache - homeAccountId from options");n=this.loadAccount(i,a.hostnameAndPort,r.clientInfo,a.authorityType)}else{if(!t.client_info)throw k.createUnableToLoadTokenError("Please provide clientInfo in the response or options.");this.logger.trace("TokenCache - homeAccountId from response");n=this.loadAccount(i,a.hostnameAndPort,t.client_info,a.authorityType)}o=new $v(n,this.loadIdToken(i,n.homeAccountId,a.hostnameAndPort,a.tenant),this.loadAccessToken(e,t,n.homeAccountId,a.hostnameAndPort,a.tenant,r),this.loadRefreshToken(e,t,n.homeAccountId,a.hostnameAndPort))}return this.generateAuthenticationResult(e,i,o,a)},ox.prototype.loadAccount=function(e,t,r,i,n){var o;if(n?o=n:void 0!==i&&r&&(o=rv.generateHomeAccountId(r,i,this.logger,this.cryptoObj,e)),!o)throw k.createUnableToLoadTokenError("Unexpected missing homeAccountId");n=r?rv.createAccount(r,o,e,void 0,void 0,void 0,t):rv.createGenericAccount(o,e,void 0,void 0,void 0,t);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading account"),this.storage.setAccount(n),n;throw k.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},ox.prototype.loadIdToken=function(e,t,r,i){t=Ov.createIdTokenEntity(t,r,e.rawToken,this.config.auth.clientId,i);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading id token"),this.storage.setIdTokenCredential(t),t;throw k.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},ox.prototype.loadAccessToken=function(e,t,r,i,n,o){if(!t.access_token)return this.logger.verbose("TokenCache - No access token provided for caching"),null;if(!t.expires_in)throw k.createUnableToLoadTokenError("Please ensure server response includes expires_in value.");if(!o.extendedExpiresOn)throw k.createUnableToLoadTokenError("Please provide an extendedExpiresOn value in the options.");var e=new Jy(e.scopes).printScopes(),a=o.expiresOn||t.expires_in+(new Date).getTime()/1e3,o=o.extendedExpiresOn,r=Bv.createAccessTokenEntity(r,i,t.access_token,this.config.auth.clientId,n,e,a,o,this.cryptoObj);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading access token"),this.storage.setAccessTokenCredential(r),r;throw k.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},ox.prototype.loadRefreshToken=function(e,t,r,i){if(!t.refresh_token)return this.logger.verbose("TokenCache - No refresh token provided for caching"),null;r=qv.createRefreshTokenEntity(r,i,t.refresh_token,this.config.auth.clientId);if(this.isBrowserEnvironment)return this.logger.verbose("TokenCache - loading refresh token"),this.storage.setRefreshTokenCredential(r),r;throw k.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.")},ox.prototype.generateAuthenticationResult=function(e,t,r,i){var n,o=T.EMPTY_STRING,a=[],s=null,l=(null!=r&&r.accessToken&&(o=r.accessToken.secret,a=Jy.fromString(r.accessToken.target).asArray(),s=new Date(1e3*Number(r.accessToken.expiresOn)),n=new Date(1e3*Number(r.accessToken.extendedExpiresOn))),(null==t?void 0:t.claims.oid)||(null==t?void 0:t.claims.sub)||T.EMPTY_STRING),c=(null==t?void 0:t.claims.tid)||T.EMPTY_STRING;return{authority:i?i.canonicalAuthority:T.EMPTY_STRING,uniqueId:l,tenantId:c,scopes:a,account:null!=r&&r.account?r.account.getAccountInfo():null,idToken:t?t.rawToken:T.EMPTY_STRING,idTokenClaims:t?t.claims:{},accessToken:o,fromCache:!0,expiresOn:s,correlationId:e.correlationId||T.EMPTY_STRING,requestId:T.EMPTY_STRING,extExpiresOn:n,familyId:T.EMPTY_STRING,tokenType:(null==(i=null==r?void 0:r.accessToken)?void 0:i.tokenType)||T.EMPTY_STRING,state:T.EMPTY_STRING,cloudGraphHostName:(null==(l=null==r?void 0:r.account)?void 0:l.cloudGraphHostName)||T.EMPTY_STRING,msGraphHost:(null==(c=null==r?void 0:r.account)?void 0:c.msGraphHost)||T.EMPTY_STRING,code:void 0,fromNativeBroker:!1}};var nx=ox;function ox(e,t,r,i){this.isBrowserEnvironment="undefined"!=typeof window,this.config=e,this.storage=t,this.logger=r,this.cryptoObj=i}zm(lx,ax=p_);var ax,sx=lx;function lx(e){e=ax.call(this,e)||this;return e.includeRedirectUri=!1,e}zm(hx,cx=s),hx.prototype.acquireToken=function(o){return _(this,void 0,void 0,function(){var t,r,i,n;return b(this,function(e){switch(e.label){case 0:if(this.logger.trace("SilentAuthCodeClient.acquireToken called"),o.code)return this.performanceClient.setPreQueueTime(A.StandardInteractionClientInitializeAuthorizationRequest,o.correlationId),[4,this.initializeAuthorizationRequest(o,P.Silent)];throw k.createAuthCodeRequiredError();case 1:t=e.sent(),this.browserStorage.updateCacheEntries(t.state,t.nonce,t.authority,t.loginHint||T.EMPTY_STRING,t.account||null),r=this.initializeServerTelemetryManager(this.apiId),e.label=2;case 2:return e.trys.push([2,4,,5]),i=v(v({},t),{code:o.code}),this.performanceClient.setPreQueueTime(A.StandardInteractionClientGetClientConfiguration,o.correlationId),[4,this.getClientConfiguration(r,t.authority)];case 3:return n=e.sent(),n=new sx(n),this.logger.verbose("Auth code client created"),[2,new dw(n,this.browserStorage,i,this.logger,this.config.system,this.performanceClient).handleCodeResponseFromServer({code:o.code,msgraph_host:o.msGraphHost,cloud_graph_host_name:o.cloudGraphHostName,cloud_instance_host_name:o.cloudInstanceHostName},t.state,n.authority,this.networkClient,!1)];case 4:throw(n=e.sent())instanceof S&&n.setCorrelationId(this.correlationId),r.cacheFailedRequest(n),this.browserStorage.cleanRequestByState(t.state),n;case 5:return[2]}})})},hx.prototype.logout=function(){return Promise.reject(k.createSilentLogoutUnsupportedError())};var cx,ux=hx;function hx(e,t,r,i,n,o,a,s,l,c){e=cx.call(this,e,t,r,i,n,o,s,l,c)||this;return e.apiId=a,e}function O(e){this.isBrowserEnvironment="undefined"!=typeof window,this.config=(t=e,r=this.isBrowserEnvironment,o=e.auth,s=e.cache,i=e.system,t=e.telemetry,e={clientId:T.EMPTY_STRING,authority:""+T.DEFAULT_AUTHORITY,knownAuthorities:[],cloudDiscoveryMetadata:T.EMPTY_STRING,authorityMetadata:T.EMPTY_STRING,redirectUri:T.EMPTY_STRING,postLogoutRedirectUri:T.EMPTY_STRING,navigateToLoginRequestUrl:!0,clientCapabilities:[],protocolMode:w_.AAD,azureCloudOptions:{azureCloudInstance:Cy.None,tenant:T.EMPTY_STRING},skipAuthorityMetadataCache:!1},a={cacheLocation:V0.SessionStorage,temporaryCacheLocation:V0.SessionStorage,storeAuthStateInCookie:!1,secureCookies:!1,cacheMigrationEnabled:!(!s||s.cacheLocation!==V0.LocalStorage),claimsBasedCachingEnabled:!0},n={loggerCallback:function(){},logLevel:_y.Info,piiLoggingEnabled:!1},r=v(v({},uv),{loggerOptions:n,networkClient:r?Ab.getBrowserNetworkClient():z_,navigationClient:new ow,loadFrameTimeout:0,windowHashTimeout:(null==i?void 0:i.loadFrameTimeout)||sw,iframeHashTimeout:(null==i?void 0:i.loadFrameTimeout)||lw,navigateFrameWait:r&&Ab.detectIEOrEdge()?500:0,redirectNavigationTimeout:cw,asyncPopups:!1,allowRedirectInIframe:!1,allowNativeBroker:!1,nativeBrokerHandshakeTimeout:(null==i?void 0:i.nativeBrokerHandshakeTimeout)||uw,pollIntervalMilliseconds:X0.DEFAULT_POLL_INTERVAL_MS,cryptoOptions:{useMsrCrypto:!1,entropy:void 0}}),i=v(v({},i),{loggerOptions:(null==i?void 0:i.loggerOptions)||n}),n={application:{appName:T.EMPTY_STRING,appVersion:T.EMPTY_STRING}},{auth:v(v({},e),o),cache:v(v({},a),s),system:v(v({},r),i),telemetry:v(v({},n),t)}),this.initialized=!1,this.logger=new wy(this.config.system.loggerOptions,xb,Cb),this.networkClient=this.config.system.networkClient,this.navigationClient=this.config.system.navigationClient,this.redirectResponse=new Map,this.hybridAuthCodeResponses=new Map,this.performanceClient=this.isBrowserEnvironment?new rx(this.config.auth.clientId,this.config.auth.authority,this.logger,xb,Cb,this.config.telemetry.application,this.config.system.cryptoOptions):new Y_(this.config.auth.clientId,this.config.auth.authority,this.logger,xb,Cb,this.config.telemetry.application),this.browserCrypto=this.isBrowserEnvironment?new Xw(this.logger,this.performanceClient,this.config.system.cryptoOptions):Eg,this.eventHandler=new bw(this.logger,this.browserCrypto),this.browserStorage=this.isBrowserEnvironment?new wb(this.config.auth.clientId,this.config.cache,this.browserCrypto,this.logger):(e=this.config.auth.clientId,o=this.logger,a={cacheLocation:V0.MemoryStorage,temporaryCacheLocation:V0.MemoryStorage,storeAuthStateInCookie:!1,secureCookies:!1,cacheMigrationEnabled:!1,claimsBasedCachingEnabled:!0},new wb(e,a,Eg,o));var t,r,i,n,o,a,s={cacheLocation:V0.MemoryStorage,temporaryCacheLocation:V0.MemoryStorage,storeAuthStateInCookie:!1,secureCookies:!1,cacheMigrationEnabled:!1,claimsBasedCachingEnabled:!0};this.nativeInternalStorage=new wb(this.config.auth.clientId,s,this.browserCrypto,this.logger),this.tokenCache=new nx(this.config,this.browserStorage,this.logger,this.browserCrypto),this.trackPageVisibilityWithMeasurement=this.trackPageVisibilityWithMeasurement.bind(this)}O.prototype.initialize=function(){return _(this,void 0,void 0,function(){var t,r,i,n,o;return b(this,function(e){switch(e.label){case 0:if(this.logger.trace("initialize called"),this.initialized)return this.logger.info("initialize has already been called, exiting early."),[2];if(t=this.config.system.allowNativeBroker,r=this.performanceClient.startMeasurement(A.InitializeClientApplication),this.eventHandler.emitEvent(R.INITIALIZE_START),!t)return[3,4];e.label=1;case 1:return e.trys.push([1,3,,4]),i=this,[4,Xb.createProvider(this.logger,this.config.system.nativeBrokerHandshakeTimeout,this.performanceClient)];case 2:return i.nativeExtensionProvider=e.sent(),[3,4];case 3:return n=e.sent(),this.logger.verbose(n),[3,4];case 4:return this.config.cache.claimsBasedCachingEnabled?[3,6]:(this.logger.verbose("Claims-based caching is disabled. Clearing the previous cache with claims"),o=this.performanceClient.startMeasurement(A.ClearTokensAndKeysWithClaims),[4,this.browserStorage.clearTokensAndKeysWithClaims()]);case 5:e.sent(),o.endMeasurement({success:!0}),e.label=6;case 6:return this.initialized=!0,this.eventHandler.emitEvent(R.INITIALIZE_END),r.endMeasurement({allowNativeBroker:t,success:!0}),[2]}})})},O.prototype.handleRedirectPromise=function(s){return _(this,void 0,void 0,function(){var t,r,i,n,o,a=this;return b(this,function(e){return this.logger.verbose("handleRedirectPromise called"),Ab.blockNativeBrokerCalledBeforeInitialized(this.config.system.allowNativeBroker,this.initialized),t=this.getAllAccounts(),this.isBrowserEnvironment?(r=s||T.EMPTY_STRING,void 0===(i=this.redirectResponse.get(r))?(this.eventHandler.emitEvent(R.HANDLE_REDIRECT_START,P.Redirect),this.logger.verbose("handleRedirectPromise has been called for the first time, storing the promise"),o=this.browserStorage.getCachedNativeRequest(),n=void 0,n=o&&Xb.isNativeAvailable(this.config,this.logger,this.nativeExtensionProvider)&&this.nativeExtensionProvider&&!s?(this.logger.trace("handleRedirectPromise - acquiring token from native platform"),new Yb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Y0.handleRedirectPromise,this.performanceClient,this.nativeExtensionProvider,o.accountId,this.nativeInternalStorage,o.correlationId).handleRedirectPromise()):(this.logger.trace("handleRedirectPromise - acquiring token from web flow"),o=this.browserStorage.getTemporaryCache(K0.CORRELATION_ID,!0)||T.EMPTY_STRING,this.createRedirectClient(o).handleRedirectPromise(s)),i=n.then(function(e){return e&&(t.length<a.getAllAccounts().length?(a.eventHandler.emitEvent(R.LOGIN_SUCCESS,P.Redirect,e),a.logger.verbose("handleRedirectResponse returned result, login success")):(a.eventHandler.emitEvent(R.ACQUIRE_TOKEN_SUCCESS,P.Redirect,e),a.logger.verbose("handleRedirectResponse returned result, acquire token success"))),a.eventHandler.emitEvent(R.HANDLE_REDIRECT_END,P.Redirect),e}).catch(function(e){throw 0<t.length?a.eventHandler.emitEvent(R.ACQUIRE_TOKEN_FAILURE,P.Redirect,null,e):a.eventHandler.emitEvent(R.LOGIN_FAILURE,P.Redirect,null,e),a.eventHandler.emitEvent(R.HANDLE_REDIRECT_END,P.Redirect),e}),this.redirectResponse.set(r,i)):this.logger.verbose("handleRedirectPromise has been called previously, returning the result from the first call"),[2,i]):(this.logger.verbose("handleRedirectPromise returns null, not browser environment"),[2,null])})})},O.prototype.acquireTokenRedirect=function(n){return _(this,void 0,void 0,function(){var t,r,i=this;return b(this,function(e){return t=this.getRequestCorrelationId(n),this.logger.verbose("acquireTokenRedirect called",t),this.preflightBrowserEnvironmentCheck(P.Redirect),(r=0<this.getAllAccounts().length)?this.eventHandler.emitEvent(R.ACQUIRE_TOKEN_START,P.Redirect,n):this.eventHandler.emitEvent(R.LOGIN_START,P.Redirect,n),[2,(this.nativeExtensionProvider&&this.canUseNative(n)?new Yb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Y0.acquireTokenRedirect,this.performanceClient,this.nativeExtensionProvider,this.getNativeAccountId(n),this.nativeInternalStorage,n.correlationId).acquireTokenRedirect(n).catch(function(e){if(e instanceof Hb&&e.isFatal())return i.nativeExtensionProvider=void 0,i.createRedirectClient(n.correlationId).acquireToken(n);if(e instanceof Wv)return i.logger.verbose("acquireTokenRedirect - Resolving interaction required error thrown by native broker by falling back to web flow"),i.createRedirectClient(n.correlationId).acquireToken(n);throw i.browserStorage.setInteractionInProgress(!1),e}):this.createRedirectClient(n.correlationId).acquireToken(n)).catch(function(e){throw r?i.eventHandler.emitEvent(R.ACQUIRE_TOKEN_FAILURE,P.Redirect,null,e):i.eventHandler.emitEvent(R.LOGIN_FAILURE,P.Redirect,null,e),e})]})})},O.prototype.acquireTokenPopup=function(t){var r=this,e=this.getRequestCorrelationId(t),i=this.performanceClient.startMeasurement(A.AcquireTokenPopup,e);try{this.logger.verbose("acquireTokenPopup called",e),this.preflightBrowserEnvironmentCheck(P.Popup)}catch(e){return Promise.reject(e)}var n=this.getAllAccounts();return 0<n.length?this.eventHandler.emitEvent(R.ACQUIRE_TOKEN_START,P.Popup,t):this.eventHandler.emitEvent(R.LOGIN_START,P.Popup,t),(this.canUseNative(t)?this.acquireTokenNative(t,Y0.acquireTokenPopup).then(function(e){return r.browserStorage.setInteractionInProgress(!1),i.endMeasurement({success:!0,isNativeBroker:!0,requestId:e.requestId}),e}).catch(function(e){if(e instanceof Hb&&e.isFatal())return r.nativeExtensionProvider=void 0,r.createPopupClient(t.correlationId).acquireToken(t);if(e instanceof Wv)return r.logger.verbose("acquireTokenPopup - Resolving interaction required error thrown by native broker by falling back to web flow"),r.createPopupClient(t.correlationId).acquireToken(t);throw r.browserStorage.setInteractionInProgress(!1),e}):this.createPopupClient(t.correlationId).acquireToken(t)).then(function(e){return n.length<r.getAllAccounts().length?r.eventHandler.emitEvent(R.LOGIN_SUCCESS,P.Popup,e):r.eventHandler.emitEvent(R.ACQUIRE_TOKEN_SUCCESS,P.Popup,e),i.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),i.endMeasurement({success:!0,requestId:e.requestId}),e}).catch(function(e){return 0<n.length?r.eventHandler.emitEvent(R.ACQUIRE_TOKEN_FAILURE,P.Popup,null,e):r.eventHandler.emitEvent(R.LOGIN_FAILURE,P.Popup,null,e),i.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),Promise.reject(e)})},O.prototype.trackPageVisibilityWithMeasurement=function(){var e=this.ssoSilentMeasurement||this.acquireTokenByCodeAsyncMeasurement;e&&(this.logger.info("Perf: Visibility change detected in ",e.event.name),e.increment({visibilityChangeCount:1}))},O.prototype.ssoSilent=function(n){var o;return _(this,void 0,void 0,function(){var t,r,i=this;return b(this,function(e){return t=this.getRequestCorrelationId(n),r=v(v({},n),{prompt:n.prompt,correlationId:t}),this.preflightBrowserEnvironmentCheck(P.Silent),this.ssoSilentMeasurement=this.performanceClient.startMeasurement(A.SsoSilent,t),null!=(o=this.ssoSilentMeasurement)&&o.increment({visibilityChangeCount:0}),document.addEventListener("visibilitychange",this.trackPageVisibilityWithMeasurement),this.logger.verbose("ssoSilent called",t),this.eventHandler.emitEvent(R.SSO_SILENT_START,P.Silent,r),[2,(this.canUseNative(r)?this.acquireTokenNative(r,Y0.ssoSilent).catch(function(e){if(e instanceof Hb&&e.isFatal())return i.nativeExtensionProvider=void 0,i.createSilentIframeClient(r.correlationId).acquireToken(r);throw e}):this.createSilentIframeClient(r.correlationId).acquireToken(r)).then(function(e){var t;return i.eventHandler.emitEvent(R.SSO_SILENT_SUCCESS,P.Silent,e),null!=(t=i.ssoSilentMeasurement)&&t.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),null!=(t=i.ssoSilentMeasurement)&&t.endMeasurement({success:!0,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){var t;throw i.eventHandler.emitEvent(R.SSO_SILENT_FAILURE,P.Silent,null,e),null!=(t=i.ssoSilentMeasurement)&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}).finally(function(){document.removeEventListener("visibilitychange",i.trackPageVisibilityWithMeasurement)})]})})},O.prototype.acquireTokenByCode=function(a){return _(this,void 0,void 0,function(){var t,r,i,n,o=this;return b(this,function(e){t=this.getRequestCorrelationId(a),this.preflightBrowserEnvironmentCheck(P.Silent),this.logger.trace("acquireTokenByCode called",t),this.eventHandler.emitEvent(R.ACQUIRE_TOKEN_BY_CODE_START,P.Silent,a),r=this.performanceClient.startMeasurement(A.AcquireTokenByCode,a.correlationId);try{if(a.code&&a.nativeAccountId)throw k.createSpaCodeAndNativeAccountIdPresentError();if(a.code)return i=a.code,(n=this.hybridAuthCodeResponses.get(i))?(this.logger.verbose("Existing acquireTokenByCode request found",a.correlationId),r.discardMeasurement()):(this.logger.verbose("Initiating new acquireTokenByCode request",t),n=this.acquireTokenByCodeAsync(v(v({},a),{correlationId:t})).then(function(e){return o.eventHandler.emitEvent(R.ACQUIRE_TOKEN_BY_CODE_SUCCESS,P.Silent,e),o.hybridAuthCodeResponses.delete(i),r.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),r.endMeasurement({success:!0,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){throw o.hybridAuthCodeResponses.delete(i),o.eventHandler.emitEvent(R.ACQUIRE_TOKEN_BY_CODE_FAILURE,P.Silent,null,e),r.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}),this.hybridAuthCodeResponses.set(i,n)),[2,n];if(a.nativeAccountId){if(this.canUseNative(a,a.nativeAccountId))return[2,this.acquireTokenNative(a,Y0.acquireTokenByCode,a.nativeAccountId).catch(function(e){throw e instanceof Hb&&e.isFatal()&&(o.nativeExtensionProvider=void 0),e})];throw k.createUnableToAcquireTokenFromNativePlatformError()}throw k.createAuthCodeOrNativeAccountIdRequiredError()}catch(e){throw this.eventHandler.emitEvent(R.ACQUIRE_TOKEN_BY_CODE_FAILURE,P.Silent,null,e),r.endMeasurement({errorCode:e instanceof S&&e.errorCode||void 0,subErrorCode:e instanceof S&&e.subError||void 0,success:!1}),e}return[2]})})},O.prototype.acquireTokenByCodeAsync=function(t){var i;return _(this,void 0,void 0,function(){var r=this;return b(this,function(e){switch(e.label){case 0:return this.logger.trace("acquireTokenByCodeAsync called",t.correlationId),this.acquireTokenByCodeAsyncMeasurement=this.performanceClient.startMeasurement(A.AcquireTokenByCodeAsync,t.correlationId),null!=(i=this.acquireTokenByCodeAsyncMeasurement)&&i.increment({visibilityChangeCount:0}),document.addEventListener("visibilitychange",this.trackPageVisibilityWithMeasurement),[4,this.createSilentAuthCodeClient(t.correlationId).acquireToken(t).then(function(e){var t;return null!=(t=r.acquireTokenByCodeAsyncMeasurement)&&t.endMeasurement({success:!0,fromCache:e.fromCache,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){var t;throw null!=(t=r.acquireTokenByCodeAsyncMeasurement)&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}).finally(function(){document.removeEventListener("visibilitychange",r.trackPageVisibilityWithMeasurement)})];case 1:return[2,e.sent()]}})})},O.prototype.acquireTokenFromCache=function(t,r,i){return _(this,void 0,void 0,function(){return b(this,function(e){switch(this.performanceClient.addQueueMeasurement(A.AcquireTokenFromCache,r.correlationId),i.cacheLookupPolicy){case $0.Default:case $0.AccessToken:case $0.AccessTokenAndRefreshToken:return[2,t.acquireToken(r)];default:throw E.createRefreshRequiredError()}return[2]})})},O.prototype.acquireTokenByRefreshToken=function(r,i){return _(this,void 0,void 0,function(){var t;return b(this,function(e){switch(this.performanceClient.addQueueMeasurement(A.AcquireTokenByRefreshToken,r.correlationId),i.cacheLookupPolicy){case $0.Default:case $0.AccessTokenAndRefreshToken:case $0.RefreshToken:case $0.RefreshTokenAndNetwork:return t=this.createSilentRefreshClient(r.correlationId),this.performanceClient.setPreQueueTime(A.SilentRefreshClientAcquireToken,r.correlationId),[2,t.acquireToken(r)];default:throw E.createRefreshRequiredError()}return[2]})})},O.prototype.acquireTokenBySilentIframe=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){return this.performanceClient.addQueueMeasurement(A.AcquireTokenBySilentIframe,r.correlationId),t=this.createSilentIframeClient(r.correlationId),this.performanceClient.setPreQueueTime(A.SilentIframeClientAcquireToken,r.correlationId),[2,t.acquireToken(r)]})})},O.prototype.logout=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){return t=this.getRequestCorrelationId(r),this.logger.warning("logout API is deprecated and will be removed in msal-browser v3.0.0. Use logoutRedirect instead.",t),[2,this.logoutRedirect(v({correlationId:t},r))]})})},O.prototype.logoutRedirect=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){return t=this.getRequestCorrelationId(r),this.preflightBrowserEnvironmentCheck(P.Redirect),[2,this.createRedirectClient(t).logout(r)]})})},O.prototype.logoutPopup=function(e){try{var t=this.getRequestCorrelationId(e);return this.preflightBrowserEnvironmentCheck(P.Popup),this.createPopupClient(t).logout(e)}catch(e){return Promise.reject(e)}},O.prototype.getAllAccounts=function(){return this.logger.verbose("getAllAccounts called"),this.isBrowserEnvironment?this.browserStorage.getAllAccounts():[]},O.prototype.getAccountByUsername=function(e){var t;return this.logger.trace("getAccountByUsername called"),e?(t=this.browserStorage.getAccountInfoFilteredBy({username:e}))?(this.logger.verbose("getAccountByUsername: Account matching username found, returning"),this.logger.verbosePii("getAccountByUsername: Returning signed-in accounts matching username: "+e),t):(this.logger.verbose("getAccountByUsername: No matching account found, returning null"),null):(this.logger.warning("getAccountByUsername: No username provided"),null)},O.prototype.getAccountByHomeId=function(e){var t;return this.logger.trace("getAccountByHomeId called"),e?(t=this.browserStorage.getAccountInfoFilteredBy({homeAccountId:e}))?(this.logger.verbose("getAccountByHomeId: Account matching homeAccountId found, returning"),this.logger.verbosePii("getAccountByHomeId: Returning signed-in accounts matching homeAccountId: "+e),t):(this.logger.verbose("getAccountByHomeId: No matching account found, returning null"),null):(this.logger.warning("getAccountByHomeId: No homeAccountId provided"),null)},O.prototype.getAccountByLocalId=function(e){var t;return this.logger.trace("getAccountByLocalId called"),e?(t=this.browserStorage.getAccountInfoFilteredBy({localAccountId:e}))?(this.logger.verbose("getAccountByLocalId: Account matching localAccountId found, returning"),this.logger.verbosePii("getAccountByLocalId: Returning signed-in accounts matching localAccountId: "+e),t):(this.logger.verbose("getAccountByLocalId: No matching account found, returning null"),null):(this.logger.warning("getAccountByLocalId: No localAccountId provided"),null)},O.prototype.setActiveAccount=function(e){this.browserStorage.setActiveAccount(e)},O.prototype.getActiveAccount=function(){return this.browserStorage.getActiveAccount()},O.prototype.preflightBrowserEnvironmentCheck=function(e,t){if(void 0===t&&(t=!0),this.logger.verbose("preflightBrowserEnvironmentCheck started"),Ab.blockNonBrowserEnvironment(this.isBrowserEnvironment),Ab.blockRedirectInIframe(e,this.config.system.allowRedirectInIframe),Ab.blockReloadInHiddenIframes(),Ab.blockAcquireTokenInPopups(),Ab.blockNativeBrokerCalledBeforeInitialized(this.config.system.allowNativeBroker,this.initialized),e===P.Redirect&&this.config.cache.cacheLocation===V0.MemoryStorage&&!this.config.cache.storeAuthStateInCookie)throw db.createInMemoryRedirectUnavailableError();e!==P.Redirect&&e!==P.Popup||this.preflightInteractiveRequest(t)},O.prototype.preflightInteractiveRequest=function(e){this.logger.verbose("preflightInteractiveRequest called, validating app environment"),Ab.blockReloadInHiddenIframes(),e&&this.browserStorage.setInteractionInProgress(!0)},O.prototype.acquireTokenNative=function(t,r,i){return _(this,void 0,void 0,function(){return b(this,function(e){if(this.logger.trace("acquireTokenNative called"),this.nativeExtensionProvider)return[2,new Yb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,r,this.performanceClient,this.nativeExtensionProvider,i||this.getNativeAccountId(t),this.nativeInternalStorage,t.correlationId).acquireToken(t)];throw k.createNativeConnectionNotEstablishedError()})})},O.prototype.canUseNative=function(e,t){if(this.logger.trace("canUseNative called"),!Xb.isNativeAvailable(this.config,this.logger,this.nativeExtensionProvider,e.authenticationScheme))return this.logger.trace("canUseNative: isNativeAvailable returned false, returning false"),!1;if(e.prompt)switch(e.prompt){case ig.NONE:case ig.CONSENT:case ig.LOGIN:this.logger.trace("canUseNative: prompt is compatible with native flow");break;default:return this.logger.trace("canUseNative: prompt = "+e.prompt+" is not compatible with native flow, returning false"),!1}return!(!t&&!this.getNativeAccountId(e)&&(this.logger.trace("canUseNative: nativeAccountId is not available, returning false"),1))},O.prototype.getNativeAccountId=function(e){e=e.account||this.browserStorage.getAccountInfoByHints(e.loginHint,e.sid)||this.getActiveAccount();return e&&e.nativeAccountId||""},O.prototype.createPopupClient=function(e){return new iw(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeInternalStorage,this.nativeExtensionProvider,e)},O.prototype.createRedirectClient=function(e){return new ew(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeInternalStorage,this.nativeExtensionProvider,e)},O.prototype.createSilentIframeClient=function(e){return new mw(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Y0.ssoSilent,this.performanceClient,this.nativeInternalStorage,this.nativeExtensionProvider,e)},O.prototype.createSilentCacheClient=function(e){return new Kb(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeExtensionProvider,e)},O.prototype.createSilentRefreshClient=function(e){return new vw(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.performanceClient,this.nativeExtensionProvider,e)},O.prototype.createSilentAuthCodeClient=function(e){return new ux(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,Y0.acquireTokenByCode,this.performanceClient,this.nativeExtensionProvider,e)},O.prototype.addEventCallback=function(e){return this.eventHandler.addEventCallback(e)},O.prototype.removeEventCallback=function(e){this.eventHandler.removeEventCallback(e)},O.prototype.addPerformanceCallback=function(e){return this.performanceClient.addPerformanceCallback(e)},O.prototype.removePerformanceCallback=function(e){return this.performanceClient.removePerformanceCallback(e)},O.prototype.enableAccountStorageEvents=function(){this.eventHandler.enableAccountStorageEvents()},O.prototype.disableAccountStorageEvents=function(){this.eventHandler.disableAccountStorageEvents()},O.prototype.getTokenCache=function(){return this.tokenCache},O.prototype.getLogger=function(){return this.logger},O.prototype.setLogger=function(e){this.logger=e},O.prototype.initializeWrapperLibrary=function(e,t){this.browserStorage.setWrapperMetadata(e,t)},O.prototype.setNavigationClient=function(e){this.navigationClient=e},O.prototype.getConfiguration=function(){return this.config},O.prototype.getRequestCorrelationId=function(e){return null!=e&&e.correlationId?e.correlationId:this.isBrowserEnvironment?this.browserCrypto.createNewGuid():T.EMPTY_STRING};zm(fx,dx=O),fx.prototype.loginRedirect=function(r){return _(this,void 0,void 0,function(){var t;return b(this,function(e){return t=this.getRequestCorrelationId(r),this.logger.verbose("loginRedirect called",t),[2,this.acquireTokenRedirect(v({correlationId:t},r||tb))]})})},fx.prototype.loginPopup=function(e){var t=this.getRequestCorrelationId(e);return this.logger.verbose("loginPopup called",t),this.acquireTokenPopup(v({correlationId:t},e||tb))},fx.prototype.acquireTokenSilent=function(s){return _(this,void 0,void 0,function(){var t,r,i,n,o,a=this;return b(this,function(e){if(t=this.getRequestCorrelationId(s),(r=this.performanceClient.startMeasurement(A.AcquireTokenSilent,t)).addStaticFields({cacheLookupPolicy:s.cacheLookupPolicy}),this.preflightBrowserEnvironmentCheck(P.Silent),this.logger.verbose("acquireTokenSilent called",t),o=s.account||this.getActiveAccount())return n={clientId:this.config.auth.clientId,authority:s.authority||T.EMPTY_STRING,scopes:s.scopes,homeAccountIdentifier:o.homeAccountId,claims:s.claims,authenticationScheme:s.authenticationScheme,resourceRequestMethod:s.resourceRequestMethod,resourceRequestUri:s.resourceRequestUri,shrClaims:s.shrClaims,sshKid:s.sshKid},i=JSON.stringify(n),void 0===(n=this.activeSilentTokenRequests.get(i))?(this.logger.verbose("acquireTokenSilent called for the first time, storing active request",t),this.performanceClient.setPreQueueTime(A.AcquireTokenSilentAsync,t),o=this.acquireTokenSilentAsync(v(v({},s),{correlationId:t}),o).then(function(e){return a.activeSilentTokenRequests.delete(i),r.addStaticFields({accessTokenSize:e.accessToken.length,idTokenSize:e.idToken.length}),r.endMeasurement({success:!0,fromCache:e.fromCache,isNativeBroker:e.fromNativeBroker,cacheLookupPolicy:s.cacheLookupPolicy,requestId:e.requestId}),e}).catch(function(e){throw a.activeSilentTokenRequests.delete(i),r.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}),this.activeSilentTokenRequests.set(i,o),[2,o]):(this.logger.verbose("acquireTokenSilent has been called previously, returning the result from the first call",t),r.discardMeasurement(),[2,n]);throw k.createNoAccountError()})})},fx.prototype.trackPageVisibility=function(){this.astsAsyncMeasurement&&(this.logger.info("Perf: Visibility change detected"),this.astsAsyncMeasurement.increment({visibilityChangeCount:1}))},fx.prototype.acquireTokenSilentAsync=function(l,i){var n;return _(this,void 0,void 0,function(){var t,r,o,a,s=this;return b(this,function(e){switch(e.label){case 0:return(this.performanceClient.addQueueMeasurement(A.AcquireTokenSilentAsync,l.correlationId),this.eventHandler.emitEvent(R.ACQUIRE_TOKEN_START,P.Silent,l),this.astsAsyncMeasurement=this.performanceClient.startMeasurement(A.AcquireTokenSilentAsync,l.correlationId),null!=(n=this.astsAsyncMeasurement)&&n.increment({visibilityChangeCount:0}),document.addEventListener("visibilitychange",this.trackPageVisibility),Xb.isNativeAvailable(this.config,this.logger,this.nativeExtensionProvider,l.authenticationScheme)&&i.nativeAccountId)?(this.logger.verbose("acquireTokenSilent - attempting to acquire token from native platform"),t=v(v({},l),{account:i}),t=this.acquireTokenNative(t,Y0.acquireTokenSilent_silentFlow).catch(function(t){return _(s,void 0,void 0,function(){return b(this,function(e){if(t instanceof Hb&&t.isFatal())return this.logger.verbose("acquireTokenSilent - native platform unavailable, falling back to web flow"),this.nativeExtensionProvider=void 0,[2,this.createSilentIframeClient(l.correlationId).acquireToken(l)];throw t})})}),[3,3]):[3,1];case 1:return this.logger.verbose("acquireTokenSilent - attempting to acquire token from web flow"),r=this.createSilentCacheClient(l.correlationId),this.performanceClient.setPreQueueTime(A.InitializeSilentRequest,l.correlationId),[4,r.initializeSilentRequest(l,i)];case 2:o=e.sent(),a=v(v({},l),{cacheLookupPolicy:l.cacheLookupPolicy||$0.Default}),this.performanceClient.setPreQueueTime(A.AcquireTokenFromCache,o.correlationId),t=this.acquireTokenFromCache(r,o,a).catch(function(e){if(a.cacheLookupPolicy===$0.AccessToken)throw e;return Ab.blockReloadInHiddenIframes(),s.eventHandler.emitEvent(R.ACQUIRE_TOKEN_NETWORK_START,P.Silent,o),s.performanceClient.setPreQueueTime(A.AcquireTokenByRefreshToken,o.correlationId),s.acquireTokenByRefreshToken(o,a).catch(function(e){var t=e instanceof bv,r=e instanceof Wv,i=e.errorCode===Kv.code,n=e.errorCode===X0.INVALID_GRANT_ERROR;if(t&&n&&!r&&a.cacheLookupPolicy!==$0.AccessTokenAndRefreshToken&&a.cacheLookupPolicy!==$0.RefreshToken||a.cacheLookupPolicy===$0.Skip||i)return s.logger.verbose("Refresh token expired/invalid or CacheLookupPolicy is set to Skip, attempting acquire token by iframe.",l.correlationId),s.performanceClient.setPreQueueTime(A.AcquireTokenBySilentIframe,o.correlationId),s.acquireTokenBySilentIframe(o);throw e})}),e.label=3;case 3:return[2,t.then(function(e){var t;return s.eventHandler.emitEvent(R.ACQUIRE_TOKEN_SUCCESS,P.Silent,e),null!=(t=s.astsAsyncMeasurement)&&t.endMeasurement({success:!0,fromCache:e.fromCache,isNativeBroker:e.fromNativeBroker,requestId:e.requestId}),e}).catch(function(e){var t;throw s.eventHandler.emitEvent(R.ACQUIRE_TOKEN_FAILURE,P.Silent,null,e),null!=(t=s.astsAsyncMeasurement)&&t.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}).finally(function(){document.removeEventListener("visibilitychange",s.trackPageVisibility)})]}})})};var dx,px=fx;function fx(e){e=dx.call(this,e)||this;return e.astsAsyncMeasurement=void 0,e.activeSilentTokenRequests=new Map,e.trackPageVisibility=e.trackPageVisibility.bind(e),e}function mx(e){this.message=e}(mx.prototype=new Error).name="InvalidCharacterError";var gx="undefined"!=typeof window&&window.atob&&window.atob.bind(window)||function(e){var t=String(e).replace(/=+$/,"");if(t.length%4==1)throw new mx("'atob' failed: The string to be decoded is not correctly encoded.");for(var r,i,n=0,o=0,a="";i=t.charAt(o++);~i&&(r=n%4?64*r+i:i,n++%4)&&(a+=String.fromCharCode(255&r>>(-2*n&6))))i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(i);return a};function yx(e){this.message=e}function vx(e,t){if("string"!=typeof e)throw new yx("Invalid token specified");t=!0===(t=t||{}).header?0:1;try{return JSON.parse(function(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw"Illegal base64url string!"}try{return decodeURIComponent(gx(t).replace(/(.)/g,function(e,t){t=t.charCodeAt(0).toString(16).toUpperCase();return"%"+(t=t.length<2?"0"+t:t)}))}catch(e){return gx(t)}}(e.split(".")[t]))}catch(e){throw new yx("Invalid token specified: "+e.message)}}(yx.prototype=new Error).name="InvalidTokenError";L.prototype.initialize=function(){var i=this;return this.initPromise||(this.initPromise=new Promise(function(e,t){if(i.options.authType===u.AuthenticationType.subscriptionKey)e();else if(i.options.authType===u.AuthenticationType.aad)i.options.authContext=i.options.authContext||L.getDefaultAuthContext(i.options),i.options.authContext.handleRedirectPromise().then(function(){setTimeout(function(){return i._loginAndAcquireTokenForAAD(e,t)})}).catch(function(e){t(new Error("Error logging in the AAD users: "+e))});else if(i.options.authType===u.AuthenticationType.anonymous)e(i._triggerTokenFetch(!0));else if(i.options.authType===u.AuthenticationType.sas){if(i.options.sasToken){var r=-1;try{r=i._getTokenExpiry(i.options.sasToken)}catch(e){return void t(new Error("An invalid sasToken was provided."))}if(r>L.constants.tokenRefreshClockSkew)return i._storeToken(i.options.sasToken),i._setTimeoutTokenFetch(r-L.constants.tokenRefreshClockSkew),void e()}e(i._triggerTokenFetch())}else t(new Error("An invalid authentication type was specified."))})),this.initPromise},L.prototype.dispose=function(){this.tokenTimeOutHandle&&(clearTimeout(this.tokenTimeOutHandle),this.tokenTimeOutHandle=null)},L.getDefaultAuthContext=function(e){if(!e.aadAppId)throw new Error("No AAD app ID was specified.");if(e.aadTenant)return this.defaultAuthContext||(this.defaultAuthContext=new px({auth:{authority:"".concat(e.aadInstance||$).concat(e.aadTenant),clientId:e.aadAppId},cache:{cacheLocation:this.constants.preferredCacheLocation}})),this.defaultAuthContext;throw new Error("No AAD tenant was specified.")},L.prototype._loginAndAcquireTokenForAAD=function(e,t){var r=(null==(r=this.options.authContext)?void 0:r.getAllAccounts())||[];0===r.length?(this.options.authContext.loginRedirect(),e()):(this.options.authContext.setActiveAccount(r[0]),this._acquireTokenForAAD(e,t))},L.prototype._acquireTokenForAAD=function(r,t){var i=this,n={scopes:[fe]};this.options.authContext.acquireTokenSilent(n).then(function(e){i._saveItem(L.constants.storage.tokenKey,e.accessToken);var t={map:i.map,type:L.constants.events.tokenAcquired},t=(i.map.events.invoke(L.constants.events.tokenAcquired,t),clearTimeout(i.tokenTimeOutHandle),new Date(e.expiresOn).getTime()-Date.now());i.tokenTimeOutHandle=setTimeout(function(){return i._acquireTokenForAAD()},t),null!=r&&r()}).catch(function(e){if(e instanceof Wv)return i.options.authContext.acquireTokenRedirect(n),null==r?void 0:r();null!=t&&t(e)})},L.prototype.getAuthType=function(){return this.options.authType},L.prototype.getClientId=function(){return this.options.clientId},L.prototype.getToken=function(){if(this.options.authType===u.AuthenticationType.aad)return this._getItem(L.constants.storage.tokenKey);if(this.options.authType!==u.AuthenticationType.anonymous&&this.options.authType!==u.AuthenticationType.sas)return this.options.authType===u.AuthenticationType.subscriptionKey?this.options.subscriptionKey:void 0;var e=this._getItem(L.constants.storage.tokenKey);if(e){var t=this._getTokenExpiry(e);if(t<300&&0<t)this._triggerTokenFetch();else if(t<=0)throw this._saveItem(L.constants.storage.tokenKey,""),new Error(L.constants.errors.tokenExpired)}else this._triggerTokenFetch();return e},L.prototype._getTokenExpiry=function(e){var e=vx(e).exp,t=this._getCurrentTime();return 0<e-t?e-t:-1},L.prototype._storeToken=function(e){this._saveItem(L.constants.storage.tokenKey,e);e={map:this.map,type:L.constants.events.tokenAcquired};this.map.events.invoke(L.constants.events.tokenAcquired,e)},L.prototype._saveItem=function(e,t){return this._supportsLocalStorage()?localStorage.setItem(e,t):this._supportsSessionStorage()?sessionStorage.setItem(e,t):this.fallbackStorage[e]=t,!0},L.prototype._getItem=function(e){return this._supportsLocalStorage()?localStorage.getItem(e):this._supportsSessionStorage()?sessionStorage.getItem(e):e in this.fallbackStorage?this.fallbackStorage[e]:null},L.prototype._supportsLocalStorage=function(){try{return window.localStorage?(window.localStorage.setItem(L.constants.storage.testStorageKey,"A"),"A"===window.localStorage.getItem(L.constants.storage.testStorageKey)&&(window.localStorage.removeItem(L.constants.storage.testStorageKey),!window.localStorage.getItem(L.constants.storage.testStorageKey))):!1}catch(e){return!1}},L.prototype._supportsSessionStorage=function(){try{return window.sessionStorage?(window.sessionStorage.setItem(L.constants.storage.testStorageKey,"A"),"A"===window.sessionStorage.getItem(L.constants.storage.testStorageKey)&&(window.sessionStorage.removeItem(L.constants.storage.testStorageKey),!window.sessionStorage.getItem(L.constants.storage.testStorageKey))):!1}catch(e){return!1}},L.prototype._getCurrentTime=function(){return Math.round((new Date).getTime()/1e3)},L.prototype.signRequest=function(e){e.headers=e.headers||{},e.headers[me]=this.sessionId,e.headers[de]=pe,e.headers[ue]="MapControl/".concat(De," (Web)");var t=this.getToken();switch(this.options.authType){case u.AuthenticationType.aad:case u.AuthenticationType.anonymous:e.headers[he]=this.options.clientId,e.headers[J]=Q+t;break;case u.AuthenticationType.sas:e.headers[J]=ee+t;break;case u.AuthenticationType.subscriptionKey:e.headers["subscription-key"]=t;break;default:throw new Error("An invalid authentication type was specified")}return e},L.constants={preferredCacheLocation:"localStorage",storage:{tokenKey:"access.token.key",testStorageKey:"testStorage"},events:{tokenAcquired:"tokenacquired"},tokenExpiresIn:3599,tokenRefreshClockSkew:300,errors:{tokenExpired:"Token Expired, Try again"}};var _x=L;function L(e){var n=this,t=(this.fallbackStorage={},this._triggerTokenFetch=function(e){return void 0===e&&(e=!1),new Promise(function(r,i){"function"!=typeof n.options.getToken?i(new Error("Token cannot be ".concat(e?"fetched":"renewed"," because getToken was not set or is not a function."))):n.options.getToken(function(e){try{var t=n._getTokenExpiry(e)-L.constants.tokenRefreshClockSkew;n._storeToken(e),n._setTimeoutTokenFetch(t),r()}catch(e){i(new Error("Invalid token returned by getToken function"))}},function(e){i(e)},n.map)})},this._setTimeoutTokenFetch=function(e){clearTimeout(n.tokenTimeOutHandle),n.tokenTimeOutHandle=setTimeout(n._triggerTokenFetch,Math.min(1e3*e,2147483647))},e.getServiceOptions());this.options=t.authOptions,this.sessionId=t.sessionId,this.map=e}var bx=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},wx=(xx.prototype.add=function(e,t){var r,i;if(Array.isArray(e))try{for(var n=bx(e),o=n.next();!o.done;o=n.next()){var a=o.value;this._add(a,t)}}catch(e){r={error:e}}finally{try{o&&!o.done&&(i=n.return)&&i.call(n)}finally{if(r)throw r.error}}else this._add(e,t)},xx.prototype.getControls=function(){return Array.from(this.controls)},xx.prototype.remove=function(e){var t,r;if(Array.isArray(e))try{for(var i=bx(e),n=i.next();!n.done;n=i.next()){var o=n.value;this._remove(o)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}else this._remove(e)},xx.prototype._add=function(e,t){this.controls.add(e);var r=(new Gt).merge(t),e=e.onAdd(this.map,t),t=this.controlContainer.getElementsByClassName(r.position);if(!(0<t.length))throw new Error("Control position ".concat(r.position," does not exist."));t.item(0).appendChild(e)},xx.prototype._remove=function(e){e.onRemove(),this.controls.delete(e)},xx);function xx(e){for(var t in this.map=e,this.controlContainer=document.createElement("div"),this.controlContainer.classList.add("atlas-control-container"),u.ControlPosition){var r;u.ControlPosition.hasOwnProperty(t)&&((r=document.createElement("div")).classList.add(u.ControlPosition[t]),r.classList.add("subcontrol-container"),this.controlContainer.appendChild(r))}this.map.getMapContainer().appendChild(this.controlContainer),this.controls=new Set}var Cx=window&&window.__assign||function(){return(Cx=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},Tx=(Sx.prototype.addCallback=function(a,s,l,e,c){var t,u,h=this;if(e)t=function(e){var t=e.lngLat?new hu(e.lngLat.lng,e.lngLat.lat):void 0,r=e.point?[e.point.x,e.point.y]:void 0,i=e.features?e.features.map(function(e){return new Ql(e.geometry,e.properties,e.id)}):[],e={type:e.type,originalEvent:e.originalEvent,position:t,coordinate:r,features:i};l(e)};else switch(a){case"data":case"sourcedata":case"styledata":t=function(e){e=Cx(Cx({dataType:e.dataType},"source"===e.dataType&&Cx(Cx(Cx({isSourceLoaded:e.isSourceLoaded},e.sourceDataType&&{sourceDataType:e.sourceDataType}),{source:h.map.sources.getById(e.sourceId)}),e.tile&&{tile:{id:{x:e.tile.tileID.canonical.x,y:e.tile.tileID.canonical.y,z:e.tile.tileID.canonical.z},size:e.tile.tileSize,state:e.tile.state}})),{map:h.map,type:e.type});c&&h.map.events._removeListener(a,s,l),l(e)};break;case"error":t=function(e){e={error:e.error,map:h.map,type:e.type};c&&h.map.events._removeListener(a,s,l),l(e)};break;case"touchstart":case"touchend":case"touchmove":case"touchcancel":t=function(e){if(e.originalEvent){if(e.originalEvent===u)return;u=e.originalEvent}var t=e.point?new ic(e.point.x,e.point.y):void 0,r=e.points?e.points.map(function(e){return new ic(e.x,e.y)}):[],i=e.lngLat?new hu(e.lngLat.lng,e.lngLat.lat):void 0,n=e.lngLats?e.lngLats.map(function(e){return new hu(e.lng,e.lat)}):[],o=i?h.map.layers.getRenderedShapes(new oc(i),s?[s]:void 0):[],t={map:h.map,originalEvent:e.originalEvent,pixel:t,pixels:r,position:i,positions:n,shapes:o,layerId:s||void 0,preventDefault:function(){return e.preventDefault()},type:e.type};c&&h.map.events._removeListener(a,s,l),l(t)};break;case"mousedown":case"mouseup":case"mouseover":case"mousemove":case"click":case"dblclick":case"mouseout":case"mouseenter":case"mouseleave":case"contextmenu":t=function(e){if(e.originalEvent){if(e.originalEvent===u)return;u=e.originalEvent}var t=e.lngLat?new hu(e.lngLat.lng,e.lngLat.lat):void 0,r=e.point?new ic(e.point.x,e.point.y):void 0,i=t?h.map.layers.getRenderedShapes(new oc(t),s?[s]:void 0):[],t={map:h.map,originalEvent:e.originalEvent,position:t,pixel:r,preventDefault:function(){return e.preventDefault()},shapes:i,layerId:s||void 0,type:e.type};c&&h.map.events._removeListener(a,s,l),l(t)};break;case"styleimagemissing":t=function(e){c&&h.map.events._removeListener(a,s,l),l(e.id)};break;case"wheel":t=function(e){if(e.originalEvent){if(e.originalEvent===u)return;u=e.originalEvent}var t={map:h.map,originalEvent:e.originalEvent,preventDefault:function(){return e.preventDefault()},type:e.type};c&&h.map.events._removeListener(a,s,l),l(t)};break;case"resize":t=function(e){var t,r={map:h.map,type:e.type};for(t in e)"type"!==t&&"target"!==t&&(r[t]=e[t]);c&&h.map.events._removeListener(a,s,l),l(r)};break;default:t=function(e){var t={map:h.map,type:e.type};e.originalEvent&&(t.originalEvent=e.originalEvent),c&&h.map.events._removeListener(a,s,l),l(t)}}this.callbacks.has(s)||this.callbacks.set(s,new Yt),this.callbacks.get(s).has(a)||this.callbacks.get(s).set(a,new Map),this.callbacks.get(s).get(a).set(l,[t,c])},Sx.prototype.removeCallback=function(e,t,r){this.callbacks.has(t)&&this.callbacks.get(t).has(e)&&this.callbacks.get(t).get(e).has(r)&&this.callbacks.get(t).get(e).delete(r)},Sx.prototype.getModifiedCallback=function(e,t,r){if(this.callbacks.has(t)&&this.callbacks.get(t).has(e)&&this.callbacks.get(t).get(e).has(r))return this.callbacks.get(t).get(e).get(r)[0]},Sx.prototype.getLayerCallbacks=function(e){if(this.callbacks.has(e))return this.callbacks.get(e)},Sx.prototype.getEventCallbacks=function(e,t){if(this.callbacks.has(t)){t=this.callbacks.get(t);if(t.has(e))return t.get(e)}},Sx);function Sx(e){this.callbacks=new Yt,this.map=e}var Ex=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Ix=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},Ax=["maxzoomchanged","minzoomchanged","mapconfigurationchanged"],kx=(Px.prototype.add=function(e,t,r){var i,n;if("function"==typeof t)this._addGlobalListener(e,t,!1,!1);else{t=Array.isArray(t)?t:[t];try{for(var o=Ex(t),a=o.next();!a.done;a=o.next()){var s=a.value;s instanceof ed&&ed._isMBoxEvent(e)?this._addLayerListener(e,s,r,!1,!1):s._addEventListener(e,r,!1)}}catch(e){i={error:e}}finally{try{a&&!a.done&&(n=o.return)&&n.call(o)}finally{if(i)throw i.error}}}},Px.prototype.addOnce=function(e,t,r){"function"==typeof t?this._addGlobalListener(e,t,!1,!0):t instanceof ed&&ed._isMBoxEvent(e)?this._addLayerListener(e,t,r,!1,!0):t._addEventListener(e,r,!0)},Px.prototype._addLegacy=function(e,t,r){"function"==typeof t?this._addGlobalListener(e,t,!0,!1):this._addLayerListener(e,t,r,!0,!1)},Px.prototype._addLayerListener=function(e,t,r,i,n){var o,a,s,l,t=t instanceof ed?t.getId():t,c=this.map.layers.getLayerById(t),u=this.mapCallbackHandler.getModifiedCallback(e,t,r);if(u&&c)try{for(var h=Ex(c._getLayerIds()),d=h.next();!d.done;d=h.next()){var p=d.value;this.map._getMap().off(e,p,u)}}catch(e){o={error:e}}finally{try{d&&!d.done&&(a=h.return)&&a.call(h)}finally{if(o)throw o.error}}if(this.mapCallbackHandler.addCallback(e,t,r,i,n),c){u=this.mapCallbackHandler.getModifiedCallback(e,t,r);try{for(var f=Ex(c._getLayerIds()),m=f.next();!m.done;m=f.next()){p=m.value;this.map._getMap().on(e,p,u)}}catch(e){s={error:e}}finally{try{m&&!m.done&&(l=f.return)&&l.call(f)}finally{if(s)throw s.error}}}},Px.prototype._addGlobalListener=function(e,t,r,i){var n,o,a,s;Ax.includes(e)?this.map._addEventListener(e,t,i):(n=this.mapCallbackHandler.getModifiedCallback(e,"",t),this.mapCallbackHandler.addCallback(e,"",t,r,i),o=this.mapCallbackHandler.getModifiedCallback(e,"",t),"load"===e&&this.map._isLoaded()?(a={type:"load",map:this.map},setTimeout(function(){return o(a)})):"ready"===e?this.map._isReady()&&(s={type:"ready",map:this.map},setTimeout(function(){return o(s)})):(n&&this.map._getMap().off(e,n),this.map._getMap().on(e,o)))},Px.prototype.invoke=function(e,t,r){if(void 0===r)this._invokeListeners(e,"",t);else if(t instanceof ed&&ed._isMBoxEvent(e))this._invokeListeners(e,t.getId(),r);else{if(!(t instanceof $t))throw new Error("The invoke target is invalid.");t._invokeEvent(e,r)}},Px.prototype._invokeListeners=function(r,i,n){var o=this,e=new Yt(this.mapCallbackHandler.getEventCallbacks(r,i));e?e.forEach(function(e,t){e=Ix(e,2);e[0],e[1]&&o._removeListener(r,i,t),t(n)}):"error"===r&&console.error("error"in n?n.error:n)},Px.prototype.remove=function(e,t,r){var i,n;if("function"==typeof t)this._removeListener(e,"",t);else{t=Array.isArray(t)?t:[t];try{for(var o=Ex(t),a=o.next();!a.done;a=o.next()){var s=a.value;s instanceof ed&&ed._isMBoxEvent(e)?this._removeListener(e,s,r):null!=s&&s._removeEventListener(e,r)}}catch(e){i={error:e}}finally{try{a&&!a.done&&(n=o.return)&&n.call(o)}finally{if(i)throw i.error}}}},Px.prototype._removeLegacy=function(e,t,r){"function"==typeof t?this._removeListener(e,"",t):this._removeListener(e,t,r)},Px.prototype._removeListener=function(e,t,r){var i,n;if(Ax.includes(e))this.map._removeEventListener(e,r);else{var t=t instanceof ed?t.getId():t,o=this.mapCallbackHandler.getModifiedCallback(e,t,r);if(o)if(t){var a=this.map.layers.getLayerById(t);if(a)try{for(var s=Ex(a._getLayerIds()),l=s.next();!l.done;l=s.next()){var c=l.value;this.map._getMap().off(e,c,o)}}catch(e){i={error:e}}finally{try{l&&!l.done&&(n=s.return)&&n.call(s)}finally{if(i)throw i.error}}}else this.map._getMap().off(e,o);this.mapCallbackHandler.removeCallback(e,t,r)}},Px.prototype._enableLayerEvents=function(l){var c=this,e=this.mapCallbackHandler.getLayerCallbacks(l.getId());e&&e.forEach(function(e,s){e.forEach(function(e){var t,r,i=Ix(e,1)[0];try{for(var n=Ex(l._getLayerIds()),o=n.next();!o.done;o=n.next()){var a=o.value;c.map._getMap().on(s,a,i)}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}})})},Px.prototype._disableLayerEvents=function(l){var c=this,e=this.mapCallbackHandler.getLayerCallbacks(l.getId());e&&e.forEach(function(e,s){e.forEach(function(e){var t,r,i=Ix(e,1)[0];try{for(var n=Ex(l._getLayerIds()),o=n.next();!o.done;o=n.next()){var a=o.value;c.map._getMap().off(s,a,i)}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}})})},Px);function Px(e){this.map=e,this.mapCallbackHandler=new Tx(this.map)}var Mx=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Rx=(Ox.prototype.add=function(e,t){var r,i;if(Array.isArray(e))try{for(var n=Mx(e),o=n.next();!o.done;o=n.next()){var a=o.value;this._addMarker(a,t)}}catch(e){r={error:e}}finally{try{o&&!o.done&&(i=n.return)&&i.call(n)}finally{if(r)throw r.error}}else this._addMarker(e,t)},Ox.prototype._addMarker=function(e,t){e._addToMap(this.map,t),this.markers.add(e)},Ox.prototype.getMarkers=function(){return Array.from(this.markers)},Ox.prototype.remove=function(e){var t,r;if(Array.isArray(e))try{for(var i=Mx(e),n=i.next();!n.done;n=i.next()){var o=n.value;this._removeMarker(o)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}else this._removeMarker(e)},Ox.prototype._removeMarker=function(t){var r=this;t instanceof gf?(t._removeFromMap(),this.markers.delete(t)):this.markers.forEach(function(e){e._getId()===t&&(e._removeFromMap(),r.markers.delete(e))})},Ox.prototype.clear=function(){var t=this;this.markers.forEach(function(e){e._removeFromMap(),t.markers.delete(e)})},Ox);function Ox(e){this.markers=new Set,this.map=e}Dx.prototype.add=function(a,t,s){var l=this;return new Promise(function(r,i){var n,e,o;l.userImages.has(a)?r():t instanceof HTMLImageElement||t instanceof ImageData?(l.map._getMap().addImage(a,t,s),l.userImages.set(a,{image:t,meta:s}),r()):"string"==typeof t&&(e=void 0,e=/<svg/i.test(t)&&!/^data:/i.test(t)?"data:image/svg+xml;base64,"+window.btoa(t):t,o=!1,l.map._sendRequest(e,"Image").then(function(e){return o?void 0:e.blob()}).then(function(e){var t;!o&&e&&(clearTimeout(n),(t=new Image).onload=function(){l.map._getMap().addImage(a,t,s),l.userImages.set(a,{image:t,meta:s}),r()},t.onerror=t.onabort=function(){i("Failed to load image into HTML element.")},t.src=URL.createObjectURL(e))}).catch(function(){o||(clearTimeout(n),i("Failed to load image into HTML element."))}),n=setTimeout(function(){o=!0,i("Failed to load image within specified timeout: ".concat(l.imageLoadTimeout," ms."))},l.imageLoadTimeout))})},Dx.prototype.clear=function(){var r=this;this.userImages.forEach(function(e,t){r.map._getMap().removeImage(t)}),this.userImages.clear()},Dx.prototype.getImageIds=function(){var r=[];return this.userImages.forEach(function(e,t){r.push(t)}),r},Dx.prototype.createFromTemplate=function(e,t,r,i,n){r=r||"#1A73AA",i=i||"#fff";t=(t=kt(t,n)).replace(/{color}/g,r).replace(/{secondaryColor}/g,i).replace(/{text}/g,"");return this.add(e,t)},Dx.prototype.hasImage=function(e){return this.userImages.has(e)},Dx.prototype.remove=function(e){this.map._getMap().removeImage(e),this.userImages.delete(e)},Dx.prototype._restoreImages=function(){var r=this;this.userImages.forEach(function(e,t){r.map._getMap().hasImage(t)||r.map._getMap().addImage(t,e.image,e.meta)})};var Lx=Dx;function Dx(e){this.userImages=new Yt,this.imageLoadTimeout=5e3,this.map=e}var zx,Nx,e=window&&window.__extends||(zx=function(e,t){return(zx=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}zx(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Bx=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Fx=(e(Ux,Nx=ed),Ux.prototype.getOptions=function(){return{}},Ux.prototype.setOptions=function(e){},Ux.prototype._buildLayers=function(){return this.layers},Ux.prototype._getLayerIds=function(){return this.layers.map(function(e){return e.id})},Ux.prototype._getSourceIds=function(){var t,e,r=new Set;try{for(var i=Bx(this.layers),n=i.next();!n.done;n=i.next()){var o=n.value;"source"in o&&"string"==typeof o.source?r.add(o.source):"source"in o&&o.source&&r.add(o.id)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(e=i.return)&&e.call(i)}finally{if(t)throw t.error}}return r},Ux.prototype._updateLayoutProperty=function(t,r,e,i){var n;Jl(r,e)||(n=this.map._getMap(),this.layers.forEach(function(e){n.getLayer(e.id)?n.setLayoutProperty(e.id,t,i||r):console.warn("Could not update layout property ".concat(t," for layer ").concat(e.id," to ").concat(i||r))}))},Ux);function Ux(e,t){t=Nx.call(this,t)||this;return t.layers=e,t}var qx=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},jx=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},Hx=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},Vx=(Gx.prototype.add=function(e,t){var r,i,n=t instanceof ed?t.getId():t;if(Array.isArray(e))try{for(var o=qx(e),a=o.next();!a.done;a=o.next()){var s=a.value;this._addLayer(s,n)}}catch(e){r={error:e}}finally{try{a&&!a.done&&(i=o.return)&&i.call(o)}finally{if(r)throw r.error}}else this._addLayer(e,n)},Gx.prototype._addLayer=function(t,r){if(!(this.map._isReady()||t instanceof Fx))throw new Error("The layer '".concat(t.getId(),"' could not be added to the map because ")+"the map is not ready. Please use a ready event listener to guarantee the map is ready before adding a layer to it.");var e,i,n,o;r!==t.getId()&&this.layerIndex.find(function(e){return r===e.getId()})?this._getMapboxLayerExists(t)?(i=this.layerIndex.findIndex(function(e){return e.getId()===t.getId()}),n=this.userLayers.findIndex(function(e){return e.layer.getId()===t.getId()}),this._removeMapboxLayers(t),this._addMapboxLayers(t,r),(o=this.layerIndex[i])&&this.map.events._disableLayerEvents(o),this.map.events._enableLayerEvents(t),this.layerIndex.splice(i,1),e=this.layerIndex.findIndex(function(e){return e.getId()===r}),this.layerIndex.splice(e,0,t),t instanceof Fx||(this.userLayers[n]={layer:t,before:r}),o&&o.onRemove()):(this._addMapboxLayers(t,r),this.map.events._enableLayerEvents(t),e=this.layerIndex.findIndex(function(e){return e.getId()===r}),this.layerIndex.splice(e,0,t),t instanceof Fx||this.userLayers.push({layer:t,before:r})):(i=this.layerIndex.findIndex(function(e){return e.getId()===t.getId()}),n=this.userLayers.findIndex(function(e){return e.layer.getId()===t.getId()}),0<=i&&0<=n?(o=this.layerIndex[i],this._removeMapboxLayers(o),this._addMapboxLayers(t,i+1),this.map.events._disableLayerEvents(o),this.map.events._enableLayerEvents(t),(this.layerIndex[i]=t)instanceof Fx||(this.userLayers[n]={layer:t,before:void 0}),o.onRemove()):(this._addMapboxLayers(t),this.map.events._enableLayerEvents(t),this.layerIndex.push(t),t instanceof Fx||this.userLayers.push({layer:t,before:r}))),t.onAdd(this.map)},Gx.prototype._addMapboxLayers=function(e,t){var r,i;if(!(e instanceof Fp)||e.getOptions().tileUrl){if(!(e instanceof Fx)){e instanceof Od&&(this.map._getMap().addSource(e._getSourceId(),e._buildSource()),this.map.sources.setSourceState(e._getSourceWrapper()));var n=this._getMapboxBefore(t);try{for(var o=qx(e._buildLayers()),a=o.next();!a.done;a=o.next()){var s=a.value;this.map._getMap().addLayer(s,n)}}catch(e){r={error:e}}finally{try{a&&!a.done&&(i=o.return)&&i.call(o)}finally{if(r)throw r.error}}}this.map.events._enableLayerEvents(e)}},Gx.prototype._removeMapboxLayers=function(e,t){var r,i;if(e instanceof Fx&&!t)this.map.events._disableLayerEvents(e);else{try{for(var n=qx(e._getLayerIds()),o=n.next();!o.done;o=n.next()){var a=o.value;this.map._getMap().getLayer(a)&&this.map._getMap().removeLayer(a)}}catch(e){r={error:e}}finally{try{o&&!o.done&&(i=n.return)&&i.call(n)}finally{if(r)throw r.error}}this.map.events._disableLayerEvents(e),e instanceof Od&&this.map._getMap().getSource(e._getSourceId())&&this.map._getMap().removeSource(e._getSourceId())}},Gx.prototype._getMapboxLayerExists=function(t){var r=this,i=!1;return"string"==typeof t?!!(t=this.layerIndex.find(function(e){return e.getId()===t})):(t._getLayerIds().forEach(function(e){r.map._getMap().getLayer(e)&&(i=!0)}),i)},Gx.prototype._getMapboxBefore=function(t){var r,e,i,n;if("string"==typeof t){var o=this.layerIndex.find(function(e){return e.getId()===t});if(!o)return;try{for(var a=qx(o._getLayerIds()),s=a.next();!s.done;s=a.next()){var l=s.value;if(this.map._getMap().getLayer(l))return l}}catch(e){r={error:e}}finally{try{s&&!s.done&&(e=a.return)&&e.call(a)}finally{if(r)throw r.error}}t=this.layerIndex.findIndex(function(e){return e.getId()===t})+1}for(var c=t;c<this.layerIndex.length;c++)try{i=void 0;for(var u=qx(this.layerIndex[c]._getLayerIds()),h=u.next();!h.done;h=u.next()){l=h.value;if(this.map._getMap().getLayer(l))return l}}catch(e){i={error:e}}finally{try{h&&!h.done&&(n=u.return)&&n.call(u)}finally{if(i)throw i.error}}},Gx.prototype.clear=function(){for(var e=this.layerIndex.length-1;0<=e;e--){var t=this.layerIndex[e];t&&(this._removeMapboxLayers(t,!0),this.layerIndex.splice(e,1),t.onRemove())}this.userLayers=[]},Gx.prototype.getLayerById=function(t){var e=this.layerIndex.find(function(e){return e.getId()===t});if(e)return e},Gx.prototype.getLayers=function(){return this.layerIndex.slice(0)},Gx.prototype._getSourceIds=function(){var t,e,r=new Set;try{for(var i=qx(this.layerIndex),n=i.next();!n.done;n=i.next())n.value._getSourceIds().forEach(function(e){return r.add(e)})}catch(e){t={error:e}}finally{try{n&&!n.done&&(e=i.return)&&e.call(i)}finally{if(t)throw t.error}}return r},Gx.prototype._getUserLayers=function(){return Array.from(this.userLayers)},Gx.prototype.move=function(e,t){var r=e instanceof ed?e.getId():e,i=t instanceof ed?t.getId():t;if(!this.layerIndex.find(function(e){return e.getId()===r}))throw new Error("The layer '".concat(r,"' has not been added to the map and cannot be moved."));t=this.layerIndex.findIndex(function(e){return e.getId()===r}),this._moveMapboxLayers(this.layerIndex[t],i),e=this.layerIndex[t],this.layerIndex.splice(t,1),t=this.layerIndex.findIndex(function(e){return e.getId()===i}),-1<t?this.layerIndex.splice(t,0,e):this.layerIndex.push(e),t=this.userLayers.find(function(e){return e.layer.getId()===r});t&&(t.before=i)},Gx.prototype._moveMapboxLayers=function(e,t){var r,i,n=this._getMapboxBefore(t);try{for(var o=qx(e._getLayerIds()),a=o.next();!a.done;a=o.next()){var s=a.value;this.map._getMap().moveLayer(s,n)}}catch(e){r={error:e}}finally{try{a&&!a.done&&(i=o.return)&&i.call(o)}finally{if(r)throw r.error}}},Gx.prototype.getRenderedShapes=function(e,t,r){var i,n,o,a=this;if(e=e||[-180,-85.0511,180,85.0511],Array.isArray(e)?4===e.length||6===e.length?o=this.map.positionsToPixels([f.getSouthWest(e),f.getNorthEast(e)]):2!==e.length&&3!==e.length||(o=this.map.positionsToPixels([e])[0]):o=this.map.positionsToPixels([e.coordinates])[0],t){t=Array.isArray(t)?t:[t];var s=[],l=this;try{for(var c=qx(t),u=c.next();!u.done;u=c.next())!function(e){var t=e instanceof ed?e.getId():e,e=l.layerIndex.findIndex(function(e){return e.getId()===t});if(!(-1<e))throw new Error("The layer '".concat(t,"' has not been added to the map ")+"and its rendered features cannot be retrieved.");s.push.apply(s,Hx([],jx(l.layerIndex[e]._getLayerIds().filter(function(e){return!!a.map._getMap().getLayer(e)})),!1))}(u.value)}catch(e){i={error:e}}finally{try{u&&!u.done&&(n=c.return)&&n.call(c)}finally{if(i)throw i.error}}}e=this.map._getMap().queryRenderedFeatures(o,{layers:s,filter:r});return this.map.sources._mapFeaturesToShapes(e)},Gx.prototype.remove=function(e){var t,r;if(Array.isArray(e))try{for(var i=qx(e),n=i.next();!n.done;n=i.next()){var o=n.value;this._removeLayer(o)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}else this._removeLayer(e)},Gx.prototype._removeLayer=function(e){var t=e instanceof ed?e.getId():e,r=this.layerIndex.findIndex(function(e){return e.getId()===t});if(-1==r)throw new Error("The layer '".concat(t,"' has not been added to the map and cannot be removed."));var i=this.layerIndex[r],r=(this._removeMapboxLayers(i),this.layerIndex.splice(r,1),this.userLayers.findIndex(function(e){return e.layer.getId()===t}));-1!=r&&this.userLayers.splice(r,1),e instanceof Od&&this.map.sources.unsetSourceState(e._getSourceId()),i.onRemove()},Gx);function Gx(e){this.layerIndex=[],this.userLayers=[],this.map=e}var Kx=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Zx=(Wx.prototype.add=function(e){var t,r;e=Array.isArray(e)?e:[e];try{for(var i=Kx(e),n=i.next();!n.done;n=i.next()){var o=n.value;this.popups.has(o)||(this.popups.add(o),o.attach(this.map))}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}},Wx.prototype.clear=function(){var t=this;this.popups.forEach(function(e){t.popups.delete(e),e.remove()})},Wx.prototype.remove=function(e){var t,r;e=Array.isArray(e)?e:[e];try{for(var i=Kx(e),n=i.next();!n.done;n=i.next()){var o=n.value;this.popups.has(o)&&(this.popups.delete(o),o.remove())}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}},Wx.prototype.getPopups=function(){return Array.from(this.popups)},Wx.prototype._getCollectionDiv=function(){var e=this.map.getMapContainer().querySelector(".".concat(Wx.Css.collection));return e||((e=document.createElement("div")).classList.add(Wx.Css.collection),e.setAttribute("aria-label","Map Information"),this.map.getMapContainer().appendChild(e)),e},Wx.prototype._addDraggedPopup=function(e){0===this.draggedPopups.size&&(this.map.getMapContainer().addEventListener("mousemove",this._onDrag),this.map.getMapContainer().addEventListener("touchmove",this._onDrag),this.map.getMapContainer().addEventListener("mouseup",this._onUp),this.map.getMapContainer().addEventListener("touchend",this._onUp)),this.draggedPopups.add(e)},Wx.Css={collection:"popup-collection-container"},Wx);function Wx(e){var i=this;this._onDrag=function(e){var t,r;"mousemove"===e.type?(t=e.clientX,r=e.clientY):"touchmove"===e.type&&(t=e.touches[0].clientX,r=e.touches[0].clientY),i.draggedPopups.forEach(function(e){e._dragToPixel([t,r])})},this._onUp=function(){i.map.getMapContainer().removeEventListener("mousemove",i._onDrag),i.map.getMapContainer().removeEventListener("touchmove",i._onDrag),i.map.getMapContainer().removeEventListener("mouseup",i._onUp),i.map.getMapContainer().removeEventListener("touchend",i._onUp),i.draggedPopups.forEach(function(e){i.draggedPopups.delete(e),e._onUp()})},this.map=e,this.popups=new Set,this.draggedPopups=new Set}var Yx=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},$x=(Xx.prototype.add=function(e,t){var r,i;if(void 0===t&&(t=!0),Array.isArray(e))try{for(var n=Yx(e),o=n.next();!o.done;o=n.next()){var a=o.value;this._addSource(a,t)}}catch(e){r={error:e}}finally{try{o&&!o.done&&(i=n.return)&&i.call(n)}finally{if(r)throw r.error}}else this._addSource(e,t)},Xx.prototype.getRenderedShapes=function(e,t,r){e="string"==typeof e?e:e.getId(),r=this.map._getMap().querySourceFeatures(e,{sourceLayer:r,filter:t});return this.map.sources._mapFeaturesToShapes(r,!0,this.sources.get(e))},Xx.prototype.getFeatureState=function(e,t,r){e="string"==typeof e?e:e instanceof vu?e.getId():e.id,t="string"==typeof t?t:t.getId();return this.map._getMap().getFeatureState({id:e,source:t,sourceLayer:r})},Xx.prototype.removeFeatureState=function(e,t,r,i){e="string"==typeof e?e:e instanceof vu?e.getId():e.id,t="string"==typeof t?t:t.getId();this.map._getMap().removeFeatureState({id:e,source:t,sourceLayer:r},i)},Xx.prototype.setFeatureState=function(e,t,r,i){e="string"==typeof e?e:e instanceof vu?e.getId():e.id,t="string"==typeof t?t:t.getId();this.map._getMap().setFeatureState({id:e,source:t,sourceLayer:i},r)},Xx.prototype._buildSources=function(){var t={};return this.sources.forEach(function(e){t[e.getId()]=e._buildSource()}),t},Xx.prototype.clear=function(){var t=this;this.sources.forEach(function(e){t.remove(e)})},Xx.prototype.getById=function(e){return this.sources.get(e)},Xx.prototype.getSources=function(){return Array.from(this.sources.values())},Xx.prototype.isSourceLoaded=function(e){e=e instanceof uh?e.getId():e;return this.map._getMap().isSourceLoaded(e)},Xx.prototype.remove=function(e,t){var r,i;if(void 0===t&&(t=!0),Array.isArray(e))try{for(var n=Yx(e),o=n.next();!o.done;o=n.next()){var a=o.value;this._removeSource(a,t)}}catch(e){r={error:e}}finally{try{o&&!o.done&&(i=n.return)&&i.call(n)}finally{if(r)throw r.error}}else this._removeSource(e,t)},Xx.prototype.setSourceState=function(e,t){void 0===t&&(t=!0),this.sources.set(e.getId(),e),e._setMap(this.map,t)},Xx.prototype.unsetSourceState=function(e){this.sources.has(e)&&(this.sources.get(e)._setMap(null),this.sources.delete(e))},Xx.prototype._removeSource=function(e,t){e=e instanceof uh?e.getId():e;if(!this.sources.has(e))throw new Error("'".concat(e,"' is not added to the map"));if(this.map._getMap().getSource(e)&&t&&this.map._getMap().removeSource(e),this.map._getMap().getSource(e)&&t)throw new Error("One or more layers have a dependency on the source '".concat(e,"'"));this.unsetSourceState(e)},Xx.prototype._addSource=function(e,t){if(this.sources.has(e.getId())){if(t)throw new Error("'".concat(e.getId(),"' is already added to the map"));this.unsetSourceState(e.getId())}if(t){if(!this.map._isReady())throw new Error("The source '".concat(e.getId(),"' could not be added to the map because ")+"the map is not ready. Please use a ready event listener to guarantee the map is ready before adding a source to it.");this.map._getMap().addSource(e.getId(),e._buildSource())}this.setSourceState(e)},Xx.prototype._mapFeaturesToShapes=function(e,t,r){var i,n,o=[];try{for(var a=Yx(e),s=a.next();!s.done;s=a.next()){var l=s.value;if((r||"string"==typeof l.source)&&"string"==typeof l.properties[vu._shapeIdPropName]){var c=r||this.sources.get(l.source);if(c instanceof mh){var u=c.getShapeById(l.properties[vu._shapeIdPropName]);if(u instanceof vu){o.push(u);continue}}}t||o.push(l)}}catch(e){i={error:e}}finally{try{s&&!s.done&&(n=a.return)&&n.call(a)}finally{if(i)throw i.error}}return o},Xx.prototype._syncSources=function(n){var i=this;n?(Object.keys(n).map(function(e){var t,r=n[e];switch(r.type){case"vector":case"raster":case"raster-dem":t=new kp(e,{name:e,tiles:r.tiles,type:r.type,url:r.url,tileSize:"tileSize"in r?r.tileSize:void 0});break;case"canvas":t=new Ih(e,r);break;case"geojson":var i=new mh(e,{maxZoom:r.maxzoom,cluster:r.cluster,clusterRadius:r.clusterRadius,tolerance:r.tolerance,lineMetrics:r.lineMetrics,clusterProperties:r.clusterProperties,buffer:r.buffer,clusterMinPoints:r.clusterMinPoints,generateId:r.generateId,promoteId:r.promoteId,filter:r.filter});"string"!=typeof r.data&&void 0!==r.data&&i._addNoUpdate(r.data),t=i;break;case"image":t=new Dh(e,r);break;case"video":t=new Fh(e,r);break;default:t=new Mh(e,r)}return t}).forEach(function(e){var t=i.sources.get(e.getId()),r=t&&e._isDeepEqual(t);!r&&t&&i.unsetSourceState(t.getId()),i.setSourceState(e,!r)}),Array.from(this.sources.keys()).filter(function(e){return!(e in n)}).forEach(function(e){return i.unsetSourceState(e)})):console.warn("syncSources called with no style sources which is unexpected.")},Xx);function Xx(e){this.map=e,this.sources=new Yt}(window&&window.__extends||(Jx=function(e,t){return(Jx=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Jx(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(t1,Qx=ye);var Jx,Qx,e1=t1;function t1(){var e=null!==Qx&&Qx.apply(this,arguments)||this;return e.duration=1e3,e.type="jump",e}(window&&window.__extends||(r1=function(e,t){return(r1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}r1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(o1,i1=ye);var r1,i1,n1=o1;function o1(){var e=null!==i1&&i1.apply(this,arguments)||this;return e.bottom=0,e.left=0,e.right=0,e.top=0,e}var a1,s1,qi=window&&window.__extends||(a1=function(e,t){return(a1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}a1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),l1=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},c1=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},u1=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},h1=(qi(d1,s1=ye),d1.prototype.merge=function(){for(var t,e,r=[],i=0;i<arguments.length;i++)r[i]=arguments[i];try{for(var n=l1(r),o=n.next();!o.done;o=n.next()){var a=o.value;a&&"number"==typeof a.padding&&(a.padding={top:a.padding,bottom:a.padding,left:a.padding,right:a.padding})}}catch(e){t={error:e}}finally{try{o&&!o.done&&(e=n.return)&&e.call(n)}finally{if(t)throw t.error}}return s1.prototype.merge.apply(this,u1([],c1(r),!1))},d1);function d1(){var e=null!==s1&&s1.apply(this,arguments)||this;return e.bounds=[-180,-89,180,90],e.maxBounds=void 0,e.maxZoom=20,e.offset=new ic(0,0),e.padding=new n1,e}(window&&window.__extends||(p1=function(e,t){return(p1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}p1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(g1,f1=ye);var p1,f1,m1=g1;function g1(){var e=null!==f1&&f1.apply(this,arguments)||this;return e.zoom=1,e.center=new hu(0,0),e.centerOffset=new ic(0,0),e.bearing=0,e.pitch=0,e.minZoom=1,e.maxZoom=20,e.minPitch=0,e.maxPitch=60,e.maxBounds=void 0,e}(window&&window.__extends||(y1=function(e,t){return(y1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}y1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(_1,v1=ye);var y1,v1,i=_1;function _1(){var e=null!==v1&&v1.apply(this,arguments)||this;return e.name=void 0,e.before=void 0,e.minZoom=1,e.maxZoom=20,e.overwrite=!1,e.opacity=1,e}(window&&window.__extends||(b1=function(e,t){return(b1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}b1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(C1,w1=i);var b1,w1,x1=C1;function C1(){var e=null!==w1&&w1.apply(this,arguments)||this;return e.color="rgba(0,0,0,.5)",e.outlineColor="#000",e.radius=1,e.outlineWidth=5,e.name="default-circles",e}(window&&window.__extends||(T1=function(e,t){return(T1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}T1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(I1,S1=i);var T1,S1,E1=I1;function I1(){var e=null!==S1&&S1.apply(this,arguments)||this;return e.cap="butt",e.join="miter",e.name="default-linestrings",e.color="#000",e.width=1,e}(window&&window.__extends||(A1=function(e,t){return(A1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}A1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(M1,k1=i);var A1,k1,P1=M1;function M1(){var e=null!==k1&&k1.apply(this,arguments)||this;return e.iconSize=1,e.fontSize=14,e.fontColor="#000",e.textFont="SegoeUi-Regular",e.cluster=!0,e.clusterIcon=void 0,e.textOffset=[0,0],e.name="default-pins",e.icon="pin-darkblue",e.title="",e}(window&&window.__extends||(R1=function(e,t){return(R1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}R1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(D1,O1=i);var R1,O1,L1=D1;function D1(){var e=null!==O1&&O1.apply(this,arguments)||this;return e.color="rgba(0,0,0,.5)",e.outlineColor="#000",e.name="default-polygons",e}(window&&window.__extends||(z1=function(e,t){return(z1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}z1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(F1,N1=i);var z1,N1,B1=F1;function F1(){var e=null!==N1&&N1.apply(this,arguments)||this;return e.name="default-raster",e}(window&&window.__extends||(U1=function(e,t){return(U1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}U1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}))(H1,q1=ye);var U1,q1,j1=H1;function H1(){var e=null!==q1&&q1.apply(this,arguments)||this;return e.anchor="map",e.color="#FFFFFF",e.intensity=.5,e.position=[1.15,210,30],e}var V1,G1,we=window&&window.__extends||(V1=function(e,t){return(V1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}V1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),K1=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},Z1=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},W1=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},Y1=(we($1,G1=ye),$1.prototype.merge=function(){for(var t,e,r=[],i=0;i<arguments.length;i++)r[i]=arguments[i];try{for(var n=K1(r),o=n.next();!o.done;o=n.next()){var a=o.value;a&&(a.hasOwnProperty("view")?a.userRegion=a.view:a.hasOwnProperty("userRegion")&&(a.view=a.userRegion),"string"==typeof a.language)&&(a.language=Me.getCode(a.language))}}catch(e){t={error:e}}finally{try{o&&!o.done&&(e=n.return)&&e.call(n)}finally{if(t)throw t.error}}return G1.prototype.merge.apply(this,W1([],Z1(r),!1))},$1);function $1(){var e=null!==G1&&G1.apply(this,arguments)||this;return e.antialias=void 0,e.autoResize=!0,e.language=Ge,e.light=new j1,e.preserveDrawingBuffer=!1,e.progressiveLoading=!1,e.progressiveLoadingInitialLayerGroups=["base"],e.renderWorldCopies=!0,e.showBuildingModels=!1,e.showFeedbackLink=!0,e.showLogo=!0,e.showLabels=!0,e.customAttribution=void 0,e.showTileBoundaries=!1,e.style=void 0,e.view=Ve,e.userRegion=e.view,e.styleOverrides=void 0,e.customStyleTransform=void 0,e}function X1(e){return 0==e.length?void 0:e.slice(1).reduce(function(r,i){return function(e,t){e=r(e,t);return eC(eC({},e),i(e.url,t))}},e[0])}var J1,Q1,Ro=window&&window.__extends||(J1=function(e,t){return(J1=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}J1(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),eC=window&&window.__assign||function(){return(eC=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},tC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},rC=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},iC=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},nC=(Ro(oC,Q1=ye),oC.prototype.merge=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=this.styleDefinitionsVersion;try{for(var i=tC(e),n=i.next();!n.done;n=i.next()){var o=n.value;o&&(o.authOptions?"string"==typeof o.authOptions.subscriptionKey&&(o.subscriptionKey=o["subscription-key"]=o.authOptions.subscriptionKey):"string"==typeof o.subscriptionKey?(o["subscription-key"]=o.subscriptionKey,o.authOptions={authType:u.AuthenticationType.subscriptionKey,subscriptionKey:o.subscriptionKey}):"string"==typeof o["subscription-key"]&&(o.subscriptionKey=o["subscription-key"],o.authOptions={authType:u.AuthenticationType.subscriptionKey,subscriptionKey:o["subscription-key"]}),"string"==typeof o.sessionId?o["session-id"]=o.sessionId:"string"==typeof o["session-id"]&&(o.sessionId=o["session-id"]),"boolean"==typeof o.disableTelemetry?o["disable-telemetry"]=o.disableTelemetry:"boolean"==typeof o["disable-telemetry"]&&(o.disableTelemetry=o["disable-telemetry"]),"boolean"==typeof o.enableAccessibility?o["enable-accessibility"]=o.enableAccessibility:"boolean"==typeof o["enable-accessibility"]&&(o.enableAccessibility=o["enable-accessibility"]))}}catch(e){l={error:e}}finally{try{n&&!n.done&&(s=i.return)&&s.call(i)}finally{if(l)throw l.error}}var a=this._transformers,s=e?e.filter(function(e){return void 0!==e}).reduce(function(e,t){return iC(iC([],rC(e),!1),rC(t._transformers||[]),!1)},[]):[],l=Q1.prototype.merge.apply(this,iC([],rC(e),!1)),s=(l.authOptions.authType!==u.AuthenticationType.subscriptionKey&&(l["subscription-key"]=l.subscriptionKey=void 0),void 0!==l.styleSet&&void 0===l.mapConfiguration&&(l.mapConfiguration=l.styleSet),l.mapConfiguration&&"string"!=typeof l.mapConfiguration&&(l.mapConfiguration=eC(eC({},l.mapConfiguration),{defaultConfiguration:l.mapConfiguration.defaultConfiguration||l.mapConfiguration.defaultStyle,configurations:l.mapConfiguration.configurations||l.mapConfiguration.styles})),this._transformers=iC(iC([],rC(a||[]),!1),rC(s.filter(function(e){return!a.includes(e)})),!1),this.transformRequest&&!this._transformers.includes(this.transformRequest)&&this._transformers.push(this.transformRequest),new Date(Date.UTC(2023,0))),c=new Date(this.styleDefinitionsVersion);return(isNaN(c.getTime())||c.getTime()<s.getTime())&&(console.warn("Style definition version ".concat(this.styleDefinitionsVersion," is invalid or deprecated, style definition version is unchanged (").concat(r,")")),this.styleDefinitionsVersion=r),this.transformRequest=X1(this._transformers),l},oC.prototype.addTransformer=function(e){this._transformers||(this._transformers=[]),this._transformers.push(e),this.transformRequest=X1(this._transformers)},oC.prototype.removeTransformer=function(t){this._transformers&&(this._transformers=this._transformers.filter(function(e){return t!==e}),this.transformRequest=X1(this._transformers))},oC._cloneCustomizer=function(e){if("object"==typeof e)return Object.assign({},e)},oC);function oC(){var e=null!==Q1&&Q1.apply(this,arguments)||this;return e.authOptions=lt(),e.disableTelemetry=!0,e["disable-telemetry"]=e.disableTelemetry,e.domain=Ze,e.staticAssetsDomain=We,e.styleDefinitionsPath=Ye,e.styleDefinitionsVersion=$e,e.styleAPIVersion=Xe,e.mapConfiguration=void 0,e.styleSet=void 0,e.enableAccessibility=!0,e["enable-accessibility"]=e.enableAccessibility,e.enableAccessibilityLocationFallback=!0,e.maxParallelImageRequests=mt(),e.refreshExpiredTiles=!0,e.subscriptionKey=vt(),e["subscription-key"]=e.subscriptionKey,e.sessionId=Ke,e["session-id"]=e.sessionId,e._transformers=[],e.transformRequest=void 0,e.workerCount=ft(),e.fadeDuration=300,e.localIdeographFontFamily="sans-serif",e.validateStyle=!1,e}sC.getLayerGroup=function(e){return"string"!=typeof e&&e.metadata&&e.metadata["microsoft.maps:layerGroup"]?e.metadata["microsoft.maps:layerGroup"]:(e="string"!=typeof e?e.id:e).startsWith("microsoft.")&&4<=(e=e.split(".")).length?e[3]:void 0};var aC=sC;function sC(){}cC.resolve=function(e){return new cC(Promise.resolve(e))},cC.reject=function(e){return new cC(Promise.reject(e))},cC.prototype.then=function(e,t){var r=this;return new Promise(function(e,t){r._resolve=e,r._reject=t,r._thenResolver(e,t)}).then(e,t)},cC.prototype.catch=function(e){var r=this;return new Promise(function(e,t){r._resolve=e,r._reject=t,r._thenResolver(e,t)}).catch(e)},cC.prototype.finally=function(e){var r=this;return new Promise(function(e,t){r._resolve=e,r._reject=t,r._thenResolver(e,t)}).finally(e)},cC.prototype.hijackAndResolve=function(e){this._hijackedToResolve=e,this._resolve&&this._resolve(e)},cC.prototype.hijackAndReject=function(e){this._hijackedToReject=e,this._reject&&this._reject(e)},cC.prototype.switchWith=function(e){this.origin=e,this._toResolve=void 0,this._toReject=void 0};var lC=cC;function cC(e){var n=this;this.isHijacked=function(){return void 0!==n._hijackedToResolve||void 0!==n._hijackedToReject},this.isResolved=function(){return void 0!==n._hijackedToResolve||void 0!==n._toResolve},this.isRejected=function(){return void 0!==n._hijackedToReject||void 0!==n._toReject},this.resultIfResolved=function(){return n._hijackedToResolve||n._toResolve},this.errorIfRejected=function(){return n._hijackedToReject||n._toReject},this._thenResolver=function(t,r){var i;n._hijackedToResolve?t(n._hijackedToResolve):n._hijackedToReject?r(n._hijackedToReject):(i=n.origin,n.origin.then(function(e){n.isHijacked()||(i!==n.origin?n._thenResolver(t,r):(n._toResolve=e,t(e)))}).catch(function(e){n.isHijacked()||(i!==n.origin?n._thenResolver(t,r):(n._toReject=e,r(e)))}))},this.origin=e,this[Symbol.toStringTag]=this.origin[Symbol.toStringTag]}var uC={road:"Road",satellite:"Satellite",satellite_road_labels:"Hybrid",grayscale_dark:"Grayscale (Dark)",grayscale_light:"Grayscale (Light)",night:"Night",road_shaded_relief:"Terra",blank:"Blank",blank_accessible:"Blank (Accessible)",high_contrast_dark:"High contrast (Dark)",high_contrast_light:"High contrast (Light)"},hC=window&&window.__assign||function(){return(hC=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},dC=window&&window.__awaiter||function(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})},pC=window&&window.__generator||function(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},c={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c;function e(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l=c&&t[c=0]?0:l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},fC=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},mC=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},gC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},yC={countryRegion:"cr|bv:0",adminDistrict:"ad|bv:0",adminDistrict2:"ds|bv:0",buildingFootprint:"bld|v:0_adr|lv:0",roadDetails:"g|rasterDetailsVisible:0"},vC=(_C.prototype.updateIndoorState=function(e,t){var r,i,n=this,o=this.map.styles.getMapConfiguration();o?(this.preservedPreindoorMapConfiguration=o,r=this.map.getStyle().style?"".concat(this.map.getStyle().style,"_indoor").concat("dark"===e?"_dark":"","_tileset_").concat(t):void 0,this.map.styles.setMapConfiguration("defaultIndoor_".concat(t),"microsoft-maps:default"===o?r:void 0)):(i=(null==(o=this.indoorState)?void 0:o.tilesetId)!==t,this.indoorState={tilesetId:t,theme:e},this.initStyleset(),this.definitions().then(function(e){var t=(n.map.getStyle().style||e.defaultConfiguration).replace("_indoor_dark","").replace("_indoor",""),r="".concat(t,"_indoor"),t=e.configurations.find(function(e){return e.name.startsWith(r)});t&&n.map.setStyle({style:t.name},!i)}))},_C.prototype.unsetIndoorState=function(){var r=this,e=this.preservedPreindoorMapConfiguration;e?this.map.styles.setMapConfiguration(e):(this.indoorState=void 0,this.initStyleset(),this.definitions().then(function(e){var t=r.map.getStyle().style;t.includes("_indoor")&&t.split("_indoor")[0]?r.map.setStyle({style:t.split("_indoor")[0]}):r.map.setStyle({style:void 0})}))},_C.prototype.initStyleset=function(){var e,r=this;return e=this.serviceOptions.mapConfiguration?"string"==typeof this.serviceOptions.mapConfiguration?(e=this.map.authentication?this.map.authentication.initialize():Promise.resolve(),new lC(e.then(function(){return r._request(r.serviceOptions.domain,"".concat(ce,"/mapconfigurations/metadata/").concat(r.serviceOptions.mapConfiguration),"StyleDefinitions").then(function(e){return hC(hC({},e),{defaultConfiguration:e.defaultConfiguration||e.defaultStyle,configurations:e.configurations||e.styles})})}))):lC.resolve(this.serviceOptions.mapConfiguration):(e=this.map.authentication?this.map.authentication.initialize():Promise.resolve(),new lC(e.then(function(){return r._request(r.serviceOptions.staticAssetsDomain,"".concat(le,"/").concat(ce),"StyleDefinitions",{version:r.serviceOptions.styleDefinitionsVersion,mcv:De.replace(/\./g,"")}).then(function(t){return{version:isNaN(t.version)?0:parseFloat(t.version),defaultConfiguration:t.defaultStyle,configurations:t.styles.filter(function(e){return r.indoorState?"auto"===r.indoorState.theme?e.name.endsWith("dark"===e.theme?"_indoor_dark":"_indoor"):e.name.endsWith("dark"===r.indoorState.theme?"_indoor_dark":"_indoor"):!e.name.includes("indoor")}).map(function(e){return{copyright:e.copyright.join(" "),name:e.name,displayName:function(e){e=r.indoorState&&e.includes("_indoor")?e.split("_indoor")[0]:e;return e in uC?uC[e]:e}(e.name),theme:e.theme,thumbnail:new Se({domain:r.serviceOptions.staticAssetsDomain,path:e.thumbnail,protocol:"https"}).toString(),url:new Se({domain:r.serviceOptions.staticAssetsDomain,path:"".concat(le,"/").concat(ce,"/").concat(e.name),queryParams:{styleVersion:void 0!==t.version&&null!==t.version?t.version:r.serviceOptions.styleDefinitionsVersion,mcv:De.replace(/\./g,"")},protocol:"https"}).toString()}})}})}))),this.initPromise&&this.initPromise.switchWith(e),this.initPromise=e,this.initPromise.then(function(e){return r.map._invokeEvent("mapconfigurationchanged",e)}),this.initPromise},_C.prototype.getStyle=function(e){e=this._lookUp(e);if(!e)throw Error("Style definition is not available.");if(e.url)return e.url;if(e.style)return e.style;throw Error("Style definition neither contains URL nor style object.")},_C.prototype.deriveNewStyleAndLayerGroups=function(e,t){for(var r,i,n=this.map.getStyle(),o=this.map.getTraffic(),a={},s=0;s<t.layers.length;s++){var l=t.layers[s],c=aC.getLayerGroup(l);c?(a[c]||(a[c]=[]),a[c].push(l),n.showBuildingModels||"fill-extrusion"!==l.type?"fill-extrusion"===l.type&&(l.layout=null!=(r=l.layout)?r:{},l.layout.visibility="visible"):(l.layout=null!=(r=l.layout)?r:{},l.layout.visibility="none"),"none"!==o.flow&&c&&c==="traffic_".concat(o.flow)&&"line"==l.type&&(l.layout=null!=(i=l.layout)?i:{},l.layout.visibility="visible"),"labels"!==c&&"labels_places"!==c&&"labels_indoor"!==c||"symbol"!==l.type||(n.showLabels&&"none"!==(null==(i=l.layout)?void 0:i.visibility)?(l.layout=null!=(c=l.layout)?c:{},l.layout.visibility="visible"):(l.layout=null!=(c=l.layout)?c:{},l.layout.visibility="none"))):a[l.id]=[l]}return[t,a]},_C.prototype.injectUserLayersIntoStyle=function(a,s,l){return a?this.map.layers._getUserLayers().reduce(function(r,t){var i,e,n,o;return t.layer instanceof Zp||(i=(null==(e=null==(e=null==l?void 0:l[t.before])?void 0:e[0])?void 0:e.id)||t.before,e=a.layers.find(function(e){return e.id===t.layer.getId()}),-1<(n=s.layers.findIndex(function(e){return e.id===t.layer.getId()}))&&s.layers.splice(n,1),e&&(n=new Set(Array.from(t.layer._getSourceIds()).map(function(e){var t;return!r.sources[e]&&(t=a.sources[e])?{source:t,id:e}:void 0}).filter(function(e){return void 0!==e})),-1<(o=i?r.layers.findIndex(function(e){return e.id===i}):-1)?r.layers.splice(o,0,e):r.layers.push(e),n.forEach(function(e){var t=e.source,e=e.id;r.sources[e]=t}))),r},hC({},s)):s},_C.prototype.setStyle=function(n,e){var o=this,t=(void 0===e&&(e=!0),this._lookUp(n));if(!t)throw Error("Style definition ".concat(n.style," is not available."));if(!t.url&&!t.style)throw Error("Style definition neither contains URL nor style object.");var r,i,a,s=function(){return o._onStyleData(t)},l=function(){o.map.events.remove("styledata",s),o.map.events.addOnce("styledata",s)},c=n&&n.customStyleTransform?function(e,t){e=n.customStyleTransform(e,t);return l(),e}:function(e,t){var r=hC(hC({},t),{layers:mC([],fC(t.layers),!1),sources:hC({},t.sources)}),i=n.progressiveLoading&&!o.map._isLoaded(),t=(i&&Array.isArray(null==t?void 0:t.layers)&&((r=hC({},t)).layers=r.layers.map(function(e){var t=hC({},e);return e.layout&&(t.layout=hC({},e.layout)),t})),fC(o.deriveNewStyleAndLayerGroups(e,r),2)),r=t[0],t=t[1],i=(i&&(i=n.progressiveLoadingInitialLayerGroups,Array.isArray(i))&&0<i.length&&o._deferLayerGroupVisibilities(t,i),o.injectUserLayersIntoStyle(e,r,t)),e=Object.entries(t).map(function(e){var e=fC(e,2),t=e[0],e=e[1];return o._buildFundamentalLayerFrom(e,t)}),r=o.map.layers._getUserLayers().reduce(function(e,t){var r=t.before?e.findIndex(function(e){return e.getId()===t.before}):-1;return-1<r?e.splice(r,0,t.layer):e.push(t.layer),e},e);return o.map.layers.layerIndex=r,o.map.sources._syncSources(i.sources),l(),i},u=t.url;u&&null!=n&&n.styleOverrides&&(r=new URL(u),i=new URLSearchParams(r.search),0<(a=Object.entries(null==n?void 0:n.styleOverrides).filter(function(e){var e=fC(e,2),t=e[0],e=e[1];return t in yC&&(yC[t].includes("bv")&&!1===(null==e?void 0:e.borderVisible)||!yC[t].includes("bv")&&!1===(null==e?void 0:e.visible))}).map(function(e){var e=fC(e,2),t=e[0];return e[1],yC[t]})).length)&&(i.set("st",a.join("_")),r.search=i.toString(),u=r.toString()),this.map._getMap().setStyle(u||t.style,{diff:e,validate:this.serviceOptions.validateStyle,transformStyle:c})},_C.prototype.getTheme=function(e){e=this._lookUp(e);if(e)return e.theme.toLowerCase()},_C.prototype.getThemeAsync=function(t){return dC(this,void 0,void 0,function(){return pC(this,function(e){switch(e.label){case 0:return[4,this._lookUpAsync(t)];case 1:return[2,e.sent().theme]}})})},_C.prototype.setMapConfiguration=function(e,r){var i=this;"string"==typeof(this.serviceOptions.mapConfiguration=e)?this.initStyleset():this.initPromise?this.initPromise.hijackAndResolve(e):this.initPromise=lC.resolve(e),this.definitions().then(function(e){var t=e.defaultConfiguration;e.configurations.find(function(e){return e.name===r})&&(t=r),i.map.setStyle({style:t})})},_C.prototype.getMapConfiguration=function(){return this.serviceOptions.mapConfiguration},_C.prototype.setStyleSet=function(e){this.updateIndoorState("indoor_dark"===e?"dark":"light",null)},_C.prototype.getStyleSet=function(){return void 0!==this.indoorState?"dark"===this.indoorState.theme?"indoor_dark":"indoor":"base"},_C.prototype.clearStyleSet=function(){this.unsetIndoorState()},_C.prototype._buildFundamentalLayerFrom=function(e,t){if(e&&0<e.length)return(e=new Fx(e,t)).onAdd(this.map),e;throw new Error("Unable to construct fundamental map layer for ID: ".concat(t,"."))},_C.prototype._transformStyleRequest=function(e,t){e.includes(te)&&(t.url=t.url.replace(te,this.serviceOptions.domain)),e.includes(ae)&&(t.url=t.url.replace(ae,le)),e.includes(se)&&(t.url=t.url.replace(se,ce)),(t.url.toLocaleLowerCase().includes(this.serviceOptions.domain.toLocaleLowerCase())||t.url.toLocaleLowerCase().includes(this.serviceOptions.staticAssetsDomain.toLocaleLowerCase()))&&((e=new URL(t.url)).searchParams.get(X)||(e.searchParams.set(X,this.serviceOptions.styleAPIVersion),t.url=e.href),null!=(e=this.map.authentication)&&e.signRequest(t),this._deleteAuthTokenForStaticAssets(t))},_C.prototype._request=function(i,n,o,a){var s;return void 0===a&&(a={}),dC(this,void 0,void 0,function(){var t,r;return pC(this,function(e){switch(e.label){case 0:return r={url:new Se({protocol:"https",domain:i,path:n,queryParams:hC(((r={})[X]=this.serviceOptions.styleAPIVersion,r),a)}).toString()},"function"==typeof this.serviceOptions.transformRequest&&o&&(r=this.serviceOptions.transformRequest(r.url,o)),null!=(s=this.map.authentication)&&s.signRequest(r),this._deleteAuthTokenForStaticAssets(r),t={method:"GET",mode:"cors"},r.credentials&&(t.credentials=r.credentials),r.headers&&(t.headers=r.headers),[4,fetch(r.url,t).then(function(e){if(e.ok)return e.json();throw new Error("HTTP ".concat(e.status,": ").concat(e.statusText," "))})];case 1:return[2,e.sent()]}})})},_C.prototype._deleteAuthTokenForStaticAssets=function(e){e.url.startsWith("https://".concat(this.serviceOptions.staticAssetsDomain,"/").concat(le))&&(delete e.headers[he],delete e.headers[J])},_C);function _C(e,t){var u=this;this.definitions=function(){var e=u.initPromise||u.initStyleset();return e},this.indoorState=void 0,this.preservedPreindoorMapConfiguration=void 0,this._progressiveLoadingState={mapStyle:void 0,pendingVisibilityChange:void 0},this._deferLayerGroupVisibilities=function(t,e){var r,n,i,o,a=e.filter(function(e){return e in t});0!==a.length&&(r=u.map._getMap(),n=r.getZoom(),i=u.map.getStyle().style,u._progressiveLoadingState.pendingVisibilityChange&&(u.map.events.remove("load",u._progressiveLoadingState.pendingVisibilityChange),u._progressiveLoadingState.pendingVisibilityChange=null),u._progressiveLoadingState.mapStyle=i,(o=Object.entries(t).reduce(function(e,t){var t=fC(t,2),r=t[0],t=t[1],i=a.includes(r);return mC(mC([],fC(e),!1),fC(t.filter(function(e){if("custom"===e.type)return!1;if(i)if("number"==typeof e.maxzoom&&"number"==typeof e.minzoom){if(n<=e.maxzoom&&n>=e.minzoom)return!1}else if("number"==typeof e.minzoom){if(n>=e.minzoom)return!1}else{if("number"!=typeof e.maxzoom)return!1;if(n<=e.maxzoom)return!1}return"none"!==(null==(e=e.layout)?void 0:e.visibility)})),!1)},[])).forEach(function(e){e.layout=e.layout||{},e.layout.visibility="none"}),u._progressiveLoadingState.pendingVisibilityChange=function(){u._progressiveLoadingState.pendingVisibilityChange=null;var e=u.map.getStyle().style;i===e&&(o.forEach(function(e){e.layout.visibility="visible",r.setLayoutProperty(e.id,"visibility","visible")}),null!=(e=u.map.copyrightDelegate))&&e.reloadAttribution()},u.map.events.addOnce("load",u._progressiveLoadingState.pendingVisibilityChange))},this._onStyleData=function(e){u.map.events.invoke("stylechanged",{style:e.name,map:u.map,type:"stylechanged"})},this._lookUp=function(e){var t,r,i=u.definitions(),n=i.errorIfRejected(),o=i.resultIfResolved();if(n||!o)return null;var i=o.configurations,a=void 0;try{for(var s=gC(i),l=s.next();!l.done;l=s.next()){var c=l.value;if(c.name===e.style)return c;c.name===o.defaultConfiguration&&(a=a||c)}}catch(e){t={error:e}}finally{try{l&&!l.done&&(r=s.return)&&r.call(s)}finally{if(t)throw t.error}}return a=a||i[0]},this._lookUpAsync=function(r){return dC(u,void 0,void 0,function(){var t;return pC(this,function(e){switch(e.label){case 0:return[4,this.definitions()];case 1:return t=e.sent(),[2,t.configurations.find(function(e){return e.name===(r.style||t.defaultConfiguration)})||t.configurations.find(function(e){return e.name===t.defaultConfiguration})||t.configurations[0]]}})})},this.map=e,this.serviceOptions=t}var bC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},wC=(xC.prototype.add=function(e){var t,r;e=Array.isArray(e)?e:[e];try{for(var i=bC(e),n=i.next();!n.done;n=i.next()){var o=n.value;this.indicators.has(o)||(this.indicators.add(o),o.attach(this.map))}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}},xC.prototype.clear=function(){var t=this;this.indicators.forEach(function(e){t.indicators.delete(e),e.remove()})},xC.prototype.remove=function(e){var t,r;e=Array.isArray(e)?e:[e];try{for(var i=bC(e),n=i.next();!n.done;n=i.next()){var o=n.value;this.indicators.has(o)&&(this.indicators.delete(o),o.remove())}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}},xC.prototype.getIndicators=function(){return Array.from(this.indicators)},xC.prototype._getCollectionDiv=function(){var e=this.map.getMapContainer().querySelector(".".concat(xC.Css.collection));return e||((e=document.createElement("div")).setAttribute("aria-label","map data"),e.setAttribute("role","listbox"),e.classList.add(xC.Css.collection),this.map.getMapContainer().appendChild(e)),e},xC.Css={collection:"accessible-indicator-collection-container"},xC);function xC(e){this.map=e,this.indicators=new Set}var CC,TC,Vt=window&&window.__extends||(CC=function(e,t){return(CC=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t}:function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])}))(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}CC(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),SC=window&&window.__assign||function(){return(SC=Object.assign||function(e){for(var t,r=1,i=arguments.length;r<i;r++)for(var n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)},EC=window&&window.__awaiter||function(e,a,s,l){return new(s=s||Promise)(function(r,t){function i(e){try{o(l.next(e))}catch(e){t(e)}}function n(e){try{o(l.throw(e))}catch(e){t(e)}}function o(e){var t;e.done?r(e.value):((t=e.value)instanceof s?t:new s(function(e){e(t)})).then(i,n)}o((l=l.apply(e,a||[])).next())})},IC=window&&window.__generator||function(i,n){var o,a,s,l={label:0,sent:function(){if(1&s[0])throw s[1];return s[1]},trys:[],ops:[]},c={next:e(0),throw:e(1),return:e(2)};return"function"==typeof Symbol&&(c[Symbol.iterator]=function(){return this}),c;function e(r){return function(e){var t=[r,e];if(o)throw new TypeError("Generator is already executing.");for(;l=c&&t[c=0]?0:l;)try{if(o=1,a&&(s=2&t[0]?a.return:t[0]?a.throw||((s=a.return)&&s.call(a),0):a.next)&&!(s=s.call(a,t[1])).done)return s;switch(a=0,(t=s?[2&t[0],s.value]:t)[0]){case 0:case 1:s=t;break;case 4:return l.label++,{value:t[1],done:!1};case 5:l.label++,a=t[1],t=[0];continue;case 7:t=l.ops.pop(),l.trys.pop();continue;default:if(!(s=0<(s=l.trys).length&&s[s.length-1])&&(6===t[0]||2===t[0])){l=0;continue}if(3===t[0]&&(!s||t[1]>s[0]&&t[1]<s[3]))l.label=t[1];else if(6===t[0]&&l.label<s[1])l.label=s[1],s=t;else{if(!(s&&l.label<s[2])){s[2]&&l.ops.pop(),l.trys.pop();continue}l.label=s[2],l.ops.push(t)}}t=n.call(i,l)}catch(e){t=[6,e],a=0}finally{o=s=0}if(5&t[0])throw t[1];return{value:t[0]?t[1]:void 0,done:!0}}}},AC=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},kC=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},PC=window&&window.__values||function(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],i=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return{value:(e=e&&i>=e.length?void 0:e)&&e[i++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")},MC=(Vt(D,TC=$t),Object.defineProperty(D.prototype,"isDisposed",{get:function(){return this.removed},enumerable:!1,configurable:!0}),D.prototype.getCanvas=function(){return this.map.getCanvas()},D.prototype.getCanvasContainer=function(){return this.map.getCanvasContainer()},D.prototype.getMapContainer=function(){return this.map.getContainer()},D.prototype.getServiceOptions=function(){return th(this.serviceOptions,nC._cloneCustomizer)},D.prototype.setServiceOptions=function(e){this.serviceOptions=(new nC).merge(this.serviceOptions,e),this.serviceOptions["enable-accessibility"]?this.accessibleMapDelegate.addToMap():this.accessibleMapDelegate.removeFromMap();e=this.styles.serviceOptions.mapConfiguration!==this.serviceOptions.mapConfiguration||this.styles.serviceOptions.staticAssetsDomain!==this.serviceOptions.staticAssetsDomain||this.styles.serviceOptions.styleDefinitionsVersion!==this.serviceOptions.styleDefinitionsVersion||this.styles.serviceOptions.domain!==this.serviceOptions.domain||this.styles.serviceOptions.styleAPIVersion!==this.serviceOptions.styleAPIVersion;this.styles.serviceOptions=this.serviceOptions,e&&(this.styles.initPromise=null,this.setStyle({}))},D.prototype.addRequestTransformer=function(e){this.serviceOptions.addTransformer(e)},D.prototype.removeRequestTransformer=function(e){this.serviceOptions.removeTransformer(e)},D.prototype.setCamera=function(e,t){if(void 0===t&&(t=!1),"padding"in e||"offset"in e||"bounds"in e){var r,i=(new h1).merge({maxZoom:this.getCamera().maxZoom},e),n=this._generateSafeBounds(i.bounds),o={padding:i.padding,offset:i.offset,maxZoom:i.maxZoom};if(!(r=this.map.cameraForBounds(n,o)))throw a={message:"The map cannot be fit to the current canvas with the given CameraBoundsOptions.",containerWidth:null==(a=null==(a=this.map)?void 0:a.getContainer())?void 0:a.clientWidth,containerHeight:null==a?void 0:a.clientHeight,safeBounds:n,cameraForBoundsOptions:o},new Error(JSON.stringify(a));"pitch"in e&&(r.pitch=e.pitch),"bearing"in e&&(r.bearing=e.bearing),"minPitch"in e&&this.map.setMinPitch(e.minPitch),"maxPitch"in e&&this.map.setMaxPitch(e.maxPitch),"minZoom"in e&&this.map.setMinZoom(e.minZoom),n=this._generateSafeBounds(i.maxBounds)}else{o=(new m1).merge(this.getCamera(),e);o.centerOffset&&2<=o.centerOffset.length&&(a=o.centerOffset,(i=$c([o.center],o.zoom))[0][0]+=a[0],i[0][1]+=a[1],o.center=Yc(i,o.zoom)[0]),r={center:o.center,zoom:o.zoom,bearing:o.bearing,pitch:o.pitch,around:void 0},o.minZoom<1&&console.warn("Setting minZoom below 1 may result in an empty map when the zoom level is less than 1."),this.map.setMinZoom(o.minZoom),this.map.setMaxZoom(o.maxZoom),o.minPitch&&this.map.setMinPitch(o.minPitch),o.maxPitch&&this.map.setMaxPitch(o.maxPitch),this._invokeEvent("minzoomchanged",this.map.getMinZoom()),this._invokeEvent("maxzoomchanged",this.map.getMaxZoom()),n=this._generateSafeBounds(o.maxBounds)}n?this.map.setMaxBounds(n):this.map.setMaxBounds(null);var a=(new e1).merge(e),i={duration:a.duration,easing:function(e){return e},offset:[0,0],animate:!0},o={fromControl:t};"jump"===a.type?this.map.jumpTo(r,o):"ease"===a.type?this.map.easeTo(SC(SC({},r),i),o):"fly"===a.type&&this.map.flyTo(SC(SC({},r),i),o)},D.prototype.setCameraBounds=function(e){this.setCamera(e)},D.prototype.getCamera=function(){var e=this.map.getBounds().getSouthWest().toArray(),t=this.map.getBounds().getNorthEast().toArray();return{zoom:this.map.getZoom(),center:this.map.getCenter().toArray(),bearing:this.map.getBearing(),pitch:this.map.getPitch(),bounds:new f(e,t),minZoom:this.map.getMinZoom(),maxZoom:this.map.getMaxZoom(),maxBounds:null==(e=this.map.getMaxBounds())?void 0:e.toArray().flat()}},D.prototype.setStyle=function(e,t){void 0===t&&(t=!0),delete e.preserveDrawingBuffer;e=(new Y1).merge(this.styleOptions,e),e.autoResize!==this.styleOptions.autoResize&&this._setAutoResize(e.autoResize),e.language!==this.styleOptions.language&&(this.localizedStringsPromise=Me.getStrings(e.language)),e.renderWorldCopies!==this.styleOptions.renderWorldCopies&&this.map.setRenderWorldCopies(e.renderWorldCopies),e.showFeedbackLink!==this.styleOptions.showFeedbackLink&&this.copyrightControl.setOptions({showFeedbackLink:e.showFeedbackLink}),e.customAttribution!==this.styleOptions.customAttribution&&this.copyrightControl.setOptions({customAttribution:e.customAttribution}),e.showLogo!==this.styleOptions.showLogo&&(this.copyrightControl.setOptions({showLogo:e.showLogo}),this.logoControl.setOptions({showLogo:e.showLogo})),e.showTileBoundaries!==this.styleOptions.showTileBoundaries&&(this.map.showTileBoundaries=e.showTileBoundaries),e.showBuildingModels&&console.warn("showBuildingModels is deprecated."),t=t&&this.styleOptions.language===e.language&&this.styleOptions.view===e.view;this.styleOptions=e,this._setStyleComponents(e,t)},D.prototype.getStyle=function(){return Wa(this.styleOptions)},D.prototype.addIcon=function(e,t){this.imageSprite.add(e,t)},D.prototype.addPins=function(e,t){var t=(new P1).merge(t),r=this.layers.getLayerById(t.name),i=!1;if(r||(i=!0,r=new Tp("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,iconOptions:{anchor:"center",size:t.iconSize,image:["case",["has","icon"],["get","icon"],t.icon],ignorePlacement:!t.cluster,opacity:t.opacity},textOptions:{anchor:"center",textField:["case",["has","point_count"],["to-string",["get","point_count"]],["has","title"],["to-string",["get","title"]],t.title],font:["case",["has","point_count"],["literal",["StandardFontCondensed-Bold"]],["literal",[t.textFont]]],size:["case",["has","point_count"],20,t.fontSize],ignorePlacement:!t.cluster,opacity:t.opacity,offset:["case",["has","point_count"],["literal",[.5,-.45]],["literal",[t.textOffset[0]/16,t.textOffset[1]/16]]],color:t.fontColor}})),!(r instanceof Tp))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a SymbolLayer.")+"A SymbolLayer should be used for rendering pins.");var n=r.getSource(),o=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(o=!0,n=new mh(a,{cluster:t.cluster})),!(n instanceof mh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");o&&this.sources.add(n),i&&this.layers.add(r,t.before);var a=new Cu(e);t.overwrite?n.setShapes(a):n.add(a)},D.prototype.addCircles=function(e,t){var t=(new x1).merge(t),r=this.layers.getLayerById(t.name),i=!1;if(r||(i=!0,r=new md("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,opacity:t.opacity,radius:["case",["has","radius"],["get","radius"],t.radius],color:["case",["has","color"],["get","color"],t.color],strokeColor:["case",["has","outlineColor"],["get","outlineColor"],t.outlineColor],strokeWidth:["case",["has","outlineWidth"],["get","outlineWidth"],t.outlineWidth]})),!(r instanceof md))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a BubbleLayer.")+"A BubbleLayer should be used for rendering circles.");var n=r.getSource(),o=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(o=!0,n=new mh(a)),!(n instanceof mh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");o&&this.sources.add(n),i&&this.layers.add(r,t.before);var a=new Cu(e);t.overwrite?n.setShapes(a):n.add(a)},D.prototype.addLinestrings=function(e,t){var t=(new E1).merge(t),r=this.layers.getLayerById(t.name),i=!1;if(r||(i=!0,r=new Gd("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,lineCap:t.cap,lineJoin:t.join,strokeOpacity:t.opacity,strokeColor:["case",["has","color"],["get","color"],t.color],strokeWidth:["case",["has","width"],["get","width"],t.width]})),!(r instanceof Gd))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a LineLayer.")+"A LineLayer should be used for rendering linestrings.");var n=r.getSource(),o=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(o=!0,n=new mh(a)),!(n instanceof mh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");o&&this.sources.add(n),i&&this.layers.add(r,t.before);var a=new Cu(e);t.overwrite?n.setShapes(a):n.add(a)},D.prototype.addPolygons=function(e,t){var t=(new L1).merge(t),r=this.layers.getLayerById(t.name),i=!1;if(r||(i=!0,r=new sp("".concat(t.name,"-source"),t.name,{source:"".concat(t.name,"-source"),minZoom:t.minZoom,maxZoom:t.maxZoom,fillOpacity:t.opacity,fillColor:["case",["has","color"],["get","color"],t.color]})),!(r instanceof sp))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a PolygonLayer.")+"A PolygonLayer should be used for rendering linestrings.");var n=r.getSource(),o=("string"==typeof n?(a=n,n=this.sources.getById(a)):a=n.getId(),!1);if(n||(o=!0,n=new mh(a)),!(n instanceof mh))throw new Error("The source with name '".concat(a,"' already exists but it is not a DataSource.")+"New data can only be added to a DataSource.");o&&this.sources.add(n),i&&this.layers.add(r,t.before);var a=new Cu(e);t.overwrite?n.setShapes(a):n.add(a)},D.prototype.addRaster=function(e,t){var r,t=(new B1).merge(t),i=this.layers.getLayerById(t.name);if(!((i=i||new Fp({maxZoom:t.maxZoom,minZoom:t.minZoom,opacity:t.opacity,tileSize:256,tileUrl:"{subdomain}"},t.name))instanceof Fp))throw new Error("A layer with name '".concat(t.name,"' already exists but it is not a TileLayer.")+"A TileLayer should be used for rendering raster images.");if("{subdomain}"!==i.getOptions().tileUrl)throw new Error("A TileLayer with name '".concat(t.name,"' already exists but was configured ")+"for a single tile url [default for new TileLayer(...)].");(r=!t.overwrite&&i.getOptions().subdomains||[]).push.apply(r,kC([],AC(e),!1)),i._setOptionsNoUpdate({subdomains:r}),this.layers.add(i,t.before)},D.prototype.getLayers=function(){return this.layers.getLayers().map(function(e){return e.getId()})},D.prototype.removeLayers=function(e){var t,r;try{for(var i=PC(e),n=i.next();!n.done;n=i.next()){var o,a=n.value;this.layers.getLayerById(a)&&(this.layers.remove(a),o="".concat(a,"-source"),this.sources.getById(o))&&this.sources.remove(o)}}catch(e){t={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}},D.prototype.addHtml=function(e,t){e.id||(e.id="marker_".concat(Z()));var r=new gf({htmlContent:e});return this.markers.add(r,t),e.id},D.prototype.removeHtml=function(e){this.markers.remove(e)},D.prototype.addEventListener=function(e,t,r){this.events._addLegacy(e,t,r)},D.prototype.removeEventListener=function(e,t,r){this.events._removeLegacy(e,t,r)},D.prototype.setUserInteraction=function(e){this.userInteractionDelegate.setOptions(e)},D.prototype.getUserInteraction=function(){return this.userInteractionDelegate.getOptions()},D.prototype.addControl=function(e,t){this.controls.add(e,t)},D.prototype.removeControl=function(e){this.controls.remove(e)},D.prototype.setTraffic=function(e){var t=this.trafficOptions.incidents,r=this.trafficOptions.flow;if(this.trafficOptions=(new ll).merge(this.trafficOptions,e),this.controls.getControls().filter(function(e){return e instanceof gl}).forEach(function(e){return e.updateButtonState()}),this.incidentDelegate&&(this.trafficOptions.incidents?t||this.incidentDelegate.addToMap():this.incidentDelegate.removeFromMap()),this.trafficOptions.flow&&"none"!==this.trafficOptions.flow){["absolute","relative-delay"].includes(this.trafficOptions.flow)&&console.warn("The 'absolute' and 'relative-delay' flow options are deprecated. Please use 'relative' instead.");try{this.trafficOptions.flow!==r&&this.flowDelegate.addToMap()}catch(e){throw this.trafficOptions.flow=r,e}}else this.flowDelegate.removeFromMap()},D.prototype.getTraffic=function(){return Wa(this.trafficOptions)},D.prototype.remove=function(){this.dispose()},D.prototype.clear=function(){this.popups.clear(),this.layers.clear(),this.sources.clear(),this.markers.clear(),this.indicators.clear()},D.prototype.dispose=function(){var e;for(this.clear(),this.map.remove(),null!=(e=this.authentication)&&e.dispose(),this.removed=!0,null!=(e=this.resizeObserver)&&e.disconnect(),this.resizeObserver=null;this.getMapContainer().firstChild;){var t=this.getMapContainer().firstChild;this.getMapContainer().removeChild(t)}},D.prototype.resize=function(e,t,r){"number"!=typeof e&&"string"!=typeof e||"number"!=typeof t&&"string"!=typeof t?r=e:(e=e,this.getMapContainer().style.height="number"==typeof e?"".concat(e,"px"):e,this.getMapContainer().style.width="number"==typeof t?"".concat(t,"px"):t);e=this.getMapContainer().style.overflow;this.getMapContainer().style.overflow="hidden",this.map.resize(r),this.getMapContainer().style.overflow=e},D.prototype.pixelsToPositions=function(e){var t,r,i=[];try{for(var n=PC(e),o=n.next();!o.done;o=n.next()){var a=o.value,s=this.map.unproject(a);i.push(new hu(s.lng,s.lat))}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}return i},D.prototype.positionsToPixels=function(e){var t,r,i=[];try{for(var n=PC(e),o=n.next();!o.done;o=n.next()){var a=o.value,s=this.map.project(a);i.push(new ic(s.x,s.y))}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}return i},D.prototype.areTilesLoaded=function(){return this.map.areTilesLoaded()},D.prototype.stop=function(){this.map.stop()},D.prototype.triggerRepaint=function(){this.map.triggerRepaint()},D.prototype.enableElevation=function(e,t){this.map.setTerrain("string"==typeof e?{source:e,exaggeration:t}:{source:e.getId(),exaggeration:t})},D.prototype.disableElevation=function(){this.map.setTerrain(null)},D.prototype._getMap=function(){return this.map},D.prototype._rebuildStyle=function(t){return void 0===t&&(t=!0),EC(this,void 0,void 0,function(){return IC(this,function(e){return this.styles.setStyle(this.styleOptions,t),this.imageSprite._restoreImages(),[2]})})},D.prototype._isLoaded=function(){return this.loaded},D.prototype._isReady=function(){return this.ready},D.prototype._getLocalizedStrings=function(){return this.localizedStringsPromise},D.prototype._sendRequest=function(e,t,r){var i;return(i="function"==typeof this.serviceOptions.transformRequest?this.serviceOptions.transformRequest(e,t):i)?fetch(i.url||e,{credentials:i.credentials,headers:SC(SC({},r),i.headers),method:"GET",mode:"cors"}):fetch(e,{headers:r,method:"GET",mode:"cors"})},D.prototype._substituteDomainLanguageViewAndSignInRequest=function(e,t){var r;(e.includes(re)||e.includes(te))&&(r=new RegExp("[^{]".concat(re,"[^}]")),e.match(r)&&(t.url=t.url.replace(re,te)),Se.protoRegEx.test(this.serviceOptions.domain)?(r=t.url.indexOf(te),t.url=this.serviceOptions.domain+t.url.substring(r+te.length)):t.url=t.url.replace(te,this.serviceOptions.domain)),(t.url.toLocaleLowerCase().includes(this.serviceOptions.domain.toLocaleLowerCase())||t.url.toLocaleLowerCase().includes(this.serviceOptions.staticAssetsDomain.toLocaleLowerCase()))&&null!=(r=this.authentication)&&r.signRequest(t),e.includes(oe)&&(t.url=t.url.replace(oe,this.styleOptions.language)),e.includes(ie)&&(t.url=this.styleOptions.view?t.url.replace(ie,this.styleOptions.view):t.url.replace(ie,"").replace("&".concat(ne,"="),""))},D.prototype._setAutoResize=function(e){e?(this.resizeObserver||(this.resizeObserver=new ResizeObserver(this._resizeCallback)),this.resizeObserver.observe(this.map.getContainer())):this.resizeObserver&&this.resizeObserver.unobserve(this.map.getContainer())},D.prototype._setStyleComponents=function(s,l){var c=this;void 0===l&&(l=!0),this.removed||this.styles.definitions().then(function(e){var t,r,i=!0;if(c.styleOptions.style)try{for(var n=PC(e.configurations),o=n.next();!o.done;o=n.next()){var a=o.value;if(c.styleOptions.style===a.name){i=!1;break}}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}i&&(c.styleOptions.style=e.defaultConfiguration),c.styleOptions=s,c._rebuildStyle(l)})},D.prototype._updateGlobalDefaults=function(e){e&&(e.authOptions&&!st&&bt(e.authOptions),e.domain&&!et&&wt(e.domain),e.styleDefinitionsPath&&!tt&&xt(e.styleDefinitionsPath),e.workerCount&&!it&&Ct(e.workerCount),e.maxParallelImageRequests&&!nt&&Tt(e.maxParallelImageRequests),!e.subscriptionKey&&!e["subscription-key"]||st||It(e.subscriptionKey||e["subscription-key"]),!e.sessionId&&!e["session-id"]||at||Et(e.sessionId||e["session-id"]),e.language&&!ot&&St(e.language),!e.userRegion&&!e.view||Qe||At(e.userRegion||e.view))},D.prototype._generateSafeBounds=function(e){if(e){var t=f.getSouth(e),r=f.getWest(e),i=f.getNorth(e),n=f.getEast(e);if(!(isFinite(t)&&isFinite(r)&&isFinite(i)&&isFinite(n)))throw new Error("The bounds specified are invalid: [".concat(e,"]"));for(;n<r;)n+=360;return new f([r,t,n,i])}return e},D.prototype._detectHighContrast=function(){var e,t;switch(vf.getHighContrastMode()){case"invert":case"light":e=D.Css.hcLight,t="high_contrast_light";break;case"dark":e=D.Css.hcDark,t="high_contrast_dark"}e&&this.map.getContainer().classList.add(e),t&&"road"===this.styleOptions.style&&(this.styleOptions.style=t)},D.Css={canvasContainer:"atlas-map-canvas-container",canvas:"atlas-map-canvas",container:"atlas-map",hcDark:"high-contrast-dark",hcLight:"high-contrast-light"},D);function D(e,t){var r,i,n=TC.call(this)||this;n.removed=!1,n.loaded=!1,n.ready=!1,n._resizeCallback=function(){return n.resize()},n._updateGlobalDefaults(t),n.serviceOptions=(new nC).merge(t),n.styleOptions=(new Y1).merge(t),n.trafficOptions=new ll,n.styles=new vC(n,n.serviceOptions),n.serviceOptions.authOptions.subscriptionKey&&(n.serviceOptions.authOptions.subscriptionKey=encodeURIComponent(n.serviceOptions.authOptions.subscriptionKey)),r=n.serviceOptions.authOptions.clientId||(n.serviceOptions.authOptions.subscriptionKey?n.serviceOptions.authOptions.subscriptionKey.replace(/.(?=.{3,}$)/g,"*"):"invalid-setting"),n.insights&&n.insights.setAuthenticatedUserContext(n.serviceOptions.sessionId,r),arguments[2]&&"ENVIRONMENT"in window&&window.ENVIRONMENT.hmr?(i=arguments[2],n.ready=!0,n.loaded=!0):(r={antialias:n.styleOptions.antialias,attributionControl:!1,container:e,fadeDuration:n.serviceOptions.fadeDuration,localIdeographFontFamily:n.serviceOptions.localIdeographFontFamily,preserveDrawingBuffer:n.styleOptions.preserveDrawingBuffer,refreshExpiredTiles:n.serviceOptions.refreshExpiredTiles,renderWorldCopies:n.styleOptions.renderWorldCopies,trackResize:!1,transformRequest:function(e,t){var r={url:e};return"Tile"===t||"Source"===t?(e.includes(re)&&n.insights&&n.insights.trackEvent({name:"TileLoad"}),n._substituteDomainLanguageViewAndSignInRequest(e,r)):"Style"!==t&&"SpriteJSON"!==t&&"SpriteImage"!==t&&"Glyphs"!==t||n.styles._transformStyleRequest(e,r),n.serviceOptions.transformRequest&&Xs(r,n.serviceOptions.transformRequest(r.url,t)),r}},i=new B.Map(r));try{n.map=i,n.authentication=new _x(n),n.controls=new wx(n),n.events=new kx(n),n.imageSprite=new Lx(n),n.layers=new Vx(n),n.markers=new Rx(n),n.sources=new $x(n),n.popups=new Zx(n),n.indicators=new wC(n),n.map.getContainer().classList.add(D.Css.container),n.map.getCanvasContainer().classList.add(D.Css.canvasContainer),n.map.getCanvas().classList.add(D.Css.canvas),n._detectHighContrast(),n.copyrightControl=new Ef({showFeedbackLink:n.styleOptions.showFeedbackLink,showLogo:n.styleOptions.showLogo,customAttribution:n.styleOptions.customAttribution}),n.controls.add(n.copyrightControl,{position:u.ControlPosition.NonFixed}),n.logoControl=new Lf({showLogo:n.styleOptions.showLogo}),n.controls.add(n.logoControl,{position:u.ControlPosition.BottomLeft});var o=n.authentication?n.authentication.initialize():Promise.resolve();if(n.removed)return n;var a=function(){n.loaded=!0,n.map.off("load",a)},s=(n.map.on("load",a),function(){n.ready=!0,n.map.off("styledata",s),n.events.invoke("ready",{map:n,type:"ready"})});n.map.on("styledata",s),n._setAutoResize(n.styleOptions.autoResize),n.map.showTileBoundaries=n.styleOptions.showTileBoundaries,n.localizedStringsPromise=Me.getStrings(n.styleOptions.language),o.then(function(){return n.styles.definitions()}).then(function(e){if(!n.removed){if(n.authentication&&!n.authentication.getToken())throw new Error("AuthenticationManager finished initializing, but no token is available");n.serviceOptions["enable-accessibility"]&&n.accessibleMapDelegate.addToMap(),n._setStyleComponents(n.styleOptions),n.copyrightDelegate&&n.copyrightDelegate.addToMap()}}).catch(function(e){e=e instanceof Error?e:new Error(e);n.events.invoke("error",{map:n,type:"error",error:e})}),n.setCamera(SC(SC({minZoom:1},t),{type:"jump",duration:0})),n.incidentDelegate=new am(n),n.flowDelegate=new Qf(n),n.accessibleMapDelegate=new Jf(n),n.userInteractionDelegate=new gm(n,t),n.userInteractionDelegate.addToMap(),n.copyrightDelegate=new Om(n,n.copyrightControl,n.styleOptions)}catch(e){throw e}return n}var RC=window&&window.__read||function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var i,n,o=r.call(e),a=[];try{for(;(void 0===t||0<t--)&&!(i=o.next()).done;)a.push(i.value)}catch(e){n={error:e}}finally{try{i&&!i.done&&(r=o.return)&&r.call(o)}finally{if(n)throw n.error}}return a},OC=window&&window.__spreadArray||function(e,t,r){if(r||2===arguments.length)for(var i,n=0,o=t.length;n<o;n++)!i&&n in t||((i=i||Array.prototype.slice.call(t,0,n))[n]=t[n]);return e.concat(i||Array.prototype.slice.call(t))},r=(LC.applyTemplate=function(t,r){var i,n,e,o=this,a=document.createElement("div");return a.classList.add(LC.Css.template),t&&("boolean"!=typeof(r=r||{}).singleDescription&&(r.singleDescription=!0),r.sandboxContent="boolean"!=typeof r.sandboxContent||r.sandboxContent,r.title&&"string"==typeof r.content&&(r.content.includes("{title}")||r.content.includes("{name}"))||(t.title?r.title="{title}":t.name&&(r.title="{name}")),"boolean"!=typeof r.detectHyperlinks&&(r.detectHyperlinks=!0),"boolean"!=typeof r.parsePropertyPaths&&(r.parsePropertyPaths=!0),r.textColor&&(a.style.color=r.textColor),r.fillColor&&(a.style.backgroundColor=r.fillColor),r.title&&((e=this._applyStringTemplate(t,r.title,r)).innerText=e.textContent||e.innerText||"",this._appendChild(a,e,LC.Css.title)),(i=document.createElement("div")).classList.add(LC.Css.content),Array.isArray(r.content)?0<r.content.length&&r.content[0].propertyPath?this._appendChild(i,this._generateContent(t,r.content,r),LC.Css.item):r.content.forEach(function(e){o._appendChild(i,o._generateContent(t,e,r),LC.Css.item)}):(n=0,e=void(t.description&&Object.keys(t).forEach(function(e){o._ignoreProperty(e,t[e])||n++})),1===n||r.singleDescription&&t.description||2===n&&t.Snippet?(e=document.createElement("div")).innerHTML=t.description:e=this._generateContent(t,r.content,r),this._appendChild(i,e,LC.Css.item)),""!==i.innerHTML)&&(r.sandboxContent?a.appendChild(LC._createSandboxedIframe(i,r)):a.appendChild(i)),a},LC._createSandboxedIframe=function(e,t){var r=document.createElement("iframe"),e=(r.sandbox.add("allow-popups"),e.innerHTML),i=!1,n=100,o=550,a=10,s=(document.body.scrollWidth<=340&&(o=300,n=50),e.split(/<(tr|div|br|li|h[0-9]|p>)/)),l=Math.max.apply(Math,OC([],RC(s.map(function(e){return e.replace(/<[a-zA-Z0-9\s=\/]+>/g,"").length})),!1))-1,c=Math.ceil(3.5*l),l=(c<o&&(o=c,n=l),e.includes("<img")||e.includes("<video")?(i=!0,r.width="550px"):(c=-1<e.indexOf(LC.Css.table)?25:20,a+=Math.max(.5*s.length*c,Math.ceil(e.replace(/<[a-zA-Z0-9\s=\/]+>/g,"").length/n)*c)),r.width=o+"px",r.height=i||280<a?"280px":a+"px",t.textColor?"color:".concat(t.textColor,";"):""),s=t.fillColor?"background-color:".concat(t.fillColor,";"):"",n='<html><head><title></title><meta charset="utf-8" /><meta http-equiv="x-ua-compatible" content="IE=Edge" />'+'<link rel="stylesheet" href="'.concat(LC._cssUrl,'" type="text/css"/>')+"<style>html, body{margin:0;padding:0;".concat(l).concat(s,"}</style></head>")+'<body><div class="'.concat(LC.Css.template,'" style="padding:0;width:').concat(o-20,'px">').concat(e,"</div></body></html>");return void 0===r.srcdoc?r.src="data:text/html;charset=utf-8,"+encodeURI(n):r.srcdoc=n,r},LC._appendChild=function(e,t,r){t&&(r&&(t.className=(t.className?t.className+" ":"")+r),e.appendChild(t))},LC._generateContent=function(e,t,r){return t?Array.isArray(t)?this._generatePropertyInfoTable(e,t,r):this._applyStringTemplate(e,t,r):(t=this._generateDynamicTableHtml(e,null,r))?((e=document.createElement("div")).innerHTML=t,e):null},LC._applyStringTemplate=function(e,t,r){if(t){for(var i,n,o=t,a=this._placeholderRx.exec(t);a;)2<=a.length&&(i=this._getPropertyValue(e,a[1],r),o=o.replace(a[0],i)),a=this._placeholderRx.exec(t);if(o)return(o=o.trim()).includes("<")&&(o=o.replace(/[\r\n]+/g,"<br/>")),(n=document.createElement("div")).innerHTML=o,n}return null},LC._getPropertyValue=function(e,t,r,i){var n=r.parsePropertyPaths?t.split("/"):[t],o=n.length;if(0<o&&e){var a=n[0],s=e[a];if(r.detectHyperlinks&&"link"===t&&(!i||i.hyperlinkFormat)){var l,c,u,h=[];if(Array.isArray(s)?s.forEach(function(e){e.href?h.push(e):"string"==typeof e&&h.push({href:e})}):s.href&&h.push(s),0<h.length)return i&&i.hyperlinkFormat?l=i.hyperlinkFormat:r&&r.hyperlinkFormat&&(l=r.hyperlinkFormat),c=l&&l.target?l.target:"_blank",u=[],h.forEach(function(e){e.title||l&&l.label||!e.rel||u.push(e.rel," - "),u.push('<a href="',e.href,'" target="',c,'">'),e.title?u.push(e.title):l&&l.label?u.push(l.label):u.push(e.href),u.push("</a>","<br/>")}),u.pop(),u.join("")}if(null!=s){for(var d=void 0,d=1;d<o&&(s=s[n[d]],a=n[d],null!=s);d++);if(d===o&&null!=s){e=void 0;if((e=void 0!==s.value?s.value:s)instanceof Date)return i&&i.dateFormat?e.toLocaleString(void 0,i.dateFormat):r.dateFormat?e.toLocaleString(void 0,r.dateFormat):e.toISOString();if("object"==typeof e)return(p=this._generateDynamicTableHtml(e,n.slice(1),r))||"";if("number"==typeof e){if(i){if(i.dateFormat)return new Date(e).toLocaleString(void 0,i.dateFormat);if(i.numberFormat)return e.toLocaleString(void 0,i.numberFormat)}else if(/(timestamp|date)/gi.test(a))return new Date(e).toISOString();return e.toLocaleString(void 0,r.numberFormat)}if("string"==typeof e&&""!==e&&!/[\n\r<>\s]/g.test(e)&&(r.detectHyperlinks||i&&i.hyperlinkFormat)){var p,e=e.trim(),t=this._isUrlRx.test(e)||i&&i.hyperlinkFormat,f=this._isImageUrlRx.test(e)&&(t||e.startsWith("data:image")),m=this._emailRx.test(e);if(t||f||m)return t=void 0,p=void(i&&i.hyperlinkFormat?t=i.hyperlinkFormat:r&&r.hyperlinkFormat&&(t=r.hyperlinkFormat)),p=t&&t.target?' target="'.concat(t.target,'"'):' target="_blank"',i="".concat(t&&t.label?t.label:e),t&&t.scheme?e=t.scheme+e:m&&(e="mailto:"+e),r=t&&t.label?' alt="'.concat(t.label,'"'):"",(t&&t.isImage||f)&&(i='<img src="'.concat(e,'" style="max-width:100%"').concat(r,'"/>')),'<a href="'.concat(e,'"').concat(p,">").concat(i,"</a>")}return e.toString()}}}return""},LC._generatePropertyInfoTable=function(r,e,i){var n,o;return r&&e&&0<e.length?((n=[]).push('<table class="'.concat((o=this).Css.table,'">')),e.forEach(function(e){var t=o._getPropertyValue(r,e.propertyPath,i,e);e.hideLabel?n.push('<tr><td colspan="2">',t,"</td></tr>"):(e=e.label||e.propertyPath.split("/")[0],n.push("<tr><th>",e,"</th><td>",t,"</td></tr>"))}),n.push("</table>"),(e=document.createElement("div")).innerHTML=n.join(""),e):null},LC._generateDynamicTableHtml=function(t,e,r){var i,n,o,a,s=this;return!t||((i=[]).push('<table class="'.concat((n=this).Css.table,'">')),o=e&&0<e.length?e.join("/")+"/":"",a=0,Object.keys(t).forEach(function(e){s._ignoreProperty(e,t[e])||(i.push("<tr><th>",e,"</th><td>",n._getPropertyValue(t,o+e,r),"</td></tr>"),a++)}),0===a)?null:(i.push("</table>"),i.join(""))},LC._ignoreProperty=function(e,t){switch(e){case"title":case"name":case"base":case"popupTemplate":case"anchor":case"icon":case"image":case"imageUrl":case"rotation":case"color":case"size":case"offset":case"strokeColor":case"strokeWidth":case"strokeOpacity":case"subType":case"fillColor":case"fillOpacity":case"visibility":case"visible":return!0;default:if(0===e.indexOf("_")||null==t||""===t)return!0}return!1},LC._placeholderRx=/\{([a-zA-Z0-9_\/\s]+)\}/gi,LC._isUrlRx=/^(http|https|ftp|tel|mailto):\/\//i,LC._isImageUrlRx=/(^data:image|.png$|.jpg$|.jpeg$|.gif$|.bmp$|.svg|.tif|.tiff$)/i,LC._emailRx=/^[^\.\s@:](?:[^\s@:]*[^\s@:\.])?@[^\.\s@]+(?:\.[^\.\s@]+)*$/,LC._cssUrl=new Se({domain:Y,path:"sdk/javascript/mapcontrol/".concat(ze.getEndpointVersion(),"/atlas.min.css")}).toString(),LC.Css={template:"azure-maps-control-popup-template",title:"azure-maps-control-popup-template-title",content:"azure-maps-control-popup-template-content",item:"azure-maps-control-popup-template-content-item",table:"azure-maps-control-popup-template-table"},LC);function LC(){this.detectHyperlinks=!0,this.parsePropertyPaths=!0}Bt(),u.HtmlMarker=gf,u.Map=MC,u.Pixel=ic,u.Popup=lf,u.PopupTemplate=r,u.Shape=vu,u._enableRTLTextPlugin=Bt,u._getAssetDomain=function(){return W},u._getDomain=function(){return Ze},u._hasMaxParallelImageRequests=Lt,u._hasSetAuthenticationOptions=Pt,u._hasSetDomain=Mt,u._hasSetLanguage=Dt,u._hasSetSessionId=zt,u._hasSetStyleDefinitionsPath=Rt,u._hasSetStyleDefinitionsVersion=function(){return rt},u._hasSetView=Nt,u._hasWorkerCount=Ot,u.addImageTemplate=function(e,t,r){!r&&Ht[e.toLowerCase()]||(Ht[e.toLowerCase()]=t)},u.addProtocol=function(e,t){B.addProtocol(e,t)},u.clearPrewarmedResources=function(){B.clearPrewarmedResources()},u.control=Fr,u.data=no,u.getAllImageTemplateNames=function(){return Object.keys(Ht)},u.getAuthenticationOptions=lt,u.getDomain=ut,u.getImageTemplate=kt,u.getLanguage=gt,u.getMaxParallelImageRequests=mt,u.getSessionId=yt,u.getStaticAssetsDomain=ct,u.getStyleAPIVersion=pt,u.getStyleDefinitionsPath=ht,u.getStyleDefinitionsVersion=dt,u.getSubscriptionKey=vt,u.getUserRegion=function(){return Ve},u.getVersion=function(){return ze.getFullVersion()},u.getView=_t,u.getWorkerCount=ft,u.internal=q,u.isSupported=function(e){return!Oe.isIE()},u.layer=Oo,u.math=an,u.prewarm=function(){B.prewarm()},u.removeProtocol=function(e){B.removeProtocol(e)},u.setAuthenticationOptions=bt,u.setDomain=wt,u.setLanguage=St,u.setMaxParallelImageRequests=Tt,u.setSessionId=Et,u.setStyleAPIVersion=function(e){Xe=e},u.setStyleDefinitionsPath=xt,u.setStyleDefinitionsVersion=function(e){$e=e,rt=!0},u.setSubscriptionKey=It,u.setUserRegion=At,u.setView=function(e){Ve=e,Qe=!0},u.setWorkerCount=Ct,u.source=un});
