/*!
MICROSOFT SOFTWARE LICENSE TERMS
MICROSOFT AZURE MAPS WEB SDK
These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW.  BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS.
1. INSTALLATION AND USE RIGHTS.
  a) General. You may install and use any number of copies of the software to develop and test your applications.
  b) User Region Parameters. The software will allow you to select from a View list to set the map view within your application for a given customer. By default the View parameter (also referred to as “user region parameter” is set to “Unified”.  Countries/Regions that are not on the View list will default to the “Unified” View. It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter must be used in compliance with applicable laws, including those regarding mapping, of the country where maps, images and other data and third party content that You are authorized to access via the software is made available. 
  c) Third Party Software. The software may include third party applications that Microsoft, not the third party, licenses to you under this agreement. Any included notices for third party applications are for your information only.
  d) Microsoft Online Subscription Agreement. Some features of the software provide access to, or rely on, Microsoft Azure Services. The use of those services (but not the software) is governed by the separate terms and privacy policies associated with your Microsoft Azure subscription. The services may not be available in all regions. For more information see https://go.microsoft.com/fwLink/?LinkID=522330&amp;clcid=0x9.
2. DISTRIBUTABLE CODE. The software is comprised of “Distributable Code”. “Distributable Code” is code that you are permitted to distribute in applications you develop if you comply with the terms below and otherwise set forth in these license terms. 
  a) Distribution Rights. 
    i. You may copy and distribute the object code form of the software.
    i. Third Party Distribution. You may permit distributors of your applications to copy and distribute any of this distributable code you elect to distribute with your applications.
  b) Distribution Requirements. For any code you distribute, you must:
    i. add significant primary functionality to it in your applications;
    ii. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
    iii. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  c) Distribution Restrictions. You may not:
    i. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
    ii. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.
3. DATA COLLECTION. The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at https://go.microsoft.com/fwlink/?LinkId=512132. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.
4. SCOPE OF LICENSE. The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
  a) work around any technical limitations in the software that only allow you to use it in certain ways;
  b) reverse engineer, decompile, or disassemble the software, or attempt to do so, except and only to the extent permitted by licensing terms governing the use of open-source components that may be included with the software;
  c) remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
  d) use the software in any way that is against the law or to create or propagate malware; or
  e) share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.
5. EXPORT RESTRICTIONS. You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.
6. SUPPORT SERVICES. Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.
7. UPDATES. The software may periodically check for updates, and download and install them for you. You may obtain updates only from Microsoft or authorized sources. Microsoft may need to update your system to provide you with updates. You agree to receive these automatic updates without any additional notice. Updates may not include or support all existing software features, services, or peripheral devices.
8. ENTIRE AGREEMENT. This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.
9. APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES. If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.
10. CONSUMER RIGHTS; REGIONAL VARIATIONS. This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
  a) Australia. You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
  b) Canada. If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
  c) Germany and Austria.
    i. Warranty. The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.
    ii. Limitation of Liability. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.
  Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.
11. DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
12. LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT, OR INCIDENTAL DAMAGES.
This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.
It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.
Please note: As this software is distributed in Canada, some of the clauses in this agreement are provided below in French.
Remarque: Ce logiciel étant distribué au Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.
EXONÉRATION DE GARANTIE. Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.
LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES. Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.
Cette limitation concerne:
• tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers; et
• les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.
Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.
EFFET JURIDIQUE. Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.
*/

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var f = n.default;
	if (typeof f == "function") {
		var a = function a () {
			if (this instanceof a) {
        return Reflect.construct(f, arguments, this.constructor);
			}
			return f.apply(this, arguments);
		};
		a.prototype = f.prototype;
  } else a = {};
  Object.defineProperty(a, '__esModule', {value: true});
	Object.keys(n).forEach(function (k) {
		var d = Object.getOwnPropertyDescriptor(n, k);
		Object.defineProperty(a, k, d.get ? d : {
			enumerable: true,
			get: function () {
				return n[k];
			}
		});
	});
	return a;
}

var azuremapsMaplibreGlDev = {exports: {}};

/* Build timestamp: Mon, 22 Apr 2024 08:56:33 GMT */

(function (module, exports) {
	/**
	 * The Azure Maps fork of MapLibre GL JS
	 * @license 3-Clause BSD. Full text of license: https://github.com/maplibre/maplibre-gl-js/blob/v4.1.2/LICENSE.txt
	 */
	(function (global, factory) {
	module.exports = factory() ;
	})(commonjsGlobal, (function () {
	/* eslint-disable */

	var maplibregl = {};
	var modules = {};
	function define(moduleName, _dependencies, moduleFactory) {
	    modules[moduleName] = moduleFactory;

	    // to get the list of modules see generated dist/maplibre-gl-dev.js file (look for `define(` calls)
	    if (moduleName !== 'index') {
	        return;
	    }

	    // we assume that when an index module is initializing then other modules are loaded already
	    var workerBundleString = 'var sharedModule = {}; (' + modules.shared + ')(sharedModule); (' + modules.worker + ')(sharedModule);';

	    var sharedModule = {};
	    // the order of arguments of a module factory depends on rollup (it decides who is whose dependency)
	    // to check the correct order, see dist/maplibre-gl-dev.js file (look for `define(` calls)
	    // we assume that for our 3 chunks it will generate 3 modules and their order is predefined like the following
	    modules.shared(sharedModule);
	    modules.index(maplibregl, sharedModule);

	    if (typeof window !== 'undefined') {
	        maplibregl.setWorkerUrl(window.URL.createObjectURL(new Blob([workerBundleString], { type: 'text/javascript' })));
	    }

	    return maplibregl;
	}


	define('shared', ['exports'], (function (exports) {
	function __awaiter(thisArg, _arguments, P, generator) {
	    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
	    return new (P || (P = Promise))(function (resolve, reject) {
	        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
	        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
	        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
	        step((generator = generator.apply(thisArg, _arguments || [])).next());
	    });
	}

	typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
	    var e = new Error(message);
	    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
	};

	function getDefaultExportFromCjs$1 (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	var pointGeometry = Point$1;

	/**
	 * A standalone point geometry with useful accessor, comparison, and
	 * modification methods.
	 *
	 * @class Point
	 * @param {Number} x the x-coordinate. this could be longitude or screen
	 * pixels, or any other sort of unit.
	 * @param {Number} y the y-coordinate. this could be latitude or screen
	 * pixels, or any other sort of unit.
	 * @example
	 * var point = new Point(-77, 38);
	 */
	function Point$1(x, y) {
	    this.x = x;
	    this.y = y;
	}

	Point$1.prototype = {

	    /**
	     * Clone this point, returning a new point that can be modified
	     * without affecting the old one.
	     * @return {Point} the clone
	     */
	    clone: function() { return new Point$1(this.x, this.y); },

	    /**
	     * Add this point's x & y coordinates to another point,
	     * yielding a new point.
	     * @param {Point} p the other point
	     * @return {Point} output point
	     */
	    add:     function(p) { return this.clone()._add(p); },

	    /**
	     * Subtract this point's x & y coordinates to from point,
	     * yielding a new point.
	     * @param {Point} p the other point
	     * @return {Point} output point
	     */
	    sub:     function(p) { return this.clone()._sub(p); },

	    /**
	     * Multiply this point's x & y coordinates by point,
	     * yielding a new point.
	     * @param {Point} p the other point
	     * @return {Point} output point
	     */
	    multByPoint:    function(p) { return this.clone()._multByPoint(p); },

	    /**
	     * Divide this point's x & y coordinates by point,
	     * yielding a new point.
	     * @param {Point} p the other point
	     * @return {Point} output point
	     */
	    divByPoint:     function(p) { return this.clone()._divByPoint(p); },

	    /**
	     * Multiply this point's x & y coordinates by a factor,
	     * yielding a new point.
	     * @param {Point} k factor
	     * @return {Point} output point
	     */
	    mult:    function(k) { return this.clone()._mult(k); },

	    /**
	     * Divide this point's x & y coordinates by a factor,
	     * yielding a new point.
	     * @param {Point} k factor
	     * @return {Point} output point
	     */
	    div:     function(k) { return this.clone()._div(k); },

	    /**
	     * Rotate this point around the 0, 0 origin by an angle a,
	     * given in radians
	     * @param {Number} a angle to rotate around, in radians
	     * @return {Point} output point
	     */
	    rotate:  function(a) { return this.clone()._rotate(a); },

	    /**
	     * Rotate this point around p point by an angle a,
	     * given in radians
	     * @param {Number} a angle to rotate around, in radians
	     * @param {Point} p Point to rotate around
	     * @return {Point} output point
	     */
	    rotateAround:  function(a,p) { return this.clone()._rotateAround(a,p); },

	    /**
	     * Multiply this point by a 4x1 transformation matrix
	     * @param {Array<Number>} m transformation matrix
	     * @return {Point} output point
	     */
	    matMult: function(m) { return this.clone()._matMult(m); },

	    /**
	     * Calculate this point but as a unit vector from 0, 0, meaning
	     * that the distance from the resulting point to the 0, 0
	     * coordinate will be equal to 1 and the angle from the resulting
	     * point to the 0, 0 coordinate will be the same as before.
	     * @return {Point} unit vector point
	     */
	    unit:    function() { return this.clone()._unit(); },

	    /**
	     * Compute a perpendicular point, where the new y coordinate
	     * is the old x coordinate and the new x coordinate is the old y
	     * coordinate multiplied by -1
	     * @return {Point} perpendicular point
	     */
	    perp:    function() { return this.clone()._perp(); },

	    /**
	     * Return a version of this point with the x & y coordinates
	     * rounded to integers.
	     * @return {Point} rounded point
	     */
	    round:   function() { return this.clone()._round(); },

	    /**
	     * Return the magitude of this point: this is the Euclidean
	     * distance from the 0, 0 coordinate to this point's x and y
	     * coordinates.
	     * @return {Number} magnitude
	     */
	    mag: function() {
	        return Math.sqrt(this.x * this.x + this.y * this.y);
	    },

	    /**
	     * Judge whether this point is equal to another point, returning
	     * true or false.
	     * @param {Point} other the other point
	     * @return {boolean} whether the points are equal
	     */
	    equals: function(other) {
	        return this.x === other.x &&
	               this.y === other.y;
	    },

	    /**
	     * Calculate the distance from this point to another point
	     * @param {Point} p the other point
	     * @return {Number} distance
	     */
	    dist: function(p) {
	        return Math.sqrt(this.distSqr(p));
	    },

	    /**
	     * Calculate the distance from this point to another point,
	     * without the square root step. Useful if you're comparing
	     * relative distances.
	     * @param {Point} p the other point
	     * @return {Number} distance
	     */
	    distSqr: function(p) {
	        var dx = p.x - this.x,
	            dy = p.y - this.y;
	        return dx * dx + dy * dy;
	    },

	    /**
	     * Get the angle from the 0, 0 coordinate to this point, in radians
	     * coordinates.
	     * @return {Number} angle
	     */
	    angle: function() {
	        return Math.atan2(this.y, this.x);
	    },

	    /**
	     * Get the angle from this point to another point, in radians
	     * @param {Point} b the other point
	     * @return {Number} angle
	     */
	    angleTo: function(b) {
	        return Math.atan2(this.y - b.y, this.x - b.x);
	    },

	    /**
	     * Get the angle between this point and another point, in radians
	     * @param {Point} b the other point
	     * @return {Number} angle
	     */
	    angleWith: function(b) {
	        return this.angleWithSep(b.x, b.y);
	    },

	    /*
	     * Find the angle of the two vectors, solving the formula for
	     * the cross product a x b = |a||b|sin(θ) for θ.
	     * @param {Number} x the x-coordinate
	     * @param {Number} y the y-coordinate
	     * @return {Number} the angle in radians
	     */
	    angleWithSep: function(x, y) {
	        return Math.atan2(
	            this.x * y - this.y * x,
	            this.x * x + this.y * y);
	    },

	    _matMult: function(m) {
	        var x = m[0] * this.x + m[1] * this.y,
	            y = m[2] * this.x + m[3] * this.y;
	        this.x = x;
	        this.y = y;
	        return this;
	    },

	    _add: function(p) {
	        this.x += p.x;
	        this.y += p.y;
	        return this;
	    },

	    _sub: function(p) {
	        this.x -= p.x;
	        this.y -= p.y;
	        return this;
	    },

	    _mult: function(k) {
	        this.x *= k;
	        this.y *= k;
	        return this;
	    },

	    _div: function(k) {
	        this.x /= k;
	        this.y /= k;
	        return this;
	    },

	    _multByPoint: function(p) {
	        this.x *= p.x;
	        this.y *= p.y;
	        return this;
	    },

	    _divByPoint: function(p) {
	        this.x /= p.x;
	        this.y /= p.y;
	        return this;
	    },

	    _unit: function() {
	        this._div(this.mag());
	        return this;
	    },

	    _perp: function() {
	        var y = this.y;
	        this.y = this.x;
	        this.x = -y;
	        return this;
	    },

	    _rotate: function(angle) {
	        var cos = Math.cos(angle),
	            sin = Math.sin(angle),
	            x = cos * this.x - sin * this.y,
	            y = sin * this.x + cos * this.y;
	        this.x = x;
	        this.y = y;
	        return this;
	    },

	    _rotateAround: function(angle, p) {
	        var cos = Math.cos(angle),
	            sin = Math.sin(angle),
	            x = p.x + cos * (this.x - p.x) - sin * (this.y - p.y),
	            y = p.y + sin * (this.x - p.x) + cos * (this.y - p.y);
	        this.x = x;
	        this.y = y;
	        return this;
	    },

	    _round: function() {
	        this.x = Math.round(this.x);
	        this.y = Math.round(this.y);
	        return this;
	    }
	};

	/**
	 * Construct a point from an array if necessary, otherwise if the input
	 * is already a Point, or an unknown type, return it unchanged
	 * @param {Array<Number>|Point|*} a any kind of input value
	 * @return {Point} constructed point, or passed-through value.
	 * @example
	 * // this
	 * var point = Point.convert([0, 1]);
	 * // is equivalent to
	 * var point = new Point(0, 1);
	 */
	Point$1.convert = function (a) {
	    if (a instanceof Point$1) {
	        return a;
	    }
	    if (Array.isArray(a)) {
	        return new Point$1(a[0], a[1]);
	    }
	    return a;
	};

	var Point$2 = /*@__PURE__*/getDefaultExportFromCjs$1(pointGeometry);

	var unitbezier$1 = UnitBezier$2;

	function UnitBezier$2(p1x, p1y, p2x, p2y) {
	    // Calculate the polynomial coefficients, implicit first and last control points are (0,0) and (1,1).
	    this.cx = 3.0 * p1x;
	    this.bx = 3.0 * (p2x - p1x) - this.cx;
	    this.ax = 1.0 - this.cx - this.bx;

	    this.cy = 3.0 * p1y;
	    this.by = 3.0 * (p2y - p1y) - this.cy;
	    this.ay = 1.0 - this.cy - this.by;

	    this.p1x = p1x;
	    this.p1y = p1y;
	    this.p2x = p2x;
	    this.p2y = p2y;
	}

	UnitBezier$2.prototype = {
	    sampleCurveX: function (t) {
	        // `ax t^3 + bx t^2 + cx t' expanded using Horner's rule.
	        return ((this.ax * t + this.bx) * t + this.cx) * t;
	    },

	    sampleCurveY: function (t) {
	        return ((this.ay * t + this.by) * t + this.cy) * t;
	    },

	    sampleCurveDerivativeX: function (t) {
	        return (3.0 * this.ax * t + 2.0 * this.bx) * t + this.cx;
	    },

	    solveCurveX: function (x, epsilon) {
	        if (epsilon === undefined) epsilon = 1e-6;

	        if (x < 0.0) return 0.0;
	        if (x > 1.0) return 1.0;

	        var t = x;

	        // First try a few iterations of Newton's method - normally very fast.
	        for (var i = 0; i < 8; i++) {
	            var x2 = this.sampleCurveX(t) - x;
	            if (Math.abs(x2) < epsilon) return t;

	            var d2 = this.sampleCurveDerivativeX(t);
	            if (Math.abs(d2) < 1e-6) break;

	            t = t - x2 / d2;
	        }

	        // Fall back to the bisection method for reliability.
	        var t0 = 0.0;
	        var t1 = 1.0;
	        t = x;

	        for (i = 0; i < 20; i++) {
	            x2 = this.sampleCurveX(t);
	            if (Math.abs(x2 - x) < epsilon) break;

	            if (x > x2) {
	                t0 = t;
	            } else {
	                t1 = t;
	            }

	            t = (t1 - t0) * 0.5 + t0;
	        }

	        return t;
	    },

	    solve: function (x, epsilon) {
	        return this.sampleCurveY(this.solveCurveX(x, epsilon));
	    }
	};

	var UnitBezier$3 = /*@__PURE__*/getDefaultExportFromCjs$1(unitbezier$1);

	let supportsOffscreenCanvas;
	function offscreenCanvasSupported() {
	    if (supportsOffscreenCanvas == null) {
	        supportsOffscreenCanvas = typeof OffscreenCanvas !== 'undefined' &&
	            new OffscreenCanvas(1, 1).getContext('2d') &&
	            typeof createImageBitmap === 'function';
	    }
	    return supportsOffscreenCanvas;
	}

	let offscreenCanvasDistorted;
	/**
	 * Some browsers don't return the exact pixels from a canvas to prevent user fingerprinting (see #3185).
	 * This function writes pixels to an OffscreenCanvas and reads them back using getImageData, returning false
	 * if they don't match.
	 *
	 * @returns true if the browser supports OffscreenCanvas but it distorts getImageData results, false otherwise.
	 */
	function isOffscreenCanvasDistorted() {
	    if (offscreenCanvasDistorted == null) {
	        offscreenCanvasDistorted = false;
	        if (offscreenCanvasSupported()) {
	            const size = 5;
	            const canvas = new OffscreenCanvas(size, size);
	            const context = canvas.getContext('2d', { willReadFrequently: true });
	            if (context) {
	                // fill each pixel with an RGB value that should make the byte at index i equal to i (except alpha channel):
	                // [0, 1, 2, 255, 4, 5, 6, 255, 8, 9, 10, 255, ...]
	                for (let i = 0; i < size * size; i++) {
	                    const base = i * 4;
	                    context.fillStyle = `rgb(${base},${base + 1},${base + 2})`;
	                    context.fillRect(i % size, Math.floor(i / size), 1, 1);
	                }
	                const data = context.getImageData(0, 0, size, size).data;
	                for (let i = 0; i < size * size * 4; i++) {
	                    if (i % 4 !== 3 && data[i] !== i) {
	                        offscreenCanvasDistorted = true;
	                        break;
	                    }
	                }
	            }
	        }
	    }
	    return offscreenCanvasDistorted || false;
	}

	/**
	 * Given a value `t` that varies between 0 and 1, return
	 * an interpolation function that eases between 0 and 1 in a pleasing
	 * cubic in-out fashion.
	 */
	function easeCubicInOut(t) {
	    if (t <= 0)
	        return 0;
	    if (t >= 1)
	        return 1;
	    const t2 = t * t, t3 = t2 * t;
	    return 4 * (t < 0.5 ? t3 : 3 * (t - t2) + t3 - 0.75);
	}
	/**
	 * Given given (x, y), (x1, y1) control points for a bezier curve,
	 * return a function that interpolates along that curve.
	 *
	 * @param p1x - control point 1 x coordinate
	 * @param p1y - control point 1 y coordinate
	 * @param p2x - control point 2 x coordinate
	 * @param p2y - control point 2 y coordinate
	 */
	function bezier$1(p1x, p1y, p2x, p2y) {
	    const bezier = new UnitBezier$3(p1x, p1y, p2x, p2y);
	    return function (t) {
	        return bezier.solve(t);
	    };
	}
	/**
	 * A default bezier-curve powered easing function with
	 * control points (0.25, 0.1) and (0.25, 1)
	 */
	const defaultEasing = bezier$1(0.25, 0.1, 0.25, 1);
	/**
	 * constrain n to the given range via min + max
	 *
	 * @param n - value
	 * @param min - the minimum value to be returned
	 * @param max - the maximum value to be returned
	 * @returns the clamped value
	 */
	function clamp$1(n, min, max) {
	    return Math.min(max, Math.max(min, n));
	}
	/**
	 * constrain n to the given range, excluding the minimum, via modular arithmetic
	 *
	 * @param n - value
	 * @param min - the minimum value to be returned, exclusive
	 * @param max - the maximum value to be returned, inclusive
	 * @returns constrained number
	 */
	function wrap(n, min, max) {
	    const d = max - min;
	    const w = ((n - min) % d + d) % d + min;
	    return (w === min) ? max : w;
	}
	/**
	 * Compute the difference between the keys in one object and the keys
	 * in another object.
	 *
	 * @returns keys difference
	 */
	function keysDifference(obj, other) {
	    const difference = [];
	    for (const i in obj) {
	        if (!(i in other)) {
	            difference.push(i);
	        }
	    }
	    return difference;
	}
	function extend(dest, ...sources) {
	    for (const src of sources) {
	        for (const k in src) {
	            dest[k] = src[k];
	        }
	    }
	    return dest;
	}
	/**
	 * Given an object and a number of properties as strings, return version
	 * of that object with only those properties.
	 *
	 * @param src - the object
	 * @param properties - an array of property names chosen
	 * to appear on the resulting object.
	 * @returns object with limited properties.
	 * @example
	 * ```ts
	 * let foo = { name: 'Charlie', age: 10 };
	 * let justName = pick(foo, ['name']); // justName = { name: 'Charlie' }
	 * ```
	 */
	function pick(src, properties) {
	    const result = {};
	    for (let i = 0; i < properties.length; i++) {
	        const k = properties[i];
	        if (k in src) {
	            result[k] = src[k];
	        }
	    }
	    return result;
	}
	let id = 1;
	/**
	 * Return a unique numeric id, starting at 1 and incrementing with
	 * each call.
	 *
	 * @returns unique numeric id.
	 */
	function uniqueId() {
	    return id++;
	}
	/**
	 * Return whether a given value is a power of two
	 */
	function isPowerOfTwo(value) {
	    return (Math.log(value) / Math.LN2) % 1 === 0;
	}
	/**
	 * Return the next power of two, or the input value if already a power of two
	 */
	function nextPowerOfTwo(value) {
	    if (value <= 1)
	        return 1;
	    return Math.pow(2, Math.ceil(Math.log(value) / Math.LN2));
	}
	/**
	 * Create an object by mapping all the values of an existing object while
	 * preserving their keys.
	 */
	function mapObject(input, iterator, context) {
	    const output = {};
	    for (const key in input) {
	        output[key] = iterator.call(context || this, input[key], key, input);
	    }
	    return output;
	}
	/**
	 * Create an object by filtering out values of an existing object.
	 */
	function filterObject(input, iterator, context) {
	    const output = {};
	    for (const key in input) {
	        if (iterator.call(context || this, input[key], key, input)) {
	            output[key] = input[key];
	        }
	    }
	    return output;
	}
	/**
	 * Deeply compares two object literals.
	 * @param a - first object literal to be compared
	 * @param b - second object literal to be compared
	 * @returns true if the two object literals are deeply equal, false otherwise
	 */
	function deepEqual$1(a, b) {
	    if (Array.isArray(a)) {
	        if (!Array.isArray(b) || a.length !== b.length)
	            return false;
	        for (let i = 0; i < a.length; i++) {
	            if (!deepEqual$1(a[i], b[i]))
	                return false;
	        }
	        return true;
	    }
	    if (typeof a === 'object' && a !== null && b !== null) {
	        if (!(typeof b === 'object'))
	            return false;
	        const keys = Object.keys(a);
	        if (keys.length !== Object.keys(b).length)
	            return false;
	        for (const key in a) {
	            if (!deepEqual$1(a[key], b[key]))
	                return false;
	        }
	        return true;
	    }
	    return a === b;
	}
	/**
	 * Deeply clones two objects.
	 */
	function clone$9(input) {
	    if (Array.isArray(input)) {
	        return input.map(clone$9);
	    }
	    else if (typeof input === 'object' && input) {
	        return mapObject(input, clone$9);
	    }
	    else {
	        return input;
	    }
	}
	/**
	 * Check if two arrays have at least one common element.
	 */
	function arraysIntersect(a, b) {
	    for (let l = 0; l < a.length; l++) {
	        if (b.indexOf(a[l]) >= 0)
	            return true;
	    }
	    return false;
	}
	/**
	 * Print a warning message to the console and ensure duplicate warning messages
	 * are not printed.
	 */
	const warnOnceHistory = {};
	function warnOnce(message) {
	    if (!warnOnceHistory[message]) {
	        // console isn't defined in some WebWorkers, see #2558
	        if (typeof console !== 'undefined')
	            console.warn(message);
	        warnOnceHistory[message] = true;
	    }
	}
	/**
	 * Indicates if the provided Points are in a counter clockwise (true) or clockwise (false) order
	 *
	 * @returns true for a counter clockwise set of points
	 */
	// http://bryceboe.com/2006/10/23/line-segment-intersection-algorithm/
	function isCounterClockwise(a, b, c) {
	    return (c.y - a.y) * (b.x - a.x) > (b.y - a.y) * (c.x - a.x);
	}
	/**
	 * For two lines a and b in 2d space, defined by any two points along the lines,
	 * find the intersection point, or return null if the lines are parallel
	 *
	 * @param a1 - First point on line a
	 * @param a2 - Second point on line a
	 * @param b1 - First point on line b
	 * @param b2 - Second point on line b
	 *
	 * @returns the intersection point of the two lines or null if they are parallel
	 */
	function findLineIntersection(a1, a2, b1, b2) {
	    const aDeltaY = a2.y - a1.y;
	    const aDeltaX = a2.x - a1.x;
	    const bDeltaY = b2.y - b1.y;
	    const bDeltaX = b2.x - b1.x;
	    const denominator = (bDeltaY * aDeltaX) - (bDeltaX * aDeltaY);
	    if (denominator === 0) {
	        // Lines are parallel
	        return null;
	    }
	    const originDeltaY = a1.y - b1.y;
	    const originDeltaX = a1.x - b1.x;
	    const aInterpolation = (bDeltaX * originDeltaY - bDeltaY * originDeltaX) / denominator;
	    // Find intersection by projecting out from origin of first segment
	    return new Point$2(a1.x + (aInterpolation * aDeltaX), a1.y + (aInterpolation * aDeltaY));
	}
	/**
	 * Returns the signed area for the polygon ring.  Positive areas are exterior rings and
	 * have a clockwise winding.  Negative areas are interior rings and have a counter clockwise
	 * ordering.
	 *
	 * @param ring - Exterior or interior ring
	 */
	function calculateSignedArea(ring) {
	    let sum = 0;
	    for (let i = 0, len = ring.length, j = len - 1, p1, p2; i < len; j = i++) {
	        p1 = ring[i];
	        p2 = ring[j];
	        sum += (p2.x - p1.x) * (p1.y + p2.y);
	    }
	    return sum;
	}
	/**
	 * Converts spherical coordinates to cartesian coordinates.
	 *
	 * @param spherical - Spherical coordinates, in [radial, azimuthal, polar]
	 * @returns cartesian coordinates in [x, y, z]
	 */
	function sphericalToCartesian([r, azimuthal, polar]) {
	    // We abstract "north"/"up" (compass-wise) to be 0° when really this is 90° (π/2):
	    // correct for that here
	    azimuthal += 90;
	    // Convert azimuthal and polar angles to radians
	    azimuthal *= Math.PI / 180;
	    polar *= Math.PI / 180;
	    return {
	        x: r * Math.cos(azimuthal) * Math.sin(polar),
	        y: r * Math.sin(azimuthal) * Math.sin(polar),
	        z: r * Math.cos(polar)
	    };
	}
	/**
	 *  Returns true if the when run in the web-worker context.
	 *
	 * @returns `true` if the when run in the web-worker context.
	 */
	function isWorker(self) {
	    // @ts-ignore
	    return typeof WorkerGlobalScope !== 'undefined' && typeof self !== 'undefined' && self instanceof WorkerGlobalScope;
	}
	/**
	 * Parses data from 'Cache-Control' headers.
	 *
	 * @param cacheControl - Value of 'Cache-Control' header
	 * @returns object containing parsed header info.
	 */
	function parseCacheControl(cacheControl) {
	    // Taken from [Wreck](https://github.com/hapijs/wreck)
	    const re = /(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g;
	    const header = {};
	    cacheControl.replace(re, ($0, $1, $2, $3) => {
	        const value = $2 || $3;
	        header[$1] = value ? value.toLowerCase() : true;
	        return '';
	    });
	    if (header['max-age']) {
	        const maxAge = parseInt(header['max-age'], 10);
	        if (isNaN(maxAge))
	            delete header['max-age'];
	        else
	            header['max-age'] = maxAge;
	    }
	    return header;
	}
	let _isSafari = null;
	/**
	 * Returns true when run in WebKit derived browsers.
	 * This is used as a workaround for a memory leak in Safari caused by using Transferable objects to
	 * transfer data between WebWorkers and the main thread.
	 * https://github.com/mapbox/mapbox-gl-js/issues/8771
	 *
	 * This should be removed once the underlying Safari issue is fixed.
	 *
	 * @param scope - Since this function is used both on the main thread and WebWorker context,
	 *      let the calling scope pass in the global scope object.
	 * @returns `true` when run in WebKit derived browsers.
	 */
	function isSafari(scope) {
	    if (_isSafari == null) {
	        const userAgent = scope.navigator ? scope.navigator.userAgent : null;
	        _isSafari = !!scope.safari ||
	            !!(userAgent && (/\b(iPad|iPhone|iPod)\b/.test(userAgent) || (!!userAgent.match('Safari') && !userAgent.match('Chrome'))));
	    }
	    return _isSafari;
	}
	function isImageBitmap(image) {
	    return typeof ImageBitmap !== 'undefined' && image instanceof ImageBitmap;
	}
	/**
	 * Converts an ArrayBuffer to an ImageBitmap.
	 *
	 * Used mostly for testing purposes only, because mocking libs don't know how to work with ArrayBuffers, but work
	 * perfectly fine with ImageBitmaps. Might also be used for environments (other than testing) not supporting
	 * ArrayBuffers.
	 *
	 * @param data - Data to convert
	 * @returns - A  promise resolved when the conversion is finished
	 */
	const arrayBufferToImageBitmap = (data) => __awaiter(void 0, void 0, void 0, function* () {
	    if (data.byteLength === 0) {
	        return createImageBitmap(new ImageData(1, 1));
	    }
	    const blob = new Blob([new Uint8Array(data)], { type: 'image/png' });
	    try {
	        return createImageBitmap(blob);
	    }
	    catch (e) {
	        throw new Error(`Could not load image because of ${e.message}. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported.`);
	    }
	});
	const transparentPngUrl = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=';
	/**
	 * Converts an ArrayBuffer to an HTMLImageElement.
	 *
	 * Used mostly for testing purposes only, because mocking libs don't know how to work with ArrayBuffers, but work
	 * perfectly fine with ImageBitmaps. Might also be used for environments (other than testing) not supporting
	 * ArrayBuffers.
	 *
	 * @param data - Data to convert
	 * @returns - A promise resolved when the conversion is finished
	 */
	const arrayBufferToImage = (data) => {
	    return new Promise((resolve, reject) => {
	        const img = new Image();
	        img.onload = () => {
	            resolve(img);
	            URL.revokeObjectURL(img.src);
	            // prevent image dataURI memory leak in Safari;
	            // but don't free the image immediately because it might be uploaded in the next frame
	            // https://github.com/mapbox/mapbox-gl-js/issues/10226
	            img.onload = null;
	            window.requestAnimationFrame(() => { img.src = transparentPngUrl; });
	        };
	        img.onerror = () => reject(new Error('Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported.'));
	        const blob = new Blob([new Uint8Array(data)], { type: 'image/png' });
	        img.src = data.byteLength ? URL.createObjectURL(blob) : transparentPngUrl;
	    });
	};
	/**
	 * Computes the webcodecs VideoFrame API options to select a rectangle out of
	 * an image and write it into the destination rectangle.
	 *
	 * Rect (x/y/width/height) select the overlapping rectangle from the source image
	 * and layout (offset/stride) write that overlapping rectangle to the correct place
	 * in the destination image.
	 *
	 * Offset is the byte offset in the dest image that the first pixel appears at
	 * and stride is the number of bytes to the start of the next row:
	 * ┌───────────┐
	 * │  dest     │
	 * │       ┌───┼───────┐
	 * │offset→│▓▓▓│ source│
	 * │       │▓▓▓│       │
	 * │       └───┼───────┘
	 * │stride ⇠╌╌╌│
	 * │╌╌╌╌╌╌→    │
	 * └───────────┘
	 *
	 * @param image - source image containing a width and height attribute
	 * @param x - top-left x coordinate to read from the image
	 * @param y - top-left y coordinate to read from the image
	 * @param width - width of the rectangle to read from the image
	 * @param height - height of the rectangle to read from the image
	 * @returns the layout and rect options to pass into VideoFrame API
	 */
	function computeVideoFrameParameters(image, x, y, width, height) {
	    const destRowOffset = Math.max(-x, 0) * 4;
	    const firstSourceRow = Math.max(0, y);
	    const firstDestRow = firstSourceRow - y;
	    const offset = firstDestRow * width * 4 + destRowOffset;
	    const stride = width * 4;
	    const sourceLeft = Math.max(0, x);
	    const sourceTop = Math.max(0, y);
	    const sourceRight = Math.min(image.width, x + width);
	    const sourceBottom = Math.min(image.height, y + height);
	    return {
	        rect: {
	            x: sourceLeft,
	            y: sourceTop,
	            width: sourceRight - sourceLeft,
	            height: sourceBottom - sourceTop
	        },
	        layout: [{ offset, stride }]
	    };
	}
	/**
	 * Reads pixels from an ImageBitmap/Image/canvas using webcodec VideoFrame API.
	 *
	 * @param data - image, imagebitmap, or canvas to parse
	 * @param x - top-left x coordinate to read from the image
	 * @param y - top-left y coordinate to read from the image
	 * @param width - width of the rectangle to read from the image
	 * @param height - height of the rectangle to read from the image
	 * @returns a promise containing the parsed RGBA pixel values of the image, or the error if an error occurred
	 */
	function readImageUsingVideoFrame(image, x, y, width, height) {
	    return __awaiter(this, void 0, void 0, function* () {
	        if (typeof VideoFrame === 'undefined') {
	            throw new Error('VideoFrame not supported');
	        }
	        const frame = new VideoFrame(image, { timestamp: 0 });
	        try {
	            const format = frame === null || frame === void 0 ? void 0 : frame.format;
	            if (!format || !(format.startsWith('BGR') || format.startsWith('RGB'))) {
	                throw new Error(`Unrecognized format ${format}`);
	            }
	            const swapBR = format.startsWith('BGR');
	            const result = new Uint8ClampedArray(width * height * 4);
	            yield frame.copyTo(result, computeVideoFrameParameters(image, x, y, width, height));
	            if (swapBR) {
	                for (let i = 0; i < result.length; i += 4) {
	                    const tmp = result[i];
	                    result[i] = result[i + 2];
	                    result[i + 2] = tmp;
	                }
	            }
	            return result;
	        }
	        finally {
	            frame.close();
	        }
	    });
	}
	let offscreenCanvas;
	let offscreenCanvasContext;
	/**
	 * Reads pixels from an ImageBitmap/Image/canvas using OffscreenCanvas
	 *
	 * @param data - image, imagebitmap, or canvas to parse
	 * @param x - top-left x coordinate to read from the image
	 * @param y - top-left y coordinate to read from the image
	 * @param width - width of the rectangle to read from the image
	 * @param height - height of the rectangle to read from the image
	 * @returns a promise containing the parsed RGBA pixel values of the image, or the error if an error occurred
	 */
	function readImageDataUsingOffscreenCanvas(imgBitmap, x, y, width, height) {
	    const origWidth = imgBitmap.width;
	    const origHeight = imgBitmap.height;
	    // Lazily initialize OffscreenCanvas
	    if (!offscreenCanvas || !offscreenCanvasContext) {
	        // Dem tiles are typically 256x256
	        offscreenCanvas = new OffscreenCanvas(origWidth, origHeight);
	        offscreenCanvasContext = offscreenCanvas.getContext('2d', { willReadFrequently: true });
	    }
	    offscreenCanvas.width = origWidth;
	    offscreenCanvas.height = origHeight;
	    offscreenCanvasContext.drawImage(imgBitmap, 0, 0, origWidth, origHeight);
	    const imgData = offscreenCanvasContext.getImageData(x, y, width, height);
	    offscreenCanvasContext.clearRect(0, 0, origWidth, origHeight);
	    return imgData.data;
	}
	/**
	 * Reads RGBA pixels from an preferring OffscreenCanvas, but falling back to VideoFrame if supported and
	 * the browser is mangling OffscreenCanvas getImageData results.
	 *
	 * @param data - image, imagebitmap, or canvas to parse
	 * @param x - top-left x coordinate to read from the image
	 * @param y - top-left y coordinate to read from the image
	 * @param width - width of the rectangle to read from the image
	 * @param height - height of the rectangle to read from the image
	 * @returns a promise containing the parsed RGBA pixel values of the image
	 */
	function getImageData(image, x, y, width, height) {
	    return __awaiter(this, void 0, void 0, function* () {
	        if (isOffscreenCanvasDistorted()) {
	            try {
	                return yield readImageUsingVideoFrame(image, x, y, width, height);
	            }
	            catch (e) {
	                // fall back to OffscreenCanvas
	            }
	        }
	        return readImageDataUsingOffscreenCanvas(image, x, y, width, height);
	    });
	}
	/**
	 * This method is used in order to register an event listener using a lambda function.
	 * The return value will allow unsubscribing from the event, without the need to store the method reference.
	 * @param target - The target
	 * @param message - The message
	 * @param listener - The listener
	 * @param options - The options
	 * @returns a subscription object that can be used to unsubscribe from the event
	 */
	function subscribe(target, message, listener, options) {
	    target.addEventListener(message, listener, options);
	    return {
	        unsubscribe: () => {
	            target.removeEventListener(message, listener, options);
	        }
	    };
	}
	/**
	 * This method converts degrees to radians.
	 * The return value is the radian value.
	 * @param degrees - The number of degrees
	 * @returns radians
	 */
	function degreesToRadians(degrees) {
	    return degrees * Math.PI / 180;
	}

	/**
	 * An error message to use when an operation is aborted
	 */
	const ABORT_ERROR = 'AbortError';
	/**
	 * Check if an error is an abort error
	 * @param error - An error object
	 * @returns - true if the error is an abort error
	 */
	function isAbortError(error) {
	    return error.message === ABORT_ERROR;
	}
	/**
	 * Use this when you need to create an abort error.
	 * @returns An error object with the message "AbortError"
	 */
	function createAbortError() {
	    return new Error(ABORT_ERROR);
	}

	const config = {
	    MAX_PARALLEL_IMAGE_REQUESTS: 16,
	    MAX_PARALLEL_IMAGE_REQUESTS_PER_FRAME: 8,
	    MAX_TILE_CACHE_ZOOM_LEVELS: 5,
	    REGISTERED_PROTOCOLS: {},
	    WORKER_URL: ''
	};

	function getProtocol(url) {
	    return config.REGISTERED_PROTOCOLS[url.substring(0, url.indexOf('://'))];
	}
	/**
	 * Adds a custom load resource function that will be called when using a URL that starts with a custom url schema.
	 * This will happen in the main thread, and workers might call it if they don't know how to handle the protocol.
	 * The example below will be triggered for custom:// urls defined in the sources list in the style definitions.
	 * The function passed will receive the request parameters and should return with the resulting resource,
	 * for example a pbf vector tile, non-compressed, represented as ArrayBuffer.
	 *
	 * @param customProtocol - the protocol to hook, for example 'custom'
	 * @param loadFn - the function to use when trying to fetch a tile specified by the customProtocol
	 * @example
	 * ```ts
	 * // This will fetch a file using the fetch API (this is obviously a non interesting example...)
	 * addProtocol('custom', async (params, abortController) => {
	 *      const t = await fetch(`https://${params.url.split("://")[1]}`);
	 *      if (t.status == 200) {
	 *          const buffer = await t.arrayBuffer();
	 *          return {data: buffer}
	 *      } else {
	 *          throw new Error(`Tile fetch error: ${t.statusText}`);
	 *      }
	 *  });
	 * // the following is an example of a way to return an error when trying to load a tile
	 * addProtocol('custom2', async (params, abortController) => {
	 *      throw new Error('someErrorMessage'));
	 * });
	 * ```
	 */
	function addProtocol(customProtocol, loadFn) {
	    config.REGISTERED_PROTOCOLS[customProtocol] = loadFn;
	}
	/**
	 * Removes a previously added protocol in the main thread.
	 *
	 * @param customProtocol - the custom protocol to remove registration for
	 * @example
	 * ```ts
	 * removeProtocol('custom');
	 * ```
	 */
	function removeProtocol(customProtocol) {
	    delete config.REGISTERED_PROTOCOLS[customProtocol];
	}

	/**
	 * This is used to identify the global dispatcher id when sending a message from the worker without a target map id.
	 */
	const GLOBAL_DISPATCHER_ID = 'global-dispatcher';
	/**
	 * An error thrown when a HTTP request results in an error response.
	 */
	class AJAXError extends Error {
	    /**
	     * @param status - The response's HTTP status code.
	     * @param statusText - The response's HTTP status text.
	     * @param url - The request's URL.
	     * @param body - The response's body.
	     */
	    constructor(status, statusText, url, body) {
	        super(`AJAXError: ${statusText} (${status}): ${url}`);
	        this.status = status;
	        this.statusText = statusText;
	        this.url = url;
	        this.body = body;
	    }
	}
	/**
	 * Ensure that we're sending the correct referrer from blob URL worker bundles.
	 * For files loaded from the local file system, `location.origin` will be set
	 * to the string(!) "null" (Firefox), or "file://" (Chrome, Safari, Edge),
	 * and we will set an empty referrer. Otherwise, we're using the document's URL.
	 */
	const getReferrer = () => isWorker(self) ?
	    self.worker && self.worker.referrer :
	    (window.location.protocol === 'blob:' ? window.parent : window).location.href;
	/**
	 * Determines whether a URL is a file:// URL. This is obviously the case if it begins
	 * with file://. Relative URLs are also file:// URLs iff the original document was loaded
	 * via a file:// URL.
	 * @param url - The URL to check
	 * @returns `true` if the URL is a file:// URL, `false` otherwise
	 */
	const isFileURL = url => /^file:/.test(url) || (/^file:/.test(getReferrer()) && !/^\w+:/.test(url));
	function makeFetchRequest(requestParameters, abortController) {
	    return __awaiter(this, void 0, void 0, function* () {
	        const request = new Request(requestParameters.url, {
	            method: requestParameters.method || 'GET',
	            body: requestParameters.body,
	            credentials: requestParameters.credentials,
	            headers: requestParameters.headers,
	            cache: requestParameters.cache,
	            referrer: getReferrer(),
	            signal: abortController.signal
	        });
	        if (requestParameters.type === 'json') {
	            request.headers.set('Accept', 'application/json');
	        }
	        const response = yield fetch(request);
	        if (!response.ok) {
	            const body = yield response.blob();
	            throw new AJAXError(response.status, response.statusText, requestParameters.url, body);
	        }
	        let parsePromise;
	        if ((requestParameters.type === 'arrayBuffer' || requestParameters.type === 'image')) {
	            parsePromise = response.arrayBuffer();
	        }
	        else if (requestParameters.type === 'json') {
	            parsePromise = response.json();
	        }
	        else {
	            parsePromise = response.text();
	        }
	        const result = yield parsePromise;
	        if (abortController.signal.aborted) {
	            throw createAbortError();
	        }
	        return { data: result, cacheControl: response.headers.get('Cache-Control'), expires: response.headers.get('Expires') };
	    });
	}
	function makeXMLHttpRequest(requestParameters, abortController) {
	    return new Promise((resolve, reject) => {
	        const xhr = new XMLHttpRequest();
	        xhr.open(requestParameters.method || 'GET', requestParameters.url, true);
	        if (requestParameters.type === 'arrayBuffer' || requestParameters.type === 'image') {
	            xhr.responseType = 'arraybuffer';
	        }
	        for (const k in requestParameters.headers) {
	            xhr.setRequestHeader(k, requestParameters.headers[k]);
	        }
	        if (requestParameters.type === 'json') {
	            xhr.responseType = 'text';
	            xhr.setRequestHeader('Accept', 'application/json');
	        }
	        xhr.withCredentials = requestParameters.credentials === 'include';
	        xhr.onerror = () => {
	            reject(new Error(xhr.statusText));
	        };
	        xhr.onload = () => {
	            if (abortController.signal.aborted) {
	                return;
	            }
	            if (((xhr.status >= 200 && xhr.status < 300) || xhr.status === 0) && xhr.response !== null) {
	                let data = xhr.response;
	                if (requestParameters.type === 'json') {
	                    // We're manually parsing JSON here to get better error messages.
	                    try {
	                        data = JSON.parse(xhr.response);
	                    }
	                    catch (err) {
	                        reject(err);
	                        return;
	                    }
	                }
	                resolve({ data, cacheControl: xhr.getResponseHeader('Cache-Control'), expires: xhr.getResponseHeader('Expires') });
	            }
	            else {
	                const body = new Blob([xhr.response], { type: xhr.getResponseHeader('Content-Type') });
	                reject(new AJAXError(xhr.status, xhr.statusText, requestParameters.url, body));
	            }
	        };
	        abortController.signal.addEventListener('abort', () => {
	            xhr.abort();
	            reject(createAbortError());
	        });
	        xhr.send(requestParameters.body);
	    });
	}
	/**
	 * We're trying to use the Fetch API if possible. However, requests for resources with the file:// URI scheme don't work with the Fetch API.
	 * In this case we unconditionally use XHR on the current thread since referrers don't matter.
	 * This method can also use the registered method if `addProtocol` was called.
	 * @param requestParameters - The request parameters
	 * @param abortController - The abort controller allowing to cancel the request
	 * @returns a promise resolving to the response, including cache control and expiry data
	 */
	const makeRequest = function (requestParameters, abortController) {
	    if (/:\/\//.test(requestParameters.url) && !(/^https?:|^file:/.test(requestParameters.url))) {
	        const protocolLoadFn = getProtocol(requestParameters.url);
	        if (protocolLoadFn) {
	            return protocolLoadFn(requestParameters, abortController);
	        }
	        if (isWorker(self) && self.worker && self.worker.actor) {
	            return self.worker.actor.sendAsync({ type: "GR" /* MessageType.getResource */, data: requestParameters, targetMapId: GLOBAL_DISPATCHER_ID }, abortController);
	        }
	    }
	    if (!isFileURL(requestParameters.url)) {
	        if (fetch && Request && AbortController && Object.prototype.hasOwnProperty.call(Request.prototype, 'signal')) {
	            return makeFetchRequest(requestParameters, abortController);
	        }
	        if (isWorker(self) && self.worker && self.worker.actor) {
	            return self.worker.actor.sendAsync({ type: "GR" /* MessageType.getResource */, data: requestParameters, mustQueue: true, targetMapId: GLOBAL_DISPATCHER_ID }, abortController);
	        }
	    }
	    return makeXMLHttpRequest(requestParameters, abortController);
	};
	const getJSON = (requestParameters, abortController) => {
	    return makeRequest(extend(requestParameters, { type: 'json' }), abortController);
	};
	const getArrayBuffer = (requestParameters, abortController) => {
	    return makeRequest(extend(requestParameters, { type: 'arrayBuffer' }), abortController);
	};
	function sameOrigin(inComingUrl) {
	    // A relative URL "/foo" or "./foo" will throw exception in URL's ctor,
	    // try-catch is expansive so just use a heuristic check to avoid it
	    // also check data URL
	    if (!inComingUrl ||
	        inComingUrl.indexOf('://') <= 0 || // relative URL
	        inComingUrl.indexOf('data:image/') === 0 || // data image URL
	        inComingUrl.indexOf('blob:') === 0) { // blob
	        return true;
	    }
	    const urlObj = new URL(inComingUrl);
	    const locationObj = window.location;
	    return urlObj.protocol === locationObj.protocol && urlObj.host === locationObj.host;
	}
	const getVideo = (urls) => {
	    const video = window.document.createElement('video');
	    video.muted = true;
	    return new Promise((resolve) => {
	        video.onloadstart = () => {
	            resolve(video);
	        };
	        for (const url of urls) {
	            const s = window.document.createElement('source');
	            if (!sameOrigin(url)) {
	                video.crossOrigin = 'Anonymous';
	            }
	            s.src = url;
	            video.appendChild(s);
	        }
	    });
	};

	function _addEventListener(type, listener, listenerList) {
	    const listenerExists = listenerList[type] && listenerList[type].indexOf(listener) !== -1;
	    if (!listenerExists) {
	        listenerList[type] = listenerList[type] || [];
	        listenerList[type].push(listener);
	    }
	}
	function _removeEventListener(type, listener, listenerList) {
	    if (listenerList && listenerList[type]) {
	        const index = listenerList[type].indexOf(listener);
	        if (index !== -1) {
	            listenerList[type].splice(index, 1);
	        }
	    }
	}
	/**
	 * The event class
	 */
	class Event {
	    constructor(type, data = {}) {
	        extend(this, data);
	        this.type = type;
	    }
	}
	/**
	 * An error event
	 */
	class ErrorEvent extends Event {
	    constructor(error, data = {}) {
	        super('error', extend({ error }, data));
	    }
	}
	/**
	 * Methods mixed in to other classes for event capabilities.
	 *
	 * @group Event Related
	 */
	class Evented {
	    /**
	     * Adds a listener to a specified event type.
	     *
	     * @param type - The event type to add a listen for.
	     * @param listener - The function to be called when the event is fired.
	     * The listener function is called with the data object passed to `fire`,
	     * extended with `target` and `type` properties.
	     * @returns `this`
	     */
	    on(type, listener) {
	        this._listeners = this._listeners || {};
	        _addEventListener(type, listener, this._listeners);
	        return this;
	    }
	    /**
	     * Removes a previously registered event listener.
	     *
	     * @param type - The event type to remove listeners for.
	     * @param listener - The listener function to remove.
	     * @returns `this`
	     */
	    off(type, listener) {
	        _removeEventListener(type, listener, this._listeners);
	        _removeEventListener(type, listener, this._oneTimeListeners);
	        return this;
	    }
	    /**
	     * Adds a listener that will be called only once to a specified event type.
	     *
	     * The listener will be called first time the event fires after the listener is registered.
	     *
	     * @param type - The event type to listen for.
	     * @param listener - The function to be called when the event is fired the first time.
	     * @returns `this` or a promise if a listener is not provided
	     */
	    once(type, listener) {
	        if (!listener) {
	            return new Promise((resolve) => this.once(type, resolve));
	        }
	        this._oneTimeListeners = this._oneTimeListeners || {};
	        _addEventListener(type, listener, this._oneTimeListeners);
	        return this;
	    }
	    fire(event, properties) {
	        // Compatibility with (type: string, properties: Object) signature from previous versions.
	        // See https://github.com/mapbox/mapbox-gl-js/issues/6522,
	        //     https://github.com/mapbox/mapbox-gl-draw/issues/766
	        if (typeof event === 'string') {
	            event = new Event(event, properties || {});
	        }
	        const type = event.type;
	        if (this.listens(type)) {
	            event.target = this;
	            // make sure adding or removing listeners inside other listeners won't cause an infinite loop
	            const listeners = this._listeners && this._listeners[type] ? this._listeners[type].slice() : [];
	            for (const listener of listeners) {
	                listener.call(this, event);
	            }
	            const oneTimeListeners = this._oneTimeListeners && this._oneTimeListeners[type] ? this._oneTimeListeners[type].slice() : [];
	            for (const listener of oneTimeListeners) {
	                _removeEventListener(type, listener, this._oneTimeListeners);
	                listener.call(this, event);
	            }
	            const parent = this._eventedParent;
	            if (parent) {
	                extend(event, typeof this._eventedParentData === 'function' ? this._eventedParentData() : this._eventedParentData);
	                parent.fire(event);
	            }
	            // To ensure that no error events are dropped, print them to the
	            // console if they have no listeners.
	        }
	        else if (event instanceof ErrorEvent) {
	            console.error(event.error);
	        }
	        return this;
	    }
	    /**
	     * Returns a true if this instance of Evented or any forwardeed instances of Evented have a listener for the specified type.
	     *
	     * @param type - The event type
	     * @returns `true` if there is at least one registered listener for specified event type, `false` otherwise
	     */
	    listens(type) {
	        return ((this._listeners && this._listeners[type] && this._listeners[type].length > 0) ||
	            (this._oneTimeListeners && this._oneTimeListeners[type] && this._oneTimeListeners[type].length > 0) ||
	            (this._eventedParent && this._eventedParent.listens(type)));
	    }
	    /**
	     * Bubble all events fired by this instance of Evented to this parent instance of Evented.
	     * @returns `this`
	     */
	    setEventedParent(parent, data) {
	        this._eventedParent = parent;
	        this._eventedParentData = data;
	        return this;
	    }
	}

	var $version = 8;
	var $root = {
		version: {
			required: true,
			type: "enum",
			values: [
				8
			]
		},
		name: {
			type: "string"
		},
		metadata: {
			type: "*"
		},
		center: {
			type: "array",
			value: "number"
		},
		zoom: {
			type: "number"
		},
		bearing: {
			type: "number",
			"default": 0,
			period: 360,
			units: "degrees"
		},
		pitch: {
			type: "number",
			"default": 0,
			units: "degrees"
		},
		light: {
			type: "light"
		},
		sky: {
			type: "sky"
		},
		terrain: {
			type: "terrain"
		},
		sources: {
			required: true,
			type: "sources"
		},
		sprite: {
			type: "sprite"
		},
		glyphs: {
			type: "string"
		},
		transition: {
			type: "transition"
		},
		layers: {
			required: true,
			type: "array",
			value: "layer"
		}
	};
	var sources = {
		"*": {
			type: "source"
		}
	};
	var source = [
		"source_vector",
		"source_raster",
		"source_raster_dem",
		"source_geojson",
		"source_video",
		"source_image"
	];
	var source_vector = {
		type: {
			required: true,
			type: "enum",
			values: {
				vector: {
				}
			}
		},
		url: {
			type: "string"
		},
		tiles: {
			type: "array",
			value: "string"
		},
		bounds: {
			type: "array",
			value: "number",
			length: 4,
			"default": [
				-180,
				-85.051129,
				180,
				85.051129
			]
		},
		scheme: {
			type: "enum",
			values: {
				xyz: {
				},
				tms: {
				}
			},
			"default": "xyz"
		},
		minzoom: {
			type: "number",
			"default": 0
		},
		maxzoom: {
			type: "number",
			"default": 22
		},
		attribution: {
			type: "string"
		},
		promoteId: {
			type: "promoteId"
		},
		volatile: {
			type: "boolean",
			"default": false
		},
		"*": {
			type: "*"
		}
	};
	var source_raster = {
		type: {
			required: true,
			type: "enum",
			values: {
				raster: {
				}
			}
		},
		url: {
			type: "string"
		},
		tiles: {
			type: "array",
			value: "string"
		},
		bounds: {
			type: "array",
			value: "number",
			length: 4,
			"default": [
				-180,
				-85.051129,
				180,
				85.051129
			]
		},
		minzoom: {
			type: "number",
			"default": 0
		},
		maxzoom: {
			type: "number",
			"default": 22
		},
		tileSize: {
			type: "number",
			"default": 512,
			units: "pixels"
		},
		scheme: {
			type: "enum",
			values: {
				xyz: {
				},
				tms: {
				}
			},
			"default": "xyz"
		},
		attribution: {
			type: "string"
		},
		volatile: {
			type: "boolean",
			"default": false
		},
		"*": {
			type: "*"
		}
	};
	var source_raster_dem = {
		type: {
			required: true,
			type: "enum",
			values: {
				"raster-dem": {
				}
			}
		},
		url: {
			type: "string"
		},
		tiles: {
			type: "array",
			value: "string"
		},
		bounds: {
			type: "array",
			value: "number",
			length: 4,
			"default": [
				-180,
				-85.051129,
				180,
				85.051129
			]
		},
		minzoom: {
			type: "number",
			"default": 0
		},
		maxzoom: {
			type: "number",
			"default": 22
		},
		tileSize: {
			type: "number",
			"default": 512,
			units: "pixels"
		},
		attribution: {
			type: "string"
		},
		encoding: {
			type: "enum",
			values: {
				terrarium: {
				},
				mapbox: {
				},
				custom: {
				}
			},
			"default": "mapbox"
		},
		redFactor: {
			type: "number",
			"default": 1
		},
		blueFactor: {
			type: "number",
			"default": 1
		},
		greenFactor: {
			type: "number",
			"default": 1
		},
		baseShift: {
			type: "number",
			"default": 0
		},
		volatile: {
			type: "boolean",
			"default": false
		},
		"*": {
			type: "*"
		}
	};
	var source_geojson = {
		type: {
			required: true,
			type: "enum",
			values: {
				geojson: {
				}
			}
		},
		data: {
			required: true,
			type: "*"
		},
		maxzoom: {
			type: "number",
			"default": 18
		},
		attribution: {
			type: "string"
		},
		buffer: {
			type: "number",
			"default": 128,
			maximum: 512,
			minimum: 0
		},
		filter: {
			type: "*"
		},
		tolerance: {
			type: "number",
			"default": 0.375
		},
		cluster: {
			type: "boolean",
			"default": false
		},
		clusterRadius: {
			type: "number",
			"default": 50,
			minimum: 0
		},
		clusterMaxZoom: {
			type: "number"
		},
		clusterMinPoints: {
			type: "number"
		},
		clusterProperties: {
			type: "*"
		},
		lineMetrics: {
			type: "boolean",
			"default": false
		},
		generateId: {
			type: "boolean",
			"default": false
		},
		promoteId: {
			type: "promoteId"
		}
	};
	var source_video = {
		type: {
			required: true,
			type: "enum",
			values: {
				video: {
				}
			}
		},
		urls: {
			required: true,
			type: "array",
			value: "string"
		},
		coordinates: {
			required: true,
			type: "array",
			length: 4,
			value: {
				type: "array",
				length: 2,
				value: "number"
			}
		}
	};
	var source_image = {
		type: {
			required: true,
			type: "enum",
			values: {
				image: {
				}
			}
		},
		url: {
			required: true,
			type: "string"
		},
		coordinates: {
			required: true,
			type: "array",
			length: 4,
			value: {
				type: "array",
				length: 2,
				value: "number"
			}
		}
	};
	var layer = {
		id: {
			type: "string",
			required: true
		},
		type: {
			type: "enum",
			values: {
				fill: {
				},
				line: {
				},
				symbol: {
				},
				circle: {
				},
				heatmap: {
				},
				"fill-extrusion": {
				},
				raster: {
				},
				hillshade: {
				},
				background: {
				}
			},
			required: true
		},
		metadata: {
			type: "*"
		},
		source: {
			type: "string"
		},
		"source-layer": {
			type: "string"
		},
		minzoom: {
			type: "number",
			minimum: 0,
			maximum: 24
		},
		maxzoom: {
			type: "number",
			minimum: 0,
			maximum: 24
		},
		filter: {
			type: "filter"
		},
		layout: {
			type: "layout"
		},
		paint: {
			type: "paint"
		}
	};
	var layout$7 = [
		"layout_fill",
		"layout_line",
		"layout_circle",
		"layout_heatmap",
		"layout_fill-extrusion",
		"layout_symbol",
		"layout_raster",
		"layout_hillshade",
		"layout_background"
	];
	var layout_background = {
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var layout_fill = {
		"fill-sort-key": {
			type: "number",
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var layout_circle = {
		"circle-sort-key": {
			type: "number",
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var layout_heatmap = {
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var layout_line = {
		"line-cap": {
			type: "enum",
			values: {
				butt: {
				},
				round: {
				},
				square: {
				}
			},
			"default": "butt",
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"line-join": {
			type: "enum",
			values: {
				bevel: {
				},
				round: {
				},
				miter: {
				}
			},
			"default": "miter",
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"line-miter-limit": {
			type: "number",
			"default": 2,
			requires: [
				{
					"line-join": "miter"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"line-round-limit": {
			type: "number",
			"default": 1.05,
			requires: [
				{
					"line-join": "round"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"line-sort-key": {
			type: "number",
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var layout_symbol = {
		"symbol-placement": {
			type: "enum",
			values: {
				point: {
				},
				line: {
				},
				"line-center": {
				}
			},
			"default": "point",
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"symbol-spacing": {
			type: "number",
			"default": 250,
			minimum: 1,
			units: "pixels",
			requires: [
				{
					"symbol-placement": "line"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"symbol-avoid-edges": {
			type: "boolean",
			"default": false,
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"symbol-sort-key": {
			type: "number",
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"symbol-z-order": {
			type: "enum",
			values: {
				auto: {
				},
				"viewport-y": {
				},
				source: {
				}
			},
			"default": "auto",
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-allow-overlap": {
			type: "boolean",
			"default": false,
			requires: [
				"icon-image",
				{
					"!": "icon-overlap"
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-overlap": {
			type: "enum",
			values: {
				never: {
				},
				always: {
				},
				cooperative: {
				}
			},
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-ignore-placement": {
			type: "boolean",
			"default": false,
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-optional": {
			type: "boolean",
			"default": false,
			requires: [
				"icon-image",
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-rotation-alignment": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				},
				auto: {
				}
			},
			"default": "auto",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-size": {
			type: "number",
			"default": 1,
			minimum: 0,
			units: "factor of the original icon size",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"icon-text-fit": {
			type: "enum",
			values: {
				none: {
				},
				width: {
				},
				height: {
				},
				both: {
				}
			},
			"default": "none",
			requires: [
				"icon-image",
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-text-fit-padding": {
			type: "array",
			value: "number",
			length: 4,
			"default": [
				0,
				0,
				0,
				0
			],
			units: "pixels",
			requires: [
				"icon-image",
				"text-field",
				{
					"icon-text-fit": [
						"both",
						"width",
						"height"
					]
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-image": {
			type: "resolvedImage",
			tokens: true,
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"icon-rotate": {
			type: "number",
			"default": 0,
			period: 360,
			units: "degrees",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"icon-padding": {
			type: "padding",
			"default": [
				2
			],
			units: "pixels",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"icon-keep-upright": {
			type: "boolean",
			"default": false,
			requires: [
				"icon-image",
				{
					"icon-rotation-alignment": "map"
				},
				{
					"symbol-placement": [
						"line",
						"line-center"
					]
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-offset": {
			type: "array",
			value: "number",
			length: 2,
			"default": [
				0,
				0
			],
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"icon-anchor": {
			type: "enum",
			values: {
				center: {
				},
				left: {
				},
				right: {
				},
				top: {
				},
				bottom: {
				},
				"top-left": {
				},
				"top-right": {
				},
				"bottom-left": {
				},
				"bottom-right": {
				}
			},
			"default": "center",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"icon-pitch-alignment": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				},
				auto: {
				}
			},
			"default": "auto",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-pitch-alignment": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				},
				auto: {
				}
			},
			"default": "auto",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-rotation-alignment": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				},
				"viewport-glyph": {
				},
				auto: {
				}
			},
			"default": "auto",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-field": {
			type: "formatted",
			"default": "",
			tokens: true,
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-font": {
			type: "array",
			value: "string",
			"default": [
				"Open Sans Regular",
				"Arial Unicode MS Regular"
			],
			requires: [
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-size": {
			type: "number",
			"default": 16,
			minimum: 0,
			units: "pixels",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-max-width": {
			type: "number",
			"default": 10,
			minimum: 0,
			units: "ems",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-line-height": {
			type: "number",
			"default": 1.2,
			units: "ems",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-letter-spacing": {
			type: "number",
			"default": 0,
			units: "ems",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-justify": {
			type: "enum",
			values: {
				auto: {
				},
				left: {
				},
				center: {
				},
				right: {
				}
			},
			"default": "center",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-radial-offset": {
			type: "number",
			units: "ems",
			"default": 0,
			requires: [
				"text-field"
			],
			"property-type": "data-driven",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			}
		},
		"text-variable-anchor": {
			type: "array",
			value: "enum",
			values: {
				center: {
				},
				left: {
				},
				right: {
				},
				top: {
				},
				bottom: {
				},
				"top-left": {
				},
				"top-right": {
				},
				"bottom-left": {
				},
				"bottom-right": {
				}
			},
			requires: [
				"text-field",
				{
					"symbol-placement": [
						"point"
					]
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-variable-anchor-offset": {
			type: "variableAnchorOffsetCollection",
			requires: [
				"text-field",
				{
					"symbol-placement": [
						"point"
					]
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-anchor": {
			type: "enum",
			values: {
				center: {
				},
				left: {
				},
				right: {
				},
				top: {
				},
				bottom: {
				},
				"top-left": {
				},
				"top-right": {
				},
				"bottom-left": {
				},
				"bottom-right": {
				}
			},
			"default": "center",
			requires: [
				"text-field",
				{
					"!": "text-variable-anchor"
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-max-angle": {
			type: "number",
			"default": 45,
			units: "degrees",
			requires: [
				"text-field",
				{
					"symbol-placement": [
						"line",
						"line-center"
					]
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-writing-mode": {
			type: "array",
			value: "enum",
			values: {
				horizontal: {
				},
				vertical: {
				}
			},
			requires: [
				"text-field",
				{
					"symbol-placement": [
						"point"
					]
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-rotate": {
			type: "number",
			"default": 0,
			period: 360,
			units: "degrees",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-padding": {
			type: "number",
			"default": 2,
			minimum: 0,
			units: "pixels",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-keep-upright": {
			type: "boolean",
			"default": true,
			requires: [
				"text-field",
				{
					"text-rotation-alignment": "map"
				},
				{
					"symbol-placement": [
						"line",
						"line-center"
					]
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-transform": {
			type: "enum",
			values: {
				none: {
				},
				uppercase: {
				},
				lowercase: {
				}
			},
			"default": "none",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-offset": {
			type: "array",
			value: "number",
			units: "ems",
			length: 2,
			"default": [
				0,
				0
			],
			requires: [
				"text-field",
				{
					"!": "text-radial-offset"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "data-driven"
		},
		"text-allow-overlap": {
			type: "boolean",
			"default": false,
			requires: [
				"text-field",
				{
					"!": "text-overlap"
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-overlap": {
			type: "enum",
			values: {
				never: {
				},
				always: {
				},
				cooperative: {
				}
			},
			requires: [
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-ignore-placement": {
			type: "boolean",
			"default": false,
			requires: [
				"text-field"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-optional": {
			type: "boolean",
			"default": false,
			requires: [
				"text-field",
				"icon-image"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var layout_raster = {
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var layout_hillshade = {
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	};
	var filter = {
		type: "array",
		value: "*"
	};
	var filter_operator = {
		type: "enum",
		values: {
			"==": {
			},
			"!=": {
			},
			">": {
			},
			">=": {
			},
			"<": {
			},
			"<=": {
			},
			"in": {
			},
			"!in": {
			},
			all: {
			},
			any: {
			},
			none: {
			},
			has: {
			},
			"!has": {
			},
			within: {
			}
		}
	};
	var geometry_type = {
		type: "enum",
		values: {
			Point: {
			},
			LineString: {
			},
			Polygon: {
			}
		}
	};
	var function_stop = {
		type: "array",
		minimum: 0,
		maximum: 24,
		value: [
			"number",
			"color"
		],
		length: 2
	};
	var expression$1 = {
		type: "array",
		value: "*",
		minimum: 1
	};
	var light = {
		anchor: {
			type: "enum",
			"default": "viewport",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"property-type": "data-constant",
			transition: false,
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			}
		},
		position: {
			type: "array",
			"default": [
				1.15,
				210,
				30
			],
			length: 3,
			value: "number",
			"property-type": "data-constant",
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			}
		},
		color: {
			type: "color",
			"property-type": "data-constant",
			"default": "#ffffff",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			transition: true
		},
		intensity: {
			type: "number",
			"property-type": "data-constant",
			"default": 0.5,
			minimum: 0,
			maximum: 1,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			transition: true
		}
	};
	var sky = {
		"sky-color": {
			type: "color",
			"property-type": "data-constant",
			"default": "#88C6FC",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			transition: true
		},
		"fog-color": {
			type: "color",
			"property-type": "data-constant",
			"default": "#ffffff",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			transition: true
		},
		"fog-blend": {
			type: "number",
			"property-type": "data-constant",
			"default": 0.5,
			minimum: 0,
			maximum: 1,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			transition: true
		},
		"horizon-blend": {
			type: "number",
			"property-type": "data-constant",
			"default": 0.8,
			minimum: 0,
			maximum: 1,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			transition: true
		}
	};
	var terrain = {
		source: {
			type: "string",
			required: true
		},
		exaggeration: {
			type: "number",
			minimum: 0,
			"default": 1
		}
	};
	var paint$9 = [
		"paint_fill",
		"paint_line",
		"paint_circle",
		"paint_heatmap",
		"paint_fill-extrusion",
		"paint_symbol",
		"paint_raster",
		"paint_hillshade",
		"paint_background"
	];
	var paint_fill = {
		"fill-antialias": {
			type: "boolean",
			"default": true,
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"fill-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"fill-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			requires: [
				{
					"!": "fill-pattern"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"fill-outline-color": {
			type: "color",
			transition: true,
			requires: [
				{
					"!": "fill-pattern"
				},
				{
					"fill-antialias": true
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"fill-translate": {
			type: "array",
			value: "number",
			length: 2,
			"default": [
				0,
				0
			],
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"fill-translate-anchor": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "map",
			requires: [
				"fill-translate"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"fill-pattern": {
			type: "resolvedImage",
			transition: true,
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "cross-faded-data-driven"
		}
	};
	var paint_line = {
		"line-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"line-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			requires: [
				{
					"!": "line-pattern"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"line-translate": {
			type: "array",
			value: "number",
			length: 2,
			"default": [
				0,
				0
			],
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"line-translate-anchor": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "map",
			requires: [
				"line-translate"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"line-width": {
			type: "number",
			"default": 1,
			minimum: 0,
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"line-gap-width": {
			type: "number",
			"default": 0,
			minimum: 0,
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"line-offset": {
			type: "number",
			"default": 0,
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"line-blur": {
			type: "number",
			"default": 0,
			minimum: 0,
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"line-dasharray": {
			type: "array",
			value: "number",
			minimum: 0,
			transition: true,
			units: "line widths",
			requires: [
				{
					"!": "line-pattern"
				}
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "cross-faded"
		},
		"line-pattern": {
			type: "resolvedImage",
			transition: true,
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "cross-faded-data-driven"
		},
		"line-gradient": {
			type: "color",
			transition: false,
			requires: [
				{
					"!": "line-dasharray"
				},
				{
					"!": "line-pattern"
				},
				{
					source: "geojson",
					has: {
						lineMetrics: true
					}
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"line-progress"
				]
			},
			"property-type": "color-ramp"
		}
	};
	var paint_circle = {
		"circle-radius": {
			type: "number",
			"default": 5,
			minimum: 0,
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"circle-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"circle-blur": {
			type: "number",
			"default": 0,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"circle-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"circle-translate": {
			type: "array",
			value: "number",
			length: 2,
			"default": [
				0,
				0
			],
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"circle-translate-anchor": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "map",
			requires: [
				"circle-translate"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"circle-pitch-scale": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "map",
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"circle-pitch-alignment": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "viewport",
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"circle-stroke-width": {
			type: "number",
			"default": 0,
			minimum: 0,
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"circle-stroke-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"circle-stroke-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		}
	};
	var paint_heatmap = {
		"heatmap-radius": {
			type: "number",
			"default": 30,
			minimum: 1,
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"heatmap-weight": {
			type: "number",
			"default": 1,
			minimum: 0,
			transition: false,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"heatmap-intensity": {
			type: "number",
			"default": 1,
			minimum: 0,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"heatmap-color": {
			type: "color",
			"default": [
				"interpolate",
				[
					"linear"
				],
				[
					"heatmap-density"
				],
				0,
				"rgba(0, 0, 255, 0)",
				0.1,
				"royalblue",
				0.3,
				"cyan",
				0.5,
				"lime",
				0.7,
				"yellow",
				1,
				"red"
			],
			transition: false,
			expression: {
				interpolated: true,
				parameters: [
					"heatmap-density"
				]
			},
			"property-type": "color-ramp"
		},
		"heatmap-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		}
	};
	var paint_symbol = {
		"icon-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"icon-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"icon-halo-color": {
			type: "color",
			"default": "rgba(0, 0, 0, 0)",
			transition: true,
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"icon-halo-width": {
			type: "number",
			"default": 0,
			minimum: 0,
			transition: true,
			units: "pixels",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"icon-halo-blur": {
			type: "number",
			"default": 0,
			minimum: 0,
			transition: true,
			units: "pixels",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"icon-translate": {
			type: "array",
			value: "number",
			length: 2,
			"default": [
				0,
				0
			],
			transition: true,
			units: "pixels",
			requires: [
				"icon-image"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"icon-translate-anchor": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "map",
			requires: [
				"icon-image",
				"icon-translate"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"text-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			overridable: true,
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"text-halo-color": {
			type: "color",
			"default": "rgba(0, 0, 0, 0)",
			transition: true,
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"text-halo-width": {
			type: "number",
			"default": 0,
			minimum: 0,
			transition: true,
			units: "pixels",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"text-halo-blur": {
			type: "number",
			"default": 0,
			minimum: 0,
			transition: true,
			units: "pixels",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"text-translate": {
			type: "array",
			value: "number",
			length: 2,
			"default": [
				0,
				0
			],
			transition: true,
			units: "pixels",
			requires: [
				"text-field"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"text-translate-anchor": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "map",
			requires: [
				"text-field",
				"text-translate"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		}
	};
	var paint_raster = {
		"raster-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"raster-hue-rotate": {
			type: "number",
			"default": 0,
			period: 360,
			transition: true,
			units: "degrees",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"raster-brightness-min": {
			type: "number",
			"default": 0,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"raster-brightness-max": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"raster-saturation": {
			type: "number",
			"default": 0,
			minimum: -1,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"raster-contrast": {
			type: "number",
			"default": 0,
			minimum: -1,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"raster-resampling": {
			type: "enum",
			values: {
				linear: {
				},
				nearest: {
				}
			},
			"default": "linear",
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"raster-fade-duration": {
			type: "number",
			"default": 300,
			minimum: 0,
			transition: false,
			units: "milliseconds",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		}
	};
	var paint_hillshade = {
		"hillshade-illumination-direction": {
			type: "number",
			"default": 335,
			minimum: 0,
			maximum: 359,
			transition: false,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"hillshade-illumination-anchor": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "viewport",
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"hillshade-exaggeration": {
			type: "number",
			"default": 0.5,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"hillshade-shadow-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"hillshade-highlight-color": {
			type: "color",
			"default": "#FFFFFF",
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"hillshade-accent-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		}
	};
	var paint_background = {
		"background-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			requires: [
				{
					"!": "background-pattern"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"background-pattern": {
			type: "resolvedImage",
			transition: true,
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "cross-faded"
		},
		"background-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		}
	};
	var transition = {
		duration: {
			type: "number",
			"default": 300,
			minimum: 0,
			units: "milliseconds"
		},
		delay: {
			type: "number",
			"default": 0,
			minimum: 0,
			units: "milliseconds"
		}
	};
	var promoteId = {
		"*": {
			type: "string"
		}
	};
	var v8Spec = {
		$version: $version,
		$root: $root,
		sources: sources,
		source: source,
		source_vector: source_vector,
		source_raster: source_raster,
		source_raster_dem: source_raster_dem,
		source_geojson: source_geojson,
		source_video: source_video,
		source_image: source_image,
		layer: layer,
		layout: layout$7,
		layout_background: layout_background,
		layout_fill: layout_fill,
		layout_circle: layout_circle,
		layout_heatmap: layout_heatmap,
		"layout_fill-extrusion": {
		visibility: {
			type: "enum",
			values: {
				visible: {
				},
				none: {
				}
			},
			"default": "visible",
			"property-type": "constant"
		}
	},
		layout_line: layout_line,
		layout_symbol: layout_symbol,
		layout_raster: layout_raster,
		layout_hillshade: layout_hillshade,
		filter: filter,
		filter_operator: filter_operator,
		geometry_type: geometry_type,
		"function": {
		expression: {
			type: "expression"
		},
		stops: {
			type: "array",
			value: "function_stop"
		},
		base: {
			type: "number",
			"default": 1,
			minimum: 0
		},
		property: {
			type: "string",
			"default": "$zoom"
		},
		type: {
			type: "enum",
			values: {
				identity: {
				},
				exponential: {
				},
				interval: {
				},
				categorical: {
				}
			},
			"default": "exponential"
		},
		colorSpace: {
			type: "enum",
			values: {
				rgb: {
				},
				lab: {
				},
				hcl: {
				}
			},
			"default": "rgb"
		},
		"default": {
			type: "*",
			required: false
		}
	},
		function_stop: function_stop,
		expression: expression$1,
		light: light,
		sky: sky,
		terrain: terrain,
		paint: paint$9,
		paint_fill: paint_fill,
		"paint_fill-extrusion": {
		"fill-extrusion-opacity": {
			type: "number",
			"default": 1,
			minimum: 0,
			maximum: 1,
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"fill-extrusion-color": {
			type: "color",
			"default": "#000000",
			transition: true,
			requires: [
				{
					"!": "fill-extrusion-pattern"
				}
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"fill-extrusion-translate": {
			type: "array",
			value: "number",
			length: 2,
			"default": [
				0,
				0
			],
			transition: true,
			units: "pixels",
			expression: {
				interpolated: true,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"fill-extrusion-translate-anchor": {
			type: "enum",
			values: {
				map: {
				},
				viewport: {
				}
			},
			"default": "map",
			requires: [
				"fill-extrusion-translate"
			],
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		},
		"fill-extrusion-pattern": {
			type: "resolvedImage",
			transition: true,
			expression: {
				interpolated: false,
				parameters: [
					"zoom",
					"feature"
				]
			},
			"property-type": "cross-faded-data-driven"
		},
		"fill-extrusion-height": {
			type: "number",
			"default": 0,
			minimum: 0,
			units: "meters",
			transition: true,
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"fill-extrusion-base": {
			type: "number",
			"default": 0,
			minimum: 0,
			units: "meters",
			transition: true,
			requires: [
				"fill-extrusion-height"
			],
			expression: {
				interpolated: true,
				parameters: [
					"zoom",
					"feature",
					"feature-state"
				]
			},
			"property-type": "data-driven"
		},
		"fill-extrusion-vertical-gradient": {
			type: "boolean",
			"default": true,
			transition: false,
			expression: {
				interpolated: false,
				parameters: [
					"zoom"
				]
			},
			"property-type": "data-constant"
		}
	},
		paint_line: paint_line,
		paint_circle: paint_circle,
		paint_heatmap: paint_heatmap,
		paint_symbol: paint_symbol,
		paint_raster: paint_raster,
		paint_hillshade: paint_hillshade,
		paint_background: paint_background,
		transition: transition,
		"property-type": {
		"data-driven": {
			type: "property-type"
		},
		"cross-faded": {
			type: "property-type"
		},
		"cross-faded-data-driven": {
			type: "property-type"
		},
		"color-ramp": {
			type: "property-type"
		},
		"data-constant": {
			type: "property-type"
		},
		constant: {
			type: "property-type"
		}
	},
		promoteId: promoteId
	};

	const refProperties = ['type', 'source', 'source-layer', 'minzoom', 'maxzoom', 'filter', 'layout'];

	function deref(layer, parent) {
	    const result = {};
	    for (const k in layer) {
	        if (k !== 'ref') {
	            result[k] = layer[k];
	        }
	    }
	    refProperties.forEach((k) => {
	        if (k in parent) {
	            result[k] = parent[k];
	        }
	    });
	    return result;
	}
	/**
	 * Given an array of layers, some of which may contain `ref` properties
	 * whose value is the `id` of another property, return a new array where
	 * such layers have been augmented with the 'type', 'source', etc. properties
	 * from the parent layer, and the `ref` property has been removed.
	 *
	 * The input is not modified. The output may contain references to portions
	 * of the input.
	 *
	 * @private
	 * @param {Array<Layer>} layers
	 * @returns {Array<Layer>}
	 */
	function derefLayers(layers) {
	    layers = layers.slice();
	    const map = Object.create(null);
	    for (let i = 0; i < layers.length; i++) {
	        map[layers[i].id] = layers[i];
	    }
	    for (let i = 0; i < layers.length; i++) {
	        if ('ref' in layers[i]) {
	            layers[i] = deref(layers[i], map[layers[i].ref]);
	        }
	    }
	    return layers;
	}

	/**
	 * Deeply compares two object literals.
	 *
	 * @private
	 */
	function deepEqual(a, b) {
	    if (Array.isArray(a)) {
	        if (!Array.isArray(b) || a.length !== b.length)
	            return false;
	        for (let i = 0; i < a.length; i++) {
	            if (!deepEqual(a[i], b[i]))
	                return false;
	        }
	        return true;
	    }
	    if (typeof a === 'object' && a !== null && b !== null) {
	        if (!(typeof b === 'object'))
	            return false;
	        const keys = Object.keys(a);
	        if (keys.length !== Object.keys(b).length)
	            return false;
	        for (const key in a) {
	            if (!deepEqual(a[key], b[key]))
	                return false;
	        }
	        return true;
	    }
	    return a === b;
	}

	/**
	 * The main reason for this method is to allow type check when adding a command to the array.
	 * @param commands - The commands array to add to
	 * @param command - The command to add
	 */
	function addCommand(commands, command) {
	    commands.push(command);
	}
	function addSource(sourceId, after, commands) {
	    addCommand(commands, { command: 'addSource', args: [sourceId, after[sourceId]] });
	}
	function removeSource(sourceId, commands, sourcesRemoved) {
	    addCommand(commands, { command: 'removeSource', args: [sourceId] });
	    sourcesRemoved[sourceId] = true;
	}
	function updateSource(sourceId, after, commands, sourcesRemoved) {
	    removeSource(sourceId, commands, sourcesRemoved);
	    addSource(sourceId, after, commands);
	}
	function canUpdateGeoJSON(before, after, sourceId) {
	    let prop;
	    for (prop in before[sourceId]) {
	        if (!Object.prototype.hasOwnProperty.call(before[sourceId], prop))
	            continue;
	        if (prop !== 'data' && !deepEqual(before[sourceId][prop], after[sourceId][prop])) {
	            return false;
	        }
	    }
	    for (prop in after[sourceId]) {
	        if (!Object.prototype.hasOwnProperty.call(after[sourceId], prop))
	            continue;
	        if (prop !== 'data' && !deepEqual(before[sourceId][prop], after[sourceId][prop])) {
	            return false;
	        }
	    }
	    return true;
	}
	function diffSources(before, after, commands, sourcesRemoved) {
	    before = before || {};
	    after = after || {};
	    let sourceId;
	    // look for sources to remove
	    for (sourceId in before) {
	        if (!Object.prototype.hasOwnProperty.call(before, sourceId))
	            continue;
	        if (!Object.prototype.hasOwnProperty.call(after, sourceId)) {
	            removeSource(sourceId, commands, sourcesRemoved);
	        }
	    }
	    // look for sources to add/update
	    for (sourceId in after) {
	        if (!Object.prototype.hasOwnProperty.call(after, sourceId))
	            continue;
	        if (!Object.prototype.hasOwnProperty.call(before, sourceId)) {
	            addSource(sourceId, after, commands);
	        }
	        else if (!deepEqual(before[sourceId], after[sourceId])) {
	            if (before[sourceId].type === 'geojson' && after[sourceId].type === 'geojson' && canUpdateGeoJSON(before, after, sourceId)) {
	                addCommand(commands, { command: 'setGeoJSONSourceData', args: [sourceId, after[sourceId].data] });
	            }
	            else {
	                // no update command, must remove then add
	                updateSource(sourceId, after, commands, sourcesRemoved);
	            }
	        }
	    }
	}
	function diffLayerPropertyChanges(before, after, commands, layerId, klass, command) {
	    before = before || {};
	    after = after || {};
	    for (const prop in before) {
	        if (!Object.prototype.hasOwnProperty.call(before, prop))
	            continue;
	        if (!deepEqual(before[prop], after[prop])) {
	            commands.push({ command, args: [layerId, prop, after[prop], klass] });
	        }
	    }
	    for (const prop in after) {
	        if (!Object.prototype.hasOwnProperty.call(after, prop) || Object.prototype.hasOwnProperty.call(before, prop))
	            continue;
	        if (!deepEqual(before[prop], after[prop])) {
	            commands.push({ command, args: [layerId, prop, after[prop], klass] });
	        }
	    }
	}
	function pluckId(layer) {
	    return layer.id;
	}
	function indexById(group, layer) {
	    group[layer.id] = layer;
	    return group;
	}
	function diffLayers(before, after, commands) {
	    before = before || [];
	    after = after || [];
	    // order of layers by id
	    const beforeOrder = before.map(pluckId);
	    const afterOrder = after.map(pluckId);
	    // index of layer by id
	    const beforeIndex = before.reduce(indexById, {});
	    const afterIndex = after.reduce(indexById, {});
	    // track order of layers as if they have been mutated
	    const tracker = beforeOrder.slice();
	    // layers that have been added do not need to be diffed
	    const clean = Object.create(null);
	    let layerId;
	    let beforeLayer;
	    let afterLayer;
	    let insertBeforeLayerId;
	    let prop;
	    // remove layers
	    for (let i = 0, d = 0; i < beforeOrder.length; i++) {
	        layerId = beforeOrder[i];
	        if (!Object.prototype.hasOwnProperty.call(afterIndex, layerId)) {
	            addCommand(commands, { command: 'removeLayer', args: [layerId] });
	            tracker.splice(tracker.indexOf(layerId, d), 1);
	        }
	        else {
	            // limit where in tracker we need to look for a match
	            d++;
	        }
	    }
	    // add/reorder layers
	    for (let i = 0, d = 0; i < afterOrder.length; i++) {
	        // work backwards as insert is before an existing layer
	        layerId = afterOrder[afterOrder.length - 1 - i];
	        if (tracker[tracker.length - 1 - i] === layerId)
	            continue;
	        if (Object.prototype.hasOwnProperty.call(beforeIndex, layerId)) {
	            // remove the layer before we insert at the correct position
	            addCommand(commands, { command: 'removeLayer', args: [layerId] });
	            tracker.splice(tracker.lastIndexOf(layerId, tracker.length - d), 1);
	        }
	        else {
	            // limit where in tracker we need to look for a match
	            d++;
	        }
	        // add layer at correct position
	        insertBeforeLayerId = tracker[tracker.length - i];
	        addCommand(commands, { command: 'addLayer', args: [afterIndex[layerId], insertBeforeLayerId] });
	        tracker.splice(tracker.length - i, 0, layerId);
	        clean[layerId] = true;
	    }
	    // update layers
	    for (let i = 0; i < afterOrder.length; i++) {
	        layerId = afterOrder[i];
	        beforeLayer = beforeIndex[layerId];
	        afterLayer = afterIndex[layerId];
	        // no need to update if previously added (new or moved)
	        if (clean[layerId] || deepEqual(beforeLayer, afterLayer))
	            continue;
	        // If source, source-layer, or type have changes, then remove the layer
	        // and add it back 'from scratch'.
	        if (!deepEqual(beforeLayer.source, afterLayer.source) || !deepEqual(beforeLayer['source-layer'], afterLayer['source-layer']) || !deepEqual(beforeLayer.type, afterLayer.type)) {
	            addCommand(commands, { command: 'removeLayer', args: [layerId] });
	            // we add the layer back at the same position it was already in, so
	            // there's no need to update the `tracker`
	            insertBeforeLayerId = tracker[tracker.lastIndexOf(layerId) + 1];
	            addCommand(commands, { command: 'addLayer', args: [afterLayer, insertBeforeLayerId] });
	            continue;
	        }
	        // layout, paint, filter, minzoom, maxzoom
	        diffLayerPropertyChanges(beforeLayer.layout, afterLayer.layout, commands, layerId, null, 'setLayoutProperty');
	        diffLayerPropertyChanges(beforeLayer.paint, afterLayer.paint, commands, layerId, null, 'setPaintProperty');
	        if (!deepEqual(beforeLayer.filter, afterLayer.filter)) {
	            addCommand(commands, { command: 'setFilter', args: [layerId, afterLayer.filter] });
	        }
	        if (!deepEqual(beforeLayer.minzoom, afterLayer.minzoom) || !deepEqual(beforeLayer.maxzoom, afterLayer.maxzoom)) {
	            addCommand(commands, { command: 'setLayerZoomRange', args: [layerId, afterLayer.minzoom, afterLayer.maxzoom] });
	        }
	        // handle all other layer props, including paint.*
	        for (prop in beforeLayer) {
	            if (!Object.prototype.hasOwnProperty.call(beforeLayer, prop))
	                continue;
	            if (prop === 'layout' || prop === 'paint' || prop === 'filter' ||
	                prop === 'metadata' || prop === 'minzoom' || prop === 'maxzoom')
	                continue;
	            if (prop.indexOf('paint.') === 0) {
	                diffLayerPropertyChanges(beforeLayer[prop], afterLayer[prop], commands, layerId, prop.slice(6), 'setPaintProperty');
	            }
	            else if (!deepEqual(beforeLayer[prop], afterLayer[prop])) {
	                addCommand(commands, { command: 'setLayerProperty', args: [layerId, prop, afterLayer[prop]] });
	            }
	        }
	        for (prop in afterLayer) {
	            if (!Object.prototype.hasOwnProperty.call(afterLayer, prop) || Object.prototype.hasOwnProperty.call(beforeLayer, prop))
	                continue;
	            if (prop === 'layout' || prop === 'paint' || prop === 'filter' ||
	                prop === 'metadata' || prop === 'minzoom' || prop === 'maxzoom')
	                continue;
	            if (prop.indexOf('paint.') === 0) {
	                diffLayerPropertyChanges(beforeLayer[prop], afterLayer[prop], commands, layerId, prop.slice(6), 'setPaintProperty');
	            }
	            else if (!deepEqual(beforeLayer[prop], afterLayer[prop])) {
	                addCommand(commands, { command: 'setLayerProperty', args: [layerId, prop, afterLayer[prop]] });
	            }
	        }
	    }
	}
	/**
	 * Diff two stylesheet
	 *
	 * Creates semanticly aware diffs that can easily be applied at runtime.
	 * Operations produced by the diff closely resemble the maplibre-gl-js API. Any
	 * error creating the diff will fall back to the 'setStyle' operation.
	 *
	 * Example diff:
	 * [
	 *     { command: 'setConstant', args: ['@water', '#0000FF'] },
	 *     { command: 'setPaintProperty', args: ['background', 'background-color', 'black'] }
	 * ]
	 *
	 * @private
	 * @param {*} [before] stylesheet to compare from
	 * @param {*} after stylesheet to compare to
	 * @returns Array list of changes
	 */
	function diffStyles(before, after) {
	    if (!before)
	        return [{ command: 'setStyle', args: [after] }];
	    let commands = [];
	    try {
	        // Handle changes to top-level properties
	        if (!deepEqual(before.version, after.version)) {
	            return [{ command: 'setStyle', args: [after] }];
	        }
	        if (!deepEqual(before.center, after.center)) {
	            commands.push({ command: 'setCenter', args: [after.center] });
	        }
	        if (!deepEqual(before.zoom, after.zoom)) {
	            commands.push({ command: 'setZoom', args: [after.zoom] });
	        }
	        if (!deepEqual(before.bearing, after.bearing)) {
	            commands.push({ command: 'setBearing', args: [after.bearing] });
	        }
	        if (!deepEqual(before.pitch, after.pitch)) {
	            commands.push({ command: 'setPitch', args: [after.pitch] });
	        }
	        if (!deepEqual(before.sprite, after.sprite)) {
	            commands.push({ command: 'setSprite', args: [after.sprite] });
	        }
	        if (!deepEqual(before.glyphs, after.glyphs)) {
	            commands.push({ command: 'setGlyphs', args: [after.glyphs] });
	        }
	        if (!deepEqual(before.transition, after.transition)) {
	            commands.push({ command: 'setTransition', args: [after.transition] });
	        }
	        if (!deepEqual(before.light, after.light)) {
	            commands.push({ command: 'setLight', args: [after.light] });
	        }
	        if (!deepEqual(before.terrain, after.terrain)) {
	            commands.push({ command: 'setTerrain', args: [after.terrain] });
	        }
	        if (!deepEqual(before.sky, after.sky)) {
	            commands.push({ command: 'setSky', args: [after.sky] });
	        }
	        // Handle changes to `sources`
	        // If a source is to be removed, we also--before the removeSource
	        // command--need to remove all the style layers that depend on it.
	        const sourcesRemoved = {};
	        // First collect the {add,remove}Source commands
	        const removeOrAddSourceCommands = [];
	        diffSources(before.sources, after.sources, removeOrAddSourceCommands, sourcesRemoved);
	        // Push a removeLayer command for each style layer that depends on a
	        // source that's being removed.
	        // Also, exclude any such layers them from the input to `diffLayers`
	        // below, so that diffLayers produces the appropriate `addLayers`
	        // command
	        const beforeLayers = [];
	        if (before.layers) {
	            before.layers.forEach((layer) => {
	                if ('source' in layer && sourcesRemoved[layer.source]) {
	                    commands.push({ command: 'removeLayer', args: [layer.id] });
	                }
	                else {
	                    beforeLayers.push(layer);
	                }
	            });
	        }
	        commands = commands.concat(removeOrAddSourceCommands);
	        // Handle changes to `layers`
	        diffLayers(beforeLayers, after.layers, commands);
	    }
	    catch (e) {
	        // fall back to setStyle
	        console.warn('Unable to compute style diff:', e);
	        commands = [{ command: 'setStyle', args: [after] }];
	    }
	    return commands;
	}

	// Note: Do not inherit from Error. It breaks when transpiling to ES5.
	class ValidationError {
	    constructor(key, value, message, identifier) {
	        this.message = (key ? `${key}: ` : '') + message;
	        if (identifier)
	            this.identifier = identifier;
	        if (value !== null && value !== undefined && value.__line__) {
	            this.line = value.__line__;
	        }
	    }
	}

	function extendBy(output, ...inputs) {
	    for (const input of inputs) {
	        for (const k in input) {
	            output[k] = input[k];
	        }
	    }
	    return output;
	}

	class ExpressionParsingError extends Error {
	    constructor(key, message) {
	        super(message);
	        this.message = message;
	        this.key = key;
	    }
	}

	/**
	 * Tracks `let` bindings during expression parsing.
	 * @private
	 */
	class Scope {
	    constructor(parent, bindings = []) {
	        this.parent = parent;
	        this.bindings = {};
	        for (const [name, expression] of bindings) {
	            this.bindings[name] = expression;
	        }
	    }
	    concat(bindings) {
	        return new Scope(this, bindings);
	    }
	    get(name) {
	        if (this.bindings[name]) {
	            return this.bindings[name];
	        }
	        if (this.parent) {
	            return this.parent.get(name);
	        }
	        throw new Error(`${name} not found in scope.`);
	    }
	    has(name) {
	        if (this.bindings[name])
	            return true;
	        return this.parent ? this.parent.has(name) : false;
	    }
	}

	const NullType = { kind: 'null' };
	const NumberType = { kind: 'number' };
	const StringType = { kind: 'string' };
	const BooleanType = { kind: 'boolean' };
	const ColorType = { kind: 'color' };
	const ObjectType = { kind: 'object' };
	const ValueType = { kind: 'value' };
	const ErrorType = { kind: 'error' };
	const CollatorType = { kind: 'collator' };
	const FormattedType = { kind: 'formatted' };
	const PaddingType = { kind: 'padding' };
	const ResolvedImageType = { kind: 'resolvedImage' };
	const VariableAnchorOffsetCollectionType = { kind: 'variableAnchorOffsetCollection' };
	function array$1(itemType, N) {
	    return {
	        kind: 'array',
	        itemType,
	        N
	    };
	}
	function toString$1(type) {
	    if (type.kind === 'array') {
	        const itemType = toString$1(type.itemType);
	        return typeof type.N === 'number' ?
	            `array<${itemType}, ${type.N}>` :
	            type.itemType.kind === 'value' ? 'array' : `array<${itemType}>`;
	    }
	    else {
	        return type.kind;
	    }
	}
	const valueMemberTypes = [
	    NullType,
	    NumberType,
	    StringType,
	    BooleanType,
	    ColorType,
	    FormattedType,
	    ObjectType,
	    array$1(ValueType),
	    PaddingType,
	    ResolvedImageType,
	    VariableAnchorOffsetCollectionType
	];
	/**
	 * Returns null if `t` is a subtype of `expected`; otherwise returns an
	 * error message.
	 * @private
	 */
	function checkSubtype(expected, t) {
	    if (t.kind === 'error') {
	        // Error is a subtype of every type
	        return null;
	    }
	    else if (expected.kind === 'array') {
	        if (t.kind === 'array' &&
	            ((t.N === 0 && t.itemType.kind === 'value') || !checkSubtype(expected.itemType, t.itemType)) &&
	            (typeof expected.N !== 'number' || expected.N === t.N)) {
	            return null;
	        }
	    }
	    else if (expected.kind === t.kind) {
	        return null;
	    }
	    else if (expected.kind === 'value') {
	        for (const memberType of valueMemberTypes) {
	            if (!checkSubtype(memberType, t)) {
	                return null;
	            }
	        }
	    }
	    return `Expected ${toString$1(expected)} but found ${toString$1(t)} instead.`;
	}
	function isValidType(provided, allowedTypes) {
	    return allowedTypes.some(t => t.kind === provided.kind);
	}
	function isValidNativeType(provided, allowedTypes) {
	    return allowedTypes.some(t => {
	        if (t === 'null') {
	            return provided === null;
	        }
	        else if (t === 'array') {
	            return Array.isArray(provided);
	        }
	        else if (t === 'object') {
	            return provided && !Array.isArray(provided) && typeof provided === 'object';
	        }
	        else {
	            return t === typeof provided;
	        }
	    });
	}
	/**
	 * Verify whether the specified type is of the same type as the specified sample.
	 *
	 * @param provided Type to verify
	 * @param sample Sample type to reference
	 * @returns `true` if both objects are of the same type, `false` otherwise
	 * @example basic types
	 * if (verifyType(outputType, ValueType)) {
	 *     // type narrowed to:
	 *     outputType.kind; // 'value'
	 * }
	 * @example array types
	 * if (verifyType(outputType, array(NumberType))) {
	 *     // type narrowed to:
	 *     outputType.kind; // 'array'
	 *     outputType.itemType; // NumberTypeT
	 *     outputType.itemType.kind; // 'number'
	 * }
	 */
	function verifyType(provided, sample) {
	    if (provided.kind === 'array' && sample.kind === 'array') {
	        return provided.itemType.kind === sample.itemType.kind && typeof provided.N === 'number';
	    }
	    return provided.kind === sample.kind;
	}

	// See https://observablehq.com/@mbostock/lab-and-rgb
	const Xn = 0.96422, Yn = 1, Zn = 0.82521, t0 = 4 / 29, t1 = 6 / 29, t2 = 3 * t1 * t1, t3 = t1 * t1 * t1, deg2rad = Math.PI / 180, rad2deg = 180 / Math.PI;
	function constrainAngle(angle) {
	    angle = angle % 360;
	    if (angle < 0) {
	        angle += 360;
	    }
	    return angle;
	}
	function rgbToLab([r, g, b, alpha]) {
	    r = rgb2xyz(r);
	    g = rgb2xyz(g);
	    b = rgb2xyz(b);
	    let x, z;
	    const y = xyz2lab((0.2225045 * r + 0.7168786 * g + 0.0606169 * b) / Yn);
	    if (r === g && g === b) {
	        x = z = y;
	    }
	    else {
	        x = xyz2lab((0.4360747 * r + 0.3850649 * g + 0.1430804 * b) / Xn);
	        z = xyz2lab((0.0139322 * r + 0.0971045 * g + 0.7141733 * b) / Zn);
	    }
	    const l = 116 * y - 16;
	    return [(l < 0) ? 0 : l, 500 * (x - y), 200 * (y - z), alpha];
	}
	function rgb2xyz(x) {
	    return (x <= 0.04045) ? x / 12.92 : Math.pow((x + 0.055) / 1.055, 2.4);
	}
	function xyz2lab(t) {
	    return (t > t3) ? Math.pow(t, 1 / 3) : t / t2 + t0;
	}
	function labToRgb([l, a, b, alpha]) {
	    let y = (l + 16) / 116, x = isNaN(a) ? y : y + a / 500, z = isNaN(b) ? y : y - b / 200;
	    y = Yn * lab2xyz(y);
	    x = Xn * lab2xyz(x);
	    z = Zn * lab2xyz(z);
	    return [
	        xyz2rgb(3.1338561 * x - 1.6168667 * y - 0.4906146 * z), // D50 -> sRGB
	        xyz2rgb(-0.9787684 * x + 1.9161415 * y + 0.0334540 * z),
	        xyz2rgb(0.0719453 * x - 0.2289914 * y + 1.4052427 * z),
	        alpha,
	    ];
	}
	function xyz2rgb(x) {
	    x = (x <= 0.00304) ? 12.92 * x : 1.055 * Math.pow(x, 1 / 2.4) - 0.055;
	    return (x < 0) ? 0 : (x > 1) ? 1 : x; // clip to 0..1 range
	}
	function lab2xyz(t) {
	    return (t > t1) ? t * t * t : t2 * (t - t0);
	}
	function rgbToHcl(rgbColor) {
	    const [l, a, b, alpha] = rgbToLab(rgbColor);
	    const c = Math.sqrt(a * a + b * b);
	    const h = Math.round(c * 10000) ? constrainAngle(Math.atan2(b, a) * rad2deg) : NaN;
	    return [h, c, l, alpha];
	}
	function hclToRgb([h, c, l, alpha]) {
	    h = isNaN(h) ? 0 : h * deg2rad;
	    return labToRgb([l, Math.cos(h) * c, Math.sin(h) * c, alpha]);
	}
	// https://drafts.csswg.org/css-color-4/#hsl-to-rgb
	function hslToRgb([h, s, l, alpha]) {
	    h = constrainAngle(h);
	    s /= 100;
	    l /= 100;
	    function f(n) {
	        const k = (n + h / 30) % 12;
	        const a = s * Math.min(l, 1 - l);
	        return l - a * Math.max(-1, Math.min(k - 3, 9 - k, 1));
	    }
	    return [f(0), f(8), f(4), alpha];
	}

	/**
	 * CSS color parser compliant with CSS Color 4 Specification.
	 * Supports: named colors, `transparent` keyword, all rgb hex notations,
	 * rgb(), rgba(), hsl() and hsla() functions.
	 * Does not round the parsed values to integers from the range 0..255.
	 *
	 * Syntax:
	 *
	 * <alpha-value> = <number> | <percentage>
	 *         <hue> = <number> | <angle>
	 *
	 *         rgb() = rgb( <percentage>{3} [ / <alpha-value> ]? ) | rgb( <number>{3} [ / <alpha-value> ]? )
	 *         rgb() = rgb( <percentage>#{3} , <alpha-value>? )    | rgb( <number>#{3} , <alpha-value>? )
	 *
	 *         hsl() = hsl( <hue> <percentage> <percentage> [ / <alpha-value> ]? )
	 *         hsl() = hsl( <hue>, <percentage>, <percentage>, <alpha-value>? )
	 *
	 * Caveats:
	 *   - <angle> - <number> with optional `deg` suffix; `grad`, `rad`, `turn` are not supported
	 *   - `none` keyword is not supported
	 *   - comments inside rgb()/hsl() are not supported
	 *   - legacy color syntax rgba() is supported with an identical grammar and behavior to rgb()
	 *   - legacy color syntax hsla() is supported with an identical grammar and behavior to hsl()
	 *
	 * @param input CSS color string to parse.
	 * @returns Color in sRGB color space, with `red`, `green`, `blue`
	 * and `alpha` channels normalized to the range 0..1,
	 * or `undefined` if the input is not a valid color string.
	 */
	function parseCssColor(input) {
	    input = input.toLowerCase().trim();
	    if (input === 'transparent') {
	        return [0, 0, 0, 0];
	    }
	    // 'white', 'black', 'blue'
	    const namedColorsMatch = namedColors[input];
	    if (namedColorsMatch) {
	        const [r, g, b] = namedColorsMatch;
	        return [r / 255, g / 255, b / 255, 1];
	    }
	    // #f0c, #f0cf, #ff00cc, #ff00ccff
	    if (input.startsWith('#')) {
	        const hexRegexp = /^#(?:[0-9a-f]{3,4}|[0-9a-f]{6}|[0-9a-f]{8})$/;
	        if (hexRegexp.test(input)) {
	            const step = input.length < 6 ? 1 : 2;
	            let i = 1;
	            return [
	                parseHex(input.slice(i, i += step)),
	                parseHex(input.slice(i, i += step)),
	                parseHex(input.slice(i, i += step)),
	                parseHex(input.slice(i, i + step) || 'ff'),
	            ];
	        }
	    }
	    // rgb(128 0 0), rgb(50% 0% 0%), rgba(255,0,255,0.6), rgb(255 0 255 / 60%), rgb(100% 0% 100% /.6)
	    if (input.startsWith('rgb')) {
	        const rgbRegExp = /^rgba?\(\s*([\de.+-]+)(%)?(?:\s+|\s*(,)\s*)([\de.+-]+)(%)?(?:\s+|\s*(,)\s*)([\de.+-]+)(%)?(?:\s*([,\/])\s*([\de.+-]+)(%)?)?\s*\)$/;
	        const rgbMatch = input.match(rgbRegExp);
	        if (rgbMatch) {
	            const [_, // eslint-disable-line @typescript-eslint/no-unused-vars
	            r, // <numeric>
	            rp, // %         (optional)
	            f1, // ,         (optional)
	            g, // <numeric>
	            gp, // %         (optional)
	            f2, // ,         (optional)
	            b, // <numeric>
	            bp, // %         (optional)
	            f3, // ,|/       (optional)
	            a, // <numeric> (optional)
	            ap, // %         (optional)
	            ] = rgbMatch;
	            const argFormat = [f1 || ' ', f2 || ' ', f3].join('');
	            if (argFormat === '  ' ||
	                argFormat === '  /' ||
	                argFormat === ',,' ||
	                argFormat === ',,,') {
	                const valFormat = [rp, gp, bp].join('');
	                const maxValue = (valFormat === '%%%') ? 100 :
	                    (valFormat === '') ? 255 : 0;
	                if (maxValue) {
	                    const rgba = [
	                        clamp(+r / maxValue, 0, 1),
	                        clamp(+g / maxValue, 0, 1),
	                        clamp(+b / maxValue, 0, 1),
	                        a ? parseAlpha(+a, ap) : 1,
	                    ];
	                    if (validateNumbers(rgba)) {
	                        return rgba;
	                    }
	                    // invalid numbers
	                }
	                // values must be all numbers or all percentages
	            }
	            return; // comma optional syntax requires no commas at all
	        }
	    }
	    // hsl(120 50% 80%), hsla(120deg,50%,80%,.9), hsl(12e1 50% 80% / 90%)
	    const hslRegExp = /^hsla?\(\s*([\de.+-]+)(?:deg)?(?:\s+|\s*(,)\s*)([\de.+-]+)%(?:\s+|\s*(,)\s*)([\de.+-]+)%(?:\s*([,\/])\s*([\de.+-]+)(%)?)?\s*\)$/;
	    const hslMatch = input.match(hslRegExp);
	    if (hslMatch) {
	        const [_, // eslint-disable-line @typescript-eslint/no-unused-vars
	        h, // <numeric>
	        f1, // ,         (optional)
	        s, // <numeric>
	        f2, // ,         (optional)
	        l, // <numeric>
	        f3, // ,|/       (optional)
	        a, // <numeric> (optional)
	        ap, // %         (optional)
	        ] = hslMatch;
	        const argFormat = [f1 || ' ', f2 || ' ', f3].join('');
	        if (argFormat === '  ' ||
	            argFormat === '  /' ||
	            argFormat === ',,' ||
	            argFormat === ',,,') {
	            const hsla = [
	                +h,
	                clamp(+s, 0, 100),
	                clamp(+l, 0, 100),
	                a ? parseAlpha(+a, ap) : 1,
	            ];
	            if (validateNumbers(hsla)) {
	                return hslToRgb(hsla);
	            }
	            // invalid numbers
	        }
	        // comma optional syntax requires no commas at all
	    }
	}
	function parseHex(hex) {
	    return parseInt(hex.padEnd(2, hex), 16) / 255;
	}
	function parseAlpha(a, asPercentage) {
	    return clamp(asPercentage ? (a / 100) : a, 0, 1);
	}
	function clamp(n, min, max) {
	    return Math.min(Math.max(min, n), max);
	}
	/**
	 * The regular expression for numeric values is not super specific, and it may
	 * happen that it will accept a value that is not a valid number. In order to
	 * detect and eliminate such values this function exists.
	 *
	 * @param array Array of uncertain numbers.
	 * @returns `true` if the specified array contains only valid numbers, `false` otherwise.
	 */
	function validateNumbers(array) {
	    return !array.some(Number.isNaN);
	}
	/**
	 * To generate:
	 * - visit {@link https://www.w3.org/TR/css-color-4/#named-colors}
	 * - run in the console:
	 * @example
	 * copy(`{\n${[...document.querySelector('.named-color-table tbody').children].map((tr) => `${tr.cells[2].textContent.trim()}: [${tr.cells[4].textContent.trim().split(/\s+/).join(', ')}],`).join('\n')}\n}`);
	 */
	const namedColors = {
	    aliceblue: [240, 248, 255],
	    antiquewhite: [250, 235, 215],
	    aqua: [0, 255, 255],
	    aquamarine: [127, 255, 212],
	    azure: [240, 255, 255],
	    beige: [245, 245, 220],
	    bisque: [255, 228, 196],
	    black: [0, 0, 0],
	    blanchedalmond: [255, 235, 205],
	    blue: [0, 0, 255],
	    blueviolet: [138, 43, 226],
	    brown: [165, 42, 42],
	    burlywood: [222, 184, 135],
	    cadetblue: [95, 158, 160],
	    chartreuse: [127, 255, 0],
	    chocolate: [210, 105, 30],
	    coral: [255, 127, 80],
	    cornflowerblue: [100, 149, 237],
	    cornsilk: [255, 248, 220],
	    crimson: [220, 20, 60],
	    cyan: [0, 255, 255],
	    darkblue: [0, 0, 139],
	    darkcyan: [0, 139, 139],
	    darkgoldenrod: [184, 134, 11],
	    darkgray: [169, 169, 169],
	    darkgreen: [0, 100, 0],
	    darkgrey: [169, 169, 169],
	    darkkhaki: [189, 183, 107],
	    darkmagenta: [139, 0, 139],
	    darkolivegreen: [85, 107, 47],
	    darkorange: [255, 140, 0],
	    darkorchid: [153, 50, 204],
	    darkred: [139, 0, 0],
	    darksalmon: [233, 150, 122],
	    darkseagreen: [143, 188, 143],
	    darkslateblue: [72, 61, 139],
	    darkslategray: [47, 79, 79],
	    darkslategrey: [47, 79, 79],
	    darkturquoise: [0, 206, 209],
	    darkviolet: [148, 0, 211],
	    deeppink: [255, 20, 147],
	    deepskyblue: [0, 191, 255],
	    dimgray: [105, 105, 105],
	    dimgrey: [105, 105, 105],
	    dodgerblue: [30, 144, 255],
	    firebrick: [178, 34, 34],
	    floralwhite: [255, 250, 240],
	    forestgreen: [34, 139, 34],
	    fuchsia: [255, 0, 255],
	    gainsboro: [220, 220, 220],
	    ghostwhite: [248, 248, 255],
	    gold: [255, 215, 0],
	    goldenrod: [218, 165, 32],
	    gray: [128, 128, 128],
	    green: [0, 128, 0],
	    greenyellow: [173, 255, 47],
	    grey: [128, 128, 128],
	    honeydew: [240, 255, 240],
	    hotpink: [255, 105, 180],
	    indianred: [205, 92, 92],
	    indigo: [75, 0, 130],
	    ivory: [255, 255, 240],
	    khaki: [240, 230, 140],
	    lavender: [230, 230, 250],
	    lavenderblush: [255, 240, 245],
	    lawngreen: [124, 252, 0],
	    lemonchiffon: [255, 250, 205],
	    lightblue: [173, 216, 230],
	    lightcoral: [240, 128, 128],
	    lightcyan: [224, 255, 255],
	    lightgoldenrodyellow: [250, 250, 210],
	    lightgray: [211, 211, 211],
	    lightgreen: [144, 238, 144],
	    lightgrey: [211, 211, 211],
	    lightpink: [255, 182, 193],
	    lightsalmon: [255, 160, 122],
	    lightseagreen: [32, 178, 170],
	    lightskyblue: [135, 206, 250],
	    lightslategray: [119, 136, 153],
	    lightslategrey: [119, 136, 153],
	    lightsteelblue: [176, 196, 222],
	    lightyellow: [255, 255, 224],
	    lime: [0, 255, 0],
	    limegreen: [50, 205, 50],
	    linen: [250, 240, 230],
	    magenta: [255, 0, 255],
	    maroon: [128, 0, 0],
	    mediumaquamarine: [102, 205, 170],
	    mediumblue: [0, 0, 205],
	    mediumorchid: [186, 85, 211],
	    mediumpurple: [147, 112, 219],
	    mediumseagreen: [60, 179, 113],
	    mediumslateblue: [123, 104, 238],
	    mediumspringgreen: [0, 250, 154],
	    mediumturquoise: [72, 209, 204],
	    mediumvioletred: [199, 21, 133],
	    midnightblue: [25, 25, 112],
	    mintcream: [245, 255, 250],
	    mistyrose: [255, 228, 225],
	    moccasin: [255, 228, 181],
	    navajowhite: [255, 222, 173],
	    navy: [0, 0, 128],
	    oldlace: [253, 245, 230],
	    olive: [128, 128, 0],
	    olivedrab: [107, 142, 35],
	    orange: [255, 165, 0],
	    orangered: [255, 69, 0],
	    orchid: [218, 112, 214],
	    palegoldenrod: [238, 232, 170],
	    palegreen: [152, 251, 152],
	    paleturquoise: [175, 238, 238],
	    palevioletred: [219, 112, 147],
	    papayawhip: [255, 239, 213],
	    peachpuff: [255, 218, 185],
	    peru: [205, 133, 63],
	    pink: [255, 192, 203],
	    plum: [221, 160, 221],
	    powderblue: [176, 224, 230],
	    purple: [128, 0, 128],
	    rebeccapurple: [102, 51, 153],
	    red: [255, 0, 0],
	    rosybrown: [188, 143, 143],
	    royalblue: [65, 105, 225],
	    saddlebrown: [139, 69, 19],
	    salmon: [250, 128, 114],
	    sandybrown: [244, 164, 96],
	    seagreen: [46, 139, 87],
	    seashell: [255, 245, 238],
	    sienna: [160, 82, 45],
	    silver: [192, 192, 192],
	    skyblue: [135, 206, 235],
	    slateblue: [106, 90, 205],
	    slategray: [112, 128, 144],
	    slategrey: [112, 128, 144],
	    snow: [255, 250, 250],
	    springgreen: [0, 255, 127],
	    steelblue: [70, 130, 180],
	    tan: [210, 180, 140],
	    teal: [0, 128, 128],
	    thistle: [216, 191, 216],
	    tomato: [255, 99, 71],
	    turquoise: [64, 224, 208],
	    violet: [238, 130, 238],
	    wheat: [245, 222, 179],
	    white: [255, 255, 255],
	    whitesmoke: [245, 245, 245],
	    yellow: [255, 255, 0],
	    yellowgreen: [154, 205, 50],
	};

	/**
	 * Color representation used by WebGL.
	 * Defined in sRGB color space and pre-blended with alpha.
	 * @private
	 */
	class Color {
	    /**
	     * @param r Red component premultiplied by `alpha` 0..1
	     * @param g Green component premultiplied by `alpha` 0..1
	     * @param b Blue component premultiplied by `alpha` 0..1
	     * @param [alpha=1] Alpha component 0..1
	     * @param [premultiplied=true] Whether the `r`, `g` and `b` values have already
	     * been multiplied by alpha. If `true` nothing happens if `false` then they will
	     * be multiplied automatically.
	     */
	    constructor(r, g, b, alpha = 1, premultiplied = true) {
	        this.r = r;
	        this.g = g;
	        this.b = b;
	        this.a = alpha;
	        if (!premultiplied) {
	            this.r *= alpha;
	            this.g *= alpha;
	            this.b *= alpha;
	            if (!alpha) {
	                // alpha = 0 erases completely rgb channels. This behavior is not desirable
	                // if this particular color is later used in color interpolation.
	                // Because of that, a reference to original color is saved.
	                this.overwriteGetter('rgb', [r, g, b, alpha]);
	            }
	        }
	    }
	    /**
	     * Parses CSS color strings and converts colors to sRGB color space if needed.
	     * Officially supported color formats:
	     * - keyword, e.g. 'aquamarine' or 'steelblue'
	     * - hex (with 3, 4, 6 or 8 digits), e.g. '#f0f' or '#e9bebea9'
	     * - rgb and rgba, e.g. 'rgb(0,240,120)' or 'rgba(0%,94%,47%,0.1)' or 'rgb(0 240 120 / .3)'
	     * - hsl and hsla, e.g. 'hsl(0,0%,83%)' or 'hsla(0,0%,83%,.5)' or 'hsl(0 0% 83% / 20%)'
	     *
	     * @param input CSS color string to parse.
	     * @returns A `Color` instance, or `undefined` if the input is not a valid color string.
	     */
	    static parse(input) {
	        // in zoom-and-property function input could be an instance of Color class
	        if (input instanceof Color) {
	            return input;
	        }
	        if (typeof input !== 'string') {
	            return;
	        }
	        const rgba = parseCssColor(input);
	        if (rgba) {
	            return new Color(...rgba, false);
	        }
	    }
	    /**
	     * Used in color interpolation and by 'to-rgba' expression.
	     *
	     * @returns Gien color, with reversed alpha blending, in sRGB color space.
	     */
	    get rgb() {
	        const { r, g, b, a } = this;
	        const f = a || Infinity; // reverse alpha blending factor
	        return this.overwriteGetter('rgb', [r / f, g / f, b / f, a]);
	    }
	    /**
	     * Used in color interpolation.
	     *
	     * @returns Gien color, with reversed alpha blending, in HCL color space.
	     */
	    get hcl() {
	        return this.overwriteGetter('hcl', rgbToHcl(this.rgb));
	    }
	    /**
	     * Used in color interpolation.
	     *
	     * @returns Gien color, with reversed alpha blending, in LAB color space.
	     */
	    get lab() {
	        return this.overwriteGetter('lab', rgbToLab(this.rgb));
	    }
	    /**
	     * Lazy getter pattern. When getter is called for the first time lazy value
	     * is calculated and then overwrites getter function in given object instance.
	     *
	     * @example:
	     * const redColor = Color.parse('red');
	     * let x = redColor.hcl; // this will invoke `get hcl()`, which will calculate
	     * // the value of red in HCL space and invoke this `overwriteGetter` function
	     * // which in turn will set a field with a key 'hcl' in the `redColor` object.
	     * // In other words it will override `get hcl()` from its `Color` prototype
	     * // with its own property: hcl = [calculated red value in hcl].
	     * let y = redColor.hcl; // next call will no longer invoke getter but simply
	     * // return the previously calculated value
	     * x === y; // true - `x` is exactly the same object as `y`
	     *
	     * @param getterKey Getter key
	     * @param lazyValue Lazily calculated value to be memoized by current instance
	     * @private
	     */
	    overwriteGetter(getterKey, lazyValue) {
	        Object.defineProperty(this, getterKey, { value: lazyValue });
	        return lazyValue;
	    }
	    /**
	     * Used by 'to-string' expression.
	     *
	     * @returns Serialized color in format `rgba(r,g,b,a)`
	     * where r,g,b are numbers within 0..255 and alpha is number within 1..0
	     *
	     * @example
	     * var purple = new Color.parse('purple');
	     * purple.toString; // = "rgba(128,0,128,1)"
	     * var translucentGreen = new Color.parse('rgba(26, 207, 26, .73)');
	     * translucentGreen.toString(); // = "rgba(26,207,26,0.73)"
	     */
	    toString() {
	        const [r, g, b, a] = this.rgb;
	        return `rgba(${[r, g, b].map(n => Math.round(n * 255)).join(',')},${a})`;
	    }
	}
	Color.black = new Color(0, 0, 0, 1);
	Color.white = new Color(1, 1, 1, 1);
	Color.transparent = new Color(0, 0, 0, 0);
	Color.red = new Color(1, 0, 0, 1);

	// Flow type declarations for Intl cribbed from
	// https://github.com/facebook/flow/issues/1270
	class Collator {
	    constructor(caseSensitive, diacriticSensitive, locale) {
	        if (caseSensitive)
	            this.sensitivity = diacriticSensitive ? 'variant' : 'case';
	        else
	            this.sensitivity = diacriticSensitive ? 'accent' : 'base';
	        this.locale = locale;
	        this.collator = new Intl.Collator(this.locale ? this.locale : [], { sensitivity: this.sensitivity, usage: 'search' });
	    }
	    compare(lhs, rhs) {
	        return this.collator.compare(lhs, rhs);
	    }
	    resolvedLocale() {
	        // We create a Collator without "usage: search" because we don't want
	        // the search options encoded in our result (e.g. "en-u-co-search")
	        return new Intl.Collator(this.locale ? this.locale : [])
	            .resolvedOptions().locale;
	    }
	}

	class FormattedSection {
	    constructor(text, image, scale, fontStack, textColor) {
	        this.text = text;
	        this.image = image;
	        this.scale = scale;
	        this.fontStack = fontStack;
	        this.textColor = textColor;
	    }
	}
	class Formatted {
	    constructor(sections) {
	        this.sections = sections;
	    }
	    static fromString(unformatted) {
	        return new Formatted([new FormattedSection(unformatted, null, null, null, null)]);
	    }
	    isEmpty() {
	        if (this.sections.length === 0)
	            return true;
	        return !this.sections.some(section => section.text.length !== 0 ||
	            (section.image && section.image.name.length !== 0));
	    }
	    static factory(text) {
	        if (text instanceof Formatted) {
	            return text;
	        }
	        else {
	            return Formatted.fromString(text);
	        }
	    }
	    toString() {
	        if (this.sections.length === 0)
	            return '';
	        return this.sections.map(section => section.text).join('');
	    }
	}

	/**
	 * A set of four numbers representing padding around a box. Create instances from
	 * bare arrays or numeric values using the static method `Padding.parse`.
	 * @private
	 */
	class Padding {
	    constructor(values) {
	        this.values = values.slice();
	    }
	    /**
	     * Numeric padding values
	     * @param input A padding value
	     * @returns A `Padding` instance, or `undefined` if the input is not a valid padding value.
	     */
	    static parse(input) {
	        if (input instanceof Padding) {
	            return input;
	        }
	        // Backwards compatibility: bare number is treated the same as array with single value.
	        // Padding applies to all four sides.
	        if (typeof input === 'number') {
	            return new Padding([input, input, input, input]);
	        }
	        if (!Array.isArray(input)) {
	            return undefined;
	        }
	        if (input.length < 1 || input.length > 4) {
	            return undefined;
	        }
	        for (const val of input) {
	            if (typeof val !== 'number') {
	                return undefined;
	            }
	        }
	        // Expand shortcut properties into explicit 4-sided values
	        switch (input.length) {
	            case 1:
	                input = [input[0], input[0], input[0], input[0]];
	                break;
	            case 2:
	                input = [input[0], input[1], input[0], input[1]];
	                break;
	            case 3:
	                input = [input[0], input[1], input[2], input[1]];
	                break;
	        }
	        return new Padding(input);
	    }
	    toString() {
	        return JSON.stringify(this.values);
	    }
	}

	/** Set of valid anchor positions, as a set for validation */
	const anchors = new Set(['center', 'left', 'right', 'top', 'bottom', 'top-left', 'top-right', 'bottom-left', 'bottom-right']);
	/**
	 * Utility class to assist managing values for text-variable-anchor-offset property. Create instances from
	 * bare arrays using the static method `VariableAnchorOffsetCollection.parse`.
	 * @private
	 */
	class VariableAnchorOffsetCollection {
	    constructor(values) {
	        this.values = values.slice();
	    }
	    static parse(input) {
	        if (input instanceof VariableAnchorOffsetCollection) {
	            return input;
	        }
	        if (!Array.isArray(input) ||
	            input.length < 1 ||
	            input.length % 2 !== 0) {
	            return undefined;
	        }
	        for (let i = 0; i < input.length; i += 2) {
	            // Elements in even positions should be anchor positions; Elements in odd positions should be offset values
	            const anchorValue = input[i];
	            const offsetValue = input[i + 1];
	            if (typeof anchorValue !== 'string' || !anchors.has(anchorValue)) {
	                return undefined;
	            }
	            if (!Array.isArray(offsetValue) || offsetValue.length !== 2 || typeof offsetValue[0] !== 'number' || typeof offsetValue[1] !== 'number') {
	                return undefined;
	            }
	        }
	        return new VariableAnchorOffsetCollection(input);
	    }
	    toString() {
	        return JSON.stringify(this.values);
	    }
	}

	class ResolvedImage {
	    constructor(options) {
	        this.name = options.name;
	        this.available = options.available;
	    }
	    toString() {
	        return this.name;
	    }
	    static fromString(name) {
	        if (!name)
	            return null; // treat empty values as no image
	        return new ResolvedImage({ name, available: false });
	    }
	}

	function validateRGBA(r, g, b, a) {
	    if (!(typeof r === 'number' && r >= 0 && r <= 255 &&
	        typeof g === 'number' && g >= 0 && g <= 255 &&
	        typeof b === 'number' && b >= 0 && b <= 255)) {
	        const value = typeof a === 'number' ? [r, g, b, a] : [r, g, b];
	        return `Invalid rgba value [${value.join(', ')}]: 'r', 'g', and 'b' must be between 0 and 255.`;
	    }
	    if (!(typeof a === 'undefined' || (typeof a === 'number' && a >= 0 && a <= 1))) {
	        return `Invalid rgba value [${[r, g, b, a].join(', ')}]: 'a' must be between 0 and 1.`;
	    }
	    return null;
	}
	function isValue(mixed) {
	    if (mixed === null ||
	        typeof mixed === 'string' ||
	        typeof mixed === 'boolean' ||
	        typeof mixed === 'number' ||
	        mixed instanceof Color ||
	        mixed instanceof Collator ||
	        mixed instanceof Formatted ||
	        mixed instanceof Padding ||
	        mixed instanceof VariableAnchorOffsetCollection ||
	        mixed instanceof ResolvedImage) {
	        return true;
	    }
	    else if (Array.isArray(mixed)) {
	        for (const item of mixed) {
	            if (!isValue(item)) {
	                return false;
	            }
	        }
	        return true;
	    }
	    else if (typeof mixed === 'object') {
	        for (const key in mixed) {
	            if (!isValue(mixed[key])) {
	                return false;
	            }
	        }
	        return true;
	    }
	    else {
	        return false;
	    }
	}
	function typeOf(value) {
	    if (value === null) {
	        return NullType;
	    }
	    else if (typeof value === 'string') {
	        return StringType;
	    }
	    else if (typeof value === 'boolean') {
	        return BooleanType;
	    }
	    else if (typeof value === 'number') {
	        return NumberType;
	    }
	    else if (value instanceof Color) {
	        return ColorType;
	    }
	    else if (value instanceof Collator) {
	        return CollatorType;
	    }
	    else if (value instanceof Formatted) {
	        return FormattedType;
	    }
	    else if (value instanceof Padding) {
	        return PaddingType;
	    }
	    else if (value instanceof VariableAnchorOffsetCollection) {
	        return VariableAnchorOffsetCollectionType;
	    }
	    else if (value instanceof ResolvedImage) {
	        return ResolvedImageType;
	    }
	    else if (Array.isArray(value)) {
	        const length = value.length;
	        let itemType;
	        for (const item of value) {
	            const t = typeOf(item);
	            if (!itemType) {
	                itemType = t;
	            }
	            else if (itemType === t) {
	                continue;
	            }
	            else {
	                itemType = ValueType;
	                break;
	            }
	        }
	        return array$1(itemType || ValueType, length);
	    }
	    else {
	        return ObjectType;
	    }
	}
	function toString(value) {
	    const type = typeof value;
	    if (value === null) {
	        return '';
	    }
	    else if (type === 'string' || type === 'number' || type === 'boolean') {
	        return String(value);
	    }
	    else if (value instanceof Color || value instanceof Formatted || value instanceof Padding || value instanceof VariableAnchorOffsetCollection || value instanceof ResolvedImage) {
	        return value.toString();
	    }
	    else {
	        return JSON.stringify(value);
	    }
	}

	class Literal {
	    constructor(type, value) {
	        this.type = type;
	        this.value = value;
	    }
	    static parse(args, context) {
	        if (args.length !== 2)
	            return context.error(`'literal' expression requires exactly one argument, but found ${args.length - 1} instead.`);
	        if (!isValue(args[1]))
	            return context.error('invalid value');
	        const value = args[1];
	        let type = typeOf(value);
	        // special case: infer the item type if possible for zero-length arrays
	        const expected = context.expectedType;
	        if (type.kind === 'array' &&
	            type.N === 0 &&
	            expected &&
	            expected.kind === 'array' &&
	            (typeof expected.N !== 'number' || expected.N === 0)) {
	            type = expected;
	        }
	        return new Literal(type, value);
	    }
	    evaluate() {
	        return this.value;
	    }
	    eachChild() { }
	    outputDefined() {
	        return true;
	    }
	}

	class RuntimeError {
	    constructor(message) {
	        this.name = 'ExpressionEvaluationError';
	        this.message = message;
	    }
	    toJSON() {
	        return this.message;
	    }
	}

	const types$1 = {
	    string: StringType,
	    number: NumberType,
	    boolean: BooleanType,
	    object: ObjectType
	};
	class Assertion {
	    constructor(type, args) {
	        this.type = type;
	        this.args = args;
	    }
	    static parse(args, context) {
	        if (args.length < 2)
	            return context.error('Expected at least one argument.');
	        let i = 1;
	        let type;
	        const name = args[0];
	        if (name === 'array') {
	            let itemType;
	            if (args.length > 2) {
	                const type = args[1];
	                if (typeof type !== 'string' || !(type in types$1) || type === 'object')
	                    return context.error('The item type argument of "array" must be one of string, number, boolean', 1);
	                itemType = types$1[type];
	                i++;
	            }
	            else {
	                itemType = ValueType;
	            }
	            let N;
	            if (args.length > 3) {
	                if (args[2] !== null &&
	                    (typeof args[2] !== 'number' ||
	                        args[2] < 0 ||
	                        args[2] !== Math.floor(args[2]))) {
	                    return context.error('The length argument to "array" must be a positive integer literal', 2);
	                }
	                N = args[2];
	                i++;
	            }
	            type = array$1(itemType, N);
	        }
	        else {
	            if (!types$1[name])
	                throw new Error(`Types doesn't contain name = ${name}`);
	            type = types$1[name];
	        }
	        const parsed = [];
	        for (; i < args.length; i++) {
	            const input = context.parse(args[i], i, ValueType);
	            if (!input)
	                return null;
	            parsed.push(input);
	        }
	        return new Assertion(type, parsed);
	    }
	    evaluate(ctx) {
	        for (let i = 0; i < this.args.length; i++) {
	            const value = this.args[i].evaluate(ctx);
	            const error = checkSubtype(this.type, typeOf(value));
	            if (!error) {
	                return value;
	            }
	            else if (i === this.args.length - 1) {
	                throw new RuntimeError(`Expected value to be of type ${toString$1(this.type)}, but found ${toString$1(typeOf(value))} instead.`);
	            }
	        }
	        throw new Error();
	    }
	    eachChild(fn) {
	        this.args.forEach(fn);
	    }
	    outputDefined() {
	        return this.args.every(arg => arg.outputDefined());
	    }
	}

	const types = {
	    'to-boolean': BooleanType,
	    'to-color': ColorType,
	    'to-number': NumberType,
	    'to-string': StringType
	};
	/**
	 * Special form for error-coalescing coercion expressions "to-number",
	 * "to-color".  Since these coercions can fail at runtime, they accept multiple
	 * arguments, only evaluating one at a time until one succeeds.
	 *
	 * @private
	 */
	class Coercion {
	    constructor(type, args) {
	        this.type = type;
	        this.args = args;
	    }
	    static parse(args, context) {
	        if (args.length < 2)
	            return context.error('Expected at least one argument.');
	        const name = args[0];
	        if (!types[name])
	            throw new Error(`Can't parse ${name} as it is not part of the known types`);
	        if ((name === 'to-boolean' || name === 'to-string') && args.length !== 2)
	            return context.error('Expected one argument.');
	        const type = types[name];
	        const parsed = [];
	        for (let i = 1; i < args.length; i++) {
	            const input = context.parse(args[i], i, ValueType);
	            if (!input)
	                return null;
	            parsed.push(input);
	        }
	        return new Coercion(type, parsed);
	    }
	    evaluate(ctx) {
	        switch (this.type.kind) {
	            case 'boolean':
	                return Boolean(this.args[0].evaluate(ctx));
	            case 'color': {
	                let input;
	                let error;
	                for (const arg of this.args) {
	                    input = arg.evaluate(ctx);
	                    error = null;
	                    if (input instanceof Color) {
	                        return input;
	                    }
	                    else if (typeof input === 'string') {
	                        const c = ctx.parseColor(input);
	                        if (c)
	                            return c;
	                    }
	                    else if (Array.isArray(input)) {
	                        if (input.length < 3 || input.length > 4) {
	                            error = `Invalid rbga value ${JSON.stringify(input)}: expected an array containing either three or four numeric values.`;
	                        }
	                        else {
	                            error = validateRGBA(input[0], input[1], input[2], input[3]);
	                        }
	                        if (!error) {
	                            return new Color(input[0] / 255, input[1] / 255, input[2] / 255, input[3]);
	                        }
	                    }
	                }
	                throw new RuntimeError(error || `Could not parse color from value '${typeof input === 'string' ? input : JSON.stringify(input)}'`);
	            }
	            case 'padding': {
	                let input;
	                for (const arg of this.args) {
	                    input = arg.evaluate(ctx);
	                    const pad = Padding.parse(input);
	                    if (pad) {
	                        return pad;
	                    }
	                }
	                throw new RuntimeError(`Could not parse padding from value '${typeof input === 'string' ? input : JSON.stringify(input)}'`);
	            }
	            case 'variableAnchorOffsetCollection': {
	                let input;
	                for (const arg of this.args) {
	                    input = arg.evaluate(ctx);
	                    const coll = VariableAnchorOffsetCollection.parse(input);
	                    if (coll) {
	                        return coll;
	                    }
	                }
	                throw new RuntimeError(`Could not parse variableAnchorOffsetCollection from value '${typeof input === 'string' ? input : JSON.stringify(input)}'`);
	            }
	            case 'number': {
	                let value = null;
	                for (const arg of this.args) {
	                    value = arg.evaluate(ctx);
	                    if (value === null)
	                        return 0;
	                    const num = Number(value);
	                    if (isNaN(num))
	                        continue;
	                    return num;
	                }
	                throw new RuntimeError(`Could not convert ${JSON.stringify(value)} to number.`);
	            }
	            case 'formatted':
	                // There is no explicit 'to-formatted' but this coercion can be implicitly
	                // created by properties that expect the 'formatted' type.
	                return Formatted.fromString(toString(this.args[0].evaluate(ctx)));
	            case 'resolvedImage':
	                return ResolvedImage.fromString(toString(this.args[0].evaluate(ctx)));
	            default:
	                return toString(this.args[0].evaluate(ctx));
	        }
	    }
	    eachChild(fn) {
	        this.args.forEach(fn);
	    }
	    outputDefined() {
	        return this.args.every(arg => arg.outputDefined());
	    }
	}

	const geometryTypes = ['Unknown', 'Point', 'LineString', 'Polygon'];
	class EvaluationContext {
	    constructor() {
	        this.globals = null;
	        this.feature = null;
	        this.featureState = null;
	        this.formattedSection = null;
	        this._parseColorCache = {};
	        this.availableImages = null;
	        this.canonical = null;
	    }
	    id() {
	        return this.feature && 'id' in this.feature ? this.feature.id : null;
	    }
	    geometryType() {
	        return this.feature ? typeof this.feature.type === 'number' ? geometryTypes[this.feature.type] : this.feature.type : null;
	    }
	    geometry() {
	        return this.feature && 'geometry' in this.feature ? this.feature.geometry : null;
	    }
	    canonicalID() {
	        return this.canonical;
	    }
	    properties() {
	        return this.feature && this.feature.properties || {};
	    }
	    parseColor(input) {
	        let cached = this._parseColorCache[input];
	        if (!cached) {
	            cached = this._parseColorCache[input] = Color.parse(input);
	        }
	        return cached;
	    }
	}

	/**
	 * State associated parsing at a given point in an expression tree.
	 * @private
	 */
	class ParsingContext {
	    constructor(registry, isConstantFunc, path = [], expectedType, scope = new Scope(), errors = []) {
	        this.registry = registry;
	        this.path = path;
	        this.key = path.map(part => `[${part}]`).join('');
	        this.scope = scope;
	        this.errors = errors;
	        this.expectedType = expectedType;
	        this._isConstant = isConstantFunc;
	    }
	    /**
	     * @param expr the JSON expression to parse
	     * @param index the optional argument index if this expression is an argument of a parent expression that's being parsed
	     * @param options
	     * @param options.omitTypeAnnotations set true to omit inferred type annotations.  Caller beware: with this option set, the parsed expression's type will NOT satisfy `expectedType` if it would normally be wrapped in an inferred annotation.
	     * @private
	     */
	    parse(expr, index, expectedType, bindings, options = {}) {
	        if (index) {
	            return this.concat(index, expectedType, bindings)._parse(expr, options);
	        }
	        return this._parse(expr, options);
	    }
	    _parse(expr, options) {
	        if (expr === null || typeof expr === 'string' || typeof expr === 'boolean' || typeof expr === 'number') {
	            expr = ['literal', expr];
	        }
	        function annotate(parsed, type, typeAnnotation) {
	            if (typeAnnotation === 'assert') {
	                return new Assertion(type, [parsed]);
	            }
	            else if (typeAnnotation === 'coerce') {
	                return new Coercion(type, [parsed]);
	            }
	            else {
	                return parsed;
	            }
	        }
	        if (Array.isArray(expr)) {
	            if (expr.length === 0) {
	                return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');
	            }
	            const op = expr[0];
	            if (typeof op !== 'string') {
	                this.error(`Expression name must be a string, but found ${typeof op} instead. If you wanted a literal array, use ["literal", [...]].`, 0);
	                return null;
	            }
	            const Expr = this.registry[op];
	            if (Expr) {
	                let parsed = Expr.parse(expr, this);
	                if (!parsed)
	                    return null;
	                if (this.expectedType) {
	                    const expected = this.expectedType;
	                    const actual = parsed.type;
	                    // When we expect a number, string, boolean, or array but have a value, wrap it in an assertion.
	                    // When we expect a color or formatted string, but have a string or value, wrap it in a coercion.
	                    // Otherwise, we do static type-checking.
	                    //
	                    // These behaviors are overridable for:
	                    //   * The "coalesce" operator, which needs to omit type annotations.
	                    //   * String-valued properties (e.g. `text-field`), where coercion is more convenient than assertion.
	                    //
	                    if ((expected.kind === 'string' || expected.kind === 'number' || expected.kind === 'boolean' || expected.kind === 'object' || expected.kind === 'array') && actual.kind === 'value') {
	                        parsed = annotate(parsed, expected, options.typeAnnotation || 'assert');
	                    }
	                    else if ((expected.kind === 'color' || expected.kind === 'formatted' || expected.kind === 'resolvedImage') && (actual.kind === 'value' || actual.kind === 'string')) {
	                        parsed = annotate(parsed, expected, options.typeAnnotation || 'coerce');
	                    }
	                    else if (expected.kind === 'padding' && (actual.kind === 'value' || actual.kind === 'number' || actual.kind === 'array')) {
	                        parsed = annotate(parsed, expected, options.typeAnnotation || 'coerce');
	                    }
	                    else if (expected.kind === 'variableAnchorOffsetCollection' && (actual.kind === 'value' || actual.kind === 'array')) {
	                        parsed = annotate(parsed, expected, options.typeAnnotation || 'coerce');
	                    }
	                    else if (this.checkSubtype(expected, actual)) {
	                        return null;
	                    }
	                }
	                // If an expression's arguments are all literals, we can evaluate
	                // it immediately and replace it with a literal value in the
	                // parsed/compiled result. Expressions that expect an image should
	                // not be resolved here so we can later get the available images.
	                if (!(parsed instanceof Literal) && (parsed.type.kind !== 'resolvedImage') && this._isConstant(parsed)) {
	                    const ec = new EvaluationContext();
	                    try {
	                        parsed = new Literal(parsed.type, parsed.evaluate(ec));
	                    }
	                    catch (e) {
	                        this.error(e.message);
	                        return null;
	                    }
	                }
	                return parsed;
	            }
	            return this.error(`Unknown expression "${op}". If you wanted a literal array, use ["literal", [...]].`, 0);
	        }
	        else if (typeof expr === 'undefined') {
	            return this.error('\'undefined\' value invalid. Use null instead.');
	        }
	        else if (typeof expr === 'object') {
	            return this.error('Bare objects invalid. Use ["literal", {...}] instead.');
	        }
	        else {
	            return this.error(`Expected an array, but found ${typeof expr} instead.`);
	        }
	    }
	    /**
	     * Returns a copy of this context suitable for parsing the subexpression at
	     * index `index`, optionally appending to 'let' binding map.
	     *
	     * Note that `errors` property, intended for collecting errors while
	     * parsing, is copied by reference rather than cloned.
	     * @private
	     */
	    concat(index, expectedType, bindings) {
	        const path = typeof index === 'number' ? this.path.concat(index) : this.path;
	        const scope = bindings ? this.scope.concat(bindings) : this.scope;
	        return new ParsingContext(this.registry, this._isConstant, path, expectedType || null, scope, this.errors);
	    }
	    /**
	     * Push a parsing (or type checking) error into the `this.errors`
	     * @param error The message
	     * @param keys Optionally specify the source of the error at a child
	     * of the current expression at `this.key`.
	     * @private
	     */
	    error(error, ...keys) {
	        const key = `${this.key}${keys.map(k => `[${k}]`).join('')}`;
	        this.errors.push(new ExpressionParsingError(key, error));
	    }
	    /**
	     * Returns null if `t` is a subtype of `expected`; otherwise returns an
	     * error message and also pushes it to `this.errors`.
	     * @param expected The expected type
	     * @param t The actual type
	     * @returns null if `t` is a subtype of `expected`; otherwise returns an error message
	     */
	    checkSubtype(expected, t) {
	        const error = checkSubtype(expected, t);
	        if (error)
	            this.error(error);
	        return error;
	    }
	}

	class CollatorExpression {
	    constructor(caseSensitive, diacriticSensitive, locale) {
	        this.type = CollatorType;
	        this.locale = locale;
	        this.caseSensitive = caseSensitive;
	        this.diacriticSensitive = diacriticSensitive;
	    }
	    static parse(args, context) {
	        if (args.length !== 2)
	            return context.error('Expected one argument.');
	        const options = args[1];
	        if (typeof options !== 'object' || Array.isArray(options))
	            return context.error('Collator options argument must be an object.');
	        const caseSensitive = context.parse(options['case-sensitive'] === undefined ? false : options['case-sensitive'], 1, BooleanType);
	        if (!caseSensitive)
	            return null;
	        const diacriticSensitive = context.parse(options['diacritic-sensitive'] === undefined ? false : options['diacritic-sensitive'], 1, BooleanType);
	        if (!diacriticSensitive)
	            return null;
	        let locale = null;
	        if (options['locale']) {
	            locale = context.parse(options['locale'], 1, StringType);
	            if (!locale)
	                return null;
	        }
	        return new CollatorExpression(caseSensitive, diacriticSensitive, locale);
	    }
	    evaluate(ctx) {
	        return new Collator(this.caseSensitive.evaluate(ctx), this.diacriticSensitive.evaluate(ctx), this.locale ? this.locale.evaluate(ctx) : null);
	    }
	    eachChild(fn) {
	        fn(this.caseSensitive);
	        fn(this.diacriticSensitive);
	        if (this.locale) {
	            fn(this.locale);
	        }
	    }
	    outputDefined() {
	        // Technically the set of possible outputs is the combinatoric set of Collators produced
	        // by all possible outputs of locale/caseSensitive/diacriticSensitive
	        // But for the primary use of Collators in comparison operators, we ignore the Collator's
	        // possible outputs anyway, so we can get away with leaving this false for now.
	        return false;
	    }
	}

	const EXTENT$1 = 8192;
	function updateBBox(bbox, coord) {
	    bbox[0] = Math.min(bbox[0], coord[0]);
	    bbox[1] = Math.min(bbox[1], coord[1]);
	    bbox[2] = Math.max(bbox[2], coord[0]);
	    bbox[3] = Math.max(bbox[3], coord[1]);
	}
	function mercatorXfromLng$1(lng) {
	    return (180 + lng) / 360;
	}
	function mercatorYfromLat$1(lat) {
	    return (180 - (180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + lat * Math.PI / 360)))) / 360;
	}
	function boxWithinBox(bbox1, bbox2) {
	    if (bbox1[0] <= bbox2[0])
	        return false;
	    if (bbox1[2] >= bbox2[2])
	        return false;
	    if (bbox1[1] <= bbox2[1])
	        return false;
	    if (bbox1[3] >= bbox2[3])
	        return false;
	    return true;
	}
	function getTileCoordinates(p, canonical) {
	    const x = mercatorXfromLng$1(p[0]);
	    const y = mercatorYfromLat$1(p[1]);
	    const tilesAtZoom = Math.pow(2, canonical.z);
	    return [Math.round(x * tilesAtZoom * EXTENT$1), Math.round(y * tilesAtZoom * EXTENT$1)];
	}
	function onBoundary(p, p1, p2) {
	    const x1 = p[0] - p1[0];
	    const y1 = p[1] - p1[1];
	    const x2 = p[0] - p2[0];
	    const y2 = p[1] - p2[1];
	    return (x1 * y2 - x2 * y1 === 0) && (x1 * x2 <= 0) && (y1 * y2 <= 0);
	}
	function rayIntersect(p, p1, p2) {
	    return ((p1[1] > p[1]) !== (p2[1] > p[1])) && (p[0] < (p2[0] - p1[0]) * (p[1] - p1[1]) / (p2[1] - p1[1]) + p1[0]);
	}
	// ray casting algorithm for detecting if point is in polygon
	function pointWithinPolygon(point, rings) {
	    let inside = false;
	    for (let i = 0, len = rings.length; i < len; i++) {
	        const ring = rings[i];
	        for (let j = 0, len2 = ring.length; j < len2 - 1; j++) {
	            if (onBoundary(point, ring[j], ring[j + 1]))
	                return false;
	            if (rayIntersect(point, ring[j], ring[j + 1]))
	                inside = !inside;
	        }
	    }
	    return inside;
	}
	function pointWithinPolygons(point, polygons) {
	    for (let i = 0; i < polygons.length; i++) {
	        if (pointWithinPolygon(point, polygons[i]))
	            return true;
	    }
	    return false;
	}
	function perp(v1, v2) {
	    return (v1[0] * v2[1] - v1[1] * v2[0]);
	}
	// check if p1 and p2 are in different sides of line segment q1->q2
	function twoSided(p1, p2, q1, q2) {
	    // q1->p1 (x1, y1), q1->p2 (x2, y2), q1->q2 (x3, y3)
	    const x1 = p1[0] - q1[0];
	    const y1 = p1[1] - q1[1];
	    const x2 = p2[0] - q1[0];
	    const y2 = p2[1] - q1[1];
	    const x3 = q2[0] - q1[0];
	    const y3 = q2[1] - q1[1];
	    const det1 = (x1 * y3 - x3 * y1);
	    const det2 = (x2 * y3 - x3 * y2);
	    if ((det1 > 0 && det2 < 0) || (det1 < 0 && det2 > 0))
	        return true;
	    return false;
	}
	// a, b are end points for line segment1, c and d are end points for line segment2
	function lineIntersectLine(a, b, c, d) {
	    // check if two segments are parallel or not
	    // precondition is end point a, b is inside polygon, if line a->b is
	    // parallel to polygon edge c->d, then a->b won't intersect with c->d
	    const vectorP = [b[0] - a[0], b[1] - a[1]];
	    const vectorQ = [d[0] - c[0], d[1] - c[1]];
	    if (perp(vectorQ, vectorP) === 0)
	        return false;
	    // If lines are intersecting with each other, the relative location should be:
	    // a and b lie in different sides of segment c->d
	    // c and d lie in different sides of segment a->b
	    if (twoSided(a, b, c, d) && twoSided(c, d, a, b))
	        return true;
	    return false;
	}
	function lineIntersectPolygon(p1, p2, polygon) {
	    for (const ring of polygon) {
	        // loop through every edge of the ring
	        for (let j = 0; j < ring.length - 1; ++j) {
	            if (lineIntersectLine(p1, p2, ring[j], ring[j + 1])) {
	                return true;
	            }
	        }
	    }
	    return false;
	}
	function lineStringWithinPolygon(line, polygon) {
	    // First, check if geometry points of line segments are all inside polygon
	    for (let i = 0; i < line.length; ++i) {
	        if (!pointWithinPolygon(line[i], polygon)) {
	            return false;
	        }
	    }
	    // Second, check if there is line segment intersecting polygon edge
	    for (let i = 0; i < line.length - 1; ++i) {
	        if (lineIntersectPolygon(line[i], line[i + 1], polygon)) {
	            return false;
	        }
	    }
	    return true;
	}
	function lineStringWithinPolygons(line, polygons) {
	    for (let i = 0; i < polygons.length; i++) {
	        if (lineStringWithinPolygon(line, polygons[i]))
	            return true;
	    }
	    return false;
	}
	function getTilePolygon(coordinates, bbox, canonical) {
	    const polygon = [];
	    for (let i = 0; i < coordinates.length; i++) {
	        const ring = [];
	        for (let j = 0; j < coordinates[i].length; j++) {
	            const coord = getTileCoordinates(coordinates[i][j], canonical);
	            updateBBox(bbox, coord);
	            ring.push(coord);
	        }
	        polygon.push(ring);
	    }
	    return polygon;
	}
	function getTilePolygons(coordinates, bbox, canonical) {
	    const polygons = [];
	    for (let i = 0; i < coordinates.length; i++) {
	        const polygon = getTilePolygon(coordinates[i], bbox, canonical);
	        polygons.push(polygon);
	    }
	    return polygons;
	}
	function updatePoint(p, bbox, polyBBox, worldSize) {
	    if (p[0] < polyBBox[0] || p[0] > polyBBox[2]) {
	        const halfWorldSize = worldSize * 0.5;
	        let shift = (p[0] - polyBBox[0] > halfWorldSize) ? -worldSize : (polyBBox[0] - p[0] > halfWorldSize) ? worldSize : 0;
	        if (shift === 0) {
	            shift = (p[0] - polyBBox[2] > halfWorldSize) ? -worldSize : (polyBBox[2] - p[0] > halfWorldSize) ? worldSize : 0;
	        }
	        p[0] += shift;
	    }
	    updateBBox(bbox, p);
	}
	function resetBBox(bbox) {
	    bbox[0] = bbox[1] = Infinity;
	    bbox[2] = bbox[3] = -Infinity;
	}
	function getTilePoints(geometry, pointBBox, polyBBox, canonical) {
	    const worldSize = Math.pow(2, canonical.z) * EXTENT$1;
	    const shifts = [canonical.x * EXTENT$1, canonical.y * EXTENT$1];
	    const tilePoints = [];
	    for (const points of geometry) {
	        for (const point of points) {
	            const p = [point.x + shifts[0], point.y + shifts[1]];
	            updatePoint(p, pointBBox, polyBBox, worldSize);
	            tilePoints.push(p);
	        }
	    }
	    return tilePoints;
	}
	function getTileLines(geometry, lineBBox, polyBBox, canonical) {
	    const worldSize = Math.pow(2, canonical.z) * EXTENT$1;
	    const shifts = [canonical.x * EXTENT$1, canonical.y * EXTENT$1];
	    const tileLines = [];
	    for (const line of geometry) {
	        const tileLine = [];
	        for (const point of line) {
	            const p = [point.x + shifts[0], point.y + shifts[1]];
	            updateBBox(lineBBox, p);
	            tileLine.push(p);
	        }
	        tileLines.push(tileLine);
	    }
	    if (lineBBox[2] - lineBBox[0] <= worldSize / 2) {
	        resetBBox(lineBBox);
	        for (const line of tileLines) {
	            for (const p of line) {
	                updatePoint(p, lineBBox, polyBBox, worldSize);
	            }
	        }
	    }
	    return tileLines;
	}
	function pointsWithinPolygons(ctx, polygonGeometry) {
	    const pointBBox = [Infinity, Infinity, -Infinity, -Infinity];
	    const polyBBox = [Infinity, Infinity, -Infinity, -Infinity];
	    const canonical = ctx.canonicalID();
	    if (polygonGeometry.type === 'Polygon') {
	        const tilePolygon = getTilePolygon(polygonGeometry.coordinates, polyBBox, canonical);
	        const tilePoints = getTilePoints(ctx.geometry(), pointBBox, polyBBox, canonical);
	        if (!boxWithinBox(pointBBox, polyBBox))
	            return false;
	        for (const point of tilePoints) {
	            if (!pointWithinPolygon(point, tilePolygon))
	                return false;
	        }
	    }
	    if (polygonGeometry.type === 'MultiPolygon') {
	        const tilePolygons = getTilePolygons(polygonGeometry.coordinates, polyBBox, canonical);
	        const tilePoints = getTilePoints(ctx.geometry(), pointBBox, polyBBox, canonical);
	        if (!boxWithinBox(pointBBox, polyBBox))
	            return false;
	        for (const point of tilePoints) {
	            if (!pointWithinPolygons(point, tilePolygons))
	                return false;
	        }
	    }
	    return true;
	}
	function linesWithinPolygons(ctx, polygonGeometry) {
	    const lineBBox = [Infinity, Infinity, -Infinity, -Infinity];
	    const polyBBox = [Infinity, Infinity, -Infinity, -Infinity];
	    const canonical = ctx.canonicalID();
	    if (polygonGeometry.type === 'Polygon') {
	        const tilePolygon = getTilePolygon(polygonGeometry.coordinates, polyBBox, canonical);
	        const tileLines = getTileLines(ctx.geometry(), lineBBox, polyBBox, canonical);
	        if (!boxWithinBox(lineBBox, polyBBox))
	            return false;
	        for (const line of tileLines) {
	            if (!lineStringWithinPolygon(line, tilePolygon))
	                return false;
	        }
	    }
	    if (polygonGeometry.type === 'MultiPolygon') {
	        const tilePolygons = getTilePolygons(polygonGeometry.coordinates, polyBBox, canonical);
	        const tileLines = getTileLines(ctx.geometry(), lineBBox, polyBBox, canonical);
	        if (!boxWithinBox(lineBBox, polyBBox))
	            return false;
	        for (const line of tileLines) {
	            if (!lineStringWithinPolygons(line, tilePolygons))
	                return false;
	        }
	    }
	    return true;
	}
	class Within {
	    constructor(geojson, geometries) {
	        this.type = BooleanType;
	        this.geojson = geojson;
	        this.geometries = geometries;
	    }
	    static parse(args, context) {
	        if (args.length !== 2)
	            return context.error(`'within' expression requires exactly one argument, but found ${args.length - 1} instead.`);
	        if (isValue(args[1])) {
	            const geojson = args[1];
	            if (geojson.type === 'FeatureCollection') {
	                const polygonsCoords = [];
	                for (const polygon of geojson.features) {
	                    const { type, coordinates } = polygon.geometry;
	                    if (type === 'Polygon') {
	                        polygonsCoords.push(coordinates);
	                    }
	                    if (type === 'MultiPolygon') {
	                        polygonsCoords.push(...coordinates);
	                    }
	                }
	                if (polygonsCoords.length) {
	                    const multipolygonWrapper = {
	                        type: 'MultiPolygon',
	                        coordinates: polygonsCoords
	                    };
	                    return new Within(geojson, multipolygonWrapper);
	                }
	            }
	            else if (geojson.type === 'Feature') {
	                const type = geojson.geometry.type;
	                if (type === 'Polygon' || type === 'MultiPolygon') {
	                    return new Within(geojson, geojson.geometry);
	                }
	            }
	            else if (geojson.type === 'Polygon' || geojson.type === 'MultiPolygon') {
	                return new Within(geojson, geojson);
	            }
	        }
	        return context.error('\'within\' expression requires valid geojson object that contains polygon geometry type.');
	    }
	    evaluate(ctx) {
	        if (ctx.geometry() != null && ctx.canonicalID() != null) {
	            if (ctx.geometryType() === 'Point') {
	                return pointsWithinPolygons(ctx, this.geometries);
	            }
	            else if (ctx.geometryType() === 'LineString') {
	                return linesWithinPolygons(ctx, this.geometries);
	            }
	        }
	        return false;
	    }
	    eachChild() { }
	    outputDefined() {
	        return true;
	    }
	}

	class Var {
	    constructor(name, boundExpression) {
	        this.type = boundExpression.type;
	        this.name = name;
	        this.boundExpression = boundExpression;
	    }
	    static parse(args, context) {
	        if (args.length !== 2 || typeof args[1] !== 'string')
	            return context.error('\'var\' expression requires exactly one string literal argument.');
	        const name = args[1];
	        if (!context.scope.has(name)) {
	            return context.error(`Unknown variable "${name}". Make sure "${name}" has been bound in an enclosing "let" expression before using it.`, 1);
	        }
	        return new Var(name, context.scope.get(name));
	    }
	    evaluate(ctx) {
	        return this.boundExpression.evaluate(ctx);
	    }
	    eachChild() { }
	    outputDefined() {
	        return false;
	    }
	}

	class CompoundExpression {
	    constructor(name, type, evaluate, args) {
	        this.name = name;
	        this.type = type;
	        this._evaluate = evaluate;
	        this.args = args;
	    }
	    evaluate(ctx) {
	        return this._evaluate(ctx, this.args);
	    }
	    eachChild(fn) {
	        this.args.forEach(fn);
	    }
	    outputDefined() {
	        return false;
	    }
	    static parse(args, context) {
	        const op = args[0];
	        const definition = CompoundExpression.definitions[op];
	        if (!definition) {
	            return context.error(`Unknown expression "${op}". If you wanted a literal array, use ["literal", [...]].`, 0);
	        }
	        // Now check argument types against each signature
	        const type = Array.isArray(definition) ?
	            definition[0] : definition.type;
	        const availableOverloads = Array.isArray(definition) ?
	            [[definition[1], definition[2]]] :
	            definition.overloads;
	        const overloads = availableOverloads.filter(([signature]) => (!Array.isArray(signature) || // varags
	            signature.length === args.length - 1 // correct param count
	        ));
	        let signatureContext = null;
	        for (const [params, evaluate] of overloads) {
	            // Use a fresh context for each attempted signature so that, if
	            // we eventually succeed, we haven't polluted `context.errors`.
	            signatureContext = new ParsingContext(context.registry, isExpressionConstant, context.path, null, context.scope);
	            // First parse all the args, potentially coercing to the
	            // types expected by this overload.
	            const parsedArgs = [];
	            let argParseFailed = false;
	            for (let i = 1; i < args.length; i++) {
	                const arg = args[i];
	                const expectedType = Array.isArray(params) ?
	                    params[i - 1] :
	                    params.type;
	                const parsed = signatureContext.parse(arg, 1 + parsedArgs.length, expectedType);
	                if (!parsed) {
	                    argParseFailed = true;
	                    break;
	                }
	                parsedArgs.push(parsed);
	            }
	            if (argParseFailed) {
	                // Couldn't coerce args of this overload to expected type, move
	                // on to next one.
	                continue;
	            }
	            if (Array.isArray(params)) {
	                if (params.length !== parsedArgs.length) {
	                    signatureContext.error(`Expected ${params.length} arguments, but found ${parsedArgs.length} instead.`);
	                    continue;
	                }
	            }
	            for (let i = 0; i < parsedArgs.length; i++) {
	                const expected = Array.isArray(params) ? params[i] : params.type;
	                const arg = parsedArgs[i];
	                signatureContext.concat(i + 1).checkSubtype(expected, arg.type);
	            }
	            if (signatureContext.errors.length === 0) {
	                return new CompoundExpression(op, type, evaluate, parsedArgs);
	            }
	        }
	        if (overloads.length === 1) {
	            context.errors.push(...signatureContext.errors);
	        }
	        else {
	            const expected = overloads.length ? overloads : availableOverloads;
	            const signatures = expected
	                .map(([params]) => stringifySignature(params))
	                .join(' | ');
	            const actualTypes = [];
	            // For error message, re-parse arguments without trying to
	            // apply any coercions
	            for (let i = 1; i < args.length; i++) {
	                const parsed = context.parse(args[i], 1 + actualTypes.length);
	                if (!parsed)
	                    return null;
	                actualTypes.push(toString$1(parsed.type));
	            }
	            context.error(`Expected arguments of type ${signatures}, but found (${actualTypes.join(', ')}) instead.`);
	        }
	        return null;
	    }
	    static register(registry, definitions) {
	        CompoundExpression.definitions = definitions;
	        for (const name in definitions) {
	            registry[name] = CompoundExpression;
	        }
	    }
	}
	function stringifySignature(signature) {
	    if (Array.isArray(signature)) {
	        return `(${signature.map(toString$1).join(', ')})`;
	    }
	    else {
	        return `(${toString$1(signature.type)}...)`;
	    }
	}
	function isExpressionConstant(expression) {
	    if (expression instanceof Var) {
	        return isExpressionConstant(expression.boundExpression);
	    }
	    else if (expression instanceof CompoundExpression && expression.name === 'error') {
	        return false;
	    }
	    else if (expression instanceof CollatorExpression) {
	        // Although the results of a Collator expression with fixed arguments
	        // generally shouldn't change between executions, we can't serialize them
	        // as constant expressions because results change based on environment.
	        return false;
	    }
	    else if (expression instanceof Within) {
	        return false;
	    }
	    const isTypeAnnotation = expression instanceof Coercion ||
	        expression instanceof Assertion;
	    let childrenConstant = true;
	    expression.eachChild(child => {
	        // We can _almost_ assume that if `expressions` children are constant,
	        // they would already have been evaluated to Literal values when they
	        // were parsed.  Type annotations are the exception, because they might
	        // have been inferred and added after a child was parsed.
	        // So we recurse into isConstant() for the children of type annotations,
	        // but otherwise simply check whether they are Literals.
	        if (isTypeAnnotation) {
	            childrenConstant = childrenConstant && isExpressionConstant(child);
	        }
	        else {
	            childrenConstant = childrenConstant && child instanceof Literal;
	        }
	    });
	    if (!childrenConstant) {
	        return false;
	    }
	    return isFeatureConstant(expression) &&
	        isGlobalPropertyConstant(expression, ['zoom', 'heatmap-density', 'line-progress', 'accumulated', 'is-supported-script']);
	}
	function isFeatureConstant(e) {
	    if (e instanceof CompoundExpression) {
	        if (e.name === 'get' && e.args.length === 1) {
	            return false;
	        }
	        else if (e.name === 'feature-state') {
	            return false;
	        }
	        else if (e.name === 'has' && e.args.length === 1) {
	            return false;
	        }
	        else if (e.name === 'properties' ||
	            e.name === 'geometry-type' ||
	            e.name === 'id') {
	            return false;
	        }
	        else if (/^filter-/.test(e.name)) {
	            return false;
	        }
	    }
	    if (e instanceof Within) {
	        return false;
	    }
	    let result = true;
	    e.eachChild(arg => {
	        if (result && !isFeatureConstant(arg)) {
	            result = false;
	        }
	    });
	    return result;
	}
	function isStateConstant(e) {
	    if (e instanceof CompoundExpression) {
	        if (e.name === 'feature-state') {
	            return false;
	        }
	    }
	    let result = true;
	    e.eachChild(arg => {
	        if (result && !isStateConstant(arg)) {
	            result = false;
	        }
	    });
	    return result;
	}
	function isGlobalPropertyConstant(e, properties) {
	    if (e instanceof CompoundExpression && properties.indexOf(e.name) >= 0) {
	        return false;
	    }
	    let result = true;
	    e.eachChild((arg) => {
	        if (result && !isGlobalPropertyConstant(arg, properties)) {
	            result = false;
	        }
	    });
	    return result;
	}

	/**
	 * Returns the index of the last stop <= input, or 0 if it doesn't exist.
	 * @private
	 */
	function findStopLessThanOrEqualTo(stops, input) {
	    const lastIndex = stops.length - 1;
	    let lowerIndex = 0;
	    let upperIndex = lastIndex;
	    let currentIndex = 0;
	    let currentValue, nextValue;
	    while (lowerIndex <= upperIndex) {
	        currentIndex = Math.floor((lowerIndex + upperIndex) / 2);
	        currentValue = stops[currentIndex];
	        nextValue = stops[currentIndex + 1];
	        if (currentValue <= input) {
	            if (currentIndex === lastIndex || input < nextValue) { // Search complete
	                return currentIndex;
	            }
	            lowerIndex = currentIndex + 1;
	        }
	        else if (currentValue > input) {
	            upperIndex = currentIndex - 1;
	        }
	        else {
	            throw new RuntimeError('Input is not a number.');
	        }
	    }
	    return 0;
	}

	class Step {
	    constructor(type, input, stops) {
	        this.type = type;
	        this.input = input;
	        this.labels = [];
	        this.outputs = [];
	        for (const [label, expression] of stops) {
	            this.labels.push(label);
	            this.outputs.push(expression);
	        }
	    }
	    static parse(args, context) {
	        if (args.length - 1 < 4) {
	            return context.error(`Expected at least 4 arguments, but found only ${args.length - 1}.`);
	        }
	        if ((args.length - 1) % 2 !== 0) {
	            return context.error('Expected an even number of arguments.');
	        }
	        const input = context.parse(args[1], 1, NumberType);
	        if (!input)
	            return null;
	        const stops = [];
	        let outputType = null;
	        if (context.expectedType && context.expectedType.kind !== 'value') {
	            outputType = context.expectedType;
	        }
	        for (let i = 1; i < args.length; i += 2) {
	            const label = i === 1 ? -Infinity : args[i];
	            const value = args[i + 1];
	            const labelKey = i;
	            const valueKey = i + 1;
	            if (typeof label !== 'number') {
	                return context.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.', labelKey);
	            }
	            if (stops.length && stops[stops.length - 1][0] >= label) {
	                return context.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.', labelKey);
	            }
	            const parsed = context.parse(value, valueKey, outputType);
	            if (!parsed)
	                return null;
	            outputType = outputType || parsed.type;
	            stops.push([label, parsed]);
	        }
	        return new Step(outputType, input, stops);
	    }
	    evaluate(ctx) {
	        const labels = this.labels;
	        const outputs = this.outputs;
	        if (labels.length === 1) {
	            return outputs[0].evaluate(ctx);
	        }
	        const value = this.input.evaluate(ctx);
	        if (value <= labels[0]) {
	            return outputs[0].evaluate(ctx);
	        }
	        const stopCount = labels.length;
	        if (value >= labels[stopCount - 1]) {
	            return outputs[stopCount - 1].evaluate(ctx);
	        }
	        const index = findStopLessThanOrEqualTo(labels, value);
	        return outputs[index].evaluate(ctx);
	    }
	    eachChild(fn) {
	        fn(this.input);
	        for (const expression of this.outputs) {
	            fn(expression);
	        }
	    }
	    outputDefined() {
	        return this.outputs.every(out => out.outputDefined());
	    }
	}

	function getDefaultExportFromCjs (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	var unitbezier = UnitBezier;

	function UnitBezier(p1x, p1y, p2x, p2y) {
	    // Calculate the polynomial coefficients, implicit first and last control points are (0,0) and (1,1).
	    this.cx = 3.0 * p1x;
	    this.bx = 3.0 * (p2x - p1x) - this.cx;
	    this.ax = 1.0 - this.cx - this.bx;

	    this.cy = 3.0 * p1y;
	    this.by = 3.0 * (p2y - p1y) - this.cy;
	    this.ay = 1.0 - this.cy - this.by;

	    this.p1x = p1x;
	    this.p1y = p1y;
	    this.p2x = p2x;
	    this.p2y = p2y;
	}

	UnitBezier.prototype = {
	    sampleCurveX: function (t) {
	        // `ax t^3 + bx t^2 + cx t' expanded using Horner's rule.
	        return ((this.ax * t + this.bx) * t + this.cx) * t;
	    },

	    sampleCurveY: function (t) {
	        return ((this.ay * t + this.by) * t + this.cy) * t;
	    },

	    sampleCurveDerivativeX: function (t) {
	        return (3.0 * this.ax * t + 2.0 * this.bx) * t + this.cx;
	    },

	    solveCurveX: function (x, epsilon) {
	        if (epsilon === undefined) epsilon = 1e-6;

	        if (x < 0.0) return 0.0;
	        if (x > 1.0) return 1.0;

	        var t = x;

	        // First try a few iterations of Newton's method - normally very fast.
	        for (var i = 0; i < 8; i++) {
	            var x2 = this.sampleCurveX(t) - x;
	            if (Math.abs(x2) < epsilon) return t;

	            var d2 = this.sampleCurveDerivativeX(t);
	            if (Math.abs(d2) < 1e-6) break;

	            t = t - x2 / d2;
	        }

	        // Fall back to the bisection method for reliability.
	        var t0 = 0.0;
	        var t1 = 1.0;
	        t = x;

	        for (i = 0; i < 20; i++) {
	            x2 = this.sampleCurveX(t);
	            if (Math.abs(x2 - x) < epsilon) break;

	            if (x > x2) {
	                t0 = t;
	            } else {
	                t1 = t;
	            }

	            t = (t1 - t0) * 0.5 + t0;
	        }

	        return t;
	    },

	    solve: function (x, epsilon) {
	        return this.sampleCurveY(this.solveCurveX(x, epsilon));
	    }
	};

	var UnitBezier$1 = /*@__PURE__*/getDefaultExportFromCjs(unitbezier);

	/**
	 * Checks whether the specified color space is one of the supported interpolation color spaces.
	 *
	 * @param colorSpace Color space key to verify.
	 * @returns `true` if the specified color space is one of the supported
	 * interpolation color spaces, `false` otherwise
	 */
	function isSupportedInterpolationColorSpace(colorSpace) {
	    return colorSpace === 'rgb' || colorSpace === 'hcl' || colorSpace === 'lab';
	}
	function number(from, to, t) {
	    return from + t * (to - from);
	}
	function color(from, to, t, spaceKey = 'rgb') {
	    switch (spaceKey) {
	        case 'rgb': {
	            const [r, g, b, alpha] = array(from.rgb, to.rgb, t);
	            return new Color(r, g, b, alpha, false);
	        }
	        case 'hcl': {
	            const [hue0, chroma0, light0, alphaF] = from.hcl;
	            const [hue1, chroma1, light1, alphaT] = to.hcl;
	            // https://github.com/gka/chroma.js/blob/cd1b3c0926c7a85cbdc3b1453b3a94006de91a92/src/interpolator/_hsx.js
	            let hue, chroma;
	            if (!isNaN(hue0) && !isNaN(hue1)) {
	                let dh = hue1 - hue0;
	                if (hue1 > hue0 && dh > 180) {
	                    dh -= 360;
	                }
	                else if (hue1 < hue0 && hue0 - hue1 > 180) {
	                    dh += 360;
	                }
	                hue = hue0 + t * dh;
	            }
	            else if (!isNaN(hue0)) {
	                hue = hue0;
	                if (light1 === 1 || light1 === 0)
	                    chroma = chroma0;
	            }
	            else if (!isNaN(hue1)) {
	                hue = hue1;
	                if (light0 === 1 || light0 === 0)
	                    chroma = chroma1;
	            }
	            else {
	                hue = NaN;
	            }
	            const [r, g, b, alpha] = hclToRgb([
	                hue,
	                chroma !== null && chroma !== void 0 ? chroma : number(chroma0, chroma1, t),
	                number(light0, light1, t),
	                number(alphaF, alphaT, t),
	            ]);
	            return new Color(r, g, b, alpha, false);
	        }
	        case 'lab': {
	            const [r, g, b, alpha] = labToRgb(array(from.lab, to.lab, t));
	            return new Color(r, g, b, alpha, false);
	        }
	    }
	}
	function array(from, to, t) {
	    return from.map((d, i) => {
	        return number(d, to[i], t);
	    });
	}
	function padding(from, to, t) {
	    return new Padding(array(from.values, to.values, t));
	}
	function variableAnchorOffsetCollection(from, to, t) {
	    const fromValues = from.values;
	    const toValues = to.values;
	    if (fromValues.length !== toValues.length) {
	        throw new RuntimeError(`Cannot interpolate values of different length. from: ${from.toString()}, to: ${to.toString()}`);
	    }
	    const output = [];
	    for (let i = 0; i < fromValues.length; i += 2) {
	        // Anchor entries must match
	        if (fromValues[i] !== toValues[i]) {
	            throw new RuntimeError(`Cannot interpolate values containing mismatched anchors. from[${i}]: ${fromValues[i]}, to[${i}]: ${toValues[i]}`);
	        }
	        output.push(fromValues[i]);
	        // Interpolate the offset values for each anchor
	        const [fx, fy] = fromValues[i + 1];
	        const [tx, ty] = toValues[i + 1];
	        output.push([number(fx, tx, t), number(fy, ty, t)]);
	    }
	    return new VariableAnchorOffsetCollection(output);
	}
	const interpolate = {
	    number,
	    color,
	    array,
	    padding,
	    variableAnchorOffsetCollection
	};

	class Interpolate {
	    constructor(type, operator, interpolation, input, stops) {
	        this.type = type;
	        this.operator = operator;
	        this.interpolation = interpolation;
	        this.input = input;
	        this.labels = [];
	        this.outputs = [];
	        for (const [label, expression] of stops) {
	            this.labels.push(label);
	            this.outputs.push(expression);
	        }
	    }
	    static interpolationFactor(interpolation, input, lower, upper) {
	        let t = 0;
	        if (interpolation.name === 'exponential') {
	            t = exponentialInterpolation(input, interpolation.base, lower, upper);
	        }
	        else if (interpolation.name === 'linear') {
	            t = exponentialInterpolation(input, 1, lower, upper);
	        }
	        else if (interpolation.name === 'cubic-bezier') {
	            const c = interpolation.controlPoints;
	            const ub = new UnitBezier$1(c[0], c[1], c[2], c[3]);
	            t = ub.solve(exponentialInterpolation(input, 1, lower, upper));
	        }
	        return t;
	    }
	    static parse(args, context) {
	        let [operator, interpolation, input, ...rest] = args;
	        if (!Array.isArray(interpolation) || interpolation.length === 0) {
	            return context.error('Expected an interpolation type expression.', 1);
	        }
	        if (interpolation[0] === 'linear') {
	            interpolation = { name: 'linear' };
	        }
	        else if (interpolation[0] === 'exponential') {
	            const base = interpolation[1];
	            if (typeof base !== 'number')
	                return context.error('Exponential interpolation requires a numeric base.', 1, 1);
	            interpolation = {
	                name: 'exponential',
	                base
	            };
	        }
	        else if (interpolation[0] === 'cubic-bezier') {
	            const controlPoints = interpolation.slice(1);
	            if (controlPoints.length !== 4 ||
	                controlPoints.some(t => typeof t !== 'number' || t < 0 || t > 1)) {
	                return context.error('Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.', 1);
	            }
	            interpolation = {
	                name: 'cubic-bezier',
	                controlPoints: controlPoints
	            };
	        }
	        else {
	            return context.error(`Unknown interpolation type ${String(interpolation[0])}`, 1, 0);
	        }
	        if (args.length - 1 < 4) {
	            return context.error(`Expected at least 4 arguments, but found only ${args.length - 1}.`);
	        }
	        if ((args.length - 1) % 2 !== 0) {
	            return context.error('Expected an even number of arguments.');
	        }
	        input = context.parse(input, 2, NumberType);
	        if (!input)
	            return null;
	        const stops = [];
	        let outputType = null;
	        if (operator === 'interpolate-hcl' || operator === 'interpolate-lab') {
	            outputType = ColorType;
	        }
	        else if (context.expectedType && context.expectedType.kind !== 'value') {
	            outputType = context.expectedType;
	        }
	        for (let i = 0; i < rest.length; i += 2) {
	            const label = rest[i];
	            const value = rest[i + 1];
	            const labelKey = i + 3;
	            const valueKey = i + 4;
	            if (typeof label !== 'number') {
	                return context.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.', labelKey);
	            }
	            if (stops.length && stops[stops.length - 1][0] >= label) {
	                return context.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.', labelKey);
	            }
	            const parsed = context.parse(value, valueKey, outputType);
	            if (!parsed)
	                return null;
	            outputType = outputType || parsed.type;
	            stops.push([label, parsed]);
	        }
	        if (!verifyType(outputType, NumberType) &&
	            !verifyType(outputType, ColorType) &&
	            !verifyType(outputType, PaddingType) &&
	            !verifyType(outputType, VariableAnchorOffsetCollectionType) &&
	            !verifyType(outputType, array$1(NumberType))) {
	            return context.error(`Type ${toString$1(outputType)} is not interpolatable.`);
	        }
	        return new Interpolate(outputType, operator, interpolation, input, stops);
	    }
	    evaluate(ctx) {
	        const labels = this.labels;
	        const outputs = this.outputs;
	        if (labels.length === 1) {
	            return outputs[0].evaluate(ctx);
	        }
	        const value = this.input.evaluate(ctx);
	        if (value <= labels[0]) {
	            return outputs[0].evaluate(ctx);
	        }
	        const stopCount = labels.length;
	        if (value >= labels[stopCount - 1]) {
	            return outputs[stopCount - 1].evaluate(ctx);
	        }
	        const index = findStopLessThanOrEqualTo(labels, value);
	        const lower = labels[index];
	        const upper = labels[index + 1];
	        const t = Interpolate.interpolationFactor(this.interpolation, value, lower, upper);
	        const outputLower = outputs[index].evaluate(ctx);
	        const outputUpper = outputs[index + 1].evaluate(ctx);
	        switch (this.operator) {
	            case 'interpolate':
	                return interpolate[this.type.kind](outputLower, outputUpper, t);
	            case 'interpolate-hcl':
	                return interpolate.color(outputLower, outputUpper, t, 'hcl');
	            case 'interpolate-lab':
	                return interpolate.color(outputLower, outputUpper, t, 'lab');
	        }
	    }
	    eachChild(fn) {
	        fn(this.input);
	        for (const expression of this.outputs) {
	            fn(expression);
	        }
	    }
	    outputDefined() {
	        return this.outputs.every(out => out.outputDefined());
	    }
	}
	/**
	 * Returns a ratio that can be used to interpolate between exponential function
	 * stops.
	 * How it works: Two consecutive stop values define a (scaled and shifted) exponential function `f(x) = a * base^x + b`, where `base` is the user-specified base,
	 * and `a` and `b` are constants affording sufficient degrees of freedom to fit
	 * the function to the given stops.
	 *
	 * Here's a bit of algebra that lets us compute `f(x)` directly from the stop
	 * values without explicitly solving for `a` and `b`:
	 *
	 * First stop value: `f(x0) = y0 = a * base^x0 + b`
	 * Second stop value: `f(x1) = y1 = a * base^x1 + b`
	 * => `y1 - y0 = a(base^x1 - base^x0)`
	 * => `a = (y1 - y0)/(base^x1 - base^x0)`
	 *
	 * Desired value: `f(x) = y = a * base^x + b`
	 * => `f(x) = y0 + a * (base^x - base^x0)`
	 *
	 * From the above, we can replace the `a` in `a * (base^x - base^x0)` and do a
	 * little algebra:
	 * ```
	 * a * (base^x - base^x0) = (y1 - y0)/(base^x1 - base^x0) * (base^x - base^x0)
	 *                     = (y1 - y0) * (base^x - base^x0) / (base^x1 - base^x0)
	 * ```
	 *
	 * If we let `(base^x - base^x0) / (base^x1 base^x0)`, then we have
	 * `f(x) = y0 + (y1 - y0) * ratio`.  In other words, `ratio` may be treated as
	 * an interpolation factor between the two stops' output values.
	 *
	 * (Note: a slightly different form for `ratio`,
	 * `(base^(x-x0) - 1) / (base^(x1-x0) - 1) `, is equivalent, but requires fewer
	 * expensive `Math.pow()` operations.)
	 *
	 * @private
	*/
	function exponentialInterpolation(input, base, lowerValue, upperValue) {
	    const difference = upperValue - lowerValue;
	    const progress = input - lowerValue;
	    if (difference === 0) {
	        return 0;
	    }
	    else if (base === 1) {
	        return progress / difference;
	    }
	    else {
	        return (Math.pow(base, progress) - 1) / (Math.pow(base, difference) - 1);
	    }
	}

	class Coalesce {
	    constructor(type, args) {
	        this.type = type;
	        this.args = args;
	    }
	    static parse(args, context) {
	        if (args.length < 2) {
	            return context.error('Expectected at least one argument.');
	        }
	        let outputType = null;
	        const expectedType = context.expectedType;
	        if (expectedType && expectedType.kind !== 'value') {
	            outputType = expectedType;
	        }
	        const parsedArgs = [];
	        for (const arg of args.slice(1)) {
	            const parsed = context.parse(arg, 1 + parsedArgs.length, outputType, undefined, { typeAnnotation: 'omit' });
	            if (!parsed)
	                return null;
	            outputType = outputType || parsed.type;
	            parsedArgs.push(parsed);
	        }
	        if (!outputType)
	            throw new Error('No output type');
	        // Above, we parse arguments without inferred type annotation so that
	        // they don't produce a runtime error for `null` input, which would
	        // preempt the desired null-coalescing behavior.
	        // Thus, if any of our arguments would have needed an annotation, we
	        // need to wrap the enclosing coalesce expression with it instead.
	        const needsAnnotation = expectedType &&
	            parsedArgs.some(arg => checkSubtype(expectedType, arg.type));
	        return needsAnnotation ?
	            new Coalesce(ValueType, parsedArgs) :
	            new Coalesce(outputType, parsedArgs);
	    }
	    evaluate(ctx) {
	        let result = null;
	        let argCount = 0;
	        let requestedImageName;
	        for (const arg of this.args) {
	            argCount++;
	            result = arg.evaluate(ctx);
	            // we need to keep track of the first requested image in a coalesce statement
	            // if coalesce can't find a valid image, we return the first image name so styleimagemissing can fire
	            if (result && result instanceof ResolvedImage && !result.available) {
	                if (!requestedImageName) {
	                    requestedImageName = result.name;
	                }
	                result = null;
	                if (argCount === this.args.length) {
	                    result = requestedImageName;
	                }
	            }
	            if (result !== null)
	                break;
	        }
	        return result;
	    }
	    eachChild(fn) {
	        this.args.forEach(fn);
	    }
	    outputDefined() {
	        return this.args.every(arg => arg.outputDefined());
	    }
	}

	class Let {
	    constructor(bindings, result) {
	        this.type = result.type;
	        this.bindings = [].concat(bindings);
	        this.result = result;
	    }
	    evaluate(ctx) {
	        return this.result.evaluate(ctx);
	    }
	    eachChild(fn) {
	        for (const binding of this.bindings) {
	            fn(binding[1]);
	        }
	        fn(this.result);
	    }
	    static parse(args, context) {
	        if (args.length < 4)
	            return context.error(`Expected at least 3 arguments, but found ${args.length - 1} instead.`);
	        const bindings = [];
	        for (let i = 1; i < args.length - 1; i += 2) {
	            const name = args[i];
	            if (typeof name !== 'string') {
	                return context.error(`Expected string, but found ${typeof name} instead.`, i);
	            }
	            if (/[^a-zA-Z0-9_]/.test(name)) {
	                return context.error('Variable names must contain only alphanumeric characters or \'_\'.', i);
	            }
	            const value = context.parse(args[i + 1], i + 1);
	            if (!value)
	                return null;
	            bindings.push([name, value]);
	        }
	        const result = context.parse(args[args.length - 1], args.length - 1, context.expectedType, bindings);
	        if (!result)
	            return null;
	        return new Let(bindings, result);
	    }
	    outputDefined() {
	        return this.result.outputDefined();
	    }
	}

	class At {
	    constructor(type, index, input) {
	        this.type = type;
	        this.index = index;
	        this.input = input;
	    }
	    static parse(args, context) {
	        if (args.length !== 3)
	            return context.error(`Expected 2 arguments, but found ${args.length - 1} instead.`);
	        const index = context.parse(args[1], 1, NumberType);
	        const input = context.parse(args[2], 2, array$1(context.expectedType || ValueType));
	        if (!index || !input)
	            return null;
	        const t = input.type;
	        return new At(t.itemType, index, input);
	    }
	    evaluate(ctx) {
	        const index = this.index.evaluate(ctx);
	        const array = this.input.evaluate(ctx);
	        if (index < 0) {
	            throw new RuntimeError(`Array index out of bounds: ${index} < 0.`);
	        }
	        if (index >= array.length) {
	            throw new RuntimeError(`Array index out of bounds: ${index} > ${array.length - 1}.`);
	        }
	        if (index !== Math.floor(index)) {
	            throw new RuntimeError(`Array index must be an integer, but found ${index} instead.`);
	        }
	        return array[index];
	    }
	    eachChild(fn) {
	        fn(this.index);
	        fn(this.input);
	    }
	    outputDefined() {
	        return false;
	    }
	}

	class In {
	    constructor(needle, haystack) {
	        this.type = BooleanType;
	        this.needle = needle;
	        this.haystack = haystack;
	    }
	    static parse(args, context) {
	        if (args.length !== 3) {
	            return context.error(`Expected 2 arguments, but found ${args.length - 1} instead.`);
	        }
	        const needle = context.parse(args[1], 1, ValueType);
	        const haystack = context.parse(args[2], 2, ValueType);
	        if (!needle || !haystack)
	            return null;
	        if (!isValidType(needle.type, [BooleanType, StringType, NumberType, NullType, ValueType])) {
	            return context.error(`Expected first argument to be of type boolean, string, number or null, but found ${toString$1(needle.type)} instead`);
	        }
	        return new In(needle, haystack);
	    }
	    evaluate(ctx) {
	        const needle = this.needle.evaluate(ctx);
	        const haystack = this.haystack.evaluate(ctx);
	        if (!haystack)
	            return false;
	        if (!isValidNativeType(needle, ['boolean', 'string', 'number', 'null'])) {
	            throw new RuntimeError(`Expected first argument to be of type boolean, string, number or null, but found ${toString$1(typeOf(needle))} instead.`);
	        }
	        if (!isValidNativeType(haystack, ['string', 'array'])) {
	            throw new RuntimeError(`Expected second argument to be of type array or string, but found ${toString$1(typeOf(haystack))} instead.`);
	        }
	        return haystack.indexOf(needle) >= 0;
	    }
	    eachChild(fn) {
	        fn(this.needle);
	        fn(this.haystack);
	    }
	    outputDefined() {
	        return true;
	    }
	}

	class IndexOf {
	    constructor(needle, haystack, fromIndex) {
	        this.type = NumberType;
	        this.needle = needle;
	        this.haystack = haystack;
	        this.fromIndex = fromIndex;
	    }
	    static parse(args, context) {
	        if (args.length <= 2 || args.length >= 5) {
	            return context.error(`Expected 3 or 4 arguments, but found ${args.length - 1} instead.`);
	        }
	        const needle = context.parse(args[1], 1, ValueType);
	        const haystack = context.parse(args[2], 2, ValueType);
	        if (!needle || !haystack)
	            return null;
	        if (!isValidType(needle.type, [BooleanType, StringType, NumberType, NullType, ValueType])) {
	            return context.error(`Expected first argument to be of type boolean, string, number or null, but found ${toString$1(needle.type)} instead`);
	        }
	        if (args.length === 4) {
	            const fromIndex = context.parse(args[3], 3, NumberType);
	            if (!fromIndex)
	                return null;
	            return new IndexOf(needle, haystack, fromIndex);
	        }
	        else {
	            return new IndexOf(needle, haystack);
	        }
	    }
	    evaluate(ctx) {
	        const needle = this.needle.evaluate(ctx);
	        const haystack = this.haystack.evaluate(ctx);
	        if (!isValidNativeType(needle, ['boolean', 'string', 'number', 'null'])) {
	            throw new RuntimeError(`Expected first argument to be of type boolean, string, number or null, but found ${toString$1(typeOf(needle))} instead.`);
	        }
	        if (!isValidNativeType(haystack, ['string', 'array'])) {
	            throw new RuntimeError(`Expected second argument to be of type array or string, but found ${toString$1(typeOf(haystack))} instead.`);
	        }
	        if (this.fromIndex) {
	            const fromIndex = this.fromIndex.evaluate(ctx);
	            return haystack.indexOf(needle, fromIndex);
	        }
	        return haystack.indexOf(needle);
	    }
	    eachChild(fn) {
	        fn(this.needle);
	        fn(this.haystack);
	        if (this.fromIndex) {
	            fn(this.fromIndex);
	        }
	    }
	    outputDefined() {
	        return false;
	    }
	}

	class Match {
	    constructor(inputType, outputType, input, cases, outputs, otherwise) {
	        this.inputType = inputType;
	        this.type = outputType;
	        this.input = input;
	        this.cases = cases;
	        this.outputs = outputs;
	        this.otherwise = otherwise;
	    }
	    static parse(args, context) {
	        if (args.length < 5)
	            return context.error(`Expected at least 4 arguments, but found only ${args.length - 1}.`);
	        if (args.length % 2 !== 1)
	            return context.error('Expected an even number of arguments.');
	        let inputType;
	        let outputType;
	        if (context.expectedType && context.expectedType.kind !== 'value') {
	            outputType = context.expectedType;
	        }
	        const cases = {};
	        const outputs = [];
	        for (let i = 2; i < args.length - 1; i += 2) {
	            let labels = args[i];
	            const value = args[i + 1];
	            if (!Array.isArray(labels)) {
	                labels = [labels];
	            }
	            const labelContext = context.concat(i);
	            if (labels.length === 0) {
	                return labelContext.error('Expected at least one branch label.');
	            }
	            for (const label of labels) {
	                if (typeof label !== 'number' && typeof label !== 'string') {
	                    return labelContext.error('Branch labels must be numbers or strings.');
	                }
	                else if (typeof label === 'number' && Math.abs(label) > Number.MAX_SAFE_INTEGER) {
	                    return labelContext.error(`Branch labels must be integers no larger than ${Number.MAX_SAFE_INTEGER}.`);
	                }
	                else if (typeof label === 'number' && Math.floor(label) !== label) {
	                    return labelContext.error('Numeric branch labels must be integer values.');
	                }
	                else if (!inputType) {
	                    inputType = typeOf(label);
	                }
	                else if (labelContext.checkSubtype(inputType, typeOf(label))) {
	                    return null;
	                }
	                if (typeof cases[String(label)] !== 'undefined') {
	                    return labelContext.error('Branch labels must be unique.');
	                }
	                cases[String(label)] = outputs.length;
	            }
	            const result = context.parse(value, i, outputType);
	            if (!result)
	                return null;
	            outputType = outputType || result.type;
	            outputs.push(result);
	        }
	        const input = context.parse(args[1], 1, ValueType);
	        if (!input)
	            return null;
	        const otherwise = context.parse(args[args.length - 1], args.length - 1, outputType);
	        if (!otherwise)
	            return null;
	        if (input.type.kind !== 'value' && context.concat(1).checkSubtype(inputType, input.type)) {
	            return null;
	        }
	        return new Match(inputType, outputType, input, cases, outputs, otherwise);
	    }
	    evaluate(ctx) {
	        const input = this.input.evaluate(ctx);
	        const output = (typeOf(input) === this.inputType && this.outputs[this.cases[input]]) || this.otherwise;
	        return output.evaluate(ctx);
	    }
	    eachChild(fn) {
	        fn(this.input);
	        this.outputs.forEach(fn);
	        fn(this.otherwise);
	    }
	    outputDefined() {
	        return this.outputs.every(out => out.outputDefined()) && this.otherwise.outputDefined();
	    }
	}

	class Case {
	    constructor(type, branches, otherwise) {
	        this.type = type;
	        this.branches = branches;
	        this.otherwise = otherwise;
	    }
	    static parse(args, context) {
	        if (args.length < 4)
	            return context.error(`Expected at least 3 arguments, but found only ${args.length - 1}.`);
	        if (args.length % 2 !== 0)
	            return context.error('Expected an odd number of arguments.');
	        let outputType;
	        if (context.expectedType && context.expectedType.kind !== 'value') {
	            outputType = context.expectedType;
	        }
	        const branches = [];
	        for (let i = 1; i < args.length - 1; i += 2) {
	            const test = context.parse(args[i], i, BooleanType);
	            if (!test)
	                return null;
	            const result = context.parse(args[i + 1], i + 1, outputType);
	            if (!result)
	                return null;
	            branches.push([test, result]);
	            outputType = outputType || result.type;
	        }
	        const otherwise = context.parse(args[args.length - 1], args.length - 1, outputType);
	        if (!otherwise)
	            return null;
	        if (!outputType)
	            throw new Error('Can\'t infer output type');
	        return new Case(outputType, branches, otherwise);
	    }
	    evaluate(ctx) {
	        for (const [test, expression] of this.branches) {
	            if (test.evaluate(ctx)) {
	                return expression.evaluate(ctx);
	            }
	        }
	        return this.otherwise.evaluate(ctx);
	    }
	    eachChild(fn) {
	        for (const [test, expression] of this.branches) {
	            fn(test);
	            fn(expression);
	        }
	        fn(this.otherwise);
	    }
	    outputDefined() {
	        return this.branches.every(([_, out]) => out.outputDefined()) && this.otherwise.outputDefined();
	    }
	}

	class Slice {
	    constructor(type, input, beginIndex, endIndex) {
	        this.type = type;
	        this.input = input;
	        this.beginIndex = beginIndex;
	        this.endIndex = endIndex;
	    }
	    static parse(args, context) {
	        if (args.length <= 2 || args.length >= 5) {
	            return context.error(`Expected 3 or 4 arguments, but found ${args.length - 1} instead.`);
	        }
	        const input = context.parse(args[1], 1, ValueType);
	        const beginIndex = context.parse(args[2], 2, NumberType);
	        if (!input || !beginIndex)
	            return null;
	        if (!isValidType(input.type, [array$1(ValueType), StringType, ValueType])) {
	            return context.error(`Expected first argument to be of type array or string, but found ${toString$1(input.type)} instead`);
	        }
	        if (args.length === 4) {
	            const endIndex = context.parse(args[3], 3, NumberType);
	            if (!endIndex)
	                return null;
	            return new Slice(input.type, input, beginIndex, endIndex);
	        }
	        else {
	            return new Slice(input.type, input, beginIndex);
	        }
	    }
	    evaluate(ctx) {
	        const input = this.input.evaluate(ctx);
	        const beginIndex = this.beginIndex.evaluate(ctx);
	        if (!isValidNativeType(input, ['string', 'array'])) {
	            throw new RuntimeError(`Expected first argument to be of type array or string, but found ${toString$1(typeOf(input))} instead.`);
	        }
	        if (this.endIndex) {
	            const endIndex = this.endIndex.evaluate(ctx);
	            return input.slice(beginIndex, endIndex);
	        }
	        return input.slice(beginIndex);
	    }
	    eachChild(fn) {
	        fn(this.input);
	        fn(this.beginIndex);
	        if (this.endIndex) {
	            fn(this.endIndex);
	        }
	    }
	    outputDefined() {
	        return false;
	    }
	}

	function isComparableType(op, type) {
	    if (op === '==' || op === '!=') {
	        // equality operator
	        return type.kind === 'boolean' ||
	            type.kind === 'string' ||
	            type.kind === 'number' ||
	            type.kind === 'null' ||
	            type.kind === 'value';
	    }
	    else {
	        // ordering operator
	        return type.kind === 'string' ||
	            type.kind === 'number' ||
	            type.kind === 'value';
	    }
	}
	function eq(ctx, a, b) { return a === b; }
	function neq(ctx, a, b) { return a !== b; }
	function lt(ctx, a, b) { return a < b; }
	function gt(ctx, a, b) { return a > b; }
	function lteq(ctx, a, b) { return a <= b; }
	function gteq(ctx, a, b) { return a >= b; }
	function eqCollate(ctx, a, b, c) { return c.compare(a, b) === 0; }
	function neqCollate(ctx, a, b, c) { return !eqCollate(ctx, a, b, c); }
	function ltCollate(ctx, a, b, c) { return c.compare(a, b) < 0; }
	function gtCollate(ctx, a, b, c) { return c.compare(a, b) > 0; }
	function lteqCollate(ctx, a, b, c) { return c.compare(a, b) <= 0; }
	function gteqCollate(ctx, a, b, c) { return c.compare(a, b) >= 0; }
	/**
	 * Special form for comparison operators, implementing the signatures:
	 * - (T, T, ?Collator) => boolean
	 * - (T, value, ?Collator) => boolean
	 * - (value, T, ?Collator) => boolean
	 *
	 * For inequalities, T must be either value, string, or number. For ==/!=, it
	 * can also be boolean or null.
	 *
	 * Equality semantics are equivalent to Javascript's strict equality (===/!==)
	 * -- i.e., when the arguments' types don't match, == evaluates to false, != to
	 * true.
	 *
	 * When types don't match in an ordering comparison, a runtime error is thrown.
	 *
	 * @private
	 */
	function makeComparison(op, compareBasic, compareWithCollator) {
	    const isOrderComparison = op !== '==' && op !== '!=';
	    return class Comparison {
	        constructor(lhs, rhs, collator) {
	            this.type = BooleanType;
	            this.lhs = lhs;
	            this.rhs = rhs;
	            this.collator = collator;
	            this.hasUntypedArgument = lhs.type.kind === 'value' || rhs.type.kind === 'value';
	        }
	        static parse(args, context) {
	            if (args.length !== 3 && args.length !== 4)
	                return context.error('Expected two or three arguments.');
	            const op = args[0];
	            let lhs = context.parse(args[1], 1, ValueType);
	            if (!lhs)
	                return null;
	            if (!isComparableType(op, lhs.type)) {
	                return context.concat(1).error(`"${op}" comparisons are not supported for type '${toString$1(lhs.type)}'.`);
	            }
	            let rhs = context.parse(args[2], 2, ValueType);
	            if (!rhs)
	                return null;
	            if (!isComparableType(op, rhs.type)) {
	                return context.concat(2).error(`"${op}" comparisons are not supported for type '${toString$1(rhs.type)}'.`);
	            }
	            if (lhs.type.kind !== rhs.type.kind &&
	                lhs.type.kind !== 'value' &&
	                rhs.type.kind !== 'value') {
	                return context.error(`Cannot compare types '${toString$1(lhs.type)}' and '${toString$1(rhs.type)}'.`);
	            }
	            if (isOrderComparison) {
	                // typing rules specific to less/greater than operators
	                if (lhs.type.kind === 'value' && rhs.type.kind !== 'value') {
	                    // (value, T)
	                    lhs = new Assertion(rhs.type, [lhs]);
	                }
	                else if (lhs.type.kind !== 'value' && rhs.type.kind === 'value') {
	                    // (T, value)
	                    rhs = new Assertion(lhs.type, [rhs]);
	                }
	            }
	            let collator = null;
	            if (args.length === 4) {
	                if (lhs.type.kind !== 'string' &&
	                    rhs.type.kind !== 'string' &&
	                    lhs.type.kind !== 'value' &&
	                    rhs.type.kind !== 'value') {
	                    return context.error('Cannot use collator to compare non-string types.');
	                }
	                collator = context.parse(args[3], 3, CollatorType);
	                if (!collator)
	                    return null;
	            }
	            return new Comparison(lhs, rhs, collator);
	        }
	        evaluate(ctx) {
	            const lhs = this.lhs.evaluate(ctx);
	            const rhs = this.rhs.evaluate(ctx);
	            if (isOrderComparison && this.hasUntypedArgument) {
	                const lt = typeOf(lhs);
	                const rt = typeOf(rhs);
	                // check that type is string or number, and equal
	                if (lt.kind !== rt.kind || !(lt.kind === 'string' || lt.kind === 'number')) {
	                    throw new RuntimeError(`Expected arguments for "${op}" to be (string, string) or (number, number), but found (${lt.kind}, ${rt.kind}) instead.`);
	                }
	            }
	            if (this.collator && !isOrderComparison && this.hasUntypedArgument) {
	                const lt = typeOf(lhs);
	                const rt = typeOf(rhs);
	                if (lt.kind !== 'string' || rt.kind !== 'string') {
	                    return compareBasic(ctx, lhs, rhs);
	                }
	            }
	            return this.collator ?
	                compareWithCollator(ctx, lhs, rhs, this.collator.evaluate(ctx)) :
	                compareBasic(ctx, lhs, rhs);
	        }
	        eachChild(fn) {
	            fn(this.lhs);
	            fn(this.rhs);
	            if (this.collator) {
	                fn(this.collator);
	            }
	        }
	        outputDefined() {
	            return true;
	        }
	    };
	}
	const Equals = makeComparison('==', eq, eqCollate);
	const NotEquals = makeComparison('!=', neq, neqCollate);
	const LessThan = makeComparison('<', lt, ltCollate);
	const GreaterThan = makeComparison('>', gt, gtCollate);
	const LessThanOrEqual = makeComparison('<=', lteq, lteqCollate);
	const GreaterThanOrEqual = makeComparison('>=', gteq, gteqCollate);

	class NumberFormat {
	    constructor(number, locale, currency, minFractionDigits, maxFractionDigits) {
	        this.type = StringType;
	        this.number = number;
	        this.locale = locale;
	        this.currency = currency;
	        this.minFractionDigits = minFractionDigits;
	        this.maxFractionDigits = maxFractionDigits;
	    }
	    static parse(args, context) {
	        if (args.length !== 3)
	            return context.error('Expected two arguments.');
	        const number = context.parse(args[1], 1, NumberType);
	        if (!number)
	            return null;
	        const options = args[2];
	        if (typeof options !== 'object' || Array.isArray(options))
	            return context.error('NumberFormat options argument must be an object.');
	        let locale = null;
	        if (options['locale']) {
	            locale = context.parse(options['locale'], 1, StringType);
	            if (!locale)
	                return null;
	        }
	        let currency = null;
	        if (options['currency']) {
	            currency = context.parse(options['currency'], 1, StringType);
	            if (!currency)
	                return null;
	        }
	        let minFractionDigits = null;
	        if (options['min-fraction-digits']) {
	            minFractionDigits = context.parse(options['min-fraction-digits'], 1, NumberType);
	            if (!minFractionDigits)
	                return null;
	        }
	        let maxFractionDigits = null;
	        if (options['max-fraction-digits']) {
	            maxFractionDigits = context.parse(options['max-fraction-digits'], 1, NumberType);
	            if (!maxFractionDigits)
	                return null;
	        }
	        return new NumberFormat(number, locale, currency, minFractionDigits, maxFractionDigits);
	    }
	    evaluate(ctx) {
	        return new Intl.NumberFormat(this.locale ? this.locale.evaluate(ctx) : [], {
	            style: this.currency ? 'currency' : 'decimal',
	            currency: this.currency ? this.currency.evaluate(ctx) : undefined,
	            minimumFractionDigits: this.minFractionDigits ? this.minFractionDigits.evaluate(ctx) : undefined,
	            maximumFractionDigits: this.maxFractionDigits ? this.maxFractionDigits.evaluate(ctx) : undefined,
	        }).format(this.number.evaluate(ctx));
	    }
	    eachChild(fn) {
	        fn(this.number);
	        if (this.locale) {
	            fn(this.locale);
	        }
	        if (this.currency) {
	            fn(this.currency);
	        }
	        if (this.minFractionDigits) {
	            fn(this.minFractionDigits);
	        }
	        if (this.maxFractionDigits) {
	            fn(this.maxFractionDigits);
	        }
	    }
	    outputDefined() {
	        return false;
	    }
	}

	class FormatExpression {
	    constructor(sections) {
	        this.type = FormattedType;
	        this.sections = sections;
	    }
	    static parse(args, context) {
	        if (args.length < 2) {
	            return context.error('Expected at least one argument.');
	        }
	        const firstArg = args[1];
	        if (!Array.isArray(firstArg) && typeof firstArg === 'object') {
	            return context.error('First argument must be an image or text section.');
	        }
	        const sections = [];
	        let nextTokenMayBeObject = false;
	        for (let i = 1; i <= args.length - 1; ++i) {
	            const arg = args[i];
	            if (nextTokenMayBeObject && typeof arg === 'object' && !Array.isArray(arg)) {
	                nextTokenMayBeObject = false;
	                let scale = null;
	                if (arg['font-scale']) {
	                    scale = context.parse(arg['font-scale'], 1, NumberType);
	                    if (!scale)
	                        return null;
	                }
	                let font = null;
	                if (arg['text-font']) {
	                    font = context.parse(arg['text-font'], 1, array$1(StringType));
	                    if (!font)
	                        return null;
	                }
	                let textColor = null;
	                if (arg['text-color']) {
	                    textColor = context.parse(arg['text-color'], 1, ColorType);
	                    if (!textColor)
	                        return null;
	                }
	                const lastExpression = sections[sections.length - 1];
	                lastExpression.scale = scale;
	                lastExpression.font = font;
	                lastExpression.textColor = textColor;
	            }
	            else {
	                const content = context.parse(args[i], 1, ValueType);
	                if (!content)
	                    return null;
	                const kind = content.type.kind;
	                if (kind !== 'string' && kind !== 'value' && kind !== 'null' && kind !== 'resolvedImage')
	                    return context.error('Formatted text type must be \'string\', \'value\', \'image\' or \'null\'.');
	                nextTokenMayBeObject = true;
	                sections.push({ content, scale: null, font: null, textColor: null });
	            }
	        }
	        return new FormatExpression(sections);
	    }
	    evaluate(ctx) {
	        const evaluateSection = section => {
	            const evaluatedContent = section.content.evaluate(ctx);
	            if (typeOf(evaluatedContent) === ResolvedImageType) {
	                return new FormattedSection('', evaluatedContent, null, null, null);
	            }
	            return new FormattedSection(toString(evaluatedContent), null, section.scale ? section.scale.evaluate(ctx) : null, section.font ? section.font.evaluate(ctx).join(',') : null, section.textColor ? section.textColor.evaluate(ctx) : null);
	        };
	        return new Formatted(this.sections.map(evaluateSection));
	    }
	    eachChild(fn) {
	        for (const section of this.sections) {
	            fn(section.content);
	            if (section.scale) {
	                fn(section.scale);
	            }
	            if (section.font) {
	                fn(section.font);
	            }
	            if (section.textColor) {
	                fn(section.textColor);
	            }
	        }
	    }
	    outputDefined() {
	        // Technically the combinatoric set of all children
	        // Usually, this.text will be undefined anyway
	        return false;
	    }
	}

	class ImageExpression {
	    constructor(input) {
	        this.type = ResolvedImageType;
	        this.input = input;
	    }
	    static parse(args, context) {
	        if (args.length !== 2) {
	            return context.error('Expected two arguments.');
	        }
	        const name = context.parse(args[1], 1, StringType);
	        if (!name)
	            return context.error('No image name provided.');
	        return new ImageExpression(name);
	    }
	    evaluate(ctx) {
	        const evaluatedImageName = this.input.evaluate(ctx);
	        const value = ResolvedImage.fromString(evaluatedImageName);
	        if (value && ctx.availableImages)
	            value.available = ctx.availableImages.indexOf(evaluatedImageName) > -1;
	        return value;
	    }
	    eachChild(fn) {
	        fn(this.input);
	    }
	    outputDefined() {
	        // The output of image is determined by the list of available images in the evaluation context
	        return false;
	    }
	}

	class Length {
	    constructor(input) {
	        this.type = NumberType;
	        this.input = input;
	    }
	    static parse(args, context) {
	        if (args.length !== 2)
	            return context.error(`Expected 1 argument, but found ${args.length - 1} instead.`);
	        const input = context.parse(args[1], 1);
	        if (!input)
	            return null;
	        if (input.type.kind !== 'array' && input.type.kind !== 'string' && input.type.kind !== 'value')
	            return context.error(`Expected argument of type string or array, but found ${toString$1(input.type)} instead.`);
	        return new Length(input);
	    }
	    evaluate(ctx) {
	        const input = this.input.evaluate(ctx);
	        if (typeof input === 'string') {
	            return input.length;
	        }
	        else if (Array.isArray(input)) {
	            return input.length;
	        }
	        else {
	            throw new RuntimeError(`Expected value to be of type string or array, but found ${toString$1(typeOf(input))} instead.`);
	        }
	    }
	    eachChild(fn) {
	        fn(this.input);
	    }
	    outputDefined() {
	        return false;
	    }
	}

	const expressions$1 = {
	    // special forms
	    '==': Equals,
	    '!=': NotEquals,
	    '>': GreaterThan,
	    '<': LessThan,
	    '>=': GreaterThanOrEqual,
	    '<=': LessThanOrEqual,
	    'array': Assertion,
	    'at': At,
	    'boolean': Assertion,
	    'case': Case,
	    'coalesce': Coalesce,
	    'collator': CollatorExpression,
	    'format': FormatExpression,
	    'image': ImageExpression,
	    'in': In,
	    'index-of': IndexOf,
	    'interpolate': Interpolate,
	    'interpolate-hcl': Interpolate,
	    'interpolate-lab': Interpolate,
	    'length': Length,
	    'let': Let,
	    'literal': Literal,
	    'match': Match,
	    'number': Assertion,
	    'number-format': NumberFormat,
	    'object': Assertion,
	    'slice': Slice,
	    'step': Step,
	    'string': Assertion,
	    'to-boolean': Coercion,
	    'to-color': Coercion,
	    'to-number': Coercion,
	    'to-string': Coercion,
	    'var': Var,
	    'within': Within
	};
	function rgba(ctx, [r, g, b, a]) {
	    r = r.evaluate(ctx);
	    g = g.evaluate(ctx);
	    b = b.evaluate(ctx);
	    const alpha = a ? a.evaluate(ctx) : 1;
	    const error = validateRGBA(r, g, b, alpha);
	    if (error)
	        throw new RuntimeError(error);
	    return new Color(r / 255, g / 255, b / 255, alpha, false);
	}
	function has(key, obj) {
	    return key in obj;
	}
	function get(key, obj) {
	    const v = obj[key];
	    return typeof v === 'undefined' ? null : v;
	}
	function binarySearch(v, a, i, j) {
	    while (i <= j) {
	        const m = (i + j) >> 1;
	        if (a[m] === v)
	            return true;
	        if (a[m] > v)
	            j = m - 1;
	        else
	            i = m + 1;
	    }
	    return false;
	}
	function varargs(type) {
	    return { type };
	}
	CompoundExpression.register(expressions$1, {
	    'error': [
	        ErrorType,
	        [StringType],
	        (ctx, [v]) => { throw new RuntimeError(v.evaluate(ctx)); }
	    ],
	    'typeof': [
	        StringType,
	        [ValueType],
	        (ctx, [v]) => toString$1(typeOf(v.evaluate(ctx)))
	    ],
	    'to-rgba': [
	        array$1(NumberType, 4),
	        [ColorType],
	        (ctx, [v]) => {
	            const [r, g, b, a] = v.evaluate(ctx).rgb;
	            return [r * 255, g * 255, b * 255, a];
	        },
	    ],
	    'rgb': [
	        ColorType,
	        [NumberType, NumberType, NumberType],
	        rgba
	    ],
	    'rgba': [
	        ColorType,
	        [NumberType, NumberType, NumberType, NumberType],
	        rgba
	    ],
	    'has': {
	        type: BooleanType,
	        overloads: [
	            [
	                [StringType],
	                (ctx, [key]) => has(key.evaluate(ctx), ctx.properties())
	            ], [
	                [StringType, ObjectType],
	                (ctx, [key, obj]) => has(key.evaluate(ctx), obj.evaluate(ctx))
	            ]
	        ]
	    },
	    'get': {
	        type: ValueType,
	        overloads: [
	            [
	                [StringType],
	                (ctx, [key]) => get(key.evaluate(ctx), ctx.properties())
	            ], [
	                [StringType, ObjectType],
	                (ctx, [key, obj]) => get(key.evaluate(ctx), obj.evaluate(ctx))
	            ]
	        ]
	    },
	    'feature-state': [
	        ValueType,
	        [StringType],
	        (ctx, [key]) => get(key.evaluate(ctx), ctx.featureState || {})
	    ],
	    'properties': [
	        ObjectType,
	        [],
	        (ctx) => ctx.properties()
	    ],
	    'geometry-type': [
	        StringType,
	        [],
	        (ctx) => ctx.geometryType()
	    ],
	    'id': [
	        ValueType,
	        [],
	        (ctx) => ctx.id()
	    ],
	    'zoom': [
	        NumberType,
	        [],
	        (ctx) => ctx.globals.zoom
	    ],
	    'heatmap-density': [
	        NumberType,
	        [],
	        (ctx) => ctx.globals.heatmapDensity || 0
	    ],
	    'line-progress': [
	        NumberType,
	        [],
	        (ctx) => ctx.globals.lineProgress || 0
	    ],
	    'accumulated': [
	        ValueType,
	        [],
	        (ctx) => ctx.globals.accumulated === undefined ? null : ctx.globals.accumulated
	    ],
	    '+': [
	        NumberType,
	        varargs(NumberType),
	        (ctx, args) => {
	            let result = 0;
	            for (const arg of args) {
	                result += arg.evaluate(ctx);
	            }
	            return result;
	        }
	    ],
	    '*': [
	        NumberType,
	        varargs(NumberType),
	        (ctx, args) => {
	            let result = 1;
	            for (const arg of args) {
	                result *= arg.evaluate(ctx);
	            }
	            return result;
	        }
	    ],
	    '-': {
	        type: NumberType,
	        overloads: [
	            [
	                [NumberType, NumberType],
	                (ctx, [a, b]) => a.evaluate(ctx) - b.evaluate(ctx)
	            ], [
	                [NumberType],
	                (ctx, [a]) => -a.evaluate(ctx)
	            ]
	        ]
	    },
	    '/': [
	        NumberType,
	        [NumberType, NumberType],
	        (ctx, [a, b]) => a.evaluate(ctx) / b.evaluate(ctx)
	    ],
	    '%': [
	        NumberType,
	        [NumberType, NumberType],
	        (ctx, [a, b]) => a.evaluate(ctx) % b.evaluate(ctx)
	    ],
	    'ln2': [
	        NumberType,
	        [],
	        () => Math.LN2
	    ],
	    'pi': [
	        NumberType,
	        [],
	        () => Math.PI
	    ],
	    'e': [
	        NumberType,
	        [],
	        () => Math.E
	    ],
	    '^': [
	        NumberType,
	        [NumberType, NumberType],
	        (ctx, [b, e]) => Math.pow(b.evaluate(ctx), e.evaluate(ctx))
	    ],
	    'sqrt': [
	        NumberType,
	        [NumberType],
	        (ctx, [x]) => Math.sqrt(x.evaluate(ctx))
	    ],
	    'log10': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.log(n.evaluate(ctx)) / Math.LN10
	    ],
	    'ln': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.log(n.evaluate(ctx))
	    ],
	    'log2': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.log(n.evaluate(ctx)) / Math.LN2
	    ],
	    'sin': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.sin(n.evaluate(ctx))
	    ],
	    'cos': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.cos(n.evaluate(ctx))
	    ],
	    'tan': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.tan(n.evaluate(ctx))
	    ],
	    'asin': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.asin(n.evaluate(ctx))
	    ],
	    'acos': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.acos(n.evaluate(ctx))
	    ],
	    'atan': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.atan(n.evaluate(ctx))
	    ],
	    'min': [
	        NumberType,
	        varargs(NumberType),
	        (ctx, args) => Math.min(...args.map(arg => arg.evaluate(ctx)))
	    ],
	    'max': [
	        NumberType,
	        varargs(NumberType),
	        (ctx, args) => Math.max(...args.map(arg => arg.evaluate(ctx)))
	    ],
	    'abs': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.abs(n.evaluate(ctx))
	    ],
	    'round': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => {
	            const v = n.evaluate(ctx);
	            // Javascript's Math.round() rounds towards +Infinity for halfway
	            // values, even when they're negative. It's more common to round
	            // away from 0 (e.g., this is what python and C++ do)
	            return v < 0 ? -Math.round(-v) : Math.round(v);
	        }
	    ],
	    'floor': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.floor(n.evaluate(ctx))
	    ],
	    'ceil': [
	        NumberType,
	        [NumberType],
	        (ctx, [n]) => Math.ceil(n.evaluate(ctx))
	    ],
	    'filter-==': [
	        BooleanType,
	        [StringType, ValueType],
	        (ctx, [k, v]) => ctx.properties()[k.value] === v.value
	    ],
	    'filter-id-==': [
	        BooleanType,
	        [ValueType],
	        (ctx, [v]) => ctx.id() === v.value
	    ],
	    'filter-type-==': [
	        BooleanType,
	        [StringType],
	        (ctx, [v]) => ctx.geometryType() === v.value
	    ],
	    'filter-<': [
	        BooleanType,
	        [StringType, ValueType],
	        (ctx, [k, v]) => {
	            const a = ctx.properties()[k.value];
	            const b = v.value;
	            return typeof a === typeof b && a < b;
	        }
	    ],
	    'filter-id-<': [
	        BooleanType,
	        [ValueType],
	        (ctx, [v]) => {
	            const a = ctx.id();
	            const b = v.value;
	            return typeof a === typeof b && a < b;
	        }
	    ],
	    'filter->': [
	        BooleanType,
	        [StringType, ValueType],
	        (ctx, [k, v]) => {
	            const a = ctx.properties()[k.value];
	            const b = v.value;
	            return typeof a === typeof b && a > b;
	        }
	    ],
	    'filter-id->': [
	        BooleanType,
	        [ValueType],
	        (ctx, [v]) => {
	            const a = ctx.id();
	            const b = v.value;
	            return typeof a === typeof b && a > b;
	        }
	    ],
	    'filter-<=': [
	        BooleanType,
	        [StringType, ValueType],
	        (ctx, [k, v]) => {
	            const a = ctx.properties()[k.value];
	            const b = v.value;
	            return typeof a === typeof b && a <= b;
	        }
	    ],
	    'filter-id-<=': [
	        BooleanType,
	        [ValueType],
	        (ctx, [v]) => {
	            const a = ctx.id();
	            const b = v.value;
	            return typeof a === typeof b && a <= b;
	        }
	    ],
	    'filter->=': [
	        BooleanType,
	        [StringType, ValueType],
	        (ctx, [k, v]) => {
	            const a = ctx.properties()[k.value];
	            const b = v.value;
	            return typeof a === typeof b && a >= b;
	        }
	    ],
	    'filter-id->=': [
	        BooleanType,
	        [ValueType],
	        (ctx, [v]) => {
	            const a = ctx.id();
	            const b = v.value;
	            return typeof a === typeof b && a >= b;
	        }
	    ],
	    'filter-has': [
	        BooleanType,
	        [ValueType],
	        (ctx, [k]) => k.value in ctx.properties()
	    ],
	    'filter-has-id': [
	        BooleanType,
	        [],
	        (ctx) => (ctx.id() !== null && ctx.id() !== undefined)
	    ],
	    'filter-type-in': [
	        BooleanType,
	        [array$1(StringType)],
	        (ctx, [v]) => v.value.indexOf(ctx.geometryType()) >= 0
	    ],
	    'filter-id-in': [
	        BooleanType,
	        [array$1(ValueType)],
	        (ctx, [v]) => v.value.indexOf(ctx.id()) >= 0
	    ],
	    'filter-in-small': [
	        BooleanType,
	        [StringType, array$1(ValueType)],
	        // assumes v is an array literal
	        (ctx, [k, v]) => v.value.indexOf(ctx.properties()[k.value]) >= 0
	    ],
	    'filter-in-large': [
	        BooleanType,
	        [StringType, array$1(ValueType)],
	        // assumes v is a array literal with values sorted in ascending order and of a single type
	        (ctx, [k, v]) => binarySearch(ctx.properties()[k.value], v.value, 0, v.value.length - 1)
	    ],
	    'all': {
	        type: BooleanType,
	        overloads: [
	            [
	                [BooleanType, BooleanType],
	                (ctx, [a, b]) => a.evaluate(ctx) && b.evaluate(ctx)
	            ],
	            [
	                varargs(BooleanType),
	                (ctx, args) => {
	                    for (const arg of args) {
	                        if (!arg.evaluate(ctx))
	                            return false;
	                    }
	                    return true;
	                }
	            ]
	        ]
	    },
	    'any': {
	        type: BooleanType,
	        overloads: [
	            [
	                [BooleanType, BooleanType],
	                (ctx, [a, b]) => a.evaluate(ctx) || b.evaluate(ctx)
	            ],
	            [
	                varargs(BooleanType),
	                (ctx, args) => {
	                    for (const arg of args) {
	                        if (arg.evaluate(ctx))
	                            return true;
	                    }
	                    return false;
	                }
	            ]
	        ]
	    },
	    '!': [
	        BooleanType,
	        [BooleanType],
	        (ctx, [b]) => !b.evaluate(ctx)
	    ],
	    'is-supported-script': [
	        BooleanType,
	        [StringType],
	        // At parse time this will always return true, so we need to exclude this expression with isGlobalPropertyConstant
	        (ctx, [s]) => {
	            const isSupportedScript = ctx.globals && ctx.globals.isSupportedScript;
	            if (isSupportedScript) {
	                return isSupportedScript(s.evaluate(ctx));
	            }
	            return true;
	        }
	    ],
	    'upcase': [
	        StringType,
	        [StringType],
	        (ctx, [s]) => s.evaluate(ctx).toUpperCase()
	    ],
	    'downcase': [
	        StringType,
	        [StringType],
	        (ctx, [s]) => s.evaluate(ctx).toLowerCase()
	    ],
	    'concat': [
	        StringType,
	        varargs(ValueType),
	        (ctx, args) => args.map(arg => toString(arg.evaluate(ctx))).join('')
	    ],
	    'resolved-locale': [
	        StringType,
	        [CollatorType],
	        (ctx, [collator]) => collator.evaluate(ctx).resolvedLocale()
	    ]
	});

	function success(value) {
	    return { result: 'success', value };
	}
	function error(value) {
	    return { result: 'error', value };
	}

	function supportsPropertyExpression(spec) {
	    return spec['property-type'] === 'data-driven' || spec['property-type'] === 'cross-faded-data-driven';
	}
	function supportsZoomExpression(spec) {
	    return !!spec.expression && spec.expression.parameters.indexOf('zoom') > -1;
	}
	function supportsInterpolation(spec) {
	    return !!spec.expression && spec.expression.interpolated;
	}

	function getType(val) {
	    if (val instanceof Number) {
	        return 'number';
	    }
	    else if (val instanceof String) {
	        return 'string';
	    }
	    else if (val instanceof Boolean) {
	        return 'boolean';
	    }
	    else if (Array.isArray(val)) {
	        return 'array';
	    }
	    else if (val === null) {
	        return 'null';
	    }
	    else {
	        return typeof val;
	    }
	}

	function isFunction$1(value) {
	    return typeof value === 'object' && value !== null && !Array.isArray(value);
	}
	function identityFunction(x) {
	    return x;
	}
	function createFunction(parameters, propertySpec) {
	    const isColor = propertySpec.type === 'color';
	    const zoomAndFeatureDependent = parameters.stops && typeof parameters.stops[0][0] === 'object';
	    const featureDependent = zoomAndFeatureDependent || parameters.property !== undefined;
	    const zoomDependent = zoomAndFeatureDependent || !featureDependent;
	    const type = parameters.type || (supportsInterpolation(propertySpec) ? 'exponential' : 'interval');
	    if (isColor || propertySpec.type === 'padding') {
	        const parseFn = isColor ? Color.parse : Padding.parse;
	        parameters = extendBy({}, parameters);
	        if (parameters.stops) {
	            parameters.stops = parameters.stops.map((stop) => {
	                return [stop[0], parseFn(stop[1])];
	            });
	        }
	        if (parameters.default) {
	            parameters.default = parseFn(parameters.default);
	        }
	        else {
	            parameters.default = parseFn(propertySpec.default);
	        }
	    }
	    if (parameters.colorSpace && !isSupportedInterpolationColorSpace(parameters.colorSpace)) {
	        throw new Error(`Unknown color space: "${parameters.colorSpace}"`);
	    }
	    let innerFun;
	    let hashedStops;
	    let categoricalKeyType;
	    if (type === 'exponential') {
	        innerFun = evaluateExponentialFunction;
	    }
	    else if (type === 'interval') {
	        innerFun = evaluateIntervalFunction;
	    }
	    else if (type === 'categorical') {
	        innerFun = evaluateCategoricalFunction;
	        // For categorical functions, generate an Object as a hashmap of the stops for fast searching
	        hashedStops = Object.create(null);
	        for (const stop of parameters.stops) {
	            hashedStops[stop[0]] = stop[1];
	        }
	        // Infer key type based on first stop key-- used to encforce strict type checking later
	        categoricalKeyType = typeof parameters.stops[0][0];
	    }
	    else if (type === 'identity') {
	        innerFun = evaluateIdentityFunction;
	    }
	    else {
	        throw new Error(`Unknown function type "${type}"`);
	    }
	    if (zoomAndFeatureDependent) {
	        const featureFunctions = {};
	        const zoomStops = [];
	        for (let s = 0; s < parameters.stops.length; s++) {
	            const stop = parameters.stops[s];
	            const zoom = stop[0].zoom;
	            if (featureFunctions[zoom] === undefined) {
	                featureFunctions[zoom] = {
	                    zoom,
	                    type: parameters.type,
	                    property: parameters.property,
	                    default: parameters.default,
	                    stops: []
	                };
	                zoomStops.push(zoom);
	            }
	            featureFunctions[zoom].stops.push([stop[0].value, stop[1]]);
	        }
	        const featureFunctionStops = [];
	        for (const z of zoomStops) {
	            featureFunctionStops.push([featureFunctions[z].zoom, createFunction(featureFunctions[z], propertySpec)]);
	        }
	        const interpolationType = { name: 'linear' };
	        return {
	            kind: 'composite',
	            interpolationType,
	            interpolationFactor: Interpolate.interpolationFactor.bind(undefined, interpolationType),
	            zoomStops: featureFunctionStops.map(s => s[0]),
	            evaluate({ zoom }, properties) {
	                return evaluateExponentialFunction({
	                    stops: featureFunctionStops,
	                    base: parameters.base
	                }, propertySpec, zoom).evaluate(zoom, properties);
	            }
	        };
	    }
	    else if (zoomDependent) {
	        const interpolationType = type === 'exponential' ?
	            { name: 'exponential', base: parameters.base !== undefined ? parameters.base : 1 } : null;
	        return {
	            kind: 'camera',
	            interpolationType,
	            interpolationFactor: Interpolate.interpolationFactor.bind(undefined, interpolationType),
	            zoomStops: parameters.stops.map(s => s[0]),
	            evaluate: ({ zoom }) => innerFun(parameters, propertySpec, zoom, hashedStops, categoricalKeyType)
	        };
	    }
	    else {
	        return {
	            kind: 'source',
	            evaluate(_, feature) {
	                const value = feature && feature.properties ? feature.properties[parameters.property] : undefined;
	                if (value === undefined) {
	                    return coalesce$1(parameters.default, propertySpec.default);
	                }
	                return innerFun(parameters, propertySpec, value, hashedStops, categoricalKeyType);
	            }
	        };
	    }
	}
	function coalesce$1(a, b, c) {
	    if (a !== undefined)
	        return a;
	    if (b !== undefined)
	        return b;
	    if (c !== undefined)
	        return c;
	}
	function evaluateCategoricalFunction(parameters, propertySpec, input, hashedStops, keyType) {
	    const evaluated = typeof input === keyType ? hashedStops[input] : undefined; // Enforce strict typing on input
	    return coalesce$1(evaluated, parameters.default, propertySpec.default);
	}
	function evaluateIntervalFunction(parameters, propertySpec, input) {
	    // Edge cases
	    if (getType(input) !== 'number')
	        return coalesce$1(parameters.default, propertySpec.default);
	    const n = parameters.stops.length;
	    if (n === 1)
	        return parameters.stops[0][1];
	    if (input <= parameters.stops[0][0])
	        return parameters.stops[0][1];
	    if (input >= parameters.stops[n - 1][0])
	        return parameters.stops[n - 1][1];
	    const index = findStopLessThanOrEqualTo(parameters.stops.map((stop) => stop[0]), input);
	    return parameters.stops[index][1];
	}
	function evaluateExponentialFunction(parameters, propertySpec, input) {
	    const base = parameters.base !== undefined ? parameters.base : 1;
	    // Edge cases
	    if (getType(input) !== 'number')
	        return coalesce$1(parameters.default, propertySpec.default);
	    const n = parameters.stops.length;
	    if (n === 1)
	        return parameters.stops[0][1];
	    if (input <= parameters.stops[0][0])
	        return parameters.stops[0][1];
	    if (input >= parameters.stops[n - 1][0])
	        return parameters.stops[n - 1][1];
	    const index = findStopLessThanOrEqualTo(parameters.stops.map((stop) => stop[0]), input);
	    const t = interpolationFactor(input, base, parameters.stops[index][0], parameters.stops[index + 1][0]);
	    const outputLower = parameters.stops[index][1];
	    const outputUpper = parameters.stops[index + 1][1];
	    const interp = interpolate[propertySpec.type] || identityFunction;
	    if (typeof outputLower.evaluate === 'function') {
	        return {
	            evaluate(...args) {
	                const evaluatedLower = outputLower.evaluate.apply(undefined, args);
	                const evaluatedUpper = outputUpper.evaluate.apply(undefined, args);
	                // Special case for fill-outline-color, which has no spec default.
	                if (evaluatedLower === undefined || evaluatedUpper === undefined) {
	                    return undefined;
	                }
	                return interp(evaluatedLower, evaluatedUpper, t, parameters.colorSpace);
	            }
	        };
	    }
	    return interp(outputLower, outputUpper, t, parameters.colorSpace);
	}
	function evaluateIdentityFunction(parameters, propertySpec, input) {
	    switch (propertySpec.type) {
	        case 'color':
	            input = Color.parse(input);
	            break;
	        case 'formatted':
	            input = Formatted.fromString(input.toString());
	            break;
	        case 'resolvedImage':
	            input = ResolvedImage.fromString(input.toString());
	            break;
	        case 'padding':
	            input = Padding.parse(input);
	            break;
	        default:
	            if (getType(input) !== propertySpec.type && (propertySpec.type !== 'enum' || !propertySpec.values[input])) {
	                input = undefined;
	            }
	    }
	    return coalesce$1(input, parameters.default, propertySpec.default);
	}
	/**
	 * Returns a ratio that can be used to interpolate between exponential function
	 * stops.
	 *
	 * How it works:
	 * Two consecutive stop values define a (scaled and shifted) exponential
	 * function `f(x) = a * base^x + b`, where `base` is the user-specified base,
	 * and `a` and `b` are constants affording sufficient degrees of freedom to fit
	 * the function to the given stops.
	 *
	 * Here's a bit of algebra that lets us compute `f(x)` directly from the stop
	 * values without explicitly solving for `a` and `b`:
	 *
	 * First stop value: `f(x0) = y0 = a * base^x0 + b`
	 * Second stop value: `f(x1) = y1 = a * base^x1 + b`
	 * => `y1 - y0 = a(base^x1 - base^x0)`
	 * => `a = (y1 - y0)/(base^x1 - base^x0)`
	 *
	 * Desired value: `f(x) = y = a * base^x + b`
	 * => `f(x) = y0 + a * (base^x - base^x0)`
	 *
	 * From the above, we can replace the `a` in `a * (base^x - base^x0)` and do a
	 * little algebra:
	 * ```
	 * a * (base^x - base^x0) = (y1 - y0)/(base^x1 - base^x0) * (base^x - base^x0)
	 *                     = (y1 - y0) * (base^x - base^x0) / (base^x1 - base^x0)
	 * ```
	 *
	 * If we let `(base^x - base^x0) / (base^x1 base^x0)`, then we have
	 * `f(x) = y0 + (y1 - y0) * ratio`.  In other words, `ratio` may be treated as
	 * an interpolation factor between the two stops' output values.
	 *
	 * (Note: a slightly different form for `ratio`,
	 * `(base^(x-x0) - 1) / (base^(x1-x0) - 1) `, is equivalent, but requires fewer
	 * expensive `Math.pow()` operations.)
	 *
	 * @private
	 */
	function interpolationFactor(input, base, lowerValue, upperValue) {
	    const difference = upperValue - lowerValue;
	    const progress = input - lowerValue;
	    if (difference === 0) {
	        return 0;
	    }
	    else if (base === 1) {
	        return progress / difference;
	    }
	    else {
	        return (Math.pow(base, progress) - 1) / (Math.pow(base, difference) - 1);
	    }
	}

	class StyleExpression {
	    constructor(expression, propertySpec) {
	        this.expression = expression;
	        this._warningHistory = {};
	        this._evaluator = new EvaluationContext();
	        this._defaultValue = propertySpec ? getDefaultValue(propertySpec) : null;
	        this._enumValues = propertySpec && propertySpec.type === 'enum' ? propertySpec.values : null;
	    }
	    evaluateWithoutErrorHandling(globals, feature, featureState, canonical, availableImages, formattedSection) {
	        this._evaluator.globals = globals;
	        this._evaluator.feature = feature;
	        this._evaluator.featureState = featureState;
	        this._evaluator.canonical = canonical;
	        this._evaluator.availableImages = availableImages || null;
	        this._evaluator.formattedSection = formattedSection;
	        return this.expression.evaluate(this._evaluator);
	    }
	    evaluate(globals, feature, featureState, canonical, availableImages, formattedSection) {
	        this._evaluator.globals = globals;
	        this._evaluator.feature = feature || null;
	        this._evaluator.featureState = featureState || null;
	        this._evaluator.canonical = canonical;
	        this._evaluator.availableImages = availableImages || null;
	        this._evaluator.formattedSection = formattedSection || null;
	        try {
	            const val = this.expression.evaluate(this._evaluator);
	            // eslint-disable-next-line no-self-compare
	            if (val === null || val === undefined || (typeof val === 'number' && val !== val)) {
	                return this._defaultValue;
	            }
	            if (this._enumValues && !(val in this._enumValues)) {
	                throw new RuntimeError(`Expected value to be one of ${Object.keys(this._enumValues).map(v => JSON.stringify(v)).join(', ')}, but found ${JSON.stringify(val)} instead.`);
	            }
	            return val;
	        }
	        catch (e) {
	            if (!this._warningHistory[e.message]) {
	                this._warningHistory[e.message] = true;
	                if (typeof console !== 'undefined') {
	                    console.warn(e.message);
	                }
	            }
	            return this._defaultValue;
	        }
	    }
	}
	function isExpression(expression) {
	    return Array.isArray(expression) && expression.length > 0 &&
	        typeof expression[0] === 'string' && expression[0] in expressions$1;
	}
	/**
	 * Parse and typecheck the given style spec JSON expression.  If
	 * options.defaultValue is provided, then the resulting StyleExpression's
	 * `evaluate()` method will handle errors by logging a warning (once per
	 * message) and returning the default value.  Otherwise, it will throw
	 * evaluation errors.
	 *
	 * @private
	 */
	function createExpression(expression, propertySpec) {
	    const parser = new ParsingContext(expressions$1, isExpressionConstant, [], propertySpec ? getExpectedType(propertySpec) : undefined);
	    // For string-valued properties, coerce to string at the top level rather than asserting.
	    const parsed = parser.parse(expression, undefined, undefined, undefined, propertySpec && propertySpec.type === 'string' ? { typeAnnotation: 'coerce' } : undefined);
	    if (!parsed) {
	        return error(parser.errors);
	    }
	    return success(new StyleExpression(parsed, propertySpec));
	}
	class ZoomConstantExpression {
	    constructor(kind, expression) {
	        this.kind = kind;
	        this._styleExpression = expression;
	        this.isStateDependent = kind !== 'constant' && !isStateConstant(expression.expression);
	    }
	    evaluateWithoutErrorHandling(globals, feature, featureState, canonical, availableImages, formattedSection) {
	        return this._styleExpression.evaluateWithoutErrorHandling(globals, feature, featureState, canonical, availableImages, formattedSection);
	    }
	    evaluate(globals, feature, featureState, canonical, availableImages, formattedSection) {
	        return this._styleExpression.evaluate(globals, feature, featureState, canonical, availableImages, formattedSection);
	    }
	}
	class ZoomDependentExpression {
	    constructor(kind, expression, zoomStops, interpolationType) {
	        this.kind = kind;
	        this.zoomStops = zoomStops;
	        this._styleExpression = expression;
	        this.isStateDependent = kind !== 'camera' && !isStateConstant(expression.expression);
	        this.interpolationType = interpolationType;
	    }
	    evaluateWithoutErrorHandling(globals, feature, featureState, canonical, availableImages, formattedSection) {
	        return this._styleExpression.evaluateWithoutErrorHandling(globals, feature, featureState, canonical, availableImages, formattedSection);
	    }
	    evaluate(globals, feature, featureState, canonical, availableImages, formattedSection) {
	        return this._styleExpression.evaluate(globals, feature, featureState, canonical, availableImages, formattedSection);
	    }
	    interpolationFactor(input, lower, upper) {
	        if (this.interpolationType) {
	            return Interpolate.interpolationFactor(this.interpolationType, input, lower, upper);
	        }
	        else {
	            return 0;
	        }
	    }
	}
	function isZoomExpression(expression) {
	    return expression._styleExpression !== undefined;
	}
	function createPropertyExpression(expressionInput, propertySpec) {
	    const expression = createExpression(expressionInput, propertySpec);
	    if (expression.result === 'error') {
	        return expression;
	    }
	    const parsed = expression.value.expression;
	    const isFeatureConstantResult = isFeatureConstant(parsed);
	    if (!isFeatureConstantResult && !supportsPropertyExpression(propertySpec)) {
	        return error([new ExpressionParsingError('', 'data expressions not supported')]);
	    }
	    const isZoomConstant = isGlobalPropertyConstant(parsed, ['zoom']);
	    if (!isZoomConstant && !supportsZoomExpression(propertySpec)) {
	        return error([new ExpressionParsingError('', 'zoom expressions not supported')]);
	    }
	    const zoomCurve = findZoomCurve(parsed);
	    if (!zoomCurve && !isZoomConstant) {
	        return error([new ExpressionParsingError('', '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.')]);
	    }
	    else if (zoomCurve instanceof ExpressionParsingError) {
	        return error([zoomCurve]);
	    }
	    else if (zoomCurve instanceof Interpolate && !supportsInterpolation(propertySpec)) {
	        return error([new ExpressionParsingError('', '"interpolate" expressions cannot be used with this property')]);
	    }
	    if (!zoomCurve) {
	        return success(isFeatureConstantResult ?
	            new ZoomConstantExpression('constant', expression.value) :
	            new ZoomConstantExpression('source', expression.value));
	    }
	    const interpolationType = zoomCurve instanceof Interpolate ? zoomCurve.interpolation : undefined;
	    return success(isFeatureConstantResult ?
	        new ZoomDependentExpression('camera', expression.value, zoomCurve.labels, interpolationType) :
	        new ZoomDependentExpression('composite', expression.value, zoomCurve.labels, interpolationType));
	}
	// serialization wrapper for old-style stop functions normalized to the
	// expression interface
	class StylePropertyFunction {
	    constructor(parameters, specification) {
	        this._parameters = parameters;
	        this._specification = specification;
	        extendBy(this, createFunction(this._parameters, this._specification));
	    }
	    static deserialize(serialized) {
	        return new StylePropertyFunction(serialized._parameters, serialized._specification);
	    }
	    static serialize(input) {
	        return {
	            _parameters: input._parameters,
	            _specification: input._specification
	        };
	    }
	}
	function normalizePropertyExpression(value, specification) {
	    if (isFunction$1(value)) {
	        return new StylePropertyFunction(value, specification);
	    }
	    else if (isExpression(value)) {
	        const expression = createPropertyExpression(value, specification);
	        if (expression.result === 'error') {
	            // this should have been caught in validation
	            throw new Error(expression.value.map(err => `${err.key}: ${err.message}`).join(', '));
	        }
	        return expression.value;
	    }
	    else {
	        let constant = value;
	        if (specification.type === 'color' && typeof value === 'string') {
	            constant = Color.parse(value);
	        }
	        else if (specification.type === 'padding' && (typeof value === 'number' || Array.isArray(value))) {
	            constant = Padding.parse(value);
	        }
	        else if (specification.type === 'variableAnchorOffsetCollection' && Array.isArray(value)) {
	            constant = VariableAnchorOffsetCollection.parse(value);
	        }
	        return {
	            kind: 'constant',
	            evaluate: () => constant
	        };
	    }
	}
	// Zoom-dependent expressions may only use ["zoom"] as the input to a top-level "step" or "interpolate"
	// expression (collectively referred to as a "curve"). The curve may be wrapped in one or more "let" or
	// "coalesce" expressions.
	function findZoomCurve(expression) {
	    let result = null;
	    if (expression instanceof Let) {
	        result = findZoomCurve(expression.result);
	    }
	    else if (expression instanceof Coalesce) {
	        for (const arg of expression.args) {
	            result = findZoomCurve(arg);
	            if (result) {
	                break;
	            }
	        }
	    }
	    else if ((expression instanceof Step || expression instanceof Interpolate) &&
	        expression.input instanceof CompoundExpression &&
	        expression.input.name === 'zoom') {
	        result = expression;
	    }
	    if (result instanceof ExpressionParsingError) {
	        return result;
	    }
	    expression.eachChild((child) => {
	        const childResult = findZoomCurve(child);
	        if (childResult instanceof ExpressionParsingError) {
	            result = childResult;
	        }
	        else if (!result && childResult) {
	            result = new ExpressionParsingError('', '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.');
	        }
	        else if (result && childResult && result !== childResult) {
	            result = new ExpressionParsingError('', 'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.');
	        }
	    });
	    return result;
	}
	function getExpectedType(spec) {
	    const types = {
	        color: ColorType,
	        string: StringType,
	        number: NumberType,
	        enum: StringType,
	        boolean: BooleanType,
	        formatted: FormattedType,
	        padding: PaddingType,
	        resolvedImage: ResolvedImageType,
	        variableAnchorOffsetCollection: VariableAnchorOffsetCollectionType
	    };
	    if (spec.type === 'array') {
	        return array$1(types[spec.value] || ValueType, spec.length);
	    }
	    return types[spec.type];
	}
	function getDefaultValue(spec) {
	    if (spec.type === 'color' && isFunction$1(spec.default)) {
	        // Special case for heatmap-color: it uses the 'default:' to define a
	        // default color ramp, but createExpression expects a simple value to fall
	        // back to in case of runtime errors
	        return new Color(0, 0, 0, 0);
	    }
	    else if (spec.type === 'color') {
	        return Color.parse(spec.default) || null;
	    }
	    else if (spec.type === 'padding') {
	        return Padding.parse(spec.default) || null;
	    }
	    else if (spec.type === 'variableAnchorOffsetCollection') {
	        return VariableAnchorOffsetCollection.parse(spec.default) || null;
	    }
	    else if (spec.default === undefined) {
	        return null;
	    }
	    else {
	        return spec.default;
	    }
	}

	function isExpressionFilter(filter) {
	    if (filter === true || filter === false) {
	        return true;
	    }
	    if (!Array.isArray(filter) || filter.length === 0) {
	        return false;
	    }
	    switch (filter[0]) {
	        case 'has':
	            return filter.length >= 2 && filter[1] !== '$id' && filter[1] !== '$type';
	        case 'in':
	            return filter.length >= 3 && (typeof filter[1] !== 'string' || Array.isArray(filter[2]));
	        case '!in':
	        case '!has':
	        case 'none':
	            return false;
	        case '==':
	        case '!=':
	        case '>':
	        case '>=':
	        case '<':
	        case '<=':
	            return filter.length !== 3 || (Array.isArray(filter[1]) || Array.isArray(filter[2]));
	        case 'any':
	        case 'all':
	            for (const f of filter.slice(1)) {
	                if (!isExpressionFilter(f) && typeof f !== 'boolean') {
	                    return false;
	                }
	            }
	            return true;
	        default:
	            return true;
	    }
	}
	const filterSpec = {
	    'type': 'boolean',
	    'default': false,
	    'transition': false,
	    'property-type': 'data-driven',
	    'expression': {
	        'interpolated': false,
	        'parameters': ['zoom', 'feature']
	    }
	};
	/**
	 * Given a filter expressed as nested arrays, return a new function
	 * that evaluates whether a given feature (with a .properties or .tags property)
	 * passes its test.
	 *
	 * @private
	 * @param {Array} filter MapLibre filter
	 * @returns {Function} filter-evaluating function
	 */
	function createFilter(filter) {
	    if (filter === null || filter === undefined) {
	        return { filter: () => true, needGeometry: false };
	    }
	    if (!isExpressionFilter(filter)) {
	        filter = convertFilter$1(filter);
	    }
	    const compiled = createExpression(filter, filterSpec);
	    if (compiled.result === 'error') {
	        throw new Error(compiled.value.map(err => `${err.key}: ${err.message}`).join(', '));
	    }
	    else {
	        const needGeometry = geometryNeeded(filter);
	        return { filter: (globalProperties, feature, canonical) => compiled.value.evaluate(globalProperties, feature, {}, canonical),
	            needGeometry };
	    }
	}
	// Comparison function to sort numbers and strings
	function compare(a, b) {
	    return a < b ? -1 : a > b ? 1 : 0;
	}
	function geometryNeeded(filter) {
	    if (!Array.isArray(filter))
	        return false;
	    if (filter[0] === 'within')
	        return true;
	    for (let index = 1; index < filter.length; index++) {
	        if (geometryNeeded(filter[index]))
	            return true;
	    }
	    return false;
	}
	function convertFilter$1(filter) {
	    if (!filter)
	        return true;
	    const op = filter[0];
	    if (filter.length <= 1)
	        return (op !== 'any');
	    const converted = op === '==' ? convertComparisonOp$1(filter[1], filter[2], '==') :
	        op === '!=' ? convertNegation(convertComparisonOp$1(filter[1], filter[2], '==')) :
	            op === '<' ||
	                op === '>' ||
	                op === '<=' ||
	                op === '>=' ? convertComparisonOp$1(filter[1], filter[2], op) :
	                op === 'any' ? convertDisjunctionOp(filter.slice(1)) :
	                    op === 'all' ? ['all'].concat(filter.slice(1).map(convertFilter$1)) :
	                        op === 'none' ? ['all'].concat(filter.slice(1).map(convertFilter$1).map(convertNegation)) :
	                            op === 'in' ? convertInOp$1(filter[1], filter.slice(2)) :
	                                op === '!in' ? convertNegation(convertInOp$1(filter[1], filter.slice(2))) :
	                                    op === 'has' ? convertHasOp$1(filter[1]) :
	                                        op === '!has' ? convertNegation(convertHasOp$1(filter[1])) :
	                                            op === 'within' ? filter :
	                                                true;
	    return converted;
	}
	function convertComparisonOp$1(property, value, op) {
	    switch (property) {
	        case '$type':
	            return [`filter-type-${op}`, value];
	        case '$id':
	            return [`filter-id-${op}`, value];
	        default:
	            return [`filter-${op}`, property, value];
	    }
	}
	function convertDisjunctionOp(filters) {
	    return ['any'].concat(filters.map(convertFilter$1));
	}
	function convertInOp$1(property, values) {
	    if (values.length === 0) {
	        return false;
	    }
	    switch (property) {
	        case '$type':
	            return ['filter-type-in', ['literal', values]];
	        case '$id':
	            return ['filter-id-in', ['literal', values]];
	        default:
	            if (values.length > 200 && !values.some(v => typeof v !== typeof values[0])) {
	                return ['filter-in-large', property, ['literal', values.sort(compare)]];
	            }
	            else {
	                return ['filter-in-small', property, ['literal', values]];
	            }
	    }
	}
	function convertHasOp$1(property) {
	    switch (property) {
	        case '$type':
	            return true;
	        case '$id':
	            return ['filter-has-id'];
	        default:
	            return ['filter-has', property];
	    }
	}
	function convertNegation(filter) {
	    return ['!', filter];
	}

	function stringify$1(obj) {
	    const type = typeof obj;
	    if (type === 'number' || type === 'boolean' || type === 'string' || obj === undefined || obj === null)
	        return JSON.stringify(obj);
	    if (Array.isArray(obj)) {
	        let str = '[';
	        for (const val of obj) {
	            str += `${stringify$1(val)},`;
	        }
	        return `${str}]`;
	    }
	    const keys = Object.keys(obj).sort();
	    let str = '{';
	    for (let i = 0; i < keys.length; i++) {
	        str += `${JSON.stringify(keys[i])}:${stringify$1(obj[keys[i]])},`;
	    }
	    return `${str}}`;
	}
	function getKey(layer) {
	    let key = '';
	    for (const k of refProperties) {
	        key += `/${stringify$1(layer[k])}`;
	    }
	    return key;
	}
	/**
	 * Given an array of layers, return an array of arrays of layers where all
	 * layers in each group have identical layout-affecting properties. These
	 * are the properties that were formerly used by explicit `ref` mechanism
	 * for layers: 'type', 'source', 'source-layer', 'minzoom', 'maxzoom',
	 * 'filter', and 'layout'.
	 *
	 * The input is not modified. The output layers are references to the
	 * input layers.
	 *
	 * @private
	 * @param {Array<Layer>} layers
	 * @param {Object} [cachedKeys] - an object to keep already calculated keys.
	 * @returns {Array<Array<Layer>>}
	 */
	function groupByLayout(layers, cachedKeys) {
	    const groups = {};
	    for (let i = 0; i < layers.length; i++) {
	        const k = (cachedKeys && cachedKeys[layers[i].id]) || getKey(layers[i]);
	        // update the cache if there is one
	        if (cachedKeys)
	            cachedKeys[layers[i].id] = k;
	        let group = groups[k];
	        if (!group) {
	            group = groups[k] = [];
	        }
	        group.push(layers[i]);
	    }
	    const result = [];
	    for (const k in groups) {
	        result.push(groups[k]);
	    }
	    return result;
	}

	function emptyStyle() {
	    const style = {};
	    const version = v8Spec['$version'];
	    for (const styleKey in v8Spec['$root']) {
	        const spec = v8Spec['$root'][styleKey];
	        if (spec.required) {
	            let value = null;
	            if (styleKey === 'version') {
	                value = version;
	            }
	            else {
	                if (spec.type === 'array') {
	                    value = [];
	                }
	                else {
	                    value = {};
	                }
	            }
	            if (value != null) {
	                style[styleKey] = value;
	            }
	        }
	    }
	    return style;
	}

	function validateConstants(options) {
	    const key = options.key;
	    const constants = options.value;
	    if (constants) {
	        return [new ValidationError(key, constants, 'constants have been deprecated as of v8')];
	    }
	    else {
	        return [];
	    }
	}

	// Turn jsonlint-lines-primitives objects into primitive objects
	function unbundle(value) {
	    if (value instanceof Number || value instanceof String || value instanceof Boolean) {
	        return value.valueOf();
	    }
	    else {
	        return value;
	    }
	}
	function deepUnbundle(value) {
	    if (Array.isArray(value)) {
	        return value.map(deepUnbundle);
	    }
	    else if (value instanceof Object && !(value instanceof Number || value instanceof String || value instanceof Boolean)) {
	        const unbundledValue = {};
	        for (const key in value) {
	            unbundledValue[key] = deepUnbundle(value[key]);
	        }
	        return unbundledValue;
	    }
	    return unbundle(value);
	}

	function validateObject(options) {
	    const key = options.key;
	    const object = options.value;
	    const elementSpecs = options.valueSpec || {};
	    const elementValidators = options.objectElementValidators || {};
	    const style = options.style;
	    const styleSpec = options.styleSpec;
	    const validateSpec = options.validateSpec;
	    let errors = [];
	    const type = getType(object);
	    if (type !== 'object') {
	        return [new ValidationError(key, object, `object expected, ${type} found`)];
	    }
	    for (const objectKey in object) {
	        const elementSpecKey = objectKey.split('.')[0]; // treat 'paint.*' as 'paint'
	        const elementSpec = elementSpecs[elementSpecKey] || elementSpecs['*'];
	        let validateElement;
	        if (elementValidators[elementSpecKey]) {
	            validateElement = elementValidators[elementSpecKey];
	        }
	        else if (elementSpecs[elementSpecKey]) {
	            validateElement = validateSpec;
	        }
	        else if (elementValidators['*']) {
	            validateElement = elementValidators['*'];
	        }
	        else if (elementSpecs['*']) {
	            validateElement = validateSpec;
	        }
	        else {
	            errors.push(new ValidationError(key, object[objectKey], `unknown property "${objectKey}"`));
	            continue;
	        }
	        errors = errors.concat(validateElement({
	            key: (key ? `${key}.` : key) + objectKey,
	            value: object[objectKey],
	            valueSpec: elementSpec,
	            style,
	            styleSpec,
	            object,
	            objectKey,
	            validateSpec,
	        }, object));
	    }
	    for (const elementSpecKey in elementSpecs) {
	        // Don't check `required` when there's a custom validator for that property.
	        if (elementValidators[elementSpecKey]) {
	            continue;
	        }
	        if (elementSpecs[elementSpecKey].required && elementSpecs[elementSpecKey]['default'] === undefined && object[elementSpecKey] === undefined) {
	            errors.push(new ValidationError(key, object, `missing required property "${elementSpecKey}"`));
	        }
	    }
	    return errors;
	}

	function validateArray(options) {
	    const array = options.value;
	    const arraySpec = options.valueSpec;
	    const validateSpec = options.validateSpec;
	    const style = options.style;
	    const styleSpec = options.styleSpec;
	    const key = options.key;
	    const validateArrayElement = options.arrayElementValidator || validateSpec;
	    if (getType(array) !== 'array') {
	        return [new ValidationError(key, array, `array expected, ${getType(array)} found`)];
	    }
	    if (arraySpec.length && array.length !== arraySpec.length) {
	        return [new ValidationError(key, array, `array length ${arraySpec.length} expected, length ${array.length} found`)];
	    }
	    if (arraySpec['min-length'] && array.length < arraySpec['min-length']) {
	        return [new ValidationError(key, array, `array length at least ${arraySpec['min-length']} expected, length ${array.length} found`)];
	    }
	    let arrayElementSpec = {
	        'type': arraySpec.value,
	        'values': arraySpec.values
	    };
	    if (styleSpec.$version < 7) {
	        arrayElementSpec['function'] = arraySpec.function;
	    }
	    if (getType(arraySpec.value) === 'object') {
	        arrayElementSpec = arraySpec.value;
	    }
	    let errors = [];
	    for (let i = 0; i < array.length; i++) {
	        errors = errors.concat(validateArrayElement({
	            array,
	            arrayIndex: i,
	            value: array[i],
	            valueSpec: arrayElementSpec,
	            validateSpec: options.validateSpec,
	            style,
	            styleSpec,
	            key: `${key}[${i}]`
	        }));
	    }
	    return errors;
	}

	function validateNumber(options) {
	    const key = options.key;
	    const value = options.value;
	    const valueSpec = options.valueSpec;
	    let type = getType(value);
	    // eslint-disable-next-line no-self-compare
	    if (type === 'number' && value !== value) {
	        type = 'NaN';
	    }
	    if (type !== 'number') {
	        return [new ValidationError(key, value, `number expected, ${type} found`)];
	    }
	    if ('minimum' in valueSpec && value < valueSpec.minimum) {
	        return [new ValidationError(key, value, `${value} is less than the minimum value ${valueSpec.minimum}`)];
	    }
	    if ('maximum' in valueSpec && value > valueSpec.maximum) {
	        return [new ValidationError(key, value, `${value} is greater than the maximum value ${valueSpec.maximum}`)];
	    }
	    return [];
	}

	function validateFunction(options) {
	    const functionValueSpec = options.valueSpec;
	    const functionType = unbundle(options.value.type);
	    let stopKeyType;
	    let stopDomainValues = {};
	    let previousStopDomainValue;
	    let previousStopDomainZoom;
	    const isZoomFunction = functionType !== 'categorical' && options.value.property === undefined;
	    const isPropertyFunction = !isZoomFunction;
	    const isZoomAndPropertyFunction = getType(options.value.stops) === 'array' &&
	        getType(options.value.stops[0]) === 'array' &&
	        getType(options.value.stops[0][0]) === 'object';
	    const errors = validateObject({
	        key: options.key,
	        value: options.value,
	        valueSpec: options.styleSpec.function,
	        validateSpec: options.validateSpec,
	        style: options.style,
	        styleSpec: options.styleSpec,
	        objectElementValidators: {
	            stops: validateFunctionStops,
	            default: validateFunctionDefault
	        }
	    });
	    if (functionType === 'identity' && isZoomFunction) {
	        errors.push(new ValidationError(options.key, options.value, 'missing required property "property"'));
	    }
	    if (functionType !== 'identity' && !options.value.stops) {
	        errors.push(new ValidationError(options.key, options.value, 'missing required property "stops"'));
	    }
	    if (functionType === 'exponential' && options.valueSpec.expression && !supportsInterpolation(options.valueSpec)) {
	        errors.push(new ValidationError(options.key, options.value, 'exponential functions not supported'));
	    }
	    if (options.styleSpec.$version >= 8) {
	        if (isPropertyFunction && !supportsPropertyExpression(options.valueSpec)) {
	            errors.push(new ValidationError(options.key, options.value, 'property functions not supported'));
	        }
	        else if (isZoomFunction && !supportsZoomExpression(options.valueSpec)) {
	            errors.push(new ValidationError(options.key, options.value, 'zoom functions not supported'));
	        }
	    }
	    if ((functionType === 'categorical' || isZoomAndPropertyFunction) && options.value.property === undefined) {
	        errors.push(new ValidationError(options.key, options.value, '"property" property is required'));
	    }
	    return errors;
	    function validateFunctionStops(options) {
	        if (functionType === 'identity') {
	            return [new ValidationError(options.key, options.value, 'identity function may not have a "stops" property')];
	        }
	        let errors = [];
	        const value = options.value;
	        errors = errors.concat(validateArray({
	            key: options.key,
	            value,
	            valueSpec: options.valueSpec,
	            validateSpec: options.validateSpec,
	            style: options.style,
	            styleSpec: options.styleSpec,
	            arrayElementValidator: validateFunctionStop
	        }));
	        if (getType(value) === 'array' && value.length === 0) {
	            errors.push(new ValidationError(options.key, value, 'array must have at least one stop'));
	        }
	        return errors;
	    }
	    function validateFunctionStop(options) {
	        let errors = [];
	        const value = options.value;
	        const key = options.key;
	        if (getType(value) !== 'array') {
	            return [new ValidationError(key, value, `array expected, ${getType(value)} found`)];
	        }
	        if (value.length !== 2) {
	            return [new ValidationError(key, value, `array length 2 expected, length ${value.length} found`)];
	        }
	        if (isZoomAndPropertyFunction) {
	            if (getType(value[0]) !== 'object') {
	                return [new ValidationError(key, value, `object expected, ${getType(value[0])} found`)];
	            }
	            if (value[0].zoom === undefined) {
	                return [new ValidationError(key, value, 'object stop key must have zoom')];
	            }
	            if (value[0].value === undefined) {
	                return [new ValidationError(key, value, 'object stop key must have value')];
	            }
	            if (previousStopDomainZoom && previousStopDomainZoom > unbundle(value[0].zoom)) {
	                return [new ValidationError(key, value[0].zoom, 'stop zoom values must appear in ascending order')];
	            }
	            if (unbundle(value[0].zoom) !== previousStopDomainZoom) {
	                previousStopDomainZoom = unbundle(value[0].zoom);
	                previousStopDomainValue = undefined;
	                stopDomainValues = {};
	            }
	            errors = errors.concat(validateObject({
	                key: `${key}[0]`,
	                value: value[0],
	                valueSpec: { zoom: {} },
	                validateSpec: options.validateSpec,
	                style: options.style,
	                styleSpec: options.styleSpec,
	                objectElementValidators: { zoom: validateNumber, value: validateStopDomainValue }
	            }));
	        }
	        else {
	            errors = errors.concat(validateStopDomainValue({
	                key: `${key}[0]`,
	                value: value[0],
	                valueSpec: {},
	                validateSpec: options.validateSpec,
	                style: options.style,
	                styleSpec: options.styleSpec
	            }, value));
	        }
	        if (isExpression(deepUnbundle(value[1]))) {
	            return errors.concat([new ValidationError(`${key}[1]`, value[1], 'expressions are not allowed in function stops.')]);
	        }
	        return errors.concat(options.validateSpec({
	            key: `${key}[1]`,
	            value: value[1],
	            valueSpec: functionValueSpec,
	            validateSpec: options.validateSpec,
	            style: options.style,
	            styleSpec: options.styleSpec
	        }));
	    }
	    function validateStopDomainValue(options, stop) {
	        const type = getType(options.value);
	        const value = unbundle(options.value);
	        const reportValue = options.value !== null ? options.value : stop;
	        if (!stopKeyType) {
	            stopKeyType = type;
	        }
	        else if (type !== stopKeyType) {
	            return [new ValidationError(options.key, reportValue, `${type} stop domain type must match previous stop domain type ${stopKeyType}`)];
	        }
	        if (type !== 'number' && type !== 'string' && type !== 'boolean') {
	            return [new ValidationError(options.key, reportValue, 'stop domain value must be a number, string, or boolean')];
	        }
	        if (type !== 'number' && functionType !== 'categorical') {
	            let message = `number expected, ${type} found`;
	            if (supportsPropertyExpression(functionValueSpec) && functionType === undefined) {
	                message += '\nIf you intended to use a categorical function, specify `"type": "categorical"`.';
	            }
	            return [new ValidationError(options.key, reportValue, message)];
	        }
	        if (functionType === 'categorical' && type === 'number' && (!isFinite(value) || Math.floor(value) !== value)) {
	            return [new ValidationError(options.key, reportValue, `integer expected, found ${value}`)];
	        }
	        if (functionType !== 'categorical' && type === 'number' && previousStopDomainValue !== undefined && value < previousStopDomainValue) {
	            return [new ValidationError(options.key, reportValue, 'stop domain values must appear in ascending order')];
	        }
	        else {
	            previousStopDomainValue = value;
	        }
	        if (functionType === 'categorical' && value in stopDomainValues) {
	            return [new ValidationError(options.key, reportValue, 'stop domain values must be unique')];
	        }
	        else {
	            stopDomainValues[value] = true;
	        }
	        return [];
	    }
	    function validateFunctionDefault(options) {
	        return options.validateSpec({
	            key: options.key,
	            value: options.value,
	            valueSpec: functionValueSpec,
	            validateSpec: options.validateSpec,
	            style: options.style,
	            styleSpec: options.styleSpec
	        });
	    }
	}

	function validateExpression(options) {
	    const expression = (options.expressionContext === 'property' ? createPropertyExpression : createExpression)(deepUnbundle(options.value), options.valueSpec);
	    if (expression.result === 'error') {
	        return expression.value.map((error) => {
	            return new ValidationError(`${options.key}${error.key}`, options.value, error.message);
	        });
	    }
	    const expressionObj = expression.value.expression || expression.value._styleExpression.expression;
	    if (options.expressionContext === 'property' && (options.propertyKey === 'text-font') &&
	        !expressionObj.outputDefined()) {
	        return [new ValidationError(options.key, options.value, `Invalid data expression for "${options.propertyKey}". Output values must be contained as literals within the expression.`)];
	    }
	    if (options.expressionContext === 'property' && options.propertyType === 'layout' &&
	        (!isStateConstant(expressionObj))) {
	        return [new ValidationError(options.key, options.value, '"feature-state" data expressions are not supported with layout properties.')];
	    }
	    if (options.expressionContext === 'filter' && !isStateConstant(expressionObj)) {
	        return [new ValidationError(options.key, options.value, '"feature-state" data expressions are not supported with filters.')];
	    }
	    if (options.expressionContext && options.expressionContext.indexOf('cluster') === 0) {
	        if (!isGlobalPropertyConstant(expressionObj, ['zoom', 'feature-state'])) {
	            return [new ValidationError(options.key, options.value, '"zoom" and "feature-state" expressions are not supported with cluster properties.')];
	        }
	        if (options.expressionContext === 'cluster-initial' && !isFeatureConstant(expressionObj)) {
	            return [new ValidationError(options.key, options.value, 'Feature data expressions are not supported with initial expression part of cluster properties.')];
	        }
	    }
	    return [];
	}

	function validateBoolean(options) {
	    const value = options.value;
	    const key = options.key;
	    const type = getType(value);
	    if (type !== 'boolean') {
	        return [new ValidationError(key, value, `boolean expected, ${type} found`)];
	    }
	    return [];
	}

	function validateColor(options) {
	    const key = options.key;
	    const value = options.value;
	    const type = getType(value);
	    if (type !== 'string') {
	        return [new ValidationError(key, value, `color expected, ${type} found`)];
	    }
	    if (!Color.parse(String(value))) { // cast String object to string primitive
	        return [new ValidationError(key, value, `color expected, "${value}" found`)];
	    }
	    return [];
	}

	function validateEnum(options) {
	    const key = options.key;
	    const value = options.value;
	    const valueSpec = options.valueSpec;
	    const errors = [];
	    if (Array.isArray(valueSpec.values)) { // <=v7
	        if (valueSpec.values.indexOf(unbundle(value)) === -1) {
	            errors.push(new ValidationError(key, value, `expected one of [${valueSpec.values.join(', ')}], ${JSON.stringify(value)} found`));
	        }
	    }
	    else { // >=v8
	        if (Object.keys(valueSpec.values).indexOf(unbundle(value)) === -1) {
	            errors.push(new ValidationError(key, value, `expected one of [${Object.keys(valueSpec.values).join(', ')}], ${JSON.stringify(value)} found`));
	        }
	    }
	    return errors;
	}

	function validateFilter$1(options) {
	    if (isExpressionFilter(deepUnbundle(options.value))) {
	        return validateExpression(extendBy({}, options, {
	            expressionContext: 'filter',
	            valueSpec: { value: 'boolean' }
	        }));
	    }
	    else {
	        return validateNonExpressionFilter(options);
	    }
	}
	function validateNonExpressionFilter(options) {
	    const value = options.value;
	    const key = options.key;
	    if (getType(value) !== 'array') {
	        return [new ValidationError(key, value, `array expected, ${getType(value)} found`)];
	    }
	    const styleSpec = options.styleSpec;
	    let type;
	    let errors = [];
	    if (value.length < 1) {
	        return [new ValidationError(key, value, 'filter array must have at least 1 element')];
	    }
	    errors = errors.concat(validateEnum({
	        key: `${key}[0]`,
	        value: value[0],
	        valueSpec: styleSpec.filter_operator,
	        style: options.style,
	        styleSpec: options.styleSpec
	    }));
	    switch (unbundle(value[0])) {
	        case '<':
	        case '<=':
	        case '>':
	        case '>=':
	            if (value.length >= 2 && unbundle(value[1]) === '$type') {
	                errors.push(new ValidationError(key, value, `"$type" cannot be use with operator "${value[0]}"`));
	            }
	        /* falls through */
	        case '==':
	        case '!=':
	            if (value.length !== 3) {
	                errors.push(new ValidationError(key, value, `filter array for operator "${value[0]}" must have 3 elements`));
	            }
	        /* falls through */
	        case 'in':
	        case '!in':
	            if (value.length >= 2) {
	                type = getType(value[1]);
	                if (type !== 'string') {
	                    errors.push(new ValidationError(`${key}[1]`, value[1], `string expected, ${type} found`));
	                }
	            }
	            for (let i = 2; i < value.length; i++) {
	                type = getType(value[i]);
	                if (unbundle(value[1]) === '$type') {
	                    errors = errors.concat(validateEnum({
	                        key: `${key}[${i}]`,
	                        value: value[i],
	                        valueSpec: styleSpec.geometry_type,
	                        style: options.style,
	                        styleSpec: options.styleSpec
	                    }));
	                }
	                else if (type !== 'string' && type !== 'number' && type !== 'boolean') {
	                    errors.push(new ValidationError(`${key}[${i}]`, value[i], `string, number, or boolean expected, ${type} found`));
	                }
	            }
	            break;
	        case 'any':
	        case 'all':
	        case 'none':
	            for (let i = 1; i < value.length; i++) {
	                errors = errors.concat(validateNonExpressionFilter({
	                    key: `${key}[${i}]`,
	                    value: value[i],
	                    style: options.style,
	                    styleSpec: options.styleSpec
	                }));
	            }
	            break;
	        case 'has':
	        case '!has':
	            type = getType(value[1]);
	            if (value.length !== 2) {
	                errors.push(new ValidationError(key, value, `filter array for "${value[0]}" operator must have 2 elements`));
	            }
	            else if (type !== 'string') {
	                errors.push(new ValidationError(`${key}[1]`, value[1], `string expected, ${type} found`));
	            }
	            break;
	        case 'within':
	            type = getType(value[1]);
	            if (value.length !== 2) {
	                errors.push(new ValidationError(key, value, `filter array for "${value[0]}" operator must have 2 elements`));
	            }
	            else if (type !== 'object') {
	                errors.push(new ValidationError(`${key}[1]`, value[1], `object expected, ${type} found`));
	            }
	            break;
	    }
	    return errors;
	}

	function validateProperty(options, propertyType) {
	    const key = options.key;
	    const validateSpec = options.validateSpec;
	    const style = options.style;
	    const styleSpec = options.styleSpec;
	    const value = options.value;
	    const propertyKey = options.objectKey;
	    const layerSpec = styleSpec[`${propertyType}_${options.layerType}`];
	    if (!layerSpec)
	        return [];
	    const transitionMatch = propertyKey.match(/^(.*)-transition$/);
	    if (propertyType === 'paint' && transitionMatch && layerSpec[transitionMatch[1]] && layerSpec[transitionMatch[1]].transition) {
	        return validateSpec({
	            key,
	            value,
	            valueSpec: styleSpec.transition,
	            style,
	            styleSpec
	        });
	    }
	    const valueSpec = options.valueSpec || layerSpec[propertyKey];
	    if (!valueSpec) {
	        return [new ValidationError(key, value, `unknown property "${propertyKey}"`)];
	    }
	    let tokenMatch;
	    if (getType(value) === 'string' && supportsPropertyExpression(valueSpec) && !valueSpec.tokens && (tokenMatch = /^{([^}]+)}$/.exec(value))) {
	        return [new ValidationError(key, value, `"${propertyKey}" does not support interpolation syntax\n` +
	                `Use an identity property function instead: \`{ "type": "identity", "property": ${JSON.stringify(tokenMatch[1])} }\`.`)];
	    }
	    const errors = [];
	    if (options.layerType === 'symbol') {
	        if (propertyKey === 'text-field' && style && !style.glyphs) {
	            errors.push(new ValidationError(key, value, 'use of "text-field" requires a style "glyphs" property'));
	        }
	        if (propertyKey === 'text-font' && isFunction$1(deepUnbundle(value)) && unbundle(value.type) === 'identity') {
	            errors.push(new ValidationError(key, value, '"text-font" does not support identity functions'));
	        }
	    }
	    return errors.concat(validateSpec({
	        key: options.key,
	        value,
	        valueSpec,
	        style,
	        styleSpec,
	        expressionContext: 'property',
	        propertyType,
	        propertyKey
	    }));
	}

	function validatePaintProperty$1(options) {
	    return validateProperty(options, 'paint');
	}

	function validateLayoutProperty$1(options) {
	    return validateProperty(options, 'layout');
	}

	function validateLayer(options) {
	    let errors = [];
	    const layer = options.value;
	    const key = options.key;
	    const style = options.style;
	    const styleSpec = options.styleSpec;
	    if (!layer.type && !layer.ref) {
	        errors.push(new ValidationError(key, layer, 'either "type" or "ref" is required'));
	    }
	    let type = unbundle(layer.type);
	    const ref = unbundle(layer.ref);
	    if (layer.id) {
	        const layerId = unbundle(layer.id);
	        for (let i = 0; i < options.arrayIndex; i++) {
	            const otherLayer = style.layers[i];
	            if (unbundle(otherLayer.id) === layerId) {
	                errors.push(new ValidationError(key, layer.id, `duplicate layer id "${layer.id}", previously used at line ${otherLayer.id.__line__}`));
	            }
	        }
	    }
	    if ('ref' in layer) {
	        ['type', 'source', 'source-layer', 'filter', 'layout'].forEach((p) => {
	            if (p in layer) {
	                errors.push(new ValidationError(key, layer[p], `"${p}" is prohibited for ref layers`));
	            }
	        });
	        let parent;
	        style.layers.forEach((layer) => {
	            if (unbundle(layer.id) === ref)
	                parent = layer;
	        });
	        if (!parent) {
	            errors.push(new ValidationError(key, layer.ref, `ref layer "${ref}" not found`));
	        }
	        else if (parent.ref) {
	            errors.push(new ValidationError(key, layer.ref, 'ref cannot reference another ref layer'));
	        }
	        else {
	            type = unbundle(parent.type);
	        }
	    }
	    else if (type !== 'background') {
	        if (!layer.source) {
	            errors.push(new ValidationError(key, layer, 'missing required property "source"'));
	        }
	        else {
	            const source = style.sources && style.sources[layer.source];
	            const sourceType = source && unbundle(source.type);
	            if (!source) {
	                errors.push(new ValidationError(key, layer.source, `source "${layer.source}" not found`));
	            }
	            else if (sourceType === 'vector' && type === 'raster') {
	                errors.push(new ValidationError(key, layer.source, `layer "${layer.id}" requires a raster source`));
	            }
	            else if (sourceType !== 'raster-dem' && type === 'hillshade') {
	                errors.push(new ValidationError(key, layer.source, `layer "${layer.id}" requires a raster-dem source`));
	            }
	            else if (sourceType === 'raster' && type !== 'raster') {
	                errors.push(new ValidationError(key, layer.source, `layer "${layer.id}" requires a vector source`));
	            }
	            else if (sourceType === 'vector' && !layer['source-layer']) {
	                errors.push(new ValidationError(key, layer, `layer "${layer.id}" must specify a "source-layer"`));
	            }
	            else if (sourceType === 'raster-dem' && type !== 'hillshade') {
	                errors.push(new ValidationError(key, layer.source, 'raster-dem source can only be used with layer type \'hillshade\'.'));
	            }
	            else if (type === 'line' && layer.paint && layer.paint['line-gradient'] &&
	                (sourceType !== 'geojson' || !source.lineMetrics)) {
	                errors.push(new ValidationError(key, layer, `layer "${layer.id}" specifies a line-gradient, which requires a GeoJSON source with \`lineMetrics\` enabled.`));
	            }
	        }
	    }
	    errors = errors.concat(validateObject({
	        key,
	        value: layer,
	        valueSpec: styleSpec.layer,
	        style: options.style,
	        styleSpec: options.styleSpec,
	        validateSpec: options.validateSpec,
	        objectElementValidators: {
	            '*'() {
	                return [];
	            },
	            // We don't want to enforce the spec's `"requires": true` for backward compatibility with refs;
	            // the actual requirement is validated above. See https://github.com/mapbox/mapbox-gl-js/issues/5772.
	            type() {
	                return options.validateSpec({
	                    key: `${key}.type`,
	                    value: layer.type,
	                    valueSpec: styleSpec.layer.type,
	                    style: options.style,
	                    styleSpec: options.styleSpec,
	                    validateSpec: options.validateSpec,
	                    object: layer,
	                    objectKey: 'type'
	                });
	            },
	            filter: validateFilter$1,
	            layout(options) {
	                return validateObject({
	                    layer,
	                    key: options.key,
	                    value: options.value,
	                    style: options.style,
	                    styleSpec: options.styleSpec,
	                    validateSpec: options.validateSpec,
	                    objectElementValidators: {
	                        '*'(options) {
	                            return validateLayoutProperty$1(extendBy({ layerType: type }, options));
	                        }
	                    }
	                });
	            },
	            paint(options) {
	                return validateObject({
	                    layer,
	                    key: options.key,
	                    value: options.value,
	                    style: options.style,
	                    styleSpec: options.styleSpec,
	                    validateSpec: options.validateSpec,
	                    objectElementValidators: {
	                        '*'(options) {
	                            return validatePaintProperty$1(extendBy({ layerType: type }, options));
	                        }
	                    }
	                });
	            }
	        }
	    }));
	    return errors;
	}

	function validateString(options) {
	    const value = options.value;
	    const key = options.key;
	    const type = getType(value);
	    if (type !== 'string') {
	        return [new ValidationError(key, value, `string expected, ${type} found`)];
	    }
	    return [];
	}

	function validateRasterDEMSource(options) {
	    var _a;
	    const sourceName = (_a = options.sourceName) !== null && _a !== void 0 ? _a : '';
	    const rasterDEM = options.value;
	    const styleSpec = options.styleSpec;
	    const rasterDEMSpec = styleSpec.source_raster_dem;
	    const style = options.style;
	    let errors = [];
	    const rootType = getType(rasterDEM);
	    if (rasterDEM === undefined) {
	        return errors;
	    }
	    else if (rootType !== 'object') {
	        errors.push(new ValidationError('source_raster_dem', rasterDEM, `object expected, ${rootType} found`));
	        return errors;
	    }
	    const encoding = unbundle(rasterDEM.encoding);
	    const isCustomEncoding = encoding === 'custom';
	    const customEncodingKeys = ['redFactor', 'greenFactor', 'blueFactor', 'baseShift'];
	    const encodingName = options.value.encoding ? `"${options.value.encoding}"` : 'Default';
	    for (const key in rasterDEM) {
	        if (!isCustomEncoding && customEncodingKeys.includes(key)) {
	            errors.push(new ValidationError(key, rasterDEM[key], `In "${sourceName}": "${key}" is only valid when "encoding" is set to "custom". ${encodingName} encoding found`));
	        }
	        else if (rasterDEMSpec[key]) {
	            errors = errors.concat(options.validateSpec({
	                key,
	                value: rasterDEM[key],
	                valueSpec: rasterDEMSpec[key],
	                validateSpec: options.validateSpec,
	                style,
	                styleSpec
	            }));
	        }
	        else {
	            errors.push(new ValidationError(key, rasterDEM[key], `unknown property "${key}"`));
	        }
	    }
	    return errors;
	}

	const objectElementValidators = {
	    promoteId: validatePromoteId
	};
	function validateSource$1(options) {
	    const value = options.value;
	    const key = options.key;
	    const styleSpec = options.styleSpec;
	    const style = options.style;
	    const validateSpec = options.validateSpec;
	    if (!value.type) {
	        return [new ValidationError(key, value, '"type" is required')];
	    }
	    const type = unbundle(value.type);
	    let errors;
	    switch (type) {
	        case 'vector':
	        case 'raster':
	            errors = validateObject({
	                key,
	                value,
	                valueSpec: styleSpec[`source_${type.replace('-', '_')}`],
	                style: options.style,
	                styleSpec,
	                objectElementValidators,
	                validateSpec,
	            });
	            return errors;
	        case 'raster-dem':
	            errors = validateRasterDEMSource({
	                sourceName: key,
	                value,
	                style: options.style,
	                styleSpec,
	                validateSpec,
	            });
	            return errors;
	        case 'geojson':
	            errors = validateObject({
	                key,
	                value,
	                valueSpec: styleSpec.source_geojson,
	                style,
	                styleSpec,
	                validateSpec,
	                objectElementValidators
	            });
	            if (value.cluster) {
	                for (const prop in value.clusterProperties) {
	                    const [operator, mapExpr] = value.clusterProperties[prop];
	                    const reduceExpr = typeof operator === 'string' ? [operator, ['accumulated'], ['get', prop]] : operator;
	                    errors.push(...validateExpression({
	                        key: `${key}.${prop}.map`,
	                        value: mapExpr,
	                        validateSpec,
	                        expressionContext: 'cluster-map'
	                    }));
	                    errors.push(...validateExpression({
	                        key: `${key}.${prop}.reduce`,
	                        value: reduceExpr,
	                        validateSpec,
	                        expressionContext: 'cluster-reduce'
	                    }));
	                }
	            }
	            return errors;
	        case 'video':
	            return validateObject({
	                key,
	                value,
	                valueSpec: styleSpec.source_video,
	                style,
	                validateSpec,
	                styleSpec
	            });
	        case 'image':
	            return validateObject({
	                key,
	                value,
	                valueSpec: styleSpec.source_image,
	                style,
	                validateSpec,
	                styleSpec
	            });
	        case 'canvas':
	            return [new ValidationError(key, null, 'Please use runtime APIs to add canvas sources, rather than including them in stylesheets.', 'source.canvas')];
	        default:
	            return validateEnum({
	                key: `${key}.type`,
	                value: value.type,
	                valueSpec: { values: ['vector', 'raster', 'raster-dem', 'geojson', 'video', 'image'] },
	                style,
	                validateSpec,
	                styleSpec
	            });
	    }
	}
	function validatePromoteId({ key, value }) {
	    if (getType(value) === 'string') {
	        return validateString({ key, value });
	    }
	    else {
	        const errors = [];
	        for (const prop in value) {
	            errors.push(...validateString({ key: `${key}.${prop}`, value: value[prop] }));
	        }
	        return errors;
	    }
	}

	function validateLight$1(options) {
	    const light = options.value;
	    const styleSpec = options.styleSpec;
	    const lightSpec = styleSpec.light;
	    const style = options.style;
	    let errors = [];
	    const rootType = getType(light);
	    if (light === undefined) {
	        return errors;
	    }
	    else if (rootType !== 'object') {
	        errors = errors.concat([new ValidationError('light', light, `object expected, ${rootType} found`)]);
	        return errors;
	    }
	    for (const key in light) {
	        const transitionMatch = key.match(/^(.*)-transition$/);
	        if (transitionMatch && lightSpec[transitionMatch[1]] && lightSpec[transitionMatch[1]].transition) {
	            errors = errors.concat(options.validateSpec({
	                key,
	                value: light[key],
	                valueSpec: styleSpec.transition,
	                validateSpec: options.validateSpec,
	                style,
	                styleSpec
	            }));
	        }
	        else if (lightSpec[key]) {
	            errors = errors.concat(options.validateSpec({
	                key,
	                value: light[key],
	                valueSpec: lightSpec[key],
	                validateSpec: options.validateSpec,
	                style,
	                styleSpec
	            }));
	        }
	        else {
	            errors = errors.concat([new ValidationError(key, light[key], `unknown property "${key}"`)]);
	        }
	    }
	    return errors;
	}

	function validateSky(options) {
	    const sky = options.value;
	    const styleSpec = options.styleSpec;
	    const skySpec = styleSpec.sky;
	    const style = options.style;
	    const rootType = getType(sky);
	    if (sky === undefined) {
	        return [];
	    }
	    else if (rootType !== 'object') {
	        return [new ValidationError('sky', sky, `object expected, ${rootType} found`)];
	    }
	    let errors = [];
	    for (const key in sky) {
	        if (skySpec[key]) {
	            errors = errors.concat(validate({
	                key,
	                value: sky[key],
	                valueSpec: skySpec[key],
	                style,
	                styleSpec
	            }));
	        }
	        else {
	            errors = errors.concat([new ValidationError(key, sky[key], `unknown property "${key}"`)]);
	        }
	    }
	    return errors;
	}

	function validateTerrain$1(options) {
	    const terrain = options.value;
	    const styleSpec = options.styleSpec;
	    const terrainSpec = styleSpec.terrain;
	    const style = options.style;
	    let errors = [];
	    const rootType = getType(terrain);
	    if (terrain === undefined) {
	        return errors;
	    }
	    else if (rootType !== 'object') {
	        errors = errors.concat([new ValidationError('terrain', terrain, `object expected, ${rootType} found`)]);
	        return errors;
	    }
	    for (const key in terrain) {
	        if (terrainSpec[key]) {
	            errors = errors.concat(options.validateSpec({
	                key,
	                value: terrain[key],
	                valueSpec: terrainSpec[key],
	                validateSpec: options.validateSpec,
	                style,
	                styleSpec
	            }));
	        }
	        else {
	            errors = errors.concat([new ValidationError(key, terrain[key], `unknown property "${key}"`)]);
	        }
	    }
	    return errors;
	}

	function validateFormatted(options) {
	    if (validateString(options).length === 0) {
	        return [];
	    }
	    return validateExpression(options);
	}

	function validateImage(options) {
	    if (validateString(options).length === 0) {
	        return [];
	    }
	    return validateExpression(options);
	}

	function validatePadding(options) {
	    const key = options.key;
	    const value = options.value;
	    const type = getType(value);
	    if (type === 'array') {
	        if (value.length < 1 || value.length > 4) {
	            return [new ValidationError(key, value, `padding requires 1 to 4 values; ${value.length} values found`)];
	        }
	        const arrayElementSpec = {
	            type: 'number'
	        };
	        let errors = [];
	        for (let i = 0; i < value.length; i++) {
	            errors = errors.concat(options.validateSpec({
	                key: `${key}[${i}]`,
	                value: value[i],
	                validateSpec: options.validateSpec,
	                valueSpec: arrayElementSpec
	            }));
	        }
	        return errors;
	    }
	    else {
	        return validateNumber({
	            key,
	            value,
	            valueSpec: {}
	        });
	    }
	}

	function validateVariableAnchorOffsetCollection(options) {
	    const key = options.key;
	    const value = options.value;
	    const type = getType(value);
	    const styleSpec = options.styleSpec;
	    if (type !== 'array' || value.length < 1 || value.length % 2 !== 0) {
	        return [new ValidationError(key, value, 'variableAnchorOffsetCollection requires a non-empty array of even length')];
	    }
	    let errors = [];
	    for (let i = 0; i < value.length; i += 2) {
	        // Elements in even positions should be values from text-anchor enum
	        errors = errors.concat(validateEnum({
	            key: `${key}[${i}]`,
	            value: value[i],
	            valueSpec: styleSpec['layout_symbol']['text-anchor']
	        }));
	        // Elements in odd positions should be points (2-element numeric arrays)
	        errors = errors.concat(validateArray({
	            key: `${key}[${i + 1}]`,
	            value: value[i + 1],
	            valueSpec: {
	                length: 2,
	                value: 'number'
	            },
	            validateSpec: options.validateSpec,
	            style: options.style,
	            styleSpec
	        }));
	    }
	    return errors;
	}

	function validateSprite(options) {
	    let errors = [];
	    const sprite = options.value;
	    const key = options.key;
	    if (!Array.isArray(sprite)) {
	        return validateString({
	            key,
	            value: sprite
	        });
	    }
	    else {
	        const allSpriteIds = [];
	        const allSpriteURLs = [];
	        for (const i in sprite) {
	            if (sprite[i].id && allSpriteIds.includes(sprite[i].id))
	                errors.push(new ValidationError(key, sprite, `all the sprites' ids must be unique, but ${sprite[i].id} is duplicated`));
	            allSpriteIds.push(sprite[i].id);
	            if (sprite[i].url && allSpriteURLs.includes(sprite[i].url))
	                errors.push(new ValidationError(key, sprite, `all the sprites' URLs must be unique, but ${sprite[i].url} is duplicated`));
	            allSpriteURLs.push(sprite[i].url);
	            const pairSpec = {
	                id: {
	                    type: 'string',
	                    required: true,
	                },
	                url: {
	                    type: 'string',
	                    required: true,
	                }
	            };
	            errors = errors.concat(validateObject({
	                key: `${key}[${i}]`,
	                value: sprite[i],
	                valueSpec: pairSpec,
	                validateSpec: options.validateSpec,
	            }));
	        }
	        return errors;
	    }
	}

	const VALIDATORS = {
	    '*'() {
	        return [];
	    },
	    'array': validateArray,
	    'boolean': validateBoolean,
	    'number': validateNumber,
	    'color': validateColor,
	    'constants': validateConstants,
	    'enum': validateEnum,
	    'filter': validateFilter$1,
	    'function': validateFunction,
	    'layer': validateLayer,
	    'object': validateObject,
	    'source': validateSource$1,
	    'light': validateLight$1,
	    'sky': validateSky,
	    'terrain': validateTerrain$1,
	    'string': validateString,
	    'formatted': validateFormatted,
	    'resolvedImage': validateImage,
	    'padding': validatePadding,
	    'variableAnchorOffsetCollection': validateVariableAnchorOffsetCollection,
	    'sprite': validateSprite,
	};
	/**
	 * Main recursive validation function used internally.
	 * You should use `validateStyleMin` in the browser or `validateStyle` in node env.
	 * @param options - the options object
	 * @param options.key - string representing location of validation in style tree. Used only
	 * for more informative error reporting.
	 * @param options.value - current value from style being evaluated. May be anything from a
	 * high level object that needs to be descended into deeper or a simple
	 * scalar value.
	 * @param options.valueSpec - current spec being evaluated. Tracks value.
	 * @param options.styleSpec - current full spec being evaluated.
	 * @param options.validateSpec - the validate function itself
	 * @param options.style - the style object
	 * @param options.objectElementValidators - optional object of functions that will be called
	 * @returns an array of errors, or an empty array if no errors are found.
	 */
	function validate(options) {
	    const value = options.value;
	    const valueSpec = options.valueSpec;
	    const styleSpec = options.styleSpec;
	    options.validateSpec = validate;
	    if (valueSpec.expression && isFunction$1(unbundle(value))) {
	        return validateFunction(options);
	    }
	    else if (valueSpec.expression && isExpression(deepUnbundle(value))) {
	        return validateExpression(options);
	    }
	    else if (valueSpec.type && VALIDATORS[valueSpec.type]) {
	        return VALIDATORS[valueSpec.type](options);
	    }
	    else {
	        const valid = validateObject(extendBy({}, options, {
	            valueSpec: valueSpec.type ? styleSpec[valueSpec.type] : valueSpec
	        }));
	        return valid;
	    }
	}

	function validateGlyphsUrl(options) {
	    const value = options.value;
	    const key = options.key;
	    const errors = validateString(options);
	    if (errors.length)
	        return errors;
	    if (value.indexOf('{fontstack}') === -1) {
	        errors.push(new ValidationError(key, value, '"glyphs" url must include a "{fontstack}" token'));
	    }
	    if (value.indexOf('{range}') === -1) {
	        errors.push(new ValidationError(key, value, '"glyphs" url must include a "{range}" token'));
	    }
	    return errors;
	}

	/**
	 * Validate a MapLibre style against the style specification.
	 * Use this when running in the browser.
	 *
	 * @param style - The style to be validated.
	 * @param styleSpec - The style specification to validate against.
	 * If omitted, the latest style spec is used.
	 * @returns an array of errors, or an empty array if no errors are found.
	 * @example
	 *   const validate = require('@maplibre/maplibre-gl-style-spec/').validateStyleMin;
	 *   const errors = validate(style);
	 */
	function validateStyleMin(style, styleSpec = v8Spec) {
	    let errors = [];
	    errors = errors.concat(validate({
	        key: '',
	        value: style,
	        valueSpec: styleSpec.$root,
	        styleSpec,
	        style,
	        validateSpec: validate,
	        objectElementValidators: {
	            glyphs: validateGlyphsUrl,
	            '*'() {
	                return [];
	            }
	        }
	    }));
	    if (style['constants']) {
	        errors = errors.concat(validateConstants({
	            key: 'constants',
	            value: style['constants'],
	            style,
	            styleSpec,
	            validateSpec: validate,
	        }));
	    }
	    return sortErrors(errors);
	}
	validateStyleMin.source = wrapCleanErrors(injectValidateSpec(validateSource$1));
	validateStyleMin.sprite = wrapCleanErrors(injectValidateSpec(validateSprite));
	validateStyleMin.glyphs = wrapCleanErrors(injectValidateSpec(validateGlyphsUrl));
	validateStyleMin.light = wrapCleanErrors(injectValidateSpec(validateLight$1));
	validateStyleMin.sky = wrapCleanErrors(injectValidateSpec(validateSky));
	validateStyleMin.terrain = wrapCleanErrors(injectValidateSpec(validateTerrain$1));
	validateStyleMin.layer = wrapCleanErrors(injectValidateSpec(validateLayer));
	validateStyleMin.filter = wrapCleanErrors(injectValidateSpec(validateFilter$1));
	validateStyleMin.paintProperty = wrapCleanErrors(injectValidateSpec(validatePaintProperty$1));
	validateStyleMin.layoutProperty = wrapCleanErrors(injectValidateSpec(validateLayoutProperty$1));
	function injectValidateSpec(validator) {
	    return function (options) {
	        return validator({
	            ...options,
	            validateSpec: validate,
	        });
	    };
	}
	function sortErrors(errors) {
	    return [].concat(errors).sort((a, b) => {
	        return a.line - b.line;
	    });
	}
	function wrapCleanErrors(inner) {
	    return function (...args) {
	        return sortErrors(inner.apply(this, args));
	    };
	}

	const validateStyle = validateStyleMin;
	validateStyle.source;
	const validateLight = validateStyle.light;
	validateStyle.terrain;
	validateStyle.filter;
	const validatePaintProperty = validateStyle.paintProperty;
	const validateLayoutProperty = validateStyle.layoutProperty;
	function emitValidationErrors(emitter, errors) {
	    let hasErrors = false;
	    if (errors && errors.length) {
	        for (const error of errors) {
	            emitter.fire(new ErrorEvent(new Error(error.message)));
	            hasErrors = true;
	        }
	    }
	    return hasErrors;
	}

	/*
	This file was copied from https://github.com/mapbox/grid-index and was
	migrated from JavaScript to TypeScript.

	Copyright (c) 2016, Mapbox

	Permission to use, copy, modify, and/or distribute this software for any purpose
	with or without fee is hereby granted, provided that the above copyright notice
	and this permission notice appear in all copies.

	THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
	REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
	FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
	INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
	OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
	THIS SOFTWARE.
	*/
	const NUM_PARAMS = 3;
	class TransferableGridIndex {
	    constructor(extent, n, padding) {
	        const cells = this.cells = [];
	        if (extent instanceof ArrayBuffer) {
	            this.arrayBuffer = extent;
	            const array = new Int32Array(this.arrayBuffer);
	            extent = array[0];
	            n = array[1];
	            padding = array[2];
	            this.d = n + 2 * padding;
	            for (let k = 0; k < this.d * this.d; k++) {
	                const start = array[NUM_PARAMS + k];
	                const end = array[NUM_PARAMS + k + 1];
	                cells.push(start === end ? null : array.subarray(start, end));
	            }
	            const keysOffset = array[NUM_PARAMS + cells.length];
	            const bboxesOffset = array[NUM_PARAMS + cells.length + 1];
	            this.keys = array.subarray(keysOffset, bboxesOffset);
	            this.bboxes = array.subarray(bboxesOffset);
	            this.insert = this._insertReadonly;
	        }
	        else {
	            this.d = n + 2 * padding;
	            for (let i = 0; i < this.d * this.d; i++) {
	                cells.push([]);
	            }
	            this.keys = [];
	            this.bboxes = [];
	        }
	        this.n = n;
	        this.extent = extent;
	        this.padding = padding;
	        this.scale = n / extent;
	        this.uid = 0;
	        const p = (padding / n) * extent;
	        this.min = -p;
	        this.max = extent + p;
	    }
	    insert(key, x1, y1, x2, y2) {
	        this._forEachCell(x1, y1, x2, y2, this._insertCell, this.uid++, undefined, undefined);
	        this.keys.push(key);
	        this.bboxes.push(x1);
	        this.bboxes.push(y1);
	        this.bboxes.push(x2);
	        this.bboxes.push(y2);
	    }
	    _insertReadonly() {
	        throw new Error('Cannot insert into a GridIndex created from an ArrayBuffer.');
	    }
	    _insertCell(x1, y1, x2, y2, cellIndex, uid) {
	        this.cells[cellIndex].push(uid);
	    }
	    query(x1, y1, x2, y2, intersectionTest) {
	        const min = this.min;
	        const max = this.max;
	        if (x1 <= min && y1 <= min && max <= x2 && max <= y2 && !intersectionTest) {
	            // We use `Array#slice` because `this.keys` may be a `Int32Array` and
	            // some browsers (Safari and IE) do not support `TypedArray#slice`
	            // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray/slice#Browser_compatibility
	            return Array.prototype.slice.call(this.keys);
	        }
	        else {
	            const result = [];
	            const seenUids = {};
	            this._forEachCell(x1, y1, x2, y2, this._queryCell, result, seenUids, intersectionTest);
	            return result;
	        }
	    }
	    _queryCell(x1, y1, x2, y2, cellIndex, result, seenUids, intersectionTest) {
	        const cell = this.cells[cellIndex];
	        if (cell !== null) {
	            const keys = this.keys;
	            const bboxes = this.bboxes;
	            for (let u = 0; u < cell.length; u++) {
	                const uid = cell[u];
	                if (seenUids[uid] === undefined) {
	                    const offset = uid * 4;
	                    if (intersectionTest ?
	                        intersectionTest(bboxes[offset + 0], bboxes[offset + 1], bboxes[offset + 2], bboxes[offset + 3]) :
	                        ((x1 <= bboxes[offset + 2]) &&
	                            (y1 <= bboxes[offset + 3]) &&
	                            (x2 >= bboxes[offset + 0]) &&
	                            (y2 >= bboxes[offset + 1]))) {
	                        seenUids[uid] = true;
	                        result.push(keys[uid]);
	                    }
	                    else {
	                        seenUids[uid] = false;
	                    }
	                }
	            }
	        }
	    }
	    _forEachCell(x1, y1, x2, y2, fn, arg1, arg2, intersectionTest) {
	        const cx1 = this._convertToCellCoord(x1);
	        const cy1 = this._convertToCellCoord(y1);
	        const cx2 = this._convertToCellCoord(x2);
	        const cy2 = this._convertToCellCoord(y2);
	        for (let x = cx1; x <= cx2; x++) {
	            for (let y = cy1; y <= cy2; y++) {
	                const cellIndex = this.d * y + x;
	                if (intersectionTest && !intersectionTest(this._convertFromCellCoord(x), this._convertFromCellCoord(y), this._convertFromCellCoord(x + 1), this._convertFromCellCoord(y + 1)))
	                    continue;
	                if (fn.call(this, x1, y1, x2, y2, cellIndex, arg1, arg2, intersectionTest))
	                    return;
	            }
	        }
	    }
	    _convertFromCellCoord(x) {
	        return (x - this.padding) / this.scale;
	    }
	    _convertToCellCoord(x) {
	        return Math.max(0, Math.min(this.d - 1, Math.floor(x * this.scale) + this.padding));
	    }
	    toArrayBuffer() {
	        if (this.arrayBuffer)
	            return this.arrayBuffer;
	        const cells = this.cells;
	        const metadataLength = NUM_PARAMS + this.cells.length + 1 + 1;
	        let totalCellLength = 0;
	        for (let i = 0; i < this.cells.length; i++) {
	            totalCellLength += this.cells[i].length;
	        }
	        const array = new Int32Array(metadataLength + totalCellLength + this.keys.length + this.bboxes.length);
	        array[0] = this.extent;
	        array[1] = this.n;
	        array[2] = this.padding;
	        let offset = metadataLength;
	        for (let k = 0; k < cells.length; k++) {
	            const cell = cells[k];
	            array[NUM_PARAMS + k] = offset;
	            array.set(cell, offset);
	            offset += cell.length;
	        }
	        array[NUM_PARAMS + cells.length] = offset;
	        array.set(this.keys, offset);
	        offset += this.keys.length;
	        array[NUM_PARAMS + cells.length + 1] = offset;
	        array.set(this.bboxes, offset);
	        offset += this.bboxes.length;
	        return array.buffer;
	    }
	    static serialize(grid, transferables) {
	        const buffer = grid.toArrayBuffer();
	        if (transferables) {
	            transferables.push(buffer);
	        }
	        return { buffer };
	    }
	    static deserialize(serialized) {
	        return new TransferableGridIndex(serialized.buffer);
	    }
	}

	const registry = {};
	/**
	 * Register the given class as serializable.
	 *
	 * @param options - the registration options
	 */
	function register(name, klass, options = {}) {
	    if (registry[name])
	        throw new Error(`${name} is already registered.`);
	    Object.defineProperty(klass, '_classRegistryKey', {
	        value: name,
	        writeable: false
	    });
	    registry[name] = {
	        klass,
	        omit: options.omit || [],
	        shallow: options.shallow || []
	    };
	}
	register('Object', Object);
	register('TransferableGridIndex', TransferableGridIndex);
	register('Color', Color);
	register('Error', Error);
	register('AJAXError', AJAXError);
	register('ResolvedImage', ResolvedImage);
	register('StylePropertyFunction', StylePropertyFunction);
	register('StyleExpression', StyleExpression, { omit: ['_evaluator'] });
	register('ZoomDependentExpression', ZoomDependentExpression);
	register('ZoomConstantExpression', ZoomConstantExpression);
	register('CompoundExpression', CompoundExpression, { omit: ['_evaluate'] });
	for (const name in expressions$1) {
	    if (expressions$1[name]._classRegistryKey)
	        continue;
	    register(`Expression_${name}`, expressions$1[name]);
	}
	function isArrayBuffer(value) {
	    return value && typeof ArrayBuffer !== 'undefined' &&
	        (value instanceof ArrayBuffer || (value.constructor && value.constructor.name === 'ArrayBuffer'));
	}
	/**
	 * Serialize the given object for transfer to or from a web worker.
	 *
	 * For non-builtin types, recursively serialize each property (possibly
	 * omitting certain properties - see register()), and package the result along
	 * with the constructor's `name` so that the appropriate constructor can be
	 * looked up in `deserialize()`.
	 *
	 * If a `transferables` array is provided, add any transferable objects (i.e.,
	 * any ArrayBuffers or ArrayBuffer views) to the list. (If a copy is needed,
	 * this should happen in the client code, before using serialize().)
	 */
	function serialize(input, transferables) {
	    if (input === null ||
	        input === undefined ||
	        typeof input === 'boolean' ||
	        typeof input === 'number' ||
	        typeof input === 'string' ||
	        input instanceof Boolean ||
	        input instanceof Number ||
	        input instanceof String ||
	        input instanceof Date ||
	        input instanceof RegExp ||
	        input instanceof Blob ||
	        input instanceof Error) {
	        return input;
	    }
	    if (isArrayBuffer(input)) {
	        if (transferables) {
	            transferables.push(input);
	        }
	        return input;
	    }
	    if (isImageBitmap(input)) {
	        if (transferables) {
	            transferables.push(input);
	        }
	        return input;
	    }
	    if (ArrayBuffer.isView(input)) {
	        const view = input;
	        if (transferables) {
	            transferables.push(view.buffer);
	        }
	        return view;
	    }
	    if (input instanceof ImageData) {
	        if (transferables) {
	            transferables.push(input.data.buffer);
	        }
	        return input;
	    }
	    if (Array.isArray(input)) {
	        const serialized = [];
	        for (const item of input) {
	            serialized.push(serialize(item, transferables));
	        }
	        return serialized;
	    }
	    if (typeof input === 'object') {
	        const klass = input.constructor;
	        const name = klass._classRegistryKey;
	        if (!name) {
	            throw new Error(`can't serialize object of unregistered class ${klass.name}`);
	        }
	        if (!registry[name])
	            throw new Error(`${name} is not registered.`);
	        const properties = klass.serialize ?
	            // (Temporary workaround) allow a class to provide static
	            // `serialize()` and `deserialize()` methods to bypass the generic
	            // approach.
	            // This temporary workaround lets us use the generic serialization
	            // approach for objects whose members include instances of dynamic
	            // StructArray types. Once we refactor StructArray to be static,
	            // we can remove this complexity.
	            klass.serialize(input, transferables) : {};
	        if (!klass.serialize) {
	            for (const key in input) {
	                if (!input.hasOwnProperty(key))
	                    continue; // eslint-disable-line no-prototype-builtins
	                if (registry[name].omit.indexOf(key) >= 0)
	                    continue;
	                const property = input[key];
	                properties[key] = registry[name].shallow.indexOf(key) >= 0 ?
	                    property :
	                    serialize(property, transferables);
	            }
	            if (input instanceof Error) {
	                properties.message = input.message;
	            }
	        }
	        else {
	            if (transferables && properties === transferables[transferables.length - 1]) {
	                throw new Error('statically serialized object won\'t survive transfer of $name property');
	            }
	        }
	        if (properties.$name) {
	            throw new Error('$name property is reserved for worker serialization logic.');
	        }
	        if (name !== 'Object') {
	            properties.$name = name;
	        }
	        return properties;
	    }
	    throw new Error(`can't serialize object of type ${typeof input}`);
	}
	function deserialize(input) {
	    if (input === null ||
	        input === undefined ||
	        typeof input === 'boolean' ||
	        typeof input === 'number' ||
	        typeof input === 'string' ||
	        input instanceof Boolean ||
	        input instanceof Number ||
	        input instanceof String ||
	        input instanceof Date ||
	        input instanceof RegExp ||
	        input instanceof Blob ||
	        input instanceof Error ||
	        isArrayBuffer(input) ||
	        isImageBitmap(input) ||
	        ArrayBuffer.isView(input) ||
	        input instanceof ImageData) {
	        return input;
	    }
	    if (Array.isArray(input)) {
	        return input.map(deserialize);
	    }
	    if (typeof input === 'object') {
	        const name = input.$name || 'Object';
	        if (!registry[name]) {
	            throw new Error(`can't deserialize unregistered class ${name}`);
	        }
	        const { klass } = registry[name];
	        if (!klass) {
	            throw new Error(`can't deserialize unregistered class ${name}`);
	        }
	        if (klass.deserialize) {
	            return klass.deserialize(input);
	        }
	        const result = Object.create(klass.prototype);
	        for (const key of Object.keys(input)) {
	            if (key === '$name')
	                continue;
	            const value = input[key];
	            result[key] = registry[name].shallow.indexOf(key) >= 0 ? value : deserialize(value);
	        }
	        return result;
	    }
	    throw new Error(`can't deserialize object of type ${typeof input}`);
	}

	class ZoomHistory {
	    constructor() {
	        this.first = true;
	    }
	    update(z, now) {
	        const floorZ = Math.floor(z);
	        if (this.first) {
	            this.first = false;
	            this.lastIntegerZoom = floorZ;
	            this.lastIntegerZoomTime = 0;
	            this.lastZoom = z;
	            this.lastFloorZoom = floorZ;
	            return true;
	        }
	        if (this.lastFloorZoom > floorZ) {
	            this.lastIntegerZoom = floorZ + 1;
	            this.lastIntegerZoomTime = now;
	        }
	        else if (this.lastFloorZoom < floorZ) {
	            this.lastIntegerZoom = floorZ;
	            this.lastIntegerZoomTime = now;
	        }
	        if (z !== this.lastZoom) {
	            this.lastZoom = z;
	            this.lastFloorZoom = floorZ;
	            return true;
	        }
	        return false;
	    }
	}

	// The following table comes from <http://www.unicode.org/Public/12.0.0/ucd/Blocks.txt>.
	// Keep it synchronized with <http://www.unicode.org/Public/UCD/latest/ucd/Blocks.txt>.
	const unicodeBlockLookup = {
	    // 'Basic Latin': (char) => char >= 0x0000 && char <= 0x007F,
	    'Latin-1 Supplement': (char) => char >= 0x0080 && char <= 0x00FF,
	    // 'Latin Extended-A': (char) => char >= 0x0100 && char <= 0x017F,
	    // 'Latin Extended-B': (char) => char >= 0x0180 && char <= 0x024F,
	    // 'IPA Extensions': (char) => char >= 0x0250 && char <= 0x02AF,
	    // 'Spacing Modifier Letters': (char) => char >= 0x02B0 && char <= 0x02FF,
	    // 'Combining Diacritical Marks': (char) => char >= 0x0300 && char <= 0x036F,
	    // 'Greek and Coptic': (char) => char >= 0x0370 && char <= 0x03FF,
	    // 'Cyrillic': (char) => char >= 0x0400 && char <= 0x04FF,
	    // 'Cyrillic Supplement': (char) => char >= 0x0500 && char <= 0x052F,
	    // 'Armenian': (char) => char >= 0x0530 && char <= 0x058F,
	    //'Hebrew': (char) => char >= 0x0590 && char <= 0x05FF,
	    'Arabic': (char) => char >= 0x0600 && char <= 0x06FF,
	    //'Syriac': (char) => char >= 0x0700 && char <= 0x074F,
	    'Arabic Supplement': (char) => char >= 0x0750 && char <= 0x077F,
	    // 'Thaana': (char) => char >= 0x0780 && char <= 0x07BF,
	    // 'NKo': (char) => char >= 0x07C0 && char <= 0x07FF,
	    // 'Samaritan': (char) => char >= 0x0800 && char <= 0x083F,
	    // 'Mandaic': (char) => char >= 0x0840 && char <= 0x085F,
	    // 'Syriac Supplement': (char) => char >= 0x0860 && char <= 0x086F,
	    'Arabic Extended-A': (char) => char >= 0x08A0 && char <= 0x08FF,
	    // 'Devanagari': (char) => char >= 0x0900 && char <= 0x097F,
	    // 'Bengali': (char) => char >= 0x0980 && char <= 0x09FF,
	    // 'Gurmukhi': (char) => char >= 0x0A00 && char <= 0x0A7F,
	    // 'Gujarati': (char) => char >= 0x0A80 && char <= 0x0AFF,
	    // 'Oriya': (char) => char >= 0x0B00 && char <= 0x0B7F,
	    // 'Tamil': (char) => char >= 0x0B80 && char <= 0x0BFF,
	    // 'Telugu': (char) => char >= 0x0C00 && char <= 0x0C7F,
	    // 'Kannada': (char) => char >= 0x0C80 && char <= 0x0CFF,
	    // 'Malayalam': (char) => char >= 0x0D00 && char <= 0x0D7F,
	    // 'Sinhala': (char) => char >= 0x0D80 && char <= 0x0DFF,
	    // 'Thai': (char) => char >= 0x0E00 && char <= 0x0E7F,
	    // 'Lao': (char) => char >= 0x0E80 && char <= 0x0EFF,
	    // 'Tibetan': (char) => char >= 0x0F00 && char <= 0x0FFF,
	    // 'Myanmar': (char) => char >= 0x1000 && char <= 0x109F,
	    // 'Georgian': (char) => char >= 0x10A0 && char <= 0x10FF,
	    'Hangul Jamo': (char) => char >= 0x1100 && char <= 0x11FF,
	    // 'Ethiopic': (char) => char >= 0x1200 && char <= 0x137F,
	    // 'Ethiopic Supplement': (char) => char >= 0x1380 && char <= 0x139F,
	    // 'Cherokee': (char) => char >= 0x13A0 && char <= 0x13FF,
	    'Unified Canadian Aboriginal Syllabics': (char) => char >= 0x1400 && char <= 0x167F,
	    // 'Ogham': (char) => char >= 0x1680 && char <= 0x169F,
	    // 'Runic': (char) => char >= 0x16A0 && char <= 0x16FF,
	    // 'Tagalog': (char) => char >= 0x1700 && char <= 0x171F,
	    // 'Hanunoo': (char) => char >= 0x1720 && char <= 0x173F,
	    // 'Buhid': (char) => char >= 0x1740 && char <= 0x175F,
	    // 'Tagbanwa': (char) => char >= 0x1760 && char <= 0x177F,
	    'Khmer': (char) => char >= 0x1780 && char <= 0x17FF,
	    // 'Mongolian': (char) => char >= 0x1800 && char <= 0x18AF,
	    'Unified Canadian Aboriginal Syllabics Extended': (char) => char >= 0x18B0 && char <= 0x18FF,
	    // 'Limbu': (char) => char >= 0x1900 && char <= 0x194F,
	    // 'Tai Le': (char) => char >= 0x1950 && char <= 0x197F,
	    // 'New Tai Lue': (char) => char >= 0x1980 && char <= 0x19DF,
	    // 'Khmer Symbols': (char) => char >= 0x19E0 && char <= 0x19FF,
	    // 'Buginese': (char) => char >= 0x1A00 && char <= 0x1A1F,
	    // 'Tai Tham': (char) => char >= 0x1A20 && char <= 0x1AAF,
	    // 'Combining Diacritical Marks Extended': (char) => char >= 0x1AB0 && char <= 0x1AFF,
	    // 'Balinese': (char) => char >= 0x1B00 && char <= 0x1B7F,
	    // 'Sundanese': (char) => char >= 0x1B80 && char <= 0x1BBF,
	    // 'Batak': (char) => char >= 0x1BC0 && char <= 0x1BFF,
	    // 'Lepcha': (char) => char >= 0x1C00 && char <= 0x1C4F,
	    // 'Ol Chiki': (char) => char >= 0x1C50 && char <= 0x1C7F,
	    // 'Cyrillic Extended-C': (char) => char >= 0x1C80 && char <= 0x1C8F,
	    // 'Georgian Extended': (char) => char >= 0x1C90 && char <= 0x1CBF,
	    // 'Sundanese Supplement': (char) => char >= 0x1CC0 && char <= 0x1CCF,
	    // 'Vedic Extensions': (char) => char >= 0x1CD0 && char <= 0x1CFF,
	    // 'Phonetic Extensions': (char) => char >= 0x1D00 && char <= 0x1D7F,
	    // 'Phonetic Extensions Supplement': (char) => char >= 0x1D80 && char <= 0x1DBF,
	    // 'Combining Diacritical Marks Supplement': (char) => char >= 0x1DC0 && char <= 0x1DFF,
	    // 'Latin Extended Additional': (char) => char >= 0x1E00 && char <= 0x1EFF,
	    // 'Greek Extended': (char) => char >= 0x1F00 && char <= 0x1FFF,
	    'General Punctuation': (char) => char >= 0x2000 && char <= 0x206F,
	    // 'Superscripts and Subscripts': (char) => char >= 0x2070 && char <= 0x209F,
	    // 'Currency Symbols': (char) => char >= 0x20A0 && char <= 0x20CF,
	    // 'Combining Diacritical Marks for Symbols': (char) => char >= 0x20D0 && char <= 0x20FF,
	    'Letterlike Symbols': (char) => char >= 0x2100 && char <= 0x214F,
	    'Number Forms': (char) => char >= 0x2150 && char <= 0x218F,
	    // 'Arrows': (char) => char >= 0x2190 && char <= 0x21FF,
	    // 'Mathematical Operators': (char) => char >= 0x2200 && char <= 0x22FF,
	    'Miscellaneous Technical': (char) => char >= 0x2300 && char <= 0x23FF,
	    'Control Pictures': (char) => char >= 0x2400 && char <= 0x243F,
	    'Optical Character Recognition': (char) => char >= 0x2440 && char <= 0x245F,
	    'Enclosed Alphanumerics': (char) => char >= 0x2460 && char <= 0x24FF,
	    // 'Box Drawing': (char) => char >= 0x2500 && char <= 0x257F,
	    // 'Block Elements': (char) => char >= 0x2580 && char <= 0x259F,
	    'Geometric Shapes': (char) => char >= 0x25A0 && char <= 0x25FF,
	    'Miscellaneous Symbols': (char) => char >= 0x2600 && char <= 0x26FF,
	    // 'Dingbats': (char) => char >= 0x2700 && char <= 0x27BF,
	    // 'Miscellaneous Mathematical Symbols-A': (char) => char >= 0x27C0 && char <= 0x27EF,
	    // 'Supplemental Arrows-A': (char) => char >= 0x27F0 && char <= 0x27FF,
	    // 'Braille Patterns': (char) => char >= 0x2800 && char <= 0x28FF,
	    // 'Supplemental Arrows-B': (char) => char >= 0x2900 && char <= 0x297F,
	    // 'Miscellaneous Mathematical Symbols-B': (char) => char >= 0x2980 && char <= 0x29FF,
	    // 'Supplemental Mathematical Operators': (char) => char >= 0x2A00 && char <= 0x2AFF,
	    'Miscellaneous Symbols and Arrows': (char) => char >= 0x2B00 && char <= 0x2BFF,
	    // 'Glagolitic': (char) => char >= 0x2C00 && char <= 0x2C5F,
	    // 'Latin Extended-C': (char) => char >= 0x2C60 && char <= 0x2C7F,
	    // 'Coptic': (char) => char >= 0x2C80 && char <= 0x2CFF,
	    // 'Georgian Supplement': (char) => char >= 0x2D00 && char <= 0x2D2F,
	    // 'Tifinagh': (char) => char >= 0x2D30 && char <= 0x2D7F,
	    // 'Ethiopic Extended': (char) => char >= 0x2D80 && char <= 0x2DDF,
	    // 'Cyrillic Extended-A': (char) => char >= 0x2DE0 && char <= 0x2DFF,
	    // 'Supplemental Punctuation': (char) => char >= 0x2E00 && char <= 0x2E7F,
	    'CJK Radicals Supplement': (char) => char >= 0x2E80 && char <= 0x2EFF,
	    'Kangxi Radicals': (char) => char >= 0x2F00 && char <= 0x2FDF,
	    'Ideographic Description Characters': (char) => char >= 0x2FF0 && char <= 0x2FFF,
	    'CJK Symbols and Punctuation': (char) => char >= 0x3000 && char <= 0x303F,
	    'Hiragana': (char) => char >= 0x3040 && char <= 0x309F,
	    'Katakana': (char) => char >= 0x30A0 && char <= 0x30FF,
	    'Bopomofo': (char) => char >= 0x3100 && char <= 0x312F,
	    'Hangul Compatibility Jamo': (char) => char >= 0x3130 && char <= 0x318F,
	    'Kanbun': (char) => char >= 0x3190 && char <= 0x319F,
	    'Bopomofo Extended': (char) => char >= 0x31A0 && char <= 0x31BF,
	    'CJK Strokes': (char) => char >= 0x31C0 && char <= 0x31EF,
	    'Katakana Phonetic Extensions': (char) => char >= 0x31F0 && char <= 0x31FF,
	    'Enclosed CJK Letters and Months': (char) => char >= 0x3200 && char <= 0x32FF,
	    'CJK Compatibility': (char) => char >= 0x3300 && char <= 0x33FF,
	    'CJK Unified Ideographs Extension A': (char) => char >= 0x3400 && char <= 0x4DBF,
	    'Yijing Hexagram Symbols': (char) => char >= 0x4DC0 && char <= 0x4DFF,
	    'CJK Unified Ideographs': (char) => char >= 0x4E00 && char <= 0x9FFF,
	    'Yi Syllables': (char) => char >= 0xA000 && char <= 0xA48F,
	    'Yi Radicals': (char) => char >= 0xA490 && char <= 0xA4CF,
	    // 'Lisu': (char) => char >= 0xA4D0 && char <= 0xA4FF,
	    // 'Vai': (char) => char >= 0xA500 && char <= 0xA63F,
	    // 'Cyrillic Extended-B': (char) => char >= 0xA640 && char <= 0xA69F,
	    // 'Bamum': (char) => char >= 0xA6A0 && char <= 0xA6FF,
	    // 'Modifier Tone Letters': (char) => char >= 0xA700 && char <= 0xA71F,
	    // 'Latin Extended-D': (char) => char >= 0xA720 && char <= 0xA7FF,
	    // 'Syloti Nagri': (char) => char >= 0xA800 && char <= 0xA82F,
	    // 'Common Indic Number Forms': (char) => char >= 0xA830 && char <= 0xA83F,
	    // 'Phags-pa': (char) => char >= 0xA840 && char <= 0xA87F,
	    // 'Saurashtra': (char) => char >= 0xA880 && char <= 0xA8DF,
	    // 'Devanagari Extended': (char) => char >= 0xA8E0 && char <= 0xA8FF,
	    // 'Kayah Li': (char) => char >= 0xA900 && char <= 0xA92F,
	    // 'Rejang': (char) => char >= 0xA930 && char <= 0xA95F,
	    'Hangul Jamo Extended-A': (char) => char >= 0xA960 && char <= 0xA97F,
	    // 'Javanese': (char) => char >= 0xA980 && char <= 0xA9DF,
	    // 'Myanmar Extended-B': (char) => char >= 0xA9E0 && char <= 0xA9FF,
	    // 'Cham': (char) => char >= 0xAA00 && char <= 0xAA5F,
	    // 'Myanmar Extended-A': (char) => char >= 0xAA60 && char <= 0xAA7F,
	    // 'Tai Viet': (char) => char >= 0xAA80 && char <= 0xAADF,
	    // 'Meetei Mayek Extensions': (char) => char >= 0xAAE0 && char <= 0xAAFF,
	    // 'Ethiopic Extended-A': (char) => char >= 0xAB00 && char <= 0xAB2F,
	    // 'Latin Extended-E': (char) => char >= 0xAB30 && char <= 0xAB6F,
	    // 'Cherokee Supplement': (char) => char >= 0xAB70 && char <= 0xABBF,
	    // 'Meetei Mayek': (char) => char >= 0xABC0 && char <= 0xABFF,
	    'Hangul Syllables': (char) => char >= 0xAC00 && char <= 0xD7AF,
	    'Hangul Jamo Extended-B': (char) => char >= 0xD7B0 && char <= 0xD7FF,
	    // 'High Surrogates': (char) => char >= 0xD800 && char <= 0xDB7F,
	    // 'High Private Use Surrogates': (char) => char >= 0xDB80 && char <= 0xDBFF,
	    // 'Low Surrogates': (char) => char >= 0xDC00 && char <= 0xDFFF,
	    'Private Use Area': (char) => char >= 0xE000 && char <= 0xF8FF,
	    'CJK Compatibility Ideographs': (char) => char >= 0xF900 && char <= 0xFAFF,
	    // 'Alphabetic Presentation Forms': (char) => char >= 0xFB00 && char <= 0xFB4F,
	    'Arabic Presentation Forms-A': (char) => char >= 0xFB50 && char <= 0xFDFF,
	    // 'Variation Selectors': (char) => char >= 0xFE00 && char <= 0xFE0F,
	    'Vertical Forms': (char) => char >= 0xFE10 && char <= 0xFE1F,
	    // 'Combining Half Marks': (char) => char >= 0xFE20 && char <= 0xFE2F,
	    'CJK Compatibility Forms': (char) => char >= 0xFE30 && char <= 0xFE4F,
	    'Small Form Variants': (char) => char >= 0xFE50 && char <= 0xFE6F,
	    'Arabic Presentation Forms-B': (char) => char >= 0xFE70 && char <= 0xFEFF,
	    'Halfwidth and Fullwidth Forms': (char) => char >= 0xFF00 && char <= 0xFFEF
	    // 'Specials': (char) => char >= 0xFFF0 && char <= 0xFFFF,
	    // 'Linear B Syllabary': (char) => char >= 0x10000 && char <= 0x1007F,
	    // 'Linear B Ideograms': (char) => char >= 0x10080 && char <= 0x100FF,
	    // 'Aegean Numbers': (char) => char >= 0x10100 && char <= 0x1013F,
	    // 'Ancient Greek Numbers': (char) => char >= 0x10140 && char <= 0x1018F,
	    // 'Ancient Symbols': (char) => char >= 0x10190 && char <= 0x101CF,
	    // 'Phaistos Disc': (char) => char >= 0x101D0 && char <= 0x101FF,
	    // 'Lycian': (char) => char >= 0x10280 && char <= 0x1029F,
	    // 'Carian': (char) => char >= 0x102A0 && char <= 0x102DF,
	    // 'Coptic Epact Numbers': (char) => char >= 0x102E0 && char <= 0x102FF,
	    // 'Old Italic': (char) => char >= 0x10300 && char <= 0x1032F,
	    // 'Gothic': (char) => char >= 0x10330 && char <= 0x1034F,
	    // 'Old Permic': (char) => char >= 0x10350 && char <= 0x1037F,
	    // 'Ugaritic': (char) => char >= 0x10380 && char <= 0x1039F,
	    // 'Old Persian': (char) => char >= 0x103A0 && char <= 0x103DF,
	    // 'Deseret': (char) => char >= 0x10400 && char <= 0x1044F,
	    // 'Shavian': (char) => char >= 0x10450 && char <= 0x1047F,
	    // 'Osmanya': (char) => char >= 0x10480 && char <= 0x104AF,
	    // 'Osage': (char) => char >= 0x104B0 && char <= 0x104FF,
	    // 'Elbasan': (char) => char >= 0x10500 && char <= 0x1052F,
	    // 'Caucasian Albanian': (char) => char >= 0x10530 && char <= 0x1056F,
	    // 'Linear A': (char) => char >= 0x10600 && char <= 0x1077F,
	    // 'Cypriot Syllabary': (char) => char >= 0x10800 && char <= 0x1083F,
	    // 'Imperial Aramaic': (char) => char >= 0x10840 && char <= 0x1085F,
	    // 'Palmyrene': (char) => char >= 0x10860 && char <= 0x1087F,
	    // 'Nabataean': (char) => char >= 0x10880 && char <= 0x108AF,
	    // 'Hatran': (char) => char >= 0x108E0 && char <= 0x108FF,
	    // 'Phoenician': (char) => char >= 0x10900 && char <= 0x1091F,
	    // 'Lydian': (char) => char >= 0x10920 && char <= 0x1093F,
	    // 'Meroitic Hieroglyphs': (char) => char >= 0x10980 && char <= 0x1099F,
	    // 'Meroitic Cursive': (char) => char >= 0x109A0 && char <= 0x109FF,
	    // 'Kharoshthi': (char) => char >= 0x10A00 && char <= 0x10A5F,
	    // 'Old South Arabian': (char) => char >= 0x10A60 && char <= 0x10A7F,
	    // 'Old North Arabian': (char) => char >= 0x10A80 && char <= 0x10A9F,
	    // 'Manichaean': (char) => char >= 0x10AC0 && char <= 0x10AFF,
	    // 'Avestan': (char) => char >= 0x10B00 && char <= 0x10B3F,
	    // 'Inscriptional Parthian': (char) => char >= 0x10B40 && char <= 0x10B5F,
	    // 'Inscriptional Pahlavi': (char) => char >= 0x10B60 && char <= 0x10B7F,
	    // 'Psalter Pahlavi': (char) => char >= 0x10B80 && char <= 0x10BAF,
	    // 'Old Turkic': (char) => char >= 0x10C00 && char <= 0x10C4F,
	    // 'Old Hungarian': (char) => char >= 0x10C80 && char <= 0x10CFF,
	    // 'Hanifi Rohingya': (char) => char >= 0x10D00 && char <= 0x10D3F,
	    // 'Rumi Numeral Symbols': (char) => char >= 0x10E60 && char <= 0x10E7F,
	    // 'Old Sogdian': (char) => char >= 0x10F00 && char <= 0x10F2F,
	    // 'Sogdian': (char) => char >= 0x10F30 && char <= 0x10F6F,
	    // 'Elymaic': (char) => char >= 0x10FE0 && char <= 0x10FFF,
	    // 'Brahmi': (char) => char >= 0x11000 && char <= 0x1107F,
	    // 'Kaithi': (char) => char >= 0x11080 && char <= 0x110CF,
	    // 'Sora Sompeng': (char) => char >= 0x110D0 && char <= 0x110FF,
	    // 'Chakma': (char) => char >= 0x11100 && char <= 0x1114F,
	    // 'Mahajani': (char) => char >= 0x11150 && char <= 0x1117F,
	    // 'Sharada': (char) => char >= 0x11180 && char <= 0x111DF,
	    // 'Sinhala Archaic Numbers': (char) => char >= 0x111E0 && char <= 0x111FF,
	    // 'Khojki': (char) => char >= 0x11200 && char <= 0x1124F,
	    // 'Multani': (char) => char >= 0x11280 && char <= 0x112AF,
	    // 'Khudawadi': (char) => char >= 0x112B0 && char <= 0x112FF,
	    // 'Grantha': (char) => char >= 0x11300 && char <= 0x1137F,
	    // 'Newa': (char) => char >= 0x11400 && char <= 0x1147F,
	    // 'Tirhuta': (char) => char >= 0x11480 && char <= 0x114DF,
	    // 'Siddham': (char) => char >= 0x11580 && char <= 0x115FF,
	    // 'Modi': (char) => char >= 0x11600 && char <= 0x1165F,
	    // 'Mongolian Supplement': (char) => char >= 0x11660 && char <= 0x1167F,
	    // 'Takri': (char) => char >= 0x11680 && char <= 0x116CF,
	    // 'Ahom': (char) => char >= 0x11700 && char <= 0x1173F,
	    // 'Dogra': (char) => char >= 0x11800 && char <= 0x1184F,
	    // 'Warang Citi': (char) => char >= 0x118A0 && char <= 0x118FF,
	    // 'Nandinagari': (char) => char >= 0x119A0 && char <= 0x119FF,
	    // 'Zanabazar Square': (char) => char >= 0x11A00 && char <= 0x11A4F,
	    // 'Soyombo': (char) => char >= 0x11A50 && char <= 0x11AAF,
	    // 'Pau Cin Hau': (char) => char >= 0x11AC0 && char <= 0x11AFF,
	    // 'Bhaiksuki': (char) => char >= 0x11C00 && char <= 0x11C6F,
	    // 'Marchen': (char) => char >= 0x11C70 && char <= 0x11CBF,
	    // 'Masaram Gondi': (char) => char >= 0x11D00 && char <= 0x11D5F,
	    // 'Gunjala Gondi': (char) => char >= 0x11D60 && char <= 0x11DAF,
	    // 'Makasar': (char) => char >= 0x11EE0 && char <= 0x11EFF,
	    // 'Tamil Supplement': (char) => char >= 0x11FC0 && char <= 0x11FFF,
	    // 'Cuneiform': (char) => char >= 0x12000 && char <= 0x123FF,
	    // 'Cuneiform Numbers and Punctuation': (char) => char >= 0x12400 && char <= 0x1247F,
	    // 'Early Dynastic Cuneiform': (char) => char >= 0x12480 && char <= 0x1254F,
	    // 'Egyptian Hieroglyphs': (char) => char >= 0x13000 && char <= 0x1342F,
	    // 'Egyptian Hieroglyph Format Controls': (char) => char >= 0x13430 && char <= 0x1343F,
	    // 'Anatolian Hieroglyphs': (char) => char >= 0x14400 && char <= 0x1467F,
	    // 'Bamum Supplement': (char) => char >= 0x16800 && char <= 0x16A3F,
	    // 'Mro': (char) => char >= 0x16A40 && char <= 0x16A6F,
	    // 'Bassa Vah': (char) => char >= 0x16AD0 && char <= 0x16AFF,
	    // 'Pahawh Hmong': (char) => char >= 0x16B00 && char <= 0x16B8F,
	    // 'Medefaidrin': (char) => char >= 0x16E40 && char <= 0x16E9F,
	    // 'Miao': (char) => char >= 0x16F00 && char <= 0x16F9F,
	    // 'Ideographic Symbols and Punctuation': (char) => char >= 0x16FE0 && char <= 0x16FFF,
	    // 'Tangut': (char) => char >= 0x17000 && char <= 0x187FF,
	    // 'Tangut Components': (char) => char >= 0x18800 && char <= 0x18AFF,
	    // 'Kana Supplement': (char) => char >= 0x1B000 && char <= 0x1B0FF,
	    // 'Kana Extended-A': (char) => char >= 0x1B100 && char <= 0x1B12F,
	    // 'Small Kana Extension': (char) => char >= 0x1B130 && char <= 0x1B16F,
	    // 'Nushu': (char) => char >= 0x1B170 && char <= 0x1B2FF,
	    // 'Duployan': (char) => char >= 0x1BC00 && char <= 0x1BC9F,
	    // 'Shorthand Format Controls': (char) => char >= 0x1BCA0 && char <= 0x1BCAF,
	    // 'Byzantine Musical Symbols': (char) => char >= 0x1D000 && char <= 0x1D0FF,
	    // 'Musical Symbols': (char) => char >= 0x1D100 && char <= 0x1D1FF,
	    // 'Ancient Greek Musical Notation': (char) => char >= 0x1D200 && char <= 0x1D24F,
	    // 'Mayan Numerals': (char) => char >= 0x1D2E0 && char <= 0x1D2FF,
	    // 'Tai Xuan Jing Symbols': (char) => char >= 0x1D300 && char <= 0x1D35F,
	    // 'Counting Rod Numerals': (char) => char >= 0x1D360 && char <= 0x1D37F,
	    // 'Mathematical Alphanumeric Symbols': (char) => char >= 0x1D400 && char <= 0x1D7FF,
	    // 'Sutton SignWriting': (char) => char >= 0x1D800 && char <= 0x1DAAF,
	    // 'Glagolitic Supplement': (char) => char >= 0x1E000 && char <= 0x1E02F,
	    // 'Nyiakeng Puachue Hmong': (char) => char >= 0x1E100 && char <= 0x1E14F,
	    // 'Wancho': (char) => char >= 0x1E2C0 && char <= 0x1E2FF,
	    // 'Mende Kikakui': (char) => char >= 0x1E800 && char <= 0x1E8DF,
	    // 'Adlam': (char) => char >= 0x1E900 && char <= 0x1E95F,
	    // 'Indic Siyaq Numbers': (char) => char >= 0x1EC70 && char <= 0x1ECBF,
	    // 'Ottoman Siyaq Numbers': (char) => char >= 0x1ED00 && char <= 0x1ED4F,
	    // 'Arabic Mathematical Alphabetic Symbols': (char) => char >= 0x1EE00 && char <= 0x1EEFF,
	    // 'Mahjong Tiles': (char) => char >= 0x1F000 && char <= 0x1F02F,
	    // 'Domino Tiles': (char) => char >= 0x1F030 && char <= 0x1F09F,
	    // 'Playing Cards': (char) => char >= 0x1F0A0 && char <= 0x1F0FF,
	    // 'Enclosed Alphanumeric Supplement': (char) => char >= 0x1F100 && char <= 0x1F1FF,
	    // 'Enclosed Ideographic Supplement': (char) => char >= 0x1F200 && char <= 0x1F2FF,
	    // 'Miscellaneous Symbols and Pictographs': (char) => char >= 0x1F300 && char <= 0x1F5FF,
	    // 'Emoticons': (char) => char >= 0x1F600 && char <= 0x1F64F,
	    // 'Ornamental Dingbats': (char) => char >= 0x1F650 && char <= 0x1F67F,
	    // 'Transport and Map Symbols': (char) => char >= 0x1F680 && char <= 0x1F6FF,
	    // 'Alchemical Symbols': (char) => char >= 0x1F700 && char <= 0x1F77F,
	    // 'Geometric Shapes Extended': (char) => char >= 0x1F780 && char <= 0x1F7FF,
	    // 'Supplemental Arrows-C': (char) => char >= 0x1F800 && char <= 0x1F8FF,
	    // 'Supplemental Symbols and Pictographs': (char) => char >= 0x1F900 && char <= 0x1F9FF,
	    // 'Chess Symbols': (char) => char >= 0x1FA00 && char <= 0x1FA6F,
	    // 'Symbols and Pictographs Extended-A': (char) => char >= 0x1FA70 && char <= 0x1FAFF,
	    // 'CJK Unified Ideographs Extension B': (char) => char >= 0x20000 && char <= 0x2A6DF,
	    // 'CJK Unified Ideographs Extension C': (char) => char >= 0x2A700 && char <= 0x2B73F,
	    // 'CJK Unified Ideographs Extension D': (char) => char >= 0x2B740 && char <= 0x2B81F,
	    // 'CJK Unified Ideographs Extension E': (char) => char >= 0x2B820 && char <= 0x2CEAF,
	    // 'CJK Unified Ideographs Extension F': (char) => char >= 0x2CEB0 && char <= 0x2EBEF,
	    // 'CJK Compatibility Ideographs Supplement': (char) => char >= 0x2F800 && char <= 0x2FA1F,
	    // 'Tags': (char) => char >= 0xE0000 && char <= 0xE007F,
	    // 'Variation Selectors Supplement': (char) => char >= 0xE0100 && char <= 0xE01EF,
	    // 'Supplementary Private Use Area-A': (char) => char >= 0xF0000 && char <= 0xFFFFF,
	    // 'Supplementary Private Use Area-B': (char) => char >= 0x100000 && char <= 0x10FFFF,
	};
	function allowsVerticalWritingMode(chars) {
	    for (const char of chars) {
	        if (charHasUprightVerticalOrientation(char.charCodeAt(0)))
	            return true;
	    }
	    return false;
	}
	function allowsLetterSpacing(chars) {
	    for (const char of chars) {
	        if (!charAllowsLetterSpacing(char.charCodeAt(0)))
	            return false;
	    }
	    return true;
	}
	function charAllowsLetterSpacing(char) {
	    if (unicodeBlockLookup['Arabic'](char))
	        return false;
	    if (unicodeBlockLookup['Arabic Supplement'](char))
	        return false;
	    if (unicodeBlockLookup['Arabic Extended-A'](char))
	        return false;
	    if (unicodeBlockLookup['Arabic Presentation Forms-A'](char))
	        return false;
	    if (unicodeBlockLookup['Arabic Presentation Forms-B'](char))
	        return false;
	    return true;
	}
	function charAllowsIdeographicBreaking(char) {
	    // Return early for characters outside all ideographic ranges.
	    if (char < 0x2E80)
	        return false;
	    if (unicodeBlockLookup['Bopomofo Extended'](char))
	        return true;
	    if (unicodeBlockLookup['Bopomofo'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Compatibility Forms'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Compatibility Ideographs'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Compatibility'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Radicals Supplement'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Strokes'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Symbols and Punctuation'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Unified Ideographs Extension A'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Unified Ideographs'](char))
	        return true;
	    if (unicodeBlockLookup['Enclosed CJK Letters and Months'](char))
	        return true;
	    if (unicodeBlockLookup['Halfwidth and Fullwidth Forms'](char))
	        return true;
	    if (unicodeBlockLookup['Hiragana'](char))
	        return true;
	    if (unicodeBlockLookup['Ideographic Description Characters'](char))
	        return true;
	    if (unicodeBlockLookup['Kangxi Radicals'](char))
	        return true;
	    if (unicodeBlockLookup['Katakana Phonetic Extensions'](char))
	        return true;
	    if (unicodeBlockLookup['Katakana'](char))
	        return true;
	    if (unicodeBlockLookup['Vertical Forms'](char))
	        return true;
	    if (unicodeBlockLookup['Yi Radicals'](char))
	        return true;
	    if (unicodeBlockLookup['Yi Syllables'](char))
	        return true;
	    return false;
	}
	// The following logic comes from
	// <http://www.unicode.org/Public/12.0.0/ucd/VerticalOrientation.txt>.
	// Keep it synchronized with
	// <http://www.unicode.org/Public/UCD/latest/ucd/VerticalOrientation.txt>.
	// The data file denotes with “U” or “Tu” any codepoint that may be drawn
	// upright in vertical text but does not distinguish between upright and
	// “neutral” characters.
	// Blocks in the Unicode supplementary planes are excluded from this module due
	// to <https://github.com/mapbox/mapbox-gl/issues/29>.
	/**
	 * Returns true if the given Unicode codepoint identifies a character with
	 * upright orientation.
	 *
	 * A character has upright orientation if it is drawn upright (unrotated)
	 * whether the line is oriented horizontally or vertically, even if both
	 * adjacent characters can be rotated. For example, a Chinese character is
	 * always drawn upright. An uprightly oriented character causes an adjacent
	 * “neutral” character to be drawn upright as well.
	 */
	function charHasUprightVerticalOrientation(char) {
	    if (char === 0x02EA /* modifier letter yin departing tone mark */ ||
	        char === 0x02EB /* modifier letter yang departing tone mark */) {
	        return true;
	    }
	    // Return early for characters outside all ranges whose characters remain
	    // upright in vertical writing mode.
	    if (char < 0x1100)
	        return false;
	    if (unicodeBlockLookup['Bopomofo Extended'](char))
	        return true;
	    if (unicodeBlockLookup['Bopomofo'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Compatibility Forms'](char)) {
	        if (!((char >= 0xFE49 /* dashed overline */ && char <= 0xFE4F) /* wavy low line */)) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['CJK Compatibility Ideographs'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Compatibility'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Radicals Supplement'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Strokes'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Symbols and Punctuation'](char)) {
	        if (!((char >= 0x3008 /* left angle bracket */ && char <= 0x3011) /* right black lenticular bracket */) &&
	            !((char >= 0x3014 /* left tortoise shell bracket */ && char <= 0x301F) /* low double prime quotation mark */) &&
	            char !== 0x3030 /* wavy dash */) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['CJK Unified Ideographs Extension A'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Unified Ideographs'](char))
	        return true;
	    if (unicodeBlockLookup['Enclosed CJK Letters and Months'](char))
	        return true;
	    if (unicodeBlockLookup['Hangul Compatibility Jamo'](char))
	        return true;
	    if (unicodeBlockLookup['Hangul Jamo Extended-A'](char))
	        return true;
	    if (unicodeBlockLookup['Hangul Jamo Extended-B'](char))
	        return true;
	    if (unicodeBlockLookup['Hangul Jamo'](char))
	        return true;
	    if (unicodeBlockLookup['Hangul Syllables'](char))
	        return true;
	    if (unicodeBlockLookup['Hiragana'](char))
	        return true;
	    if (unicodeBlockLookup['Ideographic Description Characters'](char))
	        return true;
	    if (unicodeBlockLookup['Kanbun'](char))
	        return true;
	    if (unicodeBlockLookup['Kangxi Radicals'](char))
	        return true;
	    if (unicodeBlockLookup['Katakana Phonetic Extensions'](char))
	        return true;
	    if (unicodeBlockLookup['Katakana'](char)) {
	        if (char !== 0x30FC /* katakana-hiragana prolonged sound mark */) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['Halfwidth and Fullwidth Forms'](char)) {
	        if (char !== 0xFF08 /* fullwidth left parenthesis */ &&
	            char !== 0xFF09 /* fullwidth right parenthesis */ &&
	            char !== 0xFF0D /* fullwidth hyphen-minus */ &&
	            !((char >= 0xFF1A /* fullwidth colon */ && char <= 0xFF1E) /* fullwidth greater-than sign */) &&
	            char !== 0xFF3B /* fullwidth left square bracket */ &&
	            char !== 0xFF3D /* fullwidth right square bracket */ &&
	            char !== 0xFF3F /* fullwidth low line */ &&
	            !(char >= 0xFF5B /* fullwidth left curly bracket */ && char <= 0xFFDF) &&
	            char !== 0xFFE3 /* fullwidth macron */ &&
	            !(char >= 0xFFE8 /* halfwidth forms light vertical */ && char <= 0xFFEF)) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['Small Form Variants'](char)) {
	        if (!((char >= 0xFE58 /* small em dash */ && char <= 0xFE5E) /* small right tortoise shell bracket */) &&
	            !((char >= 0xFE63 /* small hyphen-minus */ && char <= 0xFE66) /* small equals sign */)) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['Unified Canadian Aboriginal Syllabics'](char))
	        return true;
	    if (unicodeBlockLookup['Unified Canadian Aboriginal Syllabics Extended'](char))
	        return true;
	    if (unicodeBlockLookup['Vertical Forms'](char))
	        return true;
	    if (unicodeBlockLookup['Yijing Hexagram Symbols'](char))
	        return true;
	    if (unicodeBlockLookup['Yi Syllables'](char))
	        return true;
	    if (unicodeBlockLookup['Yi Radicals'](char))
	        return true;
	    return false;
	}
	/**
	 * Returns true if the given Unicode codepoint identifies a character with
	 * neutral orientation.
	 *
	 * A character has neutral orientation if it may be drawn rotated or unrotated
	 * when the line is oriented vertically, depending on the orientation of the
	 * adjacent characters. For example, along a verticlly oriented line, the vulgar
	 * fraction ½ is drawn upright among Chinese characters but rotated among Latin
	 * letters. A neutrally oriented character does not influence whether an
	 * adjacent character is drawn upright or rotated.
	 */
	function charHasNeutralVerticalOrientation(char) {
	    if (unicodeBlockLookup['Latin-1 Supplement'](char)) {
	        if (char === 0x00A7 /* section sign */ ||
	            char === 0x00A9 /* copyright sign */ ||
	            char === 0x00AE /* registered sign */ ||
	            char === 0x00B1 /* plus-minus sign */ ||
	            char === 0x00BC /* vulgar fraction one quarter */ ||
	            char === 0x00BD /* vulgar fraction one half */ ||
	            char === 0x00BE /* vulgar fraction three quarters */ ||
	            char === 0x00D7 /* multiplication sign */ ||
	            char === 0x00F7 /* division sign */) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['General Punctuation'](char)) {
	        if (char === 0x2016 /* double vertical line */ ||
	            char === 0x2020 /* dagger */ ||
	            char === 0x2021 /* double dagger */ ||
	            char === 0x2030 /* per mille sign */ ||
	            char === 0x2031 /* per ten thousand sign */ ||
	            char === 0x203B /* reference mark */ ||
	            char === 0x203C /* double exclamation mark */ ||
	            char === 0x2042 /* asterism */ ||
	            char === 0x2047 /* double question mark */ ||
	            char === 0x2048 /* question exclamation mark */ ||
	            char === 0x2049 /* exclamation question mark */ ||
	            char === 0x2051 /* two asterisks aligned vertically */) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['Letterlike Symbols'](char))
	        return true;
	    if (unicodeBlockLookup['Number Forms'](char))
	        return true;
	    if (unicodeBlockLookup['Miscellaneous Technical'](char)) {
	        if ((char >= 0x2300 /* diameter sign */ && char <= 0x2307 /* wavy line */) ||
	            (char >= 0x230C /* bottom right crop */ && char <= 0x231F /* bottom right corner */) ||
	            (char >= 0x2324 /* up arrowhead between two horizontal bars */ && char <= 0x2328 /* keyboard */) ||
	            char === 0x232B /* erase to the left */ ||
	            (char >= 0x237D /* shouldered open box */ && char <= 0x239A /* clear screen symbol */) ||
	            (char >= 0x23BE /* dentistry symbol light vertical and top right */ && char <= 0x23CD /* square foot */) ||
	            char === 0x23CF /* eject symbol */ ||
	            (char >= 0x23D1 /* metrical breve */ && char <= 0x23DB /* fuse */) ||
	            (char >= 0x23E2 /* white trapezium */ && char <= 0x23FF)) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['Control Pictures'](char) && char !== 0x2423 /* open box */)
	        return true;
	    if (unicodeBlockLookup['Optical Character Recognition'](char))
	        return true;
	    if (unicodeBlockLookup['Enclosed Alphanumerics'](char))
	        return true;
	    if (unicodeBlockLookup['Geometric Shapes'](char))
	        return true;
	    if (unicodeBlockLookup['Miscellaneous Symbols'](char)) {
	        if (!((char >= 0x261A /* black left pointing index */ && char <= 0x261F) /* white down pointing index */)) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['Miscellaneous Symbols and Arrows'](char)) {
	        if ((char >= 0x2B12 /* square with top half black */ && char <= 0x2B2F /* white vertical ellipse */) ||
	            (char >= 0x2B50 /* white medium star */ && char <= 0x2B59 /* heavy circled saltire */) ||
	            (char >= 0x2BB8 /* upwards white arrow from bar with horizontal bar */ && char <= 0x2BEB)) {
	            return true;
	        }
	    }
	    if (unicodeBlockLookup['CJK Symbols and Punctuation'](char))
	        return true;
	    if (unicodeBlockLookup['Katakana'](char))
	        return true;
	    if (unicodeBlockLookup['Private Use Area'](char))
	        return true;
	    if (unicodeBlockLookup['CJK Compatibility Forms'](char))
	        return true;
	    if (unicodeBlockLookup['Small Form Variants'](char))
	        return true;
	    if (unicodeBlockLookup['Halfwidth and Fullwidth Forms'](char))
	        return true;
	    if (char === 0x221E /* infinity */ ||
	        char === 0x2234 /* therefore */ ||
	        char === 0x2235 /* because */ ||
	        (char >= 0x2700 /* black safety scissors */ && char <= 0x2767 /* rotated floral heart bullet */) ||
	        (char >= 0x2776 /* dingbat negative circled digit one */ && char <= 0x2793 /* dingbat negative circled sans-serif number ten */) ||
	        char === 0xFFFC /* object replacement character */ ||
	        char === 0xFFFD /* replacement character */) {
	        return true;
	    }
	    return false;
	}
	/**
	 * Returns true if the given Unicode codepoint identifies a character with
	 * rotated orientation.
	 *
	 * A character has rotated orientation if it is drawn rotated when the line is
	 * oriented vertically, even if both adjacent characters are upright. For
	 * example, a Latin letter is drawn rotated along a vertical line. A rotated
	 * character causes an adjacent “neutral” character to be drawn rotated as well.
	 */
	function charHasRotatedVerticalOrientation(char) {
	    return !(charHasUprightVerticalOrientation(char) ||
	        charHasNeutralVerticalOrientation(char));
	}
	function charInComplexShapingScript(char) {
	    return unicodeBlockLookup['Arabic'](char) ||
	        unicodeBlockLookup['Arabic Supplement'](char) ||
	        unicodeBlockLookup['Arabic Extended-A'](char) ||
	        unicodeBlockLookup['Arabic Presentation Forms-A'](char) ||
	        unicodeBlockLookup['Arabic Presentation Forms-B'](char);
	}
	function charInRTLScript(char) {
	    // Main blocks for Hebrew, Arabic, Thaana and other RTL scripts
	    return (char >= 0x0590 && char <= 0x08FF) ||
	        unicodeBlockLookup['Arabic Presentation Forms-A'](char) ||
	        unicodeBlockLookup['Arabic Presentation Forms-B'](char);
	}
	function charInSupportedScript(char, canRenderRTL) {
	    // This is a rough heuristic: whether we "can render" a script
	    // actually depends on the properties of the font being used
	    // and whether differences from the ideal rendering are considered
	    // semantically significant.
	    // Even in Latin script, we "can't render" combinations such as the fi
	    // ligature, but we don't consider that semantically significant.
	    if (!canRenderRTL && charInRTLScript(char)) {
	        return false;
	    }
	    if ((char >= 0x0900 && char <= 0x0DFF) ||
	        // Main blocks for Indic scripts and Sinhala
	        (char >= 0x0F00 && char <= 0x109F) ||
	        // Main blocks for Tibetan and Myanmar
	        unicodeBlockLookup['Khmer'](char)) {
	        // These blocks cover common scripts that require
	        // complex text shaping, based on unicode script metadata:
	        // http://www.unicode.org/repos/cldr/trunk/common/properties/scriptMetadata.txt
	        // where "Web Rank <= 32" "Shaping Required = YES"
	        return false;
	    }
	    return true;
	}
	function stringContainsRTLText(chars) {
	    for (const char of chars) {
	        if (charInRTLScript(char.charCodeAt(0))) {
	            return true;
	        }
	    }
	    return false;
	}
	function isStringInSupportedScript(chars, canRenderRTL) {
	    for (const char of chars) {
	        if (!charInSupportedScript(char.charCodeAt(0), canRenderRTL)) {
	            return false;
	        }
	    }
	    return true;
	}

	class RTLWorkerPlugin {
	    constructor() {
	        this.applyArabicShaping = null;
	        this.processBidirectionalText = null;
	        this.processStyledBidirectionalText = null;
	        this.pluginStatus = 'unavailable';
	        this.pluginURL = null;
	    }
	    setState(state) {
	        this.pluginStatus = state.pluginStatus;
	        this.pluginURL = state.pluginURL;
	    }
	    getState() {
	        return {
	            pluginStatus: this.pluginStatus,
	            pluginURL: this.pluginURL
	        };
	    }
	    setMethods(rtlTextPlugin) {
	        this.applyArabicShaping = rtlTextPlugin.applyArabicShaping;
	        this.processBidirectionalText = rtlTextPlugin.processBidirectionalText;
	        this.processStyledBidirectionalText = rtlTextPlugin.processStyledBidirectionalText;
	    }
	    isParsed() {
	        return this.applyArabicShaping != null &&
	            this.processBidirectionalText != null &&
	            this.processStyledBidirectionalText != null;
	    }
	    getPluginURL() {
	        return this.pluginURL;
	    }
	    getRTLTextPluginStatus() {
	        return this.pluginStatus;
	    }
	}
	const rtlWorkerPlugin = new RTLWorkerPlugin();

	/**
	 * @internal
	 * A parameter that can be evaluated to a value
	 */
	class EvaluationParameters {
	    // "options" may also be another EvaluationParameters to copy, see CrossFadedProperty.possiblyEvaluate
	    constructor(zoom, options) {
	        this.zoom = zoom;
	        if (options) {
	            this.now = options.now;
	            this.fadeDuration = options.fadeDuration;
	            this.zoomHistory = options.zoomHistory;
	            this.transition = options.transition;
	        }
	        else {
	            this.now = 0;
	            this.fadeDuration = 0;
	            this.zoomHistory = new ZoomHistory();
	            this.transition = {};
	        }
	    }
	    isSupportedScript(str) {
	        return isStringInSupportedScript(str, rtlWorkerPlugin.getRTLTextPluginStatus() === 'loaded');
	    }
	    crossFadingFactor() {
	        if (this.fadeDuration === 0) {
	            return 1;
	        }
	        else {
	            return Math.min((this.now - this.zoomHistory.lastIntegerZoomTime) / this.fadeDuration, 1);
	        }
	    }
	    getCrossfadeParameters() {
	        const z = this.zoom;
	        const fraction = z - Math.floor(z);
	        const t = this.crossFadingFactor();
	        return z > this.zoomHistory.lastIntegerZoom ?
	            { fromScale: 2, toScale: 1, t: fraction + (1 - fraction) * t } :
	            { fromScale: 0.5, toScale: 1, t: 1 - (1 - t) * fraction };
	    }
	}

	/**
	 * @internal
	 *  `PropertyValue` represents the value part of a property key-value unit. It's used to represent both
	 *  paint and layout property values, and regardless of whether or not their property supports data-driven
	 *  expressions.
	 *
	 *  `PropertyValue` stores the raw input value as seen in a style or a runtime styling API call, i.e. one of the
	 *  following:
	 *
	 *    * A constant value of the type appropriate for the property
	 *    * A function which produces a value of that type (but functions are quasi-deprecated in favor of expressions)
	 *    * An expression which produces a value of that type
	 *    * "undefined"/"not present", in which case the property is assumed to take on its default value.
	 *
	 *  In addition to storing the original input value, `PropertyValue` also stores a normalized representation,
	 *  effectively treating functions as if they are expressions, and constant or default values as if they are
	 *  (constant) expressions.
	 */
	class PropertyValue {
	    constructor(property, value) {
	        this.property = property;
	        this.value = value;
	        this.expression = normalizePropertyExpression(value === undefined ? property.specification.default : value, property.specification);
	    }
	    isDataDriven() {
	        return this.expression.kind === 'source' || this.expression.kind === 'composite';
	    }
	    possiblyEvaluate(parameters, canonical, availableImages) {
	        return this.property.possiblyEvaluate(this, parameters, canonical, availableImages);
	    }
	}
	/**
	 * @internal
	 * Paint properties are _transitionable_: they can change in a fluid manner, interpolating or cross-fading between
	 * old and new value. The duration of the transition, and the delay before it begins, is configurable.
	 *
	 * `TransitionablePropertyValue` is a compositional class that stores both the property value and that transition
	 * configuration.
	 *
	 * A `TransitionablePropertyValue` can calculate the next step in the evaluation chain for paint property values:
	 * `TransitioningPropertyValue`.
	 */
	class TransitionablePropertyValue {
	    constructor(property) {
	        this.property = property;
	        this.value = new PropertyValue(property, undefined);
	    }
	    transitioned(parameters, prior) {
	        return new TransitioningPropertyValue(this.property, this.value, prior, extend({}, parameters.transition, this.transition), parameters.now);
	    }
	    untransitioned() {
	        return new TransitioningPropertyValue(this.property, this.value, null, {}, 0);
	    }
	}
	/**
	 * @internal
	 * `Transitionable` stores a map of all (property name, `TransitionablePropertyValue`) pairs for paint properties of a
	 * given layer type. It can calculate the `TransitioningPropertyValue`s for all of them at once, producing a
	 * `Transitioning` instance for the same set of properties.
	 */
	class Transitionable {
	    constructor(properties) {
	        this._properties = properties;
	        this._values = Object.create(properties.defaultTransitionablePropertyValues);
	    }
	    getValue(name) {
	        return clone$9(this._values[name].value.value);
	    }
	    setValue(name, value) {
	        if (!Object.prototype.hasOwnProperty.call(this._values, name)) {
	            this._values[name] = new TransitionablePropertyValue(this._values[name].property);
	        }
	        // Note that we do not _remove_ an own property in the case where a value is being reset
	        // to the default: the transition might still be non-default.
	        this._values[name].value = new PropertyValue(this._values[name].property, value === null ? undefined : clone$9(value));
	    }
	    getTransition(name) {
	        return clone$9(this._values[name].transition);
	    }
	    setTransition(name, value) {
	        if (!Object.prototype.hasOwnProperty.call(this._values, name)) {
	            this._values[name] = new TransitionablePropertyValue(this._values[name].property);
	        }
	        this._values[name].transition = clone$9(value) || undefined;
	    }
	    serialize() {
	        const result = {};
	        for (const property of Object.keys(this._values)) {
	            const value = this.getValue(property);
	            if (value !== undefined) {
	                result[property] = value;
	            }
	            const transition = this.getTransition(property);
	            if (transition !== undefined) {
	                result[`${property}-transition`] = transition;
	            }
	        }
	        return result;
	    }
	    transitioned(parameters, prior) {
	        const result = new Transitioning(this._properties);
	        for (const property of Object.keys(this._values)) {
	            result._values[property] = this._values[property].transitioned(parameters, prior._values[property]);
	        }
	        return result;
	    }
	    untransitioned() {
	        const result = new Transitioning(this._properties);
	        for (const property of Object.keys(this._values)) {
	            result._values[property] = this._values[property].untransitioned();
	        }
	        return result;
	    }
	}
	/**
	 * @internal
	 * `TransitioningPropertyValue` implements the first of two intermediate steps in the evaluation chain of a paint
	 * property value. In this step, transitions between old and new values are handled: as long as the transition is in
	 * progress, `TransitioningPropertyValue` maintains a reference to the prior value, and interpolates between it and
	 * the new value based on the current time and the configured transition duration and delay. The product is the next
	 * step in the evaluation chain: the "possibly evaluated" result type `R`. See below for more on this concept.
	 */
	class TransitioningPropertyValue {
	    constructor(property, value, prior, transition, now) {
	        this.property = property;
	        this.value = value;
	        this.begin = now + transition.delay || 0;
	        this.end = this.begin + transition.duration || 0;
	        if (property.specification.transition && (transition.delay || transition.duration)) {
	            this.prior = prior;
	        }
	    }
	    possiblyEvaluate(parameters, canonical, availableImages) {
	        const now = parameters.now || 0;
	        const finalValue = this.value.possiblyEvaluate(parameters, canonical, availableImages);
	        const prior = this.prior;
	        if (!prior) {
	            // No prior value.
	            return finalValue;
	        }
	        else if (now > this.end) {
	            // Transition from prior value is now complete.
	            this.prior = null;
	            return finalValue;
	        }
	        else if (this.value.isDataDriven()) {
	            // Transitions to data-driven properties are not supported.
	            // We snap immediately to the data-driven value so that, when we perform layout,
	            // we see the data-driven function and can use it to populate vertex buffers.
	            this.prior = null;
	            return finalValue;
	        }
	        else if (now < this.begin) {
	            // Transition hasn't started yet.
	            return prior.possiblyEvaluate(parameters, canonical, availableImages);
	        }
	        else {
	            // Interpolate between recursively-calculated prior value and final.
	            const t = (now - this.begin) / (this.end - this.begin);
	            return this.property.interpolate(prior.possiblyEvaluate(parameters, canonical, availableImages), finalValue, easeCubicInOut(t));
	        }
	    }
	}
	/**
	 * @internal
	 * `Transitioning` stores a map of all (property name, `TransitioningPropertyValue`) pairs for paint properties of a
	 * given layer type. It can calculate the possibly-evaluated values for all of them at once, producing a
	 * `PossiblyEvaluated` instance for the same set of properties.
	 */
	class Transitioning {
	    constructor(properties) {
	        this._properties = properties;
	        this._values = Object.create(properties.defaultTransitioningPropertyValues);
	    }
	    possiblyEvaluate(parameters, canonical, availableImages) {
	        const result = new PossiblyEvaluated(this._properties);
	        for (const property of Object.keys(this._values)) {
	            result._values[property] = this._values[property].possiblyEvaluate(parameters, canonical, availableImages);
	        }
	        return result;
	    }
	    hasTransition() {
	        for (const property of Object.keys(this._values)) {
	            if (this._values[property].prior) {
	                return true;
	            }
	        }
	        return false;
	    }
	}
	// ------- Layout -------
	/**
	 * Because layout properties are not transitionable, they have a simpler representation and evaluation chain than
	 * paint properties: `PropertyValue`s are possibly evaluated, producing possibly evaluated values, which are then
	 * fully evaluated.
	 *
	 * `Layout` stores a map of all (property name, `PropertyValue`) pairs for layout properties of a
	 * given layer type. It can calculate the possibly-evaluated values for all of them at once, producing a
	 * `PossiblyEvaluated` instance for the same set of properties.
	 */
	class Layout {
	    constructor(properties) {
	        this._properties = properties;
	        this._values = Object.create(properties.defaultPropertyValues);
	    }
	    hasValue(name) {
	        return this._values[name].value !== undefined;
	    }
	    getValue(name) {
	        return clone$9(this._values[name].value);
	    }
	    setValue(name, value) {
	        this._values[name] = new PropertyValue(this._values[name].property, value === null ? undefined : clone$9(value));
	    }
	    serialize() {
	        const result = {};
	        for (const property of Object.keys(this._values)) {
	            const value = this.getValue(property);
	            if (value !== undefined) {
	                result[property] = value;
	            }
	        }
	        return result;
	    }
	    possiblyEvaluate(parameters, canonical, availableImages) {
	        const result = new PossiblyEvaluated(this._properties);
	        for (const property of Object.keys(this._values)) {
	            result._values[property] = this._values[property].possiblyEvaluate(parameters, canonical, availableImages);
	        }
	        return result;
	    }
	}
	/**
	 * @internal
	 * `PossiblyEvaluatedPropertyValue` is used for data-driven paint and layout property values. It holds a
	 * `PossiblyEvaluatedValue` and the `GlobalProperties` that were used to generate it. You're not allowed to supply
	 * a different set of `GlobalProperties` when performing the final evaluation because they would be ignored in the
	 * case where the input value was a constant or camera function.
	 */
	class PossiblyEvaluatedPropertyValue {
	    constructor(property, value, parameters) {
	        this.property = property;
	        this.value = value;
	        this.parameters = parameters;
	    }
	    isConstant() {
	        return this.value.kind === 'constant';
	    }
	    constantOr(value) {
	        if (this.value.kind === 'constant') {
	            return this.value.value;
	        }
	        else {
	            return value;
	        }
	    }
	    evaluate(feature, featureState, canonical, availableImages) {
	        return this.property.evaluate(this.value, this.parameters, feature, featureState, canonical, availableImages);
	    }
	}
	/**
	 * @internal
	 * `PossiblyEvaluated` stores a map of all (property name, `R`) pairs for paint or layout properties of a
	 * given layer type.
	 */
	class PossiblyEvaluated {
	    constructor(properties) {
	        this._properties = properties;
	        this._values = Object.create(properties.defaultPossiblyEvaluatedValues);
	    }
	    get(name) {
	        return this._values[name];
	    }
	}
	/**
	 * @internal
	 * An implementation of `Property` for properties that do not permit data-driven (source or composite) expressions.
	 * This restriction allows us to declare statically that the result of possibly evaluating this kind of property
	 * is in fact always the scalar type `T`, and can be used without further evaluating the value on a per-feature basis.
	 */
	class DataConstantProperty {
	    constructor(specification) {
	        this.specification = specification;
	    }
	    possiblyEvaluate(value, parameters) {
	        if (value.isDataDriven())
	            throw new Error('Value should not be data driven');
	        return value.expression.evaluate(parameters);
	    }
	    interpolate(a, b, t) {
	        const interpolationType = this.specification.type;
	        const interpolationFn = interpolate[interpolationType];
	        if (interpolationFn) {
	            return interpolationFn(a, b, t);
	        }
	        else {
	            return a;
	        }
	    }
	}
	/**
	 * @internal
	 * An implementation of `Property` for properties that permit data-driven (source or composite) expressions.
	 * The result of possibly evaluating this kind of property is `PossiblyEvaluatedPropertyValue<T>`; obtaining
	 * a scalar value `T` requires further evaluation on a per-feature basis.
	 */
	class DataDrivenProperty {
	    constructor(specification, overrides) {
	        this.specification = specification;
	        this.overrides = overrides;
	    }
	    possiblyEvaluate(value, parameters, canonical, availableImages) {
	        if (value.expression.kind === 'constant' || value.expression.kind === 'camera') {
	            return new PossiblyEvaluatedPropertyValue(this, { kind: 'constant', value: value.expression.evaluate(parameters, null, {}, canonical, availableImages) }, parameters);
	        }
	        else {
	            return new PossiblyEvaluatedPropertyValue(this, value.expression, parameters);
	        }
	    }
	    interpolate(a, b, t) {
	        // If either possibly-evaluated value is non-constant, give up: we aren't able to interpolate data-driven values.
	        if (a.value.kind !== 'constant' || b.value.kind !== 'constant') {
	            return a;
	        }
	        // Special case hack solely for fill-outline-color. The undefined value is subsequently handled in
	        // FillStyleLayer#recalculate, which sets fill-outline-color to the fill-color value if the former
	        // is a PossiblyEvaluatedPropertyValue containing a constant undefined value. In addition to the
	        // return value here, the other source of a PossiblyEvaluatedPropertyValue containing a constant
	        // undefined value is the "default value" for fill-outline-color held in
	        // `Properties#defaultPossiblyEvaluatedValues`, which serves as the prototype of
	        // `PossiblyEvaluated#_values`.
	        if (a.value.value === undefined || b.value.value === undefined) {
	            return new PossiblyEvaluatedPropertyValue(this, { kind: 'constant', value: undefined }, a.parameters);
	        }
	        const interpolationType = this.specification.type;
	        const interpolationFn = interpolate[interpolationType];
	        if (interpolationFn) {
	            const interpolatedValue = interpolationFn(a.value.value, b.value.value, t);
	            return new PossiblyEvaluatedPropertyValue(this, { kind: 'constant', value: interpolatedValue }, a.parameters);
	        }
	        else {
	            return a;
	        }
	    }
	    evaluate(value, parameters, feature, featureState, canonical, availableImages) {
	        if (value.kind === 'constant') {
	            return value.value;
	        }
	        else {
	            return value.evaluate(parameters, feature, featureState, canonical, availableImages);
	        }
	    }
	}
	/**
	 * @internal
	 * An implementation of `Property` for  data driven `line-pattern` which are transitioned by cross-fading
	 * rather than interpolation.
	 */
	class CrossFadedDataDrivenProperty extends DataDrivenProperty {
	    possiblyEvaluate(value, parameters, canonical, availableImages) {
	        if (value.value === undefined) {
	            return new PossiblyEvaluatedPropertyValue(this, { kind: 'constant', value: undefined }, parameters);
	        }
	        else if (value.expression.kind === 'constant') {
	            const evaluatedValue = value.expression.evaluate(parameters, null, {}, canonical, availableImages);
	            const isImageExpression = value.property.specification.type === 'resolvedImage';
	            const constantValue = isImageExpression && typeof evaluatedValue !== 'string' ? evaluatedValue.name : evaluatedValue;
	            const constant = this._calculate(constantValue, constantValue, constantValue, parameters);
	            return new PossiblyEvaluatedPropertyValue(this, { kind: 'constant', value: constant }, parameters);
	        }
	        else if (value.expression.kind === 'camera') {
	            const cameraVal = this._calculate(value.expression.evaluate({ zoom: parameters.zoom - 1.0 }), value.expression.evaluate({ zoom: parameters.zoom }), value.expression.evaluate({ zoom: parameters.zoom + 1.0 }), parameters);
	            return new PossiblyEvaluatedPropertyValue(this, { kind: 'constant', value: cameraVal }, parameters);
	        }
	        else {
	            // source or composite expression
	            return new PossiblyEvaluatedPropertyValue(this, value.expression, parameters);
	        }
	    }
	    evaluate(value, globals, feature, featureState, canonical, availableImages) {
	        if (value.kind === 'source') {
	            const constant = value.evaluate(globals, feature, featureState, canonical, availableImages);
	            return this._calculate(constant, constant, constant, globals);
	        }
	        else if (value.kind === 'composite') {
	            return this._calculate(value.evaluate({ zoom: Math.floor(globals.zoom) - 1.0 }, feature, featureState), value.evaluate({ zoom: Math.floor(globals.zoom) }, feature, featureState), value.evaluate({ zoom: Math.floor(globals.zoom) + 1.0 }, feature, featureState), globals);
	        }
	        else {
	            return value.value;
	        }
	    }
	    _calculate(min, mid, max, parameters) {
	        const z = parameters.zoom;
	        return z > parameters.zoomHistory.lastIntegerZoom ? { from: min, to: mid } : { from: max, to: mid };
	    }
	    interpolate(a) {
	        return a;
	    }
	}
	/**
	 * @internal
	 * An implementation of `Property` for `*-pattern` and `line-dasharray`, which are transitioned by cross-fading
	 * rather than interpolation.
	 */
	class CrossFadedProperty {
	    constructor(specification) {
	        this.specification = specification;
	    }
	    possiblyEvaluate(value, parameters, canonical, availableImages) {
	        if (value.value === undefined) {
	            return undefined;
	        }
	        else if (value.expression.kind === 'constant') {
	            const constant = value.expression.evaluate(parameters, null, {}, canonical, availableImages);
	            return this._calculate(constant, constant, constant, parameters);
	        }
	        else {
	            return this._calculate(value.expression.evaluate(new EvaluationParameters(Math.floor(parameters.zoom - 1.0), parameters)), value.expression.evaluate(new EvaluationParameters(Math.floor(parameters.zoom), parameters)), value.expression.evaluate(new EvaluationParameters(Math.floor(parameters.zoom + 1.0), parameters)), parameters);
	        }
	    }
	    _calculate(min, mid, max, parameters) {
	        const z = parameters.zoom;
	        return z > parameters.zoomHistory.lastIntegerZoom ? { from: min, to: mid } : { from: max, to: mid };
	    }
	    interpolate(a) {
	        return a;
	    }
	}
	/**
	 * @internal
	 * An implementation of `Property` for `heatmap-color` and `line-gradient`. Interpolation is a no-op, and
	 * evaluation returns a boolean value in order to indicate its presence, but the real
	 * evaluation happens in StyleLayer classes.
	 */
	class ColorRampProperty {
	    constructor(specification) {
	        this.specification = specification;
	    }
	    possiblyEvaluate(value, parameters, canonical, availableImages) {
	        return !!value.expression.evaluate(parameters, null, {}, canonical, availableImages);
	    }
	    interpolate() { return false; }
	}
	/**
	 * @internal
	 * `Properties` holds objects containing default values for the layout or paint property set of a given
	 * layer type. These objects are immutable, and they are used as the prototypes for the `_values` members of
	 * `Transitionable`, `Transitioning`, `Layout`, and `PossiblyEvaluated`. This allows these classes to avoid
	 * doing work in the common case where a property has no explicit value set and should be considered to take
	 * on the default value: using `for (const property of Object.keys(this._values))`, they can iterate over
	 * only the _own_ properties of `_values`, skipping repeated calculation of transitions and possible/final
	 * evaluations for defaults, the result of which will always be the same.
	 */
	class Properties {
	    constructor(properties) {
	        this.properties = properties;
	        this.defaultPropertyValues = {};
	        this.defaultTransitionablePropertyValues = {};
	        this.defaultTransitioningPropertyValues = {};
	        this.defaultPossiblyEvaluatedValues = {};
	        this.overridableProperties = [];
	        for (const property in properties) {
	            const prop = properties[property];
	            if (prop.specification.overridable) {
	                this.overridableProperties.push(property);
	            }
	            const defaultPropertyValue = this.defaultPropertyValues[property] =
	                new PropertyValue(prop, undefined);
	            const defaultTransitionablePropertyValue = this.defaultTransitionablePropertyValues[property] =
	                new TransitionablePropertyValue(prop);
	            this.defaultTransitioningPropertyValues[property] =
	                defaultTransitionablePropertyValue.untransitioned();
	            this.defaultPossiblyEvaluatedValues[property] =
	                defaultPropertyValue.possiblyEvaluate({});
	        }
	    }
	}
	register('DataDrivenProperty', DataDrivenProperty);
	register('DataConstantProperty', DataConstantProperty);
	register('CrossFadedDataDrivenProperty', CrossFadedDataDrivenProperty);
	register('CrossFadedProperty', CrossFadedProperty);
	register('ColorRampProperty', ColorRampProperty);

	const TRANSITION_SUFFIX = '-transition';
	/**
	 * A base class for style layers
	 */
	class StyleLayer extends Evented {
	    constructor(layer, properties) {
	        super();
	        this.id = layer.id;
	        this.type = layer.type;
	        this._featureFilter = { filter: () => true, needGeometry: false };
	        if (layer.type === 'custom')
	            return;
	        layer = layer;
	        this.metadata = layer.metadata;
	        this.minzoom = layer.minzoom;
	        this.maxzoom = layer.maxzoom;
	        if (layer.type !== 'background') {
	            this.source = layer.source;
	            this.sourceLayer = layer['source-layer'];
	            this.filter = layer.filter;
	        }
	        if (properties.layout) {
	            this._unevaluatedLayout = new Layout(properties.layout);
	        }
	        if (properties.paint) {
	            this._transitionablePaint = new Transitionable(properties.paint);
	            for (const property in layer.paint) {
	                this.setPaintProperty(property, layer.paint[property], { validate: false });
	            }
	            for (const property in layer.layout) {
	                this.setLayoutProperty(property, layer.layout[property], { validate: false });
	            }
	            this._transitioningPaint = this._transitionablePaint.untransitioned();
	            //$FlowFixMe
	            this.paint = new PossiblyEvaluated(properties.paint);
	        }
	    }
	    getCrossfadeParameters() {
	        return this._crossfadeParameters;
	    }
	    getLayoutProperty(name) {
	        if (name === 'visibility') {
	            return this.visibility;
	        }
	        return this._unevaluatedLayout.getValue(name);
	    }
	    setLayoutProperty(name, value, options = {}) {
	        if (value !== null && value !== undefined) {
	            const key = `layers.${this.id}.layout.${name}`;
	            if (this._validate(validateLayoutProperty, key, name, value, options)) {
	                return;
	            }
	        }
	        if (name === 'visibility') {
	            this.visibility = value;
	            return;
	        }
	        this._unevaluatedLayout.setValue(name, value);
	    }
	    getPaintProperty(name) {
	        if (name.endsWith(TRANSITION_SUFFIX)) {
	            return this._transitionablePaint.getTransition(name.slice(0, -TRANSITION_SUFFIX.length));
	        }
	        else {
	            return this._transitionablePaint.getValue(name);
	        }
	    }
	    setPaintProperty(name, value, options = {}) {
	        if (value !== null && value !== undefined) {
	            const key = `layers.${this.id}.paint.${name}`;
	            if (this._validate(validatePaintProperty, key, name, value, options)) {
	                return false;
	            }
	        }
	        if (name.endsWith(TRANSITION_SUFFIX)) {
	            this._transitionablePaint.setTransition(name.slice(0, -TRANSITION_SUFFIX.length), value || undefined);
	            return false;
	        }
	        else {
	            const transitionable = this._transitionablePaint._values[name];
	            const isCrossFadedProperty = transitionable.property.specification['property-type'] === 'cross-faded-data-driven';
	            const wasDataDriven = transitionable.value.isDataDriven();
	            const oldValue = transitionable.value;
	            this._transitionablePaint.setValue(name, value);
	            this._handleSpecialPaintPropertyUpdate(name);
	            const newValue = this._transitionablePaint._values[name].value;
	            const isDataDriven = newValue.isDataDriven();
	            // if a cross-faded value is changed, we need to make sure the new icons get added to each tile's iconAtlas
	            // so a call to _updateLayer is necessary, and we return true from this function so it gets called in
	            // Style#setPaintProperty
	            return isDataDriven || wasDataDriven || isCrossFadedProperty || this._handleOverridablePaintPropertyUpdate(name, oldValue, newValue);
	        }
	    }
	    _handleSpecialPaintPropertyUpdate(_) {
	        // No-op; can be overridden by derived classes.
	    }
	    // eslint-disable-next-line @typescript-eslint/no-unused-vars
	    _handleOverridablePaintPropertyUpdate(name, oldValue, newValue) {
	        // No-op; can be overridden by derived classes.
	        return false;
	    }
	    isHidden(zoom) {
	        if (this.minzoom && zoom < this.minzoom)
	            return true;
	        if (this.maxzoom && zoom >= this.maxzoom)
	            return true;
	        return this.visibility === 'none';
	    }
	    updateTransitions(parameters) {
	        this._transitioningPaint = this._transitionablePaint.transitioned(parameters, this._transitioningPaint);
	    }
	    hasTransition() {
	        return this._transitioningPaint.hasTransition();
	    }
	    recalculate(parameters, availableImages) {
	        if (parameters.getCrossfadeParameters) {
	            this._crossfadeParameters = parameters.getCrossfadeParameters();
	        }
	        if (this._unevaluatedLayout) {
	            this.layout = this._unevaluatedLayout.possiblyEvaluate(parameters, undefined, availableImages);
	        }
	        this.paint = this._transitioningPaint.possiblyEvaluate(parameters, undefined, availableImages);
	    }
	    serialize() {
	        const output = {
	            'id': this.id,
	            'type': this.type,
	            'source': this.source,
	            'source-layer': this.sourceLayer,
	            'metadata': this.metadata,
	            'minzoom': this.minzoom,
	            'maxzoom': this.maxzoom,
	            'filter': this.filter,
	            'layout': this._unevaluatedLayout && this._unevaluatedLayout.serialize(),
	            'paint': this._transitionablePaint && this._transitionablePaint.serialize()
	        };
	        if (this.visibility) {
	            output.layout = output.layout || {};
	            output.layout.visibility = this.visibility;
	        }
	        return filterObject(output, (value, key) => {
	            return value !== undefined &&
	                !(key === 'layout' && !Object.keys(value).length) &&
	                !(key === 'paint' && !Object.keys(value).length);
	        });
	    }
	    _validate(validate, key, name, value, options = {}) {
	        if (options && options.validate === false) {
	            return false;
	        }
	        return emitValidationErrors(this, validate.call(validateStyle, {
	            key,
	            layerType: this.type,
	            objectKey: name,
	            value,
	            styleSpec: v8Spec,
	            // Workaround for https://github.com/mapbox/mapbox-gl-js/issues/2407
	            style: { glyphs: true, sprite: true }
	        }));
	    }
	    is3D() {
	        return false;
	    }
	    isTileClipped() {
	        return false;
	    }
	    hasOffscreenPass() {
	        return false;
	    }
	    resize() {
	        // noop
	    }
	    isStateDependent() {
	        for (const property in this.paint._values) {
	            const value = this.paint.get(property);
	            if (!(value instanceof PossiblyEvaluatedPropertyValue) || !supportsPropertyExpression(value.property.specification)) {
	                continue;
	            }
	            if ((value.value.kind === 'source' || value.value.kind === 'composite') &&
	                value.value.isStateDependent) {
	                return true;
	            }
	        }
	        return false;
	    }
	}

	// Note: all "sizes" are measured in bytes
	/**
	 * @internal
	 * A view type size
	 */
	const viewTypes = {
	    'Int8': Int8Array,
	    'Uint8': Uint8Array,
	    'Int16': Int16Array,
	    'Uint16': Uint16Array,
	    'Int32': Int32Array,
	    'Uint32': Uint32Array,
	    'Float32': Float32Array
	};
	/** @internal */
	class Struct {
	    /**
	     * @param structArray - The StructArray the struct is stored in
	     * @param index - The index of the struct in the StructArray.
	     */
	    constructor(structArray, index) {
	        this._structArray = structArray;
	        this._pos1 = index * this.size;
	        this._pos2 = this._pos1 / 2;
	        this._pos4 = this._pos1 / 4;
	        this._pos8 = this._pos1 / 8;
	    }
	}
	const DEFAULT_CAPACITY = 128;
	const RESIZE_MULTIPLIER = 5;
	/**
	 * @internal
	 * `StructArray` provides an abstraction over `ArrayBuffer` and `TypedArray`
	 * making it behave like an array of typed structs.
	 *
	 * Conceptually, a StructArray is comprised of elements, i.e., instances of its
	 * associated struct type. Each particular struct type, together with an
	 * alignment size, determines the memory layout of a StructArray whose elements
	 * are of that type.  Thus, for each such layout that we need, we have
	 * a corresponding StructArrayLayout class, inheriting from StructArray and
	 * implementing `emplaceBack()` and `_refreshViews()`.
	 *
	 * In some cases, where we need to access particular elements of a StructArray,
	 * we implement a more specific subclass that inherits from one of the
	 * StructArrayLayouts and adds a `get(i): T` accessor that returns a structured
	 * object whose properties are proxies into the underlying memory space for the
	 * i-th element.  This affords the convience of working with (seemingly) plain
	 * Javascript objects without the overhead of serializing/deserializing them
	 * into ArrayBuffers for efficient web worker transfer.
	 */
	class StructArray {
	    constructor() {
	        this.isTransferred = false;
	        this.capacity = -1;
	        this.resize(0);
	    }
	    /**
	     * Serialize a StructArray instance.  Serializes both the raw data and the
	     * metadata needed to reconstruct the StructArray base class during
	     * deserialization.
	     */
	    static serialize(array, transferables) {
	        array._trim();
	        if (transferables) {
	            array.isTransferred = true;
	            transferables.push(array.arrayBuffer);
	        }
	        return {
	            length: array.length,
	            arrayBuffer: array.arrayBuffer,
	        };
	    }
	    static deserialize(input) {
	        const structArray = Object.create(this.prototype);
	        structArray.arrayBuffer = input.arrayBuffer;
	        structArray.length = input.length;
	        structArray.capacity = input.arrayBuffer.byteLength / structArray.bytesPerElement;
	        structArray._refreshViews();
	        return structArray;
	    }
	    /**
	     * Resize the array to discard unused capacity.
	     */
	    _trim() {
	        if (this.length !== this.capacity) {
	            this.capacity = this.length;
	            this.arrayBuffer = this.arrayBuffer.slice(0, this.length * this.bytesPerElement);
	            this._refreshViews();
	        }
	    }
	    /**
	     * Resets the length of the array to 0 without de-allocating capcacity.
	     */
	    clear() {
	        this.length = 0;
	    }
	    /**
	     * Resize the array.
	     * If `n` is greater than the current length then additional elements with undefined values are added.
	     * If `n` is less than the current length then the array will be reduced to the first `n` elements.
	     * @param n - The new size of the array.
	     */
	    resize(n) {
	        this.reserve(n);
	        this.length = n;
	    }
	    /**
	     * Indicate a planned increase in size, so that any necessary allocation may
	     * be done once, ahead of time.
	     * @param n - The expected size of the array.
	     */
	    reserve(n) {
	        if (n > this.capacity) {
	            this.capacity = Math.max(n, Math.floor(this.capacity * RESIZE_MULTIPLIER), DEFAULT_CAPACITY);
	            this.arrayBuffer = new ArrayBuffer(this.capacity * this.bytesPerElement);
	            const oldUint8Array = this.uint8;
	            this._refreshViews();
	            if (oldUint8Array)
	                this.uint8.set(oldUint8Array);
	        }
	    }
	    /**
	     * Create TypedArray views for the current ArrayBuffer.
	     */
	    _refreshViews() {
	        throw new Error('_refreshViews() must be implemented by each concrete StructArray layout');
	    }
	}
	/**
	 * Given a list of member fields, create a full StructArrayLayout, in
	 * particular calculating the correct byte offset for each field.  This data
	 * is used at build time to generate StructArrayLayout_*#emplaceBack() and
	 * other accessors, and at runtime for binding vertex buffer attributes.
	 */
	function createLayout(members, alignment = 1) {
	    let offset = 0;
	    let maxSize = 0;
	    const layoutMembers = members.map((member) => {
	        const typeSize = sizeOf(member.type);
	        const memberOffset = offset = align$1(offset, Math.max(alignment, typeSize));
	        const components = member.components || 1;
	        maxSize = Math.max(maxSize, typeSize);
	        offset += typeSize * components;
	        return {
	            name: member.name,
	            type: member.type,
	            components,
	            offset: memberOffset,
	        };
	    });
	    const size = align$1(offset, Math.max(maxSize, alignment));
	    return {
	        members: layoutMembers,
	        size,
	        alignment
	    };
	}
	function sizeOf(type) {
	    return viewTypes[type].BYTES_PER_ELEMENT;
	}
	function align$1(offset, size) {
	    return Math.ceil(offset / size) * size;
	}

	// This file is generated. Edit build/generate-struct-arrays.ts, then run `npm run codegen`.
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[2]
	 *
	 */
	class StructArrayLayout2i4 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1);
	    }
	    emplace(i, v0, v1) {
	        const o2 = i * 2;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        return i;
	    }
	}
	StructArrayLayout2i4.prototype.bytesPerElement = 4;
	register('StructArrayLayout2i4', StructArrayLayout2i4);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[3]
	 *
	 */
	class StructArrayLayout3i6 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2);
	    }
	    emplace(i, v0, v1, v2) {
	        const o2 = i * 3;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.int16[o2 + 2] = v2;
	        return i;
	    }
	}
	StructArrayLayout3i6.prototype.bytesPerElement = 6;
	register('StructArrayLayout3i6', StructArrayLayout3i6);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[4]
	 *
	 */
	class StructArrayLayout4i8 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3);
	    }
	    emplace(i, v0, v1, v2, v3) {
	        const o2 = i * 4;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.int16[o2 + 2] = v2;
	        this.int16[o2 + 3] = v3;
	        return i;
	    }
	}
	StructArrayLayout4i8.prototype.bytesPerElement = 8;
	register('StructArrayLayout4i8', StructArrayLayout4i8);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[2]
	 * [4]: Int16[4]
	 *
	 */
	class StructArrayLayout2i4i12 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5) {
	        const o2 = i * 6;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.int16[o2 + 2] = v2;
	        this.int16[o2 + 3] = v3;
	        this.int16[o2 + 4] = v4;
	        this.int16[o2 + 5] = v5;
	        return i;
	    }
	}
	StructArrayLayout2i4i12.prototype.bytesPerElement = 12;
	register('StructArrayLayout2i4i12', StructArrayLayout2i4i12);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[2]
	 * [4]: Uint8[4]
	 *
	 */
	class StructArrayLayout2i4ub8 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5) {
	        const o2 = i * 4;
	        const o1 = i * 8;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.uint8[o1 + 4] = v2;
	        this.uint8[o1 + 5] = v3;
	        this.uint8[o1 + 6] = v4;
	        this.uint8[o1 + 7] = v5;
	        return i;
	    }
	}
	StructArrayLayout2i4ub8.prototype.bytesPerElement = 8;
	register('StructArrayLayout2i4ub8', StructArrayLayout2i4ub8);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Float32[2]
	 *
	 */
	class StructArrayLayout2f8 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1);
	    }
	    emplace(i, v0, v1) {
	        const o4 = i * 2;
	        this.float32[o4 + 0] = v0;
	        this.float32[o4 + 1] = v1;
	        return i;
	    }
	}
	StructArrayLayout2f8.prototype.bytesPerElement = 8;
	register('StructArrayLayout2f8', StructArrayLayout2f8);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint16[10]
	 *
	 */
	class StructArrayLayout10ui20 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
	        const o2 = i * 10;
	        this.uint16[o2 + 0] = v0;
	        this.uint16[o2 + 1] = v1;
	        this.uint16[o2 + 2] = v2;
	        this.uint16[o2 + 3] = v3;
	        this.uint16[o2 + 4] = v4;
	        this.uint16[o2 + 5] = v5;
	        this.uint16[o2 + 6] = v6;
	        this.uint16[o2 + 7] = v7;
	        this.uint16[o2 + 8] = v8;
	        this.uint16[o2 + 9] = v9;
	        return i;
	    }
	}
	StructArrayLayout10ui20.prototype.bytesPerElement = 20;
	register('StructArrayLayout10ui20', StructArrayLayout10ui20);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[4]
	 * [8]: Uint16[4]
	 * [16]: Int16[4]
	 *
	 */
	class StructArrayLayout4i4ui4i24 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11) {
	        const o2 = i * 12;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.int16[o2 + 2] = v2;
	        this.int16[o2 + 3] = v3;
	        this.uint16[o2 + 4] = v4;
	        this.uint16[o2 + 5] = v5;
	        this.uint16[o2 + 6] = v6;
	        this.uint16[o2 + 7] = v7;
	        this.int16[o2 + 8] = v8;
	        this.int16[o2 + 9] = v9;
	        this.int16[o2 + 10] = v10;
	        this.int16[o2 + 11] = v11;
	        return i;
	    }
	}
	StructArrayLayout4i4ui4i24.prototype.bytesPerElement = 24;
	register('StructArrayLayout4i4ui4i24', StructArrayLayout4i4ui4i24);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Float32[3]
	 *
	 */
	class StructArrayLayout3f12 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2);
	    }
	    emplace(i, v0, v1, v2) {
	        const o4 = i * 3;
	        this.float32[o4 + 0] = v0;
	        this.float32[o4 + 1] = v1;
	        this.float32[o4 + 2] = v2;
	        return i;
	    }
	}
	StructArrayLayout3f12.prototype.bytesPerElement = 12;
	register('StructArrayLayout3f12', StructArrayLayout3f12);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint32[1]
	 *
	 */
	class StructArrayLayout1ul4 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.uint32 = new Uint32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0);
	    }
	    emplace(i, v0) {
	        const o4 = i * 1;
	        this.uint32[o4 + 0] = v0;
	        return i;
	    }
	}
	StructArrayLayout1ul4.prototype.bytesPerElement = 4;
	register('StructArrayLayout1ul4', StructArrayLayout1ul4);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[6]
	 * [12]: Uint32[1]
	 * [16]: Uint16[2]
	 *
	 */
	class StructArrayLayout6i1ul2ui20 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	        this.uint32 = new Uint32Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5, v6, v7, v8) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8) {
	        const o2 = i * 10;
	        const o4 = i * 5;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.int16[o2 + 2] = v2;
	        this.int16[o2 + 3] = v3;
	        this.int16[o2 + 4] = v4;
	        this.int16[o2 + 5] = v5;
	        this.uint32[o4 + 3] = v6;
	        this.uint16[o2 + 8] = v7;
	        this.uint16[o2 + 9] = v8;
	        return i;
	    }
	}
	StructArrayLayout6i1ul2ui20.prototype.bytesPerElement = 20;
	register('StructArrayLayout6i1ul2ui20', StructArrayLayout6i1ul2ui20);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[2]
	 * [4]: Int16[2]
	 * [8]: Int16[2]
	 *
	 */
	class StructArrayLayout2i2i2i12 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5) {
	        const o2 = i * 6;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.int16[o2 + 2] = v2;
	        this.int16[o2 + 3] = v3;
	        this.int16[o2 + 4] = v4;
	        this.int16[o2 + 5] = v5;
	        return i;
	    }
	}
	StructArrayLayout2i2i2i12.prototype.bytesPerElement = 12;
	register('StructArrayLayout2i2i2i12', StructArrayLayout2i2i2i12);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Float32[2]
	 * [8]: Float32[1]
	 * [12]: Int16[2]
	 *
	 */
	class StructArrayLayout2f1f2i16 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4);
	    }
	    emplace(i, v0, v1, v2, v3, v4) {
	        const o4 = i * 4;
	        const o2 = i * 8;
	        this.float32[o4 + 0] = v0;
	        this.float32[o4 + 1] = v1;
	        this.float32[o4 + 2] = v2;
	        this.int16[o2 + 6] = v3;
	        this.int16[o2 + 7] = v4;
	        return i;
	    }
	}
	StructArrayLayout2f1f2i16.prototype.bytesPerElement = 16;
	register('StructArrayLayout2f1f2i16', StructArrayLayout2f1f2i16);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint8[2]
	 * [4]: Float32[2]
	 *
	 */
	class StructArrayLayout2ub2f12 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3);
	    }
	    emplace(i, v0, v1, v2, v3) {
	        const o1 = i * 12;
	        const o4 = i * 3;
	        this.uint8[o1 + 0] = v0;
	        this.uint8[o1 + 1] = v1;
	        this.float32[o4 + 1] = v2;
	        this.float32[o4 + 2] = v3;
	        return i;
	    }
	}
	StructArrayLayout2ub2f12.prototype.bytesPerElement = 12;
	register('StructArrayLayout2ub2f12', StructArrayLayout2ub2f12);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint16[3]
	 *
	 */
	class StructArrayLayout3ui6 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2);
	    }
	    emplace(i, v0, v1, v2) {
	        const o2 = i * 3;
	        this.uint16[o2 + 0] = v0;
	        this.uint16[o2 + 1] = v1;
	        this.uint16[o2 + 2] = v2;
	        return i;
	    }
	}
	StructArrayLayout3ui6.prototype.bytesPerElement = 6;
	register('StructArrayLayout3ui6', StructArrayLayout3ui6);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[2]
	 * [4]: Uint16[2]
	 * [8]: Uint32[3]
	 * [20]: Uint16[3]
	 * [28]: Float32[2]
	 * [36]: Uint8[3]
	 * [40]: Uint32[1]
	 * [44]: Int16[1]
	 *
	 */
	class StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	        this.uint32 = new Uint32Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16) {
	        const o2 = i * 24;
	        const o4 = i * 12;
	        const o1 = i * 48;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.uint16[o2 + 2] = v2;
	        this.uint16[o2 + 3] = v3;
	        this.uint32[o4 + 2] = v4;
	        this.uint32[o4 + 3] = v5;
	        this.uint32[o4 + 4] = v6;
	        this.uint16[o2 + 10] = v7;
	        this.uint16[o2 + 11] = v8;
	        this.uint16[o2 + 12] = v9;
	        this.float32[o4 + 7] = v10;
	        this.float32[o4 + 8] = v11;
	        this.uint8[o1 + 36] = v12;
	        this.uint8[o1 + 37] = v13;
	        this.uint8[o1 + 38] = v14;
	        this.uint32[o4 + 10] = v15;
	        this.int16[o2 + 22] = v16;
	        return i;
	    }
	}
	StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48.prototype.bytesPerElement = 48;
	register('StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48', StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Int16[8]
	 * [16]: Uint16[15]
	 * [48]: Uint32[1]
	 * [52]: Float32[2]
	 * [60]: Uint16[2]
	 *
	 */
	class StructArrayLayout8i15ui1ul2f2ui64 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.int16 = new Int16Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	        this.uint32 = new Uint32Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27);
	    }
	    emplace(i, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27) {
	        const o2 = i * 32;
	        const o4 = i * 16;
	        this.int16[o2 + 0] = v0;
	        this.int16[o2 + 1] = v1;
	        this.int16[o2 + 2] = v2;
	        this.int16[o2 + 3] = v3;
	        this.int16[o2 + 4] = v4;
	        this.int16[o2 + 5] = v5;
	        this.int16[o2 + 6] = v6;
	        this.int16[o2 + 7] = v7;
	        this.uint16[o2 + 8] = v8;
	        this.uint16[o2 + 9] = v9;
	        this.uint16[o2 + 10] = v10;
	        this.uint16[o2 + 11] = v11;
	        this.uint16[o2 + 12] = v12;
	        this.uint16[o2 + 13] = v13;
	        this.uint16[o2 + 14] = v14;
	        this.uint16[o2 + 15] = v15;
	        this.uint16[o2 + 16] = v16;
	        this.uint16[o2 + 17] = v17;
	        this.uint16[o2 + 18] = v18;
	        this.uint16[o2 + 19] = v19;
	        this.uint16[o2 + 20] = v20;
	        this.uint16[o2 + 21] = v21;
	        this.uint16[o2 + 22] = v22;
	        this.uint32[o4 + 12] = v23;
	        this.float32[o4 + 13] = v24;
	        this.float32[o4 + 14] = v25;
	        this.uint16[o2 + 30] = v26;
	        this.uint16[o2 + 31] = v27;
	        return i;
	    }
	}
	StructArrayLayout8i15ui1ul2f2ui64.prototype.bytesPerElement = 64;
	register('StructArrayLayout8i15ui1ul2f2ui64', StructArrayLayout8i15ui1ul2f2ui64);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Float32[1]
	 *
	 */
	class StructArrayLayout1f4 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0);
	    }
	    emplace(i, v0) {
	        const o4 = i * 1;
	        this.float32[o4 + 0] = v0;
	        return i;
	    }
	}
	StructArrayLayout1f4.prototype.bytesPerElement = 4;
	register('StructArrayLayout1f4', StructArrayLayout1f4);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint16[1]
	 * [4]: Float32[2]
	 *
	 */
	class StructArrayLayout1ui2f12 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2);
	    }
	    emplace(i, v0, v1, v2) {
	        const o2 = i * 6;
	        const o4 = i * 3;
	        this.uint16[o2 + 0] = v0;
	        this.float32[o4 + 1] = v1;
	        this.float32[o4 + 2] = v2;
	        return i;
	    }
	}
	StructArrayLayout1ui2f12.prototype.bytesPerElement = 12;
	register('StructArrayLayout1ui2f12', StructArrayLayout1ui2f12);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint32[1]
	 * [4]: Uint16[2]
	 *
	 */
	class StructArrayLayout1ul2ui8 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.uint32 = new Uint32Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2);
	    }
	    emplace(i, v0, v1, v2) {
	        const o4 = i * 2;
	        const o2 = i * 4;
	        this.uint32[o4 + 0] = v0;
	        this.uint16[o2 + 2] = v1;
	        this.uint16[o2 + 3] = v2;
	        return i;
	    }
	}
	StructArrayLayout1ul2ui8.prototype.bytesPerElement = 8;
	register('StructArrayLayout1ul2ui8', StructArrayLayout1ul2ui8);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint16[2]
	 *
	 */
	class StructArrayLayout2ui4 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1);
	    }
	    emplace(i, v0, v1) {
	        const o2 = i * 2;
	        this.uint16[o2 + 0] = v0;
	        this.uint16[o2 + 1] = v1;
	        return i;
	    }
	}
	StructArrayLayout2ui4.prototype.bytesPerElement = 4;
	register('StructArrayLayout2ui4', StructArrayLayout2ui4);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Uint16[1]
	 *
	 */
	class StructArrayLayout1ui2 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.uint16 = new Uint16Array(this.arrayBuffer);
	    }
	    emplaceBack(v0) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0);
	    }
	    emplace(i, v0) {
	        const o2 = i * 1;
	        this.uint16[o2 + 0] = v0;
	        return i;
	    }
	}
	StructArrayLayout1ui2.prototype.bytesPerElement = 2;
	register('StructArrayLayout1ui2', StructArrayLayout1ui2);
	/**
	 * @internal
	 * Implementation of the StructArray layout:
	 * [0]: Float32[4]
	 *
	 */
	class StructArrayLayout4f16 extends StructArray {
	    _refreshViews() {
	        this.uint8 = new Uint8Array(this.arrayBuffer);
	        this.float32 = new Float32Array(this.arrayBuffer);
	    }
	    emplaceBack(v0, v1, v2, v3) {
	        const i = this.length;
	        this.resize(i + 1);
	        return this.emplace(i, v0, v1, v2, v3);
	    }
	    emplace(i, v0, v1, v2, v3) {
	        const o4 = i * 4;
	        this.float32[o4 + 0] = v0;
	        this.float32[o4 + 1] = v1;
	        this.float32[o4 + 2] = v2;
	        this.float32[o4 + 3] = v3;
	        return i;
	    }
	}
	StructArrayLayout4f16.prototype.bytesPerElement = 16;
	register('StructArrayLayout4f16', StructArrayLayout4f16);
	/** @internal */
	class CollisionBoxStruct extends Struct {
	    get anchorPointX() { return this._structArray.int16[this._pos2 + 0]; }
	    get anchorPointY() { return this._structArray.int16[this._pos2 + 1]; }
	    get x1() { return this._structArray.int16[this._pos2 + 2]; }
	    get y1() { return this._structArray.int16[this._pos2 + 3]; }
	    get x2() { return this._structArray.int16[this._pos2 + 4]; }
	    get y2() { return this._structArray.int16[this._pos2 + 5]; }
	    get featureIndex() { return this._structArray.uint32[this._pos4 + 3]; }
	    get sourceLayerIndex() { return this._structArray.uint16[this._pos2 + 8]; }
	    get bucketIndex() { return this._structArray.uint16[this._pos2 + 9]; }
	    get anchorPoint() { return new Point$2(this.anchorPointX, this.anchorPointY); }
	}
	CollisionBoxStruct.prototype.size = 20;
	/** @internal */
	class CollisionBoxArray extends StructArrayLayout6i1ul2ui20 {
	    /**
	     * Return the CollisionBoxStruct at the given location in the array.
	     * @param index The index of the element.
	     */
	    get(index) {
	        return new CollisionBoxStruct(this, index);
	    }
	}
	register('CollisionBoxArray', CollisionBoxArray);
	/** @internal */
	class PlacedSymbolStruct extends Struct {
	    get anchorX() { return this._structArray.int16[this._pos2 + 0]; }
	    get anchorY() { return this._structArray.int16[this._pos2 + 1]; }
	    get glyphStartIndex() { return this._structArray.uint16[this._pos2 + 2]; }
	    get numGlyphs() { return this._structArray.uint16[this._pos2 + 3]; }
	    get vertexStartIndex() { return this._structArray.uint32[this._pos4 + 2]; }
	    get lineStartIndex() { return this._structArray.uint32[this._pos4 + 3]; }
	    get lineLength() { return this._structArray.uint32[this._pos4 + 4]; }
	    get segment() { return this._structArray.uint16[this._pos2 + 10]; }
	    get lowerSize() { return this._structArray.uint16[this._pos2 + 11]; }
	    get upperSize() { return this._structArray.uint16[this._pos2 + 12]; }
	    get lineOffsetX() { return this._structArray.float32[this._pos4 + 7]; }
	    get lineOffsetY() { return this._structArray.float32[this._pos4 + 8]; }
	    get writingMode() { return this._structArray.uint8[this._pos1 + 36]; }
	    get placedOrientation() { return this._structArray.uint8[this._pos1 + 37]; }
	    set placedOrientation(x) { this._structArray.uint8[this._pos1 + 37] = x; }
	    get hidden() { return this._structArray.uint8[this._pos1 + 38]; }
	    set hidden(x) { this._structArray.uint8[this._pos1 + 38] = x; }
	    get crossTileID() { return this._structArray.uint32[this._pos4 + 10]; }
	    set crossTileID(x) { this._structArray.uint32[this._pos4 + 10] = x; }
	    get associatedIconIndex() { return this._structArray.int16[this._pos2 + 22]; }
	}
	PlacedSymbolStruct.prototype.size = 48;
	/** @internal */
	class PlacedSymbolArray extends StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48 {
	    /**
	     * Return the PlacedSymbolStruct at the given location in the array.
	     * @param index The index of the element.
	     */
	    get(index) {
	        return new PlacedSymbolStruct(this, index);
	    }
	}
	register('PlacedSymbolArray', PlacedSymbolArray);
	/** @internal */
	class SymbolInstanceStruct extends Struct {
	    get anchorX() { return this._structArray.int16[this._pos2 + 0]; }
	    get anchorY() { return this._structArray.int16[this._pos2 + 1]; }
	    get rightJustifiedTextSymbolIndex() { return this._structArray.int16[this._pos2 + 2]; }
	    get centerJustifiedTextSymbolIndex() { return this._structArray.int16[this._pos2 + 3]; }
	    get leftJustifiedTextSymbolIndex() { return this._structArray.int16[this._pos2 + 4]; }
	    get verticalPlacedTextSymbolIndex() { return this._structArray.int16[this._pos2 + 5]; }
	    get placedIconSymbolIndex() { return this._structArray.int16[this._pos2 + 6]; }
	    get verticalPlacedIconSymbolIndex() { return this._structArray.int16[this._pos2 + 7]; }
	    get key() { return this._structArray.uint16[this._pos2 + 8]; }
	    get textBoxStartIndex() { return this._structArray.uint16[this._pos2 + 9]; }
	    get textBoxEndIndex() { return this._structArray.uint16[this._pos2 + 10]; }
	    get verticalTextBoxStartIndex() { return this._structArray.uint16[this._pos2 + 11]; }
	    get verticalTextBoxEndIndex() { return this._structArray.uint16[this._pos2 + 12]; }
	    get iconBoxStartIndex() { return this._structArray.uint16[this._pos2 + 13]; }
	    get iconBoxEndIndex() { return this._structArray.uint16[this._pos2 + 14]; }
	    get verticalIconBoxStartIndex() { return this._structArray.uint16[this._pos2 + 15]; }
	    get verticalIconBoxEndIndex() { return this._structArray.uint16[this._pos2 + 16]; }
	    get featureIndex() { return this._structArray.uint16[this._pos2 + 17]; }
	    get numHorizontalGlyphVertices() { return this._structArray.uint16[this._pos2 + 18]; }
	    get numVerticalGlyphVertices() { return this._structArray.uint16[this._pos2 + 19]; }
	    get numIconVertices() { return this._structArray.uint16[this._pos2 + 20]; }
	    get numVerticalIconVertices() { return this._structArray.uint16[this._pos2 + 21]; }
	    get useRuntimeCollisionCircles() { return this._structArray.uint16[this._pos2 + 22]; }
	    get crossTileID() { return this._structArray.uint32[this._pos4 + 12]; }
	    set crossTileID(x) { this._structArray.uint32[this._pos4 + 12] = x; }
	    get textBoxScale() { return this._structArray.float32[this._pos4 + 13]; }
	    get collisionCircleDiameter() { return this._structArray.float32[this._pos4 + 14]; }
	    get textAnchorOffsetStartIndex() { return this._structArray.uint16[this._pos2 + 30]; }
	    get textAnchorOffsetEndIndex() { return this._structArray.uint16[this._pos2 + 31]; }
	}
	SymbolInstanceStruct.prototype.size = 64;
	/** @internal */
	class SymbolInstanceArray extends StructArrayLayout8i15ui1ul2f2ui64 {
	    /**
	     * Return the SymbolInstanceStruct at the given location in the array.
	     * @param index The index of the element.
	     */
	    get(index) {
	        return new SymbolInstanceStruct(this, index);
	    }
	}
	register('SymbolInstanceArray', SymbolInstanceArray);
	/** @internal */
	class GlyphOffsetArray extends StructArrayLayout1f4 {
	    getoffsetX(index) { return this.float32[index * 1 + 0]; }
	}
	register('GlyphOffsetArray', GlyphOffsetArray);
	/** @internal */
	class SymbolLineVertexArray extends StructArrayLayout3i6 {
	    getx(index) { return this.int16[index * 3 + 0]; }
	    gety(index) { return this.int16[index * 3 + 1]; }
	    gettileUnitDistanceFromAnchor(index) { return this.int16[index * 3 + 2]; }
	}
	register('SymbolLineVertexArray', SymbolLineVertexArray);
	/** @internal */
	class TextAnchorOffsetStruct extends Struct {
	    get textAnchor() { return this._structArray.uint16[this._pos2 + 0]; }
	    get textOffset0() { return this._structArray.float32[this._pos4 + 1]; }
	    get textOffset1() { return this._structArray.float32[this._pos4 + 2]; }
	}
	TextAnchorOffsetStruct.prototype.size = 12;
	/** @internal */
	class TextAnchorOffsetArray extends StructArrayLayout1ui2f12 {
	    /**
	     * Return the TextAnchorOffsetStruct at the given location in the array.
	     * @param index The index of the element.
	     */
	    get(index) {
	        return new TextAnchorOffsetStruct(this, index);
	    }
	}
	register('TextAnchorOffsetArray', TextAnchorOffsetArray);
	/** @internal */
	class FeatureIndexStruct extends Struct {
	    get featureIndex() { return this._structArray.uint32[this._pos4 + 0]; }
	    get sourceLayerIndex() { return this._structArray.uint16[this._pos2 + 2]; }
	    get bucketIndex() { return this._structArray.uint16[this._pos2 + 3]; }
	}
	FeatureIndexStruct.prototype.size = 8;
	/** @internal */
	class FeatureIndexArray extends StructArrayLayout1ul2ui8 {
	    /**
	     * Return the FeatureIndexStruct at the given location in the array.
	     * @param index The index of the element.
	     */
	    get(index) {
	        return new FeatureIndexStruct(this, index);
	    }
	}
	register('FeatureIndexArray', FeatureIndexArray);
	class PosArray extends StructArrayLayout2i4 {
	}
	class Pos3dArray extends StructArrayLayout3i6 {
	}
	class RasterBoundsArray extends StructArrayLayout4i8 {
	}
	class CircleLayoutArray extends StructArrayLayout2i4 {
	}
	class FillLayoutArray extends StructArrayLayout2i4 {
	}
	class FillExtrusionLayoutArray extends StructArrayLayout2i4i12 {
	}
	class LineLayoutArray extends StructArrayLayout2i4ub8 {
	}
	class LineExtLayoutArray extends StructArrayLayout2f8 {
	}
	class PatternLayoutArray extends StructArrayLayout10ui20 {
	}
	class SymbolLayoutArray extends StructArrayLayout4i4ui4i24 {
	}
	class SymbolDynamicLayoutArray extends StructArrayLayout3f12 {
	}
	class SymbolOpacityArray extends StructArrayLayout1ul4 {
	}
	class CollisionBoxLayoutArray extends StructArrayLayout2i2i2i12 {
	}
	class CollisionCircleLayoutArray extends StructArrayLayout2f1f2i16 {
	}
	class CollisionVertexArray extends StructArrayLayout2ub2f12 {
	}
	class QuadTriangleArray extends StructArrayLayout3ui6 {
	}
	class TriangleIndexArray extends StructArrayLayout3ui6 {
	}
	class LineIndexArray extends StructArrayLayout2ui4 {
	}
	class LineStripIndexArray extends StructArrayLayout1ui2 {
	}

	const layout$6 = createLayout([
	    { name: 'a_pos', components: 2, type: 'Int16' }
	], 4);
	const { members: members$4, size: size$4, alignment: alignment$4 } = layout$6;

	/**
	 * @internal
	 * Used for calculations on vector segments
	 */
	class SegmentVector {
	    constructor(segments = []) {
	        this.segments = segments;
	    }
	    prepareSegment(numVertices, layoutVertexArray, indexArray, sortKey) {
	        let segment = this.segments[this.segments.length - 1];
	        if (numVertices > SegmentVector.MAX_VERTEX_ARRAY_LENGTH)
	            warnOnce(`Max vertices per segment is ${SegmentVector.MAX_VERTEX_ARRAY_LENGTH}: bucket requested ${numVertices}`);
	        if (!segment || segment.vertexLength + numVertices > SegmentVector.MAX_VERTEX_ARRAY_LENGTH || segment.sortKey !== sortKey) {
	            segment = {
	                vertexOffset: layoutVertexArray.length,
	                primitiveOffset: indexArray.length,
	                vertexLength: 0,
	                primitiveLength: 0
	            };
	            if (sortKey !== undefined)
	                segment.sortKey = sortKey;
	            this.segments.push(segment);
	        }
	        return segment;
	    }
	    get() {
	        return this.segments;
	    }
	    destroy() {
	        for (const segment of this.segments) {
	            for (const k in segment.vaos) {
	                segment.vaos[k].destroy();
	            }
	        }
	    }
	    static simpleSegment(vertexOffset, primitiveOffset, vertexLength, primitiveLength) {
	        return new SegmentVector([{
	                vertexOffset,
	                primitiveOffset,
	                vertexLength,
	                primitiveLength,
	                vaos: {},
	                sortKey: 0
	            }]);
	    }
	}
	/**
	 * The maximum size of a vertex array. This limit is imposed by WebGL's 16 bit
	 * addressing of vertex buffers.
	 */
	SegmentVector.MAX_VERTEX_ARRAY_LENGTH = Math.pow(2, 16) - 1;
	register('SegmentVector', SegmentVector);

	/**
	 * Packs two numbers, interpreted as 8-bit unsigned integers, into a single
	 * float.  Unpack them in the shader using the `unpack_float()` function,
	 * defined in _prelude.vertex.glsl
	 */
	function packUint8ToFloat(a, b) {
	    // coerce a and b to 8-bit ints
	    a = clamp$1(Math.floor(a), 0, 255);
	    b = clamp$1(Math.floor(b), 0, 255);
	    return 256 * a + b;
	}

	const patternAttributes = createLayout([
	    // [tl.x, tl.y, br.x, br.y]
	    { name: 'a_pattern_from', components: 4, type: 'Uint16' },
	    { name: 'a_pattern_to', components: 4, type: 'Uint16' },
	    { name: 'a_pixel_ratio_from', components: 1, type: 'Uint16' },
	    { name: 'a_pixel_ratio_to', components: 1, type: 'Uint16' },
	]);

	var murmurhashJs$1 = {exports: {}};

	var murmurhash3_gc$2 = {exports: {}};

	(function (module) {
		function murmurhash3_32_gc(key, seed) {
			var remainder, bytes, h1, h1b, c1, c2, k1, i;
			
			remainder = key.length & 3; // key.length % 4
			bytes = key.length - remainder;
			h1 = seed;
			c1 = 0xcc9e2d51;
			c2 = 0x1b873593;
			i = 0;
			
			while (i < bytes) {
			  	k1 = 
			  	  ((key.charCodeAt(i) & 0xff)) |
			  	  ((key.charCodeAt(++i) & 0xff) << 8) |
			  	  ((key.charCodeAt(++i) & 0xff) << 16) |
			  	  ((key.charCodeAt(++i) & 0xff) << 24);
				++i;
				
				k1 = ((((k1 & 0xffff) * c1) + ((((k1 >>> 16) * c1) & 0xffff) << 16))) & 0xffffffff;
				k1 = (k1 << 15) | (k1 >>> 17);
				k1 = ((((k1 & 0xffff) * c2) + ((((k1 >>> 16) * c2) & 0xffff) << 16))) & 0xffffffff;

				h1 ^= k1;
		        h1 = (h1 << 13) | (h1 >>> 19);
				h1b = ((((h1 & 0xffff) * 5) + ((((h1 >>> 16) * 5) & 0xffff) << 16))) & 0xffffffff;
				h1 = (((h1b & 0xffff) + 0x6b64) + ((((h1b >>> 16) + 0xe654) & 0xffff) << 16));
			}
			
			k1 = 0;
			
			switch (remainder) {
				case 3: k1 ^= (key.charCodeAt(i + 2) & 0xff) << 16;
				case 2: k1 ^= (key.charCodeAt(i + 1) & 0xff) << 8;
				case 1: k1 ^= (key.charCodeAt(i) & 0xff);
				
				k1 = (((k1 & 0xffff) * c1) + ((((k1 >>> 16) * c1) & 0xffff) << 16)) & 0xffffffff;
				k1 = (k1 << 15) | (k1 >>> 17);
				k1 = (((k1 & 0xffff) * c2) + ((((k1 >>> 16) * c2) & 0xffff) << 16)) & 0xffffffff;
				h1 ^= k1;
			}
			
			h1 ^= key.length;

			h1 ^= h1 >>> 16;
			h1 = (((h1 & 0xffff) * 0x85ebca6b) + ((((h1 >>> 16) * 0x85ebca6b) & 0xffff) << 16)) & 0xffffffff;
			h1 ^= h1 >>> 13;
			h1 = ((((h1 & 0xffff) * 0xc2b2ae35) + ((((h1 >>> 16) * 0xc2b2ae35) & 0xffff) << 16))) & 0xffffffff;
			h1 ^= h1 >>> 16;

			return h1 >>> 0;
		}

		{
		  module.exports = murmurhash3_32_gc;
		} 
	} (murmurhash3_gc$2));

	var murmurhash3_gcExports = murmurhash3_gc$2.exports;

	var murmurhash2_gc$2 = {exports: {}};

	(function (module) {
		function murmurhash2_32_gc(str, seed) {
		  var
		    l = str.length,
		    h = seed ^ l,
		    i = 0,
		    k;
		  
		  while (l >= 4) {
		  	k = 
		  	  ((str.charCodeAt(i) & 0xff)) |
		  	  ((str.charCodeAt(++i) & 0xff) << 8) |
		  	  ((str.charCodeAt(++i) & 0xff) << 16) |
		  	  ((str.charCodeAt(++i) & 0xff) << 24);
		    
		    k = (((k & 0xffff) * 0x5bd1e995) + ((((k >>> 16) * 0x5bd1e995) & 0xffff) << 16));
		    k ^= k >>> 24;
		    k = (((k & 0xffff) * 0x5bd1e995) + ((((k >>> 16) * 0x5bd1e995) & 0xffff) << 16));

			h = (((h & 0xffff) * 0x5bd1e995) + ((((h >>> 16) * 0x5bd1e995) & 0xffff) << 16)) ^ k;

		    l -= 4;
		    ++i;
		  }
		  
		  switch (l) {
		  case 3: h ^= (str.charCodeAt(i + 2) & 0xff) << 16;
		  case 2: h ^= (str.charCodeAt(i + 1) & 0xff) << 8;
		  case 1: h ^= (str.charCodeAt(i) & 0xff);
		          h = (((h & 0xffff) * 0x5bd1e995) + ((((h >>> 16) * 0x5bd1e995) & 0xffff) << 16));
		  }

		  h ^= h >>> 13;
		  h = (((h & 0xffff) * 0x5bd1e995) + ((((h >>> 16) * 0x5bd1e995) & 0xffff) << 16));
		  h ^= h >>> 15;

		  return h >>> 0;
		}

		{
		  module.exports = murmurhash2_32_gc;
		} 
	} (murmurhash2_gc$2));

	var murmurhash2_gcExports = murmurhash2_gc$2.exports;

	var murmur3 = murmurhash3_gcExports;
	var murmur2 = murmurhash2_gcExports;

	murmurhashJs$1.exports = murmur3;
	murmurhashJs$1.exports.murmur3 = murmur3;
	murmurhashJs$1.exports.murmur2 = murmur2;

	var murmurhashJsExports = murmurhashJs$1.exports;
	var murmur3$1 = /*@__PURE__*/getDefaultExportFromCjs$1(murmurhashJsExports);

	// A transferable data structure that maps feature ids to their indices and buffer offsets
	class FeaturePositionMap {
	    constructor() {
	        this.ids = [];
	        this.positions = [];
	        this.indexed = false;
	    }
	    add(id, index, start, end) {
	        this.ids.push(getNumericId(id));
	        this.positions.push(index, start, end);
	    }
	    getPositions(id) {
	        if (!this.indexed)
	            throw new Error('Trying to get index, but feature positions are not indexed');
	        const intId = getNumericId(id);
	        // binary search for the first occurrence of id in this.ids;
	        // relies on ids/positions being sorted by id, which happens in serialization
	        let i = 0;
	        let j = this.ids.length - 1;
	        while (i < j) {
	            const m = (i + j) >> 1;
	            if (this.ids[m] >= intId) {
	                j = m;
	            }
	            else {
	                i = m + 1;
	            }
	        }
	        const positions = [];
	        while (this.ids[i] === intId) {
	            const index = this.positions[3 * i];
	            const start = this.positions[3 * i + 1];
	            const end = this.positions[3 * i + 2];
	            positions.push({ index, start, end });
	            i++;
	        }
	        return positions;
	    }
	    static serialize(map, transferables) {
	        const ids = new Float64Array(map.ids);
	        const positions = new Uint32Array(map.positions);
	        sort$1(ids, positions, 0, ids.length - 1);
	        if (transferables) {
	            transferables.push(ids.buffer, positions.buffer);
	        }
	        return { ids, positions };
	    }
	    static deserialize(obj) {
	        const map = new FeaturePositionMap();
	        // after transferring, we only use these arrays statically (no pushes),
	        // so TypedArray vs Array distinction that flow points out doesn't matter
	        map.ids = obj.ids;
	        map.positions = obj.positions;
	        map.indexed = true;
	        return map;
	    }
	}
	function getNumericId(value) {
	    const numValue = +value;
	    if (!isNaN(numValue) && numValue <= Number.MAX_SAFE_INTEGER) {
	        return numValue;
	    }
	    return murmur3$1(String(value));
	}
	// custom quicksort that sorts ids, indices and offsets together (by ids)
	// uses Hoare partitioning & manual tail call optimization to avoid worst case scenarios
	function sort$1(ids, positions, left, right) {
	    while (left < right) {
	        const pivot = ids[(left + right) >> 1];
	        let i = left - 1;
	        let j = right + 1;
	        while (true) {
	            do
	                i++;
	            while (ids[i] < pivot);
	            do
	                j--;
	            while (ids[j] > pivot);
	            if (i >= j)
	                break;
	            swap$2(ids, i, j);
	            swap$2(positions, 3 * i, 3 * j);
	            swap$2(positions, 3 * i + 1, 3 * j + 1);
	            swap$2(positions, 3 * i + 2, 3 * j + 2);
	        }
	        if (j - left < right - j) {
	            sort$1(ids, positions, left, j);
	            left = j + 1;
	        }
	        else {
	            sort$1(ids, positions, j + 1, right);
	            right = j;
	        }
	    }
	}
	function swap$2(arr, i, j) {
	    const tmp = arr[i];
	    arr[i] = arr[j];
	    arr[j] = tmp;
	}
	register('FeaturePositionMap', FeaturePositionMap);

	/**
	 * @internal
	 * A base uniform abstract class
	 */
	class Uniform {
	    constructor(context, location) {
	        this.gl = context.gl;
	        this.location = location;
	    }
	}
	class Uniform1i extends Uniform {
	    constructor(context, location) {
	        super(context, location);
	        this.current = 0;
	    }
	    set(v) {
	        if (this.current !== v) {
	            this.current = v;
	            this.gl.uniform1i(this.location, v);
	        }
	    }
	}
	class Uniform1f extends Uniform {
	    constructor(context, location) {
	        super(context, location);
	        this.current = 0;
	    }
	    set(v) {
	        if (this.current !== v) {
	            this.current = v;
	            this.gl.uniform1f(this.location, v);
	        }
	    }
	}
	class Uniform2f extends Uniform {
	    constructor(context, location) {
	        super(context, location);
	        this.current = [0, 0];
	    }
	    set(v) {
	        if (v[0] !== this.current[0] || v[1] !== this.current[1]) {
	            this.current = v;
	            this.gl.uniform2f(this.location, v[0], v[1]);
	        }
	    }
	}
	class Uniform3f extends Uniform {
	    constructor(context, location) {
	        super(context, location);
	        this.current = [0, 0, 0];
	    }
	    set(v) {
	        if (v[0] !== this.current[0] || v[1] !== this.current[1] || v[2] !== this.current[2]) {
	            this.current = v;
	            this.gl.uniform3f(this.location, v[0], v[1], v[2]);
	        }
	    }
	}
	class Uniform4f extends Uniform {
	    constructor(context, location) {
	        super(context, location);
	        this.current = [0, 0, 0, 0];
	    }
	    set(v) {
	        if (v[0] !== this.current[0] || v[1] !== this.current[1] ||
	            v[2] !== this.current[2] || v[3] !== this.current[3]) {
	            this.current = v;
	            this.gl.uniform4f(this.location, v[0], v[1], v[2], v[3]);
	        }
	    }
	}
	class UniformColor extends Uniform {
	    constructor(context, location) {
	        super(context, location);
	        this.current = Color.transparent;
	    }
	    set(v) {
	        if (v.r !== this.current.r || v.g !== this.current.g ||
	            v.b !== this.current.b || v.a !== this.current.a) {
	            this.current = v;
	            this.gl.uniform4f(this.location, v.r, v.g, v.b, v.a);
	        }
	    }
	}
	const emptyMat4 = new Float32Array(16);
	class UniformMatrix4f extends Uniform {
	    constructor(context, location) {
	        super(context, location);
	        this.current = emptyMat4;
	    }
	    set(v) {
	        // The vast majority of matrix comparisons that will trip this set
	        // happen at i=12 or i=0, so we check those first to avoid lots of
	        // unnecessary iteration:
	        if (v[12] !== this.current[12] || v[0] !== this.current[0]) {
	            this.current = v;
	            this.gl.uniformMatrix4fv(this.location, false, v);
	            return;
	        }
	        for (let i = 1; i < 16; i++) {
	            if (v[i] !== this.current[i]) {
	                this.current = v;
	                this.gl.uniformMatrix4fv(this.location, false, v);
	                break;
	            }
	        }
	    }
	}

	function packColor(color) {
	    return [
	        packUint8ToFloat(255 * color.r, 255 * color.g),
	        packUint8ToFloat(255 * color.b, 255 * color.a)
	    ];
	}
	class ConstantBinder {
	    constructor(value, names, type) {
	        this.value = value;
	        this.uniformNames = names.map(name => `u_${name}`);
	        this.type = type;
	    }
	    setUniform(uniform, globals, currentValue) {
	        uniform.set(currentValue.constantOr(this.value));
	    }
	    getBinding(context, location, _) {
	        return (this.type === 'color') ?
	            new UniformColor(context, location) :
	            new Uniform1f(context, location);
	    }
	}
	class CrossFadedConstantBinder {
	    constructor(value, names) {
	        this.uniformNames = names.map(name => `u_${name}`);
	        this.patternFrom = null;
	        this.patternTo = null;
	        this.pixelRatioFrom = 1.0;
	        this.pixelRatioTo = 1.0;
	    }
	    setConstantPatternPositions(posTo, posFrom) {
	        this.pixelRatioFrom = posFrom.pixelRatio;
	        this.pixelRatioTo = posTo.pixelRatio;
	        this.patternFrom = posFrom.tlbr;
	        this.patternTo = posTo.tlbr;
	    }
	    setUniform(uniform, globals, currentValue, uniformName) {
	        const pos = uniformName === 'u_pattern_to' ? this.patternTo :
	            uniformName === 'u_pattern_from' ? this.patternFrom :
	                uniformName === 'u_pixel_ratio_to' ? this.pixelRatioTo :
	                    uniformName === 'u_pixel_ratio_from' ? this.pixelRatioFrom : null;
	        if (pos)
	            uniform.set(pos);
	    }
	    getBinding(context, location, name) {
	        return name.substr(0, 9) === 'u_pattern' ?
	            new Uniform4f(context, location) :
	            new Uniform1f(context, location);
	    }
	}
	class SourceExpressionBinder {
	    constructor(expression, names, type, PaintVertexArray) {
	        this.expression = expression;
	        this.type = type;
	        this.maxValue = 0;
	        this.paintVertexAttributes = names.map((name) => ({
	            name: `a_${name}`,
	            type: 'Float32',
	            components: type === 'color' ? 2 : 1,
	            offset: 0
	        }));
	        this.paintVertexArray = new PaintVertexArray();
	    }
	    populatePaintArray(newLength, feature, imagePositions, canonical, formattedSection) {
	        const start = this.paintVertexArray.length;
	        const value = this.expression.evaluate(new EvaluationParameters(0), feature, {}, canonical, [], formattedSection);
	        this.paintVertexArray.resize(newLength);
	        this._setPaintValue(start, newLength, value);
	    }
	    updatePaintArray(start, end, feature, featureState) {
	        const value = this.expression.evaluate({ zoom: 0 }, feature, featureState);
	        this._setPaintValue(start, end, value);
	    }
	    _setPaintValue(start, end, value) {
	        if (this.type === 'color') {
	            const color = packColor(value);
	            for (let i = start; i < end; i++) {
	                this.paintVertexArray.emplace(i, color[0], color[1]);
	            }
	        }
	        else {
	            for (let i = start; i < end; i++) {
	                this.paintVertexArray.emplace(i, value);
	            }
	            this.maxValue = Math.max(this.maxValue, Math.abs(value));
	        }
	    }
	    upload(context) {
	        if (this.paintVertexArray && this.paintVertexArray.arrayBuffer) {
	            if (this.paintVertexBuffer && this.paintVertexBuffer.buffer) {
	                this.paintVertexBuffer.updateData(this.paintVertexArray);
	            }
	            else {
	                this.paintVertexBuffer = context.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent);
	            }
	        }
	    }
	    destroy() {
	        if (this.paintVertexBuffer) {
	            this.paintVertexBuffer.destroy();
	        }
	    }
	}
	class CompositeExpressionBinder {
	    constructor(expression, names, type, useIntegerZoom, zoom, PaintVertexArray) {
	        this.expression = expression;
	        this.uniformNames = names.map(name => `u_${name}_t`);
	        this.type = type;
	        this.useIntegerZoom = useIntegerZoom;
	        this.zoom = zoom;
	        this.maxValue = 0;
	        this.paintVertexAttributes = names.map((name) => ({
	            name: `a_${name}`,
	            type: 'Float32',
	            components: type === 'color' ? 4 : 2,
	            offset: 0
	        }));
	        this.paintVertexArray = new PaintVertexArray();
	    }
	    populatePaintArray(newLength, feature, imagePositions, canonical, formattedSection) {
	        const min = this.expression.evaluate(new EvaluationParameters(this.zoom), feature, {}, canonical, [], formattedSection);
	        const max = this.expression.evaluate(new EvaluationParameters(this.zoom + 1), feature, {}, canonical, [], formattedSection);
	        const start = this.paintVertexArray.length;
	        this.paintVertexArray.resize(newLength);
	        this._setPaintValue(start, newLength, min, max);
	    }
	    updatePaintArray(start, end, feature, featureState) {
	        const min = this.expression.evaluate({ zoom: this.zoom }, feature, featureState);
	        const max = this.expression.evaluate({ zoom: this.zoom + 1 }, feature, featureState);
	        this._setPaintValue(start, end, min, max);
	    }
	    _setPaintValue(start, end, min, max) {
	        if (this.type === 'color') {
	            const minColor = packColor(min);
	            const maxColor = packColor(max);
	            for (let i = start; i < end; i++) {
	                this.paintVertexArray.emplace(i, minColor[0], minColor[1], maxColor[0], maxColor[1]);
	            }
	        }
	        else {
	            for (let i = start; i < end; i++) {
	                this.paintVertexArray.emplace(i, min, max);
	            }
	            this.maxValue = Math.max(this.maxValue, Math.abs(min), Math.abs(max));
	        }
	    }
	    upload(context) {
	        if (this.paintVertexArray && this.paintVertexArray.arrayBuffer) {
	            if (this.paintVertexBuffer && this.paintVertexBuffer.buffer) {
	                this.paintVertexBuffer.updateData(this.paintVertexArray);
	            }
	            else {
	                this.paintVertexBuffer = context.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent);
	            }
	        }
	    }
	    destroy() {
	        if (this.paintVertexBuffer) {
	            this.paintVertexBuffer.destroy();
	        }
	    }
	    setUniform(uniform, globals) {
	        const currentZoom = this.useIntegerZoom ? Math.floor(globals.zoom) : globals.zoom;
	        const factor = clamp$1(this.expression.interpolationFactor(currentZoom, this.zoom, this.zoom + 1), 0, 1);
	        uniform.set(factor);
	    }
	    getBinding(context, location, _) {
	        return new Uniform1f(context, location);
	    }
	}
	class CrossFadedCompositeBinder {
	    constructor(expression, type, useIntegerZoom, zoom, PaintVertexArray, layerId) {
	        this.expression = expression;
	        this.type = type;
	        this.useIntegerZoom = useIntegerZoom;
	        this.zoom = zoom;
	        this.layerId = layerId;
	        this.zoomInPaintVertexArray = new PaintVertexArray();
	        this.zoomOutPaintVertexArray = new PaintVertexArray();
	    }
	    populatePaintArray(length, feature, imagePositions) {
	        const start = this.zoomInPaintVertexArray.length;
	        this.zoomInPaintVertexArray.resize(length);
	        this.zoomOutPaintVertexArray.resize(length);
	        this._setPaintValues(start, length, feature.patterns && feature.patterns[this.layerId], imagePositions);
	    }
	    updatePaintArray(start, end, feature, featureState, imagePositions) {
	        this._setPaintValues(start, end, feature.patterns && feature.patterns[this.layerId], imagePositions);
	    }
	    _setPaintValues(start, end, patterns, positions) {
	        if (!positions || !patterns)
	            return;
	        const { min, mid, max } = patterns;
	        const imageMin = positions[min];
	        const imageMid = positions[mid];
	        const imageMax = positions[max];
	        if (!imageMin || !imageMid || !imageMax)
	            return;
	        // We populate two paint arrays because, for cross-faded properties, we don't know which direction
	        // we're cross-fading to at layout time. In order to keep vertex attributes to a minimum and not pass
	        // unnecessary vertex data to the shaders, we determine which to upload at draw time.
	        for (let i = start; i < end; i++) {
	            this.zoomInPaintVertexArray.emplace(i, imageMid.tl[0], imageMid.tl[1], imageMid.br[0], imageMid.br[1], imageMin.tl[0], imageMin.tl[1], imageMin.br[0], imageMin.br[1], imageMid.pixelRatio, imageMin.pixelRatio);
	            this.zoomOutPaintVertexArray.emplace(i, imageMid.tl[0], imageMid.tl[1], imageMid.br[0], imageMid.br[1], imageMax.tl[0], imageMax.tl[1], imageMax.br[0], imageMax.br[1], imageMid.pixelRatio, imageMax.pixelRatio);
	        }
	    }
	    upload(context) {
	        if (this.zoomInPaintVertexArray && this.zoomInPaintVertexArray.arrayBuffer && this.zoomOutPaintVertexArray && this.zoomOutPaintVertexArray.arrayBuffer) {
	            this.zoomInPaintVertexBuffer = context.createVertexBuffer(this.zoomInPaintVertexArray, patternAttributes.members, this.expression.isStateDependent);
	            this.zoomOutPaintVertexBuffer = context.createVertexBuffer(this.zoomOutPaintVertexArray, patternAttributes.members, this.expression.isStateDependent);
	        }
	    }
	    destroy() {
	        if (this.zoomOutPaintVertexBuffer)
	            this.zoomOutPaintVertexBuffer.destroy();
	        if (this.zoomInPaintVertexBuffer)
	            this.zoomInPaintVertexBuffer.destroy();
	    }
	}
	/**
	 * @internal
	 * ProgramConfiguration contains the logic for binding style layer properties and tile
	 * layer feature data into GL program uniforms and vertex attributes.
	 *
	 * Non-data-driven property values are bound to shader uniforms. Data-driven property
	 * values are bound to vertex attributes. In order to support a uniform GLSL syntax over
	 * both, [Mapbox GL Shaders](https://github.com/mapbox/mapbox-gl-shaders) defines a `#pragma`
	 * abstraction, which ProgramConfiguration is responsible for implementing. At runtime,
	 * it examines the attributes of a particular layer, combines this with fixed knowledge
	 * about how layers of the particular type are implemented, and determines which uniforms
	 * and vertex attributes will be required. It can then substitute the appropriate text
	 * into the shader source code, create and link a program, and bind the uniforms and
	 * vertex attributes in preparation for drawing.
	 *
	 * When a vector tile is parsed, this same configuration information is used to
	 * populate the attribute buffers needed for data-driven styling using the zoom
	 * level and feature property data.
	 */
	class ProgramConfiguration {
	    constructor(layer, zoom, filterProperties) {
	        this.binders = {};
	        this._buffers = [];
	        const keys = [];
	        for (const property in layer.paint._values) {
	            if (!filterProperties(property))
	                continue;
	            const value = layer.paint.get(property);
	            if (!(value instanceof PossiblyEvaluatedPropertyValue) || !supportsPropertyExpression(value.property.specification)) {
	                continue;
	            }
	            const names = paintAttributeNames(property, layer.type);
	            const expression = value.value;
	            const type = value.property.specification.type;
	            const useIntegerZoom = value.property.useIntegerZoom;
	            const propType = value.property.specification['property-type'];
	            const isCrossFaded = propType === 'cross-faded' || propType === 'cross-faded-data-driven';
	            if (expression.kind === 'constant') {
	                this.binders[property] = isCrossFaded ?
	                    new CrossFadedConstantBinder(expression.value, names) :
	                    new ConstantBinder(expression.value, names, type);
	                keys.push(`/u_${property}`);
	            }
	            else if (expression.kind === 'source' || isCrossFaded) {
	                const StructArrayLayout = layoutType(property, type, 'source');
	                this.binders[property] = isCrossFaded ?
	                    new CrossFadedCompositeBinder(expression, type, useIntegerZoom, zoom, StructArrayLayout, layer.id) :
	                    new SourceExpressionBinder(expression, names, type, StructArrayLayout);
	                keys.push(`/a_${property}`);
	            }
	            else {
	                const StructArrayLayout = layoutType(property, type, 'composite');
	                this.binders[property] = new CompositeExpressionBinder(expression, names, type, useIntegerZoom, zoom, StructArrayLayout);
	                keys.push(`/z_${property}`);
	            }
	        }
	        this.cacheKey = keys.sort().join('');
	    }
	    getMaxValue(property) {
	        const binder = this.binders[property];
	        return binder instanceof SourceExpressionBinder || binder instanceof CompositeExpressionBinder ? binder.maxValue : 0;
	    }
	    populatePaintArrays(newLength, feature, imagePositions, canonical, formattedSection) {
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof SourceExpressionBinder || binder instanceof CompositeExpressionBinder || binder instanceof CrossFadedCompositeBinder)
	                binder.populatePaintArray(newLength, feature, imagePositions, canonical, formattedSection);
	        }
	    }
	    setConstantPatternPositions(posTo, posFrom) {
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof CrossFadedConstantBinder)
	                binder.setConstantPatternPositions(posTo, posFrom);
	        }
	    }
	    updatePaintArrays(featureStates, featureMap, vtLayer, layer, imagePositions) {
	        let dirty = false;
	        for (const id in featureStates) {
	            const positions = featureMap.getPositions(id);
	            for (const pos of positions) {
	                const feature = vtLayer.feature(pos.index);
	                for (const property in this.binders) {
	                    const binder = this.binders[property];
	                    if ((binder instanceof SourceExpressionBinder || binder instanceof CompositeExpressionBinder ||
	                        binder instanceof CrossFadedCompositeBinder) && binder.expression.isStateDependent === true) {
	                        //AHM: Remove after https://github.com/mapbox/mapbox-gl-js/issues/6255
	                        const value = layer.paint.get(property);
	                        binder.expression = value.value;
	                        binder.updatePaintArray(pos.start, pos.end, feature, featureStates[id], imagePositions);
	                        dirty = true;
	                    }
	                }
	            }
	        }
	        return dirty;
	    }
	    defines() {
	        const result = [];
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof ConstantBinder || binder instanceof CrossFadedConstantBinder) {
	                result.push(...binder.uniformNames.map(name => `#define HAS_UNIFORM_${name}`));
	            }
	        }
	        return result;
	    }
	    getBinderAttributes() {
	        const result = [];
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof SourceExpressionBinder || binder instanceof CompositeExpressionBinder) {
	                for (let i = 0; i < binder.paintVertexAttributes.length; i++) {
	                    result.push(binder.paintVertexAttributes[i].name);
	                }
	            }
	            else if (binder instanceof CrossFadedCompositeBinder) {
	                for (let i = 0; i < patternAttributes.members.length; i++) {
	                    result.push(patternAttributes.members[i].name);
	                }
	            }
	        }
	        return result;
	    }
	    getBinderUniforms() {
	        const uniforms = [];
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof ConstantBinder || binder instanceof CrossFadedConstantBinder || binder instanceof CompositeExpressionBinder) {
	                for (const uniformName of binder.uniformNames) {
	                    uniforms.push(uniformName);
	                }
	            }
	        }
	        return uniforms;
	    }
	    getPaintVertexBuffers() {
	        return this._buffers;
	    }
	    getUniforms(context, locations) {
	        const uniforms = [];
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof ConstantBinder || binder instanceof CrossFadedConstantBinder || binder instanceof CompositeExpressionBinder) {
	                for (const name of binder.uniformNames) {
	                    if (locations[name]) {
	                        const binding = binder.getBinding(context, locations[name], name);
	                        uniforms.push({ name, property, binding });
	                    }
	                }
	            }
	        }
	        return uniforms;
	    }
	    setUniforms(context, binderUniforms, properties, globals) {
	        // Uniform state bindings are owned by the Program, but we set them
	        // from within the ProgramConfiguraton's binder members.
	        for (const { name, property, binding } of binderUniforms) {
	            this.binders[property].setUniform(binding, globals, properties.get(property), name);
	        }
	    }
	    updatePaintBuffers(crossfade) {
	        this._buffers = [];
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (crossfade && binder instanceof CrossFadedCompositeBinder) {
	                const patternVertexBuffer = crossfade.fromScale === 2 ? binder.zoomInPaintVertexBuffer : binder.zoomOutPaintVertexBuffer;
	                if (patternVertexBuffer)
	                    this._buffers.push(patternVertexBuffer);
	            }
	            else if ((binder instanceof SourceExpressionBinder || binder instanceof CompositeExpressionBinder) && binder.paintVertexBuffer) {
	                this._buffers.push(binder.paintVertexBuffer);
	            }
	        }
	    }
	    upload(context) {
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof SourceExpressionBinder || binder instanceof CompositeExpressionBinder || binder instanceof CrossFadedCompositeBinder)
	                binder.upload(context);
	        }
	        this.updatePaintBuffers();
	    }
	    destroy() {
	        for (const property in this.binders) {
	            const binder = this.binders[property];
	            if (binder instanceof SourceExpressionBinder || binder instanceof CompositeExpressionBinder || binder instanceof CrossFadedCompositeBinder)
	                binder.destroy();
	        }
	    }
	}
	class ProgramConfigurationSet {
	    constructor(layers, zoom, filterProperties = () => true) {
	        this.programConfigurations = {};
	        for (const layer of layers) {
	            this.programConfigurations[layer.id] = new ProgramConfiguration(layer, zoom, filterProperties);
	        }
	        this.needsUpload = false;
	        this._featureMap = new FeaturePositionMap();
	        this._bufferOffset = 0;
	    }
	    populatePaintArrays(length, feature, index, imagePositions, canonical, formattedSection) {
	        for (const key in this.programConfigurations) {
	            this.programConfigurations[key].populatePaintArrays(length, feature, imagePositions, canonical, formattedSection);
	        }
	        if (feature.id !== undefined) {
	            this._featureMap.add(feature.id, index, this._bufferOffset, length);
	        }
	        this._bufferOffset = length;
	        this.needsUpload = true;
	    }
	    updatePaintArrays(featureStates, vtLayer, layers, imagePositions) {
	        for (const layer of layers) {
	            this.needsUpload = this.programConfigurations[layer.id].updatePaintArrays(featureStates, this._featureMap, vtLayer, layer, imagePositions) || this.needsUpload;
	        }
	    }
	    get(layerId) {
	        return this.programConfigurations[layerId];
	    }
	    upload(context) {
	        if (!this.needsUpload)
	            return;
	        for (const layerId in this.programConfigurations) {
	            this.programConfigurations[layerId].upload(context);
	        }
	        this.needsUpload = false;
	    }
	    destroy() {
	        for (const layerId in this.programConfigurations) {
	            this.programConfigurations[layerId].destroy();
	        }
	    }
	}
	function paintAttributeNames(property, type) {
	    const attributeNameExceptions = {
	        'text-opacity': ['opacity'],
	        'icon-opacity': ['opacity'],
	        'text-color': ['fill_color'],
	        'icon-color': ['fill_color'],
	        'text-halo-color': ['halo_color'],
	        'icon-halo-color': ['halo_color'],
	        'text-halo-blur': ['halo_blur'],
	        'icon-halo-blur': ['halo_blur'],
	        'text-halo-width': ['halo_width'],
	        'icon-halo-width': ['halo_width'],
	        'line-gap-width': ['gapwidth'],
	        'line-pattern': ['pattern_to', 'pattern_from', 'pixel_ratio_to', 'pixel_ratio_from'],
	        'fill-pattern': ['pattern_to', 'pattern_from', 'pixel_ratio_to', 'pixel_ratio_from'],
	        'fill-extrusion-pattern': ['pattern_to', 'pattern_from', 'pixel_ratio_to', 'pixel_ratio_from'],
	    };
	    return attributeNameExceptions[property] || [property.replace(`${type}-`, '').replace(/-/g, '_')];
	}
	function getLayoutException(property) {
	    const propertyExceptions = {
	        'line-pattern': {
	            'source': PatternLayoutArray,
	            'composite': PatternLayoutArray
	        },
	        'fill-pattern': {
	            'source': PatternLayoutArray,
	            'composite': PatternLayoutArray
	        },
	        'fill-extrusion-pattern': {
	            'source': PatternLayoutArray,
	            'composite': PatternLayoutArray
	        }
	    };
	    return propertyExceptions[property];
	}
	function layoutType(property, type, binderType) {
	    const defaultLayouts = {
	        'color': {
	            'source': StructArrayLayout2f8,
	            'composite': StructArrayLayout4f16
	        },
	        'number': {
	            'source': StructArrayLayout1f4,
	            'composite': StructArrayLayout2f8
	        }
	    };
	    const layoutException = getLayoutException(property);
	    return layoutException && layoutException[binderType] || defaultLayouts[type][binderType];
	}
	register('ConstantBinder', ConstantBinder);
	register('CrossFadedConstantBinder', CrossFadedConstantBinder);
	register('SourceExpressionBinder', SourceExpressionBinder);
	register('CrossFadedCompositeBinder', CrossFadedCompositeBinder);
	register('CompositeExpressionBinder', CompositeExpressionBinder);
	register('ProgramConfiguration', ProgramConfiguration, { omit: ['_buffers'] });
	register('ProgramConfigurationSet', ProgramConfigurationSet);

	/**
	 * The maximum value of a coordinate in the internal tile coordinate system. Coordinates of
	 * all source features normalized to this extent upon load.
	 *
	 * The value is a consequence of the following:
	 *
	 * * Vertex buffer store positions as signed 16 bit integers.
	 * * One bit is lost for signedness to support tile buffers.
	 * * One bit is lost because the line vertex buffer used to pack 1 bit of other data into the int.
	 * * One bit is lost to support features extending past the extent on the right edge of the tile.
	 * * This leaves us with 2^13 = 8192
	 */
	const EXTENT = 8192;

	// These bounds define the minimum and maximum supported coordinate values.
	// While visible coordinates are within [0, EXTENT], tiles may theoretically
	// contain coordinates within [-Infinity, Infinity]. Our range is limited by the
	// number of bits used to represent the coordinate.
	const BITS = 15;
	const MAX = Math.pow(2, BITS - 1) - 1;
	const MIN = -MAX - 1;
	/**
	 * Loads a geometry from a VectorTileFeature and scales it to the common extent
	 * used internally.
	 * @param feature - the vector tile feature to load
	 */
	function loadGeometry(feature) {
	    const scale = EXTENT / feature.extent;
	    const geometry = feature.loadGeometry();
	    for (let r = 0; r < geometry.length; r++) {
	        const ring = geometry[r];
	        for (let p = 0; p < ring.length; p++) {
	            const point = ring[p];
	            // round here because mapbox-gl-native uses integers to represent
	            // points and we need to do the same to avoid renering differences.
	            const x = Math.round(point.x * scale);
	            const y = Math.round(point.y * scale);
	            point.x = clamp$1(x, MIN, MAX);
	            point.y = clamp$1(y, MIN, MAX);
	            if (x < point.x || x > point.x + 1 || y < point.y || y > point.y + 1) {
	                // warn when exceeding allowed extent except for the 1-px-off case
	                // https://github.com/mapbox/mapbox-gl-js/issues/8992
	                warnOnce('Geometry exceeds allowed extent, reduce your vector tile buffer size');
	            }
	        }
	    }
	    return geometry;
	}

	/**
	 * Construct a new feature based on a VectorTileFeature for expression evaluation, the geometry of which
	 * will be loaded based on necessity.
	 * @param feature - the feature to evaluate
	 * @param needGeometry - if set to true this will load the geometry
	 */
	function toEvaluationFeature(feature, needGeometry) {
	    return { type: feature.type,
	        id: feature.id,
	        properties: feature.properties,
	        geometry: needGeometry ? loadGeometry(feature) : [] };
	}

	function addCircleVertex(layoutVertexArray, x, y, extrudeX, extrudeY) {
	    layoutVertexArray.emplaceBack((x * 2) + ((extrudeX + 1) / 2), (y * 2) + ((extrudeY + 1) / 2));
	}
	/**
	 * @internal
	 * Circles are represented by two triangles.
	 *
	 * Each corner has a pos that is the center of the circle and an extrusion
	 * vector that is where it points.
	 */
	class CircleBucket {
	    constructor(options) {
	        this.zoom = options.zoom;
	        this.overscaling = options.overscaling;
	        this.layers = options.layers;
	        this.layerIds = this.layers.map(layer => layer.id);
	        this.index = options.index;
	        this.hasPattern = false;
	        this.layoutVertexArray = new CircleLayoutArray();
	        this.indexArray = new TriangleIndexArray();
	        this.segments = new SegmentVector();
	        this.programConfigurations = new ProgramConfigurationSet(options.layers, options.zoom);
	        this.stateDependentLayerIds = this.layers.filter((l) => l.isStateDependent()).map((l) => l.id);
	    }
	    populate(features, options, canonical) {
	        const styleLayer = this.layers[0];
	        const bucketFeatures = [];
	        let circleSortKey = null;
	        let sortFeaturesByKey = false;
	        // Heatmap layers are handled in this bucket and have no evaluated properties, so we check our access
	        if (styleLayer.type === 'circle') {
	            circleSortKey = styleLayer.layout.get('circle-sort-key');
	            sortFeaturesByKey = !circleSortKey.isConstant();
	        }
	        for (const { feature, id, index, sourceLayerIndex } of features) {
	            const needGeometry = this.layers[0]._featureFilter.needGeometry;
	            const evaluationFeature = toEvaluationFeature(feature, needGeometry);
	            if (!this.layers[0]._featureFilter.filter(new EvaluationParameters(this.zoom), evaluationFeature, canonical))
	                continue;
	            const sortKey = sortFeaturesByKey ?
	                circleSortKey.evaluate(evaluationFeature, {}, canonical) :
	                undefined;
	            const bucketFeature = {
	                id,
	                properties: feature.properties,
	                type: feature.type,
	                sourceLayerIndex,
	                index,
	                geometry: needGeometry ? evaluationFeature.geometry : loadGeometry(feature),
	                patterns: {},
	                sortKey
	            };
	            bucketFeatures.push(bucketFeature);
	        }
	        if (sortFeaturesByKey) {
	            bucketFeatures.sort((a, b) => a.sortKey - b.sortKey);
	        }
	        for (const bucketFeature of bucketFeatures) {
	            const { geometry, index, sourceLayerIndex } = bucketFeature;
	            const feature = features[index].feature;
	            this.addFeature(bucketFeature, geometry, index, canonical);
	            options.featureIndex.insert(feature, geometry, index, sourceLayerIndex, this.index);
	        }
	    }
	    update(states, vtLayer, imagePositions) {
	        if (!this.stateDependentLayers.length)
	            return;
	        this.programConfigurations.updatePaintArrays(states, vtLayer, this.stateDependentLayers, imagePositions);
	    }
	    isEmpty() {
	        return this.layoutVertexArray.length === 0;
	    }
	    uploadPending() {
	        return !this.uploaded || this.programConfigurations.needsUpload;
	    }
	    upload(context) {
	        if (!this.uploaded) {
	            this.layoutVertexBuffer = context.createVertexBuffer(this.layoutVertexArray, members$4);
	            this.indexBuffer = context.createIndexBuffer(this.indexArray);
	        }
	        this.programConfigurations.upload(context);
	        this.uploaded = true;
	    }
	    destroy() {
	        if (!this.layoutVertexBuffer)
	            return;
	        this.layoutVertexBuffer.destroy();
	        this.indexBuffer.destroy();
	        this.programConfigurations.destroy();
	        this.segments.destroy();
	    }
	    addFeature(feature, geometry, index, canonical) {
	        for (const ring of geometry) {
	            for (const point of ring) {
	                const x = point.x;
	                const y = point.y;
	                // Do not include points that are outside the tile boundaries.
	                if (x < 0 || x >= EXTENT || y < 0 || y >= EXTENT)
	                    continue;
	                // this geometry will be of the Point type, and we'll derive
	                // two triangles from it.
	                //
	                // ┌─────────┐
	                // │ 3     2 │
	                // │         │
	                // │ 0     1 │
	                // └─────────┘
	                const segment = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray, feature.sortKey);
	                const index = segment.vertexLength;
	                addCircleVertex(this.layoutVertexArray, x, y, -1, -1);
	                addCircleVertex(this.layoutVertexArray, x, y, 1, -1);
	                addCircleVertex(this.layoutVertexArray, x, y, 1, 1);
	                addCircleVertex(this.layoutVertexArray, x, y, -1, 1);
	                this.indexArray.emplaceBack(index, index + 1, index + 2);
	                this.indexArray.emplaceBack(index, index + 3, index + 2);
	                segment.vertexLength += 4;
	                segment.primitiveLength += 2;
	            }
	        }
	        this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, feature, index, {}, canonical);
	    }
	}
	register('CircleBucket', CircleBucket, { omit: ['layers'] });

	function polygonIntersectsPolygon(polygonA, polygonB) {
	    for (let i = 0; i < polygonA.length; i++) {
	        if (polygonContainsPoint(polygonB, polygonA[i]))
	            return true;
	    }
	    for (let i = 0; i < polygonB.length; i++) {
	        if (polygonContainsPoint(polygonA, polygonB[i]))
	            return true;
	    }
	    if (lineIntersectsLine(polygonA, polygonB))
	        return true;
	    return false;
	}
	function polygonIntersectsBufferedPoint(polygon, point, radius) {
	    if (polygonContainsPoint(polygon, point))
	        return true;
	    if (pointIntersectsBufferedLine(point, polygon, radius))
	        return true;
	    return false;
	}
	function polygonIntersectsMultiPolygon(polygon, multiPolygon) {
	    if (polygon.length === 1) {
	        return multiPolygonContainsPoint(multiPolygon, polygon[0]);
	    }
	    for (let m = 0; m < multiPolygon.length; m++) {
	        const ring = multiPolygon[m];
	        for (let n = 0; n < ring.length; n++) {
	            if (polygonContainsPoint(polygon, ring[n]))
	                return true;
	        }
	    }
	    for (let i = 0; i < polygon.length; i++) {
	        if (multiPolygonContainsPoint(multiPolygon, polygon[i]))
	            return true;
	    }
	    for (let k = 0; k < multiPolygon.length; k++) {
	        if (lineIntersectsLine(polygon, multiPolygon[k]))
	            return true;
	    }
	    return false;
	}
	function polygonIntersectsBufferedMultiLine(polygon, multiLine, radius) {
	    for (let i = 0; i < multiLine.length; i++) {
	        const line = multiLine[i];
	        if (polygon.length >= 3) {
	            for (let k = 0; k < line.length; k++) {
	                if (polygonContainsPoint(polygon, line[k]))
	                    return true;
	            }
	        }
	        if (lineIntersectsBufferedLine(polygon, line, radius))
	            return true;
	    }
	    return false;
	}
	function lineIntersectsBufferedLine(lineA, lineB, radius) {
	    if (lineA.length > 1) {
	        if (lineIntersectsLine(lineA, lineB))
	            return true;
	        // Check whether any point in either line is within radius of the other line
	        for (let j = 0; j < lineB.length; j++) {
	            if (pointIntersectsBufferedLine(lineB[j], lineA, radius))
	                return true;
	        }
	    }
	    for (let k = 0; k < lineA.length; k++) {
	        if (pointIntersectsBufferedLine(lineA[k], lineB, radius))
	            return true;
	    }
	    return false;
	}
	function lineIntersectsLine(lineA, lineB) {
	    if (lineA.length === 0 || lineB.length === 0)
	        return false;
	    for (let i = 0; i < lineA.length - 1; i++) {
	        const a0 = lineA[i];
	        const a1 = lineA[i + 1];
	        for (let j = 0; j < lineB.length - 1; j++) {
	            const b0 = lineB[j];
	            const b1 = lineB[j + 1];
	            if (lineSegmentIntersectsLineSegment(a0, a1, b0, b1))
	                return true;
	        }
	    }
	    return false;
	}
	function lineSegmentIntersectsLineSegment(a0, a1, b0, b1) {
	    return isCounterClockwise(a0, b0, b1) !== isCounterClockwise(a1, b0, b1) &&
	        isCounterClockwise(a0, a1, b0) !== isCounterClockwise(a0, a1, b1);
	}
	function pointIntersectsBufferedLine(p, line, radius) {
	    const radiusSquared = radius * radius;
	    if (line.length === 1)
	        return p.distSqr(line[0]) < radiusSquared;
	    for (let i = 1; i < line.length; i++) {
	        // Find line segments that have a distance <= radius^2 to p
	        // In that case, we treat the line as "containing point p".
	        const v = line[i - 1], w = line[i];
	        if (distToSegmentSquared(p, v, w) < radiusSquared)
	            return true;
	    }
	    return false;
	}
	// Code from http://stackoverflow.com/a/1501725/331379.
	function distToSegmentSquared(p, v, w) {
	    const l2 = v.distSqr(w);
	    if (l2 === 0)
	        return p.distSqr(v);
	    const t = ((p.x - v.x) * (w.x - v.x) + (p.y - v.y) * (w.y - v.y)) / l2;
	    if (t < 0)
	        return p.distSqr(v);
	    if (t > 1)
	        return p.distSqr(w);
	    return p.distSqr(w.sub(v)._mult(t)._add(v));
	}
	// point in polygon ray casting algorithm
	function multiPolygonContainsPoint(rings, p) {
	    let c = false, ring, p1, p2;
	    for (let k = 0; k < rings.length; k++) {
	        ring = rings[k];
	        for (let i = 0, j = ring.length - 1; i < ring.length; j = i++) {
	            p1 = ring[i];
	            p2 = ring[j];
	            if (((p1.y > p.y) !== (p2.y > p.y)) && (p.x < (p2.x - p1.x) * (p.y - p1.y) / (p2.y - p1.y) + p1.x)) {
	                c = !c;
	            }
	        }
	    }
	    return c;
	}
	function polygonContainsPoint(ring, p) {
	    let c = false;
	    for (let i = 0, j = ring.length - 1; i < ring.length; j = i++) {
	        const p1 = ring[i];
	        const p2 = ring[j];
	        if (((p1.y > p.y) !== (p2.y > p.y)) && (p.x < (p2.x - p1.x) * (p.y - p1.y) / (p2.y - p1.y) + p1.x)) {
	            c = !c;
	        }
	    }
	    return c;
	}
	function polygonIntersectsBox(ring, boxX1, boxY1, boxX2, boxY2) {
	    for (const p of ring) {
	        if (boxX1 <= p.x &&
	            boxY1 <= p.y &&
	            boxX2 >= p.x &&
	            boxY2 >= p.y)
	            return true;
	    }
	    const corners = [
	        new Point$2(boxX1, boxY1),
	        new Point$2(boxX1, boxY2),
	        new Point$2(boxX2, boxY2),
	        new Point$2(boxX2, boxY1)
	    ];
	    if (ring.length > 2) {
	        for (const corner of corners) {
	            if (polygonContainsPoint(ring, corner))
	                return true;
	        }
	    }
	    for (let i = 0; i < ring.length - 1; i++) {
	        const p1 = ring[i];
	        const p2 = ring[i + 1];
	        if (edgeIntersectsBox(p1, p2, corners))
	            return true;
	    }
	    return false;
	}
	function edgeIntersectsBox(e1, e2, corners) {
	    const tl = corners[0];
	    const br = corners[2];
	    // the edge and box do not intersect in either the x or y dimensions
	    if (((e1.x < tl.x) && (e2.x < tl.x)) ||
	        ((e1.x > br.x) && (e2.x > br.x)) ||
	        ((e1.y < tl.y) && (e2.y < tl.y)) ||
	        ((e1.y > br.y) && (e2.y > br.y)))
	        return false;
	    // check if all corners of the box are on the same side of the edge
	    const dir = isCounterClockwise(e1, e2, corners[0]);
	    return dir !== isCounterClockwise(e1, e2, corners[1]) ||
	        dir !== isCounterClockwise(e1, e2, corners[2]) ||
	        dir !== isCounterClockwise(e1, e2, corners[3]);
	}

	function getMaximumPaintValue(property, layer, bucket) {
	    const value = layer.paint.get(property).value;
	    if (value.kind === 'constant') {
	        return value.value;
	    }
	    else {
	        return bucket.programConfigurations.get(layer.id).getMaxValue(property);
	    }
	}
	function translateDistance(translate) {
	    return Math.sqrt(translate[0] * translate[0] + translate[1] * translate[1]);
	}
	function translate$4(queryGeometry, translate, translateAnchor, bearing, pixelsToTileUnits) {
	    if (!translate[0] && !translate[1]) {
	        return queryGeometry;
	    }
	    const pt = Point$2.convert(translate)._mult(pixelsToTileUnits);
	    if (translateAnchor === 'viewport') {
	        pt._rotate(-bearing);
	    }
	    const translated = [];
	    for (let i = 0; i < queryGeometry.length; i++) {
	        const point = queryGeometry[i];
	        translated.push(point.sub(pt));
	    }
	    return translated;
	}
	function offsetLine(rings, offset) {
	    const newRings = [];
	    for (let ringIndex = 0; ringIndex < rings.length; ringIndex++) {
	        const ring = rings[ringIndex];
	        const newRing = [];
	        for (let index = 0; index < ring.length; index++) {
	            const a = ring[index - 1];
	            const b = ring[index];
	            const c = ring[index + 1];
	            const aToB = index === 0 ? new Point$2(0, 0) : b.sub(a)._unit()._perp();
	            const bToC = index === ring.length - 1 ? new Point$2(0, 0) : c.sub(b)._unit()._perp();
	            const extrude = aToB._add(bToC)._unit();
	            const cosHalfAngle = extrude.x * bToC.x + extrude.y * bToC.y;
	            if (cosHalfAngle !== 0) {
	                extrude._mult(1 / cosHalfAngle);
	            }
	            newRing.push(extrude._mult(offset)._add(b));
	        }
	        newRings.push(newRing);
	    }
	    return newRings;
	}

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let layout$5;
	const getLayout$3 = () => layout$5 = layout$5 || new Properties({
	    "circle-sort-key": new DataDrivenProperty(v8Spec["layout_circle"]["circle-sort-key"]),
	});
	let paint$8;
	const getPaint$8 = () => paint$8 = paint$8 || new Properties({
	    "circle-radius": new DataDrivenProperty(v8Spec["paint_circle"]["circle-radius"]),
	    "circle-color": new DataDrivenProperty(v8Spec["paint_circle"]["circle-color"]),
	    "circle-blur": new DataDrivenProperty(v8Spec["paint_circle"]["circle-blur"]),
	    "circle-opacity": new DataDrivenProperty(v8Spec["paint_circle"]["circle-opacity"]),
	    "circle-translate": new DataConstantProperty(v8Spec["paint_circle"]["circle-translate"]),
	    "circle-translate-anchor": new DataConstantProperty(v8Spec["paint_circle"]["circle-translate-anchor"]),
	    "circle-pitch-scale": new DataConstantProperty(v8Spec["paint_circle"]["circle-pitch-scale"]),
	    "circle-pitch-alignment": new DataConstantProperty(v8Spec["paint_circle"]["circle-pitch-alignment"]),
	    "circle-stroke-width": new DataDrivenProperty(v8Spec["paint_circle"]["circle-stroke-width"]),
	    "circle-stroke-color": new DataDrivenProperty(v8Spec["paint_circle"]["circle-stroke-color"]),
	    "circle-stroke-opacity": new DataDrivenProperty(v8Spec["paint_circle"]["circle-stroke-opacity"]),
	});
	var properties$8 = ({ get paint() { return getPaint$8(); }, get layout() { return getLayout$3(); } });

	/**
	 * Common utilities
	 * @module glMatrix
	 */
	// Configuration Constants
	var EPSILON = 0.000001;
	var ARRAY_TYPE = typeof Float32Array !== 'undefined' ? Float32Array : Array;
	if (!Math.hypot) Math.hypot = function () {
	  var y = 0,
	      i = arguments.length;

	  while (i--) {
	    y += arguments[i] * arguments[i];
	  }

	  return Math.sqrt(y);
	};

	/**
	 * 2x2 Matrix
	 * @module mat2
	 */

	/**
	 * Creates a new identity mat2
	 *
	 * @returns {mat2} a new 2x2 matrix
	 */

	function create$8() {
	  var out = new ARRAY_TYPE(4);

	  if (ARRAY_TYPE != Float32Array) {
	    out[1] = 0;
	    out[2] = 0;
	  }

	  out[0] = 1;
	  out[3] = 1;
	  return out;
	}
	/**
	 * Rotates a mat2 by the given angle
	 *
	 * @param {mat2} out the receiving matrix
	 * @param {ReadonlyMat2} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat2} out
	 */

	function rotate$4(out, a, rad) {
	  var a0 = a[0],
	      a1 = a[1],
	      a2 = a[2],
	      a3 = a[3];
	  var s = Math.sin(rad);
	  var c = Math.cos(rad);
	  out[0] = a0 * c + a2 * s;
	  out[1] = a1 * c + a3 * s;
	  out[2] = a0 * -s + a2 * c;
	  out[3] = a1 * -s + a3 * c;
	  return out;
	}

	/**
	 * 3x3 Matrix
	 * @module mat3
	 */

	/**
	 * Creates a new identity mat3
	 *
	 * @returns {mat3} a new 3x3 matrix
	 */

	function create$6() {
	  var out = new ARRAY_TYPE(9);

	  if (ARRAY_TYPE != Float32Array) {
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[5] = 0;
	    out[6] = 0;
	    out[7] = 0;
	  }

	  out[0] = 1;
	  out[4] = 1;
	  out[8] = 1;
	  return out;
	}
	/**
	 * Creates a matrix from a given angle
	 * This is equivalent to (but much faster than):
	 *
	 *     mat3.identity(dest);
	 *     mat3.rotate(dest, dest, rad);
	 *
	 * @param {mat3} out mat3 receiving operation result
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat3} out
	 */

	function fromRotation$2(out, rad) {
	  var s = Math.sin(rad),
	      c = Math.cos(rad);
	  out[0] = c;
	  out[1] = s;
	  out[2] = 0;
	  out[3] = -s;
	  out[4] = c;
	  out[5] = 0;
	  out[6] = 0;
	  out[7] = 0;
	  out[8] = 1;
	  return out;
	}

	/**
	 * 4x4 Matrix<br>Format: column-major, when typed out it looks like row-major<br>The matrices are being post multiplied.
	 * @module mat4
	 */

	/**
	 * Creates a new identity mat4
	 *
	 * @returns {mat4} a new 4x4 matrix
	 */

	function create$5() {
	  var out = new ARRAY_TYPE(16);

	  if (ARRAY_TYPE != Float32Array) {
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	    out[4] = 0;
	    out[6] = 0;
	    out[7] = 0;
	    out[8] = 0;
	    out[9] = 0;
	    out[11] = 0;
	    out[12] = 0;
	    out[13] = 0;
	    out[14] = 0;
	  }

	  out[0] = 1;
	  out[5] = 1;
	  out[10] = 1;
	  out[15] = 1;
	  return out;
	}
	/**
	 * Creates a new mat4 initialized with values from an existing matrix
	 *
	 * @param {ReadonlyMat4} a matrix to clone
	 * @returns {mat4} a new 4x4 matrix
	 */

	function clone$5(a) {
	  var out = new ARRAY_TYPE(16);
	  out[0] = a[0];
	  out[1] = a[1];
	  out[2] = a[2];
	  out[3] = a[3];
	  out[4] = a[4];
	  out[5] = a[5];
	  out[6] = a[6];
	  out[7] = a[7];
	  out[8] = a[8];
	  out[9] = a[9];
	  out[10] = a[10];
	  out[11] = a[11];
	  out[12] = a[12];
	  out[13] = a[13];
	  out[14] = a[14];
	  out[15] = a[15];
	  return out;
	}
	/**
	 * Copy the values from one mat4 to another
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {ReadonlyMat4} a the source matrix
	 * @returns {mat4} out
	 */

	function copy$5(out, a) {
	  out[0] = a[0];
	  out[1] = a[1];
	  out[2] = a[2];
	  out[3] = a[3];
	  out[4] = a[4];
	  out[5] = a[5];
	  out[6] = a[6];
	  out[7] = a[7];
	  out[8] = a[8];
	  out[9] = a[9];
	  out[10] = a[10];
	  out[11] = a[11];
	  out[12] = a[12];
	  out[13] = a[13];
	  out[14] = a[14];
	  out[15] = a[15];
	  return out;
	}
	/**
	 * Set a mat4 to the identity matrix
	 *
	 * @param {mat4} out the receiving matrix
	 * @returns {mat4} out
	 */

	function identity$2(out) {
	  out[0] = 1;
	  out[1] = 0;
	  out[2] = 0;
	  out[3] = 0;
	  out[4] = 0;
	  out[5] = 1;
	  out[6] = 0;
	  out[7] = 0;
	  out[8] = 0;
	  out[9] = 0;
	  out[10] = 1;
	  out[11] = 0;
	  out[12] = 0;
	  out[13] = 0;
	  out[14] = 0;
	  out[15] = 1;
	  return out;
	}
	/**
	 * Inverts a mat4
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {ReadonlyMat4} a the source matrix
	 * @returns {mat4} out
	 */

	function invert$2(out, a) {
	  var a00 = a[0],
	      a01 = a[1],
	      a02 = a[2],
	      a03 = a[3];
	  var a10 = a[4],
	      a11 = a[5],
	      a12 = a[6],
	      a13 = a[7];
	  var a20 = a[8],
	      a21 = a[9],
	      a22 = a[10],
	      a23 = a[11];
	  var a30 = a[12],
	      a31 = a[13],
	      a32 = a[14],
	      a33 = a[15];
	  var b00 = a00 * a11 - a01 * a10;
	  var b01 = a00 * a12 - a02 * a10;
	  var b02 = a00 * a13 - a03 * a10;
	  var b03 = a01 * a12 - a02 * a11;
	  var b04 = a01 * a13 - a03 * a11;
	  var b05 = a02 * a13 - a03 * a12;
	  var b06 = a20 * a31 - a21 * a30;
	  var b07 = a20 * a32 - a22 * a30;
	  var b08 = a20 * a33 - a23 * a30;
	  var b09 = a21 * a32 - a22 * a31;
	  var b10 = a21 * a33 - a23 * a31;
	  var b11 = a22 * a33 - a23 * a32; // Calculate the determinant

	  var det = b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;

	  if (!det) {
	    return null;
	  }

	  det = 1.0 / det;
	  out[0] = (a11 * b11 - a12 * b10 + a13 * b09) * det;
	  out[1] = (a02 * b10 - a01 * b11 - a03 * b09) * det;
	  out[2] = (a31 * b05 - a32 * b04 + a33 * b03) * det;
	  out[3] = (a22 * b04 - a21 * b05 - a23 * b03) * det;
	  out[4] = (a12 * b08 - a10 * b11 - a13 * b07) * det;
	  out[5] = (a00 * b11 - a02 * b08 + a03 * b07) * det;
	  out[6] = (a32 * b02 - a30 * b05 - a33 * b01) * det;
	  out[7] = (a20 * b05 - a22 * b02 + a23 * b01) * det;
	  out[8] = (a10 * b10 - a11 * b08 + a13 * b06) * det;
	  out[9] = (a01 * b08 - a00 * b10 - a03 * b06) * det;
	  out[10] = (a30 * b04 - a31 * b02 + a33 * b00) * det;
	  out[11] = (a21 * b02 - a20 * b04 - a23 * b00) * det;
	  out[12] = (a11 * b07 - a10 * b09 - a12 * b06) * det;
	  out[13] = (a00 * b09 - a01 * b07 + a02 * b06) * det;
	  out[14] = (a31 * b01 - a30 * b03 - a32 * b00) * det;
	  out[15] = (a20 * b03 - a21 * b01 + a22 * b00) * det;
	  return out;
	}
	/**
	 * Multiplies two mat4s
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {ReadonlyMat4} a the first operand
	 * @param {ReadonlyMat4} b the second operand
	 * @returns {mat4} out
	 */

	function multiply$5(out, a, b) {
	  var a00 = a[0],
	      a01 = a[1],
	      a02 = a[2],
	      a03 = a[3];
	  var a10 = a[4],
	      a11 = a[5],
	      a12 = a[6],
	      a13 = a[7];
	  var a20 = a[8],
	      a21 = a[9],
	      a22 = a[10],
	      a23 = a[11];
	  var a30 = a[12],
	      a31 = a[13],
	      a32 = a[14],
	      a33 = a[15]; // Cache only the current line of the second matrix

	  var b0 = b[0],
	      b1 = b[1],
	      b2 = b[2],
	      b3 = b[3];
	  out[0] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
	  out[1] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
	  out[2] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
	  out[3] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
	  b0 = b[4];
	  b1 = b[5];
	  b2 = b[6];
	  b3 = b[7];
	  out[4] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
	  out[5] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
	  out[6] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
	  out[7] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
	  b0 = b[8];
	  b1 = b[9];
	  b2 = b[10];
	  b3 = b[11];
	  out[8] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
	  out[9] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
	  out[10] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
	  out[11] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
	  b0 = b[12];
	  b1 = b[13];
	  b2 = b[14];
	  b3 = b[15];
	  out[12] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
	  out[13] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
	  out[14] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
	  out[15] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
	  return out;
	}
	/**
	 * Translate a mat4 by the given vector
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {ReadonlyMat4} a the matrix to translate
	 * @param {ReadonlyVec3} v vector to translate by
	 * @returns {mat4} out
	 */

	function translate$1(out, a, v) {
	  var x = v[0],
	      y = v[1],
	      z = v[2];
	  var a00, a01, a02, a03;
	  var a10, a11, a12, a13;
	  var a20, a21, a22, a23;

	  if (a === out) {
	    out[12] = a[0] * x + a[4] * y + a[8] * z + a[12];
	    out[13] = a[1] * x + a[5] * y + a[9] * z + a[13];
	    out[14] = a[2] * x + a[6] * y + a[10] * z + a[14];
	    out[15] = a[3] * x + a[7] * y + a[11] * z + a[15];
	  } else {
	    a00 = a[0];
	    a01 = a[1];
	    a02 = a[2];
	    a03 = a[3];
	    a10 = a[4];
	    a11 = a[5];
	    a12 = a[6];
	    a13 = a[7];
	    a20 = a[8];
	    a21 = a[9];
	    a22 = a[10];
	    a23 = a[11];
	    out[0] = a00;
	    out[1] = a01;
	    out[2] = a02;
	    out[3] = a03;
	    out[4] = a10;
	    out[5] = a11;
	    out[6] = a12;
	    out[7] = a13;
	    out[8] = a20;
	    out[9] = a21;
	    out[10] = a22;
	    out[11] = a23;
	    out[12] = a00 * x + a10 * y + a20 * z + a[12];
	    out[13] = a01 * x + a11 * y + a21 * z + a[13];
	    out[14] = a02 * x + a12 * y + a22 * z + a[14];
	    out[15] = a03 * x + a13 * y + a23 * z + a[15];
	  }

	  return out;
	}
	/**
	 * Scales the mat4 by the dimensions in the given vec3 not using vectorization
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {ReadonlyMat4} a the matrix to scale
	 * @param {ReadonlyVec3} v the vec3 to scale the matrix by
	 * @returns {mat4} out
	 **/

	function scale$5(out, a, v) {
	  var x = v[0],
	      y = v[1],
	      z = v[2];
	  out[0] = a[0] * x;
	  out[1] = a[1] * x;
	  out[2] = a[2] * x;
	  out[3] = a[3] * x;
	  out[4] = a[4] * y;
	  out[5] = a[5] * y;
	  out[6] = a[6] * y;
	  out[7] = a[7] * y;
	  out[8] = a[8] * z;
	  out[9] = a[9] * z;
	  out[10] = a[10] * z;
	  out[11] = a[11] * z;
	  out[12] = a[12];
	  out[13] = a[13];
	  out[14] = a[14];
	  out[15] = a[15];
	  return out;
	}
	/**
	 * Rotates a matrix by the given angle around the X axis
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {ReadonlyMat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */

	function rotateX$3(out, a, rad) {
	  var s = Math.sin(rad);
	  var c = Math.cos(rad);
	  var a10 = a[4];
	  var a11 = a[5];
	  var a12 = a[6];
	  var a13 = a[7];
	  var a20 = a[8];
	  var a21 = a[9];
	  var a22 = a[10];
	  var a23 = a[11];

	  if (a !== out) {
	    // If the source and destination differ, copy the unchanged rows
	    out[0] = a[0];
	    out[1] = a[1];
	    out[2] = a[2];
	    out[3] = a[3];
	    out[12] = a[12];
	    out[13] = a[13];
	    out[14] = a[14];
	    out[15] = a[15];
	  } // Perform axis-specific matrix multiplication


	  out[4] = a10 * c + a20 * s;
	  out[5] = a11 * c + a21 * s;
	  out[6] = a12 * c + a22 * s;
	  out[7] = a13 * c + a23 * s;
	  out[8] = a20 * c - a10 * s;
	  out[9] = a21 * c - a11 * s;
	  out[10] = a22 * c - a12 * s;
	  out[11] = a23 * c - a13 * s;
	  return out;
	}
	/**
	 * Rotates a matrix by the given angle around the Z axis
	 *
	 * @param {mat4} out the receiving matrix
	 * @param {ReadonlyMat4} a the matrix to rotate
	 * @param {Number} rad the angle to rotate the matrix by
	 * @returns {mat4} out
	 */

	function rotateZ$3(out, a, rad) {
	  var s = Math.sin(rad);
	  var c = Math.cos(rad);
	  var a00 = a[0];
	  var a01 = a[1];
	  var a02 = a[2];
	  var a03 = a[3];
	  var a10 = a[4];
	  var a11 = a[5];
	  var a12 = a[6];
	  var a13 = a[7];

	  if (a !== out) {
	    // If the source and destination differ, copy the unchanged last row
	    out[8] = a[8];
	    out[9] = a[9];
	    out[10] = a[10];
	    out[11] = a[11];
	    out[12] = a[12];
	    out[13] = a[13];
	    out[14] = a[14];
	    out[15] = a[15];
	  } // Perform axis-specific matrix multiplication


	  out[0] = a00 * c + a10 * s;
	  out[1] = a01 * c + a11 * s;
	  out[2] = a02 * c + a12 * s;
	  out[3] = a03 * c + a13 * s;
	  out[4] = a10 * c - a00 * s;
	  out[5] = a11 * c - a01 * s;
	  out[6] = a12 * c - a02 * s;
	  out[7] = a13 * c - a03 * s;
	  return out;
	}
	/**
	 * Creates a matrix from a vector scaling
	 * This is equivalent to (but much faster than):
	 *
	 *     mat4.identity(dest);
	 *     mat4.scale(dest, dest, vec);
	 *
	 * @param {mat4} out mat4 receiving operation result
	 * @param {ReadonlyVec3} v Scaling vector
	 * @returns {mat4} out
	 */

	function fromScaling(out, v) {
	  out[0] = v[0];
	  out[1] = 0;
	  out[2] = 0;
	  out[3] = 0;
	  out[4] = 0;
	  out[5] = v[1];
	  out[6] = 0;
	  out[7] = 0;
	  out[8] = 0;
	  out[9] = 0;
	  out[10] = v[2];
	  out[11] = 0;
	  out[12] = 0;
	  out[13] = 0;
	  out[14] = 0;
	  out[15] = 1;
	  return out;
	}
	/**
	 * Generates a perspective projection matrix with the given bounds.
	 * The near/far clip planes correspond to a normalized device coordinate Z range of [-1, 1],
	 * which matches WebGL/OpenGL's clip volume.
	 * Passing null/undefined/no value for far will generate infinite projection matrix.
	 *
	 * @param {mat4} out mat4 frustum matrix will be written into
	 * @param {number} fovy Vertical field of view in radians
	 * @param {number} aspect Aspect ratio. typically viewport width/height
	 * @param {number} near Near bound of the frustum
	 * @param {number} far Far bound of the frustum, can be null or Infinity
	 * @returns {mat4} out
	 */

	function perspectiveNO(out, fovy, aspect, near, far) {
	  var f = 1.0 / Math.tan(fovy / 2),
	      nf;
	  out[0] = f / aspect;
	  out[1] = 0;
	  out[2] = 0;
	  out[3] = 0;
	  out[4] = 0;
	  out[5] = f;
	  out[6] = 0;
	  out[7] = 0;
	  out[8] = 0;
	  out[9] = 0;
	  out[11] = -1;
	  out[12] = 0;
	  out[13] = 0;
	  out[15] = 0;

	  if (far != null && far !== Infinity) {
	    nf = 1 / (near - far);
	    out[10] = (far + near) * nf;
	    out[14] = 2 * far * near * nf;
	  } else {
	    out[10] = -1;
	    out[14] = -2 * near;
	  }

	  return out;
	}
	/**
	 * Alias for {@link mat4.perspectiveNO}
	 * @function
	 */

	var perspective = perspectiveNO;
	/**
	 * Generates a orthogonal projection matrix with the given bounds.
	 * The near/far clip planes correspond to a normalized device coordinate Z range of [-1, 1],
	 * which matches WebGL/OpenGL's clip volume.
	 *
	 * @param {mat4} out mat4 frustum matrix will be written into
	 * @param {number} left Left bound of the frustum
	 * @param {number} right Right bound of the frustum
	 * @param {number} bottom Bottom bound of the frustum
	 * @param {number} top Top bound of the frustum
	 * @param {number} near Near bound of the frustum
	 * @param {number} far Far bound of the frustum
	 * @returns {mat4} out
	 */

	function orthoNO(out, left, right, bottom, top, near, far) {
	  var lr = 1 / (left - right);
	  var bt = 1 / (bottom - top);
	  var nf = 1 / (near - far);
	  out[0] = -2 * lr;
	  out[1] = 0;
	  out[2] = 0;
	  out[3] = 0;
	  out[4] = 0;
	  out[5] = -2 * bt;
	  out[6] = 0;
	  out[7] = 0;
	  out[8] = 0;
	  out[9] = 0;
	  out[10] = 2 * nf;
	  out[11] = 0;
	  out[12] = (left + right) * lr;
	  out[13] = (top + bottom) * bt;
	  out[14] = (far + near) * nf;
	  out[15] = 1;
	  return out;
	}
	/**
	 * Alias for {@link mat4.orthoNO}
	 * @function
	 */

	var ortho = orthoNO;
	/**
	 * Returns whether or not the matrices have exactly the same elements in the same position (when compared with ===)
	 *
	 * @param {ReadonlyMat4} a The first matrix.
	 * @param {ReadonlyMat4} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */

	function exactEquals$5(a, b) {
	  return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && a[3] === b[3] && a[4] === b[4] && a[5] === b[5] && a[6] === b[6] && a[7] === b[7] && a[8] === b[8] && a[9] === b[9] && a[10] === b[10] && a[11] === b[11] && a[12] === b[12] && a[13] === b[13] && a[14] === b[14] && a[15] === b[15];
	}
	/**
	 * Returns whether or not the matrices have approximately the same elements in the same position.
	 *
	 * @param {ReadonlyMat4} a The first matrix.
	 * @param {ReadonlyMat4} b The second matrix.
	 * @returns {Boolean} True if the matrices are equal, false otherwise.
	 */

	function equals$6(a, b) {
	  var a0 = a[0],
	      a1 = a[1],
	      a2 = a[2],
	      a3 = a[3];
	  var a4 = a[4],
	      a5 = a[5],
	      a6 = a[6],
	      a7 = a[7];
	  var a8 = a[8],
	      a9 = a[9],
	      a10 = a[10],
	      a11 = a[11];
	  var a12 = a[12],
	      a13 = a[13],
	      a14 = a[14],
	      a15 = a[15];
	  var b0 = b[0],
	      b1 = b[1],
	      b2 = b[2],
	      b3 = b[3];
	  var b4 = b[4],
	      b5 = b[5],
	      b6 = b[6],
	      b7 = b[7];
	  var b8 = b[8],
	      b9 = b[9],
	      b10 = b[10],
	      b11 = b[11];
	  var b12 = b[12],
	      b13 = b[13],
	      b14 = b[14],
	      b15 = b[15];
	  return Math.abs(a0 - b0) <= EPSILON * Math.max(1.0, Math.abs(a0), Math.abs(b0)) && Math.abs(a1 - b1) <= EPSILON * Math.max(1.0, Math.abs(a1), Math.abs(b1)) && Math.abs(a2 - b2) <= EPSILON * Math.max(1.0, Math.abs(a2), Math.abs(b2)) && Math.abs(a3 - b3) <= EPSILON * Math.max(1.0, Math.abs(a3), Math.abs(b3)) && Math.abs(a4 - b4) <= EPSILON * Math.max(1.0, Math.abs(a4), Math.abs(b4)) && Math.abs(a5 - b5) <= EPSILON * Math.max(1.0, Math.abs(a5), Math.abs(b5)) && Math.abs(a6 - b6) <= EPSILON * Math.max(1.0, Math.abs(a6), Math.abs(b6)) && Math.abs(a7 - b7) <= EPSILON * Math.max(1.0, Math.abs(a7), Math.abs(b7)) && Math.abs(a8 - b8) <= EPSILON * Math.max(1.0, Math.abs(a8), Math.abs(b8)) && Math.abs(a9 - b9) <= EPSILON * Math.max(1.0, Math.abs(a9), Math.abs(b9)) && Math.abs(a10 - b10) <= EPSILON * Math.max(1.0, Math.abs(a10), Math.abs(b10)) && Math.abs(a11 - b11) <= EPSILON * Math.max(1.0, Math.abs(a11), Math.abs(b11)) && Math.abs(a12 - b12) <= EPSILON * Math.max(1.0, Math.abs(a12), Math.abs(b12)) && Math.abs(a13 - b13) <= EPSILON * Math.max(1.0, Math.abs(a13), Math.abs(b13)) && Math.abs(a14 - b14) <= EPSILON * Math.max(1.0, Math.abs(a14), Math.abs(b14)) && Math.abs(a15 - b15) <= EPSILON * Math.max(1.0, Math.abs(a15), Math.abs(b15));
	}
	/**
	 * Alias for {@link mat4.multiply}
	 * @function
	 */

	var mul$5 = multiply$5;

	/**
	 * 3 Dimensional Vector
	 * @module vec3
	 */

	/**
	 * Creates a new, empty vec3
	 *
	 * @returns {vec3} a new 3D vector
	 */

	function create$4() {
	  var out = new ARRAY_TYPE(3);

	  if (ARRAY_TYPE != Float32Array) {
	    out[0] = 0;
	    out[1] = 0;
	    out[2] = 0;
	  }

	  return out;
	}
	/**
	 * Creates a new vec3 initialized with values from an existing vector
	 *
	 * @param {ReadonlyVec3} a vector to clone
	 * @returns {vec3} a new 3D vector
	 */

	function clone$4(a) {
	  var out = new ARRAY_TYPE(3);
	  out[0] = a[0];
	  out[1] = a[1];
	  out[2] = a[2];
	  return out;
	}
	/**
	 * Calculates the length of a vec3
	 *
	 * @param {ReadonlyVec3} a vector to calculate length of
	 * @returns {Number} length of a
	 */

	function length$4(a) {
	  var x = a[0];
	  var y = a[1];
	  var z = a[2];
	  return Math.hypot(x, y, z);
	}
	/**
	 * Creates a new vec3 initialized with the given values
	 *
	 * @param {Number} x X component
	 * @param {Number} y Y component
	 * @param {Number} z Z component
	 * @returns {vec3} a new 3D vector
	 */

	function fromValues$4(x, y, z) {
	  var out = new ARRAY_TYPE(3);
	  out[0] = x;
	  out[1] = y;
	  out[2] = z;
	  return out;
	}
	/**
	 * Adds two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {ReadonlyVec3} a the first operand
	 * @param {ReadonlyVec3} b the second operand
	 * @returns {vec3} out
	 */

	function add$4(out, a, b) {
	  out[0] = a[0] + b[0];
	  out[1] = a[1] + b[1];
	  out[2] = a[2] + b[2];
	  return out;
	}
	/**
	 * Subtracts vector b from vector a
	 *
	 * @param {vec3} out the receiving vector
	 * @param {ReadonlyVec3} a the first operand
	 * @param {ReadonlyVec3} b the second operand
	 * @returns {vec3} out
	 */

	function subtract$2(out, a, b) {
	  out[0] = a[0] - b[0];
	  out[1] = a[1] - b[1];
	  out[2] = a[2] - b[2];
	  return out;
	}
	/**
	 * Scales a vec3 by a scalar number
	 *
	 * @param {vec3} out the receiving vector
	 * @param {ReadonlyVec3} a the vector to scale
	 * @param {Number} b amount to scale the vector by
	 * @returns {vec3} out
	 */

	function scale$4(out, a, b) {
	  out[0] = a[0] * b;
	  out[1] = a[1] * b;
	  out[2] = a[2] * b;
	  return out;
	}
	/**
	 * Normalize a vec3
	 *
	 * @param {vec3} out the receiving vector
	 * @param {ReadonlyVec3} a vector to normalize
	 * @returns {vec3} out
	 */

	function normalize$4(out, a) {
	  var x = a[0];
	  var y = a[1];
	  var z = a[2];
	  var len = x * x + y * y + z * z;

	  if (len > 0) {
	    //TODO: evaluate use of glm_invsqrt here?
	    len = 1 / Math.sqrt(len);
	  }

	  out[0] = a[0] * len;
	  out[1] = a[1] * len;
	  out[2] = a[2] * len;
	  return out;
	}
	/**
	 * Calculates the dot product of two vec3's
	 *
	 * @param {ReadonlyVec3} a the first operand
	 * @param {ReadonlyVec3} b the second operand
	 * @returns {Number} dot product of a and b
	 */

	function dot$5(a, b) {
	  return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
	}
	/**
	 * Computes the cross product of two vec3's
	 *
	 * @param {vec3} out the receiving vector
	 * @param {ReadonlyVec3} a the first operand
	 * @param {ReadonlyVec3} b the second operand
	 * @returns {vec3} out
	 */

	function cross$2(out, a, b) {
	  var ax = a[0],
	      ay = a[1],
	      az = a[2];
	  var bx = b[0],
	      by = b[1],
	      bz = b[2];
	  out[0] = ay * bz - az * by;
	  out[1] = az * bx - ax * bz;
	  out[2] = ax * by - ay * bx;
	  return out;
	}
	/**
	 * Transforms the vec3 with a mat3.
	 *
	 * @param {vec3} out the receiving vector
	 * @param {ReadonlyVec3} a the vector to transform
	 * @param {ReadonlyMat3} m the 3x3 matrix to transform with
	 * @returns {vec3} out
	 */

	function transformMat3$1(out, a, m) {
	  var x = a[0],
	      y = a[1],
	      z = a[2];
	  out[0] = x * m[0] + y * m[3] + z * m[6];
	  out[1] = x * m[1] + y * m[4] + z * m[7];
	  out[2] = x * m[2] + y * m[5] + z * m[8];
	  return out;
	}
	/**
	 * Alias for {@link vec3.subtract}
	 * @function
	 */

	var sub$2 = subtract$2;
	/**
	 * Alias for {@link vec3.length}
	 * @function
	 */

	var len$4 = length$4;
	/**
	 * Perform some operation over an array of vec3s.
	 *
	 * @param {Array} a the array of vectors to iterate over
	 * @param {Number} stride Number of elements between the start of each vec3. If 0 assumes tightly packed
	 * @param {Number} offset Number of elements to skip at the beginning of the array
	 * @param {Number} count Number of vec3s to iterate over. If 0 iterates over entire array
	 * @param {Function} fn Function to call for each vector in the array
	 * @param {Object} [arg] additional argument to pass to fn
	 * @returns {Array} a
	 * @function
	 */

	(function () {
	  var vec = create$4();
	  return function (a, stride, offset, count, fn, arg) {
	    var i, l;

	    if (!stride) {
	      stride = 3;
	    }

	    if (!offset) {
	      offset = 0;
	    }

	    if (count) {
	      l = Math.min(count * stride + offset, a.length);
	    } else {
	      l = a.length;
	    }

	    for (i = offset; i < l; i += stride) {
	      vec[0] = a[i];
	      vec[1] = a[i + 1];
	      vec[2] = a[i + 2];
	      fn(vec, vec, arg);
	      a[i] = vec[0];
	      a[i + 1] = vec[1];
	      a[i + 2] = vec[2];
	    }

	    return a;
	  };
	})();

	/**
	 * 4 Dimensional Vector
	 * @module vec4
	 */

	/**
	 * Creates a new, empty vec4
	 *
	 * @returns {vec4} a new 4D vector
	 */

	function create$3() {
	  var out = new ARRAY_TYPE(4);

	  if (ARRAY_TYPE != Float32Array) {
	    out[0] = 0;
	    out[1] = 0;
	    out[2] = 0;
	    out[3] = 0;
	  }

	  return out;
	}
	/**
	 * Multiplies two vec4's
	 *
	 * @param {vec4} out the receiving vector
	 * @param {ReadonlyVec4} a the first operand
	 * @param {ReadonlyVec4} b the second operand
	 * @returns {vec4} out
	 */

	function multiply$3(out, a, b) {
	  out[0] = a[0] * b[0];
	  out[1] = a[1] * b[1];
	  out[2] = a[2] * b[2];
	  out[3] = a[3] * b[3];
	  return out;
	}
	/**
	 * Normalize a vec4
	 *
	 * @param {vec4} out the receiving vector
	 * @param {ReadonlyVec4} a vector to normalize
	 * @returns {vec4} out
	 */

	function normalize$3(out, a) {
	  var x = a[0];
	  var y = a[1];
	  var z = a[2];
	  var w = a[3];
	  var len = x * x + y * y + z * z + w * w;

	  if (len > 0) {
	    len = 1 / Math.sqrt(len);
	  }

	  out[0] = x * len;
	  out[1] = y * len;
	  out[2] = z * len;
	  out[3] = w * len;
	  return out;
	}
	/**
	 * Calculates the dot product of two vec4's
	 *
	 * @param {ReadonlyVec4} a the first operand
	 * @param {ReadonlyVec4} b the second operand
	 * @returns {Number} dot product of a and b
	 */

	function dot$4(a, b) {
	  return a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3];
	}
	/**
	 * Transforms the vec4 with a mat4.
	 *
	 * @param {vec4} out the receiving vector
	 * @param {ReadonlyVec4} a the vector to transform
	 * @param {ReadonlyMat4} m matrix to transform with
	 * @returns {vec4} out
	 */

	function transformMat4$1(out, a, m) {
	  var x = a[0],
	      y = a[1],
	      z = a[2],
	      w = a[3];
	  out[0] = m[0] * x + m[4] * y + m[8] * z + m[12] * w;
	  out[1] = m[1] * x + m[5] * y + m[9] * z + m[13] * w;
	  out[2] = m[2] * x + m[6] * y + m[10] * z + m[14] * w;
	  out[3] = m[3] * x + m[7] * y + m[11] * z + m[15] * w;
	  return out;
	}
	/**
	 * Alias for {@link vec4.multiply}
	 * @function
	 */

	var mul$3 = multiply$3;
	/**
	 * Perform some operation over an array of vec4s.
	 *
	 * @param {Array} a the array of vectors to iterate over
	 * @param {Number} stride Number of elements between the start of each vec4. If 0 assumes tightly packed
	 * @param {Number} offset Number of elements to skip at the beginning of the array
	 * @param {Number} count Number of vec4s to iterate over. If 0 iterates over entire array
	 * @param {Function} fn Function to call for each vector in the array
	 * @param {Object} [arg] additional argument to pass to fn
	 * @returns {Array} a
	 * @function
	 */

	(function () {
	  var vec = create$3();
	  return function (a, stride, offset, count, fn, arg) {
	    var i, l;

	    if (!stride) {
	      stride = 4;
	    }

	    if (!offset) {
	      offset = 0;
	    }

	    if (count) {
	      l = Math.min(count * stride + offset, a.length);
	    } else {
	      l = a.length;
	    }

	    for (i = offset; i < l; i += stride) {
	      vec[0] = a[i];
	      vec[1] = a[i + 1];
	      vec[2] = a[i + 2];
	      vec[3] = a[i + 3];
	      fn(vec, vec, arg);
	      a[i] = vec[0];
	      a[i + 1] = vec[1];
	      a[i + 2] = vec[2];
	      a[i + 3] = vec[3];
	    }

	    return a;
	  };
	})();

	/**
	 * Quaternion
	 * @module quat
	 */

	/**
	 * Creates a new identity quat
	 *
	 * @returns {quat} a new quaternion
	 */

	function create$2() {
	  var out = new ARRAY_TYPE(4);

	  if (ARRAY_TYPE != Float32Array) {
	    out[0] = 0;
	    out[1] = 0;
	    out[2] = 0;
	  }

	  out[3] = 1;
	  return out;
	}
	/**
	 * Sets a quat from the given angle and rotation axis,
	 * then returns it.
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {ReadonlyVec3} axis the axis around which to rotate
	 * @param {Number} rad the angle in radians
	 * @returns {quat} out
	 **/

	function setAxisAngle(out, axis, rad) {
	  rad = rad * 0.5;
	  var s = Math.sin(rad);
	  out[0] = s * axis[0];
	  out[1] = s * axis[1];
	  out[2] = s * axis[2];
	  out[3] = Math.cos(rad);
	  return out;
	}
	/**
	 * Performs a spherical linear interpolation between two quat
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {ReadonlyQuat} a the first operand
	 * @param {ReadonlyQuat} b the second operand
	 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
	 * @returns {quat} out
	 */

	function slerp(out, a, b, t) {
	  // benchmarks:
	  //    http://jsperf.com/quaternion-slerp-implementations
	  var ax = a[0],
	      ay = a[1],
	      az = a[2],
	      aw = a[3];
	  var bx = b[0],
	      by = b[1],
	      bz = b[2],
	      bw = b[3];
	  var omega, cosom, sinom, scale0, scale1; // calc cosine

	  cosom = ax * bx + ay * by + az * bz + aw * bw; // adjust signs (if necessary)

	  if (cosom < 0.0) {
	    cosom = -cosom;
	    bx = -bx;
	    by = -by;
	    bz = -bz;
	    bw = -bw;
	  } // calculate coefficients


	  if (1.0 - cosom > EPSILON) {
	    // standard case (slerp)
	    omega = Math.acos(cosom);
	    sinom = Math.sin(omega);
	    scale0 = Math.sin((1.0 - t) * omega) / sinom;
	    scale1 = Math.sin(t * omega) / sinom;
	  } else {
	    // "from" and "to" quaternions are very close
	    //  ... so we can do a linear interpolation
	    scale0 = 1.0 - t;
	    scale1 = t;
	  } // calculate final values


	  out[0] = scale0 * ax + scale1 * bx;
	  out[1] = scale0 * ay + scale1 * by;
	  out[2] = scale0 * az + scale1 * bz;
	  out[3] = scale0 * aw + scale1 * bw;
	  return out;
	}
	/**
	 * Creates a quaternion from the given 3x3 rotation matrix.
	 *
	 * NOTE: The resultant quaternion is not normalized, so you should be sure
	 * to renormalize the quaternion yourself where necessary.
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {ReadonlyMat3} m rotation matrix
	 * @returns {quat} out
	 * @function
	 */

	function fromMat3(out, m) {
	  // Algorithm in Ken Shoemake's article in 1987 SIGGRAPH course notes
	  // article "Quaternion Calculus and Fast Animation".
	  var fTrace = m[0] + m[4] + m[8];
	  var fRoot;

	  if (fTrace > 0.0) {
	    // |w| > 1/2, may as well choose w > 1/2
	    fRoot = Math.sqrt(fTrace + 1.0); // 2w

	    out[3] = 0.5 * fRoot;
	    fRoot = 0.5 / fRoot; // 1/(4w)

	    out[0] = (m[5] - m[7]) * fRoot;
	    out[1] = (m[6] - m[2]) * fRoot;
	    out[2] = (m[1] - m[3]) * fRoot;
	  } else {
	    // |w| <= 1/2
	    var i = 0;
	    if (m[4] > m[0]) i = 1;
	    if (m[8] > m[i * 3 + i]) i = 2;
	    var j = (i + 1) % 3;
	    var k = (i + 2) % 3;
	    fRoot = Math.sqrt(m[i * 3 + i] - m[j * 3 + j] - m[k * 3 + k] + 1.0);
	    out[i] = 0.5 * fRoot;
	    fRoot = 0.5 / fRoot;
	    out[3] = (m[j * 3 + k] - m[k * 3 + j]) * fRoot;
	    out[j] = (m[j * 3 + i] + m[i * 3 + j]) * fRoot;
	    out[k] = (m[k * 3 + i] + m[i * 3 + k]) * fRoot;
	  }

	  return out;
	}
	/**
	 * Normalize a quat
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {ReadonlyQuat} a quaternion to normalize
	 * @returns {quat} out
	 * @function
	 */

	var normalize$2 = normalize$3;
	/**
	 * Sets a quaternion to represent the shortest rotation from one
	 * vector to another.
	 *
	 * Both vectors are assumed to be unit length.
	 *
	 * @param {quat} out the receiving quaternion.
	 * @param {ReadonlyVec3} a the initial vector
	 * @param {ReadonlyVec3} b the destination vector
	 * @returns {quat} out
	 */

	(function () {
	  var tmpvec3 = create$4();
	  var xUnitVec3 = fromValues$4(1, 0, 0);
	  var yUnitVec3 = fromValues$4(0, 1, 0);
	  return function (out, a, b) {
	    var dot = dot$5(a, b);

	    if (dot < -0.999999) {
	      cross$2(tmpvec3, xUnitVec3, a);
	      if (len$4(tmpvec3) < 0.000001) cross$2(tmpvec3, yUnitVec3, a);
	      normalize$4(tmpvec3, tmpvec3);
	      setAxisAngle(out, tmpvec3, Math.PI);
	      return out;
	    } else if (dot > 0.999999) {
	      out[0] = 0;
	      out[1] = 0;
	      out[2] = 0;
	      out[3] = 1;
	      return out;
	    } else {
	      cross$2(tmpvec3, a, b);
	      out[0] = tmpvec3[0];
	      out[1] = tmpvec3[1];
	      out[2] = tmpvec3[2];
	      out[3] = 1 + dot;
	      return normalize$2(out, out);
	    }
	  };
	})();
	/**
	 * Performs a spherical linear interpolation with two control points
	 *
	 * @param {quat} out the receiving quaternion
	 * @param {ReadonlyQuat} a the first operand
	 * @param {ReadonlyQuat} b the second operand
	 * @param {ReadonlyQuat} c the third operand
	 * @param {ReadonlyQuat} d the fourth operand
	 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
	 * @returns {quat} out
	 */

	(function () {
	  var temp1 = create$2();
	  var temp2 = create$2();
	  return function (out, a, b, c, d, t) {
	    slerp(temp1, a, d, t);
	    slerp(temp2, b, c, t);
	    slerp(out, temp1, temp2, 2 * t * (1 - t));
	    return out;
	  };
	})();
	/**
	 * Sets the specified quaternion with values corresponding to the given
	 * axes. Each axis is a vec3 and is expected to be unit length and
	 * perpendicular to all other specified axes.
	 *
	 * @param {ReadonlyVec3} view  the vector representing the viewing direction
	 * @param {ReadonlyVec3} right the vector representing the local "right" direction
	 * @param {ReadonlyVec3} up    the vector representing the local "up" direction
	 * @returns {quat} out
	 */

	(function () {
	  var matr = create$6();
	  return function (out, view, right, up) {
	    matr[0] = right[0];
	    matr[3] = right[1];
	    matr[6] = right[2];
	    matr[1] = up[0];
	    matr[4] = up[1];
	    matr[7] = up[2];
	    matr[2] = -view[0];
	    matr[5] = -view[1];
	    matr[8] = -view[2];
	    return normalize$2(out, fromMat3(out, matr));
	  };
	})();

	/**
	 * 2 Dimensional Vector
	 * @module vec2
	 */

	/**
	 * Creates a new, empty vec2
	 *
	 * @returns {vec2} a new 2D vector
	 */

	function create() {
	  var out = new ARRAY_TYPE(2);

	  if (ARRAY_TYPE != Float32Array) {
	    out[0] = 0;
	    out[1] = 0;
	  }

	  return out;
	}
	/**
	 * Calculates the squared length of a vec2
	 *
	 * @param {ReadonlyVec2} a vector to calculate squared length of
	 * @returns {Number} squared length of a
	 */

	function squaredLength(a) {
	  var x = a[0],
	      y = a[1];
	  return x * x + y * y;
	}
	/**
	 * Transforms the vec2 with a mat4
	 * 3rd vector component is implicitly '0'
	 * 4th vector component is implicitly '1'
	 *
	 * @param {vec2} out the receiving vector
	 * @param {ReadonlyVec2} a the vector to transform
	 * @param {ReadonlyMat4} m matrix to transform with
	 * @returns {vec2} out
	 */

	function transformMat4(out, a, m) {
	  var x = a[0];
	  var y = a[1];
	  out[0] = m[0] * x + m[4] * y + m[12];
	  out[1] = m[1] * x + m[5] * y + m[13];
	  return out;
	}
	/**
	 * Alias for {@link vec2.squaredLength}
	 * @function
	 */

	var sqrLen = squaredLength;
	/**
	 * Perform some operation over an array of vec2s.
	 *
	 * @param {Array} a the array of vectors to iterate over
	 * @param {Number} stride Number of elements between the start of each vec2. If 0 assumes tightly packed
	 * @param {Number} offset Number of elements to skip at the beginning of the array
	 * @param {Number} count Number of vec2s to iterate over. If 0 iterates over entire array
	 * @param {Function} fn Function to call for each vector in the array
	 * @param {Object} [arg] additional argument to pass to fn
	 * @returns {Array} a
	 * @function
	 */

	(function () {
	  var vec = create();
	  return function (a, stride, offset, count, fn, arg) {
	    var i, l;

	    if (!stride) {
	      stride = 2;
	    }

	    if (!offset) {
	      offset = 0;
	    }

	    if (count) {
	      l = Math.min(count * stride + offset, a.length);
	    } else {
	      l = a.length;
	    }

	    for (i = offset; i < l; i += stride) {
	      vec[0] = a[i];
	      vec[1] = a[i + 1];
	      fn(vec, vec, arg);
	      a[i] = vec[0];
	      a[i + 1] = vec[1];
	    }

	    return a;
	  };
	})();

	/**
	 * A style layer that defines a circle
	 */
	class CircleStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties$8);
	    }
	    createBucket(parameters) {
	        return new CircleBucket(parameters);
	    }
	    queryRadius(bucket) {
	        const circleBucket = bucket;
	        return getMaximumPaintValue('circle-radius', this, circleBucket) +
	            getMaximumPaintValue('circle-stroke-width', this, circleBucket) +
	            translateDistance(this.paint.get('circle-translate'));
	    }
	    queryIntersectsFeature(queryGeometry, feature, featureState, geometry, zoom, transform, pixelsToTileUnits, pixelPosMatrix) {
	        const translatedPolygon = translate$4(queryGeometry, this.paint.get('circle-translate'), this.paint.get('circle-translate-anchor'), transform.angle, pixelsToTileUnits);
	        const radius = this.paint.get('circle-radius').evaluate(feature, featureState);
	        const stroke = this.paint.get('circle-stroke-width').evaluate(feature, featureState);
	        const size = radius + stroke;
	        // For pitch-alignment: map, compare feature geometry to query geometry in the plane of the tile
	        // // Otherwise, compare geometry in the plane of the viewport
	        // // A circle with fixed scaling relative to the viewport gets larger in tile space as it moves into the distance
	        // // A circle with fixed scaling relative to the map gets smaller in viewport space as it moves into the distance
	        const alignWithMap = this.paint.get('circle-pitch-alignment') === 'map';
	        const transformedPolygon = alignWithMap ? translatedPolygon : projectQueryGeometry$1(translatedPolygon, pixelPosMatrix);
	        const transformedSize = alignWithMap ? size * pixelsToTileUnits : size;
	        for (const ring of geometry) {
	            for (const point of ring) {
	                const transformedPoint = alignWithMap ? point : projectPoint(point, pixelPosMatrix);
	                let adjustedSize = transformedSize;
	                const projectedCenter = transformMat4$1([], [point.x, point.y, 0, 1], pixelPosMatrix);
	                if (this.paint.get('circle-pitch-scale') === 'viewport' && this.paint.get('circle-pitch-alignment') === 'map') {
	                    adjustedSize *= projectedCenter[3] / transform.cameraToCenterDistance;
	                }
	                else if (this.paint.get('circle-pitch-scale') === 'map' && this.paint.get('circle-pitch-alignment') === 'viewport') {
	                    adjustedSize *= transform.cameraToCenterDistance / projectedCenter[3];
	                }
	                if (polygonIntersectsBufferedPoint(transformedPolygon, transformedPoint, adjustedSize))
	                    return true;
	            }
	        }
	        return false;
	    }
	}
	function projectPoint(p, pixelPosMatrix) {
	    const point = transformMat4$1([], [p.x, p.y, 0, 1], pixelPosMatrix);
	    return new Point$2(point[0] / point[3], point[1] / point[3]);
	}
	function projectQueryGeometry$1(queryGeometry, pixelPosMatrix) {
	    return queryGeometry.map((p) => {
	        return projectPoint(p, pixelPosMatrix);
	    });
	}

	class HeatmapBucket extends CircleBucket {
	}
	register('HeatmapBucket', HeatmapBucket, { omit: ['layers'] });

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let paint$7;
	const getPaint$7 = () => paint$7 = paint$7 || new Properties({
	    "heatmap-radius": new DataDrivenProperty(v8Spec["paint_heatmap"]["heatmap-radius"]),
	    "heatmap-weight": new DataDrivenProperty(v8Spec["paint_heatmap"]["heatmap-weight"]),
	    "heatmap-intensity": new DataConstantProperty(v8Spec["paint_heatmap"]["heatmap-intensity"]),
	    "heatmap-color": new ColorRampProperty(v8Spec["paint_heatmap"]["heatmap-color"]),
	    "heatmap-opacity": new DataConstantProperty(v8Spec["paint_heatmap"]["heatmap-opacity"]),
	});
	var properties$7 = ({ get paint() { return getPaint$7(); } });

	function createImage(image, { width, height }, channels, data) {
	    if (!data) {
	        data = new Uint8Array(width * height * channels);
	    }
	    else if (data instanceof Uint8ClampedArray) {
	        data = new Uint8Array(data.buffer);
	    }
	    else if (data.length !== width * height * channels) {
	        throw new RangeError(`mismatched image size. expected: ${data.length} but got: ${width * height * channels}`);
	    }
	    image.width = width;
	    image.height = height;
	    image.data = data;
	    return image;
	}
	function resizeImage(image, { width, height }, channels) {
	    if (width === image.width && height === image.height) {
	        return;
	    }
	    const newImage = createImage({}, { width, height }, channels);
	    copyImage(image, newImage, { x: 0, y: 0 }, { x: 0, y: 0 }, {
	        width: Math.min(image.width, width),
	        height: Math.min(image.height, height)
	    }, channels);
	    image.width = width;
	    image.height = height;
	    image.data = newImage.data;
	}
	function copyImage(srcImg, dstImg, srcPt, dstPt, size, channels) {
	    if (size.width === 0 || size.height === 0) {
	        return dstImg;
	    }
	    if (size.width > srcImg.width ||
	        size.height > srcImg.height ||
	        srcPt.x > srcImg.width - size.width ||
	        srcPt.y > srcImg.height - size.height) {
	        throw new RangeError('out of range source coordinates for image copy');
	    }
	    if (size.width > dstImg.width ||
	        size.height > dstImg.height ||
	        dstPt.x > dstImg.width - size.width ||
	        dstPt.y > dstImg.height - size.height) {
	        throw new RangeError('out of range destination coordinates for image copy');
	    }
	    const srcData = srcImg.data;
	    const dstData = dstImg.data;
	    if (srcData === dstData)
	        throw new Error('srcData equals dstData, so image is already copied');
	    for (let y = 0; y < size.height; y++) {
	        const srcOffset = ((srcPt.y + y) * srcImg.width + srcPt.x) * channels;
	        const dstOffset = ((dstPt.y + y) * dstImg.width + dstPt.x) * channels;
	        for (let i = 0; i < size.width * channels; i++) {
	            dstData[dstOffset + i] = srcData[srcOffset + i];
	        }
	    }
	    return dstImg;
	}
	/**
	 * An image with alpha color value
	 */
	class AlphaImage {
	    constructor(size, data) {
	        createImage(this, size, 1, data);
	    }
	    resize(size) {
	        resizeImage(this, size, 1);
	    }
	    clone() {
	        return new AlphaImage({ width: this.width, height: this.height }, new Uint8Array(this.data));
	    }
	    static copy(srcImg, dstImg, srcPt, dstPt, size) {
	        copyImage(srcImg, dstImg, srcPt, dstPt, size, 1);
	    }
	}
	/**
	 * An object to store image data not premultiplied, because ImageData is not premultiplied.
	 * UNPACK_PREMULTIPLY_ALPHA_WEBGL must be used when uploading to a texture.
	 */
	class RGBAImage {
	    constructor(size, data) {
	        createImage(this, size, 4, data);
	    }
	    resize(size) {
	        resizeImage(this, size, 4);
	    }
	    replace(data, copy) {
	        if (copy) {
	            this.data.set(data);
	        }
	        else if (data instanceof Uint8ClampedArray) {
	            this.data = new Uint8Array(data.buffer);
	        }
	        else {
	            this.data = data;
	        }
	    }
	    clone() {
	        return new RGBAImage({ width: this.width, height: this.height }, new Uint8Array(this.data));
	    }
	    static copy(srcImg, dstImg, srcPt, dstPt, size) {
	        copyImage(srcImg, dstImg, srcPt, dstPt, size, 4);
	    }
	}
	register('AlphaImage', AlphaImage);
	register('RGBAImage', RGBAImage);

	/**
	 * Given an expression that should evaluate to a color ramp,
	 * return a RGBA image representing that ramp expression.
	 */
	function renderColorRamp(params) {
	    const evaluationGlobals = {};
	    const width = params.resolution || 256;
	    const height = params.clips ? params.clips.length : 1;
	    const image = params.image || new RGBAImage({ width, height });
	    if (!isPowerOfTwo(width))
	        throw new Error(`width is not a power of 2 - ${width}`);
	    const renderPixel = (stride, index, progress) => {
	        evaluationGlobals[params.evaluationKey] = progress;
	        const pxColor = params.expression.evaluate(evaluationGlobals);
	        // the colors are being unpremultiplied because Color uses
	        // premultiplied values, and the Texture class expects unpremultiplied ones
	        image.data[stride + index + 0] = Math.floor(pxColor.r * 255 / pxColor.a);
	        image.data[stride + index + 1] = Math.floor(pxColor.g * 255 / pxColor.a);
	        image.data[stride + index + 2] = Math.floor(pxColor.b * 255 / pxColor.a);
	        image.data[stride + index + 3] = Math.floor(pxColor.a * 255);
	    };
	    if (!params.clips) {
	        for (let i = 0, j = 0; i < width; i++, j += 4) {
	            const progress = i / (width - 1);
	            renderPixel(0, j, progress);
	        }
	    }
	    else {
	        for (let clip = 0, stride = 0; clip < height; ++clip, stride += width * 4) {
	            for (let i = 0, j = 0; i < width; i++, j += 4) {
	                // Remap progress between clips
	                const progress = i / (width - 1);
	                const { start, end } = params.clips[clip];
	                const evaluationProgress = start * (1 - progress) + end * progress;
	                renderPixel(stride, j, evaluationProgress);
	            }
	        }
	    }
	    return image;
	}

	/**
	 * A style layer that defines a heatmap
	 */
	class HeatmapStyleLayer extends StyleLayer {
	    createBucket(options) {
	        return new HeatmapBucket(options);
	    }
	    constructor(layer) {
	        super(layer, properties$7);
	        // make sure color ramp texture is generated for default heatmap color too
	        this._updateColorRamp();
	    }
	    _handleSpecialPaintPropertyUpdate(name) {
	        if (name === 'heatmap-color') {
	            this._updateColorRamp();
	        }
	    }
	    _updateColorRamp() {
	        const expression = this._transitionablePaint._values['heatmap-color'].value.expression;
	        this.colorRamp = renderColorRamp({
	            expression,
	            evaluationKey: 'heatmapDensity',
	            image: this.colorRamp
	        });
	        this.colorRampTexture = null;
	    }
	    resize() {
	        if (this.heatmapFbo) {
	            this.heatmapFbo.destroy();
	            this.heatmapFbo = null;
	        }
	    }
	    queryRadius() {
	        return 0;
	    }
	    queryIntersectsFeature() {
	        return false;
	    }
	    hasOffscreenPass() {
	        return this.paint.get('heatmap-opacity') !== 0 && this.visibility !== 'none';
	    }
	}

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let paint$6;
	const getPaint$6 = () => paint$6 = paint$6 || new Properties({
	    "hillshade-illumination-direction": new DataConstantProperty(v8Spec["paint_hillshade"]["hillshade-illumination-direction"]),
	    "hillshade-illumination-anchor": new DataConstantProperty(v8Spec["paint_hillshade"]["hillshade-illumination-anchor"]),
	    "hillshade-exaggeration": new DataConstantProperty(v8Spec["paint_hillshade"]["hillshade-exaggeration"]),
	    "hillshade-shadow-color": new DataConstantProperty(v8Spec["paint_hillshade"]["hillshade-shadow-color"]),
	    "hillshade-highlight-color": new DataConstantProperty(v8Spec["paint_hillshade"]["hillshade-highlight-color"]),
	    "hillshade-accent-color": new DataConstantProperty(v8Spec["paint_hillshade"]["hillshade-accent-color"]),
	});
	var properties$6 = ({ get paint() { return getPaint$6(); } });

	class HillshadeStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties$6);
	    }
	    hasOffscreenPass() {
	        return this.paint.get('hillshade-exaggeration') !== 0 && this.visibility !== 'none';
	    }
	}

	const layout$4 = createLayout([
	    { name: 'a_pos', components: 2, type: 'Int16' }
	], 4);
	const { members: members$3, size: size$3, alignment: alignment$3 } = layout$4;

	var earcut$2 = {exports: {}};

	earcut$2.exports = earcut;
	earcut$2.exports.default = earcut;

	function earcut(data, holeIndices, dim) {

	    dim = dim || 2;

	    var hasHoles = holeIndices && holeIndices.length,
	        outerLen = hasHoles ? holeIndices[0] * dim : data.length,
	        outerNode = linkedList(data, 0, outerLen, dim, true),
	        triangles = [];

	    if (!outerNode || outerNode.next === outerNode.prev) return triangles;

	    var minX, minY, maxX, maxY, x, y, invSize;

	    if (hasHoles) outerNode = eliminateHoles(data, holeIndices, outerNode, dim);

	    // if the shape is not too simple, we'll use z-order curve hash later; calculate polygon bbox
	    if (data.length > 80 * dim) {
	        minX = maxX = data[0];
	        minY = maxY = data[1];

	        for (var i = dim; i < outerLen; i += dim) {
	            x = data[i];
	            y = data[i + 1];
	            if (x < minX) minX = x;
	            if (y < minY) minY = y;
	            if (x > maxX) maxX = x;
	            if (y > maxY) maxY = y;
	        }

	        // minX, minY and invSize are later used to transform coords into integers for z-order calculation
	        invSize = Math.max(maxX - minX, maxY - minY);
	        invSize = invSize !== 0 ? 32767 / invSize : 0;
	    }

	    earcutLinked(outerNode, triangles, dim, minX, minY, invSize, 0);

	    return triangles;
	}

	// create a circular doubly linked list from polygon points in the specified winding order
	function linkedList(data, start, end, dim, clockwise) {
	    var i, last;

	    if (clockwise === (signedArea$1(data, start, end, dim) > 0)) {
	        for (i = start; i < end; i += dim) last = insertNode(i, data[i], data[i + 1], last);
	    } else {
	        for (i = end - dim; i >= start; i -= dim) last = insertNode(i, data[i], data[i + 1], last);
	    }

	    if (last && equals(last, last.next)) {
	        removeNode(last);
	        last = last.next;
	    }

	    return last;
	}

	// eliminate colinear or duplicate points
	function filterPoints(start, end) {
	    if (!start) return start;
	    if (!end) end = start;

	    var p = start,
	        again;
	    do {
	        again = false;

	        if (!p.steiner && (equals(p, p.next) || area(p.prev, p, p.next) === 0)) {
	            removeNode(p);
	            p = end = p.prev;
	            if (p === p.next) break;
	            again = true;

	        } else {
	            p = p.next;
	        }
	    } while (again || p !== end);

	    return end;
	}

	// main ear slicing loop which triangulates a polygon (given as a linked list)
	function earcutLinked(ear, triangles, dim, minX, minY, invSize, pass) {
	    if (!ear) return;

	    // interlink polygon nodes in z-order
	    if (!pass && invSize) indexCurve(ear, minX, minY, invSize);

	    var stop = ear,
	        prev, next;

	    // iterate through ears, slicing them one by one
	    while (ear.prev !== ear.next) {
	        prev = ear.prev;
	        next = ear.next;

	        if (invSize ? isEarHashed(ear, minX, minY, invSize) : isEar(ear)) {
	            // cut off the triangle
	            triangles.push(prev.i / dim | 0);
	            triangles.push(ear.i / dim | 0);
	            triangles.push(next.i / dim | 0);

	            removeNode(ear);

	            // skipping the next vertex leads to less sliver triangles
	            ear = next.next;
	            stop = next.next;

	            continue;
	        }

	        ear = next;

	        // if we looped through the whole remaining polygon and can't find any more ears
	        if (ear === stop) {
	            // try filtering points and slicing again
	            if (!pass) {
	                earcutLinked(filterPoints(ear), triangles, dim, minX, minY, invSize, 1);

	            // if this didn't work, try curing all small self-intersections locally
	            } else if (pass === 1) {
	                ear = cureLocalIntersections(filterPoints(ear), triangles, dim);
	                earcutLinked(ear, triangles, dim, minX, minY, invSize, 2);

	            // as a last resort, try splitting the remaining polygon into two
	            } else if (pass === 2) {
	                splitEarcut(ear, triangles, dim, minX, minY, invSize);
	            }

	            break;
	        }
	    }
	}

	// check whether a polygon node forms a valid ear with adjacent nodes
	function isEar(ear) {
	    var a = ear.prev,
	        b = ear,
	        c = ear.next;

	    if (area(a, b, c) >= 0) return false; // reflex, can't be an ear

	    // now make sure we don't have other points inside the potential ear
	    var ax = a.x, bx = b.x, cx = c.x, ay = a.y, by = b.y, cy = c.y;

	    // triangle bbox; min & max are calculated like this for speed
	    var x0 = ax < bx ? (ax < cx ? ax : cx) : (bx < cx ? bx : cx),
	        y0 = ay < by ? (ay < cy ? ay : cy) : (by < cy ? by : cy),
	        x1 = ax > bx ? (ax > cx ? ax : cx) : (bx > cx ? bx : cx),
	        y1 = ay > by ? (ay > cy ? ay : cy) : (by > cy ? by : cy);

	    var p = c.next;
	    while (p !== a) {
	        if (p.x >= x0 && p.x <= x1 && p.y >= y0 && p.y <= y1 &&
	            pointInTriangle(ax, ay, bx, by, cx, cy, p.x, p.y) &&
	            area(p.prev, p, p.next) >= 0) return false;
	        p = p.next;
	    }

	    return true;
	}

	function isEarHashed(ear, minX, minY, invSize) {
	    var a = ear.prev,
	        b = ear,
	        c = ear.next;

	    if (area(a, b, c) >= 0) return false; // reflex, can't be an ear

	    var ax = a.x, bx = b.x, cx = c.x, ay = a.y, by = b.y, cy = c.y;

	    // triangle bbox; min & max are calculated like this for speed
	    var x0 = ax < bx ? (ax < cx ? ax : cx) : (bx < cx ? bx : cx),
	        y0 = ay < by ? (ay < cy ? ay : cy) : (by < cy ? by : cy),
	        x1 = ax > bx ? (ax > cx ? ax : cx) : (bx > cx ? bx : cx),
	        y1 = ay > by ? (ay > cy ? ay : cy) : (by > cy ? by : cy);

	    // z-order range for the current triangle bbox;
	    var minZ = zOrder(x0, y0, minX, minY, invSize),
	        maxZ = zOrder(x1, y1, minX, minY, invSize);

	    var p = ear.prevZ,
	        n = ear.nextZ;

	    // look for points inside the triangle in both directions
	    while (p && p.z >= minZ && n && n.z <= maxZ) {
	        if (p.x >= x0 && p.x <= x1 && p.y >= y0 && p.y <= y1 && p !== a && p !== c &&
	            pointInTriangle(ax, ay, bx, by, cx, cy, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
	        p = p.prevZ;

	        if (n.x >= x0 && n.x <= x1 && n.y >= y0 && n.y <= y1 && n !== a && n !== c &&
	            pointInTriangle(ax, ay, bx, by, cx, cy, n.x, n.y) && area(n.prev, n, n.next) >= 0) return false;
	        n = n.nextZ;
	    }

	    // look for remaining points in decreasing z-order
	    while (p && p.z >= minZ) {
	        if (p.x >= x0 && p.x <= x1 && p.y >= y0 && p.y <= y1 && p !== a && p !== c &&
	            pointInTriangle(ax, ay, bx, by, cx, cy, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
	        p = p.prevZ;
	    }

	    // look for remaining points in increasing z-order
	    while (n && n.z <= maxZ) {
	        if (n.x >= x0 && n.x <= x1 && n.y >= y0 && n.y <= y1 && n !== a && n !== c &&
	            pointInTriangle(ax, ay, bx, by, cx, cy, n.x, n.y) && area(n.prev, n, n.next) >= 0) return false;
	        n = n.nextZ;
	    }

	    return true;
	}

	// go through all polygon nodes and cure small local self-intersections
	function cureLocalIntersections(start, triangles, dim) {
	    var p = start;
	    do {
	        var a = p.prev,
	            b = p.next.next;

	        if (!equals(a, b) && intersects(a, p, p.next, b) && locallyInside(a, b) && locallyInside(b, a)) {

	            triangles.push(a.i / dim | 0);
	            triangles.push(p.i / dim | 0);
	            triangles.push(b.i / dim | 0);

	            // remove two nodes involved
	            removeNode(p);
	            removeNode(p.next);

	            p = start = b;
	        }
	        p = p.next;
	    } while (p !== start);

	    return filterPoints(p);
	}

	// try splitting polygon into two and triangulate them independently
	function splitEarcut(start, triangles, dim, minX, minY, invSize) {
	    // look for a valid diagonal that divides the polygon into two
	    var a = start;
	    do {
	        var b = a.next.next;
	        while (b !== a.prev) {
	            if (a.i !== b.i && isValidDiagonal(a, b)) {
	                // split the polygon in two by the diagonal
	                var c = splitPolygon(a, b);

	                // filter colinear points around the cuts
	                a = filterPoints(a, a.next);
	                c = filterPoints(c, c.next);

	                // run earcut on each half
	                earcutLinked(a, triangles, dim, minX, minY, invSize, 0);
	                earcutLinked(c, triangles, dim, minX, minY, invSize, 0);
	                return;
	            }
	            b = b.next;
	        }
	        a = a.next;
	    } while (a !== start);
	}

	// link every hole into the outer loop, producing a single-ring polygon without holes
	function eliminateHoles(data, holeIndices, outerNode, dim) {
	    var queue = [],
	        i, len, start, end, list;

	    for (i = 0, len = holeIndices.length; i < len; i++) {
	        start = holeIndices[i] * dim;
	        end = i < len - 1 ? holeIndices[i + 1] * dim : data.length;
	        list = linkedList(data, start, end, dim, false);
	        if (list === list.next) list.steiner = true;
	        queue.push(getLeftmost(list));
	    }

	    queue.sort(compareX);

	    // process holes from left to right
	    for (i = 0; i < queue.length; i++) {
	        outerNode = eliminateHole(queue[i], outerNode);
	    }

	    return outerNode;
	}

	function compareX(a, b) {
	    return a.x - b.x;
	}

	// find a bridge between vertices that connects hole with an outer ring and and link it
	function eliminateHole(hole, outerNode) {
	    var bridge = findHoleBridge(hole, outerNode);
	    if (!bridge) {
	        return outerNode;
	    }

	    var bridgeReverse = splitPolygon(bridge, hole);

	    // filter collinear points around the cuts
	    filterPoints(bridgeReverse, bridgeReverse.next);
	    return filterPoints(bridge, bridge.next);
	}

	// David Eberly's algorithm for finding a bridge between hole and outer polygon
	function findHoleBridge(hole, outerNode) {
	    var p = outerNode,
	        hx = hole.x,
	        hy = hole.y,
	        qx = -Infinity,
	        m;

	    // find a segment intersected by a ray from the hole's leftmost point to the left;
	    // segment's endpoint with lesser x will be potential connection point
	    do {
	        if (hy <= p.y && hy >= p.next.y && p.next.y !== p.y) {
	            var x = p.x + (hy - p.y) * (p.next.x - p.x) / (p.next.y - p.y);
	            if (x <= hx && x > qx) {
	                qx = x;
	                m = p.x < p.next.x ? p : p.next;
	                if (x === hx) return m; // hole touches outer segment; pick leftmost endpoint
	            }
	        }
	        p = p.next;
	    } while (p !== outerNode);

	    if (!m) return null;

	    // look for points inside the triangle of hole point, segment intersection and endpoint;
	    // if there are no points found, we have a valid connection;
	    // otherwise choose the point of the minimum angle with the ray as connection point

	    var stop = m,
	        mx = m.x,
	        my = m.y,
	        tanMin = Infinity,
	        tan;

	    p = m;

	    do {
	        if (hx >= p.x && p.x >= mx && hx !== p.x &&
	                pointInTriangle(hy < my ? hx : qx, hy, mx, my, hy < my ? qx : hx, hy, p.x, p.y)) {

	            tan = Math.abs(hy - p.y) / (hx - p.x); // tangential

	            if (locallyInside(p, hole) &&
	                (tan < tanMin || (tan === tanMin && (p.x > m.x || (p.x === m.x && sectorContainsSector(m, p)))))) {
	                m = p;
	                tanMin = tan;
	            }
	        }

	        p = p.next;
	    } while (p !== stop);

	    return m;
	}

	// whether sector in vertex m contains sector in vertex p in the same coordinates
	function sectorContainsSector(m, p) {
	    return area(m.prev, m, p.prev) < 0 && area(p.next, m, m.next) < 0;
	}

	// interlink polygon nodes in z-order
	function indexCurve(start, minX, minY, invSize) {
	    var p = start;
	    do {
	        if (p.z === 0) p.z = zOrder(p.x, p.y, minX, minY, invSize);
	        p.prevZ = p.prev;
	        p.nextZ = p.next;
	        p = p.next;
	    } while (p !== start);

	    p.prevZ.nextZ = null;
	    p.prevZ = null;

	    sortLinked(p);
	}

	// Simon Tatham's linked list merge sort algorithm
	// http://www.chiark.greenend.org.uk/~sgtatham/algorithms/listsort.html
	function sortLinked(list) {
	    var i, p, q, e, tail, numMerges, pSize, qSize,
	        inSize = 1;

	    do {
	        p = list;
	        list = null;
	        tail = null;
	        numMerges = 0;

	        while (p) {
	            numMerges++;
	            q = p;
	            pSize = 0;
	            for (i = 0; i < inSize; i++) {
	                pSize++;
	                q = q.nextZ;
	                if (!q) break;
	            }
	            qSize = inSize;

	            while (pSize > 0 || (qSize > 0 && q)) {

	                if (pSize !== 0 && (qSize === 0 || !q || p.z <= q.z)) {
	                    e = p;
	                    p = p.nextZ;
	                    pSize--;
	                } else {
	                    e = q;
	                    q = q.nextZ;
	                    qSize--;
	                }

	                if (tail) tail.nextZ = e;
	                else list = e;

	                e.prevZ = tail;
	                tail = e;
	            }

	            p = q;
	        }

	        tail.nextZ = null;
	        inSize *= 2;

	    } while (numMerges > 1);

	    return list;
	}

	// z-order of a point given coords and inverse of the longer side of data bbox
	function zOrder(x, y, minX, minY, invSize) {
	    // coords are transformed into non-negative 15-bit integer range
	    x = (x - minX) * invSize | 0;
	    y = (y - minY) * invSize | 0;

	    x = (x | (x << 8)) & 0x00FF00FF;
	    x = (x | (x << 4)) & 0x0F0F0F0F;
	    x = (x | (x << 2)) & 0x33333333;
	    x = (x | (x << 1)) & 0x55555555;

	    y = (y | (y << 8)) & 0x00FF00FF;
	    y = (y | (y << 4)) & 0x0F0F0F0F;
	    y = (y | (y << 2)) & 0x33333333;
	    y = (y | (y << 1)) & 0x55555555;

	    return x | (y << 1);
	}

	// find the leftmost node of a polygon ring
	function getLeftmost(start) {
	    var p = start,
	        leftmost = start;
	    do {
	        if (p.x < leftmost.x || (p.x === leftmost.x && p.y < leftmost.y)) leftmost = p;
	        p = p.next;
	    } while (p !== start);

	    return leftmost;
	}

	// check if a point lies within a convex triangle
	function pointInTriangle(ax, ay, bx, by, cx, cy, px, py) {
	    return (cx - px) * (ay - py) >= (ax - px) * (cy - py) &&
	           (ax - px) * (by - py) >= (bx - px) * (ay - py) &&
	           (bx - px) * (cy - py) >= (cx - px) * (by - py);
	}

	// check if a diagonal between two polygon nodes is valid (lies in polygon interior)
	function isValidDiagonal(a, b) {
	    return a.next.i !== b.i && a.prev.i !== b.i && !intersectsPolygon(a, b) && // dones't intersect other edges
	           (locallyInside(a, b) && locallyInside(b, a) && middleInside(a, b) && // locally visible
	            (area(a.prev, a, b.prev) || area(a, b.prev, b)) || // does not create opposite-facing sectors
	            equals(a, b) && area(a.prev, a, a.next) > 0 && area(b.prev, b, b.next) > 0); // special zero-length case
	}

	// signed area of a triangle
	function area(p, q, r) {
	    return (q.y - p.y) * (r.x - q.x) - (q.x - p.x) * (r.y - q.y);
	}

	// check if two points are equal
	function equals(p1, p2) {
	    return p1.x === p2.x && p1.y === p2.y;
	}

	// check if two segments intersect
	function intersects(p1, q1, p2, q2) {
	    var o1 = sign(area(p1, q1, p2));
	    var o2 = sign(area(p1, q1, q2));
	    var o3 = sign(area(p2, q2, p1));
	    var o4 = sign(area(p2, q2, q1));

	    if (o1 !== o2 && o3 !== o4) return true; // general case

	    if (o1 === 0 && onSegment(p1, p2, q1)) return true; // p1, q1 and p2 are collinear and p2 lies on p1q1
	    if (o2 === 0 && onSegment(p1, q2, q1)) return true; // p1, q1 and q2 are collinear and q2 lies on p1q1
	    if (o3 === 0 && onSegment(p2, p1, q2)) return true; // p2, q2 and p1 are collinear and p1 lies on p2q2
	    if (o4 === 0 && onSegment(p2, q1, q2)) return true; // p2, q2 and q1 are collinear and q1 lies on p2q2

	    return false;
	}

	// for collinear points p, q, r, check if point q lies on segment pr
	function onSegment(p, q, r) {
	    return q.x <= Math.max(p.x, r.x) && q.x >= Math.min(p.x, r.x) && q.y <= Math.max(p.y, r.y) && q.y >= Math.min(p.y, r.y);
	}

	function sign(num) {
	    return num > 0 ? 1 : num < 0 ? -1 : 0;
	}

	// check if a polygon diagonal intersects any polygon segments
	function intersectsPolygon(a, b) {
	    var p = a;
	    do {
	        if (p.i !== a.i && p.next.i !== a.i && p.i !== b.i && p.next.i !== b.i &&
	                intersects(p, p.next, a, b)) return true;
	        p = p.next;
	    } while (p !== a);

	    return false;
	}

	// check if a polygon diagonal is locally inside the polygon
	function locallyInside(a, b) {
	    return area(a.prev, a, a.next) < 0 ?
	        area(a, b, a.next) >= 0 && area(a, a.prev, b) >= 0 :
	        area(a, b, a.prev) < 0 || area(a, a.next, b) < 0;
	}

	// check if the middle point of a polygon diagonal is inside the polygon
	function middleInside(a, b) {
	    var p = a,
	        inside = false,
	        px = (a.x + b.x) / 2,
	        py = (a.y + b.y) / 2;
	    do {
	        if (((p.y > py) !== (p.next.y > py)) && p.next.y !== p.y &&
	                (px < (p.next.x - p.x) * (py - p.y) / (p.next.y - p.y) + p.x))
	            inside = !inside;
	        p = p.next;
	    } while (p !== a);

	    return inside;
	}

	// link two polygon vertices with a bridge; if the vertices belong to the same ring, it splits polygon into two;
	// if one belongs to the outer ring and another to a hole, it merges it into a single ring
	function splitPolygon(a, b) {
	    var a2 = new Node(a.i, a.x, a.y),
	        b2 = new Node(b.i, b.x, b.y),
	        an = a.next,
	        bp = b.prev;

	    a.next = b;
	    b.prev = a;

	    a2.next = an;
	    an.prev = a2;

	    b2.next = a2;
	    a2.prev = b2;

	    bp.next = b2;
	    b2.prev = bp;

	    return b2;
	}

	// create a node and optionally link it with previous one (in a circular doubly linked list)
	function insertNode(i, x, y, last) {
	    var p = new Node(i, x, y);

	    if (!last) {
	        p.prev = p;
	        p.next = p;

	    } else {
	        p.next = last.next;
	        p.prev = last;
	        last.next.prev = p;
	        last.next = p;
	    }
	    return p;
	}

	function removeNode(p) {
	    p.next.prev = p.prev;
	    p.prev.next = p.next;

	    if (p.prevZ) p.prevZ.nextZ = p.nextZ;
	    if (p.nextZ) p.nextZ.prevZ = p.prevZ;
	}

	function Node(i, x, y) {
	    // vertex index in coordinates array
	    this.i = i;

	    // vertex coordinates
	    this.x = x;
	    this.y = y;

	    // previous and next vertex nodes in a polygon ring
	    this.prev = null;
	    this.next = null;

	    // z-order curve value
	    this.z = 0;

	    // previous and next nodes in z-order
	    this.prevZ = null;
	    this.nextZ = null;

	    // indicates whether this is a steiner point
	    this.steiner = false;
	}

	// return a percentage difference between the polygon area and its triangulation area;
	// used to verify correctness of triangulation
	earcut.deviation = function (data, holeIndices, dim, triangles) {
	    var hasHoles = holeIndices && holeIndices.length;
	    var outerLen = hasHoles ? holeIndices[0] * dim : data.length;

	    var polygonArea = Math.abs(signedArea$1(data, 0, outerLen, dim));
	    if (hasHoles) {
	        for (var i = 0, len = holeIndices.length; i < len; i++) {
	            var start = holeIndices[i] * dim;
	            var end = i < len - 1 ? holeIndices[i + 1] * dim : data.length;
	            polygonArea -= Math.abs(signedArea$1(data, start, end, dim));
	        }
	    }

	    var trianglesArea = 0;
	    for (i = 0; i < triangles.length; i += 3) {
	        var a = triangles[i] * dim;
	        var b = triangles[i + 1] * dim;
	        var c = triangles[i + 2] * dim;
	        trianglesArea += Math.abs(
	            (data[a] - data[c]) * (data[b + 1] - data[a + 1]) -
	            (data[a] - data[b]) * (data[c + 1] - data[a + 1]));
	    }

	    return polygonArea === 0 && trianglesArea === 0 ? 0 :
	        Math.abs((trianglesArea - polygonArea) / polygonArea);
	};

	function signedArea$1(data, start, end, dim) {
	    var sum = 0;
	    for (var i = start, j = end - dim; i < end; i += dim) {
	        sum += (data[j] - data[i]) * (data[i + 1] + data[j + 1]);
	        j = i;
	    }
	    return sum;
	}

	// turn a polygon in a multi-dimensional array form (e.g. as in GeoJSON) into a form Earcut accepts
	earcut.flatten = function (data) {
	    var dim = data[0][0].length,
	        result = {vertices: [], holes: [], dimensions: dim},
	        holeIndex = 0;

	    for (var i = 0; i < data.length; i++) {
	        for (var j = 0; j < data[i].length; j++) {
	            for (var d = 0; d < dim; d++) result.vertices.push(data[i][j][d]);
	        }
	        if (i > 0) {
	            holeIndex += data[i - 1].length;
	            result.holes.push(holeIndex);
	        }
	    }
	    return result;
	};

	var earcutExports = earcut$2.exports;
	var earcut$1 = /*@__PURE__*/getDefaultExportFromCjs$1(earcutExports);

	function quickselect(arr, k, left, right, compare) {
	    quickselectStep(arr, k, left || 0, right || (arr.length - 1), compare || defaultCompare$1);
	}

	function quickselectStep(arr, k, left, right, compare) {

	    while (right > left) {
	        if (right - left > 600) {
	            var n = right - left + 1;
	            var m = k - left + 1;
	            var z = Math.log(n);
	            var s = 0.5 * Math.exp(2 * z / 3);
	            var sd = 0.5 * Math.sqrt(z * s * (n - s) / n) * (m - n / 2 < 0 ? -1 : 1);
	            var newLeft = Math.max(left, Math.floor(k - m * s / n + sd));
	            var newRight = Math.min(right, Math.floor(k + (n - m) * s / n + sd));
	            quickselectStep(arr, k, newLeft, newRight, compare);
	        }

	        var t = arr[k];
	        var i = left;
	        var j = right;

	        swap$1(arr, left, k);
	        if (compare(arr[right], t) > 0) swap$1(arr, left, right);

	        while (i < j) {
	            swap$1(arr, i, j);
	            i++;
	            j--;
	            while (compare(arr[i], t) < 0) i++;
	            while (compare(arr[j], t) > 0) j--;
	        }

	        if (compare(arr[left], t) === 0) swap$1(arr, left, j);
	        else {
	            j++;
	            swap$1(arr, j, right);
	        }

	        if (j <= k) left = j + 1;
	        if (k <= j) right = j - 1;
	    }
	}

	function swap$1(arr, i, j) {
	    var tmp = arr[i];
	    arr[i] = arr[j];
	    arr[j] = tmp;
	}

	function defaultCompare$1(a, b) {
	    return a < b ? -1 : a > b ? 1 : 0;
	}

	// classifies an array of rings into polygons with outer rings and holes
	function classifyRings$1(rings, maxRings) {
	    const len = rings.length;
	    if (len <= 1)
	        return [rings];
	    const polygons = [];
	    let polygon, ccw;
	    for (let i = 0; i < len; i++) {
	        const area = calculateSignedArea(rings[i]);
	        if (area === 0)
	            continue;
	        rings[i].area = Math.abs(area);
	        if (ccw === undefined)
	            ccw = area < 0;
	        if (ccw === area < 0) {
	            if (polygon)
	                polygons.push(polygon);
	            polygon = [rings[i]];
	        }
	        else {
	            polygon.push(rings[i]);
	        }
	    }
	    if (polygon)
	        polygons.push(polygon);
	    // Earcut performance degrades with the # of rings in a polygon. For this
	    // reason, we limit strip out all but the `maxRings` largest rings.
	    if (maxRings > 1) {
	        for (let j = 0; j < polygons.length; j++) {
	            if (polygons[j].length <= maxRings)
	                continue;
	            quickselect(polygons[j], maxRings, 1, polygons[j].length - 1, compareAreas);
	            polygons[j] = polygons[j].slice(0, maxRings);
	        }
	    }
	    return polygons;
	}
	function compareAreas(a, b) {
	    return b.area - a.area;
	}

	function hasPattern(type, layers, options) {
	    const patterns = options.patternDependencies;
	    let hasPattern = false;
	    for (const layer of layers) {
	        const patternProperty = layer.paint.get(`${type}-pattern`);
	        if (!patternProperty.isConstant()) {
	            hasPattern = true;
	        }
	        const constantPattern = patternProperty.constantOr(null);
	        if (constantPattern) {
	            hasPattern = true;
	            patterns[constantPattern.to] = true;
	            patterns[constantPattern.from] = true;
	        }
	    }
	    return hasPattern;
	}
	function addPatternDependencies(type, layers, patternFeature, zoom, options) {
	    const patterns = options.patternDependencies;
	    for (const layer of layers) {
	        const patternProperty = layer.paint.get(`${type}-pattern`);
	        const patternPropertyValue = patternProperty.value;
	        if (patternPropertyValue.kind !== 'constant') {
	            let min = patternPropertyValue.evaluate({ zoom: zoom - 1 }, patternFeature, {}, options.availableImages);
	            let mid = patternPropertyValue.evaluate({ zoom }, patternFeature, {}, options.availableImages);
	            let max = patternPropertyValue.evaluate({ zoom: zoom + 1 }, patternFeature, {}, options.availableImages);
	            min = min && min.name ? min.name : min;
	            mid = mid && mid.name ? mid.name : mid;
	            max = max && max.name ? max.name : max;
	            // add to patternDependencies
	            patterns[min] = true;
	            patterns[mid] = true;
	            patterns[max] = true;
	            // save for layout
	            patternFeature.patterns[layer.id] = { min, mid, max };
	        }
	    }
	    return patternFeature;
	}

	const EARCUT_MAX_RINGS$1 = 500;
	class FillBucket {
	    constructor(options) {
	        this.zoom = options.zoom;
	        this.overscaling = options.overscaling;
	        this.layers = options.layers;
	        this.layerIds = this.layers.map(layer => layer.id);
	        this.index = options.index;
	        this.hasPattern = false;
	        this.patternFeatures = [];
	        this.layoutVertexArray = new FillLayoutArray();
	        this.indexArray = new TriangleIndexArray();
	        this.indexArray2 = new LineIndexArray();
	        this.programConfigurations = new ProgramConfigurationSet(options.layers, options.zoom);
	        this.segments = new SegmentVector();
	        this.segments2 = new SegmentVector();
	        this.stateDependentLayerIds = this.layers.filter((l) => l.isStateDependent()).map((l) => l.id);
	    }
	    populate(features, options, canonical) {
	        this.hasPattern = hasPattern('fill', this.layers, options);
	        const fillSortKey = this.layers[0].layout.get('fill-sort-key');
	        const sortFeaturesByKey = !fillSortKey.isConstant();
	        const bucketFeatures = [];
	        for (const { feature, id, index, sourceLayerIndex } of features) {
	            const needGeometry = this.layers[0]._featureFilter.needGeometry;
	            const evaluationFeature = toEvaluationFeature(feature, needGeometry);
	            if (!this.layers[0]._featureFilter.filter(new EvaluationParameters(this.zoom), evaluationFeature, canonical))
	                continue;
	            const sortKey = sortFeaturesByKey ?
	                fillSortKey.evaluate(evaluationFeature, {}, canonical, options.availableImages) :
	                undefined;
	            const bucketFeature = {
	                id,
	                properties: feature.properties,
	                type: feature.type,
	                sourceLayerIndex,
	                index,
	                geometry: needGeometry ? evaluationFeature.geometry : loadGeometry(feature),
	                patterns: {},
	                sortKey
	            };
	            bucketFeatures.push(bucketFeature);
	        }
	        if (sortFeaturesByKey) {
	            bucketFeatures.sort((a, b) => a.sortKey - b.sortKey);
	        }
	        for (const bucketFeature of bucketFeatures) {
	            const { geometry, index, sourceLayerIndex } = bucketFeature;
	            if (this.hasPattern) {
	                const patternFeature = addPatternDependencies('fill', this.layers, bucketFeature, this.zoom, options);
	                // pattern features are added only once the pattern is loaded into the image atlas
	                // so are stored during populate until later updated with positions by tile worker in addFeatures
	                this.patternFeatures.push(patternFeature);
	            }
	            else {
	                this.addFeature(bucketFeature, geometry, index, canonical, {});
	            }
	            const feature = features[index].feature;
	            options.featureIndex.insert(feature, geometry, index, sourceLayerIndex, this.index);
	        }
	    }
	    update(states, vtLayer, imagePositions) {
	        if (!this.stateDependentLayers.length)
	            return;
	        this.programConfigurations.updatePaintArrays(states, vtLayer, this.stateDependentLayers, imagePositions);
	    }
	    addFeatures(options, canonical, imagePositions) {
	        for (const feature of this.patternFeatures) {
	            this.addFeature(feature, feature.geometry, feature.index, canonical, imagePositions);
	        }
	    }
	    isEmpty() {
	        return this.layoutVertexArray.length === 0;
	    }
	    uploadPending() {
	        return !this.uploaded || this.programConfigurations.needsUpload;
	    }
	    upload(context) {
	        if (!this.uploaded) {
	            this.layoutVertexBuffer = context.createVertexBuffer(this.layoutVertexArray, members$3);
	            this.indexBuffer = context.createIndexBuffer(this.indexArray);
	            this.indexBuffer2 = context.createIndexBuffer(this.indexArray2);
	        }
	        this.programConfigurations.upload(context);
	        this.uploaded = true;
	    }
	    destroy() {
	        if (!this.layoutVertexBuffer)
	            return;
	        this.layoutVertexBuffer.destroy();
	        this.indexBuffer.destroy();
	        this.indexBuffer2.destroy();
	        this.programConfigurations.destroy();
	        this.segments.destroy();
	        this.segments2.destroy();
	    }
	    addFeature(feature, geometry, index, canonical, imagePositions) {
	        for (const polygon of classifyRings$1(geometry, EARCUT_MAX_RINGS$1)) {
	            let numVertices = 0;
	            for (const ring of polygon) {
	                numVertices += ring.length;
	            }
	            const triangleSegment = this.segments.prepareSegment(numVertices, this.layoutVertexArray, this.indexArray);
	            const triangleIndex = triangleSegment.vertexLength;
	            const flattened = [];
	            const holeIndices = [];
	            for (const ring of polygon) {
	                if (ring.length === 0) {
	                    continue;
	                }
	                if (ring !== polygon[0]) {
	                    holeIndices.push(flattened.length / 2);
	                }
	                const lineSegment = this.segments2.prepareSegment(ring.length, this.layoutVertexArray, this.indexArray2);
	                const lineIndex = lineSegment.vertexLength;
	                this.layoutVertexArray.emplaceBack(ring[0].x, ring[0].y);
	                this.indexArray2.emplaceBack(lineIndex + ring.length - 1, lineIndex);
	                flattened.push(ring[0].x);
	                flattened.push(ring[0].y);
	                for (let i = 1; i < ring.length; i++) {
	                    this.layoutVertexArray.emplaceBack(ring[i].x, ring[i].y);
	                    this.indexArray2.emplaceBack(lineIndex + i - 1, lineIndex + i);
	                    flattened.push(ring[i].x);
	                    flattened.push(ring[i].y);
	                }
	                lineSegment.vertexLength += ring.length;
	                lineSegment.primitiveLength += ring.length;
	            }
	            const indices = earcut$1(flattened, holeIndices);
	            for (let i = 0; i < indices.length; i += 3) {
	                this.indexArray.emplaceBack(triangleIndex + indices[i], triangleIndex + indices[i + 1], triangleIndex + indices[i + 2]);
	            }
	            triangleSegment.vertexLength += numVertices;
	            triangleSegment.primitiveLength += indices.length / 3;
	        }
	        this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, feature, index, imagePositions, canonical);
	    }
	}
	register('FillBucket', FillBucket, { omit: ['layers', 'patternFeatures'] });

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let layout$3;
	const getLayout$2 = () => layout$3 = layout$3 || new Properties({
	    "fill-sort-key": new DataDrivenProperty(v8Spec["layout_fill"]["fill-sort-key"]),
	});
	let paint$5;
	const getPaint$5 = () => paint$5 = paint$5 || new Properties({
	    "fill-antialias": new DataConstantProperty(v8Spec["paint_fill"]["fill-antialias"]),
	    "fill-opacity": new DataDrivenProperty(v8Spec["paint_fill"]["fill-opacity"]),
	    "fill-color": new DataDrivenProperty(v8Spec["paint_fill"]["fill-color"]),
	    "fill-outline-color": new DataDrivenProperty(v8Spec["paint_fill"]["fill-outline-color"]),
	    "fill-translate": new DataConstantProperty(v8Spec["paint_fill"]["fill-translate"]),
	    "fill-translate-anchor": new DataConstantProperty(v8Spec["paint_fill"]["fill-translate-anchor"]),
	    "fill-pattern": new CrossFadedDataDrivenProperty(v8Spec["paint_fill"]["fill-pattern"]),
	});
	var properties$5 = ({ get paint() { return getPaint$5(); }, get layout() { return getLayout$2(); } });

	class FillStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties$5);
	    }
	    recalculate(parameters, availableImages) {
	        super.recalculate(parameters, availableImages);
	        const outlineColor = this.paint._values['fill-outline-color'];
	        if (outlineColor.value.kind === 'constant' && outlineColor.value.value === undefined) {
	            this.paint._values['fill-outline-color'] = this.paint._values['fill-color'];
	        }
	    }
	    createBucket(parameters) {
	        return new FillBucket(parameters);
	    }
	    queryRadius() {
	        return translateDistance(this.paint.get('fill-translate'));
	    }
	    queryIntersectsFeature(queryGeometry, feature, featureState, geometry, zoom, transform, pixelsToTileUnits) {
	        const translatedPolygon = translate$4(queryGeometry, this.paint.get('fill-translate'), this.paint.get('fill-translate-anchor'), transform.angle, pixelsToTileUnits);
	        return polygonIntersectsMultiPolygon(translatedPolygon, geometry);
	    }
	    isTileClipped() {
	        return true;
	    }
	}

	const layout$2 = createLayout([
	    { name: 'a_pos', components: 2, type: 'Int16' },
	    { name: 'a_normal_ed', components: 4, type: 'Int16' },
	], 4);
	const centroidAttributes = createLayout([
	    { name: 'a_centroid', components: 2, type: 'Int16' }
	], 4);
	const { members: members$2, size: size$2, alignment: alignment$2 } = layout$2;

	var vectorTile = {};

	var Point = pointGeometry;

	var vectortilefeature = VectorTileFeature$2;

	function VectorTileFeature$2(pbf, end, extent, keys, values) {
	    // Public
	    this.properties = {};
	    this.extent = extent;
	    this.type = 0;

	    // Private
	    this._pbf = pbf;
	    this._geometry = -1;
	    this._keys = keys;
	    this._values = values;

	    pbf.readFields(readFeature, this, end);
	}

	function readFeature(tag, feature, pbf) {
	    if (tag == 1) feature.id = pbf.readVarint();
	    else if (tag == 2) readTag(pbf, feature);
	    else if (tag == 3) feature.type = pbf.readVarint();
	    else if (tag == 4) feature._geometry = pbf.pos;
	}

	function readTag(pbf, feature) {
	    var end = pbf.readVarint() + pbf.pos;

	    while (pbf.pos < end) {
	        var key = feature._keys[pbf.readVarint()],
	            value = feature._values[pbf.readVarint()];
	        feature.properties[key] = value;
	    }
	}

	VectorTileFeature$2.types = ['Unknown', 'Point', 'LineString', 'Polygon'];

	VectorTileFeature$2.prototype.loadGeometry = function() {
	    var pbf = this._pbf;
	    pbf.pos = this._geometry;

	    var end = pbf.readVarint() + pbf.pos,
	        cmd = 1,
	        length = 0,
	        x = 0,
	        y = 0,
	        lines = [],
	        line;

	    while (pbf.pos < end) {
	        if (length <= 0) {
	            var cmdLen = pbf.readVarint();
	            cmd = cmdLen & 0x7;
	            length = cmdLen >> 3;
	        }

	        length--;

	        if (cmd === 1 || cmd === 2) {
	            x += pbf.readSVarint();
	            y += pbf.readSVarint();

	            if (cmd === 1) { // moveTo
	                if (line) lines.push(line);
	                line = [];
	            }

	            line.push(new Point(x, y));

	        } else if (cmd === 7) {

	            // Workaround for https://github.com/mapbox/mapnik-vector-tile/issues/90
	            if (line) {
	                line.push(line[0].clone()); // closePolygon
	            }

	        } else {
	            throw new Error('unknown command ' + cmd);
	        }
	    }

	    if (line) lines.push(line);

	    return lines;
	};

	VectorTileFeature$2.prototype.bbox = function() {
	    var pbf = this._pbf;
	    pbf.pos = this._geometry;

	    var end = pbf.readVarint() + pbf.pos,
	        cmd = 1,
	        length = 0,
	        x = 0,
	        y = 0,
	        x1 = Infinity,
	        x2 = -Infinity,
	        y1 = Infinity,
	        y2 = -Infinity;

	    while (pbf.pos < end) {
	        if (length <= 0) {
	            var cmdLen = pbf.readVarint();
	            cmd = cmdLen & 0x7;
	            length = cmdLen >> 3;
	        }

	        length--;

	        if (cmd === 1 || cmd === 2) {
	            x += pbf.readSVarint();
	            y += pbf.readSVarint();
	            if (x < x1) x1 = x;
	            if (x > x2) x2 = x;
	            if (y < y1) y1 = y;
	            if (y > y2) y2 = y;

	        } else if (cmd !== 7) {
	            throw new Error('unknown command ' + cmd);
	        }
	    }

	    return [x1, y1, x2, y2];
	};

	VectorTileFeature$2.prototype.toGeoJSON = function(x, y, z) {
	    var size = this.extent * Math.pow(2, z),
	        x0 = this.extent * x,
	        y0 = this.extent * y,
	        coords = this.loadGeometry(),
	        type = VectorTileFeature$2.types[this.type],
	        i, j;

	    function project(line) {
	        for (var j = 0; j < line.length; j++) {
	            var p = line[j], y2 = 180 - (p.y + y0) * 360 / size;
	            line[j] = [
	                (p.x + x0) * 360 / size - 180,
	                360 / Math.PI * Math.atan(Math.exp(y2 * Math.PI / 180)) - 90
	            ];
	        }
	    }

	    switch (this.type) {
	    case 1:
	        var points = [];
	        for (i = 0; i < coords.length; i++) {
	            points[i] = coords[i][0];
	        }
	        coords = points;
	        project(coords);
	        break;

	    case 2:
	        for (i = 0; i < coords.length; i++) {
	            project(coords[i]);
	        }
	        break;

	    case 3:
	        coords = classifyRings(coords);
	        for (i = 0; i < coords.length; i++) {
	            for (j = 0; j < coords[i].length; j++) {
	                project(coords[i][j]);
	            }
	        }
	        break;
	    }

	    if (coords.length === 1) {
	        coords = coords[0];
	    } else {
	        type = 'Multi' + type;
	    }

	    var result = {
	        type: "Feature",
	        geometry: {
	            type: type,
	            coordinates: coords
	        },
	        properties: this.properties
	    };

	    if ('id' in this) {
	        result.id = this.id;
	    }

	    return result;
	};

	// classifies an array of rings into polygons with outer rings and holes

	function classifyRings(rings) {
	    var len = rings.length;

	    if (len <= 1) return [rings];

	    var polygons = [],
	        polygon,
	        ccw;

	    for (var i = 0; i < len; i++) {
	        var area = signedArea(rings[i]);
	        if (area === 0) continue;

	        if (ccw === undefined) ccw = area < 0;

	        if (ccw === area < 0) {
	            if (polygon) polygons.push(polygon);
	            polygon = [rings[i]];

	        } else {
	            polygon.push(rings[i]);
	        }
	    }
	    if (polygon) polygons.push(polygon);

	    return polygons;
	}

	function signedArea(ring) {
	    var sum = 0;
	    for (var i = 0, len = ring.length, j = len - 1, p1, p2; i < len; j = i++) {
	        p1 = ring[i];
	        p2 = ring[j];
	        sum += (p2.x - p1.x) * (p1.y + p2.y);
	    }
	    return sum;
	}

	var VectorTileFeature$1 = vectortilefeature;

	var vectortilelayer = VectorTileLayer$2;

	function VectorTileLayer$2(pbf, end) {
	    // Public
	    this.version = 1;
	    this.name = null;
	    this.extent = 4096;
	    this.length = 0;

	    // Private
	    this._pbf = pbf;
	    this._keys = [];
	    this._values = [];
	    this._features = [];

	    pbf.readFields(readLayer, this, end);

	    this.length = this._features.length;
	}

	function readLayer(tag, layer, pbf) {
	    if (tag === 15) layer.version = pbf.readVarint();
	    else if (tag === 1) layer.name = pbf.readString();
	    else if (tag === 5) layer.extent = pbf.readVarint();
	    else if (tag === 2) layer._features.push(pbf.pos);
	    else if (tag === 3) layer._keys.push(pbf.readString());
	    else if (tag === 4) layer._values.push(readValueMessage(pbf));
	}

	function readValueMessage(pbf) {
	    var value = null,
	        end = pbf.readVarint() + pbf.pos;

	    while (pbf.pos < end) {
	        var tag = pbf.readVarint() >> 3;

	        value = tag === 1 ? pbf.readString() :
	            tag === 2 ? pbf.readFloat() :
	            tag === 3 ? pbf.readDouble() :
	            tag === 4 ? pbf.readVarint64() :
	            tag === 5 ? pbf.readVarint() :
	            tag === 6 ? pbf.readSVarint() :
	            tag === 7 ? pbf.readBoolean() : null;
	    }

	    return value;
	}

	// return feature `i` from this layer as a `VectorTileFeature`
	VectorTileLayer$2.prototype.feature = function(i) {
	    if (i < 0 || i >= this._features.length) throw new Error('feature index out of bounds');

	    this._pbf.pos = this._features[i];

	    var end = this._pbf.readVarint() + this._pbf.pos;
	    return new VectorTileFeature$1(this._pbf, end, this.extent, this._keys, this._values);
	};

	var VectorTileLayer$1 = vectortilelayer;

	var vectortile = VectorTile$1;

	function VectorTile$1(pbf, end) {
	    this.layers = pbf.readFields(readTile, {}, end);
	}

	function readTile(tag, layers, pbf) {
	    if (tag === 3) {
	        var layer = new VectorTileLayer$1(pbf, pbf.readVarint() + pbf.pos);
	        if (layer.length) layers[layer.name] = layer;
	    }
	}

	vectorTile.VectorTile = vectortile;
	vectorTile.VectorTileFeature = vectortilefeature;
	vectorTile.VectorTileLayer = vectortilelayer;

	const vectorTileFeatureTypes$2 = vectorTile.VectorTileFeature.types;
	const EARCUT_MAX_RINGS = 500;
	const FACTOR = Math.pow(2, 13);
	function addVertex$1(vertexArray, x, y, nx, ny, nz, t, e) {
	    vertexArray.emplaceBack(
	    // a_pos
	    x, y, 
	    // a_normal_ed: 3-component normal and 1-component edgedistance
	    Math.floor(nx * FACTOR) * 2 + t, ny * FACTOR * 2, nz * FACTOR * 2, 
	    // edgedistance (used for wrapping patterns around extrusion sides)
	    Math.round(e));
	}
	class FillExtrusionBucket {
	    constructor(options) {
	        this.zoom = options.zoom;
	        this.overscaling = options.overscaling;
	        this.layers = options.layers;
	        this.layerIds = this.layers.map(layer => layer.id);
	        this.index = options.index;
	        this.hasPattern = false;
	        this.layoutVertexArray = new FillExtrusionLayoutArray();
	        this.centroidVertexArray = new PosArray();
	        this.indexArray = new TriangleIndexArray();
	        this.programConfigurations = new ProgramConfigurationSet(options.layers, options.zoom);
	        this.segments = new SegmentVector();
	        this.stateDependentLayerIds = this.layers.filter((l) => l.isStateDependent()).map((l) => l.id);
	    }
	    populate(features, options, canonical) {
	        this.features = [];
	        this.hasPattern = hasPattern('fill-extrusion', this.layers, options);
	        for (const { feature, id, index, sourceLayerIndex } of features) {
	            const needGeometry = this.layers[0]._featureFilter.needGeometry;
	            const evaluationFeature = toEvaluationFeature(feature, needGeometry);
	            if (!this.layers[0]._featureFilter.filter(new EvaluationParameters(this.zoom), evaluationFeature, canonical))
	                continue;
	            const bucketFeature = {
	                id,
	                sourceLayerIndex,
	                index,
	                geometry: needGeometry ? evaluationFeature.geometry : loadGeometry(feature),
	                properties: feature.properties,
	                type: feature.type,
	                patterns: {}
	            };
	            if (this.hasPattern) {
	                this.features.push(addPatternDependencies('fill-extrusion', this.layers, bucketFeature, this.zoom, options));
	            }
	            else {
	                this.addFeature(bucketFeature, bucketFeature.geometry, index, canonical, {});
	            }
	            options.featureIndex.insert(feature, bucketFeature.geometry, index, sourceLayerIndex, this.index, true);
	        }
	    }
	    addFeatures(options, canonical, imagePositions) {
	        for (const feature of this.features) {
	            const { geometry } = feature;
	            this.addFeature(feature, geometry, feature.index, canonical, imagePositions);
	        }
	    }
	    update(states, vtLayer, imagePositions) {
	        if (!this.stateDependentLayers.length)
	            return;
	        this.programConfigurations.updatePaintArrays(states, vtLayer, this.stateDependentLayers, imagePositions);
	    }
	    isEmpty() {
	        return this.layoutVertexArray.length === 0 && this.centroidVertexArray.length === 0;
	    }
	    uploadPending() {
	        return !this.uploaded || this.programConfigurations.needsUpload;
	    }
	    upload(context) {
	        if (!this.uploaded) {
	            this.layoutVertexBuffer = context.createVertexBuffer(this.layoutVertexArray, members$2);
	            this.centroidVertexBuffer = context.createVertexBuffer(this.centroidVertexArray, centroidAttributes.members, true);
	            this.indexBuffer = context.createIndexBuffer(this.indexArray);
	        }
	        this.programConfigurations.upload(context);
	        this.uploaded = true;
	    }
	    destroy() {
	        if (!this.layoutVertexBuffer)
	            return;
	        this.layoutVertexBuffer.destroy();
	        this.indexBuffer.destroy();
	        this.programConfigurations.destroy();
	        this.segments.destroy();
	        this.centroidVertexBuffer.destroy();
	    }
	    addFeature(feature, geometry, index, canonical, imagePositions) {
	        const centroid = { x: 0, y: 0, vertexCount: 0 };
	        for (const polygon of classifyRings$1(geometry, EARCUT_MAX_RINGS)) {
	            let numVertices = 0;
	            for (const ring of polygon) {
	                numVertices += ring.length;
	            }
	            let segment = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray);
	            for (const ring of polygon) {
	                if (ring.length === 0) {
	                    continue;
	                }
	                if (isEntirelyOutside(ring)) {
	                    continue;
	                }
	                let edgeDistance = 0;
	                for (let p = 0; p < ring.length; p++) {
	                    const p1 = ring[p];
	                    if (p >= 1) {
	                        const p2 = ring[p - 1];
	                        if (!isBoundaryEdge(p1, p2)) {
	                            if (segment.vertexLength + 4 > SegmentVector.MAX_VERTEX_ARRAY_LENGTH) {
	                                segment = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray);
	                            }
	                            const perp = p1.sub(p2)._perp()._unit();
	                            const dist = p2.dist(p1);
	                            if (edgeDistance + dist > 32768)
	                                edgeDistance = 0;
	                            addVertex$1(this.layoutVertexArray, p1.x, p1.y, perp.x, perp.y, 0, 0, edgeDistance);
	                            addVertex$1(this.layoutVertexArray, p1.x, p1.y, perp.x, perp.y, 0, 1, edgeDistance);
	                            centroid.x += 2 * p1.x;
	                            centroid.y += 2 * p1.y;
	                            centroid.vertexCount += 2;
	                            edgeDistance += dist;
	                            addVertex$1(this.layoutVertexArray, p2.x, p2.y, perp.x, perp.y, 0, 0, edgeDistance);
	                            addVertex$1(this.layoutVertexArray, p2.x, p2.y, perp.x, perp.y, 0, 1, edgeDistance);
	                            centroid.x += 2 * p2.x;
	                            centroid.y += 2 * p2.y;
	                            centroid.vertexCount += 2;
	                            const bottomRight = segment.vertexLength;
	                            // ┌──────┐
	                            // │ 0  1 │ Counter-clockwise winding order.
	                            // │      │ Triangle 1: 0 => 2 => 1
	                            // │ 2  3 │ Triangle 2: 1 => 2 => 3
	                            // └──────┘
	                            this.indexArray.emplaceBack(bottomRight, bottomRight + 2, bottomRight + 1);
	                            this.indexArray.emplaceBack(bottomRight + 1, bottomRight + 2, bottomRight + 3);
	                            segment.vertexLength += 4;
	                            segment.primitiveLength += 2;
	                        }
	                    }
	                }
	            }
	            if (segment.vertexLength + numVertices > SegmentVector.MAX_VERTEX_ARRAY_LENGTH) {
	                segment = this.segments.prepareSegment(numVertices, this.layoutVertexArray, this.indexArray);
	            }
	            //Only triangulate and draw the area of the feature if it is a polygon
	            //Other feature types (e.g. LineString) do not have area, so triangulation is pointless / undefined
	            if (vectorTileFeatureTypes$2[feature.type] !== 'Polygon')
	                continue;
	            const flattened = [];
	            const holeIndices = [];
	            const triangleIndex = segment.vertexLength;
	            for (const ring of polygon) {
	                if (ring.length === 0) {
	                    continue;
	                }
	                if (ring !== polygon[0]) {
	                    holeIndices.push(flattened.length / 2);
	                }
	                for (let i = 0; i < ring.length; i++) {
	                    const p = ring[i];
	                    addVertex$1(this.layoutVertexArray, p.x, p.y, 0, 0, 1, 1, 0);
	                    centroid.x += p.x;
	                    centroid.y += p.y;
	                    centroid.vertexCount += 1;
	                    flattened.push(p.x);
	                    flattened.push(p.y);
	                }
	            }
	            const indices = earcut$1(flattened, holeIndices);
	            for (let j = 0; j < indices.length; j += 3) {
	                // Counter-clockwise winding order.
	                this.indexArray.emplaceBack(triangleIndex + indices[j], triangleIndex + indices[j + 2], triangleIndex + indices[j + 1]);
	            }
	            segment.primitiveLength += indices.length / 3;
	            segment.vertexLength += numVertices;
	        }
	        // remember polygon centroid to calculate elevation in GPU
	        for (let i = 0; i < centroid.vertexCount; i++) {
	            this.centroidVertexArray.emplaceBack(Math.floor(centroid.x / centroid.vertexCount), Math.floor(centroid.y / centroid.vertexCount));
	        }
	        this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, feature, index, imagePositions, canonical);
	    }
	}
	register('FillExtrusionBucket', FillExtrusionBucket, { omit: ['layers', 'features'] });
	function isBoundaryEdge(p1, p2) {
	    return (p1.x === p2.x && (p1.x < 0 || p1.x > EXTENT)) ||
	        (p1.y === p2.y && (p1.y < 0 || p1.y > EXTENT));
	}
	function isEntirelyOutside(ring) {
	    return ring.every(p => p.x < 0) ||
	        ring.every(p => p.x > EXTENT) ||
	        ring.every(p => p.y < 0) ||
	        ring.every(p => p.y > EXTENT);
	}

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let paint$4;
	const getPaint$4 = () => paint$4 = paint$4 || new Properties({
	    "fill-extrusion-opacity": new DataConstantProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-opacity"]),
	    "fill-extrusion-color": new DataDrivenProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-color"]),
	    "fill-extrusion-translate": new DataConstantProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-translate"]),
	    "fill-extrusion-translate-anchor": new DataConstantProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-translate-anchor"]),
	    "fill-extrusion-pattern": new CrossFadedDataDrivenProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-pattern"]),
	    "fill-extrusion-height": new DataDrivenProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-height"]),
	    "fill-extrusion-base": new DataDrivenProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-base"]),
	    "fill-extrusion-vertical-gradient": new DataConstantProperty(v8Spec["paint_fill-extrusion"]["fill-extrusion-vertical-gradient"]),
	});
	var properties$4 = ({ get paint() { return getPaint$4(); } });
	class FillExtrusionStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties$4);
	    }
	    createBucket(parameters) {
	        return new FillExtrusionBucket(parameters);
	    }
	    queryRadius() {
	        return translateDistance(this.paint.get('fill-extrusion-translate'));
	    }
	    is3D() {
	        return true;
	    }
	    queryIntersectsFeature(queryGeometry, feature, featureState, geometry, zoom, transform, pixelsToTileUnits, pixelPosMatrix) {
	        const translatedPolygon = translate$4(queryGeometry, this.paint.get('fill-extrusion-translate'), this.paint.get('fill-extrusion-translate-anchor'), transform.angle, pixelsToTileUnits);
	        const height = this.paint.get('fill-extrusion-height').evaluate(feature, featureState);
	        const base = this.paint.get('fill-extrusion-base').evaluate(feature, featureState);
	        const projectedQueryGeometry = projectQueryGeometry(translatedPolygon, pixelPosMatrix, transform, 0);
	        const projected = projectExtrusion(geometry, base, height, pixelPosMatrix);
	        const projectedBase = projected[0];
	        const projectedTop = projected[1];
	        return checkIntersection(projectedBase, projectedTop, projectedQueryGeometry);
	    }
	}
	function dot(a, b) {
	    return a.x * b.x + a.y * b.y;
	}
	function getIntersectionDistance(projectedQueryGeometry, projectedFace) {
	    if (projectedQueryGeometry.length === 1) {
	        // For point queries calculate the z at which the point intersects the face
	        // using barycentric coordinates.
	        // Find the barycentric coordinates of the projected point within the first
	        // triangle of the face, using only the xy plane. It doesn't matter if the
	        // point is outside the first triangle because all the triangles in the face
	        // are in the same plane.
	        //
	        // Check whether points are coincident and use other points if they are.
	        let i = 0;
	        const a = projectedFace[i++];
	        let b;
	        while (!b || a.equals(b)) {
	            b = projectedFace[i++];
	            if (!b)
	                return Infinity;
	        }
	        // Loop until point `c` is not colinear with points `a` and `b`.
	        for (; i < projectedFace.length; i++) {
	            const c = projectedFace[i];
	            const p = projectedQueryGeometry[0];
	            const ab = b.sub(a);
	            const ac = c.sub(a);
	            const ap = p.sub(a);
	            const dotABAB = dot(ab, ab);
	            const dotABAC = dot(ab, ac);
	            const dotACAC = dot(ac, ac);
	            const dotAPAB = dot(ap, ab);
	            const dotAPAC = dot(ap, ac);
	            const denom = dotABAB * dotACAC - dotABAC * dotABAC;
	            const v = (dotACAC * dotAPAB - dotABAC * dotAPAC) / denom;
	            const w = (dotABAB * dotAPAC - dotABAC * dotAPAB) / denom;
	            const u = 1 - v - w;
	            // Use the barycentric weighting along with the original triangle z coordinates to get the point of intersection.
	            const distance = a.z * u + b.z * v + c.z * w;
	            if (isFinite(distance))
	                return distance;
	        }
	        return Infinity;
	    }
	    else {
	        // The counts as closest is less clear when the query is a box. This
	        // returns the distance to the nearest point on the face, whether it is
	        // within the query or not. It could be more correct to return the
	        // distance to the closest point within the query box but this would be
	        // more complicated and expensive to calculate with little benefit.
	        let closestDistance = Infinity;
	        for (const p of projectedFace) {
	            closestDistance = Math.min(closestDistance, p.z);
	        }
	        return closestDistance;
	    }
	}
	function checkIntersection(projectedBase, projectedTop, projectedQueryGeometry) {
	    let closestDistance = Infinity;
	    if (polygonIntersectsMultiPolygon(projectedQueryGeometry, projectedTop)) {
	        closestDistance = getIntersectionDistance(projectedQueryGeometry, projectedTop[0]);
	    }
	    for (let r = 0; r < projectedTop.length; r++) {
	        const ringTop = projectedTop[r];
	        const ringBase = projectedBase[r];
	        for (let p = 0; p < ringTop.length - 1; p++) {
	            const topA = ringTop[p];
	            const topB = ringTop[p + 1];
	            const baseA = ringBase[p];
	            const baseB = ringBase[p + 1];
	            const face = [topA, topB, baseB, baseA, topA];
	            if (polygonIntersectsPolygon(projectedQueryGeometry, face)) {
	                closestDistance = Math.min(closestDistance, getIntersectionDistance(projectedQueryGeometry, face));
	            }
	        }
	    }
	    return closestDistance === Infinity ? false : closestDistance;
	}
	/*
	 * Project the geometry using matrix `m`. This is essentially doing
	 * `vec4.transformMat4([], [p.x, p.y, z, 1], m)` but the multiplication
	 * is inlined so that parts of the projection that are the same across
	 * different points can only be done once. This produced a measurable
	 * performance improvement.
	 */
	function projectExtrusion(geometry, zBase, zTop, m) {
	    const projectedBase = [];
	    const projectedTop = [];
	    const baseXZ = m[8] * zBase;
	    const baseYZ = m[9] * zBase;
	    const baseZZ = m[10] * zBase;
	    const baseWZ = m[11] * zBase;
	    const topXZ = m[8] * zTop;
	    const topYZ = m[9] * zTop;
	    const topZZ = m[10] * zTop;
	    const topWZ = m[11] * zTop;
	    for (const r of geometry) {
	        const ringBase = [];
	        const ringTop = [];
	        for (const p of r) {
	            const x = p.x;
	            const y = p.y;
	            const sX = m[0] * x + m[4] * y + m[12];
	            const sY = m[1] * x + m[5] * y + m[13];
	            const sZ = m[2] * x + m[6] * y + m[14];
	            const sW = m[3] * x + m[7] * y + m[15];
	            const baseX = sX + baseXZ;
	            const baseY = sY + baseYZ;
	            const baseZ = sZ + baseZZ;
	            const baseW = sW + baseWZ;
	            const topX = sX + topXZ;
	            const topY = sY + topYZ;
	            const topZ = sZ + topZZ;
	            const topW = sW + topWZ;
	            const b = new Point$2(baseX / baseW, baseY / baseW);
	            b.z = baseZ / baseW;
	            ringBase.push(b);
	            const t = new Point$2(topX / topW, topY / topW);
	            t.z = topZ / topW;
	            ringTop.push(t);
	        }
	        projectedBase.push(ringBase);
	        projectedTop.push(ringTop);
	    }
	    return [projectedBase, projectedTop];
	}
	function projectQueryGeometry(queryGeometry, pixelPosMatrix, transform, z) {
	    const projectedQueryGeometry = [];
	    for (const p of queryGeometry) {
	        const v = [p.x, p.y, z, 1];
	        transformMat4$1(v, v, pixelPosMatrix);
	        projectedQueryGeometry.push(new Point$2(v[0] / v[3], v[1] / v[3]));
	    }
	    return projectedQueryGeometry;
	}

	const lineLayoutAttributes = createLayout([
	    { name: 'a_pos_normal', components: 2, type: 'Int16' },
	    { name: 'a_data', components: 4, type: 'Uint8' }
	], 4);
	const { members: members$1, size: size$1, alignment: alignment$1 } = lineLayoutAttributes;

	const lineLayoutAttributesExt = createLayout([
	    { name: 'a_uv_x', components: 1, type: 'Float32' },
	    { name: 'a_split_index', components: 1, type: 'Float32' },
	]);
	const { members, size, alignment } = lineLayoutAttributesExt;

	const vectorTileFeatureTypes$1 = vectorTile.VectorTileFeature.types;
	// NOTE ON EXTRUDE SCALE:
	// scale the extrusion vector so that the normal length is this value.
	// contains the "texture" normals (-1..1). this is distinct from the extrude
	// normals for line joins, because the x-value remains 0 for the texture
	// normal array, while the extrude normal actually moves the vertex to create
	// the acute/bevelled line join.
	const EXTRUDE_SCALE = 63;
	/*
	 * Sharp corners cause dashed lines to tilt because the distance along the line
	 * is the same at both the inner and outer corners. To improve the appearance of
	 * dashed lines we add extra points near sharp corners so that a smaller part
	 * of the line is tilted.
	 *
	 * COS_HALF_SHARP_CORNER controls how sharp a corner has to be for us to add an
	 * extra vertex. The default is 75 degrees.
	 *
	 * The newly created vertices are placed SHARP_CORNER_OFFSET pixels from the corner.
	 */
	const COS_HALF_SHARP_CORNER = Math.cos(75 / 2 * (Math.PI / 180));
	const SHARP_CORNER_OFFSET = 15;
	// Angle per triangle for approximating round line joins.
	const DEG_PER_TRIANGLE = 20;
	// The number of bits that is used to store the line distance in the buffer.
	const LINE_DISTANCE_BUFFER_BITS = 15;
	// We don't have enough bits for the line distance as we'd like to have, so
	// use this value to scale the line distance (in tile units) down to a smaller
	// value. This lets us store longer distances while sacrificing precision.
	const LINE_DISTANCE_SCALE = 1 / 2;
	// The maximum line distance, in tile units, that fits in the buffer.
	const MAX_LINE_DISTANCE = Math.pow(2, LINE_DISTANCE_BUFFER_BITS - 1) / LINE_DISTANCE_SCALE;
	/**
	 * @internal
	 * Line bucket class
	 */
	class LineBucket {
	    constructor(options) {
	        this.zoom = options.zoom;
	        this.overscaling = options.overscaling;
	        this.layers = options.layers;
	        this.layerIds = this.layers.map(layer => layer.id);
	        this.index = options.index;
	        this.hasPattern = false;
	        this.patternFeatures = [];
	        this.lineClipsArray = [];
	        this.gradients = {};
	        this.layers.forEach(layer => {
	            this.gradients[layer.id] = {};
	        });
	        this.layoutVertexArray = new LineLayoutArray();
	        this.layoutVertexArray2 = new LineExtLayoutArray();
	        this.indexArray = new TriangleIndexArray();
	        this.programConfigurations = new ProgramConfigurationSet(options.layers, options.zoom);
	        this.segments = new SegmentVector();
	        this.maxLineLength = 0;
	        this.stateDependentLayerIds = this.layers.filter((l) => l.isStateDependent()).map((l) => l.id);
	    }
	    populate(features, options, canonical) {
	        this.hasPattern = hasPattern('line', this.layers, options);
	        const lineSortKey = this.layers[0].layout.get('line-sort-key');
	        const sortFeaturesByKey = !lineSortKey.isConstant();
	        const bucketFeatures = [];
	        for (const { feature, id, index, sourceLayerIndex } of features) {
	            const needGeometry = this.layers[0]._featureFilter.needGeometry;
	            const evaluationFeature = toEvaluationFeature(feature, needGeometry);
	            if (!this.layers[0]._featureFilter.filter(new EvaluationParameters(this.zoom), evaluationFeature, canonical))
	                continue;
	            const sortKey = sortFeaturesByKey ?
	                lineSortKey.evaluate(evaluationFeature, {}, canonical) :
	                undefined;
	            const bucketFeature = {
	                id,
	                properties: feature.properties,
	                type: feature.type,
	                sourceLayerIndex,
	                index,
	                geometry: needGeometry ? evaluationFeature.geometry : loadGeometry(feature),
	                patterns: {},
	                sortKey
	            };
	            bucketFeatures.push(bucketFeature);
	        }
	        if (sortFeaturesByKey) {
	            bucketFeatures.sort((a, b) => {
	                return (a.sortKey) - (b.sortKey);
	            });
	        }
	        for (const bucketFeature of bucketFeatures) {
	            const { geometry, index, sourceLayerIndex } = bucketFeature;
	            if (this.hasPattern) {
	                const patternBucketFeature = addPatternDependencies('line', this.layers, bucketFeature, this.zoom, options);
	                // pattern features are added only once the pattern is loaded into the image atlas
	                // so are stored during populate until later updated with positions by tile worker in addFeatures
	                this.patternFeatures.push(patternBucketFeature);
	            }
	            else {
	                this.addFeature(bucketFeature, geometry, index, canonical, {});
	            }
	            const feature = features[index].feature;
	            options.featureIndex.insert(feature, geometry, index, sourceLayerIndex, this.index);
	        }
	    }
	    update(states, vtLayer, imagePositions) {
	        if (!this.stateDependentLayers.length)
	            return;
	        this.programConfigurations.updatePaintArrays(states, vtLayer, this.stateDependentLayers, imagePositions);
	    }
	    addFeatures(options, canonical, imagePositions) {
	        for (const feature of this.patternFeatures) {
	            this.addFeature(feature, feature.geometry, feature.index, canonical, imagePositions);
	        }
	    }
	    isEmpty() {
	        return this.layoutVertexArray.length === 0;
	    }
	    uploadPending() {
	        return !this.uploaded || this.programConfigurations.needsUpload;
	    }
	    upload(context) {
	        if (!this.uploaded) {
	            if (this.layoutVertexArray2.length !== 0) {
	                this.layoutVertexBuffer2 = context.createVertexBuffer(this.layoutVertexArray2, members);
	            }
	            this.layoutVertexBuffer = context.createVertexBuffer(this.layoutVertexArray, members$1);
	            this.indexBuffer = context.createIndexBuffer(this.indexArray);
	        }
	        this.programConfigurations.upload(context);
	        this.uploaded = true;
	    }
	    destroy() {
	        if (!this.layoutVertexBuffer)
	            return;
	        this.layoutVertexBuffer.destroy();
	        this.indexBuffer.destroy();
	        this.programConfigurations.destroy();
	        this.segments.destroy();
	    }
	    lineFeatureClips(feature) {
	        if (!!feature.properties && Object.prototype.hasOwnProperty.call(feature.properties, 'mapbox_clip_start') && Object.prototype.hasOwnProperty.call(feature.properties, 'mapbox_clip_end')) {
	            const start = +feature.properties['mapbox_clip_start'];
	            const end = +feature.properties['mapbox_clip_end'];
	            return { start, end };
	        }
	    }
	    addFeature(feature, geometry, index, canonical, imagePositions) {
	        const layout = this.layers[0].layout;
	        const join = layout.get('line-join').evaluate(feature, {});
	        const cap = layout.get('line-cap');
	        const miterLimit = layout.get('line-miter-limit');
	        const roundLimit = layout.get('line-round-limit');
	        this.lineClips = this.lineFeatureClips(feature);
	        for (const line of geometry) {
	            this.addLine(line, feature, join, cap, miterLimit, roundLimit);
	        }
	        this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, feature, index, imagePositions, canonical);
	    }
	    addLine(vertices, feature, join, cap, miterLimit, roundLimit) {
	        this.distance = 0;
	        this.scaledDistance = 0;
	        this.totalDistance = 0;
	        if (this.lineClips) {
	            this.lineClipsArray.push(this.lineClips);
	            // Calculate the total distance, in tile units, of this tiled line feature
	            for (let i = 0; i < vertices.length - 1; i++) {
	                this.totalDistance += vertices[i].dist(vertices[i + 1]);
	            }
	            this.updateScaledDistance();
	            this.maxLineLength = Math.max(this.maxLineLength, this.totalDistance);
	        }
	        const isPolygon = vectorTileFeatureTypes$1[feature.type] === 'Polygon';
	        // If the line has duplicate vertices at the ends, adjust start/length to remove them.
	        let len = vertices.length;
	        while (len >= 2 && vertices[len - 1].equals(vertices[len - 2])) {
	            len--;
	        }
	        let first = 0;
	        while (first < len - 1 && vertices[first].equals(vertices[first + 1])) {
	            first++;
	        }
	        // Ignore invalid geometry.
	        if (len < (isPolygon ? 3 : 2))
	            return;
	        if (join === 'bevel')
	            miterLimit = 1.05;
	        const sharpCornerOffset = this.overscaling <= 16 ?
	            SHARP_CORNER_OFFSET * EXTENT / (512 * this.overscaling) :
	            0;
	        // we could be more precise, but it would only save a negligible amount of space
	        const segment = this.segments.prepareSegment(len * 10, this.layoutVertexArray, this.indexArray);
	        let currentVertex;
	        let prevVertex;
	        let nextVertex;
	        let prevNormal;
	        let nextNormal;
	        // the last two vertices added
	        this.e1 = this.e2 = -1;
	        if (isPolygon) {
	            currentVertex = vertices[len - 2];
	            nextNormal = vertices[first].sub(currentVertex)._unit()._perp();
	        }
	        for (let i = first; i < len; i++) {
	            nextVertex = i === len - 1 ?
	                (isPolygon ? vertices[first + 1] : undefined) : // if it's a polygon, treat the last vertex like the first
	                vertices[i + 1]; // just the next vertex
	            // if two consecutive vertices exist, skip the current one
	            if (nextVertex && vertices[i].equals(nextVertex))
	                continue;
	            if (nextNormal)
	                prevNormal = nextNormal;
	            if (currentVertex)
	                prevVertex = currentVertex;
	            currentVertex = vertices[i];
	            // Calculate the normal towards the next vertex in this line. In case
	            // there is no next vertex, pretend that the line is continuing straight,
	            // meaning that we are just using the previous normal.
	            nextNormal = nextVertex ? nextVertex.sub(currentVertex)._unit()._perp() : prevNormal;
	            // If we still don't have a previous normal, this is the beginning of a
	            // non-closed line, so we're doing a straight "join".
	            prevNormal = prevNormal || nextNormal;
	            // Determine the normal of the join extrusion. It is the angle bisector
	            // of the segments between the previous line and the next line.
	            // In the case of 180° angles, the prev and next normals cancel each other out:
	            // prevNormal + nextNormal = (0, 0), its magnitude is 0, so the unit vector would be
	            // undefined. In that case, we're keeping the joinNormal at (0, 0), so that the cosHalfAngle
	            // below will also become 0 and miterLength will become Infinity.
	            let joinNormal = prevNormal.add(nextNormal);
	            if (joinNormal.x !== 0 || joinNormal.y !== 0) {
	                joinNormal._unit();
	            }
	            /*  joinNormal     prevNormal
	             *             ↖      ↑
	             *                .________. prevVertex
	             *                |
	             * nextNormal  ←  |  currentVertex
	             *                |
	             *     nextVertex !
	             *
	             */
	            // calculate cosines of the angle (and its half) using dot product
	            const cosAngle = prevNormal.x * nextNormal.x + prevNormal.y * nextNormal.y;
	            const cosHalfAngle = joinNormal.x * nextNormal.x + joinNormal.y * nextNormal.y;
	            // Calculate the length of the miter (the ratio of the miter to the width)
	            // as the inverse of cosine of the angle between next and join normals
	            const miterLength = cosHalfAngle !== 0 ? 1 / cosHalfAngle : Infinity;
	            // approximate angle from cosine
	            const approxAngle = 2 * Math.sqrt(2 - 2 * cosHalfAngle);
	            const isSharpCorner = cosHalfAngle < COS_HALF_SHARP_CORNER && prevVertex && nextVertex;
	            const lineTurnsLeft = prevNormal.x * nextNormal.y - prevNormal.y * nextNormal.x > 0;
	            if (isSharpCorner && i > first) {
	                const prevSegmentLength = currentVertex.dist(prevVertex);
	                if (prevSegmentLength > 2 * sharpCornerOffset) {
	                    const newPrevVertex = currentVertex.sub(currentVertex.sub(prevVertex)._mult(sharpCornerOffset / prevSegmentLength)._round());
	                    this.updateDistance(prevVertex, newPrevVertex);
	                    this.addCurrentVertex(newPrevVertex, prevNormal, 0, 0, segment);
	                    prevVertex = newPrevVertex;
	                }
	            }
	            // The join if a middle vertex, otherwise the cap.
	            const middleVertex = prevVertex && nextVertex;
	            let currentJoin = middleVertex ? join : isPolygon ? 'butt' : cap;
	            if (middleVertex && currentJoin === 'round') {
	                if (miterLength < roundLimit) {
	                    currentJoin = 'miter';
	                }
	                else if (miterLength <= 2) {
	                    currentJoin = 'fakeround';
	                }
	            }
	            if (currentJoin === 'miter' && miterLength > miterLimit) {
	                currentJoin = 'bevel';
	            }
	            if (currentJoin === 'bevel') {
	                // The maximum extrude length is 128 / 63 = 2 times the width of the line
	                // so if miterLength >= 2 we need to draw a different type of bevel here.
	                if (miterLength > 2)
	                    currentJoin = 'flipbevel';
	                // If the miterLength is really small and the line bevel wouldn't be visible,
	                // just draw a miter join to save a triangle.
	                if (miterLength < miterLimit)
	                    currentJoin = 'miter';
	            }
	            // Calculate how far along the line the currentVertex is
	            if (prevVertex)
	                this.updateDistance(prevVertex, currentVertex);
	            if (currentJoin === 'miter') {
	                joinNormal._mult(miterLength);
	                this.addCurrentVertex(currentVertex, joinNormal, 0, 0, segment);
	            }
	            else if (currentJoin === 'flipbevel') {
	                // miter is too big, flip the direction to make a beveled join
	                if (miterLength > 100) {
	                    // Almost parallel lines
	                    joinNormal = nextNormal.mult(-1);
	                }
	                else {
	                    const bevelLength = miterLength * prevNormal.add(nextNormal).mag() / prevNormal.sub(nextNormal).mag();
	                    joinNormal._perp()._mult(bevelLength * (lineTurnsLeft ? -1 : 1));
	                }
	                this.addCurrentVertex(currentVertex, joinNormal, 0, 0, segment);
	                this.addCurrentVertex(currentVertex, joinNormal.mult(-1), 0, 0, segment);
	            }
	            else if (currentJoin === 'bevel' || currentJoin === 'fakeround') {
	                const offset = -Math.sqrt(miterLength * miterLength - 1);
	                const offsetA = lineTurnsLeft ? offset : 0;
	                const offsetB = lineTurnsLeft ? 0 : offset;
	                // Close previous segment with a bevel
	                if (prevVertex) {
	                    this.addCurrentVertex(currentVertex, prevNormal, offsetA, offsetB, segment);
	                }
	                if (currentJoin === 'fakeround') {
	                    // The join angle is sharp enough that a round join would be visible.
	                    // Bevel joins fill the gap between segments with a single pie slice triangle.
	                    // Create a round join by adding multiple pie slices. The join isn't actually round, but
	                    // it looks like it is at the sizes we render lines at.
	                    // pick the number of triangles for approximating round join by based on the angle between normals
	                    const n = Math.round((approxAngle * 180 / Math.PI) / DEG_PER_TRIANGLE);
	                    for (let m = 1; m < n; m++) {
	                        let t = m / n;
	                        if (t !== 0.5) {
	                            // approximate spherical interpolation https://observablehq.com/@mourner/approximating-geometric-slerp
	                            const t2 = t - 0.5;
	                            const A = 1.0904 + cosAngle * (-3.2452 + cosAngle * (3.55645 - cosAngle * 1.43519));
	                            const B = 0.848013 + cosAngle * (-1.06021 + cosAngle * 0.215638);
	                            t = t + t * t2 * (t - 1) * (A * t2 * t2 + B);
	                        }
	                        const extrude = nextNormal.sub(prevNormal)._mult(t)._add(prevNormal)._unit()._mult(lineTurnsLeft ? -1 : 1);
	                        this.addHalfVertex(currentVertex, extrude.x, extrude.y, false, lineTurnsLeft, 0, segment);
	                    }
	                }
	                if (nextVertex) {
	                    // Start next segment
	                    this.addCurrentVertex(currentVertex, nextNormal, -offsetA, -offsetB, segment);
	                }
	            }
	            else if (currentJoin === 'butt') {
	                this.addCurrentVertex(currentVertex, joinNormal, 0, 0, segment); // butt cap
	            }
	            else if (currentJoin === 'square') {
	                const offset = prevVertex ? 1 : -1; // closing or starting square cap
	                this.addCurrentVertex(currentVertex, joinNormal, offset, offset, segment);
	            }
	            else if (currentJoin === 'round') {
	                if (prevVertex) {
	                    // Close previous segment with butt
	                    this.addCurrentVertex(currentVertex, prevNormal, 0, 0, segment);
	                    // Add round cap or linejoin at end of segment
	                    this.addCurrentVertex(currentVertex, prevNormal, 1, 1, segment, true);
	                }
	                if (nextVertex) {
	                    // Add round cap before first segment
	                    this.addCurrentVertex(currentVertex, nextNormal, -1, -1, segment, true);
	                    // Start next segment with a butt
	                    this.addCurrentVertex(currentVertex, nextNormal, 0, 0, segment);
	                }
	            }
	            if (isSharpCorner && i < len - 1) {
	                const nextSegmentLength = currentVertex.dist(nextVertex);
	                if (nextSegmentLength > 2 * sharpCornerOffset) {
	                    const newCurrentVertex = currentVertex.add(nextVertex.sub(currentVertex)._mult(sharpCornerOffset / nextSegmentLength)._round());
	                    this.updateDistance(currentVertex, newCurrentVertex);
	                    this.addCurrentVertex(newCurrentVertex, nextNormal, 0, 0, segment);
	                    currentVertex = newCurrentVertex;
	                }
	            }
	        }
	    }
	    /**
	     * Add two vertices to the buffers.
	     *
	     * @param p - the line vertex to add buffer vertices for
	     * @param normal - vertex normal
	     * @param endLeft - extrude to shift the left vertex along the line
	     * @param endRight - extrude to shift the left vertex along the line
	     * @param segment - the segment object to add the vertex to
	     * @param round - whether this is a round cap
	     */
	    addCurrentVertex(p, normal, endLeft, endRight, segment, round = false) {
	        // left and right extrude vectors, perpendicularly shifted by endLeft/endRight
	        const leftX = normal.x + normal.y * endLeft;
	        const leftY = normal.y - normal.x * endLeft;
	        const rightX = -normal.x + normal.y * endRight;
	        const rightY = -normal.y - normal.x * endRight;
	        this.addHalfVertex(p, leftX, leftY, round, false, endLeft, segment);
	        this.addHalfVertex(p, rightX, rightY, round, true, -endRight, segment);
	        // There is a maximum "distance along the line" that we can store in the buffers.
	        // When we get close to the distance, reset it to zero and add the vertex again with
	        // a distance of zero. The max distance is determined by the number of bits we allocate
	        // to `linesofar`.
	        if (this.distance > MAX_LINE_DISTANCE / 2 && this.totalDistance === 0) {
	            this.distance = 0;
	            this.updateScaledDistance();
	            this.addCurrentVertex(p, normal, endLeft, endRight, segment, round);
	        }
	    }
	    addHalfVertex({ x, y }, extrudeX, extrudeY, round, up, dir, segment) {
	        const totalDistance = this.lineClips ? this.scaledDistance * (MAX_LINE_DISTANCE - 1) : this.scaledDistance;
	        // scale down so that we can store longer distances while sacrificing precision.
	        const linesofarScaled = totalDistance * LINE_DISTANCE_SCALE;
	        this.layoutVertexArray.emplaceBack(
	        // a_pos_normal
	        // Encode round/up the least significant bits
	        (x << 1) + (round ? 1 : 0), (y << 1) + (up ? 1 : 0), 
	        // a_data
	        // add 128 to store a byte in an unsigned byte
	        Math.round(EXTRUDE_SCALE * extrudeX) + 128, Math.round(EXTRUDE_SCALE * extrudeY) + 128, 
	        // Encode the -1/0/1 direction value into the first two bits of .z of a_data.
	        // Combine it with the lower 6 bits of `linesofarScaled` (shifted by 2 bits to make
	        // room for the direction value). The upper 8 bits of `linesofarScaled` are placed in
	        // the `w` component.
	        ((dir === 0 ? 0 : (dir < 0 ? -1 : 1)) + 1) | ((linesofarScaled & 0x3F) << 2), linesofarScaled >> 6);
	        // Constructs a second vertex buffer with higher precision line progress
	        if (this.lineClips) {
	            const progressRealigned = this.scaledDistance - this.lineClips.start;
	            const endClipRealigned = this.lineClips.end - this.lineClips.start;
	            const uvX = progressRealigned / endClipRealigned;
	            this.layoutVertexArray2.emplaceBack(uvX, this.lineClipsArray.length);
	        }
	        const e = segment.vertexLength++;
	        if (this.e1 >= 0 && this.e2 >= 0) {
	            this.indexArray.emplaceBack(this.e1, this.e2, e);
	            segment.primitiveLength++;
	        }
	        if (up) {
	            this.e2 = e;
	        }
	        else {
	            this.e1 = e;
	        }
	    }
	    updateScaledDistance() {
	        // Knowing the ratio of the full linestring covered by this tiled feature, as well
	        // as the total distance (in tile units) of this tiled feature, and the distance
	        // (in tile units) of the current vertex, we can determine the relative distance
	        // of this vertex along the full linestring feature and scale it to [0, 2^15)
	        this.scaledDistance = this.lineClips ?
	            this.lineClips.start + (this.lineClips.end - this.lineClips.start) * this.distance / this.totalDistance :
	            this.distance;
	    }
	    updateDistance(prev, next) {
	        this.distance += prev.dist(next);
	        this.updateScaledDistance();
	    }
	}
	register('LineBucket', LineBucket, { omit: ['layers', 'patternFeatures'] });

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let layout$1;
	const getLayout$1 = () => layout$1 = layout$1 || new Properties({
	    "line-cap": new DataConstantProperty(v8Spec["layout_line"]["line-cap"]),
	    "line-join": new DataDrivenProperty(v8Spec["layout_line"]["line-join"]),
	    "line-miter-limit": new DataConstantProperty(v8Spec["layout_line"]["line-miter-limit"]),
	    "line-round-limit": new DataConstantProperty(v8Spec["layout_line"]["line-round-limit"]),
	    "line-sort-key": new DataDrivenProperty(v8Spec["layout_line"]["line-sort-key"]),
	});
	let paint$3;
	const getPaint$3 = () => paint$3 = paint$3 || new Properties({
	    "line-opacity": new DataDrivenProperty(v8Spec["paint_line"]["line-opacity"]),
	    "line-color": new DataDrivenProperty(v8Spec["paint_line"]["line-color"]),
	    "line-translate": new DataConstantProperty(v8Spec["paint_line"]["line-translate"]),
	    "line-translate-anchor": new DataConstantProperty(v8Spec["paint_line"]["line-translate-anchor"]),
	    "line-width": new DataDrivenProperty(v8Spec["paint_line"]["line-width"]),
	    "line-gap-width": new DataDrivenProperty(v8Spec["paint_line"]["line-gap-width"]),
	    "line-offset": new DataDrivenProperty(v8Spec["paint_line"]["line-offset"]),
	    "line-blur": new DataDrivenProperty(v8Spec["paint_line"]["line-blur"]),
	    "line-dasharray": new CrossFadedProperty(v8Spec["paint_line"]["line-dasharray"]),
	    "line-pattern": new CrossFadedDataDrivenProperty(v8Spec["paint_line"]["line-pattern"]),
	    "line-gradient": new ColorRampProperty(v8Spec["paint_line"]["line-gradient"]),
	});
	var properties$3 = ({ get paint() { return getPaint$3(); }, get layout() { return getLayout$1(); } });

	class LineFloorwidthProperty extends DataDrivenProperty {
	    possiblyEvaluate(value, parameters) {
	        parameters = new EvaluationParameters(Math.floor(parameters.zoom), {
	            now: parameters.now,
	            fadeDuration: parameters.fadeDuration,
	            zoomHistory: parameters.zoomHistory,
	            transition: parameters.transition
	        });
	        return super.possiblyEvaluate(value, parameters);
	    }
	    evaluate(value, globals, feature, featureState) {
	        globals = extend({}, globals, { zoom: Math.floor(globals.zoom) });
	        return super.evaluate(value, globals, feature, featureState);
	    }
	}
	let lineFloorwidthProperty;
	class LineStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties$3);
	        this.gradientVersion = 0;
	        if (!lineFloorwidthProperty) {
	            lineFloorwidthProperty =
	                new LineFloorwidthProperty(properties$3.paint.properties['line-width'].specification);
	            lineFloorwidthProperty.useIntegerZoom = true;
	        }
	    }
	    _handleSpecialPaintPropertyUpdate(name) {
	        if (name === 'line-gradient') {
	            const expression = this.gradientExpression();
	            if (isZoomExpression(expression)) {
	                this.stepInterpolant = expression._styleExpression.expression instanceof Step;
	            }
	            else {
	                this.stepInterpolant = false;
	            }
	            this.gradientVersion = (this.gradientVersion + 1) % Number.MAX_SAFE_INTEGER;
	        }
	    }
	    gradientExpression() {
	        return this._transitionablePaint._values['line-gradient'].value.expression;
	    }
	    recalculate(parameters, availableImages) {
	        super.recalculate(parameters, availableImages);
	        this.paint._values['line-floorwidth'] =
	            lineFloorwidthProperty.possiblyEvaluate(this._transitioningPaint._values['line-width'].value, parameters);
	    }
	    createBucket(parameters) {
	        return new LineBucket(parameters);
	    }
	    queryRadius(bucket) {
	        const lineBucket = bucket;
	        const width = getLineWidth(getMaximumPaintValue('line-width', this, lineBucket), getMaximumPaintValue('line-gap-width', this, lineBucket));
	        const offset = getMaximumPaintValue('line-offset', this, lineBucket);
	        return width / 2 + Math.abs(offset) + translateDistance(this.paint.get('line-translate'));
	    }
	    queryIntersectsFeature(queryGeometry, feature, featureState, geometry, zoom, transform, pixelsToTileUnits) {
	        const translatedPolygon = translate$4(queryGeometry, this.paint.get('line-translate'), this.paint.get('line-translate-anchor'), transform.angle, pixelsToTileUnits);
	        const halfWidth = pixelsToTileUnits / 2 * getLineWidth(this.paint.get('line-width').evaluate(feature, featureState), this.paint.get('line-gap-width').evaluate(feature, featureState));
	        const lineOffset = this.paint.get('line-offset').evaluate(feature, featureState);
	        if (lineOffset) {
	            geometry = offsetLine(geometry, lineOffset * pixelsToTileUnits);
	        }
	        return polygonIntersectsBufferedMultiLine(translatedPolygon, geometry, halfWidth);
	    }
	    isTileClipped() {
	        return true;
	    }
	}
	function getLineWidth(lineWidth, lineGapWidth) {
	    if (lineGapWidth > 0) {
	        return lineGapWidth + 2 * lineWidth;
	    }
	    else {
	        return lineWidth;
	    }
	}

	const symbolLayoutAttributes = createLayout([
	    { name: 'a_pos_offset', components: 4, type: 'Int16' },
	    { name: 'a_data', components: 4, type: 'Uint16' },
	    { name: 'a_pixeloffset', components: 4, type: 'Int16' }
	], 4);
	const dynamicLayoutAttributes = createLayout([
	    { name: 'a_projected_pos', components: 3, type: 'Float32' }
	], 4);
	createLayout([
	    { name: 'a_fade_opacity', components: 1, type: 'Uint32' }
	], 4);
	const collisionVertexAttributes = createLayout([
	    { name: 'a_placed', components: 2, type: 'Uint8' },
	    { name: 'a_shift', components: 2, type: 'Float32' }
	]);
	createLayout([
	    // the box is centered around the anchor point
	    { type: 'Int16', name: 'anchorPointX' },
	    { type: 'Int16', name: 'anchorPointY' },
	    // distances to the edges from the anchor
	    { type: 'Int16', name: 'x1' },
	    { type: 'Int16', name: 'y1' },
	    { type: 'Int16', name: 'x2' },
	    { type: 'Int16', name: 'y2' },
	    // the index of the feature in the original vectortile
	    { type: 'Uint32', name: 'featureIndex' },
	    // the source layer the feature appears in
	    { type: 'Uint16', name: 'sourceLayerIndex' },
	    // the bucket the feature appears in
	    { type: 'Uint16', name: 'bucketIndex' },
	]);
	const collisionBoxLayout = createLayout([
	    { name: 'a_pos', components: 2, type: 'Int16' },
	    { name: 'a_anchor_pos', components: 2, type: 'Int16' },
	    { name: 'a_extrude', components: 2, type: 'Int16' }
	], 4);
	const collisionCircleLayout = createLayout([
	    { name: 'a_pos', components: 2, type: 'Float32' },
	    { name: 'a_radius', components: 1, type: 'Float32' },
	    { name: 'a_flags', components: 2, type: 'Int16' }
	], 4);
	createLayout([
	    { name: 'triangle', components: 3, type: 'Uint16' },
	]);
	createLayout([
	    { type: 'Int16', name: 'anchorX' },
	    { type: 'Int16', name: 'anchorY' },
	    { type: 'Uint16', name: 'glyphStartIndex' },
	    { type: 'Uint16', name: 'numGlyphs' },
	    { type: 'Uint32', name: 'vertexStartIndex' },
	    { type: 'Uint32', name: 'lineStartIndex' },
	    { type: 'Uint32', name: 'lineLength' },
	    { type: 'Uint16', name: 'segment' },
	    { type: 'Uint16', name: 'lowerSize' },
	    { type: 'Uint16', name: 'upperSize' },
	    { type: 'Float32', name: 'lineOffsetX' },
	    { type: 'Float32', name: 'lineOffsetY' },
	    { type: 'Uint8', name: 'writingMode' },
	    { type: 'Uint8', name: 'placedOrientation' },
	    { type: 'Uint8', name: 'hidden' },
	    { type: 'Uint32', name: 'crossTileID' },
	    { type: 'Int16', name: 'associatedIconIndex' }
	]);
	createLayout([
	    { type: 'Int16', name: 'anchorX' },
	    { type: 'Int16', name: 'anchorY' },
	    { type: 'Int16', name: 'rightJustifiedTextSymbolIndex' },
	    { type: 'Int16', name: 'centerJustifiedTextSymbolIndex' },
	    { type: 'Int16', name: 'leftJustifiedTextSymbolIndex' },
	    { type: 'Int16', name: 'verticalPlacedTextSymbolIndex' },
	    { type: 'Int16', name: 'placedIconSymbolIndex' },
	    { type: 'Int16', name: 'verticalPlacedIconSymbolIndex' },
	    { type: 'Uint16', name: 'key' },
	    { type: 'Uint16', name: 'textBoxStartIndex' },
	    { type: 'Uint16', name: 'textBoxEndIndex' },
	    { type: 'Uint16', name: 'verticalTextBoxStartIndex' },
	    { type: 'Uint16', name: 'verticalTextBoxEndIndex' },
	    { type: 'Uint16', name: 'iconBoxStartIndex' },
	    { type: 'Uint16', name: 'iconBoxEndIndex' },
	    { type: 'Uint16', name: 'verticalIconBoxStartIndex' },
	    { type: 'Uint16', name: 'verticalIconBoxEndIndex' },
	    { type: 'Uint16', name: 'featureIndex' },
	    { type: 'Uint16', name: 'numHorizontalGlyphVertices' },
	    { type: 'Uint16', name: 'numVerticalGlyphVertices' },
	    { type: 'Uint16', name: 'numIconVertices' },
	    { type: 'Uint16', name: 'numVerticalIconVertices' },
	    { type: 'Uint16', name: 'useRuntimeCollisionCircles' },
	    { type: 'Uint32', name: 'crossTileID' },
	    { type: 'Float32', name: 'textBoxScale' },
	    { type: 'Float32', name: 'collisionCircleDiameter' },
	    { type: 'Uint16', name: 'textAnchorOffsetStartIndex' },
	    { type: 'Uint16', name: 'textAnchorOffsetEndIndex' }
	]);
	createLayout([
	    { type: 'Float32', name: 'offsetX' }
	]);
	createLayout([
	    { type: 'Int16', name: 'x' },
	    { type: 'Int16', name: 'y' },
	    { type: 'Int16', name: 'tileUnitDistanceFromAnchor' }
	]);
	createLayout([
	    { type: 'Uint16', name: 'textAnchor' },
	    { type: 'Float32', components: 2, name: 'textOffset' }
	]);

	function transformTextInternal(text, layer, feature) {
	    const transform = layer.layout.get('text-transform').evaluate(feature, {});
	    if (transform === 'uppercase') {
	        text = text.toLocaleUpperCase();
	    }
	    else if (transform === 'lowercase') {
	        text = text.toLocaleLowerCase();
	    }
	    if (rtlWorkerPlugin.applyArabicShaping) {
	        text = rtlWorkerPlugin.applyArabicShaping(text);
	    }
	    return text;
	}
	function transformText(text, layer, feature) {
	    text.sections.forEach(section => {
	        section.text = transformTextInternal(section.text, layer, feature);
	    });
	    return text;
	}

	function mergeLines(features) {
	    const leftIndex = {};
	    const rightIndex = {};
	    const mergedFeatures = [];
	    let mergedIndex = 0;
	    function add(k) {
	        mergedFeatures.push(features[k]);
	        mergedIndex++;
	    }
	    function mergeFromRight(leftKey, rightKey, geom) {
	        const i = rightIndex[leftKey];
	        delete rightIndex[leftKey];
	        rightIndex[rightKey] = i;
	        mergedFeatures[i].geometry[0].pop();
	        mergedFeatures[i].geometry[0] = mergedFeatures[i].geometry[0].concat(geom[0]);
	        return i;
	    }
	    function mergeFromLeft(leftKey, rightKey, geom) {
	        const i = leftIndex[rightKey];
	        delete leftIndex[rightKey];
	        leftIndex[leftKey] = i;
	        mergedFeatures[i].geometry[0].shift();
	        mergedFeatures[i].geometry[0] = geom[0].concat(mergedFeatures[i].geometry[0]);
	        return i;
	    }
	    function getKey(text, geom, onRight) {
	        const point = onRight ? geom[0][geom[0].length - 1] : geom[0][0];
	        return `${text}:${point.x}:${point.y}`;
	    }
	    for (let k = 0; k < features.length; k++) {
	        const feature = features[k];
	        const geom = feature.geometry;
	        const text = feature.text ? feature.text.toString() : null;
	        if (!text) {
	            add(k);
	            continue;
	        }
	        const leftKey = getKey(text, geom), rightKey = getKey(text, geom, true);
	        if ((leftKey in rightIndex) && (rightKey in leftIndex) && (rightIndex[leftKey] !== leftIndex[rightKey])) {
	            // found lines with the same text adjacent to both ends of the current line, merge all three
	            const j = mergeFromLeft(leftKey, rightKey, geom);
	            const i = mergeFromRight(leftKey, rightKey, mergedFeatures[j].geometry);
	            delete leftIndex[leftKey];
	            delete rightIndex[rightKey];
	            rightIndex[getKey(text, mergedFeatures[i].geometry, true)] = i;
	            mergedFeatures[j].geometry = null;
	        }
	        else if (leftKey in rightIndex) {
	            // found mergeable line adjacent to the start of the current line, merge
	            mergeFromRight(leftKey, rightKey, geom);
	        }
	        else if (rightKey in leftIndex) {
	            // found mergeable line adjacent to the end of the current line, merge
	            mergeFromLeft(leftKey, rightKey, geom);
	        }
	        else {
	            // no adjacent lines, add as a new item
	            add(k);
	            leftIndex[leftKey] = mergedIndex - 1;
	            rightIndex[rightKey] = mergedIndex - 1;
	        }
	    }
	    return mergedFeatures.filter((f) => f.geometry);
	}

	const verticalizedCharacterMap = {
	    '!': '︕',
	    '#': '＃',
	    '$': '＄',
	    '%': '％',
	    '&': '＆',
	    '(': '︵',
	    ')': '︶',
	    '*': '＊',
	    '+': '＋',
	    ',': '︐',
	    '-': '︲',
	    '.': '・',
	    '/': '／',
	    ':': '︓',
	    ';': '︔',
	    '<': '︿',
	    '=': '＝',
	    '>': '﹀',
	    '?': '︖',
	    '@': '＠',
	    '[': '﹇',
	    '\\': '＼',
	    ']': '﹈',
	    '^': '＾',
	    '_': '︳',
	    '`': '｀',
	    '{': '︷',
	    '|': '―',
	    '}': '︸',
	    '~': '～',
	    '¢': '￠',
	    '£': '￡',
	    '¥': '￥',
	    '¦': '￤',
	    '¬': '￢',
	    '¯': '￣',
	    '–': '︲',
	    '—': '︱',
	    '‘': '﹃',
	    '’': '﹄',
	    '“': '﹁',
	    '”': '﹂',
	    '…': '︙',
	    '‧': '・',
	    '₩': '￦',
	    '、': '︑',
	    '。': '︒',
	    '〈': '︿',
	    '〉': '﹀',
	    '《': '︽',
	    '》': '︾',
	    '「': '﹁',
	    '」': '﹂',
	    '『': '﹃',
	    '』': '﹄',
	    '【': '︻',
	    '】': '︼',
	    '〔': '︹',
	    '〕': '︺',
	    '〖': '︗',
	    '〗': '︘',
	    '！': '︕',
	    '（': '︵',
	    '）': '︶',
	    '，': '︐',
	    '－': '︲',
	    '．': '・',
	    '：': '︓',
	    '；': '︔',
	    '＜': '︿',
	    '＞': '﹀',
	    '？': '︖',
	    '［': '﹇',
	    '］': '﹈',
	    '＿': '︳',
	    '｛': '︷',
	    '｜': '―',
	    '｝': '︸',
	    '｟': '︵',
	    '｠': '︶',
	    '｡': '︒',
	    '｢': '﹁',
	    '｣': '﹂'
	};
	function verticalizePunctuation(input) {
	    let output = '';
	    for (let i = 0; i < input.length; i++) {
	        const nextCharCode = input.charCodeAt(i + 1) || null;
	        const prevCharCode = input.charCodeAt(i - 1) || null;
	        const canReplacePunctuation = ((!nextCharCode || !charHasRotatedVerticalOrientation(nextCharCode) || verticalizedCharacterMap[input[i + 1]]) &&
	            (!prevCharCode || !charHasRotatedVerticalOrientation(prevCharCode) || verticalizedCharacterMap[input[i - 1]]));
	        if (canReplacePunctuation && verticalizedCharacterMap[input[i]]) {
	            output += verticalizedCharacterMap[input[i]];
	        }
	        else {
	            output += input[i];
	        }
	    }
	    return output;
	}

	// ONE_EM constant used to go between "em" units used in style spec and "points" used internally for layout
	var ONE_EM = 24;

	var ieee754$1 = {};

	/*! ieee754. BSD-3-Clause License. Feross Aboukhadijeh <https://feross.org/opensource> */

	ieee754$1.read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m;
	  var eLen = (nBytes * 8) - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var nBits = -7;
	  var i = isLE ? (nBytes - 1) : 0;
	  var d = isLE ? -1 : 1;
	  var s = buffer[offset + i];

	  i += d;

	  e = s & ((1 << (-nBits)) - 1);
	  s >>= (-nBits);
	  nBits += eLen;
	  for (; nBits > 0; e = (e * 256) + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & ((1 << (-nBits)) - 1);
	  e >>= (-nBits);
	  nBits += mLen;
	  for (; nBits > 0; m = (m * 256) + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias;
	  } else if (e === eMax) {
	    return m ? NaN : ((s ? -1 : 1) * Infinity)
	  } else {
	    m = m + Math.pow(2, mLen);
	    e = e - eBias;
	  }
	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
	};

	ieee754$1.write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c;
	  var eLen = (nBytes * 8) - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
	  var i = isLE ? 0 : (nBytes - 1);
	  var d = isLE ? 1 : -1;
	  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

	  value = Math.abs(value);

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0;
	    e = eMax;
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2);
	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--;
	      c *= 2;
	    }
	    if (e + eBias >= 1) {
	      value += rt / c;
	    } else {
	      value += rt * Math.pow(2, 1 - eBias);
	    }
	    if (value * c >= 2) {
	      e++;
	      c /= 2;
	    }

	    if (e + eBias >= eMax) {
	      m = 0;
	      e = eMax;
	    } else if (e + eBias >= 1) {
	      m = ((value * c) - 1) * Math.pow(2, mLen);
	      e = e + eBias;
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
	      e = 0;
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = (e << mLen) | m;
	  eLen += mLen;
	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128;
	};

	var pbf = Pbf;

	var ieee754 = ieee754$1;

	function Pbf(buf) {
	    this.buf = ArrayBuffer.isView && ArrayBuffer.isView(buf) ? buf : new Uint8Array(buf || 0);
	    this.pos = 0;
	    this.type = 0;
	    this.length = this.buf.length;
	}

	Pbf.Varint  = 0; // varint: int32, int64, uint32, uint64, sint32, sint64, bool, enum
	Pbf.Fixed64 = 1; // 64-bit: double, fixed64, sfixed64
	Pbf.Bytes   = 2; // length-delimited: string, bytes, embedded messages, packed repeated fields
	Pbf.Fixed32 = 5; // 32-bit: float, fixed32, sfixed32

	var SHIFT_LEFT_32 = (1 << 16) * (1 << 16),
	    SHIFT_RIGHT_32 = 1 / SHIFT_LEFT_32;

	// Threshold chosen based on both benchmarking and knowledge about browser string
	// data structures (which currently switch structure types at 12 bytes or more)
	var TEXT_DECODER_MIN_LENGTH = 12;
	var utf8TextDecoder = typeof TextDecoder === 'undefined' ? null : new TextDecoder('utf8');

	Pbf.prototype = {

	    destroy: function() {
	        this.buf = null;
	    },

	    // === READING =================================================================

	    readFields: function(readField, result, end) {
	        end = end || this.length;

	        while (this.pos < end) {
	            var val = this.readVarint(),
	                tag = val >> 3,
	                startPos = this.pos;

	            this.type = val & 0x7;
	            readField(tag, result, this);

	            if (this.pos === startPos) this.skip(val);
	        }
	        return result;
	    },

	    readMessage: function(readField, result) {
	        return this.readFields(readField, result, this.readVarint() + this.pos);
	    },

	    readFixed32: function() {
	        var val = readUInt32(this.buf, this.pos);
	        this.pos += 4;
	        return val;
	    },

	    readSFixed32: function() {
	        var val = readInt32(this.buf, this.pos);
	        this.pos += 4;
	        return val;
	    },

	    // 64-bit int handling is based on github.com/dpw/node-buffer-more-ints (MIT-licensed)

	    readFixed64: function() {
	        var val = readUInt32(this.buf, this.pos) + readUInt32(this.buf, this.pos + 4) * SHIFT_LEFT_32;
	        this.pos += 8;
	        return val;
	    },

	    readSFixed64: function() {
	        var val = readUInt32(this.buf, this.pos) + readInt32(this.buf, this.pos + 4) * SHIFT_LEFT_32;
	        this.pos += 8;
	        return val;
	    },

	    readFloat: function() {
	        var val = ieee754.read(this.buf, this.pos, true, 23, 4);
	        this.pos += 4;
	        return val;
	    },

	    readDouble: function() {
	        var val = ieee754.read(this.buf, this.pos, true, 52, 8);
	        this.pos += 8;
	        return val;
	    },

	    readVarint: function(isSigned) {
	        var buf = this.buf,
	            val, b;

	        b = buf[this.pos++]; val  =  b & 0x7f;        if (b < 0x80) return val;
	        b = buf[this.pos++]; val |= (b & 0x7f) << 7;  if (b < 0x80) return val;
	        b = buf[this.pos++]; val |= (b & 0x7f) << 14; if (b < 0x80) return val;
	        b = buf[this.pos++]; val |= (b & 0x7f) << 21; if (b < 0x80) return val;
	        b = buf[this.pos];   val |= (b & 0x0f) << 28;

	        return readVarintRemainder(val, isSigned, this);
	    },

	    readVarint64: function() { // for compatibility with v2.0.1
	        return this.readVarint(true);
	    },

	    readSVarint: function() {
	        var num = this.readVarint();
	        return num % 2 === 1 ? (num + 1) / -2 : num / 2; // zigzag encoding
	    },

	    readBoolean: function() {
	        return Boolean(this.readVarint());
	    },

	    readString: function() {
	        var end = this.readVarint() + this.pos;
	        var pos = this.pos;
	        this.pos = end;

	        if (end - pos >= TEXT_DECODER_MIN_LENGTH && utf8TextDecoder) {
	            // longer strings are fast with the built-in browser TextDecoder API
	            return readUtf8TextDecoder(this.buf, pos, end);
	        }
	        // short strings are fast with our custom implementation
	        return readUtf8(this.buf, pos, end);
	    },

	    readBytes: function() {
	        var end = this.readVarint() + this.pos,
	            buffer = this.buf.subarray(this.pos, end);
	        this.pos = end;
	        return buffer;
	    },

	    // verbose for performance reasons; doesn't affect gzipped size

	    readPackedVarint: function(arr, isSigned) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readVarint(isSigned));
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readVarint(isSigned));
	        return arr;
	    },
	    readPackedSVarint: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readSVarint());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readSVarint());
	        return arr;
	    },
	    readPackedBoolean: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readBoolean());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readBoolean());
	        return arr;
	    },
	    readPackedFloat: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readFloat());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readFloat());
	        return arr;
	    },
	    readPackedDouble: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readDouble());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readDouble());
	        return arr;
	    },
	    readPackedFixed32: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readFixed32());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readFixed32());
	        return arr;
	    },
	    readPackedSFixed32: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readSFixed32());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readSFixed32());
	        return arr;
	    },
	    readPackedFixed64: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readFixed64());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readFixed64());
	        return arr;
	    },
	    readPackedSFixed64: function(arr) {
	        if (this.type !== Pbf.Bytes) return arr.push(this.readSFixed64());
	        var end = readPackedEnd(this);
	        arr = arr || [];
	        while (this.pos < end) arr.push(this.readSFixed64());
	        return arr;
	    },

	    skip: function(val) {
	        var type = val & 0x7;
	        if (type === Pbf.Varint) while (this.buf[this.pos++] > 0x7f) {}
	        else if (type === Pbf.Bytes) this.pos = this.readVarint() + this.pos;
	        else if (type === Pbf.Fixed32) this.pos += 4;
	        else if (type === Pbf.Fixed64) this.pos += 8;
	        else throw new Error('Unimplemented type: ' + type);
	    },

	    // === WRITING =================================================================

	    writeTag: function(tag, type) {
	        this.writeVarint((tag << 3) | type);
	    },

	    realloc: function(min) {
	        var length = this.length || 16;

	        while (length < this.pos + min) length *= 2;

	        if (length !== this.length) {
	            var buf = new Uint8Array(length);
	            buf.set(this.buf);
	            this.buf = buf;
	            this.length = length;
	        }
	    },

	    finish: function() {
	        this.length = this.pos;
	        this.pos = 0;
	        return this.buf.subarray(0, this.length);
	    },

	    writeFixed32: function(val) {
	        this.realloc(4);
	        writeInt32(this.buf, val, this.pos);
	        this.pos += 4;
	    },

	    writeSFixed32: function(val) {
	        this.realloc(4);
	        writeInt32(this.buf, val, this.pos);
	        this.pos += 4;
	    },

	    writeFixed64: function(val) {
	        this.realloc(8);
	        writeInt32(this.buf, val & -1, this.pos);
	        writeInt32(this.buf, Math.floor(val * SHIFT_RIGHT_32), this.pos + 4);
	        this.pos += 8;
	    },

	    writeSFixed64: function(val) {
	        this.realloc(8);
	        writeInt32(this.buf, val & -1, this.pos);
	        writeInt32(this.buf, Math.floor(val * SHIFT_RIGHT_32), this.pos + 4);
	        this.pos += 8;
	    },

	    writeVarint: function(val) {
	        val = +val || 0;

	        if (val > 0xfffffff || val < 0) {
	            writeBigVarint(val, this);
	            return;
	        }

	        this.realloc(4);

	        this.buf[this.pos++] =           val & 0x7f  | (val > 0x7f ? 0x80 : 0); if (val <= 0x7f) return;
	        this.buf[this.pos++] = ((val >>>= 7) & 0x7f) | (val > 0x7f ? 0x80 : 0); if (val <= 0x7f) return;
	        this.buf[this.pos++] = ((val >>>= 7) & 0x7f) | (val > 0x7f ? 0x80 : 0); if (val <= 0x7f) return;
	        this.buf[this.pos++] =   (val >>> 7) & 0x7f;
	    },

	    writeSVarint: function(val) {
	        this.writeVarint(val < 0 ? -val * 2 - 1 : val * 2);
	    },

	    writeBoolean: function(val) {
	        this.writeVarint(Boolean(val));
	    },

	    writeString: function(str) {
	        str = String(str);
	        this.realloc(str.length * 4);

	        this.pos++; // reserve 1 byte for short string length

	        var startPos = this.pos;
	        // write the string directly to the buffer and see how much was written
	        this.pos = writeUtf8(this.buf, str, this.pos);
	        var len = this.pos - startPos;

	        if (len >= 0x80) makeRoomForExtraLength(startPos, len, this);

	        // finally, write the message length in the reserved place and restore the position
	        this.pos = startPos - 1;
	        this.writeVarint(len);
	        this.pos += len;
	    },

	    writeFloat: function(val) {
	        this.realloc(4);
	        ieee754.write(this.buf, val, this.pos, true, 23, 4);
	        this.pos += 4;
	    },

	    writeDouble: function(val) {
	        this.realloc(8);
	        ieee754.write(this.buf, val, this.pos, true, 52, 8);
	        this.pos += 8;
	    },

	    writeBytes: function(buffer) {
	        var len = buffer.length;
	        this.writeVarint(len);
	        this.realloc(len);
	        for (var i = 0; i < len; i++) this.buf[this.pos++] = buffer[i];
	    },

	    writeRawMessage: function(fn, obj) {
	        this.pos++; // reserve 1 byte for short message length

	        // write the message directly to the buffer and see how much was written
	        var startPos = this.pos;
	        fn(obj, this);
	        var len = this.pos - startPos;

	        if (len >= 0x80) makeRoomForExtraLength(startPos, len, this);

	        // finally, write the message length in the reserved place and restore the position
	        this.pos = startPos - 1;
	        this.writeVarint(len);
	        this.pos += len;
	    },

	    writeMessage: function(tag, fn, obj) {
	        this.writeTag(tag, Pbf.Bytes);
	        this.writeRawMessage(fn, obj);
	    },

	    writePackedVarint:   function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedVarint, arr);   },
	    writePackedSVarint:  function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedSVarint, arr);  },
	    writePackedBoolean:  function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedBoolean, arr);  },
	    writePackedFloat:    function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedFloat, arr);    },
	    writePackedDouble:   function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedDouble, arr);   },
	    writePackedFixed32:  function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedFixed32, arr);  },
	    writePackedSFixed32: function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedSFixed32, arr); },
	    writePackedFixed64:  function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedFixed64, arr);  },
	    writePackedSFixed64: function(tag, arr) { if (arr.length) this.writeMessage(tag, writePackedSFixed64, arr); },

	    writeBytesField: function(tag, buffer) {
	        this.writeTag(tag, Pbf.Bytes);
	        this.writeBytes(buffer);
	    },
	    writeFixed32Field: function(tag, val) {
	        this.writeTag(tag, Pbf.Fixed32);
	        this.writeFixed32(val);
	    },
	    writeSFixed32Field: function(tag, val) {
	        this.writeTag(tag, Pbf.Fixed32);
	        this.writeSFixed32(val);
	    },
	    writeFixed64Field: function(tag, val) {
	        this.writeTag(tag, Pbf.Fixed64);
	        this.writeFixed64(val);
	    },
	    writeSFixed64Field: function(tag, val) {
	        this.writeTag(tag, Pbf.Fixed64);
	        this.writeSFixed64(val);
	    },
	    writeVarintField: function(tag, val) {
	        this.writeTag(tag, Pbf.Varint);
	        this.writeVarint(val);
	    },
	    writeSVarintField: function(tag, val) {
	        this.writeTag(tag, Pbf.Varint);
	        this.writeSVarint(val);
	    },
	    writeStringField: function(tag, str) {
	        this.writeTag(tag, Pbf.Bytes);
	        this.writeString(str);
	    },
	    writeFloatField: function(tag, val) {
	        this.writeTag(tag, Pbf.Fixed32);
	        this.writeFloat(val);
	    },
	    writeDoubleField: function(tag, val) {
	        this.writeTag(tag, Pbf.Fixed64);
	        this.writeDouble(val);
	    },
	    writeBooleanField: function(tag, val) {
	        this.writeVarintField(tag, Boolean(val));
	    }
	};

	function readVarintRemainder(l, s, p) {
	    var buf = p.buf,
	        h, b;

	    b = buf[p.pos++]; h  = (b & 0x70) >> 4;  if (b < 0x80) return toNum(l, h, s);
	    b = buf[p.pos++]; h |= (b & 0x7f) << 3;  if (b < 0x80) return toNum(l, h, s);
	    b = buf[p.pos++]; h |= (b & 0x7f) << 10; if (b < 0x80) return toNum(l, h, s);
	    b = buf[p.pos++]; h |= (b & 0x7f) << 17; if (b < 0x80) return toNum(l, h, s);
	    b = buf[p.pos++]; h |= (b & 0x7f) << 24; if (b < 0x80) return toNum(l, h, s);
	    b = buf[p.pos++]; h |= (b & 0x01) << 31; if (b < 0x80) return toNum(l, h, s);

	    throw new Error('Expected varint not more than 10 bytes');
	}

	function readPackedEnd(pbf) {
	    return pbf.type === Pbf.Bytes ?
	        pbf.readVarint() + pbf.pos : pbf.pos + 1;
	}

	function toNum(low, high, isSigned) {
	    if (isSigned) {
	        return high * 0x100000000 + (low >>> 0);
	    }

	    return ((high >>> 0) * 0x100000000) + (low >>> 0);
	}

	function writeBigVarint(val, pbf) {
	    var low, high;

	    if (val >= 0) {
	        low  = (val % 0x100000000) | 0;
	        high = (val / 0x100000000) | 0;
	    } else {
	        low  = ~(-val % 0x100000000);
	        high = ~(-val / 0x100000000);

	        if (low ^ 0xffffffff) {
	            low = (low + 1) | 0;
	        } else {
	            low = 0;
	            high = (high + 1) | 0;
	        }
	    }

	    if (val >= 0x10000000000000000 || val < -0x10000000000000000) {
	        throw new Error('Given varint doesn\'t fit into 10 bytes');
	    }

	    pbf.realloc(10);

	    writeBigVarintLow(low, high, pbf);
	    writeBigVarintHigh(high, pbf);
	}

	function writeBigVarintLow(low, high, pbf) {
	    pbf.buf[pbf.pos++] = low & 0x7f | 0x80; low >>>= 7;
	    pbf.buf[pbf.pos++] = low & 0x7f | 0x80; low >>>= 7;
	    pbf.buf[pbf.pos++] = low & 0x7f | 0x80; low >>>= 7;
	    pbf.buf[pbf.pos++] = low & 0x7f | 0x80; low >>>= 7;
	    pbf.buf[pbf.pos]   = low & 0x7f;
	}

	function writeBigVarintHigh(high, pbf) {
	    var lsb = (high & 0x07) << 4;

	    pbf.buf[pbf.pos++] |= lsb         | ((high >>>= 3) ? 0x80 : 0); if (!high) return;
	    pbf.buf[pbf.pos++]  = high & 0x7f | ((high >>>= 7) ? 0x80 : 0); if (!high) return;
	    pbf.buf[pbf.pos++]  = high & 0x7f | ((high >>>= 7) ? 0x80 : 0); if (!high) return;
	    pbf.buf[pbf.pos++]  = high & 0x7f | ((high >>>= 7) ? 0x80 : 0); if (!high) return;
	    pbf.buf[pbf.pos++]  = high & 0x7f | ((high >>>= 7) ? 0x80 : 0); if (!high) return;
	    pbf.buf[pbf.pos++]  = high & 0x7f;
	}

	function makeRoomForExtraLength(startPos, len, pbf) {
	    var extraLen =
	        len <= 0x3fff ? 1 :
	        len <= 0x1fffff ? 2 :
	        len <= 0xfffffff ? 3 : Math.floor(Math.log(len) / (Math.LN2 * 7));

	    // if 1 byte isn't enough for encoding message length, shift the data to the right
	    pbf.realloc(extraLen);
	    for (var i = pbf.pos - 1; i >= startPos; i--) pbf.buf[i + extraLen] = pbf.buf[i];
	}

	function writePackedVarint(arr, pbf)   { for (var i = 0; i < arr.length; i++) pbf.writeVarint(arr[i]);   }
	function writePackedSVarint(arr, pbf)  { for (var i = 0; i < arr.length; i++) pbf.writeSVarint(arr[i]);  }
	function writePackedFloat(arr, pbf)    { for (var i = 0; i < arr.length; i++) pbf.writeFloat(arr[i]);    }
	function writePackedDouble(arr, pbf)   { for (var i = 0; i < arr.length; i++) pbf.writeDouble(arr[i]);   }
	function writePackedBoolean(arr, pbf)  { for (var i = 0; i < arr.length; i++) pbf.writeBoolean(arr[i]);  }
	function writePackedFixed32(arr, pbf)  { for (var i = 0; i < arr.length; i++) pbf.writeFixed32(arr[i]);  }
	function writePackedSFixed32(arr, pbf) { for (var i = 0; i < arr.length; i++) pbf.writeSFixed32(arr[i]); }
	function writePackedFixed64(arr, pbf)  { for (var i = 0; i < arr.length; i++) pbf.writeFixed64(arr[i]);  }
	function writePackedSFixed64(arr, pbf) { for (var i = 0; i < arr.length; i++) pbf.writeSFixed64(arr[i]); }

	// Buffer code below from https://github.com/feross/buffer, MIT-licensed

	function readUInt32(buf, pos) {
	    return ((buf[pos]) |
	        (buf[pos + 1] << 8) |
	        (buf[pos + 2] << 16)) +
	        (buf[pos + 3] * 0x1000000);
	}

	function writeInt32(buf, val, pos) {
	    buf[pos] = val;
	    buf[pos + 1] = (val >>> 8);
	    buf[pos + 2] = (val >>> 16);
	    buf[pos + 3] = (val >>> 24);
	}

	function readInt32(buf, pos) {
	    return ((buf[pos]) |
	        (buf[pos + 1] << 8) |
	        (buf[pos + 2] << 16)) +
	        (buf[pos + 3] << 24);
	}

	function readUtf8(buf, pos, end) {
	    var str = '';
	    var i = pos;

	    while (i < end) {
	        var b0 = buf[i];
	        var c = null; // codepoint
	        var bytesPerSequence =
	            b0 > 0xEF ? 4 :
	            b0 > 0xDF ? 3 :
	            b0 > 0xBF ? 2 : 1;

	        if (i + bytesPerSequence > end) break;

	        var b1, b2, b3;

	        if (bytesPerSequence === 1) {
	            if (b0 < 0x80) {
	                c = b0;
	            }
	        } else if (bytesPerSequence === 2) {
	            b1 = buf[i + 1];
	            if ((b1 & 0xC0) === 0x80) {
	                c = (b0 & 0x1F) << 0x6 | (b1 & 0x3F);
	                if (c <= 0x7F) {
	                    c = null;
	                }
	            }
	        } else if (bytesPerSequence === 3) {
	            b1 = buf[i + 1];
	            b2 = buf[i + 2];
	            if ((b1 & 0xC0) === 0x80 && (b2 & 0xC0) === 0x80) {
	                c = (b0 & 0xF) << 0xC | (b1 & 0x3F) << 0x6 | (b2 & 0x3F);
	                if (c <= 0x7FF || (c >= 0xD800 && c <= 0xDFFF)) {
	                    c = null;
	                }
	            }
	        } else if (bytesPerSequence === 4) {
	            b1 = buf[i + 1];
	            b2 = buf[i + 2];
	            b3 = buf[i + 3];
	            if ((b1 & 0xC0) === 0x80 && (b2 & 0xC0) === 0x80 && (b3 & 0xC0) === 0x80) {
	                c = (b0 & 0xF) << 0x12 | (b1 & 0x3F) << 0xC | (b2 & 0x3F) << 0x6 | (b3 & 0x3F);
	                if (c <= 0xFFFF || c >= 0x110000) {
	                    c = null;
	                }
	            }
	        }

	        if (c === null) {
	            c = 0xFFFD;
	            bytesPerSequence = 1;

	        } else if (c > 0xFFFF) {
	            c -= 0x10000;
	            str += String.fromCharCode(c >>> 10 & 0x3FF | 0xD800);
	            c = 0xDC00 | c & 0x3FF;
	        }

	        str += String.fromCharCode(c);
	        i += bytesPerSequence;
	    }

	    return str;
	}

	function readUtf8TextDecoder(buf, pos, end) {
	    return utf8TextDecoder.decode(buf.subarray(pos, end));
	}

	function writeUtf8(buf, str, pos) {
	    for (var i = 0, c, lead; i < str.length; i++) {
	        c = str.charCodeAt(i); // code point

	        if (c > 0xD7FF && c < 0xE000) {
	            if (lead) {
	                if (c < 0xDC00) {
	                    buf[pos++] = 0xEF;
	                    buf[pos++] = 0xBF;
	                    buf[pos++] = 0xBD;
	                    lead = c;
	                    continue;
	                } else {
	                    c = lead - 0xD800 << 10 | c - 0xDC00 | 0x10000;
	                    lead = null;
	                }
	            } else {
	                if (c > 0xDBFF || (i + 1 === str.length)) {
	                    buf[pos++] = 0xEF;
	                    buf[pos++] = 0xBF;
	                    buf[pos++] = 0xBD;
	                } else {
	                    lead = c;
	                }
	                continue;
	            }
	        } else if (lead) {
	            buf[pos++] = 0xEF;
	            buf[pos++] = 0xBF;
	            buf[pos++] = 0xBD;
	            lead = null;
	        }

	        if (c < 0x80) {
	            buf[pos++] = c;
	        } else {
	            if (c < 0x800) {
	                buf[pos++] = c >> 0x6 | 0xC0;
	            } else {
	                if (c < 0x10000) {
	                    buf[pos++] = c >> 0xC | 0xE0;
	                } else {
	                    buf[pos++] = c >> 0x12 | 0xF0;
	                    buf[pos++] = c >> 0xC & 0x3F | 0x80;
	                }
	                buf[pos++] = c >> 0x6 & 0x3F | 0x80;
	            }
	            buf[pos++] = c & 0x3F | 0x80;
	        }
	    }
	    return pos;
	}

	var Protobuf = /*@__PURE__*/getDefaultExportFromCjs$1(pbf);

	const border$1 = 3;
	function readFontstacks(tag, glyphs, pbf) {
	    if (tag === 1) {
	        pbf.readMessage(readFontstack, glyphs);
	    }
	}
	function readFontstack(tag, glyphs, pbf) {
	    if (tag === 3) {
	        const { id, bitmap, width, height, left, top, advance } = pbf.readMessage(readGlyph, {});
	        glyphs.push({
	            id,
	            bitmap: new AlphaImage({
	                width: width + 2 * border$1,
	                height: height + 2 * border$1
	            }, bitmap),
	            metrics: { width, height, left, top, advance }
	        });
	    }
	}
	function readGlyph(tag, glyph, pbf) {
	    if (tag === 1)
	        glyph.id = pbf.readVarint();
	    else if (tag === 2)
	        glyph.bitmap = pbf.readBytes();
	    else if (tag === 3)
	        glyph.width = pbf.readVarint();
	    else if (tag === 4)
	        glyph.height = pbf.readVarint();
	    else if (tag === 5)
	        glyph.left = pbf.readSVarint();
	    else if (tag === 6)
	        glyph.top = pbf.readSVarint();
	    else if (tag === 7)
	        glyph.advance = pbf.readVarint();
	}
	function parseGlyphPbf(data) {
	    return new Protobuf(data).readFields(readFontstacks, []);
	}
	const GLYPH_PBF_BORDER = border$1;

	var ContentAspectRatioMatchingMode;
	(function (ContentAspectRatioMatchingMode) {
	    ContentAspectRatioMatchingMode["none"] = "none";
	    ContentAspectRatioMatchingMode["height"] = "height";
	    ContentAspectRatioMatchingMode["width"] = "width";
	})(ContentAspectRatioMatchingMode || (ContentAspectRatioMatchingMode = {}));
	function renderStyleImage(image) {
	    const { userImage } = image;
	    if (userImage && userImage.render) {
	        const updated = userImage.render();
	        if (updated) {
	            image.data.replace(new Uint8Array(userImage.data.buffer));
	            return true;
	        }
	    }
	    return false;
	}

	function potpack(boxes) {

	    // calculate total box area and maximum box width
	    let area = 0;
	    let maxWidth = 0;

	    for (const box of boxes) {
	        area += box.w * box.h;
	        maxWidth = Math.max(maxWidth, box.w);
	    }

	    // sort the boxes for insertion by height, descending
	    boxes.sort((a, b) => b.h - a.h);

	    // aim for a squarish resulting container,
	    // slightly adjusted for sub-100% space utilization
	    const startWidth = Math.max(Math.ceil(Math.sqrt(area / 0.95)), maxWidth);

	    // start with a single empty space, unbounded at the bottom
	    const spaces = [{x: 0, y: 0, w: startWidth, h: Infinity}];

	    let width = 0;
	    let height = 0;

	    for (const box of boxes) {
	        // look through spaces backwards so that we check smaller spaces first
	        for (let i = spaces.length - 1; i >= 0; i--) {
	            const space = spaces[i];

	            // look for empty spaces that can accommodate the current box
	            if (box.w > space.w || box.h > space.h) continue;

	            // found the space; add the box to its top-left corner
	            // |-------|-------|
	            // |  box  |       |
	            // |_______|       |
	            // |         space |
	            // |_______________|
	            box.x = space.x;
	            box.y = space.y;

	            height = Math.max(height, box.y + box.h);
	            width = Math.max(width, box.x + box.w);

	            if (box.w === space.w && box.h === space.h) {
	                // space matches the box exactly; remove it
	                const last = spaces.pop();
	                if (i < spaces.length) spaces[i] = last;

	            } else if (box.h === space.h) {
	                // space matches the box height; update it accordingly
	                // |-------|---------------|
	                // |  box  | updated space |
	                // |_______|_______________|
	                space.x += box.w;
	                space.w -= box.w;

	            } else if (box.w === space.w) {
	                // space matches the box width; update it accordingly
	                // |---------------|
	                // |      box      |
	                // |_______________|
	                // | updated space |
	                // |_______________|
	                space.y += box.h;
	                space.h -= box.h;

	            } else {
	                // otherwise the box splits the space into two spaces
	                // |-------|-----------|
	                // |  box  | new space |
	                // |_______|___________|
	                // | updated space     |
	                // |___________________|
	                spaces.push({
	                    x: space.x + box.w,
	                    y: space.y,
	                    w: space.w - box.w,
	                    h: box.h
	                });
	                space.y += box.h;
	                space.h -= box.h;
	            }
	            break;
	        }
	    }

	    return {
	        w: width, // container width
	        h: height, // container height
	        fill: (area / (width * height)) || 0 // space utilization
	    };
	}

	/* eslint-disable key-spacing */
	const IMAGE_PADDING = 1;
	class ImagePosition {
	    constructor(paddedRect, { pixelRatio, version, stretchX, stretchY, content, contentMatch }) {
	        this.paddedRect = paddedRect;
	        this.pixelRatio = pixelRatio;
	        this.stretchX = stretchX;
	        this.stretchY = stretchY;
	        this.content = content;
	        this.version = version;
	        this.contentMatch = contentMatch;
	    }
	    get tl() {
	        return [
	            this.paddedRect.x + IMAGE_PADDING,
	            this.paddedRect.y + IMAGE_PADDING
	        ];
	    }
	    get br() {
	        return [
	            this.paddedRect.x + this.paddedRect.w - IMAGE_PADDING,
	            this.paddedRect.y + this.paddedRect.h - IMAGE_PADDING
	        ];
	    }
	    get tlbr() {
	        return this.tl.concat(this.br);
	    }
	    get displaySize() {
	        return [
	            (this.paddedRect.w - IMAGE_PADDING * 2) / this.pixelRatio,
	            (this.paddedRect.h - IMAGE_PADDING * 2) / this.pixelRatio
	        ];
	    }
	}
	/**
	 * A class holding all the images
	 */
	class ImageAtlas {
	    constructor(icons, patterns) {
	        const iconPositions = {}, patternPositions = {};
	        this.haveRenderCallbacks = [];
	        const bins = [];
	        this.addImages(icons, iconPositions, bins);
	        this.addImages(patterns, patternPositions, bins);
	        const { w, h } = potpack(bins);
	        const image = new RGBAImage({ width: w || 1, height: h || 1 });
	        for (const id in icons) {
	            const src = icons[id];
	            const bin = iconPositions[id].paddedRect;
	            RGBAImage.copy(src.data, image, { x: 0, y: 0 }, { x: bin.x + IMAGE_PADDING, y: bin.y + IMAGE_PADDING }, src.data);
	        }
	        for (const id in patterns) {
	            const src = patterns[id];
	            const bin = patternPositions[id].paddedRect;
	            const x = bin.x + IMAGE_PADDING, y = bin.y + IMAGE_PADDING, w = src.data.width, h = src.data.height;
	            RGBAImage.copy(src.data, image, { x: 0, y: 0 }, { x, y }, src.data);
	            // Add 1 pixel wrapped padding on each side of the image.
	            RGBAImage.copy(src.data, image, { x: 0, y: h - 1 }, { x, y: y - 1 }, { width: w, height: 1 }); // T
	            RGBAImage.copy(src.data, image, { x: 0, y: 0 }, { x, y: y + h }, { width: w, height: 1 }); // B
	            RGBAImage.copy(src.data, image, { x: w - 1, y: 0 }, { x: x - 1, y }, { width: 1, height: h }); // L
	            RGBAImage.copy(src.data, image, { x: 0, y: 0 }, { x: x + w, y }, { width: 1, height: h }); // R
	        }
	        this.image = image;
	        this.iconPositions = iconPositions;
	        this.patternPositions = patternPositions;
	    }
	    addImages(images, positions, bins) {
	        for (const id in images) {
	            const src = images[id];
	            const bin = {
	                x: 0,
	                y: 0,
	                w: src.data.width + 2 * IMAGE_PADDING,
	                h: src.data.height + 2 * IMAGE_PADDING,
	            };
	            bins.push(bin);
	            positions[id] = new ImagePosition(bin, src);
	            if (src.hasRenderCallback) {
	                this.haveRenderCallbacks.push(id);
	            }
	        }
	    }
	    patchUpdatedImages(imageManager, texture) {
	        imageManager.dispatchRenderCallbacks(this.haveRenderCallbacks);
	        for (const name in imageManager.updatedImages) {
	            this.patchUpdatedImage(this.iconPositions[name], imageManager.getImage(name), texture);
	            this.patchUpdatedImage(this.patternPositions[name], imageManager.getImage(name), texture);
	        }
	    }
	    patchUpdatedImage(position, image, texture) {
	        if (!position || !image)
	            return;
	        if (position.version === image.version)
	            return;
	        position.version = image.version;
	        const [x, y] = position.tl;
	        texture.update(image.data, undefined, { x, y });
	    }
	}
	register('ImagePosition', ImagePosition);
	register('ImageAtlas', ImageAtlas);

	exports.WritingMode = void 0;
	(function (WritingMode) {
	    WritingMode[WritingMode["none"] = 0] = "none";
	    WritingMode[WritingMode["horizontal"] = 1] = "horizontal";
	    WritingMode[WritingMode["vertical"] = 2] = "vertical";
	    WritingMode[WritingMode["horizontalOnly"] = 3] = "horizontalOnly";
	})(exports.WritingMode || (exports.WritingMode = {}));
	const SHAPING_DEFAULT_OFFSET = -17;
	function isEmpty(positionedLines) {
	    for (const line of positionedLines) {
	        if (line.positionedGlyphs.length !== 0) {
	            return false;
	        }
	    }
	    return true;
	}
	// Max number of images in label is 6401 U+E000–U+F8FF that covers
	// Basic Multilingual Plane Unicode Private Use Area (PUA).
	const PUAbegin = 0xE000;
	const PUAend = 0xF8FF;
	class SectionOptions {
	    constructor() {
	        this.scale = 1.0;
	        this.fontStack = '';
	        this.imageName = null;
	    }
	    static forText(scale, fontStack) {
	        const textOptions = new SectionOptions();
	        textOptions.scale = scale || 1;
	        textOptions.fontStack = fontStack;
	        return textOptions;
	    }
	    static forImage(imageName) {
	        const imageOptions = new SectionOptions();
	        imageOptions.imageName = imageName;
	        return imageOptions;
	    }
	}
	class TaggedString {
	    constructor() {
	        this.text = '';
	        this.sectionIndex = [];
	        this.sections = [];
	        this.imageSectionID = null;
	    }
	    static fromFeature(text, defaultFontStack) {
	        const result = new TaggedString();
	        for (let i = 0; i < text.sections.length; i++) {
	            const section = text.sections[i];
	            if (!section.image) {
	                result.addTextSection(section, defaultFontStack);
	            }
	            else {
	                result.addImageSection(section);
	            }
	        }
	        return result;
	    }
	    length() {
	        return this.text.length;
	    }
	    getSection(index) {
	        return this.sections[this.sectionIndex[index]];
	    }
	    getSectionIndex(index) {
	        return this.sectionIndex[index];
	    }
	    getCharCode(index) {
	        return this.text.charCodeAt(index);
	    }
	    verticalizePunctuation() {
	        this.text = verticalizePunctuation(this.text);
	    }
	    trim() {
	        let beginningWhitespace = 0;
	        for (let i = 0; i < this.text.length && whitespace[this.text.charCodeAt(i)]; i++) {
	            beginningWhitespace++;
	        }
	        let trailingWhitespace = this.text.length;
	        for (let i = this.text.length - 1; i >= 0 && i >= beginningWhitespace && whitespace[this.text.charCodeAt(i)]; i--) {
	            trailingWhitespace--;
	        }
	        this.text = this.text.substring(beginningWhitespace, trailingWhitespace);
	        this.sectionIndex = this.sectionIndex.slice(beginningWhitespace, trailingWhitespace);
	    }
	    substring(start, end) {
	        const substring = new TaggedString();
	        substring.text = this.text.substring(start, end);
	        substring.sectionIndex = this.sectionIndex.slice(start, end);
	        substring.sections = this.sections;
	        return substring;
	    }
	    toString() {
	        return this.text;
	    }
	    getMaxScale() {
	        return this.sectionIndex.reduce((max, index) => Math.max(max, this.sections[index].scale), 0);
	    }
	    addTextSection(section, defaultFontStack) {
	        this.text += section.text;
	        this.sections.push(SectionOptions.forText(section.scale, section.fontStack || defaultFontStack));
	        const index = this.sections.length - 1;
	        for (let i = 0; i < section.text.length; ++i) {
	            this.sectionIndex.push(index);
	        }
	    }
	    addImageSection(section) {
	        const imageName = section.image ? section.image.name : '';
	        if (imageName.length === 0) {
	            warnOnce('Can\'t add FormattedSection with an empty image.');
	            return;
	        }
	        const nextImageSectionCharCode = this.getNextImageSectionCharCode();
	        if (!nextImageSectionCharCode) {
	            warnOnce(`Reached maximum number of images ${PUAend - PUAbegin + 2}`);
	            return;
	        }
	        this.text += String.fromCharCode(nextImageSectionCharCode);
	        this.sections.push(SectionOptions.forImage(imageName));
	        this.sectionIndex.push(this.sections.length - 1);
	    }
	    getNextImageSectionCharCode() {
	        if (!this.imageSectionID) {
	            this.imageSectionID = PUAbegin;
	            return this.imageSectionID;
	        }
	        if (this.imageSectionID >= PUAend)
	            return null;
	        return ++this.imageSectionID;
	    }
	}
	function breakLines(input, lineBreakPoints) {
	    const lines = [];
	    const text = input.text;
	    let start = 0;
	    for (const lineBreak of lineBreakPoints) {
	        lines.push(input.substring(start, lineBreak));
	        start = lineBreak;
	    }
	    if (start < text.length) {
	        lines.push(input.substring(start, text.length));
	    }
	    return lines;
	}
	function shapeText(text, glyphMap, glyphPositions, imagePositions, defaultFontStack, maxWidth, lineHeight, textAnchor, textJustify, spacing, translate, writingMode, allowVerticalPlacement, symbolPlacement, layoutTextSize, layoutTextSizeThisZoom) {
	    const logicalInput = TaggedString.fromFeature(text, defaultFontStack);
	    if (writingMode === exports.WritingMode.vertical) {
	        logicalInput.verticalizePunctuation();
	    }
	    let lines;
	    const { processBidirectionalText, processStyledBidirectionalText } = rtlWorkerPlugin;
	    if (processBidirectionalText && logicalInput.sections.length === 1) {
	        // Bidi doesn't have to be style-aware
	        lines = [];
	        const untaggedLines = processBidirectionalText(logicalInput.toString(), determineLineBreaks(logicalInput, spacing, maxWidth, glyphMap, imagePositions, symbolPlacement, layoutTextSize));
	        for (const line of untaggedLines) {
	            const taggedLine = new TaggedString();
	            taggedLine.text = line;
	            taggedLine.sections = logicalInput.sections;
	            for (let i = 0; i < line.length; i++) {
	                taggedLine.sectionIndex.push(0);
	            }
	            lines.push(taggedLine);
	        }
	    }
	    else if (processStyledBidirectionalText) {
	        // Need version of mapbox-gl-rtl-text with style support for combining RTL text
	        // with formatting
	        lines = [];
	        const processedLines = processStyledBidirectionalText(logicalInput.text, logicalInput.sectionIndex, determineLineBreaks(logicalInput, spacing, maxWidth, glyphMap, imagePositions, symbolPlacement, layoutTextSize));
	        for (const line of processedLines) {
	            const taggedLine = new TaggedString();
	            taggedLine.text = line[0];
	            taggedLine.sectionIndex = line[1];
	            taggedLine.sections = logicalInput.sections;
	            lines.push(taggedLine);
	        }
	    }
	    else {
	        lines = breakLines(logicalInput, determineLineBreaks(logicalInput, spacing, maxWidth, glyphMap, imagePositions, symbolPlacement, layoutTextSize));
	    }
	    const positionedLines = [];
	    const shaping = {
	        positionedLines,
	        text: logicalInput.toString(),
	        top: translate[1],
	        bottom: translate[1],
	        left: translate[0],
	        right: translate[0],
	        writingMode,
	        iconsInText: false,
	        verticalizable: false
	    };
	    shapeLines(shaping, glyphMap, glyphPositions, imagePositions, lines, lineHeight, textAnchor, textJustify, writingMode, spacing, allowVerticalPlacement, layoutTextSizeThisZoom);
	    if (isEmpty(positionedLines))
	        return false;
	    return shaping;
	}
	// using computed properties due to https://github.com/facebook/flow/issues/380
	/* eslint no-useless-computed-key: 0 */
	const whitespace = {
	    [0x09]: true, // tab
	    [0x0a]: true, // newline
	    [0x0b]: true, // vertical tab
	    [0x0c]: true, // form feed
	    [0x0d]: true, // carriage return
	    [0x20]: true, // space
	};
	const breakable = {
	    [0x0a]: true, // newline
	    [0x20]: true, // space
	    [0x26]: true, // ampersand
	    [0x28]: true, // left parenthesis
	    [0x29]: true, // right parenthesis
	    [0x2b]: true, // plus sign
	    [0x2d]: true, // hyphen-minus
	    [0x2f]: true, // solidus
	    [0xad]: true, // soft hyphen
	    [0xb7]: true, // middle dot
	    [0x200b]: true, // zero-width space
	    [0x2010]: true, // hyphen
	    [0x2013]: true, // en dash
	    [0x2027]: true // interpunct
	    // Many other characters may be reasonable breakpoints
	    // Consider "neutral orientation" characters at scriptDetection.charHasNeutralVerticalOrientation
	    // See https://github.com/mapbox/mapbox-gl-js/issues/3658
	};
	function getGlyphAdvance(codePoint, section, glyphMap, imagePositions, spacing, layoutTextSize) {
	    if (!section.imageName) {
	        const positions = glyphMap[section.fontStack];
	        const glyph = positions && positions[codePoint];
	        if (!glyph)
	            return 0;
	        return glyph.metrics.advance * section.scale + spacing;
	    }
	    else {
	        const imagePosition = imagePositions[section.imageName];
	        if (!imagePosition)
	            return 0;
	        return imagePosition.displaySize[0] * section.scale * ONE_EM / layoutTextSize + spacing;
	    }
	}
	function determineAverageLineWidth(logicalInput, spacing, maxWidth, glyphMap, imagePositions, layoutTextSize) {
	    let totalWidth = 0;
	    for (let index = 0; index < logicalInput.length(); index++) {
	        const section = logicalInput.getSection(index);
	        totalWidth += getGlyphAdvance(logicalInput.getCharCode(index), section, glyphMap, imagePositions, spacing, layoutTextSize);
	    }
	    const lineCount = Math.max(1, Math.ceil(totalWidth / maxWidth));
	    return totalWidth / lineCount;
	}
	function calculateBadness(lineWidth, targetWidth, penalty, isLastBreak) {
	    const raggedness = Math.pow(lineWidth - targetWidth, 2);
	    if (isLastBreak) {
	        // Favor finals lines shorter than average over longer than average
	        if (lineWidth < targetWidth) {
	            return raggedness / 2;
	        }
	        else {
	            return raggedness * 2;
	        }
	    }
	    return raggedness + Math.abs(penalty) * penalty;
	}
	function calculatePenalty(codePoint, nextCodePoint, penalizableIdeographicBreak) {
	    let penalty = 0;
	    // Force break on newline
	    if (codePoint === 0x0a) {
	        penalty -= 10000;
	    }
	    // Penalize breaks between characters that allow ideographic breaking because
	    // they are less preferable than breaks at spaces (or zero width spaces).
	    if (penalizableIdeographicBreak) {
	        penalty += 150;
	    }
	    // Penalize open parenthesis at end of line
	    if (codePoint === 0x28 || codePoint === 0xff08) {
	        penalty += 50;
	    }
	    // Penalize close parenthesis at beginning of line
	    if (nextCodePoint === 0x29 || nextCodePoint === 0xff09) {
	        penalty += 50;
	    }
	    return penalty;
	}
	function evaluateBreak(breakIndex, breakX, targetWidth, potentialBreaks, penalty, isLastBreak) {
	    // We could skip evaluating breaks where the line length (breakX - priorBreak.x) > maxWidth
	    //  ...but in fact we allow lines longer than maxWidth (if there's no break points)
	    //  ...and when targetWidth and maxWidth are close, strictly enforcing maxWidth can give
	    //     more lopsided results.
	    let bestPriorBreak = null;
	    let bestBreakBadness = calculateBadness(breakX, targetWidth, penalty, isLastBreak);
	    for (const potentialBreak of potentialBreaks) {
	        const lineWidth = breakX - potentialBreak.x;
	        const breakBadness = calculateBadness(lineWidth, targetWidth, penalty, isLastBreak) + potentialBreak.badness;
	        if (breakBadness <= bestBreakBadness) {
	            bestPriorBreak = potentialBreak;
	            bestBreakBadness = breakBadness;
	        }
	    }
	    return {
	        index: breakIndex,
	        x: breakX,
	        priorBreak: bestPriorBreak,
	        badness: bestBreakBadness
	    };
	}
	function leastBadBreaks(lastLineBreak) {
	    if (!lastLineBreak) {
	        return [];
	    }
	    return leastBadBreaks(lastLineBreak.priorBreak).concat(lastLineBreak.index);
	}
	function determineLineBreaks(logicalInput, spacing, maxWidth, glyphMap, imagePositions, symbolPlacement, layoutTextSize) {
	    if (symbolPlacement !== 'point')
	        return [];
	    if (!logicalInput)
	        return [];
	    const potentialLineBreaks = [];
	    const targetWidth = determineAverageLineWidth(logicalInput, spacing, maxWidth, glyphMap, imagePositions, layoutTextSize);
	    const hasServerSuggestedBreakpoints = logicalInput.text.indexOf('\u200b') >= 0;
	    let currentX = 0;
	    for (let i = 0; i < logicalInput.length(); i++) {
	        const section = logicalInput.getSection(i);
	        const codePoint = logicalInput.getCharCode(i);
	        if (!whitespace[codePoint])
	            currentX += getGlyphAdvance(codePoint, section, glyphMap, imagePositions, spacing, layoutTextSize);
	        // Ideographic characters, spaces, and word-breaking punctuation that often appear without
	        // surrounding spaces.
	        if ((i < logicalInput.length() - 1)) {
	            const ideographicBreak = charAllowsIdeographicBreaking(codePoint);
	            if (breakable[codePoint] || ideographicBreak || section.imageName) {
	                potentialLineBreaks.push(evaluateBreak(i + 1, currentX, targetWidth, potentialLineBreaks, calculatePenalty(codePoint, logicalInput.getCharCode(i + 1), ideographicBreak && hasServerSuggestedBreakpoints), false));
	            }
	        }
	    }
	    return leastBadBreaks(evaluateBreak(logicalInput.length(), currentX, targetWidth, potentialLineBreaks, 0, true));
	}
	function getAnchorAlignment(anchor) {
	    let horizontalAlign = 0.5, verticalAlign = 0.5;
	    switch (anchor) {
	        case 'right':
	        case 'top-right':
	        case 'bottom-right':
	            horizontalAlign = 1;
	            break;
	        case 'left':
	        case 'top-left':
	        case 'bottom-left':
	            horizontalAlign = 0;
	            break;
	    }
	    switch (anchor) {
	        case 'bottom':
	        case 'bottom-right':
	        case 'bottom-left':
	            verticalAlign = 1;
	            break;
	        case 'top':
	        case 'top-right':
	        case 'top-left':
	            verticalAlign = 0;
	            break;
	    }
	    return { horizontalAlign, verticalAlign };
	}
	function shapeLines(shaping, glyphMap, glyphPositions, imagePositions, lines, lineHeight, textAnchor, textJustify, writingMode, spacing, allowVerticalPlacement, layoutTextSizeThisZoom) {
	    let x = 0;
	    let y = SHAPING_DEFAULT_OFFSET;
	    let maxLineLength = 0;
	    let maxLineHeight = 0;
	    const justify = textJustify === 'right' ? 1 :
	        textJustify === 'left' ? 0 : 0.5;
	    let lineIndex = 0;
	    for (const line of lines) {
	        line.trim();
	        const lineMaxScale = line.getMaxScale();
	        const maxLineOffset = (lineMaxScale - 1) * ONE_EM;
	        const positionedLine = { positionedGlyphs: [], lineOffset: 0 };
	        shaping.positionedLines[lineIndex] = positionedLine;
	        const positionedGlyphs = positionedLine.positionedGlyphs;
	        let lineOffset = 0.0;
	        if (!line.length()) {
	            y += lineHeight; // Still need a line feed after empty line
	            ++lineIndex;
	            continue;
	        }
	        for (let i = 0; i < line.length(); i++) {
	            const section = line.getSection(i);
	            const sectionIndex = line.getSectionIndex(i);
	            const codePoint = line.getCharCode(i);
	            let baselineOffset = 0.0;
	            let metrics = null;
	            let rect = null;
	            let imageName = null;
	            let verticalAdvance = ONE_EM;
	            const vertical = !(writingMode === exports.WritingMode.horizontal ||
	                // Don't verticalize glyphs that have no upright orientation if vertical placement is disabled.
	                (!allowVerticalPlacement && !charHasUprightVerticalOrientation(codePoint)) ||
	                // If vertical placement is enabled, don't verticalize glyphs that
	                // are from complex text layout script, or whitespaces.
	                (allowVerticalPlacement && (whitespace[codePoint] || charInComplexShapingScript(codePoint))));
	            if (!section.imageName) {
	                const positions = glyphPositions[section.fontStack];
	                const glyphPosition = positions && positions[codePoint];
	                if (glyphPosition && glyphPosition.rect) {
	                    rect = glyphPosition.rect;
	                    metrics = glyphPosition.metrics;
	                }
	                else {
	                    const glyphs = glyphMap[section.fontStack];
	                    const glyph = glyphs && glyphs[codePoint];
	                    if (!glyph)
	                        continue;
	                    metrics = glyph.metrics;
	                }
	                // We don't know the baseline, but since we're laying out
	                // at 24 points, we can calculate how much it will move when
	                // we scale up or down.
	                baselineOffset = (lineMaxScale - section.scale) * ONE_EM;
	            }
	            else {
	                const imagePosition = imagePositions[section.imageName];
	                if (!imagePosition)
	                    continue;
	                imageName = section.imageName;
	                shaping.iconsInText = shaping.iconsInText || true;
	                rect = imagePosition.paddedRect;
	                const size = imagePosition.displaySize;
	                // If needed, allow to set scale factor for an image using
	                // alias "image-scale" that could be alias for "font-scale"
	                // when FormattedSection is an image section.
	                section.scale = section.scale * ONE_EM / layoutTextSizeThisZoom;
	                metrics = { width: size[0],
	                    height: size[1],
	                    left: IMAGE_PADDING,
	                    top: -GLYPH_PBF_BORDER,
	                    advance: vertical ? size[1] : size[0] };
	                // Difference between one EM and an image size.
	                // Aligns bottom of an image to a baseline level.
	                const imageOffset = ONE_EM - size[1] * section.scale;
	                baselineOffset = maxLineOffset + imageOffset;
	                verticalAdvance = metrics.advance;
	                // Difference between height of an image and one EM at max line scale.
	                // Pushes current line down if an image size is over 1 EM at max line scale.
	                const offset = vertical ? size[0] * section.scale - ONE_EM * lineMaxScale :
	                    size[1] * section.scale - ONE_EM * lineMaxScale;
	                if (offset > 0 && offset > lineOffset) {
	                    lineOffset = offset;
	                }
	            }
	            if (!vertical) {
	                positionedGlyphs.push({ glyph: codePoint, imageName, x, y: y + baselineOffset, vertical, scale: section.scale, fontStack: section.fontStack, sectionIndex, metrics, rect });
	                x += metrics.advance * section.scale + spacing;
	            }
	            else {
	                shaping.verticalizable = true;
	                positionedGlyphs.push({ glyph: codePoint, imageName, x, y: y + baselineOffset, vertical, scale: section.scale, fontStack: section.fontStack, sectionIndex, metrics, rect });
	                x += verticalAdvance * section.scale + spacing;
	            }
	        }
	        // Only justify if we placed at least one glyph
	        if (positionedGlyphs.length !== 0) {
	            const lineLength = x - spacing;
	            maxLineLength = Math.max(lineLength, maxLineLength);
	            justifyLine(positionedGlyphs, 0, positionedGlyphs.length - 1, justify, lineOffset);
	        }
	        x = 0;
	        const currentLineHeight = lineHeight * lineMaxScale + lineOffset;
	        positionedLine.lineOffset = Math.max(lineOffset, maxLineOffset);
	        y += currentLineHeight;
	        maxLineHeight = Math.max(currentLineHeight, maxLineHeight);
	        ++lineIndex;
	    }
	    // Calculate the bounding box and justify / align text block.
	    const height = y - SHAPING_DEFAULT_OFFSET;
	    const { horizontalAlign, verticalAlign } = getAnchorAlignment(textAnchor);
	    align(shaping.positionedLines, justify, horizontalAlign, verticalAlign, maxLineLength, maxLineHeight, lineHeight, height, lines.length);
	    shaping.top += -verticalAlign * height;
	    shaping.bottom = shaping.top + height;
	    shaping.left += -horizontalAlign * maxLineLength;
	    shaping.right = shaping.left + maxLineLength;
	}
	// justify right = 1, left = 0, center = 0.5
	function justifyLine(positionedGlyphs, start, end, justify, lineOffset) {
	    if (!justify && !lineOffset)
	        return;
	    const lastPositionedGlyph = positionedGlyphs[end];
	    const lastAdvance = lastPositionedGlyph.metrics.advance * lastPositionedGlyph.scale;
	    const lineIndent = (positionedGlyphs[end].x + lastAdvance) * justify;
	    for (let j = start; j <= end; j++) {
	        positionedGlyphs[j].x -= lineIndent;
	        positionedGlyphs[j].y += lineOffset;
	    }
	}
	function align(positionedLines, justify, horizontalAlign, verticalAlign, maxLineLength, maxLineHeight, lineHeight, blockHeight, lineCount) {
	    const shiftX = (justify - horizontalAlign) * maxLineLength;
	    let shiftY = 0;
	    if (maxLineHeight !== lineHeight) {
	        shiftY = -blockHeight * verticalAlign - SHAPING_DEFAULT_OFFSET;
	    }
	    else {
	        shiftY = (-verticalAlign * lineCount + 0.5) * lineHeight;
	    }
	    for (const line of positionedLines) {
	        for (const positionedGlyph of line.positionedGlyphs) {
	            positionedGlyph.x += shiftX;
	            positionedGlyph.y += shiftY;
	        }
	    }
	}
	function shapeIcon(image, iconOffset, iconAnchor) {
	    const { horizontalAlign, verticalAlign } = getAnchorAlignment(iconAnchor);
	    const dx = iconOffset[0];
	    const dy = iconOffset[1];
	    const x1 = dx - image.displaySize[0] * horizontalAlign;
	    const x2 = x1 + image.displaySize[0];
	    const y1 = dy - image.displaySize[1] * verticalAlign;
	    const y2 = y1 + image.displaySize[1];
	    return { image, top: y1, bottom: y2, left: x1, right: x2 };
	}
	/**
	 * Called when shapedIcon.image.contentMatch is set.
	 * Determines the dimensions of a content rectangle using the value in contentMatch.
	 *
	 * @param shapedIcon - The icon that will be resized.
	 * @returns Extents of the shapedIcon with contentMatch adjustments if necessary.
	 */
	function applyContentMatch(shapedIcon) {
	    // Assume shapedIcon.image.contentMatch is true or this wouldn't be called.
	    let iconLeft = shapedIcon.left;
	    let iconTop = shapedIcon.top;
	    let iconWidth = shapedIcon.right - iconLeft;
	    let iconHeight = shapedIcon.bottom - iconTop;
	    const contentWidth = shapedIcon.image.content[2] - shapedIcon.image.content[0];
	    const contentHeight = shapedIcon.image.content[3] - shapedIcon.image.content[1];
	    // Constrict content area to fit target aspect ratio
	    if (contentHeight !== 0 && iconWidth !== 0 && iconHeight !== 0) {
	        // Reverse calculate the content aspect ratio.
	        const contentAspectRatio = contentWidth / contentHeight;
	        if (shapedIcon.image.contentMatch === ContentAspectRatioMatchingMode.height) {
	            if (iconWidth / iconHeight < contentAspectRatio) {
	                // Target aspect ratio is height matched, adjust width
	                const newIconWidth = iconHeight * contentAspectRatio;
	                iconLeft *= newIconWidth / iconWidth;
	                iconWidth = newIconWidth;
	            }
	        }
	        else if (shapedIcon.image.contentMatch === ContentAspectRatioMatchingMode.width) {
	            if (contentAspectRatio !== 0 && iconWidth / iconHeight > contentAspectRatio) {
	                // Target aspect ratio is width matched, adjust height
	                const newIconHeight = iconWidth / contentAspectRatio;
	                iconTop *= newIconHeight / newIconHeight;
	                iconHeight = newIconHeight;
	            }
	        }
	    }
	    return { x1: iconLeft, y1: iconTop, x2: iconLeft + iconWidth, y2: iconTop + iconHeight };
	}
	function fitIconToText(shapedIcon, shapedText, textFit, padding, iconOffset, fontScale) {
	    const image = shapedIcon.image;
	    let collisionPadding;
	    if (image.content) {
	        const content = image.content;
	        const pixelRatio = image.pixelRatio || 1;
	        collisionPadding = [
	            content[0] / pixelRatio,
	            content[1] / pixelRatio,
	            image.displaySize[0] - content[2] / pixelRatio,
	            image.displaySize[1] - content[3] / pixelRatio
	        ];
	    }
	    // We don't respect the icon-anchor, because icon-text-fit is set. Instead,
	    // the icon will be centered on the text, then stretched in the given
	    // dimensions.
	    const textLeft = shapedText.left * fontScale;
	    const textRight = shapedText.right * fontScale;
	    let top, right, bottom, left;
	    if (textFit === 'width' || textFit === 'both') {
	        // Stretched horizontally to the text width
	        left = iconOffset[0] + textLeft - padding[3];
	        right = iconOffset[0] + textRight + padding[1];
	    }
	    else {
	        // Centered on the text
	        left = iconOffset[0] + (textLeft + textRight - image.displaySize[0]) / 2;
	        right = left + image.displaySize[0];
	    }
	    const textTop = shapedText.top * fontScale;
	    const textBottom = shapedText.bottom * fontScale;
	    if (textFit === 'height' || textFit === 'both') {
	        // Stretched vertically to the text height
	        top = iconOffset[1] + textTop - padding[0];
	        bottom = iconOffset[1] + textBottom + padding[2];
	    }
	    else {
	        // Centered on the text
	        top = iconOffset[1] + (textTop + textBottom - image.displaySize[1]) / 2;
	        bottom = top + image.displaySize[1];
	    }
	    return { image, top, right, bottom, left, collisionPadding };
	}

	const MAX_GLYPH_ICON_SIZE = 255;
	const SIZE_PACK_FACTOR = 128;
	const MAX_PACKED_SIZE = MAX_GLYPH_ICON_SIZE * SIZE_PACK_FACTOR;
	// For {text,icon}-size, get the bucket-level data that will be needed by
	// the painter to set symbol-size-related uniforms
	function getSizeData(tileZoom, value) {
	    const { expression } = value;
	    if (expression.kind === 'constant') {
	        const layoutSize = expression.evaluate(new EvaluationParameters(tileZoom + 1));
	        return { kind: 'constant', layoutSize };
	    }
	    else if (expression.kind === 'source') {
	        return { kind: 'source' };
	    }
	    else {
	        const { zoomStops, interpolationType } = expression;
	        // calculate covering zoom stops for zoom-dependent values
	        let lower = 0;
	        while (lower < zoomStops.length && zoomStops[lower] <= tileZoom)
	            lower++;
	        lower = Math.max(0, lower - 1);
	        let upper = lower;
	        while (upper < zoomStops.length && zoomStops[upper] < tileZoom + 1)
	            upper++;
	        upper = Math.min(zoomStops.length - 1, upper);
	        const minZoom = zoomStops[lower];
	        const maxZoom = zoomStops[upper];
	        // We'd like to be able to use CameraExpression or CompositeExpression in these
	        // return types rather than ExpressionSpecification, but the former are not
	        // transferrable across Web Worker boundaries.
	        if (expression.kind === 'composite') {
	            return { kind: 'composite', minZoom, maxZoom, interpolationType };
	        }
	        // for camera functions, also save off the function values
	        // evaluated at the covering zoom levels
	        const minSize = expression.evaluate(new EvaluationParameters(minZoom));
	        const maxSize = expression.evaluate(new EvaluationParameters(maxZoom));
	        return { kind: 'camera', minZoom, maxZoom, minSize, maxSize, interpolationType };
	    }
	}
	function evaluateSizeForFeature(sizeData, { uSize, uSizeT }, { lowerSize, upperSize }) {
	    if (sizeData.kind === 'source') {
	        return lowerSize / SIZE_PACK_FACTOR;
	    }
	    else if (sizeData.kind === 'composite') {
	        return interpolate.number(lowerSize / SIZE_PACK_FACTOR, upperSize / SIZE_PACK_FACTOR, uSizeT);
	    }
	    return uSize;
	}
	function evaluateSizeForZoom(sizeData, zoom) {
	    let uSizeT = 0;
	    let uSize = 0;
	    if (sizeData.kind === 'constant') {
	        uSize = sizeData.layoutSize;
	    }
	    else if (sizeData.kind !== 'source') {
	        const { interpolationType, minZoom, maxZoom } = sizeData;
	        // Even though we could get the exact value of the camera function
	        // at z = tr.zoom, we intentionally do not: instead, we interpolate
	        // between the camera function values at a pair of zoom stops covering
	        // [tileZoom, tileZoom + 1] in order to be consistent with this
	        // restriction on composite functions
	        const t = !interpolationType ? 0 : clamp$1(Interpolate.interpolationFactor(interpolationType, zoom, minZoom, maxZoom), 0, 1);
	        if (sizeData.kind === 'camera') {
	            uSize = interpolate.number(sizeData.minSize, sizeData.maxSize, t);
	        }
	        else {
	            uSizeT = t;
	        }
	    }
	    return { uSizeT, uSize };
	}

	function getOverlapMode(layout, overlapProp, allowOverlapProp) {
	    let result = 'never';
	    const overlap = layout.get(overlapProp);
	    if (overlap) {
	        // if -overlap is set, use it
	        result = overlap;
	    }
	    else if (layout.get(allowOverlapProp)) {
	        // fall back to -allow-overlap, with false='never', true='always'
	        result = 'always';
	    }
	    return result;
	}

	const vectorTileFeatureTypes = vectorTile.VectorTileFeature.types;
	// Opacity arrays are frequently updated but don't contain a lot of information, so we pack them
	// tight. Each Uint32 is actually four duplicate Uint8s for the four corners of a glyph
	// 7 bits are for the current opacity, and the lowest bit is the target opacity
	// actually defined in symbol_attributes.js
	// const placementOpacityAttributes = [
	//     { name: 'a_fade_opacity', components: 1, type: 'Uint32' }
	// ];
	const shaderOpacityAttributes = [
	    { name: 'a_fade_opacity', components: 1, type: 'Uint8', offset: 0 }
	];
	function addVertex(array, anchorX, anchorY, ox, oy, tx, ty, sizeVertex, isSDF, pixelOffsetX, pixelOffsetY, minFontScaleX, minFontScaleY) {
	    const aSizeX = sizeVertex ? Math.min(MAX_PACKED_SIZE, Math.round(sizeVertex[0])) : 0;
	    const aSizeY = sizeVertex ? Math.min(MAX_PACKED_SIZE, Math.round(sizeVertex[1])) : 0;
	    array.emplaceBack(
	    // a_pos_offset
	    anchorX, anchorY, Math.round(ox * 32), Math.round(oy * 32), 
	    // a_data
	    tx, // x coordinate of symbol on glyph atlas texture
	    ty, // y coordinate of symbol on glyph atlas texture
	    (aSizeX << 1) + (isSDF ? 1 : 0), aSizeY, pixelOffsetX * 16, pixelOffsetY * 16, minFontScaleX * 256, minFontScaleY * 256);
	}
	function addDynamicAttributes(dynamicLayoutVertexArray, p, angle) {
	    dynamicLayoutVertexArray.emplaceBack(p.x, p.y, angle);
	    dynamicLayoutVertexArray.emplaceBack(p.x, p.y, angle);
	    dynamicLayoutVertexArray.emplaceBack(p.x, p.y, angle);
	    dynamicLayoutVertexArray.emplaceBack(p.x, p.y, angle);
	}
	function containsRTLText(formattedText) {
	    for (const section of formattedText.sections) {
	        if (stringContainsRTLText(section.text)) {
	            return true;
	        }
	    }
	    return false;
	}
	class SymbolBuffers {
	    constructor(programConfigurations) {
	        this.layoutVertexArray = new SymbolLayoutArray();
	        this.indexArray = new TriangleIndexArray();
	        this.programConfigurations = programConfigurations;
	        this.segments = new SegmentVector();
	        this.dynamicLayoutVertexArray = new SymbolDynamicLayoutArray();
	        this.opacityVertexArray = new SymbolOpacityArray();
	        this.hasVisibleVertices = false;
	        this.placedSymbolArray = new PlacedSymbolArray();
	    }
	    isEmpty() {
	        return this.layoutVertexArray.length === 0 &&
	            this.indexArray.length === 0 &&
	            this.dynamicLayoutVertexArray.length === 0 &&
	            this.opacityVertexArray.length === 0;
	    }
	    upload(context, dynamicIndexBuffer, upload, update) {
	        if (this.isEmpty()) {
	            return;
	        }
	        if (upload) {
	            this.layoutVertexBuffer = context.createVertexBuffer(this.layoutVertexArray, symbolLayoutAttributes.members);
	            this.indexBuffer = context.createIndexBuffer(this.indexArray, dynamicIndexBuffer);
	            this.dynamicLayoutVertexBuffer = context.createVertexBuffer(this.dynamicLayoutVertexArray, dynamicLayoutAttributes.members, true);
	            this.opacityVertexBuffer = context.createVertexBuffer(this.opacityVertexArray, shaderOpacityAttributes, true);
	            // This is a performance hack so that we can write to opacityVertexArray with uint32s
	            // even though the shaders read uint8s
	            this.opacityVertexBuffer.itemSize = 1;
	        }
	        if (upload || update) {
	            this.programConfigurations.upload(context);
	        }
	    }
	    destroy() {
	        if (!this.layoutVertexBuffer)
	            return;
	        this.layoutVertexBuffer.destroy();
	        this.indexBuffer.destroy();
	        this.programConfigurations.destroy();
	        this.segments.destroy();
	        this.dynamicLayoutVertexBuffer.destroy();
	        this.opacityVertexBuffer.destroy();
	    }
	}
	register('SymbolBuffers', SymbolBuffers);
	class CollisionBuffers {
	    constructor(LayoutArray, layoutAttributes, IndexArray) {
	        this.layoutVertexArray = new LayoutArray();
	        this.layoutAttributes = layoutAttributes;
	        this.indexArray = new IndexArray();
	        this.segments = new SegmentVector();
	        this.collisionVertexArray = new CollisionVertexArray();
	    }
	    upload(context) {
	        this.layoutVertexBuffer = context.createVertexBuffer(this.layoutVertexArray, this.layoutAttributes);
	        this.indexBuffer = context.createIndexBuffer(this.indexArray);
	        this.collisionVertexBuffer = context.createVertexBuffer(this.collisionVertexArray, collisionVertexAttributes.members, true);
	    }
	    destroy() {
	        if (!this.layoutVertexBuffer)
	            return;
	        this.layoutVertexBuffer.destroy();
	        this.indexBuffer.destroy();
	        this.segments.destroy();
	        this.collisionVertexBuffer.destroy();
	    }
	}
	register('CollisionBuffers', CollisionBuffers);
	/**
	 * @internal
	 * Unlike other buckets, which simply implement #addFeature with type-specific
	 * logic for (essentially) triangulating feature geometries, SymbolBucket
	 * requires specialized behavior:
	 *
	 * 1. WorkerTile#parse(), the logical owner of the bucket creation process,
	 *    calls SymbolBucket#populate(), which resolves text and icon tokens on
	 *    each feature, adds each glyphs and symbols needed to the passed-in
	 *    collections options.glyphDependencies and options.iconDependencies, and
	 *    stores the feature data for use in subsequent step (this.features).
	 *
	 * 2. WorkerTile asynchronously requests from the main thread all of the glyphs
	 *    and icons needed (by this bucket and any others). When glyphs and icons
	 *    have been received, the WorkerTile creates a CollisionIndex and invokes:
	 *
	 * 3. performSymbolLayout(bucket, stacks, icons) perform texts shaping and
	 *    layout on a Symbol Bucket. This step populates:
	 *      `this.symbolInstances`: metadata on generated symbols
	 *      `this.collisionBoxArray`: collision data for use by foreground
	 *      `this.text`: SymbolBuffers for text symbols
	 *      `this.icons`: SymbolBuffers for icons
	 *      `this.iconCollisionBox`: Debug SymbolBuffers for icon collision boxes
	 *      `this.textCollisionBox`: Debug SymbolBuffers for text collision boxes
	 *    The results are sent to the foreground for rendering
	 *
	 * 4. placement.ts is run on the foreground,
	 *    and uses the CollisionIndex along with current camera settings to determine
	 *    which symbols can actually show on the map. Collided symbols are hidden
	 *    using a dynamic "OpacityVertexArray".
	 */
	class SymbolBucket {
	    constructor(options) {
	        this.collisionBoxArray = options.collisionBoxArray;
	        this.zoom = options.zoom;
	        this.overscaling = options.overscaling;
	        this.layers = options.layers;
	        this.layerIds = this.layers.map(layer => layer.id);
	        this.index = options.index;
	        this.pixelRatio = options.pixelRatio;
	        this.sourceLayerIndex = options.sourceLayerIndex;
	        this.hasPattern = false;
	        this.hasRTLText = false;
	        this.sortKeyRanges = [];
	        this.collisionCircleArray = [];
	        this.placementInvProjMatrix = identity$2([]);
	        this.placementViewportMatrix = identity$2([]);
	        const layer = this.layers[0];
	        const unevaluatedLayoutValues = layer._unevaluatedLayout._values;
	        this.textSizeData = getSizeData(this.zoom, unevaluatedLayoutValues['text-size']);
	        this.iconSizeData = getSizeData(this.zoom, unevaluatedLayoutValues['icon-size']);
	        const layout = this.layers[0].layout;
	        const sortKey = layout.get('symbol-sort-key');
	        const zOrder = layout.get('symbol-z-order');
	        this.canOverlap =
	            getOverlapMode(layout, 'text-overlap', 'text-allow-overlap') !== 'never' ||
	                getOverlapMode(layout, 'icon-overlap', 'icon-allow-overlap') !== 'never' ||
	                layout.get('text-ignore-placement') ||
	                layout.get('icon-ignore-placement');
	        this.sortFeaturesByKey = zOrder !== 'viewport-y' && !sortKey.isConstant();
	        const zOrderByViewportY = zOrder === 'viewport-y' || (zOrder === 'auto' && !this.sortFeaturesByKey);
	        this.sortFeaturesByY = zOrderByViewportY && this.canOverlap;
	        if (layout.get('symbol-placement') === 'point') {
	            this.writingModes = layout.get('text-writing-mode').map(wm => exports.WritingMode[wm]);
	        }
	        this.stateDependentLayerIds = this.layers.filter((l) => l.isStateDependent()).map((l) => l.id);
	        this.sourceID = options.sourceID;
	    }
	    createArrays() {
	        this.text = new SymbolBuffers(new ProgramConfigurationSet(this.layers, this.zoom, property => /^text/.test(property)));
	        this.icon = new SymbolBuffers(new ProgramConfigurationSet(this.layers, this.zoom, property => /^icon/.test(property)));
	        this.glyphOffsetArray = new GlyphOffsetArray();
	        this.lineVertexArray = new SymbolLineVertexArray();
	        this.symbolInstances = new SymbolInstanceArray();
	        this.textAnchorOffsets = new TextAnchorOffsetArray();
	    }
	    calculateGlyphDependencies(text, stack, textAlongLine, allowVerticalPlacement, doesAllowVerticalWritingMode) {
	        for (let i = 0; i < text.length; i++) {
	            stack[text.charCodeAt(i)] = true;
	            if ((textAlongLine || allowVerticalPlacement) && doesAllowVerticalWritingMode) {
	                const verticalChar = verticalizedCharacterMap[text.charAt(i)];
	                if (verticalChar) {
	                    stack[verticalChar.charCodeAt(0)] = true;
	                }
	            }
	        }
	    }
	    populate(features, options, canonical) {
	        const layer = this.layers[0];
	        const layout = layer.layout;
	        const textFont = layout.get('text-font');
	        const textField = layout.get('text-field');
	        const iconImage = layout.get('icon-image');
	        const hasText = (textField.value.kind !== 'constant' ||
	            (textField.value.value instanceof Formatted && !textField.value.value.isEmpty()) ||
	            textField.value.value.toString().length > 0) &&
	            (textFont.value.kind !== 'constant' || textFont.value.value.length > 0);
	        // we should always resolve the icon-image value if the property was defined in the style
	        // this allows us to fire the styleimagemissing event if image evaluation returns null
	        // the only way to distinguish between null returned from a coalesce statement with no valid images
	        // and null returned because icon-image wasn't defined is to check whether or not iconImage.parameters is an empty object
	        const hasIcon = iconImage.value.kind !== 'constant' || !!iconImage.value.value || Object.keys(iconImage.parameters).length > 0;
	        const symbolSortKey = layout.get('symbol-sort-key');
	        this.features = [];
	        if (!hasText && !hasIcon) {
	            return;
	        }
	        const icons = options.iconDependencies;
	        const stacks = options.glyphDependencies;
	        const availableImages = options.availableImages;
	        const globalProperties = new EvaluationParameters(this.zoom);
	        for (const { feature, id, index, sourceLayerIndex } of features) {
	            const needGeometry = layer._featureFilter.needGeometry;
	            const evaluationFeature = toEvaluationFeature(feature, needGeometry);
	            if (!layer._featureFilter.filter(globalProperties, evaluationFeature, canonical)) {
	                continue;
	            }
	            if (!needGeometry)
	                evaluationFeature.geometry = loadGeometry(feature);
	            let text;
	            if (hasText) {
	                // Expression evaluation will automatically coerce to Formatted
	                // but plain string token evaluation skips that pathway so do the
	                // conversion here.
	                const resolvedTokens = layer.getValueAndResolveTokens('text-field', evaluationFeature, canonical, availableImages);
	                const formattedText = Formatted.factory(resolvedTokens);
	                // on this instance: if hasRTLText is already true, all future calls to containsRTLText can be skipped.
	                const bucketHasRTLText = this.hasRTLText = (this.hasRTLText || containsRTLText(formattedText));
	                if (!bucketHasRTLText || // non-rtl text so can proceed safely
	                    rtlWorkerPlugin.getRTLTextPluginStatus() === 'unavailable' || // We don't intend to lazy-load the rtl text plugin, so proceed with incorrect shaping
	                    bucketHasRTLText && rtlWorkerPlugin.isParsed() // Use the rtlText plugin to shape text
	                ) {
	                    text = transformText(formattedText, layer, evaluationFeature);
	                }
	            }
	            let icon;
	            if (hasIcon) {
	                // Expression evaluation will automatically coerce to Image
	                // but plain string token evaluation skips that pathway so do the
	                // conversion here.
	                const resolvedTokens = layer.getValueAndResolveTokens('icon-image', evaluationFeature, canonical, availableImages);
	                if (resolvedTokens instanceof ResolvedImage) {
	                    icon = resolvedTokens;
	                }
	                else {
	                    icon = ResolvedImage.fromString(resolvedTokens);
	                }
	            }
	            if (!text && !icon) {
	                continue;
	            }
	            const sortKey = this.sortFeaturesByKey ?
	                symbolSortKey.evaluate(evaluationFeature, {}, canonical) :
	                undefined;
	            const symbolFeature = {
	                id,
	                text,
	                icon,
	                index,
	                sourceLayerIndex,
	                geometry: evaluationFeature.geometry,
	                properties: feature.properties,
	                type: vectorTileFeatureTypes[feature.type],
	                sortKey
	            };
	            this.features.push(symbolFeature);
	            if (icon) {
	                icons[icon.name] = true;
	            }
	            if (text) {
	                const fontStack = textFont.evaluate(evaluationFeature, {}, canonical).join(',');
	                const textAlongLine = layout.get('text-rotation-alignment') !== 'viewport' && layout.get('symbol-placement') !== 'point';
	                this.allowVerticalPlacement = this.writingModes && this.writingModes.indexOf(exports.WritingMode.vertical) >= 0;
	                for (const section of text.sections) {
	                    if (!section.image) {
	                        const doesAllowVerticalWritingMode = allowsVerticalWritingMode(text.toString());
	                        const sectionFont = section.fontStack || fontStack;
	                        const sectionStack = stacks[sectionFont] = stacks[sectionFont] || {};
	                        this.calculateGlyphDependencies(section.text, sectionStack, textAlongLine, this.allowVerticalPlacement, doesAllowVerticalWritingMode);
	                    }
	                    else {
	                        // Add section image to the list of dependencies.
	                        icons[section.image.name] = true;
	                    }
	                }
	            }
	        }
	        if (layout.get('symbol-placement') === 'line') {
	            // Merge adjacent lines with the same text to improve labelling.
	            // It's better to place labels on one long line than on many short segments.
	            this.features = mergeLines(this.features);
	        }
	        if (this.sortFeaturesByKey) {
	            this.features.sort((a, b) => {
	                // a.sortKey is always a number when sortFeaturesByKey is true
	                return a.sortKey - b.sortKey;
	            });
	        }
	    }
	    update(states, vtLayer, imagePositions) {
	        if (!this.stateDependentLayers.length)
	            return;
	        this.text.programConfigurations.updatePaintArrays(states, vtLayer, this.layers, imagePositions);
	        this.icon.programConfigurations.updatePaintArrays(states, vtLayer, this.layers, imagePositions);
	    }
	    isEmpty() {
	        // When the bucket encounters only rtl-text but the plugin isnt loaded, no symbol instances will be created.
	        // In order for the bucket to be serialized, and not discarded as an empty bucket both checks are necessary.
	        return this.symbolInstances.length === 0 && !this.hasRTLText;
	    }
	    uploadPending() {
	        return !this.uploaded || this.text.programConfigurations.needsUpload || this.icon.programConfigurations.needsUpload;
	    }
	    upload(context) {
	        if (!this.uploaded && this.hasDebugData()) {
	            this.textCollisionBox.upload(context);
	            this.iconCollisionBox.upload(context);
	        }
	        this.text.upload(context, this.sortFeaturesByY, !this.uploaded, this.text.programConfigurations.needsUpload);
	        this.icon.upload(context, this.sortFeaturesByY, !this.uploaded, this.icon.programConfigurations.needsUpload);
	        this.uploaded = true;
	    }
	    destroyDebugData() {
	        this.textCollisionBox.destroy();
	        this.iconCollisionBox.destroy();
	    }
	    destroy() {
	        this.text.destroy();
	        this.icon.destroy();
	        if (this.hasDebugData()) {
	            this.destroyDebugData();
	        }
	    }
	    addToLineVertexArray(anchor, line) {
	        const lineStartIndex = this.lineVertexArray.length;
	        if (anchor.segment !== undefined) {
	            let sumForwardLength = anchor.dist(line[anchor.segment + 1]);
	            let sumBackwardLength = anchor.dist(line[anchor.segment]);
	            const vertices = {};
	            for (let i = anchor.segment + 1; i < line.length; i++) {
	                vertices[i] = { x: line[i].x, y: line[i].y, tileUnitDistanceFromAnchor: sumForwardLength };
	                if (i < line.length - 1) {
	                    sumForwardLength += line[i + 1].dist(line[i]);
	                }
	            }
	            for (let i = anchor.segment || 0; i >= 0; i--) {
	                vertices[i] = { x: line[i].x, y: line[i].y, tileUnitDistanceFromAnchor: sumBackwardLength };
	                if (i > 0) {
	                    sumBackwardLength += line[i - 1].dist(line[i]);
	                }
	            }
	            for (let i = 0; i < line.length; i++) {
	                const vertex = vertices[i];
	                this.lineVertexArray.emplaceBack(vertex.x, vertex.y, vertex.tileUnitDistanceFromAnchor);
	            }
	        }
	        return {
	            lineStartIndex,
	            lineLength: this.lineVertexArray.length - lineStartIndex
	        };
	    }
	    addSymbols(arrays, quads, sizeVertex, lineOffset, alongLine, feature, writingMode, labelAnchor, lineStartIndex, lineLength, associatedIconIndex, canonical) {
	        const indexArray = arrays.indexArray;
	        const layoutVertexArray = arrays.layoutVertexArray;
	        const segment = arrays.segments.prepareSegment(4 * quads.length, layoutVertexArray, indexArray, this.canOverlap ? feature.sortKey : undefined);
	        const glyphOffsetArrayStart = this.glyphOffsetArray.length;
	        const vertexStartIndex = segment.vertexLength;
	        const angle = (this.allowVerticalPlacement && writingMode === exports.WritingMode.vertical) ? Math.PI / 2 : 0;
	        const sections = feature.text && feature.text.sections;
	        for (let i = 0; i < quads.length; i++) {
	            const { tl, tr, bl, br, tex, pixelOffsetTL, pixelOffsetBR, minFontScaleX, minFontScaleY, glyphOffset, isSDF, sectionIndex } = quads[i];
	            const index = segment.vertexLength;
	            const y = glyphOffset[1];
	            addVertex(layoutVertexArray, labelAnchor.x, labelAnchor.y, tl.x, y + tl.y, tex.x, tex.y, sizeVertex, isSDF, pixelOffsetTL.x, pixelOffsetTL.y, minFontScaleX, minFontScaleY);
	            addVertex(layoutVertexArray, labelAnchor.x, labelAnchor.y, tr.x, y + tr.y, tex.x + tex.w, tex.y, sizeVertex, isSDF, pixelOffsetBR.x, pixelOffsetTL.y, minFontScaleX, minFontScaleY);
	            addVertex(layoutVertexArray, labelAnchor.x, labelAnchor.y, bl.x, y + bl.y, tex.x, tex.y + tex.h, sizeVertex, isSDF, pixelOffsetTL.x, pixelOffsetBR.y, minFontScaleX, minFontScaleY);
	            addVertex(layoutVertexArray, labelAnchor.x, labelAnchor.y, br.x, y + br.y, tex.x + tex.w, tex.y + tex.h, sizeVertex, isSDF, pixelOffsetBR.x, pixelOffsetBR.y, minFontScaleX, minFontScaleY);
	            addDynamicAttributes(arrays.dynamicLayoutVertexArray, labelAnchor, angle);
	            indexArray.emplaceBack(index, index + 1, index + 2);
	            indexArray.emplaceBack(index + 1, index + 2, index + 3);
	            segment.vertexLength += 4;
	            segment.primitiveLength += 2;
	            this.glyphOffsetArray.emplaceBack(glyphOffset[0]);
	            if (i === quads.length - 1 || sectionIndex !== quads[i + 1].sectionIndex) {
	                arrays.programConfigurations.populatePaintArrays(layoutVertexArray.length, feature, feature.index, {}, canonical, sections && sections[sectionIndex]);
	            }
	        }
	        arrays.placedSymbolArray.emplaceBack(labelAnchor.x, labelAnchor.y, glyphOffsetArrayStart, this.glyphOffsetArray.length - glyphOffsetArrayStart, vertexStartIndex, lineStartIndex, lineLength, labelAnchor.segment, sizeVertex ? sizeVertex[0] : 0, sizeVertex ? sizeVertex[1] : 0, lineOffset[0], lineOffset[1], writingMode, 
	        // placedOrientation is null initially; will be updated to horizontal(1)/vertical(2) if placed
	        0, false, 
	        // The crossTileID is only filled/used on the foreground for dynamic text anchors
	        0, associatedIconIndex);
	    }
	    _addCollisionDebugVertex(layoutVertexArray, collisionVertexArray, point, anchorX, anchorY, extrude) {
	        collisionVertexArray.emplaceBack(0, 0);
	        return layoutVertexArray.emplaceBack(
	        // pos
	        point.x, point.y, 
	        // a_anchor_pos
	        anchorX, anchorY, 
	        // extrude
	        Math.round(extrude.x), Math.round(extrude.y));
	    }
	    addCollisionDebugVertices(x1, y1, x2, y2, arrays, boxAnchorPoint, symbolInstance) {
	        const segment = arrays.segments.prepareSegment(4, arrays.layoutVertexArray, arrays.indexArray);
	        const index = segment.vertexLength;
	        const layoutVertexArray = arrays.layoutVertexArray;
	        const collisionVertexArray = arrays.collisionVertexArray;
	        const anchorX = symbolInstance.anchorX;
	        const anchorY = symbolInstance.anchorY;
	        this._addCollisionDebugVertex(layoutVertexArray, collisionVertexArray, boxAnchorPoint, anchorX, anchorY, new Point$2(x1, y1));
	        this._addCollisionDebugVertex(layoutVertexArray, collisionVertexArray, boxAnchorPoint, anchorX, anchorY, new Point$2(x2, y1));
	        this._addCollisionDebugVertex(layoutVertexArray, collisionVertexArray, boxAnchorPoint, anchorX, anchorY, new Point$2(x2, y2));
	        this._addCollisionDebugVertex(layoutVertexArray, collisionVertexArray, boxAnchorPoint, anchorX, anchorY, new Point$2(x1, y2));
	        segment.vertexLength += 4;
	        const indexArray = arrays.indexArray;
	        indexArray.emplaceBack(index, index + 1);
	        indexArray.emplaceBack(index + 1, index + 2);
	        indexArray.emplaceBack(index + 2, index + 3);
	        indexArray.emplaceBack(index + 3, index);
	        segment.primitiveLength += 4;
	    }
	    addDebugCollisionBoxes(startIndex, endIndex, symbolInstance, isText) {
	        for (let b = startIndex; b < endIndex; b++) {
	            const box = this.collisionBoxArray.get(b);
	            const x1 = box.x1;
	            const y1 = box.y1;
	            const x2 = box.x2;
	            const y2 = box.y2;
	            this.addCollisionDebugVertices(x1, y1, x2, y2, isText ? this.textCollisionBox : this.iconCollisionBox, box.anchorPoint, symbolInstance);
	        }
	    }
	    generateCollisionDebugBuffers() {
	        if (this.hasDebugData()) {
	            this.destroyDebugData();
	        }
	        this.textCollisionBox = new CollisionBuffers(CollisionBoxLayoutArray, collisionBoxLayout.members, LineIndexArray);
	        this.iconCollisionBox = new CollisionBuffers(CollisionBoxLayoutArray, collisionBoxLayout.members, LineIndexArray);
	        for (let i = 0; i < this.symbolInstances.length; i++) {
	            const symbolInstance = this.symbolInstances.get(i);
	            this.addDebugCollisionBoxes(symbolInstance.textBoxStartIndex, symbolInstance.textBoxEndIndex, symbolInstance, true);
	            this.addDebugCollisionBoxes(symbolInstance.verticalTextBoxStartIndex, symbolInstance.verticalTextBoxEndIndex, symbolInstance, true);
	            this.addDebugCollisionBoxes(symbolInstance.iconBoxStartIndex, symbolInstance.iconBoxEndIndex, symbolInstance, false);
	            this.addDebugCollisionBoxes(symbolInstance.verticalIconBoxStartIndex, symbolInstance.verticalIconBoxEndIndex, symbolInstance, false);
	        }
	    }
	    // These flat arrays are meant to be quicker to iterate over than the source
	    // CollisionBoxArray
	    _deserializeCollisionBoxesForSymbol(collisionBoxArray, textStartIndex, textEndIndex, verticalTextStartIndex, verticalTextEndIndex, iconStartIndex, iconEndIndex, verticalIconStartIndex, verticalIconEndIndex) {
	        const collisionArrays = {};
	        for (let k = textStartIndex; k < textEndIndex; k++) {
	            const box = collisionBoxArray.get(k);
	            collisionArrays.textBox = { x1: box.x1, y1: box.y1, x2: box.x2, y2: box.y2, anchorPointX: box.anchorPointX, anchorPointY: box.anchorPointY };
	            collisionArrays.textFeatureIndex = box.featureIndex;
	            break; // Only one box allowed per instance
	        }
	        for (let k = verticalTextStartIndex; k < verticalTextEndIndex; k++) {
	            const box = collisionBoxArray.get(k);
	            collisionArrays.verticalTextBox = { x1: box.x1, y1: box.y1, x2: box.x2, y2: box.y2, anchorPointX: box.anchorPointX, anchorPointY: box.anchorPointY };
	            collisionArrays.verticalTextFeatureIndex = box.featureIndex;
	            break; // Only one box allowed per instance
	        }
	        for (let k = iconStartIndex; k < iconEndIndex; k++) {
	            // An icon can only have one box now, so this indexing is a bit vestigial...
	            const box = collisionBoxArray.get(k);
	            collisionArrays.iconBox = { x1: box.x1, y1: box.y1, x2: box.x2, y2: box.y2, anchorPointX: box.anchorPointX, anchorPointY: box.anchorPointY };
	            collisionArrays.iconFeatureIndex = box.featureIndex;
	            break; // Only one box allowed per instance
	        }
	        for (let k = verticalIconStartIndex; k < verticalIconEndIndex; k++) {
	            // An icon can only have one box now, so this indexing is a bit vestigial...
	            const box = collisionBoxArray.get(k);
	            collisionArrays.verticalIconBox = { x1: box.x1, y1: box.y1, x2: box.x2, y2: box.y2, anchorPointX: box.anchorPointX, anchorPointY: box.anchorPointY };
	            collisionArrays.verticalIconFeatureIndex = box.featureIndex;
	            break; // Only one box allowed per instance
	        }
	        return collisionArrays;
	    }
	    deserializeCollisionBoxes(collisionBoxArray) {
	        this.collisionArrays = [];
	        for (let i = 0; i < this.symbolInstances.length; i++) {
	            const symbolInstance = this.symbolInstances.get(i);
	            this.collisionArrays.push(this._deserializeCollisionBoxesForSymbol(collisionBoxArray, symbolInstance.textBoxStartIndex, symbolInstance.textBoxEndIndex, symbolInstance.verticalTextBoxStartIndex, symbolInstance.verticalTextBoxEndIndex, symbolInstance.iconBoxStartIndex, symbolInstance.iconBoxEndIndex, symbolInstance.verticalIconBoxStartIndex, symbolInstance.verticalIconBoxEndIndex));
	        }
	    }
	    hasTextData() {
	        return this.text.segments.get().length > 0;
	    }
	    hasIconData() {
	        return this.icon.segments.get().length > 0;
	    }
	    hasDebugData() {
	        return this.textCollisionBox && this.iconCollisionBox;
	    }
	    hasTextCollisionBoxData() {
	        return this.hasDebugData() && this.textCollisionBox.segments.get().length > 0;
	    }
	    hasIconCollisionBoxData() {
	        return this.hasDebugData() && this.iconCollisionBox.segments.get().length > 0;
	    }
	    addIndicesForPlacedSymbol(iconOrText, placedSymbolIndex) {
	        const placedSymbol = iconOrText.placedSymbolArray.get(placedSymbolIndex);
	        const endIndex = placedSymbol.vertexStartIndex + placedSymbol.numGlyphs * 4;
	        for (let vertexIndex = placedSymbol.vertexStartIndex; vertexIndex < endIndex; vertexIndex += 4) {
	            iconOrText.indexArray.emplaceBack(vertexIndex, vertexIndex + 1, vertexIndex + 2);
	            iconOrText.indexArray.emplaceBack(vertexIndex + 1, vertexIndex + 2, vertexIndex + 3);
	        }
	    }
	    getSortedSymbolIndexes(angle) {
	        if (this.sortedAngle === angle && this.symbolInstanceIndexes !== undefined) {
	            return this.symbolInstanceIndexes;
	        }
	        const sin = Math.sin(angle);
	        const cos = Math.cos(angle);
	        const rotatedYs = [];
	        const featureIndexes = [];
	        const result = [];
	        for (let i = 0; i < this.symbolInstances.length; ++i) {
	            result.push(i);
	            const symbolInstance = this.symbolInstances.get(i);
	            rotatedYs.push(Math.round(sin * symbolInstance.anchorX + cos * symbolInstance.anchorY) | 0);
	            featureIndexes.push(symbolInstance.featureIndex);
	        }
	        result.sort((aIndex, bIndex) => {
	            return (rotatedYs[aIndex] - rotatedYs[bIndex]) ||
	                (featureIndexes[bIndex] - featureIndexes[aIndex]);
	        });
	        return result;
	    }
	    addToSortKeyRanges(symbolInstanceIndex, sortKey) {
	        const last = this.sortKeyRanges[this.sortKeyRanges.length - 1];
	        if (last && last.sortKey === sortKey) {
	            last.symbolInstanceEnd = symbolInstanceIndex + 1;
	        }
	        else {
	            this.sortKeyRanges.push({
	                sortKey,
	                symbolInstanceStart: symbolInstanceIndex,
	                symbolInstanceEnd: symbolInstanceIndex + 1
	            });
	        }
	    }
	    sortFeatures(angle) {
	        if (!this.sortFeaturesByY)
	            return;
	        if (this.sortedAngle === angle)
	            return;
	        // The current approach to sorting doesn't sort across segments so don't try.
	        // Sorting within segments separately seemed not to be worth the complexity.
	        if (this.text.segments.get().length > 1 || this.icon.segments.get().length > 1)
	            return;
	        // If the symbols are allowed to overlap sort them by their vertical screen position.
	        // The index array buffer is rewritten to reference the (unchanged) vertices in the
	        // sorted order.
	        // To avoid sorting the actual symbolInstance array we sort an array of indexes.
	        this.symbolInstanceIndexes = this.getSortedSymbolIndexes(angle);
	        this.sortedAngle = angle;
	        this.text.indexArray.clear();
	        this.icon.indexArray.clear();
	        this.featureSortOrder = [];
	        for (const i of this.symbolInstanceIndexes) {
	            const symbolInstance = this.symbolInstances.get(i);
	            this.featureSortOrder.push(symbolInstance.featureIndex);
	            [
	                symbolInstance.rightJustifiedTextSymbolIndex,
	                symbolInstance.centerJustifiedTextSymbolIndex,
	                symbolInstance.leftJustifiedTextSymbolIndex
	            ].forEach((index, i, array) => {
	                // Only add a given index the first time it shows up,
	                // to avoid duplicate opacity entries when multiple justifications
	                // share the same glyphs.
	                if (index >= 0 && array.indexOf(index) === i) {
	                    this.addIndicesForPlacedSymbol(this.text, index);
	                }
	            });
	            if (symbolInstance.verticalPlacedTextSymbolIndex >= 0) {
	                this.addIndicesForPlacedSymbol(this.text, symbolInstance.verticalPlacedTextSymbolIndex);
	            }
	            if (symbolInstance.placedIconSymbolIndex >= 0) {
	                this.addIndicesForPlacedSymbol(this.icon, symbolInstance.placedIconSymbolIndex);
	            }
	            if (symbolInstance.verticalPlacedIconSymbolIndex >= 0) {
	                this.addIndicesForPlacedSymbol(this.icon, symbolInstance.verticalPlacedIconSymbolIndex);
	            }
	        }
	        if (this.text.indexBuffer)
	            this.text.indexBuffer.updateData(this.text.indexArray);
	        if (this.icon.indexBuffer)
	            this.icon.indexBuffer.updateData(this.icon.indexArray);
	    }
	}
	register('SymbolBucket', SymbolBucket, {
	    omit: ['layers', 'collisionBoxArray', 'features', 'compareText']
	});
	// this constant is based on the size of StructArray indexes used in a symbol
	// bucket--namely, glyphOffsetArrayStart
	// eg the max valid UInt16 is 65,535
	// See https://github.com/mapbox/mapbox-gl-js/issues/2907 for motivation
	// lineStartIndex and textBoxStartIndex could potentially be concerns
	// but we expect there to be many fewer boxes/lines than glyphs
	SymbolBucket.MAX_GLYPHS = 65535;
	SymbolBucket.addDynamicAttributes = addDynamicAttributes;

	/**
	 * Replace tokens in a string template with values in an object
	 *
	 * @param properties - a key/value relationship between tokens and replacements
	 * @param text - the template string
	 * @returns the template with tokens replaced
	 */
	function resolveTokens(properties, text) {
	    return text.replace(/{([^{}]+)}/g, (match, key) => {
	        return properties && key in properties ? String(properties[key]) : '';
	    });
	}

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let layout;
	const getLayout = () => layout = layout || new Properties({
	    "symbol-placement": new DataConstantProperty(v8Spec["layout_symbol"]["symbol-placement"]),
	    "symbol-spacing": new DataConstantProperty(v8Spec["layout_symbol"]["symbol-spacing"]),
	    "symbol-avoid-edges": new DataConstantProperty(v8Spec["layout_symbol"]["symbol-avoid-edges"]),
	    "symbol-sort-key": new DataDrivenProperty(v8Spec["layout_symbol"]["symbol-sort-key"]),
	    "symbol-z-order": new DataConstantProperty(v8Spec["layout_symbol"]["symbol-z-order"]),
	    "icon-allow-overlap": new DataConstantProperty(v8Spec["layout_symbol"]["icon-allow-overlap"]),
	    "icon-overlap": new DataConstantProperty(v8Spec["layout_symbol"]["icon-overlap"]),
	    "icon-ignore-placement": new DataConstantProperty(v8Spec["layout_symbol"]["icon-ignore-placement"]),
	    "icon-optional": new DataConstantProperty(v8Spec["layout_symbol"]["icon-optional"]),
	    "icon-rotation-alignment": new DataConstantProperty(v8Spec["layout_symbol"]["icon-rotation-alignment"]),
	    "icon-size": new DataDrivenProperty(v8Spec["layout_symbol"]["icon-size"]),
	    "icon-text-fit": new DataConstantProperty(v8Spec["layout_symbol"]["icon-text-fit"]),
	    "icon-text-fit-padding": new DataConstantProperty(v8Spec["layout_symbol"]["icon-text-fit-padding"]),
	    "icon-image": new DataDrivenProperty(v8Spec["layout_symbol"]["icon-image"]),
	    "icon-rotate": new DataDrivenProperty(v8Spec["layout_symbol"]["icon-rotate"]),
	    "icon-padding": new DataDrivenProperty(v8Spec["layout_symbol"]["icon-padding"]),
	    "icon-keep-upright": new DataConstantProperty(v8Spec["layout_symbol"]["icon-keep-upright"]),
	    "icon-offset": new DataDrivenProperty(v8Spec["layout_symbol"]["icon-offset"]),
	    "icon-anchor": new DataDrivenProperty(v8Spec["layout_symbol"]["icon-anchor"]),
	    "icon-pitch-alignment": new DataConstantProperty(v8Spec["layout_symbol"]["icon-pitch-alignment"]),
	    "text-pitch-alignment": new DataConstantProperty(v8Spec["layout_symbol"]["text-pitch-alignment"]),
	    "text-rotation-alignment": new DataConstantProperty(v8Spec["layout_symbol"]["text-rotation-alignment"]),
	    "text-field": new DataDrivenProperty(v8Spec["layout_symbol"]["text-field"]),
	    "text-font": new DataDrivenProperty(v8Spec["layout_symbol"]["text-font"]),
	    "text-size": new DataDrivenProperty(v8Spec["layout_symbol"]["text-size"]),
	    "text-max-width": new DataDrivenProperty(v8Spec["layout_symbol"]["text-max-width"]),
	    "text-line-height": new DataConstantProperty(v8Spec["layout_symbol"]["text-line-height"]),
	    "text-letter-spacing": new DataDrivenProperty(v8Spec["layout_symbol"]["text-letter-spacing"]),
	    "text-justify": new DataDrivenProperty(v8Spec["layout_symbol"]["text-justify"]),
	    "text-radial-offset": new DataDrivenProperty(v8Spec["layout_symbol"]["text-radial-offset"]),
	    "text-variable-anchor": new DataConstantProperty(v8Spec["layout_symbol"]["text-variable-anchor"]),
	    "text-variable-anchor-offset": new DataDrivenProperty(v8Spec["layout_symbol"]["text-variable-anchor-offset"]),
	    "text-anchor": new DataDrivenProperty(v8Spec["layout_symbol"]["text-anchor"]),
	    "text-max-angle": new DataConstantProperty(v8Spec["layout_symbol"]["text-max-angle"]),
	    "text-writing-mode": new DataConstantProperty(v8Spec["layout_symbol"]["text-writing-mode"]),
	    "text-rotate": new DataDrivenProperty(v8Spec["layout_symbol"]["text-rotate"]),
	    "text-padding": new DataConstantProperty(v8Spec["layout_symbol"]["text-padding"]),
	    "text-keep-upright": new DataConstantProperty(v8Spec["layout_symbol"]["text-keep-upright"]),
	    "text-transform": new DataDrivenProperty(v8Spec["layout_symbol"]["text-transform"]),
	    "text-offset": new DataDrivenProperty(v8Spec["layout_symbol"]["text-offset"]),
	    "text-allow-overlap": new DataConstantProperty(v8Spec["layout_symbol"]["text-allow-overlap"]),
	    "text-overlap": new DataConstantProperty(v8Spec["layout_symbol"]["text-overlap"]),
	    "text-ignore-placement": new DataConstantProperty(v8Spec["layout_symbol"]["text-ignore-placement"]),
	    "text-optional": new DataConstantProperty(v8Spec["layout_symbol"]["text-optional"]),
	});
	let paint$2;
	const getPaint$2 = () => paint$2 = paint$2 || new Properties({
	    "icon-opacity": new DataDrivenProperty(v8Spec["paint_symbol"]["icon-opacity"]),
	    "icon-color": new DataDrivenProperty(v8Spec["paint_symbol"]["icon-color"]),
	    "icon-halo-color": new DataDrivenProperty(v8Spec["paint_symbol"]["icon-halo-color"]),
	    "icon-halo-width": new DataDrivenProperty(v8Spec["paint_symbol"]["icon-halo-width"]),
	    "icon-halo-blur": new DataDrivenProperty(v8Spec["paint_symbol"]["icon-halo-blur"]),
	    "icon-translate": new DataConstantProperty(v8Spec["paint_symbol"]["icon-translate"]),
	    "icon-translate-anchor": new DataConstantProperty(v8Spec["paint_symbol"]["icon-translate-anchor"]),
	    "text-opacity": new DataDrivenProperty(v8Spec["paint_symbol"]["text-opacity"]),
	    "text-color": new DataDrivenProperty(v8Spec["paint_symbol"]["text-color"], { runtimeType: ColorType, getOverride: (o) => o.textColor, hasOverride: (o) => !!o.textColor }),
	    "text-halo-color": new DataDrivenProperty(v8Spec["paint_symbol"]["text-halo-color"]),
	    "text-halo-width": new DataDrivenProperty(v8Spec["paint_symbol"]["text-halo-width"]),
	    "text-halo-blur": new DataDrivenProperty(v8Spec["paint_symbol"]["text-halo-blur"]),
	    "text-translate": new DataConstantProperty(v8Spec["paint_symbol"]["text-translate"]),
	    "text-translate-anchor": new DataConstantProperty(v8Spec["paint_symbol"]["text-translate-anchor"]),
	});
	var properties$2 = ({ get paint() { return getPaint$2(); }, get layout() { return getLayout(); } });

	// This is an internal expression class. It is only used in GL JS and
	// has GL JS dependencies which can break the standalone style-spec module
	class FormatSectionOverride {
	    constructor(defaultValue) {
	        if (defaultValue.property.overrides === undefined)
	            throw new Error('overrides must be provided to instantiate FormatSectionOverride class');
	        this.type = defaultValue.property.overrides ? defaultValue.property.overrides.runtimeType : NullType;
	        this.defaultValue = defaultValue;
	    }
	    evaluate(ctx) {
	        if (ctx.formattedSection) {
	            const overrides = this.defaultValue.property.overrides;
	            if (overrides && overrides.hasOverride(ctx.formattedSection)) {
	                return overrides.getOverride(ctx.formattedSection);
	            }
	        }
	        if (ctx.feature && ctx.featureState) {
	            return this.defaultValue.evaluate(ctx.feature, ctx.featureState);
	        }
	        return this.defaultValue.property.specification.default;
	    }
	    eachChild(fn) {
	        if (!this.defaultValue.isConstant()) {
	            const expr = this.defaultValue.value;
	            fn(expr._styleExpression.expression);
	        }
	    }
	    // Cannot be statically evaluated, as the output depends on the evaluation context.
	    outputDefined() {
	        return false;
	    }
	    serialize() {
	        return null;
	    }
	}
	register('FormatSectionOverride', FormatSectionOverride, { omit: ['defaultValue'] });

	class SymbolStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties$2);
	    }
	    recalculate(parameters, availableImages) {
	        super.recalculate(parameters, availableImages);
	        if (this.layout.get('icon-rotation-alignment') === 'auto') {
	            if (this.layout.get('symbol-placement') !== 'point') {
	                this.layout._values['icon-rotation-alignment'] = 'map';
	            }
	            else {
	                this.layout._values['icon-rotation-alignment'] = 'viewport';
	            }
	        }
	        if (this.layout.get('text-rotation-alignment') === 'auto') {
	            if (this.layout.get('symbol-placement') !== 'point') {
	                this.layout._values['text-rotation-alignment'] = 'map';
	            }
	            else {
	                this.layout._values['text-rotation-alignment'] = 'viewport';
	            }
	        }
	        // If unspecified, `*-pitch-alignment` inherits `*-rotation-alignment`
	        if (this.layout.get('text-pitch-alignment') === 'auto') {
	            this.layout._values['text-pitch-alignment'] = this.layout.get('text-rotation-alignment') === 'map' ? 'map' : 'viewport';
	        }
	        if (this.layout.get('icon-pitch-alignment') === 'auto') {
	            this.layout._values['icon-pitch-alignment'] = this.layout.get('icon-rotation-alignment');
	        }
	        if (this.layout.get('symbol-placement') === 'point') {
	            const writingModes = this.layout.get('text-writing-mode');
	            if (writingModes) {
	                // remove duplicates, preserving order
	                const deduped = [];
	                for (const m of writingModes) {
	                    if (deduped.indexOf(m) < 0)
	                        deduped.push(m);
	                }
	                this.layout._values['text-writing-mode'] = deduped;
	            }
	            else {
	                this.layout._values['text-writing-mode'] = ['horizontal'];
	            }
	        }
	        this._setPaintOverrides();
	    }
	    getValueAndResolveTokens(name, feature, canonical, availableImages) {
	        const value = this.layout.get(name).evaluate(feature, {}, canonical, availableImages);
	        const unevaluated = this._unevaluatedLayout._values[name];
	        if (!unevaluated.isDataDriven() && !isExpression(unevaluated.value) && value) {
	            return resolveTokens(feature.properties, value);
	        }
	        return value;
	    }
	    createBucket(parameters) {
	        return new SymbolBucket(parameters);
	    }
	    queryRadius() {
	        return 0;
	    }
	    queryIntersectsFeature() {
	        throw new Error('Should take a different path in FeatureIndex');
	    }
	    _setPaintOverrides() {
	        for (const overridable of properties$2.paint.overridableProperties) {
	            if (!SymbolStyleLayer.hasPaintOverride(this.layout, overridable)) {
	                continue;
	            }
	            const overriden = this.paint.get(overridable);
	            const override = new FormatSectionOverride(overriden);
	            const styleExpression = new StyleExpression(override, overriden.property.specification);
	            let expression = null;
	            if (overriden.value.kind === 'constant' || overriden.value.kind === 'source') {
	                expression = new ZoomConstantExpression('source', styleExpression);
	            }
	            else {
	                expression = new ZoomDependentExpression('composite', styleExpression, overriden.value.zoomStops);
	            }
	            this.paint._values[overridable] = new PossiblyEvaluatedPropertyValue(overriden.property, expression, overriden.parameters);
	        }
	    }
	    _handleOverridablePaintPropertyUpdate(name, oldValue, newValue) {
	        if (!this.layout || oldValue.isDataDriven() || newValue.isDataDriven()) {
	            return false;
	        }
	        return SymbolStyleLayer.hasPaintOverride(this.layout, name);
	    }
	    static hasPaintOverride(layout, propertyName) {
	        const textField = layout.get('text-field');
	        const property = properties$2.paint.properties[propertyName];
	        let hasOverrides = false;
	        const checkSections = (sections) => {
	            for (const section of sections) {
	                if (property.overrides && property.overrides.hasOverride(section)) {
	                    hasOverrides = true;
	                    return;
	                }
	            }
	        };
	        if (textField.value.kind === 'constant' && textField.value.value instanceof Formatted) {
	            checkSections(textField.value.value.sections);
	        }
	        else if (textField.value.kind === 'source') {
	            const checkExpression = (expression) => {
	                if (hasOverrides)
	                    return;
	                if (expression instanceof Literal && typeOf(expression.value) === FormattedType) {
	                    const formatted = expression.value;
	                    checkSections(formatted.sections);
	                }
	                else if (expression instanceof FormatExpression) {
	                    checkSections(expression.sections);
	                }
	                else {
	                    expression.eachChild(checkExpression);
	                }
	            };
	            const expr = textField.value;
	            if (expr._styleExpression) {
	                checkExpression(expr._styleExpression.expression);
	            }
	        }
	        return hasOverrides;
	    }
	}
	function getIconPadding(layout, feature, canonical, pixelRatio = 1) {
	    // Support text-padding in addition to icon-padding? Unclear how to apply asymmetric text-padding to the radius for collision circles.
	    const result = layout.get('icon-padding').evaluate(feature, {}, canonical);
	    const values = result && result.values;
	    return [
	        values[0] * pixelRatio,
	        values[1] * pixelRatio,
	        values[2] * pixelRatio,
	        values[3] * pixelRatio,
	    ];
	}

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let paint$1;
	const getPaint$1 = () => paint$1 = paint$1 || new Properties({
	    "background-color": new DataConstantProperty(v8Spec["paint_background"]["background-color"]),
	    "background-pattern": new CrossFadedProperty(v8Spec["paint_background"]["background-pattern"]),
	    "background-opacity": new DataConstantProperty(v8Spec["paint_background"]["background-opacity"]),
	});
	var properties$1 = ({ get paint() { return getPaint$1(); } });

	class BackgroundStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties$1);
	    }
	}

	// This file is generated. Edit build/generate-style-code.ts, then run 'npm run codegen'.
	/* eslint-disable */
	let paint;
	const getPaint = () => paint = paint || new Properties({
	    "raster-opacity": new DataConstantProperty(v8Spec["paint_raster"]["raster-opacity"]),
	    "raster-hue-rotate": new DataConstantProperty(v8Spec["paint_raster"]["raster-hue-rotate"]),
	    "raster-brightness-min": new DataConstantProperty(v8Spec["paint_raster"]["raster-brightness-min"]),
	    "raster-brightness-max": new DataConstantProperty(v8Spec["paint_raster"]["raster-brightness-max"]),
	    "raster-saturation": new DataConstantProperty(v8Spec["paint_raster"]["raster-saturation"]),
	    "raster-contrast": new DataConstantProperty(v8Spec["paint_raster"]["raster-contrast"]),
	    "raster-resampling": new DataConstantProperty(v8Spec["paint_raster"]["raster-resampling"]),
	    "raster-fade-duration": new DataConstantProperty(v8Spec["paint_raster"]["raster-fade-duration"]),
	});
	var properties = ({ get paint() { return getPaint(); } });

	class RasterStyleLayer extends StyleLayer {
	    constructor(layer) {
	        super(layer, properties);
	    }
	}

	function validateCustomStyleLayer(layerObject) {
	    const errors = [];
	    const id = layerObject.id;
	    if (id === undefined) {
	        errors.push({
	            message: `layers.${id}: missing required property "id"`
	        });
	    }
	    if (layerObject.render === undefined) {
	        errors.push({
	            message: `layers.${id}: missing required method "render"`
	        });
	    }
	    if (layerObject.renderingMode &&
	        layerObject.renderingMode !== '2d' &&
	        layerObject.renderingMode !== '3d') {
	        errors.push({
	            message: `layers.${id}: property "renderingMode" must be either "2d" or "3d"`
	        });
	    }
	    return errors;
	}
	class CustomStyleLayer extends StyleLayer {
	    constructor(implementation) {
	        super(implementation, {});
	        this.onAdd = (map) => {
	            if (this.implementation.onAdd) {
	                this.implementation.onAdd(map, map.painter.context.gl);
	            }
	        };
	        this.onRemove = (map) => {
	            if (this.implementation.onRemove) {
	                this.implementation.onRemove(map, map.painter.context.gl);
	            }
	        };
	        this.implementation = implementation;
	    }
	    is3D() {
	        return this.implementation.renderingMode === '3d';
	    }
	    hasOffscreenPass() {
	        return this.implementation.prerender !== undefined;
	    }
	    recalculate() { }
	    updateTransitions() { }
	    hasTransition() { return false; }
	    serialize() {
	        throw new Error('Custom layers cannot be serialized');
	    }
	}

	function createStyleLayer(layer) {
	    if (layer.type === 'custom') {
	        return new CustomStyleLayer(layer);
	    }
	    switch (layer.type) {
	        case 'background':
	            return new BackgroundStyleLayer(layer);
	        case 'circle':
	            return new CircleStyleLayer(layer);
	        case 'fill':
	            return new FillStyleLayer(layer);
	        case 'fill-extrusion':
	            return new FillExtrusionStyleLayer(layer);
	        case 'heatmap':
	            return new HeatmapStyleLayer(layer);
	        case 'hillshade':
	            return new HillshadeStyleLayer(layer);
	        case 'line':
	            return new LineStyleLayer(layer);
	        case 'raster':
	            return new RasterStyleLayer(layer);
	        case 'symbol':
	            return new SymbolStyleLayer(layer);
	    }
	}

	/**
	 * Invokes the wrapped function in a non-blocking way when trigger() is called.
	 * Invocation requests are ignored until the function was actually invoked.
	 */
	class ThrottledInvoker {
	    constructor(methodToThrottle) {
	        this._methodToThrottle = methodToThrottle;
	        this._triggered = false;
	        if (typeof MessageChannel !== 'undefined') {
	            this._channel = new MessageChannel();
	            this._channel.port2.onmessage = () => {
	                this._triggered = false;
	                this._methodToThrottle();
	            };
	        }
	    }
	    trigger() {
	        if (this._triggered) {
	            return;
	        }
	        this._triggered = true;
	        if (this._channel) {
	            this._channel.port1.postMessage(true);
	        }
	        else {
	            setTimeout(() => {
	                this._triggered = false;
	                this._methodToThrottle();
	            }, 0);
	        }
	    }
	    remove() {
	        delete this._channel;
	        this._methodToThrottle = () => { };
	    }
	}

	/**
	 * An implementation of the [Actor design pattern](http://en.wikipedia.org/wiki/Actor_model)
	 * that maintains the relationship between asynchronous tasks and the objects
	 * that spin them off - in this case, tasks like parsing parts of styles,
	 * owned by the styles
	 */
	class Actor {
	    /**
	     * @param target - The target
	     * @param mapId - A unique identifier for the Map instance using this Actor.
	     */
	    constructor(target, mapId) {
	        this.target = target;
	        this.mapId = mapId;
	        this.resolveRejects = {};
	        this.tasks = {};
	        this.taskQueue = [];
	        this.abortControllers = {};
	        this.messageHandlers = {};
	        this.invoker = new ThrottledInvoker(() => this.process());
	        this.subscription = subscribe(this.target, 'message', (message) => this.receive(message), false);
	        this.globalScope = isWorker(self) ? target : window;
	    }
	    registerMessageHandler(type, handler) {
	        this.messageHandlers[type] = handler;
	    }
	    /**
	     * Sends a message from a main-thread map to a Worker or from a Worker back to
	     * a main-thread map instance.
	     * @param message - the message to send
	     * @param abortController - an optional AbortController to abort the request
	     * @returns a promise that will be resolved with the response data
	     */
	    sendAsync(message, abortController) {
	        return new Promise((resolve, reject) => {
	            // We're using a string ID instead of numbers because they are being used as object keys
	            // anyway, and thus stringified implicitly. We use random IDs because an actor may receive
	            // message from multiple other actors which could run in different execution context. A
	            // linearly increasing ID could produce collisions.
	            const id = Math.round((Math.random() * 1e18)).toString(36).substring(0, 10);
	            this.resolveRejects[id] = {
	                resolve,
	                reject
	            };
	            if (abortController) {
	                abortController.signal.addEventListener('abort', () => {
	                    delete this.resolveRejects[id];
	                    const cancelMessage = {
	                        id,
	                        type: '<cancel>',
	                        origin: location.origin,
	                        targetMapId: message.targetMapId,
	                        sourceMapId: this.mapId
	                    };
	                    this.target.postMessage(cancelMessage);
	                    // In case of abort the current behavior is to keep the promise pending.
	                }, { once: true });
	            }
	            const buffers = [];
	            const messageToPost = Object.assign(Object.assign({}, message), { id, sourceMapId: this.mapId, origin: location.origin, data: serialize(message.data, buffers) });
	            this.target.postMessage(messageToPost, { transfer: buffers });
	        });
	    }
	    receive(message) {
	        const data = message.data;
	        const id = data.id;
	        if (data.origin !== 'file://' && location.origin !== 'file://' && data.origin !== location.origin) {
	            return;
	        }
	        if (data.targetMapId && this.mapId !== data.targetMapId) {
	            return;
	        }
	        if (data.type === '<cancel>') {
	            // Remove the original request from the queue. This is only possible if it
	            // hasn't been kicked off yet. The id will remain in the queue, but because
	            // there is no associated task, it will be dropped once it's time to execute it.
	            delete this.tasks[id];
	            const abortController = this.abortControllers[id];
	            delete this.abortControllers[id];
	            if (abortController) {
	                abortController.abort();
	            }
	            return;
	        }
	        if (isWorker(self) || data.mustQueue) {
	            // In workers, store the tasks that we need to process before actually processing them. This
	            // is necessary because we want to keep receiving messages, and in particular,
	            // <cancel> messages. Some tasks may take a while in the worker thread, so before
	            // executing the next task in our queue, postMessage preempts this and <cancel>
	            // messages can be processed. We're using a MessageChannel object to get throttle the
	            // process() flow to one at a time.
	            this.tasks[id] = data;
	            this.taskQueue.push(id);
	            this.invoker.trigger();
	            return;
	        }
	        // In the main thread, process messages immediately so that other work does not slip in
	        // between getting partial data back from workers.
	        this.processTask(id, data);
	    }
	    process() {
	        if (this.taskQueue.length === 0) {
	            return;
	        }
	        const id = this.taskQueue.shift();
	        const task = this.tasks[id];
	        delete this.tasks[id];
	        // Schedule another process call if we know there's more to process _before_ invoking the
	        // current task. This is necessary so that processing continues even if the current task
	        // doesn't execute successfully.
	        if (this.taskQueue.length > 0) {
	            this.invoker.trigger();
	        }
	        if (!task) {
	            // If the task ID doesn't have associated task data anymore, it was canceled.
	            return;
	        }
	        this.processTask(id, task);
	    }
	    processTask(id, task) {
	        return __awaiter(this, void 0, void 0, function* () {
	            if (task.type === '<response>') {
	                // The `completeTask` function in the counterpart actor has been called, and we are now
	                // resolving or rejecting the promise in the originating actor, if there is one.
	                const resolveReject = this.resolveRejects[id];
	                delete this.resolveRejects[id];
	                if (!resolveReject) {
	                    // If we get a response, but don't have a resolve or reject, the request was canceled.
	                    return;
	                }
	                if (task.error) {
	                    resolveReject.reject(deserialize(task.error));
	                }
	                else {
	                    resolveReject.resolve(deserialize(task.data));
	                }
	                return;
	            }
	            if (!this.messageHandlers[task.type]) {
	                this.completeTask(id, new Error(`Could not find a registered handler for ${task.type}, map ID: ${this.mapId}, available handlers: ${Object.keys(this.messageHandlers).join(', ')}`));
	                return;
	            }
	            const params = deserialize(task.data);
	            const abortController = new AbortController();
	            this.abortControllers[id] = abortController;
	            try {
	                const data = yield this.messageHandlers[task.type](task.sourceMapId, params, abortController);
	                this.completeTask(id, null, data);
	            }
	            catch (err) {
	                this.completeTask(id, err);
	            }
	        });
	    }
	    completeTask(id, err, data) {
	        const buffers = [];
	        delete this.abortControllers[id];
	        const responseMessage = {
	            id,
	            type: '<response>',
	            sourceMapId: this.mapId,
	            origin: location.origin,
	            error: err ? serialize(err) : null,
	            data: serialize(data, buffers)
	        };
	        this.target.postMessage(responseMessage, { transfer: buffers });
	    }
	    remove() {
	        this.invoker.remove();
	        this.subscription.unsubscribe();
	    }
	}

	/*
	* Approximate radius of the earth in meters.
	* Uses the WGS-84 approximation. The radius at the equator is ~6378137 and at the poles is ~6356752. https://en.wikipedia.org/wiki/World_Geodetic_System#WGS84
	* 6371008.8 is one published "average radius" see https://en.wikipedia.org/wiki/Earth_radius#Mean_radius, or ftp://athena.fsv.cvut.cz/ZFG/grs80-Moritz.pdf p.4
	*/
	const earthRadius = 6371008.8;
	/**
	 * A `LngLat` object represents a given longitude and latitude coordinate, measured in degrees.
	 * These coordinates are based on the [WGS84 (EPSG:4326) standard](https://en.wikipedia.org/wiki/World_Geodetic_System#WGS84).
	 *
	 * MapLibre GL JS uses longitude, latitude coordinate order (as opposed to latitude, longitude) to match the
	 * [GeoJSON specification](https://tools.ietf.org/html/rfc7946).
	 *
	 * Note that any MapLibre GL JS method that accepts a `LngLat` object as an argument or option
	 * can also accept an `Array` of two numbers and will perform an implicit conversion.
	 * This flexible type is documented as {@link LngLatLike}.
	 *
	 * @group Geography and Geometry
	 *
	 * @example
	 * ```ts
	 * let ll = new LngLat(-123.9749, 40.7736);
	 * ll.lng; // = -123.9749
	 * ```
	 * @see [Get coordinates of the mouse pointer](https://maplibre.org/maplibre-gl-js/docs/examples/mouse-position/)
	 * @see [Display a popup](https://maplibre.org/maplibre-gl-js/docs/examples/popup/)
	 * @see [Create a timeline animation](https://maplibre.org/maplibre-gl-js/docs/examples/timeline-animation/)
	 */
	class LngLat {
	    /**
	     * @param lng - Longitude, measured in degrees.
	     * @param lat - Latitude, measured in degrees.
	     */
	    constructor(lng, lat) {
	        if (isNaN(lng) || isNaN(lat)) {
	            throw new Error(`Invalid LngLat object: (${lng}, ${lat})`);
	        }
	        this.lng = +lng;
	        this.lat = +lat;
	        if (this.lat > 90 || this.lat < -90) {
	            throw new Error('Invalid LngLat latitude value: must be between -90 and 90');
	        }
	    }
	    /**
	     * Returns a new `LngLat` object whose longitude is wrapped to the range (-180, 180).
	     *
	     * @returns The wrapped `LngLat` object.
	     * @example
	     * ```ts
	     * let ll = new LngLat(286.0251, 40.7736);
	     * let wrapped = ll.wrap();
	     * wrapped.lng; // = -73.9749
	     * ```
	     */
	    wrap() {
	        return new LngLat(wrap(this.lng, -180, 180), this.lat);
	    }
	    /**
	     * Returns the coordinates represented as an array of two numbers.
	     *
	     * @returns The coordinates represented as an array of longitude and latitude.
	     * @example
	     * ```ts
	     * let ll = new LngLat(-73.9749, 40.7736);
	     * ll.toArray(); // = [-73.9749, 40.7736]
	     * ```
	     */
	    toArray() {
	        return [this.lng, this.lat];
	    }
	    /**
	     * Returns the coordinates represent as a string.
	     *
	     * @returns The coordinates represented as a string of the format `'LngLat(lng, lat)'`.
	     * @example
	     * ```ts
	     * let ll = new LngLat(-73.9749, 40.7736);
	     * ll.toString(); // = "LngLat(-73.9749, 40.7736)"
	     * ```
	     */
	    toString() {
	        return `LngLat(${this.lng}, ${this.lat})`;
	    }
	    /**
	     * Returns the approximate distance between a pair of coordinates in meters
	     * Uses the Haversine Formula (from R.W. Sinnott, "Virtues of the Haversine", Sky and Telescope, vol. 68, no. 2, 1984, p. 159)
	     *
	     * @param lngLat - coordinates to compute the distance to
	     * @returns Distance in meters between the two coordinates.
	     * @example
	     * ```ts
	     * let new_york = new LngLat(-74.0060, 40.7128);
	     * let los_angeles = new LngLat(-118.2437, 34.0522);
	     * new_york.distanceTo(los_angeles); // = 3935751.690893987, "true distance" using a non-spherical approximation is ~3966km
	     * ```
	     */
	    distanceTo(lngLat) {
	        const rad = Math.PI / 180;
	        const lat1 = this.lat * rad;
	        const lat2 = lngLat.lat * rad;
	        const a = Math.sin(lat1) * Math.sin(lat2) + Math.cos(lat1) * Math.cos(lat2) * Math.cos((lngLat.lng - this.lng) * rad);
	        const maxMeters = earthRadius * Math.acos(Math.min(a, 1));
	        return maxMeters;
	    }
	    /**
	     * Converts an array of two numbers or an object with `lng` and `lat` or `lon` and `lat` properties
	     * to a `LngLat` object.
	     *
	     * If a `LngLat` object is passed in, the function returns it unchanged.
	     *
	     * @param input - An array of two numbers or object to convert, or a `LngLat` object to return.
	     * @returns A new `LngLat` object, if a conversion occurred, or the original `LngLat` object.
	     * @example
	     * ```ts
	     * let arr = [-73.9749, 40.7736];
	     * let ll = LngLat.convert(arr);
	     * ll;   // = LngLat {lng: -73.9749, lat: 40.7736}
	     * ```
	     */
	    static convert(input) {
	        if (input instanceof LngLat) {
	            return input;
	        }
	        if (Array.isArray(input) && (input.length === 2 || input.length === 3)) {
	            return new LngLat(Number(input[0]), Number(input[1]));
	        }
	        if (!Array.isArray(input) && typeof input === 'object' && input !== null) {
	            return new LngLat(
	            // flow can't refine this to have one of lng or lat, so we have to cast to any
	            Number('lng' in input ? input.lng : input.lon), Number(input.lat));
	        }
	        throw new Error('`LngLatLike` argument must be specified as a LngLat instance, an object {lng: <lng>, lat: <lat>}, an object {lon: <lng>, lat: <lat>}, or an array of [<lng>, <lat>]');
	    }
	}

	/*
	 * The average circumference of the world in meters.
	 */
	const earthCircumfrence = 2 * Math.PI * earthRadius; // meters
	/*
	 * The circumference at a line of latitude in meters.
	 */
	function circumferenceAtLatitude(latitude) {
	    return earthCircumfrence * Math.cos(latitude * Math.PI / 180);
	}
	function mercatorXfromLng(lng) {
	    return (180 + lng) / 360;
	}
	function mercatorYfromLat(lat) {
	    return (180 - (180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + lat * Math.PI / 360)))) / 360;
	}
	function mercatorZfromAltitude(altitude, lat) {
	    return altitude / circumferenceAtLatitude(lat);
	}
	function lngFromMercatorX(x) {
	    return x * 360 - 180;
	}
	function latFromMercatorY(y) {
	    const y2 = 180 - y * 360;
	    return 360 / Math.PI * Math.atan(Math.exp(y2 * Math.PI / 180)) - 90;
	}
	function altitudeFromMercatorZ(z, y) {
	    return z * circumferenceAtLatitude(latFromMercatorY(y));
	}
	/**
	 * Determine the Mercator scale factor for a given latitude, see
	 * https://en.wikipedia.org/wiki/Mercator_projection#Scale_factor
	 *
	 * At the equator the scale factor will be 1, which increases at higher latitudes.
	 *
	 * @param lat - Latitude
	 * @returns scale factor
	 */
	function mercatorScale(lat) {
	    return 1 / Math.cos(lat * Math.PI / 180);
	}
	/**
	 * A `MercatorCoordinate` object represents a projected three dimensional position.
	 *
	 * `MercatorCoordinate` uses the web mercator projection ([EPSG:3857](https://epsg.io/3857)) with slightly different units:
	 *
	 * - the size of 1 unit is the width of the projected world instead of the "mercator meter"
	 * - the origin of the coordinate space is at the north-west corner instead of the middle
	 *
	 * For example, `MercatorCoordinate(0, 0, 0)` is the north-west corner of the mercator world and
	 * `MercatorCoordinate(1, 1, 0)` is the south-east corner. If you are familiar with
	 * [vector tiles](https://github.com/mapbox/vector-tile-spec) it may be helpful to think
	 * of the coordinate space as the `0/0/0` tile with an extent of `1`.
	 *
	 * The `z` dimension of `MercatorCoordinate` is conformal. A cube in the mercator coordinate space would be rendered as a cube.
	 *
	 * @group Geography and Geometry
	 *
	 * @example
	 * ```ts
	 * let nullIsland = new MercatorCoordinate(0.5, 0.5, 0);
	 * ```
	 * @see [Add a custom style layer](https://maplibre.org/maplibre-gl-js/docs/examples/custom-style-layer/)
	 */
	class MercatorCoordinate {
	    /**
	     * @param x - The x component of the position.
	     * @param y - The y component of the position.
	     * @param z - The z component of the position.
	     */
	    constructor(x, y, z = 0) {
	        this.x = +x;
	        this.y = +y;
	        this.z = +z;
	    }
	    /**
	     * Project a `LngLat` to a `MercatorCoordinate`.
	     *
	     * @param lngLatLike - The location to project.
	     * @param altitude - The altitude in meters of the position.
	     * @returns The projected mercator coordinate.
	     * @example
	     * ```ts
	     * let coord = MercatorCoordinate.fromLngLat({ lng: 0, lat: 0}, 0);
	     * coord; // MercatorCoordinate(0.5, 0.5, 0)
	     * ```
	     */
	    static fromLngLat(lngLatLike, altitude = 0) {
	        const lngLat = LngLat.convert(lngLatLike);
	        return new MercatorCoordinate(mercatorXfromLng(lngLat.lng), mercatorYfromLat(lngLat.lat), mercatorZfromAltitude(altitude, lngLat.lat));
	    }
	    /**
	     * Returns the `LngLat` for the coordinate.
	     *
	     * @returns The `LngLat` object.
	     * @example
	     * ```ts
	     * let coord = new MercatorCoordinate(0.5, 0.5, 0);
	     * let lngLat = coord.toLngLat(); // LngLat(0, 0)
	     * ```
	     */
	    toLngLat() {
	        return new LngLat(lngFromMercatorX(this.x), latFromMercatorY(this.y));
	    }
	    /**
	     * Returns the altitude in meters of the coordinate.
	     *
	     * @returns The altitude in meters.
	     * @example
	     * ```ts
	     * let coord = new MercatorCoordinate(0, 0, 0.02);
	     * coord.toAltitude(); // 6914.281956295339
	     * ```
	     */
	    toAltitude() {
	        return altitudeFromMercatorZ(this.z, this.y);
	    }
	    /**
	     * Returns the distance of 1 meter in `MercatorCoordinate` units at this latitude.
	     *
	     * For coordinates in real world units using meters, this naturally provides the scale
	     * to transform into `MercatorCoordinate`s.
	     *
	     * @returns Distance of 1 meter in `MercatorCoordinate` units.
	     */
	    meterInMercatorCoordinateUnits() {
	        // 1 meter / circumference at equator in meters * Mercator projection scale factor at this latitude
	        return 1 / earthCircumfrence * mercatorScale(latFromMercatorY(this.y));
	    }
	}


	/**
	 * getTileBBox
	 *
	 * @param    {Number}  x  Tile coordinate x
	 * @param    {Number}  y  Tile coordinate y
	 * @param    {Number}  z  Tile zoom
	 * @returns  {String}  String of the bounding box
	 */
	function getTileBBox(x, y, z) {
	    // for Google/OSM tile scheme we need to alter the y
	    y = (Math.pow(2, z) - y - 1);

	    var min = getMercCoords(x * 256, y * 256, z),
	        max = getMercCoords((x + 1) * 256, (y + 1) * 256, z);

	    return min[0] + ',' + min[1] + ',' + max[0] + ',' + max[1];
	}


	/**
	 * getMercCoords
	 *
	 * @param    {Number}  x  Pixel coordinate x
	 * @param    {Number}  y  Pixel coordinate y
	 * @param    {Number}  z  Tile zoom
	 * @returns  {Array}   [x, y]
	 */
	function getMercCoords(x, y, z) {
	    var resolution = (2 * Math.PI * 6378137 / 256) / Math.pow(2, z),
	        merc_x = (x * resolution - 2 * Math.PI  * 6378137 / 2.0),
	        merc_y = (y * resolution - 2 * Math.PI  * 6378137 / 2.0);

	    return [merc_x, merc_y];
	}

	/**
	 * A canonical way to define a tile ID
	 */
	class CanonicalTileID {
	    constructor(z, x, y) {
	        if (z < 0 || z > 25 || y < 0 || y >= Math.pow(2, z) || x < 0 || x >= Math.pow(2, z)) {
	            throw new Error(`x=${x}, y=${y}, z=${z} outside of bounds. 0<=x<${Math.pow(2, z)}, 0<=y<${Math.pow(2, z)} 0<=z<=25 `);
	        }
	        this.z = z;
	        this.x = x;
	        this.y = y;
	        this.key = calculateKey(0, z, z, x, y);
	    }
	    equals(id) {
	        return this.z === id.z && this.x === id.x && this.y === id.y;
	    }
	    // given a list of urls, choose a url template and return a tile URL
	    url(urls, pixelRatio, scheme) {
	        const bbox = getTileBBox(this.x, this.y, this.z);
	        const quadkey = getQuadkey(this.z, this.x, this.y);
	        return urls[(this.x + this.y) % urls.length]
	            .replace(/{prefix}/g, (this.x % 16).toString(16) + (this.y % 16).toString(16))
	            .replace(/{z}/g, String(this.z))
	            .replace(/{x}/g, String(this.x))
	            .replace(/{y}/g, String(scheme === 'tms' ? (Math.pow(2, this.z) - this.y - 1) : this.y))
	            .replace(/{ratio}/g, pixelRatio > 1 ? '@2x' : '')
	            .replace(/{quadkey}/g, quadkey)
	            .replace(/{bbox-epsg-3857}/g, bbox);
	    }
	    isChildOf(parent) {
	        const dz = this.z - parent.z;
	        return dz > 0 && parent.x === (this.x >> dz) && parent.y === (this.y >> dz);
	    }
	    getTilePoint(coord) {
	        const tilesAtZoom = Math.pow(2, this.z);
	        return new Point$2((coord.x * tilesAtZoom - this.x) * EXTENT, (coord.y * tilesAtZoom - this.y) * EXTENT);
	    }
	    toString() {
	        return `${this.z}/${this.x}/${this.y}`;
	    }
	}
	/**
	 * @internal
	 * An unwrapped tile identifier
	 */
	class UnwrappedTileID {
	    constructor(wrap, canonical) {
	        this.wrap = wrap;
	        this.canonical = canonical;
	        this.key = calculateKey(wrap, canonical.z, canonical.z, canonical.x, canonical.y);
	    }
	}
	/**
	 * An overscaled tile identifier
	 */
	class OverscaledTileID {
	    constructor(overscaledZ, wrap, z, x, y) {
	        if (overscaledZ < z)
	            throw new Error(`overscaledZ should be >= z; overscaledZ = ${overscaledZ}; z = ${z}`);
	        this.overscaledZ = overscaledZ;
	        this.wrap = wrap;
	        this.canonical = new CanonicalTileID(z, +x, +y);
	        this.key = calculateKey(wrap, overscaledZ, z, x, y);
	    }
	    clone() {
	        return new OverscaledTileID(this.overscaledZ, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y);
	    }
	    equals(id) {
	        return this.overscaledZ === id.overscaledZ && this.wrap === id.wrap && this.canonical.equals(id.canonical);
	    }
	    scaledTo(targetZ) {
	        if (targetZ > this.overscaledZ)
	            throw new Error(`targetZ > this.overscaledZ; targetZ = ${targetZ}; overscaledZ = ${this.overscaledZ}`);
	        const zDifference = this.canonical.z - targetZ;
	        if (targetZ > this.canonical.z) {
	            return new OverscaledTileID(targetZ, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y);
	        }
	        else {
	            return new OverscaledTileID(targetZ, this.wrap, targetZ, this.canonical.x >> zDifference, this.canonical.y >> zDifference);
	        }
	    }
	    /*
	     * calculateScaledKey is an optimization:
	     * when withWrap == true, implements the same as this.scaledTo(z).key,
	     * when withWrap == false, implements the same as this.scaledTo(z).wrapped().key.
	     */
	    calculateScaledKey(targetZ, withWrap) {
	        if (targetZ > this.overscaledZ)
	            throw new Error(`targetZ > this.overscaledZ; targetZ = ${targetZ}; overscaledZ = ${this.overscaledZ}`);
	        const zDifference = this.canonical.z - targetZ;
	        if (targetZ > this.canonical.z) {
	            return calculateKey(this.wrap * +withWrap, targetZ, this.canonical.z, this.canonical.x, this.canonical.y);
	        }
	        else {
	            return calculateKey(this.wrap * +withWrap, targetZ, targetZ, this.canonical.x >> zDifference, this.canonical.y >> zDifference);
	        }
	    }
	    isChildOf(parent) {
	        if (parent.wrap !== this.wrap) {
	            // We can't be a child if we're in a different world copy
	            return false;
	        }
	        const zDifference = this.canonical.z - parent.canonical.z;
	        // We're first testing for z == 0, to avoid a 32 bit shift, which is undefined.
	        return parent.overscaledZ === 0 || (parent.overscaledZ < this.overscaledZ &&
	            parent.canonical.x === (this.canonical.x >> zDifference) &&
	            parent.canonical.y === (this.canonical.y >> zDifference));
	    }
	    children(sourceMaxZoom) {
	        if (this.overscaledZ >= sourceMaxZoom) {
	            // return a single tile coord representing a an overscaled tile
	            return [new OverscaledTileID(this.overscaledZ + 1, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y)];
	        }
	        const z = this.canonical.z + 1;
	        const x = this.canonical.x * 2;
	        const y = this.canonical.y * 2;
	        return [
	            new OverscaledTileID(z, this.wrap, z, x, y),
	            new OverscaledTileID(z, this.wrap, z, x + 1, y),
	            new OverscaledTileID(z, this.wrap, z, x, y + 1),
	            new OverscaledTileID(z, this.wrap, z, x + 1, y + 1)
	        ];
	    }
	    isLessThan(rhs) {
	        if (this.wrap < rhs.wrap)
	            return true;
	        if (this.wrap > rhs.wrap)
	            return false;
	        if (this.overscaledZ < rhs.overscaledZ)
	            return true;
	        if (this.overscaledZ > rhs.overscaledZ)
	            return false;
	        if (this.canonical.x < rhs.canonical.x)
	            return true;
	        if (this.canonical.x > rhs.canonical.x)
	            return false;
	        if (this.canonical.y < rhs.canonical.y)
	            return true;
	        return false;
	    }
	    wrapped() {
	        return new OverscaledTileID(this.overscaledZ, 0, this.canonical.z, this.canonical.x, this.canonical.y);
	    }
	    unwrapTo(wrap) {
	        return new OverscaledTileID(this.overscaledZ, wrap, this.canonical.z, this.canonical.x, this.canonical.y);
	    }
	    overscaleFactor() {
	        return Math.pow(2, this.overscaledZ - this.canonical.z);
	    }
	    toUnwrapped() {
	        return new UnwrappedTileID(this.wrap, this.canonical);
	    }
	    toString() {
	        return `${this.overscaledZ}/${this.canonical.x}/${this.canonical.y}`;
	    }
	    getTilePoint(coord) {
	        return this.canonical.getTilePoint(new MercatorCoordinate(coord.x - this.wrap, coord.y));
	    }
	}
	function calculateKey(wrap, overscaledZ, z, x, y) {
	    wrap *= 2;
	    if (wrap < 0)
	        wrap = wrap * -1 - 1;
	    const dim = 1 << z;
	    return (dim * dim * wrap + dim * y + x).toString(36) + z.toString(36) + overscaledZ.toString(36);
	}
	function getQuadkey(z, x, y) {
	    let quadkey = '', mask;
	    for (let i = z; i > 0; i--) {
	        mask = 1 << (i - 1);
	        quadkey += ((x & mask ? 1 : 0) + (y & mask ? 2 : 0));
	    }
	    return quadkey;
	}
	register('CanonicalTileID', CanonicalTileID);
	register('OverscaledTileID', OverscaledTileID, { omit: ['posMatrix'] });

	/**
	 * DEMData is a data structure for decoding, backfilling, and storing elevation data for processing in the hillshade shaders
	 * data can be populated either from a pngraw image tile or from serliazed data sent back from a worker. When data is initially
	 * loaded from a image tile, we decode the pixel values using the appropriate decoding formula, but we store the
	 * elevation data as an Int32 value. we add 65536 (2^16) to eliminate negative values and enable the use of
	 * integer overflow when creating the texture used in the hillshadePrepare step.
	 *
	 * DEMData also handles the backfilling of data from a tile's neighboring tiles. This is necessary because we use a pixel's 8
	 * surrounding pixel values to compute the slope at that pixel, and we cannot accurately calculate the slope at pixels on a
	 * tile's edge without backfilling from neighboring tiles.
	 */
	class DEMData {
	    /**
	     * Constructs a `DEMData` object
	     * @param uid - the tile's unique id
	     * @param data - RGBAImage data has uniform 1px padding on all sides: square tile edge size defines stride
	    // and dim is calculated as stride - 2.
	     * @param encoding - the encoding type of the data
	     * @param redFactor - the red channel factor used to unpack the data, used for `custom` encoding only
	     * @param greenFactor - the green channel factor used to unpack the data, used for `custom` encoding only
	     * @param blueFactor - the blue channel factor used to unpack the data, used for `custom` encoding only
	     * @param baseShift - the base shift used to unpack the data, used for `custom` encoding only
	     */
	    constructor(uid, data, encoding, redFactor = 1.0, greenFactor = 1.0, blueFactor = 1.0, baseShift = 0.0) {
	        this.uid = uid;
	        if (data.height !== data.width)
	            throw new RangeError('DEM tiles must be square');
	        if (encoding && !['mapbox', 'terrarium', 'custom'].includes(encoding)) {
	            warnOnce(`"${encoding}" is not a valid encoding type. Valid types include "mapbox", "terrarium" and "custom".`);
	            return;
	        }
	        this.stride = data.height;
	        const dim = this.dim = data.height - 2;
	        this.data = new Uint32Array(data.data.buffer);
	        switch (encoding) {
	            case 'terrarium':
	                // unpacking formula for mapzen terrarium:
	                // https://aws.amazon.com/public-datasets/terrain/
	                this.redFactor = 256.0;
	                this.greenFactor = 1.0;
	                this.blueFactor = 1.0 / 256.0;
	                this.baseShift = 32768.0;
	                break;
	            case 'custom':
	                this.redFactor = redFactor;
	                this.greenFactor = greenFactor;
	                this.blueFactor = blueFactor;
	                this.baseShift = baseShift;
	                break;
	            case 'mapbox':
	            default:
	                // unpacking formula for mapbox.terrain-rgb:
	                // https://www.mapbox.com/help/access-elevation-data/#mapbox-terrain-rgb
	                this.redFactor = 6553.6;
	                this.greenFactor = 25.6;
	                this.blueFactor = 0.1;
	                this.baseShift = 10000.0;
	                break;
	        }
	        // in order to avoid flashing seams between tiles, here we are initially populating a 1px border of pixels around the image
	        // with the data of the nearest pixel from the image. this data is eventually replaced when the tile's neighboring
	        // tiles are loaded and the accurate data can be backfilled using DEMData#backfillBorder
	        for (let x = 0; x < dim; x++) {
	            // left vertical border
	            this.data[this._idx(-1, x)] = this.data[this._idx(0, x)];
	            // right vertical border
	            this.data[this._idx(dim, x)] = this.data[this._idx(dim - 1, x)];
	            // left horizontal border
	            this.data[this._idx(x, -1)] = this.data[this._idx(x, 0)];
	            // right horizontal border
	            this.data[this._idx(x, dim)] = this.data[this._idx(x, dim - 1)];
	        }
	        // corners
	        this.data[this._idx(-1, -1)] = this.data[this._idx(0, 0)];
	        this.data[this._idx(dim, -1)] = this.data[this._idx(dim - 1, 0)];
	        this.data[this._idx(-1, dim)] = this.data[this._idx(0, dim - 1)];
	        this.data[this._idx(dim, dim)] = this.data[this._idx(dim - 1, dim - 1)];
	        // calculate min/max values
	        this.min = Number.MAX_SAFE_INTEGER;
	        this.max = Number.MIN_SAFE_INTEGER;
	        for (let x = 0; x < dim; x++) {
	            for (let y = 0; y < dim; y++) {
	                const ele = this.get(x, y);
	                if (ele > this.max)
	                    this.max = ele;
	                if (ele < this.min)
	                    this.min = ele;
	            }
	        }
	    }
	    get(x, y) {
	        const pixels = new Uint8Array(this.data.buffer);
	        const index = this._idx(x, y) * 4;
	        return this.unpack(pixels[index], pixels[index + 1], pixels[index + 2]);
	    }
	    getUnpackVector() {
	        return [this.redFactor, this.greenFactor, this.blueFactor, this.baseShift];
	    }
	    _idx(x, y) {
	        if (x < -1 || x >= this.dim + 1 || y < -1 || y >= this.dim + 1)
	            throw new RangeError('out of range source coordinates for DEM data');
	        return (y + 1) * this.stride + (x + 1);
	    }
	    unpack(r, g, b) {
	        return (r * this.redFactor + g * this.greenFactor + b * this.blueFactor - this.baseShift);
	    }
	    getPixels() {
	        return new RGBAImage({ width: this.stride, height: this.stride }, new Uint8Array(this.data.buffer));
	    }
	    backfillBorder(borderTile, dx, dy) {
	        if (this.dim !== borderTile.dim)
	            throw new Error('dem dimension mismatch');
	        let xMin = dx * this.dim, xMax = dx * this.dim + this.dim, yMin = dy * this.dim, yMax = dy * this.dim + this.dim;
	        switch (dx) {
	            case -1:
	                xMin = xMax - 1;
	                break;
	            case 1:
	                xMax = xMin + 1;
	                break;
	        }
	        switch (dy) {
	            case -1:
	                yMin = yMax - 1;
	                break;
	            case 1:
	                yMax = yMin + 1;
	                break;
	        }
	        const ox = -dx * this.dim;
	        const oy = -dy * this.dim;
	        for (let y = yMin; y < yMax; y++) {
	            for (let x = xMin; x < xMax; x++) {
	                this.data[this._idx(x, y)] = borderTile.data[this._idx(x + ox, y + oy)];
	            }
	        }
	    }
	}
	register('DEMData', DEMData);

	class DictionaryCoder {
	    constructor(strings) {
	        this._stringToNumber = {};
	        this._numberToString = [];
	        for (let i = 0; i < strings.length; i++) {
	            const string = strings[i];
	            this._stringToNumber[string] = i;
	            this._numberToString[i] = string;
	        }
	    }
	    encode(string) {
	        return this._stringToNumber[string];
	    }
	    decode(n) {
	        if (n >= this._numberToString.length)
	            throw new Error(`Out of bounds. Index requested n=${n} can't be >= this._numberToString.length ${this._numberToString.length}`);
	        return this._numberToString[n];
	    }
	}

	/**
	 * A geojson feature
	 */
	class GeoJSONFeature {
	    constructor(vectorTileFeature, z, x, y, id) {
	        this.type = 'Feature';
	        this._vectorTileFeature = vectorTileFeature;
	        vectorTileFeature._z = z;
	        vectorTileFeature._x = x;
	        vectorTileFeature._y = y;
	        this.properties = vectorTileFeature.properties;
	        this.id = id;
	    }
	    get geometry() {
	        if (this._geometry === undefined) {
	            this._geometry = this._vectorTileFeature.toGeoJSON(this._vectorTileFeature._x, this._vectorTileFeature._y, this._vectorTileFeature._z).geometry;
	        }
	        return this._geometry;
	    }
	    set geometry(g) {
	        this._geometry = g;
	    }
	    toJSON() {
	        const json = {
	            geometry: this.geometry
	        };
	        for (const i in this) {
	            if (i === '_geometry' || i === '_vectorTileFeature')
	                continue;
	            json[i] = (this)[i];
	        }
	        return json;
	    }
	}

	/**
	 * An in memory index class to allow fast interaction with features
	 */
	class FeatureIndex {
	    constructor(tileID, promoteId) {
	        this.tileID = tileID;
	        this.x = tileID.canonical.x;
	        this.y = tileID.canonical.y;
	        this.z = tileID.canonical.z;
	        this.grid = new TransferableGridIndex(EXTENT, 16, 0);
	        this.grid3D = new TransferableGridIndex(EXTENT, 16, 0);
	        this.featureIndexArray = new FeatureIndexArray();
	        this.promoteId = promoteId;
	    }
	    insert(feature, geometry, featureIndex, sourceLayerIndex, bucketIndex, is3D) {
	        const key = this.featureIndexArray.length;
	        this.featureIndexArray.emplaceBack(featureIndex, sourceLayerIndex, bucketIndex);
	        const grid = is3D ? this.grid3D : this.grid;
	        for (let r = 0; r < geometry.length; r++) {
	            const ring = geometry[r];
	            const bbox = [Infinity, Infinity, -Infinity, -Infinity];
	            for (let i = 0; i < ring.length; i++) {
	                const p = ring[i];
	                bbox[0] = Math.min(bbox[0], p.x);
	                bbox[1] = Math.min(bbox[1], p.y);
	                bbox[2] = Math.max(bbox[2], p.x);
	                bbox[3] = Math.max(bbox[3], p.y);
	            }
	            if (bbox[0] < EXTENT &&
	                bbox[1] < EXTENT &&
	                bbox[2] >= 0 &&
	                bbox[3] >= 0) {
	                grid.insert(key, bbox[0], bbox[1], bbox[2], bbox[3]);
	            }
	        }
	    }
	    loadVTLayers() {
	        if (!this.vtLayers) {
	            this.vtLayers = new vectorTile.VectorTile(new Protobuf(this.rawTileData)).layers;
	            this.sourceLayerCoder = new DictionaryCoder(this.vtLayers ? Object.keys(this.vtLayers).sort() : ['_geojsonTileLayer']);
	        }
	        return this.vtLayers;
	    }
	    // Finds non-symbol features in this tile at a particular position.
	    query(args, styleLayers, serializedLayers, sourceFeatureState) {
	        this.loadVTLayers();
	        const params = args.params || {}, pixelsToTileUnits = EXTENT / args.tileSize / args.scale, filter = createFilter(params.filter);
	        const queryGeometry = args.queryGeometry;
	        const queryPadding = args.queryPadding * pixelsToTileUnits;
	        const bounds = getBounds(queryGeometry);
	        const matching = this.grid.query(bounds.minX - queryPadding, bounds.minY - queryPadding, bounds.maxX + queryPadding, bounds.maxY + queryPadding);
	        const cameraBounds = getBounds(args.cameraQueryGeometry);
	        const matching3D = this.grid3D.query(cameraBounds.minX - queryPadding, cameraBounds.minY - queryPadding, cameraBounds.maxX + queryPadding, cameraBounds.maxY + queryPadding, (bx1, by1, bx2, by2) => {
	            return polygonIntersectsBox(args.cameraQueryGeometry, bx1 - queryPadding, by1 - queryPadding, bx2 + queryPadding, by2 + queryPadding);
	        });
	        for (const key of matching3D) {
	            matching.push(key);
	        }
	        matching.sort(topDownFeatureComparator);
	        const result = {};
	        let previousIndex;
	        for (let k = 0; k < matching.length; k++) {
	            const index = matching[k];
	            // don't check the same feature more than once
	            if (index === previousIndex)
	                continue;
	            previousIndex = index;
	            const match = this.featureIndexArray.get(index);
	            let featureGeometry = null;
	            this.loadMatchingFeature(result, match.bucketIndex, match.sourceLayerIndex, match.featureIndex, filter, params.layers, params.availableImages, styleLayers, serializedLayers, sourceFeatureState, (feature, styleLayer, featureState) => {
	                if (!featureGeometry) {
	                    featureGeometry = loadGeometry(feature);
	                }
	                return styleLayer.queryIntersectsFeature(queryGeometry, feature, featureState, featureGeometry, this.z, args.transform, pixelsToTileUnits, args.pixelPosMatrix);
	            });
	        }
	        return result;
	    }
	    loadMatchingFeature(result, bucketIndex, sourceLayerIndex, featureIndex, filter, filterLayerIDs, availableImages, styleLayers, serializedLayers, sourceFeatureState, intersectionTest) {
	        const layerIDs = this.bucketLayerIDs[bucketIndex];
	        if (filterLayerIDs && !arraysIntersect(filterLayerIDs, layerIDs))
	            return;
	        const sourceLayerName = this.sourceLayerCoder.decode(sourceLayerIndex);
	        const sourceLayer = this.vtLayers[sourceLayerName];
	        const feature = sourceLayer.feature(featureIndex);
	        if (filter.needGeometry) {
	            const evaluationFeature = toEvaluationFeature(feature, true);
	            if (!filter.filter(new EvaluationParameters(this.tileID.overscaledZ), evaluationFeature, this.tileID.canonical)) {
	                return;
	            }
	        }
	        else if (!filter.filter(new EvaluationParameters(this.tileID.overscaledZ), feature)) {
	            return;
	        }
	        const id = this.getId(feature, sourceLayerName);
	        for (let l = 0; l < layerIDs.length; l++) {
	            const layerID = layerIDs[l];
	            if (filterLayerIDs && filterLayerIDs.indexOf(layerID) < 0) {
	                continue;
	            }
	            const styleLayer = styleLayers[layerID];
	            if (!styleLayer)
	                continue;
	            let featureState = {};
	            if (id && sourceFeatureState) {
	                // `feature-state` expression evaluation requires feature state to be available
	                featureState = sourceFeatureState.getState(styleLayer.sourceLayer || '_geojsonTileLayer', id);
	            }
	            const serializedLayer = extend({}, serializedLayers[layerID]);
	            serializedLayer.paint = evaluateProperties(serializedLayer.paint, styleLayer.paint, feature, featureState, availableImages);
	            serializedLayer.layout = evaluateProperties(serializedLayer.layout, styleLayer.layout, feature, featureState, availableImages);
	            const intersectionZ = !intersectionTest || intersectionTest(feature, styleLayer, featureState);
	            if (!intersectionZ) {
	                // Only applied for non-symbol features
	                continue;
	            }
	            const geojsonFeature = new GeoJSONFeature(feature, this.z, this.x, this.y, id);
	            geojsonFeature.layer = serializedLayer;
	            let layerResult = result[layerID];
	            if (layerResult === undefined) {
	                layerResult = result[layerID] = [];
	            }
	            layerResult.push({ featureIndex, feature: geojsonFeature, intersectionZ });
	        }
	    }
	    // Given a set of symbol indexes that have already been looked up,
	    // return a matching set of GeoJSONFeatures
	    lookupSymbolFeatures(symbolFeatureIndexes, serializedLayers, bucketIndex, sourceLayerIndex, filterSpec, filterLayerIDs, availableImages, styleLayers) {
	        const result = {};
	        this.loadVTLayers();
	        const filter = createFilter(filterSpec);
	        for (const symbolFeatureIndex of symbolFeatureIndexes) {
	            this.loadMatchingFeature(result, bucketIndex, sourceLayerIndex, symbolFeatureIndex, filter, filterLayerIDs, availableImages, styleLayers, serializedLayers);
	        }
	        return result;
	    }
	    hasLayer(id) {
	        for (const layerIDs of this.bucketLayerIDs) {
	            for (const layerID of layerIDs) {
	                if (id === layerID)
	                    return true;
	            }
	        }
	        return false;
	    }
	    getId(feature, sourceLayerId) {
	        let id = feature.id;
	        if (this.promoteId) {
	            const propName = typeof this.promoteId === 'string' ? this.promoteId : this.promoteId[sourceLayerId];
	            id = feature.properties[propName];
	            if (typeof id === 'boolean')
	                id = Number(id);
	        }
	        return id;
	    }
	}
	register('FeatureIndex', FeatureIndex, { omit: ['rawTileData', 'sourceLayerCoder'] });
	function evaluateProperties(serializedProperties, styleLayerProperties, feature, featureState, availableImages) {
	    return mapObject(serializedProperties, (property, key) => {
	        const prop = styleLayerProperties instanceof PossiblyEvaluated ? styleLayerProperties.get(key) : null;
	        return prop && prop.evaluate ? prop.evaluate(feature, featureState, availableImages) : prop;
	    });
	}
	function getBounds(geometry) {
	    let minX = Infinity;
	    let minY = Infinity;
	    let maxX = -Infinity;
	    let maxY = -Infinity;
	    for (const p of geometry) {
	        minX = Math.min(minX, p.x);
	        minY = Math.min(minY, p.y);
	        maxX = Math.max(maxX, p.x);
	        maxY = Math.max(maxY, p.y);
	    }
	    return { minX, minY, maxX, maxY };
	}
	function topDownFeatureComparator(a, b) {
	    return b - a;
	}

	/**
	 * Returns the part of a multiline that intersects with the provided rectangular box.
	 *
	 * @param lines - the lines to check
	 * @param x1 - the left edge of the box
	 * @param y1 - the top edge of the box
	 * @param x2 - the right edge of the box
	 * @param y2 - the bottom edge of the box
	 * @returns lines
	 */
	function clipLine(lines, x1, y1, x2, y2) {
	    const clippedLines = [];
	    for (let l = 0; l < lines.length; l++) {
	        const line = lines[l];
	        let clippedLine;
	        for (let i = 0; i < line.length - 1; i++) {
	            let p0 = line[i];
	            let p1 = line[i + 1];
	            if (p0.x < x1 && p1.x < x1) {
	                continue;
	            }
	            else if (p0.x < x1) {
	                p0 = new Point$2(x1, p0.y + (p1.y - p0.y) * ((x1 - p0.x) / (p1.x - p0.x)))._round();
	            }
	            else if (p1.x < x1) {
	                p1 = new Point$2(x1, p0.y + (p1.y - p0.y) * ((x1 - p0.x) / (p1.x - p0.x)))._round();
	            }
	            if (p0.y < y1 && p1.y < y1) {
	                continue;
	            }
	            else if (p0.y < y1) {
	                p0 = new Point$2(p0.x + (p1.x - p0.x) * ((y1 - p0.y) / (p1.y - p0.y)), y1)._round();
	            }
	            else if (p1.y < y1) {
	                p1 = new Point$2(p0.x + (p1.x - p0.x) * ((y1 - p0.y) / (p1.y - p0.y)), y1)._round();
	            }
	            if (p0.x >= x2 && p1.x >= x2) {
	                continue;
	            }
	            else if (p0.x >= x2) {
	                p0 = new Point$2(x2, p0.y + (p1.y - p0.y) * ((x2 - p0.x) / (p1.x - p0.x)))._round();
	            }
	            else if (p1.x >= x2) {
	                p1 = new Point$2(x2, p0.y + (p1.y - p0.y) * ((x2 - p0.x) / (p1.x - p0.x)))._round();
	            }
	            if (p0.y >= y2 && p1.y >= y2) {
	                continue;
	            }
	            else if (p0.y >= y2) {
	                p0 = new Point$2(p0.x + (p1.x - p0.x) * ((y2 - p0.y) / (p1.y - p0.y)), y2)._round();
	            }
	            else if (p1.y >= y2) {
	                p1 = new Point$2(p0.x + (p1.x - p0.x) * ((y2 - p0.y) / (p1.y - p0.y)), y2)._round();
	            }
	            if (!clippedLine || !p0.equals(clippedLine[clippedLine.length - 1])) {
	                clippedLine = [p0];
	                clippedLines.push(clippedLine);
	            }
	            clippedLine.push(p1);
	        }
	    }
	    return clippedLines;
	}

	class Anchor extends Point$2 {
	    constructor(x, y, angle, segment) {
	        super(x, y);
	        this.angle = angle;
	        if (segment !== undefined) {
	            this.segment = segment;
	        }
	    }
	    clone() {
	        return new Anchor(this.x, this.y, this.angle, this.segment);
	    }
	}
	register('Anchor', Anchor);

	/**
	 * Labels placed around really sharp angles aren't readable. Check if any
	 * part of the potential label has a combined angle that is too big.
	 *
	 * @param line - The line to check
	 * @param anchor - The point on the line around which the label is anchored.
	 * @param labelLength - The length of the label in geometry units.
	 * @param windowSize - The check fails if the combined angles within a part of the line that is `windowSize` long is too big.
	 * @param maxAngle - The maximum combined angle that any window along the label is allowed to have.
	 *
	 * @returns whether the label should be placed
	 */
	function checkMaxAngle(line, anchor, labelLength, windowSize, maxAngle) {
	    // horizontal labels and labels with length 0 always pass
	    if (anchor.segment === undefined || labelLength === 0)
	        return true;
	    let p = anchor;
	    let index = anchor.segment + 1;
	    let anchorDistance = 0;
	    // move backwards along the line to the first segment the label appears on
	    while (anchorDistance > -labelLength / 2) {
	        index--;
	        // there isn't enough room for the label after the beginning of the line
	        if (index < 0)
	            return false;
	        anchorDistance -= line[index].dist(p);
	        p = line[index];
	    }
	    anchorDistance += line[index].dist(line[index + 1]);
	    index++;
	    // store recent corners and their total angle difference
	    const recentCorners = [];
	    let recentAngleDelta = 0;
	    // move forwards by the length of the label and check angles along the way
	    while (anchorDistance < labelLength / 2) {
	        const prev = line[index - 1];
	        const current = line[index];
	        const next = line[index + 1];
	        // there isn't enough room for the label before the end of the line
	        if (!next)
	            return false;
	        let angleDelta = prev.angleTo(current) - current.angleTo(next);
	        // restrict angle to -pi..pi range
	        angleDelta = Math.abs(((angleDelta + 3 * Math.PI) % (Math.PI * 2)) - Math.PI);
	        recentCorners.push({
	            distance: anchorDistance,
	            angleDelta
	        });
	        recentAngleDelta += angleDelta;
	        // remove corners that are far enough away from the list of recent anchors
	        while (anchorDistance - recentCorners[0].distance > windowSize) {
	            recentAngleDelta -= recentCorners.shift().angleDelta;
	        }
	        // the sum of angles within the window area exceeds the maximum allowed value. check fails.
	        if (recentAngleDelta > maxAngle)
	            return false;
	        index++;
	        anchorDistance += current.dist(next);
	    }
	    // no part of the line had an angle greater than the maximum allowed. check passes.
	    return true;
	}

	function getLineLength(line) {
	    let lineLength = 0;
	    for (let k = 0; k < line.length - 1; k++) {
	        lineLength += line[k].dist(line[k + 1]);
	    }
	    return lineLength;
	}
	function getAngleWindowSize(shapedText, glyphSize, boxScale) {
	    return shapedText ?
	        3 / 5 * glyphSize * boxScale :
	        0;
	}
	function getShapedLabelLength(shapedText, shapedIcon) {
	    return Math.max(shapedText ? shapedText.right - shapedText.left : 0, shapedIcon ? shapedIcon.right - shapedIcon.left : 0);
	}
	function getCenterAnchor(line, maxAngle, shapedText, shapedIcon, glyphSize, boxScale) {
	    const angleWindowSize = getAngleWindowSize(shapedText, glyphSize, boxScale);
	    const labelLength = getShapedLabelLength(shapedText, shapedIcon) * boxScale;
	    let prevDistance = 0;
	    const centerDistance = getLineLength(line) / 2;
	    for (let i = 0; i < line.length - 1; i++) {
	        const a = line[i], b = line[i + 1];
	        const segmentDistance = a.dist(b);
	        if (prevDistance + segmentDistance > centerDistance) {
	            // The center is on this segment
	            const t = (centerDistance - prevDistance) / segmentDistance, x = interpolate.number(a.x, b.x, t), y = interpolate.number(a.y, b.y, t);
	            const anchor = new Anchor(x, y, b.angleTo(a), i);
	            anchor._round();
	            if (!angleWindowSize || checkMaxAngle(line, anchor, labelLength, angleWindowSize, maxAngle)) {
	                return anchor;
	            }
	            else {
	                return;
	            }
	        }
	        prevDistance += segmentDistance;
	    }
	}
	function getAnchors(line, spacing, maxAngle, shapedText, shapedIcon, glyphSize, boxScale, overscaling, tileExtent) {
	    // Resample a line to get anchor points for labels and check that each
	    // potential label passes text-max-angle check and has enough froom to fit
	    // on the line.
	    const angleWindowSize = getAngleWindowSize(shapedText, glyphSize, boxScale);
	    const shapedLabelLength = getShapedLabelLength(shapedText, shapedIcon);
	    const labelLength = shapedLabelLength * boxScale;
	    // Is the line continued from outside the tile boundary?
	    const isLineContinued = line[0].x === 0 || line[0].x === tileExtent || line[0].y === 0 || line[0].y === tileExtent;
	    // Is the label long, relative to the spacing?
	    // If so, adjust the spacing so there is always a minimum space of `spacing / 4` between label edges.
	    if (spacing - labelLength < spacing / 4) {
	        spacing = labelLength + spacing / 4;
	    }
	    // Offset the first anchor by:
	    // Either half the label length plus a fixed extra offset if the line is not continued
	    // Or half the spacing if the line is continued.
	    // For non-continued lines, add a bit of fixed extra offset to avoid collisions at T intersections.
	    const fixedExtraOffset = glyphSize * 2;
	    const offset = !isLineContinued ?
	        ((shapedLabelLength / 2 + fixedExtraOffset) * boxScale * overscaling) % spacing :
	        (spacing / 2 * overscaling) % spacing;
	    return resample(line, offset, spacing, angleWindowSize, maxAngle, labelLength, isLineContinued, false, tileExtent);
	}
	function resample(line, offset, spacing, angleWindowSize, maxAngle, labelLength, isLineContinued, placeAtMiddle, tileExtent) {
	    const halfLabelLength = labelLength / 2;
	    const lineLength = getLineLength(line);
	    let distance = 0, markedDistance = offset - spacing;
	    let anchors = [];
	    for (let i = 0; i < line.length - 1; i++) {
	        const a = line[i], b = line[i + 1];
	        const segmentDist = a.dist(b), angle = b.angleTo(a);
	        while (markedDistance + spacing < distance + segmentDist) {
	            markedDistance += spacing;
	            const t = (markedDistance - distance) / segmentDist, x = interpolate.number(a.x, b.x, t), y = interpolate.number(a.y, b.y, t);
	            // Check that the point is within the tile boundaries and that
	            // the label would fit before the beginning and end of the line
	            // if placed at this point.
	            if (x >= 0 && x < tileExtent && y >= 0 && y < tileExtent &&
	                markedDistance - halfLabelLength >= 0 &&
	                markedDistance + halfLabelLength <= lineLength) {
	                const anchor = new Anchor(x, y, angle, i);
	                anchor._round();
	                if (!angleWindowSize || checkMaxAngle(line, anchor, labelLength, angleWindowSize, maxAngle)) {
	                    anchors.push(anchor);
	                }
	            }
	        }
	        distance += segmentDist;
	    }
	    if (!placeAtMiddle && !anchors.length && !isLineContinued) {
	        // The first attempt at finding anchors at which labels can be placed failed.
	        // Try again, but this time just try placing one anchor at the middle of the line.
	        // This has the most effect for short lines in overscaled tiles, since the
	        // initial offset used in overscaled tiles is calculated to align labels with positions in
	        // parent tiles instead of placing the label as close to the beginning as possible.
	        anchors = resample(line, distance / 2, spacing, angleWindowSize, maxAngle, labelLength, isLineContinued, true, tileExtent);
	    }
	    return anchors;
	}

	// If you have a 10px icon that isn't perfectly aligned to the pixel grid it will cover 11 actual
	// pixels. The quad needs to be padded to account for this, otherwise they'll look slightly clipped
	// on one edge in some cases.
	const border = IMAGE_PADDING;
	/**
	 * Create the quads used for rendering an icon.
	 */
	function getIconQuads(shapedIcon, iconRotate, isSDFIcon, hasIconTextFit) {
	    const quads = [];
	    const image = shapedIcon.image;
	    const pixelRatio = image.pixelRatio;
	    const imageWidth = image.paddedRect.w - 2 * border;
	    const imageHeight = image.paddedRect.h - 2 * border;
	    let icon = {
	        x1: shapedIcon.left,
	        y1: shapedIcon.top,
	        x2: shapedIcon.right,
	        y2: shapedIcon.bottom
	    };
	    const stretchX = image.stretchX || [[0, imageWidth]];
	    const stretchY = image.stretchY || [[0, imageHeight]];
	    const reduceRanges = (sum, range) => sum + range[1] - range[0];
	    const stretchWidth = stretchX.reduce(reduceRanges, 0);
	    const stretchHeight = stretchY.reduce(reduceRanges, 0);
	    const fixedWidth = imageWidth - stretchWidth;
	    const fixedHeight = imageHeight - stretchHeight;
	    let stretchOffsetX = 0;
	    let stretchContentWidth = stretchWidth;
	    let stretchOffsetY = 0;
	    let stretchContentHeight = stretchHeight;
	    let fixedOffsetX = 0;
	    let fixedContentWidth = fixedWidth;
	    let fixedOffsetY = 0;
	    let fixedContentHeight = fixedHeight;
	    if (image.content && hasIconTextFit) {
	        const content = image.content;
	        const contentWidth = content[2] - content[0];
	        const contentHeight = content[3] - content[1];
	        // Constrict content area to fit target aspect ratio
	        if (image.contentMatch && image.content) {
	            icon = applyContentMatch(shapedIcon);
	        }
	        stretchOffsetX = sumWithinRange(stretchX, 0, content[0]);
	        stretchOffsetY = sumWithinRange(stretchY, 0, content[1]);
	        stretchContentWidth = sumWithinRange(stretchX, content[0], content[2]);
	        stretchContentHeight = sumWithinRange(stretchY, content[1], content[3]);
	        fixedOffsetX = content[0] - stretchOffsetX;
	        fixedOffsetY = content[1] - stretchOffsetY;
	        fixedContentWidth = contentWidth - stretchContentWidth;
	        fixedContentHeight = contentHeight - stretchContentHeight;
	    }
	    const iconLeft = icon.x1;
	    const iconTop = icon.y1;
	    const iconWidth = icon.x2 - iconLeft;
	    const iconHeight = icon.y2 - iconTop;
	    const makeBox = (left, top, right, bottom) => {
	        const leftEm = getEmOffset(left.stretch - stretchOffsetX, stretchContentWidth, iconWidth, iconLeft);
	        const leftPx = getPxOffset(left.fixed - fixedOffsetX, fixedContentWidth, left.stretch, stretchWidth);
	        const topEm = getEmOffset(top.stretch - stretchOffsetY, stretchContentHeight, iconHeight, iconTop);
	        const topPx = getPxOffset(top.fixed - fixedOffsetY, fixedContentHeight, top.stretch, stretchHeight);
	        const rightEm = getEmOffset(right.stretch - stretchOffsetX, stretchContentWidth, iconWidth, iconLeft);
	        const rightPx = getPxOffset(right.fixed - fixedOffsetX, fixedContentWidth, right.stretch, stretchWidth);
	        const bottomEm = getEmOffset(bottom.stretch - stretchOffsetY, stretchContentHeight, iconHeight, iconTop);
	        const bottomPx = getPxOffset(bottom.fixed - fixedOffsetY, fixedContentHeight, bottom.stretch, stretchHeight);
	        const tl = new Point$2(leftEm, topEm);
	        const tr = new Point$2(rightEm, topEm);
	        const br = new Point$2(rightEm, bottomEm);
	        const bl = new Point$2(leftEm, bottomEm);
	        const pixelOffsetTL = new Point$2(leftPx / pixelRatio, topPx / pixelRatio);
	        const pixelOffsetBR = new Point$2(rightPx / pixelRatio, bottomPx / pixelRatio);
	        const angle = iconRotate * Math.PI / 180;
	        if (angle) {
	            const sin = Math.sin(angle), cos = Math.cos(angle), matrix = [cos, -sin, sin, cos];
	            tl._matMult(matrix);
	            tr._matMult(matrix);
	            bl._matMult(matrix);
	            br._matMult(matrix);
	        }
	        const x1 = left.stretch + left.fixed;
	        const x2 = right.stretch + right.fixed;
	        const y1 = top.stretch + top.fixed;
	        const y2 = bottom.stretch + bottom.fixed;
	        const subRect = {
	            x: image.paddedRect.x + border + x1,
	            y: image.paddedRect.y + border + y1,
	            w: x2 - x1,
	            h: y2 - y1
	        };
	        const minFontScaleX = fixedContentWidth / pixelRatio / iconWidth;
	        const minFontScaleY = fixedContentHeight / pixelRatio / iconHeight;
	        // Icon quad is padded, so texture coordinates also need to be padded.
	        return { tl, tr, bl, br, tex: subRect, writingMode: undefined, glyphOffset: [0, 0], sectionIndex: 0, pixelOffsetTL, pixelOffsetBR, minFontScaleX, minFontScaleY, isSDF: isSDFIcon };
	    };
	    if (!hasIconTextFit || (!image.stretchX && !image.stretchY)) {
	        quads.push(makeBox({ fixed: 0, stretch: -1 }, { fixed: 0, stretch: -1 }, { fixed: 0, stretch: imageWidth + 1 }, { fixed: 0, stretch: imageHeight + 1 }));
	    }
	    else {
	        const xCuts = stretchZonesToCuts(stretchX, fixedWidth, stretchWidth);
	        const yCuts = stretchZonesToCuts(stretchY, fixedHeight, stretchHeight);
	        for (let xi = 0; xi < xCuts.length - 1; xi++) {
	            const x1 = xCuts[xi];
	            const x2 = xCuts[xi + 1];
	            for (let yi = 0; yi < yCuts.length - 1; yi++) {
	                const y1 = yCuts[yi];
	                const y2 = yCuts[yi + 1];
	                quads.push(makeBox(x1, y1, x2, y2));
	            }
	        }
	    }
	    return quads;
	}
	function sumWithinRange(ranges, min, max) {
	    let sum = 0;
	    for (const range of ranges) {
	        sum += Math.max(min, Math.min(max, range[1])) - Math.max(min, Math.min(max, range[0]));
	    }
	    return sum;
	}
	function stretchZonesToCuts(stretchZones, fixedSize, stretchSize) {
	    const cuts = [{ fixed: -border, stretch: 0 }];
	    for (const [c1, c2] of stretchZones) {
	        const last = cuts[cuts.length - 1];
	        cuts.push({
	            fixed: c1 - last.stretch,
	            stretch: last.stretch
	        });
	        cuts.push({
	            fixed: c1 - last.stretch,
	            stretch: last.stretch + (c2 - c1)
	        });
	    }
	    cuts.push({
	        fixed: fixedSize + border,
	        stretch: stretchSize
	    });
	    return cuts;
	}
	function getEmOffset(stretchOffset, stretchSize, iconSize, iconOffset) {
	    return stretchOffset / stretchSize * iconSize + iconOffset;
	}
	function getPxOffset(fixedOffset, fixedSize, stretchOffset, stretchSize) {
	    return fixedOffset - fixedSize * stretchOffset / stretchSize;
	}
	/**
	 * Create the quads used for rendering a text label.
	 */
	function getGlyphQuads(anchor, shaping, textOffset, layer, alongLine, feature, imageMap, allowVerticalPlacement) {
	    const textRotate = layer.layout.get('text-rotate').evaluate(feature, {}) * Math.PI / 180;
	    const quads = [];
	    for (const line of shaping.positionedLines) {
	        for (const positionedGlyph of line.positionedGlyphs) {
	            if (!positionedGlyph.rect)
	                continue;
	            const textureRect = positionedGlyph.rect || {};
	            // The rects have an additional buffer that is not included in their size.
	            const glyphPadding = 1.0;
	            let rectBuffer = GLYPH_PBF_BORDER + glyphPadding;
	            let isSDF = true;
	            let pixelRatio = 1.0;
	            let lineOffset = 0.0;
	            const rotateVerticalGlyph = (alongLine || allowVerticalPlacement) && positionedGlyph.vertical;
	            const halfAdvance = positionedGlyph.metrics.advance * positionedGlyph.scale / 2;
	            // Align images and scaled glyphs in the middle of a vertical line.
	            if (allowVerticalPlacement && shaping.verticalizable) {
	                const scaledGlyphOffset = (positionedGlyph.scale - 1) * ONE_EM;
	                const imageOffset = (ONE_EM - positionedGlyph.metrics.width * positionedGlyph.scale) / 2;
	                lineOffset = line.lineOffset / 2 - (positionedGlyph.imageName ? -imageOffset : scaledGlyphOffset);
	            }
	            if (positionedGlyph.imageName) {
	                const image = imageMap[positionedGlyph.imageName];
	                isSDF = image.sdf;
	                pixelRatio = image.pixelRatio;
	                rectBuffer = IMAGE_PADDING / pixelRatio;
	            }
	            const glyphOffset = alongLine ?
	                [positionedGlyph.x + halfAdvance, positionedGlyph.y] :
	                [0, 0];
	            let builtInOffset = alongLine ?
	                [0, 0] :
	                [positionedGlyph.x + halfAdvance + textOffset[0], positionedGlyph.y + textOffset[1] - lineOffset];
	            let verticalizedLabelOffset = [0, 0];
	            if (rotateVerticalGlyph) {
	                // Vertical POI labels that are rotated 90deg CW and whose glyphs must preserve upright orientation
	                // need to be rotated 90deg CCW. After a quad is rotated, it is translated to the original built-in offset.
	                verticalizedLabelOffset = builtInOffset;
	                builtInOffset = [0, 0];
	            }
	            const textureScale = positionedGlyph.metrics.isDoubleResolution ? 2 : 1;
	            const x1 = (positionedGlyph.metrics.left - rectBuffer) * positionedGlyph.scale - halfAdvance + builtInOffset[0];
	            const y1 = (-positionedGlyph.metrics.top - rectBuffer) * positionedGlyph.scale + builtInOffset[1];
	            const x2 = x1 + textureRect.w / textureScale * positionedGlyph.scale / pixelRatio;
	            const y2 = y1 + textureRect.h / textureScale * positionedGlyph.scale / pixelRatio;
	            const tl = new Point$2(x1, y1);
	            const tr = new Point$2(x2, y1);
	            const bl = new Point$2(x1, y2);
	            const br = new Point$2(x2, y2);
	            if (rotateVerticalGlyph) {
	                // Vertical-supporting glyphs are laid out in 24x24 point boxes (1 square em)
	                // In horizontal orientation, the y values for glyphs are below the midline
	                // and we use a "yOffset" of -17 to pull them up to the middle.
	                // By rotating counter-clockwise around the point at the center of the left
	                // edge of a 24x24 layout box centered below the midline, we align the center
	                // of the glyphs with the horizontal midline, so the yOffset is no longer
	                // necessary, but we also pull the glyph to the left along the x axis.
	                // The y coordinate includes baseline yOffset, thus needs to be accounted
	                // for when glyph is rotated and translated.
	                const center = new Point$2(-halfAdvance, halfAdvance - SHAPING_DEFAULT_OFFSET);
	                const verticalRotation = -Math.PI / 2;
	                // xHalfWidthOffsetCorrection is a difference between full-width and half-width
	                // advance, should be 0 for full-width glyphs and will pull up half-width glyphs.
	                const xHalfWidthOffsetCorrection = ONE_EM / 2 - halfAdvance;
	                const yImageOffsetCorrection = positionedGlyph.imageName ? xHalfWidthOffsetCorrection : 0.0;
	                const halfWidthOffsetCorrection = new Point$2(5 - SHAPING_DEFAULT_OFFSET - xHalfWidthOffsetCorrection, -yImageOffsetCorrection);
	                const verticalOffsetCorrection = new Point$2(...verticalizedLabelOffset);
	                tl._rotateAround(verticalRotation, center)._add(halfWidthOffsetCorrection)._add(verticalOffsetCorrection);
	                tr._rotateAround(verticalRotation, center)._add(halfWidthOffsetCorrection)._add(verticalOffsetCorrection);
	                bl._rotateAround(verticalRotation, center)._add(halfWidthOffsetCorrection)._add(verticalOffsetCorrection);
	                br._rotateAround(verticalRotation, center)._add(halfWidthOffsetCorrection)._add(verticalOffsetCorrection);
	            }
	            if (textRotate) {
	                const sin = Math.sin(textRotate), cos = Math.cos(textRotate), matrix = [cos, -sin, sin, cos];
	                tl._matMult(matrix);
	                tr._matMult(matrix);
	                bl._matMult(matrix);
	                br._matMult(matrix);
	            }
	            const pixelOffsetTL = new Point$2(0, 0);
	            const pixelOffsetBR = new Point$2(0, 0);
	            const minFontScaleX = 0;
	            const minFontScaleY = 0;
	            quads.push({ tl, tr, bl, br, tex: textureRect, writingMode: shaping.writingMode, glyphOffset, sectionIndex: positionedGlyph.sectionIndex, isSDF, pixelOffsetTL, pixelOffsetBR, minFontScaleX, minFontScaleY });
	        }
	    }
	    return quads;
	}

	/**
	 * A CollisionFeature represents the area of the tile covered by a single label.
	 * It is used with CollisionIndex to check if the label overlaps with any
	 * previous labels. A CollisionFeature is mostly just a set of CollisionBox
	 * objects.
	 */
	class CollisionFeature {
	    /**
	     * Create a CollisionFeature, adding its collision box data to the given collisionBoxArray in the process.
	     * For line aligned labels a collision circle diameter is computed instead.
	     *
	     * @param anchor - The point along the line around which the label is anchored.
	     * @param shaped - The text or icon shaping results.
	     * @param boxScale - A magic number used to convert from glyph metrics units to geometry units.
	     * @param padding - The amount of padding to add around the label edges.
	     * @param alignLine - Whether the label is aligned with the line or the viewport.
	     */
	    constructor(collisionBoxArray, anchor, featureIndex, sourceLayerIndex, bucketIndex, shaped, boxScale, padding, alignLine, rotate) {
	        var _a;
	        this.boxStartIndex = collisionBoxArray.length;
	        if (alignLine) {
	            // Compute height of the shape in glyph metrics and apply collision padding.
	            // Note that the pixel based 'text-padding' is applied at runtime
	            let top = shaped.top;
	            let bottom = shaped.bottom;
	            const collisionPadding = shaped.collisionPadding;
	            if (collisionPadding) {
	                top -= collisionPadding[1];
	                bottom += collisionPadding[3];
	            }
	            let height = bottom - top;
	            if (height > 0) {
	                // set minimum box height to avoid very many small labels
	                height = Math.max(10, height);
	                this.circleDiameter = height;
	            }
	        }
	        else {
	            const icon = ((_a = shaped.image) === null || _a === void 0 ? void 0 : _a.contentMatch) && shaped.image.content ?
	                applyContentMatch(shaped) :
	                {
	                    x1: shaped.left,
	                    y1: shaped.top,
	                    x2: shaped.right,
	                    y2: shaped.bottom
	                };
	            // margin is in CSS order: [top, right, bottom, left]
	            icon.y1 = icon.y1 * boxScale - padding[0];
	            icon.x2 = icon.x2 * boxScale + padding[1];
	            icon.y2 = icon.y2 * boxScale + padding[2];
	            icon.x1 = icon.x1 * boxScale - padding[3];
	            const collisionPadding = shaped.collisionPadding;
	            if (collisionPadding) {
	                icon.x1 -= collisionPadding[0] * boxScale;
	                icon.y1 -= collisionPadding[1] * boxScale;
	                icon.x2 += collisionPadding[2] * boxScale;
	                icon.y2 += collisionPadding[3] * boxScale;
	            }
	            if (rotate) {
	                // Account for *-rotate in point collision boxes
	                // See https://github.com/mapbox/mapbox-gl-js/issues/6075
	                // Doesn't account for icon-text-fit
	                const tl = new Point$2(icon.x1, icon.y1);
	                const tr = new Point$2(icon.x2, icon.y1);
	                const bl = new Point$2(icon.x1, icon.y2);
	                const br = new Point$2(icon.x2, icon.y2);
	                const rotateRadians = rotate * Math.PI / 180;
	                tl._rotate(rotateRadians);
	                tr._rotate(rotateRadians);
	                bl._rotate(rotateRadians);
	                br._rotate(rotateRadians);
	                // Collision features require an "on-axis" geometry,
	                // so take the envelope of the rotated geometry
	                // (may be quite large for wide labels rotated 45 degrees)
	                icon.x1 = Math.min(tl.x, tr.x, bl.x, br.x);
	                icon.x2 = Math.max(tl.x, tr.x, bl.x, br.x);
	                icon.y1 = Math.min(tl.y, tr.y, bl.y, br.y);
	                icon.y2 = Math.max(tl.y, tr.y, bl.y, br.y);
	            }
	            collisionBoxArray.emplaceBack(anchor.x, anchor.y, icon.x1, icon.y1, icon.x2, icon.y2, featureIndex, sourceLayerIndex, bucketIndex);
	        }
	        this.boxEndIndex = collisionBoxArray.length;
	    }
	}

	class TinyQueue {
	    constructor(data = [], compare = defaultCompare) {
	        this.data = data;
	        this.length = this.data.length;
	        this.compare = compare;

	        if (this.length > 0) {
	            for (let i = (this.length >> 1) - 1; i >= 0; i--) this._down(i);
	        }
	    }

	    push(item) {
	        this.data.push(item);
	        this.length++;
	        this._up(this.length - 1);
	    }

	    pop() {
	        if (this.length === 0) return undefined;

	        const top = this.data[0];
	        const bottom = this.data.pop();
	        this.length--;

	        if (this.length > 0) {
	            this.data[0] = bottom;
	            this._down(0);
	        }

	        return top;
	    }

	    peek() {
	        return this.data[0];
	    }

	    _up(pos) {
	        const {data, compare} = this;
	        const item = data[pos];

	        while (pos > 0) {
	            const parent = (pos - 1) >> 1;
	            const current = data[parent];
	            if (compare(item, current) >= 0) break;
	            data[pos] = current;
	            pos = parent;
	        }

	        data[pos] = item;
	    }

	    _down(pos) {
	        const {data, compare} = this;
	        const halfLength = this.length >> 1;
	        const item = data[pos];

	        while (pos < halfLength) {
	            let left = (pos << 1) + 1;
	            let best = data[left];
	            const right = left + 1;

	            if (right < this.length && compare(data[right], best) < 0) {
	                left = right;
	                best = data[right];
	            }
	            if (compare(best, item) >= 0) break;

	            data[pos] = best;
	            pos = left;
	        }

	        data[pos] = item;
	    }
	}

	function defaultCompare(a, b) {
	    return a < b ? -1 : a > b ? 1 : 0;
	}

	/**
	 * Finds an approximation of a polygon's Pole Of Inaccessibiliy https://en.wikipedia.org/wiki/Pole_of_inaccessibility
	 * This is a copy of http://github.com/mapbox/polylabel adapted to use Points
	 *
	 * @param polygonRings - first item in array is the outer ring followed optionally by the list of holes, should be an element of the result of util/classify_rings
	 * @param precision - Specified in input coordinate units. If 0 returns after first run, if `> 0` repeatedly narrows the search space until the radius of the area searched for the best pole is less than precision
	 * @param debug - Print some statistics to the console during execution
	 * @returns Pole of Inaccessibiliy.
	 */
	function findPoleOfInaccessibility(polygonRings, precision = 1, debug = false) {
	    // find the bounding box of the outer ring
	    let minX = Infinity, minY = Infinity, maxX = -Infinity, maxY = -Infinity;
	    const outerRing = polygonRings[0];
	    for (let i = 0; i < outerRing.length; i++) {
	        const p = outerRing[i];
	        if (!i || p.x < minX)
	            minX = p.x;
	        if (!i || p.y < minY)
	            minY = p.y;
	        if (!i || p.x > maxX)
	            maxX = p.x;
	        if (!i || p.y > maxY)
	            maxY = p.y;
	    }
	    const width = maxX - minX;
	    const height = maxY - minY;
	    const cellSize = Math.min(width, height);
	    let h = cellSize / 2;
	    // a priority queue of cells in order of their "potential" (max distance to polygon)
	    const cellQueue = new TinyQueue([], compareMax);
	    if (cellSize === 0)
	        return new Point$2(minX, minY);
	    // cover polygon with initial cells
	    for (let x = minX; x < maxX; x += cellSize) {
	        for (let y = minY; y < maxY; y += cellSize) {
	            cellQueue.push(new Cell(x + h, y + h, h, polygonRings));
	        }
	    }
	    // take centroid as the first best guess
	    let bestCell = getCentroidCell(polygonRings);
	    let numProbes = cellQueue.length;
	    while (cellQueue.length) {
	        // pick the most promising cell from the queue
	        const cell = cellQueue.pop();
	        // update the best cell if we found a better one
	        if (cell.d > bestCell.d || !bestCell.d) {
	            bestCell = cell;
	            if (debug)
	                console.log('found best %d after %d probes', Math.round(1e4 * cell.d) / 1e4, numProbes);
	        }
	        // do not drill down further if there's no chance of a better solution
	        if (cell.max - bestCell.d <= precision)
	            continue;
	        // split the cell into four cells
	        h = cell.h / 2;
	        cellQueue.push(new Cell(cell.p.x - h, cell.p.y - h, h, polygonRings));
	        cellQueue.push(new Cell(cell.p.x + h, cell.p.y - h, h, polygonRings));
	        cellQueue.push(new Cell(cell.p.x - h, cell.p.y + h, h, polygonRings));
	        cellQueue.push(new Cell(cell.p.x + h, cell.p.y + h, h, polygonRings));
	        numProbes += 4;
	    }
	    if (debug) {
	        console.log(`num probes: ${numProbes}`);
	        console.log(`best distance: ${bestCell.d}`);
	    }
	    return bestCell.p;
	}
	function compareMax(a, b) {
	    return b.max - a.max;
	}
	function Cell(x, y, h, polygon) {
	    this.p = new Point$2(x, y);
	    this.h = h; // half the cell size
	    this.d = pointToPolygonDist(this.p, polygon); // distance from cell center to polygon
	    this.max = this.d + this.h * Math.SQRT2; // max distance to polygon within a cell
	}
	// signed distance from point to polygon outline (negative if point is outside)
	function pointToPolygonDist(p, polygon) {
	    let inside = false;
	    let minDistSq = Infinity;
	    for (let k = 0; k < polygon.length; k++) {
	        const ring = polygon[k];
	        for (let i = 0, len = ring.length, j = len - 1; i < len; j = i++) {
	            const a = ring[i];
	            const b = ring[j];
	            if ((a.y > p.y !== b.y > p.y) &&
	                (p.x < (b.x - a.x) * (p.y - a.y) / (b.y - a.y) + a.x))
	                inside = !inside;
	            minDistSq = Math.min(minDistSq, distToSegmentSquared(p, a, b));
	        }
	    }
	    return (inside ? 1 : -1) * Math.sqrt(minDistSq);
	}
	// get polygon centroid
	function getCentroidCell(polygon) {
	    let area = 0;
	    let x = 0;
	    let y = 0;
	    const points = polygon[0];
	    for (let i = 0, len = points.length, j = len - 1; i < len; j = i++) {
	        const a = points[i];
	        const b = points[j];
	        const f = a.x * b.y - b.x * a.y;
	        x += (a.x + b.x) * f;
	        y += (a.y + b.y) * f;
	        area += f * 3;
	    }
	    return new Cell(x / area, y / area, 0, polygon);
	}

	exports.TextAnchorEnum = void 0;
	(function (TextAnchorEnum) {
	    TextAnchorEnum[TextAnchorEnum["center"] = 1] = "center";
	    TextAnchorEnum[TextAnchorEnum["left"] = 2] = "left";
	    TextAnchorEnum[TextAnchorEnum["right"] = 3] = "right";
	    TextAnchorEnum[TextAnchorEnum["top"] = 4] = "top";
	    TextAnchorEnum[TextAnchorEnum["bottom"] = 5] = "bottom";
	    TextAnchorEnum[TextAnchorEnum["top-left"] = 6] = "top-left";
	    TextAnchorEnum[TextAnchorEnum["top-right"] = 7] = "top-right";
	    TextAnchorEnum[TextAnchorEnum["bottom-left"] = 8] = "bottom-left";
	    TextAnchorEnum[TextAnchorEnum["bottom-right"] = 9] = "bottom-right";
	})(exports.TextAnchorEnum || (exports.TextAnchorEnum = {}));
	// The radial offset is to the edge of the text box
	// In the horizontal direction, the edge of the text box is where glyphs start
	// But in the vertical direction, the glyphs appear to "start" at the baseline
	// We don't actually load baseline data, but we assume an offset of ONE_EM - 17
	// (see "yOffset" in shaping.js)
	const baselineOffset = 7;
	const INVALID_TEXT_OFFSET = Number.POSITIVE_INFINITY;
	function evaluateVariableOffset(anchor, offset) {
	    function fromRadialOffset(anchor, radialOffset) {
	        let x = 0, y = 0;
	        if (radialOffset < 0)
	            radialOffset = 0; // Ignore negative offset.
	        // solve for r where r^2 + r^2 = radialOffset^2
	        const hypotenuse = radialOffset / Math.SQRT2;
	        switch (anchor) {
	            case 'top-right':
	            case 'top-left':
	                y = hypotenuse - baselineOffset;
	                break;
	            case 'bottom-right':
	            case 'bottom-left':
	                y = -hypotenuse + baselineOffset;
	                break;
	            case 'bottom':
	                y = -radialOffset + baselineOffset;
	                break;
	            case 'top':
	                y = radialOffset - baselineOffset;
	                break;
	        }
	        switch (anchor) {
	            case 'top-right':
	            case 'bottom-right':
	                x = -hypotenuse;
	                break;
	            case 'top-left':
	            case 'bottom-left':
	                x = hypotenuse;
	                break;
	            case 'left':
	                x = radialOffset;
	                break;
	            case 'right':
	                x = -radialOffset;
	                break;
	        }
	        return [x, y];
	    }
	    function fromTextOffset(anchor, offsetX, offsetY) {
	        let x = 0, y = 0;
	        // Use absolute offset values.
	        offsetX = Math.abs(offsetX);
	        offsetY = Math.abs(offsetY);
	        switch (anchor) {
	            case 'top-right':
	            case 'top-left':
	            case 'top':
	                y = offsetY - baselineOffset;
	                break;
	            case 'bottom-right':
	            case 'bottom-left':
	            case 'bottom':
	                y = -offsetY + baselineOffset;
	                break;
	        }
	        switch (anchor) {
	            case 'top-right':
	            case 'bottom-right':
	            case 'right':
	                x = -offsetX;
	                break;
	            case 'top-left':
	            case 'bottom-left':
	            case 'left':
	                x = offsetX;
	                break;
	        }
	        return [x, y];
	    }
	    return (offset[1] !== INVALID_TEXT_OFFSET) ? fromTextOffset(anchor, offset[0], offset[1]) : fromRadialOffset(anchor, offset[0]);
	}
	// Helper to support both text-variable-anchor and text-variable-anchor-offset. Offset values converted from EMs to PXs
	function getTextVariableAnchorOffset(layer, feature, canonical) {
	    var _a;
	    const layout = layer.layout;
	    // If style specifies text-variable-anchor-offset, just return it
	    const variableAnchorOffset = (_a = layout.get('text-variable-anchor-offset')) === null || _a === void 0 ? void 0 : _a.evaluate(feature, {}, canonical);
	    if (variableAnchorOffset) {
	        const sourceValues = variableAnchorOffset.values;
	        const destValues = [];
	        // Convert offsets from EM to PX, and apply baseline shift
	        for (let i = 0; i < sourceValues.length; i += 2) {
	            const anchor = destValues[i] = sourceValues[i];
	            const offset = sourceValues[i + 1].map(t => t * ONE_EM);
	            if (anchor.startsWith('top')) {
	                offset[1] -= baselineOffset;
	            }
	            else if (anchor.startsWith('bottom')) {
	                offset[1] += baselineOffset;
	            }
	            destValues[i + 1] = offset;
	        }
	        return new VariableAnchorOffsetCollection(destValues);
	    }
	    // If style specifies text-variable-anchor, convert to the new format
	    const variableAnchor = layout.get('text-variable-anchor');
	    if (variableAnchor) {
	        let textOffset;
	        const unevaluatedLayout = layer._unevaluatedLayout;
	        // The style spec says don't use `text-offset` and `text-radial-offset` together
	        // but doesn't actually specify what happens if you use both. We go with the radial offset.
	        if (unevaluatedLayout.getValue('text-radial-offset') !== undefined) {
	            textOffset = [layout.get('text-radial-offset').evaluate(feature, {}, canonical) * ONE_EM, INVALID_TEXT_OFFSET];
	        }
	        else {
	            textOffset = layout.get('text-offset').evaluate(feature, {}, canonical).map(t => t * ONE_EM);
	        }
	        const anchorOffsets = [];
	        for (const anchor of variableAnchor) {
	            anchorOffsets.push(anchor, evaluateVariableOffset(anchor, textOffset));
	        }
	        return new VariableAnchorOffsetCollection(anchorOffsets);
	    }
	    return null;
	}

	function performSymbolLayout(args) {
	    args.bucket.createArrays();
	    const tileSize = 512 * args.bucket.overscaling;
	    args.bucket.tilePixelRatio = EXTENT / tileSize;
	    args.bucket.compareText = {};
	    args.bucket.iconsNeedLinear = false;
	    const layer = args.bucket.layers[0];
	    const layout = layer.layout;
	    const unevaluatedLayoutValues = layer._unevaluatedLayout._values;
	    const sizes = {
	        // Filled in below, if *SizeData.kind is 'composite'
	        // compositeIconSizes: undefined,
	        // compositeTextSizes: undefined,
	        layoutIconSize: unevaluatedLayoutValues['icon-size'].possiblyEvaluate(new EvaluationParameters(args.bucket.zoom + 1), args.canonical),
	        layoutTextSize: unevaluatedLayoutValues['text-size'].possiblyEvaluate(new EvaluationParameters(args.bucket.zoom + 1), args.canonical),
	        textMaxSize: unevaluatedLayoutValues['text-size'].possiblyEvaluate(new EvaluationParameters(18))
	    };
	    if (args.bucket.textSizeData.kind === 'composite') {
	        const { minZoom, maxZoom } = args.bucket.textSizeData;
	        sizes.compositeTextSizes = [
	            unevaluatedLayoutValues['text-size'].possiblyEvaluate(new EvaluationParameters(minZoom), args.canonical),
	            unevaluatedLayoutValues['text-size'].possiblyEvaluate(new EvaluationParameters(maxZoom), args.canonical)
	        ];
	    }
	    if (args.bucket.iconSizeData.kind === 'composite') {
	        const { minZoom, maxZoom } = args.bucket.iconSizeData;
	        sizes.compositeIconSizes = [
	            unevaluatedLayoutValues['icon-size'].possiblyEvaluate(new EvaluationParameters(minZoom), args.canonical),
	            unevaluatedLayoutValues['icon-size'].possiblyEvaluate(new EvaluationParameters(maxZoom), args.canonical)
	        ];
	    }
	    const lineHeight = layout.get('text-line-height') * ONE_EM;
	    const textAlongLine = layout.get('text-rotation-alignment') !== 'viewport' && layout.get('symbol-placement') !== 'point';
	    const keepUpright = layout.get('text-keep-upright');
	    const textSize = layout.get('text-size');
	    for (const feature of args.bucket.features) {
	        const fontstack = layout.get('text-font').evaluate(feature, {}, args.canonical).join(',');
	        const layoutTextSizeThisZoom = textSize.evaluate(feature, {}, args.canonical);
	        const layoutTextSize = sizes.layoutTextSize.evaluate(feature, {}, args.canonical);
	        const layoutIconSize = sizes.layoutIconSize.evaluate(feature, {}, args.canonical);
	        const shapedTextOrientations = {
	            horizontal: {},
	            vertical: undefined
	        };
	        const text = feature.text;
	        let textOffset = [0, 0];
	        if (text) {
	            const unformattedText = text.toString();
	            const spacing = layout.get('text-letter-spacing').evaluate(feature, {}, args.canonical) * ONE_EM;
	            const spacingIfAllowed = allowsLetterSpacing(unformattedText) ? spacing : 0;
	            const textAnchor = layout.get('text-anchor').evaluate(feature, {}, args.canonical);
	            const variableAnchorOffset = getTextVariableAnchorOffset(layer, feature, args.canonical);
	            if (!variableAnchorOffset) {
	                const radialOffset = layout.get('text-radial-offset').evaluate(feature, {}, args.canonical);
	                // Layers with variable anchors use the `text-radial-offset` property and the [x, y] offset vector
	                // is calculated at placement time instead of layout time
	                if (radialOffset) {
	                    // The style spec says don't use `text-offset` and `text-radial-offset` together
	                    // but doesn't actually specify what happens if you use both. We go with the radial offset.
	                    textOffset = evaluateVariableOffset(textAnchor, [radialOffset * ONE_EM, INVALID_TEXT_OFFSET]);
	                }
	                else {
	                    textOffset = layout.get('text-offset').evaluate(feature, {}, args.canonical).map(t => t * ONE_EM);
	                }
	            }
	            let textJustify = textAlongLine ?
	                'center' :
	                layout.get('text-justify').evaluate(feature, {}, args.canonical);
	            const symbolPlacement = layout.get('symbol-placement');
	            const maxWidth = symbolPlacement === 'point' ?
	                layout.get('text-max-width').evaluate(feature, {}, args.canonical) * ONE_EM :
	                0;
	            const addVerticalShapingForPointLabelIfNeeded = () => {
	                if (args.bucket.allowVerticalPlacement && allowsVerticalWritingMode(unformattedText)) {
	                    // Vertical POI label placement is meant to be used for scripts that support vertical
	                    // writing mode, thus, default left justification is used. If Latin
	                    // scripts would need to be supported, this should take into account other justifications.
	                    shapedTextOrientations.vertical = shapeText(text, args.glyphMap, args.glyphPositions, args.imagePositions, fontstack, maxWidth, lineHeight, textAnchor, 'left', spacingIfAllowed, textOffset, exports.WritingMode.vertical, true, symbolPlacement, layoutTextSize, layoutTextSizeThisZoom);
	                }
	            };
	            // If this layer uses text-variable-anchor, generate shapings for all justification possibilities.
	            if (!textAlongLine && variableAnchorOffset) {
	                const justifications = new Set();
	                if (textJustify === 'auto') {
	                    for (let i = 0; i < variableAnchorOffset.values.length; i += 2) {
	                        justifications.add(getAnchorJustification(variableAnchorOffset.values[i]));
	                    }
	                }
	                else {
	                    justifications.add(textJustify);
	                }
	                let singleLine = false;
	                for (const justification of justifications) {
	                    if (shapedTextOrientations.horizontal[justification])
	                        continue;
	                    if (singleLine) {
	                        // If the shaping for the first justification was only a single line, we
	                        // can re-use it for the other justifications
	                        shapedTextOrientations.horizontal[justification] = shapedTextOrientations.horizontal[0];
	                    }
	                    else {
	                        // If using text-variable-anchor for the layer, we use a center anchor for all shapings and apply
	                        // the offsets for the anchor in the placement step.
	                        const shaping = shapeText(text, args.glyphMap, args.glyphPositions, args.imagePositions, fontstack, maxWidth, lineHeight, 'center', justification, spacingIfAllowed, textOffset, exports.WritingMode.horizontal, false, symbolPlacement, layoutTextSize, layoutTextSizeThisZoom);
	                        if (shaping) {
	                            shapedTextOrientations.horizontal[justification] = shaping;
	                            singleLine = shaping.positionedLines.length === 1;
	                        }
	                    }
	                }
	                addVerticalShapingForPointLabelIfNeeded();
	            }
	            else {
	                if (textJustify === 'auto') {
	                    textJustify = getAnchorJustification(textAnchor);
	                }
	                // Horizontal point or line label.
	                const shaping = shapeText(text, args.glyphMap, args.glyphPositions, args.imagePositions, fontstack, maxWidth, lineHeight, textAnchor, textJustify, spacingIfAllowed, textOffset, exports.WritingMode.horizontal, false, symbolPlacement, layoutTextSize, layoutTextSizeThisZoom);
	                if (shaping)
	                    shapedTextOrientations.horizontal[textJustify] = shaping;
	                // Vertical point label (if allowVerticalPlacement is enabled).
	                addVerticalShapingForPointLabelIfNeeded();
	                // Verticalized line label.
	                if (allowsVerticalWritingMode(unformattedText) && textAlongLine && keepUpright) {
	                    shapedTextOrientations.vertical = shapeText(text, args.glyphMap, args.glyphPositions, args.imagePositions, fontstack, maxWidth, lineHeight, textAnchor, textJustify, spacingIfAllowed, textOffset, exports.WritingMode.vertical, false, symbolPlacement, layoutTextSize, layoutTextSizeThisZoom);
	                }
	            }
	        }
	        let shapedIcon;
	        let isSDFIcon = false;
	        if (feature.icon && feature.icon.name) {
	            const image = args.imageMap[feature.icon.name];
	            if (image) {
	                shapedIcon = shapeIcon(args.imagePositions[feature.icon.name], layout.get('icon-offset').evaluate(feature, {}, args.canonical), layout.get('icon-anchor').evaluate(feature, {}, args.canonical));
	                // null/undefined SDF property treated same as default (false)
	                isSDFIcon = !!image.sdf;
	                if (args.bucket.sdfIcons === undefined) {
	                    args.bucket.sdfIcons = isSDFIcon;
	                }
	                else if (args.bucket.sdfIcons !== isSDFIcon) {
	                    warnOnce('Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer');
	                }
	                if (image.pixelRatio !== args.bucket.pixelRatio) {
	                    args.bucket.iconsNeedLinear = true;
	                }
	                else if (layout.get('icon-rotate').constantOr(1) !== 0) {
	                    args.bucket.iconsNeedLinear = true;
	                }
	            }
	        }
	        const shapedText = getDefaultHorizontalShaping(shapedTextOrientations.horizontal) || shapedTextOrientations.vertical;
	        args.bucket.iconsInText = shapedText ? shapedText.iconsInText : false;
	        if (shapedText || shapedIcon) {
	            addFeature(args.bucket, feature, shapedTextOrientations, shapedIcon, args.imageMap, sizes, layoutTextSize, layoutIconSize, textOffset, isSDFIcon, args.canonical);
	        }
	    }
	    if (args.showCollisionBoxes) {
	        args.bucket.generateCollisionDebugBuffers();
	    }
	}
	// Choose the justification that matches the direction of the TextAnchor
	function getAnchorJustification(anchor) {
	    switch (anchor) {
	        case 'right':
	        case 'top-right':
	        case 'bottom-right':
	            return 'right';
	        case 'left':
	        case 'top-left':
	        case 'bottom-left':
	            return 'left';
	    }
	    return 'center';
	}
	/**
	 * Given a feature and its shaped text and icon data, add a 'symbol
	 * instance' for each _possible_ placement of the symbol feature.
	 * (At render timePlaceSymbols#place() selects which of these instances to
	 * show or hide based on collisions with symbols in other layers.)
	 */
	function addFeature(bucket, feature, shapedTextOrientations, shapedIcon, imageMap, sizes, layoutTextSize, layoutIconSize, textOffset, isSDFIcon, canonical) {
	    // To reduce the number of labels that jump around when zooming we need
	    // to use a text-size value that is the same for all zoom levels.
	    // bucket calculates text-size at a high zoom level so that all tiles can
	    // use the same value when calculating anchor positions.
	    let textMaxSize = sizes.textMaxSize.evaluate(feature, {});
	    if (textMaxSize === undefined) {
	        textMaxSize = layoutTextSize;
	    }
	    const layout = bucket.layers[0].layout;
	    const iconOffset = layout.get('icon-offset').evaluate(feature, {}, canonical);
	    const defaultHorizontalShaping = getDefaultHorizontalShaping(shapedTextOrientations.horizontal);
	    const glyphSize = 24, fontScale = layoutTextSize / glyphSize, textBoxScale = bucket.tilePixelRatio * fontScale, textMaxBoxScale = bucket.tilePixelRatio * textMaxSize / glyphSize, iconBoxScale = bucket.tilePixelRatio * layoutIconSize, symbolMinDistance = bucket.tilePixelRatio * layout.get('symbol-spacing'), textPadding = layout.get('text-padding') * bucket.tilePixelRatio, iconPadding = getIconPadding(layout, feature, canonical, bucket.tilePixelRatio), textMaxAngle = layout.get('text-max-angle') / 180 * Math.PI, textAlongLine = layout.get('text-rotation-alignment') !== 'viewport' && layout.get('symbol-placement') !== 'point', iconAlongLine = layout.get('icon-rotation-alignment') === 'map' && layout.get('symbol-placement') !== 'point', symbolPlacement = layout.get('symbol-placement'), textRepeatDistance = symbolMinDistance / 2;
	    const iconTextFit = layout.get('icon-text-fit');
	    let verticallyShapedIcon;
	    // Adjust shaped icon size when icon-text-fit is used.
	    if (shapedIcon && iconTextFit !== 'none') {
	        if (bucket.allowVerticalPlacement && shapedTextOrientations.vertical) {
	            verticallyShapedIcon = fitIconToText(shapedIcon, shapedTextOrientations.vertical, iconTextFit, layout.get('icon-text-fit-padding'), iconOffset, fontScale);
	        }
	        if (defaultHorizontalShaping) {
	            shapedIcon = fitIconToText(shapedIcon, defaultHorizontalShaping, iconTextFit, layout.get('icon-text-fit-padding'), iconOffset, fontScale);
	        }
	    }
	    const addSymbolAtAnchor = (line, anchor) => {
	        if (anchor.x < 0 || anchor.x >= EXTENT || anchor.y < 0 || anchor.y >= EXTENT) {
	            // Symbol layers are drawn across tile boundaries, We filter out symbols
	            // outside our tile boundaries (which may be included in vector tile buffers)
	            // to prevent double-drawing symbols.
	            return;
	        }
	        addSymbol(bucket, anchor, line, shapedTextOrientations, shapedIcon, imageMap, verticallyShapedIcon, bucket.layers[0], bucket.collisionBoxArray, feature.index, feature.sourceLayerIndex, bucket.index, textBoxScale, [textPadding, textPadding, textPadding, textPadding], textAlongLine, textOffset, iconBoxScale, iconPadding, iconAlongLine, iconOffset, feature, sizes, isSDFIcon, canonical, layoutTextSize);
	    };
	    if (symbolPlacement === 'line') {
	        for (const line of clipLine(feature.geometry, 0, 0, EXTENT, EXTENT)) {
	            const anchors = getAnchors(line, symbolMinDistance, textMaxAngle, shapedTextOrientations.vertical || defaultHorizontalShaping, shapedIcon, glyphSize, textMaxBoxScale, bucket.overscaling, EXTENT);
	            for (const anchor of anchors) {
	                const shapedText = defaultHorizontalShaping;
	                if (!shapedText || !anchorIsTooClose(bucket, shapedText.text, textRepeatDistance, anchor)) {
	                    addSymbolAtAnchor(line, anchor);
	                }
	            }
	        }
	    }
	    else if (symbolPlacement === 'line-center') {
	        // No clipping, multiple lines per feature are allowed
	        // "lines" with only one point are ignored as in clipLines
	        for (const line of feature.geometry) {
	            if (line.length > 1) {
	                const anchor = getCenterAnchor(line, textMaxAngle, shapedTextOrientations.vertical || defaultHorizontalShaping, shapedIcon, glyphSize, textMaxBoxScale);
	                if (anchor) {
	                    addSymbolAtAnchor(line, anchor);
	                }
	            }
	        }
	    }
	    else if (feature.type === 'Polygon') {
	        for (const polygon of classifyRings$1(feature.geometry, 0)) {
	            // 16 here represents 2 pixels
	            const poi = findPoleOfInaccessibility(polygon, 16);
	            addSymbolAtAnchor(polygon[0], new Anchor(poi.x, poi.y, 0));
	        }
	    }
	    else if (feature.type === 'LineString') {
	        // https://github.com/mapbox/mapbox-gl-js/issues/3808
	        for (const line of feature.geometry) {
	            addSymbolAtAnchor(line, new Anchor(line[0].x, line[0].y, 0));
	        }
	    }
	    else if (feature.type === 'Point') {
	        for (const points of feature.geometry) {
	            for (const point of points) {
	                addSymbolAtAnchor([point], new Anchor(point.x, point.y, 0));
	            }
	        }
	    }
	}
	function addTextVariableAnchorOffsets(textAnchorOffsets, variableAnchorOffset) {
	    const startIndex = textAnchorOffsets.length;
	    const values = variableAnchorOffset === null || variableAnchorOffset === void 0 ? void 0 : variableAnchorOffset.values;
	    if ((values === null || values === void 0 ? void 0 : values.length) > 0) {
	        for (let i = 0; i < values.length; i += 2) {
	            const anchor = exports.TextAnchorEnum[values[i]];
	            const offset = values[i + 1];
	            textAnchorOffsets.emplaceBack(anchor, offset[0], offset[1]);
	        }
	    }
	    return [startIndex, textAnchorOffsets.length];
	}
	function addTextVertices(bucket, anchor, shapedText, imageMap, layer, textAlongLine, feature, textOffset, lineArray, writingMode, placementTypes, placedTextSymbolIndices, placedIconIndex, sizes, canonical) {
	    const glyphQuads = getGlyphQuads(anchor, shapedText, textOffset, layer, textAlongLine, feature, imageMap, bucket.allowVerticalPlacement);
	    const sizeData = bucket.textSizeData;
	    let textSizeData = null;
	    if (sizeData.kind === 'source') {
	        textSizeData = [
	            SIZE_PACK_FACTOR * layer.layout.get('text-size').evaluate(feature, {})
	        ];
	        if (textSizeData[0] > MAX_PACKED_SIZE) {
	            warnOnce(`${bucket.layerIds[0]}: Value for "text-size" is >= ${MAX_GLYPH_ICON_SIZE}. Reduce your "text-size".`);
	        }
	    }
	    else if (sizeData.kind === 'composite') {
	        textSizeData = [
	            SIZE_PACK_FACTOR * sizes.compositeTextSizes[0].evaluate(feature, {}, canonical),
	            SIZE_PACK_FACTOR * sizes.compositeTextSizes[1].evaluate(feature, {}, canonical)
	        ];
	        if (textSizeData[0] > MAX_PACKED_SIZE || textSizeData[1] > MAX_PACKED_SIZE) {
	            warnOnce(`${bucket.layerIds[0]}: Value for "text-size" is >= ${MAX_GLYPH_ICON_SIZE}. Reduce your "text-size".`);
	        }
	    }
	    bucket.addSymbols(bucket.text, glyphQuads, textSizeData, textOffset, textAlongLine, feature, writingMode, anchor, lineArray.lineStartIndex, lineArray.lineLength, placedIconIndex, canonical);
	    // The placedSymbolArray is used at render time in drawTileSymbols
	    // These indices allow access to the array at collision detection time
	    for (const placementType of placementTypes) {
	        placedTextSymbolIndices[placementType] = bucket.text.placedSymbolArray.length - 1;
	    }
	    return glyphQuads.length * 4;
	}
	function getDefaultHorizontalShaping(horizontalShaping) {
	    // We don't care which shaping we get because this is used for collision purposes
	    // and all the justifications have the same collision box
	    for (const justification in horizontalShaping) {
	        return horizontalShaping[justification];
	    }
	    return null;
	}
	/**
	 * Add a single label & icon placement.
	 */
	function addSymbol(bucket, anchor, line, shapedTextOrientations, shapedIcon, imageMap, verticallyShapedIcon, layer, collisionBoxArray, featureIndex, sourceLayerIndex, bucketIndex, textBoxScale, textPadding, textAlongLine, textOffset, iconBoxScale, iconPadding, iconAlongLine, iconOffset, feature, sizes, isSDFIcon, canonical, layoutTextSize) {
	    const lineArray = bucket.addToLineVertexArray(anchor, line);
	    let textCollisionFeature, iconCollisionFeature, verticalTextCollisionFeature, verticalIconCollisionFeature;
	    let numIconVertices = 0;
	    let numVerticalIconVertices = 0;
	    let numHorizontalGlyphVertices = 0;
	    let numVerticalGlyphVertices = 0;
	    let placedIconSymbolIndex = -1;
	    let verticalPlacedIconSymbolIndex = -1;
	    const placedTextSymbolIndices = {};
	    let key = murmur3$1('');
	    if (bucket.allowVerticalPlacement && shapedTextOrientations.vertical) {
	        const textRotation = layer.layout.get('text-rotate').evaluate(feature, {}, canonical);
	        const verticalTextRotation = textRotation + 90.0;
	        const verticalShaping = shapedTextOrientations.vertical;
	        verticalTextCollisionFeature = new CollisionFeature(collisionBoxArray, anchor, featureIndex, sourceLayerIndex, bucketIndex, verticalShaping, textBoxScale, textPadding, textAlongLine, verticalTextRotation);
	        if (verticallyShapedIcon) {
	            verticalIconCollisionFeature = new CollisionFeature(collisionBoxArray, anchor, featureIndex, sourceLayerIndex, bucketIndex, verticallyShapedIcon, iconBoxScale, iconPadding, textAlongLine, verticalTextRotation);
	        }
	    }
	    //Place icon first, so text can have a reference to its index in the placed symbol array.
	    //Text symbols can lazily shift at render-time because of variable anchor placement.
	    //If the style specifies an `icon-text-fit` then the icon would have to shift along with it.
	    // For more info check `updateVariableAnchors` in `draw_symbol.js` .
	    if (shapedIcon) {
	        const iconRotate = layer.layout.get('icon-rotate').evaluate(feature, {});
	        const hasIconTextFit = layer.layout.get('icon-text-fit') !== 'none';
	        const iconQuads = getIconQuads(shapedIcon, iconRotate, isSDFIcon, hasIconTextFit);
	        const verticalIconQuads = verticallyShapedIcon ? getIconQuads(verticallyShapedIcon, iconRotate, isSDFIcon, hasIconTextFit) : undefined;
	        iconCollisionFeature = new CollisionFeature(collisionBoxArray, anchor, featureIndex, sourceLayerIndex, bucketIndex, shapedIcon, iconBoxScale, iconPadding, /*align boxes to line*/ false, iconRotate);
	        numIconVertices = iconQuads.length * 4;
	        const sizeData = bucket.iconSizeData;
	        let iconSizeData = null;
	        if (sizeData.kind === 'source') {
	            iconSizeData = [
	                SIZE_PACK_FACTOR * layer.layout.get('icon-size').evaluate(feature, {})
	            ];
	            if (iconSizeData[0] > MAX_PACKED_SIZE) {
	                warnOnce(`${bucket.layerIds[0]}: Value for "icon-size" is >= ${MAX_GLYPH_ICON_SIZE}. Reduce your "icon-size".`);
	            }
	        }
	        else if (sizeData.kind === 'composite') {
	            iconSizeData = [
	                SIZE_PACK_FACTOR * sizes.compositeIconSizes[0].evaluate(feature, {}, canonical),
	                SIZE_PACK_FACTOR * sizes.compositeIconSizes[1].evaluate(feature, {}, canonical)
	            ];
	            if (iconSizeData[0] > MAX_PACKED_SIZE || iconSizeData[1] > MAX_PACKED_SIZE) {
	                warnOnce(`${bucket.layerIds[0]}: Value for "icon-size" is >= ${MAX_GLYPH_ICON_SIZE}. Reduce your "icon-size".`);
	            }
	        }
	        bucket.addSymbols(bucket.icon, iconQuads, iconSizeData, iconOffset, iconAlongLine, feature, exports.WritingMode.none, anchor, lineArray.lineStartIndex, lineArray.lineLength, 
	        // The icon itself does not have an associated symbol since the text isnt placed yet
	        -1, canonical);
	        placedIconSymbolIndex = bucket.icon.placedSymbolArray.length - 1;
	        if (verticalIconQuads) {
	            numVerticalIconVertices = verticalIconQuads.length * 4;
	            bucket.addSymbols(bucket.icon, verticalIconQuads, iconSizeData, iconOffset, iconAlongLine, feature, exports.WritingMode.vertical, anchor, lineArray.lineStartIndex, lineArray.lineLength, 
	            // The icon itself does not have an associated symbol since the text isnt placed yet
	            -1, canonical);
	            verticalPlacedIconSymbolIndex = bucket.icon.placedSymbolArray.length - 1;
	        }
	    }
	    const justifications = Object.keys(shapedTextOrientations.horizontal);
	    for (const justification of justifications) {
	        const shaping = shapedTextOrientations.horizontal[justification];
	        if (!textCollisionFeature) {
	            key = murmur3$1(shaping.text);
	            const textRotate = layer.layout.get('text-rotate').evaluate(feature, {}, canonical);
	            // As a collision approximation, we can use either the vertical or any of the horizontal versions of the feature
	            // We're counting on all versions having similar dimensions
	            textCollisionFeature = new CollisionFeature(collisionBoxArray, anchor, featureIndex, sourceLayerIndex, bucketIndex, shaping, textBoxScale, textPadding, textAlongLine, textRotate);
	        }
	        const singleLine = shaping.positionedLines.length === 1;
	        numHorizontalGlyphVertices += addTextVertices(bucket, anchor, shaping, imageMap, layer, textAlongLine, feature, textOffset, lineArray, shapedTextOrientations.vertical ? exports.WritingMode.horizontal : exports.WritingMode.horizontalOnly, singleLine ? justifications : [justification], placedTextSymbolIndices, placedIconSymbolIndex, sizes, canonical);
	        if (singleLine) {
	            break;
	        }
	    }
	    if (shapedTextOrientations.vertical) {
	        numVerticalGlyphVertices += addTextVertices(bucket, anchor, shapedTextOrientations.vertical, imageMap, layer, textAlongLine, feature, textOffset, lineArray, exports.WritingMode.vertical, ['vertical'], placedTextSymbolIndices, verticalPlacedIconSymbolIndex, sizes, canonical);
	    }
	    const textBoxStartIndex = textCollisionFeature ? textCollisionFeature.boxStartIndex : bucket.collisionBoxArray.length;
	    const textBoxEndIndex = textCollisionFeature ? textCollisionFeature.boxEndIndex : bucket.collisionBoxArray.length;
	    const verticalTextBoxStartIndex = verticalTextCollisionFeature ? verticalTextCollisionFeature.boxStartIndex : bucket.collisionBoxArray.length;
	    const verticalTextBoxEndIndex = verticalTextCollisionFeature ? verticalTextCollisionFeature.boxEndIndex : bucket.collisionBoxArray.length;
	    const iconBoxStartIndex = iconCollisionFeature ? iconCollisionFeature.boxStartIndex : bucket.collisionBoxArray.length;
	    const iconBoxEndIndex = iconCollisionFeature ? iconCollisionFeature.boxEndIndex : bucket.collisionBoxArray.length;
	    const verticalIconBoxStartIndex = verticalIconCollisionFeature ? verticalIconCollisionFeature.boxStartIndex : bucket.collisionBoxArray.length;
	    const verticalIconBoxEndIndex = verticalIconCollisionFeature ? verticalIconCollisionFeature.boxEndIndex : bucket.collisionBoxArray.length;
	    // Check if runtime collision circles should be used for any of the collision features.
	    // It is enough to choose the tallest feature shape as circles are always placed on a line.
	    // All measurements are in glyph metrics and later converted into pixels using proper font size "layoutTextSize"
	    let collisionCircleDiameter = -1;
	    const getCollisionCircleHeight = (feature, prevHeight) => {
	        if (feature && feature.circleDiameter)
	            return Math.max(feature.circleDiameter, prevHeight);
	        return prevHeight;
	    };
	    collisionCircleDiameter = getCollisionCircleHeight(textCollisionFeature, collisionCircleDiameter);
	    collisionCircleDiameter = getCollisionCircleHeight(verticalTextCollisionFeature, collisionCircleDiameter);
	    collisionCircleDiameter = getCollisionCircleHeight(iconCollisionFeature, collisionCircleDiameter);
	    collisionCircleDiameter = getCollisionCircleHeight(verticalIconCollisionFeature, collisionCircleDiameter);
	    const useRuntimeCollisionCircles = (collisionCircleDiameter > -1) ? 1 : 0;
	    // Convert circle collision height into pixels
	    if (useRuntimeCollisionCircles)
	        collisionCircleDiameter *= layoutTextSize / ONE_EM;
	    if (bucket.glyphOffsetArray.length >= SymbolBucket.MAX_GLYPHS)
	        warnOnce('Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907');
	    if (feature.sortKey !== undefined) {
	        bucket.addToSortKeyRanges(bucket.symbolInstances.length, feature.sortKey);
	    }
	    const variableAnchorOffset = getTextVariableAnchorOffset(layer, feature, canonical);
	    const [textAnchorOffsetStartIndex, textAnchorOffsetEndIndex] = addTextVariableAnchorOffsets(bucket.textAnchorOffsets, variableAnchorOffset);
	    bucket.symbolInstances.emplaceBack(anchor.x, anchor.y, placedTextSymbolIndices.right >= 0 ? placedTextSymbolIndices.right : -1, placedTextSymbolIndices.center >= 0 ? placedTextSymbolIndices.center : -1, placedTextSymbolIndices.left >= 0 ? placedTextSymbolIndices.left : -1, placedTextSymbolIndices.vertical || -1, placedIconSymbolIndex, verticalPlacedIconSymbolIndex, key, textBoxStartIndex, textBoxEndIndex, verticalTextBoxStartIndex, verticalTextBoxEndIndex, iconBoxStartIndex, iconBoxEndIndex, verticalIconBoxStartIndex, verticalIconBoxEndIndex, featureIndex, numHorizontalGlyphVertices, numVerticalGlyphVertices, numIconVertices, numVerticalIconVertices, useRuntimeCollisionCircles, 0, textBoxScale, collisionCircleDiameter, textAnchorOffsetStartIndex, textAnchorOffsetEndIndex);
	}
	function anchorIsTooClose(bucket, text, repeatDistance, anchor) {
	    const compareText = bucket.compareText;
	    if (!(text in compareText)) {
	        compareText[text] = [];
	    }
	    else {
	        const otherAnchors = compareText[text];
	        for (let k = otherAnchors.length - 1; k >= 0; k--) {
	            if (anchor.dist(otherAnchors[k]) < repeatDistance) {
	                // If it's within repeatDistance of one anchor, stop looking
	                return true;
	            }
	        }
	    }
	    // If anchor is not within repeatDistance of any other anchor, add to array
	    compareText[text].push(anchor);
	    return false;
	}

	const ARRAY_TYPES = [
	    Int8Array, Uint8Array, Uint8ClampedArray, Int16Array, Uint16Array,
	    Int32Array, Uint32Array, Float32Array, Float64Array
	];

	/** @typedef {Int8ArrayConstructor | Uint8ArrayConstructor | Uint8ClampedArrayConstructor | Int16ArrayConstructor | Uint16ArrayConstructor | Int32ArrayConstructor | Uint32ArrayConstructor | Float32ArrayConstructor | Float64ArrayConstructor} TypedArrayConstructor */

	const VERSION = 1; // serialized format version
	const HEADER_SIZE = 8;

	class KDBush {

	    /**
	     * Creates an index from raw `ArrayBuffer` data.
	     * @param {ArrayBuffer} data
	     */
	    static from(data) {
	        if (!(data instanceof ArrayBuffer)) {
	            throw new Error('Data must be an instance of ArrayBuffer.');
	        }
	        const [magic, versionAndType] = new Uint8Array(data, 0, 2);
	        if (magic !== 0xdb) {
	            throw new Error('Data does not appear to be in a KDBush format.');
	        }
	        const version = versionAndType >> 4;
	        if (version !== VERSION) {
	            throw new Error(`Got v${version} data when expected v${VERSION}.`);
	        }
	        const ArrayType = ARRAY_TYPES[versionAndType & 0x0f];
	        if (!ArrayType) {
	            throw new Error('Unrecognized array type.');
	        }
	        const [nodeSize] = new Uint16Array(data, 2, 1);
	        const [numItems] = new Uint32Array(data, 4, 1);

	        return new KDBush(numItems, nodeSize, ArrayType, data);
	    }

	    /**
	     * Creates an index that will hold a given number of items.
	     * @param {number} numItems
	     * @param {number} [nodeSize=64] Size of the KD-tree node (64 by default).
	     * @param {TypedArrayConstructor} [ArrayType=Float64Array] The array type used for coordinates storage (`Float64Array` by default).
	     * @param {ArrayBuffer} [data] (For internal use only)
	     */
	    constructor(numItems, nodeSize = 64, ArrayType = Float64Array, data) {
	        if (isNaN(numItems) || numItems < 0) throw new Error(`Unpexpected numItems value: ${numItems}.`);

	        this.numItems = +numItems;
	        this.nodeSize = Math.min(Math.max(+nodeSize, 2), 65535);
	        this.ArrayType = ArrayType;
	        this.IndexArrayType = numItems < 65536 ? Uint16Array : Uint32Array;

	        const arrayTypeIndex = ARRAY_TYPES.indexOf(this.ArrayType);
	        const coordsByteSize = numItems * 2 * this.ArrayType.BYTES_PER_ELEMENT;
	        const idsByteSize = numItems * this.IndexArrayType.BYTES_PER_ELEMENT;
	        const padCoords = (8 - idsByteSize % 8) % 8;

	        if (arrayTypeIndex < 0) {
	            throw new Error(`Unexpected typed array class: ${ArrayType}.`);
	        }

	        if (data && (data instanceof ArrayBuffer)) { // reconstruct an index from a buffer
	            this.data = data;
	            this.ids = new this.IndexArrayType(this.data, HEADER_SIZE, numItems);
	            this.coords = new this.ArrayType(this.data, HEADER_SIZE + idsByteSize + padCoords, numItems * 2);
	            this._pos = numItems * 2;
	            this._finished = true;
	        } else { // initialize a new index
	            this.data = new ArrayBuffer(HEADER_SIZE + coordsByteSize + idsByteSize + padCoords);
	            this.ids = new this.IndexArrayType(this.data, HEADER_SIZE, numItems);
	            this.coords = new this.ArrayType(this.data, HEADER_SIZE + idsByteSize + padCoords, numItems * 2);
	            this._pos = 0;
	            this._finished = false;

	            // set header
	            new Uint8Array(this.data, 0, 2).set([0xdb, (VERSION << 4) + arrayTypeIndex]);
	            new Uint16Array(this.data, 2, 1)[0] = nodeSize;
	            new Uint32Array(this.data, 4, 1)[0] = numItems;
	        }
	    }

	    /**
	     * Add a point to the index.
	     * @param {number} x
	     * @param {number} y
	     * @returns {number} An incremental index associated with the added item (starting from `0`).
	     */
	    add(x, y) {
	        const index = this._pos >> 1;
	        this.ids[index] = index;
	        this.coords[this._pos++] = x;
	        this.coords[this._pos++] = y;
	        return index;
	    }

	    /**
	     * Perform indexing of the added points.
	     */
	    finish() {
	        const numAdded = this._pos >> 1;
	        if (numAdded !== this.numItems) {
	            throw new Error(`Added ${numAdded} items when expected ${this.numItems}.`);
	        }
	        // kd-sort both arrays for efficient search
	        sort(this.ids, this.coords, this.nodeSize, 0, this.numItems - 1, 0);

	        this._finished = true;
	        return this;
	    }

	    /**
	     * Search the index for items within a given bounding box.
	     * @param {number} minX
	     * @param {number} minY
	     * @param {number} maxX
	     * @param {number} maxY
	     * @returns {number[]} An array of indices correponding to the found items.
	     */
	    range(minX, minY, maxX, maxY) {
	        if (!this._finished) throw new Error('Data not yet indexed - call index.finish().');

	        const {ids, coords, nodeSize} = this;
	        const stack = [0, ids.length - 1, 0];
	        const result = [];

	        // recursively search for items in range in the kd-sorted arrays
	        while (stack.length) {
	            const axis = stack.pop() || 0;
	            const right = stack.pop() || 0;
	            const left = stack.pop() || 0;

	            // if we reached "tree node", search linearly
	            if (right - left <= nodeSize) {
	                for (let i = left; i <= right; i++) {
	                    const x = coords[2 * i];
	                    const y = coords[2 * i + 1];
	                    if (x >= minX && x <= maxX && y >= minY && y <= maxY) result.push(ids[i]);
	                }
	                continue;
	            }

	            // otherwise find the middle index
	            const m = (left + right) >> 1;

	            // include the middle item if it's in range
	            const x = coords[2 * m];
	            const y = coords[2 * m + 1];
	            if (x >= minX && x <= maxX && y >= minY && y <= maxY) result.push(ids[m]);

	            // queue search in halves that intersect the query
	            if (axis === 0 ? minX <= x : minY <= y) {
	                stack.push(left);
	                stack.push(m - 1);
	                stack.push(1 - axis);
	            }
	            if (axis === 0 ? maxX >= x : maxY >= y) {
	                stack.push(m + 1);
	                stack.push(right);
	                stack.push(1 - axis);
	            }
	        }

	        return result;
	    }

	    /**
	     * Search the index for items within a given radius.
	     * @param {number} qx
	     * @param {number} qy
	     * @param {number} r Query radius.
	     * @returns {number[]} An array of indices correponding to the found items.
	     */
	    within(qx, qy, r) {
	        if (!this._finished) throw new Error('Data not yet indexed - call index.finish().');

	        const {ids, coords, nodeSize} = this;
	        const stack = [0, ids.length - 1, 0];
	        const result = [];
	        const r2 = r * r;

	        // recursively search for items within radius in the kd-sorted arrays
	        while (stack.length) {
	            const axis = stack.pop() || 0;
	            const right = stack.pop() || 0;
	            const left = stack.pop() || 0;

	            // if we reached "tree node", search linearly
	            if (right - left <= nodeSize) {
	                for (let i = left; i <= right; i++) {
	                    if (sqDist(coords[2 * i], coords[2 * i + 1], qx, qy) <= r2) result.push(ids[i]);
	                }
	                continue;
	            }

	            // otherwise find the middle index
	            const m = (left + right) >> 1;

	            // include the middle item if it's in range
	            const x = coords[2 * m];
	            const y = coords[2 * m + 1];
	            if (sqDist(x, y, qx, qy) <= r2) result.push(ids[m]);

	            // queue search in halves that intersect the query
	            if (axis === 0 ? qx - r <= x : qy - r <= y) {
	                stack.push(left);
	                stack.push(m - 1);
	                stack.push(1 - axis);
	            }
	            if (axis === 0 ? qx + r >= x : qy + r >= y) {
	                stack.push(m + 1);
	                stack.push(right);
	                stack.push(1 - axis);
	            }
	        }

	        return result;
	    }
	}

	/**
	 * @param {Uint16Array | Uint32Array} ids
	 * @param {InstanceType<TypedArrayConstructor>} coords
	 * @param {number} nodeSize
	 * @param {number} left
	 * @param {number} right
	 * @param {number} axis
	 */
	function sort(ids, coords, nodeSize, left, right, axis) {
	    if (right - left <= nodeSize) return;

	    const m = (left + right) >> 1; // middle index

	    // sort ids and coords around the middle index so that the halves lie
	    // either left/right or top/bottom correspondingly (taking turns)
	    select(ids, coords, m, left, right, axis);

	    // recursively kd-sort first half and second half on the opposite axis
	    sort(ids, coords, nodeSize, left, m - 1, 1 - axis);
	    sort(ids, coords, nodeSize, m + 1, right, 1 - axis);
	}

	/**
	 * Custom Floyd-Rivest selection algorithm: sort ids and coords so that
	 * [left..k-1] items are smaller than k-th item (on either x or y axis)
	 * @param {Uint16Array | Uint32Array} ids
	 * @param {InstanceType<TypedArrayConstructor>} coords
	 * @param {number} k
	 * @param {number} left
	 * @param {number} right
	 * @param {number} axis
	 */
	function select(ids, coords, k, left, right, axis) {

	    while (right > left) {
	        if (right - left > 600) {
	            const n = right - left + 1;
	            const m = k - left + 1;
	            const z = Math.log(n);
	            const s = 0.5 * Math.exp(2 * z / 3);
	            const sd = 0.5 * Math.sqrt(z * s * (n - s) / n) * (m - n / 2 < 0 ? -1 : 1);
	            const newLeft = Math.max(left, Math.floor(k - m * s / n + sd));
	            const newRight = Math.min(right, Math.floor(k + (n - m) * s / n + sd));
	            select(ids, coords, k, newLeft, newRight, axis);
	        }

	        const t = coords[2 * k + axis];
	        let i = left;
	        let j = right;

	        swapItem(ids, coords, left, k);
	        if (coords[2 * right + axis] > t) swapItem(ids, coords, left, right);

	        while (i < j) {
	            swapItem(ids, coords, i, j);
	            i++;
	            j--;
	            while (coords[2 * i + axis] < t) i++;
	            while (coords[2 * j + axis] > t) j--;
	        }

	        if (coords[2 * left + axis] === t) swapItem(ids, coords, left, j);
	        else {
	            j++;
	            swapItem(ids, coords, j, right);
	        }

	        if (j <= k) left = j + 1;
	        if (k <= j) right = j - 1;
	    }
	}

	/**
	 * @param {Uint16Array | Uint32Array} ids
	 * @param {InstanceType<TypedArrayConstructor>} coords
	 * @param {number} i
	 * @param {number} j
	 */
	function swapItem(ids, coords, i, j) {
	    swap(ids, i, j);
	    swap(coords, 2 * i, 2 * j);
	    swap(coords, 2 * i + 1, 2 * j + 1);
	}

	/**
	 * @param {InstanceType<TypedArrayConstructor>} arr
	 * @param {number} i
	 * @param {number} j
	 */
	function swap(arr, i, j) {
	    const tmp = arr[i];
	    arr[i] = arr[j];
	    arr[j] = tmp;
	}

	/**
	 * @param {number} ax
	 * @param {number} ay
	 * @param {number} bx
	 * @param {number} by
	 */
	function sqDist(ax, ay, bx, by) {
	    const dx = ax - bx;
	    const dy = ay - by;
	    return dx * dx + dy * dy;
	}

	exports.PerformanceMarkers = void 0;
	(function (PerformanceMarkers) {
	    PerformanceMarkers["create"] = "create";
	    PerformanceMarkers["load"] = "load";
	    PerformanceMarkers["fullLoad"] = "fullLoad";
	})(exports.PerformanceMarkers || (exports.PerformanceMarkers = {}));
	let lastFrameTime = null;
	let frameTimes = [];
	const minFramerateTarget = 60;
	const frameTimeTarget = 1000 / minFramerateTarget;
	const loadTimeKey = 'loadTime';
	const fullLoadTimeKey = 'fullLoadTime';
	const PerformanceUtils = {
	    mark(marker) {
	        performance.mark(marker);
	    },
	    frame(timestamp) {
	        const currTimestamp = timestamp;
	        if (lastFrameTime != null) {
	            const frameTime = currTimestamp - lastFrameTime;
	            frameTimes.push(frameTime);
	        }
	        lastFrameTime = currTimestamp;
	    },
	    clearMetrics() {
	        lastFrameTime = null;
	        frameTimes = [];
	        performance.clearMeasures(loadTimeKey);
	        performance.clearMeasures(fullLoadTimeKey);
	        for (const marker in exports.PerformanceMarkers) {
	            performance.clearMarks(exports.PerformanceMarkers[marker]);
	        }
	    },
	    getPerformanceMetrics() {
	        performance.measure(loadTimeKey, exports.PerformanceMarkers.create, exports.PerformanceMarkers.load);
	        performance.measure(fullLoadTimeKey, exports.PerformanceMarkers.create, exports.PerformanceMarkers.fullLoad);
	        const loadTime = performance.getEntriesByName(loadTimeKey)[0].duration;
	        const fullLoadTime = performance.getEntriesByName(fullLoadTimeKey)[0].duration;
	        const totalFrames = frameTimes.length;
	        const avgFrameTime = frameTimes.reduce((prev, curr) => prev + curr, 0) / totalFrames / 1000;
	        const fps = 1 / avgFrameTime;
	        // count frames that missed our framerate target
	        const droppedFrames = frameTimes
	            .filter((frameTime) => frameTime > frameTimeTarget)
	            .reduce((acc, curr) => {
	            return acc + (curr - frameTimeTarget) / frameTimeTarget;
	        }, 0);
	        const percentDroppedFrames = (droppedFrames / (totalFrames + droppedFrames)) * 100;
	        return {
	            loadTime,
	            fullLoadTime,
	            fps,
	            percentDroppedFrames,
	            totalFrames
	        };
	    }
	};
	/**
	 * @internal
	 * Safe wrapper for the performance resource timing API in web workers with graceful degradation
	 */
	class RequestPerformance {
	    constructor(request) {
	        this._marks = {
	            start: [request.url, 'start'].join('#'),
	            end: [request.url, 'end'].join('#'),
	            measure: request.url.toString()
	        };
	        performance.mark(this._marks.start);
	    }
	    finish() {
	        performance.mark(this._marks.end);
	        let resourceTimingData = performance.getEntriesByName(this._marks.measure);
	        // fallback if web worker implementation of perf.getEntriesByName returns empty
	        if (resourceTimingData.length === 0) {
	            performance.measure(this._marks.measure, this._marks.start, this._marks.end);
	            resourceTimingData = performance.getEntriesByName(this._marks.measure);
	            // cleanup
	            performance.clearMarks(this._marks.start);
	            performance.clearMarks(this._marks.end);
	            performance.clearMeasures(this._marks.measure);
	        }
	        return resourceTimingData;
	    }
	}

	exports.AJAXError = AJAXError;
	exports.Actor = Actor;
	exports.AlphaImage = AlphaImage;
	exports.CanonicalTileID = CanonicalTileID;
	exports.CollisionBoxArray = CollisionBoxArray;
	exports.CollisionCircleLayoutArray = CollisionCircleLayoutArray;
	exports.Color = Color;
	exports.DEMData = DEMData;
	exports.DataConstantProperty = DataConstantProperty;
	exports.DictionaryCoder = DictionaryCoder;
	exports.EXTENT = EXTENT;
	exports.ErrorEvent = ErrorEvent;
	exports.EvaluationParameters = EvaluationParameters;
	exports.Event = Event;
	exports.Evented = Evented;
	exports.FeatureIndex = FeatureIndex;
	exports.FillBucket = FillBucket;
	exports.FillExtrusionBucket = FillExtrusionBucket;
	exports.GLOBAL_DISPATCHER_ID = GLOBAL_DISPATCHER_ID;
	exports.GeoJSONFeature = GeoJSONFeature;
	exports.ImageAtlas = ImageAtlas;
	exports.ImagePosition = ImagePosition;
	exports.KDBush = KDBush;
	exports.LineBucket = LineBucket;
	exports.LineStripIndexArray = LineStripIndexArray;
	exports.LngLat = LngLat;
	exports.MercatorCoordinate = MercatorCoordinate;
	exports.ONE_EM = ONE_EM;
	exports.OverscaledTileID = OverscaledTileID;
	exports.PerformanceUtils = PerformanceUtils;
	exports.Point = Point$2;
	exports.Pos3dArray = Pos3dArray;
	exports.PosArray = PosArray;
	exports.Properties = Properties;
	exports.Protobuf = Protobuf;
	exports.QuadTriangleArray = QuadTriangleArray;
	exports.RGBAImage = RGBAImage;
	exports.RasterBoundsArray = RasterBoundsArray;
	exports.RequestPerformance = RequestPerformance;
	exports.SegmentVector = SegmentVector;
	exports.SymbolBucket = SymbolBucket;
	exports.Transitionable = Transitionable;
	exports.TriangleIndexArray = TriangleIndexArray;
	exports.Uniform1f = Uniform1f;
	exports.Uniform1i = Uniform1i;
	exports.Uniform2f = Uniform2f;
	exports.Uniform3f = Uniform3f;
	exports.Uniform4f = Uniform4f;
	exports.UniformColor = UniformColor;
	exports.UniformMatrix4f = UniformMatrix4f;
	exports.UnwrappedTileID = UnwrappedTileID;
	exports.ValidationError = ValidationError;
	exports.ZoomHistory = ZoomHistory;
	exports.__awaiter = __awaiter;
	exports.add = add$4;
	exports.addDynamicAttributes = addDynamicAttributes;
	exports.addProtocol = addProtocol;
	exports.arrayBufferToImage = arrayBufferToImage;
	exports.arrayBufferToImageBitmap = arrayBufferToImageBitmap;
	exports.bezier = bezier$1;
	exports.clamp = clamp$1;
	exports.clipLine = clipLine;
	exports.clone = clone$5;
	exports.clone$1 = clone$9;
	exports.clone$2 = clone$4;
	exports.collisionCircleLayout = collisionCircleLayout;
	exports.config = config;
	exports.copy = copy$5;
	exports.create = create$5;
	exports.create$1 = create$6;
	exports.create$2 = create$8;
	exports.createAbortError = createAbortError;
	exports.createExpression = createExpression;
	exports.createFilter = createFilter;
	exports.createLayout = createLayout;
	exports.createStyleLayer = createStyleLayer;
	exports.cross = cross$2;
	exports.deepEqual = deepEqual$1;
	exports.defaultEasing = defaultEasing;
	exports.degreesToRadians = degreesToRadians;
	exports.derefLayers = derefLayers;
	exports.diffStyles = diffStyles;
	exports.dot = dot$5;
	exports.dot$1 = dot$4;
	exports.earthRadius = earthRadius;
	exports.emitValidationErrors = emitValidationErrors;
	exports.emptyStyle = emptyStyle;
	exports.equals = equals$6;
	exports.evaluateSizeForFeature = evaluateSizeForFeature;
	exports.evaluateSizeForZoom = evaluateSizeForZoom;
	exports.exactEquals = exactEquals$5;
	exports.extend = extend;
	exports.filterObject = filterObject;
	exports.findLineIntersection = findLineIntersection;
	exports.fromRotation = fromRotation$2;
	exports.fromScaling = fromScaling;
	exports.getAnchorAlignment = getAnchorAlignment;
	exports.getAnchorJustification = getAnchorJustification;
	exports.getArrayBuffer = getArrayBuffer;
	exports.getDefaultExportFromCjs = getDefaultExportFromCjs$1;
	exports.getImageData = getImageData;
	exports.getJSON = getJSON;
	exports.getOverlapMode = getOverlapMode;
	exports.getProtocol = getProtocol;
	exports.getReferrer = getReferrer;
	exports.getVideo = getVideo;
	exports.groupByLayout = groupByLayout;
	exports.identity = identity$2;
	exports.interpolate = interpolate;
	exports.invert = invert$2;
	exports.isAbortError = isAbortError;
	exports.isImageBitmap = isImageBitmap;
	exports.isOffscreenCanvasDistorted = isOffscreenCanvasDistorted;
	exports.isSafari = isSafari;
	exports.isWorker = isWorker;
	exports.keysDifference = keysDifference;
	exports.makeRequest = makeRequest;
	exports.mapObject = mapObject;
	exports.mercatorXfromLng = mercatorXfromLng;
	exports.mercatorYfromLat = mercatorYfromLat;
	exports.mercatorZfromAltitude = mercatorZfromAltitude;
	exports.mul = mul$5;
	exports.mul$1 = mul$3;
	exports.multiply = multiply$5;
	exports.nextPowerOfTwo = nextPowerOfTwo;
	exports.normalize = normalize$4;
	exports.offscreenCanvasSupported = offscreenCanvasSupported;
	exports.ortho = ortho;
	exports.parseCacheControl = parseCacheControl;
	exports.parseGlyphPbf = parseGlyphPbf;
	exports.pbf = pbf;
	exports.performSymbolLayout = performSymbolLayout;
	exports.perspective = perspective;
	exports.pick = pick;
	exports.pointGeometry = pointGeometry;
	exports.polygonIntersectsPolygon = polygonIntersectsPolygon;
	exports.potpack = potpack;
	exports.readImageUsingVideoFrame = readImageUsingVideoFrame;
	exports.register = register;
	exports.removeProtocol = removeProtocol;
	exports.renderColorRamp = renderColorRamp;
	exports.renderStyleImage = renderStyleImage;
	exports.rotate = rotate$4;
	exports.rotateX = rotateX$3;
	exports.rotateZ = rotateZ$3;
	exports.rtlWorkerPlugin = rtlWorkerPlugin;
	exports.sameOrigin = sameOrigin;
	exports.scale = scale$5;
	exports.scale$1 = scale$4;
	exports.sphericalToCartesian = sphericalToCartesian;
	exports.sqrLen = sqrLen;
	exports.sub = sub$2;
	exports.toEvaluationFeature = toEvaluationFeature;
	exports.transformMat3 = transformMat3$1;
	exports.transformMat4 = transformMat4$1;
	exports.transformMat4$1 = transformMat4;
	exports.translate = translate$1;
	exports.unicodeBlockLookup = unicodeBlockLookup;
	exports.uniqueId = uniqueId;
	exports.v8Spec = v8Spec;
	exports.validateCustomStyleLayer = validateCustomStyleLayer;
	exports.validateLight = validateLight;
	exports.validateStyle = validateStyle;
	exports.vectorTile = vectorTile;
	exports.warnOnce = warnOnce;
	exports.wrap = wrap;

	}));

	define('worker', ['./shared'], (function (performance) {
	class StyleLayerIndex {
	    constructor(layerConfigs) {
	        this.keyCache = {};
	        if (layerConfigs) {
	            this.replace(layerConfigs);
	        }
	    }
	    replace(layerConfigs) {
	        this._layerConfigs = {};
	        this._layers = {};
	        this.update(layerConfigs, []);
	    }
	    update(layerConfigs, removedIds) {
	        for (const layerConfig of layerConfigs) {
	            this._layerConfigs[layerConfig.id] = layerConfig;
	            const layer = this._layers[layerConfig.id] = performance.createStyleLayer(layerConfig);
	            layer._featureFilter = performance.createFilter(layer.filter);
	            if (this.keyCache[layerConfig.id])
	                delete this.keyCache[layerConfig.id];
	        }
	        for (const id of removedIds) {
	            delete this.keyCache[id];
	            delete this._layerConfigs[id];
	            delete this._layers[id];
	        }
	        this.familiesBySource = {};
	        const groups = performance.groupByLayout(Object.values(this._layerConfigs), this.keyCache);
	        for (const layerConfigs of groups) {
	            const layers = layerConfigs.map((layerConfig) => this._layers[layerConfig.id]);
	            const layer = layers[0];
	            if (layer.visibility === 'none') {
	                continue;
	            }
	            const sourceId = layer.source || '';
	            let sourceGroup = this.familiesBySource[sourceId];
	            if (!sourceGroup) {
	                sourceGroup = this.familiesBySource[sourceId] = {};
	            }
	            const sourceLayerId = layer.sourceLayer || '_geojsonTileLayer';
	            let sourceLayerFamilies = sourceGroup[sourceLayerId];
	            if (!sourceLayerFamilies) {
	                sourceLayerFamilies = sourceGroup[sourceLayerId] = [];
	            }
	            sourceLayerFamilies.push(layers);
	        }
	    }
	}

	const padding = 1;
	class GlyphAtlas {
	    constructor(stacks) {
	        const positions = {};
	        const bins = [];
	        for (const stack in stacks) {
	            const glyphs = stacks[stack];
	            const stackPositions = positions[stack] = {};
	            for (const id in glyphs) {
	                const src = glyphs[+id];
	                if (!src || src.bitmap.width === 0 || src.bitmap.height === 0)
	                    continue;
	                const bin = {
	                    x: 0,
	                    y: 0,
	                    w: src.bitmap.width + 2 * padding,
	                    h: src.bitmap.height + 2 * padding
	                };
	                bins.push(bin);
	                stackPositions[id] = { rect: bin, metrics: src.metrics };
	            }
	        }
	        const { w, h } = performance.potpack(bins);
	        const image = new performance.AlphaImage({ width: w || 1, height: h || 1 });
	        for (const stack in stacks) {
	            const glyphs = stacks[stack];
	            for (const id in glyphs) {
	                const src = glyphs[+id];
	                if (!src || src.bitmap.width === 0 || src.bitmap.height === 0)
	                    continue;
	                const bin = positions[stack][id].rect;
	                performance.AlphaImage.copy(src.bitmap, image, { x: 0, y: 0 }, { x: bin.x + padding, y: bin.y + padding }, src.bitmap);
	            }
	        }
	        this.image = image;
	        this.positions = positions;
	    }
	}
	performance.register('GlyphAtlas', GlyphAtlas);

	class WorkerTile {
	    constructor(params) {
	        this.tileID = new performance.OverscaledTileID(params.tileID.overscaledZ, params.tileID.wrap, params.tileID.canonical.z, params.tileID.canonical.x, params.tileID.canonical.y);
	        this.uid = params.uid;
	        this.zoom = params.zoom;
	        this.pixelRatio = params.pixelRatio;
	        this.tileSize = params.tileSize;
	        this.source = params.source;
	        this.overscaling = this.tileID.overscaleFactor();
	        this.showCollisionBoxes = params.showCollisionBoxes;
	        this.collectResourceTiming = !!params.collectResourceTiming;
	        this.returnDependencies = !!params.returnDependencies;
	        this.promoteId = params.promoteId;
	        this.inFlightDependencies = [];
	    }
	    parse(data, layerIndex, availableImages, actor) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            this.status = 'parsing';
	            this.data = data;
	            this.collisionBoxArray = new performance.CollisionBoxArray();
	            const sourceLayerCoder = new performance.DictionaryCoder(Object.keys(data.layers).sort());
	            const featureIndex = new performance.FeatureIndex(this.tileID, this.promoteId);
	            featureIndex.bucketLayerIDs = [];
	            const buckets = {};
	            const options = {
	                featureIndex,
	                iconDependencies: {},
	                patternDependencies: {},
	                glyphDependencies: {},
	                availableImages
	            };
	            const layerFamilies = layerIndex.familiesBySource[this.source];
	            for (const sourceLayerId in layerFamilies) {
	                const sourceLayer = data.layers[sourceLayerId];
	                if (!sourceLayer) {
	                    continue;
	                }
	                if (sourceLayer.version === 1) {
	                    performance.warnOnce(`Vector tile source "${this.source}" layer "${sourceLayerId}" ` +
	                        'does not use vector tile spec v2 and therefore may have some rendering errors.');
	                }
	                const sourceLayerIndex = sourceLayerCoder.encode(sourceLayerId);
	                const features = [];
	                for (let index = 0; index < sourceLayer.length; index++) {
	                    const feature = sourceLayer.feature(index);
	                    const id = featureIndex.getId(feature, sourceLayerId);
	                    features.push({ feature, id, index, sourceLayerIndex });
	                }
	                for (const family of layerFamilies[sourceLayerId]) {
	                    const layer = family[0];
	                    if (layer.source !== this.source) {
	                        performance.warnOnce(`layer.source = ${layer.source} does not equal this.source = ${this.source}`);
	                    }
	                    if (layer.minzoom && this.zoom < Math.floor(layer.minzoom))
	                        continue;
	                    if (layer.maxzoom && this.zoom >= layer.maxzoom)
	                        continue;
	                    if (layer.visibility === 'none')
	                        continue;
	                    recalculateLayers(family, this.zoom, availableImages);
	                    const bucket = buckets[layer.id] = layer.createBucket({
	                        index: featureIndex.bucketLayerIDs.length,
	                        layers: family,
	                        zoom: this.zoom,
	                        pixelRatio: this.pixelRatio,
	                        overscaling: this.overscaling,
	                        collisionBoxArray: this.collisionBoxArray,
	                        sourceLayerIndex,
	                        sourceID: this.source
	                    });
	                    bucket.populate(features, options, this.tileID.canonical);
	                    featureIndex.bucketLayerIDs.push(family.map((l) => l.id));
	                }
	            }
	            // options.glyphDependencies looks like: {"SomeFontName":{"10":true,"32":true}}
	            // this line makes an object like: {"SomeFontName":[10,32]}
	            const stacks = performance.mapObject(options.glyphDependencies, (glyphs) => Object.keys(glyphs).map(Number));
	            this.inFlightDependencies.forEach((request) => request === null || request === void 0 ? void 0 : request.abort());
	            this.inFlightDependencies = [];
	            let getGlyphsPromise = Promise.resolve({});
	            if (Object.keys(stacks).length) {
	                const abortController = new AbortController();
	                this.inFlightDependencies.push(abortController);
	                getGlyphsPromise = actor.sendAsync({ type: "GG" /* MessageType.getGlyphs */, data: { stacks, source: this.source, tileID: this.tileID, type: 'glyphs' } }, abortController);
	            }
	            const icons = Object.keys(options.iconDependencies);
	            let getIconsPromise = Promise.resolve({});
	            if (icons.length) {
	                const abortController = new AbortController();
	                this.inFlightDependencies.push(abortController);
	                getIconsPromise = actor.sendAsync({ type: "GI" /* MessageType.getImages */, data: { icons, source: this.source, tileID: this.tileID, type: 'icons' } }, abortController);
	            }
	            const patterns = Object.keys(options.patternDependencies);
	            let getPatternsPromise = Promise.resolve({});
	            if (patterns.length) {
	                const abortController = new AbortController();
	                this.inFlightDependencies.push(abortController);
	                getPatternsPromise = actor.sendAsync({ type: "GI" /* MessageType.getImages */, data: { icons: patterns, source: this.source, tileID: this.tileID, type: 'patterns' } }, abortController);
	            }
	            const [glyphMap, iconMap, patternMap] = yield Promise.all([getGlyphsPromise, getIconsPromise, getPatternsPromise]);
	            const glyphAtlas = new GlyphAtlas(glyphMap);
	            const imageAtlas = new performance.ImageAtlas(iconMap, patternMap);
	            for (const key in buckets) {
	                const bucket = buckets[key];
	                if (bucket instanceof performance.SymbolBucket) {
	                    recalculateLayers(bucket.layers, this.zoom, availableImages);
	                    performance.performSymbolLayout({
	                        bucket,
	                        glyphMap,
	                        glyphPositions: glyphAtlas.positions,
	                        imageMap: iconMap,
	                        imagePositions: imageAtlas.iconPositions,
	                        showCollisionBoxes: this.showCollisionBoxes,
	                        canonical: this.tileID.canonical
	                    });
	                }
	                else if (bucket.hasPattern &&
	                    (bucket instanceof performance.LineBucket ||
	                        bucket instanceof performance.FillBucket ||
	                        bucket instanceof performance.FillExtrusionBucket)) {
	                    recalculateLayers(bucket.layers, this.zoom, availableImages);
	                    bucket.addFeatures(options, this.tileID.canonical, imageAtlas.patternPositions);
	                }
	            }
	            this.status = 'done';
	            return {
	                buckets: Object.values(buckets).filter(b => !b.isEmpty()),
	                featureIndex,
	                collisionBoxArray: this.collisionBoxArray,
	                glyphAtlasImage: glyphAtlas.image,
	                imageAtlas,
	                // Only used for benchmarking:
	                glyphMap: this.returnDependencies ? glyphMap : null,
	                iconMap: this.returnDependencies ? iconMap : null,
	                glyphPositions: this.returnDependencies ? glyphAtlas.positions : null
	            };
	        });
	    }
	}
	function recalculateLayers(layers, zoom, availableImages) {
	    // Layers are shared and may have been used by a WorkerTile with a different zoom.
	    const parameters = new performance.EvaluationParameters(zoom);
	    for (const layer of layers) {
	        layer.recalculate(parameters, availableImages);
	    }
	}

	/**
	 * The {@link WorkerSource} implementation that supports {@link VectorTileSource}.
	 * This class is designed to be easily reused to support custom source types
	 * for data formats that can be parsed/converted into an in-memory VectorTile
	 * representation. To do so, override its `loadVectorTile` method.
	 */
	class VectorTileWorkerSource {
	    /**
	     * @param loadVectorData - Optional method for custom loading of a VectorTile
	     * object based on parameters passed from the main-thread Source. See
	     * {@link VectorTileWorkerSource#loadTile}. The default implementation simply
	     * loads the pbf at `params.url`.
	     */
	    constructor(actor, layerIndex, availableImages) {
	        this.actor = actor;
	        this.layerIndex = layerIndex;
	        this.availableImages = availableImages;
	        this.fetching = {};
	        this.loading = {};
	        this.loaded = {};
	    }
	    /**
	     * Loads a vector tile
	     */
	    loadVectorTile(params, abortController) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            const response = yield performance.getArrayBuffer(params.request, abortController);
	            try {
	                const vectorTile = new performance.vectorTile.VectorTile(new performance.Protobuf(response.data));
	                return {
	                    vectorTile,
	                    rawData: response.data,
	                    cacheControl: response.cacheControl,
	                    expires: response.expires
	                };
	            }
	            catch (ex) {
	                const bytes = new Uint8Array(response.data);
	                const isGzipped = bytes[0] === 0x1f && bytes[1] === 0x8b;
	                let errorMessage = `Unable to parse the tile at ${params.request.url}, `;
	                if (isGzipped) {
	                    errorMessage += 'please make sure the data is not gzipped and that you have configured the relevant header in the server';
	                }
	                else {
	                    errorMessage += `got error: ${ex.messge}`;
	                }
	                throw new Error(errorMessage);
	            }
	        });
	    }
	    /**
	     * Implements {@link WorkerSource#loadTile}. Delegates to
	     * {@link VectorTileWorkerSource#loadVectorData} (which by default expects
	     * a `params.url` property) for fetching and producing a VectorTile object.
	     */
	    loadTile(params) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            const tileUid = params.uid;
	            const perf = (params && params.request && params.request.collectResourceTiming) ?
	                new performance.RequestPerformance(params.request) : false;
	            const workerTile = new WorkerTile(params);
	            this.loading[tileUid] = workerTile;
	            const abortController = new AbortController();
	            workerTile.abort = abortController;
	            try {
	                const response = yield this.loadVectorTile(params, abortController);
	                delete this.loading[tileUid];
	                if (!response) {
	                    return null;
	                }
	                const rawTileData = response.rawData;
	                const cacheControl = {};
	                if (response.expires)
	                    cacheControl.expires = response.expires;
	                if (response.cacheControl)
	                    cacheControl.cacheControl = response.cacheControl;
	                const resourceTiming = {};
	                if (perf) {
	                    const resourceTimingData = perf.finish();
	                    // it's necessary to eval the result of getEntriesByName() here via parse/stringify
	                    // late evaluation in the main thread causes TypeError: illegal invocation
	                    if (resourceTimingData)
	                        resourceTiming.resourceTiming = JSON.parse(JSON.stringify(resourceTimingData));
	                }
	                workerTile.vectorTile = response.vectorTile;
	                const parsePromise = workerTile.parse(response.vectorTile, this.layerIndex, this.availableImages, this.actor);
	                this.loaded[tileUid] = workerTile;
	                // keep the original fetching state so that reload tile can pick it up if the original parse is cancelled by reloads' parse
	                this.fetching[tileUid] = { rawTileData, cacheControl, resourceTiming };
	                try {
	                    const result = yield parsePromise;
	                    // Transferring a copy of rawTileData because the worker needs to retain its copy.
	                    return performance.extend({ rawTileData: rawTileData.slice(0) }, result, cacheControl, resourceTiming);
	                }
	                finally {
	                    delete this.fetching[tileUid];
	                }
	            }
	            catch (err) {
	                delete this.loading[tileUid];
	                workerTile.status = 'done';
	                this.loaded[tileUid] = workerTile;
	                throw err;
	            }
	        });
	    }
	    /**
	     * Implements {@link WorkerSource#reloadTile}.
	     */
	    reloadTile(params) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            const uid = params.uid;
	            if (!this.loaded || !this.loaded[uid]) {
	                throw new Error('Should not be trying to reload a tile that was never loaded or has been removed');
	            }
	            const workerTile = this.loaded[uid];
	            workerTile.showCollisionBoxes = params.showCollisionBoxes;
	            if (workerTile.status === 'parsing') {
	                const result = yield workerTile.parse(workerTile.vectorTile, this.layerIndex, this.availableImages, this.actor);
	                // if we have cancelled the original parse, make sure to pass the rawTileData from the original fetch
	                let parseResult;
	                if (this.fetching[uid]) {
	                    const { rawTileData, cacheControl, resourceTiming } = this.fetching[uid];
	                    delete this.fetching[uid];
	                    parseResult = performance.extend({ rawTileData: rawTileData.slice(0) }, result, cacheControl, resourceTiming);
	                }
	                else {
	                    parseResult = result;
	                }
	                return parseResult;
	            }
	            // if there was no vector tile data on the initial load, don't try and re-parse tile
	            if (workerTile.status === 'done' && workerTile.vectorTile) {
	                // this seems like a missing case where cache control is lost? see #3309
	                return workerTile.parse(workerTile.vectorTile, this.layerIndex, this.availableImages, this.actor);
	            }
	        });
	    }
	    /**
	     * Implements {@link WorkerSource#abortTile}.
	     */
	    abortTile(params) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            const loading = this.loading;
	            const uid = params.uid;
	            if (loading && loading[uid] && loading[uid].abort) {
	                loading[uid].abort.abort();
	                delete loading[uid];
	            }
	        });
	    }
	    /**
	     * Implements {@link WorkerSource#removeTile}.
	     */
	    removeTile(params) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            if (this.loaded && this.loaded[params.uid]) {
	                delete this.loaded[params.uid];
	            }
	        });
	    }
	}

	class RasterDEMTileWorkerSource {
	    constructor() {
	        this.loaded = {};
	    }
	    loadTile(params) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            const { uid, encoding, rawImageData, redFactor, greenFactor, blueFactor, baseShift } = params;
	            const width = rawImageData.width + 2;
	            const height = rawImageData.height + 2;
	            const imagePixels = performance.isImageBitmap(rawImageData) ?
	                new performance.RGBAImage({ width, height }, yield performance.getImageData(rawImageData, -1, -1, width, height)) :
	                rawImageData;
	            const dem = new performance.DEMData(uid, imagePixels, encoding, redFactor, greenFactor, blueFactor, baseShift);
	            this.loaded = this.loaded || {};
	            this.loaded[uid] = dem;
	            return dem;
	        });
	    }
	    removeTile(params) {
	        const loaded = this.loaded, uid = params.uid;
	        if (loaded && loaded[uid]) {
	            delete loaded[uid];
	        }
	    }
	}

	var geojsonRewind = rewind$1;

	function rewind$1(gj, outer) {
	    var type = gj && gj.type, i;

	    if (type === 'FeatureCollection') {
	        for (i = 0; i < gj.features.length; i++) rewind$1(gj.features[i], outer);

	    } else if (type === 'GeometryCollection') {
	        for (i = 0; i < gj.geometries.length; i++) rewind$1(gj.geometries[i], outer);

	    } else if (type === 'Feature') {
	        rewind$1(gj.geometry, outer);

	    } else if (type === 'Polygon') {
	        rewindRings(gj.coordinates, outer);

	    } else if (type === 'MultiPolygon') {
	        for (i = 0; i < gj.coordinates.length; i++) rewindRings(gj.coordinates[i], outer);
	    }

	    return gj;
	}

	function rewindRings(rings, outer) {
	    if (rings.length === 0) return;

	    rewindRing(rings[0], outer);
	    for (var i = 1; i < rings.length; i++) {
	        rewindRing(rings[i], !outer);
	    }
	}

	function rewindRing(ring, dir) {
	    var area = 0, err = 0;
	    for (var i = 0, len = ring.length, j = len - 1; i < len; j = i++) {
	        var k = (ring[i][0] - ring[j][0]) * (ring[j][1] + ring[i][1]);
	        var m = area + k;
	        err += Math.abs(area) >= Math.abs(k) ? area - m + k : k - m + area;
	        area = m;
	    }
	    if (area + err >= 0 !== !!dir) ring.reverse();
	}

	var rewind$2 = /*@__PURE__*/performance.getDefaultExportFromCjs(geojsonRewind);

	const toGeoJSON = performance.vectorTile.VectorTileFeature.prototype.toGeoJSON;
	let FeatureWrapper$1 = class FeatureWrapper {
	    constructor(feature) {
	        this._feature = feature;
	        this.extent = performance.EXTENT;
	        this.type = feature.type;
	        this.properties = feature.tags;
	        // If the feature has a top-level `id` property, copy it over, but only
	        // if it can be coerced to an integer, because this wrapper is used for
	        // serializing geojson feature data into vector tile PBF data, and the
	        // vector tile spec only supports integer values for feature ids --
	        // allowing non-integer values here results in a non-compliant PBF
	        // that causes an exception when it is parsed with vector-tile-js
	        if ('id' in feature && !isNaN(feature.id)) {
	            this.id = parseInt(feature.id, 10);
	        }
	    }
	    loadGeometry() {
	        if (this._feature.type === 1) {
	            const geometry = [];
	            for (const point of this._feature.geometry) {
	                geometry.push([new performance.Point(point[0], point[1])]);
	            }
	            return geometry;
	        }
	        else {
	            const geometry = [];
	            for (const ring of this._feature.geometry) {
	                const newRing = [];
	                for (const point of ring) {
	                    newRing.push(new performance.Point(point[0], point[1]));
	                }
	                geometry.push(newRing);
	            }
	            return geometry;
	        }
	    }
	    toGeoJSON(x, y, z) {
	        return toGeoJSON.call(this, x, y, z);
	    }
	};
	let GeoJSONWrapper$2 = class GeoJSONWrapper {
	    constructor(features) {
	        this.layers = { '_geojsonTileLayer': this };
	        this.name = '_geojsonTileLayer';
	        this.extent = performance.EXTENT;
	        this.length = features.length;
	        this._features = features;
	    }
	    feature(i) {
	        return new FeatureWrapper$1(this._features[i]);
	    }
	};

	var vtPbf$1 = {exports: {}};

	var Point = performance.pointGeometry;
	var VectorTileFeature = performance.vectorTile.VectorTileFeature;

	var geojson_wrapper = GeoJSONWrapper$1;

	// conform to vectortile api
	function GeoJSONWrapper$1 (features, options) {
	  this.options = options || {};
	  this.features = features;
	  this.length = features.length;
	}

	GeoJSONWrapper$1.prototype.feature = function (i) {
	  return new FeatureWrapper(this.features[i], this.options.extent)
	};

	function FeatureWrapper (feature, extent) {
	  this.id = typeof feature.id === 'number' ? feature.id : undefined;
	  this.type = feature.type;
	  this.rawGeometry = feature.type === 1 ? [feature.geometry] : feature.geometry;
	  this.properties = feature.tags;
	  this.extent = extent || 4096;
	}

	FeatureWrapper.prototype.loadGeometry = function () {
	  var rings = this.rawGeometry;
	  this.geometry = [];

	  for (var i = 0; i < rings.length; i++) {
	    var ring = rings[i];
	    var newRing = [];
	    for (var j = 0; j < ring.length; j++) {
	      newRing.push(new Point(ring[j][0], ring[j][1]));
	    }
	    this.geometry.push(newRing);
	  }
	  return this.geometry
	};

	FeatureWrapper.prototype.bbox = function () {
	  if (!this.geometry) this.loadGeometry();

	  var rings = this.geometry;
	  var x1 = Infinity;
	  var x2 = -Infinity;
	  var y1 = Infinity;
	  var y2 = -Infinity;

	  for (var i = 0; i < rings.length; i++) {
	    var ring = rings[i];

	    for (var j = 0; j < ring.length; j++) {
	      var coord = ring[j];

	      x1 = Math.min(x1, coord.x);
	      x2 = Math.max(x2, coord.x);
	      y1 = Math.min(y1, coord.y);
	      y2 = Math.max(y2, coord.y);
	    }
	  }

	  return [x1, y1, x2, y2]
	};

	FeatureWrapper.prototype.toGeoJSON = VectorTileFeature.prototype.toGeoJSON;

	var Pbf = performance.pbf;
	var GeoJSONWrapper = geojson_wrapper;

	vtPbf$1.exports = fromVectorTileJs;
	vtPbf$1.exports.fromVectorTileJs = fromVectorTileJs;
	vtPbf$1.exports.fromGeojsonVt = fromGeojsonVt;
	vtPbf$1.exports.GeoJSONWrapper = GeoJSONWrapper;

	/**
	 * Serialize a vector-tile-js-created tile to pbf
	 *
	 * @param {Object} tile
	 * @return {Buffer} uncompressed, pbf-serialized tile data
	 */
	function fromVectorTileJs (tile) {
	  var out = new Pbf();
	  writeTile(tile, out);
	  return out.finish()
	}

	/**
	 * Serialized a geojson-vt-created tile to pbf.
	 *
	 * @param {Object} layers - An object mapping layer names to geojson-vt-created vector tile objects
	 * @param {Object} [options] - An object specifying the vector-tile specification version and extent that were used to create `layers`.
	 * @param {Number} [options.version=1] - Version of vector-tile spec used
	 * @param {Number} [options.extent=4096] - Extent of the vector tile
	 * @return {Buffer} uncompressed, pbf-serialized tile data
	 */
	function fromGeojsonVt (layers, options) {
	  options = options || {};
	  var l = {};
	  for (var k in layers) {
	    l[k] = new GeoJSONWrapper(layers[k].features, options);
	    l[k].name = k;
	    l[k].version = options.version;
	    l[k].extent = options.extent;
	  }
	  return fromVectorTileJs({ layers: l })
	}

	function writeTile (tile, pbf) {
	  for (var key in tile.layers) {
	    pbf.writeMessage(3, writeLayer, tile.layers[key]);
	  }
	}

	function writeLayer (layer, pbf) {
	  pbf.writeVarintField(15, layer.version || 1);
	  pbf.writeStringField(1, layer.name || '');
	  pbf.writeVarintField(5, layer.extent || 4096);

	  var i;
	  var context = {
	    keys: [],
	    values: [],
	    keycache: {},
	    valuecache: {}
	  };

	  for (i = 0; i < layer.length; i++) {
	    context.feature = layer.feature(i);
	    pbf.writeMessage(2, writeFeature, context);
	  }

	  var keys = context.keys;
	  for (i = 0; i < keys.length; i++) {
	    pbf.writeStringField(3, keys[i]);
	  }

	  var values = context.values;
	  for (i = 0; i < values.length; i++) {
	    pbf.writeMessage(4, writeValue, values[i]);
	  }
	}

	function writeFeature (context, pbf) {
	  var feature = context.feature;

	  if (feature.id !== undefined) {
	    pbf.writeVarintField(1, feature.id);
	  }

	  pbf.writeMessage(2, writeProperties, context);
	  pbf.writeVarintField(3, feature.type);
	  pbf.writeMessage(4, writeGeometry, feature);
	}

	function writeProperties (context, pbf) {
	  var feature = context.feature;
	  var keys = context.keys;
	  var values = context.values;
	  var keycache = context.keycache;
	  var valuecache = context.valuecache;

	  for (var key in feature.properties) {
	    var value = feature.properties[key];

	    var keyIndex = keycache[key];
	    if (value === null) continue // don't encode null value properties

	    if (typeof keyIndex === 'undefined') {
	      keys.push(key);
	      keyIndex = keys.length - 1;
	      keycache[key] = keyIndex;
	    }
	    pbf.writeVarint(keyIndex);

	    var type = typeof value;
	    if (type !== 'string' && type !== 'boolean' && type !== 'number') {
	      value = JSON.stringify(value);
	    }
	    var valueKey = type + ':' + value;
	    var valueIndex = valuecache[valueKey];
	    if (typeof valueIndex === 'undefined') {
	      values.push(value);
	      valueIndex = values.length - 1;
	      valuecache[valueKey] = valueIndex;
	    }
	    pbf.writeVarint(valueIndex);
	  }
	}

	function command (cmd, length) {
	  return (length << 3) + (cmd & 0x7)
	}

	function zigzag (num) {
	  return (num << 1) ^ (num >> 31)
	}

	function writeGeometry (feature, pbf) {
	  var geometry = feature.loadGeometry();
	  var type = feature.type;
	  var x = 0;
	  var y = 0;
	  var rings = geometry.length;
	  for (var r = 0; r < rings; r++) {
	    var ring = geometry[r];
	    var count = 1;
	    if (type === 1) {
	      count = ring.length;
	    }
	    pbf.writeVarint(command(1, count)); // moveto
	    // do not write polygon closing path as lineto
	    var lineCount = type === 3 ? ring.length - 1 : ring.length;
	    for (var i = 0; i < lineCount; i++) {
	      if (i === 1 && type !== 1) {
	        pbf.writeVarint(command(2, lineCount - 1)); // lineto
	      }
	      var dx = ring[i].x - x;
	      var dy = ring[i].y - y;
	      pbf.writeVarint(zigzag(dx));
	      pbf.writeVarint(zigzag(dy));
	      x += dx;
	      y += dy;
	    }
	    if (type === 3) {
	      pbf.writeVarint(command(7, 1)); // closepath
	    }
	  }
	}

	function writeValue (value, pbf) {
	  var type = typeof value;
	  if (type === 'string') {
	    pbf.writeStringField(1, value);
	  } else if (type === 'boolean') {
	    pbf.writeBooleanField(7, value);
	  } else if (type === 'number') {
	    if (value % 1 !== 0) {
	      pbf.writeDoubleField(3, value);
	    } else if (value < 0) {
	      pbf.writeSVarintField(6, value);
	    } else {
	      pbf.writeVarintField(5, value);
	    }
	  }
	}

	var vtPbfExports = vtPbf$1.exports;
	var vtpbf = /*@__PURE__*/performance.getDefaultExportFromCjs(vtPbfExports);

	const defaultOptions = {
	    minZoom: 0,   // min zoom to generate clusters on
	    maxZoom: 16,  // max zoom level to cluster the points on
	    minPoints: 2, // minimum points to form a cluster
	    radius: 40,   // cluster radius in pixels
	    extent: 512,  // tile extent (radius is calculated relative to it)
	    nodeSize: 64, // size of the KD-tree leaf node, affects performance
	    log: false,   // whether to log timing info

	    // whether to generate numeric ids for input features (in vector tiles)
	    generateId: false,

	    // a reduce function for calculating custom cluster properties
	    reduce: null, // (accumulated, props) => { accumulated.sum += props.sum; }

	    // properties to use for individual points when running the reducer
	    map: props => props // props => ({sum: props.my_value})
	};

	const fround = Math.fround || (tmp => ((x) => { tmp[0] = +x; return tmp[0]; }))(new Float32Array(1));

	const OFFSET_ZOOM = 2;
	const OFFSET_ID = 3;
	const OFFSET_PARENT = 4;
	const OFFSET_NUM = 5;
	const OFFSET_PROP = 6;

	class Supercluster {
	    constructor(options) {
	        this.options = Object.assign(Object.create(defaultOptions), options);
	        this.trees = new Array(this.options.maxZoom + 1);
	        this.stride = this.options.reduce ? 7 : 6;
	        this.clusterProps = [];
	    }

	    load(points) {
	        const {log, minZoom, maxZoom} = this.options;

	        if (log) console.time('total time');

	        const timerId = `prepare ${  points.length  } points`;
	        if (log) console.time(timerId);

	        this.points = points;

	        // generate a cluster object for each point and index input points into a KD-tree
	        const data = [];

	        for (let i = 0; i < points.length; i++) {
	            const p = points[i];
	            if (!p.geometry) continue;

	            const [lng, lat] = p.geometry.coordinates;
	            const x = fround(lngX(lng));
	            const y = fround(latY(lat));
	            // store internal point/cluster data in flat numeric arrays for performance
	            data.push(
	                x, y, // projected point coordinates
	                Infinity, // the last zoom the point was processed at
	                i, // index of the source feature in the original input array
	                -1, // parent cluster id
	                1 // number of points in a cluster
	            );
	            if (this.options.reduce) data.push(0); // noop
	        }
	        let tree = this.trees[maxZoom + 1] = this._createTree(data);

	        if (log) console.timeEnd(timerId);

	        // cluster points on max zoom, then cluster the results on previous zoom, etc.;
	        // results in a cluster hierarchy across zoom levels
	        for (let z = maxZoom; z >= minZoom; z--) {
	            const now = +Date.now();

	            // create a new set of clusters for the zoom and index them with a KD-tree
	            tree = this.trees[z] = this._createTree(this._cluster(tree, z));

	            if (log) console.log('z%d: %d clusters in %dms', z, tree.numItems, +Date.now() - now);
	        }

	        if (log) console.timeEnd('total time');

	        return this;
	    }

	    getClusters(bbox, zoom) {
	        let minLng = ((bbox[0] + 180) % 360 + 360) % 360 - 180;
	        const minLat = Math.max(-90, Math.min(90, bbox[1]));
	        let maxLng = bbox[2] === 180 ? 180 : ((bbox[2] + 180) % 360 + 360) % 360 - 180;
	        const maxLat = Math.max(-90, Math.min(90, bbox[3]));

	        if (bbox[2] - bbox[0] >= 360) {
	            minLng = -180;
	            maxLng = 180;
	        } else if (minLng > maxLng) {
	            const easternHem = this.getClusters([minLng, minLat, 180, maxLat], zoom);
	            const westernHem = this.getClusters([-180, minLat, maxLng, maxLat], zoom);
	            return easternHem.concat(westernHem);
	        }

	        const tree = this.trees[this._limitZoom(zoom)];
	        const ids = tree.range(lngX(minLng), latY(maxLat), lngX(maxLng), latY(minLat));
	        const data = tree.data;
	        const clusters = [];
	        for (const id of ids) {
	            const k = this.stride * id;
	            clusters.push(data[k + OFFSET_NUM] > 1 ? getClusterJSON(data, k, this.clusterProps) : this.points[data[k + OFFSET_ID]]);
	        }
	        return clusters;
	    }

	    getChildren(clusterId) {
	        const originId = this._getOriginId(clusterId);
	        const originZoom = this._getOriginZoom(clusterId);
	        const errorMsg = 'No cluster with the specified id.';

	        const tree = this.trees[originZoom];
	        if (!tree) throw new Error(errorMsg);

	        const data = tree.data;
	        if (originId * this.stride >= data.length) throw new Error(errorMsg);

	        const r = this.options.radius / (this.options.extent * Math.pow(2, originZoom - 1));
	        const x = data[originId * this.stride];
	        const y = data[originId * this.stride + 1];
	        const ids = tree.within(x, y, r);
	        const children = [];
	        for (const id of ids) {
	            const k = id * this.stride;
	            if (data[k + OFFSET_PARENT] === clusterId) {
	                children.push(data[k + OFFSET_NUM] > 1 ? getClusterJSON(data, k, this.clusterProps) : this.points[data[k + OFFSET_ID]]);
	            }
	        }

	        if (children.length === 0) throw new Error(errorMsg);

	        return children;
	    }

	    getLeaves(clusterId, limit, offset) {
	        limit = limit || 10;
	        offset = offset || 0;

	        const leaves = [];
	        this._appendLeaves(leaves, clusterId, limit, offset, 0);

	        return leaves;
	    }

	    getTile(z, x, y) {
	        const tree = this.trees[this._limitZoom(z)];
	        const z2 = Math.pow(2, z);
	        const {extent, radius} = this.options;
	        const p = radius / extent;
	        const top = (y - p) / z2;
	        const bottom = (y + 1 + p) / z2;

	        const tile = {
	            features: []
	        };

	        this._addTileFeatures(
	            tree.range((x - p) / z2, top, (x + 1 + p) / z2, bottom),
	            tree.data, x, y, z2, tile);

	        if (x === 0) {
	            this._addTileFeatures(
	                tree.range(1 - p / z2, top, 1, bottom),
	                tree.data, z2, y, z2, tile);
	        }
	        if (x === z2 - 1) {
	            this._addTileFeatures(
	                tree.range(0, top, p / z2, bottom),
	                tree.data, -1, y, z2, tile);
	        }

	        return tile.features.length ? tile : null;
	    }

	    getClusterExpansionZoom(clusterId) {
	        let expansionZoom = this._getOriginZoom(clusterId) - 1;
	        while (expansionZoom <= this.options.maxZoom) {
	            const children = this.getChildren(clusterId);
	            expansionZoom++;
	            if (children.length !== 1) break;
	            clusterId = children[0].properties.cluster_id;
	        }
	        return expansionZoom;
	    }

	    _appendLeaves(result, clusterId, limit, offset, skipped) {
	        const children = this.getChildren(clusterId);

	        for (const child of children) {
	            const props = child.properties;

	            if (props && props.cluster) {
	                if (skipped + props.point_count <= offset) {
	                    // skip the whole cluster
	                    skipped += props.point_count;
	                } else {
	                    // enter the cluster
	                    skipped = this._appendLeaves(result, props.cluster_id, limit, offset, skipped);
	                    // exit the cluster
	                }
	            } else if (skipped < offset) {
	                // skip a single point
	                skipped++;
	            } else {
	                // add a single point
	                result.push(child);
	            }
	            if (result.length === limit) break;
	        }

	        return skipped;
	    }

	    _createTree(data) {
	        const tree = new performance.KDBush(data.length / this.stride | 0, this.options.nodeSize, Float32Array);
	        for (let i = 0; i < data.length; i += this.stride) tree.add(data[i], data[i + 1]);
	        tree.finish();
	        tree.data = data;
	        return tree;
	    }

	    _addTileFeatures(ids, data, x, y, z2, tile) {
	        for (const i of ids) {
	            const k = i * this.stride;
	            const isCluster = data[k + OFFSET_NUM] > 1;

	            let tags, px, py;
	            if (isCluster) {
	                tags = getClusterProperties(data, k, this.clusterProps);
	                px = data[k];
	                py = data[k + 1];
	            } else {
	                const p = this.points[data[k + OFFSET_ID]];
	                tags = p.properties;
	                const [lng, lat] = p.geometry.coordinates;
	                px = lngX(lng);
	                py = latY(lat);
	            }

	            const f = {
	                type: 1,
	                geometry: [[
	                    Math.round(this.options.extent * (px * z2 - x)),
	                    Math.round(this.options.extent * (py * z2 - y))
	                ]],
	                tags
	            };

	            // assign id
	            let id;
	            if (isCluster || this.options.generateId) {
	                // optionally generate id for points
	                id = data[k + OFFSET_ID];
	            } else {
	                // keep id if already assigned
	                id = this.points[data[k + OFFSET_ID]].id;
	            }

	            if (id !== undefined) f.id = id;

	            tile.features.push(f);
	        }
	    }

	    _limitZoom(z) {
	        return Math.max(this.options.minZoom, Math.min(Math.floor(+z), this.options.maxZoom + 1));
	    }

	    _cluster(tree, zoom) {
	        const {radius, extent, reduce, minPoints} = this.options;
	        const r = radius / (extent * Math.pow(2, zoom));
	        const data = tree.data;
	        const nextData = [];
	        const stride = this.stride;

	        // loop through each point
	        for (let i = 0; i < data.length; i += stride) {
	            // if we've already visited the point at this zoom level, skip it
	            if (data[i + OFFSET_ZOOM] <= zoom) continue;
	            data[i + OFFSET_ZOOM] = zoom;

	            // find all nearby points
	            const x = data[i];
	            const y = data[i + 1];
	            const neighborIds = tree.within(data[i], data[i + 1], r);

	            const numPointsOrigin = data[i + OFFSET_NUM];
	            let numPoints = numPointsOrigin;

	            // count the number of points in a potential cluster
	            for (const neighborId of neighborIds) {
	                const k = neighborId * stride;
	                // filter out neighbors that are already processed
	                if (data[k + OFFSET_ZOOM] > zoom) numPoints += data[k + OFFSET_NUM];
	            }

	            // if there were neighbors to merge, and there are enough points to form a cluster
	            if (numPoints > numPointsOrigin && numPoints >= minPoints) {
	                let wx = x * numPointsOrigin;
	                let wy = y * numPointsOrigin;

	                let clusterProperties;
	                let clusterPropIndex = -1;

	                // encode both zoom and point index on which the cluster originated -- offset by total length of features
	                const id = ((i / stride | 0) << 5) + (zoom + 1) + this.points.length;

	                for (const neighborId of neighborIds) {
	                    const k = neighborId * stride;

	                    if (data[k + OFFSET_ZOOM] <= zoom) continue;
	                    data[k + OFFSET_ZOOM] = zoom; // save the zoom (so it doesn't get processed twice)

	                    const numPoints2 = data[k + OFFSET_NUM];
	                    wx += data[k] * numPoints2; // accumulate coordinates for calculating weighted center
	                    wy += data[k + 1] * numPoints2;

	                    data[k + OFFSET_PARENT] = id;

	                    if (reduce) {
	                        if (!clusterProperties) {
	                            clusterProperties = this._map(data, i, true);
	                            clusterPropIndex = this.clusterProps.length;
	                            this.clusterProps.push(clusterProperties);
	                        }
	                        reduce(clusterProperties, this._map(data, k));
	                    }
	                }

	                data[i + OFFSET_PARENT] = id;
	                nextData.push(wx / numPoints, wy / numPoints, Infinity, id, -1, numPoints);
	                if (reduce) nextData.push(clusterPropIndex);

	            } else { // left points as unclustered
	                for (let j = 0; j < stride; j++) nextData.push(data[i + j]);

	                if (numPoints > 1) {
	                    for (const neighborId of neighborIds) {
	                        const k = neighborId * stride;
	                        if (data[k + OFFSET_ZOOM] <= zoom) continue;
	                        data[k + OFFSET_ZOOM] = zoom;
	                        for (let j = 0; j < stride; j++) nextData.push(data[k + j]);
	                    }
	                }
	            }
	        }

	        return nextData;
	    }

	    // get index of the point from which the cluster originated
	    _getOriginId(clusterId) {
	        return (clusterId - this.points.length) >> 5;
	    }

	    // get zoom of the point from which the cluster originated
	    _getOriginZoom(clusterId) {
	        return (clusterId - this.points.length) % 32;
	    }

	    _map(data, i, clone) {
	        if (data[i + OFFSET_NUM] > 1) {
	            const props = this.clusterProps[data[i + OFFSET_PROP]];
	            return clone ? Object.assign({}, props) : props;
	        }
	        const original = this.points[data[i + OFFSET_ID]].properties;
	        const result = this.options.map(original);
	        return clone && result === original ? Object.assign({}, result) : result;
	    }
	}

	function getClusterJSON(data, i, clusterProps) {
	    return {
	        type: 'Feature',
	        id: data[i + OFFSET_ID],
	        properties: getClusterProperties(data, i, clusterProps),
	        geometry: {
	            type: 'Point',
	            coordinates: [xLng(data[i]), yLat(data[i + 1])]
	        }
	    };
	}

	function getClusterProperties(data, i, clusterProps) {
	    const count = data[i + OFFSET_NUM];
	    const abbrev =
	        count >= 10000 ? `${Math.round(count / 1000)  }k` :
	        count >= 1000 ? `${Math.round(count / 100) / 10  }k` : count;
	    const propIndex = data[i + OFFSET_PROP];
	    const properties = propIndex === -1 ? {} : Object.assign({}, clusterProps[propIndex]);
	    return Object.assign(properties, {
	        cluster: true,
	        cluster_id: data[i + OFFSET_ID],
	        point_count: count,
	        point_count_abbreviated: abbrev
	    });
	}

	// longitude/latitude to spherical mercator in [0..1] range
	function lngX(lng) {
	    return lng / 360 + 0.5;
	}
	function latY(lat) {
	    const sin = Math.sin(lat * Math.PI / 180);
	    const y = (0.5 - 0.25 * Math.log((1 + sin) / (1 - sin)) / Math.PI);
	    return y < 0 ? 0 : y > 1 ? 1 : y;
	}

	// spherical mercator to longitude/latitude
	function xLng(x) {
	    return (x - 0.5) * 360;
	}
	function yLat(y) {
	    const y2 = (180 - y * 360) * Math.PI / 180;
	    return 360 * Math.atan(Math.exp(y2)) / Math.PI - 90;
	}

	// calculate simplification data using optimized Douglas-Peucker algorithm

	function simplify(coords, first, last, sqTolerance) {
	    var maxSqDist = sqTolerance;
	    var mid = (last - first) >> 1;
	    var minPosToMid = last - first;
	    var index;

	    var ax = coords[first];
	    var ay = coords[first + 1];
	    var bx = coords[last];
	    var by = coords[last + 1];

	    for (var i = first + 3; i < last; i += 3) {
	        var d = getSqSegDist(coords[i], coords[i + 1], ax, ay, bx, by);

	        if (d > maxSqDist) {
	            index = i;
	            maxSqDist = d;

	        } else if (d === maxSqDist) {
	            // a workaround to ensure we choose a pivot close to the middle of the list,
	            // reducing recursion depth, for certain degenerate inputs
	            // https://github.com/mapbox/geojson-vt/issues/104
	            var posToMid = Math.abs(i - mid);
	            if (posToMid < minPosToMid) {
	                index = i;
	                minPosToMid = posToMid;
	            }
	        }
	    }

	    if (maxSqDist > sqTolerance) {
	        if (index - first > 3) simplify(coords, first, index, sqTolerance);
	        coords[index + 2] = maxSqDist;
	        if (last - index > 3) simplify(coords, index, last, sqTolerance);
	    }
	}

	// square distance from a point to a segment
	function getSqSegDist(px, py, x, y, bx, by) {

	    var dx = bx - x;
	    var dy = by - y;

	    if (dx !== 0 || dy !== 0) {

	        var t = ((px - x) * dx + (py - y) * dy) / (dx * dx + dy * dy);

	        if (t > 1) {
	            x = bx;
	            y = by;

	        } else if (t > 0) {
	            x += dx * t;
	            y += dy * t;
	        }
	    }

	    dx = px - x;
	    dy = py - y;

	    return dx * dx + dy * dy;
	}

	function createFeature(id, type, geom, tags) {
	    var feature = {
	        id: typeof id === 'undefined' ? null : id,
	        type: type,
	        geometry: geom,
	        tags: tags,
	        minX: Infinity,
	        minY: Infinity,
	        maxX: -Infinity,
	        maxY: -Infinity
	    };
	    calcBBox(feature);
	    return feature;
	}

	function calcBBox(feature) {
	    var geom = feature.geometry;
	    var type = feature.type;

	    if (type === 'Point' || type === 'MultiPoint' || type === 'LineString') {
	        calcLineBBox(feature, geom);

	    } else if (type === 'Polygon' || type === 'MultiLineString') {
	        for (var i = 0; i < geom.length; i++) {
	            calcLineBBox(feature, geom[i]);
	        }

	    } else if (type === 'MultiPolygon') {
	        for (i = 0; i < geom.length; i++) {
	            for (var j = 0; j < geom[i].length; j++) {
	                calcLineBBox(feature, geom[i][j]);
	            }
	        }
	    }
	}

	function calcLineBBox(feature, geom) {
	    for (var i = 0; i < geom.length; i += 3) {
	        feature.minX = Math.min(feature.minX, geom[i]);
	        feature.minY = Math.min(feature.minY, geom[i + 1]);
	        feature.maxX = Math.max(feature.maxX, geom[i]);
	        feature.maxY = Math.max(feature.maxY, geom[i + 1]);
	    }
	}

	// converts GeoJSON feature into an intermediate projected JSON vector format with simplification data

	function convert(data, options) {
	    var features = [];
	    if (data.type === 'FeatureCollection') {
	        for (var i = 0; i < data.features.length; i++) {
	            convertFeature(features, data.features[i], options, i);
	        }

	    } else if (data.type === 'Feature') {
	        convertFeature(features, data, options);

	    } else {
	        // single geometry or a geometry collection
	        convertFeature(features, {geometry: data}, options);
	    }

	    return features;
	}

	function convertFeature(features, geojson, options, index) {
	    if (!geojson.geometry) return;

	    var coords = geojson.geometry.coordinates;
	    var type = geojson.geometry.type;
	    var tolerance = Math.pow(options.tolerance / ((1 << options.maxZoom) * options.extent), 2);
	    var geometry = [];
	    var id = geojson.id;
	    if (options.promoteId) {
	        id = geojson.properties[options.promoteId];
	    } else if (options.generateId) {
	        id = index || 0;
	    }
	    if (type === 'Point') {
	        convertPoint(coords, geometry);

	    } else if (type === 'MultiPoint') {
	        for (var i = 0; i < coords.length; i++) {
	            convertPoint(coords[i], geometry);
	        }

	    } else if (type === 'LineString') {
	        convertLine(coords, geometry, tolerance, false);

	    } else if (type === 'MultiLineString') {
	        if (options.lineMetrics) {
	            // explode into linestrings to be able to track metrics
	            for (i = 0; i < coords.length; i++) {
	                geometry = [];
	                convertLine(coords[i], geometry, tolerance, false);
	                features.push(createFeature(id, 'LineString', geometry, geojson.properties));
	            }
	            return;
	        } else {
	            convertLines(coords, geometry, tolerance, false);
	        }

	    } else if (type === 'Polygon') {
	        convertLines(coords, geometry, tolerance, true);

	    } else if (type === 'MultiPolygon') {
	        for (i = 0; i < coords.length; i++) {
	            var polygon = [];
	            convertLines(coords[i], polygon, tolerance, true);
	            geometry.push(polygon);
	        }
	    } else if (type === 'GeometryCollection') {
	        for (i = 0; i < geojson.geometry.geometries.length; i++) {
	            convertFeature(features, {
	                id: id,
	                geometry: geojson.geometry.geometries[i],
	                properties: geojson.properties
	            }, options, index);
	        }
	        return;
	    } else {
	        throw new Error('Input data is not a valid GeoJSON object.');
	    }

	    features.push(createFeature(id, type, geometry, geojson.properties));
	}

	function convertPoint(coords, out) {
	    out.push(projectX(coords[0]));
	    out.push(projectY(coords[1]));
	    out.push(0);
	}

	function convertLine(ring, out, tolerance, isPolygon) {
	    var x0, y0;
	    var size = 0;

	    for (var j = 0; j < ring.length; j++) {
	        var x = projectX(ring[j][0]);
	        var y = projectY(ring[j][1]);

	        out.push(x);
	        out.push(y);
	        out.push(0);

	        if (j > 0) {
	            if (isPolygon) {
	                size += (x0 * y - x * y0) / 2; // area
	            } else {
	                size += Math.sqrt(Math.pow(x - x0, 2) + Math.pow(y - y0, 2)); // length
	            }
	        }
	        x0 = x;
	        y0 = y;
	    }

	    var last = out.length - 3;
	    out[2] = 1;
	    simplify(out, 0, last, tolerance);
	    out[last + 2] = 1;

	    out.size = Math.abs(size);
	    out.start = 0;
	    out.end = out.size;
	}

	function convertLines(rings, out, tolerance, isPolygon) {
	    for (var i = 0; i < rings.length; i++) {
	        var geom = [];
	        convertLine(rings[i], geom, tolerance, isPolygon);
	        out.push(geom);
	    }
	}

	function projectX(x) {
	    return x / 360 + 0.5;
	}

	function projectY(y) {
	    var sin = Math.sin(y * Math.PI / 180);
	    var y2 = 0.5 - 0.25 * Math.log((1 + sin) / (1 - sin)) / Math.PI;
	    return y2 < 0 ? 0 : y2 > 1 ? 1 : y2;
	}

	/* clip features between two axis-parallel lines:
	 *     |        |
	 *  ___|___     |     /
	 * /   |   \____|____/
	 *     |        |
	 */

	function clip(features, scale, k1, k2, axis, minAll, maxAll, options) {

	    k1 /= scale;
	    k2 /= scale;

	    if (minAll >= k1 && maxAll < k2) return features; // trivial accept
	    else if (maxAll < k1 || minAll >= k2) return null; // trivial reject

	    var clipped = [];

	    for (var i = 0; i < features.length; i++) {

	        var feature = features[i];
	        var geometry = feature.geometry;
	        var type = feature.type;

	        var min = axis === 0 ? feature.minX : feature.minY;
	        var max = axis === 0 ? feature.maxX : feature.maxY;

	        if (min >= k1 && max < k2) { // trivial accept
	            clipped.push(feature);
	            continue;
	        } else if (max < k1 || min >= k2) { // trivial reject
	            continue;
	        }

	        var newGeometry = [];

	        if (type === 'Point' || type === 'MultiPoint') {
	            clipPoints(geometry, newGeometry, k1, k2, axis);

	        } else if (type === 'LineString') {
	            clipLine(geometry, newGeometry, k1, k2, axis, false, options.lineMetrics);

	        } else if (type === 'MultiLineString') {
	            clipLines(geometry, newGeometry, k1, k2, axis, false);

	        } else if (type === 'Polygon') {
	            clipLines(geometry, newGeometry, k1, k2, axis, true);

	        } else if (type === 'MultiPolygon') {
	            for (var j = 0; j < geometry.length; j++) {
	                var polygon = [];
	                clipLines(geometry[j], polygon, k1, k2, axis, true);
	                if (polygon.length) {
	                    newGeometry.push(polygon);
	                }
	            }
	        }

	        if (newGeometry.length) {
	            if (options.lineMetrics && type === 'LineString') {
	                for (j = 0; j < newGeometry.length; j++) {
	                    clipped.push(createFeature(feature.id, type, newGeometry[j], feature.tags));
	                }
	                continue;
	            }

	            if (type === 'LineString' || type === 'MultiLineString') {
	                if (newGeometry.length === 1) {
	                    type = 'LineString';
	                    newGeometry = newGeometry[0];
	                } else {
	                    type = 'MultiLineString';
	                }
	            }
	            if (type === 'Point' || type === 'MultiPoint') {
	                type = newGeometry.length === 3 ? 'Point' : 'MultiPoint';
	            }

	            clipped.push(createFeature(feature.id, type, newGeometry, feature.tags));
	        }
	    }

	    return clipped.length ? clipped : null;
	}

	function clipPoints(geom, newGeom, k1, k2, axis) {
	    for (var i = 0; i < geom.length; i += 3) {
	        var a = geom[i + axis];

	        if (a >= k1 && a <= k2) {
	            newGeom.push(geom[i]);
	            newGeom.push(geom[i + 1]);
	            newGeom.push(geom[i + 2]);
	        }
	    }
	}

	function clipLine(geom, newGeom, k1, k2, axis, isPolygon, trackMetrics) {

	    var slice = newSlice(geom);
	    var intersect = axis === 0 ? intersectX : intersectY;
	    var len = geom.start;
	    var segLen, t;

	    for (var i = 0; i < geom.length - 3; i += 3) {
	        var ax = geom[i];
	        var ay = geom[i + 1];
	        var az = geom[i + 2];
	        var bx = geom[i + 3];
	        var by = geom[i + 4];
	        var a = axis === 0 ? ax : ay;
	        var b = axis === 0 ? bx : by;
	        var exited = false;

	        if (trackMetrics) segLen = Math.sqrt(Math.pow(ax - bx, 2) + Math.pow(ay - by, 2));

	        if (a < k1) {
	            // ---|-->  | (line enters the clip region from the left)
	            if (b > k1) {
	                t = intersect(slice, ax, ay, bx, by, k1);
	                if (trackMetrics) slice.start = len + segLen * t;
	            }
	        } else if (a > k2) {
	            // |  <--|--- (line enters the clip region from the right)
	            if (b < k2) {
	                t = intersect(slice, ax, ay, bx, by, k2);
	                if (trackMetrics) slice.start = len + segLen * t;
	            }
	        } else {
	            addPoint(slice, ax, ay, az);
	        }
	        if (b < k1 && a >= k1) {
	            // <--|---  | or <--|-----|--- (line exits the clip region on the left)
	            t = intersect(slice, ax, ay, bx, by, k1);
	            exited = true;
	        }
	        if (b > k2 && a <= k2) {
	            // |  ---|--> or ---|-----|--> (line exits the clip region on the right)
	            t = intersect(slice, ax, ay, bx, by, k2);
	            exited = true;
	        }

	        if (!isPolygon && exited) {
	            if (trackMetrics) slice.end = len + segLen * t;
	            newGeom.push(slice);
	            slice = newSlice(geom);
	        }

	        if (trackMetrics) len += segLen;
	    }

	    // add the last point
	    var last = geom.length - 3;
	    ax = geom[last];
	    ay = geom[last + 1];
	    az = geom[last + 2];
	    a = axis === 0 ? ax : ay;
	    if (a >= k1 && a <= k2) addPoint(slice, ax, ay, az);

	    // close the polygon if its endpoints are not the same after clipping
	    last = slice.length - 3;
	    if (isPolygon && last >= 3 && (slice[last] !== slice[0] || slice[last + 1] !== slice[1])) {
	        addPoint(slice, slice[0], slice[1], slice[2]);
	    }

	    // add the final slice
	    if (slice.length) {
	        newGeom.push(slice);
	    }
	}

	function newSlice(line) {
	    var slice = [];
	    slice.size = line.size;
	    slice.start = line.start;
	    slice.end = line.end;
	    return slice;
	}

	function clipLines(geom, newGeom, k1, k2, axis, isPolygon) {
	    for (var i = 0; i < geom.length; i++) {
	        clipLine(geom[i], newGeom, k1, k2, axis, isPolygon, false);
	    }
	}

	function addPoint(out, x, y, z) {
	    out.push(x);
	    out.push(y);
	    out.push(z);
	}

	function intersectX(out, ax, ay, bx, by, x) {
	    var t = (x - ax) / (bx - ax);
	    out.push(x);
	    out.push(ay + (by - ay) * t);
	    out.push(1);
	    return t;
	}

	function intersectY(out, ax, ay, bx, by, y) {
	    var t = (y - ay) / (by - ay);
	    out.push(ax + (bx - ax) * t);
	    out.push(y);
	    out.push(1);
	    return t;
	}

	function wrap(features, options) {
	    var buffer = options.buffer / options.extent;
	    var merged = features;
	    var left  = clip(features, 1, -1 - buffer, buffer,     0, -1, 2, options); // left world copy
	    var right = clip(features, 1,  1 - buffer, 2 + buffer, 0, -1, 2, options); // right world copy

	    if (left || right) {
	        merged = clip(features, 1, -buffer, 1 + buffer, 0, -1, 2, options) || []; // center world copy

	        if (left) merged = shiftFeatureCoords(left, 1).concat(merged); // merge left into center
	        if (right) merged = merged.concat(shiftFeatureCoords(right, -1)); // merge right into center
	    }

	    return merged;
	}

	function shiftFeatureCoords(features, offset) {
	    var newFeatures = [];

	    for (var i = 0; i < features.length; i++) {
	        var feature = features[i],
	            type = feature.type;

	        var newGeometry;

	        if (type === 'Point' || type === 'MultiPoint' || type === 'LineString') {
	            newGeometry = shiftCoords(feature.geometry, offset);

	        } else if (type === 'MultiLineString' || type === 'Polygon') {
	            newGeometry = [];
	            for (var j = 0; j < feature.geometry.length; j++) {
	                newGeometry.push(shiftCoords(feature.geometry[j], offset));
	            }
	        } else if (type === 'MultiPolygon') {
	            newGeometry = [];
	            for (j = 0; j < feature.geometry.length; j++) {
	                var newPolygon = [];
	                for (var k = 0; k < feature.geometry[j].length; k++) {
	                    newPolygon.push(shiftCoords(feature.geometry[j][k], offset));
	                }
	                newGeometry.push(newPolygon);
	            }
	        }

	        newFeatures.push(createFeature(feature.id, type, newGeometry, feature.tags));
	    }

	    return newFeatures;
	}

	function shiftCoords(points, offset) {
	    var newPoints = [];
	    newPoints.size = points.size;

	    if (points.start !== undefined) {
	        newPoints.start = points.start;
	        newPoints.end = points.end;
	    }

	    for (var i = 0; i < points.length; i += 3) {
	        newPoints.push(points[i] + offset, points[i + 1], points[i + 2]);
	    }
	    return newPoints;
	}

	// Transforms the coordinates of each feature in the given tile from
	// mercator-projected space into (extent x extent) tile space.
	function transformTile(tile, extent) {
	    if (tile.transformed) return tile;

	    var z2 = 1 << tile.z,
	        tx = tile.x,
	        ty = tile.y,
	        i, j, k;

	    for (i = 0; i < tile.features.length; i++) {
	        var feature = tile.features[i],
	            geom = feature.geometry,
	            type = feature.type;

	        feature.geometry = [];

	        if (type === 1) {
	            for (j = 0; j < geom.length; j += 2) {
	                feature.geometry.push(transformPoint(geom[j], geom[j + 1], extent, z2, tx, ty));
	            }
	        } else {
	            for (j = 0; j < geom.length; j++) {
	                var ring = [];
	                for (k = 0; k < geom[j].length; k += 2) {
	                    ring.push(transformPoint(geom[j][k], geom[j][k + 1], extent, z2, tx, ty));
	                }
	                feature.geometry.push(ring);
	            }
	        }
	    }

	    tile.transformed = true;

	    return tile;
	}

	function transformPoint(x, y, extent, z2, tx, ty) {
	    return [
	        Math.round(extent * (x * z2 - tx)),
	        Math.round(extent * (y * z2 - ty))];
	}

	function createTile(features, z, tx, ty, options) {
	    var tolerance = z === options.maxZoom ? 0 : options.tolerance / ((1 << z) * options.extent);
	    var tile = {
	        features: [],
	        numPoints: 0,
	        numSimplified: 0,
	        numFeatures: 0,
	        source: null,
	        x: tx,
	        y: ty,
	        z: z,
	        transformed: false,
	        minX: 2,
	        minY: 1,
	        maxX: -1,
	        maxY: 0
	    };
	    for (var i = 0; i < features.length; i++) {
	        tile.numFeatures++;
	        addFeature(tile, features[i], tolerance, options);

	        var minX = features[i].minX;
	        var minY = features[i].minY;
	        var maxX = features[i].maxX;
	        var maxY = features[i].maxY;

	        if (minX < tile.minX) tile.minX = minX;
	        if (minY < tile.minY) tile.minY = minY;
	        if (maxX > tile.maxX) tile.maxX = maxX;
	        if (maxY > tile.maxY) tile.maxY = maxY;
	    }
	    return tile;
	}

	function addFeature(tile, feature, tolerance, options) {

	    var geom = feature.geometry,
	        type = feature.type,
	        simplified = [];

	    if (type === 'Point' || type === 'MultiPoint') {
	        for (var i = 0; i < geom.length; i += 3) {
	            simplified.push(geom[i]);
	            simplified.push(geom[i + 1]);
	            tile.numPoints++;
	            tile.numSimplified++;
	        }

	    } else if (type === 'LineString') {
	        addLine(simplified, geom, tile, tolerance, false, false);

	    } else if (type === 'MultiLineString' || type === 'Polygon') {
	        for (i = 0; i < geom.length; i++) {
	            addLine(simplified, geom[i], tile, tolerance, type === 'Polygon', i === 0);
	        }

	    } else if (type === 'MultiPolygon') {

	        for (var k = 0; k < geom.length; k++) {
	            var polygon = geom[k];
	            for (i = 0; i < polygon.length; i++) {
	                addLine(simplified, polygon[i], tile, tolerance, true, i === 0);
	            }
	        }
	    }

	    if (simplified.length) {
	        var tags = feature.tags || null;
	        if (type === 'LineString' && options.lineMetrics) {
	            tags = {};
	            for (var key in feature.tags) tags[key] = feature.tags[key];
	            tags['mapbox_clip_start'] = geom.start / geom.size;
	            tags['mapbox_clip_end'] = geom.end / geom.size;
	        }
	        var tileFeature = {
	            geometry: simplified,
	            type: type === 'Polygon' || type === 'MultiPolygon' ? 3 :
	                type === 'LineString' || type === 'MultiLineString' ? 2 : 1,
	            tags: tags
	        };
	        if (feature.id !== null) {
	            tileFeature.id = feature.id;
	        }
	        tile.features.push(tileFeature);
	    }
	}

	function addLine(result, geom, tile, tolerance, isPolygon, isOuter) {
	    var sqTolerance = tolerance * tolerance;

	    if (tolerance > 0 && (geom.size < (isPolygon ? sqTolerance : tolerance))) {
	        tile.numPoints += geom.length / 3;
	        return;
	    }

	    var ring = [];

	    for (var i = 0; i < geom.length; i += 3) {
	        if (tolerance === 0 || geom[i + 2] > sqTolerance) {
	            tile.numSimplified++;
	            ring.push(geom[i]);
	            ring.push(geom[i + 1]);
	        }
	        tile.numPoints++;
	    }

	    if (isPolygon) rewind(ring, isOuter);

	    result.push(ring);
	}

	function rewind(ring, clockwise) {
	    var area = 0;
	    for (var i = 0, len = ring.length, j = len - 2; i < len; j = i, i += 2) {
	        area += (ring[i] - ring[j]) * (ring[i + 1] + ring[j + 1]);
	    }
	    if (area > 0 === clockwise) {
	        for (i = 0, len = ring.length; i < len / 2; i += 2) {
	            var x = ring[i];
	            var y = ring[i + 1];
	            ring[i] = ring[len - 2 - i];
	            ring[i + 1] = ring[len - 1 - i];
	            ring[len - 2 - i] = x;
	            ring[len - 1 - i] = y;
	        }
	    }
	}

	function geojsonvt(data, options) {
	    return new GeoJSONVT(data, options);
	}

	function GeoJSONVT(data, options) {
	    options = this.options = extend(Object.create(this.options), options);

	    var debug = options.debug;

	    if (debug) console.time('preprocess data');

	    if (options.maxZoom < 0 || options.maxZoom > 24) throw new Error('maxZoom should be in the 0-24 range');
	    if (options.promoteId && options.generateId) throw new Error('promoteId and generateId cannot be used together.');

	    var features = convert(data, options);

	    this.tiles = {};
	    this.tileCoords = [];

	    if (debug) {
	        console.timeEnd('preprocess data');
	        console.log('index: maxZoom: %d, maxPoints: %d', options.indexMaxZoom, options.indexMaxPoints);
	        console.time('generate tiles');
	        this.stats = {};
	        this.total = 0;
	    }

	    features = wrap(features, options);

	    // start slicing from the top tile down
	    if (features.length) this.splitTile(features, 0, 0, 0);

	    if (debug) {
	        if (features.length) console.log('features: %d, points: %d', this.tiles[0].numFeatures, this.tiles[0].numPoints);
	        console.timeEnd('generate tiles');
	        console.log('tiles generated:', this.total, JSON.stringify(this.stats));
	    }
	}

	GeoJSONVT.prototype.options = {
	    maxZoom: 14,            // max zoom to preserve detail on
	    indexMaxZoom: 5,        // max zoom in the tile index
	    indexMaxPoints: 100000, // max number of points per tile in the tile index
	    tolerance: 3,           // simplification tolerance (higher means simpler)
	    extent: 4096,           // tile extent
	    buffer: 64,             // tile buffer on each side
	    lineMetrics: false,     // whether to calculate line metrics
	    promoteId: null,        // name of a feature property to be promoted to feature.id
	    generateId: false,      // whether to generate feature ids. Cannot be used with promoteId
	    debug: 0                // logging level (0, 1 or 2)
	};

	GeoJSONVT.prototype.splitTile = function (features, z, x, y, cz, cx, cy) {

	    var stack = [features, z, x, y],
	        options = this.options,
	        debug = options.debug;

	    // avoid recursion by using a processing queue
	    while (stack.length) {
	        y = stack.pop();
	        x = stack.pop();
	        z = stack.pop();
	        features = stack.pop();

	        var z2 = 1 << z,
	            id = toID(z, x, y),
	            tile = this.tiles[id];

	        if (!tile) {
	            if (debug > 1) console.time('creation');

	            tile = this.tiles[id] = createTile(features, z, x, y, options);
	            this.tileCoords.push({z: z, x: x, y: y});

	            if (debug) {
	                if (debug > 1) {
	                    console.log('tile z%d-%d-%d (features: %d, points: %d, simplified: %d)',
	                        z, x, y, tile.numFeatures, tile.numPoints, tile.numSimplified);
	                    console.timeEnd('creation');
	                }
	                var key = 'z' + z;
	                this.stats[key] = (this.stats[key] || 0) + 1;
	                this.total++;
	            }
	        }

	        // save reference to original geometry in tile so that we can drill down later if we stop now
	        tile.source = features;

	        // if it's the first-pass tiling
	        if (!cz) {
	            // stop tiling if we reached max zoom, or if the tile is too simple
	            if (z === options.indexMaxZoom || tile.numPoints <= options.indexMaxPoints) continue;

	        // if a drilldown to a specific tile
	        } else {
	            // stop tiling if we reached base zoom or our target tile zoom
	            if (z === options.maxZoom || z === cz) continue;

	            // stop tiling if it's not an ancestor of the target tile
	            var m = 1 << (cz - z);
	            if (x !== Math.floor(cx / m) || y !== Math.floor(cy / m)) continue;
	        }

	        // if we slice further down, no need to keep source geometry
	        tile.source = null;

	        if (features.length === 0) continue;

	        if (debug > 1) console.time('clipping');

	        // values we'll use for clipping
	        var k1 = 0.5 * options.buffer / options.extent,
	            k2 = 0.5 - k1,
	            k3 = 0.5 + k1,
	            k4 = 1 + k1,
	            tl, bl, tr, br, left, right;

	        tl = bl = tr = br = null;

	        left  = clip(features, z2, x - k1, x + k3, 0, tile.minX, tile.maxX, options);
	        right = clip(features, z2, x + k2, x + k4, 0, tile.minX, tile.maxX, options);
	        features = null;

	        if (left) {
	            tl = clip(left, z2, y - k1, y + k3, 1, tile.minY, tile.maxY, options);
	            bl = clip(left, z2, y + k2, y + k4, 1, tile.minY, tile.maxY, options);
	            left = null;
	        }

	        if (right) {
	            tr = clip(right, z2, y - k1, y + k3, 1, tile.minY, tile.maxY, options);
	            br = clip(right, z2, y + k2, y + k4, 1, tile.minY, tile.maxY, options);
	            right = null;
	        }

	        if (debug > 1) console.timeEnd('clipping');

	        stack.push(tl || [], z + 1, x * 2,     y * 2);
	        stack.push(bl || [], z + 1, x * 2,     y * 2 + 1);
	        stack.push(tr || [], z + 1, x * 2 + 1, y * 2);
	        stack.push(br || [], z + 1, x * 2 + 1, y * 2 + 1);
	    }
	};

	GeoJSONVT.prototype.getTile = function (z, x, y) {
	    var options = this.options,
	        extent = options.extent,
	        debug = options.debug;

	    if (z < 0 || z > 24) return null;

	    var z2 = 1 << z;
	    x = ((x % z2) + z2) % z2; // wrap tile x coordinate

	    var id = toID(z, x, y);
	    if (this.tiles[id]) return transformTile(this.tiles[id], extent);

	    if (debug > 1) console.log('drilling down to z%d-%d-%d', z, x, y);

	    var z0 = z,
	        x0 = x,
	        y0 = y,
	        parent;

	    while (!parent && z0 > 0) {
	        z0--;
	        x0 = Math.floor(x0 / 2);
	        y0 = Math.floor(y0 / 2);
	        parent = this.tiles[toID(z0, x0, y0)];
	    }

	    if (!parent || !parent.source) return null;

	    // if we found a parent tile containing the original geometry, we can drill down from it
	    if (debug > 1) console.log('found parent tile z%d-%d-%d', z0, x0, y0);

	    if (debug > 1) console.time('drilling down');
	    this.splitTile(parent.source, z0, x0, y0, z, x, y);
	    if (debug > 1) console.timeEnd('drilling down');

	    return this.tiles[id] ? transformTile(this.tiles[id], extent) : null;
	};

	function toID(z, x, y) {
	    return (((1 << z) * y + x) * 32) + z;
	}

	function extend(dest, src) {
	    for (var i in src) dest[i] = src[i];
	    return dest;
	}

	function getFeatureId(feature, promoteId) {
	    return promoteId ? feature.properties[promoteId] : feature.id;
	}
	function isUpdateableGeoJSON(data, promoteId) {
	    // null can be updated
	    if (data == null) {
	        return true;
	    }
	    // a single feature with an id can be updated, need to explicitly check against null because 0 is a valid feature id that is falsy
	    if (data.type === 'Feature') {
	        return getFeatureId(data, promoteId) != null;
	    }
	    // a feature collection can be updated if every feature has an id, and the ids are all unique
	    // this prevents us from silently dropping features if ids get reused
	    if (data.type === 'FeatureCollection') {
	        const seenIds = new Set();
	        for (const feature of data.features) {
	            const id = getFeatureId(feature, promoteId);
	            if (id == null) {
	                return false;
	            }
	            if (seenIds.has(id)) {
	                return false;
	            }
	            seenIds.add(id);
	        }
	        return true;
	    }
	    return false;
	}
	function toUpdateable(data, promoteId) {
	    const result = new Map();
	    if (data == null) ;
	    else if (data.type === 'Feature') {
	        result.set(getFeatureId(data, promoteId), data);
	    }
	    else {
	        for (const feature of data.features) {
	            result.set(getFeatureId(feature, promoteId), feature);
	        }
	    }
	    return result;
	}
	// mutates updateable
	function applySourceDiff(updateable, diff, promoteId) {
	    var _a, _b, _c, _d;
	    if (diff.removeAll) {
	        updateable.clear();
	    }
	    if (diff.remove) {
	        for (const id of diff.remove) {
	            updateable.delete(id);
	        }
	    }
	    if (diff.add) {
	        for (const feature of diff.add) {
	            const id = getFeatureId(feature, promoteId);
	            if (id != null) {
	                updateable.set(id, feature);
	            }
	        }
	    }
	    if (diff.update) {
	        for (const update of diff.update) {
	            let feature = updateable.get(update.id);
	            if (feature == null) {
	                continue;
	            }
	            // be careful to clone the feature and/or properties objects to avoid mutating our input
	            const cloneFeature = update.newGeometry || update.removeAllProperties;
	            // note: removeAllProperties gives us a new properties object, so we can skip the clone step
	            const cloneProperties = !update.removeAllProperties && (((_a = update.removeProperties) === null || _a === void 0 ? void 0 : _a.length) > 0 || ((_b = update.addOrUpdateProperties) === null || _b === void 0 ? void 0 : _b.length) > 0);
	            if (cloneFeature || cloneProperties) {
	                feature = Object.assign({}, feature);
	                updateable.set(update.id, feature);
	                if (cloneProperties) {
	                    feature.properties = Object.assign({}, feature.properties);
	                }
	            }
	            if (update.newGeometry) {
	                feature.geometry = update.newGeometry;
	            }
	            if (update.removeAllProperties) {
	                feature.properties = {};
	            }
	            else if (((_c = update.removeProperties) === null || _c === void 0 ? void 0 : _c.length) > 0) {
	                for (const prop of update.removeProperties) {
	                    if (Object.prototype.hasOwnProperty.call(feature.properties, prop)) {
	                        delete feature.properties[prop];
	                    }
	                }
	            }
	            if (((_d = update.addOrUpdateProperties) === null || _d === void 0 ? void 0 : _d.length) > 0) {
	                for (const { key, value } of update.addOrUpdateProperties) {
	                    feature.properties[key] = value;
	                }
	            }
	        }
	    }
	}

	/**
	 * The {@link WorkerSource} implementation that supports {@link GeoJSONSource}.
	 * This class is designed to be easily reused to support custom source types
	 * for data formats that can be parsed/converted into an in-memory GeoJSON
	 * representation. To do so, create it with
	 * `new GeoJSONWorkerSource(actor, layerIndex, customLoadGeoJSONFunction)`.
	 * For a full example, see [mapbox-gl-topojson](https://github.com/developmentseed/mapbox-gl-topojson).
	 */
	class GeoJSONWorkerSource extends VectorTileWorkerSource {
	    constructor() {
	        super(...arguments);
	        this._dataUpdateable = new Map();
	    }
	    loadVectorTile(params, _abortController) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            const canonical = params.tileID.canonical;
	            if (!this._geoJSONIndex) {
	                throw new Error('Unable to parse the data into a cluster or geojson');
	            }
	            const geoJSONTile = this._geoJSONIndex.getTile(canonical.z, canonical.x, canonical.y);
	            if (!geoJSONTile) {
	                return null;
	            }
	            const geojsonWrapper = new GeoJSONWrapper$2(geoJSONTile.features);
	            // Encode the geojson-vt tile into binary vector tile form.  This
	            // is a convenience that allows `FeatureIndex` to operate the same way
	            // across `VectorTileSource` and `GeoJSONSource` data.
	            let pbf = vtpbf(geojsonWrapper);
	            if (pbf.byteOffset !== 0 || pbf.byteLength !== pbf.buffer.byteLength) {
	                // Compatibility with node Buffer (https://github.com/mapbox/pbf/issues/35)
	                pbf = new Uint8Array(pbf);
	            }
	            return {
	                vectorTile: geojsonWrapper,
	                rawData: pbf.buffer
	            };
	        });
	    }
	    /**
	     * Fetches (if appropriate), parses, and index geojson data into tiles. This
	     * preparatory method must be called before {@link GeoJSONWorkerSource#loadTile}
	     * can correctly serve up tiles.
	     *
	     * Defers to {@link GeoJSONWorkerSource#loadGeoJSON} for the fetching/parsing,
	     *
	     * When a `loadData` request comes in while a previous one is being processed,
	     * the previous one is aborted.
	     *
	     * @param params - the parameters
	     * @returns a promise that resolves when the data is loaded and parsed into a GeoJSON object
	     */
	    loadData(params) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            var _a;
	            (_a = this._pendingRequest) === null || _a === void 0 ? void 0 : _a.abort();
	            const perf = (params && params.request && params.request.collectResourceTiming) ?
	                new performance.RequestPerformance(params.request) : false;
	            this._pendingRequest = new AbortController();
	            try {
	                let data = yield this.loadGeoJSON(params, this._pendingRequest);
	                delete this._pendingRequest;
	                if (typeof data !== 'object') {
	                    throw new Error(`Input data given to '${params.source}' is not a valid GeoJSON object.`);
	                }
	                rewind$2(data, true);
	                if (params.filter) {
	                    const compiled = performance.createExpression(params.filter, { type: 'boolean', 'property-type': 'data-driven', overridable: false, transition: false });
	                    if (compiled.result === 'error')
	                        throw new Error(compiled.value.map(err => `${err.key}: ${err.message}`).join(', '));
	                    const features = data.features.filter(feature => compiled.value.evaluate({ zoom: 0 }, feature));
	                    data = { type: 'FeatureCollection', features };
	                }
	                this._geoJSONIndex = params.cluster ?
	                    new Supercluster(getSuperclusterOptions(params)).load(data.features) :
	                    geojsonvt(data, params.geojsonVtOptions);
	                this.loaded = {};
	                const result = {};
	                if (perf) {
	                    const resourceTimingData = perf.finish();
	                    // it's necessary to eval the result of getEntriesByName() here via parse/stringify
	                    // late evaluation in the main thread causes TypeError: illegal invocation
	                    if (resourceTimingData) {
	                        result.resourceTiming = {};
	                        result.resourceTiming[params.source] = JSON.parse(JSON.stringify(resourceTimingData));
	                    }
	                }
	                return result;
	            }
	            catch (err) {
	                delete this._pendingRequest;
	                if (performance.isAbortError(err)) {
	                    return { abandoned: true };
	                }
	                throw err;
	            }
	        });
	    }
	    /**
	    * Implements {@link WorkerSource#reloadTile}.
	    *
	    * If the tile is loaded, uses the implementation in VectorTileWorkerSource.
	    * Otherwise, such as after a setData() call, we load the tile fresh.
	    *
	    * @param params - the parameters
	    * @returns A promise that resolves when the tile is reloaded
	    */
	    reloadTile(params) {
	        const loaded = this.loaded, uid = params.uid;
	        if (loaded && loaded[uid]) {
	            return super.reloadTile(params);
	        }
	        else {
	            return this.loadTile(params);
	        }
	    }
	    /**
	     * Fetch and parse GeoJSON according to the given params.
	     *
	     * GeoJSON is loaded and parsed from `params.url` if it exists, or else
	     * expected as a literal (string or object) `params.data`.
	     *
	     * @param params - the parameters
	     * @param abortController - the abort controller that allows aborting this operation
	     * @returns a promise that resolves when the data is loaded
	     */
	    loadGeoJSON(params, abortController) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            const { promoteId } = params;
	            if (params.request) {
	                const response = yield performance.getJSON(params.request, abortController);
	                this._dataUpdateable = isUpdateableGeoJSON(response.data, promoteId) ? toUpdateable(response.data, promoteId) : undefined;
	                return response.data;
	            }
	            if (typeof params.data === 'string') {
	                try {
	                    const parsed = JSON.parse(params.data);
	                    this._dataUpdateable = isUpdateableGeoJSON(parsed, promoteId) ? toUpdateable(parsed, promoteId) : undefined;
	                    return parsed;
	                }
	                catch (e) {
	                    throw new Error(`Input data given to '${params.source}' is not a valid GeoJSON object.`);
	                }
	            }
	            if (!params.dataDiff) {
	                throw new Error(`Input data given to '${params.source}' is not a valid GeoJSON object.`);
	            }
	            if (!this._dataUpdateable) {
	                throw new Error(`Cannot update existing geojson data in ${params.source}`);
	            }
	            applySourceDiff(this._dataUpdateable, params.dataDiff, promoteId);
	            return { type: 'FeatureCollection', features: Array.from(this._dataUpdateable.values()) };
	        });
	    }
	    removeSource(_params) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            if (this._pendingRequest) {
	                this._pendingRequest.abort();
	            }
	        });
	    }
	    getClusterExpansionZoom(params) {
	        return this._geoJSONIndex.getClusterExpansionZoom(params.clusterId);
	    }
	    getClusterChildren(params) {
	        return this._geoJSONIndex.getChildren(params.clusterId);
	    }
	    getClusterLeaves(params) {
	        return this._geoJSONIndex.getLeaves(params.clusterId, params.limit, params.offset);
	    }
	}
	function getSuperclusterOptions({ superclusterOptions, clusterProperties }) {
	    if (!clusterProperties || !superclusterOptions)
	        return superclusterOptions;
	    const mapExpressions = {};
	    const reduceExpressions = {};
	    const globals = { accumulated: null, zoom: 0 };
	    const feature = { properties: null };
	    const propertyNames = Object.keys(clusterProperties);
	    for (const key of propertyNames) {
	        const [operator, mapExpression] = clusterProperties[key];
	        const mapExpressionParsed = performance.createExpression(mapExpression);
	        const reduceExpressionParsed = performance.createExpression(typeof operator === 'string' ? [operator, ['accumulated'], ['get', key]] : operator);
	        mapExpressions[key] = mapExpressionParsed.value;
	        reduceExpressions[key] = reduceExpressionParsed.value;
	    }
	    superclusterOptions.map = (pointProperties) => {
	        feature.properties = pointProperties;
	        const properties = {};
	        for (const key of propertyNames) {
	            properties[key] = mapExpressions[key].evaluate(globals, feature);
	        }
	        return properties;
	    };
	    superclusterOptions.reduce = (accumulated, clusterProperties) => {
	        feature.properties = clusterProperties;
	        for (const key of propertyNames) {
	            globals.accumulated = accumulated[key];
	            accumulated[key] = reduceExpressions[key].evaluate(globals, feature);
	        }
	    };
	    return superclusterOptions;
	}

	/**
	 * The Worker class responsidble for background thread related execution
	 */
	class Worker {
	    constructor(self) {
	        this.self = self;
	        this.actor = new performance.Actor(self);
	        this.layerIndexes = {};
	        this.availableImages = {};
	        this.workerSources = {};
	        this.demWorkerSources = {};
	        this.externalWorkerSourceTypes = {};
	        this.self.registerWorkerSource = (name, WorkerSource) => {
	            if (this.externalWorkerSourceTypes[name]) {
	                throw new Error(`Worker source with name "${name}" already registered.`);
	            }
	            this.externalWorkerSourceTypes[name] = WorkerSource;
	        };
	        this.self.addProtocol = performance.addProtocol;
	        this.self.removeProtocol = performance.removeProtocol;
	        // This is invoked by the RTL text plugin when the download via the `importScripts` call has finished, and the code has been parsed.
	        this.self.registerRTLTextPlugin = (rtlTextPlugin) => {
	            if (performance.rtlWorkerPlugin.isParsed()) {
	                throw new Error('RTL text plugin already registered.');
	            }
	            performance.rtlWorkerPlugin.setMethods(rtlTextPlugin);
	        };
	        this.actor.registerMessageHandler("LDT" /* MessageType.loadDEMTile */, (mapId, params) => {
	            return this._getDEMWorkerSource(mapId, params.source).loadTile(params);
	        });
	        this.actor.registerMessageHandler("RDT" /* MessageType.removeDEMTile */, (mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            this._getDEMWorkerSource(mapId, params.source).removeTile(params);
	        }));
	        this.actor.registerMessageHandler("GCEZ" /* MessageType.getClusterExpansionZoom */, (mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            return this._getWorkerSource(mapId, params.type, params.source).getClusterExpansionZoom(params);
	        }));
	        this.actor.registerMessageHandler("GCC" /* MessageType.getClusterChildren */, (mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            return this._getWorkerSource(mapId, params.type, params.source).getClusterChildren(params);
	        }));
	        this.actor.registerMessageHandler("GCL" /* MessageType.getClusterLeaves */, (mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            return this._getWorkerSource(mapId, params.type, params.source).getClusterLeaves(params);
	        }));
	        this.actor.registerMessageHandler("LD" /* MessageType.loadData */, (mapId, params) => {
	            return this._getWorkerSource(mapId, params.type, params.source).loadData(params);
	        });
	        this.actor.registerMessageHandler("LT" /* MessageType.loadTile */, (mapId, params) => {
	            return this._getWorkerSource(mapId, params.type, params.source).loadTile(params);
	        });
	        this.actor.registerMessageHandler("RT" /* MessageType.reloadTile */, (mapId, params) => {
	            return this._getWorkerSource(mapId, params.type, params.source).reloadTile(params);
	        });
	        this.actor.registerMessageHandler("AT" /* MessageType.abortTile */, (mapId, params) => {
	            return this._getWorkerSource(mapId, params.type, params.source).abortTile(params);
	        });
	        this.actor.registerMessageHandler("RMT" /* MessageType.removeTile */, (mapId, params) => {
	            return this._getWorkerSource(mapId, params.type, params.source).removeTile(params);
	        });
	        this.actor.registerMessageHandler("RS" /* MessageType.removeSource */, (mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            if (!this.workerSources[mapId] ||
	                !this.workerSources[mapId][params.type] ||
	                !this.workerSources[mapId][params.type][params.source]) {
	                return;
	            }
	            const worker = this.workerSources[mapId][params.type][params.source];
	            delete this.workerSources[mapId][params.type][params.source];
	            if (worker.removeSource !== undefined) {
	                worker.removeSource(params);
	            }
	        }));
	        this.actor.registerMessageHandler("RM" /* MessageType.removeMap */, (mapId) => performance.__awaiter(this, void 0, void 0, function* () {
	            delete this.layerIndexes[mapId];
	            delete this.availableImages[mapId];
	            delete this.workerSources[mapId];
	            delete this.demWorkerSources[mapId];
	        }));
	        this.actor.registerMessageHandler("SR" /* MessageType.setReferrer */, (_mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            this.referrer = params;
	        }));
	        this.actor.registerMessageHandler("SRPS" /* MessageType.syncRTLPluginState */, (mapId, params) => {
	            return this._syncRTLPluginState(mapId, params);
	        });
	        this.actor.registerMessageHandler("IS" /* MessageType.importScript */, (_mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            this.self.importScripts(params);
	        }));
	        this.actor.registerMessageHandler("SI" /* MessageType.setImages */, (mapId, params) => {
	            return this._setImages(mapId, params);
	        });
	        this.actor.registerMessageHandler("UL" /* MessageType.updateLayers */, (mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            this._getLayerIndex(mapId).update(params.layers, params.removedIds);
	        }));
	        this.actor.registerMessageHandler("SL" /* MessageType.setLayers */, (mapId, params) => performance.__awaiter(this, void 0, void 0, function* () {
	            this._getLayerIndex(mapId).replace(params);
	        }));
	    }
	    _setImages(mapId, images) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            this.availableImages[mapId] = images;
	            for (const workerSource in this.workerSources[mapId]) {
	                const ws = this.workerSources[mapId][workerSource];
	                for (const source in ws) {
	                    ws[source].availableImages = images;
	                }
	            }
	        });
	    }
	    _syncRTLPluginState(mapId, incomingState) {
	        return performance.__awaiter(this, void 0, void 0, function* () {
	            // Parsed plugin cannot be changed, so just return its current state.
	            if (performance.rtlWorkerPlugin.isParsed()) {
	                return performance.rtlWorkerPlugin.getState();
	            }
	            if (incomingState.pluginStatus !== 'loading') {
	                // simply sync and done
	                performance.rtlWorkerPlugin.setState(incomingState);
	                return incomingState;
	            }
	            const urlToLoad = incomingState.pluginURL;
	            this.self.importScripts(urlToLoad);
	            const complete = performance.rtlWorkerPlugin.isParsed();
	            if (complete) {
	                const loadedState = {
	                    pluginStatus: 'loaded',
	                    pluginURL: urlToLoad
	                };
	                performance.rtlWorkerPlugin.setState(loadedState);
	                return loadedState;
	            }
	            // error case
	            performance.rtlWorkerPlugin.setState({
	                pluginStatus: 'error',
	                pluginURL: ''
	            });
	            throw new Error(`RTL Text Plugin failed to import scripts from ${urlToLoad}`);
	        });
	    }
	    _getAvailableImages(mapId) {
	        let availableImages = this.availableImages[mapId];
	        if (!availableImages) {
	            availableImages = [];
	        }
	        return availableImages;
	    }
	    _getLayerIndex(mapId) {
	        let layerIndexes = this.layerIndexes[mapId];
	        if (!layerIndexes) {
	            layerIndexes = this.layerIndexes[mapId] = new StyleLayerIndex();
	        }
	        return layerIndexes;
	    }
	    /**
	     * This is basically a lazy initialization of a worker per mapId and sourceType and sourceName
	     * @param mapId - the mapId
	     * @param sourceType - the source type - 'vector' for example
	     * @param sourceName - the source name - 'osm' for example
	     * @returns a new instance or a cached one
	     */
	    _getWorkerSource(mapId, sourceType, sourceName) {
	        if (!this.workerSources[mapId])
	            this.workerSources[mapId] = {};
	        if (!this.workerSources[mapId][sourceType])
	            this.workerSources[mapId][sourceType] = {};
	        if (!this.workerSources[mapId][sourceType][sourceName]) {
	            // use a wrapped actor so that we can attach a target mapId param
	            // to any messages invoked by the WorkerSource, this is very important when there are multiple maps
	            const actor = {
	                sendAsync: (message, abortController) => {
	                    message.targetMapId = mapId;
	                    return this.actor.sendAsync(message, abortController);
	                }
	            };
	            switch (sourceType) {
	                case 'vector':
	                    this.workerSources[mapId][sourceType][sourceName] = new VectorTileWorkerSource(actor, this._getLayerIndex(mapId), this._getAvailableImages(mapId));
	                    break;
	                case 'geojson':
	                    this.workerSources[mapId][sourceType][sourceName] = new GeoJSONWorkerSource(actor, this._getLayerIndex(mapId), this._getAvailableImages(mapId));
	                    break;
	                default:
	                    this.workerSources[mapId][sourceType][sourceName] = new (this.externalWorkerSourceTypes[sourceType])(actor, this._getLayerIndex(mapId), this._getAvailableImages(mapId));
	                    break;
	            }
	        }
	        return this.workerSources[mapId][sourceType][sourceName];
	    }
	    /**
	     * This is basically a lazy initialization of a worker per mapId and source
	     * @param mapId - the mapId
	     * @param sourceType - the source type - 'raster-dem' for example
	     * @returns a new instance or a cached one
	     */
	    _getDEMWorkerSource(mapId, sourceType) {
	        if (!this.demWorkerSources[mapId])
	            this.demWorkerSources[mapId] = {};
	        if (!this.demWorkerSources[mapId][sourceType]) {
	            this.demWorkerSources[mapId][sourceType] = new RasterDEMTileWorkerSource();
	        }
	        return this.demWorkerSources[mapId][sourceType];
	    }
	}
	if (performance.isWorker(self)) {
	    self.worker = new Worker(self);
	}

	return Worker;

	}));

	define('index', ['exports', './shared'], (function (exports, performance$1) {
	var name = "azuremaps-maplibre-gl";
	var description = "BSD licensed community fork of mapbox-gl, a WebGL interactive maps library";
	var version$2 = "4.1.2";
	var main = "dist/azuremaps-maplibre-gl.js";
	var style = "dist/azuremaps-maplibre-gl.css";
	var license = "BSD-3-Clause";
	var homepage = "https://maplibre.org/";
	var funding = "https://github.com/maplibre/maplibre-gl-js?sponsor=1";
	var bugs = {
		url: "https://github.com/maplibre/maplibre-gl-js/issues/"
	};
	var repository = {
		type: "git",
		url: "https://dev.azure.com/msazure/One/_git/Azure-IoT-Maps-maplibre-gl-js"
	};
	var types = "dist/azuremaps-maplibre-gl.d.ts";
	var type = "module";
	var dependencies = {
		"@mapbox/geojson-rewind": "^0.5.2",
		"@mapbox/jsonlint-lines-primitives": "^2.0.2",
		"@mapbox/point-geometry": "^0.1.0",
		"@mapbox/tiny-sdf": "^2.0.6",
		"@mapbox/unitbezier": "^0.0.1",
		"@mapbox/vector-tile": "^1.3.1",
		"@mapbox/whoots-js": "^3.1.0",
		"@maplibre/maplibre-gl-style-spec": "^20.1.1",
		"@types/geojson": "^7946.0.14",
		"@types/geojson-vt": "3.2.5",
		"@types/mapbox__point-geometry": "^0.1.4",
		"@types/mapbox__vector-tile": "^1.3.4",
		"@types/pbf": "^3.0.5",
		"@types/supercluster": "^7.1.3",
		earcut: "^2.2.4",
		"geojson-vt": "^3.2.1",
		"gl-matrix": "^3.4.3",
		"global-prefix": "^3.0.0",
		kdbush: "^4.0.2",
		"murmurhash-js": "^1.0.0",
		pbf: "^3.2.1",
		potpack: "^2.0.0",
		quickselect: "^2.0.0",
		supercluster: "^8.0.1",
		tinyqueue: "^2.0.3",
		"vt-pbf": "^3.1.3"
	};
	var devDependencies = {
		"@mapbox/mapbox-gl-rtl-text": "^0.2.3",
		"@mapbox/mvt-fixtures": "^3.10.0",
		"@rollup/plugin-commonjs": "^25.0.7",
		"@rollup/plugin-json": "^6.1.0",
		"@rollup/plugin-node-resolve": "^15.2.3",
		"@rollup/plugin-replace": "^5.0.5",
		"@rollup/plugin-strip": "^3.0.4",
		"@rollup/plugin-terser": "^0.4.4",
		"@rollup/plugin-typescript": "^11.1.6",
		"@types/benchmark": "^2.1.5",
		"@types/cssnano": "^5.0.0",
		"@types/d3": "^7.4.3",
		"@types/diff": "^5.0.9",
		"@types/earcut": "^2.1.4",
		"@types/eslint": "^8.56.7",
		"@types/gl": "^6.0.5",
		"@types/glob": "^8.1.0",
		"@types/jest": "^29.5.12",
		"@types/jsdom": "^21.1.6",
		"@types/minimist": "^1.2.5",
		"@types/murmurhash-js": "^1.0.6",
		"@types/nise": "^1.4.4",
		"@types/node": "^20.12.6",
		"@types/offscreencanvas": "^2019.7.3",
		"@types/pixelmatch": "^5.2.6",
		"@types/pngjs": "^6.0.4",
		"@types/react": "^18.2.75",
		"@types/react-dom": "^18.2.24",
		"@types/request": "^2.48.12",
		"@types/shuffle-seed": "^1.1.3",
		"@types/window-or-global": "^1.0.6",
		"@typescript-eslint/eslint-plugin": "^7.6.0",
		"@typescript-eslint/parser": "^7.6.0",
		address: "^2.0.2",
		benchmark: "^2.1.4",
		canvas: "^2.11.2",
		cssnano: "^6.1.2",
		d3: "^7.9.0",
		"d3-queue": "^3.0.7",
		"devtools-protocol": "^0.0.1284279",
		diff: "^5.2.0",
		"dts-bundle-generator": "^9.3.1",
		eslint: "^8.57.0",
		"eslint-config-mourner": "^3.0.0",
		"eslint-plugin-html": "^8.0.0",
		"eslint-plugin-import": "^2.29.1",
		"eslint-plugin-jest": "^28.2.0",
		"eslint-plugin-react": "^7.34.1",
		"eslint-plugin-tsdoc": "0.2.17",
		expect: "^29.7.0",
		glob: "^10.3.12",
		"is-builtin-module": "^3.2.1",
		jest: "^29.7.0",
		"jest-environment-jsdom": "^29.7.0",
		"jest-monocart-coverage": "^1.1.0",
		"jest-webgl-canvas-mock": "^2.5.3",
		jsdom: "^24.0.0",
		"json-stringify-pretty-compact": "^4.0.0",
		minimist: "^1.2.8",
		"mock-geolocation": "^1.0.11",
		"monocart-coverage-reports": "^2.7.8",
		nise: "^5.1.9",
		"npm-font-open-sans": "^1.1.0",
		"npm-run-all": "^4.1.5",
		"pdf-merger-js": "^5.1.1",
		pixelmatch: "^5.3.0",
		pngjs: "^7.0.0",
		postcss: "^8.4.38",
		"postcss-cli": "^11.0.0",
		"postcss-inline-svg": "^6.0.0",
		"pretty-bytes": "^6.1.1",
		puppeteer: "^22.6.3",
		react: "^18.2.0",
		"react-dom": "^18.2.0",
		rollup: "^4.14.1",
		"rollup-plugin-sourcemaps": "^0.6.3",
		rw: "^1.3.3",
		semver: "^7.6.0",
		"shuffle-seed": "^1.1.6",
		"source-map-explorer": "^2.5.3",
		st: "^3.0.0",
		stylelint: "^16.3.1",
		"stylelint-config-standard": "^36.0.0",
		"ts-jest": "^29.1.2",
		"ts-node": "^10.9.2",
		tslib: "^2.6.2",
		typedoc: "^0.25.13",
		"typedoc-plugin-markdown": "^3.17.1",
		"typedoc-plugin-missing-exports": "^2.2.0",
		typescript: "^5.4.4"
	};
	var overrides = {
		"postcss-inline-svg": {
			"css-select": "^5.1.0",
			"dom-serializer": "^2.0.0",
			htmlparser2: "^8.0.1",
			"postcss-value-parser": "^4.2.0"
		}
	};
	var scripts = {
		"generate-dist-package": "node --no-warnings --loader ts-node/esm build/generate-dist-package.js",
		"generate-shaders": "node --no-warnings --loader ts-node/esm build/generate-shaders.ts",
		"generate-struct-arrays": "node --no-warnings --loader ts-node/esm build/generate-struct-arrays.ts",
		"generate-style-code": "node --no-warnings --loader ts-node/esm build/generate-style-code.ts",
		"generate-typings": "dts-bundle-generator --export-referenced-types --umd-module-name=maplibregl -o ./dist/maplibre-gl.d.ts ./src/index.ts",
		"generate-docs": "typedoc && node --no-warnings --loader ts-node/esm build/generate-docs.ts",
		"generate-images": "node --no-warnings --loader ts-node/esm build/generate-doc-images.ts",
		"build-dist": "npm run build-css && npm run generate-typings && npm run build-dev && npm run build-csp-dev && npm run build-prod && npm run build-csp",
		"build-dev": "rollup --configPlugin @rollup/plugin-typescript -c --environment BUILD:dev",
		"watch-dev": "rollup --configPlugin @rollup/plugin-typescript -c --environment BUILD:dev --watch",
		"build-prod": "rollup --configPlugin @rollup/plugin-typescript -c --environment BUILD:production",
		"build-csp": "rollup --configPlugin @rollup/plugin-typescript -c rollup.config.csp.ts",
		"build-csp-dev": "rollup --configPlugin @rollup/plugin-typescript -c rollup.config.csp.ts --environment BUILD:dev",
		"build-css": "postcss -o dist/maplibre-gl.css src/css/maplibre-gl.css",
		"watch-css": "postcss --watch -o dist/maplibre-gl.css src/css/maplibre-gl.css",
		"build-benchmarks": "npm run build-dev && rollup --configPlugin @rollup/plugin-typescript -c test/bench/rollup_config_benchmarks.ts",
		"watch-benchmarks": "rollup --configPlugin @rollup/plugin-typescript -c test/bench/rollup_config_benchmarks.ts --watch",
		"start-server": "st --no-cache -H 0.0.0.0 --port 9966 .",
		"start-docs": "docker run --rm -it -p 8000:8000 -v ${PWD}:/docs squidfunk/mkdocs-material",
		start: "run-p watch-css watch-dev start-server",
		"start-bench": "run-p watch-css watch-benchmarks start-server",
		lint: "eslint --cache --ext .ts,.tsx,.js,.html --ignore-path .gitignore .",
		"lint-css": "stylelint src/css/maplibre-gl.css",
		test: "run-p lint lint-css test-render jest",
		jest: "jest",
		"test-build": "jest --selectProjects=build --reporters=default",
		"test-build-ci": "jest --selectProjects=build",
		"test-integration": "jest --selectProjects=integration --reporters=default",
		"test-integration-ci": "jest --selectProjects=integration",
		"test-render": "node --no-warnings --loader ts-node/esm test/integration/render/run_render_tests.ts",
		"test-unit": "jest --selectProjects=unit --reporters=default",
		"test-unit-ci": "jest --coverage --selectProjects unit",
		"test-watch-roots": "jest --watch",
		codegen: "run-p --print-label generate-dist-package generate-style-code generate-struct-arrays generate-shaders && npm run generate-typings",
		benchmark: "node --no-warnings --loader ts-node/esm test/bench/run-benchmarks.ts",
		"gl-stats": "node --no-warnings --loader ts-node/esm test/bench/gl-stats.ts",
		prepare: "npm run codegen",
		typecheck: "tsc --noEmit && tsc --project tsconfig.dist.json",
		tsnode: "node --experimental-loader=ts-node/esm --no-warnings",
		"build-aml-css": "postcss -o dist/azuremaps-maplibre-gl.css src/css/azuremaps-maplibre-gl.css",
		"watch-aml-css": "postcss --watch -o dist/azuremaps-maplibre-gl.css src/css/azuremaps-maplibre-gl.css",
		"build-es2017-dev": "rollup --configPlugin @rollup/plugin-typescript -c rollup.config.es2017.ts --environment BUILD:dev",
		"build-es2017": "rollup --configPlugin @rollup/plugin-typescript -c rollup.config.es2017.ts --environment BUILD:production",
		"generate-aml-typings": "dts-bundle-generator --export-referenced-types --umd-module-name=maplibregl -o ./dist/azuremaps-maplibre-gl.d.ts ./src/index.ts",
		"build-aml-dist": "npm run generate-aml-typings && run-p --print-label build-aml-css build-dev build-prod build-es2017-dev build-es2017",
		"build-aml-package": "npm run build-aml-dist && node ./build/build-aml-package.js"
	};
	var files = [
		"build/",
		"dist/azuremaps-maplibre-gl*",
		"dist/package.json",
		"src/"
	];
	var engines = {
		npm: ">=8.1.0",
		node: ">=16.14.0"
	};
	var packageJSON = {
		name: name,
		description: description,
		version: version$2,
		main: main,
		style: style,
		license: license,
		homepage: homepage,
		funding: funding,
		bugs: bugs,
		repository: repository,
		types: types,
		type: type,
		dependencies: dependencies,
		devDependencies: devDependencies,
		overrides: overrides,
		scripts: scripts,
		files: files,
		engines: engines
	};

	const now = typeof performance !== 'undefined' && performance && performance.now ?
	    performance.now.bind(performance) :
	    Date.now.bind(Date);
	let linkEl;
	let reducedMotionQuery;
	/** */
	const browser = {
	    /**
	     * Provides a function that outputs milliseconds: either performance.now()
	     * or a fallback to Date.now()
	     */
	    now,
	    frameAsync(abortController) {
	        return new Promise((resolve, reject) => {
	            const frame = requestAnimationFrame(resolve);
	            abortController.signal.addEventListener('abort', () => {
	                cancelAnimationFrame(frame);
	                reject(performance$1.createAbortError());
	            });
	        });
	    },
	    getImageData(img, padding = 0) {
	        const context = this.getImageCanvasContext(img);
	        return context.getImageData(-padding, -padding, img.width + 2 * padding, img.height + 2 * padding);
	    },
	    getImageCanvasContext(img) {
	        const canvas = window.document.createElement('canvas');
	        const context = canvas.getContext('2d', { willReadFrequently: true });
	        if (!context) {
	            throw new Error('failed to create canvas 2d context');
	        }
	        canvas.width = img.width;
	        canvas.height = img.height;
	        context.drawImage(img, 0, 0, img.width, img.height);
	        return context;
	    },
	    resolveURL(path) {
	        if (!linkEl)
	            linkEl = document.createElement('a');
	        linkEl.href = path;
	        return linkEl.href;
	    },
	    hardwareConcurrency: typeof navigator !== 'undefined' && navigator.hardwareConcurrency || 4,
	    get prefersReducedMotion() {
	        // In case your test crashes when checking matchMedia, call setMatchMedia from 'src/util/test/util'
	        if (!matchMedia)
	            return false;
	        //Lazily initialize media query
	        if (reducedMotionQuery == null) {
	            reducedMotionQuery = matchMedia('(prefers-reduced-motion: reduce)');
	        }
	        return reducedMotionQuery.matches;
	    },
	};

	class DOM {
	    static testProp(props) {
	        if (!DOM.docStyle)
	            return props[0];
	        for (let i = 0; i < props.length; i++) {
	            if (props[i] in DOM.docStyle) {
	                return props[i];
	            }
	        }
	        return props[0];
	    }
	    static create(tagName, className, container) {
	        const el = window.document.createElement(tagName);
	        if (className !== undefined)
	            el.className = className;
	        if (container)
	            container.appendChild(el);
	        return el;
	    }
	    static createNS(namespaceURI, tagName) {
	        const el = window.document.createElementNS(namespaceURI, tagName);
	        return el;
	    }
	    static disableDrag() {
	        if (DOM.docStyle && DOM.selectProp) {
	            DOM.userSelect = DOM.docStyle[DOM.selectProp];
	            DOM.docStyle[DOM.selectProp] = 'none';
	        }
	    }
	    static enableDrag() {
	        if (DOM.docStyle && DOM.selectProp) {
	            DOM.docStyle[DOM.selectProp] = DOM.userSelect;
	        }
	    }
	    static setTransform(el, value) {
	        el.style[DOM.transformProp] = value;
	    }
	    static addEventListener(target, type, callback, options = {}) {
	        if ('passive' in options) {
	            target.addEventListener(type, callback, options);
	        }
	        else {
	            target.addEventListener(type, callback, options.capture);
	        }
	    }
	    static removeEventListener(target, type, callback, options = {}) {
	        if ('passive' in options) {
	            target.removeEventListener(type, callback, options);
	        }
	        else {
	            target.removeEventListener(type, callback, options.capture);
	        }
	    }
	    // Suppress the next click, but only if it's immediate.
	    static suppressClickInternal(e) {
	        e.preventDefault();
	        e.stopPropagation();
	        window.removeEventListener('click', DOM.suppressClickInternal, true);
	    }
	    static suppressClick() {
	        window.addEventListener('click', DOM.suppressClickInternal, true);
	        window.setTimeout(() => {
	            window.removeEventListener('click', DOM.suppressClickInternal, true);
	        }, 0);
	    }
	    static getScale(element) {
	        const rect = element.getBoundingClientRect();
	        return {
	            x: (rect.width / element.offsetWidth) || 1,
	            y: (rect.height / element.offsetHeight) || 1,
	            boundingClientRect: rect,
	        };
	    }
	    static getPoint(el, scale, e) {
	        const rect = scale.boundingClientRect;
	        return new performance$1.Point(
	        // rect.left/top values are in page scale (like clientX/Y),
	        // whereas clientLeft/Top (border width) values are the original values (before CSS scale applies).
	        ((e.clientX - rect.left) / scale.x) - el.clientLeft, ((e.clientY - rect.top) / scale.y) - el.clientTop);
	    }
	    static mousePos(el, e) {
	        const scale = DOM.getScale(el);
	        return DOM.getPoint(el, scale, e);
	    }
	    static touchPos(el, touches) {
	        const points = [];
	        const scale = DOM.getScale(el);
	        for (let i = 0; i < touches.length; i++) {
	            points.push(DOM.getPoint(el, scale, touches[i]));
	        }
	        return points;
	    }
	    static mouseButton(e) {
	        return e.button;
	    }
	    static remove(node) {
	        if (node.parentNode) {
	            node.parentNode.removeChild(node);
	        }
	    }
	}
	DOM.docStyle = typeof window !== 'undefined' && window.document && window.document.documentElement.style;
	DOM.selectProp = DOM.testProp(['userSelect', 'MozUserSelect', 'WebkitUserSelect', 'msUserSelect']);
	DOM.transformProp = DOM.testProp(['transform', 'WebkitTransform']);

	const webpSupported = {
	    supported: false,
	    testSupport
	};
	let glForTesting;
	let webpCheckComplete = false;
	let webpImgTest;
	let webpImgTestOnloadComplete = false;
	if (typeof document !== 'undefined') {
	    webpImgTest = document.createElement('img');
	    webpImgTest.onload = function () {
	        if (glForTesting)
	            testWebpTextureUpload(glForTesting);
	        glForTesting = null;
	        webpImgTestOnloadComplete = true;
	    };
	    webpImgTest.onerror = function () {
	        webpCheckComplete = true;
	        glForTesting = null;
	    };
	    webpImgTest.src = 'data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=';
	}
	function testSupport(gl) {
	    if (webpCheckComplete || !webpImgTest)
	        return;
	    // HTMLImageElement.complete is set when an image is done loading it's source
	    // regardless of whether the load was successful or not.
	    // It's possible for an error to set HTMLImageElement.complete to true which would trigger
	    // testWebpTextureUpload and mistakenly set exported.supported to true in browsers which don't support webp
	    // To avoid this, we set a flag in the image's onload handler and only call testWebpTextureUpload
	    // after a successful image load event.
	    if (webpImgTestOnloadComplete) {
	        testWebpTextureUpload(gl);
	    }
	    else {
	        glForTesting = gl;
	    }
	}
	function testWebpTextureUpload(gl) {
	    // Edge 18 supports WebP but not uploading a WebP image to a gl texture
	    // Test support for this before allowing WebP images.
	    // https://github.com/mapbox/mapbox-gl-js/issues/7671
	    const texture = gl.createTexture();
	    gl.bindTexture(gl.TEXTURE_2D, texture);
	    try {
	        gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, webpImgTest);
	        // The error does not get triggered in Edge if the context is lost
	        if (gl.isContextLost())
	            return;
	        webpSupported.supported = true;
	    }
	    catch (e) {
	        // Catch "Unspecified Error." in Edge 18.
	    }
	    gl.deleteTexture(texture);
	    webpCheckComplete = true;
	}

	/**
	 * By default, the image queue is self driven, meaning as soon as one requested item is processed,
	 * it will move on to next one as quickly as it can while limiting
	 * the number of concurrent requests to MAX_PARALLEL_IMAGE_REQUESTS. The default behavior
	 * ensures that static views of the map can be rendered with minimal delay.
	 *
	 * However, the default behavior can prevent dynamic views of the map from rendering
	 * smoothly in that many requests can finish in one render frame, putting too much pressure on GPU.
	 *
	 * When the view of the map is moving dynamically, smoother frame rates can be achieved
	 * by throttling the number of items processed by the queue per frame. This can be
	 * accomplished by using {@link addThrottleControl} to allow the caller to
	 * use a lambda function to determine when the queue should be throttled (e.g. when isMoving())
	 * and manually calling {@link processQueue} in the render loop.
	 */
	var ImageRequest;
	(function (ImageRequest) {
	    let imageRequestQueue;
	    let currentParallelImageRequests;
	    let throttleControlCallbackHandleCounter;
	    let throttleControlCallbacks;
	    /**
	     * Reset the image request queue, removing all pending requests.
	     */
	    ImageRequest.resetRequestQueue = () => {
	        imageRequestQueue = [];
	        currentParallelImageRequests = 0;
	        throttleControlCallbackHandleCounter = 0;
	        throttleControlCallbacks = {};
	    };
	    /**
	     * Install a callback to control when image queue throttling is desired.
	     * (e.g. when the map view is moving)
	     * @param callback - The callback function to install
	     * @returns handle that identifies the installed callback.
	     */
	    ImageRequest.addThrottleControl = (callback) => {
	        const handle = throttleControlCallbackHandleCounter++;
	        throttleControlCallbacks[handle] = callback;
	        return handle;
	    };
	    /**
	     * Remove a previously installed callback by passing in the handle returned
	     * by {@link addThrottleControl}.
	     * @param callbackHandle - The handle for the callback to remove.
	     */
	    ImageRequest.removeThrottleControl = (callbackHandle) => {
	        delete throttleControlCallbacks[callbackHandle];
	        // Try updating the queue
	        processQueue();
	    };
	    /**
	     * Check to see if any of the installed callbacks are requesting the queue
	     * to be throttled.
	     * @returns `true` if any callback is causing the queue to be throttled.
	     */
	    const isThrottled = () => {
	        for (const key of Object.keys(throttleControlCallbacks)) {
	            if (throttleControlCallbacks[key]()) {
	                return true;
	            }
	        }
	        return false;
	    };
	    /**
	     * Request to load an image.
	     * @param requestParameters - Request parameters.
	     * @param abortController - allows to abort the request.
	     * @param supportImageRefresh - `true`, if the image request need to support refresh based on cache headers.
	     * @returns - A promise resolved when the image is loaded.
	     */
	    ImageRequest.getImage = (requestParameters, abortController, supportImageRefresh = true) => {
	        return new Promise((resolve, reject) => {
	            if (webpSupported.supported) {
	                if (!requestParameters.headers) {
	                    requestParameters.headers = {};
	                }
	                requestParameters.headers.accept = 'image/webp,*/*';
	            }
	            performance$1.extend(requestParameters, { type: 'image' });
	            const request = {
	                abortController,
	                requestParameters,
	                supportImageRefresh,
	                state: 'queued',
	                onError: (error) => {
	                    reject(error);
	                },
	                onSuccess: (response) => {
	                    resolve(response);
	                }
	            };
	            imageRequestQueue.push(request);
	            processQueue();
	        });
	    };
	    const arrayBufferToCanvasImageSource = (data) => {
	        const imageBitmapSupported = typeof createImageBitmap === 'function';
	        if (imageBitmapSupported) {
	            return performance$1.arrayBufferToImageBitmap(data);
	        }
	        else {
	            return performance$1.arrayBufferToImage(data);
	        }
	    };
	    const doImageRequest = (itemInQueue) => performance$1.__awaiter(this, void 0, void 0, function* () {
	        itemInQueue.state = 'running';
	        const { requestParameters, supportImageRefresh, onError, onSuccess, abortController } = itemInQueue;
	        // - If refreshExpiredTiles is false, then we can use HTMLImageElement to download raster images.
	        // - Fetch/XHR (via MakeRequest API) will be used to download images for following scenarios:
	        //      1. Style image sprite will had a issue with HTMLImageElement as described
	        //          here: https://github.com/mapbox/mapbox-gl-js/issues/1470
	        //      2. If refreshExpiredTiles is true (default), then in order to read the image cache header,
	        //          fetch/XHR request will be required
	        // - For any special case handling like use of AddProtocol, worker initiated request or additional headers
	        //      let makeRequest handle it.
	        // - HtmlImageElement request automatically adds accept header for all the browser supported images
	        const canUseHTMLImageElement = supportImageRefresh === false &&
	            !performance$1.isWorker(self) &&
	            !performance$1.getProtocol(requestParameters.url) &&
	            (!requestParameters.headers ||
	                Object.keys(requestParameters.headers).reduce((acc, item) => acc && item === 'accept', true));
	        currentParallelImageRequests++;
	        const getImagePromise = canUseHTMLImageElement ?
	            getImageUsingHtmlImage(requestParameters, abortController) :
	            performance$1.makeRequest(requestParameters, abortController);
	        try {
	            const response = yield getImagePromise;
	            delete itemInQueue.abortController;
	            itemInQueue.state = 'completed';
	            if (response.data instanceof HTMLImageElement || performance$1.isImageBitmap(response.data)) {
	                // User using addProtocol can directly return HTMLImageElement/ImageBitmap type
	                // If HtmlImageElement is used to get image then response type will be HTMLImageElement
	                onSuccess(response);
	            }
	            else if (response.data) {
	                const img = yield arrayBufferToCanvasImageSource(response.data);
	                onSuccess({ data: img, cacheControl: response.cacheControl, expires: response.expires });
	            }
	        }
	        catch (err) {
	            delete itemInQueue.abortController;
	            onError(err);
	        }
	        finally {
	            currentParallelImageRequests--;
	            processQueue();
	        }
	    });
	    /**
	     * Process some number of items in the image request queue.
	     */
	    const processQueue = () => {
	        const maxImageRequests = isThrottled() ?
	            performance$1.config.MAX_PARALLEL_IMAGE_REQUESTS_PER_FRAME :
	            performance$1.config.MAX_PARALLEL_IMAGE_REQUESTS;
	        // limit concurrent image loads to help with raster sources performance on big screens
	        for (let numImageRequests = currentParallelImageRequests; numImageRequests < maxImageRequests && imageRequestQueue.length > 0; numImageRequests++) {
	            const topItemInQueue = imageRequestQueue.shift();
	            if (topItemInQueue.abortController.signal.aborted) {
	                numImageRequests--;
	                continue;
	            }
	            doImageRequest(topItemInQueue);
	        }
	    };
	    const getImageUsingHtmlImage = (requestParameters, abortController) => {
	        return new Promise((resolve, reject) => {
	            const image = new Image();
	            const url = requestParameters.url;
	            const credentials = requestParameters.credentials;
	            if (credentials && credentials === 'include') {
	                image.crossOrigin = 'use-credentials';
	            }
	            else if ((credentials && credentials === 'same-origin') || !performance$1.sameOrigin(url)) {
	                image.crossOrigin = 'anonymous';
	            }
	            abortController.signal.addEventListener('abort', () => {
	                // Set src to '' to actually cancel the request
	                image.src = '';
	                reject(performance$1.createAbortError());
	            });
	            image.fetchPriority = 'high';
	            image.onload = () => {
	                image.onerror = image.onload = null;
	                resolve({ data: image });
	            };
	            image.onerror = () => {
	                image.onerror = image.onload = null;
	                if (abortController.signal.aborted) {
	                    return;
	                }
	                reject(new Error('Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported.'));
	            };
	            image.src = url;
	        });
	    };
	})(ImageRequest || (ImageRequest = {}));
	ImageRequest.resetRequestQueue();

	class RequestManager {
	    constructor(transformRequestFn) {
	        this._transformRequestFn = transformRequestFn;
	    }
	    transformRequest(url, type) {
	        if (this._transformRequestFn) {
	            return this._transformRequestFn(url, type) || { url };
	        }
	        return { url };
	    }
	    normalizeSpriteURL(url, format, extension) {
	        const urlObject = parseUrl(url);
	        urlObject.path += `${format}${extension}`;
	        return formatUrl(urlObject);
	    }
	    setTransformRequest(transformRequest) {
	        this._transformRequestFn = transformRequest;
	    }
	}
	const urlRe = /^(\w+):\/\/([^/?]*)(\/[^?]+)?\??(.+)?/;
	function parseUrl(url) {
	    const parts = url.match(urlRe);
	    if (!parts) {
	        throw new Error(`Unable to parse URL "${url}"`);
	    }
	    return {
	        protocol: parts[1],
	        authority: parts[2],
	        path: parts[3] || '/',
	        params: parts[4] ? parts[4].split('&') : []
	    };
	}
	function formatUrl(obj) {
	    const params = obj.params.length ? `?${obj.params.join('&')}` : '';
	    return `${obj.protocol}://${obj.authority}${obj.path}${params}`;
	}

	/**
	 * Takes a SpriteSpecification value and returns it in its array form. If `undefined` is passed as an input value, an
	 * empty array is returned.
	 * duplicated entries with identical id/url will be removed in returned array
	 * @param sprite - optional sprite to coerce
	 * @returns an empty array in case `undefined` is passed; id-url pairs otherwise
	 */
	function coerceSpriteToArray(sprite) {
	    const resultArray = [];
	    if (typeof sprite === 'string') {
	        resultArray.push({ id: 'default', url: sprite });
	    }
	    else if (sprite && sprite.length > 0) {
	        const dedupArray = [];
	        for (const { id, url } of sprite) {
	            const key = `${id}${url}`;
	            if (dedupArray.indexOf(key) === -1) {
	                dedupArray.push(key);
	                resultArray.push({ id, url });
	            }
	        }
	    }
	    return resultArray;
	}

	function loadSprite(originalSprite, requestManager, pixelRatio, abortController) {
	    return performance$1.__awaiter(this, void 0, void 0, function* () {
	        const spriteArray = coerceSpriteToArray(originalSprite);
	        const format = pixelRatio > 1 ? '@2x' : '';
	        const jsonsMap = {};
	        const imagesMap = {};
	        for (const { id, url } of spriteArray) {
	            const jsonRequestParameters = requestManager.transformRequest(requestManager.normalizeSpriteURL(url, format, '.json'), "SpriteJSON" /* ResourceType.SpriteJSON */);
	            jsonsMap[id] = performance$1.getJSON(jsonRequestParameters, abortController);
	            const imageRequestParameters = requestManager.transformRequest(requestManager.normalizeSpriteURL(url, format, '.png'), "SpriteImage" /* ResourceType.SpriteImage */);
	            imagesMap[id] = ImageRequest.getImage(imageRequestParameters, abortController);
	        }
	        yield Promise.all([...Object.values(jsonsMap), ...Object.values(imagesMap)]);
	        return doOnceCompleted(jsonsMap, imagesMap);
	    });
	}
	/**
	 * @param jsonsMap - JSON data map
	 * @param imagesMap - image data map
	 */
	function doOnceCompleted(jsonsMap, imagesMap) {
	    return performance$1.__awaiter(this, void 0, void 0, function* () {
	        const result = {};
	        for (const spriteName in jsonsMap) {
	            result[spriteName] = {};
	            const context = browser.getImageCanvasContext((yield imagesMap[spriteName]).data);
	            const json = (yield jsonsMap[spriteName]).data;
	            for (const id in json) {
	                const { width, height, x, y, sdf, pixelRatio, stretchX, stretchY, content, contentMatch } = json[id];
	                const spriteData = { width, height, x, y, context };
	                result[spriteName][id] = { data: null, pixelRatio, sdf, stretchX, stretchY, content, spriteData, contentMatch };
	            }
	        }
	        return result;
	    });
	}

	/**
	 * @internal
	 * A `Texture` GL related object
	 */
	class Texture {
	    constructor(context, image, format, options) {
	        this.context = context;
	        this.format = format;
	        this.texture = context.gl.createTexture();
	        this.update(image, options);
	    }
	    update(image, options, position) {
	        const { width, height } = image;
	        const resize = (!this.size || this.size[0] !== width || this.size[1] !== height) && !position;
	        const { context } = this;
	        const { gl } = context;
	        this.useMipmap = Boolean(options && options.useMipmap);
	        gl.bindTexture(gl.TEXTURE_2D, this.texture);
	        context.pixelStoreUnpackFlipY.set(false);
	        context.pixelStoreUnpack.set(1);
	        context.pixelStoreUnpackPremultiplyAlpha.set(this.format === gl.RGBA && (!options || options.premultiply !== false));
	        if (resize) {
	            this.size = [width, height];
	            if (image instanceof HTMLImageElement || image instanceof HTMLCanvasElement || image instanceof HTMLVideoElement || image instanceof ImageData || performance$1.isImageBitmap(image)) {
	                gl.texImage2D(gl.TEXTURE_2D, 0, this.format, this.format, gl.UNSIGNED_BYTE, image);
	            }
	            else {
	                gl.texImage2D(gl.TEXTURE_2D, 0, this.format, width, height, 0, this.format, gl.UNSIGNED_BYTE, image.data);
	            }
	        }
	        else {
	            const { x, y } = position || { x: 0, y: 0 };
	            if (image instanceof HTMLImageElement || image instanceof HTMLCanvasElement || image instanceof HTMLVideoElement || image instanceof ImageData || performance$1.isImageBitmap(image)) {
	                gl.texSubImage2D(gl.TEXTURE_2D, 0, x, y, gl.RGBA, gl.UNSIGNED_BYTE, image);
	            }
	            else {
	                gl.texSubImage2D(gl.TEXTURE_2D, 0, x, y, width, height, gl.RGBA, gl.UNSIGNED_BYTE, image.data);
	            }
	        }
	        if (this.useMipmap && this.isSizePowerOfTwo()) {
	            gl.generateMipmap(gl.TEXTURE_2D);
	        }
	    }
	    bind(filter, wrap, minFilter) {
	        const { context } = this;
	        const { gl } = context;
	        gl.bindTexture(gl.TEXTURE_2D, this.texture);
	        if (minFilter === gl.LINEAR_MIPMAP_NEAREST && !this.isSizePowerOfTwo()) {
	            minFilter = gl.LINEAR;
	        }
	        if (filter !== this.filter) {
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, filter);
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, minFilter || filter);
	            this.filter = filter;
	        }
	        if (wrap !== this.wrap) {
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, wrap);
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, wrap);
	            this.wrap = wrap;
	        }
	    }
	    isSizePowerOfTwo() {
	        return this.size[0] === this.size[1] && (Math.log(this.size[0]) / Math.LN2) % 1 === 0;
	    }
	    destroy() {
	        const { gl } = this.context;
	        gl.deleteTexture(this.texture);
	        this.texture = null;
	    }
	}

	/* eslint-disable key-spacing */
	/**
	 * When copied into the atlas texture, image data is padded by one pixel on each side. Icon
	 * images are padded with fully transparent pixels, while pattern images are padded with a
	 * copy of the image data wrapped from the opposite side. In both cases, this ensures the
	 * correct behavior of GL_LINEAR texture sampling mode.
	 */
	const padding = 1;
	/**
	 * ImageManager does three things:
	 *
	 * 1. Tracks requests for icon images from tile workers and sends responses when the requests are fulfilled.
	 * 2. Builds a texture atlas for pattern images.
	 * 3. Rerenders renderable images once per frame
	 *
	 * These are disparate responsibilities and should eventually be handled by different classes. When we implement
	 * data-driven support for `*-pattern`, we'll likely use per-bucket pattern atlases, and that would be a good time
	 * to refactor this.
	*/
	class ImageManager extends performance$1.Evented {
	    constructor() {
	        super();
	        this.images = {};
	        this.updatedImages = {};
	        this.callbackDispatchedThisFrame = {};
	        this.loaded = false;
	        this.requestors = [];
	        this.patterns = {};
	        this.atlasImage = new performance$1.RGBAImage({ width: 1, height: 1 });
	        this.dirty = true;
	    }
	    isLoaded() {
	        return this.loaded;
	    }
	    setLoaded(loaded) {
	        if (this.loaded === loaded) {
	            return;
	        }
	        this.loaded = loaded;
	        if (loaded) {
	            for (const { ids, promiseResolve } of this.requestors) {
	                promiseResolve(this._getImagesForIds(ids));
	            }
	            this.requestors = [];
	        }
	    }
	    getImage(id) {
	        const image = this.images[id];
	        // Extract sprite image data on demand
	        if (image && !image.data && image.spriteData) {
	            const spriteData = image.spriteData;
	            image.data = new performance$1.RGBAImage({
	                width: spriteData.width,
	                height: spriteData.height
	            }, spriteData.context.getImageData(spriteData.x, spriteData.y, spriteData.width, spriteData.height).data);
	            image.spriteData = null;
	        }
	        return image;
	    }
	    addImage(id, image) {
	        if (this.images[id])
	            throw new Error(`Image id ${id} already exist, use updateImage instead`);
	        if (this._validate(id, image)) {
	            this.images[id] = image;
	        }
	    }
	    _validate(id, image) {
	        let valid = true;
	        const data = image.data || image.spriteData;
	        if (!this._validateStretch(image.stretchX, data && data.width)) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Image "${id}" has invalid "stretchX" value`)));
	            valid = false;
	        }
	        if (!this._validateStretch(image.stretchY, data && data.height)) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Image "${id}" has invalid "stretchY" value`)));
	            valid = false;
	        }
	        if (!this._validateContent(image.content, image)) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Image "${id}" has invalid "content" value`)));
	            valid = false;
	        }
	        return valid;
	    }
	    _validateStretch(stretch, size) {
	        if (!stretch)
	            return true;
	        let last = 0;
	        for (const part of stretch) {
	            if (part[0] < last || part[1] < part[0] || size < part[1])
	                return false;
	            last = part[1];
	        }
	        return true;
	    }
	    _validateContent(content, image) {
	        if (!content)
	            return true;
	        if (content.length !== 4)
	            return false;
	        const spriteData = image.spriteData;
	        const width = (spriteData && spriteData.width) || image.data.width;
	        const height = (spriteData && spriteData.height) || image.data.height;
	        if (content[0] < 0 || width < content[0])
	            return false;
	        if (content[1] < 0 || height < content[1])
	            return false;
	        if (content[2] < 0 || width < content[2])
	            return false;
	        if (content[3] < 0 || height < content[3])
	            return false;
	        if (content[2] < content[0])
	            return false;
	        if (content[3] < content[1])
	            return false;
	        return true;
	    }
	    updateImage(id, image, validate = true) {
	        const oldImage = this.getImage(id);
	        if (validate && (oldImage.data.width !== image.data.width || oldImage.data.height !== image.data.height)) {
	            throw new Error(`size mismatch between old image (${oldImage.data.width}x${oldImage.data.height}) and new image (${image.data.width}x${image.data.height}).`);
	        }
	        image.version = oldImage.version + 1;
	        this.images[id] = image;
	        this.updatedImages[id] = true;
	    }
	    removeImage(id) {
	        const image = this.images[id];
	        delete this.images[id];
	        delete this.patterns[id];
	        if (image.userImage && image.userImage.onRemove) {
	            image.userImage.onRemove();
	        }
	    }
	    listImages() {
	        return Object.keys(this.images);
	    }
	    getImages(ids) {
	        return new Promise((resolve, _reject) => {
	            // If the sprite has been loaded, or if all the icon dependencies are already present
	            // (i.e. if they've been added via runtime styling), then notify the requestor immediately.
	            // Otherwise, delay notification until the sprite is loaded. At that point, if any of the
	            // dependencies are still unavailable, we'll just assume they are permanently missing.
	            let hasAllDependencies = true;
	            if (!this.isLoaded()) {
	                for (const id of ids) {
	                    if (!this.images[id]) {
	                        hasAllDependencies = false;
	                    }
	                }
	            }
	            if (this.isLoaded() || hasAllDependencies) {
	                resolve(this._getImagesForIds(ids));
	            }
	            else {
	                this.requestors.push({ ids, promiseResolve: resolve });
	            }
	        });
	    }
	    _getImagesForIds(ids) {
	        const response = {};
	        for (const id of ids) {
	            let image = this.getImage(id);
	            if (!image) {
	                this.fire(new performance$1.Event('styleimagemissing', { id }));
	                //Try to acquire image again in case styleimagemissing has populated it
	                image = this.getImage(id);
	            }
	            if (image) {
	                // Clone the image so that our own copy of its ArrayBuffer doesn't get transferred.
	                response[id] = {
	                    data: image.data.clone(),
	                    pixelRatio: image.pixelRatio,
	                    sdf: image.sdf,
	                    version: image.version,
	                    stretchX: image.stretchX,
	                    stretchY: image.stretchY,
	                    content: image.content,
	                    contentMatch: image.contentMatch,
	                    hasRenderCallback: Boolean(image.userImage && image.userImage.render)
	                };
	            }
	            else {
	                performance$1.warnOnce(`Image "${id}" could not be loaded. Please make sure you have added the image with map.addImage() or a "sprite" property in your style. You can provide missing images by listening for the "styleimagemissing" map event.`);
	            }
	        }
	        return response;
	    }
	    // Pattern stuff
	    getPixelSize() {
	        const { width, height } = this.atlasImage;
	        return { width, height };
	    }
	    getPattern(id) {
	        const pattern = this.patterns[id];
	        const image = this.getImage(id);
	        if (!image) {
	            return null;
	        }
	        if (pattern && pattern.position.version === image.version) {
	            return pattern.position;
	        }
	        if (!pattern) {
	            const w = image.data.width + padding * 2;
	            const h = image.data.height + padding * 2;
	            const bin = { w, h, x: 0, y: 0 };
	            const position = new performance$1.ImagePosition(bin, image);
	            this.patterns[id] = { bin, position };
	        }
	        else {
	            pattern.position.version = image.version;
	        }
	        this._updatePatternAtlas();
	        return this.patterns[id].position;
	    }
	    bind(context) {
	        const gl = context.gl;
	        if (!this.atlasTexture) {
	            this.atlasTexture = new Texture(context, this.atlasImage, gl.RGBA);
	        }
	        else if (this.dirty) {
	            this.atlasTexture.update(this.atlasImage);
	            this.dirty = false;
	        }
	        this.atlasTexture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	    }
	    _updatePatternAtlas() {
	        const bins = [];
	        for (const id in this.patterns) {
	            bins.push(this.patterns[id].bin);
	        }
	        const { w, h } = performance$1.potpack(bins);
	        const dst = this.atlasImage;
	        dst.resize({ width: w || 1, height: h || 1 });
	        for (const id in this.patterns) {
	            const { bin } = this.patterns[id];
	            const x = bin.x + padding;
	            const y = bin.y + padding;
	            const src = this.getImage(id).data;
	            const w = src.width;
	            const h = src.height;
	            performance$1.RGBAImage.copy(src, dst, { x: 0, y: 0 }, { x, y }, { width: w, height: h });
	            // Add 1 pixel wrapped padding on each side of the image.
	            performance$1.RGBAImage.copy(src, dst, { x: 0, y: h - 1 }, { x, y: y - 1 }, { width: w, height: 1 }); // T
	            performance$1.RGBAImage.copy(src, dst, { x: 0, y: 0 }, { x, y: y + h }, { width: w, height: 1 }); // B
	            performance$1.RGBAImage.copy(src, dst, { x: w - 1, y: 0 }, { x: x - 1, y }, { width: 1, height: h }); // L
	            performance$1.RGBAImage.copy(src, dst, { x: 0, y: 0 }, { x: x + w, y }, { width: 1, height: h }); // R
	        }
	        this.dirty = true;
	    }
	    beginFrame() {
	        this.callbackDispatchedThisFrame = {};
	    }
	    dispatchRenderCallbacks(ids) {
	        for (const id of ids) {
	            // the callback for the image was already dispatched for a different frame
	            if (this.callbackDispatchedThisFrame[id])
	                continue;
	            this.callbackDispatchedThisFrame[id] = true;
	            const image = this.getImage(id);
	            if (!image)
	                performance$1.warnOnce(`Image with ID: "${id}" was not found`);
	            const updated = performance$1.renderStyleImage(image);
	            if (updated) {
	                this.updateImage(id, image);
	            }
	        }
	    }
	}

	function loadGlyphRange(fontstack, range, urlTemplate, requestManager) {
	    return performance$1.__awaiter(this, void 0, void 0, function* () {
	        const begin = range * 256;
	        const end = begin + 255;
	        const request = requestManager.transformRequest(urlTemplate.replace('{fontstack}', fontstack).replace('{range}', `${begin}-${end}`), "Glyphs" /* ResourceType.Glyphs */);
	        const response = yield performance$1.getArrayBuffer(request, new AbortController());
	        if (!response || !response.data) {
	            throw new Error(`Could not load glyph range. range: ${range}, ${begin}-${end}`);
	        }
	        const glyphs = {};
	        for (const glyph of performance$1.parseGlyphPbf(response.data)) {
	            glyphs[glyph.id] = glyph;
	        }
	        return glyphs;
	    });
	}

	const INF = 1e20;

	class TinySDF {
	    constructor({
	        fontSize = 24,
	        buffer = 3,
	        radius = 8,
	        cutoff = 0.25,
	        fontFamily = 'sans-serif',
	        fontWeight = 'normal',
	        fontStyle = 'normal'
	    } = {}) {
	        this.buffer = buffer;
	        this.cutoff = cutoff;
	        this.radius = radius;

	        // make the canvas size big enough to both have the specified buffer around the glyph
	        // for "halo", and account for some glyphs possibly being larger than their font size
	        const size = this.size = fontSize + buffer * 4;

	        const canvas = this._createCanvas(size);
	        const ctx = this.ctx = canvas.getContext('2d', {willReadFrequently: true});
	        ctx.font = `${fontStyle} ${fontWeight} ${fontSize}px ${fontFamily}`;

	        ctx.textBaseline = 'alphabetic';
	        ctx.textAlign = 'left'; // Necessary so that RTL text doesn't have different alignment
	        ctx.fillStyle = 'black';

	        // temporary arrays for the distance transform
	        this.gridOuter = new Float64Array(size * size);
	        this.gridInner = new Float64Array(size * size);
	        this.f = new Float64Array(size);
	        this.z = new Float64Array(size + 1);
	        this.v = new Uint16Array(size);
	    }

	    _createCanvas(size) {
	        const canvas = document.createElement('canvas');
	        canvas.width = canvas.height = size;
	        return canvas;
	    }

	    draw(char) {
	        const {
	            width: glyphAdvance,
	            actualBoundingBoxAscent,
	            actualBoundingBoxDescent,
	            actualBoundingBoxLeft,
	            actualBoundingBoxRight
	        } = this.ctx.measureText(char);

	        // The integer/pixel part of the top alignment is encoded in metrics.glyphTop
	        // The remainder is implicitly encoded in the rasterization
	        const glyphTop = Math.ceil(actualBoundingBoxAscent);
	        const glyphLeft = 0;

	        // If the glyph overflows the canvas size, it will be clipped at the bottom/right
	        const glyphWidth = Math.max(0, Math.min(this.size - this.buffer, Math.ceil(actualBoundingBoxRight - actualBoundingBoxLeft)));
	        const glyphHeight = Math.min(this.size - this.buffer, glyphTop + Math.ceil(actualBoundingBoxDescent));

	        const width = glyphWidth + 2 * this.buffer;
	        const height = glyphHeight + 2 * this.buffer;

	        const len = Math.max(width * height, 0);
	        const data = new Uint8ClampedArray(len);
	        const glyph = {data, width, height, glyphWidth, glyphHeight, glyphTop, glyphLeft, glyphAdvance};
	        if (glyphWidth === 0 || glyphHeight === 0) return glyph;

	        const {ctx, buffer, gridInner, gridOuter} = this;
	        ctx.clearRect(buffer, buffer, glyphWidth, glyphHeight);
	        ctx.fillText(char, buffer, buffer + glyphTop);
	        const imgData = ctx.getImageData(buffer, buffer, glyphWidth, glyphHeight);

	        // Initialize grids outside the glyph range to alpha 0
	        gridOuter.fill(INF, 0, len);
	        gridInner.fill(0, 0, len);

	        for (let y = 0; y < glyphHeight; y++) {
	            for (let x = 0; x < glyphWidth; x++) {
	                const a = imgData.data[4 * (y * glyphWidth + x) + 3] / 255; // alpha value
	                if (a === 0) continue; // empty pixels

	                const j = (y + buffer) * width + x + buffer;

	                if (a === 1) { // fully drawn pixels
	                    gridOuter[j] = 0;
	                    gridInner[j] = INF;

	                } else { // aliased pixels
	                    const d = 0.5 - a;
	                    gridOuter[j] = d > 0 ? d * d : 0;
	                    gridInner[j] = d < 0 ? d * d : 0;
	                }
	            }
	        }

	        edt(gridOuter, 0, 0, width, height, width, this.f, this.v, this.z);
	        edt(gridInner, buffer, buffer, glyphWidth, glyphHeight, width, this.f, this.v, this.z);

	        for (let i = 0; i < len; i++) {
	            const d = Math.sqrt(gridOuter[i]) - Math.sqrt(gridInner[i]);
	            data[i] = Math.round(255 - 255 * (d / this.radius + this.cutoff));
	        }

	        return glyph;
	    }
	}

	// 2D Euclidean squared distance transform by Felzenszwalb & Huttenlocher https://cs.brown.edu/~pff/papers/dt-final.pdf
	function edt(data, x0, y0, width, height, gridSize, f, v, z) {
	    for (let x = x0; x < x0 + width; x++) edt1d(data, y0 * gridSize + x, gridSize, height, f, v, z);
	    for (let y = y0; y < y0 + height; y++) edt1d(data, y * gridSize + x0, 1, width, f, v, z);
	}

	// 1D squared distance transform
	function edt1d(grid, offset, stride, length, f, v, z) {
	    v[0] = 0;
	    z[0] = -INF;
	    z[1] = INF;
	    f[0] = grid[offset];

	    for (let q = 1, k = 0, s = 0; q < length; q++) {
	        f[q] = grid[offset + q * stride];
	        const q2 = q * q;
	        do {
	            const r = v[k];
	            s = (f[q] - f[r] + q2 - r * r) / (q - r) / 2;
	        } while (s <= z[k] && --k > -1);

	        k++;
	        v[k] = q;
	        z[k] = s;
	        z[k + 1] = INF;
	    }

	    for (let q = 0, k = 0; q < length; q++) {
	        while (z[k + 1] < q) k++;
	        const r = v[k];
	        const qr = q - r;
	        grid[offset + q * stride] = f[r] + qr * qr;
	    }
	}

	class GlyphManager {
	    constructor(requestManager, localIdeographFontFamily) {
	        this.requestManager = requestManager;
	        this.localIdeographFontFamily = localIdeographFontFamily;
	        this.entries = {};
	    }
	    setURL(url) {
	        this.url = url;
	    }
	    getGlyphs(glyphs) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const glyphsPromises = [];
	            for (const stack in glyphs) {
	                for (const id of glyphs[stack]) {
	                    glyphsPromises.push(this._getAndCacheGlyphsPromise(stack, id));
	                }
	            }
	            const updatedGlyphs = yield Promise.all(glyphsPromises);
	            const result = {};
	            for (const { stack, id, glyph } of updatedGlyphs) {
	                if (!result[stack]) {
	                    result[stack] = {};
	                }
	                // Clone the glyph so that our own copy of its ArrayBuffer doesn't get transferred.
	                result[stack][id] = glyph && {
	                    id: glyph.id,
	                    bitmap: glyph.bitmap.clone(),
	                    metrics: glyph.metrics
	                };
	            }
	            return result;
	        });
	    }
	    _getAndCacheGlyphsPromise(stack, id) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            let entry = this.entries[stack];
	            if (!entry) {
	                entry = this.entries[stack] = {
	                    glyphs: {},
	                    requests: {},
	                    ranges: {}
	                };
	            }
	            let glyph = entry.glyphs[id];
	            if (glyph !== undefined) {
	                return { stack, id, glyph };
	            }
	            glyph = this._tinySDF(entry, stack, id);
	            if (glyph) {
	                entry.glyphs[id] = glyph;
	                return { stack, id, glyph };
	            }
	            const range = Math.floor(id / 256);
	            if (range * 256 > 65535) {
	                throw new Error('glyphs > 65535 not supported');
	            }
	            if (entry.ranges[range]) {
	                return { stack, id, glyph };
	            }
	            if (!this.url) {
	                throw new Error('glyphsUrl is not set');
	            }
	            if (!entry.requests[range]) {
	                const promise = GlyphManager.loadGlyphRange(stack, range, this.url, this.requestManager);
	                entry.requests[range] = promise;
	            }
	            const response = yield entry.requests[range];
	            for (const id in response) {
	                if (!this._doesCharSupportLocalGlyph(+id)) {
	                    entry.glyphs[+id] = response[+id];
	                }
	            }
	            entry.ranges[range] = true;
	            return { stack, id, glyph: response[id] || null };
	        });
	    }
	    _doesCharSupportLocalGlyph(id) {
	        /* eslint-disable new-cap */
	        return !!this.localIdeographFontFamily &&
	            (performance$1.unicodeBlockLookup['CJK Unified Ideographs'](id) ||
	                performance$1.unicodeBlockLookup['Hangul Syllables'](id) ||
	                performance$1.unicodeBlockLookup['Hiragana'](id) ||
	                performance$1.unicodeBlockLookup['Katakana'](id));
	        /* eslint-enable new-cap */
	    }
	    _tinySDF(entry, stack, id) {
	        const fontFamily = this.localIdeographFontFamily;
	        if (!fontFamily) {
	            return;
	        }
	        if (!this._doesCharSupportLocalGlyph(id)) {
	            return;
	        }
	        // Client-generated glyphs are rendered at 2x texture scale,
	        // because CJK glyphs are more detailed than others.
	        const textureScale = 2;
	        let tinySDF = entry.tinySDF;
	        if (!tinySDF) {
	            let fontWeight = '400';
	            if (/bold/i.test(stack)) {
	                fontWeight = '900';
	            }
	            else if (/medium/i.test(stack)) {
	                fontWeight = '500';
	            }
	            else if (/light/i.test(stack)) {
	                fontWeight = '200';
	            }
	            tinySDF = entry.tinySDF = new GlyphManager.TinySDF({
	                fontSize: 24 * textureScale,
	                buffer: 3 * textureScale,
	                radius: 8 * textureScale,
	                cutoff: 0.25,
	                fontFamily,
	                fontWeight
	            });
	        }
	        const char = tinySDF.draw(String.fromCharCode(id));
	        /**
	         * TinySDF's "top" is the distance from the alphabetic baseline to the top of the glyph.
	         * Server-generated fonts specify "top" relative to an origin above the em box (the origin
	         * comes from FreeType, but I'm unclear on exactly how it's derived)
	         * ref: https://github.com/mapbox/sdf-glyph-foundry
	         *
	         * Server fonts don't yet include baseline information, so we can't line up exactly with them
	         * (and they don't line up with each other)
	         * ref: https://github.com/mapbox/node-fontnik/pull/160
	         *
	         * To approximately align TinySDF glyphs with server-provided glyphs, we use this baseline adjustment
	         * factor calibrated to be in between DIN Pro and Arial Unicode (but closer to Arial Unicode)
	         */
	        const topAdjustment = 27.5;
	        const leftAdjustment = 0.5;
	        return {
	            id,
	            bitmap: new performance$1.AlphaImage({ width: char.width || 30 * textureScale, height: char.height || 30 * textureScale }, char.data),
	            metrics: {
	                width: char.glyphWidth / textureScale || 24,
	                height: char.glyphHeight / textureScale || 24,
	                left: (char.glyphLeft / textureScale + leftAdjustment) || 0,
	                top: char.glyphTop / textureScale - topAdjustment || -8,
	                advance: char.glyphAdvance / textureScale || 24,
	                isDoubleResolution: true
	            }
	        };
	    }
	}
	// exposed as statics to enable stubbing in unit tests
	GlyphManager.loadGlyphRange = loadGlyphRange;
	GlyphManager.TinySDF = TinySDF;

	class LightPositionProperty {
	    constructor() {
	        this.specification = performance$1.v8Spec.light.position;
	    }
	    possiblyEvaluate(value, parameters) {
	        return performance$1.sphericalToCartesian(value.expression.evaluate(parameters));
	    }
	    interpolate(a, b, t) {
	        return {
	            x: performance$1.interpolate.number(a.x, b.x, t),
	            y: performance$1.interpolate.number(a.y, b.y, t),
	            z: performance$1.interpolate.number(a.z, b.z, t),
	        };
	    }
	}
	const TRANSITION_SUFFIX = '-transition';
	let lightProperties;
	/*
	 * Represents the light used to light extruded features.
	 */
	class Light extends performance$1.Evented {
	    constructor(lightOptions) {
	        super();
	        lightProperties = lightProperties || new performance$1.Properties({
	            'anchor': new performance$1.DataConstantProperty(performance$1.v8Spec.light.anchor),
	            'position': new LightPositionProperty(),
	            'color': new performance$1.DataConstantProperty(performance$1.v8Spec.light.color),
	            'intensity': new performance$1.DataConstantProperty(performance$1.v8Spec.light.intensity),
	        });
	        this._transitionable = new performance$1.Transitionable(lightProperties);
	        this.setLight(lightOptions);
	        this._transitioning = this._transitionable.untransitioned();
	    }
	    getLight() {
	        return this._transitionable.serialize();
	    }
	    setLight(light, options = {}) {
	        if (this._validate(performance$1.validateLight, light, options)) {
	            return;
	        }
	        for (const name in light) {
	            const value = light[name];
	            if (name.endsWith(TRANSITION_SUFFIX)) {
	                this._transitionable.setTransition(name.slice(0, -TRANSITION_SUFFIX.length), value);
	            }
	            else {
	                this._transitionable.setValue(name, value);
	            }
	        }
	    }
	    updateTransitions(parameters) {
	        this._transitioning = this._transitionable.transitioned(parameters, this._transitioning);
	    }
	    hasTransition() {
	        return this._transitioning.hasTransition();
	    }
	    recalculate(parameters) {
	        this.properties = this._transitioning.possiblyEvaluate(parameters);
	    }
	    _validate(validate, value, options) {
	        if (options && options.validate === false) {
	            return false;
	        }
	        return performance$1.emitValidationErrors(this, validate.call(performance$1.validateStyle, {
	            value,
	            // Workaround for https://github.com/mapbox/mapbox-gl-js/issues/2407
	            style: { glyphs: true, sprite: true },
	            styleSpec: performance$1.v8Spec
	        }));
	    }
	}

	/**
	 * @internal
	 * A LineAtlas lets us reuse rendered dashed lines
	 * by writing many of them to a texture and then fetching their positions
	 * using {@link LineAtlas#getDash}.
	 *
	 * @param width - the width
	 * @param height - the height
	 */
	class LineAtlas {
	    constructor(width, height) {
	        this.width = width;
	        this.height = height;
	        this.nextRow = 0;
	        this.data = new Uint8Array(this.width * this.height);
	        this.dashEntry = {};
	    }
	    /**
	     * Get or create a dash line pattern.
	     *
	     * @param dasharray - the key (represented by numbers) to get the dash texture
	     * @param round - whether to add circle caps in between dash segments
	     * @returns position of dash texture in {@link DashEntry}
	     */
	    getDash(dasharray, round) {
	        const key = dasharray.join(',') + String(round);
	        if (!this.dashEntry[key]) {
	            this.dashEntry[key] = this.addDash(dasharray, round);
	        }
	        return this.dashEntry[key];
	    }
	    getDashRanges(dasharray, lineAtlasWidth, stretch) {
	        // If dasharray has an odd length, both the first and last parts
	        // are dashes and should be joined seamlessly.
	        const oddDashArray = dasharray.length % 2 === 1;
	        const ranges = [];
	        let left = oddDashArray ? -dasharray[dasharray.length - 1] * stretch : 0;
	        let right = dasharray[0] * stretch;
	        let isDash = true;
	        ranges.push({ left, right, isDash, zeroLength: dasharray[0] === 0 });
	        let currentDashLength = dasharray[0];
	        for (let i = 1; i < dasharray.length; i++) {
	            isDash = !isDash;
	            const dashLength = dasharray[i];
	            left = currentDashLength * stretch;
	            currentDashLength += dashLength;
	            right = currentDashLength * stretch;
	            ranges.push({ left, right, isDash, zeroLength: dashLength === 0 });
	        }
	        return ranges;
	    }
	    addRoundDash(ranges, stretch, n) {
	        const halfStretch = stretch / 2;
	        for (let y = -n; y <= n; y++) {
	            const row = this.nextRow + n + y;
	            const index = this.width * row;
	            let currIndex = 0;
	            let range = ranges[currIndex];
	            for (let x = 0; x < this.width; x++) {
	                if (x / range.right > 1) {
	                    range = ranges[++currIndex];
	                }
	                const distLeft = Math.abs(x - range.left);
	                const distRight = Math.abs(x - range.right);
	                const minDist = Math.min(distLeft, distRight);
	                let signedDistance;
	                const distMiddle = y / n * (halfStretch + 1);
	                if (range.isDash) {
	                    const distEdge = halfStretch - Math.abs(distMiddle);
	                    signedDistance = Math.sqrt(minDist * minDist + distEdge * distEdge);
	                }
	                else {
	                    signedDistance = halfStretch - Math.sqrt(minDist * minDist + distMiddle * distMiddle);
	                }
	                this.data[index + x] = Math.max(0, Math.min(255, signedDistance + 128));
	            }
	        }
	    }
	    addRegularDash(ranges) {
	        // Collapse any zero-length range
	        // Collapse neighbouring same-type parts into a single part
	        for (let i = ranges.length - 1; i >= 0; --i) {
	            const part = ranges[i];
	            const next = ranges[i + 1];
	            if (part.zeroLength) {
	                ranges.splice(i, 1);
	            }
	            else if (next && next.isDash === part.isDash) {
	                next.left = part.left;
	                ranges.splice(i, 1);
	            }
	        }
	        // Combine the first and last parts if possible
	        const first = ranges[0];
	        const last = ranges[ranges.length - 1];
	        if (first.isDash === last.isDash) {
	            first.left = last.left - this.width;
	            last.right = first.right + this.width;
	        }
	        const index = this.width * this.nextRow;
	        let currIndex = 0;
	        let range = ranges[currIndex];
	        for (let x = 0; x < this.width; x++) {
	            if (x / range.right > 1) {
	                range = ranges[++currIndex];
	            }
	            const distLeft = Math.abs(x - range.left);
	            const distRight = Math.abs(x - range.right);
	            const minDist = Math.min(distLeft, distRight);
	            const signedDistance = range.isDash ? minDist : -minDist;
	            this.data[index + x] = Math.max(0, Math.min(255, signedDistance + 128));
	        }
	    }
	    addDash(dasharray, round) {
	        const n = round ? 7 : 0;
	        const height = 2 * n + 1;
	        if (this.nextRow + height > this.height) {
	            performance$1.warnOnce('LineAtlas out of space');
	            return null;
	        }
	        let length = 0;
	        for (let i = 0; i < dasharray.length; i++) {
	            length += dasharray[i];
	        }
	        if (length !== 0) {
	            const stretch = this.width / length;
	            const ranges = this.getDashRanges(dasharray, this.width, stretch);
	            if (round) {
	                this.addRoundDash(ranges, stretch, n);
	            }
	            else {
	                this.addRegularDash(ranges);
	            }
	        }
	        const dashEntry = {
	            y: (this.nextRow + n + 0.5) / this.height,
	            height: 2 * n / this.height,
	            width: length
	        };
	        this.nextRow += height;
	        this.dirty = true;
	        return dashEntry;
	    }
	    bind(context) {
	        const gl = context.gl;
	        if (!this.texture) {
	            this.texture = gl.createTexture();
	            gl.bindTexture(gl.TEXTURE_2D, this.texture);
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
	            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
	            gl.texImage2D(gl.TEXTURE_2D, 0, gl.ALPHA, this.width, this.height, 0, gl.ALPHA, gl.UNSIGNED_BYTE, this.data);
	        }
	        else {
	            gl.bindTexture(gl.TEXTURE_2D, this.texture);
	            if (this.dirty) {
	                this.dirty = false;
	                gl.texSubImage2D(gl.TEXTURE_2D, 0, 0, 0, this.width, this.height, gl.ALPHA, gl.UNSIGNED_BYTE, this.data);
	            }
	        }
	    }
	}

	function workerFactory() {
	    return new Worker(performance$1.config.WORKER_URL);
	}

	const PRELOAD_POOL_ID = 'maplibre_preloaded_worker_pool';
	/**
	 * Constructs a worker pool.
	 */
	class WorkerPool {
	    constructor() {
	        this.active = {};
	    }
	    acquire(mapId) {
	        if (!this.workers) {
	            // Lazily look up the value of getWorkerCount so that
	            // client code has had a chance to set it.
	            this.workers = [];
	            while (this.workers.length < WorkerPool.workerCount) {
	                this.workers.push(workerFactory());
	            }
	        }
	        this.active[mapId] = true;
	        return this.workers.slice();
	    }
	    release(mapId) {
	        delete this.active[mapId];
	        if (this.numActive() === 0) {
	            this.workers.forEach((w) => {
	                w.terminate();
	            });
	            this.workers = null;
	        }
	    }
	    isPreloaded() {
	        return !!this.active[PRELOAD_POOL_ID];
	    }
	    numActive() {
	        return Object.keys(this.active).length;
	    }
	}
	// Based on results from A/B testing: https://github.com/maplibre/maplibre-gl-js/pull/2354
	const availableLogicalProcessors = Math.floor(browser.hardwareConcurrency / 2);
	WorkerPool.workerCount = performance$1.isSafari(globalThis) ? Math.max(Math.min(availableLogicalProcessors, 3), 1) : 1;

	let globalWorkerPool;
	/**
	 * Creates (if necessary) and returns the single, global WorkerPool instance
	 * to be shared across each Map
	 */
	function getGlobalWorkerPool() {
	    if (!globalWorkerPool) {
	        globalWorkerPool = new WorkerPool();
	    }
	    return globalWorkerPool;
	}
	/**
	 * Initializes resources like WebWorkers that can be shared across maps to lower load
	 * times in some situations. `setWorkerUrl()` and `setWorkerCount()`, if being
	 * used, must be set before `prewarm()` is called to have an effect.
	 *
	 * By default, the lifecycle of these resources is managed automatically, and they are
	 * lazily initialized when a Map is first created. By invoking `prewarm()`, these
	 * resources will be created ahead of time, and will not be cleared when the last Map
	 * is removed from the page. This allows them to be re-used by new Map instances that
	 * are created later. They can be manually cleared by calling
	 * `clearPrewarmedResources()`. This is only necessary if your web page remains
	 * active but stops using maps altogether.
	 *
	 * This is primarily useful when using GL-JS maps in a single page app, wherein a user
	 * would navigate between various views that can cause Map instances to constantly be
	 * created and destroyed.
	 *
	 * @example
	 * ```ts
	 * prewarm()
	 * ```
	 */
	function prewarm() {
	    const workerPool = getGlobalWorkerPool();
	    workerPool.acquire(PRELOAD_POOL_ID);
	}
	/**
	 * Clears up resources that have previously been created by `prewarm()`.
	 * Note that this is typically not necessary. You should only call this function
	 * if you expect the user of your app to not return to a Map view at any point
	 * in your application.
	 *
	 * @example
	 * ```ts
	 * clearPrewarmedResources()
	 * ```
	 */
	function clearPrewarmedResources() {
	    const pool = globalWorkerPool;
	    if (pool) {
	        // Remove the pool only if all maps that referenced the preloaded global worker pool have been removed.
	        if (pool.isPreloaded() && pool.numActive() === 1) {
	            pool.release(PRELOAD_POOL_ID);
	            globalWorkerPool = null;
	        }
	        else {
	            console.warn('Could not clear WebWorkers since there are active Map instances that still reference it. The pre-warmed WebWorker pool can only be cleared when all map instances have been removed with map.remove()');
	        }
	    }
	}

	/**
	 * Responsible for sending messages from a {@link Source} to an associated
	 * {@link WorkerSource}.
	 */
	class Dispatcher {
	    constructor(workerPool, mapId) {
	        this.workerPool = workerPool;
	        this.actors = [];
	        this.currentActor = 0;
	        this.id = mapId;
	        const workers = this.workerPool.acquire(mapId);
	        for (let i = 0; i < workers.length; i++) {
	            const worker = workers[i];
	            const actor = new performance$1.Actor(worker, mapId);
	            actor.name = `Worker ${i}`;
	            this.actors.push(actor);
	        }
	        if (!this.actors.length)
	            throw new Error('No actors found');
	    }
	    /**
	     * Broadcast a message to all Workers.
	     */
	    broadcast(type, data) {
	        const promises = [];
	        for (const actor of this.actors) {
	            promises.push(actor.sendAsync({ type, data }));
	        }
	        return Promise.all(promises);
	    }
	    /**
	     * Acquires an actor to dispatch messages to. The actors are distributed in round-robin fashion.
	     * @returns An actor object backed by a web worker for processing messages.
	     */
	    getActor() {
	        this.currentActor = (this.currentActor + 1) % this.actors.length;
	        return this.actors[this.currentActor];
	    }
	    remove(mapRemoved = true) {
	        this.actors.forEach((actor) => { actor.remove(); });
	        this.actors = [];
	        if (mapRemoved)
	            this.workerPool.release(this.id);
	    }
	    registerMessageHandler(type, handler) {
	        for (const actor of this.actors) {
	            actor.registerMessageHandler(type, handler);
	        }
	    }
	}
	let globalDispatcher;
	function getGlobalDispatcher() {
	    if (!globalDispatcher) {
	        globalDispatcher = new Dispatcher(getGlobalWorkerPool(), performance$1.GLOBAL_DISPATCHER_ID);
	        globalDispatcher.registerMessageHandler("GR" /* MessageType.getResource */, (_mapId, params, abortController) => {
	            return performance$1.makeRequest(params, abortController);
	        });
	    }
	    return globalDispatcher;
	}

	/*
	 * Returns a matrix that can be used to convert from tile coordinates to viewport pixel coordinates.
	 */
	function getPixelPosMatrix(transform, tileID) {
	    const t = performance$1.create();
	    performance$1.translate(t, t, [1, 1, 0]);
	    performance$1.scale(t, t, [transform.width * 0.5, transform.height * 0.5, 1]);
	    return performance$1.multiply(t, t, transform.calculatePosMatrix(tileID.toUnwrapped()));
	}
	function queryIncludes3DLayer(layers, styleLayers, sourceID) {
	    if (layers) {
	        for (const layerID of layers) {
	            const layer = styleLayers[layerID];
	            if (layer && layer.source === sourceID && layer.type === 'fill-extrusion') {
	                return true;
	            }
	        }
	    }
	    else {
	        for (const key in styleLayers) {
	            const layer = styleLayers[key];
	            if (layer.source === sourceID && layer.type === 'fill-extrusion') {
	                return true;
	            }
	        }
	    }
	    return false;
	}
	function queryRenderedFeatures(sourceCache, styleLayers, serializedLayers, queryGeometry, params, transform) {
	    const has3DLayer = queryIncludes3DLayer(params && params.layers, styleLayers, sourceCache.id);
	    const maxPitchScaleFactor = transform.maxPitchScaleFactor();
	    const tilesIn = sourceCache.tilesIn(queryGeometry, maxPitchScaleFactor, has3DLayer);
	    tilesIn.sort(sortTilesIn);
	    const renderedFeatureLayers = [];
	    for (const tileIn of tilesIn) {
	        renderedFeatureLayers.push({
	            wrappedTileID: tileIn.tileID.wrapped().key,
	            queryResults: tileIn.tile.queryRenderedFeatures(styleLayers, serializedLayers, sourceCache._state, tileIn.queryGeometry, tileIn.cameraQueryGeometry, tileIn.scale, params, transform, maxPitchScaleFactor, getPixelPosMatrix(sourceCache.transform, tileIn.tileID))
	        });
	    }
	    const result = mergeRenderedFeatureLayers(renderedFeatureLayers);
	    // Merge state from SourceCache into the results
	    for (const layerID in result) {
	        result[layerID].forEach((featureWrapper) => {
	            const feature = featureWrapper.feature;
	            const state = sourceCache.getFeatureState(feature.layer['source-layer'], feature.id);
	            feature.source = feature.layer.source;
	            if (feature.layer['source-layer']) {
	                feature.sourceLayer = feature.layer['source-layer'];
	            }
	            feature.state = state;
	        });
	    }
	    return result;
	}
	function queryRenderedSymbols(styleLayers, serializedLayers, sourceCaches, queryGeometry, params, collisionIndex, retainedQueryData) {
	    const result = {};
	    const renderedSymbols = collisionIndex.queryRenderedSymbols(queryGeometry);
	    const bucketQueryData = [];
	    for (const bucketInstanceId of Object.keys(renderedSymbols).map(Number)) {
	        bucketQueryData.push(retainedQueryData[bucketInstanceId]);
	    }
	    bucketQueryData.sort(sortTilesIn);
	    for (const queryData of bucketQueryData) {
	        const bucketSymbols = queryData.featureIndex.lookupSymbolFeatures(renderedSymbols[queryData.bucketInstanceId], serializedLayers, queryData.bucketIndex, queryData.sourceLayerIndex, params.filter, params.layers, params.availableImages, styleLayers);
	        for (const layerID in bucketSymbols) {
	            const resultFeatures = result[layerID] = result[layerID] || [];
	            const layerSymbols = bucketSymbols[layerID];
	            layerSymbols.sort((a, b) => {
	                // Match topDownFeatureComparator from FeatureIndex, but using
	                // most recent sorting of features from bucket.sortFeatures
	                const featureSortOrder = queryData.featureSortOrder;
	                if (featureSortOrder) {
	                    // queryRenderedSymbols documentation says we'll return features in
	                    // "top-to-bottom" rendering order (aka last-to-first).
	                    // Actually there can be multiple symbol instances per feature, so
	                    // we sort each feature based on the first matching symbol instance.
	                    const sortedA = featureSortOrder.indexOf(a.featureIndex);
	                    const sortedB = featureSortOrder.indexOf(b.featureIndex);
	                    return sortedB - sortedA;
	                }
	                else {
	                    // Bucket hasn't been re-sorted based on angle, so use the
	                    // reverse of the order the features appeared in the data.
	                    return b.featureIndex - a.featureIndex;
	                }
	            });
	            for (const symbolFeature of layerSymbols) {
	                resultFeatures.push(symbolFeature);
	            }
	        }
	    }
	    // Merge state from SourceCache into the results
	    for (const layerName in result) {
	        result[layerName].forEach((featureWrapper) => {
	            const feature = featureWrapper.feature;
	            const layer = styleLayers[layerName];
	            const sourceCache = sourceCaches[layer.source];
	            const state = sourceCache.getFeatureState(feature.layer['source-layer'], feature.id);
	            feature.source = feature.layer.source;
	            if (feature.layer['source-layer']) {
	                feature.sourceLayer = feature.layer['source-layer'];
	            }
	            feature.state = state;
	        });
	    }
	    return result;
	}
	function querySourceFeatures(sourceCache, params) {
	    const tiles = sourceCache.getRenderableIds().map((id) => {
	        return sourceCache.getTileByID(id);
	    });
	    const result = [];
	    const dataTiles = {};
	    for (let i = 0; i < tiles.length; i++) {
	        const tile = tiles[i];
	        const dataID = tile.tileID.canonical.key;
	        if (!dataTiles[dataID]) {
	            dataTiles[dataID] = true;
	            tile.querySourceFeatures(result, params);
	        }
	    }
	    return result;
	}
	function sortTilesIn(a, b) {
	    const idA = a.tileID;
	    const idB = b.tileID;
	    return (idA.overscaledZ - idB.overscaledZ) || (idA.canonical.y - idB.canonical.y) || (idA.wrap - idB.wrap) || (idA.canonical.x - idB.canonical.x);
	}
	function mergeRenderedFeatureLayers(tiles) {
	    // Merge results from all tiles, but if two tiles share the same
	    // wrapped ID, don't duplicate features between the two tiles
	    const result = {};
	    const wrappedIDLayerMap = {};
	    for (const tile of tiles) {
	        const queryResults = tile.queryResults;
	        const wrappedID = tile.wrappedTileID;
	        const wrappedIDLayers = wrappedIDLayerMap[wrappedID] = wrappedIDLayerMap[wrappedID] || {};
	        for (const layerID in queryResults) {
	            const tileFeatures = queryResults[layerID];
	            const wrappedIDFeatures = wrappedIDLayers[layerID] = wrappedIDLayers[layerID] || {};
	            const resultFeatures = result[layerID] = result[layerID] || [];
	            for (const tileFeature of tileFeatures) {
	                if (!wrappedIDFeatures[tileFeature.featureIndex]) {
	                    wrappedIDFeatures[tileFeature.featureIndex] = true;
	                    resultFeatures.push(tileFeature);
	                }
	            }
	        }
	    }
	    return result;
	}

	function loadTileJson(options, requestManager, abortController) {
	    return performance$1.__awaiter(this, void 0, void 0, function* () {
	        let tileJSON = options;
	        if (options.url) {
	            const response = yield performance$1.getJSON(requestManager.transformRequest(options.url, "Source" /* ResourceType.Source */), abortController);
	            tileJSON = response.data;
	        }
	        else {
	            yield browser.frameAsync(abortController);
	        }
	        if (!tileJSON) {
	            return null;
	        }
	        const result = performance$1.pick(
	        // explicit source options take precedence over TileJSON
	        performance$1.extend(tileJSON, options), ['tiles', 'minzoom', 'maxzoom', 'attribution', 'bounds', 'scheme', 'tileSize', 'encoding']);
	        if ('vector_layers' in tileJSON && tileJSON.vector_layers) {
	            result.vectorLayerIds = tileJSON.vector_layers.map((layer) => { return layer.id; });
	        }
	        return result;
	    });
	}

	/**
	 * A `LngLatBounds` object represents a geographical bounding box,
	 * defined by its southwest and northeast points in longitude and latitude.
	 *
	 * If no arguments are provided to the constructor, a `null` bounding box is created.
	 *
	 * Note that any Mapbox GL method that accepts a `LngLatBounds` object as an argument or option
	 * can also accept an `Array` of two {@link LngLatLike} constructs and will perform an implicit conversion.
	 * This flexible type is documented as {@link LngLatBoundsLike}.
	 *
	 * @group Geography and Geometry
	 *
	 * @example
	 * ```ts
	 * let sw = new LngLat(-73.9876, 40.7661);
	 * let ne = new LngLat(-73.9397, 40.8002);
	 * let llb = new LngLatBounds(sw, ne);
	 * ```
	 */
	class LngLatBounds {
	    /**
	     * @param sw - The southwest corner of the bounding box.
	     * OR array of 4 numbers in the order of  west, south, east, north
	     * OR array of 2 LngLatLike: [sw,ne]
	     * @param ne - The northeast corner of the bounding box.
	     * @example
	     * ```ts
	     * let sw = new LngLat(-73.9876, 40.7661);
	     * let ne = new LngLat(-73.9397, 40.8002);
	     * let llb = new LngLatBounds(sw, ne);
	     * ```
	     * OR
	     * ```ts
	     * let llb = new LngLatBounds([-73.9876, 40.7661, -73.9397, 40.8002]);
	     * ```
	     * OR
	     * ```ts
	     * let llb = new LngLatBounds([sw, ne]);
	     * ```
	     */
	    constructor(sw, ne) {
	        if (!sw) ;
	        else if (ne) {
	            this.setSouthWest(sw).setNorthEast(ne);
	        }
	        else if (Array.isArray(sw)) {
	            if (sw.length === 4) {
	                // 4 element array: west, south, east, north
	                this.setSouthWest([sw[0], sw[1]]).setNorthEast([sw[2], sw[3]]);
	            }
	            else {
	                this.setSouthWest(sw[0]).setNorthEast(sw[1]);
	            }
	        }
	    }
	    /**
	     * Set the northeast corner of the bounding box
	     *
	     * @param ne - a {@link LngLatLike} object describing the northeast corner of the bounding box.
	     * @returns `this`
	     */
	    setNorthEast(ne) {
	        this._ne = ne instanceof performance$1.LngLat ? new performance$1.LngLat(ne.lng, ne.lat) : performance$1.LngLat.convert(ne);
	        return this;
	    }
	    /**
	     * Set the southwest corner of the bounding box
	     *
	     * @param sw - a {@link LngLatLike} object describing the southwest corner of the bounding box.
	     * @returns `this`
	     */
	    setSouthWest(sw) {
	        this._sw = sw instanceof performance$1.LngLat ? new performance$1.LngLat(sw.lng, sw.lat) : performance$1.LngLat.convert(sw);
	        return this;
	    }
	    /**
	     * Extend the bounds to include a given LngLatLike or LngLatBoundsLike.
	     *
	     * @param obj - object to extend to
	     * @returns `this`
	     */
	    extend(obj) {
	        const sw = this._sw, ne = this._ne;
	        let sw2, ne2;
	        if (obj instanceof performance$1.LngLat) {
	            sw2 = obj;
	            ne2 = obj;
	        }
	        else if (obj instanceof LngLatBounds) {
	            sw2 = obj._sw;
	            ne2 = obj._ne;
	            if (!sw2 || !ne2)
	                return this;
	        }
	        else {
	            if (Array.isArray(obj)) {
	                if (obj.length === 4 || obj.every(Array.isArray)) {
	                    const lngLatBoundsObj = obj;
	                    return this.extend(LngLatBounds.convert(lngLatBoundsObj));
	                }
	                else {
	                    const lngLatObj = obj;
	                    return this.extend(performance$1.LngLat.convert(lngLatObj));
	                }
	            }
	            else if (obj && ('lng' in obj || 'lon' in obj) && 'lat' in obj) {
	                return this.extend(performance$1.LngLat.convert(obj));
	            }
	            return this;
	        }
	        if (!sw && !ne) {
	            this._sw = new performance$1.LngLat(sw2.lng, sw2.lat);
	            this._ne = new performance$1.LngLat(ne2.lng, ne2.lat);
	        }
	        else {
	            sw.lng = Math.min(sw2.lng, sw.lng);
	            sw.lat = Math.min(sw2.lat, sw.lat);
	            ne.lng = Math.max(ne2.lng, ne.lng);
	            ne.lat = Math.max(ne2.lat, ne.lat);
	        }
	        return this;
	    }
	    /**
	     * Returns the geographical coordinate equidistant from the bounding box's corners.
	     *
	     * @returns The bounding box's center.
	     * @example
	     * ```ts
	     * let llb = new LngLatBounds([-73.9876, 40.7661], [-73.9397, 40.8002]);
	     * llb.getCenter(); // = LngLat {lng: -73.96365, lat: 40.78315}
	     * ```
	     */
	    getCenter() {
	        return new performance$1.LngLat((this._sw.lng + this._ne.lng) / 2, (this._sw.lat + this._ne.lat) / 2);
	    }
	    /**
	     * Returns the southwest corner of the bounding box.
	     *
	     * @returns The southwest corner of the bounding box.
	     */
	    getSouthWest() { return this._sw; }
	    /**
	     * Returns the northeast corner of the bounding box.
	     *
	     * @returns The northeast corner of the bounding box.
	     */
	    getNorthEast() { return this._ne; }
	    /**
	     * Returns the northwest corner of the bounding box.
	     *
	     * @returns The northwest corner of the bounding box.
	     */
	    getNorthWest() { return new performance$1.LngLat(this.getWest(), this.getNorth()); }
	    /**
	     * Returns the southeast corner of the bounding box.
	     *
	     * @returns The southeast corner of the bounding box.
	     */
	    getSouthEast() { return new performance$1.LngLat(this.getEast(), this.getSouth()); }
	    /**
	     * Returns the west edge of the bounding box.
	     *
	     * @returns The west edge of the bounding box.
	     */
	    getWest() { return this._sw.lng; }
	    /**
	     * Returns the south edge of the bounding box.
	     *
	     * @returns The south edge of the bounding box.
	     */
	    getSouth() { return this._sw.lat; }
	    /**
	     * Returns the east edge of the bounding box.
	     *
	     * @returns The east edge of the bounding box.
	     */
	    getEast() { return this._ne.lng; }
	    /**
	     * Returns the north edge of the bounding box.
	     *
	     * @returns The north edge of the bounding box.
	     */
	    getNorth() { return this._ne.lat; }
	    /**
	     * Returns the bounding box represented as an array.
	     *
	     * @returns The bounding box represented as an array, consisting of the
	     * southwest and northeast coordinates of the bounding represented as arrays of numbers.
	     * @example
	     * ```ts
	     * let llb = new LngLatBounds([-73.9876, 40.7661], [-73.9397, 40.8002]);
	     * llb.toArray(); // = [[-73.9876, 40.7661], [-73.9397, 40.8002]]
	     * ```
	     */
	    toArray() {
	        return [this._sw.toArray(), this._ne.toArray()];
	    }
	    /**
	     * Return the bounding box represented as a string.
	     *
	     * @returns The bounding box represents as a string of the format
	     * `'LngLatBounds(LngLat(lng, lat), LngLat(lng, lat))'`.
	     * @example
	     * ```ts
	     * let llb = new LngLatBounds([-73.9876, 40.7661], [-73.9397, 40.8002]);
	     * llb.toString(); // = "LngLatBounds(LngLat(-73.9876, 40.7661), LngLat(-73.9397, 40.8002))"
	     * ```
	     */
	    toString() {
	        return `LngLatBounds(${this._sw.toString()}, ${this._ne.toString()})`;
	    }
	    /**
	     * Check if the bounding box is an empty/`null`-type box.
	     *
	     * @returns True if bounds have been defined, otherwise false.
	     */
	    isEmpty() {
	        return !(this._sw && this._ne);
	    }
	    /**
	     * Check if the point is within the bounding box.
	     *
	     * @param lnglat - geographic point to check against.
	     * @returns `true` if the point is within the bounding box.
	     * @example
	     * ```ts
	     * let llb = new LngLatBounds(
	     *   new LngLat(-73.9876, 40.7661),
	     *   new LngLat(-73.9397, 40.8002)
	     * );
	     *
	     * let ll = new LngLat(-73.9567, 40.7789);
	     *
	     * console.log(llb.contains(ll)); // = true
	     * ```
	     */
	    contains(lnglat) {
	        const { lng, lat } = performance$1.LngLat.convert(lnglat);
	        const containsLatitude = this._sw.lat <= lat && lat <= this._ne.lat;
	        let containsLongitude = this._sw.lng <= lng && lng <= this._ne.lng;
	        if (this._sw.lng > this._ne.lng) { // wrapped coordinates
	            containsLongitude = this._sw.lng >= lng && lng >= this._ne.lng;
	        }
	        return containsLatitude && containsLongitude;
	    }
	    /**
	     * Converts an array to a `LngLatBounds` object.
	     *
	     * If a `LngLatBounds` object is passed in, the function returns it unchanged.
	     *
	     * Internally, the function calls `LngLat#convert` to convert arrays to `LngLat` values.
	     *
	     * @param input - An array of two coordinates to convert, or a `LngLatBounds` object to return.
	     * @returns A new `LngLatBounds` object, if a conversion occurred, or the original `LngLatBounds` object.
	     * @example
	     * ```ts
	     * let arr = [[-73.9876, 40.7661], [-73.9397, 40.8002]];
	     * let llb = LngLatBounds.convert(arr); // = LngLatBounds {_sw: LngLat {lng: -73.9876, lat: 40.7661}, _ne: LngLat {lng: -73.9397, lat: 40.8002}}
	     * ```
	     */
	    static convert(input) {
	        if (input instanceof LngLatBounds)
	            return input;
	        if (!input)
	            return input;
	        return new LngLatBounds(input);
	    }
	    /**
	     * Returns a `LngLatBounds` from the coordinates extended by a given `radius`. The returned `LngLatBounds` completely contains the `radius`.
	     *
	     * @param center - center coordinates of the new bounds.
	     * @param radius - Distance in meters from the coordinates to extend the bounds.
	     * @returns A new `LngLatBounds` object representing the coordinates extended by the `radius`.
	     * @example
	     * ```ts
	     * let center = new LngLat(-73.9749, 40.7736);
	     * LngLatBounds.fromLngLat(100).toArray(); // = [[-73.97501862141328, 40.77351016847229], [-73.97478137858673, 40.77368983152771]]
	     * ```
	     */
	    static fromLngLat(center, radius = 0) {
	        const earthCircumferenceInMetersAtEquator = 40075017;
	        const latAccuracy = 360 * radius / earthCircumferenceInMetersAtEquator, lngAccuracy = latAccuracy / Math.cos((Math.PI / 180) * center.lat);
	        return new LngLatBounds(new performance$1.LngLat(center.lng - lngAccuracy, center.lat - latAccuracy), new performance$1.LngLat(center.lng + lngAccuracy, center.lat + latAccuracy));
	    }
	}

	class TileBounds {
	    constructor(bounds, minzoom, maxzoom) {
	        this.bounds = LngLatBounds.convert(this.validateBounds(bounds));
	        this.minzoom = minzoom || 0;
	        this.maxzoom = maxzoom || 24;
	    }
	    validateBounds(bounds) {
	        // make sure the bounds property contains valid longitude and latitudes
	        if (!Array.isArray(bounds) || bounds.length !== 4)
	            return [-180, -90, 180, 90];
	        return [Math.max(-180, bounds[0]), Math.max(-90, bounds[1]), Math.min(180, bounds[2]), Math.min(90, bounds[3])];
	    }
	    contains(tileID) {
	        const worldSize = Math.pow(2, tileID.z);
	        const level = {
	            minX: Math.floor(performance$1.mercatorXfromLng(this.bounds.getWest()) * worldSize),
	            minY: Math.floor(performance$1.mercatorYfromLat(this.bounds.getNorth()) * worldSize),
	            maxX: Math.ceil(performance$1.mercatorXfromLng(this.bounds.getEast()) * worldSize),
	            maxY: Math.ceil(performance$1.mercatorYfromLat(this.bounds.getSouth()) * worldSize)
	        };
	        const hit = tileID.x >= level.minX && tileID.x < level.maxX && tileID.y >= level.minY && tileID.y < level.maxY;
	        return hit;
	    }
	}

	/**
	 * A source containing vector tiles in [Mapbox Vector Tile format](https://docs.mapbox.com/vector-tiles/reference/).
	 * (See the [Style Specification](https://maplibre.org/maplibre-style-spec/) for detailed documentation of options.)
	 *
	 * @group Sources
	 *
	 * @example
	 * ```ts
	 * map.addSource('some id', {
	 *     type: 'vector',
	 *     url: 'https://demotiles.maplibre.org/tiles/tiles.json'
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * map.addSource('some id', {
	 *     type: 'vector',
	 *     tiles: ['https://d25uarhxywzl1j.cloudfront.net/v0.1/{z}/{x}/{y}.mvt'],
	 *     minzoom: 6,
	 *     maxzoom: 14
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * map.getSource('some id').setUrl("https://demotiles.maplibre.org/tiles/tiles.json");
	 * ```
	 *
	 * @example
	 * ```ts
	 * map.getSource('some id').setTiles(['https://d25uarhxywzl1j.cloudfront.net/v0.1/{z}/{x}/{y}.mvt']);
	 * ```
	 * @see [Add a vector tile source](https://maplibre.org/maplibre-gl-js/docs/examples/vector-source/)
	 */
	class VectorTileSource extends performance$1.Evented {
	    constructor(id, options, dispatcher, eventedParent) {
	        super();
	        this.id = id;
	        this.dispatcher = dispatcher;
	        this.type = 'vector';
	        this.minzoom = 0;
	        this.maxzoom = 22;
	        this.scheme = 'xyz';
	        this.tileSize = 512;
	        this.reparseOverscaled = true;
	        this.isTileClipped = true;
	        this._loaded = false;
	        performance$1.extend(this, performance$1.pick(options, ['url', 'scheme', 'tileSize', 'promoteId']));
	        this._options = performance$1.extend({ type: 'vector' }, options);
	        this._collectResourceTiming = options.collectResourceTiming;
	        if (this.tileSize !== 512) {
	            throw new Error('vector tile sources must have a tileSize of 512');
	        }
	        this.setEventedParent(eventedParent);
	    }
	    load() {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            this._loaded = false;
	            this.fire(new performance$1.Event('dataloading', { dataType: 'source' }));
	            this._tileJSONRequest = new AbortController();
	            try {
	                const tileJSON = yield loadTileJson(this._options, this.map._requestManager, this._tileJSONRequest);
	                this._tileJSONRequest = null;
	                this._loaded = true;
	                this.map.style.sourceCaches[this.id].clearTiles();
	                if (tileJSON) {
	                    performance$1.extend(this, tileJSON);
	                    if (tileJSON.bounds)
	                        this.tileBounds = new TileBounds(tileJSON.bounds, this.minzoom, this.maxzoom);
	                    // `content` is included here to prevent a race condition where `Style#_updateSources` is called
	                    // before the TileJSON arrives. this makes sure the tiles needed are loaded once TileJSON arrives
	                    // ref: https://github.com/mapbox/mapbox-gl-js/pull/4347#discussion_r104418088
	                    this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'metadata' }));
	                    this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'content' }));
	                }
	            }
	            catch (err) {
	                this._tileJSONRequest = null;
	                this.fire(new performance$1.ErrorEvent(err));
	            }
	        });
	    }
	    loaded() {
	        return this._loaded;
	    }
	    hasTile(tileID) {
	        return !this.tileBounds || this.tileBounds.contains(tileID.canonical);
	    }
	    onAdd(map) {
	        this.map = map;
	        this.load();
	    }
	    setSourceProperty(callback) {
	        if (this._tileJSONRequest) {
	            this._tileJSONRequest.abort();
	        }
	        callback();
	        this.load();
	    }
	    /**
	     * Sets the source `tiles` property and re-renders the map.
	     *
	     * @param tiles - An array of one or more tile source URLs, as in the TileJSON spec.
	     * @returns `this`
	     */
	    setTiles(tiles) {
	        this.setSourceProperty(() => {
	            this._options.tiles = tiles;
	        });
	        return this;
	    }
	    /**
	     * Sets the source `url` property and re-renders the map.
	     *
	     * @param url - A URL to a TileJSON resource. Supported protocols are `http:` and `https:`.
	     * @returns `this`
	     */
	    setUrl(url) {
	        this.setSourceProperty(() => {
	            this.url = url;
	            this._options.url = url;
	        });
	        return this;
	    }
	    onRemove() {
	        if (this._tileJSONRequest) {
	            this._tileJSONRequest.abort();
	            this._tileJSONRequest = null;
	        }
	    }
	    serialize() {
	        return performance$1.extend({}, this._options);
	    }
	    loadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const url = tile.tileID.canonical.url(this.tiles, this.map.getPixelRatio(), this.scheme);
	            const params = {
	                request: this.map._requestManager.transformRequest(url, "Tile" /* ResourceType.Tile */),
	                uid: tile.uid,
	                tileID: tile.tileID,
	                zoom: tile.tileID.overscaledZ,
	                tileSize: this.tileSize * tile.tileID.overscaleFactor(),
	                type: this.type,
	                source: this.id,
	                pixelRatio: this.map.getPixelRatio(),
	                showCollisionBoxes: this.map.showCollisionBoxes,
	                promoteId: this.promoteId
	            };
	            params.request.collectResourceTiming = this._collectResourceTiming;
	            let messageType = "RT" /* MessageType.reloadTile */;
	            if (!tile.actor || tile.state === 'expired') {
	                tile.actor = this.dispatcher.getActor();
	                messageType = "LT" /* MessageType.loadTile */;
	            }
	            else if (tile.state === 'loading') {
	                return new Promise((resolve, reject) => {
	                    tile.reloadPromise = { resolve, reject };
	                });
	            }
	            tile.abortController = new AbortController();
	            try {
	                const data = yield tile.actor.sendAsync({ type: messageType, data: params }, tile.abortController);
	                delete tile.abortController;
	                if (tile.aborted) {
	                    return;
	                }
	                this._afterTileLoadWorkerResponse(tile, data);
	            }
	            catch (err) {
	                delete tile.abortController;
	                if (tile.aborted) {
	                    return;
	                }
	                if (err && err.status !== 404) {
	                    throw err;
	                }
	                this._afterTileLoadWorkerResponse(tile, null);
	            }
	        });
	    }
	    _afterTileLoadWorkerResponse(tile, data) {
	        if (data && data.resourceTiming) {
	            tile.resourceTiming = data.resourceTiming;
	        }
	        if (data && this.map._refreshExpiredTiles) {
	            tile.setExpiryData(data);
	        }
	        tile.loadVectorData(data, this.map.painter);
	        if (tile.reloadPromise) {
	            const reloadPromise = tile.reloadPromise;
	            tile.reloadPromise = null;
	            this.loadTile(tile).then(reloadPromise.resolve).catch(reloadPromise.reject);
	        }
	    }
	    abortTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            if (tile.abortController) {
	                tile.abortController.abort();
	                delete tile.abortController;
	            }
	            if (tile.actor) {
	                yield tile.actor.sendAsync({
	                    type: "AT" /* MessageType.abortTile */,
	                    data: { uid: tile.uid, type: this.type, source: this.id }
	                });
	            }
	        });
	    }
	    unloadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            tile.unloadVectorData();
	            if (tile.actor) {
	                yield tile.actor.sendAsync({
	                    type: "RMT" /* MessageType.removeTile */,
	                    data: {
	                        uid: tile.uid,
	                        type: this.type,
	                        source: this.id
	                    }
	                });
	            }
	        });
	    }
	    hasTransition() {
	        return false;
	    }
	}

	/**
	 * A source containing raster tiles (See the [Style Specification](https://maplibre.org/maplibre-style-spec/) for detailed documentation of options.)
	 *
	 * @group Sources
	 *
	 * @example
	 * ```ts
	 * map.addSource('raster-source', {
	 *     'type': 'raster',
	 *     'tiles': ['https://tiles.stadiamaps.com/tiles/stamen_watercolor/{z}/{x}/{y}.jpg'],
	 *     'tileSize': 256,
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * map.addSource('wms-test-source', {
	 *      'type': 'raster',
	 * // use the tiles option to specify a WMS tile source URL
	 *      'tiles': [
	 *          'https://img.nj.gov/imagerywms/Natural2015?bbox={bbox-epsg-3857}&format=image/png&service=WMS&version=1.1.1&request=GetMap&srs=EPSG:3857&transparent=true&width=256&height=256&layers=Natural2015'
	 *      ],
	 *      'tileSize': 256
	 * });
	 * ```
	 * @see [Add a raster tile source](https://maplibre.org/maplibre-gl-js/docs/examples/map-tiles/)
	 * @see [Add a WMS source](https://maplibre.org/maplibre-gl-js/docs/examples/wms/)
	 * @see [Display a satellite map](https://maplibre.org/maplibre-gl-js/docs/examples/satellite-map/)
	 */
	class RasterTileSource extends performance$1.Evented {
	    constructor(id, options, dispatcher, eventedParent) {
	        super();
	        this.id = id;
	        this.dispatcher = dispatcher;
	        this.setEventedParent(eventedParent);
	        this.type = 'raster';
	        this.minzoom = 0;
	        this.maxzoom = 22;
	        this.roundZoom = true;
	        this.scheme = 'xyz';
	        this.tileSize = 512;
	        this._loaded = false;
	        this._options = performance$1.extend({ type: 'raster' }, options);
	        performance$1.extend(this, performance$1.pick(options, ['url', 'scheme', 'tileSize']));
	    }
	    load() {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            this._loaded = false;
	            this.fire(new performance$1.Event('dataloading', { dataType: 'source' }));
	            this._tileJSONRequest = new AbortController();
	            try {
	                const tileJSON = yield loadTileJson(this._options, this.map._requestManager, this._tileJSONRequest);
	                this._tileJSONRequest = null;
	                this._loaded = true;
	                if (tileJSON) {
	                    performance$1.extend(this, tileJSON);
	                    if (tileJSON.bounds)
	                        this.tileBounds = new TileBounds(tileJSON.bounds, this.minzoom, this.maxzoom);
	                    // `content` is included here to prevent a race condition where `Style#_updateSources` is called
	                    // before the TileJSON arrives. this makes sure the tiles needed are loaded once TileJSON arrives
	                    // ref: https://github.com/mapbox/mapbox-gl-js/pull/4347#discussion_r104418088
	                    this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'metadata' }));
	                    this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'content' }));
	                }
	            }
	            catch (err) {
	                this._tileJSONRequest = null;
	                this.fire(new performance$1.ErrorEvent(err));
	            }
	        });
	    }
	    loaded() {
	        return this._loaded;
	    }
	    onAdd(map) {
	        this.map = map;
	        this.load();
	    }
	    onRemove() {
	        if (this._tileJSONRequest) {
	            this._tileJSONRequest.abort();
	            this._tileJSONRequest = null;
	        }
	    }
	    setSourceProperty(callback) {
	        if (this._tileJSONRequest) {
	            this._tileJSONRequest.abort();
	            this._tileJSONRequest = null;
	        }
	        callback();
	        this.load();
	    }
	    /**
	     * Sets the source `tiles` property and re-renders the map.
	     *
	     * @param tiles - An array of one or more tile source URLs, as in the raster tiles spec (See the [Style Specification](https://maplibre.org/maplibre-style-spec/)
	     * @returns `this`
	     */
	    setTiles(tiles) {
	        this.setSourceProperty(() => {
	            this._options.tiles = tiles;
	        });
	        return this;
	    }
	    /**
	     * Sets the source `url` property and re-renders the map.
	     *
	     * @param url - A URL to a TileJSON resource. Supported protocols are `http:` and `https:`.
	     * @returns `this`
	     */
	    setUrl(url) {
	        this.setSourceProperty(() => {
	            this.url = url;
	            this._options.url = url;
	        });
	        return this;
	    }
	    serialize() {
	        return performance$1.extend({}, this._options);
	    }
	    hasTile(tileID) {
	        return !this.tileBounds || this.tileBounds.contains(tileID.canonical);
	    }
	    loadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const url = tile.tileID.canonical.url(this.tiles, this.map.getPixelRatio(), this.scheme);
	            tile.abortController = new AbortController();
	            try {
	                const response = yield ImageRequest.getImage(this.map._requestManager.transformRequest(url, "Tile" /* ResourceType.Tile */), tile.abortController, this.map._refreshExpiredTiles);
	                delete tile.abortController;
	                if (tile.aborted) {
	                    tile.state = 'unloaded';
	                    return;
	                }
	                if (response && response.data) {
	                    if (this.map._refreshExpiredTiles && response.cacheControl && response.expires) {
	                        tile.setExpiryData({ cacheControl: response.cacheControl, expires: response.expires });
	                    }
	                    const context = this.map.painter.context;
	                    const gl = context.gl;
	                    const img = response.data;
	                    tile.texture = this.map.painter.getTileTexture(img.width);
	                    if (tile.texture) {
	                        tile.texture.update(img, { useMipmap: true });
	                    }
	                    else {
	                        tile.texture = new Texture(context, img, gl.RGBA, { useMipmap: true });
	                        tile.texture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE, gl.LINEAR_MIPMAP_NEAREST);
	                        if (context.extTextureFilterAnisotropic) {
	                            gl.texParameterf(gl.TEXTURE_2D, context.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT, context.extTextureFilterAnisotropicMax);
	                        }
	                    }
	                    tile.state = 'loaded';
	                }
	            }
	            catch (err) {
	                delete tile.abortController;
	                if (tile.aborted) {
	                    tile.state = 'unloaded';
	                }
	                else if (err) {
	                    tile.state = 'errored';
	                    throw err;
	                }
	            }
	        });
	    }
	    abortTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            if (tile.abortController) {
	                tile.abortController.abort();
	                delete tile.abortController;
	            }
	        });
	    }
	    unloadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            if (tile.texture) {
	                this.map.painter.saveTileTexture(tile.texture);
	            }
	        });
	    }
	    hasTransition() {
	        return false;
	    }
	}

	/**
	 * A source containing raster DEM tiles (See the [Style Specification](https://maplibre.org/maplibre-style-spec/) for detailed documentation of options.)
	 * This source can be used to show hillshading and 3D terrain
	 *
	 * @group Sources
	 *
	 * @example
	 * ```ts
	 * map.addSource('raster-dem-source', {
	 *      type: 'raster-dem',
	 *      url: 'https://demotiles.maplibre.org/terrain-tiles/tiles.json',
	 *      tileSize: 256
	 * });
	 * ```
	 * @see [3D Terrain](https://maplibre.org/maplibre-gl-js/docs/examples/3d-terrain/)
	 */
	class RasterDEMTileSource extends RasterTileSource {
	    constructor(id, options, dispatcher, eventedParent) {
	        super(id, options, dispatcher, eventedParent);
	        this.type = 'raster-dem';
	        this.maxzoom = 22;
	        this._options = performance$1.extend({ type: 'raster-dem' }, options);
	        this.encoding = options.encoding || 'mapbox';
	        this.redFactor = options.redFactor;
	        this.greenFactor = options.greenFactor;
	        this.blueFactor = options.blueFactor;
	        this.baseShift = options.baseShift;
	    }
	    loadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const url = tile.tileID.canonical.url(this.tiles, this.map.getPixelRatio(), this.scheme);
	            const request = this.map._requestManager.transformRequest(url, "Tile" /* ResourceType.Tile */);
	            tile.neighboringTiles = this._getNeighboringTiles(tile.tileID);
	            tile.abortController = new AbortController();
	            try {
	                const response = yield ImageRequest.getImage(request, tile.abortController, this.map._refreshExpiredTiles);
	                delete tile.abortController;
	                if (tile.aborted) {
	                    tile.state = 'unloaded';
	                    return;
	                }
	                if (response && response.data) {
	                    const img = response.data;
	                    if (this.map._refreshExpiredTiles && response.cacheControl && response.expires) {
	                        tile.setExpiryData({ cacheControl: response.cacheControl, expires: response.expires });
	                    }
	                    const transfer = performance$1.isImageBitmap(img) && performance$1.offscreenCanvasSupported();
	                    const rawImageData = transfer ? img : yield this.readImageNow(img);
	                    const params = {
	                        type: this.type,
	                        uid: tile.uid,
	                        source: this.id,
	                        rawImageData,
	                        encoding: this.encoding,
	                        redFactor: this.redFactor,
	                        greenFactor: this.greenFactor,
	                        blueFactor: this.blueFactor,
	                        baseShift: this.baseShift
	                    };
	                    if (!tile.actor || tile.state === 'expired') {
	                        tile.actor = this.dispatcher.getActor();
	                        /* eslint-disable require-atomic-updates */
	                        const data = yield tile.actor.sendAsync({ type: "LDT" /* MessageType.loadDEMTile */, data: params });
	                        tile.dem = data;
	                        tile.needsHillshadePrepare = true;
	                        tile.needsTerrainPrepare = true;
	                        tile.state = 'loaded';
	                        /* eslint-enable require-atomic-updates */
	                    }
	                }
	            }
	            catch (err) {
	                delete tile.abortController;
	                if (tile.aborted) {
	                    tile.state = 'unloaded';
	                }
	                else if (err) {
	                    tile.state = 'errored';
	                    throw err;
	                }
	            }
	        });
	    }
	    readImageNow(img) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            if (typeof VideoFrame !== 'undefined' && performance$1.isOffscreenCanvasDistorted()) {
	                const width = img.width + 2;
	                const height = img.height + 2;
	                try {
	                    return new performance$1.RGBAImage({ width, height }, yield performance$1.readImageUsingVideoFrame(img, -1, -1, width, height));
	                }
	                catch (e) {
	                    // fall-back to browser canvas decoding
	                }
	            }
	            return browser.getImageData(img, 1);
	        });
	    }
	    _getNeighboringTiles(tileID) {
	        const canonical = tileID.canonical;
	        const dim = Math.pow(2, canonical.z);
	        const px = (canonical.x - 1 + dim) % dim;
	        const pxw = canonical.x === 0 ? tileID.wrap - 1 : tileID.wrap;
	        const nx = (canonical.x + 1 + dim) % dim;
	        const nxw = canonical.x + 1 === dim ? tileID.wrap + 1 : tileID.wrap;
	        const neighboringTiles = {};
	        // add adjacent tiles
	        neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, pxw, canonical.z, px, canonical.y).key] = { backfilled: false };
	        neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, nxw, canonical.z, nx, canonical.y).key] = { backfilled: false };
	        // Add upper neighboringTiles
	        if (canonical.y > 0) {
	            neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, pxw, canonical.z, px, canonical.y - 1).key] = { backfilled: false };
	            neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, tileID.wrap, canonical.z, canonical.x, canonical.y - 1).key] = { backfilled: false };
	            neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, nxw, canonical.z, nx, canonical.y - 1).key] = { backfilled: false };
	        }
	        // Add lower neighboringTiles
	        if (canonical.y + 1 < dim) {
	            neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, pxw, canonical.z, px, canonical.y + 1).key] = { backfilled: false };
	            neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, tileID.wrap, canonical.z, canonical.x, canonical.y + 1).key] = { backfilled: false };
	            neighboringTiles[new performance$1.OverscaledTileID(tileID.overscaledZ, nxw, canonical.z, nx, canonical.y + 1).key] = { backfilled: false };
	        }
	        return neighboringTiles;
	    }
	    unloadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            if (tile.demTexture)
	                this.map.painter.saveTileTexture(tile.demTexture);
	            if (tile.fbo) {
	                tile.fbo.destroy();
	                delete tile.fbo;
	            }
	            if (tile.dem)
	                delete tile.dem;
	            delete tile.neighboringTiles;
	            tile.state = 'unloaded';
	            if (tile.actor) {
	                yield tile.actor.sendAsync({ type: "RDT" /* MessageType.removeDEMTile */, data: { type: this.type, uid: tile.uid, source: this.id } });
	            }
	        });
	    }
	}

	/**
	 * A source containing GeoJSON.
	 * (See the [Style Specification](https://maplibre.org/maplibre-style-spec/#sources-geojson) for detailed documentation of options.)
	 *
	 * @group Sources
	 *
	 * @example
	 * ```ts
	 * map.addSource('some id', {
	 *     type: 'geojson',
	 *     data: 'https://d2ad6b4ur7yvpq.cloudfront.net/naturalearth-3.3.0/ne_10m_ports.geojson'
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * map.addSource('some id', {
	 *    type: 'geojson',
	 *    data: {
	 *        "type": "FeatureCollection",
	 *        "features": [{
	 *            "type": "Feature",
	 *            "properties": {},
	 *            "geometry": {
	 *                "type": "Point",
	 *                "coordinates": [
	 *                    -76.53063297271729,
	 *                    39.18174077994108
	 *                ]
	 *            }
	 *        }]
	 *    }
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * map.getSource('some id').setData({
	 *   "type": "FeatureCollection",
	 *   "features": [{
	 *       "type": "Feature",
	 *       "properties": { "name": "Null Island" },
	 *       "geometry": {
	 *           "type": "Point",
	 *           "coordinates": [ 0, 0 ]
	 *       }
	 *   }]
	 * });
	 * ```
	 * @see [Draw GeoJSON points](https://maplibre.org/maplibre-gl-js/docs/examples/geojson-markers/)
	 * @see [Add a GeoJSON line](https://maplibre.org/maplibre-gl-js/docs/examples/geojson-line/)
	 * @see [Create a heatmap from points](https://maplibre.org/maplibre-gl-js/docs/examples/heatmap/)
	 * @see [Create and style clusters](https://maplibre.org/maplibre-gl-js/docs/examples/cluster/)
	 */
	class GeoJSONSource extends performance$1.Evented {
	    /** @internal */
	    constructor(id, options, dispatcher, eventedParent) {
	        super();
	        this.id = id;
	        // `type` is a property rather than a constant to make it easy for 3rd
	        // parties to use GeoJSONSource to build their own source types.
	        this.type = 'geojson';
	        this.minzoom = 0;
	        this.maxzoom = 18;
	        this.tileSize = 512;
	        this.isTileClipped = true;
	        this.reparseOverscaled = true;
	        this._removed = false;
	        this._pendingLoads = 0;
	        this.actor = dispatcher.getActor();
	        this.setEventedParent(eventedParent);
	        this._data = options.data;
	        this._options = performance$1.extend({}, options);
	        this._collectResourceTiming = options.collectResourceTiming;
	        if (options.maxzoom !== undefined)
	            this.maxzoom = options.maxzoom;
	        if (options.type)
	            this.type = options.type;
	        if (options.attribution)
	            this.attribution = options.attribution;
	        this.promoteId = options.promoteId;
	        const scale = performance$1.EXTENT / this.tileSize;
	        // sent to the worker, along with `url: ...` or `data: literal geojson`,
	        // so that it can load/parse/index the geojson data
	        // extending with `options.workerOptions` helps to make it easy for
	        // third-party sources to hack/reuse GeoJSONSource.
	        this.workerOptions = performance$1.extend({
	            source: this.id,
	            cluster: options.cluster || false,
	            geojsonVtOptions: {
	                buffer: (options.buffer !== undefined ? options.buffer : 128) * scale,
	                tolerance: (options.tolerance !== undefined ? options.tolerance : 0.375) * scale,
	                extent: performance$1.EXTENT,
	                maxZoom: this.maxzoom,
	                lineMetrics: options.lineMetrics || false,
	                generateId: options.generateId || false
	            },
	            superclusterOptions: {
	                maxZoom: options.clusterMaxZoom !== undefined ? options.clusterMaxZoom : this.maxzoom - 1,
	                minPoints: Math.max(2, options.clusterMinPoints || 2),
	                extent: performance$1.EXTENT,
	                radius: (options.clusterRadius || 50) * scale,
	                log: false,
	                generateId: options.generateId || false
	            },
	            clusterProperties: options.clusterProperties,
	            filter: options.filter
	        }, options.workerOptions);
	        // send the promoteId to the worker to have more flexible updates, but only if it is a string
	        if (typeof this.promoteId === 'string') {
	            this.workerOptions.promoteId = this.promoteId;
	        }
	    }
	    load() {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            yield this._updateWorkerData();
	        });
	    }
	    onAdd(map) {
	        this.map = map;
	        this.load();
	    }
	    /**
	     * Sets the GeoJSON data and re-renders the map.
	     *
	     * @param data - A GeoJSON data object or a URL to one. The latter is preferable in the case of large GeoJSON files.
	     * @returns `this`
	     */
	    setData(data) {
	        this._data = data;
	        this._updateWorkerData();
	        return this;
	    }
	    /**
	     * Updates the source's GeoJSON, and re-renders the map.
	     *
	     * For sources with lots of features, this method can be used to make updates more quickly.
	     *
	     * This approach requires unique IDs for every feature in the source. The IDs can either be specified on the feature,
	     * or by using the promoteId option to specify which property should be used as the ID.
	     *
	     * It is an error to call updateData on a source that did not have unique IDs for each of its features already.
	     *
	     * Updates are applied on a best-effort basis, updating an ID that does not exist will not result in an error.
	     *
	     * @param diff - The changes that need to be applied.
	     * @returns `this`
	     */
	    updateData(diff) {
	        this._updateWorkerData(diff);
	        return this;
	    }
	    /**
	     * To disable/enable clustering on the source options
	     * @param options - The options to set
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.getSource('some id').setClusterOptions({cluster: false});
	     * map.getSource('some id').setClusterOptions({cluster: false, clusterRadius: 50, clusterMaxZoom: 14});
	     * ```
	     */
	    setClusterOptions(options) {
	        this.workerOptions.cluster = options.cluster;
	        if (options) {
	            if (options.clusterRadius !== undefined)
	                this.workerOptions.superclusterOptions.radius = options.clusterRadius;
	            if (options.clusterMaxZoom !== undefined)
	                this.workerOptions.superclusterOptions.maxZoom = options.clusterMaxZoom;
	        }
	        this._updateWorkerData();
	        return this;
	    }
	    /**
	     * For clustered sources, fetches the zoom at which the given cluster expands.
	     *
	     * @param clusterId - The value of the cluster's `cluster_id` property.
	     * @returns a promise that is resolved with the zoom number
	     */
	    getClusterExpansionZoom(clusterId) {
	        return this.actor.sendAsync({ type: "GCEZ" /* MessageType.getClusterExpansionZoom */, data: { type: this.type, clusterId, source: this.id } });
	    }
	    /**
	     * For clustered sources, fetches the children of the given cluster on the next zoom level (as an array of GeoJSON features).
	     *
	     * @param clusterId - The value of the cluster's `cluster_id` property.
	     * @returns a promise that is resolved when the features are retrieved
	     */
	    getClusterChildren(clusterId) {
	        return this.actor.sendAsync({ type: "GCC" /* MessageType.getClusterChildren */, data: { type: this.type, clusterId, source: this.id } });
	    }
	    /**
	     * For clustered sources, fetches the original points that belong to the cluster (as an array of GeoJSON features).
	     *
	     * @param clusterId - The value of the cluster's `cluster_id` property.
	     * @param limit - The maximum number of features to return.
	     * @param offset - The number of features to skip (e.g. for pagination).
	     * @returns a promise that is resolved when the features are retreived
	     * @example
	     * Retrieve cluster leaves on click
	     * ```ts
	     * map.on('click', 'clusters', (e) => {
	     *   let features = map.queryRenderedFeatures(e.point, {
	     *     layers: ['clusters']
	     *   });
	     *
	     *   let clusterId = features[0].properties.cluster_id;
	     *   let pointCount = features[0].properties.point_count;
	     *   let clusterSource = map.getSource('clusters');
	     *
	     *   const features = await clusterSource.getClusterLeaves(clusterId, pointCount) 0, function(error, features) {
	     *   // Print cluster leaves in the console
	     *   console.log('Cluster leaves:', features);
	     * });
	     * ```
	     */
	    getClusterLeaves(clusterId, limit, offset) {
	        return this.actor.sendAsync({ type: "GCL" /* MessageType.getClusterLeaves */, data: {
	                type: this.type,
	                source: this.id,
	                clusterId,
	                limit,
	                offset
	            } });
	    }
	    /**
	     * Responsible for invoking WorkerSource's geojson.loadData target, which
	     * handles loading the geojson data and preparing to serve it up as tiles,
	     * using geojson-vt or supercluster as appropriate.
	     * @param diff - the diff object
	     */
	    _updateWorkerData(diff) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const options = performance$1.extend({ type: this.type }, this.workerOptions);
	            if (diff) {
	                options.dataDiff = diff;
	            }
	            else if (typeof this._data === 'string') {
	                options.request = this.map._requestManager.transformRequest(browser.resolveURL(this._data), "Source" /* ResourceType.Source */);
	                options.request.collectResourceTiming = this._collectResourceTiming;
	            }
	            else {
	                options.data = JSON.stringify(this._data);
	            }
	            this._pendingLoads++;
	            this.fire(new performance$1.Event('dataloading', { dataType: 'source' }));
	            try {
	                const result = yield this.actor.sendAsync({ type: "LD" /* MessageType.loadData */, data: options });
	                this._pendingLoads--;
	                if (this._removed || result.abandoned) {
	                    this.fire(new performance$1.Event('dataabort', { dataType: 'source' }));
	                    return;
	                }
	                let resourceTiming = null;
	                if (result.resourceTiming && result.resourceTiming[this.id]) {
	                    resourceTiming = result.resourceTiming[this.id].slice(0);
	                }
	                const data = { dataType: 'source' };
	                if (this._collectResourceTiming && resourceTiming && resourceTiming.length > 0) {
	                    performance$1.extend(data, { resourceTiming });
	                }
	                // although GeoJSON sources contain no metadata, we fire this event to let the SourceCache
	                // know its ok to start requesting tiles.
	                this.fire(new performance$1.Event('data', Object.assign(Object.assign({}, data), { sourceDataType: 'metadata' })));
	                this.fire(new performance$1.Event('data', Object.assign(Object.assign({}, data), { sourceDataType: 'content' })));
	            }
	            catch (err) {
	                this._pendingLoads--;
	                if (this._removed) {
	                    this.fire(new performance$1.Event('dataabort', { dataType: 'source' }));
	                    return;
	                }
	                this.fire(new performance$1.ErrorEvent(err));
	            }
	        });
	    }
	    loaded() {
	        return this._pendingLoads === 0;
	    }
	    loadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const message = !tile.actor ? "LT" /* MessageType.loadTile */ : "RT" /* MessageType.reloadTile */;
	            tile.actor = this.actor;
	            const params = {
	                type: this.type,
	                uid: tile.uid,
	                tileID: tile.tileID,
	                zoom: tile.tileID.overscaledZ,
	                maxZoom: this.maxzoom,
	                tileSize: this.tileSize,
	                source: this.id,
	                pixelRatio: this.map.getPixelRatio(),
	                showCollisionBoxes: this.map.showCollisionBoxes,
	                promoteId: this.promoteId
	            };
	            tile.abortController = new AbortController();
	            const data = yield this.actor.sendAsync({ type: message, data: params }, tile.abortController);
	            delete tile.abortController;
	            tile.unloadVectorData();
	            if (!tile.aborted) {
	                tile.loadVectorData(data, this.map.painter, message === "RT" /* MessageType.reloadTile */);
	            }
	        });
	    }
	    abortTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            if (tile.abortController) {
	                tile.abortController.abort();
	                delete tile.abortController;
	            }
	            tile.aborted = true;
	        });
	    }
	    unloadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            tile.unloadVectorData();
	            yield this.actor.sendAsync({ type: "RMT" /* MessageType.removeTile */, data: { uid: tile.uid, type: this.type, source: this.id } });
	        });
	    }
	    onRemove() {
	        this._removed = true;
	        this.actor.sendAsync({ type: "RS" /* MessageType.removeSource */, data: { type: this.type, source: this.id } });
	    }
	    serialize() {
	        return performance$1.extend({}, this._options, {
	            type: this.type,
	            data: this._data
	        });
	    }
	    hasTransition() {
	        return false;
	    }
	}

	var rasterBoundsAttributes = performance$1.createLayout([
	    { name: 'a_pos', type: 'Int16', components: 2 },
	    { name: 'a_texture_pos', type: 'Int16', components: 2 }
	]);

	/**
	 * A data source containing an image.
	 * (See the [Style Specification](https://maplibre.org/maplibre-style-spec/#sources-image) for detailed documentation of options.)
	 *
	 * @group Sources
	 *
	 * @example
	 * ```ts
	 * // add to map
	 * map.addSource('some id', {
	 *    type: 'image',
	 *    url: 'https://www.maplibre.org/images/foo.png',
	 *    coordinates: [
	 *        [-76.54, 39.18],
	 *        [-76.52, 39.18],
	 *        [-76.52, 39.17],
	 *        [-76.54, 39.17]
	 *    ]
	 * });
	 *
	 * // update coordinates
	 * let mySource = map.getSource('some id');
	 * mySource.setCoordinates([
	 *     [-76.54335737228394, 39.18579907229748],
	 *     [-76.52803659439087, 39.1838364847587],
	 *     [-76.5295386314392, 39.17683392507606],
	 *     [-76.54520273208618, 39.17876344106642]
	 * ]);
	 *
	 * // update url and coordinates simultaneously
	 * mySource.updateImage({
	 *    url: 'https://www.maplibre.org/images/bar.png',
	 *    coordinates: [
	 *        [-76.54335737228394, 39.18579907229748],
	 *        [-76.52803659439087, 39.1838364847587],
	 *        [-76.5295386314392, 39.17683392507606],
	 *        [-76.54520273208618, 39.17876344106642]
	 *    ]
	 * })
	 *
	 * map.removeSource('some id');  // remove
	 * ```
	 */
	class ImageSource extends performance$1.Evented {
	    /** @internal */
	    constructor(id, options, dispatcher, eventedParent) {
	        super();
	        this.id = id;
	        this.dispatcher = dispatcher;
	        this.coordinates = options.coordinates;
	        this.type = 'image';
	        this.minzoom = 0;
	        this.maxzoom = 22;
	        this.tileSize = 512;
	        this.tiles = {};
	        this._loaded = false;
	        this.setEventedParent(eventedParent);
	        this.options = options;
	    }
	    load(newCoordinates) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            this._loaded = false;
	            this.fire(new performance$1.Event('dataloading', { dataType: 'source' }));
	            this.url = this.options.url;
	            this._request = new AbortController();
	            try {
	                const image = yield ImageRequest.getImage(this.map._requestManager.transformRequest(this.url, "Image" /* ResourceType.Image */), this._request);
	                this._request = null;
	                this._loaded = true;
	                if (image && image.data) {
	                    this.image = image.data;
	                    if (newCoordinates) {
	                        this.coordinates = newCoordinates;
	                    }
	                    this._finishLoading();
	                }
	            }
	            catch (err) {
	                this._request = null;
	                this.fire(new performance$1.ErrorEvent(err));
	            }
	        });
	    }
	    loaded() {
	        return this._loaded;
	    }
	    /**
	     * Updates the image URL and, optionally, the coordinates. To avoid having the image flash after changing,
	     * set the `raster-fade-duration` paint property on the raster layer to 0.
	     *
	     * @param options - The options object.
	     * @returns `this`
	     */
	    updateImage(options) {
	        if (!options.url) {
	            return this;
	        }
	        if (this._request) {
	            this._request.abort();
	            this._request = null;
	        }
	        this.options.url = options.url;
	        this.load(options.coordinates).finally(() => { this.texture = null; });
	        return this;
	    }
	    _finishLoading() {
	        if (this.map) {
	            this.setCoordinates(this.coordinates);
	            this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'metadata' }));
	        }
	    }
	    onAdd(map) {
	        this.map = map;
	        this.load();
	    }
	    onRemove() {
	        if (this._request) {
	            this._request.abort();
	            this._request = null;
	        }
	    }
	    /**
	     * Sets the image's coordinates and re-renders the map.
	     *
	     * @param coordinates - Four geographical coordinates,
	     * represented as arrays of longitude and latitude numbers, which define the corners of the image.
	     * The coordinates start at the top left corner of the image and proceed in clockwise order.
	     * They do not have to represent a rectangle.
	     * @returns `this`
	     */
	    setCoordinates(coordinates) {
	        this.coordinates = coordinates;
	        // Calculate which mercator tile is suitable for rendering the video in
	        // and create a buffer with the corner coordinates. These coordinates
	        // may be outside the tile, because raster tiles aren't clipped when rendering.
	        // transform the geo coordinates into (zoom 0) tile space coordinates
	        const cornerCoords = coordinates.map(performance$1.MercatorCoordinate.fromLngLat);
	        // Compute the coordinates of the tile we'll use to hold this image's
	        // render data
	        this.tileID = getCoordinatesCenterTileID(cornerCoords);
	        // Constrain min/max zoom to our tile's zoom level in order to force
	        // SourceCache to request this tile (no matter what the map's zoom
	        // level)
	        this.minzoom = this.maxzoom = this.tileID.z;
	        // Transform the corner coordinates into the coordinate space of our
	        // tile.
	        const tileCoords = cornerCoords.map((coord) => this.tileID.getTilePoint(coord)._round());
	        this._boundsArray = new performance$1.RasterBoundsArray();
	        this._boundsArray.emplaceBack(tileCoords[0].x, tileCoords[0].y, 0, 0);
	        this._boundsArray.emplaceBack(tileCoords[1].x, tileCoords[1].y, performance$1.EXTENT, 0);
	        this._boundsArray.emplaceBack(tileCoords[3].x, tileCoords[3].y, 0, performance$1.EXTENT);
	        this._boundsArray.emplaceBack(tileCoords[2].x, tileCoords[2].y, performance$1.EXTENT, performance$1.EXTENT);
	        if (this.boundsBuffer) {
	            this.boundsBuffer.destroy();
	            delete this.boundsBuffer;
	        }
	        this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'content' }));
	        return this;
	    }
	    prepare() {
	        if (Object.keys(this.tiles).length === 0 || !this.image) {
	            return;
	        }
	        const context = this.map.painter.context;
	        const gl = context.gl;
	        if (!this.boundsBuffer) {
	            this.boundsBuffer = context.createVertexBuffer(this._boundsArray, rasterBoundsAttributes.members);
	        }
	        if (!this.boundsSegments) {
	            this.boundsSegments = performance$1.SegmentVector.simpleSegment(0, 0, 4, 2);
	        }
	        if (!this.texture) {
	            this.texture = new Texture(context, this.image, gl.RGBA);
	            this.texture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	        }
	        let newTilesLoaded = false;
	        for (const w in this.tiles) {
	            const tile = this.tiles[w];
	            if (tile.state !== 'loaded') {
	                tile.state = 'loaded';
	                tile.texture = this.texture;
	                newTilesLoaded = true;
	            }
	        }
	        if (newTilesLoaded) {
	            this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'idle', sourceId: this.id }));
	        }
	    }
	    loadTile(tile) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            // We have a single tile -- whose coordinates are this.tileID -- that
	            // covers the image we want to render.  If that's the one being
	            // requested, set it up with the image; otherwise, mark the tile as
	            // `errored` to indicate that we have no data for it.
	            // If the world wraps, we may have multiple "wrapped" copies of the
	            // single tile.
	            if (this.tileID && this.tileID.equals(tile.tileID.canonical)) {
	                this.tiles[String(tile.tileID.wrap)] = tile;
	                tile.buckets = {};
	            }
	            else {
	                tile.state = 'errored';
	            }
	        });
	    }
	    serialize() {
	        return {
	            type: 'image',
	            url: this.options.url,
	            coordinates: this.coordinates
	        };
	    }
	    hasTransition() {
	        return false;
	    }
	}
	/**
	 * Given a list of coordinates, get their center as a coordinate.
	 *
	 * @returns centerpoint
	 * @internal
	 */
	function getCoordinatesCenterTileID(coords) {
	    let minX = Infinity;
	    let minY = Infinity;
	    let maxX = -Infinity;
	    let maxY = -Infinity;
	    for (const coord of coords) {
	        minX = Math.min(minX, coord.x);
	        minY = Math.min(minY, coord.y);
	        maxX = Math.max(maxX, coord.x);
	        maxY = Math.max(maxY, coord.y);
	    }
	    const dx = maxX - minX;
	    const dy = maxY - minY;
	    const dMax = Math.max(dx, dy);
	    const zoom = Math.max(0, Math.floor(-Math.log(dMax) / Math.LN2));
	    const tilesAtZoom = Math.pow(2, zoom);
	    return new performance$1.CanonicalTileID(zoom, Math.floor((minX + maxX) / 2 * tilesAtZoom), Math.floor((minY + maxY) / 2 * tilesAtZoom));
	}

	/**
	 * A data source containing video.
	 * (See the [Style Specification](https://maplibre.org/maplibre-style-spec/#sources-video) for detailed documentation of options.)
	 *
	 * @group Sources
	 *
	 * @example
	 * ```ts
	 * // add to map
	 * map.addSource('some id', {
	 *    type: 'video',
	 *    url: [
	 *        'https://www.mapbox.com/blog/assets/baltimore-smoke.mp4',
	 *        'https://www.mapbox.com/blog/assets/baltimore-smoke.webm'
	 *    ],
	 *    coordinates: [
	 *        [-76.54, 39.18],
	 *        [-76.52, 39.18],
	 *        [-76.52, 39.17],
	 *        [-76.54, 39.17]
	 *    ]
	 * });
	 *
	 * // update
	 * let mySource = map.getSource('some id');
	 * mySource.setCoordinates([
	 *     [-76.54335737228394, 39.18579907229748],
	 *     [-76.52803659439087, 39.1838364847587],
	 *     [-76.5295386314392, 39.17683392507606],
	 *     [-76.54520273208618, 39.17876344106642]
	 * ]);
	 *
	 * map.removeSource('some id');  // remove
	 * ```
	 * @see [Add a video](https://maplibre.org/maplibre-gl-js/docs/examples/video-on-a-map/)
	 *
	 * Note that when rendered as a raster layer, the layer's `raster-fade-duration` property will cause the video to fade in.
	 * This happens when playback is started, paused and resumed, or when the video's coordinates are updated. To avoid this behavior,
	 * set the layer's `raster-fade-duration` property to `0`.
	 */
	class VideoSource extends ImageSource {
	    constructor(id, options, dispatcher, eventedParent) {
	        super(id, options, dispatcher, eventedParent);
	        this.roundZoom = true;
	        this.type = 'video';
	        this.options = options;
	    }
	    load() {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            this._loaded = false;
	            const options = this.options;
	            this.urls = [];
	            for (const url of options.urls) {
	                this.urls.push(this.map._requestManager.transformRequest(url, "Source" /* ResourceType.Source */).url);
	            }
	            try {
	                const video = yield performance$1.getVideo(this.urls);
	                this._loaded = true;
	                if (!video) {
	                    return;
	                }
	                this.video = video;
	                this.video.loop = true;
	                // Start repainting when video starts playing. hasTransition() will then return
	                // true to trigger additional frames as long as the videos continues playing.
	                this.video.addEventListener('playing', () => {
	                    this.map.triggerRepaint();
	                });
	                if (this.map) {
	                    this.video.play();
	                }
	                this._finishLoading();
	            }
	            catch (err) {
	                this.fire(new performance$1.ErrorEvent(err));
	            }
	        });
	    }
	    /**
	     * Pauses the video.
	     */
	    pause() {
	        if (this.video) {
	            this.video.pause();
	        }
	    }
	    /**
	     * Plays the video.
	     */
	    play() {
	        if (this.video) {
	            this.video.play();
	        }
	    }
	    /**
	     * Sets playback to a timestamp, in seconds.
	     */
	    seek(seconds) {
	        if (this.video) {
	            const seekableRange = this.video.seekable;
	            if (seconds < seekableRange.start(0) || seconds > seekableRange.end(0)) {
	                this.fire(new performance$1.ErrorEvent(new performance$1.ValidationError(`sources.${this.id}`, null, `Playback for this video can be set only between the ${seekableRange.start(0)} and ${seekableRange.end(0)}-second mark.`)));
	            }
	            else
	                this.video.currentTime = seconds;
	        }
	    }
	    /**
	     * Returns the HTML `video` element.
	     *
	     * @returns The HTML `video` element.
	     */
	    getVideo() {
	        return this.video;
	    }
	    onAdd(map) {
	        if (this.map)
	            return;
	        this.map = map;
	        this.load();
	        if (this.video) {
	            this.video.play();
	            this.setCoordinates(this.coordinates);
	        }
	    }
	    /**
	     * Sets the video's coordinates and re-renders the map.
	     *
	     * @returns `this`
	     */
	    prepare() {
	        if (Object.keys(this.tiles).length === 0 || this.video.readyState < 2) {
	            return; // not enough data for current position
	        }
	        const context = this.map.painter.context;
	        const gl = context.gl;
	        if (!this.boundsBuffer) {
	            this.boundsBuffer = context.createVertexBuffer(this._boundsArray, rasterBoundsAttributes.members);
	        }
	        if (!this.boundsSegments) {
	            this.boundsSegments = performance$1.SegmentVector.simpleSegment(0, 0, 4, 2);
	        }
	        if (!this.texture) {
	            this.texture = new Texture(context, this.video, gl.RGBA);
	            this.texture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	        }
	        else if (!this.video.paused) {
	            this.texture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	            gl.texSubImage2D(gl.TEXTURE_2D, 0, 0, 0, gl.RGBA, gl.UNSIGNED_BYTE, this.video);
	        }
	        let newTilesLoaded = false;
	        for (const w in this.tiles) {
	            const tile = this.tiles[w];
	            if (tile.state !== 'loaded') {
	                tile.state = 'loaded';
	                tile.texture = this.texture;
	                newTilesLoaded = true;
	            }
	        }
	        if (newTilesLoaded) {
	            this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'idle', sourceId: this.id }));
	        }
	    }
	    serialize() {
	        return {
	            type: 'video',
	            urls: this.urls,
	            coordinates: this.coordinates
	        };
	    }
	    hasTransition() {
	        return this.video && !this.video.paused;
	    }
	}

	/**
	 * A data source containing the contents of an HTML canvas. See {@link CanvasSourceSpecification} for detailed documentation of options.
	 *
	 * @group Sources
	 *
	 * @example
	 * ```ts
	 * // add to map
	 * map.addSource('some id', {
	 *    type: 'canvas',
	 *    canvas: 'idOfMyHTMLCanvas',
	 *    animate: true,
	 *    coordinates: [
	 *        [-76.54, 39.18],
	 *        [-76.52, 39.18],
	 *        [-76.52, 39.17],
	 *        [-76.54, 39.17]
	 *    ]
	 * });
	 *
	 * // update
	 * let mySource = map.getSource('some id');
	 * mySource.setCoordinates([
	 *     [-76.54335737228394, 39.18579907229748],
	 *     [-76.52803659439087, 39.1838364847587],
	 *     [-76.5295386314392, 39.17683392507606],
	 *     [-76.54520273208618, 39.17876344106642]
	 * ]);
	 *
	 * map.removeSource('some id');  // remove
	 * ```
	 */
	class CanvasSource extends ImageSource {
	    /** @internal */
	    constructor(id, options, dispatcher, eventedParent) {
	        super(id, options, dispatcher, eventedParent);
	        // We build in some validation here, since canvas sources aren't included in the style spec:
	        if (!options.coordinates) {
	            this.fire(new performance$1.ErrorEvent(new performance$1.ValidationError(`sources.${id}`, null, 'missing required property "coordinates"')));
	        }
	        else if (!Array.isArray(options.coordinates) || options.coordinates.length !== 4 ||
	            options.coordinates.some(c => !Array.isArray(c) || c.length !== 2 || c.some(l => typeof l !== 'number'))) {
	            this.fire(new performance$1.ErrorEvent(new performance$1.ValidationError(`sources.${id}`, null, '"coordinates" property must be an array of 4 longitude/latitude array pairs')));
	        }
	        if (options.animate && typeof options.animate !== 'boolean') {
	            this.fire(new performance$1.ErrorEvent(new performance$1.ValidationError(`sources.${id}`, null, 'optional "animate" property must be a boolean value')));
	        }
	        if (!options.canvas) {
	            this.fire(new performance$1.ErrorEvent(new performance$1.ValidationError(`sources.${id}`, null, 'missing required property "canvas"')));
	        }
	        else if (typeof options.canvas !== 'string' && !(options.canvas instanceof HTMLCanvasElement)) {
	            this.fire(new performance$1.ErrorEvent(new performance$1.ValidationError(`sources.${id}`, null, '"canvas" must be either a string representing the ID of the canvas element from which to read, or an HTMLCanvasElement instance')));
	        }
	        this.options = options;
	        this.animate = options.animate !== undefined ? options.animate : true;
	    }
	    load() {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            this._loaded = true;
	            if (!this.canvas) {
	                this.canvas = (this.options.canvas instanceof HTMLCanvasElement) ?
	                    this.options.canvas :
	                    document.getElementById(this.options.canvas);
	                // cast to HTMLCanvasElement in else of ternary
	                // should we do a safety check and throw if it's not actually HTMLCanvasElement?
	            }
	            this.width = this.canvas.width;
	            this.height = this.canvas.height;
	            if (this._hasInvalidDimensions()) {
	                this.fire(new performance$1.ErrorEvent(new Error('Canvas dimensions cannot be less than or equal to zero.')));
	                return;
	            }
	            this.play = function () {
	                this._playing = true;
	                this.map.triggerRepaint();
	            };
	            this.pause = function () {
	                if (this._playing) {
	                    this.prepare();
	                    this._playing = false;
	                }
	            };
	            this._finishLoading();
	        });
	    }
	    /**
	     * Returns the HTML `canvas` element.
	     *
	     * @returns The HTML `canvas` element.
	     */
	    getCanvas() {
	        return this.canvas;
	    }
	    onAdd(map) {
	        this.map = map;
	        this.load();
	        if (this.canvas) {
	            if (this.animate)
	                this.play();
	        }
	    }
	    onRemove() {
	        this.pause();
	    }
	    prepare() {
	        let resize = false;
	        if (this.canvas.width !== this.width) {
	            this.width = this.canvas.width;
	            resize = true;
	        }
	        if (this.canvas.height !== this.height) {
	            this.height = this.canvas.height;
	            resize = true;
	        }
	        if (this._hasInvalidDimensions())
	            return;
	        if (Object.keys(this.tiles).length === 0)
	            return; // not enough data for current position
	        const context = this.map.painter.context;
	        const gl = context.gl;
	        if (!this.boundsBuffer) {
	            this.boundsBuffer = context.createVertexBuffer(this._boundsArray, rasterBoundsAttributes.members);
	        }
	        if (!this.boundsSegments) {
	            this.boundsSegments = performance$1.SegmentVector.simpleSegment(0, 0, 4, 2);
	        }
	        if (!this.texture) {
	            this.texture = new Texture(context, this.canvas, gl.RGBA, { premultiply: true });
	        }
	        else if (resize || this._playing) {
	            this.texture.update(this.canvas, { premultiply: true });
	        }
	        let newTilesLoaded = false;
	        for (const w in this.tiles) {
	            const tile = this.tiles[w];
	            if (tile.state !== 'loaded') {
	                tile.state = 'loaded';
	                tile.texture = this.texture;
	                newTilesLoaded = true;
	            }
	        }
	        if (newTilesLoaded) {
	            this.fire(new performance$1.Event('data', { dataType: 'source', sourceDataType: 'idle', sourceId: this.id }));
	        }
	    }
	    serialize() {
	        return {
	            type: 'canvas',
	            coordinates: this.coordinates
	        };
	    }
	    hasTransition() {
	        return this._playing;
	    }
	    _hasInvalidDimensions() {
	        for (const x of [this.canvas.width, this.canvas.height]) {
	            if (isNaN(x) || x <= 0)
	                return true;
	        }
	        return false;
	    }
	}

	const registeredSources = {};
	/**
	 * Creates a tiled data source instance given an options object.
	 *
	 * @param id - The id for the source. Must not be used by any existing source.
	 * @param specification - Source options, specific to the source type (except for `options.type`, which is always required).
	 * @param source - A source definition object compliant with
	 * [`maplibre-gl-style-spec`](https://maplibre.org/maplibre-style-spec/#sources) or, for a third-party source type,
	  * with that type's requirements.
	 * @param dispatcher - A {@link Dispatcher} instance, which can be used to send messages to the workers.
	 * @returns a newly created source
	 */
	const create = (id, specification, dispatcher, eventedParent) => {
	    const Class = getSourceType(specification.type);
	    const source = new Class(id, specification, dispatcher, eventedParent);
	    if (source.id !== id) {
	        throw new Error(`Expected Source id to be ${id} instead of ${source.id}`);
	    }
	    return source;
	};
	const getSourceType = (name) => {
	    switch (name) {
	        case 'geojson':
	            return GeoJSONSource;
	        case 'image':
	            return ImageSource;
	        case 'raster':
	            return RasterTileSource;
	        case 'raster-dem':
	            return RasterDEMTileSource;
	        case 'vector':
	            return VectorTileSource;
	        case 'video':
	            return VideoSource;
	        case 'canvas':
	            return CanvasSource;
	    }
	    return registeredSources[name];
	};
	const setSourceType = (name, type) => {
	    registeredSources[name] = type;
	};
	/**
	 * Adds a [custom source type](#Custom Sources), making it available for use with
	 * {@link Map#addSource}.
	 * @param name - The name of the source type; source definition objects use this name in the `{type: ...}` field.
	 * @param sourceType - A {@link SourceClass} - which is a constructor for the `Source` interface.
	 * @returns a promise that is resolved when the source type is ready or rejected with an error.
	 */
	const addSourceType = (name, SourceType) => performance$1.__awaiter(void 0, void 0, void 0, function* () {
	    if (getSourceType(name)) {
	        throw new Error(`A source type called "${name}" already exists.`);
	    }
	    setSourceType(name, SourceType);
	});

	function deserialize(input, style) {
	    const output = {};
	    // Guard against the case where the map's style has been set to null while
	    // this bucket has been parsing.
	    if (!style)
	        return output;
	    for (const bucket of input) {
	        const layers = bucket.layerIds
	            .map((id) => style.getLayer(id))
	            .filter(Boolean);
	        if (layers.length === 0) {
	            continue;
	        }
	        // look up StyleLayer objects from layer ids (since we don't
	        // want to waste time serializing/copying them from the worker)
	        bucket.layers = layers;
	        if (bucket.stateDependentLayerIds) {
	            bucket.stateDependentLayers = bucket.stateDependentLayerIds.map((lId) => layers.filter((l) => l.id === lId)[0]);
	        }
	        for (const layer of layers) {
	            output[layer.id] = bucket;
	        }
	    }
	    return output;
	}

	const RTLPluginLoadedEventName = 'RTLPluginLoaded';

	class RTLMainThreadPlugin extends performance$1.Evented {
	    constructor() {
	        super(...arguments);
	        this.status = 'unavailable';
	        this.url = null;
	        this.dispatcher = getGlobalDispatcher();
	    }
	    /** Sync RTL plugin state by broadcasting a message to the worker */
	    _syncState(statusToSend) {
	        this.status = statusToSend;
	        return this.dispatcher.broadcast("SRPS" /* MessageType.syncRTLPluginState */, { pluginStatus: statusToSend, pluginURL: this.url })
	            .catch((e) => {
	            this.status = 'error';
	            throw e;
	        });
	    }
	    /** This one is exposed to outside */
	    getRTLTextPluginStatus() {
	        return this.status;
	    }
	    clearRTLTextPlugin() {
	        this.status = 'unavailable';
	        this.url = null;
	    }
	    setRTLTextPlugin(url_1) {
	        return performance$1.__awaiter(this, arguments, void 0, function* (url, deferred = false) {
	            if (this.url) {
	                // error
	                throw new Error('setRTLTextPlugin cannot be called multiple times.');
	            }
	            this.url = browser.resolveURL(url);
	            if (!this.url) {
	                throw new Error(`requested url ${url} is invalid`);
	            }
	            if (this.status === 'unavailable') {
	                // from initial state:
	                if (deferred) {
	                    this.status = 'deferred';
	                    // fire and forget: in this case it does not need wait for the broadcasting result
	                    // it is important to sync the deferred status once because
	                    // symbol_bucket will be checking it in worker
	                    this._syncState(this.status);
	                }
	                else {
	                    return this._requestImport();
	                }
	            }
	            else if (this.status === 'requested') {
	                return this._requestImport();
	            }
	        });
	    }
	    /** Send a message to worker which will import the RTL plugin script */
	    _requestImport() {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            // all errors/exceptions will be handled by _syncState
	            yield this._syncState('loading');
	            this.status = 'loaded';
	            this.fire(new performance$1.Event(RTLPluginLoadedEventName));
	        });
	    }
	    /** Start a lazy loading process of RTL plugin */
	    lazyLoad() {
	        if (this.status === 'unavailable') {
	            this.status = 'requested';
	        }
	        else if (this.status === 'deferred') {
	            this._requestImport();
	        }
	    }
	}
	let rtlMainThreadPlugin = null;
	function rtlMainThreadPluginFactory() {
	    if (!rtlMainThreadPlugin) {
	        rtlMainThreadPlugin = new RTLMainThreadPlugin();
	    }
	    return rtlMainThreadPlugin;
	}

	const CLOCK_SKEW_RETRY_TIMEOUT = 30000;
	/**
	 * A tile object is the combination of a Coordinate, which defines
	 * its place, as well as a unique ID and data tracking for its content
	 */
	class Tile {
	    /**
	     * @param tileID - the tile ID
	     * @param size - The tile size
	     */
	    constructor(tileID, size) {
	        this.timeAdded = 0;
	        this.fadeEndTime = 0;
	        this.tileID = tileID;
	        this.uid = performance$1.uniqueId();
	        this.uses = 0;
	        this.tileSize = size;
	        this.buckets = {};
	        this.expirationTime = null;
	        this.queryPadding = 0;
	        this.hasSymbolBuckets = false;
	        this.hasRTLText = false;
	        this.dependencies = {};
	        this.rtt = [];
	        this.rttCoords = {};
	        // Counts the number of times a response was already expired when
	        // received. We're using this to add a delay when making a new request
	        // so we don't have to keep retrying immediately in case of a server
	        // serving expired tiles.
	        this.expiredRequestCount = 0;
	        this.state = 'loading';
	    }
	    registerFadeDuration(duration) {
	        const fadeEndTime = duration + this.timeAdded;
	        if (fadeEndTime < this.fadeEndTime) {
	            return;
	        }
	        this.fadeEndTime = fadeEndTime;
	    }
	    wasRequested() {
	        return this.state === 'errored' || this.state === 'loaded' || this.state === 'reloading';
	    }
	    clearTextures(painter) {
	        if (this.demTexture)
	            painter.saveTileTexture(this.demTexture);
	        this.demTexture = null;
	    }
	    /**
	     * Given a data object with a 'buffers' property, load it into
	     * this tile's elementGroups and buffers properties and set loaded
	     * to true. If the data is null, like in the case of an empty
	     * GeoJSON tile, no-op but still set loaded to true.
	     * @param data - The data from the worker
	     * @param painter - the painter
	     * @param justReloaded - `true` to just reload
	     */
	    loadVectorData(data, painter, justReloaded) {
	        if (this.hasData()) {
	            this.unloadVectorData();
	        }
	        this.state = 'loaded';
	        // empty GeoJSON tile
	        if (!data) {
	            this.collisionBoxArray = new performance$1.CollisionBoxArray();
	            return;
	        }
	        if (data.featureIndex) {
	            this.latestFeatureIndex = data.featureIndex;
	            if (data.rawTileData) {
	                // Only vector tiles have rawTileData, and they won't update it for
	                // 'reloadTile'
	                this.latestRawTileData = data.rawTileData;
	                this.latestFeatureIndex.rawTileData = data.rawTileData;
	            }
	            else if (this.latestRawTileData) {
	                // If rawTileData hasn't updated, hold onto a pointer to the last
	                // one we received
	                this.latestFeatureIndex.rawTileData = this.latestRawTileData;
	            }
	        }
	        this.collisionBoxArray = data.collisionBoxArray;
	        this.buckets = deserialize(data.buckets, painter.style);
	        this.hasSymbolBuckets = false;
	        for (const id in this.buckets) {
	            const bucket = this.buckets[id];
	            if (bucket instanceof performance$1.SymbolBucket) {
	                this.hasSymbolBuckets = true;
	                if (justReloaded) {
	                    bucket.justReloaded = true;
	                }
	                else {
	                    break;
	                }
	            }
	        }
	        this.hasRTLText = false;
	        if (this.hasSymbolBuckets) {
	            for (const id in this.buckets) {
	                const bucket = this.buckets[id];
	                if (bucket instanceof performance$1.SymbolBucket) {
	                    if (bucket.hasRTLText) {
	                        this.hasRTLText = true;
	                        rtlMainThreadPluginFactory().lazyLoad();
	                        break;
	                    }
	                }
	            }
	        }
	        this.queryPadding = 0;
	        for (const id in this.buckets) {
	            const bucket = this.buckets[id];
	            this.queryPadding = Math.max(this.queryPadding, painter.style.getLayer(id).queryRadius(bucket));
	        }
	        if (data.imageAtlas) {
	            this.imageAtlas = data.imageAtlas;
	        }
	        if (data.glyphAtlasImage) {
	            this.glyphAtlasImage = data.glyphAtlasImage;
	        }
	    }
	    /**
	     * Release any data or WebGL resources referenced by this tile.
	     */
	    unloadVectorData() {
	        for (const id in this.buckets) {
	            this.buckets[id].destroy();
	        }
	        this.buckets = {};
	        if (this.imageAtlasTexture) {
	            this.imageAtlasTexture.destroy();
	        }
	        if (this.imageAtlas) {
	            this.imageAtlas = null;
	        }
	        if (this.glyphAtlasTexture) {
	            this.glyphAtlasTexture.destroy();
	        }
	        this.latestFeatureIndex = null;
	        this.state = 'unloaded';
	    }
	    getBucket(layer) {
	        return this.buckets[layer.id];
	    }
	    upload(context) {
	        for (const id in this.buckets) {
	            const bucket = this.buckets[id];
	            if (bucket.uploadPending()) {
	                bucket.upload(context);
	            }
	        }
	        const gl = context.gl;
	        if (this.imageAtlas && !this.imageAtlas.uploaded) {
	            this.imageAtlasTexture = new Texture(context, this.imageAtlas.image, gl.RGBA);
	            this.imageAtlas.uploaded = true;
	        }
	        if (this.glyphAtlasImage) {
	            this.glyphAtlasTexture = new Texture(context, this.glyphAtlasImage, gl.ALPHA);
	            this.glyphAtlasImage = null;
	        }
	    }
	    prepare(imageManager) {
	        if (this.imageAtlas) {
	            this.imageAtlas.patchUpdatedImages(imageManager, this.imageAtlasTexture);
	        }
	    }
	    // Queries non-symbol features rendered for this tile.
	    // Symbol features are queried globally
	    queryRenderedFeatures(layers, serializedLayers, sourceFeatureState, queryGeometry, cameraQueryGeometry, scale, params, transform, maxPitchScaleFactor, pixelPosMatrix) {
	        if (!this.latestFeatureIndex || !this.latestFeatureIndex.rawTileData)
	            return {};
	        return this.latestFeatureIndex.query({
	            queryGeometry,
	            cameraQueryGeometry,
	            scale,
	            tileSize: this.tileSize,
	            pixelPosMatrix,
	            transform,
	            params,
	            queryPadding: this.queryPadding * maxPitchScaleFactor
	        }, layers, serializedLayers, sourceFeatureState);
	    }
	    querySourceFeatures(result, params) {
	        const featureIndex = this.latestFeatureIndex;
	        if (!featureIndex || !featureIndex.rawTileData)
	            return;
	        const vtLayers = featureIndex.loadVTLayers();
	        const sourceLayer = params && params.sourceLayer ? params.sourceLayer : '';
	        const layer = vtLayers._geojsonTileLayer || vtLayers[sourceLayer];
	        if (!layer)
	            return;
	        const filter = performance$1.createFilter(params && params.filter);
	        const { z, x, y } = this.tileID.canonical;
	        const coord = { z, x, y };
	        for (let i = 0; i < layer.length; i++) {
	            const feature = layer.feature(i);
	            if (filter.needGeometry) {
	                const evaluationFeature = performance$1.toEvaluationFeature(feature, true);
	                if (!filter.filter(new performance$1.EvaluationParameters(this.tileID.overscaledZ), evaluationFeature, this.tileID.canonical))
	                    continue;
	            }
	            else if (!filter.filter(new performance$1.EvaluationParameters(this.tileID.overscaledZ), feature)) {
	                continue;
	            }
	            const id = featureIndex.getId(feature, sourceLayer);
	            const geojsonFeature = new performance$1.GeoJSONFeature(feature, z, x, y, id);
	            geojsonFeature.tile = coord;
	            result.push(geojsonFeature);
	        }
	    }
	    hasData() {
	        return this.state === 'loaded' || this.state === 'reloading' || this.state === 'expired';
	    }
	    patternsLoaded() {
	        return this.imageAtlas && !!Object.keys(this.imageAtlas.patternPositions).length;
	    }
	    setExpiryData(data) {
	        const prior = this.expirationTime;
	        if (data.cacheControl) {
	            const parsedCC = performance$1.parseCacheControl(data.cacheControl);
	            if (parsedCC['max-age'])
	                this.expirationTime = Date.now() + parsedCC['max-age'] * 1000;
	        }
	        else if (data.expires) {
	            this.expirationTime = new Date(data.expires).getTime();
	        }
	        if (this.expirationTime) {
	            const now = Date.now();
	            let isExpired = false;
	            if (this.expirationTime > now) {
	                isExpired = false;
	            }
	            else if (!prior) {
	                isExpired = true;
	            }
	            else if (this.expirationTime < prior) {
	                // Expiring date is going backwards:
	                // fall back to exponential backoff
	                isExpired = true;
	            }
	            else {
	                const delta = this.expirationTime - prior;
	                if (!delta) {
	                    // Server is serving the same expired resource over and over: fall
	                    // back to exponential backoff.
	                    isExpired = true;
	                }
	                else {
	                    // Assume that either the client or the server clock is wrong and
	                    // try to interpolate a valid expiration date (from the client POV)
	                    // observing a minimum timeout.
	                    this.expirationTime = now + Math.max(delta, CLOCK_SKEW_RETRY_TIMEOUT);
	                }
	            }
	            if (isExpired) {
	                this.expiredRequestCount++;
	                this.state = 'expired';
	            }
	            else {
	                this.expiredRequestCount = 0;
	            }
	        }
	    }
	    getExpiryTimeout() {
	        if (this.expirationTime) {
	            if (this.expiredRequestCount) {
	                return 1000 * (1 << Math.min(this.expiredRequestCount - 1, 31));
	            }
	            else {
	                // Max value for `setTimeout` implementations is a 32 bit integer; cap this accordingly
	                return Math.min(this.expirationTime - new Date().getTime(), Math.pow(2, 31) - 1);
	            }
	        }
	    }
	    setFeatureState(states, painter) {
	        if (!this.latestFeatureIndex ||
	            !this.latestFeatureIndex.rawTileData ||
	            Object.keys(states).length === 0) {
	            return;
	        }
	        const vtLayers = this.latestFeatureIndex.loadVTLayers();
	        for (const id in this.buckets) {
	            if (!painter.style.hasLayer(id))
	                continue;
	            const bucket = this.buckets[id];
	            // Buckets are grouped by common source-layer
	            const sourceLayerId = bucket.layers[0]['sourceLayer'] || '_geojsonTileLayer';
	            const sourceLayer = vtLayers[sourceLayerId];
	            const sourceLayerStates = states[sourceLayerId];
	            if (!sourceLayer || !sourceLayerStates || Object.keys(sourceLayerStates).length === 0)
	                continue;
	            bucket.update(sourceLayerStates, sourceLayer, this.imageAtlas && this.imageAtlas.patternPositions || {});
	            const layer = painter && painter.style && painter.style.getLayer(id);
	            if (layer) {
	                this.queryPadding = Math.max(this.queryPadding, layer.queryRadius(bucket));
	            }
	        }
	    }
	    holdingForFade() {
	        return this.symbolFadeHoldUntil !== undefined;
	    }
	    symbolFadeFinished() {
	        return !this.symbolFadeHoldUntil || this.symbolFadeHoldUntil < browser.now();
	    }
	    clearFadeHold() {
	        this.symbolFadeHoldUntil = undefined;
	    }
	    setHoldDuration(duration) {
	        this.symbolFadeHoldUntil = browser.now() + duration;
	    }
	    setDependencies(namespace, dependencies) {
	        const index = {};
	        for (const dep of dependencies) {
	            index[dep] = true;
	        }
	        this.dependencies[namespace] = index;
	    }
	    hasDependency(namespaces, keys) {
	        for (const namespace of namespaces) {
	            const dependencies = this.dependencies[namespace];
	            if (dependencies) {
	                for (const key of keys) {
	                    if (dependencies[key]) {
	                        return true;
	                    }
	                }
	            }
	        }
	        return false;
	    }
	}

	/**
	 * @internal
	 * A [least-recently-used cache](http://en.wikipedia.org/wiki/Cache_algorithms)
	 * with hash lookup made possible by keeping a list of keys in parallel to
	 * an array of dictionary of values
	 */
	class TileCache {
	    /**
	     * @param max - number of permitted values
	     * @param onRemove - callback called with items when they expire
	     */
	    constructor(max, onRemove) {
	        this.max = max;
	        this.onRemove = onRemove;
	        this.reset();
	    }
	    /**
	     * Clear the cache
	     *
	     * @returns this cache
	     */
	    reset() {
	        for (const key in this.data) {
	            for (const removedData of this.data[key]) {
	                if (removedData.timeout)
	                    clearTimeout(removedData.timeout);
	                this.onRemove(removedData.value);
	            }
	        }
	        this.data = {};
	        this.order = [];
	        return this;
	    }
	    /**
	     * Add a key, value combination to the cache, trimming its size if this pushes
	     * it over max length.
	     *
	     * @param tileID - lookup key for the item
	     * @param data - tile data
	     *
	     * @returns this cache
	     */
	    add(tileID, data, expiryTimeout) {
	        const key = tileID.wrapped().key;
	        if (this.data[key] === undefined) {
	            this.data[key] = [];
	        }
	        const dataWrapper = {
	            value: data,
	            timeout: undefined
	        };
	        if (expiryTimeout !== undefined) {
	            dataWrapper.timeout = setTimeout(() => {
	                this.remove(tileID, dataWrapper);
	            }, expiryTimeout);
	        }
	        this.data[key].push(dataWrapper);
	        this.order.push(key);
	        if (this.order.length > this.max) {
	            const removedData = this._getAndRemoveByKey(this.order[0]);
	            if (removedData)
	                this.onRemove(removedData);
	        }
	        return this;
	    }
	    /**
	     * Determine whether the value attached to `key` is present
	     *
	     * @param tileID - the key to be looked-up
	     * @returns whether the cache has this value
	     */
	    has(tileID) {
	        return tileID.wrapped().key in this.data;
	    }
	    /**
	     * Get the value attached to a specific key and remove data from cache.
	     * If the key is not found, returns `null`
	     *
	     * @param tileID - the key to look up
	     * @returns the tile data, or null if it isn't found
	     */
	    getAndRemove(tileID) {
	        if (!this.has(tileID)) {
	            return null;
	        }
	        return this._getAndRemoveByKey(tileID.wrapped().key);
	    }
	    /*
	     * Get and remove the value with the specified key.
	     */
	    _getAndRemoveByKey(key) {
	        const data = this.data[key].shift();
	        if (data.timeout)
	            clearTimeout(data.timeout);
	        if (this.data[key].length === 0) {
	            delete this.data[key];
	        }
	        this.order.splice(this.order.indexOf(key), 1);
	        return data.value;
	    }
	    /*
	     * Get the value with the specified (wrapped tile) key.
	     */
	    getByKey(key) {
	        const data = this.data[key];
	        return data ? data[0].value : null;
	    }
	    /**
	     * Get the value attached to a specific key without removing data
	     * from the cache. If the key is not found, returns `null`
	     *
	     * @param tileID - the key to look up
	     * @returns the tile data, or null if it isn't found
	     */
	    get(tileID) {
	        if (!this.has(tileID)) {
	            return null;
	        }
	        const data = this.data[tileID.wrapped().key][0];
	        return data.value;
	    }
	    /**
	     * Remove a key/value combination from the cache.
	     *
	     * @param tileID - the key for the pair to delete
	     * @param value - If a value is provided, remove that exact version of the value.
	     * @returns this cache
	     */
	    remove(tileID, value) {
	        if (!this.has(tileID)) {
	            return this;
	        }
	        const key = tileID.wrapped().key;
	        const dataIndex = value === undefined ? 0 : this.data[key].indexOf(value);
	        const data = this.data[key][dataIndex];
	        this.data[key].splice(dataIndex, 1);
	        if (data.timeout)
	            clearTimeout(data.timeout);
	        if (this.data[key].length === 0) {
	            delete this.data[key];
	        }
	        this.onRemove(data.value);
	        this.order.splice(this.order.indexOf(key), 1);
	        return this;
	    }
	    /**
	     * Change the max size of the cache.
	     *
	     * @param max - the max size of the cache
	     * @returns this cache
	     */
	    setMaxSize(max) {
	        this.max = max;
	        while (this.order.length > this.max) {
	            const removedData = this._getAndRemoveByKey(this.order[0]);
	            if (removedData)
	                this.onRemove(removedData);
	        }
	        return this;
	    }
	    /**
	     * Remove entries that do not pass a filter function. Used for removing
	     * stale tiles from the cache.
	     *
	     * @param filterFn - Determines whether the tile is filtered. If the supplied function returns false, the tile will be filtered out.
	     */
	    filter(filterFn) {
	        const removed = [];
	        for (const key in this.data) {
	            for (const entry of this.data[key]) {
	                if (!filterFn(entry.value)) {
	                    removed.push(entry);
	                }
	            }
	        }
	        for (const r of removed) {
	            this.remove(r.value.tileID, r);
	        }
	    }
	}

	/**
	 * @internal
	 * SourceFeatureState manages the state and pending changes
	 * to features in a source, separated by source layer.
	 * stateChanges and deletedStates batch all changes to the tile (updates and removes, respectively)
	 * between coalesce() events. addFeatureState() and removeFeatureState() also update their counterpart's
	 * list of changes, such that coalesce() can apply the proper state changes while agnostic to the order of operations.
	 * In deletedStates, all null's denote complete removal of state at that scope
	*/
	class SourceFeatureState {
	    constructor() {
	        this.state = {};
	        this.stateChanges = {};
	        this.deletedStates = {};
	    }
	    updateState(sourceLayer, featureId, newState) {
	        const feature = String(featureId);
	        this.stateChanges[sourceLayer] = this.stateChanges[sourceLayer] || {};
	        this.stateChanges[sourceLayer][feature] = this.stateChanges[sourceLayer][feature] || {};
	        performance$1.extend(this.stateChanges[sourceLayer][feature], newState);
	        if (this.deletedStates[sourceLayer] === null) {
	            this.deletedStates[sourceLayer] = {};
	            for (const ft in this.state[sourceLayer]) {
	                if (ft !== feature)
	                    this.deletedStates[sourceLayer][ft] = null;
	            }
	        }
	        else {
	            const featureDeletionQueued = this.deletedStates[sourceLayer] && this.deletedStates[sourceLayer][feature] === null;
	            if (featureDeletionQueued) {
	                this.deletedStates[sourceLayer][feature] = {};
	                for (const prop in this.state[sourceLayer][feature]) {
	                    if (!newState[prop])
	                        this.deletedStates[sourceLayer][feature][prop] = null;
	                }
	            }
	            else {
	                for (const key in newState) {
	                    const deletionInQueue = this.deletedStates[sourceLayer] && this.deletedStates[sourceLayer][feature] && this.deletedStates[sourceLayer][feature][key] === null;
	                    if (deletionInQueue)
	                        delete this.deletedStates[sourceLayer][feature][key];
	                }
	            }
	        }
	    }
	    removeFeatureState(sourceLayer, featureId, key) {
	        const sourceLayerDeleted = this.deletedStates[sourceLayer] === null;
	        if (sourceLayerDeleted)
	            return;
	        const feature = String(featureId);
	        this.deletedStates[sourceLayer] = this.deletedStates[sourceLayer] || {};
	        if (key && featureId !== undefined) {
	            if (this.deletedStates[sourceLayer][feature] !== null) {
	                this.deletedStates[sourceLayer][feature] = this.deletedStates[sourceLayer][feature] || {};
	                this.deletedStates[sourceLayer][feature][key] = null;
	            }
	        }
	        else if (featureId !== undefined) {
	            const updateInQueue = this.stateChanges[sourceLayer] && this.stateChanges[sourceLayer][feature];
	            if (updateInQueue) {
	                this.deletedStates[sourceLayer][feature] = {};
	                for (key in this.stateChanges[sourceLayer][feature])
	                    this.deletedStates[sourceLayer][feature][key] = null;
	            }
	            else {
	                this.deletedStates[sourceLayer][feature] = null;
	            }
	        }
	        else {
	            this.deletedStates[sourceLayer] = null;
	        }
	    }
	    getState(sourceLayer, featureId) {
	        const feature = String(featureId);
	        const base = this.state[sourceLayer] || {};
	        const changes = this.stateChanges[sourceLayer] || {};
	        const reconciledState = performance$1.extend({}, base[feature], changes[feature]);
	        //return empty object if the whole source layer is awaiting deletion
	        if (this.deletedStates[sourceLayer] === null)
	            return {};
	        else if (this.deletedStates[sourceLayer]) {
	            const featureDeletions = this.deletedStates[sourceLayer][featureId];
	            if (featureDeletions === null)
	                return {};
	            for (const prop in featureDeletions)
	                delete reconciledState[prop];
	        }
	        return reconciledState;
	    }
	    initializeTileState(tile, painter) {
	        tile.setFeatureState(this.state, painter);
	    }
	    coalesceChanges(tiles, painter) {
	        //track changes with full state objects, but only for features that got modified
	        const featuresChanged = {};
	        for (const sourceLayer in this.stateChanges) {
	            this.state[sourceLayer] = this.state[sourceLayer] || {};
	            const layerStates = {};
	            for (const feature in this.stateChanges[sourceLayer]) {
	                if (!this.state[sourceLayer][feature])
	                    this.state[sourceLayer][feature] = {};
	                performance$1.extend(this.state[sourceLayer][feature], this.stateChanges[sourceLayer][feature]);
	                layerStates[feature] = this.state[sourceLayer][feature];
	            }
	            featuresChanged[sourceLayer] = layerStates;
	        }
	        for (const sourceLayer in this.deletedStates) {
	            this.state[sourceLayer] = this.state[sourceLayer] || {};
	            const layerStates = {};
	            if (this.deletedStates[sourceLayer] === null) {
	                for (const ft in this.state[sourceLayer]) {
	                    layerStates[ft] = {};
	                    this.state[sourceLayer][ft] = {};
	                }
	            }
	            else {
	                for (const feature in this.deletedStates[sourceLayer]) {
	                    const deleteWholeFeatureState = this.deletedStates[sourceLayer][feature] === null;
	                    if (deleteWholeFeatureState)
	                        this.state[sourceLayer][feature] = {};
	                    else {
	                        for (const key of Object.keys(this.deletedStates[sourceLayer][feature])) {
	                            delete this.state[sourceLayer][feature][key];
	                        }
	                    }
	                    layerStates[feature] = this.state[sourceLayer][feature];
	                }
	            }
	            featuresChanged[sourceLayer] = featuresChanged[sourceLayer] || {};
	            performance$1.extend(featuresChanged[sourceLayer], layerStates);
	        }
	        this.stateChanges = {};
	        this.deletedStates = {};
	        if (Object.keys(featuresChanged).length === 0)
	            return;
	        for (const id in tiles) {
	            const tile = tiles[id];
	            tile.setFeatureState(featuresChanged, painter);
	        }
	    }
	}

	/**
	 * @internal
	 * `SourceCache` is responsible for
	 *
	 *  - creating an instance of `Source`
	 *  - forwarding events from `Source`
	 *  - caching tiles loaded from an instance of `Source`
	 *  - loading the tiles needed to render a given viewport
	 *  - unloading the cached tiles not needed to render a given viewport
	 */
	class SourceCache extends performance$1.Evented {
	    constructor(id, options, dispatcher) {
	        super();
	        this.id = id;
	        this.dispatcher = dispatcher;
	        this.on('data', (e) => {
	            // this._sourceLoaded signifies that the TileJSON is loaded if applicable.
	            // if the source type does not come with a TileJSON, the flag signifies the
	            // source data has loaded (i.e geojson has been tiled on the worker and is ready)
	            if (e.dataType === 'source' && e.sourceDataType === 'metadata')
	                this._sourceLoaded = true;
	            // for sources with mutable data, this event fires when the underlying data
	            // to a source is changed. (i.e. GeoJSONSource#setData and ImageSource#serCoordinates)
	            if (this._sourceLoaded && !this._paused && e.dataType === 'source' && e.sourceDataType === 'content') {
	                this.reload();
	                if (this.transform) {
	                    this.update(this.transform, this.terrain);
	                }
	                this._didEmitContent = true;
	            }
	        });
	        this.on('dataloading', () => {
	            this._sourceErrored = false;
	        });
	        this.on('error', () => {
	            // Only set _sourceErrored if the source does not have pending loads.
	            this._sourceErrored = this._source.loaded();
	        });
	        this._source = create(id, options, dispatcher, this);
	        this._tiles = {};
	        this._cache = new TileCache(0, (tile) => this._unloadTile(tile));
	        this._timers = {};
	        this._cacheTimers = {};
	        this._maxTileCacheSize = null;
	        this._maxTileCacheZoomLevels = null;
	        this._loadedParentTiles = {};
	        this._coveredTiles = {};
	        this._state = new SourceFeatureState();
	        this._didEmitContent = false;
	        this._updated = false;
	    }
	    onAdd(map) {
	        this.map = map;
	        this._maxTileCacheSize = map ? map._maxTileCacheSize : null;
	        this._maxTileCacheZoomLevels = map ? map._maxTileCacheZoomLevels : null;
	        if (this._source && this._source.onAdd) {
	            this._source.onAdd(map);
	        }
	    }
	    onRemove(map) {
	        this.clearTiles();
	        if (this._source && this._source.onRemove) {
	            this._source.onRemove(map);
	        }
	    }
	    /**
	     * Return true if no tile data is pending, tiles will not change unless
	     * an additional API call is received.
	     */
	    loaded() {
	        if (this._sourceErrored) {
	            return true;
	        }
	        if (!this._sourceLoaded) {
	            return false;
	        }
	        if (!this._source.loaded()) {
	            return false;
	        }
	        if ((this.used !== undefined || this.usedForTerrain !== undefined) && !this.used && !this.usedForTerrain) {
	            return true;
	        }
	        // do not consider as loaded if the update hasn't been called yet (we do not know if we will have any tiles to fetch)
	        if (!this._updated) {
	            return false;
	        }
	        for (const t in this._tiles) {
	            const tile = this._tiles[t];
	            if (tile.state !== 'loaded' && tile.state !== 'errored')
	                return false;
	        }
	        return true;
	    }
	    getSource() {
	        return this._source;
	    }
	    pause() {
	        this._paused = true;
	    }
	    resume() {
	        if (!this._paused)
	            return;
	        const shouldReload = this._shouldReloadOnResume;
	        this._paused = false;
	        this._shouldReloadOnResume = false;
	        if (shouldReload)
	            this.reload();
	        if (this.transform)
	            this.update(this.transform, this.terrain);
	    }
	    _loadTile(tile, id, state) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            try {
	                yield this._source.loadTile(tile);
	                this._tileLoaded(tile, id, state);
	            }
	            catch (err) {
	                tile.state = 'errored';
	                if (err.status !== 404) {
	                    this._source.fire(new performance$1.ErrorEvent(err, { tile }));
	                }
	                else {
	                    // continue to try loading parent/children tiles if a tile doesn't exist (404)
	                    this.update(this.transform, this.terrain);
	                }
	            }
	        });
	    }
	    _unloadTile(tile) {
	        if (this._source.unloadTile)
	            this._source.unloadTile(tile);
	    }
	    _abortTile(tile) {
	        if (this._source.abortTile)
	            this._source.abortTile(tile);
	        this._source.fire(new performance$1.Event('dataabort', { tile, coord: tile.tileID, dataType: 'source' }));
	    }
	    serialize() {
	        return this._source.serialize();
	    }
	    prepare(context) {
	        if (this._source.prepare) {
	            this._source.prepare();
	        }
	        this._state.coalesceChanges(this._tiles, this.map ? this.map.painter : null);
	        for (const i in this._tiles) {
	            const tile = this._tiles[i];
	            tile.upload(context);
	            tile.prepare(this.map.style.imageManager);
	        }
	    }
	    /**
	     * Return all tile ids ordered with z-order, and cast to numbers
	     */
	    getIds() {
	        return Object.values(this._tiles).map((tile) => tile.tileID).sort(compareTileId).map(id => id.key);
	    }
	    getRenderableIds(symbolLayer) {
	        const renderables = [];
	        for (const id in this._tiles) {
	            if (this._isIdRenderable(id, symbolLayer))
	                renderables.push(this._tiles[id]);
	        }
	        if (symbolLayer) {
	            return renderables.sort((a_, b_) => {
	                const a = a_.tileID;
	                const b = b_.tileID;
	                const rotatedA = (new performance$1.Point(a.canonical.x, a.canonical.y))._rotate(this.transform.angle);
	                const rotatedB = (new performance$1.Point(b.canonical.x, b.canonical.y))._rotate(this.transform.angle);
	                return a.overscaledZ - b.overscaledZ || rotatedB.y - rotatedA.y || rotatedB.x - rotatedA.x;
	            }).map(tile => tile.tileID.key);
	        }
	        return renderables.map(tile => tile.tileID).sort(compareTileId).map(id => id.key);
	    }
	    hasRenderableParent(tileID) {
	        const parentTile = this.findLoadedParent(tileID, 0);
	        if (parentTile) {
	            return this._isIdRenderable(parentTile.tileID.key);
	        }
	        return false;
	    }
	    _isIdRenderable(id, symbolLayer) {
	        return this._tiles[id] && this._tiles[id].hasData() &&
	            !this._coveredTiles[id] && (symbolLayer || !this._tiles[id].holdingForFade());
	    }
	    reload() {
	        if (this._paused) {
	            this._shouldReloadOnResume = true;
	            return;
	        }
	        this._cache.reset();
	        for (const i in this._tiles) {
	            if (this._tiles[i].state !== 'errored')
	                this._reloadTile(i, 'reloading');
	        }
	    }
	    _reloadTile(id, state) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const tile = this._tiles[id];
	            // this potentially does not address all underlying
	            // issues https://github.com/mapbox/mapbox-gl-js/issues/4252
	            // - hard to tell without repro steps
	            if (!tile)
	                return;
	            // The difference between "loading" tiles and "reloading" or "expired"
	            // tiles is that "reloading"/"expired" tiles are "renderable".
	            // Therefore, a "loading" tile cannot become a "reloading" tile without
	            // first becoming a "loaded" tile.
	            if (tile.state !== 'loading') {
	                tile.state = state;
	            }
	            yield this._loadTile(tile, id, state);
	        });
	    }
	    _tileLoaded(tile, id, previousState) {
	        tile.timeAdded = browser.now();
	        if (previousState === 'expired')
	            tile.refreshedUponExpiration = true;
	        this._setTileReloadTimer(id, tile);
	        if (this.getSource().type === 'raster-dem' && tile.dem)
	            this._backfillDEM(tile);
	        this._state.initializeTileState(tile, this.map ? this.map.painter : null);
	        if (!tile.aborted) {
	            this._source.fire(new performance$1.Event('data', { dataType: 'source', tile, coord: tile.tileID }));
	        }
	    }
	    /**
	    * For raster terrain source, backfill DEM to eliminate visible tile boundaries
	    */
	    _backfillDEM(tile) {
	        const renderables = this.getRenderableIds();
	        for (let i = 0; i < renderables.length; i++) {
	            const borderId = renderables[i];
	            if (tile.neighboringTiles && tile.neighboringTiles[borderId]) {
	                const borderTile = this.getTileByID(borderId);
	                fillBorder(tile, borderTile);
	                fillBorder(borderTile, tile);
	            }
	        }
	        function fillBorder(tile, borderTile) {
	            tile.needsHillshadePrepare = true;
	            tile.needsTerrainPrepare = true;
	            let dx = borderTile.tileID.canonical.x - tile.tileID.canonical.x;
	            const dy = borderTile.tileID.canonical.y - tile.tileID.canonical.y;
	            const dim = Math.pow(2, tile.tileID.canonical.z);
	            const borderId = borderTile.tileID.key;
	            if (dx === 0 && dy === 0)
	                return;
	            if (Math.abs(dy) > 1) {
	                return;
	            }
	            if (Math.abs(dx) > 1) {
	                // Adjust the delta coordinate for world wraparound.
	                if (Math.abs(dx + dim) === 1) {
	                    dx += dim;
	                }
	                else if (Math.abs(dx - dim) === 1) {
	                    dx -= dim;
	                }
	            }
	            if (!borderTile.dem || !tile.dem)
	                return;
	            tile.dem.backfillBorder(borderTile.dem, dx, dy);
	            if (tile.neighboringTiles && tile.neighboringTiles[borderId])
	                tile.neighboringTiles[borderId].backfilled = true;
	        }
	    }
	    /**
	     * Get a specific tile by TileID
	     */
	    getTile(tileID) {
	        return this.getTileByID(tileID.key);
	    }
	    /**
	     * Get a specific tile by id
	     */
	    getTileByID(id) {
	        return this._tiles[id];
	    }
	    /**
	     * For a given set of tiles, retain children that are loaded and have a zoom
	     * between `zoom` (exclusive) and `maxCoveringZoom` (inclusive)
	     */
	    _retainLoadedChildren(idealTiles, zoom, maxCoveringZoom, retain) {
	        for (const id in this._tiles) {
	            let tile = this._tiles[id];
	            // only consider renderable tiles up to maxCoveringZoom
	            if (retain[id] ||
	                !tile.hasData() ||
	                tile.tileID.overscaledZ <= zoom ||
	                tile.tileID.overscaledZ > maxCoveringZoom)
	                continue;
	            // loop through parents and retain the topmost loaded one if found
	            let topmostLoadedID = tile.tileID;
	            while (tile && tile.tileID.overscaledZ > zoom + 1) {
	                const parentID = tile.tileID.scaledTo(tile.tileID.overscaledZ - 1);
	                tile = this._tiles[parentID.key];
	                if (tile && tile.hasData()) {
	                    topmostLoadedID = parentID;
	                }
	            }
	            // loop through ancestors of the topmost loaded child to see if there's one that needed it
	            let tileID = topmostLoadedID;
	            while (tileID.overscaledZ > zoom) {
	                tileID = tileID.scaledTo(tileID.overscaledZ - 1);
	                if (idealTiles[tileID.key]) {
	                    // found a parent that needed a loaded child; retain that child
	                    retain[topmostLoadedID.key] = topmostLoadedID;
	                    break;
	                }
	            }
	        }
	    }
	    /**
	     * Find a loaded parent of the given tile (up to minCoveringZoom)
	     */
	    findLoadedParent(tileID, minCoveringZoom) {
	        if (tileID.key in this._loadedParentTiles) {
	            const parent = this._loadedParentTiles[tileID.key];
	            if (parent && parent.tileID.overscaledZ >= minCoveringZoom) {
	                return parent;
	            }
	            else {
	                return null;
	            }
	        }
	        for (let z = tileID.overscaledZ - 1; z >= minCoveringZoom; z--) {
	            const parentTileID = tileID.scaledTo(z);
	            const tile = this._getLoadedTile(parentTileID);
	            if (tile) {
	                return tile;
	            }
	        }
	    }
	    _getLoadedTile(tileID) {
	        const tile = this._tiles[tileID.key];
	        if (tile && tile.hasData()) {
	            return tile;
	        }
	        // TileCache ignores wrap in lookup.
	        const cachedTile = this._cache.getByKey(tileID.wrapped().key);
	        return cachedTile;
	    }
	    /**
	     * Resizes the tile cache based on the current viewport's size
	     * or the maxTileCacheSize option passed during map creation
	     *
	     * Larger viewports use more tiles and need larger caches. Larger viewports
	     * are more likely to be found on devices with more memory and on pages where
	     * the map is more important.
	     */
	    updateCacheSize(transform) {
	        const widthInTiles = Math.ceil(transform.width / this._source.tileSize) + 1;
	        const heightInTiles = Math.ceil(transform.height / this._source.tileSize) + 1;
	        const approxTilesInView = widthInTiles * heightInTiles;
	        const commonZoomRange = this._maxTileCacheZoomLevels === null ?
	            performance$1.config.MAX_TILE_CACHE_ZOOM_LEVELS : this._maxTileCacheZoomLevels;
	        const viewDependentMaxSize = Math.floor(approxTilesInView * commonZoomRange);
	        const maxSize = typeof this._maxTileCacheSize === 'number' ?
	            Math.min(this._maxTileCacheSize, viewDependentMaxSize) : viewDependentMaxSize;
	        this._cache.setMaxSize(maxSize);
	    }
	    handleWrapJump(lng) {
	        // On top of the regular z/x/y values, TileIDs have a `wrap` value that specify
	        // which cppy of the world the tile belongs to. For example, at `lng: 10` you
	        // might render z/x/y/0 while at `lng: 370` you would render z/x/y/1.
	        //
	        // When lng values get wrapped (going from `lng: 370` to `long: 10`) you expect
	        // to see the same thing on the screen (370 degrees and 10 degrees is the same
	        // place in the world) but all the TileIDs will have different wrap values.
	        //
	        // In order to make this transition seamless, we calculate the rounded difference of
	        // "worlds" between the last frame and the current frame. If the map panned by
	        // a world, then we can assign all the tiles new TileIDs with updated wrap values.
	        // For example, assign z/x/y/1 a new id: z/x/y/0. It is the same tile, just rendered
	        // in a different position.
	        //
	        // This enables us to reuse the tiles at more ideal locations and prevent flickering.
	        const prevLng = this._prevLng === undefined ? lng : this._prevLng;
	        const lngDifference = lng - prevLng;
	        const worldDifference = lngDifference / 360;
	        const wrapDelta = Math.round(worldDifference);
	        this._prevLng = lng;
	        if (wrapDelta) {
	            const tiles = {};
	            for (const key in this._tiles) {
	                const tile = this._tiles[key];
	                tile.tileID = tile.tileID.unwrapTo(tile.tileID.wrap + wrapDelta);
	                tiles[tile.tileID.key] = tile;
	            }
	            this._tiles = tiles;
	            // Reset tile reload timers
	            for (const id in this._timers) {
	                clearTimeout(this._timers[id]);
	                delete this._timers[id];
	            }
	            for (const id in this._tiles) {
	                const tile = this._tiles[id];
	                this._setTileReloadTimer(id, tile);
	            }
	        }
	    }
	    /**
	     * Removes tiles that are outside the viewport and adds new tiles that
	     * are inside the viewport.
	     */
	    update(transform, terrain) {
	        this.transform = transform;
	        this.terrain = terrain;
	        if (!this._sourceLoaded || this._paused) {
	            return;
	        }
	        this.updateCacheSize(transform);
	        this.handleWrapJump(this.transform.center.lng);
	        // Covered is a list of retained tiles who's areas are fully covered by other,
	        // better, retained tiles. They are not drawn separately.
	        this._coveredTiles = {};
	        let idealTileIDs;
	        if (!this.used && !this.usedForTerrain) {
	            idealTileIDs = [];
	        }
	        else if (this._source.tileID) {
	            idealTileIDs = transform.getVisibleUnwrappedCoordinates(this._source.tileID)
	                .map((unwrapped) => new performance$1.OverscaledTileID(unwrapped.canonical.z, unwrapped.wrap, unwrapped.canonical.z, unwrapped.canonical.x, unwrapped.canonical.y));
	        }
	        else {
	            idealTileIDs = transform.coveringTiles({
	                tileSize: this.usedForTerrain ? this.tileSize : this._source.tileSize,
	                minzoom: this._source.minzoom,
	                maxzoom: this._source.maxzoom,
	                roundZoom: this.usedForTerrain ? false : this._source.roundZoom,
	                reparseOverscaled: this._source.reparseOverscaled,
	                terrain
	            });
	            if (this._source.hasTile) {
	                idealTileIDs = idealTileIDs.filter((coord) => this._source.hasTile(coord));
	            }
	        }
	        // Determine the overzooming/underzooming amounts.
	        const zoom = transform.coveringZoomLevel(this._source);
	        const minCoveringZoom = Math.max(zoom - SourceCache.maxOverzooming, this._source.minzoom);
	        const maxCoveringZoom = Math.max(zoom + SourceCache.maxUnderzooming, this._source.minzoom);
	        // When sourcecache is used for terrain also load parent tiles to avoid flickering when zooming out
	        if (this.usedForTerrain) {
	            const parents = {};
	            for (const tileID of idealTileIDs) {
	                if (tileID.canonical.z > this._source.minzoom) {
	                    const parent = tileID.scaledTo(tileID.canonical.z - 1);
	                    parents[parent.key] = parent;
	                    // load very low zoom to calculate tile visibility in transform.coveringTiles and high zoomlevels correct
	                    const parent2 = tileID.scaledTo(Math.max(this._source.minzoom, Math.min(tileID.canonical.z, 5)));
	                    parents[parent2.key] = parent2;
	                }
	            }
	            idealTileIDs = idealTileIDs.concat(Object.values(parents));
	        }
	        const noPendingDataEmissions = idealTileIDs.length === 0 && !this._updated && this._didEmitContent;
	        this._updated = true;
	        // if we won't have any tiles to fetch and content is already emitted
	        // there will be no more data emissions, so we need to emit the event with isSourceLoaded = true
	        if (noPendingDataEmissions) {
	            this.fire(new performance$1.Event('data', { sourceDataType: 'idle', dataType: 'source', sourceId: this.id }));
	        }
	        // Retain is a list of tiles that we shouldn't delete, even if they are not
	        // the most ideal tile for the current viewport. This may include tiles like
	        // parent or child tiles that are *already* loaded.
	        const retain = this._updateRetainedTiles(idealTileIDs, zoom);
	        if (isRasterType(this._source.type)) {
	            const parentsForFading = {};
	            const fadingTiles = {};
	            const ids = Object.keys(retain);
	            const now = browser.now();
	            for (const id of ids) {
	                const tileID = retain[id];
	                const tile = this._tiles[id];
	                // when fadeEndTime is 0, the tile is created but registerFadeDuration
	                // has not been called, therefore must be kept in fadingTiles dictionary
	                // for next round of rendering
	                if (!tile || (tile.fadeEndTime !== 0 && tile.fadeEndTime <= now)) {
	                    continue;
	                }
	                // if the tile is loaded but still fading in, find parents to cross-fade with it
	                const parentTile = this.findLoadedParent(tileID, minCoveringZoom);
	                if (parentTile) {
	                    this._addTile(parentTile.tileID);
	                    parentsForFading[parentTile.tileID.key] = parentTile.tileID;
	                }
	                fadingTiles[id] = tileID;
	            }
	            // for tiles that are still fading in, also find children to cross-fade with
	            this._retainLoadedChildren(fadingTiles, zoom, maxCoveringZoom, retain);
	            for (const id in parentsForFading) {
	                if (!retain[id]) {
	                    // If a tile is only needed for fading, mark it as covered so that it isn't rendered on it's own.
	                    this._coveredTiles[id] = true;
	                    retain[id] = parentsForFading[id];
	                }
	            }
	            // disable fading logic in terrain3D mode to avoid rendering two tiles on the same place
	            if (terrain) {
	                const idealRasterTileIDs = {};
	                const missingTileIDs = {};
	                for (const tileID of idealTileIDs) {
	                    if (this._tiles[tileID.key].hasData())
	                        idealRasterTileIDs[tileID.key] = tileID;
	                    else
	                        missingTileIDs[tileID.key] = tileID;
	                }
	                // search for a complete set of children for each missing tile
	                for (const key in missingTileIDs) {
	                    const children = missingTileIDs[key].children(this._source.maxzoom);
	                    if (this._tiles[children[0].key] && this._tiles[children[1].key] && this._tiles[children[2].key] && this._tiles[children[3].key]) {
	                        idealRasterTileIDs[children[0].key] = retain[children[0].key] = children[0];
	                        idealRasterTileIDs[children[1].key] = retain[children[1].key] = children[1];
	                        idealRasterTileIDs[children[2].key] = retain[children[2].key] = children[2];
	                        idealRasterTileIDs[children[3].key] = retain[children[3].key] = children[3];
	                        delete missingTileIDs[key];
	                    }
	                }
	                // search for parent for each missing tile
	                for (const key in missingTileIDs) {
	                    const parent = this.findLoadedParent(missingTileIDs[key], this._source.minzoom);
	                    if (parent) {
	                        idealRasterTileIDs[parent.tileID.key] = retain[parent.tileID.key] = parent.tileID;
	                        // remove idealTiles which would be rendered twice
	                        for (const key in idealRasterTileIDs) {
	                            if (idealRasterTileIDs[key].isChildOf(parent.tileID))
	                                delete idealRasterTileIDs[key];
	                        }
	                    }
	                }
	                // cover all tiles which are not needed
	                for (const key in this._tiles) {
	                    if (!idealRasterTileIDs[key])
	                        this._coveredTiles[key] = true;
	                }
	            }
	        }
	        for (const retainedId in retain) {
	            // Make sure retained tiles always clear any existing fade holds
	            // so that if they're removed again their fade timer starts fresh.
	            this._tiles[retainedId].clearFadeHold();
	        }
	        // Remove the tiles we don't need anymore.
	        const remove = performance$1.keysDifference(this._tiles, retain);
	        for (const tileID of remove) {
	            const tile = this._tiles[tileID];
	            if (tile.hasSymbolBuckets && !tile.holdingForFade()) {
	                tile.setHoldDuration(this.map._fadeDuration);
	            }
	            else if (!tile.hasSymbolBuckets || tile.symbolFadeFinished()) {
	                this._removeTile(tileID);
	            }
	        }
	        // Construct a cache of loaded parents
	        this._updateLoadedParentTileCache();
	    }
	    releaseSymbolFadeTiles() {
	        for (const id in this._tiles) {
	            if (this._tiles[id].holdingForFade()) {
	                this._removeTile(id);
	            }
	        }
	    }
	    _updateRetainedTiles(idealTileIDs, zoom) {
	        const retain = {};
	        const checked = {};
	        const minCoveringZoom = Math.max(zoom - SourceCache.maxOverzooming, this._source.minzoom);
	        const maxCoveringZoom = Math.max(zoom + SourceCache.maxUnderzooming, this._source.minzoom);
	        const missingTiles = {};
	        for (const tileID of idealTileIDs) {
	            const tile = this._addTile(tileID);
	            // retain the tile even if it's not loaded because it's an ideal tile.
	            retain[tileID.key] = tileID;
	            if (tile.hasData())
	                continue;
	            if (zoom < this._source.maxzoom) {
	                // save missing tiles that potentially have loaded children
	                missingTiles[tileID.key] = tileID;
	            }
	        }
	        // retain any loaded children of ideal tiles up to maxCoveringZoom
	        this._retainLoadedChildren(missingTiles, zoom, maxCoveringZoom, retain);
	        for (const tileID of idealTileIDs) {
	            let tile = this._tiles[tileID.key];
	            if (tile.hasData())
	                continue;
	            // The tile we require is not yet loaded or does not exist;
	            // Attempt to find children that fully cover it.
	            if (zoom + 1 > this._source.maxzoom) {
	                // We're looking for an overzoomed child tile.
	                const childCoord = tileID.children(this._source.maxzoom)[0];
	                const childTile = this.getTile(childCoord);
	                if (!!childTile && childTile.hasData()) {
	                    retain[childCoord.key] = childCoord;
	                    continue; // tile is covered by overzoomed child
	                }
	            }
	            else {
	                // check if all 4 immediate children are loaded (i.e. the missing ideal tile is covered)
	                const children = tileID.children(this._source.maxzoom);
	                if (retain[children[0].key] &&
	                    retain[children[1].key] &&
	                    retain[children[2].key] &&
	                    retain[children[3].key])
	                    continue; // tile is covered by children
	            }
	            // We couldn't find child tiles that entirely cover the ideal tile; look for parents now.
	            // As we ascend up the tile pyramid of the ideal tile, we check whether the parent
	            // tile has been previously requested (and errored because we only loop over tiles with no data)
	            // in order to determine if we need to request its parent.
	            let parentWasRequested = tile.wasRequested();
	            for (let overscaledZ = tileID.overscaledZ - 1; overscaledZ >= minCoveringZoom; --overscaledZ) {
	                const parentId = tileID.scaledTo(overscaledZ);
	                // Break parent tile ascent if this route has been previously checked by another child.
	                if (checked[parentId.key])
	                    break;
	                checked[parentId.key] = true;
	                tile = this.getTile(parentId);
	                if (!tile && parentWasRequested) {
	                    tile = this._addTile(parentId);
	                }
	                if (tile) {
	                    const hasData = tile.hasData();
	                    if (parentWasRequested || hasData) {
	                        retain[parentId.key] = parentId;
	                    }
	                    // Save the current values, since they're the parent of the next iteration
	                    // of the parent tile ascent loop.
	                    parentWasRequested = tile.wasRequested();
	                    if (hasData)
	                        break;
	                }
	            }
	        }
	        return retain;
	    }
	    _updateLoadedParentTileCache() {
	        this._loadedParentTiles = {};
	        for (const tileKey in this._tiles) {
	            const path = [];
	            let parentTile;
	            let currentId = this._tiles[tileKey].tileID;
	            // Find the closest loaded ancestor by traversing the tile tree towards the root and
	            // caching results along the way
	            while (currentId.overscaledZ > 0) {
	                // Do we have a cached result from previous traversals?
	                if (currentId.key in this._loadedParentTiles) {
	                    parentTile = this._loadedParentTiles[currentId.key];
	                    break;
	                }
	                path.push(currentId.key);
	                // Is the parent loaded?
	                const parentId = currentId.scaledTo(currentId.overscaledZ - 1);
	                parentTile = this._getLoadedTile(parentId);
	                if (parentTile) {
	                    break;
	                }
	                currentId = parentId;
	            }
	            // Cache the result of this traversal to all newly visited tiles
	            for (const key of path) {
	                this._loadedParentTiles[key] = parentTile;
	            }
	        }
	    }
	    /**
	     * Add a tile, given its coordinate, to the pyramid.
	     */
	    _addTile(tileID) {
	        let tile = this._tiles[tileID.key];
	        if (tile)
	            return tile;
	        tile = this._cache.getAndRemove(tileID);
	        if (tile) {
	            this._setTileReloadTimer(tileID.key, tile);
	            // set the tileID because the cached tile could have had a different wrap value
	            tile.tileID = tileID;
	            this._state.initializeTileState(tile, this.map ? this.map.painter : null);
	            if (this._cacheTimers[tileID.key]) {
	                clearTimeout(this._cacheTimers[tileID.key]);
	                delete this._cacheTimers[tileID.key];
	                this._setTileReloadTimer(tileID.key, tile);
	            }
	        }
	        const cached = tile;
	        if (!tile) {
	            tile = new Tile(tileID, this._source.tileSize * tileID.overscaleFactor());
	            this._loadTile(tile, tileID.key, tile.state);
	        }
	        tile.uses++;
	        this._tiles[tileID.key] = tile;
	        if (!cached) {
	            this._source.fire(new performance$1.Event('dataloading', { tile, coord: tile.tileID, dataType: 'source' }));
	        }
	        return tile;
	    }
	    _setTileReloadTimer(id, tile) {
	        if (id in this._timers) {
	            clearTimeout(this._timers[id]);
	            delete this._timers[id];
	        }
	        const expiryTimeout = tile.getExpiryTimeout();
	        if (expiryTimeout) {
	            this._timers[id] = setTimeout(() => {
	                this._reloadTile(id, 'expired');
	                delete this._timers[id];
	            }, expiryTimeout);
	        }
	    }
	    /**
	     * Remove a tile, given its id, from the pyramid
	     */
	    _removeTile(id) {
	        const tile = this._tiles[id];
	        if (!tile)
	            return;
	        tile.uses--;
	        delete this._tiles[id];
	        if (this._timers[id]) {
	            clearTimeout(this._timers[id]);
	            delete this._timers[id];
	        }
	        if (tile.uses > 0)
	            return;
	        if (tile.hasData() && tile.state !== 'reloading') {
	            this._cache.add(tile.tileID, tile, tile.getExpiryTimeout());
	        }
	        else {
	            tile.aborted = true;
	            this._abortTile(tile);
	            this._unloadTile(tile);
	        }
	    }
	    /**
	     * Remove all tiles from this pyramid
	     */
	    clearTiles() {
	        this._shouldReloadOnResume = false;
	        this._paused = false;
	        for (const id in this._tiles)
	            this._removeTile(id);
	        this._cache.reset();
	    }
	    /**
	     * Search through our current tiles and attempt to find the tiles that
	     * cover the given bounds.
	     * @param pointQueryGeometry - coordinates of the corners of bounding rectangle
	     * @returns result items have `{tile, minX, maxX, minY, maxY}`, where min/max bounding values are the given bounds transformed in into the coordinate space of this tile.
	     */
	    tilesIn(pointQueryGeometry, maxPitchScaleFactor, has3DLayer) {
	        const tileResults = [];
	        const transform = this.transform;
	        if (!transform)
	            return tileResults;
	        const cameraPointQueryGeometry = has3DLayer ?
	            transform.getCameraQueryGeometry(pointQueryGeometry) :
	            pointQueryGeometry;
	        const queryGeometry = pointQueryGeometry.map((p) => transform.pointCoordinate(p, this.terrain));
	        const cameraQueryGeometry = cameraPointQueryGeometry.map((p) => transform.pointCoordinate(p, this.terrain));
	        const ids = this.getIds();
	        let minX = Infinity;
	        let minY = Infinity;
	        let maxX = -Infinity;
	        let maxY = -Infinity;
	        for (const p of cameraQueryGeometry) {
	            minX = Math.min(minX, p.x);
	            minY = Math.min(minY, p.y);
	            maxX = Math.max(maxX, p.x);
	            maxY = Math.max(maxY, p.y);
	        }
	        for (let i = 0; i < ids.length; i++) {
	            const tile = this._tiles[ids[i]];
	            if (tile.holdingForFade()) {
	                // Tiles held for fading are covered by tiles that are closer to ideal
	                continue;
	            }
	            const tileID = tile.tileID;
	            const scale = Math.pow(2, transform.zoom - tile.tileID.overscaledZ);
	            const queryPadding = maxPitchScaleFactor * tile.queryPadding * performance$1.EXTENT / tile.tileSize / scale;
	            const tileSpaceBounds = [
	                tileID.getTilePoint(new performance$1.MercatorCoordinate(minX, minY)),
	                tileID.getTilePoint(new performance$1.MercatorCoordinate(maxX, maxY))
	            ];
	            if (tileSpaceBounds[0].x - queryPadding < performance$1.EXTENT && tileSpaceBounds[0].y - queryPadding < performance$1.EXTENT &&
	                tileSpaceBounds[1].x + queryPadding >= 0 && tileSpaceBounds[1].y + queryPadding >= 0) {
	                const tileSpaceQueryGeometry = queryGeometry.map((c) => tileID.getTilePoint(c));
	                const tileSpaceCameraQueryGeometry = cameraQueryGeometry.map((c) => tileID.getTilePoint(c));
	                tileResults.push({
	                    tile,
	                    tileID,
	                    queryGeometry: tileSpaceQueryGeometry,
	                    cameraQueryGeometry: tileSpaceCameraQueryGeometry,
	                    scale
	                });
	            }
	        }
	        return tileResults;
	    }
	    getVisibleCoordinates(symbolLayer) {
	        const coords = this.getRenderableIds(symbolLayer).map((id) => this._tiles[id].tileID);
	        for (const coord of coords) {
	            coord.posMatrix = this.transform.calculatePosMatrix(coord.toUnwrapped());
	        }
	        return coords;
	    }
	    hasTransition() {
	        if (this._source.hasTransition()) {
	            return true;
	        }
	        if (isRasterType(this._source.type)) {
	            const now = browser.now();
	            for (const id in this._tiles) {
	                const tile = this._tiles[id];
	                if (tile.fadeEndTime >= now) {
	                    return true;
	                }
	            }
	        }
	        return false;
	    }
	    /**
	     * Set the value of a particular state for a feature
	     */
	    setFeatureState(sourceLayer, featureId, state) {
	        sourceLayer = sourceLayer || '_geojsonTileLayer';
	        this._state.updateState(sourceLayer, featureId, state);
	    }
	    /**
	     * Resets the value of a particular state key for a feature
	     */
	    removeFeatureState(sourceLayer, featureId, key) {
	        sourceLayer = sourceLayer || '_geojsonTileLayer';
	        this._state.removeFeatureState(sourceLayer, featureId, key);
	    }
	    /**
	     * Get the entire state object for a feature
	     */
	    getFeatureState(sourceLayer, featureId) {
	        sourceLayer = sourceLayer || '_geojsonTileLayer';
	        return this._state.getState(sourceLayer, featureId);
	    }
	    /**
	     * Sets the set of keys that the tile depends on. This allows tiles to
	     * be reloaded when their dependencies change.
	     */
	    setDependencies(tileKey, namespace, dependencies) {
	        const tile = this._tiles[tileKey];
	        if (tile) {
	            tile.setDependencies(namespace, dependencies);
	        }
	    }
	    /**
	     * Reloads all tiles that depend on the given keys.
	     */
	    reloadTilesForDependencies(namespaces, keys) {
	        for (const id in this._tiles) {
	            const tile = this._tiles[id];
	            if (tile.hasDependency(namespaces, keys)) {
	                this._reloadTile(id, 'reloading');
	            }
	        }
	        this._cache.filter(tile => !tile.hasDependency(namespaces, keys));
	    }
	}
	SourceCache.maxOverzooming = 10;
	SourceCache.maxUnderzooming = 3;
	function compareTileId(a, b) {
	    // Different copies of the world are sorted based on their distance to the center.
	    // Wrap values are converted to unsigned distances by reserving odd number for copies
	    // with negative wrap and even numbers for copies with positive wrap.
	    const aWrap = Math.abs(a.wrap * 2) - +(a.wrap < 0);
	    const bWrap = Math.abs(b.wrap * 2) - +(b.wrap < 0);
	    return a.overscaledZ - b.overscaledZ || bWrap - aWrap || b.canonical.y - a.canonical.y || b.canonical.x - a.canonical.x;
	}
	function isRasterType(type) {
	    return type === 'raster' || type === 'image' || type === 'video';
	}

	class PathInterpolator {
	    constructor(points_, padding_) {
	        this.reset(points_, padding_);
	    }
	    reset(points_, padding_) {
	        this.points = points_ || [];
	        // Compute cumulative distance from first point to every other point in the segment.
	        // Last entry in the array is total length of the path
	        this._distances = [0.0];
	        for (let i = 1; i < this.points.length; i++) {
	            this._distances[i] = this._distances[i - 1] + this.points[i].dist(this.points[i - 1]);
	        }
	        this.length = this._distances[this._distances.length - 1];
	        this.padding = Math.min(padding_ || 0, this.length * 0.5);
	        this.paddedLength = this.length - this.padding * 2.0;
	    }
	    lerp(t) {
	        if (this.points.length === 1) {
	            return this.points[0];
	        }
	        t = performance$1.clamp(t, 0, 1);
	        // Find the correct segment [p0, p1] where p0 <= x < p1
	        let currentIndex = 1;
	        let distOfCurrentIdx = this._distances[currentIndex];
	        const distToTarget = t * this.paddedLength + this.padding;
	        while (distOfCurrentIdx < distToTarget && currentIndex < this._distances.length) {
	            distOfCurrentIdx = this._distances[++currentIndex];
	        }
	        // Interpolate between the two points of the segment
	        const idxOfPrevPoint = currentIndex - 1;
	        const distOfPrevIdx = this._distances[idxOfPrevPoint];
	        const segmentLength = distOfCurrentIdx - distOfPrevIdx;
	        const segmentT = segmentLength > 0 ? (distToTarget - distOfPrevIdx) / segmentLength : 0;
	        return this.points[idxOfPrevPoint].mult(1.0 - segmentT).add(this.points[currentIndex].mult(segmentT));
	    }
	}

	function overlapAllowed(overlapA, overlapB) {
	    let allowed = true;
	    if (overlapA === 'always') ;
	    else if (overlapA === 'never' || overlapB === 'never') {
	        // symbol A using 'never' overlap - can't overlap anything
	        // symbol A using 'cooperative' overlap - can overlap 'always' or 'cooperative' symbol; can't overlap 'never'
	        allowed = false;
	    }
	    return allowed;
	}
	/**
	 * @internal
	 * GridIndex is a data structure for testing the intersection of
	 * circles and rectangles in a 2d plane.
	 * It is optimized for rapid insertion and querying.
	 * GridIndex splits the plane into a set of "cells" and keeps track
	 * of which geometries intersect with each cell. At query time,
	 * full geometry comparisons are only done for items that share
	 * at least one cell. As long as the geometries are relatively
	 * uniformly distributed across the plane, this greatly reduces
	 * the number of comparisons necessary.
	 */
	class GridIndex {
	    constructor(width, height, cellSize) {
	        const boxCells = this.boxCells = [];
	        const circleCells = this.circleCells = [];
	        // More cells -> fewer geometries to check per cell, but items tend
	        // to be split across more cells.
	        // Sweet spot allows most small items to fit in one cell
	        this.xCellCount = Math.ceil(width / cellSize);
	        this.yCellCount = Math.ceil(height / cellSize);
	        for (let i = 0; i < this.xCellCount * this.yCellCount; i++) {
	            boxCells.push([]);
	            circleCells.push([]);
	        }
	        this.circleKeys = [];
	        this.boxKeys = [];
	        this.bboxes = [];
	        this.circles = [];
	        this.width = width;
	        this.height = height;
	        this.xScale = this.xCellCount / width;
	        this.yScale = this.yCellCount / height;
	        this.boxUid = 0;
	        this.circleUid = 0;
	    }
	    keysLength() {
	        return this.boxKeys.length + this.circleKeys.length;
	    }
	    insert(key, x1, y1, x2, y2) {
	        this._forEachCell(x1, y1, x2, y2, this._insertBoxCell, this.boxUid++);
	        this.boxKeys.push(key);
	        this.bboxes.push(x1);
	        this.bboxes.push(y1);
	        this.bboxes.push(x2);
	        this.bboxes.push(y2);
	    }
	    insertCircle(key, x, y, radius) {
	        // Insert circle into grid for all cells in the circumscribing square
	        // It's more than necessary (by a factor of 4/PI), but fast to insert
	        this._forEachCell(x - radius, y - radius, x + radius, y + radius, this._insertCircleCell, this.circleUid++);
	        this.circleKeys.push(key);
	        this.circles.push(x);
	        this.circles.push(y);
	        this.circles.push(radius);
	    }
	    _insertBoxCell(x1, y1, x2, y2, cellIndex, uid) {
	        this.boxCells[cellIndex].push(uid);
	    }
	    _insertCircleCell(x1, y1, x2, y2, cellIndex, uid) {
	        this.circleCells[cellIndex].push(uid);
	    }
	    _query(x1, y1, x2, y2, hitTest, overlapMode, predicate) {
	        if (x2 < 0 || x1 > this.width || y2 < 0 || y1 > this.height) {
	            return [];
	        }
	        const result = [];
	        if (x1 <= 0 && y1 <= 0 && this.width <= x2 && this.height <= y2) {
	            if (hitTest) {
	                // Covers the entire grid, so collides with everything
	                return [{
	                        key: null,
	                        x1,
	                        y1,
	                        x2,
	                        y2
	                    }];
	            }
	            for (let boxUid = 0; boxUid < this.boxKeys.length; boxUid++) {
	                result.push({
	                    key: this.boxKeys[boxUid],
	                    x1: this.bboxes[boxUid * 4],
	                    y1: this.bboxes[boxUid * 4 + 1],
	                    x2: this.bboxes[boxUid * 4 + 2],
	                    y2: this.bboxes[boxUid * 4 + 3]
	                });
	            }
	            for (let circleUid = 0; circleUid < this.circleKeys.length; circleUid++) {
	                const x = this.circles[circleUid * 3];
	                const y = this.circles[circleUid * 3 + 1];
	                const radius = this.circles[circleUid * 3 + 2];
	                result.push({
	                    key: this.circleKeys[circleUid],
	                    x1: x - radius,
	                    y1: y - radius,
	                    x2: x + radius,
	                    y2: y + radius
	                });
	            }
	        }
	        else {
	            const queryArgs = {
	                hitTest,
	                overlapMode,
	                seenUids: { box: {}, circle: {} }
	            };
	            this._forEachCell(x1, y1, x2, y2, this._queryCell, result, queryArgs, predicate);
	        }
	        return result;
	    }
	    query(x1, y1, x2, y2) {
	        return this._query(x1, y1, x2, y2, false, null);
	    }
	    hitTest(x1, y1, x2, y2, overlapMode, predicate) {
	        return this._query(x1, y1, x2, y2, true, overlapMode, predicate).length > 0;
	    }
	    hitTestCircle(x, y, radius, overlapMode, predicate) {
	        // Insert circle into grid for all cells in the circumscribing square
	        // It's more than necessary (by a factor of 4/PI), but fast to insert
	        const x1 = x - radius;
	        const x2 = x + radius;
	        const y1 = y - radius;
	        const y2 = y + radius;
	        if (x2 < 0 || x1 > this.width || y2 < 0 || y1 > this.height) {
	            return false;
	        }
	        // Box query early exits if the bounding box is larger than the grid, but we don't do
	        // the equivalent calculation for circle queries because early exit is less likely
	        // and the calculation is more expensive
	        const result = [];
	        const queryArgs = {
	            hitTest: true,
	            overlapMode,
	            circle: { x, y, radius },
	            seenUids: { box: {}, circle: {} }
	        };
	        this._forEachCell(x1, y1, x2, y2, this._queryCellCircle, result, queryArgs, predicate);
	        return result.length > 0;
	    }
	    _queryCell(x1, y1, x2, y2, cellIndex, result, queryArgs, predicate) {
	        const { seenUids, hitTest, overlapMode } = queryArgs;
	        const boxCell = this.boxCells[cellIndex];
	        if (boxCell !== null) {
	            const bboxes = this.bboxes;
	            for (const boxUid of boxCell) {
	                if (!seenUids.box[boxUid]) {
	                    seenUids.box[boxUid] = true;
	                    const offset = boxUid * 4;
	                    const key = this.boxKeys[boxUid];
	                    if ((x1 <= bboxes[offset + 2]) &&
	                        (y1 <= bboxes[offset + 3]) &&
	                        (x2 >= bboxes[offset + 0]) &&
	                        (y2 >= bboxes[offset + 1]) &&
	                        (!predicate || predicate(key))) {
	                        if (!hitTest || !overlapAllowed(overlapMode, key.overlapMode)) {
	                            result.push({
	                                key,
	                                x1: bboxes[offset],
	                                y1: bboxes[offset + 1],
	                                x2: bboxes[offset + 2],
	                                y2: bboxes[offset + 3]
	                            });
	                            if (hitTest) {
	                                // true return value stops the query after first match
	                                return true;
	                            }
	                        }
	                    }
	                }
	            }
	        }
	        const circleCell = this.circleCells[cellIndex];
	        if (circleCell !== null) {
	            const circles = this.circles;
	            for (const circleUid of circleCell) {
	                if (!seenUids.circle[circleUid]) {
	                    seenUids.circle[circleUid] = true;
	                    const offset = circleUid * 3;
	                    const key = this.circleKeys[circleUid];
	                    if (this._circleAndRectCollide(circles[offset], circles[offset + 1], circles[offset + 2], x1, y1, x2, y2) &&
	                        (!predicate || predicate(key))) {
	                        if (!hitTest || !overlapAllowed(overlapMode, key.overlapMode)) {
	                            const x = circles[offset];
	                            const y = circles[offset + 1];
	                            const radius = circles[offset + 2];
	                            result.push({
	                                key,
	                                x1: x - radius,
	                                y1: y - radius,
	                                x2: x + radius,
	                                y2: y + radius
	                            });
	                            if (hitTest) {
	                                // true return value stops the query after first match
	                                return true;
	                            }
	                        }
	                    }
	                }
	            }
	        }
	        // false return to continue query
	        return false;
	    }
	    _queryCellCircle(x1, y1, x2, y2, cellIndex, result, queryArgs, predicate) {
	        const { circle, seenUids, overlapMode } = queryArgs;
	        const boxCell = this.boxCells[cellIndex];
	        if (boxCell !== null) {
	            const bboxes = this.bboxes;
	            for (const boxUid of boxCell) {
	                if (!seenUids.box[boxUid]) {
	                    seenUids.box[boxUid] = true;
	                    const offset = boxUid * 4;
	                    const key = this.boxKeys[boxUid];
	                    if (this._circleAndRectCollide(circle.x, circle.y, circle.radius, bboxes[offset + 0], bboxes[offset + 1], bboxes[offset + 2], bboxes[offset + 3]) &&
	                        (!predicate || predicate(key)) &&
	                        !overlapAllowed(overlapMode, key.overlapMode)) {
	                        result.push(true);
	                        return true;
	                    }
	                }
	            }
	        }
	        const circleCell = this.circleCells[cellIndex];
	        if (circleCell !== null) {
	            const circles = this.circles;
	            for (const circleUid of circleCell) {
	                if (!seenUids.circle[circleUid]) {
	                    seenUids.circle[circleUid] = true;
	                    const offset = circleUid * 3;
	                    const key = this.circleKeys[circleUid];
	                    if (this._circlesCollide(circles[offset], circles[offset + 1], circles[offset + 2], circle.x, circle.y, circle.radius) &&
	                        (!predicate || predicate(key)) &&
	                        !overlapAllowed(overlapMode, key.overlapMode)) {
	                        result.push(true);
	                        return true;
	                    }
	                }
	            }
	        }
	    }
	    _forEachCell(x1, y1, x2, y2, fn, arg1, arg2, predicate) {
	        const cx1 = this._convertToXCellCoord(x1);
	        const cy1 = this._convertToYCellCoord(y1);
	        const cx2 = this._convertToXCellCoord(x2);
	        const cy2 = this._convertToYCellCoord(y2);
	        for (let x = cx1; x <= cx2; x++) {
	            for (let y = cy1; y <= cy2; y++) {
	                const cellIndex = this.xCellCount * y + x;
	                if (fn.call(this, x1, y1, x2, y2, cellIndex, arg1, arg2, predicate))
	                    return;
	            }
	        }
	    }
	    _convertToXCellCoord(x) {
	        return Math.max(0, Math.min(this.xCellCount - 1, Math.floor(x * this.xScale)));
	    }
	    _convertToYCellCoord(y) {
	        return Math.max(0, Math.min(this.yCellCount - 1, Math.floor(y * this.yScale)));
	    }
	    _circlesCollide(x1, y1, r1, x2, y2, r2) {
	        const dx = x2 - x1;
	        const dy = y2 - y1;
	        const bothRadii = r1 + r2;
	        return (bothRadii * bothRadii) > (dx * dx + dy * dy);
	    }
	    _circleAndRectCollide(circleX, circleY, radius, x1, y1, x2, y2) {
	        const halfRectWidth = (x2 - x1) / 2;
	        const distX = Math.abs(circleX - (x1 + halfRectWidth));
	        if (distX > (halfRectWidth + radius)) {
	            return false;
	        }
	        const halfRectHeight = (y2 - y1) / 2;
	        const distY = Math.abs(circleY - (y1 + halfRectHeight));
	        if (distY > (halfRectHeight + radius)) {
	            return false;
	        }
	        if (distX <= halfRectWidth || distY <= halfRectHeight) {
	            return true;
	        }
	        const dx = distX - halfRectWidth;
	        const dy = distY - halfRectHeight;
	        return (dx * dx + dy * dy <= (radius * radius));
	    }
	}

	/*
	 * # Overview of coordinate spaces
	 *
	 * ## Tile coordinate spaces
	 * Each label has an anchor. Some labels have corresponding line geometries.
	 * The points for both anchors and lines are stored in tile units. Each tile has it's own
	 * coordinate space going from (0, 0) at the top left to (EXTENT, EXTENT) at the bottom right.
	 *
	 * ## Clip space (GL coordinate space)
	 * At the end of everything, the vertex shader needs to produce a position in clip space,
	 * which is (-1, 1) at the top left and (1, -1) in the bottom right.
	 * In the depth buffer, values are between 0 (near plane) to 1 (far plane).
	 *
	 * ## Map pixel coordinate spaces
	 * Each tile has a pixel coordinate space. It's just the tile units scaled so that one unit is
	 * whatever counts as 1 pixel at the current zoom.
	 * This space is used for pitch-alignment=map, rotation-alignment=map
	 *
	 * ## Rotated map pixel coordinate spaces
	 * Like the above, but rotated so axis of the space are aligned with the viewport instead of the tile.
	 * This space is used for pitch-alignment=map, rotation-alignment=viewport
	 *
	 * ## Viewport pixel coordinate space
	 * (0, 0) is at the top left of the canvas and (pixelWidth, pixelHeight) is at the bottom right corner
	 * of the canvas. This space is used for pitch-alignment=viewport
	 *
	 *
	 * # Vertex projection
	 * It goes roughly like this:
	 * 1. project the anchor and line from tile units into the correct label coordinate space
	 *      - map pixel space           pitch-alignment=map         rotation-alignment=map
	 *      - rotated map pixel space   pitch-alignment=map         rotation-alignment=viewport
	 *      - viewport pixel space      pitch-alignment=viewport    rotation-alignment=*
	 * 2. if the label follows a line, find the point along the line that is the correct distance from the anchor.
	 * 3. add the glyph's corner offset to the point from step 3
	 * 4. convert from the label coordinate space to clip space
	 *
	 * For horizontal labels we want to do step 1 in the shader for performance reasons (no cpu work).
	 *      This is what `u_label_plane_matrix` is used for.
	 * For labels aligned with lines we have to steps 1 and 2 on the cpu since we need access to the line geometry.
	 *      This is what `updateLineLabels(...)` does.
	 *      Since the conversion is handled on the cpu we just set `u_label_plane_matrix` to an identity matrix.
	 *
	 * Steps 3 and 4 are done in the shaders for all labels.
	 */
	/*
	 * Returns a matrix for converting from tile units to the correct label coordinate space.
	 */
	function getLabelPlaneMatrix(posMatrix, pitchWithMap, rotateWithMap, transform, pixelsToTileUnits) {
	    const m = performance$1.create();
	    if (pitchWithMap) {
	        performance$1.scale(m, m, [1 / pixelsToTileUnits, 1 / pixelsToTileUnits, 1]);
	        if (!rotateWithMap) {
	            performance$1.rotateZ(m, m, transform.angle);
	        }
	    }
	    else {
	        performance$1.multiply(m, transform.labelPlaneMatrix, posMatrix);
	    }
	    return m;
	}
	/*
	 * Returns a matrix for converting from the correct label coordinate space to clip space.
	 */
	function getGlCoordMatrix(posMatrix, pitchWithMap, rotateWithMap, transform, pixelsToTileUnits) {
	    if (pitchWithMap) {
	        const m = performance$1.clone(posMatrix);
	        performance$1.scale(m, m, [pixelsToTileUnits, pixelsToTileUnits, 1]);
	        if (!rotateWithMap) {
	            performance$1.rotateZ(m, m, -transform.angle);
	        }
	        return m;
	    }
	    else {
	        return transform.glCoordMatrix;
	    }
	}
	function project(point, matrix, getElevation) {
	    let pos;
	    if (getElevation) { // slow because of handle z-index
	        pos = [point.x, point.y, getElevation(point.x, point.y), 1];
	        performance$1.transformMat4(pos, pos, matrix);
	    }
	    else { // fast because of ignore z-index
	        pos = [point.x, point.y, 0, 1];
	        xyTransformMat4(pos, pos, matrix);
	    }
	    const w = pos[3];
	    return {
	        point: new performance$1.Point(pos[0] / w, pos[1] / w),
	        signedDistanceFromCamera: w
	    };
	}
	function getPerspectiveRatio(cameraToCenterDistance, signedDistanceFromCamera) {
	    return 0.5 + 0.5 * (cameraToCenterDistance / signedDistanceFromCamera);
	}
	function isVisible(anchorPos, clippingBuffer) {
	    const x = anchorPos[0] / anchorPos[3];
	    const y = anchorPos[1] / anchorPos[3];
	    const inPaddedViewport = (x >= -clippingBuffer[0] &&
	        x <= clippingBuffer[0] &&
	        y >= -clippingBuffer[1] &&
	        y <= clippingBuffer[1]);
	    return inPaddedViewport;
	}
	/*
	 *  Update the `dynamicLayoutVertexBuffer` for the buffer with the correct glyph positions for the current map view.
	 *  This is only run on labels that are aligned with lines. Horizontal labels are handled entirely in the shader.
	 */
	function updateLineLabels(bucket, posMatrix, painter, isText, labelPlaneMatrix, glCoordMatrix, pitchWithMap, keepUpright, rotateToLine, getElevation) {
	    const sizeData = isText ? bucket.textSizeData : bucket.iconSizeData;
	    const partiallyEvaluatedSize = performance$1.evaluateSizeForZoom(sizeData, painter.transform.zoom);
	    const clippingBuffer = [256 / painter.width * 2 + 1, 256 / painter.height * 2 + 1];
	    const dynamicLayoutVertexArray = isText ?
	        bucket.text.dynamicLayoutVertexArray :
	        bucket.icon.dynamicLayoutVertexArray;
	    dynamicLayoutVertexArray.clear();
	    const lineVertexArray = bucket.lineVertexArray;
	    const placedSymbols = isText ? bucket.text.placedSymbolArray : bucket.icon.placedSymbolArray;
	    const aspectRatio = painter.transform.width / painter.transform.height;
	    let useVertical = false;
	    for (let s = 0; s < placedSymbols.length; s++) {
	        const symbol = placedSymbols.get(s);
	        // Don't do calculations for vertical glyphs unless the previous symbol was horizontal
	        // and we determined that vertical glyphs were necessary.
	        // Also don't do calculations for symbols that are collided and fully faded out
	        if (symbol.hidden || symbol.writingMode === performance$1.WritingMode.vertical && !useVertical) {
	            hideGlyphs(symbol.numGlyphs, dynamicLayoutVertexArray);
	            continue;
	        }
	        // Awkward... but we're counting on the paired "vertical" symbol coming immediately after its horizontal counterpart
	        useVertical = false;
	        let anchorPos;
	        if (getElevation) { // slow because of handle z-index
	            anchorPos = [symbol.anchorX, symbol.anchorY, getElevation(symbol.anchorX, symbol.anchorY), 1];
	            performance$1.transformMat4(anchorPos, anchorPos, posMatrix);
	        }
	        else { // fast because of ignore z-index
	            anchorPos = [symbol.anchorX, symbol.anchorY, 0, 1];
	            xyTransformMat4(anchorPos, anchorPos, posMatrix);
	        }
	        // Don't bother calculating the correct point for invisible labels.
	        if (!isVisible(anchorPos, clippingBuffer)) {
	            hideGlyphs(symbol.numGlyphs, dynamicLayoutVertexArray);
	            continue;
	        }
	        const cameraToAnchorDistance = anchorPos[3];
	        const perspectiveRatio = getPerspectiveRatio(painter.transform.cameraToCenterDistance, cameraToAnchorDistance);
	        const fontSize = performance$1.evaluateSizeForFeature(sizeData, partiallyEvaluatedSize, symbol);
	        const pitchScaledFontSize = pitchWithMap ? fontSize / perspectiveRatio : fontSize * perspectiveRatio;
	        const tileAnchorPoint = new performance$1.Point(symbol.anchorX, symbol.anchorY);
	        const anchorPoint = project(tileAnchorPoint, labelPlaneMatrix, getElevation).point;
	        const projectionCache = { projections: {}, offsets: {} };
	        const placeUnflipped = placeGlyphsAlongLine(symbol, pitchScaledFontSize, false /*unflipped*/, keepUpright, posMatrix, labelPlaneMatrix, glCoordMatrix, bucket.glyphOffsetArray, lineVertexArray, dynamicLayoutVertexArray, anchorPoint, tileAnchorPoint, projectionCache, aspectRatio, rotateToLine, getElevation);
	        useVertical = placeUnflipped.useVertical;
	        if (placeUnflipped.notEnoughRoom || useVertical ||
	            (placeUnflipped.needsFlipping &&
	                placeGlyphsAlongLine(symbol, pitchScaledFontSize, true /*flipped*/, keepUpright, posMatrix, labelPlaneMatrix, glCoordMatrix, bucket.glyphOffsetArray, lineVertexArray, dynamicLayoutVertexArray, anchorPoint, tileAnchorPoint, projectionCache, aspectRatio, rotateToLine, getElevation).notEnoughRoom)) {
	            hideGlyphs(symbol.numGlyphs, dynamicLayoutVertexArray);
	        }
	    }
	    if (isText) {
	        bucket.text.dynamicLayoutVertexBuffer.updateData(dynamicLayoutVertexArray);
	    }
	    else {
	        bucket.icon.dynamicLayoutVertexBuffer.updateData(dynamicLayoutVertexArray);
	    }
	}
	/*
	 * Place the first and last glyph of a line label, projected to the label plane.
	 * This function is called both during collision detection (to determine the label's size)
	 * and during line label rendering (to make sure the label fits on the line geometry with
	 * the current camera position, which may differ from the position used during collision detection).
	 *
	 * Calling this function has the effect of populating the "projectionCache" with all projected
	 * vertex locations the label will need, making future calls to placeGlyphAlongLine (for all the
	 * intermediate glyphs) much cheaper.
	 *
	 * Returns null if the label can't fit on the geometry
	 */
	function placeFirstAndLastGlyph(fontScale, glyphOffsetArray, lineOffsetX, lineOffsetY, flip, anchorPoint, tileAnchorPoint, symbol, lineVertexArray, labelPlaneMatrix, projectionCache, rotateToLine, getElevation) {
	    const glyphEndIndex = symbol.glyphStartIndex + symbol.numGlyphs;
	    const lineStartIndex = symbol.lineStartIndex;
	    const lineEndIndex = symbol.lineStartIndex + symbol.lineLength;
	    const firstGlyphOffset = glyphOffsetArray.getoffsetX(symbol.glyphStartIndex);
	    const lastGlyphOffset = glyphOffsetArray.getoffsetX(glyphEndIndex - 1);
	    const firstPlacedGlyph = placeGlyphAlongLine(fontScale * firstGlyphOffset, lineOffsetX, lineOffsetY, flip, anchorPoint, tileAnchorPoint, symbol.segment, lineStartIndex, lineEndIndex, lineVertexArray, labelPlaneMatrix, projectionCache, rotateToLine, getElevation);
	    if (!firstPlacedGlyph)
	        return null;
	    const lastPlacedGlyph = placeGlyphAlongLine(fontScale * lastGlyphOffset, lineOffsetX, lineOffsetY, flip, anchorPoint, tileAnchorPoint, symbol.segment, lineStartIndex, lineEndIndex, lineVertexArray, labelPlaneMatrix, projectionCache, rotateToLine, getElevation);
	    if (!lastPlacedGlyph)
	        return null;
	    return { first: firstPlacedGlyph, last: lastPlacedGlyph };
	}
	function requiresOrientationChange(writingMode, firstPoint, lastPoint, aspectRatio) {
	    if (writingMode === performance$1.WritingMode.horizontal) {
	        // On top of choosing whether to flip, choose whether to render this version of the glyphs or the alternate
	        // vertical glyphs. We can't just filter out vertical glyphs in the horizontal range because the horizontal
	        // and vertical versions can have slightly different projections which could lead to angles where both or
	        // neither showed.
	        const rise = Math.abs(lastPoint.y - firstPoint.y);
	        const run = Math.abs(lastPoint.x - firstPoint.x) * aspectRatio;
	        if (rise > run) {
	            return { useVertical: true };
	        }
	    }
	    if (writingMode === performance$1.WritingMode.vertical ? firstPoint.y < lastPoint.y : firstPoint.x > lastPoint.x) {
	        // Includes "horizontalOnly" case for labels without vertical glyphs
	        return { needsFlipping: true };
	    }
	    return null;
	}
	/*
	* Place first and last glyph along the line projected to label plane, and if they fit
	* iterate through all the intermediate glyphs, calculating their label plane positions
	* from the projected line.
	*
	* Finally, add resulting glyph position calculations to dynamicLayoutVertexArray for
	* upload to the GPU
	*/
	function placeGlyphsAlongLine(symbol, fontSize, flip, keepUpright, posMatrix, labelPlaneMatrix, glCoordMatrix, glyphOffsetArray, lineVertexArray, dynamicLayoutVertexArray, anchorPoint, tileAnchorPoint, projectionCache, aspectRatio, rotateToLine, getElevation) {
	    const fontScale = fontSize / 24;
	    const lineOffsetX = symbol.lineOffsetX * fontScale;
	    const lineOffsetY = symbol.lineOffsetY * fontScale;
	    let placedGlyphs;
	    if (symbol.numGlyphs > 1) {
	        const glyphEndIndex = symbol.glyphStartIndex + symbol.numGlyphs;
	        const lineStartIndex = symbol.lineStartIndex;
	        const lineEndIndex = symbol.lineStartIndex + symbol.lineLength;
	        // Place the first and the last glyph in the label first, so we can figure out
	        // the overall orientation of the label and determine whether it needs to be flipped in keepUpright mode
	        const firstAndLastGlyph = placeFirstAndLastGlyph(fontScale, glyphOffsetArray, lineOffsetX, lineOffsetY, flip, anchorPoint, tileAnchorPoint, symbol, lineVertexArray, labelPlaneMatrix, projectionCache, rotateToLine, getElevation);
	        if (!firstAndLastGlyph) {
	            return { notEnoughRoom: true };
	        }
	        const firstPoint = project(firstAndLastGlyph.first.point, glCoordMatrix, getElevation).point;
	        const lastPoint = project(firstAndLastGlyph.last.point, glCoordMatrix, getElevation).point;
	        if (keepUpright && !flip) {
	            const orientationChange = requiresOrientationChange(symbol.writingMode, firstPoint, lastPoint, aspectRatio);
	            if (orientationChange) {
	                return orientationChange;
	            }
	        }
	        placedGlyphs = [firstAndLastGlyph.first];
	        for (let glyphIndex = symbol.glyphStartIndex + 1; glyphIndex < glyphEndIndex - 1; glyphIndex++) {
	            // Since first and last glyph fit on the line, we're sure that the rest of the glyphs can be placed
	            placedGlyphs.push(placeGlyphAlongLine(fontScale * glyphOffsetArray.getoffsetX(glyphIndex), lineOffsetX, lineOffsetY, flip, anchorPoint, tileAnchorPoint, symbol.segment, lineStartIndex, lineEndIndex, lineVertexArray, labelPlaneMatrix, projectionCache, rotateToLine, getElevation));
	        }
	        placedGlyphs.push(firstAndLastGlyph.last);
	    }
	    else {
	        // Only a single glyph to place
	        // So, determine whether to flip based on projected angle of the line segment it's on
	        if (keepUpright && !flip) {
	            const a = project(tileAnchorPoint, posMatrix, getElevation).point;
	            const tileVertexIndex = (symbol.lineStartIndex + symbol.segment + 1);
	            const tileSegmentEnd = new performance$1.Point(lineVertexArray.getx(tileVertexIndex), lineVertexArray.gety(tileVertexIndex));
	            const projectedVertex = project(tileSegmentEnd, posMatrix, getElevation);
	            // We know the anchor will be in the viewport, but the end of the line segment may be
	            // behind the plane of the camera, in which case we can use a point at any arbitrary (closer)
	            // point on the segment.
	            const b = (projectedVertex.signedDistanceFromCamera > 0) ?
	                projectedVertex.point :
	                projectTruncatedLineSegment(tileAnchorPoint, tileSegmentEnd, a, 1, posMatrix, getElevation);
	            const orientationChange = requiresOrientationChange(symbol.writingMode, a, b, aspectRatio);
	            if (orientationChange) {
	                return orientationChange;
	            }
	        }
	        const singleGlyph = placeGlyphAlongLine(fontScale * glyphOffsetArray.getoffsetX(symbol.glyphStartIndex), lineOffsetX, lineOffsetY, flip, anchorPoint, tileAnchorPoint, symbol.segment, symbol.lineStartIndex, symbol.lineStartIndex + symbol.lineLength, lineVertexArray, labelPlaneMatrix, projectionCache, rotateToLine, getElevation);
	        if (!singleGlyph)
	            return { notEnoughRoom: true };
	        placedGlyphs = [singleGlyph];
	    }
	    for (const glyph of placedGlyphs) {
	        performance$1.addDynamicAttributes(dynamicLayoutVertexArray, glyph.point, glyph.angle);
	    }
	    return {};
	}
	function projectTruncatedLineSegment(previousTilePoint, currentTilePoint, previousProjectedPoint, minimumLength, projectionMatrix, getElevation) {
	    // We are assuming "previousTilePoint" won't project to a point within one unit of the camera plane
	    // If it did, that would mean our label extended all the way out from within the viewport to a (very distant)
	    // point near the plane of the camera. We wouldn't be able to render the label anyway once it crossed the
	    // plane of the camera.
	    const projectedUnitVertex = project(previousTilePoint.add(previousTilePoint.sub(currentTilePoint)._unit()), projectionMatrix, getElevation).point;
	    const projectedUnitSegment = previousProjectedPoint.sub(projectedUnitVertex);
	    return previousProjectedPoint.add(projectedUnitSegment._mult(minimumLength / projectedUnitSegment.mag()));
	}
	/**
	 * Transform a vertex from tile coordinates to label plane coordinates
	 * @param index - index of vertex to project
	 * @param projectionArgs - necessary data to project a vertex
	 * @returns the vertex projected to the label plane
	 */
	function projectVertexToViewport(index, projectionArgs) {
	    const { projectionCache, lineVertexArray, labelPlaneMatrix, tileAnchorPoint, distanceFromAnchor, getElevation, previousVertex, direction, absOffsetX } = projectionArgs;
	    if (projectionCache.projections[index]) {
	        return projectionCache.projections[index];
	    }
	    const currentVertex = new performance$1.Point(lineVertexArray.getx(index), lineVertexArray.gety(index));
	    const projection = project(currentVertex, labelPlaneMatrix, getElevation);
	    if (projection.signedDistanceFromCamera > 0) {
	        projectionCache.projections[index] = projection.point;
	        return projection.point;
	    }
	    // The vertex is behind the plane of the camera, so we can't project it
	    // Instead, we'll create a vertex along the line that's far enough to include the glyph
	    const previousLineVertexIndex = index - direction;
	    const previousTilePoint = distanceFromAnchor === 0 ?
	        tileAnchorPoint :
	        new performance$1.Point(lineVertexArray.getx(previousLineVertexIndex), lineVertexArray.gety(previousLineVertexIndex));
	    // Don't cache because the new vertex might not be far enough out for future glyphs on the same segment
	    return projectTruncatedLineSegment(previousTilePoint, currentVertex, previousVertex, absOffsetX - distanceFromAnchor + 1, labelPlaneMatrix, getElevation);
	}
	/**
	 * Calculate the normal vector for a line segment
	 * @param segmentVector - will be mutated as a tiny optimization
	 * @param offset - magnitude of resulting vector
	 * @param direction - direction of line traversal
	 * @returns a normal vector from the segment, with magnitude equal to offset amount
	 */
	function transformToOffsetNormal(segmentVector, offset, direction) {
	    return segmentVector._unit()._perp()._mult(offset * direction);
	}
	/**
	 * Construct offset line segments for the current segment and the next segment, then extend/shrink
	 * the segments until they intersect. If the segments are parallel, then they will touch with no modification.
	 *
	 * @param index - Index of the current vertex
	 * @param prevToCurrentOffsetNormal - Normal vector of the line segment from the previous vertex to the current vertex
	 * @param currentVertex - Current (non-offset) vertex projected to the label plane
	 * @param lineStartIndex - Beginning index for the line this label is on
	 * @param lineEndIndex - End index for the line this label is on
	 * @param offsetPreviousVertex - The previous vertex projected to the label plane, and then offset along the previous segments normal
	 * @param lineOffsetY - Magnitude of the offset
	 * @param projectionArgs - Necessary data for tile-to-label-plane projection
	 * @returns The point at which the current and next line segments intersect, once offset and extended/shrunk to their meeting point
	 */
	function findOffsetIntersectionPoint(index, prevToCurrentOffsetNormal, currentVertex, lineStartIndex, lineEndIndex, offsetPreviousVertex, lineOffsetY, projectionArgs) {
	    const { projectionCache, direction } = projectionArgs;
	    if (projectionCache.offsets[index]) {
	        return projectionCache.offsets[index];
	    }
	    const offsetCurrentVertex = currentVertex.add(prevToCurrentOffsetNormal);
	    if (index + direction < lineStartIndex || index + direction >= lineEndIndex) {
	        // This is the end of the line, no intersection to calculate
	        projectionCache.offsets[index] = offsetCurrentVertex;
	        return offsetCurrentVertex;
	    }
	    // Offset the vertices for the next segment
	    const nextVertex = projectVertexToViewport(index + direction, projectionArgs);
	    const currentToNextOffsetNormal = transformToOffsetNormal(nextVertex.sub(currentVertex), lineOffsetY, direction);
	    const offsetNextSegmentBegin = currentVertex.add(currentToNextOffsetNormal);
	    const offsetNextSegmentEnd = nextVertex.add(currentToNextOffsetNormal);
	    // find the intersection of these two lines
	    // if the lines are parallel, offsetCurrent/offsetNextBegin will touch
	    projectionCache.offsets[index] = performance$1.findLineIntersection(offsetPreviousVertex, offsetCurrentVertex, offsetNextSegmentBegin, offsetNextSegmentEnd) || offsetCurrentVertex;
	    return projectionCache.offsets[index];
	}
	/*
	 * Place a single glyph along its line, projected into the label plane, by iterating outward
	 * from the anchor point until the distance traversed in the label plane equals the glyph's
	 * offsetX. Returns null if the glyph can't fit on the line geometry.
	 */
	function placeGlyphAlongLine(offsetX, lineOffsetX, lineOffsetY, flip, anchorPoint, tileAnchorPoint, anchorSegment, lineStartIndex, lineEndIndex, lineVertexArray, labelPlaneMatrix, projectionCache, rotateToLine, getElevation) {
	    const combinedOffsetX = flip ?
	        offsetX - lineOffsetX :
	        offsetX + lineOffsetX;
	    let direction = combinedOffsetX > 0 ? 1 : -1;
	    let angle = 0;
	    if (flip) {
	        // The label needs to be flipped to keep text upright.
	        // Iterate in the reverse direction.
	        direction *= -1;
	        angle = Math.PI;
	    }
	    if (direction < 0)
	        angle += Math.PI;
	    let currentIndex = direction > 0 ?
	        lineStartIndex + anchorSegment :
	        lineStartIndex + anchorSegment + 1;
	    let currentVertex = anchorPoint;
	    let previousVertex = anchorPoint;
	    // offsetPrev and intersectionPoint are analogous to previousVertex and currentVertex
	    // but if there's a line offset they are calculated in parallel as projection happens
	    let offsetIntersectionPoint;
	    let offsetPreviousVertex;
	    let distanceFromAnchor = 0;
	    let currentSegmentDistance = 0;
	    const absOffsetX = Math.abs(combinedOffsetX);
	    const pathVertices = [];
	    let currentLineSegment;
	    while (distanceFromAnchor + currentSegmentDistance <= absOffsetX) {
	        currentIndex += direction;
	        // offset does not fit on the projected line
	        if (currentIndex < lineStartIndex || currentIndex >= lineEndIndex)
	            return null;
	        // accumulate values from last iteration
	        distanceFromAnchor += currentSegmentDistance;
	        previousVertex = currentVertex;
	        offsetPreviousVertex = offsetIntersectionPoint;
	        const projectionArgs = {
	            projectionCache,
	            lineVertexArray,
	            labelPlaneMatrix,
	            tileAnchorPoint,
	            distanceFromAnchor,
	            getElevation,
	            previousVertex,
	            direction,
	            absOffsetX
	        };
	        // find next vertex in viewport space
	        currentVertex = projectVertexToViewport(currentIndex, projectionArgs);
	        if (lineOffsetY === 0) {
	            // Store vertices for collision detection and update current segment geometry
	            pathVertices.push(previousVertex);
	            currentLineSegment = currentVertex.sub(previousVertex);
	        }
	        else {
	            // Calculate the offset for this section
	            let prevToCurrentOffsetNormal;
	            const prevToCurrent = currentVertex.sub(previousVertex);
	            if (prevToCurrent.mag() === 0) {
	                // We are starting with our anchor point directly on the vertex, so look one vertex ahead
	                // to calculate a normal
	                const nextVertex = projectVertexToViewport(currentIndex + direction, projectionArgs);
	                prevToCurrentOffsetNormal = transformToOffsetNormal(nextVertex.sub(currentVertex), lineOffsetY, direction);
	            }
	            else {
	                prevToCurrentOffsetNormal = transformToOffsetNormal(prevToCurrent, lineOffsetY, direction);
	            }
	            // Initialize offsetPrev on our first iteration, after that it will be pre-calculated
	            if (!offsetPreviousVertex)
	                offsetPreviousVertex = previousVertex.add(prevToCurrentOffsetNormal);
	            offsetIntersectionPoint = findOffsetIntersectionPoint(currentIndex, prevToCurrentOffsetNormal, currentVertex, lineStartIndex, lineEndIndex, offsetPreviousVertex, lineOffsetY, projectionArgs);
	            pathVertices.push(offsetPreviousVertex);
	            currentLineSegment = offsetIntersectionPoint.sub(offsetPreviousVertex);
	        }
	        currentSegmentDistance = currentLineSegment.mag();
	    }
	    // The point is on the current segment. Interpolate to find it.
	    const segmentInterpolationT = (absOffsetX - distanceFromAnchor) / currentSegmentDistance;
	    const p = currentLineSegment._mult(segmentInterpolationT)._add(offsetPreviousVertex || previousVertex);
	    const segmentAngle = angle + Math.atan2(currentVertex.y - previousVertex.y, currentVertex.x - previousVertex.x);
	    pathVertices.push(p);
	    return {
	        point: p,
	        angle: rotateToLine ? segmentAngle : 0.0,
	        path: pathVertices
	    };
	}
	const hiddenGlyphAttributes = new Float32Array([-Infinity, -Infinity, 0, -Infinity, -Infinity, 0, -Infinity, -Infinity, 0, -Infinity, -Infinity, 0]);
	// Hide them by moving them offscreen. We still need to add them to the buffer
	// because the dynamic buffer is paired with a static buffer that doesn't get updated.
	function hideGlyphs(num, dynamicLayoutVertexArray) {
	    for (let i = 0; i < num; i++) {
	        const offset = dynamicLayoutVertexArray.length;
	        dynamicLayoutVertexArray.resize(offset + 4);
	        // Since all hidden glyphs have the same attributes, we can build up the array faster with a single call to Float32Array.set
	        // for each set of four vertices, instead of calling addDynamicAttributes for each vertex.
	        dynamicLayoutVertexArray.float32.set(hiddenGlyphAttributes, offset * 3);
	    }
	}
	// For line label layout, we're not using z output and our w input is always 1
	// This custom matrix transformation ignores those components to make projection faster
	function xyTransformMat4(out, a, m) {
	    const x = a[0], y = a[1];
	    out[0] = m[0] * x + m[4] * y + m[12];
	    out[1] = m[1] * x + m[5] * y + m[13];
	    out[3] = m[3] * x + m[7] * y + m[15];
	    return out;
	}

	// When a symbol crosses the edge that causes it to be included in
	// collision detection, it will cause changes in the symbols around
	// it. This constant specifies how many pixels to pad the edge of
	// the viewport for collision detection so that the bulk of the changes
	// occur offscreen. Making this constant greater increases label
	// stability, but it's expensive.
	const viewportPadding = 100;
	/**
	 * @internal
	 * A collision index used to prevent symbols from overlapping. It keep tracks of
	 * where previous symbols have been placed and is used to check if a new
	 * symbol overlaps with any previously added symbols.
	 *
	 * There are two steps to insertion: first placeCollisionBox/Circles checks if
	 * there's room for a symbol, then insertCollisionBox/Circles actually puts the
	 * symbol in the index. The two step process allows paired symbols to be inserted
	 * together even if they overlap.
	 */
	class CollisionIndex {
	    constructor(transform, grid = new GridIndex(transform.width + 2 * viewportPadding, transform.height + 2 * viewportPadding, 25), ignoredGrid = new GridIndex(transform.width + 2 * viewportPadding, transform.height + 2 * viewportPadding, 25)) {
	        this.transform = transform;
	        this.grid = grid;
	        this.ignoredGrid = ignoredGrid;
	        this.pitchfactor = Math.cos(transform._pitch) * transform.cameraToCenterDistance;
	        this.screenRightBoundary = transform.width + viewportPadding;
	        this.screenBottomBoundary = transform.height + viewportPadding;
	        this.gridRightBoundary = transform.width + 2 * viewportPadding;
	        this.gridBottomBoundary = transform.height + 2 * viewportPadding;
	        this.perspectiveRatioCutoff = 0.6;
	    }
	    placeCollisionBox(collisionBox, overlapMode, textPixelRatio, posMatrix, collisionGroupPredicate, getElevation) {
	        const projectedPoint = this.projectAndGetPerspectiveRatio(posMatrix, collisionBox.anchorPointX, collisionBox.anchorPointY, getElevation);
	        const tileToViewport = textPixelRatio * projectedPoint.perspectiveRatio;
	        const tlX = collisionBox.x1 * tileToViewport + projectedPoint.point.x;
	        const tlY = collisionBox.y1 * tileToViewport + projectedPoint.point.y;
	        const brX = collisionBox.x2 * tileToViewport + projectedPoint.point.x;
	        const brY = collisionBox.y2 * tileToViewport + projectedPoint.point.y;
	        if (!this.isInsideGrid(tlX, tlY, brX, brY) ||
	            (overlapMode !== 'always' && this.grid.hitTest(tlX, tlY, brX, brY, overlapMode, collisionGroupPredicate)) ||
	            projectedPoint.perspectiveRatio < this.perspectiveRatioCutoff) {
	            return {
	                box: [],
	                offscreen: false
	            };
	        }
	        return {
	            box: [tlX, tlY, brX, brY],
	            offscreen: this.isOffscreen(tlX, tlY, brX, brY)
	        };
	    }
	    placeCollisionCircles(overlapMode, symbol, lineVertexArray, glyphOffsetArray, fontSize, posMatrix, labelPlaneMatrix, labelToScreenMatrix, showCollisionCircles, pitchWithMap, collisionGroupPredicate, circlePixelDiameter, textPixelPadding, getElevation) {
	        const placedCollisionCircles = [];
	        const tileUnitAnchorPoint = new performance$1.Point(symbol.anchorX, symbol.anchorY);
	        const screenAnchorPoint = project(tileUnitAnchorPoint, posMatrix, getElevation);
	        const perspectiveRatio = getPerspectiveRatio(this.transform.cameraToCenterDistance, screenAnchorPoint.signedDistanceFromCamera);
	        const labelPlaneFontSize = pitchWithMap ? fontSize / perspectiveRatio : fontSize * perspectiveRatio;
	        const labelPlaneFontScale = labelPlaneFontSize / performance$1.ONE_EM;
	        const labelPlaneAnchorPoint = project(tileUnitAnchorPoint, labelPlaneMatrix, getElevation).point;
	        const projectionCache = { projections: {}, offsets: {} };
	        const lineOffsetX = symbol.lineOffsetX * labelPlaneFontScale;
	        const lineOffsetY = symbol.lineOffsetY * labelPlaneFontScale;
	        const firstAndLastGlyph = placeFirstAndLastGlyph(labelPlaneFontScale, glyphOffsetArray, lineOffsetX, lineOffsetY, 
	        /*flip*/ false, labelPlaneAnchorPoint, tileUnitAnchorPoint, symbol, lineVertexArray, labelPlaneMatrix, projectionCache, false, getElevation);
	        let collisionDetected = false;
	        let inGrid = false;
	        let entirelyOffscreen = true;
	        if (firstAndLastGlyph) {
	            const radius = circlePixelDiameter * 0.5 * perspectiveRatio + textPixelPadding;
	            const screenPlaneMin = new performance$1.Point(-viewportPadding, -viewportPadding);
	            const screenPlaneMax = new performance$1.Point(this.screenRightBoundary, this.screenBottomBoundary);
	            const interpolator = new PathInterpolator();
	            // Construct a projected path from projected line vertices. Anchor points are ignored and removed
	            const first = firstAndLastGlyph.first;
	            const last = firstAndLastGlyph.last;
	            let projectedPath = [];
	            for (let i = first.path.length - 1; i >= 1; i--) {
	                projectedPath.push(first.path[i]);
	            }
	            for (let i = 1; i < last.path.length; i++) {
	                projectedPath.push(last.path[i]);
	            }
	            // Tolerate a slightly longer distance than one diameter between two adjacent circles
	            const circleDist = radius * 2.5;
	            // The path might need to be converted into screen space if a pitched map is used as the label space
	            if (labelToScreenMatrix) {
	                const screenSpacePath = projectedPath.map(p => project(p, labelToScreenMatrix, getElevation));
	                // Do not try to place collision circles if even of the points is behind the camera.
	                // This is a plausible scenario with big camera pitch angles
	                if (screenSpacePath.some(point => point.signedDistanceFromCamera <= 0)) {
	                    projectedPath = [];
	                }
	                else {
	                    projectedPath = screenSpacePath.map(p => p.point);
	                }
	            }
	            let segments = [];
	            if (projectedPath.length > 0) {
	                // Quickly check if the path is fully inside or outside of the padded collision region.
	                // For overlapping paths we'll only create collision circles for the visible segments
	                const minPoint = projectedPath[0].clone();
	                const maxPoint = projectedPath[0].clone();
	                for (let i = 1; i < projectedPath.length; i++) {
	                    minPoint.x = Math.min(minPoint.x, projectedPath[i].x);
	                    minPoint.y = Math.min(minPoint.y, projectedPath[i].y);
	                    maxPoint.x = Math.max(maxPoint.x, projectedPath[i].x);
	                    maxPoint.y = Math.max(maxPoint.y, projectedPath[i].y);
	                }
	                if (minPoint.x >= screenPlaneMin.x && maxPoint.x <= screenPlaneMax.x &&
	                    minPoint.y >= screenPlaneMin.y && maxPoint.y <= screenPlaneMax.y) {
	                    // Quad fully visible
	                    segments = [projectedPath];
	                }
	                else if (maxPoint.x < screenPlaneMin.x || minPoint.x > screenPlaneMax.x ||
	                    maxPoint.y < screenPlaneMin.y || minPoint.y > screenPlaneMax.y) {
	                    // Not visible
	                    segments = [];
	                }
	                else {
	                    segments = performance$1.clipLine([projectedPath], screenPlaneMin.x, screenPlaneMin.y, screenPlaneMax.x, screenPlaneMax.y);
	                }
	            }
	            for (const seg of segments) {
	                // interpolate positions for collision circles. Add a small padding to both ends of the segment
	                interpolator.reset(seg, radius * 0.25);
	                let numCircles = 0;
	                if (interpolator.length <= 0.5 * radius) {
	                    numCircles = 1;
	                }
	                else {
	                    numCircles = Math.ceil(interpolator.paddedLength / circleDist) + 1;
	                }
	                for (let i = 0; i < numCircles; i++) {
	                    const t = i / Math.max(numCircles - 1, 1);
	                    const circlePosition = interpolator.lerp(t);
	                    // add viewport padding to the position and perform initial collision check
	                    const centerX = circlePosition.x + viewportPadding;
	                    const centerY = circlePosition.y + viewportPadding;
	                    placedCollisionCircles.push(centerX, centerY, radius, 0);
	                    const x1 = centerX - radius;
	                    const y1 = centerY - radius;
	                    const x2 = centerX + radius;
	                    const y2 = centerY + radius;
	                    entirelyOffscreen = entirelyOffscreen && this.isOffscreen(x1, y1, x2, y2);
	                    inGrid = inGrid || this.isInsideGrid(x1, y1, x2, y2);
	                    if (overlapMode !== 'always' && this.grid.hitTestCircle(centerX, centerY, radius, overlapMode, collisionGroupPredicate)) {
	                        // Don't early exit if we're showing the debug circles because we still want to calculate
	                        // which circles are in use
	                        collisionDetected = true;
	                        if (!showCollisionCircles) {
	                            return {
	                                circles: [],
	                                offscreen: false,
	                                collisionDetected
	                            };
	                        }
	                    }
	                }
	            }
	        }
	        return {
	            circles: ((!showCollisionCircles && collisionDetected) || !inGrid || perspectiveRatio < this.perspectiveRatioCutoff) ? [] : placedCollisionCircles,
	            offscreen: entirelyOffscreen,
	            collisionDetected
	        };
	    }
	    /**
	     * Because the geometries in the CollisionIndex are an approximation of the shape of
	     * symbols on the map, we use the CollisionIndex to look up the symbol part of
	     * `queryRenderedFeatures`.
	     */
	    queryRenderedSymbols(viewportQueryGeometry) {
	        if (viewportQueryGeometry.length === 0 || (this.grid.keysLength() === 0 && this.ignoredGrid.keysLength() === 0)) {
	            return {};
	        }
	        const query = [];
	        let minX = Infinity;
	        let minY = Infinity;
	        let maxX = -Infinity;
	        let maxY = -Infinity;
	        for (const point of viewportQueryGeometry) {
	            const gridPoint = new performance$1.Point(point.x + viewportPadding, point.y + viewportPadding);
	            minX = Math.min(minX, gridPoint.x);
	            minY = Math.min(minY, gridPoint.y);
	            maxX = Math.max(maxX, gridPoint.x);
	            maxY = Math.max(maxY, gridPoint.y);
	            query.push(gridPoint);
	        }
	        const features = this.grid.query(minX, minY, maxX, maxY)
	            .concat(this.ignoredGrid.query(minX, minY, maxX, maxY));
	        const seenFeatures = {};
	        const result = {};
	        for (const feature of features) {
	            const featureKey = feature.key;
	            // Skip already seen features.
	            if (seenFeatures[featureKey.bucketInstanceId] === undefined) {
	                seenFeatures[featureKey.bucketInstanceId] = {};
	            }
	            if (seenFeatures[featureKey.bucketInstanceId][featureKey.featureIndex]) {
	                continue;
	            }
	            // Check if query intersects with the feature box
	            // "Collision Circles" for line labels are treated as boxes here
	            // Since there's no actual collision taking place, the circle vs. square
	            // distinction doesn't matter as much, and box geometry is easier
	            // to work with.
	            const bbox = [
	                new performance$1.Point(feature.x1, feature.y1),
	                new performance$1.Point(feature.x2, feature.y1),
	                new performance$1.Point(feature.x2, feature.y2),
	                new performance$1.Point(feature.x1, feature.y2)
	            ];
	            if (!performance$1.polygonIntersectsPolygon(query, bbox)) {
	                continue;
	            }
	            seenFeatures[featureKey.bucketInstanceId][featureKey.featureIndex] = true;
	            if (result[featureKey.bucketInstanceId] === undefined) {
	                result[featureKey.bucketInstanceId] = [];
	            }
	            result[featureKey.bucketInstanceId].push(featureKey.featureIndex);
	        }
	        return result;
	    }
	    insertCollisionBox(collisionBox, overlapMode, ignorePlacement, bucketInstanceId, featureIndex, collisionGroupID) {
	        const grid = ignorePlacement ? this.ignoredGrid : this.grid;
	        const key = { bucketInstanceId, featureIndex, collisionGroupID, overlapMode };
	        grid.insert(key, collisionBox[0], collisionBox[1], collisionBox[2], collisionBox[3]);
	    }
	    insertCollisionCircles(collisionCircles, overlapMode, ignorePlacement, bucketInstanceId, featureIndex, collisionGroupID) {
	        const grid = ignorePlacement ? this.ignoredGrid : this.grid;
	        const key = { bucketInstanceId, featureIndex, collisionGroupID, overlapMode };
	        for (let k = 0; k < collisionCircles.length; k += 4) {
	            grid.insertCircle(key, collisionCircles[k], collisionCircles[k + 1], collisionCircles[k + 2]);
	        }
	    }
	    projectAndGetPerspectiveRatio(posMatrix, x, y, getElevation) {
	        let p;
	        if (getElevation) { // slow because of handle z-index
	            p = [x, y, getElevation(x, y), 1];
	            performance$1.transformMat4(p, p, posMatrix);
	        }
	        else { // fast because of ignore z-index
	            p = [x, y, 0, 1];
	            xyTransformMat4(p, p, posMatrix);
	        }
	        const a = new performance$1.Point((((p[0] / p[3] + 1) / 2) * this.transform.width) + viewportPadding, (((-p[1] / p[3] + 1) / 2) * this.transform.height) + viewportPadding);
	        return {
	            point: a,
	            // See perspective ratio comment in symbol_sdf.vertex
	            // We're doing collision detection in viewport space so we need
	            // to scale down boxes in the distance
	            perspectiveRatio: 0.5 + 0.5 * (this.transform.cameraToCenterDistance / p[3])
	        };
	    }
	    isOffscreen(x1, y1, x2, y2) {
	        return x2 < viewportPadding || x1 >= this.screenRightBoundary || y2 < viewportPadding || y1 > this.screenBottomBoundary;
	    }
	    isInsideGrid(x1, y1, x2, y2) {
	        return x2 >= 0 && x1 < this.gridRightBoundary && y2 >= 0 && y1 < this.gridBottomBoundary;
	    }
	    /*
	    * Returns a matrix for transforming collision shapes to viewport coordinate space.
	    * Use this function to render e.g. collision circles on the screen.
	    *   example transformation: clipPos = glCoordMatrix * viewportMatrix * circle_pos
	    */
	    getViewportMatrix() {
	        const m = performance$1.identity([]);
	        performance$1.translate(m, m, [-viewportPadding, -viewportPadding, 0.0]);
	        return m;
	    }
	}

	/**
	 * Converts a pixel value at a the given zoom level to tile units.
	 *
	 * The shaders mostly calculate everything in tile units so style
	 * properties need to be converted from pixels to tile units using this.
	 *
	 * For example, a translation by 30 pixels at zoom 6.5 will be a
	 * translation by pixelsToTileUnits(30, 6.5) tile units.
	 *
	 * @returns value in tile units
	 */
	function pixelsToTileUnits(tile, pixelValue, z) {
	    return pixelValue * (performance$1.EXTENT / (tile.tileSize * Math.pow(2, z - tile.tileID.overscaledZ)));
	}

	class OpacityState {
	    constructor(prevState, increment, placed, skipFade) {
	        if (prevState) {
	            this.opacity = Math.max(0, Math.min(1, prevState.opacity + (prevState.placed ? increment : -increment)));
	        }
	        else {
	            this.opacity = (skipFade && placed) ? 1 : 0;
	        }
	        this.placed = placed;
	    }
	    isHidden() {
	        return this.opacity === 0 && !this.placed;
	    }
	}
	class JointOpacityState {
	    constructor(prevState, increment, placedText, placedIcon, skipFade) {
	        this.text = new OpacityState(prevState ? prevState.text : null, increment, placedText, skipFade);
	        this.icon = new OpacityState(prevState ? prevState.icon : null, increment, placedIcon, skipFade);
	    }
	    isHidden() {
	        return this.text.isHidden() && this.icon.isHidden();
	    }
	}
	class JointPlacement {
	    constructor(text, icon, skipFade) {
	        this.text = text;
	        this.icon = icon;
	        this.skipFade = skipFade;
	    }
	}
	class CollisionCircleArray {
	    constructor() {
	        this.invProjMatrix = performance$1.create();
	        this.viewportMatrix = performance$1.create();
	        this.circles = [];
	    }
	}
	class RetainedQueryData {
	    constructor(bucketInstanceId, featureIndex, sourceLayerIndex, bucketIndex, tileID) {
	        this.bucketInstanceId = bucketInstanceId;
	        this.featureIndex = featureIndex;
	        this.sourceLayerIndex = sourceLayerIndex;
	        this.bucketIndex = bucketIndex;
	        this.tileID = tileID;
	    }
	}
	class CollisionGroups {
	    constructor(crossSourceCollisions) {
	        this.crossSourceCollisions = crossSourceCollisions;
	        this.maxGroupID = 0;
	        this.collisionGroups = {};
	    }
	    get(sourceID) {
	        // The predicate/groupID mechanism allows for arbitrary grouping,
	        // but the current interface defines one source == one group when
	        // crossSourceCollisions == true.
	        if (!this.crossSourceCollisions) {
	            if (!this.collisionGroups[sourceID]) {
	                const nextGroupID = ++this.maxGroupID;
	                this.collisionGroups[sourceID] = {
	                    ID: nextGroupID,
	                    predicate: (key) => {
	                        return key.collisionGroupID === nextGroupID;
	                    }
	                };
	            }
	            return this.collisionGroups[sourceID];
	        }
	        else {
	            return { ID: 0, predicate: null };
	        }
	    }
	}
	function calculateVariableLayoutShift(anchor, width, height, textOffset, textBoxScale) {
	    const { horizontalAlign, verticalAlign } = performance$1.getAnchorAlignment(anchor);
	    const shiftX = -(horizontalAlign - 0.5) * width;
	    const shiftY = -(verticalAlign - 0.5) * height;
	    return new performance$1.Point(shiftX + textOffset[0] * textBoxScale, shiftY + textOffset[1] * textBoxScale);
	}
	function shiftVariableCollisionBox(collisionBox, shiftX, shiftY, rotateWithMap, pitchWithMap, angle) {
	    const { x1, x2, y1, y2, anchorPointX, anchorPointY } = collisionBox;
	    const rotatedOffset = new performance$1.Point(shiftX, shiftY);
	    if (rotateWithMap) {
	        rotatedOffset._rotate(pitchWithMap ? angle : -angle);
	    }
	    return {
	        x1: x1 + rotatedOffset.x,
	        y1: y1 + rotatedOffset.y,
	        x2: x2 + rotatedOffset.x,
	        y2: y2 + rotatedOffset.y,
	        // symbol anchor point stays the same regardless of text-anchor
	        anchorPointX,
	        anchorPointY
	    };
	}
	class Placement {
	    constructor(transform, terrain, fadeDuration, crossSourceCollisions, prevPlacement) {
	        this.transform = transform.clone();
	        this.terrain = terrain;
	        this.collisionIndex = new CollisionIndex(this.transform);
	        this.placements = {};
	        this.opacities = {};
	        this.variableOffsets = {};
	        this.stale = false;
	        this.commitTime = 0;
	        this.fadeDuration = fadeDuration;
	        this.retainedQueryData = {};
	        this.collisionGroups = new CollisionGroups(crossSourceCollisions);
	        this.collisionCircleArrays = {};
	        this.prevPlacement = prevPlacement;
	        if (prevPlacement) {
	            prevPlacement.prevPlacement = undefined; // Only hold on to one placement back
	        }
	        this.placedOrientations = {};
	    }
	    getBucketParts(results, styleLayer, tile, sortAcrossTiles) {
	        const symbolBucket = tile.getBucket(styleLayer);
	        const bucketFeatureIndex = tile.latestFeatureIndex;
	        if (!symbolBucket || !bucketFeatureIndex || styleLayer.id !== symbolBucket.layerIds[0])
	            return;
	        const collisionBoxArray = tile.collisionBoxArray;
	        const layout = symbolBucket.layers[0].layout;
	        const scale = Math.pow(2, this.transform.zoom - tile.tileID.overscaledZ);
	        const textPixelRatio = tile.tileSize / performance$1.EXTENT;
	        const posMatrix = this.transform.calculatePosMatrix(tile.tileID.toUnwrapped());
	        const pitchWithMap = layout.get('text-pitch-alignment') === 'map';
	        const rotateWithMap = layout.get('text-rotation-alignment') === 'map';
	        const pixelsToTiles = pixelsToTileUnits(tile, 1, this.transform.zoom);
	        const textLabelPlaneMatrix = getLabelPlaneMatrix(posMatrix, pitchWithMap, rotateWithMap, this.transform, pixelsToTiles);
	        let labelToScreenMatrix = null;
	        if (pitchWithMap) {
	            const glMatrix = getGlCoordMatrix(posMatrix, pitchWithMap, rotateWithMap, this.transform, pixelsToTiles);
	            labelToScreenMatrix = performance$1.multiply([], this.transform.labelPlaneMatrix, glMatrix);
	        }
	        // As long as this placement lives, we have to hold onto this bucket's
	        // matching FeatureIndex/data for querying purposes
	        this.retainedQueryData[symbolBucket.bucketInstanceId] = new RetainedQueryData(symbolBucket.bucketInstanceId, bucketFeatureIndex, symbolBucket.sourceLayerIndex, symbolBucket.index, tile.tileID);
	        const parameters = {
	            bucket: symbolBucket,
	            layout,
	            posMatrix,
	            textLabelPlaneMatrix,
	            labelToScreenMatrix,
	            scale,
	            textPixelRatio,
	            holdingForFade: tile.holdingForFade(),
	            collisionBoxArray,
	            partiallyEvaluatedTextSize: performance$1.evaluateSizeForZoom(symbolBucket.textSizeData, this.transform.zoom),
	            collisionGroup: this.collisionGroups.get(symbolBucket.sourceID)
	        };
	        if (sortAcrossTiles) {
	            for (const range of symbolBucket.sortKeyRanges) {
	                const { sortKey, symbolInstanceStart, symbolInstanceEnd } = range;
	                results.push({ sortKey, symbolInstanceStart, symbolInstanceEnd, parameters });
	            }
	        }
	        else {
	            results.push({
	                symbolInstanceStart: 0,
	                symbolInstanceEnd: symbolBucket.symbolInstances.length,
	                parameters
	            });
	        }
	    }
	    attemptAnchorPlacement(textAnchorOffset, textBox, width, height, textBoxScale, rotateWithMap, pitchWithMap, textPixelRatio, posMatrix, collisionGroup, textOverlapMode, symbolInstance, bucket, orientation, iconBox, getElevation) {
	        const anchor = performance$1.TextAnchorEnum[textAnchorOffset.textAnchor];
	        const textOffset = [textAnchorOffset.textOffset0, textAnchorOffset.textOffset1];
	        const shift = calculateVariableLayoutShift(anchor, width, height, textOffset, textBoxScale);
	        const placedGlyphBoxes = this.collisionIndex.placeCollisionBox(shiftVariableCollisionBox(textBox, shift.x, shift.y, rotateWithMap, pitchWithMap, this.transform.angle), textOverlapMode, textPixelRatio, posMatrix, collisionGroup.predicate, getElevation);
	        if (iconBox) {
	            const placedIconBoxes = this.collisionIndex.placeCollisionBox(shiftVariableCollisionBox(iconBox, shift.x, shift.y, rotateWithMap, pitchWithMap, this.transform.angle), textOverlapMode, textPixelRatio, posMatrix, collisionGroup.predicate, getElevation);
	            if (placedIconBoxes.box.length === 0)
	                return;
	        }
	        if (placedGlyphBoxes.box.length > 0) {
	            let prevAnchor;
	            // If this label was placed in the previous placement, record the anchor position
	            // to allow us to animate the transition
	            if (this.prevPlacement &&
	                this.prevPlacement.variableOffsets[symbolInstance.crossTileID] &&
	                this.prevPlacement.placements[symbolInstance.crossTileID] &&
	                this.prevPlacement.placements[symbolInstance.crossTileID].text) {
	                prevAnchor = this.prevPlacement.variableOffsets[symbolInstance.crossTileID].anchor;
	            }
	            if (symbolInstance.crossTileID === 0)
	                throw new Error('symbolInstance.crossTileID can\'t be 0');
	            this.variableOffsets[symbolInstance.crossTileID] = {
	                textOffset,
	                width,
	                height,
	                anchor,
	                textBoxScale,
	                prevAnchor
	            };
	            this.markUsedJustification(bucket, anchor, symbolInstance, orientation);
	            if (bucket.allowVerticalPlacement) {
	                this.markUsedOrientation(bucket, orientation, symbolInstance);
	                this.placedOrientations[symbolInstance.crossTileID] = orientation;
	            }
	            return { shift, placedGlyphBoxes };
	        }
	    }
	    placeLayerBucketPart(bucketPart, seenCrossTileIDs, showCollisionBoxes) {
	        const { bucket, layout, posMatrix, textLabelPlaneMatrix, labelToScreenMatrix, textPixelRatio, holdingForFade, collisionBoxArray, partiallyEvaluatedTextSize, collisionGroup } = bucketPart.parameters;
	        const textOptional = layout.get('text-optional');
	        const iconOptional = layout.get('icon-optional');
	        const textOverlapMode = performance$1.getOverlapMode(layout, 'text-overlap', 'text-allow-overlap');
	        const textAlwaysOverlap = textOverlapMode === 'always';
	        const iconOverlapMode = performance$1.getOverlapMode(layout, 'icon-overlap', 'icon-allow-overlap');
	        const iconAlwaysOverlap = iconOverlapMode === 'always';
	        const rotateWithMap = layout.get('text-rotation-alignment') === 'map';
	        const pitchWithMap = layout.get('text-pitch-alignment') === 'map';
	        const hasIconTextFit = layout.get('icon-text-fit') !== 'none';
	        const zOrderByViewportY = layout.get('symbol-z-order') === 'viewport-y';
	        // This logic is similar to the "defaultOpacityState" logic below in updateBucketOpacities
	        // If we know a symbol is always supposed to show, force it to be marked visible even if
	        // it wasn't placed into the collision index (because some or all of it was outside the range
	        // of the collision grid).
	        // There is a subtle edge case here we're accepting:
	        //  Symbol A has text-allow-overlap: true, icon-allow-overlap: true, icon-optional: false
	        //  A's icon is outside the grid, so doesn't get placed
	        //  A's text would be inside grid, but doesn't get placed because of icon-optional: false
	        //  We still show A because of the allow-overlap settings.
	        //  Symbol B has allow-overlap: false, and gets placed where A's text would be
	        //  On panning in, there is a short period when Symbol B and Symbol A will overlap
	        //  This is the reverse of our normal policy of "fade in on pan", but should look like any other
	        //  collision and hopefully not be too noticeable.
	        // See https://github.com/mapbox/mapbox-gl-js/issues/7172
	        const alwaysShowText = textAlwaysOverlap && (iconAlwaysOverlap || !bucket.hasIconData() || iconOptional);
	        const alwaysShowIcon = iconAlwaysOverlap && (textAlwaysOverlap || !bucket.hasTextData() || textOptional);
	        if (!bucket.collisionArrays && collisionBoxArray) {
	            bucket.deserializeCollisionBoxes(collisionBoxArray);
	        }
	        const tileID = this.retainedQueryData[bucket.bucketInstanceId].tileID;
	        const getElevation = this.terrain ? (x, y) => this.terrain.getElevation(tileID, x, y) : null;
	        const placeSymbol = (symbolInstance, collisionArrays) => {
	            var _a, _b;
	            if (seenCrossTileIDs[symbolInstance.crossTileID])
	                return;
	            if (holdingForFade) {
	                // Mark all symbols from this tile as "not placed", but don't add to seenCrossTileIDs, because we don't
	                // know yet if we have a duplicate in a parent tile that _should_ be placed.
	                this.placements[symbolInstance.crossTileID] = new JointPlacement(false, false, false);
	                return;
	            }
	            let placeText = false;
	            let placeIcon = false;
	            let offscreen = true;
	            let shift = null;
	            let placed = { box: null, offscreen: null };
	            let placedVerticalText = { box: null, offscreen: null };
	            let placedGlyphBoxes = null;
	            let placedGlyphCircles = null;
	            let placedIconBoxes = null;
	            let textFeatureIndex = 0;
	            let verticalTextFeatureIndex = 0;
	            let iconFeatureIndex = 0;
	            if (collisionArrays.textFeatureIndex) {
	                textFeatureIndex = collisionArrays.textFeatureIndex;
	            }
	            else if (symbolInstance.useRuntimeCollisionCircles) {
	                textFeatureIndex = symbolInstance.featureIndex;
	            }
	            if (collisionArrays.verticalTextFeatureIndex) {
	                verticalTextFeatureIndex = collisionArrays.verticalTextFeatureIndex;
	            }
	            const textBox = collisionArrays.textBox;
	            if (textBox) {
	                const updatePreviousOrientationIfNotPlaced = (isPlaced) => {
	                    let previousOrientation = performance$1.WritingMode.horizontal;
	                    if (bucket.allowVerticalPlacement && !isPlaced && this.prevPlacement) {
	                        const prevPlacedOrientation = this.prevPlacement.placedOrientations[symbolInstance.crossTileID];
	                        if (prevPlacedOrientation) {
	                            this.placedOrientations[symbolInstance.crossTileID] = prevPlacedOrientation;
	                            previousOrientation = prevPlacedOrientation;
	                            this.markUsedOrientation(bucket, previousOrientation, symbolInstance);
	                        }
	                    }
	                    return previousOrientation;
	                };
	                const placeTextForPlacementModes = (placeHorizontalFn, placeVerticalFn) => {
	                    if (bucket.allowVerticalPlacement && symbolInstance.numVerticalGlyphVertices > 0 && collisionArrays.verticalTextBox) {
	                        for (const placementMode of bucket.writingModes) {
	                            if (placementMode === performance$1.WritingMode.vertical) {
	                                placed = placeVerticalFn();
	                                placedVerticalText = placed;
	                            }
	                            else {
	                                placed = placeHorizontalFn();
	                            }
	                            if (placed && placed.box && placed.box.length)
	                                break;
	                        }
	                    }
	                    else {
	                        placed = placeHorizontalFn();
	                    }
	                };
	                const textAnchorOffsetStart = symbolInstance.textAnchorOffsetStartIndex;
	                const textAnchorOffsetEnd = symbolInstance.textAnchorOffsetEndIndex;
	                // If start+end indices match, text-variable-anchor is not in play.
	                if (textAnchorOffsetEnd === textAnchorOffsetStart) {
	                    const placeBox = (collisionTextBox, orientation) => {
	                        const placedFeature = this.collisionIndex.placeCollisionBox(collisionTextBox, textOverlapMode, textPixelRatio, posMatrix, collisionGroup.predicate, getElevation);
	                        if (placedFeature && placedFeature.box && placedFeature.box.length) {
	                            this.markUsedOrientation(bucket, orientation, symbolInstance);
	                            this.placedOrientations[symbolInstance.crossTileID] = orientation;
	                        }
	                        return placedFeature;
	                    };
	                    const placeHorizontal = () => {
	                        return placeBox(textBox, performance$1.WritingMode.horizontal);
	                    };
	                    const placeVertical = () => {
	                        const verticalTextBox = collisionArrays.verticalTextBox;
	                        if (bucket.allowVerticalPlacement && symbolInstance.numVerticalGlyphVertices > 0 && verticalTextBox) {
	                            return placeBox(verticalTextBox, performance$1.WritingMode.vertical);
	                        }
	                        return { box: null, offscreen: null };
	                    };
	                    placeTextForPlacementModes(placeHorizontal, placeVertical);
	                    updatePreviousOrientationIfNotPlaced(placed && placed.box && placed.box.length);
	                }
	                else {
	                    // If this symbol was in the last placement, prefer placement using same anchor, if it's still available
	                    let prevAnchor = performance$1.TextAnchorEnum[(_b = (_a = this.prevPlacement) === null || _a === void 0 ? void 0 : _a.variableOffsets[symbolInstance.crossTileID]) === null || _b === void 0 ? void 0 : _b.anchor];
	                    const placeBoxForVariableAnchors = (collisionTextBox, collisionIconBox, orientation) => {
	                        const width = collisionTextBox.x2 - collisionTextBox.x1;
	                        const height = collisionTextBox.y2 - collisionTextBox.y1;
	                        const textBoxScale = symbolInstance.textBoxScale;
	                        const variableIconBox = hasIconTextFit && (iconOverlapMode === 'never') ? collisionIconBox : null;
	                        let placedBox = { box: [], offscreen: false };
	                        let placementPasses = (textOverlapMode === 'never') ? 1 : 2;
	                        let overlapMode = 'never';
	                        if (prevAnchor) {
	                            placementPasses++;
	                        }
	                        for (let pass = 0; pass < placementPasses; pass++) {
	                            for (let i = textAnchorOffsetStart; i < textAnchorOffsetEnd; i++) {
	                                const textAnchorOffset = bucket.textAnchorOffsets.get(i);
	                                if (prevAnchor && textAnchorOffset.textAnchor !== prevAnchor) {
	                                    continue;
	                                }
	                                const result = this.attemptAnchorPlacement(textAnchorOffset, collisionTextBox, width, height, textBoxScale, rotateWithMap, pitchWithMap, textPixelRatio, posMatrix, collisionGroup, overlapMode, symbolInstance, bucket, orientation, variableIconBox, getElevation);
	                                if (result) {
	                                    placedBox = result.placedGlyphBoxes;
	                                    if (placedBox && placedBox.box && placedBox.box.length) {
	                                        placeText = true;
	                                        shift = result.shift;
	                                        return placedBox;
	                                    }
	                                }
	                            }
	                            if (prevAnchor) {
	                                prevAnchor = null;
	                            }
	                            else {
	                                overlapMode = textOverlapMode;
	                            }
	                        }
	                        return placedBox;
	                    };
	                    const placeHorizontal = () => {
	                        return placeBoxForVariableAnchors(textBox, collisionArrays.iconBox, performance$1.WritingMode.horizontal);
	                    };
	                    const placeVertical = () => {
	                        const verticalTextBox = collisionArrays.verticalTextBox;
	                        const wasPlaced = placed && placed.box && placed.box.length;
	                        if (bucket.allowVerticalPlacement && !wasPlaced && symbolInstance.numVerticalGlyphVertices > 0 && verticalTextBox) {
	                            return placeBoxForVariableAnchors(verticalTextBox, collisionArrays.verticalIconBox, performance$1.WritingMode.vertical);
	                        }
	                        return { box: null, offscreen: null };
	                    };
	                    placeTextForPlacementModes(placeHorizontal, placeVertical);
	                    if (placed) {
	                        placeText = placed.box;
	                        offscreen = placed.offscreen;
	                    }
	                    const prevOrientation = updatePreviousOrientationIfNotPlaced(placed && placed.box);
	                    // If we didn't get placed, we still need to copy our position from the last placement for
	                    // fade animations
	                    if (!placeText && this.prevPlacement) {
	                        const prevOffset = this.prevPlacement.variableOffsets[symbolInstance.crossTileID];
	                        if (prevOffset) {
	                            this.variableOffsets[symbolInstance.crossTileID] = prevOffset;
	                            this.markUsedJustification(bucket, prevOffset.anchor, symbolInstance, prevOrientation);
	                        }
	                    }
	                }
	            }
	            placedGlyphBoxes = placed;
	            placeText = placedGlyphBoxes && placedGlyphBoxes.box && placedGlyphBoxes.box.length > 0;
	            offscreen = placedGlyphBoxes && placedGlyphBoxes.offscreen;
	            if (symbolInstance.useRuntimeCollisionCircles) {
	                const placedSymbol = bucket.text.placedSymbolArray.get(symbolInstance.centerJustifiedTextSymbolIndex);
	                const fontSize = performance$1.evaluateSizeForFeature(bucket.textSizeData, partiallyEvaluatedTextSize, placedSymbol);
	                const textPixelPadding = layout.get('text-padding');
	                const circlePixelDiameter = symbolInstance.collisionCircleDiameter;
	                placedGlyphCircles = this.collisionIndex.placeCollisionCircles(textOverlapMode, placedSymbol, bucket.lineVertexArray, bucket.glyphOffsetArray, fontSize, posMatrix, textLabelPlaneMatrix, labelToScreenMatrix, showCollisionBoxes, pitchWithMap, collisionGroup.predicate, circlePixelDiameter, textPixelPadding, getElevation);
	                if (placedGlyphCircles.circles.length && placedGlyphCircles.collisionDetected && !showCollisionBoxes) {
	                    performance$1.warnOnce('Collisions detected, but collision boxes are not shown');
	                }
	                // If text-overlap is set to 'always', force "placedCircles" to true
	                // In theory there should always be at least one circle placed
	                // in this case, but for now quirks in text-anchor
	                // and text-offset may prevent that from being true.
	                placeText = textAlwaysOverlap || (placedGlyphCircles.circles.length > 0 && !placedGlyphCircles.collisionDetected);
	                offscreen = offscreen && placedGlyphCircles.offscreen;
	            }
	            if (collisionArrays.iconFeatureIndex) {
	                iconFeatureIndex = collisionArrays.iconFeatureIndex;
	            }
	            if (collisionArrays.iconBox) {
	                const placeIconFeature = iconBox => {
	                    const shiftedIconBox = hasIconTextFit && shift ?
	                        shiftVariableCollisionBox(iconBox, shift.x, shift.y, rotateWithMap, pitchWithMap, this.transform.angle) :
	                        iconBox;
	                    return this.collisionIndex.placeCollisionBox(shiftedIconBox, iconOverlapMode, textPixelRatio, posMatrix, collisionGroup.predicate, getElevation);
	                };
	                if (placedVerticalText && placedVerticalText.box && placedVerticalText.box.length && collisionArrays.verticalIconBox) {
	                    placedIconBoxes = placeIconFeature(collisionArrays.verticalIconBox);
	                    placeIcon = placedIconBoxes.box.length > 0;
	                }
	                else {
	                    placedIconBoxes = placeIconFeature(collisionArrays.iconBox);
	                    placeIcon = placedIconBoxes.box.length > 0;
	                }
	                offscreen = offscreen && placedIconBoxes.offscreen;
	            }
	            const iconWithoutText = textOptional ||
	                (symbolInstance.numHorizontalGlyphVertices === 0 && symbolInstance.numVerticalGlyphVertices === 0);
	            const textWithoutIcon = iconOptional || symbolInstance.numIconVertices === 0;
	            // Combine the scales for icons and text.
	            if (!iconWithoutText && !textWithoutIcon) {
	                placeIcon = placeText = placeIcon && placeText;
	            }
	            else if (!textWithoutIcon) {
	                placeText = placeIcon && placeText;
	            }
	            else if (!iconWithoutText) {
	                placeIcon = placeIcon && placeText;
	            }
	            if (placeText && placedGlyphBoxes && placedGlyphBoxes.box) {
	                if (placedVerticalText && placedVerticalText.box && verticalTextFeatureIndex) {
	                    this.collisionIndex.insertCollisionBox(placedGlyphBoxes.box, textOverlapMode, layout.get('text-ignore-placement'), bucket.bucketInstanceId, verticalTextFeatureIndex, collisionGroup.ID);
	                }
	                else {
	                    this.collisionIndex.insertCollisionBox(placedGlyphBoxes.box, textOverlapMode, layout.get('text-ignore-placement'), bucket.bucketInstanceId, textFeatureIndex, collisionGroup.ID);
	                }
	            }
	            if (placeIcon && placedIconBoxes) {
	                this.collisionIndex.insertCollisionBox(placedIconBoxes.box, iconOverlapMode, layout.get('icon-ignore-placement'), bucket.bucketInstanceId, iconFeatureIndex, collisionGroup.ID);
	            }
	            if (placedGlyphCircles) {
	                if (placeText) {
	                    this.collisionIndex.insertCollisionCircles(placedGlyphCircles.circles, textOverlapMode, layout.get('text-ignore-placement'), bucket.bucketInstanceId, textFeatureIndex, collisionGroup.ID);
	                }
	                if (showCollisionBoxes) {
	                    const id = bucket.bucketInstanceId;
	                    let circleArray = this.collisionCircleArrays[id];
	                    // Group collision circles together by bucket. Circles can't be pushed forward for rendering yet as the symbol placement
	                    // for a bucket is not guaranteed to be complete before the commit-function has been called
	                    if (circleArray === undefined)
	                        circleArray = this.collisionCircleArrays[id] = new CollisionCircleArray();
	                    for (let i = 0; i < placedGlyphCircles.circles.length; i += 4) {
	                        circleArray.circles.push(placedGlyphCircles.circles[i + 0]); // x
	                        circleArray.circles.push(placedGlyphCircles.circles[i + 1]); // y
	                        circleArray.circles.push(placedGlyphCircles.circles[i + 2]); // radius
	                        circleArray.circles.push(placedGlyphCircles.collisionDetected ? 1 : 0); // collisionDetected-flag
	                    }
	                }
	            }
	            if (symbolInstance.crossTileID === 0)
	                throw new Error('symbolInstance.crossTileID can\'t be 0');
	            if (bucket.bucketInstanceId === 0)
	                throw new Error('bucket.bucketInstanceId can\'t be 0');
	            this.placements[symbolInstance.crossTileID] = new JointPlacement(placeText || alwaysShowText, placeIcon || alwaysShowIcon, offscreen || bucket.justReloaded);
	            seenCrossTileIDs[symbolInstance.crossTileID] = true;
	        };
	        if (zOrderByViewportY) {
	            if (bucketPart.symbolInstanceStart !== 0)
	                throw new Error('bucket.bucketInstanceId should be 0');
	            const symbolIndexes = bucket.getSortedSymbolIndexes(this.transform.angle);
	            for (let i = symbolIndexes.length - 1; i >= 0; --i) {
	                const symbolIndex = symbolIndexes[i];
	                placeSymbol(bucket.symbolInstances.get(symbolIndex), bucket.collisionArrays[symbolIndex]);
	            }
	        }
	        else {
	            for (let i = bucketPart.symbolInstanceStart; i < bucketPart.symbolInstanceEnd; i++) {
	                placeSymbol(bucket.symbolInstances.get(i), bucket.collisionArrays[i]);
	            }
	        }
	        if (showCollisionBoxes && bucket.bucketInstanceId in this.collisionCircleArrays) {
	            const circleArray = this.collisionCircleArrays[bucket.bucketInstanceId];
	            // Store viewport and inverse projection matrices per bucket
	            performance$1.invert(circleArray.invProjMatrix, posMatrix);
	            circleArray.viewportMatrix = this.collisionIndex.getViewportMatrix();
	        }
	        bucket.justReloaded = false;
	    }
	    markUsedJustification(bucket, placedAnchor, symbolInstance, orientation) {
	        const justifications = {
	            'left': symbolInstance.leftJustifiedTextSymbolIndex,
	            'center': symbolInstance.centerJustifiedTextSymbolIndex,
	            'right': symbolInstance.rightJustifiedTextSymbolIndex
	        };
	        let autoIndex;
	        if (orientation === performance$1.WritingMode.vertical) {
	            autoIndex = symbolInstance.verticalPlacedTextSymbolIndex;
	        }
	        else {
	            autoIndex = justifications[performance$1.getAnchorJustification(placedAnchor)];
	        }
	        const indexes = [
	            symbolInstance.leftJustifiedTextSymbolIndex,
	            symbolInstance.centerJustifiedTextSymbolIndex,
	            symbolInstance.rightJustifiedTextSymbolIndex,
	            symbolInstance.verticalPlacedTextSymbolIndex
	        ];
	        for (const index of indexes) {
	            if (index >= 0) {
	                if (autoIndex >= 0 && index !== autoIndex) {
	                    // There are multiple justifications and this one isn't it: shift offscreen
	                    bucket.text.placedSymbolArray.get(index).crossTileID = 0;
	                }
	                else {
	                    // Either this is the chosen justification or the justification is hardwired: use this one
	                    bucket.text.placedSymbolArray.get(index).crossTileID = symbolInstance.crossTileID;
	                }
	            }
	        }
	    }
	    markUsedOrientation(bucket, orientation, symbolInstance) {
	        const horizontal = (orientation === performance$1.WritingMode.horizontal || orientation === performance$1.WritingMode.horizontalOnly) ? orientation : 0;
	        const vertical = orientation === performance$1.WritingMode.vertical ? orientation : 0;
	        const horizontalIndexes = [
	            symbolInstance.leftJustifiedTextSymbolIndex,
	            symbolInstance.centerJustifiedTextSymbolIndex,
	            symbolInstance.rightJustifiedTextSymbolIndex
	        ];
	        for (const index of horizontalIndexes) {
	            bucket.text.placedSymbolArray.get(index).placedOrientation = horizontal;
	        }
	        if (symbolInstance.verticalPlacedTextSymbolIndex) {
	            bucket.text.placedSymbolArray.get(symbolInstance.verticalPlacedTextSymbolIndex).placedOrientation = vertical;
	        }
	    }
	    commit(now) {
	        this.commitTime = now;
	        this.zoomAtLastRecencyCheck = this.transform.zoom;
	        const prevPlacement = this.prevPlacement;
	        let placementChanged = false;
	        this.prevZoomAdjustment = prevPlacement ? prevPlacement.zoomAdjustment(this.transform.zoom) : 0;
	        const increment = prevPlacement ? prevPlacement.symbolFadeChange(now) : 1;
	        const prevOpacities = prevPlacement ? prevPlacement.opacities : {};
	        const prevOffsets = prevPlacement ? prevPlacement.variableOffsets : {};
	        const prevOrientations = prevPlacement ? prevPlacement.placedOrientations : {};
	        // add the opacities from the current placement, and copy their current values from the previous placement
	        for (const crossTileID in this.placements) {
	            const jointPlacement = this.placements[crossTileID];
	            const prevOpacity = prevOpacities[crossTileID];
	            if (prevOpacity) {
	                this.opacities[crossTileID] = new JointOpacityState(prevOpacity, increment, jointPlacement.text, jointPlacement.icon);
	                placementChanged = placementChanged ||
	                    jointPlacement.text !== prevOpacity.text.placed ||
	                    jointPlacement.icon !== prevOpacity.icon.placed;
	            }
	            else {
	                this.opacities[crossTileID] = new JointOpacityState(null, increment, jointPlacement.text, jointPlacement.icon, jointPlacement.skipFade);
	                placementChanged = placementChanged || jointPlacement.text || jointPlacement.icon;
	            }
	        }
	        // copy and update values from the previous placement that aren't in the current placement but haven't finished fading
	        for (const crossTileID in prevOpacities) {
	            const prevOpacity = prevOpacities[crossTileID];
	            if (!this.opacities[crossTileID]) {
	                const jointOpacity = new JointOpacityState(prevOpacity, increment, false, false);
	                if (!jointOpacity.isHidden()) {
	                    this.opacities[crossTileID] = jointOpacity;
	                    placementChanged = placementChanged || prevOpacity.text.placed || prevOpacity.icon.placed;
	                }
	            }
	        }
	        for (const crossTileID in prevOffsets) {
	            if (!this.variableOffsets[crossTileID] && this.opacities[crossTileID] && !this.opacities[crossTileID].isHidden()) {
	                this.variableOffsets[crossTileID] = prevOffsets[crossTileID];
	            }
	        }
	        for (const crossTileID in prevOrientations) {
	            if (!this.placedOrientations[crossTileID] && this.opacities[crossTileID] && !this.opacities[crossTileID].isHidden()) {
	                this.placedOrientations[crossTileID] = prevOrientations[crossTileID];
	            }
	        }
	        // this.lastPlacementChangeTime is the time of the last commit() that
	        // resulted in a placement change -- in other words, the start time of
	        // the last symbol fade animation
	        if (prevPlacement && prevPlacement.lastPlacementChangeTime === undefined) {
	            throw new Error('Last placement time for previous placement is not defined');
	        }
	        if (placementChanged) {
	            this.lastPlacementChangeTime = now;
	        }
	        else if (typeof this.lastPlacementChangeTime !== 'number') {
	            this.lastPlacementChangeTime = prevPlacement ? prevPlacement.lastPlacementChangeTime : now;
	        }
	    }
	    updateLayerOpacities(styleLayer, tiles) {
	        const seenCrossTileIDs = {};
	        for (const tile of tiles) {
	            const symbolBucket = tile.getBucket(styleLayer);
	            if (symbolBucket && tile.latestFeatureIndex && styleLayer.id === symbolBucket.layerIds[0]) {
	                this.updateBucketOpacities(symbolBucket, seenCrossTileIDs, tile.collisionBoxArray);
	            }
	        }
	    }
	    updateBucketOpacities(bucket, seenCrossTileIDs, collisionBoxArray) {
	        if (bucket.hasTextData()) {
	            bucket.text.opacityVertexArray.clear();
	            bucket.text.hasVisibleVertices = false;
	        }
	        if (bucket.hasIconData()) {
	            bucket.icon.opacityVertexArray.clear();
	            bucket.icon.hasVisibleVertices = false;
	        }
	        if (bucket.hasIconCollisionBoxData())
	            bucket.iconCollisionBox.collisionVertexArray.clear();
	        if (bucket.hasTextCollisionBoxData())
	            bucket.textCollisionBox.collisionVertexArray.clear();
	        const layer = bucket.layers[0];
	        const layout = layer.layout;
	        const duplicateOpacityState = new JointOpacityState(null, 0, false, false, true);
	        const textAllowOverlap = layout.get('text-allow-overlap');
	        const iconAllowOverlap = layout.get('icon-allow-overlap');
	        const hasVariablePlacement = layer._unevaluatedLayout.hasValue('text-variable-anchor') || layer._unevaluatedLayout.hasValue('text-variable-anchor-offset');
	        const rotateWithMap = layout.get('text-rotation-alignment') === 'map';
	        const pitchWithMap = layout.get('text-pitch-alignment') === 'map';
	        const hasIconTextFit = layout.get('icon-text-fit') !== 'none';
	        // If allow-overlap is true, we can show symbols before placement runs on them
	        // But we have to wait for placement if we potentially depend on a paired icon/text
	        // with allow-overlap: false.
	        // See https://github.com/mapbox/mapbox-gl-js/issues/7032
	        const defaultOpacityState = new JointOpacityState(null, 0, textAllowOverlap && (iconAllowOverlap || !bucket.hasIconData() || layout.get('icon-optional')), iconAllowOverlap && (textAllowOverlap || !bucket.hasTextData() || layout.get('text-optional')), true);
	        if (!bucket.collisionArrays && collisionBoxArray && ((bucket.hasIconCollisionBoxData() || bucket.hasTextCollisionBoxData()))) {
	            bucket.deserializeCollisionBoxes(collisionBoxArray);
	        }
	        const addOpacities = (iconOrText, numVertices, opacity) => {
	            for (let i = 0; i < numVertices / 4; i++) {
	                iconOrText.opacityVertexArray.emplaceBack(opacity);
	            }
	            iconOrText.hasVisibleVertices = iconOrText.hasVisibleVertices || (opacity !== PACKED_HIDDEN_OPACITY);
	        };
	        for (let s = 0; s < bucket.symbolInstances.length; s++) {
	            const symbolInstance = bucket.symbolInstances.get(s);
	            const { numHorizontalGlyphVertices, numVerticalGlyphVertices, crossTileID } = symbolInstance;
	            const isDuplicate = seenCrossTileIDs[crossTileID];
	            let opacityState = this.opacities[crossTileID];
	            if (isDuplicate) {
	                opacityState = duplicateOpacityState;
	            }
	            else if (!opacityState) {
	                opacityState = defaultOpacityState;
	                // store the state so that future placements use it as a starting point
	                this.opacities[crossTileID] = opacityState;
	            }
	            seenCrossTileIDs[crossTileID] = true;
	            const hasText = numHorizontalGlyphVertices > 0 || numVerticalGlyphVertices > 0;
	            const hasIcon = symbolInstance.numIconVertices > 0;
	            const placedOrientation = this.placedOrientations[symbolInstance.crossTileID];
	            const horizontalHidden = placedOrientation === performance$1.WritingMode.vertical;
	            const verticalHidden = placedOrientation === performance$1.WritingMode.horizontal || placedOrientation === performance$1.WritingMode.horizontalOnly;
	            if (hasText) {
	                const packedOpacity = packOpacity(opacityState.text);
	                // Vertical text fades in/out on collision the same way as corresponding
	                // horizontal text. Switch between vertical/horizontal should be instantaneous
	                const horizontalOpacity = horizontalHidden ? PACKED_HIDDEN_OPACITY : packedOpacity;
	                addOpacities(bucket.text, numHorizontalGlyphVertices, horizontalOpacity);
	                const verticalOpacity = verticalHidden ? PACKED_HIDDEN_OPACITY : packedOpacity;
	                addOpacities(bucket.text, numVerticalGlyphVertices, verticalOpacity);
	                // If this label is completely faded, mark it so that we don't have to calculate
	                // its position at render time. If this layer has variable placement, shift the various
	                // symbol instances appropriately so that symbols from buckets that have yet to be placed
	                // offset appropriately.
	                const symbolHidden = opacityState.text.isHidden();
	                [
	                    symbolInstance.rightJustifiedTextSymbolIndex,
	                    symbolInstance.centerJustifiedTextSymbolIndex,
	                    symbolInstance.leftJustifiedTextSymbolIndex
	                ].forEach(index => {
	                    if (index >= 0) {
	                        bucket.text.placedSymbolArray.get(index).hidden = symbolHidden || horizontalHidden ? 1 : 0;
	                    }
	                });
	                if (symbolInstance.verticalPlacedTextSymbolIndex >= 0) {
	                    bucket.text.placedSymbolArray.get(symbolInstance.verticalPlacedTextSymbolIndex).hidden = symbolHidden || verticalHidden ? 1 : 0;
	                }
	                const prevOffset = this.variableOffsets[symbolInstance.crossTileID];
	                if (prevOffset) {
	                    this.markUsedJustification(bucket, prevOffset.anchor, symbolInstance, placedOrientation);
	                }
	                const prevOrientation = this.placedOrientations[symbolInstance.crossTileID];
	                if (prevOrientation) {
	                    this.markUsedJustification(bucket, 'left', symbolInstance, prevOrientation);
	                    this.markUsedOrientation(bucket, prevOrientation, symbolInstance);
	                }
	            }
	            if (hasIcon) {
	                const packedOpacity = packOpacity(opacityState.icon);
	                const useHorizontal = !(hasIconTextFit && symbolInstance.verticalPlacedIconSymbolIndex && horizontalHidden);
	                if (symbolInstance.placedIconSymbolIndex >= 0) {
	                    const horizontalOpacity = useHorizontal ? packedOpacity : PACKED_HIDDEN_OPACITY;
	                    addOpacities(bucket.icon, symbolInstance.numIconVertices, horizontalOpacity);
	                    bucket.icon.placedSymbolArray.get(symbolInstance.placedIconSymbolIndex).hidden =
	                        opacityState.icon.isHidden();
	                }
	                if (symbolInstance.verticalPlacedIconSymbolIndex >= 0) {
	                    const verticalOpacity = !useHorizontal ? packedOpacity : PACKED_HIDDEN_OPACITY;
	                    addOpacities(bucket.icon, symbolInstance.numVerticalIconVertices, verticalOpacity);
	                    bucket.icon.placedSymbolArray.get(symbolInstance.verticalPlacedIconSymbolIndex).hidden =
	                        opacityState.icon.isHidden();
	                }
	            }
	            if (bucket.hasIconCollisionBoxData() || bucket.hasTextCollisionBoxData()) {
	                const collisionArrays = bucket.collisionArrays[s];
	                if (collisionArrays) {
	                    let shift = new performance$1.Point(0, 0);
	                    if (collisionArrays.textBox || collisionArrays.verticalTextBox) {
	                        let used = true;
	                        if (hasVariablePlacement) {
	                            const variableOffset = this.variableOffsets[crossTileID];
	                            if (variableOffset) {
	                                // This will show either the currently placed position or the last
	                                // successfully placed position (so you can visualize what collision
	                                // just made the symbol disappear, and the most likely place for the
	                                // symbol to come back)
	                                shift = calculateVariableLayoutShift(variableOffset.anchor, variableOffset.width, variableOffset.height, variableOffset.textOffset, variableOffset.textBoxScale);
	                                if (rotateWithMap) {
	                                    shift._rotate(pitchWithMap ? this.transform.angle : -this.transform.angle);
	                                }
	                            }
	                            else {
	                                // No offset -> this symbol hasn't been placed since coming on-screen
	                                // No single box is particularly meaningful and all of them would be too noisy
	                                // Use the center box just to show something's there, but mark it "not used"
	                                used = false;
	                            }
	                        }
	                        if (collisionArrays.textBox) {
	                            updateCollisionVertices(bucket.textCollisionBox.collisionVertexArray, opacityState.text.placed, !used || horizontalHidden, shift.x, shift.y);
	                        }
	                        if (collisionArrays.verticalTextBox) {
	                            updateCollisionVertices(bucket.textCollisionBox.collisionVertexArray, opacityState.text.placed, !used || verticalHidden, shift.x, shift.y);
	                        }
	                    }
	                    const verticalIconUsed = Boolean(!verticalHidden && collisionArrays.verticalIconBox);
	                    if (collisionArrays.iconBox) {
	                        updateCollisionVertices(bucket.iconCollisionBox.collisionVertexArray, opacityState.icon.placed, verticalIconUsed, hasIconTextFit ? shift.x : 0, hasIconTextFit ? shift.y : 0);
	                    }
	                    if (collisionArrays.verticalIconBox) {
	                        updateCollisionVertices(bucket.iconCollisionBox.collisionVertexArray, opacityState.icon.placed, !verticalIconUsed, hasIconTextFit ? shift.x : 0, hasIconTextFit ? shift.y : 0);
	                    }
	                }
	            }
	        }
	        bucket.sortFeatures(this.transform.angle);
	        if (this.retainedQueryData[bucket.bucketInstanceId]) {
	            this.retainedQueryData[bucket.bucketInstanceId].featureSortOrder = bucket.featureSortOrder;
	        }
	        if (bucket.hasTextData() && bucket.text.opacityVertexBuffer) {
	            bucket.text.opacityVertexBuffer.updateData(bucket.text.opacityVertexArray);
	        }
	        if (bucket.hasIconData() && bucket.icon.opacityVertexBuffer) {
	            bucket.icon.opacityVertexBuffer.updateData(bucket.icon.opacityVertexArray);
	        }
	        if (bucket.hasIconCollisionBoxData() && bucket.iconCollisionBox.collisionVertexBuffer) {
	            bucket.iconCollisionBox.collisionVertexBuffer.updateData(bucket.iconCollisionBox.collisionVertexArray);
	        }
	        if (bucket.hasTextCollisionBoxData() && bucket.textCollisionBox.collisionVertexBuffer) {
	            bucket.textCollisionBox.collisionVertexBuffer.updateData(bucket.textCollisionBox.collisionVertexArray);
	        }
	        if (bucket.text.opacityVertexArray.length !== bucket.text.layoutVertexArray.length / 4)
	            throw new Error(`bucket.text.opacityVertexArray.length (= ${bucket.text.opacityVertexArray.length}) !== bucket.text.layoutVertexArray.length (= ${bucket.text.layoutVertexArray.length}) / 4`);
	        if (bucket.icon.opacityVertexArray.length !== bucket.icon.layoutVertexArray.length / 4)
	            throw new Error(`bucket.icon.opacityVertexArray.length (= ${bucket.icon.opacityVertexArray.length}) !== bucket.icon.layoutVertexArray.length (= ${bucket.icon.layoutVertexArray.length}) / 4`);
	        // Push generated collision circles to the bucket for debug rendering
	        if (bucket.bucketInstanceId in this.collisionCircleArrays) {
	            const instance = this.collisionCircleArrays[bucket.bucketInstanceId];
	            bucket.placementInvProjMatrix = instance.invProjMatrix;
	            bucket.placementViewportMatrix = instance.viewportMatrix;
	            bucket.collisionCircleArray = instance.circles;
	            delete this.collisionCircleArrays[bucket.bucketInstanceId];
	        }
	    }
	    symbolFadeChange(now) {
	        return this.fadeDuration === 0 ?
	            1 :
	            ((now - this.commitTime) / this.fadeDuration + this.prevZoomAdjustment);
	    }
	    zoomAdjustment(zoom) {
	        // When zooming out quickly, labels can overlap each other. This
	        // adjustment is used to reduce the interval between placement calculations
	        // and to reduce the fade duration when zooming out quickly. Discovering the
	        // collisions more quickly and fading them more quickly reduces the unwanted effect.
	        return Math.max(0, (this.transform.zoom - zoom) / 1.5);
	    }
	    hasTransitions(now) {
	        return this.stale ||
	            now - this.lastPlacementChangeTime < this.fadeDuration;
	    }
	    stillRecent(now, zoom) {
	        // The adjustment makes placement more frequent when zooming.
	        // This condition applies the adjustment only after the map has
	        // stopped zooming. This avoids adding extra jank while zooming.
	        const durationAdjustment = this.zoomAtLastRecencyCheck === zoom ?
	            (1 - this.zoomAdjustment(zoom)) :
	            1;
	        this.zoomAtLastRecencyCheck = zoom;
	        return this.commitTime + this.fadeDuration * durationAdjustment > now;
	    }
	    setStale() {
	        this.stale = true;
	    }
	}
	function updateCollisionVertices(collisionVertexArray, placed, notUsed, shiftX, shiftY) {
	    collisionVertexArray.emplaceBack(placed ? 1 : 0, notUsed ? 1 : 0, shiftX || 0, shiftY || 0);
	    collisionVertexArray.emplaceBack(placed ? 1 : 0, notUsed ? 1 : 0, shiftX || 0, shiftY || 0);
	    collisionVertexArray.emplaceBack(placed ? 1 : 0, notUsed ? 1 : 0, shiftX || 0, shiftY || 0);
	    collisionVertexArray.emplaceBack(placed ? 1 : 0, notUsed ? 1 : 0, shiftX || 0, shiftY || 0);
	}
	// All four vertices for a glyph will have the same opacity state
	// So we pack the opacity into a uint8, and then repeat it four times
	// to make a single uint32 that we can upload for each glyph in the
	// label.
	const shift25 = Math.pow(2, 25);
	const shift24 = Math.pow(2, 24);
	const shift17 = Math.pow(2, 17);
	const shift16 = Math.pow(2, 16);
	const shift9 = Math.pow(2, 9);
	const shift8 = Math.pow(2, 8);
	const shift1 = Math.pow(2, 1);
	function packOpacity(opacityState) {
	    if (opacityState.opacity === 0 && !opacityState.placed) {
	        return 0;
	    }
	    else if (opacityState.opacity === 1 && opacityState.placed) {
	        return 4294967295;
	    }
	    const targetBit = opacityState.placed ? 1 : 0;
	    const opacityBits = Math.floor(opacityState.opacity * 127);
	    return opacityBits * shift25 + targetBit * shift24 +
	        opacityBits * shift17 + targetBit * shift16 +
	        opacityBits * shift9 + targetBit * shift8 +
	        opacityBits * shift1 + targetBit;
	}
	const PACKED_HIDDEN_OPACITY = 0;

	class LayerPlacement {
	    constructor(styleLayer) {
	        this._sortAcrossTiles = styleLayer.layout.get('symbol-z-order') !== 'viewport-y' &&
	            !styleLayer.layout.get('symbol-sort-key').isConstant();
	        this._currentTileIndex = 0;
	        this._currentPartIndex = 0;
	        this._seenCrossTileIDs = {};
	        this._bucketParts = [];
	    }
	    continuePlacement(tiles, placement, showCollisionBoxes, styleLayer, shouldPausePlacement) {
	        const bucketParts = this._bucketParts;
	        while (this._currentTileIndex < tiles.length) {
	            const tile = tiles[this._currentTileIndex];
	            placement.getBucketParts(bucketParts, styleLayer, tile, this._sortAcrossTiles);
	            this._currentTileIndex++;
	            if (shouldPausePlacement()) {
	                return true;
	            }
	        }
	        if (this._sortAcrossTiles) {
	            this._sortAcrossTiles = false;
	            bucketParts.sort((a, b) => a.sortKey - b.sortKey);
	        }
	        while (this._currentPartIndex < bucketParts.length) {
	            const bucketPart = bucketParts[this._currentPartIndex];
	            placement.placeLayerBucketPart(bucketPart, this._seenCrossTileIDs, showCollisionBoxes);
	            this._currentPartIndex++;
	            if (shouldPausePlacement()) {
	                return true;
	            }
	        }
	        return false;
	    }
	}
	class PauseablePlacement {
	    constructor(transform, terrain, order, forceFullPlacement, showCollisionBoxes, fadeDuration, crossSourceCollisions, prevPlacement) {
	        this.placement = new Placement(transform, terrain, fadeDuration, crossSourceCollisions, prevPlacement);
	        this._currentPlacementIndex = order.length - 1;
	        this._forceFullPlacement = forceFullPlacement;
	        this._showCollisionBoxes = showCollisionBoxes;
	        this._done = false;
	    }
	    isDone() {
	        return this._done;
	    }
	    continuePlacement(order, layers, layerTiles) {
	        const startTime = browser.now();
	        const shouldPausePlacement = () => {
	            return this._forceFullPlacement ? false : (browser.now() - startTime) > 2;
	        };
	        while (this._currentPlacementIndex >= 0) {
	            const layerId = order[this._currentPlacementIndex];
	            const layer = layers[layerId];
	            const placementZoom = this.placement.collisionIndex.transform.zoom;
	            if (layer.type === 'symbol' &&
	                (!layer.minzoom || layer.minzoom <= placementZoom) &&
	                (!layer.maxzoom || layer.maxzoom > placementZoom)) {
	                if (!this._inProgressLayer) {
	                    this._inProgressLayer = new LayerPlacement(layer);
	                }
	                const pausePlacement = this._inProgressLayer.continuePlacement(layerTiles[layer.source], this.placement, this._showCollisionBoxes, layer, shouldPausePlacement);
	                if (pausePlacement) {
	                    // We didn't finish placing all layers within 2ms,
	                    // but we can keep rendering with a partial placement
	                    // We'll resume here on the next frame
	                    return;
	                }
	                delete this._inProgressLayer;
	            }
	            this._currentPlacementIndex--;
	        }
	        this._done = true;
	    }
	    commit(now) {
	        this.placement.commit(now);
	        return this.placement;
	    }
	}

	/*
	    The CrossTileSymbolIndex generally works on the assumption that
	    a conceptual "unique symbol" can be identified by the text of
	    the label combined with the anchor point. The goal is to assign
	    these conceptual "unique symbols" a shared crossTileID that can be
	    used by Placement to keep fading opacity states consistent and to
	    deduplicate labels.

	    The CrossTileSymbolIndex indexes all the current symbol instances and
	    their crossTileIDs. When a symbol bucket gets added or updated, the
	    index assigns a crossTileID to each of it's symbol instances by either
	    matching it with an existing id or assigning a new one.
	*/
	// Round anchor positions to roughly 4 pixel grid
	const roundingFactor = 512 / performance$1.EXTENT / 2;
	const KDBUSH_THRESHHOLD = 128;
	class TileLayerIndex {
	    constructor(tileID, symbolInstances, bucketInstanceId) {
	        this.tileID = tileID;
	        this.bucketInstanceId = bucketInstanceId;
	        this._symbolsByKey = {};
	        // group the symbolInstances by key
	        const symbolInstancesByKey = new Map();
	        for (let i = 0; i < symbolInstances.length; i++) {
	            const symbolInstance = symbolInstances.get(i);
	            const key = symbolInstance.key;
	            const instances = symbolInstancesByKey.get(key);
	            if (instances) {
	                // This tile may have multiple symbol instances with the same key
	                // Store each one along with its coordinates
	                instances.push(symbolInstance);
	            }
	            else {
	                symbolInstancesByKey.set(key, [symbolInstance]);
	            }
	        }
	        // index the SymbolInstances in this each bucket
	        for (const [key, symbols] of symbolInstancesByKey) {
	            const positions = symbols.map(symbolInstance => ({ x: Math.floor(symbolInstance.anchorX * roundingFactor), y: Math.floor(symbolInstance.anchorY * roundingFactor) }));
	            const crossTileIDs = symbols.map(v => v.crossTileID);
	            const entry = { positions, crossTileIDs };
	            // once we get too many symbols for a given key, it becomes much faster to index it before queries
	            if (entry.positions.length > KDBUSH_THRESHHOLD) {
	                const index = new performance$1.KDBush(entry.positions.length, 16, Uint16Array);
	                for (const { x, y } of entry.positions)
	                    index.add(x, y);
	                index.finish();
	                // clear all references to the original positions data
	                delete entry.positions;
	                entry.index = index;
	            }
	            this._symbolsByKey[key] = entry;
	        }
	    }
	    // Converts the coordinates of the input symbol instance into coordinates that be can compared
	    // against other symbols in this index. Coordinates are:
	    // (1) local-tile-based (so after correction we get x,y values relative to our local anchorX/Y)
	    // (2) converted to the z-scale of this TileLayerIndex
	    // (3) down-sampled by "roundingFactor" from tile coordinate precision in order to be
	    //     more tolerant of small differences between tiles.
	    getScaledCoordinates(symbolInstance, childTileID) {
	        const { x: localX, y: localY, z: localZ } = this.tileID.canonical;
	        const { x, y, z } = childTileID.canonical;
	        const zDifference = z - localZ;
	        const scale = roundingFactor / Math.pow(2, zDifference);
	        const xWorld = (x * performance$1.EXTENT + symbolInstance.anchorX) * scale;
	        const yWorld = (y * performance$1.EXTENT + symbolInstance.anchorY) * scale;
	        const xOffset = localX * performance$1.EXTENT * roundingFactor;
	        const yOffset = localY * performance$1.EXTENT * roundingFactor;
	        const result = {
	            x: Math.floor(xWorld - xOffset),
	            y: Math.floor(yWorld - yOffset)
	        };
	        return result;
	    }
	    findMatches(symbolInstances, newTileID, zoomCrossTileIDs) {
	        const tolerance = this.tileID.canonical.z < newTileID.canonical.z ? 1 : Math.pow(2, this.tileID.canonical.z - newTileID.canonical.z);
	        for (let i = 0; i < symbolInstances.length; i++) {
	            const symbolInstance = symbolInstances.get(i);
	            if (symbolInstance.crossTileID) {
	                // already has a match, skip
	                continue;
	            }
	            const entry = this._symbolsByKey[symbolInstance.key];
	            if (!entry) {
	                // No symbol with this key in this bucket
	                continue;
	            }
	            const scaledSymbolCoord = this.getScaledCoordinates(symbolInstance, newTileID);
	            if (entry.index) {
	                // Return any symbol with the same keys whose coordinates are within 1
	                // grid unit. (with a 4px grid, this covers a 12px by 12px area)
	                const indexes = entry.index.range(scaledSymbolCoord.x - tolerance, scaledSymbolCoord.y - tolerance, scaledSymbolCoord.x + tolerance, scaledSymbolCoord.y + tolerance).sort();
	                for (const i of indexes) {
	                    const crossTileID = entry.crossTileIDs[i];
	                    if (!zoomCrossTileIDs[crossTileID]) {
	                        // Once we've marked ourselves duplicate against this parent symbol,
	                        // don't let any other symbols at the same zoom level duplicate against
	                        // the same parent (see issue #5993)
	                        zoomCrossTileIDs[crossTileID] = true;
	                        symbolInstance.crossTileID = crossTileID;
	                        break;
	                    }
	                }
	            }
	            else if (entry.positions) {
	                for (let i = 0; i < entry.positions.length; i++) {
	                    const thisTileSymbol = entry.positions[i];
	                    const crossTileID = entry.crossTileIDs[i];
	                    // Return any symbol with the same keys whose coordinates are within 1
	                    // grid unit. (with a 4px grid, this covers a 12px by 12px area)
	                    if (Math.abs(thisTileSymbol.x - scaledSymbolCoord.x) <= tolerance &&
	                        Math.abs(thisTileSymbol.y - scaledSymbolCoord.y) <= tolerance &&
	                        !zoomCrossTileIDs[crossTileID]) {
	                        // Once we've marked ourselves duplicate against this parent symbol,
	                        // don't let any other symbols at the same zoom level duplicate against
	                        // the same parent (see issue #5993)
	                        zoomCrossTileIDs[crossTileID] = true;
	                        symbolInstance.crossTileID = crossTileID;
	                        break;
	                    }
	                }
	            }
	        }
	    }
	    getCrossTileIDsLists() {
	        return Object.values(this._symbolsByKey).map(({ crossTileIDs }) => crossTileIDs);
	    }
	}
	class CrossTileIDs {
	    constructor() {
	        this.maxCrossTileID = 0;
	    }
	    generate() {
	        return ++this.maxCrossTileID;
	    }
	}
	class CrossTileSymbolLayerIndex {
	    constructor() {
	        this.indexes = {};
	        this.usedCrossTileIDs = {};
	        this.lng = 0;
	    }
	    /*
	     * Sometimes when a user pans across the antimeridian the longitude value gets wrapped.
	     * To prevent labels from flashing out and in we adjust the tileID values in the indexes
	     * so that they match the new wrapped version of the map.
	     */
	    handleWrapJump(lng) {
	        const wrapDelta = Math.round((lng - this.lng) / 360);
	        if (wrapDelta !== 0) {
	            for (const zoom in this.indexes) {
	                const zoomIndexes = this.indexes[zoom];
	                const newZoomIndex = {};
	                for (const key in zoomIndexes) {
	                    // change the tileID's wrap and add it to a new index
	                    const index = zoomIndexes[key];
	                    index.tileID = index.tileID.unwrapTo(index.tileID.wrap + wrapDelta);
	                    newZoomIndex[index.tileID.key] = index;
	                }
	                this.indexes[zoom] = newZoomIndex;
	            }
	        }
	        this.lng = lng;
	    }
	    addBucket(tileID, bucket, crossTileIDs) {
	        if (this.indexes[tileID.overscaledZ] &&
	            this.indexes[tileID.overscaledZ][tileID.key]) {
	            if (this.indexes[tileID.overscaledZ][tileID.key].bucketInstanceId ===
	                bucket.bucketInstanceId) {
	                return false;
	            }
	            else {
	                // We're replacing this bucket with an updated version
	                // Remove the old bucket's "used crossTileIDs" now so that
	                // the new bucket can claim them.
	                // The old index entries themselves stick around until
	                // 'removeStaleBuckets' is called.
	                this.removeBucketCrossTileIDs(tileID.overscaledZ, this.indexes[tileID.overscaledZ][tileID.key]);
	            }
	        }
	        for (let i = 0; i < bucket.symbolInstances.length; i++) {
	            const symbolInstance = bucket.symbolInstances.get(i);
	            symbolInstance.crossTileID = 0;
	        }
	        if (!this.usedCrossTileIDs[tileID.overscaledZ]) {
	            this.usedCrossTileIDs[tileID.overscaledZ] = {};
	        }
	        const zoomCrossTileIDs = this.usedCrossTileIDs[tileID.overscaledZ];
	        for (const zoom in this.indexes) {
	            const zoomIndexes = this.indexes[zoom];
	            if (Number(zoom) > tileID.overscaledZ) {
	                for (const id in zoomIndexes) {
	                    const childIndex = zoomIndexes[id];
	                    if (childIndex.tileID.isChildOf(tileID)) {
	                        childIndex.findMatches(bucket.symbolInstances, tileID, zoomCrossTileIDs);
	                    }
	                }
	            }
	            else {
	                const parentCoord = tileID.scaledTo(Number(zoom));
	                const parentIndex = zoomIndexes[parentCoord.key];
	                if (parentIndex) {
	                    parentIndex.findMatches(bucket.symbolInstances, tileID, zoomCrossTileIDs);
	                }
	            }
	        }
	        for (let i = 0; i < bucket.symbolInstances.length; i++) {
	            const symbolInstance = bucket.symbolInstances.get(i);
	            if (!symbolInstance.crossTileID) {
	                // symbol did not match any known symbol, assign a new id
	                symbolInstance.crossTileID = crossTileIDs.generate();
	                zoomCrossTileIDs[symbolInstance.crossTileID] = true;
	            }
	        }
	        if (this.indexes[tileID.overscaledZ] === undefined) {
	            this.indexes[tileID.overscaledZ] = {};
	        }
	        this.indexes[tileID.overscaledZ][tileID.key] = new TileLayerIndex(tileID, bucket.symbolInstances, bucket.bucketInstanceId);
	        return true;
	    }
	    removeBucketCrossTileIDs(zoom, removedBucket) {
	        for (const crossTileIDs of removedBucket.getCrossTileIDsLists()) {
	            for (const crossTileID of crossTileIDs) {
	                delete this.usedCrossTileIDs[zoom][crossTileID];
	            }
	        }
	    }
	    removeStaleBuckets(currentIDs) {
	        let tilesChanged = false;
	        for (const z in this.indexes) {
	            const zoomIndexes = this.indexes[z];
	            for (const tileKey in zoomIndexes) {
	                if (!currentIDs[zoomIndexes[tileKey].bucketInstanceId]) {
	                    this.removeBucketCrossTileIDs(z, zoomIndexes[tileKey]);
	                    delete zoomIndexes[tileKey];
	                    tilesChanged = true;
	                }
	            }
	        }
	        return tilesChanged;
	    }
	}
	class CrossTileSymbolIndex {
	    constructor() {
	        this.layerIndexes = {};
	        this.crossTileIDs = new CrossTileIDs();
	        this.maxBucketInstanceId = 0;
	        this.bucketsInCurrentPlacement = {};
	    }
	    addLayer(styleLayer, tiles, lng) {
	        let layerIndex = this.layerIndexes[styleLayer.id];
	        if (layerIndex === undefined) {
	            layerIndex = this.layerIndexes[styleLayer.id] = new CrossTileSymbolLayerIndex();
	        }
	        let symbolBucketsChanged = false;
	        const currentBucketIDs = {};
	        layerIndex.handleWrapJump(lng);
	        for (const tile of tiles) {
	            const symbolBucket = tile.getBucket(styleLayer);
	            if (!symbolBucket || styleLayer.id !== symbolBucket.layerIds[0])
	                continue;
	            if (!symbolBucket.bucketInstanceId) {
	                symbolBucket.bucketInstanceId = ++this.maxBucketInstanceId;
	            }
	            if (layerIndex.addBucket(tile.tileID, symbolBucket, this.crossTileIDs)) {
	                symbolBucketsChanged = true;
	            }
	            currentBucketIDs[symbolBucket.bucketInstanceId] = true;
	        }
	        if (layerIndex.removeStaleBuckets(currentBucketIDs)) {
	            symbolBucketsChanged = true;
	        }
	        return symbolBucketsChanged;
	    }
	    pruneUnusedLayers(usedLayers) {
	        const usedLayerMap = {};
	        usedLayers.forEach((usedLayer) => {
	            usedLayerMap[usedLayer] = true;
	        });
	        for (const layerId in this.layerIndexes) {
	            if (!usedLayerMap[layerId]) {
	                delete this.layerIndexes[layerId];
	            }
	        }
	    }
	}

	// We're skipping validation errors with the `source.canvas` identifier in order
	// to continue to allow canvas sources to be added at runtime/updated in
	// smart setStyle (see https://github.com/mapbox/mapbox-gl-js/pull/6424):
	const emitValidationErrors = (evented, errors) => performance$1.emitValidationErrors(evented, errors && errors.filter(error => error.identifier !== 'source.canvas'));
	const empty = performance$1.emptyStyle();
	/**
	 * The Style base class
	 */
	class Style extends performance$1.Evented {
	    constructor(map, options = {}) {
	        super();
	        this._rtlPluginLoaded = () => {
	            for (const id in this.sourceCaches) {
	                const sourceType = this.sourceCaches[id].getSource().type;
	                if (sourceType === 'vector' || sourceType === 'geojson') {
	                    // Non-vector sources don't have any symbols buckets to reload when the RTL text plugin loads
	                    // They also load more quickly, so they're more likely to have already displaying tiles
	                    // that would be unnecessarily booted by the plugin load event
	                    this.sourceCaches[id].reload(); // Should be a no-op if the plugin loads before any tiles load
	                }
	            }
	        };
	        this.map = map;
	        this.dispatcher = new Dispatcher(getGlobalWorkerPool(), map._getMapId());
	        this.dispatcher.registerMessageHandler("GG" /* MessageType.getGlyphs */, (mapId, params) => {
	            return this.getGlyphs(mapId, params);
	        });
	        this.dispatcher.registerMessageHandler("GI" /* MessageType.getImages */, (mapId, params) => {
	            return this.getImages(mapId, params);
	        });
	        this.imageManager = new ImageManager();
	        this.imageManager.setEventedParent(this);
	        this.glyphManager = new GlyphManager(map._requestManager, options.localIdeographFontFamily);
	        this.lineAtlas = new LineAtlas(256, 512);
	        this.crossTileSymbolIndex = new CrossTileSymbolIndex();
	        this._spritesImagesIds = {};
	        this._layers = {};
	        this._order = [];
	        this.sourceCaches = {};
	        this.zoomHistory = new performance$1.ZoomHistory();
	        this._loaded = false;
	        this._availableImages = [];
	        this._resetUpdates();
	        this.dispatcher.broadcast("SR" /* MessageType.setReferrer */, performance$1.getReferrer());
	        rtlMainThreadPluginFactory().on(RTLPluginLoadedEventName, this._rtlPluginLoaded);
	        this.on('data', (event) => {
	            if (event.dataType !== 'source' || event.sourceDataType !== 'metadata') {
	                return;
	            }
	            const sourceCache = this.sourceCaches[event.sourceId];
	            if (!sourceCache) {
	                return;
	            }
	            const source = sourceCache.getSource();
	            if (!source || !source.vectorLayerIds) {
	                return;
	            }
	            for (const layerId in this._layers) {
	                const layer = this._layers[layerId];
	                if (layer.source === source.id) {
	                    this._validateLayer(layer);
	                }
	            }
	        });
	    }
	    loadURL(url, options = {}, previousStyle) {
	        this.fire(new performance$1.Event('dataloading', { dataType: 'style' }));
	        options.validate = typeof options.validate === 'boolean' ?
	            options.validate : true;
	        const request = this.map._requestManager.transformRequest(url, "Style" /* ResourceType.Style */);
	        this._loadStyleRequest = new AbortController();
	        performance$1.getJSON(request, this._loadStyleRequest).then((response) => {
	            this._loadStyleRequest = null;
	            this._load(response.data, options, previousStyle);
	        }).catch((error) => {
	            this._loadStyleRequest = null;
	            if (error) {
	                this.fire(new performance$1.ErrorEvent(error));
	            }
	        });
	    }
	    loadJSON(json, options = {}, previousStyle) {
	        this.fire(new performance$1.Event('dataloading', { dataType: 'style' }));
	        this._frameRequest = new AbortController();
	        browser.frameAsync(this._frameRequest).then(() => {
	            this._frameRequest = null;
	            options.validate = options.validate !== false;
	            this._load(json, options, previousStyle);
	        }).catch(() => { }); // ignore abort
	    }
	    loadEmpty() {
	        this.fire(new performance$1.Event('dataloading', { dataType: 'style' }));
	        this._load(empty, { validate: false });
	    }
	    _load(json, options, previousStyle) {
	        var _a;
	        const nextState = options.transformStyle ? options.transformStyle(previousStyle, json) : json;
	        if (options.validate && emitValidationErrors(this, performance$1.validateStyle(nextState))) {
	            return;
	        }
	        this._loaded = true;
	        this.stylesheet = nextState;
	        for (const id in nextState.sources) {
	            this.addSource(id, nextState.sources[id], { validate: false });
	        }
	        if (nextState.sprite) {
	            this._loadSprite(nextState.sprite);
	        }
	        else {
	            this.imageManager.setLoaded(true);
	        }
	        this.glyphManager.setURL(nextState.glyphs);
	        this._createLayers();
	        this.light = new Light(this.stylesheet.light);
	        this.map.setTerrain((_a = this.stylesheet.terrain) !== null && _a !== void 0 ? _a : null);
	        this.fire(new performance$1.Event('data', { dataType: 'style' }));
	        this.fire(new performance$1.Event('style.load'));
	    }
	    _createLayers() {
	        const dereferencedLayers = performance$1.derefLayers(this.stylesheet.layers);
	        // Broadcast layers to workers first, so that expensive style processing (createStyleLayer)
	        // can happen in parallel on both main and worker threads.
	        this.dispatcher.broadcast("SL" /* MessageType.setLayers */, dereferencedLayers);
	        this._order = dereferencedLayers.map((layer) => layer.id);
	        this._layers = {};
	        // reset serialization field, to be populated only when needed
	        this._serializedLayers = null;
	        for (const layer of dereferencedLayers) {
	            const styledLayer = performance$1.createStyleLayer(layer);
	            styledLayer.setEventedParent(this, { layer: { id: layer.id } });
	            this._layers[layer.id] = styledLayer;
	        }
	    }
	    _loadSprite(sprite, isUpdate = false, completion = undefined) {
	        this.imageManager.setLoaded(false);
	        this._spriteRequest = new AbortController();
	        let err;
	        loadSprite(sprite, this.map._requestManager, this.map.getPixelRatio(), this._spriteRequest).then((images) => {
	            this._spriteRequest = null;
	            if (images) {
	                for (const spriteId in images) {
	                    this._spritesImagesIds[spriteId] = [];
	                    // remove old sprite's loaded images (for the same sprite id) that are not in new sprite
	                    const imagesToRemove = this._spritesImagesIds[spriteId] ? this._spritesImagesIds[spriteId].filter(id => !(id in images)) : [];
	                    for (const id of imagesToRemove) {
	                        this.imageManager.removeImage(id);
	                        this._changedImages[id] = true;
	                    }
	                    for (const id in images[spriteId]) {
	                        // don't prefix images of the "default" sprite
	                        const imageId = spriteId === 'default' ? id : `${spriteId}:${id}`;
	                        // save all the sprite's images' ids to be able to delete them in `removeSprite`
	                        this._spritesImagesIds[spriteId].push(imageId);
	                        if (imageId in this.imageManager.images) {
	                            this.imageManager.updateImage(imageId, images[spriteId][id], false);
	                        }
	                        else {
	                            this.imageManager.addImage(imageId, images[spriteId][id]);
	                        }
	                        if (isUpdate) {
	                            this._changedImages[imageId] = true;
	                        }
	                    }
	                }
	            }
	        }).catch((error) => {
	            this._spriteRequest = null;
	            err = error;
	            this.fire(new performance$1.ErrorEvent(err));
	        }).finally(() => {
	            this.imageManager.setLoaded(true);
	            this._availableImages = this.imageManager.listImages();
	            if (isUpdate) {
	                this._changed = true;
	            }
	            this.dispatcher.broadcast("SI" /* MessageType.setImages */, this._availableImages);
	            this.fire(new performance$1.Event('data', { dataType: 'style' }));
	            if (completion) {
	                completion(err);
	            }
	        });
	    }
	    _unloadSprite() {
	        for (const id of Object.values(this._spritesImagesIds).flat()) {
	            this.imageManager.removeImage(id);
	            this._changedImages[id] = true;
	        }
	        this._spritesImagesIds = {};
	        this._availableImages = this.imageManager.listImages();
	        this._changed = true;
	        this.dispatcher.broadcast("SI" /* MessageType.setImages */, this._availableImages);
	        this.fire(new performance$1.Event('data', { dataType: 'style' }));
	    }
	    _validateLayer(layer) {
	        const sourceCache = this.sourceCaches[layer.source];
	        if (!sourceCache) {
	            return;
	        }
	        const sourceLayer = layer.sourceLayer;
	        if (!sourceLayer) {
	            return;
	        }
	        const source = sourceCache.getSource();
	        if (source.type === 'geojson' || (source.vectorLayerIds && source.vectorLayerIds.indexOf(sourceLayer) === -1)) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Source layer "${sourceLayer}" ` +
	                `does not exist on source "${source.id}" ` +
	                `as specified by style layer "${layer.id}".`)));
	        }
	    }
	    loaded() {
	        if (!this._loaded)
	            return false;
	        if (Object.keys(this._updatedSources).length)
	            return false;
	        for (const id in this.sourceCaches)
	            if (!this.sourceCaches[id].loaded())
	                return false;
	        if (!this.imageManager.isLoaded())
	            return false;
	        return true;
	    }
	    /**
	     * take an array of string IDs, and based on this._layers, generate an array of LayerSpecification
	     * @param ids - an array of string IDs, for which serialized layers will be generated. If omitted, all serialized layers will be returned
	     * @returns generated result
	     */
	    _serializeByIds(ids) {
	        const serializedLayersDictionary = this._serializedAllLayers();
	        if (!ids || ids.length === 0) {
	            return Object.values(serializedLayersDictionary);
	        }
	        const serializedLayers = [];
	        for (const id of ids) {
	            // this check will skip all custom layers
	            if (serializedLayersDictionary[id]) {
	                serializedLayers.push(serializedLayersDictionary[id]);
	            }
	        }
	        return serializedLayers;
	    }
	    /**
	     * Lazy initialization of this._serializedLayers dictionary and return it
	     * @returns this._serializedLayers dictionary
	     */
	    _serializedAllLayers() {
	        let serializedLayers = this._serializedLayers;
	        if (serializedLayers) {
	            return serializedLayers;
	        }
	        serializedLayers = this._serializedLayers = {};
	        const allLayerIds = Object.keys(this._layers);
	        for (const layerId of allLayerIds) {
	            const layer = this._layers[layerId];
	            if (layer.type !== 'custom') {
	                serializedLayers[layerId] = layer.serialize();
	            }
	        }
	        return serializedLayers;
	    }
	    hasTransitions() {
	        if (this.light && this.light.hasTransition()) {
	            return true;
	        }
	        for (const id in this.sourceCaches) {
	            if (this.sourceCaches[id].hasTransition()) {
	                return true;
	            }
	        }
	        for (const id in this._layers) {
	            if (this._layers[id].hasTransition()) {
	                return true;
	            }
	        }
	        return false;
	    }
	    _checkLoaded() {
	        if (!this._loaded) {
	            throw new Error('Style is not done loading.');
	        }
	    }
	    /**
	     * @internal
	     * Apply queued style updates in a batch and recalculate zoom-dependent paint properties.
	     */
	    update(parameters) {
	        if (!this._loaded) {
	            return;
	        }
	        const changed = this._changed;
	        if (this._changed) {
	            const updatedIds = Object.keys(this._updatedLayers);
	            const removedIds = Object.keys(this._removedLayers);
	            if (updatedIds.length || removedIds.length) {
	                this._updateWorkerLayers(updatedIds, removedIds);
	            }
	            for (const id in this._updatedSources) {
	                const action = this._updatedSources[id];
	                if (action === 'reload') {
	                    this._reloadSource(id);
	                }
	                else if (action === 'clear') {
	                    this._clearSource(id);
	                }
	                else {
	                    throw new Error(`Invalid action ${action}`);
	                }
	            }
	            this._updateTilesForChangedImages();
	            this._updateTilesForChangedGlyphs();
	            for (const id in this._updatedPaintProps) {
	                this._layers[id].updateTransitions(parameters);
	            }
	            this.light.updateTransitions(parameters);
	            this._resetUpdates();
	        }
	        const sourcesUsedBefore = {};
	        for (const sourceId in this.sourceCaches) {
	            const sourceCache = this.sourceCaches[sourceId];
	            sourcesUsedBefore[sourceId] = sourceCache.used;
	            sourceCache.used = false;
	        }
	        for (const layerId of this._order) {
	            const layer = this._layers[layerId];
	            layer.recalculate(parameters, this._availableImages);
	            if (!layer.isHidden(parameters.zoom) && layer.source) {
	                this.sourceCaches[layer.source].used = true;
	            }
	        }
	        for (const sourceId in sourcesUsedBefore) {
	            const sourceCache = this.sourceCaches[sourceId];
	            if (sourcesUsedBefore[sourceId] !== sourceCache.used) {
	                sourceCache.fire(new performance$1.Event('data', { sourceDataType: 'visibility', dataType: 'source', sourceId }));
	            }
	        }
	        this.light.recalculate(parameters);
	        this.z = parameters.zoom;
	        if (changed) {
	            this.fire(new performance$1.Event('data', { dataType: 'style' }));
	        }
	    }
	    /*
	     * Apply any queued image changes.
	     */
	    _updateTilesForChangedImages() {
	        const changedImages = Object.keys(this._changedImages);
	        if (changedImages.length) {
	            for (const name in this.sourceCaches) {
	                this.sourceCaches[name].reloadTilesForDependencies(['icons', 'patterns'], changedImages);
	            }
	            this._changedImages = {};
	        }
	    }
	    _updateTilesForChangedGlyphs() {
	        if (this._glyphsDidChange) {
	            for (const name in this.sourceCaches) {
	                this.sourceCaches[name].reloadTilesForDependencies(['glyphs'], ['']);
	            }
	            this._glyphsDidChange = false;
	        }
	    }
	    _updateWorkerLayers(updatedIds, removedIds) {
	        this.dispatcher.broadcast("UL" /* MessageType.updateLayers */, {
	            layers: this._serializeByIds(updatedIds),
	            removedIds
	        });
	    }
	    _resetUpdates() {
	        this._changed = false;
	        this._updatedLayers = {};
	        this._removedLayers = {};
	        this._updatedSources = {};
	        this._updatedPaintProps = {};
	        this._changedImages = {};
	        this._glyphsDidChange = false;
	    }
	    /**
	     * Update this style's state to match the given style JSON, performing only
	     * the necessary mutations.
	     *
	     * May throw an Error ('Unimplemented: METHOD') if the mapbox-gl-style-spec
	     * diff algorithm produces an operation that is not supported.
	     *
	     * @returns true if any changes were made; false otherwise
	     */
	    setState(nextState, options = {}) {
	        var _a;
	        this._checkLoaded();
	        const serializedStyle = this.serialize();
	        nextState = options.transformStyle ? options.transformStyle(serializedStyle, nextState) : nextState;
	        const validate = (_a = options.validate) !== null && _a !== void 0 ? _a : true;
	        if (validate && emitValidationErrors(this, performance$1.validateStyle(nextState)))
	            return false;
	        nextState = performance$1.clone$1(nextState);
	        nextState.layers = performance$1.derefLayers(nextState.layers);
	        const changes = performance$1.diffStyles(serializedStyle, nextState);
	        const operations = this._getOperationsToPerform(changes);
	        if (operations.unimplemented.length > 0) {
	            throw new Error(`Unimplemented: ${operations.unimplemented.join(', ')}.`);
	        }
	        if (operations.operations.length === 0) {
	            return false;
	        }
	        for (const styleChangeOperation of operations.operations) {
	            styleChangeOperation();
	        }
	        this.stylesheet = nextState;
	        // reset serialization field, to be populated only when needed
	        this._serializedLayers = null;
	        return true;
	    }
	    _getOperationsToPerform(diff) {
	        const operations = [];
	        const unimplemented = [];
	        for (const op of diff) {
	            switch (op.command) {
	                case 'setCenter':
	                case 'setZoom':
	                case 'setBearing':
	                case 'setPitch':
	                    continue;
	                case 'addLayer':
	                    operations.push(() => this.addLayer.apply(this, op.args));
	                    break;
	                case 'removeLayer':
	                    operations.push(() => this.removeLayer.apply(this, op.args));
	                    break;
	                case 'setPaintProperty':
	                    operations.push(() => this.setPaintProperty.apply(this, op.args));
	                    break;
	                case 'setLayoutProperty':
	                    operations.push(() => this.setLayoutProperty.apply(this, op.args));
	                    break;
	                case 'setFilter':
	                    operations.push(() => this.setFilter.apply(this, op.args));
	                    break;
	                case 'addSource':
	                    operations.push(() => this.addSource.apply(this, op.args));
	                    break;
	                case 'removeSource':
	                    operations.push(() => this.removeSource.apply(this, op.args));
	                    break;
	                case 'setLayerZoomRange':
	                    operations.push(() => this.setLayerZoomRange.apply(this, op.args));
	                    break;
	                case 'setLight':
	                    operations.push(() => this.setLight.apply(this, op.args));
	                    break;
	                case 'setGeoJSONSourceData':
	                    operations.push(() => this.setGeoJSONSourceData.apply(this, op.args));
	                    break;
	                case 'setGlyphs':
	                    operations.push(() => this.setGlyphs.apply(this, op.args));
	                    break;
	                case 'setSprite':
	                    operations.push(() => this.setSprite.apply(this, op.args));
	                    break;
	                case 'setTerrain':
	                    operations.push(() => this.map.setTerrain.apply(this, op.args));
	                    break;
	                case 'setTransition':
	                    operations.push(() => { });
	                    break;
	                default:
	                    unimplemented.push(op.command);
	                    break;
	            }
	        }
	        return {
	            operations,
	            unimplemented
	        };
	    }
	    addImage(id, image) {
	        if (this.getImage(id)) {
	            return this.fire(new performance$1.ErrorEvent(new Error(`An image named "${id}" already exists.`)));
	        }
	        this.imageManager.addImage(id, image);
	        this._afterImageUpdated(id);
	    }
	    updateImage(id, image) {
	        this.imageManager.updateImage(id, image);
	    }
	    getImage(id) {
	        return this.imageManager.getImage(id);
	    }
	    removeImage(id) {
	        if (!this.getImage(id)) {
	            return this.fire(new performance$1.ErrorEvent(new Error(`An image named "${id}" does not exist.`)));
	        }
	        this.imageManager.removeImage(id);
	        this._afterImageUpdated(id);
	    }
	    _afterImageUpdated(id) {
	        this._availableImages = this.imageManager.listImages();
	        this._changedImages[id] = true;
	        this._changed = true;
	        this.dispatcher.broadcast("SI" /* MessageType.setImages */, this._availableImages);
	        this.fire(new performance$1.Event('data', { dataType: 'style' }));
	    }
	    listImages() {
	        this._checkLoaded();
	        return this.imageManager.listImages();
	    }
	    addSource(id, source, options = {}) {
	        this._checkLoaded();
	        if (this.sourceCaches[id] !== undefined) {
	            throw new Error(`Source "${id}" already exists.`);
	        }
	        if (!source.type) {
	            throw new Error(`The type property must be defined, but only the following properties were given: ${Object.keys(source).join(', ')}.`);
	        }
	        const builtIns = ['vector', 'raster', 'geojson', 'video', 'image'];
	        const shouldValidate = builtIns.indexOf(source.type) >= 0;
	        if (shouldValidate && this._validate(performance$1.validateStyle.source, `sources.${id}`, source, null, options))
	            return;
	        if (this.map && this.map._collectResourceTiming)
	            source.collectResourceTiming = true;
	        const sourceCache = this.sourceCaches[id] = new SourceCache(id, source, this.dispatcher);
	        sourceCache.style = this;
	        sourceCache.setEventedParent(this, () => ({
	            isSourceLoaded: sourceCache.loaded(),
	            source: sourceCache.serialize(),
	            sourceId: id
	        }));
	        sourceCache.onAdd(this.map);
	        this._changed = true;
	    }
	    /**
	     * Remove a source from this stylesheet, given its id.
	     * @param id - id of the source to remove
	     * @throws if no source is found with the given ID
	     * @returns `this`.
	     */
	    removeSource(id) {
	        this._checkLoaded();
	        if (this.sourceCaches[id] === undefined) {
	            throw new Error('There is no source with this ID');
	        }
	        for (const layerId in this._layers) {
	            if (this._layers[layerId].source === id) {
	                return this.fire(new performance$1.ErrorEvent(new Error(`Source "${id}" cannot be removed while layer "${layerId}" is using it.`)));
	            }
	        }
	        const sourceCache = this.sourceCaches[id];
	        delete this.sourceCaches[id];
	        delete this._updatedSources[id];
	        sourceCache.fire(new performance$1.Event('data', { sourceDataType: 'metadata', dataType: 'source', sourceId: id }));
	        sourceCache.setEventedParent(null);
	        sourceCache.onRemove(this.map);
	        this._changed = true;
	    }
	    /**
	     * Set the data of a GeoJSON source, given its id.
	     * @param id - id of the source
	     * @param data - GeoJSON source
	     */
	    setGeoJSONSourceData(id, data) {
	        this._checkLoaded();
	        if (this.sourceCaches[id] === undefined)
	            throw new Error(`There is no source with this ID=${id}`);
	        const geojsonSource = this.sourceCaches[id].getSource();
	        if (geojsonSource.type !== 'geojson')
	            throw new Error(`geojsonSource.type is ${geojsonSource.type}, which is !== 'geojson`);
	        geojsonSource.setData(data);
	        this._changed = true;
	    }
	    /**
	     * Get a source by ID.
	     * @param id - ID of the desired source
	     * @returns source
	     */
	    getSource(id) {
	        return this.sourceCaches[id] && this.sourceCaches[id].getSource();
	    }
	    /**
	     * Add a layer to the map style. The layer will be inserted before the layer with
	     * ID `before`, or appended if `before` is omitted.
	     * @param layerObject - The style layer to add.
	     * @param before - ID of an existing layer to insert before
	     * @param options - Style setter options.
	     * @returns `this`.
	     */
	    addLayer(layerObject, before, options = {}) {
	        this._checkLoaded();
	        const id = layerObject.id;
	        if (this.getLayer(id)) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Layer "${id}" already exists on this map.`)));
	            return;
	        }
	        let layer;
	        if (layerObject.type === 'custom') {
	            if (emitValidationErrors(this, performance$1.validateCustomStyleLayer(layerObject)))
	                return;
	            layer = performance$1.createStyleLayer(layerObject);
	        }
	        else {
	            if ('source' in layerObject && typeof layerObject.source === 'object') {
	                this.addSource(id, layerObject.source);
	                layerObject = performance$1.clone$1(layerObject);
	                layerObject = performance$1.extend(layerObject, { source: id });
	            }
	            // this layer is not in the style.layers array, so we pass an impossible array index
	            if (this._validate(performance$1.validateStyle.layer, `layers.${id}`, layerObject, { arrayIndex: -1 }, options))
	                return;
	            layer = performance$1.createStyleLayer(layerObject);
	            this._validateLayer(layer);
	            layer.setEventedParent(this, { layer: { id } });
	        }
	        const index = before ? this._order.indexOf(before) : this._order.length;
	        if (before && index === -1) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot add layer "${id}" before non-existing layer "${before}".`)));
	            return;
	        }
	        this._order.splice(index, 0, id);
	        this._layerOrderChanged = true;
	        this._layers[id] = layer;
	        if (this._removedLayers[id] && layer.source && layer.type !== 'custom') {
	            // If, in the current batch, we have already removed this layer
	            // and we are now re-adding it with a different `type`, then we
	            // need to clear (rather than just reload) the underlying source's
	            // tiles.  Otherwise, tiles marked 'reloading' will have buckets /
	            // buffers that are set up for the _previous_ version of this
	            // layer, causing, e.g.:
	            // https://github.com/mapbox/mapbox-gl-js/issues/3633
	            const removed = this._removedLayers[id];
	            delete this._removedLayers[id];
	            if (removed.type !== layer.type) {
	                this._updatedSources[layer.source] = 'clear';
	            }
	            else {
	                this._updatedSources[layer.source] = 'reload';
	                this.sourceCaches[layer.source].pause();
	            }
	        }
	        this._updateLayer(layer);
	        if (layer.onAdd) {
	            layer.onAdd(this.map);
	        }
	    }
	    /**
	     * Moves a layer to a different z-position. The layer will be inserted before the layer with
	     * ID `before`, or appended if `before` is omitted.
	     * @param id - ID of the layer to move
	     * @param before - ID of an existing layer to insert before
	     */
	    moveLayer(id, before) {
	        this._checkLoaded();
	        this._changed = true;
	        const layer = this._layers[id];
	        if (!layer) {
	            this.fire(new performance$1.ErrorEvent(new Error(`The layer '${id}' does not exist in the map's style and cannot be moved.`)));
	            return;
	        }
	        if (id === before) {
	            return;
	        }
	        const index = this._order.indexOf(id);
	        this._order.splice(index, 1);
	        const newIndex = before ? this._order.indexOf(before) : this._order.length;
	        if (before && newIndex === -1) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot move layer "${id}" before non-existing layer "${before}".`)));
	            return;
	        }
	        this._order.splice(newIndex, 0, id);
	        this._layerOrderChanged = true;
	    }
	    /**
	     * Remove the layer with the given id from the style.
	     *
	     * If no such layer exists, an `error` event is fired.
	     *
	     * @param id - id of the layer to remove
	     * @event `error` - Fired if the layer does not exist
	     */
	    removeLayer(id) {
	        this._checkLoaded();
	        const layer = this._layers[id];
	        if (!layer) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot remove non-existing layer "${id}".`)));
	            return;
	        }
	        layer.setEventedParent(null);
	        const index = this._order.indexOf(id);
	        this._order.splice(index, 1);
	        this._layerOrderChanged = true;
	        this._changed = true;
	        this._removedLayers[id] = layer;
	        delete this._layers[id];
	        if (this._serializedLayers) {
	            delete this._serializedLayers[id];
	        }
	        delete this._updatedLayers[id];
	        delete this._updatedPaintProps[id];
	        if (layer.onRemove) {
	            layer.onRemove(this.map);
	        }
	    }
	    /**
	     * Return the style layer object with the given `id`.
	     *
	     * @param id - id of the desired layer
	     * @returns a layer, if one with the given `id` exists
	     */
	    getLayer(id) {
	        return this._layers[id];
	    }
	    /**
	     * Return the ids of all layers currently in the style, including custom layers, in order.
	     *
	     * @returns ids of layers, in order
	     */
	    getLayersOrder() {
	        return [...this._order];
	    }
	    /**
	     * Checks if a specific layer is present within the style.
	     *
	     * @param id - the id of the desired layer
	     * @returns a boolean specifying if the given layer is present
	     */
	    hasLayer(id) {
	        return id in this._layers;
	    }
	    setLayerZoomRange(layerId, minzoom, maxzoom) {
	        this._checkLoaded();
	        const layer = this.getLayer(layerId);
	        if (!layer) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot set the zoom range of non-existing layer "${layerId}".`)));
	            return;
	        }
	        if (layer.minzoom === minzoom && layer.maxzoom === maxzoom)
	            return;
	        if (minzoom != null) {
	            layer.minzoom = minzoom;
	        }
	        if (maxzoom != null) {
	            layer.maxzoom = maxzoom;
	        }
	        this._updateLayer(layer);
	    }
	    setFilter(layerId, filter, options = {}) {
	        this._checkLoaded();
	        const layer = this.getLayer(layerId);
	        if (!layer) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot filter non-existing layer "${layerId}".`)));
	            return;
	        }
	        if (performance$1.deepEqual(layer.filter, filter)) {
	            return;
	        }
	        if (filter === null || filter === undefined) {
	            layer.filter = undefined;
	            this._updateLayer(layer);
	            return;
	        }
	        if (this._validate(performance$1.validateStyle.filter, `layers.${layer.id}.filter`, filter, null, options)) {
	            return;
	        }
	        layer.filter = performance$1.clone$1(filter);
	        this._updateLayer(layer);
	    }
	    /**
	     * Get a layer's filter object
	     * @param layer - the layer to inspect
	     * @returns the layer's filter, if any
	     */
	    getFilter(layer) {
	        return performance$1.clone$1(this.getLayer(layer).filter);
	    }
	    setLayoutProperty(layerId, name, value, options = {}) {
	        this._checkLoaded();
	        const layer = this.getLayer(layerId);
	        if (!layer) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot style non-existing layer "${layerId}".`)));
	            return;
	        }
	        if (performance$1.deepEqual(layer.getLayoutProperty(name), value))
	            return;
	        layer.setLayoutProperty(name, value, options);
	        this._updateLayer(layer);
	    }
	    /**
	     * Get a layout property's value from a given layer
	     * @param layerId - the layer to inspect
	     * @param name - the name of the layout property
	     * @returns the property value
	     */
	    getLayoutProperty(layerId, name) {
	        const layer = this.getLayer(layerId);
	        if (!layer) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot get style of non-existing layer "${layerId}".`)));
	            return;
	        }
	        return layer.getLayoutProperty(name);
	    }
	    setPaintProperty(layerId, name, value, options = {}) {
	        this._checkLoaded();
	        const layer = this.getLayer(layerId);
	        if (!layer) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Cannot style non-existing layer "${layerId}".`)));
	            return;
	        }
	        if (performance$1.deepEqual(layer.getPaintProperty(name), value))
	            return;
	        const requiresRelayout = layer.setPaintProperty(name, value, options);
	        if (requiresRelayout) {
	            this._updateLayer(layer);
	        }
	        this._changed = true;
	        this._updatedPaintProps[layerId] = true;
	    }
	    getPaintProperty(layer, name) {
	        return this.getLayer(layer).getPaintProperty(name);
	    }
	    setFeatureState(target, state) {
	        this._checkLoaded();
	        const sourceId = target.source;
	        const sourceLayer = target.sourceLayer;
	        const sourceCache = this.sourceCaches[sourceId];
	        if (sourceCache === undefined) {
	            this.fire(new performance$1.ErrorEvent(new Error(`The source '${sourceId}' does not exist in the map's style.`)));
	            return;
	        }
	        const sourceType = sourceCache.getSource().type;
	        if (sourceType === 'geojson' && sourceLayer) {
	            this.fire(new performance$1.ErrorEvent(new Error('GeoJSON sources cannot have a sourceLayer parameter.')));
	            return;
	        }
	        if (sourceType === 'vector' && !sourceLayer) {
	            this.fire(new performance$1.ErrorEvent(new Error('The sourceLayer parameter must be provided for vector source types.')));
	            return;
	        }
	        if (target.id === undefined) {
	            this.fire(new performance$1.ErrorEvent(new Error('The feature id parameter must be provided.')));
	        }
	        sourceCache.setFeatureState(sourceLayer, target.id, state);
	    }
	    removeFeatureState(target, key) {
	        this._checkLoaded();
	        const sourceId = target.source;
	        const sourceCache = this.sourceCaches[sourceId];
	        if (sourceCache === undefined) {
	            this.fire(new performance$1.ErrorEvent(new Error(`The source '${sourceId}' does not exist in the map's style.`)));
	            return;
	        }
	        const sourceType = sourceCache.getSource().type;
	        const sourceLayer = sourceType === 'vector' ? target.sourceLayer : undefined;
	        if (sourceType === 'vector' && !sourceLayer) {
	            this.fire(new performance$1.ErrorEvent(new Error('The sourceLayer parameter must be provided for vector source types.')));
	            return;
	        }
	        if (key && (typeof target.id !== 'string' && typeof target.id !== 'number')) {
	            this.fire(new performance$1.ErrorEvent(new Error('A feature id is required to remove its specific state property.')));
	            return;
	        }
	        sourceCache.removeFeatureState(sourceLayer, target.id, key);
	    }
	    getFeatureState(target) {
	        this._checkLoaded();
	        const sourceId = target.source;
	        const sourceLayer = target.sourceLayer;
	        const sourceCache = this.sourceCaches[sourceId];
	        if (sourceCache === undefined) {
	            this.fire(new performance$1.ErrorEvent(new Error(`The source '${sourceId}' does not exist in the map's style.`)));
	            return;
	        }
	        const sourceType = sourceCache.getSource().type;
	        if (sourceType === 'vector' && !sourceLayer) {
	            this.fire(new performance$1.ErrorEvent(new Error('The sourceLayer parameter must be provided for vector source types.')));
	            return;
	        }
	        if (target.id === undefined) {
	            this.fire(new performance$1.ErrorEvent(new Error('The feature id parameter must be provided.')));
	        }
	        return sourceCache.getFeatureState(sourceLayer, target.id);
	    }
	    getTransition() {
	        return performance$1.extend({ duration: 300, delay: 0 }, this.stylesheet && this.stylesheet.transition);
	    }
	    serialize() {
	        // We return undefined before we're loaded, following the pattern of Map.getStyle() before
	        // the Style object is initialized.
	        // Internally, Style._validate() calls Style.serialize() but callers are responsible for
	        // calling Style._checkLoaded() first if their validation requires the style to be loaded.
	        if (!this._loaded)
	            return;
	        const sources = performance$1.mapObject(this.sourceCaches, (source) => source.serialize());
	        const layers = this._serializeByIds(this._order);
	        const terrain = this.map.getTerrain() || undefined;
	        const myStyleSheet = this.stylesheet;
	        return performance$1.filterObject({
	            version: myStyleSheet.version,
	            name: myStyleSheet.name,
	            metadata: myStyleSheet.metadata,
	            light: myStyleSheet.light,
	            center: myStyleSheet.center,
	            zoom: myStyleSheet.zoom,
	            bearing: myStyleSheet.bearing,
	            pitch: myStyleSheet.pitch,
	            sprite: myStyleSheet.sprite,
	            glyphs: myStyleSheet.glyphs,
	            transition: myStyleSheet.transition,
	            sources,
	            layers,
	            terrain
	        }, (value) => { return value !== undefined; });
	    }
	    _updateLayer(layer) {
	        this._updatedLayers[layer.id] = true;
	        if (layer.source && !this._updatedSources[layer.source] &&
	            //Skip for raster layers (https://github.com/mapbox/mapbox-gl-js/issues/7865)
	            this.sourceCaches[layer.source].getSource().type !== 'raster') {
	            this._updatedSources[layer.source] = 'reload';
	            this.sourceCaches[layer.source].pause();
	        }
	        // upon updating, serilized layer dictionary should be reset.
	        // When needed, it will be populated with the correct copy again.
	        this._serializedLayers = null;
	        this._changed = true;
	    }
	    _flattenAndSortRenderedFeatures(sourceResults) {
	        // Feature order is complicated.
	        // The order between features in two 2D layers is always determined by layer order.
	        // The order between features in two 3D layers is always determined by depth.
	        // The order between a feature in a 2D layer and a 3D layer is tricky:
	        //      Most often layer order determines the feature order in this case. If
	        //      a line layer is above a extrusion layer the line feature will be rendered
	        //      above the extrusion. If the line layer is below the extrusion layer,
	        //      it will be rendered below it.
	        //
	        //      There is a weird case though.
	        //      You have layers in this order: extrusion_layer_a, line_layer, extrusion_layer_b
	        //      Each layer has a feature that overlaps the other features.
	        //      The feature in extrusion_layer_a is closer than the feature in extrusion_layer_b so it is rendered above.
	        //      The feature in line_layer is rendered above extrusion_layer_a.
	        //      This means that that the line_layer feature is above the extrusion_layer_b feature despite
	        //      it being in an earlier layer.
	        const isLayer3D = layerId => this._layers[layerId].type === 'fill-extrusion';
	        const layerIndex = {};
	        const features3D = [];
	        for (let l = this._order.length - 1; l >= 0; l--) {
	            const layerId = this._order[l];
	            if (isLayer3D(layerId)) {
	                layerIndex[layerId] = l;
	                for (const sourceResult of sourceResults) {
	                    const layerFeatures = sourceResult[layerId];
	                    if (layerFeatures) {
	                        for (const featureWrapper of layerFeatures) {
	                            features3D.push(featureWrapper);
	                        }
	                    }
	                }
	            }
	        }
	        features3D.sort((a, b) => {
	            return b.intersectionZ - a.intersectionZ;
	        });
	        const features = [];
	        for (let l = this._order.length - 1; l >= 0; l--) {
	            const layerId = this._order[l];
	            if (isLayer3D(layerId)) {
	                // add all 3D features that are in or above the current layer
	                for (let i = features3D.length - 1; i >= 0; i--) {
	                    const topmost3D = features3D[i].feature;
	                    if (layerIndex[topmost3D.layer.id] < l)
	                        break;
	                    features.push(topmost3D);
	                    features3D.pop();
	                }
	            }
	            else {
	                for (const sourceResult of sourceResults) {
	                    const layerFeatures = sourceResult[layerId];
	                    if (layerFeatures) {
	                        for (const featureWrapper of layerFeatures) {
	                            features.push(featureWrapper.feature);
	                        }
	                    }
	                }
	            }
	        }
	        return features;
	    }
	    queryRenderedFeatures(queryGeometry, params, transform) {
	        if (params && params.filter) {
	            this._validate(performance$1.validateStyle.filter, 'queryRenderedFeatures.filter', params.filter, null, params);
	        }
	        const includedSources = {};
	        if (params && params.layers) {
	            if (!Array.isArray(params.layers)) {
	                this.fire(new performance$1.ErrorEvent(new Error('parameters.layers must be an Array.')));
	                return [];
	            }
	            for (const layerId of params.layers) {
	                const layer = this._layers[layerId];
	                if (!layer) {
	                    // this layer is not in the style.layers array
	                    this.fire(new performance$1.ErrorEvent(new Error(`The layer '${layerId}' does not exist in the map's style and cannot be queried for features.`)));
	                    return [];
	                }
	                includedSources[layer.source] = true;
	            }
	        }
	        const sourceResults = [];
	        params.availableImages = this._availableImages;
	        // LayerSpecification is serialized StyleLayer, and this casting is safe.
	        const serializedLayers = this._serializedAllLayers();
	        for (const id in this.sourceCaches) {
	            if (params.layers && !includedSources[id])
	                continue;
	            sourceResults.push(queryRenderedFeatures(this.sourceCaches[id], this._layers, serializedLayers, queryGeometry, params, transform));
	        }
	        if (this.placement) {
	            // If a placement has run, query against its CollisionIndex
	            // for symbol results, and treat it as an extra source to merge
	            sourceResults.push(queryRenderedSymbols(this._layers, serializedLayers, this.sourceCaches, queryGeometry, params, this.placement.collisionIndex, this.placement.retainedQueryData));
	        }
	        return this._flattenAndSortRenderedFeatures(sourceResults);
	    }
	    querySourceFeatures(sourceID, params) {
	        if (params && params.filter) {
	            this._validate(performance$1.validateStyle.filter, 'querySourceFeatures.filter', params.filter, null, params);
	        }
	        const sourceCache = this.sourceCaches[sourceID];
	        return sourceCache ? querySourceFeatures(sourceCache, params) : [];
	    }
	    getLight() {
	        return this.light.getLight();
	    }
	    setLight(lightOptions, options = {}) {
	        this._checkLoaded();
	        const light = this.light.getLight();
	        let _update = false;
	        for (const key in lightOptions) {
	            if (!performance$1.deepEqual(lightOptions[key], light[key])) {
	                _update = true;
	                break;
	            }
	        }
	        if (!_update)
	            return;
	        const parameters = {
	            now: browser.now(),
	            transition: performance$1.extend({
	                duration: 300,
	                delay: 0
	            }, this.stylesheet.transition)
	        };
	        this.light.setLight(lightOptions, options);
	        this.light.updateTransitions(parameters);
	    }
	    _validate(validate, key, value, props, options = {}) {
	        if (options && options.validate === false) {
	            return false;
	        }
	        return emitValidationErrors(this, validate.call(performance$1.validateStyle, performance$1.extend({
	            key,
	            style: this.serialize(),
	            value,
	            styleSpec: performance$1.v8Spec
	        }, props)));
	    }
	    _remove(mapRemoved = true) {
	        if (this._frameRequest) {
	            this._frameRequest.abort();
	            this._frameRequest = null;
	        }
	        if (this._loadStyleRequest) {
	            this._loadStyleRequest.abort();
	            this._loadStyleRequest = null;
	        }
	        if (this._spriteRequest) {
	            this._spriteRequest.abort();
	            this._spriteRequest = null;
	        }
	        rtlMainThreadPluginFactory().off(RTLPluginLoadedEventName, this._rtlPluginLoaded);
	        for (const layerId in this._layers) {
	            const layer = this._layers[layerId];
	            layer.setEventedParent(null);
	        }
	        for (const id in this.sourceCaches) {
	            const sourceCache = this.sourceCaches[id];
	            sourceCache.setEventedParent(null);
	            sourceCache.onRemove(this.map);
	        }
	        this.imageManager.setEventedParent(null);
	        this.setEventedParent(null);
	        if (mapRemoved) {
	            this.dispatcher.broadcast("RM" /* MessageType.removeMap */, undefined);
	        }
	        this.dispatcher.remove(mapRemoved);
	    }
	    _clearSource(id) {
	        this.sourceCaches[id].clearTiles();
	    }
	    _reloadSource(id) {
	        this.sourceCaches[id].resume();
	        this.sourceCaches[id].reload();
	    }
	    _updateSources(transform) {
	        for (const id in this.sourceCaches) {
	            this.sourceCaches[id].update(transform, this.map.terrain);
	        }
	    }
	    _generateCollisionBoxes() {
	        for (const id in this.sourceCaches) {
	            this._reloadSource(id);
	        }
	    }
	    _updatePlacement(transform, showCollisionBoxes, fadeDuration, crossSourceCollisions, forceFullPlacement = false) {
	        let symbolBucketsChanged = false;
	        let placementCommitted = false;
	        const layerTiles = {};
	        for (const layerID of this._order) {
	            const styleLayer = this._layers[layerID];
	            if (styleLayer.type !== 'symbol')
	                continue;
	            if (!layerTiles[styleLayer.source]) {
	                const sourceCache = this.sourceCaches[styleLayer.source];
	                layerTiles[styleLayer.source] = sourceCache.getRenderableIds(true)
	                    .map((id) => sourceCache.getTileByID(id))
	                    .sort((a, b) => (b.tileID.overscaledZ - a.tileID.overscaledZ) || (a.tileID.isLessThan(b.tileID) ? -1 : 1));
	            }
	            const layerBucketsChanged = this.crossTileSymbolIndex.addLayer(styleLayer, layerTiles[styleLayer.source], transform.center.lng);
	            symbolBucketsChanged = symbolBucketsChanged || layerBucketsChanged;
	        }
	        this.crossTileSymbolIndex.pruneUnusedLayers(this._order);
	        // Anything that changes our "in progress" layer and tile indices requires us
	        // to start over. When we start over, we do a full placement instead of incremental
	        // to prevent starvation.
	        // We need to restart placement to keep layer indices in sync.
	        // Also force full placement when fadeDuration === 0 to ensure that newly loaded
	        // tiles will fully display symbols in their first frame
	        forceFullPlacement = forceFullPlacement || this._layerOrderChanged || fadeDuration === 0;
	        if (forceFullPlacement || !this.pauseablePlacement || (this.pauseablePlacement.isDone() && !this.placement.stillRecent(browser.now(), transform.zoom))) {
	            this.pauseablePlacement = new PauseablePlacement(transform, this.map.terrain, this._order, forceFullPlacement, showCollisionBoxes, fadeDuration, crossSourceCollisions, this.placement);
	            this._layerOrderChanged = false;
	        }
	        if (this.pauseablePlacement.isDone()) {
	            // the last placement finished running, but the next one hasn’t
	            // started yet because of the `stillRecent` check immediately
	            // above, so mark it stale to ensure that we request another
	            // render frame
	            this.placement.setStale();
	        }
	        else {
	            this.pauseablePlacement.continuePlacement(this._order, this._layers, layerTiles);
	            if (this.pauseablePlacement.isDone()) {
	                this.placement = this.pauseablePlacement.commit(browser.now());
	                placementCommitted = true;
	            }
	            if (symbolBucketsChanged) {
	                // since the placement gets split over multiple frames it is possible
	                // these buckets were processed before they were changed and so the
	                // placement is already stale while it is in progress
	                this.pauseablePlacement.placement.setStale();
	            }
	        }
	        if (placementCommitted || symbolBucketsChanged) {
	            for (const layerID of this._order) {
	                const styleLayer = this._layers[layerID];
	                if (styleLayer.type !== 'symbol')
	                    continue;
	                this.placement.updateLayerOpacities(styleLayer, layerTiles[styleLayer.source]);
	            }
	        }
	        // needsRender is false when we have just finished a placement that didn't change the visibility of any symbols
	        const needsRerender = !this.pauseablePlacement.isDone() || this.placement.hasTransitions(browser.now());
	        return needsRerender;
	    }
	    _releaseSymbolFadeTiles() {
	        for (const id in this.sourceCaches) {
	            this.sourceCaches[id].releaseSymbolFadeTiles();
	        }
	    }
	    // Callbacks from web workers
	    getImages(mapId, params) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const images = yield this.imageManager.getImages(params.icons);
	            // Apply queued image changes before setting the tile's dependencies so that the tile
	            // is not reloaded unnecessarily. Without this forced update the reload could happen in cases
	            // like this one:
	            // - icons contains "my-image"
	            // - imageManager.getImages(...) triggers `onstyleimagemissing`
	            // - the user adds "my-image" within the callback
	            // - addImage adds "my-image" to this._changedImages
	            // - the next frame triggers a reload of this tile even though it already has the latest version
	            this._updateTilesForChangedImages();
	            const sourceCache = this.sourceCaches[params.source];
	            if (sourceCache) {
	                sourceCache.setDependencies(params.tileID.key, params.type, params.icons);
	            }
	            return images;
	        });
	    }
	    getGlyphs(mapId, params) {
	        return performance$1.__awaiter(this, void 0, void 0, function* () {
	            const glypgs = yield this.glyphManager.getGlyphs(params.stacks);
	            const sourceCache = this.sourceCaches[params.source];
	            if (sourceCache) {
	                // we are not setting stacks as dependencies since for now
	                // we just need to know which tiles have glyph dependencies
	                sourceCache.setDependencies(params.tileID.key, params.type, ['']);
	            }
	            return glypgs;
	        });
	    }
	    getGlyphsUrl() {
	        return this.stylesheet.glyphs || null;
	    }
	    setGlyphs(glyphsUrl, options = {}) {
	        this._checkLoaded();
	        if (glyphsUrl && this._validate(performance$1.validateStyle.glyphs, 'glyphs', glyphsUrl, null, options)) {
	            return;
	        }
	        this._glyphsDidChange = true;
	        this.stylesheet.glyphs = glyphsUrl;
	        this.glyphManager.entries = {};
	        this.glyphManager.setURL(glyphsUrl);
	    }
	    /**
	     * Add a sprite.
	     *
	     * @param id - The id of the desired sprite
	     * @param url - The url to load the desired sprite from
	     * @param options - The style setter options
	     * @param completion - The completion handler
	     */
	    addSprite(id, url, options = {}, completion) {
	        this._checkLoaded();
	        const spriteToAdd = [{ id, url }];
	        const updatedSprite = [
	            ...coerceSpriteToArray(this.stylesheet.sprite),
	            ...spriteToAdd
	        ];
	        if (this._validate(performance$1.validateStyle.sprite, 'sprite', updatedSprite, null, options))
	            return;
	        this.stylesheet.sprite = updatedSprite;
	        this._loadSprite(spriteToAdd, true, completion);
	    }
	    /**
	     * Remove a sprite by its id. When the last sprite is removed, the whole `this.stylesheet.sprite` object becomes
	     * `undefined`. This falsy `undefined` value later prevents attempts to load the sprite when it's absent.
	     *
	     * @param id - the id of the sprite to remove
	     */
	    removeSprite(id) {
	        this._checkLoaded();
	        const internalSpriteRepresentation = coerceSpriteToArray(this.stylesheet.sprite);
	        if (!internalSpriteRepresentation.find(sprite => sprite.id === id)) {
	            this.fire(new performance$1.ErrorEvent(new Error(`Sprite "${id}" doesn't exists on this map.`)));
	            return;
	        }
	        if (this._spritesImagesIds[id]) {
	            for (const imageId of this._spritesImagesIds[id]) {
	                this.imageManager.removeImage(imageId);
	                this._changedImages[imageId] = true;
	            }
	        }
	        internalSpriteRepresentation.splice(internalSpriteRepresentation.findIndex(sprite => sprite.id === id), 1);
	        this.stylesheet.sprite = internalSpriteRepresentation.length > 0 ? internalSpriteRepresentation : undefined;
	        delete this._spritesImagesIds[id];
	        this._availableImages = this.imageManager.listImages();
	        this._changed = true;
	        this.dispatcher.broadcast("SI" /* MessageType.setImages */, this._availableImages);
	        this.fire(new performance$1.Event('data', { dataType: 'style' }));
	    }
	    /**
	     * Get the current sprite value.
	     *
	     * @returns empty array when no sprite is set; id-url pairs otherwise
	     */
	    getSprite() {
	        return coerceSpriteToArray(this.stylesheet.sprite);
	    }
	    /**
	     * Set a new value for the style's sprite.
	     *
	     * @param sprite - new sprite value
	     * @param options - style setter options
	     * @param completion - the completion handler
	     */
	    setSprite(sprite, options = {}, completion) {
	        this._checkLoaded();
	        if (sprite && this._validate(performance$1.validateStyle.sprite, 'sprite', sprite, null, options)) {
	            return;
	        }
	        this.stylesheet.sprite = sprite;
	        if (sprite) {
	            this._loadSprite(sprite, true, completion);
	        }
	        else {
	            this._unloadSprite();
	            if (completion) {
	                completion(null);
	            }
	        }
	    }
	}

	var posAttributes = performance$1.createLayout([
	    { name: 'a_pos', type: 'Int16', components: 2 }
	]);

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var preludeFrag = '#ifdef GL_ES\nprecision mediump float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif\n';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var preludeVert = '#ifdef GL_ES\nprecision highp float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec2 unpack_opacity(const float packedOpacity) {int intOpacity=int(packedOpacity)/2;return vec2(float(intOpacity)/127.0,mod(packedOpacity,2.0));}vec4 decode_color(const vec2 encodedColor) {return vec4(unpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}float unpack_mix_vec2(const vec2 packedValue,const float t) {return mix(packedValue[0],packedValue[1],t);}vec4 unpack_mix_color(const vec4 packedColors,const float t) {vec4 minColor=decode_color(vec2(packedColors[0],packedColors[1]));vec4 maxColor=decode_color(vec2(packedColors[2],packedColors[3]));return mix(minColor,maxColor,t);}vec2 get_pattern_pos(const vec2 pixel_coord_upper,const vec2 pixel_coord_lower,const vec2 pattern_size,const float tile_units_to_pixels,const vec2 pos) {vec2 offset=mod(mod(mod(pixel_coord_upper,pattern_size)*256.0,pattern_size)*256.0+pixel_coord_lower,pattern_size);return (tile_units_to_pixels*pos+offset)/pattern_size;}\n#ifdef TERRAIN3D\nuniform sampler2D u_terrain;uniform float u_terrain_dim;uniform mat4 u_terrain_matrix;uniform vec4 u_terrain_unpack;uniform float u_terrain_exaggeration;uniform highp sampler2D u_depth;\n#endif\nconst highp vec4 bitSh=vec4(256.*256.*256.,256.*256.,256.,1.);const highp vec4 bitShifts=vec4(1.)/bitSh;highp float unpack(highp vec4 color) {return dot(color,bitShifts);}highp float depthOpacity(vec3 frag) {\n#ifdef TERRAIN3D\nhighp float d=unpack(texture2D(u_depth,frag.xy*0.5+0.5))+0.0001-frag.z;return 1.0-max(0.0,min(1.0,-d*500.0));\n#else\nreturn 1.0;\n#endif\n}float calculate_visibility(vec4 pos) {\n#ifdef TERRAIN3D\nvec3 frag=pos.xyz/pos.w;highp float d=depthOpacity(frag);if (d > 0.95) return 1.0;return (d+depthOpacity(frag+vec3(0.0,0.01,0.0)))/2.0;\n#else\nreturn 1.0;\n#endif\n}float ele(vec2 pos) {\n#ifdef TERRAIN3D\nvec4 rgb=(texture2D(u_terrain,pos)*255.0)*u_terrain_unpack;return rgb.r+rgb.g+rgb.b-u_terrain_unpack.a;\n#else\nreturn 0.0;\n#endif\n}float get_elevation(vec2 pos) {\n#ifdef TERRAIN3D\nvec2 coord=(u_terrain_matrix*vec4(pos,0.0,1.0)).xy*u_terrain_dim+1.0;vec2 f=fract(coord);vec2 c=(floor(coord)+0.5)/(u_terrain_dim+2.0);float d=1.0/(u_terrain_dim+2.0);float tl=ele(c);float tr=ele(c+vec2(d,0.0));float bl=ele(c+vec2(0.0,d));float br=ele(c+vec2(d,d));float elevation=mix(mix(tl,tr,f.x),mix(bl,br,f.x),f.y);return elevation*u_terrain_exaggeration;\n#else\nreturn 0.0;\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var backgroundFrag = 'uniform vec4 u_color;uniform float u_opacity;void main() {gl_FragColor=u_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var backgroundVert = 'attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var backgroundPatternFrag = 'uniform vec2 u_pattern_tl_a;uniform vec2 u_pattern_br_a;uniform vec2 u_pattern_tl_b;uniform vec2 u_pattern_br_b;uniform vec2 u_texsize;uniform float u_mix;uniform float u_opacity;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(u_pattern_tl_a/u_texsize,u_pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(u_pattern_tl_b/u_texsize,u_pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_mix)*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var backgroundPatternVert = 'uniform mat4 u_matrix;uniform vec2 u_pattern_size_a;uniform vec2 u_pattern_size_b;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_scale_a;uniform float u_scale_b;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_a*u_pattern_size_a,u_tile_units_to_pixels,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_b*u_pattern_size_b,u_tile_units_to_pixels,a_pos);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var circleFrag = 'varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=v_data.xy;float extrude_length=length(extrude);lowp float antialiasblur=v_data.z;float antialiased_blur=-max(blur,antialiasblur);float opacity_t=smoothstep(0.0,antialiased_blur,extrude_length-1.0);float color_t=stroke_width < 0.01 ? 0.0 : smoothstep(antialiased_blur,0.0,extrude_length-radius/(radius+stroke_width));gl_FragColor=v_visibility*opacity_t*mix(color*opacity,stroke_color*stroke_opacity,color_t);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var circleVert = 'uniform mat4 u_matrix;uniform bool u_scale_with_map;uniform bool u_pitch_with_map;uniform vec2 u_extrude_scale;uniform lowp float u_device_pixel_ratio;uniform highp float u_camera_to_center_distance;attribute vec2 a_pos;varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main(void) {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=vec2(mod(a_pos,2.0)*2.0-1.0);vec2 circle_center=floor(a_pos*0.5);float ele=get_elevation(circle_center);v_visibility=calculate_visibility(u_matrix*vec4(circle_center,ele,1.0));if (u_pitch_with_map) {vec2 corner_position=circle_center;if (u_scale_with_map) {corner_position+=extrude*(radius+stroke_width)*u_extrude_scale;} else {vec4 projected_center=u_matrix*vec4(circle_center,0,1);corner_position+=extrude*(radius+stroke_width)*u_extrude_scale*(projected_center.w/u_camera_to_center_distance);}gl_Position=u_matrix*vec4(corner_position,ele,1);} else {gl_Position=u_matrix*vec4(circle_center,ele,1);if (u_scale_with_map) {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*u_camera_to_center_distance;} else {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*gl_Position.w;}}lowp float antialiasblur=1.0/u_device_pixel_ratio/(radius+stroke_width);v_data=vec3(extrude.x,extrude.y,antialiasblur);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var clippingMaskFrag = 'void main() {gl_FragColor=vec4(1.0);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var clippingMaskVert = 'attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var heatmapFrag = 'uniform highp float u_intensity;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#define GAUSS_COEF 0.3989422804014327\nvoid main() {\n#pragma mapbox: initialize highp float weight\nfloat d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,1.0,1.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var heatmapVert = 'uniform mat4 u_matrix;uniform float u_extrude_scale;uniform float u_opacity;uniform float u_intensity;attribute vec2 a_pos;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#pragma mapbox: define mediump float radius\nconst highp float ZERO=1.0/255.0/16.0;\n#define GAUSS_COEF 0.3989422804014327\nvoid main(void) {\n#pragma mapbox: initialize highp float weight\n#pragma mapbox: initialize mediump float radius\nvec2 unscaled_extrude=vec2(mod(a_pos,2.0)*2.0-1.0);float S=sqrt(-2.0*log(ZERO/weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=S*unscaled_extrude;vec2 extrude=v_extrude*radius*u_extrude_scale;vec4 pos=vec4(floor(a_pos*0.5)+extrude,0,1);gl_Position=u_matrix*pos;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var heatmapTextureFrag = 'uniform sampler2D u_image;uniform sampler2D u_color_ramp;uniform float u_opacity;varying vec2 v_pos;void main() {float t=texture2D(u_image,v_pos).r;vec4 color=texture2D(u_color_ramp,vec2(t,0.5));gl_FragColor=color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(0.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var heatmapTextureVert = 'uniform mat4 u_matrix;uniform vec2 u_world;attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos*u_world,0,1);v_pos.x=a_pos.x;v_pos.y=1.0-a_pos.y;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var collisionBoxFrag = 'varying float v_placed;varying float v_notUsed;void main() {float alpha=0.5;gl_FragColor=vec4(1.0,0.0,0.0,1.0)*alpha;if (v_placed > 0.5) {gl_FragColor=vec4(0.0,0.0,1.0,0.5)*alpha;}if (v_notUsed > 0.5) {gl_FragColor*=.1;}}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var collisionBoxVert = 'attribute vec2 a_pos;attribute vec2 a_anchor_pos;attribute vec2 a_extrude;attribute vec2 a_placed;attribute vec2 a_shift;uniform mat4 u_matrix;uniform vec2 u_extrude_scale;uniform float u_camera_to_center_distance;varying float v_placed;varying float v_notUsed;void main() {vec4 projectedPoint=u_matrix*vec4(a_anchor_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);gl_Position=u_matrix*vec4(a_pos,get_elevation(a_pos),1.0);gl_Position.xy+=(a_extrude+a_shift)*u_extrude_scale*gl_Position.w*collision_perspective_ratio;v_placed=a_placed.x;v_notUsed=a_placed.y;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var collisionCircleFrag = 'varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;void main() {float alpha=0.5*min(v_perspective_ratio,1.0);float stroke_radius=0.9*max(v_perspective_ratio,1.0);float distance_to_center=length(v_extrude);float distance_to_edge=abs(distance_to_center-v_radius);float opacity_t=smoothstep(-stroke_radius,0.0,-distance_to_edge);vec4 color=mix(vec4(0.0,0.0,1.0,0.5),vec4(1.0,0.0,0.0,1.0),v_collision);gl_FragColor=color*alpha*opacity_t;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var collisionCircleVert = 'attribute vec2 a_pos;attribute float a_radius;attribute vec2 a_flags;uniform mat4 u_matrix;uniform mat4 u_inv_matrix;uniform vec2 u_viewport_size;uniform float u_camera_to_center_distance;varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;vec3 toTilePosition(vec2 screenPos) {vec4 rayStart=u_inv_matrix*vec4(screenPos,-1.0,1.0);vec4 rayEnd  =u_inv_matrix*vec4(screenPos, 1.0,1.0);rayStart.xyz/=rayStart.w;rayEnd.xyz  /=rayEnd.w;highp float t=(0.0-rayStart.z)/(rayEnd.z-rayStart.z);return mix(rayStart.xyz,rayEnd.xyz,t);}void main() {vec2 quadCenterPos=a_pos;float radius=a_radius;float collision=a_flags.x;float vertexIdx=a_flags.y;vec2 quadVertexOffset=vec2(mix(-1.0,1.0,float(vertexIdx >=2.0)),mix(-1.0,1.0,float(vertexIdx >=1.0 && vertexIdx <=2.0)));vec2 quadVertexExtent=quadVertexOffset*radius;vec3 tilePos=toTilePosition(quadCenterPos);vec4 clipPos=u_matrix*vec4(tilePos,1.0);highp float camera_to_anchor_distance=clipPos.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);float padding_factor=1.2;v_radius=radius;v_extrude=quadVertexExtent*padding_factor;v_perspective_ratio=collision_perspective_ratio;v_collision=collision;gl_Position=vec4(clipPos.xyz/clipPos.w,1.0)+vec4(quadVertexExtent*padding_factor/u_viewport_size*2.0,0.0,0.0);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var debugFrag = 'uniform highp vec4 u_color;uniform sampler2D u_overlay;varying vec2 v_uv;void main() {vec4 overlay_color=texture2D(u_overlay,v_uv);gl_FragColor=mix(u_color,overlay_color,overlay_color.a);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var debugVert = 'attribute vec2 a_pos;varying vec2 v_uv;uniform mat4 u_matrix;uniform float u_overlay_scale;void main() {v_uv=a_pos/8192.0;gl_Position=u_matrix*vec4(a_pos*u_overlay_scale,get_elevation(a_pos),1);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillFrag = '#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_FragColor=color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillVert = 'attribute vec2 a_pos;uniform mat4 u_matrix;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillOutlineFrag = 'varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=outline_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillOutlineVert = 'attribute vec2 a_pos;uniform mat4 u_matrix;uniform vec2 u_world;varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillOutlinePatternFrag = 'uniform vec2 u_texsize;uniform sampler2D u_image;uniform float u_fade;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);float dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=mix(color1,color2,u_fade)*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillOutlinePatternVert = 'uniform mat4 u_matrix;uniform vec2 u_world;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;gl_Position=u_matrix*vec4(a_pos,0,1);vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,a_pos);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillPatternFrag = '#ifdef GL_ES\nprecision highp float;\n#endif\nuniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_fade)*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillPatternVert = 'uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileZoomRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileZoomRatio,a_pos);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillExtrusionFrag = 'varying vec4 v_color;void main() {gl_FragColor=v_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillExtrusionVert = 'uniform mat4 u_matrix;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;uniform float u_vertical_gradient;uniform lowp float u_opacity;attribute vec2 a_pos;attribute vec4 a_normal_ed;\n#ifdef TERRAIN3D\nattribute vec2 a_centroid;\n#endif\nvarying vec4 v_color;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define highp vec4 color\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize highp vec4 color\nvec3 normal=a_normal_ed.xyz;\n#ifdef TERRAIN3D\nfloat height_terrain3d_offset=get_elevation(a_centroid);float base_terrain3d_offset=height_terrain3d_offset-(base > 0.0 ? 0.0 : 10.0);\n#else\nfloat height_terrain3d_offset=0.0;float base_terrain3d_offset=0.0;\n#endif\nbase=max(0.0,base)+base_terrain3d_offset;height=max(0.0,height)+height_terrain3d_offset;float t=mod(normal.x,2.0);gl_Position=u_matrix*vec4(a_pos,t > 0.0 ? height : base,1);float colorvalue=color.r*0.2126+color.g*0.7152+color.b*0.0722;v_color=vec4(0.0,0.0,0.0,1.0);vec4 ambientlight=vec4(0.03,0.03,0.03,1.0);color+=ambientlight;float directional=clamp(dot(normal/16384.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_color.r+=clamp(color.r*directional*u_lightcolor.r,mix(0.0,0.3,1.0-u_lightcolor.r),1.0);v_color.g+=clamp(color.g*directional*u_lightcolor.g,mix(0.0,0.3,1.0-u_lightcolor.g),1.0);v_color.b+=clamp(color.b*directional*u_lightcolor.b,mix(0.0,0.3,1.0-u_lightcolor.b),1.0);v_color*=u_opacity;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillExtrusionPatternFrag = 'uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 mixedColor=mix(color1,color2,u_fade);gl_FragColor=mixedColor*v_lighting;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var fillExtrusionPatternVert = 'uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_height_factor;uniform vec3 u_scale;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;attribute vec2 a_pos;attribute vec4 a_normal_ed;\n#ifdef TERRAIN3D\nattribute vec2 a_centroid;\n#endif\nvarying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec3 normal=a_normal_ed.xyz;float edgedistance=a_normal_ed.w;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;\n#ifdef TERRAIN3D\nfloat height_terrain3d_offset=get_elevation(a_centroid);float base_terrain3d_offset=height_terrain3d_offset-(base > 0.0 ? 0.0 : 10.0);\n#else\nfloat height_terrain3d_offset=0.0;float base_terrain3d_offset=0.0;\n#endif\nbase=max(0.0,base)+base_terrain3d_offset;height=max(0.0,height)+height_terrain3d_offset;float t=mod(normal.x,2.0);float z=t > 0.0 ? height : base;gl_Position=u_matrix*vec4(a_pos,z,1);vec2 pos=normal.x==1.0 && normal.y==0.0 && normal.z==16384.0\n? a_pos\n: vec2(edgedistance,z*u_height_factor);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,pos);v_lighting=vec4(0.0,0.0,0.0,1.0);float directional=clamp(dot(normal/16383.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((0.5+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_lighting.rgb+=clamp(directional*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_lighting*=u_opacity;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var hillshadePrepareFrag = '#ifdef GL_ES\nprecision highp float;\n#endif\nuniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_dimension;uniform float u_zoom;uniform vec4 u_unpack;float getElevation(vec2 coord,float bias) {vec4 data=texture2D(u_image,coord)*255.0;data.a=-1.0;return dot(data,u_unpack)/4.0;}void main() {vec2 epsilon=1.0/u_dimension;float a=getElevation(v_pos+vec2(-epsilon.x,-epsilon.y),0.0);float b=getElevation(v_pos+vec2(0,-epsilon.y),0.0);float c=getElevation(v_pos+vec2(epsilon.x,-epsilon.y),0.0);float d=getElevation(v_pos+vec2(-epsilon.x,0),0.0);float e=getElevation(v_pos,0.0);float f=getElevation(v_pos+vec2(epsilon.x,0),0.0);float g=getElevation(v_pos+vec2(-epsilon.x,epsilon.y),0.0);float h=getElevation(v_pos+vec2(0,epsilon.y),0.0);float i=getElevation(v_pos+vec2(epsilon.x,epsilon.y),0.0);float exaggerationFactor=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;float exaggeration=u_zoom < 15.0 ? (u_zoom-15.0)*exaggerationFactor : 0.0;vec2 deriv=vec2((c+f+f+i)-(a+d+d+g),(g+h+h+i)-(a+b+b+c))/pow(2.0,exaggeration+(19.2562-u_zoom));gl_FragColor=clamp(vec4(deriv.x/2.0+0.5,deriv.y/2.0+0.5,1.0,1.0),0.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var hillshadePrepareVert = 'uniform mat4 u_matrix;uniform vec2 u_dimension;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);highp vec2 epsilon=1.0/u_dimension;float scale=(u_dimension.x-2.0)/u_dimension.x;v_pos=(a_texture_pos/8192.0)*scale+epsilon;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var hillshadeFrag = 'uniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_latrange;uniform vec2 u_light;uniform vec4 u_shadow;uniform vec4 u_highlight;uniform vec4 u_accent;\n#define PI 3.141592653589793\nvoid main() {vec4 pixel=texture2D(u_image,v_pos);vec2 deriv=((pixel.rg*2.0)-1.0);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_pos.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*u_accent*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=accent_color*(1.0-shade_color.a)+shade_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var hillshadeVert = 'uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=a_texture_pos/8192.0;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var lineFrag = 'uniform lowp float u_device_pixel_ratio;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var lineVert = '\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform vec2 u_units_to_pixels;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp float v_linesofar;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;v_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*2.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_width2=vec2(outset,inset);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var lineGradientFrag = 'uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);vec4 color=texture2D(u_image,v_uv);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var lineGradientVert = '\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;attribute float a_uv_x;attribute float a_split_index;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_units_to_pixels;uniform float u_image_height;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;highp float texel_height=1.0/u_image_height;highp float half_texel_height=0.5*texel_height;v_uv=vec2(a_uv_x,a_split_index*texel_height-half_texel_height);vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_width2=vec2(outset,inset);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var linePatternFrag = '#ifdef GL_ES\nprecision highp float;\n#endif\nuniform lowp float u_device_pixel_ratio;uniform vec2 u_texsize;uniform float u_fade;uniform mediump vec3 u_scale;uniform sampler2D u_image;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;vec2 pattern_size_a=vec2(display_size_a.x*fromScale/tileZoomRatio,display_size_a.y);vec2 pattern_size_b=vec2(display_size_b.x*toScale/tileZoomRatio,display_size_b.y);float aspect_a=display_size_a.y/v_width;float aspect_b=display_size_b.y/v_width;float dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float x_a=mod(v_linesofar/pattern_size_a.x*aspect_a,1.0);float x_b=mod(v_linesofar/pattern_size_b.x*aspect_b,1.0);float y=0.5*v_normal.y+0.5;vec2 texel_size=1.0/u_texsize;vec2 pos_a=mix(pattern_tl_a*texel_size-texel_size,pattern_br_a*texel_size+texel_size,vec2(x_a,y));vec2 pos_b=mix(pattern_tl_b*texel_size-texel_size,pattern_br_b*texel_size+texel_size,vec2(x_b,y));vec4 color=mix(texture2D(u_image,pos_a),texture2D(u_image,pos_b),u_fade);gl_FragColor=color*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var linePatternVert = '\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform vec2 u_units_to_pixels;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_linesofar=a_linesofar;v_width2=vec2(outset,inset);v_width=floorwidth;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var lineSDFFrag = 'uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;uniform float u_sdfgamma;uniform float u_mix;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float sdfdist_a=texture2D(u_image,v_tex_a).a;float sdfdist_b=texture2D(u_image,v_tex_b).a;float sdfdist=mix(sdfdist_a,sdfdist_b,u_mix);alpha*=smoothstep(0.5-u_sdfgamma/floorwidth,0.5+u_sdfgamma/floorwidth,sdfdist);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var lineSDFVert = '\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_patternscale_a;uniform float u_tex_y_a;uniform vec2 u_patternscale_b;uniform float u_tex_y_b;uniform vec2 u_units_to_pixels;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_tex_a=vec2(a_linesofar*u_patternscale_a.x/floorwidth,normal.y*u_patternscale_a.y+u_tex_y_a);v_tex_b=vec2(a_linesofar*u_patternscale_b.x/floorwidth,normal.y*u_patternscale_b.y+u_tex_y_b);v_width2=vec2(outset,inset);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var rasterFrag = 'uniform float u_fade_t;uniform float u_opacity;uniform sampler2D u_image0;uniform sampler2D u_image1;varying vec2 v_pos0;varying vec2 v_pos1;uniform float u_brightness_low;uniform float u_brightness_high;uniform float u_saturation_factor;uniform float u_contrast_factor;uniform vec3 u_spin_weights;void main() {vec4 color0=texture2D(u_image0,v_pos0);vec4 color1=texture2D(u_image1,v_pos1);if (color0.a > 0.0) {color0.rgb=color0.rgb/color0.a;}if (color1.a > 0.0) {color1.rgb=color1.rgb/color1.a;}vec4 color=mix(color0,color1,u_fade_t);color.a*=u_opacity;vec3 rgb=color.rgb;rgb=vec3(dot(rgb,u_spin_weights.xyz),dot(rgb,u_spin_weights.zxy),dot(rgb,u_spin_weights.yzx));float average=(color.r+color.g+color.b)/3.0;rgb+=(average-rgb)*u_saturation_factor;rgb=(rgb-0.5)*u_contrast_factor+0.5;vec3 u_high_vec=vec3(u_brightness_low,u_brightness_low,u_brightness_low);vec3 u_low_vec=vec3(u_brightness_high,u_brightness_high,u_brightness_high);gl_FragColor=vec4(mix(u_high_vec,u_low_vec,rgb)*color.a,color.a);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var rasterVert = 'uniform mat4 u_matrix;uniform vec2 u_tl_parent;uniform float u_scale_parent;uniform float u_buffer_scale;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;varying vec2 v_pos1;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos0=(((a_texture_pos/8192.0)-0.5)/u_buffer_scale )+0.5;v_pos1=(v_pos0*u_scale_parent)+u_tl_parent;}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var symbolIconFrag = 'uniform sampler2D u_texture;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nlowp float alpha=opacity*v_fade_opacity;gl_FragColor=texture2D(u_texture,v_tex)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var symbolIconVert = 'const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform highp float u_camera_to_center_distance;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform float u_fade_change;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform vec2 u_texsize;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;vec2 a_minFontScale=a_pixeloffset.zw/256.0;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*max(a_minFontScale,fontScale)+a_pxoffset/16.0),z,1.0);v_tex=a_tex/u_texsize;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float visibility=calculate_visibility(projectedPoint);v_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var symbolSDFFrag = '#define SDF_PX 8.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_text;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat EDGE_GAMMA=0.105/u_device_pixel_ratio;vec2 tex=v_data0.xy;float gamma_scale=v_data1.x;float size=v_data1.y;float fade_opacity=v_data1[2];float fontScale=u_is_text ? size/24.0 : size;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float inner_edge=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);inner_edge=inner_edge+gamma*gamma_scale;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(inner_edge-gamma_scaled,inner_edge+gamma_scaled,dist);if (u_is_halo) {lowp float halo_edge=(6.0-halo_width/fontScale)/SDF_PX;alpha=min(smoothstep(halo_edge-gamma_scaled,halo_edge+gamma_scaled,dist),1.0-alpha);}gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var symbolSDFVert = 'const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale+a_pxoffset),z,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float visibility=calculate_visibility(projectedPoint);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));v_data0=a_tex/u_texsize;v_data1=vec3(gamma_scale,size,interpolated_fade_opacity);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var symbolTextAndIconFrag = '#define SDF_PX 8.0\n#define SDF 1.0\n#define ICON 0.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform sampler2D u_texture_icon;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat fade_opacity=v_data1[2];if (v_data1.w==ICON) {vec2 tex_icon=v_data0.zw;lowp float alpha=opacity*fade_opacity;gl_FragColor=texture2D(u_texture_icon,tex_icon)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nreturn;}vec2 tex=v_data0.xy;float EDGE_GAMMA=0.105/u_device_pixel_ratio;float gamma_scale=v_data1.x;float size=v_data1.y;float fontScale=size/24.0;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var symbolTextAndIconVert = 'const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec2 u_texsize_icon;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);float is_sdf=a_size[0]-2.0*a_size_min;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=size/24.0;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale),z,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float visibility=calculate_visibility(projectedPoint);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));v_data0.xy=a_tex/u_texsize;v_data0.zw=a_tex/u_texsize_icon;v_data1=vec4(gamma_scale,size,interpolated_fade_opacity,is_sdf);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var terrainDepthFrag = 'varying float v_depth;const highp vec4 bitSh=vec4(256.*256.*256.,256.*256.,256.,1.);const highp vec4 bitMsk=vec4(0.,vec3(1./256.0));highp vec4 pack(highp float value) {highp vec4 comp=fract(value*bitSh);comp-=comp.xxyz*bitMsk;return comp;}void main() {gl_FragColor=pack(v_depth);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var terrainCoordsFrag = 'precision mediump float;uniform sampler2D u_texture;uniform float u_terrain_coords_id;varying vec2 v_texture_pos;void main() {vec4 rgba=texture2D(u_texture,v_texture_pos);gl_FragColor=vec4(rgba.r,rgba.g,rgba.b,u_terrain_coords_id);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var terrainFrag = 'uniform sampler2D u_texture;varying vec2 v_texture_pos;void main() {gl_FragColor=texture2D(u_texture,v_texture_pos);}';

	// This file is generated. Edit build/generate-shaders.ts, then run `npm run codegen`.
	var terrainVert = 'attribute vec3 a_pos3d;uniform mat4 u_matrix;uniform float u_ele_delta;varying vec2 v_texture_pos;varying float v_depth;void main() {float extent=8192.0;float ele_delta=a_pos3d.z==1.0 ? u_ele_delta : 0.0;v_texture_pos=a_pos3d.xy/extent;gl_Position=u_matrix*vec4(a_pos3d.xy,get_elevation(a_pos3d.xy)-ele_delta,1.0);v_depth=gl_Position.z/gl_Position.w;}';

	// Disable Flow annotations here because Flow doesn't support importing GLSL files
	const shaders = {
	    prelude: compile(preludeFrag, preludeVert),
	    background: compile(backgroundFrag, backgroundVert),
	    backgroundPattern: compile(backgroundPatternFrag, backgroundPatternVert),
	    circle: compile(circleFrag, circleVert),
	    clippingMask: compile(clippingMaskFrag, clippingMaskVert),
	    heatmap: compile(heatmapFrag, heatmapVert),
	    heatmapTexture: compile(heatmapTextureFrag, heatmapTextureVert),
	    collisionBox: compile(collisionBoxFrag, collisionBoxVert),
	    collisionCircle: compile(collisionCircleFrag, collisionCircleVert),
	    debug: compile(debugFrag, debugVert),
	    fill: compile(fillFrag, fillVert),
	    fillOutline: compile(fillOutlineFrag, fillOutlineVert),
	    fillOutlinePattern: compile(fillOutlinePatternFrag, fillOutlinePatternVert),
	    fillPattern: compile(fillPatternFrag, fillPatternVert),
	    fillExtrusion: compile(fillExtrusionFrag, fillExtrusionVert),
	    fillExtrusionPattern: compile(fillExtrusionPatternFrag, fillExtrusionPatternVert),
	    hillshadePrepare: compile(hillshadePrepareFrag, hillshadePrepareVert),
	    hillshade: compile(hillshadeFrag, hillshadeVert),
	    line: compile(lineFrag, lineVert),
	    lineGradient: compile(lineGradientFrag, lineGradientVert),
	    linePattern: compile(linePatternFrag, linePatternVert),
	    lineSDF: compile(lineSDFFrag, lineSDFVert),
	    raster: compile(rasterFrag, rasterVert),
	    symbolIcon: compile(symbolIconFrag, symbolIconVert),
	    symbolSDF: compile(symbolSDFFrag, symbolSDFVert),
	    symbolTextAndIcon: compile(symbolTextAndIconFrag, symbolTextAndIconVert),
	    terrain: compile(terrainFrag, terrainVert),
	    terrainDepth: compile(terrainDepthFrag, terrainVert),
	    terrainCoords: compile(terrainCoordsFrag, terrainVert)
	};
	// Expand #pragmas to #ifdefs.
	function compile(fragmentSource, vertexSource) {
	    const re = /#pragma mapbox: ([\w]+) ([\w]+) ([\w]+) ([\w]+)/g;
	    const staticAttributes = vertexSource.match(/attribute ([\w]+) ([\w]+)/g);
	    const fragmentUniforms = fragmentSource.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g);
	    const vertexUniforms = vertexSource.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g);
	    const staticUniforms = vertexUniforms ? vertexUniforms.concat(fragmentUniforms) : fragmentUniforms;
	    const fragmentPragmas = {};
	    fragmentSource = fragmentSource.replace(re, (match, operation, precision, type, name) => {
	        fragmentPragmas[name] = true;
	        if (operation === 'define') {
	            return `
#ifndef HAS_UNIFORM_u_${name}
varying ${precision} ${type} ${name};
#else
uniform ${precision} ${type} u_${name};
#endif
`;
	        }
	        else /* if (operation === 'initialize') */ {
	            return `
#ifdef HAS_UNIFORM_u_${name}
    ${precision} ${type} ${name} = u_${name};
#endif
`;
	        }
	    });
	    vertexSource = vertexSource.replace(re, (match, operation, precision, type, name) => {
	        const attrType = type === 'float' ? 'vec2' : 'vec4';
	        const unpackType = name.match(/color/) ? 'color' : attrType;
	        if (fragmentPragmas[name]) {
	            if (operation === 'define') {
	                return `
#ifndef HAS_UNIFORM_u_${name}
uniform lowp float u_${name}_t;
attribute ${precision} ${attrType} a_${name};
varying ${precision} ${type} ${name};
#else
uniform ${precision} ${type} u_${name};
#endif
`;
	            }
	            else /* if (operation === 'initialize') */ {
	                if (unpackType === 'vec4') {
	                    // vec4 attributes are only used for cross-faded properties, and are not packed
	                    return `
#ifndef HAS_UNIFORM_u_${name}
    ${name} = a_${name};
#else
    ${precision} ${type} ${name} = u_${name};
#endif
`;
	                }
	                else {
	                    return `
#ifndef HAS_UNIFORM_u_${name}
    ${name} = unpack_mix_${unpackType}(a_${name}, u_${name}_t);
#else
    ${precision} ${type} ${name} = u_${name};
#endif
`;
	                }
	            }
	        }
	        else {
	            if (operation === 'define') {
	                return `
#ifndef HAS_UNIFORM_u_${name}
uniform lowp float u_${name}_t;
attribute ${precision} ${attrType} a_${name};
#else
uniform ${precision} ${type} u_${name};
#endif
`;
	            }
	            else /* if (operation === 'initialize') */ {
	                if (unpackType === 'vec4') {
	                    // vec4 attributes are only used for cross-faded properties, and are not packed
	                    return `
#ifndef HAS_UNIFORM_u_${name}
    ${precision} ${type} ${name} = a_${name};
#else
    ${precision} ${type} ${name} = u_${name};
#endif
`;
	                }
	                else /* */ {
	                    return `
#ifndef HAS_UNIFORM_u_${name}
    ${precision} ${type} ${name} = unpack_mix_${unpackType}(a_${name}, u_${name}_t);
#else
    ${precision} ${type} ${name} = u_${name};
#endif
`;
	                }
	            }
	        }
	    });
	    return { fragmentSource, vertexSource, staticAttributes, staticUniforms };
	}

	/**
	 * @internal
	 * A vertex array object used to pass data to the webgl code
	 */
	class VertexArrayObject {
	    constructor() {
	        this.boundProgram = null;
	        this.boundLayoutVertexBuffer = null;
	        this.boundPaintVertexBuffers = [];
	        this.boundIndexBuffer = null;
	        this.boundVertexOffset = null;
	        this.boundDynamicVertexBuffer = null;
	        this.vao = null;
	    }
	    bind(context, program, layoutVertexBuffer, paintVertexBuffers, indexBuffer, vertexOffset, dynamicVertexBuffer, dynamicVertexBuffer2, dynamicVertexBuffer3) {
	        this.context = context;
	        let paintBuffersDiffer = this.boundPaintVertexBuffers.length !== paintVertexBuffers.length;
	        for (let i = 0; !paintBuffersDiffer && i < paintVertexBuffers.length; i++) {
	            if (this.boundPaintVertexBuffers[i] !== paintVertexBuffers[i]) {
	                paintBuffersDiffer = true;
	            }
	        }
	        const isFreshBindRequired = (!this.vao ||
	            this.boundProgram !== program ||
	            this.boundLayoutVertexBuffer !== layoutVertexBuffer ||
	            paintBuffersDiffer ||
	            this.boundIndexBuffer !== indexBuffer ||
	            this.boundVertexOffset !== vertexOffset ||
	            this.boundDynamicVertexBuffer !== dynamicVertexBuffer ||
	            this.boundDynamicVertexBuffer2 !== dynamicVertexBuffer2 ||
	            this.boundDynamicVertexBuffer3 !== dynamicVertexBuffer3);
	        if (isFreshBindRequired) {
	            this.freshBind(program, layoutVertexBuffer, paintVertexBuffers, indexBuffer, vertexOffset, dynamicVertexBuffer, dynamicVertexBuffer2, dynamicVertexBuffer3);
	        }
	        else {
	            context.bindVertexArray.set(this.vao);
	            if (dynamicVertexBuffer) {
	                // The buffer may have been updated. Rebind to upload data.
	                dynamicVertexBuffer.bind();
	            }
	            if (indexBuffer && indexBuffer.dynamicDraw) {
	                indexBuffer.bind();
	            }
	            if (dynamicVertexBuffer2) {
	                dynamicVertexBuffer2.bind();
	            }
	            if (dynamicVertexBuffer3) {
	                dynamicVertexBuffer3.bind();
	            }
	        }
	    }
	    freshBind(program, layoutVertexBuffer, paintVertexBuffers, indexBuffer, vertexOffset, dynamicVertexBuffer, dynamicVertexBuffer2, dynamicVertexBuffer3) {
	        const numNextAttributes = program.numAttributes;
	        const context = this.context;
	        const gl = context.gl;
	        if (this.vao)
	            this.destroy();
	        this.vao = context.createVertexArray();
	        context.bindVertexArray.set(this.vao);
	        // store the arguments so that we can verify them when the vao is bound again
	        this.boundProgram = program;
	        this.boundLayoutVertexBuffer = layoutVertexBuffer;
	        this.boundPaintVertexBuffers = paintVertexBuffers;
	        this.boundIndexBuffer = indexBuffer;
	        this.boundVertexOffset = vertexOffset;
	        this.boundDynamicVertexBuffer = dynamicVertexBuffer;
	        this.boundDynamicVertexBuffer2 = dynamicVertexBuffer2;
	        this.boundDynamicVertexBuffer3 = dynamicVertexBuffer3;
	        layoutVertexBuffer.enableAttributes(gl, program);
	        for (const vertexBuffer of paintVertexBuffers) {
	            vertexBuffer.enableAttributes(gl, program);
	        }
	        if (dynamicVertexBuffer) {
	            dynamicVertexBuffer.enableAttributes(gl, program);
	        }
	        if (dynamicVertexBuffer2) {
	            dynamicVertexBuffer2.enableAttributes(gl, program);
	        }
	        if (dynamicVertexBuffer3) {
	            dynamicVertexBuffer3.enableAttributes(gl, program);
	        }
	        layoutVertexBuffer.bind();
	        layoutVertexBuffer.setVertexAttribPointers(gl, program, vertexOffset);
	        for (const vertexBuffer of paintVertexBuffers) {
	            vertexBuffer.bind();
	            vertexBuffer.setVertexAttribPointers(gl, program, vertexOffset);
	        }
	        if (dynamicVertexBuffer) {
	            dynamicVertexBuffer.bind();
	            dynamicVertexBuffer.setVertexAttribPointers(gl, program, vertexOffset);
	        }
	        if (indexBuffer) {
	            indexBuffer.bind();
	        }
	        if (dynamicVertexBuffer2) {
	            dynamicVertexBuffer2.bind();
	            dynamicVertexBuffer2.setVertexAttribPointers(gl, program, vertexOffset);
	        }
	        if (dynamicVertexBuffer3) {
	            dynamicVertexBuffer3.bind();
	            dynamicVertexBuffer3.setVertexAttribPointers(gl, program, vertexOffset);
	        }
	        context.currentNumAttributes = numNextAttributes;
	    }
	    destroy() {
	        if (this.vao) {
	            this.context.deleteVertexArray(this.vao);
	            this.vao = null;
	        }
	    }
	}

	const terrainPreludeUniforms = (context, locations) => ({
	    'u_depth': new performance$1.Uniform1i(context, locations.u_depth),
	    'u_terrain': new performance$1.Uniform1i(context, locations.u_terrain),
	    'u_terrain_dim': new performance$1.Uniform1f(context, locations.u_terrain_dim),
	    'u_terrain_matrix': new performance$1.UniformMatrix4f(context, locations.u_terrain_matrix),
	    'u_terrain_unpack': new performance$1.Uniform4f(context, locations.u_terrain_unpack),
	    'u_terrain_exaggeration': new performance$1.Uniform1f(context, locations.u_terrain_exaggeration)
	});
	const terrainUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_texture': new performance$1.Uniform1i(context, locations.u_texture),
	    'u_ele_delta': new performance$1.Uniform1f(context, locations.u_ele_delta)
	});
	const terrainDepthUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_ele_delta': new performance$1.Uniform1f(context, locations.u_ele_delta)
	});
	const terrainCoordsUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_texture': new performance$1.Uniform1i(context, locations.u_texture),
	    'u_terrain_coords_id': new performance$1.Uniform1f(context, locations.u_terrain_coords_id),
	    'u_ele_delta': new performance$1.Uniform1f(context, locations.u_ele_delta)
	});
	const terrainUniformValues = (matrix, eleDelta) => ({
	    'u_matrix': matrix,
	    'u_texture': 0,
	    'u_ele_delta': eleDelta
	});
	const terrainDepthUniformValues = (matrix, eleDelta) => ({
	    'u_matrix': matrix,
	    'u_ele_delta': eleDelta
	});
	const terrainCoordsUniformValues = (matrix, coordsId, eleDelta) => ({
	    'u_matrix': matrix,
	    'u_terrain_coords_id': coordsId / 255,
	    'u_texture': 0,
	    'u_ele_delta': eleDelta
	});

	function getTokenizedAttributesAndUniforms(array) {
	    const result = [];
	    for (let i = 0; i < array.length; i++) {
	        if (array[i] === null)
	            continue;
	        const token = array[i].split(' ');
	        result.push(token.pop());
	    }
	    return result;
	}
	/**
	 * @internal
	 * A webgl program to execute in the GPU space
	 */
	class Program {
	    constructor(context, source, configuration, fixedUniforms, showOverdrawInspector, terrain) {
	        const gl = context.gl;
	        this.program = gl.createProgram();
	        const staticAttrInfo = getTokenizedAttributesAndUniforms(source.staticAttributes);
	        const dynamicAttrInfo = configuration ? configuration.getBinderAttributes() : [];
	        const allAttrInfo = staticAttrInfo.concat(dynamicAttrInfo);
	        const preludeUniformsInfo = shaders.prelude.staticUniforms ? getTokenizedAttributesAndUniforms(shaders.prelude.staticUniforms) : [];
	        const staticUniformsInfo = source.staticUniforms ? getTokenizedAttributesAndUniforms(source.staticUniforms) : [];
	        const dynamicUniformsInfo = configuration ? configuration.getBinderUniforms() : [];
	        // remove duplicate uniforms
	        const uniformList = preludeUniformsInfo.concat(staticUniformsInfo).concat(dynamicUniformsInfo);
	        const allUniformsInfo = [];
	        for (const uniform of uniformList) {
	            if (allUniformsInfo.indexOf(uniform) < 0)
	                allUniformsInfo.push(uniform);
	        }
	        const defines = configuration ? configuration.defines() : [];
	        if (showOverdrawInspector) {
	            defines.push('#define OVERDRAW_INSPECTOR;');
	        }
	        if (terrain) {
	            defines.push('#define TERRAIN3D;');
	        }
	        const fragmentSource = defines.concat(shaders.prelude.fragmentSource, source.fragmentSource).join('\n');
	        const vertexSource = defines.concat(shaders.prelude.vertexSource, source.vertexSource).join('\n');
	        const fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);
	        if (gl.isContextLost()) {
	            this.failedToCreate = true;
	            return;
	        }
	        gl.shaderSource(fragmentShader, fragmentSource);
	        gl.compileShader(fragmentShader);
	        if (!gl.getShaderParameter(fragmentShader, gl.COMPILE_STATUS)) {
	            throw new Error(`Could not compile fragment shader: ${gl.getShaderInfoLog(fragmentShader)}`);
	        }
	        gl.attachShader(this.program, fragmentShader);
	        const vertexShader = gl.createShader(gl.VERTEX_SHADER);
	        if (gl.isContextLost()) {
	            this.failedToCreate = true;
	            return;
	        }
	        gl.shaderSource(vertexShader, vertexSource);
	        gl.compileShader(vertexShader);
	        if (!gl.getShaderParameter(vertexShader, gl.COMPILE_STATUS)) {
	            throw new Error(`Could not compile vertex shader: ${gl.getShaderInfoLog(vertexShader)}`);
	        }
	        gl.attachShader(this.program, vertexShader);
	        this.attributes = {};
	        const uniformLocations = {};
	        this.numAttributes = allAttrInfo.length;
	        for (let i = 0; i < this.numAttributes; i++) {
	            if (allAttrInfo[i]) {
	                gl.bindAttribLocation(this.program, i, allAttrInfo[i]);
	                this.attributes[allAttrInfo[i]] = i;
	            }
	        }
	        gl.linkProgram(this.program);
	        if (!gl.getProgramParameter(this.program, gl.LINK_STATUS)) {
	            throw new Error(`Program failed to link: ${gl.getProgramInfoLog(this.program)}`);
	        }
	        gl.deleteShader(vertexShader);
	        gl.deleteShader(fragmentShader);
	        for (let it = 0; it < allUniformsInfo.length; it++) {
	            const uniform = allUniformsInfo[it];
	            if (uniform && !uniformLocations[uniform]) {
	                const uniformLocation = gl.getUniformLocation(this.program, uniform);
	                if (uniformLocation) {
	                    uniformLocations[uniform] = uniformLocation;
	                }
	            }
	        }
	        this.fixedUniforms = fixedUniforms(context, uniformLocations);
	        this.terrainUniforms = terrainPreludeUniforms(context, uniformLocations);
	        this.binderUniforms = configuration ? configuration.getUniforms(context, uniformLocations) : [];
	    }
	    draw(context, drawMode, depthMode, stencilMode, colorMode, cullFaceMode, uniformValues, terrain, layerID, layoutVertexBuffer, indexBuffer, segments, currentProperties, zoom, configuration, dynamicLayoutBuffer, dynamicLayoutBuffer2, dynamicLayoutBuffer3) {
	        const gl = context.gl;
	        if (this.failedToCreate)
	            return;
	        context.program.set(this.program);
	        context.setDepthMode(depthMode);
	        context.setStencilMode(stencilMode);
	        context.setColorMode(colorMode);
	        context.setCullFace(cullFaceMode);
	        // set variables used by the 3d functions defined in _prelude.vertex.glsl
	        if (terrain) {
	            context.activeTexture.set(gl.TEXTURE2);
	            gl.bindTexture(gl.TEXTURE_2D, terrain.depthTexture);
	            context.activeTexture.set(gl.TEXTURE3);
	            gl.bindTexture(gl.TEXTURE_2D, terrain.texture);
	            for (const name in this.terrainUniforms) {
	                this.terrainUniforms[name].set(terrain[name]);
	            }
	        }
	        for (const name in this.fixedUniforms) {
	            this.fixedUniforms[name].set(uniformValues[name]);
	        }
	        if (configuration) {
	            configuration.setUniforms(context, this.binderUniforms, currentProperties, { zoom: zoom });
	        }
	        let primitiveSize = 0;
	        switch (drawMode) {
	            case gl.LINES:
	                primitiveSize = 2;
	                break;
	            case gl.TRIANGLES:
	                primitiveSize = 3;
	                break;
	            case gl.LINE_STRIP:
	                primitiveSize = 1;
	                break;
	        }
	        for (const segment of segments.get()) {
	            const vaos = segment.vaos || (segment.vaos = {});
	            const vao = vaos[layerID] || (vaos[layerID] = new VertexArrayObject());
	            vao.bind(context, this, layoutVertexBuffer, configuration ? configuration.getPaintVertexBuffers() : [], indexBuffer, segment.vertexOffset, dynamicLayoutBuffer, dynamicLayoutBuffer2, dynamicLayoutBuffer3);
	            gl.drawElements(drawMode, segment.primitiveLength * primitiveSize, gl.UNSIGNED_SHORT, segment.primitiveOffset * primitiveSize * 2);
	        }
	    }
	}

	function patternUniformValues(crossfade, painter, tile) {
	    const tileRatio = 1 / pixelsToTileUnits(tile, 1, painter.transform.tileZoom);
	    const numTiles = Math.pow(2, tile.tileID.overscaledZ);
	    const tileSizeAtNearestZoom = tile.tileSize * Math.pow(2, painter.transform.tileZoom) / numTiles;
	    const pixelX = tileSizeAtNearestZoom * (tile.tileID.canonical.x + tile.tileID.wrap * numTiles);
	    const pixelY = tileSizeAtNearestZoom * tile.tileID.canonical.y;
	    return {
	        'u_image': 0,
	        'u_texsize': tile.imageAtlasTexture.size,
	        'u_scale': [tileRatio, crossfade.fromScale, crossfade.toScale],
	        'u_fade': crossfade.t,
	        // split the pixel coord into two pairs of 16 bit numbers. The glsl spec only guarantees 16 bits of precision.
	        'u_pixel_coord_upper': [pixelX >> 16, pixelY >> 16],
	        'u_pixel_coord_lower': [pixelX & 0xFFFF, pixelY & 0xFFFF]
	    };
	}
	function bgPatternUniformValues(image, crossfade, painter, tile) {
	    const imagePosA = painter.imageManager.getPattern(image.from.toString());
	    const imagePosB = painter.imageManager.getPattern(image.to.toString());
	    const { width, height } = painter.imageManager.getPixelSize();
	    const numTiles = Math.pow(2, tile.tileID.overscaledZ);
	    const tileSizeAtNearestZoom = tile.tileSize * Math.pow(2, painter.transform.tileZoom) / numTiles;
	    const pixelX = tileSizeAtNearestZoom * (tile.tileID.canonical.x + tile.tileID.wrap * numTiles);
	    const pixelY = tileSizeAtNearestZoom * tile.tileID.canonical.y;
	    return {
	        'u_image': 0,
	        'u_pattern_tl_a': imagePosA.tl,
	        'u_pattern_br_a': imagePosA.br,
	        'u_pattern_tl_b': imagePosB.tl,
	        'u_pattern_br_b': imagePosB.br,
	        'u_texsize': [width, height],
	        'u_mix': crossfade.t,
	        'u_pattern_size_a': imagePosA.displaySize,
	        'u_pattern_size_b': imagePosB.displaySize,
	        'u_scale_a': crossfade.fromScale,
	        'u_scale_b': crossfade.toScale,
	        'u_tile_units_to_pixels': 1 / pixelsToTileUnits(tile, 1, painter.transform.tileZoom),
	        // split the pixel coord into two pairs of 16 bit numbers. The glsl spec only guarantees 16 bits of precision.
	        'u_pixel_coord_upper': [pixelX >> 16, pixelY >> 16],
	        'u_pixel_coord_lower': [pixelX & 0xFFFF, pixelY & 0xFFFF]
	    };
	}

	const fillExtrusionUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_lightpos': new performance$1.Uniform3f(context, locations.u_lightpos),
	    'u_lightintensity': new performance$1.Uniform1f(context, locations.u_lightintensity),
	    'u_lightcolor': new performance$1.Uniform3f(context, locations.u_lightcolor),
	    'u_vertical_gradient': new performance$1.Uniform1f(context, locations.u_vertical_gradient),
	    'u_opacity': new performance$1.Uniform1f(context, locations.u_opacity)
	});
	const fillExtrusionPatternUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_lightpos': new performance$1.Uniform3f(context, locations.u_lightpos),
	    'u_lightintensity': new performance$1.Uniform1f(context, locations.u_lightintensity),
	    'u_lightcolor': new performance$1.Uniform3f(context, locations.u_lightcolor),
	    'u_vertical_gradient': new performance$1.Uniform1f(context, locations.u_vertical_gradient),
	    'u_height_factor': new performance$1.Uniform1f(context, locations.u_height_factor),
	    // pattern uniforms
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_pixel_coord_upper': new performance$1.Uniform2f(context, locations.u_pixel_coord_upper),
	    'u_pixel_coord_lower': new performance$1.Uniform2f(context, locations.u_pixel_coord_lower),
	    'u_scale': new performance$1.Uniform3f(context, locations.u_scale),
	    'u_fade': new performance$1.Uniform1f(context, locations.u_fade),
	    'u_opacity': new performance$1.Uniform1f(context, locations.u_opacity)
	});
	const fillExtrusionUniformValues = (matrix, painter, shouldUseVerticalGradient, opacity) => {
	    const light = painter.style.light;
	    const _lp = light.properties.get('position');
	    const lightPos = [_lp.x, _lp.y, _lp.z];
	    const lightMat = performance$1.create$1();
	    if (light.properties.get('anchor') === 'viewport') {
	        performance$1.fromRotation(lightMat, -painter.transform.angle);
	    }
	    performance$1.transformMat3(lightPos, lightPos, lightMat);
	    const lightColor = light.properties.get('color');
	    return {
	        'u_matrix': matrix,
	        'u_lightpos': lightPos,
	        'u_lightintensity': light.properties.get('intensity'),
	        'u_lightcolor': [lightColor.r, lightColor.g, lightColor.b],
	        'u_vertical_gradient': +shouldUseVerticalGradient,
	        'u_opacity': opacity
	    };
	};
	const fillExtrusionPatternUniformValues = (matrix, painter, shouldUseVerticalGradient, opacity, coord, crossfade, tile) => {
	    return performance$1.extend(fillExtrusionUniformValues(matrix, painter, shouldUseVerticalGradient, opacity), patternUniformValues(crossfade, painter, tile), {
	        'u_height_factor': -Math.pow(2, coord.overscaledZ) / tile.tileSize / 8
	    });
	};

	const fillUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix)
	});
	const fillPatternUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_pixel_coord_upper': new performance$1.Uniform2f(context, locations.u_pixel_coord_upper),
	    'u_pixel_coord_lower': new performance$1.Uniform2f(context, locations.u_pixel_coord_lower),
	    'u_scale': new performance$1.Uniform3f(context, locations.u_scale),
	    'u_fade': new performance$1.Uniform1f(context, locations.u_fade)
	});
	const fillOutlineUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_world': new performance$1.Uniform2f(context, locations.u_world)
	});
	const fillOutlinePatternUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_world': new performance$1.Uniform2f(context, locations.u_world),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_pixel_coord_upper': new performance$1.Uniform2f(context, locations.u_pixel_coord_upper),
	    'u_pixel_coord_lower': new performance$1.Uniform2f(context, locations.u_pixel_coord_lower),
	    'u_scale': new performance$1.Uniform3f(context, locations.u_scale),
	    'u_fade': new performance$1.Uniform1f(context, locations.u_fade)
	});
	const fillUniformValues = (matrix) => ({
	    'u_matrix': matrix
	});
	const fillPatternUniformValues = (matrix, painter, crossfade, tile) => performance$1.extend(fillUniformValues(matrix), patternUniformValues(crossfade, painter, tile));
	const fillOutlineUniformValues = (matrix, drawingBufferSize) => ({
	    'u_matrix': matrix,
	    'u_world': drawingBufferSize
	});
	const fillOutlinePatternUniformValues = (matrix, painter, crossfade, tile, drawingBufferSize) => performance$1.extend(fillPatternUniformValues(matrix, painter, crossfade, tile), {
	    'u_world': drawingBufferSize
	});

	const circleUniforms = (context, locations) => ({
	    'u_camera_to_center_distance': new performance$1.Uniform1f(context, locations.u_camera_to_center_distance),
	    'u_scale_with_map': new performance$1.Uniform1i(context, locations.u_scale_with_map),
	    'u_pitch_with_map': new performance$1.Uniform1i(context, locations.u_pitch_with_map),
	    'u_extrude_scale': new performance$1.Uniform2f(context, locations.u_extrude_scale),
	    'u_device_pixel_ratio': new performance$1.Uniform1f(context, locations.u_device_pixel_ratio),
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix)
	});
	const circleUniformValues = (painter, coord, tile, layer) => {
	    const transform = painter.transform;
	    let pitchWithMap, extrudeScale;
	    if (layer.paint.get('circle-pitch-alignment') === 'map') {
	        const pixelRatio = pixelsToTileUnits(tile, 1, transform.zoom);
	        pitchWithMap = true;
	        extrudeScale = [pixelRatio, pixelRatio];
	    }
	    else {
	        pitchWithMap = false;
	        extrudeScale = transform.pixelsToGLUnits;
	    }
	    return {
	        'u_camera_to_center_distance': transform.cameraToCenterDistance,
	        'u_scale_with_map': +(layer.paint.get('circle-pitch-scale') === 'map'),
	        'u_matrix': painter.translatePosMatrix(coord.posMatrix, tile, layer.paint.get('circle-translate'), layer.paint.get('circle-translate-anchor')),
	        'u_pitch_with_map': +(pitchWithMap),
	        'u_device_pixel_ratio': painter.pixelRatio,
	        'u_extrude_scale': extrudeScale
	    };
	};

	const collisionUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_camera_to_center_distance': new performance$1.Uniform1f(context, locations.u_camera_to_center_distance),
	    'u_pixels_to_tile_units': new performance$1.Uniform1f(context, locations.u_pixels_to_tile_units),
	    'u_extrude_scale': new performance$1.Uniform2f(context, locations.u_extrude_scale),
	    'u_overscale_factor': new performance$1.Uniform1f(context, locations.u_overscale_factor)
	});
	const collisionCircleUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_inv_matrix': new performance$1.UniformMatrix4f(context, locations.u_inv_matrix),
	    'u_camera_to_center_distance': new performance$1.Uniform1f(context, locations.u_camera_to_center_distance),
	    'u_viewport_size': new performance$1.Uniform2f(context, locations.u_viewport_size)
	});
	const collisionUniformValues = (matrix, transform, tile) => {
	    const pixelRatio = pixelsToTileUnits(tile, 1, transform.zoom);
	    const scale = Math.pow(2, transform.zoom - tile.tileID.overscaledZ);
	    const overscaleFactor = tile.tileID.overscaleFactor();
	    return {
	        'u_matrix': matrix,
	        'u_camera_to_center_distance': transform.cameraToCenterDistance,
	        'u_pixels_to_tile_units': pixelRatio,
	        'u_extrude_scale': [transform.pixelsToGLUnits[0] / (pixelRatio * scale),
	            transform.pixelsToGLUnits[1] / (pixelRatio * scale)],
	        'u_overscale_factor': overscaleFactor
	    };
	};
	const collisionCircleUniformValues = (matrix, invMatrix, transform) => {
	    return {
	        'u_matrix': matrix,
	        'u_inv_matrix': invMatrix,
	        'u_camera_to_center_distance': transform.cameraToCenterDistance,
	        'u_viewport_size': [transform.width, transform.height]
	    };
	};

	const debugUniforms = (context, locations) => ({
	    'u_color': new performance$1.UniformColor(context, locations.u_color),
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_overlay': new performance$1.Uniform1i(context, locations.u_overlay),
	    'u_overlay_scale': new performance$1.Uniform1f(context, locations.u_overlay_scale)
	});
	const debugUniformValues = (matrix, color, scaleRatio = 1) => ({
	    'u_matrix': matrix,
	    'u_color': color,
	    'u_overlay': 0,
	    'u_overlay_scale': scaleRatio
	});

	const clippingMaskUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix)
	});
	const clippingMaskUniformValues = (matrix) => ({
	    'u_matrix': matrix
	});

	const heatmapUniforms = (context, locations) => ({
	    'u_extrude_scale': new performance$1.Uniform1f(context, locations.u_extrude_scale),
	    'u_intensity': new performance$1.Uniform1f(context, locations.u_intensity),
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix)
	});
	const heatmapTextureUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_world': new performance$1.Uniform2f(context, locations.u_world),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_color_ramp': new performance$1.Uniform1i(context, locations.u_color_ramp),
	    'u_opacity': new performance$1.Uniform1f(context, locations.u_opacity)
	});
	const heatmapUniformValues = (matrix, tile, zoom, intensity) => ({
	    'u_matrix': matrix,
	    'u_extrude_scale': pixelsToTileUnits(tile, 1, zoom),
	    'u_intensity': intensity
	});
	const heatmapTextureUniformValues = (painter, layer, textureUnit, colorRampUnit) => {
	    const matrix = performance$1.create();
	    performance$1.ortho(matrix, 0, painter.width, painter.height, 0, 0, 1);
	    const gl = painter.context.gl;
	    return {
	        'u_matrix': matrix,
	        'u_world': [gl.drawingBufferWidth, gl.drawingBufferHeight],
	        'u_image': textureUnit,
	        'u_color_ramp': colorRampUnit,
	        'u_opacity': layer.paint.get('heatmap-opacity')
	    };
	};

	const hillshadeUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_latrange': new performance$1.Uniform2f(context, locations.u_latrange),
	    'u_light': new performance$1.Uniform2f(context, locations.u_light),
	    'u_shadow': new performance$1.UniformColor(context, locations.u_shadow),
	    'u_highlight': new performance$1.UniformColor(context, locations.u_highlight),
	    'u_accent': new performance$1.UniformColor(context, locations.u_accent)
	});
	const hillshadePrepareUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_dimension': new performance$1.Uniform2f(context, locations.u_dimension),
	    'u_zoom': new performance$1.Uniform1f(context, locations.u_zoom),
	    'u_unpack': new performance$1.Uniform4f(context, locations.u_unpack)
	});
	const hillshadeUniformValues = (painter, tile, layer, coord) => {
	    const shadow = layer.paint.get('hillshade-shadow-color');
	    const highlight = layer.paint.get('hillshade-highlight-color');
	    const accent = layer.paint.get('hillshade-accent-color');
	    let azimuthal = layer.paint.get('hillshade-illumination-direction') * (Math.PI / 180);
	    // modify azimuthal angle by map rotation if light is anchored at the viewport
	    if (layer.paint.get('hillshade-illumination-anchor') === 'viewport') {
	        azimuthal -= painter.transform.angle;
	    }
	    const align = !painter.options.moving;
	    return {
	        'u_matrix': coord ? coord.posMatrix : painter.transform.calculatePosMatrix(tile.tileID.toUnwrapped(), align),
	        'u_image': 0,
	        'u_latrange': getTileLatRange(painter, tile.tileID),
	        'u_light': [layer.paint.get('hillshade-exaggeration'), azimuthal],
	        'u_shadow': shadow,
	        'u_highlight': highlight,
	        'u_accent': accent
	    };
	};
	const hillshadeUniformPrepareValues = (tileID, dem) => {
	    const stride = dem.stride;
	    const matrix = performance$1.create();
	    // Flip rendering at y axis.
	    performance$1.ortho(matrix, 0, performance$1.EXTENT, -performance$1.EXTENT, 0, 0, 1);
	    performance$1.translate(matrix, matrix, [0, -performance$1.EXTENT, 0]);
	    return {
	        'u_matrix': matrix,
	        'u_image': 1,
	        'u_dimension': [stride, stride],
	        'u_zoom': tileID.overscaledZ,
	        'u_unpack': dem.getUnpackVector()
	    };
	};
	function getTileLatRange(painter, tileID) {
	    // for scaling the magnitude of a points slope by its latitude
	    const tilesAtZoom = Math.pow(2, tileID.canonical.z);
	    const y = tileID.canonical.y;
	    return [
	        new performance$1.MercatorCoordinate(0, y / tilesAtZoom).toLngLat().lat,
	        new performance$1.MercatorCoordinate(0, (y + 1) / tilesAtZoom).toLngLat().lat
	    ];
	}

	const lineUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_ratio': new performance$1.Uniform1f(context, locations.u_ratio),
	    'u_device_pixel_ratio': new performance$1.Uniform1f(context, locations.u_device_pixel_ratio),
	    'u_units_to_pixels': new performance$1.Uniform2f(context, locations.u_units_to_pixels)
	});
	const lineGradientUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_ratio': new performance$1.Uniform1f(context, locations.u_ratio),
	    'u_device_pixel_ratio': new performance$1.Uniform1f(context, locations.u_device_pixel_ratio),
	    'u_units_to_pixels': new performance$1.Uniform2f(context, locations.u_units_to_pixels),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_image_height': new performance$1.Uniform1f(context, locations.u_image_height)
	});
	const linePatternUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_ratio': new performance$1.Uniform1f(context, locations.u_ratio),
	    'u_device_pixel_ratio': new performance$1.Uniform1f(context, locations.u_device_pixel_ratio),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_units_to_pixels': new performance$1.Uniform2f(context, locations.u_units_to_pixels),
	    'u_scale': new performance$1.Uniform3f(context, locations.u_scale),
	    'u_fade': new performance$1.Uniform1f(context, locations.u_fade)
	});
	const lineSDFUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_ratio': new performance$1.Uniform1f(context, locations.u_ratio),
	    'u_device_pixel_ratio': new performance$1.Uniform1f(context, locations.u_device_pixel_ratio),
	    'u_units_to_pixels': new performance$1.Uniform2f(context, locations.u_units_to_pixels),
	    'u_patternscale_a': new performance$1.Uniform2f(context, locations.u_patternscale_a),
	    'u_patternscale_b': new performance$1.Uniform2f(context, locations.u_patternscale_b),
	    'u_sdfgamma': new performance$1.Uniform1f(context, locations.u_sdfgamma),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_tex_y_a': new performance$1.Uniform1f(context, locations.u_tex_y_a),
	    'u_tex_y_b': new performance$1.Uniform1f(context, locations.u_tex_y_b),
	    'u_mix': new performance$1.Uniform1f(context, locations.u_mix)
	});
	const lineUniformValues = (painter, tile, layer, coord) => {
	    const transform = painter.transform;
	    return {
	        'u_matrix': calculateMatrix(painter, tile, layer, coord),
	        'u_ratio': 1 / pixelsToTileUnits(tile, 1, transform.zoom),
	        'u_device_pixel_ratio': painter.pixelRatio,
	        'u_units_to_pixels': [
	            1 / transform.pixelsToGLUnits[0],
	            1 / transform.pixelsToGLUnits[1]
	        ]
	    };
	};
	const lineGradientUniformValues = (painter, tile, layer, imageHeight, coord) => {
	    return performance$1.extend(lineUniformValues(painter, tile, layer, coord), {
	        'u_image': 0,
	        'u_image_height': imageHeight,
	    });
	};
	const linePatternUniformValues = (painter, tile, layer, crossfade, coord) => {
	    const transform = painter.transform;
	    const tileZoomRatio = calculateTileRatio(tile, transform);
	    return {
	        'u_matrix': calculateMatrix(painter, tile, layer, coord),
	        'u_texsize': tile.imageAtlasTexture.size,
	        // camera zoom ratio
	        'u_ratio': 1 / pixelsToTileUnits(tile, 1, transform.zoom),
	        'u_device_pixel_ratio': painter.pixelRatio,
	        'u_image': 0,
	        'u_scale': [tileZoomRatio, crossfade.fromScale, crossfade.toScale],
	        'u_fade': crossfade.t,
	        'u_units_to_pixels': [
	            1 / transform.pixelsToGLUnits[0],
	            1 / transform.pixelsToGLUnits[1]
	        ]
	    };
	};
	const lineSDFUniformValues = (painter, tile, layer, dasharray, crossfade, coord) => {
	    const transform = painter.transform;
	    const lineAtlas = painter.lineAtlas;
	    const tileRatio = calculateTileRatio(tile, transform);
	    const round = layer.layout.get('line-cap') === 'round';
	    const posA = lineAtlas.getDash(dasharray.from, round);
	    const posB = lineAtlas.getDash(dasharray.to, round);
	    const widthA = posA.width * crossfade.fromScale;
	    const widthB = posB.width * crossfade.toScale;
	    return performance$1.extend(lineUniformValues(painter, tile, layer, coord), {
	        'u_patternscale_a': [tileRatio / widthA, -posA.height / 2],
	        'u_patternscale_b': [tileRatio / widthB, -posB.height / 2],
	        'u_sdfgamma': lineAtlas.width / (Math.min(widthA, widthB) * 256 * painter.pixelRatio) / 2,
	        'u_image': 0,
	        'u_tex_y_a': posA.y,
	        'u_tex_y_b': posB.y,
	        'u_mix': crossfade.t
	    });
	};
	function calculateTileRatio(tile, transform) {
	    return 1 / pixelsToTileUnits(tile, 1, transform.tileZoom);
	}
	function calculateMatrix(painter, tile, layer, coord) {
	    return painter.translatePosMatrix(coord ? coord.posMatrix : tile.tileID.posMatrix, tile, layer.paint.get('line-translate'), layer.paint.get('line-translate-anchor'));
	}

	const rasterUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_tl_parent': new performance$1.Uniform2f(context, locations.u_tl_parent),
	    'u_scale_parent': new performance$1.Uniform1f(context, locations.u_scale_parent),
	    'u_buffer_scale': new performance$1.Uniform1f(context, locations.u_buffer_scale),
	    'u_fade_t': new performance$1.Uniform1f(context, locations.u_fade_t),
	    'u_opacity': new performance$1.Uniform1f(context, locations.u_opacity),
	    'u_image0': new performance$1.Uniform1i(context, locations.u_image0),
	    'u_image1': new performance$1.Uniform1i(context, locations.u_image1),
	    'u_brightness_low': new performance$1.Uniform1f(context, locations.u_brightness_low),
	    'u_brightness_high': new performance$1.Uniform1f(context, locations.u_brightness_high),
	    'u_saturation_factor': new performance$1.Uniform1f(context, locations.u_saturation_factor),
	    'u_contrast_factor': new performance$1.Uniform1f(context, locations.u_contrast_factor),
	    'u_spin_weights': new performance$1.Uniform3f(context, locations.u_spin_weights)
	});
	const rasterUniformValues = (matrix, parentTL, parentScaleBy, fade, layer) => ({
	    'u_matrix': matrix,
	    'u_tl_parent': parentTL,
	    'u_scale_parent': parentScaleBy,
	    'u_buffer_scale': 1,
	    'u_fade_t': fade.mix,
	    'u_opacity': fade.opacity * layer.paint.get('raster-opacity'),
	    'u_image0': 0,
	    'u_image1': 1,
	    'u_brightness_low': layer.paint.get('raster-brightness-min'),
	    'u_brightness_high': layer.paint.get('raster-brightness-max'),
	    'u_saturation_factor': saturationFactor(layer.paint.get('raster-saturation')),
	    'u_contrast_factor': contrastFactor(layer.paint.get('raster-contrast')),
	    'u_spin_weights': spinWeights(layer.paint.get('raster-hue-rotate'))
	});
	function spinWeights(angle) {
	    angle *= Math.PI / 180;
	    const s = Math.sin(angle);
	    const c = Math.cos(angle);
	    return [
	        (2 * c + 1) / 3,
	        (-Math.sqrt(3) * s - c + 1) / 3,
	        (Math.sqrt(3) * s - c + 1) / 3
	    ];
	}
	function contrastFactor(contrast) {
	    return contrast > 0 ?
	        1 / (1 - contrast) :
	        1 + contrast;
	}
	function saturationFactor(saturation) {
	    return saturation > 0 ?
	        1 - 1 / (1.001 - saturation) :
	        -saturation;
	}

	const symbolIconUniforms = (context, locations) => ({
	    'u_is_size_zoom_constant': new performance$1.Uniform1i(context, locations.u_is_size_zoom_constant),
	    'u_is_size_feature_constant': new performance$1.Uniform1i(context, locations.u_is_size_feature_constant),
	    'u_size_t': new performance$1.Uniform1f(context, locations.u_size_t),
	    'u_size': new performance$1.Uniform1f(context, locations.u_size),
	    'u_camera_to_center_distance': new performance$1.Uniform1f(context, locations.u_camera_to_center_distance),
	    'u_pitch': new performance$1.Uniform1f(context, locations.u_pitch),
	    'u_rotate_symbol': new performance$1.Uniform1i(context, locations.u_rotate_symbol),
	    'u_aspect_ratio': new performance$1.Uniform1f(context, locations.u_aspect_ratio),
	    'u_fade_change': new performance$1.Uniform1f(context, locations.u_fade_change),
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_label_plane_matrix': new performance$1.UniformMatrix4f(context, locations.u_label_plane_matrix),
	    'u_coord_matrix': new performance$1.UniformMatrix4f(context, locations.u_coord_matrix),
	    'u_is_text': new performance$1.Uniform1i(context, locations.u_is_text),
	    'u_pitch_with_map': new performance$1.Uniform1i(context, locations.u_pitch_with_map),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_texture': new performance$1.Uniform1i(context, locations.u_texture)
	});
	const symbolSDFUniforms = (context, locations) => ({
	    'u_is_size_zoom_constant': new performance$1.Uniform1i(context, locations.u_is_size_zoom_constant),
	    'u_is_size_feature_constant': new performance$1.Uniform1i(context, locations.u_is_size_feature_constant),
	    'u_size_t': new performance$1.Uniform1f(context, locations.u_size_t),
	    'u_size': new performance$1.Uniform1f(context, locations.u_size),
	    'u_camera_to_center_distance': new performance$1.Uniform1f(context, locations.u_camera_to_center_distance),
	    'u_pitch': new performance$1.Uniform1f(context, locations.u_pitch),
	    'u_rotate_symbol': new performance$1.Uniform1i(context, locations.u_rotate_symbol),
	    'u_aspect_ratio': new performance$1.Uniform1f(context, locations.u_aspect_ratio),
	    'u_fade_change': new performance$1.Uniform1f(context, locations.u_fade_change),
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_label_plane_matrix': new performance$1.UniformMatrix4f(context, locations.u_label_plane_matrix),
	    'u_coord_matrix': new performance$1.UniformMatrix4f(context, locations.u_coord_matrix),
	    'u_is_text': new performance$1.Uniform1i(context, locations.u_is_text),
	    'u_pitch_with_map': new performance$1.Uniform1i(context, locations.u_pitch_with_map),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_texture': new performance$1.Uniform1i(context, locations.u_texture),
	    'u_gamma_scale': new performance$1.Uniform1f(context, locations.u_gamma_scale),
	    'u_device_pixel_ratio': new performance$1.Uniform1f(context, locations.u_device_pixel_ratio),
	    'u_is_halo': new performance$1.Uniform1i(context, locations.u_is_halo)
	});
	const symbolTextAndIconUniforms = (context, locations) => ({
	    'u_is_size_zoom_constant': new performance$1.Uniform1i(context, locations.u_is_size_zoom_constant),
	    'u_is_size_feature_constant': new performance$1.Uniform1i(context, locations.u_is_size_feature_constant),
	    'u_size_t': new performance$1.Uniform1f(context, locations.u_size_t),
	    'u_size': new performance$1.Uniform1f(context, locations.u_size),
	    'u_camera_to_center_distance': new performance$1.Uniform1f(context, locations.u_camera_to_center_distance),
	    'u_pitch': new performance$1.Uniform1f(context, locations.u_pitch),
	    'u_rotate_symbol': new performance$1.Uniform1i(context, locations.u_rotate_symbol),
	    'u_aspect_ratio': new performance$1.Uniform1f(context, locations.u_aspect_ratio),
	    'u_fade_change': new performance$1.Uniform1f(context, locations.u_fade_change),
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_label_plane_matrix': new performance$1.UniformMatrix4f(context, locations.u_label_plane_matrix),
	    'u_coord_matrix': new performance$1.UniformMatrix4f(context, locations.u_coord_matrix),
	    'u_is_text': new performance$1.Uniform1i(context, locations.u_is_text),
	    'u_pitch_with_map': new performance$1.Uniform1i(context, locations.u_pitch_with_map),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_texsize_icon': new performance$1.Uniform2f(context, locations.u_texsize_icon),
	    'u_texture': new performance$1.Uniform1i(context, locations.u_texture),
	    'u_texture_icon': new performance$1.Uniform1i(context, locations.u_texture_icon),
	    'u_gamma_scale': new performance$1.Uniform1f(context, locations.u_gamma_scale),
	    'u_device_pixel_ratio': new performance$1.Uniform1f(context, locations.u_device_pixel_ratio),
	    'u_is_halo': new performance$1.Uniform1i(context, locations.u_is_halo)
	});
	const symbolIconUniformValues = (functionType, size, rotateInShader, pitchWithMap, painter, matrix, labelPlaneMatrix, glCoordMatrix, isText, texSize) => {
	    const transform = painter.transform;
	    return {
	        'u_is_size_zoom_constant': +(functionType === 'constant' || functionType === 'source'),
	        'u_is_size_feature_constant': +(functionType === 'constant' || functionType === 'camera'),
	        'u_size_t': size ? size.uSizeT : 0,
	        'u_size': size ? size.uSize : 0,
	        'u_camera_to_center_distance': transform.cameraToCenterDistance,
	        'u_pitch': transform.pitch / 360 * 2 * Math.PI,
	        'u_rotate_symbol': +rotateInShader,
	        'u_aspect_ratio': transform.width / transform.height,
	        'u_fade_change': painter.options.fadeDuration ? painter.symbolFadeChange : 1,
	        'u_matrix': matrix,
	        'u_label_plane_matrix': labelPlaneMatrix,
	        'u_coord_matrix': glCoordMatrix,
	        'u_is_text': +isText,
	        'u_pitch_with_map': +pitchWithMap,
	        'u_texsize': texSize,
	        'u_texture': 0
	    };
	};
	const symbolSDFUniformValues = (functionType, size, rotateInShader, pitchWithMap, painter, matrix, labelPlaneMatrix, glCoordMatrix, isText, texSize, isHalo) => {
	    const transform = painter.transform;
	    return performance$1.extend(symbolIconUniformValues(functionType, size, rotateInShader, pitchWithMap, painter, matrix, labelPlaneMatrix, glCoordMatrix, isText, texSize), {
	        'u_gamma_scale': (pitchWithMap ? Math.cos(transform._pitch) * transform.cameraToCenterDistance : 1),
	        'u_device_pixel_ratio': painter.pixelRatio,
	        'u_is_halo': +isHalo
	    });
	};
	const symbolTextAndIconUniformValues = (functionType, size, rotateInShader, pitchWithMap, painter, matrix, labelPlaneMatrix, glCoordMatrix, texSizeSDF, texSizeIcon) => {
	    return performance$1.extend(symbolSDFUniformValues(functionType, size, rotateInShader, pitchWithMap, painter, matrix, labelPlaneMatrix, glCoordMatrix, true, texSizeSDF, true), {
	        'u_texsize_icon': texSizeIcon,
	        'u_texture_icon': 1
	    });
	};

	const backgroundUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_opacity': new performance$1.Uniform1f(context, locations.u_opacity),
	    'u_color': new performance$1.UniformColor(context, locations.u_color)
	});
	const backgroundPatternUniforms = (context, locations) => ({
	    'u_matrix': new performance$1.UniformMatrix4f(context, locations.u_matrix),
	    'u_opacity': new performance$1.Uniform1f(context, locations.u_opacity),
	    'u_image': new performance$1.Uniform1i(context, locations.u_image),
	    'u_pattern_tl_a': new performance$1.Uniform2f(context, locations.u_pattern_tl_a),
	    'u_pattern_br_a': new performance$1.Uniform2f(context, locations.u_pattern_br_a),
	    'u_pattern_tl_b': new performance$1.Uniform2f(context, locations.u_pattern_tl_b),
	    'u_pattern_br_b': new performance$1.Uniform2f(context, locations.u_pattern_br_b),
	    'u_texsize': new performance$1.Uniform2f(context, locations.u_texsize),
	    'u_mix': new performance$1.Uniform1f(context, locations.u_mix),
	    'u_pattern_size_a': new performance$1.Uniform2f(context, locations.u_pattern_size_a),
	    'u_pattern_size_b': new performance$1.Uniform2f(context, locations.u_pattern_size_b),
	    'u_scale_a': new performance$1.Uniform1f(context, locations.u_scale_a),
	    'u_scale_b': new performance$1.Uniform1f(context, locations.u_scale_b),
	    'u_pixel_coord_upper': new performance$1.Uniform2f(context, locations.u_pixel_coord_upper),
	    'u_pixel_coord_lower': new performance$1.Uniform2f(context, locations.u_pixel_coord_lower),
	    'u_tile_units_to_pixels': new performance$1.Uniform1f(context, locations.u_tile_units_to_pixels)
	});
	const backgroundUniformValues = (matrix, opacity, color) => ({
	    'u_matrix': matrix,
	    'u_opacity': opacity,
	    'u_color': color
	});
	const backgroundPatternUniformValues = (matrix, opacity, painter, image, tile, crossfade) => performance$1.extend(bgPatternUniformValues(image, crossfade, painter, tile), {
	    'u_matrix': matrix,
	    'u_opacity': opacity
	});

	const programUniforms = {
	    fillExtrusion: fillExtrusionUniforms,
	    fillExtrusionPattern: fillExtrusionPatternUniforms,
	    fill: fillUniforms,
	    fillPattern: fillPatternUniforms,
	    fillOutline: fillOutlineUniforms,
	    fillOutlinePattern: fillOutlinePatternUniforms,
	    circle: circleUniforms,
	    collisionBox: collisionUniforms,
	    collisionCircle: collisionCircleUniforms,
	    debug: debugUniforms,
	    clippingMask: clippingMaskUniforms,
	    heatmap: heatmapUniforms,
	    heatmapTexture: heatmapTextureUniforms,
	    hillshade: hillshadeUniforms,
	    hillshadePrepare: hillshadePrepareUniforms,
	    line: lineUniforms,
	    lineGradient: lineGradientUniforms,
	    linePattern: linePatternUniforms,
	    lineSDF: lineSDFUniforms,
	    raster: rasterUniforms,
	    symbolIcon: symbolIconUniforms,
	    symbolSDF: symbolSDFUniforms,
	    symbolTextAndIcon: symbolTextAndIconUniforms,
	    background: backgroundUniforms,
	    backgroundPattern: backgroundPatternUniforms,
	    terrain: terrainUniforms,
	    terrainDepth: terrainDepthUniforms,
	    terrainCoords: terrainCoordsUniforms
	};

	/**
	 * @internal
	 * an index buffer class
	 */
	class IndexBuffer {
	    constructor(context, array, dynamicDraw) {
	        this.context = context;
	        const gl = context.gl;
	        this.buffer = gl.createBuffer();
	        this.dynamicDraw = Boolean(dynamicDraw);
	        // The bound index buffer is part of vertex array object state. We don't want to
	        // modify whatever VAO happens to be currently bound, so make sure the default
	        // vertex array provided by the context is bound instead.
	        this.context.unbindVAO();
	        context.bindElementBuffer.set(this.buffer);
	        gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, array.arrayBuffer, this.dynamicDraw ? gl.DYNAMIC_DRAW : gl.STATIC_DRAW);
	        if (!this.dynamicDraw) {
	            delete array.arrayBuffer;
	        }
	    }
	    bind() {
	        this.context.bindElementBuffer.set(this.buffer);
	    }
	    updateData(array) {
	        const gl = this.context.gl;
	        if (!this.dynamicDraw)
	            throw new Error('Attempted to update data while not in dynamic mode.');
	        // The right VAO will get this buffer re-bound later in VertexArrayObject#bind
	        // See https://github.com/mapbox/mapbox-gl-js/issues/5620
	        this.context.unbindVAO();
	        this.bind();
	        gl.bufferSubData(gl.ELEMENT_ARRAY_BUFFER, 0, array.arrayBuffer);
	    }
	    destroy() {
	        const gl = this.context.gl;
	        if (this.buffer) {
	            gl.deleteBuffer(this.buffer);
	            delete this.buffer;
	        }
	    }
	}

	/**
	 * An Enum for AttributeType
	 */
	const AttributeType = {
	    Int8: 'BYTE',
	    Uint8: 'UNSIGNED_BYTE',
	    Int16: 'SHORT',
	    Uint16: 'UNSIGNED_SHORT',
	    Int32: 'INT',
	    Uint32: 'UNSIGNED_INT',
	    Float32: 'FLOAT'
	};
	/**
	 * @internal
	 * The `VertexBuffer` class turns a `StructArray` into a WebGL buffer. Each member of the StructArray's
	 * Struct type is converted to a WebGL attribute.
	 */
	class VertexBuffer {
	    /**
	     * @param dynamicDraw - Whether this buffer will be repeatedly updated.
	     */
	    constructor(context, array, attributes, dynamicDraw) {
	        this.length = array.length;
	        this.attributes = attributes;
	        this.itemSize = array.bytesPerElement;
	        this.dynamicDraw = dynamicDraw;
	        this.context = context;
	        const gl = context.gl;
	        this.buffer = gl.createBuffer();
	        context.bindVertexBuffer.set(this.buffer);
	        gl.bufferData(gl.ARRAY_BUFFER, array.arrayBuffer, this.dynamicDraw ? gl.DYNAMIC_DRAW : gl.STATIC_DRAW);
	        if (!this.dynamicDraw) {
	            delete array.arrayBuffer;
	        }
	    }
	    bind() {
	        this.context.bindVertexBuffer.set(this.buffer);
	    }
	    updateData(array) {
	        if (array.length !== this.length)
	            throw new Error(`Length of new data is ${array.length}, which doesn't match current length of ${this.length}`);
	        const gl = this.context.gl;
	        this.bind();
	        gl.bufferSubData(gl.ARRAY_BUFFER, 0, array.arrayBuffer);
	    }
	    enableAttributes(gl, program) {
	        for (let j = 0; j < this.attributes.length; j++) {
	            const member = this.attributes[j];
	            const attribIndex = program.attributes[member.name];
	            if (attribIndex !== undefined) {
	                gl.enableVertexAttribArray(attribIndex);
	            }
	        }
	    }
	    /**
	     * Set the attribute pointers in a WebGL context
	     * @param gl - The WebGL context
	     * @param program - The active WebGL program
	     * @param vertexOffset - Index of the starting vertex of the segment
	     */
	    setVertexAttribPointers(gl, program, vertexOffset) {
	        for (let j = 0; j < this.attributes.length; j++) {
	            const member = this.attributes[j];
	            const attribIndex = program.attributes[member.name];
	            if (attribIndex !== undefined) {
	                gl.vertexAttribPointer(attribIndex, member.components, gl[AttributeType[member.type]], false, this.itemSize, member.offset + (this.itemSize * (vertexOffset || 0)));
	            }
	        }
	    }
	    /**
	     * Destroy the GL buffer bound to the given WebGL context
	     */
	    destroy() {
	        const gl = this.context.gl;
	        if (this.buffer) {
	            gl.deleteBuffer(this.buffer);
	            delete this.buffer;
	        }
	    }
	}

	const cache = new WeakMap();
	function isWebGL2(gl) {
	    var _a;
	    if (cache.has(gl)) {
	        return cache.get(gl);
	    }
	    else {
	        const value = (_a = gl.getParameter(gl.VERSION)) === null || _a === void 0 ? void 0 : _a.startsWith('WebGL 2.0');
	        cache.set(gl, value);
	        return value;
	    }
	}

	class BaseValue {
	    constructor(context) {
	        this.gl = context.gl;
	        this.default = this.getDefault();
	        this.current = this.default;
	        this.dirty = false;
	    }
	    get() {
	        return this.current;
	    }
	    set(value) {
	        // overridden in child classes;
	    }
	    getDefault() {
	        return this.default; // overriden in child classes
	    }
	    setDefault() {
	        this.set(this.default);
	    }
	}
	class ClearColor extends BaseValue {
	    getDefault() {
	        return performance$1.Color.transparent;
	    }
	    set(v) {
	        const c = this.current;
	        if (v.r === c.r && v.g === c.g && v.b === c.b && v.a === c.a && !this.dirty)
	            return;
	        this.gl.clearColor(v.r, v.g, v.b, v.a);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class ClearDepth extends BaseValue {
	    getDefault() {
	        return 1;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.clearDepth(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class ClearStencil extends BaseValue {
	    getDefault() {
	        return 0;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.clearStencil(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class ColorMask extends BaseValue {
	    getDefault() {
	        return [true, true, true, true];
	    }
	    set(v) {
	        const c = this.current;
	        if (v[0] === c[0] && v[1] === c[1] && v[2] === c[2] && v[3] === c[3] && !this.dirty)
	            return;
	        this.gl.colorMask(v[0], v[1], v[2], v[3]);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class DepthMask extends BaseValue {
	    getDefault() {
	        return true;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.depthMask(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class StencilMask extends BaseValue {
	    getDefault() {
	        return 0xFF;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.stencilMask(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class StencilFunc extends BaseValue {
	    getDefault() {
	        return {
	            func: this.gl.ALWAYS,
	            ref: 0,
	            mask: 0xFF
	        };
	    }
	    set(v) {
	        const c = this.current;
	        if (v.func === c.func && v.ref === c.ref && v.mask === c.mask && !this.dirty)
	            return;
	        this.gl.stencilFunc(v.func, v.ref, v.mask);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class StencilOp extends BaseValue {
	    getDefault() {
	        const gl = this.gl;
	        return [gl.KEEP, gl.KEEP, gl.KEEP];
	    }
	    set(v) {
	        const c = this.current;
	        if (v[0] === c[0] && v[1] === c[1] && v[2] === c[2] && !this.dirty)
	            return;
	        this.gl.stencilOp(v[0], v[1], v[2]);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class StencilTest extends BaseValue {
	    getDefault() {
	        return false;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        if (v) {
	            gl.enable(gl.STENCIL_TEST);
	        }
	        else {
	            gl.disable(gl.STENCIL_TEST);
	        }
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class DepthRange extends BaseValue {
	    getDefault() {
	        return [0, 1];
	    }
	    set(v) {
	        const c = this.current;
	        if (v[0] === c[0] && v[1] === c[1] && !this.dirty)
	            return;
	        this.gl.depthRange(v[0], v[1]);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class DepthTest extends BaseValue {
	    getDefault() {
	        return false;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        if (v) {
	            gl.enable(gl.DEPTH_TEST);
	        }
	        else {
	            gl.disable(gl.DEPTH_TEST);
	        }
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class DepthFunc extends BaseValue {
	    getDefault() {
	        return this.gl.LESS;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.depthFunc(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class Blend extends BaseValue {
	    getDefault() {
	        return false;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        if (v) {
	            gl.enable(gl.BLEND);
	        }
	        else {
	            gl.disable(gl.BLEND);
	        }
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BlendFunc extends BaseValue {
	    getDefault() {
	        const gl = this.gl;
	        return [gl.ONE, gl.ZERO];
	    }
	    set(v) {
	        const c = this.current;
	        if (v[0] === c[0] && v[1] === c[1] && !this.dirty)
	            return;
	        this.gl.blendFunc(v[0], v[1]);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BlendColor extends BaseValue {
	    getDefault() {
	        return performance$1.Color.transparent;
	    }
	    set(v) {
	        const c = this.current;
	        if (v.r === c.r && v.g === c.g && v.b === c.b && v.a === c.a && !this.dirty)
	            return;
	        this.gl.blendColor(v.r, v.g, v.b, v.a);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BlendEquation extends BaseValue {
	    getDefault() {
	        return this.gl.FUNC_ADD;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.blendEquation(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class CullFace extends BaseValue {
	    getDefault() {
	        return false;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        if (v) {
	            gl.enable(gl.CULL_FACE);
	        }
	        else {
	            gl.disable(gl.CULL_FACE);
	        }
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class CullFaceSide extends BaseValue {
	    getDefault() {
	        return this.gl.BACK;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.cullFace(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class FrontFace extends BaseValue {
	    getDefault() {
	        return this.gl.CCW;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.frontFace(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class ProgramValue extends BaseValue {
	    getDefault() {
	        return null;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.useProgram(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class ActiveTextureUnit extends BaseValue {
	    getDefault() {
	        return this.gl.TEXTURE0;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.gl.activeTexture(v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class Viewport extends BaseValue {
	    getDefault() {
	        const gl = this.gl;
	        return [0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight];
	    }
	    set(v) {
	        const c = this.current;
	        if (v[0] === c[0] && v[1] === c[1] && v[2] === c[2] && v[3] === c[3] && !this.dirty)
	            return;
	        this.gl.viewport(v[0], v[1], v[2], v[3]);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BindFramebuffer extends BaseValue {
	    getDefault() {
	        return null;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        gl.bindFramebuffer(gl.FRAMEBUFFER, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BindRenderbuffer extends BaseValue {
	    getDefault() {
	        return null;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        gl.bindRenderbuffer(gl.RENDERBUFFER, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BindTexture extends BaseValue {
	    getDefault() {
	        return null;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        gl.bindTexture(gl.TEXTURE_2D, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BindVertexBuffer extends BaseValue {
	    getDefault() {
	        return null;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        gl.bindBuffer(gl.ARRAY_BUFFER, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BindElementBuffer extends BaseValue {
	    getDefault() {
	        return null;
	    }
	    set(v) {
	        // Always rebind
	        const gl = this.gl;
	        gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class BindVertexArray extends BaseValue {
	    getDefault() {
	        return null;
	    }
	    set(v) {
	        var _a;
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        if (isWebGL2(gl)) {
	            gl.bindVertexArray(v);
	        }
	        else {
	            (_a = gl.getExtension('OES_vertex_array_object')) === null || _a === void 0 ? void 0 : _a.bindVertexArrayOES(v);
	        }
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class PixelStoreUnpack extends BaseValue {
	    getDefault() {
	        return 4;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        gl.pixelStorei(gl.UNPACK_ALIGNMENT, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class PixelStoreUnpackPremultiplyAlpha extends BaseValue {
	    getDefault() {
	        return false;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        gl.pixelStorei(gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class PixelStoreUnpackFlipY extends BaseValue {
	    getDefault() {
	        return false;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        const gl = this.gl;
	        gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class FramebufferAttachment extends BaseValue {
	    constructor(context, parent) {
	        super(context);
	        this.context = context;
	        this.parent = parent;
	    }
	    getDefault() {
	        return null;
	    }
	}
	class ColorAttachment extends FramebufferAttachment {
	    setDirty() {
	        this.dirty = true;
	    }
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.context.bindFramebuffer.set(this.parent);
	        // note: it's possible to attach a renderbuffer to the color
	        // attachment point, but thus far MBGL only uses textures for color
	        const gl = this.gl;
	        gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, v, 0);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class DepthAttachment extends FramebufferAttachment {
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.context.bindFramebuffer.set(this.parent);
	        // note: it's possible to attach a texture to the depth attachment
	        // point, but thus far MBGL only uses renderbuffers for depth
	        const gl = this.gl;
	        gl.framebufferRenderbuffer(gl.FRAMEBUFFER, gl.DEPTH_ATTACHMENT, gl.RENDERBUFFER, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}
	class DepthStencilAttachment extends FramebufferAttachment {
	    set(v) {
	        if (v === this.current && !this.dirty)
	            return;
	        this.context.bindFramebuffer.set(this.parent);
	        // note: it's possible to attach a texture to the depth attachment
	        // point, but thus far MBGL only uses renderbuffers for depth
	        const gl = this.gl;
	        gl.framebufferRenderbuffer(gl.FRAMEBUFFER, gl.DEPTH_STENCIL_ATTACHMENT, gl.RENDERBUFFER, v);
	        this.current = v;
	        this.dirty = false;
	    }
	}

	/**
	 * @internal
	 * A framebuffer holder object
	 */
	class Framebuffer {
	    constructor(context, width, height, hasDepth, hasStencil) {
	        this.context = context;
	        this.width = width;
	        this.height = height;
	        const gl = context.gl;
	        const fbo = this.framebuffer = gl.createFramebuffer();
	        this.colorAttachment = new ColorAttachment(context, fbo);
	        if (hasDepth) {
	            this.depthAttachment = hasStencil ? new DepthStencilAttachment(context, fbo) : new DepthAttachment(context, fbo);
	        }
	        else if (hasStencil) {
	            throw new Error('Stencil cannot be set without depth');
	        }
	        if (gl.checkFramebufferStatus(gl.FRAMEBUFFER) !== gl.FRAMEBUFFER_COMPLETE) {
	            throw new Error('Framebuffer is not complete');
	        }
	    }
	    destroy() {
	        const gl = this.context.gl;
	        const texture = this.colorAttachment.get();
	        if (texture)
	            gl.deleteTexture(texture);
	        if (this.depthAttachment) {
	            const renderbuffer = this.depthAttachment.get();
	            if (renderbuffer)
	                gl.deleteRenderbuffer(renderbuffer);
	        }
	        gl.deleteFramebuffer(this.framebuffer);
	    }
	}

	const ZERO = 0x0000;
	const ONE = 0x0001;
	const ONE_MINUS_SRC_ALPHA = 0x0303;
	class ColorMode {
	    constructor(blendFunction, blendColor, mask) {
	        this.blendFunction = blendFunction;
	        this.blendColor = blendColor;
	        this.mask = mask;
	    }
	}
	ColorMode.Replace = [ONE, ZERO];
	ColorMode.disabled = new ColorMode(ColorMode.Replace, performance$1.Color.transparent, [false, false, false, false]);
	ColorMode.unblended = new ColorMode(ColorMode.Replace, performance$1.Color.transparent, [true, true, true, true]);
	ColorMode.alphaBlended = new ColorMode([ONE, ONE_MINUS_SRC_ALPHA], performance$1.Color.transparent, [true, true, true, true]);

	/**
	 * @internal
	 * A webgl wrapper class to allow injection, mocking and abstaction
	 */
	class Context {
	    constructor(gl) {
	        var _a, _b;
	        this.gl = gl;
	        this.clearColor = new ClearColor(this);
	        this.clearDepth = new ClearDepth(this);
	        this.clearStencil = new ClearStencil(this);
	        this.colorMask = new ColorMask(this);
	        this.depthMask = new DepthMask(this);
	        this.stencilMask = new StencilMask(this);
	        this.stencilFunc = new StencilFunc(this);
	        this.stencilOp = new StencilOp(this);
	        this.stencilTest = new StencilTest(this);
	        this.depthRange = new DepthRange(this);
	        this.depthTest = new DepthTest(this);
	        this.depthFunc = new DepthFunc(this);
	        this.blend = new Blend(this);
	        this.blendFunc = new BlendFunc(this);
	        this.blendColor = new BlendColor(this);
	        this.blendEquation = new BlendEquation(this);
	        this.cullFace = new CullFace(this);
	        this.cullFaceSide = new CullFaceSide(this);
	        this.frontFace = new FrontFace(this);
	        this.program = new ProgramValue(this);
	        this.activeTexture = new ActiveTextureUnit(this);
	        this.viewport = new Viewport(this);
	        this.bindFramebuffer = new BindFramebuffer(this);
	        this.bindRenderbuffer = new BindRenderbuffer(this);
	        this.bindTexture = new BindTexture(this);
	        this.bindVertexBuffer = new BindVertexBuffer(this);
	        this.bindElementBuffer = new BindElementBuffer(this);
	        this.bindVertexArray = new BindVertexArray(this);
	        this.pixelStoreUnpack = new PixelStoreUnpack(this);
	        this.pixelStoreUnpackPremultiplyAlpha = new PixelStoreUnpackPremultiplyAlpha(this);
	        this.pixelStoreUnpackFlipY = new PixelStoreUnpackFlipY(this);
	        this.extTextureFilterAnisotropic = (gl.getExtension('EXT_texture_filter_anisotropic') ||
	            gl.getExtension('MOZ_EXT_texture_filter_anisotropic') ||
	            gl.getExtension('WEBKIT_EXT_texture_filter_anisotropic'));
	        if (this.extTextureFilterAnisotropic) {
	            this.extTextureFilterAnisotropicMax = gl.getParameter(this.extTextureFilterAnisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT);
	        }
	        this.maxTextureSize = gl.getParameter(gl.MAX_TEXTURE_SIZE);
	        if (isWebGL2(gl)) {
	            this.HALF_FLOAT = gl.HALF_FLOAT;
	            const extColorBufferHalfFloat = gl.getExtension('EXT_color_buffer_half_float');
	            this.RGBA16F = (_a = gl.RGBA16F) !== null && _a !== void 0 ? _a : extColorBufferHalfFloat === null || extColorBufferHalfFloat === void 0 ? void 0 : extColorBufferHalfFloat.RGBA16F_EXT;
	            this.RGB16F = (_b = gl.RGB16F) !== null && _b !== void 0 ? _b : extColorBufferHalfFloat === null || extColorBufferHalfFloat === void 0 ? void 0 : extColorBufferHalfFloat.RGB16F_EXT;
	            gl.getExtension('EXT_color_buffer_float');
	        }
	        else {
	            gl.getExtension('EXT_color_buffer_half_float');
	            gl.getExtension('OES_texture_half_float_linear');
	            const extTextureHalfFloat = gl.getExtension('OES_texture_half_float');
	            this.HALF_FLOAT = extTextureHalfFloat === null || extTextureHalfFloat === void 0 ? void 0 : extTextureHalfFloat.HALF_FLOAT_OES;
	        }
	    }
	    setDefault() {
	        this.unbindVAO();
	        this.clearColor.setDefault();
	        this.clearDepth.setDefault();
	        this.clearStencil.setDefault();
	        this.colorMask.setDefault();
	        this.depthMask.setDefault();
	        this.stencilMask.setDefault();
	        this.stencilFunc.setDefault();
	        this.stencilOp.setDefault();
	        this.stencilTest.setDefault();
	        this.depthRange.setDefault();
	        this.depthTest.setDefault();
	        this.depthFunc.setDefault();
	        this.blend.setDefault();
	        this.blendFunc.setDefault();
	        this.blendColor.setDefault();
	        this.blendEquation.setDefault();
	        this.cullFace.setDefault();
	        this.cullFaceSide.setDefault();
	        this.frontFace.setDefault();
	        this.program.setDefault();
	        this.activeTexture.setDefault();
	        this.bindFramebuffer.setDefault();
	        this.pixelStoreUnpack.setDefault();
	        this.pixelStoreUnpackPremultiplyAlpha.setDefault();
	        this.pixelStoreUnpackFlipY.setDefault();
	    }
	    setDirty() {
	        this.clearColor.dirty = true;
	        this.clearDepth.dirty = true;
	        this.clearStencil.dirty = true;
	        this.colorMask.dirty = true;
	        this.depthMask.dirty = true;
	        this.stencilMask.dirty = true;
	        this.stencilFunc.dirty = true;
	        this.stencilOp.dirty = true;
	        this.stencilTest.dirty = true;
	        this.depthRange.dirty = true;
	        this.depthTest.dirty = true;
	        this.depthFunc.dirty = true;
	        this.blend.dirty = true;
	        this.blendFunc.dirty = true;
	        this.blendColor.dirty = true;
	        this.blendEquation.dirty = true;
	        this.cullFace.dirty = true;
	        this.cullFaceSide.dirty = true;
	        this.frontFace.dirty = true;
	        this.program.dirty = true;
	        this.activeTexture.dirty = true;
	        this.viewport.dirty = true;
	        this.bindFramebuffer.dirty = true;
	        this.bindRenderbuffer.dirty = true;
	        this.bindTexture.dirty = true;
	        this.bindVertexBuffer.dirty = true;
	        this.bindElementBuffer.dirty = true;
	        this.bindVertexArray.dirty = true;
	        this.pixelStoreUnpack.dirty = true;
	        this.pixelStoreUnpackPremultiplyAlpha.dirty = true;
	        this.pixelStoreUnpackFlipY.dirty = true;
	    }
	    createIndexBuffer(array, dynamicDraw) {
	        return new IndexBuffer(this, array, dynamicDraw);
	    }
	    createVertexBuffer(array, attributes, dynamicDraw) {
	        return new VertexBuffer(this, array, attributes, dynamicDraw);
	    }
	    createRenderbuffer(storageFormat, width, height) {
	        const gl = this.gl;
	        const rbo = gl.createRenderbuffer();
	        this.bindRenderbuffer.set(rbo);
	        gl.renderbufferStorage(gl.RENDERBUFFER, storageFormat, width, height);
	        this.bindRenderbuffer.set(null);
	        return rbo;
	    }
	    createFramebuffer(width, height, hasDepth, hasStencil) {
	        return new Framebuffer(this, width, height, hasDepth, hasStencil);
	    }
	    clear({ color, depth, stencil }) {
	        const gl = this.gl;
	        let mask = 0;
	        if (color) {
	            mask |= gl.COLOR_BUFFER_BIT;
	            this.clearColor.set(color);
	            this.colorMask.set([true, true, true, true]);
	        }
	        if (typeof depth !== 'undefined') {
	            mask |= gl.DEPTH_BUFFER_BIT;
	            // Workaround for platforms where clearDepth doesn't seem to work
	            // without resetting the depthRange. See https://github.com/mapbox/mapbox-gl-js/issues/3437
	            this.depthRange.set([0, 1]);
	            this.clearDepth.set(depth);
	            this.depthMask.set(true);
	        }
	        if (typeof stencil !== 'undefined') {
	            mask |= gl.STENCIL_BUFFER_BIT;
	            this.clearStencil.set(stencil);
	            this.stencilMask.set(0xFF);
	        }
	        gl.clear(mask);
	    }
	    setCullFace(cullFaceMode) {
	        if (cullFaceMode.enable === false) {
	            this.cullFace.set(false);
	        }
	        else {
	            this.cullFace.set(true);
	            this.cullFaceSide.set(cullFaceMode.mode);
	            this.frontFace.set(cullFaceMode.frontFace);
	        }
	    }
	    setDepthMode(depthMode) {
	        if (depthMode.func === this.gl.ALWAYS && !depthMode.mask) {
	            this.depthTest.set(false);
	        }
	        else {
	            this.depthTest.set(true);
	            this.depthFunc.set(depthMode.func);
	            this.depthMask.set(depthMode.mask);
	            this.depthRange.set(depthMode.range);
	        }
	    }
	    setStencilMode(stencilMode) {
	        if (stencilMode.test.func === this.gl.ALWAYS && !stencilMode.mask) {
	            this.stencilTest.set(false);
	        }
	        else {
	            this.stencilTest.set(true);
	            this.stencilMask.set(stencilMode.mask);
	            this.stencilOp.set([stencilMode.fail, stencilMode.depthFail, stencilMode.pass]);
	            this.stencilFunc.set({
	                func: stencilMode.test.func,
	                ref: stencilMode.ref,
	                mask: stencilMode.test.mask
	            });
	        }
	    }
	    setColorMode(colorMode) {
	        if (performance$1.deepEqual(colorMode.blendFunction, ColorMode.Replace)) {
	            this.blend.set(false);
	        }
	        else {
	            this.blend.set(true);
	            this.blendFunc.set(colorMode.blendFunction);
	            this.blendColor.set(colorMode.blendColor);
	        }
	        this.colorMask.set(colorMode.mask);
	    }
	    createVertexArray() {
	        var _a;
	        if (isWebGL2(this.gl))
	            return this.gl.createVertexArray();
	        return (_a = this.gl.getExtension('OES_vertex_array_object')) === null || _a === void 0 ? void 0 : _a.createVertexArrayOES();
	    }
	    deleteVertexArray(x) {
	        var _a;
	        if (isWebGL2(this.gl))
	            return this.gl.deleteVertexArray(x);
	        return (_a = this.gl.getExtension('OES_vertex_array_object')) === null || _a === void 0 ? void 0 : _a.deleteVertexArrayOES(x);
	    }
	    unbindVAO() {
	        // Unbinding the VAO prevents other things (custom layers, new buffer creation) from
	        // unintentionally changing the state of the last VAO used.
	        this.bindVertexArray.set(null);
	    }
	}

	const ALWAYS$1 = 0x0207;
	class DepthMode {
	    constructor(depthFunc, depthMask, depthRange) {
	        this.func = depthFunc;
	        this.mask = depthMask;
	        this.range = depthRange;
	    }
	}
	DepthMode.ReadOnly = false;
	DepthMode.ReadWrite = true;
	DepthMode.disabled = new DepthMode(ALWAYS$1, DepthMode.ReadOnly, [0, 1]);

	const ALWAYS = 0x0207;
	const KEEP = 0x1E00;
	class StencilMode {
	    constructor(test, ref, mask, fail, depthFail, pass) {
	        this.test = test;
	        this.ref = ref;
	        this.mask = mask;
	        this.fail = fail;
	        this.depthFail = depthFail;
	        this.pass = pass;
	    }
	}
	StencilMode.disabled = new StencilMode({ func: ALWAYS, mask: 0 }, 0, 0, KEEP, KEEP, KEEP);

	const BACK = 0x0405;
	const CCW = 0x0901;
	class CullFaceMode {
	    constructor(enable, mode, frontFace) {
	        this.enable = enable;
	        this.mode = mode;
	        this.frontFace = frontFace;
	    }
	}
	CullFaceMode.disabled = new CullFaceMode(false, BACK, CCW);
	CullFaceMode.backCCW = new CullFaceMode(true, BACK, CCW);

	let quadTriangles;
	function drawCollisionDebug(painter, sourceCache, layer, coords, translate, translateAnchor, isText) {
	    const context = painter.context;
	    const gl = context.gl;
	    const program = painter.useProgram('collisionBox');
	    const tileBatches = [];
	    let circleCount = 0;
	    let circleOffset = 0;
	    for (let i = 0; i < coords.length; i++) {
	        const coord = coords[i];
	        const tile = sourceCache.getTile(coord);
	        const bucket = tile.getBucket(layer);
	        if (!bucket)
	            continue;
	        let posMatrix = coord.posMatrix;
	        if (translate[0] !== 0 || translate[1] !== 0) {
	            posMatrix = painter.translatePosMatrix(coord.posMatrix, tile, translate, translateAnchor);
	        }
	        const buffers = isText ? bucket.textCollisionBox : bucket.iconCollisionBox;
	        // Get collision circle data of this bucket
	        const circleArray = bucket.collisionCircleArray;
	        if (circleArray.length > 0) {
	            // We need to know the projection matrix that was used for projecting collision circles to the screen.
	            // This might vary between buckets as the symbol placement is a continuous process. This matrix is
	            // required for transforming points from previous screen space to the current one
	            const invTransform = performance$1.create();
	            const transform = posMatrix;
	            performance$1.mul(invTransform, bucket.placementInvProjMatrix, painter.transform.glCoordMatrix);
	            performance$1.mul(invTransform, invTransform, bucket.placementViewportMatrix);
	            tileBatches.push({
	                circleArray,
	                circleOffset,
	                transform,
	                invTransform,
	                coord
	            });
	            circleCount += circleArray.length / 4; // 4 values per circle
	            circleOffset = circleCount;
	        }
	        if (!buffers)
	            continue;
	        program.draw(context, gl.LINES, DepthMode.disabled, StencilMode.disabled, painter.colorModeForRenderPass(), CullFaceMode.disabled, collisionUniformValues(posMatrix, painter.transform, tile), painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord), layer.id, buffers.layoutVertexBuffer, buffers.indexBuffer, buffers.segments, null, painter.transform.zoom, null, null, buffers.collisionVertexBuffer);
	    }
	    if (!isText || !tileBatches.length) {
	        return;
	    }
	    // Render collision circles
	    const circleProgram = painter.useProgram('collisionCircle');
	    // Construct vertex data
	    const vertexData = new performance$1.CollisionCircleLayoutArray();
	    vertexData.resize(circleCount * 4);
	    vertexData._trim();
	    let vertexOffset = 0;
	    for (const batch of tileBatches) {
	        for (let i = 0; i < batch.circleArray.length / 4; i++) {
	            const circleIdx = i * 4;
	            const x = batch.circleArray[circleIdx + 0];
	            const y = batch.circleArray[circleIdx + 1];
	            const radius = batch.circleArray[circleIdx + 2];
	            const collision = batch.circleArray[circleIdx + 3];
	            // 4 floats per vertex, 4 vertices per quad
	            vertexData.emplace(vertexOffset++, x, y, radius, collision, 0);
	            vertexData.emplace(vertexOffset++, x, y, radius, collision, 1);
	            vertexData.emplace(vertexOffset++, x, y, radius, collision, 2);
	            vertexData.emplace(vertexOffset++, x, y, radius, collision, 3);
	        }
	    }
	    if (!quadTriangles || quadTriangles.length < circleCount * 2) {
	        quadTriangles = createQuadTriangles(circleCount);
	    }
	    const indexBuffer = context.createIndexBuffer(quadTriangles, true);
	    const vertexBuffer = context.createVertexBuffer(vertexData, performance$1.collisionCircleLayout.members, true);
	    // Render batches
	    for (const batch of tileBatches) {
	        const uniforms = collisionCircleUniformValues(batch.transform, batch.invTransform, painter.transform);
	        circleProgram.draw(context, gl.TRIANGLES, DepthMode.disabled, StencilMode.disabled, painter.colorModeForRenderPass(), CullFaceMode.disabled, uniforms, painter.style.map.terrain && painter.style.map.terrain.getTerrainData(batch.coord), layer.id, vertexBuffer, indexBuffer, performance$1.SegmentVector.simpleSegment(0, batch.circleOffset * 2, batch.circleArray.length, batch.circleArray.length / 2), null, painter.transform.zoom, null, null, null);
	    }
	    vertexBuffer.destroy();
	    indexBuffer.destroy();
	}
	function createQuadTriangles(quadCount) {
	    const triCount = quadCount * 2;
	    const array = new performance$1.QuadTriangleArray();
	    array.resize(triCount);
	    array._trim();
	    // Two triangles and 4 vertices per quad.
	    for (let i = 0; i < triCount; i++) {
	        const idx = i * 6;
	        array.uint16[idx + 0] = i * 4 + 0;
	        array.uint16[idx + 1] = i * 4 + 1;
	        array.uint16[idx + 2] = i * 4 + 2;
	        array.uint16[idx + 3] = i * 4 + 2;
	        array.uint16[idx + 4] = i * 4 + 3;
	        array.uint16[idx + 5] = i * 4 + 0;
	    }
	    return array;
	}

	const identityMat4 = performance$1.identity(new Float32Array(16));
	function drawSymbols(painter, sourceCache, layer, coords, variableOffsets) {
	    if (painter.renderPass !== 'translucent')
	        return;
	    // Disable the stencil test so that labels aren't clipped to tile boundaries.
	    const stencilMode = StencilMode.disabled;
	    const colorMode = painter.colorModeForRenderPass();
	    const hasVariablePlacement = layer._unevaluatedLayout.hasValue('text-variable-anchor') || layer._unevaluatedLayout.hasValue('text-variable-anchor-offset');
	    //Compute variable-offsets before painting since icons and text data positioning
	    //depend on each other in this case.
	    if (hasVariablePlacement) {
	        updateVariableAnchors(coords, painter, layer, sourceCache, layer.layout.get('text-rotation-alignment'), layer.layout.get('text-pitch-alignment'), variableOffsets);
	    }
	    if (layer.paint.get('icon-opacity').constantOr(1) !== 0) {
	        drawLayerSymbols(painter, sourceCache, layer, coords, false, layer.paint.get('icon-translate'), layer.paint.get('icon-translate-anchor'), layer.layout.get('icon-rotation-alignment'), layer.layout.get('icon-pitch-alignment'), layer.layout.get('icon-keep-upright'), stencilMode, colorMode);
	    }
	    if (layer.paint.get('text-opacity').constantOr(1) !== 0) {
	        drawLayerSymbols(painter, sourceCache, layer, coords, true, layer.paint.get('text-translate'), layer.paint.get('text-translate-anchor'), layer.layout.get('text-rotation-alignment'), layer.layout.get('text-pitch-alignment'), layer.layout.get('text-keep-upright'), stencilMode, colorMode);
	    }
	    if (sourceCache.map.showCollisionBoxes) {
	        drawCollisionDebug(painter, sourceCache, layer, coords, layer.paint.get('text-translate'), layer.paint.get('text-translate-anchor'), true);
	        drawCollisionDebug(painter, sourceCache, layer, coords, layer.paint.get('icon-translate'), layer.paint.get('icon-translate-anchor'), false);
	    }
	}
	function calculateVariableRenderShift(anchor, width, height, textOffset, textBoxScale, renderTextSize) {
	    const { horizontalAlign, verticalAlign } = performance$1.getAnchorAlignment(anchor);
	    const shiftX = -(horizontalAlign - 0.5) * width;
	    const shiftY = -(verticalAlign - 0.5) * height;
	    return new performance$1.Point((shiftX / textBoxScale + textOffset[0]) * renderTextSize, (shiftY / textBoxScale + textOffset[1]) * renderTextSize);
	}
	function updateVariableAnchors(coords, painter, layer, sourceCache, rotationAlignment, pitchAlignment, variableOffsets) {
	    const tr = painter.transform;
	    const rotateWithMap = rotationAlignment === 'map';
	    const pitchWithMap = pitchAlignment === 'map';
	    for (const coord of coords) {
	        const tile = sourceCache.getTile(coord);
	        const bucket = tile.getBucket(layer);
	        if (!bucket || !bucket.text || !bucket.text.segments.get().length)
	            continue;
	        const sizeData = bucket.textSizeData;
	        const size = performance$1.evaluateSizeForZoom(sizeData, tr.zoom);
	        const pixelToTileScale = pixelsToTileUnits(tile, 1, painter.transform.zoom);
	        const labelPlaneMatrix = getLabelPlaneMatrix(coord.posMatrix, pitchWithMap, rotateWithMap, painter.transform, pixelToTileScale);
	        const updateTextFitIcon = layer.layout.get('icon-text-fit') !== 'none' && bucket.hasIconData();
	        if (size) {
	            const tileScale = Math.pow(2, tr.zoom - tile.tileID.overscaledZ);
	            const getElevation = painter.style.map.terrain ? (x, y) => painter.style.map.terrain.getElevation(coord, x, y) : null;
	            updateVariableAnchorsForBucket(bucket, rotateWithMap, pitchWithMap, variableOffsets, tr, labelPlaneMatrix, coord.posMatrix, tileScale, size, updateTextFitIcon, getElevation);
	        }
	    }
	}
	function updateVariableAnchorsForBucket(bucket, rotateWithMap, pitchWithMap, variableOffsets, transform, labelPlaneMatrix, posMatrix, tileScale, size, updateTextFitIcon, getElevation) {
	    const placedSymbols = bucket.text.placedSymbolArray;
	    const dynamicTextLayoutVertexArray = bucket.text.dynamicLayoutVertexArray;
	    const dynamicIconLayoutVertexArray = bucket.icon.dynamicLayoutVertexArray;
	    const placedTextShifts = {};
	    dynamicTextLayoutVertexArray.clear();
	    for (let s = 0; s < placedSymbols.length; s++) {
	        const symbol = placedSymbols.get(s);
	        const skipOrientation = bucket.allowVerticalPlacement && !symbol.placedOrientation;
	        const variableOffset = (!symbol.hidden && symbol.crossTileID && !skipOrientation) ? variableOffsets[symbol.crossTileID] : null;
	        if (!variableOffset) {
	            // These symbols are from a justification that is not being used, or a label that wasn't placed
	            // so we don't need to do the extra math to figure out what incremental shift to apply.
	            hideGlyphs(symbol.numGlyphs, dynamicTextLayoutVertexArray);
	        }
	        else {
	            const tileAnchor = new performance$1.Point(symbol.anchorX, symbol.anchorY);
	            const projectedAnchor = project(tileAnchor, pitchWithMap ? posMatrix : labelPlaneMatrix, getElevation);
	            const perspectiveRatio = getPerspectiveRatio(transform.cameraToCenterDistance, projectedAnchor.signedDistanceFromCamera);
	            let renderTextSize = performance$1.evaluateSizeForFeature(bucket.textSizeData, size, symbol) * perspectiveRatio / performance$1.ONE_EM;
	            if (pitchWithMap) {
	                // Go from size in pixels to equivalent size in tile units
	                renderTextSize *= bucket.tilePixelRatio / tileScale;
	            }
	            const { width, height, anchor, textOffset, textBoxScale } = variableOffset;
	            const shift = calculateVariableRenderShift(anchor, width, height, textOffset, textBoxScale, renderTextSize);
	            // Usual case is that we take the projected anchor and add the pixel-based shift
	            // calculated above. In the (somewhat weird) case of pitch-aligned text, we add an equivalent
	            // tile-unit based shift to the anchor before projecting to the label plane.
	            const shiftedAnchor = pitchWithMap ?
	                project(tileAnchor.add(shift), labelPlaneMatrix, getElevation).point :
	                projectedAnchor.point.add(rotateWithMap ?
	                    shift.rotate(-transform.angle) :
	                    shift);
	            const angle = (bucket.allowVerticalPlacement && symbol.placedOrientation === performance$1.WritingMode.vertical) ? Math.PI / 2 : 0;
	            for (let g = 0; g < symbol.numGlyphs; g++) {
	                performance$1.addDynamicAttributes(dynamicTextLayoutVertexArray, shiftedAnchor, angle);
	            }
	            //Only offset horizontal text icons
	            if (updateTextFitIcon && symbol.associatedIconIndex >= 0) {
	                placedTextShifts[symbol.associatedIconIndex] = { shiftedAnchor, angle };
	            }
	        }
	    }
	    if (updateTextFitIcon) {
	        dynamicIconLayoutVertexArray.clear();
	        const placedIcons = bucket.icon.placedSymbolArray;
	        for (let i = 0; i < placedIcons.length; i++) {
	            const placedIcon = placedIcons.get(i);
	            if (placedIcon.hidden) {
	                hideGlyphs(placedIcon.numGlyphs, dynamicIconLayoutVertexArray);
	            }
	            else {
	                const shift = placedTextShifts[i];
	                if (!shift) {
	                    hideGlyphs(placedIcon.numGlyphs, dynamicIconLayoutVertexArray);
	                }
	                else {
	                    for (let g = 0; g < placedIcon.numGlyphs; g++) {
	                        performance$1.addDynamicAttributes(dynamicIconLayoutVertexArray, shift.shiftedAnchor, shift.angle);
	                    }
	                }
	            }
	        }
	        bucket.icon.dynamicLayoutVertexBuffer.updateData(dynamicIconLayoutVertexArray);
	    }
	    bucket.text.dynamicLayoutVertexBuffer.updateData(dynamicTextLayoutVertexArray);
	}
	function getSymbolProgramName(isSDF, isText, bucket) {
	    if (bucket.iconsInText && isText) {
	        return 'symbolTextAndIcon';
	    }
	    else if (isSDF) {
	        return 'symbolSDF';
	    }
	    else {
	        return 'symbolIcon';
	    }
	}
	function drawLayerSymbols(painter, sourceCache, layer, coords, isText, translate, translateAnchor, rotationAlignment, pitchAlignment, keepUpright, stencilMode, colorMode) {
	    const context = painter.context;
	    const gl = context.gl;
	    const tr = painter.transform;
	    const rotateWithMap = rotationAlignment === 'map';
	    const pitchWithMap = pitchAlignment === 'map';
	    const alongLine = rotationAlignment !== 'viewport' && layer.layout.get('symbol-placement') !== 'point';
	    // Line label rotation happens in `updateLineLabels`
	    // Pitched point labels are automatically rotated by the labelPlaneMatrix projection
	    // Unpitched point labels need to have their rotation applied after projection
	    const rotateInShader = rotateWithMap && !pitchWithMap && !alongLine;
	    const hasSortKey = !layer.layout.get('symbol-sort-key').isConstant();
	    let sortFeaturesByKey = false;
	    const depthMode = painter.depthModeForSublayer(0, DepthMode.ReadOnly);
	    const hasVariablePlacement = layer._unevaluatedLayout.hasValue('text-variable-anchor') || layer._unevaluatedLayout.hasValue('text-variable-anchor-offset');
	    const tileRenderState = [];
	    for (const coord of coords) {
	        const tile = sourceCache.getTile(coord);
	        const bucket = tile.getBucket(layer);
	        if (!bucket)
	            continue;
	        const buffers = isText ? bucket.text : bucket.icon;
	        if (!buffers || !buffers.segments.get().length || !buffers.hasVisibleVertices)
	            continue;
	        const programConfiguration = buffers.programConfigurations.get(layer.id);
	        const isSDF = isText || bucket.sdfIcons;
	        const sizeData = isText ? bucket.textSizeData : bucket.iconSizeData;
	        const transformed = pitchWithMap || tr.pitch !== 0;
	        const program = painter.useProgram(getSymbolProgramName(isSDF, isText, bucket), programConfiguration);
	        const size = performance$1.evaluateSizeForZoom(sizeData, tr.zoom);
	        const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	        let texSize;
	        let texSizeIcon = [0, 0];
	        let atlasTexture;
	        let atlasInterpolation;
	        let atlasTextureIcon = null;
	        let atlasInterpolationIcon;
	        if (isText) {
	            atlasTexture = tile.glyphAtlasTexture;
	            atlasInterpolation = gl.LINEAR;
	            texSize = tile.glyphAtlasTexture.size;
	            if (bucket.iconsInText) {
	                texSizeIcon = tile.imageAtlasTexture.size;
	                atlasTextureIcon = tile.imageAtlasTexture;
	                const zoomDependentSize = sizeData.kind === 'composite' || sizeData.kind === 'camera';
	                atlasInterpolationIcon = transformed || painter.options.rotating || painter.options.zooming || zoomDependentSize ? gl.LINEAR : gl.NEAREST;
	            }
	        }
	        else {
	            const iconScaled = layer.layout.get('icon-size').constantOr(0) !== 1 || bucket.iconsNeedLinear;
	            atlasTexture = tile.imageAtlasTexture;
	            atlasInterpolation = isSDF || painter.options.rotating || painter.options.zooming || iconScaled || transformed ?
	                gl.LINEAR :
	                gl.NEAREST;
	            texSize = tile.imageAtlasTexture.size;
	        }
	        const s = pixelsToTileUnits(tile, 1, painter.transform.zoom);
	        const labelPlaneMatrix = getLabelPlaneMatrix(coord.posMatrix, pitchWithMap, rotateWithMap, painter.transform, s);
	        const glCoordMatrix = getGlCoordMatrix(coord.posMatrix, pitchWithMap, rotateWithMap, painter.transform, s);
	        const hasVariableAnchors = hasVariablePlacement && bucket.hasTextData();
	        const updateTextFitIcon = layer.layout.get('icon-text-fit') !== 'none' &&
	            hasVariableAnchors &&
	            bucket.hasIconData();
	        if (alongLine) {
	            const getElevation = painter.style.map.terrain ? (x, y) => painter.style.map.terrain.getElevation(coord, x, y) : null;
	            const rotateToLine = layer.layout.get('text-rotation-alignment') === 'map';
	            updateLineLabels(bucket, coord.posMatrix, painter, isText, labelPlaneMatrix, glCoordMatrix, pitchWithMap, keepUpright, rotateToLine, getElevation);
	        }
	        const matrix = painter.translatePosMatrix(coord.posMatrix, tile, translate, translateAnchor), uLabelPlaneMatrix = (alongLine || (isText && hasVariablePlacement) || updateTextFitIcon) ? identityMat4 : labelPlaneMatrix, uglCoordMatrix = painter.translatePosMatrix(glCoordMatrix, tile, translate, translateAnchor, true);
	        const hasHalo = isSDF && layer.paint.get(isText ? 'text-halo-width' : 'icon-halo-width').constantOr(1) !== 0;
	        let uniformValues;
	        if (isSDF) {
	            if (!bucket.iconsInText) {
	                uniformValues = symbolSDFUniformValues(sizeData.kind, size, rotateInShader, pitchWithMap, painter, matrix, uLabelPlaneMatrix, uglCoordMatrix, isText, texSize, true);
	            }
	            else {
	                uniformValues = symbolTextAndIconUniformValues(sizeData.kind, size, rotateInShader, pitchWithMap, painter, matrix, uLabelPlaneMatrix, uglCoordMatrix, texSize, texSizeIcon);
	            }
	        }
	        else {
	            uniformValues = symbolIconUniformValues(sizeData.kind, size, rotateInShader, pitchWithMap, painter, matrix, uLabelPlaneMatrix, uglCoordMatrix, isText, texSize);
	        }
	        const state = {
	            program,
	            buffers,
	            uniformValues,
	            atlasTexture,
	            atlasTextureIcon,
	            atlasInterpolation,
	            atlasInterpolationIcon,
	            isSDF,
	            hasHalo
	        };
	        if (hasSortKey && bucket.canOverlap) {
	            sortFeaturesByKey = true;
	            const oldSegments = buffers.segments.get();
	            for (const segment of oldSegments) {
	                tileRenderState.push({
	                    segments: new performance$1.SegmentVector([segment]),
	                    sortKey: segment.sortKey,
	                    state,
	                    terrainData
	                });
	            }
	        }
	        else {
	            tileRenderState.push({
	                segments: buffers.segments,
	                sortKey: 0,
	                state,
	                terrainData
	            });
	        }
	    }
	    if (sortFeaturesByKey) {
	        tileRenderState.sort((a, b) => a.sortKey - b.sortKey);
	    }
	    for (const segmentState of tileRenderState) {
	        const state = segmentState.state;
	        context.activeTexture.set(gl.TEXTURE0);
	        state.atlasTexture.bind(state.atlasInterpolation, gl.CLAMP_TO_EDGE);
	        if (state.atlasTextureIcon) {
	            context.activeTexture.set(gl.TEXTURE1);
	            if (state.atlasTextureIcon) {
	                state.atlasTextureIcon.bind(state.atlasInterpolationIcon, gl.CLAMP_TO_EDGE);
	            }
	        }
	        if (state.isSDF) {
	            const uniformValues = state.uniformValues;
	            if (state.hasHalo) {
	                uniformValues['u_is_halo'] = 1;
	                drawSymbolElements(state.buffers, segmentState.segments, layer, painter, state.program, depthMode, stencilMode, colorMode, uniformValues, segmentState.terrainData);
	            }
	            uniformValues['u_is_halo'] = 0;
	        }
	        drawSymbolElements(state.buffers, segmentState.segments, layer, painter, state.program, depthMode, stencilMode, colorMode, state.uniformValues, segmentState.terrainData);
	    }
	}
	function drawSymbolElements(buffers, segments, layer, painter, program, depthMode, stencilMode, colorMode, uniformValues, terrainData) {
	    const context = painter.context;
	    const gl = context.gl;
	    program.draw(context, gl.TRIANGLES, depthMode, stencilMode, colorMode, CullFaceMode.disabled, uniformValues, terrainData, layer.id, buffers.layoutVertexBuffer, buffers.indexBuffer, segments, layer.paint, painter.transform.zoom, buffers.programConfigurations.get(layer.id), buffers.dynamicLayoutVertexBuffer, buffers.opacityVertexBuffer);
	}

	function drawCircles(painter, sourceCache, layer, coords) {
	    if (painter.renderPass !== 'translucent')
	        return;
	    const opacity = layer.paint.get('circle-opacity');
	    const strokeWidth = layer.paint.get('circle-stroke-width');
	    const strokeOpacity = layer.paint.get('circle-stroke-opacity');
	    const sortFeaturesByKey = !layer.layout.get('circle-sort-key').isConstant();
	    if (opacity.constantOr(1) === 0 && (strokeWidth.constantOr(1) === 0 || strokeOpacity.constantOr(1) === 0)) {
	        return;
	    }
	    const context = painter.context;
	    const gl = context.gl;
	    const depthMode = painter.depthModeForSublayer(0, DepthMode.ReadOnly);
	    // Turn off stencil testing to allow circles to be drawn across boundaries,
	    // so that large circles are not clipped to tiles
	    const stencilMode = StencilMode.disabled;
	    const colorMode = painter.colorModeForRenderPass();
	    const segmentsRenderStates = [];
	    for (let i = 0; i < coords.length; i++) {
	        const coord = coords[i];
	        const tile = sourceCache.getTile(coord);
	        const bucket = tile.getBucket(layer);
	        if (!bucket)
	            continue;
	        const programConfiguration = bucket.programConfigurations.get(layer.id);
	        const program = painter.useProgram('circle', programConfiguration);
	        const layoutVertexBuffer = bucket.layoutVertexBuffer;
	        const indexBuffer = bucket.indexBuffer;
	        const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	        const uniformValues = circleUniformValues(painter, coord, tile, layer);
	        const state = {
	            programConfiguration,
	            program,
	            layoutVertexBuffer,
	            indexBuffer,
	            uniformValues,
	            terrainData
	        };
	        if (sortFeaturesByKey) {
	            const oldSegments = bucket.segments.get();
	            for (const segment of oldSegments) {
	                segmentsRenderStates.push({
	                    segments: new performance$1.SegmentVector([segment]),
	                    sortKey: segment.sortKey,
	                    state
	                });
	            }
	        }
	        else {
	            segmentsRenderStates.push({
	                segments: bucket.segments,
	                sortKey: 0,
	                state
	            });
	        }
	    }
	    if (sortFeaturesByKey) {
	        segmentsRenderStates.sort((a, b) => a.sortKey - b.sortKey);
	    }
	    for (const segmentsState of segmentsRenderStates) {
	        const { programConfiguration, program, layoutVertexBuffer, indexBuffer, uniformValues, terrainData } = segmentsState.state;
	        const segments = segmentsState.segments;
	        program.draw(context, gl.TRIANGLES, depthMode, stencilMode, colorMode, CullFaceMode.disabled, uniformValues, terrainData, layer.id, layoutVertexBuffer, indexBuffer, segments, layer.paint, painter.transform.zoom, programConfiguration);
	    }
	}

	function drawHeatmap(painter, sourceCache, layer, coords) {
	    if (layer.paint.get('heatmap-opacity') === 0) {
	        return;
	    }
	    if (painter.renderPass === 'offscreen') {
	        const context = painter.context;
	        const gl = context.gl;
	        // Allow kernels to be drawn across boundaries, so that
	        // large kernels are not clipped to tiles
	        const stencilMode = StencilMode.disabled;
	        // Turn on additive blending for kernels, which is a key aspect of kernel density estimation formula
	        const colorMode = new ColorMode([gl.ONE, gl.ONE], performance$1.Color.transparent, [true, true, true, true]);
	        bindFramebuffer(context, painter, layer);
	        context.clear({ color: performance$1.Color.transparent });
	        for (let i = 0; i < coords.length; i++) {
	            const coord = coords[i];
	            // Skip tiles that have uncovered parents to avoid flickering; we don't need
	            // to use complex tile masking here because the change between zoom levels is subtle,
	            // so it's fine to simply render the parent until all its 4 children are loaded
	            if (sourceCache.hasRenderableParent(coord))
	                continue;
	            const tile = sourceCache.getTile(coord);
	            const bucket = tile.getBucket(layer);
	            if (!bucket)
	                continue;
	            const programConfiguration = bucket.programConfigurations.get(layer.id);
	            const program = painter.useProgram('heatmap', programConfiguration);
	            const { zoom } = painter.transform;
	            program.draw(context, gl.TRIANGLES, DepthMode.disabled, stencilMode, colorMode, CullFaceMode.disabled, heatmapUniformValues(coord.posMatrix, tile, zoom, layer.paint.get('heatmap-intensity')), null, layer.id, bucket.layoutVertexBuffer, bucket.indexBuffer, bucket.segments, layer.paint, painter.transform.zoom, programConfiguration);
	        }
	        context.viewport.set([0, 0, painter.width, painter.height]);
	    }
	    else if (painter.renderPass === 'translucent') {
	        painter.context.setColorMode(painter.colorModeForRenderPass());
	        renderTextureToMap(painter, layer);
	    }
	}
	function bindFramebuffer(context, painter, layer) {
	    const gl = context.gl;
	    context.activeTexture.set(gl.TEXTURE1);
	    // Use a 4x downscaled screen texture for better performance
	    context.viewport.set([0, 0, painter.width / 4, painter.height / 4]);
	    let fbo = layer.heatmapFbo;
	    if (!fbo) {
	        const texture = gl.createTexture();
	        gl.bindTexture(gl.TEXTURE_2D, texture);
	        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
	        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
	        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
	        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
	        fbo = layer.heatmapFbo = context.createFramebuffer(painter.width / 4, painter.height / 4, false, false);
	        bindTextureToFramebuffer(context, painter, texture, fbo);
	    }
	    else {
	        gl.bindTexture(gl.TEXTURE_2D, fbo.colorAttachment.get());
	        context.bindFramebuffer.set(fbo.framebuffer);
	    }
	}
	function bindTextureToFramebuffer(context, painter, texture, fbo) {
	    var _a, _b;
	    const gl = context.gl;
	    // Use the higher precision half-float texture where available (producing much smoother looking heatmaps);
	    // Otherwise, fall back to a low precision texture
	    const numType = (_a = context.HALF_FLOAT) !== null && _a !== void 0 ? _a : gl.UNSIGNED_BYTE;
	    const internalFormat = (_b = context.RGBA16F) !== null && _b !== void 0 ? _b : gl.RGBA;
	    gl.texImage2D(gl.TEXTURE_2D, 0, internalFormat, painter.width / 4, painter.height / 4, 0, gl.RGBA, numType, null);
	    fbo.colorAttachment.set(texture);
	}
	function renderTextureToMap(painter, layer) {
	    const context = painter.context;
	    const gl = context.gl;
	    // Here we bind two different textures from which we'll sample in drawing
	    // heatmaps: the kernel texture, prepared in the offscreen pass, and a
	    // color ramp texture.
	    const fbo = layer.heatmapFbo;
	    if (!fbo)
	        return;
	    context.activeTexture.set(gl.TEXTURE0);
	    gl.bindTexture(gl.TEXTURE_2D, fbo.colorAttachment.get());
	    context.activeTexture.set(gl.TEXTURE1);
	    let colorRampTexture = layer.colorRampTexture;
	    if (!colorRampTexture) {
	        colorRampTexture = layer.colorRampTexture = new Texture(context, layer.colorRamp, gl.RGBA);
	    }
	    colorRampTexture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	    painter.useProgram('heatmapTexture').draw(context, gl.TRIANGLES, DepthMode.disabled, StencilMode.disabled, painter.colorModeForRenderPass(), CullFaceMode.disabled, heatmapTextureUniformValues(painter, layer, 0, 1), null, layer.id, painter.viewportBuffer, painter.quadTriangleIndexBuffer, painter.viewportSegments, layer.paint, painter.transform.zoom);
	}

	function drawLine(painter, sourceCache, layer, coords) {
	    if (painter.renderPass !== 'translucent')
	        return;
	    const opacity = layer.paint.get('line-opacity');
	    const width = layer.paint.get('line-width');
	    if (opacity.constantOr(1) === 0 || width.constantOr(1) === 0)
	        return;
	    const depthMode = painter.depthModeForSublayer(0, DepthMode.ReadOnly);
	    const colorMode = painter.colorModeForRenderPass();
	    const dasharray = layer.paint.get('line-dasharray');
	    const patternProperty = layer.paint.get('line-pattern');
	    const image = patternProperty.constantOr(1);
	    const gradient = layer.paint.get('line-gradient');
	    const crossfade = layer.getCrossfadeParameters();
	    const programId = image ? 'linePattern' :
	        dasharray ? 'lineSDF' :
	            gradient ? 'lineGradient' : 'line';
	    const context = painter.context;
	    const gl = context.gl;
	    let firstTile = true;
	    for (const coord of coords) {
	        const tile = sourceCache.getTile(coord);
	        if (image && !tile.patternsLoaded())
	            continue;
	        const bucket = tile.getBucket(layer);
	        if (!bucket)
	            continue;
	        const programConfiguration = bucket.programConfigurations.get(layer.id);
	        const prevProgram = painter.context.program.get();
	        const program = painter.useProgram(programId, programConfiguration);
	        const programChanged = firstTile || program.program !== prevProgram;
	        const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	        const constantPattern = patternProperty.constantOr(null);
	        if (constantPattern && tile.imageAtlas) {
	            const atlas = tile.imageAtlas;
	            const posTo = atlas.patternPositions[constantPattern.to.toString()];
	            const posFrom = atlas.patternPositions[constantPattern.from.toString()];
	            if (posTo && posFrom)
	                programConfiguration.setConstantPatternPositions(posTo, posFrom);
	        }
	        const terrainCoord = terrainData ? coord : null;
	        const uniformValues = image ? linePatternUniformValues(painter, tile, layer, crossfade, terrainCoord) :
	            dasharray ? lineSDFUniformValues(painter, tile, layer, dasharray, crossfade, terrainCoord) :
	                gradient ? lineGradientUniformValues(painter, tile, layer, bucket.lineClipsArray.length, terrainCoord) :
	                    lineUniformValues(painter, tile, layer, terrainCoord);
	        if (image) {
	            context.activeTexture.set(gl.TEXTURE0);
	            tile.imageAtlasTexture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	            programConfiguration.updatePaintBuffers(crossfade);
	        }
	        else if (dasharray && (programChanged || painter.lineAtlas.dirty)) {
	            context.activeTexture.set(gl.TEXTURE0);
	            painter.lineAtlas.bind(context);
	        }
	        else if (gradient) {
	            const layerGradient = bucket.gradients[layer.id];
	            let gradientTexture = layerGradient.texture;
	            if (layer.gradientVersion !== layerGradient.version) {
	                let textureResolution = 256;
	                if (layer.stepInterpolant) {
	                    const sourceMaxZoom = sourceCache.getSource().maxzoom;
	                    const potentialOverzoom = coord.canonical.z === sourceMaxZoom ?
	                        Math.ceil(1 << (painter.transform.maxZoom - coord.canonical.z)) : 1;
	                    const lineLength = bucket.maxLineLength / performance$1.EXTENT;
	                    // Logical pixel tile size is 512px, and 1024px right before current zoom + 1
	                    const maxTilePixelSize = 1024;
	                    // Maximum possible texture coverage heuristic, bound by hardware max texture size
	                    const maxTextureCoverage = lineLength * maxTilePixelSize * potentialOverzoom;
	                    textureResolution = performance$1.clamp(performance$1.nextPowerOfTwo(maxTextureCoverage), 256, context.maxTextureSize);
	                }
	                layerGradient.gradient = performance$1.renderColorRamp({
	                    expression: layer.gradientExpression(),
	                    evaluationKey: 'lineProgress',
	                    resolution: textureResolution,
	                    image: layerGradient.gradient || undefined,
	                    clips: bucket.lineClipsArray
	                });
	                if (layerGradient.texture) {
	                    layerGradient.texture.update(layerGradient.gradient);
	                }
	                else {
	                    layerGradient.texture = new Texture(context, layerGradient.gradient, gl.RGBA);
	                }
	                layerGradient.version = layer.gradientVersion;
	                gradientTexture = layerGradient.texture;
	            }
	            context.activeTexture.set(gl.TEXTURE0);
	            gradientTexture.bind(layer.stepInterpolant ? gl.NEAREST : gl.LINEAR, gl.CLAMP_TO_EDGE);
	        }
	        program.draw(context, gl.TRIANGLES, depthMode, painter.stencilModeForClipping(coord), colorMode, CullFaceMode.disabled, uniformValues, terrainData, layer.id, bucket.layoutVertexBuffer, bucket.indexBuffer, bucket.segments, layer.paint, painter.transform.zoom, programConfiguration, bucket.layoutVertexBuffer2);
	        firstTile = false;
	        // once refactored so that bound texture state is managed, we'll also be able to remove this firstTile/programChanged logic
	    }
	}

	/**
	 * A simple helper shared by draw_fill and draw_fill_extrusions to find the correct pattern positions AND update program.
	 * For transtionable properties, especially 'fill-pattern' and 'fill-extrusion-pattern', while rendering certain frames
	 * tile.imageAtlas has been updated by worker to hold the new pattern only, but rendering code is still looking for the previous image.
	 * The mismatch was causing setConstantPatternPositions method not being called and pixelRatio was always the
	 * default of 1, instead of actual values set by original map.addImage.
	 *
	 * @param programConfiguration - to be used to set pattern position and device pixel ratio.
	 * @param propertyName - 'fill-pattern' or 'fill-extrusion-pattern' property key
	 * @param constantPattern - either 'fill-pattern' or 'fill-extrusion-pattern' property value
	 * @param tile - current tile being drawn
	 * @param layer - current layer being rendered
	 */
	function updatePatternPositionsInProgram(programConfiguration, propertyName, constantPattern, tile, layer) {
	    if (!constantPattern || !tile || !tile.imageAtlas) {
	        return;
	    }
	    const patternPositions = tile.imageAtlas.patternPositions;
	    let posTo = patternPositions[constantPattern.to.toString()];
	    let posFrom = patternPositions[constantPattern.from.toString()];
	    // https://github.com/maplibre/maplibre-gl-js/issues/3377
	    if (!posTo && posFrom)
	        posTo = posFrom;
	    if (!posFrom && posTo)
	        posFrom = posTo;
	    // try again in case patternPositions has been updated by worker
	    if (!posTo || !posFrom) {
	        const transitioned = layer.getPaintProperty(propertyName);
	        posTo = patternPositions[transitioned];
	        posFrom = patternPositions[transitioned];
	    }
	    if (posTo && posFrom) {
	        programConfiguration.setConstantPatternPositions(posTo, posFrom);
	    }
	}

	function drawFill(painter, sourceCache, layer, coords) {
	    const color = layer.paint.get('fill-color');
	    const opacity = layer.paint.get('fill-opacity');
	    if (opacity.constantOr(1) === 0) {
	        return;
	    }
	    const colorMode = painter.colorModeForRenderPass();
	    const pattern = layer.paint.get('fill-pattern');
	    const pass = painter.opaquePassEnabledForLayer() &&
	        (!pattern.constantOr(1) &&
	            color.constantOr(performance$1.Color.transparent).a === 1 &&
	            opacity.constantOr(0) === 1) ? 'opaque' : 'translucent';
	    // Draw fill
	    if (painter.renderPass === pass) {
	        const depthMode = painter.depthModeForSublayer(1, painter.renderPass === 'opaque' ? DepthMode.ReadWrite : DepthMode.ReadOnly);
	        drawFillTiles(painter, sourceCache, layer, coords, depthMode, colorMode, false);
	    }
	    // Draw stroke
	    if (painter.renderPass === 'translucent' && layer.paint.get('fill-antialias')) {
	        // If we defined a different color for the fill outline, we are
	        // going to ignore the bits in 0x07 and just care about the global
	        // clipping mask.
	        // Otherwise, we only want to drawFill the antialiased parts that are
	        // *outside* the current shape. This is important in case the fill
	        // or stroke color is translucent. If we wouldn't clip to outside
	        // the current shape, some pixels from the outline stroke overlapped
	        // the (non-antialiased) fill.
	        const depthMode = painter.depthModeForSublayer(layer.getPaintProperty('fill-outline-color') ? 2 : 0, DepthMode.ReadOnly);
	        drawFillTiles(painter, sourceCache, layer, coords, depthMode, colorMode, true);
	    }
	}
	function drawFillTiles(painter, sourceCache, layer, coords, depthMode, colorMode, isOutline) {
	    const gl = painter.context.gl;
	    const fillPropertyName = 'fill-pattern';
	    const patternProperty = layer.paint.get(fillPropertyName);
	    const image = patternProperty && patternProperty.constantOr(1);
	    const crossfade = layer.getCrossfadeParameters();
	    let drawMode, programName, uniformValues, indexBuffer, segments;
	    if (!isOutline) {
	        programName = image ? 'fillPattern' : 'fill';
	        drawMode = gl.TRIANGLES;
	    }
	    else {
	        programName = image && !layer.getPaintProperty('fill-outline-color') ? 'fillOutlinePattern' : 'fillOutline';
	        drawMode = gl.LINES;
	    }
	    const constantPattern = patternProperty.constantOr(null);
	    for (const coord of coords) {
	        const tile = sourceCache.getTile(coord);
	        if (image && !tile.patternsLoaded())
	            continue;
	        const bucket = tile.getBucket(layer);
	        if (!bucket)
	            continue;
	        const programConfiguration = bucket.programConfigurations.get(layer.id);
	        const program = painter.useProgram(programName, programConfiguration);
	        const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	        if (image) {
	            painter.context.activeTexture.set(gl.TEXTURE0);
	            tile.imageAtlasTexture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	            programConfiguration.updatePaintBuffers(crossfade);
	        }
	        updatePatternPositionsInProgram(programConfiguration, fillPropertyName, constantPattern, tile, layer);
	        const terrainCoord = terrainData ? coord : null;
	        const posMatrix = terrainCoord ? terrainCoord.posMatrix : coord.posMatrix;
	        const tileMatrix = painter.translatePosMatrix(posMatrix, tile, layer.paint.get('fill-translate'), layer.paint.get('fill-translate-anchor'));
	        if (!isOutline) {
	            indexBuffer = bucket.indexBuffer;
	            segments = bucket.segments;
	            uniformValues = image ?
	                fillPatternUniformValues(tileMatrix, painter, crossfade, tile) :
	                fillUniformValues(tileMatrix);
	        }
	        else {
	            indexBuffer = bucket.indexBuffer2;
	            segments = bucket.segments2;
	            const drawingBufferSize = [gl.drawingBufferWidth, gl.drawingBufferHeight];
	            uniformValues = (programName === 'fillOutlinePattern' && image) ?
	                fillOutlinePatternUniformValues(tileMatrix, painter, crossfade, tile, drawingBufferSize) :
	                fillOutlineUniformValues(tileMatrix, drawingBufferSize);
	        }
	        program.draw(painter.context, drawMode, depthMode, painter.stencilModeForClipping(coord), colorMode, CullFaceMode.disabled, uniformValues, terrainData, layer.id, bucket.layoutVertexBuffer, indexBuffer, segments, layer.paint, painter.transform.zoom, programConfiguration);
	    }
	}

	function drawFillExtrusion(painter, source, layer, coords) {
	    const opacity = layer.paint.get('fill-extrusion-opacity');
	    if (opacity === 0) {
	        return;
	    }
	    if (painter.renderPass === 'translucent') {
	        const depthMode = new DepthMode(painter.context.gl.LEQUAL, DepthMode.ReadWrite, painter.depthRangeFor3D);
	        if (opacity === 1 && !layer.paint.get('fill-extrusion-pattern').constantOr(1)) {
	            const colorMode = painter.colorModeForRenderPass();
	            drawExtrusionTiles(painter, source, layer, coords, depthMode, StencilMode.disabled, colorMode);
	        }
	        else {
	            // Draw transparent buildings in two passes so that only the closest surface is drawn.
	            // First draw all the extrusions into only the depth buffer. No colors are drawn.
	            drawExtrusionTiles(painter, source, layer, coords, depthMode, StencilMode.disabled, ColorMode.disabled);
	            // Then draw all the extrusions a second type, only coloring fragments if they have the
	            // same depth value as the closest fragment in the previous pass. Use the stencil buffer
	            // to prevent the second draw in cases where we have coincident polygons.
	            drawExtrusionTiles(painter, source, layer, coords, depthMode, painter.stencilModeFor3D(), painter.colorModeForRenderPass());
	        }
	    }
	}
	function drawExtrusionTiles(painter, source, layer, coords, depthMode, stencilMode, colorMode) {
	    const context = painter.context;
	    const gl = context.gl;
	    const fillPropertyName = 'fill-extrusion-pattern';
	    const patternProperty = layer.paint.get(fillPropertyName);
	    const image = patternProperty.constantOr(1);
	    const crossfade = layer.getCrossfadeParameters();
	    const opacity = layer.paint.get('fill-extrusion-opacity');
	    const constantPattern = patternProperty.constantOr(null);
	    for (const coord of coords) {
	        const tile = source.getTile(coord);
	        const bucket = tile.getBucket(layer);
	        if (!bucket)
	            continue;
	        const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	        const programConfiguration = bucket.programConfigurations.get(layer.id);
	        const program = painter.useProgram(image ? 'fillExtrusionPattern' : 'fillExtrusion', programConfiguration);
	        if (image) {
	            painter.context.activeTexture.set(gl.TEXTURE0);
	            tile.imageAtlasTexture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	            programConfiguration.updatePaintBuffers(crossfade);
	        }
	        updatePatternPositionsInProgram(programConfiguration, fillPropertyName, constantPattern, tile, layer);
	        const matrix = painter.translatePosMatrix(coord.posMatrix, tile, layer.paint.get('fill-extrusion-translate'), layer.paint.get('fill-extrusion-translate-anchor'));
	        const shouldUseVerticalGradient = layer.paint.get('fill-extrusion-vertical-gradient');
	        const uniformValues = image ?
	            fillExtrusionPatternUniformValues(matrix, painter, shouldUseVerticalGradient, opacity, coord, crossfade, tile) :
	            fillExtrusionUniformValues(matrix, painter, shouldUseVerticalGradient, opacity);
	        program.draw(context, context.gl.TRIANGLES, depthMode, stencilMode, colorMode, CullFaceMode.backCCW, uniformValues, terrainData, layer.id, bucket.layoutVertexBuffer, bucket.indexBuffer, bucket.segments, layer.paint, painter.transform.zoom, programConfiguration, painter.style.map.terrain && bucket.centroidVertexBuffer);
	    }
	}

	function drawHillshade(painter, sourceCache, layer, tileIDs) {
	    if (painter.renderPass !== 'offscreen' && painter.renderPass !== 'translucent')
	        return;
	    const context = painter.context;
	    const depthMode = painter.depthModeForSublayer(0, DepthMode.ReadOnly);
	    const colorMode = painter.colorModeForRenderPass();
	    const [stencilModes, coords] = painter.renderPass === 'translucent' ?
	        painter.stencilConfigForOverlap(tileIDs) : [{}, tileIDs];
	    for (const coord of coords) {
	        const tile = sourceCache.getTile(coord);
	        if (typeof tile.needsHillshadePrepare !== 'undefined' && tile.needsHillshadePrepare && painter.renderPass === 'offscreen') {
	            prepareHillshade(painter, tile, layer, depthMode, StencilMode.disabled, colorMode);
	        }
	        else if (painter.renderPass === 'translucent') {
	            renderHillshade(painter, coord, tile, layer, depthMode, stencilModes[coord.overscaledZ], colorMode);
	        }
	    }
	    context.viewport.set([0, 0, painter.width, painter.height]);
	}
	function renderHillshade(painter, coord, tile, layer, depthMode, stencilMode, colorMode) {
	    const context = painter.context;
	    const gl = context.gl;
	    const fbo = tile.fbo;
	    if (!fbo)
	        return;
	    const program = painter.useProgram('hillshade');
	    const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	    context.activeTexture.set(gl.TEXTURE0);
	    gl.bindTexture(gl.TEXTURE_2D, fbo.colorAttachment.get());
	    const terrainCoord = terrainData ? coord : null;
	    program.draw(context, gl.TRIANGLES, depthMode, stencilMode, colorMode, CullFaceMode.disabled, hillshadeUniformValues(painter, tile, layer, terrainCoord), terrainData, layer.id, painter.rasterBoundsBuffer, painter.quadTriangleIndexBuffer, painter.rasterBoundsSegments);
	}
	// hillshade rendering is done in two steps. the prepare step first calculates the slope of the terrain in the x and y
	// directions for each pixel, and saves those values to a framebuffer texture in the r and g channels.
	function prepareHillshade(painter, tile, layer, depthMode, stencilMode, colorMode) {
	    const context = painter.context;
	    const gl = context.gl;
	    const dem = tile.dem;
	    if (dem && dem.data) {
	        const tileSize = dem.dim;
	        const textureStride = dem.stride;
	        const pixelData = dem.getPixels();
	        context.activeTexture.set(gl.TEXTURE1);
	        context.pixelStoreUnpackPremultiplyAlpha.set(false);
	        tile.demTexture = tile.demTexture || painter.getTileTexture(textureStride);
	        if (tile.demTexture) {
	            const demTexture = tile.demTexture;
	            demTexture.update(pixelData, { premultiply: false });
	            demTexture.bind(gl.NEAREST, gl.CLAMP_TO_EDGE);
	        }
	        else {
	            tile.demTexture = new Texture(context, pixelData, gl.RGBA, { premultiply: false });
	            tile.demTexture.bind(gl.NEAREST, gl.CLAMP_TO_EDGE);
	        }
	        context.activeTexture.set(gl.TEXTURE0);
	        let fbo = tile.fbo;
	        if (!fbo) {
	            const renderTexture = new Texture(context, { width: tileSize, height: tileSize, data: null }, gl.RGBA);
	            renderTexture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	            fbo = tile.fbo = context.createFramebuffer(tileSize, tileSize, true, false);
	            fbo.colorAttachment.set(renderTexture.texture);
	        }
	        context.bindFramebuffer.set(fbo.framebuffer);
	        context.viewport.set([0, 0, tileSize, tileSize]);
	        painter.useProgram('hillshadePrepare').draw(context, gl.TRIANGLES, depthMode, stencilMode, colorMode, CullFaceMode.disabled, hillshadeUniformPrepareValues(tile.tileID, dem), null, layer.id, painter.rasterBoundsBuffer, painter.quadTriangleIndexBuffer, painter.rasterBoundsSegments);
	        tile.needsHillshadePrepare = false;
	    }
	}

	function drawRaster(painter, sourceCache, layer, tileIDs) {
	    if (painter.renderPass !== 'translucent')
	        return;
	    if (layer.paint.get('raster-opacity') === 0)
	        return;
	    if (!tileIDs.length)
	        return;
	    const context = painter.context;
	    const gl = context.gl;
	    const source = sourceCache.getSource();
	    const program = painter.useProgram('raster');
	    const colorMode = painter.colorModeForRenderPass();
	    const [stencilModes, coords] = source instanceof ImageSource ? [{}, tileIDs] :
	        painter.stencilConfigForOverlap(tileIDs);
	    const minTileZ = coords[coords.length - 1].overscaledZ;
	    const align = !painter.options.moving;
	    for (const coord of coords) {
	        // Set the lower zoom level to sublayer 0, and higher zoom levels to higher sublayers
	        // Use gl.LESS to prevent double drawing in areas where tiles overlap.
	        const depthMode = painter.depthModeForSublayer(coord.overscaledZ - minTileZ, layer.paint.get('raster-opacity') === 1 ? DepthMode.ReadWrite : DepthMode.ReadOnly, gl.LESS);
	        const tile = sourceCache.getTile(coord);
	        tile.registerFadeDuration(layer.paint.get('raster-fade-duration'));
	        const parentTile = sourceCache.findLoadedParent(coord, 0), fade = getFadeValues(tile, parentTile, sourceCache, layer, painter.transform, painter.style.map.terrain);
	        let parentScaleBy, parentTL;
	        const textureFilter = layer.paint.get('raster-resampling') === 'nearest' ? gl.NEAREST : gl.LINEAR;
	        context.activeTexture.set(gl.TEXTURE0);
	        tile.texture.bind(textureFilter, gl.CLAMP_TO_EDGE, gl.LINEAR_MIPMAP_NEAREST);
	        context.activeTexture.set(gl.TEXTURE1);
	        if (parentTile) {
	            parentTile.texture.bind(textureFilter, gl.CLAMP_TO_EDGE, gl.LINEAR_MIPMAP_NEAREST);
	            parentScaleBy = Math.pow(2, parentTile.tileID.overscaledZ - tile.tileID.overscaledZ);
	            parentTL = [tile.tileID.canonical.x * parentScaleBy % 1, tile.tileID.canonical.y * parentScaleBy % 1];
	        }
	        else {
	            tile.texture.bind(textureFilter, gl.CLAMP_TO_EDGE, gl.LINEAR_MIPMAP_NEAREST);
	        }
	        const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	        const terrainCoord = terrainData ? coord : null;
	        const posMatrix = terrainCoord ? terrainCoord.posMatrix : painter.transform.calculatePosMatrix(coord.toUnwrapped(), align);
	        const uniformValues = rasterUniformValues(posMatrix, parentTL || [0, 0], parentScaleBy || 1, fade, layer);
	        if (source instanceof ImageSource) {
	            program.draw(context, gl.TRIANGLES, depthMode, StencilMode.disabled, colorMode, CullFaceMode.disabled, uniformValues, terrainData, layer.id, source.boundsBuffer, painter.quadTriangleIndexBuffer, source.boundsSegments);
	        }
	        else {
	            program.draw(context, gl.TRIANGLES, depthMode, stencilModes[coord.overscaledZ], colorMode, CullFaceMode.disabled, uniformValues, terrainData, layer.id, painter.rasterBoundsBuffer, painter.quadTriangleIndexBuffer, painter.rasterBoundsSegments);
	        }
	    }
	}
	function getFadeValues(tile, parentTile, sourceCache, layer, transform, terrain) {
	    const fadeDuration = layer.paint.get('raster-fade-duration');
	    if (!terrain && fadeDuration > 0) {
	        const now = browser.now();
	        const sinceTile = (now - tile.timeAdded) / fadeDuration;
	        const sinceParent = parentTile ? (now - parentTile.timeAdded) / fadeDuration : -1;
	        const source = sourceCache.getSource();
	        const idealZ = transform.coveringZoomLevel({
	            tileSize: source.tileSize,
	            roundZoom: source.roundZoom
	        });
	        // if no parent or parent is older, fade in; if parent is younger, fade out
	        const fadeIn = !parentTile || Math.abs(parentTile.tileID.overscaledZ - idealZ) > Math.abs(tile.tileID.overscaledZ - idealZ);
	        const childOpacity = (fadeIn && tile.refreshedUponExpiration) ? 1 : performance$1.clamp(fadeIn ? sinceTile : 1 - sinceParent, 0, 1);
	        // we don't crossfade tiles that were just refreshed upon expiring:
	        // once they're old enough to pass the crossfading threshold
	        // (fadeDuration), unset the `refreshedUponExpiration` flag so we don't
	        // incorrectly fail to crossfade them when zooming
	        if (tile.refreshedUponExpiration && sinceTile >= 1)
	            tile.refreshedUponExpiration = false;
	        if (parentTile) {
	            return {
	                opacity: 1,
	                mix: 1 - childOpacity
	            };
	        }
	        else {
	            return {
	                opacity: childOpacity,
	                mix: 0
	            };
	        }
	    }
	    else {
	        return {
	            opacity: 1,
	            mix: 0
	        };
	    }
	}

	function drawBackground(painter, sourceCache, layer, coords) {
	    const color = layer.paint.get('background-color');
	    const opacity = layer.paint.get('background-opacity');
	    if (opacity === 0)
	        return;
	    const context = painter.context;
	    const gl = context.gl;
	    const transform = painter.transform;
	    const tileSize = transform.tileSize;
	    const image = layer.paint.get('background-pattern');
	    if (painter.isPatternMissing(image))
	        return;
	    const pass = (!image && color.a === 1 && opacity === 1 && painter.opaquePassEnabledForLayer()) ? 'opaque' : 'translucent';
	    if (painter.renderPass !== pass)
	        return;
	    const stencilMode = StencilMode.disabled;
	    const depthMode = painter.depthModeForSublayer(0, pass === 'opaque' ? DepthMode.ReadWrite : DepthMode.ReadOnly);
	    const colorMode = painter.colorModeForRenderPass();
	    const program = painter.useProgram(image ? 'backgroundPattern' : 'background');
	    const tileIDs = coords ? coords : transform.coveringTiles({ tileSize, terrain: painter.style.map.terrain });
	    if (image) {
	        context.activeTexture.set(gl.TEXTURE0);
	        painter.imageManager.bind(painter.context);
	    }
	    const crossfade = layer.getCrossfadeParameters();
	    for (const tileID of tileIDs) {
	        const matrix = coords ? tileID.posMatrix : painter.transform.calculatePosMatrix(tileID.toUnwrapped());
	        const uniformValues = image ?
	            backgroundPatternUniformValues(matrix, opacity, painter, image, { tileID, tileSize }, crossfade) :
	            backgroundUniformValues(matrix, opacity, color);
	        const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(tileID);
	        program.draw(context, gl.TRIANGLES, depthMode, stencilMode, colorMode, CullFaceMode.disabled, uniformValues, terrainData, layer.id, painter.tileExtentBuffer, painter.quadTriangleIndexBuffer, painter.tileExtentSegments);
	    }
	}

	const topColor = new performance$1.Color(1, 0, 0, 1);
	const btmColor = new performance$1.Color(0, 1, 0, 1);
	const leftColor = new performance$1.Color(0, 0, 1, 1);
	const rightColor = new performance$1.Color(1, 0, 1, 1);
	const centerColor = new performance$1.Color(0, 1, 1, 1);
	function drawDebugPadding(painter) {
	    const padding = painter.transform.padding;
	    const lineWidth = 3;
	    // Top
	    drawHorizontalLine(painter, painter.transform.height - (padding.top || 0), lineWidth, topColor);
	    // Bottom
	    drawHorizontalLine(painter, padding.bottom || 0, lineWidth, btmColor);
	    // Left
	    drawVerticalLine(painter, padding.left || 0, lineWidth, leftColor);
	    // Right
	    drawVerticalLine(painter, painter.transform.width - (padding.right || 0), lineWidth, rightColor);
	    // Center
	    const center = painter.transform.centerPoint;
	    drawCrosshair(painter, center.x, painter.transform.height - center.y, centerColor);
	}
	function drawCrosshair(painter, x, y, color) {
	    const size = 20;
	    const lineWidth = 2;
	    //Vertical line
	    drawDebugSSRect(painter, x - lineWidth / 2, y - size / 2, lineWidth, size, color);
	    //Horizontal line
	    drawDebugSSRect(painter, x - size / 2, y - lineWidth / 2, size, lineWidth, color);
	}
	function drawHorizontalLine(painter, y, lineWidth, color) {
	    drawDebugSSRect(painter, 0, y + lineWidth / 2, painter.transform.width, lineWidth, color);
	}
	function drawVerticalLine(painter, x, lineWidth, color) {
	    drawDebugSSRect(painter, x - lineWidth / 2, 0, lineWidth, painter.transform.height, color);
	}
	function drawDebugSSRect(painter, x, y, width, height, color) {
	    const context = painter.context;
	    const gl = context.gl;
	    gl.enable(gl.SCISSOR_TEST);
	    gl.scissor(x * painter.pixelRatio, y * painter.pixelRatio, width * painter.pixelRatio, height * painter.pixelRatio);
	    context.clear({ color });
	    gl.disable(gl.SCISSOR_TEST);
	}
	function drawDebug(painter, sourceCache, coords) {
	    for (let i = 0; i < coords.length; i++) {
	        drawDebugTile(painter, sourceCache, coords[i]);
	    }
	}
	function drawDebugTile(painter, sourceCache, coord) {
	    const context = painter.context;
	    const gl = context.gl;
	    const posMatrix = coord.posMatrix;
	    const program = painter.useProgram('debug');
	    const depthMode = DepthMode.disabled;
	    const stencilMode = StencilMode.disabled;
	    const colorMode = painter.colorModeForRenderPass();
	    const id = '$debug';
	    const terrainData = painter.style.map.terrain && painter.style.map.terrain.getTerrainData(coord);
	    context.activeTexture.set(gl.TEXTURE0);
	    const tileRawData = sourceCache.getTileByID(coord.key).latestRawTileData;
	    const tileByteLength = (tileRawData && tileRawData.byteLength) || 0;
	    const tileSizeKb = Math.floor(tileByteLength / 1024);
	    const tileSize = sourceCache.getTile(coord).tileSize;
	    const scaleRatio = (512 / Math.min(tileSize, 512) * (coord.overscaledZ / painter.transform.zoom)) * 0.5;
	    let tileIdText = coord.canonical.toString();
	    if (coord.overscaledZ !== coord.canonical.z) {
	        tileIdText += ` => ${coord.overscaledZ}`;
	    }
	    const tileLabel = `${tileIdText} ${tileSizeKb}kB`;
	    drawTextToOverlay(painter, tileLabel);
	    program.draw(context, gl.TRIANGLES, depthMode, stencilMode, ColorMode.alphaBlended, CullFaceMode.disabled, debugUniformValues(posMatrix, performance$1.Color.transparent, scaleRatio), null, id, painter.debugBuffer, painter.quadTriangleIndexBuffer, painter.debugSegments);
	    program.draw(context, gl.LINE_STRIP, depthMode, stencilMode, colorMode, CullFaceMode.disabled, debugUniformValues(posMatrix, performance$1.Color.red), terrainData, id, painter.debugBuffer, painter.tileBorderIndexBuffer, painter.debugSegments);
	}
	function drawTextToOverlay(painter, text) {
	    painter.initDebugOverlayCanvas();
	    const canvas = painter.debugOverlayCanvas;
	    const gl = painter.context.gl;
	    const ctx2d = painter.debugOverlayCanvas.getContext('2d');
	    ctx2d.clearRect(0, 0, canvas.width, canvas.height);
	    ctx2d.shadowColor = 'white';
	    ctx2d.shadowBlur = 2;
	    ctx2d.lineWidth = 1.5;
	    ctx2d.strokeStyle = 'white';
	    ctx2d.textBaseline = 'top';
	    ctx2d.font = `bold ${36}px Open Sans, sans-serif`;
	    ctx2d.fillText(text, 5, 5);
	    ctx2d.strokeText(text, 5, 5);
	    painter.debugOverlayTexture.update(canvas);
	    painter.debugOverlayTexture.bind(gl.LINEAR, gl.CLAMP_TO_EDGE);
	}
	function selectDebugSource(style, zoom) {
	    // Use vector source with highest maxzoom
	    // Else use source with highest maxzoom of any type
	    let selectedSource = null;
	    const layers = Object.values(style._layers);
	    const sources = layers.flatMap((layer) => {
	        if (layer.source && !layer.isHidden(zoom)) {
	            const sourceCache = style.sourceCaches[layer.source];
	            return [sourceCache];
	        }
	        else {
	            return [];
	        }
	    });
	    const vectorSources = sources.filter((source) => source.getSource().type === 'vector');
	    const otherSources = sources.filter((source) => source.getSource().type !== 'vector');
	    const considerSource = (source) => {
	        if (!selectedSource || (selectedSource.getSource().maxzoom < source.getSource().maxzoom)) {
	            selectedSource = source;
	        }
	    };
	    vectorSources.forEach((source) => considerSource(source));
	    if (!selectedSource) {
	        otherSources.forEach((source) => considerSource(source));
	    }
	    return selectedSource;
	}

	function drawCustom(painter, sourceCache, layer) {
	    const context = painter.context;
	    const implementation = layer.implementation;
	    if (painter.renderPass === 'offscreen') {
	        const prerender = implementation.prerender;
	        if (prerender) {
	            painter.setCustomLayerDefaults();
	            context.setColorMode(painter.colorModeForRenderPass());
	            prerender.call(implementation, context.gl, painter.transform.customLayerMatrix());
	            context.setDirty();
	            painter.setBaseState();
	        }
	    }
	    else if (painter.renderPass === 'translucent') {
	        painter.setCustomLayerDefaults();
	        context.setColorMode(painter.colorModeForRenderPass());
	        context.setStencilMode(StencilMode.disabled);
	        const depthMode = implementation.renderingMode === '3d' ?
	            new DepthMode(painter.context.gl.LEQUAL, DepthMode.ReadWrite, painter.depthRangeFor3D) :
	            painter.depthModeForSublayer(0, DepthMode.ReadOnly);
	        context.setDepthMode(depthMode);
	        implementation.render(context.gl, painter.transform.customLayerMatrix());
	        context.setDirty();
	        painter.setBaseState();
	        context.bindFramebuffer.set(null);
	    }
	}

	/**
	 * Redraw the Depth Framebuffer
	 * @param painter - the painter
	 * @param terrain - the terrain
	 */
	function drawDepth(painter, terrain) {
	    const context = painter.context;
	    const gl = context.gl;
	    const colorMode = ColorMode.unblended;
	    const depthMode = new DepthMode(gl.LEQUAL, DepthMode.ReadWrite, [0, 1]);
	    const mesh = terrain.getTerrainMesh();
	    const tiles = terrain.sourceCache.getRenderableTiles();
	    const program = painter.useProgram('terrainDepth');
	    context.bindFramebuffer.set(terrain.getFramebuffer('depth').framebuffer);
	    context.viewport.set([0, 0, painter.width / devicePixelRatio, painter.height / devicePixelRatio]);
	    context.clear({ color: performance$1.Color.transparent, depth: 1 });
	    for (const tile of tiles) {
	        const terrainData = terrain.getTerrainData(tile.tileID);
	        const posMatrix = painter.transform.calculatePosMatrix(tile.tileID.toUnwrapped());
	        const uniformValues = terrainDepthUniformValues(posMatrix, terrain.getMeshFrameDelta(painter.transform.zoom));
	        program.draw(context, gl.TRIANGLES, depthMode, StencilMode.disabled, colorMode, CullFaceMode.backCCW, uniformValues, terrainData, 'terrain', mesh.vertexBuffer, mesh.indexBuffer, mesh.segments);
	    }
	    context.bindFramebuffer.set(null);
	    context.viewport.set([0, 0, painter.width, painter.height]);
	}
	/**
	 * Redraw the Coords Framebuffers
	 * @param painter - the painter
	 * @param terrain - the terrain
	 */
	function drawCoords(painter, terrain) {
	    const context = painter.context;
	    const gl = context.gl;
	    const colorMode = ColorMode.unblended;
	    const depthMode = new DepthMode(gl.LEQUAL, DepthMode.ReadWrite, [0, 1]);
	    const mesh = terrain.getTerrainMesh();
	    const coords = terrain.getCoordsTexture();
	    const tiles = terrain.sourceCache.getRenderableTiles();
	    // draw tile-coords into framebuffer
	    const program = painter.useProgram('terrainCoords');
	    context.bindFramebuffer.set(terrain.getFramebuffer('coords').framebuffer);
	    context.viewport.set([0, 0, painter.width / devicePixelRatio, painter.height / devicePixelRatio]);
	    context.clear({ color: performance$1.Color.transparent, depth: 1 });
	    terrain.coordsIndex = [];
	    for (const tile of tiles) {
	        const terrainData = terrain.getTerrainData(tile.tileID);
	        context.activeTexture.set(gl.TEXTURE0);
	        gl.bindTexture(gl.TEXTURE_2D, coords.texture);
	        const posMatrix = painter.transform.calculatePosMatrix(tile.tileID.toUnwrapped());
	        const uniformValues = terrainCoordsUniformValues(posMatrix, 255 - terrain.coordsIndex.length, terrain.getMeshFrameDelta(painter.transform.zoom));
	        program.draw(context, gl.TRIANGLES, depthMode, StencilMode.disabled, colorMode, CullFaceMode.backCCW, uniformValues, terrainData, 'terrain', mesh.vertexBuffer, mesh.indexBuffer, mesh.segments);
	        terrain.coordsIndex.push(tile.tileID.key);
	    }
	    context.bindFramebuffer.set(null);
	    context.viewport.set([0, 0, painter.width, painter.height]);
	}
	function drawTerrain(painter, terrain, tiles) {
	    const context = painter.context;
	    const gl = context.gl;
	    const colorMode = painter.colorModeForRenderPass();
	    const depthMode = new DepthMode(gl.LEQUAL, DepthMode.ReadWrite, painter.depthRangeFor3D);
	    const program = painter.useProgram('terrain');
	    const mesh = terrain.getTerrainMesh();
	    context.bindFramebuffer.set(null);
	    context.viewport.set([0, 0, painter.width, painter.height]);
	    for (const tile of tiles) {
	        const texture = painter.renderToTexture.getTexture(tile);
	        const terrainData = terrain.getTerrainData(tile.tileID);
	        context.activeTexture.set(gl.TEXTURE0);
	        gl.bindTexture(gl.TEXTURE_2D, texture.texture);
	        const posMatrix = painter.transform.calculatePosMatrix(tile.tileID.toUnwrapped());
	        const uniformValues = terrainUniformValues(posMatrix, terrain.getMeshFrameDelta(painter.transform.zoom));
	        program.draw(context, gl.TRIANGLES, depthMode, StencilMode.disabled, colorMode, CullFaceMode.backCCW, uniformValues, terrainData, 'terrain', mesh.vertexBuffer, mesh.indexBuffer, mesh.segments);
	    }
	}

	/**
	 * @internal
	 * Initialize a new painter object.
	 */
	class Painter {
	    constructor(gl, transform) {
	        this.context = new Context(gl);
	        this.transform = transform;
	        this._tileTextures = {};
	        this.terrainFacilitator = { dirty: true, matrix: performance$1.identity(new Float64Array(16)), renderTime: 0 };
	        this.setup();
	        // Within each layer there are multiple distinct z-planes that can be drawn to.
	        // This is implemented using the WebGL depth buffer.
	        this.numSublayers = SourceCache.maxUnderzooming + SourceCache.maxOverzooming + 1;
	        this.depthEpsilon = 1 / Math.pow(2, 16);
	        this.crossTileSymbolIndex = new CrossTileSymbolIndex();
	    }
	    /*
	     * Update the GL viewport, projection matrix, and transforms to compensate
	     * for a new width and height value.
	     */
	    resize(width, height, pixelRatio) {
	        this.width = Math.floor(width * pixelRatio);
	        this.height = Math.floor(height * pixelRatio);
	        this.pixelRatio = pixelRatio;
	        this.context.viewport.set([0, 0, this.width, this.height]);
	        if (this.style) {
	            for (const layerId of this.style._order) {
	                this.style._layers[layerId].resize();
	            }
	        }
	    }
	    setup() {
	        const context = this.context;
	        const tileExtentArray = new performance$1.PosArray();
	        tileExtentArray.emplaceBack(0, 0);
	        tileExtentArray.emplaceBack(performance$1.EXTENT, 0);
	        tileExtentArray.emplaceBack(0, performance$1.EXTENT);
	        tileExtentArray.emplaceBack(performance$1.EXTENT, performance$1.EXTENT);
	        this.tileExtentBuffer = context.createVertexBuffer(tileExtentArray, posAttributes.members);
	        this.tileExtentSegments = performance$1.SegmentVector.simpleSegment(0, 0, 4, 2);
	        const debugArray = new performance$1.PosArray();
	        debugArray.emplaceBack(0, 0);
	        debugArray.emplaceBack(performance$1.EXTENT, 0);
	        debugArray.emplaceBack(0, performance$1.EXTENT);
	        debugArray.emplaceBack(performance$1.EXTENT, performance$1.EXTENT);
	        this.debugBuffer = context.createVertexBuffer(debugArray, posAttributes.members);
	        this.debugSegments = performance$1.SegmentVector.simpleSegment(0, 0, 4, 5);
	        const rasterBoundsArray = new performance$1.RasterBoundsArray();
	        rasterBoundsArray.emplaceBack(0, 0, 0, 0);
	        rasterBoundsArray.emplaceBack(performance$1.EXTENT, 0, performance$1.EXTENT, 0);
	        rasterBoundsArray.emplaceBack(0, performance$1.EXTENT, 0, performance$1.EXTENT);
	        rasterBoundsArray.emplaceBack(performance$1.EXTENT, performance$1.EXTENT, performance$1.EXTENT, performance$1.EXTENT);
	        this.rasterBoundsBuffer = context.createVertexBuffer(rasterBoundsArray, rasterBoundsAttributes.members);
	        this.rasterBoundsSegments = performance$1.SegmentVector.simpleSegment(0, 0, 4, 2);
	        const viewportArray = new performance$1.PosArray();
	        viewportArray.emplaceBack(0, 0);
	        viewportArray.emplaceBack(1, 0);
	        viewportArray.emplaceBack(0, 1);
	        viewportArray.emplaceBack(1, 1);
	        this.viewportBuffer = context.createVertexBuffer(viewportArray, posAttributes.members);
	        this.viewportSegments = performance$1.SegmentVector.simpleSegment(0, 0, 4, 2);
	        const tileLineStripIndices = new performance$1.LineStripIndexArray();
	        tileLineStripIndices.emplaceBack(0);
	        tileLineStripIndices.emplaceBack(1);
	        tileLineStripIndices.emplaceBack(3);
	        tileLineStripIndices.emplaceBack(2);
	        tileLineStripIndices.emplaceBack(0);
	        this.tileBorderIndexBuffer = context.createIndexBuffer(tileLineStripIndices);
	        const quadTriangleIndices = new performance$1.TriangleIndexArray();
	        quadTriangleIndices.emplaceBack(0, 1, 2);
	        quadTriangleIndices.emplaceBack(2, 1, 3);
	        this.quadTriangleIndexBuffer = context.createIndexBuffer(quadTriangleIndices);
	        const gl = this.context.gl;
	        this.stencilClearMode = new StencilMode({ func: gl.ALWAYS, mask: 0 }, 0x0, 0xFF, gl.ZERO, gl.ZERO, gl.ZERO);
	    }
	    /*
	     * Reset the drawing canvas by clearing the stencil buffer so that we can draw
	     * new tiles at the same location, while retaining previously drawn pixels.
	     */
	    clearStencil() {
	        const context = this.context;
	        const gl = context.gl;
	        this.nextStencilID = 1;
	        this.currentStencilSource = undefined;
	        // As a temporary workaround for https://github.com/mapbox/mapbox-gl-js/issues/5490,
	        // pending an upstream fix, we draw a fullscreen stencil=0 clipping mask here,
	        // effectively clearing the stencil buffer: once an upstream patch lands, remove
	        // this function in favor of context.clear({ stencil: 0x0 })
	        const matrix = performance$1.create();
	        performance$1.ortho(matrix, 0, this.width, this.height, 0, 0, 1);
	        performance$1.scale(matrix, matrix, [gl.drawingBufferWidth, gl.drawingBufferHeight, 0]);
	        this.useProgram('clippingMask').draw(context, gl.TRIANGLES, DepthMode.disabled, this.stencilClearMode, ColorMode.disabled, CullFaceMode.disabled, clippingMaskUniformValues(matrix), null, '$clipping', this.viewportBuffer, this.quadTriangleIndexBuffer, this.viewportSegments);
	    }
	    _renderTileClippingMasks(layer, tileIDs) {
	        if (this.currentStencilSource === layer.source || !layer.isTileClipped() || !tileIDs || !tileIDs.length)
	            return;
	        this.currentStencilSource = layer.source;
	        const context = this.context;
	        const gl = context.gl;
	        if (this.nextStencilID + tileIDs.length > 256) {
	            // we'll run out of fresh IDs so we need to clear and start from scratch
	            this.clearStencil();
	        }
	        context.setColorMode(ColorMode.disabled);
	        context.setDepthMode(DepthMode.disabled);
	        const program = this.useProgram('clippingMask');
	        this._tileClippingMaskIDs = {};
	        for (const tileID of tileIDs) {
	            const id = this._tileClippingMaskIDs[tileID.key] = this.nextStencilID++;
	            const terrainData = this.style.map.terrain && this.style.map.terrain.getTerrainData(tileID);
	            program.draw(context, gl.TRIANGLES, DepthMode.disabled, 
	            // Tests will always pass, and ref value will be written to stencil buffer.
	            new StencilMode({ func: gl.ALWAYS, mask: 0 }, id, 0xFF, gl.KEEP, gl.KEEP, gl.REPLACE), ColorMode.disabled, CullFaceMode.disabled, clippingMaskUniformValues(tileID.posMatrix), terrainData, '$clipping', this.tileExtentBuffer, this.quadTriangleIndexBuffer, this.tileExtentSegments);
	        }
	    }
	    stencilModeFor3D() {
	        this.currentStencilSource = undefined;
	        if (this.nextStencilID + 1 > 256) {
	            this.clearStencil();
	        }
	        const id = this.nextStencilID++;
	        const gl = this.context.gl;
	        return new StencilMode({ func: gl.NOTEQUAL, mask: 0xFF }, id, 0xFF, gl.KEEP, gl.KEEP, gl.REPLACE);
	    }
	    stencilModeForClipping(tileID) {
	        const gl = this.context.gl;
	        return new StencilMode({ func: gl.EQUAL, mask: 0xFF }, this._tileClippingMaskIDs[tileID.key], 0x00, gl.KEEP, gl.KEEP, gl.REPLACE);
	    }
	    /*
	     * Sort coordinates by Z as drawing tiles is done in Z-descending order.
	     * All children with the same Z write the same stencil value.  Children
	     * stencil values are greater than parent's.  This is used only for raster
	     * and raster-dem tiles, which are already clipped to tile boundaries, to
	     * mask area of tile overlapped by children tiles.
	     * Stencil ref values continue range used in _tileClippingMaskIDs.
	     *
	     * Returns [StencilMode for tile overscaleZ map, sortedCoords].
	     */
	    stencilConfigForOverlap(tileIDs) {
	        const gl = this.context.gl;
	        const coords = tileIDs.sort((a, b) => b.overscaledZ - a.overscaledZ);
	        const minTileZ = coords[coords.length - 1].overscaledZ;
	        const stencilValues = coords[0].overscaledZ - minTileZ + 1;
	        if (stencilValues > 1) {
	            this.currentStencilSource = undefined;
	            if (this.nextStencilID + stencilValues > 256) {
	                this.clearStencil();
	            }
	            const zToStencilMode = {};
	            for (let i = 0; i < stencilValues; i++) {
	                zToStencilMode[i + minTileZ] = new StencilMode({ func: gl.GEQUAL, mask: 0xFF }, i + this.nextStencilID, 0xFF, gl.KEEP, gl.KEEP, gl.REPLACE);
	            }
	            this.nextStencilID += stencilValues;
	            return [zToStencilMode, coords];
	        }
	        return [{ [minTileZ]: StencilMode.disabled }, coords];
	    }
	    colorModeForRenderPass() {
	        const gl = this.context.gl;
	        if (this._showOverdrawInspector) {
	            const numOverdrawSteps = 8;
	            const a = 1 / numOverdrawSteps;
	            return new ColorMode([gl.CONSTANT_COLOR, gl.ONE], new performance$1.Color(a, a, a, 0), [true, true, true, true]);
	        }
	        else if (this.renderPass === 'opaque') {
	            return ColorMode.unblended;
	        }
	        else {
	            return ColorMode.alphaBlended;
	        }
	    }
	    depthModeForSublayer(n, mask, func) {
	        if (!this.opaquePassEnabledForLayer())
	            return DepthMode.disabled;
	        const depth = 1 - ((1 + this.currentLayer) * this.numSublayers + n) * this.depthEpsilon;
	        return new DepthMode(func || this.context.gl.LEQUAL, mask, [depth, depth]);
	    }
	    /*
	     * The opaque pass and 3D layers both use the depth buffer.
	     * Layers drawn above 3D layers need to be drawn using the
	     * painter's algorithm so that they appear above 3D features.
	     * This returns true for layers that can be drawn using the
	     * opaque pass.
	     */
	    opaquePassEnabledForLayer() {
	        return this.currentLayer < this.opaquePassCutoff;
	    }
	    render(style, options) {
	        this.style = style;
	        this.options = options;
	        this.lineAtlas = style.lineAtlas;
	        this.imageManager = style.imageManager;
	        this.glyphManager = style.glyphManager;
	        this.symbolFadeChange = style.placement.symbolFadeChange(browser.now());
	        this.imageManager.beginFrame();
	        const layerIds = this.style._order;
	        const sourceCaches = this.style.sourceCaches;
	        const coordsAscending = {};
	        const coordsDescending = {};
	        const coordsDescendingSymbol = {};
	        for (const id in sourceCaches) {
	            const sourceCache = sourceCaches[id];
	            if (sourceCache.used) {
	                sourceCache.prepare(this.context);
	            }
	            coordsAscending[id] = sourceCache.getVisibleCoordinates();
	            coordsDescending[id] = coordsAscending[id].slice().reverse();
	            coordsDescendingSymbol[id] = sourceCache.getVisibleCoordinates(true).reverse();
	        }
	        this.opaquePassCutoff = Infinity;
	        for (let i = 0; i < layerIds.length; i++) {
	            const layerId = layerIds[i];
	            if (this.style._layers[layerId].is3D()) {
	                this.opaquePassCutoff = i;
	                break;
	            }
	        }
	        this.maybeDrawDepthAndCoords(false);
	        if (this.renderToTexture) {
	            this.renderToTexture.prepareForRender(this.style, this.transform.zoom);
	            // this is disabled, because render-to-texture is rendering all layers from bottom to top.
	            this.opaquePassCutoff = 0;
	        }
	        // Offscreen pass ===============================================
	        // We first do all rendering that requires rendering to a separate
	        // framebuffer, and then save those for rendering back to the map
	        // later: in doing this we avoid doing expensive framebuffer restores.
	        this.renderPass = 'offscreen';
	        for (const layerId of layerIds) {
	            const layer = this.style._layers[layerId];
	            if (!layer.hasOffscreenPass() || layer.isHidden(this.transform.zoom))
	                continue;
	            const coords = coordsDescending[layer.source];
	            if (layer.type !== 'custom' && !coords.length)
	                continue;
	            this.renderLayer(this, sourceCaches[layer.source], layer, coords);
	        }
	        // Rebind the main framebuffer now that all offscreen layers have been rendered:
	        this.context.bindFramebuffer.set(null);
	        // Clear buffers in preparation for drawing to the main framebuffer
	        this.context.clear({ color: options.showOverdrawInspector ? performance$1.Color.black : performance$1.Color.transparent, depth: 1 });
	        this.clearStencil();
	        this._showOverdrawInspector = options.showOverdrawInspector;
	        this.depthRangeFor3D = [0, 1 - ((style._order.length + 2) * this.numSublayers * this.depthEpsilon)];
	        // Opaque pass ===============================================
	        // Draw opaque layers top-to-bottom first.
	        if (!this.renderToTexture) {
	            this.renderPass = 'opaque';
	            for (this.currentLayer = layerIds.length - 1; this.currentLayer >= 0; this.currentLayer--) {
	                const layer = this.style._layers[layerIds[this.currentLayer]];
	                const sourceCache = sourceCaches[layer.source];
	                const coords = coordsAscending[layer.source];
	                this._renderTileClippingMasks(layer, coords);
	                this.renderLayer(this, sourceCache, layer, coords);
	            }
	        }
	        // Translucent pass ===============================================
	        // Draw all other layers bottom-to-top.
	        this.renderPass = 'translucent';
	        for (this.currentLayer = 0; this.currentLayer < layerIds.length; this.currentLayer++) {
	            const layer = this.style._layers[layerIds[this.currentLayer]];
	            const sourceCache = sourceCaches[layer.source];
	            if (this.renderToTexture && this.renderToTexture.renderLayer(layer))
	                continue;
	            // For symbol layers in the translucent pass, we add extra tiles to the renderable set
	            // for cross-tile symbol fading. Symbol layers don't use tile clipping, so no need to render
	            // separate clipping masks
	            const coords = (layer.type === 'symbol' ? coordsDescendingSymbol : coordsDescending)[layer.source];
	            this._renderTileClippingMasks(layer, coordsAscending[layer.source]);
	            this.renderLayer(this, sourceCache, layer, coords);
	        }
	        if (this.options.showTileBoundaries) {
	            const selectedSource = selectDebugSource(this.style, this.transform.zoom);
	            if (selectedSource) {
	                drawDebug(this, selectedSource, selectedSource.getVisibleCoordinates());
	            }
	        }
	        if (this.options.showPadding) {
	            drawDebugPadding(this);
	        }
	        // Set defaults for most GL values so that anyone using the state after the render
	        // encounters more expected values.
	        this.context.setDefault();
	    }
	    /**
	     * Update the depth and coords framebuffers, if the contents of those frame buffers is out of date.
	     * If requireExact is false, then the contents of those frame buffers is not updated if it is close
	     * to accurate (that is, the camera has not moved much since it was updated last).
	     */
	    maybeDrawDepthAndCoords(requireExact) {
	        if (!this.style || !this.style.map || !this.style.map.terrain) {
	            return;
	        }
	        const prevMatrix = this.terrainFacilitator.matrix;
	        const currMatrix = this.transform.projMatrix;
	        // Update coords/depth-framebuffer on camera movement, or tile reloading
	        let doUpdate = this.terrainFacilitator.dirty;
	        doUpdate || (doUpdate = requireExact ? !performance$1.exactEquals(prevMatrix, currMatrix) : !performance$1.equals(prevMatrix, currMatrix));
	        doUpdate || (doUpdate = this.style.map.terrain.sourceCache.tilesAfterTime(this.terrainFacilitator.renderTime).length > 0);
	        if (!doUpdate) {
	            return;
	        }
	        performance$1.copy(prevMatrix, currMatrix);
	        this.terrainFacilitator.renderTime = Date.now();
	        this.terrainFacilitator.dirty = false;
	        drawDepth(this, this.style.map.terrain);
	        drawCoords(this, this.style.map.terrain);
	    }
	    renderLayer(painter, sourceCache, layer, coords) {
	        if (layer.isHidden(this.transform.zoom))
	            return;
	        if (layer.type !== 'background' && layer.type !== 'custom' && !(coords || []).length)
	            return;
	        this.id = layer.id;
	        switch (layer.type) {
	            case 'symbol':
	                drawSymbols(painter, sourceCache, layer, coords, this.style.placement.variableOffsets);
	                break;
	            case 'circle':
	                drawCircles(painter, sourceCache, layer, coords);
	                break;
	            case 'heatmap':
	                drawHeatmap(painter, sourceCache, layer, coords);
	                break;
	            case 'line':
	                drawLine(painter, sourceCache, layer, coords);
	                break;
	            case 'fill':
	                drawFill(painter, sourceCache, layer, coords);
	                break;
	            case 'fill-extrusion':
	                drawFillExtrusion(painter, sourceCache, layer, coords);
	                break;
	            case 'hillshade':
	                drawHillshade(painter, sourceCache, layer, coords);
	                break;
	            case 'raster':
	                drawRaster(painter, sourceCache, layer, coords);
	                break;
	            case 'background':
	                drawBackground(painter, sourceCache, layer, coords);
	                break;
	            case 'custom':
	                drawCustom(painter, sourceCache, layer);
	                break;
	        }
	    }
	    /**
	     * Transform a matrix to incorporate the *-translate and *-translate-anchor properties into it.
	     * @param inViewportPixelUnitsUnits - True when the units accepted by the matrix are in viewport pixels instead of tile units.
	     * @returns matrix
	     */
	    translatePosMatrix(matrix, tile, translate, translateAnchor, inViewportPixelUnitsUnits) {
	        if (!translate[0] && !translate[1])
	            return matrix;
	        const angle = inViewportPixelUnitsUnits ?
	            (translateAnchor === 'map' ? this.transform.angle : 0) :
	            (translateAnchor === 'viewport' ? -this.transform.angle : 0);
	        if (angle) {
	            const sinA = Math.sin(angle);
	            const cosA = Math.cos(angle);
	            translate = [
	                translate[0] * cosA - translate[1] * sinA,
	                translate[0] * sinA + translate[1] * cosA
	            ];
	        }
	        const translation = [
	            inViewportPixelUnitsUnits ? translate[0] : pixelsToTileUnits(tile, translate[0], this.transform.zoom),
	            inViewportPixelUnitsUnits ? translate[1] : pixelsToTileUnits(tile, translate[1], this.transform.zoom),
	            0
	        ];
	        const translatedMatrix = new Float32Array(16);
	        performance$1.translate(translatedMatrix, matrix, translation);
	        return translatedMatrix;
	    }
	    saveTileTexture(texture) {
	        const textures = this._tileTextures[texture.size[0]];
	        if (!textures) {
	            this._tileTextures[texture.size[0]] = [texture];
	        }
	        else {
	            textures.push(texture);
	        }
	    }
	    getTileTexture(size) {
	        const textures = this._tileTextures[size];
	        return textures && textures.length > 0 ? textures.pop() : null;
	    }
	    /**
	     * Checks whether a pattern image is needed, and if it is, whether it is not loaded.
	     *
	     * @returns true if a needed image is missing and rendering needs to be skipped.
	     */
	    isPatternMissing(image) {
	        if (!image)
	            return false;
	        if (!image.from || !image.to)
	            return true;
	        const imagePosA = this.imageManager.getPattern(image.from.toString());
	        const imagePosB = this.imageManager.getPattern(image.to.toString());
	        return !imagePosA || !imagePosB;
	    }
	    useProgram(name, programConfiguration) {
	        this.cache = this.cache || {};
	        const key = name +
	            (programConfiguration ? programConfiguration.cacheKey : '') +
	            (this._showOverdrawInspector ? '/overdraw' : '') +
	            (this.style.map.terrain ? '/terrain' : '');
	        if (!this.cache[key]) {
	            this.cache[key] = new Program(this.context, shaders[name], programConfiguration, programUniforms[name], this._showOverdrawInspector, this.style.map.terrain);
	        }
	        return this.cache[key];
	    }
	    /*
	     * Reset some GL state to default values to avoid hard-to-debug bugs
	     * in custom layers.
	     */
	    setCustomLayerDefaults() {
	        // Prevent custom layers from unintentionally modify the last VAO used.
	        // All other state is state is restored on it's own, but for VAOs it's
	        // simpler to unbind so that we don't have to track the state of VAOs.
	        this.context.unbindVAO();
	        // The default values for this state is meaningful and often expected.
	        // Leaving this state dirty could cause a lot of confusion for users.
	        this.context.cullFace.setDefault();
	        this.context.activeTexture.setDefault();
	        this.context.pixelStoreUnpack.setDefault();
	        this.context.pixelStoreUnpackPremultiplyAlpha.setDefault();
	        this.context.pixelStoreUnpackFlipY.setDefault();
	    }
	    /*
	     * Set GL state that is shared by all layers.
	     */
	    setBaseState() {
	        const gl = this.context.gl;
	        this.context.cullFace.set(false);
	        this.context.viewport.set([0, 0, this.width, this.height]);
	        this.context.blendEquation.set(gl.FUNC_ADD);
	    }
	    initDebugOverlayCanvas() {
	        if (this.debugOverlayCanvas == null) {
	            this.debugOverlayCanvas = document.createElement('canvas');
	            this.debugOverlayCanvas.width = 512;
	            this.debugOverlayCanvas.height = 512;
	            const gl = this.context.gl;
	            this.debugOverlayTexture = new Texture(this.context, this.debugOverlayCanvas, gl.RGBA);
	        }
	    }
	    destroy() {
	        if (this.debugOverlayTexture) {
	            this.debugOverlayTexture.destroy();
	        }
	    }
	    /*
	     * Return true if drawing buffer size is != from requested size.
	     * That means that we've reached GL limits somehow.
	     * Note: drawing buffer size changes only when canvas size changes
	     */
	    overLimit() {
	        const { drawingBufferWidth, drawingBufferHeight } = this.context.gl;
	        return this.width !== drawingBufferWidth || this.height !== drawingBufferHeight;
	    }
	}

	class Frustum {
	    constructor(points, planes) {
	        this.points = points;
	        this.planes = planes;
	    }
	    static fromInvProjectionMatrix(invProj, worldSize, zoom) {
	        const clipSpaceCorners = [
	            [-1, 1, -1, 1],
	            [1, 1, -1, 1],
	            [1, -1, -1, 1],
	            [-1, -1, -1, 1],
	            [-1, 1, 1, 1],
	            [1, 1, 1, 1],
	            [1, -1, 1, 1],
	            [-1, -1, 1, 1]
	        ];
	        const scale = Math.pow(2, zoom);
	        // Transform frustum corner points from clip space to tile space, Z to meters
	        const frustumCoords = clipSpaceCorners.map(v => {
	            v = performance$1.transformMat4([], v, invProj);
	            const s = 1.0 / v[3] / worldSize * scale;
	            return performance$1.mul$1(v, v, [s, s, 1.0 / v[3], s]);
	        });
	        const frustumPlanePointIndices = [
	            [0, 1, 2], // near
	            [6, 5, 4], // far
	            [0, 3, 7], // left
	            [2, 1, 5], // right
	            [3, 2, 6], // bottom
	            [0, 4, 5] // top
	        ];
	        const frustumPlanes = frustumPlanePointIndices.map((p) => {
	            const a = performance$1.sub([], frustumCoords[p[0]], frustumCoords[p[1]]);
	            const b = performance$1.sub([], frustumCoords[p[2]], frustumCoords[p[1]]);
	            const n = performance$1.normalize([], performance$1.cross([], a, b));
	            const d = -performance$1.dot(n, frustumCoords[p[1]]);
	            return n.concat(d);
	        });
	        return new Frustum(frustumCoords, frustumPlanes);
	    }
	}
	class Aabb {
	    constructor(min_, max_) {
	        this.min = min_;
	        this.max = max_;
	        this.center = performance$1.scale$1([], performance$1.add([], this.min, this.max), 0.5);
	    }
	    quadrant(index) {
	        const split = [(index % 2) === 0, index < 2];
	        const qMin = performance$1.clone$2(this.min);
	        const qMax = performance$1.clone$2(this.max);
	        for (let axis = 0; axis < split.length; axis++) {
	            qMin[axis] = split[axis] ? this.min[axis] : this.center[axis];
	            qMax[axis] = split[axis] ? this.center[axis] : this.max[axis];
	        }
	        // Elevation is always constant, hence quadrant.max.z = this.max.z
	        qMax[2] = this.max[2];
	        return new Aabb(qMin, qMax);
	    }
	    distanceX(point) {
	        const pointOnAabb = Math.max(Math.min(this.max[0], point[0]), this.min[0]);
	        return pointOnAabb - point[0];
	    }
	    distanceY(point) {
	        const pointOnAabb = Math.max(Math.min(this.max[1], point[1]), this.min[1]);
	        return pointOnAabb - point[1];
	    }
	    // Performs a frustum-aabb intersection test. Returns 0 if there's no intersection,
	    // 1 if shapes are intersecting and 2 if the aabb if fully inside the frustum.
	    intersects(frustum) {
	        // Execute separating axis test between two convex objects to find intersections
	        // Each frustum plane together with 3 major axes define the separating axes
	        const aabbPoints = [
	            [this.min[0], this.min[1], this.min[2], 1],
	            [this.max[0], this.min[1], this.min[2], 1],
	            [this.max[0], this.max[1], this.min[2], 1],
	            [this.min[0], this.max[1], this.min[2], 1],
	            [this.min[0], this.min[1], this.max[2], 1],
	            [this.max[0], this.min[1], this.max[2], 1],
	            [this.max[0], this.max[1], this.max[2], 1],
	            [this.min[0], this.max[1], this.max[2], 1]
	        ];
	        let fullyInside = true;
	        for (let p = 0; p < frustum.planes.length; p++) {
	            const plane = frustum.planes[p];
	            let pointsInside = 0;
	            for (let i = 0; i < aabbPoints.length; i++) {
	                if (performance$1.dot$1(plane, aabbPoints[i]) >= 0) {
	                    pointsInside++;
	                }
	            }
	            if (pointsInside === 0)
	                return 0;
	            if (pointsInside !== aabbPoints.length)
	                fullyInside = false;
	        }
	        if (fullyInside)
	            return 2;
	        for (let axis = 0; axis < 3; axis++) {
	            let projMin = Number.MAX_VALUE;
	            let projMax = -Number.MAX_VALUE;
	            for (let p = 0; p < frustum.points.length; p++) {
	                const projectedPoint = frustum.points[p][axis] - this.min[axis];
	                projMin = Math.min(projMin, projectedPoint);
	                projMax = Math.max(projMax, projectedPoint);
	            }
	            if (projMax < 0 || projMin > this.max[axis] - this.min[axis])
	                return 0;
	        }
	        return 1;
	    }
	}

	/**
	 * An `EdgeInset` object represents screen space padding applied to the edges of the viewport.
	 * This shifts the apprent center or the vanishing point of the map. This is useful for adding floating UI elements
	 * on top of the map and having the vanishing point shift as UI elements resize.
	 *
	 * @group Geography and Geometry
	 */
	class EdgeInsets {
	    constructor(top = 0, bottom = 0, left = 0, right = 0) {
	        if (isNaN(top) || top < 0 ||
	            isNaN(bottom) || bottom < 0 ||
	            isNaN(left) || left < 0 ||
	            isNaN(right) || right < 0) {
	            throw new Error('Invalid value for edge-insets, top, bottom, left and right must all be numbers');
	        }
	        this.top = top;
	        this.bottom = bottom;
	        this.left = left;
	        this.right = right;
	    }
	    /**
	     * Interpolates the inset in-place.
	     * This maintains the current inset value for any inset not present in `target`.
	     * @param start - interpolation start
	     * @param target - interpolation target
	     * @param t - interpolation step/weight
	     * @returns the insets
	     */
	    interpolate(start, target, t) {
	        if (target.top != null && start.top != null)
	            this.top = performance$1.interpolate.number(start.top, target.top, t);
	        if (target.bottom != null && start.bottom != null)
	            this.bottom = performance$1.interpolate.number(start.bottom, target.bottom, t);
	        if (target.left != null && start.left != null)
	            this.left = performance$1.interpolate.number(start.left, target.left, t);
	        if (target.right != null && start.right != null)
	            this.right = performance$1.interpolate.number(start.right, target.right, t);
	        return this;
	    }
	    /**
	     * Utility method that computes the new apprent center or vanishing point after applying insets.
	     * This is in pixels and with the top left being (0.0) and +y being downwards.
	     *
	     * @param width - the width
	     * @param height - the height
	     * @returns the point
	     */
	    getCenter(width, height) {
	        // Clamp insets so they never overflow width/height and always calculate a valid center
	        const x = performance$1.clamp((this.left + width - this.right) / 2, 0, width);
	        const y = performance$1.clamp((this.top + height - this.bottom) / 2, 0, height);
	        return new performance$1.Point(x, y);
	    }
	    equals(other) {
	        return this.top === other.top &&
	            this.bottom === other.bottom &&
	            this.left === other.left &&
	            this.right === other.right;
	    }
	    clone() {
	        return new EdgeInsets(this.top, this.bottom, this.left, this.right);
	    }
	    /**
	     * Returns the current state as json, useful when you want to have a
	     * read-only representation of the inset.
	     *
	     * @returns state as json
	     */
	    toJSON() {
	        return {
	            top: this.top,
	            bottom: this.bottom,
	            left: this.left,
	            right: this.right
	        };
	    }
	}

	const MAX_VALID_LATITUDE = 85.051129;
	/**
	 * @internal
	 * A single transform, generally used for a single tile to be
	 * scaled, rotated, and zoomed.
	 */
	class Transform {
	    constructor(minZoom, maxZoom, minPitch, maxPitch, renderWorldCopies) {
	        this.tileSize = 512; // constant
	        this._renderWorldCopies = renderWorldCopies === undefined ? true : !!renderWorldCopies;
	        this._minZoom = minZoom || 0;
	        this._maxZoom = maxZoom || 22;
	        this._minPitch = (minPitch === undefined || minPitch === null) ? 0 : minPitch;
	        this._maxPitch = (maxPitch === undefined || maxPitch === null) ? 60 : maxPitch;
	        this.setMaxBounds();
	        this.width = 0;
	        this.height = 0;
	        this._center = new performance$1.LngLat(0, 0);
	        this._elevation = 0;
	        this.zoom = 0;
	        this.angle = 0;
	        this._fov = 0.6435011087932844;
	        this._pitch = 0;
	        this._unmodified = true;
	        this._edgeInsets = new EdgeInsets();
	        this._posMatrixCache = {};
	        this._alignedPosMatrixCache = {};
	        this.minElevationForCurrentTile = 0;
	    }
	    clone() {
	        const clone = new Transform(this._minZoom, this._maxZoom, this._minPitch, this.maxPitch, this._renderWorldCopies);
	        clone.apply(this);
	        return clone;
	    }
	    apply(that) {
	        this.tileSize = that.tileSize;
	        this.latRange = that.latRange;
	        this.width = that.width;
	        this.height = that.height;
	        this._center = that._center;
	        this._elevation = that._elevation;
	        this.minElevationForCurrentTile = that.minElevationForCurrentTile;
	        this.zoom = that.zoom;
	        this.angle = that.angle;
	        this._fov = that._fov;
	        this._pitch = that._pitch;
	        this._unmodified = that._unmodified;
	        this._edgeInsets = that._edgeInsets.clone();
	        this._calcMatrices();
	    }
	    get minZoom() { return this._minZoom; }
	    set minZoom(zoom) {
	        if (this._minZoom === zoom)
	            return;
	        this._minZoom = zoom;
	        this.zoom = Math.max(this.zoom, zoom);
	    }
	    get maxZoom() { return this._maxZoom; }
	    set maxZoom(zoom) {
	        if (this._maxZoom === zoom)
	            return;
	        this._maxZoom = zoom;
	        this.zoom = Math.min(this.zoom, zoom);
	    }
	    get minPitch() { return this._minPitch; }
	    set minPitch(pitch) {
	        if (this._minPitch === pitch)
	            return;
	        this._minPitch = pitch;
	        this.pitch = Math.max(this.pitch, pitch);
	    }
	    get maxPitch() { return this._maxPitch; }
	    set maxPitch(pitch) {
	        if (this._maxPitch === pitch)
	            return;
	        this._maxPitch = pitch;
	        this.pitch = Math.min(this.pitch, pitch);
	    }
	    get renderWorldCopies() { return this._renderWorldCopies; }
	    set renderWorldCopies(renderWorldCopies) {
	        if (renderWorldCopies === undefined) {
	            renderWorldCopies = true;
	        }
	        else if (renderWorldCopies === null) {
	            renderWorldCopies = false;
	        }
	        this._renderWorldCopies = renderWorldCopies;
	    }
	    get worldSize() {
	        return this.tileSize * this.scale;
	    }
	    get centerOffset() {
	        return this.centerPoint._sub(this.size._div(2));
	    }
	    get size() {
	        return new performance$1.Point(this.width, this.height);
	    }
	    get bearing() {
	        return -this.angle / Math.PI * 180;
	    }
	    set bearing(bearing) {
	        const b = -performance$1.wrap(bearing, -180, 180) * Math.PI / 180;
	        if (this.angle === b)
	            return;
	        this._unmodified = false;
	        this.angle = b;
	        this._calcMatrices();
	        // 2x2 matrix for rotating points
	        this.rotationMatrix = performance$1.create$2();
	        performance$1.rotate(this.rotationMatrix, this.rotationMatrix, this.angle);
	    }
	    get pitch() {
	        return this._pitch / Math.PI * 180;
	    }
	    set pitch(pitch) {
	        const p = performance$1.clamp(pitch, this.minPitch, this.maxPitch) / 180 * Math.PI;
	        if (this._pitch === p)
	            return;
	        this._unmodified = false;
	        this._pitch = p;
	        this._calcMatrices();
	    }
	    get fov() {
	        return this._fov / Math.PI * 180;
	    }
	    set fov(fov) {
	        fov = Math.max(0.01, Math.min(60, fov));
	        if (this._fov === fov)
	            return;
	        this._unmodified = false;
	        this._fov = fov / 180 * Math.PI;
	        this._calcMatrices();
	    }
	    get zoom() { return this._zoom; }
	    set zoom(zoom) {
	        const constrainedZoom = Math.min(Math.max(zoom, this.minZoom), this.maxZoom);
	        if (this._zoom === constrainedZoom)
	            return;
	        this._unmodified = false;
	        this._zoom = constrainedZoom;
	        this.tileZoom = Math.max(0, Math.floor(constrainedZoom));
	        this.scale = this.zoomScale(constrainedZoom);
	        this._constrain();
	        this._calcMatrices();
	    }
	    get center() { return this._center; }
	    set center(center) {
	        if (center.lat === this._center.lat && center.lng === this._center.lng)
	            return;
	        this._unmodified = false;
	        this._center = center;
	        this._constrain();
	        this._calcMatrices();
	    }
	    /**
	     * Elevation at current center point, meters above sea level
	     */
	    get elevation() { return this._elevation; }
	    set elevation(elevation) {
	        if (elevation === this._elevation)
	            return;
	        this._elevation = elevation;
	        this._constrain();
	        this._calcMatrices();
	    }
	    get padding() { return this._edgeInsets.toJSON(); }
	    set padding(padding) {
	        if (this._edgeInsets.equals(padding))
	            return;
	        this._unmodified = false;
	        //Update edge-insets inplace
	        this._edgeInsets.interpolate(this._edgeInsets, padding, 1);
	        this._calcMatrices();
	    }
	    /**
	     * The center of the screen in pixels with the top-left corner being (0,0)
	     * and +y axis pointing downwards. This accounts for padding.
	     */
	    get centerPoint() {
	        return this._edgeInsets.getCenter(this.width, this.height);
	    }
	    /**
	     * Returns if the padding params match
	     *
	     * @param padding - the padding to check against
	     * @returns true if they are equal, false otherwise
	     */
	    isPaddingEqual(padding) {
	        return this._edgeInsets.equals(padding);
	    }
	    /**
	     * Helper method to update edge-insets in place
	     *
	     * @param start - the starting padding
	     * @param target - the target padding
	     * @param t - the step/weight
	     */
	    interpolatePadding(start, target, t) {
	        this._unmodified = false;
	        this._edgeInsets.interpolate(start, target, t);
	        this._constrain();
	        this._calcMatrices();
	    }
	    /**
	     * Return a zoom level that will cover all tiles the transform
	     * @param options - the options
	     * @returns zoom level An integer zoom level at which all tiles will be visible.
	     */
	    coveringZoomLevel(options) {
	        const z = (options.roundZoom ? Math.round : Math.floor)(this.zoom + this.scaleZoom(this.tileSize / options.tileSize));
	        // At negative zoom levels load tiles from z0 because negative tile zoom levels don't exist.
	        return Math.max(0, z);
	    }
	    /**
	     * Return any "wrapped" copies of a given tile coordinate that are visible
	     * in the current view.
	     */
	    getVisibleUnwrappedCoordinates(tileID) {
	        const result = [new performance$1.UnwrappedTileID(0, tileID)];
	        if (this._renderWorldCopies) {
	            const utl = this.pointCoordinate(new performance$1.Point(0, 0));
	            const utr = this.pointCoordinate(new performance$1.Point(this.width, 0));
	            const ubl = this.pointCoordinate(new performance$1.Point(this.width, this.height));
	            const ubr = this.pointCoordinate(new performance$1.Point(0, this.height));
	            const w0 = Math.floor(Math.min(utl.x, utr.x, ubl.x, ubr.x));
	            const w1 = Math.floor(Math.max(utl.x, utr.x, ubl.x, ubr.x));
	            // Add an extra copy of the world on each side to properly render ImageSources and CanvasSources.
	            // Both sources draw outside the tile boundaries of the tile that "contains them" so we need
	            // to add extra copies on both sides in case offscreen tiles need to draw into on-screen ones.
	            const extraWorldCopy = 1;
	            for (let w = w0 - extraWorldCopy; w <= w1 + extraWorldCopy; w++) {
	                if (w === 0)
	                    continue;
	                result.push(new performance$1.UnwrappedTileID(w, tileID));
	            }
	        }
	        return result;
	    }
	    /**
	     * Return all coordinates that could cover this transform for a covering
	     * zoom level.
	     * @param options - the options
	     * @returns OverscaledTileIDs
	     */
	    coveringTiles(options) {
	        var _a, _b;
	        let z = this.coveringZoomLevel(options);
	        const actualZ = z;
	        if (options.minzoom !== undefined && z < options.minzoom)
	            return [];
	        if (options.maxzoom !== undefined && z > options.maxzoom)
	            z = options.maxzoom;
	        const cameraCoord = this.pointCoordinate(this.getCameraPoint());
	        const centerCoord = performance$1.MercatorCoordinate.fromLngLat(this.center);
	        const numTiles = Math.pow(2, z);
	        const cameraPoint = [numTiles * cameraCoord.x, numTiles * cameraCoord.y, 0];
	        const centerPoint = [numTiles * centerCoord.x, numTiles * centerCoord.y, 0];
	        const cameraFrustum = Frustum.fromInvProjectionMatrix(this.invProjMatrix, this.worldSize, z);
	        // No change of LOD behavior for pitch lower than 60 and when there is no top padding: return only tile ids from the requested zoom level
	        let minZoom = options.minzoom || 0;
	        // Use 0.1 as an epsilon to avoid for explicit == 0.0 floating point checks
	        if (!options.terrain && this.pitch <= 60.0 && this._edgeInsets.top < 0.1)
	            minZoom = z;
	        // There should always be a certain number of maximum zoom level tiles surrounding the center location in 2D or in front of the camera in 3D
	        const radiusOfMaxLvlLodInTiles = options.terrain ? 2 / Math.min(this.tileSize, options.tileSize) * this.tileSize : 3;
	        const newRootTile = (wrap) => {
	            return {
	                aabb: new Aabb([wrap * numTiles, 0, 0], [(wrap + 1) * numTiles, numTiles, 0]),
	                zoom: 0,
	                x: 0,
	                y: 0,
	                wrap,
	                fullyVisible: false
	            };
	        };
	        // Do a depth-first traversal to find visible tiles and proper levels of detail
	        const stack = [];
	        const result = [];
	        const maxZoom = z;
	        const overscaledZ = options.reparseOverscaled ? actualZ : z;
	        if (this._renderWorldCopies) {
	            // Render copy of the globe thrice on both sides
	            for (let i = 1; i <= 3; i++) {
	                stack.push(newRootTile(-i));
	                stack.push(newRootTile(i));
	            }
	        }
	        stack.push(newRootTile(0));
	        while (stack.length > 0) {
	            const it = stack.pop();
	            const x = it.x;
	            const y = it.y;
	            let fullyVisible = it.fullyVisible;
	            // Visibility of a tile is not required if any of its ancestor if fully inside the frustum
	            if (!fullyVisible) {
	                const intersectResult = it.aabb.intersects(cameraFrustum);
	                if (intersectResult === 0)
	                    continue;
	                fullyVisible = intersectResult === 2;
	            }
	            const refPoint = options.terrain ? cameraPoint : centerPoint;
	            const distanceX = it.aabb.distanceX(refPoint);
	            const distanceY = it.aabb.distanceY(refPoint);
	            const longestDim = Math.max(Math.abs(distanceX), Math.abs(distanceY));
	            // We're using distance based heuristics to determine if a tile should be split into quadrants or not.
	            // radiusOfMaxLvlLodInTiles defines that there's always a certain number of maxLevel tiles next to the map center.
	            // Using the fact that a parent node in quadtree is twice the size of its children (per dimension)
	            // we can define distance thresholds for each relative level:
	            // f(k) = offset + 2 + 4 + 8 + 16 + ... + 2^k. This is the same as "offset+2^(k+1)-2"
	            const distToSplit = radiusOfMaxLvlLodInTiles + (1 << (maxZoom - it.zoom)) - 2;
	            // Have we reached the target depth or is the tile too far away to be any split further?
	            if (it.zoom === maxZoom || (longestDim > distToSplit && it.zoom >= minZoom)) {
	                const dz = maxZoom - it.zoom, dx = cameraPoint[0] - 0.5 - (x << dz), dy = cameraPoint[1] - 0.5 - (y << dz);
	                result.push({
	                    tileID: new performance$1.OverscaledTileID(it.zoom === maxZoom ? overscaledZ : it.zoom, it.wrap, it.zoom, x, y),
	                    distanceSq: performance$1.sqrLen([centerPoint[0] - 0.5 - x, centerPoint[1] - 0.5 - y]),
	                    // this variable is currently not used, but may be important to reduce the amount of loaded tiles
	                    tileDistanceToCamera: Math.sqrt(dx * dx + dy * dy)
	                });
	                continue;
	            }
	            for (let i = 0; i < 4; i++) {
	                const childX = (x << 1) + (i % 2);
	                const childY = (y << 1) + (i >> 1);
	                const childZ = it.zoom + 1;
	                let quadrant = it.aabb.quadrant(i);
	                if (options.terrain) {
	                    const tileID = new performance$1.OverscaledTileID(childZ, it.wrap, childZ, childX, childY);
	                    const minMax = options.terrain.getMinMaxElevation(tileID);
	                    const minElevation = (_a = minMax.minElevation) !== null && _a !== void 0 ? _a : this.elevation;
	                    const maxElevation = (_b = minMax.maxElevation) !== null && _b !== void 0 ? _b : this.elevation;
	                    quadrant = new Aabb([quadrant.min[0], quadrant.min[1], minElevation], [quadrant.max[0], quadrant.max[1], maxElevation]);
	                }
	                stack.push({ aabb: quadrant, zoom: childZ, x: childX, y: childY, wrap: it.wrap, fullyVisible });
	            }
	        }
	        return result.sort((a, b) => a.distanceSq - b.distanceSq).map(a => a.tileID);
	    }
	    resize(width, height) {
	        this.width = width;
	        this.height = height;
	        this.pixelsToGLUnits = [2 / width, -2 / height];
	        this._constrain();
	        this._calcMatrices();
	    }
	    get unmodified() { return this._unmodified; }
	    zoomScale(zoom) { return Math.pow(2, zoom); }
	    scaleZoom(scale) { return Math.log(scale) / Math.LN2; }
	    /**
	     * Convert from LngLat to world coordinates (Mercator coordinates scaled by 512)
	     * @param lnglat - the lngLat
	     * @returns Point
	     */
	    project(lnglat) {
	        const lat = performance$1.clamp(lnglat.lat, -MAX_VALID_LATITUDE, MAX_VALID_LATITUDE);
	        return new performance$1.Point(performance$1.mercatorXfromLng(lnglat.lng) * this.worldSize, performance$1.mercatorYfromLat(lat) * this.worldSize);
	    }
	    /**
	     * Convert from world coordinates ([0, 512],[0, 512]) to LngLat ([-180, 180], [-90, 90])
	     * @param point - world coordinate
	     * @returns LngLat
	     */
	    unproject(point) {
	        return new performance$1.MercatorCoordinate(point.x / this.worldSize, point.y / this.worldSize).toLngLat();
	    }
	    get point() { return this.project(this.center); }
	    /**
	     * get the camera position in LngLat and altitudes in meter
	     * @returns An object with lngLat & altitude.
	     */
	    getCameraPosition() {
	        const lngLat = this.pointLocation(this.getCameraPoint());
	        const altitude = Math.cos(this._pitch) * this.cameraToCenterDistance / this._pixelPerMeter;
	        return { lngLat, altitude: altitude + this.elevation };
	    }
	    /**
	     * This method works in combination with freezeElevation activated.
	     * freezeElevtion is enabled during map-panning because during this the camera should sit in constant height.
	     * After panning finished, call this method to recalculate the zoomlevel for the current camera-height in current terrain.
	     * @param terrain - the terrain
	     */
	    recalculateZoom(terrain) {
	        const origElevation = this.elevation;
	        const origAltitude = Math.cos(this._pitch) * this.cameraToCenterDistance / this._pixelPerMeter;
	        // find position the camera is looking on
	        const center = this.pointLocation(this.centerPoint, terrain);
	        const elevation = terrain.getElevationForLngLatZoom(center, this.tileZoom);
	        const deltaElevation = this.elevation - elevation;
	        if (!deltaElevation)
	            return;
	        // The camera's altitude off the ground + the ground's elevation = a constant:
	        // this means the camera stays at the same total height.
	        const requiredAltitude = origAltitude + origElevation - elevation;
	        // Since altitude = Math.cos(this._pitch) * this.cameraToCenterDistance / pixelPerMeter:
	        const requiredPixelPerMeter = Math.cos(this._pitch) * this.cameraToCenterDistance / requiredAltitude;
	        // Since pixelPerMeter = mercatorZfromAltitude(1, center.lat) * worldSize:
	        const requiredWorldSize = requiredPixelPerMeter / performance$1.mercatorZfromAltitude(1, center.lat);
	        // Since worldSize = this.tileSize * scale:
	        const requiredScale = requiredWorldSize / this.tileSize;
	        const zoom = this.scaleZoom(requiredScale);
	        // update matrices
	        this._elevation = elevation;
	        this._center = center;
	        this.zoom = zoom;
	    }
	    setLocationAtPoint(lnglat, point) {
	        const a = this.pointCoordinate(point);
	        const b = this.pointCoordinate(this.centerPoint);
	        const loc = this.locationCoordinate(lnglat);
	        const newCenter = new performance$1.MercatorCoordinate(loc.x - (a.x - b.x), loc.y - (a.y - b.y));
	        this.center = this.coordinateLocation(newCenter);
	        if (this._renderWorldCopies) {
	            this.center = this.center.wrap();
	        }
	    }
	    /**
	     * Given a LngLat location, return the screen point that corresponds to it
	     * @param lnglat - location
	     * @param terrain - optional terrain
	     * @returns screen point
	     */
	    locationPoint(lnglat, terrain) {
	        return terrain ?
	            this.coordinatePoint(this.locationCoordinate(lnglat), terrain.getElevationForLngLatZoom(lnglat, this.tileZoom), this.pixelMatrix3D) :
	            this.coordinatePoint(this.locationCoordinate(lnglat));
	    }
	    /**
	     * Given a point on screen, return its lnglat
	     * @param p - screen point
	     * @param terrain - optional terrain
	     * @returns lnglat location
	     */
	    pointLocation(p, terrain) {
	        return this.coordinateLocation(this.pointCoordinate(p, terrain));
	    }
	    /**
	     * Given a geographical lnglat, return an unrounded
	     * coordinate that represents it at low zoom level.
	     * @param lnglat - the location
	     * @returns The mercator coordinate
	     */
	    locationCoordinate(lnglat) {
	        return performance$1.MercatorCoordinate.fromLngLat(lnglat);
	    }
	    /**
	     * Given a Coordinate, return its geographical position.
	     * @param coord - mercator coordinates
	     * @returns lng and lat
	     */
	    coordinateLocation(coord) {
	        return coord && coord.toLngLat();
	    }
	    /**
	     * Given a Point, return its mercator coordinate.
	     * @param p - the point
	     * @param terrain - optional terrain
	     * @returns lnglat
	     */
	    pointCoordinate(p, terrain) {
	        // get point-coordinate from terrain coordinates framebuffer
	        if (terrain) {
	            const coordinate = terrain.pointCoordinate(p);
	            if (coordinate != null) {
	                return coordinate;
	            }
	        }
	        // calculate point-coordinate on flat earth
	        const targetZ = 0;
	        // since we don't know the correct projected z value for the point,
	        // unproject two points to get a line and then find the point on that
	        // line with z=0
	        const coord0 = [p.x, p.y, 0, 1];
	        const coord1 = [p.x, p.y, 1, 1];
	        performance$1.transformMat4(coord0, coord0, this.pixelMatrixInverse);
	        performance$1.transformMat4(coord1, coord1, this.pixelMatrixInverse);
	        const w0 = coord0[3];
	        const w1 = coord1[3];
	        const x0 = coord0[0] / w0;
	        const x1 = coord1[0] / w1;
	        const y0 = coord0[1] / w0;
	        const y1 = coord1[1] / w1;
	        const z0 = coord0[2] / w0;
	        const z1 = coord1[2] / w1;
	        const t = z0 === z1 ? 0 : (targetZ - z0) / (z1 - z0);
	        return new performance$1.MercatorCoordinate(performance$1.interpolate.number(x0, x1, t) / this.worldSize, performance$1.interpolate.number(y0, y1, t) / this.worldSize);
	    }
	    /**
	     * Given a coordinate, return the screen point that corresponds to it
	     * @param coord - the coordinates
	     * @param elevation - the elevation
	     * @param pixelMatrix - the pixel matrix
	     * @returns screen point
	     */
	    coordinatePoint(coord, elevation = 0, pixelMatrix = this.pixelMatrix) {
	        const p = [coord.x * this.worldSize, coord.y * this.worldSize, elevation, 1];
	        performance$1.transformMat4(p, p, pixelMatrix);
	        return new performance$1.Point(p[0] / p[3], p[1] / p[3]);
	    }
	    /**
	     * Returns the map's geographical bounds. When the bearing or pitch is non-zero, the visible region is not
	     * an axis-aligned rectangle, and the result is the smallest bounds that encompasses the visible region.
	     * @returns Returns a {@link LngLatBounds} object describing the map's geographical bounds.
	     */
	    getBounds() {
	        const top = Math.max(0, this.height / 2 - this.getHorizon());
	        return new LngLatBounds()
	            .extend(this.pointLocation(new performance$1.Point(0, top)))
	            .extend(this.pointLocation(new performance$1.Point(this.width, top)))
	            .extend(this.pointLocation(new performance$1.Point(this.width, this.height)))
	            .extend(this.pointLocation(new performance$1.Point(0, this.height)));
	    }
	    /**
	     * Returns the maximum geographical bounds the map is constrained to, or `null` if none set.
	     * @returns max bounds
	     */
	    getMaxBounds() {
	        if (!this.latRange || this.latRange.length !== 2 ||
	            !this.lngRange || this.lngRange.length !== 2)
	            return null;
	        return new LngLatBounds([this.lngRange[0], this.latRange[0]], [this.lngRange[1], this.latRange[1]]);
	    }
	    /**
	     * Calculate pixel height of the visible horizon in relation to map-center (e.g. height/2),
	     * multiplied by a static factor to simulate the earth-radius.
	     * The calculated value is the horizontal line from the camera-height to sea-level.
	     * @returns Horizon above center in pixels.
	     */
	    getHorizon() {
	        return Math.tan(Math.PI / 2 - this._pitch) * this.cameraToCenterDistance * 0.85;
	    }
	    /**
	     * Sets or clears the map's geographical constraints.
	     * @param bounds - A {@link LngLatBounds} object describing the new geographic boundaries of the map.
	     */
	    setMaxBounds(bounds) {
	        if (bounds) {
	            this.lngRange = [bounds.getWest(), bounds.getEast()];
	            this.latRange = [bounds.getSouth(), bounds.getNorth()];
	            this._constrain();
	        }
	        else {
	            this.lngRange = null;
	            this.latRange = [-MAX_VALID_LATITUDE, MAX_VALID_LATITUDE];
	        }
	    }
	    /**
	     * Calculate the posMatrix that, given a tile coordinate, would be used to display the tile on a map.
	     * @param unwrappedTileID - the tile ID
	     */
	    calculatePosMatrix(unwrappedTileID, aligned = false) {
	        const posMatrixKey = unwrappedTileID.key;
	        const cache = aligned ? this._alignedPosMatrixCache : this._posMatrixCache;
	        if (cache[posMatrixKey]) {
	            return cache[posMatrixKey];
	        }
	        const canonical = unwrappedTileID.canonical;
	        const scale = this.worldSize / this.zoomScale(canonical.z);
	        const unwrappedX = canonical.x + Math.pow(2, canonical.z) * unwrappedTileID.wrap;
	        const posMatrix = performance$1.identity(new Float64Array(16));
	        performance$1.translate(posMatrix, posMatrix, [unwrappedX * scale, canonical.y * scale, 0]);
	        performance$1.scale(posMatrix, posMatrix, [scale / performance$1.EXTENT, scale / performance$1.EXTENT, 1]);
	        performance$1.multiply(posMatrix, aligned ? this.alignedProjMatrix : this.projMatrix, posMatrix);
	        cache[posMatrixKey] = new Float32Array(posMatrix);
	        return cache[posMatrixKey];
	    }
	    customLayerMatrix() {
	        return this.mercatorMatrix.slice();
	    }
	    /**
	     * Get center lngLat and zoom to ensure that
	     * 1) everything beyond the bounds is excluded
	     * 2) a given lngLat is as near the center as possible
	     * Bounds are those set by maxBounds or North & South "Poles" and, if only 1 globe is displayed, antimeridian.
	     */
	    getConstrained(lngLat, zoom) {
	        zoom = performance$1.clamp(+zoom, this.minZoom, this.maxZoom);
	        const result = {
	            center: new performance$1.LngLat(lngLat.lng, lngLat.lat),
	            zoom
	        };
	        let lngRange = this.lngRange;
	        if (!this._renderWorldCopies && lngRange === null) {
	            const almost180 = 180 - 1e-10;
	            lngRange = [-almost180, almost180];
	        }
	        const worldSize = this.tileSize * this.zoomScale(result.zoom); // A world size for the requested zoom level, not the current world size
	        let minY = 0;
	        let maxY = worldSize;
	        let minX = 0;
	        let maxX = worldSize;
	        let scaleY = 0;
	        let scaleX = 0;
	        const { x: screenWidth, y: screenHeight } = this.size;
	        if (this.latRange) {
	            const latRange = this.latRange;
	            minY = performance$1.mercatorYfromLat(latRange[1]) * worldSize;
	            maxY = performance$1.mercatorYfromLat(latRange[0]) * worldSize;
	            const shouldZoomIn = maxY - minY < screenHeight;
	            if (shouldZoomIn)
	                scaleY = screenHeight / (maxY - minY);
	        }
	        if (lngRange) {
	            minX = performance$1.wrap(performance$1.mercatorXfromLng(lngRange[0]) * worldSize, 0, worldSize);
	            maxX = performance$1.wrap(performance$1.mercatorXfromLng(lngRange[1]) * worldSize, 0, worldSize);
	            if (maxX < minX)
	                maxX += worldSize;
	            const shouldZoomIn = maxX - minX < screenWidth;
	            if (shouldZoomIn)
	                scaleX = screenWidth / (maxX - minX);
	        }
	        const { x: originalX, y: originalY } = this.project.call({ worldSize }, lngLat);
	        let modifiedX, modifiedY;
	        const scale = Math.max(scaleX || 0, scaleY || 0);
	        if (scale) {
	            // zoom in to exclude all beyond the given lng/lat ranges
	            const newPoint = new performance$1.Point(scaleX ? (maxX + minX) / 2 : originalX, scaleY ? (maxY + minY) / 2 : originalY);
	            result.center = this.unproject.call({ worldSize }, newPoint).wrap();
	            result.zoom += this.scaleZoom(scale);
	            return result;
	        }
	        if (this.latRange) {
	            const h2 = screenHeight / 2;
	            if (originalY - h2 < minY)
	                modifiedY = minY + h2;
	            if (originalY + h2 > maxY)
	                modifiedY = maxY - h2;
	        }
	        if (lngRange) {
	            const centerX = (minX + maxX) / 2;
	            let wrappedX = originalX;
	            if (this._renderWorldCopies) {
	                wrappedX = performance$1.wrap(originalX, centerX - worldSize / 2, centerX + worldSize / 2);
	            }
	            const w2 = screenWidth / 2;
	            if (wrappedX - w2 < minX)
	                modifiedX = minX + w2;
	            if (wrappedX + w2 > maxX)
	                modifiedX = maxX - w2;
	        }
	        // pan the map if the screen goes off the range
	        if (modifiedX !== undefined || modifiedY !== undefined) {
	            const newPoint = new performance$1.Point(modifiedX !== null && modifiedX !== void 0 ? modifiedX : originalX, modifiedY !== null && modifiedY !== void 0 ? modifiedY : originalY);
	            result.center = this.unproject.call({ worldSize }, newPoint).wrap();
	        }
	        return result;
	    }
	    _constrain() {
	        if (!this.center || !this.width || !this.height || this._constraining)
	            return;
	        this._constraining = true;
	        const unmodified = this._unmodified;
	        const { center, zoom } = this.getConstrained(this.center, this.zoom);
	        this.center = center;
	        this.zoom = zoom;
	        this._unmodified = unmodified;
	        this._constraining = false;
	    }
	    _calcMatrices() {
	        if (!this.height)
	            return;
	        const halfFov = this._fov / 2;
	        const offset = this.centerOffset;
	        const x = this.point.x, y = this.point.y;
	        this.cameraToCenterDistance = 0.5 / Math.tan(halfFov) * this.height;
	        this._pixelPerMeter = performance$1.mercatorZfromAltitude(1, this.center.lat) * this.worldSize;
	        let m = performance$1.identity(new Float64Array(16));
	        performance$1.scale(m, m, [this.width / 2, -this.height / 2, 1]);
	        performance$1.translate(m, m, [1, -1, 0]);
	        this.labelPlaneMatrix = m;
	        m = performance$1.identity(new Float64Array(16));
	        performance$1.scale(m, m, [1, -1, 1]);
	        performance$1.translate(m, m, [-1, -1, 0]);
	        performance$1.scale(m, m, [2 / this.width, 2 / this.height, 1]);
	        this.glCoordMatrix = m;
	        // Calculate the camera to sea-level distance in pixel in respect of terrain
	        const cameraToSeaLevelDistance = this.cameraToCenterDistance + this._elevation * this._pixelPerMeter / Math.cos(this._pitch);
	        // In case of negative minimum elevation (e.g. the dead see, under the sea maps) use a lower plane for calculation
	        const minElevation = Math.min(this.elevation, this.minElevationForCurrentTile);
	        const cameraToLowestPointDistance = cameraToSeaLevelDistance - minElevation * this._pixelPerMeter / Math.cos(this._pitch);
	        const lowestPlane = minElevation < 0 ? cameraToLowestPointDistance : cameraToSeaLevelDistance;
	        // Find the distance from the center point [width/2 + offset.x, height/2 + offset.y] to the
	        // center top point [width/2 + offset.x, 0] in Z units, using the law of sines.
	        // 1 Z unit is equivalent to 1 horizontal px at the center of the map
	        // (the distance between[width/2, height/2] and [width/2 + 1, height/2])
	        const groundAngle = Math.PI / 2 + this._pitch;
	        const fovAboveCenter = this._fov * (0.5 + offset.y / this.height);
	        const topHalfSurfaceDistance = Math.sin(fovAboveCenter) * lowestPlane / Math.sin(performance$1.clamp(Math.PI - groundAngle - fovAboveCenter, 0.01, Math.PI - 0.01));
	        // Find the distance from the center point to the horizon
	        const horizon = this.getHorizon();
	        const horizonAngle = Math.atan(horizon / this.cameraToCenterDistance);
	        const fovCenterToHorizon = 2 * horizonAngle * (0.5 + offset.y / (horizon * 2));
	        const topHalfSurfaceDistanceHorizon = Math.sin(fovCenterToHorizon) * lowestPlane / Math.sin(performance$1.clamp(Math.PI - groundAngle - fovCenterToHorizon, 0.01, Math.PI - 0.01));
	        // Calculate z distance of the farthest fragment that should be rendered.
	        // Add a bit extra to avoid precision problems when a fragment's distance is exactly `furthestDistance`
	        const topHalfMinDistance = Math.min(topHalfSurfaceDistance, topHalfSurfaceDistanceHorizon);
	        const farZ = (Math.cos(Math.PI / 2 - this._pitch) * topHalfMinDistance + lowestPlane) * 1.01;
	        // The larger the value of nearZ is
	        // - the more depth precision is available for features (good)
	        // - clipping starts appearing sooner when the camera is close to 3d features (bad)
	        //
	        // Other values work for mapbox-gl-js but deckgl was encountering precision issues
	        // when rendering custom layers. This value was experimentally chosen and
	        // seems to solve z-fighting issues in deckgl while not clipping buildings too close to the camera.
	        const nearZ = this.height / 50;
	        // matrix for conversion from location to clip space(-1 .. 1)
	        m = new Float64Array(16);
	        performance$1.perspective(m, this._fov, this.width / this.height, nearZ, farZ);
	        // Apply center of perspective offset
	        m[8] = -offset.x * 2 / this.width;
	        m[9] = offset.y * 2 / this.height;
	        performance$1.scale(m, m, [1, -1, 1]);
	        performance$1.translate(m, m, [0, 0, -this.cameraToCenterDistance]);
	        performance$1.rotateX(m, m, this._pitch);
	        performance$1.rotateZ(m, m, this.angle);
	        performance$1.translate(m, m, [-x, -y, 0]);
	        // The mercatorMatrix can be used to transform points from mercator coordinates
	        // ([0, 0] nw, [1, 1] se) to clip space.
	        this.mercatorMatrix = performance$1.scale([], m, [this.worldSize, this.worldSize, this.worldSize]);
	        // scale vertically to meters per pixel (inverse of ground resolution):
	        performance$1.scale(m, m, [1, 1, this._pixelPerMeter]);
	        // matrix for conversion from world space to screen coordinates in 2D
	        this.pixelMatrix = performance$1.multiply(new Float64Array(16), this.labelPlaneMatrix, m);
	        // matrix for conversion from world space to clip space (-1 .. 1)
	        performance$1.translate(m, m, [0, 0, -this.elevation]); // elevate camera over terrain
	        this.projMatrix = m;
	        this.invProjMatrix = performance$1.invert([], m);
	        // matrix for conversion from world space to screen coordinates in 3D
	        this.pixelMatrix3D = performance$1.multiply(new Float64Array(16), this.labelPlaneMatrix, m);
	        // Make a second projection matrix that is aligned to a pixel grid for rendering raster tiles.
	        // We're rounding the (floating point) x/y values to achieve to avoid rendering raster images to fractional
	        // coordinates. Additionally, we adjust by half a pixel in either direction in case that viewport dimension
	        // is an odd integer to preserve rendering to the pixel grid. We're rotating this shift based on the angle
	        // of the transformation so that 0°, 90°, 180°, and 270° rasters are crisp, and adjust the shift so that
	        // it is always <= 0.5 pixels.
	        const xShift = (this.width % 2) / 2, yShift = (this.height % 2) / 2, angleCos = Math.cos(this.angle), angleSin = Math.sin(this.angle), dx = x - Math.round(x) + angleCos * xShift + angleSin * yShift, dy = y - Math.round(y) + angleCos * yShift + angleSin * xShift;
	        const alignedM = new Float64Array(m);
	        performance$1.translate(alignedM, alignedM, [dx > 0.5 ? dx - 1 : dx, dy > 0.5 ? dy - 1 : dy, 0]);
	        this.alignedProjMatrix = alignedM;
	        // inverse matrix for conversion from screen coordinates to location
	        m = performance$1.invert(new Float64Array(16), this.pixelMatrix);
	        if (!m)
	            throw new Error('failed to invert matrix');
	        this.pixelMatrixInverse = m;
	        this._posMatrixCache = {};
	        this._alignedPosMatrixCache = {};
	    }
	    maxPitchScaleFactor() {
	        // calcMatrices hasn't run yet
	        if (!this.pixelMatrixInverse)
	            return 1;
	        const coord = this.pointCoordinate(new performance$1.Point(0, 0));
	        const p = [coord.x * this.worldSize, coord.y * this.worldSize, 0, 1];
	        const topPoint = performance$1.transformMat4(p, p, this.pixelMatrix);
	        return topPoint[3] / this.cameraToCenterDistance;
	    }
	    /**
	     * The camera looks at the map from a 3D (lng, lat, altitude) location. Let's use `cameraLocation`
	     * as the name for the location under the camera and on the surface of the earth (lng, lat, 0).
	     * `cameraPoint` is the projected position of the `cameraLocation`.
	     *
	     * This point is useful to us because only fill-extrusions that are between `cameraPoint` and
	     * the query point on the surface of the earth can extend and intersect the query.
	     *
	     * When the map is not pitched the `cameraPoint` is equivalent to the center of the map because
	     * the camera is right above the center of the map.
	     */
	    getCameraPoint() {
	        const pitch = this._pitch;
	        const yOffset = Math.tan(pitch) * (this.cameraToCenterDistance || 1);
	        return this.centerPoint.add(new performance$1.Point(0, yOffset));
	    }
	    /**
	     * When the map is pitched, some of the 3D features that intersect a query will not intersect
	     * the query at the surface of the earth. Instead the feature may be closer and only intersect
	     * the query because it extrudes into the air.
	     * @param queryGeometry - For point queries, the line from the query point to the "camera point",
	     * for other geometries, the envelope of the query geometry and the "camera point"
	     * @returns a geometry that includes all of the original query as well as all possible ares of the
	     * screen where the *base* of a visible extrusion could be.
	     *
	     */
	    getCameraQueryGeometry(queryGeometry) {
	        const c = this.getCameraPoint();
	        if (queryGeometry.length === 1) {
	            return [queryGeometry[0], c];
	        }
	        else {
	            let minX = c.x;
	            let minY = c.y;
	            let maxX = c.x;
	            let maxY = c.y;
	            for (const p of queryGeometry) {
	                minX = Math.min(minX, p.x);
	                minY = Math.min(minY, p.y);
	                maxX = Math.max(maxX, p.x);
	                maxY = Math.max(maxY, p.y);
	            }
	            return [
	                new performance$1.Point(minX, minY),
	                new performance$1.Point(maxX, minY),
	                new performance$1.Point(maxX, maxY),
	                new performance$1.Point(minX, maxY),
	                new performance$1.Point(minX, minY)
	            ];
	        }
	    }
	    /**
	     * Return the distance to the camera in clip space from a LngLat.
	     * This can be compared to the value from the depth buffer (terrain.depthAtPoint)
	     * to determine whether a point is occluded.
	     * @param lngLat - the point
	     * @param elevation - the point's elevation
	     * @returns depth value in clip space (between 0 and 1)
	     */
	    lngLatToCameraDepth(lngLat, elevation) {
	        const coord = this.locationCoordinate(lngLat);
	        const p = [coord.x * this.worldSize, coord.y * this.worldSize, elevation, 1];
	        performance$1.transformMat4(p, p, this.projMatrix);
	        return (p[2] / p[3]);
	    }
	}

	/**
	 * Throttle the given function to run at most every `period` milliseconds.
	 */
	function throttle(fn, time) {
	    let pending = false;
	    let timerId = null;
	    let lastCallContext = null;
	    let lastCallArgs;
	    const later = () => {
	        timerId = null;
	        if (pending) {
	            fn.apply(lastCallContext, lastCallArgs);
	            timerId = setTimeout(later, time);
	            pending = false;
	        }
	    };
	    return (...args) => {
	        pending = true;
	        lastCallContext = this;
	        lastCallArgs = args;
	        if (!timerId) {
	            later();
	        }
	        return timerId;
	    };
	}

	/**
	 * Adds the map's position to its page's location hash.
	 * Passed as an option to the map object.
	 *
	 * @group Markers and Controls
	 */
	class Hash {
	    constructor(hashName) {
	        this._getCurrentHash = () => {
	            // Get the current hash from location, stripped from its number sign
	            const hash = window.location.hash.replace('#', '');
	            if (this._hashName) {
	                // Split the parameter-styled hash into parts and find the value we need
	                let keyval;
	                hash.split('&').map(part => part.split('=')).forEach(part => {
	                    if (part[0] === this._hashName) {
	                        keyval = part;
	                    }
	                });
	                return (keyval ? keyval[1] || '' : '').split('/');
	            }
	            return hash.split('/');
	        };
	        this._onHashChange = () => {
	            const loc = this._getCurrentHash();
	            if (loc.length >= 3 && !loc.some(v => isNaN(v))) {
	                const bearing = this._map.dragRotate.isEnabled() && this._map.touchZoomRotate.isEnabled() ? +(loc[3] || 0) : this._map.getBearing();
	                this._map.jumpTo({
	                    center: [+loc[2], +loc[1]],
	                    zoom: +loc[0],
	                    bearing,
	                    pitch: +(loc[4] || 0)
	                });
	                return true;
	            }
	            return false;
	        };
	        this._updateHashUnthrottled = () => {
	            // Replace if already present, else append the updated hash string
	            const location = window.location.href.replace(/(#.+)?$/, this.getHashString());
	            try {
	                window.history.replaceState(window.history.state, null, location);
	            }
	            catch (SecurityError) {
	                // IE11 does not allow this if the page is within an iframe created
	                // with iframe.contentWindow.document.write(...).
	                // https://github.com/mapbox/mapbox-gl-js/issues/7410
	            }
	        };
	        /**
	         * Mobile Safari doesn't allow updating the hash more than 100 times per 30 seconds.
	         */
	        this._updateHash = throttle(this._updateHashUnthrottled, 30 * 1000 / 100);
	        this._hashName = hashName && encodeURIComponent(hashName);
	    }
	    /**
	     * Map element to listen for coordinate changes
	     *
	     * @param map - The map object
	     * @returns `this`
	     */
	    addTo(map) {
	        this._map = map;
	        addEventListener('hashchange', this._onHashChange, false);
	        this._map.on('moveend', this._updateHash);
	        return this;
	    }
	    /**
	     * Removes hash
	     *
	     * @returns `this`
	     */
	    remove() {
	        removeEventListener('hashchange', this._onHashChange, false);
	        this._map.off('moveend', this._updateHash);
	        clearTimeout(this._updateHash());
	        delete this._map;
	        return this;
	    }
	    getHashString(mapFeedback) {
	        const center = this._map.getCenter(), zoom = Math.round(this._map.getZoom() * 100) / 100, 
	        // derived from equation: 512px * 2^z / 360 / 10^d < 0.5px
	        precision = Math.ceil((zoom * Math.LN2 + Math.log(512 / 360 / 0.5)) / Math.LN10), m = Math.pow(10, precision), lng = Math.round(center.lng * m) / m, lat = Math.round(center.lat * m) / m, bearing = this._map.getBearing(), pitch = this._map.getPitch();
	        let hash = '';
	        if (mapFeedback) {
	            // new map feedback site has some constraints that don't allow
	            // us to use the same hash format as we do for the Map hash option.
	            hash += `/${lng}/${lat}/${zoom}`;
	        }
	        else {
	            hash += `${zoom}/${lat}/${lng}`;
	        }
	        if (bearing || pitch)
	            hash += (`/${Math.round(bearing * 10) / 10}`);
	        if (pitch)
	            hash += (`/${Math.round(pitch)}`);
	        if (this._hashName) {
	            const hashName = this._hashName;
	            let found = false;
	            const parts = window.location.hash.slice(1).split('&').map(part => {
	                const key = part.split('=')[0];
	                if (key === hashName) {
	                    found = true;
	                    return `${key}=${hash}`;
	                }
	                return part;
	            }).filter(a => a);
	            if (!found) {
	                parts.push(`${hashName}=${hash}`);
	            }
	            return `#${parts.join('&')}`;
	        }
	        return `#${hash}`;
	    }
	}

	const defaultInertiaOptions = {
	    linearity: 0.3,
	    easing: performance$1.bezier(0, 0, 0.3, 1),
	};
	const defaultPanInertiaOptions = performance$1.extend({
	    deceleration: 2500,
	    maxSpeed: 1400
	}, defaultInertiaOptions);
	const defaultZoomInertiaOptions = performance$1.extend({
	    deceleration: 20,
	    maxSpeed: 1400
	}, defaultInertiaOptions);
	const defaultBearingInertiaOptions = performance$1.extend({
	    deceleration: 1000,
	    maxSpeed: 360
	}, defaultInertiaOptions);
	const defaultPitchInertiaOptions = performance$1.extend({
	    deceleration: 1000,
	    maxSpeed: 90
	}, defaultInertiaOptions);
	class HandlerInertia {
	    constructor(map) {
	        this._map = map;
	        this.clear();
	    }
	    clear() {
	        this._inertiaBuffer = [];
	    }
	    record(settings) {
	        this._drainInertiaBuffer();
	        this._inertiaBuffer.push({ time: browser.now(), settings });
	    }
	    _drainInertiaBuffer() {
	        const inertia = this._inertiaBuffer, now = browser.now(), cutoff = 160; //msec
	        while (inertia.length > 0 && now - inertia[0].time > cutoff)
	            inertia.shift();
	    }
	    _onMoveEnd(panInertiaOptions) {
	        this._drainInertiaBuffer();
	        if (this._inertiaBuffer.length < 2) {
	            return;
	        }
	        const deltas = {
	            zoom: 0,
	            bearing: 0,
	            pitch: 0,
	            pan: new performance$1.Point(0, 0),
	            pinchAround: undefined,
	            around: undefined
	        };
	        for (const { settings } of this._inertiaBuffer) {
	            deltas.zoom += settings.zoomDelta || 0;
	            deltas.bearing += settings.bearingDelta || 0;
	            deltas.pitch += settings.pitchDelta || 0;
	            if (settings.panDelta)
	                deltas.pan._add(settings.panDelta);
	            if (settings.around)
	                deltas.around = settings.around;
	            if (settings.pinchAround)
	                deltas.pinchAround = settings.pinchAround;
	        }
	        const lastEntry = this._inertiaBuffer[this._inertiaBuffer.length - 1];
	        const duration = (lastEntry.time - this._inertiaBuffer[0].time);
	        const easeOptions = {};
	        if (deltas.pan.mag()) {
	            const result = calculateEasing(deltas.pan.mag(), duration, performance$1.extend({}, defaultPanInertiaOptions, panInertiaOptions || {}));
	            easeOptions.offset = deltas.pan.mult(result.amount / deltas.pan.mag());
	            easeOptions.center = this._map.transform.center;
	            extendDuration(easeOptions, result);
	        }
	        if (deltas.zoom) {
	            const result = calculateEasing(deltas.zoom, duration, defaultZoomInertiaOptions);
	            easeOptions.zoom = this._map.transform.zoom + result.amount;
	            extendDuration(easeOptions, result);
	        }
	        if (deltas.bearing) {
	            const result = calculateEasing(deltas.bearing, duration, defaultBearingInertiaOptions);
	            easeOptions.bearing = this._map.transform.bearing + performance$1.clamp(result.amount, -179, 179);
	            extendDuration(easeOptions, result);
	        }
	        if (deltas.pitch) {
	            const result = calculateEasing(deltas.pitch, duration, defaultPitchInertiaOptions);
	            easeOptions.pitch = this._map.transform.pitch + result.amount;
	            extendDuration(easeOptions, result);
	        }
	        if (easeOptions.zoom || easeOptions.bearing) {
	            const last = deltas.pinchAround === undefined ? deltas.around : deltas.pinchAround;
	            easeOptions.around = last ? this._map.unproject(last) : this._map.getCenter();
	        }
	        this.clear();
	        return performance$1.extend(easeOptions, {
	            noMoveStart: true
	        });
	    }
	}
	// Unfortunately zoom, bearing, etc can't have different durations and easings so
	// we need to choose one. We use the longest duration and it's corresponding easing.
	function extendDuration(easeOptions, result) {
	    if (!easeOptions.duration || easeOptions.duration < result.duration) {
	        easeOptions.duration = result.duration;
	        easeOptions.easing = result.easing;
	    }
	}
	function calculateEasing(amount, inertiaDuration, inertiaOptions) {
	    const { maxSpeed, linearity, deceleration } = inertiaOptions;
	    const speed = performance$1.clamp(amount * linearity / (inertiaDuration / 1000), -maxSpeed, maxSpeed);
	    const duration = Math.abs(speed) / (deceleration * linearity);
	    return {
	        easing: inertiaOptions.easing,
	        duration: duration * 1000,
	        amount: speed * (duration / 2)
	    };
	}

	/**
	 * `MapMouseEvent` is the event type for mouse-related map events.
	 *
	 * @group Event Related
	 *
	 * @example
	 * ```ts
	 * // The `click` event is an example of a `MapMouseEvent`.
	 * // Set up an event listener on the map.
	 * map.on('click', function(e) {
	 *   // The event object (e) contains information like the
	 *   // coordinates of the point on the map that was clicked.
	 *   console.log('A click event has occurred at ' + e.lngLat);
	 * });
	 * ```
	 */
	class MapMouseEvent extends performance$1.Event {
	    /**
	     * Prevents subsequent default processing of the event by the map.
	     *
	     * Calling this method will prevent the following default map behaviors:
	     *
	     *   * On `mousedown` events, the behavior of {@link DragPanHandler}
	     *   * On `mousedown` events, the behavior of {@link DragRotateHandler}
	     *   * On `mousedown` events, the behavior of {@link BoxZoomHandler}
	     *   * On `dblclick` events, the behavior of {@link DoubleClickZoomHandler}
	     *
	     */
	    preventDefault() {
	        this._defaultPrevented = true;
	    }
	    /**
	     * `true` if `preventDefault` has been called.
	     */
	    get defaultPrevented() {
	        return this._defaultPrevented;
	    }
	    constructor(type, map, originalEvent, data = {}) {
	        const point = DOM.mousePos(map.getCanvas(), originalEvent);
	        const lngLat = map.unproject(point);
	        super(type, performance$1.extend({ point, lngLat, originalEvent }, data));
	        this._defaultPrevented = false;
	        this.target = map;
	    }
	}
	/**
	 * `MapTouchEvent` is the event type for touch-related map events.
	 *
	 * @group Event Related
	 */
	class MapTouchEvent extends performance$1.Event {
	    /**
	     * Prevents subsequent default processing of the event by the map.
	     *
	     * Calling this method will prevent the following default map behaviors:
	     *
	     *   * On `touchstart` events, the behavior of {@link DragPanHandler}
	     *   * On `touchstart` events, the behavior of {@link TwoFingersTouchZoomRotateHandler}
	     *
	     */
	    preventDefault() {
	        this._defaultPrevented = true;
	    }
	    /**
	     * `true` if `preventDefault` has been called.
	     */
	    get defaultPrevented() {
	        return this._defaultPrevented;
	    }
	    constructor(type, map, originalEvent) {
	        const touches = type === 'touchend' ? originalEvent.changedTouches : originalEvent.touches;
	        const points = DOM.touchPos(map.getCanvasContainer(), touches);
	        const lngLats = points.map((t) => map.unproject(t));
	        const point = points.reduce((prev, curr, i, arr) => {
	            return prev.add(curr.div(arr.length));
	        }, new performance$1.Point(0, 0));
	        const lngLat = map.unproject(point);
	        super(type, { points, point, lngLats, lngLat, originalEvent });
	        this._defaultPrevented = false;
	    }
	}
	/**
	 * `MapWheelEvent` is the event type for the `wheel` map event.
	 *
	 * @group Event Related
	 */
	class MapWheelEvent extends performance$1.Event {
	    /**
	     * Prevents subsequent default processing of the event by the map.
	     *
	     * Calling this method will prevent the behavior of {@link ScrollZoomHandler}.
	     */
	    preventDefault() {
	        this._defaultPrevented = true;
	    }
	    /**
	     * `true` if `preventDefault` has been called.
	     */
	    get defaultPrevented() {
	        return this._defaultPrevented;
	    }
	    /** */
	    constructor(type, map, originalEvent) {
	        super(type, { originalEvent });
	        this._defaultPrevented = false;
	    }
	}

	class MapEventHandler {
	    constructor(map, options) {
	        this._map = map;
	        this._clickTolerance = options.clickTolerance;
	    }
	    reset() {
	        delete this._mousedownPos;
	    }
	    wheel(e) {
	        // If mapEvent.preventDefault() is called by the user, prevent handlers such as:
	        // - ScrollZoom
	        return this._firePreventable(new MapWheelEvent(e.type, this._map, e));
	    }
	    mousedown(e, point) {
	        this._mousedownPos = point;
	        // If mapEvent.preventDefault() is called by the user, prevent handlers such as:
	        // - MousePan
	        // - MouseRotate
	        // - MousePitch
	        // - DblclickHandler
	        return this._firePreventable(new MapMouseEvent(e.type, this._map, e));
	    }
	    mouseup(e) {
	        this._map.fire(new MapMouseEvent(e.type, this._map, e));
	    }
	    click(e, point) {
	        if (this._mousedownPos && this._mousedownPos.dist(point) >= this._clickTolerance)
	            return;
	        this._map.fire(new MapMouseEvent(e.type, this._map, e));
	    }
	    dblclick(e) {
	        // If mapEvent.preventDefault() is called by the user, prevent handlers such as:
	        // - DblClickZoom
	        return this._firePreventable(new MapMouseEvent(e.type, this._map, e));
	    }
	    mouseover(e) {
	        this._map.fire(new MapMouseEvent(e.type, this._map, e));
	    }
	    mouseout(e) {
	        this._map.fire(new MapMouseEvent(e.type, this._map, e));
	    }
	    touchstart(e) {
	        // If mapEvent.preventDefault() is called by the user, prevent handlers such as:
	        // - TouchPan
	        // - TouchZoom
	        // - TouchRotate
	        // - TouchPitch
	        // - TapZoom
	        // - SwipeZoom
	        return this._firePreventable(new MapTouchEvent(e.type, this._map, e));
	    }
	    touchmove(e) {
	        this._map.fire(new MapTouchEvent(e.type, this._map, e));
	    }
	    touchend(e) {
	        this._map.fire(new MapTouchEvent(e.type, this._map, e));
	    }
	    touchcancel(e) {
	        this._map.fire(new MapTouchEvent(e.type, this._map, e));
	    }
	    _firePreventable(mapEvent) {
	        this._map.fire(mapEvent);
	        if (mapEvent.defaultPrevented) {
	            // returning an object marks the handler as active and resets other handlers
	            return {};
	        }
	    }
	    isEnabled() {
	        return true;
	    }
	    isActive() {
	        return false;
	    }
	    enable() { }
	    disable() { }
	}
	class BlockableMapEventHandler {
	    constructor(map) {
	        this._map = map;
	    }
	    reset() {
	        this._delayContextMenu = false;
	        this._ignoreContextMenu = true;
	        delete this._contextMenuEvent;
	    }
	    mousemove(e) {
	        // mousemove map events should not be fired when interaction handlers (pan, rotate, etc) are active
	        this._map.fire(new MapMouseEvent(e.type, this._map, e));
	    }
	    mousedown() {
	        this._delayContextMenu = true;
	        this._ignoreContextMenu = false;
	    }
	    mouseup() {
	        this._delayContextMenu = false;
	        if (this._contextMenuEvent) {
	            this._map.fire(new MapMouseEvent('contextmenu', this._map, this._contextMenuEvent));
	            delete this._contextMenuEvent;
	        }
	    }
	    contextmenu(e) {
	        if (this._delayContextMenu) {
	            // Mac: contextmenu fired on mousedown; we save it until mouseup for consistency's sake
	            this._contextMenuEvent = e;
	        }
	        else if (!this._ignoreContextMenu) {
	            // Windows: contextmenu fired on mouseup, so fire event now
	            this._map.fire(new MapMouseEvent(e.type, this._map, e));
	        }
	        // prevent browser context menu when necessary
	        if (this._map.listens('contextmenu')) {
	            e.preventDefault();
	        }
	    }
	    isEnabled() {
	        return true;
	    }
	    isActive() {
	        return false;
	    }
	    enable() { }
	    disable() { }
	}

	/**
	 * @internal
	 * Shared utilities for the Handler classes to access the correct camera state.
	 * If Camera.transformCameraUpdate is specified, the "desired state" of camera may differ from the state used for rendering.
	 * The handlers need the "desired state" to track accumulated changes.
	 */
	class TransformProvider {
	    constructor(map) {
	        this._map = map;
	    }
	    get transform() {
	        return this._map._requestedCameraState || this._map.transform;
	    }
	    get center() {
	        return { lng: this.transform.center.lng, lat: this.transform.center.lat };
	    }
	    get zoom() {
	        return this.transform.zoom;
	    }
	    get pitch() {
	        return this.transform.pitch;
	    }
	    get bearing() {
	        return this.transform.bearing;
	    }
	    unproject(point) {
	        return this.transform.pointLocation(performance$1.Point.convert(point), this._map.terrain);
	    }
	}

	/**
	 * The `BoxZoomHandler` allows the user to zoom the map to fit within a bounding box.
	 * The bounding box is defined by clicking and holding `shift` while dragging the cursor.
	 *
	 * @group Handlers
	 */
	class BoxZoomHandler {
	    /** @internal */
	    constructor(map, options) {
	        this._map = map;
	        this._tr = new TransformProvider(map);
	        this._el = map.getCanvasContainer();
	        this._container = map.getContainer();
	        this._clickTolerance = options.clickTolerance || 1;
	    }
	    /**
	     * Returns a Boolean indicating whether the "box zoom" interaction is enabled.
	     *
	     * @returns `true` if the "box zoom" interaction is enabled.
	     */
	    isEnabled() {
	        return !!this._enabled;
	    }
	    /**
	     * Returns a Boolean indicating whether the "box zoom" interaction is active, i.e. currently being used.
	     *
	     * @returns `true` if the "box zoom" interaction is active.
	     */
	    isActive() {
	        return !!this._active;
	    }
	    /**
	     * Enables the "box zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.boxZoom.enable();
	     * ```
	     */
	    enable() {
	        if (this.isEnabled())
	            return;
	        this._enabled = true;
	    }
	    /**
	     * Disables the "box zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.boxZoom.disable();
	     * ```
	     */
	    disable() {
	        if (!this.isEnabled())
	            return;
	        this._enabled = false;
	    }
	    mousedown(e, point) {
	        if (!this.isEnabled())
	            return;
	        if (!(e.shiftKey && e.button === 0))
	            return;
	        DOM.disableDrag();
	        this._startPos = this._lastPos = point;
	        this._active = true;
	    }
	    mousemoveWindow(e, point) {
	        if (!this._active)
	            return;
	        const pos = point;
	        if (this._lastPos.equals(pos) || (!this._box && pos.dist(this._startPos) < this._clickTolerance)) {
	            return;
	        }
	        const p0 = this._startPos;
	        this._lastPos = pos;
	        if (!this._box) {
	            this._box = DOM.create('div', 'maplibregl-boxzoom', this._container);
	            this._container.classList.add('maplibregl-crosshair');
	            this._fireEvent('boxzoomstart', e);
	        }
	        const minX = Math.min(p0.x, pos.x), maxX = Math.max(p0.x, pos.x), minY = Math.min(p0.y, pos.y), maxY = Math.max(p0.y, pos.y);
	        DOM.setTransform(this._box, `translate(${minX}px,${minY}px)`);
	        this._box.style.width = `${maxX - minX}px`;
	        this._box.style.height = `${maxY - minY}px`;
	    }
	    mouseupWindow(e, point) {
	        if (!this._active)
	            return;
	        if (e.button !== 0)
	            return;
	        const p0 = this._startPos, p1 = point;
	        this.reset();
	        DOM.suppressClick();
	        if (p0.x === p1.x && p0.y === p1.y) {
	            this._fireEvent('boxzoomcancel', e);
	        }
	        else {
	            this._map.fire(new performance$1.Event('boxzoomend', { originalEvent: e }));
	            return {
	                cameraAnimation: map => map.fitScreenCoordinates(p0, p1, this._tr.bearing, { linear: true })
	            };
	        }
	    }
	    keydown(e) {
	        if (!this._active)
	            return;
	        if (e.keyCode === 27) {
	            this.reset();
	            this._fireEvent('boxzoomcancel', e);
	        }
	    }
	    reset() {
	        this._active = false;
	        this._container.classList.remove('maplibregl-crosshair');
	        if (this._box) {
	            DOM.remove(this._box);
	            this._box = null;
	        }
	        DOM.enableDrag();
	        delete this._startPos;
	        delete this._lastPos;
	    }
	    _fireEvent(type, e) {
	        return this._map.fire(new performance$1.Event(type, { originalEvent: e }));
	    }
	}

	function indexTouches(touches, points) {
	    if (touches.length !== points.length)
	        throw new Error(`The number of touches and points are not equal - touches ${touches.length}, points ${points.length}`);
	    const obj = {};
	    for (let i = 0; i < touches.length; i++) {
	        obj[touches[i].identifier] = points[i];
	    }
	    return obj;
	}

	function getCentroid(points) {
	    const sum = new performance$1.Point(0, 0);
	    for (const point of points) {
	        sum._add(point);
	    }
	    return sum.div(points.length);
	}
	const MAX_TAP_INTERVAL = 500;
	const MAX_TOUCH_TIME = 500;
	const MAX_DIST = 30;
	class SingleTapRecognizer {
	    constructor(options) {
	        this.reset();
	        this.numTouches = options.numTouches;
	    }
	    reset() {
	        delete this.centroid;
	        delete this.startTime;
	        delete this.touches;
	        this.aborted = false;
	    }
	    touchstart(e, points, mapTouches) {
	        if (this.centroid || mapTouches.length > this.numTouches) {
	            this.aborted = true;
	        }
	        if (this.aborted) {
	            return;
	        }
	        if (this.startTime === undefined) {
	            this.startTime = e.timeStamp;
	        }
	        if (mapTouches.length === this.numTouches) {
	            this.centroid = getCentroid(points);
	            this.touches = indexTouches(mapTouches, points);
	        }
	    }
	    touchmove(e, points, mapTouches) {
	        if (this.aborted || !this.centroid)
	            return;
	        const newTouches = indexTouches(mapTouches, points);
	        for (const id in this.touches) {
	            const prevPos = this.touches[id];
	            const pos = newTouches[id];
	            if (!pos || pos.dist(prevPos) > MAX_DIST) {
	                this.aborted = true;
	            }
	        }
	    }
	    touchend(e, points, mapTouches) {
	        if (!this.centroid || e.timeStamp - this.startTime > MAX_TOUCH_TIME) {
	            this.aborted = true;
	        }
	        if (mapTouches.length === 0) {
	            const centroid = !this.aborted && this.centroid;
	            this.reset();
	            if (centroid)
	                return centroid;
	        }
	    }
	}
	class TapRecognizer {
	    constructor(options) {
	        this.singleTap = new SingleTapRecognizer(options);
	        this.numTaps = options.numTaps;
	        this.reset();
	    }
	    reset() {
	        this.lastTime = Infinity;
	        delete this.lastTap;
	        this.count = 0;
	        this.singleTap.reset();
	    }
	    touchstart(e, points, mapTouches) {
	        this.singleTap.touchstart(e, points, mapTouches);
	    }
	    touchmove(e, points, mapTouches) {
	        this.singleTap.touchmove(e, points, mapTouches);
	    }
	    touchend(e, points, mapTouches) {
	        const tap = this.singleTap.touchend(e, points, mapTouches);
	        if (tap) {
	            const soonEnough = e.timeStamp - this.lastTime < MAX_TAP_INTERVAL;
	            const closeEnough = !this.lastTap || this.lastTap.dist(tap) < MAX_DIST;
	            if (!soonEnough || !closeEnough) {
	                this.reset();
	            }
	            this.count++;
	            this.lastTime = e.timeStamp;
	            this.lastTap = tap;
	            if (this.count === this.numTaps) {
	                this.reset();
	                return tap;
	            }
	        }
	    }
	}

	/**
	 * A `TapZoomHandler` allows the user to zoom the map at a point by double tapping
	 */
	class TapZoomHandler {
	    constructor(map) {
	        this._tr = new TransformProvider(map);
	        this._zoomIn = new TapRecognizer({
	            numTouches: 1,
	            numTaps: 2
	        });
	        this._zoomOut = new TapRecognizer({
	            numTouches: 2,
	            numTaps: 1
	        });
	        this.reset();
	    }
	    reset() {
	        this._active = false;
	        this._zoomIn.reset();
	        this._zoomOut.reset();
	    }
	    touchstart(e, points, mapTouches) {
	        this._zoomIn.touchstart(e, points, mapTouches);
	        this._zoomOut.touchstart(e, points, mapTouches);
	    }
	    touchmove(e, points, mapTouches) {
	        this._zoomIn.touchmove(e, points, mapTouches);
	        this._zoomOut.touchmove(e, points, mapTouches);
	    }
	    touchend(e, points, mapTouches) {
	        const zoomInPoint = this._zoomIn.touchend(e, points, mapTouches);
	        const zoomOutPoint = this._zoomOut.touchend(e, points, mapTouches);
	        const tr = this._tr;
	        if (zoomInPoint) {
	            this._active = true;
	            e.preventDefault();
	            setTimeout(() => this.reset(), 0);
	            return {
	                cameraAnimation: (map) => map.easeTo({
	                    duration: 300,
	                    zoom: tr.zoom + 1,
	                    around: tr.unproject(zoomInPoint)
	                }, { originalEvent: e })
	            };
	        }
	        else if (zoomOutPoint) {
	            this._active = true;
	            e.preventDefault();
	            setTimeout(() => this.reset(), 0);
	            return {
	                cameraAnimation: (map) => map.easeTo({
	                    duration: 300,
	                    zoom: tr.zoom - 1,
	                    around: tr.unproject(zoomOutPoint)
	                }, { originalEvent: e })
	            };
	        }
	    }
	    touchcancel() {
	        this.reset();
	    }
	    enable() {
	        this._enabled = true;
	    }
	    disable() {
	        this._enabled = false;
	        this.reset();
	    }
	    isEnabled() {
	        return this._enabled;
	    }
	    isActive() {
	        return this._active;
	    }
	}

	/**
	 * A generic class to create handlers for drag events, from both mouse and touch events.
	 */
	class DragHandler {
	    constructor(options) {
	        this._enabled = !!options.enable;
	        this._moveStateManager = options.moveStateManager;
	        this._clickTolerance = options.clickTolerance || 1;
	        this._moveFunction = options.move;
	        this._activateOnStart = !!options.activateOnStart;
	        options.assignEvents(this);
	        this.reset();
	    }
	    reset(e) {
	        this._active = false;
	        this._moved = false;
	        delete this._lastPoint;
	        this._moveStateManager.endMove(e);
	    }
	    _move(...params) {
	        const move = this._moveFunction(...params);
	        if (move.bearingDelta || move.pitchDelta || move.around || move.panDelta) {
	            this._active = true;
	            return move;
	        }
	    }
	    dragStart(e, point) {
	        if (!this.isEnabled() || this._lastPoint)
	            return;
	        if (!this._moveStateManager.isValidStartEvent(e))
	            return;
	        this._moveStateManager.startMove(e);
	        this._lastPoint = point['length'] ? point[0] : point;
	        if (this._activateOnStart && this._lastPoint)
	            this._active = true;
	    }
	    dragMove(e, point) {
	        if (!this.isEnabled())
	            return;
	        const lastPoint = this._lastPoint;
	        if (!lastPoint)
	            return;
	        e.preventDefault();
	        if (!this._moveStateManager.isValidMoveEvent(e)) {
	            this.reset(e);
	            return;
	        }
	        const movePoint = point['length'] ? point[0] : point;
	        if (!this._moved && movePoint.dist(lastPoint) < this._clickTolerance)
	            return;
	        this._moved = true;
	        this._lastPoint = movePoint;
	        return this._move(lastPoint, movePoint);
	    }
	    dragEnd(e) {
	        if (!this.isEnabled() || !this._lastPoint)
	            return;
	        if (!this._moveStateManager.isValidEndEvent(e))
	            return;
	        if (this._moved)
	            DOM.suppressClick();
	        this.reset(e);
	    }
	    enable() {
	        this._enabled = true;
	    }
	    disable() {
	        this._enabled = false;
	        this.reset();
	    }
	    isEnabled() {
	        return this._enabled;
	    }
	    isActive() {
	        return this._active;
	    }
	    getClickTolerance() {
	        return this._clickTolerance;
	    }
	}

	const LEFT_BUTTON$1 = 0;
	const RIGHT_BUTTON$1 = 2;
	// the values for each button in MouseEvent.buttons
	const BUTTONS_FLAGS = {
	    [LEFT_BUTTON$1]: 1,
	    [RIGHT_BUTTON$1]: 2
	};
	function buttonNoLongerPressed(e, button) {
	    const flag = BUTTONS_FLAGS[button];
	    return e.buttons === undefined || (e.buttons & flag) !== flag;
	}
	class MouseMoveStateManager {
	    constructor(options) {
	        this._correctEvent = options.checkCorrectEvent;
	    }
	    startMove(e) {
	        const eventButton = DOM.mouseButton(e);
	        this._eventButton = eventButton;
	    }
	    endMove(_e) {
	        delete this._eventButton;
	    }
	    isValidStartEvent(e) {
	        return this._correctEvent(e);
	    }
	    isValidMoveEvent(e) {
	        // Some browsers don't fire a `mouseup` when the mouseup occurs outside
	        // the window or iframe:
	        // https://github.com/mapbox/mapbox-gl-js/issues/4622
	        //
	        // If the button is no longer pressed during this `mousemove` it may have
	        // been released outside of the window or iframe.
	        return !buttonNoLongerPressed(e, this._eventButton);
	    }
	    isValidEndEvent(e) {
	        const eventButton = DOM.mouseButton(e);
	        return eventButton === this._eventButton;
	    }
	}
	class OneFingerTouchMoveStateManager {
	    constructor() {
	        this._firstTouch = undefined;
	    }
	    _isOneFingerTouch(e) {
	        return e.targetTouches.length === 1;
	    }
	    _isSameTouchEvent(e) {
	        return e.targetTouches[0].identifier === this._firstTouch;
	    }
	    startMove(e) {
	        const firstTouch = e.targetTouches[0].identifier;
	        this._firstTouch = firstTouch;
	    }
	    endMove(_e) {
	        delete this._firstTouch;
	    }
	    isValidStartEvent(e) {
	        return this._isOneFingerTouch(e);
	    }
	    isValidMoveEvent(e) {
	        return this._isOneFingerTouch(e) && this._isSameTouchEvent(e);
	    }
	    isValidEndEvent(e) {
	        return this._isOneFingerTouch(e) && this._isSameTouchEvent(e);
	    }
	}

	const LEFT_BUTTON = 0;
	const RIGHT_BUTTON = 2;
	const assignEvents$1 = (handler) => {
	    handler.mousedown = handler.dragStart;
	    handler.mousemoveWindow = handler.dragMove;
	    handler.mouseup = handler.dragEnd;
	    handler.contextmenu = function (e) {
	        e.preventDefault();
	    };
	};
	const generateMousePanHandler = ({ enable, clickTolerance, }) => {
	    const mouseMoveStateManager = new MouseMoveStateManager({
	        checkCorrectEvent: (e) => DOM.mouseButton(e) === LEFT_BUTTON && !e.ctrlKey,
	    });
	    return new DragHandler({
	        clickTolerance,
	        move: (lastPoint, point) => ({ around: point, panDelta: point.sub(lastPoint) }),
	        activateOnStart: true,
	        moveStateManager: mouseMoveStateManager,
	        enable,
	        assignEvents: assignEvents$1,
	    });
	};
	const generateMouseRotationHandler = ({ enable, clickTolerance, bearingDegreesPerPixelMoved = 0.8 }) => {
	    const mouseMoveStateManager = new MouseMoveStateManager({
	        checkCorrectEvent: (e) => (DOM.mouseButton(e) === LEFT_BUTTON && e.ctrlKey) ||
	            (DOM.mouseButton(e) === RIGHT_BUTTON),
	    });
	    return new DragHandler({
	        clickTolerance,
	        move: (lastPoint, point) => ({ bearingDelta: (point.x - lastPoint.x) * bearingDegreesPerPixelMoved }),
	        // prevent browser context menu when necessary; we don't allow it with rotation
	        // because we can't discern rotation gesture start from contextmenu on Mac
	        moveStateManager: mouseMoveStateManager,
	        enable,
	        assignEvents: assignEvents$1,
	    });
	};
	const generateMousePitchHandler = ({ enable, clickTolerance, pitchDegreesPerPixelMoved = -0.5 }) => {
	    const mouseMoveStateManager = new MouseMoveStateManager({
	        checkCorrectEvent: (e) => (DOM.mouseButton(e) === LEFT_BUTTON && e.ctrlKey) ||
	            (DOM.mouseButton(e) === RIGHT_BUTTON),
	    });
	    return new DragHandler({
	        clickTolerance,
	        move: (lastPoint, point) => ({ pitchDelta: (point.y - lastPoint.y) * pitchDegreesPerPixelMoved }),
	        // prevent browser context menu when necessary; we don't allow it with rotation
	        // because we can't discern rotation gesture start from contextmenu on Mac
	        moveStateManager: mouseMoveStateManager,
	        enable,
	        assignEvents: assignEvents$1,
	    });
	};

	/**
	 * A `TouchPanHandler` allows the user to pan the map using touch gestures.
	 */
	class TouchPanHandler {
	    constructor(options, map) {
	        this._clickTolerance = options.clickTolerance || 1;
	        this._map = map;
	        this.reset();
	    }
	    reset() {
	        this._active = false;
	        this._touches = {};
	        this._sum = new performance$1.Point(0, 0);
	    }
	    minTouchs() {
	        return this._map.cooperativeGestures.isEnabled() ? 2 : 1;
	    }
	    touchstart(e, points, mapTouches) {
	        return this._calculateTransform(e, points, mapTouches);
	    }
	    touchmove(e, points, mapTouches) {
	        if (!this._active || mapTouches.length < this.minTouchs())
	            return;
	        e.preventDefault();
	        return this._calculateTransform(e, points, mapTouches);
	    }
	    touchend(e, points, mapTouches) {
	        this._calculateTransform(e, points, mapTouches);
	        if (this._active && mapTouches.length < this.minTouchs()) {
	            this.reset();
	        }
	    }
	    touchcancel() {
	        this.reset();
	    }
	    _calculateTransform(e, points, mapTouches) {
	        if (mapTouches.length > 0)
	            this._active = true;
	        const touches = indexTouches(mapTouches, points);
	        const touchPointSum = new performance$1.Point(0, 0);
	        const touchDeltaSum = new performance$1.Point(0, 0);
	        let touchDeltaCount = 0;
	        for (const identifier in touches) {
	            const point = touches[identifier];
	            const prevPoint = this._touches[identifier];
	            if (prevPoint) {
	                touchPointSum._add(point);
	                touchDeltaSum._add(point.sub(prevPoint));
	                touchDeltaCount++;
	                touches[identifier] = point;
	            }
	        }
	        this._touches = touches;
	        if (touchDeltaCount < this.minTouchs() || !touchDeltaSum.mag())
	            return;
	        const panDelta = touchDeltaSum.div(touchDeltaCount);
	        this._sum._add(panDelta);
	        if (this._sum.mag() < this._clickTolerance)
	            return;
	        const around = touchPointSum.div(touchDeltaCount);
	        return {
	            around,
	            panDelta
	        };
	    }
	    enable() {
	        this._enabled = true;
	    }
	    disable() {
	        this._enabled = false;
	        this.reset();
	    }
	    isEnabled() {
	        return this._enabled;
	    }
	    isActive() {
	        return this._active;
	    }
	}

	/**
	 * The `TwoFingersTouchHandler`s allows the user to zoom, pitch and rotate the map using two fingers
	 *
	 */
	class TwoFingersTouchHandler {
	    /** @internal */
	    constructor() {
	        this.reset();
	    }
	    reset() {
	        this._active = false;
	        delete this._firstTwoTouches;
	    }
	    touchstart(e, points, mapTouches) {
	        //log('touchstart', points, e.target.innerHTML, e.targetTouches.length ? e.targetTouches[0].target.innerHTML: undefined);
	        if (this._firstTwoTouches || mapTouches.length < 2)
	            return;
	        this._firstTwoTouches = [
	            mapTouches[0].identifier,
	            mapTouches[1].identifier
	        ];
	        // implemented by child classes
	        this._start([points[0], points[1]]);
	    }
	    touchmove(e, points, mapTouches) {
	        if (!this._firstTwoTouches)
	            return;
	        e.preventDefault();
	        const [idA, idB] = this._firstTwoTouches;
	        const a = getTouchById(mapTouches, points, idA);
	        const b = getTouchById(mapTouches, points, idB);
	        if (!a || !b)
	            return;
	        const pinchAround = this._aroundCenter ? null : a.add(b).div(2);
	        // implemented by child classes
	        return this._move([a, b], pinchAround, e);
	    }
	    touchend(e, points, mapTouches) {
	        if (!this._firstTwoTouches)
	            return;
	        const [idA, idB] = this._firstTwoTouches;
	        const a = getTouchById(mapTouches, points, idA);
	        const b = getTouchById(mapTouches, points, idB);
	        if (a && b)
	            return;
	        if (this._active)
	            DOM.suppressClick();
	        this.reset();
	    }
	    touchcancel() {
	        this.reset();
	    }
	    /**
	     * Enables the "drag to pitch" interaction.
	     *
	     * @example
	     * ```ts
	     * map.touchPitch.enable();
	     * ```
	     */
	    enable(options) {
	        this._enabled = true;
	        this._aroundCenter = !!options && options.around === 'center';
	    }
	    /**
	     * Disables the "drag to pitch" interaction.
	     *
	     * @example
	     * ```ts
	     * map.touchPitch.disable();
	     * ```
	     */
	    disable() {
	        this._enabled = false;
	        this.reset();
	    }
	    /**
	     * Returns a Boolean indicating whether the "drag to pitch" interaction is enabled.
	     *
	     * @returns  `true` if the "drag to pitch" interaction is enabled.
	     */
	    isEnabled() {
	        return !!this._enabled;
	    }
	    /**
	     * Returns a Boolean indicating whether the "drag to pitch" interaction is active, i.e. currently being used.
	     *
	     * @returns `true` if the "drag to pitch" interaction is active.
	     */
	    isActive() {
	        return !!this._active;
	    }
	}
	function getTouchById(mapTouches, points, identifier) {
	    for (let i = 0; i < mapTouches.length; i++) {
	        if (mapTouches[i].identifier === identifier)
	            return points[i];
	    }
	    return undefined;
	}
	/* ZOOM */
	const ZOOM_THRESHOLD = 0.1;
	function getZoomDelta(distance, lastDistance) {
	    return Math.log(distance / lastDistance) / Math.LN2;
	}
	/**
	 * The `TwoFingersTouchHandler`s allows the user to zoom the map two fingers
	 *
	 * @group Handlers
	 */
	class TwoFingersTouchZoomHandler extends TwoFingersTouchHandler {
	    reset() {
	        super.reset();
	        delete this._distance;
	        delete this._startDistance;
	    }
	    _start(points) {
	        this._startDistance = this._distance = points[0].dist(points[1]);
	    }
	    _move(points, pinchAround) {
	        const lastDistance = this._distance;
	        this._distance = points[0].dist(points[1]);
	        if (!this._active && Math.abs(getZoomDelta(this._distance, this._startDistance)) < ZOOM_THRESHOLD)
	            return;
	        this._active = true;
	        return {
	            zoomDelta: getZoomDelta(this._distance, lastDistance),
	            pinchAround
	        };
	    }
	}
	/* ROTATE */
	const ROTATION_THRESHOLD = 25; // pixels along circumference of touch circle
	function getBearingDelta(a, b) {
	    return a.angleWith(b) * 180 / Math.PI;
	}
	/**
	 * The `TwoFingersTouchHandler`s allows the user to rotate the map two fingers
	 *
	 * @group Handlers
	 */
	class TwoFingersTouchRotateHandler extends TwoFingersTouchHandler {
	    reset() {
	        super.reset();
	        delete this._minDiameter;
	        delete this._startVector;
	        delete this._vector;
	    }
	    _start(points) {
	        this._startVector = this._vector = points[0].sub(points[1]);
	        this._minDiameter = points[0].dist(points[1]);
	    }
	    _move(points, pinchAround, _e) {
	        const lastVector = this._vector;
	        this._vector = points[0].sub(points[1]);
	        if (!this._active && this._isBelowThreshold(this._vector))
	            return;
	        this._active = true;
	        return {
	            bearingDelta: getBearingDelta(this._vector, lastVector),
	            pinchAround
	        };
	    }
	    _isBelowThreshold(vector) {
	        /*
	         * The threshold before a rotation actually happens is configured in
	         * pixels along the circumference of the circle formed by the two fingers.
	         * This makes the threshold in degrees larger when the fingers are close
	         * together and smaller when the fingers are far apart.
	         *
	         * Use the smallest diameter from the whole gesture to reduce sensitivity
	         * when pinching in and out.
	         */
	        this._minDiameter = Math.min(this._minDiameter, vector.mag());
	        const circumference = Math.PI * this._minDiameter;
	        const threshold = ROTATION_THRESHOLD / circumference * 360;
	        const bearingDeltaSinceStart = getBearingDelta(vector, this._startVector);
	        return Math.abs(bearingDeltaSinceStart) < threshold;
	    }
	}
	/* PITCH */
	function isVertical(vector) {
	    return Math.abs(vector.y) > Math.abs(vector.x);
	}
	const ALLOWED_SINGLE_TOUCH_TIME = 100;
	/**
	 * The `TwoFingersTouchPitchHandler` allows the user to pitch the map by dragging up and down with two fingers.
	 *
	 * @group Handlers
	 */
	class TwoFingersTouchPitchHandler extends TwoFingersTouchHandler {
	    constructor(map) {
	        super();
	        this._currentTouchCount = 0;
	        this._map = map;
	    }
	    reset() {
	        super.reset();
	        this._valid = undefined;
	        delete this._firstMove;
	        delete this._lastPoints;
	    }
	    touchstart(e, points, mapTouches) {
	        super.touchstart(e, points, mapTouches);
	        this._currentTouchCount = mapTouches.length;
	    }
	    _start(points) {
	        this._lastPoints = points;
	        if (isVertical(points[0].sub(points[1]))) {
	            // fingers are more horizontal than vertical
	            this._valid = false;
	        }
	    }
	    _move(points, center, e) {
	        // If cooperative gestures is enabled, we need a 3-finger minimum for this gesture to register
	        if (this._map.cooperativeGestures.isEnabled() && this._currentTouchCount < 3) {
	            return;
	        }
	        const vectorA = points[0].sub(this._lastPoints[0]);
	        const vectorB = points[1].sub(this._lastPoints[1]);
	        this._valid = this.gestureBeginsVertically(vectorA, vectorB, e.timeStamp);
	        if (!this._valid)
	            return;
	        this._lastPoints = points;
	        this._active = true;
	        const yDeltaAverage = (vectorA.y + vectorB.y) / 2;
	        const degreesPerPixelMoved = -0.5;
	        return {
	            pitchDelta: yDeltaAverage * degreesPerPixelMoved
	        };
	    }
	    gestureBeginsVertically(vectorA, vectorB, timeStamp) {
	        if (this._valid !== undefined)
	            return this._valid;
	        const threshold = 2;
	        const movedA = vectorA.mag() >= threshold;
	        const movedB = vectorB.mag() >= threshold;
	        // neither finger has moved a meaningful amount, wait
	        if (!movedA && !movedB)
	            return;
	        // One finger has moved and the other has not.
	        // If enough time has passed, decide it is not a pitch.
	        if (!movedA || !movedB) {
	            if (this._firstMove === undefined) {
	                this._firstMove = timeStamp;
	            }
	            if (timeStamp - this._firstMove < ALLOWED_SINGLE_TOUCH_TIME) {
	                // still waiting for a movement from the second finger
	                return undefined;
	            }
	            else {
	                return false;
	            }
	        }
	        const isSameDirection = vectorA.y > 0 === vectorB.y > 0;
	        return isVertical(vectorA) && isVertical(vectorB) && isSameDirection;
	    }
	}

	const defaultOptions$5 = {
	    panStep: 100,
	    bearingStep: 15,
	    pitchStep: 10
	};
	/**
	 * The `KeyboardHandler` allows the user to zoom, rotate, and pan the map using
	 * the following keyboard shortcuts:
	 *
	 * - `=` / `+`: Increase the zoom level by 1.
	 * - `Shift-=` / `Shift-+`: Increase the zoom level by 2.
	 * - `-`: Decrease the zoom level by 1.
	 * - `Shift--`: Decrease the zoom level by 2.
	 * - Arrow keys: Pan by 100 pixels.
	 * - `Shift+⇢`: Increase the rotation by 15 degrees.
	 * - `Shift+⇠`: Decrease the rotation by 15 degrees.
	 * - `Shift+⇡`: Increase the pitch by 10 degrees.
	 * - `Shift+⇣`: Decrease the pitch by 10 degrees.
	 *
	 * @group Handlers
	 */
	class KeyboardHandler {
	    /** @internal */
	    constructor(map) {
	        this._tr = new TransformProvider(map);
	        const stepOptions = defaultOptions$5;
	        this._panStep = stepOptions.panStep;
	        this._bearingStep = stepOptions.bearingStep;
	        this._pitchStep = stepOptions.pitchStep;
	        this._rotationDisabled = false;
	    }
	    reset() {
	        this._active = false;
	    }
	    keydown(e) {
	        if (e.altKey || e.ctrlKey || e.metaKey)
	            return;
	        let zoomDir = 0;
	        let bearingDir = 0;
	        let pitchDir = 0;
	        let xDir = 0;
	        let yDir = 0;
	        switch (e.keyCode) {
	            case 61:
	            case 107:
	            case 171:
	            case 187:
	                zoomDir = 1;
	                break;
	            case 189:
	            case 109:
	            case 173:
	                zoomDir = -1;
	                break;
	            case 37:
	                if (e.shiftKey) {
	                    bearingDir = -1;
	                }
	                else {
	                    e.preventDefault();
	                    xDir = -1;
	                }
	                break;
	            case 39:
	                if (e.shiftKey) {
	                    bearingDir = 1;
	                }
	                else {
	                    e.preventDefault();
	                    xDir = 1;
	                }
	                break;
	            case 38:
	                if (e.shiftKey) {
	                    pitchDir = 1;
	                }
	                else {
	                    e.preventDefault();
	                    yDir = -1;
	                }
	                break;
	            case 40:
	                if (e.shiftKey) {
	                    pitchDir = -1;
	                }
	                else {
	                    e.preventDefault();
	                    yDir = 1;
	                }
	                break;
	            default:
	                return;
	        }
	        if (this._rotationDisabled) {
	            bearingDir = 0;
	            pitchDir = 0;
	        }
	        return {
	            cameraAnimation: (map) => {
	                const tr = this._tr;
	                map.easeTo({
	                    duration: 300,
	                    easeId: 'keyboardHandler',
	                    easing: easeOut,
	                    zoom: zoomDir ? Math.round(tr.zoom) + zoomDir * (e.shiftKey ? 2 : 1) : tr.zoom,
	                    bearing: tr.bearing + bearingDir * this._bearingStep,
	                    pitch: tr.pitch + pitchDir * this._pitchStep,
	                    offset: [-xDir * this._panStep, -yDir * this._panStep],
	                    center: tr.center
	                }, { originalEvent: e });
	            }
	        };
	    }
	    /**
	     * Enables the "keyboard rotate and zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.keyboard.enable();
	     * ```
	     */
	    enable() {
	        this._enabled = true;
	    }
	    /**
	     * Disables the "keyboard rotate and zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.keyboard.disable();
	     * ```
	     */
	    disable() {
	        this._enabled = false;
	        this.reset();
	    }
	    /**
	     * Returns a Boolean indicating whether the "keyboard rotate and zoom"
	     * interaction is enabled.
	     *
	     * @returns `true` if the "keyboard rotate and zoom"
	     * interaction is enabled.
	     */
	    isEnabled() {
	        return this._enabled;
	    }
	    /**
	     * Returns true if the handler is enabled and has detected the start of a
	     * zoom/rotate gesture.
	     *
	     * @returns `true` if the handler is enabled and has detected the
	     * start of a zoom/rotate gesture.
	     */
	    isActive() {
	        return this._active;
	    }
	    /**
	     * Disables the "keyboard pan/rotate" interaction, leaving the
	     * "keyboard zoom" interaction enabled.
	     *
	     * @example
	     * ```ts
	     * map.keyboard.disableRotation();
	     * ```
	     */
	    disableRotation() {
	        this._rotationDisabled = true;
	    }
	    /**
	     * Enables the "keyboard pan/rotate" interaction.
	     *
	     * @example
	     * ```ts
	     * map.keyboard.enable();
	     * map.keyboard.enableRotation();
	     * ```
	     */
	    enableRotation() {
	        this._rotationDisabled = false;
	    }
	}
	function easeOut(t) {
	    return t * (2 - t);
	}

	// deltaY value for mouse scroll wheel identification
	const wheelZoomDelta = 4.000244140625;
	// These magic numbers control the rate of zoom. Trackpad events fire at a greater
	// frequency than mouse scroll wheel, so reduce the zoom rate per wheel tick
	const defaultZoomRate = 1 / 100;
	const wheelZoomRate = 1 / 450;
	// upper bound on how much we scale the map in any single render frame; this
	// is used to limit zoom rate in the case of very fast scrolling
	const maxScalePerFrame = 2;
	/**
	 * The `ScrollZoomHandler` allows the user to zoom the map by scrolling.
	 *
	 * @group Handlers
	 */
	class ScrollZoomHandler {
	    /** @internal */
	    constructor(map, triggerRenderFrame) {
	        this._onTimeout = (initialEvent) => {
	            this._type = 'wheel';
	            this._delta -= this._lastValue;
	            if (!this._active) {
	                this._start(initialEvent);
	            }
	        };
	        this._map = map;
	        this._tr = new TransformProvider(map);
	        this._triggerRenderFrame = triggerRenderFrame;
	        this._delta = 0;
	        this._defaultZoomRate = defaultZoomRate;
	        this._wheelZoomRate = wheelZoomRate;
	    }
	    /**
	     * Set the zoom rate of a trackpad
	     * @param zoomRate - 1/100 The rate used to scale trackpad movement to a zoom value.
	     * @example
	     * Speed up trackpad zoom
	     * ```ts
	     * map.scrollZoom.setZoomRate(1/25);
	     * ```
	     */
	    setZoomRate(zoomRate) {
	        this._defaultZoomRate = zoomRate;
	    }
	    /**
	     * Set the zoom rate of a mouse wheel
	     * @param wheelZoomRate - 1/450 The rate used to scale mouse wheel movement to a zoom value.
	     * @example
	     * Slow down zoom of mouse wheel
	     * ```ts
	     * map.scrollZoom.setWheelZoomRate(1/600);
	     * ```
	     */
	    setWheelZoomRate(wheelZoomRate) {
	        this._wheelZoomRate = wheelZoomRate;
	    }
	    /**
	     * Returns a Boolean indicating whether the "scroll to zoom" interaction is enabled.
	     * @returns `true` if the "scroll to zoom" interaction is enabled.
	     */
	    isEnabled() {
	        return !!this._enabled;
	    }
	    /*
	    * Active state is turned on and off with every scroll wheel event and is set back to false before the map
	    * render is called, so _active is not a good candidate for determining if a scroll zoom animation is in
	    * progress.
	    */
	    isActive() {
	        return !!this._active || this._finishTimeout !== undefined;
	    }
	    isZooming() {
	        return !!this._zooming;
	    }
	    /**
	     * Enables the "scroll to zoom" interaction.
	     *
	     * @param options - Options object.
	     * @example
	     * ```ts
	     * map.scrollZoom.enable();
	     * map.scrollZoom.enable({ around: 'center' })
	     * ```
	     */
	    enable(options) {
	        if (this.isEnabled())
	            return;
	        this._enabled = true;
	        this._aroundCenter = !!options && options.around === 'center';
	    }
	    /**
	     * Disables the "scroll to zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.scrollZoom.disable();
	     * ```
	     */
	    disable() {
	        if (!this.isEnabled())
	            return;
	        this._enabled = false;
	    }
	    wheel(e) {
	        if (!this.isEnabled())
	            return;
	        if (this._map.cooperativeGestures.isEnabled() && !e[this._map.cooperativeGestures._bypassKey]) {
	            return;
	        }
	        let value = e.deltaMode === WheelEvent.DOM_DELTA_LINE ? e.deltaY * 40 : e.deltaY;
	        const now = browser.now(), timeDelta = now - (this._lastWheelEventTime || 0);
	        this._lastWheelEventTime = now;
	        if (value !== 0 && (value % wheelZoomDelta) === 0) {
	            // This one is definitely a mouse wheel event.
	            this._type = 'wheel';
	        }
	        else if (value !== 0 && Math.abs(value) < 4) {
	            // This one is definitely a trackpad event because it is so small.
	            this._type = 'trackpad';
	        }
	        else if (timeDelta > 400) {
	            // This is likely a new scroll action.
	            this._type = null;
	            this._lastValue = value;
	            // Start a timeout in case this was a singular event, and dely it by up to 40ms.
	            this._timeout = setTimeout(this._onTimeout, 40, e);
	        }
	        else if (!this._type) {
	            // This is a repeating event, but we don't know the type of event just yet.
	            // If the delta per time is small, we assume it's a fast trackpad; otherwise we switch into wheel mode.
	            this._type = (Math.abs(timeDelta * value) < 200) ? 'trackpad' : 'wheel';
	            // Make sure our delayed event isn't fired again, because we accumulate
	            // the previous event (which was less than 40ms ago) into this event.
	            if (this._timeout) {
	                clearTimeout(this._timeout);
	                this._timeout = null;
	                value += this._lastValue;
	            }
	        }
	        // Slow down zoom if shift key is held for more precise zooming
	        if (e.shiftKey && value)
	            value = value / 4;
	        // Only fire the callback if we actually know what type of scrolling device the user uses.
	        if (this._type) {
	            this._lastWheelEvent = e;
	            this._delta -= value;
	            if (!this._active) {
	                this._start(e);
	            }
	        }
	        e.preventDefault();
	    }
	    _start(e) {
	        if (!this._delta)
	            return;
	        if (this._frameId) {
	            this._frameId = null;
	        }
	        this._active = true;
	        if (!this.isZooming()) {
	            this._zooming = true;
	        }
	        if (this._finishTimeout) {
	            clearTimeout(this._finishTimeout);
	            delete this._finishTimeout;
	        }
	        const pos = DOM.mousePos(this._map.getCanvas(), e);
	        const tr = this._tr;
	        if (pos.y > tr.transform.height / 2 - tr.transform.getHorizon()) {
	            this._around = performance$1.LngLat.convert(this._aroundCenter ? tr.center : tr.unproject(pos));
	        }
	        else {
	            // Do not use current cursor position if above the horizon to avoid 'unproject' this point
	            // as it is not mapped into 'coords' framebuffer or inversible with 'pixelMatrixInverse'.
	            this._around = performance$1.LngLat.convert(tr.center);
	        }
	        this._aroundPoint = tr.transform.locationPoint(this._around);
	        if (!this._frameId) {
	            this._frameId = true;
	            this._triggerRenderFrame();
	        }
	    }
	    renderFrame() {
	        if (!this._frameId)
	            return;
	        this._frameId = null;
	        if (!this.isActive())
	            return;
	        const tr = this._tr.transform;
	        // if we've had scroll events since the last render frame, consume the
	        // accumulated delta, and update the target zoom level accordingly
	        if (this._delta !== 0) {
	            // For trackpad events and single mouse wheel ticks, use the default zoom rate
	            const zoomRate = (this._type === 'wheel' && Math.abs(this._delta) > wheelZoomDelta) ? this._wheelZoomRate : this._defaultZoomRate;
	            // Scale by sigmoid of scroll wheel delta.
	            let scale = maxScalePerFrame / (1 + Math.exp(-Math.abs(this._delta * zoomRate)));
	            if (this._delta < 0 && scale !== 0) {
	                scale = 1 / scale;
	            }
	            const fromScale = typeof this._targetZoom === 'number' ? tr.zoomScale(this._targetZoom) : tr.scale;
	            this._targetZoom = Math.min(tr.maxZoom, Math.max(tr.minZoom, tr.scaleZoom(fromScale * scale)));
	            // if this is a mouse wheel, refresh the starting zoom and easing
	            // function we're using to smooth out the zooming between wheel
	            // events
	            if (this._type === 'wheel') {
	                this._startZoom = tr.zoom;
	                this._easing = this._smoothOutEasing(200);
	            }
	            this._delta = 0;
	        }
	        const targetZoom = typeof this._targetZoom === 'number' ?
	            this._targetZoom : tr.zoom;
	        const startZoom = this._startZoom;
	        const easing = this._easing;
	        let finished = false;
	        let zoom;
	        if (this._type === 'wheel' && startZoom && easing) {
	            const t = Math.min((browser.now() - this._lastWheelEventTime) / 200, 1);
	            const k = easing(t);
	            zoom = performance$1.interpolate.number(startZoom, targetZoom, k);
	            if (t < 1) {
	                if (!this._frameId) {
	                    this._frameId = true;
	                }
	            }
	            else {
	                finished = true;
	            }
	        }
	        else {
	            zoom = targetZoom;
	            finished = true;
	        }
	        this._active = true;
	        if (finished) {
	            this._active = false;
	            this._finishTimeout = setTimeout(() => {
	                this._zooming = false;
	                this._triggerRenderFrame();
	                delete this._targetZoom;
	                delete this._finishTimeout;
	            }, 200);
	        }
	        return {
	            noInertia: true,
	            needsRenderFrame: !finished,
	            zoomDelta: zoom - tr.zoom,
	            around: this._aroundPoint,
	            originalEvent: this._lastWheelEvent
	        };
	    }
	    _smoothOutEasing(duration) {
	        let easing = performance$1.defaultEasing;
	        if (this._prevEase) {
	            const currentEase = this._prevEase;
	            const t = (browser.now() - currentEase.start) / currentEase.duration;
	            const speed = currentEase.easing(t + 0.01) - currentEase.easing(t);
	            // Quick hack to make new bezier that is continuous with last
	            const x = 0.27 / Math.sqrt(speed * speed + 0.0001) * 0.01;
	            const y = Math.sqrt(0.27 * 0.27 - x * x);
	            easing = performance$1.bezier(x, y, 0.25, 1);
	        }
	        this._prevEase = {
	            start: browser.now(),
	            duration,
	            easing
	        };
	        return easing;
	    }
	    reset() {
	        this._active = false;
	        this._zooming = false;
	        delete this._targetZoom;
	        if (this._finishTimeout) {
	            clearTimeout(this._finishTimeout);
	            delete this._finishTimeout;
	        }
	    }
	}

	/**
	 * The `DoubleClickZoomHandler` allows the user to zoom the map at a point by
	 * double clicking or double tapping.
	 *
	 * @group Handlers
	 */
	class DoubleClickZoomHandler {
	    /** @internal */
	    constructor(clickZoom, TapZoom) {
	        this._clickZoom = clickZoom;
	        this._tapZoom = TapZoom;
	    }
	    /**
	     * Enables the "double click to zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.doubleClickZoom.enable();
	     * ```
	     */
	    enable() {
	        this._clickZoom.enable();
	        this._tapZoom.enable();
	    }
	    /**
	     * Disables the "double click to zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.doubleClickZoom.disable();
	     * ```
	     */
	    disable() {
	        this._clickZoom.disable();
	        this._tapZoom.disable();
	    }
	    /**
	     * Returns a Boolean indicating whether the "double click to zoom" interaction is enabled.
	     *
	     * @returns `true` if the "double click to zoom" interaction is enabled.
	     */
	    isEnabled() {
	        return this._clickZoom.isEnabled() && this._tapZoom.isEnabled();
	    }
	    /**
	     * Returns a Boolean indicating whether the "double click to zoom" interaction is active, i.e. currently being used.
	     *
	     * @returns `true` if the "double click to zoom" interaction is active.
	     */
	    isActive() {
	        return this._clickZoom.isActive() || this._tapZoom.isActive();
	    }
	}

	/**
	 * The `ClickZoomHandler` allows the user to zoom the map at a point by double clicking
	 * It is used by other handlers
	 */
	class ClickZoomHandler {
	    /** @internal */
	    constructor(map) {
	        this._tr = new TransformProvider(map);
	        this.reset();
	    }
	    reset() {
	        this._active = false;
	    }
	    dblclick(e, point) {
	        e.preventDefault();
	        return {
	            cameraAnimation: (map) => {
	                map.easeTo({
	                    duration: 300,
	                    zoom: this._tr.zoom + (e.shiftKey ? -1 : 1),
	                    around: this._tr.unproject(point)
	                }, { originalEvent: e });
	            }
	        };
	    }
	    enable() {
	        this._enabled = true;
	    }
	    disable() {
	        this._enabled = false;
	        this.reset();
	    }
	    isEnabled() {
	        return this._enabled;
	    }
	    isActive() {
	        return this._active;
	    }
	}

	/**
	 * A `TapDragZoomHandler` allows the user to zoom the map at a point by double tapping. It also allows the user pan the map by dragging.
	 */
	class TapDragZoomHandler {
	    constructor() {
	        this._tap = new TapRecognizer({
	            numTouches: 1,
	            numTaps: 1
	        });
	        this.reset();
	    }
	    reset() {
	        this._active = false;
	        delete this._swipePoint;
	        delete this._swipeTouch;
	        delete this._tapTime;
	        delete this._tapPoint;
	        this._tap.reset();
	    }
	    touchstart(e, points, mapTouches) {
	        if (this._swipePoint)
	            return;
	        if (!this._tapTime) {
	            this._tap.touchstart(e, points, mapTouches);
	        }
	        else {
	            const swipePoint = points[0];
	            const soonEnough = e.timeStamp - this._tapTime < MAX_TAP_INTERVAL;
	            const closeEnough = this._tapPoint.dist(swipePoint) < MAX_DIST;
	            if (!soonEnough || !closeEnough) {
	                this.reset();
	            }
	            else if (mapTouches.length > 0) {
	                this._swipePoint = swipePoint;
	                this._swipeTouch = mapTouches[0].identifier;
	            }
	        }
	    }
	    touchmove(e, points, mapTouches) {
	        if (!this._tapTime) {
	            this._tap.touchmove(e, points, mapTouches);
	        }
	        else if (this._swipePoint) {
	            if (mapTouches[0].identifier !== this._swipeTouch) {
	                return;
	            }
	            const newSwipePoint = points[0];
	            const dist = newSwipePoint.y - this._swipePoint.y;
	            this._swipePoint = newSwipePoint;
	            e.preventDefault();
	            this._active = true;
	            return {
	                zoomDelta: dist / 128
	            };
	        }
	    }
	    touchend(e, points, mapTouches) {
	        if (!this._tapTime) {
	            const point = this._tap.touchend(e, points, mapTouches);
	            if (point) {
	                this._tapTime = e.timeStamp;
	                this._tapPoint = point;
	            }
	        }
	        else if (this._swipePoint) {
	            if (mapTouches.length === 0) {
	                this.reset();
	            }
	        }
	    }
	    touchcancel() {
	        this.reset();
	    }
	    enable() {
	        this._enabled = true;
	    }
	    disable() {
	        this._enabled = false;
	        this.reset();
	    }
	    isEnabled() {
	        return this._enabled;
	    }
	    isActive() {
	        return this._active;
	    }
	}

	/**
	 * The `DragPanHandler` allows the user to pan the map by clicking and dragging
	 * the cursor.
	 *
	 * @group Handlers
	 */
	class DragPanHandler {
	    /** @internal */
	    constructor(el, mousePan, touchPan) {
	        this._el = el;
	        this._mousePan = mousePan;
	        this._touchPan = touchPan;
	    }
	    /**
	     * Enables the "drag to pan" interaction.
	     *
	     * @param options - Options object
	     * @example
	     * ```ts
	     *   map.dragPan.enable();
	     *   map.dragPan.enable({
	     *      linearity: 0.3,
	     *      easing: bezier(0, 0, 0.3, 1),
	     *      maxSpeed: 1400,
	     *      deceleration: 2500,
	     *   });
	     * ```
	     */
	    enable(options) {
	        this._inertiaOptions = options || {};
	        this._mousePan.enable();
	        this._touchPan.enable();
	        this._el.classList.add('maplibregl-touch-drag-pan');
	    }
	    /**
	     * Disables the "drag to pan" interaction.
	     *
	     * @example
	     * ```ts
	     * map.dragPan.disable();
	     * ```
	     */
	    disable() {
	        this._mousePan.disable();
	        this._touchPan.disable();
	        this._el.classList.remove('maplibregl-touch-drag-pan');
	    }
	    /**
	     * Returns a Boolean indicating whether the "drag to pan" interaction is enabled.
	     *
	     * @returns `true` if the "drag to pan" interaction is enabled.
	     */
	    isEnabled() {
	        return this._mousePan.isEnabled() && this._touchPan.isEnabled();
	    }
	    /**
	     * Returns a Boolean indicating whether the "drag to pan" interaction is active, i.e. currently being used.
	     *
	     * @returns `true` if the "drag to pan" interaction is active.
	     */
	    isActive() {
	        return this._mousePan.isActive() || this._touchPan.isActive();
	    }
	}

	/**
	 * The `DragRotateHandler` allows the user to rotate the map by clicking and
	 * dragging the cursor while holding the right mouse button or `ctrl` key.
	 *
	 * @group Handlers
	 */
	class DragRotateHandler {
	    /** @internal */
	    constructor(options, mouseRotate, mousePitch) {
	        this._pitchWithRotate = options.pitchWithRotate;
	        this._mouseRotate = mouseRotate;
	        this._mousePitch = mousePitch;
	    }
	    /**
	     * Enables the "drag to rotate" interaction.
	     *
	     * @example
	     * ```ts
	     * map.dragRotate.enable();
	     * ```
	     */
	    enable() {
	        this._mouseRotate.enable();
	        if (this._pitchWithRotate)
	            this._mousePitch.enable();
	    }
	    /**
	     * Disables the "drag to rotate" interaction.
	     *
	     * @example
	     * ```ts
	     * map.dragRotate.disable();
	     * ```
	     */
	    disable() {
	        this._mouseRotate.disable();
	        this._mousePitch.disable();
	    }
	    /**
	     * Returns a Boolean indicating whether the "drag to rotate" interaction is enabled.
	     *
	     * @returns `true` if the "drag to rotate" interaction is enabled.
	     */
	    isEnabled() {
	        return this._mouseRotate.isEnabled() && (!this._pitchWithRotate || this._mousePitch.isEnabled());
	    }
	    /**
	     * Returns a Boolean indicating whether the "drag to rotate" interaction is active, i.e. currently being used.
	     *
	     * @returns `true` if the "drag to rotate" interaction is active.
	     */
	    isActive() {
	        return this._mouseRotate.isActive() || this._mousePitch.isActive();
	    }
	}

	/**
	 * The `TwoFingersTouchZoomRotateHandler` allows the user to zoom and rotate the map by
	 * pinching on a touchscreen.
	 *
	 * They can zoom with one finger by double tapping and dragging. On the second tap,
	 * hold the finger down and drag up or down to zoom in or out.
	 *
	 * @group Handlers
	 */
	class TwoFingersTouchZoomRotateHandler {
	    /** @internal */
	    constructor(el, touchZoom, touchRotate, tapDragZoom) {
	        this._el = el;
	        this._touchZoom = touchZoom;
	        this._touchRotate = touchRotate;
	        this._tapDragZoom = tapDragZoom;
	        this._rotationDisabled = false;
	        this._enabled = true;
	    }
	    /**
	     * Enables the "pinch to rotate and zoom" interaction.
	     *
	     * @param options - Options object.
	     *
	     * @example
	     * ```ts
	     * map.touchZoomRotate.enable();
	     * map.touchZoomRotate.enable({ around: 'center' });
	     * ```
	     */
	    enable(options) {
	        this._touchZoom.enable(options);
	        if (!this._rotationDisabled)
	            this._touchRotate.enable(options);
	        this._tapDragZoom.enable();
	        this._el.classList.add('maplibregl-touch-zoom-rotate');
	    }
	    /**
	     * Disables the "pinch to rotate and zoom" interaction.
	     *
	     * @example
	     * ```ts
	     * map.touchZoomRotate.disable();
	     * ```
	     */
	    disable() {
	        this._touchZoom.disable();
	        this._touchRotate.disable();
	        this._tapDragZoom.disable();
	        this._el.classList.remove('maplibregl-touch-zoom-rotate');
	    }
	    /**
	     * Returns a Boolean indicating whether the "pinch to rotate and zoom" interaction is enabled.
	     *
	     * @returns `true` if the "pinch to rotate and zoom" interaction is enabled.
	     */
	    isEnabled() {
	        return this._touchZoom.isEnabled() &&
	            (this._rotationDisabled || this._touchRotate.isEnabled()) &&
	            this._tapDragZoom.isEnabled();
	    }
	    /**
	     * Returns true if the handler is enabled and has detected the start of a zoom/rotate gesture.
	     *
	     * @returns `true` if the handler is active, `false` otherwise
	     */
	    isActive() {
	        return this._touchZoom.isActive() || this._touchRotate.isActive() || this._tapDragZoom.isActive();
	    }
	    /**
	     * Disables the "pinch to rotate" interaction, leaving the "pinch to zoom"
	     * interaction enabled.
	     *
	     * @example
	     * ```ts
	     * map.touchZoomRotate.disableRotation();
	     * ```
	     */
	    disableRotation() {
	        this._rotationDisabled = true;
	        this._touchRotate.disable();
	    }
	    /**
	     * Enables the "pinch to rotate" interaction.
	     *
	     * @example
	     * ```ts
	     * map.touchZoomRotate.enable();
	     * map.touchZoomRotate.enableRotation();
	     * ```
	     */
	    enableRotation() {
	        this._rotationDisabled = false;
	        if (this._touchZoom.isEnabled())
	            this._touchRotate.enable();
	    }
	}

	/**
	 * A `CooperativeGestureHandler` is a control that adds cooperative gesture info when user tries to zoom in/out.
	 *
	 * @group Handlers
	 *
	 * @example
	 * ```ts
	 * const map = new Map({
	 *   cooperativeGestures: true
	 * });
	 * ```
	 * @see [Example: cooperative gestures](https://maplibre.org/maplibre-gl-js-docs/example/cooperative-gestures/)
	 **/
	class CooperativeGesturesHandler {
	    constructor(map, options) {
	        /**
	         * This is the key that will allow to bypass the cooperative gesture protection
	         */
	        this._bypassKey = navigator.userAgent.indexOf('Mac') !== -1 ? 'metaKey' : 'ctrlKey';
	        this._map = map;
	        this._options = options;
	        this._enabled = false;
	    }
	    isActive() {
	        return false;
	    }
	    reset() { }
	    _setupUI() {
	        if (this._container)
	            return;
	        const mapCanvasContainer = this._map.getCanvasContainer();
	        // Add a cooperative gestures class (enable touch-action: pan-x pan-y;)
	        mapCanvasContainer.classList.add('maplibregl-cooperative-gestures');
	        this._container = DOM.create('div', 'maplibregl-cooperative-gesture-screen', mapCanvasContainer);
	        let desktopMessage = this._map._getUIString('CooperativeGesturesHandler.WindowsHelpText');
	        if (this._bypassKey === 'metaKey') {
	            desktopMessage = this._map._getUIString('CooperativeGesturesHandler.MacHelpText');
	        }
	        const mobileMessage = this._map._getUIString('CooperativeGesturesHandler.MobileHelpText');
	        // Create and append the desktop message div
	        const desktopDiv = document.createElement('div');
	        desktopDiv.className = 'maplibregl-desktop-message';
	        desktopDiv.textContent = desktopMessage;
	        this._container.appendChild(desktopDiv);
	        // Create and append the mobile message div
	        const mobileDiv = document.createElement('div');
	        mobileDiv.className = 'maplibregl-mobile-message';
	        mobileDiv.textContent = mobileMessage;
	        this._container.appendChild(mobileDiv);
	        // Remove cooperative gesture screen from the accessibility tree since screenreaders cannot interact with the map using gestures
	        this._container.setAttribute('aria-hidden', 'true');
	    }
	    _destoryUI() {
	        if (this._container) {
	            DOM.remove(this._container);
	            const mapCanvasContainer = this._map.getCanvasContainer();
	            mapCanvasContainer.classList.remove('maplibregl-cooperative-gestures');
	        }
	        delete this._container;
	    }
	    enable() {
	        this._setupUI();
	        this._enabled = true;
	    }
	    disable() {
	        this._enabled = false;
	        this._destoryUI();
	    }
	    isEnabled() {
	        return this._enabled;
	    }
	    touchmove(e) {
	        this._onCooperativeGesture(e.touches.length === 1);
	    }
	    wheel(e) {
	        if (!this._map.scrollZoom.isEnabled()) {
	            return;
	        }
	        this._onCooperativeGesture(!e[this._bypassKey]);
	    }
	    _onCooperativeGesture(showNotification) {
	        if (!this._enabled || !showNotification)
	            return;
	        // Alert user how to scroll/pan
	        this._container.classList.add('maplibregl-show');
	        setTimeout(() => {
	            this._container.classList.remove('maplibregl-show');
	        }, 100);
	    }
	}

	const isMoving = p => p.zoom || p.drag || p.pitch || p.rotate;
	class RenderFrameEvent extends performance$1.Event {
	}
	function hasChange(result) {
	    return (result.panDelta && result.panDelta.mag()) || result.zoomDelta || result.bearingDelta || result.pitchDelta;
	}
	class HandlerManager {
	    constructor(map, options) {
	        this.handleWindowEvent = (e) => {
	            this.handleEvent(e, `${e.type}Window`);
	        };
	        this.handleEvent = (e, eventName) => {
	            if (e.type === 'blur') {
	                this.stop(true);
	                return;
	            }
	            this._updatingCamera = true;
	            const inputEvent = e.type === 'renderFrame' ? undefined : e;
	            /*
	             * We don't call e.preventDefault() for any events by default.
	             * Handlers are responsible for calling it where necessary.
	             */
	            const mergedHandlerResult = { needsRenderFrame: false };
	            const eventsInProgress = {};
	            const activeHandlers = {};
	            const eventTouches = e.touches;
	            const mapTouches = eventTouches ? this._getMapTouches(eventTouches) : undefined;
	            const points = mapTouches ?
	                DOM.touchPos(this._map.getCanvas(), mapTouches) :
	                DOM.mousePos(this._map.getCanvas(), e);
	            for (const { handlerName, handler, allowed } of this._handlers) {
	                if (!handler.isEnabled())
	                    continue;
	                let data;
	                if (this._blockedByActive(activeHandlers, allowed, handlerName)) {
	                    handler.reset();
	                }
	                else {
	                    if (handler[eventName || e.type]) {
	                        data = handler[eventName || e.type](e, points, mapTouches);
	                        this.mergeHandlerResult(mergedHandlerResult, eventsInProgress, data, handlerName, inputEvent);
	                        if (data && data.needsRenderFrame) {
	                            this._triggerRenderFrame();
	                        }
	                    }
	                }
	                if (data || handler.isActive()) {
	                    activeHandlers[handlerName] = handler;
	                }
	            }
	            const deactivatedHandlers = {};
	            for (const name in this._previousActiveHandlers) {
	                if (!activeHandlers[name]) {
	                    deactivatedHandlers[name] = inputEvent;
	                }
	            }
	            this._previousActiveHandlers = activeHandlers;
	            if (Object.keys(deactivatedHandlers).length || hasChange(mergedHandlerResult)) {
	                this._changes.push([mergedHandlerResult, eventsInProgress, deactivatedHandlers]);
	                this._triggerRenderFrame();
	            }
	            if (Object.keys(activeHandlers).length || hasChange(mergedHandlerResult)) {
	                this._map._stop(true);
	            }
	            this._updatingCamera = false;
	            const { cameraAnimation } = mergedHandlerResult;
	            if (cameraAnimation) {
	                this._inertia.clear();
	                this._fireEvents({}, {}, true);
	                this._changes = [];
	                cameraAnimation(this._map);
	            }
	        };
	        this._map = map;
	        this._el = this._map.getCanvasContainer();
	        this._handlers = [];
	        this._handlersById = {};
	        this._changes = [];
	        this._inertia = new HandlerInertia(map);
	        this._bearingSnap = options.bearingSnap;
	        this._previousActiveHandlers = {};
	        // Track whether map is currently moving, to compute start/move/end events
	        this._eventsInProgress = {};
	        this._addDefaultHandlers(options);
	        const el = this._el;
	        this._listeners = [
	            // This needs to be `passive: true` so that a double tap fires two
	            // pairs of touchstart/end events in iOS Safari 13. If this is set to
	            // `passive: false` then the second pair of events is only fired if
	            // preventDefault() is called on the first touchstart. Calling preventDefault()
	            // undesirably prevents click events.
	            [el, 'touchstart', { passive: true }],
	            // This needs to be `passive: false` so that scrolls and pinches can be
	            // prevented in browsers that don't support `touch-actions: none`, for example iOS Safari 12.
	            [el, 'touchmove', { passive: false }],
	            [el, 'touchend', undefined],
	            [el, 'touchcancel', undefined],
	            [el, 'mousedown', undefined],
	            [el, 'mousemove', undefined],
	            [el, 'mouseup', undefined],
	            // Bind window-level event listeners for move and up/end events. In the absence of
	            // the pointer capture API, which is not supported by all necessary platforms,
	            // window-level event listeners give us the best shot at capturing events that
	            // fall outside the map canvas element. Use `{capture: true}` for the move event
	            // to prevent map move events from being fired during a drag.
	            [document, 'mousemove', { capture: true }],
	            [document, 'mouseup', undefined],
	            [el, 'mouseover', undefined],
	            [el, 'mouseout', undefined],
	            [el, 'dblclick', undefined],
	            [el, 'click', undefined],
	            [el, 'keydown', { capture: false }],
	            [el, 'keyup', undefined],
	            [el, 'wheel', { passive: false }],
	            [el, 'contextmenu', undefined],
	            [window, 'blur', undefined]
	        ];
	        for (const [target, type, listenerOptions] of this._listeners) {
	            DOM.addEventListener(target, type, target === document ? this.handleWindowEvent : this.handleEvent, listenerOptions);
	        }
	    }
	    destroy() {
	        for (const [target, type, listenerOptions] of this._listeners) {
	            DOM.removeEventListener(target, type, target === document ? this.handleWindowEvent : this.handleEvent, listenerOptions);
	        }
	    }
	    _addDefaultHandlers(options) {
	        const map = this._map;
	        const el = map.getCanvasContainer();
	        this._add('mapEvent', new MapEventHandler(map, options));
	        const boxZoom = map.boxZoom = new BoxZoomHandler(map, options);
	        this._add('boxZoom', boxZoom);
	        if (options.interactive && options.boxZoom) {
	            boxZoom.enable();
	        }
	        const cooperativeGestures = map.cooperativeGestures = new CooperativeGesturesHandler(map, options.cooperativeGestures);
	        this._add('cooperativeGestures', cooperativeGestures);
	        if (options.cooperativeGestures) {
	            cooperativeGestures.enable();
	        }
	        const tapZoom = new TapZoomHandler(map);
	        const clickZoom = new ClickZoomHandler(map);
	        map.doubleClickZoom = new DoubleClickZoomHandler(clickZoom, tapZoom);
	        this._add('tapZoom', tapZoom);
	        this._add('clickZoom', clickZoom);
	        if (options.interactive && options.doubleClickZoom) {
	            map.doubleClickZoom.enable();
	        }
	        const tapDragZoom = new TapDragZoomHandler();
	        this._add('tapDragZoom', tapDragZoom);
	        const touchPitch = map.touchPitch = new TwoFingersTouchPitchHandler(map);
	        this._add('touchPitch', touchPitch);
	        if (options.interactive && options.touchPitch) {
	            map.touchPitch.enable(options.touchPitch);
	        }
	        const mouseRotate = generateMouseRotationHandler(options);
	        const mousePitch = generateMousePitchHandler(options);
	        map.dragRotate = new DragRotateHandler(options, mouseRotate, mousePitch);
	        this._add('mouseRotate', mouseRotate, ['mousePitch']);
	        this._add('mousePitch', mousePitch, ['mouseRotate']);
	        if (options.interactive && options.dragRotate) {
	            map.dragRotate.enable();
	        }
	        const mousePan = generateMousePanHandler(options);
	        const touchPan = new TouchPanHandler(options, map);
	        map.dragPan = new DragPanHandler(el, mousePan, touchPan);
	        this._add('mousePan', mousePan);
	        this._add('touchPan', touchPan, ['touchZoom', 'touchRotate']);
	        if (options.interactive && options.dragPan) {
	            map.dragPan.enable(options.dragPan);
	        }
	        const touchRotate = new TwoFingersTouchRotateHandler();
	        const touchZoom = new TwoFingersTouchZoomHandler();
	        map.touchZoomRotate = new TwoFingersTouchZoomRotateHandler(el, touchZoom, touchRotate, tapDragZoom);
	        this._add('touchRotate', touchRotate, ['touchPan', 'touchZoom']);
	        this._add('touchZoom', touchZoom, ['touchPan', 'touchRotate']);
	        if (options.interactive && options.touchZoomRotate) {
	            map.touchZoomRotate.enable(options.touchZoomRotate);
	        }
	        const scrollZoom = map.scrollZoom = new ScrollZoomHandler(map, () => this._triggerRenderFrame());
	        this._add('scrollZoom', scrollZoom, ['mousePan']);
	        if (options.interactive && options.scrollZoom) {
	            map.scrollZoom.enable(options.scrollZoom);
	        }
	        const keyboard = map.keyboard = new KeyboardHandler(map);
	        this._add('keyboard', keyboard);
	        if (options.interactive && options.keyboard) {
	            map.keyboard.enable();
	        }
	        this._add('blockableMapEvent', new BlockableMapEventHandler(map));
	    }
	    _add(handlerName, handler, allowed) {
	        this._handlers.push({ handlerName, handler, allowed });
	        this._handlersById[handlerName] = handler;
	    }
	    stop(allowEndAnimation) {
	        // do nothing if this method was triggered by a gesture update
	        if (this._updatingCamera)
	            return;
	        for (const { handler } of this._handlers) {
	            handler.reset();
	        }
	        this._inertia.clear();
	        this._fireEvents({}, {}, allowEndAnimation);
	        this._changes = [];
	    }
	    isActive() {
	        for (const { handler } of this._handlers) {
	            if (handler.isActive())
	                return true;
	        }
	        return false;
	    }
	    isZooming() {
	        return !!this._eventsInProgress.zoom || this._map.scrollZoom.isZooming();
	    }
	    isRotating() {
	        return !!this._eventsInProgress.rotate;
	    }
	    isMoving() {
	        return Boolean(isMoving(this._eventsInProgress)) || this.isZooming();
	    }
	    _blockedByActive(activeHandlers, allowed, myName) {
	        for (const name in activeHandlers) {
	            if (name === myName)
	                continue;
	            if (!allowed || allowed.indexOf(name) < 0) {
	                return true;
	            }
	        }
	        return false;
	    }
	    _getMapTouches(touches) {
	        const mapTouches = [];
	        for (const t of touches) {
	            const target = t.target;
	            if (this._el.contains(target)) {
	                mapTouches.push(t);
	            }
	        }
	        return mapTouches;
	    }
	    mergeHandlerResult(mergedHandlerResult, eventsInProgress, handlerResult, name, e) {
	        if (!handlerResult)
	            return;
	        performance$1.extend(mergedHandlerResult, handlerResult);
	        const eventData = { handlerName: name, originalEvent: handlerResult.originalEvent || e };
	        // track which handler changed which camera property
	        if (handlerResult.zoomDelta !== undefined) {
	            eventsInProgress.zoom = eventData;
	        }
	        if (handlerResult.panDelta !== undefined) {
	            eventsInProgress.drag = eventData;
	        }
	        if (handlerResult.pitchDelta !== undefined) {
	            eventsInProgress.pitch = eventData;
	        }
	        if (handlerResult.bearingDelta !== undefined) {
	            eventsInProgress.rotate = eventData;
	        }
	    }
	    _applyChanges() {
	        const combined = {};
	        const combinedEventsInProgress = {};
	        const combinedDeactivatedHandlers = {};
	        for (const [change, eventsInProgress, deactivatedHandlers] of this._changes) {
	            if (change.panDelta)
	                combined.panDelta = (combined.panDelta || new performance$1.Point(0, 0))._add(change.panDelta);
	            if (change.zoomDelta)
	                combined.zoomDelta = (combined.zoomDelta || 0) + change.zoomDelta;
	            if (change.bearingDelta)
	                combined.bearingDelta = (combined.bearingDelta || 0) + change.bearingDelta;
	            if (change.pitchDelta)
	                combined.pitchDelta = (combined.pitchDelta || 0) + change.pitchDelta;
	            if (change.around !== undefined)
	                combined.around = change.around;
	            if (change.pinchAround !== undefined)
	                combined.pinchAround = change.pinchAround;
	            if (change.noInertia)
	                combined.noInertia = change.noInertia;
	            performance$1.extend(combinedEventsInProgress, eventsInProgress);
	            performance$1.extend(combinedDeactivatedHandlers, deactivatedHandlers);
	        }
	        this._updateMapTransform(combined, combinedEventsInProgress, combinedDeactivatedHandlers);
	        this._changes = [];
	    }
	    _updateMapTransform(combinedResult, combinedEventsInProgress, deactivatedHandlers) {
	        const map = this._map;
	        const tr = map._getTransformForUpdate();
	        const terrain = map.terrain;
	        if (!hasChange(combinedResult) && !(terrain && this._terrainMovement)) {
	            return this._fireEvents(combinedEventsInProgress, deactivatedHandlers, true);
	        }
	        let { panDelta, zoomDelta, bearingDelta, pitchDelta, around, pinchAround } = combinedResult;
	        if (pinchAround !== undefined) {
	            around = pinchAround;
	        }
	        // stop any ongoing camera animations (easeTo, flyTo)
	        map._stop(true);
	        around = around || map.transform.centerPoint;
	        const loc = tr.pointLocation(panDelta ? around.sub(panDelta) : around);
	        if (bearingDelta)
	            tr.bearing += bearingDelta;
	        if (pitchDelta)
	            tr.pitch += pitchDelta;
	        if (zoomDelta)
	            tr.zoom += zoomDelta;
	        if (!terrain) {
	            tr.setLocationAtPoint(loc, around);
	        }
	        else {
	            // when 3d-terrain is enabled act a little different:
	            //    - dragging do not drag the picked point itself, instead it drags the map by pixel-delta.
	            //      With this approach it is no longer possible to pick a point from somewhere near
	            //      the horizon to the center in one move.
	            //      So this logic avoids the problem, that in such cases you easily loose orientation.
	            if (!this._terrainMovement &&
	                (combinedEventsInProgress.drag || combinedEventsInProgress.zoom)) {
	                // When starting to drag or move, flag it and register moveend to clear flagging
	                this._terrainMovement = true;
	                this._map._elevationFreeze = true;
	                tr.setLocationAtPoint(loc, around);
	                this._map.once('moveend', () => {
	                    this._map._elevationFreeze = false;
	                    this._terrainMovement = false;
	                    tr.recalculateZoom(map.terrain);
	                });
	            }
	            else if (combinedEventsInProgress.drag && this._terrainMovement) {
	                // drag map
	                tr.center = tr.pointLocation(tr.centerPoint.sub(panDelta));
	            }
	            else {
	                tr.setLocationAtPoint(loc, around);
	            }
	        }
	        map._applyUpdatedTransform(tr);
	        this._map._update();
	        if (!combinedResult.noInertia)
	            this._inertia.record(combinedResult);
	        this._fireEvents(combinedEventsInProgress, deactivatedHandlers, true);
	    }
	    _fireEvents(newEventsInProgress, deactivatedHandlers, allowEndAnimation) {
	        const wasMoving = isMoving(this._eventsInProgress);
	        const nowMoving = isMoving(newEventsInProgress);
	        const startEvents = {};
	        for (const eventName in newEventsInProgress) {
	            const { originalEvent } = newEventsInProgress[eventName];
	            if (!this._eventsInProgress[eventName]) {
	                startEvents[`${eventName}start`] = originalEvent;
	            }
	            this._eventsInProgress[eventName] = newEventsInProgress[eventName];
	        }
	        // fire start events only after this._eventsInProgress has been updated
	        if (!wasMoving && nowMoving) {
	            this._fireEvent('movestart', nowMoving.originalEvent);
	        }
	        for (const name in startEvents) {
	            this._fireEvent(name, startEvents[name]);
	        }
	        if (nowMoving) {
	            this._fireEvent('move', nowMoving.originalEvent);
	        }
	        for (const eventName in newEventsInProgress) {
	            const { originalEvent } = newEventsInProgress[eventName];
	            this._fireEvent(eventName, originalEvent);
	        }
	        const endEvents = {};
	        let originalEndEvent;
	        for (const eventName in this._eventsInProgress) {
	            const { handlerName, originalEvent } = this._eventsInProgress[eventName];
	            if (!this._handlersById[handlerName].isActive()) {
	                delete this._eventsInProgress[eventName];
	                originalEndEvent = deactivatedHandlers[handlerName] || originalEvent;
	                endEvents[`${eventName}end`] = originalEndEvent;
	            }
	        }
	        for (const name in endEvents) {
	            this._fireEvent(name, endEvents[name]);
	        }
	        const stillMoving = isMoving(this._eventsInProgress);
	        if (allowEndAnimation && (wasMoving || nowMoving) && !stillMoving) {
	            this._updatingCamera = true;
	            const inertialEase = this._inertia._onMoveEnd(this._map.dragPan._inertiaOptions);
	            const shouldSnapToNorth = bearing => bearing !== 0 && -this._bearingSnap < bearing && bearing < this._bearingSnap;
	            if (inertialEase && (inertialEase.essential || !browser.prefersReducedMotion)) {
	                if (shouldSnapToNorth(inertialEase.bearing || this._map.getBearing())) {
	                    inertialEase.bearing = 0;
	                }
	                inertialEase.freezeElevation = true;
	                this._map.easeTo(inertialEase, { originalEvent: originalEndEvent });
	            }
	            else {
	                this._map.fire(new performance$1.Event('moveend', { originalEvent: originalEndEvent }));
	                if (shouldSnapToNorth(this._map.getBearing())) {
	                    this._map.resetNorth();
	                }
	            }
	            this._updatingCamera = false;
	        }
	    }
	    _fireEvent(type, e) {
	        this._map.fire(new performance$1.Event(type, e ? { originalEvent: e } : {}));
	    }
	    _requestFrame() {
	        this._map.triggerRepaint();
	        return this._map._renderTaskQueue.add(timeStamp => {
	            delete this._frameId;
	            this.handleEvent(new RenderFrameEvent('renderFrame', { timeStamp }));
	            this._applyChanges();
	        });
	    }
	    _triggerRenderFrame() {
	        if (this._frameId === undefined) {
	            this._frameId = this._requestFrame();
	        }
	    }
	}

	class Camera extends performance$1.Evented {
	    constructor(transform, options) {
	        super();
	        // Callback for map._requestRenderFrame
	        this._renderFrameCallback = () => {
	            const t = Math.min((browser.now() - this._easeStart) / this._easeOptions.duration, 1);
	            this._onEaseFrame(this._easeOptions.easing(t));
	            // if _stop is called during _onEaseFrame from _fireMoveEvents we should avoid a new _requestRenderFrame, checking it by ensuring _easeFrameId was not deleted
	            if (t < 1 && this._easeFrameId) {
	                this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback);
	            }
	            else {
	                this.stop();
	            }
	        };
	        this._moving = false;
	        this._zooming = false;
	        this.transform = transform;
	        this._bearingSnap = options.bearingSnap;
	        this.on('moveend', () => {
	            delete this._requestedCameraState;
	        });
	    }
	    /**
	     * Returns the map's geographical centerpoint.
	     *
	     * @returns The map's geographical centerpoint.
	     * @example
	     * Return a LngLat object such as `{lng: 0, lat: 0}`
	     * ```ts
	     * let center = map.getCenter();
	     * // access longitude and latitude values directly
	     * let {lng, lat} = map.getCenter();
	     * ```
	     */
	    getCenter() { return new performance$1.LngLat(this.transform.center.lng, this.transform.center.lat); }
	    /**
	     * Sets the map's geographical centerpoint. Equivalent to `jumpTo({center: center})`.
	     *
	     * Triggers the following events: `movestart` and `moveend`.
	     *
	     * @param center - The centerpoint to set.
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setCenter([-74, 38]);
	     * ```
	     */
	    setCenter(center, eventData) {
	        return this.jumpTo({ center }, eventData);
	    }
	    /**
	     * Pans the map by the specified offset.
	     *
	     * Triggers the following events: `movestart` and `moveend`.
	     *
	     * @param offset - `x` and `y` coordinates by which to pan the map.
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @see [Navigate the map with game-like controls](https://maplibre.org/maplibre-gl-js/docs/examples/game-controls/)
	     */
	    panBy(offset, options, eventData) {
	        offset = performance$1.Point.convert(offset).mult(-1);
	        return this.panTo(this.transform.center, performance$1.extend({ offset }, options), eventData);
	    }
	    /**
	     * Pans the map to the specified location with an animated transition.
	     *
	     * Triggers the following events: `movestart` and `moveend`.
	     *
	     * @param lnglat - The location to pan the map to.
	     * @param options - Options describing the destination and animation of the transition.
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.panTo([-74, 38]);
	     * // Specify that the panTo animation should last 5000 milliseconds.
	     * map.panTo([-74, 38], {duration: 5000});
	     * ```
	     * @see [Update a feature in realtime](https://maplibre.org/maplibre-gl-js/docs/examples/live-update-feature/)
	     */
	    panTo(lnglat, options, eventData) {
	        return this.easeTo(performance$1.extend({
	            center: lnglat
	        }, options), eventData);
	    }
	    /**
	     * Returns the map's current zoom level.
	     *
	     * @returns The map's current zoom level.
	     * @example
	     * ```ts
	     * map.getZoom();
	     * ```
	     */
	    getZoom() { return this.transform.zoom; }
	    /**
	     * Sets the map's zoom level. Equivalent to `jumpTo({zoom: zoom})`.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, and `zoomend`.
	     *
	     * @param zoom - The zoom level to set (0-20).
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * Zoom to the zoom level 5 without an animated transition
	     * ```ts
	     * map.setZoom(5);
	     * ```
	     */
	    setZoom(zoom, eventData) {
	        this.jumpTo({ zoom }, eventData);
	        return this;
	    }
	    /**
	     * Zooms the map to the specified zoom level, with an animated transition.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, and `zoomend`.
	     *
	     * @param zoom - The zoom level to transition to.
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * ```ts
	     * // Zoom to the zoom level 5 without an animated transition
	     * map.zoomTo(5);
	     * // Zoom to the zoom level 8 with an animated transition
	     * map.zoomTo(8, {
	     *   duration: 2000,
	     *   offset: [100, 50]
	     * });
	     * ```
	     */
	    zoomTo(zoom, options, eventData) {
	        return this.easeTo(performance$1.extend({
	            zoom
	        }, options), eventData);
	    }
	    /**
	     * Increases the map's zoom level by 1.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, and `zoomend`.
	     *
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * Zoom the map in one level with a custom animation duration
	     * ```ts
	     * map.zoomIn({duration: 1000});
	     * ```
	     */
	    zoomIn(options, eventData) {
	        this.zoomTo(this.getZoom() + 1, options, eventData);
	        return this;
	    }
	    /**
	     * Decreases the map's zoom level by 1.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, and `zoomend`.
	     *
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * Zoom the map out one level with a custom animation offset
	     * ```ts
	     * map.zoomOut({offset: [80, 60]});
	     * ```
	     */
	    zoomOut(options, eventData) {
	        this.zoomTo(this.getZoom() - 1, options, eventData);
	        return this;
	    }
	    /**
	     * Returns the map's current bearing. The bearing is the compass direction that is "up"; for example, a bearing
	     * of 90° orients the map so that east is up.
	     *
	     * @returns The map's current bearing.
	     * @see [Navigate the map with game-like controls](https://maplibre.org/maplibre-gl-js/docs/examples/game-controls/)
	     */
	    getBearing() { return this.transform.bearing; }
	    /**
	     * Sets the map's bearing (rotation). The bearing is the compass direction that is "up"; for example, a bearing
	     * of 90° orients the map so that east is up.
	     *
	     * Equivalent to `jumpTo({bearing: bearing})`.
	     *
	     * Triggers the following events: `movestart`, `moveend`, and `rotate`.
	     *
	     * @param bearing - The desired bearing.
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * Rotate the map to 90 degrees
	     * ```ts
	     * map.setBearing(90);
	     * ```
	     */
	    setBearing(bearing, eventData) {
	        this.jumpTo({ bearing }, eventData);
	        return this;
	    }
	    /**
	     * Returns the current padding applied around the map viewport.
	     *
	     * @returns The current padding around the map viewport.
	     */
	    getPadding() { return this.transform.padding; }
	    /**
	     * Sets the padding in pixels around the viewport.
	     *
	     * Equivalent to `jumpTo({padding: padding})`.
	     *
	     * Triggers the following events: `movestart` and `moveend`.
	     *
	     * @param padding - The desired padding.
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * Sets a left padding of 300px, and a top padding of 50px
	     * ```ts
	     * map.setPadding({ left: 300, top: 50 });
	     * ```
	     */
	    setPadding(padding, eventData) {
	        this.jumpTo({ padding }, eventData);
	        return this;
	    }
	    /**
	     * Rotates the map to the specified bearing, with an animated transition. The bearing is the compass direction
	     * that is "up"; for example, a bearing of 90° orients the map so that east is up.
	     *
	     * Triggers the following events: `movestart`, `moveend`, and `rotate`.
	     *
	     * @param bearing - The desired bearing.
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     */
	    rotateTo(bearing, options, eventData) {
	        return this.easeTo(performance$1.extend({
	            bearing
	        }, options), eventData);
	    }
	    /**
	     * Rotates the map so that north is up (0° bearing), with an animated transition.
	     *
	     * Triggers the following events: `movestart`, `moveend`, and `rotate`.
	     *
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     */
	    resetNorth(options, eventData) {
	        this.rotateTo(0, performance$1.extend({ duration: 1000 }, options), eventData);
	        return this;
	    }
	    /**
	     * Rotates and pitches the map so that north is up (0° bearing) and pitch is 0°, with an animated transition.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `pitchstart`, `pitch`, `pitchend`, and `rotate`.
	     *
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     */
	    resetNorthPitch(options, eventData) {
	        this.easeTo(performance$1.extend({
	            bearing: 0,
	            pitch: 0,
	            duration: 1000
	        }, options), eventData);
	        return this;
	    }
	    /**
	     * Snaps the map so that north is up (0° bearing), if the current bearing is close enough to it (i.e. within the
	     * `bearingSnap` threshold).
	     *
	     * Triggers the following events: `movestart`, `moveend`, and `rotate`.
	     *
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     */
	    snapToNorth(options, eventData) {
	        if (Math.abs(this.getBearing()) < this._bearingSnap) {
	            return this.resetNorth(options, eventData);
	        }
	        return this;
	    }
	    /**
	     * Returns the map's current pitch (tilt).
	     *
	     * @returns The map's current pitch, measured in degrees away from the plane of the screen.
	     */
	    getPitch() { return this.transform.pitch; }
	    /**
	     * Sets the map's pitch (tilt). Equivalent to `jumpTo({pitch: pitch})`.
	     *
	     * Triggers the following events: `movestart`, `moveend`, `pitchstart`, and `pitchend`.
	     *
	     * @param pitch - The pitch to set, measured in degrees away from the plane of the screen (0-60).
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     */
	    setPitch(pitch, eventData) {
	        this.jumpTo({ pitch }, eventData);
	        return this;
	    }
	    /**
	     * @param bounds - Calculate the center for these bounds in the viewport and use
	     * the highest zoom level up to and including `Map#getMaxZoom()` that fits
	     * in the viewport. LngLatBounds represent a box that is always axis-aligned with bearing 0.
	     * @param options - Options object
	     * @returns If map is able to fit to provided bounds, returns `center`, `zoom`, and `bearing`.
	     * If map is unable to fit, method will warn and return undefined.
	     * @example
	     * ```ts
	     * let bbox = [[-79, 43], [-73, 45]];
	     * let newCameraTransform = map.cameraForBounds(bbox, {
	     *   padding: {top: 10, bottom:25, left: 15, right: 5}
	     * });
	     * ```
	     */
	    cameraForBounds(bounds, options) {
	        bounds = LngLatBounds.convert(bounds);
	        const bearing = options && options.bearing || 0;
	        return this._cameraForBoxAndBearing(bounds.getNorthWest(), bounds.getSouthEast(), bearing, options);
	    }
	    /**
	     * @internal
	     * Calculate the center of these two points in the viewport and use
	     * the highest zoom level up to and including `Map#getMaxZoom()` that fits
	     * the points in the viewport at the specified bearing.
	     * @param p0 - First point
	     * @param p1 - Second point
	     * @param bearing - Desired map bearing at end of animation, in degrees
	     * @param options - the camera options
	     * @returns If map is able to fit to provided bounds, returns `center`, `zoom`, and `bearing`.
	     *      If map is unable to fit, method will warn and return undefined.
	     * @example
	     * ```ts
	     * let p0 = [-79, 43];
	     * let p1 = [-73, 45];
	     * let bearing = 90;
	     * let newCameraTransform = map._cameraForBoxAndBearing(p0, p1, bearing, {
	     *   padding: {top: 10, bottom:25, left: 15, right: 5}
	     * });
	     * ```
	     */
	    _cameraForBoxAndBearing(p0, p1, bearing, options) {
	        const defaultPadding = {
	            top: 0,
	            bottom: 0,
	            right: 0,
	            left: 0
	        };
	        options = performance$1.extend({
	            padding: defaultPadding,
	            offset: [0, 0],
	            maxZoom: this.transform.maxZoom
	        }, options);
	        if (typeof options.padding === 'number') {
	            const p = options.padding;
	            options.padding = {
	                top: p,
	                bottom: p,
	                right: p,
	                left: p
	            };
	        }
	        options.padding = performance$1.extend(defaultPadding, options.padding);
	        const tr = this.transform;
	        const edgePadding = tr.padding;
	        // Consider all corners of the rotated bounding box derived from the given points
	        // when find the camera position that fits the given points.
	        const bounds = new LngLatBounds(p0, p1);
	        const nwWorld = tr.project(bounds.getNorthWest());
	        const neWorld = tr.project(bounds.getNorthEast());
	        const seWorld = tr.project(bounds.getSouthEast());
	        const swWorld = tr.project(bounds.getSouthWest());
	        const bearingRadians = performance$1.degreesToRadians(-bearing);
	        const nwRotatedWorld = nwWorld.rotate(bearingRadians);
	        const neRotatedWorld = neWorld.rotate(bearingRadians);
	        const seRotatedWorld = seWorld.rotate(bearingRadians);
	        const swRotatedWorld = swWorld.rotate(bearingRadians);
	        const upperRight = new performance$1.Point(Math.max(nwRotatedWorld.x, neRotatedWorld.x, swRotatedWorld.x, seRotatedWorld.x), Math.max(nwRotatedWorld.y, neRotatedWorld.y, swRotatedWorld.y, seRotatedWorld.y));
	        const lowerLeft = new performance$1.Point(Math.min(nwRotatedWorld.x, neRotatedWorld.x, swRotatedWorld.x, seRotatedWorld.x), Math.min(nwRotatedWorld.y, neRotatedWorld.y, swRotatedWorld.y, seRotatedWorld.y));
	        // Calculate zoom: consider the original bbox and padding.
	        const size = upperRight.sub(lowerLeft);
	        const scaleX = (tr.width - (edgePadding.left + edgePadding.right + options.padding.left + options.padding.right)) / size.x;
	        const scaleY = (tr.height - (edgePadding.top + edgePadding.bottom + options.padding.top + options.padding.bottom)) / size.y;
	        if (scaleY < 0 || scaleX < 0) {
	            performance$1.warnOnce('Map cannot fit within canvas with the given bounds, padding, and/or offset.');
	            return undefined;
	        }
	        const zoom = Math.min(tr.scaleZoom(tr.scale * Math.min(scaleX, scaleY)), options.maxZoom);
	        // Calculate center: apply the zoom, the configured offset, as well as offset that exists as a result of padding.
	        const offset = performance$1.Point.convert(options.offset);
	        const paddingOffsetX = (options.padding.left - options.padding.right) / 2;
	        const paddingOffsetY = (options.padding.top - options.padding.bottom) / 2;
	        const paddingOffset = new performance$1.Point(paddingOffsetX, paddingOffsetY);
	        const rotatedPaddingOffset = paddingOffset.rotate(performance$1.degreesToRadians(bearing));
	        const offsetAtInitialZoom = offset.add(rotatedPaddingOffset);
	        const offsetAtFinalZoom = offsetAtInitialZoom.mult(tr.scale / tr.zoomScale(zoom));
	        const center = tr.unproject(
	        // either world diagonal can be used (NW-SE or NE-SW)
	        nwWorld.add(seWorld).div(2).sub(offsetAtFinalZoom));
	        return {
	            center,
	            zoom,
	            bearing
	        };
	    }
	    /**
	     * Pans and zooms the map to contain its visible area within the specified geographical bounds.
	     * This function will also reset the map's bearing to 0 if bearing is nonzero.
	     *
	     * Triggers the following events: `movestart` and `moveend`.
	     *
	     * @param bounds - Center these bounds in the viewport and use the highest
	     * zoom level up to and including `Map#getMaxZoom()` that fits them in the viewport.
	     * @param options - Options supports all properties from {@link AnimationOptions} and {@link CameraOptions} in addition to the fields below.
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * ```ts
	     * let bbox = [[-79, 43], [-73, 45]];
	     * map.fitBounds(bbox, {
	     *   padding: {top: 10, bottom:25, left: 15, right: 5}
	     * });
	     * ```
	     * @see [Fit a map to a bounding box](https://maplibre.org/maplibre-gl-js/docs/examples/fitbounds/)
	     */
	    fitBounds(bounds, options, eventData) {
	        return this._fitInternal(this.cameraForBounds(bounds, options), options, eventData);
	    }
	    /**
	     * Pans, rotates and zooms the map to to fit the box made by points p0 and p1
	     * once the map is rotated to the specified bearing. To zoom without rotating,
	     * pass in the current map bearing.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, `zoomend` and `rotate`.
	     *
	     * @param p0 - First point on screen, in pixel coordinates
	     * @param p1 - Second point on screen, in pixel coordinates
	     * @param bearing - Desired map bearing at end of animation, in degrees
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * ```ts
	     * let p0 = [220, 400];
	     * let p1 = [500, 900];
	     * map.fitScreenCoordinates(p0, p1, map.getBearing(), {
	     *   padding: {top: 10, bottom:25, left: 15, right: 5}
	     * });
	     * ```
	     * @see Used by {@link BoxZoomHandler}
	     */
	    fitScreenCoordinates(p0, p1, bearing, options, eventData) {
	        return this._fitInternal(this._cameraForBoxAndBearing(this.transform.pointLocation(performance$1.Point.convert(p0)), this.transform.pointLocation(performance$1.Point.convert(p1)), bearing, options), options, eventData);
	    }
	    _fitInternal(calculatedOptions, options, eventData) {
	        // cameraForBounds warns + returns undefined if unable to fit:
	        if (!calculatedOptions)
	            return this;
	        options = performance$1.extend(calculatedOptions, options);
	        // Explicitly remove the padding field because, calculatedOptions already accounts for padding by setting zoom and center accordingly.
	        delete options.padding;
	        return options.linear ?
	            this.easeTo(options, eventData) :
	            this.flyTo(options, eventData);
	    }
	    /**
	     * Changes any combination of center, zoom, bearing, and pitch, without
	     * an animated transition. The map will retain its current values for any
	     * details not specified in `options`.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, `zoomend`, `pitchstart`,
	     * `pitch`, `pitchend`, and `rotate`.
	     *
	     * @param options - Options object
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * ```ts
	     * // jump to coordinates at current zoom
	     * map.jumpTo({center: [0, 0]});
	     * // jump with zoom, pitch, and bearing options
	     * map.jumpTo({
	     *   center: [0, 0],
	     *   zoom: 8,
	     *   pitch: 45,
	     *   bearing: 90
	     * });
	     * ```
	     * @see [Jump to a series of locations](https://maplibre.org/maplibre-gl-js/docs/examples/jump-to/)
	     * @see [Update a feature in realtime](https://maplibre.org/maplibre-gl-js/docs/examples/live-update-feature/)
	     */
	    jumpTo(options, eventData) {
	        this.stop();
	        const tr = this._getTransformForUpdate();
	        let zoomChanged = false, bearingChanged = false, pitchChanged = false;
	        if ('zoom' in options && tr.zoom !== +options.zoom) {
	            zoomChanged = true;
	            tr.zoom = +options.zoom;
	        }
	        if (options.center !== undefined) {
	            tr.center = performance$1.LngLat.convert(options.center);
	        }
	        if ('bearing' in options && tr.bearing !== +options.bearing) {
	            bearingChanged = true;
	            tr.bearing = +options.bearing;
	        }
	        if ('pitch' in options && tr.pitch !== +options.pitch) {
	            pitchChanged = true;
	            tr.pitch = +options.pitch;
	        }
	        if (options.padding != null && !tr.isPaddingEqual(options.padding)) {
	            tr.padding = options.padding;
	        }
	        this._applyUpdatedTransform(tr);
	        this.fire(new performance$1.Event('movestart', eventData))
	            .fire(new performance$1.Event('move', eventData));
	        if (zoomChanged) {
	            this.fire(new performance$1.Event('zoomstart', eventData))
	                .fire(new performance$1.Event('zoom', eventData))
	                .fire(new performance$1.Event('zoomend', eventData));
	        }
	        if (bearingChanged) {
	            this.fire(new performance$1.Event('rotatestart', eventData))
	                .fire(new performance$1.Event('rotate', eventData))
	                .fire(new performance$1.Event('rotateend', eventData));
	        }
	        if (pitchChanged) {
	            this.fire(new performance$1.Event('pitchstart', eventData))
	                .fire(new performance$1.Event('pitch', eventData))
	                .fire(new performance$1.Event('pitchend', eventData));
	        }
	        return this.fire(new performance$1.Event('moveend', eventData));
	    }
	    /**
	     * Calculates pitch, zoom and bearing for looking at `newCenter` with the camera position being `newCenter`
	     * and returns them as {@link CameraOptions}.
	     * @param from - The camera to look from
	     * @param altitudeFrom - The altitude of the camera to look from
	     * @param to - The center to look at
	     * @param altitudeTo - Optional altitude of the center to look at. If none given the ground height will be used.
	     * @returns the calculated camera options
	     */
	    calculateCameraOptionsFromTo(from, altitudeFrom, to, altitudeTo = 0) {
	        const fromMerc = performance$1.MercatorCoordinate.fromLngLat(from, altitudeFrom);
	        const toMerc = performance$1.MercatorCoordinate.fromLngLat(to, altitudeTo);
	        const dx = toMerc.x - fromMerc.x;
	        const dy = toMerc.y - fromMerc.y;
	        const dz = toMerc.z - fromMerc.z;
	        const distance3D = Math.hypot(dx, dy, dz);
	        if (distance3D === 0)
	            throw new Error('Can\'t calculate camera options with same From and To');
	        const groundDistance = Math.hypot(dx, dy);
	        const zoom = this.transform.scaleZoom(this.transform.cameraToCenterDistance / distance3D / this.transform.tileSize);
	        const bearing = (Math.atan2(dx, -dy) * 180) / Math.PI;
	        let pitch = (Math.acos(groundDistance / distance3D) * 180) / Math.PI;
	        pitch = dz < 0 ? 90 - pitch : 90 + pitch;
	        return {
	            center: toMerc.toLngLat(),
	            zoom,
	            pitch,
	            bearing
	        };
	    }
	    /**
	     * Changes any combination of `center`, `zoom`, `bearing`, `pitch`, and `padding` with an animated transition
	     * between old and new values. The map will retain its current values for any
	     * details not specified in `options`.
	     *
	     * Note: The transition will happen instantly if the user has enabled
	     * the `reduced motion` accessibility feature enabled in their operating system,
	     * unless `options` includes `essential: true`.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, `zoomend`, `pitchstart`,
	     * `pitch`, `pitchend`, and `rotate`.
	     *
	     * @param options - Options describing the destination and animation of the transition.
	     * Accepts {@link CameraOptions} and {@link AnimationOptions}.
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @see [Navigate the map with game-like controls](https://maplibre.org/maplibre-gl-js/docs/examples/game-controls/)
	     */
	    easeTo(options, eventData) {
	        var _a;
	        this._stop(false, options.easeId);
	        options = performance$1.extend({
	            offset: [0, 0],
	            duration: 500,
	            easing: performance$1.defaultEasing
	        }, options);
	        if (options.animate === false || (!options.essential && browser.prefersReducedMotion))
	            options.duration = 0;
	        const tr = this._getTransformForUpdate(), startZoom = this.getZoom(), startBearing = this.getBearing(), startPitch = this.getPitch(), startPadding = this.getPadding(), bearing = 'bearing' in options ? this._normalizeBearing(options.bearing, startBearing) : startBearing, pitch = 'pitch' in options ? +options.pitch : startPitch, padding = 'padding' in options ? options.padding : tr.padding;
	        const offsetAsPoint = performance$1.Point.convert(options.offset);
	        let pointAtOffset = tr.centerPoint.add(offsetAsPoint);
	        const locationAtOffset = tr.pointLocation(pointAtOffset);
	        const { center, zoom } = tr.getConstrained(performance$1.LngLat.convert(options.center || locationAtOffset), (_a = options.zoom) !== null && _a !== void 0 ? _a : startZoom);
	        this._normalizeCenter(center);
	        const from = tr.project(locationAtOffset);
	        const delta = tr.project(center).sub(from);
	        const finalScale = tr.zoomScale(zoom - startZoom);
	        let around, aroundPoint;
	        if (options.around) {
	            around = performance$1.LngLat.convert(options.around);
	            aroundPoint = tr.locationPoint(around);
	        }
	        const currently = {
	            moving: this._moving,
	            zooming: this._zooming,
	            rotating: this._rotating,
	            pitching: this._pitching
	        };
	        this._zooming = this._zooming || (zoom !== startZoom);
	        this._rotating = this._rotating || (startBearing !== bearing);
	        this._pitching = this._pitching || (pitch !== startPitch);
	        this._padding = !tr.isPaddingEqual(padding);
	        this._easeId = options.easeId;
	        this._prepareEase(eventData, options.noMoveStart, currently);
	        if (this.terrain)
	            this._prepareElevation(center);
	        this._ease((k) => {
	            if (this._zooming) {
	                tr.zoom = performance$1.interpolate.number(startZoom, zoom, k);
	            }
	            if (this._rotating) {
	                tr.bearing = performance$1.interpolate.number(startBearing, bearing, k);
	            }
	            if (this._pitching) {
	                tr.pitch = performance$1.interpolate.number(startPitch, pitch, k);
	            }
	            if (this._padding) {
	                tr.interpolatePadding(startPadding, padding, k);
	                // When padding is being applied, Transform#centerPoint is changing continuously,
	                // thus we need to recalculate offsetPoint every frame
	                pointAtOffset = tr.centerPoint.add(offsetAsPoint);
	            }
	            if (this.terrain && !options.freezeElevation)
	                this._updateElevation(k);
	            if (around) {
	                tr.setLocationAtPoint(around, aroundPoint);
	            }
	            else {
	                const scale = tr.zoomScale(tr.zoom - startZoom);
	                const base = zoom > startZoom ?
	                    Math.min(2, finalScale) :
	                    Math.max(0.5, finalScale);
	                const speedup = Math.pow(base, 1 - k);
	                const newCenter = tr.unproject(from.add(delta.mult(k * speedup)).mult(scale));
	                tr.setLocationAtPoint(tr.renderWorldCopies ? newCenter.wrap() : newCenter, pointAtOffset);
	            }
	            this._applyUpdatedTransform(tr);
	            this._fireMoveEvents(eventData);
	        }, (interruptingEaseId) => {
	            if (this.terrain)
	                this._finalizeElevation();
	            this._afterEase(eventData, interruptingEaseId);
	        }, options);
	        return this;
	    }
	    _prepareEase(eventData, noMoveStart, currently = {}) {
	        this._moving = true;
	        if (!noMoveStart && !currently.moving) {
	            this.fire(new performance$1.Event('movestart', eventData));
	        }
	        if (this._zooming && !currently.zooming) {
	            this.fire(new performance$1.Event('zoomstart', eventData));
	        }
	        if (this._rotating && !currently.rotating) {
	            this.fire(new performance$1.Event('rotatestart', eventData));
	        }
	        if (this._pitching && !currently.pitching) {
	            this.fire(new performance$1.Event('pitchstart', eventData));
	        }
	    }
	    _prepareElevation(center) {
	        this._elevationCenter = center;
	        this._elevationStart = this.transform.elevation;
	        this._elevationTarget = this.terrain.getElevationForLngLatZoom(center, this.transform.tileZoom);
	        this._elevationFreeze = true;
	    }
	    _updateElevation(k) {
	        this.transform.minElevationForCurrentTile = this.terrain.getMinTileElevationForLngLatZoom(this._elevationCenter, this.transform.tileZoom);
	        const elevation = this.terrain.getElevationForLngLatZoom(this._elevationCenter, this.transform.tileZoom);
	        // target terrain updated during flight, slowly move camera to new height
	        if (k < 1 && elevation !== this._elevationTarget) {
	            const pitch1 = this._elevationTarget - this._elevationStart;
	            const pitch2 = (elevation - (pitch1 * k + this._elevationStart)) / (1 - k);
	            this._elevationStart += k * (pitch1 - pitch2);
	            this._elevationTarget = elevation;
	        }
	        this.transform.elevation = performance$1.interpolate.number(this._elevationStart, this._elevationTarget, k);
	    }
	    _finalizeElevation() {
	        this._elevationFreeze = false;
	        this.transform.recalculateZoom(this.terrain);
	    }
	    /**
	     * @internal
	     * Called when the camera is about to be manipulated.
	     * If `transformCameraUpdate` is specified, a copy of the current transform is created to track the accumulated changes.
	     * This underlying transform represents the "desired state" proposed by input handlers / animations / UI controls.
	     * It may differ from the state used for rendering (`this.transform`).
	     * @hidden
	     * @returns Transform to apply changes to
	     */
	    _getTransformForUpdate() {
	        if (!this.transformCameraUpdate)
	            return this.transform;
	        if (!this._requestedCameraState) {
	            this._requestedCameraState = this.transform.clone();
	        }
	        return this._requestedCameraState;
	    }
	    /**
	     * @internal
	     * Called after the camera is done being manipulated.
	     * @param tr - the requested camera end state
	     * Call `transformCameraUpdate` if present, and then apply the "approved" changes.
	     */
	    _applyUpdatedTransform(tr) {
	        if (!this.transformCameraUpdate)
	            return;
	        const nextTransform = tr.clone();
	        const { center, zoom, pitch, bearing, elevation } = this.transformCameraUpdate(nextTransform);
	        if (center)
	            nextTransform.center = center;
	        if (zoom !== undefined)
	            nextTransform.zoom = zoom;
	        if (pitch !== undefined)
	            nextTransform.pitch = pitch;
	        if (bearing !== undefined)
	            nextTransform.bearing = bearing;
	        if (elevation !== undefined)
	            nextTransform.elevation = elevation;
	        this.transform.apply(nextTransform);
	    }
	    _fireMoveEvents(eventData) {
	        this.fire(new performance$1.Event('move', eventData));
	        if (this._zooming) {
	            this.fire(new performance$1.Event('zoom', eventData));
	        }
	        if (this._rotating) {
	            this.fire(new performance$1.Event('rotate', eventData));
	        }
	        if (this._pitching) {
	            this.fire(new performance$1.Event('pitch', eventData));
	        }
	    }
	    _afterEase(eventData, easeId) {
	        // if this easing is being stopped to start another easing with
	        // the same id then don't fire any events to avoid extra start/stop events
	        if (this._easeId && easeId && this._easeId === easeId) {
	            return;
	        }
	        delete this._easeId;
	        this.fire(new performance$1.Event('freezeElevation', { freeze: false }));
	        const wasZooming = this._zooming;
	        const wasRotating = this._rotating;
	        const wasPitching = this._pitching;
	        this._moving = false;
	        this._zooming = false;
	        this._rotating = false;
	        this._pitching = false;
	        this._padding = false;
	        if (wasZooming) {
	            this.fire(new performance$1.Event('zoomend', eventData));
	        }
	        if (wasRotating) {
	            this.fire(new performance$1.Event('rotateend', eventData));
	        }
	        if (wasPitching) {
	            this.fire(new performance$1.Event('pitchend', eventData));
	        }
	        this.fire(new performance$1.Event('moveend', eventData));
	    }
	    /**
	     * Changes any combination of center, zoom, bearing, and pitch, animating the transition along a curve that
	     * evokes flight. The animation seamlessly incorporates zooming and panning to help
	     * the user maintain her bearings even after traversing a great distance.
	     *
	     * Note: The animation will be skipped, and this will behave equivalently to `jumpTo`
	     * if the user has the `reduced motion` accessibility feature enabled in their operating system,
	     * unless 'options' includes `essential: true`.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, `zoomstart`, `zoom`, `zoomend`, `pitchstart`,
	     * `pitch`, `pitchend`, and `rotate`.
	     *
	     * @param options - Options describing the destination and animation of the transition.
	     * Accepts {@link CameraOptions}, {@link AnimationOptions},
	     * and the following additional options.
	     * @param eventData - Additional properties to be added to event objects of events triggered by this method.
	     * @returns `this`
	     * @example
	     * ```ts
	     * // fly with default options to null island
	     * map.flyTo({center: [0, 0], zoom: 9});
	     * // using flyTo options
	     * map.flyTo({
	     *   center: [0, 0],
	     *   zoom: 9,
	     *   speed: 0.2,
	     *   curve: 1,
	     *   easing(t) {
	     *     return t;
	     *   }
	     * });
	     * ```
	     * @see [Fly to a location](https://maplibre.org/maplibre-gl-js/docs/examples/flyto/)
	     * @see [Slowly fly to a location](https://maplibre.org/maplibre-gl-js/docs/examples/flyto-options/)
	     * @see [Fly to a location based on scroll position](https://maplibre.org/maplibre-gl-js/docs/examples/scroll-fly-to/)
	     */
	    flyTo(options, eventData) {
	        var _a;
	        // Fall through to jumpTo if user has set prefers-reduced-motion
	        if (!options.essential && browser.prefersReducedMotion) {
	            const coercedOptions = performance$1.pick(options, ['center', 'zoom', 'bearing', 'pitch', 'around']);
	            return this.jumpTo(coercedOptions, eventData);
	        }
	        // This method implements an “optimal path” animation, as detailed in:
	        //
	        // Van Wijk, Jarke J.; Nuij, Wim A. A. “Smooth and efficient zooming and panning.” INFOVIS
	        //   ’03. pp. 15–22. <https://www.win.tue.nl/~vanwijk/zoompan.pdf#page=5>.
	        //
	        // Where applicable, local variable documentation begins with the associated variable or
	        // function in van Wijk (2003).
	        this.stop();
	        options = performance$1.extend({
	            offset: [0, 0],
	            speed: 1.2,
	            curve: 1.42,
	            easing: performance$1.defaultEasing
	        }, options);
	        const tr = this._getTransformForUpdate(), startZoom = this.getZoom(), startBearing = this.getBearing(), startPitch = this.getPitch(), startPadding = this.getPadding();
	        const bearing = 'bearing' in options ? this._normalizeBearing(options.bearing, startBearing) : startBearing;
	        const pitch = 'pitch' in options ? +options.pitch : startPitch;
	        const padding = 'padding' in options ? options.padding : tr.padding;
	        const offsetAsPoint = performance$1.Point.convert(options.offset);
	        let pointAtOffset = tr.centerPoint.add(offsetAsPoint);
	        const locationAtOffset = tr.pointLocation(pointAtOffset);
	        const { center, zoom } = tr.getConstrained(performance$1.LngLat.convert(options.center || locationAtOffset), (_a = options.zoom) !== null && _a !== void 0 ? _a : startZoom);
	        this._normalizeCenter(center);
	        const scale = tr.zoomScale(zoom - startZoom);
	        const from = tr.project(locationAtOffset);
	        const delta = tr.project(center).sub(from);
	        let rho = options.curve;
	        // w₀: Initial visible span, measured in pixels at the initial scale.
	        const w0 = Math.max(tr.width, tr.height), 
	        // w₁: Final visible span, measured in pixels with respect to the initial scale.
	        w1 = w0 / scale, 
	        // Length of the flight path as projected onto the ground plane, measured in pixels from
	        // the world image origin at the initial scale.
	        u1 = delta.mag();
	        if ('minZoom' in options) {
	            const minZoom = performance$1.clamp(Math.min(options.minZoom, startZoom, zoom), tr.minZoom, tr.maxZoom);
	            // w<sub>m</sub>: Maximum visible span, measured in pixels with respect to the initial
	            // scale.
	            const wMax = w0 / tr.zoomScale(minZoom - startZoom);
	            rho = Math.sqrt(wMax / u1 * 2);
	        }
	        // ρ²
	        const rho2 = rho * rho;
	        /**
	         * rᵢ: Returns the zoom-out factor at one end of the animation.
	         *
	         * @param descent - `true` for the descent, `false` for the ascent
	         */
	        function zoomOutFactor(descent) {
	            const b = (w1 * w1 - w0 * w0 + (descent ? -1 : 1) * rho2 * rho2 * u1 * u1) / (2 * (descent ? w1 : w0) * rho2 * u1);
	            return Math.log(Math.sqrt(b * b + 1) - b);
	        }
	        function sinh(n) { return (Math.exp(n) - Math.exp(-n)) / 2; }
	        function cosh(n) { return (Math.exp(n) + Math.exp(-n)) / 2; }
	        function tanh(n) { return sinh(n) / cosh(n); }
	        // r₀: Zoom-out factor during ascent.
	        const r0 = zoomOutFactor(false);
	        // w(s): Returns the visible span on the ground, measured in pixels with respect to the
	        // initial scale. Assumes an angular field of view of 2 arctan ½ ≈ 53°.
	        let w = function (s) {
	            return (cosh(r0) / cosh(r0 + rho * s));
	        };
	        // u(s): Returns the distance along the flight path as projected onto the ground plane,
	        // measured in pixels from the world image origin at the initial scale.
	        let u = function (s) {
	            return w0 * ((cosh(r0) * tanh(r0 + rho * s) - sinh(r0)) / rho2) / u1;
	        };
	        // S: Total length of the flight path, measured in ρ-screenfuls.
	        let S = (zoomOutFactor(true) - r0) / rho;
	        // When u₀ = u₁, the optimal path doesn’t require both ascent and descent.
	        if (Math.abs(u1) < 0.000001 || !isFinite(S)) {
	            // Perform a more or less instantaneous transition if the path is too short.
	            if (Math.abs(w0 - w1) < 0.000001)
	                return this.easeTo(options, eventData);
	            const k = w1 < w0 ? -1 : 1;
	            S = Math.abs(Math.log(w1 / w0)) / rho;
	            u = function () { return 0; };
	            w = function (s) { return Math.exp(k * rho * s); };
	        }
	        if ('duration' in options) {
	            options.duration = +options.duration;
	        }
	        else {
	            const V = 'screenSpeed' in options ? +options.screenSpeed / rho : +options.speed;
	            options.duration = 1000 * S / V;
	        }
	        if (options.maxDuration && options.duration > options.maxDuration) {
	            options.duration = 0;
	        }
	        this._zooming = true;
	        this._rotating = (startBearing !== bearing);
	        this._pitching = (pitch !== startPitch);
	        this._padding = !tr.isPaddingEqual(padding);
	        this._prepareEase(eventData, false);
	        if (this.terrain)
	            this._prepareElevation(center);
	        this._ease((k) => {
	            // s: The distance traveled along the flight path, measured in ρ-screenfuls.
	            const s = k * S;
	            const scale = 1 / w(s);
	            tr.zoom = k === 1 ? zoom : startZoom + tr.scaleZoom(scale);
	            if (this._rotating) {
	                tr.bearing = performance$1.interpolate.number(startBearing, bearing, k);
	            }
	            if (this._pitching) {
	                tr.pitch = performance$1.interpolate.number(startPitch, pitch, k);
	            }
	            if (this._padding) {
	                tr.interpolatePadding(startPadding, padding, k);
	                // When padding is being applied, Transform#centerPoint is changing continuously,
	                // thus we need to recalculate offsetPoint every frame
	                pointAtOffset = tr.centerPoint.add(offsetAsPoint);
	            }
	            if (this.terrain && !options.freezeElevation)
	                this._updateElevation(k);
	            const newCenter = k === 1 ? center : tr.unproject(from.add(delta.mult(u(s))).mult(scale));
	            tr.setLocationAtPoint(tr.renderWorldCopies ? newCenter.wrap() : newCenter, pointAtOffset);
	            this._applyUpdatedTransform(tr);
	            this._fireMoveEvents(eventData);
	        }, () => {
	            if (this.terrain)
	                this._finalizeElevation();
	            this._afterEase(eventData);
	        }, options);
	        return this;
	    }
	    isEasing() {
	        return !!this._easeFrameId;
	    }
	    /**
	     * Stops any animated transition underway.
	     *
	     * @returns `this`
	     */
	    stop() {
	        return this._stop();
	    }
	    _stop(allowGestures, easeId) {
	        if (this._easeFrameId) {
	            this._cancelRenderFrame(this._easeFrameId);
	            delete this._easeFrameId;
	            delete this._onEaseFrame;
	        }
	        if (this._onEaseEnd) {
	            // The _onEaseEnd function might emit events which trigger new
	            // animation, which sets a new _onEaseEnd. Ensure we don't delete
	            // it unintentionally.
	            const onEaseEnd = this._onEaseEnd;
	            delete this._onEaseEnd;
	            onEaseEnd.call(this, easeId);
	        }
	        if (!allowGestures) {
	            const handlers = this.handlers;
	            if (handlers)
	                handlers.stop(false);
	        }
	        return this;
	    }
	    _ease(frame, finish, options) {
	        if (options.animate === false || options.duration === 0) {
	            frame(1);
	            finish();
	        }
	        else {
	            this._easeStart = browser.now();
	            this._easeOptions = options;
	            this._onEaseFrame = frame;
	            this._onEaseEnd = finish;
	            this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback);
	        }
	    }
	    // convert bearing so that it's numerically close to the current one so that it interpolates properly
	    _normalizeBearing(bearing, currentBearing) {
	        bearing = performance$1.wrap(bearing, -180, 180);
	        const diff = Math.abs(bearing - currentBearing);
	        if (Math.abs(bearing - 360 - currentBearing) < diff)
	            bearing -= 360;
	        if (Math.abs(bearing + 360 - currentBearing) < diff)
	            bearing += 360;
	        return bearing;
	    }
	    // If a path crossing the antimeridian would be shorter, extend the final coordinate so that
	    // interpolating between the two endpoints will cross it.
	    _normalizeCenter(center) {
	        const tr = this.transform;
	        if (!tr.renderWorldCopies || tr.lngRange)
	            return;
	        const delta = center.lng - tr.center.lng;
	        center.lng +=
	            delta > 180 ? -360 :
	                delta < -180 ? 360 : 0;
	    }
	    /**
	     * Get the elevation difference between a given point
	     * and a point that is currently in the middle of the screen.
	     * This method should be used for proper positioning of custom 3d objects, as explained [here](https://maplibre.org/maplibre-gl-js/docs/examples/add-3d-model-with-terrain/)
	     * Returns null if terrain is not enabled.
	     * This method is subject to change in Maplibre GL JS v5.
	     * @param lngLatLike - [x,y] or LngLat coordinates of the location
	     * @returns elevation offset in meters
	     */
	    queryTerrainElevation(lngLatLike) {
	        if (!this.terrain) {
	            return null;
	        }
	        const elevation = this.terrain.getElevationForLngLatZoom(performance$1.LngLat.convert(lngLatLike), this.transform.tileZoom);
	        return elevation - this.transform.elevation;
	    }
	}

	const defaultAtributionControlOptions = {
	    compact: true,
	    customAttribution: '<a href="https://maplibre.org/" target="_blank">MapLibre</a>'
	};
	/**
	 * An `AttributionControl` control presents the map's attribution information. By default, the attribution control is expanded (regardless of map width).
	 * @group Markers and Controls
	 * @example
	 * ```ts
	 * let map = new Map({attributionControl: false})
	 *     .addControl(new AttributionControl({
	 *         compact: true
	 *     }));
	 * ```
	 */
	class AttributionControl {
	    /**
	     * @param options - the attribution options
	     */
	    constructor(options = defaultAtributionControlOptions) {
	        this._toggleAttribution = () => {
	            if (this._container.classList.contains('maplibregl-compact')) {
	                if (this._container.classList.contains('maplibregl-compact-show')) {
	                    this._container.setAttribute('open', '');
	                    this._container.classList.remove('maplibregl-compact-show');
	                }
	                else {
	                    this._container.classList.add('maplibregl-compact-show');
	                    this._container.removeAttribute('open');
	                }
	            }
	        };
	        this._updateData = (e) => {
	            if (e && (e.sourceDataType === 'metadata' || e.sourceDataType === 'visibility' || e.dataType === 'style' || e.type === 'terrain')) {
	                this._updateAttributions();
	            }
	        };
	        this._updateCompact = () => {
	            if (this._map.getCanvasContainer().offsetWidth <= 640 || this._compact) {
	                if (this._compact === false) {
	                    this._container.setAttribute('open', '');
	                }
	                else if (!this._container.classList.contains('maplibregl-compact') && !this._container.classList.contains('maplibregl-attrib-empty')) {
	                    this._container.setAttribute('open', '');
	                    this._container.classList.add('maplibregl-compact', 'maplibregl-compact-show');
	                }
	            }
	            else {
	                this._container.setAttribute('open', '');
	                if (this._container.classList.contains('maplibregl-compact')) {
	                    this._container.classList.remove('maplibregl-compact', 'maplibregl-compact-show');
	                }
	            }
	        };
	        this._updateCompactMinimize = () => {
	            if (this._container.classList.contains('maplibregl-compact')) {
	                if (this._container.classList.contains('maplibregl-compact-show')) {
	                    this._container.classList.remove('maplibregl-compact-show');
	                }
	            }
	        };
	        this.options = options;
	    }
	    getDefaultPosition() {
	        return 'bottom-right';
	    }
	    /** {@inheritDoc IControl.onAdd} */
	    onAdd(map) {
	        this._map = map;
	        this._compact = this.options.compact;
	        this._container = DOM.create('details', 'maplibregl-ctrl maplibregl-ctrl-attrib');
	        this._compactButton = DOM.create('summary', 'maplibregl-ctrl-attrib-button', this._container);
	        this._compactButton.addEventListener('click', this._toggleAttribution);
	        this._setElementTitle(this._compactButton, 'ToggleAttribution');
	        this._innerContainer = DOM.create('div', 'maplibregl-ctrl-attrib-inner', this._container);
	        this._updateAttributions();
	        this._updateCompact();
	        this._map.on('styledata', this._updateData);
	        this._map.on('sourcedata', this._updateData);
	        this._map.on('terrain', this._updateData);
	        this._map.on('resize', this._updateCompact);
	        this._map.on('drag', this._updateCompactMinimize);
	        return this._container;
	    }
	    /** {@inheritDoc IControl.onRemove} */
	    onRemove() {
	        DOM.remove(this._container);
	        this._map.off('styledata', this._updateData);
	        this._map.off('sourcedata', this._updateData);
	        this._map.off('terrain', this._updateData);
	        this._map.off('resize', this._updateCompact);
	        this._map.off('drag', this._updateCompactMinimize);
	        this._map = undefined;
	        this._compact = undefined;
	        this._attribHTML = undefined;
	    }
	    _setElementTitle(element, title) {
	        const str = this._map._getUIString(`AttributionControl.${title}`);
	        element.title = str;
	        element.setAttribute('aria-label', str);
	    }
	    _updateAttributions() {
	        if (!this._map.style)
	            return;
	        let attributions = [];
	        if (this.options.customAttribution) {
	            if (Array.isArray(this.options.customAttribution)) {
	                attributions = attributions.concat(this.options.customAttribution.map(attribution => {
	                    if (typeof attribution !== 'string')
	                        return '';
	                    return attribution;
	                }));
	            }
	            else if (typeof this.options.customAttribution === 'string') {
	                attributions.push(this.options.customAttribution);
	            }
	        }
	        if (this._map.style.stylesheet) {
	            const stylesheet = this._map.style.stylesheet;
	            this.styleOwner = stylesheet.owner;
	            this.styleId = stylesheet.id;
	        }
	        const sourceCaches = this._map.style.sourceCaches;
	        for (const id in sourceCaches) {
	            const sourceCache = sourceCaches[id];
	            if (sourceCache.used || sourceCache.usedForTerrain) {
	                const source = sourceCache.getSource();
	                if (source.attribution && attributions.indexOf(source.attribution) < 0) {
	                    attributions.push(source.attribution);
	                }
	            }
	        }
	        // remove any entries that are whitespace
	        attributions = attributions.filter(e => String(e).trim());
	        // remove any entries that are substrings of another entry.
	        // first sort by length so that substrings come first
	        attributions.sort((a, b) => a.length - b.length);
	        attributions = attributions.filter((attrib, i) => {
	            for (let j = i + 1; j < attributions.length; j++) {
	                if (attributions[j].indexOf(attrib) >= 0) {
	                    return false;
	                }
	            }
	            return true;
	        });
	        // check if attribution string is different to minimize DOM changes
	        const attribHTML = attributions.join(' | ');
	        if (attribHTML === this._attribHTML)
	            return;
	        this._attribHTML = attribHTML;
	        if (attributions.length) {
	            this._innerContainer.innerHTML = attribHTML;
	            this._container.classList.remove('maplibregl-attrib-empty');
	        }
	        else {
	            this._container.classList.add('maplibregl-attrib-empty');
	        }
	        this._updateCompact();
	        // remove old DOM node from _editLink
	        this._editLink = null;
	    }
	}

	/**
	 * A `LogoControl` is a control that adds the watermark.
	 *
	 * @group Markers and Controls
	 *
	 * @example
	 * ```ts
	 * map.addControl(new LogoControl({compact: false}));
	 * ```
	 **/
	class LogoControl {
	    constructor(options = {}) {
	        this._updateCompact = () => {
	            const containerChildren = this._container.children;
	            if (containerChildren.length) {
	                const anchor = containerChildren[0];
	                if (this._map.getCanvasContainer().offsetWidth <= 640 || this._compact) {
	                    if (this._compact !== false) {
	                        anchor.classList.add('maplibregl-compact');
	                    }
	                }
	                else {
	                    anchor.classList.remove('maplibregl-compact');
	                }
	            }
	        };
	        this.options = options;
	    }
	    getDefaultPosition() {
	        return 'bottom-left';
	    }
	    /** {@inheritDoc IControl.onAdd} */
	    onAdd(map) {
	        this._map = map;
	        this._compact = this.options && this.options.compact;
	        this._container = DOM.create('div', 'maplibregl-ctrl');
	        const anchor = DOM.create('a', 'maplibregl-ctrl-logo');
	        anchor.target = '_blank';
	        anchor.rel = 'noopener nofollow';
	        anchor.href = 'https://maplibre.org/';
	        anchor.setAttribute('aria-label', this._map._getUIString('LogoControl.Title'));
	        anchor.setAttribute('rel', 'noopener nofollow');
	        this._container.appendChild(anchor);
	        this._container.style.display = 'block';
	        this._map.on('resize', this._updateCompact);
	        this._updateCompact();
	        return this._container;
	    }
	    /** {@inheritDoc IControl.onRemove} */
	    onRemove() {
	        DOM.remove(this._container);
	        this._map.off('resize', this._updateCompact);
	        this._map = undefined;
	        this._compact = undefined;
	    }
	}

	class TaskQueue {
	    constructor() {
	        this._queue = [];
	        this._id = 0;
	        this._cleared = false;
	        this._currentlyRunning = false;
	    }
	    add(callback) {
	        const id = ++this._id;
	        const queue = this._queue;
	        queue.push({ callback, id, cancelled: false });
	        return id;
	    }
	    remove(id) {
	        const running = this._currentlyRunning;
	        const queue = running ? this._queue.concat(running) : this._queue;
	        for (const task of queue) {
	            if (task.id === id) {
	                task.cancelled = true;
	                return;
	            }
	        }
	    }
	    run(timeStamp = 0) {
	        if (this._currentlyRunning)
	            throw new Error('Attempting to run(), but is already running.');
	        const queue = this._currentlyRunning = this._queue;
	        // Tasks queued by callbacks in the current queue should be executed
	        // on the next run, not the current run.
	        this._queue = [];
	        for (const task of queue) {
	            if (task.cancelled)
	                continue;
	            task.callback(timeStamp);
	            if (this._cleared)
	                break;
	        }
	        this._cleared = false;
	        this._currentlyRunning = false;
	    }
	    clear() {
	        if (this._currentlyRunning) {
	            this._cleared = true;
	        }
	        this._queue = [];
	    }
	}

	var pos3dAttributes = performance$1.createLayout([
	    { name: 'a_pos3d', type: 'Int16', components: 3 }
	]);

	/**
	 * @internal
	 * This class is a helper for the Terrain-class, it:
	 *   - loads raster-dem tiles
	 *   - manages all renderToTexture tiles.
	 *   - caches previous rendered tiles.
	 *   - finds all necessary renderToTexture tiles for a OverscaledTileID area
	 *   - finds the corresponding raster-dem tile for OverscaledTileID
	 */
	class TerrainSourceCache extends performance$1.Evented {
	    constructor(sourceCache) {
	        super();
	        this.sourceCache = sourceCache;
	        this._tiles = {};
	        this._renderableTilesKeys = [];
	        this._sourceTileCache = {};
	        this.minzoom = 0;
	        this.maxzoom = 22;
	        this.tileSize = 512;
	        this.deltaZoom = 1;
	        sourceCache.usedForTerrain = true;
	        sourceCache.tileSize = this.tileSize * 2 ** this.deltaZoom;
	    }
	    destruct() {
	        this.sourceCache.usedForTerrain = false;
	        this.sourceCache.tileSize = null;
	    }
	    /**
	     * Load Terrain Tiles, create internal render-to-texture tiles, free GPU memory.
	     * @param transform - the operation to do
	     * @param terrain - the terrain
	     */
	    update(transform, terrain) {
	        // load raster-dem tiles for the current scene.
	        this.sourceCache.update(transform, terrain);
	        // create internal render-to-texture tiles for the current scene.
	        this._renderableTilesKeys = [];
	        const keys = {};
	        for (const tileID of transform.coveringTiles({
	            tileSize: this.tileSize,
	            minzoom: this.minzoom,
	            maxzoom: this.maxzoom,
	            reparseOverscaled: false,
	            terrain
	        })) {
	            keys[tileID.key] = true;
	            this._renderableTilesKeys.push(tileID.key);
	            if (!this._tiles[tileID.key]) {
	                tileID.posMatrix = new Float64Array(16);
	                performance$1.ortho(tileID.posMatrix, 0, performance$1.EXTENT, 0, performance$1.EXTENT, 0, 1);
	                this._tiles[tileID.key] = new Tile(tileID, this.tileSize);
	            }
	        }
	        // free unused tiles
	        for (const key in this._tiles) {
	            if (!keys[key])
	                delete this._tiles[key];
	        }
	    }
	    /**
	     * Free render to texture cache
	     * @param tileID - optional, free only corresponding to tileID.
	     */
	    freeRtt(tileID) {
	        for (const key in this._tiles) {
	            const tile = this._tiles[key];
	            if (!tileID || tile.tileID.equals(tileID) || tile.tileID.isChildOf(tileID) || tileID.isChildOf(tile.tileID))
	                tile.rtt = [];
	        }
	    }
	    /**
	     * get a list of tiles, which are loaded and should be rendered in the current scene
	     * @returns the renderable tiles
	     */
	    getRenderableTiles() {
	        return this._renderableTilesKeys.map(key => this.getTileByID(key));
	    }
	    /**
	     * get terrain tile by the TileID key
	     * @param id - the tile id
	     * @returns the tile
	     */
	    getTileByID(id) {
	        return this._tiles[id];
	    }
	    /**
	     * Searches for the corresponding current renderable terrain-tiles
	     * @param tileID - the tile to look for
	     * @returns the tiles that were found
	     */
	    getTerrainCoords(tileID) {
	        const coords = {};
	        for (const key of this._renderableTilesKeys) {
	            const _tileID = this._tiles[key].tileID;
	            if (_tileID.canonical.equals(tileID.canonical)) {
	                const coord = tileID.clone();
	                coord.posMatrix = new Float64Array(16);
	                performance$1.ortho(coord.posMatrix, 0, performance$1.EXTENT, 0, performance$1.EXTENT, 0, 1);
	                coords[key] = coord;
	            }
	            else if (_tileID.canonical.isChildOf(tileID.canonical)) {
	                const coord = tileID.clone();
	                coord.posMatrix = new Float64Array(16);
	                const dz = _tileID.canonical.z - tileID.canonical.z;
	                const dx = _tileID.canonical.x - (_tileID.canonical.x >> dz << dz);
	                const dy = _tileID.canonical.y - (_tileID.canonical.y >> dz << dz);
	                const size = performance$1.EXTENT >> dz;
	                performance$1.ortho(coord.posMatrix, 0, size, 0, size, 0, 1);
	                performance$1.translate(coord.posMatrix, coord.posMatrix, [-dx * size, -dy * size, 0]);
	                coords[key] = coord;
	            }
	            else if (tileID.canonical.isChildOf(_tileID.canonical)) {
	                const coord = tileID.clone();
	                coord.posMatrix = new Float64Array(16);
	                const dz = tileID.canonical.z - _tileID.canonical.z;
	                const dx = tileID.canonical.x - (tileID.canonical.x >> dz << dz);
	                const dy = tileID.canonical.y - (tileID.canonical.y >> dz << dz);
	                const size = performance$1.EXTENT >> dz;
	                performance$1.ortho(coord.posMatrix, 0, performance$1.EXTENT, 0, performance$1.EXTENT, 0, 1);
	                performance$1.translate(coord.posMatrix, coord.posMatrix, [dx * size, dy * size, 0]);
	                performance$1.scale(coord.posMatrix, coord.posMatrix, [1 / (2 ** dz), 1 / (2 ** dz), 0]);
	                coords[key] = coord;
	            }
	        }
	        return coords;
	    }
	    /**
	     * find the covering raster-dem tile
	     * @param tileID - the tile to look for
	     * @param searchForDEM - Optinal parameter to search for (parent) souretiles with loaded dem.
	     * @returns the tile
	     */
	    getSourceTile(tileID, searchForDEM) {
	        const source = this.sourceCache._source;
	        let z = tileID.overscaledZ - this.deltaZoom;
	        if (z > source.maxzoom)
	            z = source.maxzoom;
	        if (z < source.minzoom)
	            return null;
	        // cache for tileID to terrain-tileID
	        if (!this._sourceTileCache[tileID.key])
	            this._sourceTileCache[tileID.key] = tileID.scaledTo(z).key;
	        let tile = this.sourceCache.getTileByID(this._sourceTileCache[tileID.key]);
	        // during tile-loading phase look if parent tiles (with loaded dem) are available.
	        if (!(tile && tile.dem) && searchForDEM)
	            while (z >= source.minzoom && !(tile && tile.dem))
	                tile = this.sourceCache.getTileByID(tileID.scaledTo(z--).key);
	        return tile;
	    }
	    /**
	     * get a list of tiles, loaded after a specific time. This is used to update depth & coords framebuffers.
	     * @param time - the time
	     * @returns the relevant tiles
	     */
	    tilesAfterTime(time = Date.now()) {
	        return Object.values(this._tiles).filter(t => t.timeAdded >= time);
	    }
	}

	/**
	 * @internal
	 * This is the main class which handles most of the 3D Terrain logic. It has the following topics:
	 *    1) loads raster-dem tiles via the internal sourceCache this.sourceCache
	 *    2) creates a depth-framebuffer, which is used to calculate the visibility of coordinates
	 *    3) creates a coords-framebuffer, which is used the get to tile-coordinate for a screen-pixel
	 *    4) stores all render-to-texture tiles in the this.sourceCache._tiles
	 *    5) calculates the elevation for a specific tile-coordinate
	 *    6) creates a terrain-mesh
	 *
	 *    A note about the GPU resource-usage:
	 *    Framebuffers:
	 *       - one for the depth & coords framebuffer with the size of the map-div.
	 *       - one for rendering a tile to texture with the size of tileSize (= 512x512).
	 *    Textures:
	 *       - one texture for an empty raster-dem tile with size 1x1
	 *       - one texture for an empty depth-buffer, when terrain is disabled with size 1x1
	 *       - one texture for an each loaded raster-dem with size of the source.tileSize
	 *       - one texture for the coords-framebuffer with the size of the map-div.
	 *       - one texture for the depth-framebuffer with the size of the map-div.
	 *       - one texture for the encoded tile-coords with the size 2*tileSize (=1024x1024)
	 *       - finally for each render-to-texture tile (= this._tiles) a set of textures
	 *         for each render stack (The stack-concept is documented in painter.ts).
	 *         Normally there exists 1-3 Textures per tile, depending on the stylesheet.
	 *         Each Textures has the size 2*tileSize (= 1024x1024). Also there exists a
	 *         cache of the last 150 newest rendered tiles.
	 *
	 */
	class Terrain {
	    constructor(painter, sourceCache, options) {
	        this.painter = painter;
	        this.sourceCache = new TerrainSourceCache(sourceCache);
	        this.options = options;
	        this.exaggeration = typeof options.exaggeration === 'number' ? options.exaggeration : 1.0;
	        this.qualityFactor = 2;
	        this.meshSize = 128;
	        this._demMatrixCache = {};
	        this.coordsIndex = [];
	        this._coordsTextureSize = 1024;
	    }
	    /**
	     * get the elevation-value from original dem-data for a given tile-coordinate
	     * @param tileID - the tile to get elevation for
	     * @param x - between 0 .. EXTENT
	     * @param y - between 0 .. EXTENT
	     * @param extent - optional, default 8192
	     * @returns the elevation
	     */
	    getDEMElevation(tileID, x, y, extent = performance$1.EXTENT) {
	        var _a;
	        if (!(x >= 0 && x < extent && y >= 0 && y < extent))
	            return 0;
	        const terrain = this.getTerrainData(tileID);
	        const dem = (_a = terrain.tile) === null || _a === void 0 ? void 0 : _a.dem;
	        if (!dem)
	            return 0;
	        const pos = performance$1.transformMat4$1([], [x / extent * performance$1.EXTENT, y / extent * performance$1.EXTENT], terrain.u_terrain_matrix);
	        const coord = [pos[0] * dem.dim, pos[1] * dem.dim];
	        // bilinear interpolation
	        const cx = Math.floor(coord[0]), cy = Math.floor(coord[1]), tx = coord[0] - cx, ty = coord[1] - cy;
	        return (dem.get(cx, cy) * (1 - tx) * (1 - ty) +
	            dem.get(cx + 1, cy) * (tx) * (1 - ty) +
	            dem.get(cx, cy + 1) * (1 - tx) * (ty) +
	            dem.get(cx + 1, cy + 1) * (tx) * (ty));
	    }
	    /**
	     * Get the elevation for given {@link LngLat} in respect of exaggeration.
	     * @param lnglat - the location
	     * @param zoom - the zoom
	     * @returns the elevation
	     */
	    getElevationForLngLatZoom(lnglat, zoom) {
	        const { tileID, mercatorX, mercatorY } = this._getOverscaledTileIDFromLngLatZoom(lnglat, zoom);
	        return this.getElevation(tileID, mercatorX % performance$1.EXTENT, mercatorY % performance$1.EXTENT, performance$1.EXTENT);
	    }
	    /**
	     * Get the elevation for given coordinate in respect of exaggeration.
	     * @param tileID - the tile id
	     * @param x - between 0 .. EXTENT
	     * @param y - between 0 .. EXTENT
	     * @param extent - optional, default 8192
	     * @returns the elevation
	     */
	    getElevation(tileID, x, y, extent = performance$1.EXTENT) {
	        return this.getDEMElevation(tileID, x, y, extent) * this.exaggeration;
	    }
	    /**
	     * returns a Terrain Object for a tile. Unless the tile corresponds to data (e.g. tile is loading), return a flat dem object
	     * @param tileID - the tile to get the terrain for
	     * @returns the terrain data to use in the program
	     */
	    getTerrainData(tileID) {
	        // create empty DEM Objects, which will used while raster-dem tiles are loading.
	        // creates an empty depth-buffer texture which is needed, during the initialization process of the 3d mesh..
	        if (!this._emptyDemTexture) {
	            const context = this.painter.context;
	            const image = new performance$1.RGBAImage({ width: 1, height: 1 }, new Uint8Array(1 * 4));
	            this._emptyDepthTexture = new Texture(context, image, context.gl.RGBA, { premultiply: false });
	            this._emptyDemUnpack = [0, 0, 0, 0];
	            this._emptyDemTexture = new Texture(context, new performance$1.RGBAImage({ width: 1, height: 1 }), context.gl.RGBA, { premultiply: false });
	            this._emptyDemTexture.bind(context.gl.NEAREST, context.gl.CLAMP_TO_EDGE);
	            this._emptyDemMatrix = performance$1.identity([]);
	        }
	        // find covering dem tile and prepare demTexture
	        const sourceTile = this.sourceCache.getSourceTile(tileID, true);
	        if (sourceTile && sourceTile.dem && (!sourceTile.demTexture || sourceTile.needsTerrainPrepare)) {
	            const context = this.painter.context;
	            sourceTile.demTexture = this.painter.getTileTexture(sourceTile.dem.stride);
	            if (sourceTile.demTexture)
	                sourceTile.demTexture.update(sourceTile.dem.getPixels(), { premultiply: false });
	            else
	                sourceTile.demTexture = new Texture(context, sourceTile.dem.getPixels(), context.gl.RGBA, { premultiply: false });
	            sourceTile.demTexture.bind(context.gl.NEAREST, context.gl.CLAMP_TO_EDGE);
	            sourceTile.needsTerrainPrepare = false;
	        }
	        // create matrix for lookup in dem data
	        const matrixKey = sourceTile && (sourceTile + sourceTile.tileID.key) + tileID.key;
	        if (matrixKey && !this._demMatrixCache[matrixKey]) {
	            const maxzoom = this.sourceCache.sourceCache._source.maxzoom;
	            let dz = tileID.canonical.z - sourceTile.tileID.canonical.z;
	            if (tileID.overscaledZ > tileID.canonical.z) {
	                if (tileID.canonical.z >= maxzoom)
	                    dz = tileID.canonical.z - maxzoom;
	                else
	                    performance$1.warnOnce('cannot calculate elevation if elevation maxzoom > source.maxzoom');
	            }
	            const dx = tileID.canonical.x - (tileID.canonical.x >> dz << dz);
	            const dy = tileID.canonical.y - (tileID.canonical.y >> dz << dz);
	            const demMatrix = performance$1.fromScaling(new Float64Array(16), [1 / (performance$1.EXTENT << dz), 1 / (performance$1.EXTENT << dz), 0]);
	            performance$1.translate(demMatrix, demMatrix, [dx * performance$1.EXTENT, dy * performance$1.EXTENT, 0]);
	            this._demMatrixCache[tileID.key] = { matrix: demMatrix, coord: tileID };
	        }
	        // return uniform values & textures
	        return {
	            'u_depth': 2,
	            'u_terrain': 3,
	            'u_terrain_dim': sourceTile && sourceTile.dem && sourceTile.dem.dim || 1,
	            'u_terrain_matrix': matrixKey ? this._demMatrixCache[tileID.key].matrix : this._emptyDemMatrix,
	            'u_terrain_unpack': sourceTile && sourceTile.dem && sourceTile.dem.getUnpackVector() || this._emptyDemUnpack,
	            'u_terrain_exaggeration': this.exaggeration,
	            texture: (sourceTile && sourceTile.demTexture || this._emptyDemTexture).texture,
	            depthTexture: (this._fboDepthTexture || this._emptyDepthTexture).texture,
	            tile: sourceTile
	        };
	    }
	    /**
	     * get a framebuffer as big as the map-div, which will be used to render depth & coords into a texture
	     * @param texture - the texture
	     * @returns the frame buffer
	     */
	    getFramebuffer(texture) {
	        const painter = this.painter;
	        const width = painter.width / devicePixelRatio;
	        const height = painter.height / devicePixelRatio;
	        if (this._fbo && (this._fbo.width !== width || this._fbo.height !== height)) {
	            this._fbo.destroy();
	            this._fboCoordsTexture.destroy();
	            this._fboDepthTexture.destroy();
	            delete this._fbo;
	            delete this._fboDepthTexture;
	            delete this._fboCoordsTexture;
	        }
	        if (!this._fboCoordsTexture) {
	            this._fboCoordsTexture = new Texture(painter.context, { width, height, data: null }, painter.context.gl.RGBA, { premultiply: false });
	            this._fboCoordsTexture.bind(painter.context.gl.NEAREST, painter.context.gl.CLAMP_TO_EDGE);
	        }
	        if (!this._fboDepthTexture) {
	            this._fboDepthTexture = new Texture(painter.context, { width, height, data: null }, painter.context.gl.RGBA, { premultiply: false });
	            this._fboDepthTexture.bind(painter.context.gl.NEAREST, painter.context.gl.CLAMP_TO_EDGE);
	        }
	        if (!this._fbo) {
	            this._fbo = painter.context.createFramebuffer(width, height, true, false);
	            this._fbo.depthAttachment.set(painter.context.createRenderbuffer(painter.context.gl.DEPTH_COMPONENT16, width, height));
	        }
	        this._fbo.colorAttachment.set(texture === 'coords' ? this._fboCoordsTexture.texture : this._fboDepthTexture.texture);
	        return this._fbo;
	    }
	    /**
	     * create coords texture, needed to grab coordinates from canvas
	     * encode coords coordinate into 4 bytes:
	     *   - 8 lower bits for x
	     *   - 8 lower bits for y
	     *   - 4 higher bits for x
	     *   - 4 higher bits for y
	     *   - 8 bits for coordsIndex (1 .. 255) (= number of terraintile), is later setted in draw_terrain uniform value
	     * @returns the texture
	     */
	    getCoordsTexture() {
	        const context = this.painter.context;
	        if (this._coordsTexture)
	            return this._coordsTexture;
	        const data = new Uint8Array(this._coordsTextureSize * this._coordsTextureSize * 4);
	        for (let y = 0, i = 0; y < this._coordsTextureSize; y++)
	            for (let x = 0; x < this._coordsTextureSize; x++, i += 4) {
	                data[i + 0] = x & 255;
	                data[i + 1] = y & 255;
	                data[i + 2] = ((x >> 8) << 4) | (y >> 8);
	                data[i + 3] = 0;
	            }
	        const image = new performance$1.RGBAImage({ width: this._coordsTextureSize, height: this._coordsTextureSize }, new Uint8Array(data.buffer));
	        const texture = new Texture(context, image, context.gl.RGBA, { premultiply: false });
	        texture.bind(context.gl.NEAREST, context.gl.CLAMP_TO_EDGE);
	        this._coordsTexture = texture;
	        return texture;
	    }
	    /**
	     * Reads a pixel from the coords-framebuffer and translate this to mercator.
	     * @param p - Screen-Coordinate
	     * @returns mercator coordinate for a screen pixel
	     */
	    pointCoordinate(p) {
	        // First, ensure the coords framebuffer is up to date.
	        this.painter.maybeDrawDepthAndCoords(true);
	        const rgba = new Uint8Array(4);
	        const context = this.painter.context, gl = context.gl;
	        const px = Math.round(p.x * this.painter.pixelRatio / devicePixelRatio);
	        const py = Math.round(p.y * this.painter.pixelRatio / devicePixelRatio);
	        const fbHeight = Math.round(this.painter.height / devicePixelRatio);
	        // grab coordinate pixel from coordinates framebuffer
	        context.bindFramebuffer.set(this.getFramebuffer('coords').framebuffer);
	        gl.readPixels(px, fbHeight - py - 1, 1, 1, gl.RGBA, gl.UNSIGNED_BYTE, rgba);
	        context.bindFramebuffer.set(null);
	        // decode coordinates (encoding see getCoordsTexture)
	        const x = rgba[0] + ((rgba[2] >> 4) << 8);
	        const y = rgba[1] + ((rgba[2] & 15) << 8);
	        const tileID = this.coordsIndex[255 - rgba[3]];
	        const tile = tileID && this.sourceCache.getTileByID(tileID);
	        if (!tile)
	            return null;
	        const coordsSize = this._coordsTextureSize;
	        const worldSize = (1 << tile.tileID.canonical.z) * coordsSize;
	        return new performance$1.MercatorCoordinate((tile.tileID.canonical.x * coordsSize + x) / worldSize + tile.tileID.wrap, (tile.tileID.canonical.y * coordsSize + y) / worldSize, this.getElevation(tile.tileID, x, y, coordsSize));
	    }
	    /**
	     * Reads the depth value from the depth-framebuffer at a given screen pixel
	     * @param p - Screen coordinate
	     * @returns depth value in clip space (between 0 and 1)
	     */
	    depthAtPoint(p) {
	        const rgba = new Uint8Array(4);
	        const context = this.painter.context, gl = context.gl;
	        context.bindFramebuffer.set(this.getFramebuffer('depth').framebuffer);
	        gl.readPixels(p.x, this.painter.height / devicePixelRatio - p.y - 1, 1, 1, gl.RGBA, gl.UNSIGNED_BYTE, rgba);
	        context.bindFramebuffer.set(null);
	        // decode coordinates (encoding see terran_depth.fragment.glsl)
	        const depthValue = (rgba[0] / (256 * 256 * 256) + rgba[1] / (256 * 256) + rgba[2] / 256 + rgba[3]) / 256;
	        return depthValue;
	    }
	    /**
	     * create a regular mesh which will be used by all terrain-tiles
	     * @returns the created regular mesh
	     */
	    getTerrainMesh() {
	        if (this._mesh)
	            return this._mesh;
	        const context = this.painter.context;
	        const vertexArray = new performance$1.Pos3dArray();
	        const indexArray = new performance$1.TriangleIndexArray();
	        const meshSize = this.meshSize;
	        const delta = performance$1.EXTENT / meshSize;
	        const meshSize2 = meshSize * meshSize;
	        for (let y = 0; y <= meshSize; y++)
	            for (let x = 0; x <= meshSize; x++)
	                vertexArray.emplaceBack(x * delta, y * delta, 0);
	        for (let y = 0; y < meshSize2; y += meshSize + 1)
	            for (let x = 0; x < meshSize; x++) {
	                indexArray.emplaceBack(x + y, meshSize + x + y + 1, meshSize + x + y + 2);
	                indexArray.emplaceBack(x + y, meshSize + x + y + 2, x + y + 1);
	            }
	        // add an extra frame around the mesh to avoid stiching on tile boundaries with different zoomlevels
	        // first code-block is for top-bottom frame and second for left-right frame
	        const offsetTop = vertexArray.length, offsetBottom = offsetTop + (meshSize + 1) * 2;
	        for (const y of [0, 1])
	            for (let x = 0; x <= meshSize; x++)
	                for (const z of [0, 1])
	                    vertexArray.emplaceBack(x * delta, y * performance$1.EXTENT, z);
	        for (let x = 0; x < meshSize * 2; x += 2) {
	            indexArray.emplaceBack(offsetBottom + x, offsetBottom + x + 1, offsetBottom + x + 3);
	            indexArray.emplaceBack(offsetBottom + x, offsetBottom + x + 3, offsetBottom + x + 2);
	            indexArray.emplaceBack(offsetTop + x, offsetTop + x + 3, offsetTop + x + 1);
	            indexArray.emplaceBack(offsetTop + x, offsetTop + x + 2, offsetTop + x + 3);
	        }
	        const offsetLeft = vertexArray.length, offsetRight = offsetLeft + (meshSize + 1) * 2;
	        for (const x of [0, 1])
	            for (let y = 0; y <= meshSize; y++)
	                for (const z of [0, 1])
	                    vertexArray.emplaceBack(x * performance$1.EXTENT, y * delta, z);
	        for (let y = 0; y < meshSize * 2; y += 2) {
	            indexArray.emplaceBack(offsetLeft + y, offsetLeft + y + 1, offsetLeft + y + 3);
	            indexArray.emplaceBack(offsetLeft + y, offsetLeft + y + 3, offsetLeft + y + 2);
	            indexArray.emplaceBack(offsetRight + y, offsetRight + y + 3, offsetRight + y + 1);
	            indexArray.emplaceBack(offsetRight + y, offsetRight + y + 2, offsetRight + y + 3);
	        }
	        this._mesh = {
	            indexBuffer: context.createIndexBuffer(indexArray),
	            vertexBuffer: context.createVertexBuffer(vertexArray, pos3dAttributes.members),
	            segments: performance$1.SegmentVector.simpleSegment(0, 0, vertexArray.length, indexArray.length)
	        };
	        return this._mesh;
	    }
	    /**
	     * Calculates a height of the frame around the terrain-mesh to avoid stiching between
	     * tile boundaries in different zoomlevels.
	     * @param zoom - current zoomlevel
	     * @returns the elevation delta in meters
	     */
	    getMeshFrameDelta(zoom) {
	        // divide by 5 is evaluated by trial & error to get a frame in the right height
	        return 2 * Math.PI * performance$1.earthRadius / Math.pow(2, zoom) / 5;
	    }
	    getMinTileElevationForLngLatZoom(lnglat, zoom) {
	        var _a;
	        const { tileID } = this._getOverscaledTileIDFromLngLatZoom(lnglat, zoom);
	        return (_a = this.getMinMaxElevation(tileID).minElevation) !== null && _a !== void 0 ? _a : 0;
	    }
	    /**
	     * Get the minimum and maximum elevation contained in a tile. This includes any
	     * exaggeration included in the terrain.
	     *
	     * @param tileID - ID of the tile to be used as a source for the min/max elevation
	     * @returns the minimum and maximum elevation found in the tile, including the terrain's
	     * exaggeration
	     */
	    getMinMaxElevation(tileID) {
	        const tile = this.getTerrainData(tileID).tile;
	        const minMax = { minElevation: null, maxElevation: null };
	        if (tile && tile.dem) {
	            minMax.minElevation = tile.dem.min * this.exaggeration;
	            minMax.maxElevation = tile.dem.max * this.exaggeration;
	        }
	        return minMax;
	    }
	    _getOverscaledTileIDFromLngLatZoom(lnglat, zoom) {
	        const mercatorCoordinate = performance$1.MercatorCoordinate.fromLngLat(lnglat.wrap());
	        const worldSize = (1 << zoom) * performance$1.EXTENT;
	        const mercatorX = mercatorCoordinate.x * worldSize;
	        const mercatorY = mercatorCoordinate.y * worldSize;
	        const tileX = Math.floor(mercatorX / performance$1.EXTENT), tileY = Math.floor(mercatorY / performance$1.EXTENT);
	        const tileID = new performance$1.OverscaledTileID(zoom, 0, zoom, tileX, tileY);
	        return {
	            tileID,
	            mercatorX,
	            mercatorY
	        };
	    }
	}

	/**
	 * @internal
	 * `RenderPool` is a resource pool for textures and framebuffers
	 */
	class RenderPool {
	    constructor(_context, _size, _tileSize) {
	        this._context = _context;
	        this._size = _size;
	        this._tileSize = _tileSize;
	        this._objects = [];
	        this._recentlyUsed = [];
	        this._stamp = 0;
	    }
	    destruct() {
	        for (const obj of this._objects) {
	            obj.texture.destroy();
	            obj.fbo.destroy();
	        }
	    }
	    _createObject(id) {
	        const fbo = this._context.createFramebuffer(this._tileSize, this._tileSize, true, true);
	        const texture = new Texture(this._context, { width: this._tileSize, height: this._tileSize, data: null }, this._context.gl.RGBA);
	        texture.bind(this._context.gl.LINEAR, this._context.gl.CLAMP_TO_EDGE);
	        fbo.depthAttachment.set(this._context.createRenderbuffer(this._context.gl.DEPTH_STENCIL, this._tileSize, this._tileSize));
	        fbo.colorAttachment.set(texture.texture);
	        return { id, fbo, texture, stamp: -1, inUse: false };
	    }
	    getObjectForId(id) {
	        return this._objects[id];
	    }
	    useObject(obj) {
	        obj.inUse = true;
	        this._recentlyUsed = this._recentlyUsed.filter(id => obj.id !== id);
	        this._recentlyUsed.push(obj.id);
	    }
	    stampObject(obj) {
	        obj.stamp = ++this._stamp;
	    }
	    getOrCreateFreeObject() {
	        // check for free existing object
	        for (const id of this._recentlyUsed) {
	            if (!this._objects[id].inUse)
	                return this._objects[id];
	        }
	        if (this._objects.length >= this._size)
	            throw new Error('No free RenderPool available, call freeAllObjects() required!');
	        // create new object
	        const obj = this._createObject(this._objects.length);
	        this._objects.push(obj);
	        return obj;
	    }
	    freeObject(obj) {
	        obj.inUse = false;
	    }
	    freeAllObjects() {
	        for (const obj of this._objects)
	            this.freeObject(obj);
	    }
	    isFull() {
	        if (this._objects.length < this._size) {
	            return false;
	        }
	        return this._objects.some(o => !o.inUse) === false;
	    }
	}

	/**
	 * lookup table which layers should rendered to texture
	 */
	const LAYERS = {
	    background: true,
	    fill: true,
	    line: true,
	    raster: true,
	    hillshade: true
	};
	/**
	 * @internal
	 * A helper class to help define what should be rendered to texture and how
	 */
	class RenderToTexture {
	    constructor(painter, terrain) {
	        this.painter = painter;
	        this.terrain = terrain;
	        this.pool = new RenderPool(painter.context, 30, terrain.sourceCache.tileSize * terrain.qualityFactor);
	    }
	    destruct() {
	        this.pool.destruct();
	    }
	    getTexture(tile) {
	        return this.pool.getObjectForId(tile.rtt[this._stacks.length - 1].id).texture;
	    }
	    prepareForRender(style, zoom) {
	        this._stacks = [];
	        this._prevType = null;
	        this._rttTiles = [];
	        this._renderableTiles = this.terrain.sourceCache.getRenderableTiles();
	        this._renderableLayerIds = style._order.filter(id => !style._layers[id].isHidden(zoom));
	        this._coordsDescendingInv = {};
	        for (const id in style.sourceCaches) {
	            this._coordsDescendingInv[id] = {};
	            const tileIDs = style.sourceCaches[id].getVisibleCoordinates();
	            for (const tileID of tileIDs) {
	                const keys = this.terrain.sourceCache.getTerrainCoords(tileID);
	                for (const key in keys) {
	                    if (!this._coordsDescendingInv[id][key])
	                        this._coordsDescendingInv[id][key] = [];
	                    this._coordsDescendingInv[id][key].push(keys[key]);
	                }
	            }
	        }
	        this._coordsDescendingInvStr = {};
	        for (const id of style._order) {
	            const layer = style._layers[id], source = layer.source;
	            if (LAYERS[layer.type]) {
	                if (!this._coordsDescendingInvStr[source]) {
	                    this._coordsDescendingInvStr[source] = {};
	                    for (const key in this._coordsDescendingInv[source])
	                        this._coordsDescendingInvStr[source][key] = this._coordsDescendingInv[source][key].map(c => c.key).sort().join();
	                }
	            }
	        }
	        // check tiles to render
	        for (const tile of this._renderableTiles) {
	            for (const source in this._coordsDescendingInvStr) {
	                // rerender if there are more coords to render than in the last rendering
	                const coords = this._coordsDescendingInvStr[source][tile.tileID.key];
	                if (coords && coords !== tile.rttCoords[source])
	                    tile.rtt = [];
	            }
	        }
	    }
	    /**
	     * due that switching textures is relatively slow, the render
	     * layer-by-layer context is not practicable. To bypass this problem
	     * this lines of code stack all layers and later render all at once.
	     * Because of the stylesheet possibility to mixing render-to-texture layers
	     * and 'live'-layers (f.e. symbols) it is necessary to create more stacks. For example
	     * a symbol-layer is in between of fill-layers.
	     * @param layer - the layer to render
	     * @returns if true layer is rendered to texture, otherwise false
	     */
	    renderLayer(layer) {
	        if (layer.isHidden(this.painter.transform.zoom))
	            return false;
	        const type = layer.type;
	        const painter = this.painter;
	        const isLastLayer = this._renderableLayerIds[this._renderableLayerIds.length - 1] === layer.id;
	        // remember background, fill, line & raster layer to render into a stack
	        if (LAYERS[type]) {
	            // create a new stack if previous layer was not rendered to texture (f.e. symbols)
	            if (!this._prevType || !LAYERS[this._prevType])
	                this._stacks.push([]);
	            // push current render-to-texture layer to render-stack
	            this._prevType = type;
	            this._stacks[this._stacks.length - 1].push(layer.id);
	            // rendering is done later, all in once
	            if (!isLastLayer)
	                return true;
	        }
	        // in case a stack is finished render all collected stack-layers into a texture
	        if (LAYERS[this._prevType] || (LAYERS[type] && isLastLayer)) {
	            this._prevType = type;
	            const stack = this._stacks.length - 1, layers = this._stacks[stack] || [];
	            for (const tile of this._renderableTiles) {
	                // if render pool is full draw current tiles to screen and free pool
	                if (this.pool.isFull()) {
	                    drawTerrain(this.painter, this.terrain, this._rttTiles);
	                    this._rttTiles = [];
	                    this.pool.freeAllObjects();
	                }
	                this._rttTiles.push(tile);
	                // check for cached PoolObject
	                if (tile.rtt[stack]) {
	                    const obj = this.pool.getObjectForId(tile.rtt[stack].id);
	                    if (obj.stamp === tile.rtt[stack].stamp) {
	                        this.pool.useObject(obj);
	                        continue;
	                    }
	                }
	                // get free PoolObject
	                const obj = this.pool.getOrCreateFreeObject();
	                this.pool.useObject(obj);
	                this.pool.stampObject(obj);
	                tile.rtt[stack] = { id: obj.id, stamp: obj.stamp };
	                // prepare PoolObject for rendering
	                painter.context.bindFramebuffer.set(obj.fbo.framebuffer);
	                painter.context.clear({ color: performance$1.Color.transparent, stencil: 0 });
	                painter.currentStencilSource = undefined;
	                for (let l = 0; l < layers.length; l++) {
	                    const layer = painter.style._layers[layers[l]];
	                    const coords = layer.source ? this._coordsDescendingInv[layer.source][tile.tileID.key] : [tile.tileID];
	                    painter.context.viewport.set([0, 0, obj.fbo.width, obj.fbo.height]);
	                    painter._renderTileClippingMasks(layer, coords);
	                    painter.renderLayer(painter, painter.style.sourceCaches[layer.source], layer, coords);
	                    if (layer.source)
	                        tile.rttCoords[layer.source] = this._coordsDescendingInvStr[layer.source][tile.tileID.key];
	                }
	            }
	            drawTerrain(this.painter, this.terrain, this._rttTiles);
	            this._rttTiles = [];
	            this.pool.freeAllObjects();
	            return LAYERS[type];
	        }
	        return false;
	    }
	}

	const defaultLocale = {
	    'AttributionControl.ToggleAttribution': 'Toggle attribution',
	    'AttributionControl.MapFeedback': 'Map feedback',
	    'FullscreenControl.Enter': 'Enter fullscreen',
	    'FullscreenControl.Exit': 'Exit fullscreen',
	    'GeolocateControl.FindMyLocation': 'Find my location',
	    'GeolocateControl.LocationNotAvailable': 'Location not available',
	    'LogoControl.Title': 'MapLibre logo',
	    'NavigationControl.ResetBearing': 'Reset bearing to north',
	    'NavigationControl.ZoomIn': 'Zoom in',
	    'NavigationControl.ZoomOut': 'Zoom out',
	    'ScaleControl.Feet': 'ft',
	    'ScaleControl.Meters': 'm',
	    'ScaleControl.Kilometers': 'km',
	    'ScaleControl.Miles': 'mi',
	    'ScaleControl.NauticalMiles': 'nm',
	    'TerrainControl.Enable': 'Enable terrain',
	    'TerrainControl.Disable': 'Disable terrain',
	    'CooperativeGesturesHandler.WindowsHelpText': 'Use Ctrl + scroll to zoom the map',
	    'CooperativeGesturesHandler.MacHelpText': 'Use ⌘ + scroll to zoom the map',
	    'CooperativeGesturesHandler.MobileHelpText': 'Use two fingers to move the map',
	};

	const version$1 = packageJSON.version;
	const defaultMinZoom = -2;
	const defaultMaxZoom = 22;
	// the default values, but also the valid range
	const defaultMinPitch = 0;
	const defaultMaxPitch = 60;
	// use this variable to check maxPitch for validity
	const maxPitchThreshold = 85;
	const defaultOptions$4 = {
	    center: [0, 0],
	    zoom: 0,
	    bearing: 0,
	    pitch: 0,
	    minZoom: defaultMinZoom,
	    maxZoom: defaultMaxZoom,
	    minPitch: defaultMinPitch,
	    maxPitch: defaultMaxPitch,
	    interactive: true,
	    scrollZoom: true,
	    boxZoom: true,
	    dragRotate: true,
	    dragPan: true,
	    keyboard: true,
	    doubleClickZoom: true,
	    touchZoomRotate: true,
	    touchPitch: true,
	    cooperativeGestures: false,
	    bearingSnap: 7,
	    clickTolerance: 3,
	    pitchWithRotate: true,
	    hash: false,
	    attributionControl: defaultAtributionControlOptions,
	    maplibreLogo: false,
	    failIfMajorPerformanceCaveat: false,
	    preserveDrawingBuffer: false,
	    trackResize: true,
	    renderWorldCopies: true,
	    refreshExpiredTiles: true,
	    maxTileCacheSize: null,
	    maxTileCacheZoomLevels: performance$1.config.MAX_TILE_CACHE_ZOOM_LEVELS,
	    localIdeographFontFamily: 'sans-serif',
	    transformRequest: null,
	    transformCameraUpdate: null,
	    fadeDuration: 300,
	    crossSourceCollisions: true,
	    validateStyle: true,
	    /**Because GL MAX_TEXTURE_SIZE is usually at least 4096px. */
	    maxCanvasSize: [4096, 4096]
	};
	/**
	 * The `Map` object represents the map on your page. It exposes methods
	 * and properties that enable you to programmatically change the map,
	 * and fires events as users interact with it.
	 *
	 * You create a `Map` by specifying a `container` and other options, see {@link MapOptions} for the full list.
	 * Then MapLibre GL JS initializes the map on the page and returns your `Map` object.
	 *
	 * @group Main
	 *
	 * @example
	 * ```ts
	 * let map = new Map({
	 *   container: 'map',
	 *   center: [-122.420679, 37.772537],
	 *   zoom: 13,
	 *   style: style_object,
	 *   hash: true,
	 *   transformRequest: (url, resourceType)=> {
	 *     if(resourceType === 'Source' && url.startsWith('http://myHost')) {
	 *       return {
	 *        url: url.replace('http', 'https'),
	 *        headers: { 'my-custom-header': true},
	 *        credentials: 'include'  // Include cookies for cross-origin requests
	 *      }
	 *     }
	 *   }
	 * });
	 * ```
	 * @see [Display a map](https://maplibre.org/maplibre-gl-js/docs/examples/simple-map/)
	 */
	let Map$1 = class Map extends Camera {
	    constructor(options) {
	        performance$1.PerformanceUtils.mark(performance$1.PerformanceMarkers.create);
	        options = performance$1.extend({}, defaultOptions$4, options);
	        if (options.minZoom != null && options.maxZoom != null && options.minZoom > options.maxZoom) {
	            throw new Error('maxZoom must be greater than or equal to minZoom');
	        }
	        if (options.minPitch != null && options.maxPitch != null && options.minPitch > options.maxPitch) {
	            throw new Error('maxPitch must be greater than or equal to minPitch');
	        }
	        if (options.minPitch != null && options.minPitch < defaultMinPitch) {
	            throw new Error(`minPitch must be greater than or equal to ${defaultMinPitch}`);
	        }
	        if (options.maxPitch != null && options.maxPitch > maxPitchThreshold) {
	            throw new Error(`maxPitch must be less than or equal to ${maxPitchThreshold}`);
	        }
	        const transform = new Transform(options.minZoom, options.maxZoom, options.minPitch, options.maxPitch, options.renderWorldCopies);
	        super(transform, { bearingSnap: options.bearingSnap });
	        this._contextLost = (event) => {
	            event.preventDefault();
	            if (this._frameRequest) {
	                this._frameRequest.abort();
	                this._frameRequest = null;
	            }
	            this.fire(new performance$1.Event('webglcontextlost', { originalEvent: event }));
	        };
	        this._contextRestored = (event) => {
	            this._setupPainter();
	            this.resize();
	            this._update();
	            this.fire(new performance$1.Event('webglcontextrestored', { originalEvent: event }));
	        };
	        this._onMapScroll = (event) => {
	            if (event.target !== this._container)
	                return;
	            // Revert any scroll which would move the canvas outside of the view
	            this._container.scrollTop = 0;
	            this._container.scrollLeft = 0;
	            return false;
	        };
	        this._onWindowOnline = () => {
	            this._update();
	        };
	        this._interactive = options.interactive;
	        this._maxTileCacheSize = options.maxTileCacheSize;
	        this._maxTileCacheZoomLevels = options.maxTileCacheZoomLevels;
	        this._failIfMajorPerformanceCaveat = options.failIfMajorPerformanceCaveat;
	        this._preserveDrawingBuffer = options.preserveDrawingBuffer;
	        this._antialias = options.antialias;
	        this._trackResize = options.trackResize;
	        this._bearingSnap = options.bearingSnap;
	        this._refreshExpiredTiles = options.refreshExpiredTiles;
	        this._fadeDuration = options.fadeDuration;
	        this._crossSourceCollisions = options.crossSourceCollisions;
	        this._crossFadingFactor = 1;
	        this._collectResourceTiming = options.collectResourceTiming;
	        this._renderTaskQueue = new TaskQueue();
	        this._controls = [];
	        this._mapId = performance$1.uniqueId();
	        this._locale = performance$1.extend({}, defaultLocale, options.locale);
	        this._clickTolerance = options.clickTolerance;
	        this._overridePixelRatio = options.pixelRatio;
	        this._maxCanvasSize = options.maxCanvasSize;
	        this.transformCameraUpdate = options.transformCameraUpdate;
	        this._imageQueueHandle = ImageRequest.addThrottleControl(() => this.isMoving());
	        this._requestManager = new RequestManager(options.transformRequest);
	        if (typeof options.container === 'string') {
	            this._container = document.getElementById(options.container);
	            if (!this._container) {
	                throw new Error(`Container '${options.container}' not found.`);
	            }
	        }
	        else if (options.container instanceof HTMLElement) {
	            this._container = options.container;
	        }
	        else {
	            throw new Error('Invalid type: \'container\' must be a String or HTMLElement.');
	        }
	        if (options.maxBounds) {
	            this.setMaxBounds(options.maxBounds);
	        }
	        this._setupContainer();
	        this._setupPainter();
	        this.on('move', () => this._update(false));
	        this.on('moveend', () => this._update(false));
	        this.on('zoom', () => this._update(true));
	        this.on('terrain', () => {
	            this.painter.terrainFacilitator.dirty = true;
	            this._update(true);
	        });
	        this.once('idle', () => { this._idleTriggered = true; });
	        if (typeof window !== 'undefined') {
	            addEventListener('online', this._onWindowOnline, false);
	            let initialResizeEventCaptured = false;
	            const throttledResizeCallback = throttle((entries) => {
	                if (this._trackResize && !this._removed) {
	                    this.resize(entries)._update();
	                }
	            }, 50);
	            this._resizeObserver = new ResizeObserver((entries) => {
	                if (!initialResizeEventCaptured) {
	                    initialResizeEventCaptured = true;
	                    return;
	                }
	                throttledResizeCallback(entries);
	            });
	            this._resizeObserver.observe(this._container);
	        }
	        this.handlers = new HandlerManager(this, options);
	        const hashName = (typeof options.hash === 'string' && options.hash) || undefined;
	        this._hash = options.hash && (new Hash(hashName)).addTo(this);
	        // don't set position from options if set through hash
	        if (!this._hash || !this._hash._onHashChange()) {
	            this.jumpTo({
	                center: options.center,
	                zoom: options.zoom,
	                bearing: options.bearing,
	                pitch: options.pitch
	            });
	            if (options.bounds) {
	                this.resize();
	                this.fitBounds(options.bounds, performance$1.extend({}, options.fitBoundsOptions, { duration: 0 }));
	            }
	        }
	        this.resize();
	        this._localIdeographFontFamily = options.localIdeographFontFamily;
	        this._validateStyle = options.validateStyle;
	        if (options.style)
	            this.setStyle(options.style, { localIdeographFontFamily: options.localIdeographFontFamily });
	        if (options.attributionControl)
	            this.addControl(new AttributionControl(typeof options.attributionControl === 'boolean' ? undefined : options.attributionControl));
	        if (options.maplibreLogo)
	            this.addControl(new LogoControl(), options.logoPosition);
	        this.on('style.load', () => {
	            if (this.transform.unmodified) {
	                this.jumpTo(this.style.stylesheet);
	            }
	        });
	        this.on('data', (event) => {
	            this._update(event.dataType === 'style');
	            this.fire(new performance$1.Event(`${event.dataType}data`, event));
	        });
	        this.on('dataloading', (event) => {
	            this.fire(new performance$1.Event(`${event.dataType}dataloading`, event));
	        });
	        this.on('dataabort', (event) => {
	            this.fire(new performance$1.Event('sourcedataabort', event));
	        });
	    }
	    /**
	     * @internal
	     * Returns a unique number for this map instance which is used for the MapLoadEvent
	     * to make sure we only fire one event per instantiated map object.
	     * @returns the uniq map ID
	     */
	    _getMapId() {
	        return this._mapId;
	    }
	    /**
	     * Adds an {@link IControl} to the map, calling `control.onAdd(this)`.
	     *
	     * An {@link ErrorEvent} will be fired if the image parameter is invald.
	     *
	     * @param control - The {@link IControl} to add.
	     * @param position - position on the map to which the control will be added.
	     * Valid values are `'top-left'`, `'top-right'`, `'bottom-left'`, and `'bottom-right'`. Defaults to `'top-right'`.
	     * @returns `this`
	     * @example
	     * Add zoom and rotation controls to the map.
	     * ```ts
	     * map.addControl(new NavigationControl());
	     * ```
	     * @see [Display map navigation controls](https://maplibre.org/maplibre-gl-js/docs/examples/navigation/)
	     */
	    addControl(control, position) {
	        if (position === undefined) {
	            if (control.getDefaultPosition) {
	                position = control.getDefaultPosition();
	            }
	            else {
	                position = 'top-right';
	            }
	        }
	        if (!control || !control.onAdd) {
	            return this.fire(new performance$1.ErrorEvent(new Error('Invalid argument to map.addControl(). Argument must be a control with onAdd and onRemove methods.')));
	        }
	        const controlElement = control.onAdd(this);
	        this._controls.push(control);
	        const positionContainer = this._controlPositions[position];
	        if (position.indexOf('bottom') !== -1) {
	            positionContainer.insertBefore(controlElement, positionContainer.firstChild);
	        }
	        else {
	            positionContainer.appendChild(controlElement);
	        }
	        return this;
	    }
	    /**
	     * Removes the control from the map.
	     *
	     * An {@link ErrorEvent} will be fired if the image parameter is invald.
	     *
	     * @param control - The {@link IControl} to remove.
	     * @returns `this`
	     * @example
	     * ```ts
	     * // Define a new navigation control.
	     * let navigation = new NavigationControl();
	     * // Add zoom and rotation controls to the map.
	     * map.addControl(navigation);
	     * // Remove zoom and rotation controls from the map.
	     * map.removeControl(navigation);
	     * ```
	     */
	    removeControl(control) {
	        if (!control || !control.onRemove) {
	            return this.fire(new performance$1.ErrorEvent(new Error('Invalid argument to map.removeControl(). Argument must be a control with onAdd and onRemove methods.')));
	        }
	        const ci = this._controls.indexOf(control);
	        if (ci > -1)
	            this._controls.splice(ci, 1);
	        control.onRemove(this);
	        return this;
	    }
	    /**
	     * Checks if a control exists on the map.
	     *
	     * @param control - The {@link IControl} to check.
	     * @returns true if map contains control.
	     * @example
	     * ```ts
	     * // Define a new navigation control.
	     * let navigation = new NavigationControl();
	     * // Add zoom and rotation controls to the map.
	     * map.addControl(navigation);
	     * // Check that the navigation control exists on the map.
	     * map.hasControl(navigation);
	     * ```
	     */
	    hasControl(control) {
	        return this._controls.indexOf(control) > -1;
	    }
	    calculateCameraOptionsFromTo(from, altitudeFrom, to, altitudeTo) {
	        if (altitudeTo == null && this.terrain) {
	            altitudeTo = this.terrain.getElevationForLngLatZoom(to, this.transform.tileZoom);
	        }
	        return super.calculateCameraOptionsFromTo(from, altitudeFrom, to, altitudeTo);
	    }
	    /**
	     * Resizes the map according to the dimensions of its
	     * `container` element.
	     *
	     * Checks if the map container size changed and updates the map if it has changed.
	     * This method must be called after the map's `container` is resized programmatically
	     * or when the map is shown after being initially hidden with CSS.
	     *
	     * Triggers the following events: `movestart`, `move`, `moveend`, and `resize`.
	     *
	     * @param eventData - Additional properties to be passed to `movestart`, `move`, `resize`, and `moveend`
	     * events that get triggered as a result of resize. This can be useful for differentiating the
	     * source of an event (for example, user-initiated or programmatically-triggered events).
	     * @returns `this`
	     * @example
	     * Resize the map when the map container is shown after being initially hidden with CSS.
	     * ```ts
	     * let mapDiv = document.getElementById('map');
	     * if (mapDiv.style.visibility === true) map.resize();
	     * ```
	     */
	    resize(eventData) {
	        var _a;
	        const dimensions = this._containerDimensions();
	        const width = dimensions[0];
	        const height = dimensions[1];
	        const clampedPixelRatio = this._getClampedPixelRatio(width, height);
	        this._resizeCanvas(width, height, clampedPixelRatio);
	        this.painter.resize(width, height, clampedPixelRatio);
	        // check if we've reached GL limits, in that case further clamps pixelRatio
	        if (this.painter.overLimit()) {
	            const gl = this.painter.context.gl;
	            // store updated _maxCanvasSize value
	            this._maxCanvasSize = [gl.drawingBufferWidth, gl.drawingBufferHeight];
	            const clampedPixelRatio = this._getClampedPixelRatio(width, height);
	            this._resizeCanvas(width, height, clampedPixelRatio);
	            this.painter.resize(width, height, clampedPixelRatio);
	        }
	        this.transform.resize(width, height);
	        (_a = this._requestedCameraState) === null || _a === void 0 ? void 0 : _a.resize(width, height);
	        const fireMoving = !this._moving;
	        if (fireMoving) {
	            this.stop();
	            this.fire(new performance$1.Event('movestart', eventData))
	                .fire(new performance$1.Event('move', eventData));
	        }
	        this.fire(new performance$1.Event('resize', eventData));
	        if (fireMoving)
	            this.fire(new performance$1.Event('moveend', eventData));
	        return this;
	    }
	    /**
	     * @internal
	     * Return the map's pixel ratio eventually scaled down to respect maxCanvasSize.
	     * Internally you should use this and not getPixelRatio().
	     */
	    _getClampedPixelRatio(width, height) {
	        const { 0: maxCanvasWidth, 1: maxCanvasHeight } = this._maxCanvasSize;
	        const pixelRatio = this.getPixelRatio();
	        const canvasWidth = width * pixelRatio;
	        const canvasHeight = height * pixelRatio;
	        const widthScaleFactor = canvasWidth > maxCanvasWidth ? (maxCanvasWidth / canvasWidth) : 1;
	        const heightScaleFactor = canvasHeight > maxCanvasHeight ? (maxCanvasHeight / canvasHeight) : 1;
	        return Math.min(widthScaleFactor, heightScaleFactor) * pixelRatio;
	    }
	    /**
	     * Returns the map's pixel ratio.
	     * Note that the pixel ratio actually applied may be lower to respect maxCanvasSize.
	     * @returns The pixel ratio.
	     */
	    getPixelRatio() {
	        var _a;
	        return (_a = this._overridePixelRatio) !== null && _a !== void 0 ? _a : devicePixelRatio;
	    }
	    /**
	     * Sets the map's pixel ratio. This allows to override `devicePixelRatio`.
	     * After this call, the canvas' `width` attribute will be `container.clientWidth * pixelRatio`
	     * and its height attribute will be `container.clientHeight * pixelRatio`.
	     * Set this to null to disable `devicePixelRatio` override.
	     * Note that the pixel ratio actually applied may be lower to respect maxCanvasSize.
	     * @param pixelRatio - The pixel ratio.
	     */
	    setPixelRatio(pixelRatio) {
	        this._overridePixelRatio = pixelRatio;
	        this.resize();
	    }
	    /**
	     * Returns the map's geographical bounds. When the bearing or pitch is non-zero, the visible region is not
	     * an axis-aligned rectangle, and the result is the smallest bounds that encompasses the visible region.
	     * @returns The geographical bounds of the map as {@link LngLatBounds}.
	     * @example
	     * ```ts
	     * let bounds = map.getBounds();
	     * ```
	     */
	    getBounds() {
	        return this.transform.getBounds();
	    }
	    /**
	     * Returns the maximum geographical bounds the map is constrained to, or `null` if none set.
	     * @returns The map object.
	     * @example
	     * ```ts
	     * let maxBounds = map.getMaxBounds();
	     * ```
	     */
	    getMaxBounds() {
	        return this.transform.getMaxBounds();
	    }
	    /**
	     * Sets or clears the map's geographical bounds.
	     *
	     * Pan and zoom operations are constrained within these bounds.
	     * If a pan or zoom is performed that would
	     * display regions outside these bounds, the map will
	     * instead display a position and zoom level
	     * as close as possible to the operation's request while still
	     * remaining within the bounds.
	     *
	     * @param bounds - The maximum bounds to set. If `null` or `undefined` is provided, the function removes the map's maximum bounds.
	     * @returns `this`
	     * @example
	     * Define bounds that conform to the `LngLatBoundsLike` object as set the max bounds.
	     * ```ts
	     * let bounds = [
	     *   [-74.04728, 40.68392], // [west, south]
	     *   [-73.91058, 40.87764]  // [east, north]
	     * ];
	     * map.setMaxBounds(bounds);
	     * ```
	     */
	    setMaxBounds(bounds) {
	        this.transform.setMaxBounds(LngLatBounds.convert(bounds));
	        return this._update();
	    }
	    /**
	     * Sets or clears the map's minimum zoom level.
	     * If the map's current zoom level is lower than the new minimum,
	     * the map will zoom to the new minimum.
	     *
	     * It is not always possible to zoom out and reach the set `minZoom`.
	     * Other factors such as map height may restrict zooming. For example,
	     * if the map is 512px tall it will not be possible to zoom below zoom 0
	     * no matter what the `minZoom` is set to.
	     *
	     * A {@link ErrorEvent} event will be fired if minZoom is out of bounds.
	     *
	     * @param minZoom - The minimum zoom level to set (-2 - 24).
	     * If `null` or `undefined` is provided, the function removes the current minimum zoom (i.e. sets it to -2).
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setMinZoom(12.25);
	     * ```
	     */
	    setMinZoom(minZoom) {
	        minZoom = minZoom === null || minZoom === undefined ? defaultMinZoom : minZoom;
	        if (minZoom >= defaultMinZoom && minZoom <= this.transform.maxZoom) {
	            this.transform.minZoom = minZoom;
	            this._update();
	            if (this.getZoom() < minZoom)
	                this.setZoom(minZoom);
	            return this;
	        }
	        else
	            throw new Error(`minZoom must be between ${defaultMinZoom} and the current maxZoom, inclusive`);
	    }
	    /**
	     * Returns the map's minimum allowable zoom level.
	     *
	     * @returns minZoom
	     * @example
	     * ```ts
	     * let minZoom = map.getMinZoom();
	     * ```
	     */
	    getMinZoom() { return this.transform.minZoom; }
	    /**
	     * Sets or clears the map's maximum zoom level.
	     * If the map's current zoom level is higher than the new maximum,
	     * the map will zoom to the new maximum.
	     *
	     * A {@link ErrorEvent} event will be fired if minZoom is out of bounds.
	     *
	     * @param maxZoom - The maximum zoom level to set.
	     * If `null` or `undefined` is provided, the function removes the current maximum zoom (sets it to 22).
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setMaxZoom(18.75);
	     * ```
	     */
	    setMaxZoom(maxZoom) {
	        maxZoom = maxZoom === null || maxZoom === undefined ? defaultMaxZoom : maxZoom;
	        if (maxZoom >= this.transform.minZoom) {
	            this.transform.maxZoom = maxZoom;
	            this._update();
	            if (this.getZoom() > maxZoom)
	                this.setZoom(maxZoom);
	            return this;
	        }
	        else
	            throw new Error('maxZoom must be greater than the current minZoom');
	    }
	    /**
	     * Returns the map's maximum allowable zoom level.
	     *
	     * @returns The maxZoom
	     * @example
	     * ```ts
	     * let maxZoom = map.getMaxZoom();
	     * ```
	     */
	    getMaxZoom() { return this.transform.maxZoom; }
	    /**
	     * Sets or clears the map's minimum pitch.
	     * If the map's current pitch is lower than the new minimum,
	     * the map will pitch to the new minimum.
	     *
	     * A {@link ErrorEvent} event will be fired if minPitch is out of bounds.
	     *
	     * @param minPitch - The minimum pitch to set (0-85). Values greater than 60 degrees are experimental and may result in rendering issues. If you encounter any, please raise an issue with details in the MapLibre project.
	     * If `null` or `undefined` is provided, the function removes the current minimum pitch (i.e. sets it to 0).
	     * @returns `this`
	     */
	    setMinPitch(minPitch) {
	        minPitch = minPitch === null || minPitch === undefined ? defaultMinPitch : minPitch;
	        if (minPitch < defaultMinPitch) {
	            throw new Error(`minPitch must be greater than or equal to ${defaultMinPitch}`);
	        }
	        if (minPitch >= defaultMinPitch && minPitch <= this.transform.maxPitch) {
	            this.transform.minPitch = minPitch;
	            this._update();
	            if (this.getPitch() < minPitch)
	                this.setPitch(minPitch);
	            return this;
	        }
	        else
	            throw new Error(`minPitch must be between ${defaultMinPitch} and the current maxPitch, inclusive`);
	    }
	    /**
	     * Returns the map's minimum allowable pitch.
	     *
	     * @returns The minPitch
	     */
	    getMinPitch() { return this.transform.minPitch; }
	    /**
	     * Sets or clears the map's maximum pitch.
	     * If the map's current pitch is higher than the new maximum,
	     * the map will pitch to the new maximum.
	     *
	     * A {@link ErrorEvent} event will be fired if maxPitch is out of bounds.
	     *
	     * @param maxPitch - The maximum pitch to set (0-85). Values greater than 60 degrees are experimental and may result in rendering issues. If you encounter any, please raise an issue with details in the MapLibre project.
	     * If `null` or `undefined` is provided, the function removes the current maximum pitch (sets it to 60).
	     * @returns `this`
	     */
	    setMaxPitch(maxPitch) {
	        maxPitch = maxPitch === null || maxPitch === undefined ? defaultMaxPitch : maxPitch;
	        if (maxPitch > maxPitchThreshold) {
	            throw new Error(`maxPitch must be less than or equal to ${maxPitchThreshold}`);
	        }
	        if (maxPitch >= this.transform.minPitch) {
	            this.transform.maxPitch = maxPitch;
	            this._update();
	            if (this.getPitch() > maxPitch)
	                this.setPitch(maxPitch);
	            return this;
	        }
	        else
	            throw new Error('maxPitch must be greater than the current minPitch');
	    }
	    /**
	     * Returns the map's maximum allowable pitch.
	     *
	     * @returns The maxPitch
	     */
	    getMaxPitch() { return this.transform.maxPitch; }
	    /**
	     * Returns the state of `renderWorldCopies`. If `true`, multiple copies of the world will be rendered side by side beyond -180 and 180 degrees longitude. If set to `false`:
	     *
	     * - When the map is zoomed out far enough that a single representation of the world does not fill the map's entire
	     * container, there will be blank space beyond 180 and -180 degrees longitude.
	     * - Features that cross 180 and -180 degrees longitude will be cut in two (with one portion on the right edge of the
	     * map and the other on the left edge of the map) at every zoom level.
	     * @returns The renderWorldCopies
	     * @example
	     * ```ts
	     * let worldCopiesRendered = map.getRenderWorldCopies();
	     * ```
	     * @see [Render world copies](https://maplibre.org/maplibre-gl-js/docs/examples/render-world-copies/)
	     */
	    getRenderWorldCopies() { return this.transform.renderWorldCopies; }
	    /**
	     * Sets the state of `renderWorldCopies`.
	     *
	     * @param renderWorldCopies - If `true`, multiple copies of the world will be rendered side by side beyond -180 and 180 degrees longitude. If set to `false`:
	     *
	     * - When the map is zoomed out far enough that a single representation of the world does not fill the map's entire
	     * container, there will be blank space beyond 180 and -180 degrees longitude.
	     * - Features that cross 180 and -180 degrees longitude will be cut in two (with one portion on the right edge of the
	     * map and the other on the left edge of the map) at every zoom level.
	     *
	     * `undefined` is treated as `true`, `null` is treated as `false`.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setRenderWorldCopies(true);
	     * ```
	     * @see [Render world copies](https://maplibre.org/maplibre-gl-js/docs/examples/render-world-copies/)
	     */
	    setRenderWorldCopies(renderWorldCopies) {
	        this.transform.renderWorldCopies = renderWorldCopies;
	        return this._update();
	    }
	    /**
	     * Returns a [Point](https://github.com/mapbox/point-geometry) representing pixel coordinates, relative to the map's `container`,
	     * that correspond to the specified geographical location.
	     *
	     * @param lnglat - The geographical location to project.
	     * @returns The [Point](https://github.com/mapbox/point-geometry) corresponding to `lnglat`, relative to the map's `container`.
	     * @example
	     * ```ts
	     * let coordinate = [-122.420679, 37.772537];
	     * let point = map.project(coordinate);
	     * ```
	     */
	    project(lnglat) {
	        return this.transform.locationPoint(performance$1.LngLat.convert(lnglat), this.style && this.terrain);
	    }
	    /**
	     * Returns a {@link LngLat} representing geographical coordinates that correspond
	     * to the specified pixel coordinates.
	     *
	     * @param point - The pixel coordinates to unproject.
	     * @returns The {@link LngLat} corresponding to `point`.
	     * @example
	     * ```ts
	     * map.on('click', function(e) {
	     *   // When the map is clicked, get the geographic coordinate.
	     *   let coordinate = map.unproject(e.point);
	     * });
	     * ```
	     */
	    unproject(point) {
	        return this.transform.pointLocation(performance$1.Point.convert(point), this.terrain);
	    }
	    /**
	     * Returns true if the map is panning, zooming, rotating, or pitching due to a camera animation or user gesture.
	     * @returns true if the map is moving.
	     * @example
	     * ```ts
	     * let isMoving = map.isMoving();
	     * ```
	     */
	    isMoving() {
	        var _a;
	        return this._moving || ((_a = this.handlers) === null || _a === void 0 ? void 0 : _a.isMoving());
	    }
	    /**
	     * Returns true if the map is zooming due to a camera animation or user gesture.
	     * @returns true if the map is zooming.
	     * @example
	     * ```ts
	     * let isZooming = map.isZooming();
	     * ```
	     */
	    isZooming() {
	        var _a;
	        return this._zooming || ((_a = this.handlers) === null || _a === void 0 ? void 0 : _a.isZooming());
	    }
	    /**
	     * Returns true if the map is rotating due to a camera animation or user gesture.
	     * @returns true if the map is rotating.
	     * @example
	     * ```ts
	     * map.isRotating();
	     * ```
	     */
	    isRotating() {
	        var _a;
	        return this._rotating || ((_a = this.handlers) === null || _a === void 0 ? void 0 : _a.isRotating());
	    }
	    _createDelegatedListener(type, layerId, listener) {
	        if (type === 'mouseenter' || type === 'mouseover') {
	            let mousein = false;
	            const mousemove = (e) => {
	                const features = this.getLayer(layerId) ? this.queryRenderedFeatures(e.point, { layers: [layerId] }) : [];
	                if (!features.length) {
	                    mousein = false;
	                }
	                else if (!mousein) {
	                    mousein = true;
	                    listener.call(this, new MapMouseEvent(type, this, e.originalEvent, { features }));
	                }
	            };
	            const mouseout = () => {
	                mousein = false;
	            };
	            return { layer: layerId, listener, delegates: { mousemove, mouseout } };
	        }
	        else if (type === 'mouseleave' || type === 'mouseout') {
	            let mousein = false;
	            const mousemove = (e) => {
	                const features = this.getLayer(layerId) ? this.queryRenderedFeatures(e.point, { layers: [layerId] }) : [];
	                if (features.length) {
	                    mousein = true;
	                }
	                else if (mousein) {
	                    mousein = false;
	                    listener.call(this, new MapMouseEvent(type, this, e.originalEvent));
	                }
	            };
	            const mouseout = (e) => {
	                if (mousein) {
	                    mousein = false;
	                    listener.call(this, new MapMouseEvent(type, this, e.originalEvent));
	                }
	            };
	            return { layer: layerId, listener, delegates: { mousemove, mouseout } };
	        }
	        else {
	            const delegate = (e) => {
	                const features = this.getLayer(layerId) ? this.queryRenderedFeatures(e.point, { layers: [layerId] }) : [];
	                if (features.length) {
	                    // Here we need to mutate the original event, so that preventDefault works as expected.
	                    e.features = features;
	                    listener.call(this, e);
	                    delete e.features;
	                }
	            };
	            return { layer: layerId, listener, delegates: { [type]: delegate } };
	        }
	    }
	    on(type, layerIdOrListener, listener) {
	        if (listener === undefined) {
	            return super.on(type, layerIdOrListener);
	        }
	        const delegatedListener = this._createDelegatedListener(type, layerIdOrListener, listener);
	        this._delegatedListeners = this._delegatedListeners || {};
	        this._delegatedListeners[type] = this._delegatedListeners[type] || [];
	        this._delegatedListeners[type].push(delegatedListener);
	        for (const event in delegatedListener.delegates) {
	            this.on(event, delegatedListener.delegates[event]);
	        }
	        return this;
	    }
	    once(type, layerIdOrListener, listener) {
	        if (listener === undefined) {
	            return super.once(type, layerIdOrListener);
	        }
	        const delegatedListener = this._createDelegatedListener(type, layerIdOrListener, listener);
	        for (const event in delegatedListener.delegates) {
	            this.once(event, delegatedListener.delegates[event]);
	        }
	        return this;
	    }
	    off(type, layerIdOrListener, listener) {
	        if (listener === undefined) {
	            return super.off(type, layerIdOrListener);
	        }
	        const removeDelegatedListener = (delegatedListeners) => {
	            const listeners = delegatedListeners[type];
	            for (let i = 0; i < listeners.length; i++) {
	                const delegatedListener = listeners[i];
	                if (delegatedListener.layer === layerIdOrListener && delegatedListener.listener === listener) {
	                    for (const event in delegatedListener.delegates) {
	                        this.off(event, delegatedListener.delegates[event]);
	                    }
	                    listeners.splice(i, 1);
	                    return this;
	                }
	            }
	        };
	        if (this._delegatedListeners && this._delegatedListeners[type]) {
	            removeDelegatedListener(this._delegatedListeners);
	        }
	        return this;
	    }
	    /**
	     * Returns an array of MapGeoJSONFeature objects
	     * representing visible features that satisfy the query parameters.
	     *
	     * @param geometryOrOptions - (optional) The geometry of the query region:
	     * either a single point or southwest and northeast points describing a bounding box.
	     * Omitting this parameter (i.e. calling {@link Map#queryRenderedFeatures} with zero arguments,
	     * or with only a `options` argument) is equivalent to passing a bounding box encompassing the entire
	     * map viewport.
	     * The geometryOrOptions can receive a {@link QueryRenderedFeaturesOptions} only to support a situation where the function receives only one parameter which is the options parameter.
	     * @param options - (optional) Options object.
	     *
	     * @returns An array of MapGeoJSONFeature objects.
	     *
	     * The `properties` value of each returned feature object contains the properties of its source feature. For GeoJSON sources, only
	     * string and numeric property values are supported (i.e. `null`, `Array`, and `Object` values are not supported).
	     *
	     * Each feature includes top-level `layer`, `source`, and `sourceLayer` properties. The `layer` property is an object
	     * representing the style layer to  which the feature belongs. Layout and paint properties in this object contain values
	     * which are fully evaluated for the given zoom level and feature.
	     *
	     * Only features that are currently rendered are included. Some features will **not** be included, like:
	     *
	     * - Features from layers whose `visibility` property is `"none"`.
	     * - Features from layers whose zoom range excludes the current zoom level.
	     * - Symbol features that have been hidden due to text or icon collision.
	     *
	     * Features from all other layers are included, including features that may have no visible
	     * contribution to the rendered result; for example, because the layer's opacity or color alpha component is set to
	     * 0.
	     *
	     * The topmost rendered feature appears first in the returned array, and subsequent features are sorted by
	     * descending z-order. Features that are rendered multiple times (due to wrapping across the antemeridian at low
	     * zoom levels) are returned only once (though subject to the following caveat).
	     *
	     * Because features come from tiled vector data or GeoJSON data that is converted to tiles internally, feature
	     * geometries may be split or duplicated across tile boundaries and, as a result, features may appear multiple
	     * times in query results. For example, suppose there is a highway running through the bounding rectangle of a query.
	     * The results of the query will be those parts of the highway that lie within the map tiles covering the bounding
	     * rectangle, even if the highway extends into other tiles, and the portion of the highway within each map tile
	     * will be returned as a separate feature. Similarly, a point feature near a tile boundary may appear in multiple
	     * tiles due to tile buffering.
	     *
	     * @example
	     * Find all features at a point
	     * ```ts
	     * let features = map.queryRenderedFeatures(
	     *   [20, 35],
	     *   { layers: ['my-layer-name'] }
	     * );
	     * ```
	     *
	     * @example
	     * Find all features within a static bounding box
	     * ```ts
	     * let features = map.queryRenderedFeatures(
	     *   [[10, 20], [30, 50]],
	     *   { layers: ['my-layer-name'] }
	     * );
	     * ```
	     *
	     * @example
	     * Find all features within a bounding box around a point
	     * ```ts
	     * let width = 10;
	     * let height = 20;
	     * let features = map.queryRenderedFeatures([
	     *   [point.x - width / 2, point.y - height / 2],
	     *   [point.x + width / 2, point.y + height / 2]
	     * ], { layers: ['my-layer-name'] });
	     * ```
	     *
	     * @example
	     * Query all rendered features from a single layer
	     * ```ts
	     * let features = map.queryRenderedFeatures({ layers: ['my-layer-name'] });
	     * ```
	     * @see [Get features under the mouse pointer](https://maplibre.org/maplibre-gl-js/docs/examples/queryrenderedfeatures/)
	     */
	    queryRenderedFeatures(geometryOrOptions, options) {
	        if (!this.style) {
	            return [];
	        }
	        let queryGeometry;
	        const isGeometry = geometryOrOptions instanceof performance$1.Point || Array.isArray(geometryOrOptions);
	        const geometry = isGeometry ? geometryOrOptions : [[0, 0], [this.transform.width, this.transform.height]];
	        options = options || (isGeometry ? {} : geometryOrOptions) || {};
	        if (geometry instanceof performance$1.Point || typeof geometry[0] === 'number') {
	            queryGeometry = [performance$1.Point.convert(geometry)];
	        }
	        else {
	            const tl = performance$1.Point.convert(geometry[0]);
	            const br = performance$1.Point.convert(geometry[1]);
	            queryGeometry = [tl, new performance$1.Point(br.x, tl.y), br, new performance$1.Point(tl.x, br.y), tl];
	        }
	        return this.style.queryRenderedFeatures(queryGeometry, options, this.transform);
	    }
	    /**
	     * Returns an array of MapGeoJSONFeature objects
	     * representing features within the specified vector tile or GeoJSON source that satisfy the query parameters.
	     *
	     * @param sourceId - The ID of the vector tile or GeoJSON source to query.
	     * @param parameters - The options object.
	     * @returns An array of MapGeoJSONFeature objects.
	     *
	     * In contrast to {@link Map#queryRenderedFeatures}, this function returns all features matching the query parameters,
	     * whether or not they are rendered by the current style (i.e. visible). The domain of the query includes all currently-loaded
	     * vector tiles and GeoJSON source tiles: this function does not check tiles outside the currently
	     * visible viewport.
	     *
	     * Because features come from tiled vector data or GeoJSON data that is converted to tiles internally, feature
	     * geometries may be split or duplicated across tile boundaries and, as a result, features may appear multiple
	     * times in query results. For example, suppose there is a highway running through the bounding rectangle of a query.
	     * The results of the query will be those parts of the highway that lie within the map tiles covering the bounding
	     * rectangle, even if the highway extends into other tiles, and the portion of the highway within each map tile
	     * will be returned as a separate feature. Similarly, a point feature near a tile boundary may appear in multiple
	     * tiles due to tile buffering.
	     *
	     * @example
	     * Find all features in one source layer in a vector source
	     * ```ts
	     * let features = map.querySourceFeatures('your-source-id', {
	     *   sourceLayer: 'your-source-layer'
	     * });
	     * ```
	     *
	     */
	    querySourceFeatures(sourceId, parameters) {
	        return this.style.querySourceFeatures(sourceId, parameters);
	    }
	    /**
	     * Updates the map's MapLibre style object with a new value.
	     *
	     * If a style is already set when this is used and options.diff is set to true, the map renderer will attempt to compare the given style
	     * against the map's current state and perform only the changes necessary to make the map style match the desired state. Changes in sprites
	     * (images used for icons and patterns) and glyphs (fonts for label text) **cannot** be diffed. If the sprites or fonts used in the current
	     * style and the given style are different in any way, the map renderer will force a full update, removing the current style and building
	     * the given one from scratch.
	     *
	     *
	     * @param style - A JSON object conforming to the schema described in the
	     * [MapLibre Style Specification](https://maplibre.org/maplibre-style-spec/), or a URL to such JSON.
	     * @param options - The options object.
	     * @returns `this`
	     *
	     * @example
	     * ```ts
	     * map.setStyle("https://demotiles.maplibre.org/style.json");
	     *
	     * map.setStyle('https://demotiles.maplibre.org/style.json', {
	     *   transformStyle: (previousStyle, nextStyle) => ({
	     *       ...nextStyle,
	     *       sources: {
	     *           ...nextStyle.sources,
	     *           // copy a source from previous style
	     *           'osm': previousStyle.sources.osm
	     *       },
	     *       layers: [
	     *           // background layer
	     *           nextStyle.layers[0],
	     *           // copy a layer from previous style
	     *           previousStyle.layers[0],
	     *           // other layers from the next style
	     *           ...nextStyle.layers.slice(1).map(layer => {
	     *               // hide the layers we don't need from demotiles style
	     *               if (layer.id.startsWith('geolines')) {
	     *                   layer.layout = {...layer.layout || {}, visibility: 'none'};
	     *               // filter out US polygons
	     *               } else if (layer.id.startsWith('coastline') || layer.id.startsWith('countries')) {
	     *                   layer.filter = ['!=', ['get', 'ADM0_A3'], 'USA'];
	     *               }
	     *               return layer;
	     *           })
	     *       ]
	     *   })
	     * });
	     * ```
	     */
	    setStyle(style, options) {
	        options = performance$1.extend({}, {
	            localIdeographFontFamily: this._localIdeographFontFamily,
	            validate: this._validateStyle
	        }, options);
	        if ((options.diff !== false && options.localIdeographFontFamily === this._localIdeographFontFamily) && this.style && style) {
	            this._diffStyle(style, options);
	            return this;
	        }
	        else {
	            this._localIdeographFontFamily = options.localIdeographFontFamily;
	            return this._updateStyle(style, options);
	        }
	    }
	    /**
	     *  Updates the requestManager's transform request with a new function
	     *
	     * @param transformRequest - A callback run before the Map makes a request for an external URL. The callback can be used to modify the url, set headers, or set the credentials property for cross-origin requests.
	     * Expected to return an object with a `url` property and optionally `headers` and `credentials` properties
	     *
	     * @returns `this`
	     *
	     * @example
	     * ```ts
	     * map.setTransformRequest((url: string, resourceType: string) => {});
	     * ```
	     */
	    setTransformRequest(transformRequest) {
	        this._requestManager.setTransformRequest(transformRequest);
	        return this;
	    }
	    _getUIString(key) {
	        const str = this._locale[key];
	        if (str == null) {
	            throw new Error(`Missing UI string '${key}'`);
	        }
	        return str;
	    }
	    _updateStyle(style, options) {
	        // transformStyle relies on having previous style serialized, if it is not loaded yet, delay _updateStyle until previous style is loaded
	        if (options.transformStyle && this.style && !this.style._loaded) {
	            this.style.once('style.load', () => this._updateStyle(style, options));
	            return;
	        }
	        const previousStyle = this.style && options.transformStyle ? this.style.serialize() : undefined;
	        if (this.style) {
	            this.style.setEventedParent(null);
	            // Only release workers when map is getting disposed
	            this.style._remove(!style);
	        }
	        if (!style) {
	            delete this.style;
	            return this;
	        }
	        else {
	            this.style = new Style(this, options || {});
	        }
	        this.style.setEventedParent(this, { style: this.style });
	        if (typeof style === 'string') {
	            this.style.loadURL(style, options, previousStyle);
	        }
	        else {
	            this.style.loadJSON(style, options, previousStyle);
	        }
	        return this;
	    }
	    _lazyInitEmptyStyle() {
	        if (!this.style) {
	            this.style = new Style(this, {});
	            this.style.setEventedParent(this, { style: this.style });
	            this.style.loadEmpty();
	        }
	    }
	    _diffStyle(style, options) {
	        if (typeof style === 'string') {
	            const url = style;
	            const request = this._requestManager.transformRequest(url, "Style" /* ResourceType.Style */);
	            performance$1.getJSON(request, new AbortController()).then((response) => {
	                this._updateDiff(response.data, options);
	            }).catch((error) => {
	                if (error) {
	                    this.fire(new performance$1.ErrorEvent(error));
	                }
	            });
	        }
	        else if (typeof style === 'object') {
	            this._updateDiff(style, options);
	        }
	    }
	    _updateDiff(style, options) {
	        try {
	            if (this.style.setState(style, options)) {
	                this._update(true);
	            }
	        }
	        catch (e) {
	            performance$1.warnOnce(`Unable to perform style diff: ${e.message || e.error || e}.  Rebuilding the style from scratch.`);
	            this._updateStyle(style, options);
	        }
	    }
	    /**
	     * Returns the map's MapLibre style object, a JSON object which can be used to recreate the map's style.
	     *
	     * @returns The map's style JSON object.
	     *
	     * @example
	     * ```ts
	     * let styleJson = map.getStyle();
	     * ```
	     *
	     */
	    getStyle() {
	        if (this.style) {
	            return this.style.serialize();
	        }
	    }
	    /**
	     * Returns a Boolean indicating whether the map's style is fully loaded.
	     *
	     * @returns A Boolean indicating whether the style is fully loaded.
	     *
	     * @example
	     * ```ts
	     * let styleLoadStatus = map.isStyleLoaded();
	     * ```
	     */
	    isStyleLoaded() {
	        if (!this.style)
	            return performance$1.warnOnce('There is no style added to the map.');
	        return this.style.loaded();
	    }
	    /**
	     * Adds a source to the map's style.
	     *
	     * Events triggered:
	     *
	     * Triggers the `source.add` event.
	     *
	     * @param id - The ID of the source to add. Must not conflict with existing sources.
	     * @param source - The source object, conforming to the
	     * MapLibre Style Specification's [source definition](https://maplibre.org/maplibre-style-spec/sources) or
	     * {@link CanvasSourceSpecification}.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.addSource('my-data', {
	     *   type: 'vector',
	     *   url: 'https://demotiles.maplibre.org/tiles/tiles.json'
	     * });
	     * ```
	     * @example
	     * ```ts
	     * map.addSource('my-data', {
	     *   "type": "geojson",
	     *   "data": {
	     *     "type": "Feature",
	     *     "geometry": {
	     *       "type": "Point",
	     *       "coordinates": [-77.0323, 38.9131]
	     *     },
	     *     "properties": {
	     *       "title": "Mapbox DC",
	     *       "marker-symbol": "monument"
	     *     }
	     *   }
	     * });
	     * ```
	     * @see GeoJSON source: [Add live realtime data](https://maplibre.org/maplibre-gl-js/docs/examples/live-geojson/)
	     */
	    addSource(id, source) {
	        this._lazyInitEmptyStyle();
	        this.style.addSource(id, source);
	        return this._update(true);
	    }
	    /**
	     * Returns a Boolean indicating whether the source is loaded. Returns `true` if the source with
	     * the given ID in the map's style has no outstanding network requests, otherwise `false`.
	     *
	     * A {@link ErrorEvent} event will be fired if there is no source wit the specified ID.
	     *
	     * @param id - The ID of the source to be checked.
	     * @returns A Boolean indicating whether the source is loaded.
	     * @example
	     * ```ts
	     * let sourceLoaded = map.isSourceLoaded('bathymetry-data');
	     * ```
	     */
	    isSourceLoaded(id) {
	        const source = this.style && this.style.sourceCaches[id];
	        if (source === undefined) {
	            this.fire(new performance$1.ErrorEvent(new Error(`There is no source with ID '${id}'`)));
	            return;
	        }
	        return source.loaded();
	    }
	    /**
	     * Loads a 3D terrain mesh, based on a "raster-dem" source.
	     *
	     * Triggers the `terrain` event.
	     *
	     * @param options - Options object.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setTerrain({ source: 'terrain' });
	     * ```
	     */
	    setTerrain(options) {
	        this.style._checkLoaded();
	        // clear event handlers
	        if (this._terrainDataCallback)
	            this.style.off('data', this._terrainDataCallback);
	        if (!options) {
	            // remove terrain
	            if (this.terrain)
	                this.terrain.sourceCache.destruct();
	            this.terrain = null;
	            if (this.painter.renderToTexture)
	                this.painter.renderToTexture.destruct();
	            this.painter.renderToTexture = null;
	            this.transform.minElevationForCurrentTile = 0;
	            this.transform.elevation = 0;
	        }
	        else {
	            // add terrain
	            const sourceCache = this.style.sourceCaches[options.source];
	            if (!sourceCache)
	                throw new Error(`cannot load terrain, because there exists no source with ID: ${options.source}`);
	            // Update terrain tiles when adding new terrain
	            if (this.terrain === null)
	                sourceCache.reload();
	            // Warn once if user is using the same source for hillshade and terrain
	            for (const index in this.style._layers) {
	                const thisLayer = this.style._layers[index];
	                if (thisLayer.type === 'hillshade' && thisLayer.source === options.source) {
	                    performance$1.warnOnce('You are using the same source for a hillshade layer and for 3D terrain. Please consider using two separate sources to improve rendering quality.');
	                }
	            }
	            this.terrain = new Terrain(this.painter, sourceCache, options);
	            this.painter.renderToTexture = new RenderToTexture(this.painter, this.terrain);
	            this.transform.minElevationForCurrentTile = this.terrain.getMinTileElevationForLngLatZoom(this.transform.center, this.transform.tileZoom);
	            this.transform.elevation = this.terrain.getElevationForLngLatZoom(this.transform.center, this.transform.tileZoom);
	            this._terrainDataCallback = e => {
	                if (e.dataType === 'style') {
	                    this.terrain.sourceCache.freeRtt();
	                }
	                else if (e.dataType === 'source' && e.tile) {
	                    if (e.sourceId === options.source && !this._elevationFreeze) {
	                        this.transform.minElevationForCurrentTile = this.terrain.getMinTileElevationForLngLatZoom(this.transform.center, this.transform.tileZoom);
	                        this.transform.elevation = this.terrain.getElevationForLngLatZoom(this.transform.center, this.transform.tileZoom);
	                    }
	                    this.terrain.sourceCache.freeRtt(e.tile.tileID);
	                }
	            };
	            this.style.on('data', this._terrainDataCallback);
	        }
	        this.fire(new performance$1.Event('terrain', { terrain: options }));
	        return this;
	    }
	    /**
	     * Get the terrain-options if terrain is loaded
	     * @returns the TerrainSpecification passed to setTerrain
	     * @example
	     * ```ts
	     * map.getTerrain(); // { source: 'terrain' };
	     * ```
	     */
	    getTerrain() {
	        var _a, _b;
	        return (_b = (_a = this.terrain) === null || _a === void 0 ? void 0 : _a.options) !== null && _b !== void 0 ? _b : null;
	    }
	    /**
	     * Returns a Boolean indicating whether all tiles in the viewport from all sources on
	     * the style are loaded.
	     *
	     * @returns A Boolean indicating whether all tiles are loaded.
	     * @example
	     * ```ts
	     * let tilesLoaded = map.areTilesLoaded();
	     * ```
	     */
	    areTilesLoaded() {
	        const sources = this.style && this.style.sourceCaches;
	        for (const id in sources) {
	            const source = sources[id];
	            const tiles = source._tiles;
	            for (const t in tiles) {
	                const tile = tiles[t];
	                if (!(tile.state === 'loaded' || tile.state === 'errored'))
	                    return false;
	            }
	        }
	        return true;
	    }
	    /**
	     * Removes a source from the map's style.
	     *
	     * @param id - The ID of the source to remove.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.removeSource('bathymetry-data');
	     * ```
	     */
	    removeSource(id) {
	        this.style.removeSource(id);
	        return this._update(true);
	    }
	    /**
	     * Returns the source with the specified ID in the map's style.
	     *
	     * This method is often used to update a source using the instance members for the relevant
	     * source type as defined in [Sources](#sources).
	     * For example, setting the `data` for a GeoJSON source or updating the `url` and `coordinates`
	     * of an image source.
	     *
	     * @param id - The ID of the source to get.
	     * @returns The style source with the specified ID or `undefined` if the ID
	     * corresponds to no existing sources.
	     * The shape of the object varies by source type.
	     * A list of options for each source type is available on the MapLibre Style Specification's
	     * [Sources](https://maplibre.org/maplibre-style-spec/sources/) page.
	     * @example
	     * ```ts
	     * let sourceObject = map.getSource('points');
	     * ```
	     * @see [Create a draggable point](https://maplibre.org/maplibre-gl-js/docs/examples/drag-a-point/)
	     * @see [Animate a point](https://maplibre.org/maplibre-gl-js/docs/examples/animate-point-along-line/)
	     * @see [Add live realtime data](https://maplibre.org/maplibre-gl-js/docs/examples/live-geojson/)
	     */
	    getSource(id) {
	        return this.style.getSource(id);
	    }
	    /**
	     * Add an image to the style. This image can be displayed on the map like any other icon in the style's
	     * sprite using the image's ID with
	     * [`icon-image`](https://maplibre.org/maplibre-style-spec/layers/#layout-symbol-icon-image),
	     * [`background-pattern`](https://maplibre.org/maplibre-style-spec/layers/#paint-background-background-pattern),
	     * [`fill-pattern`](https://maplibre.org/maplibre-style-spec/layers/#paint-fill-fill-pattern),
	     * or [`line-pattern`](https://maplibre.org/maplibre-style-spec/layers/#paint-line-line-pattern).
	     *
	     * A {@link ErrorEvent} event will be fired if the image parameter is invalid or there is not enough space in the sprite to add this image.
	     *
	     * @param id - The ID of the image.
	     * @param image - The image as an `HTMLImageElement`, `ImageData`, `ImageBitmap` or object with `width`, `height`, and `data`
	     * properties with the same format as `ImageData`.
	     * @param options - Options object.
	     * @returns `this`
	     * @example
	     * ```ts
	     * // If the style's sprite does not already contain an image with ID 'cat',
	     * // add the image 'cat-icon.png' to the style's sprite with the ID 'cat'.
	     * map.loadImage('https://upload.wikimedia.org/wikipedia/commons/thumb/6/60/Cat_silhouette.svg/400px-Cat_silhouette.svg.png', function(error, image) {
	     *    if (error) throw error;
	     *    if (!map.hasImage('cat')) map.addImage('cat', image);
	     * });
	     *
	     * // Add a stretchable image that can be used with `icon-text-fit`
	     * // In this example, the image is 600px wide by 400px high.
	     * map.loadImage('https://upload.wikimedia.org/wikipedia/commons/8/89/Black_and_White_Boxed_%28bordered%29.png', function(error, image) {
	     *    if (error) throw error;
	     *    if (!map.hasImage('border-image')) {
	     *      map.addImage('border-image', image, {
	     *          content: [16, 16, 300, 384], // place text over left half of image, avoiding the 16px border
	     *          stretchX: [[16, 584]], // stretch everything horizontally except the 16px border
	     *          stretchY: [[16, 384]], // stretch everything vertically except the 16px border
	     *      });
	     *    }
	     * });
	     * ```
	     * @see Use `HTMLImageElement`: [Add an icon to the map](https://maplibre.org/maplibre-gl-js/docs/examples/add-image/)
	     * @see Use `ImageData`: [Add a generated icon to the map](https://maplibre.org/maplibre-gl-js/docs/examples/add-image-generated/)
	     */
	    addImage(id, image, options = {}) {
	        const { pixelRatio = 1, sdf = false, stretchX, stretchY, content, contentMatch } = options;
	        this._lazyInitEmptyStyle();
	        const version = 0;
	        if (image instanceof HTMLImageElement || performance$1.isImageBitmap(image)) {
	            const { width, height, data } = browser.getImageData(image);
	            this.style.addImage(id, { data: new performance$1.RGBAImage({ width, height }, data), pixelRatio, stretchX, stretchY, content, contentMatch, sdf, version });
	        }
	        else if (image.width === undefined || image.height === undefined) {
	            return this.fire(new performance$1.ErrorEvent(new Error('Invalid arguments to map.addImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, ' +
	                'or object with `width`, `height`, and `data` properties with the same format as `ImageData`')));
	        }
	        else {
	            const { width, height, data } = image;
	            const userImage = image;
	            this.style.addImage(id, {
	                data: new performance$1.RGBAImage({ width, height }, new Uint8Array(data)),
	                pixelRatio,
	                stretchX,
	                stretchY,
	                content,
	                contentMatch,
	                sdf,
	                version,
	                userImage
	            });
	            if (userImage.onAdd) {
	                userImage.onAdd(this, id);
	            }
	            return this;
	        }
	    }
	    /**
	     * Update an existing image in a style. This image can be displayed on the map like any other icon in the style's
	     * sprite using the image's ID with
	     * [`icon-image`](https://maplibre.org/maplibre-style-spec/layers/#layout-symbol-icon-image),
	     * [`background-pattern`](https://maplibre.org/maplibre-style-spec/layers/#paint-background-background-pattern),
	     * [`fill-pattern`](https://maplibre.org/maplibre-style-spec/layers/#paint-fill-fill-pattern),
	     * or [`line-pattern`](https://maplibre.org/maplibre-style-spec/layers/#paint-line-line-pattern).
	     *
	     * An {@link ErrorEvent} will be fired if the image parameter is invald.
	     *
	     * @param id - The ID of the image.
	     * @param image - The image as an `HTMLImageElement`, `ImageData`, `ImageBitmap` or object with `width`, `height`, and `data`
	     * properties with the same format as `ImageData`.
	     * @returns `this`
	     * @example
	     * ```ts
	     * // If an image with the ID 'cat' already exists in the style's sprite,
	     * // replace that image with a new image, 'other-cat-icon.png'.
	     * if (map.hasImage('cat')) map.updateImage('cat', './other-cat-icon.png');
	     * ```
	     */
	    updateImage(id, image) {
	        const existingImage = this.style.getImage(id);
	        if (!existingImage) {
	            return this.fire(new performance$1.ErrorEvent(new Error('The map has no image with that id. If you are adding a new image use `map.addImage(...)` instead.')));
	        }
	        const imageData = (image instanceof HTMLImageElement || performance$1.isImageBitmap(image)) ?
	            browser.getImageData(image) :
	            image;
	        const { width, height, data } = imageData;
	        if (width === undefined || height === undefined) {
	            return this.fire(new performance$1.ErrorEvent(new Error('Invalid arguments to map.updateImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, ' +
	                'or object with `width`, `height`, and `data` properties with the same format as `ImageData`')));
	        }
	        if (width !== existingImage.data.width || height !== existingImage.data.height) {
	            return this.fire(new performance$1.ErrorEvent(new Error('The width and height of the updated image must be that same as the previous version of the image')));
	        }
	        const copy = !(image instanceof HTMLImageElement || performance$1.isImageBitmap(image));
	        existingImage.data.replace(data, copy);
	        this.style.updateImage(id, existingImage);
	        return this;
	    }
	    /**
	     * Returns an image, specified by ID, currently available in the map.
	     * This includes both images from the style's original sprite
	     * and any images that have been added at runtime using {@link Map#addImage}.
	     *
	     * @param id - The ID of the image.
	     * @returns An image in the map with the specified ID.
	     *
	     * @example
	     * ```ts
	     * let coffeeShopIcon = map.getImage("coffee_cup");
	     * ```
	     */
	    getImage(id) {
	        return this.style.getImage(id);
	    }
	    /**
	     * Check whether or not an image with a specific ID exists in the style. This checks both images
	     * in the style's original sprite and any images
	     * that have been added at runtime using {@link Map#addImage}.
	     *
	     * An {@link ErrorEvent} will be fired if the image parameter is invald.
	     *
	     * @param id - The ID of the image.
	     *
	     * @returns A Boolean indicating whether the image exists.
	     * @example
	     * Check if an image with the ID 'cat' exists in the style's sprite.
	     * ```ts
	     * let catIconExists = map.hasImage('cat');
	     * ```
	     */
	    hasImage(id) {
	        if (!id) {
	            this.fire(new performance$1.ErrorEvent(new Error('Missing required image id')));
	            return false;
	        }
	        return !!this.style.getImage(id);
	    }
	    /**
	     * Remove an image from a style. This can be an image from the style's original
	     * sprite or any images
	     * that have been added at runtime using {@link Map#addImage}.
	     *
	     * @param id - The ID of the image.
	     *
	     * @example
	     * ```ts
	     * // If an image with the ID 'cat' exists in
	     * // the style's sprite, remove it.
	     * if (map.hasImage('cat')) map.removeImage('cat');
	     * ```
	     */
	    removeImage(id) {
	        this.style.removeImage(id);
	    }
	    /**
	     * Load an image from an external URL to be used with {@link Map#addImage}. External
	     * domains must support [CORS](https://developer.mozilla.org/en-US/docs/Web/HTTP/Access_control_CORS).
	     *
	     * @param url - The URL of the image file. Image file must be in png, webp, or jpg format.
	     * @returns a promise that is resolved when the image is loaded
	     *
	     * @example
	     * Load an image from an external URL.
	     * ```ts
	     * const response = await map.loadImage('http://placekitten.com/50/50');
	     * // Add the loaded image to the style's sprite with the ID 'kitten'.
	     * map.addImage('kitten', response.data);
	     * ```
	     * @see [Add an icon to the map](https://maplibre.org/maplibre-gl-js/docs/examples/add-image/)
	     */
	    loadImage(url) {
	        return ImageRequest.getImage(this._requestManager.transformRequest(url, "Image" /* ResourceType.Image */), new AbortController());
	    }
	    /**
	     * Returns an Array of strings containing the IDs of all images currently available in the map.
	     * This includes both images from the style's original sprite
	     * and any images that have been added at runtime using {@link Map#addImage}.
	     *
	     * @returns An Array of strings containing the names of all sprites/images currently available in the map.
	     *
	     * @example
	     * ```ts
	     * let allImages = map.listImages();
	     * ```
	     */
	    listImages() {
	        return this.style.listImages();
	    }
	    /**
	     * Adds a [MapLibre style layer](https://maplibre.org/maplibre-style-spec/layers)
	     * to the map's style.
	     *
	     * A layer defines how data from a specified source will be styled. Read more about layer types
	     * and available paint and layout properties in the [MapLibre Style Specification](https://maplibre.org/maplibre-style-spec/layers).
	     *
	     * @param layer - The layer to add,
	     * conforming to either the MapLibre Style Specification's [layer definition](https://maplibre.org/maplibre-style-spec/layers) or,
	     * less commonly, the {@link CustomLayerInterface} specification. Can also be a layer definition with an embedded source definition.
	     * The MapLibre Style Specification's layer definition is appropriate for most layers.
	     *
	     * @param beforeId - The ID of an existing layer to insert the new layer before,
	     * resulting in the new layer appearing visually beneath the existing layer.
	     * If this argument is not specified, the layer will be appended to the end of the layers array
	     * and appear visually above all other layers.
	     *
	     * @returns `this`
	     *
	     * @example
	     * Add a circle layer with a vector source
	     * ```ts
	     * map.addLayer({
	     *   id: 'points-of-interest',
	     *   source: {
	     *     type: 'vector',
	     *     url: 'https://demotiles.maplibre.org/tiles/tiles.json'
	     *   },
	     *   'source-layer': 'poi_label',
	     *   type: 'circle',
	     *   paint: {
	     *     // MapLibre Style Specification paint properties
	     *   },
	     *   layout: {
	     *     // MapLibre Style Specification layout properties
	     *   }
	     * });
	     * ```
	     *
	     * @example
	     * Define a source before using it to create a new layer
	     * ```ts
	     * map.addSource('state-data', {
	     *   type: 'geojson',
	     *   data: 'path/to/data.geojson'
	     * });
	     *
	     * map.addLayer({
	     *   id: 'states',
	     *   // References the GeoJSON source defined above
	     *   // and does not require a `source-layer`
	     *   source: 'state-data',
	     *   type: 'symbol',
	     *   layout: {
	     *     // Set the label content to the
	     *     // feature's `name` property
	     *     text-field: ['get', 'name']
	     *   }
	     * });
	     * ```
	     *
	     * @example
	     * Add a new symbol layer before an existing layer
	     * ```ts
	     * map.addLayer({
	     *   id: 'states',
	     *   // References a source that's already been defined
	     *   source: 'state-data',
	     *   type: 'symbol',
	     *   layout: {
	     *     // Set the label content to the
	     *     // feature's `name` property
	     *     text-field: ['get', 'name']
	     *   }
	     * // Add the layer before the existing `cities` layer
	     * }, 'cities');
	     * ```
	     * @see [Create and style clusters](https://maplibre.org/maplibre-gl-js/docs/examples/cluster/)
	     * @see [Add a vector tile source](https://maplibre.org/maplibre-gl-js/docs/examples/vector-source/)
	     * @see [Add a WMS source](https://maplibre.org/maplibre-gl-js/docs/examples/wms/)
	     */
	    addLayer(layer, beforeId) {
	        this._lazyInitEmptyStyle();
	        this.style.addLayer(layer, beforeId);
	        return this._update(true);
	    }
	    /**
	     * Moves a layer to a different z-position.
	     *
	     * @param id - The ID of the layer to move.
	     * @param beforeId - The ID of an existing layer to insert the new layer before. When viewing the map, the `id` layer will appear beneath the `beforeId` layer. If `beforeId` is omitted, the layer will be appended to the end of the layers array and appear above all other layers on the map.
	     * @returns `this`
	     *
	     * @example
	     * Move a layer with ID 'polygon' before the layer with ID 'country-label'. The `polygon` layer will appear beneath the `country-label` layer on the map.
	     * ```ts
	     * map.moveLayer('polygon', 'country-label');
	     * ```
	     */
	    moveLayer(id, beforeId) {
	        this.style.moveLayer(id, beforeId);
	        return this._update(true);
	    }
	    /**
	     * Removes the layer with the given ID from the map's style.
	     *
	     * An {@link ErrorEvent} will be fired if the image parameter is invald.
	     *
	     * @param id - The ID of the layer to remove
	     * @returns `this`
	     *
	     * @example
	     * If a layer with ID 'state-data' exists, remove it.
	     * ```ts
	     * if (map.getLayer('state-data')) map.removeLayer('state-data');
	     * ```
	     */
	    removeLayer(id) {
	        this.style.removeLayer(id);
	        return this._update(true);
	    }
	    /**
	     * Returns the layer with the specified ID in the map's style.
	     *
	     * @param id - The ID of the layer to get.
	     * @returns The layer with the specified ID, or `undefined`
	     * if the ID corresponds to no existing layers.
	     *
	     * @example
	     * ```ts
	     * let stateDataLayer = map.getLayer('state-data');
	     * ```
	     * @see [Filter symbols by toggling a list](https://maplibre.org/maplibre-gl-js/docs/examples/filter-markers/)
	     * @see [Filter symbols by text input](https://maplibre.org/maplibre-gl-js/docs/examples/filter-markers-by-input/)
	     */
	    getLayer(id) {
	        return this.style.getLayer(id);
	    }
	    /**
	     * Return the ids of all layers currently in the style, including custom layers, in order.
	     *
	     * @returns ids of layers, in order
	     *
	     * @example
	     * ```ts
	     * const orderedLayerIds = map.getLayersOrder();
	     * ```
	     */
	    getLayersOrder() {
	        return this.style.getLayersOrder();
	    }
	    /**
	     * Sets the zoom extent for the specified style layer. The zoom extent includes the
	     * [minimum zoom level](https://maplibre.org/maplibre-style-spec/layers/#minzoom)
	     * and [maximum zoom level](https://maplibre.org/maplibre-style-spec/layers/#maxzoom))
	     * at which the layer will be rendered.
	     *
	     * Note: For style layers using vector sources, style layers cannot be rendered at zoom levels lower than the
	     * minimum zoom level of the _source layer_ because the data does not exist at those zoom levels. If the minimum
	     * zoom level of the source layer is higher than the minimum zoom level defined in the style layer, the style
	     * layer will not be rendered at all zoom levels in the zoom range.
	     *
	     * @param layerId - The ID of the layer to which the zoom extent will be applied.
	     * @param minzoom - The minimum zoom to set (0-24).
	     * @param maxzoom - The maximum zoom to set (0-24).
	     * @returns `this`
	     *
	     * @example
	     * ```ts
	     * map.setLayerZoomRange('my-layer', 2, 5);
	     * ```
	     */
	    setLayerZoomRange(layerId, minzoom, maxzoom) {
	        this.style.setLayerZoomRange(layerId, minzoom, maxzoom);
	        return this._update(true);
	    }
	    /**
	     * Sets the filter for the specified style layer.
	     *
	     * Filters control which features a style layer renders from its source.
	     * Any feature for which the filter expression evaluates to `true` will be
	     * rendered on the map. Those that are false will be hidden.
	     *
	     * Use `setFilter` to show a subset of your source data.
	     *
	     * To clear the filter, pass `null` or `undefined` as the second parameter.
	     *
	     * @param layerId - The ID of the layer to which the filter will be applied.
	     * @param filter - The filter, conforming to the MapLibre Style Specification's
	     * [filter definition](https://maplibre.org/maplibre-style-spec/layers/#filter).  If `null` or `undefined` is provided, the function removes any existing filter from the layer.
	     * @param options - Options object.
	     * @returns `this`
	     *
	     * @example
	     * Display only features with the 'name' property 'USA'
	     * ```ts
	     * map.setFilter('my-layer', ['==', ['get', 'name'], 'USA']);
	     * ```
	     * @example
	     * Display only features with five or more 'available-spots'
	     * ```ts
	     * map.setFilter('bike-docks', ['>=', ['get', 'available-spots'], 5]);
	     * ```
	     * @example
	     * Remove the filter for the 'bike-docks' style layer
	     * ```ts
	     * map.setFilter('bike-docks', null);
	     * ```
	     * @see [Create a timeline animation](https://maplibre.org/maplibre-gl-js/docs/examples/timeline-animation/)
	     */
	    setFilter(layerId, filter, options = {}) {
	        this.style.setFilter(layerId, filter, options);
	        return this._update(true);
	    }
	    /**
	     * Returns the filter applied to the specified style layer.
	     *
	     * @param layerId - The ID of the style layer whose filter to get.
	     * @returns The layer's filter.
	     */
	    getFilter(layerId) {
	        return this.style.getFilter(layerId);
	    }
	    /**
	     * Sets the value of a paint property in the specified style layer.
	     *
	     * @param layerId - The ID of the layer to set the paint property in.
	     * @param name - The name of the paint property to set.
	     * @param value - The value of the paint property to set.
	     * Must be of a type appropriate for the property, as defined in the [MapLibre Style Specification](https://maplibre.org/maplibre-style-spec/).
	     * Pass `null` to unset the existing value.
	     * @param options - Options object.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setPaintProperty('my-layer', 'fill-color', '#faafee');
	     * ```
	     * @see [Change a layer's color with buttons](https://maplibre.org/maplibre-gl-js/docs/examples/color-switcher/)
	     * @see [Create a draggable point](https://maplibre.org/maplibre-gl-js/docs/examples/drag-a-point/)
	     */
	    setPaintProperty(layerId, name, value, options = {}) {
	        this.style.setPaintProperty(layerId, name, value, options);
	        return this._update(true);
	    }
	    /**
	     * Returns the value of a paint property in the specified style layer.
	     *
	     * @param layerId - The ID of the layer to get the paint property from.
	     * @param name - The name of a paint property to get.
	     * @returns The value of the specified paint property.
	     */
	    getPaintProperty(layerId, name) {
	        return this.style.getPaintProperty(layerId, name);
	    }
	    /**
	     * Sets the value of a layout property in the specified style layer.
	     *
	     * @param layerId - The ID of the layer to set the layout property in.
	     * @param name - The name of the layout property to set.
	     * @param value - The value of the layout property. Must be of a type appropriate for the property, as defined in the [MapLibre Style Specification](https://maplibre.org/maplibre-style-spec/).
	     * @param options - The options object.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setLayoutProperty('my-layer', 'visibility', 'none');
	     * ```
	     */
	    setLayoutProperty(layerId, name, value, options = {}) {
	        this.style.setLayoutProperty(layerId, name, value, options);
	        return this._update(true);
	    }
	    /**
	     * Returns the value of a layout property in the specified style layer.
	     *
	     * @param layerId - The ID of the layer to get the layout property from.
	     * @param name - The name of the layout property to get.
	     * @returns The value of the specified layout property.
	     */
	    getLayoutProperty(layerId, name) {
	        return this.style.getLayoutProperty(layerId, name);
	    }
	    /**
	     * Sets the value of the style's glyphs property.
	     *
	     * @param glyphsUrl - Glyph URL to set. Must conform to the [MapLibre Style Specification](https://maplibre.org/maplibre-style-spec/glyphs/).
	     * @param options - Options object.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setGlyphs('https://demotiles.maplibre.org/font/{fontstack}/{range}.pbf');
	     * ```
	     */
	    setGlyphs(glyphsUrl, options = {}) {
	        this._lazyInitEmptyStyle();
	        this.style.setGlyphs(glyphsUrl, options);
	        return this._update(true);
	    }
	    /**
	     * Returns the value of the style's glyphs URL
	     *
	     * @returns glyphs Style's glyphs url
	     */
	    getGlyphs() {
	        return this.style.getGlyphsUrl();
	    }
	    /**
	     * Adds a sprite to the map's style. Fires the `style` event.
	     *
	     * @param id - The ID of the sprite to add. Must not conflict with existing sprites.
	     * @param url - The URL to load the sprite from
	     * @param options - Options object.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.addSprite('sprite-two', 'http://example.com/sprite-two');
	     * ```
	     */
	    addSprite(id, url, options = {}) {
	        this._lazyInitEmptyStyle();
	        this.style.addSprite(id, url, options, (err) => {
	            if (!err) {
	                this._update(true);
	            }
	        });
	        return this;
	    }
	    /**
	     * Removes the sprite from the map's style. Fires the `style` event.
	     *
	     * @param id - The ID of the sprite to remove. If the sprite is declared as a single URL, the ID must be "default".
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.removeSprite('sprite-two');
	     * map.removeSprite('default');
	     * ```
	     */
	    removeSprite(id) {
	        this._lazyInitEmptyStyle();
	        this.style.removeSprite(id);
	        return this._update(true);
	    }
	    /**
	     * Returns the as-is value of the style's sprite.
	     *
	     * @returns style's sprite list of id-url pairs
	     */
	    getSprite() {
	        return this.style.getSprite();
	    }
	    /**
	     * Sets the value of the style's sprite property.
	     *
	     * @param spriteUrl - Sprite URL to set.
	     * @param options - Options object.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.setSprite('YOUR_SPRITE_URL');
	     * ```
	     */
	    setSprite(spriteUrl, options = {}) {
	        this._lazyInitEmptyStyle();
	        this.style.setSprite(spriteUrl, options, (err) => {
	            if (!err) {
	                this._update(true);
	            }
	        });
	        return this;
	    }
	    /**
	     * Sets the any combination of light values.
	     *
	     * @param light - Light properties to set. Must conform to the [MapLibre Style Specification](https://maplibre.org/maplibre-style-spec/light).
	     * @param options - Options object.
	     * @returns `this`
	     *
	     * @example
	     * ```ts
	     * let layerVisibility = map.getLayoutProperty('my-layer', 'visibility');
	     * ```
	     */
	    setLight(light, options = {}) {
	        this._lazyInitEmptyStyle();
	        this.style.setLight(light, options);
	        return this._update(true);
	    }
	    /**
	     * Returns the value of the light object.
	     *
	     * @returns light Light properties of the style.
	     */
	    getLight() {
	        return this.style.getLight();
	    }
	    /**
	     * Sets the `state` of a feature.
	     * A feature's `state` is a set of user-defined key-value pairs that are assigned to a feature at runtime.
	     * When using this method, the `state` object is merged with any existing key-value pairs in the feature's state.
	     * Features are identified by their `feature.id` attribute, which can be any number or string.
	     *
	     * This method can only be used with sources that have a `feature.id` attribute. The `feature.id` attribute can be defined in three ways:
	     *
	     * - For vector or GeoJSON sources, including an `id` attribute in the original data file.
	     * - For vector or GeoJSON sources, using the [`promoteId`](https://maplibre.org/maplibre-style-spec/sources/#vector-promoteId) option at the time the source is defined.
	     * - For GeoJSON sources, using the [`generateId`](https://maplibre.org/maplibre-style-spec/sources/#geojson-generateId) option to auto-assign an `id` based on the feature's index in the source data. If you change feature data using `map.getSource('some id').setData(..)`, you may need to re-apply state taking into account updated `id` values.
	     *
	     * _Note: You can use the [`feature-state` expression](https://maplibre.org/maplibre-style-spec/expressions/#feature-state) to access the values in a feature's state object for the purposes of styling._
	     *
	     * @param feature - Feature identifier. Feature objects returned from
	     * {@link Map#queryRenderedFeatures} or event handlers can be used as feature identifiers.
	     * @param state - A set of key-value pairs. The values should be valid JSON types.
	     * @returns `this`
	     *
	     * @example
	     * ```ts
	     * // When the mouse moves over the `my-layer` layer, update
	     * // the feature state for the feature under the mouse
	     * map.on('mousemove', 'my-layer', function(e) {
	     *   if (e.features.length > 0) {
	     *     map.setFeatureState({
	     *       source: 'my-source',
	     *       sourceLayer: 'my-source-layer',
	     *       id: e.features[0].id,
	     *     }, {
	     *       hover: true
	     *     });
	     *   }
	     * });
	     * ```
	     * @see [Create a hover effect](https://maplibre.org/maplibre-gl-js/docs/examples/hover-styles/)
	     */
	    setFeatureState(feature, state) {
	        this.style.setFeatureState(feature, state);
	        return this._update();
	    }
	    /**
	     * Removes the `state` of a feature, setting it back to the default behavior.
	     * If only a `target.source` is specified, it will remove the state for all features from that source.
	     * If `target.id` is also specified, it will remove all keys for that feature's state.
	     * If `key` is also specified, it removes only that key from that feature's state.
	     * Features are identified by their `feature.id` attribute, which can be any number or string.
	     *
	     * @param target - Identifier of where to remove state. It can be a source, a feature, or a specific key of feature.
	     * Feature objects returned from {@link Map#queryRenderedFeatures} or event handlers can be used as feature identifiers.
	     * @param key - (optional) The key in the feature state to reset.
	     * @returns `this`
	     * @example
	     * Reset the entire state object for all features in the `my-source` source
	     * ```ts
	     * map.removeFeatureState({
	     *   source: 'my-source'
	     * });
	     * ```
	     *
	     * @example
	     * When the mouse leaves the `my-layer` layer,
	     * reset the entire state object for the
	     * feature under the mouse
	     * ```ts
	     * map.on('mouseleave', 'my-layer', function(e) {
	     *   map.removeFeatureState({
	     *     source: 'my-source',
	     *     sourceLayer: 'my-source-layer',
	     *     id: e.features[0].id
	     *   });
	     * });
	     * ```
	     *
	     * @example
	     * When the mouse leaves the `my-layer` layer,
	     * reset only the `hover` key-value pair in the
	     * state for the feature under the mouse
	     * ```ts
	     * map.on('mouseleave', 'my-layer', function(e) {
	     *   map.removeFeatureState({
	     *     source: 'my-source',
	     *     sourceLayer: 'my-source-layer',
	     *     id: e.features[0].id
	     *   }, 'hover');
	     * });
	     * ```
	     */
	    removeFeatureState(target, key) {
	        this.style.removeFeatureState(target, key);
	        return this._update();
	    }
	    /**
	     * Gets the `state` of a feature.
	     * A feature's `state` is a set of user-defined key-value pairs that are assigned to a feature at runtime.
	     * Features are identified by their `feature.id` attribute, which can be any number or string.
	     *
	     * _Note: To access the values in a feature's state object for the purposes of styling the feature, use the [`feature-state` expression](https://maplibre.org/maplibre-style-spec/expressions/#feature-state)._
	     *
	     * @param feature - Feature identifier. Feature objects returned from
	     * {@link Map#queryRenderedFeatures} or event handlers can be used as feature identifiers.
	     * @returns The state of the feature: a set of key-value pairs that was assigned to the feature at runtime.
	     *
	     * @example
	     * When the mouse moves over the `my-layer` layer,
	     * get the feature state for the feature under the mouse
	     * ```ts
	     * map.on('mousemove', 'my-layer', function(e) {
	     *   if (e.features.length > 0) {
	     *     map.getFeatureState({
	     *       source: 'my-source',
	     *       sourceLayer: 'my-source-layer',
	     *       id: e.features[0].id
	     *     });
	     *   }
	     * });
	     * ```
	     */
	    getFeatureState(feature) {
	        return this.style.getFeatureState(feature);
	    }
	    /**
	     * Returns the map's containing HTML element.
	     *
	     * @returns The map's container.
	     */
	    getContainer() {
	        return this._container;
	    }
	    /**
	     * Returns the HTML element containing the map's `<canvas>` element.
	     *
	     * If you want to add non-GL overlays to the map, you should append them to this element.
	     *
	     * This is the element to which event bindings for map interactivity (such as panning and zooming) are
	     * attached. It will receive bubbled events from child elements such as the `<canvas>`, but not from
	     * map controls.
	     *
	     * @returns The container of the map's `<canvas>`.
	     * @see [Create a draggable point](https://maplibre.org/maplibre-gl-js/docs/examples/drag-a-point/)
	     */
	    getCanvasContainer() {
	        return this._canvasContainer;
	    }
	    /**
	     * Returns the map's `<canvas>` element.
	     *
	     * @returns The map's `<canvas>` element.
	     * @see [Measure distances](https://maplibre.org/maplibre-gl-js/docs/examples/measure/)
	     * @see [Display a popup on hover](https://maplibre.org/maplibre-gl-js/docs/examples/popup-on-hover/)
	     * @see [Center the map on a clicked symbol](https://maplibre.org/maplibre-gl-js/docs/examples/center-on-symbol/)
	     */
	    getCanvas() {
	        return this._canvas;
	    }
	    _containerDimensions() {
	        let width = 0;
	        let height = 0;
	        if (this._container) {
	            width = this._container.clientWidth || 400;
	            height = this._container.clientHeight || 300;
	        }
	        return [width, height];
	    }
	    _setupContainer() {
	        const container = this._container;
	        container.classList.add('maplibregl-map');
	        const canvasContainer = this._canvasContainer = DOM.create('div', 'maplibregl-canvas-container', container);
	        if (this._interactive) {
	            canvasContainer.classList.add('maplibregl-interactive');
	        }
	        this._canvas = DOM.create('canvas', 'maplibregl-canvas', canvasContainer);
	        this._canvas.addEventListener('webglcontextlost', this._contextLost, false);
	        this._canvas.addEventListener('webglcontextrestored', this._contextRestored, false);
	        this._canvas.setAttribute('tabindex', '0');
	        this._canvas.setAttribute('aria-label', 'Map');
	        this._canvas.setAttribute('role', 'region');
	        const dimensions = this._containerDimensions();
	        const clampedPixelRatio = this._getClampedPixelRatio(dimensions[0], dimensions[1]);
	        this._resizeCanvas(dimensions[0], dimensions[1], clampedPixelRatio);
	        const controlContainer = this._controlContainer = DOM.create('div', 'maplibregl-control-container', container);
	        const positions = this._controlPositions = {};
	        ['top-left', 'top-right', 'bottom-left', 'bottom-right'].forEach((positionName) => {
	            positions[positionName] = DOM.create('div', `maplibregl-ctrl-${positionName} `, controlContainer);
	        });
	        this._container.addEventListener('scroll', this._onMapScroll, false);
	    }
	    _resizeCanvas(width, height, pixelRatio) {
	        // Request the required canvas size taking the pixelratio into account.
	        this._canvas.width = Math.floor(pixelRatio * width);
	        this._canvas.height = Math.floor(pixelRatio * height);
	        // Maintain the same canvas size, potentially downscaling it for HiDPI displays
	        this._canvas.style.width = `${width}px`;
	        this._canvas.style.height = `${height}px`;
	    }
	    _setupPainter() {
	        const attributes = {
	            alpha: true,
	            stencil: true,
	            depth: true,
	            failIfMajorPerformanceCaveat: this._failIfMajorPerformanceCaveat,
	            preserveDrawingBuffer: this._preserveDrawingBuffer,
	            antialias: this._antialias || false
	        };
	        let webglcontextcreationerrorDetailObject = null;
	        this._canvas.addEventListener('webglcontextcreationerror', (args) => {
	            webglcontextcreationerrorDetailObject = { requestedAttributes: attributes };
	            if (args) {
	                webglcontextcreationerrorDetailObject.statusMessage = args.statusMessage;
	                webglcontextcreationerrorDetailObject.type = args.type;
	            }
	        }, { once: true });
	        const gl = this._canvas.getContext('webgl2', attributes) ||
	            this._canvas.getContext('webgl', attributes);
	        if (!gl) {
	            const msg = 'Failed to initialize WebGL';
	            if (webglcontextcreationerrorDetailObject) {
	                webglcontextcreationerrorDetailObject.message = msg;
	                throw new Error(JSON.stringify(webglcontextcreationerrorDetailObject));
	            }
	            else {
	                throw new Error(msg);
	            }
	        }
	        this.painter = new Painter(gl, this.transform);
	        webpSupported.testSupport(gl);
	    }
	    /**
	     * Returns a Boolean indicating whether the map is fully loaded.
	     *
	     * Returns `false` if the style is not yet fully loaded,
	     * or if there has been a change to the sources or style that
	     * has not yet fully loaded.
	     *
	     * @returns A Boolean indicating whether the map is fully loaded.
	     */
	    loaded() {
	        return !this._styleDirty && !this._sourcesDirty && !!this.style && this.style.loaded();
	    }
	    /**
	     * @internal
	     * Update this map's style and sources, and re-render the map.
	     *
	     * @param updateStyle - mark the map's style for reprocessing as
	     * well as its sources
	     * @returns `this`
	     */
	    _update(updateStyle) {
	        if (!this.style || !this.style._loaded)
	            return this;
	        this._styleDirty = this._styleDirty || updateStyle;
	        this._sourcesDirty = true;
	        this.triggerRepaint();
	        return this;
	    }
	    /**
	     * @internal
	     * Request that the given callback be executed during the next render
	     * frame.  Schedule a render frame if one is not already scheduled.
	     *
	     * @returns An id that can be used to cancel the callback
	     */
	    _requestRenderFrame(callback) {
	        this._update();
	        return this._renderTaskQueue.add(callback);
	    }
	    _cancelRenderFrame(id) {
	        this._renderTaskQueue.remove(id);
	    }
	    /**
	     * @internal
	     * Call when a (re-)render of the map is required:
	     *
	     * - The style has changed (`setPaintProperty()`, etc.)
	     * - Source data has changed (e.g. tiles have finished loading)
	     * - The map has is moving (or just finished moving)
	     * - A transition is in progress
	     *
	     * @param paintStartTimeStamp - The time when the animation frame began executing.
	     *
	     * @returns `this`
	     */
	    _render(paintStartTimeStamp) {
	        const fadeDuration = this._idleTriggered ? this._fadeDuration : 0;
	        // A custom layer may have used the context asynchronously. Mark the state as dirty.
	        this.painter.context.setDirty();
	        this.painter.setBaseState();
	        this._renderTaskQueue.run(paintStartTimeStamp);
	        // A task queue callback may have fired a user event which may have removed the map
	        if (this._removed)
	            return;
	        let crossFading = false;
	        // If the style has changed, the map is being zoomed, or a transition or fade is in progress:
	        //  - Apply style changes (in a batch)
	        //  - Recalculate paint properties.
	        if (this.style && this._styleDirty) {
	            this._styleDirty = false;
	            const zoom = this.transform.zoom;
	            const now = browser.now();
	            this.style.zoomHistory.update(zoom, now);
	            const parameters = new performance$1.EvaluationParameters(zoom, {
	                now,
	                fadeDuration,
	                zoomHistory: this.style.zoomHistory,
	                transition: this.style.getTransition()
	            });
	            const factor = parameters.crossFadingFactor();
	            if (factor !== 1 || factor !== this._crossFadingFactor) {
	                crossFading = true;
	                this._crossFadingFactor = factor;
	            }
	            this.style.update(parameters);
	        }
	        // If we are in _render for any reason other than an in-progress paint
	        // transition, update source caches to check for and load any tiles we
	        // need for the current transform
	        if (this.style && this._sourcesDirty) {
	            this._sourcesDirty = false;
	            this.style._updateSources(this.transform);
	        }
	        // update terrain stuff
	        if (this.terrain) {
	            this.terrain.sourceCache.update(this.transform, this.terrain);
	            this.transform.minElevationForCurrentTile = this.terrain.getMinTileElevationForLngLatZoom(this.transform.center, this.transform.tileZoom);
	            if (!this._elevationFreeze) {
	                this.transform.elevation = this.terrain.getElevationForLngLatZoom(this.transform.center, this.transform.tileZoom);
	            }
	        }
	        else {
	            this.transform.minElevationForCurrentTile = 0;
	            this.transform.elevation = 0;
	        }
	        this._placementDirty = this.style && this.style._updatePlacement(this.painter.transform, this.showCollisionBoxes, fadeDuration, this._crossSourceCollisions);
	        // Actually draw
	        this.painter.render(this.style, {
	            showTileBoundaries: this.showTileBoundaries,
	            showOverdrawInspector: this._showOverdrawInspector,
	            rotating: this.isRotating(),
	            zooming: this.isZooming(),
	            moving: this.isMoving(),
	            fadeDuration,
	            showPadding: this.showPadding,
	        });
	        this.fire(new performance$1.Event('render'));
	        if (this.loaded() && !this._loaded) {
	            this._loaded = true;
	            performance$1.PerformanceUtils.mark(performance$1.PerformanceMarkers.load);
	            this.fire(new performance$1.Event('load'));
	        }
	        if (this.style && (this.style.hasTransitions() || crossFading)) {
	            this._styleDirty = true;
	        }
	        if (this.style && !this._placementDirty) {
	            // Since no fade operations are in progress, we can release
	            // all tiles held for fading. If we didn't do this, the tiles
	            // would just sit in the SourceCaches until the next render
	            this.style._releaseSymbolFadeTiles();
	        }
	        // Schedule another render frame if it's needed.
	        //
	        // Even though `_styleDirty` and `_sourcesDirty` are reset in this
	        // method, synchronous events fired during Style#update or
	        // Style#_updateSources could have caused them to be set again.
	        const somethingDirty = this._sourcesDirty || this._styleDirty || this._placementDirty;
	        if (somethingDirty || this._repaint) {
	            this.triggerRepaint();
	        }
	        else if (!this.isMoving() && this.loaded()) {
	            this.fire(new performance$1.Event('idle'));
	        }
	        if (this._loaded && !this._fullyLoaded && !somethingDirty) {
	            this._fullyLoaded = true;
	            performance$1.PerformanceUtils.mark(performance$1.PerformanceMarkers.fullLoad);
	        }
	        return this;
	    }
	    /**
	     * Force a synchronous redraw of the map.
	     * @returns `this`
	     * @example
	     * ```ts
	     * map.redraw();
	     * ```
	     */
	    redraw() {
	        if (this.style) {
	            // cancel the scheduled update
	            if (this._frameRequest) {
	                this._frameRequest.abort();
	                this._frameRequest = null;
	            }
	            this._render(0);
	        }
	        return this;
	    }
	    /**
	     * Clean up and release all internal resources associated with this map.
	     *
	     * This includes DOM elements, event bindings, web workers, and WebGL resources.
	     *
	     * Use this method when you are done using the map and wish to ensure that it no
	     * longer consumes browser resources. Afterwards, you must not call any other
	     * methods on the map.
	     */
	    remove() {
	        var _a;
	        if (this._hash)
	            this._hash.remove();
	        for (const control of this._controls)
	            control.onRemove(this);
	        this._controls = [];
	        if (this._frameRequest) {
	            this._frameRequest.abort();
	            this._frameRequest = null;
	        }
	        this._renderTaskQueue.clear();
	        this.painter.destroy();
	        this.handlers.destroy();
	        delete this.handlers;
	        this.setStyle(null);
	        if (typeof window !== 'undefined') {
	            removeEventListener('online', this._onWindowOnline, false);
	        }
	        ImageRequest.removeThrottleControl(this._imageQueueHandle);
	        (_a = this._resizeObserver) === null || _a === void 0 ? void 0 : _a.disconnect();
	        const extension = this.painter.context.gl.getExtension('WEBGL_lose_context');
	        if (extension)
	            extension.loseContext();
	        this._canvas.removeEventListener('webglcontextrestored', this._contextRestored, false);
	        this._canvas.removeEventListener('webglcontextlost', this._contextLost, false);
	        DOM.remove(this._canvasContainer);
	        DOM.remove(this._controlContainer);
	        this._container.classList.remove('maplibregl-map');
	        performance$1.PerformanceUtils.clearMetrics();
	        this._removed = true;
	        this.fire(new performance$1.Event('remove'));
	    }
	    /**
	     * Trigger the rendering of a single frame. Use this method with custom layers to
	     * repaint the map when the layer changes. Calling this multiple times before the
	     * next frame is rendered will still result in only a single frame being rendered.
	     * @example
	     * ```ts
	     * map.triggerRepaint();
	     * ```
	     * @see [Add a 3D model](https://maplibre.org/maplibre-gl-js/docs/examples/add-3d-model/)
	     * @see [Add an animated icon to the map](https://maplibre.org/maplibre-gl-js/docs/examples/add-image-animated/)
	     */
	    triggerRepaint() {
	        if (this.style && !this._frameRequest) {
	            this._frameRequest = new AbortController();
	            browser.frameAsync(this._frameRequest).then((paintStartTimeStamp) => {
	                performance$1.PerformanceUtils.frame(paintStartTimeStamp);
	                this._frameRequest = null;
	                this._render(paintStartTimeStamp);
	            }).catch(() => { }); // ignore abort error
	        }
	    }
	    /**
	     * Gets and sets a Boolean indicating whether the map will render an outline
	     * around each tile and the tile ID. These tile boundaries are useful for
	     * debugging.
	     *
	     * The uncompressed file size of the first vector source is drawn in the top left
	     * corner of each tile, next to the tile ID.
	     *
	     * @example
	     * ```ts
	     * map.showTileBoundaries = true;
	     * ```
	     */
	    get showTileBoundaries() { return !!this._showTileBoundaries; }
	    set showTileBoundaries(value) {
	        if (this._showTileBoundaries === value)
	            return;
	        this._showTileBoundaries = value;
	        this._update();
	    }
	    /**
	     * Gets and sets a Boolean indicating whether the map will visualize
	     * the padding offsets.
	     */
	    get showPadding() { return !!this._showPadding; }
	    set showPadding(value) {
	        if (this._showPadding === value)
	            return;
	        this._showPadding = value;
	        this._update();
	    }
	    /**
	     * Gets and sets a Boolean indicating whether the map will render boxes
	     * around all symbols in the data source, revealing which symbols
	     * were rendered or which were hidden due to collisions.
	     * This information is useful for debugging.
	     */
	    get showCollisionBoxes() { return !!this._showCollisionBoxes; }
	    set showCollisionBoxes(value) {
	        if (this._showCollisionBoxes === value)
	            return;
	        this._showCollisionBoxes = value;
	        if (value) {
	            // When we turn collision boxes on we have to generate them for existing tiles
	            // When we turn them off, there's no cost to leaving existing boxes in place
	            this.style._generateCollisionBoxes();
	        }
	        else {
	            // Otherwise, call an update to remove collision boxes
	            this._update();
	        }
	    }
	    /**
	     * Gets and sets a Boolean indicating whether the map should color-code
	     * each fragment to show how many times it has been shaded.
	     * White fragments have been shaded 8 or more times.
	     * Black fragments have been shaded 0 times.
	     * This information is useful for debugging.
	     */
	    get showOverdrawInspector() { return !!this._showOverdrawInspector; }
	    set showOverdrawInspector(value) {
	        if (this._showOverdrawInspector === value)
	            return;
	        this._showOverdrawInspector = value;
	        this._update();
	    }
	    /**
	     * Gets and sets a Boolean indicating whether the map will
	     * continuously repaint. This information is useful for analyzing performance.
	     */
	    get repaint() { return !!this._repaint; }
	    set repaint(value) {
	        if (this._repaint !== value) {
	            this._repaint = value;
	            this.triggerRepaint();
	        }
	    }
	    // show vertices
	    get vertices() { return !!this._vertices; }
	    set vertices(value) { this._vertices = value; this._update(); }
	    /**
	     * Returns the package version of the library
	     * @returns Package version of the library
	     */
	    get version() {
	        return version$1;
	    }
	    /**
	     * Returns the elevation for the point where the camera is looking.
	     * This value corresponds to:
	     * "meters above sea level" * "exaggeration"
	     * @returns The elevation.
	     */
	    getCameraTargetElevation() {
	        return this.transform.elevation;
	    }
	};

	const assignEvents = (handler) => {
	    handler.touchstart = handler.dragStart;
	    handler.touchmoveWindow = handler.dragMove;
	    handler.touchend = handler.dragEnd;
	};
	const generateOneFingerTouchRotationHandler = ({ enable, clickTolerance, bearingDegreesPerPixelMoved = 0.8 }) => {
	    const touchMoveStateManager = new OneFingerTouchMoveStateManager();
	    return new DragHandler({
	        clickTolerance,
	        move: (lastPoint, point) => ({ bearingDelta: (point.x - lastPoint.x) * bearingDegreesPerPixelMoved }),
	        moveStateManager: touchMoveStateManager,
	        enable,
	        assignEvents,
	    });
	};
	const generateOneFingerTouchPitchHandler = ({ enable, clickTolerance, pitchDegreesPerPixelMoved = -0.5 }) => {
	    const touchMoveStateManager = new OneFingerTouchMoveStateManager();
	    return new DragHandler({
	        clickTolerance,
	        move: (lastPoint, point) => ({ pitchDelta: (point.y - lastPoint.y) * pitchDegreesPerPixelMoved }),
	        moveStateManager: touchMoveStateManager,
	        enable,
	        assignEvents,
	    });
	};

	const defaultOptions$3 = {
	    showCompass: true,
	    showZoom: true,
	    visualizePitch: false
	};
	/**
	 * A `NavigationControl` control contains zoom buttons and a compass.
	 *
	 * @group Markers and Controls
	 *
	 * @example
	 * ```ts
	 * let nav = new NavigationControl();
	 * map.addControl(nav, 'top-left');
	 * ```
	 * @see [Display map navigation controls](https://maplibre.org/maplibre-gl-js/docs/examples/navigation/)
	 */
	class NavigationControl {
	    /**
	     * @param options - the control's options
	     */
	    constructor(options) {
	        this._updateZoomButtons = () => {
	            const zoom = this._map.getZoom();
	            const isMax = zoom === this._map.getMaxZoom();
	            const isMin = zoom === this._map.getMinZoom();
	            this._zoomInButton.disabled = isMax;
	            this._zoomOutButton.disabled = isMin;
	            this._zoomInButton.setAttribute('aria-disabled', isMax.toString());
	            this._zoomOutButton.setAttribute('aria-disabled', isMin.toString());
	        };
	        this._rotateCompassArrow = () => {
	            const rotate = this.options.visualizePitch ?
	                `scale(${1 / Math.pow(Math.cos(this._map.transform.pitch * (Math.PI / 180)), 0.5)}) rotateX(${this._map.transform.pitch}deg) rotateZ(${this._map.transform.angle * (180 / Math.PI)}deg)` :
	                `rotate(${this._map.transform.angle * (180 / Math.PI)}deg)`;
	            this._compassIcon.style.transform = rotate;
	        };
	        this._setButtonTitle = (button, title) => {
	            const str = this._map._getUIString(`NavigationControl.${title}`);
	            button.title = str;
	            button.setAttribute('aria-label', str);
	        };
	        this.options = performance$1.extend({}, defaultOptions$3, options);
	        this._container = DOM.create('div', 'maplibregl-ctrl maplibregl-ctrl-group');
	        this._container.addEventListener('contextmenu', (e) => e.preventDefault());
	        if (this.options.showZoom) {
	            this._zoomInButton = this._createButton('maplibregl-ctrl-zoom-in', (e) => this._map.zoomIn({}, { originalEvent: e }));
	            DOM.create('span', 'maplibregl-ctrl-icon', this._zoomInButton).setAttribute('aria-hidden', 'true');
	            this._zoomOutButton = this._createButton('maplibregl-ctrl-zoom-out', (e) => this._map.zoomOut({}, { originalEvent: e }));
	            DOM.create('span', 'maplibregl-ctrl-icon', this._zoomOutButton).setAttribute('aria-hidden', 'true');
	        }
	        if (this.options.showCompass) {
	            this._compass = this._createButton('maplibregl-ctrl-compass', (e) => {
	                if (this.options.visualizePitch) {
	                    this._map.resetNorthPitch({}, { originalEvent: e });
	                }
	                else {
	                    this._map.resetNorth({}, { originalEvent: e });
	                }
	            });
	            this._compassIcon = DOM.create('span', 'maplibregl-ctrl-icon', this._compass);
	            this._compassIcon.setAttribute('aria-hidden', 'true');
	        }
	    }
	    /** {@inheritDoc IControl.onAdd} */
	    onAdd(map) {
	        this._map = map;
	        if (this.options.showZoom) {
	            this._setButtonTitle(this._zoomInButton, 'ZoomIn');
	            this._setButtonTitle(this._zoomOutButton, 'ZoomOut');
	            this._map.on('zoom', this._updateZoomButtons);
	            this._updateZoomButtons();
	        }
	        if (this.options.showCompass) {
	            this._setButtonTitle(this._compass, 'ResetBearing');
	            if (this.options.visualizePitch) {
	                this._map.on('pitch', this._rotateCompassArrow);
	            }
	            this._map.on('rotate', this._rotateCompassArrow);
	            this._rotateCompassArrow();
	            this._handler = new MouseRotateWrapper(this._map, this._compass, this.options.visualizePitch);
	        }
	        return this._container;
	    }
	    /** {@inheritDoc IControl.onRemove} */
	    onRemove() {
	        DOM.remove(this._container);
	        if (this.options.showZoom) {
	            this._map.off('zoom', this._updateZoomButtons);
	        }
	        if (this.options.showCompass) {
	            if (this.options.visualizePitch) {
	                this._map.off('pitch', this._rotateCompassArrow);
	            }
	            this._map.off('rotate', this._rotateCompassArrow);
	            this._handler.off();
	            delete this._handler;
	        }
	        delete this._map;
	    }
	    _createButton(className, fn) {
	        const a = DOM.create('button', className, this._container);
	        a.type = 'button';
	        a.addEventListener('click', fn);
	        return a;
	    }
	}
	class MouseRotateWrapper {
	    constructor(map, element, pitch = false) {
	        this.mousedown = (e) => {
	            this.startMouse(performance$1.extend({}, e, { ctrlKey: true, preventDefault: () => e.preventDefault() }), DOM.mousePos(this.element, e));
	            DOM.addEventListener(window, 'mousemove', this.mousemove);
	            DOM.addEventListener(window, 'mouseup', this.mouseup);
	        };
	        this.mousemove = (e) => {
	            this.moveMouse(e, DOM.mousePos(this.element, e));
	        };
	        this.mouseup = (e) => {
	            this.mouseRotate.dragEnd(e);
	            if (this.mousePitch)
	                this.mousePitch.dragEnd(e);
	            this.offTemp();
	        };
	        this.touchstart = (e) => {
	            if (e.targetTouches.length !== 1) {
	                this.reset();
	            }
	            else {
	                this._startPos = this._lastPos = DOM.touchPos(this.element, e.targetTouches)[0];
	                this.startTouch(e, this._startPos);
	                DOM.addEventListener(window, 'touchmove', this.touchmove, { passive: false });
	                DOM.addEventListener(window, 'touchend', this.touchend);
	            }
	        };
	        this.touchmove = (e) => {
	            if (e.targetTouches.length !== 1) {
	                this.reset();
	            }
	            else {
	                this._lastPos = DOM.touchPos(this.element, e.targetTouches)[0];
	                this.moveTouch(e, this._lastPos);
	            }
	        };
	        this.touchend = (e) => {
	            if (e.targetTouches.length === 0 &&
	                this._startPos &&
	                this._lastPos &&
	                this._startPos.dist(this._lastPos) < this._clickTolerance) {
	                this.element.click();
	            }
	            delete this._startPos;
	            delete this._lastPos;
	            this.offTemp();
	        };
	        this.reset = () => {
	            this.mouseRotate.reset();
	            if (this.mousePitch)
	                this.mousePitch.reset();
	            this.touchRotate.reset();
	            if (this.touchPitch)
	                this.touchPitch.reset();
	            delete this._startPos;
	            delete this._lastPos;
	            this.offTemp();
	        };
	        this._clickTolerance = 10;
	        const mapRotateTolerance = map.dragRotate._mouseRotate.getClickTolerance();
	        const mapPitchTolerance = map.dragRotate._mousePitch.getClickTolerance();
	        this.element = element;
	        this.mouseRotate = generateMouseRotationHandler({ clickTolerance: mapRotateTolerance, enable: true });
	        this.touchRotate = generateOneFingerTouchRotationHandler({ clickTolerance: mapRotateTolerance, enable: true });
	        this.map = map;
	        if (pitch) {
	            this.mousePitch = generateMousePitchHandler({ clickTolerance: mapPitchTolerance, enable: true });
	            this.touchPitch = generateOneFingerTouchPitchHandler({ clickTolerance: mapPitchTolerance, enable: true });
	        }
	        DOM.addEventListener(element, 'mousedown', this.mousedown);
	        DOM.addEventListener(element, 'touchstart', this.touchstart, { passive: false });
	        DOM.addEventListener(element, 'touchcancel', this.reset);
	    }
	    startMouse(e, point) {
	        this.mouseRotate.dragStart(e, point);
	        if (this.mousePitch)
	            this.mousePitch.dragStart(e, point);
	        DOM.disableDrag();
	    }
	    startTouch(e, point) {
	        this.touchRotate.dragStart(e, point);
	        if (this.touchPitch)
	            this.touchPitch.dragStart(e, point);
	        DOM.disableDrag();
	    }
	    moveMouse(e, point) {
	        const map = this.map;
	        const { bearingDelta } = this.mouseRotate.dragMove(e, point) || {};
	        if (bearingDelta)
	            map.setBearing(map.getBearing() + bearingDelta);
	        if (this.mousePitch) {
	            const { pitchDelta } = this.mousePitch.dragMove(e, point) || {};
	            if (pitchDelta)
	                map.setPitch(map.getPitch() + pitchDelta);
	        }
	    }
	    moveTouch(e, point) {
	        const map = this.map;
	        const { bearingDelta } = this.touchRotate.dragMove(e, point) || {};
	        if (bearingDelta)
	            map.setBearing(map.getBearing() + bearingDelta);
	        if (this.touchPitch) {
	            const { pitchDelta } = this.touchPitch.dragMove(e, point) || {};
	            if (pitchDelta)
	                map.setPitch(map.getPitch() + pitchDelta);
	        }
	    }
	    off() {
	        const element = this.element;
	        DOM.removeEventListener(element, 'mousedown', this.mousedown);
	        DOM.removeEventListener(element, 'touchstart', this.touchstart, { passive: false });
	        DOM.removeEventListener(window, 'touchmove', this.touchmove, { passive: false });
	        DOM.removeEventListener(window, 'touchend', this.touchend);
	        DOM.removeEventListener(element, 'touchcancel', this.reset);
	        this.offTemp();
	    }
	    offTemp() {
	        DOM.enableDrag();
	        DOM.removeEventListener(window, 'mousemove', this.mousemove);
	        DOM.removeEventListener(window, 'mouseup', this.mouseup);
	        DOM.removeEventListener(window, 'touchmove', this.touchmove, { passive: false });
	        DOM.removeEventListener(window, 'touchend', this.touchend);
	    }
	}

	let supportsGeolocation;
	function checkGeolocationSupport() {
	    return performance$1.__awaiter(this, arguments, void 0, function* (forceRecalculation = false) {
	        if (supportsGeolocation !== undefined && !forceRecalculation) {
	            return supportsGeolocation;
	        }
	        if (window.navigator.permissions === undefined) {
	            supportsGeolocation = !!window.navigator.geolocation;
	            return supportsGeolocation;
	        }
	        // navigator.permissions has incomplete browser support
	        // http://caniuse.com/#feat=permissions-api
	        // Test for the case where a browser disables Geolocation because of an
	        // insecure origin
	        try {
	            const permissions = yield window.navigator.permissions.query({ name: 'geolocation' });
	            supportsGeolocation = permissions.state !== 'denied'; // eslint-disable-line require-atomic-updates
	        }
	        catch (_a) {
	            // Fix for iOS16 which rejects query but still supports geolocation
	            supportsGeolocation = !!window.navigator.geolocation; // eslint-disable-line require-atomic-updates
	        }
	        return supportsGeolocation;
	    });
	}

	/**
	 * Given a LngLat, prior projected position, and a transform, return a new LngLat shifted
	 * n × 360° east or west for some n ≥ 0 such that:
	 *
	 * * the projected location of the result is on screen, if possible, and secondarily:
	 * * the difference between the projected location of the result and the prior position
	 *   is minimized.
	 *
	 * The object is to preserve perceived object constancy for Popups and Markers as much as
	 * possible; they should avoid shifting large distances across the screen, even when the
	 * map center changes by ±360° due to automatic wrapping, and when about to go off screen,
	 * should wrap just enough to avoid doing so.
	 */
	function smartWrap(lngLat, priorPos, transform) {
	    const originalLngLat = new performance$1.LngLat(lngLat.lng, lngLat.lat);
	    lngLat = new performance$1.LngLat(lngLat.lng, lngLat.lat);
	    // First, try shifting one world in either direction, and see if either is closer to the
	    // prior position. This preserves object constancy when the map center is auto-wrapped
	    // during animations.
	    if (priorPos) {
	        const left = new performance$1.LngLat(lngLat.lng - 360, lngLat.lat);
	        const right = new performance$1.LngLat(lngLat.lng + 360, lngLat.lat);
	        const delta = transform.locationPoint(lngLat).distSqr(priorPos);
	        if (transform.locationPoint(left).distSqr(priorPos) < delta) {
	            lngLat = left;
	        }
	        else if (transform.locationPoint(right).distSqr(priorPos) < delta) {
	            lngLat = right;
	        }
	    }
	    // Second, wrap toward the center until the new position is on screen, or we can't get
	    // any closer.
	    while (Math.abs(lngLat.lng - transform.center.lng) > 180) {
	        const pos = transform.locationPoint(lngLat);
	        if (pos.x >= 0 && pos.y >= 0 && pos.x <= transform.width && pos.y <= transform.height) {
	            break;
	        }
	        if (lngLat.lng > transform.center.lng) {
	            lngLat.lng -= 360;
	        }
	        else {
	            lngLat.lng += 360;
	        }
	    }
	    // Apply the change only if new coord is below horizon
	    if (lngLat.lng !== originalLngLat.lng &&
	        transform.locationPoint(lngLat).y > (transform.height / 2 - transform.getHorizon())) {
	        return lngLat;
	    }
	    return originalLngLat;
	}

	const anchorTranslate = {
	    'center': 'translate(-50%,-50%)',
	    'top': 'translate(-50%,0)',
	    'top-left': 'translate(0,0)',
	    'top-right': 'translate(-100%,0)',
	    'bottom': 'translate(-50%,-100%)',
	    'bottom-left': 'translate(0,-100%)',
	    'bottom-right': 'translate(-100%,-100%)',
	    'left': 'translate(0,-50%)',
	    'right': 'translate(-100%,-50%)'
	};
	function applyAnchorClass(element, anchor, prefix) {
	    const classList = element.classList;
	    for (const key in anchorTranslate) {
	        classList.remove(`maplibregl-${prefix}-anchor-${key}`);
	    }
	    classList.add(`maplibregl-${prefix}-anchor-${anchor}`);
	}

	/**
	 * Creates a marker component
	 *
	 * @group Markers and Controls
	 *
	 * @example
	 * ```ts
	 * let marker = new Marker()
	 *   .setLngLat([30.5, 50.5])
	 *   .addTo(map);
	 * ```
	 *
	 * @example
	 * Set options
	 * ```ts
	 * let marker = new Marker({
	 *     color: "#FFFFFF",
	 *     draggable: true
	 *   }).setLngLat([30.5, 50.5])
	 *   .addTo(map);
	 * ```
	 * @see [Add custom icons with Markers](https://maplibre.org/maplibre-gl-js/docs/examples/custom-marker-icons/)
	 * @see [Create a draggable Marker](https://maplibre.org/maplibre-gl-js/docs/examples/drag-a-marker/)
	 *
	 * ### Events
	 *
	 * @event `dragstart` Fired when dragging starts, `marker` object that is being dragged
	 *
	 * @event `drag` Fired while dragging. `marker` object that is being dragged
	 *
	 * @event `dragend` Fired when the marker is finished being dragged, `marker` object that was dragged
	 */
	class Marker extends performance$1.Evented {
	    /**
	     * @param options - the options
	     */
	    constructor(options) {
	        super();
	        this._onKeyPress = (e) => {
	            const code = e.code;
	            const legacyCode = e.charCode || e.keyCode;
	            if ((code === 'Space') || (code === 'Enter') ||
	                (legacyCode === 32) || (legacyCode === 13) // space or enter
	            ) {
	                this.togglePopup();
	            }
	        };
	        this._onMapClick = (e) => {
	            const targetElement = e.originalEvent.target;
	            const element = this._element;
	            if (this._popup && (targetElement === element || element.contains(targetElement))) {
	                this.togglePopup();
	            }
	        };
	        this._update = (e) => {
	            var _a;
	            if (!this._map)
	                return;
	            const isFullyLoaded = this._map.loaded() && !this._map.isMoving();
	            if ((e === null || e === void 0 ? void 0 : e.type) === 'terrain' || ((e === null || e === void 0 ? void 0 : e.type) === 'render' && !isFullyLoaded)) {
	                this._map.once('render', this._update);
	            }
	            if (this._map.transform.renderWorldCopies) {
	                this._lngLat = smartWrap(this._lngLat, this._flatPos, this._map.transform);
	            }
	            else {
	                this._lngLat = (_a = this._lngLat) === null || _a === void 0 ? void 0 : _a.wrap();
	            }
	            this._flatPos = this._pos = this._map.project(this._lngLat)._add(this._offset);
	            if (this._map.terrain) {
	                // flat position is saved because smartWrap needs non-elevated points
	                this._flatPos = this._map.transform.locationPoint(this._lngLat)._add(this._offset);
	            }
	            let rotation = '';
	            if (this._rotationAlignment === 'viewport' || this._rotationAlignment === 'auto') {
	                rotation = `rotateZ(${this._rotation}deg)`;
	            }
	            else if (this._rotationAlignment === 'map') {
	                rotation = `rotateZ(${this._rotation - this._map.getBearing()}deg)`;
	            }
	            let pitch = '';
	            if (this._pitchAlignment === 'viewport' || this._pitchAlignment === 'auto') {
	                pitch = 'rotateX(0deg)';
	            }
	            else if (this._pitchAlignment === 'map') {
	                pitch = `rotateX(${this._map.getPitch()}deg)`;
	            }
	            // because rounding the coordinates at every `move` event causes stuttered zooming
	            // we only round them when _update is called with `moveend` or when its called with
	            // no arguments (when the Marker is initialized or Marker#setLngLat is invoked).
	            if (!e || e.type === 'moveend') {
	                this._pos = this._pos.round();
	            }
	            DOM.setTransform(this._element, `${anchorTranslate[this._anchor]} translate(${this._pos.x}px, ${this._pos.y}px) ${pitch} ${rotation}`);
	            browser.frameAsync(new AbortController()).then(() => {
	                this._updateOpacity(e && e.type === 'moveend');
	            }).catch(() => { });
	        };
	        this._onMove = (e) => {
	            if (!this._isDragging) {
	                const clickTolerance = this._clickTolerance || this._map._clickTolerance;
	                this._isDragging = e.point.dist(this._pointerdownPos) >= clickTolerance;
	            }
	            if (!this._isDragging)
	                return;
	            this._pos = e.point.sub(this._positionDelta);
	            this._lngLat = this._map.unproject(this._pos);
	            this.setLngLat(this._lngLat);
	            // suppress click event so that popups don't toggle on drag
	            this._element.style.pointerEvents = 'none';
	            // make sure dragstart only fires on the first move event after mousedown.
	            // this can't be on mousedown because that event doesn't necessarily
	            // imply that a drag is about to happen.
	            if (this._state === 'pending') {
	                this._state = 'active';
	                this.fire(new performance$1.Event('dragstart'));
	            }
	            this.fire(new performance$1.Event('drag'));
	        };
	        this._onUp = () => {
	            // revert to normal pointer event handling
	            this._element.style.pointerEvents = 'auto';
	            this._positionDelta = null;
	            this._pointerdownPos = null;
	            this._isDragging = false;
	            this._map.off('mousemove', this._onMove);
	            this._map.off('touchmove', this._onMove);
	            // only fire dragend if it was preceded by at least one drag event
	            if (this._state === 'active') {
	                this.fire(new performance$1.Event('dragend'));
	            }
	            this._state = 'inactive';
	        };
	        this._addDragHandler = (e) => {
	            if (this._element.contains(e.originalEvent.target)) {
	                e.preventDefault();
	                // We need to calculate the pixel distance between the click point
	                // and the marker position, with the offset accounted for. Then we
	                // can subtract this distance from the mousemove event's position
	                // to calculate the new marker position.
	                // If we don't do this, the marker 'jumps' to the click position
	                // creating a jarring UX effect.
	                this._positionDelta = e.point.sub(this._pos).add(this._offset);
	                this._pointerdownPos = e.point;
	                this._state = 'pending';
	                this._map.on('mousemove', this._onMove);
	                this._map.on('touchmove', this._onMove);
	                this._map.once('mouseup', this._onUp);
	                this._map.once('touchend', this._onUp);
	            }
	        };
	        this._anchor = options && options.anchor || 'center';
	        this._color = options && options.color || '#3FB1CE';
	        this._scale = options && options.scale || 1;
	        this._draggable = options && options.draggable || false;
	        this._clickTolerance = options && options.clickTolerance || 0;
	        this._isDragging = false;
	        this._state = 'inactive';
	        this._rotation = options && options.rotation || 0;
	        this._rotationAlignment = options && options.rotationAlignment || 'auto';
	        this._pitchAlignment = options && options.pitchAlignment && options.pitchAlignment !== 'auto' ? options.pitchAlignment : this._rotationAlignment;
	        this.setOpacity(); // set default opacity
	        this.setOpacity(options === null || options === void 0 ? void 0 : options.opacity, options === null || options === void 0 ? void 0 : options.opacityWhenCovered);
	        if (!options || !options.element) {
	            this._defaultMarker = true;
	            this._element = DOM.create('div');
	            this._element.setAttribute('aria-label', 'Map marker');
	            // create default map marker SVG
	            const svg = DOM.createNS('http://www.w3.org/2000/svg', 'svg');
	            const defaultHeight = 41;
	            const defaultWidth = 27;
	            svg.setAttributeNS(null, 'display', 'block');
	            svg.setAttributeNS(null, 'height', `${defaultHeight}px`);
	            svg.setAttributeNS(null, 'width', `${defaultWidth}px`);
	            svg.setAttributeNS(null, 'viewBox', `0 0 ${defaultWidth} ${defaultHeight}`);
	            const markerLarge = DOM.createNS('http://www.w3.org/2000/svg', 'g');
	            markerLarge.setAttributeNS(null, 'stroke', 'none');
	            markerLarge.setAttributeNS(null, 'stroke-width', '1');
	            markerLarge.setAttributeNS(null, 'fill', 'none');
	            markerLarge.setAttributeNS(null, 'fill-rule', 'evenodd');
	            const page1 = DOM.createNS('http://www.w3.org/2000/svg', 'g');
	            page1.setAttributeNS(null, 'fill-rule', 'nonzero');
	            const shadow = DOM.createNS('http://www.w3.org/2000/svg', 'g');
	            shadow.setAttributeNS(null, 'transform', 'translate(3.0, 29.0)');
	            shadow.setAttributeNS(null, 'fill', '#000000');
	            const ellipses = [
	                { 'rx': '10.5', 'ry': '5.25002273' },
	                { 'rx': '10.5', 'ry': '5.25002273' },
	                { 'rx': '9.5', 'ry': '4.77275007' },
	                { 'rx': '8.5', 'ry': '4.29549936' },
	                { 'rx': '7.5', 'ry': '3.81822308' },
	                { 'rx': '6.5', 'ry': '3.34094679' },
	                { 'rx': '5.5', 'ry': '2.86367051' },
	                { 'rx': '4.5', 'ry': '2.38636864' }
	            ];
	            for (const data of ellipses) {
	                const ellipse = DOM.createNS('http://www.w3.org/2000/svg', 'ellipse');
	                ellipse.setAttributeNS(null, 'opacity', '0.04');
	                ellipse.setAttributeNS(null, 'cx', '10.5');
	                ellipse.setAttributeNS(null, 'cy', '5.80029008');
	                ellipse.setAttributeNS(null, 'rx', data['rx']);
	                ellipse.setAttributeNS(null, 'ry', data['ry']);
	                shadow.appendChild(ellipse);
	            }
	            const background = DOM.createNS('http://www.w3.org/2000/svg', 'g');
	            background.setAttributeNS(null, 'fill', this._color);
	            const bgPath = DOM.createNS('http://www.w3.org/2000/svg', 'path');
	            bgPath.setAttributeNS(null, 'd', 'M27,13.5 C27,19.074644 20.250001,27.000002 14.75,34.500002 C14.016665,35.500004 12.983335,35.500004 12.25,34.500002 C6.7499993,27.000002 0,19.222562 0,13.5 C0,6.0441559 6.0441559,0 13.5,0 C20.955844,0 27,6.0441559 27,13.5 Z');
	            background.appendChild(bgPath);
	            const border = DOM.createNS('http://www.w3.org/2000/svg', 'g');
	            border.setAttributeNS(null, 'opacity', '0.25');
	            border.setAttributeNS(null, 'fill', '#000000');
	            const borderPath = DOM.createNS('http://www.w3.org/2000/svg', 'path');
	            borderPath.setAttributeNS(null, 'd', 'M13.5,0 C6.0441559,0 0,6.0441559 0,13.5 C0,19.222562 6.7499993,27 12.25,34.5 C13,35.522727 14.016664,35.500004 14.75,34.5 C20.250001,27 27,19.074644 27,13.5 C27,6.0441559 20.955844,0 13.5,0 Z M13.5,1 C20.415404,1 26,6.584596 26,13.5 C26,15.898657 24.495584,19.181431 22.220703,22.738281 C19.945823,26.295132 16.705119,30.142167 13.943359,33.908203 C13.743445,34.180814 13.612715,34.322738 13.5,34.441406 C13.387285,34.322738 13.256555,34.180814 13.056641,33.908203 C10.284481,30.127985 7.4148684,26.314159 5.015625,22.773438 C2.6163816,19.232715 1,15.953538 1,13.5 C1,6.584596 6.584596,1 13.5,1 Z');
	            border.appendChild(borderPath);
	            const maki = DOM.createNS('http://www.w3.org/2000/svg', 'g');
	            maki.setAttributeNS(null, 'transform', 'translate(6.0, 7.0)');
	            maki.setAttributeNS(null, 'fill', '#FFFFFF');
	            const circleContainer = DOM.createNS('http://www.w3.org/2000/svg', 'g');
	            circleContainer.setAttributeNS(null, 'transform', 'translate(8.0, 8.0)');
	            const circle1 = DOM.createNS('http://www.w3.org/2000/svg', 'circle');
	            circle1.setAttributeNS(null, 'fill', '#000000');
	            circle1.setAttributeNS(null, 'opacity', '0.25');
	            circle1.setAttributeNS(null, 'cx', '5.5');
	            circle1.setAttributeNS(null, 'cy', '5.5');
	            circle1.setAttributeNS(null, 'r', '5.4999962');
	            const circle2 = DOM.createNS('http://www.w3.org/2000/svg', 'circle');
	            circle2.setAttributeNS(null, 'fill', '#FFFFFF');
	            circle2.setAttributeNS(null, 'cx', '5.5');
	            circle2.setAttributeNS(null, 'cy', '5.5');
	            circle2.setAttributeNS(null, 'r', '5.4999962');
	            circleContainer.appendChild(circle1);
	            circleContainer.appendChild(circle2);
	            page1.appendChild(shadow);
	            page1.appendChild(background);
	            page1.appendChild(border);
	            page1.appendChild(maki);
	            page1.appendChild(circleContainer);
	            svg.appendChild(page1);
	            svg.setAttributeNS(null, 'height', `${defaultHeight * this._scale}px`);
	            svg.setAttributeNS(null, 'width', `${defaultWidth * this._scale}px`);
	            this._element.appendChild(svg);
	            // if no element and no offset option given apply an offset for the default marker
	            // the -14 as the y value of the default marker offset was determined as follows
	            //
	            // the marker tip is at the center of the shadow ellipse from the default svg
	            // the y value of the center of the shadow ellipse relative to the svg top left is "shadow transform translate-y (29.0) + ellipse cy (5.80029008)"
	            // offset to the svg center "height (41 / 2)" gives (29.0 + 5.80029008) - (41 / 2) and rounded for an integer pixel offset gives 14
	            // negative is used to move the marker up from the center so the tip is at the Marker lngLat
	            this._offset = performance$1.Point.convert(options && options.offset || [0, -14]);
	        }
	        else {
	            this._element = options.element;
	            this._offset = performance$1.Point.convert(options && options.offset || [0, 0]);
	        }
	        this._element.classList.add('maplibregl-marker');
	        this._element.addEventListener('dragstart', (e) => {
	            e.preventDefault();
	        });
	        this._element.addEventListener('mousedown', (e) => {
	            // prevent focusing on click
	            e.preventDefault();
	        });
	        applyAnchorClass(this._element, this._anchor, 'marker');
	        if (options && options.className) {
	            for (const name of options.className.split(' ')) {
	                this._element.classList.add(name);
	            }
	        }
	        this._popup = null;
	    }
	    /**
	     * Attaches the `Marker` to a `Map` object.
	     * @param map - The MapLibre GL JS map to add the marker to.
	     * @returns `this`
	     * @example
	     * ```ts
	     * let marker = new Marker()
	     *   .setLngLat([30.5, 50.5])
	     *   .addTo(map); // add the marker to the map
	     * ```
	     */
	    addTo(map) {
	        this.remove();
	        this._map = map;
	        map.getCanvasContainer().appendChild(this._element);
	        map.on('move', this._update);
	        map.on('moveend', this._update);
	        map.on('terrain', this._update);
	        this.setDraggable(this._draggable);
	        this._update();
	        // If we attached the `click` listener to the marker element, the popup
	        // would close once the event propagated to `map` due to the
	        // `Popup#_onClickClose` listener.
	        this._map.on('click', this._onMapClick);
	        return this;
	    }
	    /**
	     * Removes the marker from a map
	     * @example
	     * ```ts
	     * let marker = new Marker().addTo(map);
	     * marker.remove();
	     * ```
	     * @returns `this`
	     */
	    remove() {
	        if (this._opacityTimeout) {
	            clearTimeout(this._opacityTimeout);
	            delete this._opacityTimeout;
	        }
	        if (this._map) {
	            this._map.off('click', this._onMapClick);
	            this._map.off('move', this._update);
	            this._map.off('moveend', this._update);
	            this._map.off('mousedown', this._addDragHandler);
	            this._map.off('touchstart', this._addDragHandler);
	            this._map.off('mouseup', this._onUp);
	            this._map.off('touchend', this._onUp);
	            this._map.off('mousemove', this._onMove);
	            this._map.off('touchmove', this._onMove);
	            delete this._map;
	        }
	        DOM.remove(this._element);
	        if (this._popup)
	            this._popup.remove();
	        return this;
	    }
	    /**
	     * Get the marker's geographical location.
	     *
	     * The longitude of the result may differ by a multiple of 360 degrees from the longitude previously
	     * set by `setLngLat` because `Marker` wraps the anchor longitude across copies of the world to keep
	     * the marker on screen.
	     *
	     * @returns A {@link LngLat} describing the marker's location.
	     * @example
	     * ```ts
	     * // Store the marker's longitude and latitude coordinates in a variable
	     * let lngLat = marker.getLngLat();
	     * // Print the marker's longitude and latitude values in the console
	     * console.log('Longitude: ' + lngLat.lng + ', Latitude: ' + lngLat.lat )
	     * ```
	     * @see [Create a draggable Marker](https://maplibre.org/maplibre-gl-js/docs/examples/drag-a-marker/)
	     */
	    getLngLat() {
	        return this._lngLat;
	    }
	    /**
	     * Set the marker's geographical position and move it.
	     * @param lnglat - A {@link LngLat} describing where the marker should be located.
	     * @returns `this`
	     * @example
	     * Create a new marker, set the longitude and latitude, and add it to the map
	     * ```ts
	     * new Marker()
	     *   .setLngLat([-65.017, -16.457])
	     *   .addTo(map);
	     * ```
	     * @see [Add custom icons with Markers](https://maplibre.org/maplibre-gl-js/docs/examples/custom-marker-icons/)
	     * @see [Create a draggable Marker](https://maplibre.org/maplibre-gl-js/docs/examples/drag-a-marker/)
	     */
	    setLngLat(lnglat) {
	        this._lngLat = performance$1.LngLat.convert(lnglat);
	        this._pos = null;
	        if (this._popup)
	            this._popup.setLngLat(this._lngLat);
	        this._update();
	        return this;
	    }
	    /**
	     * Returns the `Marker`'s HTML element.
	     * @returns element
	     */
	    getElement() {
	        return this._element;
	    }
	    /**
	     * Binds a {@link Popup} to the {@link Marker}.
	     * @param popup - An instance of the {@link Popup} class. If undefined or null, any popup
	     * set on this {@link Marker} instance is unset.
	     * @returns `this`
	     * @example
	     * ```ts
	     * let marker = new Marker()
	     *  .setLngLat([0, 0])
	     *  .setPopup(new Popup().setHTML("<h1>Hello World!</h1>")) // add popup
	     *  .addTo(map);
	     * ```
	     * @see [Attach a popup to a marker instance](https://maplibre.org/maplibre-gl-js/docs/examples/set-popup/)
	     */
	    setPopup(popup) {
	        if (this._popup) {
	            this._popup.remove();
	            this._popup = null;
	            this._element.removeEventListener('keypress', this._onKeyPress);
	            if (!this._originalTabIndex) {
	                this._element.removeAttribute('tabindex');
	            }
	        }
	        if (popup) {
	            if (!('offset' in popup.options)) {
	                const markerHeight = 41 - (5.8 / 2);
	                const markerRadius = 13.5;
	                const linearOffset = Math.abs(markerRadius) / Math.SQRT2;
	                popup.options.offset = this._defaultMarker ? {
	                    'top': [0, 0],
	                    'top-left': [0, 0],
	                    'top-right': [0, 0],
	                    'bottom': [0, -markerHeight],
	                    'bottom-left': [linearOffset, (markerHeight - markerRadius + linearOffset) * -1],
	                    'bottom-right': [-linearOffset, (markerHeight - markerRadius + linearOffset) * -1],
	                    'left': [markerRadius, (markerHeight - markerRadius) * -1],
	                    'right': [-markerRadius, (markerHeight - markerRadius) * -1]
	                } : this._offset;
	            }
	            this._popup = popup;
	            this._originalTabIndex = this._element.getAttribute('tabindex');
	            if (!this._originalTabIndex) {
	                this._element.setAttribute('tabindex', '0');
	            }
	            this._element.addEventListener('keypress', this._onKeyPress);
	        }
	        return this;
	    }
	    /**
	     * Returns the {@link Popup} instance that is bound to the {@link Marker}.
	     * @returns popup
	     * @example
	     * ```ts
	     * let marker = new Marker()
	     *  .setLngLat([0, 0])
	     *  .setPopup(new Popup().setHTML("<h1>Hello World!</h1>"))
	     *  .addTo(map);
	     *
	     * console.log(marker.getPopup()); // return the popup instance
	     * ```
	     */
	    getPopup() {
	        return this._popup;
	    }
	    /**
	     * Opens or closes the {@link Popup} instance that is bound to the {@link Marker}, depending on the current state of the {@link Popup}.
	     * @returns `this`
	     * @example
	     * ```ts
	     * let marker = new Marker()
	     *  .setLngLat([0, 0])
	     *  .setPopup(new Popup().setHTML("<h1>Hello World!</h1>"))
	     *  .addTo(map);
	     *
	     * marker.togglePopup(); // toggle popup open or closed
	     * ```
	     */
	    togglePopup() {
	        const popup = this._popup;
	        if (this._element.style.opacity === this._opacityWhenCovered)
	            return this;
	        if (!popup)
	            return this;
	        else if (popup.isOpen())
	            popup.remove();
	        else {
	            popup.setLngLat(this._lngLat);
	            popup.addTo(this._map);
	        }
	        return this;
	    }
	    _updateOpacity(force = false) {
	        var _a, _b;
	        const terrain = (_a = this._map) === null || _a === void 0 ? void 0 : _a.terrain;
	        if (!terrain) {
	            if (this._element.style.opacity !== this._opacity) {
	                this._element.style.opacity = this._opacity;
	            }
	            return;
	        }
	        if (force) {
	            this._opacityTimeout = null;
	        }
	        else {
	            if (this._opacityTimeout) {
	                return;
	            }
	            this._opacityTimeout = setTimeout(() => {
	                this._opacityTimeout = null;
	            }, 100);
	        }
	        const map = this._map;
	        // Read depth framebuffer, getting position of terrain in line of sight to marker
	        const terrainDistance = map.terrain.depthAtPoint(this._pos);
	        // Transform marker position to clip space
	        const elevation = map.terrain.getElevationForLngLatZoom(this._lngLat, map.transform.tileZoom);
	        const markerDistance = map.transform.lngLatToCameraDepth(this._lngLat, elevation);
	        const forgiveness = .006;
	        if (markerDistance - terrainDistance < forgiveness) {
	            this._element.style.opacity = this._opacity;
	            return;
	        }
	        // If the base is obscured, use the offset to check if the marker's center is obscured.
	        const metersToCenter = -this._offset.y / map.transform._pixelPerMeter;
	        const elevationToCenter = Math.sin(map.getPitch() * Math.PI / 180) * metersToCenter;
	        const terrainDistanceCenter = map.terrain.depthAtPoint(new performance$1.Point(this._pos.x, this._pos.y - this._offset.y));
	        const markerDistanceCenter = map.transform.lngLatToCameraDepth(this._lngLat, elevation + elevationToCenter);
	        // Display at full opacity if center is visible.
	        const centerIsInvisible = markerDistanceCenter - terrainDistanceCenter > forgiveness;
	        if (((_b = this._popup) === null || _b === void 0 ? void 0 : _b.isOpen()) && centerIsInvisible)
	            this._popup.remove();
	        this._element.style.opacity = centerIsInvisible ? this._opacityWhenCovered : this._opacity;
	    }
	    /**
	     * Get the marker's offset.
	     * @returns The marker's screen coordinates in pixels.
	     */
	    getOffset() {
	        return this._offset;
	    }
	    /**
	     * Sets the offset of the marker
	     * @param offset - The offset in pixels as a {@link PointLike} object to apply relative to the element's center. Negatives indicate left and up.
	     * @returns `this`
	     */
	    setOffset(offset) {
	        this._offset = performance$1.Point.convert(offset);
	        this._update();
	        return this;
	    }
	    /**
	     * Adds a CSS class to the marker element.
	     *
	     * @param className - on-empty string with CSS class name to add to marker element
	     *
	     * @example
	     * ```
	     * let marker = new Marker()
	     * marker.addClassName('some-class')
	     * ```
	     */
	    addClassName(className) {
	        this._element.classList.add(className);
	    }
	    /**
	     * Removes a CSS class from the marker element.
	     *
	     * @param className - Non-empty string with CSS class name to remove from marker element
	     *
	     * @example
	     * ```ts
	     * let marker = new Marker()
	     * marker.removeClassName('some-class')
	     * ```
	     */
	    removeClassName(className) {
	        this._element.classList.remove(className);
	    }
	    /**
	     * Add or remove the given CSS class on the marker element, depending on whether the element currently has that class.
	     *
	     * @param className - Non-empty string with CSS class name to add/remove
	     *
	     * @returns if the class was removed return false, if class was added, then return true
	     *
	     * @example
	     * ```ts
	     * let marker = new Marker()
	     * marker.toggleClassName('toggleClass')
	     * ```
	     */
	    toggleClassName(className) {
	        return this._element.classList.toggle(className);
	    }
	    /**
	     * Sets the `draggable` property and functionality of the marker
	     * @param shouldBeDraggable - Turns drag functionality on/off
	     * @returns `this`
	     */
	    setDraggable(shouldBeDraggable) {
	        this._draggable = !!shouldBeDraggable; // convert possible undefined value to false
	        // handle case where map may not exist yet
	        // e.g. when setDraggable is called before addTo
	        if (this._map) {
	            if (shouldBeDraggable) {
	                this._map.on('mousedown', this._addDragHandler);
	                this._map.on('touchstart', this._addDragHandler);
	            }
	            else {
	                this._map.off('mousedown', this._addDragHandler);
	                this._map.off('touchstart', this._addDragHandler);
	            }
	        }
	        return this;
	    }
	    /**
	     * Returns true if the marker can be dragged
	     * @returns True if the marker is draggable.
	     */
	    isDraggable() {
	        return this._draggable;
	    }
	    /**
	     * Sets the `rotation` property of the marker.
	     * @param rotation - The rotation angle of the marker (clockwise, in degrees), relative to its respective {@link Marker#setRotationAlignment} setting.
	     * @returns `this`
	     */
	    setRotation(rotation) {
	        this._rotation = rotation || 0;
	        this._update();
	        return this;
	    }
	    /**
	     * Returns the current rotation angle of the marker (in degrees).
	     * @returns The current rotation angle of the marker.
	     */
	    getRotation() {
	        return this._rotation;
	    }
	    /**
	     * Sets the `rotationAlignment` property of the marker.
	     * @param alignment - Sets the `rotationAlignment` property of the marker. defaults to 'auto'
	     * @returns `this`
	     */
	    setRotationAlignment(alignment) {
	        this._rotationAlignment = alignment || 'auto';
	        this._update();
	        return this;
	    }
	    /**
	     * Returns the current `rotationAlignment` property of the marker.
	     * @returns The current rotational alignment of the marker.
	     */
	    getRotationAlignment() {
	        return this._rotationAlignment;
	    }
	    /**
	     * Sets the `pitchAlignment` property of the marker.
	     * @param alignment - Sets the `pitchAlignment` property of the marker. If alignment is 'auto', it will automatically match `rotationAlignment`.
	     * @returns `this`
	     */
	    setPitchAlignment(alignment) {
	        this._pitchAlignment = alignment && alignment !== 'auto' ? alignment : this._rotationAlignment;
	        this._update();
	        return this;
	    }
	    /**
	     * Returns the current `pitchAlignment` property of the marker.
	     * @returns The current pitch alignment of the marker in degrees.
	     */
	    getPitchAlignment() {
	        return this._pitchAlignment;
	    }
	    /**
	     * Sets the `opacity` and `opacityWhenCovered` properties of the marker.
	     * When called without arguments, resets opacity and opacityWhenCovered to defaults
	     * @param opacity - Sets the `opacity` property of the marker.
	     * @param opacityWhenCovered - Sets the `opacityWhenCovered` property of the marker.
	     * @returns `this`
	     */
	    setOpacity(opacity, opacityWhenCovered) {
	        if (opacity === undefined && opacityWhenCovered === undefined) {
	            this._opacity = '1';
	            this._opacityWhenCovered = '0.2';
	        }
	        if (opacity !== undefined) {
	            this._opacity = opacity;
	        }
	        if (opacityWhenCovered !== undefined) {
	            this._opacityWhenCovered = opacityWhenCovered;
	        }
	        if (this._map) {
	            this._updateOpacity(true);
	        }
	        return this;
	    }
	}

	const defaultOptions$2 = {
	    positionOptions: {
	        enableHighAccuracy: false,
	        maximumAge: 0,
	        timeout: 6000 /* 6 sec */
	    },
	    fitBoundsOptions: {
	        maxZoom: 15
	    },
	    trackUserLocation: false,
	    showAccuracyCircle: true,
	    showUserLocation: true
	};
	let numberOfWatches = 0;
	let noTimeout = false;
	/**
	 * A `GeolocateControl` control provides a button that uses the browser's geolocation
	 * API to locate the user on the map.
	 *
	 * Not all browsers support geolocation,
	 * and some users may disable the feature. Geolocation support for modern
	 * browsers including Chrome requires sites to be served over HTTPS. If
	 * geolocation support is not available, the `GeolocateControl` will show
	 * as disabled.
	 *
	 * The zoom level applied will depend on the accuracy of the geolocation provided by the device.
	 *
	 * The `GeolocateControl` has two modes. If `trackUserLocation` is `false` (default) the control acts as a button, which when pressed will set the map's camera to target the user location. If the user moves, the map won't update. This is most suited for the desktop. If `trackUserLocation` is `true` the control acts as a toggle button that when active the user's location is actively monitored for changes. In this mode the `GeolocateControl` has three interaction states:
	 * * active - the map's camera automatically updates as the user's location changes, keeping the location dot in the center. Initial state and upon clicking the `GeolocateControl` button.
	 * * passive - the user's location dot automatically updates, but the map's camera does not. Occurs upon the user initiating a map movement.
	 * * disabled - occurs if Geolocation is not available, disabled or denied.
	 *
	 * These interaction states can't be controlled programmatically, rather they are set based on user interactions.
	 * @group Markers and Controls
	 *
	 * @example
	 * ```ts
	 * map.addControl(new GeolocateControl({
	 *     positionOptions: {
	 *         enableHighAccuracy: true
	 *     },
	 *     trackUserLocation: true
	 * }));
	 * ```
	 * @see [Locate the user](https://maplibre.org/maplibre-gl-js/docs/examples/locate-user/)
	 *
	 * ### Events
	 *
	 * @event `trackuserlocationend` - Fired when the `GeolocateControl` changes to the background state, which happens when a user changes the camera during an active position lock. This only applies when `trackUserLocation` is `true`. In the background state, the dot on the map will update with location updates but the camera will not.
	 *
	 * @event `trackuserlocationstart` - Fired when the `GeolocateControl` changes to the active lock state, which happens either upon first obtaining a successful Geolocation API position for the user (a `geolocate` event will follow), or the user clicks the geolocate button when in the background state which uses the last known position to recenter the map and enter active lock state (no `geolocate` event will follow unless the users's location changes).
	 *
	 * @event `geolocate` - Fired on each Geolocation API position update which returned as success.
	 * `data` - The returned [Position](https://developer.mozilla.org/en-US/docs/Web/API/Position) object from the callback in [Geolocation.getCurrentPosition()](https://developer.mozilla.org/en-US/docs/Web/API/Geolocation/getCurrentPosition) or [Geolocation.watchPosition()](https://developer.mozilla.org/en-US/docs/Web/API/Geolocation/watchPosition).
	 *
	 * @event `error` - Fired on each Geolocation API position update which returned as an error.
	 * `data` - The returned [PositionError](https://developer.mozilla.org/en-US/docs/Web/API/PositionError) object from the callback in [Geolocation.getCurrentPosition()](https://developer.mozilla.org/en-US/docs/Web/API/Geolocation/getCurrentPosition) or [Geolocation.watchPosition()](https://developer.mozilla.org/en-US/docs/Web/API/Geolocation/watchPosition).
	 *
	 * @event `outofmaxbounds` Fired on each Geolocation API position update which returned as success but user position is out of map `maxBounds`.
	 * `data` - The returned [Position](https://developer.mozilla.org/en-US/docs/Web/API/Position) object from the callback in [Geolocation.getCurrentPosition()](https://developer.mozilla.org/en-US/docs/Web/API/Geolocation/getCurrentPosition) or [Geolocation.watchPosition()](https://developer.mozilla.org/en-US/docs/Web/API/Geolocation/watchPosition).
	 *
	 * @example
	 * ```ts
	 * // Initialize the geolocate control.
	 * let geolocate = new GeolocateControl({
	 *   positionOptions: {
	 *       enableHighAccuracy: true
	 *   },
	 *   trackUserLocation: true
	 * });
	 * // Add the control to the map.
	 * map.addControl(geolocate);
	 * // Set an event listener that fires
	 * // when a trackuserlocationend event occurs.
	 * geolocate.on('trackuserlocationend', function() {
	 *   console.log('A trackuserlocationend event has occurred.')
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * // Initialize the geolocate control.
	 * let geolocate = new GeolocateControl({
	 *   positionOptions: {
	 *       enableHighAccuracy: true
	 *   },
	 *   trackUserLocation: true
	 * });
	 * // Add the control to the map.
	 * map.addControl(geolocate);
	 * // Set an event listener that fires
	 * // when a trackuserlocationstart event occurs.
	 * geolocate.on('trackuserlocationstart', function() {
	 *   console.log('A trackuserlocationstart event has occurred.')
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * // Initialize the geolocate control.
	 * let geolocate = new GeolocateControl({
	 *   positionOptions: {
	 *       enableHighAccuracy: true
	 *   },
	 *   trackUserLocation: true
	 * });
	 * // Add the control to the map.
	 * map.addControl(geolocate);
	 * // Set an event listener that fires
	 * // when a geolocate event occurs.
	 * geolocate.on('geolocate', function() {
	 *   console.log('A geolocate event has occurred.')
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * // Initialize the geolocate control.
	 * let geolocate = new GeolocateControl({
	 *   positionOptions: {
	 *       enableHighAccuracy: true
	 *   },
	 *   trackUserLocation: true
	 * });
	 * // Add the control to the map.
	 * map.addControl(geolocate);
	 * // Set an event listener that fires
	 * // when an error event occurs.
	 * geolocate.on('error', function() {
	 *   console.log('An error event has occurred.')
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * // Initialize the geolocate control.
	 * let geolocate = new GeolocateControl({
	 *   positionOptions: {
	 *       enableHighAccuracy: true
	 *   },
	 *   trackUserLocation: true
	 * });
	 * // Add the control to the map.
	 * map.addControl(geolocate);
	 * // Set an event listener that fires
	 * // when an outofmaxbounds event occurs.
	 * geolocate.on('outofmaxbounds', function() {
	 *   console.log('An outofmaxbounds event has occurred.')
	 * });
	 * ```
	 */
	class GeolocateControl extends performance$1.Evented {
	    constructor(options) {
	        super();
	        /**
	         * When the Geolocation API returns a new location, update the `GeolocateControl`.
	         *
	         * @param position - the Geolocation API Position
	         */
	        this._onSuccess = (position) => {
	            if (!this._map) {
	                // control has since been removed
	                return;
	            }
	            if (this._isOutOfMapMaxBounds(position)) {
	                this._setErrorState();
	                this.fire(new performance$1.Event('outofmaxbounds', position));
	                this._updateMarker();
	                this._finish();
	                return;
	            }
	            if (this.options.trackUserLocation) {
	                // keep a record of the position so that if the state is BACKGROUND and the user
	                // clicks the button, we can move to ACTIVE_LOCK immediately without waiting for
	                // watchPosition to trigger _onSuccess
	                this._lastKnownPosition = position;
	                switch (this._watchState) {
	                    case 'WAITING_ACTIVE':
	                    case 'ACTIVE_LOCK':
	                    case 'ACTIVE_ERROR':
	                        this._watchState = 'ACTIVE_LOCK';
	                        this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-waiting');
	                        this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active-error');
	                        this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-active');
	                        break;
	                    case 'BACKGROUND':
	                    case 'BACKGROUND_ERROR':
	                        this._watchState = 'BACKGROUND';
	                        this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-waiting');
	                        this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-background-error');
	                        this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-background');
	                        break;
	                    default:
	                        throw new Error(`Unexpected watchState ${this._watchState}`);
	                }
	            }
	            // if showUserLocation and the watch state isn't off then update the marker location
	            if (this.options.showUserLocation && this._watchState !== 'OFF') {
	                this._updateMarker(position);
	            }
	            // if in normal mode (not watch mode), or if in watch mode and the state is active watch
	            // then update the camera
	            if (!this.options.trackUserLocation || this._watchState === 'ACTIVE_LOCK') {
	                this._updateCamera(position);
	            }
	            if (this.options.showUserLocation) {
	                this._dotElement.classList.remove('maplibregl-user-location-dot-stale');
	            }
	            this.fire(new performance$1.Event('geolocate', position));
	            this._finish();
	        };
	        /**
	         * Update the camera location to center on the current position
	         *
	         * @param position - the Geolocation API Position
	         */
	        this._updateCamera = (position) => {
	            const center = new performance$1.LngLat(position.coords.longitude, position.coords.latitude);
	            const radius = position.coords.accuracy;
	            const bearing = this._map.getBearing();
	            const options = performance$1.extend({ bearing }, this.options.fitBoundsOptions);
	            const newBounds = LngLatBounds.fromLngLat(center, radius);
	            this._map.fitBounds(newBounds, options, {
	                geolocateSource: true // tag this camera change so it won't cause the control to change to background state
	            });
	        };
	        /**
	         * Update the user location dot Marker to the current position
	         *
	         * @param position - the Geolocation API Position
	         */
	        this._updateMarker = (position) => {
	            if (position) {
	                const center = new performance$1.LngLat(position.coords.longitude, position.coords.latitude);
	                this._accuracyCircleMarker.setLngLat(center).addTo(this._map);
	                this._userLocationDotMarker.setLngLat(center).addTo(this._map);
	                this._accuracy = position.coords.accuracy;
	                if (this.options.showUserLocation && this.options.showAccuracyCircle) {
	                    this._updateCircleRadius();
	                }
	            }
	            else {
	                this._userLocationDotMarker.remove();
	                this._accuracyCircleMarker.remove();
	            }
	        };
	        this._onZoom = () => {
	            if (this.options.showUserLocation && this.options.showAccuracyCircle) {
	                this._updateCircleRadius();
	            }
	        };
	        this._onError = (error) => {
	            if (!this._map) {
	                // control has since been removed
	                return;
	            }
	            if (this.options.trackUserLocation) {
	                if (error.code === 1) {
	                    // PERMISSION_DENIED
	                    this._watchState = 'OFF';
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-waiting');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active-error');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-background');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-background-error');
	                    this._geolocateButton.disabled = true;
	                    const title = this._map._getUIString('GeolocateControl.LocationNotAvailable');
	                    this._geolocateButton.title = title;
	                    this._geolocateButton.setAttribute('aria-label', title);
	                    if (this._geolocationWatchID !== undefined) {
	                        this._clearWatch();
	                    }
	                }
	                else if (error.code === 3 && noTimeout) {
	                    // this represents a forced error state
	                    // this was triggered to force immediate geolocation when a watch is already present
	                    // see https://github.com/mapbox/mapbox-gl-js/issues/8214
	                    // and https://w3c.github.io/geolocation-api/#example-5-forcing-the-user-agent-to-return-a-fresh-cached-position
	                    return;
	                }
	                else {
	                    this._setErrorState();
	                }
	            }
	            if (this._watchState !== 'OFF' && this.options.showUserLocation) {
	                this._dotElement.classList.add('maplibregl-user-location-dot-stale');
	            }
	            this.fire(new performance$1.Event('error', error));
	            this._finish();
	        };
	        this._finish = () => {
	            if (this._timeoutId) {
	                clearTimeout(this._timeoutId);
	            }
	            this._timeoutId = undefined;
	        };
	        this._setupUI = (supported) => {
	            // this method is called asynchronously during onAdd
	            // the control could have been removed before reaching here
	            if (!this._map) {
	                return;
	            }
	            this._container.addEventListener('contextmenu', (e) => e.preventDefault());
	            this._geolocateButton = DOM.create('button', 'maplibregl-ctrl-geolocate', this._container);
	            DOM.create('span', 'maplibregl-ctrl-icon', this._geolocateButton).setAttribute('aria-hidden', 'true');
	            this._geolocateButton.type = 'button';
	            if (supported === false) {
	                performance$1.warnOnce('Geolocation support is not available so the GeolocateControl will be disabled.');
	                const title = this._map._getUIString('GeolocateControl.LocationNotAvailable');
	                this._geolocateButton.disabled = true;
	                this._geolocateButton.title = title;
	                this._geolocateButton.setAttribute('aria-label', title);
	            }
	            else {
	                const title = this._map._getUIString('GeolocateControl.FindMyLocation');
	                this._geolocateButton.title = title;
	                this._geolocateButton.setAttribute('aria-label', title);
	            }
	            if (this.options.trackUserLocation) {
	                this._geolocateButton.setAttribute('aria-pressed', 'false');
	                this._watchState = 'OFF';
	            }
	            // when showUserLocation is enabled, keep the Geolocate button disabled until the device location marker is setup on the map
	            if (this.options.showUserLocation) {
	                this._dotElement = DOM.create('div', 'maplibregl-user-location-dot');
	                this._userLocationDotMarker = new Marker({ element: this._dotElement });
	                this._circleElement = DOM.create('div', 'maplibregl-user-location-accuracy-circle');
	                this._accuracyCircleMarker = new Marker({ element: this._circleElement, pitchAlignment: 'map' });
	                if (this.options.trackUserLocation)
	                    this._watchState = 'OFF';
	                this._map.on('zoom', this._onZoom);
	            }
	            this._geolocateButton.addEventListener('click', () => this.trigger());
	            this._setup = true;
	            // when the camera is changed (and it's not as a result of the Geolocation Control) change
	            // the watch mode to background watch, so that the marker is updated but not the camera.
	            if (this.options.trackUserLocation) {
	                this._map.on('movestart', (event) => {
	                    const fromResize = event.originalEvent && event.originalEvent.type === 'resize';
	                    if (!event.geolocateSource && this._watchState === 'ACTIVE_LOCK' && !fromResize) {
	                        this._watchState = 'BACKGROUND';
	                        this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-background');
	                        this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active');
	                        this.fire(new performance$1.Event('trackuserlocationend'));
	                    }
	                });
	            }
	        };
	        this.options = performance$1.extend({}, defaultOptions$2, options);
	    }
	    /** {@inheritDoc IControl.onAdd} */
	    onAdd(map) {
	        this._map = map;
	        this._container = DOM.create('div', 'maplibregl-ctrl maplibregl-ctrl-group');
	        checkGeolocationSupport().then((supported) => this._setupUI(supported));
	        return this._container;
	    }
	    /** {@inheritDoc IControl.onRemove} */
	    onRemove() {
	        // clear the geolocation watch if exists
	        if (this._geolocationWatchID !== undefined) {
	            window.navigator.geolocation.clearWatch(this._geolocationWatchID);
	            this._geolocationWatchID = undefined;
	        }
	        // clear the markers from the map
	        if (this.options.showUserLocation && this._userLocationDotMarker) {
	            this._userLocationDotMarker.remove();
	        }
	        if (this.options.showAccuracyCircle && this._accuracyCircleMarker) {
	            this._accuracyCircleMarker.remove();
	        }
	        DOM.remove(this._container);
	        this._map.off('zoom', this._onZoom);
	        this._map = undefined;
	        numberOfWatches = 0;
	        noTimeout = false;
	    }
	    /**
	     * Check if the Geolocation API Position is outside the map's `maxBounds`.
	     *
	     * @param position - the Geolocation API Position
	     * @returns `true` if position is outside the map's `maxBounds`, otherwise returns `false`.
	     */
	    _isOutOfMapMaxBounds(position) {
	        const bounds = this._map.getMaxBounds();
	        const coordinates = position.coords;
	        return bounds && (coordinates.longitude < bounds.getWest() ||
	            coordinates.longitude > bounds.getEast() ||
	            coordinates.latitude < bounds.getSouth() ||
	            coordinates.latitude > bounds.getNorth());
	    }
	    _setErrorState() {
	        switch (this._watchState) {
	            case 'WAITING_ACTIVE':
	                this._watchState = 'ACTIVE_ERROR';
	                this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active');
	                this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-active-error');
	                break;
	            case 'ACTIVE_LOCK':
	                this._watchState = 'ACTIVE_ERROR';
	                this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active');
	                this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-active-error');
	                this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-waiting');
	                // turn marker grey
	                break;
	            case 'BACKGROUND':
	                this._watchState = 'BACKGROUND_ERROR';
	                this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-background');
	                this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-background-error');
	                this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-waiting');
	                // turn marker grey
	                break;
	            case 'ACTIVE_ERROR':
	                break;
	            default:
	                throw new Error(`Unexpected watchState ${this._watchState}`);
	        }
	    }
	    _updateCircleRadius() {
	        const bounds = this._map.getBounds();
	        const southEastPoint = bounds.getSouthEast();
	        const northEastPoint = bounds.getNorthEast();
	        const mapHeightInMeters = southEastPoint.distanceTo(northEastPoint);
	        const mapHeightInPixels = this._map._container.clientHeight;
	        const circleDiameter = Math.ceil(2 * (this._accuracy / (mapHeightInMeters / mapHeightInPixels)));
	        this._circleElement.style.width = `${circleDiameter}px`;
	        this._circleElement.style.height = `${circleDiameter}px`;
	    }
	    /**
	     * Programmatically request and move the map to the user's location.
	     *
	     * @returns `false` if called before control was added to a map, otherwise returns `true`.
	     * @example
	     * ```ts
	     * // Initialize the geolocate control.
	     * let geolocate = new GeolocateControl({
	     *  positionOptions: {
	     *    enableHighAccuracy: true
	     *  },
	     *  trackUserLocation: true
	     * });
	     * // Add the control to the map.
	     * map.addControl(geolocate);
	     * map.on('load', function() {
	     *   geolocate.trigger();
	     * });
	     * ```
	     */
	    trigger() {
	        if (!this._setup) {
	            performance$1.warnOnce('Geolocate control triggered before added to a map');
	            return false;
	        }
	        if (this.options.trackUserLocation) {
	            // update watchState and do any outgoing state cleanup
	            switch (this._watchState) {
	                case 'OFF':
	                    // turn on the Geolocate Control
	                    this._watchState = 'WAITING_ACTIVE';
	                    this.fire(new performance$1.Event('trackuserlocationstart'));
	                    break;
	                case 'WAITING_ACTIVE':
	                case 'ACTIVE_LOCK':
	                case 'ACTIVE_ERROR':
	                case 'BACKGROUND_ERROR':
	                    // turn off the Geolocate Control
	                    numberOfWatches--;
	                    noTimeout = false;
	                    this._watchState = 'OFF';
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-waiting');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-active-error');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-background');
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-background-error');
	                    this.fire(new performance$1.Event('trackuserlocationend'));
	                    break;
	                case 'BACKGROUND':
	                    this._watchState = 'ACTIVE_LOCK';
	                    this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-background');
	                    // set camera to last known location
	                    if (this._lastKnownPosition)
	                        this._updateCamera(this._lastKnownPosition);
	                    this.fire(new performance$1.Event('trackuserlocationstart'));
	                    break;
	                default:
	                    throw new Error(`Unexpected watchState ${this._watchState}`);
	            }
	            // incoming state setup
	            switch (this._watchState) {
	                case 'WAITING_ACTIVE':
	                    this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-waiting');
	                    this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-active');
	                    break;
	                case 'ACTIVE_LOCK':
	                    this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-active');
	                    break;
	                case 'OFF':
	                    break;
	                default:
	                    throw new Error(`Unexpected watchState ${this._watchState}`);
	            }
	            // manage geolocation.watchPosition / geolocation.clearWatch
	            if (this._watchState === 'OFF' && this._geolocationWatchID !== undefined) {
	                // clear watchPosition as we've changed to an OFF state
	                this._clearWatch();
	            }
	            else if (this._geolocationWatchID === undefined) {
	                // enable watchPosition since watchState is not OFF and there is no watchPosition already running
	                this._geolocateButton.classList.add('maplibregl-ctrl-geolocate-waiting');
	                this._geolocateButton.setAttribute('aria-pressed', 'true');
	                numberOfWatches++;
	                let positionOptions;
	                if (numberOfWatches > 1) {
	                    positionOptions = { maximumAge: 600000, timeout: 0 };
	                    noTimeout = true;
	                }
	                else {
	                    positionOptions = this.options.positionOptions;
	                    noTimeout = false;
	                }
	                this._geolocationWatchID = window.navigator.geolocation.watchPosition(this._onSuccess, this._onError, positionOptions);
	            }
	        }
	        else {
	            window.navigator.geolocation.getCurrentPosition(this._onSuccess, this._onError, this.options.positionOptions);
	            // This timeout ensures that we still call finish() even if
	            // the user declines to share their location in Firefox
	            this._timeoutId = setTimeout(this._finish, 10000 /* 10sec */);
	        }
	        return true;
	    }
	    _clearWatch() {
	        window.navigator.geolocation.clearWatch(this._geolocationWatchID);
	        this._geolocationWatchID = undefined;
	        this._geolocateButton.classList.remove('maplibregl-ctrl-geolocate-waiting');
	        this._geolocateButton.setAttribute('aria-pressed', 'false');
	        if (this.options.showUserLocation) {
	            this._updateMarker(null);
	        }
	    }
	}

	const defaultOptions$1 = {
	    maxWidth: 100,
	    unit: 'metric'
	};
	/**
	 * A `ScaleControl` control displays the ratio of a distance on the map to the corresponding distance on the ground.
	 *
	 * @group Markers and Controls
	 *
	 * @example
	 * ```ts
	 * let scale = new ScaleControl({
	 *     maxWidth: 80,
	 *     unit: 'imperial'
	 * });
	 * map.addControl(scale);
	 *
	 * scale.setUnit('metric');
	 * ```
	 */
	class ScaleControl {
	    constructor(options) {
	        this._onMove = () => {
	            updateScale(this._map, this._container, this.options);
	        };
	        /**
	         * Set the scale's unit of the distance
	         *
	         * @param unit - Unit of the distance (`'imperial'`, `'metric'` or `'nautical'`).
	         */
	        this.setUnit = (unit) => {
	            this.options.unit = unit;
	            updateScale(this._map, this._container, this.options);
	        };
	        this.options = performance$1.extend({}, defaultOptions$1, options);
	    }
	    getDefaultPosition() {
	        return 'bottom-left';
	    }
	    /** {@inheritDoc IControl.onAdd} */
	    onAdd(map) {
	        this._map = map;
	        this._container = DOM.create('div', 'maplibregl-ctrl maplibregl-ctrl-scale', map.getContainer());
	        this._map.on('move', this._onMove);
	        this._onMove();
	        return this._container;
	    }
	    /** {@inheritDoc IControl.onRemove} */
	    onRemove() {
	        DOM.remove(this._container);
	        this._map.off('move', this._onMove);
	        this._map = undefined;
	    }
	}
	function updateScale(map, container, options) {
	    // A horizontal scale is imagined to be present at center of the map
	    // container with maximum length (Default) as 100px.
	    // Using spherical law of cosines approximation, the real distance is
	    // found between the two coordinates.
	    const maxWidth = options && options.maxWidth || 100;
	    const y = map._container.clientHeight / 2;
	    const left = map.unproject([0, y]);
	    const right = map.unproject([maxWidth, y]);
	    const maxMeters = left.distanceTo(right);
	    // The real distance corresponding to 100px scale length is rounded off to
	    // near pretty number and the scale length for the same is found out.
	    // Default unit of the scale is based on User's locale.
	    if (options && options.unit === 'imperial') {
	        const maxFeet = 3.2808 * maxMeters;
	        if (maxFeet > 5280) {
	            const maxMiles = maxFeet / 5280;
	            setScale(container, maxWidth, maxMiles, map._getUIString('ScaleControl.Miles'));
	        }
	        else {
	            setScale(container, maxWidth, maxFeet, map._getUIString('ScaleControl.Feet'));
	        }
	    }
	    else if (options && options.unit === 'nautical') {
	        const maxNauticals = maxMeters / 1852;
	        setScale(container, maxWidth, maxNauticals, map._getUIString('ScaleControl.NauticalMiles'));
	    }
	    else if (maxMeters >= 1000) {
	        setScale(container, maxWidth, maxMeters / 1000, map._getUIString('ScaleControl.Kilometers'));
	    }
	    else {
	        setScale(container, maxWidth, maxMeters, map._getUIString('ScaleControl.Meters'));
	    }
	}
	function setScale(container, maxWidth, maxDistance, unit) {
	    const distance = getRoundNum(maxDistance);
	    const ratio = distance / maxDistance;
	    container.style.width = `${maxWidth * ratio}px`;
	    container.innerHTML = `${distance}&nbsp;${unit}`;
	}
	function getDecimalRoundNum(d) {
	    const multiplier = Math.pow(10, Math.ceil(-Math.log(d) / Math.LN10));
	    return Math.round(d * multiplier) / multiplier;
	}
	function getRoundNum(num) {
	    const pow10 = Math.pow(10, (`${Math.floor(num)}`).length - 1);
	    let d = num / pow10;
	    d = d >= 10 ? 10 :
	        d >= 5 ? 5 :
	            d >= 3 ? 3 :
	                d >= 2 ? 2 :
	                    d >= 1 ? 1 : getDecimalRoundNum(d);
	    return pow10 * d;
	}

	/**
	 * A `FullscreenControl` control contains a button for toggling the map in and out of fullscreen mode.
	 * When [requestFullscreen](https://developer.mozilla.org/en-US/docs/Web/API/Element/requestFullscreen) is not supported, fullscreen is handled via CSS properties.
	 * The map's `cooperativeGestures` option is temporarily disabled while the map
	 * is in fullscreen mode, and is restored when the map exist fullscreen mode.
	 *
	 * @group Markers and Controls
	 * @param options - the full screen control options
	 *
	 * @example
	 * ```ts
	 * map.addControl(new FullscreenControl({container: document.querySelector('body')}));
	 * ```
	 * @see [View a fullscreen map](https://maplibre.org/maplibre-gl-js/docs/examples/fullscreen/)
	 *
	 * ### Events
	 *
	 * @event `fullscreenstart` - Fired when fullscreen mode has started
	 *
	 * @event `fullscreenend` - Fired when fullscreen mode has ended
	 */
	class FullscreenControl extends performance$1.Evented {
	    constructor(options = {}) {
	        super();
	        this._onFullscreenChange = () => {
	            var _a;
	            let fullscreenElement = window.document.fullscreenElement ||
	                window.document.mozFullScreenElement ||
	                window.document.webkitFullscreenElement ||
	                window.document.msFullscreenElement;
	            while ((_a = fullscreenElement === null || fullscreenElement === void 0 ? void 0 : fullscreenElement.shadowRoot) === null || _a === void 0 ? void 0 : _a.fullscreenElement) {
	                fullscreenElement = fullscreenElement.shadowRoot.fullscreenElement;
	            }
	            if ((fullscreenElement === this._container) !== this._fullscreen) {
	                this._handleFullscreenChange();
	            }
	        };
	        this._onClickFullscreen = () => {
	            if (this._isFullscreen()) {
	                this._exitFullscreen();
	            }
	            else {
	                this._requestFullscreen();
	            }
	        };
	        this._fullscreen = false;
	        if (options && options.container) {
	            if (options.container instanceof HTMLElement) {
	                this._container = options.container;
	            }
	            else {
	                performance$1.warnOnce('Full screen control \'container\' must be a DOM element.');
	            }
	        }
	        if ('onfullscreenchange' in document) {
	            this._fullscreenchange = 'fullscreenchange';
	        }
	        else if ('onmozfullscreenchange' in document) {
	            this._fullscreenchange = 'mozfullscreenchange';
	        }
	        else if ('onwebkitfullscreenchange' in document) {
	            this._fullscreenchange = 'webkitfullscreenchange';
	        }
	        else if ('onmsfullscreenchange' in document) {
	            this._fullscreenchange = 'MSFullscreenChange';
	        }
	    }
	    /** {@inheritDoc IControl.onAdd} */
	    onAdd(map) {
	        this._map = map;
	        if (!this._container)
	            this._container = this._map.getContainer();
	        this._controlContainer = DOM.create('div', 'maplibregl-ctrl maplibregl-ctrl-group');
	        this._setupUI();
	        return this._controlContainer;
	    }
	    /** {@inheritDoc IControl.onRemove} */
	    onRemove() {
	        DOM.remove(this._controlContainer);
	        this._map = null;
	        window.document.removeEventListener(this._fullscreenchange, this._onFullscreenChange);
	    }
	    _setupUI() {
	        const button = this._fullscreenButton = DOM.create('button', (('maplibregl-ctrl-fullscreen')), this._controlContainer);
	        DOM.create('span', 'maplibregl-ctrl-icon', button).setAttribute('aria-hidden', 'true');
	        button.type = 'button';
	        this._updateTitle();
	        this._fullscreenButton.addEventListener('click', this._onClickFullscreen);
	        window.document.addEventListener(this._fullscreenchange, this._onFullscreenChange);
	    }
	    _updateTitle() {
	        const title = this._getTitle();
	        this._fullscreenButton.setAttribute('aria-label', title);
	        this._fullscreenButton.title = title;
	    }
	    _getTitle() {
	        return this._map._getUIString(this._isFullscreen() ? 'FullscreenControl.Exit' : 'FullscreenControl.Enter');
	    }
	    _isFullscreen() {
	        return this._fullscreen;
	    }
	    _handleFullscreenChange() {
	        this._fullscreen = !this._fullscreen;
	        this._fullscreenButton.classList.toggle('maplibregl-ctrl-shrink');
	        this._fullscreenButton.classList.toggle('maplibregl-ctrl-fullscreen');
	        this._updateTitle();
	        if (this._fullscreen) {
	            this.fire(new performance$1.Event('fullscreenstart'));
	            this._prevCooperativeGesturesEnabled = this._map.cooperativeGestures.isEnabled();
	            this._map.cooperativeGestures.disable();
	        }
	        else {
	            this.fire(new performance$1.Event('fullscreenend'));
	            if (this._prevCooperativeGesturesEnabled) {
	                this._map.cooperativeGestures.enable();
	            }
	        }
	    }
	    _exitFullscreen() {
	        if (window.document.exitFullscreen) {
	            window.document.exitFullscreen();
	        }
	        else if (window.document.mozCancelFullScreen) {
	            window.document.mozCancelFullScreen();
	        }
	        else if (window.document.msExitFullscreen) {
	            window.document.msExitFullscreen();
	        }
	        else if (window.document.webkitCancelFullScreen) {
	            window.document.webkitCancelFullScreen();
	        }
	        else {
	            this._togglePseudoFullScreen();
	        }
	    }
	    _requestFullscreen() {
	        if (this._container.requestFullscreen) {
	            this._container.requestFullscreen();
	        }
	        else if (this._container.mozRequestFullScreen) {
	            this._container.mozRequestFullScreen();
	        }
	        else if (this._container.msRequestFullscreen) {
	            this._container.msRequestFullscreen();
	        }
	        else if (this._container.webkitRequestFullscreen) {
	            this._container.webkitRequestFullscreen();
	        }
	        else {
	            this._togglePseudoFullScreen();
	        }
	    }
	    _togglePseudoFullScreen() {
	        this._container.classList.toggle('maplibregl-pseudo-fullscreen');
	        this._handleFullscreenChange();
	        this._map.resize();
	    }
	}

	/**
	 * A `TerrainControl` control contains a button for turning the terrain on and off.
	 *
	 * @group Markers and Controls
	 *
	 * @example
	 * ```ts
	 * let map = new Map({TerrainControl: false})
	 *     .addControl(new TerrainControl({
	 *         source: "terrain"
	 *     }));
	 * ```
	 */
	class TerrainControl {
	    constructor(options) {
	        this._toggleTerrain = () => {
	            if (this._map.getTerrain()) {
	                this._map.setTerrain(null);
	            }
	            else {
	                this._map.setTerrain(this.options);
	            }
	            this._updateTerrainIcon();
	        };
	        this._updateTerrainIcon = () => {
	            this._terrainButton.classList.remove('maplibregl-ctrl-terrain');
	            this._terrainButton.classList.remove('maplibregl-ctrl-terrain-enabled');
	            if (this._map.terrain) {
	                this._terrainButton.classList.add('maplibregl-ctrl-terrain-enabled');
	                this._terrainButton.title = this._map._getUIString('TerrainControl.Disable');
	            }
	            else {
	                this._terrainButton.classList.add('maplibregl-ctrl-terrain');
	                this._terrainButton.title = this._map._getUIString('TerrainControl.Enable');
	            }
	        };
	        this.options = options;
	    }
	    /** {@inheritDoc IControl.onAdd} */
	    onAdd(map) {
	        this._map = map;
	        this._container = DOM.create('div', 'maplibregl-ctrl maplibregl-ctrl-group');
	        this._terrainButton = DOM.create('button', 'maplibregl-ctrl-terrain', this._container);
	        DOM.create('span', 'maplibregl-ctrl-icon', this._terrainButton).setAttribute('aria-hidden', 'true');
	        this._terrainButton.type = 'button';
	        this._terrainButton.addEventListener('click', this._toggleTerrain);
	        this._updateTerrainIcon();
	        this._map.on('terrain', this._updateTerrainIcon);
	        return this._container;
	    }
	    /** {@inheritDoc IControl.onRemove} */
	    onRemove() {
	        DOM.remove(this._container);
	        this._map.off('terrain', this._updateTerrainIcon);
	        this._map = undefined;
	    }
	}

	const defaultOptions = {
	    closeButton: true,
	    closeOnClick: true,
	    focusAfterOpen: true,
	    className: '',
	    maxWidth: '240px',
	    subpixelPositioning: false
	};
	const focusQuerySelector = [
	    'a[href]',
	    '[tabindex]:not([tabindex=\'-1\'])',
	    '[contenteditable]:not([contenteditable=\'false\'])',
	    'button:not([disabled])',
	    'input:not([disabled])',
	    'select:not([disabled])',
	    'textarea:not([disabled])',
	].join(', ');
	/**
	 * A popup component.
	 *
	 * @group Markers and Controls
	 *
	 *
	 * @example
	 * Create a popup
	 * ```ts
	 * let popup = new Popup();
	 * // Set an event listener that will fire
	 * // any time the popup is opened
	 * popup.on('open', function(){
	 *   console.log('popup was opened');
	 * });
	 * ```
	 *
	 * @example
	 * Create a popup
	 * ```ts
	 * let popup = new Popup();
	 * // Set an event listener that will fire
	 * // any time the popup is closed
	 * popup.on('close', function(){
	 *   console.log('popup was closed');
	 * });
	 * ```
	 *
	 * @example
	 * ```ts
	 * let markerHeight = 50, markerRadius = 10, linearOffset = 25;
	 * let popupOffsets = {
	 *  'top': [0, 0],
	 *  'top-left': [0,0],
	 *  'top-right': [0,0],
	 *  'bottom': [0, -markerHeight],
	 *  'bottom-left': [linearOffset, (markerHeight - markerRadius + linearOffset) * -1],
	 *  'bottom-right': [-linearOffset, (markerHeight - markerRadius + linearOffset) * -1],
	 *  'left': [markerRadius, (markerHeight - markerRadius) * -1],
	 *  'right': [-markerRadius, (markerHeight - markerRadius) * -1]
	 *  };
	 * let popup = new Popup({offset: popupOffsets, className: 'my-class'})
	 *   .setLngLat(e.lngLat)
	 *   .setHTML("<h1>Hello World!</h1>")
	 *   .setMaxWidth("300px")
	 *   .addTo(map);
	 * ```
	 * @see [Display a popup](https://maplibre.org/maplibre-gl-js/docs/examples/popup/)
	 * @see [Display a popup on hover](https://maplibre.org/maplibre-gl-js/docs/examples/popup-on-hover/)
	 * @see [Display a popup on click](https://maplibre.org/maplibre-gl-js/docs/examples/popup-on-click/)
	 * @see [Attach a popup to a marker instance](https://maplibre.org/maplibre-gl-js/docs/examples/set-popup/)
	 *
	 * ### Events
	 *
	 * @event `open` Fired when the popup is opened manually or programmatically. `popup` object that was opened
	 *
	 * @event `close` Fired when the popup is closed manually or programmatically. `popup` object that was closed
	 */
	class Popup extends performance$1.Evented {
	    constructor(options) {
	        super();
	        /**
	         * Removes the popup from the map it has been added to.
	         *
	         * @example
	         * ```ts
	         * let popup = new Popup().addTo(map);
	         * popup.remove();
	         * ```
	         * @returns `this`
	         */
	        this.remove = () => {
	            if (this._content) {
	                DOM.remove(this._content);
	            }
	            if (this._container) {
	                DOM.remove(this._container);
	                delete this._container;
	            }
	            if (this._map) {
	                this._map.off('move', this._update);
	                this._map.off('move', this._onClose);
	                this._map.off('click', this._onClose);
	                this._map.off('remove', this.remove);
	                this._map.off('mousemove', this._onMouseMove);
	                this._map.off('mouseup', this._onMouseUp);
	                this._map.off('drag', this._onDrag);
	                this._map._canvasContainer.classList.remove('maplibregl-track-pointer');
	                delete this._map;
	                this.fire(new performance$1.Event('close'));
	            }
	            return this;
	        };
	        this._onMouseUp = (event) => {
	            this._update(event.point);
	        };
	        this._onMouseMove = (event) => {
	            this._update(event.point);
	        };
	        this._onDrag = (event) => {
	            this._update(event.point);
	        };
	        this._update = (cursor) => {
	            var _a;
	            const hasPosition = this._lngLat || this._trackPointer;
	            if (!this._map || !hasPosition || !this._content) {
	                return;
	            }
	            if (!this._container) {
	                this._container = DOM.create('div', 'maplibregl-popup', this._map.getContainer());
	                this._tip = DOM.create('div', 'maplibregl-popup-tip', this._container);
	                this._container.appendChild(this._content);
	                if (this.options.className) {
	                    for (const name of this.options.className.split(' ')) {
	                        this._container.classList.add(name);
	                    }
	                }
	                if (this._trackPointer) {
	                    this._container.classList.add('maplibregl-popup-track-pointer');
	                }
	            }
	            if (this.options.maxWidth && this._container.style.maxWidth !== this.options.maxWidth) {
	                this._container.style.maxWidth = this.options.maxWidth;
	            }
	            if (this._map.transform.renderWorldCopies && !this._trackPointer) {
	                this._lngLat = smartWrap(this._lngLat, this._flatPos, this._map.transform);
	            }
	            else {
	                this._lngLat = (_a = this._lngLat) === null || _a === void 0 ? void 0 : _a.wrap();
	            }
	            if (this._trackPointer && !cursor)
	                return;
	            const pos = this._flatPos = this._pos = this._trackPointer && cursor ? cursor : this._map.project(this._lngLat);
	            if (this._map.terrain) {
	                // flat position is saved because smartWrap needs non-elevated points
	                this._flatPos = this._trackPointer && cursor ? cursor : this._map.transform.locationPoint(this._lngLat);
	            }
	            let anchor = this.options.anchor;
	            const offset = normalizeOffset(this.options.offset);
	            if (!anchor) {
	                const width = this._container.offsetWidth;
	                const height = this._container.offsetHeight;
	                let anchorComponents;
	                if (pos.y + offset.bottom.y < height) {
	                    anchorComponents = ['top'];
	                }
	                else if (pos.y > this._map.transform.height - height) {
	                    anchorComponents = ['bottom'];
	                }
	                else {
	                    anchorComponents = [];
	                }
	                if (pos.x < width / 2) {
	                    anchorComponents.push('left');
	                }
	                else if (pos.x > this._map.transform.width - width / 2) {
	                    anchorComponents.push('right');
	                }
	                if (anchorComponents.length === 0) {
	                    anchor = 'bottom';
	                }
	                else {
	                    anchor = anchorComponents.join('-');
	                }
	            }
	            let offsetedPos = pos.add(offset[anchor]);
	            if (!this.options.subpixelPositioning) {
	                offsetedPos = offsetedPos.round();
	            }
	            DOM.setTransform(this._container, `${anchorTranslate[anchor]} translate(${offsetedPos.x}px,${offsetedPos.y}px)`);
	            applyAnchorClass(this._container, anchor, 'popup');
	        };
	        this._onClose = () => {
	            this.remove();
	        };
	        this.options = performance$1.extend(Object.create(defaultOptions), options);
	    }
	    /**
	     * Adds the popup to a map.
	     *
	     * @param map - The MapLibre GL JS map to add the popup to.
	     * @returns `this`
	     * @example
	     * ```ts
	     * new Popup()
	     *   .setLngLat([0, 0])
	     *   .setHTML("<h1>Null Island</h1>")
	     *   .addTo(map);
	     * ```
	     * @see [Display a popup](https://maplibre.org/maplibre-gl-js/docs/examples/popup/)
	     * @see [Display a popup on hover](https://maplibre.org/maplibre-gl-js/docs/examples/popup-on-hover/)
	     * @see [Display a popup on click](https://maplibre.org/maplibre-gl-js/docs/examples/popup-on-click/)
	     * @see [Show polygon information on click](https://maplibre.org/maplibre-gl-js/docs/examples/polygon-popup-on-click/)
	     */
	    addTo(map) {
	        if (this._map)
	            this.remove();
	        this._map = map;
	        if (this.options.closeOnClick) {
	            this._map.on('click', this._onClose);
	        }
	        if (this.options.closeOnMove) {
	            this._map.on('move', this._onClose);
	        }
	        this._map.on('remove', this.remove);
	        this._update();
	        this._focusFirstElement();
	        if (this._trackPointer) {
	            this._map.on('mousemove', this._onMouseMove);
	            this._map.on('mouseup', this._onMouseUp);
	            if (this._container) {
	                this._container.classList.add('maplibregl-popup-track-pointer');
	            }
	            this._map._canvasContainer.classList.add('maplibregl-track-pointer');
	        }
	        else {
	            this._map.on('move', this._update);
	        }
	        this.fire(new performance$1.Event('open'));
	        return this;
	    }
	    /**
	     * @returns `true` if the popup is open, `false` if it is closed.
	     */
	    isOpen() {
	        return !!this._map;
	    }
	    /**
	     * Returns the geographical location of the popup's anchor.
	     *
	     * The longitude of the result may differ by a multiple of 360 degrees from the longitude previously
	     * set by `setLngLat` because `Popup` wraps the anchor longitude across copies of the world to keep
	     * the popup on screen.
	     *
	     * @returns The geographical location of the popup's anchor.
	     */
	    getLngLat() {
	        return this._lngLat;
	    }
	    /**
	     * Sets the geographical location of the popup's anchor, and moves the popup to it. Replaces trackPointer() behavior.
	     *
	     * @param lnglat - The geographical location to set as the popup's anchor.
	     * @returns `this`
	     */
	    setLngLat(lnglat) {
	        this._lngLat = performance$1.LngLat.convert(lnglat);
	        this._pos = null;
	        this._flatPos = null;
	        this._trackPointer = false;
	        this._update();
	        if (this._map) {
	            this._map.on('move', this._update);
	            this._map.off('mousemove', this._onMouseMove);
	            if (this._container) {
	                this._container.classList.remove('maplibregl-popup-track-pointer');
	            }
	            this._map._canvasContainer.classList.remove('maplibregl-track-pointer');
	        }
	        return this;
	    }
	    /**
	     * Tracks the popup anchor to the cursor position on screens with a pointer device (it will be hidden on touchscreens). Replaces the `setLngLat` behavior.
	     * For most use cases, set `closeOnClick` and `closeButton` to `false`.
	     * @example
	     * ```ts
	     * let popup = new Popup({ closeOnClick: false, closeButton: false })
	     *   .setHTML("<h1>Hello World!</h1>")
	     *   .trackPointer()
	     *   .addTo(map);
	     * ```
	     * @returns `this`
	     */
	    trackPointer() {
	        this._trackPointer = true;
	        this._pos = null;
	        this._flatPos = null;
	        this._update();
	        if (this._map) {
	            this._map.off('move', this._update);
	            this._map.on('mousemove', this._onMouseMove);
	            this._map.on('drag', this._onDrag);
	            if (this._container) {
	                this._container.classList.add('maplibregl-popup-track-pointer');
	            }
	            this._map._canvasContainer.classList.add('maplibregl-track-pointer');
	        }
	        return this;
	    }
	    /**
	     * Returns the `Popup`'s HTML element.
	     * @example
	     * Change the `Popup` element's font size
	     * ```ts
	     * let popup = new Popup()
	     *   .setLngLat([-96, 37.8])
	     *   .setHTML("<p>Hello World!</p>")
	     *   .addTo(map);
	     * let popupElem = popup.getElement();
	     * popupElem.style.fontSize = "25px";
	     * ```
	     * @returns element
	     */
	    getElement() {
	        return this._container;
	    }
	    /**
	     * Sets the popup's content to a string of text.
	     *
	     * This function creates a [Text](https://developer.mozilla.org/en-US/docs/Web/API/Text) node in the DOM,
	     * so it cannot insert raw HTML. Use this method for security against XSS
	     * if the popup content is user-provided.
	     *
	     * @param text - Textual content for the popup.
	     * @returns `this`
	     * @example
	     * ```ts
	     * let popup = new Popup()
	     *   .setLngLat(e.lngLat)
	     *   .setText('Hello, world!')
	     *   .addTo(map);
	     * ```
	     */
	    setText(text) {
	        return this.setDOMContent(document.createTextNode(text));
	    }
	    /**
	     * Sets the popup's content to the HTML provided as a string.
	     *
	     * This method does not perform HTML filtering or sanitization, and must be
	     * used only with trusted content. Consider {@link Popup#setText} if
	     * the content is an untrusted text string.
	     *
	     * @param html - A string representing HTML content for the popup.
	     * @returns `this`
	     * @example
	     * ```ts
	     * let popup = new Popup()
	     *   .setLngLat(e.lngLat)
	     *   .setHTML("<h1>Hello World!</h1>")
	     *   .addTo(map);
	     * ```
	     * @see [Display a popup](https://maplibre.org/maplibre-gl-js/docs/examples/popup/)
	     * @see [Display a popup on hover](https://maplibre.org/maplibre-gl-js/docs/examples/popup-on-hover/)
	     * @see [Display a popup on click](https://maplibre.org/maplibre-gl-js/docs/examples/popup-on-click/)
	     * @see [Attach a popup to a marker instance](https://maplibre.org/maplibre-gl-js/docs/examples/set-popup/)
	     */
	    setHTML(html) {
	        const frag = document.createDocumentFragment();
	        const temp = document.createElement('body');
	        let child;
	        temp.innerHTML = html;
	        while (true) {
	            child = temp.firstChild;
	            if (!child)
	                break;
	            frag.appendChild(child);
	        }
	        return this.setDOMContent(frag);
	    }
	    /**
	     * Returns the popup's maximum width.
	     *
	     * @returns The maximum width of the popup.
	     */
	    getMaxWidth() {
	        var _a;
	        return (_a = this._container) === null || _a === void 0 ? void 0 : _a.style.maxWidth;
	    }
	    /**
	     * Sets the popup's maximum width. This is setting the CSS property `max-width`.
	     * Available values can be found here: https://developer.mozilla.org/en-US/docs/Web/CSS/max-width
	     *
	     * @param maxWidth - A string representing the value for the maximum width.
	     * @returns `this`
	     */
	    setMaxWidth(maxWidth) {
	        this.options.maxWidth = maxWidth;
	        this._update();
	        return this;
	    }
	    /**
	     * Sets the popup's content to the element provided as a DOM node.
	     *
	     * @param htmlNode - A DOM node to be used as content for the popup.
	     * @returns `this`
	     * @example
	     * Create an element with the popup content
	     * ```ts
	     * let div = document.createElement('div');
	     * div.innerHTML = 'Hello, world!';
	     * let popup = new Popup()
	     *   .setLngLat(e.lngLat)
	     *   .setDOMContent(div)
	     *   .addTo(map);
	     * ```
	     */
	    setDOMContent(htmlNode) {
	        if (this._content) {
	            // Clear out children first.
	            while (this._content.hasChildNodes()) {
	                if (this._content.firstChild) {
	                    this._content.removeChild(this._content.firstChild);
	                }
	            }
	        }
	        else {
	            this._content = DOM.create('div', 'maplibregl-popup-content', this._container);
	        }
	        // The close button should be the last tabbable element inside the popup for a good keyboard UX.
	        this._content.appendChild(htmlNode);
	        this._createCloseButton();
	        this._update();
	        this._focusFirstElement();
	        return this;
	    }
	    /**
	     * Adds a CSS class to the popup container element.
	     *
	     * @param className - Non-empty string with CSS class name to add to popup container
	     *
	     * @example
	     * ```ts
	     * let popup = new Popup()
	     * popup.addClassName('some-class')
	     * ```
	     */
	    addClassName(className) {
	        if (this._container) {
	            this._container.classList.add(className);
	        }
	    }
	    /**
	     * Removes a CSS class from the popup container element.
	     *
	     * @param className - Non-empty string with CSS class name to remove from popup container
	     *
	     * @example
	     * ```ts
	     * let popup = new Popup()
	     * popup.removeClassName('some-class')
	     * ```
	     */
	    removeClassName(className) {
	        if (this._container) {
	            this._container.classList.remove(className);
	        }
	    }
	    /**
	     * Sets the popup's offset.
	     *
	     * @param offset - Sets the popup's offset.
	     * @returns `this`
	     */
	    setOffset(offset) {
	        this.options.offset = offset;
	        this._update();
	        return this;
	    }
	    /**
	     * Add or remove the given CSS class on the popup container, depending on whether the container currently has that class.
	     *
	     * @param className - Non-empty string with CSS class name to add/remove
	     *
	     * @returns if the class was removed return false, if class was added, then return true, undefined if there is no container
	     *
	     * @example
	     * ```ts
	     * let popup = new Popup()
	     * popup.toggleClassName('toggleClass')
	     * ```
	     */
	    toggleClassName(className) {
	        if (this._container) {
	            return this._container.classList.toggle(className);
	        }
	    }
	    /**
	     * Set the option to allow subpixel positioning of the popup by passing a boolean
	     *
	     * @param value - When boolean is true, subpixel positioning is enabled for the popup.
	     *
	     * @example
	     * ```ts
	     * let popup = new Popup()
	     * popup.setSubpixelPositioning(true);
	     * ```
	     */
	    setSubpixelPositioning(value) {
	        this.options.subpixelPositioning = value;
	    }
	    _createCloseButton() {
	        if (this.options.closeButton) {
	            this._closeButton = DOM.create('button', 'maplibregl-popup-close-button', this._content);
	            this._closeButton.type = 'button';
	            this._closeButton.setAttribute('aria-label', 'Close popup');
	            this._closeButton.innerHTML = '&#215;';
	            this._closeButton.addEventListener('click', this._onClose);
	        }
	    }
	    _focusFirstElement() {
	        if (!this.options.focusAfterOpen || !this._container)
	            return;
	        const firstFocusable = this._container.querySelector(focusQuerySelector);
	        if (firstFocusable)
	            firstFocusable.focus();
	    }
	}
	function normalizeOffset(offset) {
	    if (!offset) {
	        return normalizeOffset(new performance$1.Point(0, 0));
	    }
	    else if (typeof offset === 'number') {
	        // input specifies a radius from which to calculate offsets at all positions
	        const cornerOffset = Math.round(Math.abs(offset) / Math.SQRT2);
	        return {
	            'center': new performance$1.Point(0, 0),
	            'top': new performance$1.Point(0, offset),
	            'top-left': new performance$1.Point(cornerOffset, cornerOffset),
	            'top-right': new performance$1.Point(-cornerOffset, cornerOffset),
	            'bottom': new performance$1.Point(0, -offset),
	            'bottom-left': new performance$1.Point(cornerOffset, -cornerOffset),
	            'bottom-right': new performance$1.Point(-cornerOffset, -cornerOffset),
	            'left': new performance$1.Point(offset, 0),
	            'right': new performance$1.Point(-offset, 0)
	        };
	    }
	    else if (offset instanceof performance$1.Point || Array.isArray(offset)) {
	        // input specifies a single offset to be applied to all positions
	        const convertedOffset = performance$1.Point.convert(offset);
	        return {
	            'center': convertedOffset,
	            'top': convertedOffset,
	            'top-left': convertedOffset,
	            'top-right': convertedOffset,
	            'bottom': convertedOffset,
	            'bottom-left': convertedOffset,
	            'bottom-right': convertedOffset,
	            'left': convertedOffset,
	            'right': convertedOffset
	        };
	    }
	    else {
	        // input specifies an offset per position
	        return {
	            'center': performance$1.Point.convert(offset['center'] || [0, 0]),
	            'top': performance$1.Point.convert(offset['top'] || [0, 0]),
	            'top-left': performance$1.Point.convert(offset['top-left'] || [0, 0]),
	            'top-right': performance$1.Point.convert(offset['top-right'] || [0, 0]),
	            'bottom': performance$1.Point.convert(offset['bottom'] || [0, 0]),
	            'bottom-left': performance$1.Point.convert(offset['bottom-left'] || [0, 0]),
	            'bottom-right': performance$1.Point.convert(offset['bottom-right'] || [0, 0]),
	            'left': performance$1.Point.convert(offset['left'] || [0, 0]),
	            'right': performance$1.Point.convert(offset['right'] || [0, 0])
	        };
	    }
	}

	const version = packageJSON.version;
	/**
	 * Sets the map's [RTL text plugin](https://www.mapbox.com/mapbox-gl-js/plugins/#mapbox-gl-rtl-text).
	 * Necessary for supporting the Arabic and Hebrew languages, which are written right-to-left.
	 *
	 * @param pluginURL - URL pointing to the Mapbox RTL text plugin source.
	 * @param lazy - If set to `true`, mapboxgl will defer loading the plugin until rtl text is encountered,
	 * rtl text will then be rendered only after the plugin finishes loading.
	 * @example
	 * ```ts
	 * setRTLTextPlugin('https://unpkg.com/@mapbox/mapbox-gl-rtl-text@0.2.3/mapbox-gl-rtl-text.js', false);
	 * ```
	 * @see [Add support for right-to-left scripts](https://maplibre.org/maplibre-gl-js/docs/examples/mapbox-gl-rtl-text/)
	 */
	function setRTLTextPlugin(pluginURL, lazy) {
	    return rtlMainThreadPluginFactory().setRTLTextPlugin(pluginURL, lazy);
	}
	/**
	 * Gets the map's [RTL text plugin](https://www.mapbox.com/mapbox-gl-js/plugins/#mapbox-gl-rtl-text) status.
	 * The status can be `unavailable` (i.e. not requested or removed), `loading`, `loaded` or `error`.
	 * If the status is `loaded` and the plugin is requested again, an error will be thrown.
	 *
	 * @example
	 * ```ts
	 * const pluginStatus = getRTLTextPluginStatus();
	 * ```
	 */
	function getRTLTextPluginStatus() {
	    return rtlMainThreadPluginFactory().getRTLTextPluginStatus();
	}
	/**
	 * Returns the package version of the library
	 * @returns Package version of the library
	 */
	function getVersion() { return version; }
	/**
	 * Gets the number of web workers instantiated on a page with GL JS maps.
	 * By default, workerCount is 1 except for Safari browser where it is set to half the number of CPU cores (capped at 3).
	 * Make sure to set this property before creating any map instances for it to have effect.
	 *
	 * @returns Number of workers currently configured.
	 * @example
	 * ```ts
	 * const workerCount = getWorkerCount()
	 * ```
	 */
	function getWorkerCount() { return WorkerPool.workerCount; }
	/**
	 * Sets the number of web workers instantiated on a page with GL JS maps.
	 * By default, workerCount is 1 except for Safari browser where it is set to half the number of CPU cores (capped at 3).
	 * Make sure to set this property before creating any map instances for it to have effect.
	 *
	 * @example
	 * ```ts
	 * setWorkerCount(2);
	 * ```
	 */
	function setWorkerCount(count) { WorkerPool.workerCount = count; }
	/**
	 * Gets and sets the maximum number of images (raster tiles, sprites, icons) to load in parallel,
	 * which affects performance in raster-heavy maps. 16 by default.
	 *
	 * @returns Number of parallel requests currently configured.
	 * @example
	 * ```ts
	 * getMaxParallelImageRequests();
	 * ```
	 */
	function getMaxParallelImageRequests() { return performance$1.config.MAX_PARALLEL_IMAGE_REQUESTS; }
	/**
	 * Sets the maximum number of images (raster tiles, sprites, icons) to load in parallel,
	 * which affects performance in raster-heavy maps. 16 by default.
	 *
	 * @example
	 * ```ts
	 * setMaxParallelImageRequests(10);
	 * ```
	 */
	function setMaxParallelImageRequests(numRequests) { performance$1.config.MAX_PARALLEL_IMAGE_REQUESTS = numRequests; }
	/**
	 * Gets the worker url
	 * @returns The worker url
	 */
	function getWorkerUrl() { return performance$1.config.WORKER_URL; }
	/**
	 * Sets the worker url
	 */
	function setWorkerUrl(value) { performance$1.config.WORKER_URL = value; }
	/**
	 * Allows loading javascript code in the worker thread.
	 * *Note* that since this is using some very internal classes and flows it is considered experimental and can break at any point.
	 *
	 * It can be useful for the following examples:
	 * 1. Using `self.addProtocol` in the worker thread - note that you might need to also register the protocol on the main thread.
	 * 2. Using `self.registerWorkerSource(workerSource: WorkerSource)` to register a worker source, which sould come with `addSourceType` usually.
	 * 3. using `self.actor.registerMessageHandler` to override some internal worker operations
	 * @param workerUrl - the worker url e.g. a url of a javascript file to load in the worker
	 * @returns
	 *
	 * @example
	 * ```ts
	 * // below is an example of sending a js file to the worker to load the method there
	 * // Note that you'll need to call the global function `addProtocol` in the worker to register the protocol there.
	 * // add-protocol-worker.js
	 * async function loadFn(params, abortController) {
	 *     const t = await fetch(`https://${params.url.split("://")[1]}`);
	 *     if (t.status == 200) {
	 *         const buffer = await t.arrayBuffer();
	 *         return {data: buffer}
	 *     } else {
	 *         throw new Error(`Tile fetch error: ${t.statusText}`);
	 *     }
	 * }
	 * self.addPRotocol('custom', loadFn);
	 *
	 * // main.js
	 * importScriptInWorkers('add-protocol-worker.js');
	 * ```
	 */
	function importScriptInWorkers(workerUrl) { return getGlobalDispatcher().broadcast("IS" /* MessageType.importScript */, workerUrl); }

	exports.AJAXError = performance$1.AJAXError;
	exports.Evented = performance$1.Evented;
	exports.LngLat = performance$1.LngLat;
	exports.MercatorCoordinate = performance$1.MercatorCoordinate;
	exports.Point = performance$1.Point;
	exports.addProtocol = performance$1.addProtocol;
	exports.config = performance$1.config;
	exports.removeProtocol = performance$1.removeProtocol;
	exports.AttributionControl = AttributionControl;
	exports.BoxZoomHandler = BoxZoomHandler;
	exports.CanvasSource = CanvasSource;
	exports.CooperativeGesturesHandler = CooperativeGesturesHandler;
	exports.DoubleClickZoomHandler = DoubleClickZoomHandler;
	exports.DragPanHandler = DragPanHandler;
	exports.DragRotateHandler = DragRotateHandler;
	exports.EdgeInsets = EdgeInsets;
	exports.FullscreenControl = FullscreenControl;
	exports.GeoJSONSource = GeoJSONSource;
	exports.GeolocateControl = GeolocateControl;
	exports.Hash = Hash;
	exports.ImageSource = ImageSource;
	exports.KeyboardHandler = KeyboardHandler;
	exports.LngLatBounds = LngLatBounds;
	exports.LogoControl = LogoControl;
	exports.Map = Map$1;
	exports.MapMouseEvent = MapMouseEvent;
	exports.MapTouchEvent = MapTouchEvent;
	exports.MapWheelEvent = MapWheelEvent;
	exports.Marker = Marker;
	exports.NavigationControl = NavigationControl;
	exports.Popup = Popup;
	exports.RasterDEMTileSource = RasterDEMTileSource;
	exports.RasterTileSource = RasterTileSource;
	exports.ScaleControl = ScaleControl;
	exports.ScrollZoomHandler = ScrollZoomHandler;
	exports.Style = Style;
	exports.TerrainControl = TerrainControl;
	exports.TwoFingersTouchPitchHandler = TwoFingersTouchPitchHandler;
	exports.TwoFingersTouchRotateHandler = TwoFingersTouchRotateHandler;
	exports.TwoFingersTouchZoomHandler = TwoFingersTouchZoomHandler;
	exports.TwoFingersTouchZoomRotateHandler = TwoFingersTouchZoomRotateHandler;
	exports.VectorTileSource = VectorTileSource;
	exports.VideoSource = VideoSource;
	exports.addSourceType = addSourceType;
	exports.clearPrewarmedResources = clearPrewarmedResources;
	exports.getMaxParallelImageRequests = getMaxParallelImageRequests;
	exports.getRTLTextPluginStatus = getRTLTextPluginStatus;
	exports.getVersion = getVersion;
	exports.getWorkerCount = getWorkerCount;
	exports.getWorkerUrl = getWorkerUrl;
	exports.importScriptInWorkers = importScriptInWorkers;
	exports.prewarm = prewarm;
	exports.setMaxParallelImageRequests = setMaxParallelImageRequests;
	exports.setRTLTextPlugin = setRTLTextPlugin;
	exports.setWorkerCount = setWorkerCount;
	exports.setWorkerUrl = setWorkerUrl;

	}));

	//
	// Our custom intro provides a specialized "define()" function, called by the
	// AMD modules below, that sets up the worker blob URL and then executes the
	// main module, storing its exported value as 'maplibregl'


	var maplibregl$1 = maplibregl;

	return maplibregl$1;

	}));
	
} (azuremapsMaplibreGlDev));

var azuremapsMaplibreGlDevExports = azuremapsMaplibreGlDev.exports;
var maplibregl = /*@__PURE__*/getDefaultExportFromCjs(azuremapsMaplibreGlDevExports);

function commonjsRequire(path) {
	throw new Error('Could not dynamically require "' + path + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
}

var uuidRandom = {exports: {}};

var _nodeResolve_empty = {};

var _nodeResolve_empty$1 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	default: _nodeResolve_empty
});

var require$$0 = /*@__PURE__*/getAugmentedNamespace(_nodeResolve_empty$1);

(function (module) {

	(function(){

	  var
	    buf,
	    bufIdx = 0,
	    hexBytes = [],
	    i
	  ;

	  // Pre-calculate toString(16) for speed
	  for (i = 0; i < 256; i++) {
	    hexBytes[i] = (i + 0x100).toString(16).substr(1);
	  }

	  // Buffer random numbers for speed
	  // Reduce memory usage by decreasing this number (min 16)
	  // or improve speed by increasing this number (try 16384)
	  uuid.BUFFER_SIZE = 4096;

	  // Binary uuids
	  uuid.bin = uuidBin;

	  // Clear buffer
	  uuid.clearBuffer = function() {
	    buf = null;
	    bufIdx = 0;
	  };

	  // Test for uuid
	  uuid.test = function(uuid) {
	    if (typeof uuid === 'string') {
	      return /^[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(uuid);
	    }
	    return false;
	  };

	  // Node & Browser support
	  var crypt0;
	  if (typeof crypto !== 'undefined') {
	    crypt0 = crypto;
	  } else if( (typeof window !== 'undefined') && (typeof window.msCrypto !== 'undefined')) {
	    crypt0 = window.msCrypto; // IE11
	  }

	  if ((typeof commonjsRequire === 'function')) {
	    crypt0 = crypt0 || require$$0;
	    module.exports = uuid;
	  } else if (typeof window !== 'undefined') {
	    window.uuid = uuid;
	  }

	  // Use best available PRNG
	  // Also expose this so you can override it.
	  uuid.randomBytes = (function(){
	    if (crypt0) {
	      if (crypt0.randomBytes) {
	        return crypt0.randomBytes;
	      }
	      if (crypt0.getRandomValues) {
	        if (typeof Uint8Array.prototype.slice !== 'function') {
	          return function(n) {
	            var bytes = new Uint8Array(n);
	            crypt0.getRandomValues(bytes);
	            return Array.from(bytes);
	          };
	        }
	        return function(n) {
	          var bytes = new Uint8Array(n);
	          crypt0.getRandomValues(bytes);
	          return bytes;
	        };
	      }
	    }
	    return function(n) {
	      var i, r = [];
	      for (i = 0; i < n; i++) {
	        r.push(Math.floor(Math.random() * 256));
	      }
	      return r;
	    };
	  })();

	  // Buffer some random bytes for speed
	  function randomBytesBuffered(n) {
	    if (!buf || ((bufIdx + n) > uuid.BUFFER_SIZE)) {
	      bufIdx = 0;
	      buf = uuid.randomBytes(uuid.BUFFER_SIZE);
	    }
	    return buf.slice(bufIdx, bufIdx += n);
	  }

	  // uuid.bin
	  function uuidBin() {
	    var b = randomBytesBuffered(16);
	    b[6] = (b[6] & 0x0f) | 0x40;
	    b[8] = (b[8] & 0x3f) | 0x80;
	    return b;
	  }

	  // String UUIDv4 (Random)
	  function uuid() {
	    var b = uuidBin();
	    return hexBytes[b[0]] + hexBytes[b[1]] +
	      hexBytes[b[2]] + hexBytes[b[3]] + '-' +
	      hexBytes[b[4]] + hexBytes[b[5]] + '-' +
	      hexBytes[b[6]] + hexBytes[b[7]] + '-' +
	      hexBytes[b[8]] + hexBytes[b[9]] + '-' +
	      hexBytes[b[10]] + hexBytes[b[11]] +
	      hexBytes[b[12]] + hexBytes[b[13]] +
	      hexBytes[b[14]] + hexBytes[b[15]]
	    ;
	  }

	})(); 
} (uuidRandom));

var uuidRandomExports = uuidRandom.exports;
var uuid = /*@__PURE__*/getDefaultExportFromCjs(uuidRandomExports);

var env = {
	domain: "atlas.microsoft.com",
	staticAssetsDomain: "atlas.microsoft.com",
	stylePath: "styling",
	styleDefinitionsVersion: "2023-01-01",
	appInsightsKey: "e96cb745-c6f5-409c-a775-c4313e468c1d",
	aadInstance: "https://login.microsoftonline.com/"
};
var constants = {
	apiVersionQueryParameter: "api-version",
	authorizationHeaderName: "Authorization",
	authorizationTokenPrefix: "Bearer ",
	jwtSasPrefix: "jwt-sas ",
	domainPlaceHolder: "{{azMapsDomain}}",
	legacyDomainPlaceHolder: "{azMapsDomain}",
	viewPlaceHolder: "{{azMapsView}}",
	viewParameter: "view",
	languagePlaceHolder: "{{azMapsLanguage}}",
	stylePathHolder: "{{azMapsStylingPath}}",
	styleResourcePlaceholder: "{{azMapsStylePath}}",
	stylePath: "styling",
	styleResourcePath: "styles",
	styleApiVersion: "2.0",
	mapAgentHeaderName: "Map-Agent",
	msClientIdHeaderName: "x-ms-client-id",
	msOriginHeaderName: "Ms-Am-Request-Origin",
	msOriginHeaderValue: "MapControl",
	aadResourceId: "https://atlas.microsoft.com/.default",
	sessionIdHeaderName: "Session-Id"
};

var __values$k = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * @private
 */
var Options = /** @class */ (function () {
    function Options() {
    }
    /**
     * @internal
     */
    Options.prototype.merge = function () {
        var e_1, _a;
        var valuesList = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            valuesList[_i] = arguments[_i];
        }
        var defaults;
        try {
            for (var valuesList_1 = __values$k(valuesList), valuesList_1_1 = valuesList_1.next(); !valuesList_1_1.done; valuesList_1_1 = valuesList_1.next()) {
                var values = valuesList_1_1.value;
                if (!values) {
                    continue;
                }
                for (var property in values) {
                    if (values.hasOwnProperty(property) && this.hasOwnProperty(property)) {
                        if (values[property] !== undefined && values[property] != null) {
                            // Check for nested options and merge them rather than simply overwriting.
                            if (this[property] instanceof Options) {
                                this[property].merge(values[property]);
                            }
                            else {
                                this[property] = values[property];
                            }
                        }
                        else {
                            // Assume a value of undefined or null intends to take the default value.
                            // Create a new object to access its defaults.
                            if (!defaults) {
                                defaults = new (Object.getPrototypeOf(this).constructor)();
                            }
                            this[property] = defaults[property];
                        }
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (valuesList_1_1 && !valuesList_1_1.done && (_a = valuesList_1.return)) _a.call(valuesList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return this;
    };
    return Options;
}());

var __extends$1n = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read$h = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
/**
 * @private
 */
var UrlOptions = /** @class */ (function (_super) {
    __extends$1n(UrlOptions, _super);
    function UrlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.domain = undefined;
        _this.headers = {};
        _this.path = "";
        _this.protocol = "https";
        _this.queryParams = {};
        _this.subdomain = "";
        return _this;
    }
    return UrlOptions;
}(Options));
/**
 * @private
 */
// tslint:disable-next-line:max-classes-per-file
var Url = /** @class */ (function () {
    function Url(options) {
        this.options = new UrlOptions().merge(options);
    }
    // tslint:disable-next-line:no-reserved-keywords
    Url.prototype.get = function () {
        return fetch(this.toString(), {
            method: "GET",
            mode: "cors",
            headers: new Headers(this.options.headers),
        }).then(function (response) {
            if (response.ok) {
                return response.json();
            }
            else {
                throw new Error("HTTP ".concat(response.status, ": ").concat(response.statusText));
            }
        });
    };
    Url.prototype.toString = function () {
        var self = this;
        var queryParamsString = Object.entries(self.options.queryParams)
            .map(function (_a) {
            var _b = __read$h(_a, 2), key = _b[0], value = _b[1];
            return "".concat(key, "=").concat(value);
        })
            .join("&");
        var url = [];
        var path = self.options.path || "";
        // If path contains the protocol, don't add domain to the url.
        if (Url.protoRegEx.test(path)) {
            url.push(path);
        }
        else {
            // domain may be empty for absolute paths or
            // path itself might start with '/' for absolute paths
            if (self.options.domain) {
                if (!Url.protoRegEx.test(self.options.domain)) {
                    // If the domain doesn't include a protocol use the separate protocol and subdomain properties.
                    // If the domain includes a protocol assume it also includes the subdomain.
                    url.push("".concat(self.options.protocol, "://"));
                    url.push(self.options.subdomain ? "".concat(self.options.subdomain, ".") : "");
                }
                url.push(self.options.domain);
            }
            url.push(self.options.path ? "/".concat(path) : "");
        }
        url.push(queryParamsString ? "?".concat(queryParamsString) : "");
        return url.join("");
    };
    Url.protoRegEx = new RegExp(/^(((file|http|https):\/\/)|blob:)/i);
    return Url;
}());

/**
 * A helper class that will parses and splits a culture code into its language and region parts.
 */
var CultureCode = /** @class */ (function () {
    function CultureCode() {
    }
    /**
     * Parses and splits the specified culture code.
     * Splits based on the last index of "-".
     * If a split can not be made the specified code will be considered just the language leaving region undefined.
     * All string properties will be in lowercase for simplified string matching.
     * @param code The culture code.
     */
    CultureCode.parse = function (code) {
        code = code.toLowerCase();
        var index = code.lastIndexOf("-");
        if (index !== -1) {
            return {
                code: code,
                language: code.substring(0, index),
                region: code.substring(index + 1)
            };
        }
        return {
            code: code,
            language: code,
        };
    };
    return CultureCode;
}());

/**
 * A specific implementation of the LocaleIndex interface.
 * Contains real information about the available/supported locales.
 */
var localeIndex = {
    localizationsPath: "locs/mapcontrol/2019-3-12",
    sensitiveUserRegions: ["il", "kr", "pk", "in", "cn", "ar", "bh", "eg", "jo", "sa", "kw", "om", "qa", "ma", "ae"],
    locales: {
        defaultLanguage: {
            defaultRegion: {
                code: "NGT",
                strings: "en/resource.json"
            },
            latn: {
                code: "NGT-Latn",
                strings: "en/resource.json"
            }
        },
        ar: {
            defaultRegion: {
                code: "ar",
                strings: "ar-sa/resource.json"
            }
        },
        bg: {
            defaultRegion: {
                code: "bg-BG",
                strings: "bg-bg/resource.json"
            }
        },
        cs: {
            defaultRegion: {
                code: "cs-CZ",
                strings: "cs-cz/resource.json"
            }
        },
        da: {
            defaultRegion: {
                code: "da-DK",
                strings: "da-dk/resource.json"
            }
        },
        de: {
            defaultRegion: {
                code: "de-DE",
                strings: "de-de/resource.json"
            }
        },
        el: {
            defaultRegion: {
                code: "el-GR",
                strings: "el-gr/resource.json"
            }
        },
        en: {
            defaultRegion: {
                code: "en",
                strings: "en/resource.json"
            },
            us: {
                code: "en-US",
                strings: "en/resource.json"
            },
            au: {
                code: "en-AU",
                strings: "en/resource.json"
            },
            gb: {
                code: "en-GB",
                strings: "en/resource.json"
            },
            nz: {
                code: "en-NZ",
                strings: "en/resource.json"
            }
        },
        es: {
            defaultRegion: {
                code: "es-ES",
                strings: "es-es/resource.json"
            },
            mx: {
                code: "es-MX",
                strings: "es-mx/resource.json"
            }
        },
        fi: {
            defaultRegion: {
                code: "fi-FI",
                strings: "fi-fi/resource.json"
            }
        },
        fr: {
            defaultRegion: {
                code: "fr-FR",
                strings: "fr-fr/resource.json"
            }
        },
        hu: {
            defaultRegion: {
                code: "hu-HU",
                strings: "hu-hu/resource.json"
            }
        },
        id: {
            defaultRegion: {
                code: "id-ID",
                strings: "id-id/resource.json"
            }
        },
        it: {
            defaultRegion: {
                code: "it-IT",
                strings: "it-it/resource.json"
            }
        },
        ko: {
            defaultRegion: {
                code: "ko-KR",
                strings: "ko-kr/resource.json"
            }
        },
        lt: {
            defaultRegion: {
                code: "lt-LT",
                strings: "lt-lt/resource.json"
            }
        },
        ms: {
            defaultRegion: {
                code: "ms-MY",
                strings: "ms-my/resource.json"
            }
        },
        nb: {
            defaultRegion: {
                code: "nb-NO",
                strings: "nb-no/resource.json"
            }
        },
        nl: {
            defaultRegion: {
                code: "nl-NL",
                strings: "nl-nl/resource.json"
            }
        },
        pl: {
            defaultRegion: {
                code: "pl-PL",
                strings: "pl-pl/resource.json"
            }
        },
        pt: {
            defaultRegion: {
                code: "pt-PT",
                strings: "pt-pt/resource.json"
            },
            br: {
                code: "pt-BR",
                strings: "pt-br/resource.json"
            }
        },
        ru: {
            defaultRegion: {
                code: "ru-RU",
                strings: "ru-ru/resource.json"
            }
        },
        sk: {
            defaultRegion: {
                code: "sk-SK",
                strings: "sk-sk/resource.json"
            }
        },
        sl: {
            defaultRegion: {
                code: "sl-SL",
                strings: "sl-sl/resource.json"
            }
        },
        sv: {
            defaultRegion: {
                code: "sv-SE",
                strings: "sv-se/resource.json"
            }
        },
        th: {
            defaultRegion: {
                code: "th-TH",
                strings: "th-th/resource.json"
            }
        },
        tr: {
            defaultRegion: {
                code: "tr-TR",
                strings: "tr-tr/resource.json"
            }
        },
        zh: {
            // per https://microsoft.sharepoint.com/sites/globalreadiness/SitePages/Language-fallback.aspx
            // Chinese - Neutral (zh) fallbacks to en-US
            defaultRegion: {
                code: "zh",
                strings: "en/resource.json"
            }
        },
        "zh-hans": {
            defaultRegion: {
                code: "zh-Hans",
                strings: "zh-cn/resource.json"
            },
            cn: {
                code: "zh-Hans-CN",
                strings: "zh-cn/resource.json"
            }
        },
        "zh-hant": {
            // per discussion with global readiness team, we were explicitly asked to not fallback zh-hant to zh-tw
            defaultRegion: {
                code: "zh-Hant",
                strings: "en/resource.json"
            },
            tw: {
                code: "zh-Hant-TW",
                strings: "zh-tw/resource.json"
            }
        }
    }
};

/**
 * An interface defining the contents of a specific localized strings json.
 */
var LocalizedStrings = /** @class */ (function () {
    function LocalizedStrings() {
        /**
         * A localized version of `"Unknown"`.
         */
        this.Unknown = "Unknown";
        /**
         * A localized version of `"Accident"`.
         */
        this.Accident = "Accident";
        /**
         * A localized version of `"Fog"`.
         */
        this.Fog = "Fog";
        /**
         * A localized version of `"Danger"`.
         */
        this.Danger = "Danger";
        /**
         * A localized version of `"Rain"`.
         */
        this.Rain = "Rain";
        /**
         * A localized version of `"Ice"`.
         */
        this.Ice = "Ice";
        /**
         * A localized version of `"Jam"`.
         */
        this.Jam = "Jam";
        /**
         * A localized version of `"Lane Closed"`.
         */
        this.LaneClosed = "Lane Closed";
        /**
         * A localized version of `"Road Closed"`.
         */
        this.RoadClosed = "Road Closed";
        /**
         * A localized version of `"Road Works"`.
         */
        this.RoadWorks = "Road Works";
        /**
         * A localized version of `"Wind"`.
         */
        this.Wind = "Wind";
        /**
         * A localized version of `"Flood"`.
         */
        this.Flood = "Flood";
        /**
         * A localized version of `"Detour"`.
         */
        this.Detour = "Detour";
    }
    return LocalizedStrings;
}());

/**
 * A static class used for fetching localized strings and validating supported language codes.
 */
var Localizer = /** @class */ (function () {
    function Localizer() {
    }
    /**
     * Returns a supported culture code that best fits the requested one.
     * @param locale The requested culture code.
     */
    Localizer.getCode = function (locale) {
        // If locale is set to 'auto', use the browser's configured language.
        if (locale.localeCompare("auto", undefined, { sensitivity: "base" }) === 0) {
            locale = navigator.language;
        }
        var code = CultureCode.parse(locale);
        // If the requested culture code includes a sensitive region simply return the original code.
        // This is to hopefully reduce the risk or providing bad content to users in a sensitive region.
        return (localeIndex.sensitiveUserRegions.indexOf(code.region) === -1) ?
            this.getLocaleData(code).code :
            locale;
    };
    /**
     * Returns a collection of localized strings that best fits the requested culture code.
     * @param locale The requested culture code.
     */
    Localizer.getStrings = function (locale) {
        var localeData = this.getLocaleData(locale);
        // For default locale no need to make a network request
        // Its value is already defined in LocalizedStrings
        // This will also make sure that request is not made for Bing maps
        if (localeIndex.locales.defaultLanguage.defaultRegion.code === localeData.code) {
            return new Promise(function (resolve) {
                resolve(new LocalizedStrings());
            });
        }
        else {
            // Start a GET request
            var request = new Url({
                domain: env.staticAssetsDomain,
                path: "".concat(localeIndex.localizationsPath, "/").concat(localeData.strings)
            }).get();
            // Return the response as a LocalizedStrings object.
            return request.then(function (response) {
                return response;
            }, function () {
                // If the request for the localized strings json fails return a default localization in English.
                return new LocalizedStrings();
            });
        }
    };
    /**
     * Gets the best fit locale data based on the specified culture code.
     * @param locale The requested culture code.
     */
    Localizer.getLocaleData = function (locale) {
        // Convert the locale to a culture code if one wasn't already provided.
        if (typeof locale === "string") {
            locale = CultureCode.parse(locale);
        }
        // Check if the locale could be just the language.
        // If so return the default locale data for that language.
        if (localeIndex.locales[locale.code]) {
            return localeIndex.locales[locale.code].defaultRegion;
        }
        // Check if the language is supported.
        // If not use the default language.
        var regionIndex;
        if (localeIndex.locales[locale.language]) {
            regionIndex = localeIndex.locales[locale.language];
        }
        else if (locale.language.indexOf("-") !== -1) {
            // If the current language can't be matched but there is another "-"
            // Try to use the language as if it is a full culture code.
            return this.getLocaleData(locale.language);
        }
        else {
            regionIndex = localeIndex.locales.defaultLanguage;
        }
        // Check if the region is supported for the chosen language.
        // If not use the default region for the chosen language.
        if (locale.region && regionIndex[locale.region]) {
            return regionIndex[locale.region];
        }
        else {
            return regionIndex.defaultRegion;
        }
    };
    return Localizer;
}());

var UserAgent = /** @class */ (function () {
    function UserAgent() {
    }
    /**
     * Returns the Edge or IE browser version number.
     * Edge will be version 12 or greater.
     * IE will be version 11 or less.
     * If the browser is not Edge or IE -1 will be returned.
     */
    UserAgent.getEdgeOrIEVersion = function () {
        var ua = window.navigator.userAgent;
        var msie = ua.indexOf("MSIE ");
        if (msie > 0) {
            // IE 10 or older
            return parseInt(ua.substring(msie + 5, ua.indexOf(".", msie)), 10);
        }
        var trident = ua.indexOf("Trident/");
        if (trident > 0) {
            // IE 11
            var rv = ua.indexOf("rv:");
            return parseInt(ua.substring(rv + 3, ua.indexOf(".", rv)), 10);
        }
        var edge = ua.indexOf("Edge/");
        if (edge > 0) {
            // Edge (IE 12+)
            return parseInt(ua.substring(edge + 5, ua.indexOf(".", edge)), 10);
        }
        // other browser
        return -1;
    };
    /**
     * Detects if the browser is IE or Edge.
     */
    UserAgent.isEdgeOrIE = function () {
        var version = this.getEdgeOrIEVersion();
        return version !== -1;
    };
    /**
     * Detects if the browser is IE but not Edge.
     */
    UserAgent.isIE = function () {
        var version = this.getEdgeOrIEVersion();
        return version !== -1 && version <= 11;
    };
    return UserAgent;
}());

var version$3 = "3.6.1";

/**
 * A helper class that provides methods for getting various forms of the map controls current version.
 */
var Version$1 = /** @class */ (function () {
    function Version() {
    }
    /**
     * Returns the full version string for the map control.
     * For example, `"1.3.5"`.
     */
    Version.getFullVersion = function () {
        return version$3;
    };
    /**
     * Returns the endpoint compatible version string for the map control.
     * For example, `"1.3.5"` becomes `"1.3"`.
     */
    Version.getEndpointVersion = function () {
        // Get the index of the second "."
        var index = version$3.indexOf(".");
        index = version$3.indexOf(".", index + 1);
        // If the index of the second "." can't be found just return the whole version string.
        if (index === -1) {
            return version$3;
        }
        return version$3.substring(0, index);
    };
    return Version;
}());

var __extends$1m = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read$g = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$b = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * An enumeration used to specify the type of authentication mechanism to use.
 */
var AuthenticationType;
(function (AuthenticationType) {
    /**
     * The subscription key authentication mechanism.
     * Literal value `"subscriptionKey"`
     */
    AuthenticationType["subscriptionKey"] = "subscriptionKey";
    /**
     * The AAD implicit grant mechanism. Recommended for pages protected by a sign-in.
     * By default the page will be redirected to the AAD login when the map control initializes.
     * Specify a logged-in `PublicClientApplication` in the `AuthenticationOptions`
     * for greater control over when/how the users signs in.
     * Literal value `"aad"`
     */
    AuthenticationType["aad"] = "aad";
    /**
     * The anonymous authentication mechanism. Recommended for public pages.
     * Allows a callback responsible for acquiring an authentication token to be provided.
     * Literal value `"anonymous"`
     */
    AuthenticationType["anonymous"] = "anonymous";
    /**
     * The shared access signature authentication mechanism. Allows a callback responsible for acquiring a token to be provided on requests.
     * Literal value `"sas"`.
     */
    AuthenticationType["sas"] = "sas";
})(AuthenticationType || (AuthenticationType = {}));
/**
 * Options for specifying how the map control should authenticate with the Azure Maps services.
 */
var AuthenticationOptions = /** @class */ (function (_super) {
    __extends$1m(AuthenticationOptions, _super);
    function AuthenticationOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The authentication mechanism to be used.
         */
        _this.authType = undefined;
        /**
         * Subscription key from your Azure Maps account.
         * Must be specified for subscription key authentication type.
         */
        _this.subscriptionKey = undefined;
        /**
         * The Azure Maps client ID, This is an unique identifier used to identify the maps account.
         * Preferred to always be specified, but must be specified for AAD and anonymous authentication types.
         */
        _this.clientId = undefined;
        /**
         * The Azure AD registered app ID. This is the app ID of an app registered in your Azure AD tenant.
         * Must be specified for AAD authentication type.
         */
        _this.aadAppId = undefined;
        /**
         * The AAD tenant that owns the registered app specified by `aadAppId`.
         * Must be specified for AAD authentication type.
         */
        _this.aadTenant = undefined;
        /**
         * The AAD instance to use for logging in.
         * Can be optionally specified when using the AAD authentication type.
         * By default the `https://login.microsoftonline.com/` instance will be used.
         */
        _this.aadInstance = undefined;
        /**
         * A callback to use with the anonymous/sas authentication mechanism.
         * This callback will be responsible for resolving to a authentication token.
         * E.g. fetching a CORS protected token from an endpoint.
         */
        _this.getToken = undefined;
        /**
         * Optionally provide an initial token for sas authentication.
         */
        _this.sasToken = undefined;
        /**
         * Optionally provide an existing `PublicClientApplication` from the MSAL.js library.
         * This authentication context will be used to acquire the AAD token.
         * Only used with the AAD authentication type.
         * This auth context must be configured to use the same AAD app ID as `this.aadAppId`.
         * If this is not provided all map instances will share their own private auth context.
         */
        _this.authContext = undefined;
        return _this;
    }
    /**
     * Sets the required options to configure the subscription key authentication mechanism.
     * @param subscriptionKey Subscription Key from your azure maps account
     */
    AuthenticationOptions.prototype.setSubscriptionKey = function (key) {
        this.authType = AuthenticationType.subscriptionKey;
        this.subscriptionKey = key;
    };
    /**
     * Sets the required authentication options to configure the AAD implicit grant mechanism.
     * @param clientId Client ID from your azure maps account
     * @param aadAppId Azure AD App ID
     * @param aadTenant Azure AD Tenant Name
     * @param aadInstance An optional Azure AD Instance
     * @param authContext An optional `PublicClientApplication` from the MSAL.js library
     */
    AuthenticationOptions.prototype.setAadProperties = function (clientId, aadAppId, aadTenant, aadInstance, authContext) {
        this.authType = AuthenticationType.aad;
        this.authContext = authContext || this.authContext;
        this.aadInstance = aadInstance || this.aadInstance;
        this.clientId = clientId;
        this.aadAppId = aadAppId;
        this.aadTenant = aadTenant;
    };
    /**
     * Sets the required options to configure the anonymous authentication method.
     * @param getTokenCallback Callback function responsible for resolving to an authentication token.
     */
    AuthenticationOptions.prototype.setTokenCallbackFunction = function (getTokenCallback) {
        this.authType = AuthenticationType.anonymous;
        this.getToken = getTokenCallback;
    };
    /**
     * Sets the required options to configure the sas authentication method.
     * @param getTokenCallback Callback function responsible for resolving to an authentication token.
     */
    AuthenticationOptions.prototype.setSasCallbackFunction = function (getTokenCallback) {
        this.authType = AuthenticationType.sas;
        this.getToken = getTokenCallback;
    };
    /**
     * Override the standard merge behavior to handle mutually exclusive options.
     * @internal
     */
    AuthenticationOptions.prototype.merge = function () {
        var valueList = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            valueList[_i] = arguments[_i];
        }
        var merged = _super.prototype.merge.apply(this, __spreadArray$b([], __read$g(valueList), false));
        if (merged.authType === AuthenticationType.subscriptionKey) {
            merged.authContext = merged.aadAppId = merged.getToken = undefined;
        }
        else if (merged.authType === AuthenticationType.aad) {
            merged.subscriptionKey = merged.getToken = undefined;
        }
        else if (merged.authType === AuthenticationType.anonymous) {
            merged.subscriptionKey = merged.authContext = merged.aadAppId = undefined;
        }
        else if (merged.authType === AuthenticationType.sas) {
            merged.authContext = merged.subscriptionKey = merged.aadAppId = undefined;
        }
        return merged;
    };
    return AuthenticationOptions;
}(Options));

var supported = isSupported$1;

/**
 * Test whether the current browser supports Mapbox GL JS
 * @param {Object} options
 * @param {boolean} [options.failIfMajorPerformanceCaveat=false] Return `false`
 *   if the performance of Mapbox GL JS would be dramatically worse than
 *   expected (i.e. a software renderer is would be used)
 * @return {boolean}
 */
function isSupported$1(options) {
    return !notSupportedReason(options);
}

function notSupportedReason(options) {
    if (!isBrowser()) return 'not a browser';
    if (!isArraySupported()) return 'insufficent Array support';
    if (!isFunctionSupported()) return 'insufficient Function support';
    if (!isObjectSupported()) return 'insufficient Object support';
    if (!isJSONSupported()) return 'insufficient JSON support';
    if (!isWorkerSupported()) return 'insufficient worker support';
    if (!isUint8ClampedArraySupported()) return 'insufficient Uint8ClampedArray support';
    if (!isArrayBufferSupported()) return 'insufficient ArrayBuffer support';
    if (!isCanvasGetImageDataSupported()) return 'insufficient Canvas/getImageData support';
    if (!isWebGLSupportedCached(options && options.failIfMajorPerformanceCaveat)) return 'insufficient WebGL support';
    if (!isNotIE()) return 'insufficient ECMAScript 6 support';
}

function isBrowser() {
    return typeof window !== 'undefined' && typeof document !== 'undefined';
}

function isArraySupported() {
    return (
        Array.prototype &&
        Array.prototype.every &&
        Array.prototype.filter &&
        Array.prototype.forEach &&
        Array.prototype.indexOf &&
        Array.prototype.lastIndexOf &&
        Array.prototype.map &&
        Array.prototype.some &&
        Array.prototype.reduce &&
        Array.prototype.reduceRight &&
        Array.isArray
    );
}

function isFunctionSupported() {
    return Function.prototype && Function.prototype.bind;
}

function isObjectSupported() {
    return (
        Object.keys &&
        Object.create &&
        Object.getPrototypeOf &&
        Object.getOwnPropertyNames &&
        Object.isSealed &&
        Object.isFrozen &&
        Object.isExtensible &&
        Object.getOwnPropertyDescriptor &&
        Object.defineProperty &&
        Object.defineProperties &&
        Object.seal &&
        Object.freeze &&
        Object.preventExtensions
    );
}

function isJSONSupported() {
    return 'JSON' in window && 'parse' in JSON && 'stringify' in JSON;
}

function isWorkerSupported() {
    if (!('Worker' in window && 'Blob' in window && 'URL' in window)) {
        return false;
    }

    var blob = new Blob([''], { type: 'text/javascript' });
    var workerURL = URL.createObjectURL(blob);
    var supported;
    var worker;

    try {
        worker = new Worker(workerURL);
        supported = true;
    } catch (e) {
        supported = false;
    }

    if (worker) {
        worker.terminate();
    }
    URL.revokeObjectURL(workerURL);

    return supported;
}

// IE11 only supports `Uint8ClampedArray` as of version
// [KB2929437](https://support.microsoft.com/en-us/kb/2929437)
function isUint8ClampedArraySupported() {
    return 'Uint8ClampedArray' in window;
}

// https://github.com/mapbox/mapbox-gl-supported/issues/19
function isArrayBufferSupported() {
    return ArrayBuffer.isView;
}

// Some browsers or browser extensions block access to canvas data to prevent fingerprinting.
// Mapbox GL uses this API to load sprites and images in general.
function isCanvasGetImageDataSupported() {
    var canvas = document.createElement('canvas');
    canvas.width = canvas.height = 1;
    var context = canvas.getContext('2d');
    if (!context) {
        return false;
    }
    var imageData = context.getImageData(0, 0, 1, 1);
    return imageData && imageData.width === canvas.width;
}

var isWebGLSupportedCache = {};
function isWebGLSupportedCached(failIfMajorPerformanceCaveat) {

    if (isWebGLSupportedCache[failIfMajorPerformanceCaveat] === undefined) {
        isWebGLSupportedCache[failIfMajorPerformanceCaveat] = isWebGLSupported(failIfMajorPerformanceCaveat);
    }

    return isWebGLSupportedCache[failIfMajorPerformanceCaveat];
}

isSupported$1.webGLContextAttributes = {
    antialias: false,
    alpha: true,
    stencil: true,
    depth: true
};

function getWebGLContext(failIfMajorPerformanceCaveat) {
    var canvas = document.createElement('canvas');

    var attributes = Object.create(isSupported$1.webGLContextAttributes);
    attributes.failIfMajorPerformanceCaveat = failIfMajorPerformanceCaveat;

    return (
        canvas.getContext('webgl', attributes) ||
        canvas.getContext('experimental-webgl', attributes)
    );
}

function isWebGLSupported(failIfMajorPerformanceCaveat) {
    var gl = getWebGLContext(failIfMajorPerformanceCaveat);
    if (!gl) {
        return false;
    }

    // Try compiling a shader and get its compile status. Some browsers like Brave block this API
    // to prevent fingerprinting. Unfortunately, this also means that Mapbox GL won't work.
    var shader;
    try {
        shader = gl.createShader(gl.VERTEX_SHADER);
    } catch (e) {
        // some older browsers throw an exception that `createShader` is not defined
        // so handle this separately from the case where browsers block `createShader`
        // for security reasons
        return false;
    }

    if (!shader || gl.isContextLost()) {
        return false;
    }
    gl.shaderSource(shader, 'void main() {}');
    gl.compileShader(shader);
    return gl.getShaderParameter(shader, gl.COMPILE_STATUS) === true;
}

function isNotIE() {
    return !document.documentMode;
}

var defaultView;
var defaultLanguage = "NGT";
var defaultSessionId = uuid();
var defaultDomain = env.domain;
var defaultStaticAssetsDomain = env.staticAssetsDomain;
var defaultStyleDefinitionsPath = env.stylePath;
var defaultStyleDefinitionsVersion = env.styleDefinitionsVersion;
var defaultStyleAPIVersion = constants.styleApiVersion;
var defaultAuthOptions = new AuthenticationOptions();
var hasSetView = false;
var hasSetDomain = false;
var hasSetStyleDefinitionsPath = false;
var hasSetStyleDefinitionsVersion = false;
var hasWorkerCount = false;
var hasMaxParallelImageRequests = false;
var hasSetLanguage = false;
var hasSetSessionId = false;
var hasSetAuthenticationOptions = false;
/**
 * Gets the default authentication options that were provided.
 * If not previously set all properties will be undefined.
 */
function getAuthenticationOptions() {
    return Object.assign({}, defaultAuthOptions);
}
/**
 * Getrs the defawult static assets domain.
 * @internal
 */
function getStaticAssetsDomain() {
    return defaultStaticAssetsDomain;
}
/**
 * Gets the default domain that was provided.
 * If not previously set the default value is `"atlas.microsoft.com"`.
 */
function getDomain() {
    return defaultDomain;
}
/**
 * Gets the default styleDefinitionsPath that was provided.
 * @internal
 */
function getStyleDefinitionsPath() {
    return defaultStyleDefinitionsPath;
}
/**
 * Gets the default styleDefinitionsVersion that was provided.
 * @internal
 */
function getStyleDefinitionsVersion() {
    return defaultStyleDefinitionsVersion;
}
/**
 * Gets the default styleAPI version that was provided
 * @internal
 */
function getStyleAPIVersion() {
    return defaultStyleAPIVersion;
}
/**
 * Gets the worker count that will get created.
 */
function getWorkerCount() {
    return maplibregl.getWorkerCount();
}
/**
 * Gets the Maximum number of images (raster tiles, sprites, icons) to load in parallel
 */
function getMaxParallelImageRequests() {
    return maplibregl.getMaxParallelImageRequests();
}
/**
 * Gets the default language that was provided.
 * If not previously set the default value is `"NGT"`.
 */
function getLanguage() {
    return defaultLanguage;
}
/**
 * Gets the default session id that was provided.
 * If not previously set the default value is a random UUID.
 */
function getSessionId() {
    return defaultSessionId;
}
/**
 * Gets the default Azure Maps subscription key that was provided.
 */
function getSubscriptionKey() {
    return defaultAuthOptions.authType === AuthenticationType.subscriptionKey ?
        defaultAuthOptions.subscriptionKey : undefined;
}
/**
 * @deprecated use atlas.getView() instead
 */
function getUserRegion() {
    return defaultView;
}
/**
 * Gets the default view setting of the map control.
 * If not previously set the default value is `undefined`.
 */
function getView() {
    return defaultView;
}
/**
 * Current API version number based on build number.
 */
function getVersion() {
    return Version$1.getFullVersion();
}
/**
 * Checks to see if the user's browser is supported by the map control.
 * @param failIfMajorPerformanceCaveat If true the function will return false
 * if the performance of the map control would be dramatically worse than expected
 * (e.g. a software WebGL renderer would be used).
 */
function isSupported(failIfMajorPerformanceCaveat) {
    var result;
    // Always return false for IE since we don't support it ourselves.
    result = !UserAgent.isIE();
    // When withInsights is false (bing script), Skip the check from mapbox-gl-supported in favor of script size.
    // "result && withInsights" will not shake things away (tree shaking quirks)
    if (result) {
        result = supported({
            failIfMajorPerformanceCaveat: failIfMajorPerformanceCaveat
        }) && document.createElement("canvas").getContext("webgl2") !== null;
    }
    return result;
}
/**
 * Sets your authentication options as the default options in the atlas namespace
 * which is used by the map control and any modules that make requests to the Azure maps services.
 * If a Map is initialized with the authentication options explicitly defined and
 * setAuthenticationOptions hasn't previously been called it will automatically be called by the Map constructor.
 * @param options The new default authentication options.
 */
function setAuthenticationOptions(options) {
    defaultAuthOptions = new AuthenticationOptions().merge(defaultAuthOptions, options);
    hasSetAuthenticationOptions = true;
}
/**
 * Sets the default domain used by the map and service modules unless the
 * domain is explicitly specified when using those parts of the API.
 * If a Map is initialized with the domain explicitly defined and
 * setDomain hasn't previously been called it will automatically be called by the Map constructor.
 * If the protocol is not specified `https` is assumed.
 * @param domain The new default domain.
 */
function setDomain(domain) {
    defaultDomain = domain;
    hasSetDomain = true;
}
/**
 * Sets the default styleDefinitionsPath to use for getting the map styles.
 * If a Map is initialized with the styleDefinitionsPath explicitly defined and
 * setStyleDefinitionsPath hasn't previously been called it will automatically be called by the Map constructor.
 * @param styleDefinitionsPath The new default styleDefinitionsPath.
 * @internal
 */
function setStyleDefinitionsPath(styleDefinitionsPath) {
    defaultStyleDefinitionsPath = styleDefinitionsPath;
    hasSetStyleDefinitionsPath = true;
}
/**
 * Sets the default styleDefinitionsVersion to use when requesting style definitions
 * from styleDefinitionsPath.  If a map is initialized with the with the styleDefinitionsVersion
 * explicitly defined and setStyleDefinitionsVersion hasn't previously been called it will be
 * automatically called by the Map constructor.
 * @param styleDefinitionsVersion
 */
function setStyleDefinitionsVersion(styleDefinitionsVersion) {
    defaultStyleDefinitionsVersion = styleDefinitionsVersion;
    hasSetStyleDefinitionsVersion = true;
}
function setStyleAPIVersion(styleAPIVersion) {
    defaultStyleAPIVersion = styleAPIVersion;
}
/**
 * Sets number of web workers instantiated on a page.
 * By default, it is set to half the number of CPU cores (capped at 6).
 * @param workerCount worker count.
 */
function setWorkerCount(workerCount) {
    if (workerCount > 0) {
        maplibregl.setWorkerCount(workerCount);
        hasWorkerCount = true;
    }
}
/**
 * Sets Maximum number of images (raster tiles, sprites, icons) to load in parallel,
 * which affects performance in raster-heavy maps. 16 by default.
 * @param maxParallelImageRequests Maximum number of images to load in parallel.
 */
function setMaxParallelImageRequests(maxParallelImageRequests) {
    if (maxParallelImageRequests > 0) {
        maplibregl.setMaxParallelImageRequests(maxParallelImageRequests);
        hasMaxParallelImageRequests = true;
    }
}
/**
 * Sets the default language used by the map and service modules unless the
 * language is explicitly specified when using those parts of the API.
 * If a Map is initialized with the language explicitly defined and
 * setLanguage hasn't previously been called it will automatically be called by the Map constructor.
 * @param language The new default language. If set to "auto", the browser's configured language will be used.
 */
function setLanguage(language) {
    defaultLanguage = Localizer.getCode(language);
    hasSetLanguage = true;
}
/**
 * Sets the default session id used by the map and service modules unless the
 * session id is explicitly specified when using those parts of the API.
 * If a Map is initialized with the session ID explicitly defined and
 * setSessionId hasn't previously been called it will automatically be called by the Map constructor.
 * @param id The new default session id.
 */
function setSessionId(id) {
    defaultSessionId = id;
    hasSetSessionId = true;
}
/**
 * Sets your Azure Maps subscription key as the default subscription key in the atlas namespace
 * which is used by the map control and any modules that make requests to the Azure maps services.
 * If a Map is initialized with the subscription key explicitly defined and
 * setSubscriptionKey hasn't previously been called it will automatically be called by the Map constructor.
 * @param key The new default subscription key.
 */
function setSubscriptionKey(key) {
    defaultAuthOptions.setSubscriptionKey(key);
    hasSetAuthenticationOptions = true;
}
/**
 * @deprecated use atlas.setView(view: string) instead.
 */
function setUserRegion(userRegion) {
    defaultView = userRegion;
    hasSetView = true;
}
/**
 * Specifies which set of geopolitically disputed borders and labels are displayed on the map. The View parameter (also referred to as “user region parameter”) is a 2-letter ISO-3166 Country Code that will show the correct maps for that country/region. Country/Regions that are not on the View list or if unspecified will default to the “Unified” View.
 * Please see the supported [Views]{@link https://aka.ms/AzureMapsLocalizationViews }.
 * It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter in Azure Maps must be used in compliance with applicable laws, including those regarding mapping, of the country/region where maps, images and other data and third party content that You are authorized to access via Azure Maps is made available.
 * @param view The new default view
 */
function setView(view) {
    defaultView = view;
    hasSetView = true;
}
/**
 * Adds an image template to the atlas namespace.
 * @param templateName The name of the template.
 * @param template The SVG template to add. Supports {color}, {secondaryColor}, {scale}, {text}.
 * @param override Specifies if it should override existing templates if one with the same name already exists.
 */
function addImageTemplate(templateName, template, override) {
    if (override || !imageTemplates[templateName.toLowerCase()]) {
        imageTemplates[templateName.toLowerCase()] = template;
    }
}
/**
 * Retrieves an SVG template by name.
 * @param templateName The name of the template to retrieve.
 * @param scale Specifies how much to scale the template. For best results, scale the icon to the maximum size you want to display it on the map, then use the symbol layers icon size option to scale down if needed. This will reduce blurriness due to scaling. Default: 1
 */
function getImageTemplate(templateName, scale) {
    scale = Math.abs(scale || 1);
    if (typeof templateName === "string" && imageTemplates[templateName.toLowerCase()]) {
        var template = imageTemplates[templateName.toLowerCase()];
        // Firefox/Edge don't support calc for inline SVG's. Need to manually calculate this.
        var pattern = /calc\(([0-9.]+)[px]*\s*\*\s*\{scale\}\)/gi;
        var t = template;
        var match = pattern.exec(template);
        while (match) {
            t = t.replace(match[0], parseFloat(match[1]) * scale + "");
            match = pattern.exec(template);
        }
        // Just for good measure incase the pattern doesn't match.
        t = t.replace("{scale}", scale + "");
        return t;
    }
    else {
        throw new Error("Invalid templateName.");
    }
}
/**
 * Retrieves an array of names for all image templates that are available in the atlas namespace.
 */
function getAllImageTemplateNames() {
    return Object.keys(imageTemplates);
}
/**
 * Initializes resources like WebWorkers that can be shared across maps to lower load
 * times in some situations. `atlas.setWorkerCount`, if being
 * used, must be set before `prewarm()` is called to have an effect.
 *
 * By default, the lifecycle of these resources is managed automatically, and they are
 * lazily initialized when a Map is first created. By invoking `prewarm()`, these
 * resources will be created ahead of time, and will not be cleared when the last Map
 * is removed from the page. This allows them to be re-used by new Map instances that
 * are created later. They can be manually cleared by calling
 * `atlas.clearPrewarmedResources()`. This is only necessary if your web page remains
 * active but stops using maps altogether.
 *
 * This is primarily useful when using GL-JS maps in a single page app, wherein a user
 * would navigate between various views that can cause Map instances to constantly be
 * created and destroyed.
 */
function prewarm() {
    maplibregl.prewarm();
}
/**
 * Clears up resources that have previously been created by `atlas.prewarm()`.
 * Note that this is typically not necessary. You should only call this function
 * if you expect the user of your app to not return to a Map view at any point
 * in your application.
 */
function clearPrewarmedResources() {
    maplibregl.clearPrewarmedResources();
}
/**
 * Adds a custom load resource function that will be called when using a URL that starts with a custom url schema.
 * @param customProtocol - the protocol to hook, for example 'custom'
 * @param loadFn - the function to use when trying to fetch a tile specified by the customProtocol
 */
function addProtocol(customProtocol, loadFn) {
    maplibregl.addProtocol(customProtocol, loadFn);
}
/**
 * Removes a previously added protocol in the main thread.
 * @param customProtocol - the custom protocol to remove registration for
 */
function removeProtocol(customProtocol) {
    maplibregl.removeProtocol(customProtocol);
}
/**
 * Returns if authentication options are set.
 * @internal
 */
function _hasSetAuthenticationOptions() {
    return hasSetAuthenticationOptions;
}
/**
 * Returns if the default domain has been set yet.
 * @internal
 */
function _hasSetDomain() {
    return hasSetDomain;
}
/**
 * Returns if the default StyleDefinitionsPath has been set yet.
 * @internal
 */
function _hasSetStyleDefinitionsPath() {
    return hasSetStyleDefinitionsPath;
}
/**
 * Returns if the default StyleDefinitionsVersion has been set yet.
 * @internal
 */
function _hasSetStyleDefinitionsVersion() {
    return hasSetStyleDefinitionsVersion;
}
/**
 * Returns if the default workerCount has been set yet.
 * @internal
 */
function _hasWorkerCount() {
    return hasWorkerCount;
}
/**
 * Returns if the default MaxParallelImageRequests has been set yet.
 * @internal
 */
function _hasMaxParallelImageRequests() {
    return hasMaxParallelImageRequests;
}
/**
 * Returns is a default language has been set yet.
 * @internal
 */
function _hasSetLanguage() {
    return hasSetLanguage;
}
/**
 * Returns is a default session id has been set yet.
 * @internal
 */
function _hasSetSessionId() {
    return hasSetSessionId;
}
/**
 * Returns is a default language has been set yet.
 * @internal
 */
function _hasSetView() {
    return hasSetView;
}
/**
 * Gets the base domain used for asset retrieval.
 * @internal
 */
function _getAssetDomain() {
    return env.domain;
}
/**
 * Gets the base domain used for general map services.
 * @internal
 */
// TODO Remove once all internal dependencies of this function are gone.
function _getDomain() {
    return getDomain();
}
/**
 * Enable the map's RTL text plugin. Necessary for supporting the Arabic and Hebrew languages, which are written right-to-left.
 * @internal
 */
function _enableRTLTextPlugin() {
    var rtlPluginUrl = new Url({
        domain: env.staticAssetsDomain,
        path: "sdk/javascript/mapcontrol/".concat(Version$1.getEndpointVersion(), "/mapbox-gl-rtl-text.min.js")
    });
    maplibregl.setRTLTextPlugin(rtlPluginUrl.toString(), true).catch(function (error) {
        if (error) {
            console.warn(error);
        }
    });
}
var imageTemplates = {
    /**********************
     * Marker templates
     **********************/
    // Default built in marker. Supports {color} and {secondaryColor}
    "marker": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 26 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:1"/><text x="12.5" y="17.5" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "marker-thick": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 27 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:2"/><text x="12.5" y="18.5" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "marker-circle": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(39 * {scale})" viewBox="-1 -1 27 38"><path d="M12.25.25a12.254 12.254 0 0 0-12 12.494c0 6.444 6.488 12.109 11.059 22.564.549 1.256 1.333 1.256 1.882 0C17.762 24.853 24.25 19.186 24.25 12.744A12.254 12.254 0 0 0 12.25.25Z" style="fill:{color};stroke:{secondaryColor};stroke-width:1"/><circle cx="12.5" cy="12.5" r="9" fill="{secondaryColor}"/><text x="12" y="17.5" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',
    // Older pin style. (consider removing, although we could look at removing these icons from sprite and wrapping event that fires when missing icon is needed.)
    "pin": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(24 * {scale})" height="calc(28 * {scale})" viewBox="0 0 24 28"><path d="m11.988 16.615a5.15 5.15 0 0 1-2.268-.525 4.909 4.909 0 0 1-2.805-4.442 5.019 5.019 0 0 1 5.072-4.936h.012a5.03 5.03 0 0 1 5.085 4.961 4.907 4.907 0 0 1-.549 2.224 5.114 5.114 0 0 1-4.548 2.718zm0-8.06a3.173 3.173 0 0 0-3.226 3.099 3.081 3.081 0 0 0 1.77 2.782 3.299 3.299 0 0 0 4.365-1.386 3.049 3.049 0 0 0 .342-1.381 3.184 3.184 0 0 0-3.239-3.114h-.012z" fill="{secondaryColor}"/><path d="m11.999.922a10.908 10.908 0 0 0-11.076 10.732 10.639 10.639 0 0 0 4.418 8.598l6.658 6.464 6.658-6.463a10.537 10.537 0 0 0 2.198-15.041 11.182 11.182 0 0 0-8.856-4.289zm1.873 14.341a4.221 4.221 0 0 1-5.589-1.789 3.945 3.945 0 0 1-.445-1.8 4.164 4.164 0 0 1 8.323-.037 4.028 4.028 0 0 1-2.289 3.626Z" fill="{color}"/><path d="m11.999 28-7.256-7.044a11.611 11.611 0 0 1-4.743-9.303 11.844 11.844 0 0 1 11.988-11.652.102 .102 0 0 1 .02 0 12.164 12.164 0 0 1 9.577 4.647 11.357 11.357 0 0 1 2.299 8.614 11.521 11.521 0 0 1-4.63 7.695zm-.01-26.157a9.997 9.997 0 0 0-10.143 9.812 9.769 9.769 0 0 0 4.04 7.853l.099.083 6.014 5.838 6.113-5.922a9.7 9.7 0 0 0 3.945-6.505 9.533 9.533 0 0 0-1.933-7.229 10.305 10.305 0 0 0-8.116-3.931h-.021zm.021 14.772a5.11 5.11 0 0 1-4.547-2.718 4.868 4.868 0 0 1 .932-5.743 5.118 5.118 0 0 1 3.58-1.46h.024a5.031 5.031 0 0 1 5.084 4.938 4.92 4.92 0 0 1-2.805 4.457h0a5.152 5.152 0 0 1-2.269.525zm-.011-8.079h-.015a3.277 3.277 0 0 0-2.295.933 3.029 3.029 0 0 0-.587 3.58 3.297 3.297 0 0 0 4.364 1.386h0a3.092 3.092 0 0 0 1.772-2.795 3.185 3.185 0 0 0-3.239-3.105z" fill="{secondaryColor}"/><text x="12" y="17" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',
    // Older pin-round style. (consider removing, although we could look at removing these icons from sprite and wrapping event that fires when missing icon is needed.)
    "pin-round": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(25 * {scale})" height="calc(25 * {scale})" viewBox="0 0 25 25"><g transform="translate(0 1)"><circle cx="12.25" cy="11.5833" r="11" fill="{color}"/><path d="m12.25 23.583a12 12 0 1 1 12-12 12 12 0 0 1-12 12zm0-22a10 10 0 1 0 10 10 10 10 0 0 0-10-10z" fill="{secondaryColor}"/><circle cx="12.25" cy="11.5833" r="4.2386" fill="{secondaryColor}"/></g><text x="12.5" y="17" style="font-size:14px;fill:#000;text-anchor:middle">{text}</text></svg>',
    "marker-flat": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(42.8 * {scale})"  viewBox="0 0 1600 2570"><g fill="{color}"><path d="M691 2419c-409-575-641-1086-683-1504-10-106-10-136 5-224 31-188 105-330 241-458 129-124 270-190 453-214 69-9 113-10 182-1 373 46 655 326 703 698 40 308-120 801-424 1309-134 224-348 535-369 535-4 0-53-63-108-141z"/></g><g fill="rgba(0,0,0,0.15)" style="transform:scale(-1,1);transform-origin:center"><path d="M691 2419c-407-571-639-1083-682-1498-14-139-3-249 37-371 69-208 254-402 459-481 68-27 217-59 271-59h24v160 180 940 635c0 349-2 635-5 635-2 0-49-63-104-141z"/></g><circle cx="800" cy="800" r="600" fill="{secondaryColor}"/><text x="800" y="1100" style="font-size:800px;fill:#000;text-anchor:middle">{text}</text></svg>',
    "marker-arrow": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(25.47 * {scale})" height="calc(35.18 * {scale})" viewBox="0 0 4330 5980"><g fill="{color}"><path d="m2080 5969c-49-20-93-63-115-113-25-55-1928-5486-1953-5573-40-138 67-282 210-283 36 0 246 73 987 345 518 190 947 345 955 345 8 0 438-155 955-345 615-226 954-345 979-345 87 0 165 47 204 123 46 91 107-95-957 2942-537 1535-986 2805-997 2823-11 18-43 46-72 62-41 24-62 30-111 29-33 0-71-5-85-10z"/></g><g fill="{secondaryColor}"><path d="m2200 1600c-36 10-83 2-484-84-243-53-451-94-461-91-11 4-22 18-25 31-5 19 114 371 436 1292 244 697 448 1273 454 1281 19 24 50 30 71 12z"/><path d="m2200 1600c-36 10-83 2-484-84-243-53-451-94-461-91-11 4-22 18-25 31-5 19 114 371 436 1292 244 697 448 1273 454 1281 19 24 50 30 71 12z" style="transform:scale(-1,1);transform-origin:center"/></g><g fill="rgba(0,0,0,0.2)" ><path d="m2165 685c8 0 438-155 955-345 615-226 954-345 979-345 87 0 165 47 204 123 46 91 107-95-957 2942-537 1535-986 2805-997 2823-11 18-43 46-72 62-41 24-62 30-111 29z"/></g><text x="2165" y="3300" style="font-size:2500px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "marker-ball-pin": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(15.67 * {scale})" height="calc(33.33 * {scale})" viewBox="0 0 235 452"><g transform="translate(-135 10)"><path fill="{secondaryColor}" d="m256 442 0 0c-13 0-18-11-18-24l-6-323c0-13 11-24 24-24h0c13 0 24 11 24 24l-6 323c0 13-5 24-18 24z"/><circle style="fill:{color};stroke-width:10;stroke:{secondaryColor}" cx="256" cy="112" r="111"/><ellipse transform="matrix(0.834 0.5518 -0.5518 0.834 65.7916 -97.18)" fill="rgba(255,255,255,0.3)" cx="194.399" cy="60.749" rx="19.076" ry="32.428"/></g><text x="117.5" y="160" style="font-size:160px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "marker-square": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(26.67 * {scale})" height="calc(32.27 * {scale})" viewBox="0 0 2000 2420"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="M845 2152c-22-37-58-95-80-129-22-35-62-99-90-143l-50-80-312 0-313 0 0-900 0-900 900 0 900 0 0 900 0 900-313 0-313 0-34 58c-19 31-38 59-42 60-5 2-8 8-8 12 0 9-69 123-88 145-5 6-11 15-13 21-16 39-77 123-89 124-8 0-33-31-55-68z"/></g><text x="1000" y="1300" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "marker-square-cluster": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(33.33 * {scale})" height="calc(38.8 * {scale})" viewBox="0 0 2500 2910"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="m866 2652c-17-31-37-68-46-82-9-14-32-54-51-90-19-36-50-92-70-125l-36-60-332-3-331-2 0-905 0-905 660 0 660 0 0-38c0-71 50-196 102-258 71-85 189-164 244-164 12 0 26-4 29-10 8-13 222-13 230 0 3 6 17 10 30 10 25 0 117 45 154 76 130 107 191 232 191 392 0 155-63 284-190 386-36 29-129 76-150 76-11 0-22 5-25 10-3 6-31 10-61 10l-54 0 0 660 0 660-332 2-332 3-29 50c-17 28-48 84-70 125-22 41-47 86-56 100-9 14-30 51-46 83-17 32-36 57-45 57-8 0-28-25-44-58z"/></g><text x="1650" y="900" style="font-size:1000px;fill:#fff">+</text><text x="1000" y="1800" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "marker-square-rounded": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(26.8 * {scale})" height="calc(32.27 * {scale})" viewBox="0 0 2010 2410"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="M856 2155c-20-30-36-59-36-65 0-5-4-10-10-10-5 0-10-5-10-11 0-5-18-37-40-69-22-32-40-64-40-69 0-6-4-11-10-11-5 0-10-5-10-10 0-6-15-33-32-60l-33-50-127 0c-74 0-129-4-133-10-3-5-17-10-30-10-25 0-116-45-155-76-87-69-142-151-178-265-15-46-17-1075-2-1084 5-3 10-17 10-30 0-13 5-27 10-30 6-3 10-13 10-22 0-22 83-135 122-168 57-46 62-50 112-75l50-25 585 0 586 0 63 34c84 46 169 133 212 218l35 68 0 565 0 565-28 59c-32 69-100 157-139 180-15 9-33 22-40 29-23 22-99 57-123 57-13 0-27 5-30 10-4 6-60 10-135 10l-128 0-128 205c-84 136-133 205-144 205-10 0-33-24-54-55z"/></g><text x="1000" y="1300" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "marker-square-rounded-cluster": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(33.33 * {scale})" height="calc(32.13 * {scale})" viewBox="0 0 2500 2900"><g transform="translate(100 100)" style="stroke:{secondaryColor};stroke-width:100;fill:{color}"><path d="m874 2669c-9-18-26-49-37-68-11-20-30-55-43-78-13-24-36-64-51-90-14-27-38-69-52-95l-26-48-142 0c-84 0-144-4-148-10-3-5-17-10-30-10-25 0-118-46-154-76-91-76-136-142-175-254-13-38-16-119-16-554 0-358 3-520 12-545 40-125 106-219 195-278 127-84 116-83 646-83l467 0 0-42c0-46 11-87 45-163 54-121 169-220 306-264 46-14 232-14 278 0 165 53 284 175 340 350 19 61 14 204-10 273-32 91-94 178-169 240-38 31-130 76-155 76-13 0-27 5-30 10-3 6-28 10-56 10l-49 0 0 462c0 446-1 464-21 522-32 91-94 178-169 240-38 31-130 76-155 76-13 0-27 5-30 10-4 6-65 10-149 10-138 0-143 1-154 23-12 23-62 114-112 202-16 28-44 79-63 115-42 77-67 88-93 39z"/></g><text x="1650" y="900" style="font-size:1000px;fill:#fff">+</text><text x="1000" y="1800" style="font-size:1000px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "flag": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(23.5 * {scale})" height="calc(40 * {scale})" viewBox="34 28 198 308"><path style="stroke:{secondaryColor};stroke-width:15;stroke-linecap:round;" d="M42 327l0 -291"/><path style="fill:{color};stroke:{secondaryColor};stroke-width:10;stroke-linejoin:round;" d="M49 50c70 30 104 28 178 2-21 42-21 74 0 116-72 25-101 25-178 0l0-118z"/><text x="130" y="165" style="font-size:100px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "flag-triangle": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(27 * {scale})" height="calc(35.33 * {scale})" viewBox="0 0 40.5 53"><g transform="translate(-31 -20)"><path fill="{secondaryColor}" d="M34.7,73.3V48.4l34.6-10.1c0.7-0.2,1.2-0.8,1.2-1.5s-0.4-1.4-1-1.7L33.7,20.5c-0.5-0.2-1.1-0.2-1.6,0.2 c-0.5,0.3-0.7,0.8-0.7,1.4v51.2H34.7z"/><polygon points="34.7,24.5 66,36.5 34.7,45 34.7,10" fill="{color}"/></g><text x="11" y="21" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "rounded-square": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(34 * {scale})" height="calc(34 * {scale})" viewBox="0 0 34 34"><g transform="translate(2 2)"><rect x="0" y="0" rx="8" ry="8" width="30" height="30" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17" y="22" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "rounded-square-thick": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(38 * {scale})" height="calc(38 * {scale})" viewBox="0 0 38 38"><g transform="translate(4 4)"><rect x="0" y="0" rx="8" ry="8" width="30" height="30" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19" y="24" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "triangle": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(36 * {scale})" height="calc(36 * {scale})" viewBox="0 0 36 36"><g transform="translate(2 2)"><polygon points="16,0 32,32 0,32 16,0" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17.5" y="30" style="font-size:12px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "triangle-thick": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 40 40"><g transform="translate(4 4)"><polygon points="16,0 32,32 0,32 16,0" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19.5" y="32" style="font-size:12px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "hexagon": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(35 * {scale})" height="calc(40 * {scale})" viewBox="0 0 35 40"><g transform="translate(2 2)"><path d="M31 9 15.5 0 0 9 0 27 15.5 36 31 27 31 9Z" style="stroke:{secondaryColor};stroke-width:2;fill:{color}"/></g><text x="17.5" y="25" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "hexagon-thick": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(39 * {scale})" height="calc(44 * {scale})" viewBox="0 0 39 44"><g transform="translate(4 4)"><path d="M31 9 15.5 0 0 9 0 27 15.5 36 31 27 31 9Z" style="stroke:{secondaryColor};stroke-width:4;fill:{color}"/></g><text x="19.5" y="27" style="font-size:14px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "hexagon-rounded": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 1100 1100"><g transform="translate(50 50)"><path style="stroke:{secondaryColor};stroke-width:50;fill:{color}" d="M881 210 561 25c-33-19-88-19-121 0L119 210c-33 19-61 67-61 105v370c0 39 27 86 61 105l321 185c33 19 88 19 122 0l321-185c33-19 61-67 61-105V315C942 276 915 229 881 210z"/></g><text x="550" y="700" style="font-size:400px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "hexagon-rounded-thick": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 1200 1200"><g transform="translate(100 100)"><path style="stroke:{secondaryColor};stroke-width:100;fill:{color}" d="M881 210 561 25c-33-19-88-19-121 0L119 210c-33 19-61 67-61 105v370c0 39 27 86 61 105l321 185c33 19 88 19 122 0l321-185c33-19 61-67 61-105V315C942 276 915 229 881 210z"/></g><text x="600" y="750" style="font-size:400px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "triangle-arrow-up": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(28 * {scale})" viewBox="0 0 28 28"><g transform="translate(2 2)"><polygon points="12,0 0,24 12,17 24,24" stroke-width="2" stroke="{secondaryColor}" fill="{color}"/></g><text x="14" y="17" style="font-size:8px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "triangle-arrow-left": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(28 * {scale})" height="calc(28 * {scale})" viewBox="0 0 28 28"><g transform="translate(2 2)"><polygon points="24,12 0,0 7,12 0,24" stroke-width="2" stroke="{secondaryColor}" fill="{color}"/></g><text x="14" y="16.5" style="font-size:8px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    "arrow-up": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(12.16 * {scale})" height="calc(30.1 * {scale})" viewBox="0 0 902 364"><g fill="{color}" transform="matrix(0,2.4,-2.4,0,897,-930)"><polygon points="902,222 233,222 233,364 0,182 233,0 233,141 902,141 902,222"/></g><text x="450" y="700" style="font-size:900px;fill:#000;text-anchor:middle">{text}</text></svg>',
    "arrow-up-thin": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(33.33 * {scale})" viewBox="0 0 12 25"><g transform="translate(-136.91823 -751.91998)"><path fill="{color}" d="m148.271 760.71c-1.641-.547-3.186-1.47-4.633-2.769l0 18.07-1.675 0 0-18.07c-1.447 1.299-2.986 2.222-4.616 2.769l0-1.231c2.325-1.596 4.006-3.812 5.043-6.65l.838 0c1.037 2.838 2.718 5.055 5.043 6.65l0 1.231z"/></g><text x="6" y="20" style="font-size:10px;fill:#000;text-anchor:middle">{text}</text></svg>',
    "car": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(21.93 * {scale})" height="calc(40.9 * {scale})" viewBox="0 0 6580 12270"><g transform="translate(0 12270) rotate(-90)"><path fill="{secondaryColor}" d="M7045 6566c-42-13-105-44-105-51 0-2 23-105 50-228 28-123 50-230 50-236 0-8-241-11-907-11-855 0-1145 6-1513 30-85 6-189 13-230 15-41 3-133 10-205 15-286 21-430 32-705 50-953 63-1459 18-2335-205-304-77-746-209-799-238-131-72-221-408-285-1062-34-345-42-532-48-1130-16-1557 108-2532 336-2649 32-17 469-149 676-205 409-110 819-191 1205-238 116-14 224-18 540-18 395 1 494 5 1140 50 1124 79 1224 82 2496 78l641-3-53-237c-29-131-52-238-51-239 1-1 31-14 66-29 56-23 76-26 142-23 67 3 83 7 120 33 23 17 50 41 61 55 10 14 51 117 91 230l73 205 674 3 675 2 90-39c98-43 198-72 315-93 122-21 829-18 990 5 321 45 626 143 849 270 293 168 516 378 704 662 266 402 416 893 467 1527 15 174 8 882-9 998-6 41-18 127-27 190-69 502-253 969-523 1325-79 105-262 284-381 374-189 142-355 229-574 300-336 110-526 139-952 148-457 9-685-23-887-124l-47-24-678-6-678-6-64 179c-79 224-92 253-121 284-67 70-177 97-274 66zm-2752-5073c-23-2-64-2-90 0-26 2-7 3 42 3 50 0 71-1 48-3zm395 0c-21-2-55-2-75 0-21 2-4 4 37 4 41 0 58-2 38-4z"/><path fill="{color}" d="M7043 6498c-13-6-23-19-23-28 0-9 23-117 50-240 28-123 50-230 50-237 0-22-2126-13-2465 10-132 10-400 28-595 42-661 47-824 55-1160 62-435 7-656-8-1040-73-415-70-865-183-1447-365-168-53-272-556-325-1569-16-319-16-1311 0-1630 45-872 129-1366 257-1518 22-26 51-39 172-77 557-177 1122-310 1563-369 271-36 351-40 690-40 361 1 463 6 1165 54 1122 78 1288 83 2337 79 460-2 840-7 843-11 4-4-17-117-47-252l-55-245 39-16c76-30 180-8 224 47 10 13 54 124 98 246l79 222 709 0 709 0 47-24c74-37 219-83 322-101 122-22 606-32 802-16 374 29 658 102 933 238 124 62 271 155 361 230l61 51 6 100c19 278 103 497 247 643 88 89 173 136 278 152l70 11 41 131c116 369 159 673 168 1170 10 584-38 984-167 1397l-40 126-70 12c-193 33-348 175-441 405-56 139-89 302-89 445 0 43-3 47-58 91-290 235-644 384-1068 450-191 29-796 39-974 16-135-18-263-54-368-102l-75-35-701 0-701 0-79 223c-82 232-102 267-163 293-38 16-138 17-170 2zm-2023-820c332-15 1155-12 1835 6 308 8 563 12 566 8 4-4 10-21 13-38 7-30 6-31-92-77-518-244-1197-396-2112-474-295-25-1282-25-1579 0-231 20-473 46-479 51-6 7 49 110 93 171 160 226 416 335 855 365 142 10 539 5 900-12zm3304-263c525-111 899-887 934-1935 19-557-37-1023-172-1435-186-563-521-900-896-899-81 0-158 14-525 92-426 91-431 92-540 146-195 96-287 207-306 368-12 104-11 2985 1 3078 22 170 135 291 365 389 49 21 191 55 480 115 226 47 419 87 430 89 45 10 164 6 229-8zm-5570-485c112-43 197-156 216-291 12-83 13-2623 1-2706-23-158-125-273-270-304-44-9-100-1-542 75-272 47-514 91-539 98-266 68-487 424-594 958-56 280-70 548-40 800 56 484 207 878 414 1081 115 114 122 116 702 218 277 49 524 90 550 90 26 1 72-8 102-19zm2111-3440c1023-44 1884-213 2462-486l113-53-7-33c-3-18-8-35-10-37-2-3-236 1-521 7-993 24-1271 26-1708 11-541-18-1128-18-1249-1-377 56-588 181-734 437-32 55-41 79-32 84 12 8 246 32 491 51 356 28 815 36 1195 20z"/></g><text x="3250" y="8250" style="font-size:3000px;fill:#fff;text-anchor:middle">{text}</text></svg>',
    /**********************
     * Fill Patterns
     **********************/
    "checker": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(16 * {scale})" viewBox="0 0 16 16"><pattern id="p" x="0" y="0" width="16" height="16" patternUnits="userSpaceOnUse"><rect fill="{color}" x="0" width="8" height="8" y="0"/><rect fill="{color}" x="8" width="8" height="8" y="8"/></pattern><rect x="0" y="0" width="16" height="16" fill="{secondaryColor}"/><rect x="0" y="0" width="16" height="16" fill="url(#p)"/></svg>',
    "checker-rotated": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(16 * {scale})" height="calc(16 * {scale})" viewBox="0 0 60 60"><rect width="60" height="60" fill="{secondaryColor}"/><rect width="42.42" height="42.42" transform="translate(30 0) rotate(45)" fill="{color}"/></svg>',
    "zig-zag": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(15 * {scale})" height="calc(15 * {scale})" viewBox="0 0 120 120"><rect x="0" y="0" width="120" height="120" fill="{secondaryColor}"/><polygon fill="{color}" points="120 120 60 120 90 90 120 60 120 0 120 0 60 60 0 0 0 60 30 90 60 120 120 120"/></svg>',
    "zig-zag-vertical": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(15 * {scale})" height="calc(15 * {scale})" viewBox="0 0 120 120"><rect x="0" y="0" width="120" height="120" fill="{secondaryColor}"/><polygon fill="{color}" points="120 0 120 60 90 30 60 0 0 0 0 0 60 60 0 120 60 120 90 90 120 60 120 0"/></svg>',
    "circles-spaced": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 20 20"><defs><pattern id="p" x="0" y="0" width="20" height="20" patternUnits="userSpaceOnUse"><circle cx="10" cy="10" r="2" stroke="none" fill="{color}"/></pattern></defs><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><rect x="0" y="0" width="100" height="100" fill="url(#p)"/></svg>',
    "circles": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(7 * {scale})" height="calc(7 * {scale})" viewBox="0 0 20 20"><defs><pattern id="p" x="0" y="0" width="20" height="20" patternUnits="userSpaceOnUse"><circle cx="10" cy="10" r="6" stroke="none" fill="{color}"/></pattern></defs><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><rect x="0" y="0" width="100" height="100" fill="url(#p)"/></svg>',
    "diagonal-lines-up": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',
    "diagonal-lines-down": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(90 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',
    "diagonal-stripes-up": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',
    "diagonal-stripes-down": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g transform="rotate(90 20 20)" fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',
    "grid-lines": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(14 * {scale})" height="calc(14 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(45 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g><g fill="{color}" transform="rotate(-45 3 3)"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',
    "rotated-grid-lines": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(18 * {scale})" height="calc(18 * {scale})" viewBox="0 0 6 6"><rect x="0" y="0" width="6" height="6" fill="{secondaryColor}"/><g transform="rotate(90 3 3)" fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g><g fill="{color}"><path d="M5 0h1L0 6V5zM6 5v1H5z"/></g></svg>',
    "rotated-grid-stripes": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(20 * {scale})" height="calc(20 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="40" height="40" fill="{secondaryColor}"/><g transform="rotate(90 20 20)" fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g><g fill="{color}"><path d="M0 40L40 0H20L0 20M40 40V20L20 40"/></g></svg>',
    "x-fill": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(40 * {scale})" height="calc(40 * {scale})" viewBox="0 0 40 40"><rect x="0" y="0" width="45.3" height="45.3" fill="{secondaryColor}"/><g fill="{color}"><path d="M0 38.59l2.83-2.83 1.41 1.41L1.41 40H0v-1.41zM0 1.4l2.83 2.83 1.41-1.41L1.41 0H0v1.41zM38.59 40l-2.83-2.83 1.41-1.41L40 38.59V40h-1.41zM40 1.41l-2.83 2.83-1.41-1.41L38.59 0H40v1.41zM20 18.6l2.83-2.83 1.41 1.41L21.41 20l2.83 2.83-1.41 1.41L20 21.41l-2.83 2.83-1.41-1.41L18.59 20l-2.83-2.83 1.41-1.41L20 18.59z"/></g></svg>',
    "dots": '<svg xmlns="http://www.w3.org/2000/svg" width="calc(13 * {scale})" height="calc(13 * {scale})" viewBox="0 0 20 20"><rect x="0" y="0" width="20" height="20" fill="{secondaryColor}"/><g fill="{color}"><circle cx="3" cy="3" r="3"/><circle cx="13" cy="13" r="3"/></g></svg>'
};

/** The vertical distance between the tooltip and its target */
var tooltipVerticalOffset = 4;
/**
  * Creates tooltip content element
  */
var buildAccessibleTooltip = function (name) {
    var tooltipContent = document.createElement("span");
    tooltipContent.innerText = name;
    tooltipContent.classList.add('tooltiptext');
    if (navigator.userAgent.indexOf('Edg') != -1) {
        tooltipContent.classList.add('edge');
    }
    else if (navigator.userAgent.indexOf('Chrome') != -1) {
        tooltipContent.classList.add('chrome');
    }
    else if (navigator.userAgent.indexOf('Safari') != -1) {
        tooltipContent.classList.add('safari');
    }
    else if (navigator.userAgent.indexOf('Firefox') != -1) {
        tooltipContent.classList.add('firefox');
    }
    if (navigator.userAgent.indexOf('Windows') != -1) {
        tooltipContent.classList.add('win');
    }
    else if (navigator.userAgent.indexOf('Macintosh') != -1) {
        tooltipContent.classList.add('mac');
    }
    return tooltipContent;
};
/**
 * Determines tooltip position
 * @param tooltip tooltip to position
 * @param eventTarget target element that tooltip is bound to
 * @param forceAbsolute position:fixed is generally desired, however since tooltip is positioned alongside the target,
 *  the runtime transform of the parent container(maplibre marker) will apply to tooltip as well, in such case resort to position:absolute
 */
var positionTooltip = function (tooltip, eventTarget, forceAbsolute) {
    if (forceAbsolute === void 0) { forceAbsolute = false; }
    var positionTooltip = function (event) {
        var buttonRect = eventTarget.getBoundingClientRect();
        var tooltipRect = tooltip.getBoundingClientRect();
        var left, top;
        if ((buttonRect.x + tooltipRect.width) > window.innerWidth) {
            // the tooltip body may not fit the visible window width
            left = window.innerWidth - tooltipRect.width;
        }
        else {
            left = buttonRect.x;
        }
        if ((buttonRect.y + buttonRect.height + tooltipRect.height + tooltipVerticalOffset) > window.innerHeight) {
            // the tooltip body may not fit the visible window height
            // position above the target element
            top = buttonRect.y - tooltipRect.height - tooltipVerticalOffset;
        }
        else {
            top = buttonRect.y + buttonRect.height + tooltipVerticalOffset;
        }
        if (forceAbsolute && eventTarget.parentElement) {
            var parentRect = eventTarget.parentElement ? eventTarget.parentElement.getBoundingClientRect() : null;
            tooltip.style.position = 'absolute';
            left = left - parentRect.x;
            top = top - parentRect.y;
        }
        tooltip.style.transform = "translate(".concat(left, "px, ").concat(top, "px)");
        tooltip.style.display = "block";
    };
    // Accessibility: tooltip should be dismissible with the escape key
    var dismissTooltip = function (event) {
        if ((event.key === "Escape" || event.key === "Esc") && tooltip.style.display === "block") {
            event.stopPropagation();
            tooltip.style.display = "none";
        }
    };
    eventTarget.addEventListener("mouseover", positionTooltip);
    eventTarget.addEventListener("focusin", positionTooltip);
    eventTarget.addEventListener("keydown", dismissTooltip);
};

var __extends$1l = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Positions where the control can be placed on the map.
 */
var ControlPosition;
(function (ControlPosition) {
    /**
     * Places the control in the top left of the map.
     * Literal value `"top-left"`
     */
    ControlPosition["TopLeft"] = "top-left";
    /**
     * Places the control in the top right of the map.
     * Literal value `"top-right"`
     */
    ControlPosition["TopRight"] = "top-right";
    /**
     * Places the control in the bottom left of the map.
     * Literal value `"bottom-left"`
     */
    ControlPosition["BottomLeft"] = "bottom-left";
    /**
     * Places the control in the bottom right of the map.
     * Literal value `"bottom-right"`
     */
    ControlPosition["BottomRight"] = "bottom-right";
    /**
     * The control will place itself in its default location.
     * Literal value `"non-fixed"`
     */
    ControlPosition["NonFixed"] = "non-fixed";
})(ControlPosition || (ControlPosition = {}));
/**
 * The options for adding a control to the map.
 */
var ControlOptions = /** @class */ (function (_super) {
    __extends$1l(ControlOptions, _super);
    function ControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The position the control will be placed on the map. If not specified, the control will be located at the
         * default position it defines.
         * default `ControlPosition.NonFixed`
         * @default ControlPosition.NonFixed
         */
        _this.position = ControlPosition.NonFixed;
        return _this;
    }
    return ControlOptions;
}(Options));

/**
 * Color helper class to get the RGBA and luminosity of the color
 * @private
 */
var Color = /** @class */ (function () {
    function Color(color) {
        if (color) {
            var rgba = void 0;
            if (typeof color === "string") {
                rgba = this.getRBGA(color);
            }
            else {
                rgba = color;
            }
            if (rgba.length >= 3) {
                this.r = rgba[0];
                this.g = rgba[1];
                this.b = rgba[2];
                if (rgba.length > 3) {
                    this.a = rgba[3];
                }
            }
        }
    }
    /**
     * Get Luminosity of color
     */
    Color.prototype.getLuminosity = function () {
        // http://www.w3.org/TR/WCAG20/#relativeluminancedef
        var rgb = [this.r, this.g, this.b];
        var luminosity = [];
        for (var i = 0; i < rgb.length; i++) {
            var chan = rgb[i] / 255;
            luminosity[i] =
                chan <= 0.03928 ? chan / 12.92 : Math.pow((chan + 0.055) / 1.055, 2.4);
        }
        return (0.2126 * luminosity[0] + 0.7152 * luminosity[1] + 0.0722 * luminosity[2]);
    };
    /**
     * Get RGBA value of the color
     */
    Color.prototype.getRBGA = function (color) {
        var canvas = document.createElement("canvas");
        var ctx = canvas.getContext("2d");
        ctx.globalAlpha = 1;
        ctx.fillStyle = color;
        ctx.fillRect(0, 0, 1, 1);
        var data = ctx.getImageData(0, 0, 1, 1).data;
        return [data[0], data[1], data[2], data[3]];
    };
    return Color;
}());

/**
 * Available styles for a Control.
 */
var ControlStyle;
(function (ControlStyle) {
    /**
     * The control will be in the light style.
     * Literal value `"light"`
     */
    ControlStyle["light"] = "light";
    /**
     * The control will be in the dark style.
     * Literal value `"dark"`
     */
    ControlStyle["dark"] = "dark";
    /**
     * The control will automatically switch styles based on the style of the map.
     * If a control doesn't support automatic styling the light style will be used by default.
     * Literal value `"auto"`
     */
    ControlStyle["auto"] = "auto";
})(ControlStyle || (ControlStyle = {}));

var Dictionary = Map;

/**
 * An internal abstract class that can be extended to provide event listening/firing.
 * This class is for internal use only, and users will find little use with it.
 * Not to be used by the Map class. MapCallbackHandler implements the more complex logic for handling map events.
 */
var EventEmitter = /** @class */ (function () {
    function EventEmitter() {
        // Event listeners.
        this.listeners = new Dictionary();
    }
    EventEmitter.prototype._addEventListener = function (eventType, callback, once) {
        if (!this.listeners.has(eventType)) {
            this.listeners.set(eventType, new Dictionary());
        }
        this.listeners.get(eventType).set(callback, once);
    };
    EventEmitter.prototype._removeEventListener = function (eventType, callback) {
        if (this.listeners.has(eventType)) {
            this.listeners.get(eventType).delete(callback);
        }
    };
    /**
     * Invokes a given event type.
     * @param eventType The event name.
     * @param eventData The data to pass to the listener callbacks.
     */
    EventEmitter.prototype._invokeEvent = function (eventType, eventData) {
        var _this = this;
        if (this.listeners.has(eventType)) {
            this.listeners.get(eventType).forEach(function (once, callback) {
                if (once) {
                    _this._removeEventListener(eventType, callback);
                }
                try {
                    callback(eventData);
                }
                catch (error) {
                    // tslint:disable-next-line:no-console
                    console.error(error);
                }
            });
        }
    };
    return EventEmitter;
}());

var index$5 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	EventEmitter: EventEmitter
});

var __extends$1k = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * For internal use only.
 * Implements control interface and provides support for automatic styling based on the map style.
 */
var ControlBase = /** @class */ (function (_super) {
    __extends$1k(ControlBase, _super);
    function ControlBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * A callback for when the map's style changes.
         * Used for auto styling.
         */
        _this._onStyleChange = function () {
            if (_this._map.getStyle().style.toLowerCase().startsWith("blank")) {
                // If the style is blank the div background should decide the theme.
                if (!_this._observer) {
                    // Add an observer to see changes to the background.
                    _this._onBackgroundChange();
                    _this._observer = new MutationObserver(_this._onBackgroundChange);
                    _this._observer.observe(_this._map.getMapContainer(), { attributes: true, attributeFilter: ["style"] });
                }
            }
            else {
                if (_this._observer) {
                    // Remove any existing observer for non-blank styles.
                    _this._observer.disconnect();
                    delete _this._observer;
                }
                // If the style is anything but blank the style definition should decide the theme.
                _this._map.styles.getThemeAsync(_this._map.getStyle()).then(function (theme) {
                    _this._setTheme(theme);
                });
            }
        };
        /**
         * A callback for when the map's
         */
        _this._onBackgroundChange = function () {
            // Calculate the luminosity of the map div's background to determine the theme.
            // Try to parse the color, could fail if something complex like a gradient is used.
            var color = new Color(_this._map.getMapContainer().style.backgroundColor);
            var luminosity = color.getLuminosity();
            // If the background color can't be parsed assume it is light.
            var theme = isNaN(luminosity) || luminosity > 0.5
                ? ControlStyle.light
                : ControlStyle.dark;
            _this._setTheme(theme);
        };
        return _this;
    }
    /**
     * Method that is called when the control is removed from the map. Should perform any necessary cleanup for the
     * control.
     */
    ControlBase.prototype.onRemove = function () {
        if (this._container) {
            this._container.remove();
            delete this._container;
        }
        if (this._map) {
            this._map.events.remove("stylechanged", this._onStyleChange);
            delete this._map;
        }
        if (this._observer) {
            this._observer.disconnect();
            delete this._observer;
        }
        delete this._theme;
    };
    /**
     * Build the outermost container for the control, applies styling including any listeners for auto styling.
     */
    ControlBase.prototype.buildContainer = function (map, style, ariaLabel, tagName) {
        this._map = map;
        this._container = document.createElement(tagName || "div");
        this._container.classList.add("azure-maps-control-container");
        if (typeof ariaLabel === "string") {
            this._container.setAttribute("aria-label", ariaLabel);
        }
        // Set the style or add the auto listener.
        if (style.toLowerCase() === ControlStyle.auto) {
            if (this._map) {
                this._map.events.add("stylechanged", this._onStyleChange);
            }
        }
        else {
            this._container.classList.add(style);
        }
        return this._container;
    };
    /**
     * Sets the control's theme (light/dark).
     * Only applies changes if the theme is different than the previous.
     */
    ControlBase.prototype._setTheme = function (theme) {
        // Only update if the theme is different.
        if (this._theme !== theme) {
            this._container.classList.remove(this._theme);
            this._container.classList.add(theme);
            this._theme = theme;
        }
    };
    /** The delay between activating the control and when a click should occur, else assume it's a touch */
    ControlBase.activateClickDelay = 100;
    return ControlBase;
}(EventEmitter));

var __extends$1j = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a CompassControl object.
 */
var CompassControlOptions = /** @class */ (function (_super) {
    __extends$1j(CompassControlOptions, _super);
    function CompassControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The angle that the map will rotate with each click of the control.
         * Default `15`.
         * @default 15
         */
        _this.rotationDegreesDelta = 15;
        /**
         * The style of the control.
         * Default `ControlStyle.light`
         * @default ControlStyle.light
         */
        _this.style = ControlStyle.light;
        /**
         * Inverts the direction of map rotation controls.
         * @default false
         */
        _this.inverted = false;
        return _this;
    }
    return CompassControlOptions;
}(Options));

var __extends$1i = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A control for changing the rotation of the map.
 */
var CompassControl = /** @class */ (function (_super) {
    __extends$1i(CompassControl, _super);
    /**
     * Constructs a CompassControl.
     * @param options The options for the control.
     */
    function CompassControl(options) {
        var _this = _super.call(this) || this;
        _this.hasMouse = false;
        _this.hasFocus = false;
        _this.options = new CompassControlOptions().merge(options);
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    CompassControl.prototype.onAdd = function (map, options) {
        var _this = this;
        var container = this.buildContainer(map, this.options.style, "Rotation Control");
        var rotationButton = this.constructRotationButton(map);
        var grid = this.constructRotationGrid(map, options);
        var tooltip = buildAccessibleTooltip("Reset to Default Rotation");
        var expandGrid = function (expanded) {
            if (expanded) {
                container.classList.add("in-use");
                grid.classList.remove("hidden-accessible-element");
            }
            else {
                container.classList.remove("in-use");
                grid.classList.add("hidden-accessible-element");
            }
        };
        container.addEventListener("mouseover", function (event) {
            _this.lastActiveTime = _this.lastActiveTime || event.timeStamp;
            _this.hasMouse = true;
            expandGrid(true);
        });
        container.addEventListener("focusin", function (event) {
            _this.lastActiveTime = _this.lastActiveTime || event.timeStamp;
            _this.hasFocus = true;
            expandGrid(true);
        });
        container.addEventListener("mouseleave", function () {
            _this.hasMouse = false;
            if (!_this.hasFocus) {
                delete _this.lastActiveTime;
                expandGrid(false);
            }
        });
        container.addEventListener("focusout", function (event) {
            if (!(event.relatedTarget instanceof Node && container.contains(event.relatedTarget))) {
                _this.hasFocus = false;
                if (!_this.hasMouse) {
                    delete _this.lastActiveTime;
                    expandGrid(false);
                }
            }
        });
        // Keep the focus on this control when esc key is pressed on the grid
        grid.addEventListener("keydown", function (event) {
            if (event.key === "Escape" || event.key === "Esc") {
                event.stopPropagation();
                rotationButton.focus();
                expandGrid(false);
            }
        });
        // Dismiss the grid when esc key is pressed on the reset button and the tooltip is not visible
        rotationButton.addEventListener("keydown", function (event) {
            if ((event.key === "Escape" || event.key === "Esc") &&
                (container === null || container === void 0 ? void 0 : container.classList.contains("in-use")) &&
                (tooltip === null || tooltip === void 0 ? void 0 : tooltip.style.display) === "none") {
                event.stopPropagation();
                expandGrid(false);
            }
        });
        // If the control's position will require inverting the element order
        // add them in the opposite order to preserve tabindex.
        if (options && CompassControl.InvertOrderPositions.includes(options.position)) {
            container.appendChild(grid);
            container.appendChild(rotationButton);
            container.appendChild(tooltip);
            positionTooltip(tooltip, rotationButton);
        }
        else {
            container.appendChild(rotationButton);
            container.appendChild(tooltip);
            positionTooltip(tooltip, rotationButton);
            container.appendChild(grid);
        }
        return container;
    };
    CompassControl.prototype.constructRotationGrid = function (map, options) {
        var grid = document.createElement("div");
        grid.classList.add("sub-container");
        grid.classList.add("hidden-accessible-element");
        var rotationRightButton = this.constructRightRotationButton(map);
        var rotationLeftButton = this.constructLeftRotationButton(map);
        var tooltipLeft = buildAccessibleTooltip("Rotate Left");
        var tooltipRight = buildAccessibleTooltip("Rotate Right");
        if (options && CompassControl.InvertOrderPositions.includes(options.position)) {
            grid.appendChild(rotationRightButton);
            grid.appendChild(tooltipRight);
            positionTooltip(tooltipRight, rotationRightButton);
            grid.appendChild(rotationLeftButton);
            grid.appendChild(tooltipLeft);
            positionTooltip(tooltipLeft, rotationLeftButton);
        }
        else {
            grid.appendChild(rotationLeftButton);
            grid.appendChild(tooltipLeft);
            positionTooltip(tooltipLeft, rotationLeftButton);
            grid.appendChild(rotationRightButton);
            grid.appendChild(tooltipRight);
            positionTooltip(tooltipRight, rotationRightButton);
        }
        return grid;
    };
    CompassControl.prototype.constructRotationButton = function (map) {
        var _this = this;
        var rotationButton = document.createElement("button");
        rotationButton.classList.add("azure-maps-control-button");
        rotationButton.classList.add("rotation");
        rotationButton.setAttribute("aria-label", "Reset to Default Rotation");
        rotationButton.setAttribute("alt", "Reset to Default Rotation");
        rotationButton.setAttribute("type", "button");
        var icon = document.createElement("div");
        rotationButton.appendChild(icon);
        rotationButton.addEventListener("click", function (event) {
            // If the click is happening just after the control became active assume it's a touch event from Edge.
            if (event.timeStamp - _this.lastActiveTime > ControlBase.activateClickDelay) {
                map.setCamera({
                    bearing: CompassControl.DefaultRotation
                }, true);
            }
        });
        map.events.add("rotate", function (e) {
            icon.style.transform = "rotate(".concat(-e.map.getCamera().bearing, "deg)");
        });
        return rotationButton;
    };
    CompassControl.prototype.constructRightRotationButton = function (map) {
        var _this = this;
        var rotationRightButton = document.createElement("button");
        rotationRightButton.classList.add("azure-maps-control-button");
        rotationRightButton.classList.add("rotation-right");
        rotationRightButton.setAttribute("aria-label", "Rotate Right");
        rotationRightButton.setAttribute("alt", "Rotate Right");
        rotationRightButton.setAttribute("type", "button");
        rotationRightButton.addEventListener("click", function () {
            map.setCamera({
                bearing: map.getCamera().bearing - (_this.options.inverted ? -1 : 1) * _this.options.rotationDegreesDelta,
                duration: CompassControl.RotationDuration,
                type: "ease",
            }, true);
        });
        return rotationRightButton;
    };
    CompassControl.prototype.constructLeftRotationButton = function (map) {
        var _this = this;
        var rotationLeftButton = document.createElement("button");
        rotationLeftButton.classList.add("azure-maps-control-button");
        rotationLeftButton.classList.add("rotation-left");
        rotationLeftButton.setAttribute("aria-label", "Rotate Left");
        rotationLeftButton.setAttribute("alt", "Rotate Left");
        rotationLeftButton.setAttribute("type", "button");
        rotationLeftButton.addEventListener("click", function () {
            map.setCamera({
                bearing: map.getCamera().bearing + (_this.options.inverted ? -1 : 1) * _this.options.rotationDegreesDelta,
                duration: CompassControl.RotationDuration,
                type: "ease"
            }, true);
        });
        return rotationLeftButton;
    };
    CompassControl.DefaultRotation = 0;
    /** @internal */ CompassControl.RotationDuration = 100;
    CompassControl.InvertOrderPositions = [ControlPosition.BottomRight, ControlPosition.TopRight];
    return CompassControl;
}(ControlBase));

var __extends$1h = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a PitchControl object.
 */
var PitchControlOptions = /** @class */ (function (_super) {
    __extends$1h(PitchControlOptions, _super);
    function PitchControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The angle that the map will tilt with each click of the control.
         * Default `10`.
         * @default 10
         */
        _this.pitchDegreesDelta = 10;
        /**
         * The style of the control.
         * Default `ControlStyle.light`.
         * @default ControlStyle.light
         */
        _this.style = ControlStyle.light;
        /**
         * Inverts the direction of map pitch controls.
         * @default false
         */
        _this.inverted = false;
        return _this;
    }
    return PitchControlOptions;
}(Options));

var __extends$1g = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A control for changing the pitch of the map.
 */
var PitchControl = /** @class */ (function (_super) {
    __extends$1g(PitchControl, _super);
    /**
     * Constructs a PitchControl.
     * @param options The options for the control.
     */
    function PitchControl(options) {
        var _this = _super.call(this) || this;
        _this.container = null;
        _this.map = null;
        _this.pitchButton = null;
        _this.pitchIncrementButton = null;
        _this.pitchDecrementButton = null;
        _this.hasMouse = false;
        _this.hasFocus = false;
        _this.pitchChanged = function (map) { return _this.updatePitchButtonsState(); };
        _this.updatePitchButtonsState = function () {
            var minPitchReached = _this.map.getCamera().pitch <= 0;
            var maxPitchReached = _this.map.getCamera().pitch >= 60;
            // Keep the focus on this control when max/min pitch is reached
            if (_this.hasFocus && _this.pitchButton && (minPitchReached || maxPitchReached)) {
                _this.pitchButton.focus();
            }
            if (_this.options.inverted) {
                if (_this.pitchIncrementButton && _this.pitchIncrementButton.disabled != minPitchReached) {
                    _this.pitchIncrementButton.disabled = minPitchReached;
                }
                if (_this.pitchDecrementButton && _this.pitchDecrementButton.disabled != maxPitchReached) {
                    _this.pitchDecrementButton.disabled = maxPitchReached;
                }
            }
            else {
                if (_this.pitchIncrementButton && _this.pitchIncrementButton.disabled != maxPitchReached) {
                    _this.pitchIncrementButton.disabled = maxPitchReached;
                }
                if (_this.pitchDecrementButton && _this.pitchDecrementButton.disabled != minPitchReached) {
                    _this.pitchDecrementButton.disabled = minPitchReached;
                }
            }
        };
        _this.options = new PitchControlOptions().merge(options);
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    PitchControl.prototype.onAdd = function (map, options) {
        var _this = this;
        var container = this.buildContainer(map, this.options.style, "Pitch Control");
        var pitchButton = this.constructPitchButton(map);
        var grid = this.constructPitchGrid(map, options);
        var tooltip = buildAccessibleTooltip("Reset to Default Pitch");
        var expandGrid = function (expanded) {
            if (expanded) {
                container.classList.add("in-use");
                grid.classList.remove("hidden-accessible-element");
            }
            else {
                container.classList.remove("in-use");
                grid.classList.add("hidden-accessible-element");
            }
        };
        container.addEventListener("mouseover", function (event) {
            _this.lastActiveTime = _this.lastActiveTime || event.timeStamp;
            _this.hasMouse = true;
            expandGrid(true);
        });
        container.addEventListener("focusin", function (event) {
            _this.lastActiveTime = _this.lastActiveTime || event.timeStamp;
            _this.hasFocus = true;
            expandGrid(true);
        });
        container.addEventListener("mouseleave", function () {
            _this.hasMouse = false;
            if (!_this.hasFocus) {
                delete _this.lastActiveTime;
                expandGrid(false);
            }
        });
        container.addEventListener("focusout", function (event) {
            if (!(event.relatedTarget instanceof Node && container.contains(event.relatedTarget))) {
                _this.hasFocus = false;
                if (!_this.hasMouse) {
                    delete _this.lastActiveTime;
                    expandGrid(false);
                }
            }
        });
        // Keep the focus on this control when esc key is pressed on the grid
        grid.addEventListener("keydown", function (event) {
            if (event.key === "Escape" || event.key === "Esc") {
                event.stopPropagation();
                pitchButton.focus();
                expandGrid(false);
            }
        });
        // Dismiss the grid when esc key is pressed on the reset button and the tooltip is not visible
        pitchButton.addEventListener("keydown", function (event) {
            if ((event.key === "Escape" || event.key === "Esc") &&
                (container === null || container === void 0 ? void 0 : container.classList.contains("in-use")) &&
                (tooltip === null || tooltip === void 0 ? void 0 : tooltip.style.display) === "none") {
                event.stopPropagation();
                expandGrid(false);
            }
        });
        // If the control's position will require inverting the element order
        // add them in the opposite order to preserve tabindex.
        if (options && PitchControl.INVERT_ORDER_POSITIONS.includes(options.position)) {
            container.appendChild(grid);
            container.appendChild(pitchButton);
            container.appendChild(tooltip);
            positionTooltip(tooltip, container);
        }
        else {
            container.appendChild(pitchButton);
            container.appendChild(tooltip);
            positionTooltip(tooltip, container);
            container.appendChild(grid);
        }
        this.map = map;
        this.container = container;
        this.pitchButton = pitchButton;
        map.events.add('pitch', this.pitchChanged);
        this.updatePitchButtonsState();
        return container;
    };
    PitchControl.prototype.onRemove = function () {
        if (this.container) {
            this.container.remove();
            this.container = null;
            this.pitchButton = null;
            this.pitchIncrementButton = null;
            this.pitchDecrementButton = null;
        }
        if (this.map) {
            this.map.events.remove('pitch', this.pitchChanged);
            this.map = null;
        }
    };
    PitchControl.prototype.constructPitchGrid = function (map, options) {
        var grid = document.createElement("div");
        grid.classList.add("sub-container");
        grid.classList.add("hidden-accessible-element");
        this.pitchIncrementButton = this.constructPitchIncrementButton(map);
        this.pitchDecrementButton = this.constructPitchDecrementButton(map);
        var tooltipIncrement = buildAccessibleTooltip("Increase Pitch");
        var tooltipDecrease = buildAccessibleTooltip("Decrease Pitch");
        if (options && PitchControl.INVERT_ORDER_POSITIONS.includes(options.position)) {
            grid.appendChild(this.pitchDecrementButton);
            grid.appendChild(tooltipDecrease);
            positionTooltip(tooltipDecrease, this.pitchDecrementButton);
            grid.appendChild(this.pitchIncrementButton);
            grid.appendChild(tooltipIncrement);
            positionTooltip(tooltipIncrement, this.pitchIncrementButton);
        }
        else {
            grid.appendChild(this.pitchIncrementButton);
            grid.appendChild(tooltipIncrement);
            positionTooltip(tooltipIncrement, this.pitchIncrementButton);
            grid.appendChild(this.pitchDecrementButton);
            grid.appendChild(tooltipDecrease);
            positionTooltip(tooltipDecrease, this.pitchDecrementButton);
        }
        return grid;
    };
    PitchControl.prototype.constructPitchButton = function (map) {
        var _this = this;
        var pitchButton = document.createElement("button");
        pitchButton.classList.add("azure-maps-control-button");
        pitchButton.classList.add("pitch");
        pitchButton.setAttribute("aria-label", "Reset to Default Pitch");
        pitchButton.setAttribute("alt", "Reset to Default Pitch");
        pitchButton.setAttribute("type", "button");
        pitchButton.addEventListener("click", function () {
            // If the click is happening just after the control became active assume it's a touch event from Edge.
            if (event.timeStamp - _this.lastActiveTime > ControlBase.activateClickDelay) {
                map.setCamera({
                    pitch: PitchControl.DEFAULT_PITCH
                }, true);
            }
        });
        return pitchButton;
    };
    PitchControl.prototype.constructPitchDecrementButton = function (map) {
        var _this = this;
        var pitchDecrementButton = document.createElement("button");
        pitchDecrementButton.classList.add("azure-maps-control-button");
        pitchDecrementButton.classList.add("pitch-down");
        pitchDecrementButton.setAttribute("aria-label", "Decrease Pitch");
        pitchDecrementButton.setAttribute("alt", "Decrease Pitch");
        pitchDecrementButton.setAttribute("type", "button");
        pitchDecrementButton.addEventListener("click", function () {
            map.setCamera({
                pitch: map.getCamera().pitch - (_this.options.inverted ? -1 : 1) * _this.options.pitchDegreesDelta,
                duration: PitchControl.PITCH_DURATION_MS,
                type: "ease"
            }, true);
        });
        return pitchDecrementButton;
    };
    PitchControl.prototype.constructPitchIncrementButton = function (map) {
        var _this = this;
        var pitchIncrementButton = document.createElement("button");
        pitchIncrementButton.classList.add("azure-maps-control-button");
        pitchIncrementButton.classList.add("pitch-up");
        pitchIncrementButton.setAttribute("aria-label", "Increase Pitch");
        pitchIncrementButton.setAttribute("alt", "Increase Pitch");
        pitchIncrementButton.setAttribute("type", "button");
        pitchIncrementButton.addEventListener("click", function () {
            map.setCamera({
                pitch: map.getCamera().pitch + (_this.options.inverted ? -1 : 1) * _this.options.pitchDegreesDelta,
                duration: PitchControl.PITCH_DURATION_MS,
                type: "ease"
            }, true);
        });
        return pitchIncrementButton;
    };
    PitchControl.PITCH_DURATION_MS = 100;
    PitchControl.DEFAULT_PITCH = 0;
    PitchControl.INVERT_ORDER_POSITIONS = [ControlPosition.BottomRight, ControlPosition.TopRight];
    return PitchControl;
}(ControlBase));

var __extends$1f = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A control to display a scale bar on the map.
 */
var ScaleControl = /** @class */ (function (_super) {
    __extends$1f(ScaleControl, _super);
    /**
     * A control to displays a scale bar relative to the pixel resolution at the center of the map.
     * @param options Options for defining how the control is rendered and functions.
     */
    function ScaleControl(options) {
        var _this = _super.call(this) || this;
        _this.map = null;
        _this.control = new maplibregl.ScaleControl({
            maxWidth: options === null || options === void 0 ? void 0 : options.maxWidth,
            unit: options === null || options === void 0 ? void 0 : options.unit
        });
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    ScaleControl.prototype.onAdd = function (map, options) {
        var _a, _b, _c;
        this.map = map;
        (_b = (_a = this.map) === null || _a === void 0 ? void 0 : _a._getMap()) === null || _b === void 0 ? void 0 : _b.addControl(this.control);
        var container = this.buildContainer(map, ControlStyle.auto, "Scale Bar");
        container.appendChild((_c = this.control) === null || _c === void 0 ? void 0 : _c._container);
        return container;
    };
    /**
     * Method that is called when the control is removed from the map. Should perform any necessary cleanup for the
     * control.
     */
    ScaleControl.prototype.onRemove = function () {
        var _a, _b;
        _super.prototype.onRemove.call(this);
        (_b = (_a = this.map) === null || _a === void 0 ? void 0 : _a._getMap()) === null || _b === void 0 ? void 0 : _b.removeControl(this.control);
        this.map = null;
    };
    /**
     * Set the scale's unit of the distance
     * @param unit - Unit of the distance (`"imperial"`, `"metric"` or `"nautical"`).
     */
    ScaleControl.prototype.setUnit = function (unit) {
        var _a;
        (_a = this.control) === null || _a === void 0 ? void 0 : _a.setUnit(unit);
    };
    return ScaleControl;
}(ControlBase));

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */

function listCacheClear$1() {
  this.__data__ = [];
  this.size = 0;
}

var _listCacheClear = listCacheClear$1;

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */

function eq$5(value, other) {
  return value === other || (value !== value && other !== other);
}

var eq_1 = eq$5;

var eq$4 = eq_1;

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf$4(array, key) {
  var length = array.length;
  while (length--) {
    if (eq$4(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

var _assocIndexOf = assocIndexOf$4;

var assocIndexOf$3 = _assocIndexOf;

/** Used for built-in method references. */
var arrayProto = Array.prototype;

/** Built-in value references. */
var splice = arrayProto.splice;

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete$1(key) {
  var data = this.__data__,
      index = assocIndexOf$3(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

var _listCacheDelete = listCacheDelete$1;

var assocIndexOf$2 = _assocIndexOf;

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet$1(key) {
  var data = this.__data__,
      index = assocIndexOf$2(data, key);

  return index < 0 ? undefined : data[index][1];
}

var _listCacheGet = listCacheGet$1;

var assocIndexOf$1 = _assocIndexOf;

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas$1(key) {
  return assocIndexOf$1(this.__data__, key) > -1;
}

var _listCacheHas = listCacheHas$1;

var assocIndexOf = _assocIndexOf;

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet$1(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

var _listCacheSet = listCacheSet$1;

var listCacheClear = _listCacheClear,
    listCacheDelete = _listCacheDelete,
    listCacheGet = _listCacheGet,
    listCacheHas = _listCacheHas,
    listCacheSet = _listCacheSet;

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache$4(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `ListCache`.
ListCache$4.prototype.clear = listCacheClear;
ListCache$4.prototype['delete'] = listCacheDelete;
ListCache$4.prototype.get = listCacheGet;
ListCache$4.prototype.has = listCacheHas;
ListCache$4.prototype.set = listCacheSet;

var _ListCache = ListCache$4;

var ListCache$3 = _ListCache;

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear$1() {
  this.__data__ = new ListCache$3;
  this.size = 0;
}

var _stackClear = stackClear$1;

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function stackDelete$1(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

var _stackDelete = stackDelete$1;

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function stackGet$1(key) {
  return this.__data__.get(key);
}

var _stackGet = stackGet$1;

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function stackHas$1(key) {
  return this.__data__.has(key);
}

var _stackHas = stackHas$1;

/** Detect free variable `global` from Node.js. */

var freeGlobal$1 = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

var _freeGlobal = freeGlobal$1;

var freeGlobal = _freeGlobal;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root$8 = freeGlobal || freeSelf || Function('return this')();

var _root = root$8;

var root$7 = _root;

/** Built-in value references. */
var Symbol$5 = root$7.Symbol;

var _Symbol = Symbol$5;

var Symbol$4 = _Symbol;

/** Used for built-in method references. */
var objectProto$f = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$c = objectProto$f.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString$1 = objectProto$f.toString;

/** Built-in value references. */
var symToStringTag$1 = Symbol$4 ? Symbol$4.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$c.call(value, symToStringTag$1),
      tag = value[symToStringTag$1];

  try {
    value[symToStringTag$1] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}

var _getRawTag = getRawTag$1;

/** Used for built-in method references. */

var objectProto$e = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto$e.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}

var _objectToString = objectToString$1;

var Symbol$3 = _Symbol,
    getRawTag = _getRawTag,
    objectToString = _objectToString;

/** `Object#toString` result references. */
var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol$3 ? Symbol$3.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag$5(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

var _baseGetTag = baseGetTag$5;

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */

function isObject$9(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

var isObject_1 = isObject$9;

var baseGetTag$4 = _baseGetTag,
    isObject$8 = isObject_1;

/** `Object#toString` result references. */
var asyncTag = '[object AsyncFunction]',
    funcTag$2 = '[object Function]',
    genTag$1 = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction$4(value) {
  if (!isObject$8(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag$4(value);
  return tag == funcTag$2 || tag == genTag$1 || tag == asyncTag || tag == proxyTag;
}

var isFunction_1 = isFunction$4;

var root$6 = _root;

/** Used to detect overreaching core-js shims. */
var coreJsData$1 = root$6['__core-js_shared__'];

var _coreJsData = coreJsData$1;

var coreJsData = _coreJsData;

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked$1(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

var _isMasked = isMasked$1;

/** Used for built-in method references. */

var funcProto$2 = Function.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString$2 = funcProto$2.toString;

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */
function toSource$2(func) {
  if (func != null) {
    try {
      return funcToString$2.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

var _toSource = toSource$2;

var isFunction$3 = isFunction_1,
    isMasked = _isMasked,
    isObject$7 = isObject_1,
    toSource$1 = _toSource;

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used for built-in method references. */
var funcProto$1 = Function.prototype,
    objectProto$d = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString$1 = funcProto$1.toString;

/** Used to check objects for own properties. */
var hasOwnProperty$b = objectProto$d.hasOwnProperty;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString$1.call(hasOwnProperty$b).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative$1(value) {
  if (!isObject$7(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction$3(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource$1(value));
}

var _baseIsNative = baseIsNative$1;

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */

function getValue$1(object, key) {
  return object == null ? undefined : object[key];
}

var _getValue = getValue$1;

var baseIsNative = _baseIsNative,
    getValue = _getValue;

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative$7(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

var _getNative = getNative$7;

var getNative$6 = _getNative,
    root$5 = _root;

/* Built-in method references that are verified to be native. */
var Map$5 = getNative$6(root$5, 'Map');

var _Map = Map$5;

var getNative$5 = _getNative;

/* Built-in method references that are verified to be native. */
var nativeCreate$4 = getNative$5(Object, 'create');

var _nativeCreate = nativeCreate$4;

var nativeCreate$3 = _nativeCreate;

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear$1() {
  this.__data__ = nativeCreate$3 ? nativeCreate$3(null) : {};
  this.size = 0;
}

var _hashClear = hashClear$1;

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function hashDelete$1(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

var _hashDelete = hashDelete$1;

var nativeCreate$2 = _nativeCreate;

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED$2 = '__lodash_hash_undefined__';

/** Used for built-in method references. */
var objectProto$c = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$a = objectProto$c.hasOwnProperty;

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet$1(key) {
  var data = this.__data__;
  if (nativeCreate$2) {
    var result = data[key];
    return result === HASH_UNDEFINED$2 ? undefined : result;
  }
  return hasOwnProperty$a.call(data, key) ? data[key] : undefined;
}

var _hashGet = hashGet$1;

var nativeCreate$1 = _nativeCreate;

/** Used for built-in method references. */
var objectProto$b = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$9 = objectProto$b.hasOwnProperty;

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas$1(key) {
  var data = this.__data__;
  return nativeCreate$1 ? (data[key] !== undefined) : hasOwnProperty$9.call(data, key);
}

var _hashHas = hashHas$1;

var nativeCreate = _nativeCreate;

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED$1 = '__lodash_hash_undefined__';

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet$1(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED$1 : value;
  return this;
}

var _hashSet = hashSet$1;

var hashClear = _hashClear,
    hashDelete = _hashDelete,
    hashGet = _hashGet,
    hashHas = _hashHas,
    hashSet = _hashSet;

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash$1(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `Hash`.
Hash$1.prototype.clear = hashClear;
Hash$1.prototype['delete'] = hashDelete;
Hash$1.prototype.get = hashGet;
Hash$1.prototype.has = hashHas;
Hash$1.prototype.set = hashSet;

var _Hash = Hash$1;

var Hash = _Hash,
    ListCache$2 = _ListCache,
    Map$4 = _Map;

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear$1() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map$4 || ListCache$2),
    'string': new Hash
  };
}

var _mapCacheClear = mapCacheClear$1;

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */

function isKeyable$1(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

var _isKeyable = isKeyable$1;

var isKeyable = _isKeyable;

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData$4(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

var _getMapData = getMapData$4;

var getMapData$3 = _getMapData;

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete$1(key) {
  var result = getMapData$3(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

var _mapCacheDelete = mapCacheDelete$1;

var getMapData$2 = _getMapData;

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet$1(key) {
  return getMapData$2(this, key).get(key);
}

var _mapCacheGet = mapCacheGet$1;

var getMapData$1 = _getMapData;

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas$1(key) {
  return getMapData$1(this, key).has(key);
}

var _mapCacheHas = mapCacheHas$1;

var getMapData = _getMapData;

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet$1(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

var _mapCacheSet = mapCacheSet$1;

var mapCacheClear = _mapCacheClear,
    mapCacheDelete = _mapCacheDelete,
    mapCacheGet = _mapCacheGet,
    mapCacheHas = _mapCacheHas,
    mapCacheSet = _mapCacheSet;

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache$2(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `MapCache`.
MapCache$2.prototype.clear = mapCacheClear;
MapCache$2.prototype['delete'] = mapCacheDelete;
MapCache$2.prototype.get = mapCacheGet;
MapCache$2.prototype.has = mapCacheHas;
MapCache$2.prototype.set = mapCacheSet;

var _MapCache = MapCache$2;

var ListCache$1 = _ListCache,
    Map$3 = _Map,
    MapCache$1 = _MapCache;

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet$1(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache$1) {
    var pairs = data.__data__;
    if (!Map$3 || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache$1(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

var _stackSet = stackSet$1;

var ListCache = _ListCache,
    stackClear = _stackClear,
    stackDelete = _stackDelete,
    stackGet = _stackGet,
    stackHas = _stackHas,
    stackSet = _stackSet;

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack$3(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack$3.prototype.clear = stackClear;
Stack$3.prototype['delete'] = stackDelete;
Stack$3.prototype.get = stackGet;
Stack$3.prototype.has = stackHas;
Stack$3.prototype.set = stackSet;

var _Stack = Stack$3;

/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */

function arrayEach$1(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}

var _arrayEach = arrayEach$1;

var getNative$4 = _getNative;

var defineProperty$2 = (function() {
  try {
    var func = getNative$4(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

var _defineProperty = defineProperty$2;

var defineProperty$1 = _defineProperty;

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function baseAssignValue$3(object, key, value) {
  if (key == '__proto__' && defineProperty$1) {
    defineProperty$1(object, key, {
      'configurable': true,
      'enumerable': true,
      'value': value,
      'writable': true
    });
  } else {
    object[key] = value;
  }
}

var _baseAssignValue = baseAssignValue$3;

var baseAssignValue$2 = _baseAssignValue,
    eq$3 = eq_1;

/** Used for built-in method references. */
var objectProto$a = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$8 = objectProto$a.hasOwnProperty;

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue$2(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty$8.call(object, key) && eq$3(objValue, value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue$2(object, key, value);
  }
}

var _assignValue = assignValue$2;

var assignValue$1 = _assignValue,
    baseAssignValue$1 = _baseAssignValue;

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */
function copyObject$5(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});

  var index = -1,
      length = props.length;

  while (++index < length) {
    var key = props[index];

    var newValue = customizer
      ? customizer(object[key], source[key], key, object, source)
      : undefined;

    if (newValue === undefined) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue$1(object, key, newValue);
    } else {
      assignValue$1(object, key, newValue);
    }
  }
  return object;
}

var _copyObject = copyObject$5;

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */

function baseTimes$1(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

var _baseTimes = baseTimes$1;

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */

function isObjectLike$9(value) {
  return value != null && typeof value == 'object';
}

var isObjectLike_1 = isObjectLike$9;

var baseGetTag$3 = _baseGetTag,
    isObjectLike$8 = isObjectLike_1;

/** `Object#toString` result references. */
var argsTag$3 = '[object Arguments]';

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments$1(value) {
  return isObjectLike$8(value) && baseGetTag$3(value) == argsTag$3;
}

var _baseIsArguments = baseIsArguments$1;

var baseIsArguments = _baseIsArguments,
    isObjectLike$7 = isObjectLike_1;

/** Used for built-in method references. */
var objectProto$9 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$7 = objectProto$9.hasOwnProperty;

/** Built-in value references. */
var propertyIsEnumerable$1 = objectProto$9.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments$2 = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike$7(value) && hasOwnProperty$7.call(value, 'callee') &&
    !propertyIsEnumerable$1.call(value, 'callee');
};

var isArguments_1 = isArguments$2;

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */

var isArray$6 = Array.isArray;

var isArray_1 = isArray$6;

var isBuffer$4 = {exports: {}};

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */

function stubFalse() {
  return false;
}

var stubFalse_1 = stubFalse;

isBuffer$4.exports;

(function (module, exports) {
	var root = _root,
	    stubFalse = stubFalse_1;

	/** Detect free variable `exports`. */
	var freeExports = exports && !exports.nodeType && exports;

	/** Detect free variable `module`. */
	var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

	/** Detect the popular CommonJS extension `module.exports`. */
	var moduleExports = freeModule && freeModule.exports === freeExports;

	/** Built-in value references. */
	var Buffer = moduleExports ? root.Buffer : undefined;

	/* Built-in method references for those with the same name as other `lodash` methods. */
	var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

	/**
	 * Checks if `value` is a buffer.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.3.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
	 * @example
	 *
	 * _.isBuffer(new Buffer(2));
	 * // => true
	 *
	 * _.isBuffer(new Uint8Array(2));
	 * // => false
	 */
	var isBuffer = nativeIsBuffer || stubFalse;

	module.exports = isBuffer; 
} (isBuffer$4, isBuffer$4.exports));

var isBufferExports = isBuffer$4.exports;

/** Used as references for various `Number` constants. */

var MAX_SAFE_INTEGER$1 = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex$2(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER$1 : length;

  return !!length &&
    (type == 'number' ||
      (type != 'symbol' && reIsUint.test(value))) &&
        (value > -1 && value % 1 == 0 && value < length);
}

var _isIndex = isIndex$2;

/** Used as references for various `Number` constants. */

var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength$2(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

var isLength_1 = isLength$2;

var baseGetTag$2 = _baseGetTag,
    isLength$1 = isLength_1,
    isObjectLike$6 = isObjectLike_1;

/** `Object#toString` result references. */
var argsTag$2 = '[object Arguments]',
    arrayTag$2 = '[object Array]',
    boolTag$3 = '[object Boolean]',
    dateTag$3 = '[object Date]',
    errorTag$2 = '[object Error]',
    funcTag$1 = '[object Function]',
    mapTag$5 = '[object Map]',
    numberTag$3 = '[object Number]',
    objectTag$4 = '[object Object]',
    regexpTag$3 = '[object RegExp]',
    setTag$5 = '[object Set]',
    stringTag$3 = '[object String]',
    weakMapTag$2 = '[object WeakMap]';

var arrayBufferTag$3 = '[object ArrayBuffer]',
    dataViewTag$4 = '[object DataView]',
    float32Tag$2 = '[object Float32Array]',
    float64Tag$2 = '[object Float64Array]',
    int8Tag$2 = '[object Int8Array]',
    int16Tag$2 = '[object Int16Array]',
    int32Tag$2 = '[object Int32Array]',
    uint8Tag$2 = '[object Uint8Array]',
    uint8ClampedTag$2 = '[object Uint8ClampedArray]',
    uint16Tag$2 = '[object Uint16Array]',
    uint32Tag$2 = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag$2] = typedArrayTags[float64Tag$2] =
typedArrayTags[int8Tag$2] = typedArrayTags[int16Tag$2] =
typedArrayTags[int32Tag$2] = typedArrayTags[uint8Tag$2] =
typedArrayTags[uint8ClampedTag$2] = typedArrayTags[uint16Tag$2] =
typedArrayTags[uint32Tag$2] = true;
typedArrayTags[argsTag$2] = typedArrayTags[arrayTag$2] =
typedArrayTags[arrayBufferTag$3] = typedArrayTags[boolTag$3] =
typedArrayTags[dataViewTag$4] = typedArrayTags[dateTag$3] =
typedArrayTags[errorTag$2] = typedArrayTags[funcTag$1] =
typedArrayTags[mapTag$5] = typedArrayTags[numberTag$3] =
typedArrayTags[objectTag$4] = typedArrayTags[regexpTag$3] =
typedArrayTags[setTag$5] = typedArrayTags[stringTag$3] =
typedArrayTags[weakMapTag$2] = false;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray$1(value) {
  return isObjectLike$6(value) &&
    isLength$1(value.length) && !!typedArrayTags[baseGetTag$2(value)];
}

var _baseIsTypedArray = baseIsTypedArray$1;

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */

function baseUnary$3(func) {
  return function(value) {
    return func(value);
  };
}

var _baseUnary = baseUnary$3;

var _nodeUtil = {exports: {}};

_nodeUtil.exports;

(function (module, exports) {
	var freeGlobal = _freeGlobal;

	/** Detect free variable `exports`. */
	var freeExports = exports && !exports.nodeType && exports;

	/** Detect free variable `module`. */
	var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

	/** Detect the popular CommonJS extension `module.exports`. */
	var moduleExports = freeModule && freeModule.exports === freeExports;

	/** Detect free variable `process` from Node.js. */
	var freeProcess = moduleExports && freeGlobal.process;

	/** Used to access faster Node.js helpers. */
	var nodeUtil = (function() {
	  try {
	    // Use `util.types` for Node.js 10+.
	    var types = freeModule && freeModule.require && freeModule.require('util').types;

	    if (types) {
	      return types;
	    }

	    // Legacy `process.binding('util')` for Node.js < 10.
	    return freeProcess && freeProcess.binding && freeProcess.binding('util');
	  } catch (e) {}
	}());

	module.exports = nodeUtil; 
} (_nodeUtil, _nodeUtil.exports));

var _nodeUtilExports = _nodeUtil.exports;

var baseIsTypedArray = _baseIsTypedArray,
    baseUnary$2 = _baseUnary,
    nodeUtil$2 = _nodeUtilExports;

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil$2 && nodeUtil$2.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray$3 = nodeIsTypedArray ? baseUnary$2(nodeIsTypedArray) : baseIsTypedArray;

var isTypedArray_1 = isTypedArray$3;

var baseTimes = _baseTimes,
    isArguments$1 = isArguments_1,
    isArray$5 = isArray_1,
    isBuffer$3 = isBufferExports,
    isIndex$1 = _isIndex,
    isTypedArray$2 = isTypedArray_1;

/** Used for built-in method references. */
var objectProto$8 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$6 = objectProto$8.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys$2(value, inherited) {
  var isArr = isArray$5(value),
      isArg = !isArr && isArguments$1(value),
      isBuff = !isArr && !isArg && isBuffer$3(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray$2(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty$6.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex$1(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

var _arrayLikeKeys = arrayLikeKeys$2;

/** Used for built-in method references. */

var objectProto$7 = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype$3(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto$7;

  return value === proto;
}

var _isPrototype = isPrototype$3;

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */

function overArg$2(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

var _overArg = overArg$2;

var overArg$1 = _overArg;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys$1 = overArg$1(Object.keys, Object);

var _nativeKeys = nativeKeys$1;

var isPrototype$2 = _isPrototype,
    nativeKeys = _nativeKeys;

/** Used for built-in method references. */
var objectProto$6 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$5 = objectProto$6.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys$1(object) {
  if (!isPrototype$2(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$5.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

var _baseKeys = baseKeys$1;

var isFunction$2 = isFunction_1,
    isLength = isLength_1;

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike$4(value) {
  return value != null && isLength(value.length) && !isFunction$2(value);
}

var isArrayLike_1 = isArrayLike$4;

var arrayLikeKeys$1 = _arrayLikeKeys,
    baseKeys = _baseKeys,
    isArrayLike$3 = isArrayLike_1;

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys$3(object) {
  return isArrayLike$3(object) ? arrayLikeKeys$1(object) : baseKeys(object);
}

var keys_1 = keys$3;

var copyObject$4 = _copyObject,
    keys$2 = keys_1;

/**
 * The base implementation of `_.assign` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssign$1(object, source) {
  return object && copyObject$4(source, keys$2(source), object);
}

var _baseAssign = baseAssign$1;

/**
 * This function is like
 * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * except that it includes inherited enumerable properties.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */

function nativeKeysIn$1(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}

var _nativeKeysIn = nativeKeysIn$1;

var isObject$6 = isObject_1,
    isPrototype$1 = _isPrototype,
    nativeKeysIn = _nativeKeysIn;

/** Used for built-in method references. */
var objectProto$5 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$4 = objectProto$5.hasOwnProperty;

/**
 * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeysIn$1(object) {
  if (!isObject$6(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype$1(object),
      result = [];

  for (var key in object) {
    if (!(key == 'constructor' && (isProto || !hasOwnProperty$4.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}

var _baseKeysIn = baseKeysIn$1;

var arrayLikeKeys = _arrayLikeKeys,
    baseKeysIn = _baseKeysIn,
    isArrayLike$2 = isArrayLike_1;

/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keysIn(new Foo);
 * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
 */
function keysIn$5(object) {
  return isArrayLike$2(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}

var keysIn_1 = keysIn$5;

var copyObject$3 = _copyObject,
    keysIn$4 = keysIn_1;

/**
 * The base implementation of `_.assignIn` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssignIn$1(object, source) {
  return object && copyObject$3(source, keysIn$4(source), object);
}

var _baseAssignIn = baseAssignIn$1;

var _cloneBuffer = {exports: {}};

_cloneBuffer.exports;

(function (module, exports) {
	var root = _root;

	/** Detect free variable `exports`. */
	var freeExports = exports && !exports.nodeType && exports;

	/** Detect free variable `module`. */
	var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

	/** Detect the popular CommonJS extension `module.exports`. */
	var moduleExports = freeModule && freeModule.exports === freeExports;

	/** Built-in value references. */
	var Buffer = moduleExports ? root.Buffer : undefined,
	    allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined;

	/**
	 * Creates a clone of  `buffer`.
	 *
	 * @private
	 * @param {Buffer} buffer The buffer to clone.
	 * @param {boolean} [isDeep] Specify a deep clone.
	 * @returns {Buffer} Returns the cloned buffer.
	 */
	function cloneBuffer(buffer, isDeep) {
	  if (isDeep) {
	    return buffer.slice();
	  }
	  var length = buffer.length,
	      result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

	  buffer.copy(result);
	  return result;
	}

	module.exports = cloneBuffer; 
} (_cloneBuffer, _cloneBuffer.exports));

var _cloneBufferExports = _cloneBuffer.exports;

/**
 * Copies the values of `source` to `array`.
 *
 * @private
 * @param {Array} source The array to copy values from.
 * @param {Array} [array=[]] The array to copy values to.
 * @returns {Array} Returns `array`.
 */

function copyArray$2(source, array) {
  var index = -1,
      length = source.length;

  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}

var _copyArray = copyArray$2;

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */

function arrayFilter$1(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

var _arrayFilter = arrayFilter$1;

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */

function stubArray$2() {
  return [];
}

var stubArray_1 = stubArray$2;

var arrayFilter = _arrayFilter,
    stubArray$1 = stubArray_1;

/** Used for built-in method references. */
var objectProto$4 = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable = objectProto$4.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols$1 = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols$3 = !nativeGetSymbols$1 ? stubArray$1 : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols$1(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

var _getSymbols = getSymbols$3;

var copyObject$2 = _copyObject,
    getSymbols$2 = _getSymbols;

/**
 * Copies own symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbols$1(source, object) {
  return copyObject$2(source, getSymbols$2(source), object);
}

var _copySymbols = copySymbols$1;

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */

function arrayPush$2(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

var _arrayPush = arrayPush$2;

var overArg = _overArg;

/** Built-in value references. */
var getPrototype$3 = overArg(Object.getPrototypeOf, Object);

var _getPrototype = getPrototype$3;

var arrayPush$1 = _arrayPush,
    getPrototype$2 = _getPrototype,
    getSymbols$1 = _getSymbols,
    stubArray = stubArray_1;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own and inherited enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbolsIn$2 = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush$1(result, getSymbols$1(object));
    object = getPrototype$2(object);
  }
  return result;
};

var _getSymbolsIn = getSymbolsIn$2;

var copyObject$1 = _copyObject,
    getSymbolsIn$1 = _getSymbolsIn;

/**
 * Copies own and inherited symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbolsIn$1(source, object) {
  return copyObject$1(source, getSymbolsIn$1(source), object);
}

var _copySymbolsIn = copySymbolsIn$1;

var arrayPush = _arrayPush,
    isArray$4 = isArray_1;

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys$2(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray$4(object) ? result : arrayPush(result, symbolsFunc(object));
}

var _baseGetAllKeys = baseGetAllKeys$2;

var baseGetAllKeys$1 = _baseGetAllKeys,
    getSymbols = _getSymbols,
    keys$1 = keys_1;

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys$2(object) {
  return baseGetAllKeys$1(object, keys$1, getSymbols);
}

var _getAllKeys = getAllKeys$2;

var baseGetAllKeys = _baseGetAllKeys,
    getSymbolsIn = _getSymbolsIn,
    keysIn$3 = keysIn_1;

/**
 * Creates an array of own and inherited enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeysIn$1(object) {
  return baseGetAllKeys(object, keysIn$3, getSymbolsIn);
}

var _getAllKeysIn = getAllKeysIn$1;

var getNative$3 = _getNative,
    root$4 = _root;

/* Built-in method references that are verified to be native. */
var DataView$1 = getNative$3(root$4, 'DataView');

var _DataView = DataView$1;

var getNative$2 = _getNative,
    root$3 = _root;

/* Built-in method references that are verified to be native. */
var Promise$2 = getNative$2(root$3, 'Promise');

var _Promise = Promise$2;

var getNative$1 = _getNative,
    root$2 = _root;

/* Built-in method references that are verified to be native. */
var Set$2 = getNative$1(root$2, 'Set');

var _Set = Set$2;

var getNative = _getNative,
    root$1 = _root;

/* Built-in method references that are verified to be native. */
var WeakMap$2 = getNative(root$1, 'WeakMap');

var _WeakMap = WeakMap$2;

var DataView = _DataView,
    Map$2 = _Map,
    Promise$1 = _Promise,
    Set$1 = _Set,
    WeakMap$1 = _WeakMap,
    baseGetTag$1 = _baseGetTag,
    toSource = _toSource;

/** `Object#toString` result references. */
var mapTag$4 = '[object Map]',
    objectTag$3 = '[object Object]',
    promiseTag = '[object Promise]',
    setTag$4 = '[object Set]',
    weakMapTag$1 = '[object WeakMap]';

var dataViewTag$3 = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map$2),
    promiseCtorString = toSource(Promise$1),
    setCtorString = toSource(Set$1),
    weakMapCtorString = toSource(WeakMap$1);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag$4 = baseGetTag$1;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag$4(new DataView(new ArrayBuffer(1))) != dataViewTag$3) ||
    (Map$2 && getTag$4(new Map$2) != mapTag$4) ||
    (Promise$1 && getTag$4(Promise$1.resolve()) != promiseTag) ||
    (Set$1 && getTag$4(new Set$1) != setTag$4) ||
    (WeakMap$1 && getTag$4(new WeakMap$1) != weakMapTag$1)) {
  getTag$4 = function(value) {
    var result = baseGetTag$1(value),
        Ctor = result == objectTag$3 ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag$3;
        case mapCtorString: return mapTag$4;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag$4;
        case weakMapCtorString: return weakMapTag$1;
      }
    }
    return result;
  };
}

var _getTag = getTag$4;

/** Used for built-in method references. */

var objectProto$3 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$3 = objectProto$3.hasOwnProperty;

/**
 * Initializes an array clone.
 *
 * @private
 * @param {Array} array The array to clone.
 * @returns {Array} Returns the initialized clone.
 */
function initCloneArray$1(array) {
  var length = array.length,
      result = new array.constructor(length);

  // Add properties assigned by `RegExp#exec`.
  if (length && typeof array[0] == 'string' && hasOwnProperty$3.call(array, 'index')) {
    result.index = array.index;
    result.input = array.input;
  }
  return result;
}

var _initCloneArray = initCloneArray$1;

var root = _root;

/** Built-in value references. */
var Uint8Array$3 = root.Uint8Array;

var _Uint8Array = Uint8Array$3;

var Uint8Array$2 = _Uint8Array;

/**
 * Creates a clone of `arrayBuffer`.
 *
 * @private
 * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
 * @returns {ArrayBuffer} Returns the cloned array buffer.
 */
function cloneArrayBuffer$3(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array$2(result).set(new Uint8Array$2(arrayBuffer));
  return result;
}

var _cloneArrayBuffer = cloneArrayBuffer$3;

var cloneArrayBuffer$2 = _cloneArrayBuffer;

/**
 * Creates a clone of `dataView`.
 *
 * @private
 * @param {Object} dataView The data view to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned data view.
 */
function cloneDataView$1(dataView, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer$2(dataView.buffer) : dataView.buffer;
  return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}

var _cloneDataView = cloneDataView$1;

/** Used to match `RegExp` flags from their coerced string values. */

var reFlags = /\w*$/;

/**
 * Creates a clone of `regexp`.
 *
 * @private
 * @param {Object} regexp The regexp to clone.
 * @returns {Object} Returns the cloned regexp.
 */
function cloneRegExp$1(regexp) {
  var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
  result.lastIndex = regexp.lastIndex;
  return result;
}

var _cloneRegExp = cloneRegExp$1;

var Symbol$2 = _Symbol;

/** Used to convert symbols to primitives and strings. */
var symbolProto$1 = Symbol$2 ? Symbol$2.prototype : undefined,
    symbolValueOf$1 = symbolProto$1 ? symbolProto$1.valueOf : undefined;

/**
 * Creates a clone of the `symbol` object.
 *
 * @private
 * @param {Object} symbol The symbol object to clone.
 * @returns {Object} Returns the cloned symbol object.
 */
function cloneSymbol$1(symbol) {
  return symbolValueOf$1 ? Object(symbolValueOf$1.call(symbol)) : {};
}

var _cloneSymbol = cloneSymbol$1;

var cloneArrayBuffer$1 = _cloneArrayBuffer;

/**
 * Creates a clone of `typedArray`.
 *
 * @private
 * @param {Object} typedArray The typed array to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned typed array.
 */
function cloneTypedArray$2(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer$1(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}

var _cloneTypedArray = cloneTypedArray$2;

var cloneArrayBuffer = _cloneArrayBuffer,
    cloneDataView = _cloneDataView,
    cloneRegExp = _cloneRegExp,
    cloneSymbol = _cloneSymbol,
    cloneTypedArray$1 = _cloneTypedArray;

/** `Object#toString` result references. */
var boolTag$2 = '[object Boolean]',
    dateTag$2 = '[object Date]',
    mapTag$3 = '[object Map]',
    numberTag$2 = '[object Number]',
    regexpTag$2 = '[object RegExp]',
    setTag$3 = '[object Set]',
    stringTag$2 = '[object String]',
    symbolTag$2 = '[object Symbol]';

var arrayBufferTag$2 = '[object ArrayBuffer]',
    dataViewTag$2 = '[object DataView]',
    float32Tag$1 = '[object Float32Array]',
    float64Tag$1 = '[object Float64Array]',
    int8Tag$1 = '[object Int8Array]',
    int16Tag$1 = '[object Int16Array]',
    int32Tag$1 = '[object Int32Array]',
    uint8Tag$1 = '[object Uint8Array]',
    uint8ClampedTag$1 = '[object Uint8ClampedArray]',
    uint16Tag$1 = '[object Uint16Array]',
    uint32Tag$1 = '[object Uint32Array]';

/**
 * Initializes an object clone based on its `toStringTag`.
 *
 * **Note:** This function only supports cloning values with tags of
 * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
 *
 * @private
 * @param {Object} object The object to clone.
 * @param {string} tag The `toStringTag` of the object to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneByTag$1(object, tag, isDeep) {
  var Ctor = object.constructor;
  switch (tag) {
    case arrayBufferTag$2:
      return cloneArrayBuffer(object);

    case boolTag$2:
    case dateTag$2:
      return new Ctor(+object);

    case dataViewTag$2:
      return cloneDataView(object, isDeep);

    case float32Tag$1: case float64Tag$1:
    case int8Tag$1: case int16Tag$1: case int32Tag$1:
    case uint8Tag$1: case uint8ClampedTag$1: case uint16Tag$1: case uint32Tag$1:
      return cloneTypedArray$1(object, isDeep);

    case mapTag$3:
      return new Ctor;

    case numberTag$2:
    case stringTag$2:
      return new Ctor(object);

    case regexpTag$2:
      return cloneRegExp(object);

    case setTag$3:
      return new Ctor;

    case symbolTag$2:
      return cloneSymbol(object);
  }
}

var _initCloneByTag = initCloneByTag$1;

var isObject$5 = isObject_1;

/** Built-in value references. */
var objectCreate = Object.create;

/**
 * The base implementation of `_.create` without support for assigning
 * properties to the created object.
 *
 * @private
 * @param {Object} proto The object to inherit from.
 * @returns {Object} Returns the new object.
 */
var baseCreate$1 = (function() {
  function object() {}
  return function(proto) {
    if (!isObject$5(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object.prototype = proto;
    var result = new object;
    object.prototype = undefined;
    return result;
  };
}());

var _baseCreate = baseCreate$1;

var baseCreate = _baseCreate,
    getPrototype$1 = _getPrototype,
    isPrototype = _isPrototype;

/**
 * Initializes an object clone.
 *
 * @private
 * @param {Object} object The object to clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneObject$2(object) {
  return (typeof object.constructor == 'function' && !isPrototype(object))
    ? baseCreate(getPrototype$1(object))
    : {};
}

var _initCloneObject = initCloneObject$2;

var getTag$3 = _getTag,
    isObjectLike$5 = isObjectLike_1;

/** `Object#toString` result references. */
var mapTag$2 = '[object Map]';

/**
 * The base implementation of `_.isMap` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 */
function baseIsMap$1(value) {
  return isObjectLike$5(value) && getTag$3(value) == mapTag$2;
}

var _baseIsMap = baseIsMap$1;

var baseIsMap = _baseIsMap,
    baseUnary$1 = _baseUnary,
    nodeUtil$1 = _nodeUtilExports;

/* Node.js helper references. */
var nodeIsMap = nodeUtil$1 && nodeUtil$1.isMap;

/**
 * Checks if `value` is classified as a `Map` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 * @example
 *
 * _.isMap(new Map);
 * // => true
 *
 * _.isMap(new WeakMap);
 * // => false
 */
var isMap$1 = nodeIsMap ? baseUnary$1(nodeIsMap) : baseIsMap;

var isMap_1 = isMap$1;

var getTag$2 = _getTag,
    isObjectLike$4 = isObjectLike_1;

/** `Object#toString` result references. */
var setTag$2 = '[object Set]';

/**
 * The base implementation of `_.isSet` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 */
function baseIsSet$1(value) {
  return isObjectLike$4(value) && getTag$2(value) == setTag$2;
}

var _baseIsSet = baseIsSet$1;

var baseIsSet = _baseIsSet,
    baseUnary = _baseUnary,
    nodeUtil = _nodeUtilExports;

/* Node.js helper references. */
var nodeIsSet = nodeUtil && nodeUtil.isSet;

/**
 * Checks if `value` is classified as a `Set` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 * @example
 *
 * _.isSet(new Set);
 * // => true
 *
 * _.isSet(new WeakSet);
 * // => false
 */
var isSet$1 = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

var isSet_1 = isSet$1;

var Stack$2 = _Stack,
    arrayEach = _arrayEach,
    assignValue = _assignValue,
    baseAssign = _baseAssign,
    baseAssignIn = _baseAssignIn,
    cloneBuffer$1 = _cloneBufferExports,
    copyArray$1 = _copyArray,
    copySymbols = _copySymbols,
    copySymbolsIn = _copySymbolsIn,
    getAllKeys$1 = _getAllKeys,
    getAllKeysIn = _getAllKeysIn,
    getTag$1 = _getTag,
    initCloneArray = _initCloneArray,
    initCloneByTag = _initCloneByTag,
    initCloneObject$1 = _initCloneObject,
    isArray$3 = isArray_1,
    isBuffer$2 = isBufferExports,
    isMap = isMap_1,
    isObject$4 = isObject_1,
    isSet = isSet_1,
    keys = keys_1,
    keysIn$2 = keysIn_1;

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG$2 = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG$2 = 4;

/** `Object#toString` result references. */
var argsTag$1 = '[object Arguments]',
    arrayTag$1 = '[object Array]',
    boolTag$1 = '[object Boolean]',
    dateTag$1 = '[object Date]',
    errorTag$1 = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag$1 = '[object Map]',
    numberTag$1 = '[object Number]',
    objectTag$2 = '[object Object]',
    regexpTag$1 = '[object RegExp]',
    setTag$1 = '[object Set]',
    stringTag$1 = '[object String]',
    symbolTag$1 = '[object Symbol]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag$1 = '[object ArrayBuffer]',
    dataViewTag$1 = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values supported by `_.clone`. */
var cloneableTags = {};
cloneableTags[argsTag$1] = cloneableTags[arrayTag$1] =
cloneableTags[arrayBufferTag$1] = cloneableTags[dataViewTag$1] =
cloneableTags[boolTag$1] = cloneableTags[dateTag$1] =
cloneableTags[float32Tag] = cloneableTags[float64Tag] =
cloneableTags[int8Tag] = cloneableTags[int16Tag] =
cloneableTags[int32Tag] = cloneableTags[mapTag$1] =
cloneableTags[numberTag$1] = cloneableTags[objectTag$2] =
cloneableTags[regexpTag$1] = cloneableTags[setTag$1] =
cloneableTags[stringTag$1] = cloneableTags[symbolTag$1] =
cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
cloneableTags[errorTag$1] = cloneableTags[funcTag] =
cloneableTags[weakMapTag] = false;

/**
 * The base implementation of `_.clone` and `_.cloneDeep` which tracks
 * traversed objects.
 *
 * @private
 * @param {*} value The value to clone.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Deep clone
 *  2 - Flatten inherited properties
 *  4 - Clone symbols
 * @param {Function} [customizer] The function to customize cloning.
 * @param {string} [key] The key of `value`.
 * @param {Object} [object] The parent object of `value`.
 * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
 * @returns {*} Returns the cloned value.
 */
function baseClone$2(value, bitmask, customizer, key, object, stack) {
  var result,
      isDeep = bitmask & CLONE_DEEP_FLAG$2,
      isFlat = bitmask & CLONE_FLAT_FLAG,
      isFull = bitmask & CLONE_SYMBOLS_FLAG$2;

  if (customizer) {
    result = object ? customizer(value, key, object, stack) : customizer(value);
  }
  if (result !== undefined) {
    return result;
  }
  if (!isObject$4(value)) {
    return value;
  }
  var isArr = isArray$3(value);
  if (isArr) {
    result = initCloneArray(value);
    if (!isDeep) {
      return copyArray$1(value, result);
    }
  } else {
    var tag = getTag$1(value),
        isFunc = tag == funcTag || tag == genTag;

    if (isBuffer$2(value)) {
      return cloneBuffer$1(value, isDeep);
    }
    if (tag == objectTag$2 || tag == argsTag$1 || (isFunc && !object)) {
      result = (isFlat || isFunc) ? {} : initCloneObject$1(value);
      if (!isDeep) {
        return isFlat
          ? copySymbolsIn(value, baseAssignIn(result, value))
          : copySymbols(value, baseAssign(result, value));
      }
    } else {
      if (!cloneableTags[tag]) {
        return object ? value : {};
      }
      result = initCloneByTag(value, tag, isDeep);
    }
  }
  // Check for circular references and return its corresponding clone.
  stack || (stack = new Stack$2);
  var stacked = stack.get(value);
  if (stacked) {
    return stacked;
  }
  stack.set(value, result);

  if (isSet(value)) {
    value.forEach(function(subValue) {
      result.add(baseClone$2(subValue, bitmask, customizer, subValue, value, stack));
    });
  } else if (isMap(value)) {
    value.forEach(function(subValue, key) {
      result.set(key, baseClone$2(subValue, bitmask, customizer, key, value, stack));
    });
  }

  var keysFunc = isFull
    ? (isFlat ? getAllKeysIn : getAllKeys$1)
    : (isFlat ? keysIn$2 : keys);

  var props = isArr ? undefined : keysFunc(value);
  arrayEach(props || value, function(subValue, key) {
    if (props) {
      key = subValue;
      subValue = value[key];
    }
    // Recursively populate clone (susceptible to call stack limits).
    assignValue(result, key, baseClone$2(subValue, bitmask, customizer, key, value, stack));
  });
  return result;
}

var _baseClone = baseClone$2;

var baseClone$1 = _baseClone;

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG$1 = 1,
    CLONE_SYMBOLS_FLAG$1 = 4;

/**
 * This method is like `_.clone` except that it recursively clones `value`.
 *
 * @static
 * @memberOf _
 * @since 1.0.0
 * @category Lang
 * @param {*} value The value to recursively clone.
 * @returns {*} Returns the deep cloned value.
 * @see _.clone
 * @example
 *
 * var objects = [{ 'a': 1 }, { 'b': 2 }];
 *
 * var deep = _.cloneDeep(objects);
 * console.log(deep[0] === objects[0]);
 * // => false
 */
function cloneDeep(value) {
  return baseClone$1(value, CLONE_DEEP_FLAG$1 | CLONE_SYMBOLS_FLAG$1);
}

var cloneDeep_1 = cloneDeep;

var cloneDeep$1 = /*@__PURE__*/getDefaultExportFromCjs(cloneDeep_1);

var baseAssignValue = _baseAssignValue,
    eq$2 = eq_1;

/**
 * This function is like `assignValue` except that it doesn't assign
 * `undefined` values.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignMergeValue$2(object, key, value) {
  if ((value !== undefined && !eq$2(object[key], value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue(object, key, value);
  }
}

var _assignMergeValue = assignMergeValue$2;

/**
 * Creates a base function for methods like `_.forIn` and `_.forOwn`.
 *
 * @private
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */

function createBaseFor$1(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;

    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}

var _createBaseFor = createBaseFor$1;

var createBaseFor = _createBaseFor;

/**
 * The base implementation of `baseForOwn` which iterates over `object`
 * properties returned by `keysFunc` and invokes `iteratee` for each property.
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @returns {Object} Returns `object`.
 */
var baseFor$1 = createBaseFor();

var _baseFor = baseFor$1;

var isArrayLike$1 = isArrayLike_1,
    isObjectLike$3 = isObjectLike_1;

/**
 * This method is like `_.isArrayLike` except that it also checks if `value`
 * is an object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array-like object,
 *  else `false`.
 * @example
 *
 * _.isArrayLikeObject([1, 2, 3]);
 * // => true
 *
 * _.isArrayLikeObject(document.body.children);
 * // => true
 *
 * _.isArrayLikeObject('abc');
 * // => false
 *
 * _.isArrayLikeObject(_.noop);
 * // => false
 */
function isArrayLikeObject$1(value) {
  return isObjectLike$3(value) && isArrayLike$1(value);
}

var isArrayLikeObject_1 = isArrayLikeObject$1;

var baseGetTag = _baseGetTag,
    getPrototype = _getPrototype,
    isObjectLike$2 = isObjectLike_1;

/** `Object#toString` result references. */
var objectTag$1 = '[object Object]';

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto$2 = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty$2 = objectProto$2.hasOwnProperty;

/** Used to infer the `Object` constructor. */
var objectCtorString = funcToString.call(Object);

/**
 * Checks if `value` is a plain object, that is, an object created by the
 * `Object` constructor or one with a `[[Prototype]]` of `null`.
 *
 * @static
 * @memberOf _
 * @since 0.8.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * _.isPlainObject(new Foo);
 * // => false
 *
 * _.isPlainObject([1, 2, 3]);
 * // => false
 *
 * _.isPlainObject({ 'x': 0, 'y': 0 });
 * // => true
 *
 * _.isPlainObject(Object.create(null));
 * // => true
 */
function isPlainObject$3(value) {
  if (!isObjectLike$2(value) || baseGetTag(value) != objectTag$1) {
    return false;
  }
  var proto = getPrototype(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty$2.call(proto, 'constructor') && proto.constructor;
  return typeof Ctor == 'function' && Ctor instanceof Ctor &&
    funcToString.call(Ctor) == objectCtorString;
}

var isPlainObject_1 = isPlainObject$3;

/**
 * Gets the value at `key`, unless `key` is "__proto__" or "constructor".
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */

function safeGet$3(object, key) {
  if (key === 'constructor' && typeof object[key] === 'function') {
    return;
  }

  if (key == '__proto__') {
    return;
  }

  return object[key];
}

var _safeGet = safeGet$3;

var copyObject = _copyObject,
    keysIn$1 = keysIn_1;

/**
 * Converts `value` to a plain object flattening inherited enumerable string
 * keyed properties of `value` to own properties of the plain object.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {Object} Returns the converted plain object.
 * @example
 *
 * function Foo() {
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.assign({ 'a': 1 }, new Foo);
 * // => { 'a': 1, 'b': 2 }
 *
 * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));
 * // => { 'a': 1, 'b': 2, 'c': 3 }
 */
function toPlainObject$1(value) {
  return copyObject(value, keysIn$1(value));
}

var toPlainObject_1 = toPlainObject$1;

var assignMergeValue$1 = _assignMergeValue,
    cloneBuffer = _cloneBufferExports,
    cloneTypedArray = _cloneTypedArray,
    copyArray = _copyArray,
    initCloneObject = _initCloneObject,
    isArguments = isArguments_1,
    isArray$2 = isArray_1,
    isArrayLikeObject = isArrayLikeObject_1,
    isBuffer$1 = isBufferExports,
    isFunction$1 = isFunction_1,
    isObject$3 = isObject_1,
    isPlainObject$2 = isPlainObject_1,
    isTypedArray$1 = isTypedArray_1,
    safeGet$2 = _safeGet,
    toPlainObject = toPlainObject_1;

/**
 * A specialized version of `baseMerge` for arrays and objects which performs
 * deep merges and tracks traversed objects enabling objects with circular
 * references to be merged.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @param {string} key The key of the value to merge.
 * @param {number} srcIndex The index of `source`.
 * @param {Function} mergeFunc The function to merge values.
 * @param {Function} [customizer] The function to customize assigned values.
 * @param {Object} [stack] Tracks traversed source values and their merged
 *  counterparts.
 */
function baseMergeDeep$1(object, source, key, srcIndex, mergeFunc, customizer, stack) {
  var objValue = safeGet$2(object, key),
      srcValue = safeGet$2(source, key),
      stacked = stack.get(srcValue);

  if (stacked) {
    assignMergeValue$1(object, key, stacked);
    return;
  }
  var newValue = customizer
    ? customizer(objValue, srcValue, (key + ''), object, source, stack)
    : undefined;

  var isCommon = newValue === undefined;

  if (isCommon) {
    var isArr = isArray$2(srcValue),
        isBuff = !isArr && isBuffer$1(srcValue),
        isTyped = !isArr && !isBuff && isTypedArray$1(srcValue);

    newValue = srcValue;
    if (isArr || isBuff || isTyped) {
      if (isArray$2(objValue)) {
        newValue = objValue;
      }
      else if (isArrayLikeObject(objValue)) {
        newValue = copyArray(objValue);
      }
      else if (isBuff) {
        isCommon = false;
        newValue = cloneBuffer(srcValue, true);
      }
      else if (isTyped) {
        isCommon = false;
        newValue = cloneTypedArray(srcValue, true);
      }
      else {
        newValue = [];
      }
    }
    else if (isPlainObject$2(srcValue) || isArguments(srcValue)) {
      newValue = objValue;
      if (isArguments(objValue)) {
        newValue = toPlainObject(objValue);
      }
      else if (!isObject$3(objValue) || isFunction$1(objValue)) {
        newValue = initCloneObject(srcValue);
      }
    }
    else {
      isCommon = false;
    }
  }
  if (isCommon) {
    // Recursively merge objects and arrays (susceptible to call stack limits).
    stack.set(srcValue, newValue);
    mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
    stack['delete'](srcValue);
  }
  assignMergeValue$1(object, key, newValue);
}

var _baseMergeDeep = baseMergeDeep$1;

var Stack$1 = _Stack,
    assignMergeValue = _assignMergeValue,
    baseFor = _baseFor,
    baseMergeDeep = _baseMergeDeep,
    isObject$2 = isObject_1,
    keysIn = keysIn_1,
    safeGet$1 = _safeGet;

/**
 * The base implementation of `_.merge` without support for multiple sources.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @param {number} srcIndex The index of `source`.
 * @param {Function} [customizer] The function to customize merged values.
 * @param {Object} [stack] Tracks traversed source values and their merged
 *  counterparts.
 */
function baseMerge$1(object, source, srcIndex, customizer, stack) {
  if (object === source) {
    return;
  }
  baseFor(source, function(srcValue, key) {
    stack || (stack = new Stack$1);
    if (isObject$2(srcValue)) {
      baseMergeDeep(object, source, key, srcIndex, baseMerge$1, customizer, stack);
    }
    else {
      var newValue = customizer
        ? customizer(safeGet$1(object, key), srcValue, (key + ''), object, source, stack)
        : undefined;

      if (newValue === undefined) {
        newValue = srcValue;
      }
      assignMergeValue(object, key, newValue);
    }
  }, keysIn);
}

var _baseMerge = baseMerge$1;

/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */

function identity$2(value) {
  return value;
}

var identity_1 = identity$2;

/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */

function apply$1(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}

var _apply = apply$1;

var apply = _apply;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * A specialized version of `baseRest` which transforms the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @param {Function} transform The rest array transform.
 * @returns {Function} Returns the new function.
 */
function overRest$1(func, start, transform) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);

    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return apply(func, this, otherArgs);
  };
}

var _overRest = overRest$1;

/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */

function constant$1(value) {
  return function() {
    return value;
  };
}

var constant_1 = constant$1;

var constant = constant_1,
    defineProperty = _defineProperty,
    identity$1 = identity_1;

/**
 * The base implementation of `setToString` without support for hot loop shorting.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var baseSetToString$1 = !defineProperty ? identity$1 : function(func, string) {
  return defineProperty(func, 'toString', {
    'configurable': true,
    'enumerable': false,
    'value': constant(string),
    'writable': true
  });
};

var _baseSetToString = baseSetToString$1;

/** Used to detect hot functions by number of calls within a span of milliseconds. */

var HOT_COUNT = 800,
    HOT_SPAN = 16;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeNow = Date.now;

/**
 * Creates a function that'll short out and invoke `identity` instead
 * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
 * milliseconds.
 *
 * @private
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new shortable function.
 */
function shortOut$1(func) {
  var count = 0,
      lastCalled = 0;

  return function() {
    var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);

    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(undefined, arguments);
  };
}

var _shortOut = shortOut$1;

var baseSetToString = _baseSetToString,
    shortOut = _shortOut;

/**
 * Sets the `toString` method of `func` to return `string`.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var setToString$1 = shortOut(baseSetToString);

var _setToString = setToString$1;

var identity = identity_1,
    overRest = _overRest,
    setToString = _setToString;

/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest$1(func, start) {
  return setToString(overRest(func, start, identity), func + '');
}

var _baseRest = baseRest$1;

var eq$1 = eq_1,
    isArrayLike = isArrayLike_1,
    isIndex = _isIndex,
    isObject$1 = isObject_1;

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall$1(value, index, object) {
  if (!isObject$1(object)) {
    return false;
  }
  var type = typeof index;
  if (type == 'number'
        ? (isArrayLike(object) && isIndex(index, object.length))
        : (type == 'string' && index in object)
      ) {
    return eq$1(object[index], value);
  }
  return false;
}

var _isIterateeCall = isIterateeCall$1;

var baseRest = _baseRest,
    isIterateeCall = _isIterateeCall;

/**
 * Creates a function like `_.assign`.
 *
 * @private
 * @param {Function} assigner The function to assign values.
 * @returns {Function} Returns the new assigner function.
 */
function createAssigner$1(assigner) {
  return baseRest(function(object, sources) {
    var index = -1,
        length = sources.length,
        customizer = length > 1 ? sources[length - 1] : undefined,
        guard = length > 2 ? sources[2] : undefined;

    customizer = (assigner.length > 3 && typeof customizer == 'function')
      ? (length--, customizer)
      : undefined;

    if (guard && isIterateeCall(sources[0], sources[1], guard)) {
      customizer = length < 3 ? undefined : customizer;
      length = 1;
    }
    object = Object(object);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object, source, index, customizer);
      }
    }
    return object;
  });
}

var _createAssigner = createAssigner$1;

var baseMerge = _baseMerge,
    createAssigner = _createAssigner;

/**
 * This method is like `_.assign` except that it recursively merges own and
 * inherited enumerable string keyed properties of source objects into the
 * destination object. Source properties that resolve to `undefined` are
 * skipped if a destination value exists. Array and plain object properties
 * are merged recursively. Other objects and value types are overridden by
 * assignment. Source objects are applied from left to right. Subsequent
 * sources overwrite property assignments of previous sources.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 0.5.0
 * @category Object
 * @param {Object} object The destination object.
 * @param {...Object} [sources] The source objects.
 * @returns {Object} Returns `object`.
 * @example
 *
 * var object = {
 *   'a': [{ 'b': 2 }, { 'd': 4 }]
 * };
 *
 * var other = {
 *   'a': [{ 'c': 3 }, { 'e': 5 }]
 * };
 *
 * _.merge(object, other);
 * // => { 'a': [{ 'b': 2, 'c': 3 }, { 'd': 4, 'e': 5 }] }
 */
var merge = createAssigner(function(object, source, srcIndex) {
  baseMerge(object, source, srcIndex);
});

var merge_1 = merge;

var merge$1 = /*@__PURE__*/getDefaultExportFromCjs(merge_1);

var __extends$1e = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a StyleControl object.
 */
var StyleControlOptions = /** @class */ (function (_super) {
    __extends$1e(StyleControlOptions, _super);
    function StyleControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The layout to display the styles in.<br />
         * `"icons"`: A row of clickable icons for each style.<br />
         * `"list"`: A scrollable list with the icons and names for each style.<br />
         * Default `"icons"`
         * @default "icons"
         */
        _this.layout = "icons";
        /**
         * The map styles to show in the control.
         * Style names are case sensitive.
         * If an included style isn't supported by the map it will be ignored.
         * Available styles can be found in the
         * [supported styles]{@link https://docs.microsoft.com/en-us/azure/azure-maps/supported-map-styles} article.
         * If "all" is specified, all map styles will be shown.
         * Default `["road", "grayscale_light", "grayscale_dark", "night", "road_shaded_relief"]`
         * @default ["road", "grayscale_light", "grayscale_dark", "night", "road_shaded_relief"]
         */
        _this.mapStyles = [
            "road",
            "grayscale_light",
            "grayscale_dark",
            "night",
            "road_shaded_relief",
        ];
        /**
         * The style of the control.
         * Default `ControlStyle.light`.
         * @default ControlStyle.light
         */
        _this.style = ControlStyle.light;
        /**
         * Whether to let style control automatically set the style, once user select a map style.
         * If set to `false`, then clicking on style will not set the set the style automatically.
         * Default `true`
         */
        _this.autoSelectionMode = true;
        return _this;
    }
    return StyleControlOptions;
}(Options));

var __extends$1d = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$7 = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$7 = (window && window.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read$f = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
/**
 * A control for changing the style of the map.
 */
var StyleControl = /** @class */ (function (_super) {
    __extends$1d(StyleControl, _super);
    /**
     * Constructs a StyleControl.
     * @param options The options for the control.
     */
    function StyleControl(options) {
        var _this = _super.call(this) || this;
        _this.styleOpsGrid = null;
        _this.hasMouse = false;
        _this.hasFocus = false;
        _this.styleButtons = new Dictionary();
        _this.styleIcons = new Dictionary();
        // we need to rely on this to avoid potentially redundant thumbnail requests and .blob calls
        _this.thumbnailCache = {
            assumedConfiguration: undefined,
            response: new Dictionary(),
            blob: new Dictionary()
        };
        /**
         * Callback handler for the style changing.
         */
        _this.onStyleChange = function () {
            if (_this.options.autoSelectionMode) {
                var newStyle = _this.map.getStyle().style;
                _this.setSelectedStyle(newStyle);
            }
        };
        _this.onMapConfigurationChange = function (definitions) {
            if (!_this.styleOpsGrid) {
                return;
            }
            // do not recreate the styleOpsGrid if it is initialized and configuration object reference has not changed
            if (_this.styleOpsGrid.children.length > 0 && _this.thumbnailCache.assumedConfiguration === definitions) {
                return;
            }
            _this.thumbnailCache.assumedConfiguration = definitions;
            Array.from(_this.styleOpsGrid.children).forEach(function (element) { return element.remove(); });
            _this.styleButtons.clear();
            _this.populateOpsGridFromDefinitions(definitions);
        };
        _this.mapToFriendlyStyleName = function (name, mapConfiguration) {
            var style = mapConfiguration.configurations.find(function (style) { return style.name === name; });
            return (style === null || style === void 0 ? void 0 : style.displayName) || name;
        };
        _this.options = new StyleControlOptions().merge(cloneDeep$1(options));
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    StyleControl.prototype.onAdd = function (map, options) {
        var _this = this;
        this.map = map;
        var container = this.buildContainer(map, this.options.style, "Map Style Control");
        var styleOpsGrid = this.buildStyleOpsGrid();
        this.styleOpsGrid = styleOpsGrid;
        var currStyleButton = this.buildCurrStyleBtn();
        var tooltip = buildAccessibleTooltip("Select Style");
        var expandGrid = function (expanded) {
            if (expanded) {
                container.classList.add(StyleControl.Css.inUse);
                styleOpsGrid.classList.remove("hidden-accessible-element");
            }
            else {
                container.classList.remove(StyleControl.Css.inUse);
                styleOpsGrid.classList.add("hidden-accessible-element");
            }
        };
        styleOpsGrid.classList.add(options ? options.position || 'top-right' : 'top-right');
        container.addEventListener("mouseover", function () {
            _this.hasMouse = true;
            expandGrid(true);
        });
        container.addEventListener("focusin", function () {
            _this.hasFocus = true;
            expandGrid(true);
        });
        container.addEventListener("mouseleave", function () {
            _this.hasMouse = false;
            if (!_this.hasFocus) {
                expandGrid(false);
            }
        });
        container.addEventListener("focusout", function (event) {
            if (event.target === currStyleButton) {
                // on focusout from reveal button -> reset the tabIndex on the styleOpsGrid elements that could have been set to -1 on esc key press
                Array.from(styleOpsGrid.children).forEach(function (e) { return e.removeAttribute('tabIndex'); });
            }
            if (!(event.relatedTarget instanceof Node && container.contains(event.relatedTarget))) {
                _this.hasFocus = false;
                if (!_this.hasMouse) {
                    expandGrid(false);
                }
            }
        });
        // explictly hijack esc key behavior: we should not interrupt normal tab-navigation flow
        // but focus out via esc from to the parent container should instead bring focus to the reveal button
        styleOpsGrid.addEventListener('keydown', function (event) {
            if (event.keyCode === 27) {
                event.stopPropagation();
                currStyleButton.focus();
                Array.from(styleOpsGrid.children).forEach(function (e) { return e.setAttribute('tabIndex', "-1"); });
                if (container.classList.contains(StyleControl.Css.inUse)) {
                    expandGrid(false);
                }
            }
        });
        currStyleButton.addEventListener("click", function (event) {
            if (container.classList.contains(StyleControl.Css.inUse)) {
                expandGrid(false);
            }
            else {
                expandGrid(true);
                // clicking on a reveal button should move the focus to the first styleOpsGrid button
                if (styleOpsGrid.firstElementChild) {
                    styleOpsGrid.firstElementChild.focus();
                }
            }
        });
        if (options && StyleControl.InvertOrderPositions.includes(options.position)) {
            container.appendChild(styleOpsGrid);
            container.appendChild(currStyleButton);
            container.appendChild(tooltip);
            positionTooltip(tooltip, currStyleButton);
        }
        else {
            container.appendChild(currStyleButton);
            container.appendChild(tooltip);
            positionTooltip(tooltip, currStyleButton);
            container.appendChild(styleOpsGrid);
        }
        return container;
    };
    /**
     * Method that is called when the control is removed from the map. Should perform any necessary cleanup for the
     * control.
     */
    StyleControl.prototype.onRemove = function () {
        _super.prototype.onRemove.call(this);
        this.styleOpsGrid = null;
        this.styleButtons.clear();
        this.thumbnailCache.response.clear();
        this.thumbnailCache.blob.clear();
        this.thumbnailCache.assumedConfiguration = undefined;
        this.map.events.remove("stylechanged", this.onStyleChange);
        this.map.events.remove("mapconfigurationchanged", this.onMapConfigurationChange);
    };
    /**
     * Set the style that need to be displayed as currently selected.
     * Style will automatically get selected if `StyleControlOptions.autoSelectionMode` is `true`
     * @param styleName - Style name that need to be disabled as currently selected
     */
    StyleControl.prototype.setSelectedStyle = function (styleName) {
        var _this = this;
        if (this.styleIcons.has(styleName)) {
            var image_1 = this.currStyleImage;
            var newSrc = this.styleIcons.get(styleName);
            if (image_1.src !== newSrc) {
                image_1.src = newSrc;
            }
            Object.entries(this.styleButtons).forEach(function (_a) {
                var _b = __read$f(_a, 2), buttonStyleName = _b[0], button = _b[1];
                return button.setAttribute('aria-current', buttonStyleName === styleName ? 'true' : 'false');
            });
            this.map.styles.definitions().then(function (mapConfiguration) {
                var newAlt = _this.mapToFriendlyStyleName(styleName, mapConfiguration);
                if (image_1.alt !== newAlt) {
                    image_1.alt = newAlt;
                }
                if (image_1.parentElement.lastChild instanceof Text) {
                    image_1.parentElement.lastChild.textContent = newAlt;
                }
            });
        }
    };
    /**
     * Set style in a disabled state
     * @param styleName Style to be disabled
     */
    StyleControl.prototype.disableStyle = function (styleName) {
        var styleButton = this.styleButtons[styleName];
        if (styleButton) {
            styleButton.setAttribute("disabled", "true");
        }
    };
    /**
     * Enabled style that was previously disabled
     * @param styleName Style to be disabled
     */
    StyleControl.prototype.enableStyle = function (styleName) {
        var styleButton = this.styleButtons[styleName];
        if (styleButton) {
            styleButton.removeAttribute("disabled");
        }
    };
    StyleControl.prototype.buildSelectStyleBtn = function (name, mapConfiguration, fetchIconPromise) {
        var _this = this;
        var styleOptionButton = document.createElement("button");
        var friendlyName = this.mapToFriendlyStyleName(name, mapConfiguration);
        styleOptionButton.setAttribute("aria-label", friendlyName);
        styleOptionButton.setAttribute("type", "button");
        var styleIconImage = new Image();
        fetchIconPromise
            .then(function (response) {
            if (_this.thumbnailCache.blob.has(response.url)) {
                return _this.thumbnailCache.blob.get(response.url);
            }
            else {
                // we need the response.clone() to allow reading over body multiple times since response objects are cached 
                // and can be reused across multiple invocations
                var blobPromise = response.clone().blob();
                _this.thumbnailCache.blob.set(response.url, blobPromise);
                return blobPromise;
            }
        })
            .then(function (blob) {
            var iconUrl = URL.createObjectURL(blob);
            styleIconImage.src = iconUrl;
            if (name === _this.map.getStyle().style) {
                _this.currStyleImage.src = iconUrl;
                _this.currStyleImage.alt = friendlyName;
                if (_this.currStyleImage.parentElement.lastChild.nodeType == Node.TEXT_NODE) {
                    _this.currStyleImage.parentElement.lastChild.textContent = friendlyName;
                }
                else {
                    _this.currStyleImage.parentElement.appendChild(document.createTextNode(friendlyName));
                }
            }
            _this.styleIcons.set(name, iconUrl);
        });
        styleIconImage.setAttribute("aria-hidden", "true");
        styleOptionButton.appendChild(styleIconImage);
        if (this.options.layout === "icons") {
            styleOptionButton.classList.add(StyleControl.Css.button);
        }
        else {
            styleOptionButton.classList.add(StyleControl.Css.listButton);
            styleOptionButton.classList.add(StyleControl.Css.expanded);
            styleOptionButton.appendChild(document.createTextNode(friendlyName));
        }
        styleOptionButton.addEventListener("click", function () {
            _this.hasMouse = false;
            _this.hasFocus = false;
            var styleButton = _this.styleButtons[name];
            if (styleButton && !styleButton.hasAttribute("disabled")) {
                _this._invokeEvent("styleselected", name);
                if (_this.options.autoSelectionMode) {
                    _this.map.setStyle({ style: name });
                }
                Object.entries(_this.styleButtons).forEach(function (_a) {
                    var _b = __read$f(_a, 2), styleName = _b[0], button = _b[1];
                    return button.setAttribute('aria-current', styleName === name ? 'true' : 'false');
                });
            }
        });
        var iconDiv = document.createElement('div');
        iconDiv.classList.add('selected-icon');
        styleOptionButton.appendChild(iconDiv);
        return styleOptionButton;
    };
    StyleControl.prototype.buildCurrStyleBtn = function () {
        var selectCurrButton = document.createElement("button");
        if (this.options.layout == 'icons') {
            selectCurrButton.classList.add(StyleControl.Css.button);
        }
        else {
            selectCurrButton.classList.add(StyleControl.Css.listButton);
        }
        selectCurrButton.classList.add(StyleControl.Css.currentStyle);
        selectCurrButton.setAttribute("aria-label", "Select Style");
        selectCurrButton.setAttribute("tabindex", "-1");
        this.currStyleImage = new Image();
        selectCurrButton.appendChild(this.currStyleImage);
        var selectCurrButtonIcon = document.createElement("div");
        selectCurrButtonIcon.classList.add("icon");
        selectCurrButton.appendChild(selectCurrButtonIcon);
        return selectCurrButton;
    };
    StyleControl.prototype.buildStyleOpsGrid = function () {
        var _this = this;
        var styleOpsGrid = document.createElement("div");
        styleOpsGrid.classList.add(StyleControl.Css.styleOptions);
        if (this.options.layout === 'icons') {
            styleOpsGrid.classList.add(this.options.layout);
        }
        else {
            styleOpsGrid.classList.add(StyleControl.Css.dropdown);
        }
        styleOpsGrid.setAttribute("aria-label", "Style Options");
        styleOpsGrid.classList.add("hidden-accessible-element");
        // Once the map's style definition is initialized create a map between style names and icons.
        // If a style is one of those to be shown by the style picker also create it's element.
        this.map.styles.definitions().then(function (definitions) { return __awaiter$7(_this, void 0, void 0, function () {
            return __generator$7(this, function (_a) {
                this.onMapConfigurationChange(definitions);
                this.map.events.add("stylechanged", this.onStyleChange);
                return [2 /*return*/];
            });
        }); });
        this.map.events.add("mapconfigurationchanged", this.onMapConfigurationChange);
        return styleOpsGrid;
    };
    StyleControl.prototype.populateOpsGridFromDefinitions = function (definitions) {
        var _this = this;
        if (!this.styleOpsGrid) {
            return;
        }
        var styles = definitions.configurations;
        if (Array.isArray(this.options.mapStyles)) {
            styles = styles.filter(function (style) { return _this.options.mapStyles.includes(style.name.split("_indoor")[0]); });
        }
        styles.forEach(function (style) {
            // Create fetch thumbnail request
            var requestParams = {
                url: style.thumbnail
            };
            style.thumbnail && _this.map.styles._transformStyleRequest(style.thumbnail, requestParams);
            // Apply the users specified transform after ours
            var mapServiceOptions = _this.map.getServiceOptions();
            if (mapServiceOptions.transformRequest) {
                merge$1(requestParams, mapServiceOptions.transformRequest(requestParams.url, "Thumbnail"));
            }
            var fetchThumbnailPromise;
            if (_this.thumbnailCache.response.has(requestParams.url)) {
                fetchThumbnailPromise = Promise.resolve(_this.thumbnailCache.response.get(requestParams.url));
            }
            else {
                fetchThumbnailPromise = fetch(requestParams.url, { headers: requestParams.headers });
                _this.thumbnailCache.response.set(requestParams.url, fetchThumbnailPromise);
            }
            // Add button for each style
            var styleOptionButton = _this.buildSelectStyleBtn(style.name, definitions, fetchThumbnailPromise);
            _this.styleOpsGrid.appendChild(styleOptionButton);
            _this.styleButtons[style.name] = styleOptionButton;
            if (_this.options.layout === "icons") {
                var tooltip = buildAccessibleTooltip(_this.mapToFriendlyStyleName(style.name, definitions));
                _this.styleOpsGrid.appendChild(tooltip);
                positionTooltip(tooltip, styleOptionButton);
            }
        });
        var targetStyleName = this.map.getStyle().style;
        Object.entries(this.styleButtons).forEach(function (_a) {
            var _b = __read$f(_a, 2), styleName = _b[0], button = _b[1];
            return button.setAttribute('aria-current', styleName === targetStyleName ? 'true' : 'false');
        });
    };
    StyleControl.InvertOrderPositions = [ControlPosition.TopRight, ControlPosition.BottomRight];
    StyleControl.Css = {
        button: "azure-maps-control-button",
        listButton: "azure-maps-control-list-button",
        expanded: 'expanded',
        currentStyle: "curr-style",
        inUse: "in-use",
        styleOptions: "style-options",
        dropdown: "azure-maps-control-dropdown"
    };
    return StyleControl;
}(ControlBase));

var __extends$1c = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for setting traffic on the map.
 */
var TrafficOptions = /** @class */ (function (_super) {
    __extends$1c(TrafficOptions, _super);
    function TrafficOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The type of traffic flow to display:<br />
         * `"none"` is to display no traffic flow data<br />
         * `"relative"` is the speed of the road relative to free-flow<br />
         * @deprecated `"absolute"` is the absolute speed of the road<br />
         * @deprecated `"relative-delay"` displays relative speed only where they differ from free-flow;
         * false to stop displaying the traffic flow.<br />
         * default `"none"`
         * @default "none"
         */
        _this.flow = "none";
        /**
         * Whether to display incidents on the map.
         * default `false`
         * @default false
         */
        _this.incidents = false;
        return _this;
    }
    return TrafficOptions;
}(Options));

var __extends$1b = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a TrafficControl object.
 */
var TrafficControlOptions = /** @class */ (function (_super) {
    __extends$1b(TrafficControlOptions, _super);
    function TrafficControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Specifies if the control is in the active state (displaying traffic).
         * Default: false
         * @default false
         */
        _this.isActive = false;
        /**
         * The style of the control. Can be; light, dark, auto, or any CSS3 color. When set to auto, the style will change based on the map style.
         * Default `light'.
         * @default light
         */
        _this.style = ControlStyle.light;
        return _this;
    }
    return TrafficControlOptions;
}(TrafficOptions));

var __extends$1a = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A control that toggles traffic data on the map.
 */
var TrafficControl = /** @class */ (function (_super) {
    __extends$1a(TrafficControl, _super);
    /**
     * Constructs a TrafficControl
     * @param options The options for the control.
     */
    function TrafficControl(options) {
        var _this = this;
        var _a, _b;
        _this = _super.call(this) || this;
        _this.hasMouse = false;
        _this.hasFocus = false;
        // desired map traffic state when control is enabled 
        _this.options = new TrafficOptions().merge({
            flow: 'relative',
            incidents: true
        });
        _this.style = ControlStyle.light;
        _this.container = null;
        _this.trafficButton = null;
        _this.map = null;
        if (options) {
            _this.initIsActive = (_a = options.isActive) !== null && _a !== void 0 ? _a : false;
            _this.options.flow = options.flow || 'relative';
            _this.options.incidents = (_b = options.incidents) !== null && _b !== void 0 ? _b : true;
            _this.style = options.style || ControlStyle.light;
        }
        return _this;
    }
    Object.defineProperty(TrafficControl.prototype, "isActive", {
        /**
         * Current control state (is traffic information displayed?)
         */
        get: function () {
            if (!this.map) {
                return false;
            }
            var trafficState = this.map.getTraffic();
            return trafficState.flow !== "none" || trafficState.incidents;
        },
        /**
         * Sets the control state
         */
        set: function (newValue) {
            if (!this.map) {
                return;
            }
            this.map.setTraffic({
                flow: newValue ? this.options.flow : 'none',
                incidents: newValue ? this.options.incidents : false
            });
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    TrafficControl.prototype.onAdd = function (map) {
        this.map = map;
        map.getTraffic();
        // bring map traffic state in sync with desired if initIsActive have been set
        if (this.initIsActive !== undefined) {
            this.isActive = this.initIsActive;
        }
        this.container = this.buildContainer(map, this.style, "Traffic Control");
        this.container.style.flexDirection = "column";
        var trafficButton = this.constructTrafficButton(map);
        this.container.appendChild(trafficButton);
        var tooltip = buildAccessibleTooltip("Toggle Traffic Display");
        this.container.appendChild(tooltip);
        positionTooltip(tooltip, trafficButton);
        return this.container;
    };
    TrafficControl.prototype.onRemove = function () {
        _super.prototype.onRemove.call(this);
        this.map = null;
    };
    /**
     * Get the TrafficControlOptions
     */
    TrafficControl.prototype.getOptions = function () {
        return new TrafficControlOptions().merge({
            isActive: this.isActive,
            flow: this.options.flow,
            incidents: this.options.incidents,
            style: this.style
        });
    };
    /**
     * Updates the button state according to current traffic state
     * This is invoked on init in constructTrafficButton and on each Map.setTraffic()
     */
    TrafficControl.prototype.updateButtonState = function () {
        if (this.trafficButton) {
            if (this.isActive) {
                this.container.classList.add("in-use");
                this.trafficButton.setAttribute("aria-description", "Traffic is displayed");
            }
            else {
                this.container.classList.remove("in-use");
                this.trafficButton.removeAttribute("aria-description");
            }
            this.trafficButton.setAttribute("aria-pressed", this.isActive ? "true" : "false");
        }
    };
    TrafficControl.prototype.constructTrafficButton = function (map) {
        var _this = this;
        var trafficButton = document.createElement("button");
        trafficButton.classList.add("azure-maps-control-button");
        trafficButton.classList.add("traffic");
        trafficButton.setAttribute("aria-label", "Toggle Traffic Display");
        trafficButton.setAttribute("alt", "Toggle Traffic Display");
        trafficButton.setAttribute("type", "button");
        this.trafficButton = trafficButton;
        this.updateButtonState();
        // toggle button
        trafficButton.addEventListener("click", function () {
            _this.isActive = !_this.isActive;
        });
        return trafficButton;
    };
    return TrafficControl;
}(ControlBase));

var __extends$19 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values$j = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A control that display traffic legend on the map.
 */
var TrafficLegendControl = /** @class */ (function (_super) {
    __extends$19(TrafficLegendControl, _super);
    /**
     * Construct a traffic legend control
     */
    function TrafficLegendControl() {
        var _this = _super.call(this) || this;
        _this.table = ["Fast",
            ["green", "yellow", "red", "dark-red"],
            "Slow"];
        _this.map = null;
        _this.syncHiddenState = null;
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    TrafficLegendControl.prototype.onAdd = function (map) {
        this.map = map;
        var container = this.buildContainer(map, ControlStyle.auto, "Traffic Legend");
        var TrafficLegendDiv = this.buildTrafficLegendDiv(map);
        container.setAttribute("role", "definition");
        container.appendChild(TrafficLegendDiv);
        return container;
    };
    TrafficLegendControl.prototype.onRemove = function () {
        _super.prototype.onRemove.call(this);
        if (this.syncHiddenState) {
            this.map.events.remove('styledata', this.syncHiddenState);
            this.syncHiddenState = null;
        }
        this.map = null;
    };
    TrafficLegendControl.prototype.buildTrafficLegendDiv = function (map) {
        var e_1, _a, e_2, _b;
        var trafficLegend = document.createElement("div");
        trafficLegend.classList.add("traffic-legend", "hidden");
        trafficLegend.setAttribute("alt", "Traffic Legend");
        var trafficLegendTable = document.createElement("table");
        // legend table title
        var tr1 = document.createElement("tr");
        var td = document.createElement("td");
        td.setAttribute("alt", "Traffic");
        td.appendChild(document.createTextNode("Traffic"));
        var tooltip = buildAccessibleTooltip("Traffic");
        td.classList.add("traffic-legend-title");
        td.colSpan = 6;
        tr1.appendChild(td);
        tr1.appendChild(tooltip);
        positionTooltip(tooltip, td);
        trafficLegendTable.appendChild(tr1);
        // legend table contents
        var tr2 = document.createElement("tr");
        try {
            for (var _c = __values$j(this.table), _d = _c.next(); !_d.done; _d = _c.next()) {
                var col = _d.value;
                var data = document.createElement("td");
                if (col === "Fast" || col === "Slow") {
                    data.setAttribute("alt", col);
                    data.appendChild(document.createTextNode(col));
                    data.classList.add("traffic-legend-text");
                }
                else {
                    data.classList.add("traffic-legend-colors");
                    data.setAttribute("aria-label", "Traffic Legend");
                    data.setAttribute("role", "img");
                    try {
                        for (var col_1 = (e_2 = void 0, __values$j(col)), col_1_1 = col_1.next(); !col_1_1.done; col_1_1 = col_1.next()) {
                            var color = col_1_1.value;
                            var div = document.createElement("div");
                            div.classList.add(color);
                            data.appendChild(div);
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (col_1_1 && !col_1_1.done && (_b = col_1.return)) _b.call(col_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
                tr2.appendChild(data);
                var tooltip_1 = buildAccessibleTooltip(col instanceof Array ? "Traffic Legend" : col);
                tr2.appendChild(tooltip_1);
                positionTooltip(tooltip_1, data);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        trafficLegendTable.appendChild(tr2);
        trafficLegend.appendChild(trafficLegendTable);
        this.syncHiddenState = function (eventData) {
            if (eventData.dataType === "style") {
                var trafficOptions = map.getTraffic();
                if (trafficOptions.flow && trafficOptions.flow !== "none") {
                    trafficLegend.classList.remove("hidden");
                }
                else {
                    trafficLegend.classList.add("hidden");
                }
            }
        };
        // display legend when the traffic flow is shown, hide it otherwise
        this.syncHiddenState({ dataType: 'style' });
        map.events.add("styledata", this.syncHiddenState);
        return trafficLegend;
    };
    return TrafficLegendControl;
}(ControlBase));

/** Used to stand-in for `undefined` hash values. */

var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd$1(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

var _setCacheAdd = setCacheAdd$1;

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */

function setCacheHas$1(value) {
  return this.__data__.has(value);
}

var _setCacheHas = setCacheHas$1;

var MapCache = _MapCache,
    setCacheAdd = _setCacheAdd,
    setCacheHas = _setCacheHas;

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache$1(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache$1.prototype.add = SetCache$1.prototype.push = setCacheAdd;
SetCache$1.prototype.has = setCacheHas;

var _SetCache = SetCache$1;

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */

function arraySome$1(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

var _arraySome = arraySome$1;

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function cacheHas$1(cache, key) {
  return cache.has(key);
}

var _cacheHas = cacheHas$1;

var SetCache = _SetCache,
    arraySome = _arraySome,
    cacheHas = _cacheHas;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$3 = 1,
    COMPARE_UNORDERED_FLAG$1 = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays$2(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Check that cyclic values are equal.
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG$1) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

var _equalArrays = equalArrays$2;

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */

function mapToArray$1(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

var _mapToArray = mapToArray$1;

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */

function setToArray$1(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

var _setToArray = setToArray$1;

var Symbol$1 = _Symbol,
    Uint8Array$1 = _Uint8Array,
    eq = eq_1,
    equalArrays$1 = _equalArrays,
    mapToArray = _mapToArray,
    setToArray = _setToArray;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$2 = 1,
    COMPARE_UNORDERED_FLAG = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol$1 ? Symbol$1.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag$1(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array$1(object), new Uint8Array$1(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$2;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays$1(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

var _equalByTag = equalByTag$1;

var getAllKeys = _getAllKeys;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$1 = 1;

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects$1(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$1,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty$1.call(other, key))) {
      return false;
    }
  }
  // Check that cyclic values are equal.
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

var _equalObjects = equalObjects$1;

var Stack = _Stack,
    equalArrays = _equalArrays,
    equalByTag = _equalByTag,
    equalObjects = _equalObjects,
    getTag = _getTag,
    isArray$1 = isArray_1,
    isBuffer = isBufferExports,
    isTypedArray = isTypedArray_1;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep$1(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray$1(object),
      othIsArr = isArray$1(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

var _baseIsEqualDeep = baseIsEqualDeep$1;

var baseIsEqualDeep = _baseIsEqualDeep,
    isObjectLike$1 = isObjectLike_1;

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual$1(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike$1(value) && !isObjectLike$1(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual$1, stack);
}

var _baseIsEqual = baseIsEqual$1;

var baseIsEqual = _baseIsEqual;

/**
 * Performs a deep comparison between two values to determine if they are
 * equivalent.
 *
 * **Note:** This method supports comparing arrays, array buffers, booleans,
 * date objects, error objects, maps, numbers, `Object` objects, regexes,
 * sets, strings, symbols, and typed arrays. `Object` objects are compared
 * by their own, not inherited, enumerable properties. Functions and DOM
 * nodes are compared by strict equality, i.e. `===`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.isEqual(object, other);
 * // => true
 *
 * object === other;
 * // => false
 */
function isEqual(value, other) {
  return baseIsEqual(value, other);
}

var isEqual_1 = isEqual;

var isEqual$1 = /*@__PURE__*/getDefaultExportFromCjs(isEqual_1);

/**
 * A GeoJSON Feature object - a JSON object representing a spatially bounded entity. The full description is detailed in
 * [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.2}.
 */
var Feature = /** @class */ (function () {
    /**
     * Constructs a Feature.
     * @param geometry The geometry of the feature.
     * @param properties The properties of the feature.
     * @param id The id of the feature.
     * @param bbox The bounding box of the feature.
     */
    function Feature(geometry, properties, id, bbox) {
        /**
         * A GeoJSON type descriptor with value "Feature".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "Feature";
        this.type = Feature.TYPE;
        this.properties = properties || {};
        this.id = id;
        this.geometry = geometry;
        this.bbox = bbox;
    }
    /**
     * A static GeoJSON type descriptor for the Feature class to be used in runtime comparisons.
     */
    Feature.TYPE = "Feature";
    return Feature;
}());

var __extends$18 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Represent a pixel coordinate or offset. Extends an array of [x, y].
 */
var Pixel = /** @class */ (function (_super) {
    __extends$18(Pixel, _super);
    /**
     * Constructs a Pixel object and initializes it with the specified x and y coordinates.
     * @param x The horizontal pixel offset.
     * @param y The vertical pixel offset.
     */
    function Pixel(x, y) {
        return _super.call(this, x, y) || this;
    }
    /**
     * Generates a Pixel object from an object that contains coordinate information.
     * The object is scanned for x and y properties using a case insensitive test.
     * @param data The object to extract coordinate information from.
     * @returns A Pixel object that represents the provided data information.
     */
    Pixel.fromData = function (data) {
        var x = NaN;
        var y = NaN;
        var xNames = new Set(["y"]);
        var yNames = new Set(["x"]);
        // Do a case insensitive search through the object properties.
        Object.keys(data).forEach(function (key) {
            var smallKey = key.toLowerCase();
            if (isNaN(x) && xNames.has(smallKey) && typeof data[key] === "number") {
                x = data[key];
            }
            else if (isNaN(y) && yNames.has(smallKey) && typeof data[key] === "number") {
                y = data[key];
            }
        });
        // If an x and y value were found return the Pixel constructed from them.
        if (!isNaN(x) && !isNaN(y)) {
            return new Pixel(x, y);
        }
        return null;
    };
    /**
     * Return the x coordinate of the specified pixel.
     * @param pixel The pixel to get the x coordinate of.
     */
    Pixel.getX = function (pixel) {
        if (pixel.length > 0) {
            return pixel[0];
        }
        return NaN;
    };
    /**
     * Return the y coordinate of the specified pixel.
     * @param pixel The pixel to get the y coordinate of.
     */
    Pixel.getY = function (pixel) {
        if (pixel.length > 1) {
            return pixel[1];
        }
        return NaN;
    };
    /**
     * Calculates a destination pixel given an origin pixel,​
     * a heading relative to the y-axis (0 = north) with clockwise-rotation,​
     * and a distance in pixel units.​
     * @param origin The starting pixel.​
     * @param heading The heading at which to move away from the origin pixel.​
     * @param distance The distance to move from the origin pixel.​
     */
    Pixel.getDestination = function (origin, heading, distance) {
        return new Pixel(Pixel.getX(origin) + distance * Math.cos((heading + 270) * Math.PI / 180), Pixel.getY(origin) + distance * Math.sin((heading + 270) * Math.PI / 180));
    };
    /**
     * Calculates the distance between two pixels.
     * Returned value is in screen pixel units.
     * @param p1 The first pixel.
     * @param p2 The second pixel.
     */
    Pixel.getDistance = function (p1, p2) {
        var dx = Pixel.getX(p1) - Pixel.getX(p2);
        var dy = Pixel.getY(p1) - Pixel.getY(p2);
        return Math.sqrt(dx * dx + dy * dy);
    };
    /**​
     * Calculates the heading between two pixels.​ The heading value is relative to the y-axis (0 = north) with clockwise-rotation.
     * @param origin The pixel the heading will point away from.​
     * @param destination The pixel the heading will point toward.​
     */
    Pixel.getHeading = function (origin, destination) {
        var dx = Pixel.getX(destination) - Pixel.getX(origin);
        var dy = Pixel.getY(origin) - Pixel.getY(destination);
        return ((5 / 2 * Math.PI) - Math.atan2(dy, dx)) * 180 / Math.PI % 360;
    };
    return Pixel;
}(Array));

/**
 * A GeoJSON Point object - a JSON object that represents a geographic position. The full description is detailed in
 * [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.2}.
 */
var Point = /** @class */ (function () {
    /**
     * Constructs a Point.
     * @param coordinates The position defining the point.
     */
    function Point(coordinates) {
        /**
         * A GeoJSON type descriptor with value "Point".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "Point";
        this.type = Point.TYPE;
        this.coordinates = coordinates;
    }
    /**
     * A static GeoJSON type descriptor for the Point class to be used in runtime comparisons.
     */
    Point.TYPE = "Point";
    return Point;
}());

var __read$e = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values$i = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
//////////////////////
/// Constants
//////////////////////
/**
 * Earth Radius Semi Major Axis in meters
 */
var EARTH_RADIUS_SEMI_MAJOR_AXIS = 6378137;
/**
 * A constant for Math.PI/180. Using this constant is upto 3 times faster than always doing the calculation.
 */
var PI_BY_180 = Math.PI / 180;
/**
 * A constant for 180 / Math.PI. Using this constant is upto 3 times faster than always doing the calculation.
 */
var INV_PI_BY_180 = 180 / Math.PI;
/**
 * Cached array of powers of 10. This will be faster than call Math.pow.
 */
var POWERS_OF_10 = [1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000];
/**
 * Maximum latitude as defined in WebMercator
 */
var WEBMERCATOR_MAXLAT = 85.0511;
//////////////////////
/// Private Functions
//////////////////////
/**
 * Converts an angle that is in degrees to radians. Angle * (PI / 180).
 * @param angle An angle in degrees.
 * @returns An angle in radians.
 */
function _toRadians(angle) {
    return angle * PI_BY_180;
}
/**
 * Converts an angle that is in radians to degrees. Angle * (180 / PI).
 * @param angle An angle in radians.
 * @returns An angle in degrees.
 */
function _toDegrees(angle) {
    return angle * INV_PI_BY_180;
}
/**
 * Clips a number to the specified minimum and maximum values.
 * @param val The number to clip.
 * @param minValue Minimum allowable value.
 * @param maxValue Maximum allowable value.
 * @returns The clipped value.
 */
function _clip(val, minValue, maxValue) {
    return Math.min(Math.max(val, minValue), maxValue);
}
/**
 * Calculates geodetic distance between two Position objects using Haversine formula in meters.
 * @param origin Position to calculate distance from.
 * @param destination Position to calculate distance to.
 * @returns A distance in meters between the two positions.
 */
function _haversineDistance(origin, destination) {
    // https://en.wikipedia.org/wiki/Haversine_formula
    var dLat = _toRadians(destination[1] - origin[1]);
    var dLon = _toRadians(destination[0] - origin[0]);
    var a = Math.pow(Math.sin(dLat / 2), 2) + Math.cos(_toRadians(origin[1])) * Math.cos(_toRadians(destination[1])) * Math.pow(Math.sin(dLon / 2), 2);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
    return Math.round(EARTH_RADIUS_SEMI_MAJOR_AXIS * c * 100) / 100; // Round to 1cm precision.
}
/**
 * Normalizes a distance unit string. Defaults to meters.
 * @param units The distance units to normalize.
 * @returns A normalized distance unit string.
 */
function _normalizeDistanceUnit(units) {
    if (units) {
        switch (units.toLowerCase()) {
            case "feet":
            case "foot":
            case "ft":
                return DistanceUnits.feet;
            case "kilometers":
            case "kilometer":
            case "kilometres":
            case "kilometre":
            case "km":
            case "kms":
                return DistanceUnits.kilometers;
            case "miles":
            case "mile":
            case "mi":
                return DistanceUnits.miles;
            case "nauticalmiles":
            case "nauticalmile":
            case "nms":
            case "nm":
                return DistanceUnits.nauticalMiles;
            case "yards":
            case "yard":
            case "yds":
            case "yrd":
            case "yrds":
                return DistanceUnits.yards;
            case "meters":
            case "metres":
            case "m":
            default:
                return DistanceUnits.meters;
        }
    }
    return DistanceUnits.meters;
}
/**
 * Normailzes a acceleration unit string. Defaults to metersPerSecondSquared.
 * Supported units:
 *    milesPerSecondSquared, kilometersPerSecondSquared, metersPerSecondSquared, feetPerSecondSquared
 *    yardsPerSecondSquared, kilometersPerHoursSecond, milesPerHourSecond, knotsPerSecond, standardGravity
 * @param units The acceleration units to normalize.
 * @returns A normailzed acceleration unit string.
 */
function _normalizeAccelerationUnit(units) {
    // Convert to metersPerSecondSquared
    if (units) {
        switch (units.toLowerCase()) {
            case "milespersecondsquared": // mi/s^2
            case "milepersecondsquared":
            case "mi/s^2":
            case "mi/s2":
                return AccelerationUnits.milesPerSecondSquared;
            case "kilometerspersecondsquared": // km/s^2
            case "kilometrespersecondsquared":
            case "kilometerpersecondsquared":
            case "kilometrepersecondsquared":
            case "km/s^2":
            case "km/s2":
                return AccelerationUnits.kilometersPerSecondSquared;
            case "knotspersecond": // knts/s
            case "knotpersecond":
            case "knts/s":
            case "kn/s":
            case "kt/s":
                return AccelerationUnits.knotsPerSecond;
            case "standardgravity": // g
            case "g":
                return AccelerationUnits.standardGravity;
            case "feetpersecondsquared": // ft/s^2
            case "footpersecondsquared":
            case "ft/s^2":
            case "ft/s2":
                return AccelerationUnits.feetPerSecondSquared;
            case "yardspersecondsquared": // yds/s^2
            case "yardpersecondsquared":
            case "yds/s^2":
            case "yds/s2":
            case "yd/s^2":
            case "yd/s2":
                return AccelerationUnits.yardsPerSecondSquared;
            case "milesperhoursecond": // mi/h/s
            case "mileperhoursecond":
            case "milesperhourseconds":
            case "mileperhourseconds":
            case "mi/h/s":
                return AccelerationUnits.milesPerHourSecond;
            case "kilometersperhoursecond": // km/h/s
            case "kilometrespersoursecond":
            case "kilometerperhoursecond":
            case "kilometrepersoursecond":
            case "kilometersperhourssecond":
            case "kilometrespersourssecond":
            case "kilometerperhourssecond":
            case "kilometrepersourssecond":
            case "kmhs":
            case "km/h/s":
                return AccelerationUnits.kilometersPerHourSecond;
            case "meterspersecondsquared": // m/s^2
            case "metrespersecondsquared":
            case "meterpersecondsquared":
            case "metrepersecondsquared":
            case "m/s^2":
            case "m/s2":
            default:
                return AccelerationUnits.metersPerSecondSquared;
        }
    }
    return AccelerationUnits.metersPerSecondSquared;
}
/**
 * Normailzes an area unit string. Defaults to squareMeters.
 * @param units The area units to normalize.
 * @returns A normailzed area unit string.
 */
function _normalizeAreaUnits(units) {
    if (units) {
        switch (units) {
            case "acres":
            case "ac":
                return AreaUnits.acres;
            case "hectares":
            case "ha":
                return AreaUnits.hectares;
            case "squareFeet":
            case "ft^2":
            case "ft2":
                return AreaUnits.squareFeet;
            case "squareYards":
            case "squareYard":
            case "yds^2":
            case "yds2":
            case "yd^2":
            case "yd2":
                return AreaUnits.squareYards;
            case "squareKilometers":
            case "squareKilometres":
            case "squareKilometer":
            case "squareKilometre":
            case "km^2":
            case "km2":
                return AreaUnits.squareKilometers;
            case "squareMiles":
            case "squareMile":
            case "mi^2":
            case "mi2":
                return AreaUnits.squareMiles;
            case "squareMeters":
            case "squareMetres":
            case "squareMeter":
            case "squareMetre":
            case "m^2":
            case "m2":
            default:
                return AreaUnits.squareMeters;
        }
    }
    return AreaUnits.squareMeters;
}
/**
 * Normailzes a speed unit string. Defaults to metersPerSecond.
 * Supported units:
 *    kilometersPerHour, milesPerHour, metersPerSecond, feetPerSecond, knots, mach
 * @param units The speed units to normalize.
 * @returns A normailzed speed unit string.
 */
function _normalizeSpeedUnit(units) {
    if (units) {
        switch (units.toLowerCase()) {
            case "feetpersecond":
            case "footsecond":
            case "ftps":
            case "ft/s":
                return SpeedUnits.feetPerSecond;
            case "milesperhour":
            case "mileperhour":
            case "mph":
            case "mi/hr":
            case "mi/h":
                return SpeedUnits.milesPerHour;
            case "knots":
            case "knot":
            case "knts":
            case "knt":
            case "kn":
            case "kt":
                return SpeedUnits.knots;
            case "mach":
            case "m":
                return SpeedUnits.mach;
            case "kilometersperhour":
            case "kilometresperhour":
            case "kmperhour":
            case "kmph":
            case "km/hr":
            case "km/h":
                return SpeedUnits.kilometersPerHour;
            case "meterspersecond":
            case "metrespersecond":
            case "mps":
            case "ms":
            case "m/s":
            default:
                return SpeedUnits.metersPerSecond;
        }
    }
    return SpeedUnits.metersPerSecond;
}
/**
 * Normailzes a time unit string. Defaults to seconds.
 * Supported units:
 *    ms (milliseconds), hours, minutes, seconds
 * @param units The time units to normalize.
 * @returns A normailzed time unit string.
 */
function _normalizeTimeUnit(units) {
    if (units) {
        switch (units.toLowerCase()) {
            case "milliseconds":
            case "ms":
                return TimeUnits.ms;
            case "minutes":
            case "minute":
            case "mins":
            case "min":
                return TimeUnits.minutes;
            case "hours":
            case "hour":
            case "hr":
            case "h":
                return TimeUnits.hours;
            case "days":
            case "day":
            case "d":
                return TimeUnits.days;
            case "seconds":
            case "second":
            case "secs":
            case "sec":
            case "s":
            default:
                return TimeUnits.seconds;
        }
    }
    return TimeUnits.seconds;
}
/**
 * Calculates the area of a polygon in square meters.
 * @param coordinates The coordinates of the polygon ring.
 * The first ring is the outer/exterior ring and all other rings are the interior ring.
 * @returns The area of a polygon in square meters.
 */
function _calculatePolygonArea(coordinates) {
    // Based on https://trs-new.jpl.nasa.gov/handle/2014/40409
    var area = 0;
    if (coordinates && coordinates.length > 0) {
        // Calculate the area of the outer/exterior ring of the polygon.
        area = Math.abs(_calculatePolygonRingArea(coordinates[0]));
        // Subtract the area of the holes of the polygon.
        for (var i = 1, len = coordinates.length; i < len; i++) {
            area -= Math.abs(_calculatePolygonRingArea(coordinates[i]));
        }
    }
    return area;
}
/**
 * Calculates the area of a polygon ring  in square meters.
 * The area value will be positive if the coordinates in the ring are ordered clockwise,
 * and negative if ordered counter-clockwise.
 * @param coordinates The coordinates of the polygon ring.
 * @returns The area of the ring in square meters.
 */
function _calculatePolygonRingArea(coordinates) {
    // Based on https://trs-new.jpl.nasa.gov/handle/2014/40409
    var area = 0;
    if (coordinates.length >= 3) {
        var p1 = void 0;
        var p2 = void 0;
        var p3 = void 0;
        for (var i = 0, len = coordinates.length; i < len; i++) {
            // Create triangles from the coordinates.
            if (i === len - 2) { // i = N-2
                p1 = len - 2;
                p2 = len - 1;
                p3 = 0;
            }
            else if (i === len - 1) { // i = N-1
                p1 = len - 1;
                p2 = 0;
                p3 = 1;
            }
            else { // i = 0 to N-3
                p1 = i;
                p2 = i + 1;
                p3 = i + 2;
            }
            area += (_toRadians(coordinates[p3][0]) - _toRadians(coordinates[p1][0])) * Math.sin(_toRadians(coordinates[p2][1]));
        }
        area = area * EARTH_RADIUS_SEMI_MAJOR_AXIS * EARTH_RADIUS_SEMI_MAJOR_AXIS / 2;
    }
    return area;
}
/**
 * 2D cross product of OA and OB vectors, i.e. z-component of their 3D cross product.
 * Returns a positive value, if OAB makes a counter-clockwise turn,
 * negative for clockwise turn, and zero if the points are collinear.
 * @param a Position A
 * @param b Position B
 * @param o Position O
 * @returns The 2D cross product of OA and OB vectors.
 */
function _cross(a, b, o) {
    return (a[0] - o[0]) * (b[1] - o[1]) - (a[1] - o[1]) * (b[0] - o[0]);
}
/**
 * Takes an array of positions that form a path and calculates the closest point on the path to a specified position.
 * @param pos The position to find the closest point to.
 * @param px The pixel value of the position at zoom level 22.
 * @param path An array of positions that form a path.
 * @returns The closest point on the path to the specified position.
 */
function _closestPointOnPath(pos, px, path) {
    // Need atleast two points
    if (path.length >= 2) {
        var minDis = Infinity;
        var d = void 0;
        var closest = null;
        // Convert path to pixels.
        var pixels = mercatorPositionsToPixels(path, 22);
        var cPx = void 0;
        for (var i = 0, len = pixels.length - 1; i < len; i++) {
            cPx = _closestPixelOnLineSegment(px, pixels[i], pixels[i + 1]);
            d = Pixel.getDistance(px, cPx);
            if (d < minDis) {
                minDis = d;
                closest = cPx;
            }
        }
        if (closest) {
            var cPos = mercatorPixelsToPositions([closest], 22)[0];
            return new Feature(new Point(cPos), {
                distance: getDistanceTo(pos, cPos)
            });
        }
    }
    else if (path.length === 1) {
        return new Feature(new Point(path[0]), {
            distance: getDistanceTo(pos, path[0])
        });
    }
    return null;
}
/**
 * Calculates the closest pixel on a line segment from a given point in 2D space.
 * @param px The pixel near the line that we are working with.
 * @param sPx Start pixel of the line segment.
 * @param ePx End pixel of the line segment.
 * @returns The closest pixel on the line segement to the specified pixel.
 */
function _closestPixelOnLineSegment(px, sPx, ePx) {
    // If start and end points of line are equal, then that is the closest point.
    if (sPx[0] === ePx[0] && sPx[1] === ePx[1]) {
        return sPx;
    }
    var APx = px[0] - sPx[0];
    var APy = px[1] - sPx[1];
    var ABx = ePx[0] - sPx[0];
    var ABy = ePx[1] - sPx[1];
    var magAB2 = ABx * ABx + ABy * ABy;
    var ABdotAP = ABx * APx + ABy * APy;
    var t = ABdotAP / magAB2;
    if (t < 0) {
        return sPx;
    }
    else if (t > 1) {
        return ePx;
    }
    else {
        return [sPx[0] + ABx * t, sPx[1] + ABy * t];
    }
}
//////////////////////
/// Internal Functions
//////////////////////
/**
 * Round a number to the specified number of decimal places.
 * @param val The value to round.
 * @param decimals The number of decimals.
 * @returns A number rounded to the specified number of decimal places.
 * @internal
 */
function _precision(val, decimals) {
    if (!isNaN(val) && typeof decimals === "number" && decimals >= 0) {
        var power = void 0;
        if (decimals < POWERS_OF_10.length) {
            power = POWERS_OF_10[decimals];
        }
        else {
            power = Math.pow(10, decimals);
        }
        val = Math.round(val * power) / power;
    }
    return val;
}
//////////////////////
/// Public Enums
//////////////////////
/**
 * Units of measurement for areas.
 */
var AreaUnits;
(function (AreaUnits) {
    /**
     * Represents areas in square meters (m^2).
     * Literal value `""`
     */
    AreaUnits["squareMeters"] = "squareMeters";
    /**
     * Represents areas in acres (ac).
     * Literal value `"acres"`
     */
    AreaUnits["acres"] = "acres";
    /**
     * Represents areas in hectares (ha).
     * Literal value `"hectares"`
     */
    AreaUnits["hectares"] = "hectares";
    /**
     * Represents areas in feet (ft^2).
     * Literal value `"squareFeet"`
     */
    AreaUnits["squareFeet"] = "squareFeet";
    /**
     * Represents areas in square kilometers (km^2).
     * Literal value `"squareKilometers"`
     */
    AreaUnits["squareKilometers"] = "squareKilometers";
    /**
     * Represents areas in miles (mi^2).
     * Literal value `"squareMiles"`
     */
    AreaUnits["squareMiles"] = "squareMiles";
    /**
     * Represents areas in yards (yds^2).
     * Literal value `"squareYards"`
     */
    AreaUnits["squareYards"] = "squareYards";
})(AreaUnits || (AreaUnits = {}));
/**
 * Units of measurement for distances.
 */
var DistanceUnits;
(function (DistanceUnits) {
    /**
     * Represents a distance in meters (m).
     * Literal value `"meters"`
     */
    DistanceUnits["meters"] = "meters";
    /**
     * Represents a distance in kilometers (km).
     * Literal value `"kilometers"`
     */
    DistanceUnits["kilometers"] = "kilometers";
    /**
     * Represents a distance in feet (ft).
     * Literal value `"feet"`
     */
    DistanceUnits["feet"] = "feet";
    /**
     * Represents a distance in miles (mi).
     * Literal value `"miles"`
     */
    DistanceUnits["miles"] = "miles";
    /**
     * Represents a distance in nautical miles.
     * Literal value `"nauticalMiles"`
     */
    DistanceUnits["nauticalMiles"] = "nauticalMiles";
    /**
     * Represents a distance in yards (yds).
     * Literal value `"yards"`
     */
    DistanceUnits["yards"] = "yards";
})(DistanceUnits || (DistanceUnits = {}));
/**
 * Units of measurement for time.
 */
var TimeUnits;
(function (TimeUnits) {
    /**
     * Represents a time in seconds (s).
     * Literal value `"seconds"`
     */
    TimeUnits["seconds"] = "seconds";
    /**
     * Represents a time in hours (hr).
     * Literal value `"hours"`
     */
    TimeUnits["hours"] = "hours";
    /**
     * Represents a time in milliseconds (ms).
     * Literal value `"ms"`
     */
    TimeUnits["ms"] = "ms";
    /**
     * Represents a time in minutes (min).
     * Literal value `"minutes"`
     */
    TimeUnits["minutes"] = "minutes";
    /**
     * Represents a time in days (d).
     * Literal value `"days"`
     */
    TimeUnits["days"] = "days";
})(TimeUnits || (TimeUnits = {}));
/**
 * Units of measurement for speed.
 */
var SpeedUnits;
(function (SpeedUnits) {
    /**
     * Represents a speed in meters per second (m/s).
     * Literal value `"metersPerSecond"`
     */
    SpeedUnits["metersPerSecond"] = "metersPerSecond";
    /**
     * Represents a speed in kilometers per hour (km/h).
     * Literal value `"kilometersPerHour"`
     */
    SpeedUnits["kilometersPerHour"] = "kilometersPerHour";
    /**
     * Represents a speed in feet per second (ft/s).
     * Literal value `"feetPerSecond"`
     */
    SpeedUnits["feetPerSecond"] = "feetPerSecond";
    /**
     * Represents a speed in miles per hour (mph).
     * Literal value `"milesPerHour"`
     */
    SpeedUnits["milesPerHour"] = "milesPerHour";
    /**
     * Represents a speed in knots (knts).
     * Literal value `"knots"`
     */
    SpeedUnits["knots"] = "knots";
    /**
     * Represents a speed in mach.
     * Literal value `"mach"`
     */
    SpeedUnits["mach"] = "mach";
})(SpeedUnits || (SpeedUnits = {}));
/**
 * Units of measurement for acceleration.
 */
var AccelerationUnits;
(function (AccelerationUnits) {
    /**
     * Represents an acceleration in miles per second squared (mi/s^2).
     * Literal value `"milesPerSecondSquared"`
     */
    AccelerationUnits["milesPerSecondSquared"] = "milesPerSecondSquared";
    /**
     * Represents an acceleration in kilometers per second squared (km/s^2).
     * Literal value `"kilometersPerSecondSquared"`
     */
    AccelerationUnits["kilometersPerSecondSquared"] = "kilometersPerSecondSquared";
    /**
     * Represents an acceleration in knots per second (knts/s).
     * Literal value `"knotsPerSecond"`
     */
    AccelerationUnits["knotsPerSecond"] = "knotsPerSecond";
    /**
     * Represents an acceleration in standard gravity units (g).
     * Literal value `"standardGravity"`
     */
    AccelerationUnits["standardGravity"] = "standardGravity";
    /**
     * Represents an acceleration in feet per second squared (ft/s^2).
     * Literal value `"feetPerSecondSquared"`
     */
    AccelerationUnits["feetPerSecondSquared"] = "feetPerSecondSquared";
    /**
     * Represents an acceleration in yards per second squared (yds/s^2).
     * Literal value `"yardsPerSecondSquared"`
     */
    AccelerationUnits["yardsPerSecondSquared"] = "yardsPerSecondSquared";
    /**
     * Represents an acceleration in miles per hour second (mi/h/s).
     * Literal value `"milesPerHourSecond"`
     */
    AccelerationUnits["milesPerHourSecond"] = "milesPerHourSecond";
    /**
     * Represents an acceleration in kilometers per hours second (km/h/s).
     * Literal value `"kilometersPerHourSecond"`
     */
    AccelerationUnits["kilometersPerHourSecond"] = "kilometersPerHourSecond";
    /**
     * Represents an acceleration in meters per second squared (m/s^2).
     * Literal value `"metersPerSecondSquared"`
     */
    AccelerationUnits["metersPerSecondSquared"] = "metersPerSecondSquared";
})(AccelerationUnits || (AccelerationUnits = {}));
//////////////////////
/// Public Methods
//////////////////////
/**
 * Takes a BoundingBox and converts it to a polygon.
 * @param bounds The BoundingBox to convert to a Polygon.
 * @returns A polygon representation of the BoundingBox.
 */
function boundingBoxToPolygon(bounds) {
    var w = normalizeLongitude(BoundingBox.getWest(bounds));
    var e = normalizeLongitude(BoundingBox.getEast(bounds));
    var n = normalizeLatitude(BoundingBox.getNorth(bounds));
    var s = normalizeLatitude(BoundingBox.getSouth(bounds));
    var center = BoundingBox.getCenter(bounds);
    var pos = [
        [w, n],
        [w, s],
        [center[0], s],
        [e, s],
        [e, n],
        [center[0], n],
        [w, n]
    ];
    return new Polygon([pos]);
}
/**
 * Converts a distance from one distance units to another. Supported units: miles, nauticalMiles, yards, meters, kilometers, feet
 * @param distance A number that represents a distance to convert.
 * @param fromUnits The distance units the original distance is in.
 * @param toUnits The desired distance units to convert to.
 * @param decimals Specifies the number of decimal places to round the result to. If undefined, no rounding will occur.
 * @returns A distance in the new units.
 */
function convertDistance(distance, fromUnits, toUnits, decimals) {
    // Convert the distance to kilometers
    switch (_normalizeDistanceUnit(fromUnits)) {
        case DistanceUnits.meters:
            distance /= 1000;
            break;
        case DistanceUnits.feet:
            distance /= 3280.8399;
            break;
        case DistanceUnits.miles:
            distance /= 0.62137119;
            break;
        case DistanceUnits.yards:
            distance /= 1093.6133;
            break;
        case DistanceUnits.nauticalMiles:
            distance /= 0.5399568;
            break;
        case DistanceUnits.kilometers:
            break;
    }
    // Convert from kilometers to output distance unit
    switch (_normalizeDistanceUnit(toUnits)) {
        case DistanceUnits.meters:
            distance *= 1000;
            break;
        case DistanceUnits.feet:
            distance *= 3280.8399;
            break;
        case DistanceUnits.miles:
            distance *= 0.62137119;
            break;
        case DistanceUnits.yards:
            distance *= 1093.6133;
            break;
        case DistanceUnits.nauticalMiles:
            distance *= 0.5399568;
            break;
        case DistanceUnits.kilometers:
            break;
    }
    if (typeof decimals === "number" && decimals >= 0) {
        var power = Math.pow(10, decimals);
        distance = Math.round(distance * power) / power;
    }
    return distance;
}
/**
 * Calculates an array of positions that form a cardinal spline between the specified array of positions.
 * @param positions The array of positions to calculate the spline through.
 * @param tension A number that indicates the tightness of the curve. Can be any number, although a value between 0 and 1 is usually used. Default: 0.5
 * @param nodeSize Number of nodes to insert between each position. Default: 15
 * @param close A boolean indicating if the spline should be a closed ring or not. Default: false
 * @returns An array of positions that form a cardinal spline between the specified array of positions.
 */
function getCardinalSpline(positions, tension, nodeSize, close) {
    // Resources:
    // http://www.cubic.org/docs/hermite.htm
    // http://codeplea.com/introduction-to-splines
    // https://msdn.microsoft.com/en-us/library/windows/desktop/ms536358(v=vs.85).aspx
    var locs;
    if (!positions || positions.length <= 2) {
        return locs;
    }
    if (typeof tension !== "number") {
        tension = 0.5;
    }
    if (typeof nodeSize !== "number" || nodeSize <= 0) {
        nodeSize = 15;
    }
    // Get the number of locations the spline passs through.
    var len = positions.length;
    // Create a copy of the array of locations so that we don't alter the original array.
    locs = positions.slice(0);
    // Add additional locations to array so that tangents can be calculated for end points.
    if (close) {
        // If the location array forms a closed ring, remove the last location.
        if (Position.areEqual(locs[0], locs[len - 1])) {
            locs.pop();
            len--;
        }
        // Insert the last coordinate as the first point.
        locs.unshift(positions[len - 1]);
        // Add the first two points to the end of the array.
        locs.push(positions[0]);
        locs.push(positions[1]);
        // Increase index so that spline wraps back around to starting location.
        len++;
    }
    else {
        // In this case the spline is not closed, so tanget of end points will be 0.
        // Buffer the end-points so that tanget calculations can be performed.
        locs.unshift(positions[0]);
        locs.push(positions[len - 1]);
    }
    // Precalculate the hermite basis function steps along the spline.
    var hermiteSteps = [];
    // Force the first step between two locations to be the first location.
    hermiteSteps.push([1, 0, 0, 0]);
    var step;
    var step2;
    var step3;
    // Calculate the steps along the spline between two locations.
    for (var i = 1; i < nodeSize - 1; i++) {
        step = i / nodeSize; // Scale step to go from 0 to 1.
        step2 = step * step; // s^2
        step3 = step * step2; // s^3
        hermiteSteps.push([
            2 * step3 - 3 * step2 + 1,
            -2 * step3 + 3 * step2,
            step3 - 2 * step2 + step,
            step3 - step2
        ]); // Calculate hermite basis function 4.
    }
    // Force the last step between two locations to be the last location.
    hermiteSteps.push([0, 1, 0, 0]);
    var splineLocs = [];
    var hermiteStep;
    // Tangents
    var t1x;
    var t1y;
    var t2x;
    var t2y;
    var lat;
    var lon;
    // Loop through and calculate the spline path between each location pair.
    for (var i = 1; i < len; i++) {
        t1x = tension * (locs[i + 1][0] - locs[i - 1][0]);
        t1y = tension * (locs[i + 1][1] - locs[i - 1][1]);
        t2x = tension * (locs[i + 2][0] - locs[i][0]);
        t2y = tension * (locs[i + 2][1] - locs[i][1]);
        for (step = 0; step < nodeSize; step++) {
            hermiteStep = hermiteSteps[step];
            lon = hermiteStep[0] * locs[i][0] + hermiteStep[1] * locs[i + 1][0] + hermiteStep[2] * t1x + hermiteStep[3] * t2x;
            lat = hermiteStep[0] * locs[i][1] + hermiteStep[1] * locs[i + 1][1] + hermiteStep[2] * t1y + hermiteStep[3] * t2y;
            lat = _clip(lat, -85, 85);
            splineLocs.push([lon, lat]);
        }
    }
    return splineLocs;
}
/**
 * Calculates a destination position based on a starting position, a heading, a distance, and a distance unit type.
 * @param origin Position that the destination is relative to.
 * @param heading A heading angle between 0 - 360 degrees. 0 - North, 90 - East, 180 - South, 270 - West.
 * @param distance Distance that destination is away.
 * @param units Unit of distance measurement. Default is meters.
 * @returns A position that is the specified distance away from the origin.
 */
function getDestination(origin, heading, distance, units) {
    units = units || "meters";
    origin = getPosition(origin);
    var radius = getEarthRadius(units);
    // convert latitude, longitude and heading into radians
    var latRad = _toRadians(origin[1]);
    var lonRad = _toRadians(origin[0]);
    var headingRad = _toRadians(heading);
    var centralAngle = distance / radius;
    var desLatRad = Math.asin(Math.sin(latRad) * Math.cos(centralAngle) + Math.cos(latRad) * Math.sin(centralAngle) * Math.cos(headingRad));
    var desLonRad = lonRad + Math.atan2(Math.sin(headingRad) * Math.sin(centralAngle) * Math.cos(latRad), Math.cos(centralAngle) - Math.sin(latRad) * Math.sin(desLatRad));
    var lat = _clip(normalizeLatitude(_toDegrees(desLatRad)), -85, 85);
    var lon = normalizeLongitude(_toDegrees(desLonRad));
    return [lon, lat];
}
/**
 * Calculate the distance between two position objects on the surface of the earth using the Haversine formula.
 * @param origin First position to calculate distance between.
 * @param destination Second position to calculate distance between.
 * @param units Unit of distance measurement. Default is meters.
 * @returns The shortest distance between two positions in the specified units.
 */
function getDistanceTo(origin, destination, units) {
    origin = getPosition(origin);
    destination = getPosition(destination);
    var d = _haversineDistance(origin, destination);
    if (units === "meters") {
        return d;
    }
    return convertDistance(d, "meters", units || "meters");
}
/**
 * Retrieves the radius of the earth in a specific distance unit for WGS84.
 * @param units Unit of distance measurement. Default: meters
 * @returns A number that represents the radius of the earth in a specific distance unit.
 */
function getEarthRadius(units) {
    var normalUnit = _normalizeDistanceUnit(units);
    return convertDistance(EARTH_RADIUS_SEMI_MAJOR_AXIS, DistanceUnits.meters, normalUnit);
}
/**
 * constructs raw geodesic path that doesn't handle antimeridian crossing
 */
function _constructGeodesic(position, nextPosition, nodeSize) {
    var geodesic = [];
    // Convert positions from degrees to Radians
    var lat1 = _toRadians(position[1]);
    var lon1 = _toRadians(position[0]);
    var lat2 = _toRadians(nextPosition[1]);
    var lon2 = _toRadians(nextPosition[0]);
    // Calculate the total extent of the route
    var d = 2 * Math.asin(Math.sqrt(Math.pow((Math.sin((lat1 - lat2) / 2)), 2) + Math.cos(lat1) * Math.cos(lat2) * Math.pow((Math.sin((lon1 - lon2) / 2)), 2)));
    // Calculate positions at fixed intervals along the route
    for (var k = 0; k <= nodeSize; k++) {
        var f = (k / nodeSize);
        var A = Math.sin((1 - f) * d) / Math.sin(d);
        var B = Math.sin(f * d) / Math.sin(d);
        // Obtain 3D Cartesian coordinates of each point
        var x = A * Math.cos(lat1) * Math.cos(lon1) + B * Math.cos(lat2) * Math.cos(lon2);
        var y = A * Math.cos(lat1) * Math.sin(lon1) + B * Math.cos(lat2) * Math.sin(lon2);
        var z = A * Math.sin(lat1) + B * Math.sin(lat2);
        // Convert these to latitude/longitude
        var lat = Math.atan2(z, Math.sqrt(Math.pow(x, 2) + Math.pow(y, 2)));
        var lon = Math.atan2(y, x);
        lat = _clip(_toDegrees(lat), -85, 85);
        lon = _toDegrees(lon);
        // Add this to the array
        geodesic.push([lon, lat]);
    }
    return geodesic;
}
/**
 * Denormalizes path on antimeridian, this makes lines with coordinates on the opposite side of the antimeridian to always cross it. Note that the path crossing antimeridian will contain longitude outside of -180 to 180 range.
 * See getPathSplitByAntimeridian when this is not desired.
 * @param path Array of position objects or linestring to denormalize
 * @returns A denormalized array of position objects, path crossing antimeridian will contain longitude outside of -180 to 180 range.
 */
function getPathDenormalizedAtAntimerian(path) {
    var coords = Array.isArray(path) ? path : path.coordinates;
    return coords.reduce(function (targetPath, coord) {
        var last = targetPath.length > 0 ? targetPath[targetPath.length - 1] : null;
        // denormalize longitude on antimeridian crossing
        if (last && Math.abs(coord[0] - last[0]) > 180.0) {
            var denormLon = last[0] < 0 ? coord[0] - 360.0 : coord[0] + 360.0;
            targetPath.push([denormLon, coord[1]]);
        }
        else {
            targetPath.push(coord);
        }
        return targetPath;
    }, []);
}
/**
 * Split path on antimeridian into multiple paths.
 * See getPathDenormalizedAtAntimerian when this is not desired.
 * @param path Array of position objects or linestring to split
 * @returns A path split into multiple paths by antimeridian.
 */
function getPathSplitByAntimeridian(path) {
    var coords = Array.isArray(path) ? path : path.coordinates;
    var currentNonCrossing = [];
    var outputPaths = [];
    for (var k = 0; k < coords.length; k++) {
        currentNonCrossing.push(coords[k]);
        if (k + 1 >= coords.length) {
            continue;
        }
        var _a = __read$e(coords[k], 2), lon1 = _a[0], lat1 = _a[1];
        var _b = __read$e(coords[k + 1], 2), lon2 = _b[0], lat2 = _b[1];
        // split the line by antimeridian
        // and break geodesic into two line segments
        if (Math.abs(lon2 - lon1) > 180.0) {
            var denormLon2 = lon1 > 0 ? lon2 + 360.0 : lon2 - 360.0;
            var antiLon = lon1 > 0 ? 180.0 : -180.0;
            var abs = Math.abs(denormLon2 - lon1);
            var antiAbs = Math.abs(antiLon - lon1);
            var f = antiAbs / abs;
            var dLat = (lat2 - lat1) * f;
            var antiLat = lat1 + dLat;
            currentNonCrossing.push([antiLon, antiLat]);
            outputPaths.push(currentNonCrossing);
            currentNonCrossing = [[-antiLon, antiLat]];
        }
    }
    outputPaths.push(currentNonCrossing);
    return outputPaths;
}
/**
 * Takes an array of positions objects and fills in the space between them with accurately positioned positions to form an approximated Geodesic path.
 * @param path Array of position objects that form a path to fill in.
 * @param nodeSize Number of nodes to insert between each position. Default: 15
 * @returns An array of position objects that form a geodesic paths, geodesic path crossing antimeridian will contain longitude outside of -180 to 180 range. See getGeodesicPaths() when this is undesired.
 */
function getGeodesicPath(path, nodeSize) {
    if (!nodeSize || nodeSize <= 0) {
        nodeSize = 15;
    }
    var locs;
    if (Array.isArray(path)) {
        locs = path;
    }
    else if (path.type && path.type === "LineString") {
        locs = path.coordinates;
    }
    var len = locs.length - 1;
    var geodesic = [];
    for (var i = 0; i < len; i++) {
        // Convert positions from degrees to Radians
        geodesic = geodesic.concat(_constructGeodesic(locs[i], locs[i + 1], nodeSize));
    }
    return getPathDenormalizedAtAntimerian(geodesic);
}
/**
 * Takes an array of positions objects and fills in the space between them with accurately positioned positions to form an approximated Geodesic path broken by antimeridian into multiple sub-paths.
 * @param path Array of position objects that form a path to fill in.
 * @param nodeSize Number of nodes to insert between each position. Default: 15
 * @returns An array of paths that form geodesic paths, Comparing to getGeodesicPath, sub-paths will always contain longitude in -180 to 180 range
 */
function getGeodesicPaths(path, nodeSize) {
    if (!nodeSize || nodeSize <= 0) {
        nodeSize = 15;
    }
    var locs;
    if (Array.isArray(path)) {
        locs = path;
    }
    else if (path.type && path.type === "LineString") {
        locs = path.coordinates;
    }
    var len = locs.length - 1;
    var currentNonCrossing = [];
    var outputLocs = [];
    for (var i = 0; i < len; i++) {
        var geodesic = _constructGeodesic(locs[i], locs[i + 1], nodeSize);
        for (var k = 0; k < geodesic.length; k++) {
            currentNonCrossing.push(geodesic[k]);
            if (k + 1 >= geodesic.length) {
                continue;
            }
            var _a = __read$e(geodesic[k], 2), lon1 = _a[0], lat1 = _a[1];
            var _b = __read$e(geodesic[k + 1], 2), lon2 = _b[0], lat2 = _b[1];
            // split the line by antimeridian
            // and break geodesic into two line segments
            if (Math.abs(lon2 - lon1) > 180.0) {
                var denormLon2 = lon1 > 0 ? lon2 + 360.0 : lon2 - 360.0;
                var antiLon = lon1 > 0 ? 180.0 : -180.0;
                var abs = Math.abs(denormLon2 - lon1);
                var antiAbs = Math.abs(antiLon - lon1);
                var f = antiAbs / abs;
                var dLat = (lat2 - lat1) * f;
                var antiLat = lat1 + dLat;
                currentNonCrossing.push([antiLon, antiLat]);
                outputLocs.push(currentNonCrossing);
                currentNonCrossing = [[-antiLon, antiLat]];
            }
        }
    }
    outputLocs.push(currentNonCrossing);
    return outputLocs;
}
/**
 * Calculates the heading from one position object to another.
 * @param origin Point of origin.
 * @param destination Destination to calculate relative heading to.
 * @returns A heading in degrees between 0 and 360. 0 degrees points due North.
 */
function getHeading(origin, destination) {
    origin = getPosition(origin);
    destination = getPosition(destination);
    if (origin && origin.length >= 2 && destination && destination.length >= 2) {
        var radianLat1 = _toRadians(origin[1]);
        var radianLat2 = _toRadians(destination[1]);
        var dLon = _toRadians(destination[0] - origin[0]);
        var dy = Math.sin(dLon) * Math.cos(radianLat2);
        var dx = Math.cos(radianLat1) * Math.sin(radianLat2) - Math.sin(radianLat1) * Math.cos(radianLat2) * Math.cos(dLon);
        return (_toDegrees(Math.atan2(dy, dx)) + 360) % 360;
    }
    return NaN;
}
/**
 * Calculates the distance between all position objects in an array.
 * @param path The array of position objects that make up the path to calculate the length of.
 * @param units Unit of distance measurement. Default: meters
 * @returns The distance between all positions in between all position objects in an array on the surface of a earth in the specified units.
 */
function getLengthOfPath(path, units) {
    var totalLength = 0;
    var locs;
    if (Array.isArray(path)) {
        locs = path;
    }
    else if (path.type && path.type === "LineString") {
        locs = path.coordinates;
    }
    for (var i = 0, len = locs.length - 1; i < len; i++) {
        totalLength += _haversineDistance(locs[i], locs[i + 1]);
    }
    return convertDistance(totalLength, "meters", units || "meters");
}
/**
 * Calculates the position object on a path that is a specified distance away from the start of the path. If the specified distance is longer
 * than the length of the path, the last position of the path will be returned.
 * @param path A polyline or array of position coordinates that form a path.
 * @param distance The distance along the path (from the start) to calculate the position for.
 * @param units Unit of distance measurement. Default is meters.
 * @returns A position object that is the specified distance away from the start of the path when following the path.
 */
function getPositionAlongPath(path, distance, units) {
    units = units || "meters";
    var travelled = 0;
    var dx;
    var locs;
    if (Array.isArray(path)) {
        locs = path;
    }
    else if (path.type && path.type === "LineString") {
        locs = path.coordinates;
    }
    if (locs.length >= 2) {
        var len = locs.length;
        for (var i = 1; i < len; i++) {
            dx = getDistanceTo(locs[i - 1], locs[i], units);
            if (travelled + dx >= distance) {
                // Overshot
                var heading = getHeading(locs[i - 1], locs[i]);
                return getDestination(locs[i - 1], heading, distance - travelled, units);
            }
            travelled += dx;
        }
        if (distance >= travelled) {
            return locs[len - 1];
        }
        return locs[0];
    }
    return null;
}
/**
 * constructs raw regular polygon path that doesn't handle antimeridian crossing
 */
function _constructRegularPolygonPath(origin, radius, numberOfPositions, units, offset) {
    units = units || "meters";
    offset = (offset) ? offset : 0;
    origin = getPosition(origin);
    var points = [];
    var centralAngle = 360 / numberOfPositions;
    for (var i = 0; i <= numberOfPositions; i++) {
        points.push(getDestination(origin, (i * centralAngle + offset) % 360, radius, units));
    }
    return points;
}
/**
 * Calculates an array of position objects that are an equal distance away from a central point to create a regular polygon.
 * @param origin Center of the regular polygon.
 * @param radius Radius of the regular polygon.
 * @param numberOfPositions Number of positions the polygon should have.
 * @param units Unit of distance measurement. Default is meters.
 * @param offset An offset to rotate the polygon. When 0 the first position will align with North.
 * @returns An array of position objects that form a regular polygon. Path crossing antimeridian will contain longitude outside of -180 to 180 range. See getRegularPolygonPaths() when this is undesired.
 */
function getRegularPolygonPath(origin, radius, numberOfPositions, units, offset) {
    return getPathDenormalizedAtAntimerian(_constructRegularPolygonPath(origin, radius, numberOfPositions, units, offset));
}
/**
 * Calculates an array of position objects that are an equal distance away from a central point to create a regular polygon broken by antimeridian into multiple sub-paths.
 * @param origin Center of the regular polygon.
 * @param radius Radius of the regular polygon.
 * @param numberOfPositions Number of positions the polygon should have.
 * @param units Unit of distance measurement. Default is meters.
 * @param offset An offset to rotate the polygon. When 0 the first position will align with North.
 * @returns An array of paths that form a regular polygon. Comparing to getRegularPolygonPath, sub-paths will always contain longitude in -180 to 180 range
 */
function getRegularPolygonPaths(origin, radius, numberOfPositions, units, offset) {
    return getPathSplitByAntimeridian(_constructRegularPolygonPath(origin, radius, numberOfPositions, units, offset));
}
/**
 * Calculates a position object that is a fractional distance between two position objects.
 * @param origin First position to calculate mid-point between.
 * @param destination Second position to calculate mid-point between.
 * @param fraction The fractional parameter to calculate a mid-point for. Default 0.5.
 * @returns A position that lies a fraction of the distance between two position objects, relative to the first position object.
 */
function interpolate(origin, destination, fraction) {
    fraction = (typeof fraction === "undefined") ? 0.5 : fraction;
    origin = getPosition(origin);
    destination = getPosition(destination);
    var arcLength = getDistanceTo(origin, destination, "kilometers");
    var brng = getHeading(origin, destination);
    return getDestination(origin, brng, arcLength * fraction, "kilometers");
}
/**
 * Normalizes a latitude value between -90 and 90 degrees.
 * @param lat The latitude value to normalize.
 */
function normalizeLatitude(lat) {
    if (lat > 90) {
        lat = (lat + 90) % 360;
        return lat > 180 ? 90 - (lat - 180) : lat - 90;
    }
    else if (lat < -90) {
        lat = (lat - 90) % 360;
        return lat < -180 ? -90 - (lat + 180) : lat + 90;
    }
    else {
        return lat;
    }
}
/**
 * Normalizes a longitude value between -180 and 180 degrees.
 * @param lng The longitude value to normalize.
 */
function normalizeLongitude(lng) {
    if (lng > 180) {
        return ((lng + 180) % 360) - 180;
    }
    else if (lng < -180) {
        return ((lng - 180) % 360) + 180;
    }
    else {
        return lng;
    }
}
/**
 * Takes an array of positions and rotates them around a given position for the specified angle of rotation.
 * @param positions An array of positions to be rotated.
 * @param origin The position to rotate the positions around.
 * @param angle The amount to rotate the array of positions in degrees clockwise.
 */
function rotatePositions(positions, origin, angle) {
    if (angle === 0) {
        // When the rotation is 0 the results can sometimes be odd if the coordinates are on the meridians.
        return Object.assign({}, positions);
    }
    origin = getPosition(origin);
    var rotatedPositions = [];
    var distance;
    var heading;
    for (var i = 0, len = positions.length; i < len; i++) {
        distance = getDistanceTo(origin, positions[i]);
        heading = getHeading(origin, positions[i]);
        rotatedPositions.push(getDestination(origin, heading + angle, distance));
    }
    return rotatedPositions;
}
/**
 * Calculates the pixel accurate heading from one position to another based on the Mercator map projection. This heading is visually accurate.
 * @param origin
 * @param destination
 */
function getPixelHeading(origin, destination) {
    origin = getPosition(origin);
    destination = getPosition(destination);
    var _a = __read$e(mercatorPositionsToPixels([origin, destination], 21), 2), p1 = _a[0], p2 = _a[1];
    var dx = (p2[0] - p1[0]);
    var dy = (p1[1] - p2[1]);
    var alpha = ((5 / 2 * Math.PI) - Math.atan2(dy, dx)) * INV_PI_BY_180 % 360;
    return alpha;
}
/**
 * Converts an array of global Mercator pixel coordinates into an array of geospatial positions at a specified zoom level.
 * Global pixel coordinates are relative to the top left corner of the map [-180, 90].
 * @param pixels Array of pixel coordinates.
 * @param zoom Zoom level.
 * @returns An array of positions.
 */
function mercatorPixelsToPositions(pixels, zoom) {
    // 512 is our tile size in pixels.
    var mapSize = 512 * Math.pow(2, zoom);
    var positions = [];
    var x;
    var y;
    for (var i = 0, len = pixels.length; i < len; i++) {
        x = (pixels[i][0] / mapSize) - 0.5;
        y = 0.5 - (pixels[i][1] / mapSize);
        positions.push([
            360 * x,
            90 - 360 * Math.atan(Math.exp(-y * 2 * Math.PI)) / Math.PI
        ]);
    }
    return positions;
}
/**
 * Converts an array of positions into an array of global Mercator pixel coordinates at a specified zoom level.
 * @param positions Array of positions.
 * @param zoom Zoom level.
 * @returns Array of global Mercator pixels.
 */
function mercatorPositionsToPixels(positions, zoom) {
    // 512 is our tile size in pixels.
    var mapSize = 512 * Math.pow(2, zoom);
    var pixels = [];
    var x;
    var y;
    var sinLatitude;
    for (var i = 0, len = positions.length; i < len; i++) {
        sinLatitude = Math.sin(positions[i][1] * Math.PI / 180);
        x = (positions[i][0] + 180) / 360;
        y = 0.5 - Math.log((1 + sinLatitude) / (1 - sinLatitude)) / (4 * Math.PI);
        pixels.push([
            Math.round(x * mapSize),
            Math.round(y * mapSize)
        ]);
    }
    return pixels;
}
/**
 * Converts an acceleration value from one unit to another.
 * Supported units:
 *    milesPerSecondSquared, kilometersPerSecondSquared, metersPerSecondSquared, feetPerSecondSquared
 *    yardsPerSecondSquared, kilometersPerHoursSecond, milesPerHourSecond, knotsPerSecond, standardGravity
 * @param acceleration The acceleration value to convert.
 * @param fromUnits The acceleration units the value is in.
 * @param toUnits The acceleration units to convert to.
 * @param decimals The number of decimal places to round the result to.
 * @returns An acceleration value convertered from one unit to another.
 */
function convertAcceleration(acceleration, fromUnits, toUnits, decimals) {
    // Convert the speed to meters per second squared and then convert to the toUnits.
    switch (_normalizeAccelerationUnit(fromUnits)) {
        case AccelerationUnits.kilometersPerHourSecond:
            acceleration /= 3.6;
            break;
        case AccelerationUnits.milesPerHourSecond:
            acceleration /= 2.236936292054;
            break;
        case AccelerationUnits.knotsPerSecond:
            acceleration /= 1.943844492441;
            break;
        case AccelerationUnits.standardGravity:
            acceleration /= 0.1019716212978;
            break;
        case AccelerationUnits.kilometersPerSecondSquared:
            acceleration /= 0.001;
            break;
        case AccelerationUnits.milesPerSecondSquared:
            acceleration /= 0.000621371192;
            break;
        case AccelerationUnits.feetPerSecondSquared:
            acceleration /= 3.280839895012;
            break;
        case AccelerationUnits.yardsPerSecondSquared:
            acceleration /= 1.093613298338;
            break;
        case AccelerationUnits.metersPerSecondSquared:
    }
    // metersPerSecondSquared to toUnit.
    switch (_normalizeAccelerationUnit(toUnits)) {
        case AccelerationUnits.kilometersPerHourSecond:
            acceleration *= 3.6;
            break;
        case AccelerationUnits.milesPerHourSecond:
            acceleration *= 2.236936292054;
            break;
        case AccelerationUnits.knotsPerSecond:
            acceleration *= 1.943844492441;
            break;
        case AccelerationUnits.standardGravity:
            acceleration *= 0.1019716212978;
            break;
        case AccelerationUnits.kilometersPerSecondSquared:
            acceleration *= 0.001;
            break;
        case AccelerationUnits.milesPerSecondSquared:
            acceleration *= 0.000621371192;
            break;
        case AccelerationUnits.feetPerSecondSquared:
            acceleration *= 3.280839895012;
            break;
        case AccelerationUnits.yardsPerSecondSquared:
            acceleration *= 1.093613298338;
            break;
        case AccelerationUnits.metersPerSecondSquared:
    }
    return _precision(acceleration, decimals);
}
/**
 * Converts an area value from one unit to another.
 * Supported units: squareMeters, acres, hectares, squareFeet, squareYards, squareMiles, squareKilometers
 * @param area The area value to convert.
 * @param fromUnits The area units the value is in.
 * @param toUnits The area units to convert to.
 * @param decimals The number of decimal places to round the result to.
 * @returns An area value convertered from one unit to another.
 */
function convertArea(area, fromUnits, toUnits, decimals) {
    switch (_normalizeAreaUnits(fromUnits)) {
        case AreaUnits.acres:
            area *= 4046.8564224;
            break;
        case AreaUnits.hectares:
            area *= 10000;
            break;
        case AreaUnits.squareFeet:
            area *= 0.09290304;
            break;
        case AreaUnits.squareKilometers:
            area *= 1000000;
            break;
        case AreaUnits.squareMiles:
            area *= 2590000;
            break;
        case AreaUnits.squareYards:
            area *= 0.83612736;
            break;
        case AreaUnits.squareMeters:
    }
    switch (_normalizeAreaUnits(toUnits)) {
        case AreaUnits.acres:
            area /= 4046.8564224;
            break;
        case AreaUnits.hectares:
            area /= 10000;
            break;
        case AreaUnits.squareFeet:
            area /= 0.09290304;
            break;
        case AreaUnits.squareKilometers:
            area /= 1000000;
            break;
        case AreaUnits.squareMiles:
            area /= 2590000;
            break;
        case AreaUnits.squareYards:
            area /= 0.83612736;
            break;
        case AreaUnits.squareMeters:
    }
    return _precision(area, decimals);
}
/**
 * Converts a speed value from one unit to another.
 * Supported units:
 *    kilometersPerHour, milesPerHour, metersPerSecond, feetPerSecond, knots, mach
 * @param speed The speed value to convert.
 * @param fromUnits The speed units to convert from.
 * @param toUnits The speed units to convert to.
 * @param decimals The number of decimal places to round the result to.
 * @returns A speed value convertered from one unit to another.
 */
function convertSpeed(speed, fromUnits, toUnits, decimals) {
    // Convert the speed to kilometers per hour and then convert to the toUnits.
    switch (_normalizeSpeedUnit(fromUnits)) {
        case SpeedUnits.feetPerSecond:
            speed *= 1.09728;
            break;
        case SpeedUnits.milesPerHour:
            speed *= 1.6093;
            break;
        case SpeedUnits.knots:
            speed *= 1.852;
            break;
        case SpeedUnits.metersPerSecond:
            speed *= 3.6;
            break;
        case SpeedUnits.mach:
            speed *= 1234.8;
            break;
        case SpeedUnits.kilometersPerHour:
    }
    // KMPH to toUnit.
    switch (_normalizeSpeedUnit(toUnits)) {
        case SpeedUnits.feetPerSecond:
            speed /= 1.09728;
            break;
        case SpeedUnits.milesPerHour:
            speed /= 1.6093;
            break;
        case SpeedUnits.knots:
            speed /= 1.852;
            break;
        case SpeedUnits.metersPerSecond:
            speed /= 3.6;
            break;
        case SpeedUnits.mach:
            speed /= 1234.8;
            break;
        case SpeedUnits.kilometersPerHour:
    }
    return _precision(speed, decimals);
}
/**
 * Converts a timespan value from one unit to another.
 * Supported units:
 *    ms (milliseconds), hours, minutes, seconds
 * @param timespan The time value to convert.
 * @param fromUnits The time units to convert from.
 * @param toUnits The time units to convert to.
 * @param decimals The number of decimal places to round the result to.
 * @returns A time value convertered from one unit to another.
 */
function convertTimespan(timespan, fromUnits, toUnits, decimals) {
    // Convert the time to seconds as base units.
    switch (_normalizeTimeUnit(fromUnits)) {
        case TimeUnits.ms:
            timespan /= 1000;
            break;
        case TimeUnits.hours:
            timespan *= 3600;
            break;
        case TimeUnits.minutes:
            timespan *= 60;
            break;
        case TimeUnits.days:
            timespan *= 86400;
            break;
        case TimeUnits.seconds:
    }
    // seconds to toUnit.
    switch (_normalizeTimeUnit(toUnits)) {
        case TimeUnits.ms:
            timespan *= 1000;
            break;
        case TimeUnits.hours:
            timespan /= 3600;
            break;
        case TimeUnits.minutes:
            timespan /= 60;
            break;
        case TimeUnits.days:
            timespan /= 86400;
            break;
        case TimeUnits.seconds:
    }
    return _precision(timespan, decimals);
}
/**
 * Calculates an acceleration based on an initial speed, travel distance and timespan. Formula: a = 2*(d - v*t)/t^2
 * @param initialSpeed The initial speed.
 * @param distance The distance that has been travelled.
 * @param timespan The timespan that was travelled.
 * @param distanceUnits The units of the distance information. If not specified meters are used.
 * @param timeUnits The units of the timespan information. If not specified seconds are used.
 * @param speedUnits The units of the speed information. If not specified m/s are used.
 * @param accelerationUnits The units to return the acceleration value in. If not specified m/s^2 are used.
 * @param decimals The number of decimal places to round the result to.
 * @returns An acceleration based on an initial speed, travel distance and timespan.
 */
function getAcceleration(initialSpeed, distance, timespan, speedUnits, distanceUnits, timeUnits, accelerationUnits, decimals) {
    var d = convertDistance(distance, distanceUnits, DistanceUnits.meters);
    var t = convertTimespan(timespan, timeUnits, TimeUnits.seconds);
    var v = convertSpeed(initialSpeed, speedUnits, SpeedUnits.metersPerSecond);
    return convertAcceleration(2 * (d - v * t) / (t * t), AccelerationUnits.metersPerSecondSquared, accelerationUnits, decimals);
}
/**
 * Calculates an acceleration based on an initial speed, final speed and timespan. Formula: a = 2* (v2 - v1)/t
 * @param initialSpeed The initial speed.
 * @param finalSpeed The final speed.
 * @param timespan The timespan that was travelled.
 * @param speedUnits The units of the speed information. If not specified meters are used.
 * @param timeUnits The units of the timespan information. If not specified seconds are used.
 * @param accelerationUnits The units to return the acceleration value in. If not specified m/s^2 are used.
 * @param decimals The number of decimal places to round the result to.
 * @returns An acceleration based on an initial speed, final speed and timespan.
 */
function getAccelerationFromSpeeds(initialSpeed, finalSpeed, timespan, speedUnits, timeUnits, accelerationUnits, decimals) {
    var v1 = convertSpeed(initialSpeed, speedUnits, SpeedUnits.metersPerSecond);
    var v2 = convertSpeed(finalSpeed, speedUnits, SpeedUnits.metersPerSecond);
    var t = convertTimespan(timespan, timeUnits, TimeUnits.seconds);
    return convertAcceleration((v2 - v1) / t, AccelerationUnits.metersPerSecondSquared, accelerationUnits, decimals);
}
/**
 * Calculates an acceleration between two point features that have a timestamp property and optionally a speed property.
 * if speeds are provided, ignore distance between points as the path may not have been straight and calculate: a = (v2 - v1)/(t2 - t1)
 * if speeds not provided or only provided on first point, calculate straight line distance between points and calculate: a = 2*(d - v*t)/t^2
 * @param origin The initial point in which the acceleration is calculated from.
 * @param destination The final point in which the acceleration is calculated from.
 * @param timestampProperty The name of the property on the features that contains the timestamp information.
 * @param speedProperty The name of the property on the features that contains a speed information.
 * @param speedUnits The units of the speed information. If not specified m/s is used.
 * @param accelerationUnits The units to return the acceleration value in. If not specified m/s^2 are used.
 * @param decimals The number of decimal places to round the result to.
 * @returns An acceleration between two point features that have a timestamp property and optionally a speed property. Returns NaN if unable to parse timestamp.
 */
function getAccelerationFromFeatures(origin, destination, timestampProperty, speedProperty, speedUnits, accelerationUnits, decimals) {
    if (typeof timestampProperty === "string" && origin.type === "Feature" && origin.geometry.type === "Point" &&
        destination.type === "Feature" && destination.geometry.type === "Point") {
        var timespan = getTimespan(origin.properties[timestampProperty], destination.properties[timestampProperty], TimeUnits.seconds);
        // Ensure that the start and end point features have the specified timeStamp
        if (!isNaN(timespan)) {
            var v = 0;
            if (speedProperty && typeof speedProperty === "string") {
                var v1 = origin.properties[speedProperty];
                var v2 = destination.properties[speedProperty];
                if (typeof v1 === "number") {
                    v = v1;
                    if (typeof v2 === "number") {
                        return getAccelerationFromSpeeds(v1, v2, timespan, speedUnits, TimeUnits.seconds, accelerationUnits, decimals);
                    }
                }
            }
            var d = getDistanceTo(origin.geometry.coordinates, destination.geometry.coordinates, DistanceUnits.meters);
            return getAcceleration(v, d, timespan, speedUnits, DistanceUnits.meters, TimeUnits.seconds, accelerationUnits, decimals);
        }
    }
    return NaN;
}
/**
 * Calculates the approximate area of a geometry in the specified units
 * @param coordinates The coordinates of the polyon ring.
 * The first ring is the outer/exterior ring and all other rings are the interior ring.
 * @param areaUnits Unit of area measurement. Default is squareMeters.
 * @param decimals The number of decimal places to round the result to.
 * @returns The area of a geometry in the specified units.
 */
function getArea(data, areaUnits, decimals) {
    // https://github.com/Turfjs/turf/blob/master/packages/turf-area/index.ts#L68-L75
    if (data) {
        var area = 0;
        data = data instanceof Shape ? data.toJson() : data;
        switch (data.type) {
            case "Feature":
                var f = data;
                if (f.geometry) {
                    return getArea(f.geometry, areaUnits, decimals);
                }
                break;
            case "Polygon":
                var p = data;
                if (p.coordinates) {
                    area = _calculatePolygonArea(p.coordinates);
                }
                break;
            case "MultiPolygon":
                var mp = data;
                if (mp.coordinates) {
                    for (var i = 0, len = mp.coordinates.length; i < len; i++) {
                        area += _calculatePolygonArea(mp.coordinates[i]);
                    }
                }
                break;
        }
        return convertArea(area, AreaUnits.squareMeters, areaUnits, decimals);
    }
    return 0;
}
/**
 * Calculates the average speed of travel between two points based on the provided amount of time.
 * @param origin The initial point in which the speed is calculated from.
 * @param destination The final point in which the speed is calculated from.
 * @param time The time take to travel between the start and end points.
 * @param timeUnits The units of the time value. If not specified seconds are used.
 * @param speedUnits The units to return the speed value in. If not specified m/s are used.
 * @param decimals The number of decimal places to round the result to.
 * @returns The average speed of travel between two points based on the provided amount of time.
 */
function getSpeed(origin, destination, timespan, timeUnits, speedUnits, decimals) {
    var org = getPosition(origin);
    var dest = getPosition(destination);
    if (org && dest) {
        // Convert the time value to seconds.
        var t = convertTimespan(timespan, timeUnits, TimeUnits.seconds);
        // Calculate the distance`between the points in meters.
        var d = getDistanceTo(org, dest, DistanceUnits.meters);
        // Calculate the speed and convert it into the requested units.
        return convertSpeed(d / t, SpeedUnits.metersPerSecond, speedUnits, decimals);
    }
    return 0;
}
/**
 * Calculates the average speed of travel between two point features that have a property containing a timestamp.
 * The timestamp can be;
 *  - A JavaScript Date object
 *  - A number which represents the number of milliseconds since Jan 1st, 1970.
 *  - A string which uses one of the following formats:
 *      - ISO8601 date format (i.e. 2012-04-23T18:25:43.511Z)
 *      - RFC282 / IETF date syntax (section 3.3)
 *      - OData Date string (i.e. "/Date(1235764800000)/")
 * @param origin The initial point in which the speed is calculated from.
 * @param destination The final point in which the speed is calculated from.
 * @param timestampProperty The name of the property on the features which has the timestamp information.
 * @param speedUnits The units to return the speed value in. If not specified m/s are used.
 * @param decimals The number of decimal places to round the result to.
 * @returns The speed in the specified units or NaN if valid timestamps are not found.
 */
function getSpeedFromFeatures(origin, destination, timestampProperty, speedUnits, decimals) {
    if (typeof timestampProperty === "string" &&
        origin.type === "Feature" && origin.geometry.type === "Point" &&
        destination.type === "Feature" && destination.geometry.type === "Point") {
        var timespan = getTimespan(origin.properties[timestampProperty], destination.properties[timestampProperty], TimeUnits.seconds);
        // Ensure that the start and end point features have the specified timeStamp
        if (!isNaN(timespan)) {
            // Calculate the distance`between the points in meters.
            var d = getDistanceTo(origin.geometry.coordinates, destination.geometry.coordinates, DistanceUnits.meters);
            return convertSpeed(d / timespan, SpeedUnits.metersPerSecond, speedUnits, decimals);
        }
    }
    return NaN;
}
/**
 * Calculates the timespan between two dates or timestamps.
 * Timestamps can be;
 *  - A JavaScript Date object
 *  - A number which represents the number of milliseconds since Jan 1st, 1970.
 *  - A string which uses one of the following formats:
 *      - ISO8601 date format (i.e. 2012-04-23T18:25:43.511Z)
 *      - RFC282 / IETF date syntax (section 3.3)
 *      - OData Date string (i.e. "/Date(1235764800000)/")
 * @param startTime The start date or time.
 * @param endTime The end date or time.
 * @param units The units to return the time value in. If not specified seconds are used.
 * @returns A timespan between two dates or timestamps. Returns NaN if unable to parse timestamps.
 */
function getTimespan(startTime, endTime, units, decimals) {
    var st = parseTimestamp(startTime);
    var et = parseTimestamp(endTime);
    // Ensure that the start and end point features have the specified timeStamp
    if (st != null && et != null) {
        // Calculate timespan between the time stamps in seconds.
        return convertTimespan(et.getTime() - st.getTime(), TimeUnits.ms, units, decimals);
    }
    return NaN;
}
/**
 * Calculates the distance traveled for a specified timespan, speed and optionally an acceleration.
 * Formula: d = v*t + 0.5*a*t^2
 * @param distanceUnits The distance units in which to return the distance in.
 * @param timespan The timespan to calculate the distance for.
 * @param speed The initial or constant speed.
 * @param acceleration Optional. An acceleration which increases the speed over time.
 * @param timeUnits The units of the timespan. If not specified seconds are used.
 * @param speedUnits The units of the speed value. If not specified m/s are used.
 * @param accelerationUnits Optional. The units of the acceleration value. If not specified m/s^2 are used.
 * @param decimals The number of decimal places to round the result to.
 * @returns The distance traveled for a specified timespan, speed and optionally an acceleration.
 */
function getTravelDistance(distanceUnits, timespan, speed, acceleration, timeUnits, speedUnits, accelerationUnits, decimals) {
    // Convert timespan to seconds.
    timespan = convertTimespan(timespan, timeUnits, TimeUnits.seconds);
    // Convert speed to meters per second.
    speed = convertSpeed(speed, speedUnits, SpeedUnits.metersPerSecond);
    var distance = speed * timespan;
    if (typeof acceleration === "number") {
        // Convert acceleration to meters per second squared.
        distance += 0.5 * convertAcceleration(acceleration, accelerationUnits, AccelerationUnits.metersPerSecondSquared) * timespan * timespan;
    }
    return convertDistance(distance, DistanceUnits.meters, distanceUnits, decimals);
}
/**
 * Parses a timestamp into a JavaScript Date object.
 * Timestamps can be;
 *  - A JavaScript Date object
 *  - A number which represents the number of milliseconds since Jan 1st, 1970.
 *  - A string which uses one of the following formats:
 *      - ISO8601 date format (i.e. 2012-04-23T18:25:43.511Z)
 *      - RFC282 / IETF date syntax (section 3.3)
 *      - OData Date string (i.e. "/Date(1235764800000)/")
 * @param timestamp The timestamp value to parse.
 * @returns A Date object that represents the timestamp or null if the timestamp could not be parsed.
 */
function parseTimestamp(timestamp) {
    if (Object.prototype.toString.call(timestamp) === "[object Date]") {
        return timestamp;
    }
    if (typeof timestamp === "string") {
        // ISO8601 date format (i.e. 2012-04-23T18:25:43.511Z)
        // RFC282 / IETF date syntax (section 3.3)
        var d = Date.parse(timestamp);
        if (!isNaN(d)) {
            return new Date(d);
        }
        // OData Date format "/Date(1235764800000)/"
        if (timestamp.indexOf("Date(") >= 0) {
            timestamp = timestamp.replace("/Date(", "").replace(")/", "");
            var ms = 0; // number of milliseconds since midnight Jan 1, 1970
            if (timestamp.indexOf("+") > 0) {
                ms = parseInt(timestamp.substr(0, timestamp.indexOf("+")), 10);
            }
            else if (timestamp.indexOf("-") > 0) {
                ms = parseInt(timestamp.substr(0, timestamp.indexOf("-")), 10);
            }
            else {
                ms = parseInt(timestamp, 10);
            }
            return new Date(ms);
        }
    }
    else if (typeof timestamp === "number") {
        // Assume the number is the number of milliseconds from Jan 1st, 1970.
        return new Date(timestamp);
    }
    return null;
}
/**
 * Calculates a Convex Hull from an array of positions, geometries or features.
 * @param data The array of positions, geometries or features to calculate a convex hull for.
 * @returns A Convex Hull from an array of positions, geometries or features.
 */
function getConvexHull(data) {
    var e_1, _a;
    // Uses a Monotone chain algorithm for convex hulls:
    // https://en.wikibooks.org/wiki/Algorithm_Implementation/Geometry/Convex_hull/Monotone_chain
    var positions = getPositions(data).map(function (pos) {
        return [normalizeLongitude(pos[0]), normalizeLatitude(pos[1])];
    });
    positions.sort(function (a, b) {
        return a[0] === b[0] ? a[1] - b[1] : a[0] - b[0];
    });
    var lower = [];
    try {
        for (var positions_1 = __values$i(positions), positions_1_1 = positions_1.next(); !positions_1_1.done; positions_1_1 = positions_1.next()) {
            var position = positions_1_1.value;
            while (lower.length >= 2 && _cross(lower[lower.length - 2], lower[lower.length - 1], position) <= 0) {
                lower.pop();
            }
            lower.push(position);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (positions_1_1 && !positions_1_1.done && (_a = positions_1.return)) _a.call(positions_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var upper = [];
    for (var i = positions.length - 1; i >= 0; i--) {
        while (upper.length >= 2 && _cross(upper[upper.length - 2], upper[upper.length - 1], positions[i]) <= 0) {
            upper.pop();
        }
        upper.push(positions[i]);
    }
    return new Polygon([lower.concat(upper)]);
}
/**
 * Retrieves an array of all positions in the provided geometry, feature or array of geometries/features.
 * @param data The geometries or features to retrieve the positions from.
 * @returns An array of all positions in the provided geometry, feature or array of geometries/features.
 */
function getPositions(data) {
    var loc = [];
    var loc2d = null;
    var loc3d = null;
    if (Array.isArray(data) && data.length > 0) {
        if (Array.isArray(data[0]) && typeof data[0][0] === "number") {
            loc = data;
        }
        else {
            var len = data.length;
            for (var i = 0; i < len; i++) {
                loc = loc.concat(getPositions(data[i]));
            }
        }
    }
    else if (data["type"]) {
        switch (data["type"]) {
            case "Point":
                loc = [data.coordinates];
                break;
            case "LineString":
                loc = data.coordinates;
                break;
            case "Polygon":
                loc2d = data.coordinates;
                break;
            case "MultiPoint":
                loc = data.coordinates;
                break;
            case "MultiLineString":
                loc2d = data.coordinates;
                break;
            case "MultiPolygon":
                loc3d = data.coordinates;
                break;
            case "Feature":
                var f = data;
                if (Shape._isCircle(f)) {
                    loc = Shape._getCirclePositions(f);
                }
                else {
                    loc = getPositions(f.geometry);
                }
                break;
            case "FeatureCollection":
                loc = getPositions(data.features);
                break;
            case "GeometryCollection":
                loc = getPositions(data.geometries);
                break;
        }
    }
    else if (data instanceof Shape) {
        return getPositions(data.toJson());
    }
    if (loc2d) {
        var len = loc2d.length;
        for (var i = 0; i < len; i++) {
            loc = loc.concat(loc2d[i]);
        }
    }
    else if (loc3d) {
        var outerLen = loc3d.length;
        for (var i = 0; i < outerLen; i++) {
            var innerLen = loc3d[i].length;
            for (var j = 0; j < innerLen; j++) {
                loc = loc.concat(loc3d[i][j]);
            }
        }
    }
    return loc;
}
/**
 * Gets the position of an object that is a position, point, point feature, or circle. If it is a circle, its center coordinate will be returned.
 * @param data The data object to extract the position from.
 * @returns The position of an object that is a position, point, or point feature. Returns null if invalid data passed in.
 */
function getPosition(data) {
    if (Array.isArray(data) && typeof data[0] === "number") {
        return data;
    }
    else if (data["type"]) {
        if (data["type"] === "Point") {
            return data.coordinates;
        }
        else if (data["type"] === "Feature" && data["geometry"]["type"] === "Point") {
            return data.geometry.coordinates;
        }
    }
    else if (data instanceof Shape && data.getType() === "Point") {
        return data.getCoordinates();
    }
    return null;
}
/**
 * Gets an array of evenly spaced positions along a path.
 * @param path The path to get the positions from.
 * @param numPositions The number of positions to get.
 * @returns An array of evenly spaced positions along a path.
 */
function getPositionsAlongPath(path, numPositions) {
    if (numPositions < 2) {
        return [];
    }
    var positions = [];
    var len = getLengthOfPath(path, DistanceUnits.meters);
    // Calculate the gaps between the positions. There is one less gap than there are positions.
    var dx = len / (numPositions - 1);
    for (var i = 0; i < numPositions; i++) {
        var p = getPositionAlongPath(path, dx * i, DistanceUnits.meters);
        if (p != null) {
            positions.push(p);
        }
    }
    return positions;
}
/**
 * Gets a point with heading a specified distance along a path.
 * @param path The path to get the point from.
 * @param distance The distance along the path to get the point at.
 * @param units The distance units.
 * @returns A point with heading a specified distance along a path.
 */
function getPointWithHeadingAlongPath(path, distance, units) {
    units = units || "meters";
    var travelled = 0;
    var dx;
    var locs;
    if (Array.isArray(path)) {
        locs = path;
    }
    else if (path.type && path.type === "LineString") {
        locs = path.coordinates;
    }
    if (locs.length >= 2) {
        var len = locs.length;
        for (var i = 1; i < len; i++) {
            dx = getDistanceTo(locs[i - 1], locs[i], units);
            if (travelled + dx >= distance) {
                // Overshot
                var heading = getHeading(locs[i - 1], locs[i]);
                var p = getDestination(locs[i - 1], heading, distance - travelled, units);
                return new Feature(new Point(p), {
                    heading: heading
                });
            }
            travelled += dx;
        }
        if (distance >= travelled) {
            return new Feature(new Point(locs[len - 1]), {
                heading: getHeading(locs[len - 2], locs[len - 1])
            });
        }
        return new Feature(new Point(locs[0]), {
            heading: getHeading(locs[0], locs[1])
        });
    }
    return null;
}
/**
 * Gets an array of evenly spaced points with headings along a path.
 * @param path The path to get the positions from.
 * @param numPoints The number of points to get.
 * @returns An array of evenly spaced points with headings along a path.
 */
function getPointsWithHeadingsAlongPath(path, numPoints) {
    if (numPoints <= 0) {
        return [];
    }
    var points = [];
    var len = getLengthOfPath(path, DistanceUnits.meters);
    // Calculate the gaps between the points. There is one less gap than there are points.
    var dx = len / (numPoints - 1);
    for (var i = 0; i < numPoints; i++) {
        var p = getPointWithHeadingAlongPath(path, dx * i, DistanceUnits.meters);
        if (p != null) {
            points.push(p);
        }
    }
    return points;
}
/**
 * Calculates the closest point on the edge of a geometry to a specified point or position.
 * The returned point feature will have a `distance` property that specifies the distance between the two points in the specified units.
 * If the geometry is a Point, that points position will be used for the result.
 * If the geometry is a MultiPoint, the distances to the individual positions will be used.
 * If the geometry is a Polygon or MultiPolygon, the point closest to any edge will be returned regardless of if the point intersects the geometry or not.
 * @param pt The point or position to find the closest point on the edge of the geometry.
 * @param geom The geometry to find the closest point on.
 * @param units Unit of distance measurement. Default is meters.
 * @param decimals The number of decimal places to round the result to.
 * @returns
 */
function getClosestPointOnGeometry(pt, geom, units, decimals) {
    // Does not support geometries that cross the antimerdian.
    var pos = getPosition(pt);
    var px = mercatorPositionsToPixels([pos], 22)[0];
    var result = null;
    var paths;
    var minDis = Infinity;
    geom = geom instanceof Shape ? geom.toJson() : geom;
    switch (geom.type) {
        case "Feature":
            return getClosestPointOnGeometry(pt, geom.geometry, units);
        case "Point":
            paths = [[geom.coordinates]];
            break;
        case "MultiPoint":
            var d = void 0;
            var mp = geom.coordinates;
            for (var i = 0, len = mp.length; i < len; i++) {
                d = getDistanceTo(pos, mp[i]);
                if (d < minDis) {
                    minDis = d;
                    result = new Feature(new Point(mp[i]), {
                        distance: d
                    });
                }
            }
            break;
        case "LineString":
            paths = [geom.coordinates];
            break;
        case "Polygon":
        case "MultiLineString":
            paths = geom.coordinates;
            break;
        case "MultiPolygon":
            var mPaths = geom.coordinates;
            if (mPaths.length > 0) {
                paths = mPaths[0];
                for (var i = 1, len = mPaths.length; i < len; i++) {
                    paths = paths.concat(mPaths[i]);
                }
            }
            break;
    }
    if (paths) {
        var temp = void 0;
        for (var i = 0, len = paths.length; i < len; i++) {
            temp = _closestPointOnPath(pos, px, paths[i]);
            if (temp && temp.properties.distance < minDis) {
                minDis = temp.properties.distance;
                result = temp;
            }
        }
    }
    if (result) {
        result.properties.distance = convertDistance(result.properties.distance, "meters", units, decimals);
    }
    return result;
}

var __extends$17 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A GeoJSON Position object - an array that specifies the longitude and latitude of a location. The
 * full description is detailed in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.1}.
 */
var Position = /** @class */ (function (_super) {
    __extends$17(Position, _super);
    /**
     * Constructs a Position.
     * @param longitude The position's longitude.
     * @param latitude The position's latitude.
     * @param elevation The position's elevation.
     */
    function Position(longitude, latitude, elevation) {
        var _this = this;
        if (elevation) {
            _this = _super.call(this, longitude, latitude, elevation) || this;
        }
        else {
            _this = _super.call(this, longitude, latitude) || this;
        }
        return _this;
    }
    /**
     * Clones a position.
     * @param position The position to clone.
     */
    Position.fromPosition = function (position) {
        if (position.length === 2) {
            return new Position(position[0], position[1]);
        }
        else if (position.length > 2) {
            return new Position(position[0], position[1], position[2]);
        }
        return null;
    };
    /**
     * Compares the longitude and latitude values of two positions to see if they are equal at an accuracy of 6 decimal places.
     * @param pos1 First position to compare.
     * @param pos2 Second position to compare.
     * @param precision The number of decimal places to compare to. Default: 6.
     * @returns A boolean indicating if two positions to see if they are equal at an accuracy of the specified precision or 6 decimal places.
     */
    Position.areEqual = function (pos1, pos2, precision) {
        if (typeof (precision) === "undefined") {
            precision = 6;
        }
        if (pos1 && pos1.length >= 2 && pos2 && pos2.length >= 2) {
            var offset = Math.pow(10, precision);
            var lat1 = normalizeLatitude(pos1[1]);
            var lat2 = normalizeLatitude(pos2[1]);
            var lon1 = normalizeLongitude(pos1[0]);
            var lon2 = normalizeLongitude(pos2[0]);
            var latDiff = Math.round((lat1 - lat2) * offset) / offset;
            if (latDiff !== 0) {
                return false;
            }
            // A diff of 360 is also allowed because -180 and 180 are the same longitude
            var lonDiff = Math.round((lon1 - lon2) * offset) / offset;
            if (lonDiff !== 0 && lonDiff !== 360) {
                return false;
            }
            return true;
        }
        return false;
    };
    Position.fromLatLng = function (y, x, z) {
        var position = [];
        if (typeof y === "number") {
            if (typeof x === "number") {
                position.push(x);
            }
            position.push(y);
            if (typeof z === "number") {
                position.push(z);
            }
        }
        else if (Array.isArray(y)) {
            // Assume array is in the form [lat, lng] or [lat, lng, elv]
            if (y.length >= 2 && typeof y[0] === "number" && typeof y[1] === "number") {
                if (y.length >= 3 && typeof y[2] === "number") {
                    position.push(y[1], y[0], y[2]);
                }
                else {
                    position.push(y[1], y[0]);
                }
            }
        }
        else if (typeof y === "object") {
            // Consider pulling these out into static variable so that we don't constantly create instances of these.
            var latNames_1 = ["lat", "latitude", "y"];
            var lngNames_1 = ["lng", "longitude", "lon", "x"];
            var elvNames_1 = ["elv", "elevation", "alt", "altitude", "z"];
            var lat_1 = NaN;
            var lng_1 = NaN;
            var elv_1 = NaN;
            // Do a case insensitive search through the object properties.
            Object.keys(y).forEach(function (key, idx, arr) {
                var smallKey = key.toLowerCase();
                if (isNaN(lat_1) && latNames_1.indexOf(smallKey) >= 0 && typeof y[key] === "number") {
                    lat_1 = y[key];
                }
                else if (isNaN(lng_1) && lngNames_1.indexOf(smallKey) >= 0 && typeof y[key] === "number") {
                    lng_1 = y[key];
                }
                else if (isNaN(elv_1) && elvNames_1.indexOf(smallKey) >= 0 && typeof y[key] === "number") {
                    elv_1 = y[key];
                }
            });
            if (!isNaN(lat_1) && !isNaN(lng_1)) {
                position.push(lng_1, lat_1);
                if (!isNaN(elv_1)) {
                    position.push(elv_1);
                }
            }
        }
        if (position.length >= 2) {
            return position;
        }
        return null;
    };
    /**
     * Converts an array of objects that contain coordinate information into an array of Positions. Objects that can't be converted are discarded.
     * Each object is either an array in the format; [lat, lng] or [lat, lng, elv], or an object with the any combination of the following properties:
     * Longitude: lng, longitude, lon, x
     * Latitude: lat, latitude, y
     * Elevation: elv, elevation, alt, altitude, z
     * @param latLngs The objects that contain coordinate information.
     * @returns An array of Position objects that contain all the provided coordinate information.
     */
    Position.fromLatLngs = function (latLngs) {
        var positions = [];
        if (Array.isArray(latLngs)) {
            for (var i = 0, len = latLngs.length; i < len; i++) {
                var p = Position.fromLatLng(latLngs[i]);
                // skip undetermined positions.
                if (p) {
                    positions.push(p);
                }
            }
        }
        return positions;
    };
    /**
     * Returns the number of dimensions in the specified coordinates.
     * Does not include the extra dimension form the Position type.
     * @param coords The coordinates to get the dimension count for.
     * @private
     */
    Position._getDimensions = function (coords) {
        var count = 0;
        while (Array.isArray(coords)) {
            coords = coords[0];
            count++;
        }
        // If the inner most array has a number for it's first
        // element it is a position and the count must be reduced by 1.
        if (typeof coords === "number") {
            count--;
        }
        return count;
    };
    return Position;
}(Array));

/**
 * A GeoJSON Polygon object - a JSON object that represents a geographic polygon. The full description is detailed in
 * [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.6}.
 */
var Polygon = /** @class */ (function () {
    /**
     * Constructs a Polygon.
     * @param coordinates The array of linear ring coordinate arrays defining the polygon.
     * @param bbox The bounding box of the polygon.
     */
    function Polygon(coordinates, bbox) {
        /**
         * A GeoJSON type descriptor with value "Polygon".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "Polygon";
        this.type = Polygon.TYPE;
        // check if it has only one ring
        if (Position._getDimensions(coordinates) === 1) {
            this.coordinates = [coordinates];
        }
        else {
            this.coordinates = coordinates;
        }
        this.bbox = bbox;
    }
    /**
     * A static GeoJSON type descriptor for the Polygon class to be used in runtime comparisons.
     */
    Polygon.TYPE = "Polygon";
    return Polygon;
}());

var __extends$16 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values$h = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A helper class that wraps a Geometry or Feature and makes it easy to update and maintain.
 */
var Shape = /** @class */ (function (_super) {
    __extends$16(Shape, _super);
    function Shape(data, id, properties) {
        var _this = _super.call(this) || this;
        var geometry;
        if (data.type === "Feature") {
            var feature = data;
            geometry = cloneDeep$1(feature.geometry);
            properties = feature.properties ? cloneDeep$1(feature.properties) : {};
            id = feature.id == null || feature.id === "" ? uuid() : feature.id;
        }
        else {
            geometry = cloneDeep$1(data);
            id = id == null || id === "" ? uuid() : id;
            properties = properties ? cloneDeep$1(properties) : {};
        }
        // Assign the feature's id to another property to workaround the Mapbox bug
        // that prevents non-numerical ids from being returned by some functions.
        // TODO Remove once this issue if fixed. https://github.com/mapbox/mapbox-gl-js/issues/2716
        properties[Shape._shapeIdPropName] = id;
        // Always create a new feature to guarantee the data matches our definition of a Feature.
        _this.data = new Feature(geometry, properties, id);
        _this._handleCircle();
        return _this;
    }
    /**
     * Adds or updates an existing property value in the shape.
     * @param key
     * @param value
     */
    Shape.prototype.addProperty = function (key, value) {
        // Only add the property if it is a new value.
        if (!isEqual$1(this.data.properties[key], value)) {
            this.data.properties[key] = cloneDeep$1(value);
            if (key === "subType" || key === "radius") {
                this._handleCircle();
            }
            if (this.dataSource) {
                this.dataSource._updateSource();
            }
            this._invokeEvent("shapechanged", this);
        }
    };
    /**
     * Gets the bounding box of the shape
     */
    Shape.prototype.getBounds = function () {
        var e_1, _a, e_2, _b;
        var positions = this.getCoordinates();
        var bbox;
        var geoType = this.getType();
        if (geoType === "Point") {
            if (this.circlePolygon) { // If a circle from the extended GeoJSON spec.
                var pos = this.circlePolygon.geometry.coordinates;
                bbox = BoundingBox.fromPositions(pos[0]);
            }
            else {
                var pos = positions;
                bbox = new BoundingBox(pos, pos);
            }
        }
        else if (geoType === "MultiPoint" || geoType === "LineString") {
            var pos = positions;
            bbox = BoundingBox.fromPositions(pos);
        }
        else if (geoType === "Polygon") {
            var pos = positions;
            // only need to check the exterior ring of Polygon
            bbox = BoundingBox.fromPositions(pos[0]);
        }
        else if (geoType === "MultiLineString") {
            var pos = positions;
            try {
                for (var pos_1 = __values$h(pos), pos_1_1 = pos_1.next(); !pos_1_1.done; pos_1_1 = pos_1.next()) {
                    var p = pos_1_1.value;
                    bbox = BoundingBox.merge(bbox, BoundingBox.fromPositions(p));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (pos_1_1 && !pos_1_1.done && (_a = pos_1.return)) _a.call(pos_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else if (geoType === "MultiPolygon") {
            var pos = positions;
            try {
                for (var pos_2 = __values$h(pos), pos_2_1 = pos_2.next(); !pos_2_1.done; pos_2_1 = pos_2.next()) {
                    var p1 = pos_2_1.value;
                    // only need to check the exterior ring of Polygon
                    bbox = BoundingBox.merge(bbox, BoundingBox.fromPositions(p1[0]));
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (pos_2_1 && !pos_2_1.done && (_b = pos_2.return)) _b.call(pos_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        return bbox;
    };
    /**
     * Gets the coordinates of the shape.
     */
    Shape.prototype.getCoordinates = function () {
        return cloneDeep$1(this.data.geometry.coordinates);
    };
    /**
     * If the shape is a circle, this gets its coordinates. Otherwise returns null.
     */
    Shape.prototype.getCircleCoordinates = function () {
        if (this.circlePolygon) {
            return cloneDeep$1(this.circlePolygon.geometry.coordinates[0]);
        }
        else {
            return null;
        }
    };
    /**
     * Gets the id of the shape.
     */
    Shape.prototype.getId = function () {
        return this.data.id;
    };
    /**
     * Gets the properties of the shape.
     */
    Shape.prototype.getProperties = function () {
        return cloneDeep$1(this.data.properties);
    };
    /**
     * Returns a string indicating the type of geometry this shape contains.
     */
    Shape.prototype.getType = function () {
        return this.data.geometry.type;
    };
    /**
     * Indicates if the contained shape is a Circle, defined by the extended GeoJSON specification supported by Azure Maps.
     * [Extended Spec]{@link https://docs.microsoft.com/en-us/azure/azure-maps/extend-geojson}
     */
    Shape.prototype.isCircle = function () {
        return Shape._isCircle(this.data);
    };
    /**
     * Indicates if the contained shape is a Rectangle, defined by the extended GeoJSON specification supported by Azure Maps.
     * [Extended Spec]{@link https://docs.microsoft.com/en-us/azure/azure-maps/extend-geojson}
     */
    Shape.prototype.isRectangle = function () {
        return Shape._isRectangle(this.data);
    };
    /**
     * Updates the coordinates of the shape
     * @param coords Point: Position, LineString: Position[], Polygon: Position[][],
     * MultiPoint: Position[], MultiLineString: Position[][], MultiPolygon: Position[][]
     */
    Shape.prototype.setCoordinates = function (coords) {
        // If a Position[] is supplied for a polygon wrap it in an array.
        var newCoords;
        if (this.getType() === "Polygon" &&
            Position._getDimensions(coords) === 1) {
            newCoords = [coords];
        }
        else {
            newCoords = coords;
        }
        // Only update the coordinates if they've actually changed.
        if (!isEqual$1(this.data.geometry.coordinates, newCoords)) {
            this.data.geometry.coordinates = cloneDeep$1(newCoords);
            this._handleCircle();
            if (this.dataSource) {
                this.dataSource._updateSource();
            }
            this._invokeEvent("shapechanged", this);
        }
    };
    /**
     * Sets the properties on the shape. Overwrites all existing properties.
     * @param properties
     */
    Shape.prototype.setProperties = function (properties) {
        // Assign the feature's id to another property to workaround the Mapbox bug
        // that prevents non-numerical ids from being returned by some functions.
        // TODO Remove once this issue if fixed. https://github.com/mapbox/mapbox-gl-js/issues/2716
        properties[Shape._shapeIdPropName] = this.data.id;
        // Only update the properties if they've actually changed.
        if (!isEqual$1(this.data.properties, properties)) {
            this.data.properties = cloneDeep$1(properties);
            this._handleCircle();
            if (this.dataSource) {
                this.dataSource._updateSource();
            }
            this._invokeEvent("shapechanged", this);
        }
    };
    /**
     * Returns a GeoJSON feature that represents the shape.
     */
    Shape.prototype.toJson = function () {
        return JSON.parse(JSON.stringify(this.data));
    };
    /**
     * Just like the toJson() function but will return a polygon feature
     * for any circles as defined by the extended GeoJSON spec.
     * [Extended Spec]{@link https://docs.microsoft.com/en-us/azure/azure-maps/extend-geojson}
     * @internal
     */
    Shape.prototype._toJson = function () {
        return this.circlePolygon || this.data;
    };
    /**
     * @internal
     */
    Shape.prototype._setDataSource = function (dataSource) {
        if (dataSource === undefined || dataSource == null) {
            delete this.dataSource;
        }
        else {
            this.dataSource = dataSource;
        }
    };
    /**
     * Check if the shape's wrapped feature is a circle form the extended GeoJSON spec.
     * If so it will calculate a polygon feature that approximates the specified circle.
     * @private
     */
    Shape.prototype._handleCircle = function () {
        if (this.isCircle()) {
            var coords = Shape._getCirclePositions(this.data);
            this.circlePolygon = new Feature(new Polygon([coords]), this.data.properties, this.data.id);
            // Set the subType to "Circle" to make sure the case is correct.
            this.data.properties.subType = "Circle";
        }
        else {
            delete this.circlePolygon;
        }
    };
    /**
     * Indicates if the specified feature is a circle, defined by the extended GeoJSON specification supported by Azure Maps.
     * [Extended Spec]{@link https://docs.microsoft.com/en-us/azure/azure-maps/extend-geojson}
     * @internal
     */
    Shape._isCircle = function (data) {
        return data && data.geometry &&
            data.geometry.type === "Point" &&
            data.geometry.coordinates && data.properties &&
            typeof data.properties.subType === "string" &&
            data.properties.subType.toLowerCase() === "circle" &&
            typeof data.properties.radius === "number";
    };
    /**
     * Indicates if the specified feature is a rectangle, defined by the extended GeoJSON specification supported by Azure Maps.
     * [Extended Spec]{@link https://docs.microsoft.com/en-us/azure/azure-maps/extend-geojson}
     * @internal
     */
    Shape._isRectangle = function (data) {
        if (data.geometry.type === "Polygon" &&
            data.geometry.coordinates &&
            typeof data.properties.subType === "string" &&
            data.properties.subType.toLowerCase() === "rectangle") {
            // If type is Polygon we can assume the coordinates are a Position[][].
            var coords = data.geometry.coordinates;
            if (coords.length === 1) {
                var ring = coords[0];
                if (ring.length === 5) {
                    return ring[0][0] === ring[4][0] &&
                        ring[0][1] === ring[4][1];
                }
                else if (ring.length === 4) {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * Calculates to positions that should be used to approximate the specified circle feature.
     * @internal
     */
    Shape._getCirclePositions = function (data) {
        return getRegularPolygonPath(data.geometry.coordinates, data.properties.radius, 72, "meters");
    };
    /**
     * Represents the feature property name that the shape's id will be assigned to.
     * This is a workaround for the Mapbox bug preventing non-numerical ids from being returned by some functions.
     * TODO Remove once this issue if fixed.
     * {@link https://github.com/mapbox/mapbox-gl-js/issues/2716}
     * @internal
     */
    // tslint:disable-next-line: variable-name
    Shape._shapeIdPropName = "_azureMapsShapeId";
    return Shape;
}(EventEmitter));

var __extends$15 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values$g = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A GeoJSON BoundingBox object - an array that defines a shape whose edges follow lines of constant longitude,
 * latitude, and elevation. All axes of the most southwesterly point are followed by all axes of the more northeasterly
 * point. The axes order of the BoundingBox follows the axes order of geometries. The full description is detailed in
 * [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-5}.
 */
var BoundingBox = /** @class */ (function (_super) {
    __extends$15(BoundingBox, _super);
    function BoundingBox(southwestPositionOrPositions, northeastPosition) {
        var _this = this;
        if (southwestPositionOrPositions && northeastPosition) {
            var southwestPosition = southwestPositionOrPositions;
            if (southwestPosition[2] && northeastPosition[2]) {
                _this = _super.call(this, southwestPosition[0], southwestPosition[1], southwestPosition[2] || 0, northeastPosition[0], northeastPosition[1], northeastPosition[2] || 0) || this;
            }
            else {
                _this = _super.call(this, southwestPosition[0], southwestPosition[1], northeastPosition[0], northeastPosition[1]) || this;
            }
        }
        else if (southwestPositionOrPositions) {
            var positions = southwestPositionOrPositions;
            if (positions) {
                if (positions.length === 4) {
                    // [west, south, east, north]
                    _this = _super.call(this, positions[0], positions[1], positions[2], positions[3]) || this;
                }
                else if (positions.length >= 6) {
                    // [west, south, elevation1, east, north, elevation2]
                    _this = _super.call(this, positions[0], positions[1], positions[2], positions[3], positions[4], positions[5]) || this;
                }
            }
        }
        return _this;
    }
    /**
     * Clones a bounding box.
     * @param boundingBox The bounding box to clone.
     */
    BoundingBox.fromBoundingBox = function (boundingBox) {
        var west = BoundingBox.getWest(boundingBox);
        var south = BoundingBox.getSouth(boundingBox);
        var east = BoundingBox.getEast(boundingBox);
        var north = BoundingBox.getNorth(boundingBox);
        return new BoundingBox([west, south, east, north]);
    };
    /**
     * Constructs a BoundingBox from the specified dimensions.
     * @param center The center position of the bounding box.
     * @param width The width of the bounding box.
     * @param height The height of the bounding box.
     */
    BoundingBox.fromDimensions = function (center, width, height) {
        var lon = center[0];
        var lat = center[1];
        var north = Math.min(Math.max(lat + height / 2, -85.5), 85.5);
        var south = Math.min(Math.max(lat - height / 2, -85.5), 85.5);
        var east = normalizeLongitude(lon + width / 2);
        var west = normalizeLongitude(lon - width / 2);
        return new BoundingBox([west, south, east, north]);
    };
    /**
     * Constructs a BoundingBox from the specified edges.
     * @param west The west edge of the bounding box.
     * @param south The south edge of the bounding box.
     * @param east The east edge of the bounding box.
     * @param north The north edge of the bounding box.
     */
    BoundingBox.fromEdges = function (west, south, east, north) {
        return new BoundingBox([west, south, east, north]);
    };
    /**
     * Determines if a position is within a bounding box.
     * @param bounds The bounding box to see if the position is in.
     * @param position The position to see if it is in the bounding box.
     * @returns True if the position is within the bounding box.
     */
    BoundingBox.containsPosition = function (bounds, position) {
        // Allow a small difference to account for arithmetic accuracy errors.
        // This is important for points on the edge of the bounding box which is the case when using BoundingBox.fromLocations
        var accuracyAllowance = 0.00000001;
        // Use the distance between the position and center of the bounding box to determine if they intersect.
        var center = BoundingBox.getCenter(bounds);
        var diffLatitude = Math.abs(center[1] - position[1]);
        var diffLongitude = Math.abs(center[0] - position[0]);
        if (diffLongitude > 180.0) {
            // We want the shortest distance between the 2 points.
            diffLongitude = 360 - diffLongitude;
        }
        var height = BoundingBox.getHeight(bounds);
        var width = BoundingBox.getWidth(bounds);
        return (diffLatitude <= (height / 2) + accuracyAllowance) && (diffLongitude <= (width / 2) + accuracyAllowance);
    };
    /**
     * Determines if a bounding box is within another bounding box
     * @param outer The outer bounding box
     * @param inner The inner bounding box (the one that should be contained within outer)
     * @returns True if the inner bounding box is fully container in outer
     */
    BoundingBox.containsBoundingBox = function (outer, inner) {
        var outerValid = outer && outer.length === 4;
        var innerValid = inner && inner.length === 4;
        if (!outerValid || !innerValid) {
            return false;
        }
        return BoundingBox.getWest(outer) < BoundingBox.getWest(inner) && BoundingBox.getWest(inner) < BoundingBox.getEast(outer) &&
            BoundingBox.getWest(outer) < BoundingBox.getEast(inner) && BoundingBox.getEast(inner) < BoundingBox.getEast(outer) &&
            BoundingBox.getSouth(outer) < BoundingBox.getSouth(inner) && BoundingBox.getSouth(inner) < BoundingBox.getNorth(outer) &&
            BoundingBox.getSouth(outer) < BoundingBox.getNorth(inner) && BoundingBox.getNorth(inner) < BoundingBox.getNorth(outer);
    };
    /**
     * Returns a boolean indicating if the bounding box crosses the antimeridian or not.
     * @param bounds The bounding box to check.
     * @returns A boolean indicating if the bounding box crosses the antimeridian or not.
     */
    BoundingBox.crossesAntimeridian = function (bounds) {
        var east = normalizeLongitude(BoundingBox.getEast(bounds));
        var west = normalizeLongitude(BoundingBox.getWest(bounds));
        return (east - west) < 0
            || BoundingBox.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe(bounds)
            || BoundingBox.isBoundingBoxWithLessThanSixElementsLargerThanGlobe(bounds);
    };
    /**
     * Calculates the center of a bounding box.
     * @param bounds A bounding box to calculate the center of.
     * @returns A position that represents the center of the bounding box.
     */
    BoundingBox.getCenter = function (bounds) {
        // [west, south, east, north]
        var east = normalizeLongitude(BoundingBox.getEast(bounds));
        var west = normalizeLongitude(BoundingBox.getWest(bounds));
        if (west > east) {
            east += 360.0;
        }
        var centerLongitude = normalizeLongitude((west + east) / 2.0);
        var south = normalizeLatitude(BoundingBox.getSouth(bounds));
        var north = normalizeLatitude(BoundingBox.getNorth(bounds));
        var centerLatitude = normalizeLatitude((south + north) / 2.0);
        return [centerLongitude, centerLatitude];
    };
    /**
     * Gets the height of a bounding box in degrees.
     * @param bounds The bounding box to check.
     * @returns The height of the bounding box in degrees.
     */
    BoundingBox.getHeight = function (bounds) {
        var north = normalizeLatitude(BoundingBox.getNorth(bounds));
        var south = normalizeLatitude(BoundingBox.getSouth(bounds));
        var height = north - south;
        return isNaN(height) ? 0 : height;
    };
    /**
     * Gets the width of a bounding box in degrees.
     * @param bounds The bounding box to check.
     * @returns The width of the bounding box in degrees.
     */
    BoundingBox.getWidth = function (bounds) {
        var east = normalizeLongitude(BoundingBox.getEast(bounds));
        var west = normalizeLongitude(BoundingBox.getWest(bounds));
        var width = east - west;
        // Check to see if bounds crosses antimeridian
        return isNaN(width) ? 0 : width < 0 ? width += 360 : width;
    };
    /**
     * Returns the south west position of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The south west position of the bounding box.
     */
    BoundingBox.getSouthWest = function (bounds) {
        var south = this.getSouth(bounds);
        var west = this.getWest(bounds);
        return (isNaN(south) || isNaN(west)) ? null : [west, south];
    };
    /**
     * Returns the north east position of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The north east position of the bounding box.
     */
    BoundingBox.getNorthEast = function (bounds) {
        var north = this.getNorth(bounds);
        var east = this.getEast(bounds);
        return (isNaN(north) || isNaN(east)) ? null : [east, north];
    };
    /**
     * Returns the north west position of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The north west position of the bounding box.
     */
    BoundingBox.getNorthWest = function (bounds) {
        var north = this.getNorth(bounds);
        var west = this.getWest(bounds);
        return (isNaN(north) || isNaN(west)) ? null : [west, north];
    };
    /**
     * Returns the south east position of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The south east position of the bounding box.
     */
    BoundingBox.getSouthEast = function (bounds) {
        var south = this.getSouth(bounds);
        var east = this.getEast(bounds);
        return (isNaN(south) || isNaN(east)) ? null : [east, south];
    };
    /**
     * Returns the south position value of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The south position value of the bounding box.
     */
    BoundingBox.getSouth = function (bounds) {
        if (bounds && bounds.length >= 4) {
            return Number(bounds[1]);
        }
        return NaN;
    };
    /**
     * Returns the west position value of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The west position value of the bounding box.
     */
    BoundingBox.getWest = function (bounds) {
        if (bounds && bounds.length >= 4) {
            return Number(bounds[0]);
        }
        return NaN;
    };
    /**
     * Returns the north position value of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The north position value of the bounding box.
     */
    BoundingBox.getNorth = function (bounds) {
        if (bounds) {
            if (bounds.length === 4) {
                return Number(bounds[3]);
            }
            else if (bounds.length === 6) {
                return Number(bounds[4]);
            }
        }
        return NaN;
    };
    /**
     * Returns the east position value of the bounding box.
     * @param bounds The bounding box to get the position from.
     * @returns The east position value of the bounding box.
     */
    BoundingBox.getEast = function (bounds) {
        if (bounds) {
            if (bounds.length === 4) {
                return Number(bounds[2]);
            }
            else if (bounds.length === 6) {
                return Number(bounds[3]);
            }
        }
        return NaN;
    };
    /**
     * Determines is two bounding boxes intersect.
     * @param bounds1 The first bounding box to compare with.
     * @param bounds2 The second bounding box to compare with.
     * @returns true if the provided bounding boxes intersect.
     */
    BoundingBox.intersect = function (bounds1, bounds2) {
        var center1 = BoundingBox.getCenter(bounds1);
        var center2 = BoundingBox.getCenter(bounds2);
        // Use the distance between the 2 centers to determine if they intersect.
        var diffLatitude = Math.abs(center1[1] - center2[1]);
        var diffLongitude = Math.abs(center1[0] - center2[0]);
        if (diffLongitude > 180.0) {
            // We want the shortest distance between the 2 points.
            diffLongitude = 360 - diffLongitude;
        }
        var height1 = BoundingBox.getHeight(bounds1);
        var width1 = BoundingBox.getWidth(bounds1);
        var height2 = BoundingBox.getHeight(bounds2);
        var width2 = BoundingBox.getWidth(bounds2);
        return (diffLatitude <= (height1 / 2 + height2 / 2) && diffLongitude <= (width1 / 2 + width2 / 2));
    };
    /**
     * Merges two bounding boxes together.
     * @param bounds1 The first bounding box to merge with.
     * @param bounds2 The second bounding box to merge with.
     * @returns A bounding box in the format [minLon, minLat, maxLon, maxLat].
     */
    BoundingBox.merge = function (bounds1, bounds2) {
        var bb1Valid = bounds1 && bounds1.length === 4;
        var bb2Valid = bounds2 && bounds2.length === 4;
        if (bb1Valid && !bb2Valid) {
            return bounds1;
        }
        else if (bb2Valid && !bb1Valid) {
            return bounds2;
        }
        else if (!bb1Valid && !bb2Valid) {
            return null;
        }
        var north = Math.max(normalizeLatitude(BoundingBox.getNorth(bounds1)), normalizeLatitude(BoundingBox.getNorth(bounds2)));
        var south = Math.min(normalizeLatitude(BoundingBox.getSouth(bounds1)), normalizeLatitude(BoundingBox.getSouth(bounds2)));
        // Find out the longitude spans of the two bounding boxes.
        var boundingBoxes = [bounds1, bounds2];
        var longIntervals = [];
        var i = 0;
        for (i = 0; i < boundingBoxes.length; i++) {
            var b = boundingBoxes[i];
            var w = normalizeLongitude(BoundingBox.getWest(b));
            var e = normalizeLongitude(BoundingBox.getEast(b));
            if (BoundingBox.crossesAntimeridian(b)) {
                longIntervals.push([w, 180]);
                longIntervals.push([-180, e]);
            }
            else {
                longIntervals.push([w, e]);
            }
        }
        // sort and merge (overlaped intervals) these intervals
        // after the sort and merge we should have a list of intervals that don't overlap with each other.
        longIntervals.sort(function (a, b) { return a[0] === b[0] ? a[1] - b[1] : a[0] - b[0]; });
        var mergedIntervals = [];
        var currentInterval = longIntervals[0];
        i = 1;
        while (i < longIntervals.length) {
            var nextInterval = longIntervals[i];
            if (currentInterval[1] >= nextInterval[0]) {
                currentInterval[1] = Math.max(currentInterval[1], nextInterval[1]);
            }
            else {
                mergedIntervals.push(currentInterval);
                currentInterval = nextInterval;
            }
            i++;
        }
        mergedIntervals.push(currentInterval);
        // find out the biggest gap between these intervals. suppose this gap is [A, B], then A will be the east bound and B will be the west bound of the merged rectangle.
        var length = mergedIntervals.length;
        var maxGapSpan = mergedIntervals[0][0] + 360 - mergedIntervals[length - 1][1];
        var maxGap = [mergedIntervals[length - 1][1], mergedIntervals[0][0]];
        for (i = 1; i < length; i++) {
            var thisGapSpan = mergedIntervals[i][0] - mergedIntervals[i - 1][1];
            if (thisGapSpan > maxGapSpan) {
                maxGapSpan = thisGapSpan;
                maxGap = [mergedIntervals[i - 1][1], mergedIntervals[i][0]];
            }
        }
        // now we have all the edges of the rectangle
        return new BoundingBox([maxGap[1], south], [maxGap[0], north]);
    };
    /**
     * Creates a BoundingBox that contains all provided Position objects.
     * @param positions An array of locations to use to generate the bounding box.
     * @returns A bounding box that contains all given positions.
     */
    BoundingBox.fromPositions = function (positions) {
        var north = NaN;
        var south = NaN;
        var west = NaN;
        var east = NaN;
        var position;
        var i = positions.length;
        var longitudes = new Array(i);
        var longCount = 0;
        while (i--) {
            position = positions[i];
            if (position && position.length >= 2) {
                var normalizedPosition1 = normalizeLatitude(position[1]);
                north = isNaN(north) ? normalizedPosition1 : Math.max(north, normalizedPosition1);
                south = isNaN(south) ? normalizedPosition1 : Math.min(south, normalizedPosition1);
                longitudes[longCount++] = normalizeLongitude(position[0]);
            }
        }
        if (longCount) {
            // Find largest gap between longitudes
            longitudes.length = longCount;
            longitudes.sort(function (a, b) { return a - b; });
            var maxGap = (longitudes[0] + 360) - longitudes[longCount - 1];
            var maxGapIndex = 0;
            for (i = 1; i < longCount; i++) {
                var gap = longitudes[i] - longitudes[i - 1];
                if (gap > maxGap) {
                    maxGap = gap;
                    maxGapIndex = i;
                }
            }
            west = longitudes[maxGapIndex];
            east = longitudes[(maxGapIndex || longCount) - 1];
        }
        if (isNaN(west) || isNaN(south) || isNaN(east) || isNaN(north)) {
            return null;
        }
        return new BoundingBox([west, south, east, north]);
    };
    /**
     * Creates a BoundingBox from any array of objects that contain coordinate information.
     * Each object is either an array in the format; [lat, lng] or [lat, lng, elv], or an object with the any combination of the following properties:
     * Longitude: lng, longitude, lon, x
     * Latitude: lat, latitude, y
     * Elevation: elv, elevation, alt, altitude, z
     * @param latLngs The objects that contain coordinate information.
     * @returns A BoundingBox that contains all the provided coordinate information.
     */
    BoundingBox.fromLatLngs = function (latLngs) {
        return BoundingBox.fromPositions(Position.fromLatLngs(latLngs));
    };
    /**
     * Calculates the bounding box of a FeatureCollection, Feature, Geometry, Shape or array of these objects.
     * @param data The FeatureCollection, Feature, Geometry, Shape or array of these objects to calculate the bounding box for.
     * @returns A bounding box in the format [minLon, minLat, maxLon, maxLat].
     */
    BoundingBox.fromData = function (data) {
        var e_1, _a;
        var tempBounds;
        var bounds = null;
        if (Array.isArray(data) && data.length > 0) {
            try {
                for (var data_1 = __values$g(data), data_1_1 = data_1.next(); !data_1_1.done; data_1_1 = data_1.next()) {
                    var datum = data_1_1.value;
                    tempBounds = BoundingBox.fromData(datum);
                    if (tempBounds != null) {
                        if (bounds === null) {
                            bounds = tempBounds;
                        }
                        else {
                            bounds = BoundingBox.merge(bounds, tempBounds);
                        }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (data_1_1 && !data_1_1.done && (_a = data_1.return)) _a.call(data_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return bounds;
        }
        else if (data instanceof Shape) {
            return data.getBounds();
        }
        else if (data && data["type"]) {
            // Data is a GeoJson object.
            var geoJsonObj = data;
            // Check to see if the GeoJSON object has a bbox, property, and if it does, use that.
            if (geoJsonObj["bbox"] && geoJsonObj["bbox"].length === 4) {
                return geoJsonObj["bbox"];
            }
            else {
                switch (geoJsonObj.type) {
                    case "FeatureCollection":
                        // features: Array<Feature<Geometry>>
                        return BoundingBox.fromData(geoJsonObj.features);
                    case "Feature":
                        // geometry: G
                        if (Shape._isCircle(geoJsonObj)) {
                            return BoundingBox.fromPositions(Shape._getCirclePositions(geoJsonObj));
                        }
                        else {
                            return BoundingBox.fromData(geoJsonObj.geometry);
                        }
                    case "GeometryCollection":
                        // geometries: Geometry[]
                        return BoundingBox.fromData(geoJsonObj.geometries);
                    case "Point":
                        // coordinates: Position
                        var p = geoJsonObj.coordinates;
                        if (p && p.length >= 2) {
                            return [p[0], p[1], p[0], p[1]];
                        }
                        break;
                    case "LineString":
                    case "MultiPoint":
                        // coordinates: Position[]
                        return BoundingBox.fromPositions(geoJsonObj.coordinates);
                    case "Polygon":
                    case "MultiLineString":
                        // coordinates: Position[][]
                        var ml = geoJsonObj.coordinates;
                        if (ml && ml.length > 0) {
                            for (var i = 0, len = ml.length; i < len; i++) {
                                tempBounds = BoundingBox.fromPositions(ml[i]);
                                if (tempBounds != null) {
                                    if (bounds === null) {
                                        bounds = tempBounds;
                                    }
                                    else {
                                        bounds = BoundingBox.merge(bounds, tempBounds);
                                    }
                                }
                            }
                            if (bounds != null) {
                                return bounds;
                            }
                        }
                        break;
                    case "MultiPolygon":
                        // coordinates: Position[][][]
                        var mp = geoJsonObj.coordinates;
                        if (mp && mp.length > 0) {
                            for (var i = 0, len = mp.length; i < len; i++) {
                                for (var j = 0, cnt = mp[i].length; j < cnt; j++) {
                                    tempBounds = BoundingBox.fromPositions(mp[i][j]);
                                    if (tempBounds != null) {
                                        if (bounds === null) {
                                            bounds = tempBounds;
                                        }
                                        else {
                                            bounds = BoundingBox.merge(bounds, tempBounds);
                                        }
                                    }
                                }
                            }
                            return bounds;
                        }
                        break;
                }
            }
        }
        return null;
    };
    /**
     * Splits a BoundingBox that crosses the Antimeridian into two BoundingBox's. One entirely west of the Antimerdian and another entirely east of the Antimerdian.
     * @param bounds
     */
    BoundingBox.splitOnAntimeridian = function (bounds) {
        var bboxes = [];
        //Test the case when the bounding box is wider than a single globe.
        if (BoundingBox.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe(bounds)) {
            return [[-180, bounds[1], bounds[2], 180, bounds[4], bounds[5]]];
        }
        else if (BoundingBox.isBoundingBoxWithLessThanSixElementsLargerThanGlobe(bounds)) {
            return [[-180, bounds[1], 180, bounds[3]]];
        }
        else if (BoundingBox.crossesAntimeridian(bounds)) {
            //Case when map less than full globe width, but crosses anti-meridian.
            var bbox1 = void 0;
            var bbox2 = void 0;
            var west = normalizeLongitude(BoundingBox.getWest(bounds));
            var east = normalizeLongitude(BoundingBox.getEast(bounds));
            var north = normalizeLatitude(BoundingBox.getNorth(bounds));
            var south = normalizeLatitude(BoundingBox.getSouth(bounds));
            // has elevations
            if (bounds.length >= 6) {
                bbox1 = [west, south, bounds[2], 180, north, bounds[5]];
                bbox2 = [-180, south, bounds[2], east, north, bounds[5]];
            }
            else {
                bbox1 = [west, south, 180, north];
                bbox2 = [-180, south, east, north];
            }
            bboxes.push(bbox1, bbox2);
        }
        else {
            bboxes.push(bounds);
        }
        return bboxes;
    };
    BoundingBox.isBoundingBoxWithSixOrMoreElementsLargerThanGlobe = function (bounds) {
        return bounds.length >= 6 && bounds[3] - bounds[0] > 360;
    };
    BoundingBox.isBoundingBoxWithLessThanSixElementsLargerThanGlobe = function (bounds) {
        return bounds.length < 6 && bounds[2] - bounds[0] > 360;
    };
    return BoundingBox;
}(Array));

/**
 * A GeoJSON FeatureCollection object - a JSON object that contains a collection of GeoJSON features. The full
 * description is detailed in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.3}.
 */
var FeatureCollection = /** @class */ (function () {
    /**
     * Constructs a FeatureCollection.
     * @param features The collection of features that make up the feature collection.
     * @param bbox The bounding box of the feature collection.
     */
    function FeatureCollection(features, bbox) {
        /**
         * A GeoJSON type descriptor with value "FeatureCollection".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "FeatureCollection";
        this.type = FeatureCollection.TYPE;
        this.features = features;
        this.bbox = bbox;
    }
    /**
     * A static GeoJSON type descriptor for the FeatureCollection class to be used in runtime comparisons.
     */
    FeatureCollection.TYPE = "FeatureCollection";
    return FeatureCollection;
}());

/**
 * A GeoJSON GeometryCollection object - a JSON object that contains a collection of a GeoJSON Geometry objects. The
 * full description is detailed in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.8}.
 */
var GeometryCollection = /** @class */ (function () {
    /**
     * Constructs a GeometryCollection.
     * @param geometries The collection of geometries that make up the geometry collection.
     */
    function GeometryCollection(geometries) {
        /**
         * A GeoJSON type descriptor with value "GeometryCollection".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "GeometryCollection";
        this.type = GeometryCollection.TYPE;
        this.geometries = geometries;
    }
    /**
     * A static GeoJSON type descriptor for the GeometryCollection class to be used in runtime comparisons.
     */
    GeometryCollection.TYPE = "GeometryCollection";
    return GeometryCollection;
}());

/**
 * A GeoJSON LineString object - a JSON object that represents a geographic curve. The full description is detailed
 * in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.4}.
 */
var LineString = /** @class */ (function () {
    /**
     * Constructs a LineString.
     * @param coordinates The ordered list of positions defining the linestring.
     * @param bbox The bounding box of the linestring.
     */
    function LineString(coordinates, bbox) {
        /**
         * A GeoJSON type descriptor with value "LineString".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "LineString";
        this.type = LineString.TYPE;
        this.coordinates = coordinates;
        this.bbox = bbox;
    }
    /**
     * A static GeoJSON type descriptor for the LineString class to be used in runtime comparisons.
     */
    LineString.TYPE = "LineString";
    return LineString;
}());

/**
 * A GeoJSON MultiLineString object - a JSON object that represents multiple geographic curves. The full description
 * is detailed in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.5}.
 */
var MultiLineString = /** @class */ (function () {
    /**
     * Constructs a MultiLineString.
     * @param coordinates The array of LineString coordinate arrays defining the multilinestring.
     * @param bbox The bounding box of the multilinestring.
     */
    function MultiLineString(coordinates, bbox) {
        /**
         * A GeoJSON type descriptor with value "MutliLineString".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "MultiLineString";
        this.type = MultiLineString.TYPE;
        this.coordinates = coordinates;
        this.bbox = bbox;
    }
    /**
     * A static GeoJSON type descriptor for the MultiLineString class to be used in runtime comparisons.
     */
    MultiLineString.TYPE = "MultiLineString";
    return MultiLineString;
}());

/**
 * A GeoJSON MultiPoint object - a JSON object that represents multiple geographic positions. The full description
 * is detailed in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.3}.
 */
var MultiPoint = /** @class */ (function () {
    /**
     * Constructs a MultiPoint.
     * @param coordinates The array of multiple positions defining the multipoint.
     * @param bbox The bounding box of the multipoint.
     */
    function MultiPoint(coordinates, bbox) {
        /**
         * A GeoJSON type descriptor with value "MutliPoint".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "MultiPoint";
        this.type = MultiPoint.TYPE;
        this.coordinates = coordinates;
        this.bbox = bbox;
    }
    /**
     * A static GeoJSON type descriptor for the MultiPoint class to be used in runtime comparisons.
     */
    MultiPoint.TYPE = "MultiPoint";
    return MultiPoint;
}());

/**
 * A GeoJSON MultiPolygon object - a JSON object that represents multiple geographic polygons. The full description is
 * detailed in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.7}.
 */
var MultiPolygon = /** @class */ (function () {
    /**
     * Constructs a MultiPolygon.
     * @param coordinates The array of polygon coordinate arrays defining the multipolygon.
     * @param bbox The bounding box of the multipolygon.
     */
    function MultiPolygon(coordinates, bbox) {
        /**
         * A GeoJSON type descriptor with value "MutliPolygon".
         */
        // tslint:disable-next-line:no-reserved-keywords
        this.type = "MultiPolygon";
        this.type = MultiPolygon.TYPE;
        this.coordinates = coordinates;
        this.bbox = bbox;
    }
    /**
     * A static GeoJSON type descriptor for the MultiPolygon class to be used in runtime comparisons.
     */
    MultiPolygon.TYPE = "MultiPolygon";
    return MultiPolygon;
}());

var __extends$14 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
//Based on: https://github.com/mapbox/mapbox-gl-js/blob/main/src/geo/mercator_coordinate.js
/**
 * A `MercatorPoint` object represents a projected three dimensional position.
 *
 * `MercatorPoint` uses the web mercator projection ([EPSG:3857](https://epsg.io/3857)) with slightly different units:
 * - the size of 1 unit is the width of the projected world instead of the "mercator meter"
 * - the origin of the coordinate space is at the north-west corner instead of the middle.
 *
 * For example, `MercatorPoint(0, 0, 0)` is the north-west corner of the mercator world and
 * `MercatorPoint(1, 1, 0)` is the south-east corner. If you are familiar with
 * [vector tiles](https://github.com/mapbox/vector-tile-spec) it may be helpful to think
 * of the coordinate space as the `0/0/0` tile with an extent of `1`.
 *
 * The `z` dimension of `MercatorPoint` is conformal. A cube in the mercator coordinate space would be rendered as a cube.
 */
var MercatorPoint = /** @class */ (function (_super) {
    __extends$14(MercatorPoint, _super);
    /**
     * Constructs a MercatorPoint.
     * @param x A points x position in mercator units.
     * @param y A points y position in mercator units.
     * @param z A points z position in mercator units.
     */
    function MercatorPoint(x, y, z) {
        return _super.call(this, x, y, z ? z : 0) || this;
    }
    /***********************************
     * Public static functions
     ***********************************/
    /**
     * Converts a position into a mercator point.
     * @param position Position to convert.
     * @returns A mercator point.
     */
    MercatorPoint.fromPosition = function (position) {
        if (position.length >= 2) {
            return new MercatorPoint((180 + position[0]) / 360, MercatorPoint._latToMercatorY(position[1]), position.length >= 3 ? MercatorPoint._altitudeToMercatorZ(position[2], position[1]) : 0);
        }
        return [0, 0, 0];
    };
    /**
     * Converts an array of positions into an array of mercator points.
     * @param positions Array of positions to convert.
     * @returns An array of  mercator points.
     */
    MercatorPoint.fromPositions = function (positions) {
        var mercators = [];
        for (var i = 0, len = positions.length; i < len; i++) {
            mercators.push(this.fromPosition(positions[i]));
        }
        return mercators;
    };
    /**
     * Converts an array of positions into a Float32Array of mercator xyz values.
     * @param positions Array of positions to convert.
     * @returns A Float32Array of mercator xyz values.
     */
    MercatorPoint.toFloat32Array = function (positions) {
        var arr = new Float32Array(positions.length * 3);
        for (var i = 0, len = positions.length; i < len; i++) {
            var idx = i * 3;
            var p = positions[i];
            //x
            arr[idx] = (180 + p[0]) / 360;
            //y
            arr[idx + 1] = MercatorPoint._latToMercatorY(p[1]);
            //z
            arr[idx + 2] = p.length >= 3 ? MercatorPoint._altitudeToMercatorZ(p[2], p[1]) : 0;
        }
        return arr;
    };
    /**
     * Converts a mercator point into a map position.
     * @param mercator Mercator point to convert.
     * @returns A map position.
     */
    MercatorPoint.toPosition = function (mercator) {
        if (mercator.length >= 2) {
            var lat = (360 / Math.PI) * Math.atan(Math.exp(((180 - mercator[1] * 360) * Math.PI) / 180)) - 90;
            return new Position(mercator[0] * 360 - 180, lat, mercator.length >= 3 ? MercatorPoint._mercatorZToAltitude(mercator[2], mercator[1]) : 0);
        }
        return [0, 0, 0];
    };
    /**
     * Converts an array of mercator points into an array of map positions.
     * @param mercators Mercator points to convert.
     * @returns An array of map positions.
     */
    MercatorPoint.toPositions = function (mercators) {
        var positions = [];
        for (var i = 0, len = mercators.length; i < len; i++) {
            positions.push(this.toPosition(mercators[i]));
        }
        return positions;
    };
    /**
     * Determine the Mercator scale factor for a given latitude, see
     * https://en.wikipedia.org/wiki/Mercator_projection#Scale_factor
     *
     * At the equator the scale factor will be 1, which increases at higher latitudes.
     *
     * @param latitude Latitude
     * @returns The mercator scale factor.
     */
    MercatorPoint.mercatorScale = function (latitude) {
        return 1 / Math.cos((latitude * Math.PI) / 180);
    };
    /**
     * Returns the distance of 1 meter in `MercatorPoint` units at this latitude.
     *
     * For coordinates in real world units using meters, this naturally provides the scale
     * to transform into `MercatorPoint`s.
     *
     * @returns {number} Distance of 1 meter in `MercatorPoint` units.
     */
    MercatorPoint.meterInMercatorUnits = function (latitude) {
        // 1 meter / circumference at equator in meters * Mercator projection scale factor at this latitude
        return ((1 / MercatorPoint.earthCircumference) *
            MercatorPoint.mercatorScale(MercatorPoint._latToMercatorY(latitude)));
    };
    /***********************************
     * Private static functions
     ***********************************/
    /*
     * The circumference at a line of latitude in meters.
     */
    MercatorPoint._circumferenceAtLatitude = function (latitude) {
        return MercatorPoint.earthCircumference * Math.cos((latitude * Math.PI) / 180);
    };
    MercatorPoint._altitudeToMercatorZ = function (altitude, latitude) {
        return altitude / MercatorPoint._circumferenceAtLatitude(latitude);
    };
    MercatorPoint._mercatorZToAltitude = function (zoom, y) {
        return zoom * MercatorPoint._circumferenceAtLatitude(MercatorPoint._latToMercatorY(y));
    };
    MercatorPoint._latToMercatorY = function (y) {
        return (180 - (180 / Math.PI) * Math.log(Math.tan(Math.PI / 4 + (y * Math.PI) / 360))) / 360;
    };
    /*
     * The average circumference of the world in meters.
     */
    MercatorPoint.earthCircumference = 2 * Math.PI * getEarthRadius(); // meters
    return MercatorPoint;
}(Array));

var index$4 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	BoundingBox: BoundingBox,
	Feature: Feature,
	FeatureCollection: FeatureCollection,
	GeometryCollection: GeometryCollection,
	LineString: LineString,
	MercatorPoint: MercatorPoint,
	MultiLineString: MultiLineString,
	MultiPoint: MultiPoint,
	MultiPolygon: MultiPolygon,
	Point: Point,
	Polygon: Polygon,
	Position: Position
});

function getAddedSquaresAP(dx, dy) {
    return dx * dx + dy * dy;
}
function getSqDistAP(p1, p2) {
    return getAddedSquaresAP(p1[0] - p2[0], p1[1] - p2[1]);
}
function getSqSegDistAP(p, p1, p2) {
    var x = p1[0], y = p1[1], dx = p2[0] - x, dy = p2[1] - y;
    if (dx !== 0 || dy !== 0) {
        var t = ((p[0] - x) * dx + (p[1] - y) * dy) / getAddedSquaresAP(dx, dy);
        if (t > 1) {
            x = p2[0];
            y = p2[1];
        }
        else if (t > 0) {
            x += dx * t;
            y += dy * t;
        }
    }
    return getAddedSquaresAP(p[0] - x, p[1] - y);
}
function simplifyRadialDistAP(points, sqTolerance) {
    var prevPoint = points[0], point;
    var newPoints = [prevPoint];
    for (var i = 1, len = points.length; i < len; i++) {
        point = points[i];
        if (getSqDistAP(point, prevPoint) > sqTolerance) {
            newPoints.push(point);
            prevPoint = point;
        }
    }
    if (prevPoint !== point) {
        newPoints.push(point);
    }
    return newPoints;
}
function simplifyDPStepAP(points, first, last, sqTolerance, simplified) {
    var maxSqDist = sqTolerance, index;
    for (var i = first + 1; i < last; i++) {
        var sqDist = getSqSegDistAP(points[i], points[first], points[last]);
        if (sqDist > maxSqDist) {
            index = i;
            maxSqDist = sqDist;
        }
    }
    if (maxSqDist > sqTolerance) {
        if (index - first > 1) {
            simplifyDPStepAP(points, first, index, sqTolerance, simplified);
        }
        simplified.push(points[index]);
        if (last - index > 1) {
            simplifyDPStepAP(points, index, last, sqTolerance, simplified);
        }
    }
}
function simplifyDouglasPeuckerAP(points, sqTolerance) {
    var last = points.length - 1;
    var simplified = [points[0]];
    simplifyDPStepAP(points, 0, last, sqTolerance, simplified);
    simplified.push(points[last]);
    return simplified;
}
function SimplifyAP(points, tolerance, highestQuality) {
    if (tolerance === void 0) { tolerance = 1; }
    if (highestQuality === void 0) { highestQuality = false; }
    if (points.length <= 2) {
        return points;
    }
    var sqTolerance = tolerance * tolerance;
    points = highestQuality ? points : simplifyRadialDistAP(points, sqTolerance);
    points = simplifyDouglasPeuckerAP(points, sqTolerance);
    return points;
}
var SimplifyAP_1 = SimplifyAP;

/**
 * Perform a Douglas-Peucker simplification on an array of positions or pixels.
 * @param points The position or pixel points to simplify.
 * @param tolerance A tolerance to use in the simplification.
 * @returns A new array of the simplified set of points.
 */
function simplify(points, tolerance) {
    //Perform a Douglas-Peucker simplification of the pixels.
    return SimplifyAP_1(points, tolerance, true);
}

var __values$f = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * An Affine Transform class generated from a set of reference points.
 */
var AffineTransform = /** @class */ (function () {
    /**
     * An Affine Transform class generated from a set of reference points.
     * @param source A set of reference points from the source reference system to transform from.
     * @param target A set of reference points from the target reference system to transform to.
     */
    function AffineTransform(source, target) {
        this.M = AffineTransform._calculateAffineTransform(source, target);
        this.inverseM = AffineTransform._calculateAffineTransform(target, source);
    }
    /**
     * Converts an array of points from the source reference system to the target reference system.
     * @param sourcePoints An array of points from the source reference system to transform.
     * @param decimals Number of decimal places to round the results off to.
     * @returns An array of points that have been transformed to the target reference system.
     */
    AffineTransform.prototype.toTarget = function (sourcePoints, decimals) {
        if (typeof sourcePoints !== undefined) {
            return this.transformArray(sourcePoints, this.M, decimals);
        }
        throw new Error("Invalid sourcePoints specified.");
    };
    /**
     * Converts an array of points from the target reference system to the source reference system.
     * @param targetPoints An array of points from the target reference system to transform.
     * @param decimals Number of decimal places to round the results off to.
     * @returns An array of points that have been transformed to the source reference system.
     */
    AffineTransform.prototype.toSource = function (targetPoints, decimals) {
        if (typeof targetPoints !== undefined) {
            return this.transformArray(targetPoints, this.inverseM, decimals);
        }
        throw new Error("Invalid targetPoints specified.");
    };
    /**
     * Applies a transform matrix over a set of points and optionally rounds off the values to a specified number of decimals.
     * @param points The array of points to transform.
     * @param transformMatrix The transform matrix to apply.
     * @param decimals The number of decimals to round each calculated point value off to.
     * @returns An array of points that have been transformed.
     */
    AffineTransform.prototype.transformArray = function (points, transformMatrix, decimals) {
        var e_1, _a;
        if (points && Array.isArray(points) && Array.isArray(points[0])) {
            var pos = [];
            try {
                for (var points_1 = __values$f(points), points_1_1 = points_1.next(); !points_1_1.done; points_1_1 = points_1.next()) {
                    var subPoints = points_1_1.value;
                    pos.push(this.transform(subPoints, transformMatrix, decimals));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (points_1_1 && !points_1_1.done && (_a = points_1.return)) _a.call(points_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return pos;
        }
        return null;
    };
    /**
     * Applies a transform matrix on a point and optionally rounds off the values to a specified number of decimals.
     * @param point The point to transform.
     * @param transformMatrix The transform matrix to apply.
     * @param decimals The number of decimals to round each calculated point value off to.
     * @returns An array of points that have been transformed.
     */
    AffineTransform.prototype.transform = function (point, transformMatrix, decimals) {
        var x = point[0] * transformMatrix[0][3] + point[1] * transformMatrix[1][3] + transformMatrix[2][3];
        var y = point[0] * transformMatrix[0][4] + point[1] * transformMatrix[1][4] + transformMatrix[2][4];
        return typeof decimals === "number" && decimals >= 0 ?
            [_precision(x, decimals), _precision(y, decimals)] :
            [_precision(x, 6), _precision(y, 6)];
    };
    /**
     * Takes in a set of source and target points can calculates an approximate Affine Transform matrix that best fits the data.
     * Modified version of this code: https://github.com/commenthol/affinefit
     * @param sourcePoints A set of source points to transform from.
     * @param targetPoints A set of target points to transform to.
     * @returns An Affine Tranform matrix.
     */
    AffineTransform._calculateAffineTransform = function (sourcePoints, targetPoints) {
        if (sourcePoints.length !== targetPoints.length || sourcePoints.length < 1) {
            throw new Error("Error: source and target arrays must have the same length.");
        }
        // Use the smallest dimension of the input.
        var dim = Math.min(sourcePoints[0].length, targetPoints[0].length);
        var dimPlusOne = dim + 1;
        if (sourcePoints.length < dim) {
            throw new Error("Erorr: At least " + dim + " reference points required.");
        }
        // Create an empty (dim + 1) x (dim) matrix and fill it.
        var c = [];
        var transformMatrix = [];
        for (var i = 0; i < dimPlusOne; i++) {
            transformMatrix[i] = [];
            for (var j = 0; j < dimPlusOne; j++) {
                if (j < dim) {
                    c[j] = 0;
                }
                transformMatrix[i][j] = 0;
                for (var k = 0; k < sourcePoints.length; k++) {
                    if (j < dim) {
                        if (i < dim) {
                            c[j] += sourcePoints[k][i] * targetPoints[k][j];
                        }
                        else {
                            c[j] += targetPoints[k][j];
                        }
                    }
                    if (i >= dim && j >= dim) {
                        transformMatrix[i][j] += 1;
                    }
                    else if (i >= dim) {
                        transformMatrix[i][j] += sourcePoints[k][j];
                    }
                    else if (j >= dim) {
                        transformMatrix[i][j] += sourcePoints[k][i];
                    }
                    else {
                        transformMatrix[i][j] += sourcePoints[k][i] * sourcePoints[k][j];
                    }
                }
            }
            transformMatrix[i] = transformMatrix[i].concat(c);
        }
        if (!this._gaussJordanElimination(transformMatrix)) {
            throw new Error("Error: Singular matrix. Points are likely coplanar.");
        }
        return transformMatrix;
    };
    /**
     * Puts a given matrix (2D array) into the Reduced Row Echelon Form.
     * Returns True if successful, False if the transformMatrix is singular.
     * Code from: https://github.com/commenthol/affinefit
     * Modification:
     * 1. Updated epsilon from 1e-10 to 1e-12 to reduce the possibility of valid matrix detected as singular
     *    (can happen when points to convert are too close to each other on high LODs)
     */
    AffineTransform._gaussJordanElimination = function (transformMatrix) {
        var eps = 1e-12; // 1.0 / Math.pow(10, 12)
        var dimPlusOne = transformMatrix.length;
        var w = 2 * dimPlusOne - 1;
        var tempNum;
        var tempArray;
        for (var j = 0; j < dimPlusOne; j++) {
            var maxrow = j;
            for (var i = j + 1; i < dimPlusOne; i++) {
                // Find max pivot.
                if (Math.abs(transformMatrix[i][j]) > Math.abs(transformMatrix[maxrow][j])) {
                    maxrow = i;
                }
            }
            tempArray = transformMatrix[maxrow];
            transformMatrix[maxrow] = transformMatrix[j];
            transformMatrix[j] = tempArray;
            if (Math.abs(transformMatrix[j][j]) <= eps) {
                // Is Singular?
                return false;
            }
            for (var _j = j + 1; _j < dimPlusOne; _j++) {
                // Eliminate column y.
                tempNum = transformMatrix[_j][j] / transformMatrix[j][j];
                for (var _i = j; _i < w; _i++) {
                    transformMatrix[_j][_i] -= transformMatrix[j][_i] * tempNum;
                }
            }
        }
        for (var j = dimPlusOne - 1; j > -1; j--) {
            // Backsubstitute.
            tempNum = transformMatrix[j][j];
            for (var i = 0; i < j; i++) {
                for (var _x = w - 1; _x > j - 1; _x--) {
                    transformMatrix[i][_x] -= transformMatrix[j][_x] * transformMatrix[i][j] / tempNum;
                }
            }
            transformMatrix[j][j] /= tempNum;
            for (var _x2 = dimPlusOne; _x2 < w; _x2++) {
                // Normalize row y.
                transformMatrix[j][_x2] /= tempNum;
            }
        }
        return true;
    };
    return AffineTransform;
}());

var index$3 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	get AccelerationUnits () { return AccelerationUnits; },
	AffineTransform: AffineTransform,
	get AreaUnits () { return AreaUnits; },
	get DistanceUnits () { return DistanceUnits; },
	get SpeedUnits () { return SpeedUnits; },
	get TimeUnits () { return TimeUnits; },
	WEBMERCATOR_MAXLAT: WEBMERCATOR_MAXLAT,
	_precision: _precision,
	boundingBoxToPolygon: boundingBoxToPolygon,
	convertAcceleration: convertAcceleration,
	convertArea: convertArea,
	convertDistance: convertDistance,
	convertSpeed: convertSpeed,
	convertTimespan: convertTimespan,
	getAcceleration: getAcceleration,
	getAccelerationFromFeatures: getAccelerationFromFeatures,
	getAccelerationFromSpeeds: getAccelerationFromSpeeds,
	getArea: getArea,
	getCardinalSpline: getCardinalSpline,
	getClosestPointOnGeometry: getClosestPointOnGeometry,
	getConvexHull: getConvexHull,
	getDestination: getDestination,
	getDistanceTo: getDistanceTo,
	getEarthRadius: getEarthRadius,
	getGeodesicPath: getGeodesicPath,
	getGeodesicPaths: getGeodesicPaths,
	getHeading: getHeading,
	getLengthOfPath: getLengthOfPath,
	getPathDenormalizedAtAntimerian: getPathDenormalizedAtAntimerian,
	getPathSplitByAntimeridian: getPathSplitByAntimeridian,
	getPixelHeading: getPixelHeading,
	getPointWithHeadingAlongPath: getPointWithHeadingAlongPath,
	getPointsWithHeadingsAlongPath: getPointsWithHeadingsAlongPath,
	getPosition: getPosition,
	getPositionAlongPath: getPositionAlongPath,
	getPositions: getPositions,
	getPositionsAlongPath: getPositionsAlongPath,
	getRegularPolygonPath: getRegularPolygonPath,
	getRegularPolygonPaths: getRegularPolygonPaths,
	getSpeed: getSpeed,
	getSpeedFromFeatures: getSpeedFromFeatures,
	getTimespan: getTimespan,
	getTravelDistance: getTravelDistance,
	interpolate: interpolate,
	mercatorPixelsToPositions: mercatorPixelsToPositions,
	mercatorPositionsToPixels: mercatorPositionsToPixels,
	normalizeLatitude: normalizeLatitude,
	normalizeLongitude: normalizeLongitude,
	parseTimestamp: parseTimestamp,
	rotatePositions: rotatePositions,
	simplify: simplify
});

var __extends$13 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a ZoomControl object.
 */
var ZoomControlOptions = /** @class */ (function (_super) {
    __extends$13(ZoomControlOptions, _super);
    function ZoomControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The extent to which the map will zoom with each click of the control.
         * Default `1`.
         * @default 1
         */
        _this.zoomDelta = 1;
        /**
         * The style of the control.
         * Default `ControlStyle.light`.
         * @default ControlStyle.light
         */
        _this.style = ControlStyle.light;
        return _this;
    }
    return ZoomControlOptions;
}(Options));

var __extends$12 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A control for changing the zoom of the map.
 */
var ZoomControl = /** @class */ (function (_super) {
    __extends$12(ZoomControl, _super);
    /**
     * Constructs a ZoomControl.
     * @param options The options for the control.
     */
    function ZoomControl(options) {
        var _this = _super.call(this) || this;
        _this.container = null;
        _this.zoomInButton = null;
        _this.zoomOutButton = null;
        _this.zoomChanged = function (event) { return _this.updateZoomButtonsState(); };
        _this.minZoomChanged = function (zoom) { return _this.updateZoomButtonsState(); };
        _this.maxZoomChanged = function (zoom) { return _this.updateZoomButtonsState(); };
        _this.options = new ZoomControlOptions().merge(options);
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @return An HTMLElement to be placed on the map for the control.
     */
    ZoomControl.prototype.onAdd = function (map) {
        this.container = this.buildContainer(map, this.options.style, "Zoom Control");
        this.container.style.flexDirection = "column";
        this.zoomInButton = this.constructZoomInButton(map);
        this.zoomOutButton = this.constructZoomOutButton(map);
        var tooltipZoomIn = buildAccessibleTooltip("Zoom In");
        var tooltipZoomOut = buildAccessibleTooltip("Zoom Out");
        this.container.appendChild(this.zoomInButton);
        this.container.appendChild(tooltipZoomIn);
        this.container.appendChild(this.zoomOutButton);
        this.container.appendChild(tooltipZoomOut);
        positionTooltip(tooltipZoomIn, this.zoomInButton);
        positionTooltip(tooltipZoomOut, this.zoomOutButton);
        map.events.add('zoom', this.zoomChanged);
        map.events.add('minzoomchanged', this.minZoomChanged);
        map.events.add('maxzoomchanged', this.maxZoomChanged);
        this.map = map;
        return this.container;
    };
    ZoomControl.prototype.onRemove = function () {
        _super.prototype.onRemove.call(this);
        if (this.map) {
            this.map.events.remove('zoom', this.zoomChanged);
            this.map.events.remove('minzoomchanged', this.minZoomChanged);
            this.map.events.remove('maxzoomchanged', this.maxZoomChanged);
            this.map = null;
        }
        if (this.container) {
            this.container.remove();
            this.container = null;
            this.zoomInButton = null;
            this.zoomOutButton = null;
        }
    };
    ZoomControl.prototype.updateZoomButtonsState = function () {
        var zoomInDisabled = this.map.getCamera().zoom >= this.map._getMap().getMaxZoom();
        // small values need special handling, since depending on the height of the map view
        // the actual zoom we can zoom out to can be above or below 0 when the entire map fits the height into the view
        // use web mercator bounds to check if entire latitude range is visible
        var reachedLatitudeBoundaries = BoundingBox.getSouth(this.map.getCamera().bounds) <= -WEBMERCATOR_MAXLAT
            && BoundingBox.getNorth(this.map.getCamera().bounds) >= WEBMERCATOR_MAXLAT;
        var zoomOutDisabled = this.map.getCamera().zoom <= this.map._getMap().getMinZoom() || reachedLatitudeBoundaries;
        if (this.zoomInButton && this.zoomInButton.disabled != zoomInDisabled) {
            this.zoomInButton.disabled = zoomInDisabled;
            this.zoomInButton.setAttribute("aria-label", zoomInDisabled ? "Zoom In disabled" : "Zoom In");
        }
        if (this.zoomOutButton && this.zoomOutButton.disabled != zoomOutDisabled) {
            this.zoomOutButton.disabled = zoomOutDisabled;
            this.zoomOutButton.setAttribute("aria-label", zoomInDisabled ? "Zoom Out disabled" : "Zoom Out");
        }
    };
    ZoomControl.prototype.constructZoomInButton = function (map) {
        var _this = this;
        var zoomInButton = document.createElement("button");
        zoomInButton.classList.add("azure-maps-control-button");
        zoomInButton.classList.add("zoom-in");
        zoomInButton.setAttribute("aria-label", "Zoom In");
        zoomInButton.setAttribute("alt", "Zoom In");
        zoomInButton.setAttribute("type", "button");
        zoomInButton.addEventListener("click", function () {
            map.setCamera({
                zoom: map.getCamera().zoom + _this.options.zoomDelta,
                duration: ZoomControl.ZOOM_DURATION_MS,
                type: "ease",
            }, true);
        });
        return zoomInButton;
    };
    ZoomControl.prototype.constructZoomOutButton = function (map) {
        var _this = this;
        var zoomOutButton = document.createElement("button");
        zoomOutButton.classList.add("azure-maps-control-button");
        zoomOutButton.classList.add("zoom-out");
        zoomOutButton.setAttribute("aria-label", "Zoom Out");
        zoomOutButton.setAttribute("alt", "Zoom Out");
        zoomOutButton.setAttribute("type", "button");
        zoomOutButton.addEventListener("click", function () {
            map.setCamera({
                zoom: map.getCamera().zoom - _this.options.zoomDelta,
                duration: ZoomControl.ZOOM_DURATION_MS,
                type: "ease",
            }, true);
        });
        return zoomOutButton;
    };
    ZoomControl.ZOOM_DURATION_MS = 200;
    return ZoomControl;
}(ControlBase));

var __extends$11 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a FullscreenControl object.
 */
var FullscreenControlOptions = /** @class */ (function (_super) {
    __extends$11(FullscreenControlOptions, _super);
    function FullscreenControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The style of the control.
         * Default `ControlStyle.light`
         * @default ControlStyle.light
         */
        _this.style = ControlStyle.light;
        /**
         * Indicates if the control should be hidden if the browser does not support fullscreen mode.
         * Default `false`
         * @default false
         */
        _this.hideIfUnsupported = false;
        /**
         * The HTML element which should be made full screen.
         * If not specified, the map container element will be used.
         */
        _this.container = undefined;
        return _this;
    }
    return FullscreenControlOptions;
}(Options));

var __extends$10 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A control to make the map or a specified element fullscreen.
 */
var FullscreenControl = /** @class */ (function (_super) {
    __extends$10(FullscreenControl, _super);
    /**
     * A control to make the map or a specified element fullscreen.
     * @param options Options for defining how the control is rendered and the container to be made fullscreen.
     */
    function FullscreenControl(options) {
        var _this = _super.call(this) || this;
        _this.map = null;
        _this.isFullscreenState = false;
        _this.options = new FullscreenControlOptions().merge(options);
        _this.control = new maplibregl.FullscreenControl({
            container: _this.options.container,
        });
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    FullscreenControl.prototype.onAdd = function (map) {
        var _this = this;
        var _a, _b;
        this.map = map;
        (_b = (_a = this.map) === null || _a === void 0 ? void 0 : _a._getMap()) === null || _b === void 0 ? void 0 : _b.addControl(this.control);
        var container = this.buildContainer(map, this.options.style, "Fullscreen Control");
        var fullscreenButton = this.control._fullscreenButton;
        if (fullscreenButton) {
            var icon_1 = fullscreenButton.querySelector("span");
            if (icon_1) {
                var tooltip_1 = buildAccessibleTooltip("Enter Fullscreen");
                container.appendChild(fullscreenButton);
                // Add classes for styling.
                fullscreenButton.classList.add("azure-maps-control-button", "fullscreen");
                icon_1.classList.add("fullscreen-icon", "fullscreen-end");
                // Add the tooltip and prevent the default one set by Maplibre.
                fullscreenButton.removeAttribute("title"); // A title attribute will be converted to a tooltip by the browser.
                container.appendChild(tooltip_1);
                positionTooltip(tooltip_1, fullscreenButton);
                // Update the icon and the tooltip based on the fullscreen state.
                this.control.on("fullscreenstart", function () {
                    // Remove the title attribute added automatically whenever fullscreen event is fired
                    fullscreenButton.removeAttribute("title");
                    icon_1.classList.remove("fullscreen-end");
                    icon_1.classList.add("fullscreen-start");
                    tooltip_1.innerText = "Exit Fullscreen";
                    _this.isFullscreenState = true;
                });
                this.control.on("fullscreenend", function () {
                    fullscreenButton.removeAttribute("title");
                    icon_1.classList.remove("fullscreen-start");
                    icon_1.classList.add("fullscreen-end");
                    tooltip_1.innerText = "Enter Fullscreen";
                    _this.isFullscreenState = false;
                });
            }
        }
        // Invisiblize the control if the browser does not support fullscreen mode.
        if (this.options.hideIfUnsupported && !FullscreenControl.isSupported()) {
            container.style.display = "none";
        }
        return container;
    };
    /**
     * Method that is called when the control is removed from the map. Should perform any necessary cleanup for the
     * control.
     */
    FullscreenControl.prototype.onRemove = function () {
        var _a, _b;
        _super.prototype.onRemove.call(this);
        (_b = (_a = this.map) === null || _a === void 0 ? void 0 : _a._getMap()) === null || _b === void 0 ? void 0 : _b.removeControl(this.control);
        this.map = null;
    };
    /**
     * Gets the current fullscreen state of the map.
     * @returns A boolean indicating if the map is in fullscreen mode.
     */
    FullscreenControl.prototype.isFullscreen = function () {
        return this.isFullscreenState;
    };
    /**
     * Checks to see if the browser supports going into fullscreen mode.
     * @returns A boolean indicating if the browser supports fullscreen mode.
     */
    FullscreenControl.isSupported = function () {
        var d = document;
        return d['fullscreenEnabled'] ||
            d['msFullscreenEnabled'] ||
            d['mozFullScreenEnabled'] ||
            d['webkitFullscreenEnabled'];
    };
    return FullscreenControl;
}(ControlBase));

var index$2 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	CompassControl: CompassControl,
	ControlBase: ControlBase,
	FullscreenControl: FullscreenControl,
	PitchControl: PitchControl,
	ScaleControl: ScaleControl,
	StyleControl: StyleControl,
	TrafficControl: TrafficControl,
	TrafficLegendControl: TrafficLegendControl,
	ZoomControl: ZoomControl
});

var baseClone = _baseClone;

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG = 1,
    CLONE_SYMBOLS_FLAG = 4;

/**
 * This method is like `_.cloneWith` except that it recursively clones `value`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to recursively clone.
 * @param {Function} [customizer] The function to customize cloning.
 * @returns {*} Returns the deep cloned value.
 * @see _.cloneWith
 * @example
 *
 * function customizer(value) {
 *   if (_.isElement(value)) {
 *     return value.cloneNode(true);
 *   }
 * }
 *
 * var el = _.cloneDeepWith(document.body, customizer);
 *
 * console.log(el === document.body);
 * // => false
 * console.log(el.nodeName);
 * // => 'BODY'
 * console.log(el.childNodes.length);
 * // => 20
 */
function cloneDeepWith(value, customizer) {
  customizer = typeof customizer == 'function' ? customizer : undefined;
  return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
}

var cloneDeepWith_1 = cloneDeepWith;

var cloneDeepWith$1 = /*@__PURE__*/getDefaultExportFromCjs(cloneDeepWith_1);

/**
 * A hidden HTML element that is used to provide accessibility to shapes such as bubble.
 */
var AccessibleIndicator = /** @class */ (function () {
    /**
     * Constructs an AccessibleIndicator object by initializing a hidden `div` element.
     * @internal
     */
    function AccessibleIndicator(options) {
        var _this = this;
        /**
         * Attaches the indicator to the HTML document in a hidden style.
         * @param map The map.
         */
        this.attach = function (map) {
            // If attaching to a different map, remove popup on current map
            if (_this.map !== map) {
                // If map was defined the indicator was attached to another map.
                if (_this.map) {
                    _this.detachFromCurrentMap();
                }
                _this.map = map;
                _this.map.indicators._getCollectionDiv().appendChild(_this.element);
                _this.map.indicators.add(_this);
            }
        };
        /**
         * Removes the indicator from the map and the HTML document.
        */
        this.remove = function () {
            _this.detachFromCurrentMap();
            _this.element.remove();
        };
        /**
         * Get the DOM element of the indicator.
         * @returns The DOM element of the indicator.
         */
        this.getElement = function () {
            return _this.element;
        };
        this.detachFromCurrentMap = function () {
            if (_this.map) {
                _this.map.indicators.remove(_this);
                delete _this.map;
            }
        };
        this.element = document.createElement("div");
        // Set tabindex to 0 to make the element focusable.
        this.element.setAttribute("tabindex", "0");
        // Set the role to option, and it's container to listbox so the reader will read the listbox as a list.
        // For example, NVDA will read "data point, {posinset} of {setsize}" when the indicator is focused.
        this.element.setAttribute("role", "option");
        if (options === null || options === void 0 ? void 0 : options.setSize)
            this.element.setAttribute("aria-setsize", options.setSize.toString());
        if (options === null || options === void 0 ? void 0 : options.positionInSet)
            this.element.setAttribute("aria-posinset", options.positionInSet.toString());
        this.element.setAttribute("aria-label", "data point");
        this.element.classList.add(AccessibleIndicator.Css.hidden);
    }
    // CSS class names.
    AccessibleIndicator.Css = {
        hidden: "hidden-accessible-element"
    };
    return AccessibleIndicator;
}());

var __extends$$ = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A data source for managing shape data that will be displayed on the map.
 * A data source must be added to a layer before it is visible on the map.
 * Options for a `DataSourceOptions`.
 * @module Object Definitions
 */
var DataSourceOptions = /** @class */ (function (_super) {
    __extends$$(DataSourceOptions, _super);
    function DataSourceOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /*
         * The size of the buffer around each tile.
         * A buffer value of 0 will provide better performance but will be more likely to generate artifacts when rendering.
         * Larger buffers will produce left artifacts but will result in slower performance.
         */
        _this.buffer = 128;
        /**
         * Maximum zoom level at which to create vector tiles (higher means greater detail at high zoom levels).
         * default `18`
         * @default 18
         */
        _this.maxZoom = 18;
        /**
         * A boolean indicating if Point features in the source should be clustered or not.
         * If set to true, points will be clustered together into groups by radius.
         * default `false`
         * @default false
         */
        _this.cluster = false;
        /**
         * The radius of each cluster in pixels.
         * default `50`
         * @default 50
         */
        _this.clusterRadius = 50;
        /**
         * The maximum zoom level in which to cluster points.
         * Defaults to one zoom less than `maxZoom` so that last zoom features are not clustered.
         */
        _this.clusterMaxZoom = undefined;
        /**
         * Defines custom properties that are calculated using expressions against all the points within each cluster and added to the properties of each cluster point.
         */
        _this.clusterProperties = undefined;
        /**
         * Specifies whether to calculate line distance metrics.
         * This is required for line layers that specify `lineGradient` values.
         * default `false`
         * @default false
         */
        _this.lineMetrics = false;
        /**
         * The Douglas-Peucker simplification tolerance that is applied to the data when rendering (higher means simpler geometries and faster performance).
         * default `0.375`
         * @default 0.375
         */
        _this.tolerance = 0.375;
        /**
         * Minimum number of points necessary to form a cluster if clustering is enabled.
         * @default 2
         */
        _this.clusterMinPoints = 2;
        /**
         * Whether to generate ids for the geojson features. When enabled, the feature.id property will be auto assigned based on its index in the features array, over-writing any previous values.
         */
        _this.generateId = false;
        /**
         * A specified property name to be used as a feature ID (for feature state).
         * This can either be a property name or an object in the form `{<sourceLayer>: <propertyName>}`.
         */
        _this.promoteId = undefined;
        /**
         * An expression for filtering features prior to processing them for rendering.
         */
        _this.filter = undefined;
        return _this;
    }
    return DataSourceOptions;
}(Options));

var __extends$_ = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A base abstract class in which all other source objects extend.
 * A source must be added to a layer before it is visible on the map.
 */
var Source = /** @class */ (function (_super) {
    __extends$_(Source, _super);
    function Source(id) {
        var _this = _super.call(this) || this;
        _this.id = id || uuid();
        return _this;
    }
    /**
     * Gets the id of the data source
     */
    Source.prototype.getId = function () {
        return this.id;
    };
    /**
     * Get reference to Mapbox Map
     * @internal
     */
    Source.prototype._setMap = function (map, shouldInvokeEvent) {
        if (shouldInvokeEvent === void 0) { shouldInvokeEvent = true; }
        if (map == null || map === undefined) {
            var temp = this.map;
            delete this.map;
            if (shouldInvokeEvent) {
                this._invokeEvent("sourceremoved", this);
                if (temp) {
                    temp.events.invoke("sourceremoved", this);
                }
            }
        }
        else {
            this.map = map;
            if (shouldInvokeEvent) {
                this._invokeEvent("sourceadded", this);
                this.map.events.invoke("sourceadded", this);
            }
        }
    };
    return Source;
}(EventEmitter));

var __extends$Z = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values$e = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A data source class that makes it easy to manage shapes data that will be displayed on the map.
 * A data source must be added to a layer before it is visible on the map.
 * The DataSource class may be used with the SymbolLayer, LineLayer, PolygonLayer, BubbleLayer, and HeatMapLayer.
 */
var DataSource = /** @class */ (function (_super) {
    __extends$Z(DataSource, _super);
    /**
     * A data source class that makes it easy to manage shapes data that will be displayed on the map.
     * A data source must be added to a layer before it is visible on the map.
     * The `DataSource` class may be used with the `SymbolLayer`, `LineLayer`, `PolygonLayer`, `BubbleLayer`, and `HeatMapLayer`.
     * @param id a unique id that the user assigns to the data source. If this is not specified, then the data source will automatically be assigned an id.
     * @param options the options for the data source.
     */
    function DataSource(id, options) {
        var _this = _super.call(this, id) || this;
        _this.requestId = undefined;
        _this.options = new DataSourceOptions().merge(cloneDeep$1(options));
        _this.shapes = [];
        _this.shapesMap = new Dictionary();
        return _this;
    }
    /**
     * Adds shapes to the data source.
     * GeoJSON objects will be wrapped within a Shape class to make them easier to manage.
     * Optionally specify an index to insert the feature between other shapes/features in the layers.
     * @param data
     * @param index
     */
    DataSource.prototype.add = function (data, index) {
        this._addNoUpdate(data, index);
        this._updateSource();
    };
    /**
     * Removes all data in the data source.
     */
    DataSource.prototype.clear = function () {
        this._clearNoUpdate();
        this._updateSource();
    };
    /**
     * Cleans up any resources this object is consuming.
     */
    DataSource.prototype.dispose = function () {
        this.options = null;
        this.shapes = null;
        this.shapesMap = null;
        this.map = null;
    };
    /*
     * (P3) Gets the bounding box the encloses all data in the data source.
     * public getBounds() {}
     */
    /**
     * Calculates a zoom level at which the cluster will start expanding or break apart.
     * @param clusterId
     */
    DataSource.prototype.getClusterExpansionZoom = function (clusterId) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (!_this.map) {
                reject("The DataSource hasn't been added to a map.");
                return;
            }
            var mbSource = _this.map._getMap().getSource(_this.getId());
            // Double check a source was found and that it is a GeoJSON source.
            if (mbSource && mbSource.type === "geojson") {
                mbSource.getClusterExpansionZoom(clusterId)
                    .then(function (zoom) {
                    if (typeof zoom === "number") {
                        resolve(zoom);
                    }
                })
                    .catch(function (error) {
                    if (error) {
                        reject(error);
                    }
                });
            }
        });
    };
    /**
     * Retrieves the children of the given cluster on the next zoom level. This may be a combination of shapes and sub-clusters.
     * The sub-clusters will be features with properties matching ClusteredProperties.
     * @param clusterId
     */
    DataSource.prototype.getClusterChildren = function (clusterId) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (!_this.map) {
                reject("The DataSource hasn't been added to a map.");
                return;
            }
            var mbSource = _this.map._getMap().getSource(_this.getId());
            // Double check a source was found and that it is a GeoJSON source.
            if (mbSource && mbSource.type === "geojson") {
                mbSource.getClusterChildren(clusterId)
                    .then(function (features) {
                    if (features) {
                        resolve(_this.map.sources._mapFeaturesToShapes(features, false, _this));
                    }
                })
                    .catch(function (error) {
                    if (error) {
                        reject(error);
                    }
                });
            }
        });
    };
    /**
     * Retrieves shapes that are within the cluster.
     * @param clusterId
     * @param limit The maximum number of features to return. Set to Infinity to return all shapes.
     * @param offset The number of shapes to skip. Allows you to page through the shapes in the cluster.
     */
    DataSource.prototype.getClusterLeaves = function (clusterId, limit, offset) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (!_this.map) {
                reject("The DataSource hasn't been added to a map.");
                return;
            }
            var mbSource = _this.map._getMap().getSource(_this.getId());
            // Double check a source was found and that it is a GeoJSON source.
            if (mbSource && mbSource.type === "geojson") {
                mbSource.getClusterLeaves(clusterId, limit, offset)
                    .then(function (features) {
                    if (features) {
                        resolve(_this.map.sources._mapFeaturesToShapes(features, false, _this));
                    }
                })
                    .catch(function (error) {
                    if (error) {
                        reject(error);
                        return;
                    }
                });
            }
        });
    };
    /**
     * Gets the options used by the data source.
     */
    DataSource.prototype.getOptions = function () {
        return cloneDeep$1(this.options);
    };
    /**
     * Returns all shapes that are in the DataSource.
     */
    DataSource.prototype.getShapes = function () {
        return Array.from(this.shapes);
    };
    /**
     * Downloads a GeoJSON document and imports its data into the data source.
     * The GeoJSON document must be on the same domain or accessible using CORS.
     * @param url
     */
    DataSource.prototype.importDataFromUrl = function (url) {
        var _this = this;
        return fetch(url, {
            method: "GET",
            mode: "cors"
        }).then(function (response) {
            if (response.ok) {
                return response.json();
            }
            else {
                throw new Error("HTTP ".concat(response.status, ": ").concat(response.statusText));
            }
        }).then(function (geoJson) {
            _this.add(geoJson);
        });
    };
    /**
     * Retrieves a shape with the specified id.
     * If no shape with the specified id is contained in the data source, null will be return.
     * @param id The id of the shape to return.
     */
    DataSource.prototype.getShapeById = function (id) {
        return this.shapes[this.shapesMap.get(id)] || null;
    };
    /**
     * Removes one or more shapes from the data source.
     * If a string is passed in, it is assumed to be an id.
     * If a number is passed in, removes the shape at that index.
     * @param shape The shape(s), shape id(s), or feature(s) to be removed
     */
    DataSource.prototype.remove = function (shape) {
        var e_1, _a;
        var shapes = Array.isArray(shape) ? shape : [shape];
        try {
            for (var shapes_1 = __values$e(shapes), shapes_1_1 = shapes_1.next(); !shapes_1_1.done; shapes_1_1 = shapes_1.next()) {
                var s = shapes_1_1.value;
                if (typeof s === "number") {
                    this._removeByIndex(s);
                }
                else {
                    this._removeById(s);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (shapes_1_1 && !shapes_1_1.done && (_a = shapes_1.return)) _a.call(shapes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this._updateSource();
    };
    /**
     * Removes one or more shapes from the datasource based on its id.
     * @param shape shape id
     */
    DataSource.prototype.removeById = function (id) {
        var e_2, _a;
        var ids = Array.isArray(id) ? id : [id];
        try {
            for (var ids_1 = __values$e(ids), ids_1_1 = ids_1.next(); !ids_1_1.done; ids_1_1 = ids_1.next()) {
                var i = ids_1_1.value;
                this._removeById(i);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (ids_1_1 && !ids_1_1.done && (_a = ids_1.return)) _a.call(ids_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this._updateSource();
    };
    /**
     * Sets the data source options.
     * The data source will retain its current values for any option not specified in the supplied options.
     * @param options the DataSourceOptions to be set
     */
    DataSource.prototype.setOptions = function (options) {
        var newOptions = new DataSourceOptions().merge(this.options, cloneDeep$1(options));
        // Only rebuild the map's style if a options has actually changed.
        if (!isEqual$1(this.options, newOptions)) {
            this._invokeEvent("datasourceupdated", this);
            // Update the options before rebuilding.
            this.options = newOptions;
            if (this.map) {
                this.map._rebuildStyle();
            }
        }
    };
    /**
     * Overwrites all shapes in the data source with the new array of shapes.
     * @param shape the new shapes to update
     */
    DataSource.prototype.setShapes = function (shape) {
        this._clearNoUpdate();
        this.add(shape);
    };
    /**
     * Returns a GeoJSON FeatureCollection which contains all the shape data that is in the data source.
     */
    DataSource.prototype.toJson = function () {
        return new FeatureCollection(this.shapes.map(function (shape) { return shape.toJson(); }));
    };
    /**
     * Just like the toJson() function but will return a polygon feature
     * for any circles as defined by the extended GeoJSON spec.
     * [Extended Spec]{@link https://docs.microsoft.com/en-us/azure/azure-maps/extend-geojson}
     * @internal
     */
    DataSource.prototype._toJson = function () {
        return new FeatureCollection(this.shapes.map(function (shape) { return shape._toJson(); }));
    };
    /**
     * @internal
     */
    DataSource.prototype._buildSource = function () {
        var geoJsonSource = {
            type: "geojson",
            data: this._toJson(),
            maxzoom: this.options.maxZoom,
            cluster: this.options.cluster,
            clusterRadius: this.options.clusterRadius,
            tolerance: this.options.tolerance,
            lineMetrics: this.options.lineMetrics,
            clusterProperties: this.options.clusterProperties,
            buffer: this.options.buffer,
            clusterMinPoints: this.options.clusterMinPoints,
            generateId: this.options.generateId,
            promoteId: this.options.promoteId,
            filter: this.options.filter
        };
        if (typeof this.options.clusterMaxZoom === "number") {
            geoJsonSource.clusterMaxZoom = this.options.clusterMaxZoom;
        }
        return geoJsonSource;
    };
    DataSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var source = this._buildSource();
        var otherSource = other._buildSource();
        return source.type === otherSource.type &&
            // no data comparison since it is costly and not needed. If geojson data is different, but other source properties are same, we treat it as an update.
            //source.data === otherSource.data &&
            source.maxzoom === otherSource.maxzoom &&
            source.cluster === otherSource.cluster &&
            source.clusterRadius === otherSource.clusterRadius &&
            source.tolerance === otherSource.tolerance &&
            source.lineMetrics === otherSource.lineMetrics &&
            JSON.stringify(source.clusterProperties) === JSON.stringify(otherSource.clusterProperties) &&
            source.buffer === otherSource.buffer &&
            source.clusterMinPoints === otherSource.clusterMinPoints &&
            source.generateId === otherSource.generateId &&
            source.promoteId === otherSource.promoteId &&
            source.filter === otherSource.filter;
    };
    /**
     * @internal
     */
    DataSource.prototype._addNoUpdate = function (data, index) {
        var newShapes;
        if (data instanceof Shape) {
            this._addToSources(data, index);
            newShapes = [data];
        }
        else if (Array.isArray(data)) {
            newShapes = data.map(function (ele) { return ele instanceof Shape ? ele : new Shape(ele); });
            this._addToSources(newShapes, index);
        }
        else if (data.type === "FeatureCollection") {
            newShapes = data.features.map(function (ele) { return new Shape(ele); });
            this._addToSources(newShapes, index);
        }
        else if (data.type === "GeometryCollection") {
            newShapes = data.geometries.map(function (ele) { return new Shape(ele); });
            this._addToSources(newShapes, index);
        }
        else {
            // Either a Feature or Geometry.
            // The Shape constructor can handle either.
            var shape = new Shape(data);
            this._addToSources(shape, index);
            newShapes = [shape];
        }
        // Invoke the dataadded event once all the new features have been wrapped with shapes.
        this._invokeEvent("dataadded", newShapes);
    };
    /**
     * @internal
     */
    DataSource.prototype._clearNoUpdate = function () {
        var oldShapes = this.shapes;
        this.shapes = [];
        this.shapesMap = new Dictionary();
        // If any shapes were removed fire the dataremoved event.
        if (oldShapes && oldShapes.length > 0) {
            this._invokeEvent("dataremoved", oldShapes);
        }
    };
    /**
     * @internal
     */
    DataSource.prototype._updateSource = function () {
        var _this = this;
        // throttling logic that makes DataSource waits a small amount of time before rerendering the map, so the browser won't get frozen
        // when there is too much data
        if (this.requestId !== undefined) {
            return;
        }
        else {
            this.requestId = requestAnimationFrame(function () {
                _this._updateMboxSource();
                _this.requestId = undefined;
            });
        }
    };
    DataSource.prototype._addToSources = function (data, index) {
        var e_3, _a, e_4, _b;
        data = Array.isArray(data) ? data : [data];
        if (typeof index !== "number") {
            try {
                for (var data_1 = __values$e(data), data_1_1 = data_1.next(); !data_1_1.done; data_1_1 = data_1.next()) {
                    var d = data_1_1.value;
                    this.shapes.push(d);
                    this.shapesMap.set(d.getId(), this.shapes.length - 1);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (data_1_1 && !data_1_1.done && (_a = data_1.return)) _a.call(data_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        else {
            for (var i = data.length - 1; i >= 0; i--) {
                this.shapes.splice(index, 0, data[i]);
                this._updateShapesMap(index);
            }
        }
        try {
            for (var data_2 = __values$e(data), data_2_1 = data_2.next(); !data_2_1.done; data_2_1 = data_2.next()) {
                var d = data_2_1.value;
                d._setDataSource(this);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (data_2_1 && !data_2_1.done && (_b = data_2.return)) _b.call(data_2);
            }
            finally { if (e_4) throw e_4.error; }
        }
    };
    DataSource.prototype._removeById = function (shape) {
        var oldShape;
        var i = shape instanceof Shape ? shape.getId() : typeof shape === "string" || typeof shape === "number" ? shape : shape.id;
        oldShape = this.shapes[this.shapesMap.get(i)];
        if (oldShape) {
            oldShape._setDataSource(null);
            this.shapes.splice(this.shapesMap.get(i), 1);
            this._updateShapesMap(this.shapesMap.get(i));
            this.shapesMap.delete(i);
            // Invoke the dataremoved event with the single shape removed.
            this._invokeEvent("dataremoved", [oldShape]);
        }
    };
    DataSource.prototype._removeByIndex = function (i) {
        var oldShape;
        if (i >= this.shapes.length) {
            throw new Error("The specified remove index '".concat(i, "' ") +
                "is greater than the maximum possible index '".concat(this.shapes.length - 1, "'"));
        }
        oldShape = this.shapes[i];
        this.shapesMap.delete(oldShape.getId());
        oldShape._setDataSource(null);
        this.shapes.splice(i, 1);
        this._updateShapesMap(i);
        // Invoke the dataremoved event with the single shape removed.
        this._invokeEvent("dataremoved", [oldShape]);
    };
    DataSource.prototype._updateShapesMap = function (index) {
        for (var i = index; i < this.shapes.length; i++) {
            this.shapesMap.set(this.shapes[i].getId(), i);
        }
    };
    DataSource.prototype._updateMboxSource = function () {
        if (this.map && this.map._getMap()) {
            var mbSource = this.map._getMap().getSource(this.getId());
            // Double check a source was found and that it is a GeoJSON source.
            if (mbSource && mbSource.type === "geojson") {
                mbSource.setData(this._toJson());
            }
        }
    };
    return DataSource;
}(Source));

var __extends$Y = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A data source for managing shape data that will be displayed on the map.
 * A data source must be added to a layer before it is visible on the map.
 * Options for a `VectorTileSource`.
 * @module Object Definitions
 */
var VectorTileSourceOptions = /** @class */ (function (_super) {
    __extends$Y(VectorTileSourceOptions, _super);
    function VectorTileSourceOptions() {
        /*
         * TODO:
         * (P4) An attribute to display to the user when this data source is visible.
         *
         * public attribute?: string;
         */
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * A bounding box that specifies where tiles are available.
         * When specified, no tiles outside of the bounding box will be requested.
         */
        _this.bounds = undefined;
        /**
         * An integer specifying the minimum zoom level to render the layer at.
         * default `0`
         * @default 0
         */
        _this.minZoom = 0;
        /**
         * An integer specifying the maximum zoom level to render the layer at.
         * default `22`
         * @default 22
         */
        _this.maxZoom = 22;
        /**
         * Specifies is the tile systems y coordinate uses the OSGeo Tile Map Services which reverses the Y coordinate axis.
         * default `false`
         * @default false
         */
        _this.isTMS = false;
        /**
         * An array of one or more tile source URLs. Supported URL parameters:
         *  <ul>
         *      <li>`{x}` - X position of tile. Tile URL usually also needs {y} and {z}.</li>
         *      <li>`{y}` - Y position of tile. Tile URL usually also needs {x} and {z}.</li>
         *      <li>`{z}` - Zoom level of tile. Tile URL usually also needs {x} and {y}.</li>
         *      <li>`{quadkey}` - Tile quadkey id based on the Bing Maps tile system naming convention.</li>
         *      <li>`{bbox-epsg-3857}` - A bounding box string with the format "{west},{south},{east},{north}" with coordinates in the EPSG 3857 Spatial Reference System also commonly known as WGS84 Web Mercator. This is useful when working with WMS imagery services.</li>
         *  <ul>
         */
        _this.tiles = undefined;
        /**
         * A URL to a TileJSON resource.
         * Supported protocols are `http:` and `https:`.
         */
        _this.url = undefined;
        return _this;
    }
    return VectorTileSourceOptions;
}(Options));

var __extends$X = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A vector tile source describes how to access a vector tile layer.
 * Vector tile sources can be used with; SymbolLayer, LineLayer, PolygonLayer, BubbleLayer, HeatmapLayer and VectorTileLayer.
 */
var VectorTileSource = /** @class */ (function (_super) {
    __extends$X(VectorTileSource, _super);
    function VectorTileSource(id, options) {
        var _this = _super.call(this, id) || this;
        _this.options = new VectorTileSourceOptions().merge(cloneDeep$1(options));
        return _this;
    }
    /**
     * Gets the options of the VectorTileSource.
     */
    VectorTileSource.prototype.getOptions = function () {
        return cloneDeep$1(this.options);
    };
    /**
     * Returns all GeoJSON features that are in the VectorTileSource and which satisfy the specified filter expression.
     * @param sourceLayer Required if the source is a VectorTileSource. Specifies the layer within the VectorTileSource to query.
     * @param filter A filter that will limit the query.
     */
    VectorTileSource.prototype.getShape = function (sourceLayer, filter) {
        return this.map._getMap().querySourceFeatures(this.getId(), { sourceLayer: sourceLayer, filter: filter });
    };
    /**
     * @internal
     */
    VectorTileSource.prototype._buildSource = function () {
        var vectorSource = {
            type: "vector",
        };
        if (this.options.bounds) {
            vectorSource.bounds = this.options.bounds;
        }
        if (this.options.tiles) {
            vectorSource.tiles = this.options.tiles;
            vectorSource.minzoom = this.options.minZoom;
            vectorSource.maxzoom = this.options.maxZoom;
        }
        else if (this.options.url) {
            vectorSource.url = this.options.url;
        }
        if (this.options.isTMS) {
            vectorSource.scheme = "tms";
        }
        return vectorSource;
    };
    /**
     * @internal
     */
    VectorTileSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var source = this._buildSource();
        var otherSource = other._buildSource();
        return source.type === otherSource.type &&
            source.url === otherSource.url &&
            ((source.tiles === undefined && otherSource.tiles === undefined) ||
                (source.tiles && otherSource.tiles && source.tiles.length === otherSource.tiles.length && source.tiles.every(function (value, idx) { return value === otherSource.tiles[idx]; }))) &&
            source.minzoom === otherSource.minzoom &&
            source.maxzoom === otherSource.maxzoom &&
            source.bounds === otherSource.bounds &&
            source.attribution === otherSource.attribution &&
            source.promoteId === otherSource.promoteId &&
            source.scheme === otherSource.scheme;
    };
    return VectorTileSource;
}(Source));

var __extends$W = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Used to represent the canvas source wrapper.
 * This is not meant to be exposed publicly yet
 * @private
 */
var CanvasSource = /** @class */ (function (_super) {
    __extends$W(CanvasSource, _super);
    /**
     * Constructs a source from the contents of a layer resource file.
     * @param id The source's id.
     * @param sourceDef Canvas source specification.
     * @param options Unused for now
     */
    function CanvasSource(id, sourceDef, options) {
        var _this = _super.call(this, id) || this;
        _this.source = sourceDef;
        return _this;
    }
    /**
     * @internal
     */
    CanvasSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var source = this.source;
        var otherSource = other.source;
        return source.type === otherSource.type
            && source.canvas === otherSource.canvas
            && JSON.stringify(source.coordinates) === JSON.stringify(otherSource.coordinates)
            && source.animate === otherSource.animate;
    };
    /**
     * @internal
     */
    CanvasSource.prototype._buildSource = function () {
        return this.source;
    };
    return CanvasSource;
}(Source));

var __extends$V = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Used to represent an unkown source wrapper.
 * This is not meant to be exposed publicly yet
 * @private
 */
var UnknownSource = /** @class */ (function (_super) {
    __extends$V(UnknownSource, _super);
    /**
     * Constructs a source from the contents of a layer resource file.
     * @param id The source's id.
     * @param sourceDef source specification.
     * @param options Unused for now
     */
    function UnknownSource(id, sourceDef, options) {
        var _this = _super.call(this, id) || this;
        _this.source = sourceDef;
        return _this;
    }
    /**
     * @internal
     */
    UnknownSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var source = this.source;
        var otherSource = other.source;
        return source.type === otherSource.type;
    };
    /**
     * @internal
     */
    UnknownSource.prototype._buildSource = function () {
        return this.source;
    };
    return UnknownSource;
}(Source));

var __extends$U = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Used to represent the image source wrapper.
 * This is not meant to be exposed publicly yet
 * @private
 */
var ImageSource = /** @class */ (function (_super) {
    __extends$U(ImageSource, _super);
    /**
     * Constructs a source from the contents of a layer resource file.
     * @param id The source's id.
     * @param sourceDef Image source specification.
     * @param options Unused for now
     */
    function ImageSource(id, sourceDef, options) {
        var _this = _super.call(this, id) || this;
        _this.source = sourceDef;
        return _this;
    }
    /**
     * @internal
     */
    ImageSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var source = this.source;
        var otherSource = other.source;
        return source.type === otherSource.type
            && JSON.stringify(source.coordinates) === JSON.stringify(otherSource.coordinates)
            && source.url === otherSource.url;
    };
    /**
     * @internal
     */
    ImageSource.prototype._buildSource = function () {
        return this.source;
    };
    return ImageSource;
}(Source));

var __extends$T = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Used to represent the video source wrapper.
 * This is not meant to be exposed publicly yet
 * @private
 */
var VideoSource = /** @class */ (function (_super) {
    __extends$T(VideoSource, _super);
    /**
     * Constructs a source from the contents of a layer resource file.
     * @param id The source's id.
     * @param sourceDef Video source specification.
     * @param options Unused for now
     */
    function VideoSource(id, sourceDef, options) {
        var _this = _super.call(this, id) || this;
        _this.source = sourceDef;
        return _this;
    }
    /**
     * @internal
     */
    VideoSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var source = this.source;
        var otherSource = other.source;
        return source.type === otherSource.type
            && JSON.stringify(source.coordinates) === JSON.stringify(otherSource.coordinates)
            && source.urls === otherSource.urls;
    };
    /**
     * @internal
     */
    VideoSource.prototype._buildSource = function () {
        return this.source;
    };
    return VideoSource;
}(Source));

var __extends$S = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var RasterTileSourceOptions = /** @class */ (function (_super) {
    __extends$S(RasterTileSourceOptions, _super);
    function RasterTileSourceOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * raster tile pixel size.
         * default `512`
         * @default 512
         */
        _this.tileSize = 512;
        return _this;
    }
    return RasterTileSourceOptions;
}(VectorTileSourceOptions));

var __extends$R = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ElevationTileSourceOptions = /** @class */ (function (_super) {
    __extends$R(ElevationTileSourceOptions, _super);
    function ElevationTileSourceOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * DEM tiles encoding format. Supported: `mapbox` or `terrarium`.<br />
         * `"terrarium": Terrarium format PNG tiles. See https://aws.amazon.com/es/public-datasets/terrain/ for more info.<br />
         * `"mapbox": Mapbox Terrain RGB tiles. See https://www.mapbox.com/help/access-elevation-data/#mapbox-terrain-rgb for more info.<br />
         * default `mapbox`
         * @default mapbox
         */
        _this.encoding = undefined;
        return _this;
    }
    return ElevationTileSourceOptions;
}(RasterTileSourceOptions));

var __extends$Q = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$c = (window && window.__assign) || function () {
    __assign$c = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$c.apply(this, arguments);
};
/**
 * Publicly exposed ElevationTileSource.
 */
var ElevationTileSource = /** @class */ (function (_super) {
    __extends$Q(ElevationTileSource, _super);
    function ElevationTileSource(id, options) {
        var _this = _super.call(this, id) || this;
        _this.options = new ElevationTileSourceOptions().merge(cloneDeep$1(options));
        return _this;
    }
    /**
     * Gets the options of the ElevationTileSource.
     */
    ElevationTileSource.prototype.getOptions = function () {
        return cloneDeep$1(this.options);
    };
    ElevationTileSource.prototype._buildSource = function () {
        var t = __assign$c({ type: "raster-dem", bounds: this.options.bounds, minzoom: this.options.minZoom, maxzoom: this.options.maxZoom, tileSize: this.options.tileSize, encoding: this.options.encoding }, (!this.options.tiles ? { url: this.options.url } : { tiles: this.options.tiles }));
        return t;
    };
    ElevationTileSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var otherOptions = other.getOptions();
        return this.options.url === otherOptions.url &&
            this.options.tiles === otherOptions.tiles &&
            this.options.bounds === otherOptions.bounds &&
            this.options.minZoom === otherOptions.minZoom &&
            this.options.maxZoom === otherOptions.maxZoom &&
            this.options.tileSize === otherOptions.tileSize &&
            this.options.encoding === otherOptions.encoding;
    };
    return ElevationTileSource;
}(Source));

var index$1 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	CanvasSource: CanvasSource,
	DataSource: DataSource,
	ElevationTileSource: ElevationTileSource,
	ImageSource: ImageSource,
	Source: Source,
	UnknownSource: UnknownSource,
	VectorTileSource: VectorTileSource,
	VideoSource: VideoSource
});

var __extends$P = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Abstract class for other layer classes to extend.
 */
var Layer = /** @class */ (function (_super) {
    __extends$P(Layer, _super);
    function Layer(id) {
        var _this = 
        // Assign an random id using a UUID if none was specified.
        _super.call(this) || this;
        _this.id = id || uuid();
        return _this;
    }
    /**
     * Gets the id of the layer
     */
    Layer.prototype.getId = function () {
        return this.id;
    };
    /**
     * Gets the map that the layer is currently added to, or null.
     */
    Layer.prototype.getMap = function () {
        return this.map || null;
    };
    /**
     * Initialization method for the layer which is called when added to the map.
     * @param map The map the layer has been added to.
     */
    Layer.prototype.onAdd = function (map) {
        this.map = map;
        this._invokeEvent("layeradded", this);
        this.map.events.invoke("layeradded", this);
    };
    /**
     * Method that is called when the layer is removed from the map.
     * Should perform any necessary cleanup for the layer.
     */
    Layer.prototype.onRemove = function () {
        var temp = this.map;
        delete this.map;
        this._invokeEvent("layerremoved", this);
        if (temp) {
            temp.events.invoke("layerremoved", this);
        }
    };
    /**
     * Returns if an event is one specified by Mapbox.
     * False means we have defined that event.
     * @internal
     */
    Layer._isMBoxEvent = function (eventType) {
        return !this.LayerEvents.hasOwnProperty(eventType);
    };
    /**
     * Updates the base layout and paint properties.
     * Covers the follow properties: minZoom, maxZoom, filter, and visible.
     * @param newOptions The new base layer options.
     * @internal
     */
    Layer.prototype._updateBaseProperties = function (newOptions, oldOptions) {
        this._updateFilter(newOptions.filter, oldOptions.filter);
        this._updateZoomRange(newOptions.minZoom, oldOptions.minZoom, newOptions.maxZoom, oldOptions.maxZoom);
        this._updateLayoutProperty("visibility", newOptions.visible, oldOptions.visible, newOptions.visible ? "visible" : "none");
    };
    /**
     * Updates the filter for the layer in the maps its attached to.
     * @param newFilter The new filter.
     * @param oldFilter The old filter.
     * Will be checked against newFilter to determine if an update is necessary.
     * @param subFilter Optional filter to substitute for newFilter if updating is necessary.
     * Useful when the option value doesn't exactly match the paint property.
     * @internal
     */
    Layer.prototype._updateFilter = function (newFilter, oldFilter) {
        if (!(isEqual$1(newFilter, oldFilter))) {
            this.map._getMap().setFilter(this.id, newFilter);
        }
    };
    Layer.prototype._updatePaintProperty = function (name, newValue, oldValue, subValue) {
        // Only update if attached to a map and the values are changed.
        if (!(isEqual$1(newValue, oldValue))) {
            this.map._getMap().setPaintProperty(this.id, name, subValue || newValue);
        }
    };
    Layer.prototype._updateLayoutProperty = function (name, newValue, oldValue, subValue) {
        if (!(isEqual$1(newValue, oldValue))) {
            this.map._getMap().setLayoutProperty(this.id, name, subValue || newValue);
        }
    };
    /**
     * Sets the zoom range for the layer in the attached map.
     * @param minZoom The new minimum zoom value.
     * @param maxZoom The new maximum zoom value.
     * @internal
     */
    Layer.prototype._updateZoomRange = function (newMin, oldMin, newMax, oldMax) {
        if ((newMin !== oldMin) || (oldMax !== newMax)) {
            this.map._getMap().setLayerZoomRange(this.id, newMin, newMax);
        }
    };
    // This object is accessible at runtime (unlike interfaces)
    // and can be used to determine which events are ours vs Mapbox's.
    Layer.LayerEvents = {
        layeradded: undefined,
        layerremoved: undefined,
        focusin: undefined,
        focusout: undefined,
    };
    return Layer;
}(EventEmitter));

var __extends$O = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A base class which all other layer options inherit from.
 */
var LayerOptions$1 = /** @class */ (function (_super) {
    __extends$O(LayerOptions, _super);
    function LayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * An expression specifying conditions on source features.
         * Only features that match the filter are displayed.
         */
        _this.filter = undefined;
        /**
         * An integer specifying the minimum zoom level to render the layer at.
         * This value is inclusive, i.e. the layer will be visible at `maxZoom > zoom >= minZoom`.
         * Default `0`.
         * @default 0
         */
        _this.minZoom = 0;
        /**
         * An integer specifying the maximum zoom level to render the layer at.
         * This value is exclusive, i.e. the layer will be visible at `maxZoom > zoom >= minZoom`.
         * Default `24`.
         * @default 24
         */
        _this.maxZoom = 24;
        /**
         * Specifies if the layer is visible or not.
         * Default `true`.
         * @default true
         */
        _this.visible = true;
        return _this;
    }
    /**
     * Customizer for _.cloneDeep calls, allows Source objects to pass through without cloning.
     * Source objects are designed to be modifiable so a reference to the actual Source is fine for users to have.
     * @param value The value being cloned.
     * @internal
     */
    LayerOptions._cloneCustomizer = function (value) {
        if (value instanceof Source) {
            return value;
        }
        else {
            return undefined;
        }
    };
    return LayerOptions;
}(Options));

var __extends$N = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering Point objects in a BubbleLayer.
 */
var BubbleLayerOptions = /** @class */ (function (_super) {
    __extends$N(BubbleLayerOptions, _super);
    function BubbleLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The id or instance of a data source which the layer will render.
         */
        _this.source = undefined;
        /**
         * Required when the source of the layer is a VectorTileSource.
         * A vector source can have multiple layers within it, this identifies which one to render in this layer.
         * Prohibited for all other types of sources.
         */
        _this.sourceLayer = undefined;
        /**
         * The color to fill the circle symbol with.
         * Default `"#1A73AA"`.
         * @default "#1A73AA"
         */
        _this.color = "#1A73AA";
        /**
         * The amount to blur the circles.
         * A value of 1 blurs the circles such that only the center point if at full opacity.
         * Default `0`.
         * @default 0
         */
        _this.blur = 0;
        /**
         * A number between 0 and 1 that indicates the opacity at which the circles will be drawn.
         * Default `1`.
         * @default 1
         */
        _this.opacity = 1;
        /**
         * The color of the circles' outlines.
         * Default `"#FFFFFF"`.
         * @default "#FFFFFF"
         */
        _this.strokeColor = "#FFFFFF";
        /**
         * A number between 0 and 1 that indicates the opacity at which the circles' outlines will be drawn.
         * Default `1`.
         * @default 1
         */
        _this.strokeOpacity = 1;
        /**
         * The width of the circles' outlines in pixels.
         * Default `2`.
         * @default 2
         */
        _this.strokeWidth = 2;
        /**
         * Specifies the orientation of circle when map is pitched.<br />
         * `"map"`: The circle is aligned to the plane of the map.<br />
         * `"viewport"`: The circle is aligned to the plane of the viewport.<br />
         * Default: `"viewport"`
         * @default "viewport"
         */
        _this.pitchAlignment = "viewport";
        /**
         * The radius of the circle symbols in pixels.
         * Must be greater than or equal to 0.
         * Default `8`.
         * @default 8
         */
        _this.radius = 8;
        /**
         * @internal
         * Specifies whether to create focusable indicators for the bubbles.
         * The default highlighting style is provided if the source is DataSource with Shape:
         * ```ts
         * const datasource = new DataSource('bubble-source');
         * datasource.setShapes([new Shape(new Point([-122.335, 47.62]))]);
         * this.map.sources.add(datasource);
         * const layer = new BubbleLayer(datasource, 'bubble', {
         *  radius: 10,
         *  color: 'cyan',
         *  createIndicators: true,
         * });
         * ```
         *
         * For other sources, you can provide the accessibilityIdKey option to specify the property name of the feature to use as the accessibility id.
         * ```ts
         * const vtSource = new VectorTileSource("indoorTiles", { tiles,  // provide your tile urls });
         * this.map.sources.add(vtSource);
         * const layer = new BubbleLayer(vtSource, 'bubble', {
         *  createIndicators: true,
         *  accessibilityIdKey: '{add your ID here}'
         * });
         * ```
         *
         * If you want to customize the highlighting style, you can use the focusin/focusout events to change the style of the bubble.
         * ```ts
         * this.map.events.add('focusin', 'bubble', (e) => { handle the style highlight });
         * ```
         *
         * Note: We treat this as an internal option for now because we hadn't fully decided the default styling for the indicators.
         * Once we decide, we will make this a public option or remove it.
         */
        _this.createIndicators = false;
        /**
         * @internal
         */
        _this.accessibilityIdKey = undefined;
        return _this;
    }
    return BubbleLayerOptions;
}(LayerOptions$1));

var __extends$M = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$6 = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$6 = (window && window.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read$d = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$a = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * Renders Point objects as scalable circles (bubbles).
 */
var BubbleLayer = /** @class */ (function (_super) {
    __extends$M(BubbleLayer, _super);
    /**
     * Constructs a new BubbleLayer.
     * @param source The id or instance of a data source which the layer will render.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the bubble layer.
     */
    function BubbleLayer(source, id, options) {
        var _this = _super.call(this, id) || this;
        _this.accessibleIndicator = [];
        /** @internal */
        _this._setAccessibleIndicator = function () { return __awaiter$6(_this, void 0, void 0, function () {
            var renderedShapes, accessibilityIdKey, createIndicator, insertHiddenBefore, insertHiddenInFront, attach;
            var _this = this;
            return __generator$6(this, function (_a) {
                this.accessibleIndicator.forEach(function (indicator) { return indicator.remove(); });
                this.accessibleIndicator = [];
                renderedShapes = this.map.layers.getRenderedShapes(this.map.getCamera().bounds, this);
                accessibilityIdKey = this.options.accessibilityIdKey || (this._getDataSource() ? Shape._shapeIdPropName : undefined);
                createIndicator = function (renderedShapes, idx) {
                    var curRenderedShape = renderedShapes[idx];
                    var bubbleFeature = curRenderedShape instanceof Shape ? curRenderedShape.toJson() : curRenderedShape;
                    var indicator = new AccessibleIndicator({ positionInSet: idx + 1, setSize: renderedShapes.length });
                    var element = indicator.getElement();
                    var _a = __read$d(_this.map.positionsToPixels([_this.getFirstCoordinate(bubbleFeature.geometry.coordinates)]), 1), pixel = _a[0];
                    element.addEventListener('focusin', function (event) {
                        _this.accessibleIndicator.filter(function (i) { return i !== indicator; }).forEach(function (indicator) { return indicator.remove(); });
                        // insert previous and next popups
                        if (idx - 1 >= 0) {
                            insertHiddenBefore(indicator, createIndicator(renderedShapes, idx - 1));
                        }
                        if (idx + 1 < renderedShapes.length) {
                            attach(createIndicator(renderedShapes, idx + 1));
                        }
                        // if we are on boundaries: add the first / last indicator 
                        // to maintain indicators on full page navigation cycle
                        if (idx >= 2 && idx == renderedShapes.length - 1) {
                            insertHiddenInFront(createIndicator(renderedShapes, 0));
                        }
                        if (idx == 0 && renderedShapes.length >= 2) {
                            attach(createIndicator(renderedShapes, renderedShapes.length - 1));
                        }
                        if (accessibilityIdKey !== undefined) {
                            _this.map._getMap().setPaintProperty(_this.id, 'circle-stroke-color', ['case', ['==', ['get', accessibilityIdKey], bubbleFeature.properties[accessibilityIdKey]], '#000000', _this.options.strokeColor]);
                        }
                        var focusEvent = {
                            target: element,
                            type: 'focusin',
                            map: _this.map,
                            shape: curRenderedShape,
                            originalEvent: event,
                            pixel: pixel
                        };
                        _this._invokeEvent('focusin', focusEvent);
                    });
                    element.addEventListener('focusout', function (event) {
                        if (accessibilityIdKey !== undefined) {
                            _this.map._getMap().setPaintProperty(_this.id, 'circle-stroke-color', ['case', ['==', ['get', accessibilityIdKey], bubbleFeature.properties[accessibilityIdKey]], _this.options.strokeColor, _this.options.strokeColor]);
                        }
                        var focusEvent = {
                            target: element,
                            type: 'focusout',
                            map: _this.map,
                            shape: curRenderedShape,
                            originalEvent: event,
                            pixel: pixel
                        };
                        _this._invokeEvent('focusout', focusEvent);
                    });
                    _this.accessibleIndicator.push(indicator);
                    return indicator;
                };
                insertHiddenBefore = function (base, toInsert) {
                    toInsert.attach(_this.map);
                    var elementToSwapIn = toInsert.getElement();
                    var baseElement = base.getElement();
                    baseElement.parentElement.insertBefore(elementToSwapIn, baseElement);
                };
                insertHiddenInFront = function (toInsert) {
                    toInsert.attach(_this.map);
                    var elementToSwapIn = toInsert.getElement();
                    var parent = elementToSwapIn.parentElement;
                    parent.insertBefore(elementToSwapIn, parent.firstElementChild);
                };
                attach = function (popup) {
                    popup.attach(_this.map);
                };
                if (renderedShapes.length > 0) {
                    attach(createIndicator(renderedShapes, 0));
                }
                if (renderedShapes.length > 1) {
                    attach(createIndicator(renderedShapes, renderedShapes.length - 1));
                }
                return [2 /*return*/];
            });
        }); };
        _this.options = new BubbleLayerOptions().merge(cloneDeepWith$1(options, BubbleLayerOptions._cloneCustomizer));
        _this.options.source = source || _this.options.source;
        return _this;
    }
    /**
     * Gets the options of the bubble layer.
     */
    BubbleLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, BubbleLayerOptions._cloneCustomizer);
    };
    /**
     * Gets the source provided when creating the layer.
     */
    BubbleLayer.prototype.getSource = function () {
        return this.options.source;
    };
    /**
     * Sets the options of the bubble layer.
     * @param newOptions The new options of the bubble layer.
     */
    BubbleLayer.prototype.setOptions = function (options) {
        var newOptions = new BubbleLayerOptions().merge(this.options, cloneDeepWith$1(options, BubbleLayerOptions._cloneCustomizer));
        // Update layout and paint properties if they've changed.
        if (this.map) {
            // If the source or sourceLayer options are changed
            // the layer must be re-added to the map entirely.
            if (newOptions.source !== this.options.source ||
                newOptions.sourceLayer !== this.options.sourceLayer) {
                // No update calls needed if the entire layer is being re-added.
                this.options = newOptions;
                this.map.layers.add(this);
                return;
            }
            this._updateBaseProperties(newOptions, this.options);
            this._updatePaintProperty("circle-blur", newOptions.blur, this.options.blur);
            this._updatePaintProperty("circle-color", newOptions.color, this.options.color);
            this._updatePaintProperty("circle-opacity", newOptions.opacity, this.options.opacity);
            this._updatePaintProperty("circle-radius", newOptions.radius, this.options.radius);
            this._updatePaintProperty("circle-stroke-color", newOptions.strokeColor, this.options.strokeColor);
            this._updatePaintProperty("circle-stroke-opacity", newOptions.strokeOpacity, this.options.strokeOpacity);
            this._updatePaintProperty("circle-stroke-width", newOptions.strokeWidth, this.options.strokeWidth);
            this._updatePaintProperty("circle-pitch-alignment", newOptions.pitchAlignment, this.options.pitchAlignment);
        }
        this.options = newOptions;
    };
    BubbleLayer.prototype.onAdd = function (map) {
        var _this = this;
        _super.prototype.onAdd.call(this, map);
        if (this.options.createIndicators) {
            // Wait for map idle for the first time to ensure `layer.getRenderedShapes` return correct shapes.
            map.events.addOnce('idle', this._setAccessibleIndicator);
            // The rendered shapes may be changed when map is moved. Update the indicators when map is moved.
            map.events.add('moveend', this._setAccessibleIndicator);
            var dataSource = this._getDataSource();
            if (dataSource) {
                // The rendered shapes may be changed when data is added. Update the indicators when data is added.
                map.events.add('dataadded', dataSource, function () {
                    // Wait for map idle to ensure `layer.getRenderedShapes` return correct shapes.
                    map.events.addOnce('idle', _this._setAccessibleIndicator);
                });
            }
            else {
                var sourceId_1 = typeof this.options.source === 'string' ? this.options.source : this.options.source.getId();
                map.events.add('sourcedata', function (mapDataEvent) {
                    var _a;
                    // There's chances that mapDataEvent.isSourceLoaded doesn't update correctly when using flyTo, thus we check by using map.isSourceLoaded.
                    if (((_a = mapDataEvent.source) === null || _a === void 0 ? void 0 : _a.getId()) === sourceId_1 && map._getMap().isSourceLoaded(sourceId_1)) {
                        // Source event will be fired multiple times, and we are only interested when the source is loaded.
                        // Thus design a cache key that only changed when camera & style properties are changed.
                        var curCacheKey = _this._getSourceDataEventCacheKey();
                        if (curCacheKey !== _this.sourceDataEventCacheKey) {
                            _this._setAccessibleIndicator();
                            _this.sourceDataEventCacheKey = curCacheKey;
                        }
                    }
                });
            }
        }
    };
    BubbleLayer.prototype.onRemove = function () {
        if (this.options.createIndicators) {
            this.map.events.remove('idle', this._setAccessibleIndicator);
            this.map.events.remove('moveend', this._setAccessibleIndicator);
            var dataSource = this._getDataSource();
            if (dataSource) {
                this.map.events.remove('dataadded', dataSource, this._setAccessibleIndicator);
            }
            else {
                this.map.events.remove('sourcedata', this._setAccessibleIndicator);
            }
        }
        _super.prototype.onRemove.call(this);
    };
    BubbleLayer.prototype._getSourceDataEventCacheKey = function () {
        if (!this.map) {
            return undefined;
        }
        var mapConfiguration = this.map.getServiceOptions().mapConfiguration;
        return __spreadArray$a(__spreadArray$a([], __read$d(this.map.getCamera().bounds), false), [
            this.map.getCamera().zoom,
            this.map.getCamera().pitch,
            this.map.getStyle().style,
            mapConfiguration instanceof Object ? mapConfiguration.id : mapConfiguration
        ], false).join(',');
    };
    BubbleLayer.prototype._getDataSource = function () {
        var source = typeof this.options.source === 'string' ? this.map.sources.getById(this.options.source) : this.options.source;
        if (source instanceof DataSource) {
            return source;
        }
        return undefined;
    };
    /**
     * @internal
     */
    BubbleLayer.prototype._buildLayers = function () {
        var layer = {
            id: this.id,
            type: "circle",
            source: this.options.source instanceof Source ?
                this.options.source.getId() :
                this.options.source,
            layout: {
                visibility: this.options.visible ? "visible" : "none"
            },
            paint: {
                "circle-color": this.options.color,
                "circle-blur": this.options.blur,
                "circle-opacity": this.options.opacity,
                "circle-stroke-color": this.options.strokeColor,
                "circle-stroke-opacity": this.options.strokeOpacity,
                "circle-stroke-width": this.options.strokeWidth,
                "circle-pitch-alignment": this.options.pitchAlignment,
                "circle-radius": this.options.radius
            },
            minzoom: this.options.minZoom,
            maxzoom: this.options.maxZoom
        };
        // Set properties without defaults only if they are defined.
        if (this.options.filter) {
            layer["filter"] = this.options.filter;
        }
        if (this.options.sourceLayer) {
            layer["source-layer"] = this.options.sourceLayer;
        }
        return [layer];
    };
    /**
     * @internal
     */
    BubbleLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * @internal
     */
    BubbleLayer.prototype._getSourceIds = function () {
        var ids = new Set();
        this.options.source instanceof Source ?
            ids.add(this.options.source.getId()) :
            ids.add(this.options.source);
        return ids;
    };
    /**
     * The coordinates can be nested, so we need to get the first coordinate.
     * @param coordinates The property from the Geometry. Can be Position, Position[], Position[][], etc.
     * @returns
     */
    BubbleLayer.prototype.getFirstCoordinate = function (coordinates) {
        if (!Array.isArray(coordinates[0])) {
            return coordinates;
        }
        return this.getFirstCoordinate(coordinates[0]);
    };
    return BubbleLayer;
}(Layer));

var __extends$L = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering Point objects in a HeatMapLayer.
 */
var HeatMapLayerOptions = /** @class */ (function (_super) {
    __extends$L(HeatMapLayerOptions, _super);
    function HeatMapLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The id or instance of a data source which the layer will render.
         */
        _this.source = undefined;
        /**
         * Required when the source of the layer is a VectorTileSource.
         * A vector source can have multiple layers within it, this identifies which one to render in this layer.
         * Prohibited for all other types of sources.
         */
        _this.sourceLayer = undefined;
        /**
         * Specifies the color gradient used to colorize the pixels in the heatmap.
         * This is defined using an expression that uses `["heatmap-density"]` as input.
         * Default `["interpolate",["linear"],["heatmap-density"],0,"rgba(0,0, 255,0)",0.1,"royalblue",0.3,"cyan",0.5,"lime",0.7,"yellow",1,"red"]`
         * @default `["interpolate",["linear"],["heatmap-density"],0,"rgba(0,0, 255,0)",0.1,"royalblue",0.3,"cyan",0.5,"lime",0.7,"yellow",1,"red"]`
         */
        _this.color = ["interpolate", ["linear"], ["heatmap-density"], 0, "rgba(0,0, 255,0)", 0.1, "royalblue", 0.3, "cyan", 0.5, "lime", 0.7, "yellow", 1, "red"];
        /**
         * Similar to `heatmap-weight` but specifies the global heatmap intensity.
         * The higher this value is, the more ‘weight’ each point will contribute to the appearance.
         * Default `1`
         * @default 1
         */
        _this.intensity = 1;
        /**
         * The opacity at which the heatmap layer will be rendered defined as a number between 0 and 1.
         * Default `1`.
         * @default 1
         */
        _this.opacity = 1;
        /**
         * The radius in pixels used to render a data point on the heatmap.
         * The radius must be a number greater or equal to 1.
         * Default `30`.
         * @default 30
         */
        _this.radius = 30;
        /**
         * Specifies how much an individual data point contributes to the heatmap.
         * Must be a number greater than 0. A value of 5 would be equivalent to having 5 points of weight 1 in the same spot.
         * This is useful when clustering points to allow heatmap rendering or large datasets.
         * Default `1`
         * @default 1
         */
        _this.weight = 1;
        return _this;
    }
    /**
     * Customizer for _.cloneDeep calls, allows Source objects to pass through without cloning.
     * Source objects are designed to be modifiable so a reference to the actual Source is fine for users to have.
     * @param value The value being cloned.
     * @internal
     */
    HeatMapLayerOptions._cloneCustomizer = function (value) {
        if (value instanceof Source) {
            return value;
        }
        else {
            return undefined;
        }
    };
    return HeatMapLayerOptions;
}(LayerOptions$1));

var __extends$K = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Represent the density of data using different colors (HeatMap).
 */
var HeatMapLayer = /** @class */ (function (_super) {
    __extends$K(HeatMapLayer, _super);
    /**
     * Constructs a new HeatMapLayer.
     * @param source The id or instance of a data source which the layer will render.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the heat map layer.
     */
    function HeatMapLayer(source, id, options) {
        var _this = _super.call(this, id) || this;
        _this.options = new HeatMapLayerOptions().merge(cloneDeepWith$1(options, HeatMapLayerOptions._cloneCustomizer));
        _this.options.source = source || _this.options.source;
        return _this;
    }
    /**
     * Gets the options of the heat map layer.
     */
    HeatMapLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, HeatMapLayerOptions._cloneCustomizer);
    };
    /**
     * Gets the source provided when creating the layer.
     */
    HeatMapLayer.prototype.getSource = function () {
        return this.options.source;
    };
    /**
     * Sets the options of the heat map layer.
     * @param newOptions The new options of the heat map layer.
     */
    HeatMapLayer.prototype.setOptions = function (options) {
        var newOptions = new HeatMapLayerOptions().merge(this.options, cloneDeepWith$1(options, HeatMapLayerOptions._cloneCustomizer));
        // Update layout and paint properties if they've changed.
        if (this.map) {
            // If the source or sourceLayer options are changed
            // the layer must be re-added to the map entirely.
            if (newOptions.source !== this.options.source ||
                newOptions.sourceLayer !== this.options.sourceLayer) {
                // No update calls needed if the entire layer is being re-added.
                this.options = newOptions;
                this.map.layers.add(this);
                return;
            }
            this._updateBaseProperties(newOptions, this.options);
            this._updatePaintProperty("heatmap-color", newOptions.color, this.options.color);
            this._updatePaintProperty("heatmap-intensity", newOptions.intensity, this.options.intensity);
            this._updatePaintProperty("heatmap-opacity", newOptions.opacity, this.options.opacity);
            this._updatePaintProperty("heatmap-radius", newOptions.radius, this.options.radius);
            this._updatePaintProperty("heatmap-weight", newOptions.weight, this.options.weight);
        }
        this.options = newOptions;
    };
    /**
     * @internal
     */
    HeatMapLayer.prototype._buildLayers = function () {
        var layer = {
            id: this.id,
            type: "heatmap",
            source: this.options.source instanceof Source ?
                this.options.source.getId() :
                this.options.source,
            layout: {
                visibility: this.options.visible ? "visible" : "none"
            },
            paint: {
                "heatmap-color": this.options.color,
                "heatmap-intensity": this.options.intensity,
                "heatmap-opacity": this.options.opacity,
                "heatmap-radius": this.options.radius,
                "heatmap-weight": this.options.weight,
            },
            minzoom: this.options.minZoom,
            maxzoom: this.options.maxZoom
        };
        // Set properties without defaults only if they are defined.
        if (this.options.filter) {
            layer["filter"] = this.options.filter;
        }
        if (this.options.sourceLayer) {
            layer["source-layer"] = this.options.sourceLayer;
        }
        return [layer];
    };
    /**
     * @internal
     */
    HeatMapLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * @internal
     */
    HeatMapLayer.prototype._getSourceIds = function () {
        var ids = new Set();
        this.options.source instanceof Source ?
            ids.add(this.options.source.getId()) :
            ids.add(this.options.source);
        return ids;
    };
    return HeatMapLayer;
}(Layer));

var __extends$J = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering canvas, image, raster tile, and video layers
 */
var MediaLayerOptions = /** @class */ (function (_super) {
    __extends$J(MediaLayerOptions, _super);
    function MediaLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * A number between -1 and 1 that increases or decreases the contrast of the overlay.
         * Default `0`.
         * @default 0
         */
        _this.contrast = 0;
        /**
         * The duration in milliseconds of a fade transition when a new tile is added.
         * Must be greater or equal to 0.
         * Default `300`.
         * @default 300
         */
        _this.fadeDuration = 300;
        /**
         * Rotates hues around the color wheel.
         * A number in degrees.
         * Default `0`.
         * @default 0
         */
        _this.hueRotation = 0;
        /**
         * A number between 0 and 1 that increases or decreases the maximum brightness of the overlay.
         * Default `1`.
         * @default 1
         */
        _this.maxBrightness = 1;
        /**
         * A number between 0 and 1 that increases or decreases the minimum brightness of the overlay.
         * Default `0`.
         * @default 0
         */
        _this.minBrightness = 0;
        /**
         * A number between 0 and 1 that indicates the opacity at which the overlay will be drawn.
         * Default `1`.
         * @default 1
         */
        _this.opacity = 1;
        /**
         * A number between -1 and 1 that increases or decreases the saturation of the overlay.
         * Default `0`.
         * @default 0
         */
        _this.saturation = 0;
        return _this;
    }
    return MediaLayerOptions;
}(LayerOptions$1));

var __extends$I = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering Point objects in a ImageLayer.
 */
var ImageLayerOptions = /** @class */ (function (_super) {
    __extends$I(ImageLayerOptions, _super);
    function ImageLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * URL to an image to overlay. Images hosted on other domains must have CORs enabled.
         */
        _this.url = undefined;
        /**
         * An array of positions for the corners of the image listed in clockwise order: [top left, top right, bottom right, bottom left].
         */
        _this.coordinates = undefined;
        return _this;
    }
    /**
     * Customizer for _.cloneDeep calls, allows Source objects to pass through without cloning.
     * Source objects are designed to be modifiable so a reference to the actual Source is fine for users to have.
     * @param value The value being cloned.
     * @internal
     */
    ImageLayerOptions._cloneCustomizer = function (value) {
        if (value instanceof Source) {
            return value;
        }
        else {
            return undefined;
        }
    };
    return ImageLayerOptions;
}(MediaLayerOptions));

var __extends$H = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Abstract class for other layer classes which have to build sources.
 * @internal
 */
var SourceBuildingLayer = /** @class */ (function (_super) {
    __extends$H(SourceBuildingLayer, _super);
    function SourceBuildingLayer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @internal
     */
    SourceBuildingLayer.prototype._getSourceIds = function () {
        var ids = new Set();
        ids.add(this._getSourceId());
        return ids;
    };
    SourceBuildingLayer.prototype.onAdd = function (map) {
        _super.prototype.onAdd.call(this, map);
    };
    return SourceBuildingLayer;
}(Layer));

var __extends$G = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Overlays an image on the map with each corner anchored to a coordinate on the map. Also known as a ground or image overlay.
 */
var ImageLayer = /** @class */ (function (_super) {
    __extends$G(ImageLayer, _super);
    /**
     * Constructs a new ImageLayer.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the image layer.
     */
    function ImageLayer(options, id) {
        var _this = _super.call(this, id) || this;
        _this.isLoading = false;
        _this.options = new ImageLayerOptions().merge(cloneDeepWith$1(options, ImageLayerOptions._cloneCustomizer));
        _this.img = new Image();
        _this.reloadImage();
        return _this;
    }
    /**
     * Gets the options of the image layer.
     */
    ImageLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, ImageLayerOptions._cloneCustomizer);
    };
    /**
     * Sets the options of the image layer.
     * @param newOptions The new options of the tile layer.
     */
    ImageLayer.prototype.setOptions = function (options) {
        var newOptions = new ImageLayerOptions().merge(this.options, cloneDeepWith$1(options, ImageLayerOptions._cloneCustomizer));
        var reloadImage = (typeof options.url === "string" && options.url !== this.getOptions().url);
        var coordChanged = (typeof options.coordinates !== "undefined" && options.coordinates !== this.getOptions().coordinates);
        if (this.map) {
            this._updateBaseProperties(newOptions, this.options);
            this._updatePaintProperty("raster-contrast", newOptions.contrast, this.options.contrast);
            this._updatePaintProperty("raster-fade-duration", newOptions.fadeDuration, this.options.fadeDuration);
            this._updatePaintProperty("raster-hue-rotate", newOptions.hueRotation, this.options.hueRotation);
            this._updatePaintProperty("raster-brightness-max", newOptions.maxBrightness, this.options.maxBrightness);
            this._updatePaintProperty("raster-opacity", newOptions.opacity, this.options.opacity);
            this._updatePaintProperty("raster-saturation", newOptions.saturation, this.options.saturation);
            // Get the image source
            var source = this.map._getMap().getSource(this._getSourceId());
            // Check if the source exists and if we need to reload the image or if coordinates have changed
            if (source && (reloadImage || coordChanged)) {
                // Update the image with the new options
                source.updateImage(newOptions);
            }
        }
        this.options = newOptions;
        // Modified to update transform if image url or coordinates change
        if (reloadImage) {
            this.reloadImage();
        }
        else if (coordChanged) {
            this.updateTransform();
        }
    };
    /**
     * Calculates the approximate positions that align with the provided pixels from the source image.
     * @param pixels the provided pixels from the source image used to calculate the positions
     */
    ImageLayer.prototype.getPositions = function (pixels) {
        return this.transform.then(function (t) {
            return t.toTarget(pixels);
        });
    };
    /**
     * Calculates the approximate pixels on the source image that align with the provided positions.
     * @param positions the provided positions from the source image used to calculate the pixels
     */
    ImageLayer.prototype.getPixels = function (positions) {
        return this.transform.then(function (t) {
            return t.toSource(positions);
        });
    };
    /**
     * Calculates the approximate corner coordinates for an image based on the image width, height and by calculating an affine transform from a set of source pixels in the image and a set of target positions that are related.
     * The same number of source and target values must be provided as reference points. It is recommended to provide atleast 3 reference points.
     * @param imgWidth image width
     * @param imgHeight image height
     * @param source a set of source pixels
     * @param target target positions
     */
    ImageLayer.getCoordinatesFromRefPoints = function (imgWidth, imgHeight, source, target) {
        var transform = new AffineTransform(source, target);
        return transform.toTarget([
            [0, 0],
            [imgWidth, 0],
            [imgWidth, imgHeight],
            [0, imgHeight]
        ]);
    };
    /**
     * Calculates coordinates for a rotated image layer when provided with the bounding box edges and rotation value.
     * Note: If your rotation value is from a KML Ground Overlay it will need to be converted to a clockwise rotation using the following formula: `rotation = 360 – KmlRotation`
     * @param north The north edge of the bounding box.
     * @param south The south edge of the bounding box.
     * @param east The east edge of the bounding box.
     * @param west The west edge of the bounding box.
     * @param rotation Clockwise rotation in degrees
     */
    ImageLayer.getCoordinatesFromEdges = function (north, south, east, west, rotation) {
        if (typeof rotation !== "number") {
            rotation = 0;
        }
        // [minLon, minLat, maxLon, maxLat]
        var bounds = [
            Math.min(west, east),
            south,
            Math.max(west, east),
            north
        ];
        // Calculate the center of the bounding box and use that as the rotation origin.
        var origin = BoundingBox.getCenter(bounds);
        // Calculate the corner coordinates of the bounding box.
        var topLeft = BoundingBox.getNorthWest(bounds);
        var topRight = BoundingBox.getNorthEast(bounds);
        var bottomRight = BoundingBox.getSouthEast(bounds);
        var bottomLeft = BoundingBox.getSouthWest(bounds);
        // Calcuate to rotated corners of the bounding box.
        return rotatePositions([
            topLeft,
            topRight,
            bottomRight,
            bottomLeft
        ], origin, rotation);
    };
    /**
     * @internal
     */
    ImageLayer.prototype._buildLayers = function () {
        var layer = {
            id: this.id,
            type: "raster",
            source: this._getSourceId(),
            layout: {
                visibility: this.options.visible ? "visible" : "none"
            },
            paint: {
                "raster-opacity": this.options.opacity,
                "raster-hue-rotate": this.options.hueRotation,
                "raster-brightness-min": this.options.minBrightness,
                "raster-brightness-max": this.options.maxBrightness,
                "raster-saturation": this.options.saturation,
                "raster-contrast": this.options.contrast,
                "raster-fade-duration": this.options.fadeDuration
            },
            minzoom: this.options.minZoom,
            maxzoom: this.options.maxZoom
        };
        // Set properties without defaults only if they are defined.
        if (this.options.filter) {
            layer["filter"] = this.options.filter;
        }
        return [layer];
    };
    /**
     * @internal
     */
    ImageLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * Builds the imge source to include with the layer.
     * @internal
     */
    ImageLayer.prototype._buildSource = function () {
        return {
            type: "image",
            url: this.options.url,
            coordinates: this.options.coordinates
        };
    };
    /**
     * Gets the id of the source to be paired with this layer.
     * @internal
     */
    ImageLayer.prototype._getSourceId = function () {
        return "".concat(this.getId(), "-ImageSource");
    };
    ImageLayer.prototype.reloadImage = function () {
        var _this = this;
        if (this.options.url) {
            this.transform = new Promise(function (resolve, reject) {
                _this.img.onload = function () {
                    var corners = [[0, 0], [_this.img.width, 0], [_this.img.width, _this.img.height], [0, _this.img.height]];
                    resolve(new AffineTransform(corners, _this.options.coordinates));
                    _this.isLoading = false;
                };
                _this.img.onerror = _this.img.onabort = function () {
                    reject("Failed to load image");
                };
                _this.isLoading = true;
                _this.img.src = _this.options.url;
            });
        }
    };
    ImageLayer.prototype.updateTransform = function () {
        if (!this.isLoading) {
            var corners = [[0, 0], [this.img.width, 0], [this.img.width, this.img.height], [0, this.img.height]];
            this.transform = Promise.resolve(new AffineTransform(corners, this.options.coordinates));
        }
    };
    ImageLayer.prototype._getSourceWrapper = function () {
        var sourceId = this._getSourceId();
        var source = this._buildSource();
        return new ImageSource(sourceId, source);
    };
    return ImageLayer;
}(SourceBuildingLayer));

var __extends$F = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering SimpleLine, SimplePolygon, CirclePolygon,
 * LineString, MultiLineString, Polygon, and MultiPolygon objects in a line layer.
 */
var LineLayerOptions = /** @class */ (function (_super) {
    __extends$F(LineLayerOptions, _super);
    function LineLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The id or instance of a data source which the layer will render.
         */
        _this.source = undefined;
        /**
         * Required when the source of the layer is a VectorTileSource.
         * A vector source can have multiple layers within it, this identifies which one to render in this layer.
         * Prohibited for all other types of sources.
         */
        _this.sourceLayer = undefined;
        /**
         * Specifies how the ends of the lines are rendered.<br />
         * `"butt"`: A cap with a squared-off end which is drawn to the exact endpoint of the line.<br />
         * `"round"`: A cap with a rounded end which is drawn beyond the endpoint of the line
         * at a radius of one-half of the lines width and centered on the endpoint of the line.<br />
         * `"square"`: A cap with a squared-off end which is drawn beyond the endpoint of the line
         * at a distance of one-half of the line width.<br />
         * Default `"round"`.
         * @default "round"
         */
        _this.lineCap = "round";
        /**
         * Specifies how the joints in the lines are rendered.<br />
         * `"bevel"`: A join with a squared-off end which is drawn beyond the endpoint of the line
         * at a distance of one-half of the lines width.<br />
         * `"round"`: A join with a rounded end which is drawn beyond the endpoint of the line
         * at a radius of one-half of the lines width and centered on the endpoint of the line.<br />
         * `"miter"`: A join with a sharp, angled corner which is drawn with the outer sides
         * beyond the endpoint of the path until they meet.<br />
         * Default `"round"`.
         * @default "round"
         */
        _this.lineJoin = "round";
        /**
         * The amount of blur to apply to the line in pixels.
         * Default `0`.
         * @default 0
         */
        _this.blur = 0;
        /**
         * Specifies the color of the line.
         * Default `"#1E90FF"`.
         * @default "#1E90FF"
         */
        _this.strokeColor = "#1E90FF";
        /**
         * Specifies the lengths of the alternating dashes and gaps that form the dash pattern.
         * Numbers must be equal or greater than 0. The lengths are scaled by the strokeWidth.
         * To convert a dash length to pixels, multiply the length by the current stroke width.
         */
        _this.strokeDashArray = undefined;
        /**
         * Defines a gradient with which to color the lines.
         * Requires the DataSource lineMetrics option to be set to true.
         * Disabled if strokeDashArray is set.
         */
        _this.strokeGradient = undefined;
        /**
         * The line's offset.
         * A positive value offsets the line to the right, relative to the direction of the line.
         * A negative value offsets to the left.
         * Default `0`.
         * @default 0
         */
        _this.offset = 0;
        /**
         * A number between 0 and 1 that indicates the opacity at which the line will be drawn.
         * Default `1`.
         * @default 1
         */
        _this.strokeOpacity = 1;
        /**
         * The amount of offset in pixels to render the line relative to where it would render normally.
         * Negative values indicate left and up.
         * Default: `[0,0]`
         * @default [0, 0]
         */
        _this.translate = new Pixel(0, 0);
        /**
         * Specifies the frame of reference for `translate`.<br />
         * `"map"`: Lines are translated relative to the map.<br />
         * `"viewport"`: Lines are translated relative to the viewport<br />
         * Default: `"map"`
         * @default "map"
         */
        _this.translateAnchor = "map";
        /**
         * The width of the line in pixels. Must be a value greater or equal to 0.
         * Default `2`.
         * @default 2
         */
        _this.strokeWidth = 2;
        return _this;
    }
    return LineLayerOptions;
}(LayerOptions$1));

var __extends$E = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$b = (window && window.__assign) || function () {
    __assign$b = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$b.apply(this, arguments);
};
/**
 * Renders line data on the map. Can be used with SimpleLine, SimplePolygon,
 * CirclePolygon, LineString, MultiLineString, Polygon, and MultiPolygon objects.
 */
var LineLayer = /** @class */ (function (_super) {
    __extends$E(LineLayer, _super);
    /**
     * Constructs a new LineLayer.
     * @param source The id or instance of a data source which the layer will render.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the line layer.
     */
    function LineLayer(source, id, options) {
        var _this = _super.call(this, id) || this;
        _this.options = new LineLayerOptions().merge(cloneDeepWith$1(options, LineLayerOptions._cloneCustomizer));
        _this.options.source = source || _this.options.source;
        return _this;
    }
    /**
     * Gets the options of the line layer.
     */
    LineLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, LineLayerOptions._cloneCustomizer);
    };
    /**
     * Gets the source provided when creating the layer.
     */
    LineLayer.prototype.getSource = function () {
        return this.options.source;
    };
    /**
     * Sets the options of the line layer.
     * @param options The new options of the line layer.
     */
    LineLayer.prototype.setOptions = function (options) {
        var newOptions = new LineLayerOptions().merge(this.options, cloneDeepWith$1(options, LineLayerOptions._cloneCustomizer));
        // Update layout and paint properties if they've changed.
        if (this.map) {
            // If the source or sourceLayer options are changed
            // the layer must be re-added to the map entirely.
            if (newOptions.source !== this.options.source ||
                newOptions.sourceLayer !== this.options.sourceLayer) {
                // No update calls needed if the entire layer is being re-added.
                this.options = newOptions;
                this.map.layers.add(this);
                return;
            }
            this._updateBaseProperties(newOptions, this.options);
            this._updatePaintProperty("line-blur", newOptions.blur, this.options.blur);
            this._updateLayoutProperty("line-cap", newOptions.lineCap, this.options.lineCap);
            this._updateLayoutProperty("line-join", newOptions.lineJoin, this.options.lineJoin);
            this._updatePaintProperty("line-offset", newOptions.offset, this.options.offset);
            this._updatePaintProperty("line-color", newOptions.strokeColor, this.options.strokeColor);
            this._updatePaintProperty("line-dasharray", newOptions.strokeDashArray, this.options.strokeDashArray);
            this._updatePaintProperty("line-gradient", newOptions.strokeGradient, this.options.strokeGradient);
            this._updatePaintProperty("line-opacity", newOptions.strokeOpacity, this.options.strokeOpacity);
            this._updatePaintProperty("line-width", newOptions.strokeWidth, this.options.strokeWidth);
            this._updatePaintProperty("line-translate", newOptions.translate, this.options.translate);
            this._updatePaintProperty("line-translate-anchor", newOptions.translateAnchor, this.options.translateAnchor);
        }
        this.options = newOptions;
    };
    /**
     * @internal
     */
    LineLayer.prototype._buildLayers = function () {
        var layer = __assign$b(__assign$b(__assign$b(__assign$b({ id: this.id, type: "line" }, (this.options.sourceLayer && { "source-layer": this.options.sourceLayer })), { source: this.options.source instanceof Source ?
                this.options.source.getId() :
                this.options.source, layout: {
                visibility: this.options.visible ? "visible" : "none",
                "line-cap": this.options.lineCap,
                "line-join": this.options.lineJoin
            }, paint: __assign$b(__assign$b(__assign$b({ "line-blur": this.options.blur, "line-color": this.options.strokeColor }, (this.options.strokeDashArray ? { "line-dasharray": this.options.strokeDashArray } : {})), (this.options.strokeGradient ? { "line-gradient": this.options.strokeGradient } : {})), { "line-offset": this.options.offset, "line-opacity": this.options.strokeOpacity, "line-translate": this.options.translate, "line-translate-anchor": this.options.translateAnchor, "line-width": this.options.strokeWidth }) }), (this.options.filter && { filter: this.options.filter })), { minzoom: this.options.minZoom, maxzoom: this.options.maxZoom });
        return [layer];
    };
    /**
     * @internal
     */
    LineLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * @internal
     */
    LineLayer.prototype._getSourceIds = function () {
        var ids = new Set();
        this.options.source instanceof Source ?
            ids.add(this.options.source.getId()) :
            ids.add(this.options.source);
        return ids;
    };
    return LineLayer;
}(Layer));

var __extends$D = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering `Polygon` and `MultiPolygon` objects in a `PolygonExtrusionLayer`.
 */
var PolygonExtrusionLayerOptions = /** @class */ (function (_super) {
    __extends$D(PolygonExtrusionLayerOptions, _super);
    function PolygonExtrusionLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The id or instance of a data source which the layer will render.
         */
        _this.source = undefined;
        /**
         * Required when the source of the layer is a VectorTileSource.
         * A vector source can have multiple layers within it, this identifies which one to render in this layer.
         * Prohibited for all other types of sources.
         */
        _this.sourceLayer = undefined;
        /**
         * The height in meters to extrude the base of this layer.
         * This height is relative to the ground.
         * Must be greater or equal to 0 and less than or equal to `height`.
         * Default `0`.
         * @default 0
         */
        _this.base = 0;
        /**
         * The color to fill the polygons with.
         * Ignored if `fillPattern` is set.
         * Default `"#1E90FF"`.
         * @default "#1E90FF"
         */
        _this.fillColor = "#1E90FF";
        /**
         * The height in meters to extrude this layer.
         * This height is relative to the ground.
         * Must be a number greater or equal to 0.
         * Default `0`
         * @default 0
         */
        _this.height = 0;
        /**
         * A number between 0 and 1 that indicates the opacity at which the fill will be drawn.
         * Default `1`.
         * @default 1
         */
        _this.fillOpacity = 1;
        /**
         * Name of image in sprite to use for drawing image fills.
         * For seamless patterns, image width must be a factor of two (2, 4, 8, ..., 512).
         */
        _this.fillPattern = undefined;
        /**
         * The polygons' pixel offset.
         * Values are [x, y] where negatives indicate left and up, respectively.
         * Default `[0, 0]`
         * @default [0, 0]
         */
        _this.translate = new Pixel(0, 0);
        /**
         * Specifies the frame of reference for `translate`.<br />
         * `"map"`: Polygons are translated relative to the map.<br />
         * `"viewport"`: Polygons are translated relative to the viewport.<br />
         * Default: `"map"`
         * @default "map"
         */
        _this.translateAnchor = "map";
        /**
         * Specifies if the polygon should have a vertical gradient on the sides of the extrusion.
         * Default: `true`
         * @default true
         */
        _this.verticalGradient = true;
        return _this;
    }
    return PolygonExtrusionLayerOptions;
}(LayerOptions$1));

var __extends$C = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$a = (window && window.__assign) || function () {
    __assign$a = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$a.apply(this, arguments);
};
/**
 * Renders extruded filled `Polygon` and `MultiPolygon` objects on the map.
 */
var PolygonExtrusionLayer = /** @class */ (function (_super) {
    __extends$C(PolygonExtrusionLayer, _super);
    /**
     * Constructs a new PolygonExtrusionLayer.
     * @param source The id or instance of a data source which the layer will render.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the polygon extrusion layer.
     */
    function PolygonExtrusionLayer(source, id, options) {
        var _this = _super.call(this, id) || this;
        _this.options = new PolygonExtrusionLayerOptions().merge(cloneDeepWith$1(options, PolygonExtrusionLayerOptions._cloneCustomizer));
        _this.options.source = source || _this.options.source;
        return _this;
    }
    /**
     * Gets the options of the polygon layer.
     */
    PolygonExtrusionLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, PolygonExtrusionLayerOptions._cloneCustomizer);
    };
    /**
     * Gets the source provided when creating the layer.
     */
    PolygonExtrusionLayer.prototype.getSource = function () {
        return this.options.source;
    };
    /**
     * Sets the options of the polygon layer.
     * @param newOptions The new options of the polygon layer.
     */
    PolygonExtrusionLayer.prototype.setOptions = function (options) {
        var newOptions = new PolygonExtrusionLayerOptions().merge(this.options, cloneDeepWith$1(options, PolygonExtrusionLayerOptions._cloneCustomizer));
        // Update layout and paint properties if they've changed.
        if (this.map) {
            // If the source or sourceLayer options are changed
            // the layer must be re-added to the map entirely.
            if (newOptions.source !== this.options.source ||
                newOptions.sourceLayer !== this.options.sourceLayer) {
                // No update calls needed if the entire layer is being re-added.
                this.options = newOptions;
                this.map.layers.add(this);
                return;
            }
            this._updateBaseProperties(newOptions, this.options);
            this._updatePaintProperty("fill-extrusion-base", newOptions.base, this.options.base);
            this._updatePaintProperty("fill-extrusion-color", newOptions.fillColor, this.options.fillColor);
            this._updatePaintProperty("fill-extrusion-height", newOptions.height, this.options.height);
            this._updatePaintProperty("fill-extrusion-opacity", newOptions.fillOpacity, this.options.fillOpacity);
            this._updatePaintProperty("fill-extrusion-pattern", newOptions.fillPattern, this.options.fillPattern);
            this._updatePaintProperty("fill-extrusion-translate", newOptions.translate, this.options.translate);
            this._updatePaintProperty("fill-extrusion-translate-anchor", newOptions.translateAnchor, this.options.translateAnchor);
            this._updatePaintProperty("fill-extrusion-vertical-gradient", newOptions.verticalGradient, this.options.verticalGradient);
        }
        this.options = newOptions;
    };
    /**
     * @internal
     */
    PolygonExtrusionLayer.prototype._buildLayers = function () {
        var layer = __assign$a(__assign$a(__assign$a(__assign$a({ id: this.id, type: "fill-extrusion" }, (this.options.sourceLayer && { "source-layer": this.options.sourceLayer })), { source: this.options.source instanceof Source ?
                this.options.source.getId() :
                this.options.source, layout: {
                visibility: this.options.visible ? "visible" : "none",
            }, paint: __assign$a(__assign$a({ "fill-extrusion-base": this.options.base, "fill-extrusion-height": this.options.height, "fill-extrusion-opacity": this.options.fillOpacity }, (this.options.fillPattern ?
                { "fill-extrusion-pattern": this.options.fillPattern } :
                { "fill-extrusion-color": this.options.fillColor })), { "fill-extrusion-translate": this.options.translate, "fill-extrusion-translate-anchor": this.options.translateAnchor, "fill-extrusion-vertical-gradient": this.options.verticalGradient }) }), (this.options.filter && { filter: this.options.filter })), { minzoom: this.options.minZoom, maxzoom: this.options.maxZoom });
        return [layer];
    };
    /**
     * @internal
     */
    PolygonExtrusionLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * @internal
     */
    PolygonExtrusionLayer.prototype._getSourceIds = function () {
        var ids = new Set();
        this.options.source instanceof Source ?
            ids.add(this.options.source.getId()) :
            ids.add(this.options.source);
        return ids;
    };
    return PolygonExtrusionLayer;
}(Layer));

var __extends$B = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering Polygon and MultiPolygon objects in a PolygonLayer.
 */
var PolygonLayerOptions$1 = /** @class */ (function (_super) {
    __extends$B(PolygonLayerOptions, _super);
    function PolygonLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The id or instance of a data source which the layer will render.
         */
        _this.source = undefined;
        /**
         * Required when the source of the layer is a VectorTileSource.
         * A vector source can have multiple layers within it, this identifies which one to render in this layer.
         * Prohibited for all other types of sources.
         */
        _this.sourceLayer = undefined;
        /**
         * The color to fill the polygons with.
         * Default `"#1E90FF"`.
         * @default "#1E90FF"
         */
        _this.fillColor = "#1E90FF";
        /**
         * A number between 0 and 1 that indicates the opacity at which the fill will be drawn.
         * Default `0.5`.
         * @default 0.5
         */
        _this.fillOpacity = 0.5;
        /**
         * Name of image in sprite to use for drawing image fills. For seamless patterns, image width must be a factor of two (2, 4, 8, ..., 512).
         */
        _this.fillPattern = undefined;
        /**
         * Whether or not the fill should be antialiased.
         * Default `true`.
         * @default true
         */
        _this.fillAntialias = true;
        return _this;
    }
    return PolygonLayerOptions;
}(LayerOptions$1));

var __extends$A = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Renders filled Polygon and MultiPolygon objects on the map.
 */
var PolygonLayer = /** @class */ (function (_super) {
    __extends$A(PolygonLayer, _super);
    /**
     * Constructs a new PolygonLayer.
     * @param source The id or instance of a data source which the layer will render.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the polygon layer.
     */
    function PolygonLayer(source, id, options) {
        var _this = _super.call(this, id) || this;
        _this.options = new PolygonLayerOptions$1().merge(cloneDeepWith$1(options, PolygonLayerOptions$1._cloneCustomizer));
        _this.options.source = source || _this.options.source;
        return _this;
    }
    /**
     * Gets the options of the polygon layer.
     */
    PolygonLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, PolygonLayerOptions$1._cloneCustomizer);
    };
    /**
     * Gets the source provided when creating the layer.
     */
    PolygonLayer.prototype.getSource = function () {
        return this.options.source;
    };
    /**
     * Sets the options of the polygon layer.
     * When `fillPattern` is set, `fillColor` will be ignored.
     * To set `fillColor`, make sure `fillPattern` is set to `undefined`.
     * @param newOptions The new options of the polygon layer.
     */
    PolygonLayer.prototype.setOptions = function (options) {
        var newOptions = new PolygonLayerOptions$1().merge(this.options, cloneDeepWith$1(options, PolygonLayerOptions$1._cloneCustomizer));
        // Update layout and paint properties if they've changed.
        if (this.map) {
            // If the source or sourceLayer options are changed
            // the layer must be re-added to the map entirely.
            if (newOptions.source !== this.options.source ||
                newOptions.sourceLayer !== this.options.sourceLayer) {
                // No update calls needed if the entire layer is being re-added.
                this.options = newOptions;
                this.map.layers.add(this);
                return;
            }
            this._updateBaseProperties(newOptions, this.options);
            this._updatePaintProperty("fill-color", newOptions.fillColor, this.options.fillColor);
            this._updatePaintProperty("fill-opacity", newOptions.fillOpacity, this.options.fillOpacity);
            this._updatePaintProperty("fill-pattern", newOptions.fillPattern, this.options.fillPattern);
            this._updatePaintProperty("fill-antialias", newOptions.fillAntialias, this.options.fillAntialias);
        }
        this.options = newOptions;
    };
    /**
     * @internal
     */
    PolygonLayer.prototype._buildLayers = function () {
        var layer = {
            id: this.id,
            type: "fill",
            source: this.options.source instanceof Source ?
                this.options.source.getId() :
                this.options.source,
            layout: {
                visibility: this.options.visible ? "visible" : "none"
            },
            paint: {
                "fill-opacity": this.options.fillOpacity,
                "fill-antialias": this.options.fillAntialias,
            },
            minzoom: this.options.minZoom,
            maxzoom: this.options.maxZoom
        };
        // Set properties without defaults only if they are defined.
        if (this.options.filter) {
            layer["filter"] = this.options.filter;
        }
        if (this.options.sourceLayer) {
            layer["source-layer"] = this.options.sourceLayer;
        }
        // The property fill-pattern should only be set if there is a value for fillPattern.
        // The property fill-color should only be set if fill-pattern isn't.
        if (this.options.fillPattern) {
            layer.paint["fill-pattern"] = this.options.fillPattern;
        }
        else {
            layer.paint["fill-color"] = this.options.fillColor;
        }
        return [layer];
    };
    /**
     * @internal
     */
    PolygonLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * @internal
     */
    PolygonLayer.prototype._getSourceIds = function () {
        var ids = new Set();
        this.options.source instanceof Source ?
            ids.add(this.options.source.getId()) :
            ids.add(this.options.source);
        return ids;
    };
    return PolygonLayer;
}(Layer));

var __extends$z = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used to customize the icons in a SymbolLayer
 */
var IconOptions = /** @class */ (function (_super) {
    __extends$z(IconOptions, _super);
    function IconOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Specifies if the symbol icon can overlay other symbols on the map.
         * If `true` the icon will be visible even if it collides with other previously drawn symbols.
         * Tip: Set this to true if animating an symbol to ensure smooth rendering.
         * Default `false`.
         * @default false
         */
        _this.allowOverlap = false;
        /**
         * Specifies which part of the icon is placed closest to the icons anchor position on the map.<br />
         * `"center"`: The center of the icon is placed closest to the anchor.<br />
         * `"left"`: The left side of the icon is placed closest to the anchor.<br />
         * `"right"`: The right side of the icon is placed closest to the anchor.<br />
         * `"top"`: The top of the icon is placed closest to the anchor.<br />
         * `"bottom"`: The bottom of the icon is placed closest to the anchor.<br />
         * `"top-left"`: The top left corner of the icon is placed closest to the anchor.<br />
         * `"top-right"`: The top right corner of the icon is placed closest to the anchor.<br />
         * `"bottom-left"`: The bottom left corner of the icon is placed closest to the anchor.<br />
         * `"bottom-right"`: The bottom right corner of the icon is placed closest to the anchor.<br />
         * Default `"bottom"`.
         * @default "bottom"
         */
        _this.anchor = "bottom";
        /**
         * Specifies if other symbols can overlap this symbol.
         * If true, other symbols can be visible even if they collide with the icon.
         * Default `false`.
         * @default false
         */
        _this.ignorePlacement = false;
        /**
         * The name of the image in the map's image sprite to use for drawing the icon.
         * Available built-in images are: `marker-black`, `marker-blue`, `marker-darkblue`,
         * `marker-red`, `marker-yellow`, `pin-blue`, `pin-darkblue`, `pin-red`, `pin-round-blue`,
         * `pin-round-darkblue`, `pin-round-red`.
         * Default `"marker-blue"`.
         * @default "marker-blue"
         */
        _this.image = "marker-blue";
        /**
         * Specifies an offset distance of the icon from its anchor in pixels.
         * Positive values indicate right and down, while negative values indicate left and up.
         * Each component is multiplied by the value of size to obtain the final offset in pixels.
         * When combined with rotation the offset will be as if the rotated direction was up.
         * Default `[0, 0]`.
         * @default [0, 0]
         */
        _this.offset = new Pixel(0, 0);
        /**
         * Specifies if a symbols icon can be hidden but its text displayed if it is overlapped with another symbol.
         * If true, text will display without their corresponding icons
         * when the icon collides with other symbols and the text does not.
         * Default `false`.
         * @default false
         */
        _this.optional = false;
        /**
         * Size of the additional area around the icon bounding box used for detecting symbol collisions.
         * Default `2`.
         * @default 2
         */
        _this.padding = 2;
        /**
         * Specifies the orientation of the icon when the map is pitched.<br />
         * `"auto"`: Automatically matches the value of `rotationAlignment`.<br />
         * `"map"`: The icon is aligned to the plane of the map.<br />
         * `"viewport"`: The icon is aligned to the plane of the viewport<br />
         * Default `"auto"`
         * @default "auto"
         */
        _this.pitchAlignment = "auto";
        /**
         * The amount to rotate the icon clockwise in degrees
         * Default `0`.
         * @default 0
         */
        _this.rotation = 0;
        /**
         * In combination with the placement property of a SymbolLayerOptions
         * this determines the rotation behavior of icons.<br />
         * `"auto"`: When placement is "point" this is equivalent to "viewport".
         * When placement is "line" this is equivalent to "map".<br />
         * `"map"`: When placement is "point" aligns icons east-west.
         * When placement is "line" aligns the icons' x-axes with the line.<br />
         * `"viewport"`: Icons' x-axes will align with the x-axis of the viewport.<br />
         * Default `"auto"`.
         * @default "auto"
         */
        _this.rotationAlignment = "auto";
        /**
         * Scales the original size of the icon by the provided factor.
         * Must be greater or equal to 0.
         * Default `1`.
         * @default 1
         */
        _this.size = 1;
        /**
         * A number between 0 and 1 that indicates the opacity at which the icon will be drawn.
         * Default `1`.
         * @default 1
         */
        _this.opacity = 1;
        return _this;
    }
    return IconOptions;
}(Options));

var __extends$y = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used to customize the text in a SymbolLayer
 */
var TextOptions = /** @class */ (function (_super) {
    __extends$y(TextOptions, _super);
    function TextOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Specifies if the text will be visible if it collides with other symbols.
         * If true, the text will be visible even if it collides with other previously drawn symbols.
         * Default `false`.
         * @default false
         */
        _this.allowOverlap = false;
        /**
         * Specifies which part of the icon is placed closest to the icons anchor position on the map.<br />
         * `"center"`: The center of the icon is placed closest to the anchor.<br />
         * `"left"`: The left side of the icon is placed closest to the anchor.<br />
         * `"right"`: The right side of the icon is placed closest to the anchor.<br />
         * `"top"`: The top of the icon is placed closest to the anchor.<br />
         * `"bottom"`: The bottom of the icon is placed closest to the anchor.<br />
         * `"top-left"`: The top left corner of the icon is placed closest to the anchor.<br />
         * `"top-right"`: The top right corner of the icon is placed closest to the anchor.<br />
         * `"bottom-left"`: The bottom left corner of the icon is placed closest to the anchor.<br />
         * `"bottom-right"`: The bottom right corner of the icon is placed closest to the anchor.<br />
         * Default `"center"`.
         * @default "center"
         */
        _this.anchor = "center";
        /**
         * Specifies the name of a property on the features to use for a text label.
         */
        _this.textField = undefined;
        /**
         * The font stack to use for displaying text.
         * Possible values: `"SegoeFrutigerHelveticaMYingHei-Bold"`, `"SegoeFrutigerHelveticaMYingHei-Medium"`,
         * `"SegoeFrutigerHelveticaMYingHei-Regular"`, `"SegoeUi-Bold"`, `"SegoeUi-Light"`, `"SegoeUi-Regular"`,
         * `"SegoeUi-SemiBold"`, `"SegoeUi-SemiLight"`, `"SegoeUi-SymbolRegular"`, `"StandardCondensedSegoeUi-Black"`,
         * `"StandardCondensedSegoeUi-Bold"`, `"StandardCondensedSegoeUi-Light"`, `"StandardCondensedSegoeUi-Regular"`,
         * `"StandardFont-Black"`, `"StandardFont-Bold"`, `"StandardFont-Light"`, `"StandardFont-Regular"`,
         * `"StandardFontCondensed-Black"`, `"StandardFontCondensed-Bold"`, `"StandardFontCondensed-Light"`,
         * `"StandardFontCondensed-Regular"`.
         * Default `["StandardFont-Regular"]`.
         * @default ["StandardFont-Regular"]
         */
        _this.font = ["StandardFont-Regular"];
        /**
         * Specifies if the other symbols are allowed to collide with the text.
         * If true, other symbols can be visible even if they collide with the text.
         * Default `false`.
         * @default false
         */
        _this.ignorePlacement = false;
        /**
         * Text justification options.<br />
         * `"auto"`: The text is aligned towards the anchor position.<br />
         * `"left"`: The text is aligned to the left.<br />
         * `"center"`: The text is centered.<br />
         * `"right"`: The text is aligned to the right.<br />
         * Default `"center"`.
         * @default "center"
         */
        _this.justify = "center";
        /**
         * Specifies an offset distance of the icon from its anchor in ems.
         * Positive values indicate right and down, while negative values indicate left and up.
         * Default `[0, 0]`.
         * @default [0, 0]
         */
        _this.offset = new Pixel(0, 0);
        /**
         * Specifies if the text can be hidden if it is overlapped by another symbol.
         * If true, icons will display without their corresponding text
         * when the text collides wit other symbols and the icon does not.
         * Default `false`.
         * @default false
         */
        _this.optional = false;
        /**
         * Size of the additional area around the text bounding box used for detecting
         * symbol collisions.
         * Default `2`.
         * @default 2
         */
        _this.padding = 2;
        /**
         * Specifies the orientation of the text when the map is pitched.<br />
         * `"auto"`: Automatically matches the value of `rotationAlignment`.<br />
         * `"map"`: The text is aligned to the plane of the map.<br />
         * `"viewport"`: The text is aligned to the plane of the viewport.<br />
         * Default: `"auto"`
         * @default "auto"
         */
        _this.pitchAlignment = "auto";
        /**
         * Radial offset of text, in the direction of the symbol's anchor. Useful in combination
         * with `variableAnchor`, which defaults to using the two-dimensional `offset` if present.
         * Default: `undefined`
         * @default undefined
         */
        _this.radialOffset = undefined;
        /**
         * The amount to rotate the text clockwise in degrees.
         * Default `0`
         * @default 0
         */
        _this.rotation = 0;
        /**
         * In combination with the `placement` property of the `SymbolLayerOptions`,
         * specifies the rotation behavior of the individual glyphs forming the text.<br />
         * `"auto"`: When the `placement` is set to `"point"`, this is equivalent to `"map"`.
         * When the `placement` is set to `"line"` this is equivalent to `"map"`.<br />
         * `"map"`: When the `placement` is set to `"point"`, aligns text east-west.
         * When the `placement` is set to `"line"`, aligns text x-axes with the line.<br />
         * `"viewport"`: Produces glyphs whose x-axes are aligned with the x-axis of the viewport,
         * regardless of the value of `placement`.<br />
         * Default: `"auto"`
         * @default "auto"
         */
        _this.rotationAlignment = "auto";
        /**
         * List of potential anchor locations, to increase the chance of placing high-priority
         * labels on the map. The renderer will attempt to place the label at each location,
         * in order, before moving onto the next label. Use `justify: "auto"` to choose text
         * justification based on anchor position. To apply an offset use the `radialOffset` or
         * two-dimensional `offset` options.<br />
         * `"center"`: The center of the icon is placed closest to the anchor.<br />
         * `"left"`: The left side of the icon is placed closest to the anchor.<br />
         * `"right"`: The right side of the icon is placed closest to the anchor.<br />
         * `"top"`: The top of the icon is placed closest to the anchor.<br />
         * `"bottom"`: The bottom of the icon is placed closest to the anchor.<br />
         * `"top-left"`: The top left corner of the icon is placed closest to the anchor.<br />
         * `"top-right"`: The top right corner of the icon is placed closest to the anchor.<br />
         * `"bottom-left"`: The bottom left corner of the icon is placed closest to the anchor.<br />
         * `"bottom-right"`: The bottom right corner of the icon is placed closest to the anchor.<br />
         * Default: `undefined`
         * @default undefined
         */
        _this.variableAnchor = undefined;
        /**
         * The size of the font in pixels.
         * Must be a number greater or equal to 0.
         * Default `16`.
         * @default 16
         */
        _this.size = 16;
        /**
         * The color of the text.
         * Default `"#000000"`.
         * @default "#000000"
         */
        _this.color = "#000000";
        /**
         * The halo's fadeout distance towards the outside in pixels.
         * Must be a number greater or equal to 0.
         * Default `0`.
         * @default 0
         */
        _this.haloBlur = 0;
        /**
         * The color of the text's halo, which helps it stand out from backgrounds.
         * Default `"rgba(0,0,0,0)"`.
         * @default "rgba(0,0,0,0)"
         */
        _this.haloColor = "rgba(0,0,0,0)";
        /**
         * The distance of the halo to the font outline in pixels.
         * Must be a number greater or equal to 0.
         * The maximum text halo width is 1/4 of the font size.
         * Default `0`.
         * @default 0
         */
        _this.haloWidth = 0;
        /**
         * A number between 0 and 1 that indicates the opacity at which the text will be drawn.
         * Default `1`.
         * @default 1
         */
        _this.opacity = 1;
        return _this;
    }
    return TextOptions;
}(Options));

var __extends$x = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering geometries in a SymbolLayer.
 */
var SymbolLayerOptions = /** @class */ (function (_super) {
    __extends$x(SymbolLayerOptions, _super);
    function SymbolLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The id or instance of a data source which the layer will render.
         */
        _this.source = undefined;
        /**
         * Required when the source of the layer is a VectorTileSource.
         * A vector source can have multiple layers within it, this identifies which one to render in this layer.
         * Prohibited for all other types of sources.
         */
        _this.sourceLayer = undefined;
        /**
         * Options used to customize the icons of the symbols.
         * @see IconOptions for defaults.
         */
        _this.iconOptions = new IconOptions();
        /**
         * Options used to customize the text of the symbols.
         * @see TextOptions for defaults.
         */
        _this.textOptions = new TextOptions();
        /**
         * Specifies the label placement relative to its geometry.<br />
         * `"point"`: The label is placed at the point where the geometry is located.<br />
         * `"line"`: The label is placed along the line of the geometry.
         * Can only be used on LineString and Polygon geometries.<br />
         *  `"line-center"`: The label is placed at the center of the line of the geometry.
         * Can only be used on `LineString` and `Polygon` geometries <br />
         * Default `"point"`.
         * @default "point"
         */
        _this.placement = "point";
        /**
         * Sorts features in ascending order based on this value. Features with
         * lower sort keys are drawn and placed first.
         * Default `undefined`.
         * @default undefined
         */
        _this.sortKey = undefined;
        /**
         * Determines whether overlapping symbols in the same layer are rendered in the order
         * that they appear in the data source, or by their y position relative to the viewport.
         * To control the order and prioritization of symbols otherwise, use `sortKey`.<br />
         * `"auto"`: Sorts symbols by `sortKey` if set. Otherwise behaves like `"viewport-y"`.<br />
         * `"viewport-y"`: Sorts symbols by their y position if `allowOverlap` is `true` or
         * if `ignorePlacement` is `false`.<br />
         * `"source"`: Sorts symbols by `sortKey` if set. Otherwise, symbols are rendered in the
         * same order as the source data.<br />
         * Default `"auto"`
         * @default "auto"
         */
        _this.zOrder = "auto";
        /**
         * Distance in pixels between two symbol anchors along a line. Must be greater or equal to 1.
         * Default `250`.
         * @default 250
         */
        _this.lineSpacing = 250;
        return _this;
    }
    return SymbolLayerOptions;
}(LayerOptions$1));

var __extends$w = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$9 = (window && window.__assign) || function () {
    __assign$9 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$9.apply(this, arguments);
};
/**
 * Renders point based data as symbols on the map using text and/or icons.
 * Symbols can also be created for line and polygon data as well.
 */
var SymbolLayer = /** @class */ (function (_super) {
    __extends$w(SymbolLayer, _super);
    /**
     * Constructs a new SymbolLayer.
     * @param source The id or instance of a data source which the layer will render.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the polygon layer.
     */
    function SymbolLayer(source, id, options) {
        var _this = _super.call(this, id) || this;
        _this.options = new SymbolLayerOptions().merge(cloneDeepWith$1(options, SymbolLayerOptions._cloneCustomizer));
        _this.options.source = source || _this.options.source;
        return _this;
    }
    /**
     * Gets the options of the symbol layer.
     */
    SymbolLayer.prototype.getOptions = function () {
        return cloneDeepWith$1(this.options, SymbolLayerOptions._cloneCustomizer);
    };
    /**
     * Gets the source provided when creating the layer.
     */
    SymbolLayer.prototype.getSource = function () {
        return this.options.source;
    };
    /**
     * Sets the options of the symbol layer.
     * @param newOptions The new options of the polygon layer.
     */
    SymbolLayer.prototype.setOptions = function (options) {
        var newOptions = new SymbolLayerOptions().merge(this.options, cloneDeepWith$1(options, SymbolLayerOptions._cloneCustomizer));
        if (this.map) {
            // If the source or sourceLayer options are changed
            // the layer must be re-added to the map entirely.
            if (newOptions.source !== this.options.source ||
                newOptions.sourceLayer !== this.options.sourceLayer) {
                // No update calls needed if the entire layer is being re-added.
                this.options = newOptions;
                this.map.layers.add(this);
                return;
            }
            var thisOpts = this.options;
            var newIconOpts = newOptions.iconOptions;
            var thisIconOpts = thisOpts.iconOptions;
            var newTextOpts = newOptions.textOptions;
            var thisTextOpts = thisOpts.textOptions;
            // Symbol options.
            this._updateBaseProperties(newOptions, thisOpts);
            this._updateLayoutProperty("symbol-spacing", newOptions.lineSpacing, thisOpts.lineSpacing);
            this._updateLayoutProperty("symbol-placement", newOptions.placement, thisOpts.placement);
            this._updateLayoutProperty("symbol-sort-key", newOptions.sortKey, thisOpts.sortKey);
            // REVIEW: @types/maplibregl-js doesn't show "auto" for "symbol-z-order"
            this._updateLayoutProperty("symbol-z-order", newOptions.zOrder, thisOpts.zOrder);
            // Icon options.
            this._updateLayoutProperty("icon-allow-overlap", newIconOpts.allowOverlap, thisIconOpts.allowOverlap);
            this._updateLayoutProperty("icon-anchor", newIconOpts.anchor, thisIconOpts.anchor);
            this._updateLayoutProperty("icon-ignore-placement", newIconOpts.ignorePlacement, thisIconOpts.ignorePlacement);
            this._updateLayoutProperty("icon-image", newIconOpts.image, thisIconOpts.image);
            this._updateLayoutProperty("icon-offset", newIconOpts.offset, thisIconOpts.offset);
            this._updatePaintProperty("icon-opacity", newIconOpts.opacity, thisIconOpts.opacity);
            this._updateLayoutProperty("icon-optional", newIconOpts.optional, thisIconOpts.optional);
            this._updateLayoutProperty("icon-padding", newIconOpts.padding, thisIconOpts.padding);
            this._updateLayoutProperty("icon-pitch-alignment", newIconOpts.pitchAlignment, thisIconOpts.pitchAlignment);
            this._updateLayoutProperty("icon-rotate", newIconOpts.rotation, thisIconOpts.rotation);
            this._updateLayoutProperty("icon-rotation-alignment", newIconOpts.rotationAlignment, thisIconOpts.rotationAlignment);
            this._updateLayoutProperty("icon-size", newIconOpts.size, thisIconOpts.size);
            // Text options.
            this._updateLayoutProperty("text-allow-overlap", newTextOpts.allowOverlap, thisTextOpts.allowOverlap);
            this._updateLayoutProperty("text-anchor", newTextOpts.anchor, thisTextOpts.anchor);
            this._updatePaintProperty("text-color", newTextOpts.color, thisTextOpts.color);
            this._updateLayoutProperty("text-font", newTextOpts.font, thisTextOpts.font);
            this._updateLayoutProperty("text-ignore-placement", newTextOpts.ignorePlacement, thisTextOpts.ignorePlacement);
            this._updateLayoutProperty("text-justify", newTextOpts.justify, thisTextOpts.justify);
            this._updatePaintProperty("text-halo-blur", newTextOpts.haloBlur, thisTextOpts.haloBlur);
            this._updatePaintProperty("text-halo-color", newTextOpts.haloColor, thisTextOpts.haloColor);
            this._updatePaintProperty("text-halo-width", newTextOpts.haloWidth, thisTextOpts.haloWidth);
            this._updateLayoutProperty("text-offset", newTextOpts.offset, thisTextOpts.offset);
            this._updatePaintProperty("text-opacity", newTextOpts.opacity, thisTextOpts.opacity);
            this._updateLayoutProperty("text-optional", newTextOpts.optional, thisTextOpts.optional);
            this._updateLayoutProperty("text-padding", newTextOpts.padding, thisTextOpts.padding);
            this._updateLayoutProperty("text-pitch-alignment", newTextOpts.pitchAlignment, thisTextOpts.pitchAlignment);
            this._updateLayoutProperty("text-radial-offset", newTextOpts.radialOffset, thisTextOpts.radialOffset);
            this._updateLayoutProperty("text-rotate", newTextOpts.rotation, thisTextOpts.rotation);
            this._updateLayoutProperty("text-rotation-alignment", newTextOpts.rotationAlignment, thisTextOpts.rotationAlignment);
            this._updateLayoutProperty("text-size", newTextOpts.size, thisTextOpts.size);
            this._updateLayoutProperty("text-variable-anchor", newTextOpts.variableAnchor, thisTextOpts.variableAnchor);
            this._updateLayoutProperty("text-field", newTextOpts.textField, thisTextOpts.textField);
        }
        this.options = newOptions;
    };
    /**
     * @internal
     */
    SymbolLayer.prototype._buildLayers = function () {
        var layer = __assign$9(__assign$9(__assign$9(__assign$9({ id: this.id, type: "symbol" }, (this.options.sourceLayer && { "source-layer": this.options.sourceLayer })), { source: this.options.source instanceof Source ?
                this.options.source.getId() :
                this.options.source, layout: __assign$9(__assign$9({ visibility: this.options.visible ? "visible" : "none", "symbol-placement": this.options.placement, "symbol-spacing": this.options.lineSpacing, "symbol-z-order": this.options.zOrder, 
                // Text options.
                "text-allow-overlap": this.options.textOptions.allowOverlap, "text-anchor": this.options.textOptions.anchor }, (this.options.textOptions.textField && { "text-field": this.options.textOptions.textField })), { "text-font": this.options.textOptions.font, "text-ignore-placement": this.options.textOptions.ignorePlacement, "text-justify": this.options.textOptions.justify, "text-offset": this.options.textOptions.offset, "text-optional": this.options.textOptions.optional, "text-padding": this.options.textOptions.padding, "text-pitch-alignment": this.options.textOptions.pitchAlignment, "text-rotate": this.options.textOptions.rotation, "text-rotation-alignment": this.options.textOptions.rotationAlignment, "text-size": this.options.textOptions.size, 
                // Icon options.
                "icon-allow-overlap": this.options.iconOptions.allowOverlap, "icon-anchor": this.options.iconOptions.anchor, "icon-ignore-placement": this.options.iconOptions.ignorePlacement, "icon-image": this.options.iconOptions.image, "icon-offset": this.options.iconOptions.offset, "icon-optional": this.options.iconOptions.optional, "icon-padding": this.options.iconOptions.padding, "icon-pitch-alignment": this.options.iconOptions.pitchAlignment, "icon-rotate": this.options.iconOptions.rotation, "icon-rotation-alignment": this.options.iconOptions.rotationAlignment, "icon-size": this.options.iconOptions.size }), paint: {
                // Text options.
                "text-color": this.options.textOptions.color,
                "text-halo-blur": this.options.textOptions.haloBlur,
                "text-halo-color": this.options.textOptions.haloColor,
                "text-halo-width": this.options.textOptions.haloWidth,
                "text-opacity": this.options.textOptions.opacity,
                // Icon options.
                "icon-opacity": this.options.iconOptions.opacity,
            } }), (this.options.filter && { filter: this.options.filter })), { minzoom: this.options.minZoom, maxzoom: this.options.maxZoom });
        // REVIEW: MapLibre throws style validation error if optional properties show up in style
        // with null/undefined as value.
        if (typeof this.options.sortKey !== "undefined") {
            layer.layout["symbol-sort-key"] = this.options.sortKey;
        }
        if (typeof this.options.textOptions.radialOffset !== "undefined") {
            layer.layout["text-radial-offset"] = this.options.textOptions.radialOffset;
        }
        if (typeof this.options.textOptions.variableAnchor !== "undefined") {
            layer.layout["text-variable-anchor"] = this.options.textOptions.variableAnchor;
        }
        return [layer];
    };
    /**
     * @internal
     */
    SymbolLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * @internal
     */
    SymbolLayer.prototype._getSourceIds = function () {
        var ids = new Set();
        this.options.source instanceof Source ?
            ids.add(this.options.source.getId()) :
            ids.add(this.options.source);
        return ids;
    };
    return SymbolLayer;
}(Layer));

var __extends$v = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$8 = (window && window.__assign) || function () {
    __assign$8 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$8.apply(this, arguments);
};
/**
 * Used to represent the fundamental map source.
 * @private
 */
var FundamentalMapSource = /** @class */ (function (_super) {
    __extends$v(FundamentalMapSource, _super);
    /**
     * Constructs a source from the contents of a layer resource file.
     * @param id The source's id.
     * @param sourceDef The sources entry of the resource file.
     * @param options The query parameters to add to the urls listed in the resource file.
     */
    function FundamentalMapSource(id, sourceDef, options) {
        var _this = _super.call(this, id) || this;
        _this.source = _this._modifySource(sourceDef, options);
        return _this;
    }
    /**
     * @internal
     */
    FundamentalMapSource.prototype._buildSource = function () {
        return this.source;
    };
    /**
     * @internal
     */
    FundamentalMapSource.prototype._isDeepEqual = function (other) {
        if (this.constructor !== other.constructor) {
            return false;
        }
        var source = this.source;
        var otherSource = other.source;
        var baseEqual = source.type === otherSource.type &&
            source.url === otherSource.url
            && ((source.tiles === undefined && otherSource.tiles === undefined) ||
                (source.tiles && otherSource.tiles && source.tiles.length === otherSource.tiles.length && source.tiles.every(function (value, idx) { return value === otherSource.tiles[idx]; })))
            && source.minzoom === otherSource.minzoom
            && source.maxzoom === otherSource.maxzoom
            && source.bounds === otherSource.bounds
            && source['attribution'] === otherSource['attribution'];
        var rasterEqual = source.type !== "raster" || (source.type === "raster"
            && source.type === otherSource.type
            && source.tileSize === otherSource.tileSize
            && source.scheme === otherSource.scheme);
        var rasterDemEqual = source.type !== "raster-dem" || (source.type === "raster-dem"
            && source.type === otherSource.type
            && source.tileSize === otherSource.tileSize
            && source['encoding'] === otherSource['encoding']);
        var vectorEqual = source.type !== "vector" || (source.type === "vector"
            && source.type === otherSource.type
            && source.promoteId === otherSource.promoteId
            && source.scheme === otherSource.scheme);
        return baseEqual && rasterEqual && rasterDemEqual && vectorEqual;
    };
    /**
     * Updates the source info to convert the tiles to url strings.
     * @param sourceDef The original source info.
     * @param options The query parameters to add to the tile urls.
     */
    FundamentalMapSource.prototype._modifySource = function (sourceDef, options) {
        if ((sourceDef.type === 'raster' || sourceDef.type === 'raster-dem' || sourceDef.type === 'vector') && sourceDef.tiles) {
            var tileStrings = sourceDef.tiles.map(function (tile) {
                if (typeof tile === "string") {
                    return tile;
                }
                var tileUrl = new Url({
                    domain: constants.domainPlaceHolder,
                    path: tile.path,
                    queryParams: __assign$8(__assign$8({}, options), tile.queryParams)
                });
                return tileUrl.toString();
            });
            sourceDef.tiles = tileStrings;
        }
        else if ((sourceDef.type === 'raster' || sourceDef.type === 'raster-dem' || sourceDef.type === 'vector') && sourceDef.url) {
            sourceDef.url = (typeof sourceDef.url === "string") ?
                sourceDef.url :
                new Url({
                    domain: constants.domainPlaceHolder,
                    path: sourceDef.url.path,
                    queryParams: __assign$8(__assign$8({}, options), sourceDef.url.queryParams)
                }).toString();
        }
        else {
            throw new Error("Source definition must define a TileJSON 'url' or a 'tiles' array.");
        }
        return sourceDef;
    };
    return FundamentalMapSource;
}(Source));

var __extends$u = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used when rendering raster tiled images in a TileLayer.
 */
var TileLayerOptions = /** @class */ (function (_super) {
    __extends$u(TileLayerOptions, _super);
    function TileLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * A bounding box that specifies where tiles are available.
         * When specified, no tiles outside of the bounding box will be requested.
         * Default `[-180, -85.0511, 180, 85.0511]`.
         * @default [-180, -85.0511, 180, 85.0511]
         */
        _this.bounds = [-180, -85.0511, 180, 85.0511];
        /**
         * An integer specifying the minimum zoom level in which tiles are available from the tile source.
         * Default `0`.
         * @default 0
         */
        _this.minSourceZoom = 0;
        /**
         * An integer specifying the maximum zoom level in which tiles are available from the tile source.
         * Default `22`.
         * @default 22
         */
        _this.maxSourceZoom = 22;
        /**
         * An integer value that specifies the width and height dimensions of the map tiles.
         * For a seamless experience, the tile size must be a multiplier of 2.
         * Default `512`.
         * @default 512
         */
        _this.tileSize = 512;
        /**
         * Specifies if the tile systems coordinates uses the Tile Map Services specification,
         * which reverses the Y coordinate axis.
         * Default `false`.
         * @default false
         */
        _this.isTMS = false;
        /**
         * An array of subdomain values to apply to the tile URL.
         */
        _this.subdomains = undefined;
        /**
         * A http/https URL to a TileJSON resource or a tile URL template that uses the following parameters:
         * <p>{x}: X position of the tile. Usually also needs {y} and {z}.</p>
         * <p>{y}: Y position of the tile. Usually also needs {x} and {z}.</p>
         * <p>{z}: Zoom level of the tile. Usually also needs {x} and {y}.</p>
         * <p>{quadkey}: Tile quadKey id based on the Bing Maps tile system naming convention.</p>
         * <p>{bbox-epsg-3857}: A bounding box string with the format {west},{south},{east},{north}
         * in the EPSG 4325 Spacial Reference System.</p>
         * <p>{subdomain}: A placeholder where the subdomain values if specified will be added.</p>
         */
        _this.tileUrl = undefined;
        return _this;
    }
    return TileLayerOptions;
}(MediaLayerOptions));

var __extends$t = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$7 = (window && window.__assign) || function () {
    __assign$7 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$7.apply(this, arguments);
};
var __values$d = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * Renders raster tiled images on top of the map tiles.
 */
var TileLayer = /** @class */ (function (_super) {
    __extends$t(TileLayer, _super);
    /**
     * Constructs a new TileLayer.
     * @param options The options for the tile layer.
     * @param id The id of the layer. If not specified a random one will be generated.
     */
    function TileLayer(options, id) {
        var _this = _super.call(this, id) || this;
        if (options) {
            _this.setOptions(options);
        }
        return _this;
    }
    /**
     * Gets the options of the tile layer.
     */
    TileLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, TileLayerOptions._cloneCustomizer);
    };
    /**
     * Sets the options of the tile layer.
     * @param newOptions The new options of the tile layer.
     */
    TileLayer.prototype.setOptions = function (options) {
        var newOptions = new TileLayerOptions().merge(this.options, cloneDeepWith$1(options, TileLayerOptions._cloneCustomizer));
        if (this.map) {
            // If the bounds, isTMS, max/minSourceZoom, subdomains, tileSize, or tileUrl
            // options are changed the layer must be re-added to the map entirely.
            if (!(isEqual$1(newOptions.bounds, this.options.bounds)) ||
                newOptions.isTMS !== this.options.isTMS ||
                newOptions.maxSourceZoom !== this.options.maxSourceZoom ||
                newOptions.minSourceZoom !== this.options.minSourceZoom ||
                !(isEqual$1(newOptions.subdomains, this.options.subdomains)) ||
                newOptions.tileSize !== this.options.tileSize ||
                newOptions.tileUrl !== this.options.tileUrl) {
                // No update calls needed if the entire layer is being re-added.
                this.options = newOptions;
                this.map.layers.add(this);
                return;
            }
            this._updateBaseProperties(newOptions, this.options);
            this._updatePaintProperty("raster-contrast", newOptions.contrast, this.options.contrast);
            this._updatePaintProperty("raster-fade-duration", newOptions.fadeDuration, this.options.fadeDuration);
            this._updatePaintProperty("raster-hue-rotate", newOptions.hueRotation, this.options.hueRotation);
            this._updatePaintProperty("raster-brightness-max", newOptions.maxBrightness, this.options.maxBrightness);
            this._updatePaintProperty("raster-opacity", newOptions.opacity, this.options.opacity);
            this._updatePaintProperty("raster-saturation", newOptions.saturation, this.options.saturation);
        }
        this.options = newOptions;
    };
    /**
     * @internal
     */
    TileLayer.prototype._setOptionsNoUpdate = function (options) {
        this.options = new TileLayerOptions().merge(this.options, cloneDeepWith$1(options, TileLayerOptions._cloneCustomizer));
    };
    /**
     * @internal
     */
    TileLayer.prototype._buildLayers = function () {
        var layer = __assign$7(__assign$7({ id: this.id, type: "raster", source: this._getSourceId(), layout: {
                visibility: this.options.visible ? "visible" : "none"
            }, paint: {
                "raster-contrast": this.options.contrast,
                "raster-fade-duration": this.options.fadeDuration,
                "raster-hue-rotate": this.options.hueRotation,
                "raster-brightness-max": this.options.maxBrightness,
                "raster-brightness-min": this.options.minBrightness,
                "raster-opacity": this.options.opacity,
                "raster-saturation": this.options.saturation
            } }, (this.options.filter && { filter: this.options.filter })), { minzoom: this.options.minZoom, maxzoom: this.options.maxZoom });
        return [layer];
    };
    /**
     * @internal
     */
    TileLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * Builds the raster source to include with the layer.
     * @internal
     */
    TileLayer.prototype._buildSource = function () {
        var e_1, _a;
        var tiles;
        if (this.options.tileUrl) {
            // If the tileUrl include { assume it is a formatted string and use tiles property.
            if (this.options.tileUrl.indexOf("{") !== -1) {
                // If the tileUrl include the subdomain placeholder
                // we must manually assign an array of urls to the tiles property
                // because mapbox does not support the subdomain placeholder.
                if (this.options.tileUrl.indexOf("{subdomain}") !== -1) {
                    // Throw an error if no subdomains were specified
                    if (this.options.subdomains && this.options.subdomains.length > 0) {
                        var urls = [];
                        try {
                            for (var _b = __values$d(this.options.subdomains), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var subdomain = _c.value;
                                urls.push(this.options.tileUrl.replace(/{subdomain}/g, subdomain));
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        tiles = urls;
                    }
                    else {
                        throw new Error("The {subdomain} placeholder was included in the tileUrl but no subdomains were specified");
                    }
                }
                else {
                    // Else just provide a single url.
                    tiles = [this.options.tileUrl];
                }
            }
            else {
                // Else assume it is just a TileJSON url and use the url property.
                // For a TileJSON url only the url needs to be specified.
                return {
                    type: "raster",
                    url: this.options.tileUrl
                };
            }
        }
        return __assign$7({ type: "raster", bounds: this.options.bounds, maxzoom: this.options.maxSourceZoom, minzoom: this.options.minSourceZoom, scheme: this.options.isTMS ? "tms" : "xyz", tileSize: this.options.tileSize }, (tiles && { tiles: tiles }));
    };
    /**
     * Gets the id of the source to be paired with this layer.
     * @internal
     */
    TileLayer.prototype._getSourceId = function () {
        return "".concat(this.getId(), "-RasterSource");
    };
    TileLayer.prototype._getSourceWrapper = function () {
        var sourceId = this._getSourceId();
        var source = this._buildSource();
        return new FundamentalMapSource(sourceId, {
            name: sourceId,
            tiles: source.tiles,
            type: source.type,
            url: source.url
        });
    };
    return TileLayer;
}(SourceBuildingLayer));

var __extends$s = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options used to render graphics in a WebGLLayer.
 */
var WebGLLayerOptions = /** @class */ (function (_super) {
    __extends$s(WebGLLayerOptions, _super);
    function WebGLLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * An object that contains the rendering logic.
         */
        _this.renderer = undefined;
        return _this;
    }
    return WebGLLayerOptions;
}(LayerOptions$1));

var __extends$r = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Enables custom rendering logic with access to the WebGL context of the map.
 */
var WebGLLayer = /** @class */ (function (_super) {
    __extends$r(WebGLLayer, _super);
    /**
     * Constructs a new WebGLLayer.
     * @param id The id of the layer. If not specified a random one will be generated.
     * @param options The options of the WebGL layer.
     */
    function WebGLLayer(id, options) {
        var _this = _super.call(this, id) || this;
        /**
         * Make sure the layer is available after a style change.
         * @internal
         */
        _this._onStyleChange = function () {
            var _a;
            // Custom layers cannot be serialized and preserved by mapbox.
            // Add this layer again if the layer was removed by mapbox after a style change.
            if (!_this.map._getMap().getLayer(_this.id)) {
                var map = _this.map;
                var before = (_a = _this.map.layers._getUserLayers().find(function (l) { return l.layer.getId() == _this.id; })) === null || _a === void 0 ? void 0 : _a.before;
                map.layers.remove(_this);
                map.layers.add(_this, before);
            }
        };
        _this.options = new WebGLLayerOptions().merge(cloneDeepWith$1(options, WebGLLayerOptions._cloneCustomizer));
        _this.source = new DataSource();
        return _this;
    }
    /**
     * Gets the options of the WebGL layer.
     */
    WebGLLayer.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, WebGLLayerOptions._cloneCustomizer);
    };
    /**
     * Sets the options of the WebGL layer.
     * @param options The new options of the WebGL layer.
     */
    WebGLLayer.prototype.setOptions = function (options) {
        var newOptions = new WebGLLayerOptions().merge(this.options, cloneDeepWith$1(options, WebGLLayerOptions._cloneCustomizer));
        // Trigger a repaint of the map if the layer options have changed.
        if (this.map) {
            this.map.triggerRepaint();
        }
        this.options = newOptions;
    };
    WebGLLayer.prototype.onAdd = function (map) {
        var _a, _b;
        _super.prototype.onAdd.call(this, map);
        // Make sure the layer is available after a style change.
        this.map.events.add("stylechanged", this._onStyleChange);
        // Notify the renderer this layer has been added to the map.
        if (this.options.renderer && this.glContext) {
            (_b = (_a = this.options.renderer).onAdd) === null || _b === void 0 ? void 0 : _b.call(_a, map, this.glContext);
        }
    };
    WebGLLayer.prototype.onRemove = function () {
        var _a, _b;
        // Notify the renderer this layer has been removed from the map.
        if (this.options.renderer && this.glContext) {
            (_b = (_a = this.options.renderer).onRemove) === null || _b === void 0 ? void 0 : _b.call(_a, this.map, this.glContext);
        }
        // Cleanup
        this.map.events.remove("stylechanged", this._onStyleChange);
        this.glContext = null;
        _super.prototype.onRemove.call(this);
    };
    /**
     * @internal
     */
    WebGLLayer.prototype._buildLayers = function () {
        var _this = this;
        if (!this.options.renderer) {
            throw new Error("Cannot build the WebGL layer because renderer was not set.");
        }
        return [
            {
                id: this.id,
                type: "custom",
                renderingMode: this.options.renderer.renderingMode,
                onAdd: function (m, gl) {
                    // Capture the GL context to reuse it later.
                    // renderer.onAdd will be called in the onAdd callback of this layer.
                    _this.glContext = gl;
                },
                onRemove: function (m, gl) {
                    // renderer.onRemove will be called in the onRemove callback of this layer.
                },
                prerender: function (gl, matrix) {
                    var _a, _b;
                    if (_this._shouldRender()) {
                        (_b = (_a = _this.options.renderer).prerender) === null || _b === void 0 ? void 0 : _b.call(_a, gl, matrix);
                    }
                },
                render: function (gl, matrix) {
                    if (_this._shouldRender()) {
                        _this.options.renderer.render(gl, matrix);
                    }
                }
            }
        ];
    };
    /**
     * @internal
     */
    WebGLLayer.prototype._getLayerIds = function () {
        return [this.id];
    };
    /**
     * @internal
     */
    WebGLLayer.prototype._getSourceIds = function () {
        return new Set().add(this.source.getId());
    };
    /**
     * Returns true if the next frame should be rendered
     * @internal
     */
    WebGLLayer.prototype._shouldRender = function () {
        if (this.map) {
            var zoom = this.map.getCamera().zoom;
            return this.options.visible && this.options.minZoom <= zoom && this.options.maxZoom > zoom;
        }
        return false;
    };
    return WebGLLayer;
}(Layer));

var index = /*#__PURE__*/Object.freeze({
	__proto__: null,
	BubbleLayer: BubbleLayer,
	HeatMapLayer: HeatMapLayer,
	ImageLayer: ImageLayer,
	Layer: Layer,
	LineLayer: LineLayer,
	PolygonExtrusionLayer: PolygonExtrusionLayer,
	PolygonLayer: PolygonLayer,
	SymbolLayer: SymbolLayer,
	TileLayer: TileLayer,
	WebGLLayer: WebGLLayer
});

var Html = /** @class */ (function () {
    function Html() {
    }
    /**
     * Converts the specified content into a div element.
     * @param content A string to make the innerHTML of the div element.
     * If a HTMLElement is provided it is returned unmodified.
     */
    Html.convertHtmlString = function (content) {
        if (typeof content === "string") {
            var htmlEle = document.createElement("div");
            htmlEle.innerHTML = content;
            return htmlEle;
        }
        else {
            return content;
        }
    };
    /**
     * Parses the html string and filters out DOM nodes according to provided filter
     * @param content A string containing valid html.
     * @param filter A filter condition to check if the DOM node is allowed
     * @param groupingElement An element that will be used as a root element if the content is a flat list of nodes
     * If plain text is provided, the string will be returned
     */
    Html.parseWithFilter = function (content, filter, transformer, groupingElement) {
        var _this = this;
        if (filter === void 0) { filter = function (_) { return true; }; }
        if (transformer === void 0) { transformer = function (elem) { return elem; }; }
        if (groupingElement === void 0) { groupingElement = function () { return document.createElement('div'); }; }
        var elem;
        if (typeof content === 'string') {
            var body = (new DOMParser()).parseFromString(content, 'text/html').body;
            if (body.children.length == 0) {
                return transformer(body.innerHTML);
            }
            else if (body.children.length == 1 && body.childNodes.length == 1) {
                elem = body.children[0];
            }
            else {
                var container_1 = groupingElement();
                Array.from(body.childNodes).map(function (node) { return container_1.append(node); });
                elem = container_1;
            }
        }
        else {
            elem = content;
        }
        Array.from(elem.children).forEach(function (elem) { return _this.parseWithFilter(elem, filter, transformer); });
        if (!filter(elem)) {
            if (elem.parentNode) {
                elem.parentNode.removeChild(elem);
            }
            return null;
        }
        else {
            return transformer(elem);
        }
    };
    return Html;
}());

var isObjectLike = isObjectLike_1,
    isPlainObject$1 = isPlainObject_1;

/**
 * Checks if `value` is likely a DOM element.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a DOM element, else `false`.
 * @example
 *
 * _.isElement(document.body);
 * // => true
 *
 * _.isElement('<body>');
 * // => false
 */
function isElement(value) {
  return isObjectLike(value) && value.nodeType === 1 && !isPlainObject$1(value);
}

var isElement_1 = isElement;

var isElement$1 = /*@__PURE__*/getDefaultExportFromCjs(isElement_1);

var __extends$q = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a popup.
 */
var PopupOptions = /** @class */ (function (_super) {
    __extends$q(PopupOptions, _super);
    function PopupOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Indicates the popup's location relative to its position on the map.
         * Optional values: `"none"`, `"top"`, `"bottom"`, `"left"`, `"right"`,
         * `"top-left"`, `"top-right"`, `"bottom-left"`, `"bottom-right"`.
         * default `"none"`
         * @default "none"
         */
        _this.anchor = "none";
        /**
         * Specifies if the popup can be dragged away from its position.
         * default `false`
         * @default false
         */
        _this.draggable = false;
        /**
         * Specifies if the close button should be displayed in the popup or not.
         * default `true`
         * @default true
         */
        _this.closeButton = true;
        /**
         * The content to display within the popup.
         * default `span`
         * @default span
         */
        _this.content = document.createElement("span");
        /**
         * Specifies the fill color of the popup.
         * default `"#FFFFFF"`
         * @default "#FFFFFF"
         */
        _this.fillColor = "#FFFFFF";
        /**
         * An array of [pixelsRight, pixelsDown] for how many pixels to the right and down the anchor of the popup should be
         * offset. Negative numbers can be used to offset the popup left and up.
         * default `[0, 0]`
         * @default [0, 0]
         */
        _this.pixelOffset = new Pixel(0, 0);
        /**
         * The position on the map where the popup should be anchored.
         * default `[0, 0]`
         * @default [0, 0]
         */
        _this.position = new Position(0, 0);
        /**
         * Specifies if the pointer should be displayed in the popup or not.
         * default `true`
         * @default true
         */
        _this.showPointer = true;
        return _this;
    }
    /**
     * Customizer for _.cloneDeep calls, allows HTMLElements to pass through without cloning.
     * @param value The value being cloned.
     * @internal
     */
    PopupOptions._cloneCustomizer = function (value) {
        if (isElement$1(value)) {
            return value;
        }
    };
    return PopupOptions;
}(Options));

var __extends$p = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read$c = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
/**
 * An information window anchored at a specified position on a map.
 */
var Popup = /** @class */ (function (_super) {
    __extends$p(Popup, _super);
    /**
     * Constructs a Popup object and initializes it with the specified options.
     * @param options The options for the popup.
     */
    function Popup(options) {
        var _this = _super.call(this) || this;
        /**
         * Attaches the popup to the HTML document in a hidden state.
         * @param map The map.
         */
        _this.attach = function (map) {
            // If attaching to a different map, remove popup on current map
            if (_this.map !== map) {
                // If map was defined the popup was attached to another map.
                if (_this.map) {
                    _this.remove();
                }
                // Create the marker before attaching the popup and it to the map.
                _this.map = map;
                _this.marker = _this._createMarker(_this.options);
                // Attach the wrapped mapbox marker to the map.
                // When the marker is attached to the map it will attach the containerHtml to a default container.
                // Move the containerHtml to the popup collection container after attaching the marker.
                _this.marker.addTo(_this.map._getMap());
                _this.map.popups._getCollectionDiv().appendChild(_this.containerDiv);
                _this.map.popups.add(_this);
            }
        };
        /**
         * Opens the popup.
         * @param map The map to open the popup on.
         * Optional if already attached to a map.
         */
        _this.open = function (map) {
            if (!map && !_this.map) {
                throw new Error("Must specify a map to open on or attach to a map in advance");
            }
            _this.attach(map || _this.map);
            _this.containerDiv.classList.remove(Popup.Css.hidden);
            _this.map.events.add("move", _this._onMove);
            _this._onMove();
            _this._invokeEvent("open", { target: _this, type: "open" });
        };
        /**
         * Closes the popup on the map. The popup remains attached to the HTML document.
         */
        _this.close = function () {
            if (_this.map) {
                _this.map.events.remove("move", _this._onMove);
            }
            _this.containerDiv.classList.add(Popup.Css.hidden);
            _this._invokeEvent("close", { target: _this, type: "close" });
        };
        /**
         * Closes the popup on the map and removes it from the HTML document.
         */
        _this.remove = function () {
            if (_this.map) {
                _this.marker.remove();
                _this.containerDiv.classList.remove(_this.autoAnchor || _this.options.anchor);
                _this.map.events.remove("move", _this._onMove);
                _this.map.popups.remove(_this);
                delete _this.map;
                delete _this.marker;
                delete _this.autoAnchor;
            }
        };
        /**
         * Returns true if the popup is currently open, otherwise false.
         */
        _this.isOpen = function () {
            return _this.map && !_this.containerDiv.classList.contains(Popup.Css.hidden);
        };
        /**
         * Callback for the move listener used for auto anchoring.
         */
        _this._onMove = function () {
            var newAutoAnchor = _this._getAutoAnchor(_this.map, _this.options);
            if (newAutoAnchor !== _this.autoAnchor) {
                // When we replace the marker it adds a new move listeners.
                // We want our listener to fire after the marker's, so we add it again.
                // Adding the listener again means it will fire after all other previously listeners.
                _this._replaceMarker(_this.map, _this.options, newAutoAnchor);
                _this.map.events.add("move", _this._onMove);
            }
        };
        /**
         * Called by a mouse down or touch start event.
         */
        _this._onDown = function (event) {
            var _a;
            _this.map.popups._addDraggedPopup(_this);
            var anchorPixel = (_a = __read$c(_this.map.positionsToPixels([_this.options.position]), 1), _a[0]);
            if (event.type === "mousedown") {
                event = event;
                _this.dragOffset = [
                    anchorPixel[0] - event.clientX,
                    anchorPixel[1] - event.clientY
                ];
            }
            else if (event.type === "touchstart") {
                event = event;
                _this.dragOffset = [
                    anchorPixel[0] - event.touches[0].clientX,
                    anchorPixel[1] - event.touches[0].clientY
                ];
            }
        };
        /**
         * Called by the container's dragstart event.
         * Used to call preventDefault as a fix for Edge dragging issues.
         */
        _this._onDragStart = function (event) {
            event.preventDefault();
        };
        _this.options = new PopupOptions().merge(cloneDeepWith$1(options, PopupOptions._cloneCustomizer));
        // Create full content container
        _this.containerDiv = _this._createContainerDiv(_this.options);
        // Create the container for the content specified in the options.
        _this.contentDiv = _this._createContentDiv(_this.options);
        _this.containerDiv.appendChild(_this.contentDiv);
        // Create arrow tip if specified in the options.
        if (_this.options.showPointer) {
            _this.arrowDiv = _this._createArrowDiv();
            _this.containerDiv.appendChild(_this.arrowDiv);
        }
        // Create close button if specified in the options.
        if (_this.options.closeButton) {
            _this.closeBtn = _this._createCloseButton();
            _this.contentDiv.appendChild(_this.closeBtn);
            var tooltip = buildAccessibleTooltip("close");
            _this.contentDiv.appendChild(tooltip);
            positionTooltip(tooltip, _this.closeBtn, true);
        }
        return _this;
    }
    /**
     * Sets the options for the popup.
     * @param options The options for the popup.
     * @deprecated Use setOptions(...) instead.
     */
    Popup.prototype.setPopupOptions = function (options) {
        this.setOptions(options);
    };
    /**
     * Sets the options for the popup.
     * @param options The options for the popup.
     */
    Popup.prototype.setOptions = function (options) {
        var newOptions = new PopupOptions().merge(this.options, cloneDeepWith$1(options, PopupOptions._cloneCustomizer));
        if (newOptions.content !== this.options.content) {
            // If the popup content is changed remove the old content and add the new stuff.
            // Will also implicitly update draggability.
            this.htmlContent.remove();
            this.htmlContent = this._createHtmlContent(newOptions);
            this.contentDiv.prepend(this.htmlContent);
        }
        else if (newOptions.draggable !== this.options.draggable) {
            // If the content hasn't changed, check if draggable is changed.
            this._setDraggable(this.htmlContent, newOptions.draggable);
        }
        // If a close button should be shown but the close button hasn't
        // been initialized or is missing from the container add it.
        if (newOptions.closeButton && !this.closeBtn) {
            this.closeBtn = this._createCloseButton();
            this.contentDiv.appendChild(this.closeBtn);
            var tooltip = buildAccessibleTooltip("close");
            this.contentDiv.appendChild(tooltip);
            positionTooltip(tooltip, this.closeBtn, true);
        }
        else if (!newOptions.closeButton && this.closeBtn) {
            this.contentDiv.removeChild(this.closeBtn);
            delete this.closeBtn;
        }
        // If a pointer should be shown but the close button hasn't
        // been initialized or is missing from the container add it.
        if (newOptions.showPointer && !this.arrowDiv) {
            this.arrowDiv = this._createArrowDiv();
            this.containerDiv.appendChild(this.arrowDiv);
        }
        else if (!newOptions.showPointer && this.arrowDiv) {
            this.containerDiv.removeChild(this.arrowDiv);
            delete this.arrowDiv;
        }
        // If the fill color is changed update the relavent elements.
        if (newOptions.fillColor !== this.options.fillColor) {
            this.containerDiv.style.borderColor = newOptions.fillColor;
            this.contentDiv.style.backgroundColor = newOptions.fillColor;
        }
        if (this.marker) {
            if (newOptions.anchor !== this.options.anchor) {
                // If the anchor property has changed we need to build a new marker.
                if (this.options.anchor === "none") {
                    if (this.autoAnchor !== newOptions.anchor) {
                        this._replaceMarker(this.map, newOptions);
                    }
                    this.map.events.remove("move", this._onMove);
                    delete this.autoAnchor;
                }
                else {
                    this._replaceMarker(this.map, newOptions);
                    if (newOptions.anchor === "none") {
                        this.map.events.add("move", this._onMove);
                    }
                }
            }
            else {
                // Check if the position is changed.
                if (!isEqual$1(newOptions.position, this.options.position)) {
                    this.marker.setLngLat(newOptions.position);
                }
                // Check if the offset is changed.
                if (!isEqual$1(newOptions.pixelOffset, this.options.pixelOffset)) {
                    this.marker.setOffset(newOptions.pixelOffset);
                }
            }
        }
        this.options = newOptions;
    };
    /**
     * Returns the options for the popup.
     * @deprecated Use getOptions() instead.
     */
    Popup.prototype.getPopupOptions = function () {
        return this.getOptions();
    };
    /**
     * Returns the options for the popup.
     */
    Popup.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, PopupOptions._cloneCustomizer);
    };
    /**
     * Returns popup container element.
     */
    Popup.prototype.getPopupContainer = function () {
        return this.containerDiv;
    };
    /**
     * Drags the popup to the specified pixel.
     * Accounts for the pixel offset when dragging started.
     * @internal
     */
    Popup.prototype._dragToPixel = function (pixel) {
        var _a;
        // Wait until the popup has been dragged the first time to fire th dragstart event.
        if (!this.dragging) {
            this.dragging = true;
            this.contentDiv.style.pointerEvents = "none";
            this._invokeEvent("dragstart", { type: "dragstart", target: this });
        }
        var anchorPixel = [
            pixel[0] + this.dragOffset[0],
            pixel[1] + this.dragOffset[1]
        ];
        var anchorPos = (_a = __read$c(this.map.pixelsToPositions([anchorPixel]), 1), _a[0]);
        this.options.position = anchorPos;
        this.marker.setLngLat(this.options.position);
        this._invokeEvent("drag", { type: "drag", target: this });
    };
    /**
     * Called by a mouse up or touch end event.
     * @internal
     */
    Popup.prototype._onUp = function () {
        // Only fire the dragend event if the popup was actually dragged.
        if (this.dragging) {
            this.contentDiv.style.pointerEvents = "";
            this._invokeEvent("dragend", { type: "dragend", target: this });
            if (this.options.anchor === "none") {
                // If automatically anchoring the popup check if the anchor should change after done dragging.
                this._onMove();
            }
        }
        // Clear the drag state tracking variables.
        delete this.dragOffset;
        delete this.dragging;
    };
    /**
     * Creates the overall container div.
     */
    Popup.prototype._createContainerDiv = function (options) {
        var _this = this;
        var ele = document.createElement("div");
        ele.classList.add(Popup.Css.container);
        ele.classList.add(Popup.Css.hidden);
        ele.style.borderColor = options.fillColor;
        ele.setAttribute("role", "dialog");
        ele.setAttribute("aria-label", "Map Information Window");
        // Track if a key which can change the focus has been pressed.
        var focusKeyDown = false;
        ele.addEventListener("keydown", function (e) {
            if (e.key === "Tab" || e.key === "Escape" || e.key === "Esc") {
                focusKeyDown = true;
            }
        });
        // If the keyup event occurs before the focusout then don't close the popup.
        ele.addEventListener("keyup", function (e) {
            if (e.key === "Tab" || e.key === "Escape" || e.key === "Esc") {
                focusKeyDown = false;
            }
        });
        // If focus comes in without the popup being open go ahead and open it.
        ele.addEventListener("focusin", function (e) {
            if (_this.map && !_this.isOpen()) {
                _this.open(_this.map);
                // Focus on the element again because it may have been removed and added back to the DOM
                if (e.target instanceof HTMLElement) {
                    e.target.focus();
                }
            }
        });
        // If the focus is lost after a key was pressed close the popup.
        ele.addEventListener("focusout", function (e) {
            if (focusKeyDown && e.relatedTarget instanceof Node && !ele.contains(e.relatedTarget)) {
                focusKeyDown = false;
                if (_this.isOpen()) {
                    _this.close();
                }
            }
        });
        return ele;
    };
    /**
     * Creates the content container div.
     */
    Popup.prototype._createContentDiv = function (options) {
        var ele = document.createElement("div");
        ele.classList.add(Popup.Css.content);
        ele.style.backgroundColor = options.fillColor;
        ele.setAttribute("tabindex", "0");
        this.htmlContent = this._createHtmlContent(options);
        ele.appendChild(this.htmlContent);
        return ele;
    };
    /**
     * Creates an arrow element.
     */
    Popup.prototype._createArrowDiv = function () {
        var ele = document.createElement("div");
        ele.classList.add(Popup.Css.arrow);
        return ele;
    };
    /**
     * Creates a close button.
     */
    Popup.prototype._createCloseButton = function () {
        var ele = document.createElement("button");
        ele.addEventListener("click", this.close);
        ele.classList.add(Popup.Css.close);
        ele.setAttribute("aria-label", "close");
        ele.setAttribute("type", "button");
        ele.setAttribute("tabindex", "0");
        ele.innerHTML = "&times;";
        return ele;
    };
    /**
     * Creates the user content element.
     */
    Popup.prototype._createHtmlContent = function (options) {
        var ele = Html.convertHtmlString(options.content);
        if (options.draggable) {
            this._setDraggable(ele, options.draggable);
        }
        return ele;
    };
    /**
     * Creates the marker which wraps the popup.
     */
    Popup.prototype._createMarker = function (options, autoAnchor) {
        // If a marker already exists use it's LngLat value for the new marker's position
        // This prevent the marker from jumping around if world copies are rendered.
        var position = this.marker ?
            this.marker.getLngLat() :
            options.position;
        // Create the mapbox marker that will hold the popup.
        var marker;
        if (options.anchor === "none") {
            this.autoAnchor = autoAnchor || "bottom";
            this.containerDiv.classList.add(this.autoAnchor);
            marker = new maplibregl.Marker({
                anchor: this.autoAnchor,
                element: this.containerDiv,
                offset: options.pixelOffset,
            }).setLngLat(position);
        }
        else {
            this.containerDiv.classList.add(options.anchor);
            marker = new maplibregl.Marker({
                anchor: options.anchor,
                element: this.containerDiv,
                offset: options.pixelOffset,
            }).setLngLat(position);
        }
        return marker;
    };
    /**
     * Calculates the auto anchor value for the current marker.
     */
    Popup.prototype._getAutoAnchor = function (map, options) {
        var _a, _b;
        var width = this.containerDiv.offsetWidth;
        var height = this.containerDiv.offsetHeight;
        var posX;
        var posY;
        if (this.marker) {
            var pt = map._getMap().project(this.marker.getLngLat());
            posX = pt.x;
            posY = pt.y;
        }
        else {
            var x = (_a = __read$c(map.positionsToPixels([options.position]), 1), _b = __read$c(_a[0], 2), _b[0]), y = _b[1];
            posX = x;
            posY = y;
        }
        var autoAnchor = [];
        if (posY < height) {
            autoAnchor.push("top");
        }
        else if (posY > map.getCanvas().offsetHeight - height) {
            autoAnchor.push("bottom");
        }
        if (posX < width / 2) {
            autoAnchor.push("left");
        }
        else if (posX > map.getCanvas().offsetWidth - width / 2) {
            autoAnchor.push("right");
        }
        return autoAnchor.length > 0 ?
            autoAnchor.join("-") :
            "bottom";
    };
    /**
     * Replaces the current marker with a new one using the specified options.
     */
    Popup.prototype._replaceMarker = function (map, options, autoAnchor) {
        // Track the next sibling before the marker is removed.
        var next = this.containerDiv.nextElementSibling;
        this.marker.remove();
        this.containerDiv.classList.remove(this.autoAnchor || this.options.anchor);
        this.marker = this._createMarker(options, autoAnchor);
        this.marker.addTo(map._getMap());
        // If the popup was already to the DOM place it back in the original order
        // This keeps the tab order consistent.
        map.popups._getCollectionDiv().insertBefore(this.containerDiv, next || null);
    };
    /**
     * Called to setup or remove draggability.
     */
    Popup.prototype._setDraggable = function (ele, draggable) {
        if (draggable) {
            ele.addEventListener("mousedown", this._onDown);
            ele.addEventListener("touchstart", this._onDown);
            ele.addEventListener("dragstart", this._onDragStart);
        }
        else {
            ele.removeEventListener("mousedown", this._onDown);
            ele.removeEventListener("touchstart", this._onDown);
            ele.removeEventListener("dragstart", this._onDragStart);
        }
    };
    // CSS class names.
    Popup.Css = {
        arrow: "popup-arrow",
        close: "popup-close",
        container: "popup-container",
        content: "popup-content-container",
        hidden: "hidden-accessible-element"
    };
    return Popup;
}(EventEmitter));

var __extends$o = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Options for rendering an HtmlMarker object
 */
var HtmlMarkerOptions = /** @class */ (function (_super) {
    __extends$o(HtmlMarkerOptions, _super);
    function HtmlMarkerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Indicates the marker's location relative to its position on the map.
         * Optional values: `"center"`, `"top"`, `"bottom"`, `"left"`, `"right"`,
         * `"top-left"`, `"top-right"`, `"bottom-left"`, `"bottom-right"`.
         * Default `"bottom"`
         * @default "bottom"
         */
        _this.anchor = "bottom";
        /**
         * A color value that replaces any {color} placeholder property that has been included in a string htmlContent.
         * default `"#1A73AA"`
         * @default "#1A73AA"
         */
        _this.color = "#1A73AA";
        /**
         * Indicates if the user can drag the position of the marker using the mouse or touch controls.
         * default `false`
         * @default false
         */
        _this.draggable = false;
        /**
         * The HTML content of the marker. Can be an HTMLElement or HTML string.
         * Add {text} and {color} to HTML strings as placeholders to make it easy to update
         * these values in your marker by using the setOptions function of the HtmlMarker class.
         * This allows you to create a single HTML marker string that can be used as a template for multiple markers.
         */
        _this.htmlContent = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24.5 36.5\" id=\"marker_".concat(uuid(), "\" width=\"24.5\" height=\"36.5\" display=\"block\"><path d=\"M12.25.25a12.2543,12.2543,0,0,0-12,12.4937c0,6.4436,6.4879,12.1093,11.059,22.5641.5493,1.2563,1.3327,1.2563,1.882,0C17.7621,24.8529,24.25,19.1857,24.25,12.7437A12.2543,12.2543,0,0,0,12.25.25Z\"   fill=\"{color}\" stroke=\"{secondaryColor}\" stroke-width=\"0.5\"/><text style=\"font-family: Arial, Helvetica, sans-serif; font-size: 14px; fill: white;\" text-anchor=\"middle\" x=\"12\" y=\"18\">{text}</text></svg>");
        /**
         * An offset in pixels to move the popup relative to the markers center.
         * Negatives indicate left and up.
         * default `[0, 0]`
         * @default [0, 0]
         */
        _this.pixelOffset = new Pixel(0, 0);
        /**
         * The position of the marker.
         * default `[0, 0]`
         * @default [0, 0]
         */
        _this.position = new Position(0, 0);
        /**
         * A popup that is attached to the marker.
         */
        _this.popup = undefined;
        /**
         * A color value that replaces any {secondaryColor} placeholder property that has been included in a string htmlContent.
         * default `"white"`
         * @default "white"
         */
        _this.secondaryColor = "white";
        /**
         * A string of text that replaces any {text} placeholder property that has been included in a string htmlContent.
         */
        _this.text = undefined;
        /**
         * Specifies if the marker is visible or not.
         * default `true`
         * @default true
         */
        _this.visible = true;
        return _this;
    }
    /**
     * Customizer for _.cloneDeep calls, allows Popups and HTMLElements to pass through without cloning.
     * @param value The value being cloned.
     * @internal
     */
    HtmlMarkerOptions._cloneCustomizer = function (value) {
        if (value instanceof Popup || isElement$1(value)) {
            return value;
        }
    };
    return HtmlMarkerOptions;
}(Options));

var __extends$n = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * This class wraps an HTML element that can be displayed on the map.
 */
var HtmlMarker = /** @class */ (function (_super) {
    __extends$n(HtmlMarker, _super);
    /**
     * Constructs a new HtmlMarker.
     * @param options The options for the HtmlMarker.
     */
    function HtmlMarker(options) {
        var _this = _super.call(this) || this;
        /**
         * Called by the drag event of the mapbox marker.
         * @private
         */
        _this._onDrag = function () {
            var lngLat = _this.marker.getLngLat().wrap();
            _this.options.position = new Position(lngLat.lng, lngLat.lat);
            _this._invokeEvent("drag", { type: "drag", target: _this });
        };
        /**
         * Called by the dragstart event of the mapbox marker.
         * @private
         */
        _this._onDragStart = function () {
            _this._invokeEvent("dragstart", { type: "dragstart", target: _this });
        };
        /**
         * Called by the dragend event of the mapbox marker.
         * @private
         */
        _this._onDragEnd = function () {
            _this._invokeEvent("dragend", { type: "dragend", target: _this });
        };
        /**
         * Called by the events of the marker's element.
         * @private
         */
        _this._bubbleElementEvent = function (event) {
            _this._invokeEvent(event.type, { type: event.type, target: _this });
        };
        /**
         * Called by the element's dragstart event.
         * Used to call preventDefault so Edge doesn't break dragging.
         * @private
         */
        _this._onEleDragStart = function (event) {
            event.preventDefault();
        };
        _this.options = new HtmlMarkerOptions().merge(cloneDeepWith$1(options, HtmlMarkerOptions._cloneCustomizer));
        _this._buildMarker(_this.options);
        return _this;
    }
    /**
     * Gets the HTML marker options.
     */
    HtmlMarker.prototype.getOptions = function () {
        // Copy the options so the user can't directly change options.
        // They must use setOptions(...).
        return cloneDeepWith$1(this.options, HtmlMarkerOptions._cloneCustomizer);
    };
    /**
     * Returns the underlying `Marker`'s HTML element.
     */
    HtmlMarker.prototype.getElement = function () {
        return this.marker.getElement();
    };
    /**
     * Sets the options of the marker.
     * @param options The options for the marker.
     */
    HtmlMarker.prototype.setOptions = function (options) {
        var newOptions = new HtmlMarkerOptions().merge(this.options, cloneDeepWith$1(options, HtmlMarkerOptions._cloneCustomizer));
        if (!isEqual$1(newOptions.htmlContent, this.options.htmlContent) ||
            newOptions.anchor !== this.options.anchor) {
            // If the htmlContent is new the old marker must be removed and a new one created.
            this.marker.remove();
            this._buildMarker(newOptions);
            // If this marker is attached to a map the new mapbox marker should be added to it.
            if (this.map) {
                this.marker.addTo(this.map._getMap());
                this._getCollectionContainer().appendChild(this.element);
            }
        }
        else {
            // Check for which options have been updated.
            // Not necessary if a new marker was created as it will have all the new properties.
            if (typeof newOptions.htmlContent === "string" &&
                (newOptions.color !== this.options.color ||
                    newOptions.text !== this.options.text ||
                    newOptions.secondaryColor !== this.options.secondaryColor)) {
                this.element.innerHTML = this._getSubbedHtmlString(newOptions) || "";
            }
            if (newOptions.draggable !== this.options.draggable) {
                this._setDraggable(newOptions.draggable);
                this.marker.setDraggable(newOptions.draggable);
            }
            if (!isEqual$1(newOptions.pixelOffset, this.options.pixelOffset)) {
                this.marker.setOffset(newOptions.pixelOffset);
            }
            if (!isEqual$1(newOptions.position, this.options.position)) {
                this.marker.setLngLat(newOptions.position);
            }
            if (newOptions.visible !== this.options.visible) {
                if (newOptions.visible) {
                    this.element.classList.remove(HtmlMarker.hiddenClass);
                }
                else {
                    this.element.classList.add(HtmlMarker.hiddenClass);
                }
            }
        }
        this.options = newOptions;
    };
    /**
     * Toggles the popup attached to the marker.
     */
    HtmlMarker.prototype.togglePopup = function () {
        if (this.options.popup) {
            if (this.options.popup.isOpen()) {
                this.options.popup.close();
            }
            else if (this.map) {
                // Set the popup position to match the marker's.
                // Same as the mapbox behavior.
                this.options.popup.setOptions({
                    position: this.options.position,
                });
                this.options.popup.open(this.map);
            }
            else {
                throw new Error("The marker must be added to a map before calling togglePopup().");
            }
        }
    };
    /**
     * @internal
     */
    HtmlMarker.prototype._addToMap = function (map, position) {
        // If already added to a different map remove it and add to the new one.
        if (this.map && this.map !== map) {
            this._removeFromMap();
        }
        if (position) {
            this.options.position = cloneDeep$1(position);
            this.marker.setLngLat(this.options.position);
        }
        // If the marker is being added to a map it already belongs to this isn't needed.
        if (this.map !== map) {
            this.map = map;
            this.marker.addTo(map._getMap());
            this._getCollectionContainer().appendChild(this.element);
        }
    };
    /**
     * @internal
     */
    HtmlMarker.prototype._removeFromMap = function () {
        if (this.map) {
            this.marker.remove();
            delete this.map;
        }
    };
    /**
     * @internal
     */
    HtmlMarker.prototype._getId = function () {
        if (this.element) {
            if (typeof this.options.htmlContent === "string") {
                return this.element.firstChild["id"];
            }
            else {
                return this.element.id;
            }
        }
        return undefined;
    };
    /**
     * Builds the Mapbox marker that this HtmlMarker will wrap.
     * @private
     */
    HtmlMarker.prototype._buildMarker = function (options) {
        // Construct a mapbox marker that this class wraps.
        // Must converts a HTML string to a HTMLElement (div with innerHTML == htmlContent).
        // Must also handle the substitution of HTML string placeholders.
        if (typeof options.htmlContent === "string") {
            var subbedContent = this._getSubbedHtmlString(options) || "";
            this.element = Html.convertHtmlString(subbedContent);
        }
        else {
            this.element = options.htmlContent;
        }
        this.element.classList.add(HtmlMarker.containerClass);
        // If draggability is enabled some attributes need updated.
        if (options.draggable) {
            this._setDraggable(true);
        }
        // If visible is false the marker should still exist on the DOM so it is accessible.
        if (!options.visible) {
            this.element.classList.add(HtmlMarker.hiddenClass);
        }
        this.marker = new maplibregl.Marker({
            element: this.element,
            offset: options.pixelOffset,
            draggable: options.draggable,
            anchor: options.anchor
        }).setLngLat(options.position);
        // Listen for marker specific events.
        this.marker.on("drag", this._onDrag);
        this.marker.on("dragstart", this._onDragStart);
        this.marker.on("dragend", this._onDragEnd);
        // Listen for HtmlElement specific events.
        this.element.addEventListener("click", this._bubbleElementEvent);
        this.element.addEventListener("dblclick", this._bubbleElementEvent);
        this.element.addEventListener("contextmenu", this._bubbleElementEvent);
        this.element.addEventListener("keydown", this._bubbleElementEvent);
        this.element.addEventListener("keypress", this._bubbleElementEvent);
        this.element.addEventListener("keyup", this._bubbleElementEvent);
        this.element.addEventListener("mousedown", this._bubbleElementEvent);
        this.element.addEventListener("mouseenter", this._bubbleElementEvent);
        this.element.addEventListener("mouseleave", this._bubbleElementEvent);
        this.element.addEventListener("mousemove", this._bubbleElementEvent);
        this.element.addEventListener("mouseout", this._bubbleElementEvent);
        this.element.addEventListener("mouseover", this._bubbleElementEvent);
        this.element.addEventListener("mouseup", this._bubbleElementEvent);
    };
    /**
     * Returns a HTML string with all place holders substituted for.
     * @private
     */
    HtmlMarker.prototype._getSubbedHtmlString = function (options) {
        if (typeof options.htmlContent === "string") {
            return options.htmlContent
                .replace(/{color}/ig, options.color || "")
                .replace(/{secondaryColor}/ig, options.secondaryColor || "")
                .replace(/{text}/ig, options.text || "");
        }
        else {
            return null;
        }
    };
    /**
     * Returns the element that should contain all the markers.
     * Creates it if it doesn't already exist.
     * @private
     */
    HtmlMarker.prototype._getCollectionContainer = function () {
        var collectionContainer = this.map.getCanvasContainer()
            .querySelector(".".concat(HtmlMarker.collectionContainerClass));
        if (!collectionContainer) {
            collectionContainer = document.createElement("div");
            collectionContainer.classList.add(HtmlMarker.collectionContainerClass);
            this.map.getCanvasContainer().appendChild(collectionContainer);
        }
        return collectionContainer;
    };
    /**
     * Called to set the element dragstart listener, needed for proper draggability on Edge.
     */
    HtmlMarker.prototype._setDraggable = function (draggable) {
        if (draggable) {
            this.element.addEventListener("dragstart", this._onEleDragStart);
        }
        else {
            this.element.removeEventListener("dragstart", this._onEleDragStart);
        }
    };
    HtmlMarker.collectionContainerClass = "marker-collection-container";
    HtmlMarker.hiddenClass = "hidden-accessible-element";
    HtmlMarker.containerClass = "marker-container";
    return HtmlMarker;
}(EventEmitter));

var Media = /** @class */ (function () {
    function Media() {
    }
    /**
     * Returns the current high contrast mode based on media queries.
     * Can return the following values:
     * - `"light"`: High contrast using black text on white backgrounds
     * - `"dark"`: High contrast using white text on black backgrounds
     * - `"invert"`: Inverting colors, often used for high contrast
     * - `null`: Not in high contrast mode
     */
    Media.getHighContrastMode = function () {
        if (matchMedia("(-ms-high-contrast: white-on-black)").matches) {
            return "dark";
        }
        else if (matchMedia("(-ms-high-contrast: black-on-white)").matches) {
            return "light";
        }
        else if (matchMedia("(-ms-high-contrast: active)").matches) {
            return "dark"; // Default to dark if we can't detect a specific style
        }
        else if (matchMedia("(inverted-colors: inverted)").matches) {
            return "invert"; // Inverted colors is specific to macOS
        }
        // If nothing matches assume high contrast isn't in use
        return null;
    };
    return Media;
}());

/*! https://github.com/nevware21/ts-utils v0.11.3 */
/*
 * Copyright (c) NevWare21 Solutions LLC and contributors. All rights reserved.
 * Licensed under the MIT license.
 */
/*#__NO_SIDE_EFFECTS__*/
function _pureAssign(func1, func2) {
    return func1 || func2;
}
/*#__NO_SIDE_EFFECTS__*/
function _pureRef(value, name) {
    return value[name];
}

var UNDEF_VALUE = undefined;
var NULL_VALUE = null;
var EMPTY = "";
var FUNCTION = "function";
var OBJECT = "object";
var PROTOTYPE = "prototype";
var __PROTO__ = "__proto__";
var UNDEFINED = "undefined";
var CONSTRUCTOR = "constructor";
var SYMBOL = "Symbol";
var POLYFILL_TAG = "_polyfill";
var LENGTH = "length";
var NAME = "name";
var CALL = "call";
var TO_STRING = "toString";
var ObjClass$1 = ( /*#__PURE__*/_pureAssign(Object));
var ObjProto$1 = ( /*#__PURE__*/_pureRef(ObjClass$1, PROTOTYPE));
var StrCls = ( /*#__PURE__*/_pureAssign(String));
var StrProto = ( /*#__PURE__*/_pureRef(StrCls, PROTOTYPE));
var MathCls = ( /*#__PURE__*/_pureAssign(Math));
var ArrCls = ( /*#__PURE__*/_pureAssign(Array));
var ArrProto = ( /*#__PURE__*/_pureRef(ArrCls, PROTOTYPE));
var ArrSlice = ( /*#__PURE__*/_pureRef(ArrProto, "slice"));

function safe(func, argArray) {
    try {
        return {
            v: func.apply(this, argArray)
        };
    }
    catch (e) {
        return { e: e };
    }
}

/*#__NO_SIDE_EFFECTS__*/
function safeGet(cb, defValue) {
    var result = safe(cb);
    return result.e ? defValue : result.v;
}

var _primitiveTypes;
/*#__NO_SIDE_EFFECTS__*/
function _createIs(theType) {
    return function (value) {
        return typeof value === theType;
    };
}
/*#__NO_SIDE_EFFECTS__*/
function _createObjIs(theName) {
    var theType = "[object " + theName + "]";
    return function (value) {
        return !!(value && objToString(value) === theType);
    };
}
/*#__NO_SIDE_EFFECTS__*/
function objToString(value) {
    return ObjProto$1[TO_STRING].call(value);
}
/*#__NO_SIDE_EFFECTS__*/
function isUndefined(value) {
    return typeof value === UNDEFINED || value === UNDEFINED;
}
/*#__NO_SIDE_EFFECTS__*/
function isNullOrUndefined(value) {
    return value === NULL_VALUE || isUndefined(value);
}
/*#__NO_SIDE_EFFECTS__*/
function isStrictNullOrUndefined(value) {
    return value === NULL_VALUE || !isDefined(value);
}
/*#__NO_SIDE_EFFECTS__*/
function isDefined(arg) {
    return !!arg || arg !== UNDEF_VALUE;
}
/*#__NO_SIDE_EFFECTS__*/
function isPrimitiveType(theType) {
    !_primitiveTypes && (_primitiveTypes = ["string", "number", "boolean", UNDEFINED, "symbol", "bigint"]);
    return theType !== OBJECT && _primitiveTypes.indexOf(theType) !== -1;
}
var isString = ( /*#__PURE__*/_createIs("string"));
var isFunction = ( /*#__PURE__*/_createIs(FUNCTION));
/*#__NO_SIDE_EFFECTS__*/
function isObject(value) {
    if (!value && isNullOrUndefined(value)) {
        return false;
    }
    return !!value && typeof value === OBJECT;
}
var isArray = ( /* #__PURE__*/_pureRef(ArrCls, "isArray"));
var isDate = ( /*#__PURE__*/_createObjIs("Date"));
var isNumber = ( /*#__PURE__*/_createIs("number"));
var isBoolean = ( /*#__PURE__*/_createIs("boolean"));
var isError = ( /*#__PURE__*/_createObjIs("Error"));
/*#__NO_SIDE_EFFECTS__*/
function isPromiseLike(value) {
    return !!(value && value.then && isFunction(value.then));
}
/*#__NO_SIDE_EFFECTS__*/
function isTruthy(value) {
    return !(!value || safeGet(function () { return !(value && (0 + value)); }, !value));
}

var objGetOwnPropertyDescriptor = ( /* #__PURE__ */_pureRef(ObjClass$1, "getOwnPropertyDescriptor"));

/*#__NO_SIDE_EFFECTS__*/
function objHasOwnProperty(obj, prop) {
    return !!obj && ObjProto$1.hasOwnProperty[CALL](obj, prop);
}

var objHasOwn = ( /*#__PURE__*/_pureAssign(( /* #__PURE__ */_pureRef(ObjClass$1, "hasOwn")), polyObjHasOwn));
/*#__NO_SIDE_EFFECTS__*/
function polyObjHasOwn(obj, prop) {
    return objHasOwnProperty(obj, prop) || !!objGetOwnPropertyDescriptor(obj, prop);
}

function objForEachKey(theObject, callbackfn, thisArg) {
    if (theObject && isObject(theObject)) {
        for (var prop in theObject) {
            if (objHasOwn(theObject, prop)) {
                if (callbackfn[CALL](thisArg || theObject, prop, theObject[prop]) === -1) {
                    break;
                }
            }
        }
    }
}

var propMap = {
    e: "enumerable",
    c: "configurable",
    v: "value",
    w: "writable",
    g: "get",
    s: "set"
};
/*#__NO_SIDE_EFFECTS__*/
function _createProp(value) {
    var prop = {};
    prop[propMap["c"]] = true;
    prop[propMap["e"]] = true;
    if (value.l) {
        prop.get = function () { return value.l.v; };
        var desc = objGetOwnPropertyDescriptor(value.l, "v");
        if (desc && desc.set) {
            prop.set = function (newValue) {
                value.l.v = newValue;
            };
        }
    }
    objForEachKey(value, function (key, value) {
        prop[propMap[key]] = isUndefined(value) ? prop[propMap[key]] : value;
    });
    return prop;
}
var objDefineProp = ( /*#__PURE__*/_pureRef(ObjClass$1, "defineProperty"));
function objDefine(target, key, propDesc) {
    return objDefineProp(target, key, _createProp(propDesc));
}

/*#__NO_SIDE_EFFECTS__*/
function _createKeyValueMap(values, keyType, valueType, completeFn, writable) {
    var theMap = {};
    objForEachKey(values, function (key, value) {
        _assignMapValue(theMap, key, keyType ? value : key, writable);
        _assignMapValue(theMap, value, valueType ? value : key, writable);
    });
    return completeFn ? completeFn(theMap) : theMap;
}
function _assignMapValue(theMap, key, value, writable) {
    objDefineProp(theMap, key, {
        value: value,
        enumerable: true,
        writable: !!writable
    });
}

var asString = ( /* #__PURE__ */_pureAssign(StrCls));

var ERROR_TYPE = "[object Error]";
/*#__NO_SIDE_EFFECTS__*/
function dumpObj(object, format) {
    var propertyValueDump = EMPTY;
    var objType = ObjProto$1[TO_STRING][CALL](object);
    if (objType === ERROR_TYPE) {
        object = { stack: asString(object.stack), message: asString(object.message), name: asString(object.name) };
    }
    try {
        propertyValueDump = JSON.stringify(object, NULL_VALUE, format ? ((typeof format === "number") ? format : 4) : UNDEF_VALUE);
        propertyValueDump = (propertyValueDump && propertyValueDump.replace(/"(\w+)"\s*:\s{0,1}/g, "$1: ")) || asString(object);
    }
    catch (e) {
        propertyValueDump = " - " + dumpObj(e, format);
    }
    return objType + ": " + propertyValueDump;
}

function throwError(message) {
    throw new Error(message);
}
function throwTypeError(message) {
    throw new TypeError(message);
}

var _objFreeze = ( /* #__PURE__ */_pureRef(ObjClass$1, "freeze"));
function _doNothing(value) {
    return value;
}
/*#__NO_SIDE_EFFECTS__*/
function _getProto(value) {
    return value[__PROTO__] || NULL_VALUE;
}
var objAssign = ( /*#__PURE__*/_pureRef(ObjClass$1, "assign"));
var objKeys = ( /*#__PURE__*/_pureRef(ObjClass$1, "keys"));
function objDeepFreeze(value) {
    if (_objFreeze) {
        objForEachKey(value, function (key, value) {
            if (isArray(value) || isObject(value)) {
                objDeepFreeze(value);
            }
        });
    }
    return objFreeze(value);
}
var objFreeze = ( /* #__PURE__*/_pureAssign(_objFreeze, _doNothing));
var objGetPrototypeOf = ( /* #__PURE__*/_pureAssign(( /* #__PURE__*/_pureRef(ObjClass$1, "getPrototypeOf")), _getProto));

/*#__NO_SIDE_EFFECTS__*/
function createEnum(values) {
    return _createKeyValueMap(values, 1 , 0 , objFreeze);
}
/*#__NO_SIDE_EFFECTS__*/
function createEnumKeyMap(values) {
    return _createKeyValueMap(values, 0 , 0 , objFreeze);
}
/*#__NO_SIDE_EFFECTS__*/
function createSimpleMap(values) {
    var mapClass = {};
    objForEachKey(values, function (key, value) {
        _assignMapValue(mapClass, key, value[1]);
        _assignMapValue(mapClass, value[0], value[1]);
    });
    return objFreeze(mapClass);
}
/*#__NO_SIDE_EFFECTS__*/
function createTypeMap(values) {
    return createSimpleMap(values);
}

var _wellKnownSymbolMap = /*#__PURE__*/ createEnumKeyMap({
    asyncIterator: 0 ,
    hasInstance: 1 ,
    isConcatSpreadable: 2 ,
    iterator: 3 ,
    match: 4 ,
    matchAll: 5 ,
    replace: 6 ,
    search: 7 ,
    species: 8 ,
    split: 9 ,
    toPrimitive: 10 ,
    toStringTag: 11 ,
    unscopables: 12
});

var GLOBAL_CONFIG_KEY = "__tsUtils$gblCfg";
var _globalCfg;
/*#__NO_SIDE_EFFECTS__*/
function _getGlobalValue() {
    var result;
    if (typeof globalThis !== UNDEFINED) {
        result = globalThis;
    }
    if (!result && typeof self !== UNDEFINED) {
        result = self;
    }
    if (!result && typeof window !== UNDEFINED) {
        result = window;
    }
    if (!result && typeof global !== UNDEFINED) {
        result = global;
    }
    return result;
}
/*#__NO_SIDE_EFFECTS__*/
function _getGlobalConfig() {
    if (!_globalCfg) {
        var gbl = safe(_getGlobalValue).v || {};
        _globalCfg = gbl[GLOBAL_CONFIG_KEY] = gbl[GLOBAL_CONFIG_KEY] || {};
    }
    return _globalCfg;
}

var _unwrapFunction = ( _unwrapFunctionWithPoly);
/*#__NO_SIDE_EFFECTS__*/
function _unwrapFunctionWithPoly(funcName, clsProto, polyFunc) {
    var clsFn = clsProto && clsProto[funcName];
    return function (thisArg) {
        var theFunc = (thisArg && thisArg[funcName]) || clsFn;
        if (theFunc || polyFunc) {
            var theArgs = arguments;
            return (theFunc || polyFunc).apply(thisArg, theFunc ? ArrSlice[CALL](theArgs, 1) : theArgs);
        }
        throwTypeError("\"" + asString(funcName) + "\" not defined for " + dumpObj(thisArg));
    };
}
/*#__NO_SIDE_EFFECTS__*/
function _unwrapProp(propName) {
    return function (thisArg) {
        return thisArg[propName];
    };
}
var mathMax = ( /*#__PURE__*/_pureRef(MathCls, "max"));

var strSlice = ( /*#__PURE__*/_unwrapFunction("slice", StrProto));

var strSubstring = ( /*#__PURE__*/_unwrapFunction("substring", StrProto));
var strSubstr = ( /*#__PURE__*/_unwrapFunctionWithPoly("substr", StrProto, polyStrSubstr));
/*#__NO_SIDE_EFFECTS__*/
function polyStrSubstr(value, start, length) {
    if (isNullOrUndefined(value)) {
        throwTypeError("Invalid " + dumpObj(value));
    }
    if (length < 0) {
        return EMPTY;
    }
    start = start || 0;
    if (start < 0) {
        start = mathMax(start + value[LENGTH], 0);
    }
    if (isUndefined(length)) {
        return strSlice(value, start);
    }
    return strSlice(value, start, start + length);
}
/*#__NO_SIDE_EFFECTS__*/
function strLeft(value, count) {
    return strSubstring(value, 0, count);
}

var UNIQUE_REGISTRY_ID = "_urid";
var _polySymbols;
/*#__NO_SIDE_EFFECTS__*/
function _globalSymbolRegistry() {
    if (!_polySymbols) {
        var gblCfg = _getGlobalConfig();
        _polySymbols = gblCfg.gblSym = gblCfg.gblSym || { k: {}, s: {} };
    }
    return _polySymbols;
}
var _wellKnownSymbolCache;
/*#__NO_SIDE_EFFECTS__*/
function polyNewSymbol(description) {
    var theSymbol = {
        description: asString(description),
        toString: function () { return SYMBOL + "(" + description + ")"; }
    };
    theSymbol[POLYFILL_TAG] = true;
    return theSymbol;
}
/*#__NO_SIDE_EFFECTS__*/
function polySymbolFor(key) {
    var registry = _globalSymbolRegistry();
    if (!objHasOwn(registry.k, key)) {
        var newSymbol_1 = polyNewSymbol(key);
        var regId_1 = objKeys(registry.s).length;
        newSymbol_1[UNIQUE_REGISTRY_ID] = function () { return regId_1 + "_" + newSymbol_1[TO_STRING](); };
        registry.k[key] = newSymbol_1;
        registry.s[newSymbol_1[UNIQUE_REGISTRY_ID]()] = asString(key);
    }
    return registry.k[key];
}
/*#__NO_SIDE_EFFECTS__*/
function polyGetKnownSymbol(name) {
    !_wellKnownSymbolCache && (_wellKnownSymbolCache = {});
    var result;
    var knownName = _wellKnownSymbolMap[name];
    if (knownName) {
        result = _wellKnownSymbolCache[knownName] = _wellKnownSymbolCache[knownName] || polyNewSymbol(SYMBOL + "." + knownName);
    }
    return result;
}

var _globalLazyTestHooks;
function _initTestHooks() {
    _globalLazyTestHooks = _getGlobalConfig();
}
/*#__NO_SIDE_EFFECTS__*/
function getLazy(cb) {
    var lazyValue = {};
    !_globalLazyTestHooks && _initTestHooks();
    lazyValue.b = _globalLazyTestHooks.lzy;
    objDefineProp(lazyValue, "v", {
        configurable: true,
        get: function () {
            var result = cb();
            if (!_globalLazyTestHooks.lzy) {
                objDefineProp(lazyValue, "v", {
                    value: result
                });
            }
            lazyValue.b = _globalLazyTestHooks.lzy;
            return result;
        }
    });
    return lazyValue;
}

/*#__NO_SIDE_EFFECTS__*/
function createCachedValue(value) {
    return objDefineProp({
        toJSON: function () { return value; }
    }, "v", { value: value });
}

var WINDOW = "window";
var _cachedGlobal;
function _getGlobalInstFn(getFn, theArgs) {
    var cachedValue;
    return function () {
        !_globalLazyTestHooks && _initTestHooks();
        (!cachedValue || _globalLazyTestHooks.lzy) && (cachedValue = createCachedValue(safe(getFn, theArgs).v));
        return cachedValue.v;
    };
}
/*#__NO_SIDE_EFFECTS__*/
function getGlobal(useCached) {
    !_globalLazyTestHooks && _initTestHooks();
    (!_cachedGlobal || useCached === false || _globalLazyTestHooks.lzy) && (_cachedGlobal = createCachedValue(safe(_getGlobalValue).v || NULL_VALUE));
    return _cachedGlobal.v;
}
/*#__NO_SIDE_EFFECTS__*/
function getInst(name, useCached) {
    var gbl = (!_cachedGlobal || useCached === false) ? getGlobal(useCached) : _cachedGlobal.v;
    if (gbl && gbl[name]) {
        return gbl[name];
    }
    if (name === WINDOW) {
        return getWindow();
    }
    return NULL_VALUE;
}
/*#__NO_SIDE_EFFECTS__*/
function hasDocument() {
    return !!( /*#__PURE__*/getDocument());
}
var getDocument = ( /*#__PURE__*/_getGlobalInstFn(getInst, ["document"]));
/*#__NO_SIDE_EFFECTS__*/
function hasWindow() {
    return !!( /*#__PURE__*/getWindow());
}
var getWindow = ( /*#__PURE__*/_getGlobalInstFn(getInst, [WINDOW]));
/*#__NO_SIDE_EFFECTS__*/
function hasNavigator() {
    return !!( /*#__PURE__*/getNavigator());
}
var getNavigator = ( /*#__PURE__*/_getGlobalInstFn(getInst, ["navigator"]));
/*#__NO_SIDE_EFFECTS__*/
function hasHistory() {
    return !!( /*#__PURE__*/getHistory());
}
var getHistory = ( /*#__PURE__*/_getGlobalInstFn(getInst, ["history"]));
var isNode = ( /*#__PURE__*/_getGlobalInstFn(function () {
    return !!( safe(function () { return (process && (process.versions || {}).node); }).v);
}));
var isWebWorker = ( /*#__PURE__*/_getGlobalInstFn(function () {
    return !!( safe(function () { return self && self instanceof WorkerGlobalScope; }).v);
}));

var _symbol;
var _symbolFor;
/*#__NO_SIDE_EFFECTS__*/
function _initSymbol() {
    _symbol = ( /*#__PURE__*/createCachedValue(safe((getInst), [SYMBOL]).v));
    return _symbol;
}
function _getSymbolKey(key) {
    var gblSym = ((!_globalLazyTestHooks.lzy ? _symbol : 0) || _initSymbol());
    return (gblSym.v ? gblSym.v[key] : UNDEF_VALUE);
}
/*#__NO_SIDE_EFFECTS__*/
function hasSymbol() {
    return !!( /*#__PURE__*/getSymbol());
}
/*#__NO_SIDE_EFFECTS__*/
function getSymbol() {
    !_globalLazyTestHooks && _initTestHooks();
    return ((!_globalLazyTestHooks.lzy ? _symbol : 0) || _initSymbol()).v;
}
/*#__NO_SIDE_EFFECTS__*/
function getKnownSymbol(name, noPoly) {
    var knownName = _wellKnownSymbolMap[name];
    !_globalLazyTestHooks && _initTestHooks();
    var sym = ((!_globalLazyTestHooks.lzy ? _symbol : 0) || _initSymbol());
    return sym.v ? sym.v[knownName || name] : (!noPoly ? polyGetKnownSymbol(name) : UNDEF_VALUE);
}
/*#__NO_SIDE_EFFECTS__*/
function newSymbol(description, noPoly) {
    !_globalLazyTestHooks && _initTestHooks();
    var sym = ((!_globalLazyTestHooks.lzy ? _symbol : 0) || _initSymbol());
    return sym.v ? sym.v(description) : (!noPoly ? polyNewSymbol(description) : NULL_VALUE);
}
/*#__NO_SIDE_EFFECTS__*/
function symbolFor(key) {
    !_globalLazyTestHooks && _initTestHooks();
    _symbolFor = ((!_globalLazyTestHooks.lzy ? _symbolFor : 0) || ( /*#__PURE__*/createCachedValue(safe((_getSymbolKey), ["for"]).v)));
    return (_symbolFor.v || polySymbolFor)(key);
}

/*#__NO_SIDE_EFFECTS__*/
function isIterator(value) {
    return !!value && isFunction(value.next);
}
/*#__NO_SIDE_EFFECTS__*/
function isIterable(value) {
    return !isStrictNullOrUndefined(value) && isFunction(value[getKnownSymbol(3 )]);
}

var _iterSymbol$1;
function iterForOf(iter, callbackfn, thisArg) {
    if (iter) {
        if (!isIterator(iter)) {
            !_iterSymbol$1 && (_iterSymbol$1 = createCachedValue(getKnownSymbol(3 )));
            iter = iter[_iterSymbol$1.v] ? iter[_iterSymbol$1.v]() : null;
        }
        if (isIterator(iter)) {
            var err = UNDEF_VALUE;
            var iterResult = UNDEF_VALUE;
            try {
                var count = 0;
                while (!(iterResult = iter.next()).done) {
                    if (callbackfn[CALL](thisArg || iter, iterResult.value, count, iter) === -1) {
                        break;
                    }
                    count++;
                }
            }
            catch (failed) {
                err = { e: failed };
                if (iter.throw) {
                    iterResult = NULL_VALUE;
                    iter.throw(err);
                }
            }
            finally {
                try {
                    if (iterResult && !iterResult.done) {
                        iter.return && iter.return(iterResult);
                    }
                }
                finally {
                    if (err) {
                        // eslint-disable-next-line no-unsafe-finally
                        throw err.e;
                    }
                }
            }
        }
    }
}

function fnApply(fn, thisArg, argArray) {
    return fn.apply(thisArg, argArray);
}

function arrAppend(target, elms) {
    if (!isUndefined(elms) && target) {
        if (isArray(elms)) {
            fnApply(target.push, target, elms);
        }
        else if (isIterator(elms) || isIterable(elms)) {
            iterForOf(elms, function (elm) {
                target.push(elm);
            });
        }
        else {
            target.push(elms);
        }
    }
    return target;
}

function arrForEach(theArray, callbackfn, thisArg) {
    if (theArray) {
        var len = theArray[LENGTH] >>> 0;
        for (var idx = 0; idx < len; idx++) {
            if (idx in theArray) {
                if (callbackfn[CALL](thisArg || theArray, theArray[idx], idx, theArray) === -1) {
                    break;
                }
            }
        }
    }
}

var arrIndexOf = ( /*#__PURE__*/_unwrapFunction("indexOf", ArrProto));

var arrMap = ( /*#__PURE__*/_unwrapFunction("map", ArrProto));

function arrSlice(theArray, start, end) {
    return ((theArray && theArray["slice"]) || ArrSlice).apply(theArray, ArrSlice[CALL](arguments, 1));
}

var arrReduce = ( /*#__PURE__*/_unwrapFunction("reduce", ArrProto));

var objCreate = ( /* #__PURE__*/_pureAssign(( /* #__PURE__*/_pureRef(ObjClass$1, "create")), polyObjCreate));
/*#__NO_SIDE_EFFECTS__*/
function polyObjCreate(obj) {
    if (!obj) {
        return {};
    }
    var type = typeof obj;
    if (type !== OBJECT && type !== FUNCTION) {
        throwTypeError("Prototype must be an Object or function: " + dumpObj(obj));
    }
    function tempFunc() { }
    tempFunc[PROTOTYPE] = obj;
    return new tempFunc();
}

var _isProtoArray;
function objSetPrototypeOf(obj, proto) {
    var fn = ObjClass$1["setPrototypeOf"] ||
        function (d, b) {
            var _a;
            !_isProtoArray && (_isProtoArray = createCachedValue((_a = {}, _a[__PROTO__] = [], _a) instanceof Array));
            _isProtoArray.v ? d[__PROTO__] = b : objForEachKey(b, function (key, value) { return d[key] = value; });
        };
    return fn(obj, proto);
}

/*#__NO_SIDE_EFFECTS__*/
function _createCustomError(name, d, b) {
    safe(objDefine, [d, NAME, { v: name, c: true, e: false }]);
    d = objSetPrototypeOf(d, b);
    function __() {
        this[CONSTRUCTOR] = d;
        safe(objDefine, [this, NAME, { v: name, c: true, e: false }]);
    }
    d[PROTOTYPE] = b === NULL_VALUE ? objCreate(b) : (__[PROTOTYPE] = b[PROTOTYPE], new __());
    return d;
}
function _setName(baseClass, name) {
    name && (baseClass[NAME] = name);
}
/*#__NO_SIDE_EFFECTS__*/
function createCustomError(name, constructCb, errorBase) {
    var theBaseClass = errorBase || Error;
    var orgName = theBaseClass[PROTOTYPE][NAME];
    var captureFn = Error.captureStackTrace;
    return _createCustomError(name, function () {
        var _this = this;
        var theArgs = arguments;
        try {
            safe(_setName, [theBaseClass, name]);
            var _self = fnApply(theBaseClass, _this, ArrSlice[CALL](theArgs)) || _this;
            if (_self !== _this) {
                var orgProto = objGetPrototypeOf(_this);
                if (orgProto !== objGetPrototypeOf(_self)) {
                    objSetPrototypeOf(_self, orgProto);
                }
            }
            captureFn && captureFn(_self, _this[CONSTRUCTOR]);
            constructCb && constructCb(_self, theArgs);
            return _self;
        }
        finally {
            safe(_setName, [theBaseClass, orgName]);
        }
    }, theBaseClass);
}
var _unsupportedError;
function throwUnsupported(message) {
    if (!_unsupportedError) {
        _unsupportedError = createCustomError("UnsupportedError");
    }
    throw new _unsupportedError(message);
}

/*#__NO_SIDE_EFFECTS__*/
function utcNow() {
    return (Date.now || polyUtcNow)();
}
/*#__NO_SIDE_EFFECTS__*/
function polyUtcNow() {
    return new Date().getTime();
}

/*#__NO_SIDE_EFFECTS__*/
function _createTrimFn(exp) {
    return function _doTrim(value) {
        if (isNullOrUndefined(value)) {
            throwTypeError("strTrim called [" + dumpObj(value) + "]");
        }
        if (value && value.replace) {
            value = value.replace(exp, EMPTY);
        }
        return value;
    };
}
var polyStrTrim = ( /*#__PURE__*/_createTrimFn(/^\s+|(?=\s)\s+$/g));

var strTrim = ( /*#__PURE__*/_unwrapFunctionWithPoly("trim", StrProto, polyStrTrim));

var _fnToString;
var _objCtrFnString;
var _gblWindow;
/*#__NO_SIDE_EFFECTS__*/
function isPlainObject(value) {
    if (!value || typeof value !== OBJECT) {
        return false;
    }
    if (!_gblWindow) {
        _gblWindow = hasWindow() ? getWindow() : true;
    }
    var result = false;
    if (value !== _gblWindow) {
        if (!_objCtrFnString) {
            _fnToString = Function[PROTOTYPE][TO_STRING];
            _objCtrFnString = _fnToString[CALL](ObjClass$1);
        }
        try {
            var proto = objGetPrototypeOf(value);
            result = !proto;
            if (!result) {
                if (objHasOwnProperty(proto, CONSTRUCTOR)) {
                    proto = proto[CONSTRUCTOR];
                }
                result = proto && typeof proto === FUNCTION && _fnToString[CALL](proto) === _objCtrFnString;
            }
        }
        catch (ex) {
        }
    }
    return result;
}

/*#__NO_SIDE_EFFECTS__*/
function _defaultDeepCopyHandler(details) {
    details.value && plainObjDeepCopyHandler(details);
    return true;
}
var defaultDeepCopyHandlers = [
    arrayDeepCopyHandler,
    plainObjDeepCopyHandler,
    functionDeepCopyHandler,
    dateDeepCopyHandler
];
/*#__NO_SIDE_EFFECTS__*/
function _getSetVisited(visitMap, source, newPath, cb) {
    var theEntry;
    arrForEach(visitMap, function (entry) {
        if (entry.k === source) {
            theEntry = entry;
            return -1;
        }
    });
    if (!theEntry) {
        theEntry = { k: source, v: source };
        visitMap.push(theEntry);
        cb(theEntry);
    }
    return theEntry.v;
}
function _deepCopy(visitMap, value, ctx, key) {
    var userHandler = ctx.handler;
    var newPath = ctx.path ? (key ? ctx.path.concat(key) : ctx.path) : [];
    var newCtx = {
        handler: ctx.handler,
        src: ctx.src,
        path: newPath
    };
    var theType = typeof value;
    var isPlain = false;
    var isPrim = false;
    if (value && theType === OBJECT) {
        isPlain = isPlainObject(value);
    }
    else {
        isPrim = value === NULL_VALUE || isPrimitiveType(theType);
    }
    var details = {
        type: theType,
        isPrim: isPrim,
        isPlain: isPlain,
        value: value,
        result: value,
        path: newPath,
        origin: ctx.src,
        copy: function (source, newKey) {
            return _deepCopy(visitMap, source, newKey ? newCtx : ctx, newKey);
        },
        copyTo: function (target, source) {
            return _copyProps(visitMap, target, source, newCtx);
        }
    };
    if (!details.isPrim) {
        return _getSetVisited(visitMap, value, newPath, function (newEntry) {
            objDefine(details, "result", {
                g: function () {
                    return newEntry.v;
                },
                s: function (newValue) {
                    newEntry.v = newValue;
                }
            });
            var idx = 0;
            var handler = userHandler;
            while (!(handler || (idx < defaultDeepCopyHandlers.length ? defaultDeepCopyHandlers[idx++] : _defaultDeepCopyHandler))[CALL](ctx, details)) {
                handler = NULL_VALUE;
            }
        });
    }
    if (userHandler && userHandler[CALL](ctx, details)) {
        return details.result;
    }
    return value;
}
function _copyProps(visitMap, target, source, ctx) {
    if (!isNullOrUndefined(source)) {
        for (var key in source) {
            target[key] = _deepCopy(visitMap, source[key], ctx, key);
        }
    }
    return target;
}
function objCopyProps(target, source, handler) {
    var ctx = {
        handler: handler,
        src: source,
        path: []
    };
    return _copyProps([], target, source, ctx);
}
/*#__NO_SIDE_EFFECTS__*/
function objDeepCopy(source, handler) {
    var ctx = {
        handler: handler,
        src: source
    };
    return _deepCopy([], source, ctx);
}
function arrayDeepCopyHandler(details) {
    var value = details.value;
    if (isArray(value)) {
        var target = details.result = [];
        target.length = value.length;
        details.copyTo(target, value);
        return true;
    }
    return false;
}
function dateDeepCopyHandler(details) {
    var value = details.value;
    if (isDate(value)) {
        details.result = new Date(value.getTime());
        return true;
    }
    return false;
}
function functionDeepCopyHandler(details) {
    if (details.type === FUNCTION) {
        return true;
    }
    return false;
}
function plainObjDeepCopyHandler(details) {
    var value = details.value;
    if (value && details.isPlain) {
        var target = details.result = {};
        details.copyTo(target, value);
        return true;
    }
    return false;
}

function _doExtend(target, theArgs) {
    arrForEach(theArgs, function (theArg) {
        objCopyProps(target, theArg);
    });
    return target;
}
function deepExtend(target, obj1, obj2, obj3, obj4, obj5, obj6) {
    return _doExtend(objDeepCopy(target) || {}, ArrSlice[CALL](arguments));
}
function objExtend$1(target, obj1, obj2, obj3, obj4, obj5, obj6) {
    return _doExtend(target || {}, ArrSlice[CALL](arguments));
}

var getLength = ( /*#__PURE__*/_unwrapProp(LENGTH));

var _perf;
/*#__NO_SIDE_EFFECTS__*/
function getPerformance() {
    !_globalLazyTestHooks && _initTestHooks();
    (!_perf || _globalLazyTestHooks.lzy) && (_perf = createCachedValue(safe((getInst), ["performance"]).v));
    return _perf.v;
}

var strSplit = ( /*#__PURE__*/_unwrapFunction("split", StrProto));
function setValueByKey(target, path, value) {
    if (target && path) {
        var parts = strSplit(path, ".");
        var lastKey = parts.pop();
        arrForEach(parts, function (key) {
            if (isNullOrUndefined(target[key])) {
                target[key] = {};
            }
            target = target[key];
        });
        target[lastKey] = value;
    }
}

var strEndsWith = ( /*#__PURE__*/_unwrapFunctionWithPoly("endsWith", StrProto, polyStrEndsWith));
/*#__NO_SIDE_EFFECTS__*/
function polyStrEndsWith(value, searchString, length) {
    if (!isString(value)) {
        throwTypeError("'" + dumpObj(value) + "' is not a string");
    }
    var searchValue = isString(searchString) ? searchString : asString(searchString);
    var end = !isUndefined(length) && length < value[LENGTH] ? length : value[LENGTH];
    return strSubstring(value, end - searchValue[LENGTH], end) === searchValue;
}

var strIndexOf = ( /*#__PURE__*/_unwrapFunction("indexOf", StrProto));

var REF = "ref";
var UNREF = "unref";
var HAS_REF = "hasRef";
var ENABLED = "enabled";
/*#__NO_SIDE_EFFECTS__*/
function _createTimerHandler(startTimer, refreshFn, cancelFn) {
    var ref = true;
    var timerId = startTimer ? refreshFn(NULL_VALUE) : NULL_VALUE;
    var theTimerHandler;
    function _unref() {
        ref = false;
        timerId && timerId[UNREF] && timerId[UNREF]();
        return theTimerHandler;
    }
    function _cancel() {
        timerId && cancelFn(timerId);
        timerId = NULL_VALUE;
    }
    function _refresh() {
        timerId = refreshFn(timerId);
        if (!ref) {
            _unref();
        }
        return theTimerHandler;
    }
    function _setEnabled(value) {
        !value && timerId && _cancel();
        value && !timerId && _refresh();
    }
    theTimerHandler = {
        cancel: _cancel,
        refresh: _refresh
    };
    theTimerHandler[HAS_REF] = function () {
        if (timerId && timerId[HAS_REF]) {
            return timerId[HAS_REF]();
        }
        return ref;
    };
    theTimerHandler[REF] = function () {
        ref = true;
        timerId && timerId[REF] && timerId[REF]();
        return theTimerHandler;
    };
    theTimerHandler[UNREF] = _unref;
    theTimerHandler = objDefineProp(theTimerHandler, ENABLED, {
        get: function () { return !!timerId; },
        set: _setEnabled
    });
    return {
        h: theTimerHandler,
        dn: function () {
            timerId = NULL_VALUE;
        }
    };
}

function _createTimeoutWith(startTimer, overrideFn, theArgs) {
    var isArr = isArray(overrideFn);
    var len = isArr ? overrideFn.length : 0;
    var setFn = (len > 0 ? overrideFn[0] : (!isArr ? overrideFn : UNDEF_VALUE)) || setTimeout;
    var clearFn = (len > 1 ? overrideFn[1] : UNDEF_VALUE) || clearTimeout;
    var timerFn = theArgs[0];
    theArgs[0] = function () {
        handler.dn();
        fnApply(timerFn, UNDEF_VALUE, ArrSlice[CALL](arguments));
    };
    var handler = _createTimerHandler(startTimer, function (timerId) {
        if (timerId) {
            if (timerId.refresh) {
                timerId.refresh();
                return timerId;
            }
            fnApply(clearFn, UNDEF_VALUE, [timerId]);
        }
        return fnApply(setFn, UNDEF_VALUE, theArgs);
    }, function (timerId) {
        fnApply(clearFn, UNDEF_VALUE, [timerId]);
    });
    return handler.h;
}
function scheduleTimeout(callback, timeout) {
    return _createTimeoutWith(true, UNDEF_VALUE, ArrSlice[CALL](arguments));
}
function createTimeout(callback, timeout) {
    return _createTimeoutWith(false, UNDEF_VALUE, ArrSlice[CALL](arguments));
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Create an enum style object which has both the key => value and value => key mappings
 * @param values - The values to populate on the new object
 * @returns
 */
var createEnumStyle = createEnum;
/**
 * Create a 2 index map that maps an enum's key and value to the defined map value, X["key"] => mapValue and X[0] => mapValue.
 * Generic values
 * - E = the const enum type (typeof eRequestHeaders);
 * - V = Identifies the valid values for the keys, this should include both the enum numeric and string key of the type. The
 * resulting "Value" of each entry identifies the valid values withing the assignments.
 * @param values - The values to populate on the new object
 * @returns
 */
var createValueMap = createTypeMap;

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var ActiveStatus = createEnumStyle({
    NONE: 0 /* eActiveStatus.NONE */,
    PENDING: 3 /* eActiveStatus.PENDING */,
    INACTIVE: 1 /* eActiveStatus.INACTIVE */,
    ACTIVE: 2 /* eActiveStatus.ACTIVE */
});

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_TO_LOWER_CASE$2 = "toLowerCase"; // Count: 11
var _DYN_BLK_VAL = "blkVal"; // Count: 5
var _DYN_LENGTH$5 = "length"; // Count: 55
var _DYN_RD_ONLY = "rdOnly"; // Count: 4
var _DYN_NOTIFY = "notify"; // Count: 4
var _DYN_WARN_TO_CONSOLE = "warnToConsole"; // Count: 4
var _DYN_THROW_INTERNAL = "throwInternal"; // Count: 5
var _DYN_SET_DF = "setDf"; // Count: 6
var _DYN_WATCH = "watch"; // Count: 8
var _DYN_LOGGER = "logger"; // Count: 21
var _DYN_APPLY = "apply"; // Count: 7
var _DYN_PUSH$2 = "push"; // Count: 34
var _DYN_SPLICE = "splice"; // Count: 8
var _DYN_HDLR = "hdlr"; // Count: 6
var _DYN_CANCEL = "cancel"; // Count: 6
var _DYN_INITIALIZE$1 = "initialize"; // Count: 5
var _DYN_IDENTIFIER = "identifier"; // Count: 8
var _DYN_REMOVE_NOTIFICATION_0 = "removeNotificationListener"; // Count: 4
var _DYN_ADD_NOTIFICATION_LIS1 = "addNotificationListener"; // Count: 4
var _DYN_IS_INITIALIZED = "isInitialized"; // Count: 10
var _DYN_INSTRUMENTATION_KEY$2 = "instrumentationKey"; // Count: 2
var _DYN__INACTIVE = "INACTIVE"; // Count: 3
var _DYN_VALUE = "value"; // Count: 5
var _DYN_GET_NOTIFY_MGR = "getNotifyMgr"; // Count: 5
var _DYN_GET_PLUGIN = "getPlugin"; // Count: 6
var _DYN_NAME$3 = "name"; // Count: 12
var _DYN_I_KEY = "iKey"; // Count: 5
var _DYN_TIME = "time"; // Count: 6
var _DYN_PROCESS_NEXT = "processNext"; // Count: 15
var _DYN_GET_PROCESS_TEL_CONT2 = "getProcessTelContext"; // Count: 2
var _DYN_POLL_INTERNAL_LOGS = "pollInternalLogs"; // Count: 2
var _DYN_ENABLED = "enabled"; // Count: 6
var _DYN_STOP_POLLING_INTERNA3 = "stopPollingInternalLogs"; // Count: 2
var _DYN_UNLOAD = "unload"; // Count: 9
var _DYN_ON_COMPLETE = "onComplete"; // Count: 5
var _DYN_VERSION$1 = "version"; // Count: 6
var _DYN_LOGGING_LEVEL_CONSOL4 = "loggingLevelConsole"; // Count: 2
var _DYN_CREATE_NEW$1 = "createNew"; // Count: 7
var _DYN_TEARDOWN = "teardown"; // Count: 9
var _DYN_MESSAGE_ID = "messageId"; // Count: 4
var _DYN_MESSAGE$2 = "message"; // Count: 7
var _DYN_IS_ASYNC = "isAsync"; // Count: 6
var _DYN_DIAG_LOG$2 = "diagLog"; // Count: 10
var _DYN__DO_TEARDOWN = "_doTeardown"; // Count: 5
var _DYN_UPDATE$1 = "update"; // Count: 6
var _DYN_GET_NEXT = "getNext"; // Count: 12
var _DYN_SET_NEXT_PLUGIN = "setNextPlugin"; // Count: 5
var _DYN_PROTOCOL = "protocol"; // Count: 3
var _DYN_USER_AGENT = "userAgent"; // Count: 5
var _DYN_SPLIT$1 = "split"; // Count: 7
var _DYN_NODE_TYPE = "nodeType"; // Count: 3
var _DYN_REPLACE = "replace"; // Count: 9
var _DYN_LOG_INTERNAL_MESSAGE = "logInternalMessage"; // Count: 2
var _DYN_TYPE = "type"; // Count: 14
var _DYN_HANDLER = "handler"; // Count: 5
var _DYN_STATUS$1 = "status"; // Count: 5
var _DYN_GET_RESPONSE_HEADER = "getResponseHeader"; // Count: 2
var _DYN_GET_ALL_RESPONSE_HEA5 = "getAllResponseHeaders"; // Count: 2
var _DYN_IS_CHILD_EVT = "isChildEvt"; // Count: 3
var _DYN_DATA$1 = "data"; // Count: 7
var _DYN_GET_CTX = "getCtx"; // Count: 6
var _DYN_SET_CTX = "setCtx"; // Count: 10
var _DYN_COMPLETE = "complete"; // Count: 3
var _DYN_ITEMS_RECEIVED$1 = "itemsReceived"; // Count: 3
var _DYN_URL_STRING = "urlString"; // Count: 5
var _DYN_SEND_POST = "sendPOST"; // Count: 3
var _DYN_HEADERS$1 = "headers"; // Count: 5
var _DYN_TIMEOUT = "timeout"; // Count: 6
var _DYN_SET_REQUEST_HEADER$1 = "setRequestHeader"; // Count: 2
var _DYN_TRACE_ID$2 = "traceId"; // Count: 5
var _DYN_SPAN_ID$1 = "spanId"; // Count: 5
var _DYN_TRACE_FLAGS$1 = "traceFlags"; // Count: 6

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var aggregationErrorType;
/**
 * Throws an Aggregation Error which includes all of the errors that led to this error occurring
 * @param message - The message describing the aggregation error (the sourceError details are added to this)
 * @param sourceErrors - An array of the errors that caused this situation
 */
function throwAggregationError(message, sourceErrors) {
    if (!aggregationErrorType) {
        aggregationErrorType = createCustomError("AggregationError", function (self, args) {
            if (args[_DYN_LENGTH$5 /* @min:%2elength */] > 1) {
                // Save the provided errors
                self.errors = args[1];
            }
        });
    }
    var theMessage = message || "One or more errors occurred.";
    arrForEach(sourceErrors, function (srcError, idx) {
        theMessage += "\n".concat(idx, " > ").concat(dumpObj(srcError));
    });
    throw new aggregationErrorType(theMessage, sourceErrors || []);
}

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License.
var strShimFunction = "function";
var strShimObject = "object";
var strShimUndefined = "undefined";
var strShimPrototype = "prototype";
var ObjClass = Object;
var ObjProto = ObjClass[strShimPrototype];

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License.
// Most of these functions have been directly shamelessly "lifted" from the https://github.com/@microsoft/tslib and
// modified to be ES5 compatible and applying several minification and tree-shaking techniques so that Application Insights
// can successfully use TypeScript "importHelpers" which imports tslib during compilation but it will use these at runtime
// Which is also why all of the functions have not been included as Application Insights currently doesn't use or require
// them.
(getGlobal() || {})["Symbol"];
(getGlobal() || {})["Reflect"];
var strHasOwnProperty = "hasOwnProperty";
var __objAssignFnImpl = function (t) {
    // tslint:disable-next-line: ban-comma-operator
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) {
            if (ObjProto[strHasOwnProperty].call(s, p)) {
                t[p] = s[p];
            }
        }
    }
    return t;
};
var __assignFn = objAssign || __objAssignFnImpl;
// tslint:disable-next-line: only-arrow-functions
var extendStaticsFn = function (d, b) {
    extendStaticsFn = ObjClass["setPrototypeOf"] ||
        // tslint:disable-next-line: only-arrow-functions
        ({ __proto__: [] } instanceof Array && function (d, b) {
            d.__proto__ = b;
        }) ||
        // tslint:disable-next-line: only-arrow-functions
        function (d, b) {
            for (var p in b) {
                if (b[strHasOwnProperty](p)) {
                    d[p] = b[p];
                }
            }
        };
    return extendStaticsFn(d, b);
};
function __extendsFn(d, b) {
    if (typeof b !== strShimFunction && b !== null) {
        throwTypeError("Class extends value " + String(b) + " is not a constructor or null");
    }
    extendStaticsFn(d, b);
    function __() {
        this.constructor = d;
    }
    // tslint:disable-next-line: ban-comma-operator
    d[strShimPrototype] = b === null ? objCreate(b) : (__[strShimPrototype] = b[strShimPrototype], new __());
}
function __spreadArrayFn(to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++) {
        to[j] = from[i];
    }
    return to;
}

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License.
var _a$a;
/**
 * Constant string defined to support minimization
 * @ignore
 */
var Constructor = 'constructor';
/**
 * Constant string defined to support minimization
 * @ignore
 */
var Prototype = 'prototype';
/**
 * Constant string defined to support minimization
 * @ignore
 */
var strFunction = 'function';
/**
 * Used to define the name of the instance function lookup table
 * @ignore
 */
var DynInstFuncTable = '_dynInstFuncs';
/**
 * Name used to tag the dynamic prototype function
 * @ignore
 */
var DynProxyTag = '_isDynProxy';
/**
 * Name added to a prototype to define the dynamic prototype "class" name used to lookup the function table
 * @ignore
 */
var DynClassName = '_dynClass';
/**
 * Prefix added to the classname to avoid any name clashes with other instance level properties
 * @ignore
 */
var DynClassNamePrefix = '_dynCls$';
/**
 * A tag which is used to check if we have already to attempted to set the instance function if one is not present
 * @ignore
 */
var DynInstChkTag = '_dynInstChk';
/**
 * A tag which is used to check if we are allows to try and set an instance function is one is not present. Using the same
 * tag name as the function level but a different const name for readability only.
 */
var DynAllowInstChkTag = DynInstChkTag;
/**
 * The global (imported) instances where the global performance options are stored
 */
var DynProtoDefaultOptions = '_dfOpts';
/**
 * Value used as the name of a class when it cannot be determined
 * @ignore
 */
var UnknownValue = '_unknown_';
/**
 * Constant string defined to support minimization
 * @ignore
 */
var str__Proto = "__proto__";
/**
 * The polyfill version of __proto__ so that it doesn't cause issues for anyone not expecting it to exist
 */
var DynProtoBaseProto = "_dyn" + str__Proto;
/**
 * Runtime Global holder for dynamicProto settings
 */
var DynProtoGlobalSettings = "__dynProto$Gbl";
/**
 * Track the current prototype for IE8 as you can't look back to get the prototype
 */
var DynProtoCurrent = "_dynInstProto";
/**
 * Constant string defined to support minimization
 * @ignore
 */
var strUseBaseInst = 'useBaseInst';
/**
 * Constant string defined to support minimization
 * @ignore
 */
var strSetInstFuncs = 'setInstFuncs';
var Obj = Object;
/**
 * Pre-lookup to check if we are running on a modern browser (i.e. not IE8)
 * @ignore
 */
var _objGetPrototypeOf = Obj["getPrototypeOf"];
/**
 * Pre-lookup to check for the existence of this function
 */
var _objGetOwnProps = Obj["getOwnPropertyNames"];
// Since 1.1.7 moving these to the runtime global to work around mixed version and module issues
// See Issue https://github.com/microsoft/DynamicProto-JS/issues/57 for details
var _gbl = getGlobal();
var _gblInst = _gbl[DynProtoGlobalSettings] || (_gbl[DynProtoGlobalSettings] = {
    o: (_a$a = {},
        _a$a[strSetInstFuncs] = true,
        _a$a[strUseBaseInst] = true,
        _a$a),
    n: 1000 // Start new global index @ 1000 so we "fix" some cases when mixed with 1.1.6 or earlier
});
/**
 * Helper used to check whether the target is an Object prototype or Array prototype
 * @ignore
 */
function _isObjectOrArrayPrototype(target) {
    return target && (target === Obj[Prototype] || target === Array[Prototype]);
}
/**
 * Helper used to check whether the target is an Object prototype, Array prototype or Function prototype
 * @ignore
 */
function _isObjectArrayOrFunctionPrototype(target) {
    return _isObjectOrArrayPrototype(target) || target === Function[Prototype];
}
/**
 * Helper used to get the prototype of the target object as getPrototypeOf is not available in an ES3 environment.
 * @ignore
 */
function _getObjProto$1(target) {
    var newProto;
    if (target) {
        // This method doesn't exist in older browsers (e.g. IE8)
        if (_objGetPrototypeOf) {
            return _objGetPrototypeOf(target);
        }
        var curProto = target[str__Proto] || target[Prototype] || (target[Constructor] ? target[Constructor][Prototype] : null);
        // Using the pre-calculated value as IE8 doesn't support looking up the prototype of a prototype and thus fails for more than 1 base class
        newProto = target[DynProtoBaseProto] || curProto;
        if (!objHasOwnProperty(target, DynProtoBaseProto)) {
            // As this prototype doesn't have this property then this is from an inherited class so newProto is the base to return so save it
            // so we can look it up value (which for a multiple hierarchy dynamicProto will be the base class)
            delete target[DynProtoCurrent]; // Delete any current value allocated to this instance so we pick up the value from prototype hierarchy
            newProto = target[DynProtoBaseProto] = target[DynProtoCurrent] || target[DynProtoBaseProto];
            target[DynProtoCurrent] = curProto;
        }
    }
    return newProto;
}
/**
 * Helper to get the properties of an object, including none enumerable ones as functions on a prototype in ES6
 * are not enumerable.
 * @param target
 */
function _forEachProp(target, func) {
    var props = [];
    if (_objGetOwnProps) {
        props = _objGetOwnProps(target);
    }
    else {
        for (var name_1 in target) {
            if (typeof name_1 === "string" && objHasOwnProperty(target, name_1)) {
                props.push(name_1);
            }
        }
    }
    if (props && props.length > 0) {
        for (var lp = 0; lp < props.length; lp++) {
            func(props[lp]);
        }
    }
}
/**
 * Helper function to check whether the provided function name is a potential candidate for dynamic
 * callback and prototype generation.
 * @param target The target object, may be a prototype or class object
 * @param funcName The function name
 * @param skipOwn Skips the check for own property
 * @ignore
 */
function _isDynamicCandidate(target, funcName, skipOwn) {
    return (funcName !== Constructor && typeof target[funcName] === strFunction && (skipOwn || objHasOwnProperty(target, funcName)) && funcName !== str__Proto && funcName !== Prototype);
}
/**
 * Helper to throw a TypeError exception
 * @param message the message
 * @ignore
 */
function _throwTypeError(message) {
    throwTypeError("DynamicProto: " + message);
}
/**
 * Returns a collection of the instance functions that are defined directly on the thisTarget object, it does
 * not return any inherited functions
 * @param thisTarget The object to get the instance functions from
 * @ignore
 */
function _getInstanceFuncs(thisTarget) {
    // Get the base proto
    var instFuncs = objCreate(null);
    // Save any existing instance functions
    _forEachProp(thisTarget, function (name) {
        // Don't include any dynamic prototype instances - as we only want the real functions
        if (!instFuncs[name] && _isDynamicCandidate(thisTarget, name, false)) {
            // Create an instance callback for passing the base function to the caller
            instFuncs[name] = thisTarget[name];
        }
    });
    return instFuncs;
}
/**
 * Returns whether the value is included in the array
 * @param values The array of values
 * @param value  The value
 */
function _hasVisited(values, value) {
    for (var lp = values.length - 1; lp >= 0; lp--) {
        if (values[lp] === value) {
            return true;
        }
    }
    return false;
}
/**
 * Returns an object that contains callback functions for all "base/super" functions, this is used to "save"
 * enabling calling super.xxx() functions without requiring that the base "class" has defined a prototype references
 * @param target The current instance
 * @ignore
 */
function _getBaseFuncs(classProto, thisTarget, instFuncs, useBaseInst) {
    function _instFuncProxy(target, funcHost, funcName) {
        var theFunc = funcHost[funcName];
        if (theFunc[DynProxyTag] && useBaseInst) {
            // grab and reuse the hosted looking function (if available) otherwise the original passed function
            var instFuncTable = target[DynInstFuncTable] || {};
            if (instFuncTable[DynAllowInstChkTag] !== false) {
                theFunc = (instFuncTable[funcHost[DynClassName]] || {})[funcName] || theFunc;
            }
        }
        return function () {
            // eslint-disable-next-line prefer-rest-params
            return theFunc.apply(target, arguments);
        };
    }
    // Start creating a new baseFuncs by creating proxies for the instance functions (as they may get replaced)
    var baseFuncs = objCreate(null);
    _forEachProp(instFuncs, function (name) {
        // Create an instance callback for passing the base function to the caller
        baseFuncs[name] = _instFuncProxy(thisTarget, instFuncs, name);
    });
    // Get the base prototype functions
    var baseProto = _getObjProto$1(classProto);
    var visited = [];
    // Don't include base object functions for Object, Array or Function
    while (baseProto && !_isObjectArrayOrFunctionPrototype(baseProto) && !_hasVisited(visited, baseProto)) {
        // look for prototype functions
        _forEachProp(baseProto, function (name) {
            // Don't include any dynamic prototype instances - as we only want the real functions
            // For IE 7/8 the prototype lookup doesn't provide the full chain so we need to bypass the 
            // hasOwnProperty check we get all of the methods, main difference is that IE7/8 doesn't return
            // the Object prototype methods while bypassing the check
            if (!baseFuncs[name] && _isDynamicCandidate(baseProto, name, !_objGetPrototypeOf)) {
                // Create an instance callback for passing the base function to the caller
                baseFuncs[name] = _instFuncProxy(thisTarget, baseProto, name);
            }
        });
        // We need to find all possible functions that might be overloaded by walking the entire prototype chain
        // This avoids the caller from needing to check whether it's direct base class implements the function or not
        // by walking the entire chain it simplifies the usage and issues from upgrading any of the base classes.
        visited.push(baseProto);
        baseProto = _getObjProto$1(baseProto);
    }
    return baseFuncs;
}
function _getInstFunc(target, funcName, proto, currentDynProtoProxy) {
    var instFunc = null;
    // We need to check whether the class name is defined directly on this prototype otherwise
    // it will walk the proto chain and return any parent proto classname.
    if (target && objHasOwnProperty(proto, DynClassName)) {
        var instFuncTable = target[DynInstFuncTable] || objCreate(null);
        instFunc = (instFuncTable[proto[DynClassName]] || objCreate(null))[funcName];
        if (!instFunc) {
            // Avoid stack overflow from recursive calling the same function
            _throwTypeError("Missing [" + funcName + "] " + strFunction);
        }
        // We have the instance function, lets check it we can speed up further calls
        // by adding the instance function back directly on the instance (avoiding the dynamic func lookup)
        if (!instFunc[DynInstChkTag] && instFuncTable[DynAllowInstChkTag] !== false) {
            // If the instance already has an instance function we can't replace it
            var canAddInst = !objHasOwnProperty(target, funcName);
            // Get current prototype
            var objProto = _getObjProto$1(target);
            var visited = [];
            // Lookup the function starting at the top (instance level prototype) and traverse down, if the first matching function
            // if nothing is found or if the first hit is a dynamic proto instance then we can safely add an instance shortcut
            while (canAddInst && objProto && !_isObjectArrayOrFunctionPrototype(objProto) && !_hasVisited(visited, objProto)) {
                var protoFunc = objProto[funcName];
                if (protoFunc) {
                    canAddInst = (protoFunc === currentDynProtoProxy);
                    break;
                }
                // We need to find all possible initial functions to ensure that we don't bypass a valid override function
                visited.push(objProto);
                objProto = _getObjProto$1(objProto);
            }
            try {
                if (canAddInst) {
                    // This instance doesn't have an instance func and the class hierarchy does have a higher level prototype version
                    // so it's safe to directly assign for any subsequent calls (for better performance)
                    target[funcName] = instFunc;
                }
                // Block further attempts to set the instance function for any
                instFunc[DynInstChkTag] = 1;
            }
            catch (e) {
                // Don't crash if the object is readonly or the runtime doesn't allow changing this
                // And set a flag so we don't try again for any function
                instFuncTable[DynAllowInstChkTag] = false;
            }
        }
    }
    return instFunc;
}
function _getProtoFunc(funcName, proto, currentDynProtoProxy) {
    var protoFunc = proto[funcName];
    // Check that the prototype function is not a self reference -- try to avoid stack overflow!
    if (protoFunc === currentDynProtoProxy) {
        // It is so lookup the base prototype
        protoFunc = _getObjProto$1(proto)[funcName];
    }
    if (typeof protoFunc !== strFunction) {
        _throwTypeError("[" + funcName + "] is not a " + strFunction);
    }
    return protoFunc;
}
/**
 * Add the required dynamic prototype methods to the the class prototype
 * @param proto - The class prototype
 * @param className - The instance classname
 * @param target - The target instance
 * @param baseInstFuncs - The base instance functions
 * @param setInstanceFunc - Flag to allow prototype function to reset the instance function if one does not exist
 * @ignore
 */
function _populatePrototype(proto, className, target, baseInstFuncs, setInstanceFunc) {
    function _createDynamicPrototype(proto, funcName) {
        var dynProtoProxy = function () {
            // Use the instance or prototype function
            var instFunc = _getInstFunc(this, funcName, proto, dynProtoProxy) || _getProtoFunc(funcName, proto, dynProtoProxy);
            // eslint-disable-next-line prefer-rest-params
            return instFunc.apply(this, arguments);
        };
        // Tag this function as a proxy to support replacing dynamic proxy elements (primary use case is for unit testing
        // via which can dynamically replace the prototype function reference)
        dynProtoProxy[DynProxyTag] = 1;
        return dynProtoProxy;
    }
    if (!_isObjectOrArrayPrototype(proto)) {
        var instFuncTable = target[DynInstFuncTable] = target[DynInstFuncTable] || objCreate(null);
        if (!_isObjectOrArrayPrototype(instFuncTable)) {
            var instFuncs_1 = instFuncTable[className] = (instFuncTable[className] || objCreate(null)); // fetch and assign if as it may not exist yet
            // Set whether we are allow to lookup instances, if someone has set to false then do not re-enable
            if (instFuncTable[DynAllowInstChkTag] !== false) {
                instFuncTable[DynAllowInstChkTag] = !!setInstanceFunc;
            }
            if (!_isObjectOrArrayPrototype(instFuncs_1)) {
                _forEachProp(target, function (name) {
                    // Only add overridden functions
                    if (_isDynamicCandidate(target, name, false) && target[name] !== baseInstFuncs[name]) {
                        // Save the instance Function to the lookup table and remove it from the instance as it's not a dynamic proto function
                        instFuncs_1[name] = target[name];
                        delete target[name];
                        // Add a dynamic proto if one doesn't exist or if a prototype function exists and it's not a dynamic one
                        if (!objHasOwnProperty(proto, name) || (proto[name] && !proto[name][DynProxyTag])) {
                            proto[name] = _createDynamicPrototype(proto, name);
                        }
                    }
                });
            }
        }
    }
}
/**
 * Checks whether the passed prototype object appears to be correct by walking the prototype hierarchy of the instance
 * @param classProto The class prototype instance
 * @param thisTarget The current instance that will be checked whether the passed prototype instance is in the hierarchy
 * @ignore
 */
function _checkPrototype(classProto, thisTarget) {
    // This method doesn't existing in older browsers (e.g. IE8)
    if (_objGetPrototypeOf) {
        // As this is primarily a coding time check, don't bother checking if running in IE8 or lower
        var visited = [];
        var thisProto = _getObjProto$1(thisTarget);
        while (thisProto && !_isObjectArrayOrFunctionPrototype(thisProto) && !_hasVisited(visited, thisProto)) {
            if (thisProto === classProto) {
                return true;
            }
            // This avoids the caller from needing to check whether it's direct base class implements the function or not
            // by walking the entire chain it simplifies the usage and issues from upgrading any of the base classes.
            visited.push(thisProto);
            thisProto = _getObjProto$1(thisProto);
        }
        return false;
    }
    // If objGetPrototypeOf doesn't exist then just assume everything is ok.
    return true;
}
/**
 * Gets the current prototype name using the ES6 name if available otherwise falling back to a use unknown as the name.
 * It's not critical for this to return a name, it's used to decorate the generated unique name for easier debugging only.
 * @param target
 * @param unknownValue
 * @ignore
 */
function _getObjName(target, unknownValue) {
    if (objHasOwnProperty(target, Prototype)) {
        // Look like a prototype
        return target.name || unknownValue || UnknownValue;
    }
    return (((target || {})[Constructor]) || {}).name || unknownValue || UnknownValue;
}
/**
 * Helper function when creating dynamic (inline) functions for classes, this helper performs the following tasks :-
 * - Saves references to all defined base class functions
 * - Calls the delegateFunc with the current target (this) and a base object reference that can be used to call all "super" functions.
 * - Will populate the class prototype for all overridden functions to support class extension that call the prototype instance.
 * Callers should use this helper when declaring all function within the constructor of a class, as mentioned above the delegateFunc is
 * passed both the target "this" and an object that can be used to call any base (super) functions, using this based object in place of
 * super.XXX() (which gets expanded to _super.prototype.XXX()) provides a better minification outcome and also ensures the correct "this"
 * context is maintained as TypeScript creates incorrect references using super.XXXX() for dynamically defined functions i.e. Functions
 * defined in the constructor or some other function (rather than declared as complete typescript functions).
 * ### Usage
 * ```typescript
 * import dynamicProto from "@microsoft/dynamicproto-js";
 * class ExampleClass extends BaseClass {
 *     constructor() {
 *         dynamicProto(ExampleClass, this, (_self, base) => {
 *             // This will define a function that will be converted to a prototype function
 *             _self.newFunc = () => {
 *                 // Access any "this" instance property
 *                 if (_self.someProperty) {
 *                     ...
 *                 }
 *             }
 *             // This will define a function that will be converted to a prototype function
 *             _self.myFunction = () => {
 *                 // Access any "this" instance property
 *                 if (_self.someProperty) {
 *                     // Call the base version of the function that we are overriding
 *                     base.myFunction();
 *                 }
 *                 ...
 *             }
 *             _self.initialize = () => {
 *                 ...
 *             }
 *             // Warnings: While the following will work as _self is simply a reference to
 *             // this, if anyone overrides myFunction() the overridden will be called first
 *             // as the normal JavaScript method resolution will occur and the defined
 *             // _self.initialize() function is actually gets removed from the instance and
 *             // a proxy prototype version is created to reference the created method.
 *             _self.initialize();
 *         });
 *     }
 * }
 * ```
 * @typeparam DPType This is the generic type of the class, used to keep intellisense valid
 * @typeparam DPCls The type that contains the prototype of the current class
 * @param theClass - This is the current class instance which contains the prototype for the current class
 * @param target - The current "this" (target) reference, when the class has been extended this.prototype will not be the 'theClass' value.
 * @param delegateFunc - The callback function (closure) that will create the dynamic function
 * @param options - Additional options to configure how the dynamic prototype operates
 */
function dynamicProto(theClass, target, delegateFunc, options) {
    // Make sure that the passed theClass argument looks correct
    if (!objHasOwnProperty(theClass, Prototype)) {
        _throwTypeError("theClass is an invalid class definition.");
    }
    // Quick check to make sure that the passed theClass argument looks correct (this is a common copy/paste error)
    var classProto = theClass[Prototype];
    if (!_checkPrototype(classProto, target)) {
        _throwTypeError("[" + _getObjName(theClass) + "] not in hierarchy of [" + _getObjName(target) + "]");
    }
    var className = null;
    if (objHasOwnProperty(classProto, DynClassName)) {
        // Only grab the class name if it's defined on this prototype (i.e. don't walk the prototype chain)
        className = classProto[DynClassName];
    }
    else {
        // As not all browser support name on the prototype creating a unique dynamic one if we have not already
        // assigned one, so we can use a simple string as the lookup rather than an object for the dynamic instance
        // function table lookup.
        className = DynClassNamePrefix + _getObjName(theClass, "_") + "$" + _gblInst.n;
        _gblInst.n++;
        classProto[DynClassName] = className;
    }
    var perfOptions = dynamicProto[DynProtoDefaultOptions];
    var useBaseInst = !!perfOptions[strUseBaseInst];
    if (useBaseInst && options && options[strUseBaseInst] !== undefined) {
        useBaseInst = !!options[strUseBaseInst];
    }
    // Get the current instance functions
    var instFuncs = _getInstanceFuncs(target);
    // Get all of the functions for any base instance (before they are potentially overridden)
    var baseFuncs = _getBaseFuncs(classProto, target, instFuncs, useBaseInst);
    // Execute the delegate passing in both the current target "this" and "base" function references
    // Note casting the same type as we don't actually have the base class here and this will provide some intellisense support
    delegateFunc(target, baseFuncs);
    // Don't allow setting instance functions for older IE instances
    var setInstanceFunc = !!_objGetPrototypeOf && !!perfOptions[strSetInstFuncs];
    if (setInstanceFunc && options) {
        setInstanceFunc = !!options[strSetInstFuncs];
    }
    // Populate the Prototype for any overridden instance functions
    _populatePrototype(classProto, className, target, instFuncs, setInstanceFunc !== false);
}
/**
 * Exposes the default global options to allow global configuration, if the global values are disabled these will override
 * any passed values. This is primarily exposed to support unit-testing without the need for individual classes to expose
 * their internal usage of dynamic proto.
 */
dynamicProto[DynProtoDefaultOptions] = _gblInst.o;

/*!
 * NevWare21 Solutions LLC - ts-async, 0.5.2
 * https://github.com/nevware21/ts-async
 * Copyright (c) NevWare21 Solutions LLC and contributors. All rights reserved.
 * Licensed under the MIT license.
 */

var STR_PROMISE = "Promise";
var REJECTED = "rejected";

function doAwaitResponse(value, cb) {
    return doAwait(value, function (value) {
        return cb ? cb({
            status: "fulfilled",
            rejected: false,
            value: value
        }) : value;
    }, function (reason) {
        return cb ? cb({
            status: REJECTED,
            rejected: true,
            reason: reason
        }) : reason;
    });
}
function doAwait(value, resolveFn, rejectFn, finallyFn) {
    var result = value;
    try {
        if (isPromiseLike(value)) {
            if (resolveFn || rejectFn) {
                result = value.then(resolveFn, rejectFn);
            }
        }
        else {
            try {
                if (resolveFn) {
                    result = resolveFn(value);
                }
            }
            catch (err) {
                if (rejectFn) {
                    result = rejectFn(err);
                }
                else {
                    throw err;
                }
            }
        }
    }
    finally {
        if (finallyFn) {
            doFinally(result, finallyFn);
        }
    }
    return result;
}
function doFinally(value, finallyFn) {
    var result = value;
    if (finallyFn) {
        if (isPromiseLike(value)) {
            if (value.finally) {
                result = value.finally(finallyFn);
            }
            else {
                result = value.then(function (value) {
                    finallyFn();
                    return value;
                }, function (reason) {
                    finallyFn();
                    throw reason;
                });
            }
        }
        else {
            finallyFn();
        }
    }
    return result;
}

var STRING_STATES =  [
    "pending", "resolving", "resolved", REJECTED
];

var DISPATCH_EVENT = "dispatchEvent";
var _hasInitEvent;
function _hasInitEventFn(doc) {
    var evt;
    if (doc && doc.createEvent) {
        evt = doc.createEvent("Event");
    }
    return (!!evt && evt.initEvent);
}
function emitEvent(target, evtName, populateEvent, useNewEvent) {
    var doc = getDocument();
    !_hasInitEvent && (_hasInitEvent = createCachedValue(!!safe(_hasInitEventFn, [doc]).v));
    var theEvt = _hasInitEvent.v ? doc.createEvent("Event") : (useNewEvent ? new Event(evtName) : {});
    populateEvent && populateEvent(theEvt);
    if (_hasInitEvent.v) {
        theEvt.initEvent(evtName, false, true);
    }
    if (theEvt && target[DISPATCH_EVENT]) {
        target[DISPATCH_EVENT](theEvt);
    }
    else {
        var handler = target["on" + evtName];
        if (handler) {
            handler(theEvt);
        }
        else {
            var theConsole = getInst("console");
            theConsole && (theConsole["error"] || theConsole["log"])(evtName, dumpObj(theEvt));
        }
    }
}

var NODE_UNHANDLED_REJECTION = "unhandledRejection";
var UNHANDLED_REJECTION = NODE_UNHANDLED_REJECTION.toLowerCase();
var _unhandledRejectionTimeout = 10;
var _hasPromiseRejectionEvent;
function dumpFnObj(value) {
    if (isFunction(value)) {
        return value.toString();
    }
    return dumpObj(value);
}
function _createPromise(newPromise, processor, executor) {
    var additionalArgs = arrSlice(arguments, 3);
    var _state = 0 ;
    var _hasResolved = false;
    var _settledValue;
    var _queue = [];
    var _handled = false;
    var _unHandledRejectionHandler = null;
    var _thePromise;
    function _then(onResolved, onRejected) {
        try {
            _handled = true;
            _unHandledRejectionHandler && _unHandledRejectionHandler.cancel();
            _unHandledRejectionHandler = null;
            var thenPromise = newPromise(function (resolve, reject) {
                _queue.push(function () {
                    try {
                        var handler = _state === 2  ? onResolved : onRejected;
                        var value = isUndefined(handler) ? _settledValue : (isFunction(handler) ? handler(_settledValue) : handler);
                        if (isPromiseLike(value)) {
                            value.then(resolve, reject);
                        }
                        else if (handler) {
                            resolve(value);
                        }
                        else if (_state === 3 ) {
                            reject(value);
                        }
                        else {
                            resolve(value);
                        }
                    }
                    catch (e) {
                        reject(e);
                    }
                });
                if (_hasResolved) {
                    _processQueue();
                }
            }, additionalArgs);
            return thenPromise;
        }
        finally {
        }
    }
    function _catch(onRejected) {
        return _then(undefined, onRejected);
    }
    function _finally(onFinally) {
        var thenFinally = onFinally;
        var catchFinally = onFinally;
        if (isFunction(onFinally)) {
            thenFinally = function (value) {
                onFinally && onFinally();
                return value;
            };
            catchFinally = function (reason) {
                onFinally && onFinally();
                throw reason;
            };
        }
        return _then(thenFinally, catchFinally);
    }
    function _strState() {
        return STRING_STATES[_state];
    }
    function _processQueue() {
        if (_queue.length > 0) {
            var pending = _queue.slice();
            _queue = [];
            _handled = true;
            _unHandledRejectionHandler && _unHandledRejectionHandler.cancel();
            _unHandledRejectionHandler = null;
            processor(pending);
        }
    }
    function _createSettleIfFn(newState, allowState) {
        return function (theValue) {
            if (_state === allowState) {
                if (newState === 2  && isPromiseLike(theValue)) {
                    _state = 1 ;
                    theValue.then(_createSettleIfFn(2 , 1 ), _createSettleIfFn(3 , 1 ));
                    return;
                }
                _state = newState;
                _hasResolved = true;
                _settledValue = theValue;
                _processQueue();
                if (!_handled && newState === 3  && !_unHandledRejectionHandler) {
                    _unHandledRejectionHandler = scheduleTimeout(_notifyUnhandledRejection, _unhandledRejectionTimeout);
                }
            }
        };
    }
    function _notifyUnhandledRejection() {
        if (!_handled) {
            _handled = true;
            if (isNode()) {
                process.emit(NODE_UNHANDLED_REJECTION, _settledValue, _thePromise);
            }
            else {
                var gbl = getWindow() || getGlobal();
                !_hasPromiseRejectionEvent && (_hasPromiseRejectionEvent = createCachedValue(safe((getInst), [STR_PROMISE + "RejectionEvent"]).v));
                emitEvent(gbl, UNHANDLED_REJECTION, function (theEvt) {
                    objDefine(theEvt, "promise", { g: function () { return _thePromise; } });
                    theEvt.reason = _settledValue;
                    return theEvt;
                }, !!_hasPromiseRejectionEvent.v);
            }
        }
    }
    _thePromise = {
        then: _then,
        "catch": _catch,
        finally: _finally
    };
    objDefineProp(_thePromise, "state", {
        get: _strState
    });
    if (hasSymbol()) {
        _thePromise[getKnownSymbol(11 )] = "IPromise";
    }
    function _toString() {
        return "IPromise" + ("") + " " + _strState() + (_hasResolved ? (" - " + dumpFnObj(_settledValue)) : "") + ("");
    }
    _thePromise.toString = _toString;
    (function _initialize() {
        if (!isFunction(executor)) {
            throwTypeError(STR_PROMISE + ": executor is not a function - " + dumpFnObj(executor));
        }
        var _rejectFn = _createSettleIfFn(3 , 0 );
        try {
            executor.call(_thePromise, _createSettleIfFn(2 , 0 ), _rejectFn);
        }
        catch (e) {
            _rejectFn(e);
        }
    })();
    return _thePromise;
}
/*#__NO_SIDE_EFFECTS__*/
function _createAllPromise(newPromise) {
    return function (input) {
        var additionalArgs = arrSlice(arguments, 1);
        return newPromise(function (resolve, reject) {
            try {
                var values_1 = [];
                var pending_1 = 1;
                iterForOf(input, function (item, idx) {
                    if (item) {
                        pending_1++;
                        doAwait(item, function (value) {
                            values_1[idx] = value;
                            if (--pending_1 === 0) {
                                resolve(values_1);
                            }
                        }, reject);
                    }
                });
                pending_1--;
                if (pending_1 === 0) {
                    resolve(values_1);
                }
            }
            catch (e) {
                reject(e);
            }
        }, additionalArgs);
    };
}
/*#__NO_SIDE_EFFECTS__*/
function _createAllSettledPromise(newPromise) {
    return createCachedValue(function (input) {
        var additionalArgs = arrSlice(arguments, 1);
        return newPromise(function (resolve, reject) {
            var values = [];
            var pending = 1;
            function processItem(item, idx) {
                pending++;
                doAwaitResponse(item, function (value) {
                    if (value.rejected) {
                        values[idx] = {
                            status: REJECTED,
                            reason: value.reason
                        };
                    }
                    else {
                        values[idx] = {
                            status: "fulfilled",
                            value: value.value
                        };
                    }
                    if (--pending === 0) {
                        resolve(values);
                    }
                });
            }
            try {
                if (isArray(input)) {
                    arrForEach(input, processItem);
                }
                else if (isIterable(input)) {
                    iterForOf(input, processItem);
                }
                else {
                    throwTypeError("Input is not an iterable");
                }
                pending--;
                if (pending === 0) {
                    resolve(values);
                }
            }
            catch (e) {
                reject(e);
            }
        }, additionalArgs);
    });
}

function syncItemProcessor(pending) {
    arrForEach(pending, function (fn) {
        try {
            fn();
        }
        catch (e) {
        }
    });
}
function timeoutItemProcessor(timeout) {
    var callbackTimeout = isNumber(timeout) ? timeout : 0;
    return function (pending) {
        scheduleTimeout(function () {
            syncItemProcessor(pending);
        }, callbackTimeout);
    };
}
function createAsyncPromise(executor, timeout) {
    return _createPromise(createAsyncPromise, timeoutItemProcessor(timeout), executor, timeout);
}

var _promiseCls;
function createNativePromise(executor, timeout) {
    !_promiseCls && (_promiseCls = createCachedValue((safe(getInst, [STR_PROMISE]).v) || null));
    var PrmCls = _promiseCls.v;
    if (!PrmCls) {
        return createAsyncPromise(executor);
    }
    if (!isFunction(executor)) {
        throwTypeError(STR_PROMISE + ": executor is not a function - " + dumpObj(executor));
    }
    var _state = 0 ;
    function _strState() {
        return STRING_STATES[_state];
    }
    var thePromise = new PrmCls(function (resolve, reject) {
        function _resolve(value) {
            _state = 2 ;
            resolve(value);
        }
        function _reject(reason) {
            _state = 3 ;
            reject(reason);
        }
        executor(_resolve, _reject);
    });
    objDefineProp(thePromise, "state", {
        get: _strState
    });
    return thePromise;
}

var _promiseCreator;
var _allSettledCreator;
function createPromise(executor, timeout) {
    !_promiseCreator && (_promiseCreator = createCachedValue(createNativePromise));
    return _promiseCreator.v.call(this, executor, timeout);
}
var createAllPromise = /*#__PURE__*/ _createAllPromise(createPromise);
function createAllSettledPromise(input, timeout) {
    !_allSettledCreator && (_allSettledCreator = _createAllSettledPromise(createPromise));
    return _allSettledCreator.v(input, timeout);
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// ###################################################################################################################################################
// Note: DON'T Export these const from the package as we are still targeting IE/ES5 this will export a mutable variables that someone could change ###
// ###################################################################################################################################################
var UNDEFINED_VALUE$2 = undefined;
var STR_EMPTY$1 = "";
var STR_CHANNELS = "channels";
var STR_CORE = "core";
var STR_CREATE_PERF_MGR = "createPerfMgr";
var STR_DISABLED = "disabled";
var STR_EXTENSION_CONFIG = "extensionConfig";
var STR_EXTENSIONS = "extensions";
var STR_PROCESS_TELEMETRY = "processTelemetry";
var STR_PRIORITY = "priority";
var STR_EVENTS_SENT = "eventsSent";
var STR_EVENTS_DISCARDED = "eventsDiscarded";
var STR_EVENTS_SEND_REQUEST = "eventsSendRequest";
var STR_PERF_EVENT = "perfEvent";
var STR_OFFLINE_STORE = "offlineEventsStored";
var STR_OFFLINE_SENT = "offlineBatchSent";
var STR_OFFLINE_DROP = "offlineBatchDrop";
var STR_GET_PERF_MGR = "getPerfMgr";
var STR_DOMAIN = "domain";
var STR_PATH = "path";
var STR_NOT_DYNAMIC_ERROR = "Not dynamic - ";

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

// RESTRICT and AVOID circular dependencies you should not import other contained modules or export the contents of this file directly
// Added to help with minification
var strGetPrototypeOf = "getPrototypeOf";
var rCamelCase = /-([a-z])/g;
var rNormalizeInvalid = /([^\w\d_$])/g;
var rLeadingNumeric = /^(\d+[\w\d_$])/;
var _getObjProto = Object[strGetPrototypeOf];
function isNotNullOrUndefined(value) {
    return !isNullOrUndefined(value);
}
/**
 * Validates that the string name conforms to the JS IdentifierName specification and if not
 * normalizes the name so that it would. This method does not identify or change any keywords
 * meaning that if you pass in a known keyword the same value will be returned.
 * This is a simplified version
 * @param name - The name to validate
 */
function normalizeJsName(name) {
    var value = name;
    if (value && isString(value)) {
        // CamelCase everything after the "-" and remove the dash
        value = value[_DYN_REPLACE /* @min:%2ereplace */](rCamelCase, function (_all, letter) {
            return letter.toUpperCase();
        });
        value = value[_DYN_REPLACE /* @min:%2ereplace */](rNormalizeInvalid, "_");
        value = value[_DYN_REPLACE /* @min:%2ereplace */](rLeadingNumeric, function (_all, match) {
            return "_" + match;
        });
    }
    return value;
}
/**
 * A simple wrapper (for minification support) to check if the value contains the search string.
 * @param value - The string value to check for the existence of the search value
 * @param search - The value search within the value
 */
function strContains(value, search) {
    if (value && search) {
        return strIndexOf(value, search) !== -1;
    }
    return false;
}
/**
 * Convert a date to I.S.O. format in IE8
 */
function toISOString(date) {
    return date && date.toISOString() || "";
}
/**
 * Returns the name of object if it's an Error. Otherwise, returns empty string.
 */
function getExceptionName(object) {
    if (isError(object)) {
        return object[_DYN_NAME$3 /* @min:%2ename */];
    }
    return STR_EMPTY$1;
}
/**
 * Sets the provided value on the target instance using the field name when the provided chk function returns true, the chk
 * function will only be called if the new value is no equal to the original value.
 * @param target - The target object
 * @param field - The key of the target
 * @param value - The value to set
 * @param valChk - [Optional] Callback to check the value that if supplied will be called check if the new value can be set
 * @param srcChk - [Optional] Callback to check to original value that if supplied will be called if the new value should be set (if allowed)
 * @returns The existing or new value, depending what was set
 */
function setValue(target, field, value, valChk, srcChk) {
    var theValue = value;
    if (target) {
        theValue = target[field];
        if (theValue !== value && (!srcChk || srcChk(theValue)) && (!valChk || valChk(value))) {
            theValue = value;
            target[field] = theValue;
        }
    }
    return theValue;
}
/**
 * Returns the current value from the target object if not null or undefined otherwise sets the new value and returns it
 * @param target - The target object to return or set the default value
 * @param field - The key for the field to set on the target
 * @param defValue - [Optional] The value to set if not already present, when not provided a empty object will be added
 */
function getSetValue(target, field, defValue) {
    var theValue;
    if (target) {
        theValue = target[field];
        if (!theValue && isNullOrUndefined(theValue)) {
            // Supports having the default as null
            theValue = !isUndefined(defValue) ? defValue : {};
            target[field] = theValue;
        }
    }
    else {
        // Expanded for performance so we only check defValue if required
        theValue = !isUndefined(defValue) ? defValue : {};
    }
    return theValue;
}
function _createProxyFunction(source, funcName) {
    var srcFunc = null;
    var src = null;
    if (isFunction(source)) {
        srcFunc = source;
    }
    else {
        src = source;
    }
    return function () {
        // Capture the original arguments passed to the method
        var originalArguments = arguments;
        if (srcFunc) {
            src = srcFunc();
        }
        if (src) {
            return src[funcName][_DYN_APPLY /* @min:%2eapply */](src, originalArguments);
        }
    };
}
/**
 * Effectively assigns all enumerable properties (not just own properties) and functions (including inherited prototype) from
 * the source object to the target, it attempts to use proxy getters / setters (if possible) and proxy functions to avoid potential
 * implementation issues by assigning prototype functions as instance ones
 *
 * This method is the primary method used to "update" the snippet proxy with the ultimate implementations.
 *
 * Special ES3 Notes:
 * Updates (setting) of direct property values on the target or indirectly on the source object WILL NOT WORK PROPERLY, updates to the
 * properties of "referenced" object will work (target.context.newValue = 10 => will be reflected in the source.context as it's the
 * same object). ES3 Failures: assigning target.myProp = 3 -> Won't change source.myProp = 3, likewise the reverse would also fail.
 * @param target - The target object to be assigned with the source properties and functions
 * @param source - The source object which will be assigned / called by setting / calling the targets proxies
 * @param chkSet - An optional callback to determine whether a specific property/function should be proxied
 */
function proxyAssign(target, source, chkSet) {
    if (target && source && isObject(target) && isObject(source)) {
        var _loop_1 = function (field) {
            if (isString(field)) {
                var value = source[field];
                if (isFunction(value)) {
                    if (!chkSet || chkSet(field, true, source, target)) {
                        // Create a proxy function rather than just copying the (possible) prototype to the new object as an instance function
                        target[field] = _createProxyFunction(source, field);
                    }
                }
                else if (!chkSet || chkSet(field, false, source, target)) {
                    if (objHasOwn(target, field)) {
                        // Remove any previous instance property
                        delete target[field];
                    }
                    objDefine(target, field, {
                        g: function () {
                            return source[field];
                        },
                        s: function (theValue) {
                            source[field] = theValue;
                        }
                    });
                }
            }
        };
        // effectively apply/proxy full source to the target instance
        for (var field in source) {
            _loop_1(field);
        }
    }
    return target;
}
/**
 * Creates a proxy function on the target which internally will call the source version with all arguments passed to the target method.
 *
 * @param target - The target object to be assigned with the source properties and functions
 * @param name - The function name that will be added on the target
 * @param source - The source object which will be assigned / called by setting / calling the targets proxies
 * @param theFunc - The function name on the source that will be proxied on the target
 * @param overwriteTarget - If `false` this will not replace any pre-existing name otherwise (the default) it will overwrite any existing name
 */
function proxyFunctionAs(target, name, source, theFunc, overwriteTarget) {
    if (target && name && source) {
        if (overwriteTarget !== false || isUndefined(target[name])) {
            target[name] = _createProxyFunction(source, theFunc);
        }
    }
}
/**
 * Creates proxy functions on the target which internally will call the source version with all arguments passed to the target method.
 *
 * @param target - The target object to be assigned with the source properties and functions
 * @param source - The source object which will be assigned / called by setting / calling the targets proxies
 * @param functionsToProxy - An array of function names that will be proxied on the target
 * @param overwriteTarget - If false this will not replace any pre-existing name otherwise (the default) it will overwrite any existing name
 */
function proxyFunctions(target, source, functionsToProxy, overwriteTarget) {
    if (target && source && isObject(target) && isArray(functionsToProxy)) {
        arrForEach(functionsToProxy, function (theFuncName) {
            if (isString(theFuncName)) {
                proxyFunctionAs(target, theFuncName, source, theFuncName, overwriteTarget);
            }
        });
    }
    return target;
}
/**
 * Simpler helper to create a dynamic class that implements the interface and populates the values with the defaults.
 * Only instance properties (hasOwnProperty) values are copied from the defaults to the new instance
 * @param defaults - Simple helper
 */
function createClassFromInterface(defaults) {
    return /** @class */ (function () {
        function class_1() {
            var _this = this;
            if (defaults) {
                objForEachKey(defaults, function (field, value) {
                    _this[field] = value;
                });
            }
        }
        return class_1;
    }());
}
/**
 * A helper function to assist with JIT performance for objects that have properties added / removed dynamically
 * this is primarily for chromium based browsers and has limited effects on Firefox and none of IE. Only call this
 * function after you have finished "updating" the object, calling this within loops reduces or defeats the benefits.
 * This helps when iterating using for..in, objKeys() and objForEach()
 * @param theObject - The object to be optimized if possible
 */
function optimizeObject(theObject) {
    // V8 Optimization to cause the JIT compiler to create a new optimized object for looking up the own properties
    // primarily for object with <= 19 properties for >= 20 the effect is reduced or non-existent
    if (theObject && objAssign) {
        theObject = ObjClass(objAssign({}, theObject));
    }
    return theObject;
}
function objExtend(obj1, obj2, obj3, obj4, obj5, obj6) {
    // Variables
    var theArgs = arguments;
    var extended = theArgs[0] || {};
    var argLen = theArgs[_DYN_LENGTH$5 /* @min:%2elength */];
    var deep = false;
    var idx = 1;
    // Check for "Deep" flag
    if (argLen > 0 && isBoolean(extended)) {
        deep = extended;
        extended = theArgs[idx] || {};
        idx++;
    }
    // Handle case when target is a string or something (possible in deep copy)
    if (!isObject(extended)) {
        extended = {};
    }
    // Loop through each remaining object and conduct a merge
    for (; idx < argLen; idx++) {
        var arg = theArgs[idx];
        var isArgArray = isArray(arg);
        var isArgObj = isObject(arg);
        for (var prop in arg) {
            var propOk = (isArgArray && (prop in arg)) || (isArgObj && objHasOwn(arg, prop));
            if (!propOk) {
                continue;
            }
            var newValue = arg[prop];
            var isNewArray = void 0;
            // If deep merge and property is an object, merge properties
            if (deep && newValue && ((isNewArray = isArray(newValue)) || isPlainObject(newValue))) {
                // Grab the current value of the extended object
                var clone = extended[prop];
                if (isNewArray) {
                    if (!isArray(clone)) {
                        // We can't "merge" an array with a non-array so overwrite the original
                        clone = [];
                    }
                }
                else if (!isPlainObject(clone)) {
                    // We can't "merge" an object with a non-object
                    clone = {};
                }
                // Never move the original objects always clone them
                newValue = objExtend(deep, clone, newValue);
            }
            // Assign the new (or previous) value (unless undefined)
            if (newValue !== undefined) {
                extended[prop] = newValue;
            }
        }
    }
    return extended;
}
function isFeatureEnabled(feature, cfg) {
    var rlt = false;
    var ft = cfg && cfg.featureOptIn && cfg.featureOptIn[feature];
    if (feature && ft) {
        var mode = ft.mode;
        // NOTE: None will be considered as true
        rlt = (mode == 3 /* FeatureOptInMode.enable */) || (mode == 1 /* FeatureOptInMode.none */);
    }
    return rlt;
}
function getResponseText(xhr) {
    try {
        return xhr.responseText;
    }
    catch (e) {
        // Best effort, as XHR may throw while XDR wont so just ignore
    }
    return null;
}
function formatErrorMessageXdr(xdr, message) {
    if (xdr) {
        return "XDomainRequest,Response:" + getResponseText(xdr) || "";
    }
    return message;
}
function formatErrorMessageXhr(xhr, message) {
    if (xhr) {
        return "XMLHttpRequest,Status:" + xhr[_DYN_STATUS$1 /* @min:%2estatus */] + ",Response:" + getResponseText(xhr) || xhr.response || "";
    }
    return message;
}
function prependTransports(theTransports, newTransports) {
    if (newTransports) {
        if (isNumber(newTransports)) {
            theTransports = [newTransports].concat(theTransports);
        }
        else if (isArray(newTransports)) {
            theTransports = newTransports.concat(theTransports);
        }
    }
    return theTransports;
}
var strDisabledPropertyName = "Microsoft_ApplicationInsights_BypassAjaxInstrumentation";
var strWithCredentials = "withCredentials";
var strTimeout = "timeout";
/**
 * Create and open an XMLHttpRequest object
 * @param method - The request method
 * @param urlString - The url
 * @param withCredentials - Option flag indicating that credentials should be sent
 * @param disabled - Optional flag indicating that the XHR object should be marked as disabled and not tracked (default is false)
 * @param isSync - Optional flag indicating if the instance should be a synchronous request (defaults to false)
 * @param timeout - Optional value identifying the timeout value that should be assigned to the XHR request
 * @returns A new opened XHR request
 */
function openXhr(method, urlString, withCredentials, disabled, isSync, timeout) {
    if (disabled === void 0) { disabled = false; }
    if (isSync === void 0) { isSync = false; }
    function _wrapSetXhrProp(xhr, prop, value) {
        try {
            xhr[prop] = value;
        }
        catch (e) {
            // - Wrapping as depending on the environment setting the property may fail (non-terminally)
        }
    }
    var xhr = new XMLHttpRequest();
    if (disabled) {
        // Tag the instance so it's not tracked (trackDependency)
        // If the environment has locked down the XMLHttpRequest (preventExtensions and/or freeze), this would
        // cause the request to fail and we no telemetry would be sent
        _wrapSetXhrProp(xhr, strDisabledPropertyName, disabled);
    }
    if (withCredentials) {
        // Some libraries require that the withCredentials flag is set "before" open and
        // - Wrapping as IE 10 has started throwing when setting before open
        _wrapSetXhrProp(xhr, strWithCredentials, withCredentials);
    }
    xhr.open(method, urlString, !isSync);
    if (withCredentials) {
        // withCredentials should be set AFTER open (https://xhr.spec.whatwg.org/#the-withcredentials-attribute)
        // And older firefox instances from 11+ will throw for sync events (current versions don't) which happens during unload processing
        _wrapSetXhrProp(xhr, strWithCredentials, withCredentials);
    }
    // Only set the timeout for asynchronous requests as
    // "Timeout shouldn't be used for synchronous XMLHttpRequests requests used in a document environment or it will throw an InvalidAccessError exception.""
    // https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/timeout
    if (!isSync && timeout) {
        _wrapSetXhrProp(xhr, strTimeout, timeout);
    }
    return xhr;
}
/**
* Converts the XHR getAllResponseHeaders to a map containing the header key and value.
* @internal
*/
// tslint:disable-next-line: align
function convertAllHeadersToMap(headersString) {
    var headers = {};
    if (isString(headersString)) {
        var headersArray = strTrim(headersString)[_DYN_SPLIT$1 /* @min:%2esplit */](/[\r\n]+/);
        arrForEach(headersArray, function (headerEntry) {
            if (headerEntry) {
                var idx = headerEntry.indexOf(": ");
                if (idx !== -1) {
                    // The new spec has the headers returning all as lowercase -- but not all browsers do this yet
                    var header = strTrim(headerEntry.substring(0, idx))[_DYN_TO_LOWER_CASE$2 /* @min:%2etoLowerCase */]();
                    var value = strTrim(headerEntry.substring(idx + 1));
                    headers[header] = value;
                }
                else {
                    headers[strTrim(headerEntry)] = 1;
                }
            }
        });
    }
    return headers;
}
/**
* append the XHR headers.
* @internal
*/
function _appendHeader(theHeaders, xhr, name) {
    if (!theHeaders[name] && xhr && xhr[_DYN_GET_RESPONSE_HEADER /* @min:%2egetResponseHeader */]) {
        var value = xhr[_DYN_GET_RESPONSE_HEADER /* @min:%2egetResponseHeader */](name);
        if (value) {
            theHeaders[name] = strTrim(value);
        }
    }
    return theHeaders;
}
var STR_KILL_DURATION_HEADER = "kill-duration";
var STR_KILL_DURATION_SECONDS_HEADER = "kill-duration-seconds";
var STR_TIME_DELTA_HEADER = "time-delta-millis";
/**
* get the XHR getAllResponseHeaders.
* @internal
*/
function _getAllResponseHeaders(xhr, isOneDs) {
    var theHeaders = {};
    if (!xhr[_DYN_GET_ALL_RESPONSE_HEA5 /* @min:%2egetAllResponseHeaders */]) {
        // Firefox 2-63 doesn't have getAllResponseHeaders function but it does have getResponseHeader
        // Only call these if getAllResponseHeaders doesn't exist, otherwise we can get invalid response errors
        // as collector is not currently returning the correct header to allow JS to access these headers
        if (!!isOneDs) {
            theHeaders = _appendHeader(theHeaders, xhr, STR_TIME_DELTA_HEADER);
            theHeaders = _appendHeader(theHeaders, xhr, STR_KILL_DURATION_HEADER);
            theHeaders = _appendHeader(theHeaders, xhr, STR_KILL_DURATION_SECONDS_HEADER);
        }
    }
    else {
        theHeaders = convertAllHeadersToMap(xhr[_DYN_GET_ALL_RESPONSE_HEA5 /* @min:%2egetAllResponseHeaders */]());
    }
    return theHeaders;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * This file exists to hold environment utilities that are required to check and
 * validate the current operating environment. Unless otherwise required, please
 * only use defined methods (functions) in this class so that users of these
 * functions/properties only need to include those that are used within their own modules.
 */
var strDocumentMode = "documentMode";
var strLocation = "location";
var strConsole = "console";
var strJSON = "JSON";
var strCrypto = "crypto";
var strMsCrypto = "msCrypto";
var strReactNative = "ReactNative";
var strMsie = "msie";
var strTrident = "trident/";
var strXMLHttpRequest = "XMLHttpRequest";
var _isTrident = null;
var _navUserAgentCheck = null;
var _enableMocks = false;
var _useXDomainRequest = null;
var _beaconsSupported = null;
function _hasProperty(theClass, property) {
    var supported = false;
    if (theClass) {
        try {
            supported = property in theClass;
            if (!supported) {
                var proto = theClass[strShimPrototype];
                if (proto) {
                    supported = property in proto;
                }
            }
        }
        catch (e) {
            // Do Nothing
        }
        if (!supported) {
            try {
                var tmp = new theClass();
                supported = !isUndefined(tmp[property]);
            }
            catch (e) {
                // Do Nothing
            }
        }
    }
    return supported;
}
/**
 * Returns the global location object if it is present otherwise null.
 * This helper is used to access the location object without causing an exception
 * "Uncaught ReferenceError: location is not defined"
 */
function getLocation(checkForMock) {
    if (checkForMock && _enableMocks) {
        var mockLocation = getInst("__mockLocation");
        if (mockLocation) {
            return mockLocation;
        }
    }
    if (typeof location === strShimObject && location) {
        return location;
    }
    return getInst(strLocation);
}
/**
 * Returns the global console object
 */
function getConsole() {
    if (typeof console !== strShimUndefined) {
        return console;
    }
    return getInst(strConsole);
}
/**
 * Checks if JSON object is available, this is required as we support the API running without a
 * window /document (eg. Node server, electron webworkers) and if we attempt to assign a history
 * object to a local variable or pass as an argument an "Uncaught ReferenceError: JSON is not defined"
 * exception will be thrown.
 * Defined as a function to support lazy / late binding environments.
 */
function hasJSON() {
    return Boolean((typeof JSON === strShimObject && JSON) || getInst(strJSON) !== null);
}
/**
 * Returns the global JSON object if it is present otherwise null.
 * This helper is used to access the JSON object without causing an exception
 * "Uncaught ReferenceError: JSON is not defined"
 */
function getJSON() {
    if (hasJSON()) {
        return JSON || getInst(strJSON);
    }
    return null;
}
/**
 * Returns the crypto object if it is present otherwise null.
 * This helper is used to access the crypto object from the current
 * global instance which could be window or globalThis for a web worker
 */
function getCrypto() {
    return getInst(strCrypto);
}
/**
 * Returns the crypto object if it is present otherwise null.
 * This helper is used to access the crypto object from the current
 * global instance which could be window or globalThis for a web worker
 */
function getMsCrypto() {
    return getInst(strMsCrypto);
}
/**
 * Returns whether the environment is reporting that we are running in a React Native Environment
 */
function isReactNative() {
    // If running in React Native, navigator.product will be populated
    var nav = getNavigator();
    if (nav && nav.product) {
        return nav.product === strReactNative;
    }
    return false;
}
/**
 * Identifies whether the current environment appears to be IE
 */
function isIE() {
    var nav = getNavigator();
    if (nav && (nav[_DYN_USER_AGENT /* @min:%2euserAgent */] !== _navUserAgentCheck || _isTrident === null)) {
        // Added to support test mocking of the user agent
        _navUserAgentCheck = nav[_DYN_USER_AGENT /* @min:%2euserAgent */];
        var userAgent = (_navUserAgentCheck || STR_EMPTY$1)[_DYN_TO_LOWER_CASE$2 /* @min:%2etoLowerCase */]();
        _isTrident = (strContains(userAgent, strMsie) || strContains(userAgent, strTrident));
    }
    return _isTrident;
}
/**
 * Gets IE version returning the document emulation mode if we are running on IE, or null otherwise
 */
function getIEVersion(userAgentStr) {
    if (userAgentStr === void 0) { userAgentStr = null; }
    if (!userAgentStr) {
        var navigator_1 = getNavigator() || {};
        userAgentStr = navigator_1 ? (navigator_1.userAgent || STR_EMPTY$1)[_DYN_TO_LOWER_CASE$2 /* @min:%2etoLowerCase */]() : STR_EMPTY$1;
    }
    var ua = (userAgentStr || STR_EMPTY$1)[_DYN_TO_LOWER_CASE$2 /* @min:%2etoLowerCase */]();
    // Also check for documentMode in case X-UA-Compatible meta tag was included in HTML.
    if (strContains(ua, strMsie)) {
        var doc = getDocument() || {};
        return Math.max(parseInt(ua[_DYN_SPLIT$1 /* @min:%2esplit */](strMsie)[1]), (doc[strDocumentMode] || 0));
    }
    else if (strContains(ua, strTrident)) {
        var tridentVer = parseInt(ua[_DYN_SPLIT$1 /* @min:%2esplit */](strTrident)[1]);
        if (tridentVer) {
            return tridentVer + 4;
        }
    }
    return null;
}
/**
 * Checks if HTML5 Beacons are supported in the current environment.
 * @param useCached - [Optional] used for testing to bypass the cached lookup, when `true` this will
 * cause the cached global to be reset.
 * @returns True if supported, false otherwise.
 */
function isBeaconsSupported(useCached) {
    if (_beaconsSupported === null || useCached === false) {
        _beaconsSupported = hasNavigator() && Boolean(getNavigator().sendBeacon);
    }
    return _beaconsSupported;
}
/**
 * Checks if the Fetch API is supported in the current environment.
 * @param withKeepAlive - [Optional] If True, check if fetch is available and it supports the keepalive feature, otherwise only check if fetch is supported
 * @returns True if supported, otherwise false
 */
function isFetchSupported(withKeepAlive) {
    var isSupported = false;
    try {
        isSupported = !!getInst("fetch");
        var request = getInst("Request");
        if (isSupported && withKeepAlive && request) {
            isSupported = _hasProperty(request, "keepalive");
        }
    }
    catch (e) {
        // Just Swallow any failure during availability checks
    }
    return isSupported;
}
function useXDomainRequest() {
    if (_useXDomainRequest === null) {
        _useXDomainRequest = (typeof XDomainRequest !== strShimUndefined);
        if (_useXDomainRequest && isXhrSupported()) {
            _useXDomainRequest = _useXDomainRequest && !_hasProperty(getInst(strXMLHttpRequest), "withCredentials");
        }
    }
    return _useXDomainRequest;
}
/**
 * Checks if XMLHttpRequest is supported
 * @returns True if supported, otherwise false
 */
function isXhrSupported() {
    var isSupported = false;
    try {
        var xmlHttpRequest = getInst(strXMLHttpRequest);
        isSupported = !!xmlHttpRequest;
    }
    catch (e) {
        // Just Swallow any failure during availability checks
    }
    return isSupported;
}
// TODO: should reuse this method for analytics plugin
function dispatchEvent(target, evnt) {
    if (target && target.dispatchEvent && evnt) {
        target.dispatchEvent(evnt);
        return true;
    }
    return false;
}
function createCustomDomEvent(eventName, details) {
    var event = null;
    var detail = { detail: details || null };
    if (isFunction(CustomEvent)) { // Use CustomEvent constructor when available
        event = new CustomEvent(eventName, detail);
    }
    else { // CustomEvent has no constructor in IE
        var doc = getDocument();
        if (doc && doc.createEvent) {
            event = doc.createEvent("CustomEvent");
            event.initCustomEvent(eventName, true, true, detail);
        }
    }
    return event;
}
function sendCustomEvent(evtName, cfg, customDetails) {
    var global = getGlobal();
    if (global && global.CustomEvent) {
        try {
            var details = { cfg: cfg || null, customDetails: customDetails || null };
            return dispatchEvent(global, createCustomDomEvent(evtName, details));
        }
        catch (e) {
            // eslint-disable-next-line no-empty
        }
    }
    return false;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var UInt32Mask = 0x100000000;
var MaxUInt32 = 0xffffffff;
var SEED1 = 123456789;
var SEED2 = 987654321;
// MWC based Random generator (for IE)
var _mwcSeeded = false;
var _mwcW = SEED1;
var _mwcZ = SEED2;
// Takes any integer
function _mwcSeed(seedValue) {
    if (seedValue < 0) {
        // Make sure we end up with a positive number and not -ve one.
        seedValue >>>= 0;
    }
    _mwcW = (SEED1 + seedValue) & MaxUInt32;
    _mwcZ = (SEED2 - seedValue) & MaxUInt32;
    _mwcSeeded = true;
}
function _autoSeedMwc() {
    // Simple initialization using default Math.random() - So we inherit any entropy from the browser
    // and bitwise XOR with the current milliseconds
    try {
        var now = utcNow() & 0x7fffffff;
        _mwcSeed(((Math.random() * UInt32Mask) ^ now) + now);
    }
    catch (e) {
        // Don't crash if something goes wrong
    }
}
/**
 * Generate a random value between 0 and maxValue, max value should be limited to a 32-bit maximum.
 * So maxValue(16) will produce a number from 0..16 (range of 17)
 * @param maxValue
 */
function randomValue(maxValue) {
    if (maxValue > 0) {
        return Math.floor((random32() / MaxUInt32) * (maxValue + 1)) >>> 0;
    }
    return 0;
}
/**
 * generate a random 32-bit number (0x000000..0xFFFFFFFF) or (-0x80000000..0x7FFFFFFF), defaults un-unsigned.
 * @param signed - True to return a signed 32-bit number (-0x80000000..0x7FFFFFFF) otherwise an unsigned one (0x000000..0xFFFFFFFF)
 */
function random32(signed) {
    var value = 0;
    var c = getCrypto() || getMsCrypto();
    if (c && c.getRandomValues) {
        // Make sure the number is converted into the specified range (-0x80000000..0x7FFFFFFF)
        value = c.getRandomValues(new Uint32Array(1))[0] & MaxUInt32;
    }
    if (value === 0 && isIE()) {
        // For IE 6, 7, 8 (especially on XP) Math.random is not very random
        if (!_mwcSeeded) {
            // Set the seed for the Mwc algorithm
            _autoSeedMwc();
        }
        // Don't use Math.random for IE
        // Make sure the number is converted into the specified range (-0x80000000..0x7FFFFFFF)
        value = mwcRandom32() & MaxUInt32;
    }
    if (value === 0) {
        // Make sure the number is converted into the specified range (-0x80000000..0x7FFFFFFF)
        value = Math.floor((UInt32Mask * Math.random()) | 0);
    }
    if (!signed) {
        // Make sure we end up with a positive number and not -ve one.
        value >>>= 0;
    }
    return value;
}
/**
 * Generate a random 32-bit number between (0x000000..0xFFFFFFFF) or (-0x80000000..0x7FFFFFFF), using MWC (Multiply with carry)
 * instead of Math.random() defaults to un-signed.
 * Used as a replacement random generator for IE to avoid issues with older IE instances.
 * @param signed - True to return a signed 32-bit number (-0x80000000..0x7FFFFFFF) otherwise an unsigned one (0x000000..0xFFFFFFFF)
 */
function mwcRandom32(signed) {
    _mwcZ = (36969 * (_mwcZ & 0xFFFF) + (_mwcZ >> 16)) & MaxUInt32;
    _mwcW = (18000 * (_mwcW & 0xFFFF) + (_mwcW >> 16)) & MaxUInt32;
    var value = (((_mwcZ << 16) + (_mwcW & 0xFFFF)) >>> 0) & MaxUInt32 | 0;
    if (!signed) {
        // Make sure we end up with a positive number and not -ve one.
        value >>>= 0;
    }
    return value;
}
/**
 * Generate random base64 id string.
 * The default length is 22 which is 132-bits so almost the same as a GUID but as base64 (the previous default was 5)
 * @param maxLength - Optional value to specify the length of the id to be generated, defaults to 22
 */
function newId(maxLength) {
    if (maxLength === void 0) { maxLength = 22; }
    var base64chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    // Start with an initial random number, consuming the value in reverse byte order
    var number = random32() >>> 0; // Make sure it's a +ve number
    var chars = 0;
    var result = STR_EMPTY$1;
    while (result[_DYN_LENGTH$5 /* @min:%2elength */] < maxLength) {
        chars++;
        result += base64chars.charAt(number & 0x3F);
        number >>>= 6; // Zero fill with right shift
        if (chars === 5) {
            // 5 base64 characters === 30 bits so we don't have enough bits for another base64 char
            // So add on another 30 bits and make sure it's +ve
            number = (((random32() << 2) & 0xFFFFFFFF) | (number & 0x03)) >>> 0;
            chars = 0; // We need to reset the number every 5 chars (30 bits)
        }
    }
    return result;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var version$2 = '3.3.0';
var instanceName = "." + newId(6);
var _dataUid = 0;
// Accepts only:
//  - Node
//    - Node.ELEMENT_NODE
//    - Node.DOCUMENT_NODE
//  - Object
//    - Any
function _canAcceptData(target) {
    return target[_DYN_NODE_TYPE /* @min:%2enodeType */] === 1 || target[_DYN_NODE_TYPE /* @min:%2enodeType */] === 9 || !(+target[_DYN_NODE_TYPE /* @min:%2enodeType */]);
}
function _getCache(data, target) {
    var theCache = target[data.id];
    if (!theCache) {
        theCache = {};
        try {
            if (_canAcceptData(target)) {
                objDefine(target, data.id, {
                    e: false,
                    v: theCache
                });
            }
        }
        catch (e) {
            // Not all environments allow extending all objects, so just ignore the cache in those cases
        }
    }
    return theCache;
}
function createUniqueNamespace(name, includeVersion) {
    if (includeVersion === void 0) { includeVersion = false; }
    return normalizeJsName(name + (_dataUid++) + (includeVersion ? "." + version$2 : STR_EMPTY$1) + instanceName);
}
function createElmNodeData(name) {
    var data = {
        id: createUniqueNamespace("_aiData-" + (name || STR_EMPTY$1) + "." + version$2),
        accept: function (target) {
            return _canAcceptData(target);
        },
        get: function (target, name, defValue, addDefault) {
            var theCache = target[data.id];
            if (!theCache) {
                if (addDefault) {
                    // Side effect is adds the cache
                    theCache = _getCache(data, target);
                    theCache[normalizeJsName(name)] = defValue;
                }
                return defValue;
            }
            return theCache[normalizeJsName(name)];
        },
        kill: function (target, name) {
            if (target && target[name]) {
                try {
                    delete target[name];
                }
                catch (e) {
                    // Just cleaning up, so if this fails -- ignore
                }
            }
        }
    };
    return data;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

function _isConfigDefaults(value) {
    return (value && isObject(value) && (value.isVal || value.fb || objHasOwn(value, "v") || objHasOwn(value, "mrg") || objHasOwn(value, "ref") || value.set));
}
function _getDefault(dynamicHandler, theConfig, cfgDefaults) {
    var defValue;
    var isDefaultValid = cfgDefaults.dfVal || isDefined;
    // There is a fallback config key so try and grab that first
    if (theConfig && cfgDefaults.fb) {
        var fallbacks = cfgDefaults.fb;
        if (!isArray(fallbacks)) {
            fallbacks = [fallbacks];
        }
        for (var lp = 0; lp < fallbacks[_DYN_LENGTH$5 /* @min:%2elength */]; lp++) {
            var fallback = fallbacks[lp];
            var fbValue = theConfig[fallback];
            if (isDefaultValid(fbValue)) {
                defValue = fbValue;
            }
            else if (dynamicHandler) {
                // Needed to ensure that the fallback value (and potentially) new field is also dynamic even if null/undefined
                fbValue = dynamicHandler.cfg[fallback];
                if (isDefaultValid(fbValue)) {
                    defValue = fbValue;
                }
                // Needed to ensure that the fallback value (and potentially) new field is also dynamic even if null/undefined
                dynamicHandler.set(dynamicHandler.cfg, asString(fallback), fbValue);
            }
            if (isDefaultValid(defValue)) {
                // We have a valid default so break out of the look
                break;
            }
        }
    }
    // If the value is still not defined and we have a default value then use that
    if (!isDefaultValid(defValue) && isDefaultValid(cfgDefaults.v)) {
        defValue = cfgDefaults.v;
    }
    return defValue;
}
/**
 * Recursively resolve the default value
 * @param dynamicHandler
 * @param theConfig
 * @param cfgDefaults
 * @returns
 */
function _resolveDefaultValue(dynamicHandler, theConfig, cfgDefaults) {
    var theValue = cfgDefaults;
    if (cfgDefaults && _isConfigDefaults(cfgDefaults)) {
        theValue = _getDefault(dynamicHandler, theConfig, cfgDefaults);
    }
    if (theValue) {
        if (_isConfigDefaults(theValue)) {
            theValue = _resolveDefaultValue(dynamicHandler, theConfig, theValue);
        }
        var newValue_1;
        if (isArray(theValue)) {
            newValue_1 = [];
            newValue_1[_DYN_LENGTH$5 /* @min:%2elength */] = theValue[_DYN_LENGTH$5 /* @min:%2elength */];
        }
        else if (isPlainObject(theValue)) {
            newValue_1 = {};
        }
        if (newValue_1) {
            objForEachKey(theValue, function (key, value) {
                if (value && _isConfigDefaults(value)) {
                    value = _resolveDefaultValue(dynamicHandler, theConfig, value);
                }
                newValue_1[key] = value;
            });
            theValue = newValue_1;
        }
    }
    return theValue;
}
/**
 * Applies the default value on the config property and makes sure that it's dynamic
 * @param theConfig
 * @param name
 * @param defaultValue
 */
function _applyDefaultValue(dynamicHandler, theConfig, name, defaultValue) {
    // Resolve the initial config value from the provided value or use the defined default
    var isValid;
    var setFn;
    var defValue;
    var cfgDefaults = defaultValue;
    var mergeDf;
    var reference;
    var readOnly;
    var blkDynamicValue;
    if (_isConfigDefaults(cfgDefaults)) {
        // looks like a IConfigDefault
        isValid = cfgDefaults.isVal;
        setFn = cfgDefaults.set;
        readOnly = cfgDefaults[_DYN_RD_ONLY /* @min:%2erdOnly */];
        blkDynamicValue = cfgDefaults[_DYN_BLK_VAL /* @min:%2eblkVal */];
        mergeDf = cfgDefaults.mrg;
        reference = cfgDefaults.ref;
        if (!reference && isUndefined(reference)) {
            reference = !!mergeDf;
        }
        defValue = _getDefault(dynamicHandler, theConfig, cfgDefaults);
    }
    else {
        defValue = defaultValue;
    }
    if (blkDynamicValue) {
        // Mark the property so that any value assigned will be blocked from conversion, we need to do this
        // before assigning or fetching the value to ensure it's not converted
        dynamicHandler[_DYN_BLK_VAL /* @min:%2eblkVal */](theConfig, name);
    }
    // Set the value to the default value;
    var theValue;
    var usingDefault = true;
    var cfgValue = theConfig[name];
    // try and get and user provided values
    if (cfgValue || !isNullOrUndefined(cfgValue)) {
        // Use the defined theConfig[name] value
        theValue = cfgValue;
        usingDefault = false;
        // The values are different and we have a special default value check, which is used to
        // override config values like empty strings to continue using the default
        if (isValid && theValue !== defValue && !isValid(theValue)) {
            theValue = defValue;
            usingDefault = true;
        }
        if (setFn) {
            theValue = setFn(theValue, defValue, theConfig);
            usingDefault = theValue === defValue;
        }
    }
    if (!usingDefault) {
        if (isPlainObject(theValue) || isArray(defValue)) {
            // we are using the user supplied value and it's an object
            if (mergeDf && defValue && (isPlainObject(defValue) || isArray(defValue))) {
                // Resolve/apply the defaults
                objForEachKey(defValue, function (dfName, dfValue) {
                    // Sets the value and makes it dynamic (if it doesn't already exist)
                    _applyDefaultValue(dynamicHandler, theValue, dfName, dfValue);
                });
            }
        }
    }
    else if (defValue) {
        // Just resolve the default
        theValue = _resolveDefaultValue(dynamicHandler, theConfig, defValue);
    }
    else {
        theValue = defValue;
    }
    // if (theValue && usingDefault && (isPlainObject(theValue) || isArray(theValue))) {
    //     theValue = _cfgDeepCopy(theValue);
    // }
    // Needed to ensure that the (potentially) new field is dynamic even if null/undefined
    dynamicHandler.set(theConfig, name, theValue);
    if (reference) {
        dynamicHandler.ref(theConfig, name);
    }
    if (readOnly) {
        dynamicHandler[_DYN_RD_ONLY /* @min:%2erdOnly */](theConfig, name);
    }
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

// Using Symbol.for so that if the same symbol was already created it would be returned
// To handle multiple instances using potentially different versions we are not using
// createUniqueNamespace()
var CFG_HANDLER_LINK = symbolFor("[[ai_dynCfg_1]]");
/**
 * @internal
 * @ignore
 * The symbol to tag objects / arrays with if they should not be converted
 */
var BLOCK_DYNAMIC = symbolFor("[[ai_blkDynCfg_1]]");
/**
 * @internal
 * @ignore
 * The symbol to tag objects to indicate that when included into the configuration that
 * they should be converted into a trackable dynamic object.
 */
var FORCE_DYNAMIC = symbolFor("[[ai_frcDynCfg_1]]");
function _cfgDeepCopy(source) {
    if (source) {
        var target_1;
        if (isArray(source)) {
            target_1 = [];
            target_1[_DYN_LENGTH$5 /* @min:%2elength */] = source[_DYN_LENGTH$5 /* @min:%2elength */];
        }
        else if (isPlainObject(source)) {
            target_1 = {};
        }
        if (target_1) {
            // Copying index values by property name as the extensionConfig can be an array or object
            objForEachKey(source, function (key, value) {
                // Perform a deep copy of the object
                target_1[key] = _cfgDeepCopy(value);
            });
            return target_1;
        }
    }
    return source;
}
/**
 * @internal
 * Get the dynamic config handler if the value is already dynamic
 * @param value
 * @returns
 */
function getDynamicConfigHandler(value) {
    if (value) {
        var handler = value[CFG_HANDLER_LINK] || value;
        if (handler.cfg && (handler.cfg === value || handler.cfg[CFG_HANDLER_LINK] === handler)) {
            return handler;
        }
    }
    return null;
}
/**
 * Mark the provided value so that if it's included into the configuration it will NOT have
 * its properties converted into a dynamic (reactive) object. If the object is not a plain object
 * or an array (ie. a class) this function has not affect as only Objects and Arrays are converted
 * into dynamic objects in the dynamic configuration.
 *
 * When you have tagged a value as both {@link forceDynamicConversion} and blocked force will take precedence.
 *
 * You should only need to use this function, if you are creating dynamic "classes" from objects
 * which confirm to the require interface. A common case for this is during unit testing where it's
 * easier to create mock extensions.
 *
 * If `value` is falsy (null / undefined / 0 / empty string etc) it will not be tagged and
 * if there is an exception adding the property to the value (because its frozen etc) the
 * exception will be swallowed
 *
 * @example
 * ```ts
 * // This is a valid "extension", but it is technically an object
 * // So when included in the config.extensions it WILL be cloned and then
 * // converted into a dynamic object, where all of its properties will become
 * // get/set object properties and will be tracked. While this WILL still
 * // function, when attempt to use a mocking framework on top of this the
 * // functions are now technically get accessors which return a function
 * // and this can cause some mocking frameworks to fail.
 * let mockChannel = {
 *      pause: () => { },
*      resume: () => { },
*      teardown: () => { },
*      flush: (async: any, callBack: any) => { },
*      processTelemetry: (env: any) => { },
*      setNextPlugin: (next: any) => { },
*      initialize: (config: any, core: any, extensions: any) => { },
*      identifier: "testChannel",
*      priority: 1003
* };
 * ```
 * @param value - The object that you want to block from being converted into a
 * trackable dynamic object
 * @returns The original value
 */
function blockDynamicConversion(value) {
    if (value && (isPlainObject(value) || isArray(value))) {
        try {
            value[BLOCK_DYNAMIC] = true;
        }
        catch (e) {
            // Don't throw for this case as it's an ask only
        }
    }
    return value;
}
/**
 * @internal
 * @ignore
 * Helper function to check whether an object can or should be converted into a dynamic
 * object.
 * @param value - The object to check whether it should be converted
 * @returns `true` if the value should be converted otherwise `false`.
 */
function _canMakeDynamic(getFunc, state, value) {
    var result = false;
    // Object must exist and be truthy
    if (value && !getFunc[state.blkVal]) {
        // Tagged as always convert
        result = value[FORCE_DYNAMIC];
        // Check that it's not explicitly tagged as blocked
        if (!result && !value[BLOCK_DYNAMIC]) {
            // Only convert plain objects or arrays by default
            result = isPlainObject(value) || isArray(value);
        }
    }
    return result;
}
/**
 * Throws an invalid access exception
 * @param message - The message to include in the exception
 */
function throwInvalidAccess(message) {
    throwTypeError("InvalidAccess:" + message);
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var arrayMethodsToPatch = [
    "push",
    "pop",
    "shift",
    "unshift",
    "splice"
];
var _throwDynamicError = function (logger, name, desc, e) {
    logger && logger[_DYN_THROW_INTERNAL /* @min:%2ethrowInternal */](3 /* eLoggingSeverity.DEBUG */, 108 /* _eInternalMessageId.DynamicConfigException */, "".concat(desc, " [").concat(name, "] failed - ") + dumpObj(e));
};
function _patchArray(state, target, name) {
    if (isArray(target)) {
        // Monkey Patch the methods that might change the array
        arrForEach(arrayMethodsToPatch, function (method) {
            var orgMethod = target[method];
            target[method] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var result = orgMethod[_DYN_APPLY /* @min:%2eapply */](this, args);
                // items may be added, removed or moved so need to make some new dynamic properties
                _makeDynamicObject(state, target, name, "Patching");
                return result;
            };
        });
    }
}
function _getOwnPropGetter(target, name) {
    var propDesc = objGetOwnPropertyDescriptor(target, name);
    return propDesc && propDesc.get;
}
function _createDynamicProperty(state, theConfig, name, value) {
    // Does not appear to be dynamic so lets make it so
    var detail = {
        n: name,
        h: [],
        trk: function (handler) {
            if (handler && handler.fn) {
                if (arrIndexOf(detail.h, handler) === -1) {
                    // Add this handler to the collection that should be notified when the value changes
                    detail.h[_DYN_PUSH$2 /* @min:%2epush */](handler);
                }
                state.trk(handler, detail);
            }
        },
        clr: function (handler) {
            var idx = arrIndexOf(detail.h, handler);
            if (idx !== -1) {
                detail.h[_DYN_SPLICE /* @min:%2esplice */](idx, 1);
            }
        }
    };
    // Flag to optimize lookup response time by avoiding additional function calls
    var checkDynamic = true;
    var isObjectOrArray = false;
    function _getProperty() {
        if (checkDynamic) {
            isObjectOrArray = isObjectOrArray || _canMakeDynamic(_getProperty, state, value);
            // Make sure that if it's an object that we make it dynamic
            if (value && !value[CFG_HANDLER_LINK] && isObjectOrArray) {
                // It doesn't look like it's already dynamic so lets make sure it's converted the object into a dynamic Config as well
                value = _makeDynamicObject(state, value, name, "Converting");
            }
            // If it needed to be converted it now has been
            checkDynamic = false;
        }
        // If there is an active handler then add it to the tracking set of handlers
        var activeHandler = state.act;
        if (activeHandler) {
            detail.trk(activeHandler);
        }
        return value;
    }
    // Tag this getter as our dynamic property and provide shortcut for notifying a change
    _getProperty[state.prop] = {
        chng: function () {
            state.add(detail);
        }
    };
    function _setProperty(newValue) {
        if (value !== newValue) {
            if (!!_getProperty[state.ro] && !state.upd) {
                // field is marked as readonly so return false
                throwInvalidAccess("[" + name + "] is read-only:" + dumpObj(theConfig));
            }
            if (checkDynamic) {
                isObjectOrArray = isObjectOrArray || _canMakeDynamic(_getProperty, state, value);
                checkDynamic = false;
            }
            // The value must be a plain object or an array to enforce the reference (in-place updates)
            var isReferenced = isObjectOrArray && _getProperty[state.rf];
            if (isObjectOrArray) {
                // We are about to replace a plain object or an array
                if (isReferenced) {
                    // Reassign the properties from the current value to the same properties from the newValue
                    // This will set properties not in the newValue to undefined
                    objForEachKey(value, function (key) {
                        value[key] = newValue ? newValue[key] : UNDEFINED_VALUE$2;
                    });
                    // Now assign / re-assign value with all of the keys from newValue
                    try {
                        objForEachKey(newValue, function (key, theValue) {
                            _setDynamicProperty(state, value, key, theValue);
                        });
                        // Now drop newValue so when we assign value later it keeps the existing reference
                        newValue = value;
                    }
                    catch (e) {
                        // Unable to convert to dynamic property so just leave as non-dynamic
                        _throwDynamicError((state.hdlr || {})[_DYN_LOGGER /* @min:%2elogger */], name, "Assigning", e);
                        // Mark as not an object or array so we don't try and do this again
                        isObjectOrArray = false;
                    }
                }
                else if (value && value[CFG_HANDLER_LINK]) {
                    // As we are replacing the value, if it's already dynamic then we need to notify the listeners
                    // for every property it has already
                    objForEachKey(value, function (key) {
                        // Check if the value is dynamic
                        var getter = _getOwnPropGetter(value, key);
                        if (getter) {
                            // And if it is tell it's listeners that the value has changed
                            var valueState = getter[state.prop];
                            valueState && valueState.chng();
                        }
                    });
                }
            }
            if (newValue !== value) {
                var newIsObjectOrArray = newValue && _canMakeDynamic(_getProperty, state, newValue);
                if (!isReferenced && newIsObjectOrArray) {
                    // As the newValue is an object/array lets preemptively make it dynamic
                    newValue = _makeDynamicObject(state, newValue, name, "Converting");
                }
                // Now assign the internal "value" to the newValue
                value = newValue;
                isObjectOrArray = newIsObjectOrArray;
            }
            // Cause any listeners to be scheduled for notification
            state.add(detail);
        }
    }
    objDefine(theConfig, detail.n, { g: _getProperty, s: _setProperty });
}
function _setDynamicProperty(state, target, name, value) {
    if (target) {
        // To be a dynamic property it needs to have a get function
        var getter = _getOwnPropGetter(target, name);
        var isDynamic = getter && !!getter[state.prop];
        if (!isDynamic) {
            _createDynamicProperty(state, target, name, value);
        }
        else {
            // Looks like it's already dynamic just assign the new value
            target[name] = value;
        }
    }
    return target;
}
function _setDynamicPropertyState(state, target, name, flags) {
    if (target) {
        // To be a dynamic property it needs to have a get function
        var getter = _getOwnPropGetter(target, name);
        var isDynamic = getter && !!getter[state.prop];
        var inPlace = flags && flags[0 /* _eSetDynamicPropertyFlags.inPlace */];
        var rdOnly = flags && flags[1 /* _eSetDynamicPropertyFlags.readOnly */];
        var blkProp = flags && flags[2 /* _eSetDynamicPropertyFlags.blockDynamicProperty */];
        if (!isDynamic) {
            if (blkProp) {
                try {
                    // Attempt to mark the target as blocked from conversion
                    blockDynamicConversion(target);
                }
                catch (e) {
                    _throwDynamicError((state.hdlr || {})[_DYN_LOGGER /* @min:%2elogger */], name, "Blocking", e);
                }
            }
            try {
                // Make sure it's dynamic so that we can tag the property as per the state
                _setDynamicProperty(state, target, name, target[name]);
                getter = _getOwnPropGetter(target, name);
            }
            catch (e) {
                // Unable to convert to dynamic property so just leave as non-dynamic
                _throwDynamicError((state.hdlr || {})[_DYN_LOGGER /* @min:%2elogger */], name, "State", e);
            }
        }
        // Assign the optional flags if true
        if (inPlace) {
            getter[state.rf] = inPlace;
        }
        if (rdOnly) {
            getter[state.ro] = rdOnly;
        }
        if (blkProp) {
            getter[state.blkVal] = true;
        }
    }
    return target;
}
function _makeDynamicObject(state, target, name, desc) {
    try {
        // Assign target with new value properties (converting into dynamic properties in the process)
        objForEachKey(target, function (key, value) {
            // Assign and/or make the property dynamic
            _setDynamicProperty(state, target, key, value);
        });
        if (!target[CFG_HANDLER_LINK]) {
            // Link the config back to the dynamic config details
            objDefineProp(target, CFG_HANDLER_LINK, {
                get: function () {
                    return state[_DYN_HDLR /* @min:%2ehdlr */];
                }
            });
            _patchArray(state, target, name);
        }
    }
    catch (e) {
        // Unable to convert to dynamic property so just leave as non-dynamic
        _throwDynamicError((state.hdlr || {})[_DYN_LOGGER /* @min:%2elogger */], name, desc, e);
    }
    return target;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var symPrefix = "[[ai_";
var symPostfix = "]]";
function _createState(cfgHandler) {
    var _a;
    var dynamicPropertySymbol = newSymbol(symPrefix + "get" + cfgHandler.uid + symPostfix);
    var dynamicPropertyReadOnly = newSymbol(symPrefix + "ro" + cfgHandler.uid + symPostfix);
    var dynamicPropertyReferenced = newSymbol(symPrefix + "rf" + cfgHandler.uid + symPostfix);
    var dynamicPropertyBlockValue = newSymbol(symPrefix + "blkVal" + cfgHandler.uid + symPostfix);
    var dynamicPropertyDetail = newSymbol(symPrefix + "dtl" + cfgHandler.uid + symPostfix);
    var _waitingHandlers = null;
    var _watcherTimer = null;
    var theState;
    function _useHandler(activeHandler, callback) {
        var prevWatcher = theState.act;
        try {
            theState.act = activeHandler;
            if (activeHandler && activeHandler[dynamicPropertyDetail]) {
                // Clear out the previously tracked details for this handler, so that access are re-evaluated
                arrForEach(activeHandler[dynamicPropertyDetail], function (detail) {
                    detail.clr(activeHandler);
                });
                activeHandler[dynamicPropertyDetail] = [];
            }
            callback({
                cfg: cfgHandler.cfg,
                set: cfgHandler.set.bind(cfgHandler),
                setDf: cfgHandler[_DYN_SET_DF /* @min:%2esetDf */].bind(cfgHandler),
                ref: cfgHandler.ref.bind(cfgHandler),
                rdOnly: cfgHandler[_DYN_RD_ONLY /* @min:%2erdOnly */].bind(cfgHandler)
            });
        }
        catch (e) {
            var logger = cfgHandler[_DYN_LOGGER /* @min:%2elogger */];
            if (logger) {
                // Don't let one individual failure break everyone
                logger[_DYN_THROW_INTERNAL /* @min:%2ethrowInternal */](1 /* eLoggingSeverity.CRITICAL */, 107 /* _eInternalMessageId.ConfigWatcherException */, dumpObj(e));
            }
            // Re-throw the exception so that any true "error" is reported back to the called
            throw e;
        }
        finally {
            theState.act = prevWatcher || null;
        }
    }
    function _notifyWatchers() {
        if (_waitingHandlers) {
            var notifyHandlers = _waitingHandlers;
            _waitingHandlers = null;
            // Stop any timer as we are running them now anyway
            _watcherTimer && _watcherTimer[_DYN_CANCEL /* @min:%2ecancel */]();
            _watcherTimer = null;
            var watcherFailures_1 = [];
            // Now run the handlers
            arrForEach(notifyHandlers, function (handler) {
                if (handler) {
                    if (handler[dynamicPropertyDetail]) {
                        arrForEach(handler[dynamicPropertyDetail], function (detail) {
                            // Clear out this handler from  previously tracked details, so that access are re-evaluated
                            detail.clr(handler);
                        });
                        handler[dynamicPropertyDetail] = null;
                    }
                    // The handler may have self removed as part of another handler so re-check
                    if (handler.fn) {
                        try {
                            _useHandler(handler, handler.fn);
                        }
                        catch (e) {
                            // Don't let a single failing watcher cause other watches to fail
                            watcherFailures_1[_DYN_PUSH$2 /* @min:%2epush */](e);
                        }
                    }
                }
            });
            // During notification we may have had additional updates -- so notify those updates as well
            if (_waitingHandlers) {
                try {
                    _notifyWatchers();
                }
                catch (e) {
                    watcherFailures_1[_DYN_PUSH$2 /* @min:%2epush */](e);
                }
            }
            if (watcherFailures_1[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                throwAggregationError("Watcher error(s): ", watcherFailures_1);
            }
        }
    }
    function _addWatcher(detail) {
        if (detail && detail.h[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
            if (!_waitingHandlers) {
                _waitingHandlers = [];
            }
            if (!_watcherTimer) {
                _watcherTimer = scheduleTimeout(function () {
                    _watcherTimer = null;
                    _notifyWatchers();
                }, 0);
            }
            // Add all of the handlers for this detail (if not already present) - using normal for-loop for performance
            for (var idx = 0; idx < detail.h[_DYN_LENGTH$5 /* @min:%2elength */]; idx++) {
                var handler = detail.h[idx];
                // Add this handler to the collection of handlers to re-execute
                if (handler && arrIndexOf(_waitingHandlers, handler) === -1) {
                    _waitingHandlers[_DYN_PUSH$2 /* @min:%2epush */](handler);
                }
            }
        }
    }
    function _trackHandler(handler, detail) {
        if (handler) {
            var details = handler[dynamicPropertyDetail] = handler[dynamicPropertyDetail] || [];
            if (arrIndexOf(details, detail) === -1) {
                // If this detail is not already listed as tracked then add it so that we re-evaluate it's usage
                details[_DYN_PUSH$2 /* @min:%2epush */](detail);
            }
        }
    }
    theState = (_a = {
            prop: dynamicPropertySymbol,
            ro: dynamicPropertyReadOnly,
            rf: dynamicPropertyReferenced
        },
        _a[_DYN_BLK_VAL /* @min:blkVal */] = dynamicPropertyBlockValue,
        _a[_DYN_HDLR /* @min:hdlr */] = cfgHandler,
        _a.add = _addWatcher,
        _a[_DYN_NOTIFY /* @min:notify */] = _notifyWatchers,
        _a.use = _useHandler,
        _a.trk = _trackHandler,
        _a);
    return theState;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Identifies a function which will be re-called whenever any of it's accessed configuration values
 * change.
 * @param configHandler - The callback that will be called for the initial request and then whenever any
 * accessed configuration changes are identified.
 */
function _createAndUseHandler(state, configHandler) {
    var handler = {
        fn: configHandler,
        rm: function () {
            // Clear all references to the handler so it can be garbage collected
            // This will also cause this handler to never get called and eventually removed
            handler.fn = null;
            state = null;
            configHandler = null;
        }
    };
    objDefine(handler, "toJSON", { v: function () { return "WatcherHandler" + (handler.fn ? "" : "[X]"); } });
    state.use(handler, configHandler);
    return handler;
}
/**
 * Creates the dynamic config handler and associates with the target config as the root object
 * @param target - The config that you want to be root of the dynamic config
 * @param inPlace - Should the passed config be converted in-place or a new proxy returned
 * @returns The existing dynamic handler or a new instance with the provided config values
 */
function _createDynamicHandler(logger, target, inPlace) {
    var _a;
    var dynamicHandler = getDynamicConfigHandler(target);
    if (dynamicHandler) {
        // The passed config is already dynamic so return it's tracker
        return dynamicHandler;
    }
    var uid = createUniqueNamespace("dyncfg", true);
    var newTarget = (target && inPlace !== false) ? target : _cfgDeepCopy(target);
    var theState;
    function _notifyWatchers() {
        theState[_DYN_NOTIFY /* @min:%2enotify */]();
    }
    function _setValue(target, name, value) {
        try {
            target = _setDynamicProperty(theState, target, name, value);
        }
        catch (e) {
            // Unable to convert to dynamic property so just leave as non-dynamic
            _throwDynamicError(logger, name, "Setting value", e);
        }
        return target[name];
    }
    function _watch(configHandler) {
        return _createAndUseHandler(theState, configHandler);
    }
    function _block(configHandler, allowUpdate) {
        theState.use(null, function (details) {
            var prevUpd = theState.upd;
            try {
                if (!isUndefined(allowUpdate)) {
                    theState.upd = allowUpdate;
                }
                configHandler(details);
            }
            finally {
                theState.upd = prevUpd;
            }
        });
    }
    function _ref(target, name) {
        var _a;
        // Make sure it's dynamic and mark as referenced with it's current value
        return _setDynamicPropertyState(theState, target, name, (_a = {}, _a[0 /* _eSetDynamicPropertyFlags.inPlace */] = true, _a))[name];
    }
    function _rdOnly(target, name) {
        var _a;
        // Make sure it's dynamic and mark as readonly with it's current value
        return _setDynamicPropertyState(theState, target, name, (_a = {}, _a[1 /* _eSetDynamicPropertyFlags.readOnly */] = true, _a))[name];
    }
    function _blkPropValue(target, name) {
        var _a;
        // Make sure it's dynamic and mark as readonly with it's current value
        return _setDynamicPropertyState(theState, target, name, (_a = {}, _a[2 /* _eSetDynamicPropertyFlags.blockDynamicProperty */] = true, _a))[name];
    }
    function _applyDefaults(theConfig, defaultValues) {
        if (defaultValues) {
            // Resolve/apply the defaults
            objForEachKey(defaultValues, function (name, value) {
                // Sets the value and makes it dynamic (if it doesn't already exist)
                _applyDefaultValue(cfgHandler, theConfig, name, value);
            });
        }
        return theConfig;
    }
    var cfgHandler = (_a = {
            uid: null,
            cfg: newTarget
        },
        _a[_DYN_LOGGER /* @min:logger */] = logger,
        _a[_DYN_NOTIFY /* @min:notify */] = _notifyWatchers,
        _a.set = _setValue,
        _a[_DYN_SET_DF /* @min:setDf */] = _applyDefaults,
        _a[_DYN_WATCH /* @min:watch */] = _watch,
        _a.ref = _ref,
        _a[_DYN_RD_ONLY /* @min:rdOnly */] = _rdOnly,
        _a[_DYN_BLK_VAL /* @min:blkVal */] = _blkPropValue,
        _a._block = _block,
        _a);
    objDefine(cfgHandler, "uid", {
        c: false,
        e: false,
        w: false,
        v: uid
    });
    theState = _createState(cfgHandler);
    // Setup tracking for all defined default keys
    _makeDynamicObject(theState, newTarget, "config", "Creating");
    return cfgHandler;
}
/**
 * Log an invalid access message to the console
 * @param message
 */
function _logInvalidAccess(logger, message) {
    if (logger) {
        logger[_DYN_WARN_TO_CONSOLE /* @min:%2ewarnToConsole */](message);
        logger[_DYN_THROW_INTERNAL /* @min:%2ethrowInternal */](2 /* eLoggingSeverity.WARNING */, 108 /* _eInternalMessageId.DynamicConfigException */, message);
    }
    else {
        // We don't have a logger so just throw an exception
        throwInvalidAccess(message);
    }
}
/**
 * Create or return a dynamic version of the passed config, if it is not already dynamic
 * @param config - The config to be converted into a dynamic config
 * @param defaultConfig - The default values to apply on the config if the properties don't already exist
 * @param inPlace - Should the config be converted in-place into a dynamic config or a new instance returned, defaults to true
 * @returns The dynamic config handler for the config (whether new or existing)
 */
function createDynamicConfig(config, defaultConfig, logger, inPlace) {
    var dynamicHandler = _createDynamicHandler(logger, config || {}, inPlace);
    if (defaultConfig) {
        dynamicHandler[_DYN_SET_DF /* @min:%2esetDf */](dynamicHandler.cfg, defaultConfig);
    }
    return dynamicHandler;
}
/**
 * Watch and track changes for accesses to the current config, the provided config MUST already be
 * a dynamic config or a child accessed via the dynamic config
 * @param config
 * @param configHandler
 * @param logger - The logger instance to use if there is no existing handler
 * @returns A watcher handler instance that can be used to remove itself when being unloaded
 * @throws TypeError if the provided config is not a dynamic config instance
 */
function onConfigChange(config, configHandler, logger) {
    var handler = config[CFG_HANDLER_LINK] || config;
    if (handler.cfg && (handler.cfg === config || handler.cfg[CFG_HANDLER_LINK] === handler)) {
        return handler[_DYN_WATCH /* @min:%2ewatch */](configHandler);
    }
    _logInvalidAccess(logger, STR_NOT_DYNAMIC_ERROR + dumpObj(config));
    return createDynamicConfig(config, null, logger)[_DYN_WATCH /* @min:%2ewatch */](configHandler);
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Run the unload function of the target object if it exists
 * @param target - The target object that contains the unload function
 * @param isAsync - The caller identifies whether it is expecting the operation to complete synchronously or asynchronously. Even
 * if the caller is not waiting the operation may still be performed asynchronously depending on the component and the reverse is
 * also true.
 * @returns The result of the target function
 */
function runTargetUnload(target, isAsync) {
    if (target && target[_DYN_UNLOAD /* @min:%2eunload */]) {
        return target[_DYN_UNLOAD /* @min:%2eunload */](isAsync);
    }
}
/**
 * Call the unload function on all targets handling any returned [IPromise](https://nevware21.github.io/ts-async/typedoc/interfaces/IPromise.html)
 * / Promise before calling the next targets unload
 * @param targets - An array of the targets to unload
 * @param isAsync - The caller identifies whether it is expecting the operations to complete synchronously or asynchronously.  Even
 * if the caller is not waiting the operation may still be performed asynchronously depending on the component and the reverse is
 * also true.
 * @param done - Optional callback function to call once all of the unload functions have been called.
 */
function doUnloadAll(targets, isAsync, done) {
    var result;
    if (!done) {
        result = createPromise(function (resolved) {
            done = resolved;
        });
    }
    if (targets && getLength(targets) > 0) {
        doAwaitResponse(runTargetUnload(targets[0], isAsync), function () {
            doUnloadAll(arrSlice(targets, 1), isAsync, done);
        });
    }
    else {
        done();
    }
    return result;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


var ChannelControllerPriority = 500;
var DisabledPropertyName$1 = "Microsoft_ApplicationInsights_BypassAjaxInstrumentation";
// export const SampleRate = "sampleRate";
// export const ProcessLegacy = "ProcessLegacy";
// export const HttpMethod = "http.method";
// export const DEFAULT_BREEZE_ENDPOINT = "https://dc.services.visualstudio.com";
// export const DEFAULT_BREEZE_PATH = "/v2/track";
// export const strNotSpecified = "not_specified";
// export const strIkey = "iKey";

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * @internal
 * @ignore
 * @param str
 * @param defaultValue
 * @returns
 */
function _stringToBoolOrDefault(theValue, defaultValue, theConfig) {
    if (!theValue && isNullOrUndefined(theValue)) {
        return defaultValue;
    }
    if (isBoolean(theValue)) {
        return theValue;
    }
    return asString(theValue)[_DYN_TO_LOWER_CASE$2 /* @min:%2etoLowerCase */]() === "true";
}
/**
 * Helper which returns an IConfigDefaultCheck instance with the field defined as an object
 * that should be merged
 * @param defaultValue - The default value to apply it not provided or it's not valid
 * @returns a new IConfigDefaultCheck structure
 */
function cfgDfMerge(defaultValue) {
    return {
        mrg: true,
        v: defaultValue
    };
}
/**
 * Helper which returns an IConfigDefaultCheck instance with the provided field set function
 * @param setter - The IConfigCheckFn function to validate the user provided value
 * @param defaultValue - The default value to apply it not provided or it's not valid
 * @returns a new IConfigDefaultCheck structure
 */
function cfgDfSet(setter, defaultValue) {
    return {
        set: setter,
        v: defaultValue
    };
}
/**
 * Helper which returns an IConfigDefaultCheck instance with the provided field validator
 * @param validator - The IConfigCheckFn function to validate the user provided value
 * @param defaultValue - The default value to apply it not provided or it's not valid
 * @param fallBackName - The fallback configuration name if the current value is not available
 * @returns a new IConfigDefaultCheck structure
 */
function cfgDfValidate(validator, defaultValue, fallBackName) {
    return {
        fb: fallBackName,
        isVal: validator,
        v: defaultValue
    };
}
/**
 * Helper which returns an IConfigDefaultCheck instance that will validate and convert the user
 * provided value to a boolean from a string or boolean value
 * @param defaultValue - The default value to apply it not provided or it's not valid
 * @param fallBackName - The fallback configuration name if the current value is not available
 * @returns a new IConfigDefaultCheck structure
 */
function cfgDfBoolean(defaultValue, fallBackName) {
    return {
        fb: fallBackName,
        set: _stringToBoolOrDefault,
        v: !!defaultValue
    };
}
/**
 * Helper which returns an IConfigDefaultCheck instance that will validate that the user
 * provided value is a function.
 * @param defaultValue - The default string value to apply it not provided or it's not valid, defaults to an empty string
 * @returns a new IConfigDefaultCheck structure
 */
function cfgDfString(defaultValue) {
    return {
        isVal: isString,
        v: asString(defaultValue || STR_EMPTY$1)
    };
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var listenerFuncs = [STR_EVENTS_SENT, STR_EVENTS_DISCARDED, STR_EVENTS_SEND_REQUEST, STR_PERF_EVENT];
var _aiNamespace = null;
var _debugListener;
function _listenerProxyFunc(name, config) {
    return function () {
        var args = arguments;
        var dbgExt = getDebugExt(config);
        if (dbgExt) {
            var listener = dbgExt.listener;
            if (listener && listener[name]) {
                listener[name][_DYN_APPLY /* @min:%2eapply */](listener, args);
            }
        }
    };
}
function _getExtensionNamespace() {
    // Cache the lookup of the global namespace object
    var target = getInst("Microsoft");
    if (target) {
        _aiNamespace = target["ApplicationInsights"];
    }
    return _aiNamespace;
}
function getDebugExt(config) {
    var ns = _aiNamespace;
    if (!ns && config.disableDbgExt !== true) {
        ns = _aiNamespace || _getExtensionNamespace();
    }
    return ns ? ns["ChromeDbgExt"] : null;
}
function getDebugListener(config) {
    if (!_debugListener) {
        _debugListener = {};
        for (var lp = 0; lp < listenerFuncs[_DYN_LENGTH$5 /* @min:%2elength */]; lp++) {
            _debugListener[listenerFuncs[lp]] = _listenerProxyFunc(listenerFuncs[lp], config);
        }
    }
    return _debugListener;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var _a$9;
var STR_WARN_TO_CONSOLE = "warnToConsole";
/**
 * For user non actionable traces use AI Internal prefix.
 */
var AiNonUserActionablePrefix = "AI (Internal): ";
/**
 * Prefix of the traces in portal.
 */
var AiUserActionablePrefix = "AI: ";
/**
 *  Session storage key for the prefix for the key indicating message type already logged
 */
var AIInternalMessagePrefix = "AITR_";
var defaultValues$3 = {
    loggingLevelConsole: 0,
    loggingLevelTelemetry: 1,
    maxMessageLimit: 25,
    enableDebug: false
};
var _logFuncs = (_a$9 = {},
    _a$9[0 /* eLoggingSeverity.DISABLED */] = null,
    _a$9[1 /* eLoggingSeverity.CRITICAL */] = "errorToConsole",
    _a$9[2 /* eLoggingSeverity.WARNING */] = STR_WARN_TO_CONSOLE,
    _a$9[3 /* eLoggingSeverity.DEBUG */] = "debugToConsole",
    _a$9);
function _sanitizeDiagnosticText(text) {
    if (text) {
        return "\"" + text[_DYN_REPLACE /* @min:%2ereplace */](/\"/g, STR_EMPTY$1) + "\"";
    }
    return STR_EMPTY$1;
}
function _logToConsole(func, message) {
    var theConsole = getConsole();
    if (!!theConsole) {
        var logFunc = "log";
        if (theConsole[func]) {
            logFunc = func;
        }
        if (isFunction(theConsole[logFunc])) {
            theConsole[logFunc](message);
        }
    }
}
var _InternalLogMessage = /** @class */ (function () {
    function _InternalLogMessage(msgId, msg, isUserAct, properties) {
        if (isUserAct === void 0) { isUserAct = false; }
        var _self = this;
        _self[_DYN_MESSAGE_ID /* @min:%2emessageId */] = msgId;
        _self[_DYN_MESSAGE$2 /* @min:%2emessage */] =
            (isUserAct ? AiUserActionablePrefix : AiNonUserActionablePrefix) +
                msgId;
        var strProps = STR_EMPTY$1;
        if (hasJSON()) {
            strProps = getJSON().stringify(properties);
        }
        var diagnosticText = (msg ? " message:" + _sanitizeDiagnosticText(msg) : STR_EMPTY$1) +
            (properties ? " props:" + _sanitizeDiagnosticText(strProps) : STR_EMPTY$1);
        _self[_DYN_MESSAGE$2 /* @min:%2emessage */] += diagnosticText;
    }
    _InternalLogMessage.dataType = "MessageData";
    return _InternalLogMessage;
}());
function safeGetLogger(core, config) {
    return (core || {})[_DYN_LOGGER /* @min:%2elogger */] || new DiagnosticLogger(config);
}
var DiagnosticLogger = /** @class */ (function () {
    function DiagnosticLogger(config) {
        this.identifier = "DiagnosticLogger";
        /**
         * The internal logging queue
         */
        this.queue = [];
        /**
         * Count of internal messages sent
         */
        var _messageCount = 0;
        /**
         * Holds information about what message types were already logged to console or sent to server.
         */
        var _messageLogged = {};
        var _loggingLevelConsole;
        var _loggingLevelTelemetry;
        var _maxInternalMessageLimit;
        var _enableDebug;
        var _unloadHandler;
        dynamicProto(DiagnosticLogger, this, function (_self) {
            _unloadHandler = _setDefaultsFromConfig(config || {});
            _self.consoleLoggingLevel = function () { return _loggingLevelConsole; };
            /**
             * This method will throw exceptions in debug mode or attempt to log the error as a console warning.
             * @param severity - {LoggingSeverity} - The severity of the log message
             * @param message - {_InternalLogMessage} - The log message.
             */
            _self[_DYN_THROW_INTERNAL /* @min:%2ethrowInternal */] = function (severity, msgId, msg, properties, isUserAct) {
                if (isUserAct === void 0) { isUserAct = false; }
                var message = new _InternalLogMessage(msgId, msg, isUserAct, properties);
                if (_enableDebug) {
                    throw dumpObj(message);
                }
                else {
                    // Get the logging function and fallback to warnToConsole of for some reason errorToConsole doesn't exist
                    var logFunc = _logFuncs[severity] || STR_WARN_TO_CONSOLE;
                    if (!isUndefined(message[_DYN_MESSAGE$2 /* @min:%2emessage */])) {
                        if (isUserAct) {
                            // check if this message type was already logged to console for this page view and if so, don't log it again
                            var messageKey = +message[_DYN_MESSAGE_ID /* @min:%2emessageId */];
                            if (!_messageLogged[messageKey] && _loggingLevelConsole >= severity) {
                                _self[logFunc](message[_DYN_MESSAGE$2 /* @min:%2emessage */]);
                                _messageLogged[messageKey] = true;
                            }
                        }
                        else {
                            // Only log traces if the console Logging Level is >= the throwInternal severity level
                            if (_loggingLevelConsole >= severity) {
                                _self[logFunc](message[_DYN_MESSAGE$2 /* @min:%2emessage */]);
                            }
                        }
                        _logInternalMessage(severity, message);
                    }
                    else {
                        _debugExtMsg("throw" + (severity === 1 /* eLoggingSeverity.CRITICAL */ ? "Critical" : "Warning"), message);
                    }
                }
            };
            _self.debugToConsole = function (message) {
                _logToConsole("debug", message);
                _debugExtMsg("warning", message);
            };
            _self[_DYN_WARN_TO_CONSOLE /* @min:%2ewarnToConsole */] = function (message) {
                _logToConsole("warn", message);
                _debugExtMsg("warning", message);
            };
            _self.errorToConsole = function (message) {
                _logToConsole("error", message);
                _debugExtMsg("error", message);
            };
            _self.resetInternalMessageCount = function () {
                _messageCount = 0;
                _messageLogged = {};
            };
            _self[_DYN_LOG_INTERNAL_MESSAGE /* @min:%2elogInternalMessage */] = _logInternalMessage;
            _self[_DYN_UNLOAD /* @min:%2eunload */] = function (isAsync) {
                _unloadHandler && _unloadHandler.rm();
                _unloadHandler = null;
            };
            function _logInternalMessage(severity, message) {
                if (_areInternalMessagesThrottled()) {
                    return;
                }
                // check if this message type was already logged for this session and if so, don't log it again
                var logMessage = true;
                var messageKey = AIInternalMessagePrefix + message[_DYN_MESSAGE_ID /* @min:%2emessageId */];
                // if the session storage is not available, limit to only one message type per page view
                if (_messageLogged[messageKey]) {
                    logMessage = false;
                }
                else {
                    _messageLogged[messageKey] = true;
                }
                if (logMessage) {
                    // Push the event in the internal queue
                    if (severity <= _loggingLevelTelemetry) {
                        _self.queue[_DYN_PUSH$2 /* @min:%2epush */](message);
                        _messageCount++;
                        _debugExtMsg((severity === 1 /* eLoggingSeverity.CRITICAL */ ? "error" : "warn"), message);
                    }
                    // When throttle limit reached, send a special event
                    if (_messageCount === _maxInternalMessageLimit) {
                        var throttleLimitMessage = "Internal events throttle limit per PageView reached for this app.";
                        var throttleMessage = new _InternalLogMessage(23 /* _eInternalMessageId.MessageLimitPerPVExceeded */, throttleLimitMessage, false);
                        _self.queue[_DYN_PUSH$2 /* @min:%2epush */](throttleMessage);
                        if (severity === 1 /* eLoggingSeverity.CRITICAL */) {
                            _self.errorToConsole(throttleLimitMessage);
                        }
                        else {
                            _self[_DYN_WARN_TO_CONSOLE /* @min:%2ewarnToConsole */](throttleLimitMessage);
                        }
                    }
                }
            }
            function _setDefaultsFromConfig(config) {
                // make sure the config is dynamic
                return onConfigChange(createDynamicConfig(config, defaultValues$3, _self).cfg, function (details) {
                    var config = details.cfg;
                    _loggingLevelConsole = config[_DYN_LOGGING_LEVEL_CONSOL4 /* @min:%2eloggingLevelConsole */];
                    _loggingLevelTelemetry = config.loggingLevelTelemetry;
                    _maxInternalMessageLimit = config.maxMessageLimit;
                    _enableDebug = config.enableDebug;
                });
            }
            function _areInternalMessagesThrottled() {
                return _messageCount >= _maxInternalMessageLimit;
            }
            function _debugExtMsg(name, data) {
                var dbgExt = getDebugExt(config || {});
                if (dbgExt && dbgExt[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */]) {
                    dbgExt[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */](name, data);
                }
            }
        });
    }
// Removed Stub for DiagnosticLogger.prototype.consoleLoggingLevel.
// Removed Stub for DiagnosticLogger.prototype.throwInternal.
// Removed Stub for DiagnosticLogger.prototype.debugToConsole.
// Removed Stub for DiagnosticLogger.prototype.warnToConsole.
// Removed Stub for DiagnosticLogger.prototype.errorToConsole.
// Removed Stub for DiagnosticLogger.prototype.resetInternalMessageCount.
// Removed Stub for DiagnosticLogger.prototype.logInternalMessage.
// Removed Stub for DiagnosticLogger.prototype.unload.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    DiagnosticLogger.__ieDyn=1;

    return DiagnosticLogger;
}());
function _getLogger(logger) {
    return (logger || new DiagnosticLogger());
}
/**
 * This is a helper method which will call throwInternal on the passed logger, will throw exceptions in
 * debug mode or attempt to log the error as a console warning. This helper is provided mostly to better
 * support minification as logger.throwInternal() will not compress the publish "throwInternal" used throughout
 * the code.
 * @param logger - The Diagnostic Logger instance to use.
 * @param severity - {LoggingSeverity} - The severity of the log message
 * @param message - {_InternalLogMessage} - The log message.
 */
function _throwInternal(logger, severity, msgId, msg, properties, isUserAct) {
    if (isUserAct === void 0) { isUserAct = false; }
    _getLogger(logger)[_DYN_THROW_INTERNAL /* @min:%2ethrowInternal */](severity, msgId, msg, properties, isUserAct);
}
/**
 * This is a helper method which will call warnToConsole on the passed logger with the provided message.
 * @param logger - The Diagnostic Logger instance to use.
 * @param message - {_InternalLogMessage} - The log message.
 */
function _warnToConsole(logger, message) {
    _getLogger(logger)[_DYN_WARN_TO_CONSOLE /* @min:%2ewarnToConsole */](message);
}
/**
 * Logs a message to the internal queue.
 * @param logger - The Diagnostic Logger instance to use.
 * @param severity - {LoggingSeverity} - The severity of the log message
 * @param message - {_InternalLogMessage} - The message to log.
 */
function _logInternalMessage(logger, severity, message) {
    _getLogger(logger)[_DYN_LOG_INTERNAL_MESSAGE /* @min:%2elogInternalMessage */](severity, message);
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var _a$8, _b$2;
var strToGMTString = "toGMTString";
var strToUTCString = "toUTCString";
var strCookie = "cookie";
var strExpires = "expires";
var strIsCookieUseDisabled = "isCookieUseDisabled";
var strDisableCookiesUsage = "disableCookiesUsage";
var strConfigCookieMgr = "_ckMgr";
var _supportsCookies = null;
var _allowUaSameSite = null;
var _parsedCookieValue = null;
var _doc;
var _cookieCache = {};
var _globalCookieConfig = {};
// // `isCookieUseDisabled` is deprecated, so explicitly casting as a key of IConfiguration to avoid typing error
// // when both isCookieUseDisabled and disableCookiesUsage are used disableCookiesUsage will take precedent, which is
// // why its listed first
/**
 * Set the supported dynamic config values as undefined (or an empty object) so that
 * any listeners will be informed of any changes.
 * Explicitly NOT including the deprecated `isCookieUseDisabled` as we don't want to support
 * the v1 deprecated field as dynamic for updates
 */
var rootDefaultConfig = (_a$8 = {
        cookieCfg: cfgDfMerge((_b$2 = {},
            _b$2[STR_DOMAIN] = { fb: "cookieDomain", dfVal: isNotNullOrUndefined },
            _b$2.path = { fb: "cookiePath", dfVal: isNotNullOrUndefined },
            _b$2.enabled = UNDEFINED_VALUE$2,
            _b$2.ignoreCookies = UNDEFINED_VALUE$2,
            _b$2.blockedCookies = UNDEFINED_VALUE$2,
            _b$2)),
        cookieDomain: UNDEFINED_VALUE$2,
        cookiePath: UNDEFINED_VALUE$2
    },
    _a$8[strDisableCookiesUsage] = UNDEFINED_VALUE$2,
    _a$8);
function _getDoc() {
    !_doc && (_doc = getLazy(function () { return getDocument(); }));
}
/**
 * @ignore
 * DO NOT USE or export from the module, this is exposed as public to support backward compatibility of previous static utility methods only.
 * If you want to manager cookies either use the ICookieMgr available from the core instance via getCookieMgr() or create
 * your own instance of the CookieMgr and use that.
 * Using this directly for enabling / disabling cookie handling will not only affect your usage but EVERY user of cookies.
 * Example, if you are using a shared component that is also using Application Insights you will affect their cookie handling.
 * @param logger - The DiagnosticLogger to use for reporting errors.
 */
function _gblCookieMgr(config, logger) {
    // Stash the global instance against the BaseCookieMgr class
    var inst = createCookieMgr[strConfigCookieMgr] || _globalCookieConfig[strConfigCookieMgr];
    if (!inst) {
        // Note: not using the getSetValue() helper as that would require always creating a temporary cookieMgr
        // that ultimately is never used
        inst = createCookieMgr[strConfigCookieMgr] = createCookieMgr(config, logger);
        _globalCookieConfig[strConfigCookieMgr] = inst;
    }
    return inst;
}
function _isMgrEnabled(cookieMgr) {
    if (cookieMgr) {
        return cookieMgr.isEnabled();
    }
    return true;
}
function _isIgnoredCookie(cookieMgrCfg, name) {
    if (name && cookieMgrCfg && isArray(cookieMgrCfg.ignoreCookies)) {
        return arrIndexOf(cookieMgrCfg.ignoreCookies, name) !== -1;
    }
    return false;
}
function _isBlockedCookie(cookieMgrCfg, name) {
    if (name && cookieMgrCfg && isArray(cookieMgrCfg.blockedCookies)) {
        if (arrIndexOf(cookieMgrCfg.blockedCookies, name) !== -1) {
            return true;
        }
    }
    return _isIgnoredCookie(cookieMgrCfg, name);
}
function _isCfgEnabled(rootConfig, cookieMgrConfig) {
    var isCfgEnabled = cookieMgrConfig[_DYN_ENABLED /* @min:%2eenabled */];
    if (isNullOrUndefined(isCfgEnabled)) {
        // Set the enabled from the provided setting or the legacy root values
        var cookieEnabled = void 0;
        // This field is deprecated and dynamic updates will not be fully supported
        if (!isUndefined(rootConfig[strIsCookieUseDisabled])) {
            cookieEnabled = !rootConfig[strIsCookieUseDisabled];
        }
        // If this value is defined it takes precedent over the above
        if (!isUndefined(rootConfig[strDisableCookiesUsage])) {
            cookieEnabled = !rootConfig[strDisableCookiesUsage];
        }
        // Not setting the cookieMgrConfig.enabled as that will update (set) the global dynamic config
        // So future "updates" then may not be as expected
        isCfgEnabled = cookieEnabled;
    }
    return isCfgEnabled;
}
/**
 * Helper to return the ICookieMgr from the core (if not null/undefined) or a default implementation
 * associated with the configuration or a legacy default.
 * @param core
 * @param config
 * @returns
 */
function safeGetCookieMgr(core, config) {
    var cookieMgr;
    if (core) {
        // Always returns an instance
        cookieMgr = core.getCookieMgr();
    }
    else if (config) {
        var cookieCfg = config.cookieCfg;
        if (cookieCfg && cookieCfg[strConfigCookieMgr]) {
            cookieMgr = cookieCfg[strConfigCookieMgr];
        }
        else {
            cookieMgr = createCookieMgr(config);
        }
    }
    if (!cookieMgr) {
        // Get or initialize the default global (legacy) cookie manager if we couldn't find one
        cookieMgr = _gblCookieMgr(config, (core || {})[_DYN_LOGGER /* @min:%2elogger */]);
    }
    return cookieMgr;
}
function createCookieMgr(rootConfig, logger) {
    var _a;
    var cookieMgrConfig;
    var _path;
    var _domain;
    var unloadHandler;
    // Explicitly checking against false, so that setting to undefined will === true
    var _enabled;
    var _getCookieFn;
    var _setCookieFn;
    var _delCookieFn;
    // Make sure the root config is dynamic as it may be the global config
    rootConfig = createDynamicConfig(rootConfig || _globalCookieConfig, null, logger).cfg;
    // Will get recalled if the referenced configuration is changed
    unloadHandler = onConfigChange(rootConfig, function (details) {
        // Make sure the root config has all of the the defaults to the root config to ensure they are dynamic
        details[_DYN_SET_DF /* @min:%2esetDf */](details.cfg, rootDefaultConfig);
        // Create and apply the defaults to the cookieCfg element
        cookieMgrConfig = details.ref(details.cfg, "cookieCfg"); // details.setDf(details.cfg.cookieCfg, defaultConfig);
        _path = cookieMgrConfig[STR_PATH /* @min:%2epath */] || "/";
        _domain = cookieMgrConfig[STR_DOMAIN /* @min:%2edomain */];
        // Explicitly checking against false, so that setting to undefined will === true
        _enabled = _isCfgEnabled(rootConfig, cookieMgrConfig) !== false;
        _getCookieFn = cookieMgrConfig.getCookie || _getCookieValue;
        _setCookieFn = cookieMgrConfig.setCookie || _setCookieValue;
        _delCookieFn = cookieMgrConfig.delCookie || _setCookieValue;
    }, logger);
    var cookieMgr = (_a = {
            isEnabled: function () {
                var enabled = _isCfgEnabled(rootConfig, cookieMgrConfig) !== false && _enabled && areCookiesSupported(logger);
                // Using an indirect lookup for any global cookie manager to support tree shaking for SDK's
                // that don't use the "applicationinsights-core" version of the default cookie function
                var gblManager = _globalCookieConfig[strConfigCookieMgr];
                if (enabled && gblManager && cookieMgr !== gblManager) {
                    // Make sure the GlobalCookie Manager instance (if not this instance) is also enabled.
                    // As the global (deprecated) functions may have been called (for backward compatibility)
                    enabled = _isMgrEnabled(gblManager);
                }
                return enabled;
            },
            setEnabled: function (value) {
                // Explicitly checking against false, so that setting to undefined will === true
                _enabled = value !== false;
                cookieMgrConfig[_DYN_ENABLED /* @min:%2eenabled */] = value;
            },
            set: function (name, value, maxAgeSec, domain, path) {
                var result = false;
                if (_isMgrEnabled(cookieMgr) && !_isBlockedCookie(cookieMgrConfig, name)) {
                    var values = {};
                    var theValue = strTrim(value || STR_EMPTY$1);
                    var idx = strIndexOf(theValue, ";");
                    if (idx !== -1) {
                        theValue = strTrim(strLeft(value, idx));
                        values = _extractParts(strSubstring(value, idx + 1));
                    }
                    // Only update domain if not already present (isUndefined) and the value is truthy (not null, undefined or empty string)
                    setValue(values, STR_DOMAIN, domain || _domain, isTruthy, isUndefined);
                    if (!isNullOrUndefined(maxAgeSec)) {
                        var _isIE = isIE();
                        if (isUndefined(values[strExpires])) {
                            var nowMs = utcNow();
                            // Only add expires if not already present
                            var expireMs = nowMs + (maxAgeSec * 1000);
                            // Sanity check, if zero or -ve then ignore
                            if (expireMs > 0) {
                                var expiry = new Date();
                                expiry.setTime(expireMs);
                                setValue(values, strExpires, _formatDate(expiry, !_isIE ? strToUTCString : strToGMTString) || _formatDate(expiry, _isIE ? strToGMTString : strToUTCString) || STR_EMPTY$1, isTruthy);
                            }
                        }
                        if (!_isIE) {
                            // Only replace if not already present
                            setValue(values, "max-age", STR_EMPTY$1 + maxAgeSec, null, isUndefined);
                        }
                    }
                    var location_1 = getLocation();
                    if (location_1 && location_1[_DYN_PROTOCOL /* @min:%2eprotocol */] === "https:") {
                        setValue(values, "secure", null, null, isUndefined);
                        // Only set same site if not also secure
                        if (_allowUaSameSite === null) {
                            _allowUaSameSite = !uaDisallowsSameSiteNone((getNavigator() || {})[_DYN_USER_AGENT /* @min:%2euserAgent */]);
                        }
                        if (_allowUaSameSite) {
                            setValue(values, "SameSite", "None", null, isUndefined);
                        }
                    }
                    setValue(values, STR_PATH, path || _path, null, isUndefined);
                    //let setCookieFn = cookieMgrConfig.setCookie || _setCookieValue;
                    _setCookieFn(name, _formatCookieValue(theValue, values));
                    result = true;
                }
                return result;
            },
            get: function (name) {
                var value = STR_EMPTY$1;
                if (_isMgrEnabled(cookieMgr) && !_isIgnoredCookie(cookieMgrConfig, name)) {
                    value = _getCookieFn(name);
                }
                return value;
            },
            del: function (name, path) {
                var result = false;
                if (_isMgrEnabled(cookieMgr)) {
                    // Only remove the cookie if the manager and cookie support has not been disabled
                    result = cookieMgr.purge(name, path);
                }
                return result;
            },
            purge: function (name, path) {
                var _a;
                var result = false;
                if (areCookiesSupported(logger)) {
                    // Setting the expiration date in the past immediately removes the cookie
                    var values = (_a = {},
                        _a[STR_PATH] = path ? path : "/",
                        _a[strExpires] = "Thu, 01 Jan 1970 00:00:01 GMT",
                        _a);
                    if (!isIE()) {
                        // Set max age to expire now
                        values["max-age"] = "0";
                    }
                    // let delCookie = cookieMgrConfig.delCookie || _setCookieValue;
                    _delCookieFn(name, _formatCookieValue(STR_EMPTY$1, values));
                    result = true;
                }
                return result;
            }
        },
        _a[_DYN_UNLOAD /* @min:unload */] = function (isAsync) {
            unloadHandler && unloadHandler.rm();
            unloadHandler = null;
        },
        _a);
    // Associated this cookie manager with the config
    cookieMgr[strConfigCookieMgr] = cookieMgr;
    return cookieMgr;
}
/*
* Helper method to tell if document.cookie object is supported by the runtime
*/
function areCookiesSupported(logger) {
    if (_supportsCookies === null) {
        _supportsCookies = false;
        !_doc && _getDoc();
        try {
            var doc = _doc.v || {};
            _supportsCookies = doc[strCookie] !== undefined;
        }
        catch (e) {
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 68 /* _eInternalMessageId.CannotAccessCookie */, "Cannot access document.cookie - " + getExceptionName(e), { exception: dumpObj(e) });
        }
    }
    return _supportsCookies;
}
function _extractParts(theValue) {
    var values = {};
    if (theValue && theValue[_DYN_LENGTH$5 /* @min:%2elength */]) {
        var parts = strTrim(theValue)[_DYN_SPLIT$1 /* @min:%2esplit */](";");
        arrForEach(parts, function (thePart) {
            thePart = strTrim(thePart || STR_EMPTY$1);
            if (thePart) {
                var idx = strIndexOf(thePart, "=");
                if (idx === -1) {
                    values[thePart] = null;
                }
                else {
                    values[strTrim(strLeft(thePart, idx))] = strTrim(strSubstring(thePart, idx + 1));
                }
            }
        });
    }
    return values;
}
function _formatDate(theDate, func) {
    if (isFunction(theDate[func])) {
        return theDate[func]();
    }
    return null;
}
function _formatCookieValue(value, values) {
    var cookieValue = value || STR_EMPTY$1;
    objForEachKey(values, function (name, theValue) {
        cookieValue += "; " + name + (!isNullOrUndefined(theValue) ? "=" + theValue : STR_EMPTY$1);
    });
    return cookieValue;
}
function _getCookieValue(name) {
    var cookieValue = STR_EMPTY$1;
    !_doc && _getDoc();
    if (_doc.v) {
        var theCookie = _doc.v[strCookie] || STR_EMPTY$1;
        if (_parsedCookieValue !== theCookie) {
            _cookieCache = _extractParts(theCookie);
            _parsedCookieValue = theCookie;
        }
        cookieValue = strTrim(_cookieCache[name] || STR_EMPTY$1);
    }
    return cookieValue;
}
function _setCookieValue(name, cookieValue) {
    !_doc && _getDoc();
    if (_doc.v) {
        _doc.v[strCookie] = name + "=" + cookieValue;
    }
}
function uaDisallowsSameSiteNone(userAgent) {
    if (!isString(userAgent)) {
        return false;
    }
    // Cover all iOS based browsers here. This includes:
    // - Safari on iOS 12 for iPhone, iPod Touch, iPad
    // - WkWebview on iOS 12 for iPhone, iPod Touch, iPad
    // - Chrome on iOS 12 for iPhone, iPod Touch, iPad
    // All of which are broken by SameSite=None, because they use the iOS networking stack
    if (strContains(userAgent, "CPU iPhone OS 12") || strContains(userAgent, "iPad; CPU OS 12")) {
        return true;
    }
    // Cover Mac OS X based browsers that use the Mac OS networking stack. This includes:
    // - Safari on Mac OS X
    // This does not include:
    // - Internal browser on Mac OS X
    // - Chrome on Mac OS X
    // - Chromium on Mac OS X
    // Because they do not use the Mac OS networking stack.
    if (strContains(userAgent, "Macintosh; Intel Mac OS X 10_14") && strContains(userAgent, "Version/") && strContains(userAgent, "Safari")) {
        return true;
    }
    // Cover Mac OS X internal browsers that use the Mac OS networking stack. This includes:
    // - Internal browser on Mac OS X
    // This does not include:
    // - Safari on Mac OS X
    // - Chrome on Mac OS X
    // - Chromium on Mac OS X
    // Because they do not use the Mac OS networking stack.
    if (strContains(userAgent, "Macintosh; Intel Mac OS X 10_14") && strEndsWith(userAgent, "AppleWebKit/605.1.15 (KHTML, like Gecko)")) {
        return true;
    }
    // Cover Chrome 50-69, because some versions are broken by SameSite=None, and none in this range require it.
    // Note: this covers some pre-Chromium Edge versions, but pre-Chromim Edge does not require SameSite=None, so this is fine.
    // Note: this regex applies to Windows, Mac OS X, and Linux, deliberately.
    if (strContains(userAgent, "Chrome/5") || strContains(userAgent, "Chrome/6")) {
        return true;
    }
    // Unreal Engine runs Chromium 59, but does not advertise as Chrome until 4.23. Treat versions of Unreal
    // that don't specify their Chrome version as lacking support for SameSite=None.
    if (strContains(userAgent, "UnrealEngine") && !strContains(userAgent, "Chrome")) {
        return true;
    }
    // UCBrowser < 12.13.2 ignores Set-Cookie headers with SameSite=None
    // NB: this rule isn't complete - you need regex to make a complete rule.
    // See: https://www.chromium.org/updates/same-site/incompatible-clients
    if (strContains(userAgent, "UCBrowser/12") || strContains(userAgent, "UCBrowser/11")) {
        return true;
    }
    return false;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var defaultValues$2 = {
    perfEvtsSendAll: false
};
function _runScheduledListeners(asyncNotifications) {
    asyncNotifications.h = null;
    var callbacks = asyncNotifications.cb;
    asyncNotifications.cb = [];
    arrForEach(callbacks, function (cb) {
        // Run the listener in a try-catch to ensure that a single listener failing doesn't prevent the others from running
        safe(cb.fn, [cb.arg]);
    });
}
// This function is used to combine the logic of running the listeners and handling the async notifications so that they don't
// create multiple timers if there are multiple async listeners.
function _runListeners(listeners, name, asyncNotifications, callback) {
    arrForEach(listeners, function (listener) {
        if (listener && listener[name]) {
            if (asyncNotifications) {
                // Schedule the callback to be called after the current call stack has cleared.
                asyncNotifications.cb[_DYN_PUSH$2 /* @min:%2epush */]({
                    fn: callback,
                    arg: listener
                });
                asyncNotifications.h = asyncNotifications.h || scheduleTimeout(_runScheduledListeners, 0, asyncNotifications);
            }
            else {
                // Run the listener in a try-catch to ensure that a single listener failing doesn't prevent the others from running
                safe(callback, [listener]);
            }
        }
    });
}
/**
 * Class to manage sending notifications to all the listeners.
 */
var NotificationManager = /** @class */ (function () {
    function NotificationManager(config) {
        this.listeners = [];
        var perfEvtsSendAll;
        var unloadHandler;
        var _listeners = [];
        var _asyncNotifications = {
            h: null,
            cb: []
        };
        var cfgHandler = createDynamicConfig(config, defaultValues$2);
        unloadHandler = cfgHandler[_DYN_WATCH /* @min:%2ewatch */](function (details) {
            perfEvtsSendAll = !!details.cfg.perfEvtsSendAll;
        });
        dynamicProto(NotificationManager, this, function (_self) {
            objDefine(_self, "listeners", {
                g: function () { return _listeners; }
            });
            _self[_DYN_ADD_NOTIFICATION_LIS1 /* @min:%2eaddNotificationListener */] = function (listener) {
                _listeners[_DYN_PUSH$2 /* @min:%2epush */](listener);
            };
            /**
             * Removes all instances of the listener.
             * @param listener - AWTNotificationListener to remove.
             */
            _self[_DYN_REMOVE_NOTIFICATION_0 /* @min:%2eremoveNotificationListener */] = function (listener) {
                var index = arrIndexOf(_listeners, listener);
                while (index > -1) {
                    _listeners[_DYN_SPLICE /* @min:%2esplice */](index, 1);
                    index = arrIndexOf(_listeners, listener);
                }
            };
            /**
             * Notification for events sent.
             * @param events - The array of events that have been sent.
             */
            _self[STR_EVENTS_SENT /* @min:%2eeventsSent */] = function (events) {
                _runListeners(_listeners, STR_EVENTS_SENT, _asyncNotifications, function (listener) {
                    listener[STR_EVENTS_SENT /* @min:%2eeventsSent */](events);
                });
            };
            /**
             * Notification for events being discarded.
             * @param events - The array of events that have been discarded by the SDK.
             * @param reason - The reason for which the SDK discarded the events. The EventsDiscardedReason
             * constant should be used to check the different values.
             */
            _self[STR_EVENTS_DISCARDED /* @min:%2eeventsDiscarded */] = function (events, reason) {
                _runListeners(_listeners, STR_EVENTS_DISCARDED, _asyncNotifications, function (listener) {
                    listener[STR_EVENTS_DISCARDED /* @min:%2eeventsDiscarded */](events, reason);
                });
            };
            /**
             * [Optional] A function called when the events have been requested to be sent to the sever.
             * @param sendReason - The reason why the event batch is being sent.
             * @param isAsync - A flag which identifies whether the requests are being sent in an async or sync manner.
             */
            _self[STR_EVENTS_SEND_REQUEST /* @min:%2eeventsSendRequest */] = function (sendReason, isAsync) {
                _runListeners(_listeners, STR_EVENTS_SEND_REQUEST, isAsync ? _asyncNotifications : null, function (listener) {
                    listener[STR_EVENTS_SEND_REQUEST /* @min:%2eeventsSendRequest */](sendReason, isAsync);
                });
            };
            _self[STR_PERF_EVENT /* @min:%2eperfEvent */] = function (perfEvent) {
                if (perfEvent) {
                    // Send all events or only parent events
                    if (perfEvtsSendAll || !perfEvent[_DYN_IS_CHILD_EVT /* @min:%2eisChildEvt */]()) {
                        _runListeners(_listeners, STR_PERF_EVENT, null, function (listener) {
                            if (perfEvent[_DYN_IS_ASYNC /* @min:%2eisAsync */]) {
                                scheduleTimeout(function () { return listener[STR_PERF_EVENT /* @min:%2eperfEvent */](perfEvent); }, 0);
                            }
                            else {
                                listener[STR_PERF_EVENT /* @min:%2eperfEvent */](perfEvent);
                            }
                        });
                    }
                }
            };
            _self[STR_OFFLINE_STORE /* @min:%2eofflineEventsStored */] = function (events) {
                if (events && events[_DYN_LENGTH$5 /* @min:%2elength */]) {
                    _runListeners(_listeners, STR_OFFLINE_STORE, _asyncNotifications, function (listener) {
                        listener[STR_OFFLINE_STORE /* @min:%2eofflineEventsStored */](events);
                    });
                }
            };
            _self[STR_OFFLINE_SENT /* @min:%2eofflineBatchSent */] = function (batch) {
                if (batch && batch[_DYN_DATA$1 /* @min:%2edata */]) {
                    _runListeners(_listeners, STR_OFFLINE_SENT, _asyncNotifications, function (listener) {
                        listener[STR_OFFLINE_SENT /* @min:%2eofflineBatchSent */](batch);
                    });
                }
            };
            _self[STR_OFFLINE_DROP /* @min:%2eofflineBatchDrop */] = function (cnt, reason) {
                if (cnt > 0) {
                    var rn_1 = reason || 0; // default is unknown
                    _runListeners(_listeners, STR_OFFLINE_DROP, _asyncNotifications, function (listener) {
                        listener[STR_OFFLINE_DROP /* @min:%2eofflineBatchDrop */](cnt, rn_1);
                    });
                }
            };
            _self[_DYN_UNLOAD /* @min:%2eunload */] = function (isAsync) {
                var _finishUnload = function () {
                    unloadHandler && unloadHandler.rm();
                    unloadHandler = null;
                    _listeners = [];
                    // Clear any async listener
                    _asyncNotifications.h && _asyncNotifications.h[_DYN_CANCEL /* @min:%2ecancel */]();
                    _asyncNotifications.h = null;
                    _asyncNotifications.cb = [];
                };
                var waiting;
                _runListeners(_listeners, "unload", null, function (listener) {
                    var asyncUnload = listener[_DYN_UNLOAD /* @min:%2eunload */](isAsync);
                    if (asyncUnload) {
                        if (!waiting) {
                            waiting = [];
                        }
                        waiting[_DYN_PUSH$2 /* @min:%2epush */](asyncUnload);
                    }
                });
                if (waiting) {
                    return createPromise(function (resolve) {
                        return doAwaitResponse(createAllPromise(waiting), function () {
                            _finishUnload();
                            resolve();
                        });
                    });
                }
                else {
                    _finishUnload();
                }
            };
        });
    }
// Removed Stub for NotificationManager.prototype.addNotificationListener.
// Removed Stub for NotificationManager.prototype.removeNotificationListener.
// Removed Stub for NotificationManager.prototype.eventsSent.
// Removed Stub for NotificationManager.prototype.eventsDiscarded.
// Removed Stub for NotificationManager.prototype.eventsSendRequest.
// Removed Stub for NotificationManager.prototype.perfEvent.
// Removed Stub for NotificationManager.prototype.unload.
// Removed Stub for NotificationManager.prototype.offlineEventsStored.
// Removed Stub for NotificationManager.prototype.offlineBatchSent.
// Removed Stub for NotificationManager.prototype.offlineBatchDrop.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    NotificationManager.__ieDyn=1;

    return NotificationManager;
}());

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var strExecutionContextKey = "ctx";
var strParentContextKey = "ParentContextKey";
var strChildrenContextKey = "ChildrenContextKey";
var _defaultPerfManager = null;
var PerfEvent = /** @class */ (function () {
    function PerfEvent(name, payloadDetails, isAsync) {
        var _self = this;
        _self.start = utcNow();
        _self[_DYN_NAME$3 /* @min:%2ename */] = name;
        _self[_DYN_IS_ASYNC /* @min:%2eisAsync */] = isAsync;
        _self[_DYN_IS_CHILD_EVT /* @min:%2eisChildEvt */] = function () { return false; };
        if (isFunction(payloadDetails)) {
            // Create an accessor to minimize the potential performance impact of executing the payloadDetails callback
            var theDetails_1;
            objDefine(_self, "payload", {
                g: function () {
                    // Delay the execution of the payloadDetails until needed
                    if (!theDetails_1 && isFunction(payloadDetails)) {
                        theDetails_1 = payloadDetails();
                        // clear it out now so the referenced objects can be garbage collected
                        payloadDetails = null;
                    }
                    return theDetails_1;
                }
            });
        }
        _self[_DYN_GET_CTX /* @min:%2egetCtx */] = function (key) {
            if (key) {
                // The parent and child links are located directly on the object (for better viewing in the DebugPlugin)
                if (key === PerfEvent[strParentContextKey] || key === PerfEvent[strChildrenContextKey]) {
                    return _self[key];
                }
                return (_self[strExecutionContextKey] || {})[key];
            }
            return null;
        };
        _self[_DYN_SET_CTX /* @min:%2esetCtx */] = function (key, value) {
            if (key) {
                // Put the parent and child links directly on the object (for better viewing in the DebugPlugin)
                if (key === PerfEvent[strParentContextKey]) {
                    // Simple assumption, if we are setting a parent then we must be a child
                    if (!_self[key]) {
                        _self[_DYN_IS_CHILD_EVT /* @min:%2eisChildEvt */] = function () { return true; };
                    }
                    _self[key] = value;
                }
                else if (key === PerfEvent[strChildrenContextKey]) {
                    _self[key] = value;
                }
                else {
                    var ctx = _self[strExecutionContextKey] = _self[strExecutionContextKey] || {};
                    ctx[key] = value;
                }
            }
        };
        _self[_DYN_COMPLETE /* @min:%2ecomplete */] = function () {
            var childTime = 0;
            var childEvts = _self[_DYN_GET_CTX /* @min:%2egetCtx */](PerfEvent[strChildrenContextKey]);
            if (isArray(childEvts)) {
                for (var lp = 0; lp < childEvts[_DYN_LENGTH$5 /* @min:%2elength */]; lp++) {
                    var childEvt = childEvts[lp];
                    if (childEvt) {
                        childTime += childEvt[_DYN_TIME /* @min:%2etime */];
                    }
                }
            }
            _self[_DYN_TIME /* @min:%2etime */] = utcNow() - _self.start;
            _self.exTime = _self[_DYN_TIME /* @min:%2etime */] - childTime;
            _self[_DYN_COMPLETE /* @min:%2ecomplete */] = function () { };
        };
    }
    PerfEvent.ParentContextKey = "parent";
    PerfEvent.ChildrenContextKey = "childEvts";
    return PerfEvent;
}());
var PerfManager = /** @class */ (function () {
    function PerfManager(manager) {
        /**
         * General bucket used for execution context set and retrieved via setCtx() and getCtx.
         * Defined as private so it can be visualized via the DebugPlugin
         */
        this.ctx = {};
        dynamicProto(PerfManager, this, function (_self) {
            _self.create = function (src, payloadDetails, isAsync) {
                // TODO (@MSNev): at some point we will want to add additional configuration to "select" which events to instrument
                // for now this is just a simple do everything.
                return new PerfEvent(src, payloadDetails, isAsync);
            };
            _self.fire = function (perfEvent) {
                if (perfEvent) {
                    perfEvent[_DYN_COMPLETE /* @min:%2ecomplete */]();
                    if (manager && isFunction(manager[STR_PERF_EVENT /* @min:%2eperfEvent */])) {
                        manager[STR_PERF_EVENT /* @min:%2eperfEvent */](perfEvent);
                    }
                }
            };
            _self[_DYN_SET_CTX /* @min:%2esetCtx */] = function (key, value) {
                if (key) {
                    var ctx = _self[strExecutionContextKey] = _self[strExecutionContextKey] || {};
                    ctx[key] = value;
                }
            };
            _self[_DYN_GET_CTX /* @min:%2egetCtx */] = function (key) {
                return (_self[strExecutionContextKey] || {})[key];
            };
        });
    }
// Removed Stub for PerfManager.prototype.create.
// Removed Stub for PerfManager.prototype.fire.
// Removed Stub for PerfManager.prototype.setCtx.
// Removed Stub for PerfManager.prototype.getCtx.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    PerfManager.__ieDyn=1;

    return PerfManager;
}());
var doPerfActiveKey = "CoreUtils.doPerf";
/**
 * Helper function to wrap a function with a perf event
 * @param mgrSource - The Performance Manager or a Performance provider source (may be null)
 * @param getSource - The callback to create the source name for the event (if perf monitoring is enabled)
 * @param func - The function to call and measure
 * @param details - A function to return the payload details
 * @param isAsync - Is the event / function being call asynchronously or synchronously
 */
function doPerf(mgrSource, getSource, func, details, isAsync) {
    if (mgrSource) {
        var perfMgr = mgrSource;
        if (perfMgr[STR_GET_PERF_MGR]) {
            // Looks like a perf manager provider object
            perfMgr = perfMgr[STR_GET_PERF_MGR]();
        }
        if (perfMgr) {
            var perfEvt = void 0;
            var currentActive = perfMgr[_DYN_GET_CTX /* @min:%2egetCtx */](doPerfActiveKey);
            try {
                perfEvt = perfMgr.create(getSource(), details, isAsync);
                if (perfEvt) {
                    if (currentActive && perfEvt[_DYN_SET_CTX /* @min:%2esetCtx */]) {
                        perfEvt[_DYN_SET_CTX /* @min:%2esetCtx */](PerfEvent[strParentContextKey], currentActive);
                        if (currentActive[_DYN_GET_CTX /* @min:%2egetCtx */] && currentActive[_DYN_SET_CTX /* @min:%2esetCtx */]) {
                            var children = currentActive[_DYN_GET_CTX /* @min:%2egetCtx */](PerfEvent[strChildrenContextKey]);
                            if (!children) {
                                children = [];
                                currentActive[_DYN_SET_CTX /* @min:%2esetCtx */](PerfEvent[strChildrenContextKey], children);
                            }
                            children[_DYN_PUSH$2 /* @min:%2epush */](perfEvt);
                        }
                    }
                    // Set this event as the active event now
                    perfMgr[_DYN_SET_CTX /* @min:%2esetCtx */](doPerfActiveKey, perfEvt);
                    return func(perfEvt);
                }
            }
            catch (ex) {
                if (perfEvt && perfEvt[_DYN_SET_CTX /* @min:%2esetCtx */]) {
                    perfEvt[_DYN_SET_CTX /* @min:%2esetCtx */]("exception", ex);
                }
            }
            finally {
                // fire the perf event
                if (perfEvt) {
                    perfMgr.fire(perfEvt);
                }
                // Reset the active event to the previous value
                perfMgr[_DYN_SET_CTX /* @min:%2esetCtx */](doPerfActiveKey, currentActive);
            }
        }
    }
    return func();
}
/**
 * Get the current global performance manager that will be used with no performance manager is supplied.
 * @returns - The current default manager
 */
function getGblPerfMgr() {
    return _defaultPerfManager;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * generate W3C trace id
 */
function generateW3CId() {
    var hexValues = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"];
    // rfc4122 version 4 UUID without dashes and with lowercase letters
    var oct = STR_EMPTY$1, tmp;
    for (var a = 0; a < 4; a++) {
        tmp = random32();
        oct +=
            hexValues[tmp & 0xF] +
                hexValues[tmp >> 4 & 0xF] +
                hexValues[tmp >> 8 & 0xF] +
                hexValues[tmp >> 12 & 0xF] +
                hexValues[tmp >> 16 & 0xF] +
                hexValues[tmp >> 20 & 0xF] +
                hexValues[tmp >> 24 & 0xF] +
                hexValues[tmp >> 28 & 0xF];
    }
    // "Set the two most significant bits (bits 6 and 7) of the clock_seq_hi_and_reserved to zero and one, respectively"
    var clockSequenceHi = hexValues[8 + (random32() & 0x03) | 0];
    return strSubstr(oct, 0, 8) + strSubstr(oct, 9, 4) + "4" + strSubstr(oct, 13, 3) + clockSequenceHi + strSubstr(oct, 16, 3) + strSubstr(oct, 19, 12);
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var DEFAULT_VERSION = "00";
var INVALID_VERSION = "ff";
var INVALID_TRACE_ID = "00000000000000000000000000000000";
var INVALID_SPAN_ID = "0000000000000000";
function _isValid(value, len, invalidValue) {
    if (value && value[_DYN_LENGTH$5 /* @min:%2elength */] === len && value !== invalidValue) {
        return !!value.match(/^[\da-f]*$/i);
    }
    return false;
}
function _formatValue(value, len, defValue) {
    if (_isValid(value, len)) {
        return value;
    }
    return defValue;
}
function _formatFlags(value) {
    if (isNaN(value) || value < 0 || value > 255) {
        value = 0x01;
    }
    var result = value.toString(16);
    while (result[_DYN_LENGTH$5 /* @min:%2elength */] < 2) {
        result = "0" + result;
    }
    return result;
}
/**
 * Create a new ITraceParent instance using the provided values.
 * @param traceId - The traceId to use, when invalid a new random W3C id will be generated.
 * @param spanId - The parent/span id to use, a new random value will be generated if it is invalid.
 * @param flags - The traceFlags to use, defaults to zero (0) if not supplied or invalid
 * @param version - The version to used, defaults to version "01" if not supplied or invalid.
 * @returns
 */
function createTraceParent(traceId, spanId, flags, version) {
    var _a;
    return _a = {},
        _a[_DYN_VERSION$1 /* @min:version */] = _isValid(version, 2, INVALID_VERSION) ? version : DEFAULT_VERSION,
        _a[_DYN_TRACE_ID$2 /* @min:traceId */] = isValidTraceId(traceId) ? traceId : generateW3CId(),
        _a[_DYN_SPAN_ID$1 /* @min:spanId */] = isValidSpanId(spanId) ? spanId : strLeft(generateW3CId(), 16),
        _a.traceFlags = flags >= 0 && flags <= 0xFF ? flags : 1,
        _a;
}
/**
 * Is the provided W3c Trace Id a valid string representation, it must be a 32-character string
 * of lowercase hexadecimal characters for example, 4bf92f3577b34da6a3ce929d0e0e4736.
 * If all characters as zero (00000000000000000000000000000000) it will be considered an invalid value.
 * @param value - The W3c trace Id to be validated
 * @returns true if valid otherwise false
 */
function isValidTraceId(value) {
    return _isValid(value, 32, INVALID_TRACE_ID);
}
/**
 * Is the provided W3c span id (aka. parent id) a valid string representation, it must be a 16-character
 * string of lowercase hexadecimal characters, for example, 00f067aa0ba902b7.
 * If all characters are zero (0000000000000000) this is considered an invalid value.
 * @param value - The W3c span id to be validated
 * @returns true if valid otherwise false
 */
function isValidSpanId(value) {
    return _isValid(value, 16, INVALID_SPAN_ID);
}
/**
 * Format the ITraceParent value as a string using the supported and know version formats.
 * So even if the passed traceParent is a later version the string value returned from this
 * function will convert it to only the known version formats.
 * This currently only supports version "00" and invalid "ff"
 * @param value - The parsed traceParent value
 * @returns
 */
function formatTraceParent(value) {
    if (value) {
        // Special Note: This only supports formatting as version 00, future versions should encode any known supported version
        // So parsing a future version will populate the correct version value but reformatting will reduce it to version 00.
        var flags = _formatFlags(value[_DYN_TRACE_FLAGS$1 /* @min:%2etraceFlags */]);
        if (!_isValid(flags, 2)) {
            flags = "01";
        }
        var version = value[_DYN_VERSION$1 /* @min:%2eversion */] || DEFAULT_VERSION;
        if (version !== "00" && version !== "ff") {
            // Reduce version to "00"
            version = DEFAULT_VERSION;
        }
        // Format as version 00
        return "".concat(version.toLowerCase(), "-").concat(_formatValue(value.traceId, 32, INVALID_TRACE_ID).toLowerCase(), "-").concat(_formatValue(value.spanId, 16, INVALID_SPAN_ID).toLowerCase(), "-").concat(flags.toLowerCase());
    }
    return "";
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var pluginStateData = createElmNodeData("plugin");
function _getPluginState(plugin) {
    return pluginStateData.get(plugin, "state", {}, true);
}
/**
 * Initialize the queue of plugins
 * @param plugins - The array of plugins to initialize and setting of the next plugin
 * @param config - The current config for the instance
 * @param core - THe current core instance
 * @param extensions - The extensions
 */
function initializePlugins(processContext, extensions) {
    // Set the next plugin and identified the uninitialized plugins
    var initPlugins = [];
    var lastPlugin = null;
    var proxy = processContext[_DYN_GET_NEXT /* @min:%2egetNext */]();
    var pluginState;
    while (proxy) {
        var thePlugin = proxy[_DYN_GET_PLUGIN /* @min:%2egetPlugin */]();
        if (thePlugin) {
            if (lastPlugin && lastPlugin[_DYN_SET_NEXT_PLUGIN /* @min:%2esetNextPlugin */] && thePlugin[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */]) {
                // Set this plugin as the next for the previous one
                lastPlugin[_DYN_SET_NEXT_PLUGIN /* @min:%2esetNextPlugin */](thePlugin);
            }
            pluginState = _getPluginState(thePlugin);
            var isInitialized = !!pluginState[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */];
            if (thePlugin[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */]) {
                isInitialized = thePlugin[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */]();
            }
            if (!isInitialized) {
                initPlugins[_DYN_PUSH$2 /* @min:%2epush */](thePlugin);
            }
            lastPlugin = thePlugin;
            proxy = proxy[_DYN_GET_NEXT /* @min:%2egetNext */]();
        }
    }
    // Now initialize the plugins
    arrForEach(initPlugins, function (thePlugin) {
        var core = processContext[STR_CORE /* @min:%2ecore */]();
        thePlugin[_DYN_INITIALIZE$1 /* @min:%2einitialize */](processContext.getCfg(), core, extensions, processContext[_DYN_GET_NEXT /* @min:%2egetNext */]());
        pluginState = _getPluginState(thePlugin);
        // Only add the core to the state if the plugin didn't set it (doesn't extend from BaseTelemetryPlugin)
        if (!thePlugin[STR_CORE] && !pluginState[STR_CORE]) {
            pluginState[STR_CORE] = core;
        }
        pluginState[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */] = true;
        delete pluginState[_DYN_TEARDOWN /* @min:%2eteardown */];
    });
}
function sortPlugins(plugins) {
    // Sort by priority
    return plugins.sort(function (extA, extB) {
        var result = 0;
        if (extB) {
            var bHasProcess = extB[STR_PROCESS_TELEMETRY];
            if (extA[STR_PROCESS_TELEMETRY]) {
                result = bHasProcess ? extA[STR_PRIORITY] - extB[STR_PRIORITY] : 1;
            }
            else if (bHasProcess) {
                result = -1;
            }
        }
        else {
            result = extA ? 1 : -1;
        }
        return result;
    });
    // sort complete
}
/**
 * Creates a IDistributedTraceContext which optionally also "sets" the value on a parent
 * @param parentCtx - An optional parent distributed trace instance
 * @returns A new IDistributedTraceContext instance that uses an internal temporary object
 */
function createDistributedTraceContext(parentCtx) {
    var trace = {};
    return {
        getName: function () {
            return trace[_DYN_NAME$3 /* @min:%2ename */];
        },
        setName: function (newValue) {
            parentCtx && parentCtx.setName(newValue);
            trace[_DYN_NAME$3 /* @min:%2ename */] = newValue;
        },
        getTraceId: function () {
            return trace[_DYN_TRACE_ID$2 /* @min:%2etraceId */];
        },
        setTraceId: function (newValue) {
            parentCtx && parentCtx.setTraceId(newValue);
            if (isValidTraceId(newValue)) {
                trace[_DYN_TRACE_ID$2 /* @min:%2etraceId */] = newValue;
            }
        },
        getSpanId: function () {
            return trace[_DYN_SPAN_ID$1 /* @min:%2espanId */];
        },
        setSpanId: function (newValue) {
            parentCtx && parentCtx.setSpanId(newValue);
            if (isValidSpanId(newValue)) {
                trace[_DYN_SPAN_ID$1 /* @min:%2espanId */] = newValue;
            }
        },
        getTraceFlags: function () {
            return trace[_DYN_TRACE_FLAGS$1 /* @min:%2etraceFlags */];
        },
        setTraceFlags: function (newTraceFlags) {
            parentCtx && parentCtx.setTraceFlags(newTraceFlags);
            trace[_DYN_TRACE_FLAGS$1 /* @min:%2etraceFlags */] = newTraceFlags;
        }
    };
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var strTelemetryPluginChain = "TelemetryPluginChain";
var strHasRunFlags = "_hasRun";
var strGetTelCtx = "_getTelCtx";
var _chainId = 0;
function _getNextProxyStart(proxy, core, startAt) {
    while (proxy) {
        if (proxy[_DYN_GET_PLUGIN /* @min:%2egetPlugin */]() === startAt) {
            return proxy;
        }
        proxy = proxy[_DYN_GET_NEXT /* @min:%2egetNext */]();
    }
    // This wasn't found in the existing chain so create an isolated one with just this plugin
    return createTelemetryProxyChain([startAt], core.config || {}, core);
}
/**
 * @ignore
 * @param telemetryChain
 * @param dynamicHandler
 * @param core
 * @param startAt - Identifies the next plugin to execute, if null there is no "next" plugin and if undefined it should assume the start of the chain
 * @returns
 */
function _createInternalContext(telemetryChain, dynamicHandler, core, startAt) {
    // We have a special case where we want to start execution from this specific plugin
    // or we simply reuse the existing telemetry plugin chain (normal execution case)
    var _nextProxy = null; // By Default set as no next plugin
    var _onComplete = [];
    if (!dynamicHandler) {
        dynamicHandler = createDynamicConfig({}, null, core[_DYN_LOGGER /* @min:%2elogger */]);
    }
    if (startAt !== null) {
        // There is no next element (null) vs not defined (undefined) so use the full chain
        _nextProxy = startAt ? _getNextProxyStart(telemetryChain, core, startAt) : telemetryChain;
    }
    var context = {
        _next: _moveNext,
        ctx: {
            core: function () {
                return core;
            },
            diagLog: function () {
                return safeGetLogger(core, dynamicHandler.cfg);
            },
            getCfg: function () {
                return dynamicHandler.cfg;
            },
            getExtCfg: _resolveExtCfg,
            getConfig: _getConfig,
            hasNext: function () {
                return !!_nextProxy;
            },
            getNext: function () {
                return _nextProxy;
            },
            setNext: function (nextPlugin) {
                _nextProxy = nextPlugin;
            },
            iterate: _iterateChain,
            onComplete: _addOnComplete
        }
    };
    function _addOnComplete(onComplete, that) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        if (onComplete) {
            _onComplete[_DYN_PUSH$2 /* @min:%2epush */]({
                func: onComplete,
                self: !isUndefined(that) ? that : context.ctx,
                args: args
            });
        }
    }
    function _moveNext() {
        var nextProxy = _nextProxy;
        // Automatically move to the next plugin
        _nextProxy = nextProxy ? nextProxy[_DYN_GET_NEXT /* @min:%2egetNext */]() : null;
        if (!nextProxy) {
            var onComplete = _onComplete;
            if (onComplete && onComplete[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                arrForEach(onComplete, function (completeDetails) {
                    try {
                        completeDetails.func.call(completeDetails.self, completeDetails.args);
                    }
                    catch (e) {
                        _throwInternal(core[_DYN_LOGGER /* @min:%2elogger */], 2 /* eLoggingSeverity.WARNING */, 73 /* _eInternalMessageId.PluginException */, "Unexpected Exception during onComplete - " + dumpObj(e));
                    }
                });
                _onComplete = [];
            }
        }
        return nextProxy;
    }
    function _getExtCfg(identifier, createIfMissing) {
        var idCfg = null;
        var cfg = dynamicHandler.cfg;
        if (cfg && identifier) {
            var extCfg = cfg[STR_EXTENSION_CONFIG /* @min:%2eextensionConfig */];
            if (!extCfg && createIfMissing) {
                extCfg = {};
            }
            // Always set the value so that the property always exists
            cfg[STR_EXTENSION_CONFIG] = extCfg; // Note: it is valid for the "value" to be undefined
            // Calling `ref()` has a side effect of causing the referenced property to become dynamic  (if not already)
            extCfg = dynamicHandler.ref(cfg, STR_EXTENSION_CONFIG);
            if (extCfg) {
                idCfg = extCfg[identifier];
                if (!idCfg && createIfMissing) {
                    idCfg = {};
                }
                // Always set the value so that the property always exists
                extCfg[identifier] = idCfg; // Note: it is valid for the "value" to be undefined
                // Calling `ref()` has a side effect of causing the referenced property to become dynamic  (if not already)
                idCfg = dynamicHandler.ref(extCfg, identifier);
            }
        }
        return idCfg;
    }
    function _resolveExtCfg(identifier, defaultValues) {
        var newConfig = _getExtCfg(identifier, true);
        if (defaultValues) {
            // Enumerate over the defaultValues and if not already populated attempt to
            // find a value from the root config or use the default value
            objForEachKey(defaultValues, function (field, defaultValue) {
                // for each unspecified field, set the default value
                if (isNullOrUndefined(newConfig[field])) {
                    var cfgValue = dynamicHandler.cfg[field];
                    if (cfgValue || !isNullOrUndefined(cfgValue)) {
                        newConfig[field] = cfgValue;
                    }
                }
                _applyDefaultValue(dynamicHandler, newConfig, field, defaultValue);
            });
        }
        return dynamicHandler[_DYN_SET_DF /* @min:%2esetDf */](newConfig, defaultValues);
    }
    function _getConfig(identifier, field, defaultValue) {
        if (defaultValue === void 0) { defaultValue = false; }
        var theValue;
        var extConfig = _getExtCfg(identifier, false);
        var rootConfig = dynamicHandler.cfg;
        if (extConfig && (extConfig[field] || !isNullOrUndefined(extConfig[field]))) {
            theValue = extConfig[field];
        }
        else if (rootConfig[field] || !isNullOrUndefined(rootConfig[field])) {
            theValue = rootConfig[field];
        }
        return (theValue || !isNullOrUndefined(theValue)) ? theValue : defaultValue;
    }
    function _iterateChain(cb) {
        // Keep processing until we reach the end of the chain
        var nextPlugin;
        while (!!(nextPlugin = context._next())) {
            var plugin = nextPlugin[_DYN_GET_PLUGIN /* @min:%2egetPlugin */]();
            if (plugin) {
                // callback with the current on
                cb(plugin);
            }
        }
    }
    return context;
}
/**
 * Creates a new Telemetry Item context with the current config, core and plugin execution chain
 * @param plugins - The plugin instances that will be executed
 * @param config - The current config
 * @param core - The current core instance
 * @param startAt - Identifies the next plugin to execute, if null there is no "next" plugin and if undefined it should assume the start of the chain
 */
function createProcessTelemetryContext(telemetryChain, cfg, core, startAt) {
    var config = createDynamicConfig(cfg);
    var internalContext = _createInternalContext(telemetryChain, config, core, startAt);
    var context = internalContext.ctx;
    function _processNext(env) {
        var nextPlugin = internalContext._next();
        if (nextPlugin) {
            // Run the next plugin which will call "processNext()"
            nextPlugin[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */](env, context);
        }
        return !nextPlugin;
    }
    function _createNew(plugins, startAt) {
        if (plugins === void 0) { plugins = null; }
        if (isArray(plugins)) {
            plugins = createTelemetryProxyChain(plugins, config.cfg, core, startAt);
        }
        return createProcessTelemetryContext(plugins || context[_DYN_GET_NEXT /* @min:%2egetNext */](), config.cfg, core, startAt);
    }
    context[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */] = _processNext;
    context[_DYN_CREATE_NEW$1 /* @min:%2ecreateNew */] = _createNew;
    return context;
}
/**
 * Creates a new Telemetry Item context with the current config, core and plugin execution chain for handling the unloading of the chain
 * @param plugins - The plugin instances that will be executed
 * @param config - The current config
 * @param core - The current core instance
 * @param startAt - Identifies the next plugin to execute, if null there is no "next" plugin and if undefined it should assume the start of the chain
 */
function createProcessTelemetryUnloadContext(telemetryChain, core, startAt) {
    var config = createDynamicConfig(core.config);
    var internalContext = _createInternalContext(telemetryChain, config, core, startAt);
    var context = internalContext.ctx;
    function _processNext(unloadState) {
        var nextPlugin = internalContext._next();
        nextPlugin && nextPlugin[_DYN_UNLOAD /* @min:%2eunload */](context, unloadState);
        return !nextPlugin;
    }
    function _createNew(plugins, startAt) {
        if (plugins === void 0) { plugins = null; }
        if (isArray(plugins)) {
            plugins = createTelemetryProxyChain(plugins, config.cfg, core, startAt);
        }
        return createProcessTelemetryUnloadContext(plugins || context[_DYN_GET_NEXT /* @min:%2egetNext */](), core, startAt);
    }
    context[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */] = _processNext;
    context[_DYN_CREATE_NEW$1 /* @min:%2ecreateNew */] = _createNew;
    return context;
}
/**
 * Creates a new Telemetry Item context with the current config, core and plugin execution chain for updating the configuration
 * @param plugins - The plugin instances that will be executed
 * @param config - The current config
 * @param core - The current core instance
 * @param startAt - Identifies the next plugin to execute, if null there is no "next" plugin and if undefined it should assume the start of the chain
 */
function createProcessTelemetryUpdateContext(telemetryChain, core, startAt) {
    var config = createDynamicConfig(core.config);
    var internalContext = _createInternalContext(telemetryChain, config, core, startAt);
    var context = internalContext.ctx;
    function _processNext(updateState) {
        return context.iterate(function (plugin) {
            if (isFunction(plugin[_DYN_UPDATE$1 /* @min:%2eupdate */])) {
                plugin[_DYN_UPDATE$1 /* @min:%2eupdate */](context, updateState);
            }
        });
    }
    function _createNew(plugins, startAt) {
        if (plugins === void 0) { plugins = null; }
        if (isArray(plugins)) {
            plugins = createTelemetryProxyChain(plugins, config.cfg, core, startAt);
        }
        return createProcessTelemetryUpdateContext(plugins || context[_DYN_GET_NEXT /* @min:%2egetNext */](), core, startAt);
    }
    context[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */] = _processNext;
    context[_DYN_CREATE_NEW$1 /* @min:%2ecreateNew */] = _createNew;
    return context;
}
/**
 * Creates an execution chain from the array of plugins
 * @param plugins - The array of plugins that will be executed in this order
 * @param defItemCtx - The default execution context to use when no telemetry context is passed to processTelemetry(), this
 * should be for legacy plugins only. Currently, only used for passing the current core instance and to provide better error
 * reporting (hasRun) when errors occur.
 */
function createTelemetryProxyChain(plugins, config, core, startAt) {
    var firstProxy = null;
    var add = startAt ? false : true;
    if (isArray(plugins) && plugins[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
        // Create the proxies and wire up the next plugin chain
        var lastProxy_1 = null;
        arrForEach(plugins, function (thePlugin) {
            if (!add && startAt === thePlugin) {
                add = true;
            }
            if (add && thePlugin && isFunction(thePlugin[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */])) {
                // Only add plugins that are processors
                var newProxy = createTelemetryPluginProxy(thePlugin, config, core);
                if (!firstProxy) {
                    firstProxy = newProxy;
                }
                if (lastProxy_1) {
                    // Set this new proxy as the next for the previous one
                    lastProxy_1._setNext(newProxy);
                }
                lastProxy_1 = newProxy;
            }
        });
    }
    if (startAt && !firstProxy) {
        // Special case where the "startAt" was not in the original list of plugins
        return createTelemetryProxyChain([startAt], config, core);
    }
    return firstProxy;
}
/**
 * Create the processing telemetry proxy instance, the proxy is used to abstract the current plugin to allow monitoring and
 * execution plugins while passing around the dynamic execution state (IProcessTelemetryContext), the proxy instance no longer
 * contains any execution state and can be reused between requests (this was not the case for 2.7.2 and earlier with the
 * TelemetryPluginChain class).
 * @param plugin - The plugin instance to proxy
 * @param config - The default execution context to use when no telemetry context is passed to processTelemetry(), this
 * should be for legacy plugins only. Currently, only used for passing the current core instance and to provide better error
 * reporting (hasRun) when errors occur.
 * @returns
 */
function createTelemetryPluginProxy(plugin, config, core) {
    var nextProxy = null;
    var hasProcessTelemetry = isFunction(plugin[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */]);
    var hasSetNext = isFunction(plugin[_DYN_SET_NEXT_PLUGIN /* @min:%2esetNextPlugin */]);
    var chainId;
    if (plugin) {
        chainId = plugin[_DYN_IDENTIFIER /* @min:%2eidentifier */] + "-" + plugin[STR_PRIORITY /* @min:%2epriority */] + "-" + _chainId++;
    }
    else {
        chainId = "Unknown-0-" + _chainId++;
    }
    var proxyChain = {
        getPlugin: function () {
            return plugin;
        },
        getNext: function () {
            return nextProxy;
        },
        processTelemetry: _processTelemetry,
        unload: _unloadPlugin,
        update: _updatePlugin,
        _id: chainId,
        _setNext: function (nextPlugin) {
            nextProxy = nextPlugin;
        }
    };
    function _getTelCtx() {
        var itemCtx;
        // Looks like a plugin didn't pass the (optional) context, so create a new one
        if (plugin && isFunction(plugin[strGetTelCtx])) {
            // This plugin extends from the BaseTelemetryPlugin so lets use it
            itemCtx = plugin[strGetTelCtx]();
        }
        if (!itemCtx) {
            // Create a temporary one
            itemCtx = createProcessTelemetryContext(proxyChain, config, core);
        }
        return itemCtx;
    }
    function _processChain(itemCtx, processPluginFn, name, details, isAsync) {
        var hasRun = false;
        var identifier = plugin ? plugin[_DYN_IDENTIFIER /* @min:%2eidentifier */] : strTelemetryPluginChain;
        var hasRunContext = itemCtx[strHasRunFlags];
        if (!hasRunContext) {
            // Assign and populate
            hasRunContext = itemCtx[strHasRunFlags] = {};
        }
        // Ensure that we keep the context in sync
        itemCtx.setNext(nextProxy);
        if (plugin) {
            doPerf(itemCtx[STR_CORE /* @min:%2ecore */](), function () { return identifier + ":" + name; }, function () {
                // Mark this component as having run
                hasRunContext[chainId] = true;
                try {
                    // Set a flag on the next plugin so we know if it was attempted to be executed
                    var nextId = nextProxy ? nextProxy._id : STR_EMPTY$1;
                    if (nextId) {
                        hasRunContext[nextId] = false;
                    }
                    hasRun = processPluginFn(itemCtx);
                }
                catch (error) {
                    var hasNextRun = nextProxy ? hasRunContext[nextProxy._id] : true;
                    if (hasNextRun) {
                        // The next plugin after us has already run so set this one as complete
                        hasRun = true;
                    }
                    if (!nextProxy || !hasNextRun) {
                        // Either we have no next plugin or the current one did not attempt to call the next plugin
                        // Which means the current one is the root of the failure so log/report this failure
                        _throwInternal(itemCtx[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */](), 1 /* eLoggingSeverity.CRITICAL */, 73 /* _eInternalMessageId.PluginException */, "Plugin [" + identifier + "] failed during " + name + " - " + dumpObj(error) + ", run flags: " + dumpObj(hasRunContext));
                    }
                }
            }, details, isAsync);
        }
        return hasRun;
    }
    function _processTelemetry(env, itemCtx) {
        itemCtx = itemCtx || _getTelCtx();
        function _callProcessTelemetry(itemCtx) {
            if (!plugin || !hasProcessTelemetry) {
                return false;
            }
            var pluginState = _getPluginState(plugin);
            if (pluginState[_DYN_TEARDOWN /* @min:%2eteardown */] || pluginState[STR_DISABLED]) {
                return false;
            }
            // Ensure that we keep the context in sync (for processNext()), just in case a plugin
            // doesn't calls processTelemetry() instead of itemContext.processNext() or some
            // other form of error occurred
            if (hasSetNext) {
                // Backward compatibility setting the next plugin on the instance
                plugin[_DYN_SET_NEXT_PLUGIN /* @min:%2esetNextPlugin */](nextProxy);
            }
            plugin[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */](env, itemCtx);
            // Process Telemetry is expected to call itemCtx.processNext() or nextPlugin.processTelemetry()
            return true;
        }
        if (!_processChain(itemCtx, _callProcessTelemetry, "processTelemetry", function () { return ({ item: env }); }, !(env.sync))) {
            // The underlying plugin is either not defined, not enabled or does not have a processTelemetry implementation
            // so we still want the next plugin to be executed.
            itemCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](env);
        }
    }
    function _unloadPlugin(unloadCtx, unloadState) {
        function _callTeardown() {
            // Setting default of hasRun as false so the proxyProcessFn() is called as teardown() doesn't have to exist or call unloadNext().
            var hasRun = false;
            if (plugin) {
                var pluginState = _getPluginState(plugin);
                var pluginCore = plugin[STR_CORE] || pluginState[STR_CORE /* @min:%2ecore */];
                // Only teardown the plugin if it was initialized by the current core (i.e. It's not a shared plugin)
                if (plugin && (!pluginCore || pluginCore === unloadCtx.core()) && !pluginState[_DYN_TEARDOWN /* @min:%2eteardown */]) {
                    // Handle plugins that don't extend from the BaseTelemetryPlugin
                    pluginState[STR_CORE /* @min:%2ecore */] = null;
                    pluginState[_DYN_TEARDOWN /* @min:%2eteardown */] = true;
                    pluginState[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */] = false;
                    if (plugin[_DYN_TEARDOWN /* @min:%2eteardown */] && plugin[_DYN_TEARDOWN /* @min:%2eteardown */](unloadCtx, unloadState) === true) {
                        // plugin told us that it was going to (or has) call unloadCtx.processNext()
                        hasRun = true;
                    }
                }
            }
            return hasRun;
        }
        if (!_processChain(unloadCtx, _callTeardown, "unload", function () { }, unloadState[_DYN_IS_ASYNC /* @min:%2eisAsync */])) {
            // Only called if we hasRun was not true
            unloadCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](unloadState);
        }
    }
    function _updatePlugin(updateCtx, updateState) {
        function _callUpdate() {
            // Setting default of hasRun as false so the proxyProcessFn() is called as teardown() doesn't have to exist or call unloadNext().
            var hasRun = false;
            if (plugin) {
                var pluginState = _getPluginState(plugin);
                var pluginCore = plugin[STR_CORE] || pluginState[STR_CORE /* @min:%2ecore */];
                // Only update the plugin if it was initialized by the current core (i.e. It's not a shared plugin)
                if (plugin && (!pluginCore || pluginCore === updateCtx.core()) && !pluginState[_DYN_TEARDOWN /* @min:%2eteardown */]) {
                    if (plugin[_DYN_UPDATE$1 /* @min:%2eupdate */] && plugin[_DYN_UPDATE$1 /* @min:%2eupdate */](updateCtx, updateState) === true) {
                        // plugin told us that it was going to (or has) call unloadCtx.processNext()
                        hasRun = true;
                    }
                }
            }
            return hasRun;
        }
        if (!_processChain(updateCtx, _callUpdate, "update", function () { }, false)) {
            // Only called if we hasRun was not true
            updateCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](updateState);
        }
    }
    return objFreeze(proxyChain);
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

function createUnloadHandlerContainer() {
    var handlers = [];
    function _addHandler(handler) {
        if (handler) {
            handlers[_DYN_PUSH$2 /* @min:%2epush */](handler);
        }
    }
    function _runHandlers(unloadCtx, unloadState) {
        arrForEach(handlers, function (handler) {
            try {
                handler(unloadCtx, unloadState);
            }
            catch (e) {
                _throwInternal(unloadCtx[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 73 /* _eInternalMessageId.PluginException */, "Unexpected error calling unload handler - " + dumpObj(e));
            }
        });
        handlers = [];
    }
    return {
        add: _addHandler,
        run: _runHandlers
    };
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Create a IUnloadHookContainer which can be used to remember unload hook functions to be executed during the component unloading
 * process.
 * @returns A new IUnloadHookContainer instance
 */
function createUnloadHookContainer() {
    var _hooks = [];
    function _doUnload(logger) {
        var oldHooks = _hooks;
        _hooks = [];
        // Remove all registered unload hooks
        arrForEach(oldHooks, function (fn) {
            // allow either rm or remove callback function
            try {
                (fn.rm || fn.remove).call(fn);
            }
            catch (e) {
                _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 73 /* _eInternalMessageId.PluginException */, "Unloading:" + dumpObj(e));
            }
        });
    }
    function _addHook(hooks) {
        if (hooks) {
            arrAppend(_hooks, hooks);
        }
    }
    return {
        run: _doUnload,
        add: _addHook
    };
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var _a$7;
var strGetPlugin = "getPlugin";
var defaultValues$1 = (_a$7 = {},
    _a$7[STR_EXTENSION_CONFIG] = { isVal: isNotNullOrUndefined, v: {} },
    _a$7);
/**
 * BaseTelemetryPlugin provides a basic implementation of the ITelemetryPlugin interface so that plugins
 * can avoid implementation the same set of boiler plate code as well as provide a base
 * implementation so that new default implementations can be added without breaking all plugins.
 */
var BaseTelemetryPlugin = /** @class */ (function () {
    function BaseTelemetryPlugin() {
        var _self = this; // Setting _self here as it's used outside of the dynamicProto as well
        // NOTE!: DON'T set default values here, instead set them in the _initDefaults() function as it is also called during teardown()
        var _isinitialized;
        var _rootCtx; // Used as the root context, holding the current config and initialized core
        var _nextPlugin; // Used for backward compatibility where plugins don't call the main pipeline
        var _unloadHandlerContainer;
        var _hookContainer;
        _initDefaults();
        dynamicProto(BaseTelemetryPlugin, _self, function (_self) {
            _self[_DYN_INITIALIZE$1 /* @min:%2einitialize */] = function (config, core, extensions, pluginChain) {
                _setDefaults(config, core, pluginChain);
                _isinitialized = true;
            };
            _self[_DYN_TEARDOWN /* @min:%2eteardown */] = function (unloadCtx, unloadState) {
                var _a;
                // If this plugin has already been torn down (not operational) or is not initialized (core is not set)
                // or the core being used for unload was not the same core used for initialization.
                var core = _self[STR_CORE /* @min:%2ecore */];
                if (!core || (unloadCtx && core !== unloadCtx[STR_CORE /* @min:%2ecore */]())) {
                    // Do Nothing as either the plugin is not initialized or was not initialized by the current core
                    return;
                }
                var result;
                var unloadDone = false;
                var theUnloadCtx = unloadCtx || createProcessTelemetryUnloadContext(null, core, _nextPlugin && _nextPlugin[strGetPlugin] ? _nextPlugin[strGetPlugin]() : _nextPlugin);
                var theUnloadState = unloadState || (_a = {
                        reason: 0 /* TelemetryUnloadReason.ManualTeardown */
                    },
                    _a[_DYN_IS_ASYNC /* @min:isAsync */] = false,
                    _a);
                function _unloadCallback() {
                    if (!unloadDone) {
                        unloadDone = true;
                        _unloadHandlerContainer.run(theUnloadCtx, unloadState);
                        _hookContainer.run(theUnloadCtx[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */]());
                        if (result === true) {
                            theUnloadCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](theUnloadState);
                        }
                        _initDefaults();
                    }
                }
                if (!_self[_DYN__DO_TEARDOWN /* @min:%2e_doTeardown */] || _self[_DYN__DO_TEARDOWN /* @min:%2e_doTeardown */](theUnloadCtx, theUnloadState, _unloadCallback) !== true) {
                    _unloadCallback();
                }
                else {
                    // Tell the caller that we will be calling processNext()
                    result = true;
                }
                return result;
            };
            _self[_DYN_UPDATE$1 /* @min:%2eupdate */] = function (updateCtx, updateState) {
                // If this plugin has already been torn down (not operational) or is not initialized (core is not set)
                // or the core being used for unload was not the same core used for initialization.
                var core = _self[STR_CORE /* @min:%2ecore */];
                if (!core || (updateCtx && core !== updateCtx[STR_CORE /* @min:%2ecore */]())) {
                    // Do Nothing
                    return;
                }
                var result;
                var updateDone = false;
                var theUpdateCtx = updateCtx || createProcessTelemetryUpdateContext(null, core, _nextPlugin && _nextPlugin[strGetPlugin] ? _nextPlugin[strGetPlugin]() : _nextPlugin);
                var theUpdateState = updateState || {
                    reason: 0 /* TelemetryUpdateReason.Unknown */
                };
                function _updateCallback() {
                    if (!updateDone) {
                        updateDone = true;
                        _setDefaults(theUpdateCtx.getCfg(), theUpdateCtx.core(), theUpdateCtx[_DYN_GET_NEXT /* @min:%2egetNext */]());
                    }
                }
                if (!_self._doUpdate || _self._doUpdate(theUpdateCtx, theUpdateState, _updateCallback) !== true) {
                    _updateCallback();
                }
                else {
                    result = true;
                }
                return result;
            };
            proxyFunctionAs(_self, "_addUnloadCb", function () { return _unloadHandlerContainer; }, "add");
            proxyFunctionAs(_self, "_addHook", function () { return _hookContainer; }, "add");
            objDefine(_self, "_unloadHooks", { g: function () { return _hookContainer; } });
        });
        // These are added after the dynamicProto so that are not moved to the prototype
        _self[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */] = function (itemCtx) {
            return _getTelCtx(itemCtx)[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */]();
        };
        _self[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */] = function () {
            return _isinitialized;
        };
        _self.setInitialized = function (isInitialized) {
            _isinitialized = isInitialized;
        };
        // _self.getNextPlugin = () => DO NOT IMPLEMENT
        // Sub-classes of this base class *should* not be relying on this value and instead
        // should use processNext() function. If you require access to the plugin use the
        // IProcessTelemetryContext.getNext().getPlugin() while in the pipeline, Note getNext() may return null.
        _self[_DYN_SET_NEXT_PLUGIN /* @min:%2esetNextPlugin */] = function (next) {
            _nextPlugin = next;
        };
        _self[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */] = function (env, itemCtx) {
            if (itemCtx) {
                // Normal core execution sequence
                itemCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](env);
            }
            else if (_nextPlugin && isFunction(_nextPlugin[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */])) {
                // Looks like backward compatibility or out of band processing. And as it looks
                // like a ITelemetryPlugin or ITelemetryPluginChain, just call processTelemetry
                _nextPlugin[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */](env, null);
            }
        };
        _self._getTelCtx = _getTelCtx;
        function _getTelCtx(currentCtx) {
            if (currentCtx === void 0) { currentCtx = null; }
            var itemCtx = currentCtx;
            if (!itemCtx) {
                var rootCtx = _rootCtx || createProcessTelemetryContext(null, {}, _self[STR_CORE /* @min:%2ecore */]);
                // tslint:disable-next-line: prefer-conditional-expression
                if (_nextPlugin && _nextPlugin[strGetPlugin]) {
                    // Looks like a chain object
                    itemCtx = rootCtx[_DYN_CREATE_NEW$1 /* @min:%2ecreateNew */](null, _nextPlugin[strGetPlugin]);
                }
                else {
                    itemCtx = rootCtx[_DYN_CREATE_NEW$1 /* @min:%2ecreateNew */](null, _nextPlugin);
                }
            }
            return itemCtx;
        }
        function _setDefaults(config, core, pluginChain) {
            // Make sure the extensionConfig exists and the config is dynamic
            createDynamicConfig(config, defaultValues$1, safeGetLogger(core));
            if (!pluginChain && core) {
                // Get the first plugin from the core
                pluginChain = core[_DYN_GET_PROCESS_TEL_CONT2 /* @min:%2egetProcessTelContext */]()[_DYN_GET_NEXT /* @min:%2egetNext */]();
            }
            var nextPlugin = _nextPlugin;
            if (_nextPlugin && _nextPlugin[strGetPlugin]) {
                // If it looks like a proxy/chain then get the plugin
                nextPlugin = _nextPlugin[strGetPlugin]();
            }
            // Support legacy plugins where core was defined as a property
            _self[STR_CORE /* @min:%2ecore */] = core;
            _rootCtx = createProcessTelemetryContext(pluginChain, config, core, nextPlugin);
        }
        function _initDefaults() {
            _isinitialized = false;
            _self[STR_CORE /* @min:%2ecore */] = null;
            _rootCtx = null;
            _nextPlugin = null;
            _hookContainer = createUnloadHookContainer();
            _unloadHandlerContainer = createUnloadHandlerContainer();
        }
    }
// Removed Stub for BaseTelemetryPlugin.prototype.initialize.
// Removed Stub for BaseTelemetryPlugin.prototype.teardown.
// Removed Stub for BaseTelemetryPlugin.prototype.update.
// Removed Stub for BaseTelemetryPlugin.prototype._addUnloadCb.
// Removed Stub for BaseTelemetryPlugin.prototype._addHook.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    BaseTelemetryPlugin.__ieDyn=1;

    return BaseTelemetryPlugin;
}());

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
// 
// 
function _addInitializer(_initializers, id, telemetryInitializer) {
    var theInitializer = {
        id: id,
        fn: telemetryInitializer
    };
    arrAppend(_initializers, theInitializer);
    var handler = {
        remove: function () {
            arrForEach(_initializers, function (initializer, idx) {
                if (initializer.id === theInitializer.id) {
                    _initializers[_DYN_SPLICE /* @min:%2esplice */](idx, 1);
                    return -1;
                }
            });
        }
    };
    return handler;
}
function _runInitializers(_initializers, item, logger) {
    var doNotSendItem = false;
    var telemetryInitializersCount = _initializers[_DYN_LENGTH$5 /* @min:%2elength */];
    for (var i = 0; i < telemetryInitializersCount; ++i) {
        var telemetryInitializer = _initializers[i];
        if (telemetryInitializer) {
            try {
                if (telemetryInitializer.fn[_DYN_APPLY /* @min:%2eapply */](null, [item]) === false) {
                    doNotSendItem = true;
                    break;
                }
            }
            catch (e) {
                // log error but dont stop executing rest of the telemetry initializers
                // doNotSendItem = true;
                _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 64 /* _eInternalMessageId.TelemetryInitializerFailed */, "Telemetry initializer failed: " + getExceptionName(e), { exception: dumpObj(e) }, true);
            }
        }
    }
    return !doNotSendItem;
}
var TelemetryInitializerPlugin = /** @class */ (function (_super) {
    __extendsFn(TelemetryInitializerPlugin, _super);
    function TelemetryInitializerPlugin() {
        var _this = _super.call(this) || this;
        _this.identifier = "TelemetryInitializerPlugin";
        _this.priority = 199;
        // NOTE!: DON'T set default values here, instead set them in the _initDefaults() function as it is also called during teardown()
        var _id;
        var _initializers;
        _initDefaults();
        dynamicProto(TelemetryInitializerPlugin, _this, function (_self, _base) {
            _self.addTelemetryInitializer = function (telemetryInitializer) {
                return _addInitializer(_initializers, _id++, telemetryInitializer);
            };
            _self[STR_PROCESS_TELEMETRY /* @min:%2eprocessTelemetry */] = function (item, itemCtx) {
                if (_runInitializers(_initializers, item, itemCtx ? itemCtx[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */]() : _self[_DYN_DIAG_LOG$2 /* @min:%2ediagLog */]())) {
                    _self[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](item, itemCtx);
                }
            };
            _self[_DYN__DO_TEARDOWN /* @min:%2e_doTeardown */] = function () {
                _initDefaults();
            };
        });
        function _initDefaults() {
            _id = 0;
            _initializers = [];
        }
        return _this;
    }
// Removed Stub for TelemetryInitializerPlugin.prototype.addTelemetryInitializer.
// Removed Stub for TelemetryInitializerPlugin.prototype.processTelemetry.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    TelemetryInitializerPlugin.__ieDyn=1;

    return TelemetryInitializerPlugin;
}(BaseTelemetryPlugin));

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var _a$6;
var strValidationError = "Plugins must provide initialize method";
var strNotificationManager = "_notificationManager";
var strSdkUnloadingError = "SDK is still unloading...";
var strSdkNotInitialized = "SDK is not initialized";
var maxInitQueueSize = 100;
var maxInitTimeout = 50000;
// const strPluginUnloadFailed = "Failed to unload plugin";
/**
 * The default settings for the config.
 * WE MUST include all defaults here to ensure that the config is created with all of the properties
 * defined as dynamic.
 */
var defaultConfig = objDeepFreeze((_a$6 = {
        cookieCfg: {}
    },
    _a$6[STR_EXTENSIONS] = { rdOnly: true, ref: true, v: [] },
    _a$6[STR_CHANNELS] = { rdOnly: true, ref: true, v: [] },
    _a$6[STR_EXTENSION_CONFIG] = { ref: true, v: {} },
    _a$6[STR_CREATE_PERF_MGR] = UNDEFINED_VALUE$2,
    _a$6.loggingLevelConsole = 0 /* eLoggingSeverity.DISABLED */,
    _a$6.diagnosticLogInterval = UNDEFINED_VALUE$2,
    _a$6));
/**
 * Helper to create the default performance manager
 * @param core
 * @param notificationMgr
 */
function _createPerfManager(core, notificationMgr) {
    return new PerfManager(notificationMgr);
}
function _validateExtensions(logger, channelPriority, allExtensions) {
    var _a;
    // Concat all available extensions
    var coreExtensions = [];
    var channels = [];
    // Check if any two extensions have the same priority, then warn to console
    // And extract the local extensions from the
    var extPriorities = {};
    // Extension validation
    arrForEach(allExtensions, function (ext) {
        // Check for ext.initialize
        if (isNullOrUndefined(ext) || isNullOrUndefined(ext[_DYN_INITIALIZE$1 /* @min:%2einitialize */])) {
            throwError(strValidationError);
        }
        var extPriority = ext[STR_PRIORITY /* @min:%2epriority */];
        var identifier = ext[_DYN_IDENTIFIER /* @min:%2eidentifier */];
        if (ext && extPriority) {
            if (!isNullOrUndefined(extPriorities[extPriority])) {
                _warnToConsole(logger, "Two extensions have same priority #" + extPriority + " - " + extPriorities[extPriority] + ", " + identifier);
            }
            else {
                // set a value
                extPriorities[extPriority] = identifier;
            }
        }
        // Split extensions to core and channels
        if (!extPriority || extPriority < channelPriority) {
            // Add to core extension that will be managed by AppInsightsCore
            coreExtensions[_DYN_PUSH$2 /* @min:%2epush */](ext);
        }
        else {
            channels[_DYN_PUSH$2 /* @min:%2epush */](ext);
        }
    });
    return _a = {},
        _a[STR_CORE /* @min:core */] = coreExtensions,
        _a[STR_CHANNELS /* @min:channels */] = channels,
        _a;
}
function _isPluginPresent(thePlugin, plugins) {
    var exists = false;
    arrForEach(plugins, function (plugin) {
        if (plugin === thePlugin) {
            exists = true;
            return -1;
        }
    });
    return exists;
}
function _deepMergeConfig(details, target, newValues, merge) {
    // Lets assign the new values to the existing config
    if (newValues) {
        objForEachKey(newValues, function (key, value) {
            if (merge) {
                if (isPlainObject(value) && isPlainObject(target[key])) {
                    // The target is an object and it has a value
                    _deepMergeConfig(details, target[key], value, merge);
                }
            }
            if (merge && isPlainObject(value) && isPlainObject(target[key])) {
                // The target is an object and it has a value
                _deepMergeConfig(details, target[key], value, merge);
            }
            else {
                // Just Assign (replace) and/or make the property dynamic
                details.set(target, key, value);
            }
        });
    }
}
function _findWatcher(listeners, newWatcher) {
    var theListener = null;
    var idx = -1;
    arrForEach(listeners, function (listener, lp) {
        if (listener.w === newWatcher) {
            theListener = listener;
            idx = lp;
            return -1;
        }
    });
    return { i: idx, l: theListener };
}
function _addDelayedCfgListener(listeners, newWatcher) {
    var theListener = _findWatcher(listeners, newWatcher).l;
    if (!theListener) {
        theListener = {
            w: newWatcher,
            rm: function () {
                var fnd = _findWatcher(listeners, newWatcher);
                if (fnd.i !== -1) {
                    listeners[_DYN_SPLICE /* @min:%2esplice */](fnd.i, 1);
                }
            }
        };
        listeners[_DYN_PUSH$2 /* @min:%2epush */](theListener);
    }
    return theListener;
}
function _registerDelayedCfgListener(config, listeners, logger) {
    arrForEach(listeners, function (listener) {
        var unloadHdl = onConfigChange(config, listener.w, logger);
        delete listener.w; // Clear the listener reference so it will get garbage collected.
        // replace the remove function
        listener.rm = function () {
            unloadHdl.rm();
        };
    });
}
// Moved this outside of the closure to reduce the retained memory footprint
function _initDebugListener(configHandler, unloadContainer, notificationManager, debugListener) {
    // Will get recalled if any referenced config values are changed
    unloadContainer.add(configHandler[_DYN_WATCH /* @min:%2ewatch */](function (details) {
        var disableDbgExt = details.cfg.disableDbgExt;
        if (disableDbgExt === true && debugListener) {
            // Remove any previously loaded debug listener
            notificationManager[_DYN_REMOVE_NOTIFICATION_0 /* @min:%2eremoveNotificationListener */](debugListener);
            debugListener = null;
        }
        if (notificationManager && !debugListener && disableDbgExt !== true) {
            debugListener = getDebugListener(details.cfg);
            notificationManager[_DYN_ADD_NOTIFICATION_LIS1 /* @min:%2eaddNotificationListener */](debugListener);
        }
    }));
    return debugListener;
}
// Moved this outside of the closure to reduce the retained memory footprint
function _createUnloadHook(unloadHook) {
    return objDefine({
        rm: function () {
            unloadHook.rm();
        }
    }, "toJSON", { v: function () { return "aicore::onCfgChange<" + JSON.stringify(unloadHook) + ">"; } });
}
/**
 * @group Classes
 * @group Entrypoint
 */
var AppInsightsCore = /** @class */ (function () {
    function AppInsightsCore() {
        // NOTE!: DON'T set default values here, instead set them in the _initDefaults() function as it is also called during teardown()
        var _configHandler;
        var _isInitialized;
        var _logger;
        var _eventQueue;
        var _notificationManager;
        var _perfManager;
        var _cfgPerfManager;
        var _cookieManager;
        var _pluginChain;
        var _configExtensions;
        var _channelConfig;
        var _channels;
        var _isUnloading;
        var _telemetryInitializerPlugin;
        var _internalLogsEventName;
        var _evtNamespace;
        var _unloadHandlers;
        var _hookContainer;
        var _debugListener;
        var _traceCtx;
        var _instrumentationKey;
        var _cfgListeners;
        var _extensions;
        var _pluginVersionStringArr;
        var _pluginVersionString;
        var _activeStatus; // to indicate if ikey or endpoint url promised is resolved or not
        var _endpoint;
        var _initInMemoMaxSize; // max event count limit during wait for init promises to be resolved
        var _isStatusSet; // track if active status is set in case of init timeout and init promises setting the status twice
        /**
         * Internal log poller
         */
        var _internalLogPoller;
        var _internalLogPollerListening;
        var _forceStopInternalLogPoller;
        dynamicProto(AppInsightsCore, this, function (_self) {
            // Set the default values (also called during teardown)
            _initDefaults();
            // Special internal method to allow the unit tests and DebugPlugin to hook embedded objects
            _self["_getDbgPlgTargets"] = function () {
                return [_extensions, _eventQueue];
            };
            _self[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */] = function () { return _isInitialized; };
            // since version 3.3.0
            _self.activeStatus = function () { return _activeStatus; };
            // since version 3.3.0
            // internal
            _self._setPendingStatus = function () {
                _activeStatus = 3 /* eActiveStatus.PENDING */;
            };
            // Creating the self.initialize = ()
            _self[_DYN_INITIALIZE$1 /* @min:%2einitialize */] = function (config, extensions, logger, notificationManager) {
                if (_isUnloading) {
                    throwError(strSdkUnloadingError);
                }
                // Make sure core is only initialized once
                if (_self[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */]()) {
                    throwError("Core cannot be initialized more than once");
                }
                _configHandler = createDynamicConfig(config, defaultConfig, logger || _self[_DYN_LOGGER /* @min:%2elogger */], false);
                // Re-assigning the local config property so we don't have any references to the passed value and it can be garbage collected
                config = _configHandler.cfg;
                // This will be "re-run" if the referenced config properties are changed
                _addUnloadHook(_configHandler[_DYN_WATCH /* @min:%2ewatch */](function (details) {
                    var rootCfg = details.cfg;
                    var isPending = _activeStatus === 3 /* eActiveStatus.PENDING */;
                    if (isPending) {
                        // means waiting for previous promises to be resolved, won't apply new changes
                        return;
                    }
                    _initInMemoMaxSize = rootCfg.initInMemoMaxSize || maxInitQueueSize;
                    // app Insights core only handle ikey and endpointurl, aisku will handle cs
                    var ikey = rootCfg[_DYN_INSTRUMENTATION_KEY$2 /* @min:%2einstrumentationKey */];
                    var endpointUrl = rootCfg.endpointUrl; // do not need to validate endpoint url, if it is null, default one will be set by sender
                    if (isNullOrUndefined(ikey)) {
                        _instrumentationKey = null;
                        // if new ikey is null, set status to be inactive, all new events will be saved in memory or dropped
                        _activeStatus = ActiveStatus[_DYN__INACTIVE /* @min:%2eINACTIVE */];
                        var msg = "Please provide instrumentation key";
                        if (!_isInitialized) {
                            // only throw error during initialization
                            throwError(msg);
                        }
                        else {
                            _throwInternal(_logger, 1 /* eLoggingSeverity.CRITICAL */, 100 /* _eInternalMessageId.InvalidInstrumentationKey */, msg);
                            _releaseQueues();
                        }
                        return;
                    }
                    var promises = [];
                    if (isPromiseLike(ikey)) {
                        promises[_DYN_PUSH$2 /* @min:%2epush */](ikey);
                        _instrumentationKey = null; // reset current local ikey variable (otherwise it will always be the previous ikeys if timeout is called before promise cb)
                    }
                    else {
                        // string
                        _instrumentationKey = ikey;
                    }
                    if (isPromiseLike(endpointUrl)) {
                        promises[_DYN_PUSH$2 /* @min:%2epush */](endpointUrl);
                        _endpoint = null; // reset current local endpoint variable (otherwise it will always be the previous urls if timeout is called before promise cb)
                    }
                    else {
                        // string or null
                        _endpoint = endpointUrl;
                    }
                    // at least have one promise
                    if (promises[_DYN_LENGTH$5 /* @min:%2elength */]) {
                        // reset to false for new dynamic changes
                        _isStatusSet = false;
                        _activeStatus = 3 /* eActiveStatus.PENDING */;
                        var initTimeout = isNotNullOrUndefined(rootCfg.initTimeOut) ? rootCfg.initTimeOut : maxInitTimeout; // rootCfg.initTimeOut could be 0
                        var allPromises = createAllSettledPromise(promises);
                        scheduleTimeout(function () {
                            if (!_isStatusSet) {
                                _setStatus();
                            }
                        }, initTimeout);
                        doAwaitResponse(allPromises, function (response) {
                            try {
                                if (_isStatusSet) {
                                    // promises take too long to resolve, ignore them
                                    // active status should be set by timeout already
                                    return;
                                }
                                if (!response.rejected) {
                                    var values = response[_DYN_VALUE /* @min:%2evalue */];
                                    if (values && values[_DYN_LENGTH$5 /* @min:%2elength */]) {
                                        // ikey
                                        var ikeyRes = values[0];
                                        _instrumentationKey = ikeyRes && ikeyRes[_DYN_VALUE /* @min:%2evalue */];
                                        // endpoint
                                        if (values[_DYN_LENGTH$5 /* @min:%2elength */] > 1) {
                                            var endpointRes = values[1];
                                            _endpoint = endpointRes && endpointRes[_DYN_VALUE /* @min:%2evalue */];
                                        }
                                    }
                                    if (_instrumentationKey) {
                                        // if ikey is null, no need to trigger extra dynamic changes for extensions
                                        config[_DYN_INSTRUMENTATION_KEY$2 /* @min:%2einstrumentationKey */] = _instrumentationKey; // set config.instrumentationKey for extensions to consume
                                        config.endpointUrl = _endpoint; // set config.endpointUrl for extensions to consume
                                    }
                                }
                                // set _isStatusSet to true
                                // set active status
                                // release queues
                                _setStatus();
                            }
                            catch (e) {
                                if (!_isStatusSet) {
                                    _setStatus();
                                }
                            }
                        });
                    }
                    else {
                        // means no promises
                        _setStatus();
                    }
                    //_instrumentationKey = details.cfg.instrumentationKey;
                    // Mark the extensionConfig and all first level keys as referenced
                    // This is so that calls to getExtCfg() will always return the same object
                    // Even when a user may "re-assign" the plugin properties (or it's unloaded/reloaded)
                    var extCfg = details.ref(details.cfg, STR_EXTENSION_CONFIG);
                    objForEachKey(extCfg, function (key) {
                        details.ref(extCfg, key);
                    });
                }));
                _notificationManager = notificationManager;
                // Initialize the debug listener outside of the closure to reduce the retained memory footprint
                _debugListener = _initDebugListener(_configHandler, _hookContainer, _notificationManager && _self[_DYN_GET_NOTIFY_MGR /* @min:%2egetNotifyMgr */](), _debugListener);
                _initPerfManager();
                _self[_DYN_LOGGER /* @min:%2elogger */] = logger;
                var cfgExtensions = config[STR_EXTENSIONS /* @min:%2eextensions */];
                // Extension validation
                _configExtensions = [];
                _configExtensions[_DYN_PUSH$2 /* @min:%2epush */].apply(_configExtensions, __spreadArrayFn(__spreadArrayFn([], extensions, false), cfgExtensions));
                _channelConfig = config[STR_CHANNELS /* @min:%2echannels */];
                _initPluginChain(null);
                if (!_channels || _channels[_DYN_LENGTH$5 /* @min:%2elength */] === 0) {
                    throwError("No " + STR_CHANNELS + " available");
                }
                if (_channelConfig && _channelConfig[_DYN_LENGTH$5 /* @min:%2elength */] > 1) {
                    var teeController = _self[_DYN_GET_PLUGIN /* @min:%2egetPlugin */]("TeeChannelController");
                    if (!teeController || !teeController.plugin) {
                        _throwInternal(_logger, 1 /* eLoggingSeverity.CRITICAL */, 28 /* _eInternalMessageId.SenderNotInitialized */, "TeeChannel required");
                    }
                }
                _registerDelayedCfgListener(config, _cfgListeners, _logger);
                _cfgListeners = null;
                _isInitialized = true;
                if (_activeStatus === ActiveStatus.ACTIVE) {
                    _releaseQueues();
                }
            };
            _self.getChannels = function () {
                var controls = [];
                if (_channels) {
                    arrForEach(_channels, function (channel) {
                        controls[_DYN_PUSH$2 /* @min:%2epush */](channel);
                    });
                }
                return objFreeze(controls);
            };
            _self.track = function (telemetryItem) {
                doPerf(_self[STR_GET_PERF_MGR /* @min:%2egetPerfMgr */](), function () { return "AppInsightsCore:track"; }, function () {
                    if (telemetryItem === null) {
                        _notifyInvalidEvent(telemetryItem);
                        // throw error
                        throwError("Invalid telemetry item");
                    }
                    // do basic validation before sending it through the pipeline
                    if (!telemetryItem[_DYN_NAME$3 /* @min:%2ename */] && isNullOrUndefined(telemetryItem[_DYN_NAME$3 /* @min:%2ename */])) {
                        _notifyInvalidEvent(telemetryItem);
                        throwError("telemetry name required");
                    }
                    // setup default iKey if not passed in
                    telemetryItem[_DYN_I_KEY /* @min:%2eiKey */] = telemetryItem[_DYN_I_KEY /* @min:%2eiKey */] || _instrumentationKey;
                    // add default timestamp if not passed in
                    telemetryItem[_DYN_TIME /* @min:%2etime */] = telemetryItem[_DYN_TIME /* @min:%2etime */] || toISOString(new Date());
                    // Common Schema 4.0
                    telemetryItem.ver = telemetryItem.ver || "4.0";
                    if (!_isUnloading && _self[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */]() && _activeStatus === ActiveStatus.ACTIVE) {
                        // Process the telemetry plugin chain
                        _createTelCtx()[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](telemetryItem);
                    }
                    else if (_activeStatus !== ActiveStatus[_DYN__INACTIVE /* @min:%2eINACTIVE */]) {
                        // Queue events until all extensions are initialized
                        if (_eventQueue[_DYN_LENGTH$5 /* @min:%2elength */] <= _initInMemoMaxSize) {
                            // set limit, if full, stop adding new events
                            _eventQueue[_DYN_PUSH$2 /* @min:%2epush */](telemetryItem);
                        }
                    }
                }, function () { return ({ item: telemetryItem }); }, !(telemetryItem.sync));
            };
            _self[_DYN_GET_PROCESS_TEL_CONT2 /* @min:%2egetProcessTelContext */] = _createTelCtx;
            _self[_DYN_GET_NOTIFY_MGR /* @min:%2egetNotifyMgr */] = function () {
                if (!_notificationManager) {
                    _notificationManager = new NotificationManager(_configHandler.cfg);
                    // For backward compatibility only
                    _self[strNotificationManager] = _notificationManager;
                }
                return _notificationManager;
            };
            /**
             * Adds a notification listener. The SDK calls methods on the listener when an appropriate notification is raised.
             * The added plugins must raise notifications. If the plugins do not implement the notifications, then no methods will be
             * called.
             * @param listener - An INotificationListener object.
             */
            _self[_DYN_ADD_NOTIFICATION_LIS1 /* @min:%2eaddNotificationListener */] = function (listener) {
                _self.getNotifyMgr()[_DYN_ADD_NOTIFICATION_LIS1 /* @min:%2eaddNotificationListener */](listener);
            };
            /**
             * Removes all instances of the listener.
             * @param listener - INotificationListener to remove.
             */
            _self[_DYN_REMOVE_NOTIFICATION_0 /* @min:%2eremoveNotificationListener */] = function (listener) {
                if (_notificationManager) {
                    _notificationManager[_DYN_REMOVE_NOTIFICATION_0 /* @min:%2eremoveNotificationListener */](listener);
                }
            };
            _self.getCookieMgr = function () {
                if (!_cookieManager) {
                    _cookieManager = createCookieMgr(_configHandler.cfg, _self[_DYN_LOGGER /* @min:%2elogger */]);
                }
                return _cookieManager;
            };
            _self.setCookieMgr = function (cookieMgr) {
                if (_cookieManager !== cookieMgr) {
                    runTargetUnload(_cookieManager, false);
                    _cookieManager = cookieMgr;
                }
            };
            _self[STR_GET_PERF_MGR /* @min:%2egetPerfMgr */] = function () {
                return _perfManager || _cfgPerfManager || getGblPerfMgr();
            };
            _self.setPerfMgr = function (perfMgr) {
                _perfManager = perfMgr;
            };
            _self.eventCnt = function () {
                return _eventQueue[_DYN_LENGTH$5 /* @min:%2elength */];
            };
            _self.releaseQueue = function () {
                if (_isInitialized && _eventQueue[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                    var eventQueue = _eventQueue;
                    _eventQueue = [];
                    if (_activeStatus === 2 /* eActiveStatus.ACTIVE */) {
                        arrForEach(eventQueue, function (event) {
                            event[_DYN_I_KEY /* @min:%2eiKey */] = event[_DYN_I_KEY /* @min:%2eiKey */] || _instrumentationKey;
                            _createTelCtx()[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](event);
                        });
                    }
                    else {
                        // new one for msg ikey
                        _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 20 /* _eInternalMessageId.FailedToSendQueuedTelemetry */, "core init status is not active");
                    }
                }
            };
            _self[_DYN_POLL_INTERNAL_LOGS /* @min:%2epollInternalLogs */] = function (eventName) {
                _internalLogsEventName = eventName || null;
                _forceStopInternalLogPoller = false;
                _internalLogPoller && _internalLogPoller[_DYN_CANCEL /* @min:%2ecancel */]();
                return _startLogPoller(true);
            };
            function _setStatus() {
                _isStatusSet = true;
                if (isNullOrUndefined(_instrumentationKey)) {
                    _activeStatus = ActiveStatus[_DYN__INACTIVE /* @min:%2eINACTIVE */];
                    _throwInternal(_logger, 1 /* eLoggingSeverity.CRITICAL */, 112 /* _eInternalMessageId.InitPromiseException */, "ikey can't be resolved from promises");
                }
                else {
                    _activeStatus = ActiveStatus.ACTIVE;
                }
                _releaseQueues();
            }
            function _releaseQueues() {
                if (_isInitialized) {
                    _self.releaseQueue();
                    _self[_DYN_POLL_INTERNAL_LOGS /* @min:%2epollInternalLogs */]();
                }
            }
            function _startLogPoller(alwaysStart) {
                if ((!_internalLogPoller || !_internalLogPoller[_DYN_ENABLED /* @min:%2eenabled */]) && !_forceStopInternalLogPoller) {
                    var shouldStart = alwaysStart || (_logger && _logger.queue[_DYN_LENGTH$5 /* @min:%2elength */] > 0);
                    if (shouldStart) {
                        if (!_internalLogPollerListening) {
                            _internalLogPollerListening = true;
                            // listen for any configuration changes so that changes to the
                            // interval will cause the timer to be re-initialized
                            _addUnloadHook(_configHandler[_DYN_WATCH /* @min:%2ewatch */](function (details) {
                                var interval = details.cfg.diagnosticLogInterval;
                                if (!interval || !(interval > 0)) {
                                    interval = 10000;
                                }
                                var isRunning = false;
                                if (_internalLogPoller) {
                                    // It was already created so remember it's running and cancel
                                    isRunning = _internalLogPoller[_DYN_ENABLED /* @min:%2eenabled */];
                                    _internalLogPoller[_DYN_CANCEL /* @min:%2ecancel */]();
                                }
                                // Create / reconfigure
                                _internalLogPoller = createTimeout(_flushInternalLogs, interval);
                                _internalLogPoller.unref();
                                // Restart if previously running
                                _internalLogPoller[_DYN_ENABLED /* @min:%2eenabled */] = isRunning;
                            }));
                        }
                        _internalLogPoller[_DYN_ENABLED /* @min:%2eenabled */] = true;
                    }
                }
                return _internalLogPoller;
            }
            _self[_DYN_STOP_POLLING_INTERNA3 /* @min:%2estopPollingInternalLogs */] = function () {
                _forceStopInternalLogPoller = true;
                _internalLogPoller && _internalLogPoller[_DYN_CANCEL /* @min:%2ecancel */]();
                _flushInternalLogs();
            };
            // Add addTelemetryInitializer
            proxyFunctions(_self, function () { return _telemetryInitializerPlugin; }, ["addTelemetryInitializer"]);
            _self[_DYN_UNLOAD /* @min:%2eunload */] = function (isAsync, unloadComplete, cbTimeout) {
                var _a;
                if (isAsync === void 0) { isAsync = true; }
                if (!_isInitialized) {
                    // The SDK is not initialized
                    throwError(strSdkNotInitialized);
                }
                // Check if the SDK still unloading so throw
                if (_isUnloading) {
                    // The SDK is already unloading
                    throwError(strSdkUnloadingError);
                }
                var unloadState = (_a = {
                        reason: 50 /* TelemetryUnloadReason.SdkUnload */
                    },
                    _a[_DYN_IS_ASYNC /* @min:isAsync */] = isAsync,
                    _a.flushComplete = false,
                    _a);
                var result;
                if (isAsync && !unloadComplete) {
                    result = createPromise(function (resolve) {
                        // Set the callback to the promise resolve callback
                        unloadComplete = resolve;
                    });
                }
                var processUnloadCtx = createProcessTelemetryUnloadContext(_getPluginChain(), _self);
                processUnloadCtx[_DYN_ON_COMPLETE /* @min:%2eonComplete */](function () {
                    _hookContainer.run(_self[_DYN_LOGGER /* @min:%2elogger */]);
                    // Run any "unload" functions for the _cookieManager, _notificationManager and _logger
                    doUnloadAll([_cookieManager, _notificationManager, _logger], isAsync, function () {
                        _initDefaults();
                        unloadComplete && unloadComplete(unloadState);
                    });
                }, _self);
                function _doUnload(flushComplete) {
                    unloadState.flushComplete = flushComplete;
                    _isUnloading = true;
                    // Run all of the unload handlers first (before unloading the plugins)
                    _unloadHandlers.run(processUnloadCtx, unloadState);
                    // Stop polling the internal logs
                    _self[_DYN_STOP_POLLING_INTERNA3 /* @min:%2estopPollingInternalLogs */]();
                    // Start unloading the components, from this point onwards the SDK should be considered to be in an unstable state
                    processUnloadCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](unloadState);
                }
                _flushInternalLogs();
                if (!_flushChannels(isAsync, _doUnload, 6 /* SendRequestReason.SdkUnload */, cbTimeout)) ;
                return result;
            };
            _self[_DYN_GET_PLUGIN /* @min:%2egetPlugin */] = _getPlugin;
            _self.addPlugin = function (plugin, replaceExisting, isAsync, addCb) {
                if (!plugin) {
                    addCb && addCb(false);
                    _logOrThrowError(strValidationError);
                    return;
                }
                var existingPlugin = _getPlugin(plugin[_DYN_IDENTIFIER /* @min:%2eidentifier */]);
                if (existingPlugin && !replaceExisting) {
                    addCb && addCb(false);
                    _logOrThrowError("Plugin [" + plugin[_DYN_IDENTIFIER /* @min:%2eidentifier */] + "] is already loaded!");
                    return;
                }
                var updateState = {
                    reason: 16 /* TelemetryUpdateReason.PluginAdded */
                };
                function _addPlugin(removed) {
                    _configExtensions[_DYN_PUSH$2 /* @min:%2epush */](plugin);
                    updateState.added = [plugin];
                    // Re-Initialize the plugin chain
                    _initPluginChain(updateState);
                    addCb && addCb(true);
                }
                if (existingPlugin) {
                    var removedPlugins_1 = [existingPlugin.plugin];
                    var unloadState = {
                        reason: 2 /* TelemetryUnloadReason.PluginReplace */,
                        isAsync: !!isAsync
                    };
                    _removePlugins(removedPlugins_1, unloadState, function (removed) {
                        if (!removed) {
                            // Previous plugin was successfully removed or was not installed
                            addCb && addCb(false);
                        }
                        else {
                            updateState.removed = removedPlugins_1;
                            updateState.reason |= 32 /* TelemetryUpdateReason.PluginRemoved */;
                            _addPlugin();
                        }
                    });
                }
                else {
                    _addPlugin();
                }
            };
            _self.updateCfg = function (newConfig, mergeExisting) {
                if (mergeExisting === void 0) { mergeExisting = true; }
                var updateState;
                if (_self[_DYN_IS_INITIALIZED /* @min:%2eisInitialized */]()) {
                    updateState = {
                        reason: 1 /* TelemetryUpdateReason.ConfigurationChanged */,
                        cfg: _configHandler.cfg,
                        oldCfg: deepExtend({}, _configHandler.cfg),
                        newConfig: deepExtend({}, newConfig),
                        merge: mergeExisting
                    };
                    newConfig = updateState.newConfig;
                    var cfg = _configHandler.cfg;
                    // replace the immutable (if initialized) values
                    // We don't currently allow updating the extensions and channels via the update config
                    // So overwriting any user provided values to reuse the existing values
                    newConfig[STR_EXTENSIONS /* @min:%2eextensions */] = cfg[STR_EXTENSIONS /* @min:%2eextensions */];
                    newConfig[STR_CHANNELS /* @min:%2echannels */] = cfg[STR_CHANNELS /* @min:%2echannels */];
                }
                // Explicitly blocking any previous config watchers so that they don't get called because
                // of this bulk update (Probably not necessary)
                _configHandler._block(function (details) {
                    // Lets assign the new values to the existing config either overwriting or re-assigning
                    var theConfig = details.cfg;
                    _deepMergeConfig(details, theConfig, newConfig, mergeExisting);
                    if (!mergeExisting) {
                        // Remove (unassign) the values "missing" from the newConfig and also not in the default config
                        objForEachKey(theConfig, function (key) {
                            if (!objHasOwn(newConfig, key)) {
                                // Set the value to undefined
                                details.set(theConfig, key, UNDEFINED_VALUE$2);
                            }
                        });
                    }
                    // Apply defaults to the new config
                    details[_DYN_SET_DF /* @min:%2esetDf */](theConfig, defaultConfig);
                }, true);
                // Now execute all of the listeners (synchronously) so they update their values immediately
                _configHandler[_DYN_NOTIFY /* @min:%2enotify */]();
                if (updateState) {
                    _doUpdate(updateState);
                }
            };
            _self.evtNamespace = function () {
                return _evtNamespace;
            };
            _self.flush = _flushChannels;
            _self.getTraceCtx = function (createNew) {
                if (!_traceCtx) {
                    _traceCtx = createDistributedTraceContext();
                }
                return _traceCtx;
            };
            _self.setTraceCtx = function (traceCtx) {
                _traceCtx = traceCtx || null;
            };
            _self.addUnloadHook = _addUnloadHook;
            // Create the addUnloadCb
            proxyFunctionAs(_self, "addUnloadCb", function () { return _unloadHandlers; }, "add");
            _self.onCfgChange = function (handler) {
                var unloadHook;
                if (!_isInitialized) {
                    unloadHook = _addDelayedCfgListener(_cfgListeners, handler);
                }
                else {
                    unloadHook = onConfigChange(_configHandler.cfg, handler, _self[_DYN_LOGGER /* @min:%2elogger */]);
                }
                return _createUnloadHook(unloadHook);
            };
            _self.getWParam = function () {
                return (hasDocument() || !!_configHandler.cfg.enableWParam) ? 0 : -1;
            };
            function _setPluginVersions() {
                var thePlugins = {};
                _pluginVersionStringArr = [];
                var _addPluginVersions = function (plugins) {
                    if (plugins) {
                        arrForEach(plugins, function (plugin) {
                            if (plugin[_DYN_IDENTIFIER /* @min:%2eidentifier */] && plugin[_DYN_VERSION$1 /* @min:%2eversion */] && !thePlugins[plugin.identifier]) {
                                var ver = plugin[_DYN_IDENTIFIER /* @min:%2eidentifier */] + "=" + plugin[_DYN_VERSION$1 /* @min:%2eversion */];
                                _pluginVersionStringArr[_DYN_PUSH$2 /* @min:%2epush */](ver);
                                thePlugins[plugin.identifier] = plugin;
                            }
                        });
                    }
                };
                _addPluginVersions(_channels);
                if (_channelConfig) {
                    arrForEach(_channelConfig, function (channels) {
                        _addPluginVersions(channels);
                    });
                }
                _addPluginVersions(_configExtensions);
            }
            function _initDefaults() {
                _isInitialized = false;
                // Use a default logger so initialization errors are not dropped on the floor with full logging
                _configHandler = createDynamicConfig({}, defaultConfig, _self[_DYN_LOGGER /* @min:%2elogger */]);
                // Set the logging level to critical so that any critical initialization failures are displayed on the console
                _configHandler.cfg[_DYN_LOGGING_LEVEL_CONSOL4 /* @min:%2eloggingLevelConsole */] = 1 /* eLoggingSeverity.CRITICAL */;
                // Define _self.config
                objDefine(_self, "config", {
                    g: function () { return _configHandler.cfg; },
                    s: function (newValue) {
                        _self.updateCfg(newValue, false);
                    }
                });
                objDefine(_self, "pluginVersionStringArr", {
                    g: function () {
                        if (!_pluginVersionStringArr) {
                            _setPluginVersions();
                        }
                        return _pluginVersionStringArr;
                    }
                });
                objDefine(_self, "pluginVersionString", {
                    g: function () {
                        if (!_pluginVersionString) {
                            if (!_pluginVersionStringArr) {
                                _setPluginVersions();
                            }
                            _pluginVersionString = _pluginVersionStringArr.join(";");
                        }
                        return _pluginVersionString || STR_EMPTY$1;
                    }
                });
                objDefine(_self, "logger", {
                    g: function () {
                        if (!_logger) {
                            _logger = new DiagnosticLogger(_configHandler.cfg);
                            _configHandler[_DYN_LOGGER /* @min:%2elogger */] = _logger;
                        }
                        return _logger;
                    },
                    s: function (newLogger) {
                        _configHandler[_DYN_LOGGER /* @min:%2elogger */] = newLogger;
                        if (_logger !== newLogger) {
                            runTargetUnload(_logger, false);
                            _logger = newLogger;
                        }
                    }
                });
                _self[_DYN_LOGGER /* @min:%2elogger */] = new DiagnosticLogger(_configHandler.cfg);
                _extensions = [];
                var cfgExtensions = _self.config[STR_EXTENSIONS /* @min:%2eextensions */] || [];
                cfgExtensions.splice(0, cfgExtensions[_DYN_LENGTH$5 /* @min:%2elength */]);
                arrAppend(cfgExtensions, _extensions);
                _telemetryInitializerPlugin = new TelemetryInitializerPlugin();
                _eventQueue = [];
                runTargetUnload(_notificationManager, false);
                _notificationManager = null;
                _perfManager = null;
                _cfgPerfManager = null;
                runTargetUnload(_cookieManager, false);
                _cookieManager = null;
                _pluginChain = null;
                _configExtensions = [];
                _channelConfig = null;
                _channels = null;
                _isUnloading = false;
                _internalLogsEventName = null;
                _evtNamespace = createUniqueNamespace("AIBaseCore", true);
                _unloadHandlers = createUnloadHandlerContainer();
                _traceCtx = null;
                _instrumentationKey = null;
                _hookContainer = createUnloadHookContainer();
                _cfgListeners = [];
                _pluginVersionString = null;
                _pluginVersionStringArr = null;
                _forceStopInternalLogPoller = false;
                _internalLogPoller = null;
                _internalLogPollerListening = false;
                _activeStatus = 0 /* eActiveStatus.NONE */; // default is None
                _endpoint = null;
                _initInMemoMaxSize = null;
                _isStatusSet = false;
            }
            function _createTelCtx() {
                var theCtx = createProcessTelemetryContext(_getPluginChain(), _configHandler.cfg, _self);
                theCtx[_DYN_ON_COMPLETE /* @min:%2eonComplete */](_startLogPoller);
                return theCtx;
            }
            // Initialize or Re-initialize the plugins
            function _initPluginChain(updateState) {
                // Extension validation
                var theExtensions = _validateExtensions(_self[_DYN_LOGGER /* @min:%2elogger */], ChannelControllerPriority, _configExtensions);
                _pluginChain = null;
                _pluginVersionString = null;
                _pluginVersionStringArr = null;
                // Get the primary channel queue and include as part of the normal extensions
                _channels = (_channelConfig || [])[0] || [];
                // Add any channels provided in the extensions and sort them
                _channels = sortPlugins(arrAppend(_channels, theExtensions[STR_CHANNELS /* @min:%2echannels */]));
                // Create an array of all extensions, including the _channels
                var allExtensions = arrAppend(sortPlugins(theExtensions[STR_CORE /* @min:%2ecore */]), _channels);
                // Required to allow plugins to call core.getPlugin() during their own initialization
                _extensions = objFreeze(allExtensions);
                // This has a side effect of adding the extensions passed during initialization
                // into the config.extensions, so you can see all of the extensions loaded.
                // This will also get updated by the addPlugin() and remove plugin code.
                var cfgExtensions = _self.config[STR_EXTENSIONS /* @min:%2eextensions */] || [];
                cfgExtensions.splice(0, cfgExtensions[_DYN_LENGTH$5 /* @min:%2elength */]);
                arrAppend(cfgExtensions, _extensions);
                var rootCtx = _createTelCtx();
                // Initializing the channels first
                if (_channels && _channels[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                    initializePlugins(rootCtx[_DYN_CREATE_NEW$1 /* @min:%2ecreateNew */](_channels), allExtensions);
                }
                // Now initialize the normal extensions (explicitly not including the _channels as this can cause duplicate initialization)
                initializePlugins(rootCtx, allExtensions);
                if (updateState) {
                    _doUpdate(updateState);
                }
            }
            function _getPlugin(pluginIdentifier) {
                var theExt = null;
                var thePlugin = null;
                var channelHosts = [];
                arrForEach(_extensions, function (ext) {
                    if (ext[_DYN_IDENTIFIER /* @min:%2eidentifier */] === pluginIdentifier && ext !== _telemetryInitializerPlugin) {
                        thePlugin = ext;
                        return -1;
                    }
                    if (ext.getChannel) {
                        channelHosts[_DYN_PUSH$2 /* @min:%2epush */](ext);
                    }
                });
                if (!thePlugin && channelHosts[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                    arrForEach(channelHosts, function (host) {
                        thePlugin = host.getChannel(pluginIdentifier);
                        if (!thePlugin) {
                            return -1;
                        }
                    });
                }
                if (thePlugin) {
                    theExt = {
                        plugin: thePlugin,
                        setEnabled: function (enabled) {
                            _getPluginState(thePlugin)[STR_DISABLED] = !enabled;
                        },
                        isEnabled: function () {
                            var pluginState = _getPluginState(thePlugin);
                            return !pluginState[_DYN_TEARDOWN /* @min:%2eteardown */] && !pluginState[STR_DISABLED];
                        },
                        remove: function (isAsync, removeCb) {
                            var _a;
                            if (isAsync === void 0) { isAsync = true; }
                            var pluginsToRemove = [thePlugin];
                            var unloadState = (_a = {
                                    reason: 1 /* TelemetryUnloadReason.PluginUnload */
                                },
                                _a[_DYN_IS_ASYNC /* @min:isAsync */] = isAsync,
                                _a);
                            _removePlugins(pluginsToRemove, unloadState, function (removed) {
                                if (removed) {
                                    // Re-Initialize the plugin chain
                                    _initPluginChain({
                                        reason: 32 /* TelemetryUpdateReason.PluginRemoved */,
                                        removed: pluginsToRemove
                                    });
                                }
                                removeCb && removeCb(removed);
                            });
                        }
                    };
                }
                return theExt;
            }
            function _getPluginChain() {
                if (!_pluginChain) {
                    // copy the collection of extensions
                    var extensions = (_extensions || []).slice();
                    // During add / remove this may get called again, so don't read if already present
                    if (arrIndexOf(extensions, _telemetryInitializerPlugin) === -1) {
                        extensions[_DYN_PUSH$2 /* @min:%2epush */](_telemetryInitializerPlugin);
                    }
                    _pluginChain = createTelemetryProxyChain(sortPlugins(extensions), _configHandler.cfg, _self);
                }
                return _pluginChain;
            }
            function _removePlugins(thePlugins, unloadState, removeComplete) {
                if (thePlugins && thePlugins[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                    var unloadChain = createTelemetryProxyChain(thePlugins, _configHandler.cfg, _self);
                    var unloadCtx = createProcessTelemetryUnloadContext(unloadChain, _self);
                    unloadCtx[_DYN_ON_COMPLETE /* @min:%2eonComplete */](function () {
                        var removed = false;
                        // Remove the listed config extensions
                        var newConfigExtensions = [];
                        arrForEach(_configExtensions, function (plugin, idx) {
                            if (!_isPluginPresent(plugin, thePlugins)) {
                                newConfigExtensions[_DYN_PUSH$2 /* @min:%2epush */](plugin);
                            }
                            else {
                                removed = true;
                            }
                        });
                        _configExtensions = newConfigExtensions;
                        _pluginVersionString = null;
                        _pluginVersionStringArr = null;
                        // Re-Create the channel config
                        var newChannelConfig = [];
                        if (_channelConfig) {
                            arrForEach(_channelConfig, function (queue, idx) {
                                var newQueue = [];
                                arrForEach(queue, function (channel) {
                                    if (!_isPluginPresent(channel, thePlugins)) {
                                        newQueue[_DYN_PUSH$2 /* @min:%2epush */](channel);
                                    }
                                    else {
                                        removed = true;
                                    }
                                });
                                newChannelConfig[_DYN_PUSH$2 /* @min:%2epush */](newQueue);
                            });
                            _channelConfig = newChannelConfig;
                        }
                        removeComplete && removeComplete(removed);
                        _startLogPoller();
                    });
                    unloadCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](unloadState);
                }
                else {
                    removeComplete(false);
                }
            }
            function _flushInternalLogs() {
                if (_logger && _logger.queue) {
                    var queue = _logger.queue.slice(0);
                    _logger.queue[_DYN_LENGTH$5 /* @min:%2elength */] = 0;
                    arrForEach(queue, function (logMessage) {
                        var _a;
                        var item = (_a = {},
                            _a[_DYN_NAME$3 /* @min:name */] = _internalLogsEventName ? _internalLogsEventName : "InternalMessageId: " + logMessage[_DYN_MESSAGE_ID /* @min:%2emessageId */],
                            _a[_DYN_I_KEY /* @min:iKey */] = _instrumentationKey,
                            _a[_DYN_TIME /* @min:time */] = toISOString(new Date()),
                            _a.baseType = _InternalLogMessage.dataType,
                            _a.baseData = { message: logMessage[_DYN_MESSAGE$2 /* @min:%2emessage */] },
                            _a);
                        _self.track(item);
                    });
                }
            }
            function _flushChannels(isAsync, callBack, sendReason, cbTimeout) {
                // Setting waiting to one so that we don't call the callBack until we finish iterating
                var waiting = 1;
                var doneIterating = false;
                var cbTimer = null;
                cbTimeout = cbTimeout || 5000;
                function doCallback() {
                    waiting--;
                    if (doneIterating && waiting === 0) {
                        cbTimer && cbTimer[_DYN_CANCEL /* @min:%2ecancel */]();
                        cbTimer = null;
                        callBack && callBack(doneIterating);
                        callBack = null;
                    }
                }
                if (_channels && _channels[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                    var flushCtx = _createTelCtx()[_DYN_CREATE_NEW$1 /* @min:%2ecreateNew */](_channels);
                    flushCtx.iterate(function (plugin) {
                        if (plugin.flush) {
                            waiting++;
                            var handled_1 = false;
                            // Not all channels will call this callback for every scenario
                            if (!plugin.flush(isAsync, function () {
                                handled_1 = true;
                                doCallback();
                            }, sendReason)) {
                                if (!handled_1) {
                                    // If any channel doesn't return true and it didn't call the callback, then we should assume that the callback
                                    // will never be called, so use a timeout to allow the channel(s) some time to "finish" before triggering any
                                    // followup function (such as unloading)
                                    if (isAsync && cbTimer == null) {
                                        cbTimer = scheduleTimeout(function () {
                                            cbTimer = null;
                                            doCallback();
                                        }, cbTimeout);
                                    }
                                    else {
                                        doCallback();
                                    }
                                }
                            }
                        }
                    });
                }
                doneIterating = true;
                doCallback();
                return true;
            }
            function _initPerfManager() {
                // Save the previous config based performance manager creator to avoid creating new perf manager instances if unchanged
                var prevCfgPerfMgr;
                // Will get recalled if any referenced config values are changed
                _addUnloadHook(_configHandler[_DYN_WATCH /* @min:%2ewatch */](function (details) {
                    var enablePerfMgr = details.cfg.enablePerfMgr;
                    if (enablePerfMgr) {
                        var createPerfMgr = details.cfg[STR_CREATE_PERF_MGR /* @min:%2ecreatePerfMgr */];
                        if (prevCfgPerfMgr !== createPerfMgr) {
                            if (!createPerfMgr) {
                                createPerfMgr = _createPerfManager;
                            }
                            // Set the performance manager creation function if not defined
                            getSetValue(details.cfg, STR_CREATE_PERF_MGR, createPerfMgr);
                            prevCfgPerfMgr = createPerfMgr;
                            // Remove any existing config based performance manager
                            _cfgPerfManager = null;
                        }
                        // Only create the performance manager if it's not already created or manually set
                        if (!_perfManager && !_cfgPerfManager && isFunction(createPerfMgr)) {
                            // Create a new config based performance manager
                            _cfgPerfManager = createPerfMgr(_self, _self[_DYN_GET_NOTIFY_MGR /* @min:%2egetNotifyMgr */]());
                        }
                    }
                    else {
                        // Remove any existing config based performance manager
                        _cfgPerfManager = null;
                        // Clear the previous cached value so it can be GC'd
                        prevCfgPerfMgr = null;
                    }
                }));
            }
            function _doUpdate(updateState) {
                var updateCtx = createProcessTelemetryUpdateContext(_getPluginChain(), _self);
                updateCtx[_DYN_ON_COMPLETE /* @min:%2eonComplete */](_startLogPoller);
                if (!_self._updateHook || _self._updateHook(updateCtx, updateState) !== true) {
                    updateCtx[_DYN_PROCESS_NEXT /* @min:%2eprocessNext */](updateState);
                }
            }
            function _logOrThrowError(message) {
                var logger = _self[_DYN_LOGGER /* @min:%2elogger */];
                if (logger) {
                    // there should always be a logger
                    _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 73 /* _eInternalMessageId.PluginException */, message);
                    _startLogPoller();
                }
                else {
                    throwError(message);
                }
            }
            function _notifyInvalidEvent(telemetryItem) {
                var manager = _self[_DYN_GET_NOTIFY_MGR /* @min:%2egetNotifyMgr */]();
                if (manager) {
                    manager[STR_EVENTS_DISCARDED /* @min:%2eeventsDiscarded */]([telemetryItem], 2 /* eEventsDiscardedReason.InvalidEvent */);
                }
            }
            function _addUnloadHook(hooks) {
                _hookContainer.add(hooks);
            }
        });
    }
// Removed Stub for AppInsightsCore.prototype.initialize.
// Removed Stub for AppInsightsCore.prototype.getChannels.
// Removed Stub for AppInsightsCore.prototype.track.
// Removed Stub for AppInsightsCore.prototype.getProcessTelContext.
// Removed Stub for AppInsightsCore.prototype.getNotifyMgr.
// Removed Stub for AppInsightsCore.prototype.addNotificationListener.
// Removed Stub for AppInsightsCore.prototype.removeNotificationListener.
// Removed Stub for AppInsightsCore.prototype.getCookieMgr.
// Removed Stub for AppInsightsCore.prototype.setCookieMgr.
// Removed Stub for AppInsightsCore.prototype.getPerfMgr.
// Removed Stub for AppInsightsCore.prototype.setPerfMgr.
// Removed Stub for AppInsightsCore.prototype.eventCnt.
// Removed Stub for AppInsightsCore.prototype.pollInternalLogs.
// Removed Stub for AppInsightsCore.prototype.stopPollingInternalLogs.
// Removed Stub for AppInsightsCore.prototype.addTelemetryInitializer.
// Removed Stub for AppInsightsCore.prototype.unload.
// Removed Stub for AppInsightsCore.prototype.getPlugin.
// Removed Stub for AppInsightsCore.prototype.addPlugin.
// Removed Stub for AppInsightsCore.prototype.updateCfg.
// Removed Stub for AppInsightsCore.prototype.evtNamespace.
// Removed Stub for AppInsightsCore.prototype.addUnloadCb.
// Removed Stub for AppInsightsCore.prototype.flush.
// Removed Stub for AppInsightsCore.prototype.getTraceCtx.
// Removed Stub for AppInsightsCore.prototype.setTraceCtx.
// Removed Stub for AppInsightsCore.prototype.addUnloadHook.
// Removed Stub for AppInsightsCore.prototype.onCfgChange.
// Removed Stub for AppInsightsCore.prototype.activeStatus.
// Removed Stub for AppInsightsCore.prototype._setPendingStatus.
// Removed Stub for AppInsightsCore.prototype.releaseQueue.
// Removed Stub for AppInsightsCore.prototype._updateHook.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    AppInsightsCore.__ieDyn=1;

    return AppInsightsCore;
}());

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Parses the response from the backend.
 * @param response - XMLHttpRequest or XDomainRequest response
 */
function parseResponse(response, diagLog) {
    try {
        if (response && response !== "") {
            var result = getJSON().parse(response);
            if (result && result[_DYN_ITEMS_RECEIVED$1 /* @min:%2eitemsReceived */] && result[_DYN_ITEMS_RECEIVED$1 /* @min:%2eitemsReceived */] >= result.itemsAccepted &&
                result.itemsReceived - result.itemsAccepted === result.errors[_DYN_LENGTH$5 /* @min:%2elength */]) {
                return result;
            }
        }
    }
    catch (e) {
        _throwInternal(diagLog, 1 /* eLoggingSeverity.CRITICAL */, 43 /* _eInternalMessageId.InvalidBackendResponse */, "Cannot parse the response. " + (e[_DYN_NAME$3 /* @min:%2ename */] || dumpObj(e)), {
            response: response
        });
    }
    return null;
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var STR_EMPTY = "";
var STR_NO_RESPONSE_BODY = "NoResponseBody";
var _noResponseQs = "&" + STR_NO_RESPONSE_BODY + "=true";
var STR_POST_METHOD = "POST";
/**
 * This Internal component
 * Manager SendPost functions
 * SendPostManger
 * @internal for internal use only
 */
var SenderPostManager = /** @class */ (function () {
    function SenderPostManager() {
        var _syncFetchPayload = 0; // Keep track of the outstanding sync fetch payload total (as sync fetch has limits)
        var _enableSendPromise;
        var _isInitialized;
        var _diagLog;
        var _isOneDs;
        var _onCompleteFuncs;
        var _disableCredentials;
        var _fallbackInst;
        var _disableXhr;
        var _disableBeacon;
        var _disableBeaconSync;
        var _disableFetchKeepAlive;
        var _addNoResponse;
        var _timeoutWrapper;
        dynamicProto(SenderPostManager, this, function (_self, _base) {
            var _sendCredentials = true; // for 1ds
            _initDefaults();
            _self[_DYN_INITIALIZE$1 /* @min:%2einitialize */] = function (config, diagLog) {
                _diagLog = diagLog;
                if (_isInitialized) {
                    _throwInternal(_diagLog, 1 /* eLoggingSeverity.CRITICAL */, 28 /* _eInternalMessageId.SenderNotInitialized */, "Sender is already initialized");
                }
                _self.SetConfig(config);
                _isInitialized = true;
            };
            _self["_getDbgPlgTargets"] = function () {
                return [_isInitialized, _isOneDs, _disableCredentials, _enableSendPromise];
            };
            // This componet might get its config from sender, offline sender, 1ds post
            // so set this function to mock dynamic changes
            _self.SetConfig = function (config) {
                try {
                    _onCompleteFuncs = config.senderOnCompleteCallBack || {};
                    _disableCredentials = !!config.disableCredentials;
                    _isOneDs = !!config.isOneDs;
                    _enableSendPromise = !!config.enableSendPromise;
                    _disableXhr = !!config.disableXhr;
                    _disableBeacon = !!config.disableBeacon;
                    _disableBeaconSync = !!config.disableBeaconSync;
                    _timeoutWrapper = config.timeWrapper;
                    _addNoResponse = !!config.addNoResponse;
                    _disableFetchKeepAlive = !!config.disableFetchKeepAlive;
                    _fallbackInst = { sendPOST: _xhrSender };
                    if (!_isOneDs) {
                        _sendCredentials = false; // for appInsights, set it to false always
                    }
                    if (_disableCredentials) {
                        var location_1 = getLocation();
                        if (location_1 && location_1.protocol && location_1.protocol[_DYN_TO_LOWER_CASE$2 /* @min:%2etoLowerCase */]() === "file:") {
                            // Special case where a local html file fails with a CORS error on Chromium browsers
                            _sendCredentials = false;
                        }
                    }
                    return true;
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return false;
            };
            _self.getSyncFetchPayload = function () {
                return _syncFetchPayload;
            };
            _self.getSenderInst = function (transports, sync) {
                if (transports && transports[_DYN_LENGTH$5 /* @min:%2elength */]) {
                    return _getSenderInterface(transports, sync);
                }
                return null;
            };
            _self.getFallbackInst = function () {
                return _fallbackInst;
            };
            _self[_DYN__DO_TEARDOWN /* @min:%2e_doTeardown */] = function (unloadCtx, unloadState) {
                _initDefaults();
            };
            /**
             * success handler
             */
            function _onSuccess(res, onComplete) {
                _doOnComplete(onComplete, 200, {}, res);
            }
            /**
             * error handler
             */
            function _onError(message, onComplete) {
                _throwInternal(_diagLog, 2 /* eLoggingSeverity.WARNING */, 26 /* _eInternalMessageId.OnError */, "Failed to send telemetry.", { message: message });
                _doOnComplete(onComplete, 400, {});
            }
            function _onNoPayloadUrl(onComplete) {
                _onError("No endpoint url is provided for the batch", onComplete);
            }
            function _getSenderInterface(transports, syncSupport) {
                var _a;
                var transportType = 0 /* TransportType.NotSet */;
                var sendPostFunc = null;
                var lp = 0;
                while (sendPostFunc == null && lp < transports[_DYN_LENGTH$5 /* @min:%2elength */]) {
                    transportType = transports[lp];
                    if (!_disableXhr && transportType === 1 /* TransportType.Xhr */) {
                        if (useXDomainRequest()) {
                            // IE 8 and 9
                            sendPostFunc = _xdrSender;
                        }
                        else if (isXhrSupported()) {
                            sendPostFunc = _xhrSender;
                        }
                    }
                    else if (transportType === 2 /* TransportType.Fetch */ && isFetchSupported(syncSupport) && (!syncSupport || !_disableFetchKeepAlive)) {
                        sendPostFunc = _doFetchSender;
                    }
                    else if (transportType === 3 /* TransportType.Beacon */ && isBeaconsSupported() && (syncSupport ? !_disableBeaconSync : !_disableBeacon)) {
                        sendPostFunc = _beaconSender;
                    }
                    lp++;
                }
                if (sendPostFunc) {
                    return _a = {
                            _transport: transportType,
                            _isSync: syncSupport
                        },
                        _a[_DYN_SEND_POST /* @min:sendPOST */] = sendPostFunc,
                        _a;
                }
                return null;
            }
            function _doOnComplete(oncomplete, status, headers, response) {
                try {
                    oncomplete && oncomplete(status, headers, response);
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
            }
            function _doBeaconSend(payload, oncomplete) {
                var nav = getNavigator();
                var url = payload[_DYN_URL_STRING /* @min:%2eurlString */];
                if (!url) {
                    _onNoPayloadUrl(oncomplete);
                    // return true here, because we don't want to retry it with fallback sender
                    return true;
                }
                url = payload[_DYN_URL_STRING /* @min:%2eurlString */] + (_addNoResponse ? _noResponseQs : STR_EMPTY);
                var data = payload[_DYN_DATA$1 /* @min:%2edata */];
                // Chrome only allows CORS-safelisted values for the sendBeacon data argument
                // see: https://bugs.chromium.org/p/chromium/issues/detail?id=720283
                // Chrome only allows CORS-safelisted values for the sendBeacon data argument
                // see: https://bugs.chromium.org/p/chromium/issues/detail?id=720283
                var plainTextBatch = _isOneDs ? data : new Blob([data], { type: "text/plain;charset=UTF-8" });
                // The sendBeacon method returns true if the user agent is able to successfully queue the data for transfer. Otherwise it returns false.
                var queued = nav.sendBeacon(url, plainTextBatch);
                return queued;
            }
            /**
             * Send Beacon API request
             * @param payload - {string} - The data payload to be sent.
             * @param sync - {boolean} - not used
             * Note: Beacon API does not support custom headers and we are not able to get
             * appId from the backend for the correct correlation.
             */
            function _beaconSender(payload, oncomplete, sync) {
                var data = payload[_DYN_DATA$1 /* @min:%2edata */];
                try {
                    if (data) {
                        // The sendBeacon method returns true if the user agent is able to successfully queue the data for transfer. Otherwise it returns false.
                        if (!_doBeaconSend(payload, oncomplete)) {
                            var onRetry = _onCompleteFuncs && _onCompleteFuncs.beaconOnRetry;
                            if (onRetry && isFunction(onRetry)) {
                                onRetry(payload, oncomplete, _doBeaconSend);
                            }
                            else {
                                _fallbackInst && _fallbackInst[_DYN_SEND_POST /* @min:%2esendPOST */](payload, oncomplete, true);
                                _throwInternal(_diagLog, 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, ". " + "Failed to send telemetry with Beacon API, retried with normal sender.");
                            }
                        }
                        else {
                            // if can send
                            _onSuccess(STR_EMPTY, oncomplete);
                        }
                    }
                }
                catch (e) {
                    _isOneDs && _warnToConsole(_diagLog, "Failed to send telemetry using sendBeacon API. Ex:" + dumpObj(e));
                    _doOnComplete(oncomplete, _isOneDs ? 0 : 400, {}, STR_EMPTY);
                }
                return;
            }
            /**
             * Send XMLHttpRequest
             * @param payload - {string} - The data payload to be sent.
             * @param sync - {boolean} - Indicates if the request should be sent synchronously
             */
            function _xhrSender(payload, oncomplete, sync) {
                //let  internalPayload = payload as IInternalPayloadData;
                var thePromise;
                var resolveFunc;
                var rejectFunc;
                var headers = payload[_DYN_HEADERS$1 /* @min:%2eheaders */] || {};
                if (!sync && _enableSendPromise) {
                    thePromise = createPromise(function (resolve, reject) {
                        resolveFunc = resolve;
                        rejectFunc = reject;
                    });
                }
                if (_isOneDs && sync && payload.disableXhrSync) {
                    sync = false;
                }
                //const xhr = new XMLHttpRequest();
                var endPointUrl = payload[_DYN_URL_STRING /* @min:%2eurlString */];
                if (!endPointUrl) {
                    _onNoPayloadUrl(oncomplete);
                    resolveFunc && resolveFunc(false);
                    return;
                }
                var xhr = openXhr(STR_POST_METHOD, endPointUrl, _sendCredentials, true, sync, payload[_DYN_TIMEOUT /* @min:%2etimeout */]);
                if (!_isOneDs) {
                    // application/json should NOT add to 1ds post by default
                    xhr[_DYN_SET_REQUEST_HEADER$1 /* @min:%2esetRequestHeader */]("Content-type", "application/json");
                }
                arrForEach(objKeys(headers), function (headerName) {
                    xhr[_DYN_SET_REQUEST_HEADER$1 /* @min:%2esetRequestHeader */](headerName, headers[headerName]);
                });
                xhr.onreadystatechange = function () {
                    if (!_isOneDs) {
                        _doOnReadyFunc(xhr);
                        if (xhr.readyState === 4) {
                            resolveFunc && resolveFunc(true);
                        }
                    }
                };
                xhr.onload = function () {
                    if (_isOneDs) {
                        _doOnReadyFunc(xhr);
                    }
                };
                function _doOnReadyFunc(xhr) {
                    var onReadyFunc = _onCompleteFuncs && _onCompleteFuncs.xhrOnComplete;
                    var onReadyFuncExist = onReadyFunc && isFunction(onReadyFunc);
                    if (onReadyFuncExist) {
                        onReadyFunc(xhr, oncomplete, payload);
                    }
                    else {
                        var response = getResponseText(xhr);
                        _doOnComplete(oncomplete, xhr[_DYN_STATUS$1 /* @min:%2estatus */], _getAllResponseHeaders(xhr, _isOneDs), response);
                    }
                }
                xhr.onerror = function (event) {
                    _doOnComplete(oncomplete, _isOneDs ? xhr[_DYN_STATUS$1 /* @min:%2estatus */] : 400, _getAllResponseHeaders(xhr, _isOneDs), _isOneDs ? STR_EMPTY : formatErrorMessageXhr(xhr));
                    rejectFunc && rejectFunc(event);
                };
                xhr.ontimeout = function () {
                    _doOnComplete(oncomplete, _isOneDs ? xhr[_DYN_STATUS$1 /* @min:%2estatus */] : 500, _getAllResponseHeaders(xhr, _isOneDs), _isOneDs ? STR_EMPTY : formatErrorMessageXhr(xhr));
                    resolveFunc && resolveFunc(false);
                };
                xhr.send(payload[_DYN_DATA$1 /* @min:%2edata */]);
                return thePromise;
            }
            /**
             * Send fetch API request
             * @param payload - {string} - The data payload to be sent.
             * @param sync - {boolean} - For fetch this identifies whether we are "unloading" (false) or a normal request
             */
            function _doFetchSender(payload, oncomplete, sync) {
                var _a;
                var endPointUrl = payload[_DYN_URL_STRING /* @min:%2eurlString */];
                var batch = payload[_DYN_DATA$1 /* @min:%2edata */];
                var plainTextBatch = _isOneDs ? batch : new Blob([batch], { type: "application/json" });
                var thePromise;
                var resolveFunc;
                var rejectFunc;
                var requestHeaders = new Headers();
                var batchLength = batch[_DYN_LENGTH$5 /* @min:%2elength */];
                var ignoreResponse = false;
                var responseHandled = false;
                var headers = payload[_DYN_HEADERS$1 /* @min:%2eheaders */] || {};
                //TODO: handle time out for 1ds
                var init = (_a = {
                        method: STR_POST_METHOD,
                        body: plainTextBatch
                    },
                    _a[DisabledPropertyName$1] = true // Mark so we don't attempt to track this request
                ,
                    _a);
                // Only add headers if there are headers to add, due to issue with some polyfills
                if (payload.headers && objKeys(payload.headers)[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
                    arrForEach(objKeys(headers), function (headerName) {
                        requestHeaders.append(headerName, headers[headerName]);
                    });
                    init[_DYN_HEADERS$1 /* @min:%2eheaders */] = requestHeaders;
                }
                if (_sendCredentials && _isOneDs) {
                    // for 1ds, Don't send credentials when URL is file://
                    init.credentials = "include";
                }
                if (sync) {
                    init.keepalive = true;
                    _syncFetchPayload += batchLength;
                    if (_isOneDs) {
                        if (payload["_sendReason"] === 2 /* SendRequestReason.Unload */) {
                            // As a sync request (during unload), it is unlikely that we will get a chance to process the response so
                            // just like beacon send assume that the events have been accepted and processed
                            ignoreResponse = true;
                            if (_addNoResponse) {
                                endPointUrl += _noResponseQs;
                            }
                        }
                    }
                    else {
                        // for appinsights, set to true for all sync request
                        ignoreResponse = true;
                    }
                }
                var request = new Request(endPointUrl, init);
                try {
                    // Also try and tag the request (just in case the value in init is not copied over)
                    request[DisabledPropertyName$1] = true;
                }
                catch (e) {
                    // If the environment has locked down the XMLHttpRequest (preventExtensions and/or freeze), this would
                    // cause the request to fail and we no telemetry would be sent
                }
                if (!sync && _enableSendPromise) {
                    thePromise = createPromise(function (resolve, reject) {
                        resolveFunc = resolve;
                        rejectFunc = reject;
                    });
                }
                if (!endPointUrl) {
                    _onNoPayloadUrl(oncomplete);
                    resolveFunc && resolveFunc(false);
                    return;
                }
                function _handleError(res) {
                    // In case there is an error in the request. Set the status to 0 for 1ds and 400 for appInsights
                    // so that the events can be retried later.
                    _doOnComplete(oncomplete, _isOneDs ? 0 : 400, {}, _isOneDs ? STR_EMPTY : res);
                }
                function _onFetchComplete(response, payload, value) {
                    var status = response[_DYN_STATUS$1 /* @min:%2estatus */];
                    var onCompleteFunc = _onCompleteFuncs.fetchOnComplete;
                    if (onCompleteFunc && isFunction(onCompleteFunc)) {
                        onCompleteFunc(response, oncomplete, value || STR_EMPTY, payload);
                    }
                    else {
                        _doOnComplete(oncomplete, status, {}, value || STR_EMPTY);
                    }
                }
                try {
                    doAwaitResponse(fetch(_isOneDs ? endPointUrl : request, _isOneDs ? init : null), function (result) {
                        if (sync) {
                            _syncFetchPayload -= batchLength;
                            batchLength = 0;
                        }
                        if (!responseHandled) {
                            responseHandled = true;
                            if (!result.rejected) {
                                var response_1 = result[_DYN_VALUE /* @min:%2evalue */];
                                try {
                                    /**
                                     * The Promise returned from fetch() won’t reject on HTTP error status even if the response is an HTTP 404 or 500.
                                     * Instead, it will resolve normally (with ok status set to false), and it will only reject on network failure
                                     * or if anything prevented the request from completing.
                                     */
                                    if (!_isOneDs && !response_1.ok) {
                                        // this is for appInsights only
                                        _handleError(response_1.statusText);
                                        resolveFunc && resolveFunc(false);
                                    }
                                    else {
                                        if (_isOneDs && !response_1.body) {
                                            _onFetchComplete(response_1, null, STR_EMPTY);
                                            resolveFunc && resolveFunc(true);
                                        }
                                        else {
                                            doAwaitResponse(response_1.text(), function (resp) {
                                                _onFetchComplete(response_1, payload, resp[_DYN_VALUE /* @min:%2evalue */]);
                                                resolveFunc && resolveFunc(true);
                                            });
                                        }
                                    }
                                }
                                catch (e) {
                                    _handleError(dumpObj(e));
                                    rejectFunc && rejectFunc(e);
                                }
                            }
                            else {
                                _handleError(result.reason && result.reason[_DYN_MESSAGE$2 /* @min:%2emessage */]);
                                rejectFunc && rejectFunc(result.reason);
                            }
                        }
                    });
                }
                catch (e) {
                    if (!responseHandled) {
                        _handleError(dumpObj(e));
                        rejectFunc && rejectFunc(e);
                    }
                }
                if (ignoreResponse && !responseHandled) {
                    // Assume success during unload processing as we most likely won't get the response
                    responseHandled = true;
                    _doOnComplete(oncomplete, 200, {});
                    resolveFunc && resolveFunc(true);
                }
                if (_isOneDs && !responseHandled && payload[_DYN_TIMEOUT /* @min:%2etimeout */] > 0) {
                    // Simulate timeout
                    _timeoutWrapper && _timeoutWrapper.set(function () {
                        if (!responseHandled) {
                            // Assume a 500 response (which will cause a retry)
                            responseHandled = true;
                            _doOnComplete(oncomplete, 500, {});
                            resolveFunc && resolveFunc(true);
                        }
                    }, payload[_DYN_TIMEOUT /* @min:%2etimeout */]);
                }
                return thePromise;
            }
            /**
             * Send XDomainRequest
             * @param payload - {string} - The data payload to be sent.
             * @param sync - {boolean} - Indicates if the request should be sent synchronously
             *
             * Note: XDomainRequest does not support sync requests. This 'isAsync' parameter is added
             * to maintain consistency with the xhrSender's contract
             * Note: XDomainRequest does not support custom headers and we are not able to get
             * appId from the backend for the correct correlation.
             */
            function _xdrSender(payload, oncomplete, sync) {
                // It doesn't support custom headers, so no action is taken with current requestHeaders
                var _window = getWindow();
                var xdr = new XDomainRequest();
                var data = payload[_DYN_DATA$1 /* @min:%2edata */];
                xdr.onload = function () {
                    var response = getResponseText(xdr);
                    var onloadFunc = _onCompleteFuncs && _onCompleteFuncs.xdrOnComplete;
                    if (onloadFunc && isFunction(onloadFunc)) {
                        onloadFunc(xdr, oncomplete, payload);
                    }
                    else {
                        _doOnComplete(oncomplete, 200, {}, response);
                    }
                };
                xdr.onerror = function () {
                    _doOnComplete(oncomplete, 400, {}, _isOneDs ? STR_EMPTY : formatErrorMessageXdr(xdr));
                };
                xdr.ontimeout = function () {
                    _doOnComplete(oncomplete, 500, {});
                };
                xdr.onprogress = function () { };
                // XDomainRequest requires the same protocol as the hosting page.
                // If the protocol doesn't match, we can't send the telemetry :(.
                var hostingProtocol = _window && _window.location && _window.location[_DYN_PROTOCOL /* @min:%2eprotocol */] || "";
                var endpoint = payload[_DYN_URL_STRING /* @min:%2eurlString */];
                if (!endpoint) {
                    _onNoPayloadUrl(oncomplete);
                    return;
                }
                if (!_isOneDs && endpoint.lastIndexOf(hostingProtocol, 0) !== 0) {
                    var msg = "Cannot send XDomain request. The endpoint URL protocol doesn't match the hosting page protocol.";
                    _throwInternal(_diagLog, 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, ". " + msg);
                    _onError(msg, oncomplete);
                    return;
                }
                var endpointUrl = _isOneDs ? endpoint : endpoint[_DYN_REPLACE /* @min:%2ereplace */](/^(https?:)/, "");
                xdr.open(STR_POST_METHOD, endpointUrl);
                if (payload[_DYN_TIMEOUT /* @min:%2etimeout */]) {
                    xdr[_DYN_TIMEOUT /* @min:%2etimeout */] = payload[_DYN_TIMEOUT /* @min:%2etimeout */];
                }
                xdr.send(data);
                if (_isOneDs && sync) {
                    _timeoutWrapper && _timeoutWrapper.set(function () {
                        xdr.send(data);
                    }, 0);
                }
                else {
                    xdr.send(data);
                }
            }
            function _initDefaults() {
                _syncFetchPayload = 0;
                _isInitialized = false;
                _enableSendPromise = false;
                _diagLog = null;
                _isOneDs = null;
                _onCompleteFuncs = null;
                _disableCredentials = null;
                _fallbackInst = null;
                _disableXhr = false;
                _disableBeacon = false;
                _disableBeaconSync = false;
                _disableFetchKeepAlive = false;
                _addNoResponse = false;
                _timeoutWrapper = null;
            }
        });
    }
// Removed Stub for SenderPostManager.prototype.initialize.
// Removed Stub for SenderPostManager.prototype.getSyncFetchPayload.
// Removed Stub for SenderPostManager.prototype.SetConfig.
// Removed Stub for SenderPostManager.prototype.getSenderInst.
// Removed Stub for SenderPostManager.prototype.getFallbackInst.
// Removed Stub for SenderPostManager.prototype._doTeardown.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    SenderPostManager.__ieDyn=1;

    return SenderPostManager;
}());

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

// Added to help with minfication
var strOnPrefix = "on";
var strAttachEvent = "attachEvent";
var strAddEventHelper = "addEventListener";
var strDetachEvent = "detachEvent";
var strRemoveEventListener = "removeEventListener";
var strEvents = "events";
var strVisibilityChangeEvt = "visibilitychange";
var strPageHide = "pagehide";
var strUnload = "unload";
var strBeforeUnload = "beforeunload";
var strPageHideNamespace = createUniqueNamespace("aiEvtPageHide");
createUniqueNamespace("aiEvtPageShow");
var rRemoveEmptyNs = /\.[\.]+/g;
var rRemoveTrailingEmptyNs = /[\.]+$/;
var _guid = 1;
var elmNodeData = createElmNodeData("events");
var eventNamespace = /^([^.]*)(?:\.(.+)|)/;
function _normalizeNamespace(name) {
    if (name && name[_DYN_REPLACE /* @min:%2ereplace */]) {
        return name[_DYN_REPLACE /* @min:%2ereplace */](/^[\s\.]+|(?=[\s\.])[\.\s]+$/g, STR_EMPTY$1);
    }
    return name;
}
function _getEvtNamespace(eventName, evtNamespace) {
    var _a;
    if (evtNamespace) {
        var theNamespace_1 = STR_EMPTY$1;
        if (isArray(evtNamespace)) {
            theNamespace_1 = STR_EMPTY$1;
            arrForEach(evtNamespace, function (name) {
                name = _normalizeNamespace(name);
                if (name) {
                    if (name[0] !== ".") {
                        name = "." + name;
                    }
                    theNamespace_1 += name;
                }
            });
        }
        else {
            theNamespace_1 = _normalizeNamespace(evtNamespace);
        }
        if (theNamespace_1) {
            if (theNamespace_1[0] !== ".") {
                theNamespace_1 = "." + theNamespace_1;
            }
            // We may only have the namespace and not an eventName
            eventName = (eventName || STR_EMPTY$1) + theNamespace_1;
        }
    }
    var parsedEvent = (eventNamespace.exec(eventName || STR_EMPTY$1) || []);
    return _a = {},
        _a[_DYN_TYPE /* @min:type */] = parsedEvent[1],
        _a.ns = ((parsedEvent[2] || STR_EMPTY$1).replace(rRemoveEmptyNs, ".").replace(rRemoveTrailingEmptyNs, STR_EMPTY$1)[_DYN_SPLIT$1 /* @min:%2esplit */](".").sort()).join("."),
        _a;
}
// Exported for internal unit testing only
function _getRegisteredEvents(target, evtName, addDefault) {
    if (addDefault === void 0) { addDefault = true; }
    var aiEvts = elmNodeData.get(target, strEvents, {}, addDefault);
    var registeredEvents = aiEvts[evtName];
    if (!registeredEvents) {
        registeredEvents = aiEvts[evtName] = [];
    }
    return registeredEvents;
}
function _doDetach(obj, evtName, handlerRef, useCapture) {
    if (obj && evtName && evtName[_DYN_TYPE /* @min:%2etype */]) {
        if (obj[strRemoveEventListener]) {
            obj[strRemoveEventListener](evtName[_DYN_TYPE /* @min:%2etype */], handlerRef, useCapture);
        }
        else if (obj[strDetachEvent]) {
            obj[strDetachEvent](strOnPrefix + evtName[_DYN_TYPE /* @min:%2etype */], handlerRef);
        }
    }
}
function _doAttach(obj, evtName, handlerRef, useCapture) {
    var result = false;
    if (obj && evtName && evtName[_DYN_TYPE /* @min:%2etype */] && handlerRef) {
        if (obj[strAddEventHelper]) {
            // all browsers except IE before version 9
            obj[strAddEventHelper](evtName[_DYN_TYPE /* @min:%2etype */], handlerRef, useCapture);
            result = true;
        }
        else if (obj[strAttachEvent]) {
            // IE before version 9
            obj[strAttachEvent](strOnPrefix + evtName[_DYN_TYPE /* @min:%2etype */], handlerRef);
            result = true;
        }
    }
    return result;
}
function _doUnregister(target, events, evtName, unRegFn) {
    var idx = events[_DYN_LENGTH$5 /* @min:%2elength */];
    while (idx--) {
        var theEvent = events[idx];
        if (theEvent) {
            if (!evtName.ns || evtName.ns === theEvent.evtName.ns) {
                if (!unRegFn || unRegFn(theEvent)) {
                    _doDetach(target, theEvent.evtName, theEvent[_DYN_HANDLER /* @min:%2ehandler */], theEvent.capture);
                    // Remove the registered event
                    events[_DYN_SPLICE /* @min:%2esplice */](idx, 1);
                }
            }
        }
    }
}
function _unregisterEvents(target, evtName, unRegFn) {
    if (evtName[_DYN_TYPE /* @min:%2etype */]) {
        _doUnregister(target, _getRegisteredEvents(target, evtName[_DYN_TYPE /* @min:%2etype */]), evtName, unRegFn);
    }
    else {
        var eventCache = elmNodeData.get(target, strEvents, {});
        objForEachKey(eventCache, function (evtType, events) {
            _doUnregister(target, events, evtName, unRegFn);
        });
        // Cleanup
        if (objKeys(eventCache)[_DYN_LENGTH$5 /* @min:%2elength */] === 0) {
            elmNodeData.kill(target, strEvents);
        }
    }
}
function mergeEvtNamespace(theNamespace, namespaces) {
    var newNamespaces;
    if (namespaces) {
        if (isArray(namespaces)) {
            newNamespaces = [theNamespace].concat(namespaces);
        }
        else {
            newNamespaces = [theNamespace, namespaces];
        }
        // resort the namespaces so they are always in order
        newNamespaces = (_getEvtNamespace("xx", newNamespaces).ns)[_DYN_SPLIT$1 /* @min:%2esplit */](".");
    }
    else {
        newNamespaces = theNamespace;
    }
    return newNamespaces;
}
/**
 * Binds the specified function to an event, so that the function gets called whenever the event fires on the object
 * @param obj - Object to add the event too.
 * @param eventName - String that specifies any of the standard DHTML Events without "on" prefix, if may also include an optional (dot "." prefixed)
 * namespaces "click" "click.mynamespace" in addition to specific namespaces.
 * @param handlerRef - Pointer that specifies the function to call when event fires
 * @param evtNamespace - [Optional] Additional namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace,
 * if the eventName also includes a namespace the namespace(s) are merged into a single namespace
 * @param useCapture - [Optional] Defaults to false
 * @returns True if the function was bound successfully to the event, otherwise false
 */
function eventOn(target, eventName, handlerRef, evtNamespace, useCapture) {
    var _a;
    if (useCapture === void 0) { useCapture = false; }
    var result = false;
    if (target) {
        try {
            var evtName = _getEvtNamespace(eventName, evtNamespace);
            result = _doAttach(target, evtName, handlerRef, useCapture);
            if (result && elmNodeData.accept(target)) {
                var registeredEvent = (_a = {
                        guid: _guid++,
                        evtName: evtName
                    },
                    _a[_DYN_HANDLER /* @min:handler */] = handlerRef,
                    _a.capture = useCapture,
                    _a);
                _getRegisteredEvents(target, evtName.type)[_DYN_PUSH$2 /* @min:%2epush */](registeredEvent);
            }
        }
        catch (e) {
            // Just Ignore any error so that we don't break any execution path
        }
    }
    return result;
}
/**
 * Removes an event handler for the specified event
 * @param Object - to remove the event from
 * @param eventName - {string} - The name of the event, with optional namespaces or just the namespaces,
 * such as "click", "click.mynamespace" or ".mynamespace"
 * @param handlerRef - {any} - The callback function that needs to be removed from the given event, when using a
 * namespace (with or without a qualifying event) this may be null to remove all previously attached event handlers
 * otherwise this will only remove events with this specific handler.
 * @param evtNamespace - [Optional] Additional namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace,
 * if the eventName also includes a namespace the namespace(s) are merged into a single namespace
 * @param useCapture - [Optional] Defaults to false
 */
function eventOff(target, eventName, handlerRef, evtNamespace, useCapture) {
    if (useCapture === void 0) { useCapture = false; }
    if (target) {
        try {
            var evtName_1 = _getEvtNamespace(eventName, evtNamespace);
            var found_1 = false;
            _unregisterEvents(target, evtName_1, function (regEvent) {
                if ((evtName_1.ns && !handlerRef) || regEvent[_DYN_HANDLER /* @min:%2ehandler */] === handlerRef) {
                    found_1 = true;
                    return true;
                }
                return false;
            });
            if (!found_1) {
                // fallback to try and remove as requested
                _doDetach(target, evtName_1, handlerRef, useCapture);
            }
        }
        catch (e) {
            // Just Ignore any error so that we don't break any execution path
        }
    }
}
/**
 * Trys to add an event handler for the specified event to the window, body and document
 * @param eventName - {string} - The name of the event
 * @param callback - {any} - The callback function that needs to be executed for the given event
 * @param evtNamespace - [Optional] Namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace.
 * @return {boolean} - true if the handler was successfully added
 */
function addEventHandler(eventName, callback, evtNamespace) {
    var result = false;
    var w = getWindow();
    if (w) {
        result = eventOn(w, eventName, callback, evtNamespace);
        result = eventOn(w["body"], eventName, callback, evtNamespace) || result;
    }
    var doc = getDocument();
    if (doc) {
        result = eventOn(doc, eventName, callback, evtNamespace) || result;
    }
    return result;
}
/**
 * Trys to remove event handler(s) for the specified event/namespace to the window, body and document
 * @param eventName - {string} - The name of the event, with optional namespaces or just the namespaces,
 * such as "click", "click.mynamespace" or ".mynamespace"
 * @param callback - {any} - - The callback function that needs to be removed from the given event, when using a
 * namespace (with or without a qualifying event) this may be null to remove all previously attached event handlers
 * otherwise this will only remove events with this specific handler.
 * @param evtNamespace - [Optional] Namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace.
 */
function removeEventHandler(eventName, callback, evtNamespace) {
    var w = getWindow();
    if (w) {
        eventOff(w, eventName, callback, evtNamespace);
        eventOff(w["body"], eventName, callback, evtNamespace);
    }
    var doc = getDocument();
    if (doc) {
        eventOff(doc, eventName, callback, evtNamespace);
    }
}
/**
 * Bind the listener to the array of events
 * @param events - An string array of event names to bind the listener to
 * @param listener - The event callback to call when the event is triggered
 * @param excludeEvents - [Optional] An array of events that should not be hooked (if possible), unless no other events can be.
 * @param evtNamespace - [Optional] Namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace.
 * @returns true - when at least one of the events was registered otherwise false
 */
function _addEventListeners(events, listener, excludeEvents, evtNamespace) {
    var added = false;
    if (listener && events && events[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
        arrForEach(events, function (name) {
            if (name) {
                if (!excludeEvents || arrIndexOf(excludeEvents, name) === -1) {
                    added = addEventHandler(name, listener, evtNamespace) || added;
                }
            }
        });
    }
    return added;
}
/**
 * Bind the listener to the array of events
 * @param events - An string array of event names to bind the listener to
 * @param listener - The event callback to call when the event is triggered
 * @param excludeEvents - [Optional] An array of events that should not be hooked (if possible), unless no other events can be.
 * @param evtNamespace - [Optional] Namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace.
 * @returns true - when at least one of the events was registered otherwise false
 */
function addEventListeners(events, listener, excludeEvents, evtNamespace) {
    var added = false;
    if (listener && events && isArray(events)) {
        added = _addEventListeners(events, listener, excludeEvents, evtNamespace);
        if (!added && excludeEvents && excludeEvents[_DYN_LENGTH$5 /* @min:%2elength */] > 0) {
            // Failed to add any listeners and we excluded some, so just attempt to add the excluded events
            added = _addEventListeners(events, listener, null, evtNamespace);
        }
    }
    return added;
}
/**
 * Remove the listener from the array of events
 * @param events - An string array of event names to bind the listener to
 * @param listener - The event callback to call when the event is triggered
 * @param evtNamespace - [Optional] Namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace.
 */
function removeEventListeners(events, listener, evtNamespace) {
    if (events && isArray(events)) {
        arrForEach(events, function (name) {
            if (name) {
                removeEventHandler(name, listener, evtNamespace);
            }
        });
    }
}
/**
 * Listen to the 'beforeunload', 'unload' and 'pagehide' events which indicates a page unload is occurring,
 * this does NOT listen to the 'visibilitychange' event as while it does indicate that the page is being hidden
 * it does not *necessarily* mean that the page is being completely unloaded, it can mean that the user is
 * just navigating to a different Tab and may come back (without unloading the page). As such you may also
 * need to listen to the 'addPageHideEventListener' and 'addPageShowEventListener' events.
 * @param listener - The event callback to call when a page unload event is triggered
 * @param excludeEvents - [Optional] An array of events that should not be hooked, unless no other events can be.
 * @param evtNamespace - [Optional] Namespace(s) to append to the event listeners so they can be uniquely identified and removed based on this namespace.
 * @returns true - when at least one of the events was registered otherwise false
 */
function addPageUnloadEventListener(listener, excludeEvents, evtNamespace) {
    // Hook the unload event for the document, window and body to ensure that the client events are flushed to the server
    // As just hooking the window does not always fire (on chrome) for page navigation's.
    return addEventListeners([strBeforeUnload, strUnload, strPageHide], listener, excludeEvents, evtNamespace);
}
/**
 * Remove any matching 'beforeunload', 'unload' and 'pagehide' events that may have been added via addEventListener,
 * addEventListeners, addPageUnloadEventListener or addPageHideEventListener.
 * @param listener - The specific event callback to to be removed
 * @param evtNamespace - [Optional] Namespace(s) uniquely identified and removed based on this namespace.
 * @returns true - when at least one of the events was registered otherwise false
 */
function removePageUnloadEventListener(listener, evtNamespace) {
    removeEventListeners([strBeforeUnload, strUnload, strPageHide], listener, evtNamespace);
}
/**
 * Listen to the pagehide and visibility changing to 'hidden' events, because the 'visibilitychange' uses
 * an internal proxy to detect the visibility state you SHOULD use a unique namespace when if you plan to call
 * removePageShowEventListener as the remove ignores the listener argument for the 'visibilitychange' event.
 * @param listener - The event callback to call when a page hide event is triggered
 * @param excludeEvents - [Optional] An array of events that should not be hooked (if possible), unless no other events can be.
 * @param evtNamespace - [Optional] A Namespace to append to the event listeners so they can be uniquely identified and removed
 * based on this namespace. This call also adds an additional unique "pageshow" namespace to the events
 * so that only the matching "removePageHideEventListener" can remove these events.
 * Suggestion: pass as true if you are also calling addPageUnloadEventListener as that also hooks pagehide
 * @returns true - when at least one of the events was registered otherwise false
 */
function addPageHideEventListener(listener, excludeEvents, evtNamespace) {
    function _handlePageVisibility(evt) {
        var doc = getDocument();
        if (listener && doc && doc.visibilityState === "hidden") {
            listener(evt);
        }
    }
    // add the unique page show namespace to any provided namespace so we can only remove the ones added by "pagehide"
    var newNamespaces = mergeEvtNamespace(strPageHideNamespace, evtNamespace);
    var pageUnloadAdded = _addEventListeners([strPageHide], listener, excludeEvents, newNamespaces);
    if (!excludeEvents || arrIndexOf(excludeEvents, strVisibilityChangeEvt) === -1) {
        pageUnloadAdded = _addEventListeners([strVisibilityChangeEvt], _handlePageVisibility, excludeEvents, newNamespaces) || pageUnloadAdded;
    }
    if (!pageUnloadAdded && excludeEvents) {
        // Failed to add any listeners and we where requested to exclude some, so just call again without excluding anything
        pageUnloadAdded = addPageHideEventListener(listener, null, evtNamespace);
    }
    return pageUnloadAdded;
}
/**
 * Removes the pageHide event listeners added by addPageHideEventListener, because the 'visibilitychange' uses
 * an internal proxy to detect the visibility state you SHOULD use a unique namespace when calling addPageHideEventListener
 * as the remove ignores the listener argument for the 'visibilitychange' event.
 * @param listener - The specific listener to remove for the 'pageshow' event only (ignored for 'visibilitychange')
 * @param evtNamespace - The unique namespace used when calling addPageShowEventListener
 */
function removePageHideEventListener(listener, evtNamespace) {
    // add the unique page show namespace to any provided namespace so we only remove the ones added by "pagehide"
    var newNamespaces = mergeEvtNamespace(strPageHideNamespace, evtNamespace);
    removeEventListeners([strPageHide], listener, newNamespaces);
    removeEventListeners([strVisibilityChangeEvt], null, newNamespaces);
}

/*
 * Application Insights JavaScript SDK - Core, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var aiInstrumentHooks = "_aiHooks";
var cbNames = [
    "req", "rsp", "hkErr", "fnErr"
];
/** @ignore */
function _arrLoop(arr, fn) {
    if (arr) {
        for (var lp = 0; lp < arr[_DYN_LENGTH$5 /* @min:%2elength */]; lp++) {
            if (fn(arr[lp], lp)) {
                break;
            }
        }
    }
}
/** @ignore */
function _doCallbacks(hooks, callDetails, cbArgs, hookCtx, type) {
    if (type >= 0 /* CallbackType.Request */ && type <= 2 /* CallbackType.HookError */) {
        _arrLoop(hooks, function (hook, idx) {
            var cbks = hook.cbks;
            var cb = cbks[cbNames[type]];
            if (cb) {
                // Set the specific hook context implementation using a lazy creation pattern
                callDetails.ctx = function () {
                    var ctx = hookCtx[idx] = (hookCtx[idx] || {});
                    return ctx;
                };
                try {
                    cb[_DYN_APPLY /* @min:%2eapply */](callDetails.inst, cbArgs);
                }
                catch (err) {
                    var orgEx = callDetails.err;
                    try {
                        // Report Hook error via the callback
                        var hookErrorCb = cbks[cbNames[2 /* CallbackType.HookError */]];
                        if (hookErrorCb) {
                            callDetails.err = err;
                            hookErrorCb[_DYN_APPLY /* @min:%2eapply */](callDetails.inst, cbArgs);
                        }
                    }
                    catch (e) {
                        // Not much we can do here -- swallowing the exception to avoid crashing the hosting app
                    }
                    finally {
                        // restore the original exception (if any)
                        callDetails.err = orgEx;
                    }
                }
            }
        });
    }
}
/** @ignore */
function _createFunctionHook(aiHook) {
    // Define a temporary method that queues-up a the real method call
    return function () {
        var _a;
        var funcThis = this;
        // Capture the original arguments passed to the method
        var orgArgs = arguments;
        var hooks = aiHook.h;
        var funcArgs = (_a = {},
            _a[_DYN_NAME$3 /* @min:name */] = aiHook.n,
            _a.inst = funcThis,
            _a.ctx = null,
            _a.set = _replaceArg,
            _a);
        var hookCtx = [];
        var cbArgs = _createArgs([funcArgs], orgArgs);
        funcArgs.evt = getInst("event");
        function _createArgs(target, theArgs) {
            _arrLoop(theArgs, function (arg) {
                target[_DYN_PUSH$2 /* @min:%2epush */](arg);
            });
            return target;
        }
        function _replaceArg(idx, value) {
            orgArgs = _createArgs([], orgArgs);
            orgArgs[idx] = value;
            cbArgs = _createArgs([funcArgs], orgArgs);
        }
        // Call the pre-request hooks
        _doCallbacks(hooks, funcArgs, cbArgs, hookCtx, 0 /* CallbackType.Request */);
        // Call the original function was called
        var theFunc = aiHook.f;
        if (theFunc) {
            try {
                funcArgs.rslt = theFunc[_DYN_APPLY /* @min:%2eapply */](funcThis, orgArgs);
            }
            catch (err) {
                // Report the request callback
                funcArgs.err = err;
                _doCallbacks(hooks, funcArgs, cbArgs, hookCtx, 3 /* CallbackType.FunctionError */);
                // rethrow the original exception so anyone listening for it can catch the exception
                throw err;
            }
        }
        // Call the post-request hooks
        _doCallbacks(hooks, funcArgs, cbArgs, hookCtx, 1 /* CallbackType.Response */);
        return funcArgs.rslt;
    };
}
/** @ignore */
function _getOwner(target, name, checkPrototype, checkParentProto) {
    var owner = null;
    if (target) {
        if (objHasOwnProperty(target, name)) {
            owner = target;
        }
        else if (checkPrototype) {
            owner = _getOwner(_getObjProto(target), name, checkParentProto, false);
        }
    }
    return owner;
}
/**
 * Intercept the named prototype functions for the target class / object
 * @param target - The target object
 * @param funcName - The function name
 * @param callbacks - The callbacks to configure and call whenever the function is called
 */
function InstrumentProto(target, funcName, callbacks) {
    if (target) {
        return InstrumentFunc(target[strShimPrototype], funcName, callbacks, false);
    }
    return null;
}
function _createInstrumentHook(owner, funcName, fn, callbacks) {
    var aiHook = fn && fn[aiInstrumentHooks];
    if (!aiHook) {
        // Only hook the function once
        aiHook = {
            i: 0,
            n: funcName,
            f: fn,
            h: []
        };
        // Override (hook) the original function
        var newFunc = _createFunctionHook(aiHook);
        newFunc[aiInstrumentHooks] = aiHook; // Tag and store the function hooks
        owner[funcName] = newFunc;
    }
    var theHook = {
        // tslint:disable:object-literal-shorthand
        id: aiHook.i,
        cbks: callbacks,
        rm: function () {
            // DO NOT Use () => { shorthand for the function as the this gets replaced
            // with the outer this and not the this for theHook instance.
            var id = this.id;
            _arrLoop(aiHook.h, function (hook, idx) {
                if (hook.id === id) {
                    aiHook.h[_DYN_SPLICE /* @min:%2esplice */](idx, 1);
                    return 1;
                }
            });
        }
        // tslint:enable:object-literal-shorthand
    };
    aiHook.i++;
    aiHook.h[_DYN_PUSH$2 /* @min:%2epush */](theHook);
    return theHook;
}
/**
 * Intercept the named prototype functions for the target class / object
 * @param target - The target object
 * @param funcName - The function name
 * @param callbacks - The callbacks to configure and call whenever the function is called
 * @param checkPrototype - If the function doesn't exist on the target should it attempt to hook the prototype function
 * @param checkParentProto - If the function doesn't exist on the target or it's prototype should it attempt to hook the parent's prototype
 */
function InstrumentFunc(target, funcName, callbacks, checkPrototype, checkParentProto) {
    if (checkPrototype === void 0) { checkPrototype = true; }
    if (target && funcName && callbacks) {
        var owner = _getOwner(target, funcName, checkPrototype, checkParentProto);
        if (owner) {
            var fn = owner[funcName];
            if (typeof fn === strShimFunction) {
                return _createInstrumentHook(owner, funcName, fn, callbacks);
            }
        }
    }
    return null;
}
/**
 * Add an instrumentation hook to the provided named "event" for the target class / object, this doesn't check whether the
 * named "event" is in fact a function and just assigns the instrumentation hook to the target[evtName]
 * @param target - The target object
 * @param evtName - The name of the event
 * @param callbacks - The callbacks to configure and call whenever the function is called
 * @param checkPrototype - If the function doesn't exist on the target should it attempt to hook the prototype function
 * @param checkParentProto - If the function doesn't exist on the target or it's prototype should it attempt to hook the parent's prototype
 */
function InstrumentEvent(target, evtName, callbacks, checkPrototype, checkParentProto) {
    if (target && evtName && callbacks) {
        var owner = _getOwner(target, evtName, checkPrototype, checkParentProto) || target;
        if (owner) {
            return _createInstrumentHook(owner, evtName, owner[evtName], callbacks);
        }
    }
    return null;
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


/**
 * This is an internal property used to cause internal (reporting) requests to be ignored from reporting
 * additional telemetry, to handle polyfil implementations ALL urls used with a disabled request will
 * also be ignored for future requests even when this property is not provided.
 * Tagging as Ignore as this is an internal value and is not expected to be used outside of the SDK
 * @ignore
 */
var DisabledPropertyName = "Microsoft_ApplicationInsights_BypassAjaxInstrumentation";
var SampleRate = "sampleRate";
var ProcessLegacy = "ProcessLegacy";
var HttpMethod = "http.method";
var DEFAULT_BREEZE_ENDPOINT = "https://dc.services.visualstudio.com";
var DEFAULT_BREEZE_PATH = "/v2/track";
var strNotSpecified = "not_specified";
var strIkey = "iKey";

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var RequestHeaders = createValueMap({
    requestContextHeader: [0 /* eRequestHeaders.requestContextHeader */, "Request-Context"],
    requestContextTargetKey: [1 /* eRequestHeaders.requestContextTargetKey */, "appId"],
    requestContextAppIdFormat: [2 /* eRequestHeaders.requestContextAppIdFormat */, "appId=cid-v1:"],
    requestIdHeader: [3 /* eRequestHeaders.requestIdHeader */, "Request-Id"],
    traceParentHeader: [4 /* eRequestHeaders.traceParentHeader */, "traceparent"],
    traceStateHeader: [5 /* eRequestHeaders.traceStateHeader */, "tracestate"],
    sdkContextHeader: [6 /* eRequestHeaders.sdkContextHeader */, "Sdk-Context"],
    sdkContextHeaderAppIdRequest: [7 /* eRequestHeaders.sdkContextHeaderAppIdRequest */, "appId"],
    requestContextHeaderLowerCase: [8 /* eRequestHeaders.requestContextHeaderLowerCase */, "request-context"]
});

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_SPLIT = "split"; // Count: 6
var _DYN_LENGTH$4 = "length"; // Count: 41
var _DYN_TO_LOWER_CASE$1 = "toLowerCase"; // Count: 6
var _DYN_INGESTIONENDPOINT$1 = "ingestionendpoint"; // Count: 6
var _DYN_TO_STRING$2 = "toString"; // Count: 9
var _DYN_PUSH$1 = "push"; // Count: 5
var _DYN_REMOVE_ITEM = "removeItem"; // Count: 3
var _DYN_NAME$2 = "name"; // Count: 11
var _DYN_MESSAGE$1 = "message"; // Count: 10
var _DYN_COUNT$1 = "count"; // Count: 8
var _DYN_PRE_TRIGGER_DATE = "preTriggerDate"; // Count: 4
var _DYN_DISABLED = "disabled"; // Count: 3
var _DYN_INTERVAL = "interval"; // Count: 3
var _DYN_DAYS_OF_MONTH = "daysOfMonth"; // Count: 3
var _DYN_DATE = "date"; // Count: 5
var _DYN_GET_UTCDATE = "getUTCDate"; // Count: 3
var _DYN_STRINGIFY$1 = "stringify"; // Count: 4
var _DYN_PATHNAME = "pathname"; // Count: 4
var _DYN_CORRELATION_HEADER_E0 = "correlationHeaderExcludePatterns"; // Count: 2
var _DYN_EXCEPTIONS = "exceptions"; // Count: 6
var _DYN_PARSED_STACK = "parsedStack"; // Count: 13
var _DYN_PROPERTIES$1 = "properties"; // Count: 9
var _DYN_MEASUREMENTS$1 = "measurements"; // Count: 9
var _DYN_SIZE_IN_BYTES = "sizeInBytes"; // Count: 11
var _DYN_TYPE_NAME = "typeName"; // Count: 11
var _DYN_SEVERITY_LEVEL = "severityLevel"; // Count: 5
var _DYN_PROBLEM_GROUP = "problemGroup"; // Count: 3
var _DYN_IS_MANUAL = "isManual"; // Count: 3
var _DYN__CREATE_FROM_INTERFA1 = "CreateFromInterface"; // Count: 2
var _DYN_ASSEMBLY = "assembly"; // Count: 7
var _DYN_FILE_NAME = "fileName"; // Count: 8
var _DYN_HAS_FULL_STACK = "hasFullStack"; // Count: 6
var _DYN_LEVEL = "level"; // Count: 5
var _DYN_METHOD$1 = "method"; // Count: 7
var _DYN_LINE = "line"; // Count: 6
var _DYN_DURATION$1 = "duration"; // Count: 4
var _DYN_RECEIVED_RESPONSE = "receivedResponse"; // Count: 2

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

function dataSanitizeKeyAndAddUniqueness(logger, key, map) {
    var origLength = key[_DYN_LENGTH$4 /* @min:%2elength */];
    var field = dataSanitizeKey(logger, key);
    // validation truncated the length.  We need to add uniqueness
    if (field[_DYN_LENGTH$4 /* @min:%2elength */] !== origLength) {
        var i = 0;
        var uniqueField = field;
        while (map[uniqueField] !== undefined) {
            i++;
            uniqueField = strSubstring(field, 0, 150 /* DataSanitizerValues.MAX_NAME_LENGTH */ - 3) + dsPadNumber(i);
        }
        field = uniqueField;
    }
    return field;
}
function dataSanitizeKey(logger, name) {
    var nameTrunc;
    if (name) {
        // Remove any leading or trailing whitespace
        name = strTrim(asString(name));
        // truncate the string to 150 chars
        if (name[_DYN_LENGTH$4 /* @min:%2elength */] > 150 /* DataSanitizerValues.MAX_NAME_LENGTH */) {
            nameTrunc = strSubstring(name, 0, 150 /* DataSanitizerValues.MAX_NAME_LENGTH */);
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 57 /* _eInternalMessageId.NameTooLong */, "name is too long.  It has been truncated to " + 150 /* DataSanitizerValues.MAX_NAME_LENGTH */ + " characters.", { name: name }, true);
        }
    }
    return nameTrunc || name;
}
function dataSanitizeString(logger, value, maxLength) {
    if (maxLength === void 0) { maxLength = 1024 /* DataSanitizerValues.MAX_STRING_LENGTH */; }
    var valueTrunc;
    if (value) {
        maxLength = maxLength ? maxLength : 1024 /* DataSanitizerValues.MAX_STRING_LENGTH */; // in case default parameters dont work
        value = strTrim(asString(value));
        if (value[_DYN_LENGTH$4 /* @min:%2elength */] > maxLength) {
            valueTrunc = strSubstring(value, 0, maxLength);
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 61 /* _eInternalMessageId.StringValueTooLong */, "string value is too long. It has been truncated to " + maxLength + " characters.", { value: value }, true);
        }
    }
    return valueTrunc || value;
}
function dataSanitizeUrl(logger, url) {
    return dataSanitizeInput(logger, url, 2048 /* DataSanitizerValues.MAX_URL_LENGTH */, 66 /* _eInternalMessageId.UrlTooLong */);
}
function dataSanitizeMessage(logger, message) {
    var messageTrunc;
    if (message) {
        if (message[_DYN_LENGTH$4 /* @min:%2elength */] > 32768 /* DataSanitizerValues.MAX_MESSAGE_LENGTH */) {
            messageTrunc = strSubstring(message, 0, 32768 /* DataSanitizerValues.MAX_MESSAGE_LENGTH */);
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 56 /* _eInternalMessageId.MessageTruncated */, "message is too long, it has been truncated to " + 32768 /* DataSanitizerValues.MAX_MESSAGE_LENGTH */ + " characters.", { message: message }, true);
        }
    }
    return messageTrunc || message;
}
function dataSanitizeException(logger, exception) {
    var exceptionTrunc;
    if (exception) {
        // Make surte its a string
        var value = "" + exception;
        if (value[_DYN_LENGTH$4 /* @min:%2elength */] > 32768 /* DataSanitizerValues.MAX_EXCEPTION_LENGTH */) {
            exceptionTrunc = strSubstring(value, 0, 32768 /* DataSanitizerValues.MAX_EXCEPTION_LENGTH */);
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 52 /* _eInternalMessageId.ExceptionTruncated */, "exception is too long, it has been truncated to " + 32768 /* DataSanitizerValues.MAX_EXCEPTION_LENGTH */ + " characters.", { exception: exception }, true);
        }
    }
    return exceptionTrunc || exception;
}
function dataSanitizeProperties(logger, properties) {
    if (properties) {
        var tempProps_1 = {};
        objForEachKey(properties, function (prop, value) {
            if (isObject(value) && hasJSON()) {
                // Stringify any part C properties
                try {
                    value = getJSON()[_DYN_STRINGIFY$1 /* @min:%2estringify */](value);
                }
                catch (e) {
                    _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 49 /* _eInternalMessageId.CannotSerializeObjectNonSerializable */, "custom property is not valid", { exception: e }, true);
                }
            }
            value = dataSanitizeString(logger, value, 8192 /* DataSanitizerValues.MAX_PROPERTY_LENGTH */);
            prop = dataSanitizeKeyAndAddUniqueness(logger, prop, tempProps_1);
            tempProps_1[prop] = value;
        });
        properties = tempProps_1;
    }
    return properties;
}
function dataSanitizeMeasurements(logger, measurements) {
    if (measurements) {
        var tempMeasurements_1 = {};
        objForEachKey(measurements, function (measure, value) {
            measure = dataSanitizeKeyAndAddUniqueness(logger, measure, tempMeasurements_1);
            tempMeasurements_1[measure] = value;
        });
        measurements = tempMeasurements_1;
    }
    return measurements;
}
function dataSanitizeId(logger, id) {
    return id ? dataSanitizeInput(logger, id, 128 /* DataSanitizerValues.MAX_ID_LENGTH */, 69 /* _eInternalMessageId.IdTooLong */)[_DYN_TO_STRING$2 /* @min:%2etoString */]() : id;
}
function dataSanitizeInput(logger, input, maxLength, _msgId) {
    var inputTrunc;
    if (input) {
        input = strTrim(asString(input));
        if (input[_DYN_LENGTH$4 /* @min:%2elength */] > maxLength) {
            inputTrunc = strSubstring(input, 0, maxLength);
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, _msgId, "input is too long, it has been truncated to " + maxLength + " characters.", { data: input }, true);
        }
    }
    return inputTrunc || input;
}
function dsPadNumber(num) {
    var s = "00" + num;
    return strSubstr(s, s[_DYN_LENGTH$4 /* @min:%2elength */] - 3);
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var _document = getDocument() || {};
var _htmlAnchorIdx = 0;
// Use an array of temporary values as it's possible for multiple calls to parseUrl() will be called with different URLs
// Using a cache size of 5 for now as it current depth usage is at least 2, so adding a minor buffer to handle future updates
var _htmlAnchorElement = [null, null, null, null, null];
function urlParseUrl(url) {
    var anchorIdx = _htmlAnchorIdx;
    var anchorCache = _htmlAnchorElement;
    var tempAnchor = anchorCache[anchorIdx];
    if (!_document.createElement) {
        // Always create the temp instance if createElement is not available
        tempAnchor = { host: urlParseHost(url, true) };
    }
    else if (!anchorCache[anchorIdx]) {
        // Create and cache the unattached anchor instance
        tempAnchor = anchorCache[anchorIdx] = _document.createElement("a");
    }
    tempAnchor.href = url;
    // Move the cache index forward
    anchorIdx++;
    if (anchorIdx >= anchorCache[_DYN_LENGTH$4 /* @min:%2elength */]) {
        anchorIdx = 0;
    }
    _htmlAnchorIdx = anchorIdx;
    return tempAnchor;
}
function urlGetAbsoluteUrl(url) {
    var result;
    var a = urlParseUrl(url);
    if (a) {
        result = a.href;
    }
    return result;
}
function urlGetCompleteUrl(method, absoluteUrl) {
    if (method) {
        return method.toUpperCase() + " " + absoluteUrl;
    }
    return absoluteUrl;
}
// Fallback method to grab host from url if document.createElement method is not available
function urlParseHost(url, inclPort) {
    var fullHost = urlParseFullHost(url, inclPort) || "";
    if (fullHost) {
        var match = fullHost.match(/(www\d{0,5}\.)?([^\/:]{1,256})(:\d{1,20})?/i);
        if (match != null && match[_DYN_LENGTH$4 /* @min:%2elength */] > 3 && isString(match[2]) && match[2][_DYN_LENGTH$4 /* @min:%2elength */] > 0) {
            return match[2] + (match[3] || "");
        }
    }
    return fullHost;
}
function urlParseFullHost(url, inclPort) {
    var result = null;
    if (url) {
        var match = url.match(/(\w{1,150}):\/\/([^\/:]{1,256})(:\d{1,20})?/i);
        if (match != null && match[_DYN_LENGTH$4 /* @min:%2elength */] > 2 && isString(match[2]) && match[2][_DYN_LENGTH$4 /* @min:%2elength */] > 0) {
            result = match[2] || "";
            if (inclPort && match[_DYN_LENGTH$4 /* @min:%2elength */] > 2) {
                var protocol = (match[1] || "")[_DYN_TO_LOWER_CASE$1 /* @min:%2etoLowerCase */]();
                var port = match[3] || "";
                // IE includes the standard port so pass it off if it's the same as the protocol
                if (protocol === "http" && port === ":80") {
                    port = "";
                }
                else if (protocol === "https" && port === ":443") {
                    port = "";
                }
                result += port;
            }
        }
    }
    return result;
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

// listing only non-geo specific locations
var _internalEndpoints = [
    DEFAULT_BREEZE_ENDPOINT + DEFAULT_BREEZE_PATH,
    "https://breeze.aimon.applicationinsights.io" + DEFAULT_BREEZE_PATH,
    "https://dc-int.services.visualstudio.com" + DEFAULT_BREEZE_PATH
];
var _correlationIdPrefix = "cid-v1:";
function isInternalApplicationInsightsEndpoint(endpointUrl) {
    return arrIndexOf(_internalEndpoints, endpointUrl[_DYN_TO_LOWER_CASE$1 /* @min:%2etoLowerCase */]()) !== -1;
}
/**
 * Checks if a request url is not on a excluded domain list and if it is safe to add correlation headers.
 * Headers are always included if the current domain matches the request domain. If they do not match (CORS),
 * they are regex-ed across correlationHeaderDomains and correlationHeaderExcludedDomains to determine if headers are included.
 * Some environments don't give information on currentHost via window.location.host (e.g. Cordova). In these cases, the user must
 * manually supply domains to include correlation headers on. Else, no headers will be included at all.
 */
function correlationIdCanIncludeCorrelationHeader(config, requestUrl, currentHost) {
    if (!requestUrl || (config && config.disableCorrelationHeaders)) {
        return false;
    }
    if (config && config[_DYN_CORRELATION_HEADER_E0 /* @min:%2ecorrelationHeaderExcludePatterns */]) {
        for (var i = 0; i < config.correlationHeaderExcludePatterns[_DYN_LENGTH$4 /* @min:%2elength */]; i++) {
            if (config[_DYN_CORRELATION_HEADER_E0 /* @min:%2ecorrelationHeaderExcludePatterns */][i].test(requestUrl)) {
                return false;
            }
        }
    }
    var requestHost = urlParseUrl(requestUrl).host[_DYN_TO_LOWER_CASE$1 /* @min:%2etoLowerCase */]();
    if (requestHost && (strIndexOf(requestHost, ":443") !== -1 || strIndexOf(requestHost, ":80") !== -1)) {
        // [Bug #1260] IE can include the port even for http and https URLs so if present
        // try and parse it to remove if it matches the default protocol port
        requestHost = (urlParseFullHost(requestUrl, true) || "")[_DYN_TO_LOWER_CASE$1 /* @min:%2etoLowerCase */]();
    }
    if ((!config || !config.enableCorsCorrelation) && (requestHost && requestHost !== currentHost)) {
        return false;
    }
    var includedDomains = config && config.correlationHeaderDomains;
    if (includedDomains) {
        var matchExists_1;
        arrForEach(includedDomains, function (domain) {
            var regex = new RegExp(domain.toLowerCase().replace(/\\/g, "\\\\").replace(/\./g, "\\.").replace(/\*/g, ".*"));
            matchExists_1 = matchExists_1 || regex.test(requestHost);
        });
        if (!matchExists_1) {
            return false;
        }
    }
    var excludedDomains = config && config.correlationHeaderExcludedDomains;
    if (!excludedDomains || excludedDomains[_DYN_LENGTH$4 /* @min:%2elength */] === 0) {
        return true;
    }
    for (var i = 0; i < excludedDomains[_DYN_LENGTH$4 /* @min:%2elength */]; i++) {
        var regex = new RegExp(excludedDomains[i].toLowerCase().replace(/\\/g, "\\\\").replace(/\./g, "\\.").replace(/\*/g, ".*"));
        if (regex.test(requestHost)) {
            return false;
        }
    }
    // if we don't know anything about the requestHost, require the user to use included/excludedDomains.
    // Previously we always returned false for a falsy requestHost
    return requestHost && requestHost[_DYN_LENGTH$4 /* @min:%2elength */] > 0;
}
/**
 * Combines target appId and target role name from response header.
 */
function correlationIdGetCorrelationContext(responseHeader) {
    if (responseHeader) {
        var correlationId = correlationIdGetCorrelationContextValue(responseHeader, RequestHeaders[1 /* eRequestHeaders.requestContextTargetKey */]);
        if (correlationId && correlationId !== _correlationIdPrefix) {
            return correlationId;
        }
    }
}
/**
 * Gets key from correlation response header
 */
function correlationIdGetCorrelationContextValue(responseHeader, key) {
    if (responseHeader) {
        var keyValues = responseHeader[_DYN_SPLIT /* @min:%2esplit */](",");
        for (var i = 0; i < keyValues[_DYN_LENGTH$4 /* @min:%2elength */]; ++i) {
            var keyValue = keyValues[i][_DYN_SPLIT /* @min:%2esplit */]("=");
            if (keyValue[_DYN_LENGTH$4 /* @min:%2elength */] === 2 && keyValue[0] === key) {
                return keyValue[1];
            }
        }
    }
}
function AjaxHelperParseDependencyPath(logger, absoluteUrl, method, commandName) {
    var target, name = commandName, data = commandName;
    if (absoluteUrl && absoluteUrl[_DYN_LENGTH$4 /* @min:%2elength */] > 0) {
        var parsedUrl = urlParseUrl(absoluteUrl);
        target = parsedUrl.host;
        if (!name) {
            if (parsedUrl[_DYN_PATHNAME /* @min:%2epathname */] != null) {
                var pathName = (parsedUrl.pathname[_DYN_LENGTH$4 /* @min:%2elength */] === 0) ? "/" : parsedUrl[_DYN_PATHNAME /* @min:%2epathname */];
                if (pathName.charAt(0) !== "/") {
                    pathName = "/" + pathName;
                }
                data = parsedUrl[_DYN_PATHNAME /* @min:%2epathname */];
                name = dataSanitizeString(logger, method ? method + " " + pathName : pathName);
            }
            else {
                name = dataSanitizeString(logger, absoluteUrl);
            }
        }
    }
    else {
        target = commandName;
        name = commandName;
    }
    return {
        target: target,
        name: name,
        data: data
    };
}
function dateTimeUtilsNow() {
    // returns the window or webworker performance object
    var perf = getPerformance();
    if (perf && perf.now && perf.timing) {
        var now = perf.now() + perf.timing.navigationStart;
        // Known issue with IE where this calculation can be negative, so if it is then ignore and fallback
        if (now > 0) {
            return now;
        }
    }
    return utcNow();
}
function dateTimeUtilsDuration(start, end) {
    var result = null;
    if (start !== 0 && end !== 0 && !isNullOrUndefined(start) && !isNullOrUndefined(end)) {
        result = end - start;
    }
    return result;
}
/**
 * Creates a IDistributedTraceContext from an optional telemetryTrace
 * @param telemetryTrace - The telemetryTrace instance that is being wrapped
 * @param parentCtx - An optional parent distributed trace instance, almost always undefined as this scenario is only used in the case of multiple property handlers.
 * @returns A new IDistributedTraceContext instance that is backed by the telemetryTrace or temporary object
 */
function createDistributedTraceContextFromTrace(telemetryTrace, parentCtx) {
    var trace = telemetryTrace || {};
    return {
        getName: function () {
            return trace[_DYN_NAME$2 /* @min:%2ename */];
        },
        setName: function (newValue) {
            parentCtx && parentCtx.setName(newValue);
            trace[_DYN_NAME$2 /* @min:%2ename */] = newValue;
        },
        getTraceId: function () {
            return trace.traceID;
        },
        setTraceId: function (newValue) {
            parentCtx && parentCtx.setTraceId(newValue);
            if (isValidTraceId(newValue)) {
                trace.traceID = newValue;
            }
        },
        getSpanId: function () {
            return trace.parentID;
        },
        setSpanId: function (newValue) {
            parentCtx && parentCtx.setSpanId(newValue);
            if (isValidSpanId(newValue)) {
                trace.parentID = newValue;
            }
        },
        getTraceFlags: function () {
            return trace.traceFlags;
        },
        setTraceFlags: function (newTraceFlags) {
            parentCtx && parentCtx.setTraceFlags(newTraceFlags);
            trace.traceFlags = newTraceFlags;
        }
    };
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var StorageType = createEnumStyle({
    LocalStorage: 0 /* eStorageType.LocalStorage */,
    SessionStorage: 1 /* eStorageType.SessionStorage */
});

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var _canUseLocalStorage = undefined;
var _canUseSessionStorage = undefined;
var _storagePrefix = "";
/**
 * Gets the localStorage object if available
 * @return {Storage} - Returns the storage object if available else returns null
 */
function _getLocalStorageObject() {
    if (utlCanUseLocalStorage()) {
        return _getVerifiedStorageObject(StorageType.LocalStorage);
    }
    return null;
}
/**
 * Tests storage object (localStorage or sessionStorage) to verify that it is usable
 * More details here: https://mathiasbynens.be/notes/localstorage-pattern
 * @param storageType - Type of storage
 * @return {Storage} Returns storage object verified that it is usable
 */
function _getVerifiedStorageObject(storageType) {
    try {
        if (isNullOrUndefined(getGlobal())) {
            return null;
        }
        var uid = (new Date)[_DYN_TO_STRING$2 /* @min:%2etoString */]();
        var storage = getInst(storageType === StorageType.LocalStorage ? "localStorage" : "sessionStorage");
        var name_1 = _storagePrefix + uid;
        storage.setItem(name_1, uid);
        var fail = storage.getItem(name_1) !== uid;
        storage[_DYN_REMOVE_ITEM /* @min:%2eremoveItem */](name_1);
        if (!fail) {
            return storage;
        }
    }
    catch (exception) {
        // eslint-disable-next-line no-empty
    }
    return null;
}
/**
 * Gets the sessionStorage object if available
 * @return {Storage} - Returns the storage object if available else returns null
 */
function _getSessionStorageObject() {
    if (utlCanUseSessionStorage()) {
        return _getVerifiedStorageObject(StorageType.SessionStorage);
    }
    return null;
}
/**
 * Disables the global SDK usage of local or session storage if available
 */
function utlDisableStorage() {
    _canUseLocalStorage = false;
    _canUseSessionStorage = false;
}
function utlSetStoragePrefix(storagePrefix) {
    _storagePrefix = storagePrefix || "";
}
/**
 * Re-enables the global SDK usage of local or session storage if available
 */
function utlEnableStorage() {
    _canUseLocalStorage = utlCanUseLocalStorage(true);
    _canUseSessionStorage = utlCanUseSessionStorage(true);
}
/**
 * Returns whether LocalStorage can be used, if the reset parameter is passed a true this will override
 * any previous disable calls.
 * @param reset - Should the usage be reset and determined only based on whether LocalStorage is available
 */
function utlCanUseLocalStorage(reset) {
    if (reset || _canUseLocalStorage === undefined) {
        _canUseLocalStorage = !!_getVerifiedStorageObject(StorageType.LocalStorage);
    }
    return _canUseLocalStorage;
}
function utlGetLocalStorage(logger, name) {
    var storage = _getLocalStorageObject();
    if (storage !== null) {
        try {
            return storage.getItem(name);
        }
        catch (e) {
            _canUseLocalStorage = false;
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 1 /* _eInternalMessageId.BrowserCannotReadLocalStorage */, "Browser failed read of local storage. " + getExceptionName(e), { exception: dumpObj(e) });
        }
    }
    return null;
}
function utlSetLocalStorage(logger, name, data) {
    var storage = _getLocalStorageObject();
    if (storage !== null) {
        try {
            storage.setItem(name, data);
            return true;
        }
        catch (e) {
            _canUseLocalStorage = false;
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 3 /* _eInternalMessageId.BrowserCannotWriteLocalStorage */, "Browser failed write to local storage. " + getExceptionName(e), { exception: dumpObj(e) });
        }
    }
    return false;
}
function utlRemoveStorage(logger, name) {
    var storage = _getLocalStorageObject();
    if (storage !== null) {
        try {
            storage[_DYN_REMOVE_ITEM /* @min:%2eremoveItem */](name);
            return true;
        }
        catch (e) {
            _canUseLocalStorage = false;
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 5 /* _eInternalMessageId.BrowserFailedRemovalFromLocalStorage */, "Browser failed removal of local storage item. " + getExceptionName(e), { exception: dumpObj(e) });
        }
    }
    return false;
}
function utlCanUseSessionStorage(reset) {
    if (reset || _canUseSessionStorage === undefined) {
        _canUseSessionStorage = !!_getVerifiedStorageObject(StorageType.SessionStorage);
    }
    return _canUseSessionStorage;
}
function utlGetSessionStorage(logger, name) {
    var storage = _getSessionStorageObject();
    if (storage !== null) {
        try {
            return storage.getItem(name);
        }
        catch (e) {
            _canUseSessionStorage = false;
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 2 /* _eInternalMessageId.BrowserCannotReadSessionStorage */, "Browser failed read of session storage. " + getExceptionName(e), { exception: dumpObj(e) });
        }
    }
    return null;
}
function utlSetSessionStorage(logger, name, data) {
    var storage = _getSessionStorageObject();
    if (storage !== null) {
        try {
            storage.setItem(name, data);
            return true;
        }
        catch (e) {
            _canUseSessionStorage = false;
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 4 /* _eInternalMessageId.BrowserCannotWriteSessionStorage */, "Browser failed write to session storage. " + getExceptionName(e), { exception: dumpObj(e) });
        }
    }
    return false;
}
function utlRemoveSessionStorage(logger, name) {
    var storage = _getSessionStorageObject();
    if (storage !== null) {
        try {
            storage[_DYN_REMOVE_ITEM /* @min:%2eremoveItem */](name);
            return true;
        }
        catch (e) {
            _canUseSessionStorage = false;
            _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 6 /* _eInternalMessageId.BrowserFailedRemovalFromSessionStorage */, "Browser failed removal of session storage item. " + getExceptionName(e), { exception: dumpObj(e) });
        }
    }
    return false;
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var THROTTLE_STORAGE_PREFIX = "appInsightsThrottle";
var ThrottleMgr = /** @class */ (function () {
    function ThrottleMgr(core, namePrefix) {
        var _self = this;
        var _canUseLocalStorage;
        var _logger;
        var _config;
        var _localStorageObj;
        var _isTriggered; //_isTriggered is to make sure that we only trigger throttle once a day
        var _namePrefix;
        var _queue;
        var _isReady = false;
        var _isSpecificDaysGiven = false;
        _initConfig();
        // Special internal method to allow the unit tests and DebugPlugin to hook embedded objects
        _self["_getDbgPlgTargets"] = function () {
            return [_queue];
        };
        _self.getConfig = function () {
            return _config;
        };
        /**
         * Check if it is the correct day to send message.
         * If _isTriggered is true, even if canThrottle returns true, message will not be sent,
         * because we only allow triggering sendMessage() once a day.
         * @returns if the current date is the valid date to send message
         */
        _self.canThrottle = function (msgId) {
            var localObj = _getLocalStorageObjByKey(msgId);
            var cfg = _getCfgByKey(msgId);
            return _canThrottle(cfg, _canUseLocalStorage, localObj);
        };
        /**
         * Check if throttle is triggered on current day(UTC)
         * if canThrottle returns false, isTriggered will return false
         * @returns if throttle is triggered on current day(UTC)
         */
        _self.isTriggered = function (msgId) {
            return _isTrigger(msgId);
        };
        /**
         * Before isReady set to true, all message will be stored in queue.
         * Message will only be sent out after isReady set to true.
         * Initial and default value: false
         * @returns isReady state
         */
        _self.isReady = function () {
            return _isReady;
        };
        /**
         * Flush all message with given message key in queue with isReady state set to true.
         * @returns if message queue is flushed
         */
        _self.flush = function (msgId) {
            try {
                var queue = _getQueueByKey(msgId);
                if (queue && queue[_DYN_LENGTH$4 /* @min:%2elength */] > 0) {
                    var items = queue.slice(0);
                    _queue[msgId] = [];
                    arrForEach(items, function (item) {
                        _flushMessage(item.msgID, item[_DYN_MESSAGE$1 /* @min:%2emessage */], item.severity, false);
                    });
                    return true;
                }
            }
            catch (err) {
                // eslint-disable-next-line no-empty
            }
            return false;
        };
        /**
         * Flush all message in queue with isReady state set to true.
         * @returns if message queue is flushed
         */
        _self.flushAll = function () {
            try {
                if (_queue) {
                    var result_1 = true;
                    objForEachKey(_queue, function (key) {
                        var isFlushed = _self.flush(parseInt(key));
                        result_1 = result_1 && isFlushed;
                    });
                    return result_1;
                }
            }
            catch (err) {
                // eslint-disable-next-line no-empty
            }
            return false;
        };
        /**
         * Set isReady State
         * if isReady set to true, message queue will be flushed automatically.
         * @param isReady isReady State
         * @pa
         * @returns if message queue is flushed
         */
        _self.onReadyState = function (isReady, flushAll) {
            if (flushAll === void 0) { flushAll = true; }
            _isReady = isNullOrUndefined(isReady) ? true : isReady;
            if (_isReady && flushAll) {
                return _self.flushAll();
            }
            return null;
        };
        _self.sendMessage = function (msgID, message, severity) {
            return _flushMessage(msgID, message, severity, true);
        };
        function _flushMessage(msgID, message, severity, saveUnsentMsg) {
            if (_isReady) {
                var isSampledIn = _canSampledIn(msgID);
                if (!isSampledIn) {
                    return;
                }
                var cfg = _getCfgByKey(msgID);
                var localStorageObj = _getLocalStorageObjByKey(msgID);
                var canThrottle = _canThrottle(cfg, _canUseLocalStorage, localStorageObj);
                var throttled = false;
                var number = 0;
                var isTriggered = _isTrigger(msgID);
                try {
                    if (canThrottle && !isTriggered) {
                        number = Math.min(cfg.limit.maxSendNumber, localStorageObj[_DYN_COUNT$1 /* @min:%2ecount */] + 1);
                        localStorageObj[_DYN_COUNT$1 /* @min:%2ecount */] = 0;
                        throttled = true;
                        _isTriggered[msgID] = true;
                        localStorageObj[_DYN_PRE_TRIGGER_DATE /* @min:%2epreTriggerDate */] = new Date();
                    }
                    else {
                        _isTriggered[msgID] = canThrottle;
                        localStorageObj[_DYN_COUNT$1 /* @min:%2ecount */] += 1;
                    }
                    var localStorageName = _getLocalStorageName(msgID);
                    _resetLocalStorage(_logger, localStorageName, localStorageObj);
                    for (var i = 0; i < number; i++) {
                        _sendMessage(msgID, _logger, message, severity);
                    }
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return {
                    isThrottled: throttled,
                    throttleNum: number
                };
            }
            else {
                if (!!saveUnsentMsg) {
                    var queue = _getQueueByKey(msgID);
                    queue[_DYN_PUSH$1 /* @min:%2epush */]({
                        msgID: msgID,
                        message: message,
                        severity: severity
                    });
                }
            }
            return null;
        }
        function _initConfig() {
            _logger = safeGetLogger(core);
            _isTriggered = {};
            _localStorageObj = {};
            _queue = {};
            _config = {};
            _setCfgByKey(109 /* _eInternalMessageId.DefaultThrottleMsgKey */);
            _namePrefix = isNotNullOrUndefined(namePrefix) ? namePrefix : "";
            core.addUnloadHook(onConfigChange(core.config, function (details) {
                var coreConfig = details.cfg;
                _canUseLocalStorage = utlCanUseLocalStorage();
                var configMgr = coreConfig.throttleMgrCfg || {};
                objForEachKey(configMgr, function (key, cfg) {
                    _setCfgByKey(parseInt(key), cfg);
                });
            }));
        }
        function _getCfgByKey(msgID) {
            return _config[msgID] || _config[109 /* _eInternalMessageId.DefaultThrottleMsgKey */];
        }
        function _setCfgByKey(msgID, config) {
            var _a, _b;
            try {
                var cfg = config || {};
                var curCfg = {};
                curCfg[_DYN_DISABLED /* @min:%2edisabled */] = !!cfg[_DYN_DISABLED /* @min:%2edisabled */];
                var configInterval = cfg[_DYN_INTERVAL /* @min:%2einterval */] || {};
                _isSpecificDaysGiven = (configInterval === null || configInterval === void 0 ? void 0 : configInterval.daysOfMonth) && (configInterval === null || configInterval === void 0 ? void 0 : configInterval.daysOfMonth[_DYN_LENGTH$4 /* @min:%2elength */]) > 0;
                curCfg[_DYN_INTERVAL /* @min:%2einterval */] = _getIntervalConfig(configInterval);
                var limit = {
                    samplingRate: ((_a = cfg.limit) === null || _a === void 0 ? void 0 : _a.samplingRate) || 100,
                    // dafault: every time sent only 1 event
                    maxSendNumber: ((_b = cfg.limit) === null || _b === void 0 ? void 0 : _b.maxSendNumber) || 1
                };
                curCfg.limit = limit;
                _config[msgID] = curCfg;
            }
            catch (e) {
                // eslint-disable-next-line no-empty
            }
        }
        function _getIntervalConfig(interval) {
            interval = interval || {};
            var monthInterval = interval === null || interval === void 0 ? void 0 : interval.monthInterval;
            var dayInterval = interval === null || interval === void 0 ? void 0 : interval.dayInterval;
            // default: send data every 3 month each year
            if (isNullOrUndefined(monthInterval) && isNullOrUndefined(dayInterval)) {
                interval.monthInterval = 3;
                if (!_isSpecificDaysGiven) {
                    // default: send data on 28th
                    interval[_DYN_DAYS_OF_MONTH /* @min:%2edaysOfMonth */] = [28];
                    _isSpecificDaysGiven = true;
                }
            }
            interval = {
                // dafault: sent every three months
                monthInterval: interval === null || interval === void 0 ? void 0 : interval.monthInterval,
                dayInterval: interval === null || interval === void 0 ? void 0 : interval.dayInterval,
                daysOfMonth: interval === null || interval === void 0 ? void 0 : interval.daysOfMonth
            };
            return interval;
        }
        function _canThrottle(config, canUseLocalStorage, localStorageObj) {
            if (config && !config[_DYN_DISABLED /* @min:%2edisabled */] && canUseLocalStorage && isNotNullOrUndefined(localStorageObj)) {
                var curDate = _getThrottleDate();
                var date = localStorageObj[_DYN_DATE /* @min:%2edate */];
                var interval = config[_DYN_INTERVAL /* @min:%2einterval */];
                var monthCheck = 1;
                if (interval === null || interval === void 0 ? void 0 : interval.monthInterval) {
                    var monthExpand = (curDate.getUTCFullYear() - date.getUTCFullYear()) * 12 + curDate.getUTCMonth() - date.getUTCMonth();
                    monthCheck = _checkInterval(interval.monthInterval, 0, monthExpand);
                }
                var dayCheck = 1;
                if (_isSpecificDaysGiven) {
                    dayCheck = arrIndexOf(interval[_DYN_DAYS_OF_MONTH /* @min:%2edaysOfMonth */], curDate[_DYN_GET_UTCDATE /* @min:%2egetUTCDate */]());
                }
                else if (interval === null || interval === void 0 ? void 0 : interval.dayInterval) {
                    var daySpan = Math.floor((curDate.getTime() - date.getTime()) / 86400000);
                    dayCheck = _checkInterval(interval.dayInterval, 0, daySpan);
                }
                return monthCheck >= 0 && dayCheck >= 0;
            }
            return false;
        }
        function _getLocalStorageName(msgKey, prefix) {
            var fix = isNotNullOrUndefined(prefix) ? prefix : "";
            if (msgKey) {
                return THROTTLE_STORAGE_PREFIX + fix + "-" + msgKey;
            }
            return null;
        }
        // returns if throttle is triggered on current Date
        function _isTriggeredOnCurDate(preTriggerDate) {
            try {
                if (preTriggerDate) {
                    var curDate = new Date();
                    return preTriggerDate.getUTCFullYear() === curDate.getUTCFullYear() &&
                        preTriggerDate.getUTCMonth() === curDate.getUTCMonth() &&
                        preTriggerDate[_DYN_GET_UTCDATE /* @min:%2egetUTCDate */]() === curDate[_DYN_GET_UTCDATE /* @min:%2egetUTCDate */]();
                }
            }
            catch (e) {
                // eslint-disable-next-line no-empty
            }
            return false;
        }
        // transfer local storage string value to object that identifies start date, current count and preTriggerDate
        function _getLocalStorageObj(value, logger, storageName) {
            try {
                var storageObj = {
                    date: _getThrottleDate(),
                    count: 0
                };
                if (value) {
                    var obj = JSON.parse(value);
                    var curObj = {
                        date: _getThrottleDate(obj[_DYN_DATE /* @min:%2edate */]) || storageObj[_DYN_DATE /* @min:%2edate */],
                        count: obj[_DYN_COUNT$1 /* @min:%2ecount */] || storageObj[_DYN_COUNT$1 /* @min:%2ecount */],
                        preTriggerDate: obj.preTriggerDate ? _getThrottleDate(obj[_DYN_PRE_TRIGGER_DATE /* @min:%2epreTriggerDate */]) : undefined
                    };
                    return curObj;
                }
                else {
                    _resetLocalStorage(logger, storageName, storageObj);
                    return storageObj;
                }
            }
            catch (e) {
                // eslint-disable-next-line no-empty
            }
            return null;
        }
        // if datestr is not defined, current date will be returned
        function _getThrottleDate(dateStr) {
            // if new Date() can't be created through the provided dateStr, null will be returned.
            try {
                if (dateStr) {
                    var date = new Date(dateStr);
                    //make sure it is a valid Date Object
                    if (!isNaN(date.getDate())) {
                        return date;
                    }
                }
                else {
                    return new Date();
                }
            }
            catch (e) {
                // eslint-disable-next-line no-empty
            }
            return null;
        }
        function _resetLocalStorage(logger, storageName, obj) {
            try {
                return utlSetLocalStorage(logger, storageName, strTrim(JSON[_DYN_STRINGIFY$1 /* @min:%2estringify */](obj)));
            }
            catch (e) {
                // eslint-disable-next-line no-empty
            }
            return false;
        }
        function _checkInterval(interval, start, current) {
            if (interval <= 0) {
                return 1;
            }
            // count from start year
            return (current >= start) && (current - start) % interval == 0 ? Math.floor((current - start) / interval) + 1 : -1;
        }
        function _sendMessage(msgID, logger, message, severity) {
            _throwInternal(logger, severity || 1 /* eLoggingSeverity.CRITICAL */, msgID, message);
        }
        // NOTE: config.limit.samplingRate is set to 4 decimal places,
        // so config.limit.samplingRate = 1 means 0.0001%
        function _canSampledIn(msgID) {
            try {
                var cfg = _getCfgByKey(msgID);
                return randomValue(1000000) <= cfg.limit.samplingRate;
            }
            catch (e) {
                // eslint-disable-next-line no-empty
            }
            return false;
        }
        function _getLocalStorageObjByKey(key) {
            try {
                var curObj = _localStorageObj[key];
                if (!curObj) {
                    var localStorageName = _getLocalStorageName(key, _namePrefix);
                    curObj = _getLocalStorageObj(utlGetLocalStorage(_logger, localStorageName), _logger, localStorageName);
                    _localStorageObj[key] = curObj;
                }
                return _localStorageObj[key];
            }
            catch (e) {
                // eslint-disable-next-line no-empty
            }
            return null;
        }
        function _isTrigger(key) {
            var isTrigger = _isTriggered[key];
            if (isNullOrUndefined(isTrigger)) {
                isTrigger = false;
                var localStorageObj = _getLocalStorageObjByKey(key);
                if (localStorageObj) {
                    isTrigger = _isTriggeredOnCurDate(localStorageObj[_DYN_PRE_TRIGGER_DATE /* @min:%2epreTriggerDate */]);
                }
                _isTriggered[key] = isTrigger;
            }
            return _isTriggered[key];
        }
        function _getQueueByKey(key) {
            _queue = _queue || {};
            if (isNullOrUndefined(_queue[key])) {
                _queue[key] = [];
            }
            return _queue[key];
        }
    }
    return ThrottleMgr;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var _FIELDS_SEPARATOR = ";";
var _FIELD_KEY_VALUE_SEPARATOR = "=";
function parseConnectionString(connectionString) {
    if (!connectionString) {
        return {};
    }
    var kvPairs = connectionString[_DYN_SPLIT /* @min:%2esplit */](_FIELDS_SEPARATOR);
    var result = arrReduce(kvPairs, function (fields, kv) {
        var kvParts = kv[_DYN_SPLIT /* @min:%2esplit */](_FIELD_KEY_VALUE_SEPARATOR);
        if (kvParts[_DYN_LENGTH$4 /* @min:%2elength */] === 2) { // only save fields with valid formats
            var key = kvParts[0][_DYN_TO_LOWER_CASE$1 /* @min:%2etoLowerCase */]();
            var value = kvParts[1];
            fields[key] = value;
        }
        return fields;
    }, {});
    if (objKeys(result)[_DYN_LENGTH$4 /* @min:%2elength */] > 0) {
        // this is a valid connection string, so parse the results
        if (result.endpointsuffix) {
            // apply the default endpoints
            var locationPrefix = result.location ? result.location + "." : "";
            result[_DYN_INGESTIONENDPOINT$1 /* @min:%2eingestionendpoint */] = result[_DYN_INGESTIONENDPOINT$1 /* @min:%2eingestionendpoint */] || ("https://" + locationPrefix + "dc." + result.endpointsuffix);
        }
        // apply user override endpoint or the default endpoints
        result[_DYN_INGESTIONENDPOINT$1 /* @min:%2eingestionendpoint */] = result[_DYN_INGESTIONENDPOINT$1 /* @min:%2eingestionendpoint */] || DEFAULT_BREEZE_ENDPOINT;
        if (strEndsWith(result[_DYN_INGESTIONENDPOINT$1 /* @min:%2eingestionendpoint */], "/")) {
            result[_DYN_INGESTIONENDPOINT$1 /* @min:%2eingestionendpoint */] = result[_DYN_INGESTIONENDPOINT$1 /* @min:%2eingestionendpoint */].slice(0, -1);
        }
    }
    return result;
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var Envelope = /** @class */ (function () {
    /**
     * Constructs a new instance of telemetry data.
     */
    function Envelope(logger, data, name) {
        var _this = this;
        var _self = this;
        _self.ver = 1;
        _self.sampleRate = 100.0;
        _self.tags = {};
        _self[_DYN_NAME$2 /* @min:%2ename */] = dataSanitizeString(logger, name) || strNotSpecified;
        _self.data = data;
        _self.time = toISOString(new Date());
        _self.aiDataContract = {
            time: 1 /* FieldType.Required */,
            iKey: 1 /* FieldType.Required */,
            name: 1 /* FieldType.Required */,
            sampleRate: function () {
                return (_this.sampleRate === 100) ? 4 /* FieldType.Hidden */ : 1 /* FieldType.Required */;
            },
            tags: 1 /* FieldType.Required */,
            data: 1 /* FieldType.Required */
        };
    }
    return Envelope;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var Event$1 = /** @class */ (function () {
    /**
     * Constructs a new instance of the EventTelemetry object
     */
    function Event(logger, name, properties, measurements) {
        this.aiDataContract = {
            ver: 1 /* FieldType.Required */,
            name: 1 /* FieldType.Required */,
            properties: 0 /* FieldType.Default */,
            measurements: 0 /* FieldType.Default */
        };
        var _self = this;
        _self.ver = 2;
        _self[_DYN_NAME$2 /* @min:%2ename */] = dataSanitizeString(logger, name) || strNotSpecified;
        _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = dataSanitizeProperties(logger, properties);
        _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = dataSanitizeMeasurements(logger, measurements);
    }
    Event.envelopeType = "Microsoft.ApplicationInsights.{0}.Event";
    Event.dataType = "EventData";
    return Event;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var NoMethod = "<no_method>";
var strError = "error";
var strStack = "stack";
var strStackDetails = "stackDetails";
var strErrorSrc = "errorSrc";
var strMessage = "message";
var strDescription = "description";
function _stringify(value, convertToString) {
    var result = value;
    if (result && !isString(result)) {
        if (JSON && JSON[_DYN_STRINGIFY$1 /* @min:%2estringify */]) {
            result = JSON[_DYN_STRINGIFY$1 /* @min:%2estringify */](value);
            if (convertToString && (!result || result === "{}")) {
                if (isFunction(value[_DYN_TO_STRING$2 /* @min:%2etoString */])) {
                    result = value[_DYN_TO_STRING$2 /* @min:%2etoString */]();
                }
                else {
                    result = "" + value;
                }
            }
        }
        else {
            result = "" + value + " - (Missing JSON.stringify)";
        }
    }
    return result || "";
}
function _formatMessage(theEvent, errorType) {
    var evtMessage = theEvent;
    if (theEvent) {
        if (evtMessage && !isString(evtMessage)) {
            evtMessage = theEvent[strMessage] || theEvent[strDescription] || evtMessage;
        }
        // Make sure the message is a string
        if (evtMessage && !isString(evtMessage)) {
            // tslint:disable-next-line: prefer-conditional-expression
            evtMessage = _stringify(evtMessage, true);
        }
        if (theEvent["filename"]) {
            // Looks like an event object with filename
            evtMessage = evtMessage + " @" + (theEvent["filename"] || "") + ":" + (theEvent["lineno"] || "?") + ":" + (theEvent["colno"] || "?");
        }
    }
    // Automatically add the error type to the message if it does already appear to be present
    if (errorType && errorType !== "String" && errorType !== "Object" && errorType !== "Error" && strIndexOf(evtMessage || "", errorType) === -1) {
        evtMessage = errorType + ": " + evtMessage;
    }
    return evtMessage || "";
}
function _isExceptionDetailsInternal(value) {
    try {
        if (isObject(value)) {
            return "hasFullStack" in value && "typeName" in value;
        }
    }
    catch (e) {
        // This can happen with some native browser objects, but should not happen for the type we are checking for
    }
    return false;
}
function _isExceptionInternal(value) {
    try {
        if (isObject(value)) {
            return ("ver" in value && "exceptions" in value && "properties" in value);
        }
    }
    catch (e) {
        // This can happen with some native browser objects, but should not happen for the type we are checking for
    }
    return false;
}
function _isStackDetails(details) {
    return details && details.src && isString(details.src) && details.obj && isArray(details.obj);
}
function _convertStackObj(errorStack) {
    var src = errorStack || "";
    if (!isString(src)) {
        if (isString(src[strStack])) {
            src = src[strStack];
        }
        else {
            src = "" + src;
        }
    }
    var items = src[_DYN_SPLIT /* @min:%2esplit */]("\n");
    return {
        src: src,
        obj: items
    };
}
function _getOperaStack(errorMessage) {
    var stack = [];
    var lines = errorMessage[_DYN_SPLIT /* @min:%2esplit */]("\n");
    for (var lp = 0; lp < lines[_DYN_LENGTH$4 /* @min:%2elength */]; lp++) {
        var entry = lines[lp];
        if (lines[lp + 1]) {
            entry += "@" + lines[lp + 1];
            lp++;
        }
        stack[_DYN_PUSH$1 /* @min:%2epush */](entry);
    }
    return {
        src: errorMessage,
        obj: stack
    };
}
function _getStackFromErrorObj(errorObj) {
    var details = null;
    if (errorObj) {
        try {
            /* Using bracket notation is support older browsers (IE 7/8 -- dont remember the version) that throw when using dot
            notation for undefined objects and we don't want to loose the error from being reported */
            if (errorObj[strStack]) {
                // Chrome/Firefox
                details = _convertStackObj(errorObj[strStack]);
            }
            else if (errorObj[strError] && errorObj[strError][strStack]) {
                // Edge error event provides the stack and error object
                details = _convertStackObj(errorObj[strError][strStack]);
            }
            else if (errorObj["exception"] && errorObj.exception[strStack]) {
                details = _convertStackObj(errorObj.exception[strStack]);
            }
            else if (_isStackDetails(errorObj)) {
                details = errorObj;
            }
            else if (_isStackDetails(errorObj[strStackDetails])) {
                details = errorObj[strStackDetails];
            }
            else if (getWindow() && getWindow()["opera"] && errorObj[strMessage]) {
                // Opera
                details = _getOperaStack(errorObj[_DYN_MESSAGE$1 /* @min:%2emessage */]);
            }
            else if (errorObj["reason"] && errorObj.reason[strStack]) {
                // UnhandledPromiseRejection
                details = _convertStackObj(errorObj.reason[strStack]);
            }
            else if (isString(errorObj)) {
                details = _convertStackObj(errorObj);
            }
            else {
                var evtMessage = errorObj[strMessage] || errorObj[strDescription] || "";
                if (isString(errorObj[strErrorSrc])) {
                    if (evtMessage) {
                        evtMessage += "\n";
                    }
                    evtMessage += " from " + errorObj[strErrorSrc];
                }
                if (evtMessage) {
                    details = _convertStackObj(evtMessage);
                }
            }
        }
        catch (e) {
            // something unexpected happened so to avoid failing to report any error lets swallow the exception
            // and fallback to the callee/caller method
            details = _convertStackObj(e);
        }
    }
    return details || {
        src: "",
        obj: null
    };
}
function _formatStackTrace(stackDetails) {
    var stack = "";
    if (stackDetails) {
        if (stackDetails.obj) {
            arrForEach(stackDetails.obj, function (entry) {
                stack += entry + "\n";
            });
        }
        else {
            stack = stackDetails.src || "";
        }
    }
    return stack;
}
function _parseStack(stack) {
    var parsedStack;
    var frames = stack.obj;
    if (frames && frames[_DYN_LENGTH$4 /* @min:%2elength */] > 0) {
        parsedStack = [];
        var level_1 = 0;
        var totalSizeInBytes_1 = 0;
        arrForEach(frames, function (frame) {
            var theFrame = frame[_DYN_TO_STRING$2 /* @min:%2etoString */]();
            if (_StackFrame.regex.test(theFrame)) {
                var parsedFrame = new _StackFrame(theFrame, level_1++);
                totalSizeInBytes_1 += parsedFrame[_DYN_SIZE_IN_BYTES /* @min:%2esizeInBytes */];
                parsedStack[_DYN_PUSH$1 /* @min:%2epush */](parsedFrame);
            }
        });
        // DP Constraint - exception parsed stack must be < 32KB
        // remove frames from the middle to meet the threshold
        var exceptionParsedStackThreshold = 32 * 1024;
        if (totalSizeInBytes_1 > exceptionParsedStackThreshold) {
            var left = 0;
            var right = parsedStack[_DYN_LENGTH$4 /* @min:%2elength */] - 1;
            var size = 0;
            var acceptedLeft = left;
            var acceptedRight = right;
            while (left < right) {
                // check size
                var lSize = parsedStack[left][_DYN_SIZE_IN_BYTES /* @min:%2esizeInBytes */];
                var rSize = parsedStack[right][_DYN_SIZE_IN_BYTES /* @min:%2esizeInBytes */];
                size += lSize + rSize;
                if (size > exceptionParsedStackThreshold) {
                    // remove extra frames from the middle
                    var howMany = acceptedRight - acceptedLeft + 1;
                    parsedStack.splice(acceptedLeft, howMany);
                    break;
                }
                // update pointers
                acceptedLeft = left;
                acceptedRight = right;
                left++;
                right--;
            }
        }
    }
    return parsedStack;
}
function _getErrorType(errorType) {
    // Gets the Error Type by passing the constructor (used to get the true type of native error object).
    var typeName = "";
    if (errorType) {
        typeName = errorType.typeName || errorType[_DYN_NAME$2 /* @min:%2ename */] || "";
        if (!typeName) {
            try {
                var funcNameRegex = /function (.{1,200})\(/;
                var results = (funcNameRegex).exec((errorType).constructor[_DYN_TO_STRING$2 /* @min:%2etoString */]());
                typeName = (results && results[_DYN_LENGTH$4 /* @min:%2elength */] > 1) ? results[1] : "";
            }
            catch (e) {
                // eslint-disable-next-line no-empty -- Ignoring any failures as nothing we can do
            }
        }
    }
    return typeName;
}
/**
 * Formats the provided errorObj for display and reporting, it may be a String, Object, integer or undefined depending on the browser.
 * @param errorObj - The supplied errorObj
 */
function _formatErrorCode(errorObj) {
    if (errorObj) {
        try {
            if (!isString(errorObj)) {
                var errorType = _getErrorType(errorObj);
                var result = _stringify(errorObj, false);
                if (!result || result === "{}") {
                    if (errorObj[strError]) {
                        // Looks like an MS Error Event
                        errorObj = errorObj[strError];
                        errorType = _getErrorType(errorObj);
                    }
                    result = _stringify(errorObj, true);
                }
                if (strIndexOf(result, errorType) !== 0 && errorType !== "String") {
                    return errorType + ":" + result;
                }
                return result;
            }
        }
        catch (e) {
            // eslint-disable-next-line no-empty -- Ignoring any failures as nothing we can do
        }
    }
    // Fallback to just letting the object format itself into a string
    return "" + (errorObj || "");
}
var Exception = /** @class */ (function () {
    /**
     * Constructs a new instance of the ExceptionTelemetry object
     */
    function Exception(logger, exception, properties, measurements, severityLevel, id) {
        this.aiDataContract = {
            ver: 1 /* FieldType.Required */,
            exceptions: 1 /* FieldType.Required */,
            severityLevel: 0 /* FieldType.Default */,
            properties: 0 /* FieldType.Default */,
            measurements: 0 /* FieldType.Default */
        };
        var _self = this;
        _self.ver = 2; // TODO: handle the CS"4.0" ==> breeze 2 conversion in a better way
        if (!_isExceptionInternal(exception)) {
            if (!properties) {
                properties = {};
            }
            if (id) {
                properties.id = id;
            }
            _self[_DYN_EXCEPTIONS /* @min:%2eexceptions */] = [new _ExceptionDetails(logger, exception, properties)];
            _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = dataSanitizeProperties(logger, properties);
            _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = dataSanitizeMeasurements(logger, measurements);
            if (severityLevel) {
                _self[_DYN_SEVERITY_LEVEL /* @min:%2eseverityLevel */] = severityLevel;
            }
            if (id) {
                _self.id = id;
            }
        }
        else {
            _self[_DYN_EXCEPTIONS /* @min:%2eexceptions */] = exception[_DYN_EXCEPTIONS /* @min:%2eexceptions */] || [];
            _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = exception[_DYN_PROPERTIES$1 /* @min:%2eproperties */];
            _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = exception[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */];
            if (exception[_DYN_SEVERITY_LEVEL /* @min:%2eseverityLevel */]) {
                _self[_DYN_SEVERITY_LEVEL /* @min:%2eseverityLevel */] = exception[_DYN_SEVERITY_LEVEL /* @min:%2eseverityLevel */];
            }
            if (exception.id) {
                _self.id = exception.id;
                exception[_DYN_PROPERTIES$1 /* @min:%2eproperties */].id = exception.id;
            }
            if (exception[_DYN_PROBLEM_GROUP /* @min:%2eproblemGroup */]) {
                _self[_DYN_PROBLEM_GROUP /* @min:%2eproblemGroup */] = exception[_DYN_PROBLEM_GROUP /* @min:%2eproblemGroup */];
            }
            // bool/int types, use isNullOrUndefined
            if (!isNullOrUndefined(exception[_DYN_IS_MANUAL /* @min:%2eisManual */])) {
                _self[_DYN_IS_MANUAL /* @min:%2eisManual */] = exception[_DYN_IS_MANUAL /* @min:%2eisManual */];
            }
        }
    }
    Exception.CreateAutoException = function (message, url, lineNumber, columnNumber, error, evt, stack, errorSrc) {
        var _a;
        var errorType = _getErrorType(error || evt || message);
        return _a = {},
            _a[_DYN_MESSAGE$1 /* @min:message */] = _formatMessage(message, errorType),
            _a.url = url,
            _a.lineNumber = lineNumber,
            _a.columnNumber = columnNumber,
            _a.error = _formatErrorCode(error || evt || message),
            _a.evt = _formatErrorCode(evt || message),
            _a[_DYN_TYPE_NAME /* @min:typeName */] = errorType,
            _a.stackDetails = _getStackFromErrorObj(stack || error || evt),
            _a.errorSrc = errorSrc,
            _a;
    };
    Exception.CreateFromInterface = function (logger, exception, properties, measurements) {
        var exceptions = exception[_DYN_EXCEPTIONS /* @min:%2eexceptions */]
            && arrMap(exception[_DYN_EXCEPTIONS /* @min:%2eexceptions */], function (ex) { return _ExceptionDetails[_DYN__CREATE_FROM_INTERFA1 /* @min:%2eCreateFromInterface */](logger, ex); });
        var exceptionData = new Exception(logger, __assignFn(__assignFn({}, exception), { exceptions: exceptions }), properties, measurements);
        return exceptionData;
    };
    Exception.prototype.toInterface = function () {
        var _a;
        var _b = this, exceptions = _b.exceptions, properties = _b.properties, measurements = _b.measurements, severityLevel = _b.severityLevel, problemGroup = _b.problemGroup, id = _b.id, isManual = _b.isManual;
        var exceptionDetailsInterface = exceptions instanceof Array
            && arrMap(exceptions, function (exception) { return exception.toInterface(); })
            || undefined;
        return _a = {
                ver: "4.0"
            },
            _a[_DYN_EXCEPTIONS /* @min:exceptions */] = exceptionDetailsInterface,
            _a.severityLevel = severityLevel,
            _a.properties = properties,
            _a.measurements = measurements,
            _a.problemGroup = problemGroup,
            _a.id = id,
            _a.isManual = isManual,
            _a;
    };
    /**
     * Creates a simple exception with 1 stack frame. Useful for manual constracting of exception.
     */
    Exception.CreateSimpleException = function (message, typeName, assembly, fileName, details, line) {
        var _a;
        return {
            exceptions: [
                (_a = {},
                    _a[_DYN_HAS_FULL_STACK /* @min:hasFullStack */] = true,
                    _a.message = message,
                    _a.stack = details,
                    _a.typeName = typeName,
                    _a)
            ]
        };
    };
    Exception.envelopeType = "Microsoft.ApplicationInsights.{0}.Exception";
    Exception.dataType = "ExceptionData";
    Exception.formatError = _formatErrorCode;
    return Exception;
}());
var _ExceptionDetails = /** @class */ (function () {
    function _ExceptionDetails(logger, exception, properties) {
        this.aiDataContract = {
            id: 0 /* FieldType.Default */,
            outerId: 0 /* FieldType.Default */,
            typeName: 1 /* FieldType.Required */,
            message: 1 /* FieldType.Required */,
            hasFullStack: 0 /* FieldType.Default */,
            stack: 0 /* FieldType.Default */,
            parsedStack: 2 /* FieldType.Array */
        };
        var _self = this;
        if (!_isExceptionDetailsInternal(exception)) {
            var error = exception;
            var evt = error && error.evt;
            if (!isError(error)) {
                error = error[strError] || evt || error;
            }
            _self[_DYN_TYPE_NAME /* @min:%2etypeName */] = dataSanitizeString(logger, _getErrorType(error)) || strNotSpecified;
            _self[_DYN_MESSAGE$1 /* @min:%2emessage */] = dataSanitizeMessage(logger, _formatMessage(exception || error, _self[_DYN_TYPE_NAME /* @min:%2etypeName */])) || strNotSpecified;
            var stack = exception[strStackDetails] || _getStackFromErrorObj(exception);
            _self[_DYN_PARSED_STACK /* @min:%2eparsedStack */] = _parseStack(stack);
            // after parsedStack is inited, iterate over each frame object, sanitize its assembly field
            if (isArray(_self[_DYN_PARSED_STACK /* @min:%2eparsedStack */])) {
                arrMap(_self[_DYN_PARSED_STACK /* @min:%2eparsedStack */], function (frame) {
                    frame[_DYN_ASSEMBLY /* @min:%2eassembly */] = dataSanitizeString(logger, frame[_DYN_ASSEMBLY /* @min:%2eassembly */]);
                    frame[_DYN_FILE_NAME /* @min:%2efileName */] = dataSanitizeString(logger, frame[_DYN_FILE_NAME /* @min:%2efileName */]);
                });
            }
            _self[strStack] = dataSanitizeException(logger, _formatStackTrace(stack));
            _self.hasFullStack = isArray(_self.parsedStack) && _self.parsedStack[_DYN_LENGTH$4 /* @min:%2elength */] > 0;
            if (properties) {
                properties[_DYN_TYPE_NAME /* @min:%2etypeName */] = properties[_DYN_TYPE_NAME /* @min:%2etypeName */] || _self[_DYN_TYPE_NAME /* @min:%2etypeName */];
            }
        }
        else {
            _self[_DYN_TYPE_NAME /* @min:%2etypeName */] = exception[_DYN_TYPE_NAME /* @min:%2etypeName */];
            _self[_DYN_MESSAGE$1 /* @min:%2emessage */] = exception[_DYN_MESSAGE$1 /* @min:%2emessage */];
            _self[strStack] = exception[strStack];
            _self[_DYN_PARSED_STACK /* @min:%2eparsedStack */] = exception[_DYN_PARSED_STACK /* @min:%2eparsedStack */] || [];
            _self[_DYN_HAS_FULL_STACK /* @min:%2ehasFullStack */] = exception[_DYN_HAS_FULL_STACK /* @min:%2ehasFullStack */];
        }
    }
    _ExceptionDetails.prototype.toInterface = function () {
        var _a;
        var _self = this;
        var parsedStack = _self[_DYN_PARSED_STACK /* @min:%2eparsedStack */] instanceof Array
            && arrMap(_self[_DYN_PARSED_STACK /* @min:%2eparsedStack */], function (frame) { return frame.toInterface(); });
        var exceptionDetailsInterface = (_a = {
                id: _self.id,
                outerId: _self.outerId,
                typeName: _self[_DYN_TYPE_NAME /* @min:%2etypeName */],
                message: _self[_DYN_MESSAGE$1 /* @min:%2emessage */],
                hasFullStack: _self[_DYN_HAS_FULL_STACK /* @min:%2ehasFullStack */],
                stack: _self[strStack]
            },
            _a[_DYN_PARSED_STACK /* @min:parsedStack */] = parsedStack || undefined,
            _a);
        return exceptionDetailsInterface;
    };
    _ExceptionDetails.CreateFromInterface = function (logger, exception) {
        var parsedStack = (exception[_DYN_PARSED_STACK /* @min:%2eparsedStack */] instanceof Array
            && arrMap(exception[_DYN_PARSED_STACK /* @min:%2eparsedStack */], function (frame) { return _StackFrame[_DYN__CREATE_FROM_INTERFA1 /* @min:%2eCreateFromInterface */](frame); }))
            || exception[_DYN_PARSED_STACK /* @min:%2eparsedStack */];
        var exceptionDetails = new _ExceptionDetails(logger, __assignFn(__assignFn({}, exception), { parsedStack: parsedStack }));
        return exceptionDetails;
    };
    return _ExceptionDetails;
}());
var _StackFrame = /** @class */ (function () {
    function _StackFrame(sourceFrame, level) {
        this.aiDataContract = {
            level: 1 /* FieldType.Required */,
            method: 1 /* FieldType.Required */,
            assembly: 0 /* FieldType.Default */,
            fileName: 0 /* FieldType.Default */,
            line: 0 /* FieldType.Default */
        };
        var _self = this;
        _self[_DYN_SIZE_IN_BYTES /* @min:%2esizeInBytes */] = 0;
        // Not converting this to isString() as typescript uses this logic to "understand" the different
        // types for the 2 different code paths
        if (typeof sourceFrame === "string") {
            var frame = sourceFrame;
            _self[_DYN_LEVEL /* @min:%2elevel */] = level;
            _self[_DYN_METHOD$1 /* @min:%2emethod */] = NoMethod;
            _self[_DYN_ASSEMBLY /* @min:%2eassembly */] = strTrim(frame);
            _self[_DYN_FILE_NAME /* @min:%2efileName */] = "";
            _self[_DYN_LINE /* @min:%2eline */] = 0;
            var matches = frame.match(_StackFrame.regex);
            if (matches && matches[_DYN_LENGTH$4 /* @min:%2elength */] >= 5) {
                _self[_DYN_METHOD$1 /* @min:%2emethod */] = strTrim(matches[2]) || _self[_DYN_METHOD$1 /* @min:%2emethod */];
                _self[_DYN_FILE_NAME /* @min:%2efileName */] = strTrim(matches[4]);
                _self[_DYN_LINE /* @min:%2eline */] = parseInt(matches[5]) || 0;
            }
        }
        else {
            _self[_DYN_LEVEL /* @min:%2elevel */] = sourceFrame[_DYN_LEVEL /* @min:%2elevel */];
            _self[_DYN_METHOD$1 /* @min:%2emethod */] = sourceFrame[_DYN_METHOD$1 /* @min:%2emethod */];
            _self[_DYN_ASSEMBLY /* @min:%2eassembly */] = sourceFrame[_DYN_ASSEMBLY /* @min:%2eassembly */];
            _self[_DYN_FILE_NAME /* @min:%2efileName */] = sourceFrame[_DYN_FILE_NAME /* @min:%2efileName */];
            _self[_DYN_LINE /* @min:%2eline */] = sourceFrame[_DYN_LINE /* @min:%2eline */];
            _self[_DYN_SIZE_IN_BYTES /* @min:%2esizeInBytes */] = 0;
        }
        _self.sizeInBytes += _self.method[_DYN_LENGTH$4 /* @min:%2elength */];
        _self.sizeInBytes += _self.fileName[_DYN_LENGTH$4 /* @min:%2elength */];
        _self.sizeInBytes += _self.assembly[_DYN_LENGTH$4 /* @min:%2elength */];
        // todo: these might need to be removed depending on how the back-end settles on their size calculation
        _self[_DYN_SIZE_IN_BYTES /* @min:%2esizeInBytes */] += _StackFrame.baseSize;
        _self.sizeInBytes += _self.level.toString()[_DYN_LENGTH$4 /* @min:%2elength */];
        _self.sizeInBytes += _self.line.toString()[_DYN_LENGTH$4 /* @min:%2elength */];
    }
    _StackFrame.CreateFromInterface = function (frame) {
        return new _StackFrame(frame, null /* level is available in frame interface */);
    };
    _StackFrame.prototype.toInterface = function () {
        var _self = this;
        return {
            level: _self[_DYN_LEVEL /* @min:%2elevel */],
            method: _self[_DYN_METHOD$1 /* @min:%2emethod */],
            assembly: _self[_DYN_ASSEMBLY /* @min:%2eassembly */],
            fileName: _self[_DYN_FILE_NAME /* @min:%2efileName */],
            line: _self[_DYN_LINE /* @min:%2eline */]
        };
    };
    // regex to match stack frames from ie/chrome/ff
    // methodName=$2, fileName=$4, lineNo=$5, column=$6
    _StackFrame.regex = /^([\s]+at)?[\s]{0,50}([^\@\()]+?)[\s]{0,50}(\@|\()([^\(\n]+):([0-9]+):([0-9]+)(\)?)$/;
    _StackFrame.baseSize = 58; // '{"method":"","level":,"assembly":"","fileName":"","line":}'.length
    return _StackFrame;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


var DataPoint = /** @class */ (function () {
    function DataPoint() {
        /**
         * The data contract for serializing this object.
         */
        this.aiDataContract = {
            name: 1 /* FieldType.Required */,
            kind: 0 /* FieldType.Default */,
            value: 1 /* FieldType.Required */,
            count: 0 /* FieldType.Default */,
            min: 0 /* FieldType.Default */,
            max: 0 /* FieldType.Default */,
            stdDev: 0 /* FieldType.Default */
        };
        /**
         * Metric type. Single measurement or the aggregated value.
         */
        this.kind = 0 /* DataPointType.Measurement */;
    }
    return DataPoint;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var Metric = /** @class */ (function () {
    /**
     * Constructs a new instance of the MetricTelemetry object
     */
    function Metric(logger, name, value, count, min, max, stdDev, properties, measurements) {
        this.aiDataContract = {
            ver: 1 /* FieldType.Required */,
            metrics: 1 /* FieldType.Required */,
            properties: 0 /* FieldType.Default */
        };
        var _self = this;
        _self.ver = 2;
        var dataPoint = new DataPoint();
        dataPoint[_DYN_COUNT$1 /* @min:%2ecount */] = count > 0 ? count : undefined;
        dataPoint.max = isNaN(max) || max === null ? undefined : max;
        dataPoint.min = isNaN(min) || min === null ? undefined : min;
        dataPoint[_DYN_NAME$2 /* @min:%2ename */] = dataSanitizeString(logger, name) || strNotSpecified;
        dataPoint.value = value;
        dataPoint.stdDev = isNaN(stdDev) || stdDev === null ? undefined : stdDev;
        _self.metrics = [dataPoint];
        _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = dataSanitizeProperties(logger, properties);
        _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = dataSanitizeMeasurements(logger, measurements);
    }
    Metric.envelopeType = "Microsoft.ApplicationInsights.{0}.Metric";
    Metric.dataType = "MetricData";
    return Metric;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var strEmpty = "";
/**
 * Convert ms to c# time span format
 */
function msToTimeSpan(totalms) {
    if (isNaN(totalms) || totalms < 0) {
        totalms = 0;
    }
    totalms = Math.round(totalms);
    var ms = strEmpty + totalms % 1000;
    var sec = strEmpty + Math.floor(totalms / 1000) % 60;
    var min = strEmpty + Math.floor(totalms / (1000 * 60)) % 60;
    var hour = strEmpty + Math.floor(totalms / (1000 * 60 * 60)) % 24;
    var days = Math.floor(totalms / (1000 * 60 * 60 * 24));
    ms = ms[_DYN_LENGTH$4 /* @min:%2elength */] === 1 ? "00" + ms : ms[_DYN_LENGTH$4 /* @min:%2elength */] === 2 ? "0" + ms : ms;
    sec = sec[_DYN_LENGTH$4 /* @min:%2elength */] < 2 ? "0" + sec : sec;
    min = min[_DYN_LENGTH$4 /* @min:%2elength */] < 2 ? "0" + min : min;
    hour = hour[_DYN_LENGTH$4 /* @min:%2elength */] < 2 ? "0" + hour : hour;
    return (days > 0 ? days + "." : strEmpty) + hour + ":" + min + ":" + sec + "." + ms;
}
function isCrossOriginError(message, url, lineNumber, columnNumber, error) {
    return !error && isString(message) && (message === "Script error." || message === "Script error");
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var PageView = /** @class */ (function () {
    /**
     * Constructs a new instance of the PageEventTelemetry object
     */
    function PageView(logger, name, url, durationMs, properties, measurements, id) {
        this.aiDataContract = {
            ver: 1 /* FieldType.Required */,
            name: 0 /* FieldType.Default */,
            url: 0 /* FieldType.Default */,
            duration: 0 /* FieldType.Default */,
            properties: 0 /* FieldType.Default */,
            measurements: 0 /* FieldType.Default */,
            id: 0 /* FieldType.Default */
        };
        var _self = this;
        _self.ver = 2;
        _self.id = dataSanitizeId(logger, id);
        _self.url = dataSanitizeUrl(logger, url);
        _self[_DYN_NAME$2 /* @min:%2ename */] = dataSanitizeString(logger, name) || strNotSpecified;
        if (!isNaN(durationMs)) {
            _self[_DYN_DURATION$1 /* @min:%2eduration */] = msToTimeSpan(durationMs);
        }
        _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = dataSanitizeProperties(logger, properties);
        _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = dataSanitizeMeasurements(logger, measurements);
    }
    PageView.envelopeType = "Microsoft.ApplicationInsights.{0}.Pageview";
    PageView.dataType = "PageviewData";
    return PageView;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var RemoteDependencyData = /** @class */ (function () {
    /**
     * Constructs a new instance of the RemoteDependencyData object
     */
    function RemoteDependencyData(logger, id, absoluteUrl, commandName, value, success, resultCode, method, requestAPI, correlationContext, properties, measurements) {
        if (requestAPI === void 0) { requestAPI = "Ajax"; }
        this.aiDataContract = {
            id: 1 /* FieldType.Required */,
            ver: 1 /* FieldType.Required */,
            name: 0 /* FieldType.Default */,
            resultCode: 0 /* FieldType.Default */,
            duration: 0 /* FieldType.Default */,
            success: 0 /* FieldType.Default */,
            data: 0 /* FieldType.Default */,
            target: 0 /* FieldType.Default */,
            type: 0 /* FieldType.Default */,
            properties: 0 /* FieldType.Default */,
            measurements: 0 /* FieldType.Default */,
            kind: 0 /* FieldType.Default */,
            value: 0 /* FieldType.Default */,
            count: 0 /* FieldType.Default */,
            min: 0 /* FieldType.Default */,
            max: 0 /* FieldType.Default */,
            stdDev: 0 /* FieldType.Default */,
            dependencyKind: 0 /* FieldType.Default */,
            dependencySource: 0 /* FieldType.Default */,
            commandName: 0 /* FieldType.Default */,
            dependencyTypeName: 0 /* FieldType.Default */
        };
        var _self = this;
        _self.ver = 2;
        _self.id = id;
        _self[_DYN_DURATION$1 /* @min:%2eduration */] = msToTimeSpan(value);
        _self.success = success;
        _self.resultCode = resultCode + "";
        _self.type = dataSanitizeString(logger, requestAPI);
        var dependencyFields = AjaxHelperParseDependencyPath(logger, absoluteUrl, method, commandName);
        _self.data = dataSanitizeUrl(logger, commandName) || dependencyFields.data; // get a value from hosturl if commandName not available
        _self.target = dataSanitizeString(logger, dependencyFields.target);
        if (correlationContext) {
            _self.target = "".concat(_self.target, " | ").concat(correlationContext);
        }
        _self[_DYN_NAME$2 /* @min:%2ename */] = dataSanitizeString(logger, dependencyFields[_DYN_NAME$2 /* @min:%2ename */]);
        _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = dataSanitizeProperties(logger, properties);
        _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = dataSanitizeMeasurements(logger, measurements);
    }
    RemoteDependencyData.envelopeType = "Microsoft.ApplicationInsights.{0}.RemoteDependency";
    RemoteDependencyData.dataType = "RemoteDependencyData";
    return RemoteDependencyData;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var Trace = /** @class */ (function () {
    /**
     * Constructs a new instance of the TraceTelemetry object
     */
    function Trace(logger, message, severityLevel, properties, measurements) {
        this.aiDataContract = {
            ver: 1 /* FieldType.Required */,
            message: 1 /* FieldType.Required */,
            severityLevel: 0 /* FieldType.Default */,
            properties: 0 /* FieldType.Default */
        };
        var _self = this;
        _self.ver = 2;
        message = message || strNotSpecified;
        _self[_DYN_MESSAGE$1 /* @min:%2emessage */] = dataSanitizeMessage(logger, message);
        _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = dataSanitizeProperties(logger, properties);
        _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = dataSanitizeMeasurements(logger, measurements);
        if (severityLevel) {
            _self[_DYN_SEVERITY_LEVEL /* @min:%2eseverityLevel */] = severityLevel;
        }
    }
    Trace.envelopeType = "Microsoft.ApplicationInsights.{0}.Message";
    Trace.dataType = "MessageData";
    return Trace;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var PageViewPerformance = /** @class */ (function () {
    /**
     * Constructs a new instance of the PageEventTelemetry object
     */
    function PageViewPerformance(logger, name, url, unused, properties, measurements, cs4BaseData) {
        this.aiDataContract = {
            ver: 1 /* FieldType.Required */,
            name: 0 /* FieldType.Default */,
            url: 0 /* FieldType.Default */,
            duration: 0 /* FieldType.Default */,
            perfTotal: 0 /* FieldType.Default */,
            networkConnect: 0 /* FieldType.Default */,
            sentRequest: 0 /* FieldType.Default */,
            receivedResponse: 0 /* FieldType.Default */,
            domProcessing: 0 /* FieldType.Default */,
            properties: 0 /* FieldType.Default */,
            measurements: 0 /* FieldType.Default */
        };
        var _self = this;
        _self.ver = 2;
        _self.url = dataSanitizeUrl(logger, url);
        _self[_DYN_NAME$2 /* @min:%2ename */] = dataSanitizeString(logger, name) || strNotSpecified;
        _self[_DYN_PROPERTIES$1 /* @min:%2eproperties */] = dataSanitizeProperties(logger, properties);
        _self[_DYN_MEASUREMENTS$1 /* @min:%2emeasurements */] = dataSanitizeMeasurements(logger, measurements);
        if (cs4BaseData) {
            _self.domProcessing = cs4BaseData.domProcessing;
            _self[_DYN_DURATION$1 /* @min:%2eduration */] = cs4BaseData[_DYN_DURATION$1 /* @min:%2eduration */];
            _self.networkConnect = cs4BaseData.networkConnect;
            _self.perfTotal = cs4BaseData.perfTotal;
            _self[_DYN_RECEIVED_RESPONSE /* @min:%2ereceivedResponse */] = cs4BaseData[_DYN_RECEIVED_RESPONSE /* @min:%2ereceivedResponse */];
            _self.sentRequest = cs4BaseData.sentRequest;
        }
    }
    PageViewPerformance.envelopeType = "Microsoft.ApplicationInsights.{0}.PageviewPerformance";
    PageViewPerformance.dataType = "PageviewPerformanceData";
    return PageViewPerformance;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


var Data = /** @class */ (function () {
    /**
     * Constructs a new instance of telemetry data.
     */
    function Data(baseType, data) {
        /**
         * The data contract for serializing this object.
         */
        this.aiDataContract = {
            baseType: 1 /* FieldType.Required */,
            baseData: 1 /* FieldType.Required */
        };
        this.baseType = baseType;
        this.baseData = data;
    }
    return Data;
}());

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

function _aiNameFunc(baseName) {
    var aiName = "ai." + baseName + ".";
    return function (name) {
        return aiName + name;
    };
}
var _aiApplication = _aiNameFunc("application");
var _aiDevice = _aiNameFunc("device");
var _aiLocation = _aiNameFunc("location");
var _aiOperation = _aiNameFunc("operation");
var _aiSession = _aiNameFunc("session");
var _aiUser = _aiNameFunc("user");
var _aiCloud = _aiNameFunc("cloud");
var _aiInternal = _aiNameFunc("internal");
var ContextTagKeys = /** @class */ (function (_super) {
    __extendsFn(ContextTagKeys, _super);
    function ContextTagKeys() {
        return _super.call(this) || this;
    }
    return ContextTagKeys;
}(createClassFromInterface({
    applicationVersion: _aiApplication("ver"),
    applicationBuild: _aiApplication("build"),
    applicationTypeId: _aiApplication("typeId"),
    applicationId: _aiApplication("applicationId"),
    applicationLayer: _aiApplication("layer"),
    deviceId: _aiDevice("id"),
    deviceIp: _aiDevice("ip"),
    deviceLanguage: _aiDevice("language"),
    deviceLocale: _aiDevice("locale"),
    deviceModel: _aiDevice("model"),
    deviceFriendlyName: _aiDevice("friendlyName"),
    deviceNetwork: _aiDevice("network"),
    deviceNetworkName: _aiDevice("networkName"),
    deviceOEMName: _aiDevice("oemName"),
    deviceOS: _aiDevice("os"),
    deviceOSVersion: _aiDevice("osVersion"),
    deviceRoleInstance: _aiDevice("roleInstance"),
    deviceRoleName: _aiDevice("roleName"),
    deviceScreenResolution: _aiDevice("screenResolution"),
    deviceType: _aiDevice("type"),
    deviceMachineName: _aiDevice("machineName"),
    deviceVMName: _aiDevice("vmName"),
    deviceBrowser: _aiDevice("browser"),
    deviceBrowserVersion: _aiDevice("browserVersion"),
    locationIp: _aiLocation("ip"),
    locationCountry: _aiLocation("country"),
    locationProvince: _aiLocation("province"),
    locationCity: _aiLocation("city"),
    operationId: _aiOperation("id"),
    operationName: _aiOperation("name"),
    operationParentId: _aiOperation("parentId"),
    operationRootId: _aiOperation("rootId"),
    operationSyntheticSource: _aiOperation("syntheticSource"),
    operationCorrelationVector: _aiOperation("correlationVector"),
    sessionId: _aiSession("id"),
    sessionIsFirst: _aiSession("isFirst"),
    sessionIsNew: _aiSession("isNew"),
    userAccountAcquisitionDate: _aiUser("accountAcquisitionDate"),
    userAccountId: _aiUser("accountId"),
    userAgent: _aiUser("userAgent"),
    userId: _aiUser("id"),
    userStoreRegion: _aiUser("storeRegion"),
    userAuthUserId: _aiUser("authUserId"),
    userAnonymousUserAcquisitionDate: _aiUser("anonUserAcquisitionDate"),
    userAuthenticatedUserAcquisitionDate: _aiUser("authUserAcquisitionDate"),
    cloudName: _aiCloud("name"),
    cloudRole: _aiCloud("role"),
    cloudRoleVer: _aiCloud("roleVer"),
    cloudRoleInstance: _aiCloud("roleInstance"),
    cloudEnvironment: _aiCloud("environment"),
    cloudLocation: _aiCloud("location"),
    cloudDeploymentUnit: _aiCloud("deploymentUnit"),
    internalNodeName: _aiInternal("nodeName"),
    internalSdkVersion: _aiInternal("sdkVersion"),
    internalAgentVersion: _aiInternal("agentVersion"),
    internalSnippet: _aiInternal("snippet"),
    internalSdkSrc: _aiInternal("sdkSrc")
})));

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Create a telemetry item that the 1DS channel understands
 * @param item - domain specific properties; part B
 * @param baseType - telemetry item type. ie PageViewData
 * @param envelopeName - name of the envelope. ie Microsoft.ApplicationInsights.<instrumentation key>.PageView
 * @param customProperties - user defined custom properties; part C
 * @param systemProperties - system properties that are added to the context; part A
 * @returns ITelemetryItem that is sent to channel
 */
function createTelemetryItem(item, baseType, envelopeName, logger, customProperties, systemProperties) {
    var _a;
    envelopeName = dataSanitizeString(logger, envelopeName) || strNotSpecified;
    if (isNullOrUndefined(item) ||
        isNullOrUndefined(baseType) ||
        isNullOrUndefined(envelopeName)) {
        throwError("Input doesn't contain all required fields");
    }
    var iKey = "";
    if (item[strIkey]) {
        iKey = item[strIkey];
        delete item[strIkey];
    }
    var telemetryItem = (_a = {},
        _a[_DYN_NAME$2 /* @min:name */] = envelopeName,
        _a.time = toISOString(new Date()),
        _a.iKey = iKey,
        _a.ext = systemProperties ? systemProperties : {},
        _a.tags = [],
        _a.data = {},
        _a.baseType = baseType,
        _a.baseData = item // Part B
    ,
        _a);
    // Part C
    if (!isNullOrUndefined(customProperties)) {
        objForEachKey(customProperties, function (prop, value) {
            telemetryItem.data[prop] = value;
        });
    }
    return telemetryItem;
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var Extensions = {
    UserExt: "user",
    DeviceExt: "device",
    TraceExt: "trace",
    WebExt: "web",
    AppExt: "app",
    OSExt: "os",
    SessionExt: "ses",
    SDKExt: "sdk"
};
var CtxTagKeys = new ContextTagKeys();

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

function createDomEvent(eventName) {
    var event = null;
    if (isFunction(Event)) { // Use Event constructor when available
        event = new Event(eventName);
    }
    else { // Event has no constructor in IE
        var doc = getDocument();
        if (doc && doc.createEvent) {
            event = doc.createEvent("Event");
            event.initEvent(eventName, true, true);
        }
    }
    return event;
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
function _disableEvents(target, evtNamespace) {
    eventOff(target, null, null, evtNamespace);
}
/**
 * Create a new OfflineListener instance to monitor browser online / offline events
 * @param parentEvtNamespace - The parent event namespace to append to any specific events for this instance
 */
function createOfflineListener(parentEvtNamespace) {
    var _document = getDocument();
    var _navigator = getNavigator(); // Gets the window.navigator or workerNavigator depending on the global
    var _isListening = false;
    var listenerList = [];
    // Set the initial state
    // rState is changed by the browser, both via events and when we check the navigator.onLine property
    var rState = 1 /* eOfflineValue.Online */;
    if (_navigator && !isNullOrUndefined(_navigator.onLine) && !_navigator.onLine) { // navigator.onLine is undefined in react-native
        rState = 2 /* eOfflineValue.Offline */;
    }
    // ustate is changed by the user calling setOnlineState
    var uState = 0 /* eOfflineValue.Unknown */;
    // current state would be updated each time rState or uState is changed
    // it is a resolved value of rState and uState
    var _currentState = calCurrentState();
    var _evtNamespace = mergeEvtNamespace(createUniqueNamespace("OfflineListener"), parentEvtNamespace);
    try {
        if (_enableEvents(getWindow())) {
            _isListening = true;
        }
        if (_document) {
            // Also attach to the document.body or document
            var target = _document.body || _document;
            if (target.ononline) {
                if (_enableEvents(target)) {
                    _isListening = true;
                }
            }
        }
    }
    catch (e) {
        // this makes react-native less angry
        _isListening = false;
    }
    function _enableEvents(target) {
        var enabled = false;
        if (target) {
            enabled = eventOn(target, "online", _setOnline, _evtNamespace);
            if (enabled) {
                eventOn(target, "offline", _setOffline, _evtNamespace);
            }
        }
        return enabled;
    }
    function _isOnline() {
        return _currentState;
    }
    function calCurrentState() {
        if (uState === 2 /* eOfflineValue.Offline */ || rState === 2 /* eOfflineValue.Offline */) {
            return false;
        }
        return true; // if both unknown, then we assume the network is good
    }
    function listnerNoticeCheck() {
        // we were offline and are now online or we were online and now offline
        var newState = calCurrentState();
        if (_currentState !== newState) {
            _currentState = newState; // use the resolved state to update
            // send all the callbacks with the current state
            arrForEach(listenerList, function (callback) {
                var offlineState = {
                    isOnline: _currentState,
                    rState: rState,
                    uState: uState
                };
                try {
                    callback(offlineState);
                }
                catch (e) {
                    // Do nothing, just making sure we run all of the callbacks
                }
            });
        }
    }
    function setOnlineState(newState) {
        uState = newState;
        listnerNoticeCheck();
    }
    function _setOnline() {
        rState = 1 /* eOfflineValue.Online */;
        listnerNoticeCheck();
    }
    function _setOffline() {
        rState = 2 /* eOfflineValue.Offline */;
        listnerNoticeCheck();
    }
    function _unload() {
        var win = getWindow();
        if (win && _isListening) {
            _disableEvents(win, _evtNamespace);
            if (_document) {
                // Also attach to the document.body or document
                var target = _document.body || _document;
                if (!isUndefined(target.ononline)) {
                    _disableEvents(target, _evtNamespace);
                }
            }
            _isListening = false;
        }
    }
    function addListener(callback) {
        listenerList[_DYN_PUSH$1 /* @min:%2epush */](callback);
        // Define rm as an instance of IUnloadHook
        return {
            rm: function () {
                var index = listenerList.indexOf(callback);
                if (index > -1) {
                    return listenerList.splice(index, 1);
                }
                else {
                    return;
                }
            }
        };
    }
    return {
        isOnline: _isOnline,
        isListening: function () { return _isListening; },
        unload: _unload,
        addListener: addListener,
        setOnlineState: setOnlineState
    };
}

/*
 * Application Insights JavaScript SDK - Common, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var PropertiesPluginIdentifier = "AppInsightsPropertiesPlugin";
var BreezeChannelIdentifier = "AppInsightsChannelPlugin";
var AnalyticsPluginIdentifier = "ApplicationInsightsAnalytics";

/*
 * Application Insights JavaScript SDK - Web Analytics, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_TO_STRING$1 = "toString"; // Count: 4
var _DYN_IS_STORAGE_USE_DISAB0 = "isStorageUseDisabled"; // Count: 3
var _DYN__ADD_HOOK$1 = "_addHook"; // Count: 6
var _DYN_CORE$1 = "core"; // Count: 7
var _DYN_DATA_TYPE$1 = "dataType"; // Count: 8
var _DYN_ENVELOPE_TYPE$1 = "envelopeType"; // Count: 7
var _DYN_DIAG_LOG$1 = "diagLog"; // Count: 13
var _DYN_TRACK = "track"; // Count: 7
var _DYN_TRACK_PAGE_VIEW = "trackPageView"; // Count: 4
var _DYN_TRACK_PREVIOUS_PAGE_1 = "trackPreviousPageVisit"; // Count: 3
var _DYN_SEND_PAGE_VIEW_INTER2 = "sendPageViewInternal"; // Count: 7
var _DYN_START_TIME$1 = "startTime"; // Count: 6
var _DYN_PROPERTIES = "properties"; // Count: 3
var _DYN_DURATION = "duration"; // Count: 12
var _DYN_SEND_PAGE_VIEW_PERFO3 = "sendPageViewPerformanceInternal"; // Count: 3
var _DYN_POPULATE_PAGE_VIEW_P4 = "populatePageViewPerformanceEvent"; // Count: 3
var _DYN_HREF = "href"; // Count: 6
var _DYN_SEND_EXCEPTION_INTER5 = "sendExceptionInternal"; // Count: 2
var _DYN_EXCEPTION$1 = "exception"; // Count: 3
var _DYN_ERROR = "error"; // Count: 5
var _DYN__ONERROR = "_onerror"; // Count: 3
var _DYN_ERROR_SRC = "errorSrc"; // Count: 3
var _DYN_LINE_NUMBER = "lineNumber"; // Count: 5
var _DYN_COLUMN_NUMBER = "columnNumber"; // Count: 5
var _DYN_MESSAGE = "message"; // Count: 4
var _DYN__CREATE_AUTO_EXCEPTI6 = "CreateAutoException"; // Count: 3
var _DYN_ADD_TELEMETRY_INITIA7 = "addTelemetryInitializer"; // Count: 4
var _DYN_OVERRIDE_PAGE_VIEW_D8 = "overridePageViewDuration"; // Count: 2
var _DYN_AUTO_TRACK_PAGE_VISI9 = "autoTrackPageVisitTime"; // Count: 2
var _DYN_IS_BROWSER_LINK_TRAC10 = "isBrowserLinkTrackingEnabled"; // Count: 2
var _DYN_LENGTH$3 = "length"; // Count: 5
var _DYN_ENABLE_AUTO_ROUTE_TR11 = "enableAutoRouteTracking"; // Count: 2
var _DYN_ENABLE_UNHANDLED_PRO12 = "enableUnhandledPromiseRejectionTracking"; // Count: 2
var _DYN_AUTO_UNHANDLED_PROMI13 = "autoUnhandledPromiseInstrumented"; // Count: 3
var _DYN_GET_ENTRIES_BY_TYPE = "getEntriesByType"; // Count: 5
var _DYN_IS_PERFORMANCE_TIMIN14 = "isPerformanceTimingSupported"; // Count: 2
var _DYN_GET_PERFORMANCE_TIMI15 = "getPerformanceTiming"; // Count: 2
var _DYN_NAVIGATION_START = "navigationStart"; // Count: 4
var _DYN_SHOULD_COLLECT_DURAT16 = "shouldCollectDuration"; // Count: 3
var _DYN_IS_PERFORMANCE_TIMIN17 = "isPerformanceTimingDataReady"; // Count: 2
var _DYN_RESPONSE_START = "responseStart"; // Count: 5
var _DYN_REQUEST_START = "requestStart"; // Count: 3
var _DYN_LOAD_EVENT_END = "loadEventEnd"; // Count: 4
var _DYN_RESPONSE_END = "responseEnd"; // Count: 5
var _DYN_CONNECT_END = "connectEnd"; // Count: 4
var _DYN_PAGE_VISIT_START_TIM18 = "pageVisitStartTime"; // Count: 2

/*
 * Application Insights JavaScript SDK - Web Analytics, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Class encapsulates sending page views and page view performance telemetry.
 */
var PageViewManager = /** @class */ (function () {
    function PageViewManager(appInsights, overridePageViewDuration, core, pageViewPerformanceManager) {
        dynamicProto(PageViewManager, this, function (_self) {
            var queueTimer = null;
            var itemQueue = [];
            var pageViewPerformanceSent = false;
            var firstPageViewSent = false;
            var _logger;
            if (core) {
                _logger = core.logger;
            }
            function _flushChannels(isAsync) {
                if (core) {
                    core.flush(isAsync, function () {
                        // Event flushed, callback added to prevent promise creation
                    });
                }
            }
            function _startTimer() {
                if (!queueTimer) {
                    queueTimer = scheduleTimeout((function () {
                        queueTimer = null;
                        var allItems = itemQueue.slice(0);
                        var doFlush = false;
                        itemQueue = [];
                        arrForEach(allItems, function (item) {
                            if (!item()) {
                                // Not processed so rescheduled
                                itemQueue.push(item);
                            }
                            else {
                                doFlush = true;
                            }
                        });
                        if (itemQueue[_DYN_LENGTH$3 /* @min:%2elength */] > 0) {
                            _startTimer();
                        }
                        if (doFlush) {
                            // We process at least one item so flush the queue
                            _flushChannels(true);
                        }
                    }), 100);
                }
            }
            function _addQueue(cb) {
                itemQueue.push(cb);
                _startTimer();
            }
            _self[_DYN_TRACK_PAGE_VIEW /* @min:%2etrackPageView */] = function (pageView, customProperties) {
                var name = pageView.name;
                if (isNullOrUndefined(name) || typeof name !== "string") {
                    var doc = getDocument();
                    name = pageView.name = doc && doc.title || "";
                }
                var uri = pageView.uri;
                if (isNullOrUndefined(uri) || typeof uri !== "string") {
                    var location_1 = getLocation();
                    uri = pageView.uri = location_1 && location_1[_DYN_HREF /* @min:%2ehref */] || "";
                }
                if (!firstPageViewSent) {
                    var perf = getPerformance();
                    // Access the performance timing object
                    var navigationEntries = (perf && perf[_DYN_GET_ENTRIES_BY_TYPE /* @min:%2egetEntriesByType */] && perf[_DYN_GET_ENTRIES_BY_TYPE /* @min:%2egetEntriesByType */]("navigation"));
                    // Edge Case the navigation Entries may return an empty array and the timeOrigin is not supported on IE
                    if (navigationEntries && navigationEntries[0] && !isUndefined(perf.timeOrigin)) {
                        // Get the value of loadEventStart
                        var loadEventStart = navigationEntries[0].loadEventStart;
                        pageView[_DYN_START_TIME$1 /* @min:%2estartTime */] = new Date(perf.timeOrigin + loadEventStart);
                    }
                    else {
                        // calculate the start time manually
                        var duration_1 = ((customProperties || pageView[_DYN_PROPERTIES /* @min:%2eproperties */] || {})[_DYN_DURATION /* @min:%2eduration */] || 0);
                        pageView[_DYN_START_TIME$1 /* @min:%2estartTime */] = new Date(new Date().getTime() - duration_1);
                    }
                    firstPageViewSent = true;
                }
                // case 1a. if performance timing is not supported by the browser, send the page view telemetry with the duration provided by the user. If the user
                // do not provide the duration, set duration to undefined
                // Also this is case 4
                if (!pageViewPerformanceManager[_DYN_IS_PERFORMANCE_TIMIN14 /* @min:%2eisPerformanceTimingSupported */]()) {
                    appInsights[_DYN_SEND_PAGE_VIEW_INTER2 /* @min:%2esendPageViewInternal */](pageView, customProperties);
                    _flushChannels(true);
                    if (!isWebWorker()) {
                        // no navigation timing (IE 8, iOS Safari 8.4, Opera Mini 8 - see http://caniuse.com/#feat=nav-timing)
                        _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 25 /* _eInternalMessageId.NavigationTimingNotSupported */, "trackPageView: navigation timing API used for calculation of page duration is not supported in this browser. This page view will be collected without duration and timing info.");
                    }
                    return;
                }
                var pageViewSent = false;
                var customDuration;
                // if the performance timing is supported by the browser, calculate the custom duration
                var start = pageViewPerformanceManager[_DYN_GET_PERFORMANCE_TIMI15 /* @min:%2egetPerformanceTiming */]()[_DYN_NAVIGATION_START /* @min:%2enavigationStart */];
                if (start > 0) {
                    customDuration = dateTimeUtilsDuration(start, +new Date);
                    if (!pageViewPerformanceManager[_DYN_SHOULD_COLLECT_DURAT16 /* @min:%2eshouldCollectDuration */](customDuration)) {
                        customDuration = undefined;
                    }
                }
                // if the user has provided duration, send a page view telemetry with the provided duration. Otherwise, if
                // overridePageViewDuration is set to true, send a page view telemetry with the custom duration calculated earlier
                var duration;
                if (!isNullOrUndefined(customProperties) &&
                    !isNullOrUndefined(customProperties[_DYN_DURATION /* @min:%2eduration */])) {
                    duration = customProperties[_DYN_DURATION /* @min:%2eduration */];
                }
                if (overridePageViewDuration || !isNaN(duration)) {
                    if (isNaN(duration)) {
                        // case 3
                        if (!customProperties) {
                            customProperties = {};
                        }
                        customProperties[_DYN_DURATION /* @min:%2eduration */] = customDuration;
                    }
                    // case 2
                    appInsights[_DYN_SEND_PAGE_VIEW_INTER2 /* @min:%2esendPageViewInternal */](pageView, customProperties);
                    _flushChannels(true);
                    pageViewSent = true;
                }
                // now try to send the page view performance telemetry
                var maxDurationLimit = 60000;
                if (!customProperties) {
                    customProperties = {};
                }
                // Queue the event for processing
                _addQueue(function () {
                    var processed = false;
                    try {
                        if (pageViewPerformanceManager[_DYN_IS_PERFORMANCE_TIMIN17 /* @min:%2eisPerformanceTimingDataReady */]()) {
                            processed = true;
                            var pageViewPerformance = {
                                name: name,
                                uri: uri
                            };
                            pageViewPerformanceManager[_DYN_POPULATE_PAGE_VIEW_P4 /* @min:%2epopulatePageViewPerformanceEvent */](pageViewPerformance);
                            if (!pageViewPerformance.isValid && !pageViewSent) {
                                // If navigation timing gives invalid numbers, then go back to "override page view duration" mode.
                                // That's the best value we can get that makes sense.
                                customProperties[_DYN_DURATION /* @min:%2eduration */] = customDuration;
                                appInsights[_DYN_SEND_PAGE_VIEW_INTER2 /* @min:%2esendPageViewInternal */](pageView, customProperties);
                            }
                            else {
                                if (!pageViewSent) {
                                    customProperties[_DYN_DURATION /* @min:%2eduration */] = pageViewPerformance.durationMs;
                                    appInsights[_DYN_SEND_PAGE_VIEW_INTER2 /* @min:%2esendPageViewInternal */](pageView, customProperties);
                                }
                                if (!pageViewPerformanceSent) {
                                    appInsights[_DYN_SEND_PAGE_VIEW_PERFO3 /* @min:%2esendPageViewPerformanceInternal */](pageViewPerformance, customProperties);
                                    pageViewPerformanceSent = true;
                                }
                            }
                        }
                        else if (start > 0 && dateTimeUtilsDuration(start, +new Date) > maxDurationLimit) {
                            // if performance timings are not ready but we exceeded the maximum duration limit, just log a page view telemetry
                            // with the maximum duration limit. Otherwise, keep waiting until performance timings are ready
                            processed = true;
                            if (!pageViewSent) {
                                customProperties[_DYN_DURATION /* @min:%2eduration */] = maxDurationLimit;
                                appInsights[_DYN_SEND_PAGE_VIEW_INTER2 /* @min:%2esendPageViewInternal */](pageView, customProperties);
                            }
                        }
                    }
                    catch (e) {
                        _throwInternal(_logger, 1 /* eLoggingSeverity.CRITICAL */, 38 /* _eInternalMessageId.TrackPVFailedCalc */, "trackPageView failed on page load calculation: " + getExceptionName(e), { exception: dumpObj(e) });
                    }
                    return processed;
                });
            };
            _self.teardown = function (unloadCtx, unloadState) {
                if (queueTimer) {
                    queueTimer.cancel();
                    queueTimer = null;
                    var allItems = itemQueue.slice(0);
                    itemQueue = [];
                    arrForEach(allItems, function (item) {
                        if (item()) ;
                    });
                }
            };
        });
    }
// Removed Stub for PageViewManager.prototype.trackPageView.
// Removed Stub for PageViewManager.prototype.teardown.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    PageViewManager.__ieDyn=1;

    return PageViewManager;
}());

/*
 * Application Insights JavaScript SDK - Web Analytics, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var MAX_DURATION_ALLOWED = 3600000; // 1h
var botAgentNames = ["googlebot", "adsbot-google", "apis-google", "mediapartners-google"];
function _isPerformanceTimingSupported() {
    var perf = getPerformance();
    return perf && !!perf.timing;
}
function _isPerformanceNavigationTimingSupported() {
    var perf = getPerformance();
    return perf && perf.getEntriesByType && perf.getEntriesByType("navigation")[_DYN_LENGTH$3 /* @min:%2elength */] > 0;
}
function _isPerformanceTimingDataReady() {
    var perf = getPerformance();
    var timing = perf ? perf.timing : 0;
    return timing
        && timing.domainLookupStart > 0
        && timing[_DYN_NAVIGATION_START /* @min:%2enavigationStart */] > 0
        && timing[_DYN_RESPONSE_START /* @min:%2eresponseStart */] > 0
        && timing[_DYN_REQUEST_START /* @min:%2erequestStart */] > 0
        && timing[_DYN_LOAD_EVENT_END /* @min:%2eloadEventEnd */] > 0
        && timing[_DYN_RESPONSE_END /* @min:%2eresponseEnd */] > 0
        && timing[_DYN_CONNECT_END /* @min:%2econnectEnd */] > 0
        && timing.domLoading > 0;
}
function _getPerformanceTiming() {
    if (_isPerformanceTimingSupported()) {
        return getPerformance().timing;
    }
    return null;
}
function _getPerformanceNavigationTiming() {
    if (_isPerformanceNavigationTimingSupported()) {
        return getPerformance()[_DYN_GET_ENTRIES_BY_TYPE /* @min:%2egetEntriesByType */]("navigation")[0];
    }
    return null;
}
/**
* This method tells if given durations should be excluded from collection.
*/
function _shouldCollectDuration() {
    var durations = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        durations[_i] = arguments[_i];
    }
    var _navigator = getNavigator() || {};
    // a full list of Google crawlers user agent strings - https://support.google.com/webmasters/answer/1061943?hl=en
    var userAgent = _navigator.userAgent;
    var isGoogleBot = false;
    if (userAgent) {
        for (var i = 0; i < botAgentNames[_DYN_LENGTH$3 /* @min:%2elength */]; i++) {
            isGoogleBot = isGoogleBot || strIndexOf(userAgent.toLowerCase(), botAgentNames[i]) !== -1;
        }
    }
    if (isGoogleBot) {
        // Don't report durations for GoogleBot, it is returning invalid values in performance.timing API.
        return false;
    }
    else {
        // for other page views, don't report if it's outside of a reasonable range
        for (var i = 0; i < durations[_DYN_LENGTH$3 /* @min:%2elength */]; i++) {
            if (durations[i] < 0 || durations[i] >= MAX_DURATION_ALLOWED) {
                return false;
            }
        }
    }
    return true;
}
/**
 * Class encapsulates sending page view performance telemetry.
 */
var PageViewPerformanceManager = /** @class */ (function () {
    function PageViewPerformanceManager(core) {
        var _logger = safeGetLogger(core);
        dynamicProto(PageViewPerformanceManager, this, function (_self) {
            _self[_DYN_POPULATE_PAGE_VIEW_P4 /* @min:%2epopulatePageViewPerformanceEvent */] = function (pageViewPerformance) {
                pageViewPerformance.isValid = false;
                /*
                 * http://www.w3.org/TR/navigation-timing/#processing-model
                 *  |-navigationStart
                 *  |             |-connectEnd
                 *  |             ||-requestStart
                 *  |             ||             |-responseStart
                 *  |             ||             |              |-responseEnd
                 *  |             ||             |              |
                 *  |             ||             |              |         |-loadEventEnd
                 *  |---network---||---request---|---response---|---dom---|
                 *  |--------------------------total----------------------|
                 *
                 *  total = The difference between the load event of the current document is completed and the first recorded timestamp of the performance entry : https://developer.mozilla.org/en-US/docs/Web/Performance/Navigation_and_resource_timings#duration
                 *  network = Redirect time + App Cache + DNS lookup time + TCP connection time
                 *  request = Request time : https://developer.mozilla.org/en-US/docs/Web/Performance/Navigation_and_resource_timings#request_time
                 *  response = Response time
                 *  dom = Document load time : https://html.spec.whatwg.org/multipage/dom.html#document-load-timing-info
                 *      = Document processing time : https://developers.google.com/web/fundamentals/performance/navigation-and-resource-timing/#document_processing
                 *      + Loading time : https://developers.google.com/web/fundamentals/performance/navigation-and-resource-timing/#loading
                 */
                var navigationTiming = _getPerformanceNavigationTiming();
                var timing = _getPerformanceTiming();
                var total = 0;
                var network = 0;
                var request = 0;
                var response = 0;
                var dom = 0;
                if (navigationTiming || timing) {
                    if (navigationTiming) {
                        total = navigationTiming[_DYN_DURATION /* @min:%2eduration */];
                        /**
                         * support both cases:
                         * - startTime is always zero: https://developer.mozilla.org/en-US/docs/Web/API/PerformanceNavigationTiming
                         * - for older browsers where the startTime is not zero
                         */
                        network = navigationTiming[_DYN_START_TIME$1 /* @min:%2estartTime */] === 0 ? navigationTiming[_DYN_CONNECT_END /* @min:%2econnectEnd */] : dateTimeUtilsDuration(navigationTiming[_DYN_START_TIME$1 /* @min:%2estartTime */], navigationTiming[_DYN_CONNECT_END /* @min:%2econnectEnd */]);
                        request = dateTimeUtilsDuration(navigationTiming.requestStart, navigationTiming[_DYN_RESPONSE_START /* @min:%2eresponseStart */]);
                        response = dateTimeUtilsDuration(navigationTiming[_DYN_RESPONSE_START /* @min:%2eresponseStart */], navigationTiming[_DYN_RESPONSE_END /* @min:%2eresponseEnd */]);
                        dom = dateTimeUtilsDuration(navigationTiming.responseEnd, navigationTiming[_DYN_LOAD_EVENT_END /* @min:%2eloadEventEnd */]);
                    }
                    else {
                        total = dateTimeUtilsDuration(timing[_DYN_NAVIGATION_START /* @min:%2enavigationStart */], timing[_DYN_LOAD_EVENT_END /* @min:%2eloadEventEnd */]);
                        network = dateTimeUtilsDuration(timing[_DYN_NAVIGATION_START /* @min:%2enavigationStart */], timing[_DYN_CONNECT_END /* @min:%2econnectEnd */]);
                        request = dateTimeUtilsDuration(timing.requestStart, timing[_DYN_RESPONSE_START /* @min:%2eresponseStart */]);
                        response = dateTimeUtilsDuration(timing[_DYN_RESPONSE_START /* @min:%2eresponseStart */], timing[_DYN_RESPONSE_END /* @min:%2eresponseEnd */]);
                        dom = dateTimeUtilsDuration(timing.responseEnd, timing[_DYN_LOAD_EVENT_END /* @min:%2eloadEventEnd */]);
                    }
                    if (total === 0) {
                        _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 10 /* _eInternalMessageId.ErrorPVCalc */, "error calculating page view performance.", { total: total, network: network, request: request, response: response, dom: dom });
                    }
                    else if (!_self[_DYN_SHOULD_COLLECT_DURAT16 /* @min:%2eshouldCollectDuration */](total, network, request, response, dom)) {
                        _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 45 /* _eInternalMessageId.InvalidDurationValue */, "Invalid page load duration value. Browser perf data won't be sent.", { total: total, network: network, request: request, response: response, dom: dom });
                    }
                    else if (total < Math.floor(network) + Math.floor(request) + Math.floor(response) + Math.floor(dom)) {
                        // some browsers may report individual components incorrectly so that the sum of the parts will be bigger than total PLT
                        // in this case, don't report client performance from this page
                        _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 8 /* _eInternalMessageId.ClientPerformanceMathError */, "client performance math error.", { total: total, network: network, request: request, response: response, dom: dom });
                    }
                    else {
                        pageViewPerformance.durationMs = total;
                        // // convert to timespans
                        pageViewPerformance.perfTotal = pageViewPerformance[_DYN_DURATION /* @min:%2eduration */] = msToTimeSpan(total);
                        pageViewPerformance.networkConnect = msToTimeSpan(network);
                        pageViewPerformance.sentRequest = msToTimeSpan(request);
                        pageViewPerformance.receivedResponse = msToTimeSpan(response);
                        pageViewPerformance.domProcessing = msToTimeSpan(dom);
                        pageViewPerformance.isValid = true;
                    }
                }
            };
            _self[_DYN_GET_PERFORMANCE_TIMI15 /* @min:%2egetPerformanceTiming */] = _getPerformanceTiming;
            _self[_DYN_IS_PERFORMANCE_TIMIN14 /* @min:%2eisPerformanceTimingSupported */] = _isPerformanceTimingSupported;
            _self[_DYN_IS_PERFORMANCE_TIMIN17 /* @min:%2eisPerformanceTimingDataReady */] = _isPerformanceTimingDataReady;
            _self[_DYN_SHOULD_COLLECT_DURAT16 /* @min:%2eshouldCollectDuration */] = _shouldCollectDuration;
        });
    }
// Removed Stub for PageViewPerformanceManager.prototype.populatePageViewPerformanceEvent.
// Removed Stub for PageViewPerformanceManager.prototype.getPerformanceTiming.
// Removed Stub for PageViewPerformanceManager.prototype.isPerformanceTimingSupported.
// Removed Stub for PageViewPerformanceManager.prototype.isPerformanceTimingDataReady.
// Removed Stub for PageViewPerformanceManager.prototype.shouldCollectDuration.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    PageViewPerformanceManager.__ieDyn=1;

    return PageViewPerformanceManager;
}());

/*
 * Application Insights JavaScript SDK - Web Analytics, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Used to track page visit durations
 */
var PageVisitTimeManager = /** @class */ (function () {
    /**
     * Creates a new instance of PageVisitTimeManager
     * @param pageVisitTimeTrackingHandler - Delegate that will be called to send telemetry data to AI (when trackPreviousPageVisit is called)
     * @returns {}
     */
    function PageVisitTimeManager(logger, pageVisitTimeTrackingHandler) {
        var prevPageVisitDataKeyName = "prevPageVisitData";
        dynamicProto(PageVisitTimeManager, this, function (_self) {
            _self[_DYN_TRACK_PREVIOUS_PAGE_1 /* @min:%2etrackPreviousPageVisit */] = function (currentPageName, currentPageUrl) {
                try {
                    // Restart timer for new page view
                    var prevPageVisitTimeData = restartPageVisitTimer(currentPageName, currentPageUrl);
                    // If there was a page already being timed, track the visit time for it now.
                    if (prevPageVisitTimeData) {
                        pageVisitTimeTrackingHandler(prevPageVisitTimeData.pageName, prevPageVisitTimeData.pageUrl, prevPageVisitTimeData.pageVisitTime);
                    }
                }
                catch (e) {
                    _warnToConsole(logger, "Auto track page visit time failed, metric will not be collected: " + dumpObj(e));
                }
            };
            /**
             * Stops timing of current page (if exists) and starts timing for duration of visit to pageName
             * @param pageName - Name of page to begin timing visit duration
             * @returns {PageVisitData} Page visit data (including duration) of pageName from last call to start or restart, if exists. Null if not.
             */
            function restartPageVisitTimer(pageName, pageUrl) {
                var prevPageVisitData = null;
                try {
                    prevPageVisitData = stopPageVisitTimer();
                    if (utlCanUseSessionStorage()) {
                        if (utlGetSessionStorage(logger, prevPageVisitDataKeyName) != null) {
                            throwError("Cannot call startPageVisit consecutively without first calling stopPageVisit");
                        }
                        var currPageVisitDataStr = getJSON().stringify(new PageVisitData(pageName, pageUrl));
                        utlSetSessionStorage(logger, prevPageVisitDataKeyName, currPageVisitDataStr);
                    }
                }
                catch (e) {
                    _warnToConsole(logger, "Call to restart failed: " + dumpObj(e));
                    prevPageVisitData = null;
                }
                return prevPageVisitData;
            }
            /**
             * Stops timing of current page, if exists.
             * @returns {PageVisitData} Page visit data (including duration) of pageName from call to start, if exists. Null if not.
             */
            function stopPageVisitTimer() {
                var prevPageVisitData = null;
                try {
                    if (utlCanUseSessionStorage()) {
                        // Define end time of page's visit
                        var pageVisitEndTime = utcNow();
                        // Try to retrieve  page name and start time from session storage
                        var pageVisitDataJsonStr = utlGetSessionStorage(logger, prevPageVisitDataKeyName);
                        if (pageVisitDataJsonStr && hasJSON()) {
                            // if previous page data exists, set end time of visit
                            prevPageVisitData = getJSON().parse(pageVisitDataJsonStr);
                            prevPageVisitData.pageVisitTime = pageVisitEndTime - prevPageVisitData[_DYN_PAGE_VISIT_START_TIM18 /* @min:%2epageVisitStartTime */];
                            // Remove data from storage since we already used it
                            utlRemoveSessionStorage(logger, prevPageVisitDataKeyName);
                        }
                    }
                }
                catch (e) {
                    _warnToConsole(logger, "Stop page visit timer failed: " + dumpObj(e));
                    prevPageVisitData = null;
                }
                return prevPageVisitData;
            }
            // For backward compatibility
            objDefine(_self, "_logger", { g: function () { return logger; } });
            objDefine(_self, "pageVisitTimeTrackingHandler", { g: function () { return pageVisitTimeTrackingHandler; } });
        });
    }
// Removed Stub for PageVisitTimeManager.prototype.trackPreviousPageVisit.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    PageVisitTimeManager.__ieDyn=1;

    return PageVisitTimeManager;
}());
var PageVisitData = /** @class */ (function () {
    function PageVisitData(pageName, pageUrl) {
        this[_DYN_PAGE_VISIT_START_TIM18 /* @min:%2epageVisitStartTime */] = utcNow();
        this.pageName = pageName;
        this.pageUrl = pageUrl;
    }
    return PageVisitData;
}());

/*
 * Application Insights JavaScript SDK - Web Analytics, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/**
 * Used to record timed events and page views.
 */
var Timing = /** @class */ (function () {
    function Timing(logger, name) {
        var _self = this;
        var _events = {};
        _self.start = function (name) {
            if (typeof _events[name] !== "undefined") {
                _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 62 /* _eInternalMessageId.StartCalledMoreThanOnce */, "start was called more than once for this event without calling stop.", { name: name, key: name }, true);
            }
            _events[name] = +new Date;
        };
        _self.stop = function (name, url, properties, measurements) {
            var start = _events[name];
            if (isNaN(start)) {
                _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 63 /* _eInternalMessageId.StopCalledWithoutStart */, "stop was called without a corresponding start.", { name: name, key: name }, true);
            }
            else {
                var end = +new Date;
                var duration = dateTimeUtilsDuration(start, end);
                _self.action(name, url, duration, properties, measurements);
            }
            delete _events[name];
            _events[name] = undefined;
        };
    }
    return Timing;
}());

/*
 * Application Insights JavaScript SDK - Web Analytics, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
/**
* ApplicationInsights.ts
* @copyright Microsoft 2018
*/
var _a$5;
var strEvent = "event";
function _dispatchEvent(target, evnt) {
    if (target && target.dispatchEvent && evnt) {
        target.dispatchEvent(evnt);
    }
}
function _getReason(error) {
    if (error && error.reason) {
        var reason = error.reason;
        if (!isString(reason) && isFunction(reason[_DYN_TO_STRING$1 /* @min:%2etoString */])) {
            return reason[_DYN_TO_STRING$1 /* @min:%2etoString */]();
        }
        return dumpObj(reason);
    }
    // Pass the original object down which will eventually get evaluated for any message or description
    return error || "";
}
var MinMilliSeconds = 60000;
var defaultValues = objDeepFreeze((_a$5 = {
        sessionRenewalMs: cfgDfSet(_chkConfigMilliseconds, 30 * 60 * 1000),
        sessionExpirationMs: cfgDfSet(_chkConfigMilliseconds, 24 * 60 * 60 * 1000),
        disableExceptionTracking: cfgDfBoolean()
    },
    _a$5[_DYN_AUTO_TRACK_PAGE_VISI9 /* @min:autoTrackPageVisitTime */] = cfgDfBoolean(),
    _a$5[_DYN_OVERRIDE_PAGE_VIEW_D8 /* @min:overridePageViewDuration */] = cfgDfBoolean(),
    _a$5[_DYN_ENABLE_UNHANDLED_PRO12 /* @min:enableUnhandledPromiseRejectionTracking */] = cfgDfBoolean(),
    _a$5[_DYN_AUTO_UNHANDLED_PROMI13 /* @min:autoUnhandledPromiseInstrumented */] = false,
    _a$5.samplingPercentage = cfgDfValidate(_chkSampling$1, 100),
    _a$5[_DYN_IS_STORAGE_USE_DISAB0 /* @min:isStorageUseDisabled */] = cfgDfBoolean(),
    _a$5[_DYN_IS_BROWSER_LINK_TRAC10 /* @min:isBrowserLinkTrackingEnabled */] = cfgDfBoolean(),
    _a$5[_DYN_ENABLE_AUTO_ROUTE_TR11 /* @min:enableAutoRouteTracking */] = cfgDfBoolean(),
    _a$5.namePrefix = cfgDfString(),
    _a$5.enableDebug = cfgDfBoolean(),
    _a$5.disableFlushOnBeforeUnload = cfgDfBoolean(),
    _a$5.disableFlushOnUnload = cfgDfBoolean(false, "disableFlushOnBeforeUnload"),
    _a$5));
function _chkConfigMilliseconds(value, defValue) {
    value = value || defValue;
    if (value < MinMilliSeconds) {
        value = MinMilliSeconds;
    }
    return +value;
}
function _chkSampling$1(value) {
    return !isNaN(value) && value > 0 && value <= 100;
}
function _updateStorageUsage(extConfig) {
    // Not resetting the storage usage as someone may have manually called utlDisableStorage, so this will only
    // reset based if the configuration option is provided
    if (!isUndefined(extConfig[_DYN_IS_STORAGE_USE_DISAB0 /* @min:%2eisStorageUseDisabled */])) {
        if (extConfig[_DYN_IS_STORAGE_USE_DISAB0 /* @min:%2eisStorageUseDisabled */]) {
            utlDisableStorage();
        }
        else {
            utlEnableStorage();
        }
    }
}
var AnalyticsPlugin = /** @class */ (function (_super) {
    __extendsFn(AnalyticsPlugin, _super);
    function AnalyticsPlugin() {
        var _this = _super.call(this) || this;
        _this.identifier = AnalyticsPluginIdentifier; // do not change name or priority
        _this.priority = 180; // take from reserved priority range 100- 200
        _this.autoRoutePVDelay = 500; // ms; Time to wait after a route change before triggering a pageview to allow DOM changes to take place
        var _eventTracking;
        var _pageTracking;
        var _pageViewManager;
        var _pageViewPerformanceManager;
        var _pageVisitTimeManager;
        var _preInitTelemetryInitializers;
        var _isBrowserLinkTrackingEnabled;
        var _browserLinkInitializerAdded;
        var _enableAutoRouteTracking;
        var _historyListenerAdded;
        var _disableExceptionTracking;
        var _autoExceptionInstrumented;
        var _enableUnhandledPromiseRejectionTracking;
        var _autoUnhandledPromiseInstrumented;
        var _extConfig;
        var _autoTrackPageVisitTime;
        // array with max length of 2 that store current url and previous url for SPA page route change trackPageview use.
        var _prevUri; // Assigned in the constructor
        var _currUri;
        var _evtNamespace;
        dynamicProto(AnalyticsPlugin, _this, function (_self, _base) {
            var _addHook = _base[_DYN__ADD_HOOK$1 /* @min:%2e_addHook */];
            _initDefaults();
            _self.getCookieMgr = function () {
                return safeGetCookieMgr(_self[_DYN_CORE$1 /* @min:%2ecore */]);
            };
            _self.processTelemetry = function (env, itemCtx) {
                _self.processNext(env, itemCtx);
            };
            _self.trackEvent = function (event, customProperties) {
                try {
                    var telemetryItem = createTelemetryItem(event, Event$1[_DYN_DATA_TYPE$1 /* @min:%2edataType */], Event$1[_DYN_ENVELOPE_TYPE$1 /* @min:%2eenvelopeType */], _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), customProperties);
                    _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_TRACK /* @min:%2etrack */](telemetryItem);
                }
                catch (e) {
                    _throwInternal(2 /* eLoggingSeverity.WARNING */, 39 /* _eInternalMessageId.TrackTraceFailed */, "trackTrace failed, trace will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * Start timing an extended event. Call `stopTrackEvent` to log the event when it ends.
             * @param   name    A string that identifies this event uniquely within the document.
             */
            _self.startTrackEvent = function (name) {
                try {
                    _eventTracking.start(name);
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 29 /* _eInternalMessageId.StartTrackEventFailed */, "startTrackEvent failed, event will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * Log an extended event that you started timing with `startTrackEvent`.
             * @param   name    The string you used to identify this event in `startTrackEvent`.
             * @param   properties  map[string, string] - additional data used to filter events and metrics in the portal. Defaults to empty.
             * @param   measurements    map[string, number] - metrics associated with this event, displayed in Metrics Explorer on the portal. Defaults to empty.
             */
            _self.stopTrackEvent = function (name, properties, measurements) {
                try {
                    _eventTracking.stop(name, undefined, properties, measurements);
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 30 /* _eInternalMessageId.StopTrackEventFailed */, "stopTrackEvent failed, event will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * @description Log a diagnostic message
             * @param trace
             * @param ICustomProperties.
             * @memberof ApplicationInsights
             */
            _self.trackTrace = function (trace, customProperties) {
                try {
                    var telemetryItem = createTelemetryItem(trace, Trace[_DYN_DATA_TYPE$1 /* @min:%2edataType */], Trace[_DYN_ENVELOPE_TYPE$1 /* @min:%2eenvelopeType */], _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), customProperties);
                    _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_TRACK /* @min:%2etrack */](telemetryItem);
                }
                catch (e) {
                    _throwInternal(2 /* eLoggingSeverity.WARNING */, 39 /* _eInternalMessageId.TrackTraceFailed */, "trackTrace failed, trace will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * @description Log a numeric value that is not associated with a specific event. Typically
             * used to send regular reports of performance indicators. To send single measurement, just
             * use the name and average fields of {@link IMetricTelemetry}. If you take measurements
             * frequently, you can reduce the telemetry bandwidth by aggregating multiple measurements
             * and sending the resulting average at intervals
             * @param metric - input object argument. Only name and average are mandatory.
             * @param } customProperties additional data used to filter metrics in the
             * portal. Defaults to empty.
             * @memberof ApplicationInsights
             */
            _self.trackMetric = function (metric, customProperties) {
                try {
                    var telemetryItem = createTelemetryItem(metric, Metric[_DYN_DATA_TYPE$1 /* @min:%2edataType */], Metric[_DYN_ENVELOPE_TYPE$1 /* @min:%2eenvelopeType */], _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), customProperties);
                    _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_TRACK /* @min:%2etrack */](telemetryItem);
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 36 /* _eInternalMessageId.TrackMetricFailed */, "trackMetric failed, metric will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * Logs that a page or other item was viewed.
             * @param IPageViewTelemetry - The string you used as the name in startTrackPage. Defaults to the document title.
             * @param customProperties - Additional data used to filter events and metrics. Defaults to empty.
             * If a user wants to provide duration for pageLoad, it'll have to be in pageView.properties.duration
             */
            _self[_DYN_TRACK_PAGE_VIEW /* @min:%2etrackPageView */] = function (pageView, customProperties) {
                try {
                    var inPv = pageView || {};
                    _pageViewManager[_DYN_TRACK_PAGE_VIEW /* @min:%2etrackPageView */](inPv, __assignFn(__assignFn(__assignFn({}, inPv.properties), inPv.measurements), customProperties));
                    if (_autoTrackPageVisitTime) {
                        _pageVisitTimeManager[_DYN_TRACK_PREVIOUS_PAGE_1 /* @min:%2etrackPreviousPageVisit */](inPv.name, inPv.uri);
                    }
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 37 /* _eInternalMessageId.TrackPVFailed */, "trackPageView failed, page view will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * Create a page view telemetry item and send it to the SDK pipeline through the core.track API
             * @param pageView - Page view item to be sent
             * @param properties - Custom properties (Part C) that a user can add to the telemetry item
             * @param systemProperties - System level properties (Part A) that a user can add to the telemetry item
             */
            _self[_DYN_SEND_PAGE_VIEW_INTER2 /* @min:%2esendPageViewInternal */] = function (pageView, properties, systemProperties) {
                var doc = getDocument();
                if (doc) {
                    pageView.refUri = pageView.refUri === undefined ? doc.referrer : pageView.refUri;
                }
                if (isNullOrUndefined(pageView[_DYN_START_TIME$1 /* @min:%2estartTime */])) {
                    // calculate the start time manually
                    var duration = ((properties || pageView[_DYN_PROPERTIES /* @min:%2eproperties */] || {})[_DYN_DURATION /* @min:%2eduration */] || 0);
                    pageView[_DYN_START_TIME$1 /* @min:%2estartTime */] = new Date(new Date().getTime() - duration);
                }
                var telemetryItem = createTelemetryItem(pageView, PageView[_DYN_DATA_TYPE$1 /* @min:%2edataType */], PageView[_DYN_ENVELOPE_TYPE$1 /* @min:%2eenvelopeType */], _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), properties, systemProperties);
                _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_TRACK /* @min:%2etrack */](telemetryItem);
            };
            /**
             * @ignore INTERNAL ONLY
             * @param pageViewPerformance
             * @param properties
             */
            _self[_DYN_SEND_PAGE_VIEW_PERFO3 /* @min:%2esendPageViewPerformanceInternal */] = function (pageViewPerformance, properties, systemProperties) {
                var telemetryItem = createTelemetryItem(pageViewPerformance, PageViewPerformance[_DYN_DATA_TYPE$1 /* @min:%2edataType */], PageViewPerformance[_DYN_ENVELOPE_TYPE$1 /* @min:%2eenvelopeType */], _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), properties, systemProperties);
                _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_TRACK /* @min:%2etrack */](telemetryItem);
            };
            /**
             * Send browser performance metrics.
             * @param pageViewPerformance
             * @param customProperties
             */
            _self.trackPageViewPerformance = function (pageViewPerformance, customProperties) {
                var inPvp = pageViewPerformance || {};
                try {
                    _pageViewPerformanceManager[_DYN_POPULATE_PAGE_VIEW_P4 /* @min:%2epopulatePageViewPerformanceEvent */](inPvp);
                    _self[_DYN_SEND_PAGE_VIEW_PERFO3 /* @min:%2esendPageViewPerformanceInternal */](inPvp, customProperties);
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 37 /* _eInternalMessageId.TrackPVFailed */, "trackPageViewPerformance failed, page view will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * Starts the timer for tracking a page load time. Use this instead of `trackPageView` if you want to control when the page view timer starts and stops,
             * but don't want to calculate the duration yourself. This method doesn't send any telemetry. Call `stopTrackPage` to log the end of the page view
             * and send the event.
             * @param name - A string that idenfities this item, unique within this HTML document. Defaults to the document title.
             */
            _self.startTrackPage = function (name) {
                try {
                    if (typeof name !== "string") {
                        var doc = getDocument();
                        name = doc && doc.title || "";
                    }
                    _pageTracking.start(name);
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 31 /* _eInternalMessageId.StartTrackFailed */, "startTrackPage failed, page view may not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * Stops the timer that was started by calling `startTrackPage` and sends the pageview load time telemetry with the specified properties and measurements.
             * The duration of the page view will be the time between calling `startTrackPage` and `stopTrackPage`.
             * @param   name  The string you used as the name in startTrackPage. Defaults to the document title.
             * @param   url   String - a relative or absolute URL that identifies the page or other item. Defaults to the window location.
             * @param   properties  map[string, string] - additional data used to filter pages and metrics in the portal. Defaults to empty.
             * @param   measurements    map[string, number] - metrics associated with this page, displayed in Metrics Explorer on the portal. Defaults to empty.
             */
            _self.stopTrackPage = function (name, url, properties, measurement) {
                try {
                    if (typeof name !== "string") {
                        var doc = getDocument();
                        name = doc && doc.title || "";
                    }
                    if (typeof url !== "string") {
                        var loc = getLocation();
                        url = loc && loc[_DYN_HREF /* @min:%2ehref */] || "";
                    }
                    _pageTracking.stop(name, url, properties, measurement);
                    if (_autoTrackPageVisitTime) {
                        _pageVisitTimeManager[_DYN_TRACK_PREVIOUS_PAGE_1 /* @min:%2etrackPreviousPageVisit */](name, url);
                    }
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 32 /* _eInternalMessageId.StopTrackFailed */, "stopTrackPage failed, page view will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
            * @ignore INTERNAL ONLY
            * @param exception
            * @param properties
            * @param systemProperties
            */
            _self[_DYN_SEND_EXCEPTION_INTER5 /* @min:%2esendExceptionInternal */] = function (exception, customProperties, systemProperties) {
                // Adding additional edge cases to handle
                // - Not passing anything (null / undefined)
                var theError = (exception && (exception[_DYN_EXCEPTION$1 /* @min:%2eexception */] || exception[_DYN_ERROR /* @min:%2eerror */])) ||
                    // - Handle someone calling trackException based of v1 API where the exception was the Error
                    isError(exception) && exception ||
                    // - Handles no error being defined and instead of creating a new Error() instance attempt to map so any stacktrace
                    //   is preserved and does not list ApplicationInsights code as the source
                    { name: (exception && typeof exception), message: exception || strNotSpecified };
                // If no exception object was passed assign to an empty object to avoid internal exceptions
                exception = exception || {};
                var exceptionPartB = new Exception(_self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), theError, exception[_DYN_PROPERTIES /* @min:%2eproperties */] || customProperties, exception.measurements, exception.severityLevel, exception.id).toInterface();
                var telemetryItem = createTelemetryItem(exceptionPartB, Exception[_DYN_DATA_TYPE$1 /* @min:%2edataType */], Exception[_DYN_ENVELOPE_TYPE$1 /* @min:%2eenvelopeType */], _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), customProperties, systemProperties);
                _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_TRACK /* @min:%2etrack */](telemetryItem);
            };
            /**
             * Log an exception you have caught.
             *
             * @param exception -   Object which contains exception to be sent
             * @param } customProperties   Additional data used to filter pages and metrics in the portal. Defaults to empty.
             *
             * Any property of type double will be considered a measurement, and will be treated by Application Insights as a metric.
             * @memberof ApplicationInsights
             */
            _self.trackException = function (exception, customProperties) {
                if (exception && !exception[_DYN_EXCEPTION$1 /* @min:%2eexception */] && exception[_DYN_ERROR /* @min:%2eerror */]) {
                    exception[_DYN_EXCEPTION$1 /* @min:%2eexception */] = exception[_DYN_ERROR /* @min:%2eerror */];
                }
                try {
                    _self[_DYN_SEND_EXCEPTION_INTER5 /* @min:%2esendExceptionInternal */](exception, customProperties);
                }
                catch (e) {
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 35 /* _eInternalMessageId.TrackExceptionFailed */, "trackException failed, exception will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                }
            };
            /**
             * @description Custom error handler for Application Insights Analytics
             * @param exception
             * @memberof ApplicationInsights
             */
            _self[_DYN__ONERROR /* @min:%2e_onerror */] = function (exception) {
                var error = exception && exception[_DYN_ERROR /* @min:%2eerror */];
                var evt = exception && exception.evt;
                try {
                    if (!evt) {
                        var _window = getWindow();
                        if (_window) {
                            evt = _window[strEvent];
                        }
                    }
                    var url = (exception && exception.url) || (getDocument() || {}).URL;
                    // If no error source is provided assume the default window.onerror handler
                    var errorSrc = exception[_DYN_ERROR_SRC /* @min:%2eerrorSrc */] || "window.onerror@" + url + ":" + (exception[_DYN_LINE_NUMBER /* @min:%2elineNumber */] || 0) + ":" + (exception[_DYN_COLUMN_NUMBER /* @min:%2ecolumnNumber */] || 0);
                    var properties = {
                        errorSrc: errorSrc,
                        url: url,
                        lineNumber: exception[_DYN_LINE_NUMBER /* @min:%2elineNumber */] || 0,
                        columnNumber: exception[_DYN_COLUMN_NUMBER /* @min:%2ecolumnNumber */] || 0,
                        message: exception[_DYN_MESSAGE /* @min:%2emessage */]
                    };
                    if (isCrossOriginError(exception.message, exception.url, exception.lineNumber, exception.columnNumber, exception[_DYN_ERROR /* @min:%2eerror */])) {
                        _sendCORSException(Exception[_DYN__CREATE_AUTO_EXCEPTI6 /* @min:%2eCreateAutoException */]("Script error: The browser's same-origin policy prevents us from getting the details of this exception. Consider using the 'crossorigin' attribute.", url, exception[_DYN_LINE_NUMBER /* @min:%2elineNumber */] || 0, exception[_DYN_COLUMN_NUMBER /* @min:%2ecolumnNumber */] || 0, error, evt, null, errorSrc), properties);
                    }
                    else {
                        if (!exception[_DYN_ERROR_SRC /* @min:%2eerrorSrc */]) {
                            exception[_DYN_ERROR_SRC /* @min:%2eerrorSrc */] = errorSrc;
                        }
                        _self.trackException({ exception: exception, severityLevel: 3 /* eSeverityLevel.Error */ }, properties);
                    }
                }
                catch (e) {
                    var errorString = error ? (error.name + ", " + error[_DYN_MESSAGE /* @min:%2emessage */]) : "null";
                    _throwInternal(1 /* eLoggingSeverity.CRITICAL */, 11 /* _eInternalMessageId.ExceptionWhileLoggingError */, "_onError threw exception while logging error, error will not be collected: "
                        + getExceptionName(e), { exception: dumpObj(e), errorString: errorString });
                }
            };
            _self[_DYN_ADD_TELEMETRY_INITIA7 /* @min:%2eaddTelemetryInitializer */] = function (telemetryInitializer) {
                if (_self[_DYN_CORE$1 /* @min:%2ecore */]) {
                    // Just add to the core
                    return _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_ADD_TELEMETRY_INITIA7 /* @min:%2eaddTelemetryInitializer */](telemetryInitializer);
                }
                // Handle "pre-initialization" telemetry initializers (for backward compatibility)
                if (!_preInitTelemetryInitializers) {
                    _preInitTelemetryInitializers = [];
                }
                _preInitTelemetryInitializers.push(telemetryInitializer);
            };
            _self.initialize = function (config, core, extensions, pluginChain) {
                if (_self.isInitialized()) {
                    return;
                }
                if (isNullOrUndefined(core)) {
                    throwError("Error initializing");
                }
                _base.initialize(config, core, extensions, pluginChain);
                try {
                    _evtNamespace = mergeEvtNamespace(createUniqueNamespace(_self.identifier), core.evtNamespace && core.evtNamespace());
                    if (_preInitTelemetryInitializers) {
                        arrForEach(_preInitTelemetryInitializers, function (initializer) {
                            core[_DYN_ADD_TELEMETRY_INITIA7 /* @min:%2eaddTelemetryInitializer */](initializer);
                        });
                        _preInitTelemetryInitializers = null;
                    }
                    _populateDefaults(config);
                    _pageViewPerformanceManager = new PageViewPerformanceManager(_self[_DYN_CORE$1 /* @min:%2ecore */]);
                    _pageViewManager = new PageViewManager(_self, _extConfig.overridePageViewDuration, _self[_DYN_CORE$1 /* @min:%2ecore */], _pageViewPerformanceManager);
                    _pageVisitTimeManager = new PageVisitTimeManager(_self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), function (pageName, pageUrl, pageVisitTime) { return trackPageVisitTime(pageName, pageUrl, pageVisitTime); });
                    _eventTracking = new Timing(_self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), "trackEvent");
                    _eventTracking.action =
                        function (name, url, duration, properties, measurements) {
                            if (!properties) {
                                properties = {};
                            }
                            if (!measurements) {
                                measurements = {};
                            }
                            properties.duration = duration[_DYN_TO_STRING$1 /* @min:%2etoString */]();
                            _self.trackEvent({ name: name, properties: properties, measurements: measurements });
                        };
                    // initialize page view timing
                    _pageTracking = new Timing(_self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), "trackPageView");
                    _pageTracking.action = function (name, url, duration, properties, measurements) {
                        // duration must be a custom property in order for the collector to extract it
                        if (isNullOrUndefined(properties)) {
                            properties = {};
                        }
                        properties.duration = duration[_DYN_TO_STRING$1 /* @min:%2etoString */]();
                        var pageViewItem = {
                            name: name,
                            uri: url,
                            properties: properties,
                            measurements: measurements
                        };
                        _self[_DYN_SEND_PAGE_VIEW_INTER2 /* @min:%2esendPageViewInternal */](pageViewItem, properties);
                    };
                    if (hasWindow()) {
                        _updateExceptionTracking();
                        _updateLocationChange();
                    }
                }
                catch (e) {
                    // resetting the initialized state because of failure
                    _self.setInitialized(false);
                    throw e;
                }
            };
            _self._doTeardown = function (unloadCtx, unloadState) {
                _pageViewManager && _pageViewManager.teardown(unloadCtx, unloadState);
                // Just register to remove all events associated with this namespace
                eventOff(window, null, null, _evtNamespace);
                _initDefaults();
            };
            function _populateDefaults(config) {
                var identifier = _self.identifier;
                var core = _self[_DYN_CORE$1 /* @min:%2ecore */];
                _self[_DYN__ADD_HOOK$1 /* @min:%2e_addHook */](onConfigChange(config, function () {
                    var ctx = createProcessTelemetryContext(null, config, core);
                    _extConfig = ctx.getExtCfg(identifier, defaultValues);
                    _autoTrackPageVisitTime = _extConfig[_DYN_AUTO_TRACK_PAGE_VISI9 /* @min:%2eautoTrackPageVisitTime */];
                    if (config.storagePrefix) {
                        utlSetStoragePrefix(config.storagePrefix);
                    }
                    _updateStorageUsage(_extConfig);
                    // _updateBrowserLinkTracking
                    _isBrowserLinkTrackingEnabled = _extConfig[_DYN_IS_BROWSER_LINK_TRAC10 /* @min:%2eisBrowserLinkTrackingEnabled */];
                    _addDefaultTelemetryInitializers();
                }));
            }
            /**
             * Log a page visit time
             * @param    pageName    Name of page
             * @param    pageVisitDuration Duration of visit to the page in milliseconds
             */
            function trackPageVisitTime(pageName, pageUrl, pageVisitTime) {
                var properties = { PageName: pageName, PageUrl: pageUrl };
                _self.trackMetric({
                    name: "PageVisitTime",
                    average: pageVisitTime,
                    max: pageVisitTime,
                    min: pageVisitTime,
                    sampleCount: 1
                }, properties);
            }
            function _addDefaultTelemetryInitializers() {
                if (!_browserLinkInitializerAdded && _isBrowserLinkTrackingEnabled) {
                    var browserLinkPaths_1 = ["/browserLinkSignalR/", "/__browserLink/"];
                    var dropBrowserLinkRequests = function (envelope) {
                        if (_isBrowserLinkTrackingEnabled && envelope.baseType === RemoteDependencyData[_DYN_DATA_TYPE$1 /* @min:%2edataType */]) {
                            var remoteData = envelope.baseData;
                            if (remoteData) {
                                for (var i = 0; i < browserLinkPaths_1[_DYN_LENGTH$3 /* @min:%2elength */]; i++) {
                                    if (remoteData.target && strIndexOf(remoteData.target, browserLinkPaths_1[i]) >= 0) {
                                        return false;
                                    }
                                }
                            }
                        }
                        return true;
                    };
                    _self[_DYN__ADD_HOOK$1 /* @min:%2e_addHook */](_self[_DYN_ADD_TELEMETRY_INITIA7 /* @min:%2eaddTelemetryInitializer */](dropBrowserLinkRequests));
                    _browserLinkInitializerAdded = true;
                }
            }
            function _sendCORSException(exception, properties) {
                var telemetryItem = createTelemetryItem(exception, Exception[_DYN_DATA_TYPE$1 /* @min:%2edataType */], Exception[_DYN_ENVELOPE_TYPE$1 /* @min:%2eenvelopeType */], _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), properties);
                _self[_DYN_CORE$1 /* @min:%2ecore */][_DYN_TRACK /* @min:%2etrack */](telemetryItem);
            }
            function _updateExceptionTracking() {
                var _window = getWindow();
                var locn = getLocation(true);
                _self[_DYN__ADD_HOOK$1 /* @min:%2e_addHook */](onConfigChange(_extConfig, function () {
                    _disableExceptionTracking = _extConfig.disableExceptionTracking;
                    if (!_disableExceptionTracking && !_autoExceptionInstrumented && !_extConfig.autoExceptionInstrumented) {
                        // We want to enable exception auto collection and it has not been done so yet
                        _addHook(InstrumentEvent(_window, "onerror", {
                            ns: _evtNamespace,
                            rsp: function (callDetails, message, url, lineNumber, columnNumber, error) {
                                if (!_disableExceptionTracking && callDetails.rslt !== true) {
                                    _self[_DYN__ONERROR /* @min:%2e_onerror */](Exception[_DYN__CREATE_AUTO_EXCEPTI6 /* @min:%2eCreateAutoException */](message, url, lineNumber, columnNumber, error, callDetails.evt));
                                }
                            }
                        }, false));
                        _autoExceptionInstrumented = true;
                    }
                }));
                _addUnhandledPromiseRejectionTracking(_window, locn);
            }
            function _updateLocationChange() {
                var win = getWindow();
                var locn = getLocation(true);
                _self[_DYN__ADD_HOOK$1 /* @min:%2e_addHook */](onConfigChange(_extConfig, function () {
                    _enableAutoRouteTracking = _extConfig[_DYN_ENABLE_AUTO_ROUTE_TR11 /* @min:%2eenableAutoRouteTracking */] === true;
                    /**
                     * Create a custom "locationchange" event which is triggered each time the history object is changed
                     */
                    if (win && _enableAutoRouteTracking && !_historyListenerAdded && hasHistory()) {
                        var _history = getHistory();
                        if (isFunction(_history.pushState) && isFunction(_history.replaceState) && typeof Event !== strShimUndefined) {
                            _addHistoryListener(win, _history, locn);
                        }
                    }
                }));
            }
            function _getDistributedTraceCtx() {
                var distributedTraceCtx = null;
                if (_self[_DYN_CORE$1 /* @min:%2ecore */] && _self[_DYN_CORE$1 /* @min:%2ecore */].getTraceCtx) {
                    distributedTraceCtx = _self[_DYN_CORE$1 /* @min:%2ecore */].getTraceCtx(false);
                }
                if (!distributedTraceCtx) {
                    // Fallback when using an older Core and PropertiesPlugin
                    var properties = _self[_DYN_CORE$1 /* @min:%2ecore */].getPlugin(PropertiesPluginIdentifier);
                    if (properties) {
                        var context = properties.plugin.context;
                        if (context) {
                            distributedTraceCtx = createDistributedTraceContextFromTrace(context.telemetryTrace);
                        }
                    }
                }
                return distributedTraceCtx;
            }
            /**
             * Create a custom "locationchange" event which is triggered each time the history object is changed
             */
            function _addHistoryListener(win, history, locn) {
                if (_historyListenerAdded) {
                    return;
                }
                // Name Prefix is only referenced during the initial initialization and cannot be changed afterwards
                var namePrefix = _extConfig.namePrefix || "";
                function _popstateHandler() {
                    if (_enableAutoRouteTracking) {
                        _dispatchEvent(win, createDomEvent(namePrefix + "locationchange"));
                    }
                }
                function _locationChangeHandler() {
                    // We always track the changes (if the handler is installed) to handle the feature being disabled between location changes
                    if (_currUri) {
                        _prevUri = _currUri;
                        _currUri = locn && locn[_DYN_HREF /* @min:%2ehref */] || "";
                    }
                    else {
                        _currUri = locn && locn[_DYN_HREF /* @min:%2ehref */] || "";
                    }
                    if (_enableAutoRouteTracking) {
                        var distributedTraceCtx = _getDistributedTraceCtx();
                        if (distributedTraceCtx) {
                            distributedTraceCtx.setTraceId(generateW3CId());
                            var traceLocationName = "_unknown_";
                            if (locn && locn.pathname) {
                                traceLocationName = locn.pathname + (locn.hash || "");
                            }
                            // This populates the ai.operation.name which has a maximum size of 1024 so we need to sanitize it
                            distributedTraceCtx.setName(dataSanitizeString(_self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */](), traceLocationName));
                        }
                        scheduleTimeout((function (uri) {
                            // todo: override start time so that it is not affected by autoRoutePVDelay
                            _self[_DYN_TRACK_PAGE_VIEW /* @min:%2etrackPageView */]({ refUri: uri, properties: { duration: 0 } }); // SPA route change loading durations are undefined, so send 0
                        }).bind(_self, _prevUri), _self.autoRoutePVDelay);
                    }
                }
                _addHook(InstrumentEvent(history, "pushState", {
                    ns: _evtNamespace,
                    rsp: function () {
                        if (_enableAutoRouteTracking) {
                            _dispatchEvent(win, createDomEvent(namePrefix + "pushState"));
                            _dispatchEvent(win, createDomEvent(namePrefix + "locationchange"));
                        }
                    }
                }, true));
                _addHook(InstrumentEvent(history, "replaceState", {
                    ns: _evtNamespace,
                    rsp: function () {
                        if (_enableAutoRouteTracking) {
                            _dispatchEvent(win, createDomEvent(namePrefix + "replaceState"));
                            _dispatchEvent(win, createDomEvent(namePrefix + "locationchange"));
                        }
                    }
                }, true));
                eventOn(win, namePrefix + "popstate", _popstateHandler, _evtNamespace);
                eventOn(win, namePrefix + "locationchange", _locationChangeHandler, _evtNamespace);
                _historyListenerAdded = true;
            }
            function _addUnhandledPromiseRejectionTracking(_window, _location) {
                _self[_DYN__ADD_HOOK$1 /* @min:%2e_addHook */](onConfigChange(_extConfig, function () {
                    _enableUnhandledPromiseRejectionTracking = _extConfig[_DYN_ENABLE_UNHANDLED_PRO12 /* @min:%2eenableUnhandledPromiseRejectionTracking */] === true;
                    _autoExceptionInstrumented = _autoExceptionInstrumented || _extConfig[_DYN_AUTO_UNHANDLED_PROMI13 /* @min:%2eautoUnhandledPromiseInstrumented */];
                    if (_enableUnhandledPromiseRejectionTracking && !_autoUnhandledPromiseInstrumented) {
                        // We want to enable exception auto collection and it has not been done so yet
                        _addHook(InstrumentEvent(_window, "onunhandledrejection", {
                            ns: _evtNamespace,
                            rsp: function (callDetails, error) {
                                if (_enableUnhandledPromiseRejectionTracking && callDetails.rslt !== true) { // handled could be typeof function
                                    _self[_DYN__ONERROR /* @min:%2e_onerror */](Exception[_DYN__CREATE_AUTO_EXCEPTI6 /* @min:%2eCreateAutoException */](_getReason(error), _location ? _location[_DYN_HREF /* @min:%2ehref */] : "", 0, 0, error, callDetails.evt));
                                }
                            }
                        }, false));
                        _extConfig[_DYN_AUTO_UNHANDLED_PROMI13 /* @min:%2eautoUnhandledPromiseInstrumented */] = _autoUnhandledPromiseInstrumented = true;
                    }
                }));
            }
            /**
             * This method will throw exceptions in debug mode or attempt to log the error as a console warning.
             * @param severity - {eLoggingSeverity} - The severity of the log message
             * @param msgId - {_eInternalLogMessage} - The log message.
             */
            function _throwInternal(severity, msgId, msg, properties, isUserAct) {
                _self[_DYN_DIAG_LOG$1 /* @min:%2ediagLog */]().throwInternal(severity, msgId, msg, properties, isUserAct);
            }
            function _initDefaults() {
                _eventTracking = null;
                _pageTracking = null;
                _pageViewManager = null;
                _pageViewPerformanceManager = null;
                _pageVisitTimeManager = null;
                _preInitTelemetryInitializers = null;
                _isBrowserLinkTrackingEnabled = false;
                _browserLinkInitializerAdded = false;
                _enableAutoRouteTracking = false;
                _historyListenerAdded = false;
                _disableExceptionTracking = false;
                _autoExceptionInstrumented = false;
                _enableUnhandledPromiseRejectionTracking = false;
                _autoUnhandledPromiseInstrumented = false;
                _autoTrackPageVisitTime = false;
                // array with max length of 2 that store current url and previous url for SPA page route change trackPageview use.
                var location = getLocation(true);
                _prevUri = location && location[_DYN_HREF /* @min:%2ehref */] || "";
                _currUri = null;
                _evtNamespace = null;
                _extConfig = null;
                // Define _self.config
                objDefine(_self, "config", {
                    g: function () { return _extConfig; }
                });
            }
            // For backward compatibility
            objDefine(_self, "_pageViewManager", { g: function () { return _pageViewManager; } });
            objDefine(_self, "_pageViewPerformanceManager", { g: function () { return _pageViewPerformanceManager; } });
            objDefine(_self, "_pageVisitTimeManager", { g: function () { return _pageVisitTimeManager; } });
            objDefine(_self, "_evtNamespace", { g: function () { return "." + _evtNamespace; } });
        });
        return _this;
    }
// Removed Stub for AnalyticsPlugin.prototype.getCookieMgr.
// Removed Stub for AnalyticsPlugin.prototype.processTelemetry.
// Removed Stub for AnalyticsPlugin.prototype.trackEvent.
// Removed Stub for AnalyticsPlugin.prototype.startTrackEvent.
// Removed Stub for AnalyticsPlugin.prototype.stopTrackEvent.
// Removed Stub for AnalyticsPlugin.prototype.trackTrace.
// Removed Stub for AnalyticsPlugin.prototype.trackMetric.
// Removed Stub for AnalyticsPlugin.prototype.trackPageView.
// Removed Stub for AnalyticsPlugin.prototype.sendPageViewInternal.
// Removed Stub for AnalyticsPlugin.prototype.sendPageViewPerformanceInternal.
// Removed Stub for AnalyticsPlugin.prototype.trackPageViewPerformance.
// Removed Stub for AnalyticsPlugin.prototype.startTrackPage.
// Removed Stub for AnalyticsPlugin.prototype.stopTrackPage.
// Removed Stub for AnalyticsPlugin.prototype.sendExceptionInternal.
// Removed Stub for AnalyticsPlugin.prototype.trackException.
// Removed Stub for AnalyticsPlugin.prototype._onerror.
// Removed Stub for AnalyticsPlugin.prototype.addTelemetryInitializer.
// Removed Stub for AnalyticsPlugin.prototype.initialize.
    AnalyticsPlugin.Version = '3.3.0'; // Not currently used anywhere
    return AnalyticsPlugin;
}(BaseTelemetryPlugin));

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_FEATURE_OPT_IN = "featureOptIn"; // Count: 4
var _DYN_ON_CFG_CHANGE_RECEIV0 = "onCfgChangeReceive"; // Count: 2
var _DYN_NON_OVERRIDE_CONFIGS = "nonOverrideConfigs"; // Count: 2
var _DYN_SCHEDULE_FETCH_TIMEO1 = "scheduleFetchTimeout"; // Count: 2

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
/**
 * Delete a config key in the given cfg, if the config key exists in nonOverrideConfigs and its value is set to true
 * @param cfg cfg to modify
 * @param nonOverrideConfigs nonOverrideConfigs
 * @param curLevel cur config level, starting at 0
 * @param maxLevel max config level
 * @returns new copy of modified configs
 */
function replaceByNonOverrideCfg(cfg, nonOverrideConfigs, curLevel, maxLevel) {
    try {
        var exceedMaxLevel = curLevel > maxLevel;
        if (exceedMaxLevel) {
            cfg = null;
        }
        var curCfg_1 = curLevel == 0 ? objExtend$1({}, cfg) : cfg; // only copy cfg at the begining level
        if (curCfg_1 && nonOverrideConfigs && !exceedMaxLevel) {
            objForEachKey(curCfg_1, function (key) {
                var nonOverrideVal = nonOverrideConfigs[key];
                if (!!nonOverrideVal) {
                    if (isObject(curCfg_1[key]) && isObject(nonOverrideVal)) {
                        curCfg_1[key] = replaceByNonOverrideCfg(curCfg_1[key], nonOverrideVal, ++curLevel, maxLevel);
                    }
                    else {
                        delete curCfg_1[key];
                    }
                }
            });
        }
        return curCfg_1;
    }
    catch (e) {
        // eslint-disable-next-line no-empty
    }
    // if errors happen, do nothing
    return cfg;
}
//                                                     CDN Mode, value = B (CDN value = B)
//                                |--------------------------------------------------------------------------|-----------|
//                                |                    | none        | disabled    | enabled     | forceOn   | forceOff  |
//                                | ------------------ | ----------- | ----------- | ----------- | --------- | --------- |
// | User Mode, value = A         | none               | none        | disabled    | enabled     | enabled   | disabled  |
// (user Value = A)               | disabled           | disabled    | disabled    | disabled    | enabled   | disabled  |
//                                | enabled            | enabled     | disabled    | enabled     | enabled   | disabled  |
//                                | none(blockCdn)     | none        | none        | none        | none      | none      |
//                                | disabled(blockCdn) | disabled    | disabled    | disabled    | disabled  | disabled  |
//                                | enabled(blockCdn)  | enabled     | enabled     | enabled     | enabled   | enabled   |
// This matrix identifies how feature based overrides are selected (if present)
//                                cdn Mode (cdn Value = B)
//                   |---------------------------------------------------------------------------|
//                   |                    | none     | disabled | enabled  | forceOn  | forceOff |
//                   | ------------------ | ---------| ---------| ---------| ---------|----------|
// | User Mode       | none               | A        | A        | A || B   | B || A   | B || A   |
// (user Value = A)  | disabled           | A        | A        | A        | B || A   | B || A   |
//                   | enabled            | A        | A        | A || B   | B || A   | B || A   |
//                   | none(blockCdn)     | A        | A        | A        | A        | A        |
//                   | disabled(blockCdn) | A        | A        | A        | A        | A        |
//                   | enabled(blockCdn)  | A        | A        | A        | A        | A        |
// Note:
// Where the "value" is an object (map) of encoded key/values which will be used to override the real configuration
// A = either the user supplied enable/disable value (via the `config.featureOptIn[name]`) or if not defined by the user the SDK defaults of the same.
// B = The enable/disable value obtained from the CDN for the named feature
// These are evaluated based on the above matrix to either
// - A (Always the user/sdk value)
// - B (Always the value from the CDN)
// - A || B (If A is null or undefined use the value from the CDN (B) otherwise A)
// - B || A (If B is null or undefined use the user/SDK value otherwise use the value from the CDN)
//
// The result of the value may also be null / undefined, which means there are no overrides to apply when the feature is enabled
var F = "featureOptIn.";
var M = ".mode";
var ON = ".onCfg";
var OFF = ".offCfg";
function resolveCdnFeatureCfg(field, cdnCfg, userOptInDetails) {
    var _a;
    // cdn conifg value
    if (!cdnCfg || !cdnCfg.enabled) {
        return null;
    }
    var cdnFt = (cdnCfg[_DYN_FEATURE_OPT_IN /* @min:%2efeatureOptIn */] || {})[field] || { mode: 1 /* CdnFeatureMode.none */ };
    var cdnM = cdnFt.mode;
    var cdnOnV = cdnFt.onCfg;
    var cdnOffV = cdnFt.offCfg;
    var userFt = (userOptInDetails || {})[field] || { mode: 2 /* FeatureOptInMode.disable */ }; // default user mode is disable
    var userM = userFt.mode;
    var userOnV = userFt.onCfg;
    var userOffV = userFt.offCfg;
    var blockCdn = !!userFt.blockCdnCfg;
    var mFld = F + field + M;
    var onFld = F + field + ON;
    var offFld = F + field + OFF;
    var mode = userM;
    var onV = userOnV;
    var offV = userOffV;
    if (!blockCdn) {
        if (cdnM === 4 /* CdnFeatureMode.forceOn */ || cdnM === 5 /* CdnFeatureMode.forceOff */) {
            mode = (cdnM == 4 /* CdnFeatureMode.forceOn */ ? 3 /* FeatureOptInMode.enable */ : 2 /* FeatureOptInMode.disable */);
            onV = cdnOnV || userOnV;
            offV = cdnOffV || userOffV;
        }
        else if (cdnM === 2 /* CdnFeatureMode.disable */ || userM === 2 /* FeatureOptInMode.disable */) {
            mode = 2 /* FeatureOptInMode.disable */;
            onV = userOnV || cdnOnV;
            offV = userOffV || cdnOffV;
        }
        else if (cdnM === 3 /* CdnFeatureMode.enable */) {
            mode = 3 /* FeatureOptInMode.enable */;
            onV = userOnV || cdnOnV;
            offV = userOffV || cdnOffV;
        }
        else if (cdnM === 1 /* CdnFeatureMode.none */ && userM === 1 /* FeatureOptInMode.none */) {
            mode = 1 /* FeatureOptInMode.none */;
        }
    }
    return _a = {},
        _a[mFld] = mode,
        _a[onFld] = onV,
        _a[offFld] = offV,
        _a;
}
// helper function to get cdn config with opt-in features
function applyCdnfeatureCfg(cdnCfg, core) {
    try {
        if (!cdnCfg || !cdnCfg.enabled) {
            return null;
        }
        if (!cdnCfg[_DYN_FEATURE_OPT_IN /* @min:%2efeatureOptIn */]) {
            return cdnCfg.config;
        }
        var optInMap = cdnCfg[_DYN_FEATURE_OPT_IN /* @min:%2efeatureOptIn */];
        var cdnConfig_1 = cdnCfg.config || {};
        objForEachKey(optInMap, function (key) {
            var featureVal = resolveCdnFeatureCfg(key, cdnCfg, core.config[_DYN_FEATURE_OPT_IN /* @min:%2efeatureOptIn */]);
            if (!isNullOrUndefined(featureVal)) {
                objForEachKey(featureVal, function (config, val) {
                    setValueByKey(cdnConfig_1, config, val);
                });
                _overrideCdnCfgByFeature(key, featureVal, cdnConfig_1);
            }
        });
        return cdnConfig_1;
    }
    catch (e) {
        // eslint-disable-next-line no-empty
    }
    return null;
}
function _overrideCdnCfgByFeature(field, ftVal, config) {
    var mode = ftVal[F + field + M];
    var val = ftVal[F + field + ON];
    var dVal = ftVal[F + field + OFF];
    var target = null;
    if (mode === 3 /* FeatureOptInMode.enable */) {
        target = val;
    }
    if (mode === 2 /* FeatureOptInMode.disable */) {
        target = dVal;
    }
    if (target) {
        objForEachKey(target, function (key, cfg) {
            setValueByKey(config, key, cfg);
        });
    }
}

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
/**
* CfgSyncPlugin.ts
* @copyright Microsoft 2018
*/
var _a$4;
var EVENT_NAME = "ai_cfgsync";
var STR_GET_METHOD = "GET";
var FETCH_TIMEOUT = 1800000; // 30 minutes
var udfVal = undefined;
var defaultNonOverrideCfg = { instrumentationKey: true, connectionString: true, endpointUrl: true };
var _defaultConfig$2 = objDeepFreeze((_a$4 = {
        syncMode: 1 /* ICfgSyncMode.Broadcast */,
        blkCdnCfg: udfVal,
        customEvtName: udfVal,
        cfgUrl: udfVal,
        overrideSyncFn: udfVal,
        overrideFetchFn: udfVal
    },
    _a$4[_DYN_ON_CFG_CHANGE_RECEIV0 /* @min:onCfgChangeReceive */] = udfVal,
    _a$4[_DYN_SCHEDULE_FETCH_TIMEO1 /* @min:scheduleFetchTimeout */] = FETCH_TIMEOUT,
    _a$4[_DYN_NON_OVERRIDE_CONFIGS /* @min:nonOverrideConfigs */] = defaultNonOverrideCfg,
    _a$4));
var CfgSyncPlugin = /** @class */ (function (_super) {
    __extendsFn(CfgSyncPlugin, _super);
    function CfgSyncPlugin() {
        var _this = _super.call(this) || this;
        _this.priority = 198;
        _this.identifier = "AppInsightsCfgSyncPlugin";
        var _extensionConfig;
        var _mainConfig; // throttle config should be wrapped in IConfiguration
        var _evtName;
        var _evtNamespace;
        var _cfgUrl;
        var _timeoutHandle;
        var _receiveChanges;
        var _broadcastChanges;
        var _blkCdnCfg;
        var _fetchTimeout;
        var _retryCnt;
        var _onCfgChangeReceive;
        var _nonOverrideConfigs;
        var _fetchFn;
        var _overrideFetchFn;
        var _overrideSyncFn;
        var _paused = false;
        dynamicProto(CfgSyncPlugin, _this, function (_self, _base) {
            _initDefaults();
            _self.initialize = function (config, core, extensions, pluginChain) {
                _base.initialize(config, core, extensions, pluginChain);
                _evtNamespace = mergeEvtNamespace(createUniqueNamespace(_self.identifier), core.evtNamespace && core.evtNamespace());
                _populateDefaults(config);
            };
            _self.getCfg = function () {
                return _mainConfig;
            };
            _self.pause = function () {
                _paused = true;
                _clearScheduledTimer();
            };
            _self.resume = function () {
                _paused = false;
                _setupTimer();
            };
            // used for V2 to manaully trigger config udpate
            _self.setCfg = function (config) {
                return _setCfg(config);
            };
            _self.sync = function (customDetails) {
                return _sendCfgsyncEvents(customDetails);
            };
            _self.updateEventListenerName = function (eventName) {
                return _updateEventListenerName(eventName);
            };
            _self._doTeardown = function (unloadCtx, unloadState) {
                _eventOff();
                _clearScheduledTimer();
                _initDefaults();
            };
            _self["_getDbgPlgTargets"] = function () {
                return [_broadcastChanges, _receiveChanges, _evtName, _blkCdnCfg, _nonOverrideConfigs];
            };
            function _initDefaults() {
                _mainConfig = null;
                _evtName = null;
                _evtNamespace = null;
                _cfgUrl = null;
                _receiveChanges = null;
                _broadcastChanges = null;
                _nonOverrideConfigs = null;
                _timeoutHandle = null;
                _fetchTimeout = null;
                _retryCnt = null;
                _blkCdnCfg = null;
                _overrideFetchFn = null;
                _overrideSyncFn = null;
                _onCfgChangeReceive = null;
            }
            function _populateDefaults(config) {
                var identifier = _self.identifier;
                var core = _self.core;
                _self._addHook(onConfigChange(config, function () {
                    var ctx = createProcessTelemetryContext(null, config, core);
                    _extensionConfig = ctx.getExtCfg(identifier, _defaultConfig$2);
                    var preBlkCdn = _blkCdnCfg;
                    _blkCdnCfg = !!_extensionConfig.blkCdnCfg;
                    // avoid initial call
                    if (!isNullOrUndefined(preBlkCdn) && preBlkCdn !== _blkCdnCfg) {
                        if (!_blkCdnCfg && _cfgUrl) {
                            _fetchFn && _fetchFn(_cfgUrl, _onFetchComplete, _broadcastChanges);
                        }
                        else {
                            _clearScheduledTimer();
                        }
                    }
                    if (isNullOrUndefined(_receiveChanges)) {
                        _receiveChanges = _extensionConfig.syncMode === 2 /* ICfgSyncMode.Receive */;
                    }
                    if (isNullOrUndefined(_broadcastChanges)) {
                        _broadcastChanges = _extensionConfig.syncMode === 1 /* ICfgSyncMode.Broadcast */;
                    }
                    var newEvtName = _extensionConfig.customEvtName || EVENT_NAME;
                    if (_evtName !== newEvtName) {
                        if (_receiveChanges) {
                            _updateEventListenerName(newEvtName);
                        }
                        else {
                            _eventOff();
                            _evtName = newEvtName;
                        }
                    }
                    if (isNullOrUndefined(_cfgUrl)) {
                        _cfgUrl = _extensionConfig.cfgUrl;
                    }
                    // if cfgUrl is set, we will ignore core config change
                    if (!_cfgUrl) {
                        _mainConfig = config;
                        if (_broadcastChanges) {
                            _sendCfgsyncEvents();
                        }
                    }
                }));
                _overrideSyncFn = _extensionConfig.overrideSyncFn;
                _overrideFetchFn = _extensionConfig.overrideFetchFn;
                _onCfgChangeReceive = _extensionConfig[_DYN_ON_CFG_CHANGE_RECEIV0 /* @min:%2eonCfgChangeReceive */];
                _nonOverrideConfigs = _extensionConfig[_DYN_NON_OVERRIDE_CONFIGS /* @min:%2enonOverrideConfigs */]; // override values should not be changed
                _fetchTimeout = _extensionConfig[_DYN_SCHEDULE_FETCH_TIMEO1 /* @min:%2escheduleFetchTimeout */];
                _fetchFn = _getFetchFnInterface();
                _retryCnt = 0;
                // NOT support cfgURL change to avoid mutiple fetch calls
                if (_cfgUrl && !_blkCdnCfg) {
                    _fetchFn && _fetchFn(_cfgUrl, _onFetchComplete, _broadcastChanges);
                }
            }
            function _setCfg(config, isAutoSync) {
                if (config) {
                    _mainConfig = config;
                    if (!!isAutoSync && !_paused) {
                        return _sendCfgsyncEvents();
                    }
                    if (_receiveChanges && !_paused) {
                        _self.core.updateCfg(config);
                        return true;
                    }
                }
                return false;
            }
            function _eventOff() {
                try {
                    var global_1 = getGlobal();
                    if (global_1) {
                        eventOff(global_1, null, null, _evtNamespace);
                    }
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
            }
            function _sendCfgsyncEvents(customDetails) {
                try {
                    if (!!_overrideSyncFn && isFunction(_overrideSyncFn)) {
                        return _overrideSyncFn(_mainConfig, customDetails);
                    }
                    return sendCustomEvent(_evtName, _mainConfig, customDetails);
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return false;
            }
            function _updateEventListenerName(name) {
                try {
                    _eventOff();
                    if (name) {
                        _evtName = name;
                        _addEventListener();
                    }
                    return true;
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return false;
            }
            function _getFetchFnInterface() {
                var _fetchFn = _overrideFetchFn;
                if (isNullOrUndefined(_fetchFn)) {
                    if (isFetchSupported()) {
                        _fetchFn = _fetchSender;
                    }
                    else if (isXhrSupported()) {
                        _fetchFn = _xhrSender;
                    }
                }
                return _fetchFn;
            }
            function _fetchSender(url, oncomplete, isAutoSync) {
                var global = getGlobal();
                var fetchFn = (global && global.fetch) || null;
                if (url && fetchFn && isFunction(fetchFn)) {
                    try {
                        var init = {
                            method: STR_GET_METHOD
                        };
                        var request = new Request(url, init);
                        doAwaitResponse(fetch(request), function (result) {
                            var response = result.value;
                            if (!result.rejected) {
                                if (response.ok) {
                                    doAwaitResponse(response.text(), function (res) {
                                        _doOnComplete(oncomplete, response.status, res.value, isAutoSync);
                                    });
                                }
                                else {
                                    _doOnComplete(oncomplete, response.status, null, isAutoSync);
                                }
                            }
                            else {
                                _doOnComplete(oncomplete, 400);
                            }
                        });
                    }
                    catch (e) {
                        // eslint-disable-next-line no-empty
                    }
                }
            }
            function _xhrSender(url, oncomplete, isAutoSync) {
                try {
                    var xhr_1 = new XMLHttpRequest();
                    xhr_1.open(STR_GET_METHOD, url);
                    xhr_1.onreadystatechange = function () {
                        if (xhr_1.readyState === XMLHttpRequest.DONE) {
                            _doOnComplete(oncomplete, xhr_1.status, xhr_1.responseText, isAutoSync);
                        }
                    };
                    xhr_1.onerror = function () {
                        _doOnComplete(oncomplete, 400);
                    };
                    xhr_1.ontimeout = function () {
                        _doOnComplete(oncomplete, 400);
                    };
                    xhr_1.send();
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
            }
            function _onFetchComplete(status, response, isAutoSync) {
                try {
                    if (status >= 200 && status < 400 && response) {
                        _retryCnt = 0; // any successful response will reset retry count to 0
                        var JSON_1 = getJSON();
                        if (JSON_1) {
                            var cdnCfg = JSON_1.parse(response); //comments are not allowed
                            var cfg = applyCdnfeatureCfg(cdnCfg, _self.core);
                            var newCfg = cfg && isPlainObject(cfg) && _replaceTartgetByKeys(cfg);
                            newCfg && _setCfg(newCfg, isAutoSync);
                            //cfg && _setCfg(cfg, isAutoSync);
                        }
                    }
                    else {
                        _retryCnt++;
                    }
                    if (_retryCnt < 3) {
                        _setupTimer();
                    }
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
            }
            function _doOnComplete(oncomplete, status, response, isAutoSync) {
                try {
                    oncomplete(status, response, isAutoSync);
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
            }
            function _addEventListener() {
                if (_receiveChanges) {
                    var global_2 = getGlobal();
                    if (global_2) {
                        try {
                            eventOn(global_2, _evtName, function (event) {
                                // TODO: add more validation here
                                // may include a "name" or some other features to check
                                var cfgEvent = event && event.detail;
                                if (_onCfgChangeReceive && cfgEvent) {
                                    _onCfgChangeReceive(cfgEvent);
                                }
                                else {
                                    var cfg = cfgEvent && cfgEvent.cfg;
                                    var newCfg = cfg && isPlainObject(cfg) && _replaceTartgetByKeys(cfg);
                                    newCfg && _setCfg(newCfg);
                                }
                            }, _evtNamespace, true);
                        }
                        catch (e) {
                            // eslint-disable-next-line no-empty
                        }
                    }
                }
            }
            // 4 levels
            function _replaceTartgetByKeys(cfg, level) {
                var _cfg = null;
                try {
                    if (cfg) {
                        _cfg = replaceByNonOverrideCfg(cfg, _nonOverrideConfigs, 0, 5);
                    }
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return _cfg;
            }
            /**
             * Sets up the timer which triggers fetching cdn every 30mins after inital call
             */
            function _setupTimer() {
                if (!_timeoutHandle && _fetchTimeout) {
                    _timeoutHandle = scheduleTimeout(function () {
                        _timeoutHandle = null;
                        _fetchFn(_cfgUrl, _onFetchComplete, _broadcastChanges);
                    }, _fetchTimeout);
                    _timeoutHandle.unref();
                }
            }
            function _clearScheduledTimer() {
                _timeoutHandle && _timeoutHandle.cancel();
                _timeoutHandle = null;
                _retryCnt = 0;
            }
            _self.processTelemetry = function (env, itemCtx) {
                _self.processNext(env, itemCtx);
            };
        });
        return _this;
    }
// Removed Stub for CfgSyncPlugin.prototype.initialize.
// Removed Stub for CfgSyncPlugin.prototype.getCfg.
// Removed Stub for CfgSyncPlugin.prototype.setCfg.
// Removed Stub for CfgSyncPlugin.prototype.sync.
// Removed Stub for CfgSyncPlugin.prototype.updateEventListenerName.
// Removed Stub for CfgSyncPlugin.prototype.pause.
// Removed Stub for CfgSyncPlugin.prototype.resume.
    //// Removed Stub for CfgSyncPlugin.prototype.processTelemetry.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    CfgSyncPlugin.__ieDyn=1;

    return CfgSyncPlugin;
}(BaseTelemetryPlugin));

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// ###################################################################################################################################################
// Note: DON'T Export these const from the package as we are still targeting IE/ES5 this will export a mutable variables that someone could change ###
// ###################################################################################################################################################
// Generally you should only put values that are used more than 2 times and then only if not already exposed as a constant (such as SdkCoreNames)
// as when using "short" named values from here they will be will be minified smaller than the SdkCoreNames[eSdkCoreNames.xxxx] value.
var STR_DURATION$1 = "duration";

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_TAGS = "tags"; // Count: 17
var _DYN_DEVICE_TYPE = "deviceType"; // Count: 3
var _DYN_DATA = "data"; // Count: 15
var _DYN_NAME$1 = "name"; // Count: 8
var _DYN_TRACE_ID$1 = "traceID"; // Count: 5
var _DYN_LENGTH$2 = "length"; // Count: 38
var _DYN_STRINGIFY = "stringify"; // Count: 5
var _DYN_MEASUREMENTS = "measurements"; // Count: 7
var _DYN_DATA_TYPE = "dataType"; // Count: 10
var _DYN_ENVELOPE_TYPE = "envelopeType"; // Count: 7
var _DYN_TO_STRING = "toString"; // Count: 7
var _DYN__GET = "_get"; // Count: 5
var _DYN_ENQUEUE = "enqueue"; // Count: 7
var _DYN_COUNT = "count"; // Count: 7
var _DYN_EVENTS_LIMIT_IN_MEM = "eventsLimitInMem"; // Count: 2
var _DYN_PUSH = "push"; // Count: 9
var _DYN_ITEM = "item"; // Count: 6
var _DYN_EMIT_LINE_DELIMITED_0 = "emitLineDelimitedJson"; // Count: 3
var _DYN_CLEAR = "clear"; // Count: 6
var _DYN_CREATE_NEW = "createNew"; // Count: 3
var _DYN_MARK_AS_SENT = "markAsSent"; // Count: 4
var _DYN_CLEAR_SENT = "clearSent"; // Count: 5
var _DYN_BUFFER_OVERRIDE = "bufferOverride"; // Count: 3
var _DYN__BUFFER__KEY = "BUFFER_KEY"; // Count: 5
var _DYN__SENT__BUFFER__KEY = "SENT_BUFFER_KEY"; // Count: 8
var _DYN_CONCAT = "concat"; // Count: 6
var _DYN__MAX__BUFFER__SIZE = "MAX_BUFFER_SIZE"; // Count: 5
var _DYN_TRIGGER_SEND = "triggerSend"; // Count: 5
var _DYN_DIAG_LOG = "diagLog"; // Count: 16
var _DYN_INITIALIZE = "initialize"; // Count: 3
var _DYN__SENDER = "_sender"; // Count: 5
var _DYN_CUSTOM_HEADERS = "customHeaders"; // Count: 3
var _DYN_MAX_BATCH_SIZE_IN_BY1 = "maxBatchSizeInBytes"; // Count: 2
var _DYN_ONUNLOAD_DISABLE_BEA2 = "onunloadDisableBeacon"; // Count: 3
var _DYN_IS_BEACON_API_DISABL3 = "isBeaconApiDisabled"; // Count: 3
var _DYN_ALWAYS_USE_XHR_OVERR4 = "alwaysUseXhrOverride"; // Count: 2
var _DYN_DISABLE_XHR = "disableXhr"; // Count: 3
var _DYN_ENABLE_SESSION_STORA5 = "enableSessionStorageBuffer"; // Count: 2
var _DYN__BUFFER = "_buffer"; // Count: 9
var _DYN_ONUNLOAD_DISABLE_FET6 = "onunloadDisableFetch"; // Count: 2
var _DYN_DISABLE_SEND_BEACON_7 = "disableSendBeaconSplit"; // Count: 2
var _DYN_INSTRUMENTATION_KEY$1 = "instrumentationKey"; // Count: 2
var _DYN_ENABLE_SEND_PROMISE = "enableSendPromise"; // Count: 2
var _DYN_GET_SENDER_INST = "getSenderInst"; // Count: 4
var _DYN_UNLOAD_TRANSPORTS = "unloadTransports"; // Count: 2
var _DYN_CONVERT_UNDEFINED = "convertUndefined"; // Count: 2
var _DYN_MAX_BATCH_INTERVAL = "maxBatchInterval"; // Count: 2
var _DYN_SERIALIZE = "serialize"; // Count: 4
var _DYN__ON_ERROR = "_onError"; // Count: 7
var _DYN__ON_PARTIAL_SUCCESS = "_onPartialSuccess"; // Count: 3
var _DYN__ON_SUCCESS = "_onSuccess"; // Count: 6
var _DYN_ITEMS_RECEIVED = "itemsReceived"; // Count: 3
var _DYN_ITEMS_ACCEPTED = "itemsAccepted"; // Count: 3
var _DYN_ORI_PAYLOAD = "oriPayload"; // Count: 3
var _DYN_BASE_TYPE = "baseType"; // Count: 4
var _DYN_SAMPLE_RATE = "sampleRate"; // Count: 4
var _DYN_EVENTS_SEND_REQUEST = "eventsSendRequest"; // Count: 2
var _DYN_GET_SAMPLING_SCORE = "getSamplingScore"; // Count: 2
var _DYN_GET_HASH_CODE_SCORE = "getHashCodeScore"; // Count: 4

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
// these two constants are used to filter out properties not needed when trying to extract custom properties and measurements from the incoming payload
var strBaseType = "baseType";
var strBaseData = "baseData";
var strProperties = "properties";
var strTrue = "true";
function _setValueIf(target, field, value) {
    return setValue(target, field, value, isTruthy);
}
/*
 * Maps Part A data from CS 4.0
 */
function _extractPartAExtensions(logger, item, env) {
    // todo: switch to keys from common in this method
    var envTags = env[_DYN_TAGS /* @min:%2etags */] = env[_DYN_TAGS /* @min:%2etags */] || {};
    var itmExt = item.ext = item.ext || {};
    var itmTags = item[_DYN_TAGS /* @min:%2etags */] = item[_DYN_TAGS /* @min:%2etags */] || [];
    var extUser = itmExt.user;
    if (extUser) {
        _setValueIf(envTags, CtxTagKeys.userAuthUserId, extUser.authId);
        _setValueIf(envTags, CtxTagKeys.userId, extUser.id || extUser.localId);
    }
    var extApp = itmExt.app;
    if (extApp) {
        _setValueIf(envTags, CtxTagKeys.sessionId, extApp.sesId);
    }
    var extDevice = itmExt.device;
    if (extDevice) {
        _setValueIf(envTags, CtxTagKeys.deviceId, extDevice.id || extDevice.localId);
        _setValueIf(envTags, CtxTagKeys[_DYN_DEVICE_TYPE /* @min:%2edeviceType */], extDevice.deviceClass);
        _setValueIf(envTags, CtxTagKeys.deviceIp, extDevice.ip);
        _setValueIf(envTags, CtxTagKeys.deviceModel, extDevice.model);
        _setValueIf(envTags, CtxTagKeys[_DYN_DEVICE_TYPE /* @min:%2edeviceType */], extDevice[_DYN_DEVICE_TYPE /* @min:%2edeviceType */]);
    }
    var web = item.ext.web;
    if (web) {
        _setValueIf(envTags, CtxTagKeys.deviceLanguage, web.browserLang);
        _setValueIf(envTags, CtxTagKeys.deviceBrowserVersion, web.browserVer);
        _setValueIf(envTags, CtxTagKeys.deviceBrowser, web.browser);
        var envData = env[_DYN_DATA /* @min:%2edata */] = env[_DYN_DATA /* @min:%2edata */] || {};
        var envBaseData = envData[strBaseData] = envData[strBaseData] || {};
        var envProps = envBaseData[strProperties] = envBaseData[strProperties] || {};
        _setValueIf(envProps, "domain", web.domain);
        _setValueIf(envProps, "isManual", web.isManual ? strTrue : null);
        _setValueIf(envProps, "screenRes", web.screenRes);
        _setValueIf(envProps, "userConsent", web.userConsent ? strTrue : null);
    }
    var extOs = itmExt.os;
    if (extOs) {
        _setValueIf(envTags, CtxTagKeys.deviceOS, extOs[_DYN_NAME$1 /* @min:%2ename */]);
        _setValueIf(envTags, CtxTagKeys.deviceOSVersion, extOs.osVer);
    }
    // No support for mapping Trace.traceState to 2.0 as it is currently empty
    var extTrace = itmExt.trace;
    if (extTrace) {
        _setValueIf(envTags, CtxTagKeys.operationParentId, extTrace.parentID);
        _setValueIf(envTags, CtxTagKeys.operationName, dataSanitizeString(logger, extTrace[_DYN_NAME$1 /* @min:%2ename */]));
        _setValueIf(envTags, CtxTagKeys.operationId, extTrace[_DYN_TRACE_ID$1 /* @min:%2etraceID */]);
    }
    // Sample 4.0 schema
    //  {
    //     "time" : "2018-09-05T22:51:22.4936Z",
    //     "name" : "MetricWithNamespace",
    //     "iKey" : "ABC-5a4cbd20-e601-4ef5-a3c6-5d6577e4398e",
    //     "ext": {  "cloud": {
    //          "role": "WATSON3",
    //          "roleInstance": "CO4AEAP00000260"
    //      },
    //      "device": {}, "correlation": {} },
    //      "tags": [
    //        { "amazon.region" : "east2" },
    //        { "os.expid" : "wp:02df239" }
    //     ]
    //   }
    var tgs = {};
    // deals with tags.push({object})
    for (var i = itmTags[_DYN_LENGTH$2 /* @min:%2elength */] - 1; i >= 0; i--) {
        var tg = itmTags[i];
        objForEachKey(tg, function (key, value) {
            tgs[key] = value;
        });
        itmTags.splice(i, 1);
    }
    // deals with tags[key]=value (and handles hasOwnProperty)
    objForEachKey(itmTags, function (tg, value) {
        tgs[tg] = value;
    });
    var theTags = __assignFn(__assignFn({}, envTags), tgs);
    if (!theTags[CtxTagKeys.internalSdkVersion]) {
        // Append a version in case it is not already set
        theTags[CtxTagKeys.internalSdkVersion] = dataSanitizeString(logger, "javascript:".concat(EnvelopeCreator.Version), 64);
    }
    env[_DYN_TAGS /* @min:%2etags */] = optimizeObject(theTags);
}
function _extractPropsAndMeasurements(data, properties, measurements) {
    if (!isNullOrUndefined(data)) {
        objForEachKey(data, function (key, value) {
            if (isNumber(value)) {
                measurements[key] = value;
            }
            else if (isString(value)) {
                properties[key] = value;
            }
            else if (hasJSON()) {
                properties[key] = getJSON()[_DYN_STRINGIFY /* @min:%2estringify */](value);
            }
        });
    }
}
function _convertPropsUndefinedToCustomDefinedValue(properties, customUndefinedValue) {
    if (!isNullOrUndefined(properties)) {
        objForEachKey(properties, function (key, value) {
            properties[key] = value || customUndefinedValue;
        });
    }
}
// TODO: Do we want this to take logger as arg or use this._logger as nonstatic?
function _createEnvelope(logger, envelopeType, telemetryItem, data) {
    var envelope = new Envelope(logger, data, envelopeType);
    _setValueIf(envelope, "sampleRate", telemetryItem[SampleRate]);
    if ((telemetryItem[strBaseData] || {}).startTime) {
        // Starting from Version 3.0.3, the time property will be assigned by the startTime value,
        // which records the loadEvent time for the pageView event.
        envelope.time = toISOString(telemetryItem[strBaseData].startTime);
    }
    envelope.iKey = telemetryItem.iKey;
    var iKeyNoDashes = telemetryItem.iKey.replace(/-/g, "");
    envelope[_DYN_NAME$1 /* @min:%2ename */] = envelope[_DYN_NAME$1 /* @min:%2ename */].replace("{0}", iKeyNoDashes);
    // extract all extensions from ctx
    _extractPartAExtensions(logger, telemetryItem, envelope);
    // loop through the envelope tags (extension of Part A) and pick out the ones that should go in outgoing envelope tags
    telemetryItem[_DYN_TAGS /* @min:%2etags */] = telemetryItem[_DYN_TAGS /* @min:%2etags */] || [];
    return optimizeObject(envelope);
}
function EnvelopeCreatorInit(logger, telemetryItem) {
    if (isNullOrUndefined(telemetryItem[strBaseData])) {
        _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 46 /* _eInternalMessageId.TelemetryEnvelopeInvalid */, "telemetryItem.baseData cannot be null.");
    }
}
var EnvelopeCreator = {
    Version: '3.3.0'
};
function DependencyEnvelopeCreator(logger, telemetryItem, customUndefinedValue) {
    EnvelopeCreatorInit(logger, telemetryItem);
    var customMeasurements = telemetryItem[strBaseData][_DYN_MEASUREMENTS /* @min:%2emeasurements */] || {};
    var customProperties = telemetryItem[strBaseData][strProperties] || {};
    _extractPropsAndMeasurements(telemetryItem[_DYN_DATA /* @min:%2edata */], customProperties, customMeasurements);
    if (!isNullOrUndefined(customUndefinedValue)) {
        _convertPropsUndefinedToCustomDefinedValue(customProperties, customUndefinedValue);
    }
    var bd = telemetryItem[strBaseData];
    if (isNullOrUndefined(bd)) {
        _warnToConsole(logger, "Invalid input for dependency data");
        return null;
    }
    var method = bd[strProperties] && bd[strProperties][HttpMethod] ? bd[strProperties][HttpMethod] : "GET";
    var remoteDepData = new RemoteDependencyData(logger, bd.id, bd.target, bd[_DYN_NAME$1 /* @min:%2ename */], bd[STR_DURATION$1 /* @min:%2eduration */], bd.success, bd.responseCode, method, bd.type, bd.correlationContext, customProperties, customMeasurements);
    var data = new Data(RemoteDependencyData[_DYN_DATA_TYPE /* @min:%2edataType */], remoteDepData);
    return _createEnvelope(logger, RemoteDependencyData[_DYN_ENVELOPE_TYPE /* @min:%2eenvelopeType */], telemetryItem, data);
}
function EventEnvelopeCreator(logger, telemetryItem, customUndefinedValue) {
    EnvelopeCreatorInit(logger, telemetryItem);
    var customProperties = {};
    var customMeasurements = {};
    if (telemetryItem[strBaseType] !== Event$1[_DYN_DATA_TYPE /* @min:%2edataType */]) {
        customProperties["baseTypeSource"] = telemetryItem[strBaseType]; // save the passed in base type as a property
    }
    if (telemetryItem[strBaseType] === Event$1[_DYN_DATA_TYPE /* @min:%2edataType */]) { // take collection
        customProperties = telemetryItem[strBaseData][strProperties] || {};
        customMeasurements = telemetryItem[strBaseData][_DYN_MEASUREMENTS /* @min:%2emeasurements */] || {};
    }
    else { // if its not a known type, convert to custom event
        if (telemetryItem[strBaseData]) {
            _extractPropsAndMeasurements(telemetryItem[strBaseData], customProperties, customMeasurements);
        }
    }
    // Extract root level properties from part C telemetryItem.data
    _extractPropsAndMeasurements(telemetryItem[_DYN_DATA /* @min:%2edata */], customProperties, customMeasurements);
    if (!isNullOrUndefined(customUndefinedValue)) {
        _convertPropsUndefinedToCustomDefinedValue(customProperties, customUndefinedValue);
    }
    var eventName = telemetryItem[strBaseData][_DYN_NAME$1 /* @min:%2ename */];
    var eventData = new Event$1(logger, eventName, customProperties, customMeasurements);
    var data = new Data(Event$1[_DYN_DATA_TYPE /* @min:%2edataType */], eventData);
    return _createEnvelope(logger, Event$1[_DYN_ENVELOPE_TYPE /* @min:%2eenvelopeType */], telemetryItem, data);
}
function ExceptionEnvelopeCreator(logger, telemetryItem, customUndefinedValue) {
    EnvelopeCreatorInit(logger, telemetryItem);
    // Extract root level properties from part C telemetryItem.data
    var customMeasurements = telemetryItem[strBaseData][_DYN_MEASUREMENTS /* @min:%2emeasurements */] || {};
    var customProperties = telemetryItem[strBaseData][strProperties] || {};
    _extractPropsAndMeasurements(telemetryItem[_DYN_DATA /* @min:%2edata */], customProperties, customMeasurements);
    if (!isNullOrUndefined(customUndefinedValue)) {
        _convertPropsUndefinedToCustomDefinedValue(customProperties, customUndefinedValue);
    }
    var bd = telemetryItem[strBaseData];
    var exData = Exception.CreateFromInterface(logger, bd, customProperties, customMeasurements);
    var data = new Data(Exception[_DYN_DATA_TYPE /* @min:%2edataType */], exData);
    return _createEnvelope(logger, Exception[_DYN_ENVELOPE_TYPE /* @min:%2eenvelopeType */], telemetryItem, data);
}
function MetricEnvelopeCreator(logger, telemetryItem, customUndefinedValue) {
    EnvelopeCreatorInit(logger, telemetryItem);
    var baseData = telemetryItem[strBaseData];
    var props = baseData[strProperties] || {};
    var measurements = baseData[_DYN_MEASUREMENTS /* @min:%2emeasurements */] || {};
    _extractPropsAndMeasurements(telemetryItem[_DYN_DATA /* @min:%2edata */], props, measurements);
    if (!isNullOrUndefined(customUndefinedValue)) {
        _convertPropsUndefinedToCustomDefinedValue(props, customUndefinedValue);
    }
    var baseMetricData = new Metric(logger, baseData[_DYN_NAME$1 /* @min:%2ename */], baseData.average, baseData.sampleCount, baseData.min, baseData.max, baseData.stdDev, props, measurements);
    var data = new Data(Metric[_DYN_DATA_TYPE /* @min:%2edataType */], baseMetricData);
    return _createEnvelope(logger, Metric[_DYN_ENVELOPE_TYPE /* @min:%2eenvelopeType */], telemetryItem, data);
}
function PageViewEnvelopeCreator(logger, telemetryItem, customUndefinedValue) {
    EnvelopeCreatorInit(logger, telemetryItem);
    // Since duration is not part of the domain properties in Common Schema, extract it from part C
    var duration;
    var baseData = telemetryItem[strBaseData];
    if (!isNullOrUndefined(baseData) &&
        !isNullOrUndefined(baseData[strProperties]) &&
        !isNullOrUndefined(baseData[strProperties][STR_DURATION$1])) { // from part B properties
        duration = baseData[strProperties][STR_DURATION$1];
        delete baseData[strProperties][STR_DURATION$1];
    }
    else if (!isNullOrUndefined(telemetryItem[_DYN_DATA /* @min:%2edata */]) &&
        !isNullOrUndefined(telemetryItem[_DYN_DATA /* @min:%2edata */][STR_DURATION$1])) { // from custom properties
        duration = telemetryItem[_DYN_DATA /* @min:%2edata */][STR_DURATION$1];
        delete telemetryItem[_DYN_DATA /* @min:%2edata */][STR_DURATION$1];
    }
    var bd = telemetryItem[strBaseData];
    // special case: pageview.id is grabbed from current operation id. Analytics plugin is decoupled from properties plugin, so this is done here instead. This can be made a default telemetry intializer instead if needed to be decoupled from channel
    var currentContextId;
    if (((telemetryItem.ext || {}).trace || {})[_DYN_TRACE_ID$1 /* @min:%2etraceID */]) {
        currentContextId = telemetryItem.ext.trace[_DYN_TRACE_ID$1 /* @min:%2etraceID */];
    }
    var id = bd.id || currentContextId;
    var name = bd[_DYN_NAME$1 /* @min:%2ename */];
    var url = bd.uri;
    var properties = bd[strProperties] || {};
    var measurements = bd[_DYN_MEASUREMENTS /* @min:%2emeasurements */] || {};
    // refUri is a field that Breeze still does not recognize as part of Part B. For now, put it in Part C until it supports it as a domain property
    if (!isNullOrUndefined(bd.refUri)) {
        properties["refUri"] = bd.refUri;
    }
    // pageType is a field that Breeze still does not recognize as part of Part B. For now, put it in Part C until it supports it as a domain property
    if (!isNullOrUndefined(bd.pageType)) {
        properties["pageType"] = bd.pageType;
    }
    // isLoggedIn is a field that Breeze still does not recognize as part of Part B. For now, put it in Part C until it supports it as a domain property
    if (!isNullOrUndefined(bd.isLoggedIn)) {
        properties["isLoggedIn"] = bd.isLoggedIn[_DYN_TO_STRING /* @min:%2etoString */]();
    }
    // pageTags is a field that Breeze still does not recognize as part of Part B. For now, put it in Part C until it supports it as a domain property
    if (!isNullOrUndefined(bd[strProperties])) {
        var pageTags = bd[strProperties];
        objForEachKey(pageTags, function (key, value) {
            properties[key] = value;
        });
    }
    _extractPropsAndMeasurements(telemetryItem[_DYN_DATA /* @min:%2edata */], properties, measurements);
    if (!isNullOrUndefined(customUndefinedValue)) {
        _convertPropsUndefinedToCustomDefinedValue(properties, customUndefinedValue);
    }
    var pageViewData = new PageView(logger, name, url, duration, properties, measurements, id);
    var data = new Data(PageView[_DYN_DATA_TYPE /* @min:%2edataType */], pageViewData);
    return _createEnvelope(logger, PageView[_DYN_ENVELOPE_TYPE /* @min:%2eenvelopeType */], telemetryItem, data);
}
function PageViewPerformanceEnvelopeCreator(logger, telemetryItem, customUndefinedValue) {
    EnvelopeCreatorInit(logger, telemetryItem);
    var bd = telemetryItem[strBaseData];
    var name = bd[_DYN_NAME$1 /* @min:%2ename */];
    var url = bd.uri || bd.url;
    var properties = bd[strProperties] || {};
    var measurements = bd[_DYN_MEASUREMENTS /* @min:%2emeasurements */] || {};
    _extractPropsAndMeasurements(telemetryItem[_DYN_DATA /* @min:%2edata */], properties, measurements);
    if (!isNullOrUndefined(customUndefinedValue)) {
        _convertPropsUndefinedToCustomDefinedValue(properties, customUndefinedValue);
    }
    var baseData = new PageViewPerformance(logger, name, url, undefined, properties, measurements, bd);
    var data = new Data(PageViewPerformance[_DYN_DATA_TYPE /* @min:%2edataType */], baseData);
    return _createEnvelope(logger, PageViewPerformance[_DYN_ENVELOPE_TYPE /* @min:%2eenvelopeType */], telemetryItem, data);
}
function TraceEnvelopeCreator(logger, telemetryItem, customUndefinedValue) {
    EnvelopeCreatorInit(logger, telemetryItem);
    var message = telemetryItem[strBaseData].message;
    var severityLevel = telemetryItem[strBaseData].severityLevel;
    var props = telemetryItem[strBaseData][strProperties] || {};
    var measurements = telemetryItem[strBaseData][_DYN_MEASUREMENTS /* @min:%2emeasurements */] || {};
    _extractPropsAndMeasurements(telemetryItem[_DYN_DATA /* @min:%2edata */], props, measurements);
    if (!isNullOrUndefined(customUndefinedValue)) {
        _convertPropsUndefinedToCustomDefinedValue(props, customUndefinedValue);
    }
    var baseData = new Trace(logger, message, severityLevel, props, measurements);
    var data = new Data(Trace[_DYN_DATA_TYPE /* @min:%2edataType */], baseData);
    return _createEnvelope(logger, Trace[_DYN_ENVELOPE_TYPE /* @min:%2eenvelopeType */], telemetryItem, data);
}

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var BaseSendBuffer = /** @class */ (function () {
    function BaseSendBuffer(logger, config) {
        var _buffer = [];
        var _bufferFullMessageSent = false;
        var _maxRetryCnt = config.maxRetryCnt;
        this[_DYN__GET /* @min:%2e_get */] = function () {
            return _buffer;
        };
        this._set = function (buffer) {
            _buffer = buffer;
            return _buffer;
        };
        dynamicProto(BaseSendBuffer, this, function (_self) {
            _self[_DYN_ENQUEUE /* @min:%2eenqueue */] = function (payload) {
                if (_self[_DYN_COUNT /* @min:%2ecount */]() >= config[_DYN_EVENTS_LIMIT_IN_MEM /* @min:%2eeventsLimitInMem */]) {
                    // sent internal log only once per page view
                    if (!_bufferFullMessageSent) {
                        _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 105 /* _eInternalMessageId.InMemoryStorageBufferFull */, "Maximum in-memory buffer size reached: " + _self[_DYN_COUNT /* @min:%2ecount */](), true);
                        _bufferFullMessageSent = true;
                    }
                    return;
                }
                payload.cnt = payload.cnt || 0;
                // max retry is defined, and max retry is reached, do not add the payload to buffer
                if (!isNullOrUndefined(_maxRetryCnt)) {
                    if (payload.cnt > _maxRetryCnt) {
                        // TODO: add log here on dropping payloads
                        return;
                    }
                }
                _buffer[_DYN_PUSH /* @min:%2epush */](payload);
                return;
            };
            _self[_DYN_COUNT /* @min:%2ecount */] = function () {
                return _buffer[_DYN_LENGTH$2 /* @min:%2elength */];
            };
            _self.size = function () {
                var size = _buffer[_DYN_LENGTH$2 /* @min:%2elength */];
                for (var lp = 0; lp < _buffer[_DYN_LENGTH$2 /* @min:%2elength */]; lp++) {
                    size += (_buffer[lp].item)[_DYN_LENGTH$2 /* @min:%2elength */];
                }
                if (!config[_DYN_EMIT_LINE_DELIMITED_0 /* @min:%2eemitLineDelimitedJson */]) {
                    size += 2;
                }
                return size;
            };
            _self[_DYN_CLEAR /* @min:%2eclear */] = function () {
                _buffer = [];
                _bufferFullMessageSent = false;
            };
            _self.getItems = function () {
                return _buffer.slice(0);
            };
            _self.batchPayloads = function (payloads) {
                if (payloads && payloads[_DYN_LENGTH$2 /* @min:%2elength */] > 0) {
                    var payloadStr_1 = [];
                    arrForEach(payloads, function (payload) {
                        payloadStr_1[_DYN_PUSH /* @min:%2epush */](payload[_DYN_ITEM /* @min:%2eitem */]);
                    });
                    var batch = config[_DYN_EMIT_LINE_DELIMITED_0 /* @min:%2eemitLineDelimitedJson */] ?
                        payloadStr_1.join("\n") :
                        "[" + payloadStr_1.join(",") + "]";
                    return batch;
                }
                return null;
            };
            _self[_DYN_CREATE_NEW /* @min:%2ecreateNew */] = function (newLogger, newConfig, canUseSessionStorage) {
                var items = _buffer.slice(0);
                newLogger = newLogger || logger;
                newConfig = newConfig || {};
                var newBuffer = !!canUseSessionStorage ? new SessionStorageSendBuffer(newLogger, newConfig) : new ArraySendBuffer(newLogger, newConfig);
                arrForEach(items, function (payload) {
                    newBuffer[_DYN_ENQUEUE /* @min:%2eenqueue */](payload);
                });
                return newBuffer;
            };
        });
    }
// Removed Stub for BaseSendBuffer.prototype.enqueue.
// Removed Stub for BaseSendBuffer.prototype.count.
// Removed Stub for BaseSendBuffer.prototype.size.
// Removed Stub for BaseSendBuffer.prototype.clear.
// Removed Stub for BaseSendBuffer.prototype.getItems.
// Removed Stub for BaseSendBuffer.prototype.batchPayloads.
// Removed Stub for BaseSendBuffer.prototype.createNew.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    BaseSendBuffer.__ieDyn=1;

    return BaseSendBuffer;
}());
/*
 * An array based send buffer.
 */
var ArraySendBuffer = /** @class */ (function (_super) {
    __extendsFn(ArraySendBuffer, _super);
    function ArraySendBuffer(logger, config) {
        var _this = _super.call(this, logger, config) || this;
        dynamicProto(ArraySendBuffer, _this, function (_self, _base) {
            _self[_DYN_MARK_AS_SENT /* @min:%2emarkAsSent */] = function (payload) {
                _base[_DYN_CLEAR /* @min:%2eclear */]();
            };
            _self[_DYN_CLEAR_SENT /* @min:%2eclearSent */] = function (payload) {
                // not supported
            };
        });
        return _this;
    }
// Removed Stub for ArraySendBuffer.prototype.markAsSent.
// Removed Stub for ArraySendBuffer.prototype.clearSent.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    ArraySendBuffer.__ieDyn=1;

    return ArraySendBuffer;
}(BaseSendBuffer));
var PREVIOUS_KEYS = ["AI_buffer", "AI_sentBuffer"];
/*
 * Session storage buffer holds a copy of all unsent items in the browser session storage.
 */
var SessionStorageSendBuffer = /** @class */ (function (_super) {
    __extendsFn(SessionStorageSendBuffer, _super);
    function SessionStorageSendBuffer(logger, config) {
        var _this = _super.call(this, logger, config) || this;
        var _bufferFullMessageSent = false;
        //Note: should not use config.namePrefix directly, because it will always refers to the latest namePrefix
        var _namePrefix = config === null || config === void 0 ? void 0 : config.namePrefix;
        // TODO: add remove buffer override as well
        var _b = config[_DYN_BUFFER_OVERRIDE /* @min:%2ebufferOverride */] || { getItem: utlGetSessionStorage, setItem: utlSetSessionStorage }, getItem = _b.getItem, setItem = _b.setItem;
        var _maxRetryCnt = config.maxRetryCnt;
        dynamicProto(SessionStorageSendBuffer, _this, function (_self, _base) {
            var bufferItems = _getBuffer(SessionStorageSendBuffer[_DYN__BUFFER__KEY /* @min:%2eBUFFER_KEY */]);
            var itemsInSentBuffer = _getBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */]);
            var previousItems = _getPreviousEvents();
            var notDeliveredItems = itemsInSentBuffer[_DYN_CONCAT /* @min:%2econcat */](previousItems);
            var buffer = _self._set(bufferItems[_DYN_CONCAT /* @min:%2econcat */](notDeliveredItems));
            // If the buffer has too many items, drop items from the end.
            if (buffer[_DYN_LENGTH$2 /* @min:%2elength */] > SessionStorageSendBuffer[_DYN__MAX__BUFFER__SIZE /* @min:%2eMAX_BUFFER_SIZE */]) {
                buffer[_DYN_LENGTH$2 /* @min:%2elength */] = SessionStorageSendBuffer[_DYN__MAX__BUFFER__SIZE /* @min:%2eMAX_BUFFER_SIZE */];
            }
            _setBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */], []);
            _setBuffer(SessionStorageSendBuffer[_DYN__BUFFER__KEY /* @min:%2eBUFFER_KEY */], buffer);
            _self[_DYN_ENQUEUE /* @min:%2eenqueue */] = function (payload) {
                if (_self[_DYN_COUNT /* @min:%2ecount */]() >= SessionStorageSendBuffer[_DYN__MAX__BUFFER__SIZE /* @min:%2eMAX_BUFFER_SIZE */]) {
                    // sent internal log only once per page view
                    if (!_bufferFullMessageSent) {
                        _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 67 /* _eInternalMessageId.SessionStorageBufferFull */, "Maximum buffer size reached: " + _self[_DYN_COUNT /* @min:%2ecount */](), true);
                        _bufferFullMessageSent = true;
                    }
                    return;
                }
                payload.cnt = payload.cnt || 0;
                // max retry is defined, and max retry is reached, do not add the payload to buffer
                if (!isNullOrUndefined(_maxRetryCnt)) {
                    if (payload.cnt > _maxRetryCnt) {
                        // TODO: add log here on dropping payloads
                        return;
                    }
                }
                _base[_DYN_ENQUEUE /* @min:%2eenqueue */](payload);
                _setBuffer(SessionStorageSendBuffer.BUFFER_KEY, _self[_DYN__GET /* @min:%2e_get */]());
            };
            _self[_DYN_CLEAR /* @min:%2eclear */] = function () {
                _base[_DYN_CLEAR /* @min:%2eclear */]();
                _setBuffer(SessionStorageSendBuffer.BUFFER_KEY, _self[_DYN__GET /* @min:%2e_get */]());
                _setBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */], []);
                _bufferFullMessageSent = false;
            };
            _self[_DYN_MARK_AS_SENT /* @min:%2emarkAsSent */] = function (payload) {
                _setBuffer(SessionStorageSendBuffer[_DYN__BUFFER__KEY /* @min:%2eBUFFER_KEY */], _self._set(_removePayloadsFromBuffer(payload, _self[_DYN__GET /* @min:%2e_get */]())));
                var sentElements = _getBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */]);
                if (sentElements instanceof Array && payload instanceof Array) {
                    sentElements = sentElements[_DYN_CONCAT /* @min:%2econcat */](payload);
                    if (sentElements[_DYN_LENGTH$2 /* @min:%2elength */] > SessionStorageSendBuffer[_DYN__MAX__BUFFER__SIZE /* @min:%2eMAX_BUFFER_SIZE */]) {
                        // We send telemetry normally. If the SENT_BUFFER is too big we don't add new elements
                        // until we receive a response from the backend and the buffer has free space again (see clearSent method)
                        _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 67 /* _eInternalMessageId.SessionStorageBufferFull */, "Sent buffer reached its maximum size: " + sentElements[_DYN_LENGTH$2 /* @min:%2elength */], true);
                        sentElements[_DYN_LENGTH$2 /* @min:%2elength */] = SessionStorageSendBuffer[_DYN__MAX__BUFFER__SIZE /* @min:%2eMAX_BUFFER_SIZE */];
                    }
                    _setBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */], sentElements);
                }
            };
            _self[_DYN_CLEAR_SENT /* @min:%2eclearSent */] = function (payload) {
                var sentElements = _getBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */]);
                sentElements = _removePayloadsFromBuffer(payload, sentElements);
                _setBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */], sentElements);
            };
            _self[_DYN_CREATE_NEW /* @min:%2ecreateNew */] = function (newLogger, newConfig, canUseSessionStorage) {
                canUseSessionStorage = !!canUseSessionStorage;
                var unsentItems = _self[_DYN__GET /* @min:%2e_get */]().slice(0);
                var sentItems = _getBuffer(SessionStorageSendBuffer[_DYN__SENT__BUFFER__KEY /* @min:%2eSENT_BUFFER_KEY */]).slice(0);
                newLogger = newLogger || logger;
                newConfig = newConfig || {};
                // to make sure that we do not send duplicated payloads when it is switched back to previous one
                _self[_DYN_CLEAR /* @min:%2eclear */]();
                var newBuffer = canUseSessionStorage ? new SessionStorageSendBuffer(newLogger, newConfig) : new ArraySendBuffer(newLogger, newConfig);
                arrForEach(unsentItems, function (payload) {
                    newBuffer[_DYN_ENQUEUE /* @min:%2eenqueue */](payload);
                });
                if (canUseSessionStorage) {
                    // arr buffer will clear all payloads if markAsSent() is called
                    newBuffer[_DYN_MARK_AS_SENT /* @min:%2emarkAsSent */](sentItems);
                }
                return newBuffer;
            };
            function _removePayloadsFromBuffer(payloads, buffer) {
                var remaining = [];
                var payloadStr = [];
                arrForEach(payloads, function (payload) {
                    payloadStr[_DYN_PUSH /* @min:%2epush */](payload[_DYN_ITEM /* @min:%2eitem */]);
                });
                arrForEach(buffer, function (value) {
                    if (!isFunction(value) && arrIndexOf(payloadStr, value[_DYN_ITEM /* @min:%2eitem */]) === -1) {
                        remaining[_DYN_PUSH /* @min:%2epush */](value);
                    }
                });
                return remaining;
            }
            function _getBuffer(key) {
                var prefixedKey = key;
                prefixedKey = _namePrefix ? _namePrefix + "_" + prefixedKey : prefixedKey;
                return _getBufferBase(prefixedKey);
            }
            function _getBufferBase(key) {
                try {
                    var bufferJson = getItem(logger, key);
                    if (bufferJson) {
                        var buffer_1 = getJSON().parse(bufferJson);
                        if (isString(buffer_1)) {
                            // When using some version prototype.js the stringify / parse cycle does not decode array's correctly
                            buffer_1 = getJSON().parse(buffer_1);
                        }
                        if (buffer_1 && isArray(buffer_1)) {
                            return buffer_1;
                        }
                    }
                }
                catch (e) {
                    _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 42 /* _eInternalMessageId.FailedToRestoreStorageBuffer */, " storage key: " + key + ", " + getExceptionName(e), { exception: dumpObj(e) });
                }
                return [];
            }
            function _setBuffer(key, buffer) {
                var prefixedKey = key;
                try {
                    prefixedKey = _namePrefix ? _namePrefix + "_" + prefixedKey : prefixedKey;
                    var bufferJson = JSON[_DYN_STRINGIFY /* @min:%2estringify */](buffer);
                    setItem(logger, prefixedKey, bufferJson);
                }
                catch (e) {
                    // if there was an error, clear the buffer
                    // telemetry is stored in the _buffer array so we won't loose any items
                    setItem(logger, prefixedKey, JSON[_DYN_STRINGIFY /* @min:%2estringify */]([]));
                    _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 41 /* _eInternalMessageId.FailedToSetStorageBuffer */, " storage key: " + prefixedKey + ", " + getExceptionName(e) + ". Buffer cleared", { exception: dumpObj(e) });
                }
            }
            // this removes buffer with prefix+key
            function _getPreviousEvents() {
                var items = [];
                try {
                    arrForEach(PREVIOUS_KEYS, function (key) {
                        var events = _getItemsFromPreviousKey(key);
                        items = items[_DYN_CONCAT /* @min:%2econcat */](events);
                        // to make sure that we also transfer items from old prefixed + key buffer
                        if (_namePrefix) {
                            var prefixedKey = _namePrefix + "_" + key;
                            var prefixEvents = _getItemsFromPreviousKey(prefixedKey);
                            items = items[_DYN_CONCAT /* @min:%2econcat */](prefixEvents);
                        }
                    });
                    return items;
                }
                catch (e) {
                    _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 41 /* _eInternalMessageId.FailedToSetStorageBuffer */, "Transfer events from previous buffers: " + getExceptionName(e) + ". previous Buffer items can not be removed", { exception: dumpObj(e) });
                }
                return [];
            }
            // transform string[] to IInternalStorageItem[]
            function _getItemsFromPreviousKey(key) {
                try {
                    var items = _getBufferBase(key);
                    var transFormedItems_1 = [];
                    arrForEach(items, function (item) {
                        var internalItem = {
                            item: item,
                            cnt: 0 // previous events will be default to 0 count
                        };
                        transFormedItems_1[_DYN_PUSH /* @min:%2epush */](internalItem);
                    });
                    // remove the session storage if we can add events back
                    utlRemoveSessionStorage(logger, key);
                    return transFormedItems_1;
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return [];
            }
        });
        return _this;
    }
// Removed Stub for SessionStorageSendBuffer.prototype.enqueue.
// Removed Stub for SessionStorageSendBuffer.prototype.clear.
// Removed Stub for SessionStorageSendBuffer.prototype.markAsSent.
// Removed Stub for SessionStorageSendBuffer.prototype.clearSent.
// Removed Stub for SessionStorageSendBuffer.prototype.createNew.
    var _a;
    _a = SessionStorageSendBuffer;
    SessionStorageSendBuffer.VERSION = "_1";
    SessionStorageSendBuffer.BUFFER_KEY = "AI_buffer" + _a.VERSION;
    SessionStorageSendBuffer.SENT_BUFFER_KEY = "AI_sentBuffer" + _a.VERSION;
    // Maximum number of payloads stored in the buffer. If the buffer is full, new elements will be dropped.
    SessionStorageSendBuffer.MAX_BUFFER_SIZE = 2000;
    return SessionStorageSendBuffer;
}(BaseSendBuffer));

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var Serializer = /** @class */ (function () {
    function Serializer(logger) {
        dynamicProto(Serializer, this, function (_self) {
            /**
             * Serializes the current object to a JSON string.
             */
            _self[_DYN_SERIALIZE /* @min:%2eserialize */] = function (input) {
                var output = _serializeObject(input, "root");
                try {
                    return getJSON()[_DYN_STRINGIFY /* @min:%2estringify */](output);
                }
                catch (e) {
                    // if serialization fails return an empty string
                    _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 48 /* _eInternalMessageId.CannotSerializeObject */, (e && isFunction(e[_DYN_TO_STRING /* @min:%2etoString */])) ? e[_DYN_TO_STRING /* @min:%2etoString */]() : "Error serializing object", null, true);
                }
            };
            function _serializeObject(source, name) {
                var circularReferenceCheck = "__aiCircularRefCheck";
                var output = {};
                if (!source) {
                    _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 48 /* _eInternalMessageId.CannotSerializeObject */, "cannot serialize object because it is null or undefined", { name: name }, true);
                    return output;
                }
                if (source[circularReferenceCheck]) {
                    _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 50 /* _eInternalMessageId.CircularReferenceDetected */, "Circular reference detected while serializing object", { name: name }, true);
                    return output;
                }
                if (!source.aiDataContract) {
                    // special case for measurements/properties/tags
                    if (name === "measurements") {
                        output = _serializeStringMap(source, "number", name);
                    }
                    else if (name === "properties") {
                        output = _serializeStringMap(source, "string", name);
                    }
                    else if (name === "tags") {
                        output = _serializeStringMap(source, "string", name);
                    }
                    else if (isArray(source)) {
                        output = _serializeArray(source, name);
                    }
                    else {
                        _throwInternal(logger, 2 /* eLoggingSeverity.WARNING */, 49 /* _eInternalMessageId.CannotSerializeObjectNonSerializable */, "Attempting to serialize an object which does not implement ISerializable", { name: name }, true);
                        try {
                            // verify that the object can be stringified
                            getJSON()[_DYN_STRINGIFY /* @min:%2estringify */](source);
                            output = source;
                        }
                        catch (e) {
                            // if serialization fails return an empty string
                            _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 48 /* _eInternalMessageId.CannotSerializeObject */, (e && isFunction(e[_DYN_TO_STRING /* @min:%2etoString */])) ? e[_DYN_TO_STRING /* @min:%2etoString */]() : "Error serializing object", null, true);
                        }
                    }
                    return output;
                }
                source[circularReferenceCheck] = true;
                objForEachKey(source.aiDataContract, function (field, contract) {
                    var isRequired = (isFunction(contract)) ? (contract() & 1 /* FieldType.Required */) : (contract & 1 /* FieldType.Required */);
                    var isHidden = (isFunction(contract)) ? (contract() & 4 /* FieldType.Hidden */) : (contract & 4 /* FieldType.Hidden */);
                    var isArray = contract & 2 /* FieldType.Array */;
                    var isPresent = source[field] !== undefined;
                    var isObj = isObject(source[field]) && source[field] !== null;
                    if (isRequired && !isPresent && !isArray) {
                        _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 24 /* _eInternalMessageId.MissingRequiredFieldSpecification */, "Missing required field specification. The field is required but not present on source", { field: field, name: name });
                        // If not in debug mode, continue and hope the error is permissible
                    }
                    else if (!isHidden) { // Don't serialize hidden fields
                        var value = void 0;
                        if (isObj) {
                            if (isArray) {
                                // special case; recurse on each object in the source array
                                value = _serializeArray(source[field], field);
                            }
                            else {
                                // recurse on the source object in this field
                                value = _serializeObject(source[field], field);
                            }
                        }
                        else {
                            // assign the source field to the output even if undefined or required
                            value = source[field];
                        }
                        // only emit this field if the value is defined
                        if (value !== undefined) {
                            output[field] = value;
                        }
                    }
                });
                delete source[circularReferenceCheck];
                return output;
            }
            function _serializeArray(sources, name) {
                var output;
                if (!!sources) {
                    if (!isArray(sources)) {
                        _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, 54 /* _eInternalMessageId.ItemNotInArray */, "This field was specified as an array in the contract but the item is not an array.\r\n", { name: name }, true);
                    }
                    else {
                        output = [];
                        for (var i = 0; i < sources[_DYN_LENGTH$2 /* @min:%2elength */]; i++) {
                            var source = sources[i];
                            var item = _serializeObject(source, name + "[" + i + "]");
                            output[_DYN_PUSH /* @min:%2epush */](item);
                        }
                    }
                }
                return output;
            }
            function _serializeStringMap(map, expectedType, name) {
                var output;
                if (map) {
                    output = {};
                    objForEachKey(map, function (field, value) {
                        if (expectedType === "string") {
                            if (value === undefined) {
                                output[field] = "undefined";
                            }
                            else if (value === null) {
                                output[field] = "null";
                            }
                            else if (!value[_DYN_TO_STRING /* @min:%2etoString */]) {
                                output[field] = "invalid field: toString() is not defined.";
                            }
                            else {
                                output[field] = value[_DYN_TO_STRING /* @min:%2etoString */]();
                            }
                        }
                        else if (expectedType === "number") {
                            if (value === undefined) {
                                output[field] = "undefined";
                            }
                            else if (value === null) {
                                output[field] = "null";
                            }
                            else {
                                var num = parseFloat(value);
                                output[field] = num;
                            }
                        }
                        else {
                            output[field] = "invalid field: " + name + " is of unknown type.";
                            _throwInternal(logger, 1 /* eLoggingSeverity.CRITICAL */, output[field], null, true);
                        }
                    });
                }
                return output;
            }
        });
    }
// Removed Stub for Serializer.prototype.serialize.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    Serializer.__ieDyn=1;

    return Serializer;
}());

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

// (Magic number) DJB algorithm can't work on shorter strings (results in poor distribution
var MIN_INPUT_LENGTH = 8;
var HashCodeScoreGenerator = /** @class */ (function () {
    function HashCodeScoreGenerator() {
    }
    HashCodeScoreGenerator.prototype.getHashCodeScore = function (key) {
        var score = this.getHashCode(key) / HashCodeScoreGenerator.INT_MAX_VALUE;
        return score * 100;
    };
    HashCodeScoreGenerator.prototype.getHashCode = function (input) {
        if (input === "") {
            return 0;
        }
        while (input[_DYN_LENGTH$2 /* @min:%2elength */] < MIN_INPUT_LENGTH) {
            input = input[_DYN_CONCAT /* @min:%2econcat */](input);
        }
        // 5381 is a magic number: http://stackoverflow.com/questions/10696223/reason-for-5381-number-in-djb-hash-function
        var hash = 5381;
        for (var i = 0; i < input[_DYN_LENGTH$2 /* @min:%2elength */]; ++i) {
            hash = ((hash << 5) + hash) + input.charCodeAt(i);
            // 'hash' is of number type which means 53 bit integer (http://www.ecma-international.org/ecma-262/6.0/#sec-ecmascript-language-types-number-type)
            // 'hash & hash' will keep it 32 bit integer - just to make it clearer what the result is.
            hash = hash & hash;
        }
        return Math.abs(hash);
    };
    // We're using 32 bit math, hence max value is (2^31 - 1)
    HashCodeScoreGenerator.INT_MAX_VALUE = 2147483647;
    return HashCodeScoreGenerator;
}());

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var SamplingScoreGenerator = /** @class */ (function () {
    function SamplingScoreGenerator() {
        var _self = this;
        var hashCodeGenerator = new HashCodeScoreGenerator();
        var keys = new ContextTagKeys();
        _self[_DYN_GET_SAMPLING_SCORE /* @min:%2egetSamplingScore */] = function (item) {
            var score = 0;
            if (item[_DYN_TAGS /* @min:%2etags */] && item[_DYN_TAGS /* @min:%2etags */][keys.userId]) { // search in tags first, then ext
                score = hashCodeGenerator.getHashCodeScore(item[_DYN_TAGS /* @min:%2etags */][keys.userId]);
            }
            else if (item.ext && item.ext.user && item.ext.user.id) {
                score = hashCodeGenerator[_DYN_GET_HASH_CODE_SCORE /* @min:%2egetHashCodeScore */](item.ext.user.id);
            }
            else if (item[_DYN_TAGS /* @min:%2etags */] && item[_DYN_TAGS /* @min:%2etags */][keys.operationId]) { // search in tags first, then ext
                score = hashCodeGenerator.getHashCodeScore(item[_DYN_TAGS /* @min:%2etags */][keys.operationId]);
            }
            else if (item.ext && item.ext.telemetryTrace && item.ext.telemetryTrace[_DYN_TRACE_ID$1 /* @min:%2etraceID */]) {
                score = hashCodeGenerator.getHashCodeScore(item.ext.telemetryTrace[_DYN_TRACE_ID$1 /* @min:%2etraceID */]);
            }
            else {
                // tslint:disable-next-line:insecure-random
                score = (Math.random() * 100);
            }
            return score;
        };
    }
    return SamplingScoreGenerator;
}());

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var Sample = /** @class */ (function () {
    function Sample(sampleRate, logger) {
        // We're using 32 bit math, hence max value is (2^31 - 1)
        this.INT_MAX_VALUE = 2147483647;
        var _logger = logger || safeGetLogger(null);
        if (sampleRate > 100 || sampleRate < 0) {
            _logger.throwInternal(2 /* eLoggingSeverity.WARNING */, 58 /* _eInternalMessageId.SampleRateOutOfRange */, "Sampling rate is out of range (0..100). Sampling will be disabled, you may be sending too much data which may affect your AI service level.", { samplingRate: sampleRate }, true);
            sampleRate = 100;
        }
        this[_DYN_SAMPLE_RATE /* @min:%2esampleRate */] = sampleRate;
        this.samplingScoreGenerator = new SamplingScoreGenerator();
    }
    /**
    * Determines if an envelope is sampled in (i.e. will be sent) or not (i.e. will be dropped).
    */
    Sample.prototype.isSampledIn = function (envelope) {
        var samplingPercentage = this[_DYN_SAMPLE_RATE /* @min:%2esampleRate */]; // 0 - 100
        var isSampledIn = false;
        if (samplingPercentage === null || samplingPercentage === undefined || samplingPercentage >= 100) {
            return true;
        }
        else if (envelope.baseType === Metric[_DYN_DATA_TYPE /* @min:%2edataType */]) {
            // exclude MetricData telemetry from sampling
            return true;
        }
        isSampledIn = this.samplingScoreGenerator[_DYN_GET_SAMPLING_SCORE /* @min:%2egetSamplingScore */](envelope) < samplingPercentage;
        return isSampledIn;
    };
    return Sample;
}());

/*
 * Application Insights JavaScript SDK - Channel, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
var _a$3, _b$1;
var UNDEFINED_VALUE$1 = undefined;
var EMPTY_STR = "";
var FetchSyncRequestSizeLimitBytes = 65000; // approx 64kb (the current Edge, Firefox and Chrome max limit)
function _getResponseText(xhr) {
    try {
        return xhr.responseText;
    }
    catch (e) {
        // Best effort, as XHR may throw while XDR wont so just ignore
    }
    return null;
}
function isOverrideFn(httpXHROverride) {
    return httpXHROverride && httpXHROverride.sendPOST;
}
var defaultAppInsightsChannelConfig = objDeepFreeze((_a$3 = {
        // Use the default value (handles empty string in the configuration)
        endpointUrl: cfgDfValidate(isTruthy, DEFAULT_BREEZE_ENDPOINT + DEFAULT_BREEZE_PATH)
    },
    _a$3[_DYN_EMIT_LINE_DELIMITED_0 /* @min:emitLineDelimitedJson */] = cfgDfBoolean(),
    _a$3[_DYN_MAX_BATCH_INTERVAL /* @min:maxBatchInterval */] = 15000,
    _a$3[_DYN_MAX_BATCH_SIZE_IN_BY1 /* @min:maxBatchSizeInBytes */] = 102400,
    _a$3.disableTelemetry = cfgDfBoolean(),
    _a$3[_DYN_ENABLE_SESSION_STORA5 /* @min:enableSessionStorageBuffer */] = cfgDfBoolean(true),
    _a$3.isRetryDisabled = cfgDfBoolean(),
    _a$3[_DYN_IS_BEACON_API_DISABL3 /* @min:isBeaconApiDisabled */] = cfgDfBoolean(true),
    _a$3[_DYN_DISABLE_SEND_BEACON_7 /* @min:disableSendBeaconSplit */] = cfgDfBoolean(true),
    _a$3[_DYN_DISABLE_XHR /* @min:disableXhr */] = cfgDfBoolean(),
    _a$3[_DYN_ONUNLOAD_DISABLE_FET6 /* @min:onunloadDisableFetch */] = cfgDfBoolean(),
    _a$3[_DYN_ONUNLOAD_DISABLE_BEA2 /* @min:onunloadDisableBeacon */] = cfgDfBoolean(),
    _a$3[_DYN_INSTRUMENTATION_KEY$1 /* @min:instrumentationKey */] = UNDEFINED_VALUE$1,
    _a$3.namePrefix = UNDEFINED_VALUE$1,
    _a$3.samplingPercentage = cfgDfValidate(_chkSampling, 100),
    _a$3[_DYN_CUSTOM_HEADERS /* @min:customHeaders */] = UNDEFINED_VALUE$1,
    _a$3[_DYN_CONVERT_UNDEFINED /* @min:convertUndefined */] = UNDEFINED_VALUE$1,
    _a$3[_DYN_EVENTS_LIMIT_IN_MEM /* @min:eventsLimitInMem */] = 10000,
    _a$3[_DYN_BUFFER_OVERRIDE /* @min:bufferOverride */] = false,
    _a$3.httpXHROverride = { isVal: isOverrideFn, v: UNDEFINED_VALUE$1 },
    _a$3[_DYN_ALWAYS_USE_XHR_OVERR4 /* @min:alwaysUseXhrOverride */] = cfgDfBoolean(),
    _a$3.transports = UNDEFINED_VALUE$1,
    _a$3.retryCodes = UNDEFINED_VALUE$1,
    _a$3.maxRetryCnt = { isVal: isNumber, v: 10 },
    _a$3));
function _chkSampling(value) {
    return !isNaN(value) && value > 0 && value <= 100;
}
var EnvelopeTypeCreator = (_b$1 = {},
    _b$1[Event$1.dataType] = EventEnvelopeCreator,
    _b$1[Trace.dataType] = TraceEnvelopeCreator,
    _b$1[PageView.dataType] = PageViewEnvelopeCreator,
    _b$1[PageViewPerformance.dataType] = PageViewPerformanceEnvelopeCreator,
    _b$1[Exception.dataType] = ExceptionEnvelopeCreator,
    _b$1[Metric.dataType] = MetricEnvelopeCreator,
    _b$1[RemoteDependencyData.dataType] = DependencyEnvelopeCreator,
    _b$1);
var Sender = /** @class */ (function (_super) {
    __extendsFn(Sender, _super);
    function Sender() {
        var _this = _super.call(this) || this;
        _this.priority = 1001;
        _this.identifier = BreezeChannelIdentifier;
        // Don't set the defaults here, set them in the _initDefaults() as this is also called during unload
        var _consecutiveErrors; // How many times in a row a retryable error condition has occurred.
        var _retryAt; // The time to retry at in milliseconds from 1970/01/01 (this makes the timer calculation easy).
        var _paused; // Flag indicating that the sending should be paused
        var _timeoutHandle; // Handle to the timer for delayed sending of batches of data.
        var _serializer;
        var _stamp_specific_redirects;
        var _headers;
        var _syncFetchPayload = 0; // Keep track of the outstanding sync fetch payload total (as sync fetch has limits)
        var _syncUnloadSender; // The identified sender to use for the synchronous unload stage
        var _offlineListener;
        var _evtNamespace;
        var _endpointUrl;
        var _orgEndpointUrl;
        var _maxBatchSizeInBytes;
        var _beaconSupported;
        var _beaconOnUnloadSupported;
        var _beaconNormalSupported;
        var _customHeaders;
        var _disableTelemetry;
        var _instrumentationKey;
        var _convertUndefined;
        var _isRetryDisabled;
        var _maxBatchInterval;
        var _sessionStorageUsed;
        var _bufferOverrideUsed;
        var _namePrefix;
        var _enableSendPromise;
        var _alwaysUseCustomSend;
        var _disableXhr;
        var _fetchKeepAlive;
        var _xhrSend;
        var _fallbackSend;
        var _disableBeaconSplit;
        var _sendPostMgr;
        var _retryCodes;
        dynamicProto(Sender, _this, function (_self, _base) {
            _initDefaults();
            _self.pause = function () {
                _clearScheduledTimer();
                _paused = true;
            };
            _self.resume = function () {
                if (_paused) {
                    _paused = false;
                    _retryAt = null;
                    // flush if we have exceeded the max-size already
                    _checkMaxSize();
                    _setupTimer();
                }
            };
            _self.flush = function (isAsync, callBack, sendReason) {
                if (isAsync === void 0) { isAsync = true; }
                if (!_paused) {
                    // Clear the normal schedule timer as we are going to try and flush ASAP
                    _clearScheduledTimer();
                    try {
                        return _self[_DYN_TRIGGER_SEND /* @min:%2etriggerSend */](isAsync, null, sendReason || 1 /* SendRequestReason.ManualFlush */);
                    }
                    catch (e) {
                        _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 1 /* eLoggingSeverity.CRITICAL */, 22 /* _eInternalMessageId.FlushFailed */, "flush failed, telemetry will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                    }
                }
            };
            _self.onunloadFlush = function () {
                if (!_paused) {
                    if (_beaconSupported || _alwaysUseCustomSend) {
                        try {
                            return _self[_DYN_TRIGGER_SEND /* @min:%2etriggerSend */](true, _doUnloadSend, 2 /* SendRequestReason.Unload */);
                        }
                        catch (e) {
                            _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 1 /* eLoggingSeverity.CRITICAL */, 20 /* _eInternalMessageId.FailedToSendQueuedTelemetry */, "failed to flush with beacon sender on page unload, telemetry will not be collected: " + getExceptionName(e), { exception: dumpObj(e) });
                        }
                    }
                    else {
                        _self.flush(false);
                    }
                }
            };
            _self.addHeader = function (name, value) {
                _headers[name] = value;
            };
            _self[_DYN_INITIALIZE /* @min:%2einitialize */] = function (config, core, extensions, pluginChain) {
                if (_self.isInitialized()) {
                    _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 1 /* eLoggingSeverity.CRITICAL */, 28 /* _eInternalMessageId.SenderNotInitialized */, "Sender is already initialized");
                }
                _base[_DYN_INITIALIZE /* @min:%2einitialize */](config, core, extensions, pluginChain);
                var identifier = _self.identifier;
                _serializer = new Serializer(core.logger);
                _consecutiveErrors = 0;
                _retryAt = null;
                _self[_DYN__SENDER /* @min:%2e_sender */] = null;
                _stamp_specific_redirects = 0;
                var diagLog = _self[_DYN_DIAG_LOG /* @min:%2ediagLog */]();
                _evtNamespace = mergeEvtNamespace(createUniqueNamespace("Sender"), core.evtNamespace && core.evtNamespace());
                _offlineListener = createOfflineListener(_evtNamespace);
                // This function will be re-called whenever any referenced configuration is changed
                _self._addHook(onConfigChange(config, function (details) {
                    var config = details.cfg;
                    if (config.storagePrefix) {
                        utlSetStoragePrefix(config.storagePrefix);
                    }
                    var ctx = createProcessTelemetryContext(null, config, core);
                    var senderConfig = ctx.getExtCfg(identifier, defaultAppInsightsChannelConfig);
                    objDefine(_self, "_senderConfig", {
                        g: function () {
                            return senderConfig;
                        }
                    });
                    // or is not string
                    if (core.activeStatus() === ActiveStatus.PENDING) {
                        // waiting for core promises to be resolved
                        // NOTE: if active status is set to pending, stop sending, clear timer here
                        _self.pause();
                    }
                    else if (core.activeStatus() === ActiveStatus.ACTIVE) {
                        // core status changed from pending to other status
                        _self.resume();
                    }
                    // Only update the endpoint if the original config !== the current config
                    // This is so any redirect endpointUrl is not overwritten
                    if (_orgEndpointUrl !== senderConfig.endpointUrl) {
                        _endpointUrl = _orgEndpointUrl = senderConfig.endpointUrl;
                    }
                    if (_customHeaders && _customHeaders !== senderConfig[_DYN_CUSTOM_HEADERS /* @min:%2ecustomHeaders */]) {
                        // Removing any previously defined custom headers as they have changed
                        arrForEach(_customHeaders, function (customHeader) {
                            delete _headers[customHeader.header];
                        });
                    }
                    _maxBatchSizeInBytes = senderConfig[_DYN_MAX_BATCH_SIZE_IN_BY1 /* @min:%2emaxBatchSizeInBytes */];
                    _beaconSupported = (senderConfig[_DYN_ONUNLOAD_DISABLE_BEA2 /* @min:%2eonunloadDisableBeacon */] === false || senderConfig[_DYN_IS_BEACON_API_DISABL3 /* @min:%2eisBeaconApiDisabled */] === false) && isBeaconsSupported();
                    _beaconOnUnloadSupported = senderConfig[_DYN_ONUNLOAD_DISABLE_BEA2 /* @min:%2eonunloadDisableBeacon */] === false && isBeaconsSupported();
                    _beaconNormalSupported = senderConfig[_DYN_IS_BEACON_API_DISABL3 /* @min:%2eisBeaconApiDisabled */] === false && isBeaconsSupported();
                    _alwaysUseCustomSend = senderConfig[_DYN_ALWAYS_USE_XHR_OVERR4 /* @min:%2ealwaysUseXhrOverride */];
                    _disableXhr = !!senderConfig[_DYN_DISABLE_XHR /* @min:%2edisableXhr */];
                    _retryCodes = senderConfig.retryCodes;
                    var bufferOverride = senderConfig[_DYN_BUFFER_OVERRIDE /* @min:%2ebufferOverride */];
                    var canUseSessionStorage = !!senderConfig[_DYN_ENABLE_SESSION_STORA5 /* @min:%2eenableSessionStorageBuffer */] &&
                        (!!bufferOverride || utlCanUseSessionStorage());
                    var namePrefix = senderConfig.namePrefix;
                    //Note: emitLineDelimitedJson and eventsLimitInMem is directly accessed via config in senderBuffer
                    //Therefore, if canUseSessionStorage is not changed, we do not need to re initialize a new one
                    var shouldUpdate = (canUseSessionStorage !== _sessionStorageUsed)
                        || (canUseSessionStorage && (_namePrefix !== namePrefix)) // prefixName is only used in session storage
                        || (canUseSessionStorage && (_bufferOverrideUsed !== bufferOverride));
                    if (_self[_DYN__BUFFER /* @min:%2e_buffer */]) {
                        // case1 (Pre and Now enableSessionStorageBuffer settings are same)
                        // if namePrefix changes, transfer current buffer to new buffer
                        // else no action needed
                        //case2 (Pre and Now enableSessionStorageBuffer settings are changed)
                        // transfer current buffer to new buffer
                        if (shouldUpdate) {
                            try {
                                _self._buffer = _self._buffer[_DYN_CREATE_NEW /* @min:%2ecreateNew */](diagLog, senderConfig, canUseSessionStorage);
                            }
                            catch (e) {
                                _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 1 /* eLoggingSeverity.CRITICAL */, 12 /* _eInternalMessageId.FailedAddingTelemetryToBuffer */, "failed to transfer telemetry to different buffer storage, telemetry will be lost: " + getExceptionName(e), { exception: dumpObj(e) });
                            }
                        }
                        _checkMaxSize();
                    }
                    else {
                        _self[_DYN__BUFFER /* @min:%2e_buffer */] = canUseSessionStorage
                            ? new SessionStorageSendBuffer(diagLog, senderConfig) : new ArraySendBuffer(diagLog, senderConfig);
                    }
                    _namePrefix = namePrefix;
                    _sessionStorageUsed = canUseSessionStorage;
                    _bufferOverrideUsed = bufferOverride;
                    _fetchKeepAlive = !senderConfig[_DYN_ONUNLOAD_DISABLE_FET6 /* @min:%2eonunloadDisableFetch */] && isFetchSupported(true);
                    _disableBeaconSplit = !!senderConfig[_DYN_DISABLE_SEND_BEACON_7 /* @min:%2edisableSendBeaconSplit */];
                    _self._sample = new Sample(senderConfig.samplingPercentage, diagLog);
                    _instrumentationKey = senderConfig[_DYN_INSTRUMENTATION_KEY$1 /* @min:%2einstrumentationKey */];
                    if (!_validateInstrumentationKey(_instrumentationKey, config)) {
                        _throwInternal(diagLog, 1 /* eLoggingSeverity.CRITICAL */, 100 /* _eInternalMessageId.InvalidInstrumentationKey */, "Invalid Instrumentation key " + _instrumentationKey);
                    }
                    _customHeaders = senderConfig[_DYN_CUSTOM_HEADERS /* @min:%2ecustomHeaders */];
                    if (isString(_endpointUrl) && !isInternalApplicationInsightsEndpoint(_endpointUrl) && _customHeaders && _customHeaders[_DYN_LENGTH$2 /* @min:%2elength */] > 0) {
                        arrForEach(_customHeaders, function (customHeader) {
                            _this.addHeader(customHeader.header, customHeader.value);
                        });
                    }
                    else {
                        _customHeaders = null;
                    }
                    _enableSendPromise = senderConfig[_DYN_ENABLE_SEND_PROMISE /* @min:%2eenableSendPromise */];
                    var sendPostConfig = _getSendPostMgrConfig();
                    // only init it once
                    if (!_sendPostMgr) {
                        _sendPostMgr = new SenderPostManager();
                        _sendPostMgr[_DYN_INITIALIZE /* @min:%2einitialize */](sendPostConfig, diagLog);
                    }
                    else {
                        _sendPostMgr.SetConfig(sendPostConfig);
                    }
                    var customInterface = senderConfig.httpXHROverride;
                    var httpInterface = null;
                    var syncInterface = null;
                    // User requested transport(s) values > Beacon > Fetch > XHR
                    // Beacon would be filtered out if user has set disableBeaconApi to true at _getSenderInterface
                    var theTransports = prependTransports([3 /* TransportType.Beacon */, 1 /* TransportType.Xhr */, 2 /* TransportType.Fetch */], senderConfig.transports);
                    httpInterface = _sendPostMgr && _sendPostMgr[_DYN_GET_SENDER_INST /* @min:%2egetSenderInst */](theTransports, false);
                    var xhrInterface = _sendPostMgr && _sendPostMgr.getFallbackInst();
                    _xhrSend = function (payload, isAsync) {
                        return _doSend(xhrInterface, payload, isAsync);
                    };
                    _fallbackSend = function (payload, isAsync) {
                        return _doSend(xhrInterface, payload, isAsync, false);
                    };
                    httpInterface = _alwaysUseCustomSend ? customInterface : (httpInterface || customInterface || xhrInterface);
                    _self[_DYN__SENDER /* @min:%2e_sender */] = function (payload, isAsync) {
                        return _doSend(httpInterface, payload, isAsync);
                    };
                    if (_fetchKeepAlive) {
                        // Try and use the fetch with keepalive
                        _syncUnloadSender = _fetchKeepAliveSender;
                    }
                    var syncTransports = prependTransports([3 /* TransportType.Beacon */, 1 /* TransportType.Xhr */], senderConfig[_DYN_UNLOAD_TRANSPORTS /* @min:%2eunloadTransports */]);
                    if (!_fetchKeepAlive) {
                        // remove fetch from theTransports
                        syncTransports = syncTransports.filter(function (transport) { return transport !== 2 /* TransportType.Fetch */; });
                    }
                    syncInterface = _sendPostMgr && _sendPostMgr[_DYN_GET_SENDER_INST /* @min:%2egetSenderInst */](syncTransports, true);
                    syncInterface = _alwaysUseCustomSend ? customInterface : (syncInterface || customInterface);
                    if ((_alwaysUseCustomSend || senderConfig[_DYN_UNLOAD_TRANSPORTS /* @min:%2eunloadTransports */] || !_syncUnloadSender) && syncInterface) {
                        _syncUnloadSender = function (payload, isAsync) {
                            return _doSend(syncInterface, payload, isAsync);
                        };
                    }
                    if (!_syncUnloadSender) {
                        _syncUnloadSender = _xhrSend;
                    }
                    _disableTelemetry = senderConfig.disableTelemetry;
                    _convertUndefined = senderConfig[_DYN_CONVERT_UNDEFINED /* @min:%2econvertUndefined */] || UNDEFINED_VALUE$1;
                    _isRetryDisabled = senderConfig.isRetryDisabled;
                    _maxBatchInterval = senderConfig[_DYN_MAX_BATCH_INTERVAL /* @min:%2emaxBatchInterval */];
                }));
            };
            _self.processTelemetry = function (telemetryItem, itemCtx) {
                var _a;
                itemCtx = _self._getTelCtx(itemCtx);
                var diagLogger = itemCtx[_DYN_DIAG_LOG /* @min:%2ediagLog */]();
                try {
                    var isValidate = _validate(telemetryItem, diagLogger);
                    if (!isValidate) {
                        return;
                    }
                    var aiEnvelope = _getEnvelope(telemetryItem, diagLogger);
                    if (!aiEnvelope) {
                        return;
                    }
                    // check if the incoming payload is too large, truncate if necessary
                    var payload = _serializer[_DYN_SERIALIZE /* @min:%2eserialize */](aiEnvelope);
                    // flush if we would exceed the max-size limit by adding this item
                    var buffer = _self[_DYN__BUFFER /* @min:%2e_buffer */];
                    _checkMaxSize(payload);
                    var payloadItem = (_a = {},
                        _a[_DYN_ITEM /* @min:item */] = payload,
                        _a.cnt = 0 // inital cnt will always be 0
                    ,
                        _a);
                    // enqueue the payload
                    buffer[_DYN_ENQUEUE /* @min:%2eenqueue */](payloadItem);
                    // ensure an invocation timeout is set
                    _setupTimer();
                }
                catch (e) {
                    _throwInternal(diagLogger, 2 /* eLoggingSeverity.WARNING */, 12 /* _eInternalMessageId.FailedAddingTelemetryToBuffer */, "Failed adding telemetry to the sender's buffer, some telemetry will be lost: " + getExceptionName(e), { exception: dumpObj(e) });
                }
                // hand off the telemetry item to the next plugin
                _self.processNext(telemetryItem, itemCtx);
            };
            _self.isCompletelyIdle = function () {
                return !_paused && _syncFetchPayload === 0 && _self._buffer[_DYN_COUNT /* @min:%2ecount */]() === 0;
            };
            /**
             * xhr state changes
             */
            _self._xhrReadyStateChange = function (xhr, payload, countOfItemsInPayload) {
                // since version 3.2.0, this function is no-op
                if (_isStringArr(payload)) {
                    return;
                }
                return _xhrReadyStateChange(xhr, payload, countOfItemsInPayload);
            };
            /**
             * Immediately send buffered data
             * @param async - {boolean} - Indicates if the events should be sent asynchronously
             * @param forcedSender - {SenderFunction} - Indicates the forcedSender, undefined if not passed
             */
            _self[_DYN_TRIGGER_SEND /* @min:%2etriggerSend */] = function (async, forcedSender, sendReason) {
                if (async === void 0) { async = true; }
                var result;
                if (!_paused) {
                    try {
                        var buffer = _self[_DYN__BUFFER /* @min:%2e_buffer */];
                        // Send data only if disableTelemetry is false
                        if (!_disableTelemetry) {
                            if (buffer[_DYN_COUNT /* @min:%2ecount */]() > 0) {
                                var payload = buffer.getItems();
                                _notifySendRequest(sendReason || 0 /* SendRequestReason.Undefined */, async);
                                // invoke send
                                if (forcedSender) {
                                    result = forcedSender.call(_self, payload, async);
                                }
                                else {
                                    result = _self[_DYN__SENDER /* @min:%2e_sender */](payload, async);
                                }
                            }
                        }
                        else {
                            buffer[_DYN_CLEAR /* @min:%2eclear */]();
                        }
                        _clearScheduledTimer();
                    }
                    catch (e) {
                        /* Ignore this error for IE under v10 */
                        var ieVer = getIEVersion();
                        if (!ieVer || ieVer > 9) {
                            _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 1 /* eLoggingSeverity.CRITICAL */, 40 /* _eInternalMessageId.TransmissionFailed */, "Telemetry transmission failed, some telemetry will be lost: " + getExceptionName(e), { exception: dumpObj(e) });
                        }
                    }
                }
                return result;
            };
            _self.getOfflineSupport = function () {
                var _a;
                return _a = {
                        getUrl: function () {
                            return _endpointUrl;
                        },
                        createPayload: _createPayload
                    },
                    _a[_DYN_SERIALIZE /* @min:serialize */] = _serialize,
                    _a.batch = _batch,
                    _a.shouldProcess = function (evt) {
                        return !!_validate(evt);
                    },
                    _a;
            };
            _self._doTeardown = function (unloadCtx, unloadState) {
                _self.onunloadFlush();
                runTargetUnload(_offlineListener, false);
                _initDefaults();
            };
            /**
             * error handler
             */
            _self[_DYN__ON_ERROR /* @min:%2e_onError */] = function (payload, message, event) {
                // since version 3.1.3, string[] is no-op
                if (_isStringArr(payload)) {
                    return;
                }
                return _onError(payload, message);
            };
            /**
             * partial success handler
             */
            _self[_DYN__ON_PARTIAL_SUCCESS /* @min:%2e_onPartialSuccess */] = function (payload, results) {
                // since version 3.1.3, string[] is no-op
                if (_isStringArr(payload)) {
                    return;
                }
                return _onPartialSuccess(payload, results);
            };
            /**
             * success handler
             */
            _self[_DYN__ON_SUCCESS /* @min:%2e_onSuccess */] = function (payload, countOfItemsInPayload) {
                // since version 3.1.3, string[] is no-op
                if (_isStringArr(payload)) {
                    return;
                }
                return _onSuccess(payload);
                //_self._buffer && _self._buffer.clearSent(payload);
            };
            /**
             * xdr state changes
             */
            _self._xdrOnLoad = function (xdr, payload) {
                // since version 3.1.3, string[] is no-op
                if (_isStringArr(payload)) {
                    return;
                }
                return _xdrOnLoad(xdr, payload);
            };
            function _xdrOnLoad(xdr, payload) {
                var responseText = _getResponseText(xdr);
                if (xdr && (responseText + "" === "200" || responseText === "")) {
                    _consecutiveErrors = 0;
                    _self[_DYN__ON_SUCCESS /* @min:%2e_onSuccess */](payload, 0);
                }
                else {
                    var results = parseResponse(responseText);
                    if (results && results[_DYN_ITEMS_RECEIVED /* @min:%2eitemsReceived */] && results[_DYN_ITEMS_RECEIVED /* @min:%2eitemsReceived */] > results[_DYN_ITEMS_ACCEPTED /* @min:%2eitemsAccepted */]
                        && !_isRetryDisabled) {
                        _self[_DYN__ON_PARTIAL_SUCCESS /* @min:%2e_onPartialSuccess */](payload, results);
                    }
                    else {
                        _self[_DYN__ON_ERROR /* @min:%2e_onError */](payload, formatErrorMessageXdr(xdr));
                    }
                }
            }
            function _getSendPostMgrConfig() {
                var _a;
                try {
                    var onCompleteFuncs = {
                        xdrOnComplete: function (xdr, oncomplete, payload) {
                            var data = _getPayloadArr(payload);
                            if (!data) {
                                return;
                            }
                            return _xdrOnLoad(xdr, data);
                        },
                        fetchOnComplete: function (response, onComplete, resValue, payload) {
                            var data = _getPayloadArr(payload);
                            if (!data) {
                                return;
                            }
                            return _checkResponsStatus(response.status, data, response.url, data[_DYN_LENGTH$2 /* @min:%2elength */], response.statusText, resValue || "");
                        },
                        xhrOnComplete: function (request, oncomplete, payload) {
                            var data = _getPayloadArr(payload);
                            if (!data) {
                                return;
                            }
                            return _xhrReadyStateChange(request, data, data[_DYN_LENGTH$2 /* @min:%2elength */]);
                        },
                        beaconOnRetry: function (data, onComplete, canSend) {
                            return _onBeaconRetry(data, onComplete, canSend);
                        }
                    };
                    var config = (_a = {},
                        _a[_DYN_ENABLE_SEND_PROMISE /* @min:enableSendPromise */] = _enableSendPromise,
                        _a.isOneDs = false,
                        _a.disableCredentials = false,
                        _a[_DYN_DISABLE_XHR /* @min:disableXhr */] = _disableXhr,
                        _a.disableBeacon = !_beaconNormalSupported,
                        _a.disableBeaconSync = !_beaconOnUnloadSupported,
                        _a.senderOnCompleteCallBack = onCompleteFuncs,
                        _a);
                    return config;
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return null;
            }
            /**
             * xhr state changes
             */
            function _xhrReadyStateChange(xhr, payload, countOfItemsInPayload) {
                if (xhr.readyState === 4) {
                    _checkResponsStatus(xhr.status, payload, xhr.responseURL, countOfItemsInPayload, formatErrorMessageXhr(xhr), _getResponseText(xhr) || xhr.response);
                }
            }
            /**
             * error handler
             */
            function _onError(payload, message, event) {
                _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 26 /* _eInternalMessageId.OnError */, "Failed to send telemetry.", { message: message });
                _self._buffer && _self._buffer[_DYN_CLEAR_SENT /* @min:%2eclearSent */](payload);
            }
            /**
             * partial success handler
             */
            function _onPartialSuccess(payload, results) {
                var failed = [];
                var retry = [];
                // Iterate through the reversed array of errors so that splicing doesn't have invalid indexes after the first item.
                var errors = results.errors.reverse();
                for (var _i = 0, errors_1 = errors; _i < errors_1.length; _i++) {
                    var error = errors_1[_i];
                    var extracted = payload.splice(error.index, 1)[0];
                    if (_isRetriable(error.statusCode)) {
                        retry[_DYN_PUSH /* @min:%2epush */](extracted);
                    }
                    else {
                        // All other errors, including: 402 (Monthly quota exceeded) and 439 (Too many requests and refresh cache).
                        failed[_DYN_PUSH /* @min:%2epush */](extracted);
                    }
                }
                if (payload[_DYN_LENGTH$2 /* @min:%2elength */] > 0) {
                    _self[_DYN__ON_SUCCESS /* @min:%2e_onSuccess */](payload, results[_DYN_ITEMS_ACCEPTED /* @min:%2eitemsAccepted */]);
                }
                if (failed[_DYN_LENGTH$2 /* @min:%2elength */] > 0) {
                    _self[_DYN__ON_ERROR /* @min:%2e_onError */](failed, formatErrorMessageXhr(null, ["partial success", results[_DYN_ITEMS_ACCEPTED /* @min:%2eitemsAccepted */], "of", results.itemsReceived].join(" ")));
                }
                if (retry[_DYN_LENGTH$2 /* @min:%2elength */] > 0) {
                    _resendPayload(retry);
                    _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, "Partial success. " +
                        "Delivered: " + payload[_DYN_LENGTH$2 /* @min:%2elength */] + ", Failed: " + failed[_DYN_LENGTH$2 /* @min:%2elength */] +
                        ". Will retry to send " + retry[_DYN_LENGTH$2 /* @min:%2elength */] + " our of " + results[_DYN_ITEMS_RECEIVED /* @min:%2eitemsReceived */] + " items");
                }
            }
            /**
             * success handler
             */
            function _onSuccess(payload, countOfItemsInPayload) {
                _self._buffer && _self._buffer[_DYN_CLEAR_SENT /* @min:%2eclearSent */](payload);
            }
            function _getPayloadArr(payload) {
                try {
                    if (payload) {
                        var internalPayload = payload;
                        var arr = internalPayload[_DYN_ORI_PAYLOAD /* @min:%2eoriPayload */];
                        if (arr && arr[_DYN_LENGTH$2 /* @min:%2elength */]) {
                            return arr;
                        }
                        return null;
                    }
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return null;
            }
            function _validate(telemetryItem, diagLogger) {
                if (_disableTelemetry) {
                    // Do not send/save data
                    return false;
                }
                // validate input
                if (!telemetryItem) {
                    diagLogger && _throwInternal(diagLogger, 1 /* eLoggingSeverity.CRITICAL */, 7 /* _eInternalMessageId.CannotSendEmptyTelemetry */, "Cannot send empty telemetry");
                    return false;
                }
                // validate event
                if (telemetryItem.baseData && !telemetryItem[_DYN_BASE_TYPE /* @min:%2ebaseType */]) {
                    diagLogger && _throwInternal(diagLogger, 1 /* eLoggingSeverity.CRITICAL */, 70 /* _eInternalMessageId.InvalidEvent */, "Cannot send telemetry without baseData and baseType");
                    return false;
                }
                if (!telemetryItem[_DYN_BASE_TYPE /* @min:%2ebaseType */]) {
                    // Default
                    telemetryItem[_DYN_BASE_TYPE /* @min:%2ebaseType */] = "EventData";
                }
                // ensure a sender was constructed
                if (!_self[_DYN__SENDER /* @min:%2e_sender */]) {
                    diagLogger && _throwInternal(diagLogger, 1 /* eLoggingSeverity.CRITICAL */, 28 /* _eInternalMessageId.SenderNotInitialized */, "Sender was not initialized");
                    return false;
                }
                // check if this item should be sampled in, else add sampleRate tag
                if (!_isSampledIn(telemetryItem)) {
                    // Item is sampled out, do not send it
                    diagLogger && _throwInternal(diagLogger, 2 /* eLoggingSeverity.WARNING */, 33 /* _eInternalMessageId.TelemetrySampledAndNotSent */, "Telemetry item was sampled out and not sent", { SampleRate: _self._sample[_DYN_SAMPLE_RATE /* @min:%2esampleRate */] });
                    return false;
                }
                else {
                    telemetryItem[SampleRate] = _self._sample[_DYN_SAMPLE_RATE /* @min:%2esampleRate */];
                }
                return true;
            }
            function _getEnvelope(telemetryItem, diagLogger) {
                // construct an envelope that Application Insights endpoint can understand
                // if ikey of telemetry is provided and not empty, envelope will use this iKey instead of senderConfig iKey
                var defaultEnvelopeIkey = telemetryItem.iKey || _instrumentationKey;
                var aiEnvelope = Sender.constructEnvelope(telemetryItem, defaultEnvelopeIkey, diagLogger, _convertUndefined);
                if (!aiEnvelope) {
                    _throwInternal(diagLogger, 1 /* eLoggingSeverity.CRITICAL */, 47 /* _eInternalMessageId.CreateEnvelopeError */, "Unable to create an AppInsights envelope");
                    return;
                }
                var doNotSendItem = false;
                // this is for running in legacy mode, where customer may already have a custom initializer present
                if (telemetryItem[_DYN_TAGS /* @min:%2etags */] && telemetryItem[_DYN_TAGS /* @min:%2etags */][ProcessLegacy]) {
                    arrForEach(telemetryItem[_DYN_TAGS /* @min:%2etags */][ProcessLegacy], function (callBack) {
                        try {
                            if (callBack && callBack(aiEnvelope) === false) {
                                doNotSendItem = true;
                                _warnToConsole(diagLogger, "Telemetry processor check returns false");
                            }
                        }
                        catch (e) {
                            // log error but dont stop executing rest of the telemetry initializers
                            // doNotSendItem = true;
                            _throwInternal(diagLogger, 1 /* eLoggingSeverity.CRITICAL */, 64 /* _eInternalMessageId.TelemetryInitializerFailed */, "One of telemetry initializers failed, telemetry item will not be sent: " + getExceptionName(e), { exception: dumpObj(e) }, true);
                        }
                    });
                    delete telemetryItem[_DYN_TAGS /* @min:%2etags */][ProcessLegacy];
                }
                if (doNotSendItem) {
                    return; // do not send, no need to execute next plugin
                }
                return aiEnvelope;
            }
            function _serialize(item) {
                var rlt = EMPTY_STR;
                var diagLogger = _self[_DYN_DIAG_LOG /* @min:%2ediagLog */]();
                try {
                    var valid = _validate(item, diagLogger);
                    var envelope = null;
                    if (valid) {
                        envelope = _getEnvelope(item, diagLogger);
                    }
                    if (envelope) {
                        rlt = _serializer[_DYN_SERIALIZE /* @min:%2eserialize */](envelope);
                    }
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return rlt;
            }
            function _batch(arr) {
                var rlt = EMPTY_STR;
                if (arr && arr[_DYN_LENGTH$2 /* @min:%2elength */]) {
                    rlt = "[" + arr.join(",") + "]";
                }
                return rlt;
            }
            function _createPayload(data) {
                var _a;
                var headers = _getHeaders();
                return _a = {
                        urlString: _endpointUrl
                    },
                    _a[_DYN_DATA /* @min:data */] = data,
                    _a.headers = headers,
                    _a;
            }
            function _isSampledIn(envelope) {
                return _self._sample.isSampledIn(envelope);
            }
            function _getOnComplete(payload, status, headers, response) {
                // ***********************************************************************************************
                //TODO: handle other status codes
                if (status === 200 && payload) {
                    _self._onSuccess(payload, payload[_DYN_LENGTH$2 /* @min:%2elength */]);
                }
                else {
                    response && _self[_DYN__ON_ERROR /* @min:%2e_onError */](payload, response);
                }
            }
            function _doSend(sendInterface, payload, isAsync, markAsSent) {
                if (markAsSent === void 0) { markAsSent = true; }
                var onComplete = function (status, headers, response) {
                    return _getOnComplete(payload, status, headers, response);
                };
                var payloadData = _getPayload(payload);
                var sendPostFunc = sendInterface && sendInterface.sendPOST;
                if (sendPostFunc && payloadData) {
                    // ***********************************************************************************************
                    // mark payload as sent at the beginning of calling each send function
                    if (markAsSent) {
                        _self._buffer[_DYN_MARK_AS_SENT /* @min:%2emarkAsSent */](payload);
                    }
                    return sendPostFunc(payloadData, onComplete, !isAsync);
                }
                return null;
            }
            function _getPayload(payload) {
                var _a;
                if (isArray(payload) && payload[_DYN_LENGTH$2 /* @min:%2elength */] > 0) {
                    var batch = _self[_DYN__BUFFER /* @min:%2e_buffer */].batchPayloads(payload);
                    var headers = _getHeaders();
                    var payloadData = (_a = {},
                        _a[_DYN_DATA /* @min:data */] = batch,
                        _a.urlString = _endpointUrl,
                        _a.headers = headers,
                        _a.disableXhrSync = _disableXhr,
                        _a.disableFetchKeepAlive = !_fetchKeepAlive,
                        _a[_DYN_ORI_PAYLOAD /* @min:oriPayload */] = payload,
                        _a);
                    return payloadData;
                }
                return null;
            }
            function _getHeaders() {
                try {
                    var headers = _headers || {};
                    if (isInternalApplicationInsightsEndpoint(_endpointUrl)) {
                        headers[RequestHeaders[6 /* eRequestHeaders.sdkContextHeader */]] = RequestHeaders[7 /* eRequestHeaders.sdkContextHeaderAppIdRequest */];
                    }
                    return headers;
                }
                catch (e) {
                    // eslint-disable-next-line no-empty
                }
                return null;
            }
            function _checkMaxSize(incomingPayload) {
                var incomingSize = incomingPayload ? incomingPayload[_DYN_LENGTH$2 /* @min:%2elength */] : 0;
                if ((_self[_DYN__BUFFER /* @min:%2e_buffer */].size() + incomingSize) > _maxBatchSizeInBytes) {
                    if (!_offlineListener || _offlineListener.isOnline()) { // only trigger send when currently online
                        _self[_DYN_TRIGGER_SEND /* @min:%2etriggerSend */](true, null, 10 /* SendRequestReason.MaxBatchSize */);
                    }
                    return true;
                }
                return false;
            }
            function _checkResponsStatus(status, payload, responseUrl, countOfItemsInPayload, errorMessage, res) {
                var response = null;
                if (!_self._appId) {
                    response = parseResponse(res);
                    if (response && response.appId) {
                        _self._appId = response.appId;
                    }
                }
                if ((status < 200 || status >= 300) && status !== 0) {
                    // Update End Point url if permanent redirect or moved permanently
                    // Updates the end point url before retry
                    if (status === 301 || status === 307 || status === 308) {
                        if (!_checkAndUpdateEndPointUrl(responseUrl)) {
                            _self[_DYN__ON_ERROR /* @min:%2e_onError */](payload, errorMessage);
                            return;
                        }
                    }
                    if (!_isRetryDisabled && _isRetriable(status)) {
                        _resendPayload(payload);
                        _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, ". " +
                            "Response code " + status + ". Will retry to send " + payload[_DYN_LENGTH$2 /* @min:%2elength */] + " items.");
                    }
                    else {
                        _self[_DYN__ON_ERROR /* @min:%2e_onError */](payload, errorMessage);
                    }
                }
                else if (_offlineListener && !_offlineListener.isOnline()) { // offline
                    // Note: Don't check for status == 0, since adblock gives this code
                    if (!_isRetryDisabled) {
                        var offlineBackOffMultiplier = 10; // arbritrary number
                        _resendPayload(payload, offlineBackOffMultiplier);
                        _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, ". Offline - Response Code: ".concat(status, ". Offline status: ").concat(!_offlineListener.isOnline(), ". Will retry to send ").concat(payload.length, " items."));
                    }
                }
                else {
                    // check if the xhr's responseURL or fetch's response.url is same as endpoint url
                    // TODO after 10 redirects force send telemetry with 'redirect=false' as query parameter.
                    _checkAndUpdateEndPointUrl(responseUrl);
                    if (status === 206) {
                        if (!response) {
                            response = parseResponse(res);
                        }
                        if (response && !_isRetryDisabled) {
                            _self[_DYN__ON_PARTIAL_SUCCESS /* @min:%2e_onPartialSuccess */](payload, response);
                        }
                        else {
                            _self[_DYN__ON_ERROR /* @min:%2e_onError */](payload, errorMessage);
                        }
                    }
                    else {
                        _consecutiveErrors = 0;
                        _self[_DYN__ON_SUCCESS /* @min:%2e_onSuccess */](payload, countOfItemsInPayload);
                    }
                }
            }
            function _checkAndUpdateEndPointUrl(responseUrl) {
                // Maximum stamp specific redirects allowed(uncomment this when breeze is ready with not allowing redirects feature)
                if (_stamp_specific_redirects >= 10) {
                    //  _self._senderConfig.endpointUrl = () => Sender._getDefaultAppInsightsChannelConfig().endpointUrl()+"/?redirect=false";
                    //  _stamp_specific_redirects = 0;
                    return false;
                }
                if (!isNullOrUndefined(responseUrl) && responseUrl !== "") {
                    if (responseUrl !== _endpointUrl) {
                        _endpointUrl = responseUrl;
                        ++_stamp_specific_redirects;
                        return true;
                    }
                }
                return false;
            }
            function _doUnloadSend(payload, isAsync) {
                if (_syncUnloadSender) {
                    // We are unloading so always call the sender with sync set to false
                    _syncUnloadSender(payload, false);
                }
                else {
                    // Fallback to the previous beacon Sender (which causes a CORB warning on chrome now)
                    var beaconInst = _sendPostMgr && _sendPostMgr[_DYN_GET_SENDER_INST /* @min:%2egetSenderInst */]([3 /* TransportType.Beacon */], true);
                    return _doSend(beaconInst, payload, isAsync);
                }
            }
            function _onBeaconRetry(payload, onComplete, canSend) {
                var internalPayload = payload;
                var data = internalPayload && internalPayload[_DYN_ORI_PAYLOAD /* @min:%2eoriPayload */];
                if (!_disableBeaconSplit) {
                    // Failed to send entire payload so try and split data and try to send as much events as possible
                    var droppedPayload = [];
                    for (var lp = 0; lp < data[_DYN_LENGTH$2 /* @min:%2elength */]; lp++) {
                        var thePayload = data[lp];
                        var arr = [thePayload];
                        var item = _getPayload(arr);
                        if (!canSend(item, onComplete)) {
                            // Can't send anymore, so split the batch and drop the rest
                            droppedPayload[_DYN_PUSH /* @min:%2epush */](thePayload);
                        }
                        else {
                            _self._onSuccess(arr, arr[_DYN_LENGTH$2 /* @min:%2elength */]);
                        }
                    }
                    if (droppedPayload[_DYN_LENGTH$2 /* @min:%2elength */] > 0) {
                        _fallbackSend && _fallbackSend(droppedPayload, true);
                        _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, ". " + "Failed to send telemetry with Beacon API, retried with normal sender.");
                    }
                }
                else {
                    _fallbackSend && _fallbackSend(data, true);
                    _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, ". " + "Failed to send telemetry with Beacon API, retried with normal sender.");
                }
            }
            function _isStringArr(arr) {
                try {
                    if (arr && arr[_DYN_LENGTH$2 /* @min:%2elength */]) {
                        return (isString(arr[0]));
                    }
                }
                catch (e) {
                    //TODO: log, sender use IInternalStorageItem instead of string since 3.1.3
                }
                return null;
            }
            function _fetchKeepAliveSender(payload, isAsync) {
                var transport = null;
                if (isArray(payload)) {
                    var payloadSize = payload[_DYN_LENGTH$2 /* @min:%2elength */];
                    for (var lp = 0; lp < payload[_DYN_LENGTH$2 /* @min:%2elength */]; lp++) {
                        payloadSize += payload[lp].item[_DYN_LENGTH$2 /* @min:%2elength */];
                    }
                    var syncFetchPayload = _sendPostMgr.getSyncFetchPayload();
                    if ((syncFetchPayload + payloadSize) <= FetchSyncRequestSizeLimitBytes) {
                        transport = 2 /* TransportType.Fetch */;
                    }
                    else if (isBeaconsSupported()) {
                        // Fallback to beacon sender as we at least get told which events can't be scheduled
                        transport = 3 /* TransportType.Beacon */;
                    }
                    else {
                        // Payload is going to be too big so just try and send via XHR
                        transport = 1 /* TransportType.Xhr */;
                        _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 2 /* eLoggingSeverity.WARNING */, 40 /* _eInternalMessageId.TransmissionFailed */, ". " + "Failed to send telemetry with Beacon API, retried with xhrSender.");
                    }
                    var inst = _sendPostMgr && _sendPostMgr[_DYN_GET_SENDER_INST /* @min:%2egetSenderInst */]([transport], true);
                    return _doSend(inst, payload, isAsync);
                }
                return null;
            }
            /**
             * Resend payload. Adds payload back to the send buffer and setup a send timer (with exponential backoff).
             * @param payload
             */
            function _resendPayload(payload, linearFactor) {
                if (linearFactor === void 0) { linearFactor = 1; }
                if (!payload || payload[_DYN_LENGTH$2 /* @min:%2elength */] === 0) {
                    return;
                }
                var buffer = _self[_DYN__BUFFER /* @min:%2e_buffer */];
                buffer[_DYN_CLEAR_SENT /* @min:%2eclearSent */](payload);
                _consecutiveErrors++;
                for (var _i = 0, payload_1 = payload; _i < payload_1.length; _i++) {
                    var item = payload_1[_i];
                    item.cnt = item.cnt || 0; // to make sure we have cnt for each payload
                    item.cnt++; // when resend, increase cnt
                    buffer[_DYN_ENQUEUE /* @min:%2eenqueue */](item);
                }
                // setup timer
                _setRetryTime(linearFactor);
                _setupTimer();
            }
            /**
             * Calculates the time to wait before retrying in case of an error based on
             * http://en.wikipedia.org/wiki/Exponential_backoff
             */
            function _setRetryTime(linearFactor) {
                var SlotDelayInSeconds = 10;
                var delayInSeconds;
                if (_consecutiveErrors <= 1) {
                    delayInSeconds = SlotDelayInSeconds;
                }
                else {
                    var backOffSlot = (Math.pow(2, _consecutiveErrors) - 1) / 2;
                    // tslint:disable-next-line:insecure-random
                    var backOffDelay = Math.floor(Math.random() * backOffSlot * SlotDelayInSeconds) + 1;
                    backOffDelay = linearFactor * backOffDelay;
                    delayInSeconds = Math.max(Math.min(backOffDelay, 3600), SlotDelayInSeconds);
                }
                // TODO: Log the backoff time like the C# version does.
                var retryAfterTimeSpan = utcNow() + (delayInSeconds * 1000);
                // TODO: Log the retry at time like the C# version does.
                _retryAt = retryAfterTimeSpan;
            }
            /**
             * Sets up the timer which triggers actually sending the data.
             */
            function _setupTimer() {
                if (!_timeoutHandle && !_paused) {
                    var retryInterval = _retryAt ? Math.max(0, _retryAt - utcNow()) : 0;
                    var timerValue = Math.max(_maxBatchInterval, retryInterval);
                    _timeoutHandle = scheduleTimeout(function () {
                        _timeoutHandle = null;
                        _self[_DYN_TRIGGER_SEND /* @min:%2etriggerSend */](true, null, 1 /* SendRequestReason.NormalSchedule */);
                    }, timerValue);
                }
            }
            function _clearScheduledTimer() {
                _timeoutHandle && _timeoutHandle.cancel();
                _timeoutHandle = null;
                _retryAt = null;
            }
            /**
             * Checks if the SDK should resend the payload after receiving this status code from the backend.
             * @param statusCode
             */
            function _isRetriable(statusCode) {
                // retryCodes = [] means should not retry
                if (!isNullOrUndefined(_retryCodes)) {
                    return _retryCodes[_DYN_LENGTH$2 /* @min:%2elength */] && _retryCodes.indexOf(statusCode) > -1;
                }
                return statusCode === 401 // Unauthorized
                    // Removing as private links can return a 403 which causes excessive retries and session storage usage
                    // || statusCode === 403 // Forbidden
                    || statusCode === 408 // Timeout
                    || statusCode === 429 // Too many requests.
                    || statusCode === 500 // Internal server error.
                    || statusCode === 502 // Bad Gateway.
                    || statusCode === 503 // Service unavailable.
                    || statusCode === 504; // Gateway timeout.
            }
            // Using function lookups for backward compatibility as the getNotifyMgr() did not exist until after v2.5.6
            function _getNotifyMgr() {
                var func = "getNotifyMgr";
                if (_self.core[func]) {
                    return _self.core[func]();
                }
                // using _self.core['_notificationManager'] for backward compatibility
                return _self.core["_notificationManager"];
            }
            function _notifySendRequest(sendRequest, isAsync) {
                var manager = _getNotifyMgr();
                if (manager && manager[_DYN_EVENTS_SEND_REQUEST /* @min:%2eeventsSendRequest */]) {
                    try {
                        manager[_DYN_EVENTS_SEND_REQUEST /* @min:%2eeventsSendRequest */](sendRequest, isAsync);
                    }
                    catch (e) {
                        _throwInternal(_self[_DYN_DIAG_LOG /* @min:%2ediagLog */](), 1 /* eLoggingSeverity.CRITICAL */, 74 /* _eInternalMessageId.NotificationException */, "send request notification failed: " + getExceptionName(e), { exception: dumpObj(e) });
                    }
                }
            }
            /**
             * Validate UUID Format
             * Specs taken from https://tools.ietf.org/html/rfc4122 and breeze repo
             */
            function _validateInstrumentationKey(instrumentationKey, config) {
                var disableValidation = config.disableInstrumentationKeyValidation;
                var disableIKeyValidationFlag = isNullOrUndefined(disableValidation) ? false : disableValidation;
                if (disableIKeyValidationFlag) {
                    return true;
                }
                var UUID_Regex = "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$";
                var regexp = new RegExp(UUID_Regex);
                return regexp.test(instrumentationKey);
            }
            function _initDefaults() {
                _self[_DYN__SENDER /* @min:%2e_sender */] = null;
                _self[_DYN__BUFFER /* @min:%2e_buffer */] = null;
                _self._appId = null;
                _self._sample = null;
                _headers = {};
                _offlineListener = null;
                _consecutiveErrors = 0;
                _retryAt = null;
                _paused = false;
                _timeoutHandle = null;
                _serializer = null;
                _stamp_specific_redirects = 0;
                _syncFetchPayload = 0;
                _syncUnloadSender = null;
                _evtNamespace = null;
                _endpointUrl = null;
                _orgEndpointUrl = null;
                _maxBatchSizeInBytes = 0;
                _beaconSupported = false;
                _customHeaders = null;
                _disableTelemetry = false;
                _instrumentationKey = null;
                _convertUndefined = UNDEFINED_VALUE$1;
                _isRetryDisabled = false;
                _sessionStorageUsed = null;
                _namePrefix = UNDEFINED_VALUE$1;
                _disableXhr = false;
                _fetchKeepAlive = false;
                _disableBeaconSplit = false;
                _xhrSend = null;
                _fallbackSend = null;
                _sendPostMgr = null;
                objDefine(_self, "_senderConfig", {
                    g: function () {
                        return objExtend({}, defaultAppInsightsChannelConfig);
                    }
                });
            }
        });
        return _this;
    }
    Sender.constructEnvelope = function (orig, iKey, logger, convertUndefined) {
        var envelope;
        if (iKey !== orig.iKey && !isNullOrUndefined(iKey)) {
            envelope = __assignFn(__assignFn({}, orig), { iKey: iKey });
        }
        else {
            envelope = orig;
        }
        var creator = EnvelopeTypeCreator[envelope.baseType] || EventEnvelopeCreator;
        return creator(logger, envelope, convertUndefined);
    };
// Removed Stub for Sender.prototype.pause.
// Removed Stub for Sender.prototype.resume.
// Removed Stub for Sender.prototype.flush.
// Removed Stub for Sender.prototype.onunloadFlush.
// Removed Stub for Sender.prototype.initialize.
// Removed Stub for Sender.prototype.processTelemetry.
// Removed Stub for Sender.prototype._xhrReadyStateChange.
// Removed Stub for Sender.prototype.triggerSend.
// Removed Stub for Sender.prototype._onError.
// Removed Stub for Sender.prototype._onPartialSuccess.
// Removed Stub for Sender.prototype._onSuccess.
// Removed Stub for Sender.prototype._xdrOnLoad.
// Removed Stub for Sender.prototype.addHeader.
// Removed Stub for Sender.prototype.isCompletelyIdle.
// Removed Stub for Sender.prototype.getOfflineSupport.
    return Sender;
}(BaseTelemetryPlugin));

/*
 * Application Insights JavaScript SDK - Dependencies Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// ###################################################################################################################################################
// Note: DON'T Export these const from the package as we are still targeting IE/ES5 this will export a mutable variables that someone could change ###
// ###################################################################################################################################################
// Generally you should only put values that are used more than 2 times and then only if not already exposed as a constant (such as SdkCoreNames)
// as when using "short" named values from here they will be will be minified smaller than the SdkCoreNames[eSdkCoreNames.xxxx] value.
var STR_DURATION = "duration";
var STR_PROPERTIES = "properties";

/*
 * Application Insights JavaScript SDK - Dependencies Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_REQUEST_URL = "requestUrl"; // Count: 11
var _DYN_INST = "inst"; // Count: 5
var _DYN_LENGTH$1 = "length"; // Count: 8
var _DYN_TRACE_ID = "traceID"; // Count: 9
var _DYN_SPAN_ID = "spanID"; // Count: 8
var _DYN_TRACE_FLAGS = "traceFlags"; // Count: 13
var _DYN_CONTEXT$1 = "context"; // Count: 7
var _DYN_ABORTED = "aborted"; // Count: 7
var _DYN_TRACE_ID0 = "traceId"; // Count: 5
var _DYN_SPAN_ID1 = "spanId"; // Count: 5
var _DYN__ADD_HOOK = "_addHook"; // Count: 4
var _DYN_CORE = "core"; // Count: 8
var _DYN_INCLUDE_CORRELATION_2 = "includeCorrelationHeaders"; // Count: 4
var _DYN_GET_ABSOLUTE_URL = "getAbsoluteUrl"; // Count: 3
var _DYN_HEADERS = "headers"; // Count: 6
var _DYN_REQUEST_HEADERS = "requestHeaders"; // Count: 13
var _DYN_SET_REQUEST_HEADER = "setRequestHeader"; // Count: 3
var _DYN_TRACK_DEPENDENCY_DAT3 = "trackDependencyDataInternal"; // Count: 2
var _DYN_START_TIME = "startTime"; // Count: 6
var _DYN_TO_LOWER_CASE = "toLowerCase"; // Count: 6
var _DYN_ENABLE_REQUEST_HEADE4 = "enableRequestHeaderTracking"; // Count: 3
var _DYN_ENABLE_AJAX_ERROR_ST5 = "enableAjaxErrorStatusText"; // Count: 2
var _DYN_ENABLE_AJAX_PERF_TRA6 = "enableAjaxPerfTracking"; // Count: 2
var _DYN_MAX_AJAX_CALLS_PER_V7 = "maxAjaxCallsPerView"; // Count: 2
var _DYN_EXCLUDE_REQUEST_FROM8 = "excludeRequestFromAutoTrackingPatterns"; // Count: 2
var _DYN_ADD_REQUEST_CONTEXT = "addRequestContext"; // Count: 2
var _DYN_DISABLE_AJAX_TRACKIN9 = "disableAjaxTracking"; // Count: 3
var _DYN_AJAX_PERF_LOOKUP_DEL10 = "ajaxPerfLookupDelay"; // Count: 2
var _DYN_DISABLE_FETCH_TRACKI11 = "disableFetchTracking"; // Count: 2
var _DYN_ENABLE_RESPONSE_HEAD12 = "enableResponseHeaderTracking"; // Count: 2
var _DYN_STATUS = "status"; // Count: 11
var _DYN_STATUS_TEXT = "statusText"; // Count: 9
var _DYN_HEADER_MAP = "headerMap"; // Count: 8
var _DYN_OPEN_DONE = "openDone"; // Count: 3
var _DYN_SEND_DONE = "sendDone"; // Count: 3
var _DYN_REQUEST_SENT_TIME = "requestSentTime"; // Count: 9
var _DYN_ABORT_DONE = "abortDone"; // Count: 3
var _DYN_GET_TRACE_ID = "getTraceId"; // Count: 3
var _DYN_GET_TRACE_FLAGS = "getTraceFlags"; // Count: 3
var _DYN_METHOD = "method"; // Count: 8
var _DYN_ERROR_STATUS_TEXT = "errorStatusText"; // Count: 3
var _DYN_STATE_CHANGE_ATTACHE13 = "stateChangeAttached"; // Count: 2
var _DYN_RESPONSE_TEXT = "responseText"; // Count: 6
var _DYN_RESPONSE_FINISHED_TI14 = "responseFinishedTime"; // Count: 7
var _DYN__CREATE_TRACK_ITEM = "CreateTrackItem"; // Count: 3
var _DYN_RESPONSE = "response"; // Count: 4
var _DYN_GET_ALL_RESPONSE_HEA15 = "getAllResponseHeaders"; // Count: 2
var _DYN_GET_PART_APROPS = "getPartAProps"; // Count: 3
var _DYN_PERF_MARK = "perfMark"; // Count: 4
var _DYN_NAME = "name"; // Count: 6
var _DYN_PERF_TIMING = "perfTiming"; // Count: 3
var _DYN_EXCEPTION = "exception"; // Count: 5
var _DYN_AJAX_DIAGNOSTICS_MES16 = "ajaxDiagnosticsMessage"; // Count: 3
var _DYN_CORRELATION_CONTEXT = "correlationContext"; // Count: 3
var _DYN_AJAX_TOTAL_DURATION = "ajaxTotalDuration"; // Count: 3
var _DYN_EVENT_TRACE_CTX = "eventTraceCtx"; // Count: 3

/*
 * Application Insights JavaScript SDK - Dependencies Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

/** @ignore */
function _calcPerfDuration(resourceEntry, start, end) {
    var result = 0;
    var from = resourceEntry[start];
    var to = resourceEntry[end];
    if (from && to) {
        result = dateTimeUtilsDuration(from, to);
    }
    return result;
}
/** @ignore */
function _setPerfDuration(props, name, resourceEntry, start, end) {
    var result = 0;
    var value = _calcPerfDuration(resourceEntry, start, end);
    if (value) {
        result = _setPerfValue(props, name, msToTimeSpan(value));
    }
    return result;
}
/** @ignore */
function _setPerfValue(props, name, value) {
    var strPerf = "ajaxPerf";
    var result = 0;
    if (props && name && value) {
        var perfData = props[strPerf] = (props[strPerf] || {});
        perfData[name] = value;
        result = 1;
    }
    return result;
}
/** @ignore */
function _populatePerfData(ajaxData, dependency) {
    /*
    * https://developer.mozilla.org/en-US/docs/Web/API/Resource_Timing_API/Using_the_Resource_Timing_API
    *  | -startTime
    *  | -redirectStart
    *  |            | -redirectEnd
    *  |            | | -fetchStart
    *  |            | |   | -domainLookupStart
    *  |            | |   |                |- domainLookupEnd
    *  |            | |   |                | | -connectStart
    *  |            | |   |                | |  | -secureConnectionStart
    *  |            | |   |                | |  |        | -connectEnd
    *  |            | |   |                | |  |        | | -requestStart
    *  |            | |   |                | |  |        | |           | | -responseStart
    *  |            | |   |                | |  |        | |           | |            | | -responseEnd
    *  +------------+-+---+----------------+-+--+--------+-+-----------+-+------------+-+
    *  |--redirect--| |---|--domainLookup--| |--connect--| |--request--| |--response--| |
    *  |-------------------networkConnect----------------|
    *  |                                                   |---------sentRequest--------|
    *  |------------------------------------perfTotal-----------------------------------|
    */
    var resourceEntry = ajaxData[_DYN_PERF_TIMING /* @min:%2eperfTiming */];
    var props = dependency[STR_PROPERTIES /* @min:%2eproperties */] || {};
    var propsSet = 0;
    var strName = "name";
    var strStart = "Start";
    var strEnd = "End";
    var strDomainLookup = "domainLookup";
    var strConnect = "connect";
    var strRedirect = "redirect";
    var strRequest = "request";
    var strResponse = "response";
    var strStartTime = "startTime";
    var strDomainLookupStart = strDomainLookup + strStart;
    var strDomainLookupEnd = strDomainLookup + strEnd;
    var strConnectStart = strConnect + strStart;
    var strConnectEnd = strConnect + strEnd;
    var strRequestStart = strRequest + strStart;
    var strRequestEnd = strRequest + strEnd;
    var strResponseStart = strResponse + strStart;
    var strResponseEnd = strResponse + strEnd;
    var strRedirectStart = strRedirect + strStart;
    var strRedirectEnd = strRedirect = strEnd;
    var strTransferSize = "transferSize";
    var strEncodedBodySize = "encodedBodySize";
    var strDecodedBodySize = "decodedBodySize";
    var strServerTiming = "serverTiming";
    if (resourceEntry) {
        // redirect
        propsSet |= _setPerfDuration(props, strRedirect, resourceEntry, strRedirectStart, strRedirectEnd);
        // domainLookup
        propsSet |= _setPerfDuration(props, strDomainLookup, resourceEntry, strDomainLookupStart, strDomainLookupEnd);
        // connect
        propsSet |= _setPerfDuration(props, strConnect, resourceEntry, strConnectStart, strConnectEnd);
        // request
        propsSet |= _setPerfDuration(props, strRequest, resourceEntry, strRequestStart, strRequestEnd);
        // response
        propsSet |= _setPerfDuration(props, strResponse, resourceEntry, strResponseStart, strResponseEnd);
        // Network connection time
        propsSet |= _setPerfDuration(props, "networkConnect", resourceEntry, strStartTime, strConnectEnd);
        // Sent Request
        propsSet |= _setPerfDuration(props, "sentRequest", resourceEntry, strRequestStart, strResponseEnd);
        // PerfTotal / Duration
        var duration = resourceEntry[STR_DURATION /* @min:%2eduration */];
        if (!duration) {
            duration = _calcPerfDuration(resourceEntry, strStartTime, strResponseEnd) || 0;
        }
        propsSet |= _setPerfValue(props, STR_DURATION, duration);
        propsSet |= _setPerfValue(props, "perfTotal", duration);
        var serverTiming = resourceEntry[strServerTiming];
        if (serverTiming) {
            var server_1 = {};
            arrForEach(serverTiming, function (value, idx) {
                var name = normalizeJsName(value[strName] || "" + idx);
                var newValue = server_1[name] || {};
                objForEachKey(value, function (key, val) {
                    if (key !== strName && isString(val) || isNumber(val)) {
                        if (newValue[key]) {
                            val = newValue[key] + ";" + val;
                        }
                        if (val || !isString(val)) {
                            // Only set the value if it has a value and it's not an empty string
                            newValue[key] = val;
                        }
                    }
                });
                server_1[name] = newValue;
            });
            propsSet |= _setPerfValue(props, strServerTiming, server_1);
        }
        propsSet |= _setPerfValue(props, strTransferSize, resourceEntry[strTransferSize]);
        propsSet |= _setPerfValue(props, strEncodedBodySize, resourceEntry[strEncodedBodySize]);
        propsSet |= _setPerfValue(props, strDecodedBodySize, resourceEntry[strDecodedBodySize]);
    }
    else {
        if (ajaxData[_DYN_PERF_MARK /* @min:%2eperfMark */]) {
            propsSet |= _setPerfValue(props, "missing", ajaxData.perfAttempts);
        }
    }
    if (propsSet) {
        dependency[STR_PROPERTIES /* @min:%2eproperties */] = props;
    }
}
var XHRMonitoringState = /** @class */ (function () {
    function XHRMonitoringState() {
        var self = this;
        self[_DYN_OPEN_DONE /* @min:%2eopenDone */] = false;
        self.setRequestHeaderDone = false;
        self[_DYN_SEND_DONE /* @min:%2esendDone */] = false;
        self[_DYN_ABORT_DONE /* @min:%2eabortDone */] = false;
        // <summary>True, if onreadyStateChangeCallback function attached to xhr, otherwise false</summary>
        self[_DYN_STATE_CHANGE_ATTACHE13 /* @min:%2estateChangeAttached */] = false;
    }
    return XHRMonitoringState;
}());
var ajaxRecord = /** @class */ (function () {
    function ajaxRecord(traceId, spanId, logger, traceCtx) {
        var _a;
        var self = this;
        var _logger = logger;
        var strResponseText = "responseText";
        // Assigning the initial/default values within the constructor to avoid typescript from creating a bunch of
        // this.XXXX = null
        self[_DYN_PERF_MARK /* @min:%2eperfMark */] = null;
        self.completed = false;
        self.requestHeadersSize = null;
        self[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */] = null;
        self.responseReceivingDuration = null;
        self.callbackDuration = null;
        self[_DYN_AJAX_TOTAL_DURATION /* @min:%2eajaxTotalDuration */] = null;
        self[_DYN_ABORTED /* @min:%2eaborted */] = 0;
        self.pageUrl = null;
        self[_DYN_REQUEST_URL /* @min:%2erequestUrl */] = null;
        self.requestSize = 0;
        self[_DYN_METHOD /* @min:%2emethod */] = null;
        self[_DYN_STATUS /* @min:%2estatus */] = null;
        self[_DYN_REQUEST_SENT_TIME /* @min:%2erequestSentTime */] = null;
        self.responseStartedTime = null;
        self[_DYN_RESPONSE_FINISHED_TI14 /* @min:%2eresponseFinishedTime */] = null;
        self.callbackFinishedTime = null;
        self.endTime = null;
        self.xhrMonitoringState = new XHRMonitoringState();
        self.clientFailure = 0;
        self[_DYN_TRACE_ID /* @min:%2etraceID */] = traceId;
        self[_DYN_SPAN_ID /* @min:%2espanID */] = spanId;
        self[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */] = traceCtx === null || traceCtx === void 0 ? void 0 : traceCtx.getTraceFlags();
        if (traceCtx) {
            self[_DYN_EVENT_TRACE_CTX /* @min:%2eeventTraceCtx */] = (_a = {},
                _a[_DYN_TRACE_ID0 /* @min:traceId */] = traceCtx[_DYN_GET_TRACE_ID /* @min:%2egetTraceId */](),
                _a[_DYN_SPAN_ID1 /* @min:spanId */] = traceCtx.getSpanId(),
                _a[_DYN_TRACE_FLAGS /* @min:traceFlags */] = traceCtx[_DYN_GET_TRACE_FLAGS /* @min:%2egetTraceFlags */](),
                _a);
        }
        else {
            self[_DYN_EVENT_TRACE_CTX /* @min:%2eeventTraceCtx */] = null;
        }
        dynamicProto(ajaxRecord, self, function (self) {
            self.getAbsoluteUrl = function () {
                return self[_DYN_REQUEST_URL /* @min:%2erequestUrl */] ? urlGetAbsoluteUrl(self[_DYN_REQUEST_URL /* @min:%2erequestUrl */]) : null;
            };
            self.getPathName = function () {
                return self[_DYN_REQUEST_URL /* @min:%2erequestUrl */] ? dataSanitizeUrl(_logger, urlGetCompleteUrl(self[_DYN_METHOD /* @min:%2emethod */], self[_DYN_REQUEST_URL /* @min:%2erequestUrl */])) : null;
            };
            self[_DYN__CREATE_TRACK_ITEM /* @min:%2eCreateTrackItem */] = function (ajaxType, enableRequestHeaderTracking, getResponse) {
                var _a;
                // round to 3 decimal points
                self.ajaxTotalDuration = Math.round(dateTimeUtilsDuration(self.requestSentTime, self.responseFinishedTime) * 1000) / 1000;
                if (self[_DYN_AJAX_TOTAL_DURATION /* @min:%2eajaxTotalDuration */] < 0) {
                    return null;
                }
                var dependency = (_a = {
                        id: "|" + self[_DYN_TRACE_ID /* @min:%2etraceID */] + "." + self[_DYN_SPAN_ID /* @min:%2espanID */],
                        target: self[_DYN_GET_ABSOLUTE_URL /* @min:%2egetAbsoluteUrl */]()
                    },
                    _a[_DYN_NAME /* @min:name */] = self.getPathName(),
                    _a.type = ajaxType,
                    _a[_DYN_START_TIME /* @min:startTime */] = null,
                    _a.duration = self[_DYN_AJAX_TOTAL_DURATION /* @min:%2eajaxTotalDuration */],
                    _a.success = (+(self[_DYN_STATUS /* @min:%2estatus */])) >= 200 && (+(self[_DYN_STATUS /* @min:%2estatus */])) < 400,
                    _a.responseCode = (+(self[_DYN_STATUS /* @min:%2estatus */])),
                    _a[STR_PROPERTIES] = { HttpMethod: self[_DYN_METHOD /* @min:%2emethod */] },
                    _a);
                var props = dependency[STR_PROPERTIES];
                if (self[_DYN_ABORTED /* @min:%2eaborted */]) {
                    props[_DYN_ABORTED /* @min:%2eaborted */] = true;
                }
                if (self[_DYN_REQUEST_SENT_TIME /* @min:%2erequestSentTime */]) {
                    // Set the correct dependency start time
                    dependency[_DYN_START_TIME /* @min:%2estartTime */] = new Date();
                    dependency[_DYN_START_TIME /* @min:%2estartTime */].setTime(self[_DYN_REQUEST_SENT_TIME /* @min:%2erequestSentTime */]);
                }
                // Add Ajax perf details if available
                _populatePerfData(self, dependency);
                if (enableRequestHeaderTracking) {
                    if (objKeys(self.requestHeaders)[_DYN_LENGTH$1 /* @min:%2elength */] > 0) {
                        props[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */] = self[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */];
                    }
                }
                if (getResponse) {
                    var response = getResponse();
                    if (response) {
                        // enrich dependency target with correlation context from the server
                        var correlationContext = response[_DYN_CORRELATION_CONTEXT /* @min:%2ecorrelationContext */];
                        if (correlationContext) {
                            dependency.correlationContext = /* dependency.target + " | " + */ correlationContext;
                        }
                        if (response[_DYN_HEADER_MAP /* @min:%2eheaderMap */]) {
                            if (objKeys(response.headerMap)[_DYN_LENGTH$1 /* @min:%2elength */] > 0) {
                                props.responseHeaders = response[_DYN_HEADER_MAP /* @min:%2eheaderMap */];
                            }
                        }
                        if (self[_DYN_ERROR_STATUS_TEXT /* @min:%2eerrorStatusText */]) {
                            if (self[_DYN_STATUS /* @min:%2estatus */] >= 400) {
                                var responseType = response.type;
                                if (responseType === "" || responseType === "text") {
                                    props.responseText = response.responseText ? response[_DYN_STATUS_TEXT /* @min:%2estatusText */] + " - " + response[strResponseText] : response[_DYN_STATUS_TEXT /* @min:%2estatusText */];
                                }
                                if (responseType === "json") {
                                    props.responseText = response.response ? response[_DYN_STATUS_TEXT /* @min:%2estatusText */] + " - " + JSON.stringify(response[_DYN_RESPONSE /* @min:%2eresponse */]) : response[_DYN_STATUS_TEXT /* @min:%2estatusText */];
                                }
                            }
                            else if (self[_DYN_STATUS /* @min:%2estatus */] === 0) {
                                props.responseText = response[_DYN_STATUS_TEXT /* @min:%2estatusText */] || "";
                            }
                        }
                    }
                }
                return dependency;
            };
            self[_DYN_GET_PART_APROPS /* @min:%2egetPartAProps */] = function () {
                var _a;
                var partA = null;
                var traceCtx = self[_DYN_EVENT_TRACE_CTX /* @min:%2eeventTraceCtx */];
                if (traceCtx && (traceCtx[_DYN_TRACE_ID0 /* @min:%2etraceId */] || traceCtx[_DYN_SPAN_ID1 /* @min:%2espanId */])) {
                    partA = {};
                    var traceExt = partA[Extensions.TraceExt] = (_a = {},
                        _a[_DYN_TRACE_ID /* @min:traceID */] = traceCtx[_DYN_TRACE_ID0 /* @min:%2etraceId */],
                        _a.parentID = traceCtx[_DYN_SPAN_ID1 /* @min:%2espanId */],
                        _a);
                    if (!isNullOrUndefined(traceCtx[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */])) {
                        traceExt[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */] = traceCtx[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */];
                    }
                }
                return partA;
            };
        });
    }
// Removed Stub for ajaxRecord.prototype.getAbsoluteUrl.
// Removed Stub for ajaxRecord.prototype.getPathName.
// Removed Stub for ajaxRecord.prototype.CreateTrackItem.
// Removed Stub for ajaxRecord.prototype.getPartAProps.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    ajaxRecord.__ieDyn=1;

    return ajaxRecord;
}());

/*
 * Application Insights JavaScript SDK - Dependencies Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


var _a$2;
var strDiagLog = "diagLog";
var AJAX_DATA_CONTAINER = "_ajaxData";
var STR_FETCH = "fetch";
var ERROR_HEADER = "Failed to monitor XMLHttpRequest";
var ERROR_PREFIX = ", monitoring data for this ajax call ";
var ERROR_POSTFIX = ERROR_PREFIX + "may be incorrect.";
var ERROR_NOT_SENT = ERROR_PREFIX + "won't be sent.";
var CORRELATION_HEADER_ERROR = "Failed to get Request-Context correlation header as it may be not included in the response or not accessible.";
var CUSTOM_REQUEST_CONTEXT_ERROR = "Failed to add custom defined request context as configured call back may missing a null check.";
var FAILED_TO_CALCULATE_DURATION_ERROR = "Failed to calculate the duration of the ";
// Using a global value so that to handle same iKey with multiple app insights instances (mostly for testing)
var _markCount = 0;
/** @Ignore */
function _supportsFetch() {
    var _global = getGlobal();
    if (!_global ||
        isNullOrUndefined(_global.Request) ||
        isNullOrUndefined(_global.Request[strShimPrototype]) ||
        isNullOrUndefined(_global[STR_FETCH])) {
        return null;
    }
    return _global[STR_FETCH];
}
/**
 * Determines whether ajax monitoring can be enabled on this document
 * @returns True if Ajax monitoring is supported on this page, otherwise false
 * @ignore
 */
function _supportsAjaxMonitoring(ajaxMonitorInstance, ajaxDataId) {
    var _a, _b;
    var result = false;
    if (isXhrSupported()) {
        var proto = XMLHttpRequest[strShimPrototype];
        result = !isNullOrUndefined(proto) &&
            !isNullOrUndefined(proto.open) && // eslint-disable-line security/detect-non-literal-fs-filename -- false positive
            !isNullOrUndefined(proto.send) &&
            !isNullOrUndefined(proto.abort);
    }
    var ieVer = getIEVersion();
    if (ieVer && ieVer < 9) {
        result = false;
    }
    if (result) {
        // Disable if the XmlHttpRequest can't be extended or hooked
        try {
            var xhr = new XMLHttpRequest();
            var xhrData = {
                xh: [],
                i: (_a = {},
                    _a[ajaxDataId] = {},
                    _a)
            };
            xhr[AJAX_DATA_CONTAINER] = xhrData;
            // Check that we can update the prototype
            var theOpen = XMLHttpRequest[strShimPrototype].open;
            XMLHttpRequest[strShimPrototype].open = theOpen;
        }
        catch (e) {
            // We can't decorate the xhr object so disable monitoring
            result = false;
            _throwInternalCritical(ajaxMonitorInstance, 15 /* _eInternalMessageId.FailedMonitorAjaxOpen */, "Failed to enable XMLHttpRequest monitoring, extension is not supported", (_b = {},
                _b[_DYN_EXCEPTION /* @min:exception */] = dumpObj(e),
                _b));
        }
    }
    return result;
}
/**
 * Internal helper to fetch the SDK instance tracking data for this XHR request
 * @param xhr
 * @param ajaxDataId
 * @returns
 */
var _getAjaxData = function (xhr, ajaxDataId) {
    if (xhr && ajaxDataId && xhr[AJAX_DATA_CONTAINER]) {
        return (xhr[AJAX_DATA_CONTAINER].i || {})[ajaxDataId];
    }
    return null;
};
/**
 * @ignore
 * Internal helper to track the singleton shared tracking headers, so we can attempt to not create headers
 * that might cause an issue if multiple values are populated.
 * @param xhr - The instrumented XHR instance
 */
var _addSharedXhrHeaders = function (xhr, name, value) {
    if (xhr) {
        var headers = (xhr[AJAX_DATA_CONTAINER] || {}).xh;
        if (headers) {
            headers.push({
                n: name,
                v: value
            });
        }
    }
};
var _isHeaderSet = function (xhr, name) {
    var isPresent = false;
    if (xhr) {
        var headers = (xhr[AJAX_DATA_CONTAINER] || {}).xh;
        if (headers) {
            arrForEach(headers, function (header) {
                if (header.n === name) {
                    isPresent = true;
                    return -1;
                }
            });
        }
    }
    return isPresent;
};
/** @Ignore */
function _getFailedAjaxDiagnosticsMessage(xhr, ajaxDataId) {
    var result = "";
    try {
        var ajaxData = _getAjaxData(xhr, ajaxDataId);
        if (ajaxData && ajaxData[_DYN_REQUEST_URL /* @min:%2erequestUrl */]) {
            result += "(url: '" + ajaxData[_DYN_REQUEST_URL /* @min:%2erequestUrl */] + "')";
        }
    }
    catch (e) {
        // eslint-disable-next-line no-empty
    }
    return result;
}
/** @ignore */
function _throwInternalCritical(ajaxMonitorInstance, msgId, message, properties, isUserAct) {
    _throwInternal(ajaxMonitorInstance[strDiagLog](), 1 /* eLoggingSeverity.CRITICAL */, msgId, message, properties, isUserAct);
}
/** @ignore */
function _throwInternalWarning(ajaxMonitorInstance, msgId, message, properties, isUserAct) {
    _throwInternal(ajaxMonitorInstance[strDiagLog](), 2 /* eLoggingSeverity.WARNING */, msgId, message, properties, isUserAct);
}
/** @Ignore */
function _createErrorCallbackFunc(ajaxMonitorInstance, internalMessage, message) {
    // tslint:disable-next-line
    return function (callDetails) {
        var _a;
        _throwInternalCritical(ajaxMonitorInstance, internalMessage, message, (_a = {
                ajaxDiagnosticsMessage: _getFailedAjaxDiagnosticsMessage(callDetails[_DYN_INST /* @min:%2einst */], ajaxMonitorInstance._ajaxDataId)
            },
            _a[_DYN_EXCEPTION /* @min:exception */] = dumpObj(callDetails.err),
            _a));
    };
}
function _indexOf(value, match) {
    if (value && match) {
        return strIndexOf(value, match);
    }
    return -1;
}
function _addHandler(container, id, theFunc) {
    var theHandler = {
        id: id,
        fn: theFunc
    };
    container.push(theHandler);
    return {
        remove: function () {
            arrForEach(container, function (initializer, idx) {
                if (initializer.id === theHandler.id) {
                    container.splice(idx, 1);
                    return -1;
                }
            });
        }
    };
}
function _processDependencyContainer(core, container, details, message) {
    var result = true;
    arrForEach(container, function (theFunc, idx) {
        try {
            if (theFunc.fn.call(null, details) === false) {
                result = false;
            }
        }
        catch (e) {
            _throwInternal(core && core.logger, 1 /* eLoggingSeverity.CRITICAL */, 64 /* _eInternalMessageId.TelemetryInitializerFailed */, "Dependency " + message + " [#" + idx + "] failed: " + getExceptionName(e), { exception: dumpObj(e) }, true);
        }
    });
    return result;
}
function _processDependencyListeners(listeners, core, ajaxData, xhr, input, init) {
    var _a;
    var initializersCount = listeners[_DYN_LENGTH$1 /* @min:%2elength */];
    if (initializersCount > 0) {
        var details = (_a = {},
            _a[_DYN_CORE /* @min:core */] = core,
            _a.xhr = xhr,
            _a.input = input,
            _a.init = init,
            _a.traceId = ajaxData[_DYN_TRACE_ID /* @min:%2etraceID */],
            _a.spanId = ajaxData[_DYN_SPAN_ID /* @min:%2espanID */],
            _a.traceFlags = ajaxData[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */],
            _a.context = ajaxData[_DYN_CONTEXT$1 /* @min:%2econtext */] || {},
            _a.aborted = !!ajaxData[_DYN_ABORTED /* @min:%2eaborted */],
            _a);
        _processDependencyContainer(core, listeners, details, "listener");
        ajaxData[_DYN_TRACE_ID /* @min:%2etraceID */] = details[_DYN_TRACE_ID0 /* @min:%2etraceId */];
        ajaxData[_DYN_SPAN_ID /* @min:%2espanID */] = details[_DYN_SPAN_ID1 /* @min:%2espanId */];
        ajaxData[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */] = details[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */];
        ajaxData[_DYN_CONTEXT$1 /* @min:%2econtext */] = details[_DYN_CONTEXT$1 /* @min:%2econtext */];
    }
}
var BLOB_CORE = "*.blob.core.";
var DfltAjaxCorrelationHeaderExDomains = objFreeze([
    BLOB_CORE + "windows.net",
    BLOB_CORE + "chinacloudapi.cn",
    BLOB_CORE + "cloudapi.de",
    BLOB_CORE + "usgovcloudapi.net"
]);
var _internalExcludeEndpoints = [
    /https:\/\/[^\/]*(\.pipe\.aria|aria\.pipe|events\.data|collector\.azure)\.[^\/]+\/(OneCollector\/1|Collector\/3)\.0/i
];
var _defaultConfig$1 = objFreeze((_a$2 = {},
    _a$2[_DYN_MAX_AJAX_CALLS_PER_V7 /* @min:maxAjaxCallsPerView */] = 500,
    _a$2[_DYN_DISABLE_AJAX_TRACKIN9 /* @min:disableAjaxTracking */] = false,
    _a$2[_DYN_DISABLE_FETCH_TRACKI11 /* @min:disableFetchTracking */] = false,
    _a$2[_DYN_EXCLUDE_REQUEST_FROM8 /* @min:excludeRequestFromAutoTrackingPatterns */] = undefined,
    _a$2.disableCorrelationHeaders = false,
    _a$2.distributedTracingMode = 1 /* eDistributedTracingModes.AI_AND_W3C */,
    _a$2.correlationHeaderExcludedDomains = DfltAjaxCorrelationHeaderExDomains,
    _a$2.correlationHeaderDomains = undefined,
    _a$2.correlationHeaderExcludePatterns = undefined,
    _a$2.appId = undefined,
    _a$2.enableCorsCorrelation = false,
    _a$2[_DYN_ENABLE_REQUEST_HEADE4 /* @min:enableRequestHeaderTracking */] = false,
    _a$2[_DYN_ENABLE_RESPONSE_HEAD12 /* @min:enableResponseHeaderTracking */] = false,
    _a$2[_DYN_ENABLE_AJAX_ERROR_ST5 /* @min:enableAjaxErrorStatusText */] = false,
    _a$2[_DYN_ENABLE_AJAX_PERF_TRA6 /* @min:enableAjaxPerfTracking */] = false,
    _a$2.maxAjaxPerfLookupAttempts = 3,
    _a$2[_DYN_AJAX_PERF_LOOKUP_DEL10 /* @min:ajaxPerfLookupDelay */] = 25,
    _a$2.ignoreHeaders = [
        "Authorization",
        "X-API-Key",
        "WWW-Authenticate"
    ],
    _a$2[_DYN_ADD_REQUEST_CONTEXT /* @min:addRequestContext */] = undefined,
    _a$2.addIntEndpoints = true,
    _a$2));
var AjaxMonitor = /** @class */ (function (_super) {
    __extendsFn(AjaxMonitor, _super);
    function AjaxMonitor() {
        var _this = _super.call(this) || this;
        _this.identifier = AjaxMonitor.identifier;
        _this.priority = 120;
        var _fetchInitialized; // fetch monitoring initialized
        var _xhrInitialized; // XHR monitoring initialized
        var _currentWindowHost;
        var _extensionConfig;
        var _enableRequestHeaderTracking;
        var _enableAjaxErrorStatusText;
        var _trackAjaxAttempts;
        var _context;
        var _isUsingW3CHeaders;
        var _isUsingAIHeaders;
        var _markPrefix;
        var _enableAjaxPerfTracking;
        var _maxAjaxCallsPerView;
        var _enableResponseHeaderTracking;
        var _disabledUrls;
        var _disableAjaxTracking;
        var _disableFetchTracking;
        var _excludeRequestFromAutoTrackingPatterns;
        var _addRequestContext;
        var _evtNamespace;
        var _ajaxDataId;
        var _dependencyHandlerId;
        var _dependencyListeners;
        var _dependencyInitializers;
        var _ignoreHeaders;
        var _maxAjaxPerfLookupAttempts;
        var _ajaxPerfLookupDelay;
        var _distributedTracingMode;
        var _appId;
        var _polyfillInitialized;
        dynamicProto(AjaxMonitor, _this, function (_self, _base) {
            var _addHook = _base[_DYN__ADD_HOOK /* @min:%2e_addHook */];
            _initDefaults();
            _self.initialize = function (config, core, extensions, pluginChain) {
                if (!_self.isInitialized()) {
                    _base.initialize(config, core, extensions, pluginChain);
                    _evtNamespace = mergeEvtNamespace(createUniqueNamespace("ajax"), core && core.evtNamespace && core.evtNamespace());
                    _populateDefaults(config);
                    _instrumentXhr();
                    _instrumentFetch();
                    _populateContext();
                }
            };
            _self._doTeardown = function () {
                _initDefaults();
            };
            _self.trackDependencyData = function (dependency, properties) {
                _reportDependencyInternal(_dependencyInitializers, _self[_DYN_CORE /* @min:%2ecore */], null, dependency, properties);
            };
            _self[_DYN_INCLUDE_CORRELATION_2 /* @min:%2eincludeCorrelationHeaders */] = function (ajaxData, input, init, xhr) {
                // Test Hook to allow the overriding of the location host
                var currentWindowHost = _self["_currentWindowHost"] || _currentWindowHost;
                _processDependencyListeners(_dependencyListeners, _self[_DYN_CORE /* @min:%2ecore */], ajaxData, xhr, input, init);
                if (input || input === "") { // Fetch
                    if (correlationIdCanIncludeCorrelationHeader(_extensionConfig, ajaxData[_DYN_GET_ABSOLUTE_URL /* @min:%2egetAbsoluteUrl */](), currentWindowHost)) {
                        if (!init) {
                            init = {};
                        }
                        // init headers override original request headers
                        // so, if they exist use only them, otherwise use request's because they should have been applied in the first place
                        // not using original request headers will result in them being lost
                        var headers = new Headers(init[_DYN_HEADERS /* @min:%2eheaders */] || (input instanceof Request ? (input[_DYN_HEADERS /* @min:%2eheaders */] || {}) : {}));
                        if (_isUsingAIHeaders) {
                            var id = "|" + ajaxData[_DYN_TRACE_ID /* @min:%2etraceID */] + "." + ajaxData[_DYN_SPAN_ID /* @min:%2espanID */];
                            headers.set(RequestHeaders[3 /* eRequestHeaders.requestIdHeader */], id);
                            if (_enableRequestHeaderTracking) {
                                ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */][RequestHeaders[3 /* eRequestHeaders.requestIdHeader */]] = id;
                            }
                        }
                        var appId = _appId || (_context && _context.appId());
                        if (appId) {
                            headers.set(RequestHeaders[0 /* eRequestHeaders.requestContextHeader */], RequestHeaders[2 /* eRequestHeaders.requestContextAppIdFormat */] + appId);
                            if (_enableRequestHeaderTracking) {
                                ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */][RequestHeaders[0 /* eRequestHeaders.requestContextHeader */]] = RequestHeaders[2 /* eRequestHeaders.requestContextAppIdFormat */] + appId;
                            }
                        }
                        if (_isUsingW3CHeaders) {
                            var traceFlags = ajaxData[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */];
                            if (isNullOrUndefined(traceFlags)) {
                                traceFlags = 0x01;
                            }
                            var traceParent = formatTraceParent(createTraceParent(ajaxData[_DYN_TRACE_ID /* @min:%2etraceID */], ajaxData[_DYN_SPAN_ID /* @min:%2espanID */], traceFlags));
                            headers.set(RequestHeaders[4 /* eRequestHeaders.traceParentHeader */], traceParent);
                            if (_enableRequestHeaderTracking) {
                                ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */][RequestHeaders[4 /* eRequestHeaders.traceParentHeader */]] = traceParent;
                            }
                        }
                        init[_DYN_HEADERS /* @min:%2eheaders */] = headers;
                    }
                    return init;
                }
                else if (xhr) { // XHR
                    if (correlationIdCanIncludeCorrelationHeader(_extensionConfig, ajaxData[_DYN_GET_ABSOLUTE_URL /* @min:%2egetAbsoluteUrl */](), currentWindowHost)) {
                        if (_isUsingAIHeaders) {
                            if (!_isHeaderSet(xhr, RequestHeaders[3 /* eRequestHeaders.requestIdHeader */])) {
                                var id = "|" + ajaxData[_DYN_TRACE_ID /* @min:%2etraceID */] + "." + ajaxData[_DYN_SPAN_ID /* @min:%2espanID */];
                                xhr[_DYN_SET_REQUEST_HEADER /* @min:%2esetRequestHeader */](RequestHeaders[3 /* eRequestHeaders.requestIdHeader */], id);
                                if (_enableRequestHeaderTracking) {
                                    ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */][RequestHeaders[3 /* eRequestHeaders.requestIdHeader */]] = id;
                                }
                            }
                            else {
                                _throwInternalWarning(_self, 71 /* _eInternalMessageId.FailedMonitorAjaxSetRequestHeader */, "Unable to set [" + RequestHeaders[3 /* eRequestHeaders.requestIdHeader */] + "] as it has already been set by another instance");
                            }
                        }
                        var appId = _appId || (_context && _context.appId());
                        if (appId) {
                            if (!_isHeaderSet(xhr, RequestHeaders[0 /* eRequestHeaders.requestContextHeader */])) {
                                xhr[_DYN_SET_REQUEST_HEADER /* @min:%2esetRequestHeader */](RequestHeaders[0 /* eRequestHeaders.requestContextHeader */], RequestHeaders[2 /* eRequestHeaders.requestContextAppIdFormat */] + appId);
                                if (_enableRequestHeaderTracking) {
                                    ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */][RequestHeaders[0 /* eRequestHeaders.requestContextHeader */]] = RequestHeaders[2 /* eRequestHeaders.requestContextAppIdFormat */] + appId;
                                }
                            }
                            else {
                                _throwInternalWarning(_self, 71 /* _eInternalMessageId.FailedMonitorAjaxSetRequestHeader */, "Unable to set [" + RequestHeaders[0 /* eRequestHeaders.requestContextHeader */] + "] as it has already been set by another instance");
                            }
                        }
                        if (_isUsingW3CHeaders) {
                            var traceFlags = ajaxData[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */];
                            if (isNullOrUndefined(traceFlags)) {
                                traceFlags = 0x01;
                            }
                            if (!_isHeaderSet(xhr, RequestHeaders[4 /* eRequestHeaders.traceParentHeader */])) {
                                var traceParent = formatTraceParent(createTraceParent(ajaxData[_DYN_TRACE_ID /* @min:%2etraceID */], ajaxData[_DYN_SPAN_ID /* @min:%2espanID */], traceFlags));
                                xhr[_DYN_SET_REQUEST_HEADER /* @min:%2esetRequestHeader */](RequestHeaders[4 /* eRequestHeaders.traceParentHeader */], traceParent);
                                if (_enableRequestHeaderTracking) {
                                    ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */][RequestHeaders[4 /* eRequestHeaders.traceParentHeader */]] = traceParent;
                                }
                            }
                            else {
                                _throwInternalWarning(_self, 71 /* _eInternalMessageId.FailedMonitorAjaxSetRequestHeader */, "Unable to set [" + RequestHeaders[4 /* eRequestHeaders.traceParentHeader */] + "] as it has already been set by another instance");
                            }
                        }
                    }
                    return xhr;
                }
                return undefined;
            };
            _self[_DYN_TRACK_DEPENDENCY_DAT3 /* @min:%2etrackDependencyDataInternal */] = function (dependency, properties, systemProperties) {
                if (_maxAjaxCallsPerView === -1 || _trackAjaxAttempts < _maxAjaxCallsPerView) {
                    // Hack since expected format in w3c mode is |abc.def.
                    // Non-w3c format is |abc.def
                    // @todo Remove if better solution is available, e.g. handle in portal
                    if ((_distributedTracingMode === 2 /* eDistributedTracingModes.W3C */
                        || _distributedTracingMode === 1 /* eDistributedTracingModes.AI_AND_W3C */)
                        && typeof dependency.id === "string" && dependency.id[dependency.id[_DYN_LENGTH$1 /* @min:%2elength */] - 1] !== ".") {
                        dependency.id += ".";
                    }
                    if (isNullOrUndefined(dependency[_DYN_START_TIME /* @min:%2estartTime */])) {
                        dependency[_DYN_START_TIME /* @min:%2estartTime */] = new Date();
                    }
                    var item = createTelemetryItem(dependency, RemoteDependencyData.dataType, RemoteDependencyData.envelopeType, _self[strDiagLog](), properties, systemProperties);
                    _self[_DYN_CORE /* @min:%2ecore */].track(item);
                }
                else if (_trackAjaxAttempts === _maxAjaxCallsPerView) {
                    _throwInternalCritical(_self, 55 /* _eInternalMessageId.MaxAjaxPerPVExceeded */, "Maximum ajax per page view limit reached, ajax monitoring is paused until the next trackPageView(). In order to increase the limit set the maxAjaxCallsPerView configuration parameter.", true);
                }
                ++_trackAjaxAttempts;
            };
            _self.addDependencyListener = function (dependencyListener) {
                return _addHandler(_dependencyListeners, _dependencyHandlerId++, dependencyListener);
            };
            _self.addDependencyInitializer = function (dependencyInitializer) {
                return _addHandler(_dependencyInitializers, _dependencyHandlerId++, dependencyInitializer);
            };
            function _initDefaults() {
                var location = getLocation();
                _fetchInitialized = false; // fetch monitoring initialized
                _xhrInitialized = false; // XHR monitoring initialized
                _polyfillInitialized = false; // polyfill monitoring initialized
                _currentWindowHost = location && location.host && location.host[_DYN_TO_LOWER_CASE /* @min:%2etoLowerCase */]();
                _extensionConfig = null;
                _enableRequestHeaderTracking = false;
                _enableAjaxErrorStatusText = false;
                _trackAjaxAttempts = 0;
                _context = null;
                _isUsingW3CHeaders = false;
                _isUsingAIHeaders = false;
                _markPrefix = null;
                _enableAjaxPerfTracking = false;
                _maxAjaxCallsPerView = 0;
                _enableResponseHeaderTracking = false;
                _disabledUrls = {};
                _disableAjaxTracking = false;
                _disableFetchTracking = false;
                _excludeRequestFromAutoTrackingPatterns = null;
                _addRequestContext = null;
                _evtNamespace = null;
                _dependencyHandlerId = 0;
                _dependencyListeners = [];
                _dependencyInitializers = [];
                _ajaxDataId = createUniqueNamespace("ajaxData");
                _self._ajaxDataId = _ajaxDataId;
                _ignoreHeaders = null;
                _maxAjaxPerfLookupAttempts = 1;
                _ajaxPerfLookupDelay = 1;
                _distributedTracingMode = 1 /* eDistributedTracingModes.AI_AND_W3C */;
                _appId = null;
            }
            function _populateDefaults(config) {
                _self[_DYN__ADD_HOOK /* @min:%2e_addHook */](onConfigChange(config, function (details) {
                    var config = details.cfg;
                    var ctx = createProcessTelemetryContext(null, config, _self[_DYN_CORE /* @min:%2ecore */]);
                    _extensionConfig = ctx.getExtCfg(AjaxMonitor.identifier, _defaultConfig$1);
                    _distributedTracingMode = _extensionConfig.distributedTracingMode;
                    _enableRequestHeaderTracking = _extensionConfig[_DYN_ENABLE_REQUEST_HEADE4 /* @min:%2eenableRequestHeaderTracking */];
                    _enableAjaxErrorStatusText = _extensionConfig[_DYN_ENABLE_AJAX_ERROR_ST5 /* @min:%2eenableAjaxErrorStatusText */];
                    _enableAjaxPerfTracking = _extensionConfig[_DYN_ENABLE_AJAX_PERF_TRA6 /* @min:%2eenableAjaxPerfTracking */];
                    _maxAjaxCallsPerView = _extensionConfig[_DYN_MAX_AJAX_CALLS_PER_V7 /* @min:%2emaxAjaxCallsPerView */];
                    _excludeRequestFromAutoTrackingPatterns = [].concat(_extensionConfig[_DYN_EXCLUDE_REQUEST_FROM8 /* @min:%2eexcludeRequestFromAutoTrackingPatterns */] || [], _extensionConfig.addIntEndpoints !== false ? _internalExcludeEndpoints : []);
                    _addRequestContext = _extensionConfig[_DYN_ADD_REQUEST_CONTEXT /* @min:%2eaddRequestContext */];
                    _isUsingAIHeaders = _distributedTracingMode === 0 /* eDistributedTracingModes.AI */ || _distributedTracingMode === 1 /* eDistributedTracingModes.AI_AND_W3C */;
                    _isUsingW3CHeaders = _distributedTracingMode === 1 /* eDistributedTracingModes.AI_AND_W3C */ || _distributedTracingMode === 2 /* eDistributedTracingModes.W3C */;
                    if (_enableAjaxPerfTracking) {
                        _markPrefix = _ajaxDataId;
                    }
                    _disableAjaxTracking = !!_extensionConfig[_DYN_DISABLE_AJAX_TRACKIN9 /* @min:%2edisableAjaxTracking */];
                    _maxAjaxPerfLookupAttempts = _extensionConfig.maxAjaxPerfLookupAttempts;
                    _ajaxPerfLookupDelay = _extensionConfig[_DYN_AJAX_PERF_LOOKUP_DEL10 /* @min:%2eajaxPerfLookupDelay */];
                    _ignoreHeaders = _extensionConfig.ignoreHeaders;
                    _appId = _extensionConfig.appId;
                }));
            }
            function _populateContext() {
                var propExt = _self[_DYN_CORE /* @min:%2ecore */].getPlugin(PropertiesPluginIdentifier);
                if (propExt) {
                    _context = propExt.plugin[_DYN_CONTEXT$1 /* @min:%2econtext */]; // we could move IPropertiesPlugin to common as well
                }
            }
            // discard the header if it's defined as ignoreHeaders in ICorrelationConfig
            function _canIncludeHeaders(header) {
                var rlt = true;
                if (header || _ignoreHeaders) {
                    arrForEach(_ignoreHeaders, (function (key) {
                        if (key[_DYN_TO_LOWER_CASE /* @min:%2etoLowerCase */]() === header[_DYN_TO_LOWER_CASE /* @min:%2etoLowerCase */]()) {
                            rlt = false;
                            return -1;
                        }
                    }));
                }
                return rlt;
            }
            // Fetch Stuff
            function _instrumentFetch() {
                var fetch = _supportsFetch();
                if (!fetch) {
                    return;
                }
                var global = getGlobal();
                var isPolyfill = fetch.polyfill;
                _self[_DYN__ADD_HOOK /* @min:%2e_addHook */](onConfigChange(_extensionConfig, function () {
                    _disableFetchTracking = !!_extensionConfig[_DYN_DISABLE_FETCH_TRACKI11 /* @min:%2edisableFetchTracking */];
                    _enableResponseHeaderTracking = _extensionConfig[_DYN_ENABLE_RESPONSE_HEAD12 /* @min:%2eenableResponseHeaderTracking */];
                    if (!_disableFetchTracking && !_fetchInitialized) {
                        _addHook(InstrumentFunc(global, STR_FETCH, {
                            ns: _evtNamespace,
                            // Add request hook
                            req: function (callDetails, input, init) {
                                var fetchData;
                                if (!_disableFetchTracking && _fetchInitialized &&
                                    !_isDisabledRequest(null, input, init) &&
                                    // If we have a polyfil and XHR instrumented then let XHR report otherwise we get duplicates
                                    !(isPolyfill && _xhrInitialized)) {
                                    var ctx = callDetails.ctx();
                                    fetchData = _createFetchRecord(input, init);
                                    var newInit = _self[_DYN_INCLUDE_CORRELATION_2 /* @min:%2eincludeCorrelationHeaders */](fetchData, input, init);
                                    if (newInit !== init) {
                                        callDetails.set(1, newInit);
                                    }
                                    ctx.data = fetchData;
                                }
                            },
                            rsp: function (callDetails, input) {
                                if (!_disableFetchTracking) {
                                    var fetchData_1 = callDetails.ctx().data;
                                    if (fetchData_1) {
                                        // Replace the result with the new promise from this code
                                        callDetails.rslt = callDetails.rslt.then(function (response) {
                                            _reportFetchMetrics(callDetails, (response || {})[_DYN_STATUS /* @min:%2estatus */], input, response, fetchData_1, function () {
                                                var _a;
                                                var ajaxResponse = (_a = {
                                                        statusText: (response || {})[_DYN_STATUS_TEXT /* @min:%2estatusText */]
                                                    },
                                                    _a[_DYN_HEADER_MAP /* @min:headerMap */] = null,
                                                    _a[_DYN_CORRELATION_CONTEXT /* @min:correlationContext */] = _getFetchCorrelationContext(response),
                                                    _a);
                                                if (_enableResponseHeaderTracking && response) {
                                                    var responseHeaderMap_1 = {};
                                                    response.headers.forEach(function (value, name) {
                                                        if (_canIncludeHeaders(name)) {
                                                            responseHeaderMap_1[name] = value;
                                                        }
                                                    });
                                                    ajaxResponse[_DYN_HEADER_MAP /* @min:%2eheaderMap */] = responseHeaderMap_1;
                                                }
                                                return ajaxResponse;
                                            });
                                            return response;
                                        })
                                            .catch(function (reason) {
                                            _reportFetchMetrics(callDetails, 0, input, null, fetchData_1, null, { error: reason.message || dumpObj(reason) });
                                            throw reason;
                                        });
                                    }
                                }
                            },
                            // Create an error callback to report any hook errors
                            hkErr: _createErrorCallbackFunc(_self, 15 /* _eInternalMessageId.FailedMonitorAjaxOpen */, "Failed to monitor Window.fetch" + ERROR_POSTFIX)
                        }, true, isWebWorker()));
                        _fetchInitialized = true;
                    }
                    else if (isPolyfill && !_polyfillInitialized) {
                        // If fetch is a polyfill we need to capture the request to ensure that we correctly track
                        // disabled request URLS (i.e. internal urls) to ensure we don't end up in a constant loop
                        // of reporting ourselves, for example React Native uses a polyfill for fetch
                        // Note: Polyfill implementations that don't support the "polyfill" tag are not supported
                        // the workaround is to add a polyfill property to your fetch implementation before initializing
                        // App Insights
                        _addHook(InstrumentFunc(global, STR_FETCH, {
                            ns: _evtNamespace,
                            req: function (callDetails, input, init) {
                                // Just call so that we record any disabled URL
                                _isDisabledRequest(null, input, init);
                            }
                        }));
                        _polyfillInitialized = true;
                    }
                }));
                if (isPolyfill) {
                    // retag the instrumented fetch with the same polyfill settings this is mostly for testing
                    // But also supports multiple App Insights usages
                    global[STR_FETCH].polyfill = isPolyfill;
                }
            }
            function _hookProto(target, funcName, callbacks) {
                _addHook(InstrumentProto(target, funcName, callbacks));
            }
            function _instrumentXhr() {
                if (!_supportsAjaxMonitoring(_self, _ajaxDataId)) {
                    return;
                }
                _self[_DYN__ADD_HOOK /* @min:%2e_addHook */](onConfigChange(_extensionConfig, function () {
                    _disableAjaxTracking = !!_extensionConfig[_DYN_DISABLE_AJAX_TRACKIN9 /* @min:%2edisableAjaxTracking */];
                    _enableRequestHeaderTracking = _extensionConfig[_DYN_ENABLE_REQUEST_HEADE4 /* @min:%2eenableRequestHeaderTracking */];
                    if (!_disableAjaxTracking && !_xhrInitialized) {
                        // Instrument open
                        _hookProto(XMLHttpRequest, "open", {
                            ns: _evtNamespace,
                            req: function (callDetails, method, url, async) {
                                if (!_disableAjaxTracking) {
                                    var xhr = callDetails[_DYN_INST /* @min:%2einst */];
                                    var ajaxData = _getAjaxData(xhr, _ajaxDataId);
                                    if (!_isDisabledRequest(xhr, url) && _isMonitoredXhrInstance(xhr, ajaxData, true)) {
                                        if (!ajaxData || !ajaxData.xhrMonitoringState[_DYN_OPEN_DONE /* @min:%2eopenDone */]) {
                                            // Only create a single ajaxData (even when multiple AI instances are running)
                                            ajaxData = _openHandler(xhr, method, url, async);
                                        }
                                        // always attach to the on ready state change (required for handling multiple instances)
                                        _attachToOnReadyStateChange(xhr, ajaxData);
                                    }
                                }
                            },
                            hkErr: _createErrorCallbackFunc(_self, 15 /* _eInternalMessageId.FailedMonitorAjaxOpen */, ERROR_HEADER + ".open" + ERROR_POSTFIX)
                        });
                        // Instrument send
                        _hookProto(XMLHttpRequest, "send", {
                            ns: _evtNamespace,
                            req: function (callDetails, context) {
                                if (!_disableAjaxTracking) {
                                    var xhr = callDetails[_DYN_INST /* @min:%2einst */];
                                    var ajaxData = _getAjaxData(xhr, _ajaxDataId);
                                    if (_isMonitoredXhrInstance(xhr, ajaxData) && !ajaxData.xhrMonitoringState[_DYN_SEND_DONE /* @min:%2esendDone */]) {
                                        _createMarkId("xhr", ajaxData);
                                        ajaxData[_DYN_REQUEST_SENT_TIME /* @min:%2erequestSentTime */] = dateTimeUtilsNow();
                                        _self[_DYN_INCLUDE_CORRELATION_2 /* @min:%2eincludeCorrelationHeaders */](ajaxData, undefined, undefined, xhr);
                                        ajaxData.xhrMonitoringState[_DYN_SEND_DONE /* @min:%2esendDone */] = true;
                                    }
                                }
                            },
                            hkErr: _createErrorCallbackFunc(_self, 17 /* _eInternalMessageId.FailedMonitorAjaxSend */, ERROR_HEADER + ERROR_POSTFIX)
                        });
                        // Instrument abort
                        _hookProto(XMLHttpRequest, "abort", {
                            ns: _evtNamespace,
                            req: function (callDetails) {
                                if (!_disableAjaxTracking) {
                                    var xhr = callDetails[_DYN_INST /* @min:%2einst */];
                                    var ajaxData = _getAjaxData(xhr, _ajaxDataId);
                                    if (_isMonitoredXhrInstance(xhr, ajaxData) && !ajaxData.xhrMonitoringState[_DYN_ABORT_DONE /* @min:%2eabortDone */]) {
                                        ajaxData[_DYN_ABORTED /* @min:%2eaborted */] = 1;
                                        ajaxData.xhrMonitoringState[_DYN_ABORT_DONE /* @min:%2eabortDone */] = true;
                                    }
                                }
                            },
                            hkErr: _createErrorCallbackFunc(_self, 13 /* _eInternalMessageId.FailedMonitorAjaxAbort */, ERROR_HEADER + ".abort" + ERROR_POSTFIX)
                        });
                        // Instrument setRequestHeader
                        _hookProto(XMLHttpRequest, "setRequestHeader", {
                            ns: _evtNamespace,
                            req: function (callDetails, header, value) {
                                if (!_disableAjaxTracking) {
                                    var xhr = callDetails[_DYN_INST /* @min:%2einst */];
                                    var ajaxData = _getAjaxData(xhr, _ajaxDataId);
                                    if (ajaxData && _isMonitoredXhrInstance(xhr, ajaxData)) {
                                        _addSharedXhrHeaders(xhr, header, value);
                                        if (_enableRequestHeaderTracking && _canIncludeHeaders(header)) {
                                            if (ajaxData) {
                                                ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */][header] = value;
                                            }
                                        }
                                    }
                                }
                            },
                            hkErr: _createErrorCallbackFunc(_self, 71 /* _eInternalMessageId.FailedMonitorAjaxSetRequestHeader */, ERROR_HEADER + ".setRequestHeader" + ERROR_POSTFIX)
                        });
                        _xhrInitialized = true;
                    }
                }));
            }
            function _isDisabledRequest(xhr, request, init) {
                var isDisabled = false;
                var theUrl = ((!isString(request) ? (request || {}).url || "" : request) || "")[_DYN_TO_LOWER_CASE /* @min:%2etoLowerCase */]();
                // check excludeRequestFromAutoTrackingPatterns before stripping off any query string
                arrForEach(_excludeRequestFromAutoTrackingPatterns, function (regex) {
                    var theRegex = regex;
                    if (isString(regex)) {
                        theRegex = new RegExp(regex);
                    }
                    if (!isDisabled) {
                        isDisabled = theRegex.test(theUrl);
                    }
                });
                // if request url matches with exclude regex pattern, return true and no need to check for headers
                if (isDisabled) {
                    return isDisabled;
                }
                var idx = _indexOf(theUrl, "?");
                var idx2 = _indexOf(theUrl, "#");
                if (idx === -1 || (idx2 !== -1 && idx2 < idx)) {
                    idx = idx2;
                }
                if (idx !== -1) {
                    // Strip off any Query string
                    theUrl = theUrl.substring(0, idx);
                }
                // check that this instance is not not used by ajax call performed inside client side monitoring to send data to collector
                if (!isNullOrUndefined(xhr)) {
                    // Look on the XMLHttpRequest of the URL string value
                    isDisabled = xhr[DisabledPropertyName] === true || theUrl[DisabledPropertyName] === true;
                }
                else if (!isNullOrUndefined(request)) { // fetch
                    // Look for DisabledPropertyName in either Request or RequestInit
                    isDisabled = (typeof request === "object" ? request[DisabledPropertyName] === true : false) ||
                        (init ? init[DisabledPropertyName] === true : false);
                }
                // Also add extra check just in case the XHR or fetch objects where not decorated with the DisableProperty due to sealing or freezing
                if (!isDisabled && theUrl && isInternalApplicationInsightsEndpoint(theUrl)) {
                    isDisabled = true;
                }
                if (isDisabled) {
                    // Add the disabled url if not present
                    if (!_disabledUrls[theUrl]) {
                        _disabledUrls[theUrl] = 1;
                    }
                }
                else {
                    // Check to see if the url is listed as disabled
                    if (_disabledUrls[theUrl]) {
                        isDisabled = true;
                    }
                }
                return isDisabled;
            }
            /// <summary>Verifies that particular instance of XMLHttpRequest needs to be monitored</summary>
            /// <param name="excludeAjaxDataValidation">Optional parameter. True if ajaxData must be excluded from verification</param>
            /// <returns type="bool">True if instance needs to be monitored, otherwise false</returns>
            function _isMonitoredXhrInstance(xhr, ajaxData, excludeAjaxDataValidation) {
                var ajaxValidation = true;
                var initialized = _xhrInitialized;
                if (!isNullOrUndefined(xhr)) {
                    ajaxValidation = excludeAjaxDataValidation === true || !isNullOrUndefined(ajaxData);
                }
                // checking to see that all interested functions on xhr were instrumented
                return initialized
                    // checking on ajaxData to see that it was not removed in user code
                    && ajaxValidation;
            }
            function _getDistributedTraceCtx() {
                var distributedTraceCtx = null;
                if (_self[_DYN_CORE /* @min:%2ecore */] && _self[_DYN_CORE /* @min:%2ecore */].getTraceCtx) {
                    distributedTraceCtx = _self[_DYN_CORE /* @min:%2ecore */].getTraceCtx(false);
                }
                // Fall back
                if (!distributedTraceCtx && _context && _context.telemetryTrace) {
                    distributedTraceCtx = createDistributedTraceContextFromTrace(_context.telemetryTrace);
                }
                return distributedTraceCtx;
            }
            function _openHandler(xhr, method, url, async) {
                var _a;
                var distributedTraceCtx = _getDistributedTraceCtx();
                var traceID = (distributedTraceCtx && distributedTraceCtx[_DYN_GET_TRACE_ID /* @min:%2egetTraceId */]()) || generateW3CId();
                var spanID = strSubstr(generateW3CId(), 0, 16);
                var xhrRequestData = xhr[AJAX_DATA_CONTAINER] = (xhr[AJAX_DATA_CONTAINER] || { xh: [], i: {} });
                var ajaxDataCntr = xhrRequestData.i = (xhrRequestData.i || {});
                var ajaxData = ajaxDataCntr[_ajaxDataId] = (ajaxDataCntr[_ajaxDataId] || new ajaxRecord(traceID, spanID, _self[strDiagLog](), (_a = _self.core) === null || _a === void 0 ? void 0 : _a.getTraceCtx()));
                ajaxData[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */] = distributedTraceCtx && distributedTraceCtx[_DYN_GET_TRACE_FLAGS /* @min:%2egetTraceFlags */]();
                ajaxData[_DYN_METHOD /* @min:%2emethod */] = method;
                ajaxData[_DYN_REQUEST_URL /* @min:%2erequestUrl */] = url;
                ajaxData.xhrMonitoringState[_DYN_OPEN_DONE /* @min:%2eopenDone */] = true;
                ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */] = {};
                ajaxData.async = async;
                ajaxData[_DYN_ERROR_STATUS_TEXT /* @min:%2eerrorStatusText */] = _enableAjaxErrorStatusText;
                return ajaxData;
            }
            function _attachToOnReadyStateChange(xhr, ajaxData) {
                ajaxData.xhrMonitoringState[_DYN_STATE_CHANGE_ATTACHE13 /* @min:%2estateChangeAttached */] = eventOn(xhr, "readystatechange", function () {
                    var _a;
                    try {
                        if (xhr && xhr.readyState === 4 && _isMonitoredXhrInstance(xhr, ajaxData)) {
                            _onAjaxComplete(xhr);
                        }
                    }
                    catch (e) {
                        var exceptionText = dumpObj(e);
                        // ignore messages with c00c023f, as this a known IE9 XHR abort issue
                        if (!exceptionText || _indexOf(exceptionText[_DYN_TO_LOWER_CASE /* @min:%2etoLowerCase */](), "c00c023f") === -1) {
                            _throwInternalCritical(_self, 16 /* _eInternalMessageId.FailedMonitorAjaxRSC */, ERROR_HEADER + " 'readystatechange' event handler" + ERROR_POSTFIX, (_a = {},
                                _a[_DYN_AJAX_DIAGNOSTICS_MES16 /* @min:ajaxDiagnosticsMessage */] = _getFailedAjaxDiagnosticsMessage(xhr, _ajaxDataId),
                                _a[_DYN_EXCEPTION /* @min:exception */] = exceptionText,
                                _a));
                        }
                    }
                }, _evtNamespace);
            }
            function _getResponseText(xhr) {
                try {
                    var responseType = xhr.responseType;
                    if (responseType === "" || responseType === "text") {
                        // As per the specification responseText is only valid if the type is an empty string or "text"
                        return xhr[_DYN_RESPONSE_TEXT /* @min:%2eresponseText */];
                    }
                }
                catch (e) {
                    // This shouldn't happen because of the above check -- but just in case, so just ignore
                }
                return null;
            }
            function _onAjaxComplete(xhr) {
                var ajaxData = _getAjaxData(xhr, _ajaxDataId);
                ajaxData[_DYN_RESPONSE_FINISHED_TI14 /* @min:%2eresponseFinishedTime */] = dateTimeUtilsNow();
                ajaxData[_DYN_STATUS /* @min:%2estatus */] = xhr[_DYN_STATUS /* @min:%2estatus */];
                function _reportXhrError(e, failedProps) {
                    var errorProps = failedProps || {};
                    errorProps["ajaxDiagnosticsMessage"] = _getFailedAjaxDiagnosticsMessage(xhr, _ajaxDataId);
                    if (e) {
                        errorProps["exception"] = dumpObj(e);
                    }
                    _throwInternalWarning(_self, 14 /* _eInternalMessageId.FailedMonitorAjaxDur */, FAILED_TO_CALCULATE_DURATION_ERROR + "ajax call" + ERROR_NOT_SENT, errorProps);
                }
                _findPerfResourceEntry("xmlhttprequest", ajaxData, function () {
                    try {
                        var dependency = ajaxData[_DYN__CREATE_TRACK_ITEM /* @min:%2eCreateTrackItem */]("Ajax", _enableRequestHeaderTracking, function () {
                            var _a;
                            var ajaxResponse = (_a = {
                                    statusText: xhr[_DYN_STATUS_TEXT /* @min:%2estatusText */]
                                },
                                _a[_DYN_HEADER_MAP /* @min:headerMap */] = null,
                                _a[_DYN_CORRELATION_CONTEXT /* @min:correlationContext */] = _getAjaxCorrelationContext(xhr),
                                _a.type = xhr.responseType,
                                _a[_DYN_RESPONSE_TEXT /* @min:responseText */] = _getResponseText(xhr),
                                _a.response = xhr[_DYN_RESPONSE /* @min:%2eresponse */],
                                _a);
                            if (_enableResponseHeaderTracking) {
                                var headers = xhr[_DYN_GET_ALL_RESPONSE_HEA15 /* @min:%2egetAllResponseHeaders */]();
                                if (headers) {
                                    // xhr.getAllResponseHeaders() method returns all the response headers, separated by CRLF, as a string or null
                                    // the regex converts the header string into an array of individual headers
                                    var arr = strTrim(headers).split(/[\r\n]+/);
                                    var responseHeaderMap_2 = {};
                                    arrForEach(arr, function (line) {
                                        var parts = line.split(": ");
                                        var header = parts.shift();
                                        var value = parts.join(": ");
                                        if (_canIncludeHeaders(header)) {
                                            responseHeaderMap_2[header] = value;
                                        }
                                    });
                                    ajaxResponse[_DYN_HEADER_MAP /* @min:%2eheaderMap */] = responseHeaderMap_2;
                                }
                            }
                            return ajaxResponse;
                        });
                        var properties = void 0;
                        try {
                            if (!!_addRequestContext) {
                                properties = _addRequestContext({ status: xhr[_DYN_STATUS /* @min:%2estatus */], xhr: xhr });
                            }
                        }
                        catch (e) {
                            _throwInternalWarning(_self, 104 /* _eInternalMessageId.FailedAddingCustomDefinedRequestContext */, CUSTOM_REQUEST_CONTEXT_ERROR);
                        }
                        if (dependency) {
                            if (properties !== undefined) {
                                dependency[STR_PROPERTIES /* @min:%2eproperties */] = __assignFn(__assignFn({}, dependency.properties), properties);
                            }
                            var sysProperties = ajaxData[_DYN_GET_PART_APROPS /* @min:%2egetPartAProps */]();
                            _reportDependencyInternal(_dependencyInitializers, _self[_DYN_CORE /* @min:%2ecore */], ajaxData, dependency, null, sysProperties);
                        }
                        else {
                            _reportXhrError(null, {
                                requestSentTime: ajaxData[_DYN_REQUEST_SENT_TIME /* @min:%2erequestSentTime */],
                                responseFinishedTime: ajaxData[_DYN_RESPONSE_FINISHED_TI14 /* @min:%2eresponseFinishedTime */]
                            });
                        }
                    }
                    finally {
                        // cleanup telemetry data
                        try {
                            var xhrRequestData = (xhr[AJAX_DATA_CONTAINER] || { i: {} });
                            var ajaxDataCntr = (xhrRequestData.i || {});
                            if (ajaxDataCntr[_ajaxDataId]) {
                                ajaxDataCntr[_ajaxDataId] = null;
                            }
                        }
                        catch (e) {
                            // May throw in environments that prevent extension or freeze xhr
                        }
                    }
                }, function (e) {
                    _reportXhrError(e, null);
                });
            }
            function _getAjaxCorrelationContext(xhr) {
                var _a;
                try {
                    var responseHeadersString = xhr[_DYN_GET_ALL_RESPONSE_HEA15 /* @min:%2egetAllResponseHeaders */]();
                    if (responseHeadersString !== null) {
                        var index = _indexOf(responseHeadersString[_DYN_TO_LOWER_CASE /* @min:%2etoLowerCase */](), RequestHeaders[8 /* eRequestHeaders.requestContextHeaderLowerCase */]);
                        if (index !== -1) {
                            var responseHeader = xhr.getResponseHeader(RequestHeaders[0 /* eRequestHeaders.requestContextHeader */]);
                            return correlationIdGetCorrelationContext(responseHeader);
                        }
                    }
                }
                catch (e) {
                    _throwInternalWarning(_self, 18 /* _eInternalMessageId.FailedMonitorAjaxGetCorrelationHeader */, CORRELATION_HEADER_ERROR, (_a = {},
                        _a[_DYN_AJAX_DIAGNOSTICS_MES16 /* @min:ajaxDiagnosticsMessage */] = _getFailedAjaxDiagnosticsMessage(xhr, _ajaxDataId),
                        _a[_DYN_EXCEPTION /* @min:exception */] = dumpObj(e),
                        _a));
                }
            }
            function _createMarkId(type, ajaxData) {
                if (ajaxData[_DYN_REQUEST_URL /* @min:%2erequestUrl */] && _markPrefix && _enableAjaxPerfTracking) {
                    var performance_1 = getPerformance();
                    if (performance_1 && isFunction(performance_1.mark)) {
                        _markCount++;
                        var markId = _markPrefix + type + "#" + _markCount;
                        performance_1.mark(markId);
                        var entries = performance_1.getEntriesByName(markId);
                        if (entries && entries[_DYN_LENGTH$1 /* @min:%2elength */] === 1) {
                            ajaxData[_DYN_PERF_MARK /* @min:%2eperfMark */] = entries[0];
                        }
                    }
                }
            }
            function _findPerfResourceEntry(initiatorType, ajaxData, trackCallback, reportError) {
                var perfMark = ajaxData[_DYN_PERF_MARK /* @min:%2eperfMark */];
                var performance = getPerformance();
                var maxAttempts = _maxAjaxPerfLookupAttempts;
                var retryDelay = _ajaxPerfLookupDelay;
                var requestUrl = ajaxData[_DYN_REQUEST_URL /* @min:%2erequestUrl */];
                var attempt = 0;
                (function locateResourceTiming() {
                    try {
                        if (performance && perfMark) {
                            attempt++;
                            var perfTiming = null;
                            var entries = performance.getEntries();
                            for (var lp = entries[_DYN_LENGTH$1 /* @min:%2elength */] - 1; lp >= 0; lp--) {
                                var entry = entries[lp];
                                if (entry) {
                                    if (entry.entryType === "resource") {
                                        if (entry.initiatorType === initiatorType &&
                                            (_indexOf(entry[_DYN_NAME /* @min:%2ename */], requestUrl) !== -1 || _indexOf(requestUrl, entry[_DYN_NAME /* @min:%2ename */]) !== -1)) {
                                            perfTiming = entry;
                                        }
                                    }
                                    else if (entry.entryType === "mark" && entry[_DYN_NAME /* @min:%2ename */] === perfMark[_DYN_NAME /* @min:%2ename */]) {
                                        // We hit the start event
                                        ajaxData[_DYN_PERF_TIMING /* @min:%2eperfTiming */] = perfTiming;
                                        break;
                                    }
                                    if (entry[_DYN_START_TIME /* @min:%2estartTime */] < perfMark[_DYN_START_TIME /* @min:%2estartTime */] - 1000) {
                                        // Fallback to try and reduce the time spent looking for the perf entry
                                        break;
                                    }
                                }
                            }
                        }
                        if (!perfMark || // - we don't have a perfMark or
                            ajaxData[_DYN_PERF_TIMING /* @min:%2eperfTiming */] || // - we have not found the perf entry or
                            attempt >= maxAttempts || // - we have tried too many attempts or
                            ajaxData.async === false) { // - this is a sync request
                            if (perfMark && isFunction(performance.clearMarks)) {
                                // Remove the mark so we don't fill up the performance resources too much
                                performance.clearMarks(perfMark[_DYN_NAME /* @min:%2ename */]);
                            }
                            ajaxData.perfAttempts = attempt;
                            // just continue and report the track event
                            trackCallback();
                        }
                        else {
                            // We need to wait for the browser to populate the window.performance entry
                            // This needs to be at least 1ms as waiting <= 1 (on firefox) is not enough time for fetch or xhr,
                            // this is a scheduling issue for the browser implementation
                            scheduleTimeout(locateResourceTiming, retryDelay);
                        }
                    }
                    catch (e) {
                        reportError(e);
                    }
                })();
            }
            function _createFetchRecord(input, init) {
                var _a;
                var distributedTraceCtx = _getDistributedTraceCtx();
                var traceID = (distributedTraceCtx && distributedTraceCtx[_DYN_GET_TRACE_ID /* @min:%2egetTraceId */]()) || generateW3CId();
                var spanID = strSubstr(generateW3CId(), 0, 16);
                var ajaxData = new ajaxRecord(traceID, spanID, _self[strDiagLog](), (_a = _self.core) === null || _a === void 0 ? void 0 : _a.getTraceCtx());
                ajaxData[_DYN_TRACE_FLAGS /* @min:%2etraceFlags */] = distributedTraceCtx && distributedTraceCtx[_DYN_GET_TRACE_FLAGS /* @min:%2egetTraceFlags */]();
                ajaxData[_DYN_REQUEST_SENT_TIME /* @min:%2erequestSentTime */] = dateTimeUtilsNow();
                ajaxData[_DYN_ERROR_STATUS_TEXT /* @min:%2eerrorStatusText */] = _enableAjaxErrorStatusText;
                var requestUrl;
                if (input instanceof Request) {
                    requestUrl = (input || {}).url || "";
                }
                else {
                    requestUrl = input;
                }
                if (requestUrl === "") {
                    var location_1 = getLocation();
                    if (location_1 && location_1.href) {
                        requestUrl = strSplit(location_1.href, "#")[0];
                    }
                }
                ajaxData[_DYN_REQUEST_URL /* @min:%2erequestUrl */] = requestUrl;
                var method = "GET";
                if (init && init[_DYN_METHOD /* @min:%2emethod */]) {
                    method = init[_DYN_METHOD /* @min:%2emethod */];
                }
                else if (input && input instanceof Request) {
                    method = input[_DYN_METHOD /* @min:%2emethod */];
                }
                ajaxData[_DYN_METHOD /* @min:%2emethod */] = method;
                var requestHeaders = {};
                if (_enableRequestHeaderTracking) {
                    var headers = new Headers((init ? init[_DYN_HEADERS /* @min:%2eheaders */] : 0) || (input instanceof Request ? (input[_DYN_HEADERS /* @min:%2eheaders */] || {}) : {}));
                    headers.forEach(function (value, key) {
                        if (_canIncludeHeaders(key)) {
                            requestHeaders[key] = value;
                        }
                    });
                }
                ajaxData[_DYN_REQUEST_HEADERS /* @min:%2erequestHeaders */] = requestHeaders;
                _createMarkId(STR_FETCH, ajaxData);
                return ajaxData;
            }
            function _getFailedFetchDiagnosticsMessage(input) {
                var result = "";
                try {
                    if (!isNullOrUndefined(input)) {
                        if (typeof (input) === "string") {
                            result += "(url: '".concat(input, "')");
                        }
                        else {
                            result += "(url: '".concat(input.url, "')");
                        }
                    }
                }
                catch (e) {
                    _throwInternalCritical(_self, 15 /* _eInternalMessageId.FailedMonitorAjaxOpen */, "Failed to grab failed fetch diagnostics message", { exception: dumpObj(e) });
                }
                return result;
            }
            function _reportFetchMetrics(callDetails, status, input, response, ajaxData, getResponse, properties) {
                if (!ajaxData) {
                    return;
                }
                function _reportFetchError(msgId, e, failedProps) {
                    var errorProps = failedProps || {};
                    errorProps["fetchDiagnosticsMessage"] = _getFailedFetchDiagnosticsMessage(input);
                    if (e) {
                        errorProps["exception"] = dumpObj(e);
                    }
                    _throwInternalWarning(_self, msgId, FAILED_TO_CALCULATE_DURATION_ERROR + "fetch call" + ERROR_NOT_SENT, errorProps);
                }
                ajaxData[_DYN_RESPONSE_FINISHED_TI14 /* @min:%2eresponseFinishedTime */] = dateTimeUtilsNow();
                ajaxData[_DYN_STATUS /* @min:%2estatus */] = status;
                _findPerfResourceEntry(STR_FETCH, ajaxData, function () {
                    var dependency = ajaxData[_DYN__CREATE_TRACK_ITEM /* @min:%2eCreateTrackItem */]("Fetch", _enableRequestHeaderTracking, getResponse);
                    var properties;
                    try {
                        if (!!_addRequestContext) {
                            properties = _addRequestContext({ status: status, request: input, response: response });
                        }
                    }
                    catch (e) {
                        _throwInternalWarning(_self, 104 /* _eInternalMessageId.FailedAddingCustomDefinedRequestContext */, CUSTOM_REQUEST_CONTEXT_ERROR);
                    }
                    if (dependency) {
                        if (properties !== undefined) {
                            dependency[STR_PROPERTIES /* @min:%2eproperties */] = __assignFn(__assignFn({}, dependency.properties), properties);
                        }
                        var sysProperties = ajaxData[_DYN_GET_PART_APROPS /* @min:%2egetPartAProps */]();
                        _reportDependencyInternal(_dependencyInitializers, _self[_DYN_CORE /* @min:%2ecore */], ajaxData, dependency, null, sysProperties);
                    }
                    else {
                        _reportFetchError(14 /* _eInternalMessageId.FailedMonitorAjaxDur */, null, {
                            requestSentTime: ajaxData[_DYN_REQUEST_SENT_TIME /* @min:%2erequestSentTime */],
                            responseFinishedTime: ajaxData[_DYN_RESPONSE_FINISHED_TI14 /* @min:%2eresponseFinishedTime */]
                        });
                    }
                }, function (e) {
                    _reportFetchError(18 /* _eInternalMessageId.FailedMonitorAjaxGetCorrelationHeader */, e, null);
                });
            }
            function _getFetchCorrelationContext(response) {
                var _a;
                if (response && response[_DYN_HEADERS /* @min:%2eheaders */]) {
                    try {
                        var responseHeader = response[_DYN_HEADERS /* @min:%2eheaders */].get(RequestHeaders[0 /* eRequestHeaders.requestContextHeader */]);
                        return correlationIdGetCorrelationContext(responseHeader);
                    }
                    catch (e) {
                        _throwInternalWarning(_self, 18 /* _eInternalMessageId.FailedMonitorAjaxGetCorrelationHeader */, CORRELATION_HEADER_ERROR, (_a = {
                                fetchDiagnosticsMessage: _getFailedFetchDiagnosticsMessage(response)
                            },
                            _a[_DYN_EXCEPTION /* @min:exception */] = dumpObj(e),
                            _a));
                    }
                }
            }
            function _reportDependencyInternal(initializers, core, ajaxData, dependency, properties, systemProperties) {
                var _a;
                var result = true;
                var initializersCount = initializers[_DYN_LENGTH$1 /* @min:%2elength */];
                if (initializersCount > 0) {
                    var details = (_a = {
                            item: dependency
                        },
                        _a[STR_PROPERTIES /* @min:properties */] = properties,
                        _a.sysProperties = systemProperties,
                        _a.context = ajaxData ? ajaxData[_DYN_CONTEXT$1 /* @min:%2econtext */] : null,
                        _a.aborted = ajaxData ? !!ajaxData[_DYN_ABORTED /* @min:%2eaborted */] : false,
                        _a);
                    result = _processDependencyContainer(core, initializers, details, "initializer");
                }
                if (result) {
                    _self[_DYN_TRACK_DEPENDENCY_DAT3 /* @min:%2etrackDependencyDataInternal */](dependency, properties, systemProperties);
                }
            }
        });
        return _this;
    }
// Removed Stub for AjaxMonitor.prototype.initialize.
    AjaxMonitor.prototype.processTelemetry = function (item, itemCtx) {
        this.processNext(item, itemCtx);
    };
// Removed Stub for AjaxMonitor.prototype.trackDependencyData.
// Removed Stub for AjaxMonitor.prototype.includeCorrelationHeaders.
// Removed Stub for AjaxMonitor.prototype.addDependencyListener.
    /**
     * Add an dependency telemetry initializer callback function to allow populating additional properties or drop the request.
     * It is called after the dependency call has completed and any available performance details are available. A dependency
     * initializer is similar to the TelemetryInitializer function but it allows you to block the reporting of the dependency
     * request so that it doesn't count against the `maxAjaxCallsPerView`.
     * @param dependencyInitializer - The Dependency Telemetry Initializer function
     * @returns - A IDependencyInitializerHandler to enable the initializer to be removed
     */
    AjaxMonitor.prototype.addDependencyInitializer = function (dependencyInitializer) {
        return null;
    };
// Removed Stub for AjaxMonitor.prototype.trackDependencyDataInternal.
    AjaxMonitor.identifier = "AjaxDependencyPlugin";
    return AjaxMonitor;
}(BaseTelemetryPlugin));

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


var Application = /** @class */ (function () {
    function Application() {
    }
    return Application;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


var Device = /** @class */ (function () {
    /**
     * Constructs a new instance of the Device class
     */
    function Device() {
        // don't attempt to fingerprint browsers
        this.id = "browser";
        // Device type is a dimension in our data platform
        // Setting it to 'Browser' allows to separate client and server dependencies/exceptions
        this.deviceClass = "Browser";
    }
    return Device;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var Version = '3.3.0';
var Internal = /** @class */ (function () {
    /**
     * Constructs a new instance of the internal telemetry data class.
     */
    function Internal(config, unloadHookContainer) {
        var _this = this;
        var unloadHook = onConfigChange((config), function () {
            var prefix = config.sdkExtension;
            _this.sdkVersion = (prefix ? prefix + "_" : "") + "javascript:" + Version;
        });
        unloadHookContainer && unloadHookContainer.add(unloadHook);
    }
    return Internal;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


var Location = /** @class */ (function () {
    function Location() {
    }
    return Location;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_SESSION_MANAGER = "sessionManager"; // Count: 3
var _DYN_UPDATE = "update"; // Count: 4
var _DYN_IS_USER_COOKIE_SET = "isUserCookieSet"; // Count: 4
var _DYN_IS_NEW_USER = "isNewUser"; // Count: 4
var _DYN_GET_TRACE_CTX = "getTraceCtx"; // Count: 3
var _DYN_TELEMETRY_TRACE = "telemetryTrace"; // Count: 3
var _DYN_APPLY_SESSION_CONTEX0 = "applySessionContext"; // Count: 2
var _DYN_APPLY_APPLICATION_CO1 = "applyApplicationContext"; // Count: 2
var _DYN_APPLY_DEVICE_CONTEXT = "applyDeviceContext"; // Count: 2
var _DYN_APPLY_OPERATION_CONT2 = "applyOperationContext"; // Count: 2
var _DYN_APPLY_USER_CONTEXT = "applyUserContext"; // Count: 2
var _DYN_APPLY_OPERATING_SYST3 = "applyOperatingSystemContxt"; // Count: 2
var _DYN_APPLY_LOCATION_CONTE4 = "applyLocationContext"; // Count: 2
var _DYN_APPLY_INTERNAL_CONTE5 = "applyInternalContext"; // Count: 2
var _DYN_ACCOUNT_ID = "accountId"; // Count: 7
var _DYN_GET_SESSION_ID = "getSessionId"; // Count: 4
var _DYN_NAME_PREFIX = "namePrefix"; // Count: 3
var _DYN_SESSION_COOKIE_POSTF6 = "sessionCookiePostfix"; // Count: 2
var _DYN_USER_COOKIE_POSTFIX = "userCookiePostfix"; // Count: 2
var _DYN_ID_LENGTH = "idLength"; // Count: 4
var _DYN_GET_NEW_ID = "getNewId"; // Count: 3
var _DYN_LENGTH = "length"; // Count: 4
var _DYN_AUTOMATIC_SESSION = "automaticSession"; // Count: 5
var _DYN_AUTHENTICATED_ID = "authenticatedId"; // Count: 6
var _DYN_ACQUISITION_DATE = "acquisitionDate"; // Count: 5
var _DYN_RENEWAL_DATE = "renewalDate"; // Count: 4
var _DYN_JOIN = "join"; // Count: 5
var _DYN_COOKIE_SEPARATOR = "cookieSeparator"; // Count: 5
var _DYN_AUTH_USER_COOKIE_NAM7 = "authUserCookieName"; // Count: 3

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var SESSION_COOKIE_NAME = "ai_session";
var ACQUISITION_SPAN = 86400000; // 24 hours in ms
var RENEWAL_SPAN = 1800000; // 30 minutes in ms
var COOKIE_UPDATE_INTERVAL = 60000; // 1 minute in ms
var Session = /** @class */ (function () {
    function Session() {
    }
    return Session;
}());
var _SessionManager = /** @class */ (function () {
    function _SessionManager(config, core, unloadHookContainer) {
        var self = this;
        var _storageNamePrefix;
        var _cookieUpdatedTimestamp;
        var _logger = safeGetLogger(core);
        var _cookieManager = safeGetCookieMgr(core);
        var _sessionExpirationMs;
        var _sessionRenewalMs;
        dynamicProto(_SessionManager, self, function (_self) {
            if (!config) {
                config = {};
            }
            var unloadHook = onConfigChange(config, function (details) {
                _sessionExpirationMs = config.sessionExpirationMs || ACQUISITION_SPAN;
                _sessionRenewalMs = config.sessionRenewalMs || RENEWAL_SPAN;
                // sessionCookiePostfix takes the preference if it is configured, otherwise takes namePrefix if configured.
                var sessionCookiePostfix = config.sessionCookiePostfix || config[_DYN_NAME_PREFIX /* @min:%2enamePrefix */] || "";
                _storageNamePrefix = SESSION_COOKIE_NAME + sessionCookiePostfix;
            });
            unloadHookContainer && unloadHookContainer.add(unloadHook);
            _self[_DYN_AUTOMATIC_SESSION /* @min:%2eautomaticSession */] = new Session();
            _self[_DYN_UPDATE /* @min:%2eupdate */] = function () {
                // Always using Date getTime() as there is a bug in older IE instances that causes the performance timings to have the hi-bit set eg 0x800000000 causing
                // the number to be incorrect.
                var nowMs = utcNow();
                var isExpired = false;
                var session = _self[_DYN_AUTOMATIC_SESSION /* @min:%2eautomaticSession */];
                if (!session.id) {
                    isExpired = !_initializeAutomaticSession(session);
                }
                if (!isExpired && _sessionExpirationMs > 0) {
                    var timeSinceAcqMs = nowMs - session[_DYN_ACQUISITION_DATE /* @min:%2eacquisitionDate */];
                    var timeSinceRenewalMs = nowMs - session[_DYN_RENEWAL_DATE /* @min:%2erenewalDate */];
                    isExpired = timeSinceAcqMs < 0 || timeSinceRenewalMs < 0; // expired if the acquisition or last renewal are in the future
                    isExpired = isExpired || timeSinceAcqMs > _sessionExpirationMs; // expired if the time since acquisition is more than session Expiration
                    isExpired = isExpired || timeSinceRenewalMs > _sessionRenewalMs; // expired if the time since last renewal is more than renewal period
                }
                // renew if acquisitionSpan or renewalSpan has elapsed
                if (isExpired) {
                    // update automaticSession so session state has correct id
                    _renew(nowMs);
                }
                else {
                    // do not update the cookie more often than cookieUpdateInterval
                    if (!_cookieUpdatedTimestamp || nowMs - _cookieUpdatedTimestamp > COOKIE_UPDATE_INTERVAL) {
                        _setCookie(session, nowMs);
                    }
                }
            };
            /**
             *  Record the current state of the automatic session and store it in our cookie string format
             *  into the browser's local storage. This is used to restore the session data when the cookie
             *  expires.
             */
            _self.backup = function () {
                var session = _self[_DYN_AUTOMATIC_SESSION /* @min:%2eautomaticSession */];
                _setStorage(session.id, session[_DYN_ACQUISITION_DATE /* @min:%2eacquisitionDate */], session[_DYN_RENEWAL_DATE /* @min:%2erenewalDate */]);
            };
            /**
             * Use config.namePrefix + ai_session cookie data or local storage data (when the cookie is unavailable) to
             * initialize the automatic session.
             * @returns true if values set otherwise false
             */
            function _initializeAutomaticSession(session, now) {
                var isValid = false;
                var cookieValue = _cookieManager.get(_storageNamePrefix);
                if (cookieValue && isFunction(cookieValue.split)) {
                    isValid = _initializeAutomaticSessionWithData(session, cookieValue);
                }
                else {
                    // There's no cookie, but we might have session data in local storage
                    // This can happen if the session expired or the user actively deleted the cookie
                    // We only want to recover data if the cookie is missing from expiry. We should respect the user's wishes if the cookie was deleted actively.
                    // The User class handles this for us and deletes our local storage object if the persistent user cookie was removed.
                    var storageValue = utlGetLocalStorage(_logger, _storageNamePrefix);
                    if (storageValue) {
                        isValid = _initializeAutomaticSessionWithData(session, storageValue);
                    }
                }
                return isValid || !!session.id;
            }
            /**
             * Extract id, acquisitionDate, and renewalDate from an ai_session payload string and
             * use this data to initialize automaticSession.
             *
             * @param sessionData - The string stored in an ai_session cookie or local storage backup
             * @returns true if values set otherwise false
             */
            function _initializeAutomaticSessionWithData(session, sessionData) {
                var isValid = false;
                var sessionReset = ", session will be reset";
                var tokens = sessionData.split("|");
                if (tokens[_DYN_LENGTH /* @min:%2elength */] >= 2) {
                    try {
                        var acqMs = +tokens[1] || 0;
                        var renewalMs = +tokens[2] || 0;
                        if (isNaN(acqMs) || acqMs <= 0) {
                            _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 27 /* _eInternalMessageId.SessionRenewalDateIsZero */, "AI session acquisition date is 0" + sessionReset);
                        }
                        else if (isNaN(renewalMs) || renewalMs <= 0) {
                            _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 27 /* _eInternalMessageId.SessionRenewalDateIsZero */, "AI session renewal date is 0" + sessionReset);
                        }
                        else if (tokens[0]) {
                            // Everything looks valid so set the values
                            session.id = tokens[0];
                            session[_DYN_ACQUISITION_DATE /* @min:%2eacquisitionDate */] = acqMs;
                            session[_DYN_RENEWAL_DATE /* @min:%2erenewalDate */] = renewalMs;
                            isValid = true;
                        }
                    }
                    catch (e) {
                        _throwInternal(_logger, 1 /* eLoggingSeverity.CRITICAL */, 9 /* _eInternalMessageId.ErrorParsingAISessionCookie */, "Error parsing ai_session value [" + (sessionData || "") + "]" + sessionReset + " - " + getExceptionName(e), { exception: dumpObj(e) });
                    }
                }
                return isValid;
            }
            function _renew(nowMs) {
                var getNewId = config[_DYN_GET_NEW_ID /* @min:%2egetNewId */] || newId;
                _self.automaticSession.id = getNewId(config[_DYN_ID_LENGTH /* @min:%2eidLength */] || 22);
                _self[_DYN_AUTOMATIC_SESSION /* @min:%2eautomaticSession */][_DYN_ACQUISITION_DATE /* @min:%2eacquisitionDate */] = nowMs;
                _setCookie(_self[_DYN_AUTOMATIC_SESSION /* @min:%2eautomaticSession */], nowMs);
                // If this browser does not support local storage, fire an internal log to keep track of it at this point
                if (!utlCanUseLocalStorage()) {
                    _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 0 /* _eInternalMessageId.BrowserDoesNotSupportLocalStorage */, "Browser does not support local storage. Session durations will be inaccurate.");
                }
            }
            function _setCookie(session, nowMs) {
                var acq = session[_DYN_ACQUISITION_DATE /* @min:%2eacquisitionDate */];
                session[_DYN_RENEWAL_DATE /* @min:%2erenewalDate */] = nowMs;
                var renewalPeriodMs = _sessionRenewalMs;
                // Set cookie to expire after the session expiry time passes or the session renewal deadline, whichever is sooner
                // Expiring the cookie will cause the session to expire even if the user isn't on the page
                var acqTimeLeftMs = (acq + _sessionExpirationMs) - nowMs;
                var cookie = [session.id, acq, nowMs];
                var maxAgeSec = 0;
                if (acqTimeLeftMs < renewalPeriodMs) {
                    maxAgeSec = acqTimeLeftMs / 1000;
                }
                else {
                    maxAgeSec = renewalPeriodMs / 1000;
                }
                var cookieDomain = config.cookieDomain || null;
                // if sessionExpirationMs is set to 0, it means the expiry is set to 0 for this session cookie
                // A cookie with 0 expiry in the session cookie will never expire for that browser session.  If the browser is closed the cookie expires.
                // Depending on the browser, another instance does not inherit this cookie, however, another tab will
                _cookieManager.set(_storageNamePrefix, cookie[_DYN_JOIN /* @min:%2ejoin */]("|"), _sessionExpirationMs > 0 ? maxAgeSec : null, cookieDomain);
                _cookieUpdatedTimestamp = nowMs;
            }
            function _setStorage(guid, acq, renewal) {
                // Keep data in local storage to retain the last session id, allowing us to cleanly end the session when it expires
                // Browsers that don't support local storage won't be able to end sessions cleanly from the client
                // The server will notice this and end the sessions itself, with loss of accurate session duration
                utlSetLocalStorage(_logger, _storageNamePrefix, [guid, acq, renewal][_DYN_JOIN /* @min:%2ejoin */]("|"));
            }
        });
    }
// Removed Stub for _SessionManager.prototype.update.
// Removed Stub for _SessionManager.prototype.backup.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    _SessionManager.__ieDyn=1;

    return _SessionManager;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var TelemetryTrace = /** @class */ (function () {
    function TelemetryTrace(id, parentId, name, logger) {
        var _self = this;
        _self.traceID = id || generateW3CId();
        _self.parentID = parentId;
        var location = getLocation();
        if (!name && location && location.pathname) {
            name = location.pathname;
        }
        _self.name = dataSanitizeString(logger, name);
    }
    return TelemetryTrace;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

function _validateUserInput(id) {
    // Validate:
    // 1. Id is a non-empty string.
    // 2. It does not contain special characters for cookies.
    if (typeof id !== "string" ||
        !id ||
        id.match(/,|;|=| |\|/)) {
        return false;
    }
    return true;
}
var User = /** @class */ (function () {
    function User(config, core, unloadHookContainer) {
        /**
         * A flag indicating whether this represents a new user
         */
        this.isNewUser = false;
        /**
         * A flag indicating whether the user cookie has been set
         */
        this.isUserCookieSet = false;
        var _logger = safeGetLogger(core);
        var _cookieManager = safeGetCookieMgr(core);
        var _storageNamePrefix;
        dynamicProto(User, this, function (_self) {
            // Define _self.config
            objDefine(_self, "config", {
                g: function () { return config; }
            });
            var unloadHook = onConfigChange(config, function () {
                var userCookiePostfix = config[_DYN_USER_COOKIE_POSTFIX /* @min:%2euserCookiePostfix */] || "";
                _storageNamePrefix = User.userCookieName + userCookiePostfix;
                // get userId or create new one if none exists
                var cookie = _cookieManager.get(_storageNamePrefix);
                if (cookie) {
                    _self[_DYN_IS_NEW_USER /* @min:%2eisNewUser */] = false;
                    var params = cookie.split(User[_DYN_COOKIE_SEPARATOR /* @min:%2ecookieSeparator */]);
                    if (params[_DYN_LENGTH /* @min:%2elength */] > 0) {
                        _self.id = params[0];
                        // we already have a cookie
                        _self[_DYN_IS_USER_COOKIE_SET /* @min:%2eisUserCookieSet */] = !!_self.id;
                    }
                }
                if (!_self.id) {
                    _self.id = _generateNewId();
                    var newCookie = _generateNewCookie(_self.id);
                    _setUserCookie(newCookie[_DYN_JOIN /* @min:%2ejoin */](User[_DYN_COOKIE_SEPARATOR /* @min:%2ecookieSeparator */]));
                    // If we have an config.namePrefix() + ai_session in local storage this means the user actively removed our cookies.
                    // We should respect their wishes and clear ourselves from local storage
                    var name_1 = (config[_DYN_NAME_PREFIX /* @min:%2enamePrefix */] || "") + "ai_session";
                    utlRemoveStorage(_logger, name_1);
                }
                // We still take the account id from the ctor param for backward compatibility.
                // But if the the customer set the accountId through the newer setAuthenticatedUserContext API, we will override it.
                _self[_DYN_ACCOUNT_ID /* @min:%2eaccountId */] = config[_DYN_ACCOUNT_ID /* @min:%2eaccountId */] || undefined;
                // Get the auth user id and account id from the cookie if exists
                // Cookie is in the pattern: <authenticatedId>|<accountId>
                var authCookie = _cookieManager.get(User[_DYN_AUTH_USER_COOKIE_NAM7 /* @min:%2eauthUserCookieName */]);
                if (authCookie) {
                    authCookie = decodeURI(authCookie);
                    var authCookieString = authCookie.split(User[_DYN_COOKIE_SEPARATOR /* @min:%2ecookieSeparator */]);
                    if (authCookieString[0]) {
                        _self[_DYN_AUTHENTICATED_ID /* @min:%2eauthenticatedId */] = authCookieString[0];
                    }
                    if (authCookieString[_DYN_LENGTH /* @min:%2elength */] > 1 && authCookieString[1]) {
                        _self[_DYN_ACCOUNT_ID /* @min:%2eaccountId */] = authCookieString[1];
                    }
                }
            });
            unloadHookContainer && unloadHookContainer.add(unloadHook);
            function _generateNewId() {
                var theConfig = (config || {});
                var getNewId = theConfig[_DYN_GET_NEW_ID /* @min:%2egetNewId */] || newId;
                var id = getNewId(theConfig[_DYN_ID_LENGTH /* @min:%2eidLength */] ? config[_DYN_ID_LENGTH /* @min:%2eidLength */] : 22);
                return id;
            }
            function _generateNewCookie(userId) {
                var acqStr = toISOString(new Date());
                _self.accountAcquisitionDate = acqStr;
                _self[_DYN_IS_NEW_USER /* @min:%2eisNewUser */] = true;
                var newCookie = [userId, acqStr];
                return newCookie;
            }
            function _setUserCookie(cookie) {
                // without expiration, cookies expire at the end of the session
                // set it to 365 days from now
                // 365 * 24 * 60 * 60 = 31536000
                var oneYear = 31536000;
                _self[_DYN_IS_USER_COOKIE_SET /* @min:%2eisUserCookieSet */] = _cookieManager.set(_storageNamePrefix, cookie, oneYear);
            }
            _self.setAuthenticatedUserContext = function (authenticatedUserId, accountId, storeInCookie) {
                if (storeInCookie === void 0) { storeInCookie = false; }
                // Validate inputs to ensure no cookie control characters.
                var isInvalidInput = !_validateUserInput(authenticatedUserId) || (accountId && !_validateUserInput(accountId));
                if (isInvalidInput) {
                    _throwInternal(_logger, 2 /* eLoggingSeverity.WARNING */, 60 /* _eInternalMessageId.SetAuthContextFailedAccountName */, "Setting auth user context failed. " +
                        "User auth/account id should be of type string, and not contain commas, semi-colons, equal signs, spaces, or vertical-bars.", true);
                    return;
                }
                // Create cookie string.
                _self[_DYN_AUTHENTICATED_ID /* @min:%2eauthenticatedId */] = authenticatedUserId;
                var authCookie = _self[_DYN_AUTHENTICATED_ID /* @min:%2eauthenticatedId */];
                if (accountId) {
                    _self[_DYN_ACCOUNT_ID /* @min:%2eaccountId */] = accountId;
                    authCookie = [_self[_DYN_AUTHENTICATED_ID /* @min:%2eauthenticatedId */], _self.accountId][_DYN_JOIN /* @min:%2ejoin */](User[_DYN_COOKIE_SEPARATOR /* @min:%2ecookieSeparator */]);
                }
                if (storeInCookie) {
                    // Set the cookie. No expiration date because this is a session cookie (expires when browser closed).
                    // Encoding the cookie to handle unexpected unicode characters.
                    _cookieManager.set(User[_DYN_AUTH_USER_COOKIE_NAM7 /* @min:%2eauthUserCookieName */], encodeURI(authCookie));
                }
            };
            /**
             * Clears the authenticated user id and the account id from the user context.
             * @returns {}
             */
            _self.clearAuthenticatedUserContext = function () {
                _self[_DYN_AUTHENTICATED_ID /* @min:%2eauthenticatedId */] = null;
                _self[_DYN_ACCOUNT_ID /* @min:%2eaccountId */] = null;
                _cookieManager.del(User[_DYN_AUTH_USER_COOKIE_NAM7 /* @min:%2eauthUserCookieName */]);
            };
            _self[_DYN_UPDATE /* @min:%2eupdate */] = function (userId) {
                // Optimizations to avoid setting and processing the cookie when not needed
                if (_self.id !== userId || !_self[_DYN_IS_USER_COOKIE_SET /* @min:%2eisUserCookieSet */]) {
                    var user_id = userId ? userId : _generateNewId();
                    var user_cookie = _generateNewCookie(user_id);
                    _setUserCookie(user_cookie[_DYN_JOIN /* @min:%2ejoin */](User[_DYN_COOKIE_SEPARATOR /* @min:%2ecookieSeparator */]));
                }
            };
        });
    }
// Removed Stub for User.prototype.setAuthenticatedUserContext.
// Removed Stub for User.prototype.clearAuthenticatedUserContext.
// Removed Stub for User.prototype.update.
    User.cookieSeparator = "|";
    User.userCookieName = "ai_user";
    User.authUserCookieName = "ai_authUser";
    return User;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
/**
* TelemetryContext.ts
* @copyright Microsoft 2018
*/
var strExt = "ext";
var strTags = "tags";
function _removeEmpty(target, name) {
    if (target && target[name] && objKeys(target[name])[_DYN_LENGTH /* @min:%2elength */] === 0) {
        delete target[name];
    }
}
function _nullResult() {
    return null;
}
var TelemetryContext = /** @class */ (function () {
    function TelemetryContext(core, defaultConfig, previousTraceCtx, unloadHookContainer) {
        var _this = this;
        var logger = core.logger;
        dynamicProto(TelemetryContext, this, function (_self) {
            _self.appId = _nullResult;
            _self[_DYN_GET_SESSION_ID /* @min:%2egetSessionId */] = _nullResult;
            _self.application = new Application();
            _self.internal = new Internal(defaultConfig, unloadHookContainer);
            if (hasWindow()) {
                _self[_DYN_SESSION_MANAGER /* @min:%2esessionManager */] = new _SessionManager(defaultConfig, core, unloadHookContainer);
                _self.device = new Device();
                _self.location = new Location();
                _self.user = new User(defaultConfig, core, unloadHookContainer);
                var traceId = void 0;
                var parentId = void 0;
                var name_1;
                if (previousTraceCtx) {
                    traceId = previousTraceCtx.getTraceId();
                    parentId = previousTraceCtx.getSpanId();
                    name_1 = previousTraceCtx.getName();
                }
                _self[_DYN_TELEMETRY_TRACE /* @min:%2etelemetryTrace */] = new TelemetryTrace(traceId, parentId, name_1, logger);
                _self.session = new Session();
            }
            _self[_DYN_GET_SESSION_ID /* @min:%2egetSessionId */] = function () {
                var session = _self.session;
                var sesId = null;
                // If customer set session info, apply their context; otherwise apply context automatically generated
                if (session && isString(session.id)) {
                    sesId = session.id;
                }
                else {
                    // Gets the automatic session if it exists or an empty object
                    var autoSession = (_self[_DYN_SESSION_MANAGER /* @min:%2esessionManager */] || {})[_DYN_AUTOMATIC_SESSION /* @min:%2eautomaticSession */];
                    sesId = autoSession && isString(autoSession.id) ? autoSession.id : null;
                }
                return sesId;
            };
            _self[_DYN_APPLY_SESSION_CONTEX0 /* @min:%2eapplySessionContext */] = function (evt, itemCtx) {
                setValue(getSetValue(evt.ext, Extensions.AppExt), "sesId", _self[_DYN_GET_SESSION_ID /* @min:%2egetSessionId */](), isString);
            };
            _self[_DYN_APPLY_OPERATING_SYST3 /* @min:%2eapplyOperatingSystemContxt */] = function (evt, itemCtx) {
                setValue(evt.ext, Extensions.OSExt, _self.os);
            };
            _self[_DYN_APPLY_APPLICATION_CO1 /* @min:%2eapplyApplicationContext */] = function (evt, itemCtx) {
                var application = _self.application;
                if (application) {
                    // evt.ext.app
                    var tags = getSetValue(evt, strTags);
                    setValue(tags, CtxTagKeys.applicationVersion, application.ver, isString);
                    setValue(tags, CtxTagKeys.applicationBuild, application.build, isString);
                }
            };
            _self[_DYN_APPLY_DEVICE_CONTEXT /* @min:%2eapplyDeviceContext */] = function (evt, itemCtx) {
                var device = _self.device;
                if (device) {
                    // evt.ext.device
                    var extDevice = getSetValue(getSetValue(evt, strExt), Extensions.DeviceExt);
                    setValue(extDevice, "localId", device.id, isString);
                    setValue(extDevice, "ip", device.ip, isString);
                    setValue(extDevice, "model", device.model, isString);
                    setValue(extDevice, "deviceClass", device.deviceClass, isString);
                }
            };
            _self[_DYN_APPLY_INTERNAL_CONTE5 /* @min:%2eapplyInternalContext */] = function (evt, itemCtx) {
                var internal = _self.internal;
                if (internal) {
                    var tags = getSetValue(evt, strTags);
                    setValue(tags, CtxTagKeys.internalAgentVersion, internal.agentVersion, isString); // not mapped in CS 4.0
                    setValue(tags, CtxTagKeys.internalSdkVersion, dataSanitizeString(logger, internal.sdkVersion, 64), isString);
                    if (evt.baseType === _InternalLogMessage.dataType || evt.baseType === PageView.dataType) {
                        setValue(tags, CtxTagKeys.internalSnippet, internal.snippetVer, isString);
                        setValue(tags, CtxTagKeys.internalSdkSrc, internal.sdkSrc, isString);
                    }
                }
            };
            _self[_DYN_APPLY_LOCATION_CONTE4 /* @min:%2eapplyLocationContext */] = function (evt, itemCtx) {
                var location = _this.location;
                if (location) {
                    setValue(getSetValue(evt, strTags, []), CtxTagKeys.locationIp, location.ip, isString);
                }
            };
            _self[_DYN_APPLY_OPERATION_CONT2 /* @min:%2eapplyOperationContext */] = function (evt, itemCtx) {
                var telemetryTrace = _self[_DYN_TELEMETRY_TRACE /* @min:%2etelemetryTrace */];
                if (telemetryTrace) {
                    var extTrace = getSetValue(getSetValue(evt, strExt), Extensions.TraceExt, { traceID: undefined, parentID: undefined });
                    setValue(extTrace, "traceID", telemetryTrace.traceID, isString, isNullOrUndefined);
                    setValue(extTrace, "name", telemetryTrace.name, isString, isNullOrUndefined);
                    setValue(extTrace, "parentID", telemetryTrace.parentID, isString, isNullOrUndefined);
                }
            };
            _self.applyWebContext = function (evt, itemCtx) {
                var web = _this.web;
                if (web) {
                    setValue(getSetValue(evt, strExt), Extensions.WebExt, web);
                }
            };
            _self[_DYN_APPLY_USER_CONTEXT /* @min:%2eapplyUserContext */] = function (evt, itemCtx) {
                var user = _self.user;
                if (user) {
                    var tags = getSetValue(evt, strTags, []);
                    // stays in tags
                    setValue(tags, CtxTagKeys.userAccountId, user[_DYN_ACCOUNT_ID /* @min:%2eaccountId */], isString);
                    // CS 4.0
                    var extUser = getSetValue(getSetValue(evt, strExt), Extensions.UserExt);
                    setValue(extUser, "id", user.id, isString);
                    setValue(extUser, "authId", user[_DYN_AUTHENTICATED_ID /* @min:%2eauthenticatedId */], isString);
                }
            };
            _self.cleanUp = function (evt, itemCtx) {
                var ext = evt.ext;
                if (ext) {
                    _removeEmpty(ext, Extensions.DeviceExt);
                    _removeEmpty(ext, Extensions.UserExt);
                    _removeEmpty(ext, Extensions.WebExt);
                    _removeEmpty(ext, Extensions.OSExt);
                    _removeEmpty(ext, Extensions.AppExt);
                    _removeEmpty(ext, Extensions.TraceExt);
                }
            };
        });
    }
// Removed Stub for TelemetryContext.prototype.applySessionContext.
// Removed Stub for TelemetryContext.prototype.applyOperatingSystemContxt.
// Removed Stub for TelemetryContext.prototype.applyApplicationContext.
// Removed Stub for TelemetryContext.prototype.applyDeviceContext.
// Removed Stub for TelemetryContext.prototype.applyInternalContext.
// Removed Stub for TelemetryContext.prototype.applyLocationContext.
// Removed Stub for TelemetryContext.prototype.applyOperationContext.
// Removed Stub for TelemetryContext.prototype.applyWebContext.
// Removed Stub for TelemetryContext.prototype.applyUserContext.
// Removed Stub for TelemetryContext.prototype.cleanUp.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    TelemetryContext.__ieDyn=1;

    return TelemetryContext;
}());

/*
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
/**
* PropertiesPlugin.ts
* @copyright Microsoft 2018
*/
var _a$1;
var undefString;
var nullValue = null;
var _defaultConfig = objDeepFreeze((_a$1 = {},
    _a$1[_DYN_ACCOUNT_ID /* @min:accountId */] = nullValue,
    _a$1.sessionRenewalMs = 30 * 60 * 1000,
    _a$1.samplingPercentage = 100,
    _a$1.sessionExpirationMs = 24 * 60 * 60 * 1000,
    _a$1.cookieDomain = nullValue,
    _a$1.sdkExtension = nullValue,
    _a$1.isBrowserLinkTrackingEnabled = false,
    _a$1.appId = nullValue,
    _a$1[_DYN_GET_SESSION_ID /* @min:getSessionId */] = nullValue,
    _a$1[_DYN_NAME_PREFIX /* @min:namePrefix */] = undefString,
    _a$1[_DYN_SESSION_COOKIE_POSTF6 /* @min:sessionCookiePostfix */] = undefString,
    _a$1[_DYN_USER_COOKIE_POSTFIX /* @min:userCookiePostfix */] = undefString,
    _a$1[_DYN_ID_LENGTH /* @min:idLength */] = 22,
    _a$1[_DYN_GET_NEW_ID /* @min:getNewId */] = nullValue,
    _a$1));
var PropertiesPlugin = /** @class */ (function (_super) {
    __extendsFn(PropertiesPlugin, _super);
    function PropertiesPlugin() {
        var _this = _super.call(this) || this;
        _this.priority = 110;
        _this.identifier = PropertiesPluginIdentifier;
        var _extensionConfig;
        var _distributedTraceCtx;
        var _previousTraceCtx;
        var _context;
        var _disableUserInitMessage;
        dynamicProto(PropertiesPlugin, _this, function (_self, _base) {
            _initDefaults();
            objDefine(_self, "context", {
                g: function () {
                    return _context;
                }
            });
            _self.initialize = function (config, core, extensions, pluginChain) {
                _base.initialize(config, core, extensions, pluginChain);
                _populateDefaults(config);
            };
            /**
             * Add Part A fields to the event
             * @param event - The event that needs to be processed
             */
            _self.processTelemetry = function (event, itemCtx) {
                if (!isNullOrUndefined(event)) {
                    itemCtx = _self._getTelCtx(itemCtx);
                    // If the envelope is PageView, reset the internal message count so that we can send internal telemetry for the new page.
                    if (event.name === PageView.envelopeType) {
                        itemCtx.diagLog().resetInternalMessageCount();
                    }
                    var theContext = (_context || {});
                    if (theContext.session) {
                        // If customer did not provide custom session id update the session manager
                        if (typeof _context.session.id !== "string" && theContext[_DYN_SESSION_MANAGER /* @min:%2esessionManager */]) {
                            theContext[_DYN_SESSION_MANAGER /* @min:%2esessionManager */][_DYN_UPDATE /* @min:%2eupdate */]();
                        }
                    }
                    var userCtx = theContext.user;
                    if (userCtx && !userCtx[_DYN_IS_USER_COOKIE_SET /* @min:%2eisUserCookieSet */]) {
                        userCtx[_DYN_UPDATE /* @min:%2eupdate */](theContext.user.id);
                    }
                    _processTelemetryInternal(event, itemCtx);
                    if (userCtx && userCtx[_DYN_IS_NEW_USER /* @min:%2eisNewUser */]) {
                        userCtx[_DYN_IS_NEW_USER /* @min:%2eisNewUser */] = false;
                        if (!_disableUserInitMessage) {
                            var message = new _InternalLogMessage(72 /* _eInternalMessageId.SendBrowserInfoOnUserInit */, ((getNavigator() || {}).userAgent || ""));
                            _logInternalMessage(itemCtx.diagLog(), 1 /* eLoggingSeverity.CRITICAL */, message);
                        }
                    }
                    _self.processNext(event, itemCtx);
                }
            };
            _self._doTeardown = function (unloadCtx, unloadState) {
                var core = (unloadCtx || {}).core();
                if (core && core[_DYN_GET_TRACE_CTX /* @min:%2egetTraceCtx */]) {
                    var traceCtx = core[_DYN_GET_TRACE_CTX /* @min:%2egetTraceCtx */](false);
                    if (traceCtx === _distributedTraceCtx) {
                        core.setTraceCtx(_previousTraceCtx);
                    }
                }
                _initDefaults();
            };
            function _initDefaults() {
                _extensionConfig = null;
                _distributedTraceCtx = null;
                _previousTraceCtx = null;
                _context = null;
                _disableUserInitMessage = true;
            }
            function _populateDefaults(config) {
                var identifier = _self.identifier;
                var core = _self.core;
                // This function will be re-called whenever any referenced configuration is changed
                _self._addHook(onConfigChange(config, function () {
                    var ctx = createProcessTelemetryContext(null, config, core);
                    if (config.storagePrefix) {
                        utlSetStoragePrefix(config.storagePrefix);
                    }
                    _disableUserInitMessage = config.disableUserInitMessage === false ? false : true;
                    _extensionConfig = ctx.getExtCfg(identifier, _defaultConfig);
                    // Test hook to allow accessing the internal values -- explicitly not defined as an available property on the class
                    _self["_extConfig"] = _extensionConfig;
                }));
                // This is outside of the onConfigChange as we don't want to update (replace) these values whenever a referenced config item changes
                _previousTraceCtx = core[_DYN_GET_TRACE_CTX /* @min:%2egetTraceCtx */](false);
                _context = new TelemetryContext(core, _extensionConfig, _previousTraceCtx, _self._unloadHooks);
                _distributedTraceCtx = createDistributedTraceContextFromTrace(_self.context[_DYN_TELEMETRY_TRACE /* @min:%2etelemetryTrace */], _previousTraceCtx);
                core.setTraceCtx(_distributedTraceCtx);
                _self.context.appId = function () {
                    var breezeChannel = core.getPlugin(BreezeChannelIdentifier);
                    return breezeChannel ? breezeChannel.plugin["_appId"] : null;
                };
            }
            function _processTelemetryInternal(evt, itemCtx) {
                // Set Part A fields
                getSetValue(evt, "tags", []);
                getSetValue(evt, "ext", {});
                var ctx = _self.context;
                ctx[_DYN_APPLY_SESSION_CONTEX0 /* @min:%2eapplySessionContext */](evt, itemCtx);
                ctx[_DYN_APPLY_APPLICATION_CO1 /* @min:%2eapplyApplicationContext */](evt, itemCtx);
                ctx[_DYN_APPLY_DEVICE_CONTEXT /* @min:%2eapplyDeviceContext */](evt, itemCtx);
                ctx[_DYN_APPLY_OPERATION_CONT2 /* @min:%2eapplyOperationContext */](evt, itemCtx);
                ctx[_DYN_APPLY_USER_CONTEXT /* @min:%2eapplyUserContext */](evt, itemCtx);
                ctx[_DYN_APPLY_OPERATING_SYST3 /* @min:%2eapplyOperatingSystemContxt */](evt, itemCtx);
                ctx.applyWebContext(evt, itemCtx);
                ctx[_DYN_APPLY_LOCATION_CONTE4 /* @min:%2eapplyLocationContext */](evt, itemCtx); // legacy tags
                ctx[_DYN_APPLY_INTERNAL_CONTE5 /* @min:%2eapplyInternalContext */](evt, itemCtx); // legacy tags
                ctx.cleanUp(evt, itemCtx);
            }
        });
        return _this;
    }
// Removed Stub for PropertiesPlugin.prototype.initialize.
// Removed Stub for PropertiesPlugin.prototype.processTelemetry.
    // This is a workaround for an IE bug when using dynamicProto() with classes that don't have any
    // non-dynamic functions or static properties/functions when using uglify-js to minify the resulting code.
    PropertiesPlugin.__ieDyn=1;

    return PropertiesPlugin;
}(BaseTelemetryPlugin));
var PropertiesPlugin$1 = PropertiesPlugin;

/*
 * Application Insights JavaScript SDK - Web, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// ###################################################################################################################################################
// Note: DON'T Export these const from the package as we are still targeting IE/ES5 this will export a mutable variables that someone could change ###
// ###################################################################################################################################################
// Generally you should only put values that are used more than 2 times and then only if not already exposed as a constant (such as SdkCoreNames)
// as when using "short" named values from here they will be will be minified smaller than the SdkCoreNames[eSdkCoreNames.xxxx] value.
var _AUTHENTICATED_USER_CONTEXT = "AuthenticatedUserContext";
var _TRACK = "track";
var STR_SNIPPET = "snippet";
var STR_GET_COOKIE_MGR = "getCookieMgr";
var STR_START_TRACK_PAGE = "startTrackPage";
var STR_STOP_TRACK_PAGE = "stopTrackPage";
var STR_FLUSH = "flush";
var STR_START_TRACK_EVENT = "startTrackEvent";
var STR_STOP_TRACK_EVENT = "stopTrackEvent";
var STR_ADD_TELEMETRY_INITIALIZER = "addTelemetryInitializer";
var STR_POLL_INTERNAL_LOGS = "pollInternalLogs";
var STR_GET_PLUGIN = "getPlugin";
var STR_EVT_NAMESPACE = "evtNamespace";
var STR_TRACK_EVENT = _TRACK + "Event";
var STR_TRACK_TRACE = _TRACK + "Trace";
var STR_TRACK_METRIC = _TRACK + "Metric";
var STR_TRACK_PAGE_VIEW = _TRACK + "PageView";
var STR_TRACK_EXCEPTION = _TRACK + "Exception";
var STR_TRACK_DEPENDENCY_DATA = _TRACK + "DependencyData";
var STR_SET_AUTHENTICATED_USER_CONTEXT = "set" + _AUTHENTICATED_USER_CONTEXT;
var STR_CLEAR_AUTHENTICATED_USER_CONTEXT = "clear" + _AUTHENTICATED_USER_CONTEXT;
var CONFIG_ENDPOINT_URL = "https://js.monitor.azure.com/scripts/b/ai.config.1.cfg.json";

/*
 * Application Insights JavaScript SDK - Web, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */


// @skip-file-minify
// ##############################################################
// AUTO GENERATED FILE: This file is Auto Generated during build.
// ##############################################################
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Note: DON'T Export these const from the package as we are still targeting ES3 this will export a mutable variables that someone could change!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
var _DYN_VERSION = "version"; // Count: 6
var _DYN_QUEUE = "queue"; // Count: 6
var _DYN_CONNECTION_STRING = "connectionString"; // Count: 4
var _DYN_INSTRUMENTATION_KEY = "instrumentationKey"; // Count: 5
var _DYN_INSTRUMENTATIONKEY0 = "instrumentationkey"; // Count: 2
var _DYN_USER_OVERRIDE_ENDPOI1 = "userOverrideEndpointUrl"; // Count: 6
var _DYN_ENDPOINT_URL = "endpointUrl"; // Count: 6
var _DYN_INGESTIONENDPOINT = "ingestionendpoint"; // Count: 2
var _DYN_ONUNLOAD_FLUSH = "onunloadFlush"; // Count: 6
var _DYN_CONTEXT = "context"; // Count: 5
var _DYN_ADD_HOUSEKEEPING_BEF2 = "addHousekeepingBeforeUnload"; // Count: 2
var _DYN_SEND_MESSAGE = "sendMessage"; // Count: 3
var _DYN_UPDATE_SNIPPET_DEFIN3 = "updateSnippetDefinitions"; // Count: 2

/*
 * Application Insights JavaScript SDK - Web, 3.3.0
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */

var _a, _b, _c, _d;
var _internalSdkSrc;
// This is an exclude list of properties that should not be updated during initialization
// They include a combination of private and internal property names
var _ignoreUpdateSnippetProperties = [
    STR_SNIPPET, "dependencies", "properties", "_snippetVersion", "appInsightsNew", "getSKUDefaults"
];
var IKEY_USAGE = "iKeyUsage";
var CDN_USAGE = "CdnUsage";
var SDK_LOADER_VER = "SdkLoaderVer";
var UNDEFINED_VALUE = undefined;
var default_limit = {
    samplingRate: 100,
    maxSendNumber: 1
};
var default_interval = {
    monthInterval: 3,
    daysOfMonth: [28]
};
var default_throttle_config = {
    disabled: true,
    limit: cfgDfMerge(default_limit),
    interval: cfgDfMerge(default_interval)
};
// We need to include all properties that we only reference that we want to be dynamically updatable here
// So they are converted even when not specified in the passed configuration
var defaultConfigValues = (_a = {},
    _a[_DYN_CONNECTION_STRING /* @min:connectionString */] = UNDEFINED_VALUE,
    _a[_DYN_ENDPOINT_URL /* @min:endpointUrl */] = UNDEFINED_VALUE,
    _a[_DYN_INSTRUMENTATION_KEY /* @min:instrumentationKey */] = UNDEFINED_VALUE,
    _a[_DYN_USER_OVERRIDE_ENDPOI1 /* @min:userOverrideEndpointUrl */] = UNDEFINED_VALUE,
    _a.diagnosticLogInterval = cfgDfValidate(_chkDiagLevel, 10000),
    _a.featureOptIn = (_b = {},
        _b[IKEY_USAGE] = { mode: 3 /* FeatureOptInMode.enable */ },
        _b[CDN_USAGE] = { mode: 2 /* FeatureOptInMode.disable */ },
        _b[SDK_LOADER_VER] = { mode: 2 /* FeatureOptInMode.disable */ },
        _b),
    _a.throttleMgrCfg = cfgDfMerge((_c = {},
        _c[109 /* _eInternalMessageId.DefaultThrottleMsgKey */] = cfgDfMerge(default_throttle_config),
        _c[106 /* _eInternalMessageId.InstrumentationKeyDeprecation */] = cfgDfMerge(default_throttle_config),
        _c[111 /* _eInternalMessageId.SdkLdrUpdate */] = cfgDfMerge(default_throttle_config),
        _c[110 /* _eInternalMessageId.CdnDeprecation */] = cfgDfMerge(default_throttle_config),
        _c)),
    _a.extensionConfig = cfgDfMerge((_d = {},
        _d["AppInsightsCfgSyncPlugin"] = cfgDfMerge({
            cfgUrl: CONFIG_ENDPOINT_URL,
            syncMode: 2 /* ICfgSyncMode.Receive */
        }),
        _d)),
    _a);
function _chkDiagLevel(value) {
    // Make sure we have a value > 0
    return value && value > 0;
}
/**
 * Application Insights API
 * @group Entrypoint
 * @group Classes
 * @class Initialization
 * @implements {IApplicationInsights}
 */
var AppInsightsSku = /** @class */ (function () {
    function AppInsightsSku(snippet) {
        var _this = this;
        // NOTE!: DON'T set default values here, instead set them in the _initDefaults() function as it is also called during teardown()
        var dependencies;
        var properties;
        var _sender;
        var _snippetVersion;
        var _evtNamespace;
        var _houseKeepingNamespace;
        var _core;
        var _config;
        var _analyticsPlugin;
        var _cfgSyncPlugin;
        var _throttleMgr;
        var _iKeySentMessage;
        var _cdnSentMessage;
        var _sdkVerSentMessage;
        dynamicProto(AppInsightsSku, this, function (_self) {
            _initDefaults();
            objDefine(_self, "config", {
                g: function () {
                    return _config;
                }
            });
            arrForEach(["pluginVersionStringArr", "pluginVersionString"], function (key) {
                objDefine(_self, key, {
                    g: function () {
                        if (_core) {
                            return _core[key];
                        }
                        return null;
                    }
                });
            });
            // initialize the queue and config in case they are undefined
            _snippetVersion = "" + (snippet.sv || snippet[_DYN_VERSION /* @min:%2eversion */] || "");
            snippet[_DYN_QUEUE /* @min:%2equeue */] = snippet[_DYN_QUEUE /* @min:%2equeue */] || [];
            snippet[_DYN_VERSION /* @min:%2eversion */] = snippet[_DYN_VERSION /* @min:%2eversion */] || 2.0; // Default to new version
            var cfgHandler = createDynamicConfig(snippet.config || {}, defaultConfigValues);
            _config = cfgHandler.cfg;
            _analyticsPlugin = new AnalyticsPlugin();
            objDefine(_self, "appInsights", {
                g: function () {
                    return _analyticsPlugin;
                }
            });
            properties = new PropertiesPlugin$1();
            dependencies = new AjaxMonitor();
            _sender = new Sender();
            _core = new AppInsightsCore();
            objDefine(_self, "core", {
                g: function () {
                    return _core;
                }
            });
            // Will get recalled if any referenced values are changed
            _addUnloadHook(onConfigChange(cfgHandler, function () {
                var configCs = _config[_DYN_CONNECTION_STRING /* @min:%2econnectionString */];
                function _parseCs() {
                    return createAsyncPromise(function (resolve, reject) {
                        doAwaitResponse(configCs, function (res) {
                            var curCs = res && res.value;
                            var parsedCs = null;
                            if (!res.rejected && curCs) {
                                // replace cs with resolved values in case of circular promises
                                _config[_DYN_CONNECTION_STRING /* @min:%2econnectionString */] = curCs;
                                parsedCs = parseConnectionString(curCs);
                            }
                            // if can't resolve cs promise, null will be returned
                            resolve(parsedCs);
                        });
                    });
                }
                if (isPromiseLike(configCs)) {
                    var ikeyPromise = createAsyncPromise(function (resolve, reject) {
                        _parseCs().then(function (cs) {
                            var ikey = _config[_DYN_INSTRUMENTATION_KEY /* @min:%2einstrumentationKey */];
                            ikey = cs && cs[_DYN_INSTRUMENTATIONKEY0 /* @min:%2einstrumentationkey */] || ikey;
                            resolve(ikey);
                        }).catch(function (e) {
                            // parseCs will always resolve(unless timeout)
                            // return null in case any error happens
                            resolve(null);
                        });
                    });
                    var url = _config[_DYN_USER_OVERRIDE_ENDPOI1 /* @min:%2euserOverrideEndpointUrl */];
                    if (isNullOrUndefined(url)) {
                        url = createAsyncPromise(function (resolve, reject) {
                            _parseCs().then(function (cs) {
                                var url = _config[_DYN_ENDPOINT_URL /* @min:%2eendpointUrl */];
                                var ingest = cs && cs[_DYN_INGESTIONENDPOINT /* @min:%2eingestionendpoint */];
                                url = ingest ? ingest + DEFAULT_BREEZE_PATH : url;
                                resolve(url);
                            }).catch(function (e) {
                                // parseCs will always resolve(unless timeout)
                                // return null in case any error happens
                                resolve(null);
                            });
                        });
                    }
                    _config[_DYN_INSTRUMENTATION_KEY /* @min:%2einstrumentationKey */] = ikeyPromise;
                    _config[_DYN_ENDPOINT_URL /* @min:%2eendpointUrl */] = url;
                }
                if (isString(configCs)) {
                    // confirm if promiselike function present
                    // handle cs promise here
                    // add cases to oneNote
                    var cs = parseConnectionString(configCs);
                    var ingest = cs[_DYN_INGESTIONENDPOINT /* @min:%2eingestionendpoint */];
                    _config.endpointUrl = _config[_DYN_USER_OVERRIDE_ENDPOI1 /* @min:%2euserOverrideEndpointUrl */] ? _config[_DYN_USER_OVERRIDE_ENDPOI1 /* @min:%2euserOverrideEndpointUrl */] : ingest + DEFAULT_BREEZE_PATH; // add /v2/track
                    _config[_DYN_INSTRUMENTATION_KEY /* @min:%2einstrumentationKey */] = cs[_DYN_INSTRUMENTATIONKEY0 /* @min:%2einstrumentationkey */] || _config[_DYN_INSTRUMENTATION_KEY /* @min:%2einstrumentationKey */];
                }
                // userOverrideEndpointUrl have the highest priority
                _config.endpointUrl = _config[_DYN_USER_OVERRIDE_ENDPOI1 /* @min:%2euserOverrideEndpointUrl */] ? _config[_DYN_USER_OVERRIDE_ENDPOI1 /* @min:%2euserOverrideEndpointUrl */] : _config[_DYN_ENDPOINT_URL /* @min:%2eendpointUrl */];
            }));
            _self[STR_SNIPPET /* @min:%2esnippet */] = snippet;
            _self[STR_FLUSH /* @min:%2eflush */] = function (async, callBack) {
                if (async === void 0) { async = true; }
                var result;
                doPerf(_core, function () { return "AISKU.flush"; }, function () {
                    if (async && !callBack) {
                        result = createPromise(function (resolve) {
                            callBack = resolve;
                        });
                    }
                    var waiting = 1;
                    var flushDone = function () {
                        waiting--;
                        if (waiting === 0) {
                            callBack();
                        }
                    };
                    arrForEach(_core.getChannels(), function (channel) {
                        if (channel) {
                            waiting++;
                            channel[STR_FLUSH /* @min:%2eflush */](async, flushDone);
                        }
                    });
                    // decrement the initial "waiting"
                    flushDone();
                }, null, async);
                return result;
            };
            _self[_DYN_ONUNLOAD_FLUSH /* @min:%2eonunloadFlush */] = function (async) {
                if (async === void 0) { async = true; }
                arrForEach(_core.getChannels(), function (channel) {
                    if (channel[_DYN_ONUNLOAD_FLUSH /* @min:%2eonunloadFlush */]) {
                        channel[_DYN_ONUNLOAD_FLUSH /* @min:%2eonunloadFlush */]();
                    }
                    else {
                        channel[STR_FLUSH /* @min:%2eflush */](async);
                    }
                });
            };
            _self.loadAppInsights = function (legacyMode, logger, notificationManager) {
                if (legacyMode === void 0) { legacyMode = false; }
                if (legacyMode) {
                    throwUnsupported("Legacy Mode is no longer supported");
                }
                function _updateSnippetProperties(snippet) {
                    if (snippet) {
                        var snippetVer = "";
                        if (!isNullOrUndefined(_snippetVersion)) {
                            snippetVer += _snippetVersion;
                        }
                        if (_self[_DYN_CONTEXT /* @min:%2econtext */] && _self[_DYN_CONTEXT /* @min:%2econtext */].internal) {
                            _self[_DYN_CONTEXT /* @min:%2econtext */].internal.snippetVer = snippetVer || "-";
                        }
                        // apply updated properties to the global instance (snippet)
                        objForEachKey(_self, function (field, value) {
                            if (isString(field) &&
                                !isFunction(value) &&
                                field && field[0] !== "_" && // Don't copy "internal" values
                                arrIndexOf(_ignoreUpdateSnippetProperties, field) === -1) {
                                if (snippet[field] !== value) {
                                    snippet[field] = value;
                                }
                            }
                        });
                    }
                }
                doPerf(_self.core, function () { return "AISKU.loadAppInsights"; }, function () {
                    // initialize core
                    _core.initialize(_config, [_sender, properties, dependencies, _analyticsPlugin, _cfgSyncPlugin], logger, notificationManager);
                    objDefine(_self, "context", {
                        g: function () { return properties[_DYN_CONTEXT /* @min:%2econtext */]; }
                    });
                    if (!_throttleMgr) {
                        _throttleMgr = new ThrottleMgr(_core);
                    }
                    var sdkSrc = _findSdkSourceFile();
                    if (sdkSrc && _self[_DYN_CONTEXT /* @min:%2econtext */]) {
                        _self[_DYN_CONTEXT /* @min:%2econtext */].internal.sdkSrc = sdkSrc;
                    }
                    _updateSnippetProperties(_self[STR_SNIPPET /* @min:%2esnippet */]);
                    // Empty queue of all api calls logged prior to sdk download
                    _self.emptyQueue();
                    _self[STR_POLL_INTERNAL_LOGS /* @min:%2epollInternalLogs */]();
                    _self[_DYN_ADD_HOUSEKEEPING_BEF2 /* @min:%2eaddHousekeepingBeforeUnload */](_self);
                    _addUnloadHook(onConfigChange(cfgHandler, function () {
                        var defaultEnable = false;
                        if (_config.throttleMgrCfg[109 /* _eInternalMessageId.DefaultThrottleMsgKey */]) {
                            defaultEnable = !_config.throttleMgrCfg[109 /* _eInternalMessageId.DefaultThrottleMsgKey */].disabled;
                        }
                        if (!_throttleMgr.isReady() && _config.extensionConfig && _config.extensionConfig[_cfgSyncPlugin.identifier] && defaultEnable) {
                            // set ready state to true will automatically trigger flush()
                            _throttleMgr.onReadyState(true);
                        }
                        if (!_iKeySentMessage && !_config[_DYN_CONNECTION_STRING /* @min:%2econnectionString */] && isFeatureEnabled(IKEY_USAGE, _config)) {
                            _throttleMgr[_DYN_SEND_MESSAGE /* @min:%2esendMessage */](106 /* _eInternalMessageId.InstrumentationKeyDeprecation */, "See Instrumentation key support at aka.ms/IkeyMigrate");
                            _iKeySentMessage = true;
                        }
                        if (!_cdnSentMessage && _self[_DYN_CONTEXT /* @min:%2econtext */].internal.sdkSrc && _self[_DYN_CONTEXT /* @min:%2econtext */].internal.sdkSrc.indexOf("az416426") != -1 && isFeatureEnabled(CDN_USAGE, _config)) {
                            _throttleMgr[_DYN_SEND_MESSAGE /* @min:%2esendMessage */](110 /* _eInternalMessageId.CdnDeprecation */, "See Cdn support notice at aka.ms/JsActiveCdn");
                            _cdnSentMessage = true;
                        }
                        if (!_sdkVerSentMessage && parseInt(_snippetVersion) < 6 && isFeatureEnabled(SDK_LOADER_VER, _config)) {
                            _throttleMgr[_DYN_SEND_MESSAGE /* @min:%2esendMessage */](111 /* _eInternalMessageId.SdkLdrUpdate */, "An updated Sdk Loader is available, see aka.ms/SnippetVer");
                            _sdkVerSentMessage = true;
                        }
                    }));
                });
                return _self;
            };
            _self[_DYN_UPDATE_SNIPPET_DEFIN3 /* @min:%2eupdateSnippetDefinitions */] = function (snippet) {
                // apply full appInsights to the global instance
                // Note: This must be called before loadAppInsights is called
                proxyAssign(snippet, _self, function (name) {
                    // Not excluding names prefixed with "_" as we need to proxy some functions like _onError
                    return name && arrIndexOf(_ignoreUpdateSnippetProperties, name) === -1;
                });
            };
            _self.emptyQueue = function () {
                // call functions that were queued before the main script was loaded
                try {
                    if (isArray(_self.snippet[_DYN_QUEUE /* @min:%2equeue */])) {
                        // note: do not check length in the for-loop conditional in case something goes wrong and the stub methods are not overridden.
                        var length_1 = _self.snippet[_DYN_QUEUE /* @min:%2equeue */].length;
                        for (var i = 0; i < length_1; i++) {
                            var call = _self.snippet[_DYN_QUEUE /* @min:%2equeue */][i];
                            call();
                        }
                        _self.snippet[_DYN_QUEUE /* @min:%2equeue */] = undefined;
                        delete _self.snippet[_DYN_QUEUE /* @min:%2equeue */];
                    }
                }
                catch (exception) {
                    var properties_1 = {};
                    if (exception && isFunction(exception.toString)) {
                        properties_1.exception = exception.toString();
                    }
                    // need from core
                    // Microsoft.ApplicationInsights._InternalLogging.throwInternal(
                    //     eLoggingSeverity.WARNING,
                    //     _eInternalMessageId.FailedToSendQueuedTelemetry,
                    //     "Failed to send queued telemetry",
                    //     properties);
                }
            };
            _self[_DYN_ADD_HOUSEKEEPING_BEF2 /* @min:%2eaddHousekeepingBeforeUnload */] = function (appInsightsInstance) {
                // Add callback to push events when the user navigates away
                if (hasWindow() || hasDocument()) {
                    var performHousekeeping_1 = function () {
                        // Adds the ability to flush all data before the page unloads.
                        // Note: This approach tries to push a sync request with all the pending events onbeforeunload.
                        // Firefox does not respect this.Other browsers DO push out the call with < 100% hit rate.
                        // Telemetry here will help us analyze how effective this approach is.
                        // Another approach would be to make this call sync with a acceptable timeout to reduce the
                        // impact on user experience.
                        // appInsightsInstance.context._sender.triggerSend();
                        appInsightsInstance[_DYN_ONUNLOAD_FLUSH /* @min:%2eonunloadFlush */](false);
                        // Back up the current session to local storage
                        // This lets us close expired sessions after the cookies themselves expire
                        if (isFunction(_self.core[STR_GET_PLUGIN /* @min:%2egetPlugin */])) {
                            var loadedPlugin = _this.core[STR_GET_PLUGIN /* @min:%2egetPlugin */](PropertiesPluginIdentifier);
                            if (loadedPlugin) {
                                var propertiesPlugin = loadedPlugin.plugin;
                                if (propertiesPlugin && propertiesPlugin[_DYN_CONTEXT /* @min:%2econtext */] && propertiesPlugin[_DYN_CONTEXT /* @min:%2econtext */]._sessionManager) {
                                    propertiesPlugin[_DYN_CONTEXT /* @min:%2econtext */]._sessionManager.backup();
                                }
                            }
                        }
                    };
                    var added_1 = false;
                    if (!_houseKeepingNamespace) {
                        _houseKeepingNamespace = mergeEvtNamespace(_evtNamespace, _core[STR_EVT_NAMESPACE /* @min:%2eevtNamespace */] && _core[STR_EVT_NAMESPACE /* @min:%2eevtNamespace */]());
                    }
                    // Will be recalled if any referenced config properties change
                    _addUnloadHook(onConfigChange(_config, function (details) {
                        var coreConfig = details.cfg;
                        var analyticsPlugin = appInsightsInstance.appInsights;
                        var ctx = createProcessTelemetryContext(null, coreConfig, analyticsPlugin.core);
                        var extConfig = ctx.getExtCfg(analyticsPlugin.identifier || AnalyticsPluginIdentifier);
                        // As we could get recalled, remove any previously registered event handlers first
                        _removePageEventHandlers();
                        var excludePageUnloadEvents = coreConfig.disablePageUnloadEvents;
                        if (!extConfig.disableFlushOnBeforeUnload) {
                            // Hook the unload event for the document, window and body to ensure that the client events are flushed to the server
                            // As just hooking the window does not always fire (on chrome) for page navigation's.
                            if (addPageUnloadEventListener(performHousekeeping_1, excludePageUnloadEvents, _houseKeepingNamespace)) {
                                added_1 = true;
                            }
                            // We also need to hook the pagehide and visibilitychange events as not all versions of Safari support load/unload events.
                            if (addPageHideEventListener(performHousekeeping_1, excludePageUnloadEvents, _houseKeepingNamespace)) {
                                added_1 = true;
                            }
                            // A reactNative app may not have a window and therefore the beforeunload/pagehide events -- so don't
                            // log the failure in this case
                            if (!added_1 && !isReactNative()) {
                                _throwInternal(_core.logger, 1 /* eLoggingSeverity.CRITICAL */, 19 /* _eInternalMessageId.FailedToAddHandlerForOnBeforeUnload */, "Could not add handler for beforeunload and pagehide");
                            }
                        }
                        if (!added_1 && !extConfig.disableFlushOnUnload) {
                            // If we didn't add the normal set then attempt to add the pagehide and visibilitychange only
                            addPageHideEventListener(performHousekeeping_1, excludePageUnloadEvents, _houseKeepingNamespace);
                        }
                    }));
                }
            };
            _self.getSender = function () {
                return _sender;
            };
            _self.unload = function (isAsync, unloadComplete, cbTimeout) {
                var unloadDone = false;
                var result;
                if (isAsync && !unloadComplete) {
                    result = createPromise(function (resolve) {
                        // Set the callback to the promise resolve callback
                        unloadComplete = resolve;
                    });
                }
                function _unloadCallback(unloadState) {
                    if (!unloadDone) {
                        unloadDone = true;
                        _initDefaults();
                        unloadComplete && unloadComplete(unloadState);
                    }
                }
                _self[_DYN_ONUNLOAD_FLUSH /* @min:%2eonunloadFlush */](isAsync);
                _removePageEventHandlers();
                _core.unload && _core.unload(isAsync, _unloadCallback, cbTimeout);
                return result;
            };
            proxyFunctions(_self, _analyticsPlugin, [
                STR_GET_COOKIE_MGR,
                STR_TRACK_EVENT,
                STR_TRACK_PAGE_VIEW,
                "trackPageViewPerformance",
                STR_TRACK_EXCEPTION,
                "_onerror",
                STR_TRACK_TRACE,
                STR_TRACK_METRIC,
                STR_START_TRACK_PAGE,
                STR_STOP_TRACK_PAGE,
                STR_START_TRACK_EVENT,
                STR_STOP_TRACK_EVENT
            ]);
            proxyFunctions(_self, _getCurrentDependencies, [
                STR_TRACK_DEPENDENCY_DATA,
                "addDependencyListener",
                "addDependencyInitializer"
            ]);
            proxyFunctions(_self, _core, [
                STR_ADD_TELEMETRY_INITIALIZER,
                STR_POLL_INTERNAL_LOGS,
                "stopPollingInternalLogs",
                STR_GET_PLUGIN,
                "addPlugin",
                STR_EVT_NAMESPACE,
                "addUnloadCb",
                "getTraceCtx",
                "updateCfg",
                "onCfgChange"
            ]);
            proxyFunctions(_self, function () {
                var context = properties[_DYN_CONTEXT /* @min:%2econtext */];
                return context ? context.user : null;
            }, [
                STR_SET_AUTHENTICATED_USER_CONTEXT,
                STR_CLEAR_AUTHENTICATED_USER_CONTEXT
            ]);
            // Using a function to support the dynamic adding / removal of plugins, so this will always return the current value
            function _getCurrentDependencies() {
                return dependencies;
            }
            function _initDefaults() {
                _evtNamespace = createUniqueNamespace("AISKU");
                _houseKeepingNamespace = null;
                dependencies = null;
                properties = null;
                _sender = null;
                _snippetVersion = null;
                _throttleMgr = null;
                _iKeySentMessage = false;
                _cdnSentMessage = false;
                _sdkVerSentMessage = false;
                _cfgSyncPlugin = new CfgSyncPlugin();
            }
            function _removePageEventHandlers() {
                // Remove any registered event handlers
                if (_houseKeepingNamespace) {
                    removePageUnloadEventListener(null, _houseKeepingNamespace);
                    removePageHideEventListener(null, _houseKeepingNamespace);
                }
            }
            function _addUnloadHook(hooks) {
                _core.addUnloadHook(hooks);
            }
        });
    }
    // Analytics Plugin
// Removed Stub for AppInsightsSku.prototype.getCookieMgr.
// Removed Stub for AppInsightsSku.prototype.trackEvent.
// Removed Stub for AppInsightsSku.prototype.trackPageView.
// Removed Stub for AppInsightsSku.prototype.trackPageViewPerformance.
// Removed Stub for AppInsightsSku.prototype.trackException.
// Removed Stub for AppInsightsSku.prototype._onerror.
// Removed Stub for AppInsightsSku.prototype.trackTrace.
// Removed Stub for AppInsightsSku.prototype.trackMetric.
// Removed Stub for AppInsightsSku.prototype.startTrackPage.
// Removed Stub for AppInsightsSku.prototype.stopTrackPage.
// Removed Stub for AppInsightsSku.prototype.startTrackEvent.
// Removed Stub for AppInsightsSku.prototype.stopTrackEvent.
// Removed Stub for AppInsightsSku.prototype.addTelemetryInitializer.
    // Properties Plugin
// Removed Stub for AppInsightsSku.prototype.setAuthenticatedUserContext.
// Removed Stub for AppInsightsSku.prototype.clearAuthenticatedUserContext.
    // Dependencies Plugin
// Removed Stub for AppInsightsSku.prototype.trackDependencyData.
    // Misc
// Removed Stub for AppInsightsSku.prototype.flush.
// Removed Stub for AppInsightsSku.prototype.onunloadFlush.
// Removed Stub for AppInsightsSku.prototype.loadAppInsights.
// Removed Stub for AppInsightsSku.prototype.updateSnippetDefinitions.
// Removed Stub for AppInsightsSku.prototype.emptyQueue.
// Removed Stub for AppInsightsSku.prototype.pollInternalLogs.
// Removed Stub for AppInsightsSku.prototype.stopPollingInternalLogs.
// Removed Stub for AppInsightsSku.prototype.addHousekeepingBeforeUnload.
// Removed Stub for AppInsightsSku.prototype.getSender.
// Removed Stub for AppInsightsSku.prototype.unload.
// Removed Stub for AppInsightsSku.prototype.getPlugin.
// Removed Stub for AppInsightsSku.prototype.addPlugin.
// Removed Stub for AppInsightsSku.prototype.updateCfg.
// Removed Stub for AppInsightsSku.prototype.evtNamespace.
// Removed Stub for AppInsightsSku.prototype.addUnloadCb.
// Removed Stub for AppInsightsSku.prototype.addDependencyListener.
    /**
     * Add an dependency telemetry initializer callback function to allow populating additional properties or drop the request.
     * It is called after the dependency call has completed and any available performance details are available. A dependency
     * initializer is similar to the TelemetryInitializer function but it allows you to block the reporting of the dependency
     * request so that it doesn't count against the `maxAjaxCallsPerView`.
     * @param dependencyInitializer - The Dependency Telemetry Initializer function
     * @returns - A IDependencyInitializerHandler to enable the initializer to be removed
     */
    AppInsightsSku.prototype.addDependencyInitializer = function (dependencyInitializer) {
        return null;
    };
// Removed Stub for AppInsightsSku.prototype.getTraceCtx.
// Removed Stub for AppInsightsSku.prototype.onCfgChange.
    return AppInsightsSku;
}());
// tslint:disable-next-line
function _findSdkSourceFile() {
    if (_internalSdkSrc) {
        // Use the cached value
        return _internalSdkSrc;
    }
    var sdkSrc = null;
    var cdns = [
        "://js.monitor.azure.com/",
        "://az416426.vo.msecnd.net/"
    ];
    try {
        // Try and determine whether the sdk is being loaded from the CDN
        // currentScript is only valid during initial processing
        var scrpt = (document || {}).currentScript;
        if (scrpt) {
            sdkSrc = scrpt.src;
            // } else {
            //     // We need to update to at least typescript 2.9 for this to work :-(
            //     // Leaving as a stub for now so after we upgrade this breadcrumb is available
            //     let meta = import.meta;
            //     sdkSrc = (meta || {}).url;
            //     isModule = true;
        }
    }
    catch (e) {
        // eslint-disable-next-line no-empty
    }
    if (sdkSrc) {
        try {
            var url_1 = sdkSrc.toLowerCase();
            if (url_1) {
                var src_1 = "";
                arrForEach(cdns, function (value, idx) {
                    if (strIndexOf(url_1, value) !== -1) {
                        src_1 = "cdn" + (idx + 1);
                        if (strIndexOf(url_1, "/scripts/") === -1) {
                            if (strIndexOf(url_1, "/next/") !== -1) {
                                src_1 += "-next";
                            }
                            else if (strIndexOf(url_1, "/beta/") !== -1) {
                                src_1 += "-beta";
                            }
                        }
                        _internalSdkSrc = src_1 + ("");
                        return -1;
                    }
                });
            }
        }
        catch (e) {
            // eslint-disable-next-line no-empty
        }
        // Cache the found value so we don't have to look it up again
        _internalSdkSrc = sdkSrc;
    }
    return _internalSdkSrc;
}

/**
 * @private
 */
var Insights = /** @class */ (function () {
    function Insights(options) {
        this.options = options;
        if (!this.options.disableTelemetry && env.appInsightsKey) {
            this.appInsights = new AppInsightsSku({
                config: {
                    instrumentationKey: env.appInsightsKey,
                    // Don't globally track exceptions unless we call trackException()
                    disableExceptionTracking: true,
                    // Don't track every AJAX call
                    disableAjaxTracking: true,
                    // Play nice with other's AI instances by not using cookies
                    isCookieUseDisabled: true,
                    // Tighten the batch size window
                    maxBatchInterval: 5000
                }
            });
            // Load the app insights object.
            // Add our app version number to all telemetry items.
            this.appInsights.loadAppInsights();
            this.appInsights.addTelemetryInitializer(function (item) {
                // The applicationVersion property is special and defined by the app insights package.
                item.tags[CtxTagKeys.applicationVersion] = Version$1.getFullVersion();
            });
        }
    }
    Insights.prototype.trackEvent = function (event, customProperties) {
        if (!this.options.disableTelemetry && this.appInsights) {
            this.appInsights.trackEvent(event, customProperties);
        }
    };
    Insights.prototype.setAuthenticatedUserContext = function (authenticatedUserId, accountId) {
        if (!this.options.disableTelemetry && this.appInsights) {
            this.appInsights.setAuthenticatedUserContext(authenticatedUserId, accountId);
        }
    };
    Insights.prototype.trackException = function (exception) {
        if (!this.options.disableTelemetry && this.appInsights) {
            this.appInsights.trackException(exception);
        }
    };
    Insights.prototype.flush = function (async) {
        if (!this.options.disableTelemetry && this.appInsights) {
            this.appInsights.flush(async);
        }
    };
    return Insights;
}());

var __extends$m = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a CopyrightControl object.
 */
var CopyrightControlOptions = /** @class */ (function (_super) {
    __extends$m(CopyrightControlOptions, _super);
    function CopyrightControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The copyright plain text message to display. Will be appended to copyright content if provided
         */
        _this.copyrightMessage = undefined;
        /**
         * The copyright content element containing formatted copyright message
         * this is the primary way of setting copyright by CopyrightDelegate
         */
        _this.copyrightContent = undefined;
        /**
         * Additional custom user attribution appended to the end as it is
         */
        _this.customAttribution = undefined;
        /**
         * If true will show a link to the map feedback page.
         */
        _this.showFeedbackLink = true;
        /**
         * If true will show the Microsoft logo.
         */
        _this.showLogo = true;
        return _this;
    }
    return CopyrightControlOptions;
}(Options));

var __extends$l = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @private
 */
var CopyrightControl = /** @class */ (function (_super) {
    __extends$l(CopyrightControl, _super);
    function CopyrightControl(options) {
        var _this = _super.call(this) || this;
        _this.textAttribution = function (options) {
            return [_this.options.copyrightMessage, _this.options.customAttribution]
                .filter(function (message) { return message; })
                .join("");
        };
        // Append latitude, longitude and zoom level to feedback link.
        _this.updateFeedbackLink = function () {
            var _a;
            if (_this.feedbackAnchor && _this.map) {
                var center = (_a = _this.map.getCamera(), _a.center), zoom = _a.zoom;
                _this.feedbackAnchor.href = "".concat(CopyrightControl.feedbackLink, "&cp=").concat(center[1], "~").concat(center[0], "&lvl=").concat(zoom + 1);
            }
        };
        _this.options = new CopyrightControlOptions().merge(options);
        return _this;
    }
    CopyrightControl.prototype.onAdd = function (map) {
        this.map = map;
        this.container = this.buildContainer(map, ControlStyle.auto);
        this.container.className = "map-copyright without-bg";
        this.copyrightDiv = this.buildCopyrightDiv();
        this.copyrightDiv.className = "azure-map-copyright";
        this.container.appendChild(this.copyrightDiv);
        if (this.options.showFeedbackLink) {
            this.addRemoveFeedbackDiv(true);
        }
        return this.container;
    };
    CopyrightControl.prototype.onRemove = function () {
        _super.prototype.onRemove.call(this);
        delete this.container;
    };
    CopyrightControl.prototype.setOptions = function (options) {
        var _this = this;
        var newOptions = new CopyrightControlOptions().merge(this.options, options);
        if (newOptions.copyrightMessage !== this.options.copyrightMessage
            || newOptions.customAttribution !== this.options.customAttribution) {
            this.copyrightDiv.innerText = this.textAttribution(newOptions);
        }
        if (newOptions.copyrightContent !== this.options.copyrightContent) {
            if (this.options.copyrightContent) {
                var prev = Array.from(this.copyrightDiv.children).find(function (elem) { return elem === _this.options.copyrightContent; });
                this.copyrightDiv.removeChild(prev);
            }
            if (this.copyrightDiv.childNodes.length > 0) {
                this.copyrightDiv.insertBefore(newOptions.copyrightContent, this.copyrightDiv.childNodes[0]);
            }
            else {
                this.copyrightDiv.appendChild(newOptions.copyrightContent);
            }
            this.options.copyrightContent = newOptions.copyrightContent;
        }
        if (!newOptions.showFeedbackLink && this.feedbackAnchor) {
            this.addRemoveFeedbackDiv(false);
        }
        else if (newOptions.showFeedbackLink && !this.feedbackAnchor) {
            this.addRemoveFeedbackDiv(true);
        }
        this.options = newOptions;
    };
    CopyrightControl.prototype.getDefaultAttributions = function () {
        var currentYear = new Date().getFullYear();
        var copyright = ["\u00A9".concat(currentYear, " TomTom")];
        if (!this.options.showLogo) {
            copyright.push("\u00A9".concat(currentYear, " Microsoft"));
        }
        return copyright;
    };
    CopyrightControl.prototype.buildCopyrightDiv = function () {
        var copyright = document.createElement("div");
        copyright.innerText = this.textAttribution(this.options) || "";
        return copyright;
    };
    CopyrightControl.prototype.buildFeedbackLink = function () {
        var link = document.createElement("a");
        link.setAttribute("alt", "Provide Map Data Feedback");
        link.setAttribute("aria-label", "Provide Map Data Feedback");
        link.innerText = "Feedback";
        link.href = CopyrightControl.feedbackLink;
        link.target = "_blank";
        link.rel = "noopener";
        link.className = "azure-map-feedback-text";
        return link;
    };
    CopyrightControl.prototype.addRemoveFeedbackDiv = function (add) {
        var _a, _b, _c, _d;
        if (add) {
            this.feedbackAnchor = this.buildFeedbackLink();
            this.feedbackTooltip = buildAccessibleTooltip("Provide Map Data Feedback");
            this.container.appendChild(this.feedbackAnchor);
            this.container.appendChild(this.feedbackTooltip);
            positionTooltip(this.feedbackTooltip, this.feedbackAnchor);
            (_b = (_a = this.map) === null || _a === void 0 ? void 0 : _a.events) === null || _b === void 0 ? void 0 : _b.add("moveend", this.updateFeedbackLink);
        }
        else {
            this.feedbackAnchor.remove();
            this.feedbackTooltip.remove();
            delete this.feedbackTooltip;
            delete this.feedbackAnchor;
            (_d = (_c = this.map) === null || _c === void 0 ? void 0 : _c.events) === null || _d === void 0 ? void 0 : _d.remove("moveend", this.updateFeedbackLink);
        }
    };
    CopyrightControl.feedbackLink = "https://aka.ms/azuremaps-feedback?feedbackep=UrlAzureMapsWebSdk";
    return CopyrightControl;
}(ControlBase));

var __extends$k = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a LogoControl object.
 */
var LogoControlOptions = /** @class */ (function (_super) {
    __extends$k(LogoControlOptions, _super);
    function LogoControlOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * If true will show the Microsoft logo.
         */
        _this.showLogo = true;
        return _this;
    }
    return LogoControlOptions;
}(Options));

var __extends$j = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * A control that displays the logo on the map.
 * @private
 */
var LogoControl = /** @class */ (function (_super) {
    __extends$j(LogoControl, _super);
    /**
     * Construct a control
     */
    function LogoControl(options) {
        var _this = _super.call(this) || this;
        _this.map = null;
        /**
         * Set visibility of the control based on the container width.
         */
        _this._onResize = function () {
            var _a, _b;
            var width = ((_b = (_a = _this.map) === null || _a === void 0 ? void 0 : _a.getMapContainer()) === null || _b === void 0 ? void 0 : _b.clientWidth) || 0;
            _this._setVisiblity(_this.options.showLogo && width >= LogoControl.CONTAINER_MIN_WIDTH);
        };
        _this.options = new LogoControlOptions().merge(options);
        return _this;
    }
    /**
     * Initialization method for the control which is called when added to the map.
     * @param map The map that the control will be added to.
     * @param options The ControlOptions for this control.
     * @return An HTMLElement to be placed on the map for the control.
     */
    LogoControl.prototype.onAdd = function (map) {
        var _a;
        this.map = map;
        this.container = this.buildContainer(map, ControlStyle.auto);
        this.container.className = "map-logo-control";
        (_a = this.map) === null || _a === void 0 ? void 0 : _a.events.add("resize", this._onResize);
        this._addRemoveLogo(this.options.showLogo);
        return this.container;
    };
    LogoControl.prototype.onRemove = function () {
        var _a;
        _super.prototype.onRemove.call(this);
        (_a = this.map) === null || _a === void 0 ? void 0 : _a.events.remove("resize", this._onResize);
        this.map = null;
        delete this.container;
    };
    LogoControl.prototype.setOptions = function (options) {
        var newOptions = new LogoControlOptions().merge(this.options, options);
        if (!newOptions.showLogo && this.logoAnchor) {
            this._addRemoveLogo(false);
        }
        else if (newOptions.showLogo && !this.logoAnchor) {
            this._addRemoveLogo(true);
        }
        this.options = newOptions;
    };
    LogoControl.prototype._addRemoveLogo = function (add) {
        var _a, _b;
        if (add) {
            this.logoAnchor = document.createElement("a");
            this.logoAnchor.className = "azure-map-logo";
            this.logoAnchor.href = "https://aka.ms/azuremaps";
            this.logoAnchor.setAttribute("aria-label", "Visit azure.microsoft.com");
            this.logoAnchor.setAttribute("target", "_blank");
            this.container.appendChild(this.logoAnchor);
            this.logoTooltip = buildAccessibleTooltip("Visit azure.microsoft.com");
            this.container.appendChild(this.logoTooltip);
            positionTooltip(this.logoTooltip, this.logoAnchor);
            this._setVisiblity(true);
        }
        else {
            (_a = this.logoAnchor) === null || _a === void 0 ? void 0 : _a.remove();
            (_b = this.logoTooltip) === null || _b === void 0 ? void 0 : _b.remove();
            delete this.logoAnchor;
            this._setVisiblity(false);
        }
    };
    /**
     * Set visibility of the control.
     */
    LogoControl.prototype._setVisiblity = function (visible) {
        if (this.container) {
            this.container.style.display = visible ? "flex" : "none";
        }
    };
    LogoControl.CONTAINER_MIN_WIDTH = 480; // The minimum width of the container to show the logo, 5 copyright texts, and the feedback link.
    return LogoControl;
}(ControlBase));

/**
 * Provides some static methods to translate Mapbox's event based errors to try/catch style.
 */
var ErrorHandler = /** @class */ (function () {
    function ErrorHandler() {
    }
    /**
     * Executes the specified function and throws an error if Mapbox fires an error event.
     * A call to this should be wrapped in a try/catch.
     * @param map Either our map or the Mapbox map that will be firing the error events.
     * @param func The function to execute.
     * @internal
     */
    ErrorHandler.throwOnError = function (map, func) {
        // Work directly with the Mapbox map.
        var mbMap = map instanceof Map$1 ? map._getMap() : map;
        // Listen for the error event and throw if one is seen.
        var throwError = function (data) {
            mbMap.off("error", throwError);
            throw data.error;
        };
        mbMap.on("error", throwError);
        // Execute the specified function and return the result.
        // Stop the error listener before returning.
        var result = func();
        mbMap.off("error", throwError);
        return result;
    };
    /**
     * Executes the specified function and and throws an error if Mapbox fires an error event.
     * The call is wrapped in a try/catch.
     * @param map Either our map or the Mapbox map that will be firing the error events.
     * @param tryFunc The function to try executing.
     * @param catchFunc The function to execute if an error is fired.
     * @param finallyFunc An optional function to execute in the finally block.
     */
    ErrorHandler.tryCatch = function (map, tryFunc, catchFunc, finallyFunc) {
        try {
            return this.throwOnError(map, tryFunc);
        }
        catch (error) {
            return catchFunc(error);
        }
        finally {
            if (typeof finallyFunc === "function") {
                finallyFunc();
            }
        }
    };
    /**
     * Executes the specified function and and throws an error if Mapbox fires an error event.
     * The call is wrapped in a try/finally.
     * @param map Either our map or the Mapbox map that will be firing the error events.
     * @param tryFunc The function to try executing.
     * @param finallyFunc An optional function to execute in the finally block.
     */
    ErrorHandler.tryFinally = function (map, tryFunc, finallyFunc) {
        try {
            return this.throwOnError(map, tryFunc);
        }
        finally {
            finallyFunc();
        }
    };
    return ErrorHandler;
}());

var __assign$6 = (window && window.__assign) || function () {
    __assign$6 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$6.apply(this, arguments);
};
/**
 * @private
 */
var NearbyGeographySearchService = /** @class */ (function () {
    function NearbyGeographySearchService(map) {
        this.map = map;
    }
    NearbyGeographySearchService.prototype.request = function (options) {
        var _a;
        var domain = this.map.getServiceOptions().domain;
        var urlOptions = {
            domain: domain,
            path: "reverseGeocode",
            queryParams: __assign$6({ "api-version": "2023-06-01", "coordinates": "".concat(normalizeLongitude(options.position[0]), ",").concat(normalizeLatitude(options.position[1])) }, (options.style.view && { view: options.style.view })),
            headers: {
                "Accept-Language": options.style.language
            }
        };
        return new Url(((_a = this.map.authentication) === null || _a === void 0 ? void 0 : _a.signRequest(urlOptions)) || urlOptions).get();
    };
    return NearbyGeographySearchService;
}());

/** A static class that maintains a cache of place labels. */
var MapLabelCache = /** @class */ (function () {
    function MapLabelCache() {
        this._labelCache = {};
        this._labelIdx = {};
        this._preloadedCache = new Set();
    }
    /**
     * Adds a label to the cache.
     * @param label The label to cache.
     * @param layerInfo The configu info for the label.
     * @param pos The position of the label.
     * @param lang The language of the label.
     */
    MapLabelCache.prototype.cache = function (name, layerInfo, pos, lang) {
        var id = "".concat(name, "_").concat(pos[0], "_").concat(pos[1], "_").concat(lang);
        if (!this._labelIdx[layerInfo.labelType]) {
            this._labelIdx[layerInfo.labelType] = [];
            this._labelCache[layerInfo.labelType] = [];
        }
        if (this._labelIdx[layerInfo.labelType].indexOf(id) === -1) {
            // Add label to cache.
            this._labelCache[layerInfo.labelType].push({
                name: name,
                radius: layerInfo.radius,
                minZoom: layerInfo.minZoom,
                maxZoom: layerInfo.maxZoom || 24,
                position: pos
            });
            // Add label to index.
            this._labelIdx[layerInfo.labelType].push(id);
        }
    };
    /**
     * Calculates the nearest label in the cache.
     * @param labelType The type/category of the label in which the label is seperated into.
     * @param pos The position to center the search on.
     */
    MapLabelCache.prototype.getNearestLabel = function (labelType, pos, zoom) {
        var nearest = null;
        var c = this._labelCache[labelType];
        if (c) {
            var minDistance = Infinity;
            for (var i = 0, len = c.length; i < len; i++) {
                if (zoom >= c[i].minZoom && zoom <= c[i].maxZoom) {
                    var d = getDistanceTo(c[i].position, pos);
                    if (d <= c[i].radius && d <= minDistance) {
                        minDistance = d;
                        nearest = c[i];
                    }
                }
            }
        }
        return nearest;
    };
    /**
     * This function preloads the cache with major labels for a select few languages
     * in which these labels are most likely to be used with.
     * This is to help with identifying these major labels when the user is zoomed in close to the map.
     * In testing, this has been found to drastically reduce the number of times "unknown" is returned
     * for locations that border an ocean. Based on Bing Maps usage,
     * the following languages cover 98% of traffic they recieve.
     * Limiting the languages to those most likely to be used on the broder with an ocean.
     * @param lang The language to load into the cache.
     */
    MapLabelCache.prototype._preloadCache = function (lang) {
        // Only load a language once into cache.
        if (!this._preloadedCache.has(lang)) {
            // Translations for oceans: https://en.wikipedia.org/wiki/List_of_alternative_names_for_oceans
            this._preloadedCache.add(lang);
            var oceanConfig = {
                source: [],
                labelType: "water",
                minZoom: 0,
                radius: 3950000,
                polygonSources: [] // doesn't affect the cache key
            };
            var shortLang = lang;
            var index = shortLang.indexOf("-");
            if (index !== -1) {
                shortLang = shortLang.substr(0, index);
            }
            switch (shortLang) {
                case "fr":
                    this.cache("Océan Pacifique", oceanConfig, [-170, 32], lang);
                    this.cache("Océan Pacifique", oceanConfig, [-138, -27], lang);
                    this.cache("Océan Atlantique", oceanConfig, [-40, 32], lang);
                    this.cache("Océan Atlantique", oceanConfig, [-17, -29], lang);
                    break;
                case "es":
                    this.cache("Océan Pacifique", oceanConfig, [-170, 32], lang);
                    this.cache("Océan Pacifique", oceanConfig, [-138, -27], lang);
                    this.cache("Océano Atlántico", oceanConfig, [-40, 32], lang);
                    this.cache("Océano Atlántico", oceanConfig, [-17, -29], lang);
                    break;
                case "pt":
                    this.cache("Oceano Pacífico", oceanConfig, [-170, 32], lang);
                    this.cache("Oceano Pacífico", oceanConfig, [-138, -27], lang);
                    this.cache("Oceano Atlântico", oceanConfig, [-40, 32], lang);
                    this.cache("Oceano Atlântico", oceanConfig, [-17, -29], lang);
                    break;
                case "ja":
                    // Pacific Ocean
                    this.cache("太平洋", oceanConfig, [-170, 32], lang);
                    this.cache("太平洋", oceanConfig, [-138, -27], lang);
                    break;
                case "en":
                    this.cache("Pacific Ocean", oceanConfig, [-170, 32], lang);
                    this.cache("Pacific Ocean", oceanConfig, [-138, -27], lang);
                    this.cache("Atlantic Ocean", oceanConfig, [-40, 32], lang);
                    this.cache("Atlantic Ocean", oceanConfig, [-17, -29], lang);
                    this.cache("Indian Ocean", oceanConfig, [77, -26], lang);
                    break;
            }
        }
    };
    return MapLabelCache;
}());

var __awaiter$5 = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$5 = (window && window.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read$b = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$9 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * This class analyizes the current view of a map and provides a description for use by accessibilty tools.
 * TODO: Use services when in  GeoPol regions. (Kasmir) or when user region sensitive.
 */
var MapViewDescriptor = /** @class */ (function () {
    function MapViewDescriptor(map, descCallback) {
        var _this = this;
        // Track if disposed.
        this._disposed = false;
        // Track when the last description update occurred due to rotation.
        this._lastHeadingTime = 0;
        // A queue of the actions that haven't been described yet.
        this._actionQueue = [];
        // Number of milliseconds required for the pointer to be held down to get a description of that location.
        this._pointerUpdateDelay = 3000;
        // Number of milliseconds required between move end and the description update.
        this._camUpdateDelay = 1000;
        // Number of milliseconds required between heading description updates.
        this._headUpdateLimit = 1000;
        // Number of milliseconds to wait before acting on a move event originating from a control element.
        this._controlEventDelay = 500;
        // The minium number of pixels the map must move to trigger an update.
        // The larger this number is, the less updates will be triggered, but the less accurate the results will be.
        this._moveThreshold = 25;
        // The minium number of degrees the map must rotate to trigger an update.
        // The larger this number is, the less updates will be triggered, but the less accurate the results will be.
        this._headingThreshold = 5;
        // The minium number of degrees the map must pitch to trigger an update.
        // The larger this number is, the less updates will be triggered, but the less accurate the results will be.
        this._pitchThreshold = 5;
        // The number of pixels to search around the center for a road, or major label.
        this._roadPixelRadius = 120;
        // Minum distance a road has to be before it can be displayed. Only used when zoomed in close.
        this._minRoadDistance = 25;
        // Minium distance in pixels a second road must be in order to be considered an intersection.
        this._minIntersectionPixelDistance = 50;
        /*
         * Show details based on zoom level.
         *
         * Country: 1+
         * Water: 1+
         * States: 4+
         * City: 8+
         * Major POI: 8+  or 12+
         * Neighborhood: 12+
         * Poi: 16+
         * Road: 16+
         *
         * The following label types will be cached; Country, State, City, Water, and majorPoi.
         * The purpose of the cache is to provide a backup if no information is found in the source,
         * we can do a radial search for appropriate label type.
         * These often cover large areas and only have a single label.
         * When zoomed in, no icon is visible, so based on the type of polygon the center intersects with,
         * we can make an educated guess on what cache to pull a label from.
         *
         * Vector Tile source layers: https://developer.tomtom.com/maps-api/maps-api-documentation-vector/tile
         */
        // Configuration for label extraction.
        this._labelConfig = [
            // Water labels
            {
                source: ["Ocean label", "Ocean name"],
                labelType: "water",
                minZoom: 0, radius: 3950000,
                polygonSources: ["Ocean", "Ocean or sea"]
            },
            {
                source: ["Sea label"],
                labelType: "water",
                minZoom: 3,
                radius: 1000000,
                polygonSources: ["Sea", "Ocean or sea"]
            },
            // Country labels
            {
                source: ["Country name"],
                labelType: "country",
                minZoom: 0,
                maxZoom: 5,
                radius: 300000
            },
            // State labels
            {
                source: ["State name", "State name short"],
                labelType: "state",
                minZoom: 4,
                maxZoom: 7,
                radius: 300000
            },
            // City labels
            {
                source: ["Capital city", "Large city"],
                labelType: "city", minZoom: 8,
                radius: 40000
            },
            {
                source: ["Medium city"],
                labelType: "city",
                minZoom: 8,
                radius: 30000
            },
            {
                source: ["Small city"],
                labelType: "city",
                minZoom: 8,
                radius: 20000
            },
            {
                source: ["Island label"],
                labelType: "city",
                minZoom: 8,
                radius: 10000
            },
            {
                source: ["Town"],
                labelType: "city",
                minZoom: 10,
                radius: 10000
            },
            // Neighbourhood labels
            {
                source: ["Village"],
                labelType: "neighbourhood",
                minZoom: 12,
                radius: 6000
            },
            // POI labels
            {
                source: ["Amusement area label"],
                labelType: "poi",
                minZoom: 14,
                radius: 2000,
                polygonSources: ["Amusement park"]
            },
            {
                source: ["Hospital label"],
                labelType: "poi",
                minZoom: 14,
                radius: 1000,
                polygonSources: ["Hospital"]
            },
            {
                source: ["Shopping centre label"],
                labelType: "poi",
                minZoom: 14,
                radius: 1000,
                polygonSources: ["Shopping"]
            },
            {
                source: ["Stadium label"],
                labelType: "poi",
                minZoom: 14,
                radius: 1000,
                polygonSources: ["Stadium"]
            },
            {
                source: ["University/School label"],
                labelType: "poi",
                minZoom: 14,
                radius: 1000,
                polygonSources: ["University"]
            },
            {
                source: ["Zoo label"],
                labelType: "poi",
                minZoom: 14,
                radius: 1000,
                polygonSources: ["Zoo"]
            },
            // Major Poi labels
            {
                source: ["Airport Label", "Airport name", "Airport POI"],
                labelType: "majorPoi",
                minZoom: 11,
                radius: 3000,
                polygonSources: ["Airport", "Runway"]
            },
            {
                source: ["National park label"],
                labelType: "majorPoi",
                minZoom: 7,
                radius: 15000,
                polygonSources: ["National or state park", "National park", "Forest"]
            },
            {
                source: ["Reservation label"],
                labelType: "majorPoi",
                minZoom: 7,
                radius: 15000,
                polygonSources: ["Reservation"]
            }
        ];
        // Name of all label types to cache.
        this._labelCache = new Set(["city", "state", "country", "water", "majorPoi"]);
        // Name of all road source layers.
        this._roadLayers = new Set([
            "Connecting road",
            "Connecting road tunnel",
            "International road",
            "International road tunnel",
            "Local road",
            "Local road tunnel",
            "Major local road",
            "Major local road tunnel",
            "Major road",
            "Major road tunnel",
            "Minor local road",
            "Minor local road tunnel",
            "Motorway",
            "Motorway tunnel",
            "Secondary road",
            "Secondary road tunnel",
            "Toll connecting road",
            "Toll connecting road tunnel",
            "Toll international road",
            "Toll international road tunnel",
            "Toll local road",
            "Toll local road tunnel",
            "Toll major local road",
            "Toll major local road tunnel",
            "Toll major road",
            "Toll major road tunnel",
            "Toll minor local road",
            "Toll minor local road tunnel",
            "Toll motorway",
            "Toll motorway tunnel",
            "Toll secondary road",
            "Toll secondary road tunnel"
        ]);
        // Flag indicating if detailed descriptions which include zoom, lat/lon information should be returned.
        this._returnDetailedDescriptions = false;
        /** Event handler for shortcuts. */
        this._shortcutListener = function (e) { return __awaiter$5(_this, void 0, void 0, function () {
            var cam, styleOps, lang, style, camDesc;
            return __generator$5(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(e.altKey && e.ctrlKey && e.keyCode === 68)) return [3 /*break*/, 2];
                        this._returnDetailedDescriptions = !this._returnDetailedDescriptions;
                        cam = this._map.getCamera();
                        styleOps = this._map.getStyle();
                        lang = styleOps.language.toLowerCase();
                        style = styleOps.style.toLowerCase();
                        return [4 /*yield*/, this._getLocDesc(cam, lang, style)];
                    case 1:
                        camDesc = _a.sent();
                        this._descCallback(camDesc);
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        }); };
        /** Event handler for when the map is actively rotating and should update the heading description. */
        this._onRotate = function () {
            if (!_this._rotateTimeout) {
                if (Date.now() - _this._lastHeadingTime >= _this._headUpdateLimit) {
                    // If the min required time has already passed just do the update.
                    // tslint:disable-next-line: no-string-based-set-timeout
                    _this._rotateTimeout = setTimeout(_this._updateHeading, CompassControl.RotationDuration + 25);
                }
                else {
                    // If the min required time hasn't passed start a timeout if doesn't already exist.
                    // tslint:disable-next-line: no-string-based-set-timeout
                    _this._rotateTimeout = setTimeout(_this._updateHeading, _this._headUpdateLimit - (Date.now() - _this._lastHeadingTime));
                }
            }
        };
        /** Event handler for when the map is actively moving should wait to update the camera description. */
        this._onMove = function () {
            // Clear the timeout for updating the map's camera description.
            if (_this._moveTimeout) {
                clearTimeout(_this._moveTimeout);
                delete _this._moveTimeout;
            }
            // Clear the timeout for delaying updates originating from control elements.
            if (_this._controlTimeout) {
                clearTimeout(_this._controlTimeout);
                delete _this._controlTimeout;
            }
        };
        /** Event handler for when the mas has stopped moving and thus a new description is needed. */
        this._onMoveEnd = function (event) {
            if (event.fromControl) {
                // If the move end event originated from a control element delay the response to batch control clicks.
                // tslint:disable-next-line: no-string-based-set-timeout
                _this._controlTimeout = setTimeout(_this._updateCam, _this._controlEventDelay);
            }
            else {
                // Otherwise start processing a new description immediately.
                _this._updateCam();
            }
        };
        /** Event handler for when the map has changed styles. */
        this._onStyleData = function () {
            // Use setTimeout with no delay to allow mapbox time to
            // update the value of .loaded() before we check it.
            // tslint:disable-next-line: no-string-based-set-timeout
            setTimeout(_this._updateStyle);
        };
        /** Event handler for when the mouse or touch goes down */
        this._onPointerDown = function (event) {
            _this._lastPointerPos = _this._getEventPos(event);
            _this._pointerTimeout = setTimeout(function () { return __awaiter$5(_this, void 0, void 0, function () {
                var styleOps, lang, style, cam, loc;
                return __generator$5(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            styleOps = this._map.getStyle();
                            lang = styleOps.language.toLowerCase();
                            style = styleOps.style.toLowerCase();
                            cam = this._map.getCamera();
                            cam.center = this._map.pixelsToPositions([this._lastPointerPos])[0];
                            return [4 /*yield*/, this._getLocDesc(cam, lang, style)];
                        case 1:
                            loc = _a.sent();
                            this._descCallback(loc);
                            this._onPointerUp();
                            return [2 /*return*/];
                    }
                });
            }); }, _this._pointerUpdateDelay);
            // Start listening for the pointer moving in-case it moves far enough to cancel the location update.
            _this._map.getCanvas().addEventListener("mousemove", _this._onPointerMove);
            _this._map.getCanvas().addEventListener("touchmove", _this._onPointerMove);
            // Start listening for the pointer to go up to cancel the location update.
            _this._map.getCanvas().addEventListener("mouseup", _this._onPointerUp);
            _this._map.getCanvas().addEventListener("touchend", _this._onPointerUp);
        };
        /** Event handler for when the mouse or touch is moved */
        this._onPointerMove = function (event) {
            var pos = _this._getEventPos(event);
            var dx = _this._lastPointerPos[0] - pos[0];
            var dy = _this._lastPointerPos[1] - pos[1];
            var dist = Math.sqrt(dx * dx + dy * dy);
            if (dist > _this._moveThreshold) {
                _this._onPointerUp();
            }
        };
        /** Event handler for when the mouse or touch goes up */
        this._onPointerUp = function () {
            clearTimeout(_this._pointerTimeout);
            delete _this._pointerTimeout;
            _this._map.getCanvas().removeEventListener("mousemove", _this._onPointerMove);
            _this._map.getCanvas().removeEventListener("touchmove", _this._onPointerMove);
            _this._map.getCanvas().removeEventListener("mouseup", _this._onPointerUp);
            _this._map.getCanvas().removeEventListener("touchend", _this._onPointerUp);
        };
        /** Called when the map is rotating and needs a new description created */
        this._updateHeading = function () {
            // Update the heading description.
            var cam = _this._map.getCamera();
            if (!_this._lastHead || _this._checkHeadingThreshold(cam.bearing, _this._lastHead)) {
                // Update the last heading value and update time.
                var headDesc = _this._getHeadingDesc(cam);
                _this._lastHead = cam.bearing;
                _this._descCallback("<p>Map heading ".concat(headDesc, ".</p>"));
                _this._lastHeadingTime = Date.now();
            }
            // Reset for the next rotate.
            delete _this._rotateTimeout;
        };
        /** Called when the map has finished changing styles and is ready to create a new description */
        this._updateStyle = function () { return __awaiter$5(_this, void 0, void 0, function () {
            var cam, styleOps, lang, style, camDesc;
            return __generator$5(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cam = this._map.getCamera();
                        styleOps = this._map.getStyle();
                        lang = styleOps.language.toLowerCase();
                        style = styleOps.style.toLowerCase();
                        if (!(this._lastLang !== lang)) return [3 /*break*/, 2];
                        MapViewDescriptor._labelCache._preloadCache(lang);
                        return [4 /*yield*/, this._getLocDesc(cam, lang, style)];
                    case 1:
                        camDesc = _a.sent();
                        return [3 /*break*/, 4];
                    case 2:
                        if (!(this._lastStyle !== style && this._lastStyle === "blank")) return [3 /*break*/, 4];
                        return [4 /*yield*/, this._getLocDesc(cam, lang, style)];
                    case 3:
                        camDesc = _a.sent();
                        _a.label = 4;
                    case 4:
                        // Update the last lang and style values.
                        this._lastLang = lang;
                        this._lastStyle = style;
                        // Send the new description to the map.
                        if (camDesc) {
                            this._descCallback(camDesc);
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        /** Called when the map has finished updating and is ready to create a new description */
        this._updateCam = function (immediate) {
            if (immediate === void 0) { immediate = false; }
            var cam = _this._map.getCamera();
            if (!_this._lastCam || _this._actionQueue.length > 0 || _this._checkThresholds(cam, _this._lastCam)) {
                var styleOps = _this._map.getStyle();
                var lang_1 = styleOps.language.toLowerCase();
                var style_1 = styleOps.style.toLowerCase();
                // Update the action queue if an action is provided.
                var action = _this._getActionDesc(cam);
                if (action) {
                    _this._actionQueue.push(action);
                }
                // Update the last camera value.
                _this._lastCam = cam;
                // Make sure no other timeouts are active.
                if (_this._moveTimeout) {
                    clearTimeout(_this._moveTimeout);
                    delete _this._moveTimeout;
                }
                // Send the new description to the map.
                _this._moveTimeout = setTimeout(function () { return __awaiter$5(_this, void 0, void 0, function () {
                    var loc;
                    return __generator$5(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                // Clear the rotate timeout as the move description will cover rotation.
                                clearTimeout(this._rotateTimeout);
                                delete this._rotateTimeout;
                                return [4 /*yield*/, this._getLocDesc(cam, lang_1, style_1)];
                            case 1:
                                loc = _a.sent();
                                // Build the message from the action queue and current loc description.
                                if (this._actionQueue.length > 0) {
                                    this._descCallback("<p>Map ".concat(this._actionQueue.join(", then "), ".</p>").concat(loc));
                                    this._actionQueue = []; // Reset the queue because all actions have been delivered.
                                }
                                else {
                                    this._descCallback(loc);
                                }
                                return [2 /*return*/];
                        }
                    });
                }); }, immediate ? 0 : _this._camUpdateDelay);
            }
        };
        this._map = map;
        this._restFallback = map.getServiceOptions().enableAccessibilityLocationFallback;
        this._descCallback = descCallback;
        this._reverseSearch = new NearbyGeographySearchService(map);
        if (!MapViewDescriptor._labelCache) {
            MapViewDescriptor._labelCache = new MapLabelCache();
        }
        this._lastLang = this._map.getStyle().language.toLowerCase();
        MapViewDescriptor._labelCache._preloadCache(this._lastLang);
        this._map.events.addOnce("idle", function () {
            if (!_this._disposed) {
                _this._updateCam(true);
                // Find the id of the vector tile source being used.
                _this._baseVectorTileSourceId = MapViewDescriptor._baseVectorTileSourceIds.find(function (id) { return _this._map.sources.getById(id); });
                // Set the label config based on the vector tile source.
                if (_this._baseVectorTileSourceId === "bing-mvt") {
                    _this._labelConfig = MapViewDescriptor._labelConfigBing;
                    _this._roadLayers = MapViewDescriptor._roadLayersBing;
                }
                // Derive polygon layers from the label config.
                _this._polygonStyleLayer = _this._labelConfig.reduce(function (acc, cur) {
                    if (cur.polygonSources) {
                        acc.push.apply(acc, __spreadArray$9([], __read$b(cur.polygonSources), false));
                    }
                    return acc;
                }, []);
                // Add event listeners directly to mapbox because we will be using custom event data.
                // We don't automatically forward all properties of a mapbox event, so the custom data would be lost.
                var baseMap = _this._map._getMap();
                baseMap.on("move", _this._onMove);
                baseMap.on("moveend", _this._onMoveEnd);
                baseMap.on("styledata", _this._onStyleData);
                baseMap.on("rotate", _this._onRotate);
                var canvas = _this._map.getCanvas();
                canvas.addEventListener("mousedown", _this._onPointerDown);
                canvas.addEventListener("touchstart", _this._onPointerDown);
            }
        });
        this._map.getMapContainer().addEventListener("keydown", this._shortcutListener);
    }
    /** Disposes the MapViewDescriptor preventing any further updates */
    MapViewDescriptor.prototype.dispose = function () {
        this._disposed = true;
        // Event listeners were added directly to mapbox.
        // Remove them directly from there too.
        var baseMap = this._map._getMap();
        baseMap.off("move", this._onMove);
        baseMap.off("moveend", this._onMoveEnd);
        baseMap.off("styledata", this._onStyleData);
        baseMap.off("rotate", this._onRotate);
        var canvas = this._map.getCanvas();
        canvas.removeEventListener("mousedown", this._onPointerDown);
        canvas.removeEventListener("touchstart", this._onPointerDown);
        this._map.getMapContainer().removeEventListener("keydown", this._shortcutListener);
    };
    MapViewDescriptor.prototype._getEventPos = function (event) {
        if ("touches" in event) {
            var touch = event.touches[0];
            var rect = event.target.getBoundingClientRect();
            return [touch.pageX - rect.left, touch.pageY - rect.top];
        }
        else {
            return [event.offsetX, event.offsetY];
        }
    };
    /** Checks if the camera has changed enough to justify a new description */
    MapViewDescriptor.prototype._checkThresholds = function (newCam, lastCam) {
        return this._checkZoomThreshold(newCam.zoom, lastCam.zoom) ||
            this._checkPitchThreshold(newCam.pitch, lastCam.pitch) ||
            this._checkLocThreshold(newCam.center, lastCam.center) ||
            this._checkHeadingThreshold(newCam.bearing, lastCam.bearing);
    };
    /** Checks if the zoom has changed enough to justify a new description */
    MapViewDescriptor.prototype._checkZoomThreshold = function (newZoom, lastZoom) {
        return this._round(newZoom) !== this._round(lastZoom);
    };
    /** Checks if the pitch has changed enough to justify a new description */
    MapViewDescriptor.prototype._checkPitchThreshold = function (newPitch, lastPitch) {
        return Math.abs(newPitch - lastPitch) >= this._pitchThreshold;
    };
    /** Checks if the location has changed enough to justify a new description */
    MapViewDescriptor.prototype._checkLocThreshold = function (newCenter, lastCenter) {
        var _a;
        var lastPixel = (_a = __read$b(this._map.positionsToPixels([lastCenter, newCenter]), 2), _a[0]), newPixel = _a[1];
        return Pixel.getDistance(lastPixel, newPixel) >= this._moveThreshold;
    };
    /** Checks if the heading has changed enough to justify a new description */
    MapViewDescriptor.prototype._checkHeadingThreshold = function (newHeading, lastHeading) {
        // Modify the heading values to always be positive.
        if (newHeading < 0) {
            newHeading += 360;
        }
        if (lastHeading < 0) {
            lastHeading += 360;
        }
        // If the heading diff is greater than 180 it is
        // less difference in the other direction of rotation.
        var headDiff = Math.abs(newHeading - lastHeading);
        if (headDiff > 180) {
            headDiff = 360 - headDiff;
        }
        return headDiff >= this._headingThreshold;
    };
    /**
     * Generates the description for the map view around the center of the map.
     * @param cam The map camera informaiton.
     */
    MapViewDescriptor.prototype._getLocDesc = function (cam, lang, style) {
        return __awaiter$5(this, void 0, void 0, function () {
            var info_1, cPx_1, intersects_1, intersectingPolygon, intersectingType_1, i, cnt, layerInfo, cl_1;
            var _this = this;
            return __generator$5(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(style !== "blank")) return [3 /*break*/, 3];
                        if (!!this._map._getMap().loaded()) return [3 /*break*/, 2];
                        return [4 /*yield*/, new Promise(function (done) { return _this._map._getMap().once("idle", done); })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        info_1 = {};
                        cPx_1 = this._map.positionsToPixels([cam.center])[0];
                        ErrorHandler.tryCatch(this._map, function () {
                            var map = _this._map._getMap();
                            intersects_1 = map.queryRenderedFeatures(cPx_1, {
                                layers: _this._polygonStyleLayer.filter(function (layerId) { return map.getLayer(layerId); }),
                                filter: ["==", ["geometry-type"], "Polygon"]
                            });
                        }, function () { });
                        intersectingPolygon = null;
                        if (intersects_1 && intersects_1.length > 0) {
                            intersectingPolygon = intersects_1[0];
                        }
                        intersectingType_1 = null;
                        // Loop through each label config and try and retireve details about the map view.
                        for (i = 0, cnt = this._labelConfig.length; i < cnt; i++) {
                            layerInfo = this._labelConfig[i];
                            if (cam.zoom >= layerInfo.minZoom) {
                                // If the layer info has polygons defined, do an intersection test for matching.
                                if (layerInfo.polygonSources) {
                                    // Only if a value of the same type hasn't already been captured and the intersection polygon has the same source, retrieve a label.
                                    if (intersectingPolygon &&
                                        layerInfo.polygonSources.indexOf(intersectingPolygon.layer["source-layer"]) !== -1) {
                                        intersectingType_1 = layerInfo.labelType;
                                        this._getClosestLabel(layerInfo, cam, lang, info_1, false);
                                    }
                                    else {
                                        // If the polygon doesn't intersect, cache labels.
                                        this._getClosestLabel(layerInfo, cam, lang, info_1, true);
                                    }
                                }
                                else {
                                    this._getClosestLabel(layerInfo, cam, lang, info_1, false);
                                }
                            }
                            else {
                                this._getClosestLabel(layerInfo, cam, lang, info_1, true);
                            }
                        }
                        if (cam.zoom >= 8) {
                            // When zoomed in get all the roads as possible that roads might be only near edge.
                            // Need road to determine state info when zoomed in.
                            this._processRoads(info_1, cam, lang);
                        }
                        this._labelCache.forEach(function (label) {
                            if (!info_1[label]) {
                                cl_1 = null;
                                if (label === "water" || label === "majorPoi") {
                                    // Only check cache for water and majorPoi labels if the map is over top of water or a major Poi.
                                    if (label === intersectingType_1) {
                                        cl_1 = MapViewDescriptor._labelCache.getNearestLabel(label, cam.center, cam.zoom);
                                    }
                                }
                                else {
                                    cl_1 = MapViewDescriptor._labelCache.getNearestLabel(label, cam.center, cam.zoom);
                                }
                                if (cl_1) {
                                    info_1[label] = cl_1.name;
                                }
                            }
                        });
                        return [2 /*return*/, this._processLocInfo(cam, intersectingType_1, info_1, true, this._restFallback)];
                    case 3: 
                    // If the style is blank don't provide a label as that would always require a reverse geocode api call.
                    return [2 /*return*/, this._processLocInfo(cam, null, null, false, false)];
                }
            });
        });
    };
    /**
     * Generates the description for the map view around the center of the map.
     * @param cam The map camera informaiton.
     */
    MapViewDescriptor.prototype._getHeadingDesc = function (cam) {
        // Use the heading but shift any negative values.
        var heading = cam.bearing;
        if (heading < 0) {
            heading += 360;
        }
        // Snap to the nearest 5 degrees.
        heading = this._round(heading, this._headingThreshold);
        // Generate a new description.
        switch (heading) {
            case 0:
            case 360:
                return "north";
            case 45:
                return "north east";
            case 90:
                return "east";
            case 135:
                return "south east";
            case 180:
                return "south";
            case 225:
                return "south west";
            case 270:
                return "west";
            case 315:
                return "north west";
            default:
                return "".concat(heading, " degrees");
        }
    };
    /**
     * Gets the closest label to the center of the map.
     * @param layerInfo The label lauyer information.
     * @param cam The map camera information.
     * @param info The result information.
     * @param cacheOnly Specifies if labels should only be cached and not set on the result.
     */
    MapViewDescriptor.prototype._getClosestLabel = function (layerInfo, cam, lang, info, cacheOnly) {
        var radius = layerInfo.radius;
        // Loop through the label sources.
        for (var i = 0, len = layerInfo.source.length; i < len; i++) {
            var params = {
                sourceLayer: layerInfo.source[i],
                filter: ["has", "name"]
            };
            var labels = this._map._getMap().querySourceFeatures(this._baseVectorTileSourceId, params);
            var closest = null;
            var minDistance = Infinity;
            var cacheLabels = this._labelCache.has(layerInfo.labelType);
            if (!cacheOnly || (cacheOnly && cacheLabels)) {
                for (var j = 0, cnt = labels.length; j < cnt; j++) {
                    var p = labels[j].geometry.type === "Point" ?
                        labels[j] :
                        getClosestPointOnGeometry(cam.center, labels[j].geometry);
                    if (!cacheOnly) {
                        // Distance in meters.
                        var d = labels[j].geometry.type === "Point" ?
                            getDistanceTo(cam.center, p.geometry.coordinates) :
                            p.properties.distance;
                        if (d < minDistance) {
                            minDistance = d;
                            closest = labels[j];
                        }
                    }
                    if (cacheLabels) {
                        MapViewDescriptor._labelCache.cache(labels[j].properties.name, layerInfo, p.geometry.coordinates, lang);
                    }
                }
            }
            if (!cacheOnly) {
                var disParam = layerInfo.labelType + "Dis";
                if (closest && minDistance <= radius &&
                    (typeof info[disParam] !== "number" || minDistance <= info[disParam])) {
                    info[layerInfo.labelType] = closest.properties.name;
                    info[disParam] = minDistance;
                }
            }
        }
    };
    /**
     * Retrieve road information and extracts the closest road (within a threshold), as well as any state/country data that might be on it.
     * @param info The MapViewInfo object in which the results are added.
     * @param cam The map camera information.
     * @param searchArea An optional search area to limit the scope of where roads are extracted from.
     */
    MapViewDescriptor.prototype._processRoads = function (info, cam, lang, searchArea) {
        // Try and get road data. This provides additional country/state info, and also road names.
        var roads = this._map._getMap().queryRenderedFeatures(searchArea, {
            filter: ["==", ["geometry-type"], "LineString"]
        });
        if (roads) {
            var closestRoad = void 0;
            var closestRoad2 = void 0;
            var cPoint = void 0;
            var cPoint2 = void 0;
            // Get the closest road.
            for (var i = 0, len = roads.length; i < len; i++) {
                if (this._roadLayers.has(roads[i].layer["source-layer"])) {
                    if (roads[i].properties.name && roads[i].properties.name !== "") {
                        var cp = getClosestPointOnGeometry(cam.center, roads[i]);
                        if (!cPoint || cp.properties.distance < cPoint.properties.distance) {
                            if (closestRoad && roads[i].properties.name === closestRoad.properties.name) {
                                cPoint = cp;
                            }
                            else if (!closestRoad || roads[i].properties.name !== closestRoad.properties.name) {
                                cPoint2 = cPoint;
                                closestRoad2 = closestRoad;
                                cPoint = cp;
                                closestRoad = roads[i];
                            }
                            else if (!cPoint2 || cp.properties.distance < cPoint2.properties.distance) {
                                cPoint2 = cp;
                                closestRoad2 = roads[i];
                            }
                        }
                    }
                }
            }
            if (closestRoad) {
                // Capture state and country codes from the closest road to ensure we have the most accurate values.
                // Note: bing tiles do not have country_code and country_subdivision in road features.
                if (!info.country && closestRoad.properties.country_code) {
                    info.country = closestRoad.properties.country_code;
                    info.countryDis = 0;
                    MapViewDescriptor._labelCache.cache(info.country, {
                        source: [],
                        labelType: "country",
                        radius: 5000,
                        minZoom: 0
                    }, cPoint.geometry.coordinates, lang);
                }
                if (!info.state && closestRoad.properties.country_subdivision) {
                    info.state = closestRoad.properties.country_subdivision;
                    info.stateDis = 0;
                    MapViewDescriptor._labelCache.cache(info.state, {
                        source: [],
                        labelType: "state",
                        radius: 5000,
                        minZoom: 4
                    }, cPoint.geometry.coordinates, lang);
                }
                // Only capture road name if zoomed in and close enough to the center of the map.
                if (cam.zoom >= 15) {
                    var pixels = this._map.positionsToPixels([cam.center, cPoint.geometry.coordinates]);
                    var pxDis = Pixel.getDistance(pixels[0], pixels[1]);
                    if (pxDis < this._roadPixelRadius || cPoint.properties.distance < this._minRoadDistance) {
                        info.road = closestRoad.properties.name;
                    }
                    if (closestRoad2) {
                        var px = this._map.positionsToPixels([cPoint2.geometry.coordinates]);
                        pxDis = Pixel.getDistance(pixels[0], px[0]);
                        if (pxDis < this._minIntersectionPixelDistance || cPoint2.properties.distance < this._minRoadDistance) {
                            info.secondRoad = closestRoad2.properties.name;
                            info.secondRoadDis = cPoint2.properties.distance;
                        }
                    }
                }
            }
        }
    };
    /**
     * Generates a description of the most recent map actions.
     * @param cam The map camera information.
     */
    MapViewDescriptor.prototype._getActionDesc = function (cam) {
        if (this._lastCam) {
            // Build and array of actions that have occurred.
            // Will be flattened into just a string at the end.
            var actions = [];
            // Panning/Center
            if (this._checkLocThreshold(cam.center, this._lastCam.center)) {
                // Build the panning message is stages.
                var msg = ["panned"];
                var heading = Math.round(getHeading(this._lastCam.center, cam.center));
                // Assign a cardinal direction for the panning.
                if (heading === 0 || heading === 360) {
                    msg.push("north");
                }
                else if (heading < 90) {
                    msg.push("north east");
                }
                else if (heading === 90) {
                    msg.push("east");
                }
                else if (heading < 180) {
                    msg.push("south east");
                }
                else if (heading === 180) {
                    msg.push("south");
                }
                else if (heading < 270) {
                    msg.push("south west");
                }
                else if (heading === 270) {
                    msg.push("west");
                }
                else if (heading < 360) {
                    msg.push("north west");
                }
                // If the distance is greater than 1000 use KM instead of meters.
                var distance = getDistanceTo(this._lastCam.center, cam.center, DistanceUnits.meters);
                msg.push(distance > 1000 ?
                    "".concat(_precision(distance / 1000, 2), " kilometers") :
                    "".concat(_precision(distance, 2), " meters"));
                // Add the complete message to the actions array.
                actions.push(msg.join(" "));
            }
            // Zoom
            if (this._checkZoomThreshold(cam.zoom, this._lastCam.zoom)) {
                // Start with zoom and the direction of change.
                var msg = ["zoomed"];
                msg.push(this._lastCam.zoom < cam.zoom ? "in" : "out");
                // Include the number of levels changed if greater than 1.
                var diff = Math.abs(this._lastCam.zoom - cam.zoom);
                if (diff >= 1) {
                    // Round the zoom level difference to the nearest integer.
                    diff = Math.ceil(diff);
                    // Add the number of levels difference.
                    msg.push(diff > 1 ?
                        "".concat(diff, " levels") :
                        "".concat(diff, " level"));
                }
                // If the canonical zoom name is different include the new name.
                if (this._getCanonicalZoom(this._lastCam.zoom) !== this._getCanonicalZoom(cam.zoom)) {
                    msg.push("to ".concat(this._getCanonicalZoom(cam.zoom), " level"));
                }
                // announce maximum zoom reached
                if (cam.zoom >= cam.maxZoom) {
                    msg.push("Zoom In button disabled, maximum zoom level reached");
                }
                var reachedLatitudeBoundaries = BoundingBox.getSouth(cam.bounds) <= -WEBMERCATOR_MAXLAT
                    && BoundingBox.getNorth(cam.bounds) >= WEBMERCATOR_MAXLAT;
                // annouce minimum zoom level reached
                if (cam.zoom <= cam.minZoom || reachedLatitudeBoundaries) {
                    msg.push("Zoom Out button disabled, minimum zoom level reached");
                }
                // Add the complete message to the actions array.
                actions.push(msg.join(" "));
            }
            // Pitch
            if (this._checkPitchThreshold(cam.pitch, this._lastCam.pitch)) {
                // If the pitch has changed enough add the new pitch value to the actions array.
                var pitch = this._round(cam.pitch, this._pitchThreshold);
                actions.push("pitched to ".concat(pitch, " degrees"));
                if (cam.pitch === 60 || cam.pitch === 0) {
                    var maxOrMim = cam.pitch === 60 ? "maximum" : "minimum";
                    actions.push("reached ".concat(maxOrMim, " of ").concat(cam.pitch, " degrees"));
                }
            }
            // Heading
            if (this._checkHeadingThreshold(this._lastCam.bearing, cam.bearing)) {
                actions.push("rotated to ".concat(this._getHeadingDesc(cam)));
            }
            // Return the flattened list of actions as one string.
            return actions.join(" and ") || null;
        }
        return null;
    };
    /** Gets the canonical zoom level name, such as world, country, or city level. */
    MapViewDescriptor.prototype._getCanonicalZoom = function (zoom) {
        // Determine the canonical name based on the rounded zoom level.
        zoom = this._round(zoom);
        // Determine the canonical name.
        if (zoom < 2) {
            return "world";
        }
        else if (zoom < 5) {
            return "country";
        }
        else if (zoom < 11) {
            return "state province";
        }
        else if (zoom < 15) {
            return "city";
        }
        return "street"; // Zoom 15+ is street level.
    };
    /**
     * Generates a description from extracted location information.
     * @param cam The map camera information.
     * @param info The extracted locaiton information.
     * @returns A string description for the map view.
     */
    MapViewDescriptor.prototype._processLocInfo = function (cam, intersectingType, info, location, restFallback) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var html = [];
            if (location) {
                /*
                 * Show details based on zoom level.
                 *
                 * Country: 1+
                 * Water: 1+
                 * States: 4+
                 * City: 6+
                 * Major POI: 8+
                 * Neighborhood: 12+
                 * Poi: 14+
                 * Road: 15+
                 */
                var text = [];
                if (info) {
                    if (intersectingType) {
                        if (intersectingType === "water" && info.water) {
                            text.push(info.water);
                        }
                        else if (intersectingType === "majorPoi" && info.majorPoi) {
                            text.push(info.majorPoi);
                        }
                    }
                    if (text.length === 0) {
                        if (info.majorPoi && cam.zoom >= 8) {
                            text.push(info.majorPoi);
                        }
                        else {
                            if (info.poi && cam.zoom >= 14) {
                                text.push(info.poi);
                            }
                            else if (info.road && cam.zoom >= 15) {
                                if (info.secondRoad) {
                                    text.push(info.road + " & " + info.secondRoad);
                                }
                                else {
                                    text.push(info.road);
                                }
                            }
                            if (info.neighbourhood && cam.zoom >= 12) {
                                text.push(info.neighbourhood);
                            }
                            if (info.city && cam.zoom >= 6) {
                                text.push(info.city);
                            }
                        }
                        if (info.state && cam.zoom >= 4) {
                            text.push(info.state);
                        }
                        if (text.length === 0) {
                            if (info.water) {
                                text.push(info.water);
                            }
                            else if (info.country) {
                                text.push(info.country);
                            }
                        }
                        else if (text.length === 1 && info.state && cam.zoom >= 4 && info.country) {
                            text.push(info.country);
                        }
                    }
                }
                // TODO: need to support localization for these value.
                if (text.length > 0) {
                    html.push("<p>Location: ", text.join(", "), ".</p>");
                }
                else if (restFallback && intersectingType !== "water") {
                    // No location text found, so fallback onto REST services, but only if map not over water.
                    _this._reverseGeocodeDescription(cam).then(function (desc) {
                        resolve(desc);
                    }, function () {
                        reject("<p>Location: unknown</p>");
                    });
                    return;
                }
            }
            if (_this._returnDetailedDescriptions) {
                html.push("<p>Zoom: ", _precision(cam.zoom, 2), ".</p>");
                html.push("<p>Latitude: ", _precision(cam.center[1], 5), ".</p>");
                html.push("<p>Longitude: ", _precision(cam.center[0], 5), ".</p>");
            }
            resolve(html.join(""));
        });
    };
    /**
     * Uses the reverse geocoding service to determine the description for the center of the map.
     * @param cam The map camera information.
     */
    MapViewDescriptor.prototype._reverseGeocodeDescription = function (cam) {
        var _this = this;
        return new Promise(function (resolve) {
            var style = _this._map.getStyle();
            _this._reverseSearch.request({
                position: cam.center,
                style: style
            }).then(function (r) {
                var _a, _b, _c;
                var info = {};
                if (r && r.features && r.features.length > 0) {
                    if ((_b = (_a = r.features[0]) === null || _a === void 0 ? void 0 : _a.properties) === null || _b === void 0 ? void 0 : _b.address) {
                        var a = r.features[0].properties.address;
                        if (a.countryRegion) {
                            info.country = a.countryRegion.name;
                            MapViewDescriptor._labelCache.cache(info.country, {
                                source: [],
                                labelType: "country",
                                radius: 5000,
                                minZoom: 0
                            }, cam.center, style.language);
                        }
                        if (a.adminDistricts) {
                            info.state = (_c = a.adminDistricts[0]) === null || _c === void 0 ? void 0 : _c.shortName;
                            MapViewDescriptor._labelCache.cache(info.state, {
                                source: [],
                                labelType: "state",
                                radius: 5000,
                                minZoom: 4
                            }, cam.center, style.language);
                        }
                        if (a.locality) {
                            info.city = a.locality;
                            MapViewDescriptor._labelCache.cache(info.city, {
                                source: [],
                                labelType: "city",
                                radius: 1000,
                                minZoom: 10
                            }, cam.center, style.language);
                        }
                        if (a.addressLine) {
                            info.road = a.addressLine;
                        }
                    }
                }
                _this._processLocInfo(cam, null, info, true, false).then(function (desc) {
                    resolve(desc);
                });
            }, function (error) {
                _this._processLocInfo(cam, null, null, true, false).then(function (desc) {
                    resolve(desc);
                });
            }).catch(function (e) {
                _this._processLocInfo(cam, null, null, true, false).then(function (desc) {
                    resolve(desc);
                });
            });
        });
    };
    /** Rounds the input value to the nearest multiple of the specified increment value. */
    MapViewDescriptor.prototype._round = function (val, increment) {
        if (increment === void 0) { increment = 1; }
        return Math.round(val / increment) * increment;
    };
    // Ids of vector tile sources for different style APIs.
    MapViewDescriptor._baseVectorTileSourceIds = ["microsoft.base", "vectorTiles", "bing-mvt"];
    // Configuration for label extraction of Bing tiles.
    MapViewDescriptor._labelConfigBing = [
        // Water labels
        {
            source: ["water_feature"],
            labelType: "water",
            minZoom: 0,
            radius: 3950000,
            polygonSources: ["generic_water_fill"]
        },
        {
            source: ["water_feature"],
            labelType: "water",
            minZoom: 3,
            radius: 1000000,
            polygonSources: ["generic_water_fill"]
        },
        // Country labels
        {
            source: ["country_region"],
            labelType: "country",
            minZoom: 0,
            maxZoom: 5,
            radius: 300000
        },
        // State labels
        {
            source: ["admin_division1"],
            labelType: "state",
            minZoom: 4,
            maxZoom: 7,
            radius: 300000
        },
        // City labels
        {
            source: ["populated_place"],
            labelType: "city",
            minZoom: 8,
            radius: 40000
        },
        // Neighbourhood labels
        {
            source: ["neighborhood"],
            labelType: "neighbourhood",
            minZoom: 12,
            radius: 6000
        },
        // POI labels
        {
            source: ["amusement_park"],
            labelType: "poi",
            minZoom: 14,
            radius: 2000,
            polygonSources: ["amusement_park_fill"]
        },
        {
            source: ["hospital"],
            labelType: "poi",
            minZoom: 14,
            radius: 1000,
            polygonSources: ["hospital_fill"]
        },
        {
            source: ["shopping_center"],
            labelType: "poi",
            minZoom: 14,
            radius: 1000,
            polygonSources: ["shopping_center_fill"]
        },
        {
            source: ["stadium"],
            labelType: "poi",
            minZoom: 14,
            radius: 1000,
            polygonSources: ["stadium_fill"]
        },
        {
            source: ["higher_education_facility", "school"],
            labelType: "poi",
            minZoom: 14,
            radius: 1000,
            polygonSources: ["higher_education_facility_fill", "school_fill"]
        },
        {
            source: ["zoo"],
            labelType: "poi",
            minZoom: 14,
            radius: 1000,
            polygonSources: ["zoo_fill"]
        },
        // Major Poi labels
        {
            source: ["airport", "airport_terminal"],
            labelType: "majorPoi",
            minZoom: 11,
            radius: 3000,
            polygonSources: ["airport_terminal_fill", "airport_fill-merged7", "airport_runway_fill"]
        },
        {
            source: ["reserve"],
            labelType: "majorPoi",
            minZoom: 7,
            radius: 15000,
            polygonSources: ["generic_reserve_fill", "land_cover_forest_fill"]
        }
    ];
    // Name of all road source layers of Bing tiles.
    MapViewDescriptor._roadLayersBing = new Set([
        "road"
    ]);
    return MapViewDescriptor;
}());

/**
 * @private
 */
var AccessibleMapDelegate = /** @class */ (function () {
    function AccessibleMapDelegate(map) {
        var _this = this;
        this.addToMap = function () {
            if (_this.mapViewDesc != null) {
                // AccessibleMapDelegate is already initialized and added to the map.
                return;
            }
            _this.initializeMapLiveStateInfo();
            _this.initializeMapStyleInfo();
            _this.createMapKeyBindingInfo();
            _this.map.getMapContainer().setAttribute("role", "application");
            _this.map.getMapContainer().setAttribute("aria-label", "Map Application");
            _this.map.getCanvasContainer().setAttribute("aria-live", "polite");
            _this.map.getCanvasContainer().setAttribute("aria-describedby", "atlas-map-state atlas-map-style");
            _this.map.getCanvas().setAttribute("aria-label", "Interactive Map");
            _this.map.getCanvas().setAttribute("aria-describedby", "atlas-map-shortcuts");
            _this.map.getCanvas().setAttribute("alt", "Interactive Map");
        };
        this.removeFromMap = function () {
            if (_this.mapViewDesc != null) {
                _this.mapViewDesc.dispose();
            }
            delete _this.mapViewDesc;
            if (_this.atlasMapKeyBindings != null) {
                _this.map.getCanvasContainer().removeChild(_this.atlasMapKeyBindings);
            }
            delete _this.atlasMapKeyBindings;
            if (_this.atlasMapLiveStateInfo != null) {
                _this.map.getCanvasContainer().removeChild(_this.atlasMapLiveStateInfo);
            }
            delete _this.atlasMapLiveStateInfo;
            if (_this.atlasMapStyleInfo != null) {
                _this.map.getCanvasContainer().removeChild(_this.atlasMapStyleInfo);
            }
            delete _this.atlasMapStyleInfo;
            _this.map.getMapContainer().removeAttribute("role");
            _this.map.getMapContainer().removeAttribute("aria-label");
            _this.map.getCanvasContainer().removeAttribute("aria-live");
            _this.map.getCanvasContainer().removeAttribute("aria-describedby");
            _this.map.getCanvas().removeAttribute("aria-label");
            _this.map.getCanvas().removeAttribute("aria-describedby");
            _this.map.getCanvas().removeAttribute("alt");
            _this.map.events.remove("stylechanged", _this.updateMapStyle);
        };
        this.createMapKeyBindingInfo = function () {
            _this.atlasMapKeyBindings = document.createElement("div");
            _this.atlasMapKeyBindings.setAttribute("tabindex", "-1");
            _this.atlasMapKeyBindings.setAttribute("aria-hidden", "true");
            _this.atlasMapKeyBindings.id = "atlas-map-shortcuts";
            _this.atlasMapKeyBindings.classList.add("hidden-accessible-element");
            _this.atlasMapKeyBindings.innerHTML = [
                "Map shortcuts:",
                "Zoom out: hyphen.",
                "Zoom in: plus.",
                "Pan right 100 pixels: right arrow.",
                "Pan left 100 pixels: left arrow.",
                "Pan up 100 pixels: up arrow.",
                "Pan down 100 pixels: down arrow.",
                "Rotate 15 degrees clockwise: shift + right arrow.",
                "Rotate 15 degrees counter clockwise: shift + left arrow.",
                "Increase pitch 10 degrees: shift + up arrow.",
                "Decrease pitch 10 degrees: shift + down arrow.",
                // Interesting... i'm not sure that verbose map state was ever implemented 
                // "Toggle verbose map state: control + alt + D.",
                "Jump focus to the map: Escape."
            ].join("\n");
            _this.map.getCanvasContainer().appendChild(_this.atlasMapKeyBindings);
            var baseShortcutKeyCodes = [
                // - (zoom out)
                189,
                // = (zoom in)
                187,
                // arrow up
                38,
                // arrow left
                37,
                // arrow right
                39,
                // arrow down
                40
            ];
            // accessibility recommendation: After using any of the map shortcut keys, NVDA should not read all the shortcut keys again.
            // // TODO: this should be this.map._getMap().getCanvas
            var mapCanvas = _this.map._getMap()._canvas;
            mapCanvas === null || mapCanvas === void 0 ? void 0 : mapCanvas.addEventListener('keyup', function (event) {
                if (baseShortcutKeyCodes.find(function (code) { return event.keyCode === code; })) {
                    _this.atlasMapKeyBindings.innerHTML = '';
                }
            });
        };
        this.initializeMapLiveStateInfo = function () {
            {
                _this.mapViewDesc = new MapViewDescriptor(_this.map, _this.updateMapState);
                _this.atlasMapLiveStateInfo = document.createElement("div");
                _this.atlasMapLiveStateInfo.setAttribute("tabindex", "-1");
                _this.atlasMapLiveStateInfo.setAttribute("aria-hidden", "true");
                _this.atlasMapLiveStateInfo.id = "atlas-map-state";
                _this.atlasMapLiveStateInfo.classList.add("hidden-accessible-element");
                _this.map.getCanvasContainer().appendChild(_this.atlasMapLiveStateInfo);
            }
        };
        this.initializeMapStyleInfo = function () {
            _this.atlasMapStyleInfo = document.createElement("div");
            _this.atlasMapStyleInfo.setAttribute("tabindex", "-1");
            _this.atlasMapStyleInfo.setAttribute("aria-hidden", "true");
            _this.atlasMapStyleInfo.id = "atlas-map-style";
            _this.atlasMapStyleInfo.classList.add("hidden-accessible-element");
            _this.map.events.add("stylechanged", _this.updateMapStyle);
            _this.map.getCanvasContainer().appendChild(_this.atlasMapStyleInfo);
        };
        this.updateMapStyle = function () {
            _this.atlasMapStyleInfo.innerHTML = "<p>Map style: ".concat(_this.map.getStyle().style, ".</p>");
        };
        this.updateMapState = function (desc) {
            _this.atlasMapLiveStateInfo.innerHTML = desc;
        };
        this.map = map;
    }
    return AccessibleMapDelegate;
}());

/**
 * @private
 */
var FlowServiceDelegate = /** @class */ (function () {
    function FlowServiceDelegate(map) {
        var _this = this;
        this.listenerEnabled = false;
        this.lastFlowMode = "none";
        this.addToMap = function () {
            // Check that the map is ready first.
            if (!_this.map._isReady()) {
                throw new Error("Traffic flow could not be added to the map because " +
                    "the map is not ready. Please use a ready event listener to guarantee " +
                    "the map is ready before enabling traffic flow.");
            }
            // Enable the styledata listener.
            // The flowPath may need to change if the style changes.
            if (!_this.listenerEnabled) {
                _this.map.events.add("styledata", _this.addToMap);
                _this.listenerEnabled = true;
            }
            var trafficOptions = _this.map.getTraffic();
            if (trafficOptions.flow !== "none") {
                var trafficFlowComponent = _this.map.layers.getLayerById("traffic_".concat(trafficOptions.flow));
                if (trafficFlowComponent) {
                    _this.lastFlowMode = trafficOptions.flow;
                    trafficFlowComponent._updateLayoutProperty("visibility", "visible", "none");
                }
            }
        };
        this.removeFromMap = function () {
            _this.map.getTraffic();
            if (_this.lastFlowMode != "none") {
                var trafficFlowComponent = _this.map.layers.getLayerById("traffic_".concat(_this.lastFlowMode));
                if (trafficFlowComponent) {
                    trafficFlowComponent._updateLayoutProperty("visibility", "none", "visible");
                }
                _this.lastFlowMode = "none";
            }
            // Disable the styledata listener
            if (_this.listenerEnabled) {
                _this.map.events.remove("styledata", _this.addToMap);
                _this.listenerEnabled = false;
            }
        };
        this.map = map;
    }
    return FlowServiceDelegate;
}());

var __extends$i = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @private
 */
var Incident = /** @class */ (function (_super) {
    __extends$i(Incident, _super);
    function Incident(data, point, localizedStrings) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1;
        var iconCategory = ((_o = (_m = (_l = (_k = (_j = (_h = (_g = (_f = (_e = (_d = (_c = (_b = (_a = data.icon_category_12) !== null && _a !== void 0 ? _a : data.icon_category_11) !== null && _b !== void 0 ? _b : data.icon_category_10) !== null && _c !== void 0 ? _c : data.icon_category_9) !== null && _d !== void 0 ? _d : data.icon_category_8) !== null && _e !== void 0 ? _e : data.icon_category_7) !== null && _f !== void 0 ? _f : data.icon_category_6) !== null && _g !== void 0 ? _g : data.icon_category_5) !== null && _h !== void 0 ? _h : data.icon_category_4) !== null && _j !== void 0 ? _j : data.icon_category_3) !== null && _k !== void 0 ? _k : data.icon_category_2) !== null && _l !== void 0 ? _l : data.icon_category_1) !== null && _m !== void 0 ? _m : data.icon_category_0) !== null && _o !== void 0 ? _o : data.icon_category);
        var description = ((_1 = (_0 = (_z = (_y = (_x = (_w = (_v = (_u = (_t = (_s = (_r = (_q = (_p = data.description_12) !== null && _p !== void 0 ? _p : data.description_11) !== null && _q !== void 0 ? _q : data.description_10) !== null && _r !== void 0 ? _r : data.description_9) !== null && _s !== void 0 ? _s : data.description_8) !== null && _t !== void 0 ? _t : data.description_7) !== null && _u !== void 0 ? _u : data.description_6) !== null && _v !== void 0 ? _v : data.description_5) !== null && _w !== void 0 ? _w : data.description_4) !== null && _x !== void 0 ? _x : data.description_3) !== null && _y !== void 0 ? _y : data.description_2) !== null && _z !== void 0 ? _z : data.description_1) !== null && _0 !== void 0 ? _0 : data.description_0) !== null && _1 !== void 0 ? _1 : data.description);
        var incidentPinProperties = {
            icon: "".concat(Incident.getSeverityColorName(data.magnitude), "-").concat(Incident.getIncidentTypeIconName(iconCategory)),
            incidentType: Incident.getIncidentTypeName(iconCategory, localizedStrings),
            description: description,
            // "length", "from", and "to" properties are currently not returned by
            // the incident tile response
            // length: data.length,
            // from: data.from,
            // to: data.to,
            delay: data.delay,
            color: Incident.getSeverityColorHexCode(data.magnitude),
            id: data.id
        };
        return _super.call(this, point, incidentPinProperties) || this;
    }
    Incident.getIncidentTypeName = function (incidentCategory, localizedStrings) {
        switch (incidentCategory) {
            case 0:
                return localizedStrings.Unknown;
            case 1:
                return localizedStrings.Accident;
            case 2:
                return localizedStrings.Fog;
            case 3:
                return localizedStrings.Danger;
            case 4:
                return localizedStrings.Rain;
            case 5:
                return localizedStrings.Ice;
            case 6:
                return localizedStrings.Jam;
            case 7:
                return localizedStrings.LaneClosed;
            case 8:
                return localizedStrings.RoadClosed;
            case 9:
                return localizedStrings.RoadWorks;
            case 10:
                return localizedStrings.Wind;
            case 11:
                return localizedStrings.Flood;
            case 12:
                return localizedStrings.Detour;
            default:
                return localizedStrings.Unknown;
        }
    };
    Incident.getIncidentTypeIconName = function (incidentCategory) {
        switch (incidentCategory) {
            case 0:
                return "unknown";
            case 1:
                return "accident";
            case 2:
                return "fog";
            case 3:
                return "danger";
            case 4:
                return "rain";
            case 5:
                return "ice";
            case 6:
                return "jam";
            case 7:
                return "lane-closed";
            case 8:
                return "road-closed";
            case 9:
                return "road-work";
            case 10:
                return "wind";
            case 11:
                return "flood";
            case 12:
                return "detour";
            default:
                return "unknown";
        }
    };
    Incident.getSeverityColorName = function (severity) {
        switch (severity) {
            case 0:
                return "grey";
            case 1:
                return "yellow";
            case 2:
                return "orange";
            case 3:
                return "red";
            case 4:
                return "grey";
            default:
                return "grey";
        }
    };
    Incident.getSeverityColorHexCode = function (severity) {
        switch (severity) {
            case 0:
                return "#B5B6B7";
            case 1:
                return "#F4C951";
            case 2:
                return "#F4873F";
            case 3:
                return "#F04F4E";
            case 4:
                return "#B5B6B7";
            default:
                return "#B5B6B7";
        }
    };
    return Incident;
}(Feature));

/**
 * @private
 */
var IncidentPopupIconName;
(function (IncidentPopupIconName) {
    IncidentPopupIconName["DELAY"] = "delay";
    IncidentPopupIconName["LENGTH"] = "length";
    IncidentPopupIconName["FROM"] = "from";
    IncidentPopupIconName["TO"] = "to";
})(IncidentPopupIconName || (IncidentPopupIconName = {}));
/**
 * @private
 */
var IncidentPopupFactory = /** @class */ (function () {
    function IncidentPopupFactory() {
    }
    IncidentPopupFactory.build = function (incident, languageCode) {
        if (languageCode === void 0) { languageCode = "en-US"; }
        var titleEl = document.createElement("div");
        titleEl.classList.add("incident-popup-title");
        titleEl.classList.add("font-segoeui-b");
        titleEl.innerText = incident.properties.incidentType;
        titleEl.setAttribute("aria-label", "Incident Type ".concat(incident.properties.incidentType));
        var subtitleEl = document.createElement("div");
        subtitleEl.classList.add("incident-popup-subtitle");
        subtitleEl.classList.add("font-segoeui-b");
        subtitleEl.setAttribute("aria-label", "Incident Description ".concat(incident.properties.description));
        subtitleEl.innerText = incident.properties.description;
        var headerEl = document.createElement("div");
        headerEl.classList.add("incident-popup-header");
        headerEl.style.backgroundColor = incident.properties.color;
        headerEl.appendChild(titleEl);
        headerEl.appendChild(subtitleEl);
        var bodyEl = document.createElement("div");
        bodyEl.classList.add("incident-popup-body");
        if (incident.properties.delay) {
            var delay = "".concat(Math.floor(incident.properties.delay / 60), " min");
            var delayInfoEl = this.createInfoSection(delay, IncidentPopupIconName.DELAY);
            bodyEl.appendChild(delayInfoEl);
        }
        if (incident.properties.length) {
            var i18nNumberFormat = new Intl.NumberFormat([languageCode, "en-US"], {
                maximumFractionDigits: 2
            });
            // If the language code is "en-US" it will always match this case
            // because Localizer controls the final language value.
            var i18nLength = void 0;
            if (languageCode === "en-US") {
                var lengthInMiles = convertDistance(incident.properties.length, "meters", "miles");
                i18nLength = "".concat(i18nNumberFormat.format(lengthInMiles), " miles");
            }
            else {
                var lengthInKm = convertDistance(incident.properties.length, "meters", "kilometers");
                i18nLength = "".concat(i18nNumberFormat.format(lengthInKm), " km");
            }
            var lengthInfoEl = this.createInfoSection(i18nLength, IncidentPopupIconName.LENGTH);
            bodyEl.appendChild(lengthInfoEl);
        }
        if (incident.properties.from) {
            var fromInfoEl = this.createInfoSection(incident.properties.from, IncidentPopupIconName.FROM);
            bodyEl.appendChild(fromInfoEl);
        }
        if (incident.properties.to) {
            var toInfoEl = this.createInfoSection(incident.properties.to, IncidentPopupIconName.TO);
            bodyEl.appendChild(toInfoEl);
        }
        var incidentPopupContentEl = document.createElement("div");
        incidentPopupContentEl.classList.add("incident-popup-content");
        incidentPopupContentEl.appendChild(headerEl);
        incidentPopupContentEl.appendChild(bodyEl);
        var incidentPopup = new Popup({
            content: incidentPopupContentEl,
            position: incident.geometry.coordinates
        });
        return incidentPopup;
    };
    IncidentPopupFactory.createInfoSection = function (message, iconName) {
        var infoSectionEl = document.createElement("div");
        infoSectionEl.classList.add("incident-popup-info");
        var iconEl = document.createElement("div");
        iconEl.classList.add("icon");
        iconEl.classList.add(iconName);
        var messageEl = document.createElement("span");
        messageEl.classList.add("message");
        messageEl.classList.add("font-segoeui");
        messageEl.setAttribute("aria-label", "Incident ".concat(iconName, " ").concat(message));
        messageEl.innerText = message;
        infoSectionEl.appendChild(iconEl);
        infoSectionEl.appendChild(messageEl);
        return infoSectionEl;
    };
    return IncidentPopupFactory;
}());

var __awaiter$4 = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$4 = (window && window.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * @private
 */
var IncidentServiceDelegate = /** @class */ (function () {
    function IncidentServiceDelegate(map) {
        var _this = this;
        this.incidentLayerName = "incidents";
        this.incidentSourceName = "mapcontrol_traffic_incident";
        this.addToMap = function () {
            if (!_this.map.sources.getById(_this.incidentSourceName)) {
                _this.map.sources.add(_this.vectorTileSource);
            }
            if (!_this.map.layers.getLayerById(_this.incidentLayerName)) {
                _this.map.layers.add(_this.incidentLayer, "labels");
            }
            //Create a popup but leave it closed so we can update it and display it later.
            _this.clickPopup = new Popup({
                position: [0, 0],
                pixelOffset: [0, -18]
            });
            _this.map.addEventListener("mouseover", _this.incidentLayerName, _this.cursorToPointer);
            _this.map.addEventListener("mouseleave", _this.incidentLayerName, _this.cursorToDefault);
            _this.map.addEventListener("click", _this.incidentLayerName, _this.openIncidentPopup);
            _this.map.events.addOnce('idle', _this.setAccessiblePopups);
            _this.map.events.add('moveend', _this.setAccessiblePopups);
        };
        this.accessiblePopups = [];
        this.setAccessiblePopups = function () { return __awaiter$4(_this, void 0, void 0, function () {
            var features, localizedStrings, createPopup, insertHiddenBefore, insertHiddenInFront, addHidden;
            var _this = this;
            return __generator$4(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.accessiblePopups.forEach(function (popup) { return popup.remove(); });
                        this.accessiblePopups = [];
                        features = this.map.layers.getRenderedShapes(this.map.getCamera().bounds, this.incidentLayer);
                        return [4 /*yield*/, this.map._getLocalizedStrings()];
                    case 1:
                        localizedStrings = _a.sent();
                        createPopup = function (features, idx) {
                            var incidentFeature = features[idx];
                            var incidentPosition = incidentFeature.geometry.coordinates;
                            var point = new Point(new Position(incidentPosition[0], incidentPosition[1]));
                            var incident = new Incident(incidentFeature.properties, point, localizedStrings);
                            var popup = IncidentPopupFactory.build(incident, _this.incidentLanguage);
                            var element = popup.getPopupContainer();
                            element.addEventListener('focusin', function (event) {
                                // side effects: clear other managed popups 
                                _this.clickPopup.remove();
                                _this.accessiblePopups.filter(function (p) { return p !== popup; }).forEach(function (popup) { return popup.remove(); });
                                // insert previous and next popups
                                if (idx - 1 >= 0) {
                                    insertHiddenBefore(popup, createPopup(features, idx - 1));
                                }
                                if (idx + 1 < features.length) {
                                    addHidden(createPopup(features, idx + 1));
                                }
                                // if we are on boundaries: add the first / last popup 
                                // to maintain popups on full page navigation cycle
                                if (idx >= 2 && idx == features.length - 1) {
                                    insertHiddenInFront(createPopup(features, 0));
                                }
                                if (idx == 0 && features.length >= 2) {
                                    addHidden(createPopup(features, features.length - 1));
                                }
                            });
                            if (idx == features.length - 1) {
                                element.addEventListener('focusout', function (event) {
                                    // close the popup if we detect the focus moving away from the page (relatedTarget === null)
                                    // (will remain open otherwise)
                                    if (event.relatedTarget === null) {
                                        popup.close();
                                    }
                                });
                            }
                            _this.accessiblePopups.push(popup);
                            return popup;
                        };
                        insertHiddenBefore = function (base, toInsert) {
                            toInsert.open(_this.map);
                            toInsert.close();
                            var containerToSwapIn = toInsert.getPopupContainer();
                            var baseContainer = base.getPopupContainer();
                            baseContainer.parentElement.insertBefore(containerToSwapIn, baseContainer);
                        };
                        insertHiddenInFront = function (toInsert) {
                            toInsert.open(_this.map);
                            toInsert.close();
                            var containerToSwapIn = toInsert.getPopupContainer();
                            var parent = containerToSwapIn.parentElement;
                            parent.insertBefore(containerToSwapIn, parent.firstElementChild);
                        };
                        addHidden = function (popup) {
                            popup.open(_this.map);
                            popup.close();
                        };
                        if (features.length > 0) {
                            addHidden(createPopup(features, 0));
                        }
                        if (features.length > 1) {
                            addHidden(createPopup(features, features.length - 1));
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        this.removeFromMap = function () {
            var _a;
            _this.map.removeEventListener("mouseover", _this.incidentLayerName, _this.cursorToPointer);
            _this.map.removeEventListener("mouseleave", _this.incidentLayerName, _this.cursorToDefault);
            _this.map.removeEventListener("click", _this.incidentLayerName, _this.openIncidentPopup);
            _this.map.events.remove('idle', _this.setAccessiblePopups);
            _this.map.events.remove('moveend', _this.setAccessiblePopups);
            _this.accessiblePopups.forEach(function (popup) { return popup.remove(); });
            _this.accessiblePopups = [];
            (_a = _this.clickPopup) === null || _a === void 0 ? void 0 : _a.remove();
            if (_this.map.layers.getLayerById(_this.incidentLayerName) != null) {
                _this.map.layers.remove(_this.incidentLayerName);
            }
            if (_this.map.sources.getById(_this.incidentSourceName) != null) {
                _this.map.sources.remove(_this.incidentSourceName);
            }
        };
        this.cursorToPointer = function (data) {
            _this.map.getCanvas().style.cursor = "pointer";
        };
        this.cursorToDefault = function (data) {
            _this.map.getCanvas().style.cursor = "";
        };
        this.openIncidentPopup = function (data) {
            _this.clickPopup.remove();
            _this.accessiblePopups.forEach(function (popup) { return popup.close(); });
            var incidentPosition = data.position;
            var incidentFeature = data.features[0];
            _this.map._getLocalizedStrings().then(function (localizedStrings) {
                var point = new Point(new Position(incidentPosition[0], incidentPosition[1]));
                var incident = new Incident(incidentFeature.properties, point, localizedStrings);
                _this.clickPopup = IncidentPopupFactory.build(incident, _this.incidentLanguage);
                _this.clickPopup.open(_this.map);
                var element = _this.clickPopup.getPopupContainer();
                // ensures popup is closed on tabbing when the focus is moved away from the window
                element.addEventListener('focusout', function (event) {
                    if (event.relatedTarget === null) {
                        _this.clickPopup.close();
                    }
                });
            });
        };
        this.map = map;
        this.vectorTileSource = new VectorTileSource(this.incidentSourceName, {
            maxZoom: 22,
            tiles: [
                "https://".concat(constants.domainPlaceHolder, "/traffic/incident/tile/pbf?api-version=1.0&zoom={z}&x={x}&y={y}"),
            ],
        });
        var imageExpression = this.getIncidentIconImageExpression();
        this.incidentLayer = new SymbolLayer(this.incidentSourceName, this.incidentLayerName, {
            sourceLayer: "Traffic incident POI",
            iconOptions: {
                ignorePlacement: true,
                allowOverlap: true,
                image: imageExpression,
                size: 0.75
            }
        });
    }
    IncidentServiceDelegate.prototype.getIncidentIconImageExpression = function () {
        // incident icon color expression
        var iconColorExpression = [
            "let", "magnitude", ["get", "magnitude"],
            [
                "case",
                ["==", ['var', 'magnitude'], 0],
                "grey",
                ["==", ['var', 'magnitude'], 1],
                "yellow",
                ["==", ['var', 'magnitude'], 2],
                "orange",
                ["==", ['var', 'magnitude'], 3],
                "red",
                ["==", ['var', 'magnitude'], 4],
                "grey",
                "grey", // default.
            ],
        ];
        // incident icon type name expression
        var incidentCategoryExpression = [
            "coalesce",
            ["get", "icon_category_12"],
            ["get", "icon_category_11"],
            ["get", "icon_category_10"],
            ["get", "icon_category_9"],
            ["get", "icon_category_8"],
            ["get", "icon_category_7"],
            ["get", "icon_category_6"],
            ["get", "icon_category_5"],
            ["get", "icon_category_4"],
            ["get", "icon_category_3"],
            ["get", "icon_category_2"],
            ["get", "icon_category_0"],
            ["get", "icon_category"],
            0
        ];
        var incidentTypeIconNameExpression = [
            "let", "category", incidentCategoryExpression,
            [
                "case",
                ["==", ["var", "category"], 0],
                "unknown",
                ["==", ["var", "category"], 1],
                "accident",
                ["==", ["var", "category"], 2],
                "fog",
                ["==", ["var", "category"], 3],
                "danger",
                ["==", ["var", "category"], 4],
                "rain",
                ["==", ["var", "category"], 5],
                "ice",
                ["==", ["var", "category"], 6],
                "jam",
                ["==", ["var", "category"], 7],
                "lane-closed",
                ["==", ["var", "category"], 8],
                "road-closed",
                ["==", ["var", "category"], 9],
                "road-work",
                ["==", ["var", "category"], 10],
                "wind",
                ["==", ["var", "category"], 11],
                "flood",
                ["==", ["var", "category"], 12],
                "detour",
                "unknown"
            ]
        ];
        var incidentIconNameExpression = [
            "concat", iconColorExpression, "-", incidentTypeIconNameExpression
        ];
        return incidentIconNameExpression;
    };
    return IncidentServiceDelegate;
}());

var __extends$h = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for enabling/disabling user interaction with the map.
 */
var UserInteractionOptions = /** @class */ (function (_super) {
    __extends$h(UserInteractionOptions, _super);
    function UserInteractionOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Whether the map is interactive or static. If false, all user interaction is disabled.  If true, only selected
         * user interactions will enabled.
         * default `true`
         * @default true
         */
        _this.interactive = true;
        /**
         * Whether the map should zoom on scroll input.
         * default `true`
         * @default true
         */
        _this.scrollZoomInteraction = true;
        /**
         * Whether the Shift + left click and drag will draw a zoom box.
         * default `true`
         * @default true
         */
        _this.boxZoomInteraction = true;
        /**
         * Whether right click and drag will rotate and pitch the map.
         * default `true`
         * @default true
         */
        _this.dragRotateInteraction = true;
        /**
         * Whether left click and drag will pan the map.
         * default `true`
         * @default true
         */
        _this.dragPanInteraction = true;
        /**
         * Whether the keyboard interactions are enabled.
         * <style> .k-key { border: 1px solid grey; border-radius: 6px; background-color: #ccc; line-height: 14px;
         * font-size: 14px; padding: 2px; } </style>
         * <p><span class="k-key">Escape</span>: Jump focus to the map.</p>
         * <p><span class="k-key">+/=</span>: Increase zoom level by 1.</p>
         * <p><span class="k-key">Shift</span> + <span class="k-key">+/=</span>: Increase the zoom level by 2.</p>
         * <p><span class="k-key">-</span>: Decrease zoom level by 1.</p>
         * <p><span class="k-key">Shift</span> + <span class="k-key">-</span>: Decrease zoom level by 2.</p>
         * <p><span class="k-key">⇢</span>: Pan right 100 pixels.</p>
         * <p><span class="k-key">⇠</span>: Pan left 100 pixels.</p>
         * <p><span class="k-key">⇡</span>: Pan up 100 pixels.</p>
         * <p><span class="k-key">⇣</span>: Pan down 100 pixels.</p>
         * <p><span class="k-key">Shift</span> + <span class="k-key">⇢</span>: Rotate 15 degrees clockwise.</p>
         * <p><span class="k-key">Shift</span> + <span class="k-key">⇠</span>: Rotate 15 degrees counter-clockwise.</p>
         * <p><span class="k-key">Shift</span> + <span class="k-key">⇡</span>: Increase pitch by 10 degrees.</p>
         * <p><span class="k-key">Shift</span> + <span class="k-key">⇣</span>: Decrease pitch by 10 degrees.</p>
         * default `true`
         * @default true
         */
        _this.keyboardInteraction = true;
        /**
         * Whether double left click will zoom the map inwards.
         * default `true`
         * @default true
         */
        _this.dblClickZoomInteraction = true;
        /**
         * Whether touch interactions are enabled for touch devices.
         * default `true`
         * @default true
         */
        _this.touchInteraction = true;
        /**
         * Whether touch rotation is enabled for touch devices. This option is not applied if touchInteraction is disabled.
         * default `true`
         * @default true
         */
        _this.touchRotate = true;
        /**
         * Sets the zoom rate of the mouse wheel
         * default `1/450`
         * @default 1/450
         */
        _this.wheelZoomRate = 1 / 450;
        return _this;
    }
    return UserInteractionOptions;
}(Options));

/** A handler that adds a shortcut for jumping focus to the top map div. */
var FocusShortcutHandler = /** @class */ (function () {
    function FocusShortcutHandler(map) {
        var _this = this;
        /** A listener for the shortcut */
        this._onKeyDown = function (event) {
            if (event.keyCode === 27 /* Escape */) {
                _this.map.getCanvas().focus();
            }
        };
        this.map = map;
    }
    /** Enables the mobile pitch gesture support. */
    FocusShortcutHandler.prototype.enable = function () {
        this.map.getMapContainer().addEventListener("keydown", this._onKeyDown);
    };
    /** Disables the mobile pitch gesture support. */
    FocusShortcutHandler.prototype.disable = function () {
        this.map.getMapContainer().removeEventListener("keydown", this._onKeyDown);
    };
    return FocusShortcutHandler;
}());

/** A handler that adds support for pinch and zoom gestures on devices without touch events. */
var PinchZoomHandler = /** @class */ (function () {
    function PinchZoomHandler(map) {
        var _this = this;
        this._onGestureStart = function (e) {
            if (!_this.hasTouch) {
                e.preventDefault();
                _this.initZoom = _this.map.getCamera().zoom;
            }
        };
        this._onGestureChange = function (e) {
            if (!_this.hasTouch) {
                e.preventDefault();
                _this.map.setCamera({ zoom: _this.initZoom + e.scale - 1 });
            }
        };
        this._onTouchStart = function (e) {
            _this.hasTouch = true;
        };
        this._onTouchEnd = function (e) {
            if (e.touches.length === 0) {
                _this.hasTouch = false;
            }
        };
        this.map = map;
    }
    /** Enables the mobile pitch gesture support. */
    PinchZoomHandler.prototype.enable = function () {
        this.map.getCanvasContainer().addEventListener("gesturestart", this._onGestureStart);
        this.map.getCanvasContainer().addEventListener("gesturechange", this._onGestureChange);
        this.map.getCanvasContainer().addEventListener("touchstart", this._onTouchStart);
        this.map.getCanvasContainer().addEventListener("touchend", this._onTouchEnd);
    };
    /** Disables the mobile pitch gesture support. */
    PinchZoomHandler.prototype.disable = function () {
        this.map.getCanvasContainer().removeEventListener("gesturestart", this._onGestureStart);
        this.map.getCanvasContainer().removeEventListener("gesturechange", this._onGestureChange);
        this.map.getCanvasContainer().removeEventListener("touchstart", this._onTouchStart);
        this.map.getCanvasContainer().removeEventListener("touchend", this._onTouchEnd);
    };
    return PinchZoomHandler;
}());

/**
 * @private
 */
var UserInteractionDelegate = /** @class */ (function () {
    function UserInteractionDelegate(map, options) {
        this.added = false;
        this.map = map;
        this.focusShortcut = new FocusShortcutHandler(map);
        this.pinchZoom = new PinchZoomHandler(map);
        this.options = new UserInteractionOptions().merge(options);
    }
    UserInteractionDelegate.prototype.addToMap = function () {
        if (!this.added) {
            this.added = true;
            this._setInteractions(this.options);
        }
    };
    UserInteractionDelegate.prototype.removeFromMap = function () {
        if (this.added) {
            this.added = false;
            this._setInteractions({ interactive: false });
        }
    };
    /**
     * Set the map control's user interaction handlers. Any options not specified will default to their current values.
     * @param options The options for enabling/disabling the user interaction handlers.
     */
    UserInteractionDelegate.prototype.setOptions = function (options) {
        this.options = new UserInteractionOptions().merge(this.options, options);
        // Only need to actually update things if the delegate has already been added to the map
        if (this.added) {
            this._setInteractions(this.options);
        }
    };
    /**
     * Return the map control's current user interaction handler settings.
     */
    UserInteractionDelegate.prototype.getOptions = function () {
        return Object.assign({}, this.options);
    };
    /** Sets the interaction config based on the specified options. */
    UserInteractionDelegate.prototype._setInteractions = function (options) {
        if (!options.interactive) {
            // Disable everything
            this.map._getMap().boxZoom.disable();
            this.map._getMap().doubleClickZoom.disable();
            this.map._getMap().dragPan.disable();
            this.map._getMap().dragRotate.disable();
            this.map._getMap().keyboard.disable();
            this.focusShortcut.disable();
            this.map._getMap().scrollZoom.disable();
            this.map._getMap().touchZoomRotate.disable();
            this.pinchZoom.disable();
        }
        else {
            // Box Zoom
            if (options.boxZoomInteraction) {
                this.map._getMap().boxZoom.enable();
            }
            else {
                this.map._getMap().boxZoom.disable();
            }
            // Double Click Zoom
            if (options.dblClickZoomInteraction) {
                this.map._getMap().doubleClickZoom.enable();
            }
            else {
                this.map._getMap().doubleClickZoom.disable();
            }
            // Drag Pan
            if (options.dragPanInteraction) {
                this.map._getMap().dragPan.enable();
            }
            else {
                this.map._getMap().dragPan.disable();
            }
            // Drag Rotate
            if (options.dragRotateInteraction) {
                this.map._getMap().dragRotate.enable();
            }
            else {
                this.map._getMap().dragRotate.disable();
            }
            // Keyboard
            if (options.keyboardInteraction) {
                this.map._getMap().keyboard.enable();
                this.focusShortcut.enable();
            }
            else {
                this.map._getMap().keyboard.disable();
                this.focusShortcut.disable();
            }
            // Scroll Zoom
            if (options.scrollZoomInteraction) {
                this.map._getMap().scrollZoom.enable();
                this.map._getMap().scrollZoom.setWheelZoomRate(options.wheelZoomRate);
            }
            else {
                this.map._getMap().scrollZoom.disable();
            }
            // Touch
            var touchZoomRotate = this.map._getMap().touchZoomRotate;
            if (options.touchInteraction) {
                touchZoomRotate.enable();
                if (options.touchRotate) {
                    touchZoomRotate.enableRotation();
                }
                else {
                    touchZoomRotate.disableRotation();
                }
                this.pinchZoom.enable();
            }
            else {
                touchZoomRotate.disable();
                this.pinchZoom.enable();
            }
        }
    };
    return UserInteractionDelegate;
}());

/**
 * @module helpers
 */
/**
 * Earth Radius used with the Harvesine formula and approximates using a spherical (non-ellipsoid) Earth.
 *
 * @memberof helpers
 * @type {number}
 */
/**
 * Wraps a GeoJSON {@link Geometry} in a GeoJSON {@link Feature}.
 *
 * @name feature
 * @param {Geometry} geometry input geometry
 * @param {Object} [properties={}] an Object of key-value pairs to add as properties
 * @param {Object} [options={}] Optional Parameters
 * @param {Array<number>} [options.bbox] Bounding Box Array [west, south, east, north] associated with the Feature
 * @param {string|number} [options.id] Identifier associated with the Feature
 * @returns {Feature} a GeoJSON Feature
 * @example
 * var geometry = {
 *   "type": "Point",
 *   "coordinates": [110, 50]
 * };
 *
 * var feature = turf.feature(geometry);
 *
 * //=feature
 */
function feature(geom, properties, options) {
    if (options === void 0) { options = {}; }
    var feat = { type: "Feature" };
    if (options.id === 0 || options.id) {
        feat.id = options.id;
    }
    if (options.bbox) {
        feat.bbox = options.bbox;
    }
    feat.properties = properties || {};
    feat.geometry = geom;
    return feat;
}
/**
 * Creates a {@link Polygon} {@link Feature} from an Array of LinearRings.
 *
 * @name polygon
 * @param {Array<Array<Array<number>>>} coordinates an array of LinearRings
 * @param {Object} [properties={}] an Object of key-value pairs to add as properties
 * @param {Object} [options={}] Optional Parameters
 * @param {Array<number>} [options.bbox] Bounding Box Array [west, south, east, north] associated with the Feature
 * @param {string|number} [options.id] Identifier associated with the Feature
 * @returns {Feature<Polygon>} Polygon Feature
 * @example
 * var polygon = turf.polygon([[[-5, 52], [-4, 56], [-2, 51], [-7, 54], [-5, 52]]], { name: 'poly1' });
 *
 * //=polygon
 */
function polygon(coordinates, properties, options) {
    if (options === void 0) { options = {}; }
    for (var _i = 0, coordinates_1 = coordinates; _i < coordinates_1.length; _i++) {
        var ring = coordinates_1[_i];
        if (ring.length < 4) {
            throw new Error("Each LinearRing of a Polygon must have 4 or more Positions.");
        }
        for (var j = 0; j < ring[ring.length - 1].length; j++) {
            // Check if first point of Polygon contains two numbers
            if (ring[ring.length - 1][j] !== ring[0][j]) {
                throw new Error("First and last Position are not equivalent.");
            }
        }
    }
    var geom = {
        type: "Polygon",
        coordinates: coordinates,
    };
    return feature(geom, properties, options);
}
/**
 * Creates a {@link Feature<MultiPolygon>} based on a
 * coordinate array. Properties can be added optionally.
 *
 * @name multiPolygon
 * @param {Array<Array<Array<Array<number>>>>} coordinates an array of Polygons
 * @param {Object} [properties={}] an Object of key-value pairs to add as properties
 * @param {Object} [options={}] Optional Parameters
 * @param {Array<number>} [options.bbox] Bounding Box Array [west, south, east, north] associated with the Feature
 * @param {string|number} [options.id] Identifier associated with the Feature
 * @returns {Feature<MultiPolygon>} a multipolygon feature
 * @throws {Error} if no coordinates are passed
 * @example
 * var multiPoly = turf.multiPolygon([[[[0,0],[0,10],[10,10],[10,0],[0,0]]]]);
 *
 * //=multiPoly
 *
 */
function multiPolygon(coordinates, properties, options) {
    if (options === void 0) { options = {}; }
    var geom = {
        type: "MultiPolygon",
        coordinates: coordinates,
    };
    return feature(geom, properties, options);
}

/**
 * Get Geometry from Feature or Geometry Object
 *
 * @param {Feature|Geometry} geojson GeoJSON Feature or Geometry Object
 * @returns {Geometry|null} GeoJSON Geometry Object
 * @throws {Error} if geojson is not a Feature or Geometry Object
 * @example
 * var point = {
 *   "type": "Feature",
 *   "properties": {},
 *   "geometry": {
 *     "type": "Point",
 *     "coordinates": [110, 40]
 *   }
 * }
 * var geom = turf.getGeom(point)
 * //={"type": "Point", "coordinates": [110, 40]}
 */
function getGeom(geojson) {
    if (geojson.type === "Feature") {
        return geojson.geometry;
    }
    return geojson;
}

var polygonClipping_umd = {exports: {}};

(function (module, exports) {
	(function (global, factory) {
	  module.exports = factory() ;
	}(commonjsGlobal, (function () {
	  function _classCallCheck(instance, Constructor) {
	    if (!(instance instanceof Constructor)) {
	      throw new TypeError("Cannot call a class as a function");
	    }
	  }

	  function _defineProperties(target, props) {
	    for (var i = 0; i < props.length; i++) {
	      var descriptor = props[i];
	      descriptor.enumerable = descriptor.enumerable || false;
	      descriptor.configurable = true;
	      if ("value" in descriptor) descriptor.writable = true;
	      Object.defineProperty(target, descriptor.key, descriptor);
	    }
	  }

	  function _createClass(Constructor, protoProps, staticProps) {
	    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
	    if (staticProps) _defineProperties(Constructor, staticProps);
	    return Constructor;
	  }

	  /**
	   * splaytree v3.1.0
	   * Fast Splay tree for Node and browser
	   *
	   * @author Alexander Milevski <info@w8r.name>
	   * @license MIT
	   * @preserve
	   */
	  var Node =
	  /** @class */
	  function () {
	    function Node(key, data) {
	      this.next = null;
	      this.key = key;
	      this.data = data;
	      this.left = null;
	      this.right = null;
	    }

	    return Node;
	  }();
	  /* follows "An implementation of top-down splaying"
	   * by D. Sleator <sleator@cs.cmu.edu> March 1992
	   */


	  function DEFAULT_COMPARE(a, b) {
	    return a > b ? 1 : a < b ? -1 : 0;
	  }
	  /**
	   * Simple top down splay, not requiring i to be in the tree t.
	   */


	  function splay(i, t, comparator) {
	    var N = new Node(null, null);
	    var l = N;
	    var r = N;

	    while (true) {
	      var cmp = comparator(i, t.key); //if (i < t.key) {

	      if (cmp < 0) {
	        if (t.left === null) break; //if (i < t.left.key) {

	        if (comparator(i, t.left.key) < 0) {
	          var y = t.left;
	          /* rotate right */

	          t.left = y.right;
	          y.right = t;
	          t = y;
	          if (t.left === null) break;
	        }

	        r.left = t;
	        /* link right */

	        r = t;
	        t = t.left; //} else if (i > t.key) {
	      } else if (cmp > 0) {
	        if (t.right === null) break; //if (i > t.right.key) {

	        if (comparator(i, t.right.key) > 0) {
	          var y = t.right;
	          /* rotate left */

	          t.right = y.left;
	          y.left = t;
	          t = y;
	          if (t.right === null) break;
	        }

	        l.right = t;
	        /* link left */

	        l = t;
	        t = t.right;
	      } else break;
	    }
	    /* assemble */


	    l.right = t.left;
	    r.left = t.right;
	    t.left = N.right;
	    t.right = N.left;
	    return t;
	  }

	  function insert(i, data, t, comparator) {
	    var node = new Node(i, data);

	    if (t === null) {
	      node.left = node.right = null;
	      return node;
	    }

	    t = splay(i, t, comparator);
	    var cmp = comparator(i, t.key);

	    if (cmp < 0) {
	      node.left = t.left;
	      node.right = t;
	      t.left = null;
	    } else if (cmp >= 0) {
	      node.right = t.right;
	      node.left = t;
	      t.right = null;
	    }

	    return node;
	  }

	  function split(key, v, comparator) {
	    var left = null;
	    var right = null;

	    if (v) {
	      v = splay(key, v, comparator);
	      var cmp = comparator(v.key, key);

	      if (cmp === 0) {
	        left = v.left;
	        right = v.right;
	      } else if (cmp < 0) {
	        right = v.right;
	        v.right = null;
	        left = v;
	      } else {
	        left = v.left;
	        v.left = null;
	        right = v;
	      }
	    }

	    return {
	      left: left,
	      right: right
	    };
	  }

	  function merge(left, right, comparator) {
	    if (right === null) return left;
	    if (left === null) return right;
	    right = splay(left.key, right, comparator);
	    right.left = left;
	    return right;
	  }
	  /**
	   * Prints level of the tree
	   */


	  function printRow(root, prefix, isTail, out, printNode) {
	    if (root) {
	      out("" + prefix + (isTail ? '└── ' : '├── ') + printNode(root) + "\n");
	      var indent = prefix + (isTail ? '    ' : '│   ');
	      if (root.left) printRow(root.left, indent, false, out, printNode);
	      if (root.right) printRow(root.right, indent, true, out, printNode);
	    }
	  }

	  var Tree =
	  /** @class */
	  function () {
	    function Tree(comparator) {
	      if (comparator === void 0) {
	        comparator = DEFAULT_COMPARE;
	      }

	      this._root = null;
	      this._size = 0;
	      this._comparator = comparator;
	    }
	    /**
	     * Inserts a key, allows duplicates
	     */


	    Tree.prototype.insert = function (key, data) {
	      this._size++;
	      return this._root = insert(key, data, this._root, this._comparator);
	    };
	    /**
	     * Adds a key, if it is not present in the tree
	     */


	    Tree.prototype.add = function (key, data) {
	      var node = new Node(key, data);

	      if (this._root === null) {
	        node.left = node.right = null;
	        this._size++;
	        this._root = node;
	      }

	      var comparator = this._comparator;
	      var t = splay(key, this._root, comparator);
	      var cmp = comparator(key, t.key);
	      if (cmp === 0) this._root = t;else {
	        if (cmp < 0) {
	          node.left = t.left;
	          node.right = t;
	          t.left = null;
	        } else if (cmp > 0) {
	          node.right = t.right;
	          node.left = t;
	          t.right = null;
	        }

	        this._size++;
	        this._root = node;
	      }
	      return this._root;
	    };
	    /**
	     * @param  {Key} key
	     * @return {Node|null}
	     */


	    Tree.prototype.remove = function (key) {
	      this._root = this._remove(key, this._root, this._comparator);
	    };
	    /**
	     * Deletes i from the tree if it's there
	     */


	    Tree.prototype._remove = function (i, t, comparator) {
	      var x;
	      if (t === null) return null;
	      t = splay(i, t, comparator);
	      var cmp = comparator(i, t.key);

	      if (cmp === 0) {
	        /* found it */
	        if (t.left === null) {
	          x = t.right;
	        } else {
	          x = splay(i, t.left, comparator);
	          x.right = t.right;
	        }

	        this._size--;
	        return x;
	      }

	      return t;
	      /* It wasn't there */
	    };
	    /**
	     * Removes and returns the node with smallest key
	     */


	    Tree.prototype.pop = function () {
	      var node = this._root;

	      if (node) {
	        while (node.left) {
	          node = node.left;
	        }

	        this._root = splay(node.key, this._root, this._comparator);
	        this._root = this._remove(node.key, this._root, this._comparator);
	        return {
	          key: node.key,
	          data: node.data
	        };
	      }

	      return null;
	    };
	    /**
	     * Find without splaying
	     */


	    Tree.prototype.findStatic = function (key) {
	      var current = this._root;
	      var compare = this._comparator;

	      while (current) {
	        var cmp = compare(key, current.key);
	        if (cmp === 0) return current;else if (cmp < 0) current = current.left;else current = current.right;
	      }

	      return null;
	    };

	    Tree.prototype.find = function (key) {
	      if (this._root) {
	        this._root = splay(key, this._root, this._comparator);
	        if (this._comparator(key, this._root.key) !== 0) return null;
	      }

	      return this._root;
	    };

	    Tree.prototype.contains = function (key) {
	      var current = this._root;
	      var compare = this._comparator;

	      while (current) {
	        var cmp = compare(key, current.key);
	        if (cmp === 0) return true;else if (cmp < 0) current = current.left;else current = current.right;
	      }

	      return false;
	    };

	    Tree.prototype.forEach = function (visitor, ctx) {
	      var current = this._root;
	      var Q = [];
	      /* Initialize stack s */

	      var done = false;

	      while (!done) {
	        if (current !== null) {
	          Q.push(current);
	          current = current.left;
	        } else {
	          if (Q.length !== 0) {
	            current = Q.pop();
	            visitor.call(ctx, current);
	            current = current.right;
	          } else done = true;
	        }
	      }

	      return this;
	    };
	    /**
	     * Walk key range from `low` to `high`. Stops if `fn` returns a value.
	     */


	    Tree.prototype.range = function (low, high, fn, ctx) {
	      var Q = [];
	      var compare = this._comparator;
	      var node = this._root;
	      var cmp;

	      while (Q.length !== 0 || node) {
	        if (node) {
	          Q.push(node);
	          node = node.left;
	        } else {
	          node = Q.pop();
	          cmp = compare(node.key, high);

	          if (cmp > 0) {
	            break;
	          } else if (compare(node.key, low) >= 0) {
	            if (fn.call(ctx, node)) return this; // stop if smth is returned
	          }

	          node = node.right;
	        }
	      }

	      return this;
	    };
	    /**
	     * Returns array of keys
	     */


	    Tree.prototype.keys = function () {
	      var keys = [];
	      this.forEach(function (_a) {
	        var key = _a.key;
	        return keys.push(key);
	      });
	      return keys;
	    };
	    /**
	     * Returns array of all the data in the nodes
	     */


	    Tree.prototype.values = function () {
	      var values = [];
	      this.forEach(function (_a) {
	        var data = _a.data;
	        return values.push(data);
	      });
	      return values;
	    };

	    Tree.prototype.min = function () {
	      if (this._root) return this.minNode(this._root).key;
	      return null;
	    };

	    Tree.prototype.max = function () {
	      if (this._root) return this.maxNode(this._root).key;
	      return null;
	    };

	    Tree.prototype.minNode = function (t) {
	      if (t === void 0) {
	        t = this._root;
	      }

	      if (t) while (t.left) {
	        t = t.left;
	      }
	      return t;
	    };

	    Tree.prototype.maxNode = function (t) {
	      if (t === void 0) {
	        t = this._root;
	      }

	      if (t) while (t.right) {
	        t = t.right;
	      }
	      return t;
	    };
	    /**
	     * Returns node at given index
	     */


	    Tree.prototype.at = function (index) {
	      var current = this._root;
	      var done = false;
	      var i = 0;
	      var Q = [];

	      while (!done) {
	        if (current) {
	          Q.push(current);
	          current = current.left;
	        } else {
	          if (Q.length > 0) {
	            current = Q.pop();
	            if (i === index) return current;
	            i++;
	            current = current.right;
	          } else done = true;
	        }
	      }

	      return null;
	    };

	    Tree.prototype.next = function (d) {
	      var root = this._root;
	      var successor = null;

	      if (d.right) {
	        successor = d.right;

	        while (successor.left) {
	          successor = successor.left;
	        }

	        return successor;
	      }

	      var comparator = this._comparator;

	      while (root) {
	        var cmp = comparator(d.key, root.key);
	        if (cmp === 0) break;else if (cmp < 0) {
	          successor = root;
	          root = root.left;
	        } else root = root.right;
	      }

	      return successor;
	    };

	    Tree.prototype.prev = function (d) {
	      var root = this._root;
	      var predecessor = null;

	      if (d.left !== null) {
	        predecessor = d.left;

	        while (predecessor.right) {
	          predecessor = predecessor.right;
	        }

	        return predecessor;
	      }

	      var comparator = this._comparator;

	      while (root) {
	        var cmp = comparator(d.key, root.key);
	        if (cmp === 0) break;else if (cmp < 0) root = root.left;else {
	          predecessor = root;
	          root = root.right;
	        }
	      }

	      return predecessor;
	    };

	    Tree.prototype.clear = function () {
	      this._root = null;
	      this._size = 0;
	      return this;
	    };

	    Tree.prototype.toList = function () {
	      return toList(this._root);
	    };
	    /**
	     * Bulk-load items. Both array have to be same size
	     */


	    Tree.prototype.load = function (keys, values, presort) {
	      if (values === void 0) {
	        values = [];
	      }

	      if (presort === void 0) {
	        presort = false;
	      }

	      var size = keys.length;
	      var comparator = this._comparator; // sort if needed

	      if (presort) sort(keys, values, 0, size - 1, comparator);

	      if (this._root === null) {
	        // empty tree
	        this._root = loadRecursive(keys, values, 0, size);
	        this._size = size;
	      } else {
	        // that re-builds the whole tree from two in-order traversals
	        var mergedList = mergeLists(this.toList(), createList(keys, values), comparator);
	        size = this._size + size;
	        this._root = sortedListToBST({
	          head: mergedList
	        }, 0, size);
	      }

	      return this;
	    };

	    Tree.prototype.isEmpty = function () {
	      return this._root === null;
	    };

	    Object.defineProperty(Tree.prototype, "size", {
	      get: function get() {
	        return this._size;
	      },
	      enumerable: true,
	      configurable: true
	    });
	    Object.defineProperty(Tree.prototype, "root", {
	      get: function get() {
	        return this._root;
	      },
	      enumerable: true,
	      configurable: true
	    });

	    Tree.prototype.toString = function (printNode) {
	      if (printNode === void 0) {
	        printNode = function printNode(n) {
	          return String(n.key);
	        };
	      }

	      var out = [];
	      printRow(this._root, '', true, function (v) {
	        return out.push(v);
	      }, printNode);
	      return out.join('');
	    };

	    Tree.prototype.update = function (key, newKey, newData) {
	      var comparator = this._comparator;

	      var _a = split(key, this._root, comparator),
	          left = _a.left,
	          right = _a.right;

	      if (comparator(key, newKey) < 0) {
	        right = insert(newKey, newData, right, comparator);
	      } else {
	        left = insert(newKey, newData, left, comparator);
	      }

	      this._root = merge(left, right, comparator);
	    };

	    Tree.prototype.split = function (key) {
	      return split(key, this._root, this._comparator);
	    };

	    return Tree;
	  }();

	  function loadRecursive(keys, values, start, end) {
	    var size = end - start;

	    if (size > 0) {
	      var middle = start + Math.floor(size / 2);
	      var key = keys[middle];
	      var data = values[middle];
	      var node = new Node(key, data);
	      node.left = loadRecursive(keys, values, start, middle);
	      node.right = loadRecursive(keys, values, middle + 1, end);
	      return node;
	    }

	    return null;
	  }

	  function createList(keys, values) {
	    var head = new Node(null, null);
	    var p = head;

	    for (var i = 0; i < keys.length; i++) {
	      p = p.next = new Node(keys[i], values[i]);
	    }

	    p.next = null;
	    return head.next;
	  }

	  function toList(root) {
	    var current = root;
	    var Q = [];
	    var done = false;
	    var head = new Node(null, null);
	    var p = head;

	    while (!done) {
	      if (current) {
	        Q.push(current);
	        current = current.left;
	      } else {
	        if (Q.length > 0) {
	          current = p = p.next = Q.pop();
	          current = current.right;
	        } else done = true;
	      }
	    }

	    p.next = null; // that'll work even if the tree was empty

	    return head.next;
	  }

	  function sortedListToBST(list, start, end) {
	    var size = end - start;

	    if (size > 0) {
	      var middle = start + Math.floor(size / 2);
	      var left = sortedListToBST(list, start, middle);
	      var root = list.head;
	      root.left = left;
	      list.head = list.head.next;
	      root.right = sortedListToBST(list, middle + 1, end);
	      return root;
	    }

	    return null;
	  }

	  function mergeLists(l1, l2, compare) {
	    var head = new Node(null, null); // dummy

	    var p = head;
	    var p1 = l1;
	    var p2 = l2;

	    while (p1 !== null && p2 !== null) {
	      if (compare(p1.key, p2.key) < 0) {
	        p.next = p1;
	        p1 = p1.next;
	      } else {
	        p.next = p2;
	        p2 = p2.next;
	      }

	      p = p.next;
	    }

	    if (p1 !== null) {
	      p.next = p1;
	    } else if (p2 !== null) {
	      p.next = p2;
	    }

	    return head.next;
	  }

	  function sort(keys, values, left, right, compare) {
	    if (left >= right) return;
	    var pivot = keys[left + right >> 1];
	    var i = left - 1;
	    var j = right + 1;

	    while (true) {
	      do {
	        i++;
	      } while (compare(keys[i], pivot) < 0);

	      do {
	        j--;
	      } while (compare(keys[j], pivot) > 0);

	      if (i >= j) break;
	      var tmp = keys[i];
	      keys[i] = keys[j];
	      keys[j] = tmp;
	      tmp = values[i];
	      values[i] = values[j];
	      values[j] = tmp;
	    }

	    sort(keys, values, left, j, compare);
	    sort(keys, values, j + 1, right, compare);
	  }

	  /**
	   * A bounding box has the format:
	   *
	   *  { ll: { x: xmin, y: ymin }, ur: { x: xmax, y: ymax } }
	   *
	   */
	  var isInBbox = function isInBbox(bbox, point) {
	    return bbox.ll.x <= point.x && point.x <= bbox.ur.x && bbox.ll.y <= point.y && point.y <= bbox.ur.y;
	  };
	  /* Returns either null, or a bbox (aka an ordered pair of points)
	   * If there is only one point of overlap, a bbox with identical points
	   * will be returned */

	  var getBboxOverlap = function getBboxOverlap(b1, b2) {
	    // check if the bboxes overlap at all
	    if (b2.ur.x < b1.ll.x || b1.ur.x < b2.ll.x || b2.ur.y < b1.ll.y || b1.ur.y < b2.ll.y) return null; // find the middle two X values

	    var lowerX = b1.ll.x < b2.ll.x ? b2.ll.x : b1.ll.x;
	    var upperX = b1.ur.x < b2.ur.x ? b1.ur.x : b2.ur.x; // find the middle two Y values

	    var lowerY = b1.ll.y < b2.ll.y ? b2.ll.y : b1.ll.y;
	    var upperY = b1.ur.y < b2.ur.y ? b1.ur.y : b2.ur.y; // put those middle values together to get the overlap

	    return {
	      ll: {
	        x: lowerX,
	        y: lowerY
	      },
	      ur: {
	        x: upperX,
	        y: upperY
	      }
	    };
	  };

	  /* Javascript doesn't do integer math. Everything is
	   * floating point with percision Number.EPSILON.
	   *
	   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/EPSILON
	   */
	  var epsilon = Number.EPSILON; // IE Polyfill

	  if (epsilon === undefined) epsilon = Math.pow(2, -52);
	  var EPSILON_SQ = epsilon * epsilon;
	  /* FLP comparator */

	  var cmp = function cmp(a, b) {
	    // check if they're both 0
	    if (-epsilon < a && a < epsilon) {
	      if (-epsilon < b && b < epsilon) {
	        return 0;
	      }
	    } // check if they're flp equal


	    var ab = a - b;

	    if (ab * ab < EPSILON_SQ * a * b) {
	      return 0;
	    } // normal comparison


	    return a < b ? -1 : 1;
	  };

	  /**
	   * This class rounds incoming values sufficiently so that
	   * floating points problems are, for the most part, avoided.
	   *
	   * Incoming points are have their x & y values tested against
	   * all previously seen x & y values. If either is 'too close'
	   * to a previously seen value, it's value is 'snapped' to the
	   * previously seen value.
	   *
	   * All points should be rounded by this class before being
	   * stored in any data structures in the rest of this algorithm.
	   */

	  var PtRounder = /*#__PURE__*/function () {
	    function PtRounder() {
	      _classCallCheck(this, PtRounder);

	      this.reset();
	    }

	    _createClass(PtRounder, [{
	      key: "reset",
	      value: function reset() {
	        this.xRounder = new CoordRounder();
	        this.yRounder = new CoordRounder();
	      }
	    }, {
	      key: "round",
	      value: function round(x, y) {
	        return {
	          x: this.xRounder.round(x),
	          y: this.yRounder.round(y)
	        };
	      }
	    }]);

	    return PtRounder;
	  }();

	  var CoordRounder = /*#__PURE__*/function () {
	    function CoordRounder() {
	      _classCallCheck(this, CoordRounder);

	      this.tree = new Tree(); // preseed with 0 so we don't end up with values < Number.EPSILON

	      this.round(0);
	    } // Note: this can rounds input values backwards or forwards.
	    //       You might ask, why not restrict this to just rounding
	    //       forwards? Wouldn't that allow left endpoints to always
	    //       remain left endpoints during splitting (never change to
	    //       right). No - it wouldn't, because we snap intersections
	    //       to endpoints (to establish independence from the segment
	    //       angle for t-intersections).


	    _createClass(CoordRounder, [{
	      key: "round",
	      value: function round(coord) {
	        var node = this.tree.add(coord);
	        var prevNode = this.tree.prev(node);

	        if (prevNode !== null && cmp(node.key, prevNode.key) === 0) {
	          this.tree.remove(coord);
	          return prevNode.key;
	        }

	        var nextNode = this.tree.next(node);

	        if (nextNode !== null && cmp(node.key, nextNode.key) === 0) {
	          this.tree.remove(coord);
	          return nextNode.key;
	        }

	        return coord;
	      }
	    }]);

	    return CoordRounder;
	  }(); // singleton available by import


	  var rounder = new PtRounder();

	  /* Cross Product of two vectors with first point at origin */

	  var crossProduct = function crossProduct(a, b) {
	    return a.x * b.y - a.y * b.x;
	  };
	  /* Dot Product of two vectors with first point at origin */

	  var dotProduct = function dotProduct(a, b) {
	    return a.x * b.x + a.y * b.y;
	  };
	  /* Comparator for two vectors with same starting point */

	  var compareVectorAngles = function compareVectorAngles(basePt, endPt1, endPt2) {
	    var v1 = {
	      x: endPt1.x - basePt.x,
	      y: endPt1.y - basePt.y
	    };
	    var v2 = {
	      x: endPt2.x - basePt.x,
	      y: endPt2.y - basePt.y
	    };
	    var kross = crossProduct(v1, v2);
	    return cmp(kross, 0);
	  };
	  var length = function length(v) {
	    return Math.sqrt(dotProduct(v, v));
	  };
	  /* Get the sine of the angle from pShared -> pAngle to pShaed -> pBase */

	  var sineOfAngle = function sineOfAngle(pShared, pBase, pAngle) {
	    var vBase = {
	      x: pBase.x - pShared.x,
	      y: pBase.y - pShared.y
	    };
	    var vAngle = {
	      x: pAngle.x - pShared.x,
	      y: pAngle.y - pShared.y
	    };
	    return crossProduct(vAngle, vBase) / length(vAngle) / length(vBase);
	  };
	  /* Get the cosine of the angle from pShared -> pAngle to pShaed -> pBase */

	  var cosineOfAngle = function cosineOfAngle(pShared, pBase, pAngle) {
	    var vBase = {
	      x: pBase.x - pShared.x,
	      y: pBase.y - pShared.y
	    };
	    var vAngle = {
	      x: pAngle.x - pShared.x,
	      y: pAngle.y - pShared.y
	    };
	    return dotProduct(vAngle, vBase) / length(vAngle) / length(vBase);
	  };
	  /* Get the x coordinate where the given line (defined by a point and vector)
	   * crosses the horizontal line with the given y coordiante.
	   * In the case of parrallel lines (including overlapping ones) returns null. */

	  var horizontalIntersection = function horizontalIntersection(pt, v, y) {
	    if (v.y === 0) return null;
	    return {
	      x: pt.x + v.x / v.y * (y - pt.y),
	      y: y
	    };
	  };
	  /* Get the y coordinate where the given line (defined by a point and vector)
	   * crosses the vertical line with the given x coordiante.
	   * In the case of parrallel lines (including overlapping ones) returns null. */

	  var verticalIntersection = function verticalIntersection(pt, v, x) {
	    if (v.x === 0) return null;
	    return {
	      x: x,
	      y: pt.y + v.y / v.x * (x - pt.x)
	    };
	  };
	  /* Get the intersection of two lines, each defined by a base point and a vector.
	   * In the case of parrallel lines (including overlapping ones) returns null. */

	  var intersection = function intersection(pt1, v1, pt2, v2) {
	    // take some shortcuts for vertical and horizontal lines
	    // this also ensures we don't calculate an intersection and then discover
	    // it's actually outside the bounding box of the line
	    if (v1.x === 0) return verticalIntersection(pt2, v2, pt1.x);
	    if (v2.x === 0) return verticalIntersection(pt1, v1, pt2.x);
	    if (v1.y === 0) return horizontalIntersection(pt2, v2, pt1.y);
	    if (v2.y === 0) return horizontalIntersection(pt1, v1, pt2.y); // General case for non-overlapping segments.
	    // This algorithm is based on Schneider and Eberly.
	    // http://www.cimec.org.ar/~ncalvo/Schneider_Eberly.pdf - pg 244

	    var kross = crossProduct(v1, v2);
	    if (kross == 0) return null;
	    var ve = {
	      x: pt2.x - pt1.x,
	      y: pt2.y - pt1.y
	    };
	    var d1 = crossProduct(ve, v1) / kross;
	    var d2 = crossProduct(ve, v2) / kross; // take the average of the two calculations to minimize rounding error

	    var x1 = pt1.x + d2 * v1.x,
	        x2 = pt2.x + d1 * v2.x;
	    var y1 = pt1.y + d2 * v1.y,
	        y2 = pt2.y + d1 * v2.y;
	    var x = (x1 + x2) / 2;
	    var y = (y1 + y2) / 2;
	    return {
	      x: x,
	      y: y
	    };
	  };

	  var SweepEvent = /*#__PURE__*/function () {
	    _createClass(SweepEvent, null, [{
	      key: "compare",
	      // for ordering sweep events in the sweep event queue
	      value: function compare(a, b) {
	        // favor event with a point that the sweep line hits first
	        var ptCmp = SweepEvent.comparePoints(a.point, b.point);
	        if (ptCmp !== 0) return ptCmp; // the points are the same, so link them if needed

	        if (a.point !== b.point) a.link(b); // favor right events over left

	        if (a.isLeft !== b.isLeft) return a.isLeft ? 1 : -1; // we have two matching left or right endpoints
	        // ordering of this case is the same as for their segments

	        return Segment.compare(a.segment, b.segment);
	      } // for ordering points in sweep line order

	    }, {
	      key: "comparePoints",
	      value: function comparePoints(aPt, bPt) {
	        if (aPt.x < bPt.x) return -1;
	        if (aPt.x > bPt.x) return 1;
	        if (aPt.y < bPt.y) return -1;
	        if (aPt.y > bPt.y) return 1;
	        return 0;
	      } // Warning: 'point' input will be modified and re-used (for performance)

	    }]);

	    function SweepEvent(point, isLeft) {
	      _classCallCheck(this, SweepEvent);

	      if (point.events === undefined) point.events = [this];else point.events.push(this);
	      this.point = point;
	      this.isLeft = isLeft; // this.segment, this.otherSE set by factory
	    }

	    _createClass(SweepEvent, [{
	      key: "link",
	      value: function link(other) {
	        if (other.point === this.point) {
	          throw new Error('Tried to link already linked events');
	        }

	        var otherEvents = other.point.events;

	        for (var i = 0, iMax = otherEvents.length; i < iMax; i++) {
	          var evt = otherEvents[i];
	          this.point.events.push(evt);
	          evt.point = this.point;
	        }

	        this.checkForConsuming();
	      }
	      /* Do a pass over our linked events and check to see if any pair
	       * of segments match, and should be consumed. */

	    }, {
	      key: "checkForConsuming",
	      value: function checkForConsuming() {
	        // FIXME: The loops in this method run O(n^2) => no good.
	        //        Maintain little ordered sweep event trees?
	        //        Can we maintaining an ordering that avoids the need
	        //        for the re-sorting with getLeftmostComparator in geom-out?
	        // Compare each pair of events to see if other events also match
	        var numEvents = this.point.events.length;

	        for (var i = 0; i < numEvents; i++) {
	          var evt1 = this.point.events[i];
	          if (evt1.segment.consumedBy !== undefined) continue;

	          for (var j = i + 1; j < numEvents; j++) {
	            var evt2 = this.point.events[j];
	            if (evt2.consumedBy !== undefined) continue;
	            if (evt1.otherSE.point.events !== evt2.otherSE.point.events) continue;
	            evt1.segment.consume(evt2.segment);
	          }
	        }
	      }
	    }, {
	      key: "getAvailableLinkedEvents",
	      value: function getAvailableLinkedEvents() {
	        // point.events is always of length 2 or greater
	        var events = [];

	        for (var i = 0, iMax = this.point.events.length; i < iMax; i++) {
	          var evt = this.point.events[i];

	          if (evt !== this && !evt.segment.ringOut && evt.segment.isInResult()) {
	            events.push(evt);
	          }
	        }

	        return events;
	      }
	      /**
	       * Returns a comparator function for sorting linked events that will
	       * favor the event that will give us the smallest left-side angle.
	       * All ring construction starts as low as possible heading to the right,
	       * so by always turning left as sharp as possible we'll get polygons
	       * without uncessary loops & holes.
	       *
	       * The comparator function has a compute cache such that it avoids
	       * re-computing already-computed values.
	       */

	    }, {
	      key: "getLeftmostComparator",
	      value: function getLeftmostComparator(baseEvent) {
	        var _this = this;

	        var cache = new Map();

	        var fillCache = function fillCache(linkedEvent) {
	          var nextEvent = linkedEvent.otherSE;
	          cache.set(linkedEvent, {
	            sine: sineOfAngle(_this.point, baseEvent.point, nextEvent.point),
	            cosine: cosineOfAngle(_this.point, baseEvent.point, nextEvent.point)
	          });
	        };

	        return function (a, b) {
	          if (!cache.has(a)) fillCache(a);
	          if (!cache.has(b)) fillCache(b);

	          var _cache$get = cache.get(a),
	              asine = _cache$get.sine,
	              acosine = _cache$get.cosine;

	          var _cache$get2 = cache.get(b),
	              bsine = _cache$get2.sine,
	              bcosine = _cache$get2.cosine; // both on or above x-axis


	          if (asine >= 0 && bsine >= 0) {
	            if (acosine < bcosine) return 1;
	            if (acosine > bcosine) return -1;
	            return 0;
	          } // both below x-axis


	          if (asine < 0 && bsine < 0) {
	            if (acosine < bcosine) return -1;
	            if (acosine > bcosine) return 1;
	            return 0;
	          } // one above x-axis, one below


	          if (bsine < asine) return -1;
	          if (bsine > asine) return 1;
	          return 0;
	        };
	      }
	    }]);

	    return SweepEvent;
	  }();

	  // segments and sweep events when all else is identical

	  var segmentId = 0;

	  var Segment = /*#__PURE__*/function () {
	    _createClass(Segment, null, [{
	      key: "compare",

	      /* This compare() function is for ordering segments in the sweep
	       * line tree, and does so according to the following criteria:
	       *
	       * Consider the vertical line that lies an infinestimal step to the
	       * right of the right-more of the two left endpoints of the input
	       * segments. Imagine slowly moving a point up from negative infinity
	       * in the increasing y direction. Which of the two segments will that
	       * point intersect first? That segment comes 'before' the other one.
	       *
	       * If neither segment would be intersected by such a line, (if one
	       * or more of the segments are vertical) then the line to be considered
	       * is directly on the right-more of the two left inputs.
	       */
	      value: function compare(a, b) {
	        var alx = a.leftSE.point.x;
	        var blx = b.leftSE.point.x;
	        var arx = a.rightSE.point.x;
	        var brx = b.rightSE.point.x; // check if they're even in the same vertical plane

	        if (brx < alx) return 1;
	        if (arx < blx) return -1;
	        var aly = a.leftSE.point.y;
	        var bly = b.leftSE.point.y;
	        var ary = a.rightSE.point.y;
	        var bry = b.rightSE.point.y; // is left endpoint of segment B the right-more?

	        if (alx < blx) {
	          // are the two segments in the same horizontal plane?
	          if (bly < aly && bly < ary) return 1;
	          if (bly > aly && bly > ary) return -1; // is the B left endpoint colinear to segment A?

	          var aCmpBLeft = a.comparePoint(b.leftSE.point);
	          if (aCmpBLeft < 0) return 1;
	          if (aCmpBLeft > 0) return -1; // is the A right endpoint colinear to segment B ?

	          var bCmpARight = b.comparePoint(a.rightSE.point);
	          if (bCmpARight !== 0) return bCmpARight; // colinear segments, consider the one with left-more
	          // left endpoint to be first (arbitrary?)

	          return -1;
	        } // is left endpoint of segment A the right-more?


	        if (alx > blx) {
	          if (aly < bly && aly < bry) return -1;
	          if (aly > bly && aly > bry) return 1; // is the A left endpoint colinear to segment B?

	          var bCmpALeft = b.comparePoint(a.leftSE.point);
	          if (bCmpALeft !== 0) return bCmpALeft; // is the B right endpoint colinear to segment A?

	          var aCmpBRight = a.comparePoint(b.rightSE.point);
	          if (aCmpBRight < 0) return 1;
	          if (aCmpBRight > 0) return -1; // colinear segments, consider the one with left-more
	          // left endpoint to be first (arbitrary?)

	          return 1;
	        } // if we get here, the two left endpoints are in the same
	        // vertical plane, ie alx === blx
	        // consider the lower left-endpoint to come first


	        if (aly < bly) return -1;
	        if (aly > bly) return 1; // left endpoints are identical
	        // check for colinearity by using the left-more right endpoint
	        // is the A right endpoint more left-more?

	        if (arx < brx) {
	          var _bCmpARight = b.comparePoint(a.rightSE.point);

	          if (_bCmpARight !== 0) return _bCmpARight;
	        } // is the B right endpoint more left-more?


	        if (arx > brx) {
	          var _aCmpBRight = a.comparePoint(b.rightSE.point);

	          if (_aCmpBRight < 0) return 1;
	          if (_aCmpBRight > 0) return -1;
	        }

	        if (arx !== brx) {
	          // are these two [almost] vertical segments with opposite orientation?
	          // if so, the one with the lower right endpoint comes first
	          var ay = ary - aly;
	          var ax = arx - alx;
	          var by = bry - bly;
	          var bx = brx - blx;
	          if (ay > ax && by < bx) return 1;
	          if (ay < ax && by > bx) return -1;
	        } // we have colinear segments with matching orientation
	        // consider the one with more left-more right endpoint to be first


	        if (arx > brx) return 1;
	        if (arx < brx) return -1; // if we get here, two two right endpoints are in the same
	        // vertical plane, ie arx === brx
	        // consider the lower right-endpoint to come first

	        if (ary < bry) return -1;
	        if (ary > bry) return 1; // right endpoints identical as well, so the segments are idential
	        // fall back on creation order as consistent tie-breaker

	        if (a.id < b.id) return -1;
	        if (a.id > b.id) return 1; // identical segment, ie a === b

	        return 0;
	      }
	      /* Warning: a reference to ringWindings input will be stored,
	       *  and possibly will be later modified */

	    }]);

	    function Segment(leftSE, rightSE, rings, windings) {
	      _classCallCheck(this, Segment);

	      this.id = ++segmentId;
	      this.leftSE = leftSE;
	      leftSE.segment = this;
	      leftSE.otherSE = rightSE;
	      this.rightSE = rightSE;
	      rightSE.segment = this;
	      rightSE.otherSE = leftSE;
	      this.rings = rings;
	      this.windings = windings; // left unset for performance, set later in algorithm
	      // this.ringOut, this.consumedBy, this.prev
	    }

	    _createClass(Segment, [{
	      key: "replaceRightSE",

	      /* When a segment is split, the rightSE is replaced with a new sweep event */
	      value: function replaceRightSE(newRightSE) {
	        this.rightSE = newRightSE;
	        this.rightSE.segment = this;
	        this.rightSE.otherSE = this.leftSE;
	        this.leftSE.otherSE = this.rightSE;
	      }
	    }, {
	      key: "bbox",
	      value: function bbox() {
	        var y1 = this.leftSE.point.y;
	        var y2 = this.rightSE.point.y;
	        return {
	          ll: {
	            x: this.leftSE.point.x,
	            y: y1 < y2 ? y1 : y2
	          },
	          ur: {
	            x: this.rightSE.point.x,
	            y: y1 > y2 ? y1 : y2
	          }
	        };
	      }
	      /* A vector from the left point to the right */

	    }, {
	      key: "vector",
	      value: function vector() {
	        return {
	          x: this.rightSE.point.x - this.leftSE.point.x,
	          y: this.rightSE.point.y - this.leftSE.point.y
	        };
	      }
	    }, {
	      key: "isAnEndpoint",
	      value: function isAnEndpoint(pt) {
	        return pt.x === this.leftSE.point.x && pt.y === this.leftSE.point.y || pt.x === this.rightSE.point.x && pt.y === this.rightSE.point.y;
	      }
	      /* Compare this segment with a point.
	       *
	       * A point P is considered to be colinear to a segment if there
	       * exists a distance D such that if we travel along the segment
	       * from one * endpoint towards the other a distance D, we find
	       * ourselves at point P.
	       *
	       * Return value indicates:
	       *
	       *   1: point lies above the segment (to the left of vertical)
	       *   0: point is colinear to segment
	       *  -1: point lies below the segment (to the right of vertical)
	       */

	    }, {
	      key: "comparePoint",
	      value: function comparePoint(point) {
	        if (this.isAnEndpoint(point)) return 0;
	        var lPt = this.leftSE.point;
	        var rPt = this.rightSE.point;
	        var v = this.vector(); // Exactly vertical segments.

	        if (lPt.x === rPt.x) {
	          if (point.x === lPt.x) return 0;
	          return point.x < lPt.x ? 1 : -1;
	        } // Nearly vertical segments with an intersection.
	        // Check to see where a point on the line with matching Y coordinate is.


	        var yDist = (point.y - lPt.y) / v.y;
	        var xFromYDist = lPt.x + yDist * v.x;
	        if (point.x === xFromYDist) return 0; // General case.
	        // Check to see where a point on the line with matching X coordinate is.

	        var xDist = (point.x - lPt.x) / v.x;
	        var yFromXDist = lPt.y + xDist * v.y;
	        if (point.y === yFromXDist) return 0;
	        return point.y < yFromXDist ? -1 : 1;
	      }
	      /**
	       * Given another segment, returns the first non-trivial intersection
	       * between the two segments (in terms of sweep line ordering), if it exists.
	       *
	       * A 'non-trivial' intersection is one that will cause one or both of the
	       * segments to be split(). As such, 'trivial' vs. 'non-trivial' intersection:
	       *
	       *   * endpoint of segA with endpoint of segB --> trivial
	       *   * endpoint of segA with point along segB --> non-trivial
	       *   * endpoint of segB with point along segA --> non-trivial
	       *   * point along segA with point along segB --> non-trivial
	       *
	       * If no non-trivial intersection exists, return null
	       * Else, return null.
	       */

	    }, {
	      key: "getIntersection",
	      value: function getIntersection(other) {
	        // If bboxes don't overlap, there can't be any intersections
	        var tBbox = this.bbox();
	        var oBbox = other.bbox();
	        var bboxOverlap = getBboxOverlap(tBbox, oBbox);
	        if (bboxOverlap === null) return null; // We first check to see if the endpoints can be considered intersections.
	        // This will 'snap' intersections to endpoints if possible, and will
	        // handle cases of colinearity.

	        var tlp = this.leftSE.point;
	        var trp = this.rightSE.point;
	        var olp = other.leftSE.point;
	        var orp = other.rightSE.point; // does each endpoint touch the other segment?
	        // note that we restrict the 'touching' definition to only allow segments
	        // to touch endpoints that lie forward from where we are in the sweep line pass

	        var touchesOtherLSE = isInBbox(tBbox, olp) && this.comparePoint(olp) === 0;
	        var touchesThisLSE = isInBbox(oBbox, tlp) && other.comparePoint(tlp) === 0;
	        var touchesOtherRSE = isInBbox(tBbox, orp) && this.comparePoint(orp) === 0;
	        var touchesThisRSE = isInBbox(oBbox, trp) && other.comparePoint(trp) === 0; // do left endpoints match?

	        if (touchesThisLSE && touchesOtherLSE) {
	          // these two cases are for colinear segments with matching left
	          // endpoints, and one segment being longer than the other
	          if (touchesThisRSE && !touchesOtherRSE) return trp;
	          if (!touchesThisRSE && touchesOtherRSE) return orp; // either the two segments match exactly (two trival intersections)
	          // or just on their left endpoint (one trivial intersection

	          return null;
	        } // does this left endpoint matches (other doesn't)


	        if (touchesThisLSE) {
	          // check for segments that just intersect on opposing endpoints
	          if (touchesOtherRSE) {
	            if (tlp.x === orp.x && tlp.y === orp.y) return null;
	          } // t-intersection on left endpoint


	          return tlp;
	        } // does other left endpoint matches (this doesn't)


	        if (touchesOtherLSE) {
	          // check for segments that just intersect on opposing endpoints
	          if (touchesThisRSE) {
	            if (trp.x === olp.x && trp.y === olp.y) return null;
	          } // t-intersection on left endpoint


	          return olp;
	        } // trivial intersection on right endpoints


	        if (touchesThisRSE && touchesOtherRSE) return null; // t-intersections on just one right endpoint

	        if (touchesThisRSE) return trp;
	        if (touchesOtherRSE) return orp; // None of our endpoints intersect. Look for a general intersection between
	        // infinite lines laid over the segments

	        var pt = intersection(tlp, this.vector(), olp, other.vector()); // are the segments parrallel? Note that if they were colinear with overlap,
	        // they would have an endpoint intersection and that case was already handled above

	        if (pt === null) return null; // is the intersection found between the lines not on the segments?

	        if (!isInBbox(bboxOverlap, pt)) return null; // round the the computed point if needed

	        return rounder.round(pt.x, pt.y);
	      }
	      /**
	       * Split the given segment into multiple segments on the given points.
	       *  * Each existing segment will retain its leftSE and a new rightSE will be
	       *    generated for it.
	       *  * A new segment will be generated which will adopt the original segment's
	       *    rightSE, and a new leftSE will be generated for it.
	       *  * If there are more than two points given to split on, new segments
	       *    in the middle will be generated with new leftSE and rightSE's.
	       *  * An array of the newly generated SweepEvents will be returned.
	       *
	       * Warning: input array of points is modified
	       */

	    }, {
	      key: "split",
	      value: function split(point) {
	        var newEvents = [];
	        var alreadyLinked = point.events !== undefined;
	        var newLeftSE = new SweepEvent(point, true);
	        var newRightSE = new SweepEvent(point, false);
	        var oldRightSE = this.rightSE;
	        this.replaceRightSE(newRightSE);
	        newEvents.push(newRightSE);
	        newEvents.push(newLeftSE);
	        var newSeg = new Segment(newLeftSE, oldRightSE, this.rings.slice(), this.windings.slice()); // when splitting a nearly vertical downward-facing segment,
	        // sometimes one of the resulting new segments is vertical, in which
	        // case its left and right events may need to be swapped

	        if (SweepEvent.comparePoints(newSeg.leftSE.point, newSeg.rightSE.point) > 0) {
	          newSeg.swapEvents();
	        }

	        if (SweepEvent.comparePoints(this.leftSE.point, this.rightSE.point) > 0) {
	          this.swapEvents();
	        } // in the point we just used to create new sweep events with was already
	        // linked to other events, we need to check if either of the affected
	        // segments should be consumed


	        if (alreadyLinked) {
	          newLeftSE.checkForConsuming();
	          newRightSE.checkForConsuming();
	        }

	        return newEvents;
	      }
	      /* Swap which event is left and right */

	    }, {
	      key: "swapEvents",
	      value: function swapEvents() {
	        var tmpEvt = this.rightSE;
	        this.rightSE = this.leftSE;
	        this.leftSE = tmpEvt;
	        this.leftSE.isLeft = true;
	        this.rightSE.isLeft = false;

	        for (var i = 0, iMax = this.windings.length; i < iMax; i++) {
	          this.windings[i] *= -1;
	        }
	      }
	      /* Consume another segment. We take their rings under our wing
	       * and mark them as consumed. Use for perfectly overlapping segments */

	    }, {
	      key: "consume",
	      value: function consume(other) {
	        var consumer = this;
	        var consumee = other;

	        while (consumer.consumedBy) {
	          consumer = consumer.consumedBy;
	        }

	        while (consumee.consumedBy) {
	          consumee = consumee.consumedBy;
	        }

	        var cmp = Segment.compare(consumer, consumee);
	        if (cmp === 0) return; // already consumed
	        // the winner of the consumption is the earlier segment
	        // according to sweep line ordering

	        if (cmp > 0) {
	          var tmp = consumer;
	          consumer = consumee;
	          consumee = tmp;
	        } // make sure a segment doesn't consume it's prev


	        if (consumer.prev === consumee) {
	          var _tmp = consumer;
	          consumer = consumee;
	          consumee = _tmp;
	        }

	        for (var i = 0, iMax = consumee.rings.length; i < iMax; i++) {
	          var ring = consumee.rings[i];
	          var winding = consumee.windings[i];
	          var index = consumer.rings.indexOf(ring);

	          if (index === -1) {
	            consumer.rings.push(ring);
	            consumer.windings.push(winding);
	          } else consumer.windings[index] += winding;
	        }

	        consumee.rings = null;
	        consumee.windings = null;
	        consumee.consumedBy = consumer; // mark sweep events consumed as to maintain ordering in sweep event queue

	        consumee.leftSE.consumedBy = consumer.leftSE;
	        consumee.rightSE.consumedBy = consumer.rightSE;
	      }
	      /* The first segment previous segment chain that is in the result */

	    }, {
	      key: "prevInResult",
	      value: function prevInResult() {
	        if (this._prevInResult !== undefined) return this._prevInResult;
	        if (!this.prev) this._prevInResult = null;else if (this.prev.isInResult()) this._prevInResult = this.prev;else this._prevInResult = this.prev.prevInResult();
	        return this._prevInResult;
	      }
	    }, {
	      key: "beforeState",
	      value: function beforeState() {
	        if (this._beforeState !== undefined) return this._beforeState;
	        if (!this.prev) this._beforeState = {
	          rings: [],
	          windings: [],
	          multiPolys: []
	        };else {
	          var seg = this.prev.consumedBy || this.prev;
	          this._beforeState = seg.afterState();
	        }
	        return this._beforeState;
	      }
	    }, {
	      key: "afterState",
	      value: function afterState() {
	        if (this._afterState !== undefined) return this._afterState;
	        var beforeState = this.beforeState();
	        this._afterState = {
	          rings: beforeState.rings.slice(0),
	          windings: beforeState.windings.slice(0),
	          multiPolys: []
	        };
	        var ringsAfter = this._afterState.rings;
	        var windingsAfter = this._afterState.windings;
	        var mpsAfter = this._afterState.multiPolys; // calculate ringsAfter, windingsAfter

	        for (var i = 0, iMax = this.rings.length; i < iMax; i++) {
	          var ring = this.rings[i];
	          var winding = this.windings[i];
	          var index = ringsAfter.indexOf(ring);

	          if (index === -1) {
	            ringsAfter.push(ring);
	            windingsAfter.push(winding);
	          } else windingsAfter[index] += winding;
	        } // calcualte polysAfter


	        var polysAfter = [];
	        var polysExclude = [];

	        for (var _i = 0, _iMax = ringsAfter.length; _i < _iMax; _i++) {
	          if (windingsAfter[_i] === 0) continue; // non-zero rule

	          var _ring = ringsAfter[_i];
	          var poly = _ring.poly;
	          if (polysExclude.indexOf(poly) !== -1) continue;
	          if (_ring.isExterior) polysAfter.push(poly);else {
	            if (polysExclude.indexOf(poly) === -1) polysExclude.push(poly);

	            var _index = polysAfter.indexOf(_ring.poly);

	            if (_index !== -1) polysAfter.splice(_index, 1);
	          }
	        } // calculate multiPolysAfter


	        for (var _i2 = 0, _iMax2 = polysAfter.length; _i2 < _iMax2; _i2++) {
	          var mp = polysAfter[_i2].multiPoly;
	          if (mpsAfter.indexOf(mp) === -1) mpsAfter.push(mp);
	        }

	        return this._afterState;
	      }
	      /* Is this segment part of the final result? */

	    }, {
	      key: "isInResult",
	      value: function isInResult() {
	        // if we've been consumed, we're not in the result
	        if (this.consumedBy) return false;
	        if (this._isInResult !== undefined) return this._isInResult;
	        var mpsBefore = this.beforeState().multiPolys;
	        var mpsAfter = this.afterState().multiPolys;

	        switch (operation.type) {
	          case 'union':
	            {
	              // UNION - included iff:
	              //  * On one side of us there is 0 poly interiors AND
	              //  * On the other side there is 1 or more.
	              var noBefores = mpsBefore.length === 0;
	              var noAfters = mpsAfter.length === 0;
	              this._isInResult = noBefores !== noAfters;
	              break;
	            }

	          case 'intersection':
	            {
	              // INTERSECTION - included iff:
	              //  * on one side of us all multipolys are rep. with poly interiors AND
	              //  * on the other side of us, not all multipolys are repsented
	              //    with poly interiors
	              var least;
	              var most;

	              if (mpsBefore.length < mpsAfter.length) {
	                least = mpsBefore.length;
	                most = mpsAfter.length;
	              } else {
	                least = mpsAfter.length;
	                most = mpsBefore.length;
	              }

	              this._isInResult = most === operation.numMultiPolys && least < most;
	              break;
	            }

	          case 'xor':
	            {
	              // XOR - included iff:
	              //  * the difference between the number of multipolys represented
	              //    with poly interiors on our two sides is an odd number
	              var diff = Math.abs(mpsBefore.length - mpsAfter.length);
	              this._isInResult = diff % 2 === 1;
	              break;
	            }

	          case 'difference':
	            {
	              // DIFFERENCE included iff:
	              //  * on exactly one side, we have just the subject
	              var isJustSubject = function isJustSubject(mps) {
	                return mps.length === 1 && mps[0].isSubject;
	              };

	              this._isInResult = isJustSubject(mpsBefore) !== isJustSubject(mpsAfter);
	              break;
	            }

	          default:
	            throw new Error("Unrecognized operation type found ".concat(operation.type));
	        }

	        return this._isInResult;
	      }
	    }], [{
	      key: "fromRing",
	      value: function fromRing(pt1, pt2, ring) {
	        var leftPt, rightPt, winding; // ordering the two points according to sweep line ordering

	        var cmpPts = SweepEvent.comparePoints(pt1, pt2);

	        if (cmpPts < 0) {
	          leftPt = pt1;
	          rightPt = pt2;
	          winding = 1;
	        } else if (cmpPts > 0) {
	          leftPt = pt2;
	          rightPt = pt1;
	          winding = -1;
	        } else throw new Error("Tried to create degenerate segment at [".concat(pt1.x, ", ").concat(pt1.y, "]"));

	        var leftSE = new SweepEvent(leftPt, true);
	        var rightSE = new SweepEvent(rightPt, false);
	        return new Segment(leftSE, rightSE, [ring], [winding]);
	      }
	    }]);

	    return Segment;
	  }();

	  var RingIn = /*#__PURE__*/function () {
	    function RingIn(geomRing, poly, isExterior) {
	      _classCallCheck(this, RingIn);

	      if (!Array.isArray(geomRing) || geomRing.length === 0) {
	        throw new Error('Input geometry is not a valid Polygon or MultiPolygon');
	      }

	      this.poly = poly;
	      this.isExterior = isExterior;
	      this.segments = [];

	      if (typeof geomRing[0][0] !== 'number' || typeof geomRing[0][1] !== 'number') {
	        throw new Error('Input geometry is not a valid Polygon or MultiPolygon');
	      }

	      var firstPoint = rounder.round(geomRing[0][0], geomRing[0][1]);
	      this.bbox = {
	        ll: {
	          x: firstPoint.x,
	          y: firstPoint.y
	        },
	        ur: {
	          x: firstPoint.x,
	          y: firstPoint.y
	        }
	      };
	      var prevPoint = firstPoint;

	      for (var i = 1, iMax = geomRing.length; i < iMax; i++) {
	        if (typeof geomRing[i][0] !== 'number' || typeof geomRing[i][1] !== 'number') {
	          throw new Error('Input geometry is not a valid Polygon or MultiPolygon');
	        }

	        var point = rounder.round(geomRing[i][0], geomRing[i][1]); // skip repeated points

	        if (point.x === prevPoint.x && point.y === prevPoint.y) continue;
	        this.segments.push(Segment.fromRing(prevPoint, point, this));
	        if (point.x < this.bbox.ll.x) this.bbox.ll.x = point.x;
	        if (point.y < this.bbox.ll.y) this.bbox.ll.y = point.y;
	        if (point.x > this.bbox.ur.x) this.bbox.ur.x = point.x;
	        if (point.y > this.bbox.ur.y) this.bbox.ur.y = point.y;
	        prevPoint = point;
	      } // add segment from last to first if last is not the same as first


	      if (firstPoint.x !== prevPoint.x || firstPoint.y !== prevPoint.y) {
	        this.segments.push(Segment.fromRing(prevPoint, firstPoint, this));
	      }
	    }

	    _createClass(RingIn, [{
	      key: "getSweepEvents",
	      value: function getSweepEvents() {
	        var sweepEvents = [];

	        for (var i = 0, iMax = this.segments.length; i < iMax; i++) {
	          var segment = this.segments[i];
	          sweepEvents.push(segment.leftSE);
	          sweepEvents.push(segment.rightSE);
	        }

	        return sweepEvents;
	      }
	    }]);

	    return RingIn;
	  }();
	  var PolyIn = /*#__PURE__*/function () {
	    function PolyIn(geomPoly, multiPoly) {
	      _classCallCheck(this, PolyIn);

	      if (!Array.isArray(geomPoly)) {
	        throw new Error('Input geometry is not a valid Polygon or MultiPolygon');
	      }

	      this.exteriorRing = new RingIn(geomPoly[0], this, true); // copy by value

	      this.bbox = {
	        ll: {
	          x: this.exteriorRing.bbox.ll.x,
	          y: this.exteriorRing.bbox.ll.y
	        },
	        ur: {
	          x: this.exteriorRing.bbox.ur.x,
	          y: this.exteriorRing.bbox.ur.y
	        }
	      };
	      this.interiorRings = [];

	      for (var i = 1, iMax = geomPoly.length; i < iMax; i++) {
	        var ring = new RingIn(geomPoly[i], this, false);
	        if (ring.bbox.ll.x < this.bbox.ll.x) this.bbox.ll.x = ring.bbox.ll.x;
	        if (ring.bbox.ll.y < this.bbox.ll.y) this.bbox.ll.y = ring.bbox.ll.y;
	        if (ring.bbox.ur.x > this.bbox.ur.x) this.bbox.ur.x = ring.bbox.ur.x;
	        if (ring.bbox.ur.y > this.bbox.ur.y) this.bbox.ur.y = ring.bbox.ur.y;
	        this.interiorRings.push(ring);
	      }

	      this.multiPoly = multiPoly;
	    }

	    _createClass(PolyIn, [{
	      key: "getSweepEvents",
	      value: function getSweepEvents() {
	        var sweepEvents = this.exteriorRing.getSweepEvents();

	        for (var i = 0, iMax = this.interiorRings.length; i < iMax; i++) {
	          var ringSweepEvents = this.interiorRings[i].getSweepEvents();

	          for (var j = 0, jMax = ringSweepEvents.length; j < jMax; j++) {
	            sweepEvents.push(ringSweepEvents[j]);
	          }
	        }

	        return sweepEvents;
	      }
	    }]);

	    return PolyIn;
	  }();
	  var MultiPolyIn = /*#__PURE__*/function () {
	    function MultiPolyIn(geom, isSubject) {
	      _classCallCheck(this, MultiPolyIn);

	      if (!Array.isArray(geom)) {
	        throw new Error('Input geometry is not a valid Polygon or MultiPolygon');
	      }

	      try {
	        // if the input looks like a polygon, convert it to a multipolygon
	        if (typeof geom[0][0][0] === 'number') geom = [geom];
	      } catch (ex) {// The input is either malformed or has empty arrays.
	        // In either case, it will be handled later on.
	      }

	      this.polys = [];
	      this.bbox = {
	        ll: {
	          x: Number.POSITIVE_INFINITY,
	          y: Number.POSITIVE_INFINITY
	        },
	        ur: {
	          x: Number.NEGATIVE_INFINITY,
	          y: Number.NEGATIVE_INFINITY
	        }
	      };

	      for (var i = 0, iMax = geom.length; i < iMax; i++) {
	        var poly = new PolyIn(geom[i], this);
	        if (poly.bbox.ll.x < this.bbox.ll.x) this.bbox.ll.x = poly.bbox.ll.x;
	        if (poly.bbox.ll.y < this.bbox.ll.y) this.bbox.ll.y = poly.bbox.ll.y;
	        if (poly.bbox.ur.x > this.bbox.ur.x) this.bbox.ur.x = poly.bbox.ur.x;
	        if (poly.bbox.ur.y > this.bbox.ur.y) this.bbox.ur.y = poly.bbox.ur.y;
	        this.polys.push(poly);
	      }

	      this.isSubject = isSubject;
	    }

	    _createClass(MultiPolyIn, [{
	      key: "getSweepEvents",
	      value: function getSweepEvents() {
	        var sweepEvents = [];

	        for (var i = 0, iMax = this.polys.length; i < iMax; i++) {
	          var polySweepEvents = this.polys[i].getSweepEvents();

	          for (var j = 0, jMax = polySweepEvents.length; j < jMax; j++) {
	            sweepEvents.push(polySweepEvents[j]);
	          }
	        }

	        return sweepEvents;
	      }
	    }]);

	    return MultiPolyIn;
	  }();

	  var RingOut = /*#__PURE__*/function () {
	    _createClass(RingOut, null, [{
	      key: "factory",

	      /* Given the segments from the sweep line pass, compute & return a series
	       * of closed rings from all the segments marked to be part of the result */
	      value: function factory(allSegments) {
	        var ringsOut = [];

	        for (var i = 0, iMax = allSegments.length; i < iMax; i++) {
	          var segment = allSegments[i];
	          if (!segment.isInResult() || segment.ringOut) continue;
	          var prevEvent = null;
	          var event = segment.leftSE;
	          var nextEvent = segment.rightSE;
	          var events = [event];
	          var startingPoint = event.point;
	          var intersectionLEs = [];
	          /* Walk the chain of linked events to form a closed ring */

	          while (true) {
	            prevEvent = event;
	            event = nextEvent;
	            events.push(event);
	            /* Is the ring complete? */

	            if (event.point === startingPoint) break;

	            while (true) {
	              var availableLEs = event.getAvailableLinkedEvents();
	              /* Did we hit a dead end? This shouldn't happen. Indicates some earlier
	               * part of the algorithm malfunctioned... please file a bug report. */

	              if (availableLEs.length === 0) {
	                var firstPt = events[0].point;
	                var lastPt = events[events.length - 1].point;
	                throw new Error("Unable to complete output ring starting at [".concat(firstPt.x, ",") + " ".concat(firstPt.y, "]. Last matching segment found ends at") + " [".concat(lastPt.x, ", ").concat(lastPt.y, "]."));
	              }
	              /* Only one way to go, so cotinue on the path */


	              if (availableLEs.length === 1) {
	                nextEvent = availableLEs[0].otherSE;
	                break;
	              }
	              /* We must have an intersection. Check for a completed loop */


	              var indexLE = null;

	              for (var j = 0, jMax = intersectionLEs.length; j < jMax; j++) {
	                if (intersectionLEs[j].point === event.point) {
	                  indexLE = j;
	                  break;
	                }
	              }
	              /* Found a completed loop. Cut that off and make a ring */


	              if (indexLE !== null) {
	                var intersectionLE = intersectionLEs.splice(indexLE)[0];
	                var ringEvents = events.splice(intersectionLE.index);
	                ringEvents.unshift(ringEvents[0].otherSE);
	                ringsOut.push(new RingOut(ringEvents.reverse()));
	                continue;
	              }
	              /* register the intersection */


	              intersectionLEs.push({
	                index: events.length,
	                point: event.point
	              });
	              /* Choose the left-most option to continue the walk */

	              var comparator = event.getLeftmostComparator(prevEvent);
	              nextEvent = availableLEs.sort(comparator)[0].otherSE;
	              break;
	            }
	          }

	          ringsOut.push(new RingOut(events));
	        }

	        return ringsOut;
	      }
	    }]);

	    function RingOut(events) {
	      _classCallCheck(this, RingOut);

	      this.events = events;

	      for (var i = 0, iMax = events.length; i < iMax; i++) {
	        events[i].segment.ringOut = this;
	      }

	      this.poly = null;
	    }

	    _createClass(RingOut, [{
	      key: "getGeom",
	      value: function getGeom() {
	        // Remove superfluous points (ie extra points along a straight line),
	        var prevPt = this.events[0].point;
	        var points = [prevPt];

	        for (var i = 1, iMax = this.events.length - 1; i < iMax; i++) {
	          var _pt = this.events[i].point;
	          var _nextPt = this.events[i + 1].point;
	          if (compareVectorAngles(_pt, prevPt, _nextPt) === 0) continue;
	          points.push(_pt);
	          prevPt = _pt;
	        } // ring was all (within rounding error of angle calc) colinear points


	        if (points.length === 1) return null; // check if the starting point is necessary

	        var pt = points[0];
	        var nextPt = points[1];
	        if (compareVectorAngles(pt, prevPt, nextPt) === 0) points.shift();
	        points.push(points[0]);
	        var step = this.isExteriorRing() ? 1 : -1;
	        var iStart = this.isExteriorRing() ? 0 : points.length - 1;
	        var iEnd = this.isExteriorRing() ? points.length : -1;
	        var orderedPoints = [];

	        for (var _i = iStart; _i != iEnd; _i += step) {
	          orderedPoints.push([points[_i].x, points[_i].y]);
	        }

	        return orderedPoints;
	      }
	    }, {
	      key: "isExteriorRing",
	      value: function isExteriorRing() {
	        if (this._isExteriorRing === undefined) {
	          var enclosing = this.enclosingRing();
	          this._isExteriorRing = enclosing ? !enclosing.isExteriorRing() : true;
	        }

	        return this._isExteriorRing;
	      }
	    }, {
	      key: "enclosingRing",
	      value: function enclosingRing() {
	        if (this._enclosingRing === undefined) {
	          this._enclosingRing = this._calcEnclosingRing();
	        }

	        return this._enclosingRing;
	      }
	      /* Returns the ring that encloses this one, if any */

	    }, {
	      key: "_calcEnclosingRing",
	      value: function _calcEnclosingRing() {
	        // start with the ealier sweep line event so that the prevSeg
	        // chain doesn't lead us inside of a loop of ours
	        var leftMostEvt = this.events[0];

	        for (var i = 1, iMax = this.events.length; i < iMax; i++) {
	          var evt = this.events[i];
	          if (SweepEvent.compare(leftMostEvt, evt) > 0) leftMostEvt = evt;
	        }

	        var prevSeg = leftMostEvt.segment.prevInResult();
	        var prevPrevSeg = prevSeg ? prevSeg.prevInResult() : null;

	        while (true) {
	          // no segment found, thus no ring can enclose us
	          if (!prevSeg) return null; // no segments below prev segment found, thus the ring of the prev
	          // segment must loop back around and enclose us

	          if (!prevPrevSeg) return prevSeg.ringOut; // if the two segments are of different rings, the ring of the prev
	          // segment must either loop around us or the ring of the prev prev
	          // seg, which would make us and the ring of the prev peers

	          if (prevPrevSeg.ringOut !== prevSeg.ringOut) {
	            if (prevPrevSeg.ringOut.enclosingRing() !== prevSeg.ringOut) {
	              return prevSeg.ringOut;
	            } else return prevSeg.ringOut.enclosingRing();
	          } // two segments are from the same ring, so this was a penisula
	          // of that ring. iterate downward, keep searching


	          prevSeg = prevPrevSeg.prevInResult();
	          prevPrevSeg = prevSeg ? prevSeg.prevInResult() : null;
	        }
	      }
	    }]);

	    return RingOut;
	  }();
	  var PolyOut = /*#__PURE__*/function () {
	    function PolyOut(exteriorRing) {
	      _classCallCheck(this, PolyOut);

	      this.exteriorRing = exteriorRing;
	      exteriorRing.poly = this;
	      this.interiorRings = [];
	    }

	    _createClass(PolyOut, [{
	      key: "addInterior",
	      value: function addInterior(ring) {
	        this.interiorRings.push(ring);
	        ring.poly = this;
	      }
	    }, {
	      key: "getGeom",
	      value: function getGeom() {
	        var geom = [this.exteriorRing.getGeom()]; // exterior ring was all (within rounding error of angle calc) colinear points

	        if (geom[0] === null) return null;

	        for (var i = 0, iMax = this.interiorRings.length; i < iMax; i++) {
	          var ringGeom = this.interiorRings[i].getGeom(); // interior ring was all (within rounding error of angle calc) colinear points

	          if (ringGeom === null) continue;
	          geom.push(ringGeom);
	        }

	        return geom;
	      }
	    }]);

	    return PolyOut;
	  }();
	  var MultiPolyOut = /*#__PURE__*/function () {
	    function MultiPolyOut(rings) {
	      _classCallCheck(this, MultiPolyOut);

	      this.rings = rings;
	      this.polys = this._composePolys(rings);
	    }

	    _createClass(MultiPolyOut, [{
	      key: "getGeom",
	      value: function getGeom() {
	        var geom = [];

	        for (var i = 0, iMax = this.polys.length; i < iMax; i++) {
	          var polyGeom = this.polys[i].getGeom(); // exterior ring was all (within rounding error of angle calc) colinear points

	          if (polyGeom === null) continue;
	          geom.push(polyGeom);
	        }

	        return geom;
	      }
	    }, {
	      key: "_composePolys",
	      value: function _composePolys(rings) {
	        var polys = [];

	        for (var i = 0, iMax = rings.length; i < iMax; i++) {
	          var ring = rings[i];
	          if (ring.poly) continue;
	          if (ring.isExteriorRing()) polys.push(new PolyOut(ring));else {
	            var enclosingRing = ring.enclosingRing();
	            if (!enclosingRing.poly) polys.push(new PolyOut(enclosingRing));
	            enclosingRing.poly.addInterior(ring);
	          }
	        }

	        return polys;
	      }
	    }]);

	    return MultiPolyOut;
	  }();

	  /**
	   * NOTE:  We must be careful not to change any segments while
	   *        they are in the SplayTree. AFAIK, there's no way to tell
	   *        the tree to rebalance itself - thus before splitting
	   *        a segment that's in the tree, we remove it from the tree,
	   *        do the split, then re-insert it. (Even though splitting a
	   *        segment *shouldn't* change its correct position in the
	   *        sweep line tree, the reality is because of rounding errors,
	   *        it sometimes does.)
	   */

	  var SweepLine = /*#__PURE__*/function () {
	    function SweepLine(queue) {
	      var comparator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Segment.compare;

	      _classCallCheck(this, SweepLine);

	      this.queue = queue;
	      this.tree = new Tree(comparator);
	      this.segments = [];
	    }

	    _createClass(SweepLine, [{
	      key: "process",
	      value: function process(event) {
	        var segment = event.segment;
	        var newEvents = []; // if we've already been consumed by another segment,
	        // clean up our body parts and get out

	        if (event.consumedBy) {
	          if (event.isLeft) this.queue.remove(event.otherSE);else this.tree.remove(segment);
	          return newEvents;
	        }

	        var node = event.isLeft ? this.tree.insert(segment) : this.tree.find(segment);
	        if (!node) throw new Error("Unable to find segment #".concat(segment.id, " ") + "[".concat(segment.leftSE.point.x, ", ").concat(segment.leftSE.point.y, "] -> ") + "[".concat(segment.rightSE.point.x, ", ").concat(segment.rightSE.point.y, "] ") + 'in SweepLine tree. Please submit a bug report.');
	        var prevNode = node;
	        var nextNode = node;
	        var prevSeg = undefined;
	        var nextSeg = undefined; // skip consumed segments still in tree

	        while (prevSeg === undefined) {
	          prevNode = this.tree.prev(prevNode);
	          if (prevNode === null) prevSeg = null;else if (prevNode.key.consumedBy === undefined) prevSeg = prevNode.key;
	        } // skip consumed segments still in tree


	        while (nextSeg === undefined) {
	          nextNode = this.tree.next(nextNode);
	          if (nextNode === null) nextSeg = null;else if (nextNode.key.consumedBy === undefined) nextSeg = nextNode.key;
	        }

	        if (event.isLeft) {
	          // Check for intersections against the previous segment in the sweep line
	          var prevMySplitter = null;

	          if (prevSeg) {
	            var prevInter = prevSeg.getIntersection(segment);

	            if (prevInter !== null) {
	              if (!segment.isAnEndpoint(prevInter)) prevMySplitter = prevInter;

	              if (!prevSeg.isAnEndpoint(prevInter)) {
	                var newEventsFromSplit = this._splitSafely(prevSeg, prevInter);

	                for (var i = 0, iMax = newEventsFromSplit.length; i < iMax; i++) {
	                  newEvents.push(newEventsFromSplit[i]);
	                }
	              }
	            }
	          } // Check for intersections against the next segment in the sweep line


	          var nextMySplitter = null;

	          if (nextSeg) {
	            var nextInter = nextSeg.getIntersection(segment);

	            if (nextInter !== null) {
	              if (!segment.isAnEndpoint(nextInter)) nextMySplitter = nextInter;

	              if (!nextSeg.isAnEndpoint(nextInter)) {
	                var _newEventsFromSplit = this._splitSafely(nextSeg, nextInter);

	                for (var _i = 0, _iMax = _newEventsFromSplit.length; _i < _iMax; _i++) {
	                  newEvents.push(_newEventsFromSplit[_i]);
	                }
	              }
	            }
	          } // For simplicity, even if we find more than one intersection we only
	          // spilt on the 'earliest' (sweep-line style) of the intersections.
	          // The other intersection will be handled in a future process().


	          if (prevMySplitter !== null || nextMySplitter !== null) {
	            var mySplitter = null;
	            if (prevMySplitter === null) mySplitter = nextMySplitter;else if (nextMySplitter === null) mySplitter = prevMySplitter;else {
	              var cmpSplitters = SweepEvent.comparePoints(prevMySplitter, nextMySplitter);
	              mySplitter = cmpSplitters <= 0 ? prevMySplitter : nextMySplitter;
	            } // Rounding errors can cause changes in ordering,
	            // so remove afected segments and right sweep events before splitting

	            this.queue.remove(segment.rightSE);
	            newEvents.push(segment.rightSE);

	            var _newEventsFromSplit2 = segment.split(mySplitter);

	            for (var _i2 = 0, _iMax2 = _newEventsFromSplit2.length; _i2 < _iMax2; _i2++) {
	              newEvents.push(_newEventsFromSplit2[_i2]);
	            }
	          }

	          if (newEvents.length > 0) {
	            // We found some intersections, so re-do the current event to
	            // make sure sweep line ordering is totally consistent for later
	            // use with the segment 'prev' pointers
	            this.tree.remove(segment);
	            newEvents.push(event);
	          } else {
	            // done with left event
	            this.segments.push(segment);
	            segment.prev = prevSeg;
	          }
	        } else {
	          // event.isRight
	          // since we're about to be removed from the sweep line, check for
	          // intersections between our previous and next segments
	          if (prevSeg && nextSeg) {
	            var inter = prevSeg.getIntersection(nextSeg);

	            if (inter !== null) {
	              if (!prevSeg.isAnEndpoint(inter)) {
	                var _newEventsFromSplit3 = this._splitSafely(prevSeg, inter);

	                for (var _i3 = 0, _iMax3 = _newEventsFromSplit3.length; _i3 < _iMax3; _i3++) {
	                  newEvents.push(_newEventsFromSplit3[_i3]);
	                }
	              }

	              if (!nextSeg.isAnEndpoint(inter)) {
	                var _newEventsFromSplit4 = this._splitSafely(nextSeg, inter);

	                for (var _i4 = 0, _iMax4 = _newEventsFromSplit4.length; _i4 < _iMax4; _i4++) {
	                  newEvents.push(_newEventsFromSplit4[_i4]);
	                }
	              }
	            }
	          }

	          this.tree.remove(segment);
	        }

	        return newEvents;
	      }
	      /* Safely split a segment that is currently in the datastructures
	       * IE - a segment other than the one that is currently being processed. */

	    }, {
	      key: "_splitSafely",
	      value: function _splitSafely(seg, pt) {
	        // Rounding errors can cause changes in ordering,
	        // so remove afected segments and right sweep events before splitting
	        // removeNode() doesn't work, so have re-find the seg
	        // https://github.com/w8r/splay-tree/pull/5
	        this.tree.remove(seg);
	        var rightSE = seg.rightSE;
	        this.queue.remove(rightSE);
	        var newEvents = seg.split(pt);
	        newEvents.push(rightSE); // splitting can trigger consumption

	        if (seg.consumedBy === undefined) this.tree.insert(seg);
	        return newEvents;
	      }
	    }]);

	    return SweepLine;
	  }();

	  var POLYGON_CLIPPING_MAX_QUEUE_SIZE = typeof process !== 'undefined' && process.env.POLYGON_CLIPPING_MAX_QUEUE_SIZE || 1000000;
	  var POLYGON_CLIPPING_MAX_SWEEPLINE_SEGMENTS = typeof process !== 'undefined' && process.env.POLYGON_CLIPPING_MAX_SWEEPLINE_SEGMENTS || 1000000;
	  var Operation = /*#__PURE__*/function () {
	    function Operation() {
	      _classCallCheck(this, Operation);
	    }

	    _createClass(Operation, [{
	      key: "run",
	      value: function run(type, geom, moreGeoms) {
	        operation.type = type;
	        rounder.reset();
	        /* Convert inputs to MultiPoly objects */

	        var multipolys = [new MultiPolyIn(geom, true)];

	        for (var i = 0, iMax = moreGeoms.length; i < iMax; i++) {
	          multipolys.push(new MultiPolyIn(moreGeoms[i], false));
	        }

	        operation.numMultiPolys = multipolys.length;
	        /* BBox optimization for difference operation
	         * If the bbox of a multipolygon that's part of the clipping doesn't
	         * intersect the bbox of the subject at all, we can just drop that
	         * multiploygon. */

	        if (operation.type === 'difference') {
	          // in place removal
	          var subject = multipolys[0];
	          var _i = 1;

	          while (_i < multipolys.length) {
	            if (getBboxOverlap(multipolys[_i].bbox, subject.bbox) !== null) _i++;else multipolys.splice(_i, 1);
	          }
	        }
	        /* BBox optimization for intersection operation
	         * If we can find any pair of multipolygons whose bbox does not overlap,
	         * then the result will be empty. */


	        if (operation.type === 'intersection') {
	          // TODO: this is O(n^2) in number of polygons. By sorting the bboxes,
	          //       it could be optimized to O(n * ln(n))
	          for (var _i2 = 0, _iMax = multipolys.length; _i2 < _iMax; _i2++) {
	            var mpA = multipolys[_i2];

	            for (var j = _i2 + 1, jMax = multipolys.length; j < jMax; j++) {
	              if (getBboxOverlap(mpA.bbox, multipolys[j].bbox) === null) return [];
	            }
	          }
	        }
	        /* Put segment endpoints in a priority queue */


	        var queue = new Tree(SweepEvent.compare);

	        for (var _i3 = 0, _iMax2 = multipolys.length; _i3 < _iMax2; _i3++) {
	          var sweepEvents = multipolys[_i3].getSweepEvents();

	          for (var _j = 0, _jMax = sweepEvents.length; _j < _jMax; _j++) {
	            queue.insert(sweepEvents[_j]);

	            if (queue.size > POLYGON_CLIPPING_MAX_QUEUE_SIZE) {
	              // prevents an infinite loop, an otherwise common manifestation of bugs
	              throw new Error('Infinite loop when putting segment endpoints in a priority queue ' + '(queue size too big). Please file a bug report.');
	            }
	          }
	        }
	        /* Pass the sweep line over those endpoints */


	        var sweepLine = new SweepLine(queue);
	        var prevQueueSize = queue.size;
	        var node = queue.pop();

	        while (node) {
	          var evt = node.key;

	          if (queue.size === prevQueueSize) {
	            // prevents an infinite loop, an otherwise common manifestation of bugs
	            var seg = evt.segment;
	            throw new Error("Unable to pop() ".concat(evt.isLeft ? 'left' : 'right', " SweepEvent ") + "[".concat(evt.point.x, ", ").concat(evt.point.y, "] from segment #").concat(seg.id, " ") + "[".concat(seg.leftSE.point.x, ", ").concat(seg.leftSE.point.y, "] -> ") + "[".concat(seg.rightSE.point.x, ", ").concat(seg.rightSE.point.y, "] from queue. ") + 'Please file a bug report.');
	          }

	          if (queue.size > POLYGON_CLIPPING_MAX_QUEUE_SIZE) {
	            // prevents an infinite loop, an otherwise common manifestation of bugs
	            throw new Error('Infinite loop when passing sweep line over endpoints ' + '(queue size too big). Please file a bug report.');
	          }

	          if (sweepLine.segments.length > POLYGON_CLIPPING_MAX_SWEEPLINE_SEGMENTS) {
	            // prevents an infinite loop, an otherwise common manifestation of bugs
	            throw new Error('Infinite loop when passing sweep line over endpoints ' + '(too many sweep line segments). Please file a bug report.');
	          }

	          var newEvents = sweepLine.process(evt);

	          for (var _i4 = 0, _iMax3 = newEvents.length; _i4 < _iMax3; _i4++) {
	            var _evt = newEvents[_i4];
	            if (_evt.consumedBy === undefined) queue.insert(_evt);
	          }

	          prevQueueSize = queue.size;
	          node = queue.pop();
	        } // free some memory we don't need anymore


	        rounder.reset();
	        /* Collect and compile segments we're keeping into a multipolygon */

	        var ringsOut = RingOut.factory(sweepLine.segments);
	        var result = new MultiPolyOut(ringsOut);
	        return result.getGeom();
	      }
	    }]);

	    return Operation;
	  }(); // singleton available by import

	  var operation = new Operation();

	  var union = function union(geom) {
	    for (var _len = arguments.length, moreGeoms = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
	      moreGeoms[_key - 1] = arguments[_key];
	    }

	    return operation.run('union', geom, moreGeoms);
	  };

	  var intersection$1 = function intersection(geom) {
	    for (var _len2 = arguments.length, moreGeoms = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
	      moreGeoms[_key2 - 1] = arguments[_key2];
	    }

	    return operation.run('intersection', geom, moreGeoms);
	  };

	  var xor = function xor(geom) {
	    for (var _len3 = arguments.length, moreGeoms = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
	      moreGeoms[_key3 - 1] = arguments[_key3];
	    }

	    return operation.run('xor', geom, moreGeoms);
	  };

	  var difference = function difference(subjectGeom) {
	    for (var _len4 = arguments.length, clippingGeoms = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
	      clippingGeoms[_key4 - 1] = arguments[_key4];
	    }

	    return operation.run('difference', subjectGeom, clippingGeoms);
	  };

	  var index = {
	    union: union,
	    intersection: intersection$1,
	    xor: xor,
	    difference: difference
	  };

	  return index;

	}))); 
} (polygonClipping_umd));

var polygonClipping_umdExports = polygonClipping_umd.exports;
var polygonClipping = /*@__PURE__*/getDefaultExportFromCjs(polygonClipping_umdExports);

/**
 * Takes two {@link Polygon|polygon} or {@link MultiPolygon|multi-polygon} geometries and
 * finds their polygonal intersection. If they don't intersect, returns null.
 *
 * @name intersect
 * @param {Feature<Polygon | MultiPolygon>} poly1 the first polygon or multipolygon
 * @param {Feature<Polygon | MultiPolygon>} poly2 the second polygon or multipolygon
 * @param {Object} [options={}] Optional Parameters
 * @param {Object} [options.properties={}] Translate GeoJSON Properties to Feature
 * @returns {Feature|null} returns a feature representing the area they share (either a {@link Polygon} or
 * {@link MultiPolygon}). If they do not share any area, returns `null`.
 * @example
 * var poly1 = turf.polygon([[
 *   [-122.801742, 45.48565],
 *   [-122.801742, 45.60491],
 *   [-122.584762, 45.60491],
 *   [-122.584762, 45.48565],
 *   [-122.801742, 45.48565]
 * ]]);
 *
 * var poly2 = turf.polygon([[
 *   [-122.520217, 45.535693],
 *   [-122.64038, 45.553967],
 *   [-122.720031, 45.526554],
 *   [-122.669906, 45.507309],
 *   [-122.723464, 45.446643],
 *   [-122.532577, 45.408574],
 *   [-122.487258, 45.477466],
 *   [-122.520217, 45.535693]
 * ]]);
 *
 * var intersection = turf.intersect(poly1, poly2);
 *
 * //addToMap
 * var addToMap = [poly1, poly2, intersection];
 */
function intersect(poly1, poly2, options) {
    if (options === void 0) { options = {}; }
    var geom1 = getGeom(poly1);
    var geom2 = getGeom(poly2);
    var intersection = polygonClipping.intersection(geom1.coordinates, geom2.coordinates);
    if (intersection.length === 0)
        return null;
    if (intersection.length === 1)
        return polygon(intersection[0], options.properties);
    return multiPolygon(intersection, options.properties);
}

/**
 * Discard invocations that take less than the specified time between output
 * (latest invocation is made if duration has been passed and no new invocations made to decorated method)
 * This mimics the behaviour of rxjs debounceTime: https://www.learnrxjs.io/learn-rxjs/operators/filtering/debouncetime but via decorator
 *
 * @param duration debounce time interval duration in milliseconds
 */
/**
 * Emit first value then ignore for specified duration
 * This mimics the behaviour of rxjs throttleTime: https://www.learnrxjs.io/learn-rxjs/operators/filtering/throttletime but via decorator
 *
 * @param duration throttle time interval duration in milliseconds
 */
var throttleTime = function (duration) { return function (target, propertyKey, descriptor) {
    var originalMethod = descriptor.value;
    var shouldCancel = new Map();
    descriptor.value = function () {
        var context = this;
        var args = arguments;
        var cancel = shouldCancel.get(context) || false;
        if (!cancel) {
            originalMethod.apply(context, args);
            shouldCancel.set(context, true);
            // tslint:disable-next-line: no-string-based-set-timeout
            setTimeout(function () { return shouldCancel.delete(context); }, duration);
        }
    };
    return descriptor;
}; };

var __decorate = (window && window.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __read$a = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$8 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var allowedAttributionTags = [
    'DIV',
    'SPAN',
    'A'
];
var attributionRuleAttributes = [
    'data-azure-maps-attribution-minzoom',
    'data-azure-maps-attribution-maxzoom',
    'data-azure-maps-attribution-geometry',
    'data-azure-maps-attribution-tileset',
    'data-azure-maps-attribution-order',
    'data-azure-maps-attribution-dynamic'
];
var allowedAttributionAttributes = __spreadArray$8([
    'href'
], __read$a(attributionRuleAttributes), false);
var AttributionRuleProxy = /** @class */ (function () {
    function AttributionRuleProxy(element, attributionChangeCallback) {
        var _this = this;
        this.lastFetchState = {
            bounds: null,
            zoom: null
        };
        this.getElement = function () { return _this.element; };
        this.element = element;
        this.attributionChangeCallback = attributionChangeCallback;
    }
    /** Whether one rule equals another: this doesn't imply the equivalence in terms of attribution, while rules can be the same, the content inside might differ */
    AttributionRuleProxy.prototype.equals = function (other) {
        return this.stringRepresentation === other.stringRepresentation;
    };
    Object.defineProperty(AttributionRuleProxy.prototype, "stringRepresentation", {
        get: function () {
            // NOTE: order is not included here as it does not affect the attribution rule
            return [
                this.minZoom !== undefined ? "minzoom=".concat(this.minZoom) : '',
                this.maxZoom !== undefined ? "maxzoom=".concat(this.maxZoom) : '',
                this.geometry !== undefined ? this.element.attributes.getNamedItem('data-azure-maps-attribution-geometry').value : '',
                this.tilesetId !== undefined ? "tilesetId=".concat(this.tilesetId) : '',
                this.dynamic ? "dynamic" : ''
            ].filter(function (comp) { return comp.length > 0; }).join(';');
        },
        enumerable: false,
        configurable: true
    });
    /** checks whether attribution rule is used on an element: i.e: whether element contains at least one attribution property */
    AttributionRuleProxy.applicable = function (element) {
        return Array.from(element.attributes)
            .map(function (attr) { return attributionRuleAttributes.includes(attr.name); })
            .reduce(function (atLeastOneRuleAttribute, includes) { return atLeastOneRuleAttribute || includes; }, false);
    };
    Object.defineProperty(AttributionRuleProxy.prototype, "minZoom", {
        /** The HTML anchor describing an attribution zone that includes minzoom and maxzoom will be scoped to that range */
        get: function () {
            var attr = this.element.attributes.getNamedItem('data-azure-maps-attribution-minzoom');
            return attr && !isNaN(attr.value) ? parseInt(attr.value) : undefined;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AttributionRuleProxy.prototype, "maxZoom", {
        /** The HTML anchor describing an attribution zone that includes minzoom and maxzoom will be scoped to that range */
        get: function () {
            var attr = this.element.attributes.getNamedItem('data-azure-maps-attribution-maxzoom');
            return attr && !isNaN(attr.value) ? parseInt(attr.value) : undefined;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AttributionRuleProxy.prototype, "geometry", {
        /** The HTML anchor describing an attribution zone that includes a GeoJSON geometry will be scoped to that area. */
        get: function () {
            var attr = this.element.attributes.getNamedItem('data-azure-maps-attribution-geometry');
            if (attr && attr.value) {
                try {
                    var json = JSON.parse(attr.value);
                    return json;
                }
                catch (e) {
                    // SyntaxError
                    return undefined;
                }
            }
            else {
                return undefined;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AttributionRuleProxy.prototype, "tilesetId", {
        /** Attribution associated tilesetId, used for dynamic attribution requests */
        get: function () {
            var attr = this.element.attributes.getNamedItem('data-azure-maps-attribution-tileset');
            return attr && attr.value ? attr.value : undefined;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AttributionRuleProxy.prototype, "order", {
        /** the position of attribution message */
        get: function () {
            var attr = this.element.attributes.getNamedItem('data-azure-maps-attribution-order');
            return attr && !isNaN(attr.value) ? parseInt(attr.value) : undefined;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AttributionRuleProxy.prototype, "dynamic", {
        /**
         * The HTML anchor text is ignored, instead the tilesetId will be used to call the tile metadata service to determine attribution based on the current map view.
         * Supplants minzoom, maxzoom, and geometry attributes.
         */
        get: function () {
            return this.element.attributes.getNamedItem('data-azure-maps-attribution-dynamic') !== null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AttributionRuleProxy.prototype, "hidesElement", {
        /** whether the underlying element is hidden */
        get: function () {
            return this.element.style.display == 'none';
        },
        enumerable: false,
        configurable: true
    });
    /** hides the underlying element */
    AttributionRuleProxy.prototype.forceHide = function () {
        this.element.style.display = 'none';
    };
    /**
     * Checks whether the provided camera state satisfies this rule
     *
     * @param camera current state of map control camera: map.getCamera()
     * @returns
     */
    AttributionRuleProxy.prototype.satisfied = function (camera) {
        var satisfiesMinZoom = this.minZoom && camera.zoom ? camera.zoom >= this.minZoom : true;
        var satisfiesMaxZoom = this.maxZoom && camera.zoom ? camera.zoom <= this.maxZoom : true;
        var satisfiesGeometry = true;
        if (this.geometry && camera.bounds) {
            var geometry = {
                type: 'Feature',
                geometry: this.geometry,
                properties: {}
            };
            var viewport = {
                type: 'Feature',
                geometry: {
                    type: 'Polygon',
                    coordinates: [[
                            BoundingBox.getNorthWest(camera.bounds),
                            BoundingBox.getNorthEast(camera.bounds),
                            BoundingBox.getSouthEast(camera.bounds),
                            BoundingBox.getSouthWest(camera.bounds),
                            BoundingBox.getNorthWest(camera.bounds)
                        ]]
                },
                properties: {}
            };
            satisfiesGeometry = intersect(geometry, viewport) !== null;
        }
        return satisfiesMinZoom && satisfiesMaxZoom && satisfiesGeometry;
    };
    /**
     * Applies the rule to the underlying attribution element
     *
     * @param map map control
     * @param event original event that triggered this apply call
     * returns whether any dom modification were made
     */
    AttributionRuleProxy.prototype.apply = function (map, event) {
        var _this = this;
        if (event === void 0) { event = null; }
        var satisfied = this.satisfied(map.getCamera());
        var willFetch = this.dynamic && this.tilesetId;
        var hidesElement = this.hidesElement;
        // wait for map idle event if call was triggered from dragend / zoomend / pitchend
        var shouldFetchOnMapIdle = event && ['dragend', 'zoomend', 'pitchend'].includes(event.type);
        if (!satisfied && !hidesElement) {
            this.element.style.display = 'none';
        }
        else if (satisfied && (hidesElement || willFetch)) {
            if (satisfied && hidesElement) {
                this.element.style.removeProperty('display');
            }
            if (willFetch) {
                if (shouldFetchOnMapIdle) {
                    map.events.addOnce('idle', function (event) { return _this.fetchAndApplyDynamicAttribution(map); });
                }
                else {
                    this.fetchAndApplyDynamicAttribution(map);
                }
            }
        }
        return satisfied === hidesElement;
    };
    AttributionRuleProxy.prototype.fetchAndApplyDynamicAttribution = function (map) {
        var _this = this;
        var camera = map.getCamera();
        if (this.lastFetchState && BoundingBox.containsBoundingBox(this.lastFetchState.bounds, camera.bounds) && Math.floor(this.lastFetchState.zoom) == Math.floor(camera.zoom)) {
            // viewport is fully contained in the area used in previous attribution request, and zoom level hasn't changed, do nothing
            return;
        }
        var attributionEndpointOrigin = 'https://{{azMapsDomain}}';
        // expand the viewport bounding box and fetch attribution for a larger area, use expanded viewport to filter out subsequent calls if viewport is fully contained 
        var expSouthWest = interpolate(camera.center, BoundingBox.getSouthWest(camera.bounds), AttributionRuleProxy.viewportBufferExpansionRatio);
        var expNorthEast = interpolate(camera.center, BoundingBox.getNorthEast(camera.bounds), AttributionRuleProxy.viewportBufferExpansionRatio);
        var antimeridianAdjusted = (expNorthEast[0] < expSouthWest[0])
            // west, south, east, north
            ? [[expSouthWest[0], expSouthWest[1], 180.0, expNorthEast[1]], [-180.0, expSouthWest[1], expNorthEast[0], expNorthEast[1]]]
            : [[expSouthWest[0], expSouthWest[1], expNorthEast[0], expNorthEast[1]]];
        var requests = antimeridianAdjusted.map(function (bbox) {
            var params = new URLSearchParams({
                'api-version': '2.1',
                tilesetId: _this.tilesetId,
                zoom: camera.zoom !== undefined ? "".concat(Math.floor(camera.zoom)) : undefined,
                bounds: bbox.join(',')
            });
            var attributionUrl = "".concat(attributionEndpointOrigin, "/map/attribution");
            var toReplace = { url: attributionUrl, headers: {} };
            map._substituteDomainLanguageViewAndSignInRequest(attributionUrl, toReplace);
            var targetUrl = "".concat(toReplace.url).concat(toReplace.url.includes('?') ? '&' : '?').concat(params.toString());
            return map._sendRequest(targetUrl, 'Attribution', toReplace.headers).then(function (response) { return response.json(); });
        });
        Promise.all(requests).then(function (response) {
            _this.applyAttributionResponse(response);
            _this.lastFetchState = {
                bounds: new BoundingBox([expSouthWest[0], expSouthWest[1], expNorthEast[0], expNorthEast[1]]),
                zoom: camera.zoom
            };
        })
            // TODO: any specific error formatting here?
            .catch(function (error) { return console.error(error); });
    };
    AttributionRuleProxy.prototype.applyAttributionResponse = function (attributions) {
        var _this = this;
        var copyrights = attributions.map(function (resp) { return resp.copyrights || []; }).reduce(function (flat, copyrights) { return __spreadArray$8(__spreadArray$8([], __read$a(flat), false), __read$a(copyrights), false); }, []);
        if (copyrights.length == 0) {
            // no attribution for a provided tileset/bbox/z
            return;
        }
        var target = Html.parseWithFilter(copyrights.join(''), function (elem) { return true; }, function (elem) { return elem; }, 
        // use current element as the grouping element for attribution, drop existing content
        function () {
            _this.element.innerHTML = '';
            return _this.element;
        });
        if (target === null) {
            // attribution was filtered out
            console.warn('Dynamic attribution is empty after filtering');
            return;
        }
        var newAttribution = typeof target === 'string'
            ? (function () { var e = document.createElement('span'); e.innerHTML = target; return e; })()
            : target;
        var newRuleElement;
        // handles multiple attributions wrapped into current element
        if (newAttribution === this.element) {
            // use a span element to group multiple (likely anchors)
            // this will replace current rule element to ensure consistent behavior (we don't want to add child nodes to anchors etc)
            var container_1 = document.createElement('span');
            Array.from(this.element.childNodes).forEach(function (node) { return container_1.appendChild(node); });
            newRuleElement = container_1;
        }
        else {
            newRuleElement = newAttribution;
        }
        // reassign all rule attributes to preserve state
        Array.from(this.element.attributes).filter(function (attrib) { return attributionRuleAttributes.includes(attrib.name); }).forEach(function (attrib) {
            return newRuleElement.attributes.setNamedItem(attrib.cloneNode());
        });
        newRuleElement.style.display = this.element.style.display;
        var parent = this.element.parentElement;
        this.element.remove();
        parent.append(newRuleElement);
        this.element = newRuleElement;
        this.attributionChangeCallback(this);
    };
    AttributionRuleProxy.viewportBufferExpansionRatio = 2;
    __decorate([
        throttleTime(1000)
    ], AttributionRuleProxy.prototype, "fetchAndApplyDynamicAttribution", null);
    return AttributionRuleProxy;
}());

var __read$9 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$7 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
// contains phrases that should be filtered out from all attribution content
var attributionFilters = [
    /all rights reserved/gi
];
var CopyrightDelegate = /** @class */ (function () {
    function CopyrightDelegate(map, copyrightControl, options) {
        var _this = this;
        this.rules = [];
        /**
         * represents the source of truth for parsed aggregated attribution markup without any filtering, text deduplication
         * this gets hidden/on/off mutated as rules come into play.
         */
        this.virtualContext = (function () {
            var elem = document.createElement('span');
            elem.className = 'azure-map-copyright-context';
            return elem;
        })();
        /**
         * represents the actual DOM that gets attached to the copyright control
         * a clone of virtual context with textual nodes redacted
         */
        this.renderContext = this.virtualContext.cloneNode(false);
        this.addAttributionFromSource = function (source) {
            //FundamentalMapSources are handled on style.load
        };
        this.removeAttributionFromSource = function (source) {
            //FundamentalMapSources are handled on style.load
        };
        this.getMapStyleVisibleSources = function () {
            var map = _this.map._getMap();
            var style = map.getStyle();
            return Object.entries(style.sources)
                .filter(function (_a) {
                var _b = __read$9(_a, 1), key = _b[0];
                return style.layers
                    .filter(function (layer) { return layer && layer['source'] == key; })
                    .reduce(function (isVisible, layer) {
                    var isLayerHidden = (layer["layout"] && layer["layout"].visibility === "none") || layer["paint"] && (layer["paint"]["icon-opacity"] === 0 && layer["paint"]["text-opacity"] === 0);
                    return !isLayerHidden || isVisible;
                }, false);
            }).map(function (_a) {
                var _b = __read$9(_a, 1), key = _b[0];
                return map.getSource(key);
            });
        };
        this.loadAttributionOnceSourcesLoaded = function () {
            var sources = _this.getMapStyleVisibleSources();
            Promise.all(sources.map(function (source) { return new Promise(function (resolve, reject) {
                if ('tiles' in source || (source === null || source === void 0 ? void 0 : source.type) === 'geojson') {
                    resolve(source);
                    // TileJSON source may yet be unresolved
                }
                else {
                    var unresolved_1 = source;
                    unresolved_1.on('data', function sourceDataListener(event) {
                        if (event.sourceDataType == 'metadata') {
                            unresolved_1.off('data', sourceDataListener);
                            resolve(source);
                        }
                    });
                    unresolved_1.on('error', function tilejsonLoadError(event) {
                        unresolved_1.off('error', tilejsonLoadError);
                        reject(event);
                    });
                }
            })
                // mimics https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/allSettled 
                // until wider availability (https://caniuse.com/?search=allSettled)
                .then(function (source) { return ({ status: 'fulfilled', value: source }); })
                .catch(function (error) { return ({ status: 'rejected', reason: error }); }); })).then(function (loadResults) {
                // reload attribution no matter tilejson loaded gracefully or errored
                _this.reloadAttribution();
            });
        };
        /**
         * @internal
         */
        this.reloadAttribution = function () {
            var sources = _this.getMapStyleVisibleSources();
            // keep track of all rules as well as registered to determine redundant rules that won't get applied.
            // a rule is considered redundant when it is has same rule attributes(excluding order) as well as endpoints
            // a rule with the minimum order will be picked 
            var allRules = new Set();
            var registeredRules = {};
            var attributions = sources
                // also ignore sources that don't specify tile endpoints
                .filter(function (source) { return 'attribution' in source && source.attribution && 'tiles' in source && source['tiles'] instanceof Array && source['tiles'].length > 0; })
                .map(function (source) {
                var _a;
                return Html.parseWithFilter((_a = source.attribution) !== null && _a !== void 0 ? _a : "", function (elem) { return allowedAttributionTags.includes(elem.tagName)
                    && Array.from(elem.attributes).map(function (attr) { return allowedAttributionAttributes.includes(attr.name); }).reduce(function (allAllowed, inclAllowed) { return allAllowed && inclAllowed; }, true); }, function (elem) {
                    // effect: register rules for elements with at least one rule attribute 
                    // and add flexbox order attribute if order is set
                    var rule = null;
                    if (elem instanceof HTMLElement && AttributionRuleProxy.applicable(elem)) {
                        // NOTE: the first tile endpoint will be used to derive the base url for dynamic attribution requests
                        rule = new AttributionRuleProxy(elem, function () { return _this.renderAttribution(); });
                        allRules.add(rule);
                        if (rule.order !== undefined) {
                            elem.style.order = "".concat(rule.order);
                        }
                    }
                    if (rule && elem instanceof HTMLElement) {
                        var ruleKey = rule.stringRepresentation;
                        if (!(ruleKey in registeredRules)) {
                            registeredRules[ruleKey] = rule;
                            // equivalent rules: prefer the lowest order rule
                        }
                        else if ((rule.order !== undefined && registeredRules[ruleKey].order !== undefined && rule.order < registeredRules[ruleKey].order ||
                            rule.order !== undefined && registeredRules[ruleKey].order === undefined)) {
                            registeredRules[ruleKey] = rule;
                        }
                    }
                    return elem;
                }, function () { return document.createElement('span'); });
            });
            var registeredRuleSet = new Set(Object.values(registeredRules));
            var redundantRules = new Set(__spreadArray$7([], __read$9(allRules), false).filter(function (rule) { return !registeredRuleSet.has(rule); }));
            var redundantElements = new Set(__spreadArray$7([], __read$9(redundantRules), false).map(function (rule) { return rule.getElement(); }));
            // eject redundant rules associated elements altogether
            __spreadArray$7([], __read$9(redundantElements), false).filter(function (elem) { return elem.parentElement !== null; })
                .forEach(function (elem) { return elem.parentElement.removeChild(elem); });
            _this.rules = Object.values(registeredRules);
            var attributionsToApply = attributions
                .filter(function (attribution) { return typeof attribution === 'string' || !redundantElements.has(attribution); })
                .map(function (attribution) { return typeof (attribution) === 'string' ? new Text(attribution) : attribution; });
            var virtualContext = document.createElement('span');
            if (attributionsToApply.length > 0) {
                attributionsToApply.forEach(function (attribution) { return virtualContext.appendChild(attribution); });
            }
            else {
                _this.getDefaultAttribution().forEach(function (attribution) { return virtualContext.appendChild(attribution); });
            }
            _this.virtualContext = virtualContext;
            _this.copyrightControl.setOptions({
                copyrightContent: _this.renderContext
            });
            _this.applyRules();
            _this.renderAttribution();
        };
        this.applyRules = function (mapEvent) {
            if (mapEvent === void 0) { mapEvent = null; }
            var hasDOMChanges = _this.rules.reduce(function (hasDomChanges, rule) {
                var ruleChangedDOM = rule.apply(_this.map, mapEvent);
                return hasDomChanges || ruleChangedDOM;
            }, false);
            if (hasDOMChanges)
                (_this.renderAttribution());
        };
        /**
         * clones virtual context, reduces textual nodes for visual purposes (dedups years, common phrases) and sets the actual rendered context
         */
        this.renderAttribution = function () {
            var visibleTextNodes = function (elem) {
                return Array.from(elem.style.display != 'none' ? elem.children : [])
                    .map(function (elem) { return visibleTextNodes(elem); })
                    .reduce(function (flattened, nodes) { return __spreadArray$7(__spreadArray$7([], __read$9(flattened), false), __read$9(nodes), false); }, Array.from(elem.style.display != 'none' ? elem.childNodes : []).filter(function (node) { return node.nodeType == node.TEXT_NODE; }));
            };
            var newRenderContext = _this.virtualContext.cloneNode(true);
            var visibleNodes = visibleTextNodes(newRenderContext);
            // Do not extract years for now
            // Just deduplicate full matches
            //
            // const years = new Set<number>();
            // visibleNodes.forEach(node => { 
            //     let match: RegExpExecArray | null = null
            //     while((match = copyrightYearPattern.exec(node.textContent)) != null){
            //         years.add(parseInt(match[1])) 
            //     }
            // });
            // strip all predefined keywords 
            visibleNodes.forEach(function (node) { return node.textContent = __spreadArray$7([], __read$9(attributionFilters), false).reduce(function (target, filter) { return target.replace(filter, '').trim(); }, node.textContent); });
            // strip year from each node
            // visibleNodes.forEach(node => node.textContent = node.textContent.replace(copyrightYearPattern, '').trim());
            // deduplicate attribution text
            visibleNodes.reduce(function (attributions, node) {
                if (attributions.has(node.textContent)) {
                    node.textContent = '';
                    if (node.parentElement) {
                        node.parentElement.removeChild(node);
                    }
                }
                else {
                    attributions.add(node.textContent);
                }
                return attributions;
            }, new Set());
            _this.renderContext.innerHTML = '';
            // don't use this.renderContext.innerHTML = newRenderContext.innerHTML
            // as original dom structure might be changed
            Array.from(newRenderContext.childNodes).forEach(function (node) { return _this.renderContext.appendChild(node); });
            // add years text node as the first text node in render context 
            // to make sure flexbox order has no effect on where copyright years will appear
            // if(years.size > 0){
            //     const yearsNode = new Text(`©${[...years].sort((lhs, rhs) => lhs - rhs).join(',')}`);
            //     if(this.renderContext.children.length > 0){
            //         this.renderContext.insertBefore(yearsNode, this.renderContext.children[0])
            //     } else {
            //         this.renderContext.appendChild(yearsNode);
            //     }
            // }
        };
        this.map = map;
        this.copyrightControl = copyrightControl;
        this.options = options;
    }
    CopyrightDelegate.prototype.addToMap = function () {
        this.map.events.add('stylechanged', this.loadAttributionOnceSourcesLoaded);
        // this.map.events.add('sourceadded', this.addAttributionFromSource);
        // this.map.events.add('sourceremoved', this.removeAttributionFromSource);
        this.map.events.add('dragend', this.applyRules);
        this.map.events.add('zoomend', this.applyRules);
        this.map.events.add('pitchend', this.applyRules);
    };
    CopyrightDelegate.prototype.removeFromMap = function () {
        this.map.events.remove('stylechanged', this.loadAttributionOnceSourcesLoaded);
        // this.map.events.remove('sourceadded', this.addAttributionFromSource);
        // this.map.events.remove('sourceremoved', this.removeAttributionFromSource);
        this.map.events.remove('dragend', this.applyRules);
        this.map.events.remove('zoomend', this.applyRules);
        this.map.events.remove('pitchend', this.applyRules);
    };
    /**
     * Gets the default fallback copyright caption
     */
    CopyrightDelegate.prototype.getDefaultAttribution = function () {
        var anchor = function (content) {
            var elem = document.createElement('a');
            elem.textContent = content;
            return elem;
        };
        return this.copyrightControl.getDefaultAttributions().map(function (copyright) { return anchor(copyright); });
    };
    return CopyrightDelegate;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics$1 = function(d, b) {
    extendStatics$1 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics$1(d, b);
};

function __extends$g(d, b) {
    extendStatics$1(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign$5 = function() {
    __assign$5 = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign$5.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter$3(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator$3(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __read$8(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read$8(arguments[i]));
    return ar;
}

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends$f(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign$4 = function() {
    __assign$4 = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign$4.apply(this, arguments);
};

function __awaiter$2(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator$2(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var Constants = {
    LIBRARY_NAME: "MSAL.JS",
    SKU: "msal.js.common",
    // Prefix for all library cache entries
    CACHE_PREFIX: "msal",
    // default authority
    DEFAULT_AUTHORITY: "https://login.microsoftonline.com/common/",
    DEFAULT_AUTHORITY_HOST: "login.microsoftonline.com",
    DEFAULT_COMMON_TENANT: "common",
    // ADFS String
    ADFS: "adfs",
    DSTS: "dstsv2",
    // Default AAD Instance Discovery Endpoint
    AAD_INSTANCE_DISCOVERY_ENDPT: "https://login.microsoftonline.com/common/discovery/instance?api-version=1.1&authorization_endpoint=",
    // CIAM URL
    CIAM_AUTH_URL: ".ciamlogin.com",
    AAD_TENANT_DOMAIN_SUFFIX: ".onmicrosoft.com",
    // Resource delimiter - used for certain cache entries
    RESOURCE_DELIM: "|",
    // Placeholder for non-existent account ids/objects
    NO_ACCOUNT: "NO_ACCOUNT",
    // Claims
    CLAIMS: "claims",
    // Consumer UTID
    CONSUMER_UTID: "9188040d-6c67-4c5b-b112-36a304b66dad",
    // Default scopes
    OPENID_SCOPE: "openid",
    PROFILE_SCOPE: "profile",
    OFFLINE_ACCESS_SCOPE: "offline_access",
    EMAIL_SCOPE: "email",
    // Default response type for authorization code flow
    CODE_RESPONSE_TYPE: "code",
    CODE_GRANT_TYPE: "authorization_code",
    RT_GRANT_TYPE: "refresh_token",
    FRAGMENT_RESPONSE_MODE: "fragment",
    S256_CODE_CHALLENGE_METHOD: "S256",
    URL_FORM_CONTENT_TYPE: "application/x-www-form-urlencoded;charset=utf-8",
    AUTHORIZATION_PENDING: "authorization_pending",
    NOT_DEFINED: "not_defined",
    EMPTY_STRING: "",
    NOT_APPLICABLE: "N/A",
    FORWARD_SLASH: "/",
    IMDS_ENDPOINT: "http://169.254.169.254/metadata/instance/compute/location",
    IMDS_VERSION: "2020-06-01",
    IMDS_TIMEOUT: 2000,
    AZURE_REGION_AUTO_DISCOVER_FLAG: "TryAutoDetect",
    REGIONAL_AUTH_PUBLIC_CLOUD_SUFFIX: "login.microsoft.com",
    REGIONAL_AUTH_NON_MSI_QUERY_STRING: "allowestsrnonmsi=true",
    KNOWN_PUBLIC_CLOUDS: ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"],
    TOKEN_RESPONSE_TYPE: "token",
    ID_TOKEN_RESPONSE_TYPE: "id_token",
    SHR_NONCE_VALIDITY: 240,
    INVALID_INSTANCE: "invalid_instance",
};
var OIDC_DEFAULT_SCOPES = [
    Constants.OPENID_SCOPE,
    Constants.PROFILE_SCOPE,
    Constants.OFFLINE_ACCESS_SCOPE
];
var OIDC_SCOPES = __spreadArrays(OIDC_DEFAULT_SCOPES, [
    Constants.EMAIL_SCOPE
]);
/**
 * Request header names
 */
var HeaderNames;
(function (HeaderNames) {
    HeaderNames["CONTENT_TYPE"] = "Content-Type";
    HeaderNames["RETRY_AFTER"] = "Retry-After";
    HeaderNames["CCS_HEADER"] = "X-AnchorMailbox";
    HeaderNames["WWWAuthenticate"] = "WWW-Authenticate";
    HeaderNames["AuthenticationInfo"] = "Authentication-Info";
    HeaderNames["X_MS_REQUEST_ID"] = "x-ms-request-id";
    HeaderNames["X_MS_HTTP_VERSION"] = "x-ms-httpver";
})(HeaderNames || (HeaderNames = {}));
/**
 * Persistent cache keys MSAL which stay while user is logged in.
 */
var PersistentCacheKeys;
(function (PersistentCacheKeys) {
    PersistentCacheKeys["ID_TOKEN"] = "idtoken";
    PersistentCacheKeys["CLIENT_INFO"] = "client.info";
    PersistentCacheKeys["ADAL_ID_TOKEN"] = "adal.idtoken";
    PersistentCacheKeys["ERROR"] = "error";
    PersistentCacheKeys["ERROR_DESC"] = "error.description";
    PersistentCacheKeys["ACTIVE_ACCOUNT"] = "active-account";
    PersistentCacheKeys["ACTIVE_ACCOUNT_FILTERS"] = "active-account-filters"; // new cache entry for active_account for a more robust version for browser
})(PersistentCacheKeys || (PersistentCacheKeys = {}));
/**
 * String constants related to AAD Authority
 */
var AADAuthorityConstants;
(function (AADAuthorityConstants) {
    AADAuthorityConstants["COMMON"] = "common";
    AADAuthorityConstants["ORGANIZATIONS"] = "organizations";
    AADAuthorityConstants["CONSUMERS"] = "consumers";
})(AADAuthorityConstants || (AADAuthorityConstants = {}));
/**
 * Keys in the hashParams sent by AAD Server
 */
var AADServerParamKeys;
(function (AADServerParamKeys) {
    AADServerParamKeys["CLIENT_ID"] = "client_id";
    AADServerParamKeys["REDIRECT_URI"] = "redirect_uri";
    AADServerParamKeys["RESPONSE_TYPE"] = "response_type";
    AADServerParamKeys["RESPONSE_MODE"] = "response_mode";
    AADServerParamKeys["GRANT_TYPE"] = "grant_type";
    AADServerParamKeys["CLAIMS"] = "claims";
    AADServerParamKeys["SCOPE"] = "scope";
    AADServerParamKeys["ERROR"] = "error";
    AADServerParamKeys["ERROR_DESCRIPTION"] = "error_description";
    AADServerParamKeys["ACCESS_TOKEN"] = "access_token";
    AADServerParamKeys["ID_TOKEN"] = "id_token";
    AADServerParamKeys["REFRESH_TOKEN"] = "refresh_token";
    AADServerParamKeys["EXPIRES_IN"] = "expires_in";
    AADServerParamKeys["STATE"] = "state";
    AADServerParamKeys["NONCE"] = "nonce";
    AADServerParamKeys["PROMPT"] = "prompt";
    AADServerParamKeys["SESSION_STATE"] = "session_state";
    AADServerParamKeys["CLIENT_INFO"] = "client_info";
    AADServerParamKeys["CODE"] = "code";
    AADServerParamKeys["CODE_CHALLENGE"] = "code_challenge";
    AADServerParamKeys["CODE_CHALLENGE_METHOD"] = "code_challenge_method";
    AADServerParamKeys["CODE_VERIFIER"] = "code_verifier";
    AADServerParamKeys["CLIENT_REQUEST_ID"] = "client-request-id";
    AADServerParamKeys["X_CLIENT_SKU"] = "x-client-SKU";
    AADServerParamKeys["X_CLIENT_VER"] = "x-client-VER";
    AADServerParamKeys["X_CLIENT_OS"] = "x-client-OS";
    AADServerParamKeys["X_CLIENT_CPU"] = "x-client-CPU";
    AADServerParamKeys["X_CLIENT_CURR_TELEM"] = "x-client-current-telemetry";
    AADServerParamKeys["X_CLIENT_LAST_TELEM"] = "x-client-last-telemetry";
    AADServerParamKeys["X_MS_LIB_CAPABILITY"] = "x-ms-lib-capability";
    AADServerParamKeys["X_APP_NAME"] = "x-app-name";
    AADServerParamKeys["X_APP_VER"] = "x-app-ver";
    AADServerParamKeys["POST_LOGOUT_URI"] = "post_logout_redirect_uri";
    AADServerParamKeys["ID_TOKEN_HINT"] = "id_token_hint";
    AADServerParamKeys["DEVICE_CODE"] = "device_code";
    AADServerParamKeys["CLIENT_SECRET"] = "client_secret";
    AADServerParamKeys["CLIENT_ASSERTION"] = "client_assertion";
    AADServerParamKeys["CLIENT_ASSERTION_TYPE"] = "client_assertion_type";
    AADServerParamKeys["TOKEN_TYPE"] = "token_type";
    AADServerParamKeys["REQ_CNF"] = "req_cnf";
    AADServerParamKeys["OBO_ASSERTION"] = "assertion";
    AADServerParamKeys["REQUESTED_TOKEN_USE"] = "requested_token_use";
    AADServerParamKeys["ON_BEHALF_OF"] = "on_behalf_of";
    AADServerParamKeys["FOCI"] = "foci";
    AADServerParamKeys["CCS_HEADER"] = "X-AnchorMailbox";
    AADServerParamKeys["RETURN_SPA_CODE"] = "return_spa_code";
    AADServerParamKeys["NATIVE_BROKER"] = "nativebroker";
    AADServerParamKeys["LOGOUT_HINT"] = "logout_hint";
})(AADServerParamKeys || (AADServerParamKeys = {}));
/**
 * Claims request keys
 */
var ClaimsRequestKeys;
(function (ClaimsRequestKeys) {
    ClaimsRequestKeys["ACCESS_TOKEN"] = "access_token";
    ClaimsRequestKeys["XMS_CC"] = "xms_cc";
})(ClaimsRequestKeys || (ClaimsRequestKeys = {}));
/**
 * we considered making this "enum" in the request instead of string, however it looks like the allowed list of
 * prompt values kept changing over past couple of years. There are some undocumented prompt values for some
 * internal partners too, hence the choice of generic "string" type instead of the "enum"
 */
var PromptValue = {
    LOGIN: "login",
    SELECT_ACCOUNT: "select_account",
    CONSENT: "consent",
    NONE: "none",
    CREATE: "create",
    NO_SESSION: "no_session"
};
/**
 * SSO Types - generated to populate hints
 */
var SSOTypes;
(function (SSOTypes) {
    SSOTypes["ACCOUNT"] = "account";
    SSOTypes["SID"] = "sid";
    SSOTypes["LOGIN_HINT"] = "login_hint";
    SSOTypes["ID_TOKEN"] = "id_token";
    SSOTypes["DOMAIN_HINT"] = "domain_hint";
    SSOTypes["ORGANIZATIONS"] = "organizations";
    SSOTypes["CONSUMERS"] = "consumers";
    SSOTypes["ACCOUNT_ID"] = "accountIdentifier";
    SSOTypes["HOMEACCOUNT_ID"] = "homeAccountIdentifier";
})(SSOTypes || (SSOTypes = {}));
/**
 * allowed values for codeVerifier
 */
var CodeChallengeMethodValues = {
    PLAIN: "plain",
    S256: "S256"
};
/**
 * allowed values for response_mode
 */
var ResponseMode;
(function (ResponseMode) {
    ResponseMode["QUERY"] = "query";
    ResponseMode["FRAGMENT"] = "fragment";
    ResponseMode["FORM_POST"] = "form_post";
})(ResponseMode || (ResponseMode = {}));
/**
 * allowed grant_type
 */
var GrantType;
(function (GrantType) {
    GrantType["IMPLICIT_GRANT"] = "implicit";
    GrantType["AUTHORIZATION_CODE_GRANT"] = "authorization_code";
    GrantType["CLIENT_CREDENTIALS_GRANT"] = "client_credentials";
    GrantType["RESOURCE_OWNER_PASSWORD_GRANT"] = "password";
    GrantType["REFRESH_TOKEN_GRANT"] = "refresh_token";
    GrantType["DEVICE_CODE_GRANT"] = "device_code";
    GrantType["JWT_BEARER"] = "urn:ietf:params:oauth:grant-type:jwt-bearer";
})(GrantType || (GrantType = {}));
/**
 * Account types in Cache
 */
var CacheAccountType;
(function (CacheAccountType) {
    CacheAccountType["MSSTS_ACCOUNT_TYPE"] = "MSSTS";
    CacheAccountType["ADFS_ACCOUNT_TYPE"] = "ADFS";
    CacheAccountType["MSAV1_ACCOUNT_TYPE"] = "MSA";
    CacheAccountType["GENERIC_ACCOUNT_TYPE"] = "Generic"; // NTLM, Kerberos, FBA, Basic etc
})(CacheAccountType || (CacheAccountType = {}));
/**
 * Separators used in cache
 */
var Separators;
(function (Separators) {
    Separators["CACHE_KEY_SEPARATOR"] = "-";
    Separators["CLIENT_INFO_SEPARATOR"] = ".";
})(Separators || (Separators = {}));
/**
 * Credential Type stored in the cache
 */
var CredentialType;
(function (CredentialType) {
    CredentialType["ID_TOKEN"] = "IdToken";
    CredentialType["ACCESS_TOKEN"] = "AccessToken";
    CredentialType["ACCESS_TOKEN_WITH_AUTH_SCHEME"] = "AccessToken_With_AuthScheme";
    CredentialType["REFRESH_TOKEN"] = "RefreshToken";
})(CredentialType || (CredentialType = {}));
/**
 * Combine all cache types
 */
var CacheType;
(function (CacheType) {
    CacheType[CacheType["ADFS"] = 1001] = "ADFS";
    CacheType[CacheType["MSA"] = 1002] = "MSA";
    CacheType[CacheType["MSSTS"] = 1003] = "MSSTS";
    CacheType[CacheType["GENERIC"] = 1004] = "GENERIC";
    CacheType[CacheType["ACCESS_TOKEN"] = 2001] = "ACCESS_TOKEN";
    CacheType[CacheType["REFRESH_TOKEN"] = 2002] = "REFRESH_TOKEN";
    CacheType[CacheType["ID_TOKEN"] = 2003] = "ID_TOKEN";
    CacheType[CacheType["APP_METADATA"] = 3001] = "APP_METADATA";
    CacheType[CacheType["UNDEFINED"] = 9999] = "UNDEFINED";
})(CacheType || (CacheType = {}));
/**
 * More Cache related constants
 */
var APP_METADATA = "appmetadata";
var CLIENT_INFO = "client_info";
var THE_FAMILY_ID = "1";
var AUTHORITY_METADATA_CONSTANTS = {
    CACHE_KEY: "authority-metadata",
    REFRESH_TIME_SECONDS: 3600 * 24 // 24 Hours
};
var AuthorityMetadataSource;
(function (AuthorityMetadataSource) {
    AuthorityMetadataSource["CONFIG"] = "config";
    AuthorityMetadataSource["CACHE"] = "cache";
    AuthorityMetadataSource["NETWORK"] = "network";
    AuthorityMetadataSource["HARDCODED_VALUES"] = "hardcoded_values";
})(AuthorityMetadataSource || (AuthorityMetadataSource = {}));
var SERVER_TELEM_CONSTANTS = {
    SCHEMA_VERSION: 5,
    MAX_CUR_HEADER_BYTES: 80,
    MAX_LAST_HEADER_BYTES: 330,
    MAX_CACHED_ERRORS: 50,
    CACHE_KEY: "server-telemetry",
    CATEGORY_SEPARATOR: "|",
    VALUE_SEPARATOR: ",",
    OVERFLOW_TRUE: "1",
    OVERFLOW_FALSE: "0",
    UNKNOWN_ERROR: "unknown_error"
};
/**
 * Type of the authentication request
 */
var AuthenticationScheme;
(function (AuthenticationScheme) {
    AuthenticationScheme["BEARER"] = "Bearer";
    AuthenticationScheme["POP"] = "pop";
    AuthenticationScheme["SSH"] = "ssh-cert";
})(AuthenticationScheme || (AuthenticationScheme = {}));
/**
 * Constants related to throttling
 */
var ThrottlingConstants = {
    // Default time to throttle RequestThumbprint in seconds
    DEFAULT_THROTTLE_TIME_SECONDS: 60,
    // Default maximum time to throttle in seconds, overrides what the server sends back
    DEFAULT_MAX_THROTTLE_TIME_SECONDS: 3600,
    // Prefix for storing throttling entries
    THROTTLING_PREFIX: "throttling",
    // Value assigned to the x-ms-lib-capability header to indicate to the server the library supports throttling
    X_MS_LIB_CAPABILITY_VALUE: "retry-after, h429"
};
var Errors = {
    INVALID_GRANT_ERROR: "invalid_grant",
    CLIENT_MISMATCH_ERROR: "client_mismatch",
};
/**
 * Password grant parameters
 */
var PasswordGrantConstants;
(function (PasswordGrantConstants) {
    PasswordGrantConstants["username"] = "username";
    PasswordGrantConstants["password"] = "password";
})(PasswordGrantConstants || (PasswordGrantConstants = {}));
/**
 * Response codes
 */
var ResponseCodes;
(function (ResponseCodes) {
    ResponseCodes[ResponseCodes["httpSuccess"] = 200] = "httpSuccess";
    ResponseCodes[ResponseCodes["httpBadRequest"] = 400] = "httpBadRequest";
})(ResponseCodes || (ResponseCodes = {}));
/**
 * Region Discovery Sources
 */
var RegionDiscoverySources;
(function (RegionDiscoverySources) {
    RegionDiscoverySources["FAILED_AUTO_DETECTION"] = "1";
    RegionDiscoverySources["INTERNAL_CACHE"] = "2";
    RegionDiscoverySources["ENVIRONMENT_VARIABLE"] = "3";
    RegionDiscoverySources["IMDS"] = "4";
})(RegionDiscoverySources || (RegionDiscoverySources = {}));
/**
 * Region Discovery Outcomes
 */
var RegionDiscoveryOutcomes;
(function (RegionDiscoveryOutcomes) {
    RegionDiscoveryOutcomes["CONFIGURED_MATCHES_DETECTED"] = "1";
    RegionDiscoveryOutcomes["CONFIGURED_NO_AUTO_DETECTION"] = "2";
    RegionDiscoveryOutcomes["CONFIGURED_NOT_DETECTED"] = "3";
    RegionDiscoveryOutcomes["AUTO_DETECTION_REQUESTED_SUCCESSFUL"] = "4";
    RegionDiscoveryOutcomes["AUTO_DETECTION_REQUESTED_FAILED"] = "5";
})(RegionDiscoveryOutcomes || (RegionDiscoveryOutcomes = {}));
var CacheOutcome;
(function (CacheOutcome) {
    CacheOutcome["NO_CACHE_HIT"] = "0";
    CacheOutcome["FORCE_REFRESH"] = "1";
    CacheOutcome["NO_CACHED_ACCESS_TOKEN"] = "2";
    CacheOutcome["CACHED_ACCESS_TOKEN_EXPIRED"] = "3";
    CacheOutcome["REFRESH_CACHED_ACCESS_TOKEN"] = "4";
    CacheOutcome["CLAIMS_REQUESTED_CACHE_SKIPPED"] = "5";
})(CacheOutcome || (CacheOutcome = {}));
var JsonTypes;
(function (JsonTypes) {
    JsonTypes["Jwt"] = "JWT";
    JsonTypes["Jwk"] = "JWK";
    JsonTypes["Pop"] = "pop";
})(JsonTypes || (JsonTypes = {}));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * AuthErrorMessage class containing string constants used by error codes and messages.
 */
var AuthErrorMessage = {
    unexpectedError: {
        code: "unexpected_error",
        desc: "Unexpected error in authentication."
    },
    postRequestFailed: {
        code: "post_request_failed",
        desc: "Post request failed from the network, could be a 4xx/5xx or a network unavailability. Please check the exact error code for details."
    }
};
/**
 * General error class thrown by the MSAL.js library.
 */
var AuthError = /** @class */ (function (_super) {
    __extends$f(AuthError, _super);
    function AuthError(errorCode, errorMessage, suberror) {
        var _this = this;
        var errorString = errorMessage ? errorCode + ": " + errorMessage : errorCode;
        _this = _super.call(this, errorString) || this;
        Object.setPrototypeOf(_this, AuthError.prototype);
        _this.errorCode = errorCode || Constants.EMPTY_STRING;
        _this.errorMessage = errorMessage || Constants.EMPTY_STRING;
        _this.subError = suberror || Constants.EMPTY_STRING;
        _this.name = "AuthError";
        return _this;
    }
    AuthError.prototype.setCorrelationId = function (correlationId) {
        this.correlationId = correlationId;
    };
    /**
     * Creates an error that is thrown when something unexpected happens in the library.
     * @param errDesc
     */
    AuthError.createUnexpectedError = function (errDesc) {
        return new AuthError(AuthErrorMessage.unexpectedError.code, AuthErrorMessage.unexpectedError.desc + ": " + errDesc);
    };
    /**
     * Creates an error for post request failures.
     * @param errDesc
     * @returns
     */
    AuthError.createPostRequestFailed = function (errDesc) {
        return new AuthError(AuthErrorMessage.postRequestFailed.code, AuthErrorMessage.postRequestFailed.desc + ": " + errDesc);
    };
    return AuthError;
}(Error));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var DEFAULT_CRYPTO_IMPLEMENTATION = {
    createNewGuid: function () {
        var notImplErr = "Crypto interface - createNewGuid() has not been implemented";
        throw AuthError.createUnexpectedError(notImplErr);
    },
    base64Decode: function () {
        var notImplErr = "Crypto interface - base64Decode() has not been implemented";
        throw AuthError.createUnexpectedError(notImplErr);
    },
    base64Encode: function () {
        var notImplErr = "Crypto interface - base64Encode() has not been implemented";
        throw AuthError.createUnexpectedError(notImplErr);
    },
    generatePkceCodes: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Crypto interface - generatePkceCodes() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    },
    getPublicKeyThumbprint: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Crypto interface - getPublicKeyThumbprint() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    },
    removeTokenBindingKey: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Crypto interface - removeTokenBindingKey() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    },
    clearKeystore: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Crypto interface - clearKeystore() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    },
    signJwt: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Crypto interface - signJwt() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    },
    hashString: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Crypto interface - hashString() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    }
};

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * ClientAuthErrorMessage class containing string constants used by error codes and messages.
 */
var ClientAuthErrorMessage = {
    clientInfoDecodingError: {
        code: "client_info_decoding_error",
        desc: "The client info could not be parsed/decoded correctly. Please review the trace to determine the root cause."
    },
    clientInfoEmptyError: {
        code: "client_info_empty_error",
        desc: "The client info was empty. Please review the trace to determine the root cause."
    },
    tokenParsingError: {
        code: "token_parsing_error",
        desc: "Token cannot be parsed. Please review stack trace to determine root cause."
    },
    nullOrEmptyToken: {
        code: "null_or_empty_token",
        desc: "The token is null or empty. Please review the trace to determine the root cause."
    },
    endpointResolutionError: {
        code: "endpoints_resolution_error",
        desc: "Error: could not resolve endpoints. Please check network and try again."
    },
    networkError: {
        code: "network_error",
        desc: "Network request failed. Please check network trace to determine root cause."
    },
    unableToGetOpenidConfigError: {
        code: "openid_config_error",
        desc: "Could not retrieve endpoints. Check your authority and verify the .well-known/openid-configuration endpoint returns the required endpoints."
    },
    hashNotDeserialized: {
        code: "hash_not_deserialized",
        desc: "The hash parameters could not be deserialized. Please review the trace to determine the root cause."
    },
    blankGuidGenerated: {
        code: "blank_guid_generated",
        desc: "The guid generated was blank. Please review the trace to determine the root cause."
    },
    invalidStateError: {
        code: "invalid_state",
        desc: "State was not the expected format. Please check the logs to determine whether the request was sent using ProtocolUtils.setRequestState()."
    },
    stateMismatchError: {
        code: "state_mismatch",
        desc: "State mismatch error. Please check your network. Continued requests may cause cache overflow."
    },
    stateNotFoundError: {
        code: "state_not_found",
        desc: "State not found"
    },
    nonceMismatchError: {
        code: "nonce_mismatch",
        desc: "Nonce mismatch error. This may be caused by a race condition in concurrent requests."
    },
    nonceNotFoundError: {
        code: "nonce_not_found",
        desc: "nonce not found"
    },
    authTimeNotFoundError: {
        code: "auth_time_not_found",
        desc: "Max Age was requested and the ID token is missing the auth_time variable." +
            " auth_time is an optional claim and is not enabled by default - it must be enabled." +
            " See https://aka.ms/msaljs/optional-claims for more information."
    },
    maxAgeTranspiredError: {
        code: "max_age_transpired",
        desc: "Max Age is set to 0, or too much time has elapsed since the last end-user authentication."
    },
    noTokensFoundError: {
        code: "no_tokens_found",
        desc: "No tokens were found for the given scopes, and no authorization code was passed to acquireToken. You must retrieve an authorization code before making a call to acquireToken()."
    },
    multipleMatchingTokens: {
        code: "multiple_matching_tokens",
        desc: "The cache contains multiple tokens satisfying the requirements. " +
            "Call AcquireToken again providing more requirements such as authority or account."
    },
    multipleMatchingAccounts: {
        code: "multiple_matching_accounts",
        desc: "The cache contains multiple accounts satisfying the given parameters. Please pass more info to obtain the correct account"
    },
    multipleMatchingAppMetadata: {
        code: "multiple_matching_appMetadata",
        desc: "The cache contains multiple appMetadata satisfying the given parameters. Please pass more info to obtain the correct appMetadata"
    },
    tokenRequestCannotBeMade: {
        code: "request_cannot_be_made",
        desc: "Token request cannot be made without authorization code or refresh token."
    },
    appendEmptyScopeError: {
        code: "cannot_append_empty_scope",
        desc: "Cannot append null or empty scope to ScopeSet. Please check the stack trace for more info."
    },
    removeEmptyScopeError: {
        code: "cannot_remove_empty_scope",
        desc: "Cannot remove null or empty scope from ScopeSet. Please check the stack trace for more info."
    },
    appendScopeSetError: {
        code: "cannot_append_scopeset",
        desc: "Cannot append ScopeSet due to error."
    },
    emptyInputScopeSetError: {
        code: "empty_input_scopeset",
        desc: "Empty input ScopeSet cannot be processed."
    },
    DeviceCodePollingCancelled: {
        code: "device_code_polling_cancelled",
        desc: "Caller has cancelled token endpoint polling during device code flow by setting DeviceCodeRequest.cancel = true."
    },
    DeviceCodeExpired: {
        code: "device_code_expired",
        desc: "Device code is expired."
    },
    DeviceCodeUnknownError: {
        code: "device_code_unknown_error",
        desc: "Device code stopped polling for unknown reasons."
    },
    NoAccountInSilentRequest: {
        code: "no_account_in_silent_request",
        desc: "Please pass an account object, silent flow is not supported without account information"
    },
    invalidCacheRecord: {
        code: "invalid_cache_record",
        desc: "Cache record object was null or undefined."
    },
    invalidCacheEnvironment: {
        code: "invalid_cache_environment",
        desc: "Invalid environment when attempting to create cache entry"
    },
    noAccountFound: {
        code: "no_account_found",
        desc: "No account found in cache for given key."
    },
    CachePluginError: {
        code: "no cache plugin set on CacheManager",
        desc: "ICachePlugin needs to be set before using readFromStorage or writeFromStorage"
    },
    noCryptoObj: {
        code: "no_crypto_object",
        desc: "No crypto object detected. This is required for the following operation: "
    },
    invalidCacheType: {
        code: "invalid_cache_type",
        desc: "Invalid cache type"
    },
    unexpectedAccountType: {
        code: "unexpected_account_type",
        desc: "Unexpected account type."
    },
    unexpectedCredentialType: {
        code: "unexpected_credential_type",
        desc: "Unexpected credential type."
    },
    invalidAssertion: {
        code: "invalid_assertion",
        desc: "Client assertion must meet requirements described in https://tools.ietf.org/html/rfc7515"
    },
    invalidClientCredential: {
        code: "invalid_client_credential",
        desc: "Client credential (secret, certificate, or assertion) must not be empty when creating a confidential client. An application should at most have one credential"
    },
    tokenRefreshRequired: {
        code: "token_refresh_required",
        desc: "Cannot return token from cache because it must be refreshed. This may be due to one of the following reasons: forceRefresh parameter is set to true, claims have been requested, there is no cached access token or it is expired."
    },
    userTimeoutReached: {
        code: "user_timeout_reached",
        desc: "User defined timeout for device code polling reached",
    },
    tokenClaimsRequired: {
        code: "token_claims_cnf_required_for_signedjwt",
        desc: "Cannot generate a POP jwt if the token_claims are not populated"
    },
    noAuthorizationCodeFromServer: {
        code: "authorization_code_missing_from_server_response",
        desc: "Server response does not contain an authorization code to proceed"
    },
    noAzureRegionDetected: {
        code: "no_azure_region_detected",
        desc: "No azure region was detected and no fallback was made available"
    },
    accessTokenEntityNullError: {
        code: "access_token_entity_null",
        desc: "Access token entity is null, please check logs and cache to ensure a valid access token is present."
    },
    bindingKeyNotRemovedError: {
        code: "binding_key_not_removed",
        desc: "Could not remove the credential's binding key from storage."
    },
    logoutNotSupported: {
        code: "end_session_endpoint_not_supported",
        desc: "Provided authority does not support logout."
    },
    keyIdMissing: {
        code: "key_id_missing",
        desc: "A keyId value is missing from the requested bound token's cache record and is required to match the token to it's stored binding key."
    },
    noNetworkConnectivity: {
        code: "no_network_connectivity",
        desc: "No network connectivity. Check your internet connection."
    },
    userCanceledError: {
        code: "user_canceled",
        desc: "User canceled the flow."
    }
};
/**
 * Error thrown when there is an error in the client code running on the browser.
 */
var ClientAuthError = /** @class */ (function (_super) {
    __extends$f(ClientAuthError, _super);
    function ClientAuthError(errorCode, errorMessage) {
        var _this = _super.call(this, errorCode, errorMessage) || this;
        _this.name = "ClientAuthError";
        Object.setPrototypeOf(_this, ClientAuthError.prototype);
        return _this;
    }
    /**
     * Creates an error thrown when client info object doesn't decode correctly.
     * @param caughtError
     */
    ClientAuthError.createClientInfoDecodingError = function (caughtError) {
        return new ClientAuthError(ClientAuthErrorMessage.clientInfoDecodingError.code, ClientAuthErrorMessage.clientInfoDecodingError.desc + " Failed with error: " + caughtError);
    };
    /**
     * Creates an error thrown if the client info is empty.
     * @param rawClientInfo
     */
    ClientAuthError.createClientInfoEmptyError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.clientInfoEmptyError.code, "" + ClientAuthErrorMessage.clientInfoEmptyError.desc);
    };
    /**
     * Creates an error thrown when the id token extraction errors out.
     * @param err
     */
    ClientAuthError.createTokenParsingError = function (caughtExtractionError) {
        return new ClientAuthError(ClientAuthErrorMessage.tokenParsingError.code, ClientAuthErrorMessage.tokenParsingError.desc + " Failed with error: " + caughtExtractionError);
    };
    /**
     * Creates an error thrown when the id token string is null or empty.
     * @param invalidRawTokenString
     */
    ClientAuthError.createTokenNullOrEmptyError = function (invalidRawTokenString) {
        return new ClientAuthError(ClientAuthErrorMessage.nullOrEmptyToken.code, ClientAuthErrorMessage.nullOrEmptyToken.desc + " Raw Token Value: " + invalidRawTokenString);
    };
    /**
     * Creates an error thrown when the endpoint discovery doesn't complete correctly.
     */
    ClientAuthError.createEndpointDiscoveryIncompleteError = function (errDetail) {
        return new ClientAuthError(ClientAuthErrorMessage.endpointResolutionError.code, ClientAuthErrorMessage.endpointResolutionError.desc + " Detail: " + errDetail);
    };
    /**
     * Creates an error thrown when the fetch client throws
     */
    ClientAuthError.createNetworkError = function (endpoint, errDetail) {
        return new ClientAuthError(ClientAuthErrorMessage.networkError.code, ClientAuthErrorMessage.networkError.desc + " | Fetch client threw: " + errDetail + " | Attempted to reach: " + endpoint.split("?")[0]);
    };
    /**
     * Creates an error thrown when the openid-configuration endpoint cannot be reached or does not contain the required data
     */
    ClientAuthError.createUnableToGetOpenidConfigError = function (errDetail) {
        return new ClientAuthError(ClientAuthErrorMessage.unableToGetOpenidConfigError.code, ClientAuthErrorMessage.unableToGetOpenidConfigError.desc + " Attempted to retrieve endpoints from: " + errDetail);
    };
    /**
     * Creates an error thrown when the hash cannot be deserialized.
     * @param hashParamObj
     */
    ClientAuthError.createHashNotDeserializedError = function (hashParamObj) {
        return new ClientAuthError(ClientAuthErrorMessage.hashNotDeserialized.code, ClientAuthErrorMessage.hashNotDeserialized.desc + " Given Object: " + hashParamObj);
    };
    /**
     * Creates an error thrown when the state cannot be parsed.
     * @param invalidState
     */
    ClientAuthError.createInvalidStateError = function (invalidState, errorString) {
        return new ClientAuthError(ClientAuthErrorMessage.invalidStateError.code, ClientAuthErrorMessage.invalidStateError.desc + " Invalid State: " + invalidState + ", Root Err: " + errorString);
    };
    /**
     * Creates an error thrown when two states do not match.
     */
    ClientAuthError.createStateMismatchError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.stateMismatchError.code, ClientAuthErrorMessage.stateMismatchError.desc);
    };
    /**
     * Creates an error thrown when the state is not present
     * @param missingState
     */
    ClientAuthError.createStateNotFoundError = function (missingState) {
        return new ClientAuthError(ClientAuthErrorMessage.stateNotFoundError.code, ClientAuthErrorMessage.stateNotFoundError.desc + ":  " + missingState);
    };
    /**
     * Creates an error thrown when the nonce does not match.
     */
    ClientAuthError.createNonceMismatchError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.nonceMismatchError.code, ClientAuthErrorMessage.nonceMismatchError.desc);
    };
    /**
     * Creates an error thrown when max_age was provided in the request, but auth_time is not in the token claims
     * @param missingNonce
     */
    ClientAuthError.createAuthTimeNotFoundError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.authTimeNotFoundError.code, ClientAuthErrorMessage.authTimeNotFoundError.desc);
    };
    /**
     * Creates an error thrown when too much time has elapsed since the last end-user authentication
     */
    ClientAuthError.createMaxAgeTranspiredError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.maxAgeTranspiredError.code, ClientAuthErrorMessage.maxAgeTranspiredError.desc);
    };
    /**
     * Creates an error thrown when the mnonce is not present
     * @param missingNonce
     */
    ClientAuthError.createNonceNotFoundError = function (missingNonce) {
        return new ClientAuthError(ClientAuthErrorMessage.nonceNotFoundError.code, ClientAuthErrorMessage.nonceNotFoundError.desc + ":  " + missingNonce);
    };
    /**
     * Throws error when multiple tokens are in cache.
     */
    ClientAuthError.createMultipleMatchingTokensInCacheError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.multipleMatchingTokens.code, ClientAuthErrorMessage.multipleMatchingTokens.desc + ".");
    };
    /**
     * Throws error when multiple accounts are in cache for the given params
     */
    ClientAuthError.createMultipleMatchingAccountsInCacheError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.multipleMatchingAccounts.code, ClientAuthErrorMessage.multipleMatchingAccounts.desc);
    };
    /**
     * Throws error when multiple appMetada are in cache for the given clientId.
     */
    ClientAuthError.createMultipleMatchingAppMetadataInCacheError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.multipleMatchingAppMetadata.code, ClientAuthErrorMessage.multipleMatchingAppMetadata.desc);
    };
    /**
     * Throws error when no auth code or refresh token is given to ServerTokenRequestParameters.
     */
    ClientAuthError.createTokenRequestCannotBeMadeError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.tokenRequestCannotBeMade.code, ClientAuthErrorMessage.tokenRequestCannotBeMade.desc);
    };
    /**
     * Throws error when attempting to append a null, undefined or empty scope to a set
     * @param givenScope
     */
    ClientAuthError.createAppendEmptyScopeToSetError = function (givenScope) {
        return new ClientAuthError(ClientAuthErrorMessage.appendEmptyScopeError.code, ClientAuthErrorMessage.appendEmptyScopeError.desc + " Given Scope: " + givenScope);
    };
    /**
     * Throws error when attempting to append a null, undefined or empty scope to a set
     * @param givenScope
     */
    ClientAuthError.createRemoveEmptyScopeFromSetError = function (givenScope) {
        return new ClientAuthError(ClientAuthErrorMessage.removeEmptyScopeError.code, ClientAuthErrorMessage.removeEmptyScopeError.desc + " Given Scope: " + givenScope);
    };
    /**
     * Throws error when attempting to append null or empty ScopeSet.
     * @param appendError
     */
    ClientAuthError.createAppendScopeSetError = function (appendError) {
        return new ClientAuthError(ClientAuthErrorMessage.appendScopeSetError.code, ClientAuthErrorMessage.appendScopeSetError.desc + " Detail Error: " + appendError);
    };
    /**
     * Throws error if ScopeSet is null or undefined.
     * @param givenScopeSet
     */
    ClientAuthError.createEmptyInputScopeSetError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.emptyInputScopeSetError.code, "" + ClientAuthErrorMessage.emptyInputScopeSetError.desc);
    };
    /**
     * Throws error if user sets CancellationToken.cancel = true during polling of token endpoint during device code flow
     */
    ClientAuthError.createDeviceCodeCancelledError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.DeviceCodePollingCancelled.code, "" + ClientAuthErrorMessage.DeviceCodePollingCancelled.desc);
    };
    /**
     * Throws error if device code is expired
     */
    ClientAuthError.createDeviceCodeExpiredError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.DeviceCodeExpired.code, "" + ClientAuthErrorMessage.DeviceCodeExpired.desc);
    };
    /**
     * Throws error if device code is expired
     */
    ClientAuthError.createDeviceCodeUnknownError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.DeviceCodeUnknownError.code, "" + ClientAuthErrorMessage.DeviceCodeUnknownError.desc);
    };
    /**
     * Throws error when silent requests are made without an account object
     */
    ClientAuthError.createNoAccountInSilentRequestError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.NoAccountInSilentRequest.code, "" + ClientAuthErrorMessage.NoAccountInSilentRequest.desc);
    };
    /**
     * Throws error when cache record is null or undefined.
     */
    ClientAuthError.createNullOrUndefinedCacheRecord = function () {
        return new ClientAuthError(ClientAuthErrorMessage.invalidCacheRecord.code, ClientAuthErrorMessage.invalidCacheRecord.desc);
    };
    /**
     * Throws error when provided environment is not part of the CloudDiscoveryMetadata object
     */
    ClientAuthError.createInvalidCacheEnvironmentError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.invalidCacheEnvironment.code, ClientAuthErrorMessage.invalidCacheEnvironment.desc);
    };
    /**
     * Throws error when account is not found in cache.
     */
    ClientAuthError.createNoAccountFoundError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.noAccountFound.code, ClientAuthErrorMessage.noAccountFound.desc);
    };
    /**
     * Throws error if ICachePlugin not set on CacheManager.
     */
    ClientAuthError.createCachePluginError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.CachePluginError.code, "" + ClientAuthErrorMessage.CachePluginError.desc);
    };
    /**
     * Throws error if crypto object not found.
     * @param operationName
     */
    ClientAuthError.createNoCryptoObjectError = function (operationName) {
        return new ClientAuthError(ClientAuthErrorMessage.noCryptoObj.code, "" + ClientAuthErrorMessage.noCryptoObj.desc + operationName);
    };
    /**
     * Throws error if cache type is invalid.
     */
    ClientAuthError.createInvalidCacheTypeError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.invalidCacheType.code, "" + ClientAuthErrorMessage.invalidCacheType.desc);
    };
    /**
     * Throws error if unexpected account type.
     */
    ClientAuthError.createUnexpectedAccountTypeError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.unexpectedAccountType.code, "" + ClientAuthErrorMessage.unexpectedAccountType.desc);
    };
    /**
     * Throws error if unexpected credential type.
     */
    ClientAuthError.createUnexpectedCredentialTypeError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.unexpectedCredentialType.code, "" + ClientAuthErrorMessage.unexpectedCredentialType.desc);
    };
    /**
     * Throws error if client assertion is not valid.
     */
    ClientAuthError.createInvalidAssertionError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.invalidAssertion.code, "" + ClientAuthErrorMessage.invalidAssertion.desc);
    };
    /**
     * Throws error if client assertion is not valid.
     */
    ClientAuthError.createInvalidCredentialError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.invalidClientCredential.code, "" + ClientAuthErrorMessage.invalidClientCredential.desc);
    };
    /**
     * Throws error if token cannot be retrieved from cache due to refresh being required.
     */
    ClientAuthError.createRefreshRequiredError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.tokenRefreshRequired.code, ClientAuthErrorMessage.tokenRefreshRequired.desc);
    };
    /**
     * Throws error if the user defined timeout is reached.
     */
    ClientAuthError.createUserTimeoutReachedError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.userTimeoutReached.code, ClientAuthErrorMessage.userTimeoutReached.desc);
    };
    /*
     * Throws error if token claims are not populated for a signed jwt generation
     */
    ClientAuthError.createTokenClaimsRequiredError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.tokenClaimsRequired.code, ClientAuthErrorMessage.tokenClaimsRequired.desc);
    };
    /**
     * Throws error when the authorization code is missing from the server response
     */
    ClientAuthError.createNoAuthCodeInServerResponseError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.noAuthorizationCodeFromServer.code, ClientAuthErrorMessage.noAuthorizationCodeFromServer.desc);
    };
    ClientAuthError.createBindingKeyNotRemovedError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.bindingKeyNotRemovedError.code, ClientAuthErrorMessage.bindingKeyNotRemovedError.desc);
    };
    /**
     * Thrown when logout is attempted for an authority that doesnt have an end_session_endpoint
     */
    ClientAuthError.createLogoutNotSupportedError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.logoutNotSupported.code, ClientAuthErrorMessage.logoutNotSupported.desc);
    };
    /**
     * Create an error when kid attribute is missing from a PoP token's cache record
     */
    ClientAuthError.createKeyIdMissingError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.keyIdMissing.code, ClientAuthErrorMessage.keyIdMissing.desc);
    };
    /**
     * Create an error when the client does not have network connectivity
     */
    ClientAuthError.createNoNetworkConnectivityError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.noNetworkConnectivity.code, ClientAuthErrorMessage.noNetworkConnectivity.desc);
    };
    /**
     * Create an error when the user cancels the flow
     */
    ClientAuthError.createUserCanceledError = function () {
        return new ClientAuthError(ClientAuthErrorMessage.userCanceledError.code, ClientAuthErrorMessage.userCanceledError.desc);
    };
    return ClientAuthError;
}(AuthError));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * @hidden
 */
var StringUtils = /** @class */ (function () {
    function StringUtils() {
    }
    /**
     * decode a JWT
     *
     * @param authToken
     */
    StringUtils.decodeAuthToken = function (authToken) {
        if (StringUtils.isEmpty(authToken)) {
            throw ClientAuthError.createTokenNullOrEmptyError(authToken);
        }
        var tokenPartsRegex = /^([^\.\s]*)\.([^\.\s]+)\.([^\.\s]*)$/;
        var matches = tokenPartsRegex.exec(authToken);
        if (!matches || matches.length < 4) {
            throw ClientAuthError.createTokenParsingError("Given token is malformed: " + JSON.stringify(authToken));
        }
        var crackedToken = {
            header: matches[1],
            JWSPayload: matches[2],
            JWSSig: matches[3]
        };
        return crackedToken;
    };
    /**
     * Check if a string is empty.
     *
     * @param str
     */
    StringUtils.isEmpty = function (str) {
        return (typeof str === "undefined" || !str || 0 === str.length);
    };
    /**
     * Check if stringified object is empty
     * @param strObj
     */
    StringUtils.isEmptyObj = function (strObj) {
        if (strObj && !StringUtils.isEmpty(strObj)) {
            try {
                var obj = JSON.parse(strObj);
                return Object.keys(obj).length === 0;
            }
            catch (e) { }
        }
        return true;
    };
    StringUtils.startsWith = function (str, search) {
        return str.indexOf(search) === 0;
    };
    StringUtils.endsWith = function (str, search) {
        return (str.length >= search.length) && (str.lastIndexOf(search) === (str.length - search.length));
    };
    /**
     * Parses string into an object.
     *
     * @param query
     */
    StringUtils.queryStringToObject = function (query) {
        var obj = {};
        var params = query.split("&");
        var decode = function (s) { return decodeURIComponent(s.replace(/\+/g, " ")); };
        params.forEach(function (pair) {
            if (pair.trim()) {
                var _a = pair.split(/=(.+)/g, 2), key = _a[0], value = _a[1]; // Split on the first occurence of the '=' character
                if (key && value) {
                    obj[decode(key)] = decode(value);
                }
            }
        });
        return obj;
    };
    /**
     * Trims entries in an array.
     *
     * @param arr
     */
    StringUtils.trimArrayEntries = function (arr) {
        return arr.map(function (entry) { return entry.trim(); });
    };
    /**
     * Removes empty strings from array
     * @param arr
     */
    StringUtils.removeEmptyStringsFromArray = function (arr) {
        return arr.filter(function (entry) {
            return !StringUtils.isEmpty(entry);
        });
    };
    /**
     * Attempts to parse a string into JSON
     * @param str
     */
    StringUtils.jsonParseHelper = function (str) {
        try {
            return JSON.parse(str);
        }
        catch (e) {
            return null;
        }
    };
    /**
     * Tests if a given string matches a given pattern, with support for wildcards and queries.
     * @param pattern Wildcard pattern to string match. Supports "*" for wildcards and "?" for queries
     * @param input String to match against
     */
    StringUtils.matchPattern = function (pattern, input) {
        /**
         * Wildcard support: https://stackoverflow.com/a/3117248/4888559
         * Queries: replaces "?" in string with escaped "\?" for regex test
         */
        var regex = new RegExp(pattern.replace(/\\/g, "\\\\").replace(/\*/g, "[^ ]*").replace(/\?/g, "\\\?")); // eslint-disable-line security/detect-non-literal-regexp
        return regex.test(input);
    };
    return StringUtils;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Log message level.
 */
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["Error"] = 0] = "Error";
    LogLevel[LogLevel["Warning"] = 1] = "Warning";
    LogLevel[LogLevel["Info"] = 2] = "Info";
    LogLevel[LogLevel["Verbose"] = 3] = "Verbose";
    LogLevel[LogLevel["Trace"] = 4] = "Trace";
})(LogLevel || (LogLevel = {}));
/**
 * Class which facilitates logging of messages to a specific place.
 */
var Logger = /** @class */ (function () {
    function Logger(loggerOptions, packageName, packageVersion) {
        // Current log level, defaults to info.
        this.level = LogLevel.Info;
        var defaultLoggerCallback = function () {
            return;
        };
        var setLoggerOptions = loggerOptions || Logger.createDefaultLoggerOptions();
        this.localCallback = setLoggerOptions.loggerCallback || defaultLoggerCallback;
        this.piiLoggingEnabled = setLoggerOptions.piiLoggingEnabled || false;
        this.level = typeof (setLoggerOptions.logLevel) === "number" ? setLoggerOptions.logLevel : LogLevel.Info;
        this.correlationId = setLoggerOptions.correlationId || Constants.EMPTY_STRING;
        this.packageName = packageName || Constants.EMPTY_STRING;
        this.packageVersion = packageVersion || Constants.EMPTY_STRING;
    }
    Logger.createDefaultLoggerOptions = function () {
        return {
            loggerCallback: function () {
                // allow users to not set loggerCallback
            },
            piiLoggingEnabled: false,
            logLevel: LogLevel.Info
        };
    };
    /**
     * Create new Logger with existing configurations.
     */
    Logger.prototype.clone = function (packageName, packageVersion, correlationId) {
        return new Logger({ loggerCallback: this.localCallback, piiLoggingEnabled: this.piiLoggingEnabled, logLevel: this.level, correlationId: correlationId || this.correlationId }, packageName, packageVersion);
    };
    /**
     * Log message with required options.
     */
    Logger.prototype.logMessage = function (logMessage, options) {
        if ((options.logLevel > this.level) || (!this.piiLoggingEnabled && options.containsPii)) {
            return;
        }
        var timestamp = new Date().toUTCString();
        // Add correlationId to logs if set, correlationId provided on log messages take precedence
        var logHeader;
        if (!StringUtils.isEmpty(options.correlationId)) {
            logHeader = "[" + timestamp + "] : [" + options.correlationId + "]";
        }
        else if (!StringUtils.isEmpty(this.correlationId)) {
            logHeader = "[" + timestamp + "] : [" + this.correlationId + "]";
        }
        else {
            logHeader = "[" + timestamp + "]";
        }
        var log = logHeader + " : " + this.packageName + "@" + this.packageVersion + " : " + LogLevel[options.logLevel] + " - " + logMessage;
        // debug(`msal:${LogLevel[options.logLevel]}${options.containsPii ? "-Pii": Constants.EMPTY_STRING}${options.context ? `:${options.context}` : Constants.EMPTY_STRING}`)(logMessage);
        this.executeCallback(options.logLevel, log, options.containsPii || false);
    };
    /**
     * Execute callback with message.
     */
    Logger.prototype.executeCallback = function (level, message, containsPii) {
        if (this.localCallback) {
            this.localCallback(level, message, containsPii);
        }
    };
    /**
     * Logs error messages.
     */
    Logger.prototype.error = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Error,
            containsPii: false,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs error messages with PII.
     */
    Logger.prototype.errorPii = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Error,
            containsPii: true,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs warning messages.
     */
    Logger.prototype.warning = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Warning,
            containsPii: false,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs warning messages with PII.
     */
    Logger.prototype.warningPii = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Warning,
            containsPii: true,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs info messages.
     */
    Logger.prototype.info = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Info,
            containsPii: false,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs info messages with PII.
     */
    Logger.prototype.infoPii = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Info,
            containsPii: true,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs verbose messages.
     */
    Logger.prototype.verbose = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Verbose,
            containsPii: false,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs verbose messages with PII.
     */
    Logger.prototype.verbosePii = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Verbose,
            containsPii: true,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs trace messages.
     */
    Logger.prototype.trace = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Trace,
            containsPii: false,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Logs trace messages with PII.
     */
    Logger.prototype.tracePii = function (message, correlationId) {
        this.logMessage(message, {
            logLevel: LogLevel.Trace,
            containsPii: true,
            correlationId: correlationId || Constants.EMPTY_STRING
        });
    };
    /**
     * Returns whether PII Logging is enabled or not.
     */
    Logger.prototype.isPiiLoggingEnabled = function () {
        return this.piiLoggingEnabled || false;
    };
    return Logger;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */
/* eslint-disable header/header */
var name$1 = "@azure/msal-common";
var version$1 = "13.3.1";

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var AzureCloudInstance;
(function (AzureCloudInstance) {
    // AzureCloudInstance is not specified.
    AzureCloudInstance[AzureCloudInstance["None"] = 0] = "None";
    // Microsoft Azure public cloud
    AzureCloudInstance["AzurePublic"] = "https://login.microsoftonline.com";
    // Microsoft PPE
    AzureCloudInstance["AzurePpe"] = "https://login.windows-ppe.net";
    // Microsoft Chinese national cloud
    AzureCloudInstance["AzureChina"] = "https://login.chinacloudapi.cn";
    // Microsoft German national cloud ("Black Forest")
    AzureCloudInstance["AzureGermany"] = "https://login.microsoftonline.de";
    // US Government cloud
    AzureCloudInstance["AzureUsGovernment"] = "https://login.microsoftonline.us";
})(AzureCloudInstance || (AzureCloudInstance = {}));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * ClientConfigurationErrorMessage class containing string constants used by error codes and messages.
 */
var ClientConfigurationErrorMessage = {
    redirectUriNotSet: {
        code: "redirect_uri_empty",
        desc: "A redirect URI is required for all calls, and none has been set."
    },
    postLogoutUriNotSet: {
        code: "post_logout_uri_empty",
        desc: "A post logout redirect has not been set."
    },
    claimsRequestParsingError: {
        code: "claims_request_parsing_error",
        desc: "Could not parse the given claims request object."
    },
    authorityUriInsecure: {
        code: "authority_uri_insecure",
        desc: "Authority URIs must use https.  Please see here for valid authority configuration options: https://docs.microsoft.com/en-us/azure/active-directory/develop/msal-js-initializing-client-applications#configuration-options"
    },
    urlParseError: {
        code: "url_parse_error",
        desc: "URL could not be parsed into appropriate segments."
    },
    urlEmptyError: {
        code: "empty_url_error",
        desc: "URL was empty or null."
    },
    emptyScopesError: {
        code: "empty_input_scopes_error",
        desc: "Scopes cannot be passed as null, undefined or empty array because they are required to obtain an access token."
    },
    nonArrayScopesError: {
        code: "nonarray_input_scopes_error",
        desc: "Scopes cannot be passed as non-array."
    },
    clientIdSingleScopeError: {
        code: "clientid_input_scopes_error",
        desc: "Client ID can only be provided as a single scope."
    },
    invalidPrompt: {
        code: "invalid_prompt_value",
        desc: "Supported prompt values are 'login', 'select_account', 'consent', 'create', 'none' and 'no_session'.  Please see here for valid configuration options: https://azuread.github.io/microsoft-authentication-library-for-js/ref/modules/_azure_msal_common.html#commonauthorizationurlrequest",
    },
    invalidClaimsRequest: {
        code: "invalid_claims",
        desc: "Given claims parameter must be a stringified JSON object."
    },
    tokenRequestEmptyError: {
        code: "token_request_empty",
        desc: "Token request was empty and not found in cache."
    },
    logoutRequestEmptyError: {
        code: "logout_request_empty",
        desc: "The logout request was null or undefined."
    },
    invalidCodeChallengeMethod: {
        code: "invalid_code_challenge_method",
        desc: "code_challenge_method passed is invalid. Valid values are \"plain\" and \"S256\"."
    },
    invalidCodeChallengeParams: {
        code: "pkce_params_missing",
        desc: "Both params: code_challenge and code_challenge_method are to be passed if to be sent in the request"
    },
    invalidCloudDiscoveryMetadata: {
        code: "invalid_cloud_discovery_metadata",
        desc: "Invalid cloudDiscoveryMetadata provided. Must be a stringified JSON object containing tenant_discovery_endpoint and metadata fields"
    },
    invalidAuthorityMetadata: {
        code: "invalid_authority_metadata",
        desc: "Invalid authorityMetadata provided. Must by a stringified JSON object containing authorization_endpoint, token_endpoint, issuer fields."
    },
    untrustedAuthority: {
        code: "untrusted_authority",
        desc: "The provided authority is not a trusted authority. Please include this authority in the knownAuthorities config parameter."
    },
    invalidAzureCloudInstance: {
        code: "invalid_azure_cloud_instance",
        desc: "Invalid AzureCloudInstance provided. Please refer MSAL JS docs: aks.ms/msaljs/azure_cloud_instance for valid values"
    },
    missingSshJwk: {
        code: "missing_ssh_jwk",
        desc: "Missing sshJwk in SSH certificate request. A stringified JSON Web Key is required when using the SSH authentication scheme."
    },
    missingSshKid: {
        code: "missing_ssh_kid",
        desc: "Missing sshKid in SSH certificate request. A string that uniquely identifies the public SSH key is required when using the SSH authentication scheme."
    },
    missingNonceAuthenticationHeader: {
        code: "missing_nonce_authentication_header",
        desc: "Unable to find an authentication header containing server nonce. Either the Authentication-Info or WWW-Authenticate headers must be present in order to obtain a server nonce."
    },
    invalidAuthenticationHeader: {
        code: "invalid_authentication_header",
        desc: "Invalid authentication header provided"
    },
    authorityMismatch: {
        code: "authority_mismatch",
        desc: "Authority mismatch error. Authority provided in login request or PublicClientApplication config does not match the environment of the provided account. Please use a matching account or make an interactive request to login to this authority."
    }
};
/**
 * Error thrown when there is an error in configuration of the MSAL.js library.
 */
var ClientConfigurationError = /** @class */ (function (_super) {
    __extends$f(ClientConfigurationError, _super);
    function ClientConfigurationError(errorCode, errorMessage) {
        var _this = _super.call(this, errorCode, errorMessage) || this;
        _this.name = "ClientConfigurationError";
        Object.setPrototypeOf(_this, ClientConfigurationError.prototype);
        return _this;
    }
    /**
     * Creates an error thrown when the redirect uri is empty (not set by caller)
     */
    ClientConfigurationError.createRedirectUriEmptyError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.redirectUriNotSet.code, ClientConfigurationErrorMessage.redirectUriNotSet.desc);
    };
    /**
     * Creates an error thrown when the post-logout redirect uri is empty (not set by caller)
     */
    ClientConfigurationError.createPostLogoutRedirectUriEmptyError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.postLogoutUriNotSet.code, ClientConfigurationErrorMessage.postLogoutUriNotSet.desc);
    };
    /**
     * Creates an error thrown when the claims request could not be successfully parsed
     */
    ClientConfigurationError.createClaimsRequestParsingError = function (claimsRequestParseError) {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.claimsRequestParsingError.code, ClientConfigurationErrorMessage.claimsRequestParsingError.desc + " Given value: " + claimsRequestParseError);
    };
    /**
     * Creates an error thrown if authority uri is given an insecure protocol.
     * @param urlString
     */
    ClientConfigurationError.createInsecureAuthorityUriError = function (urlString) {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.authorityUriInsecure.code, ClientConfigurationErrorMessage.authorityUriInsecure.desc + " Given URI: " + urlString);
    };
    /**
     * Creates an error thrown if URL string does not parse into separate segments.
     * @param urlString
     */
    ClientConfigurationError.createUrlParseError = function (urlParseError) {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.urlParseError.code, ClientConfigurationErrorMessage.urlParseError.desc + " Given Error: " + urlParseError);
    };
    /**
     * Creates an error thrown if URL string is empty or null.
     * @param urlString
     */
    ClientConfigurationError.createUrlEmptyError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.urlEmptyError.code, ClientConfigurationErrorMessage.urlEmptyError.desc);
    };
    /**
     * Error thrown when scopes are empty.
     * @param scopesValue
     */
    ClientConfigurationError.createEmptyScopesArrayError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.emptyScopesError.code, "" + ClientConfigurationErrorMessage.emptyScopesError.desc);
    };
    /**
     * Error thrown when client id scope is not provided as single scope.
     * @param inputScopes
     */
    ClientConfigurationError.createClientIdSingleScopeError = function (inputScopes) {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.clientIdSingleScopeError.code, ClientConfigurationErrorMessage.clientIdSingleScopeError.desc + " Given Scopes: " + inputScopes);
    };
    /**
     * Error thrown when prompt is not an allowed type.
     * @param promptValue
     */
    ClientConfigurationError.createInvalidPromptError = function (promptValue) {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidPrompt.code, ClientConfigurationErrorMessage.invalidPrompt.desc + " Given value: " + promptValue);
    };
    /**
     * Creates error thrown when claims parameter is not a stringified JSON object
     */
    ClientConfigurationError.createInvalidClaimsRequestError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidClaimsRequest.code, ClientConfigurationErrorMessage.invalidClaimsRequest.desc);
    };
    /**
     * Throws error when token request is empty and nothing cached in storage.
     */
    ClientConfigurationError.createEmptyLogoutRequestError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.logoutRequestEmptyError.code, ClientConfigurationErrorMessage.logoutRequestEmptyError.desc);
    };
    /**
     * Throws error when token request is empty and nothing cached in storage.
     */
    ClientConfigurationError.createEmptyTokenRequestError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.tokenRequestEmptyError.code, ClientConfigurationErrorMessage.tokenRequestEmptyError.desc);
    };
    /**
     * Throws error when an invalid code_challenge_method is passed by the user
     */
    ClientConfigurationError.createInvalidCodeChallengeMethodError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidCodeChallengeMethod.code, ClientConfigurationErrorMessage.invalidCodeChallengeMethod.desc);
    };
    /**
     * Throws error when both params: code_challenge and code_challenge_method are not passed together
     */
    ClientConfigurationError.createInvalidCodeChallengeParamsError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidCodeChallengeParams.code, ClientConfigurationErrorMessage.invalidCodeChallengeParams.desc);
    };
    /**
     * Throws an error when the user passes invalid cloudDiscoveryMetadata
     */
    ClientConfigurationError.createInvalidCloudDiscoveryMetadataError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidCloudDiscoveryMetadata.code, ClientConfigurationErrorMessage.invalidCloudDiscoveryMetadata.desc);
    };
    /**
     * Throws an error when the user passes invalid cloudDiscoveryMetadata
     */
    ClientConfigurationError.createInvalidAuthorityMetadataError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidAuthorityMetadata.code, ClientConfigurationErrorMessage.invalidAuthorityMetadata.desc);
    };
    /**
     * Throws error when provided authority is not a member of the trusted host list
     */
    ClientConfigurationError.createUntrustedAuthorityError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.untrustedAuthority.code, ClientConfigurationErrorMessage.untrustedAuthority.desc);
    };
    /**
     * Throws error when the AzureCloudInstance is set to an invalid value
     */
    ClientConfigurationError.createInvalidAzureCloudInstanceError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidAzureCloudInstance.code, ClientConfigurationErrorMessage.invalidAzureCloudInstance.desc);
    };
    /**
     * Throws an error when the authentication scheme is set to SSH but the SSH public key is omitted from the request
     */
    ClientConfigurationError.createMissingSshJwkError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.missingSshJwk.code, ClientConfigurationErrorMessage.missingSshJwk.desc);
    };
    /**
     * Throws an error when the authentication scheme is set to SSH but the SSH public key ID is omitted from the request
     */
    ClientConfigurationError.createMissingSshKidError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.missingSshKid.code, ClientConfigurationErrorMessage.missingSshKid.desc);
    };
    /**
     * Throws error when provided headers don't contain a header that a server nonce can be extracted from
     */
    ClientConfigurationError.createMissingNonceAuthenticationHeadersError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.missingNonceAuthenticationHeader.code, ClientConfigurationErrorMessage.missingNonceAuthenticationHeader.desc);
    };
    /**
     * Throws error when a provided header is invalid in any way
     */
    ClientConfigurationError.createInvalidAuthenticationHeaderError = function (invalidHeaderName, details) {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidAuthenticationHeader.code, ClientConfigurationErrorMessage.invalidAuthenticationHeader.desc + ". Invalid header: " + invalidHeaderName + ". Details: " + details);
    };
    /**
     * Create an error when the authority provided in request does not match authority provided in account or MSAL.js configuration.
     */
    ClientConfigurationError.createAuthorityMismatchError = function () {
        return new ClientConfigurationError(ClientConfigurationErrorMessage.authorityMismatch.code, ClientConfigurationErrorMessage.authorityMismatch.desc);
    };
    return ClientConfigurationError;
}(ClientAuthError));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * The ScopeSet class creates a set of scopes. Scopes are case-insensitive, unique values, so the Set object in JS makes
 * the most sense to implement for this class. All scopes are trimmed and converted to lower case strings in intersection and union functions
 * to ensure uniqueness of strings.
 */
var ScopeSet = /** @class */ (function () {
    function ScopeSet(inputScopes) {
        var _this = this;
        // Filter empty string and null/undefined array items
        var scopeArr = inputScopes ? StringUtils.trimArrayEntries(__spreadArrays(inputScopes)) : [];
        var filteredInput = scopeArr ? StringUtils.removeEmptyStringsFromArray(scopeArr) : [];
        // Validate and filter scopes (validate function throws if validation fails)
        this.validateInputScopes(filteredInput);
        this.scopes = new Set(); // Iterator in constructor not supported by IE11
        filteredInput.forEach(function (scope) { return _this.scopes.add(scope); });
    }
    /**
     * Factory method to create ScopeSet from space-delimited string
     * @param inputScopeString
     * @param appClientId
     * @param scopesRequired
     */
    ScopeSet.fromString = function (inputScopeString) {
        var scopeString = inputScopeString || Constants.EMPTY_STRING;
        var inputScopes = scopeString.split(" ");
        return new ScopeSet(inputScopes);
    };
    /**
     * Creates the set of scopes to search for in cache lookups
     * @param inputScopeString
     * @returns
     */
    ScopeSet.createSearchScopes = function (inputScopeString) {
        var scopeSet = new ScopeSet(inputScopeString);
        if (!scopeSet.containsOnlyOIDCScopes()) {
            scopeSet.removeOIDCScopes();
        }
        else {
            scopeSet.removeScope(Constants.OFFLINE_ACCESS_SCOPE);
        }
        return scopeSet;
    };
    /**
     * Used to validate the scopes input parameter requested  by the developer.
     * @param {Array<string>} inputScopes - Developer requested permissions. Not all scopes are guaranteed to be included in the access token returned.
     * @param {boolean} scopesRequired - Boolean indicating whether the scopes array is required or not
     */
    ScopeSet.prototype.validateInputScopes = function (inputScopes) {
        // Check if scopes are required but not given or is an empty array
        if (!inputScopes || inputScopes.length < 1) {
            throw ClientConfigurationError.createEmptyScopesArrayError();
        }
    };
    /**
     * Check if a given scope is present in this set of scopes.
     * @param scope
     */
    ScopeSet.prototype.containsScope = function (scope) {
        var lowerCaseScopes = this.printScopesLowerCase().split(" ");
        var lowerCaseScopesSet = new ScopeSet(lowerCaseScopes);
        // compare lowercase scopes
        return !StringUtils.isEmpty(scope) ? lowerCaseScopesSet.scopes.has(scope.toLowerCase()) : false;
    };
    /**
     * Check if a set of scopes is present in this set of scopes.
     * @param scopeSet
     */
    ScopeSet.prototype.containsScopeSet = function (scopeSet) {
        var _this = this;
        if (!scopeSet || scopeSet.scopes.size <= 0) {
            return false;
        }
        return (this.scopes.size >= scopeSet.scopes.size && scopeSet.asArray().every(function (scope) { return _this.containsScope(scope); }));
    };
    /**
     * Check if set of scopes contains only the defaults
     */
    ScopeSet.prototype.containsOnlyOIDCScopes = function () {
        var _this = this;
        var defaultScopeCount = 0;
        OIDC_SCOPES.forEach(function (defaultScope) {
            if (_this.containsScope(defaultScope)) {
                defaultScopeCount += 1;
            }
        });
        return this.scopes.size === defaultScopeCount;
    };
    /**
     * Appends single scope if passed
     * @param newScope
     */
    ScopeSet.prototype.appendScope = function (newScope) {
        if (!StringUtils.isEmpty(newScope)) {
            this.scopes.add(newScope.trim());
        }
    };
    /**
     * Appends multiple scopes if passed
     * @param newScopes
     */
    ScopeSet.prototype.appendScopes = function (newScopes) {
        var _this = this;
        try {
            newScopes.forEach(function (newScope) { return _this.appendScope(newScope); });
        }
        catch (e) {
            throw ClientAuthError.createAppendScopeSetError(e);
        }
    };
    /**
     * Removes element from set of scopes.
     * @param scope
     */
    ScopeSet.prototype.removeScope = function (scope) {
        if (StringUtils.isEmpty(scope)) {
            throw ClientAuthError.createRemoveEmptyScopeFromSetError(scope);
        }
        this.scopes.delete(scope.trim());
    };
    /**
     * Removes default scopes from set of scopes
     * Primarily used to prevent cache misses if the default scopes are not returned from the server
     */
    ScopeSet.prototype.removeOIDCScopes = function () {
        var _this = this;
        OIDC_SCOPES.forEach(function (defaultScope) {
            _this.scopes.delete(defaultScope);
        });
    };
    /**
     * Combines an array of scopes with the current set of scopes.
     * @param otherScopes
     */
    ScopeSet.prototype.unionScopeSets = function (otherScopes) {
        if (!otherScopes) {
            throw ClientAuthError.createEmptyInputScopeSetError();
        }
        var unionScopes = new Set(); // Iterator in constructor not supported in IE11
        otherScopes.scopes.forEach(function (scope) { return unionScopes.add(scope.toLowerCase()); });
        this.scopes.forEach(function (scope) { return unionScopes.add(scope.toLowerCase()); });
        return unionScopes;
    };
    /**
     * Check if scopes intersect between this set and another.
     * @param otherScopes
     */
    ScopeSet.prototype.intersectingScopeSets = function (otherScopes) {
        if (!otherScopes) {
            throw ClientAuthError.createEmptyInputScopeSetError();
        }
        // Do not allow OIDC scopes to be the only intersecting scopes
        if (!otherScopes.containsOnlyOIDCScopes()) {
            otherScopes.removeOIDCScopes();
        }
        var unionScopes = this.unionScopeSets(otherScopes);
        var sizeOtherScopes = otherScopes.getScopeCount();
        var sizeThisScopes = this.getScopeCount();
        var sizeUnionScopes = unionScopes.size;
        return sizeUnionScopes < (sizeThisScopes + sizeOtherScopes);
    };
    /**
     * Returns size of set of scopes.
     */
    ScopeSet.prototype.getScopeCount = function () {
        return this.scopes.size;
    };
    /**
     * Returns the scopes as an array of string values
     */
    ScopeSet.prototype.asArray = function () {
        var array = [];
        this.scopes.forEach(function (val) { return array.push(val); });
        return array;
    };
    /**
     * Prints scopes into a space-delimited string
     */
    ScopeSet.prototype.printScopes = function () {
        if (this.scopes) {
            var scopeArr = this.asArray();
            return scopeArr.join(" ");
        }
        return Constants.EMPTY_STRING;
    };
    /**
     * Prints scopes into a space-delimited lower-case string (used for caching)
     */
    ScopeSet.prototype.printScopesLowerCase = function () {
        return this.printScopes().toLowerCase();
    };
    return ScopeSet;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Function to build a client info object from server clientInfo string
 * @param rawClientInfo
 * @param crypto
 */
function buildClientInfo(rawClientInfo, crypto) {
    if (StringUtils.isEmpty(rawClientInfo)) {
        throw ClientAuthError.createClientInfoEmptyError();
    }
    try {
        var decodedClientInfo = crypto.base64Decode(rawClientInfo);
        return JSON.parse(decodedClientInfo);
    }
    catch (e) {
        throw ClientAuthError.createClientInfoDecodingError(e.message);
    }
}
/**
 * Function to build a client info object from cached homeAccountId string
 * @param homeAccountId
 */
function buildClientInfoFromHomeAccountId(homeAccountId) {
    if (StringUtils.isEmpty(homeAccountId)) {
        throw ClientAuthError.createClientInfoDecodingError("Home account ID was empty.");
    }
    var clientInfoParts = homeAccountId.split(Separators.CLIENT_INFO_SEPARATOR, 2);
    return {
        uid: clientInfoParts[0],
        utid: clientInfoParts.length < 2 ? Constants.EMPTY_STRING : clientInfoParts[1]
    };
}

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Authority types supported by MSAL.
 */
var AuthorityType;
(function (AuthorityType) {
    AuthorityType[AuthorityType["Default"] = 0] = "Default";
    AuthorityType[AuthorityType["Adfs"] = 1] = "Adfs";
    AuthorityType[AuthorityType["Dsts"] = 2] = "Dsts";
    AuthorityType[AuthorityType["Ciam"] = 3] = "Ciam";
})(AuthorityType || (AuthorityType = {}));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Type that defines required and optional parameters for an Account field (based on universal cache schema implemented by all MSALs).
 *
 * Key : Value Schema
 *
 * Key: <home_account_id>-<environment>-<realm*>
 *
 * Value Schema:
 * {
 *      homeAccountId: home account identifier for the auth scheme,
 *      environment: entity that issued the token, represented as a full host
 *      realm: Full tenant or organizational identifier that the account belongs to
 *      localAccountId: Original tenant-specific accountID, usually used for legacy cases
 *      username: primary username that represents the user, usually corresponds to preferred_username in the v2 endpt
 *      authorityType: Accounts authority type as a string
 *      name: Full name for the account, including given name and family name,
 *      clientInfo: Full base64 encoded client info received from ESTS
 *      lastModificationTime: last time this entity was modified in the cache
 *      lastModificationApp:
 *      idTokenClaims: Object containing claims parsed from ID token
 *      nativeAccountId: Account identifier on the native device
 * }
 */
var AccountEntity = /** @class */ (function () {
    function AccountEntity() {
    }
    /**
     * Generate Account Id key component as per the schema: <home_account_id>-<environment>
     */
    AccountEntity.prototype.generateAccountId = function () {
        var accountId = [this.homeAccountId, this.environment];
        return accountId.join(Separators.CACHE_KEY_SEPARATOR).toLowerCase();
    };
    /**
     * Generate Account Cache Key as per the schema: <home_account_id>-<environment>-<realm*>
     */
    AccountEntity.prototype.generateAccountKey = function () {
        return AccountEntity.generateAccountCacheKey({
            homeAccountId: this.homeAccountId,
            environment: this.environment,
            tenantId: this.realm,
            username: this.username,
            localAccountId: this.localAccountId
        });
    };
    /**
     * returns the type of the cache (in this case account)
     */
    AccountEntity.prototype.generateType = function () {
        switch (this.authorityType) {
            case CacheAccountType.ADFS_ACCOUNT_TYPE:
                return CacheType.ADFS;
            case CacheAccountType.MSAV1_ACCOUNT_TYPE:
                return CacheType.MSA;
            case CacheAccountType.MSSTS_ACCOUNT_TYPE:
                return CacheType.MSSTS;
            case CacheAccountType.GENERIC_ACCOUNT_TYPE:
                return CacheType.GENERIC;
            default: {
                throw ClientAuthError.createUnexpectedAccountTypeError();
            }
        }
    };
    /**
     * Returns the AccountInfo interface for this account.
     */
    AccountEntity.prototype.getAccountInfo = function () {
        return {
            homeAccountId: this.homeAccountId,
            environment: this.environment,
            tenantId: this.realm,
            username: this.username,
            localAccountId: this.localAccountId,
            name: this.name,
            idTokenClaims: this.idTokenClaims,
            nativeAccountId: this.nativeAccountId
        };
    };
    /**
     * Generates account key from interface
     * @param accountInterface
     */
    AccountEntity.generateAccountCacheKey = function (accountInterface) {
        var accountKey = [
            accountInterface.homeAccountId,
            accountInterface.environment || Constants.EMPTY_STRING,
            accountInterface.tenantId || Constants.EMPTY_STRING,
        ];
        return accountKey.join(Separators.CACHE_KEY_SEPARATOR).toLowerCase();
    };
    /**
     * Build Account cache from IdToken, clientInfo and authority/policy. Associated with AAD.
     * @param clientInfo
     * @param authority
     * @param idToken
     * @param policy
     */
    AccountEntity.createAccount = function (clientInfo, homeAccountId, idToken, authority, cloudGraphHostName, msGraphHost, environment, nativeAccountId) {
        var _a, _b, _c, _d, _e, _f;
        var account = new AccountEntity();
        account.authorityType = CacheAccountType.MSSTS_ACCOUNT_TYPE;
        account.clientInfo = clientInfo;
        account.homeAccountId = homeAccountId;
        account.nativeAccountId = nativeAccountId;
        var env = environment || (authority && authority.getPreferredCache());
        if (!env) {
            throw ClientAuthError.createInvalidCacheEnvironmentError();
        }
        account.environment = env;
        // non AAD scenarios can have empty realm
        account.realm = ((_a = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _a === void 0 ? void 0 : _a.tid) || Constants.EMPTY_STRING;
        if (idToken) {
            account.idTokenClaims = idToken.claims;
            // How do you account for MSA CID here?
            account.localAccountId = ((_b = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _b === void 0 ? void 0 : _b.oid) || ((_c = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _c === void 0 ? void 0 : _c.sub) || Constants.EMPTY_STRING;
            /*
             * In B2C scenarios the emails claim is used instead of preferred_username and it is an array.
             * In most cases it will contain a single email. This field should not be relied upon if a custom
             * policy is configured to return more than 1 email.
             */
            var preferredUsername = (_d = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _d === void 0 ? void 0 : _d.preferred_username;
            var email = ((_e = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _e === void 0 ? void 0 : _e.emails) ? idToken.claims.emails[0] : null;
            account.username = preferredUsername || email || Constants.EMPTY_STRING;
            account.name = (_f = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _f === void 0 ? void 0 : _f.name;
        }
        account.cloudGraphHostName = cloudGraphHostName;
        account.msGraphHost = msGraphHost;
        return account;
    };
    /**
     * Builds non-AAD/ADFS account.
     * @param authority
     * @param idToken
     */
    AccountEntity.createGenericAccount = function (homeAccountId, idToken, authority, cloudGraphHostName, msGraphHost, environment) {
        var _a, _b, _c, _d;
        var account = new AccountEntity();
        account.authorityType = (authority &&
            authority.authorityType === AuthorityType.Adfs) ? CacheAccountType.ADFS_ACCOUNT_TYPE : CacheAccountType.GENERIC_ACCOUNT_TYPE;
        account.homeAccountId = homeAccountId;
        // non AAD scenarios can have empty realm
        account.realm = Constants.EMPTY_STRING;
        var env = environment || authority && authority.getPreferredCache();
        if (!env) {
            throw ClientAuthError.createInvalidCacheEnvironmentError();
        }
        if (idToken) {
            // How do you account for MSA CID here?
            account.localAccountId = ((_a = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _a === void 0 ? void 0 : _a.oid) || ((_b = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _b === void 0 ? void 0 : _b.sub) || Constants.EMPTY_STRING;
            // upn claim for most ADFS scenarios
            account.username = ((_c = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _c === void 0 ? void 0 : _c.upn) || Constants.EMPTY_STRING;
            account.name = ((_d = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _d === void 0 ? void 0 : _d.name) || Constants.EMPTY_STRING;
            account.idTokenClaims = idToken === null || idToken === void 0 ? void 0 : idToken.claims;
        }
        account.environment = env;
        account.cloudGraphHostName = cloudGraphHostName;
        account.msGraphHost = msGraphHost;
        /*
         * add uniqueName to claims
         * account.name = idToken.claims.uniqueName;
         */
        return account;
    };
    /**
     * Generate HomeAccountId from server response
     * @param serverClientInfo
     * @param authType
     */
    AccountEntity.generateHomeAccountId = function (serverClientInfo, authType, logger, cryptoObj, idToken) {
        var _a;
        var accountId = ((_a = idToken === null || idToken === void 0 ? void 0 : idToken.claims) === null || _a === void 0 ? void 0 : _a.sub) ? idToken.claims.sub : Constants.EMPTY_STRING;
        // since ADFS does not have tid and does not set client_info
        if (authType === AuthorityType.Adfs || authType === AuthorityType.Dsts) {
            return accountId;
        }
        // for cases where there is clientInfo
        if (serverClientInfo) {
            try {
                var clientInfo = buildClientInfo(serverClientInfo, cryptoObj);
                if (!StringUtils.isEmpty(clientInfo.uid) && !StringUtils.isEmpty(clientInfo.utid)) {
                    return "" + clientInfo.uid + Separators.CLIENT_INFO_SEPARATOR + clientInfo.utid;
                }
            }
            catch (e) { }
        }
        // default to "sub" claim
        logger.verbose("No client info in response");
        return accountId;
    };
    /**
     * Validates an entity: checks for all expected params
     * @param entity
     */
    AccountEntity.isAccountEntity = function (entity) {
        if (!entity) {
            return false;
        }
        return (entity.hasOwnProperty("homeAccountId") &&
            entity.hasOwnProperty("environment") &&
            entity.hasOwnProperty("realm") &&
            entity.hasOwnProperty("localAccountId") &&
            entity.hasOwnProperty("username") &&
            entity.hasOwnProperty("authorityType"));
    };
    /**
     * Helper function to determine whether 2 accountInfo objects represent the same account
     * @param accountA
     * @param accountB
     * @param compareClaims - If set to true idTokenClaims will also be compared to determine account equality
     */
    AccountEntity.accountInfoIsEqual = function (accountA, accountB, compareClaims) {
        if (!accountA || !accountB) {
            return false;
        }
        var claimsMatch = true; // default to true so as to not fail comparison below if compareClaims: false
        if (compareClaims) {
            var accountAClaims = (accountA.idTokenClaims || {});
            var accountBClaims = (accountB.idTokenClaims || {});
            // issued at timestamp and nonce are expected to change each time a new id token is acquired
            claimsMatch = (accountAClaims.iat === accountBClaims.iat) &&
                (accountAClaims.nonce === accountBClaims.nonce);
        }
        return (accountA.homeAccountId === accountB.homeAccountId) &&
            (accountA.localAccountId === accountB.localAccountId) &&
            (accountA.username === accountB.username) &&
            (accountA.tenantId === accountB.tenantId) &&
            (accountA.environment === accountB.environment) &&
            (accountA.nativeAccountId === accountB.nativeAccountId) &&
            claimsMatch;
    };
    return AccountEntity;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * JWT Token representation class. Parses token string and generates claims object.
 */
var AuthToken = /** @class */ (function () {
    function AuthToken(rawToken, crypto) {
        if (StringUtils.isEmpty(rawToken)) {
            throw ClientAuthError.createTokenNullOrEmptyError(rawToken);
        }
        this.rawToken = rawToken;
        this.claims = AuthToken.extractTokenClaims(rawToken, crypto);
    }
    /**
     * Extract token by decoding the rawToken
     *
     * @param encodedToken
     */
    AuthToken.extractTokenClaims = function (encodedToken, crypto) {
        var decodedToken = StringUtils.decodeAuthToken(encodedToken);
        // token will be decoded to get the username
        try {
            var base64TokenPayload = decodedToken.JWSPayload;
            // base64Decode() should throw an error if there is an issue
            var base64Decoded = crypto.base64Decode(base64TokenPayload);
            return JSON.parse(base64Decoded);
        }
        catch (err) {
            throw ClientAuthError.createTokenParsingError(err);
        }
    };
    /**
     * Determine if the token's max_age has transpired
     */
    AuthToken.checkMaxAge = function (authTime, maxAge) {
        /*
         * per https://openid.net/specs/openid-connect-core-1_0.html#AuthRequest
         * To force an immediate re-authentication: If an app requires that a user re-authenticate prior to access,
         * provide a value of 0 for the max_age parameter and the AS will force a fresh login.
         */
        var fiveMinuteSkew = 300000; // five minutes in milliseconds
        if ((maxAge === 0) || ((Date.now() - fiveMinuteSkew) > (authTime + maxAge))) {
            throw ClientAuthError.createMaxAgeTranspiredError();
        }
    };
    return AuthToken;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Interface class which implement cache storage functions used by MSAL to perform validity checks, and store tokens.
 */
var CacheManager = /** @class */ (function () {
    function CacheManager(clientId, cryptoImpl, logger) {
        this.clientId = clientId;
        this.cryptoImpl = cryptoImpl;
        this.commonLogger = logger.clone(name$1, version$1);
    }
    /**
     * Returns all accounts in cache
     */
    CacheManager.prototype.getAllAccounts = function () {
        var _this = this;
        var allAccountKeys = this.getAccountKeys();
        if (allAccountKeys.length < 1) {
            return [];
        }
        var accountEntities = allAccountKeys.reduce(function (accounts, key) {
            var entity = _this.getAccount(key);
            if (!entity) {
                return accounts;
            }
            accounts.push(entity);
            return accounts;
        }, []);
        if (accountEntities.length < 1) {
            return [];
        }
        else {
            var allAccounts = accountEntities.map(function (accountEntity) {
                return _this.getAccountInfoFromEntity(accountEntity);
            });
            return allAccounts;
        }
    };
    /**
     * Gets accountInfo object based on provided filters
     */
    CacheManager.prototype.getAccountInfoFilteredBy = function (accountFilter) {
        var allAccounts = this.getAccountsFilteredBy(accountFilter);
        if (allAccounts.length > 0) {
            return this.getAccountInfoFromEntity(allAccounts[0]);
        }
        else {
            return null;
        }
    };
    CacheManager.prototype.getAccountInfoFromEntity = function (accountEntity) {
        var accountInfo = accountEntity.getAccountInfo();
        var idToken = this.getIdToken(accountInfo);
        if (idToken) {
            accountInfo.idToken = idToken.secret;
            accountInfo.idTokenClaims = new AuthToken(idToken.secret, this.cryptoImpl).claims;
        }
        return accountInfo;
    };
    /**
     * saves a cache record
     * @param cacheRecord
     */
    CacheManager.prototype.saveCacheRecord = function (cacheRecord) {
        return __awaiter$2(this, void 0, void 0, function () {
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!cacheRecord) {
                            throw ClientAuthError.createNullOrUndefinedCacheRecord();
                        }
                        if (!!cacheRecord.account) {
                            this.setAccount(cacheRecord.account);
                        }
                        if (!!cacheRecord.idToken) {
                            this.setIdTokenCredential(cacheRecord.idToken);
                        }
                        if (!!!cacheRecord.accessToken) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.saveAccessToken(cacheRecord.accessToken)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (!!cacheRecord.refreshToken) {
                            this.setRefreshTokenCredential(cacheRecord.refreshToken);
                        }
                        if (!!cacheRecord.appMetadata) {
                            this.setAppMetadata(cacheRecord.appMetadata);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * saves access token credential
     * @param credential
     */
    CacheManager.prototype.saveAccessToken = function (credential) {
        return __awaiter$2(this, void 0, void 0, function () {
            var accessTokenFilter, tokenKeys, currentScopes, removedAccessTokens;
            var _this = this;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        accessTokenFilter = {
                            clientId: credential.clientId,
                            credentialType: credential.credentialType,
                            environment: credential.environment,
                            homeAccountId: credential.homeAccountId,
                            realm: credential.realm,
                            tokenType: credential.tokenType,
                            requestedClaimsHash: credential.requestedClaimsHash
                        };
                        tokenKeys = this.getTokenKeys();
                        currentScopes = ScopeSet.fromString(credential.target);
                        removedAccessTokens = [];
                        tokenKeys.accessToken.forEach(function (key) {
                            if (!_this.accessTokenKeyMatchesFilter(key, accessTokenFilter, false)) {
                                return;
                            }
                            var tokenEntity = _this.getAccessTokenCredential(key);
                            if (tokenEntity && _this.credentialMatchesFilter(tokenEntity, accessTokenFilter)) {
                                var tokenScopeSet = ScopeSet.fromString(tokenEntity.target);
                                if (tokenScopeSet.intersectingScopeSets(currentScopes)) {
                                    removedAccessTokens.push(_this.removeAccessToken(key));
                                }
                            }
                        });
                        return [4 /*yield*/, Promise.all(removedAccessTokens)];
                    case 1:
                        _a.sent();
                        this.setAccessTokenCredential(credential);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * retrieve accounts matching all provided filters; if no filter is set, get all accounts
     * not checking for casing as keys are all generated in lower case, remember to convert to lower case if object properties are compared
     * @param homeAccountId
     * @param environment
     * @param realm
     */
    CacheManager.prototype.getAccountsFilteredBy = function (accountFilter) {
        var _this = this;
        var allAccountKeys = this.getAccountKeys();
        var matchingAccounts = [];
        allAccountKeys.forEach(function (cacheKey) {
            if (!_this.isAccountKey(cacheKey, accountFilter.homeAccountId, accountFilter.realm)) {
                // Don't parse value if the key doesn't match the account filters
                return;
            }
            var entity = _this.getAccount(cacheKey);
            if (!entity) {
                return;
            }
            if (!!accountFilter.homeAccountId && !_this.matchHomeAccountId(entity, accountFilter.homeAccountId)) {
                return;
            }
            if (!!accountFilter.localAccountId && !_this.matchLocalAccountId(entity, accountFilter.localAccountId)) {
                return;
            }
            if (!!accountFilter.username && !_this.matchUsername(entity, accountFilter.username)) {
                return;
            }
            if (!!accountFilter.environment && !_this.matchEnvironment(entity, accountFilter.environment)) {
                return;
            }
            if (!!accountFilter.realm && !_this.matchRealm(entity, accountFilter.realm)) {
                return;
            }
            if (!!accountFilter.nativeAccountId && !_this.matchNativeAccountId(entity, accountFilter.nativeAccountId)) {
                return;
            }
            matchingAccounts.push(entity);
        });
        return matchingAccounts;
    };
    /**
     * Returns true if the given key matches our account key schema. Also matches homeAccountId and/or tenantId if provided
     * @param key
     * @param homeAccountId
     * @param tenantId
     * @returns
     */
    CacheManager.prototype.isAccountKey = function (key, homeAccountId, tenantId) {
        if (key.split(Separators.CACHE_KEY_SEPARATOR).length < 3) {
            // Account cache keys contain 3 items separated by '-' (each item may also contain '-')
            return false;
        }
        if (homeAccountId && !key.toLowerCase().includes(homeAccountId.toLowerCase())) {
            return false;
        }
        if (tenantId && !key.toLowerCase().includes(tenantId.toLowerCase())) {
            return false;
        }
        // Do not check environment as aliasing can cause false negatives
        return true;
    };
    /**
     * Returns true if the given key matches our credential key schema.
     * @param key
     */
    CacheManager.prototype.isCredentialKey = function (key) {
        if (key.split(Separators.CACHE_KEY_SEPARATOR).length < 6) {
            // Credential cache keys contain 6 items separated by '-' (each item may also contain '-')
            return false;
        }
        var lowerCaseKey = key.toLowerCase();
        // Credential keys must indicate what credential type they represent
        if (lowerCaseKey.indexOf(CredentialType.ID_TOKEN.toLowerCase()) === -1 &&
            lowerCaseKey.indexOf(CredentialType.ACCESS_TOKEN.toLowerCase()) === -1 &&
            lowerCaseKey.indexOf(CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME.toLowerCase()) === -1 &&
            lowerCaseKey.indexOf(CredentialType.REFRESH_TOKEN.toLowerCase()) === -1) {
            return false;
        }
        if (lowerCaseKey.indexOf(CredentialType.REFRESH_TOKEN.toLowerCase()) > -1) {
            // Refresh tokens must contain the client id or family id
            var clientIdValidation = "" + CredentialType.REFRESH_TOKEN + Separators.CACHE_KEY_SEPARATOR + this.clientId + Separators.CACHE_KEY_SEPARATOR;
            var familyIdValidation = "" + CredentialType.REFRESH_TOKEN + Separators.CACHE_KEY_SEPARATOR + THE_FAMILY_ID + Separators.CACHE_KEY_SEPARATOR;
            if (lowerCaseKey.indexOf(clientIdValidation.toLowerCase()) === -1 && lowerCaseKey.indexOf(familyIdValidation.toLowerCase()) === -1) {
                return false;
            }
        }
        else if (lowerCaseKey.indexOf(this.clientId.toLowerCase()) === -1) {
            // Tokens must contain the clientId
            return false;
        }
        return true;
    };
    /**
     * Returns whether or not the given credential entity matches the filter
     * @param entity
     * @param filter
     * @returns
     */
    CacheManager.prototype.credentialMatchesFilter = function (entity, filter) {
        if (!!filter.clientId && !this.matchClientId(entity, filter.clientId)) {
            return false;
        }
        if (!!filter.userAssertionHash && !this.matchUserAssertionHash(entity, filter.userAssertionHash)) {
            return false;
        }
        /*
         * homeAccountId can be undefined, and we want to filter out cached items that have a homeAccountId of ""
         * because we don't want a client_credential request to return a cached token that has a homeAccountId
         */
        if ((typeof filter.homeAccountId === "string") && !this.matchHomeAccountId(entity, filter.homeAccountId)) {
            return false;
        }
        if (!!filter.environment && !this.matchEnvironment(entity, filter.environment)) {
            return false;
        }
        if (!!filter.realm && !this.matchRealm(entity, filter.realm)) {
            return false;
        }
        if (!!filter.credentialType && !this.matchCredentialType(entity, filter.credentialType)) {
            return false;
        }
        if (!!filter.familyId && !this.matchFamilyId(entity, filter.familyId)) {
            return false;
        }
        /*
         * idTokens do not have "target", target specific refreshTokens do exist for some types of authentication
         * Resource specific refresh tokens case will be added when the support is deemed necessary
         */
        if (!!filter.target && !this.matchTarget(entity, filter.target)) {
            return false;
        }
        // If request OR cached entity has requested Claims Hash, check if they match
        if (filter.requestedClaimsHash || entity.requestedClaimsHash) {
            // Don't match if either is undefined or they are different
            if (entity.requestedClaimsHash !== filter.requestedClaimsHash) {
                return false;
            }
        }
        // Access Token with Auth Scheme specific matching
        if (entity.credentialType === CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME) {
            if (!!filter.tokenType && !this.matchTokenType(entity, filter.tokenType)) {
                return false;
            }
            // KeyId (sshKid) in request must match cached SSH certificate keyId because SSH cert is bound to a specific key
            if (filter.tokenType === AuthenticationScheme.SSH) {
                if (filter.keyId && !this.matchKeyId(entity, filter.keyId)) {
                    return false;
                }
            }
        }
        return true;
    };
    /**
     * retrieve appMetadata matching all provided filters; if no filter is set, get all appMetadata
     * @param filter
     */
    CacheManager.prototype.getAppMetadataFilteredBy = function (filter) {
        return this.getAppMetadataFilteredByInternal(filter.environment, filter.clientId);
    };
    /**
     * Support function to help match appMetadata
     * @param environment
     * @param clientId
     */
    CacheManager.prototype.getAppMetadataFilteredByInternal = function (environment, clientId) {
        var _this = this;
        var allCacheKeys = this.getKeys();
        var matchingAppMetadata = {};
        allCacheKeys.forEach(function (cacheKey) {
            // don't parse any non-appMetadata type cache entities
            if (!_this.isAppMetadata(cacheKey)) {
                return;
            }
            // Attempt retrieval
            var entity = _this.getAppMetadata(cacheKey);
            if (!entity) {
                return;
            }
            if (!!environment && !_this.matchEnvironment(entity, environment)) {
                return;
            }
            if (!!clientId && !_this.matchClientId(entity, clientId)) {
                return;
            }
            matchingAppMetadata[cacheKey] = entity;
        });
        return matchingAppMetadata;
    };
    /**
     * retrieve authorityMetadata that contains a matching alias
     * @param filter
     */
    CacheManager.prototype.getAuthorityMetadataByAlias = function (host) {
        var _this = this;
        var allCacheKeys = this.getAuthorityMetadataKeys();
        var matchedEntity = null;
        allCacheKeys.forEach(function (cacheKey) {
            // don't parse any non-authorityMetadata type cache entities
            if (!_this.isAuthorityMetadata(cacheKey) || cacheKey.indexOf(_this.clientId) === -1) {
                return;
            }
            // Attempt retrieval
            var entity = _this.getAuthorityMetadata(cacheKey);
            if (!entity) {
                return;
            }
            if (entity.aliases.indexOf(host) === -1) {
                return;
            }
            matchedEntity = entity;
        });
        return matchedEntity;
    };
    /**
     * Removes all accounts and related tokens from cache.
     */
    CacheManager.prototype.removeAllAccounts = function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var allAccountKeys, removedAccounts;
            var _this = this;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        allAccountKeys = this.getAccountKeys();
                        removedAccounts = [];
                        allAccountKeys.forEach(function (cacheKey) {
                            removedAccounts.push(_this.removeAccount(cacheKey));
                        });
                        return [4 /*yield*/, Promise.all(removedAccounts)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Removes the account and related tokens for a given account key
     * @param account
     */
    CacheManager.prototype.removeAccount = function (accountKey) {
        return __awaiter$2(this, void 0, void 0, function () {
            var account;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        account = this.getAccount(accountKey);
                        if (!account) {
                            throw ClientAuthError.createNoAccountFoundError();
                        }
                        return [4 /*yield*/, this.removeAccountContext(account)];
                    case 1:
                        _a.sent();
                        this.removeItem(accountKey);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Removes credentials associated with the provided account
     * @param account
     */
    CacheManager.prototype.removeAccountContext = function (account) {
        return __awaiter$2(this, void 0, void 0, function () {
            var allTokenKeys, accountId, removedCredentials;
            var _this = this;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        allTokenKeys = this.getTokenKeys();
                        accountId = account.generateAccountId();
                        removedCredentials = [];
                        allTokenKeys.idToken.forEach(function (key) {
                            if (key.indexOf(accountId) === 0) {
                                _this.removeIdToken(key);
                            }
                        });
                        allTokenKeys.accessToken.forEach(function (key) {
                            if (key.indexOf(accountId) === 0) {
                                removedCredentials.push(_this.removeAccessToken(key));
                            }
                        });
                        allTokenKeys.refreshToken.forEach(function (key) {
                            if (key.indexOf(accountId) === 0) {
                                _this.removeRefreshToken(key);
                            }
                        });
                        return [4 /*yield*/, Promise.all(removedCredentials)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * returns a boolean if the given credential is removed
     * @param credential
     */
    CacheManager.prototype.removeAccessToken = function (key) {
        return __awaiter$2(this, void 0, void 0, function () {
            var credential, accessTokenWithAuthSchemeEntity, kid;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        credential = this.getAccessTokenCredential(key);
                        if (!credential) {
                            return [2 /*return*/];
                        }
                        if (!(credential.credentialType.toLowerCase() === CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME.toLowerCase())) return [3 /*break*/, 4];
                        if (!(credential.tokenType === AuthenticationScheme.POP)) return [3 /*break*/, 4];
                        accessTokenWithAuthSchemeEntity = credential;
                        kid = accessTokenWithAuthSchemeEntity.keyId;
                        if (!kid) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.cryptoImpl.removeTokenBindingKey(kid)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _a.sent();
                        throw ClientAuthError.createBindingKeyNotRemovedError();
                    case 4: return [2 /*return*/, this.removeItem(key)];
                }
            });
        });
    };
    /**
     * Removes all app metadata objects from cache.
     */
    CacheManager.prototype.removeAppMetadata = function () {
        var _this = this;
        var allCacheKeys = this.getKeys();
        allCacheKeys.forEach(function (cacheKey) {
            if (_this.isAppMetadata(cacheKey)) {
                _this.removeItem(cacheKey);
            }
        });
        return true;
    };
    /**
     * Retrieve the cached credentials into a cacherecord
     * @param account
     * @param clientId
     * @param scopes
     * @param environment
     * @param authScheme
     */
    CacheManager.prototype.readCacheRecord = function (account, request, environment) {
        var tokenKeys = this.getTokenKeys();
        var cachedAccount = this.readAccountFromCache(account);
        var cachedIdToken = this.getIdToken(account, tokenKeys);
        var cachedAccessToken = this.getAccessToken(account, request, tokenKeys);
        var cachedRefreshToken = this.getRefreshToken(account, false, tokenKeys);
        var cachedAppMetadata = this.readAppMetadataFromCache(environment);
        if (cachedAccount && cachedIdToken) {
            cachedAccount.idTokenClaims = new AuthToken(cachedIdToken.secret, this.cryptoImpl).claims;
        }
        return {
            account: cachedAccount,
            idToken: cachedIdToken,
            accessToken: cachedAccessToken,
            refreshToken: cachedRefreshToken,
            appMetadata: cachedAppMetadata,
        };
    };
    /**
     * Retrieve AccountEntity from cache
     * @param account
     */
    CacheManager.prototype.readAccountFromCache = function (account) {
        var accountKey = AccountEntity.generateAccountCacheKey(account);
        return this.getAccount(accountKey);
    };
    /**
     * Retrieve IdTokenEntity from cache
     * @param clientId
     * @param account
     * @param inputRealm
     */
    CacheManager.prototype.getIdToken = function (account, tokenKeys) {
        var _this = this;
        this.commonLogger.trace("CacheManager - getIdToken called");
        var idTokenFilter = {
            homeAccountId: account.homeAccountId,
            environment: account.environment,
            credentialType: CredentialType.ID_TOKEN,
            clientId: this.clientId,
            realm: account.tenantId,
        };
        var idTokens = this.getIdTokensByFilter(idTokenFilter, tokenKeys);
        var numIdTokens = idTokens.length;
        if (numIdTokens < 1) {
            this.commonLogger.info("CacheManager:getIdToken - No token found");
            return null;
        }
        else if (numIdTokens > 1) {
            this.commonLogger.info("CacheManager:getIdToken - Multiple id tokens found, clearing them");
            idTokens.forEach(function (idToken) {
                _this.removeIdToken(idToken.generateCredentialKey());
            });
            return null;
        }
        this.commonLogger.info("CacheManager:getIdToken - Returning id token");
        return idTokens[0];
    };
    /**
     * Gets all idTokens matching the given filter
     * @param filter
     * @returns
     */
    CacheManager.prototype.getIdTokensByFilter = function (filter, tokenKeys) {
        var _this = this;
        var idTokenKeys = tokenKeys && tokenKeys.idToken || this.getTokenKeys().idToken;
        var idTokens = [];
        idTokenKeys.forEach(function (key) {
            if (!_this.idTokenKeyMatchesFilter(key, __assign$4({ clientId: _this.clientId }, filter))) {
                return;
            }
            var idToken = _this.getIdTokenCredential(key);
            if (idToken && _this.credentialMatchesFilter(idToken, filter)) {
                idTokens.push(idToken);
            }
        });
        return idTokens;
    };
    /**
     * Validate the cache key against filter before retrieving and parsing cache value
     * @param key
     * @param filter
     * @returns
     */
    CacheManager.prototype.idTokenKeyMatchesFilter = function (inputKey, filter) {
        var key = inputKey.toLowerCase();
        if (filter.clientId && key.indexOf(filter.clientId.toLowerCase()) === -1) {
            return false;
        }
        if (filter.homeAccountId && key.indexOf(filter.homeAccountId.toLowerCase()) === -1) {
            return false;
        }
        return true;
    };
    /**
     * Removes idToken from the cache
     * @param key
     */
    CacheManager.prototype.removeIdToken = function (key) {
        this.removeItem(key);
    };
    /**
     * Removes refresh token from the cache
     * @param key
     */
    CacheManager.prototype.removeRefreshToken = function (key) {
        this.removeItem(key);
    };
    /**
     * Retrieve AccessTokenEntity from cache
     * @param clientId
     * @param account
     * @param scopes
     * @param authScheme
     */
    CacheManager.prototype.getAccessToken = function (account, request, tokenKeys) {
        var _this = this;
        this.commonLogger.trace("CacheManager - getAccessToken called");
        var scopes = ScopeSet.createSearchScopes(request.scopes);
        var authScheme = request.authenticationScheme || AuthenticationScheme.BEARER;
        /*
         * Distinguish between Bearer and PoP/SSH token cache types
         * Cast to lowercase to handle "bearer" from ADFS
         */
        var credentialType = (authScheme && authScheme.toLowerCase() !== AuthenticationScheme.BEARER.toLowerCase()) ? CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME : CredentialType.ACCESS_TOKEN;
        var accessTokenFilter = {
            homeAccountId: account.homeAccountId,
            environment: account.environment,
            credentialType: credentialType,
            clientId: this.clientId,
            realm: account.tenantId,
            target: scopes,
            tokenType: authScheme,
            keyId: request.sshKid,
            requestedClaimsHash: request.requestedClaimsHash,
        };
        var accessTokenKeys = tokenKeys && tokenKeys.accessToken || this.getTokenKeys().accessToken;
        var accessTokens = [];
        accessTokenKeys.forEach(function (key) {
            // Validate key
            if (_this.accessTokenKeyMatchesFilter(key, accessTokenFilter, true)) {
                var accessToken = _this.getAccessTokenCredential(key);
                // Validate value
                if (accessToken && _this.credentialMatchesFilter(accessToken, accessTokenFilter)) {
                    accessTokens.push(accessToken);
                }
            }
        });
        var numAccessTokens = accessTokens.length;
        if (numAccessTokens < 1) {
            this.commonLogger.info("CacheManager:getAccessToken - No token found");
            return null;
        }
        else if (numAccessTokens > 1) {
            this.commonLogger.info("CacheManager:getAccessToken - Multiple access tokens found, clearing them");
            accessTokens.forEach(function (accessToken) {
                _this.removeAccessToken(accessToken.generateCredentialKey());
            });
            return null;
        }
        this.commonLogger.info("CacheManager:getAccessToken - Returning access token");
        return accessTokens[0];
    };
    /**
     * Validate the cache key against filter before retrieving and parsing cache value
     * @param key
     * @param filter
     * @param keyMustContainAllScopes
     * @returns
     */
    CacheManager.prototype.accessTokenKeyMatchesFilter = function (inputKey, filter, keyMustContainAllScopes) {
        var key = inputKey.toLowerCase();
        if (filter.clientId && key.indexOf(filter.clientId.toLowerCase()) === -1) {
            return false;
        }
        if (filter.homeAccountId && key.indexOf(filter.homeAccountId.toLowerCase()) === -1) {
            return false;
        }
        if (filter.realm && key.indexOf(filter.realm.toLowerCase()) === -1) {
            return false;
        }
        if (filter.requestedClaimsHash && key.indexOf(filter.requestedClaimsHash.toLowerCase()) === -1) {
            return false;
        }
        if (filter.target) {
            var scopes = filter.target.asArray();
            for (var i = 0; i < scopes.length; i++) {
                if (keyMustContainAllScopes && !key.includes(scopes[i].toLowerCase())) {
                    // When performing a cache lookup a missing scope would be a cache miss
                    return false;
                }
                else if (!keyMustContainAllScopes && key.includes(scopes[i].toLowerCase())) {
                    // When performing a cache write, any token with a subset of requested scopes should be replaced
                    return true;
                }
            }
        }
        return true;
    };
    /**
     * Gets all access tokens matching the filter
     * @param filter
     * @returns
     */
    CacheManager.prototype.getAccessTokensByFilter = function (filter) {
        var _this = this;
        var tokenKeys = this.getTokenKeys();
        var accessTokens = [];
        tokenKeys.accessToken.forEach(function (key) {
            if (!_this.accessTokenKeyMatchesFilter(key, filter, true)) {
                return;
            }
            var accessToken = _this.getAccessTokenCredential(key);
            if (accessToken && _this.credentialMatchesFilter(accessToken, filter)) {
                accessTokens.push(accessToken);
            }
        });
        return accessTokens;
    };
    /**
     * Helper to retrieve the appropriate refresh token from cache
     * @param clientId
     * @param account
     * @param familyRT
     */
    CacheManager.prototype.getRefreshToken = function (account, familyRT, tokenKeys) {
        var _this = this;
        this.commonLogger.trace("CacheManager - getRefreshToken called");
        var id = familyRT ? THE_FAMILY_ID : undefined;
        var refreshTokenFilter = {
            homeAccountId: account.homeAccountId,
            environment: account.environment,
            credentialType: CredentialType.REFRESH_TOKEN,
            clientId: this.clientId,
            familyId: id,
        };
        var refreshTokenKeys = tokenKeys && tokenKeys.refreshToken || this.getTokenKeys().refreshToken;
        var refreshTokens = [];
        refreshTokenKeys.forEach(function (key) {
            // Validate key
            if (_this.refreshTokenKeyMatchesFilter(key, refreshTokenFilter)) {
                var refreshToken = _this.getRefreshTokenCredential(key);
                // Validate value
                if (refreshToken && _this.credentialMatchesFilter(refreshToken, refreshTokenFilter)) {
                    refreshTokens.push(refreshToken);
                }
            }
        });
        var numRefreshTokens = refreshTokens.length;
        if (numRefreshTokens < 1) {
            this.commonLogger.info("CacheManager:getRefreshToken - No refresh token found.");
            return null;
        }
        // address the else case after remove functions address environment aliases
        this.commonLogger.info("CacheManager:getRefreshToken - returning refresh token");
        return refreshTokens[0];
    };
    /**
     * Validate the cache key against filter before retrieving and parsing cache value
     * @param key
     * @param filter
     */
    CacheManager.prototype.refreshTokenKeyMatchesFilter = function (inputKey, filter) {
        var key = inputKey.toLowerCase();
        if (filter.familyId && key.indexOf(filter.familyId.toLowerCase()) === -1) {
            return false;
        }
        // If familyId is used, clientId is not in the key
        if (!filter.familyId && filter.clientId && key.indexOf(filter.clientId.toLowerCase()) === -1) {
            return false;
        }
        if (filter.homeAccountId && key.indexOf(filter.homeAccountId.toLowerCase()) === -1) {
            return false;
        }
        return true;
    };
    /**
     * Retrieve AppMetadataEntity from cache
     */
    CacheManager.prototype.readAppMetadataFromCache = function (environment) {
        var appMetadataFilter = {
            environment: environment,
            clientId: this.clientId,
        };
        var appMetadata = this.getAppMetadataFilteredBy(appMetadataFilter);
        var appMetadataEntries = Object.keys(appMetadata).map(function (key) { return appMetadata[key]; });
        var numAppMetadata = appMetadataEntries.length;
        if (numAppMetadata < 1) {
            return null;
        }
        else if (numAppMetadata > 1) {
            throw ClientAuthError.createMultipleMatchingAppMetadataInCacheError();
        }
        return appMetadataEntries[0];
    };
    /**
     * Return the family_id value associated  with FOCI
     * @param environment
     * @param clientId
     */
    CacheManager.prototype.isAppMetadataFOCI = function (environment) {
        var appMetadata = this.readAppMetadataFromCache(environment);
        return !!(appMetadata && appMetadata.familyId === THE_FAMILY_ID);
    };
    /**
     * helper to match account ids
     * @param value
     * @param homeAccountId
     */
    CacheManager.prototype.matchHomeAccountId = function (entity, homeAccountId) {
        return !!((typeof entity.homeAccountId === "string") && (homeAccountId === entity.homeAccountId));
    };
    /**
     * helper to match account ids
     * @param entity
     * @param localAccountId
     * @returns
     */
    CacheManager.prototype.matchLocalAccountId = function (entity, localAccountId) {
        return !!((typeof entity.localAccountId === "string") && (localAccountId === entity.localAccountId));
    };
    /**
     * helper to match usernames
     * @param entity
     * @param username
     * @returns
     */
    CacheManager.prototype.matchUsername = function (entity, username) {
        return !!((typeof entity.username === "string") && (username.toLowerCase() === entity.username.toLowerCase()));
    };
    /**
     * helper to match assertion
     * @param value
     * @param oboAssertion
     */
    CacheManager.prototype.matchUserAssertionHash = function (entity, userAssertionHash) {
        return !!(entity.userAssertionHash && userAssertionHash === entity.userAssertionHash);
    };
    /**
     * helper to match environment
     * @param value
     * @param environment
     */
    CacheManager.prototype.matchEnvironment = function (entity, environment) {
        var cloudMetadata = this.getAuthorityMetadataByAlias(environment);
        if (cloudMetadata && cloudMetadata.aliases.indexOf(entity.environment) > -1) {
            return true;
        }
        return false;
    };
    /**
     * helper to match credential type
     * @param entity
     * @param credentialType
     */
    CacheManager.prototype.matchCredentialType = function (entity, credentialType) {
        return (entity.credentialType && credentialType.toLowerCase() === entity.credentialType.toLowerCase());
    };
    /**
     * helper to match client ids
     * @param entity
     * @param clientId
     */
    CacheManager.prototype.matchClientId = function (entity, clientId) {
        return !!(entity.clientId && clientId === entity.clientId);
    };
    /**
     * helper to match family ids
     * @param entity
     * @param familyId
     */
    CacheManager.prototype.matchFamilyId = function (entity, familyId) {
        return !!(entity.familyId && familyId === entity.familyId);
    };
    /**
     * helper to match realm
     * @param entity
     * @param realm
     */
    CacheManager.prototype.matchRealm = function (entity, realm) {
        return !!(entity.realm && realm === entity.realm);
    };
    /**
     * helper to match nativeAccountId
     * @param entity
     * @param nativeAccountId
     * @returns boolean indicating the match result
     */
    CacheManager.prototype.matchNativeAccountId = function (entity, nativeAccountId) {
        return !!(entity.nativeAccountId && nativeAccountId === entity.nativeAccountId);
    };
    /**
     * Returns true if the target scopes are a subset of the current entity's scopes, false otherwise.
     * @param entity
     * @param target
     */
    CacheManager.prototype.matchTarget = function (entity, target) {
        var isNotAccessTokenCredential = (entity.credentialType !== CredentialType.ACCESS_TOKEN && entity.credentialType !== CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME);
        if (isNotAccessTokenCredential || !entity.target) {
            return false;
        }
        var entityScopeSet = ScopeSet.fromString(entity.target);
        return entityScopeSet.containsScopeSet(target);
    };
    /**
     * Returns true if the credential's tokenType or Authentication Scheme matches the one in the request, false otherwise
     * @param entity
     * @param tokenType
     */
    CacheManager.prototype.matchTokenType = function (entity, tokenType) {
        return !!(entity.tokenType && entity.tokenType === tokenType);
    };
    /**
     * Returns true if the credential's keyId matches the one in the request, false otherwise
     * @param entity
     * @param tokenType
     */
    CacheManager.prototype.matchKeyId = function (entity, keyId) {
        return !!(entity.keyId && entity.keyId === keyId);
    };
    /**
     * returns if a given cache entity is of the type appmetadata
     * @param key
     */
    CacheManager.prototype.isAppMetadata = function (key) {
        return key.indexOf(APP_METADATA) !== -1;
    };
    /**
     * returns if a given cache entity is of the type authoritymetadata
     * @param key
     */
    CacheManager.prototype.isAuthorityMetadata = function (key) {
        return key.indexOf(AUTHORITY_METADATA_CONSTANTS.CACHE_KEY) !== -1;
    };
    /**
     * returns cache key used for cloud instance metadata
     */
    CacheManager.prototype.generateAuthorityMetadataCacheKey = function (authority) {
        return AUTHORITY_METADATA_CONSTANTS.CACHE_KEY + "-" + this.clientId + "-" + authority;
    };
    /**
     * Helper to convert serialized data to object
     * @param obj
     * @param json
     */
    CacheManager.toObject = function (obj, json) {
        for (var propertyName in json) {
            obj[propertyName] = json[propertyName];
        }
        return obj;
    };
    return CacheManager;
}());
var DefaultStorageClass = /** @class */ (function (_super) {
    __extends$f(DefaultStorageClass, _super);
    function DefaultStorageClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultStorageClass.prototype.setAccount = function () {
        var notImplErr = "Storage interface - setAccount() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getAccount = function () {
        var notImplErr = "Storage interface - getAccount() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.setIdTokenCredential = function () {
        var notImplErr = "Storage interface - setIdTokenCredential() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getIdTokenCredential = function () {
        var notImplErr = "Storage interface - getIdTokenCredential() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.setAccessTokenCredential = function () {
        var notImplErr = "Storage interface - setAccessTokenCredential() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getAccessTokenCredential = function () {
        var notImplErr = "Storage interface - getAccessTokenCredential() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.setRefreshTokenCredential = function () {
        var notImplErr = "Storage interface - setRefreshTokenCredential() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getRefreshTokenCredential = function () {
        var notImplErr = "Storage interface - getRefreshTokenCredential() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.setAppMetadata = function () {
        var notImplErr = "Storage interface - setAppMetadata() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getAppMetadata = function () {
        var notImplErr = "Storage interface - getAppMetadata() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.setServerTelemetry = function () {
        var notImplErr = "Storage interface - setServerTelemetry() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getServerTelemetry = function () {
        var notImplErr = "Storage interface - getServerTelemetry() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.setAuthorityMetadata = function () {
        var notImplErr = "Storage interface - setAuthorityMetadata() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getAuthorityMetadata = function () {
        var notImplErr = "Storage interface - getAuthorityMetadata() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getAuthorityMetadataKeys = function () {
        var notImplErr = "Storage interface - getAuthorityMetadataKeys() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.setThrottlingCache = function () {
        var notImplErr = "Storage interface - setThrottlingCache() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getThrottlingCache = function () {
        var notImplErr = "Storage interface - getThrottlingCache() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.removeItem = function () {
        var notImplErr = "Storage interface - removeItem() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.containsKey = function () {
        var notImplErr = "Storage interface - containsKey() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getKeys = function () {
        var notImplErr = "Storage interface - getKeys() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getAccountKeys = function () {
        var notImplErr = "Storage interface - getAccountKeys() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.getTokenKeys = function () {
        var notImplErr = "Storage interface - getTokenKeys() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    DefaultStorageClass.prototype.clear = function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Storage interface - clear() has not been implemented for the cacheStorage interface.";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    };
    DefaultStorageClass.prototype.updateCredentialCacheKey = function () {
        var notImplErr = "Storage interface - updateCredentialCacheKey() has not been implemented for the cacheStorage interface.";
        throw AuthError.createUnexpectedError(notImplErr);
    };
    return DefaultStorageClass;
}(CacheManager));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
// Token renewal offset default in seconds
var DEFAULT_TOKEN_RENEWAL_OFFSET_SEC = 300;
var DEFAULT_SYSTEM_OPTIONS = {
    tokenRenewalOffsetSeconds: DEFAULT_TOKEN_RENEWAL_OFFSET_SEC,
    preventCorsPreflight: false
};
var DEFAULT_LOGGER_IMPLEMENTATION = {
    loggerCallback: function () {
        // allow users to not set loggerCallback
    },
    piiLoggingEnabled: false,
    logLevel: LogLevel.Info,
    correlationId: Constants.EMPTY_STRING
};
var DEFAULT_CACHE_OPTIONS = {
    claimsBasedCachingEnabled: true
};
var DEFAULT_NETWORK_IMPLEMENTATION = {
    sendGetRequestAsync: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Network interface - sendGetRequestAsync() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    },
    sendPostRequestAsync: function () {
        return __awaiter$2(this, void 0, void 0, function () {
            var notImplErr;
            return __generator$2(this, function (_a) {
                notImplErr = "Network interface - sendPostRequestAsync() has not been implemented";
                throw AuthError.createUnexpectedError(notImplErr);
            });
        });
    }
};
var DEFAULT_LIBRARY_INFO = {
    sku: Constants.SKU,
    version: version$1,
    cpu: Constants.EMPTY_STRING,
    os: Constants.EMPTY_STRING
};
var DEFAULT_CLIENT_CREDENTIALS = {
    clientSecret: Constants.EMPTY_STRING,
    clientAssertion: undefined
};
var DEFAULT_AZURE_CLOUD_OPTIONS = {
    azureCloudInstance: AzureCloudInstance.None,
    tenant: "" + Constants.DEFAULT_COMMON_TENANT
};
var DEFAULT_TELEMETRY_OPTIONS = {
    application: {
        appName: "",
        appVersion: ""
    }
};
/**
 * Function that sets the default options when not explicitly configured from app developer
 *
 * @param Configuration
 *
 * @returns Configuration
 */
function buildClientConfiguration(_a) {
    var userAuthOptions = _a.authOptions, userSystemOptions = _a.systemOptions, userLoggerOption = _a.loggerOptions, userCacheOptions = _a.cacheOptions, storageImplementation = _a.storageInterface, networkImplementation = _a.networkInterface, cryptoImplementation = _a.cryptoInterface, clientCredentials = _a.clientCredentials, libraryInfo = _a.libraryInfo, telemetry = _a.telemetry, serverTelemetryManager = _a.serverTelemetryManager, persistencePlugin = _a.persistencePlugin, serializableCache = _a.serializableCache;
    var loggerOptions = __assign$4(__assign$4({}, DEFAULT_LOGGER_IMPLEMENTATION), userLoggerOption);
    return {
        authOptions: buildAuthOptions(userAuthOptions),
        systemOptions: __assign$4(__assign$4({}, DEFAULT_SYSTEM_OPTIONS), userSystemOptions),
        loggerOptions: loggerOptions,
        cacheOptions: __assign$4(__assign$4({}, DEFAULT_CACHE_OPTIONS), userCacheOptions),
        storageInterface: storageImplementation || new DefaultStorageClass(userAuthOptions.clientId, DEFAULT_CRYPTO_IMPLEMENTATION, new Logger(loggerOptions)),
        networkInterface: networkImplementation || DEFAULT_NETWORK_IMPLEMENTATION,
        cryptoInterface: cryptoImplementation || DEFAULT_CRYPTO_IMPLEMENTATION,
        clientCredentials: clientCredentials || DEFAULT_CLIENT_CREDENTIALS,
        libraryInfo: __assign$4(__assign$4({}, DEFAULT_LIBRARY_INFO), libraryInfo),
        telemetry: __assign$4(__assign$4({}, DEFAULT_TELEMETRY_OPTIONS), telemetry),
        serverTelemetryManager: serverTelemetryManager || null,
        persistencePlugin: persistencePlugin || null,
        serializableCache: serializableCache || null,
    };
}
/**
 * Construct authoptions from the client and platform passed values
 * @param authOptions
 */
function buildAuthOptions(authOptions) {
    return __assign$4({ clientCapabilities: [], azureCloudOptions: DEFAULT_AZURE_CLOUD_OPTIONS, skipAuthorityMetadataCache: false }, authOptions);
}

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Error thrown when there is an error with the server code, for example, unavailability.
 */
var ServerError = /** @class */ (function (_super) {
    __extends$f(ServerError, _super);
    function ServerError(errorCode, errorMessage, subError) {
        var _this = _super.call(this, errorCode, errorMessage, subError) || this;
        _this.name = "ServerError";
        Object.setPrototypeOf(_this, ServerError.prototype);
        return _this;
    }
    return ServerError;
}(AuthError));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var ThrottlingUtils = /** @class */ (function () {
    function ThrottlingUtils() {
    }
    /**
     * Prepares a RequestThumbprint to be stored as a key.
     * @param thumbprint
     */
    ThrottlingUtils.generateThrottlingStorageKey = function (thumbprint) {
        return ThrottlingConstants.THROTTLING_PREFIX + "." + JSON.stringify(thumbprint);
    };
    /**
     * Performs necessary throttling checks before a network request.
     * @param cacheManager
     * @param thumbprint
     */
    ThrottlingUtils.preProcess = function (cacheManager, thumbprint) {
        var _a;
        var key = ThrottlingUtils.generateThrottlingStorageKey(thumbprint);
        var value = cacheManager.getThrottlingCache(key);
        if (value) {
            if (value.throttleTime < Date.now()) {
                cacheManager.removeItem(key);
                return;
            }
            throw new ServerError(((_a = value.errorCodes) === null || _a === void 0 ? void 0 : _a.join(" ")) || Constants.EMPTY_STRING, value.errorMessage, value.subError);
        }
    };
    /**
     * Performs necessary throttling checks after a network request.
     * @param cacheManager
     * @param thumbprint
     * @param response
     */
    ThrottlingUtils.postProcess = function (cacheManager, thumbprint, response) {
        if (ThrottlingUtils.checkResponseStatus(response) || ThrottlingUtils.checkResponseForRetryAfter(response)) {
            var thumbprintValue = {
                throttleTime: ThrottlingUtils.calculateThrottleTime(parseInt(response.headers[HeaderNames.RETRY_AFTER])),
                error: response.body.error,
                errorCodes: response.body.error_codes,
                errorMessage: response.body.error_description,
                subError: response.body.suberror
            };
            cacheManager.setThrottlingCache(ThrottlingUtils.generateThrottlingStorageKey(thumbprint), thumbprintValue);
        }
    };
    /**
     * Checks a NetworkResponse object's status codes against 429 or 5xx
     * @param response
     */
    ThrottlingUtils.checkResponseStatus = function (response) {
        return response.status === 429 || response.status >= 500 && response.status < 600;
    };
    /**
     * Checks a NetworkResponse object's RetryAfter header
     * @param response
     */
    ThrottlingUtils.checkResponseForRetryAfter = function (response) {
        if (response.headers) {
            return response.headers.hasOwnProperty(HeaderNames.RETRY_AFTER) && (response.status < 200 || response.status >= 300);
        }
        return false;
    };
    /**
     * Calculates the Unix-time value for a throttle to expire given throttleTime in seconds.
     * @param throttleTime
     */
    ThrottlingUtils.calculateThrottleTime = function (throttleTime) {
        var time = throttleTime <= 0 ? 0 : throttleTime;
        var currentSeconds = Date.now() / 1000;
        return Math.floor(Math.min(currentSeconds + (time || ThrottlingConstants.DEFAULT_THROTTLE_TIME_SECONDS), currentSeconds + ThrottlingConstants.DEFAULT_MAX_THROTTLE_TIME_SECONDS) * 1000);
    };
    ThrottlingUtils.removeThrottle = function (cacheManager, clientId, request, homeAccountIdentifier) {
        var thumbprint = {
            clientId: clientId,
            authority: request.authority,
            scopes: request.scopes,
            homeAccountIdentifier: homeAccountIdentifier,
            claims: request.claims,
            authenticationScheme: request.authenticationScheme,
            resourceRequestMethod: request.resourceRequestMethod,
            resourceRequestUri: request.resourceRequestUri,
            shrClaims: request.shrClaims,
            sshKid: request.sshKid
        };
        var key = this.generateThrottlingStorageKey(thumbprint);
        cacheManager.removeItem(key);
    };
    return ThrottlingUtils;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var NetworkManager = /** @class */ (function () {
    function NetworkManager(networkClient, cacheManager) {
        this.networkClient = networkClient;
        this.cacheManager = cacheManager;
    }
    /**
     * Wraps sendPostRequestAsync with necessary preflight and postflight logic
     * @param thumbprint
     * @param tokenEndpoint
     * @param options
     */
    NetworkManager.prototype.sendPostRequest = function (thumbprint, tokenEndpoint, options) {
        return __awaiter$2(this, void 0, void 0, function () {
            var response, e_1;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ThrottlingUtils.preProcess(this.cacheManager, thumbprint);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.networkClient.sendPostRequestAsync(tokenEndpoint, options)];
                    case 2:
                        response = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        if (e_1 instanceof AuthError) {
                            throw e_1;
                        }
                        else {
                            throw ClientAuthError.createNetworkError(tokenEndpoint, e_1);
                        }
                    case 4:
                        ThrottlingUtils.postProcess(this.cacheManager, thumbprint, response);
                        return [2 /*return*/, response];
                }
            });
        });
    };
    return NetworkManager;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var CcsCredentialType;
(function (CcsCredentialType) {
    CcsCredentialType["HOME_ACCOUNT_ID"] = "home_account_id";
    CcsCredentialType["UPN"] = "UPN";
})(CcsCredentialType || (CcsCredentialType = {}));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Validates server consumable params from the "request" objects
 */
var RequestValidator = /** @class */ (function () {
    function RequestValidator() {
    }
    /**
     * Utility to check if the `redirectUri` in the request is a non-null value
     * @param redirectUri
     */
    RequestValidator.validateRedirectUri = function (redirectUri) {
        if (StringUtils.isEmpty(redirectUri)) {
            throw ClientConfigurationError.createRedirectUriEmptyError();
        }
    };
    /**
     * Utility to validate prompt sent by the user in the request
     * @param prompt
     */
    RequestValidator.validatePrompt = function (prompt) {
        var promptValues = [];
        for (var value in PromptValue) {
            promptValues.push(PromptValue[value]);
        }
        if (promptValues.indexOf(prompt) < 0) {
            throw ClientConfigurationError.createInvalidPromptError(prompt);
        }
    };
    RequestValidator.validateClaims = function (claims) {
        try {
            JSON.parse(claims);
        }
        catch (e) {
            throw ClientConfigurationError.createInvalidClaimsRequestError();
        }
    };
    /**
     * Utility to validate code_challenge and code_challenge_method
     * @param codeChallenge
     * @param codeChallengeMethod
     */
    RequestValidator.validateCodeChallengeParams = function (codeChallenge, codeChallengeMethod) {
        if (StringUtils.isEmpty(codeChallenge) || StringUtils.isEmpty(codeChallengeMethod)) {
            throw ClientConfigurationError.createInvalidCodeChallengeParamsError();
        }
        else {
            this.validateCodeChallengeMethod(codeChallengeMethod);
        }
    };
    /**
     * Utility to validate code_challenge_method
     * @param codeChallengeMethod
     */
    RequestValidator.validateCodeChallengeMethod = function (codeChallengeMethod) {
        if ([
            CodeChallengeMethodValues.PLAIN,
            CodeChallengeMethodValues.S256
        ].indexOf(codeChallengeMethod) < 0) {
            throw ClientConfigurationError.createInvalidCodeChallengeMethodError();
        }
    };
    /**
     * Removes unnecessary, duplicate, and empty string query parameters from extraQueryParameters
     * @param request
     */
    RequestValidator.sanitizeEQParams = function (eQParams, queryParams) {
        if (!eQParams) {
            return {};
        }
        // Remove any query parameters already included in SSO params
        queryParams.forEach(function (value, key) {
            if (eQParams[key]) {
                delete eQParams[key];
            }
        });
        // remove empty string parameters
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        return Object.fromEntries(Object.entries(eQParams).filter(function (_a) {
            var value = _a[1];
            return value !== "";
        }));
    };
    return RequestValidator;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var RequestParameterBuilder = /** @class */ (function () {
    function RequestParameterBuilder() {
        this.parameters = new Map();
    }
    /**
     * add response_type = code
     */
    RequestParameterBuilder.prototype.addResponseTypeCode = function () {
        this.parameters.set(AADServerParamKeys.RESPONSE_TYPE, encodeURIComponent(Constants.CODE_RESPONSE_TYPE));
    };
    /**
     * add response_type = token id_token
     */
    RequestParameterBuilder.prototype.addResponseTypeForTokenAndIdToken = function () {
        this.parameters.set(AADServerParamKeys.RESPONSE_TYPE, encodeURIComponent(Constants.TOKEN_RESPONSE_TYPE + " " + Constants.ID_TOKEN_RESPONSE_TYPE));
    };
    /**
     * add response_mode. defaults to query.
     * @param responseMode
     */
    RequestParameterBuilder.prototype.addResponseMode = function (responseMode) {
        this.parameters.set(AADServerParamKeys.RESPONSE_MODE, encodeURIComponent((responseMode) ? responseMode : ResponseMode.QUERY));
    };
    /**
     * Add flag to indicate STS should attempt to use WAM if available
     */
    RequestParameterBuilder.prototype.addNativeBroker = function () {
        this.parameters.set(AADServerParamKeys.NATIVE_BROKER, encodeURIComponent("1"));
    };
    /**
     * add scopes. set addOidcScopes to false to prevent default scopes in non-user scenarios
     * @param scopeSet
     * @param addOidcScopes
     */
    RequestParameterBuilder.prototype.addScopes = function (scopes, addOidcScopes) {
        if (addOidcScopes === void 0) { addOidcScopes = true; }
        var requestScopes = addOidcScopes ? __spreadArrays(scopes || [], OIDC_DEFAULT_SCOPES) : scopes || [];
        var scopeSet = new ScopeSet(requestScopes);
        this.parameters.set(AADServerParamKeys.SCOPE, encodeURIComponent(scopeSet.printScopes()));
    };
    /**
     * add clientId
     * @param clientId
     */
    RequestParameterBuilder.prototype.addClientId = function (clientId) {
        this.parameters.set(AADServerParamKeys.CLIENT_ID, encodeURIComponent(clientId));
    };
    /**
     * add redirect_uri
     * @param redirectUri
     */
    RequestParameterBuilder.prototype.addRedirectUri = function (redirectUri) {
        RequestValidator.validateRedirectUri(redirectUri);
        this.parameters.set(AADServerParamKeys.REDIRECT_URI, encodeURIComponent(redirectUri));
    };
    /**
     * add post logout redirectUri
     * @param redirectUri
     */
    RequestParameterBuilder.prototype.addPostLogoutRedirectUri = function (redirectUri) {
        RequestValidator.validateRedirectUri(redirectUri);
        this.parameters.set(AADServerParamKeys.POST_LOGOUT_URI, encodeURIComponent(redirectUri));
    };
    /**
     * add id_token_hint to logout request
     * @param idTokenHint
     */
    RequestParameterBuilder.prototype.addIdTokenHint = function (idTokenHint) {
        this.parameters.set(AADServerParamKeys.ID_TOKEN_HINT, encodeURIComponent(idTokenHint));
    };
    /**
     * add domain_hint
     * @param domainHint
     */
    RequestParameterBuilder.prototype.addDomainHint = function (domainHint) {
        this.parameters.set(SSOTypes.DOMAIN_HINT, encodeURIComponent(domainHint));
    };
    /**
     * add login_hint
     * @param loginHint
     */
    RequestParameterBuilder.prototype.addLoginHint = function (loginHint) {
        this.parameters.set(SSOTypes.LOGIN_HINT, encodeURIComponent(loginHint));
    };
    /**
     * Adds the CCS (Cache Credential Service) query parameter for login_hint
     * @param loginHint
     */
    RequestParameterBuilder.prototype.addCcsUpn = function (loginHint) {
        this.parameters.set(HeaderNames.CCS_HEADER, encodeURIComponent("UPN:" + loginHint));
    };
    /**
     * Adds the CCS (Cache Credential Service) query parameter for account object
     * @param loginHint
     */
    RequestParameterBuilder.prototype.addCcsOid = function (clientInfo) {
        this.parameters.set(HeaderNames.CCS_HEADER, encodeURIComponent("Oid:" + clientInfo.uid + "@" + clientInfo.utid));
    };
    /**
     * add sid
     * @param sid
     */
    RequestParameterBuilder.prototype.addSid = function (sid) {
        this.parameters.set(SSOTypes.SID, encodeURIComponent(sid));
    };
    /**
     * add claims
     * @param claims
     */
    RequestParameterBuilder.prototype.addClaims = function (claims, clientCapabilities) {
        var mergedClaims = this.addClientCapabilitiesToClaims(claims, clientCapabilities);
        RequestValidator.validateClaims(mergedClaims);
        this.parameters.set(AADServerParamKeys.CLAIMS, encodeURIComponent(mergedClaims));
    };
    /**
     * add correlationId
     * @param correlationId
     */
    RequestParameterBuilder.prototype.addCorrelationId = function (correlationId) {
        this.parameters.set(AADServerParamKeys.CLIENT_REQUEST_ID, encodeURIComponent(correlationId));
    };
    /**
     * add library info query params
     * @param libraryInfo
     */
    RequestParameterBuilder.prototype.addLibraryInfo = function (libraryInfo) {
        // Telemetry Info
        this.parameters.set(AADServerParamKeys.X_CLIENT_SKU, libraryInfo.sku);
        this.parameters.set(AADServerParamKeys.X_CLIENT_VER, libraryInfo.version);
        if (libraryInfo.os) {
            this.parameters.set(AADServerParamKeys.X_CLIENT_OS, libraryInfo.os);
        }
        if (libraryInfo.cpu) {
            this.parameters.set(AADServerParamKeys.X_CLIENT_CPU, libraryInfo.cpu);
        }
    };
    /**
     * Add client telemetry parameters
     * @param appTelemetry
     */
    RequestParameterBuilder.prototype.addApplicationTelemetry = function (appTelemetry) {
        if (appTelemetry === null || appTelemetry === void 0 ? void 0 : appTelemetry.appName) {
            this.parameters.set(AADServerParamKeys.X_APP_NAME, appTelemetry.appName);
        }
        if (appTelemetry === null || appTelemetry === void 0 ? void 0 : appTelemetry.appVersion) {
            this.parameters.set(AADServerParamKeys.X_APP_VER, appTelemetry.appVersion);
        }
    };
    /**
     * add prompt
     * @param prompt
     */
    RequestParameterBuilder.prototype.addPrompt = function (prompt) {
        RequestValidator.validatePrompt(prompt);
        this.parameters.set("" + AADServerParamKeys.PROMPT, encodeURIComponent(prompt));
    };
    /**
     * add state
     * @param state
     */
    RequestParameterBuilder.prototype.addState = function (state) {
        if (!StringUtils.isEmpty(state)) {
            this.parameters.set(AADServerParamKeys.STATE, encodeURIComponent(state));
        }
    };
    /**
     * add nonce
     * @param nonce
     */
    RequestParameterBuilder.prototype.addNonce = function (nonce) {
        this.parameters.set(AADServerParamKeys.NONCE, encodeURIComponent(nonce));
    };
    /**
     * add code_challenge and code_challenge_method
     * - throw if either of them are not passed
     * @param codeChallenge
     * @param codeChallengeMethod
     */
    RequestParameterBuilder.prototype.addCodeChallengeParams = function (codeChallenge, codeChallengeMethod) {
        RequestValidator.validateCodeChallengeParams(codeChallenge, codeChallengeMethod);
        if (codeChallenge && codeChallengeMethod) {
            this.parameters.set(AADServerParamKeys.CODE_CHALLENGE, encodeURIComponent(codeChallenge));
            this.parameters.set(AADServerParamKeys.CODE_CHALLENGE_METHOD, encodeURIComponent(codeChallengeMethod));
        }
        else {
            throw ClientConfigurationError.createInvalidCodeChallengeParamsError();
        }
    };
    /**
     * add the `authorization_code` passed by the user to exchange for a token
     * @param code
     */
    RequestParameterBuilder.prototype.addAuthorizationCode = function (code) {
        this.parameters.set(AADServerParamKeys.CODE, encodeURIComponent(code));
    };
    /**
     * add the `authorization_code` passed by the user to exchange for a token
     * @param code
     */
    RequestParameterBuilder.prototype.addDeviceCode = function (code) {
        this.parameters.set(AADServerParamKeys.DEVICE_CODE, encodeURIComponent(code));
    };
    /**
     * add the `refreshToken` passed by the user
     * @param refreshToken
     */
    RequestParameterBuilder.prototype.addRefreshToken = function (refreshToken) {
        this.parameters.set(AADServerParamKeys.REFRESH_TOKEN, encodeURIComponent(refreshToken));
    };
    /**
     * add the `code_verifier` passed by the user to exchange for a token
     * @param codeVerifier
     */
    RequestParameterBuilder.prototype.addCodeVerifier = function (codeVerifier) {
        this.parameters.set(AADServerParamKeys.CODE_VERIFIER, encodeURIComponent(codeVerifier));
    };
    /**
     * add client_secret
     * @param clientSecret
     */
    RequestParameterBuilder.prototype.addClientSecret = function (clientSecret) {
        this.parameters.set(AADServerParamKeys.CLIENT_SECRET, encodeURIComponent(clientSecret));
    };
    /**
     * add clientAssertion for confidential client flows
     * @param clientAssertion
     */
    RequestParameterBuilder.prototype.addClientAssertion = function (clientAssertion) {
        if (!StringUtils.isEmpty(clientAssertion)) {
            this.parameters.set(AADServerParamKeys.CLIENT_ASSERTION, encodeURIComponent(clientAssertion));
        }
    };
    /**
     * add clientAssertionType for confidential client flows
     * @param clientAssertionType
     */
    RequestParameterBuilder.prototype.addClientAssertionType = function (clientAssertionType) {
        if (!StringUtils.isEmpty(clientAssertionType)) {
            this.parameters.set(AADServerParamKeys.CLIENT_ASSERTION_TYPE, encodeURIComponent(clientAssertionType));
        }
    };
    /**
     * add OBO assertion for confidential client flows
     * @param clientAssertion
     */
    RequestParameterBuilder.prototype.addOboAssertion = function (oboAssertion) {
        this.parameters.set(AADServerParamKeys.OBO_ASSERTION, encodeURIComponent(oboAssertion));
    };
    /**
     * add grant type
     * @param grantType
     */
    RequestParameterBuilder.prototype.addRequestTokenUse = function (tokenUse) {
        this.parameters.set(AADServerParamKeys.REQUESTED_TOKEN_USE, encodeURIComponent(tokenUse));
    };
    /**
     * add grant type
     * @param grantType
     */
    RequestParameterBuilder.prototype.addGrantType = function (grantType) {
        this.parameters.set(AADServerParamKeys.GRANT_TYPE, encodeURIComponent(grantType));
    };
    /**
     * add client info
     *
     */
    RequestParameterBuilder.prototype.addClientInfo = function () {
        this.parameters.set(CLIENT_INFO, "1");
    };
    /**
     * add extraQueryParams
     * @param eQParams
     */
    RequestParameterBuilder.prototype.addExtraQueryParameters = function (eQParams) {
        var _this = this;
        var sanitizedEQParams = RequestValidator.sanitizeEQParams(eQParams, this.parameters);
        Object.keys(sanitizedEQParams).forEach(function (key) {
            _this.parameters.set(key, eQParams[key]);
        });
    };
    RequestParameterBuilder.prototype.addClientCapabilitiesToClaims = function (claims, clientCapabilities) {
        var mergedClaims;
        // Parse provided claims into JSON object or initialize empty object
        if (!claims) {
            mergedClaims = {};
        }
        else {
            try {
                mergedClaims = JSON.parse(claims);
            }
            catch (e) {
                throw ClientConfigurationError.createInvalidClaimsRequestError();
            }
        }
        if (clientCapabilities && clientCapabilities.length > 0) {
            if (!mergedClaims.hasOwnProperty(ClaimsRequestKeys.ACCESS_TOKEN)) {
                // Add access_token key to claims object
                mergedClaims[ClaimsRequestKeys.ACCESS_TOKEN] = {};
            }
            // Add xms_cc claim with provided clientCapabilities to access_token key
            mergedClaims[ClaimsRequestKeys.ACCESS_TOKEN][ClaimsRequestKeys.XMS_CC] = {
                values: clientCapabilities
            };
        }
        return JSON.stringify(mergedClaims);
    };
    /**
     * adds `username` for Password Grant flow
     * @param username
     */
    RequestParameterBuilder.prototype.addUsername = function (username) {
        this.parameters.set(PasswordGrantConstants.username, encodeURIComponent(username));
    };
    /**
     * adds `password` for Password Grant flow
     * @param password
     */
    RequestParameterBuilder.prototype.addPassword = function (password) {
        this.parameters.set(PasswordGrantConstants.password, encodeURIComponent(password));
    };
    /**
     * add pop_jwk to query params
     * @param cnfString
     */
    RequestParameterBuilder.prototype.addPopToken = function (cnfString) {
        if (!StringUtils.isEmpty(cnfString)) {
            this.parameters.set(AADServerParamKeys.TOKEN_TYPE, AuthenticationScheme.POP);
            this.parameters.set(AADServerParamKeys.REQ_CNF, encodeURIComponent(cnfString));
        }
    };
    /**
     * add SSH JWK and key ID to query params
     */
    RequestParameterBuilder.prototype.addSshJwk = function (sshJwkString) {
        if (!StringUtils.isEmpty(sshJwkString)) {
            this.parameters.set(AADServerParamKeys.TOKEN_TYPE, AuthenticationScheme.SSH);
            this.parameters.set(AADServerParamKeys.REQ_CNF, encodeURIComponent(sshJwkString));
        }
    };
    /**
     * add server telemetry fields
     * @param serverTelemetryManager
     */
    RequestParameterBuilder.prototype.addServerTelemetry = function (serverTelemetryManager) {
        this.parameters.set(AADServerParamKeys.X_CLIENT_CURR_TELEM, serverTelemetryManager.generateCurrentRequestHeaderValue());
        this.parameters.set(AADServerParamKeys.X_CLIENT_LAST_TELEM, serverTelemetryManager.generateLastRequestHeaderValue());
    };
    /**
     * Adds parameter that indicates to the server that throttling is supported
     */
    RequestParameterBuilder.prototype.addThrottling = function () {
        this.parameters.set(AADServerParamKeys.X_MS_LIB_CAPABILITY, ThrottlingConstants.X_MS_LIB_CAPABILITY_VALUE);
    };
    /**
     * Adds logout_hint parameter for "silent" logout which prevent server account picker
     */
    RequestParameterBuilder.prototype.addLogoutHint = function (logoutHint) {
        this.parameters.set(AADServerParamKeys.LOGOUT_HINT, encodeURIComponent(logoutHint));
    };
    /**
     * Utility to create a URL from the params map
     */
    RequestParameterBuilder.prototype.createQueryString = function () {
        var queryParameterArray = new Array();
        this.parameters.forEach(function (value, key) {
            queryParameterArray.push(key + "=" + value);
        });
        return queryParameterArray.join("&");
    };
    return RequestParameterBuilder;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Base application class which will construct requests to send to and handle responses from the Microsoft STS using the authorization code flow.
 */
var BaseClient = /** @class */ (function () {
    function BaseClient(configuration, performanceClient) {
        // Set the configuration
        this.config = buildClientConfiguration(configuration);
        // Initialize the logger
        this.logger = new Logger(this.config.loggerOptions, name$1, version$1);
        // Initialize crypto
        this.cryptoUtils = this.config.cryptoInterface;
        // Initialize storage interface
        this.cacheManager = this.config.storageInterface;
        // Set the network interface
        this.networkClient = this.config.networkInterface;
        // Set the NetworkManager
        this.networkManager = new NetworkManager(this.networkClient, this.cacheManager);
        // Set TelemetryManager
        this.serverTelemetryManager = this.config.serverTelemetryManager;
        // set Authority
        this.authority = this.config.authOptions.authority;
        // set performance telemetry client
        this.performanceClient = performanceClient;
    }
    /**
     * Creates default headers for requests to token endpoint
     */
    BaseClient.prototype.createTokenRequestHeaders = function (ccsCred) {
        var headers = {};
        headers[HeaderNames.CONTENT_TYPE] = Constants.URL_FORM_CONTENT_TYPE;
        if (!this.config.systemOptions.preventCorsPreflight && ccsCred) {
            switch (ccsCred.type) {
                case CcsCredentialType.HOME_ACCOUNT_ID:
                    try {
                        var clientInfo = buildClientInfoFromHomeAccountId(ccsCred.credential);
                        headers[HeaderNames.CCS_HEADER] = "Oid:" + clientInfo.uid + "@" + clientInfo.utid;
                    }
                    catch (e) {
                        this.logger.verbose("Could not parse home account ID for CCS Header: " + e);
                    }
                    break;
                case CcsCredentialType.UPN:
                    headers[HeaderNames.CCS_HEADER] = "UPN: " + ccsCred.credential;
                    break;
            }
        }
        return headers;
    };
    /**
     * Http post to token endpoint
     * @param tokenEndpoint
     * @param queryString
     * @param headers
     * @param thumbprint
     */
    BaseClient.prototype.executePostToTokenEndpoint = function (tokenEndpoint, queryString, headers, thumbprint) {
        return __awaiter$2(this, void 0, void 0, function () {
            var response;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.networkManager.sendPostRequest(thumbprint, tokenEndpoint, { body: queryString, headers: headers })];
                    case 1:
                        response = _a.sent();
                        if (this.config.serverTelemetryManager && response.status < 500 && response.status !== 429) {
                            // Telemetry data successfully logged by server, clear Telemetry cache
                            this.config.serverTelemetryManager.clearTelemetryCache();
                        }
                        return [2 /*return*/, response];
                }
            });
        });
    };
    /**
     * Updates the authority object of the client. Endpoint discovery must be completed.
     * @param updatedAuthority
     */
    BaseClient.prototype.updateAuthority = function (updatedAuthority) {
        if (!updatedAuthority.discoveryComplete()) {
            throw ClientAuthError.createEndpointDiscoveryIncompleteError("Updated authority has not completed endpoint discovery.");
        }
        this.authority = updatedAuthority;
    };
    /**
     * Creates query string for the /token request
     * @param request
     */
    BaseClient.prototype.createTokenQueryParameters = function (request) {
        var parameterBuilder = new RequestParameterBuilder();
        if (request.tokenQueryParameters) {
            parameterBuilder.addExtraQueryParameters(request.tokenQueryParameters);
        }
        return parameterBuilder.createQueryString();
    };
    return BaseClient;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Base type for credentials to be stored in the cache: eg: ACCESS_TOKEN, ID_TOKEN etc
 *
 * Key:Value Schema:
 *
 * Key: <home_account_id*>-<environment>-<credential_type>-<client_id>-<realm*>-<target*>-<requestedClaims*>-<scheme*>
 *
 * Value Schema:
 * {
 *      homeAccountId: home account identifier for the auth scheme,
 *      environment: entity that issued the token, represented as a full host
 *      credentialType: Type of credential as a string, can be one of the following: RefreshToken, AccessToken, IdToken, Password, Cookie, Certificate, Other
 *      clientId: client ID of the application
 *      secret: Actual credential as a string
 *      familyId: Family ID identifier, usually only used for refresh tokens
 *      realm: Full tenant or organizational identifier that the account belongs to
 *      target: Permissions that are included in the token, or for refresh tokens, the resource identifier.
 *      tokenType: Matches the authentication scheme for which the token was issued (i.e. Bearer or pop)
 *      requestedClaimsHash: Matches the SHA 256 hash of the claims object included in the token request
 *      userAssertionHash: Matches the SHA 256 hash of the obo_assertion for the OBO flow
 * }
 */
var CredentialEntity = /** @class */ (function () {
    function CredentialEntity() {
    }
    /**
     * Generate Account Id key component as per the schema: <home_account_id>-<environment>
     */
    CredentialEntity.prototype.generateAccountId = function () {
        return CredentialEntity.generateAccountIdForCacheKey(this.homeAccountId, this.environment);
    };
    /**
     * Generate Credential Id key component as per the schema: <credential_type>-<client_id>-<realm>
     */
    CredentialEntity.prototype.generateCredentialId = function () {
        return CredentialEntity.generateCredentialIdForCacheKey(this.credentialType, this.clientId, this.realm, this.familyId);
    };
    /**
     * Generate target key component as per schema: <target>
     */
    CredentialEntity.prototype.generateTarget = function () {
        return CredentialEntity.generateTargetForCacheKey(this.target);
    };
    /**
     * generates credential key
     */
    CredentialEntity.prototype.generateCredentialKey = function () {
        return CredentialEntity.generateCredentialCacheKey(this.homeAccountId, this.environment, this.credentialType, this.clientId, this.realm, this.target, this.familyId, this.tokenType, this.requestedClaimsHash);
    };
    /**
     * returns the type of the cache (in this case credential)
     */
    CredentialEntity.prototype.generateType = function () {
        switch (this.credentialType) {
            case CredentialType.ID_TOKEN:
                return CacheType.ID_TOKEN;
            case CredentialType.ACCESS_TOKEN:
            case CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME:
                return CacheType.ACCESS_TOKEN;
            case CredentialType.REFRESH_TOKEN:
                return CacheType.REFRESH_TOKEN;
            default: {
                throw ClientAuthError.createUnexpectedCredentialTypeError();
            }
        }
    };
    /**
     * generates credential key
     * <home_account_id*>-\<environment>-<credential_type>-<client_id>-<realm\*>-<target\*>-<scheme\*>
     */
    CredentialEntity.generateCredentialCacheKey = function (homeAccountId, environment, credentialType, clientId, realm, target, familyId, tokenType, requestedClaimsHash) {
        var credentialKey = [
            this.generateAccountIdForCacheKey(homeAccountId, environment),
            this.generateCredentialIdForCacheKey(credentialType, clientId, realm, familyId),
            this.generateTargetForCacheKey(target),
            this.generateClaimsHashForCacheKey(requestedClaimsHash),
            this.generateSchemeForCacheKey(tokenType)
        ];
        return credentialKey.join(Separators.CACHE_KEY_SEPARATOR).toLowerCase();
    };
    /**
     * generates Account Id for keys
     * @param homeAccountId
     * @param environment
     */
    CredentialEntity.generateAccountIdForCacheKey = function (homeAccountId, environment) {
        var accountId = [homeAccountId, environment];
        return accountId.join(Separators.CACHE_KEY_SEPARATOR).toLowerCase();
    };
    /**
     * Generates Credential Id for keys
     * @param credentialType
     * @param realm
     * @param clientId
     * @param familyId
     */
    CredentialEntity.generateCredentialIdForCacheKey = function (credentialType, clientId, realm, familyId) {
        var clientOrFamilyId = credentialType === CredentialType.REFRESH_TOKEN
            ? familyId || clientId
            : clientId;
        var credentialId = [
            credentialType,
            clientOrFamilyId,
            realm || Constants.EMPTY_STRING,
        ];
        return credentialId.join(Separators.CACHE_KEY_SEPARATOR).toLowerCase();
    };
    /**
     * Generate target key component as per schema: <target>
     */
    CredentialEntity.generateTargetForCacheKey = function (scopes) {
        return (scopes || Constants.EMPTY_STRING).toLowerCase();
    };
    /**
     * Generate requested claims key component as per schema: <requestedClaims>
     */
    CredentialEntity.generateClaimsHashForCacheKey = function (requestedClaimsHash) {
        return (requestedClaimsHash || Constants.EMPTY_STRING).toLowerCase();
    };
    /**
     * Generate scheme key componenet as per schema: <scheme>
     */
    CredentialEntity.generateSchemeForCacheKey = function (tokenType) {
        /*
         * PoP Tokens and SSH certs include scheme in cache key
         * Cast to lowercase to handle "bearer" from ADFS
         */
        return (tokenType && tokenType.toLowerCase() !== AuthenticationScheme.BEARER.toLowerCase()) ? tokenType.toLowerCase() : Constants.EMPTY_STRING;
    };
    return CredentialEntity;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * ID_TOKEN Cache
 *
 * Key:Value Schema:
 *
 * Key Example: uid.utid-login.microsoftonline.com-idtoken-clientId-contoso.com-
 *
 * Value Schema:
 * {
 *      homeAccountId: home account identifier for the auth scheme,
 *      environment: entity that issued the token, represented as a full host
 *      credentialType: Type of credential as a string, can be one of the following: RefreshToken, AccessToken, IdToken, Password, Cookie, Certificate, Other
 *      clientId: client ID of the application
 *      secret: Actual credential as a string
 *      realm: Full tenant or organizational identifier that the account belongs to
 * }
 */
var IdTokenEntity = /** @class */ (function (_super) {
    __extends$f(IdTokenEntity, _super);
    function IdTokenEntity() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Create IdTokenEntity
     * @param homeAccountId
     * @param authenticationResult
     * @param clientId
     * @param authority
     */
    IdTokenEntity.createIdTokenEntity = function (homeAccountId, environment, idToken, clientId, tenantId) {
        var idTokenEntity = new IdTokenEntity();
        idTokenEntity.credentialType = CredentialType.ID_TOKEN;
        idTokenEntity.homeAccountId = homeAccountId;
        idTokenEntity.environment = environment;
        idTokenEntity.clientId = clientId;
        idTokenEntity.secret = idToken;
        idTokenEntity.realm = tenantId;
        return idTokenEntity;
    };
    /**
     * Validates an entity: checks for all expected params
     * @param entity
     */
    IdTokenEntity.isIdTokenEntity = function (entity) {
        if (!entity) {
            return false;
        }
        return (entity.hasOwnProperty("homeAccountId") &&
            entity.hasOwnProperty("environment") &&
            entity.hasOwnProperty("credentialType") &&
            entity.hasOwnProperty("realm") &&
            entity.hasOwnProperty("clientId") &&
            entity.hasOwnProperty("secret") &&
            entity["credentialType"] === CredentialType.ID_TOKEN);
    };
    return IdTokenEntity;
}(CredentialEntity));

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Utility class which exposes functions for managing date and time operations.
 */
var TimeUtils = /** @class */ (function () {
    function TimeUtils() {
    }
    /**
     * return the current time in Unix time (seconds).
     */
    TimeUtils.nowSeconds = function () {
        // Date.getTime() returns in milliseconds.
        return Math.round(new Date().getTime() / 1000.0);
    };
    /**
     * check if a token is expired based on given UTC time in seconds.
     * @param expiresOn
     */
    TimeUtils.isTokenExpired = function (expiresOn, offset) {
        // check for access token expiry
        var expirationSec = Number(expiresOn) || 0;
        var offsetCurrentTimeSec = TimeUtils.nowSeconds() + offset;
        // If current time + offset is greater than token expiration time, then token is expired.
        return (offsetCurrentTimeSec > expirationSec);
    };
    /**
     * If the current time is earlier than the time that a token was cached at, we must discard the token
     * i.e. The system clock was turned back after acquiring the cached token
     * @param cachedAt
     * @param offset
     */
    TimeUtils.wasClockTurnedBack = function (cachedAt) {
        var cachedAtSec = Number(cachedAt);
        return cachedAtSec > TimeUtils.nowSeconds();
    };
    /**
     * Waits for t number of milliseconds
     * @param t number
     * @param value T
     */
    TimeUtils.delay = function (t, value) {
        return new Promise(function (resolve) { return setTimeout(function () { return resolve(value); }, t); });
    };
    return TimeUtils;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * ACCESS_TOKEN Credential Type
 *
 * Key:Value Schema:
 *
 * Key Example: uid.utid-login.microsoftonline.com-accesstoken-clientId-contoso.com-user.read
 *
 * Value Schema:
 * {
 *      homeAccountId: home account identifier for the auth scheme,
 *      environment: entity that issued the token, represented as a full host
 *      credentialType: Type of credential as a string, can be one of the following: RefreshToken, AccessToken, IdToken, Password, Cookie, Certificate, Other
 *      clientId: client ID of the application
 *      secret: Actual credential as a string
 *      familyId: Family ID identifier, usually only used for refresh tokens
 *      realm: Full tenant or organizational identifier that the account belongs to
 *      target: Permissions that are included in the token, or for refresh tokens, the resource identifier.
 *      cachedAt: Absolute device time when entry was created in the cache.
 *      expiresOn: Token expiry time, calculated based on current UTC time in seconds. Represented as a string.
 *      extendedExpiresOn: Additional extended expiry time until when token is valid in case of server-side outage. Represented as string in UTC seconds.
 *      keyId: used for POP and SSH tokenTypes
 *      tokenType: Type of the token issued. Usually "Bearer"
 * }
 */
var AccessTokenEntity = /** @class */ (function (_super) {
    __extends$f(AccessTokenEntity, _super);
    function AccessTokenEntity() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Create AccessTokenEntity
     * @param homeAccountId
     * @param environment
     * @param accessToken
     * @param clientId
     * @param tenantId
     * @param scopes
     * @param expiresOn
     * @param extExpiresOn
     */
    AccessTokenEntity.createAccessTokenEntity = function (homeAccountId, environment, accessToken, clientId, tenantId, scopes, expiresOn, extExpiresOn, cryptoUtils, refreshOn, tokenType, userAssertionHash, keyId, requestedClaims, requestedClaimsHash) {
        var _a, _b;
        var atEntity = new AccessTokenEntity();
        atEntity.homeAccountId = homeAccountId;
        atEntity.credentialType = CredentialType.ACCESS_TOKEN;
        atEntity.secret = accessToken;
        var currentTime = TimeUtils.nowSeconds();
        atEntity.cachedAt = currentTime.toString();
        /*
         * Token expiry time.
         * This value should be  calculated based on the current UTC time measured locally and the value  expires_in Represented as a string in JSON.
         */
        atEntity.expiresOn = expiresOn.toString();
        atEntity.extendedExpiresOn = extExpiresOn.toString();
        if (refreshOn) {
            atEntity.refreshOn = refreshOn.toString();
        }
        atEntity.environment = environment;
        atEntity.clientId = clientId;
        atEntity.realm = tenantId;
        atEntity.target = scopes;
        atEntity.userAssertionHash = userAssertionHash;
        atEntity.tokenType = StringUtils.isEmpty(tokenType) ? AuthenticationScheme.BEARER : tokenType;
        if (requestedClaims) {
            atEntity.requestedClaims = requestedClaims;
            atEntity.requestedClaimsHash = requestedClaimsHash;
        }
        /*
         * Create Access Token With Auth Scheme instead of regular access token
         * Cast to lower to handle "bearer" from ADFS
         */
        if (((_a = atEntity.tokenType) === null || _a === void 0 ? void 0 : _a.toLowerCase()) !== AuthenticationScheme.BEARER.toLowerCase()) {
            atEntity.credentialType = CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME;
            switch (atEntity.tokenType) {
                case AuthenticationScheme.POP:
                    // Make sure keyId is present and add it to credential
                    var tokenClaims = AuthToken.extractTokenClaims(accessToken, cryptoUtils);
                    if (!((_b = tokenClaims === null || tokenClaims === void 0 ? void 0 : tokenClaims.cnf) === null || _b === void 0 ? void 0 : _b.kid)) {
                        throw ClientAuthError.createTokenClaimsRequiredError();
                    }
                    atEntity.keyId = tokenClaims.cnf.kid;
                    break;
                case AuthenticationScheme.SSH:
                    atEntity.keyId = keyId;
            }
        }
        return atEntity;
    };
    /**
     * Validates an entity: checks for all expected params
     * @param entity
     */
    AccessTokenEntity.isAccessTokenEntity = function (entity) {
        if (!entity) {
            return false;
        }
        return (entity.hasOwnProperty("homeAccountId") &&
            entity.hasOwnProperty("environment") &&
            entity.hasOwnProperty("credentialType") &&
            entity.hasOwnProperty("realm") &&
            entity.hasOwnProperty("clientId") &&
            entity.hasOwnProperty("secret") &&
            entity.hasOwnProperty("target") &&
            (entity["credentialType"] === CredentialType.ACCESS_TOKEN || entity["credentialType"] === CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME));
    };
    return AccessTokenEntity;
}(CredentialEntity));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * REFRESH_TOKEN Cache
 *
 * Key:Value Schema:
 *
 * Key Example: uid.utid-login.microsoftonline.com-refreshtoken-clientId--
 *
 * Value:
 * {
 *      homeAccountId: home account identifier for the auth scheme,
 *      environment: entity that issued the token, represented as a full host
 *      credentialType: Type of credential as a string, can be one of the following: RefreshToken, AccessToken, IdToken, Password, Cookie, Certificate, Other
 *      clientId: client ID of the application
 *      secret: Actual credential as a string
 *      familyId: Family ID identifier, '1' represents Microsoft Family
 *      realm: Full tenant or organizational identifier that the account belongs to
 *      target: Permissions that are included in the token, or for refresh tokens, the resource identifier.
 * }
 */
var RefreshTokenEntity = /** @class */ (function (_super) {
    __extends$f(RefreshTokenEntity, _super);
    function RefreshTokenEntity() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Create RefreshTokenEntity
     * @param homeAccountId
     * @param authenticationResult
     * @param clientId
     * @param authority
     */
    RefreshTokenEntity.createRefreshTokenEntity = function (homeAccountId, environment, refreshToken, clientId, familyId, userAssertionHash) {
        var rtEntity = new RefreshTokenEntity();
        rtEntity.clientId = clientId;
        rtEntity.credentialType = CredentialType.REFRESH_TOKEN;
        rtEntity.environment = environment;
        rtEntity.homeAccountId = homeAccountId;
        rtEntity.secret = refreshToken;
        rtEntity.userAssertionHash = userAssertionHash;
        if (familyId)
            rtEntity.familyId = familyId;
        return rtEntity;
    };
    /**
     * Validates an entity: checks for all expected params
     * @param entity
     */
    RefreshTokenEntity.isRefreshTokenEntity = function (entity) {
        if (!entity) {
            return false;
        }
        return (entity.hasOwnProperty("homeAccountId") &&
            entity.hasOwnProperty("environment") &&
            entity.hasOwnProperty("credentialType") &&
            entity.hasOwnProperty("clientId") &&
            entity.hasOwnProperty("secret") &&
            entity["credentialType"] === CredentialType.REFRESH_TOKEN);
    };
    return RefreshTokenEntity;
}(CredentialEntity));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * InteractionRequiredServerErrorMessage contains string constants used by error codes and messages returned by the server indicating interaction is required
 */
var InteractionRequiredServerErrorMessage = [
    "interaction_required",
    "consent_required",
    "login_required"
];
var InteractionRequiredAuthSubErrorMessage = [
    "message_only",
    "additional_action",
    "basic_action",
    "user_password_expired",
    "consent_required"
];
/**
 * Interaction required errors defined by the SDK
 */
var InteractionRequiredAuthErrorMessage = {
    noTokensFoundError: {
        code: "no_tokens_found",
        desc: "No refresh token found in the cache. Please sign-in."
    },
    native_account_unavailable: {
        code: "native_account_unavailable",
        desc: "The requested account is not available in the native broker. It may have been deleted or logged out. Please sign-in again using an interactive API."
    }
};
/**
 * Error thrown when user interaction is required.
 */
var InteractionRequiredAuthError = /** @class */ (function (_super) {
    __extends$f(InteractionRequiredAuthError, _super);
    function InteractionRequiredAuthError(errorCode, errorMessage, subError, timestamp, traceId, correlationId, claims) {
        var _this = _super.call(this, errorCode, errorMessage, subError) || this;
        Object.setPrototypeOf(_this, InteractionRequiredAuthError.prototype);
        _this.timestamp = timestamp || Constants.EMPTY_STRING;
        _this.traceId = traceId || Constants.EMPTY_STRING;
        _this.correlationId = correlationId || Constants.EMPTY_STRING;
        _this.claims = claims || Constants.EMPTY_STRING;
        _this.name = "InteractionRequiredAuthError";
        return _this;
    }
    /**
     * Helper function used to determine if an error thrown by the server requires interaction to resolve
     * @param errorCode
     * @param errorString
     * @param subError
     */
    InteractionRequiredAuthError.isInteractionRequiredError = function (errorCode, errorString, subError) {
        var isInteractionRequiredErrorCode = !!errorCode && InteractionRequiredServerErrorMessage.indexOf(errorCode) > -1;
        var isInteractionRequiredSubError = !!subError && InteractionRequiredAuthSubErrorMessage.indexOf(subError) > -1;
        var isInteractionRequiredErrorDesc = !!errorString && InteractionRequiredServerErrorMessage.some(function (irErrorCode) {
            return errorString.indexOf(irErrorCode) > -1;
        });
        return isInteractionRequiredErrorCode || isInteractionRequiredErrorDesc || isInteractionRequiredSubError;
    };
    /**
     * Creates an error thrown when the authorization code required for a token request is null or empty.
     */
    InteractionRequiredAuthError.createNoTokensFoundError = function () {
        return new InteractionRequiredAuthError(InteractionRequiredAuthErrorMessage.noTokensFoundError.code, InteractionRequiredAuthErrorMessage.noTokensFoundError.desc);
    };
    /**
     * Creates an error thrown when the native broker returns ACCOUNT_UNAVAILABLE status, indicating that the account was removed and interactive sign-in is required
     * @returns
     */
    InteractionRequiredAuthError.createNativeAccountUnavailableError = function () {
        return new InteractionRequiredAuthError(InteractionRequiredAuthErrorMessage.native_account_unavailable.code, InteractionRequiredAuthErrorMessage.native_account_unavailable.desc);
    };
    return InteractionRequiredAuthError;
}(AuthError));

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var CacheRecord = /** @class */ (function () {
    function CacheRecord(accountEntity, idTokenEntity, accessTokenEntity, refreshTokenEntity, appMetadataEntity) {
        this.account = accountEntity || null;
        this.idToken = idTokenEntity || null;
        this.accessToken = accessTokenEntity || null;
        this.refreshToken = refreshTokenEntity || null;
        this.appMetadata = appMetadataEntity || null;
    }
    return CacheRecord;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Class which provides helpers for OAuth 2.0 protocol specific values
 */
var ProtocolUtils = /** @class */ (function () {
    function ProtocolUtils() {
    }
    /**
     * Appends user state with random guid, or returns random guid.
     * @param userState
     * @param randomGuid
     */
    ProtocolUtils.setRequestState = function (cryptoObj, userState, meta) {
        var libraryState = ProtocolUtils.generateLibraryState(cryptoObj, meta);
        return !StringUtils.isEmpty(userState) ? "" + libraryState + Constants.RESOURCE_DELIM + userState : libraryState;
    };
    /**
     * Generates the state value used by the common library.
     * @param randomGuid
     * @param cryptoObj
     */
    ProtocolUtils.generateLibraryState = function (cryptoObj, meta) {
        if (!cryptoObj) {
            throw ClientAuthError.createNoCryptoObjectError("generateLibraryState");
        }
        // Create a state object containing a unique id and the timestamp of the request creation
        var stateObj = {
            id: cryptoObj.createNewGuid()
        };
        if (meta) {
            stateObj.meta = meta;
        }
        var stateString = JSON.stringify(stateObj);
        return cryptoObj.base64Encode(stateString);
    };
    /**
     * Parses the state into the RequestStateObject, which contains the LibraryState info and the state passed by the user.
     * @param state
     * @param cryptoObj
     */
    ProtocolUtils.parseRequestState = function (cryptoObj, state) {
        if (!cryptoObj) {
            throw ClientAuthError.createNoCryptoObjectError("parseRequestState");
        }
        if (StringUtils.isEmpty(state)) {
            throw ClientAuthError.createInvalidStateError(state, "Null, undefined or empty state");
        }
        try {
            // Split the state between library state and user passed state and decode them separately
            var splitState = state.split(Constants.RESOURCE_DELIM);
            var libraryState = splitState[0];
            var userState = splitState.length > 1 ? splitState.slice(1).join(Constants.RESOURCE_DELIM) : Constants.EMPTY_STRING;
            var libraryStateString = cryptoObj.base64Decode(libraryState);
            var libraryStateObj = JSON.parse(libraryStateString);
            return {
                userRequestState: !StringUtils.isEmpty(userState) ? userState : Constants.EMPTY_STRING,
                libraryState: libraryStateObj
            };
        }
        catch (e) {
            throw ClientAuthError.createInvalidStateError(state, e);
        }
    };
    return ProtocolUtils;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Url object class which can perform various transformations on url strings.
 */
var UrlString = /** @class */ (function () {
    function UrlString(url) {
        this._urlString = url;
        if (StringUtils.isEmpty(this._urlString)) {
            // Throws error if url is empty
            throw ClientConfigurationError.createUrlEmptyError();
        }
        if (StringUtils.isEmpty(this.getHash())) {
            this._urlString = UrlString.canonicalizeUri(url);
        }
    }
    Object.defineProperty(UrlString.prototype, "urlString", {
        get: function () {
            return this._urlString;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Ensure urls are lower case and end with a / character.
     * @param url
     */
    UrlString.canonicalizeUri = function (url) {
        if (url) {
            var lowerCaseUrl = url.toLowerCase();
            if (StringUtils.endsWith(lowerCaseUrl, "?")) {
                lowerCaseUrl = lowerCaseUrl.slice(0, -1);
            }
            else if (StringUtils.endsWith(lowerCaseUrl, "?/")) {
                lowerCaseUrl = lowerCaseUrl.slice(0, -2);
            }
            if (!StringUtils.endsWith(lowerCaseUrl, "/")) {
                lowerCaseUrl += "/";
            }
            return lowerCaseUrl;
        }
        return url;
    };
    /**
     * Throws if urlString passed is not a valid authority URI string.
     */
    UrlString.prototype.validateAsUri = function () {
        // Attempts to parse url for uri components
        var components;
        try {
            components = this.getUrlComponents();
        }
        catch (e) {
            throw ClientConfigurationError.createUrlParseError(e);
        }
        // Throw error if URI or path segments are not parseable.
        if (!components.HostNameAndPort || !components.PathSegments) {
            throw ClientConfigurationError.createUrlParseError("Given url string: " + this.urlString);
        }
        // Throw error if uri is insecure.
        if (!components.Protocol || components.Protocol.toLowerCase() !== "https:") {
            throw ClientConfigurationError.createInsecureAuthorityUriError(this.urlString);
        }
    };
    /**
     * Given a url and a query string return the url with provided query string appended
     * @param url
     * @param queryString
     */
    UrlString.appendQueryString = function (url, queryString) {
        if (StringUtils.isEmpty(queryString)) {
            return url;
        }
        return url.indexOf("?") < 0 ? url + "?" + queryString : url + "&" + queryString;
    };
    /**
     * Returns a url with the hash removed
     * @param url
     */
    UrlString.removeHashFromUrl = function (url) {
        return UrlString.canonicalizeUri(url.split("#")[0]);
    };
    /**
     * Given a url like https://a:b/common/d?e=f#g, and a tenantId, returns https://a:b/tenantId/d
     * @param href The url
     * @param tenantId The tenant id to replace
     */
    UrlString.prototype.replaceTenantPath = function (tenantId) {
        var urlObject = this.getUrlComponents();
        var pathArray = urlObject.PathSegments;
        if (tenantId && (pathArray.length !== 0 && (pathArray[0] === AADAuthorityConstants.COMMON || pathArray[0] === AADAuthorityConstants.ORGANIZATIONS))) {
            pathArray[0] = tenantId;
        }
        return UrlString.constructAuthorityUriFromObject(urlObject);
    };
    /**
     * Returns the anchor part(#) of the URL
     */
    UrlString.prototype.getHash = function () {
        return UrlString.parseHash(this.urlString);
    };
    /**
     * Parses out the components from a url string.
     * @returns An object with the various components. Please cache this value insted of calling this multiple times on the same url.
     */
    UrlString.prototype.getUrlComponents = function () {
        // https://gist.github.com/curtisz/11139b2cfcaef4a261e0
        var regEx = RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?");
        // If url string does not match regEx, we throw an error
        var match = this.urlString.match(regEx);
        if (!match) {
            throw ClientConfigurationError.createUrlParseError("Given url string: " + this.urlString);
        }
        // Url component object
        var urlComponents = {
            Protocol: match[1],
            HostNameAndPort: match[4],
            AbsolutePath: match[5],
            QueryString: match[7]
        };
        var pathSegments = urlComponents.AbsolutePath.split("/");
        pathSegments = pathSegments.filter(function (val) { return val && val.length > 0; }); // remove empty elements
        urlComponents.PathSegments = pathSegments;
        if (!StringUtils.isEmpty(urlComponents.QueryString) && urlComponents.QueryString.endsWith("/")) {
            urlComponents.QueryString = urlComponents.QueryString.substring(0, urlComponents.QueryString.length - 1);
        }
        return urlComponents;
    };
    UrlString.getDomainFromUrl = function (url) {
        var regEx = RegExp("^([^:/?#]+://)?([^/?#]*)");
        var match = url.match(regEx);
        if (!match) {
            throw ClientConfigurationError.createUrlParseError("Given url string: " + url);
        }
        return match[2];
    };
    UrlString.getAbsoluteUrl = function (relativeUrl, baseUrl) {
        if (relativeUrl[0] === Constants.FORWARD_SLASH) {
            var url = new UrlString(baseUrl);
            var baseComponents = url.getUrlComponents();
            return baseComponents.Protocol + "//" + baseComponents.HostNameAndPort + relativeUrl;
        }
        return relativeUrl;
    };
    /**
     * Parses hash string from given string. Returns empty string if no hash symbol is found.
     * @param hashString
     */
    UrlString.parseHash = function (hashString) {
        var hashIndex1 = hashString.indexOf("#");
        var hashIndex2 = hashString.indexOf("#/");
        if (hashIndex2 > -1) {
            return hashString.substring(hashIndex2 + 2);
        }
        else if (hashIndex1 > -1) {
            return hashString.substring(hashIndex1 + 1);
        }
        return Constants.EMPTY_STRING;
    };
    /**
     * Parses query string from given string. Returns empty string if no query symbol is found.
     * @param queryString
     */
    UrlString.parseQueryString = function (queryString) {
        var queryIndex1 = queryString.indexOf("?");
        var queryIndex2 = queryString.indexOf("/?");
        if (queryIndex2 > -1) {
            return queryString.substring(queryIndex2 + 2);
        }
        else if (queryIndex1 > -1) {
            return queryString.substring(queryIndex1 + 1);
        }
        return Constants.EMPTY_STRING;
    };
    UrlString.constructAuthorityUriFromObject = function (urlObject) {
        return new UrlString(urlObject.Protocol + "//" + urlObject.HostNameAndPort + "/" + urlObject.PathSegments.join("/"));
    };
    /**
     * Returns URL hash as server auth code response object.
     */
    UrlString.getDeserializedHash = function (hash) {
        // Check if given hash is empty
        if (StringUtils.isEmpty(hash)) {
            return {};
        }
        // Strip the # symbol if present
        var parsedHash = UrlString.parseHash(hash);
        // If # symbol was not present, above will return empty string, so give original hash value
        var deserializedHash = StringUtils.queryStringToObject(StringUtils.isEmpty(parsedHash) ? hash : parsedHash);
        // Check if deserialization didn't work
        if (!deserializedHash) {
            throw ClientAuthError.createHashNotDeserializedError(JSON.stringify(deserializedHash));
        }
        return deserializedHash;
    };
    /**
     * Returns URL query string as server auth code response object.
     */
    UrlString.getDeserializedQueryString = function (query) {
        // Check if given query is empty
        if (StringUtils.isEmpty(query)) {
            return {};
        }
        // Strip the ? symbol if present
        var parsedQueryString = UrlString.parseQueryString(query);
        // If ? symbol was not present, above will return empty string, so give original query value
        var deserializedQueryString = StringUtils.queryStringToObject(StringUtils.isEmpty(parsedQueryString) ? query : parsedQueryString);
        // Check if deserialization didn't work
        if (!deserializedQueryString) {
            throw ClientAuthError.createHashNotDeserializedError(JSON.stringify(deserializedQueryString));
        }
        return deserializedQueryString;
    };
    /**
     * Check if the hash of the URL string contains known properties
     */
    UrlString.hashContainsKnownProperties = function (hash) {
        if (StringUtils.isEmpty(hash) || hash.indexOf("=") < 0) {
            // Hash doesn't contain key/value pairs
            return false;
        }
        var parameters = UrlString.getDeserializedHash(hash);
        return !!(parameters.code ||
            parameters.error_description ||
            parameters.error ||
            parameters.state);
    };
    return UrlString;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Enumeration of operations that are instrumented by have their performance measured by the PerformanceClient.
 *
 * @export
 * @enum {number}
 */
var PerformanceEvents;
(function (PerformanceEvents) {
    /**
     * acquireTokenByCode API (msal-browser and msal-node).
     * Used to acquire tokens by trading an authorization code against the token endpoint.
     */
    PerformanceEvents["AcquireTokenByCode"] = "acquireTokenByCode";
    /**
     * acquireTokenByRefreshToken API (msal-browser and msal-node).
     * Used to renew an access token using a refresh token against the token endpoint.
     */
    PerformanceEvents["AcquireTokenByRefreshToken"] = "acquireTokenByRefreshToken";
    /**
     * acquireTokenSilent API (msal-browser and msal-node).
     * Used to silently acquire a new access token (from the cache or the network).
     */
    PerformanceEvents["AcquireTokenSilent"] = "acquireTokenSilent";
    /**
     * acquireTokenSilentAsync (msal-browser).
     * Internal API for acquireTokenSilent.
     */
    PerformanceEvents["AcquireTokenSilentAsync"] = "acquireTokenSilentAsync";
    /**
     * acquireTokenPopup (msal-browser).
     * Used to acquire a new access token interactively through pop ups
     */
    PerformanceEvents["AcquireTokenPopup"] = "acquireTokenPopup";
    /**
     * getPublicKeyThumbprint API in CryptoOpts class (msal-browser).
     * Used to generate a public/private keypair and generate a public key thumbprint for pop requests.
     */
    PerformanceEvents["CryptoOptsGetPublicKeyThumbprint"] = "cryptoOptsGetPublicKeyThumbprint";
    /**
     * signJwt API in CryptoOpts class (msal-browser).
     * Used to signed a pop token.
     */
    PerformanceEvents["CryptoOptsSignJwt"] = "cryptoOptsSignJwt";
    /**
     * acquireToken API in the SilentCacheClient class (msal-browser).
     * Used to read access tokens from the cache.
     */
    PerformanceEvents["SilentCacheClientAcquireToken"] = "silentCacheClientAcquireToken";
    /**
     * acquireToken API in the SilentIframeClient class (msal-browser).
     * Used to acquire a new set of tokens from the authorize endpoint in a hidden iframe.
     */
    PerformanceEvents["SilentIframeClientAcquireToken"] = "silentIframeClientAcquireToken";
    /**
     * acquireToken API in SilentRereshClient (msal-browser).
     * Used to acquire a new set of tokens from the token endpoint using a refresh token.
     */
    PerformanceEvents["SilentRefreshClientAcquireToken"] = "silentRefreshClientAcquireToken";
    /**
     * ssoSilent API (msal-browser).
     * Used to silently acquire an authorization code and set of tokens using a hidden iframe.
     */
    PerformanceEvents["SsoSilent"] = "ssoSilent";
    /**
     * getDiscoveredAuthority API in StandardInteractionClient class (msal-browser).
     * Used to load authority metadata for a request.
     */
    PerformanceEvents["StandardInteractionClientGetDiscoveredAuthority"] = "standardInteractionClientGetDiscoveredAuthority";
    /**
     * acquireToken APIs in msal-browser.
     * Used to make an /authorize endpoint call with native brokering enabled.
     */
    PerformanceEvents["FetchAccountIdWithNativeBroker"] = "fetchAccountIdWithNativeBroker";
    /**
     * acquireToken API in NativeInteractionClient class (msal-browser).
     * Used to acquire a token from Native component when native brokering is enabled.
     */
    PerformanceEvents["NativeInteractionClientAcquireToken"] = "nativeInteractionClientAcquireToken";
    /**
     * Time spent creating default headers for requests to token endpoint
     */
    PerformanceEvents["BaseClientCreateTokenRequestHeaders"] = "baseClientCreateTokenRequestHeaders";
    /**
     * Used to measure the time taken for completing embedded-broker handshake (PW-Broker).
     */
    PerformanceEvents["BrokerHandhshake"] = "brokerHandshake";
    /**
     * acquireTokenByRefreshToken API in BrokerClientApplication (PW-Broker) .
     */
    PerformanceEvents["AcquireTokenByRefreshTokenInBroker"] = "acquireTokenByRefreshTokenInBroker";
    /**
     * Time taken for token acquisition by broker
     */
    PerformanceEvents["AcquireTokenByBroker"] = "acquireTokenByBroker";
    /**
     * Time spent on the network for refresh token acquisition
     */
    PerformanceEvents["RefreshTokenClientExecuteTokenRequest"] = "refreshTokenClientExecuteTokenRequest";
    /**
     * Time taken for acquiring refresh token , records RT size
     */
    PerformanceEvents["RefreshTokenClientAcquireToken"] = "refreshTokenClientAcquireToken";
    /**
     * Time taken for acquiring cached refresh token
     */
    PerformanceEvents["RefreshTokenClientAcquireTokenWithCachedRefreshToken"] = "refreshTokenClientAcquireTokenWithCachedRefreshToken";
    /**
     * acquireTokenByRefreshToken API in RefreshTokenClient (msal-common).
     */
    PerformanceEvents["RefreshTokenClientAcquireTokenByRefreshToken"] = "refreshTokenClientAcquireTokenByRefreshToken";
    /**
     * Helper function to create token request body in RefreshTokenClient (msal-common).
     */
    PerformanceEvents["RefreshTokenClientCreateTokenRequestBody"] = "refreshTokenClientCreateTokenRequestBody";
    /**
     * acquireTokenFromCache (msal-browser).
     * Internal API for acquiring token from cache
     */
    PerformanceEvents["AcquireTokenFromCache"] = "acquireTokenFromCache";
    /**
     * acquireTokenBySilentIframe (msal-browser).
     * Internal API for acquiring token by silent Iframe
     */
    PerformanceEvents["AcquireTokenBySilentIframe"] = "acquireTokenBySilentIframe";
    /**
     * Internal API for initializing base request in BaseInteractionClient (msal-browser)
     */
    PerformanceEvents["InitializeBaseRequest"] = "initializeBaseRequest";
    /**
     * Internal API for initializing silent request in SilentCacheClient (msal-browser)
     */
    PerformanceEvents["InitializeSilentRequest"] = "initializeSilentRequest";
    PerformanceEvents["InitializeClientApplication"] = "initializeClientApplication";
    /**
     * Helper function in SilentIframeClient class (msal-browser).
     */
    PerformanceEvents["SilentIframeClientTokenHelper"] = "silentIframeClientTokenHelper";
    /**
     * SilentHandler
     */
    PerformanceEvents["SilentHandlerInitiateAuthRequest"] = "silentHandlerInitiateAuthRequest";
    PerformanceEvents["SilentHandlerMonitorIframeForHash"] = "silentHandlerMonitorIframeForHash";
    PerformanceEvents["SilentHandlerLoadFrame"] = "silentHandlerLoadFrame";
    /**
     * Helper functions in StandardInteractionClient class (msal-browser)
     */
    PerformanceEvents["StandardInteractionClientCreateAuthCodeClient"] = "standardInteractionClientCreateAuthCodeClient";
    PerformanceEvents["StandardInteractionClientGetClientConfiguration"] = "standardInteractionClientGetClientConfiguration";
    PerformanceEvents["StandardInteractionClientInitializeAuthorizationRequest"] = "standardInteractionClientInitializeAuthorizationRequest";
    PerformanceEvents["StandardInteractionClientInitializeAuthorizationCodeRequest"] = "standardInteractionClientInitializeAuthorizationCodeRequest";
    /**
     * getAuthCodeUrl API (msal-browser and msal-node).
     */
    PerformanceEvents["GetAuthCodeUrl"] = "getAuthCodeUrl";
    /**
     * Functions from InteractionHandler (msal-browser)
     */
    PerformanceEvents["HandleCodeResponseFromServer"] = "handleCodeResponseFromServer";
    PerformanceEvents["HandleCodeResponseFromHash"] = "handleCodeResponseFromHash";
    PerformanceEvents["UpdateTokenEndpointAuthority"] = "updateTokenEndpointAuthority";
    /**
     * APIs in Authorization Code Client (msal-common)
     */
    PerformanceEvents["AuthClientAcquireToken"] = "authClientAcquireToken";
    PerformanceEvents["AuthClientExecuteTokenRequest"] = "authClientExecuteTokenRequest";
    PerformanceEvents["AuthClientCreateTokenRequestBody"] = "authClientCreateTokenRequestBody";
    PerformanceEvents["AuthClientCreateQueryString"] = "authClientCreateQueryString";
    /**
     * Generate functions in PopTokenGenerator (msal-common)
     */
    PerformanceEvents["PopTokenGenerateCnf"] = "popTokenGenerateCnf";
    PerformanceEvents["PopTokenGenerateKid"] = "popTokenGenerateKid";
    /**
     * handleServerTokenResponse API in ResponseHandler (msal-common)
     */
    PerformanceEvents["HandleServerTokenResponse"] = "handleServerTokenResponse";
    /**
     * Authority functions
     */
    PerformanceEvents["AuthorityFactoryCreateDiscoveredInstance"] = "authorityFactoryCreateDiscoveredInstance";
    PerformanceEvents["AuthorityResolveEndpointsAsync"] = "authorityResolveEndpointsAsync";
    PerformanceEvents["AuthorityGetCloudDiscoveryMetadataFromNetwork"] = "authorityGetCloudDiscoveryMetadataFromNetwork";
    PerformanceEvents["AuthorityUpdateCloudDiscoveryMetadata"] = "authorityUpdateCloudDiscoveryMetadata";
    PerformanceEvents["AuthorityGetEndpointMetadataFromNetwork"] = "authorityGetEndpointMetadataFromNetwork";
    PerformanceEvents["AuthorityUpdateEndpointMetadata"] = "authorityUpdateEndpointMetadata";
    PerformanceEvents["AuthorityUpdateMetadataWithRegionalInformation"] = "authorityUpdateMetadataWithRegionalInformation";
    /**
     * Region Discovery functions
     */
    PerformanceEvents["RegionDiscoveryDetectRegion"] = "regionDiscoveryDetectRegion";
    PerformanceEvents["RegionDiscoveryGetRegionFromIMDS"] = "regionDiscoveryGetRegionFromIMDS";
    PerformanceEvents["RegionDiscoveryGetCurrentVersion"] = "regionDiscoveryGetCurrentVersion";
    PerformanceEvents["AcquireTokenByCodeAsync"] = "acquireTokenByCodeAsync";
    PerformanceEvents["GetEndpointMetadataFromNetwork"] = "getEndpointMetadataFromNetwork";
    PerformanceEvents["GetCloudDiscoveryMetadataFromNetworkMeasurement"] = "getCloudDiscoveryMetadataFromNetworkMeasurement";
    PerformanceEvents["HandleRedirectPromiseMeasurement"] = "handleRedirectPromiseMeasurement";
    PerformanceEvents["UpdateCloudDiscoveryMetadataMeasurement"] = "updateCloudDiscoveryMetadataMeasurement";
    PerformanceEvents["UsernamePasswordClientAcquireToken"] = "usernamePasswordClientAcquireToken";
    PerformanceEvents["NativeMessageHandlerHandshake"] = "nativeMessageHandlerHandshake";
    /**
     * Cache operations
     */
    PerformanceEvents["ClearTokensAndKeysWithClaims"] = "clearTokensAndKeysWithClaims";
})(PerformanceEvents || (PerformanceEvents = {}));
/**
 * State of the performance event.
 *
 * @export
 * @enum {number}
 */
var PerformanceEventStatus;
(function (PerformanceEventStatus) {
    PerformanceEventStatus[PerformanceEventStatus["NotStarted"] = 0] = "NotStarted";
    PerformanceEventStatus[PerformanceEventStatus["InProgress"] = 1] = "InProgress";
    PerformanceEventStatus[PerformanceEventStatus["Completed"] = 2] = "Completed";
})(PerformanceEventStatus || (PerformanceEventStatus = {}));
var IntFields = new Set([
    "accessTokenSize",
    "durationMs",
    "idTokenSize",
    "matsSilentStatus",
    "matsHttpStatus",
    "refreshTokenSize",
    "queuedTimeMs",
    "startTimeMs",
    "status",
]);

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var KeyLocation;
(function (KeyLocation) {
    KeyLocation["SW"] = "sw";
    KeyLocation["UHW"] = "uhw";
})(KeyLocation || (KeyLocation = {}));
var PopTokenGenerator = /** @class */ (function () {
    function PopTokenGenerator(cryptoUtils, performanceClient) {
        this.cryptoUtils = cryptoUtils;
        this.performanceClient = performanceClient;
    }
    /**
     * Generates the req_cnf validated at the RP in the POP protocol for SHR parameters
     * and returns an object containing the keyid, the full req_cnf string and the req_cnf string hash
     * @param request
     * @returns
     */
    PopTokenGenerator.prototype.generateCnf = function (request) {
        var _a, _b;
        return __awaiter$2(this, void 0, void 0, function () {
            var reqCnf, reqCnfString, _c;
            return __generator$2(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.PopTokenGenerateCnf, request.correlationId);
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.PopTokenGenerateKid, request.correlationId);
                        return [4 /*yield*/, this.generateKid(request)];
                    case 1:
                        reqCnf = _d.sent();
                        reqCnfString = this.cryptoUtils.base64Encode(JSON.stringify(reqCnf));
                        _c = {
                            kid: reqCnf.kid,
                            reqCnfString: reqCnfString
                        };
                        return [4 /*yield*/, this.cryptoUtils.hashString(reqCnfString)];
                    case 2: return [2 /*return*/, (_c.reqCnfHash = _d.sent(),
                            _c)];
                }
            });
        });
    };
    /**
     * Generates key_id for a SHR token request
     * @param request
     * @returns
     */
    PopTokenGenerator.prototype.generateKid = function (request) {
        var _a;
        return __awaiter$2(this, void 0, void 0, function () {
            var kidThumbprint;
            return __generator$2(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.PopTokenGenerateKid, request.correlationId);
                        return [4 /*yield*/, this.cryptoUtils.getPublicKeyThumbprint(request)];
                    case 1:
                        kidThumbprint = _b.sent();
                        return [2 /*return*/, {
                                kid: kidThumbprint,
                                xms_ksl: KeyLocation.SW
                            }];
                }
            });
        });
    };
    /**
     * Signs the POP access_token with the local generated key-pair
     * @param accessToken
     * @param request
     * @returns
     */
    PopTokenGenerator.prototype.signPopToken = function (accessToken, keyId, request) {
        return __awaiter$2(this, void 0, void 0, function () {
            return __generator$2(this, function (_a) {
                return [2 /*return*/, this.signPayload(accessToken, keyId, request)];
            });
        });
    };
    /**
     * Utility function to generate the signed JWT for an access_token
     * @param payload
     * @param kid
     * @param request
     * @param claims
     * @returns
     */
    PopTokenGenerator.prototype.signPayload = function (payload, keyId, request, claims) {
        return __awaiter$2(this, void 0, void 0, function () {
            var resourceRequestMethod, resourceRequestUri, shrClaims, shrNonce, resourceUrlString, resourceUrlComponents;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resourceRequestMethod = request.resourceRequestMethod, resourceRequestUri = request.resourceRequestUri, shrClaims = request.shrClaims, shrNonce = request.shrNonce;
                        resourceUrlString = (resourceRequestUri) ? new UrlString(resourceRequestUri) : undefined;
                        resourceUrlComponents = resourceUrlString === null || resourceUrlString === void 0 ? void 0 : resourceUrlString.getUrlComponents();
                        return [4 /*yield*/, this.cryptoUtils.signJwt(__assign$4({ at: payload, ts: TimeUtils.nowSeconds(), m: resourceRequestMethod === null || resourceRequestMethod === void 0 ? void 0 : resourceRequestMethod.toUpperCase(), u: resourceUrlComponents === null || resourceUrlComponents === void 0 ? void 0 : resourceUrlComponents.HostNameAndPort, nonce: shrNonce || this.cryptoUtils.createNewGuid(), p: resourceUrlComponents === null || resourceUrlComponents === void 0 ? void 0 : resourceUrlComponents.AbsolutePath, q: (resourceUrlComponents === null || resourceUrlComponents === void 0 ? void 0 : resourceUrlComponents.QueryString) ? [[], resourceUrlComponents.QueryString] : undefined, client_claims: shrClaims || undefined }, claims), keyId, request.correlationId)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return PopTokenGenerator;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * APP_METADATA Cache
 *
 * Key:Value Schema:
 *
 * Key: appmetadata-<environment>-<client_id>
 *
 * Value:
 * {
 *      clientId: client ID of the application
 *      environment: entity that issued the token, represented as a full host
 *      familyId: Family ID identifier, '1' represents Microsoft Family
 * }
 */
var AppMetadataEntity = /** @class */ (function () {
    function AppMetadataEntity() {
    }
    /**
     * Generate AppMetadata Cache Key as per the schema: appmetadata-<environment>-<client_id>
     */
    AppMetadataEntity.prototype.generateAppMetadataKey = function () {
        return AppMetadataEntity.generateAppMetadataCacheKey(this.environment, this.clientId);
    };
    /**
     * Generate AppMetadata Cache Key
     */
    AppMetadataEntity.generateAppMetadataCacheKey = function (environment, clientId) {
        var appMetaDataKeyArray = [
            APP_METADATA,
            environment,
            clientId,
        ];
        return appMetaDataKeyArray.join(Separators.CACHE_KEY_SEPARATOR).toLowerCase();
    };
    /**
     * Creates AppMetadataEntity
     * @param clientId
     * @param environment
     * @param familyId
     */
    AppMetadataEntity.createAppMetadataEntity = function (clientId, environment, familyId) {
        var appMetadata = new AppMetadataEntity();
        appMetadata.clientId = clientId;
        appMetadata.environment = environment;
        if (familyId) {
            appMetadata.familyId = familyId;
        }
        return appMetadata;
    };
    /**
     * Validates an entity: checks for all expected params
     * @param entity
     */
    AppMetadataEntity.isAppMetadataEntity = function (key, entity) {
        if (!entity) {
            return false;
        }
        return (key.indexOf(APP_METADATA) === 0 &&
            entity.hasOwnProperty("clientId") &&
            entity.hasOwnProperty("environment"));
    };
    return AppMetadataEntity;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * This class instance helps track the memory changes facilitating
 * decisions to read from and write to the persistent cache
 */ var TokenCacheContext = /** @class */ (function () {
    function TokenCacheContext(tokenCache, hasChanged) {
        this.cache = tokenCache;
        this.hasChanged = hasChanged;
    }
    Object.defineProperty(TokenCacheContext.prototype, "cacheHasChanged", {
        /**
         * boolean which indicates the changes in cache
         */
        get: function () {
            return this.hasChanged;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TokenCacheContext.prototype, "tokenCache", {
        /**
         * function to retrieve the token cache
         */
        get: function () {
            return this.cache;
        },
        enumerable: false,
        configurable: true
    });
    return TokenCacheContext;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Class that handles response parsing.
 */
var ResponseHandler = /** @class */ (function () {
    function ResponseHandler(clientId, cacheStorage, cryptoObj, logger, serializableCache, persistencePlugin, performanceClient) {
        this.clientId = clientId;
        this.cacheStorage = cacheStorage;
        this.cryptoObj = cryptoObj;
        this.logger = logger;
        this.serializableCache = serializableCache;
        this.persistencePlugin = persistencePlugin;
        this.performanceClient = performanceClient;
    }
    /**
     * Function which validates server authorization code response.
     * @param serverResponseHash
     * @param cachedState
     * @param cryptoObj
     */
    ResponseHandler.prototype.validateServerAuthorizationCodeResponse = function (serverResponseHash, cachedState, cryptoObj) {
        if (!serverResponseHash.state || !cachedState) {
            throw !serverResponseHash.state ? ClientAuthError.createStateNotFoundError("Server State") : ClientAuthError.createStateNotFoundError("Cached State");
        }
        if (decodeURIComponent(serverResponseHash.state) !== decodeURIComponent(cachedState)) {
            throw ClientAuthError.createStateMismatchError();
        }
        // Check for error
        if (serverResponseHash.error || serverResponseHash.error_description || serverResponseHash.suberror) {
            if (InteractionRequiredAuthError.isInteractionRequiredError(serverResponseHash.error, serverResponseHash.error_description, serverResponseHash.suberror)) {
                throw new InteractionRequiredAuthError(serverResponseHash.error || Constants.EMPTY_STRING, serverResponseHash.error_description, serverResponseHash.suberror, serverResponseHash.timestamp || Constants.EMPTY_STRING, serverResponseHash.trace_id || Constants.EMPTY_STRING, serverResponseHash.correlation_id || Constants.EMPTY_STRING, serverResponseHash.claims || Constants.EMPTY_STRING);
            }
            throw new ServerError(serverResponseHash.error || Constants.EMPTY_STRING, serverResponseHash.error_description, serverResponseHash.suberror);
        }
        if (serverResponseHash.client_info) {
            buildClientInfo(serverResponseHash.client_info, cryptoObj);
        }
    };
    /**
     * Function which validates server authorization token response.
     * @param serverResponse
     */
    ResponseHandler.prototype.validateTokenResponse = function (serverResponse) {
        // Check for error
        if (serverResponse.error || serverResponse.error_description || serverResponse.suberror) {
            if (InteractionRequiredAuthError.isInteractionRequiredError(serverResponse.error, serverResponse.error_description, serverResponse.suberror)) {
                throw new InteractionRequiredAuthError(serverResponse.error, serverResponse.error_description, serverResponse.suberror, serverResponse.timestamp || Constants.EMPTY_STRING, serverResponse.trace_id || Constants.EMPTY_STRING, serverResponse.correlation_id || Constants.EMPTY_STRING, serverResponse.claims || Constants.EMPTY_STRING);
            }
            var errString = serverResponse.error_codes + " - [" + serverResponse.timestamp + "]: " + serverResponse.error_description + " - Correlation ID: " + serverResponse.correlation_id + " - Trace ID: " + serverResponse.trace_id;
            throw new ServerError(serverResponse.error, errString, serverResponse.suberror);
        }
    };
    /**
     * Returns a constructed token response based on given string. Also manages the cache updates and cleanups.
     * @param serverTokenResponse
     * @param authority
     */
    ResponseHandler.prototype.handleServerTokenResponse = function (serverTokenResponse, authority, reqTimestamp, request, authCodePayload, userAssertionHash, handlingRefreshTokenResponse, forceCacheRefreshTokenResponse, serverRequestId) {
        var _a;
        return __awaiter$2(this, void 0, void 0, function () {
            var idTokenObj, authTime, requestStateObj, cacheRecord, cacheContext, key, account;
            return __generator$2(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.HandleServerTokenResponse, serverTokenResponse.correlation_id);
                        if (serverTokenResponse.id_token) {
                            idTokenObj = new AuthToken(serverTokenResponse.id_token || Constants.EMPTY_STRING, this.cryptoObj);
                            // token nonce check (TODO: Add a warning if no nonce is given?)
                            if (authCodePayload && !StringUtils.isEmpty(authCodePayload.nonce)) {
                                if (idTokenObj.claims.nonce !== authCodePayload.nonce) {
                                    throw ClientAuthError.createNonceMismatchError();
                                }
                            }
                            // token max_age check
                            if (request.maxAge || (request.maxAge === 0)) {
                                authTime = idTokenObj.claims.auth_time;
                                if (!authTime) {
                                    throw ClientAuthError.createAuthTimeNotFoundError();
                                }
                                AuthToken.checkMaxAge(authTime, request.maxAge);
                            }
                        }
                        // generate homeAccountId
                        this.homeAccountIdentifier = AccountEntity.generateHomeAccountId(serverTokenResponse.client_info || Constants.EMPTY_STRING, authority.authorityType, this.logger, this.cryptoObj, idTokenObj);
                        if (!!authCodePayload && !!authCodePayload.state) {
                            requestStateObj = ProtocolUtils.parseRequestState(this.cryptoObj, authCodePayload.state);
                        }
                        // Add keyId from request to serverTokenResponse if defined
                        serverTokenResponse.key_id = serverTokenResponse.key_id || request.sshKid || undefined;
                        cacheRecord = this.generateCacheRecord(serverTokenResponse, authority, reqTimestamp, request, idTokenObj, userAssertionHash, authCodePayload);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, , 5, 8]);
                        if (!(this.persistencePlugin && this.serializableCache)) return [3 /*break*/, 3];
                        this.logger.verbose("Persistence enabled, calling beforeCacheAccess");
                        cacheContext = new TokenCacheContext(this.serializableCache, true);
                        return [4 /*yield*/, this.persistencePlugin.beforeCacheAccess(cacheContext)];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        /*
                         * When saving a refreshed tokens to the cache, it is expected that the account that was used is present in the cache.
                         * If not present, we should return null, as it's the case that another application called removeAccount in between
                         * the calls to getAllAccounts and acquireTokenSilent. We should not overwrite that removal, unless explicitly flagged by
                         * the developer, as in the case of refresh token flow used in ADAL Node to MSAL Node migration.
                         */
                        if (handlingRefreshTokenResponse && !forceCacheRefreshTokenResponse && cacheRecord.account) {
                            key = cacheRecord.account.generateAccountKey();
                            account = this.cacheStorage.getAccount(key);
                            if (!account) {
                                this.logger.warning("Account used to refresh tokens not in persistence, refreshed tokens will not be stored in the cache");
                                return [2 /*return*/, ResponseHandler.generateAuthenticationResult(this.cryptoObj, authority, cacheRecord, false, request, idTokenObj, requestStateObj, undefined, serverRequestId)];
                            }
                        }
                        return [4 /*yield*/, this.cacheStorage.saveCacheRecord(cacheRecord)];
                    case 4:
                        _b.sent();
                        return [3 /*break*/, 8];
                    case 5:
                        if (!(this.persistencePlugin && this.serializableCache && cacheContext)) return [3 /*break*/, 7];
                        this.logger.verbose("Persistence enabled, calling afterCacheAccess");
                        return [4 /*yield*/, this.persistencePlugin.afterCacheAccess(cacheContext)];
                    case 6:
                        _b.sent();
                        _b.label = 7;
                    case 7: return [7 /*endfinally*/];
                    case 8: return [2 /*return*/, ResponseHandler.generateAuthenticationResult(this.cryptoObj, authority, cacheRecord, false, request, idTokenObj, requestStateObj, serverTokenResponse, serverRequestId)];
                }
            });
        });
    };
    /**
     * Generates CacheRecord
     * @param serverTokenResponse
     * @param idTokenObj
     * @param authority
     */
    ResponseHandler.prototype.generateCacheRecord = function (serverTokenResponse, authority, reqTimestamp, request, idTokenObj, userAssertionHash, authCodePayload) {
        var env = authority.getPreferredCache();
        if (StringUtils.isEmpty(env)) {
            throw ClientAuthError.createInvalidCacheEnvironmentError();
        }
        // IdToken: non AAD scenarios can have empty realm
        var cachedIdToken;
        var cachedAccount;
        if (!StringUtils.isEmpty(serverTokenResponse.id_token) && !!idTokenObj) {
            cachedIdToken = IdTokenEntity.createIdTokenEntity(this.homeAccountIdentifier, env, serverTokenResponse.id_token || Constants.EMPTY_STRING, this.clientId, idTokenObj.claims.tid || Constants.EMPTY_STRING);
            cachedAccount = this.generateAccountEntity(serverTokenResponse, idTokenObj, authority, authCodePayload);
        }
        // AccessToken
        var cachedAccessToken = null;
        if (!StringUtils.isEmpty(serverTokenResponse.access_token)) {
            // If scopes not returned in server response, use request scopes
            var responseScopes = serverTokenResponse.scope ? ScopeSet.fromString(serverTokenResponse.scope) : new ScopeSet(request.scopes || []);
            /*
             * Use timestamp calculated before request
             * Server may return timestamps as strings, parse to numbers if so.
             */
            var expiresIn = (typeof serverTokenResponse.expires_in === "string" ? parseInt(serverTokenResponse.expires_in, 10) : serverTokenResponse.expires_in) || 0;
            var extExpiresIn = (typeof serverTokenResponse.ext_expires_in === "string" ? parseInt(serverTokenResponse.ext_expires_in, 10) : serverTokenResponse.ext_expires_in) || 0;
            var refreshIn = (typeof serverTokenResponse.refresh_in === "string" ? parseInt(serverTokenResponse.refresh_in, 10) : serverTokenResponse.refresh_in) || undefined;
            var tokenExpirationSeconds = reqTimestamp + expiresIn;
            var extendedTokenExpirationSeconds = tokenExpirationSeconds + extExpiresIn;
            var refreshOnSeconds = refreshIn && refreshIn > 0 ? reqTimestamp + refreshIn : undefined;
            // non AAD scenarios can have empty realm
            cachedAccessToken = AccessTokenEntity.createAccessTokenEntity(this.homeAccountIdentifier, env, serverTokenResponse.access_token || Constants.EMPTY_STRING, this.clientId, idTokenObj ? idTokenObj.claims.tid || Constants.EMPTY_STRING : authority.tenant, responseScopes.printScopes(), tokenExpirationSeconds, extendedTokenExpirationSeconds, this.cryptoObj, refreshOnSeconds, serverTokenResponse.token_type, userAssertionHash, serverTokenResponse.key_id, request.claims, request.requestedClaimsHash);
        }
        // refreshToken
        var cachedRefreshToken = null;
        if (!StringUtils.isEmpty(serverTokenResponse.refresh_token)) {
            cachedRefreshToken = RefreshTokenEntity.createRefreshTokenEntity(this.homeAccountIdentifier, env, serverTokenResponse.refresh_token || Constants.EMPTY_STRING, this.clientId, serverTokenResponse.foci, userAssertionHash);
        }
        // appMetadata
        var cachedAppMetadata = null;
        if (!StringUtils.isEmpty(serverTokenResponse.foci)) {
            cachedAppMetadata = AppMetadataEntity.createAppMetadataEntity(this.clientId, env, serverTokenResponse.foci);
        }
        return new CacheRecord(cachedAccount, cachedIdToken, cachedAccessToken, cachedRefreshToken, cachedAppMetadata);
    };
    /**
     * Generate Account
     * @param serverTokenResponse
     * @param idToken
     * @param authority
     */
    ResponseHandler.prototype.generateAccountEntity = function (serverTokenResponse, idToken, authority, authCodePayload) {
        var authorityType = authority.authorityType;
        var cloudGraphHostName = authCodePayload ? authCodePayload.cloud_graph_host_name : Constants.EMPTY_STRING;
        var msGraphhost = authCodePayload ? authCodePayload.msgraph_host : Constants.EMPTY_STRING;
        // ADFS does not require client_info in the response
        if (authorityType === AuthorityType.Adfs) {
            this.logger.verbose("Authority type is ADFS, creating ADFS account");
            return AccountEntity.createGenericAccount(this.homeAccountIdentifier, idToken, authority, cloudGraphHostName, msGraphhost);
        }
        // This fallback applies to B2C as well as they fall under an AAD account type.
        if (StringUtils.isEmpty(serverTokenResponse.client_info) && authority.protocolMode === "AAD") {
            throw ClientAuthError.createClientInfoEmptyError();
        }
        return serverTokenResponse.client_info ?
            AccountEntity.createAccount(serverTokenResponse.client_info, this.homeAccountIdentifier, idToken, authority, cloudGraphHostName, msGraphhost) :
            AccountEntity.createGenericAccount(this.homeAccountIdentifier, idToken, authority, cloudGraphHostName, msGraphhost);
    };
    /**
     * Creates an @AuthenticationResult from @CacheRecord , @IdToken , and a boolean that states whether or not the result is from cache.
     *
     * Optionally takes a state string that is set as-is in the response.
     *
     * @param cacheRecord
     * @param idTokenObj
     * @param fromTokenCache
     * @param stateString
     */
    ResponseHandler.generateAuthenticationResult = function (cryptoObj, authority, cacheRecord, fromTokenCache, request, idTokenObj, requestState, serverTokenResponse, requestId) {
        var _a, _b, _c;
        return __awaiter$2(this, void 0, void 0, function () {
            var accessToken, responseScopes, expiresOn, extExpiresOn, familyId, popTokenGenerator, _d, secret, keyId, uid, tid;
            return __generator$2(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        accessToken = Constants.EMPTY_STRING;
                        responseScopes = [];
                        expiresOn = null;
                        familyId = Constants.EMPTY_STRING;
                        if (!cacheRecord.accessToken) return [3 /*break*/, 4];
                        if (!(cacheRecord.accessToken.tokenType === AuthenticationScheme.POP)) return [3 /*break*/, 2];
                        popTokenGenerator = new PopTokenGenerator(cryptoObj);
                        _d = cacheRecord.accessToken, secret = _d.secret, keyId = _d.keyId;
                        if (!keyId) {
                            throw ClientAuthError.createKeyIdMissingError();
                        }
                        return [4 /*yield*/, popTokenGenerator.signPopToken(secret, keyId, request)];
                    case 1:
                        accessToken = _e.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        accessToken = cacheRecord.accessToken.secret;
                        _e.label = 3;
                    case 3:
                        responseScopes = ScopeSet.fromString(cacheRecord.accessToken.target).asArray();
                        expiresOn = new Date(Number(cacheRecord.accessToken.expiresOn) * 1000);
                        extExpiresOn = new Date(Number(cacheRecord.accessToken.extendedExpiresOn) * 1000);
                        _e.label = 4;
                    case 4:
                        if (cacheRecord.appMetadata) {
                            familyId = cacheRecord.appMetadata.familyId === THE_FAMILY_ID ? THE_FAMILY_ID : Constants.EMPTY_STRING;
                        }
                        uid = (idTokenObj === null || idTokenObj === void 0 ? void 0 : idTokenObj.claims.oid) || (idTokenObj === null || idTokenObj === void 0 ? void 0 : idTokenObj.claims.sub) || Constants.EMPTY_STRING;
                        tid = (idTokenObj === null || idTokenObj === void 0 ? void 0 : idTokenObj.claims.tid) || Constants.EMPTY_STRING;
                        // for hybrid + native bridge enablement, send back the native account Id
                        if ((serverTokenResponse === null || serverTokenResponse === void 0 ? void 0 : serverTokenResponse.spa_accountid) && !!cacheRecord.account) {
                            cacheRecord.account.nativeAccountId = serverTokenResponse === null || serverTokenResponse === void 0 ? void 0 : serverTokenResponse.spa_accountid;
                        }
                        return [2 /*return*/, {
                                authority: authority.canonicalAuthority,
                                uniqueId: uid,
                                tenantId: tid,
                                scopes: responseScopes,
                                account: cacheRecord.account ? cacheRecord.account.getAccountInfo() : null,
                                idToken: idTokenObj ? idTokenObj.rawToken : Constants.EMPTY_STRING,
                                idTokenClaims: idTokenObj ? idTokenObj.claims : {},
                                accessToken: accessToken,
                                fromCache: fromTokenCache,
                                expiresOn: expiresOn,
                                correlationId: request.correlationId,
                                requestId: requestId || Constants.EMPTY_STRING,
                                extExpiresOn: extExpiresOn,
                                familyId: familyId,
                                tokenType: ((_a = cacheRecord.accessToken) === null || _a === void 0 ? void 0 : _a.tokenType) || Constants.EMPTY_STRING,
                                state: requestState ? requestState.userRequestState : Constants.EMPTY_STRING,
                                cloudGraphHostName: ((_b = cacheRecord.account) === null || _b === void 0 ? void 0 : _b.cloudGraphHostName) || Constants.EMPTY_STRING,
                                msGraphHost: ((_c = cacheRecord.account) === null || _c === void 0 ? void 0 : _c.msGraphHost) || Constants.EMPTY_STRING,
                                code: serverTokenResponse === null || serverTokenResponse === void 0 ? void 0 : serverTokenResponse.spa_code,
                                fromNativeBroker: false,
                            }];
                }
            });
        });
    };
    return ResponseHandler;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Oauth2.0 Authorization Code client
 */
var AuthorizationCodeClient = /** @class */ (function (_super) {
    __extends$f(AuthorizationCodeClient, _super);
    function AuthorizationCodeClient(configuration, performanceClient) {
        var _this = _super.call(this, configuration, performanceClient) || this;
        // Flag to indicate if client is for hybrid spa auth code redemption
        _this.includeRedirectUri = true;
        return _this;
    }
    /**
     * Creates the URL of the authorization request letting the user input credentials and consent to the
     * application. The URL target the /authorize endpoint of the authority configured in the
     * application object.
     *
     * Once the user inputs their credentials and consents, the authority will send a response to the redirect URI
     * sent in the request and should contain an authorization code, which can then be used to acquire tokens via
     * acquireToken(AuthorizationCodeRequest)
     * @param request
     */
    AuthorizationCodeClient.prototype.getAuthCodeUrl = function (request) {
        var _a, _b;
        return __awaiter$2(this, void 0, void 0, function () {
            var queryString;
            return __generator$2(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.GetAuthCodeUrl, request.correlationId);
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.AuthClientCreateQueryString, request.correlationId);
                        return [4 /*yield*/, this.createAuthCodeUrlQueryString(request)];
                    case 1:
                        queryString = _c.sent();
                        return [2 /*return*/, UrlString.appendQueryString(this.authority.authorizationEndpoint, queryString)];
                }
            });
        });
    };
    /**
     * API to acquire a token in exchange of 'authorization_code` acquired by the user in the first leg of the
     * authorization_code_grant
     * @param request
     */
    AuthorizationCodeClient.prototype.acquireToken = function (request, authCodePayload) {
        var _a, _b, _c, _d, _e, _f;
        return __awaiter$2(this, void 0, void 0, function () {
            var atsMeasurement, reqTimestamp, response, requestId, httpVerAuthority, responseHandler;
            var _this = this;
            return __generator$2(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        if (!request || !request.code) {
                            throw ClientAuthError.createTokenRequestCannotBeMadeError();
                        }
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthClientAcquireToken, request.correlationId);
                        atsMeasurement = (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.startMeasurement("AuthCodeClientAcquireToken", request.correlationId);
                        this.logger.info("in acquireToken call in auth-code client");
                        reqTimestamp = TimeUtils.nowSeconds();
                        (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.AuthClientExecuteTokenRequest, request.correlationId);
                        return [4 /*yield*/, this.executeTokenRequest(this.authority, request)];
                    case 1:
                        response = _g.sent();
                        requestId = (_d = response.headers) === null || _d === void 0 ? void 0 : _d[HeaderNames.X_MS_REQUEST_ID];
                        httpVerAuthority = (_e = response.headers) === null || _e === void 0 ? void 0 : _e[HeaderNames.X_MS_HTTP_VERSION];
                        if (httpVerAuthority) {
                            atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.addStaticFields({
                                httpVerAuthority: httpVerAuthority
                            });
                        }
                        responseHandler = new ResponseHandler(this.config.authOptions.clientId, this.cacheManager, this.cryptoUtils, this.logger, this.config.serializableCache, this.config.persistencePlugin, this.performanceClient);
                        // Validate response. This function throws a server error if an error is returned by the server.
                        responseHandler.validateTokenResponse(response.body);
                        (_f = this.performanceClient) === null || _f === void 0 ? void 0 : _f.setPreQueueTime(PerformanceEvents.HandleServerTokenResponse, request.correlationId);
                        return [2 /*return*/, responseHandler.handleServerTokenResponse(response.body, this.authority, reqTimestamp, request, authCodePayload, undefined, undefined, undefined, requestId).then(function (result) {
                                atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.endMeasurement({
                                    success: true
                                });
                                return result;
                            })
                                .catch(function (error) {
                                _this.logger.verbose("Error in fetching token in ACC", request.correlationId);
                                atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.endMeasurement({
                                    errorCode: error.errorCode,
                                    subErrorCode: error.subError,
                                    success: false
                                });
                                throw error;
                            })];
                }
            });
        });
    };
    /**
     * Handles the hash fragment response from public client code request. Returns a code response used by
     * the client to exchange for a token in acquireToken.
     * @param hashFragment
     */
    AuthorizationCodeClient.prototype.handleFragmentResponse = function (hashFragment, cachedState) {
        // Handle responses.
        var responseHandler = new ResponseHandler(this.config.authOptions.clientId, this.cacheManager, this.cryptoUtils, this.logger, null, null);
        // Deserialize hash fragment response parameters.
        var hashUrlString = new UrlString(hashFragment);
        // Deserialize hash fragment response parameters.
        var serverParams = UrlString.getDeserializedHash(hashUrlString.getHash());
        // Get code response
        responseHandler.validateServerAuthorizationCodeResponse(serverParams, cachedState, this.cryptoUtils);
        // throw when there is no auth code in the response
        if (!serverParams.code) {
            throw ClientAuthError.createNoAuthCodeInServerResponseError();
        }
        return __assign$4(__assign$4({}, serverParams), { 
            // Code param is optional in ServerAuthorizationCodeResponse but required in AuthorizationCodePaylod
            code: serverParams.code });
    };
    /**
     * Used to log out the current user, and redirect the user to the postLogoutRedirectUri.
     * Default behaviour is to redirect the user to `window.location.href`.
     * @param authorityUri
     */
    AuthorizationCodeClient.prototype.getLogoutUri = function (logoutRequest) {
        // Throw error if logoutRequest is null/undefined
        if (!logoutRequest) {
            throw ClientConfigurationError.createEmptyLogoutRequestError();
        }
        var queryString = this.createLogoutUrlQueryString(logoutRequest);
        // Construct logout URI
        return UrlString.appendQueryString(this.authority.endSessionEndpoint, queryString);
    };
    /**
     * Executes POST request to token endpoint
     * @param authority
     * @param request
     */
    AuthorizationCodeClient.prototype.executeTokenRequest = function (authority, request) {
        var _a, _b;
        return __awaiter$2(this, void 0, void 0, function () {
            var queryParametersString, endpoint, requestBody, ccsCredential, clientInfo, headers, thumbprint;
            return __generator$2(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthClientExecuteTokenRequest, request.correlationId);
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.AuthClientCreateTokenRequestBody, request.correlationId);
                        queryParametersString = this.createTokenQueryParameters(request);
                        endpoint = UrlString.appendQueryString(authority.tokenEndpoint, queryParametersString);
                        return [4 /*yield*/, this.createTokenRequestBody(request)];
                    case 1:
                        requestBody = _c.sent();
                        ccsCredential = undefined;
                        if (request.clientInfo) {
                            try {
                                clientInfo = buildClientInfo(request.clientInfo, this.cryptoUtils);
                                ccsCredential = {
                                    credential: "" + clientInfo.uid + Separators.CLIENT_INFO_SEPARATOR + clientInfo.utid,
                                    type: CcsCredentialType.HOME_ACCOUNT_ID
                                };
                            }
                            catch (e) {
                                this.logger.verbose("Could not parse client info for CCS Header: " + e);
                            }
                        }
                        headers = this.createTokenRequestHeaders(ccsCredential || request.ccsCredential);
                        thumbprint = {
                            clientId: this.config.authOptions.clientId,
                            authority: authority.canonicalAuthority,
                            scopes: request.scopes,
                            claims: request.claims,
                            authenticationScheme: request.authenticationScheme,
                            resourceRequestMethod: request.resourceRequestMethod,
                            resourceRequestUri: request.resourceRequestUri,
                            shrClaims: request.shrClaims,
                            sshKid: request.sshKid
                        };
                        return [2 /*return*/, this.executePostToTokenEndpoint(endpoint, requestBody, headers, thumbprint)];
                }
            });
        });
    };
    /**
     * Generates a map for all the params to be sent to the service
     * @param request
     */
    AuthorizationCodeClient.prototype.createTokenRequestBody = function (request) {
        var _a, _b;
        return __awaiter$2(this, void 0, void 0, function () {
            var parameterBuilder, clientAssertion, popTokenGenerator, reqCnfData, correlationId, ccsCred, clientInfo, clientInfo;
            var _c;
            return __generator$2(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthClientCreateTokenRequestBody, request.correlationId);
                        parameterBuilder = new RequestParameterBuilder();
                        parameterBuilder.addClientId(this.config.authOptions.clientId);
                        /*
                         * For hybrid spa flow, there will be a code but no verifier
                         * In this scenario, don't include redirect uri as auth code will not be bound to redirect URI
                         */
                        if (!this.includeRedirectUri) {
                            // Just validate
                            RequestValidator.validateRedirectUri(request.redirectUri);
                        }
                        else {
                            // Validate and include redirect uri
                            parameterBuilder.addRedirectUri(request.redirectUri);
                        }
                        // Add scope array, parameter builder will add default scopes and dedupe
                        parameterBuilder.addScopes(request.scopes);
                        // add code: user set, not validated
                        parameterBuilder.addAuthorizationCode(request.code);
                        // Add library metadata
                        parameterBuilder.addLibraryInfo(this.config.libraryInfo);
                        parameterBuilder.addApplicationTelemetry(this.config.telemetry.application);
                        parameterBuilder.addThrottling();
                        if (this.serverTelemetryManager) {
                            parameterBuilder.addServerTelemetry(this.serverTelemetryManager);
                        }
                        // add code_verifier if passed
                        if (request.codeVerifier) {
                            parameterBuilder.addCodeVerifier(request.codeVerifier);
                        }
                        if (this.config.clientCredentials.clientSecret) {
                            parameterBuilder.addClientSecret(this.config.clientCredentials.clientSecret);
                        }
                        if (this.config.clientCredentials.clientAssertion) {
                            clientAssertion = this.config.clientCredentials.clientAssertion;
                            parameterBuilder.addClientAssertion(clientAssertion.assertion);
                            parameterBuilder.addClientAssertionType(clientAssertion.assertionType);
                        }
                        parameterBuilder.addGrantType(GrantType.AUTHORIZATION_CODE_GRANT);
                        parameterBuilder.addClientInfo();
                        if (!(request.authenticationScheme === AuthenticationScheme.POP)) return [3 /*break*/, 2];
                        popTokenGenerator = new PopTokenGenerator(this.cryptoUtils, this.performanceClient);
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.PopTokenGenerateCnf, request.correlationId);
                        return [4 /*yield*/, popTokenGenerator.generateCnf(request)];
                    case 1:
                        reqCnfData = _d.sent();
                        // SPA PoP requires full Base64Url encoded req_cnf string (unhashed)
                        parameterBuilder.addPopToken(reqCnfData.reqCnfString);
                        return [3 /*break*/, 3];
                    case 2:
                        if (request.authenticationScheme === AuthenticationScheme.SSH) {
                            if (request.sshJwk) {
                                parameterBuilder.addSshJwk(request.sshJwk);
                            }
                            else {
                                throw ClientConfigurationError.createMissingSshJwkError();
                            }
                        }
                        _d.label = 3;
                    case 3:
                        correlationId = request.correlationId || this.config.cryptoInterface.createNewGuid();
                        parameterBuilder.addCorrelationId(correlationId);
                        if (!StringUtils.isEmptyObj(request.claims) || this.config.authOptions.clientCapabilities && this.config.authOptions.clientCapabilities.length > 0) {
                            parameterBuilder.addClaims(request.claims, this.config.authOptions.clientCapabilities);
                        }
                        ccsCred = undefined;
                        if (request.clientInfo) {
                            try {
                                clientInfo = buildClientInfo(request.clientInfo, this.cryptoUtils);
                                ccsCred = {
                                    credential: "" + clientInfo.uid + Separators.CLIENT_INFO_SEPARATOR + clientInfo.utid,
                                    type: CcsCredentialType.HOME_ACCOUNT_ID
                                };
                            }
                            catch (e) {
                                this.logger.verbose("Could not parse client info for CCS Header: " + e);
                            }
                        }
                        else {
                            ccsCred = request.ccsCredential;
                        }
                        // Adds these as parameters in the request instead of headers to prevent CORS preflight request
                        if (this.config.systemOptions.preventCorsPreflight && ccsCred) {
                            switch (ccsCred.type) {
                                case CcsCredentialType.HOME_ACCOUNT_ID:
                                    try {
                                        clientInfo = buildClientInfoFromHomeAccountId(ccsCred.credential);
                                        parameterBuilder.addCcsOid(clientInfo);
                                    }
                                    catch (e) {
                                        this.logger.verbose("Could not parse home account ID for CCS Header: " + e);
                                    }
                                    break;
                                case CcsCredentialType.UPN:
                                    parameterBuilder.addCcsUpn(ccsCred.credential);
                                    break;
                            }
                        }
                        if (request.tokenBodyParameters) {
                            parameterBuilder.addExtraQueryParameters(request.tokenBodyParameters);
                        }
                        // Add hybrid spa parameters if not already provided
                        if (request.enableSpaAuthorizationCode && (!request.tokenBodyParameters || !request.tokenBodyParameters[AADServerParamKeys.RETURN_SPA_CODE])) {
                            parameterBuilder.addExtraQueryParameters((_c = {},
                                _c[AADServerParamKeys.RETURN_SPA_CODE] = "1",
                                _c));
                        }
                        return [2 /*return*/, parameterBuilder.createQueryString()];
                }
            });
        });
    };
    /**
     * This API validates the `AuthorizationCodeUrlRequest` and creates a URL
     * @param request
     */
    AuthorizationCodeClient.prototype.createAuthCodeUrlQueryString = function (request) {
        var _a;
        return __awaiter$2(this, void 0, void 0, function () {
            var parameterBuilder, requestScopes, correlationId, accountSid, accountLoginHintClaim, clientInfo, clientInfo, clientInfo, popTokenGenerator, reqCnfData;
            return __generator$2(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthClientCreateQueryString, request.correlationId);
                        parameterBuilder = new RequestParameterBuilder();
                        parameterBuilder.addClientId(this.config.authOptions.clientId);
                        requestScopes = __spreadArrays(request.scopes || [], request.extraScopesToConsent || []);
                        parameterBuilder.addScopes(requestScopes);
                        // validate the redirectUri (to be a non null value)
                        parameterBuilder.addRedirectUri(request.redirectUri);
                        correlationId = request.correlationId || this.config.cryptoInterface.createNewGuid();
                        parameterBuilder.addCorrelationId(correlationId);
                        // add response_mode. If not passed in it defaults to query.
                        parameterBuilder.addResponseMode(request.responseMode);
                        // add response_type = code
                        parameterBuilder.addResponseTypeCode();
                        // add library info parameters
                        parameterBuilder.addLibraryInfo(this.config.libraryInfo);
                        parameterBuilder.addApplicationTelemetry(this.config.telemetry.application);
                        // add client_info=1
                        parameterBuilder.addClientInfo();
                        if (request.codeChallenge && request.codeChallengeMethod) {
                            parameterBuilder.addCodeChallengeParams(request.codeChallenge, request.codeChallengeMethod);
                        }
                        if (request.prompt) {
                            parameterBuilder.addPrompt(request.prompt);
                        }
                        if (request.domainHint) {
                            parameterBuilder.addDomainHint(request.domainHint);
                        }
                        // Add sid or loginHint with preference for login_hint claim (in request) -> sid -> loginHint (upn/email) -> username of AccountInfo object
                        if (request.prompt !== PromptValue.SELECT_ACCOUNT) {
                            // AAD will throw if prompt=select_account is passed with an account hint
                            if (request.sid && request.prompt === PromptValue.NONE) {
                                // SessionID is only used in silent calls
                                this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from request");
                                parameterBuilder.addSid(request.sid);
                            }
                            else if (request.account) {
                                accountSid = this.extractAccountSid(request.account);
                                accountLoginHintClaim = this.extractLoginHint(request.account);
                                // If login_hint claim is present, use it over sid/username
                                if (accountLoginHintClaim) {
                                    this.logger.verbose("createAuthCodeUrlQueryString: login_hint claim present on account");
                                    parameterBuilder.addLoginHint(accountLoginHintClaim);
                                    try {
                                        clientInfo = buildClientInfoFromHomeAccountId(request.account.homeAccountId);
                                        parameterBuilder.addCcsOid(clientInfo);
                                    }
                                    catch (e) {
                                        this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header");
                                    }
                                }
                                else if (accountSid && request.prompt === PromptValue.NONE) {
                                    /*
                                     * If account and loginHint are provided, we will check account first for sid before adding loginHint
                                     * SessionId is only used in silent calls
                                     */
                                    this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from account");
                                    parameterBuilder.addSid(accountSid);
                                    try {
                                        clientInfo = buildClientInfoFromHomeAccountId(request.account.homeAccountId);
                                        parameterBuilder.addCcsOid(clientInfo);
                                    }
                                    catch (e) {
                                        this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header");
                                    }
                                }
                                else if (request.loginHint) {
                                    this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from request");
                                    parameterBuilder.addLoginHint(request.loginHint);
                                    parameterBuilder.addCcsUpn(request.loginHint);
                                }
                                else if (request.account.username) {
                                    // Fallback to account username if provided
                                    this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from account");
                                    parameterBuilder.addLoginHint(request.account.username);
                                    try {
                                        clientInfo = buildClientInfoFromHomeAccountId(request.account.homeAccountId);
                                        parameterBuilder.addCcsOid(clientInfo);
                                    }
                                    catch (e) {
                                        this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header");
                                    }
                                }
                            }
                            else if (request.loginHint) {
                                this.logger.verbose("createAuthCodeUrlQueryString: No account, adding login_hint from request");
                                parameterBuilder.addLoginHint(request.loginHint);
                                parameterBuilder.addCcsUpn(request.loginHint);
                            }
                        }
                        else {
                            this.logger.verbose("createAuthCodeUrlQueryString: Prompt is select_account, ignoring account hints");
                        }
                        if (request.nonce) {
                            parameterBuilder.addNonce(request.nonce);
                        }
                        if (request.state) {
                            parameterBuilder.addState(request.state);
                        }
                        if (!StringUtils.isEmpty(request.claims) || this.config.authOptions.clientCapabilities && this.config.authOptions.clientCapabilities.length > 0) {
                            parameterBuilder.addClaims(request.claims, this.config.authOptions.clientCapabilities);
                        }
                        if (request.extraQueryParameters) {
                            parameterBuilder.addExtraQueryParameters(request.extraQueryParameters);
                        }
                        if (!request.nativeBroker) return [3 /*break*/, 2];
                        // signal ests that this is a WAM call
                        parameterBuilder.addNativeBroker();
                        if (!(request.authenticationScheme === AuthenticationScheme.POP)) return [3 /*break*/, 2];
                        popTokenGenerator = new PopTokenGenerator(this.cryptoUtils);
                        return [4 /*yield*/, popTokenGenerator.generateCnf(request)];
                    case 1:
                        reqCnfData = _b.sent();
                        parameterBuilder.addPopToken(reqCnfData.reqCnfString);
                        _b.label = 2;
                    case 2: return [2 /*return*/, parameterBuilder.createQueryString()];
                }
            });
        });
    };
    /**
     * This API validates the `EndSessionRequest` and creates a URL
     * @param request
     */
    AuthorizationCodeClient.prototype.createLogoutUrlQueryString = function (request) {
        var parameterBuilder = new RequestParameterBuilder();
        if (request.postLogoutRedirectUri) {
            parameterBuilder.addPostLogoutRedirectUri(request.postLogoutRedirectUri);
        }
        if (request.correlationId) {
            parameterBuilder.addCorrelationId(request.correlationId);
        }
        if (request.idTokenHint) {
            parameterBuilder.addIdTokenHint(request.idTokenHint);
        }
        if (request.state) {
            parameterBuilder.addState(request.state);
        }
        if (request.logoutHint) {
            parameterBuilder.addLogoutHint(request.logoutHint);
        }
        if (request.extraQueryParameters) {
            parameterBuilder.addExtraQueryParameters(request.extraQueryParameters);
        }
        return parameterBuilder.createQueryString();
    };
    /**
     * Helper to get sid from account. Returns null if idTokenClaims are not present or sid is not present.
     * @param account
     */
    AuthorizationCodeClient.prototype.extractAccountSid = function (account) {
        var _a;
        return ((_a = account.idTokenClaims) === null || _a === void 0 ? void 0 : _a.sid) || null;
    };
    AuthorizationCodeClient.prototype.extractLoginHint = function (account) {
        var _a;
        return ((_a = account.idTokenClaims) === null || _a === void 0 ? void 0 : _a.login_hint) || null;
    };
    return AuthorizationCodeClient;
}(BaseClient));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * OAuth2.0 refresh token client
 */
var RefreshTokenClient = /** @class */ (function (_super) {
    __extends$f(RefreshTokenClient, _super);
    function RefreshTokenClient(configuration, performanceClient) {
        return _super.call(this, configuration, performanceClient) || this;
    }
    RefreshTokenClient.prototype.acquireToken = function (request) {
        var _a, _b, _c, _d, _e, _f, _g;
        return __awaiter$2(this, void 0, void 0, function () {
            var atsMeasurement, reqTimestamp, response, httpVerToken, requestId, responseHandler;
            var _this = this;
            return __generator$2(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientAcquireToken, request.correlationId);
                        atsMeasurement = (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.startMeasurement(PerformanceEvents.RefreshTokenClientAcquireToken, request.correlationId);
                        this.logger.verbose("RefreshTokenClientAcquireToken called", request.correlationId);
                        reqTimestamp = TimeUtils.nowSeconds();
                        (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.RefreshTokenClientExecuteTokenRequest, request.correlationId);
                        return [4 /*yield*/, this.executeTokenRequest(request, this.authority)];
                    case 1:
                        response = _h.sent();
                        httpVerToken = (_d = response.headers) === null || _d === void 0 ? void 0 : _d[HeaderNames.X_MS_HTTP_VERSION];
                        atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.addStaticFields({
                            refreshTokenSize: ((_e = response.body.refresh_token) === null || _e === void 0 ? void 0 : _e.length) || 0,
                        });
                        if (httpVerToken) {
                            atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.addStaticFields({
                                httpVerToken: httpVerToken,
                            });
                        }
                        requestId = (_f = response.headers) === null || _f === void 0 ? void 0 : _f[HeaderNames.X_MS_REQUEST_ID];
                        responseHandler = new ResponseHandler(this.config.authOptions.clientId, this.cacheManager, this.cryptoUtils, this.logger, this.config.serializableCache, this.config.persistencePlugin);
                        responseHandler.validateTokenResponse(response.body);
                        (_g = this.performanceClient) === null || _g === void 0 ? void 0 : _g.setPreQueueTime(PerformanceEvents.HandleServerTokenResponse, request.correlationId);
                        return [2 /*return*/, responseHandler.handleServerTokenResponse(response.body, this.authority, reqTimestamp, request, undefined, undefined, true, request.forceCache, requestId).then(function (result) {
                                atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.endMeasurement({
                                    success: true
                                });
                                return result;
                            })
                                .catch(function (error) {
                                _this.logger.verbose("Error in fetching refresh token", request.correlationId);
                                atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.endMeasurement({
                                    errorCode: error.errorCode,
                                    subErrorCode: error.subError,
                                    success: false
                                });
                                throw error;
                            })];
                }
            });
        });
    };
    /**
     * Gets cached refresh token and attaches to request, then calls acquireToken API
     * @param request
     */
    RefreshTokenClient.prototype.acquireTokenByRefreshToken = function (request) {
        var _a, _b, _c, _d;
        return __awaiter$2(this, void 0, void 0, function () {
            var isFOCI, noFamilyRTInCache, clientMismatchErrorWithFamilyRT;
            return __generator$2(this, function (_e) {
                // Cannot renew token if no request object is given.
                if (!request) {
                    throw ClientConfigurationError.createEmptyTokenRequestError();
                }
                (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientAcquireTokenByRefreshToken, request.correlationId);
                // We currently do not support silent flow for account === null use cases; This will be revisited for confidential flow usecases
                if (!request.account) {
                    throw ClientAuthError.createNoAccountInSilentRequestError();
                }
                isFOCI = this.cacheManager.isAppMetadataFOCI(request.account.environment);
                // if the app is part of the family, retrive a Family refresh token if present and make a refreshTokenRequest
                if (isFOCI) {
                    try {
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken, request.correlationId);
                        return [2 /*return*/, this.acquireTokenWithCachedRefreshToken(request, true)];
                    }
                    catch (e) {
                        noFamilyRTInCache = e instanceof InteractionRequiredAuthError && e.errorCode === InteractionRequiredAuthErrorMessage.noTokensFoundError.code;
                        clientMismatchErrorWithFamilyRT = e instanceof ServerError && e.errorCode === Errors.INVALID_GRANT_ERROR && e.subError === Errors.CLIENT_MISMATCH_ERROR;
                        // if family Refresh Token (FRT) cache acquisition fails or if client_mismatch error is seen with FRT, reattempt with application Refresh Token (ART)
                        if (noFamilyRTInCache || clientMismatchErrorWithFamilyRT) {
                            (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken, request.correlationId);
                            return [2 /*return*/, this.acquireTokenWithCachedRefreshToken(request, false)];
                            // throw in all other cases
                        }
                        else {
                            throw e;
                        }
                    }
                }
                // fall back to application refresh token acquisition
                (_d = this.performanceClient) === null || _d === void 0 ? void 0 : _d.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken, request.correlationId);
                return [2 /*return*/, this.acquireTokenWithCachedRefreshToken(request, false)];
            });
        });
    };
    /**
     * makes a network call to acquire tokens by exchanging RefreshToken available in userCache; throws if refresh token is not cached
     * @param request
     */
    RefreshTokenClient.prototype.acquireTokenWithCachedRefreshToken = function (request, foci) {
        var _a, _b, _c;
        return __awaiter$2(this, void 0, void 0, function () {
            var atsMeasurement, refreshToken, refreshTokenRequest;
            return __generator$2(this, function (_d) {
                (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken, request.correlationId);
                atsMeasurement = (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.startMeasurement(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken, request.correlationId);
                this.logger.verbose("RefreshTokenClientAcquireTokenWithCachedRefreshToken called", request.correlationId);
                refreshToken = this.cacheManager.getRefreshToken(request.account, foci);
                if (!refreshToken) {
                    atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.discardMeasurement();
                    throw InteractionRequiredAuthError.createNoTokensFoundError();
                }
                // attach cached RT size to the current measurement
                atsMeasurement === null || atsMeasurement === void 0 ? void 0 : atsMeasurement.endMeasurement({
                    success: true
                });
                refreshTokenRequest = __assign$4(__assign$4({}, request), { refreshToken: refreshToken.secret, authenticationScheme: request.authenticationScheme || AuthenticationScheme.BEARER, ccsCredential: {
                        credential: request.account.homeAccountId,
                        type: CcsCredentialType.HOME_ACCOUNT_ID
                    } });
                (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireToken, request.correlationId);
                return [2 /*return*/, this.acquireToken(refreshTokenRequest)];
            });
        });
    };
    /**
     * Constructs the network message and makes a NW call to the underlying secure token service
     * @param request
     * @param authority
     */
    RefreshTokenClient.prototype.executeTokenRequest = function (request, authority) {
        var _a, _b, _c;
        return __awaiter$2(this, void 0, void 0, function () {
            var acquireTokenMeasurement, queryParametersString, endpoint, requestBody, headers, thumbprint;
            return __generator$2(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientExecuteTokenRequest, request.correlationId);
                        acquireTokenMeasurement = (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.startMeasurement(PerformanceEvents.RefreshTokenClientExecuteTokenRequest, request.correlationId);
                        (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.RefreshTokenClientCreateTokenRequestBody, request.correlationId);
                        queryParametersString = this.createTokenQueryParameters(request);
                        endpoint = UrlString.appendQueryString(authority.tokenEndpoint, queryParametersString);
                        return [4 /*yield*/, this.createTokenRequestBody(request)];
                    case 1:
                        requestBody = _d.sent();
                        headers = this.createTokenRequestHeaders(request.ccsCredential);
                        thumbprint = {
                            clientId: this.config.authOptions.clientId,
                            authority: authority.canonicalAuthority,
                            scopes: request.scopes,
                            claims: request.claims,
                            authenticationScheme: request.authenticationScheme,
                            resourceRequestMethod: request.resourceRequestMethod,
                            resourceRequestUri: request.resourceRequestUri,
                            shrClaims: request.shrClaims,
                            sshKid: request.sshKid
                        };
                        return [2 /*return*/, this.executePostToTokenEndpoint(endpoint, requestBody, headers, thumbprint)
                                .then(function (result) {
                                acquireTokenMeasurement === null || acquireTokenMeasurement === void 0 ? void 0 : acquireTokenMeasurement.endMeasurement({
                                    success: true
                                });
                                return result;
                            })
                                .catch(function (error) {
                                acquireTokenMeasurement === null || acquireTokenMeasurement === void 0 ? void 0 : acquireTokenMeasurement.endMeasurement({
                                    success: false
                                });
                                throw error;
                            })];
                }
            });
        });
    };
    /**
     * Helper function to create the token request body
     * @param request
     */
    RefreshTokenClient.prototype.createTokenRequestBody = function (request) {
        var _a, _b, _c;
        return __awaiter$2(this, void 0, void 0, function () {
            var correlationId, acquireTokenMeasurement, parameterBuilder, clientAssertion, popTokenGenerator, reqCnfData, clientInfo;
            return __generator$2(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientCreateTokenRequestBody, request.correlationId);
                        correlationId = request.correlationId;
                        acquireTokenMeasurement = (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.startMeasurement(PerformanceEvents.BaseClientCreateTokenRequestHeaders, correlationId);
                        parameterBuilder = new RequestParameterBuilder();
                        parameterBuilder.addClientId(this.config.authOptions.clientId);
                        parameterBuilder.addScopes(request.scopes);
                        parameterBuilder.addGrantType(GrantType.REFRESH_TOKEN_GRANT);
                        parameterBuilder.addClientInfo();
                        parameterBuilder.addLibraryInfo(this.config.libraryInfo);
                        parameterBuilder.addApplicationTelemetry(this.config.telemetry.application);
                        parameterBuilder.addThrottling();
                        if (this.serverTelemetryManager) {
                            parameterBuilder.addServerTelemetry(this.serverTelemetryManager);
                        }
                        parameterBuilder.addCorrelationId(correlationId);
                        parameterBuilder.addRefreshToken(request.refreshToken);
                        if (this.config.clientCredentials.clientSecret) {
                            parameterBuilder.addClientSecret(this.config.clientCredentials.clientSecret);
                        }
                        if (this.config.clientCredentials.clientAssertion) {
                            clientAssertion = this.config.clientCredentials.clientAssertion;
                            parameterBuilder.addClientAssertion(clientAssertion.assertion);
                            parameterBuilder.addClientAssertionType(clientAssertion.assertionType);
                        }
                        if (!(request.authenticationScheme === AuthenticationScheme.POP)) return [3 /*break*/, 2];
                        popTokenGenerator = new PopTokenGenerator(this.cryptoUtils, this.performanceClient);
                        (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.PopTokenGenerateCnf, request.correlationId);
                        return [4 /*yield*/, popTokenGenerator.generateCnf(request)];
                    case 1:
                        reqCnfData = _d.sent();
                        // SPA PoP requires full Base64Url encoded req_cnf string (unhashed)
                        parameterBuilder.addPopToken(reqCnfData.reqCnfString);
                        return [3 /*break*/, 3];
                    case 2:
                        if (request.authenticationScheme === AuthenticationScheme.SSH) {
                            if (request.sshJwk) {
                                parameterBuilder.addSshJwk(request.sshJwk);
                            }
                            else {
                                acquireTokenMeasurement === null || acquireTokenMeasurement === void 0 ? void 0 : acquireTokenMeasurement.endMeasurement({
                                    success: false
                                });
                                throw ClientConfigurationError.createMissingSshJwkError();
                            }
                        }
                        _d.label = 3;
                    case 3:
                        if (!StringUtils.isEmptyObj(request.claims) || this.config.authOptions.clientCapabilities && this.config.authOptions.clientCapabilities.length > 0) {
                            parameterBuilder.addClaims(request.claims, this.config.authOptions.clientCapabilities);
                        }
                        if (this.config.systemOptions.preventCorsPreflight && request.ccsCredential) {
                            switch (request.ccsCredential.type) {
                                case CcsCredentialType.HOME_ACCOUNT_ID:
                                    try {
                                        clientInfo = buildClientInfoFromHomeAccountId(request.ccsCredential.credential);
                                        parameterBuilder.addCcsOid(clientInfo);
                                    }
                                    catch (e) {
                                        this.logger.verbose("Could not parse home account ID for CCS Header: " + e);
                                    }
                                    break;
                                case CcsCredentialType.UPN:
                                    parameterBuilder.addCcsUpn(request.ccsCredential.credential);
                                    break;
                            }
                        }
                        acquireTokenMeasurement === null || acquireTokenMeasurement === void 0 ? void 0 : acquireTokenMeasurement.endMeasurement({
                            success: true
                        });
                        return [2 /*return*/, parameterBuilder.createQueryString()];
                }
            });
        });
    };
    return RefreshTokenClient;
}(BaseClient));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var SilentFlowClient = /** @class */ (function (_super) {
    __extends$f(SilentFlowClient, _super);
    function SilentFlowClient(configuration, performanceClient) {
        return _super.call(this, configuration, performanceClient) || this;
    }
    /**
     * Retrieves a token from cache if it is still valid, or uses the cached refresh token to renew
     * the given token and returns the renewed token
     * @param request
     */
    SilentFlowClient.prototype.acquireToken = function (request) {
        return __awaiter$2(this, void 0, void 0, function () {
            var e_1, refreshTokenClient;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.acquireCachedToken(request)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_1 = _a.sent();
                        if (e_1 instanceof ClientAuthError && e_1.errorCode === ClientAuthErrorMessage.tokenRefreshRequired.code) {
                            refreshTokenClient = new RefreshTokenClient(this.config, this.performanceClient);
                            return [2 /*return*/, refreshTokenClient.acquireTokenByRefreshToken(request)];
                        }
                        else {
                            throw e_1;
                        }
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Retrieves token from cache or throws an error if it must be refreshed.
     * @param request
     */
    SilentFlowClient.prototype.acquireCachedToken = function (request) {
        var _a, _b, _c, _d, _e;
        return __awaiter$2(this, void 0, void 0, function () {
            var environment, cacheRecord;
            return __generator$2(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        // Cannot renew token if no request object is given.
                        if (!request) {
                            throw ClientConfigurationError.createEmptyTokenRequestError();
                        }
                        if (request.forceRefresh) {
                            // Must refresh due to present force_refresh flag.
                            (_a = this.serverTelemetryManager) === null || _a === void 0 ? void 0 : _a.setCacheOutcome(CacheOutcome.FORCE_REFRESH);
                            this.logger.info("SilentFlowClient:acquireCachedToken - Skipping cache because forceRefresh is true.");
                            throw ClientAuthError.createRefreshRequiredError();
                        }
                        else if (!this.config.cacheOptions.claimsBasedCachingEnabled && !StringUtils.isEmptyObj(request.claims)) {
                            // Must refresh due to presence of claims in request preventing cache lookup
                            (_b = this.serverTelemetryManager) === null || _b === void 0 ? void 0 : _b.setCacheOutcome(CacheOutcome.CLAIMS_REQUESTED_CACHE_SKIPPED);
                            this.logger.info("SilentFlowClient:acquireCachedToken - Skipping cache because claims-based caching is disabled and claims were requested.");
                            throw ClientAuthError.createRefreshRequiredError();
                        }
                        // We currently do not support silent flow for account === null use cases; This will be revisited for confidential flow usecases
                        if (!request.account) {
                            throw ClientAuthError.createNoAccountInSilentRequestError();
                        }
                        environment = request.authority || this.authority.getPreferredCache();
                        cacheRecord = this.cacheManager.readCacheRecord(request.account, request, environment);
                        if (!cacheRecord.accessToken) {
                            // Must refresh due to non-existent access_token.
                            (_c = this.serverTelemetryManager) === null || _c === void 0 ? void 0 : _c.setCacheOutcome(CacheOutcome.NO_CACHED_ACCESS_TOKEN);
                            this.logger.info("SilentFlowClient:acquireCachedToken - No access token found in cache for the given properties.");
                            throw ClientAuthError.createRefreshRequiredError();
                        }
                        else if (TimeUtils.wasClockTurnedBack(cacheRecord.accessToken.cachedAt) ||
                            TimeUtils.isTokenExpired(cacheRecord.accessToken.expiresOn, this.config.systemOptions.tokenRenewalOffsetSeconds)) {
                            // Must refresh due to expired access_token.
                            (_d = this.serverTelemetryManager) === null || _d === void 0 ? void 0 : _d.setCacheOutcome(CacheOutcome.CACHED_ACCESS_TOKEN_EXPIRED);
                            this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token is expired or will expire within " + this.config.systemOptions.tokenRenewalOffsetSeconds + " seconds.");
                            throw ClientAuthError.createRefreshRequiredError();
                        }
                        else if (cacheRecord.accessToken.refreshOn && TimeUtils.isTokenExpired(cacheRecord.accessToken.refreshOn, 0)) {
                            // Must refresh due to the refresh_in value.
                            (_e = this.serverTelemetryManager) === null || _e === void 0 ? void 0 : _e.setCacheOutcome(CacheOutcome.REFRESH_CACHED_ACCESS_TOKEN);
                            this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token's refreshOn property has been exceeded'.");
                            throw ClientAuthError.createRefreshRequiredError();
                        }
                        if (this.config.serverTelemetryManager) {
                            this.config.serverTelemetryManager.incrementCacheHits();
                        }
                        return [4 /*yield*/, this.generateResultFromCacheRecord(cacheRecord, request)];
                    case 1: return [2 /*return*/, _f.sent()];
                }
            });
        });
    };
    /**
     * Helper function to build response object from the CacheRecord
     * @param cacheRecord
     */
    SilentFlowClient.prototype.generateResultFromCacheRecord = function (cacheRecord, request) {
        return __awaiter$2(this, void 0, void 0, function () {
            var idTokenObj, authTime;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (cacheRecord.idToken) {
                            idTokenObj = new AuthToken(cacheRecord.idToken.secret, this.config.cryptoInterface);
                        }
                        // token max_age check
                        if (request.maxAge || (request.maxAge === 0)) {
                            authTime = idTokenObj === null || idTokenObj === void 0 ? void 0 : idTokenObj.claims.auth_time;
                            if (!authTime) {
                                throw ClientAuthError.createAuthTimeNotFoundError();
                            }
                            AuthToken.checkMaxAge(authTime, request.maxAge);
                        }
                        return [4 /*yield*/, ResponseHandler.generateAuthenticationResult(this.cryptoUtils, this.authority, cacheRecord, true, request, idTokenObj)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return SilentFlowClient;
}(BaseClient));

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
function isOpenIdConfigResponse(response) {
    return (response.hasOwnProperty("authorization_endpoint") &&
        response.hasOwnProperty("token_endpoint") &&
        response.hasOwnProperty("issuer") &&
        response.hasOwnProperty("jwks_uri"));
}

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var rawMetdataJSON = { "endpointMetadata": { "https://login.microsoftonline.com/common/": { "token_endpoint": "https://login.microsoftonline.com/common/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.microsoftonline.com/common/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.microsoftonline.com/{tenantid}/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://graph.microsoft.com/oidc/userinfo", "authorization_endpoint": "https://login.microsoftonline.com/common/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.microsoftonline.com/common/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.microsoftonline.com/common/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.microsoftonline.com/common/kerberos", "tenant_region_scope": null, "cloud_instance_name": "microsoftonline.com", "cloud_graph_host_name": "graph.windows.net", "msgraph_host": "graph.microsoft.com", "rbac_url": "https://pas.windows.net" }, "https://login.chinacloudapi.cn/common/": { "token_endpoint": "https://login.chinacloudapi.cn/common/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.chinacloudapi.cn/common/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.partner.microsoftonline.cn/{tenantid}/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://microsoftgraph.chinacloudapi.cn/oidc/userinfo", "authorization_endpoint": "https://login.chinacloudapi.cn/common/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.chinacloudapi.cn/common/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.chinacloudapi.cn/common/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.chinacloudapi.cn/common/kerberos", "tenant_region_scope": null, "cloud_instance_name": "partner.microsoftonline.cn", "cloud_graph_host_name": "graph.chinacloudapi.cn", "msgraph_host": "microsoftgraph.chinacloudapi.cn", "rbac_url": "https://pas.chinacloudapi.cn" }, "https://login.microsoftonline.us/common/": { "token_endpoint": "https://login.microsoftonline.us/common/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.microsoftonline.us/common/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.microsoftonline.us/{tenantid}/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://graph.microsoft.com/oidc/userinfo", "authorization_endpoint": "https://login.microsoftonline.us/common/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.microsoftonline.us/common/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.microsoftonline.us/common/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.microsoftonline.us/common/kerberos", "tenant_region_scope": null, "cloud_instance_name": "microsoftonline.us", "cloud_graph_host_name": "graph.windows.net", "msgraph_host": "graph.microsoft.com", "rbac_url": "https://pasff.usgovcloudapi.net" }, "https://login.microsoftonline.com/consumers/": { "token_endpoint": "https://login.microsoftonline.com/consumers/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.microsoftonline.com/consumers/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.microsoftonline.com/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://graph.microsoft.com/oidc/userinfo", "authorization_endpoint": "https://login.microsoftonline.com/consumers/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.microsoftonline.com/consumers/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.microsoftonline.com/consumers/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.microsoftonline.com/consumers/kerberos", "tenant_region_scope": null, "cloud_instance_name": "microsoftonline.com", "cloud_graph_host_name": "graph.windows.net", "msgraph_host": "graph.microsoft.com", "rbac_url": "https://pas.windows.net" }, "https://login.chinacloudapi.cn/consumers/": { "token_endpoint": "https://login.chinacloudapi.cn/consumers/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.chinacloudapi.cn/consumers/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.partner.microsoftonline.cn/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://microsoftgraph.chinacloudapi.cn/oidc/userinfo", "authorization_endpoint": "https://login.chinacloudapi.cn/consumers/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.chinacloudapi.cn/consumers/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.chinacloudapi.cn/consumers/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.chinacloudapi.cn/consumers/kerberos", "tenant_region_scope": null, "cloud_instance_name": "partner.microsoftonline.cn", "cloud_graph_host_name": "graph.chinacloudapi.cn", "msgraph_host": "microsoftgraph.chinacloudapi.cn", "rbac_url": "https://pas.chinacloudapi.cn" }, "https://login.microsoftonline.us/consumers/": { "token_endpoint": "https://login.microsoftonline.us/consumers/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.microsoftonline.us/consumers/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.microsoftonline.us/9188040d-6c67-4c5b-b112-36a304b66dad/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://graph.microsoft.com/oidc/userinfo", "authorization_endpoint": "https://login.microsoftonline.us/consumers/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.microsoftonline.us/consumers/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.microsoftonline.us/consumers/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.microsoftonline.us/consumers/kerberos", "tenant_region_scope": null, "cloud_instance_name": "microsoftonline.us", "cloud_graph_host_name": "graph.windows.net", "msgraph_host": "graph.microsoft.com", "rbac_url": "https://pasff.usgovcloudapi.net" }, "https://login.microsoftonline.com/organizations/": { "token_endpoint": "https://login.microsoftonline.com/organizations/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.microsoftonline.com/organizations/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.microsoftonline.com/{tenantid}/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://graph.microsoft.com/oidc/userinfo", "authorization_endpoint": "https://login.microsoftonline.com/organizations/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.microsoftonline.com/organizations/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.microsoftonline.com/organizations/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.microsoftonline.com/organizations/kerberos", "tenant_region_scope": null, "cloud_instance_name": "microsoftonline.com", "cloud_graph_host_name": "graph.windows.net", "msgraph_host": "graph.microsoft.com", "rbac_url": "https://pas.windows.net" }, "https://login.chinacloudapi.cn/organizations/": { "token_endpoint": "https://login.chinacloudapi.cn/organizations/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.chinacloudapi.cn/organizations/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.partner.microsoftonline.cn/{tenantid}/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://microsoftgraph.chinacloudapi.cn/oidc/userinfo", "authorization_endpoint": "https://login.chinacloudapi.cn/organizations/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.chinacloudapi.cn/organizations/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.chinacloudapi.cn/organizations/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.chinacloudapi.cn/organizations/kerberos", "tenant_region_scope": null, "cloud_instance_name": "partner.microsoftonline.cn", "cloud_graph_host_name": "graph.chinacloudapi.cn", "msgraph_host": "microsoftgraph.chinacloudapi.cn", "rbac_url": "https://pas.chinacloudapi.cn" }, "https://login.microsoftonline.us/organizations/": { "token_endpoint": "https://login.microsoftonline.us/organizations/oauth2/v2.0/token", "token_endpoint_auth_methods_supported": ["client_secret_post", "private_key_jwt", "client_secret_basic"], "jwks_uri": "https://login.microsoftonline.us/organizations/discovery/v2.0/keys", "response_modes_supported": ["query", "fragment", "form_post"], "subject_types_supported": ["pairwise"], "id_token_signing_alg_values_supported": ["RS256"], "response_types_supported": ["code", "id_token", "code id_token", "id_token token"], "scopes_supported": ["openid", "profile", "email", "offline_access"], "issuer": "https://login.microsoftonline.us/{tenantid}/v2.0", "request_uri_parameter_supported": false, "userinfo_endpoint": "https://graph.microsoft.com/oidc/userinfo", "authorization_endpoint": "https://login.microsoftonline.us/organizations/oauth2/v2.0/authorize", "device_authorization_endpoint": "https://login.microsoftonline.us/organizations/oauth2/v2.0/devicecode", "http_logout_supported": true, "frontchannel_logout_supported": true, "end_session_endpoint": "https://login.microsoftonline.us/organizations/oauth2/v2.0/logout", "claims_supported": ["sub", "iss", "cloud_instance_name", "cloud_instance_host_name", "cloud_graph_host_name", "msgraph_host", "aud", "exp", "iat", "auth_time", "acr", "nonce", "preferred_username", "name", "tid", "ver", "at_hash", "c_hash", "email"], "kerberos_endpoint": "https://login.microsoftonline.us/organizations/kerberos", "tenant_region_scope": null, "cloud_instance_name": "microsoftonline.us", "cloud_graph_host_name": "graph.windows.net", "msgraph_host": "graph.microsoft.com", "rbac_url": "https://pasff.usgovcloudapi.net" } }, "instanceDiscoveryMetadata": { "https://login.microsoftonline.com/common/": { "tenant_discovery_endpoint": "https://login.microsoftonline.com/common/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.chinacloudapi.cn/common/": { "tenant_discovery_endpoint": "https://login.chinacloudapi.cn/common/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.microsoftonline.us/common/": { "tenant_discovery_endpoint": "https://login.microsoftonline.us/common/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.microsoftonline.com/consumers/": { "tenant_discovery_endpoint": "https://login.microsoftonline.com/consumers/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.chinacloudapi.cn/consumers/": { "tenant_discovery_endpoint": "https://login.chinacloudapi.cn/consumers/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.microsoftonline.us/consumers/": { "tenant_discovery_endpoint": "https://login.microsoftonline.us/consumers/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.microsoftonline.com/organizations/": { "tenant_discovery_endpoint": "https://login.microsoftonline.com/organizations/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.chinacloudapi.cn/organizations/": { "tenant_discovery_endpoint": "https://login.chinacloudapi.cn/organizations/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] }, "https://login.microsoftonline.us/organizations/": { "tenant_discovery_endpoint": "https://login.microsoftonline.us/organizations/v2.0/.well-known/openid-configuration", "api-version": "1.1", "metadata": [{ "preferred_network": "login.microsoftonline.com", "preferred_cache": "login.windows.net", "aliases": ["login.microsoftonline.com", "login.windows.net", "login.microsoft.com", "sts.windows.net"] }, { "preferred_network": "login.partner.microsoftonline.cn", "preferred_cache": "login.partner.microsoftonline.cn", "aliases": ["login.partner.microsoftonline.cn", "login.chinacloudapi.cn"] }, { "preferred_network": "login.microsoftonline.de", "preferred_cache": "login.microsoftonline.de", "aliases": ["login.microsoftonline.de"] }, { "preferred_network": "login.microsoftonline.us", "preferred_cache": "login.microsoftonline.us", "aliases": ["login.microsoftonline.us", "login.usgovcloudapi.net"] }, { "preferred_network": "login-us.microsoftonline.com", "preferred_cache": "login-us.microsoftonline.com", "aliases": ["login-us.microsoftonline.com"] }] } } };
var EndpointMetadata = rawMetdataJSON.endpointMetadata;
var InstanceDiscoveryMetadata = rawMetdataJSON.instanceDiscoveryMetadata;

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Protocol modes supported by MSAL.
 */
var ProtocolMode;
(function (ProtocolMode) {
    ProtocolMode["AAD"] = "AAD";
    ProtocolMode["OIDC"] = "OIDC";
})(ProtocolMode || (ProtocolMode = {}));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var AuthorityMetadataEntity = /** @class */ (function () {
    function AuthorityMetadataEntity() {
        this.expiresAt = TimeUtils.nowSeconds() + AUTHORITY_METADATA_CONSTANTS.REFRESH_TIME_SECONDS;
    }
    /**
     * Update the entity with new aliases, preferred_cache and preferred_network values
     * @param metadata
     * @param fromNetwork
     */
    AuthorityMetadataEntity.prototype.updateCloudDiscoveryMetadata = function (metadata, fromNetwork) {
        this.aliases = metadata.aliases;
        this.preferred_cache = metadata.preferred_cache;
        this.preferred_network = metadata.preferred_network;
        this.aliasesFromNetwork = fromNetwork;
    };
    /**
     * Update the entity with new endpoints
     * @param metadata
     * @param fromNetwork
     */
    AuthorityMetadataEntity.prototype.updateEndpointMetadata = function (metadata, fromNetwork) {
        this.authorization_endpoint = metadata.authorization_endpoint;
        this.token_endpoint = metadata.token_endpoint;
        this.end_session_endpoint = metadata.end_session_endpoint;
        this.issuer = metadata.issuer;
        this.endpointsFromNetwork = fromNetwork;
        this.jwks_uri = metadata.jwks_uri;
    };
    /**
     * Save the authority that was used to create this cache entry
     * @param authority
     */
    AuthorityMetadataEntity.prototype.updateCanonicalAuthority = function (authority) {
        this.canonical_authority = authority;
    };
    /**
     * Reset the exiresAt value
     */
    AuthorityMetadataEntity.prototype.resetExpiresAt = function () {
        this.expiresAt = TimeUtils.nowSeconds() + AUTHORITY_METADATA_CONSTANTS.REFRESH_TIME_SECONDS;
    };
    /**
     * Returns whether or not the data needs to be refreshed
     */
    AuthorityMetadataEntity.prototype.isExpired = function () {
        return this.expiresAt <= TimeUtils.nowSeconds();
    };
    /**
     * Validates an entity: checks for all expected params
     * @param entity
     */
    AuthorityMetadataEntity.isAuthorityMetadataEntity = function (key, entity) {
        if (!entity) {
            return false;
        }
        return (key.indexOf(AUTHORITY_METADATA_CONSTANTS.CACHE_KEY) === 0 &&
            entity.hasOwnProperty("aliases") &&
            entity.hasOwnProperty("preferred_cache") &&
            entity.hasOwnProperty("preferred_network") &&
            entity.hasOwnProperty("canonical_authority") &&
            entity.hasOwnProperty("authorization_endpoint") &&
            entity.hasOwnProperty("token_endpoint") &&
            entity.hasOwnProperty("issuer") &&
            entity.hasOwnProperty("aliasesFromNetwork") &&
            entity.hasOwnProperty("endpointsFromNetwork") &&
            entity.hasOwnProperty("expiresAt") &&
            entity.hasOwnProperty("jwks_uri"));
    };
    return AuthorityMetadataEntity;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
function isCloudInstanceDiscoveryResponse(response) {
    return (response.hasOwnProperty("tenant_discovery_endpoint") &&
        response.hasOwnProperty("metadata"));
}

/*! @azure/msal-common v13.3.1 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
function isCloudInstanceDiscoveryErrorResponse(response) {
    return (response.hasOwnProperty("error") &&
        response.hasOwnProperty("error_description"));
}

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var RegionDiscovery = /** @class */ (function () {
    function RegionDiscovery(networkInterface, performanceClient, correlationId) {
        this.networkInterface = networkInterface;
        this.performanceClient = performanceClient;
        this.correlationId = correlationId;
    }
    /**
     * Detect the region from the application's environment.
     *
     * @returns Promise<string | null>
     */
    RegionDiscovery.prototype.detectRegion = function (environmentRegion, regionDiscoveryMetadata) {
        var _a, _b, _c, _d;
        return __awaiter$2(this, void 0, void 0, function () {
            var autodetectedRegionName, options, localIMDSVersionResponse, currentIMDSVersion, currentIMDSVersionResponse;
            return __generator$2(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RegionDiscoveryDetectRegion, this.correlationId);
                        autodetectedRegionName = environmentRegion;
                        if (!!autodetectedRegionName) return [3 /*break*/, 8];
                        options = RegionDiscovery.IMDS_OPTIONS;
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 6, , 7]);
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.RegionDiscoveryGetRegionFromIMDS, this.correlationId);
                        return [4 /*yield*/, this.getRegionFromIMDS(Constants.IMDS_VERSION, options)];
                    case 2:
                        localIMDSVersionResponse = _e.sent();
                        if (localIMDSVersionResponse.status === ResponseCodes.httpSuccess) {
                            autodetectedRegionName = localIMDSVersionResponse.body;
                            regionDiscoveryMetadata.region_source = RegionDiscoverySources.IMDS;
                        }
                        if (!(localIMDSVersionResponse.status === ResponseCodes.httpBadRequest)) return [3 /*break*/, 5];
                        (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.RegionDiscoveryGetCurrentVersion, this.correlationId);
                        return [4 /*yield*/, this.getCurrentVersion(options)];
                    case 3:
                        currentIMDSVersion = _e.sent();
                        if (!currentIMDSVersion) {
                            regionDiscoveryMetadata.region_source = RegionDiscoverySources.FAILED_AUTO_DETECTION;
                            return [2 /*return*/, null];
                        }
                        (_d = this.performanceClient) === null || _d === void 0 ? void 0 : _d.setPreQueueTime(PerformanceEvents.RegionDiscoveryGetRegionFromIMDS, this.correlationId);
                        return [4 /*yield*/, this.getRegionFromIMDS(currentIMDSVersion, options)];
                    case 4:
                        currentIMDSVersionResponse = _e.sent();
                        if (currentIMDSVersionResponse.status === ResponseCodes.httpSuccess) {
                            autodetectedRegionName = currentIMDSVersionResponse.body;
                            regionDiscoveryMetadata.region_source = RegionDiscoverySources.IMDS;
                        }
                        _e.label = 5;
                    case 5: return [3 /*break*/, 7];
                    case 6:
                        _e.sent();
                        regionDiscoveryMetadata.region_source = RegionDiscoverySources.FAILED_AUTO_DETECTION;
                        return [2 /*return*/, null];
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        regionDiscoveryMetadata.region_source = RegionDiscoverySources.ENVIRONMENT_VARIABLE;
                        _e.label = 9;
                    case 9:
                        // If no region was auto detected from the environment or from the IMDS endpoint, mark the attempt as a FAILED_AUTO_DETECTION
                        if (!autodetectedRegionName) {
                            regionDiscoveryMetadata.region_source = RegionDiscoverySources.FAILED_AUTO_DETECTION;
                        }
                        return [2 /*return*/, autodetectedRegionName || null];
                }
            });
        });
    };
    /**
     * Make the call to the IMDS endpoint
     *
     * @param imdsEndpointUrl
     * @returns Promise<NetworkResponse<string>>
     */
    RegionDiscovery.prototype.getRegionFromIMDS = function (version, options) {
        var _a;
        return __awaiter$2(this, void 0, void 0, function () {
            return __generator$2(this, function (_b) {
                (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RegionDiscoveryGetRegionFromIMDS, this.correlationId);
                return [2 /*return*/, this.networkInterface.sendGetRequestAsync(Constants.IMDS_ENDPOINT + "?api-version=" + version + "&format=text", options, Constants.IMDS_TIMEOUT)];
            });
        });
    };
    /**
     * Get the most recent version of the IMDS endpoint available
     *
     * @returns Promise<string | null>
     */
    RegionDiscovery.prototype.getCurrentVersion = function (options) {
        var _a;
        return __awaiter$2(this, void 0, void 0, function () {
            var response;
            return __generator$2(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.RegionDiscoveryGetCurrentVersion, this.correlationId);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.networkInterface.sendGetRequestAsync(Constants.IMDS_ENDPOINT + "?format=json", options)];
                    case 2:
                        response = _b.sent();
                        // When IMDS endpoint is called without the api version query param, bad request response comes back with latest version.
                        if (response.status === ResponseCodes.httpBadRequest && response.body && response.body["newest-versions"] && response.body["newest-versions"].length > 0) {
                            return [2 /*return*/, response.body["newest-versions"][0]];
                        }
                        return [2 /*return*/, null];
                    case 3:
                        _b.sent();
                        return [2 /*return*/, null];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // Options for the IMDS endpoint request
    RegionDiscovery.IMDS_OPTIONS = {
        headers: {
            Metadata: "true",
        },
    };
    return RegionDiscovery;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * The authority class validates the authority URIs used by the user, and retrieves the OpenID Configuration Data from the
 * endpoint. It will store the pertinent config data in this object for use during token calls.
 */
var Authority = /** @class */ (function () {
    function Authority(authority, networkInterface, cacheManager, authorityOptions, logger, performanceClient, correlationId) {
        this.canonicalAuthority = authority;
        this._canonicalAuthority.validateAsUri();
        this.networkInterface = networkInterface;
        this.cacheManager = cacheManager;
        this.authorityOptions = authorityOptions;
        this.regionDiscoveryMetadata = { region_used: undefined, region_source: undefined, region_outcome: undefined };
        this.logger = logger;
        this.performanceClient = performanceClient;
        this.correlationId = correlationId;
        this.regionDiscovery = new RegionDiscovery(networkInterface, this.performanceClient, this.correlationId);
    }
    /**
     * Get {@link AuthorityType}
     * @param authorityUri {@link IUri}
     * @private
     */
    Authority.prototype.getAuthorityType = function (authorityUri) {
        // CIAM auth url pattern is being standardized as: <tenant>.ciamlogin.com
        if (authorityUri.HostNameAndPort.endsWith(Constants.CIAM_AUTH_URL)) {
            return AuthorityType.Ciam;
        }
        var pathSegments = authorityUri.PathSegments;
        if (pathSegments.length) {
            switch (pathSegments[0].toLowerCase()) {
                case Constants.ADFS:
                    return AuthorityType.Adfs;
                case Constants.DSTS:
                    return AuthorityType.Dsts;
            }
        }
        return AuthorityType.Default;
    };
    Object.defineProperty(Authority.prototype, "authorityType", {
        // See above for AuthorityType
        get: function () {
            return this.getAuthorityType(this.canonicalAuthorityUrlComponents);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "protocolMode", {
        /**
         * ProtocolMode enum representing the way endpoints are constructed.
         */
        get: function () {
            return this.authorityOptions.protocolMode;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "options", {
        /**
         * Returns authorityOptions which can be used to reinstantiate a new authority instance
         */
        get: function () {
            return this.authorityOptions;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "canonicalAuthority", {
        /**
         * A URL that is the authority set by the developer
         */
        get: function () {
            return this._canonicalAuthority.urlString;
        },
        /**
         * Sets canonical authority.
         */
        set: function (url) {
            this._canonicalAuthority = new UrlString(url);
            this._canonicalAuthority.validateAsUri();
            this._canonicalAuthorityUrlComponents = null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "canonicalAuthorityUrlComponents", {
        /**
         * Get authority components.
         */
        get: function () {
            if (!this._canonicalAuthorityUrlComponents) {
                this._canonicalAuthorityUrlComponents = this._canonicalAuthority.getUrlComponents();
            }
            return this._canonicalAuthorityUrlComponents;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "hostnameAndPort", {
        /**
         * Get hostname and port i.e. login.microsoftonline.com
         */
        get: function () {
            return this.canonicalAuthorityUrlComponents.HostNameAndPort.toLowerCase();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "tenant", {
        /**
         * Get tenant for authority.
         */
        get: function () {
            return this.canonicalAuthorityUrlComponents.PathSegments[0];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "authorizationEndpoint", {
        /**
         * OAuth /authorize endpoint for requests
         */
        get: function () {
            if (this.discoveryComplete()) {
                return this.replacePath(this.metadata.authorization_endpoint);
            }
            else {
                throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "tokenEndpoint", {
        /**
         * OAuth /token endpoint for requests
         */
        get: function () {
            if (this.discoveryComplete()) {
                return this.replacePath(this.metadata.token_endpoint);
            }
            else {
                throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "deviceCodeEndpoint", {
        get: function () {
            if (this.discoveryComplete()) {
                return this.replacePath(this.metadata.token_endpoint.replace("/token", "/devicecode"));
            }
            else {
                throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "endSessionEndpoint", {
        /**
         * OAuth logout endpoint for requests
         */
        get: function () {
            if (this.discoveryComplete()) {
                // ROPC policies may not have end_session_endpoint set
                if (!this.metadata.end_session_endpoint) {
                    throw ClientAuthError.createLogoutNotSupportedError();
                }
                return this.replacePath(this.metadata.end_session_endpoint);
            }
            else {
                throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "selfSignedJwtAudience", {
        /**
         * OAuth issuer for requests
         */
        get: function () {
            if (this.discoveryComplete()) {
                return this.replacePath(this.metadata.issuer);
            }
            else {
                throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Authority.prototype, "jwksUri", {
        /**
         * Jwks_uri for token signing keys
         */
        get: function () {
            if (this.discoveryComplete()) {
                return this.replacePath(this.metadata.jwks_uri);
            }
            else {
                throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.");
            }
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Returns a flag indicating that tenant name can be replaced in authority {@link IUri}
     * @param authorityUri {@link IUri}
     * @private
     */
    Authority.prototype.canReplaceTenant = function (authorityUri) {
        return authorityUri.PathSegments.length === 1
            && !Authority.reservedTenantDomains.has(authorityUri.PathSegments[0])
            && this.getAuthorityType(authorityUri) === AuthorityType.Default
            && this.protocolMode === ProtocolMode.AAD;
    };
    /**
     * Replaces tenant in url path with current tenant. Defaults to common.
     * @param urlString
     */
    Authority.prototype.replaceTenant = function (urlString) {
        return urlString.replace(/{tenant}|{tenantid}/g, this.tenant);
    };
    /**
     * Replaces path such as tenant or policy with the current tenant or policy.
     * @param urlString
     */
    Authority.prototype.replacePath = function (urlString) {
        var _this = this;
        var endpoint = urlString;
        var cachedAuthorityUrl = new UrlString(this.metadata.canonical_authority);
        var cachedAuthorityUrlComponents = cachedAuthorityUrl.getUrlComponents();
        var cachedAuthorityParts = cachedAuthorityUrlComponents.PathSegments;
        var currentAuthorityParts = this.canonicalAuthorityUrlComponents.PathSegments;
        currentAuthorityParts.forEach(function (currentPart, index) {
            var cachedPart = cachedAuthorityParts[index];
            if (index === 0 && _this.canReplaceTenant(cachedAuthorityUrlComponents)) {
                var tenantId = (new UrlString(_this.metadata.authorization_endpoint)).getUrlComponents().PathSegments[0];
                /**
                 * Check if AAD canonical authority contains tenant domain name, for example "testdomain.onmicrosoft.com",
                 * by comparing its first path segment to the corresponding authorization endpoint path segment, which is
                 * always resolved with tenant id by OIDC.
                 */
                if (cachedPart !== tenantId) {
                    _this.logger.verbose("Replacing tenant domain name " + cachedPart + " with id " + tenantId);
                    cachedPart = tenantId;
                }
            }
            if (currentPart !== cachedPart) {
                endpoint = endpoint.replace("/" + cachedPart + "/", "/" + currentPart + "/");
            }
        });
        return this.replaceTenant(endpoint);
    };
    Object.defineProperty(Authority.prototype, "defaultOpenIdConfigurationEndpoint", {
        /**
         * The default open id configuration endpoint for any canonical authority.
         */
        get: function () {
            if (this.authorityType === AuthorityType.Adfs ||
                this.authorityType === AuthorityType.Dsts ||
                this.protocolMode === ProtocolMode.OIDC) {
                return this.canonicalAuthority + ".well-known/openid-configuration";
            }
            return this.canonicalAuthority + "v2.0/.well-known/openid-configuration";
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Boolean that returns whethr or not tenant discovery has been completed.
     */
    Authority.prototype.discoveryComplete = function () {
        return !!this.metadata;
    };
    /**
     * Perform endpoint discovery to discover aliases, preferred_cache, preferred_network
     * and the /authorize, /token and logout endpoints.
     */
    Authority.prototype.resolveEndpointsAsync = function () {
        var _a, _b, _c;
        return __awaiter$2(this, void 0, void 0, function () {
            var metadataEntity, cloudDiscoverySource, endpointSource, cacheKey;
            return __generator$2(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthorityResolveEndpointsAsync, this.correlationId);
                        metadataEntity = this.cacheManager.getAuthorityMetadataByAlias(this.hostnameAndPort);
                        if (!metadataEntity) {
                            metadataEntity = new AuthorityMetadataEntity();
                            metadataEntity.updateCanonicalAuthority(this.canonicalAuthority);
                        }
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.AuthorityUpdateCloudDiscoveryMetadata, this.correlationId);
                        return [4 /*yield*/, this.updateCloudDiscoveryMetadata(metadataEntity)];
                    case 1:
                        cloudDiscoverySource = _d.sent();
                        this.canonicalAuthority = this.canonicalAuthority.replace(this.hostnameAndPort, metadataEntity.preferred_network);
                        (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.AuthorityUpdateEndpointMetadata, this.correlationId);
                        return [4 /*yield*/, this.updateEndpointMetadata(metadataEntity)];
                    case 2:
                        endpointSource = _d.sent();
                        if (cloudDiscoverySource !== AuthorityMetadataSource.CACHE && endpointSource !== AuthorityMetadataSource.CACHE) {
                            // Reset the expiration time unless both values came from a successful cache lookup
                            metadataEntity.resetExpiresAt();
                            metadataEntity.updateCanonicalAuthority(this.canonicalAuthority);
                        }
                        cacheKey = this.cacheManager.generateAuthorityMetadataCacheKey(metadataEntity.preferred_cache);
                        this.cacheManager.setAuthorityMetadata(cacheKey, metadataEntity);
                        this.metadata = metadataEntity;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update AuthorityMetadataEntity with new endpoints and return where the information came from
     * @param metadataEntity
     */
    Authority.prototype.updateEndpointMetadata = function (metadataEntity) {
        var _a, _b, _c, _d, _e, _f;
        return __awaiter$2(this, void 0, void 0, function () {
            var metadata, harcodedMetadata;
            return __generator$2(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthorityUpdateEndpointMetadata, this.correlationId);
                        metadata = this.getEndpointMetadataFromConfig();
                        if (metadata) {
                            metadataEntity.updateEndpointMetadata(metadata, false);
                            return [2 /*return*/, AuthorityMetadataSource.CONFIG];
                        }
                        if (this.isAuthoritySameType(metadataEntity) && metadataEntity.endpointsFromNetwork && !metadataEntity.isExpired()) {
                            // No need to update
                            return [2 /*return*/, AuthorityMetadataSource.CACHE];
                        }
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.AuthorityGetEndpointMetadataFromNetwork, this.correlationId);
                        return [4 /*yield*/, this.getEndpointMetadataFromNetwork()];
                    case 1:
                        metadata = _g.sent();
                        if (!metadata) return [3 /*break*/, 4];
                        if (!((_c = this.authorityOptions.azureRegionConfiguration) === null || _c === void 0 ? void 0 : _c.azureRegion)) return [3 /*break*/, 3];
                        (_d = this.performanceClient) === null || _d === void 0 ? void 0 : _d.setPreQueueTime(PerformanceEvents.AuthorityUpdateMetadataWithRegionalInformation, this.correlationId);
                        return [4 /*yield*/, this.updateMetadataWithRegionalInformation(metadata)];
                    case 2:
                        metadata = _g.sent();
                        _g.label = 3;
                    case 3:
                        metadataEntity.updateEndpointMetadata(metadata, true);
                        return [2 /*return*/, AuthorityMetadataSource.NETWORK];
                    case 4:
                        harcodedMetadata = this.getEndpointMetadataFromHardcodedValues();
                        if (!(harcodedMetadata && !this.authorityOptions.skipAuthorityMetadataCache)) return [3 /*break*/, 7];
                        if (!((_e = this.authorityOptions.azureRegionConfiguration) === null || _e === void 0 ? void 0 : _e.azureRegion)) return [3 /*break*/, 6];
                        (_f = this.performanceClient) === null || _f === void 0 ? void 0 : _f.setPreQueueTime(PerformanceEvents.AuthorityUpdateMetadataWithRegionalInformation, this.correlationId);
                        return [4 /*yield*/, this.updateMetadataWithRegionalInformation(harcodedMetadata)];
                    case 5:
                        harcodedMetadata = _g.sent();
                        _g.label = 6;
                    case 6:
                        metadataEntity.updateEndpointMetadata(harcodedMetadata, false);
                        return [2 /*return*/, AuthorityMetadataSource.HARDCODED_VALUES];
                    case 7: throw ClientAuthError.createUnableToGetOpenidConfigError(this.defaultOpenIdConfigurationEndpoint);
                }
            });
        });
    };
    /**
     * Compares the number of url components after the domain to determine if the cached
     * authority metadata can be used for the requested authority. Protects against same domain different
     * authority such as login.microsoftonline.com/tenant and login.microsoftonline.com/tfp/tenant/policy
     * @param metadataEntity
     */
    Authority.prototype.isAuthoritySameType = function (metadataEntity) {
        var cachedAuthorityUrl = new UrlString(metadataEntity.canonical_authority);
        var cachedParts = cachedAuthorityUrl.getUrlComponents().PathSegments;
        return cachedParts.length === this.canonicalAuthorityUrlComponents.PathSegments.length;
    };
    /**
     * Parse authorityMetadata config option
     */
    Authority.prototype.getEndpointMetadataFromConfig = function () {
        if (this.authorityOptions.authorityMetadata) {
            try {
                return JSON.parse(this.authorityOptions.authorityMetadata);
            }
            catch (e) {
                throw ClientConfigurationError.createInvalidAuthorityMetadataError();
            }
        }
        return null;
    };
    /**
     * Gets OAuth endpoints from the given OpenID configuration endpoint.
     *
     * @param hasHardcodedMetadata boolean
     */
    Authority.prototype.getEndpointMetadataFromNetwork = function () {
        var _a;
        return __awaiter$2(this, void 0, void 0, function () {
            var options, response;
            return __generator$2(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthorityGetEndpointMetadataFromNetwork, this.correlationId);
                        options = {};
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.networkInterface.
                                sendGetRequestAsync(this.defaultOpenIdConfigurationEndpoint, options)];
                    case 2:
                        response = _b.sent();
                        return [2 /*return*/, isOpenIdConfigResponse(response.body) ? response.body : null];
                    case 3:
                        _b.sent();
                        return [2 /*return*/, null];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get OAuth endpoints for common authorities.
     */
    Authority.prototype.getEndpointMetadataFromHardcodedValues = function () {
        if (this.canonicalAuthority in EndpointMetadata) {
            return EndpointMetadata[this.canonicalAuthority];
        }
        return null;
    };
    /**
     * Update the retrieved metadata with regional information.
     * User selected Azure region will be used if configured.
     */
    Authority.prototype.updateMetadataWithRegionalInformation = function (metadata) {
        var _a, _b, _c, _d;
        return __awaiter$2(this, void 0, void 0, function () {
            var userConfiguredAzureRegion, autodetectedRegionName;
            return __generator$2(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthorityUpdateMetadataWithRegionalInformation, this.correlationId);
                        userConfiguredAzureRegion = (_b = this.authorityOptions.azureRegionConfiguration) === null || _b === void 0 ? void 0 : _b.azureRegion;
                        if (!userConfiguredAzureRegion) return [3 /*break*/, 2];
                        if (userConfiguredAzureRegion !== Constants.AZURE_REGION_AUTO_DISCOVER_FLAG) {
                            this.regionDiscoveryMetadata.region_outcome = RegionDiscoveryOutcomes.CONFIGURED_NO_AUTO_DETECTION;
                            this.regionDiscoveryMetadata.region_used = userConfiguredAzureRegion;
                            return [2 /*return*/, Authority.replaceWithRegionalInformation(metadata, userConfiguredAzureRegion)];
                        }
                        (_c = this.performanceClient) === null || _c === void 0 ? void 0 : _c.setPreQueueTime(PerformanceEvents.RegionDiscoveryDetectRegion, this.correlationId);
                        return [4 /*yield*/, this.regionDiscovery.detectRegion((_d = this.authorityOptions.azureRegionConfiguration) === null || _d === void 0 ? void 0 : _d.environmentRegion, this.regionDiscoveryMetadata)];
                    case 1:
                        autodetectedRegionName = _e.sent();
                        if (autodetectedRegionName) {
                            this.regionDiscoveryMetadata.region_outcome = RegionDiscoveryOutcomes.AUTO_DETECTION_REQUESTED_SUCCESSFUL;
                            this.regionDiscoveryMetadata.region_used = autodetectedRegionName;
                            return [2 /*return*/, Authority.replaceWithRegionalInformation(metadata, autodetectedRegionName)];
                        }
                        this.regionDiscoveryMetadata.region_outcome = RegionDiscoveryOutcomes.AUTO_DETECTION_REQUESTED_FAILED;
                        _e.label = 2;
                    case 2: return [2 /*return*/, metadata];
                }
            });
        });
    };
    /**
     * Updates the AuthorityMetadataEntity with new aliases, preferred_network and preferred_cache
     * and returns where the information was retrieved from
     * @param metadataEntity
     * @returns AuthorityMetadataSource
     */
    Authority.prototype.updateCloudDiscoveryMetadata = function (metadataEntity) {
        var _a, _b;
        return __awaiter$2(this, void 0, void 0, function () {
            var metadata, metadataEntityExpired, harcodedMetadata;
            return __generator$2(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthorityUpdateCloudDiscoveryMetadata, this.correlationId);
                        // attempt to read metadata from the config
                        this.logger.verbose("Attempting to get cloud discovery metadata in the config");
                        this.logger.verbosePii("Known Authorities: " + (this.authorityOptions.knownAuthorities || Constants.NOT_APPLICABLE));
                        this.logger.verbosePii("Authority Metadata: " + (this.authorityOptions.authorityMetadata || Constants.NOT_APPLICABLE));
                        this.logger.verbosePii("Canonical Authority: " + (metadataEntity.canonical_authority || Constants.NOT_APPLICABLE));
                        metadata = this.getCloudDiscoveryMetadataFromConfig();
                        if (metadata) {
                            this.logger.verbose("Found cloud discovery metadata in the config.");
                            metadataEntity.updateCloudDiscoveryMetadata(metadata, false);
                            return [2 /*return*/, AuthorityMetadataSource.CONFIG];
                        }
                        // If the cached metadata came from config but that config was not passed to this instance, we must go to the network
                        this.logger.verbose("Did not find cloud discovery metadata in the config... Attempting to get cloud discovery metadata from the cache.");
                        metadataEntityExpired = metadataEntity.isExpired();
                        if (this.isAuthoritySameType(metadataEntity) && metadataEntity.aliasesFromNetwork && !metadataEntityExpired) {
                            this.logger.verbose("Found metadata in the cache.");
                            // No need to update
                            return [2 /*return*/, AuthorityMetadataSource.CACHE];
                        }
                        else if (metadataEntityExpired) {
                            this.logger.verbose("The metadata entity is expired.");
                        }
                        this.logger.verbose("Did not find cloud discovery metadata in the cache... Attempting to get cloud discovery metadata from the network.");
                        (_b = this.performanceClient) === null || _b === void 0 ? void 0 : _b.setPreQueueTime(PerformanceEvents.AuthorityGetCloudDiscoveryMetadataFromNetwork, this.correlationId);
                        return [4 /*yield*/, this.getCloudDiscoveryMetadataFromNetwork()];
                    case 1:
                        metadata = _c.sent();
                        if (metadata) {
                            this.logger.verbose("cloud discovery metadata was successfully returned from getCloudDiscoveryMetadataFromNetwork()");
                            metadataEntity.updateCloudDiscoveryMetadata(metadata, true);
                            return [2 /*return*/, AuthorityMetadataSource.NETWORK];
                        }
                        this.logger.verbose("Did not find cloud discovery metadata from the network... Attempting to get cloud discovery metadata from hardcoded values.");
                        harcodedMetadata = this.getCloudDiscoveryMetadataFromHarcodedValues();
                        if (harcodedMetadata && !this.options.skipAuthorityMetadataCache) {
                            this.logger.verbose("Found cloud discovery metadata from hardcoded values.");
                            metadataEntity.updateCloudDiscoveryMetadata(harcodedMetadata, false);
                            return [2 /*return*/, AuthorityMetadataSource.HARDCODED_VALUES];
                        }
                        // Metadata could not be obtained from the config, cache, network or hardcoded values
                        this.logger.error("Did not find cloud discovery metadata from hardcoded values... Metadata could not be obtained from config, cache, network or hardcoded values. Throwing Untrusted Authority Error.");
                        throw ClientConfigurationError.createUntrustedAuthorityError();
                }
            });
        });
    };
    /**
     * Parse cloudDiscoveryMetadata config or check knownAuthorities
     */
    Authority.prototype.getCloudDiscoveryMetadataFromConfig = function () {
        // CIAM does not support cloud discovery metadata
        if (this.authorityType === AuthorityType.Ciam) {
            this.logger.verbose("CIAM authorities do not support cloud discovery metadata, generate the aliases from authority host.");
            return Authority.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort);
        }
        // Check if network response was provided in config
        if (this.authorityOptions.cloudDiscoveryMetadata) {
            this.logger.verbose("The cloud discovery metadata has been provided as a network response, in the config.");
            try {
                this.logger.verbose("Attempting to parse the cloud discovery metadata.");
                var parsedResponse = JSON.parse(this.authorityOptions.cloudDiscoveryMetadata);
                var metadata = Authority.getCloudDiscoveryMetadataFromNetworkResponse(parsedResponse.metadata, this.hostnameAndPort);
                this.logger.verbose("Parsed the cloud discovery metadata.");
                if (metadata) {
                    this.logger.verbose("There is returnable metadata attached to the parsed cloud discovery metadata.");
                    return metadata;
                }
                else {
                    this.logger.verbose("There is no metadata attached to the parsed cloud discovery metadata.");
                }
            }
            catch (e) {
                this.logger.verbose("Unable to parse the cloud discovery metadata. Throwing Invalid Cloud Discovery Metadata Error.");
                throw ClientConfigurationError.createInvalidCloudDiscoveryMetadataError();
            }
        }
        // If cloudDiscoveryMetadata is empty or does not contain the host, check knownAuthorities
        if (this.isInKnownAuthorities()) {
            this.logger.verbose("The host is included in knownAuthorities. Creating new cloud discovery metadata from the host.");
            return Authority.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort);
        }
        return null;
    };
    /**
     * Called to get metadata from network if CloudDiscoveryMetadata was not populated by config
     *
     * @param hasHardcodedMetadata boolean
     */
    Authority.prototype.getCloudDiscoveryMetadataFromNetwork = function () {
        var _a;
        return __awaiter$2(this, void 0, void 0, function () {
            var instanceDiscoveryEndpoint, options, match, response, typedResponseBody, metadata, error_1, typedError;
            return __generator$2(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.addQueueMeasurement(PerformanceEvents.AuthorityGetCloudDiscoveryMetadataFromNetwork, this.correlationId);
                        instanceDiscoveryEndpoint = "" + Constants.AAD_INSTANCE_DISCOVERY_ENDPT + this.canonicalAuthority + "oauth2/v2.0/authorize";
                        options = {};
                        match = null;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.networkInterface.sendGetRequestAsync(instanceDiscoveryEndpoint, options)];
                    case 2:
                        response = _b.sent();
                        typedResponseBody = void 0;
                        metadata = void 0;
                        if (isCloudInstanceDiscoveryResponse(response.body)) {
                            typedResponseBody = response.body;
                            metadata = typedResponseBody.metadata;
                            this.logger.verbosePii("tenant_discovery_endpoint is: " + typedResponseBody.tenant_discovery_endpoint);
                        }
                        else if (isCloudInstanceDiscoveryErrorResponse(response.body)) {
                            this.logger.warning("A CloudInstanceDiscoveryErrorResponse was returned. The cloud instance discovery network request's status code is: " + response.status);
                            typedResponseBody = response.body;
                            if (typedResponseBody.error === Constants.INVALID_INSTANCE) {
                                this.logger.error("The CloudInstanceDiscoveryErrorResponse error is invalid_instance.");
                                return [2 /*return*/, null];
                            }
                            this.logger.warning("The CloudInstanceDiscoveryErrorResponse error is " + typedResponseBody.error);
                            this.logger.warning("The CloudInstanceDiscoveryErrorResponse error description is " + typedResponseBody.error_description);
                            this.logger.warning("Setting the value of the CloudInstanceDiscoveryMetadata (returned from the network) to []");
                            metadata = [];
                        }
                        else {
                            this.logger.error("AAD did not return a CloudInstanceDiscoveryResponse or CloudInstanceDiscoveryErrorResponse");
                            return [2 /*return*/, null];
                        }
                        this.logger.verbose("Attempting to find a match between the developer's authority and the CloudInstanceDiscoveryMetadata returned from the network request.");
                        match = Authority.getCloudDiscoveryMetadataFromNetworkResponse(metadata, this.hostnameAndPort);
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        if (error_1 instanceof AuthError) {
                            this.logger.error("There was a network error while attempting to get the cloud discovery instance metadata.\nError: " + error_1.errorCode + "\nError Description: " + error_1.errorMessage);
                        }
                        else {
                            typedError = error_1;
                            this.logger.error("A non-MSALJS error was thrown while attempting to get the cloud instance discovery metadata.\nError: " + typedError.name + "\nError Description: " + typedError.message);
                        }
                        return [2 /*return*/, null];
                    case 4:
                        // Custom Domain scenario, host is trusted because Instance Discovery call succeeded
                        if (!match) {
                            this.logger.warning("The developer's authority was not found within the CloudInstanceDiscoveryMetadata returned from the network request.");
                            this.logger.verbose("Creating custom Authority for custom domain scenario.");
                            match = Authority.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort);
                        }
                        return [2 /*return*/, match];
                }
            });
        });
    };
    /**
     * Get cloud discovery metadata for common authorities
     */
    Authority.prototype.getCloudDiscoveryMetadataFromHarcodedValues = function () {
        if (this.canonicalAuthority in InstanceDiscoveryMetadata) {
            return InstanceDiscoveryMetadata[this.canonicalAuthority];
        }
        return null;
    };
    /**
     * Helper function to determine if this host is included in the knownAuthorities config option
     */
    Authority.prototype.isInKnownAuthorities = function () {
        var _this = this;
        var matches = this.authorityOptions.knownAuthorities.filter(function (authority) {
            return UrlString.getDomainFromUrl(authority).toLowerCase() === _this.hostnameAndPort;
        });
        return matches.length > 0;
    };
    /**
     * helper function to populate the authority based on azureCloudOptions
     * @param authorityString
     * @param azureCloudOptions
     */
    Authority.generateAuthority = function (authorityString, azureCloudOptions) {
        var authorityAzureCloudInstance;
        if (azureCloudOptions && azureCloudOptions.azureCloudInstance !== AzureCloudInstance.None) {
            var tenant = azureCloudOptions.tenant ? azureCloudOptions.tenant : Constants.DEFAULT_COMMON_TENANT;
            authorityAzureCloudInstance = azureCloudOptions.azureCloudInstance + "/" + tenant + "/";
        }
        return authorityAzureCloudInstance ? authorityAzureCloudInstance : authorityString;
    };
    /**
     * Creates cloud discovery metadata object from a given host
     * @param host
     */
    Authority.createCloudDiscoveryMetadataFromHost = function (host) {
        return {
            preferred_network: host,
            preferred_cache: host,
            aliases: [host]
        };
    };
    /**
     * Searches instance discovery network response for the entry that contains the host in the aliases list
     * @param response
     * @param authority
     */
    Authority.getCloudDiscoveryMetadataFromNetworkResponse = function (response, authority) {
        for (var i = 0; i < response.length; i++) {
            var metadata = response[i];
            if (metadata.aliases.indexOf(authority) > -1) {
                return metadata;
            }
        }
        return null;
    };
    /**
     * helper function to generate environment from authority object
     */
    Authority.prototype.getPreferredCache = function () {
        if (this.discoveryComplete()) {
            return this.metadata.preferred_cache;
        }
        else {
            throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.");
        }
    };
    /**
     * Returns whether or not the provided host is an alias of this authority instance
     * @param host
     */
    Authority.prototype.isAlias = function (host) {
        return this.metadata.aliases.indexOf(host) > -1;
    };
    /**
     * Checks whether the provided host is that of a public cloud authority
     *
     * @param authority string
     * @returns bool
     */
    Authority.isPublicCloudAuthority = function (host) {
        return Constants.KNOWN_PUBLIC_CLOUDS.indexOf(host) >= 0;
    };
    /**
     * Rebuild the authority string with the region
     *
     * @param host string
     * @param region string
     */
    Authority.buildRegionalAuthorityString = function (host, region, queryString) {
        // Create and validate a Url string object with the initial authority string
        var authorityUrlInstance = new UrlString(host);
        authorityUrlInstance.validateAsUri();
        var authorityUrlParts = authorityUrlInstance.getUrlComponents();
        var hostNameAndPort = region + "." + authorityUrlParts.HostNameAndPort;
        if (this.isPublicCloudAuthority(authorityUrlParts.HostNameAndPort)) {
            hostNameAndPort = region + "." + Constants.REGIONAL_AUTH_PUBLIC_CLOUD_SUFFIX;
        }
        // Include the query string portion of the url
        var url = UrlString.constructAuthorityUriFromObject(__assign$4(__assign$4({}, authorityUrlInstance.getUrlComponents()), { HostNameAndPort: hostNameAndPort })).urlString;
        // Add the query string if a query string was provided
        if (queryString)
            return url + "?" + queryString;
        return url;
    };
    /**
     * Replace the endpoints in the metadata object with their regional equivalents.
     *
     * @param metadata OpenIdConfigResponse
     * @param azureRegion string
     */
    Authority.replaceWithRegionalInformation = function (metadata, azureRegion) {
        metadata.authorization_endpoint = Authority.buildRegionalAuthorityString(metadata.authorization_endpoint, azureRegion);
        // TODO: Enquire on whether we should leave the query string or remove it before releasing the feature
        metadata.token_endpoint = Authority.buildRegionalAuthorityString(metadata.token_endpoint, azureRegion, Constants.REGIONAL_AUTH_NON_MSI_QUERY_STRING);
        if (metadata.end_session_endpoint) {
            metadata.end_session_endpoint = Authority.buildRegionalAuthorityString(metadata.end_session_endpoint, azureRegion);
        }
        return metadata;
    };
    /**
     * Transform CIAM_AUTHORIY as per the below rules:
     * If no path segments found and it is a CIAM authority (hostname ends with .ciamlogin.com), then transform it
     *
     * NOTE: The transformation path should go away once STS supports CIAM with the format: `tenantIdorDomain.ciamlogin.com`
     * `ciamlogin.com` can also change in the future and we should accommodate the same
     *
     * @param authority
     */
    Authority.transformCIAMAuthority = function (authority) {
        var ciamAuthority = authority.endsWith(Constants.FORWARD_SLASH) ? authority : "" + authority + Constants.FORWARD_SLASH;
        var authorityUrl = new UrlString(authority);
        var authorityUrlComponents = authorityUrl.getUrlComponents();
        // check if transformation is needed
        if (authorityUrlComponents.PathSegments.length === 0 && (authorityUrlComponents.HostNameAndPort.endsWith(Constants.CIAM_AUTH_URL))) {
            var tenantIdOrDomain = authorityUrlComponents.HostNameAndPort.split(".")[0];
            ciamAuthority = "" + ciamAuthority + tenantIdOrDomain + Constants.AAD_TENANT_DOMAIN_SUFFIX;
        }
        return ciamAuthority;
    };
    // Reserved tenant domain names that will not be replaced with tenant id
    Authority.reservedTenantDomains = (new Set([
        "{tenant}",
        "{tenantid}",
        AADAuthorityConstants.COMMON,
        AADAuthorityConstants.CONSUMERS,
        AADAuthorityConstants.ORGANIZATIONS
    ]));
    return Authority;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var AuthorityFactory = /** @class */ (function () {
    function AuthorityFactory() {
    }
    /**
     * Create an authority object of the correct type based on the url
     * Performs basic authority validation - checks to see if the authority is of a valid type (i.e. aad, b2c, adfs)
     *
     * Also performs endpoint discovery.
     *
     * @param authorityUri
     * @param networkClient
     * @param protocolMode
     */
    AuthorityFactory.createDiscoveredInstance = function (authorityUri, networkClient, cacheManager, authorityOptions, logger, performanceClient, correlationId) {
        return __awaiter$2(this, void 0, void 0, function () {
            var authorityUriFinal, acquireTokenAuthority, e_1;
            return __generator$2(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        performanceClient === null || performanceClient === void 0 ? void 0 : performanceClient.addQueueMeasurement(PerformanceEvents.AuthorityFactoryCreateDiscoveredInstance, correlationId);
                        authorityUriFinal = Authority.transformCIAMAuthority(authorityUri);
                        acquireTokenAuthority = AuthorityFactory.createInstance(authorityUriFinal, networkClient, cacheManager, authorityOptions, logger, performanceClient, correlationId);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        performanceClient === null || performanceClient === void 0 ? void 0 : performanceClient.setPreQueueTime(PerformanceEvents.AuthorityResolveEndpointsAsync, correlationId);
                        return [4 /*yield*/, acquireTokenAuthority.resolveEndpointsAsync()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, acquireTokenAuthority];
                    case 3:
                        e_1 = _a.sent();
                        throw ClientAuthError.createEndpointDiscoveryIncompleteError(e_1);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create an authority object of the correct type based on the url
     * Performs basic authority validation - checks to see if the authority is of a valid type (i.e. aad, b2c, adfs)
     *
     * Does not perform endpoint discovery.
     *
     * @param authorityUrl
     * @param networkInterface
     * @param protocolMode
     */
    AuthorityFactory.createInstance = function (authorityUrl, networkInterface, cacheManager, authorityOptions, logger, performanceClient, correlationId) {
        // Throw error if authority url is empty
        if (StringUtils.isEmpty(authorityUrl)) {
            throw ClientConfigurationError.createUrlEmptyError();
        }
        return new Authority(authorityUrl, networkInterface, cacheManager, authorityOptions, logger, performanceClient, correlationId);
    };
    return AuthorityFactory;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var ServerTelemetryEntity = /** @class */ (function () {
    function ServerTelemetryEntity() {
        this.failedRequests = [];
        this.errors = [];
        this.cacheHits = 0;
    }
    /**
     * validates if a given cache entry is "Telemetry", parses <key,value>
     * @param key
     * @param entity
     */
    ServerTelemetryEntity.isServerTelemetryEntity = function (key, entity) {
        var validateKey = key.indexOf(SERVER_TELEM_CONSTANTS.CACHE_KEY) === 0;
        var validateEntity = true;
        if (entity) {
            validateEntity =
                entity.hasOwnProperty("failedRequests") &&
                    entity.hasOwnProperty("errors") &&
                    entity.hasOwnProperty("cacheHits");
        }
        return validateKey && validateEntity;
    };
    return ServerTelemetryEntity;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var ThrottlingEntity = /** @class */ (function () {
    function ThrottlingEntity() {
    }
    /**
     * validates if a given cache entry is "Throttling", parses <key,value>
     * @param key
     * @param entity
     */
    ThrottlingEntity.isThrottlingEntity = function (key, entity) {
        var validateKey = false;
        if (key) {
            validateKey = key.indexOf(ThrottlingConstants.THROTTLING_PREFIX) === 0;
        }
        var validateEntity = true;
        if (entity) {
            validateEntity = entity.hasOwnProperty("throttleTime");
        }
        return validateKey && validateEntity;
    };
    return ThrottlingEntity;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var StubbedNetworkModule = {
    sendGetRequestAsync: function () {
        var notImplErr = "Network interface - sendGetRequestAsync() has not been implemented for the Network interface.";
        return Promise.reject(AuthError.createUnexpectedError(notImplErr));
    },
    sendPostRequestAsync: function () {
        var notImplErr = "Network interface - sendPostRequestAsync() has not been implemented for the Network interface.";
        return Promise.reject(AuthError.createUnexpectedError(notImplErr));
    }
};

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * ClientAuthErrorMessage class containing string constants used by error codes and messages.
 */
var JoseHeaderErrorMessage = {
    missingKidError: {
        code: "missing_kid_error",
        desc: "The JOSE Header for the requested JWT, JWS or JWK object requires a keyId to be configured as the 'kid' header claim. No 'kid' value was provided."
    },
    missingAlgError: {
        code: "missing_alg_error",
        desc: "The JOSE Header for the requested JWT, JWS or JWK object requires an algorithm to be specified as the 'alg' header claim. No 'alg' value was provided."
    },
};
/**
 * Error thrown when there is an error in the client code running on the browser.
 */
var JoseHeaderError = /** @class */ (function (_super) {
    __extends$f(JoseHeaderError, _super);
    function JoseHeaderError(errorCode, errorMessage) {
        var _this = _super.call(this, errorCode, errorMessage) || this;
        _this.name = "JoseHeaderError";
        Object.setPrototypeOf(_this, JoseHeaderError.prototype);
        return _this;
    }
    /**
     * Creates an error thrown when keyId isn't set on JOSE header.
     */
    JoseHeaderError.createMissingKidError = function () {
        return new JoseHeaderError(JoseHeaderErrorMessage.missingKidError.code, JoseHeaderErrorMessage.missingKidError.desc);
    };
    /**
     * Creates an error thrown when algorithm isn't set on JOSE header.
     */
    JoseHeaderError.createMissingAlgError = function () {
        return new JoseHeaderError(JoseHeaderErrorMessage.missingAlgError.code, JoseHeaderErrorMessage.missingAlgError.desc);
    };
    return JoseHeaderError;
}(AuthError));

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var JoseHeader = /** @class */ (function () {
    function JoseHeader(options) {
        this.typ = options.typ;
        this.alg = options.alg;
        this.kid = options.kid;
    }
    /**
     * Builds SignedHttpRequest formatted JOSE Header from the
     * JOSE Header options provided or previously set on the object and returns
     * the stringified header object.
     * Throws if keyId or algorithm aren't provided since they are required for Access Token Binding.
     * @param shrHeaderOptions
     * @returns
     */
    JoseHeader.getShrHeaderString = function (shrHeaderOptions) {
        // KeyID is required on the SHR header
        if (!shrHeaderOptions.kid) {
            throw JoseHeaderError.createMissingKidError();
        }
        // Alg is required on the SHR header
        if (!shrHeaderOptions.alg) {
            throw JoseHeaderError.createMissingAlgError();
        }
        var shrHeader = new JoseHeader({
            // Access Token PoP headers must have type pop, but the type header can be overriden for special cases
            typ: shrHeaderOptions.typ || JsonTypes.Pop,
            kid: shrHeaderOptions.kid,
            alg: shrHeaderOptions.alg
        });
        return JSON.stringify(shrHeader);
    };
    return JoseHeader;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var ServerTelemetryManager = /** @class */ (function () {
    function ServerTelemetryManager(telemetryRequest, cacheManager) {
        this.cacheOutcome = CacheOutcome.NO_CACHE_HIT;
        this.cacheManager = cacheManager;
        this.apiId = telemetryRequest.apiId;
        this.correlationId = telemetryRequest.correlationId;
        this.wrapperSKU = telemetryRequest.wrapperSKU || Constants.EMPTY_STRING;
        this.wrapperVer = telemetryRequest.wrapperVer || Constants.EMPTY_STRING;
        this.telemetryCacheKey = SERVER_TELEM_CONSTANTS.CACHE_KEY + Separators.CACHE_KEY_SEPARATOR + telemetryRequest.clientId;
    }
    /**
     * API to add MSER Telemetry to request
     */
    ServerTelemetryManager.prototype.generateCurrentRequestHeaderValue = function () {
        var request = "" + this.apiId + SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR + this.cacheOutcome;
        var platformFields = [this.wrapperSKU, this.wrapperVer].join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR);
        var regionDiscoveryFields = this.getRegionDiscoveryFields();
        var requestWithRegionDiscoveryFields = [request, regionDiscoveryFields].join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR);
        return [SERVER_TELEM_CONSTANTS.SCHEMA_VERSION, requestWithRegionDiscoveryFields, platformFields].join(SERVER_TELEM_CONSTANTS.CATEGORY_SEPARATOR);
    };
    /**
     * API to add MSER Telemetry for the last failed request
     */
    ServerTelemetryManager.prototype.generateLastRequestHeaderValue = function () {
        var lastRequests = this.getLastRequests();
        var maxErrors = ServerTelemetryManager.maxErrorsToSend(lastRequests);
        var failedRequests = lastRequests.failedRequests.slice(0, 2 * maxErrors).join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR);
        var errors = lastRequests.errors.slice(0, maxErrors).join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR);
        var errorCount = lastRequests.errors.length;
        // Indicate whether this header contains all data or partial data
        var overflow = maxErrors < errorCount ? SERVER_TELEM_CONSTANTS.OVERFLOW_TRUE : SERVER_TELEM_CONSTANTS.OVERFLOW_FALSE;
        var platformFields = [errorCount, overflow].join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR);
        return [SERVER_TELEM_CONSTANTS.SCHEMA_VERSION, lastRequests.cacheHits, failedRequests, errors, platformFields].join(SERVER_TELEM_CONSTANTS.CATEGORY_SEPARATOR);
    };
    /**
     * API to cache token failures for MSER data capture
     * @param error
     */
    ServerTelemetryManager.prototype.cacheFailedRequest = function (error) {
        var lastRequests = this.getLastRequests();
        if (lastRequests.errors.length >= SERVER_TELEM_CONSTANTS.MAX_CACHED_ERRORS) {
            // Remove a cached error to make room, first in first out
            lastRequests.failedRequests.shift(); // apiId
            lastRequests.failedRequests.shift(); // correlationId
            lastRequests.errors.shift();
        }
        lastRequests.failedRequests.push(this.apiId, this.correlationId);
        if (!StringUtils.isEmpty(error.subError)) {
            lastRequests.errors.push(error.subError);
        }
        else if (!StringUtils.isEmpty(error.errorCode)) {
            lastRequests.errors.push(error.errorCode);
        }
        else if (!!error && error.toString()) {
            lastRequests.errors.push(error.toString());
        }
        else {
            lastRequests.errors.push(SERVER_TELEM_CONSTANTS.UNKNOWN_ERROR);
        }
        this.cacheManager.setServerTelemetry(this.telemetryCacheKey, lastRequests);
        return;
    };
    /**
     * Update server telemetry cache entry by incrementing cache hit counter
     */
    ServerTelemetryManager.prototype.incrementCacheHits = function () {
        var lastRequests = this.getLastRequests();
        lastRequests.cacheHits += 1;
        this.cacheManager.setServerTelemetry(this.telemetryCacheKey, lastRequests);
        return lastRequests.cacheHits;
    };
    /**
     * Get the server telemetry entity from cache or initialize a new one
     */
    ServerTelemetryManager.prototype.getLastRequests = function () {
        var initialValue = new ServerTelemetryEntity();
        var lastRequests = this.cacheManager.getServerTelemetry(this.telemetryCacheKey);
        return lastRequests || initialValue;
    };
    /**
     * Remove server telemetry cache entry
     */
    ServerTelemetryManager.prototype.clearTelemetryCache = function () {
        var lastRequests = this.getLastRequests();
        var numErrorsFlushed = ServerTelemetryManager.maxErrorsToSend(lastRequests);
        var errorCount = lastRequests.errors.length;
        if (numErrorsFlushed === errorCount) {
            // All errors were sent on last request, clear Telemetry cache
            this.cacheManager.removeItem(this.telemetryCacheKey);
        }
        else {
            // Partial data was flushed to server, construct a new telemetry cache item with errors that were not flushed
            var serverTelemEntity = new ServerTelemetryEntity();
            serverTelemEntity.failedRequests = lastRequests.failedRequests.slice(numErrorsFlushed * 2); // failedRequests contains 2 items for each error
            serverTelemEntity.errors = lastRequests.errors.slice(numErrorsFlushed);
            this.cacheManager.setServerTelemetry(this.telemetryCacheKey, serverTelemEntity);
        }
    };
    /**
     * Returns the maximum number of errors that can be flushed to the server in the next network request
     * @param serverTelemetryEntity
     */
    ServerTelemetryManager.maxErrorsToSend = function (serverTelemetryEntity) {
        var i;
        var maxErrors = 0;
        var dataSize = 0;
        var errorCount = serverTelemetryEntity.errors.length;
        for (i = 0; i < errorCount; i++) {
            // failedRequests parameter contains pairs of apiId and correlationId, multiply index by 2 to preserve pairs
            var apiId = serverTelemetryEntity.failedRequests[2 * i] || Constants.EMPTY_STRING;
            var correlationId = serverTelemetryEntity.failedRequests[2 * i + 1] || Constants.EMPTY_STRING;
            var errorCode = serverTelemetryEntity.errors[i] || Constants.EMPTY_STRING;
            // Count number of characters that would be added to header, each character is 1 byte. Add 3 at the end to account for separators
            dataSize += apiId.toString().length + correlationId.toString().length + errorCode.length + 3;
            if (dataSize < SERVER_TELEM_CONSTANTS.MAX_LAST_HEADER_BYTES) {
                // Adding this entry to the header would still keep header size below the limit
                maxErrors += 1;
            }
            else {
                break;
            }
        }
        return maxErrors;
    };
    /**
     * Get the region discovery fields
     *
     * @returns string
     */
    ServerTelemetryManager.prototype.getRegionDiscoveryFields = function () {
        var regionDiscoveryFields = [];
        regionDiscoveryFields.push(this.regionUsed || Constants.EMPTY_STRING);
        regionDiscoveryFields.push(this.regionSource || Constants.EMPTY_STRING);
        regionDiscoveryFields.push(this.regionOutcome || Constants.EMPTY_STRING);
        return regionDiscoveryFields.join(",");
    };
    /**
     * Update the region discovery metadata
     *
     * @param regionDiscoveryMetadata
     * @returns void
     */
    ServerTelemetryManager.prototype.updateRegionDiscoveryMetadata = function (regionDiscoveryMetadata) {
        this.regionUsed = regionDiscoveryMetadata.region_used;
        this.regionSource = regionDiscoveryMetadata.region_source;
        this.regionOutcome = regionDiscoveryMetadata.region_outcome;
    };
    /**
     * Set cache outcome
     */
    ServerTelemetryManager.prototype.setCacheOutcome = function (cacheOutcome) {
        this.cacheOutcome = cacheOutcome;
    };
    return ServerTelemetryManager;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var PerformanceClient = /** @class */ (function () {
    /**
     * Creates an instance of PerformanceClient,
     * an abstract class containing core performance telemetry logic.
     *
     * @constructor
     * @param {string} clientId Client ID of the application
     * @param {string} authority Authority used by the application
     * @param {Logger} logger Logger used by the application
     * @param {string} libraryName Name of the library
     * @param {string} libraryVersion Version of the library
     */
    function PerformanceClient(clientId, authority, logger, libraryName, libraryVersion, applicationTelemetry) {
        this.authority = authority;
        this.libraryName = libraryName;
        this.libraryVersion = libraryVersion;
        this.applicationTelemetry = applicationTelemetry;
        this.clientId = clientId;
        this.logger = logger;
        this.callbacks = new Map();
        this.eventsByCorrelationId = new Map();
        this.queueMeasurements = new Map();
        this.preQueueTimeByCorrelationId = new Map();
    }
    /**
     * Starts and returns an platform-specific implementation of IPerformanceMeasurement.
     * Note: this function can be changed to abstract at the next major version bump.
     *
     * @param {string} measureName
     * @param {string} correlationId
     * @returns {IPerformanceMeasurement}
     */
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    PerformanceClient.prototype.startPerformanceMeasurement = function (measureName, correlationId) {
        return {};
    };
    /**
     * Starts and returns an platform-specific implementation of IPerformanceMeasurement.
     * Note: this incorrectly-named function will be removed at the next major version bump.
     *
     * @param {string} measureName
     * @param {string} correlationId
     * @returns {IPerformanceMeasurement}
     */
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    PerformanceClient.prototype.startPerformanceMeasuremeant = function (measureName, correlationId) {
        return {};
    };
    /**
     * Get integral fields.
     * Override to change the set.
     */
    PerformanceClient.prototype.getIntFields = function () {
        return IntFields;
    };
    /**
     * Gets map of pre-queue times by correlation Id
     *
     * @param {PerformanceEvents} eventName
     * @param {string} correlationId
     * @returns {number}
     */
    PerformanceClient.prototype.getPreQueueTime = function (eventName, correlationId) {
        var preQueueEvent = this.preQueueTimeByCorrelationId.get(correlationId);
        if (!preQueueEvent) {
            this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue times found for correlationId: " + correlationId + ", unable to add queue measurement");
            return;
        }
        else if (preQueueEvent.name !== eventName) {
            this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue time found for " + eventName + ", unable to add queue measurement");
            return;
        }
        return preQueueEvent.time;
    };
    /**
     * Calculates the difference between current time and time when function was queued.
     * Note: It is possible to have 0 as the queue time if the current time and the queued time was the same.
     *
     * @param {number} preQueueTime
     * @param {number} currentTime
     * @returns {number}
     */
    PerformanceClient.prototype.calculateQueuedTime = function (preQueueTime, currentTime) {
        if (preQueueTime < 1) {
            this.logger.trace("PerformanceClient: preQueueTime should be a positive integer and not " + preQueueTime);
            return 0;
        }
        if (currentTime < 1) {
            this.logger.trace("PerformanceClient: currentTime should be a positive integer and not " + currentTime);
            return 0;
        }
        if (currentTime < preQueueTime) {
            this.logger.trace("PerformanceClient: currentTime is less than preQueueTime, check how time is being retrieved");
            return 0;
        }
        return currentTime - preQueueTime;
    };
    /**
     * Adds queue measurement time to QueueMeasurements array for given correlation ID.
     *
     * @param {PerformanceEvents} eventName
     * @param {?string} correlationId
     * @param {?number} queueTime
     * @param {?boolean} manuallyCompleted - indicator for manually completed queue measurements
     * @returns
     */
    PerformanceClient.prototype.addQueueMeasurement = function (eventName, correlationId, queueTime, manuallyCompleted) {
        if (!correlationId) {
            this.logger.trace("PerformanceClient.addQueueMeasurement: correlationId not provided for " + eventName + ", cannot add queue measurement");
            return;
        }
        if (queueTime === 0) {
            // Possible for there to be no queue time after calculation
            this.logger.trace("PerformanceClient.addQueueMeasurement: queue time provided for " + eventName + " is " + queueTime);
        }
        else if (!queueTime) {
            this.logger.trace("PerformanceClient.addQueueMeasurement: no queue time provided for " + eventName);
            return;
        }
        var queueMeasurement = { eventName: eventName, queueTime: queueTime, manuallyCompleted: manuallyCompleted };
        // Adds to existing correlation Id if present in queueMeasurements
        var existingMeasurements = this.queueMeasurements.get(correlationId);
        if (existingMeasurements) {
            existingMeasurements.push(queueMeasurement);
            this.queueMeasurements.set(correlationId, existingMeasurements);
        }
        else {
            // Sets new correlation Id if not present in queueMeasurements
            this.logger.trace("PerformanceClient.addQueueMeasurement: adding correlationId " + correlationId + " to queue measurements");
            var measurementArray = [queueMeasurement];
            this.queueMeasurements.set(correlationId, measurementArray);
        }
        // Delete processed pre-queue event.
        this.preQueueTimeByCorrelationId.delete(correlationId);
    };
    /**
     * Starts measuring performance for a given operation. Returns a function that should be used to end the measurement.
     *
     * @param {PerformanceEvents} measureName
     * @param {?string} [correlationId]
     * @returns {InProgressPerformanceEvent}
     */
    PerformanceClient.prototype.startMeasurement = function (measureName, correlationId) {
        var _this = this;
        var _a, _b;
        // Generate a placeholder correlation if the request does not provide one
        var eventCorrelationId = correlationId || this.generateId();
        if (!correlationId) {
            this.logger.info("PerformanceClient: No correlation id provided for " + measureName + ", generating", eventCorrelationId);
        }
        // Duplicate code to address spelling error will be removed at the next major version bump.
        this.logger.trace("PerformanceClient: Performance measurement started for " + measureName, eventCorrelationId);
        var performanceMeasurement = this.startPerformanceMeasuremeant(measureName, eventCorrelationId);
        performanceMeasurement.startMeasurement();
        var inProgressEvent = {
            eventId: this.generateId(),
            status: PerformanceEventStatus.InProgress,
            authority: this.authority,
            libraryName: this.libraryName,
            libraryVersion: this.libraryVersion,
            clientId: this.clientId,
            name: measureName,
            startTimeMs: Date.now(),
            correlationId: eventCorrelationId,
            appName: (_a = this.applicationTelemetry) === null || _a === void 0 ? void 0 : _a.appName,
            appVersion: (_b = this.applicationTelemetry) === null || _b === void 0 ? void 0 : _b.appVersion,
        };
        // Store in progress events so they can be discarded if not ended properly
        this.cacheEventByCorrelationId(inProgressEvent);
        // Return the event and functions the caller can use to properly end/flush the measurement
        return {
            endMeasurement: function (event) {
                return _this.endMeasurement(__assign$4(__assign$4({}, inProgressEvent), event), performanceMeasurement);
            },
            discardMeasurement: function () {
                return _this.discardMeasurements(inProgressEvent.correlationId);
            },
            addStaticFields: function (fields) {
                return _this.addStaticFields(fields, inProgressEvent.correlationId);
            },
            increment: function (counters) {
                return _this.increment(counters, inProgressEvent.correlationId);
            },
            measurement: performanceMeasurement,
            event: inProgressEvent
        };
    };
    /**
     * Stops measuring the performance for an operation. Should only be called directly by PerformanceClient classes,
     * as consumers should instead use the function returned by startMeasurement.
     * Adds a new field named as "[event name]DurationMs" for sub-measurements, completes and emits an event
     * otherwise.
     *
     * @param {PerformanceEvent} event
     * @param {IPerformanceMeasurement} measurement
     * @returns {(PerformanceEvent | null)}
     */
    PerformanceClient.prototype.endMeasurement = function (event, measurement) {
        var _this = this;
        var _a, _b;
        var rootEvent = this.eventsByCorrelationId.get(event.correlationId);
        if (!rootEvent) {
            this.logger.trace("PerformanceClient: Measurement not found for " + event.eventId, event.correlationId);
            return null;
        }
        var isRoot = event.eventId === rootEvent.eventId;
        var queueInfo = {
            totalQueueTime: 0,
            totalQueueCount: 0,
            manuallyCompletedCount: 0
        };
        if (isRoot) {
            queueInfo = this.getQueueInfo(event.correlationId);
            this.discardCache(rootEvent.correlationId);
        }
        else {
            (_a = rootEvent.incompleteSubMeasurements) === null || _a === void 0 ? void 0 : _a.delete(event.eventId);
        }
        measurement === null || measurement === void 0 ? void 0 : measurement.endMeasurement();
        var durationMs = measurement === null || measurement === void 0 ? void 0 : measurement.flushMeasurement();
        // null indicates no measurement was taken (e.g. needed performance APIs not present)
        if (!durationMs) {
            this.logger.trace("PerformanceClient: Performance measurement not taken", rootEvent.correlationId);
            return null;
        }
        this.logger.trace("PerformanceClient: Performance measurement ended for " + event.name + ": " + durationMs + " ms", event.correlationId);
        // Add sub-measurement attribute to root event.
        if (!isRoot) {
            rootEvent[event.name + "DurationMs"] = Math.floor(durationMs);
            return __assign$4({}, rootEvent);
        }
        var finalEvent = __assign$4(__assign$4({}, rootEvent), event);
        var incompleteSubsCount = 0;
        // Incomplete sub-measurements are discarded. They are likely an instrumentation bug that should be fixed.
        (_b = finalEvent.incompleteSubMeasurements) === null || _b === void 0 ? void 0 : _b.forEach(function (subMeasurement) {
            _this.logger.trace("PerformanceClient: Incomplete submeasurement " + subMeasurement.name + " found for " + event.name, finalEvent.correlationId);
            incompleteSubsCount++;
        });
        finalEvent.incompleteSubMeasurements = undefined;
        finalEvent = __assign$4(__assign$4({}, finalEvent), { durationMs: Math.round(durationMs), queuedTimeMs: queueInfo.totalQueueTime, queuedCount: queueInfo.totalQueueCount, queuedManuallyCompletedCount: queueInfo.manuallyCompletedCount, status: PerformanceEventStatus.Completed, incompleteSubsCount: incompleteSubsCount });
        this.truncateIntegralFields(finalEvent, this.getIntFields());
        this.emitEvents([finalEvent], event.correlationId);
        return finalEvent;
    };
    /**
     * Saves extra information to be emitted when the measurements are flushed
     * @param fields
     * @param correlationId
     */
    PerformanceClient.prototype.addStaticFields = function (fields, correlationId) {
        this.logger.trace("PerformanceClient: Updating static fields");
        var event = this.eventsByCorrelationId.get(correlationId);
        if (event) {
            this.eventsByCorrelationId.set(correlationId, __assign$4(__assign$4({}, event), fields));
        }
        else {
            this.logger.trace("PerformanceClient: Event not found for", correlationId);
        }
    };
    /**
     * Increment counters to be emitted when the measurements are flushed
     * @param counters {Counters}
     * @param correlationId {string} correlation identifier
     */
    PerformanceClient.prototype.increment = function (counters, correlationId) {
        this.logger.trace("PerformanceClient: Updating counters");
        var event = this.eventsByCorrelationId.get(correlationId);
        if (event) {
            for (var counter in counters) {
                if (!event.hasOwnProperty(counter)) {
                    event[counter] = 0;
                }
                event[counter] += counters[counter];
            }
        }
        else {
            this.logger.trace("PerformanceClient: Event not found for", correlationId);
        }
    };
    /**
     * Upserts event into event cache.
     * First key is the correlation id, second key is the event id.
     * Allows for events to be grouped by correlation id,
     * and to easily allow for properties on them to be updated.
     *
     * @private
     * @param {PerformanceEvent} event
     */
    PerformanceClient.prototype.cacheEventByCorrelationId = function (event) {
        var rootEvent = this.eventsByCorrelationId.get(event.correlationId);
        if (rootEvent) {
            this.logger.trace("PerformanceClient: Performance measurement for " + event.name + " added/updated", event.correlationId);
            rootEvent.incompleteSubMeasurements = rootEvent.incompleteSubMeasurements || new Map();
            rootEvent.incompleteSubMeasurements.set(event.eventId, { name: event.name, startTimeMs: event.startTimeMs });
        }
        else {
            this.logger.trace("PerformanceClient: Performance measurement for " + event.name + " started", event.correlationId);
            this.eventsByCorrelationId.set(event.correlationId, __assign$4({}, event));
        }
    };
    PerformanceClient.prototype.getQueueInfo = function (correlationId) {
        var queueMeasurementForCorrelationId = this.queueMeasurements.get(correlationId);
        if (!queueMeasurementForCorrelationId) {
            this.logger.trace("PerformanceClient: no queue measurements found for for correlationId: " + correlationId);
        }
        var totalQueueTime = 0;
        var totalQueueCount = 0;
        var manuallyCompletedCount = 0;
        queueMeasurementForCorrelationId === null || queueMeasurementForCorrelationId === void 0 ? void 0 : queueMeasurementForCorrelationId.forEach(function (measurement) {
            totalQueueTime += measurement.queueTime;
            totalQueueCount++;
            manuallyCompletedCount += measurement.manuallyCompleted ? 1 : 0;
        });
        return {
            totalQueueTime: totalQueueTime,
            totalQueueCount: totalQueueCount,
            manuallyCompletedCount: manuallyCompletedCount
        };
    };
    /**
     * Removes measurements for a given correlation id.
     *
     * @param {string} correlationId
     */
    PerformanceClient.prototype.discardMeasurements = function (correlationId) {
        this.logger.trace("PerformanceClient: Performance measurements discarded", correlationId);
        this.eventsByCorrelationId.delete(correlationId);
    };
    /**
     * Removes cache for a given correlation id.
     *
     * @param {string} correlationId correlation identifier
     */
    PerformanceClient.prototype.discardCache = function (correlationId) {
        this.discardMeasurements(correlationId);
        this.logger.trace("PerformanceClient: QueueMeasurements discarded", correlationId);
        this.queueMeasurements.delete(correlationId);
        this.logger.trace("PerformanceClient: Pre-queue times discarded", correlationId);
        this.preQueueTimeByCorrelationId.delete(correlationId);
    };
    /**
     * Registers a callback function to receive performance events.
     *
     * @param {PerformanceCallbackFunction} callback
     * @returns {string}
     */
    PerformanceClient.prototype.addPerformanceCallback = function (callback) {
        var callbackId = this.generateId();
        this.callbacks.set(callbackId, callback);
        this.logger.verbose("PerformanceClient: Performance callback registered with id: " + callbackId);
        return callbackId;
    };
    /**
     * Removes a callback registered with addPerformanceCallback.
     *
     * @param {string} callbackId
     * @returns {boolean}
     */
    PerformanceClient.prototype.removePerformanceCallback = function (callbackId) {
        var result = this.callbacks.delete(callbackId);
        if (result) {
            this.logger.verbose("PerformanceClient: Performance callback " + callbackId + " removed.");
        }
        else {
            this.logger.verbose("PerformanceClient: Performance callback " + callbackId + " not removed.");
        }
        return result;
    };
    /**
     * Emits events to all registered callbacks.
     *
     * @param {PerformanceEvent[]} events
     * @param {?string} [correlationId]
     */
    PerformanceClient.prototype.emitEvents = function (events, correlationId) {
        var _this = this;
        this.logger.verbose("PerformanceClient: Emitting performance events", correlationId);
        this.callbacks.forEach(function (callback, callbackId) {
            _this.logger.trace("PerformanceClient: Emitting event to callback " + callbackId, correlationId);
            callback.apply(null, [events]);
        });
    };
    /**
     * Enforce truncation of integral fields in performance event.
     * @param {PerformanceEvent} event performance event to update.
     * @param {Set<string>} intFields integral fields.
     */
    PerformanceClient.prototype.truncateIntegralFields = function (event, intFields) {
        intFields.forEach(function (key) {
            if (key in event && typeof event[key] === "number") {
                event[key] = Math.floor(event[key]);
            }
        });
    };
    return PerformanceClient;
}());

/*! @azure/msal-common v13.3.1 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var StubPerformanceMeasurement = /** @class */ (function () {
    function StubPerformanceMeasurement() {
    }
    /* eslint-disable-next-line @typescript-eslint/no-empty-function */
    StubPerformanceMeasurement.prototype.startMeasurement = function () { };
    /* eslint-disable-next-line @typescript-eslint/no-empty-function */
    StubPerformanceMeasurement.prototype.endMeasurement = function () { };
    StubPerformanceMeasurement.prototype.flushMeasurement = function () {
        return null;
    };
    return StubPerformanceMeasurement;
}());
var StubPerformanceClient = /** @class */ (function (_super) {
    __extends$f(StubPerformanceClient, _super);
    function StubPerformanceClient() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StubPerformanceClient.prototype.generateId = function () {
        return "callback-id";
    };
    StubPerformanceClient.prototype.startPerformanceMeasuremeant = function () {
        return new StubPerformanceMeasurement();
    };
    StubPerformanceClient.prototype.startPerformanceMeasurement = function () {
        return new StubPerformanceMeasurement();
    };
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    StubPerformanceClient.prototype.calculateQueuedTime = function (preQueueTime, currentTime) {
        return 0;
    };
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    StubPerformanceClient.prototype.addQueueMeasurement = function (eventName, correlationId, queueTime) {
        return;
    };
    /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
    StubPerformanceClient.prototype.setPreQueueTime = function (eventName, correlationId) {
        return;
    };
    return StubPerformanceClient;
}(PerformanceClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * BrowserAuthErrorMessage class containing string constants used by error codes and messages.
 */
var BrowserAuthErrorMessage = {
    pkceNotGenerated: {
        code: "pkce_not_created",
        desc: "The PKCE code challenge and verifier could not be generated."
    },
    cryptoDoesNotExist: {
        code: "crypto_nonexistent",
        desc: "The crypto object or function is not available."
    },
    httpMethodNotImplementedError: {
        code: "http_method_not_implemented",
        desc: "The HTTP method given has not been implemented in this library."
    },
    emptyNavigateUriError: {
        code: "empty_navigate_uri",
        desc: "Navigation URI is empty. Please check stack trace for more info."
    },
    hashEmptyError: {
        code: "hash_empty_error",
        desc: "Hash value cannot be processed because it is empty. Please verify that your redirectUri is not clearing the hash. For more visit: aka.ms/msaljs/browser-errors."
    },
    hashDoesNotContainStateError: {
        code: "no_state_in_hash",
        desc: "Hash does not contain state. Please verify that the request originated from msal."
    },
    hashDoesNotContainKnownPropertiesError: {
        code: "hash_does_not_contain_known_properties",
        desc: "Hash does not contain known properites. Please verify that your redirectUri is not changing the hash. For more visit: aka.ms/msaljs/browser-errors."
    },
    unableToParseStateError: {
        code: "unable_to_parse_state",
        desc: "Unable to parse state. Please verify that the request originated from msal."
    },
    stateInteractionTypeMismatchError: {
        code: "state_interaction_type_mismatch",
        desc: "Hash contains state but the interaction type does not match the caller."
    },
    interactionInProgress: {
        code: "interaction_in_progress",
        desc: "Interaction is currently in progress. Please ensure that this interaction has been completed before calling an interactive API.  For more visit: aka.ms/msaljs/browser-errors."
    },
    popupWindowError: {
        code: "popup_window_error",
        desc: "Error opening popup window. This can happen if you are using IE or if popups are blocked in the browser."
    },
    emptyWindowError: {
        code: "empty_window_error",
        desc: "window.open returned null or undefined window object."
    },
    userCancelledError: {
        code: "user_cancelled",
        desc: "User cancelled the flow."
    },
    monitorPopupTimeoutError: {
        code: "monitor_window_timeout",
        desc: "Token acquisition in popup failed due to timeout. For more visit: aka.ms/msaljs/browser-errors."
    },
    monitorIframeTimeoutError: {
        code: "monitor_window_timeout",
        desc: "Token acquisition in iframe failed due to timeout. For more visit: aka.ms/msaljs/browser-errors."
    },
    redirectInIframeError: {
        code: "redirect_in_iframe",
        desc: "Redirects are not supported for iframed or brokered applications. Please ensure you are using MSAL.js in a top frame of the window if using the redirect APIs, or use the popup APIs."
    },
    blockTokenRequestsInHiddenIframeError: {
        code: "block_iframe_reload",
        desc: "Request was blocked inside an iframe because MSAL detected an authentication response. For more visit: aka.ms/msaljs/browser-errors"
    },
    blockAcquireTokenInPopupsError: {
        code: "block_nested_popups",
        desc: "Request was blocked inside a popup because MSAL detected it was running in a popup."
    },
    iframeClosedPrematurelyError: {
        code: "iframe_closed_prematurely",
        desc: "The iframe being monitored was closed prematurely."
    },
    silentLogoutUnsupportedError: {
        code: "silent_logout_unsupported",
        desc: "Silent logout not supported. Please call logoutRedirect or logoutPopup instead."
    },
    noAccountError: {
        code: "no_account_error",
        desc: "No account object provided to acquireTokenSilent and no active account has been set. Please call setActiveAccount or provide an account on the request."
    },
    silentPromptValueError: {
        code: "silent_prompt_value_error",
        desc: "The value given for the prompt value is not valid for silent requests - must be set to 'none' or 'no_session'."
    },
    noTokenRequestCacheError: {
        code: "no_token_request_cache_error",
        desc: "No token request found in cache."
    },
    unableToParseTokenRequestCacheError: {
        code: "unable_to_parse_token_request_cache_error",
        desc: "The cached token request could not be parsed."
    },
    noCachedAuthorityError: {
        code: "no_cached_authority_error",
        desc: "No cached authority found."
    },
    authRequestNotSet: {
        code: "auth_request_not_set_error",
        desc: "Auth Request not set. Please ensure initiateAuthRequest was called from the InteractionHandler"
    },
    invalidCacheType: {
        code: "invalid_cache_type",
        desc: "Invalid cache type"
    },
    notInBrowserEnvironment: {
        code: "non_browser_environment",
        desc: "Login and token requests are not supported in non-browser environments."
    },
    databaseNotOpen: {
        code: "database_not_open",
        desc: "Database is not open!"
    },
    noNetworkConnectivity: {
        code: "no_network_connectivity",
        desc: "No network connectivity. Check your internet connection."
    },
    postRequestFailed: {
        code: "post_request_failed",
        desc: "Network request failed: If the browser threw a CORS error, check that the redirectUri is registered in the Azure App Portal as type 'SPA'"
    },
    getRequestFailed: {
        code: "get_request_failed",
        desc: "Network request failed. Please check the network trace to determine root cause."
    },
    failedToParseNetworkResponse: {
        code: "failed_to_parse_response",
        desc: "Failed to parse network response. Check network trace."
    },
    unableToLoadTokenError: {
        code: "unable_to_load_token",
        desc: "Error loading token to cache."
    },
    signingKeyNotFoundInStorage: {
        code: "crypto_key_not_found",
        desc: "Cryptographic Key or Keypair not found in browser storage."
    },
    authCodeRequired: {
        code: "auth_code_required",
        desc: "An authorization code must be provided (as the `code` property on the request) to this flow."
    },
    authCodeOrNativeAccountRequired: {
        code: "auth_code_or_nativeAccountId_required",
        desc: "An authorization code or nativeAccountId must be provided to this flow."
    },
    spaCodeAndNativeAccountPresent: {
        code: "spa_code_and_nativeAccountId_present",
        desc: "Request cannot contain both spa code and native account id."
    },
    databaseUnavailable: {
        code: "database_unavailable",
        desc: "IndexedDB, which is required for persistent cryptographic key storage, is unavailable. This may be caused by browser privacy features which block persistent storage in third-party contexts."
    },
    unableToAcquireTokenFromNativePlatform: {
        code: "unable_to_acquire_token_from_native_platform",
        desc: "Unable to acquire token from native platform. For a list of possible reasons visit aka.ms/msaljs/browser-errors."
    },
    nativeHandshakeTimeout: {
        code: "native_handshake_timeout",
        desc: "Timed out while attempting to establish connection to browser extension"
    },
    nativeExtensionNotInstalled: {
        code: "native_extension_not_installed",
        desc: "Native extension is not installed. If you think this is a mistake call the initialize function."
    },
    nativeConnectionNotEstablished: {
        code: "native_connection_not_established",
        desc: "Connection to native platform has not been established. Please install a compatible browser extension and run initialize(). For more please visit aka.ms/msaljs/browser-errors."
    },
    nativeBrokerCalledBeforeInitialize: {
        code: "native_broker_called_before_initialize",
        desc: "You must call and await the initialize function before attempting to call any other MSAL API when native brokering is enabled. For more please visit aka.ms/msaljs/browser-errors."
    },
    nativePromptNotSupported: {
        code: "native_prompt_not_supported",
        desc: "The provided prompt is not supported by the native platform. This request should be routed to the web based flow."
    }
};
/**
 * Browser library error class thrown by the MSAL.js library for SPAs
 */
var BrowserAuthError = /** @class */ (function (_super) {
    __extends$g(BrowserAuthError, _super);
    function BrowserAuthError(errorCode, errorMessage) {
        var _this = _super.call(this, errorCode, errorMessage) || this;
        Object.setPrototypeOf(_this, BrowserAuthError.prototype);
        _this.name = "BrowserAuthError";
        return _this;
    }
    /**
     * Creates an error thrown when PKCE is not implemented.
     * @param errDetail
     */
    BrowserAuthError.createPkceNotGeneratedError = function (errDetail) {
        return new BrowserAuthError(BrowserAuthErrorMessage.pkceNotGenerated.code, BrowserAuthErrorMessage.pkceNotGenerated.desc + " Detail:" + errDetail);
    };
    /**
     * Creates an error thrown when the crypto object is unavailable.
     * @param errDetail
     */
    BrowserAuthError.createCryptoNotAvailableError = function (errDetail) {
        return new BrowserAuthError(BrowserAuthErrorMessage.cryptoDoesNotExist.code, BrowserAuthErrorMessage.cryptoDoesNotExist.desc + " Detail:" + errDetail);
    };
    /**
     * Creates an error thrown when an HTTP method hasn't been implemented by the browser class.
     * @param method
     */
    BrowserAuthError.createHttpMethodNotImplementedError = function (method) {
        return new BrowserAuthError(BrowserAuthErrorMessage.httpMethodNotImplementedError.code, BrowserAuthErrorMessage.httpMethodNotImplementedError.desc + " Given Method: " + method);
    };
    /**
     * Creates an error thrown when the navigation URI is empty.
     */
    BrowserAuthError.createEmptyNavigationUriError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.emptyNavigateUriError.code, BrowserAuthErrorMessage.emptyNavigateUriError.desc);
    };
    /**
     * Creates an error thrown when the hash string value is unexpectedly empty.
     * @param hashValue
     */
    BrowserAuthError.createEmptyHashError = function (hashValue) {
        return new BrowserAuthError(BrowserAuthErrorMessage.hashEmptyError.code, BrowserAuthErrorMessage.hashEmptyError.desc + " Given Url: " + hashValue);
    };
    /**
     * Creates an error thrown when the hash string value is unexpectedly empty.
     */
    BrowserAuthError.createHashDoesNotContainStateError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.hashDoesNotContainStateError.code, BrowserAuthErrorMessage.hashDoesNotContainStateError.desc);
    };
    /**
     * Creates an error thrown when the hash string value does not contain known properties
     */
    BrowserAuthError.createHashDoesNotContainKnownPropertiesError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.hashDoesNotContainKnownPropertiesError.code, BrowserAuthErrorMessage.hashDoesNotContainKnownPropertiesError.desc);
    };
    /**
     * Creates an error thrown when the hash string value is unexpectedly empty.
     */
    BrowserAuthError.createUnableToParseStateError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.unableToParseStateError.code, BrowserAuthErrorMessage.unableToParseStateError.desc);
    };
    /**
     * Creates an error thrown when the state value in the hash does not match the interaction type of the API attempting to consume it.
     */
    BrowserAuthError.createStateInteractionTypeMismatchError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.stateInteractionTypeMismatchError.code, BrowserAuthErrorMessage.stateInteractionTypeMismatchError.desc);
    };
    /**
     * Creates an error thrown when a browser interaction (redirect or popup) is in progress.
     */
    BrowserAuthError.createInteractionInProgressError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.interactionInProgress.code, BrowserAuthErrorMessage.interactionInProgress.desc);
    };
    /**
     * Creates an error thrown when the popup window could not be opened.
     * @param errDetail
     */
    BrowserAuthError.createPopupWindowError = function (errDetail) {
        var errorMessage = BrowserAuthErrorMessage.popupWindowError.desc;
        errorMessage = !StringUtils.isEmpty(errDetail) ? errorMessage + " Details: " + errDetail : errorMessage;
        return new BrowserAuthError(BrowserAuthErrorMessage.popupWindowError.code, errorMessage);
    };
    /**
     * Creates an error thrown when window.open returns an empty window object.
     * @param errDetail
     */
    BrowserAuthError.createEmptyWindowCreatedError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.emptyWindowError.code, BrowserAuthErrorMessage.emptyWindowError.desc);
    };
    /**
     * Creates an error thrown when the user closes a popup.
     */
    BrowserAuthError.createUserCancelledError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.userCancelledError.code, BrowserAuthErrorMessage.userCancelledError.desc);
    };
    /**
     * Creates an error thrown when monitorPopupFromHash times out for a given popup.
     */
    BrowserAuthError.createMonitorPopupTimeoutError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.monitorPopupTimeoutError.code, BrowserAuthErrorMessage.monitorPopupTimeoutError.desc);
    };
    /**
     * Creates an error thrown when monitorIframeFromHash times out for a given iframe.
     */
    BrowserAuthError.createMonitorIframeTimeoutError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.monitorIframeTimeoutError.code, BrowserAuthErrorMessage.monitorIframeTimeoutError.desc);
    };
    /**
     * Creates an error thrown when navigateWindow is called inside an iframe or brokered applications.
     * @param windowParentCheck
     */
    BrowserAuthError.createRedirectInIframeError = function (windowParentCheck) {
        return new BrowserAuthError(BrowserAuthErrorMessage.redirectInIframeError.code, BrowserAuthErrorMessage.redirectInIframeError.desc + " (window.parent !== window) => " + windowParentCheck);
    };
    /**
     * Creates an error thrown when an auth reload is done inside an iframe.
     */
    BrowserAuthError.createBlockReloadInHiddenIframeError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.blockTokenRequestsInHiddenIframeError.code, BrowserAuthErrorMessage.blockTokenRequestsInHiddenIframeError.desc);
    };
    /**
     * Creates an error thrown when a popup attempts to call an acquireToken API
     * @returns
     */
    BrowserAuthError.createBlockAcquireTokenInPopupsError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.blockAcquireTokenInPopupsError.code, BrowserAuthErrorMessage.blockAcquireTokenInPopupsError.desc);
    };
    /**
     * Creates an error thrown when an iframe is found to be closed before the timeout is reached.
     */
    BrowserAuthError.createIframeClosedPrematurelyError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.iframeClosedPrematurelyError.code, BrowserAuthErrorMessage.iframeClosedPrematurelyError.desc);
    };
    /**
     * Creates an error thrown when the logout API is called on any of the silent interaction clients
     */
    BrowserAuthError.createSilentLogoutUnsupportedError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.silentLogoutUnsupportedError.code, BrowserAuthErrorMessage.silentLogoutUnsupportedError.desc);
    };
    /**
     * Creates an error thrown when the account object is not provided in the acquireTokenSilent API.
     */
    BrowserAuthError.createNoAccountError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.noAccountError.code, BrowserAuthErrorMessage.noAccountError.desc);
    };
    /**
     * Creates an error thrown when a given prompt value is invalid for silent requests.
     */
    BrowserAuthError.createSilentPromptValueError = function (givenPrompt) {
        return new BrowserAuthError(BrowserAuthErrorMessage.silentPromptValueError.code, BrowserAuthErrorMessage.silentPromptValueError.desc + " Given value: " + givenPrompt);
    };
    /**
     * Creates an error thrown when the cached token request could not be retrieved from the cache
     */
    BrowserAuthError.createUnableToParseTokenRequestCacheError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.unableToParseTokenRequestCacheError.code, BrowserAuthErrorMessage.unableToParseTokenRequestCacheError.desc);
    };
    /**
     * Creates an error thrown when the token request could not be retrieved from the cache
     */
    BrowserAuthError.createNoTokenRequestCacheError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.noTokenRequestCacheError.code, BrowserAuthErrorMessage.noTokenRequestCacheError.desc);
    };
    /**
     * Creates an error thrown when handleCodeResponse is called before initiateAuthRequest (InteractionHandler)
     */
    BrowserAuthError.createAuthRequestNotSetError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.authRequestNotSet.code, BrowserAuthErrorMessage.authRequestNotSet.desc);
    };
    /**
     * Creates an error thrown when the authority could not be retrieved from the cache
     */
    BrowserAuthError.createNoCachedAuthorityError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.noCachedAuthorityError.code, BrowserAuthErrorMessage.noCachedAuthorityError.desc);
    };
    /**
     * Creates an error thrown if cache type is invalid.
     */
    BrowserAuthError.createInvalidCacheTypeError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.invalidCacheType.code, "" + BrowserAuthErrorMessage.invalidCacheType.desc);
    };
    /**
     * Create an error thrown when login and token requests are made from a non-browser environment
     */
    BrowserAuthError.createNonBrowserEnvironmentError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.notInBrowserEnvironment.code, BrowserAuthErrorMessage.notInBrowserEnvironment.desc);
    };
    /**
     * Create an error thrown when indexDB database is not open
     */
    BrowserAuthError.createDatabaseNotOpenError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.databaseNotOpen.code, BrowserAuthErrorMessage.databaseNotOpen.desc);
    };
    /**
     * Create an error thrown when token fetch fails due to no internet
     */
    BrowserAuthError.createNoNetworkConnectivityError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.noNetworkConnectivity.code, BrowserAuthErrorMessage.noNetworkConnectivity.desc);
    };
    /**
     * Create an error thrown when token fetch fails due to reasons other than internet connectivity
     */
    BrowserAuthError.createPostRequestFailedError = function (errorDesc, endpoint) {
        return new BrowserAuthError(BrowserAuthErrorMessage.postRequestFailed.code, BrowserAuthErrorMessage.postRequestFailed.desc + " | Network client threw: " + errorDesc + " | Attempted to reach: " + endpoint.split("?")[0]);
    };
    /**
     * Create an error thrown when get request fails due to reasons other than internet connectivity
     */
    BrowserAuthError.createGetRequestFailedError = function (errorDesc, endpoint) {
        return new BrowserAuthError(BrowserAuthErrorMessage.getRequestFailed.code, BrowserAuthErrorMessage.getRequestFailed.desc + " | Network client threw: " + errorDesc + " | Attempted to reach: " + endpoint.split("?")[0]);
    };
    /**
     * Create an error thrown when network client fails to parse network response
     */
    BrowserAuthError.createFailedToParseNetworkResponseError = function (endpoint) {
        return new BrowserAuthError(BrowserAuthErrorMessage.failedToParseNetworkResponse.code, BrowserAuthErrorMessage.failedToParseNetworkResponse.desc + " | Attempted to reach: " + endpoint.split("?")[0]);
    };
    /**
     * Create an error thrown when the necessary information is not available to sideload tokens
     */
    BrowserAuthError.createUnableToLoadTokenError = function (errorDetail) {
        return new BrowserAuthError(BrowserAuthErrorMessage.unableToLoadTokenError.code, BrowserAuthErrorMessage.unableToLoadTokenError.desc + " | " + errorDetail);
    };
    /**
     * Create an error thrown when the queried cryptographic key is not found in IndexedDB
     */
    BrowserAuthError.createSigningKeyNotFoundInStorageError = function (keyId) {
        return new BrowserAuthError(BrowserAuthErrorMessage.signingKeyNotFoundInStorage.code, BrowserAuthErrorMessage.signingKeyNotFoundInStorage.desc + " | No match found for KeyId: " + keyId);
    };
    /**
     * Create an error when an authorization code is required but not provided
     */
    BrowserAuthError.createAuthCodeRequiredError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.authCodeRequired.code, BrowserAuthErrorMessage.authCodeRequired.desc);
    };
    /**
     * Create an error when an authorization code or native account ID is required but not provided
     */
    BrowserAuthError.createAuthCodeOrNativeAccountIdRequiredError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.authCodeOrNativeAccountRequired.code, BrowserAuthErrorMessage.authCodeOrNativeAccountRequired.desc);
    };
    /**
     * Create an error when both authorization code and native account ID are provided
     */
    BrowserAuthError.createSpaCodeAndNativeAccountIdPresentError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.spaCodeAndNativeAccountPresent.code, BrowserAuthErrorMessage.spaCodeAndNativeAccountPresent.desc);
    };
    /**
     * Create an error when IndexedDB is unavailable
     */
    BrowserAuthError.createDatabaseUnavailableError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.databaseUnavailable.code, BrowserAuthErrorMessage.databaseUnavailable.desc);
    };
    /**
     * Create an error when native token acquisition is not possible
     */
    BrowserAuthError.createUnableToAcquireTokenFromNativePlatformError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.unableToAcquireTokenFromNativePlatform.code, BrowserAuthErrorMessage.unableToAcquireTokenFromNativePlatform.desc);
    };
    /**
     * Create an error thrown when Handshake with browser extension times out
     */
    BrowserAuthError.createNativeHandshakeTimeoutError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.nativeHandshakeTimeout.code, BrowserAuthErrorMessage.nativeHandshakeTimeout.desc);
    };
    /**
     * Create an error thrown when browser extension is not installed
     */
    BrowserAuthError.createNativeExtensionNotInstalledError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.nativeExtensionNotInstalled.code, BrowserAuthErrorMessage.nativeExtensionNotInstalled.desc);
    };
    /**
     * Create an error when native connection has not been established
     * @returns
     */
    BrowserAuthError.createNativeConnectionNotEstablishedError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.nativeConnectionNotEstablished.code, BrowserAuthErrorMessage.nativeConnectionNotEstablished.desc);
    };
    /**
     * Create an error thrown when the initialize function hasn't been called
     */
    BrowserAuthError.createNativeBrokerCalledBeforeInitialize = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.nativeBrokerCalledBeforeInitialize.code, BrowserAuthErrorMessage.nativeBrokerCalledBeforeInitialize.desc);
    };
    /**
     * Create an error thrown when requesting a token directly from the native platform with an unsupported prompt parameter e.g. select_account, login or create
     * These requests must go through eSTS to ensure eSTS is aware of the new account
     */
    BrowserAuthError.createNativePromptParameterNotSupportedError = function () {
        return new BrowserAuthError(BrowserAuthErrorMessage.nativePromptNotSupported.code, BrowserAuthErrorMessage.nativePromptNotSupported.desc);
    };
    return BrowserAuthError;
}(AuthError));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Constants
 */
var BrowserConstants = {
    /**
     * Interaction in progress cache value
     */
    INTERACTION_IN_PROGRESS_VALUE: "interaction_in_progress",
    /**
     * Invalid grant error code
     */
    INVALID_GRANT_ERROR: "invalid_grant",
    /**
     * Default popup window width
     */
    POPUP_WIDTH: 483,
    /**
     * Default popup window height
     */
    POPUP_HEIGHT: 600,
    /**
     * Name of the popup window starts with
     */
    POPUP_NAME_PREFIX: "msal",
    /**
     * Default popup monitor poll interval in milliseconds
     */
    DEFAULT_POLL_INTERVAL_MS: 30,
    /**
     * Msal-browser SKU
     */
    MSAL_SKU: "msal.js.browser",
};
var NativeConstants = {
    CHANNEL_ID: "53ee284d-920a-4b59-9d30-a60315b26836",
    PREFERRED_EXTENSION_ID: "ppnbnpeolgkicgegkbkbjmhlideopiji",
    MATS_TELEMETRY: "MATS"
};
var NativeExtensionMethod;
(function (NativeExtensionMethod) {
    NativeExtensionMethod["HandshakeRequest"] = "Handshake";
    NativeExtensionMethod["HandshakeResponse"] = "HandshakeResponse";
    NativeExtensionMethod["GetToken"] = "GetToken";
    NativeExtensionMethod["Response"] = "Response";
})(NativeExtensionMethod || (NativeExtensionMethod = {}));
var BrowserCacheLocation;
(function (BrowserCacheLocation) {
    BrowserCacheLocation["LocalStorage"] = "localStorage";
    BrowserCacheLocation["SessionStorage"] = "sessionStorage";
    BrowserCacheLocation["MemoryStorage"] = "memoryStorage";
})(BrowserCacheLocation || (BrowserCacheLocation = {}));
/**
 * HTTP Request types supported by MSAL.
 */
var HTTP_REQUEST_TYPE;
(function (HTTP_REQUEST_TYPE) {
    HTTP_REQUEST_TYPE["GET"] = "GET";
    HTTP_REQUEST_TYPE["POST"] = "POST";
})(HTTP_REQUEST_TYPE || (HTTP_REQUEST_TYPE = {}));
/**
 * Temporary cache keys for MSAL, deleted after any request.
 */
var TemporaryCacheKeys;
(function (TemporaryCacheKeys) {
    TemporaryCacheKeys["AUTHORITY"] = "authority";
    TemporaryCacheKeys["ACQUIRE_TOKEN_ACCOUNT"] = "acquireToken.account";
    TemporaryCacheKeys["SESSION_STATE"] = "session.state";
    TemporaryCacheKeys["REQUEST_STATE"] = "request.state";
    TemporaryCacheKeys["NONCE_IDTOKEN"] = "nonce.id_token";
    TemporaryCacheKeys["ORIGIN_URI"] = "request.origin";
    TemporaryCacheKeys["RENEW_STATUS"] = "token.renew.status";
    TemporaryCacheKeys["URL_HASH"] = "urlHash";
    TemporaryCacheKeys["REQUEST_PARAMS"] = "request.params";
    TemporaryCacheKeys["SCOPES"] = "scopes";
    TemporaryCacheKeys["INTERACTION_STATUS_KEY"] = "interaction.status";
    TemporaryCacheKeys["CCS_CREDENTIAL"] = "ccs.credential";
    TemporaryCacheKeys["CORRELATION_ID"] = "request.correlationId";
    TemporaryCacheKeys["NATIVE_REQUEST"] = "request.native";
    TemporaryCacheKeys["REDIRECT_CONTEXT"] = "request.redirect.context";
})(TemporaryCacheKeys || (TemporaryCacheKeys = {}));
var StaticCacheKeys;
(function (StaticCacheKeys) {
    StaticCacheKeys["ACCOUNT_KEYS"] = "msal.account.keys";
    StaticCacheKeys["TOKEN_KEYS"] = "msal.token.keys";
})(StaticCacheKeys || (StaticCacheKeys = {}));
/**
 * Cache keys stored in-memory
 */
var InMemoryCacheKeys;
(function (InMemoryCacheKeys) {
    InMemoryCacheKeys["WRAPPER_SKU"] = "wrapper.sku";
    InMemoryCacheKeys["WRAPPER_VER"] = "wrapper.version";
})(InMemoryCacheKeys || (InMemoryCacheKeys = {}));
/**
 * API Codes for Telemetry purposes.
 * Before adding a new code you must claim it in the MSAL Telemetry tracker as these number spaces are shared across all MSALs
 * 0-99 Silent Flow
 * 800-899 Auth Code Flow
 */
var ApiId;
(function (ApiId) {
    ApiId[ApiId["acquireTokenRedirect"] = 861] = "acquireTokenRedirect";
    ApiId[ApiId["acquireTokenPopup"] = 862] = "acquireTokenPopup";
    ApiId[ApiId["ssoSilent"] = 863] = "ssoSilent";
    ApiId[ApiId["acquireTokenSilent_authCode"] = 864] = "acquireTokenSilent_authCode";
    ApiId[ApiId["handleRedirectPromise"] = 865] = "handleRedirectPromise";
    ApiId[ApiId["acquireTokenByCode"] = 866] = "acquireTokenByCode";
    ApiId[ApiId["acquireTokenSilent_silentFlow"] = 61] = "acquireTokenSilent_silentFlow";
    ApiId[ApiId["logout"] = 961] = "logout";
    ApiId[ApiId["logoutPopup"] = 962] = "logoutPopup";
})(ApiId || (ApiId = {}));
/*
 * Interaction type of the API - used for state and telemetry
 */
var InteractionType;
(function (InteractionType) {
    InteractionType["Redirect"] = "redirect";
    InteractionType["Popup"] = "popup";
    InteractionType["Silent"] = "silent";
    InteractionType["None"] = "none";
})(InteractionType || (InteractionType = {}));
/**
 * Types of interaction currently in progress.
 * Used in events in wrapper libraries to invoke functions when certain interaction is in progress or all interactions are complete.
 */
var InteractionStatus;
(function (InteractionStatus) {
    /**
     * Initial status before interaction occurs
     */
    InteractionStatus["Startup"] = "startup";
    /**
     * Status set when all login calls occuring
     */
    InteractionStatus["Login"] = "login";
    /**
     * Status set when logout call occuring
     */
    InteractionStatus["Logout"] = "logout";
    /**
     * Status set for acquireToken calls
     */
    InteractionStatus["AcquireToken"] = "acquireToken";
    /**
     * Status set for ssoSilent calls
     */
    InteractionStatus["SsoSilent"] = "ssoSilent";
    /**
     * Status set when handleRedirect in progress
     */
    InteractionStatus["HandleRedirect"] = "handleRedirect";
    /**
     * Status set when interaction is complete
     */
    InteractionStatus["None"] = "none";
})(InteractionStatus || (InteractionStatus = {}));
var DEFAULT_REQUEST = {
    scopes: OIDC_DEFAULT_SCOPES
};
/**
 * JWK Key Format string (Type MUST be defined for window crypto APIs)
 */
var KEY_FORMAT_JWK = "jwk";
// Supported wrapper SKUs
var WrapperSKU;
(function (WrapperSKU) {
    WrapperSKU["React"] = "@azure/msal-react";
    WrapperSKU["Angular"] = "@azure/msal-angular";
})(WrapperSKU || (WrapperSKU = {}));
// DatabaseStorage Constants
var DB_NAME = "msal.db";
var DB_VERSION = 1;
var DB_TABLE_NAME = DB_NAME + ".keys";
var CacheLookupPolicy;
(function (CacheLookupPolicy) {
    /*
     * acquireTokenSilent will attempt to retrieve an access token from the cache. If the access token is expired
     * or cannot be found the refresh token will be used to acquire a new one. Finally, if the refresh token
     * is expired acquireTokenSilent will attempt to acquire new access and refresh tokens.
     */
    CacheLookupPolicy[CacheLookupPolicy["Default"] = 0] = "Default";
    /*
     * acquireTokenSilent will only look for access tokens in the cache. It will not attempt to renew access or
     * refresh tokens.
     */
    CacheLookupPolicy[CacheLookupPolicy["AccessToken"] = 1] = "AccessToken";
    /*
     * acquireTokenSilent will attempt to retrieve an access token from the cache. If the access token is expired or
     * cannot be found, the refresh token will be used to acquire a new one. If the refresh token is expired, it
     * will not be renewed and acquireTokenSilent will fail.
     */
    CacheLookupPolicy[CacheLookupPolicy["AccessTokenAndRefreshToken"] = 2] = "AccessTokenAndRefreshToken";
    /*
     * acquireTokenSilent will not attempt to retrieve access tokens from the cache and will instead attempt to
     * exchange the cached refresh token for a new access token. If the refresh token is expired, it will not be
     * renewed and acquireTokenSilent will fail.
     */
    CacheLookupPolicy[CacheLookupPolicy["RefreshToken"] = 3] = "RefreshToken";
    /*
     * acquireTokenSilent will not look in the cache for the access token. It will go directly to network with the
     * cached refresh token. If the refresh token is expired an attempt will be made to renew it. This is equivalent to
     * setting "forceRefresh: true".
     */
    CacheLookupPolicy[CacheLookupPolicy["RefreshTokenAndNetwork"] = 4] = "RefreshTokenAndNetwork";
    /*
     * acquireTokenSilent will attempt to renew both access and refresh tokens. It will not look in the cache. This will
     * always fail if 3rd party cookies are blocked by the browser.
     */
    CacheLookupPolicy[CacheLookupPolicy["Skip"] = 5] = "Skip";
})(CacheLookupPolicy || (CacheLookupPolicy = {}));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * BrowserAuthErrorMessage class containing string constants used by error codes and messages.
 */
var BrowserConfigurationAuthErrorMessage = {
    redirectUriNotSet: {
        code: "redirect_uri_empty",
        desc: "A redirect URI is required for all calls, and none has been set."
    },
    postLogoutUriNotSet: {
        code: "post_logout_uri_empty",
        desc: "A post logout redirect has not been set."
    },
    storageNotSupportedError: {
        code: "storage_not_supported",
        desc: "Given storage configuration option was not supported."
    },
    noRedirectCallbacksSet: {
        code: "no_redirect_callbacks",
        desc: "No redirect callbacks have been set. Please call setRedirectCallbacks() with the appropriate function arguments before continuing. " +
            "More information is available here: https://github.com/AzureAD/microsoft-authentication-library-for-js/wiki/MSAL-basics."
    },
    invalidCallbackObject: {
        code: "invalid_callback_object",
        desc: "The object passed for the callback was invalid. " +
            "More information is available here: https://github.com/AzureAD/microsoft-authentication-library-for-js/wiki/MSAL-basics."
    },
    stubPcaInstanceCalled: {
        code: "stubbed_public_client_application_called",
        desc: "Stub instance of Public Client Application was called. If using msal-react, please ensure context is not used without a provider. For more visit: aka.ms/msaljs/browser-errors"
    },
    inMemRedirectUnavailable: {
        code: "in_mem_redirect_unavailable",
        desc: "Redirect cannot be supported. In-memory storage was selected and storeAuthStateInCookie=false, which would cause the library to be unable to handle the incoming hash. If you would like to use the redirect API, please use session/localStorage or set storeAuthStateInCookie=true."
    },
    entropyNotProvided: {
        code: "entropy_not_provided",
        desc: "The available browser crypto interface requires entropy set via system.cryptoOptions.entropy configuration option."
    }
};
/**
 * Browser library error class thrown by the MSAL.js library for SPAs
 */
var BrowserConfigurationAuthError = /** @class */ (function (_super) {
    __extends$g(BrowserConfigurationAuthError, _super);
    function BrowserConfigurationAuthError(errorCode, errorMessage) {
        var _this = _super.call(this, errorCode, errorMessage) || this;
        _this.name = "BrowserConfigurationAuthError";
        Object.setPrototypeOf(_this, BrowserConfigurationAuthError.prototype);
        return _this;
    }
    /**
     * Creates an error thrown when the redirect uri is empty (not set by caller)
     */
    BrowserConfigurationAuthError.createRedirectUriEmptyError = function () {
        return new BrowserConfigurationAuthError(BrowserConfigurationAuthErrorMessage.redirectUriNotSet.code, BrowserConfigurationAuthErrorMessage.redirectUriNotSet.desc);
    };
    /**
     * Creates an error thrown when the post-logout redirect uri is empty (not set by caller)
     */
    BrowserConfigurationAuthError.createPostLogoutRedirectUriEmptyError = function () {
        return new BrowserConfigurationAuthError(BrowserConfigurationAuthErrorMessage.postLogoutUriNotSet.code, BrowserConfigurationAuthErrorMessage.postLogoutUriNotSet.desc);
    };
    /**
     * Creates error thrown when given storage location is not supported.
     * @param givenStorageLocation
     */
    BrowserConfigurationAuthError.createStorageNotSupportedError = function (givenStorageLocation) {
        return new BrowserConfigurationAuthError(BrowserConfigurationAuthErrorMessage.storageNotSupportedError.code, BrowserConfigurationAuthErrorMessage.storageNotSupportedError.desc + " Given Location: " + givenStorageLocation);
    };
    /**
     * Creates error thrown when redirect callbacks are not set before calling loginRedirect() or acquireTokenRedirect().
     */
    BrowserConfigurationAuthError.createRedirectCallbacksNotSetError = function () {
        return new BrowserConfigurationAuthError(BrowserConfigurationAuthErrorMessage.noRedirectCallbacksSet.code, BrowserConfigurationAuthErrorMessage.noRedirectCallbacksSet.desc);
    };
    /**
     * Creates error thrown when the stub instance of PublicClientApplication is called.
     */
    BrowserConfigurationAuthError.createStubPcaInstanceCalledError = function () {
        return new BrowserConfigurationAuthError(BrowserConfigurationAuthErrorMessage.stubPcaInstanceCalled.code, BrowserConfigurationAuthErrorMessage.stubPcaInstanceCalled.desc);
    };
    /*
     * Create an error thrown when in-memory storage is used and storeAuthStateInCookie=false.
     */
    BrowserConfigurationAuthError.createInMemoryRedirectUnavailableError = function () {
        return new BrowserConfigurationAuthError(BrowserConfigurationAuthErrorMessage.inMemRedirectUnavailable.code, BrowserConfigurationAuthErrorMessage.inMemRedirectUnavailable.desc);
    };
    /**
     * Creates an error thrown when a crypto interface that requires entropy is initialized without entropy
     */
    BrowserConfigurationAuthError.createEntropyNotProvided = function () {
        return new BrowserConfigurationAuthError(BrowserConfigurationAuthErrorMessage.entropyNotProvided.code, BrowserConfigurationAuthErrorMessage.entropyNotProvided.desc);
    };
    return BrowserConfigurationAuthError;
}(AuthError));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var BrowserStorage = /** @class */ (function () {
    function BrowserStorage(cacheLocation) {
        this.validateWindowStorage(cacheLocation);
        this.windowStorage = window[cacheLocation];
    }
    BrowserStorage.prototype.validateWindowStorage = function (cacheLocation) {
        if (cacheLocation !== BrowserCacheLocation.LocalStorage && cacheLocation !== BrowserCacheLocation.SessionStorage) {
            throw BrowserConfigurationAuthError.createStorageNotSupportedError(cacheLocation);
        }
        var storageSupported = !!window[cacheLocation];
        if (!storageSupported) {
            throw BrowserConfigurationAuthError.createStorageNotSupportedError(cacheLocation);
        }
    };
    BrowserStorage.prototype.getItem = function (key) {
        return this.windowStorage.getItem(key);
    };
    BrowserStorage.prototype.setItem = function (key, value) {
        this.windowStorage.setItem(key, value);
    };
    BrowserStorage.prototype.removeItem = function (key) {
        this.windowStorage.removeItem(key);
    };
    BrowserStorage.prototype.getKeys = function () {
        return Object.keys(this.windowStorage);
    };
    BrowserStorage.prototype.containsKey = function (key) {
        return this.windowStorage.hasOwnProperty(key);
    };
    return BrowserStorage;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var MemoryStorage = /** @class */ (function () {
    function MemoryStorage() {
        this.cache = new Map();
    }
    MemoryStorage.prototype.getItem = function (key) {
        return this.cache.get(key) || null;
    };
    MemoryStorage.prototype.setItem = function (key, value) {
        this.cache.set(key, value);
    };
    MemoryStorage.prototype.removeItem = function (key) {
        this.cache.delete(key);
    };
    MemoryStorage.prototype.getKeys = function () {
        var cacheKeys = [];
        this.cache.forEach(function (value, key) {
            cacheKeys.push(key);
        });
        return cacheKeys;
    };
    MemoryStorage.prototype.containsKey = function (key) {
        return this.cache.has(key);
    };
    MemoryStorage.prototype.clear = function () {
        this.cache.clear();
    };
    return MemoryStorage;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var BrowserProtocolUtils = /** @class */ (function () {
    function BrowserProtocolUtils() {
    }
    /**
     * Extracts the BrowserStateObject from the state string.
     * @param browserCrypto
     * @param state
     */
    BrowserProtocolUtils.extractBrowserRequestState = function (browserCrypto, state) {
        if (StringUtils.isEmpty(state)) {
            return null;
        }
        try {
            var requestStateObj = ProtocolUtils.parseRequestState(browserCrypto, state);
            return requestStateObj.libraryState.meta;
        }
        catch (e) {
            throw ClientAuthError.createInvalidStateError(state, e);
        }
    };
    /**
     * Parses properties of server response from url hash
     * @param locationHash Hash from url
     */
    BrowserProtocolUtils.parseServerResponseFromHash = function (locationHash) {
        if (!locationHash) {
            return {};
        }
        var hashUrlString = new UrlString(locationHash);
        return UrlString.getDeserializedHash(hashUrlString.getHash());
    };
    return BrowserProtocolUtils;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * This class implements the cache storage interface for MSAL through browser local or session storage.
 * Cookies are only used if storeAuthStateInCookie is true, and are only used for
 * parameters such as state and nonce, generally.
 */
var BrowserCacheManager = /** @class */ (function (_super) {
    __extends$g(BrowserCacheManager, _super);
    function BrowserCacheManager(clientId, cacheConfig, cryptoImpl, logger) {
        var _this = _super.call(this, clientId, cryptoImpl, logger) || this;
        // Cookie life calculation (hours * minutes * seconds * ms)
        _this.COOKIE_LIFE_MULTIPLIER = 24 * 60 * 60 * 1000;
        _this.cacheConfig = cacheConfig;
        _this.logger = logger;
        _this.internalStorage = new MemoryStorage();
        _this.browserStorage = _this.setupBrowserStorage(_this.cacheConfig.cacheLocation);
        _this.temporaryCacheStorage = _this.setupTemporaryCacheStorage(_this.cacheConfig.temporaryCacheLocation, _this.cacheConfig.cacheLocation);
        // Migrate cache entries from older versions of MSAL.
        if (cacheConfig.cacheMigrationEnabled) {
            _this.migrateCacheEntries();
            _this.createKeyMaps();
        }
        return _this;
    }
    /**
     * Returns a window storage class implementing the IWindowStorage interface that corresponds to the configured cacheLocation.
     * @param cacheLocation
     */
    BrowserCacheManager.prototype.setupBrowserStorage = function (cacheLocation) {
        switch (cacheLocation) {
            case BrowserCacheLocation.LocalStorage:
            case BrowserCacheLocation.SessionStorage:
                try {
                    return new BrowserStorage(cacheLocation);
                }
                catch (e) {
                    this.logger.verbose(e);
                    break;
                }
        }
        this.cacheConfig.cacheLocation = BrowserCacheLocation.MemoryStorage;
        return new MemoryStorage();
    };
    /**
     * Returns a window storage class implementing the IWindowStorage interface that corresponds to the configured temporaryCacheLocation.
     * @param temporaryCacheLocation
     * @param cacheLocation
     */
    BrowserCacheManager.prototype.setupTemporaryCacheStorage = function (temporaryCacheLocation, cacheLocation) {
        switch (cacheLocation) {
            case BrowserCacheLocation.LocalStorage:
            case BrowserCacheLocation.SessionStorage:
                try {
                    /*
                     * When users do not explicitly choose their own temporaryCacheLocation,
                     * temporary cache items will always be stored in session storage to mitigate problems caused by multiple tabs
                     */
                    return new BrowserStorage(temporaryCacheLocation || BrowserCacheLocation.SessionStorage);
                }
                catch (e) {
                    this.logger.verbose(e);
                    return this.internalStorage;
                }
            case BrowserCacheLocation.MemoryStorage:
            default:
                return this.internalStorage;
        }
    };
    /**
     * Migrate all old cache entries to new schema. No rollback supported.
     * @param storeAuthStateInCookie
     */
    BrowserCacheManager.prototype.migrateCacheEntries = function () {
        var _this = this;
        var idTokenKey = Constants.CACHE_PREFIX + "." + PersistentCacheKeys.ID_TOKEN;
        var clientInfoKey = Constants.CACHE_PREFIX + "." + PersistentCacheKeys.CLIENT_INFO;
        var errorKey = Constants.CACHE_PREFIX + "." + PersistentCacheKeys.ERROR;
        var errorDescKey = Constants.CACHE_PREFIX + "." + PersistentCacheKeys.ERROR_DESC;
        var idTokenValue = this.browserStorage.getItem(idTokenKey);
        var clientInfoValue = this.browserStorage.getItem(clientInfoKey);
        var errorValue = this.browserStorage.getItem(errorKey);
        var errorDescValue = this.browserStorage.getItem(errorDescKey);
        var values = [idTokenValue, clientInfoValue, errorValue, errorDescValue];
        var keysToMigrate = [PersistentCacheKeys.ID_TOKEN, PersistentCacheKeys.CLIENT_INFO, PersistentCacheKeys.ERROR, PersistentCacheKeys.ERROR_DESC];
        keysToMigrate.forEach(function (cacheKey, index) { return _this.migrateCacheEntry(cacheKey, values[index]); });
    };
    /**
     * Utility function to help with migration.
     * @param newKey
     * @param value
     * @param storeAuthStateInCookie
     */
    BrowserCacheManager.prototype.migrateCacheEntry = function (newKey, value) {
        if (value) {
            this.setTemporaryCache(newKey, value, true);
        }
    };
    /**
     * Searches all cache entries for MSAL accounts and creates the account key map
     * This is used to migrate users from older versions of MSAL which did not create the map.
     * @returns
     */
    BrowserCacheManager.prototype.createKeyMaps = function () {
        var _this = this;
        this.logger.trace("BrowserCacheManager - createKeyMaps called.");
        var accountKeys = this.getItem(StaticCacheKeys.ACCOUNT_KEYS);
        var tokenKeys = this.getItem(StaticCacheKeys.TOKEN_KEYS + "." + this.clientId);
        if (accountKeys && tokenKeys) {
            this.logger.verbose("BrowserCacheManager:createKeyMaps - account and token key maps already exist, skipping migration.");
            // Key maps already exist, no need to iterate through cache
            return;
        }
        var allKeys = this.browserStorage.getKeys();
        allKeys.forEach(function (key) {
            if (_this.isCredentialKey(key)) {
                // Get item, parse, validate and write key to map
                var value = _this.getItem(key);
                if (value) {
                    var credObj = _this.validateAndParseJson(value);
                    if (credObj && credObj.hasOwnProperty("credentialType")) {
                        switch (credObj["credentialType"]) {
                            case CredentialType.ID_TOKEN:
                                if (IdTokenEntity.isIdTokenEntity(credObj)) {
                                    _this.logger.trace("BrowserCacheManager:createKeyMaps - idToken found, saving key to token key map");
                                    _this.logger.tracePii("BrowserCacheManager:createKeyMaps - idToken with key: " + key + " found, saving key to token key map");
                                    var idTokenEntity = CacheManager.toObject(new IdTokenEntity(), credObj);
                                    var newKey = _this.updateCredentialCacheKey(key, idTokenEntity);
                                    _this.addTokenKey(newKey, CredentialType.ID_TOKEN);
                                    return;
                                }
                                else {
                                    _this.logger.trace("BrowserCacheManager:createKeyMaps - key found matching idToken schema with value containing idToken credentialType field but value failed IdTokenEntity validation, skipping.");
                                    _this.logger.tracePii("BrowserCacheManager:createKeyMaps - failed idToken validation on key: " + key);
                                }
                                break;
                            case CredentialType.ACCESS_TOKEN:
                            case CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME:
                                if (AccessTokenEntity.isAccessTokenEntity(credObj)) {
                                    _this.logger.trace("BrowserCacheManager:createKeyMaps - accessToken found, saving key to token key map");
                                    _this.logger.tracePii("BrowserCacheManager:createKeyMaps - accessToken with key: " + key + " found, saving key to token key map");
                                    var accessTokenEntity = CacheManager.toObject(new AccessTokenEntity(), credObj);
                                    var newKey = _this.updateCredentialCacheKey(key, accessTokenEntity);
                                    _this.addTokenKey(newKey, CredentialType.ACCESS_TOKEN);
                                    return;
                                }
                                else {
                                    _this.logger.trace("BrowserCacheManager:createKeyMaps - key found matching accessToken schema with value containing accessToken credentialType field but value failed AccessTokenEntity validation, skipping.");
                                    _this.logger.tracePii("BrowserCacheManager:createKeyMaps - failed accessToken validation on key: " + key);
                                }
                                break;
                            case CredentialType.REFRESH_TOKEN:
                                if (RefreshTokenEntity.isRefreshTokenEntity(credObj)) {
                                    _this.logger.trace("BrowserCacheManager:createKeyMaps - refreshToken found, saving key to token key map");
                                    _this.logger.tracePii("BrowserCacheManager:createKeyMaps - refreshToken with key: " + key + " found, saving key to token key map");
                                    var refreshTokenEntity = CacheManager.toObject(new RefreshTokenEntity(), credObj);
                                    var newKey = _this.updateCredentialCacheKey(key, refreshTokenEntity);
                                    _this.addTokenKey(newKey, CredentialType.REFRESH_TOKEN);
                                    return;
                                }
                                else {
                                    _this.logger.trace("BrowserCacheManager:createKeyMaps - key found matching refreshToken schema with value containing refreshToken credentialType field but value failed RefreshTokenEntity validation, skipping.");
                                    _this.logger.tracePii("BrowserCacheManager:createKeyMaps - failed refreshToken validation on key: " + key);
                                }
                                break;
                            // If credentialType isn't one of our predefined ones, it may not be an MSAL cache value. Ignore.
                        }
                    }
                }
            }
            if (_this.isAccountKey(key)) {
                var value = _this.getItem(key);
                if (value) {
                    var accountObj = _this.validateAndParseJson(value);
                    if (accountObj && AccountEntity.isAccountEntity(accountObj)) {
                        _this.logger.trace("BrowserCacheManager:createKeyMaps - account found, saving key to account key map");
                        _this.logger.tracePii("BrowserCacheManager:createKeyMaps - account with key: " + key + " found, saving key to account key map");
                        _this.addAccountKeyToMap(key);
                    }
                }
            }
        });
    };
    /**
     * Parses passed value as JSON object, JSON.parse() will throw an error.
     * @param input
     */
    BrowserCacheManager.prototype.validateAndParseJson = function (jsonValue) {
        try {
            var parsedJson = JSON.parse(jsonValue);
            /**
             * There are edge cases in which JSON.parse will successfully parse a non-valid JSON object
             * (e.g. JSON.parse will parse an escaped string into an unescaped string), so adding a type check
             * of the parsed value is necessary in order to be certain that the string represents a valid JSON object.
             *
             */
            return (parsedJson && typeof parsedJson === "object") ? parsedJson : null;
        }
        catch (error) {
            return null;
        }
    };
    /**
     * fetches the entry from the browser storage based off the key
     * @param key
     */
    BrowserCacheManager.prototype.getItem = function (key) {
        return this.browserStorage.getItem(key);
    };
    /**
     * sets the entry in the browser storage
     * @param key
     * @param value
     */
    BrowserCacheManager.prototype.setItem = function (key, value) {
        this.browserStorage.setItem(key, value);
    };
    /**
     * fetch the account entity from the platform cache
     * @param accountKey
     */
    BrowserCacheManager.prototype.getAccount = function (accountKey) {
        this.logger.trace("BrowserCacheManager.getAccount called");
        var account = this.getItem(accountKey);
        if (!account) {
            this.removeAccountKeyFromMap(accountKey);
            return null;
        }
        var parsedAccount = this.validateAndParseJson(account);
        if (!parsedAccount || !AccountEntity.isAccountEntity(parsedAccount)) {
            this.removeAccountKeyFromMap(accountKey);
            return null;
        }
        return CacheManager.toObject(new AccountEntity(), parsedAccount);
    };
    /**
     * set account entity in the platform cache
     * @param key
     * @param value
     */
    BrowserCacheManager.prototype.setAccount = function (account) {
        this.logger.trace("BrowserCacheManager.setAccount called");
        var key = account.generateAccountKey();
        this.setItem(key, JSON.stringify(account));
        this.addAccountKeyToMap(key);
    };
    /**
     * Returns the array of account keys currently cached
     * @returns
     */
    BrowserCacheManager.prototype.getAccountKeys = function () {
        this.logger.trace("BrowserCacheManager.getAccountKeys called");
        var accountKeys = this.getItem(StaticCacheKeys.ACCOUNT_KEYS);
        if (accountKeys) {
            return JSON.parse(accountKeys);
        }
        this.logger.verbose("BrowserCacheManager.getAccountKeys - No account keys found");
        return [];
    };
    /**
     * Add a new account to the key map
     * @param key
     */
    BrowserCacheManager.prototype.addAccountKeyToMap = function (key) {
        this.logger.trace("BrowserCacheManager.addAccountKeyToMap called");
        this.logger.tracePii("BrowserCacheManager.addAccountKeyToMap called with key: " + key);
        var accountKeys = this.getAccountKeys();
        if (accountKeys.indexOf(key) === -1) {
            // Only add key if it does not already exist in the map
            accountKeys.push(key);
            this.setItem(StaticCacheKeys.ACCOUNT_KEYS, JSON.stringify(accountKeys));
            this.logger.verbose("BrowserCacheManager.addAccountKeyToMap account key added");
        }
        else {
            this.logger.verbose("BrowserCacheManager.addAccountKeyToMap account key already exists in map");
        }
    };
    /**
     * Remove an account from the key map
     * @param key
     */
    BrowserCacheManager.prototype.removeAccountKeyFromMap = function (key) {
        this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap called");
        this.logger.tracePii("BrowserCacheManager.removeAccountKeyFromMap called with key: " + key);
        var accountKeys = this.getAccountKeys();
        var removalIndex = accountKeys.indexOf(key);
        if (removalIndex > -1) {
            accountKeys.splice(removalIndex, 1);
            this.setItem(StaticCacheKeys.ACCOUNT_KEYS, JSON.stringify(accountKeys));
            this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap account key removed");
        }
        else {
            this.logger.trace("BrowserCacheManager.removeAccountKeyFromMap key not found in existing map");
        }
    };
    /**
     * Extends inherited removeAccount function to include removal of the account key from the map
     * @param key
     */
    BrowserCacheManager.prototype.removeAccount = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                _super.prototype.removeAccount.call(this, key);
                this.removeAccountKeyFromMap(key);
                return [2 /*return*/];
            });
        });
    };
    /**
     * Removes given idToken from the cache and from the key map
     * @param key
     */
    BrowserCacheManager.prototype.removeIdToken = function (key) {
        _super.prototype.removeIdToken.call(this, key);
        this.removeTokenKey(key, CredentialType.ID_TOKEN);
    };
    /**
     * Removes given accessToken from the cache and from the key map
     * @param key
     */
    BrowserCacheManager.prototype.removeAccessToken = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                _super.prototype.removeAccessToken.call(this, key);
                this.removeTokenKey(key, CredentialType.ACCESS_TOKEN);
                return [2 /*return*/];
            });
        });
    };
    /**
     * Removes given refreshToken from the cache and from the key map
     * @param key
     */
    BrowserCacheManager.prototype.removeRefreshToken = function (key) {
        _super.prototype.removeRefreshToken.call(this, key);
        this.removeTokenKey(key, CredentialType.REFRESH_TOKEN);
    };
    /**
     * Gets the keys for the cached tokens associated with this clientId
     * @returns
     */
    BrowserCacheManager.prototype.getTokenKeys = function () {
        this.logger.trace("BrowserCacheManager.getTokenKeys called");
        var item = this.getItem(StaticCacheKeys.TOKEN_KEYS + "." + this.clientId);
        if (item) {
            var tokenKeys = this.validateAndParseJson(item);
            if (tokenKeys &&
                tokenKeys.hasOwnProperty("idToken") &&
                tokenKeys.hasOwnProperty("accessToken") &&
                tokenKeys.hasOwnProperty("refreshToken")) {
                return tokenKeys;
            }
            else {
                this.logger.error("BrowserCacheManager.getTokenKeys - Token keys found but in an unknown format. Returning empty key map.");
            }
        }
        else {
            this.logger.verbose("BrowserCacheManager.getTokenKeys - No token keys found");
        }
        return {
            idToken: [],
            accessToken: [],
            refreshToken: []
        };
    };
    /**
     * Adds the given key to the token key map
     * @param key
     * @param type
     */
    BrowserCacheManager.prototype.addTokenKey = function (key, type) {
        this.logger.trace("BrowserCacheManager addTokenKey called");
        var tokenKeys = this.getTokenKeys();
        switch (type) {
            case CredentialType.ID_TOKEN:
                if (tokenKeys.idToken.indexOf(key) === -1) {
                    this.logger.info("BrowserCacheManager: addTokenKey - idToken added to map");
                    tokenKeys.idToken.push(key);
                }
                break;
            case CredentialType.ACCESS_TOKEN:
                if (tokenKeys.accessToken.indexOf(key) === -1) {
                    this.logger.info("BrowserCacheManager: addTokenKey - accessToken added to map");
                    tokenKeys.accessToken.push(key);
                }
                break;
            case CredentialType.REFRESH_TOKEN:
                if (tokenKeys.refreshToken.indexOf(key) === -1) {
                    this.logger.info("BrowserCacheManager: addTokenKey - refreshToken added to map");
                    tokenKeys.refreshToken.push(key);
                }
                break;
            default:
                this.logger.error("BrowserCacheManager:addTokenKey - CredentialType provided invalid. CredentialType: " + type);
                ClientAuthError.createUnexpectedCredentialTypeError();
        }
        this.setItem(StaticCacheKeys.TOKEN_KEYS + "." + this.clientId, JSON.stringify(tokenKeys));
    };
    /**
     * Removes the given key from the token key map
     * @param key
     * @param type
     */
    BrowserCacheManager.prototype.removeTokenKey = function (key, type) {
        this.logger.trace("BrowserCacheManager removeTokenKey called");
        var tokenKeys = this.getTokenKeys();
        switch (type) {
            case CredentialType.ID_TOKEN:
                this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove idToken with key: " + key + " from map");
                var idRemoval = tokenKeys.idToken.indexOf(key);
                if (idRemoval > -1) {
                    this.logger.info("BrowserCacheManager: removeTokenKey - idToken removed from map");
                    tokenKeys.idToken.splice(idRemoval, 1);
                }
                else {
                    this.logger.info("BrowserCacheManager: removeTokenKey - idToken does not exist in map. Either it was previously removed or it was never added.");
                }
                break;
            case CredentialType.ACCESS_TOKEN:
                this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove accessToken with key: " + key + " from map");
                var accessRemoval = tokenKeys.accessToken.indexOf(key);
                if (accessRemoval > -1) {
                    this.logger.info("BrowserCacheManager: removeTokenKey - accessToken removed from map");
                    tokenKeys.accessToken.splice(accessRemoval, 1);
                }
                else {
                    this.logger.info("BrowserCacheManager: removeTokenKey - accessToken does not exist in map. Either it was previously removed or it was never added.");
                }
                break;
            case CredentialType.REFRESH_TOKEN:
                this.logger.infoPii("BrowserCacheManager: removeTokenKey - attempting to remove refreshToken with key: " + key + " from map");
                var refreshRemoval = tokenKeys.refreshToken.indexOf(key);
                if (refreshRemoval > -1) {
                    this.logger.info("BrowserCacheManager: removeTokenKey - refreshToken removed from map");
                    tokenKeys.refreshToken.splice(refreshRemoval, 1);
                }
                else {
                    this.logger.info("BrowserCacheManager: removeTokenKey - refreshToken does not exist in map. Either it was previously removed or it was never added.");
                }
                break;
            default:
                this.logger.error("BrowserCacheManager:removeTokenKey - CredentialType provided invalid. CredentialType: " + type);
                ClientAuthError.createUnexpectedCredentialTypeError();
        }
        this.setItem(StaticCacheKeys.TOKEN_KEYS + "." + this.clientId, JSON.stringify(tokenKeys));
    };
    /**
     * generates idToken entity from a string
     * @param idTokenKey
     */
    BrowserCacheManager.prototype.getIdTokenCredential = function (idTokenKey) {
        var value = this.getItem(idTokenKey);
        if (!value) {
            this.logger.trace("BrowserCacheManager.getIdTokenCredential: called, no cache hit");
            this.removeTokenKey(idTokenKey, CredentialType.ID_TOKEN);
            return null;
        }
        var parsedIdToken = this.validateAndParseJson(value);
        if (!parsedIdToken || !IdTokenEntity.isIdTokenEntity(parsedIdToken)) {
            this.logger.trace("BrowserCacheManager.getIdTokenCredential: called, no cache hit");
            this.removeTokenKey(idTokenKey, CredentialType.ID_TOKEN);
            return null;
        }
        this.logger.trace("BrowserCacheManager.getIdTokenCredential: cache hit");
        return CacheManager.toObject(new IdTokenEntity(), parsedIdToken);
    };
    /**
     * set IdToken credential to the platform cache
     * @param idToken
     */
    BrowserCacheManager.prototype.setIdTokenCredential = function (idToken) {
        this.logger.trace("BrowserCacheManager.setIdTokenCredential called");
        var idTokenKey = idToken.generateCredentialKey();
        this.setItem(idTokenKey, JSON.stringify(idToken));
        this.addTokenKey(idTokenKey, CredentialType.ID_TOKEN);
    };
    /**
     * generates accessToken entity from a string
     * @param key
     */
    BrowserCacheManager.prototype.getAccessTokenCredential = function (accessTokenKey) {
        var value = this.getItem(accessTokenKey);
        if (!value) {
            this.logger.trace("BrowserCacheManager.getAccessTokenCredential: called, no cache hit");
            this.removeTokenKey(accessTokenKey, CredentialType.ACCESS_TOKEN);
            return null;
        }
        var parsedAccessToken = this.validateAndParseJson(value);
        if (!parsedAccessToken || !AccessTokenEntity.isAccessTokenEntity(parsedAccessToken)) {
            this.logger.trace("BrowserCacheManager.getAccessTokenCredential: called, no cache hit");
            this.removeTokenKey(accessTokenKey, CredentialType.ACCESS_TOKEN);
            return null;
        }
        this.logger.trace("BrowserCacheManager.getAccessTokenCredential: cache hit");
        return CacheManager.toObject(new AccessTokenEntity(), parsedAccessToken);
    };
    /**
     * set accessToken credential to the platform cache
     * @param accessToken
     */
    BrowserCacheManager.prototype.setAccessTokenCredential = function (accessToken) {
        this.logger.trace("BrowserCacheManager.setAccessTokenCredential called");
        var accessTokenKey = accessToken.generateCredentialKey();
        this.setItem(accessTokenKey, JSON.stringify(accessToken));
        this.addTokenKey(accessTokenKey, CredentialType.ACCESS_TOKEN);
    };
    /**
     * generates refreshToken entity from a string
     * @param refreshTokenKey
     */
    BrowserCacheManager.prototype.getRefreshTokenCredential = function (refreshTokenKey) {
        var value = this.getItem(refreshTokenKey);
        if (!value) {
            this.logger.trace("BrowserCacheManager.getRefreshTokenCredential: called, no cache hit");
            this.removeTokenKey(refreshTokenKey, CredentialType.REFRESH_TOKEN);
            return null;
        }
        var parsedRefreshToken = this.validateAndParseJson(value);
        if (!parsedRefreshToken || !RefreshTokenEntity.isRefreshTokenEntity(parsedRefreshToken)) {
            this.logger.trace("BrowserCacheManager.getRefreshTokenCredential: called, no cache hit");
            this.removeTokenKey(refreshTokenKey, CredentialType.REFRESH_TOKEN);
            return null;
        }
        this.logger.trace("BrowserCacheManager.getRefreshTokenCredential: cache hit");
        return CacheManager.toObject(new RefreshTokenEntity(), parsedRefreshToken);
    };
    /**
     * set refreshToken credential to the platform cache
     * @param refreshToken
     */
    BrowserCacheManager.prototype.setRefreshTokenCredential = function (refreshToken) {
        this.logger.trace("BrowserCacheManager.setRefreshTokenCredential called");
        var refreshTokenKey = refreshToken.generateCredentialKey();
        this.setItem(refreshTokenKey, JSON.stringify(refreshToken));
        this.addTokenKey(refreshTokenKey, CredentialType.REFRESH_TOKEN);
    };
    /**
     * fetch appMetadata entity from the platform cache
     * @param appMetadataKey
     */
    BrowserCacheManager.prototype.getAppMetadata = function (appMetadataKey) {
        var value = this.getItem(appMetadataKey);
        if (!value) {
            this.logger.trace("BrowserCacheManager.getAppMetadata: called, no cache hit");
            return null;
        }
        var parsedMetadata = this.validateAndParseJson(value);
        if (!parsedMetadata || !AppMetadataEntity.isAppMetadataEntity(appMetadataKey, parsedMetadata)) {
            this.logger.trace("BrowserCacheManager.getAppMetadata: called, no cache hit");
            return null;
        }
        this.logger.trace("BrowserCacheManager.getAppMetadata: cache hit");
        return CacheManager.toObject(new AppMetadataEntity(), parsedMetadata);
    };
    /**
     * set appMetadata entity to the platform cache
     * @param appMetadata
     */
    BrowserCacheManager.prototype.setAppMetadata = function (appMetadata) {
        this.logger.trace("BrowserCacheManager.setAppMetadata called");
        var appMetadataKey = appMetadata.generateAppMetadataKey();
        this.setItem(appMetadataKey, JSON.stringify(appMetadata));
    };
    /**
     * fetch server telemetry entity from the platform cache
     * @param serverTelemetryKey
     */
    BrowserCacheManager.prototype.getServerTelemetry = function (serverTelemetryKey) {
        var value = this.getItem(serverTelemetryKey);
        if (!value) {
            this.logger.trace("BrowserCacheManager.getServerTelemetry: called, no cache hit");
            return null;
        }
        var parsedMetadata = this.validateAndParseJson(value);
        if (!parsedMetadata || !ServerTelemetryEntity.isServerTelemetryEntity(serverTelemetryKey, parsedMetadata)) {
            this.logger.trace("BrowserCacheManager.getServerTelemetry: called, no cache hit");
            return null;
        }
        this.logger.trace("BrowserCacheManager.getServerTelemetry: cache hit");
        return CacheManager.toObject(new ServerTelemetryEntity(), parsedMetadata);
    };
    /**
     * set server telemetry entity to the platform cache
     * @param serverTelemetryKey
     * @param serverTelemetry
     */
    BrowserCacheManager.prototype.setServerTelemetry = function (serverTelemetryKey, serverTelemetry) {
        this.logger.trace("BrowserCacheManager.setServerTelemetry called");
        this.setItem(serverTelemetryKey, JSON.stringify(serverTelemetry));
    };
    /**
     *
     */
    BrowserCacheManager.prototype.getAuthorityMetadata = function (key) {
        var value = this.internalStorage.getItem(key);
        if (!value) {
            this.logger.trace("BrowserCacheManager.getAuthorityMetadata: called, no cache hit");
            return null;
        }
        var parsedMetadata = this.validateAndParseJson(value);
        if (parsedMetadata && AuthorityMetadataEntity.isAuthorityMetadataEntity(key, parsedMetadata)) {
            this.logger.trace("BrowserCacheManager.getAuthorityMetadata: cache hit");
            return CacheManager.toObject(new AuthorityMetadataEntity(), parsedMetadata);
        }
        return null;
    };
    /**
     *
     */
    BrowserCacheManager.prototype.getAuthorityMetadataKeys = function () {
        var _this = this;
        var allKeys = this.internalStorage.getKeys();
        return allKeys.filter(function (key) {
            return _this.isAuthorityMetadata(key);
        });
    };
    /**
     * Sets wrapper metadata in memory
     * @param wrapperSKU
     * @param wrapperVersion
     */
    BrowserCacheManager.prototype.setWrapperMetadata = function (wrapperSKU, wrapperVersion) {
        this.internalStorage.setItem(InMemoryCacheKeys.WRAPPER_SKU, wrapperSKU);
        this.internalStorage.setItem(InMemoryCacheKeys.WRAPPER_VER, wrapperVersion);
    };
    /**
     * Returns wrapper metadata from in-memory storage
     */
    BrowserCacheManager.prototype.getWrapperMetadata = function () {
        var sku = this.internalStorage.getItem(InMemoryCacheKeys.WRAPPER_SKU) || Constants.EMPTY_STRING;
        var version = this.internalStorage.getItem(InMemoryCacheKeys.WRAPPER_VER) || Constants.EMPTY_STRING;
        return [sku, version];
    };
    /**
     *
     * @param entity
     */
    BrowserCacheManager.prototype.setAuthorityMetadata = function (key, entity) {
        this.logger.trace("BrowserCacheManager.setAuthorityMetadata called");
        this.internalStorage.setItem(key, JSON.stringify(entity));
    };
    /**
     * Gets the active account
     */
    BrowserCacheManager.prototype.getActiveAccount = function () {
        var activeAccountKeyFilters = this.generateCacheKey(PersistentCacheKeys.ACTIVE_ACCOUNT_FILTERS);
        var activeAccountValueFilters = this.getItem(activeAccountKeyFilters);
        if (!activeAccountValueFilters) {
            // if new active account cache type isn't found, it's an old version, so look for that instead
            this.logger.trace("BrowserCacheManager.getActiveAccount: No active account filters cache schema found, looking for legacy schema");
            var activeAccountKeyLocal = this.generateCacheKey(PersistentCacheKeys.ACTIVE_ACCOUNT);
            var activeAccountValueLocal = this.getItem(activeAccountKeyLocal);
            if (!activeAccountValueLocal) {
                this.logger.trace("BrowserCacheManager.getActiveAccount: No active account found");
                return null;
            }
            var activeAccount = this.getAccountInfoByFilter({ localAccountId: activeAccountValueLocal })[0] || null;
            if (activeAccount) {
                this.logger.trace("BrowserCacheManager.getActiveAccount: Legacy active account cache schema found");
                this.logger.trace("BrowserCacheManager.getActiveAccount: Adding active account filters cache schema");
                this.setActiveAccount(activeAccount);
                return activeAccount;
            }
            return null;
        }
        var activeAccountValueObj = this.validateAndParseJson(activeAccountValueFilters);
        if (activeAccountValueObj) {
            this.logger.trace("BrowserCacheManager.getActiveAccount: Active account filters schema found");
            return this.getAccountInfoByFilter({
                homeAccountId: activeAccountValueObj.homeAccountId,
                localAccountId: activeAccountValueObj.localAccountId
            })[0] || null;
        }
        this.logger.trace("BrowserCacheManager.getActiveAccount: No active account found");
        return null;
    };
    /**
     * Sets the active account's localAccountId in cache
     * @param account
     */
    BrowserCacheManager.prototype.setActiveAccount = function (account) {
        var activeAccountKey = this.generateCacheKey(PersistentCacheKeys.ACTIVE_ACCOUNT_FILTERS);
        var activeAccountKeyLocal = this.generateCacheKey(PersistentCacheKeys.ACTIVE_ACCOUNT);
        if (account) {
            this.logger.verbose("setActiveAccount: Active account set");
            var activeAccountValue = {
                homeAccountId: account.homeAccountId,
                localAccountId: account.localAccountId
            };
            this.browserStorage.setItem(activeAccountKey, JSON.stringify(activeAccountValue));
            this.browserStorage.setItem(activeAccountKeyLocal, account.localAccountId);
        }
        else {
            this.logger.verbose("setActiveAccount: No account passed, active account not set");
            this.browserStorage.removeItem(activeAccountKey);
            this.browserStorage.removeItem(activeAccountKeyLocal);
        }
    };
    /**
     * Gets a list of accounts that match all of the filters provided
     * @param account
     */
    BrowserCacheManager.prototype.getAccountInfoByFilter = function (accountFilter) {
        var allAccounts = this.getAllAccounts();
        this.logger.trace("BrowserCacheManager.getAccountInfoByFilter: total " + allAccounts.length + " accounts found");
        return allAccounts.filter(function (accountObj) {
            if (accountFilter.username && accountFilter.username.toLowerCase() !== accountObj.username.toLowerCase()) {
                return false;
            }
            if (accountFilter.homeAccountId && accountFilter.homeAccountId !== accountObj.homeAccountId) {
                return false;
            }
            if (accountFilter.localAccountId && accountFilter.localAccountId !== accountObj.localAccountId) {
                return false;
            }
            if (accountFilter.tenantId && accountFilter.tenantId !== accountObj.tenantId) {
                return false;
            }
            if (accountFilter.environment && accountFilter.environment !== accountObj.environment) {
                return false;
            }
            return true;
        });
    };
    /**
     * Checks the cache for accounts matching loginHint or SID
     * @param loginHint
     * @param sid
     */
    BrowserCacheManager.prototype.getAccountInfoByHints = function (loginHint, sid) {
        var matchingAccounts = this.getAllAccounts().filter(function (accountInfo) {
            if (sid) {
                var accountSid = accountInfo.idTokenClaims && accountInfo.idTokenClaims["sid"];
                return sid === accountSid;
            }
            if (loginHint) {
                return loginHint === accountInfo.username;
            }
            return false;
        });
        if (matchingAccounts.length === 1) {
            return matchingAccounts[0];
        }
        else if (matchingAccounts.length > 1) {
            throw ClientAuthError.createMultipleMatchingAccountsInCacheError();
        }
        return null;
    };
    /**
     * fetch throttling entity from the platform cache
     * @param throttlingCacheKey
     */
    BrowserCacheManager.prototype.getThrottlingCache = function (throttlingCacheKey) {
        var value = this.getItem(throttlingCacheKey);
        if (!value) {
            this.logger.trace("BrowserCacheManager.getThrottlingCache: called, no cache hit");
            return null;
        }
        var parsedThrottlingCache = this.validateAndParseJson(value);
        if (!parsedThrottlingCache || !ThrottlingEntity.isThrottlingEntity(throttlingCacheKey, parsedThrottlingCache)) {
            this.logger.trace("BrowserCacheManager.getThrottlingCache: called, no cache hit");
            return null;
        }
        this.logger.trace("BrowserCacheManager.getThrottlingCache: cache hit");
        return CacheManager.toObject(new ThrottlingEntity(), parsedThrottlingCache);
    };
    /**
     * set throttling entity to the platform cache
     * @param throttlingCacheKey
     * @param throttlingCache
     */
    BrowserCacheManager.prototype.setThrottlingCache = function (throttlingCacheKey, throttlingCache) {
        this.logger.trace("BrowserCacheManager.setThrottlingCache called");
        this.setItem(throttlingCacheKey, JSON.stringify(throttlingCache));
    };
    /**
     * Gets cache item with given key.
     * Will retrieve from cookies if storeAuthStateInCookie is set to true.
     * @param key
     */
    BrowserCacheManager.prototype.getTemporaryCache = function (cacheKey, generateKey) {
        var key = generateKey ? this.generateCacheKey(cacheKey) : cacheKey;
        if (this.cacheConfig.storeAuthStateInCookie) {
            var itemCookie = this.getItemCookie(key);
            if (itemCookie) {
                this.logger.trace("BrowserCacheManager.getTemporaryCache: storeAuthStateInCookies set to true, retrieving from cookies");
                return itemCookie;
            }
        }
        var value = this.temporaryCacheStorage.getItem(key);
        if (!value) {
            // If temp cache item not found in session/memory, check local storage for items set by old versions
            if (this.cacheConfig.cacheLocation === BrowserCacheLocation.LocalStorage) {
                var item = this.browserStorage.getItem(key);
                if (item) {
                    this.logger.trace("BrowserCacheManager.getTemporaryCache: Temporary cache item found in local storage");
                    return item;
                }
            }
            this.logger.trace("BrowserCacheManager.getTemporaryCache: No cache item found in local storage");
            return null;
        }
        this.logger.trace("BrowserCacheManager.getTemporaryCache: Temporary cache item returned");
        return value;
    };
    /**
     * Sets the cache item with the key and value given.
     * Stores in cookie if storeAuthStateInCookie is set to true.
     * This can cause cookie overflow if used incorrectly.
     * @param key
     * @param value
     */
    BrowserCacheManager.prototype.setTemporaryCache = function (cacheKey, value, generateKey) {
        var key = generateKey ? this.generateCacheKey(cacheKey) : cacheKey;
        this.temporaryCacheStorage.setItem(key, value);
        if (this.cacheConfig.storeAuthStateInCookie) {
            this.logger.trace("BrowserCacheManager.setTemporaryCache: storeAuthStateInCookie set to true, setting item cookie");
            this.setItemCookie(key, value);
        }
    };
    /**
     * Removes the cache item with the given key.
     * Will also clear the cookie item if storeAuthStateInCookie is set to true.
     * @param key
     */
    BrowserCacheManager.prototype.removeItem = function (key) {
        this.browserStorage.removeItem(key);
        this.temporaryCacheStorage.removeItem(key);
        if (this.cacheConfig.storeAuthStateInCookie) {
            this.logger.trace("BrowserCacheManager.removeItem: storeAuthStateInCookie is true, clearing item cookie");
            this.clearItemCookie(key);
        }
    };
    /**
     * Checks whether key is in cache.
     * @param key
     */
    BrowserCacheManager.prototype.containsKey = function (key) {
        return this.browserStorage.containsKey(key) || this.temporaryCacheStorage.containsKey(key);
    };
    /**
     * Gets all keys in window.
     */
    BrowserCacheManager.prototype.getKeys = function () {
        return __spread(this.browserStorage.getKeys(), this.temporaryCacheStorage.getKeys());
    };
    /**
     * Clears all cache entries created by MSAL.
     */
    BrowserCacheManager.prototype.clear = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Removes all accounts and their credentials
                    return [4 /*yield*/, this.removeAllAccounts()];
                    case 1:
                        // Removes all accounts and their credentials
                        _a.sent();
                        this.removeAppMetadata();
                        // Removes all remaining MSAL cache items
                        this.getKeys().forEach(function (cacheKey) {
                            // Check if key contains msal prefix; For now, we are clearing all the cache items created by MSAL.js
                            if ((_this.browserStorage.containsKey(cacheKey) || _this.temporaryCacheStorage.containsKey(cacheKey)) && ((cacheKey.indexOf(Constants.CACHE_PREFIX) !== -1) || (cacheKey.indexOf(_this.clientId) !== -1))) {
                                _this.removeItem(cacheKey);
                            }
                        });
                        this.internalStorage.clear();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Clears all access tokes that have claims prior to saving the current one
     * @param credential
     * @returns
     */
    BrowserCacheManager.prototype.clearTokensAndKeysWithClaims = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var tokenKeys, removedAccessTokens;
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.trace("BrowserCacheManager.clearTokensAndKeysWithClaims called");
                        tokenKeys = this.getTokenKeys();
                        removedAccessTokens = [];
                        tokenKeys.accessToken.forEach(function (key) {
                            // if the access token has claims in its key, remove the token key and the token
                            var credential = _this.getAccessTokenCredential(key);
                            if ((credential === null || credential === void 0 ? void 0 : credential.requestedClaimsHash) && key.includes(credential.requestedClaimsHash.toLowerCase())) {
                                removedAccessTokens.push(_this.removeAccessToken(key));
                            }
                        });
                        return [4 /*yield*/, Promise.all(removedAccessTokens)];
                    case 1:
                        _a.sent();
                        // warn if any access tokens are removed
                        if (removedAccessTokens.length > 0) {
                            this.logger.warning(removedAccessTokens.length + " access tokens with claims in the cache keys have been removed from the cache.");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Add value to cookies
     * @param cookieName
     * @param cookieValue
     * @param expires
     */
    BrowserCacheManager.prototype.setItemCookie = function (cookieName, cookieValue, expires) {
        var cookieStr = encodeURIComponent(cookieName) + "=" + encodeURIComponent(cookieValue) + ";path=/;SameSite=Lax;";
        if (expires) {
            var expireTime = this.getCookieExpirationTime(expires);
            cookieStr += "expires=" + expireTime + ";";
        }
        if (this.cacheConfig.secureCookies) {
            cookieStr += "Secure;";
        }
        document.cookie = cookieStr;
    };
    /**
     * Get one item by key from cookies
     * @param cookieName
     */
    BrowserCacheManager.prototype.getItemCookie = function (cookieName) {
        var name = encodeURIComponent(cookieName) + "=";
        var cookieList = document.cookie.split(";");
        for (var i = 0; i < cookieList.length; i++) {
            var cookie = cookieList[i];
            while (cookie.charAt(0) === " ") {
                cookie = cookie.substring(1);
            }
            if (cookie.indexOf(name) === 0) {
                return decodeURIComponent(cookie.substring(name.length, cookie.length));
            }
        }
        return Constants.EMPTY_STRING;
    };
    /**
     * Clear all msal-related cookies currently set in the browser. Should only be used to clear temporary cache items.
     */
    BrowserCacheManager.prototype.clearMsalCookies = function () {
        var _this = this;
        var cookiePrefix = Constants.CACHE_PREFIX + "." + this.clientId;
        var cookieList = document.cookie.split(";");
        cookieList.forEach(function (cookie) {
            while (cookie.charAt(0) === " ") {
                // eslint-disable-next-line no-param-reassign
                cookie = cookie.substring(1);
            }
            if (cookie.indexOf(cookiePrefix) === 0) {
                var cookieKey = cookie.split("=")[0];
                _this.clearItemCookie(cookieKey);
            }
        });
    };
    /**
     * Clear an item in the cookies by key
     * @param cookieName
     */
    BrowserCacheManager.prototype.clearItemCookie = function (cookieName) {
        this.setItemCookie(cookieName, Constants.EMPTY_STRING, -1);
    };
    /**
     * Get cookie expiration time
     * @param cookieLifeDays
     */
    BrowserCacheManager.prototype.getCookieExpirationTime = function (cookieLifeDays) {
        var today = new Date();
        var expr = new Date(today.getTime() + cookieLifeDays * this.COOKIE_LIFE_MULTIPLIER);
        return expr.toUTCString();
    };
    /**
     * Gets the cache object referenced by the browser
     */
    BrowserCacheManager.prototype.getCache = function () {
        return this.browserStorage;
    };
    /**
     * interface compat, we cannot overwrite browser cache; Functionality is supported by individual entities in browser
     */
    BrowserCacheManager.prototype.setCache = function () {
        // sets nothing
    };
    /**
     * Prepend msal.<client-id> to each key; Skip for any JSON object as Key (defined schemas do not need the key appended: AccessToken Keys or the upcoming schema)
     * @param key
     * @param addInstanceId
     */
    BrowserCacheManager.prototype.generateCacheKey = function (key) {
        var generatedKey = this.validateAndParseJson(key);
        if (!generatedKey) {
            if (StringUtils.startsWith(key, Constants.CACHE_PREFIX) || StringUtils.startsWith(key, PersistentCacheKeys.ADAL_ID_TOKEN)) {
                return key;
            }
            return Constants.CACHE_PREFIX + "." + this.clientId + "." + key;
        }
        return JSON.stringify(key);
    };
    /**
     * Create authorityKey to cache authority
     * @param state
     */
    BrowserCacheManager.prototype.generateAuthorityKey = function (stateString) {
        var stateId = ProtocolUtils.parseRequestState(this.cryptoImpl, stateString).libraryState.id;
        return this.generateCacheKey(TemporaryCacheKeys.AUTHORITY + "." + stateId);
    };
    /**
     * Create Nonce key to cache nonce
     * @param state
     */
    BrowserCacheManager.prototype.generateNonceKey = function (stateString) {
        var stateId = ProtocolUtils.parseRequestState(this.cryptoImpl, stateString).libraryState.id;
        return this.generateCacheKey(TemporaryCacheKeys.NONCE_IDTOKEN + "." + stateId);
    };
    /**
     * Creates full cache key for the request state
     * @param stateString State string for the request
     */
    BrowserCacheManager.prototype.generateStateKey = function (stateString) {
        // Use the library state id to key temp storage for uniqueness for multiple concurrent requests
        var stateId = ProtocolUtils.parseRequestState(this.cryptoImpl, stateString).libraryState.id;
        return this.generateCacheKey(TemporaryCacheKeys.REQUEST_STATE + "." + stateId);
    };
    /**
     * Gets the cached authority based on the cached state. Returns empty if no cached state found.
     */
    BrowserCacheManager.prototype.getCachedAuthority = function (cachedState) {
        var stateCacheKey = this.generateStateKey(cachedState);
        var state = this.getTemporaryCache(stateCacheKey);
        if (!state) {
            return null;
        }
        var authorityCacheKey = this.generateAuthorityKey(state);
        return this.getTemporaryCache(authorityCacheKey);
    };
    /**
     * Updates account, authority, and state in cache
     * @param serverAuthenticationRequest
     * @param account
     */
    BrowserCacheManager.prototype.updateCacheEntries = function (state, nonce, authorityInstance, loginHint, account) {
        this.logger.trace("BrowserCacheManager.updateCacheEntries called");
        // Cache the request state
        var stateCacheKey = this.generateStateKey(state);
        this.setTemporaryCache(stateCacheKey, state, false);
        // Cache the nonce
        var nonceCacheKey = this.generateNonceKey(state);
        this.setTemporaryCache(nonceCacheKey, nonce, false);
        // Cache authorityKey
        var authorityCacheKey = this.generateAuthorityKey(state);
        this.setTemporaryCache(authorityCacheKey, authorityInstance, false);
        if (account) {
            var ccsCredential = {
                credential: account.homeAccountId,
                type: CcsCredentialType.HOME_ACCOUNT_ID
            };
            this.setTemporaryCache(TemporaryCacheKeys.CCS_CREDENTIAL, JSON.stringify(ccsCredential), true);
        }
        else if (!StringUtils.isEmpty(loginHint)) {
            var ccsCredential = {
                credential: loginHint,
                type: CcsCredentialType.UPN
            };
            this.setTemporaryCache(TemporaryCacheKeys.CCS_CREDENTIAL, JSON.stringify(ccsCredential), true);
        }
    };
    /**
     * Reset all temporary cache items
     * @param state
     */
    BrowserCacheManager.prototype.resetRequestCache = function (state) {
        var _this = this;
        this.logger.trace("BrowserCacheManager.resetRequestCache called");
        // check state and remove associated cache items
        if (!StringUtils.isEmpty(state)) {
            this.getKeys().forEach(function (key) {
                if (key.indexOf(state) !== -1) {
                    _this.removeItem(key);
                }
            });
        }
        // delete generic interactive request parameters
        if (state) {
            this.removeItem(this.generateStateKey(state));
            this.removeItem(this.generateNonceKey(state));
            this.removeItem(this.generateAuthorityKey(state));
        }
        this.removeItem(this.generateCacheKey(TemporaryCacheKeys.REQUEST_PARAMS));
        this.removeItem(this.generateCacheKey(TemporaryCacheKeys.ORIGIN_URI));
        this.removeItem(this.generateCacheKey(TemporaryCacheKeys.URL_HASH));
        this.removeItem(this.generateCacheKey(TemporaryCacheKeys.CORRELATION_ID));
        this.removeItem(this.generateCacheKey(TemporaryCacheKeys.CCS_CREDENTIAL));
        this.removeItem(this.generateCacheKey(TemporaryCacheKeys.NATIVE_REQUEST));
        this.setInteractionInProgress(false);
    };
    /**
     * Removes temporary cache for the provided state
     * @param stateString
     */
    BrowserCacheManager.prototype.cleanRequestByState = function (stateString) {
        this.logger.trace("BrowserCacheManager.cleanRequestByState called");
        // Interaction is completed - remove interaction status.
        if (stateString) {
            var stateKey = this.generateStateKey(stateString);
            var cachedState = this.temporaryCacheStorage.getItem(stateKey);
            this.logger.infoPii("BrowserCacheManager.cleanRequestByState: Removing temporary cache items for state: " + cachedState);
            this.resetRequestCache(cachedState || Constants.EMPTY_STRING);
        }
        this.clearMsalCookies();
    };
    /**
     * Looks in temporary cache for any state values with the provided interactionType and removes all temporary cache items for that state
     * Used in scenarios where temp cache needs to be cleaned but state is not known, such as clicking browser back button.
     * @param interactionType
     */
    BrowserCacheManager.prototype.cleanRequestByInteractionType = function (interactionType) {
        var _this = this;
        this.logger.trace("BrowserCacheManager.cleanRequestByInteractionType called");
        // Loop through all keys to find state key
        this.getKeys().forEach(function (key) {
            // If this key is not the state key, move on
            if (key.indexOf(TemporaryCacheKeys.REQUEST_STATE) === -1) {
                return;
            }
            // Retrieve state value, return if not a valid value
            var stateValue = _this.temporaryCacheStorage.getItem(key);
            if (!stateValue) {
                return;
            }
            // Extract state and ensure it matches given InteractionType, then clean request cache
            var parsedState = BrowserProtocolUtils.extractBrowserRequestState(_this.cryptoImpl, stateValue);
            if (parsedState && parsedState.interactionType === interactionType) {
                _this.logger.infoPii("BrowserCacheManager.cleanRequestByInteractionType: Removing temporary cache items for state: " + stateValue);
                _this.resetRequestCache(stateValue);
            }
        });
        this.clearMsalCookies();
        this.setInteractionInProgress(false);
    };
    BrowserCacheManager.prototype.cacheCodeRequest = function (authCodeRequest, browserCrypto) {
        this.logger.trace("BrowserCacheManager.cacheCodeRequest called");
        var encodedValue = browserCrypto.base64Encode(JSON.stringify(authCodeRequest));
        this.setTemporaryCache(TemporaryCacheKeys.REQUEST_PARAMS, encodedValue, true);
    };
    /**
     * Gets the token exchange parameters from the cache. Throws an error if nothing is found.
     */
    BrowserCacheManager.prototype.getCachedRequest = function (state, browserCrypto) {
        this.logger.trace("BrowserCacheManager.getCachedRequest called");
        // Get token request from cache and parse as TokenExchangeParameters.
        var encodedTokenRequest = this.getTemporaryCache(TemporaryCacheKeys.REQUEST_PARAMS, true);
        if (!encodedTokenRequest) {
            throw BrowserAuthError.createNoTokenRequestCacheError();
        }
        var parsedRequest = this.validateAndParseJson(browserCrypto.base64Decode(encodedTokenRequest));
        if (!parsedRequest) {
            throw BrowserAuthError.createUnableToParseTokenRequestCacheError();
        }
        this.removeItem(this.generateCacheKey(TemporaryCacheKeys.REQUEST_PARAMS));
        // Get cached authority and use if no authority is cached with request.
        if (StringUtils.isEmpty(parsedRequest.authority)) {
            var authorityCacheKey = this.generateAuthorityKey(state);
            var cachedAuthority = this.getTemporaryCache(authorityCacheKey);
            if (!cachedAuthority) {
                throw BrowserAuthError.createNoCachedAuthorityError();
            }
            parsedRequest.authority = cachedAuthority;
        }
        return parsedRequest;
    };
    /**
     * Gets cached native request for redirect flows
     */
    BrowserCacheManager.prototype.getCachedNativeRequest = function () {
        this.logger.trace("BrowserCacheManager.getCachedNativeRequest called");
        var cachedRequest = this.getTemporaryCache(TemporaryCacheKeys.NATIVE_REQUEST, true);
        if (!cachedRequest) {
            this.logger.trace("BrowserCacheManager.getCachedNativeRequest: No cached native request found");
            return null;
        }
        var parsedRequest = this.validateAndParseJson(cachedRequest);
        if (!parsedRequest) {
            this.logger.error("BrowserCacheManager.getCachedNativeRequest: Unable to parse native request");
            return null;
        }
        return parsedRequest;
    };
    BrowserCacheManager.prototype.isInteractionInProgress = function (matchClientId) {
        var clientId = this.getInteractionInProgress();
        if (matchClientId) {
            return clientId === this.clientId;
        }
        else {
            return !!clientId;
        }
    };
    BrowserCacheManager.prototype.getInteractionInProgress = function () {
        var key = Constants.CACHE_PREFIX + "." + TemporaryCacheKeys.INTERACTION_STATUS_KEY;
        return this.getTemporaryCache(key, false);
    };
    BrowserCacheManager.prototype.setInteractionInProgress = function (inProgress) {
        // Ensure we don't overwrite interaction in progress for a different clientId
        var key = Constants.CACHE_PREFIX + "." + TemporaryCacheKeys.INTERACTION_STATUS_KEY;
        if (inProgress) {
            if (this.getInteractionInProgress()) {
                throw BrowserAuthError.createInteractionInProgressError();
            }
            else {
                // No interaction is in progress
                this.setTemporaryCache(key, this.clientId, false);
            }
        }
        else if (!inProgress && this.getInteractionInProgress() === this.clientId) {
            this.removeItem(key);
        }
    };
    /**
     * Returns username retrieved from ADAL or MSAL v1 idToken
     */
    BrowserCacheManager.prototype.getLegacyLoginHint = function () {
        // Only check for adal/msal token if no SSO params are being used
        var adalIdTokenString = this.getTemporaryCache(PersistentCacheKeys.ADAL_ID_TOKEN);
        if (adalIdTokenString) {
            this.browserStorage.removeItem(PersistentCacheKeys.ADAL_ID_TOKEN);
            this.logger.verbose("Cached ADAL id token retrieved.");
        }
        // Check for cached MSAL v1 id token
        var msalIdTokenString = this.getTemporaryCache(PersistentCacheKeys.ID_TOKEN, true);
        if (msalIdTokenString) {
            this.removeItem(this.generateCacheKey(PersistentCacheKeys.ID_TOKEN));
            this.logger.verbose("Cached MSAL.js v1 id token retrieved");
        }
        var cachedIdTokenString = msalIdTokenString || adalIdTokenString;
        if (cachedIdTokenString) {
            var cachedIdToken = new AuthToken(cachedIdTokenString, this.cryptoImpl);
            if (cachedIdToken.claims && cachedIdToken.claims.preferred_username) {
                this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, setting ADAL/MSAL v1 preferred_username as loginHint");
                return cachedIdToken.claims.preferred_username;
            }
            else if (cachedIdToken.claims && cachedIdToken.claims.upn) {
                this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, setting ADAL/MSAL v1 upn as loginHint");
                return cachedIdToken.claims.upn;
            }
            else {
                this.logger.verbose("No SSO params used and ADAL/MSAL v1 token retrieved, however, no account hint claim found. Enable preferred_username or upn id token claim to get SSO.");
            }
        }
        return null;
    };
    /**
     * Updates a credential's cache key if the current cache key is outdated
     */
    BrowserCacheManager.prototype.updateCredentialCacheKey = function (currentCacheKey, credential) {
        var updatedCacheKey = credential.generateCredentialKey();
        if (currentCacheKey !== updatedCacheKey) {
            var cacheItem = this.getItem(currentCacheKey);
            if (cacheItem) {
                this.removeItem(currentCacheKey);
                this.setItem(updatedCacheKey, cacheItem);
                this.logger.verbose("Updated an outdated " + credential.credentialType + " cache key");
                return updatedCacheKey;
            }
            else {
                this.logger.error("Attempted to update an outdated " + credential.credentialType + " cache key but no item matching the outdated key was found in storage");
            }
        }
        return currentCacheKey;
    };
    /**
     * Returns application id as redirect context during AcquireTokenRedirect flow.
     */
    BrowserCacheManager.prototype.getRedirectRequestContext = function () {
        return this.getTemporaryCache(TemporaryCacheKeys.REDIRECT_CONTEXT, true);
    };
    /**
     * Sets application id as the redirect context during AcquireTokenRedirect flow.
     * @param value
     */
    BrowserCacheManager.prototype.setRedirectRequestContext = function (value) {
        this.setTemporaryCache(TemporaryCacheKeys.REDIRECT_CONTEXT, value, true);
    };
    return BrowserCacheManager;
}(CacheManager));
var DEFAULT_BROWSER_CACHE_MANAGER = function (clientId, logger) {
    var cacheOptions = {
        cacheLocation: BrowserCacheLocation.MemoryStorage,
        temporaryCacheLocation: BrowserCacheLocation.MemoryStorage,
        storeAuthStateInCookie: false,
        secureCookies: false,
        cacheMigrationEnabled: false,
        claimsBasedCachingEnabled: true
    };
    return new BrowserCacheManager(clientId, cacheOptions, DEFAULT_CRYPTO_IMPLEMENTATION, logger);
};

/*! @azure/msal-browser v2.38.3 2023-10-27 */
/* eslint-disable header/header */
var name = "@azure/msal-browser";
var version = "2.38.3";

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * This class implements the Fetch API for GET and POST requests. See more here: https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API
 */
var FetchClient = /** @class */ (function () {
    function FetchClient() {
    }
    /**
     * Fetch Client for REST endpoints - Get request
     * @param url
     * @param headers
     * @param body
     */
    FetchClient.prototype.sendGetRequestAsync = function (url, options) {
        return __awaiter$3(this, void 0, void 0, function () {
            var response, e_1, _a;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, fetch(url, {
                                method: HTTP_REQUEST_TYPE.GET,
                                headers: this.getFetchHeaders(options)
                            })];
                    case 1:
                        response = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _b.sent();
                        if (window.navigator.onLine) {
                            throw BrowserAuthError.createGetRequestFailedError(e_1, url);
                        }
                        else {
                            throw BrowserAuthError.createNoNetworkConnectivityError();
                        }
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        _a = {
                            headers: this.getHeaderDict(response.headers)
                        };
                        return [4 /*yield*/, response.json()];
                    case 4: return [2 /*return*/, (_a.body = (_b.sent()),
                            _a.status = response.status,
                            _a)];
                    case 5:
                        _b.sent();
                        throw BrowserAuthError.createFailedToParseNetworkResponseError(url);
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Fetch Client for REST endpoints - Post request
     * @param url
     * @param headers
     * @param body
     */
    FetchClient.prototype.sendPostRequestAsync = function (url, options) {
        return __awaiter$3(this, void 0, void 0, function () {
            var reqBody, response, e_3, _a;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        reqBody = (options && options.body) || Constants.EMPTY_STRING;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, fetch(url, {
                                method: HTTP_REQUEST_TYPE.POST,
                                headers: this.getFetchHeaders(options),
                                body: reqBody
                            })];
                    case 2:
                        response = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _b.sent();
                        if (window.navigator.onLine) {
                            throw BrowserAuthError.createPostRequestFailedError(e_3, url);
                        }
                        else {
                            throw BrowserAuthError.createNoNetworkConnectivityError();
                        }
                    case 4:
                        _b.trys.push([4, 6, , 7]);
                        _a = {
                            headers: this.getHeaderDict(response.headers)
                        };
                        return [4 /*yield*/, response.json()];
                    case 5: return [2 /*return*/, (_a.body = (_b.sent()),
                            _a.status = response.status,
                            _a)];
                    case 6:
                        _b.sent();
                        throw BrowserAuthError.createFailedToParseNetworkResponseError(url);
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Fetch API Headers object from string map
     * @param inputHeaders
     */
    FetchClient.prototype.getFetchHeaders = function (options) {
        var headers = new Headers();
        if (!(options && options.headers)) {
            return headers;
        }
        var optionsHeaders = options.headers;
        Object.keys(optionsHeaders).forEach(function (key) {
            headers.append(key, optionsHeaders[key]);
        });
        return headers;
    };
    FetchClient.prototype.getHeaderDict = function (headers) {
        var headerDict = {};
        headers.forEach(function (value, key) {
            headerDict[key] = value;
        });
        return headerDict;
    };
    return FetchClient;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * This client implements the XMLHttpRequest class to send GET and POST requests.
 */
var XhrClient = /** @class */ (function () {
    function XhrClient() {
    }
    /**
     * XhrClient for REST endpoints - Get request
     * @param url
     * @param headers
     * @param body
     */
    XhrClient.prototype.sendGetRequestAsync = function (url, options) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, this.sendRequestAsync(url, HTTP_REQUEST_TYPE.GET, options)];
            });
        });
    };
    /**
     * XhrClient for REST endpoints - Post request
     * @param url
     * @param headers
     * @param body
     */
    XhrClient.prototype.sendPostRequestAsync = function (url, options) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, this.sendRequestAsync(url, HTTP_REQUEST_TYPE.POST, options)];
            });
        });
    };
    /**
     * Helper for XhrClient requests.
     * @param url
     * @param method
     * @param options
     */
    XhrClient.prototype.sendRequestAsync = function (url, method, options) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var xhr = new XMLHttpRequest();
            xhr.open(method, url, /* async: */ true);
            _this.setXhrHeaders(xhr, options);
            xhr.onload = function () {
                if (xhr.status < 200 || xhr.status >= 300) {
                    if (method === HTTP_REQUEST_TYPE.POST) {
                        reject(BrowserAuthError.createPostRequestFailedError("Failed with status " + xhr.status, url));
                    }
                    else {
                        reject(BrowserAuthError.createGetRequestFailedError("Failed with status " + xhr.status, url));
                    }
                }
                try {
                    var jsonResponse = JSON.parse(xhr.responseText);
                    var networkResponse = {
                        headers: _this.getHeaderDict(xhr),
                        body: jsonResponse,
                        status: xhr.status
                    };
                    resolve(networkResponse);
                }
                catch (e) {
                    reject(BrowserAuthError.createFailedToParseNetworkResponseError(url));
                }
            };
            xhr.onerror = function () {
                if (window.navigator.onLine) {
                    if (method === HTTP_REQUEST_TYPE.POST) {
                        reject(BrowserAuthError.createPostRequestFailedError("Failed with status " + xhr.status, url));
                    }
                    else {
                        reject(BrowserAuthError.createGetRequestFailedError("Failed with status " + xhr.status, url));
                    }
                }
                else {
                    reject(BrowserAuthError.createNoNetworkConnectivityError());
                }
            };
            if (method === HTTP_REQUEST_TYPE.POST && options && options.body) {
                xhr.send(options.body);
            }
            else if (method === HTTP_REQUEST_TYPE.GET) {
                xhr.send();
            }
            else {
                throw BrowserAuthError.createHttpMethodNotImplementedError(method);
            }
        });
    };
    /**
     * Helper to set XHR headers for request.
     * @param xhr
     * @param options
     */
    XhrClient.prototype.setXhrHeaders = function (xhr, options) {
        if (options && options.headers) {
            var headers_1 = options.headers;
            Object.keys(headers_1).forEach(function (key) {
                xhr.setRequestHeader(key, headers_1[key]);
            });
        }
    };
    /**
     * Gets a string map of the headers received in the response.
     *
     * Algorithm comes from https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/getAllResponseHeaders
     * @param xhr
     */
    XhrClient.prototype.getHeaderDict = function (xhr) {
        var headerString = xhr.getAllResponseHeaders();
        var headerArr = headerString.trim().split(/[\r\n]+/);
        var headerDict = {};
        headerArr.forEach(function (value) {
            var parts = value.split(": ");
            var headerName = parts.shift();
            var headerVal = parts.join(": ");
            if (headerName && headerVal) {
                headerDict[headerName] = headerVal;
            }
        });
        return headerDict;
    };
    return XhrClient;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Utility class for browser specific functions
 */
var BrowserUtils = /** @class */ (function () {
    function BrowserUtils() {
    }
    // #region Window Navigation and URL management
    /**
     * Clears hash from window url.
     */
    BrowserUtils.clearHash = function (contentWindow) {
        // Office.js sets history.replaceState to null
        contentWindow.location.hash = Constants.EMPTY_STRING;
        if (typeof contentWindow.history.replaceState === "function") {
            // Full removes "#" from url
            contentWindow.history.replaceState(null, Constants.EMPTY_STRING, "" + contentWindow.location.origin + contentWindow.location.pathname + contentWindow.location.search);
        }
    };
    /**
     * Replaces current hash with hash from provided url
     */
    BrowserUtils.replaceHash = function (url) {
        var urlParts = url.split("#");
        urlParts.shift(); // Remove part before the hash
        window.location.hash = urlParts.length > 0 ? urlParts.join("#") : Constants.EMPTY_STRING;
    };
    /**
     * Returns boolean of whether the current window is in an iframe or not.
     */
    BrowserUtils.isInIframe = function () {
        return window.parent !== window;
    };
    /**
     * Returns boolean of whether or not the current window is a popup opened by msal
     */
    BrowserUtils.isInPopup = function () {
        return typeof window !== "undefined" && !!window.opener &&
            window.opener !== window &&
            typeof window.name === "string" &&
            window.name.indexOf(BrowserConstants.POPUP_NAME_PREFIX + ".") === 0;
    };
    // #endregion
    /**
     * Returns current window URL as redirect uri
     */
    BrowserUtils.getCurrentUri = function () {
        return window.location.href.split("?")[0].split("#")[0];
    };
    /**
     * Gets the homepage url for the current window location.
     */
    BrowserUtils.getHomepage = function () {
        var currentUrl = new UrlString(window.location.href);
        var urlComponents = currentUrl.getUrlComponents();
        return urlComponents.Protocol + "//" + urlComponents.HostNameAndPort + "/";
    };
    /**
     * Returns best compatible network client object.
     */
    BrowserUtils.getBrowserNetworkClient = function () {
        if (window.fetch && window.Headers) {
            return new FetchClient();
        }
        else {
            return new XhrClient();
        }
    };
    /**
     * Throws error if we have completed an auth and are
     * attempting another auth request inside an iframe.
     */
    BrowserUtils.blockReloadInHiddenIframes = function () {
        var isResponseHash = UrlString.hashContainsKnownProperties(window.location.hash);
        // return an error if called from the hidden iframe created by the msal js silent calls
        if (isResponseHash && BrowserUtils.isInIframe()) {
            throw BrowserAuthError.createBlockReloadInHiddenIframeError();
        }
    };
    /**
     * Block redirect operations in iframes unless explicitly allowed
     * @param interactionType Interaction type for the request
     * @param allowRedirectInIframe Config value to allow redirects when app is inside an iframe
     */
    BrowserUtils.blockRedirectInIframe = function (interactionType, allowRedirectInIframe) {
        var isIframedApp = BrowserUtils.isInIframe();
        if (interactionType === InteractionType.Redirect && isIframedApp && !allowRedirectInIframe) {
            // If we are not in top frame, we shouldn't redirect. This is also handled by the service.
            throw BrowserAuthError.createRedirectInIframeError(isIframedApp);
        }
    };
    /**
     * Block redirectUri loaded in popup from calling AcquireToken APIs
     */
    BrowserUtils.blockAcquireTokenInPopups = function () {
        // Popups opened by msal popup APIs are given a name that starts with "msal."
        if (BrowserUtils.isInPopup()) {
            throw BrowserAuthError.createBlockAcquireTokenInPopupsError();
        }
    };
    /**
     * Throws error if token requests are made in non-browser environment
     * @param isBrowserEnvironment Flag indicating if environment is a browser.
     */
    BrowserUtils.blockNonBrowserEnvironment = function (isBrowserEnvironment) {
        if (!isBrowserEnvironment) {
            throw BrowserAuthError.createNonBrowserEnvironmentError();
        }
    };
    /**
     * Throws error if native brokering is enabled but initialize hasn't been called
     * @param allowNativeBroker
     * @param initialized
     */
    BrowserUtils.blockNativeBrokerCalledBeforeInitialized = function (allowNativeBroker, initialized) {
        if (allowNativeBroker && !initialized) {
            throw BrowserAuthError.createNativeBrokerCalledBeforeInitialize();
        }
    };
    /**
     * Returns boolean of whether current browser is an Internet Explorer or Edge browser.
     */
    BrowserUtils.detectIEOrEdge = function () {
        var ua = window.navigator.userAgent;
        var msie = ua.indexOf("MSIE ");
        var msie11 = ua.indexOf("Trident/");
        var msedge = ua.indexOf("Edge/");
        var isIE = msie > 0 || msie11 > 0;
        var isEdge = msedge > 0;
        return isIE || isEdge;
    };
    return BrowserUtils;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var BaseInteractionClient = /** @class */ (function () {
    function BaseInteractionClient(config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, performanceClient, nativeMessageHandler, correlationId) {
        this.config = config;
        this.browserStorage = storageImpl;
        this.browserCrypto = browserCrypto;
        this.networkClient = this.config.system.networkClient;
        this.eventHandler = eventHandler;
        this.navigationClient = navigationClient;
        this.nativeMessageHandler = nativeMessageHandler;
        this.correlationId = correlationId || this.browserCrypto.createNewGuid();
        this.logger = logger.clone(BrowserConstants.MSAL_SKU, version, this.correlationId);
        this.performanceClient = performanceClient;
    }
    BaseInteractionClient.prototype.clearCacheOnLogout = function (account) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!account) return [3 /*break*/, 5];
                        if (AccountEntity.accountInfoIsEqual(account, this.browserStorage.getActiveAccount(), false)) {
                            this.logger.verbose("Setting active account to null");
                            this.browserStorage.setActiveAccount(null);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.browserStorage.removeAccount(AccountEntity.generateAccountCacheKey(account))];
                    case 2:
                        _a.sent();
                        this.logger.verbose("Cleared cache items belonging to the account provided in the logout request.");
                        return [3 /*break*/, 4];
                    case 3:
                        _a.sent();
                        this.logger.error("Account provided in logout request was not found. Local cache unchanged.");
                        return [3 /*break*/, 4];
                    case 4: return [3 /*break*/, 9];
                    case 5:
                        _a.trys.push([5, 8, , 9]);
                        this.logger.verbose("No account provided in logout request, clearing all cache items.", this.correlationId);
                        // Clear all accounts and tokens
                        return [4 /*yield*/, this.browserStorage.clear()];
                    case 6:
                        // Clear all accounts and tokens
                        _a.sent();
                        // Clear any stray keys from IndexedDB
                        return [4 /*yield*/, this.browserCrypto.clearKeystore()];
                    case 7:
                        // Clear any stray keys from IndexedDB
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 8:
                        _a.sent();
                        this.logger.error("Attempted to clear all MSAL cache items and failed. Local cache unchanged.");
                        return [3 /*break*/, 9];
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Initializer function for all request APIs
     * @param request
     */
    BaseInteractionClient.prototype.initializeBaseRequest = function (request, account) {
        return __awaiter$3(this, void 0, void 0, function () {
            var authority, scopes, validatedRequest, _a;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.InitializeBaseRequest, request.correlationId);
                        this.logger.verbose("Initializing BaseAuthRequest");
                        authority = request.authority || this.config.auth.authority;
                        if (!account) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.validateRequestAuthority(authority, account)];
                    case 1:
                        _b.sent();
                        _b.label = 2;
                    case 2:
                        scopes = __spread(((request && request.scopes) || []));
                        validatedRequest = __assign$5(__assign$5({}, request), { correlationId: this.correlationId, authority: authority,
                            scopes: scopes });
                        // Set authenticationScheme to BEARER if not explicitly set in the request
                        if (!validatedRequest.authenticationScheme) {
                            validatedRequest.authenticationScheme = AuthenticationScheme.BEARER;
                            this.logger.verbose("Authentication Scheme wasn't explicitly set in request, defaulting to \"Bearer\" request");
                        }
                        else {
                            if (validatedRequest.authenticationScheme === AuthenticationScheme.SSH) {
                                if (!request.sshJwk) {
                                    throw ClientConfigurationError.createMissingSshJwkError();
                                }
                                if (!request.sshKid) {
                                    throw ClientConfigurationError.createMissingSshKidError();
                                }
                            }
                            this.logger.verbose("Authentication Scheme set to \"" + validatedRequest.authenticationScheme + "\" as configured in Auth request");
                        }
                        if (!(this.config.cache.claimsBasedCachingEnabled && request.claims && !StringUtils.isEmptyObj(request.claims))) return [3 /*break*/, 4];
                        _a = validatedRequest;
                        return [4 /*yield*/, this.browserCrypto.hashString(request.claims)];
                    case 3:
                        _a.requestedClaimsHash = _b.sent();
                        _b.label = 4;
                    case 4: return [2 /*return*/, validatedRequest];
                }
            });
        });
    };
    /**
     *
     * Use to get the redirect uri configured in MSAL or null.
     * @param requestRedirectUri
     * @returns Redirect URL
     *
     */
    BaseInteractionClient.prototype.getRedirectUri = function (requestRedirectUri) {
        this.logger.verbose("getRedirectUri called");
        var redirectUri = requestRedirectUri || this.config.auth.redirectUri || BrowserUtils.getCurrentUri();
        return UrlString.getAbsoluteUrl(redirectUri, BrowserUtils.getCurrentUri());
    };
    /*
     * If authority provided in the request does not match environment/authority specified
     * in the account or MSAL config, we throw an error.
     */
    BaseInteractionClient.prototype.validateRequestAuthority = function (authority, account) {
        return __awaiter$3(this, void 0, void 0, function () {
            var discoveredAuthority;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getDiscoveredAuthority(authority)];
                    case 1:
                        discoveredAuthority = _a.sent();
                        if (!discoveredAuthority.isAlias(account.environment)) {
                            throw ClientConfigurationError.createAuthorityMismatchError();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     * @param apiId
     * @param correlationId
     * @param forceRefresh
     */
    BaseInteractionClient.prototype.initializeServerTelemetryManager = function (apiId, forceRefresh) {
        this.logger.verbose("initializeServerTelemetryManager called");
        var telemetryPayload = {
            clientId: this.config.auth.clientId,
            correlationId: this.correlationId,
            apiId: apiId,
            forceRefresh: forceRefresh || false,
            wrapperSKU: this.browserStorage.getWrapperMetadata()[0],
            wrapperVer: this.browserStorage.getWrapperMetadata()[1]
        };
        return new ServerTelemetryManager(telemetryPayload, this.browserStorage);
    };
    /**
     * Used to get a discovered version of the default authority.
     * @param requestAuthority
     * @param requestCorrelationId
     */
    BaseInteractionClient.prototype.getDiscoveredAuthority = function (requestAuthority) {
        return __awaiter$3(this, void 0, void 0, function () {
            var authorityOptions;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose("getDiscoveredAuthority called");
                        authorityOptions = {
                            protocolMode: this.config.auth.protocolMode,
                            knownAuthorities: this.config.auth.knownAuthorities,
                            cloudDiscoveryMetadata: this.config.auth.cloudDiscoveryMetadata,
                            authorityMetadata: this.config.auth.authorityMetadata
                        };
                        if (!requestAuthority) return [3 /*break*/, 2];
                        this.logger.verbose("Creating discovered authority with request authority");
                        return [4 /*yield*/, AuthorityFactory.createDiscoveredInstance(requestAuthority, this.config.system.networkClient, this.browserStorage, authorityOptions, this.logger)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        this.logger.verbose("Creating discovered authority with configured authority");
                        return [4 /*yield*/, AuthorityFactory.createDiscoveredInstance(this.config.auth.authority, this.config.system.networkClient, this.browserStorage, authorityOptions, this.logger)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return BaseInteractionClient;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Defines the class structure and helper functions used by the "standard", non-brokered auth flows (popup, redirect, silent (RT), silent (iframe))
 */
var StandardInteractionClient = /** @class */ (function (_super) {
    __extends$g(StandardInteractionClient, _super);
    function StandardInteractionClient() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Generates an auth code request tied to the url request.
     * @param request
     */
    StandardInteractionClient.prototype.initializeAuthorizationCodeRequest = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var generatedPkceParams, authCodeRequest;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.StandardInteractionClientInitializeAuthorizationCodeRequest, request.correlationId);
                        this.logger.verbose("initializeAuthorizationRequest called", request.correlationId);
                        return [4 /*yield*/, this.browserCrypto.generatePkceCodes()];
                    case 1:
                        generatedPkceParams = _a.sent();
                        authCodeRequest = __assign$5(__assign$5({}, request), { redirectUri: request.redirectUri, code: Constants.EMPTY_STRING, codeVerifier: generatedPkceParams.verifier });
                        request.codeChallenge = generatedPkceParams.challenge;
                        request.codeChallengeMethod = Constants.S256_CODE_CHALLENGE_METHOD;
                        return [2 /*return*/, authCodeRequest];
                }
            });
        });
    };
    /**
     * Initializer for the logout request.
     * @param logoutRequest
     */
    StandardInteractionClient.prototype.initializeLogoutRequest = function (logoutRequest) {
        this.logger.verbose("initializeLogoutRequest called", logoutRequest === null || logoutRequest === void 0 ? void 0 : logoutRequest.correlationId);
        var validLogoutRequest = __assign$5({ correlationId: this.correlationId || this.browserCrypto.createNewGuid() }, logoutRequest);
        /**
         * Set logout_hint to be login_hint from ID Token Claims if present
         * and logoutHint attribute wasn't manually set in logout request
         */
        if (logoutRequest) {
            // If logoutHint isn't set and an account was passed in, try to extract logoutHint from ID Token Claims
            if (!logoutRequest.logoutHint) {
                if (logoutRequest.account) {
                    var logoutHint = this.getLogoutHintFromIdTokenClaims(logoutRequest.account);
                    if (logoutHint) {
                        this.logger.verbose("Setting logoutHint to login_hint ID Token Claim value for the account provided");
                        validLogoutRequest.logoutHint = logoutHint;
                    }
                }
                else {
                    this.logger.verbose("logoutHint was not set and account was not passed into logout request, logoutHint will not be set");
                }
            }
            else {
                this.logger.verbose("logoutHint has already been set in logoutRequest");
            }
        }
        else {
            this.logger.verbose("logoutHint will not be set since no logout request was configured");
        }
        /*
         * Only set redirect uri if logout request isn't provided or the set uri isn't null.
         * Otherwise, use passed uri, config, or current page.
         */
        if (!logoutRequest || logoutRequest.postLogoutRedirectUri !== null) {
            if (logoutRequest && logoutRequest.postLogoutRedirectUri) {
                this.logger.verbose("Setting postLogoutRedirectUri to uri set on logout request", validLogoutRequest.correlationId);
                validLogoutRequest.postLogoutRedirectUri = UrlString.getAbsoluteUrl(logoutRequest.postLogoutRedirectUri, BrowserUtils.getCurrentUri());
            }
            else if (this.config.auth.postLogoutRedirectUri === null) {
                this.logger.verbose("postLogoutRedirectUri configured as null and no uri set on request, not passing post logout redirect", validLogoutRequest.correlationId);
            }
            else if (this.config.auth.postLogoutRedirectUri) {
                this.logger.verbose("Setting postLogoutRedirectUri to configured uri", validLogoutRequest.correlationId);
                validLogoutRequest.postLogoutRedirectUri = UrlString.getAbsoluteUrl(this.config.auth.postLogoutRedirectUri, BrowserUtils.getCurrentUri());
            }
            else {
                this.logger.verbose("Setting postLogoutRedirectUri to current page", validLogoutRequest.correlationId);
                validLogoutRequest.postLogoutRedirectUri = UrlString.getAbsoluteUrl(BrowserUtils.getCurrentUri(), BrowserUtils.getCurrentUri());
            }
        }
        else {
            this.logger.verbose("postLogoutRedirectUri passed as null, not setting post logout redirect uri", validLogoutRequest.correlationId);
        }
        return validLogoutRequest;
    };
    /**
     * Parses login_hint ID Token Claim out of AccountInfo object to be used as
     * logout_hint in end session request.
     * @param account
     */
    StandardInteractionClient.prototype.getLogoutHintFromIdTokenClaims = function (account) {
        var idTokenClaims = account.idTokenClaims;
        if (idTokenClaims) {
            if (idTokenClaims.login_hint) {
                return idTokenClaims.login_hint;
            }
            else {
                this.logger.verbose("The ID Token Claims tied to the provided account do not contain a login_hint claim, logoutHint will not be added to logout request");
            }
        }
        else {
            this.logger.verbose("The provided account does not contain ID Token Claims, logoutHint will not be added to logout request");
        }
        return null;
    };
    /**
     * Creates an Authorization Code Client with the given authority, or the default authority.
     * @param serverTelemetryManager
     * @param authorityUrl
     */
    StandardInteractionClient.prototype.createAuthCodeClient = function (serverTelemetryManager, authorityUrl, requestAzureCloudOptions) {
        return __awaiter$3(this, void 0, void 0, function () {
            var clientConfig;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient, this.correlationId);
                        // Create auth module.
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetClientConfiguration, this.correlationId);
                        return [4 /*yield*/, this.getClientConfiguration(serverTelemetryManager, authorityUrl, requestAzureCloudOptions)];
                    case 1:
                        clientConfig = _a.sent();
                        return [2 /*return*/, new AuthorizationCodeClient(clientConfig, this.performanceClient)];
                }
            });
        });
    };
    /**
     * Creates a Client Configuration object with the given request authority, or the default authority.
     * @param serverTelemetryManager
     * @param requestAuthority
     * @param requestCorrelationId
     */
    StandardInteractionClient.prototype.getClientConfiguration = function (serverTelemetryManager, requestAuthority, requestAzureCloudOptions) {
        return __awaiter$3(this, void 0, void 0, function () {
            var discoveredAuthority, logger;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.StandardInteractionClientGetClientConfiguration, this.correlationId);
                        this.logger.verbose("getClientConfiguration called", this.correlationId);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetDiscoveredAuthority, this.correlationId);
                        return [4 /*yield*/, this.getDiscoveredAuthority(requestAuthority, requestAzureCloudOptions)];
                    case 1:
                        discoveredAuthority = _a.sent();
                        logger = this.config.system.loggerOptions;
                        return [2 /*return*/, {
                                authOptions: {
                                    clientId: this.config.auth.clientId,
                                    authority: discoveredAuthority,
                                    clientCapabilities: this.config.auth.clientCapabilities
                                },
                                systemOptions: {
                                    tokenRenewalOffsetSeconds: this.config.system.tokenRenewalOffsetSeconds,
                                    preventCorsPreflight: true
                                },
                                loggerOptions: {
                                    loggerCallback: logger.loggerCallback,
                                    piiLoggingEnabled: logger.piiLoggingEnabled,
                                    logLevel: logger.logLevel,
                                    correlationId: this.correlationId
                                },
                                cacheOptions: {
                                    claimsBasedCachingEnabled: this.config.cache.claimsBasedCachingEnabled
                                },
                                cryptoInterface: this.browserCrypto,
                                networkInterface: this.networkClient,
                                storageInterface: this.browserStorage,
                                serverTelemetryManager: serverTelemetryManager,
                                libraryInfo: {
                                    sku: BrowserConstants.MSAL_SKU,
                                    version: version,
                                    cpu: Constants.EMPTY_STRING,
                                    os: Constants.EMPTY_STRING
                                },
                                telemetry: this.config.telemetry
                            }];
                }
            });
        });
    };
    /**
     * @param hash
     * @param interactionType
     */
    StandardInteractionClient.prototype.validateAndExtractStateFromHash = function (serverParams, interactionType, requestCorrelationId) {
        this.logger.verbose("validateAndExtractStateFromHash called", requestCorrelationId);
        if (!serverParams.state) {
            throw BrowserAuthError.createHashDoesNotContainStateError();
        }
        var platformStateObj = BrowserProtocolUtils.extractBrowserRequestState(this.browserCrypto, serverParams.state);
        if (!platformStateObj) {
            throw BrowserAuthError.createUnableToParseStateError();
        }
        if (platformStateObj.interactionType !== interactionType) {
            throw BrowserAuthError.createStateInteractionTypeMismatchError();
        }
        this.logger.verbose("Returning state from hash", requestCorrelationId);
        return serverParams.state;
    };
    /**
     * Used to get a discovered version of the default authority.
     * @param requestAuthority
     * @param requestCorrelationId
     */
    StandardInteractionClient.prototype.getDiscoveredAuthority = function (requestAuthority, requestAzureCloudOptions) {
        var _a;
        return __awaiter$3(this, void 0, void 0, function () {
            var getAuthorityMeasurement, authorityOptions, userAuthority, builtAuthority;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.StandardInteractionClientGetDiscoveredAuthority, this.correlationId);
                        this.logger.verbose("getDiscoveredAuthority called", this.correlationId);
                        getAuthorityMeasurement = (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.startMeasurement(PerformanceEvents.StandardInteractionClientGetDiscoveredAuthority, this.correlationId);
                        authorityOptions = {
                            protocolMode: this.config.auth.protocolMode,
                            knownAuthorities: this.config.auth.knownAuthorities,
                            cloudDiscoveryMetadata: this.config.auth.cloudDiscoveryMetadata,
                            authorityMetadata: this.config.auth.authorityMetadata,
                            skipAuthorityMetadataCache: this.config.auth.skipAuthorityMetadataCache
                        };
                        userAuthority = requestAuthority ? requestAuthority : this.config.auth.authority;
                        builtAuthority = Authority.generateAuthority(userAuthority, requestAzureCloudOptions || this.config.auth.azureCloudOptions);
                        this.logger.verbose("Creating discovered authority with configured authority", this.correlationId);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.AuthorityFactoryCreateDiscoveredInstance, this.correlationId);
                        return [4 /*yield*/, AuthorityFactory.createDiscoveredInstance(builtAuthority, this.config.system.networkClient, this.browserStorage, authorityOptions, this.logger, this.performanceClient, this.correlationId)
                                .then(function (result) {
                                getAuthorityMeasurement.endMeasurement({
                                    success: true,
                                });
                                return result;
                            })
                                .catch(function (error) {
                                getAuthorityMeasurement.endMeasurement({
                                    errorCode: error.errorCode,
                                    subErrorCode: error.subError,
                                    success: false
                                });
                                throw error;
                            })];
                    case 1: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    /**
     * Helper to initialize required request parameters for interactive APIs and ssoSilent()
     * @param request
     * @param interactionType
     */
    StandardInteractionClient.prototype.initializeAuthorizationRequest = function (request, interactionType) {
        return __awaiter$3(this, void 0, void 0, function () {
            var redirectUri, browserState, state, validatedRequest, _a, account, legacyLoginHint;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest, this.correlationId);
                        this.logger.verbose("initializeAuthorizationRequest called", this.correlationId);
                        redirectUri = this.getRedirectUri(request.redirectUri);
                        browserState = {
                            interactionType: interactionType
                        };
                        state = ProtocolUtils.setRequestState(this.browserCrypto, (request && request.state) || Constants.EMPTY_STRING, browserState);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.InitializeBaseRequest, this.correlationId);
                        _a = [{}];
                        return [4 /*yield*/, this.initializeBaseRequest(request)];
                    case 1:
                        validatedRequest = __assign$5.apply(void 0, [__assign$5.apply(void 0, _a.concat([_b.sent()])), { redirectUri: redirectUri, state: state, nonce: request.nonce || this.browserCrypto.createNewGuid(), responseMode: ResponseMode.FRAGMENT }]);
                        account = request.account || this.browserStorage.getActiveAccount();
                        if (account) {
                            this.logger.verbose("Setting validated request account", this.correlationId);
                            this.logger.verbosePii("Setting validated request account: " + account.homeAccountId, this.correlationId);
                            validatedRequest.account = account;
                        }
                        // Check for ADAL/MSAL v1 SSO
                        if (StringUtils.isEmpty(validatedRequest.loginHint) && !account) {
                            legacyLoginHint = this.browserStorage.getLegacyLoginHint();
                            if (legacyLoginHint) {
                                validatedRequest.loginHint = legacyLoginHint;
                            }
                        }
                        return [2 /*return*/, validatedRequest];
                }
            });
        });
    };
    return StandardInteractionClient;
}(BaseInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Abstract class which defines operations for a browser interaction handling class.
 */
var InteractionHandler = /** @class */ (function () {
    function InteractionHandler(authCodeModule, storageImpl, authCodeRequest, logger, performanceClient) {
        this.authModule = authCodeModule;
        this.browserStorage = storageImpl;
        this.authCodeRequest = authCodeRequest;
        this.logger = logger;
        this.performanceClient = performanceClient;
    }
    /**
     * Function to handle response parameters from hash.
     * @param locationHash
     */
    InteractionHandler.prototype.handleCodeResponseFromHash = function (locationHash, state, authority, networkModule) {
        return __awaiter$3(this, void 0, void 0, function () {
            var stateKey, requestState, authCodeResponse;
            return __generator$3(this, function (_a) {
                this.performanceClient.addQueueMeasurement(PerformanceEvents.HandleCodeResponseFromHash, this.authCodeRequest.correlationId);
                this.logger.verbose("InteractionHandler.handleCodeResponse called");
                // Check that location hash isn't empty.
                if (StringUtils.isEmpty(locationHash)) {
                    throw BrowserAuthError.createEmptyHashError(locationHash);
                }
                stateKey = this.browserStorage.generateStateKey(state);
                requestState = this.browserStorage.getTemporaryCache(stateKey);
                if (!requestState) {
                    throw ClientAuthError.createStateNotFoundError("Cached State");
                }
                try {
                    authCodeResponse = this.authModule.handleFragmentResponse(locationHash, requestState);
                }
                catch (e) {
                    if (e instanceof ServerError && e.subError === BrowserAuthErrorMessage.userCancelledError.code) {
                        // Translate server error caused by user closing native prompt to corresponding first class MSAL error
                        throw BrowserAuthError.createUserCancelledError();
                    }
                    else {
                        throw e;
                    }
                }
                this.performanceClient.setPreQueueTime(PerformanceEvents.HandleCodeResponseFromServer, this.authCodeRequest.correlationId);
                return [2 /*return*/, this.handleCodeResponseFromServer(authCodeResponse, state, authority, networkModule)];
            });
        });
    };
    /**
     * Process auth code response from AAD
     * @param authCodeResponse
     * @param state
     * @param authority
     * @param networkModule
     * @returns
     */
    InteractionHandler.prototype.handleCodeResponseFromServer = function (authCodeResponse, state, authority, networkModule, validateNonce) {
        if (validateNonce === void 0) { validateNonce = true; }
        return __awaiter$3(this, void 0, void 0, function () {
            var stateKey, requestState, nonceKey, cachedNonce, cachedCcsCred, tokenResponse;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.HandleCodeResponseFromServer, this.authCodeRequest.correlationId);
                        this.logger.trace("InteractionHandler.handleCodeResponseFromServer called");
                        stateKey = this.browserStorage.generateStateKey(state);
                        requestState = this.browserStorage.getTemporaryCache(stateKey);
                        if (!requestState) {
                            throw ClientAuthError.createStateNotFoundError("Cached State");
                        }
                        nonceKey = this.browserStorage.generateNonceKey(requestState);
                        cachedNonce = this.browserStorage.getTemporaryCache(nonceKey);
                        // Assign code to request
                        this.authCodeRequest.code = authCodeResponse.code;
                        if (!authCodeResponse.cloud_instance_host_name) return [3 /*break*/, 2];
                        this.performanceClient.setPreQueueTime(PerformanceEvents.UpdateTokenEndpointAuthority, this.authCodeRequest.correlationId);
                        return [4 /*yield*/, this.updateTokenEndpointAuthority(authCodeResponse.cloud_instance_host_name, authority, networkModule)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        // Nonce validation not needed when redirect not involved (e.g. hybrid spa, renewing token via rt)
                        if (validateNonce) {
                            authCodeResponse.nonce = cachedNonce || undefined;
                        }
                        authCodeResponse.state = requestState;
                        // Add CCS parameters if available
                        if (authCodeResponse.client_info) {
                            this.authCodeRequest.clientInfo = authCodeResponse.client_info;
                        }
                        else {
                            cachedCcsCred = this.checkCcsCredentials();
                            if (cachedCcsCred) {
                                this.authCodeRequest.ccsCredential = cachedCcsCred;
                            }
                        }
                        // Acquire token with retrieved code.
                        this.performanceClient.setPreQueueTime(PerformanceEvents.AuthClientAcquireToken, this.authCodeRequest.correlationId);
                        return [4 /*yield*/, this.authModule.acquireToken(this.authCodeRequest, authCodeResponse)];
                    case 3:
                        tokenResponse = _a.sent();
                        this.browserStorage.cleanRequestByState(state);
                        return [2 /*return*/, tokenResponse];
                }
            });
        });
    };
    /**
     * Updates authority based on cloudInstanceHostname
     * @param cloudInstanceHostname
     * @param authority
     * @param networkModule
     */
    InteractionHandler.prototype.updateTokenEndpointAuthority = function (cloudInstanceHostname, authority, networkModule) {
        return __awaiter$3(this, void 0, void 0, function () {
            var cloudInstanceAuthorityUri, cloudInstanceAuthority;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.UpdateTokenEndpointAuthority, this.authCodeRequest.correlationId);
                        cloudInstanceAuthorityUri = "https://" + cloudInstanceHostname + "/" + authority.tenant + "/";
                        return [4 /*yield*/, AuthorityFactory.createDiscoveredInstance(cloudInstanceAuthorityUri, networkModule, this.browserStorage, authority.options, this.logger, this.performanceClient, this.authCodeRequest.correlationId)];
                    case 1:
                        cloudInstanceAuthority = _a.sent();
                        this.authModule.updateAuthority(cloudInstanceAuthority);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Looks up ccs creds in the cache
     */
    InteractionHandler.prototype.checkCcsCredentials = function () {
        // Look up ccs credential in temp cache
        var cachedCcsCred = this.browserStorage.getTemporaryCache(TemporaryCacheKeys.CCS_CREDENTIAL, true);
        if (cachedCcsCred) {
            try {
                return JSON.parse(cachedCcsCred);
            }
            catch (e) {
                this.authModule.logger.error("Cache credential could not be parsed");
                this.authModule.logger.errorPii("Cache credential could not be parsed: " + cachedCcsCred);
            }
        }
        return null;
    };
    return InteractionHandler;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var RedirectHandler = /** @class */ (function (_super) {
    __extends$g(RedirectHandler, _super);
    function RedirectHandler(authCodeModule, storageImpl, authCodeRequest, logger, browserCrypto, performanceClient) {
        var _this = _super.call(this, authCodeModule, storageImpl, authCodeRequest, logger, performanceClient) || this;
        _this.browserCrypto = browserCrypto;
        return _this;
    }
    /**
     * Redirects window to given URL.
     * @param urlNavigate
     */
    RedirectHandler.prototype.initiateAuthRequest = function (requestUrl, params) {
        return __awaiter$3(this, void 0, void 0, function () {
            var navigationOptions, navigate;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose("RedirectHandler.initiateAuthRequest called");
                        if (!!StringUtils.isEmpty(requestUrl)) return [3 /*break*/, 7];
                        // Cache start page, returns to this page after redirectUri if navigateToLoginRequestUrl is true
                        if (params.redirectStartPage) {
                            this.logger.verbose("RedirectHandler.initiateAuthRequest: redirectStartPage set, caching start page");
                            this.browserStorage.setTemporaryCache(TemporaryCacheKeys.ORIGIN_URI, params.redirectStartPage, true);
                        }
                        // Set interaction status in the library.
                        this.browserStorage.setTemporaryCache(TemporaryCacheKeys.CORRELATION_ID, this.authCodeRequest.correlationId, true);
                        this.browserStorage.cacheCodeRequest(this.authCodeRequest, this.browserCrypto);
                        this.logger.infoPii("RedirectHandler.initiateAuthRequest: Navigate to: " + requestUrl);
                        navigationOptions = {
                            apiId: ApiId.acquireTokenRedirect,
                            timeout: params.redirectTimeout,
                            noHistory: false
                        };
                        if (!(typeof params.onRedirectNavigate === "function")) return [3 /*break*/, 4];
                        this.logger.verbose("RedirectHandler.initiateAuthRequest: Invoking onRedirectNavigate callback");
                        navigate = params.onRedirectNavigate(requestUrl);
                        if (!(navigate !== false)) return [3 /*break*/, 2];
                        this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate did not return false, navigating");
                        return [4 /*yield*/, params.navigationClient.navigateExternal(requestUrl, navigationOptions)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                    case 2:
                        this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate returned false, stopping navigation");
                        return [2 /*return*/];
                    case 3: return [3 /*break*/, 6];
                    case 4:
                        // Navigate window to request URL
                        this.logger.verbose("RedirectHandler.initiateAuthRequest: Navigating window to navigate url");
                        return [4 /*yield*/, params.navigationClient.navigateExternal(requestUrl, navigationOptions)];
                    case 5:
                        _a.sent();
                        return [2 /*return*/];
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        // Throw error if request URL is empty.
                        this.logger.info("RedirectHandler.initiateAuthRequest: Navigate url is empty");
                        throw BrowserAuthError.createEmptyNavigationUriError();
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Handle authorization code response in the window.
     * @param hash
     */
    RedirectHandler.prototype.handleCodeResponseFromHash = function (locationHash, state, authority, networkModule) {
        return __awaiter$3(this, void 0, void 0, function () {
            var stateKey, requestState, authCodeResponse, nonceKey, cachedNonce, cachedCcsCred, tokenResponse;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose("RedirectHandler.handleCodeResponse called");
                        // Check that location hash isn't empty.
                        if (StringUtils.isEmpty(locationHash)) {
                            throw BrowserAuthError.createEmptyHashError(locationHash);
                        }
                        // Interaction is completed - remove interaction status.
                        this.browserStorage.setInteractionInProgress(false);
                        stateKey = this.browserStorage.generateStateKey(state);
                        requestState = this.browserStorage.getTemporaryCache(stateKey);
                        if (!requestState) {
                            throw ClientAuthError.createStateNotFoundError("Cached State");
                        }
                        try {
                            authCodeResponse = this.authModule.handleFragmentResponse(locationHash, requestState);
                        }
                        catch (e) {
                            if (e instanceof ServerError && e.subError === BrowserAuthErrorMessage.userCancelledError.code) {
                                // Translate server error caused by user closing native prompt to corresponding first class MSAL error
                                throw BrowserAuthError.createUserCancelledError();
                            }
                            else {
                                throw e;
                            }
                        }
                        nonceKey = this.browserStorage.generateNonceKey(requestState);
                        cachedNonce = this.browserStorage.getTemporaryCache(nonceKey);
                        // Assign code to request
                        this.authCodeRequest.code = authCodeResponse.code;
                        if (!authCodeResponse.cloud_instance_host_name) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.updateTokenEndpointAuthority(authCodeResponse.cloud_instance_host_name, authority, networkModule)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        authCodeResponse.nonce = cachedNonce || undefined;
                        authCodeResponse.state = requestState;
                        // Add CCS parameters if available
                        if (authCodeResponse.client_info) {
                            this.authCodeRequest.clientInfo = authCodeResponse.client_info;
                        }
                        else {
                            cachedCcsCred = this.checkCcsCredentials();
                            if (cachedCcsCred) {
                                this.authCodeRequest.ccsCredential = cachedCcsCred;
                            }
                        }
                        return [4 /*yield*/, this.authModule.acquireToken(this.authCodeRequest, authCodeResponse)];
                    case 3:
                        tokenResponse = _a.sent();
                        this.browserStorage.cleanRequestByState(state);
                        return [2 /*return*/, tokenResponse];
                }
            });
        });
    };
    return RedirectHandler;
}(InteractionHandler));

/*! @azure/msal-browser v2.38.3 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var EventType;
(function (EventType) {
    EventType["INITIALIZE_START"] = "msal:initializeStart";
    EventType["INITIALIZE_END"] = "msal:initializeEnd";
    EventType["ACCOUNT_ADDED"] = "msal:accountAdded";
    EventType["ACCOUNT_REMOVED"] = "msal:accountRemoved";
    EventType["LOGIN_START"] = "msal:loginStart";
    EventType["LOGIN_SUCCESS"] = "msal:loginSuccess";
    EventType["LOGIN_FAILURE"] = "msal:loginFailure";
    EventType["ACQUIRE_TOKEN_START"] = "msal:acquireTokenStart";
    EventType["ACQUIRE_TOKEN_SUCCESS"] = "msal:acquireTokenSuccess";
    EventType["ACQUIRE_TOKEN_FAILURE"] = "msal:acquireTokenFailure";
    EventType["ACQUIRE_TOKEN_NETWORK_START"] = "msal:acquireTokenFromNetworkStart";
    EventType["SSO_SILENT_START"] = "msal:ssoSilentStart";
    EventType["SSO_SILENT_SUCCESS"] = "msal:ssoSilentSuccess";
    EventType["SSO_SILENT_FAILURE"] = "msal:ssoSilentFailure";
    EventType["ACQUIRE_TOKEN_BY_CODE_START"] = "msal:acquireTokenByCodeStart";
    EventType["ACQUIRE_TOKEN_BY_CODE_SUCCESS"] = "msal:acquireTokenByCodeSuccess";
    EventType["ACQUIRE_TOKEN_BY_CODE_FAILURE"] = "msal:acquireTokenByCodeFailure";
    EventType["HANDLE_REDIRECT_START"] = "msal:handleRedirectStart";
    EventType["HANDLE_REDIRECT_END"] = "msal:handleRedirectEnd";
    EventType["POPUP_OPENED"] = "msal:popupOpened";
    EventType["LOGOUT_START"] = "msal:logoutStart";
    EventType["LOGOUT_SUCCESS"] = "msal:logoutSuccess";
    EventType["LOGOUT_FAILURE"] = "msal:logoutFailure";
    EventType["LOGOUT_END"] = "msal:logoutEnd";
    EventType["RESTORE_FROM_BFCACHE"] = "msal:restoreFromBFCache";
})(EventType || (EventType = {}));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var NativeStatusCode;
(function (NativeStatusCode) {
    NativeStatusCode["USER_INTERACTION_REQUIRED"] = "USER_INTERACTION_REQUIRED";
    NativeStatusCode["USER_CANCEL"] = "USER_CANCEL";
    NativeStatusCode["NO_NETWORK"] = "NO_NETWORK";
    NativeStatusCode["TRANSIENT_ERROR"] = "TRANSIENT_ERROR";
    NativeStatusCode["PERSISTENT_ERROR"] = "PERSISTENT_ERROR";
    NativeStatusCode["DISABLED"] = "DISABLED";
    NativeStatusCode["ACCOUNT_UNAVAILABLE"] = "ACCOUNT_UNAVAILABLE";
})(NativeStatusCode || (NativeStatusCode = {}));
var NativeAuthErrorMessage = {
    extensionError: {
        code: "ContentError"
    },
    userSwitch: {
        code: "user_switch",
        desc: "User attempted to switch accounts in the native broker, which is not allowed. All new accounts must sign-in through the standard web flow first, please try again."
    },
    tokensNotFoundInCache: {
        code: "tokens_not_found_in_internal_memory_cache",
        desc: "Tokens not cached in MSAL JS internal memory, please make the WAM request"
    }
};
var NativeAuthError = /** @class */ (function (_super) {
    __extends$g(NativeAuthError, _super);
    function NativeAuthError(errorCode, description, ext) {
        var _this = _super.call(this, errorCode, description) || this;
        Object.setPrototypeOf(_this, NativeAuthError.prototype);
        _this.name = "NativeAuthError";
        _this.ext = ext;
        return _this;
    }
    /**
     * These errors should result in a fallback to the 'standard' browser based auth flow.
     */
    NativeAuthError.prototype.isFatal = function () {
        if (this.ext && this.ext.status && (this.ext.status === NativeStatusCode.PERSISTENT_ERROR || this.ext.status === NativeStatusCode.DISABLED)) {
            return true;
        }
        switch (this.errorCode) {
            case NativeAuthErrorMessage.extensionError.code:
                return true;
            default:
                return false;
        }
    };
    /**
     * Create the appropriate error object based on the WAM status code.
     * @param code
     * @param description
     * @param ext
     * @returns
     */
    NativeAuthError.createError = function (code, description, ext) {
        if (ext && ext.status) {
            switch (ext.status) {
                case NativeStatusCode.ACCOUNT_UNAVAILABLE:
                    return InteractionRequiredAuthError.createNativeAccountUnavailableError();
                case NativeStatusCode.USER_INTERACTION_REQUIRED:
                    return new InteractionRequiredAuthError(code, description);
                case NativeStatusCode.USER_CANCEL:
                    return BrowserAuthError.createUserCancelledError();
                case NativeStatusCode.NO_NETWORK:
                    return BrowserAuthError.createNoNetworkConnectivityError();
            }
        }
        return new NativeAuthError(code, description, ext);
    };
    /**
     * Creates user switch error when the user chooses a different account in the native broker prompt
     * @returns
     */
    NativeAuthError.createUserSwitchError = function () {
        return new NativeAuthError(NativeAuthErrorMessage.userSwitch.code, NativeAuthErrorMessage.userSwitch.desc);
    };
    /**
     * Creates a tokens not found error when the internal cache look up fails
     * @returns NativeAuthError: tokensNotFoundInCache
     */
    NativeAuthError.createTokensNotFoundInCacheError = function () {
        return new NativeAuthError(NativeAuthErrorMessage.tokensNotFoundInCache.code, NativeAuthErrorMessage.tokensNotFoundInCache.desc);
    };
    return NativeAuthError;
}(AuthError));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var SilentCacheClient = /** @class */ (function (_super) {
    __extends$g(SilentCacheClient, _super);
    function SilentCacheClient() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Returns unexpired tokens from the cache, if available
     * @param silentRequest
     */
    SilentCacheClient.prototype.acquireToken = function (silentRequest) {
        return __awaiter$3(this, void 0, void 0, function () {
            var acquireTokenMeasurement, serverTelemetryManager, silentAuthClient, cachedToken, error_1;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        acquireTokenMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.SilentCacheClientAcquireToken, silentRequest.correlationId);
                        serverTelemetryManager = this.initializeServerTelemetryManager(ApiId.acquireTokenSilent_silentFlow);
                        return [4 /*yield*/, this.createSilentFlowClient(serverTelemetryManager, silentRequest.authority, silentRequest.azureCloudOptions)];
                    case 1:
                        silentAuthClient = _a.sent();
                        this.logger.verbose("Silent auth client created");
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, silentAuthClient.acquireCachedToken(silentRequest)];
                    case 3:
                        cachedToken = _a.sent();
                        acquireTokenMeasurement.endMeasurement({
                            success: true,
                            fromCache: true
                        });
                        return [2 /*return*/, cachedToken];
                    case 4:
                        error_1 = _a.sent();
                        if (error_1 instanceof BrowserAuthError && error_1.errorCode === BrowserAuthErrorMessage.signingKeyNotFoundInStorage.code) {
                            this.logger.verbose("Signing keypair for bound access token not found. Refreshing bound access token and generating a new crypto keypair.");
                        }
                        acquireTokenMeasurement.endMeasurement({
                            errorCode: error_1 instanceof AuthError && error_1.errorCode || undefined,
                            subErrorCode: error_1 instanceof AuthError && error_1.subError || undefined,
                            success: false
                        });
                        throw error_1;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Currently Unsupported
     */
    SilentCacheClient.prototype.logout = function () {
        // Synchronous so we must reject
        return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError());
    };
    /**
     * Creates an Silent Flow Client with the given authority, or the default authority.
     * @param serverTelemetryManager
     * @param authorityUrl
     */
    SilentCacheClient.prototype.createSilentFlowClient = function (serverTelemetryManager, authorityUrl, azureCloudOptions) {
        return __awaiter$3(this, void 0, void 0, function () {
            var clientConfig;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Create auth module.
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetClientConfiguration, this.correlationId);
                        return [4 /*yield*/, this.getClientConfiguration(serverTelemetryManager, authorityUrl, azureCloudOptions)];
                    case 1:
                        clientConfig = _a.sent();
                        return [2 /*return*/, new SilentFlowClient(clientConfig, this.performanceClient)];
                }
            });
        });
    };
    SilentCacheClient.prototype.initializeSilentRequest = function (request, account) {
        return __awaiter$3(this, void 0, void 0, function () {
            var _a;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.InitializeSilentRequest, this.correlationId);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.InitializeBaseRequest, this.correlationId);
                        _a = [__assign$5({}, request)];
                        return [4 /*yield*/, this.initializeBaseRequest(request, account)];
                    case 1: return [2 /*return*/, __assign$5.apply(void 0, [__assign$5.apply(void 0, _a.concat([_b.sent()])), { account: account, forceRefresh: request.forceRefresh || false }])];
                }
            });
        });
    };
    return SilentCacheClient;
}(StandardInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var NativeInteractionClient = /** @class */ (function (_super) {
    __extends$g(NativeInteractionClient, _super);
    function NativeInteractionClient(config, browserStorage, browserCrypto, logger, eventHandler, navigationClient, apiId, performanceClient, provider, accountId, nativeStorageImpl, correlationId) {
        var _this = _super.call(this, config, browserStorage, browserCrypto, logger, eventHandler, navigationClient, performanceClient, provider, correlationId) || this;
        _this.apiId = apiId;
        _this.accountId = accountId;
        _this.nativeMessageHandler = provider;
        _this.nativeStorageManager = nativeStorageImpl;
        _this.silentCacheClient = new SilentCacheClient(config, _this.nativeStorageManager, browserCrypto, logger, eventHandler, navigationClient, performanceClient, provider, correlationId);
        return _this;
    }
    /**
     * Acquire token from native platform via browser extension
     * @param request
     */
    NativeInteractionClient.prototype.acquireToken = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var nativeATMeasurement, reqTimestamp, nativeRequest, result, messageBody, response, validatedResponse;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.trace("NativeInteractionClient - acquireToken called.");
                        nativeATMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.NativeInteractionClientAcquireToken, request.correlationId);
                        reqTimestamp = TimeUtils.nowSeconds();
                        return [4 /*yield*/, this.initializeNativeRequest(request)];
                    case 1:
                        nativeRequest = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.acquireTokensFromCache(this.accountId, nativeRequest)];
                    case 3:
                        result = _a.sent();
                        nativeATMeasurement.endMeasurement({
                            success: true,
                            isNativeBroker: false,
                            fromCache: true
                        });
                        return [2 /*return*/, result];
                    case 4:
                        _a.sent();
                        // continue with a native call for any and all errors
                        this.logger.info("MSAL internal Cache does not contain tokens, proceed to make a native call");
                        return [3 /*break*/, 5];
                    case 5:
                        messageBody = {
                            method: NativeExtensionMethod.GetToken,
                            request: nativeRequest
                        };
                        return [4 /*yield*/, this.nativeMessageHandler.sendMessage(messageBody)];
                    case 6:
                        response = _a.sent();
                        validatedResponse = this.validateNativeResponse(response);
                        return [2 /*return*/, this.handleNativeResponse(validatedResponse, nativeRequest, reqTimestamp)
                                .then(function (result) {
                                nativeATMeasurement.endMeasurement({
                                    success: true,
                                    isNativeBroker: true,
                                    requestId: result.requestId
                                });
                                return result;
                            })
                                .catch(function (error) {
                                nativeATMeasurement.endMeasurement({
                                    success: false,
                                    errorCode: error.errorCode,
                                    subErrorCode: error.subError,
                                    isNativeBroker: true
                                });
                                throw error;
                            })];
                }
            });
        });
    };
    /**
     * Creates silent flow request
     * @param request
     * @param cachedAccount
     * @returns CommonSilentFlowRequest
     */
    NativeInteractionClient.prototype.createSilentCacheRequest = function (request, cachedAccount) {
        return {
            authority: request.authority,
            correlationId: this.correlationId,
            scopes: ScopeSet.fromString(request.scope).asArray(),
            account: cachedAccount,
            forceRefresh: false,
        };
    };
    /**
     * Fetches the tokens from the cache if un-expired
     * @param nativeAccountId
     * @param request
     * @returns authenticationResult
     */
    NativeInteractionClient.prototype.acquireTokensFromCache = function (nativeAccountId, request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var account, silentRequest, result, e_2;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!nativeAccountId) {
                            this.logger.warning("NativeInteractionClient:acquireTokensFromCache - No nativeAccountId provided");
                            throw ClientAuthError.createNoAccountFoundError();
                        }
                        account = this.browserStorage.getAccountInfoFilteredBy({ nativeAccountId: nativeAccountId });
                        if (!account) {
                            throw ClientAuthError.createNoAccountFoundError();
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        silentRequest = this.createSilentCacheRequest(request, account);
                        return [4 /*yield*/, this.silentCacheClient.acquireToken(silentRequest)];
                    case 2:
                        result = _a.sent();
                        return [2 /*return*/, result];
                    case 3:
                        e_2 = _a.sent();
                        throw e_2;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Acquires a token from native platform then redirects to the redirectUri instead of returning the response
     * @param request
     */
    NativeInteractionClient.prototype.acquireTokenRedirect = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var nativeRequest, messageBody, response, e_3, navigationOptions, redirectUri;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.trace("NativeInteractionClient - acquireTokenRedirect called.");
                        return [4 /*yield*/, this.initializeNativeRequest(request)];
                    case 1:
                        nativeRequest = _a.sent();
                        messageBody = {
                            method: NativeExtensionMethod.GetToken,
                            request: nativeRequest
                        };
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.nativeMessageHandler.sendMessage(messageBody)];
                    case 3:
                        response = _a.sent();
                        this.validateNativeResponse(response);
                        return [3 /*break*/, 5];
                    case 4:
                        e_3 = _a.sent();
                        // Only throw fatal errors here to allow application to fallback to regular redirect. Otherwise proceed and the error will be thrown in handleRedirectPromise
                        if (e_3 instanceof NativeAuthError && e_3.isFatal()) {
                            throw e_3;
                        }
                        return [3 /*break*/, 5];
                    case 5:
                        this.browserStorage.setTemporaryCache(TemporaryCacheKeys.NATIVE_REQUEST, JSON.stringify(nativeRequest), true);
                        navigationOptions = {
                            apiId: ApiId.acquireTokenRedirect,
                            timeout: this.config.system.redirectNavigationTimeout,
                            noHistory: false
                        };
                        redirectUri = this.config.auth.navigateToLoginRequestUrl ? window.location.href : this.getRedirectUri(request.redirectUri);
                        return [4 /*yield*/, this.navigationClient.navigateExternal(redirectUri, navigationOptions)];
                    case 6:
                        _a.sent(); // Need to treat this as external to ensure handleRedirectPromise is run again
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * If the previous page called native platform for a token using redirect APIs, send the same request again and return the response
     */
    NativeInteractionClient.prototype.handleRedirectPromise = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var cachedRequest, prompt, request, messageBody, reqTimestamp, response, result, e_4;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.trace("NativeInteractionClient - handleRedirectPromise called.");
                        if (!this.browserStorage.isInteractionInProgress(true)) {
                            this.logger.info("handleRedirectPromise called but there is no interaction in progress, returning null.");
                            return [2 /*return*/, null];
                        }
                        cachedRequest = this.browserStorage.getCachedNativeRequest();
                        if (!cachedRequest) {
                            this.logger.verbose("NativeInteractionClient - handleRedirectPromise called but there is no cached request, returning null.");
                            return [2 /*return*/, null];
                        }
                        prompt = cachedRequest.prompt, request = __rest(cachedRequest, ["prompt"]);
                        if (prompt) {
                            this.logger.verbose("NativeInteractionClient - handleRedirectPromise called and prompt was included in the original request, removing prompt from cached request to prevent second interaction with native broker window.");
                        }
                        this.browserStorage.removeItem(this.browserStorage.generateCacheKey(TemporaryCacheKeys.NATIVE_REQUEST));
                        messageBody = {
                            method: NativeExtensionMethod.GetToken,
                            request: request
                        };
                        reqTimestamp = TimeUtils.nowSeconds();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        this.logger.verbose("NativeInteractionClient - handleRedirectPromise sending message to native broker.");
                        return [4 /*yield*/, this.nativeMessageHandler.sendMessage(messageBody)];
                    case 2:
                        response = _a.sent();
                        this.validateNativeResponse(response);
                        result = this.handleNativeResponse(response, request, reqTimestamp);
                        this.browserStorage.setInteractionInProgress(false);
                        return [2 /*return*/, result];
                    case 3:
                        e_4 = _a.sent();
                        this.browserStorage.setInteractionInProgress(false);
                        throw e_4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Logout from native platform via browser extension
     * @param request
     */
    NativeInteractionClient.prototype.logout = function () {
        this.logger.trace("NativeInteractionClient - logout called.");
        return Promise.reject("Logout not implemented yet");
    };
    /**
     * Transform response from native platform into AuthenticationResult object which will be returned to the end user
     * @param response
     * @param request
     * @param reqTimestamp
     */
    NativeInteractionClient.prototype.handleNativeResponse = function (response, request, reqTimestamp) {
        return __awaiter$3(this, void 0, void 0, function () {
            var authority, authorityPreferredCache, idTokenObj, homeAccountIdentifier, accountEntity, result;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.trace("NativeInteractionClient - handleNativeResponse called.");
                        if (response.account.id !== request.accountId) {
                            // User switch in native broker prompt is not supported. All users must first sign in through web flow to ensure server state is in sync
                            throw NativeAuthError.createUserSwitchError();
                        }
                        return [4 /*yield*/, this.getDiscoveredAuthority(request.authority)];
                    case 1:
                        authority = _a.sent();
                        authorityPreferredCache = authority.getPreferredCache();
                        idTokenObj = this.createIdTokenObj(response);
                        homeAccountIdentifier = this.createHomeAccountIdentifier(response, idTokenObj);
                        accountEntity = this.createAccountEntity(response, homeAccountIdentifier, idTokenObj, authorityPreferredCache);
                        return [4 /*yield*/, this.generateAuthenticationResult(response, request, idTokenObj, accountEntity, authority.canonicalAuthority, reqTimestamp)];
                    case 2:
                        result = _a.sent();
                        // cache accounts and tokens in the appropriate storage
                        this.cacheAccount(accountEntity);
                        this.cacheNativeTokens(response, request, homeAccountIdentifier, accountEntity, idTokenObj, result.accessToken, result.tenantId, reqTimestamp);
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * Create an idToken Object (not entity)
     * @param response
     * @returns
     */
    NativeInteractionClient.prototype.createIdTokenObj = function (response) {
        return new AuthToken(response.id_token || Constants.EMPTY_STRING, this.browserCrypto);
    };
    /**
     * creates an homeAccountIdentifier for the account
     * @param response
     * @param idTokenObj
     * @returns
     */
    NativeInteractionClient.prototype.createHomeAccountIdentifier = function (response, idTokenObj) {
        // Save account in browser storage
        var homeAccountIdentifier = AccountEntity.generateHomeAccountId(response.client_info || Constants.EMPTY_STRING, AuthorityType.Default, this.logger, this.browserCrypto, idTokenObj);
        return homeAccountIdentifier;
    };
    /**
     * Creates account entity
     * @param response
     * @param homeAccountIdentifier
     * @param idTokenObj
     * @param authority
     * @returns
     */
    NativeInteractionClient.prototype.createAccountEntity = function (response, homeAccountIdentifier, idTokenObj, authority) {
        return AccountEntity.createAccount(response.client_info, homeAccountIdentifier, idTokenObj, undefined, undefined, undefined, authority, response.account.id);
    };
    /**
     * Helper to generate scopes
     * @param response
     * @param request
     * @returns
     */
    NativeInteractionClient.prototype.generateScopes = function (response, request) {
        return response.scope ? ScopeSet.fromString(response.scope) : ScopeSet.fromString(request.scope);
    };
    /**
     * If PoP token is requesred, records the PoP token if returned from the WAM, else generates one in the browser
     * @param request
     * @param response
     */
    NativeInteractionClient.prototype.generatePopAccessToken = function (response, request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var popTokenGenerator, shrParameters;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(request.tokenType === AuthenticationScheme.POP)) return [3 /*break*/, 2];
                        /**
                         * This code prioritizes SHR returned from the native layer. In case of error/SHR not calculated from WAM and the AT
                         * is still received, SHR is calculated locally
                         */
                        // Check if native layer returned an SHR token
                        if (response.shr) {
                            this.logger.trace("handleNativeServerResponse: SHR is enabled in native layer");
                            return [2 /*return*/, response.shr];
                        }
                        popTokenGenerator = new PopTokenGenerator(this.browserCrypto);
                        shrParameters = {
                            resourceRequestMethod: request.resourceRequestMethod,
                            resourceRequestUri: request.resourceRequestUri,
                            shrClaims: request.shrClaims,
                            shrNonce: request.shrNonce
                        };
                        /**
                         * KeyID must be present in the native request from when the PoP key was generated in order for
                         * PopTokenGenerator to query the full key for signing
                         */
                        if (!request.keyId) {
                            throw ClientAuthError.createKeyIdMissingError();
                        }
                        return [4 /*yield*/, popTokenGenerator.signPopToken(response.access_token, request.keyId, shrParameters)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/, response.access_token];
                }
            });
        });
    };
    /**
     * Generates authentication result
     * @param response
     * @param request
     * @param idTokenObj
     * @param accountEntity
     * @param authority
     * @param reqTimestamp
     * @returns
     */
    NativeInteractionClient.prototype.generateAuthenticationResult = function (response, request, idTokenObj, accountEntity, authority, reqTimestamp) {
        return __awaiter$3(this, void 0, void 0, function () {
            var mats, responseScopes, accountProperties, uid, tid, responseAccessToken, tokenType, result;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mats = this.addTelemetryFromNativeResponse(response);
                        responseScopes = response.scope ? ScopeSet.fromString(response.scope) : ScopeSet.fromString(request.scope);
                        accountProperties = response.account.properties || {};
                        uid = accountProperties["UID"] || idTokenObj.claims.oid || idTokenObj.claims.sub || Constants.EMPTY_STRING;
                        tid = accountProperties["TenantId"] || idTokenObj.claims.tid || Constants.EMPTY_STRING;
                        return [4 /*yield*/, this.generatePopAccessToken(response, request)];
                    case 1:
                        responseAccessToken = _a.sent();
                        tokenType = (request.tokenType === AuthenticationScheme.POP) ? AuthenticationScheme.POP : AuthenticationScheme.BEARER;
                        result = {
                            authority: authority,
                            uniqueId: uid,
                            tenantId: tid,
                            scopes: responseScopes.asArray(),
                            account: accountEntity.getAccountInfo(),
                            idToken: response.id_token,
                            idTokenClaims: idTokenObj.claims,
                            accessToken: responseAccessToken,
                            fromCache: mats ? this.isResponseFromCache(mats) : false,
                            expiresOn: new Date(Number(reqTimestamp + response.expires_in) * 1000),
                            tokenType: tokenType,
                            correlationId: this.correlationId,
                            state: response.state,
                            fromNativeBroker: true
                        };
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * cache the account entity in browser storage
     * @param accountEntity
     */
    NativeInteractionClient.prototype.cacheAccount = function (accountEntity) {
        var _this = this;
        // Store the account info and hence `nativeAccountId` in browser cache
        this.browserStorage.setAccount(accountEntity);
        // Remove any existing cached tokens for this account in browser storage
        this.browserStorage.removeAccountContext(accountEntity).catch(function (e) {
            _this.logger.error("Error occurred while removing account context from browser storage. " + e);
        });
    };
    /**
     * Stores the access_token and id_token in inmemory storage
     * @param response
     * @param request
     * @param homeAccountIdentifier
     * @param idTokenObj
     * @param responseAccessToken
     * @param tenantId
     * @param reqTimestamp
     */
    NativeInteractionClient.prototype.cacheNativeTokens = function (response, request, homeAccountIdentifier, accountEntity, idTokenObj, responseAccessToken, tenantId, reqTimestamp) {
        var cachedIdToken = IdTokenEntity.createIdTokenEntity(homeAccountIdentifier, request.authority, response.id_token || Constants.EMPTY_STRING, request.clientId, idTokenObj.claims.tid || Constants.EMPTY_STRING);
        // cache accessToken in inmemory storage
        var expiresIn = (request.tokenType === AuthenticationScheme.POP)
            ? Constants.SHR_NONCE_VALIDITY
            : (typeof response.expires_in === "string"
                ? parseInt(response.expires_in, 10)
                : response.expires_in) || 0;
        var tokenExpirationSeconds = reqTimestamp + expiresIn;
        var responseScopes = this.generateScopes(response, request);
        var cachedAccessToken = AccessTokenEntity.createAccessTokenEntity(homeAccountIdentifier, request.authority, responseAccessToken, request.clientId, idTokenObj
            ? idTokenObj.claims.tid || Constants.EMPTY_STRING
            : tenantId, responseScopes.printScopes(), tokenExpirationSeconds, 0, this.browserCrypto);
        var nativeCacheRecord = new CacheRecord(accountEntity, cachedIdToken, cachedAccessToken);
        this.nativeStorageManager.saveCacheRecord(nativeCacheRecord);
    };
    NativeInteractionClient.prototype.addTelemetryFromNativeResponse = function (response) {
        var mats = this.getMATSFromResponse(response);
        if (!mats) {
            return null;
        }
        this.performanceClient.addStaticFields({
            extensionId: this.nativeMessageHandler.getExtensionId(),
            extensionVersion: this.nativeMessageHandler.getExtensionVersion(),
            matsBrokerVersion: mats.broker_version,
            matsAccountJoinOnStart: mats.account_join_on_start,
            matsAccountJoinOnEnd: mats.account_join_on_end,
            matsDeviceJoin: mats.device_join,
            matsPromptBehavior: mats.prompt_behavior,
            matsApiErrorCode: mats.api_error_code,
            matsUiVisible: mats.ui_visible,
            matsSilentCode: mats.silent_code,
            matsSilentBiSubCode: mats.silent_bi_sub_code,
            matsSilentMessage: mats.silent_message,
            matsSilentStatus: mats.silent_status,
            matsHttpStatus: mats.http_status,
            matsHttpEventCount: mats.http_event_count
        }, this.correlationId);
        return mats;
    };
    /**
     * Validates native platform response before processing
     * @param response
     */
    NativeInteractionClient.prototype.validateNativeResponse = function (response) {
        if (response.hasOwnProperty("access_token") &&
            response.hasOwnProperty("id_token") &&
            response.hasOwnProperty("client_info") &&
            response.hasOwnProperty("account") &&
            response.hasOwnProperty("scope") &&
            response.hasOwnProperty("expires_in")) {
            return response;
        }
        else {
            throw NativeAuthError.createUnexpectedError("Response missing expected properties.");
        }
    };
    /**
     * Gets MATS telemetry from native response
     * @param response
     * @returns
     */
    NativeInteractionClient.prototype.getMATSFromResponse = function (response) {
        if (response.properties.MATS) {
            try {
                return JSON.parse(response.properties.MATS);
            }
            catch (e) {
                this.logger.error("NativeInteractionClient - Error parsing MATS telemetry, returning null instead");
            }
        }
        return null;
    };
    /**
     * Returns whether or not response came from native cache
     * @param response
     * @returns
     */
    NativeInteractionClient.prototype.isResponseFromCache = function (mats) {
        if (typeof mats.is_cached === "undefined") {
            this.logger.verbose("NativeInteractionClient - MATS telemetry does not contain field indicating if response was served from cache. Returning false.");
            return false;
        }
        return !!mats.is_cached;
    };
    /**
     * Translates developer provided request object into NativeRequest object
     * @param request
     */
    NativeInteractionClient.prototype.initializeNativeRequest = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var authority, canonicalAuthority, scopes, remainingProperties, scopeSet, getPrompt, validatedRequest, shrParameters, popTokenGenerator, reqCnfData;
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.trace("NativeInteractionClient - initializeNativeRequest called");
                        authority = request.authority || this.config.auth.authority;
                        if (!request.account) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.validateRequestAuthority(authority, request.account)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        canonicalAuthority = new UrlString(authority);
                        canonicalAuthority.validateAsUri();
                        scopes = request.scopes, remainingProperties = __rest(request, ["scopes"]);
                        scopeSet = new ScopeSet(scopes || []);
                        scopeSet.appendScopes(OIDC_DEFAULT_SCOPES);
                        getPrompt = function () {
                            // If request is silent, prompt is always none
                            switch (_this.apiId) {
                                case ApiId.ssoSilent:
                                case ApiId.acquireTokenSilent_silentFlow:
                                    _this.logger.trace("initializeNativeRequest: silent request sets prompt to none");
                                    return PromptValue.NONE;
                            }
                            // Prompt not provided, request may proceed and native broker decides if it needs to prompt
                            if (!request.prompt) {
                                _this.logger.trace("initializeNativeRequest: prompt was not provided");
                                return undefined;
                            }
                            // If request is interactive, check if prompt provided is allowed to go directly to native broker
                            switch (request.prompt) {
                                case PromptValue.NONE:
                                case PromptValue.CONSENT:
                                case PromptValue.LOGIN:
                                    _this.logger.trace("initializeNativeRequest: prompt is compatible with native flow");
                                    return request.prompt;
                                default:
                                    _this.logger.trace("initializeNativeRequest: prompt = " + request.prompt + " is not compatible with native flow");
                                    throw BrowserAuthError.createNativePromptParameterNotSupportedError();
                            }
                        };
                        validatedRequest = __assign$5(__assign$5({}, remainingProperties), { accountId: this.accountId, clientId: this.config.auth.clientId, authority: canonicalAuthority.urlString, scope: scopeSet.printScopes(), redirectUri: this.getRedirectUri(request.redirectUri), prompt: getPrompt(), correlationId: this.correlationId, tokenType: request.authenticationScheme, windowTitleSubstring: document.title, extraParameters: __assign$5(__assign$5(__assign$5({}, request.extraQueryParameters), request.tokenQueryParameters), { telemetry: NativeConstants.MATS_TELEMETRY }), extendedExpiryToken: false // Make this configurable?
                         });
                        if (!(request.authenticationScheme === AuthenticationScheme.POP)) return [3 /*break*/, 4];
                        shrParameters = {
                            resourceRequestUri: request.resourceRequestUri,
                            resourceRequestMethod: request.resourceRequestMethod,
                            shrClaims: request.shrClaims,
                            shrNonce: request.shrNonce
                        };
                        popTokenGenerator = new PopTokenGenerator(this.browserCrypto);
                        return [4 /*yield*/, popTokenGenerator.generateCnf(shrParameters)];
                    case 3:
                        reqCnfData = _a.sent();
                        // to reduce the URL length, it is recommended to send the short form of the req_cnf 
                        validatedRequest.reqCnf = reqCnfData.reqCnfString;
                        validatedRequest.keyId = reqCnfData.kid;
                        _a.label = 4;
                    case 4: return [2 /*return*/, validatedRequest];
                }
            });
        });
    };
    return NativeInteractionClient;
}(BaseInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var NativeMessageHandler = /** @class */ (function () {
    function NativeMessageHandler(logger, handshakeTimeoutMs, performanceClient, extensionId) {
        this.logger = logger;
        this.handshakeTimeoutMs = handshakeTimeoutMs;
        this.extensionId = extensionId;
        this.resolvers = new Map(); // Used for non-handshake messages
        this.handshakeResolvers = new Map(); // Used for handshake messages
        this.responseId = 0;
        this.messageChannel = new MessageChannel();
        this.windowListener = this.onWindowMessage.bind(this); // Window event callback doesn't have access to 'this' unless it's bound
        this.performanceClient = performanceClient;
        this.handshakeEvent = performanceClient.startMeasurement(PerformanceEvents.NativeMessageHandlerHandshake);
    }
    /**
     * Sends a given message to the extension and resolves with the extension response
     * @param body
     */
    NativeMessageHandler.prototype.sendMessage = function (body) {
        return __awaiter$3(this, void 0, void 0, function () {
            var req;
            var _this = this;
            return __generator$3(this, function (_a) {
                this.logger.trace("NativeMessageHandler - sendMessage called.");
                req = {
                    channel: NativeConstants.CHANNEL_ID,
                    extensionId: this.extensionId,
                    responseId: this.responseId++,
                    body: body
                };
                this.logger.trace("NativeMessageHandler - Sending request to browser extension");
                this.logger.tracePii("NativeMessageHandler - Sending request to browser extension: " + JSON.stringify(req));
                this.messageChannel.port1.postMessage(req);
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.resolvers.set(req.responseId, { resolve: resolve, reject: reject });
                    })];
            });
        });
    };
    /**
     * Returns an instance of the MessageHandler that has successfully established a connection with an extension
     * @param {Logger} logger
     * @param {number} handshakeTimeoutMs
     * @param {IPerformanceClient} performanceClient
     */
    NativeMessageHandler.createProvider = function (logger, handshakeTimeoutMs, performanceClient) {
        return __awaiter$3(this, void 0, void 0, function () {
            var preferredProvider, backupProvider;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger.trace("NativeMessageHandler - createProvider called.");
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 5]);
                        preferredProvider = new NativeMessageHandler(logger, handshakeTimeoutMs, performanceClient, NativeConstants.PREFERRED_EXTENSION_ID);
                        return [4 /*yield*/, preferredProvider.sendHandshakeRequest()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, preferredProvider];
                    case 3:
                        _a.sent();
                        backupProvider = new NativeMessageHandler(logger, handshakeTimeoutMs, performanceClient);
                        return [4 /*yield*/, backupProvider.sendHandshakeRequest()];
                    case 4:
                        _a.sent();
                        return [2 /*return*/, backupProvider];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Send handshake request helper.
     */
    NativeMessageHandler.prototype.sendHandshakeRequest = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var req;
            var _this = this;
            return __generator$3(this, function (_a) {
                this.logger.trace("NativeMessageHandler - sendHandshakeRequest called.");
                // Register this event listener before sending handshake
                window.addEventListener("message", this.windowListener, false); // false is important, because content script message processing should work first
                req = {
                    channel: NativeConstants.CHANNEL_ID,
                    extensionId: this.extensionId,
                    responseId: this.responseId++,
                    body: {
                        method: NativeExtensionMethod.HandshakeRequest
                    }
                };
                this.handshakeEvent.addStaticFields({
                    extensionId: this.extensionId,
                    extensionHandshakeTimeoutMs: this.handshakeTimeoutMs
                });
                this.messageChannel.port1.onmessage = function (event) {
                    _this.onChannelMessage(event);
                };
                window.postMessage(req, window.origin, [this.messageChannel.port2]);
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.handshakeResolvers.set(req.responseId, { resolve: resolve, reject: reject });
                        _this.timeoutId = window.setTimeout(function () {
                            /*
                             * Throw an error if neither HandshakeResponse nor original Handshake request are received in a reasonable timeframe.
                             * This typically suggests an event handler stopped propagation of the Handshake request but did not respond to it on the MessageChannel port
                             */
                            window.removeEventListener("message", _this.windowListener, false);
                            _this.messageChannel.port1.close();
                            _this.messageChannel.port2.close();
                            _this.handshakeEvent.endMeasurement({ extensionHandshakeTimedOut: true, success: false });
                            reject(BrowserAuthError.createNativeHandshakeTimeoutError());
                            _this.handshakeResolvers.delete(req.responseId);
                        }, _this.handshakeTimeoutMs); // Use a reasonable timeout in milliseconds here
                    })];
            });
        });
    };
    /**
     * Invoked when a message is posted to the window. If a handshake request is received it means the extension is not installed.
     * @param event
     */
    NativeMessageHandler.prototype.onWindowMessage = function (event) {
        this.logger.trace("NativeMessageHandler - onWindowMessage called");
        // We only accept messages from ourselves
        if (event.source !== window) {
            return;
        }
        var request = event.data;
        if (!request.channel || request.channel !== NativeConstants.CHANNEL_ID) {
            return;
        }
        if (request.extensionId && request.extensionId !== this.extensionId) {
            return;
        }
        if (request.body.method === NativeExtensionMethod.HandshakeRequest) {
            // If we receive this message back it means no extension intercepted the request, meaning no extension supporting handshake protocol is installed
            this.logger.verbose(request.extensionId ? "Extension with id: " + request.extensionId + " not installed" : "No extension installed");
            clearTimeout(this.timeoutId);
            this.messageChannel.port1.close();
            this.messageChannel.port2.close();
            window.removeEventListener("message", this.windowListener, false);
            var handshakeResolver = this.handshakeResolvers.get(request.responseId);
            if (handshakeResolver) {
                this.handshakeEvent.endMeasurement({ success: false, extensionInstalled: false });
                handshakeResolver.reject(BrowserAuthError.createNativeExtensionNotInstalledError());
            }
        }
    };
    /**
     * Invoked when a message is received from the extension on the MessageChannel port
     * @param event
     */
    NativeMessageHandler.prototype.onChannelMessage = function (event) {
        this.logger.trace("NativeMessageHandler - onChannelMessage called.");
        var request = event.data;
        var resolver = this.resolvers.get(request.responseId);
        var handshakeResolver = this.handshakeResolvers.get(request.responseId);
        try {
            var method = request.body.method;
            if (method === NativeExtensionMethod.Response) {
                if (!resolver) {
                    return;
                }
                var response = request.body.response;
                this.logger.trace("NativeMessageHandler - Received response from browser extension");
                this.logger.tracePii("NativeMessageHandler - Received response from browser extension: " + JSON.stringify(response));
                if (response.status !== "Success") {
                    resolver.reject(NativeAuthError.createError(response.code, response.description, response.ext));
                }
                else if (response.result) {
                    if (response.result["code"] && response.result["description"]) {
                        resolver.reject(NativeAuthError.createError(response.result["code"], response.result["description"], response.result["ext"]));
                    }
                    else {
                        resolver.resolve(response.result);
                    }
                }
                else {
                    throw AuthError.createUnexpectedError("Event does not contain result.");
                }
                this.resolvers.delete(request.responseId);
            }
            else if (method === NativeExtensionMethod.HandshakeResponse) {
                if (!handshakeResolver) {
                    return;
                }
                clearTimeout(this.timeoutId); // Clear setTimeout
                window.removeEventListener("message", this.windowListener, false); // Remove 'No extension' listener
                this.extensionId = request.extensionId;
                this.extensionVersion = request.body.version;
                this.logger.verbose("NativeMessageHandler - Received HandshakeResponse from extension: " + this.extensionId);
                this.handshakeEvent.endMeasurement({ extensionInstalled: true, success: true });
                handshakeResolver.resolve();
                this.handshakeResolvers.delete(request.responseId);
            }
            // Do nothing if method is not Response or HandshakeResponse
        }
        catch (err) {
            this.logger.error("Error parsing response from WAM Extension");
            this.logger.errorPii("Error parsing response from WAM Extension: " + err.toString());
            this.logger.errorPii("Unable to parse " + event);
            if (resolver) {
                resolver.reject(err);
            }
            else if (handshakeResolver) {
                handshakeResolver.reject(err);
            }
        }
    };
    /**
     * Returns the Id for the browser extension this handler is communicating with
     * @returns
     */
    NativeMessageHandler.prototype.getExtensionId = function () {
        return this.extensionId;
    };
    /**
     * Returns the version for the browser extension this handler is communicating with
     * @returns
     */
    NativeMessageHandler.prototype.getExtensionVersion = function () {
        return this.extensionVersion;
    };
    /**
     * Returns boolean indicating whether or not the request should attempt to use native broker
     * @param logger
     * @param config
     * @param nativeExtensionProvider
     * @param authenticationScheme
     */
    NativeMessageHandler.isNativeAvailable = function (config, logger, nativeExtensionProvider, authenticationScheme) {
        logger.trace("isNativeAvailable called");
        if (!config.system.allowNativeBroker) {
            logger.trace("isNativeAvailable: allowNativeBroker is not enabled, returning false");
            // Developer disabled WAM
            return false;
        }
        if (!nativeExtensionProvider) {
            logger.trace("isNativeAvailable: WAM extension provider is not initialized, returning false");
            // Extension is not available
            return false;
        }
        if (authenticationScheme) {
            switch (authenticationScheme) {
                case AuthenticationScheme.BEARER:
                case AuthenticationScheme.POP:
                    logger.trace("isNativeAvailable: authenticationScheme is supported, returning true");
                    return true;
                default:
                    logger.trace("isNativeAvailable: authenticationScheme is not supported, returning false");
                    return false;
            }
        }
        return true;
    };
    return NativeMessageHandler;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var RedirectClient = /** @class */ (function (_super) {
    __extends$g(RedirectClient, _super);
    function RedirectClient(config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, performanceClient, nativeStorageImpl, nativeMessageHandler, correlationId) {
        var _this = _super.call(this, config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, performanceClient, nativeMessageHandler, correlationId) || this;
        _this.nativeStorage = nativeStorageImpl;
        return _this;
    }
    /**
     * Redirects the page to the /authorize endpoint of the IDP
     * @param request
     */
    RedirectClient.prototype.acquireToken = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var validRequest, serverTelemetryManager, handleBackButton, authCodeRequest, authClient, interactionHandler, navigateUrl, redirectStartPage, e_1;
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest, request.correlationId);
                        return [4 /*yield*/, this.initializeAuthorizationRequest(request, InteractionType.Redirect)];
                    case 1:
                        validRequest = _a.sent();
                        this.browserStorage.updateCacheEntries(validRequest.state, validRequest.nonce, validRequest.authority, validRequest.loginHint || Constants.EMPTY_STRING, validRequest.account || null);
                        serverTelemetryManager = this.initializeServerTelemetryManager(ApiId.acquireTokenRedirect);
                        handleBackButton = function (event) {
                            // Clear temporary cache if the back button is clicked during the redirect flow.
                            if (event.persisted) {
                                _this.logger.verbose("Page was restored from back/forward cache. Clearing temporary cache.");
                                _this.browserStorage.cleanRequestByState(validRequest.state);
                                _this.eventHandler.emitEvent(EventType.RESTORE_FROM_BFCACHE, InteractionType.Redirect);
                            }
                        };
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 7, , 8]);
                        // Create auth code request and generate PKCE params
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationCodeRequest, request.correlationId);
                        return [4 /*yield*/, this.initializeAuthorizationCodeRequest(validRequest)];
                    case 3:
                        authCodeRequest = _a.sent();
                        // Initialize the client
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient, request.correlationId);
                        return [4 /*yield*/, this.createAuthCodeClient(serverTelemetryManager, validRequest.authority, validRequest.azureCloudOptions)];
                    case 4:
                        authClient = _a.sent();
                        this.logger.verbose("Auth code client created");
                        interactionHandler = new RedirectHandler(authClient, this.browserStorage, authCodeRequest, this.logger, this.browserCrypto, this.performanceClient);
                        return [4 /*yield*/, authClient.getAuthCodeUrl(__assign$5(__assign$5({}, validRequest), { nativeBroker: NativeMessageHandler.isNativeAvailable(this.config, this.logger, this.nativeMessageHandler, request.authenticationScheme) }))];
                    case 5:
                        navigateUrl = _a.sent();
                        redirectStartPage = this.getRedirectStartPage(request.redirectStartPage);
                        this.logger.verbosePii("Redirect start page: " + redirectStartPage);
                        // Clear temporary cache if the back button is clicked during the redirect flow.
                        window.addEventListener("pageshow", handleBackButton);
                        return [4 /*yield*/, interactionHandler.initiateAuthRequest(navigateUrl, {
                                navigationClient: this.navigationClient,
                                redirectTimeout: this.config.system.redirectNavigationTimeout,
                                redirectStartPage: redirectStartPage,
                                onRedirectNavigate: request.onRedirectNavigate
                            })];
                    case 6: 
                    // Show the UI once the url has been created. Response will come back in the hash, which will be handled in the handleRedirectCallback function.
                    return [2 /*return*/, _a.sent()];
                    case 7:
                        e_1 = _a.sent();
                        if (e_1 instanceof AuthError) {
                            e_1.setCorrelationId(this.correlationId);
                        }
                        window.removeEventListener("pageshow", handleBackButton);
                        serverTelemetryManager.cacheFailedRequest(e_1);
                        this.browserStorage.cleanRequestByState(validRequest.state);
                        throw e_1;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Checks if navigateToLoginRequestUrl is set, and:
     * - if true, performs logic to cache and navigate
     * - if false, handles hash string and parses response
     * @param hash
     */
    RedirectClient.prototype.handleRedirectPromise = function (hash) {
        return __awaiter$3(this, void 0, void 0, function () {
            var serverTelemetryManager, responseHash, state, serverParams, loginRequestUrl, loginRequestUrlNormalized, currentUrlNormalized, handleHashResult, navigationOptions, processHashOnRedirect, homepage, e_2;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        serverTelemetryManager = this.initializeServerTelemetryManager(ApiId.handleRedirectPromise);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 10, , 11]);
                        if (!this.browserStorage.isInteractionInProgress(true)) {
                            this.logger.info("handleRedirectPromise called but there is no interaction in progress, returning null.");
                            return [2 /*return*/, null];
                        }
                        responseHash = this.getRedirectResponseHash(hash || window.location.hash);
                        if (!responseHash) {
                            // Not a recognized server response hash or hash not associated with a redirect request
                            this.logger.info("handleRedirectPromise did not detect a response hash as a result of a redirect. Cleaning temporary cache.");
                            this.browserStorage.cleanRequestByInteractionType(InteractionType.Redirect);
                            return [2 /*return*/, null];
                        }
                        state = void 0;
                        try {
                            serverParams = UrlString.getDeserializedHash(responseHash);
                            state = this.validateAndExtractStateFromHash(serverParams, InteractionType.Redirect);
                            this.logger.verbose("State extracted from hash");
                        }
                        catch (e) {
                            this.logger.info("handleRedirectPromise was unable to extract state due to: " + e);
                            this.browserStorage.cleanRequestByInteractionType(InteractionType.Redirect);
                            return [2 /*return*/, null];
                        }
                        loginRequestUrl = this.browserStorage.getTemporaryCache(TemporaryCacheKeys.ORIGIN_URI, true) || Constants.EMPTY_STRING;
                        loginRequestUrlNormalized = UrlString.removeHashFromUrl(loginRequestUrl);
                        currentUrlNormalized = UrlString.removeHashFromUrl(window.location.href);
                        if (!(loginRequestUrlNormalized === currentUrlNormalized && this.config.auth.navigateToLoginRequestUrl)) return [3 /*break*/, 3];
                        // We are on the page we need to navigate to - handle hash
                        this.logger.verbose("Current page is loginRequestUrl, handling hash");
                        return [4 /*yield*/, this.handleHash(responseHash, state, serverTelemetryManager)];
                    case 2:
                        handleHashResult = _a.sent();
                        if (loginRequestUrl.indexOf("#") > -1) {
                            // Replace current hash with non-msal hash, if present
                            BrowserUtils.replaceHash(loginRequestUrl);
                        }
                        return [2 /*return*/, handleHashResult];
                    case 3:
                        if (!!this.config.auth.navigateToLoginRequestUrl) return [3 /*break*/, 4];
                        this.logger.verbose("NavigateToLoginRequestUrl set to false, handling hash");
                        return [2 /*return*/, this.handleHash(responseHash, state, serverTelemetryManager)];
                    case 4:
                        if (!(!BrowserUtils.isInIframe() || this.config.system.allowRedirectInIframe)) return [3 /*break*/, 9];
                        /*
                         * Returned from authority using redirect - need to perform navigation before processing response
                         * Cache the hash to be retrieved after the next redirect
                         */
                        this.browserStorage.setTemporaryCache(TemporaryCacheKeys.URL_HASH, responseHash, true);
                        navigationOptions = {
                            apiId: ApiId.handleRedirectPromise,
                            timeout: this.config.system.redirectNavigationTimeout,
                            noHistory: true
                        };
                        processHashOnRedirect = true;
                        if (!(!loginRequestUrl || loginRequestUrl === "null")) return [3 /*break*/, 6];
                        homepage = BrowserUtils.getHomepage();
                        // Cache the homepage under ORIGIN_URI to ensure cached hash is processed on homepage
                        this.browserStorage.setTemporaryCache(TemporaryCacheKeys.ORIGIN_URI, homepage, true);
                        this.logger.warning("Unable to get valid login request url from cache, redirecting to home page");
                        return [4 /*yield*/, this.navigationClient.navigateInternal(homepage, navigationOptions)];
                    case 5:
                        processHashOnRedirect = _a.sent();
                        return [3 /*break*/, 8];
                    case 6:
                        // Navigate to page that initiated the redirect request
                        this.logger.verbose("Navigating to loginRequestUrl: " + loginRequestUrl);
                        return [4 /*yield*/, this.navigationClient.navigateInternal(loginRequestUrl, navigationOptions)];
                    case 7:
                        processHashOnRedirect = _a.sent();
                        _a.label = 8;
                    case 8:
                        // If navigateInternal implementation returns false, handle the hash now
                        if (!processHashOnRedirect) {
                            return [2 /*return*/, this.handleHash(responseHash, state, serverTelemetryManager)];
                        }
                        _a.label = 9;
                    case 9: return [2 /*return*/, null];
                    case 10:
                        e_2 = _a.sent();
                        if (e_2 instanceof AuthError) {
                            e_2.setCorrelationId(this.correlationId);
                        }
                        serverTelemetryManager.cacheFailedRequest(e_2);
                        this.browserStorage.cleanRequestByInteractionType(InteractionType.Redirect);
                        throw e_2;
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Gets the response hash for a redirect request
     * Returns null if interactionType in the state value is not "redirect" or the hash does not contain known properties
     * @param hash
     */
    RedirectClient.prototype.getRedirectResponseHash = function (hash) {
        this.logger.verbose("getRedirectResponseHash called");
        // Get current location hash from window or cache.
        var isResponseHash = UrlString.hashContainsKnownProperties(hash);
        if (isResponseHash) {
            BrowserUtils.clearHash(window);
            this.logger.verbose("Hash contains known properties, returning response hash");
            return hash;
        }
        var cachedHash = this.browserStorage.getTemporaryCache(TemporaryCacheKeys.URL_HASH, true);
        this.browserStorage.removeItem(this.browserStorage.generateCacheKey(TemporaryCacheKeys.URL_HASH));
        this.logger.verbose("Hash does not contain known properties, returning cached hash");
        return cachedHash;
    };
    /**
     * Checks if hash exists and handles in window.
     * @param hash
     * @param state
     */
    RedirectClient.prototype.handleHash = function (hash, state, serverTelemetryManager) {
        return __awaiter$3(this, void 0, void 0, function () {
            var cachedRequest, serverParams, nativeInteractionClient, userRequestState, currentAuthority, authClient, interactionHandler;
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cachedRequest = this.browserStorage.getCachedRequest(state, this.browserCrypto);
                        this.logger.verbose("handleHash called, retrieved cached request");
                        serverParams = UrlString.getDeserializedHash(hash);
                        if (serverParams.accountId) {
                            this.logger.verbose("Account id found in hash, calling WAM for token");
                            if (!this.nativeMessageHandler) {
                                throw BrowserAuthError.createNativeConnectionNotEstablishedError();
                            }
                            nativeInteractionClient = new NativeInteractionClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, ApiId.acquireTokenPopup, this.performanceClient, this.nativeMessageHandler, serverParams.accountId, this.nativeStorage, cachedRequest.correlationId);
                            userRequestState = ProtocolUtils.parseRequestState(this.browserCrypto, state).userRequestState;
                            return [2 /*return*/, nativeInteractionClient.acquireToken(__assign$5(__assign$5({}, cachedRequest), { state: userRequestState, prompt: undefined // Server should handle the prompt, ideally native broker can do this part silently
                                 })).finally(function () {
                                    _this.browserStorage.cleanRequestByState(state);
                                })];
                        }
                        currentAuthority = this.browserStorage.getCachedAuthority(state);
                        if (!currentAuthority) {
                            throw BrowserAuthError.createNoCachedAuthorityError();
                        }
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient, cachedRequest.correlationId);
                        return [4 /*yield*/, this.createAuthCodeClient(serverTelemetryManager, currentAuthority)];
                    case 1:
                        authClient = _a.sent();
                        this.logger.verbose("Auth code client created");
                        ThrottlingUtils.removeThrottle(this.browserStorage, this.config.auth.clientId, cachedRequest);
                        interactionHandler = new RedirectHandler(authClient, this.browserStorage, cachedRequest, this.logger, this.browserCrypto, this.performanceClient);
                        return [4 /*yield*/, interactionHandler.handleCodeResponseFromHash(hash, state, authClient.authority, this.networkClient)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Use to log out the current user, and redirect the user to the postLogoutRedirectUri.
     * Default behaviour is to redirect the user to `window.location.href`.
     * @param logoutRequest
     */
    RedirectClient.prototype.logout = function (logoutRequest) {
        return __awaiter$3(this, void 0, void 0, function () {
            var validLogoutRequest, serverTelemetryManager, navigationOptions, authClient, logoutUri, navigate, e_3;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose("logoutRedirect called");
                        validLogoutRequest = this.initializeLogoutRequest(logoutRequest);
                        serverTelemetryManager = this.initializeServerTelemetryManager(ApiId.logout);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 10, , 11]);
                        this.eventHandler.emitEvent(EventType.LOGOUT_START, InteractionType.Redirect, logoutRequest);
                        // Clear cache on logout
                        return [4 /*yield*/, this.clearCacheOnLogout(validLogoutRequest.account)];
                    case 2:
                        // Clear cache on logout
                        _a.sent();
                        navigationOptions = {
                            apiId: ApiId.logout,
                            timeout: this.config.system.redirectNavigationTimeout,
                            noHistory: false
                        };
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient, validLogoutRequest.correlationId);
                        return [4 /*yield*/, this.createAuthCodeClient(serverTelemetryManager, logoutRequest && logoutRequest.authority)];
                    case 3:
                        authClient = _a.sent();
                        this.logger.verbose("Auth code client created");
                        logoutUri = authClient.getLogoutUri(validLogoutRequest);
                        this.eventHandler.emitEvent(EventType.LOGOUT_SUCCESS, InteractionType.Redirect, validLogoutRequest);
                        if (!(logoutRequest && typeof logoutRequest.onRedirectNavigate === "function")) return [3 /*break*/, 7];
                        navigate = logoutRequest.onRedirectNavigate(logoutUri);
                        if (!(navigate !== false)) return [3 /*break*/, 5];
                        this.logger.verbose("Logout onRedirectNavigate did not return false, navigating");
                        // Ensure interaction is in progress
                        if (!this.browserStorage.getInteractionInProgress()) {
                            this.browserStorage.setInteractionInProgress(true);
                        }
                        return [4 /*yield*/, this.navigationClient.navigateExternal(logoutUri, navigationOptions)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/];
                    case 5:
                        // Ensure interaction is not in progress
                        this.browserStorage.setInteractionInProgress(false);
                        this.logger.verbose("Logout onRedirectNavigate returned false, stopping navigation");
                        _a.label = 6;
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        // Ensure interaction is in progress
                        if (!this.browserStorage.getInteractionInProgress()) {
                            this.browserStorage.setInteractionInProgress(true);
                        }
                        return [4 /*yield*/, this.navigationClient.navigateExternal(logoutUri, navigationOptions)];
                    case 8:
                        _a.sent();
                        return [2 /*return*/];
                    case 9: return [3 /*break*/, 11];
                    case 10:
                        e_3 = _a.sent();
                        if (e_3 instanceof AuthError) {
                            e_3.setCorrelationId(this.correlationId);
                        }
                        serverTelemetryManager.cacheFailedRequest(e_3);
                        this.eventHandler.emitEvent(EventType.LOGOUT_FAILURE, InteractionType.Redirect, null, e_3);
                        this.eventHandler.emitEvent(EventType.LOGOUT_END, InteractionType.Redirect);
                        throw e_3;
                    case 11:
                        this.eventHandler.emitEvent(EventType.LOGOUT_END, InteractionType.Redirect);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Use to get the redirectStartPage either from request or use current window
     * @param requestStartPage
     */
    RedirectClient.prototype.getRedirectStartPage = function (requestStartPage) {
        var redirectStartPage = requestStartPage || window.location.href;
        return UrlString.getAbsoluteUrl(redirectStartPage, BrowserUtils.getCurrentUri());
    };
    return RedirectClient;
}(StandardInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var PopupClient = /** @class */ (function (_super) {
    __extends$g(PopupClient, _super);
    function PopupClient(config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, performanceClient, nativeStorageImpl, nativeMessageHandler, correlationId) {
        var _this = _super.call(this, config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, performanceClient, nativeMessageHandler, correlationId) || this;
        // Properly sets this reference for the unload event.
        _this.unloadWindow = _this.unloadWindow.bind(_this);
        _this.nativeStorage = nativeStorageImpl;
        return _this;
    }
    /**
     * Acquires tokens by opening a popup window to the /authorize endpoint of the authority
     * @param request
     */
    PopupClient.prototype.acquireToken = function (request) {
        try {
            var popupName = this.generatePopupName(request.scopes || OIDC_DEFAULT_SCOPES, request.authority || this.config.auth.authority);
            var popupWindowAttributes = request.popupWindowAttributes || {};
            // asyncPopups flag is true. Acquires token without first opening popup. Popup will be opened later asynchronously.
            if (this.config.system.asyncPopups) {
                this.logger.verbose("asyncPopups set to true, acquiring token");
                // Passes on popup position and dimensions if in request
                return this.acquireTokenPopupAsync(request, popupName, popupWindowAttributes);
            }
            else {
                // asyncPopups flag is set to false. Opens popup before acquiring token.
                this.logger.verbose("asyncPopup set to false, opening popup before acquiring token");
                var popup = this.openSizedPopup("about:blank", popupName, popupWindowAttributes);
                return this.acquireTokenPopupAsync(request, popupName, popupWindowAttributes, popup);
            }
        }
        catch (e) {
            return Promise.reject(e);
        }
    };
    /**
     * Clears local cache for the current user then opens a popup window prompting the user to sign-out of the server
     * @param logoutRequest
     */
    PopupClient.prototype.logout = function (logoutRequest) {
        try {
            this.logger.verbose("logoutPopup called");
            var validLogoutRequest = this.initializeLogoutRequest(logoutRequest);
            var popupName = this.generateLogoutPopupName(validLogoutRequest);
            var authority = logoutRequest && logoutRequest.authority;
            var mainWindowRedirectUri = logoutRequest && logoutRequest.mainWindowRedirectUri;
            var popupWindowAttributes = (logoutRequest === null || logoutRequest === void 0 ? void 0 : logoutRequest.popupWindowAttributes) || {};
            // asyncPopups flag is true. Acquires token without first opening popup. Popup will be opened later asynchronously.
            if (this.config.system.asyncPopups) {
                this.logger.verbose("asyncPopups set to true");
                // Passes on popup position and dimensions if in request
                return this.logoutPopupAsync(validLogoutRequest, popupName, popupWindowAttributes, authority, undefined, mainWindowRedirectUri);
            }
            else {
                // asyncPopups flag is set to false. Opens popup before logging out.
                this.logger.verbose("asyncPopup set to false, opening popup");
                var popup = this.openSizedPopup("about:blank", popupName, popupWindowAttributes);
                return this.logoutPopupAsync(validLogoutRequest, popupName, popupWindowAttributes, authority, popup, mainWindowRedirectUri);
            }
        }
        catch (e) {
            // Since this function is synchronous we need to reject
            return Promise.reject(e);
        }
    };
    /**
     * Helper which obtains an access_token for your API via opening a popup window in the user's browser
     * @param validRequest
     * @param popupName
     * @param popup
     * @param popupWindowAttributes
     *
     * @returns A promise that is fulfilled when this function has completed, or rejected if an error was raised.
     */
    PopupClient.prototype.acquireTokenPopupAsync = function (request, popupName, popupWindowAttributes, popup) {
        return __awaiter$3(this, void 0, void 0, function () {
            var serverTelemetryManager, validRequest, authCodeRequest, authClient, isNativeBroker, fetchNativeAccountIdMeasurement, navigateUrl, interactionHandler, popupParameters, popupWindow, hash, serverParams, state_1, nativeInteractionClient, userRequestState, result, e_1;
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose("acquireTokenPopupAsync called");
                        serverTelemetryManager = this.initializeServerTelemetryManager(ApiId.acquireTokenPopup);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest, request.correlationId);
                        return [4 /*yield*/, this.initializeAuthorizationRequest(request, InteractionType.Popup)];
                    case 1:
                        validRequest = _a.sent();
                        this.browserStorage.updateCacheEntries(validRequest.state, validRequest.nonce, validRequest.authority, validRequest.loginHint || Constants.EMPTY_STRING, validRequest.account || null);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 8, , 9]);
                        // Create auth code request and generate PKCE params
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationCodeRequest, request.correlationId);
                        return [4 /*yield*/, this.initializeAuthorizationCodeRequest(validRequest)];
                    case 3:
                        authCodeRequest = _a.sent();
                        // Initialize the client
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient, request.correlationId);
                        return [4 /*yield*/, this.createAuthCodeClient(serverTelemetryManager, validRequest.authority, validRequest.azureCloudOptions)];
                    case 4:
                        authClient = _a.sent();
                        this.logger.verbose("Auth code client created");
                        isNativeBroker = NativeMessageHandler.isNativeAvailable(this.config, this.logger, this.nativeMessageHandler, request.authenticationScheme);
                        fetchNativeAccountIdMeasurement = void 0;
                        if (isNativeBroker) {
                            fetchNativeAccountIdMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.FetchAccountIdWithNativeBroker, request.correlationId);
                        }
                        return [4 /*yield*/, authClient.getAuthCodeUrl(__assign$5(__assign$5({}, validRequest), { nativeBroker: isNativeBroker }))];
                    case 5:
                        navigateUrl = _a.sent();
                        interactionHandler = new InteractionHandler(authClient, this.browserStorage, authCodeRequest, this.logger, this.performanceClient);
                        popupParameters = {
                            popup: popup,
                            popupName: popupName,
                            popupWindowAttributes: popupWindowAttributes
                        };
                        popupWindow = this.initiateAuthRequest(navigateUrl, popupParameters);
                        this.eventHandler.emitEvent(EventType.POPUP_OPENED, InteractionType.Popup, { popupWindow: popupWindow }, null);
                        return [4 /*yield*/, this.monitorPopupForHash(popupWindow)];
                    case 6:
                        hash = _a.sent();
                        serverParams = UrlString.getDeserializedHash(hash);
                        state_1 = this.validateAndExtractStateFromHash(serverParams, InteractionType.Popup, validRequest.correlationId);
                        // Remove throttle if it exists
                        ThrottlingUtils.removeThrottle(this.browserStorage, this.config.auth.clientId, authCodeRequest);
                        if (serverParams.accountId) {
                            this.logger.verbose("Account id found in hash, calling WAM for token");
                            // end measurement for server call with native brokering enabled
                            if (fetchNativeAccountIdMeasurement) {
                                fetchNativeAccountIdMeasurement.endMeasurement({
                                    success: true,
                                    isNativeBroker: true
                                });
                            }
                            if (!this.nativeMessageHandler) {
                                throw BrowserAuthError.createNativeConnectionNotEstablishedError();
                            }
                            nativeInteractionClient = new NativeInteractionClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, ApiId.acquireTokenPopup, this.performanceClient, this.nativeMessageHandler, serverParams.accountId, this.nativeStorage, validRequest.correlationId);
                            userRequestState = ProtocolUtils.parseRequestState(this.browserCrypto, state_1).userRequestState;
                            return [2 /*return*/, nativeInteractionClient.acquireToken(__assign$5(__assign$5({}, validRequest), { state: userRequestState, prompt: undefined // Server should handle the prompt, ideally native broker can do this part silently
                                 })).finally(function () {
                                    _this.browserStorage.cleanRequestByState(state_1);
                                })];
                        }
                        return [4 /*yield*/, interactionHandler.handleCodeResponseFromHash(hash, state_1, authClient.authority, this.networkClient)];
                    case 7:
                        result = _a.sent();
                        return [2 /*return*/, result];
                    case 8:
                        e_1 = _a.sent();
                        if (popup) {
                            // Close the synchronous popup if an error is thrown before the window unload event is registered
                            popup.close();
                        }
                        if (e_1 instanceof AuthError) {
                            e_1.setCorrelationId(this.correlationId);
                        }
                        serverTelemetryManager.cacheFailedRequest(e_1);
                        this.browserStorage.cleanRequestByState(validRequest.state);
                        throw e_1;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     * @param validRequest
     * @param popupName
     * @param requestAuthority
     * @param popup
     * @param mainWindowRedirectUri
     * @param popupWindowAttributes
     */
    PopupClient.prototype.logoutPopupAsync = function (validRequest, popupName, popupWindowAttributes, requestAuthority, popup, mainWindowRedirectUri) {
        return __awaiter$3(this, void 0, void 0, function () {
            var serverTelemetryManager, authClient, logoutUri, popupWindow, navigationOptions, absoluteUrl, e_2;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.verbose("logoutPopupAsync called");
                        this.eventHandler.emitEvent(EventType.LOGOUT_START, InteractionType.Popup, validRequest);
                        serverTelemetryManager = this.initializeServerTelemetryManager(ApiId.logoutPopup);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        // Clear cache on logout
                        return [4 /*yield*/, this.clearCacheOnLogout(validRequest.account)];
                    case 2:
                        // Clear cache on logout
                        _a.sent();
                        // Initialize the client
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient, validRequest.correlationId);
                        return [4 /*yield*/, this.createAuthCodeClient(serverTelemetryManager, requestAuthority)];
                    case 3:
                        authClient = _a.sent();
                        this.logger.verbose("Auth code client created");
                        logoutUri = authClient.getLogoutUri(validRequest);
                        this.eventHandler.emitEvent(EventType.LOGOUT_SUCCESS, InteractionType.Popup, validRequest);
                        popupWindow = this.openPopup(logoutUri, { popupName: popupName, popupWindowAttributes: popupWindowAttributes, popup: popup });
                        this.eventHandler.emitEvent(EventType.POPUP_OPENED, InteractionType.Popup, { popupWindow: popupWindow }, null);
                        return [4 /*yield*/, this.waitForLogoutPopup(popupWindow)];
                    case 4:
                        _a.sent();
                        if (mainWindowRedirectUri) {
                            navigationOptions = {
                                apiId: ApiId.logoutPopup,
                                timeout: this.config.system.redirectNavigationTimeout,
                                noHistory: false
                            };
                            absoluteUrl = UrlString.getAbsoluteUrl(mainWindowRedirectUri, BrowserUtils.getCurrentUri());
                            this.logger.verbose("Redirecting main window to url specified in the request");
                            this.logger.verbosePii("Redirecting main window to: " + absoluteUrl);
                            this.navigationClient.navigateInternal(absoluteUrl, navigationOptions);
                        }
                        else {
                            this.logger.verbose("No main window navigation requested");
                        }
                        return [3 /*break*/, 6];
                    case 5:
                        e_2 = _a.sent();
                        if (popup) {
                            // Close the synchronous popup if an error is thrown before the window unload event is registered
                            popup.close();
                        }
                        if (e_2 instanceof AuthError) {
                            e_2.setCorrelationId(this.correlationId);
                        }
                        this.browserStorage.setInteractionInProgress(false);
                        this.eventHandler.emitEvent(EventType.LOGOUT_FAILURE, InteractionType.Popup, null, e_2);
                        this.eventHandler.emitEvent(EventType.LOGOUT_END, InteractionType.Popup);
                        serverTelemetryManager.cacheFailedRequest(e_2);
                        throw e_2;
                    case 6:
                        this.eventHandler.emitEvent(EventType.LOGOUT_END, InteractionType.Popup);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Opens a popup window with given request Url.
     * @param requestUrl
     */
    PopupClient.prototype.initiateAuthRequest = function (requestUrl, params) {
        // Check that request url is not empty.
        if (!StringUtils.isEmpty(requestUrl)) {
            this.logger.infoPii("Navigate to: " + requestUrl);
            // Open the popup window to requestUrl.
            return this.openPopup(requestUrl, params);
        }
        else {
            // Throw error if request URL is empty.
            this.logger.error("Navigate url is empty");
            throw BrowserAuthError.createEmptyNavigationUriError();
        }
    };
    /**
     * Monitors a window until it loads a url with the same origin.
     * @param popupWindow - window that is being monitored
     * @param timeout - timeout for processing hash once popup is redirected back to application
     */
    PopupClient.prototype.monitorPopupForHash = function (popupWindow) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            /*
             * Polling for popups needs to be tick-based,
             * since a non-trivial amount of time can be spent on interaction (which should not count against the timeout).
             */
            var maxTicks = _this.config.system.windowHashTimeout / _this.config.system.pollIntervalMilliseconds;
            var ticks = 0;
            _this.logger.verbose("PopupHandler.monitorPopupForHash - polling started");
            var intervalId = setInterval(function () {
                // Window is closed
                if (popupWindow.closed) {
                    _this.logger.error("PopupHandler.monitorPopupForHash - window closed");
                    _this.cleanPopup();
                    clearInterval(intervalId);
                    reject(BrowserAuthError.createUserCancelledError());
                    return;
                }
                var href = Constants.EMPTY_STRING;
                var hash = Constants.EMPTY_STRING;
                try {
                    /*
                     * Will throw if cross origin,
                     * which should be caught and ignored
                     * since we need the interval to keep running while on STS UI.
                     */
                    href = popupWindow.location.href;
                    hash = popupWindow.location.hash;
                }
                catch (e) { }
                // Don't process blank pages or cross domain
                if (StringUtils.isEmpty(href) || href === "about:blank") {
                    return;
                }
                _this.logger.verbose("PopupHandler.monitorPopupForHash - popup window is on same origin as caller");
                /*
                 * Only run clock when we are on same domain for popups
                 * as popup operations can take a long time.
                 */
                ticks++;
                if (hash) {
                    _this.logger.verbose("PopupHandler.monitorPopupForHash - found hash in url");
                    clearInterval(intervalId);
                    _this.cleanPopup(popupWindow);
                    if (UrlString.hashContainsKnownProperties(hash)) {
                        _this.logger.verbose("PopupHandler.monitorPopupForHash - hash contains known properties, returning.");
                        resolve(hash);
                    }
                    else {
                        _this.logger.error("PopupHandler.monitorPopupForHash - found hash in url but it does not contain known properties. Check that your router is not changing the hash prematurely.");
                        _this.logger.errorPii("PopupHandler.monitorPopupForHash - hash found: " + hash);
                        reject(BrowserAuthError.createHashDoesNotContainKnownPropertiesError());
                    }
                }
                else if (ticks > maxTicks) {
                    _this.logger.error("PopupHandler.monitorPopupForHash - unable to find hash in url, timing out");
                    clearInterval(intervalId);
                    reject(BrowserAuthError.createMonitorPopupTimeoutError());
                }
            }, _this.config.system.pollIntervalMilliseconds);
        });
    };
    /**
     * Waits for user interaction in logout popup window
     * @param popupWindow
     * @returns
     */
    PopupClient.prototype.waitForLogoutPopup = function (popupWindow) {
        var _this = this;
        return new Promise(function (resolve) {
            _this.logger.verbose("PopupHandler.waitForLogoutPopup - polling started");
            var intervalId = setInterval(function () {
                // Window is closed
                if (popupWindow.closed) {
                    _this.logger.error("PopupHandler.waitForLogoutPopup - window closed");
                    _this.cleanPopup();
                    clearInterval(intervalId);
                    resolve();
                }
                var href = Constants.EMPTY_STRING;
                try {
                    /*
                     * Will throw if cross origin,
                     * which should be caught and ignored
                     * since we need the interval to keep running while on STS UI.
                     */
                    href = popupWindow.location.href;
                }
                catch (e) { }
                // Don't process blank pages or cross domain
                if (StringUtils.isEmpty(href) || href === "about:blank") {
                    return;
                }
                _this.logger.verbose("PopupHandler.waitForLogoutPopup - popup window is on same origin as caller, closing.");
                clearInterval(intervalId);
                _this.cleanPopup(popupWindow);
                resolve();
            }, _this.config.system.pollIntervalMilliseconds);
        });
    };
    /**
     * @hidden
     *
     * Configures popup window for login.
     *
     * @param urlNavigate
     * @param title
     * @param popUpWidth
     * @param popUpHeight
     * @param popupWindowAttributes
     * @ignore
     * @hidden
     */
    PopupClient.prototype.openPopup = function (urlNavigate, popupParams) {
        try {
            var popupWindow = void 0;
            // Popup window passed in, setting url to navigate to
            if (popupParams.popup) {
                popupWindow = popupParams.popup;
                this.logger.verbosePii("Navigating popup window to: " + urlNavigate);
                popupWindow.location.assign(urlNavigate);
            }
            else if (typeof popupParams.popup === "undefined") {
                // Popup will be undefined if it was not passed in
                this.logger.verbosePii("Opening popup window to: " + urlNavigate);
                popupWindow = this.openSizedPopup(urlNavigate, popupParams.popupName, popupParams.popupWindowAttributes);
            }
            // Popup will be null if popups are blocked
            if (!popupWindow) {
                throw BrowserAuthError.createEmptyWindowCreatedError();
            }
            if (popupWindow.focus) {
                popupWindow.focus();
            }
            this.currentWindow = popupWindow;
            window.addEventListener("beforeunload", this.unloadWindow);
            return popupWindow;
        }
        catch (e) {
            this.logger.error("error opening popup " + e.message);
            this.browserStorage.setInteractionInProgress(false);
            throw BrowserAuthError.createPopupWindowError(e.toString());
        }
    };
    /**
     * Helper function to set popup window dimensions and position
     * @param urlNavigate
     * @param popupName
     * @param popupWindowAttributes
     * @returns
     */
    PopupClient.prototype.openSizedPopup = function (urlNavigate, popupName, popupWindowAttributes) {
        var _a, _b, _c, _d;
        /**
         * adding winLeft and winTop to account for dual monitor
         * using screenLeft and screenTop for IE8 and earlier
         */
        var winLeft = window.screenLeft ? window.screenLeft : window.screenX;
        var winTop = window.screenTop ? window.screenTop : window.screenY;
        /**
         * window.innerWidth displays browser window"s height and width excluding toolbars
         * using document.documentElement.clientWidth for IE8 and earlier
         */
        var winWidth = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
        var winHeight = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
        var width = (_a = popupWindowAttributes.popupSize) === null || _a === void 0 ? void 0 : _a.width;
        var height = (_b = popupWindowAttributes.popupSize) === null || _b === void 0 ? void 0 : _b.height;
        var top = (_c = popupWindowAttributes.popupPosition) === null || _c === void 0 ? void 0 : _c.top;
        var left = (_d = popupWindowAttributes.popupPosition) === null || _d === void 0 ? void 0 : _d.left;
        if (!width || width < 0 || width > winWidth) {
            this.logger.verbose("Default popup window width used. Window width not configured or invalid.");
            width = BrowserConstants.POPUP_WIDTH;
        }
        if (!height || height < 0 || height > winHeight) {
            this.logger.verbose("Default popup window height used. Window height not configured or invalid.");
            height = BrowserConstants.POPUP_HEIGHT;
        }
        if (!top || top < 0 || top > winHeight) {
            this.logger.verbose("Default popup window top position used. Window top not configured or invalid.");
            top = Math.max(0, ((winHeight / 2) - (BrowserConstants.POPUP_HEIGHT / 2)) + winTop);
        }
        if (!left || left < 0 || left > winWidth) {
            this.logger.verbose("Default popup window left position used. Window left not configured or invalid.");
            left = Math.max(0, ((winWidth / 2) - (BrowserConstants.POPUP_WIDTH / 2)) + winLeft);
        }
        return window.open(urlNavigate, popupName, "width=" + width + ", height=" + height + ", top=" + top + ", left=" + left + ", scrollbars=yes");
    };
    /**
     * Event callback to unload main window.
     */
    PopupClient.prototype.unloadWindow = function (e) {
        this.browserStorage.cleanRequestByInteractionType(InteractionType.Popup);
        if (this.currentWindow) {
            this.currentWindow.close();
        }
        // Guarantees browser unload will happen, so no other errors will be thrown.
        e.preventDefault();
    };
    /**
     * Closes popup, removes any state vars created during popup calls.
     * @param popupWindow
     */
    PopupClient.prototype.cleanPopup = function (popupWindow) {
        if (popupWindow) {
            // Close window.
            popupWindow.close();
        }
        // Remove window unload function
        window.removeEventListener("beforeunload", this.unloadWindow);
        // Interaction is completed - remove interaction status.
        this.browserStorage.setInteractionInProgress(false);
    };
    /**
     * Generates the name for the popup based on the client id and request
     * @param clientId
     * @param request
     */
    PopupClient.prototype.generatePopupName = function (scopes, authority) {
        return BrowserConstants.POPUP_NAME_PREFIX + "." + this.config.auth.clientId + "." + scopes.join("-") + "." + authority + "." + this.correlationId;
    };
    /**
     * Generates the name for the popup based on the client id and request for logouts
     * @param clientId
     * @param request
     */
    PopupClient.prototype.generateLogoutPopupName = function (request) {
        var homeAccountId = request.account && request.account.homeAccountId;
        return BrowserConstants.POPUP_NAME_PREFIX + "." + this.config.auth.clientId + "." + homeAccountId + "." + this.correlationId;
    };
    return PopupClient;
}(StandardInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var NavigationClient = /** @class */ (function () {
    function NavigationClient() {
    }
    /**
     * Navigates to other pages within the same web application
     * @param url
     * @param options
     */
    NavigationClient.prototype.navigateInternal = function (url, options) {
        return NavigationClient.defaultNavigateWindow(url, options);
    };
    /**
     * Navigates to other pages outside the web application i.e. the Identity Provider
     * @param url
     * @param options
     */
    NavigationClient.prototype.navigateExternal = function (url, options) {
        return NavigationClient.defaultNavigateWindow(url, options);
    };
    /**
     * Default navigation implementation invoked by the internal and external functions
     * @param url
     * @param options
     */
    NavigationClient.defaultNavigateWindow = function (url, options) {
        if (options.noHistory) {
            window.location.replace(url);
        }
        else {
            window.location.assign(url);
        }
        return new Promise(function (resolve) {
            setTimeout(function () {
                resolve(true);
            }, options.timeout);
        });
    };
    return NavigationClient;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
// Default timeout for popup windows and iframes in milliseconds
var DEFAULT_POPUP_TIMEOUT_MS = 60000;
var DEFAULT_IFRAME_TIMEOUT_MS = 6000;
var DEFAULT_REDIRECT_TIMEOUT_MS = 30000;
var DEFAULT_NATIVE_BROKER_HANDSHAKE_TIMEOUT_MS = 2000;
/**
 * MSAL function that sets the default options when not explicitly configured from app developer
 *
 * @param auth
 * @param cache
 * @param system
 *
 * @returns Configuration object
 */
function buildConfiguration(_a, isBrowserEnvironment) {
    var userInputAuth = _a.auth, userInputCache = _a.cache, userInputSystem = _a.system, userInputTelemetry = _a.telemetry;
    // Default auth options for browser
    var DEFAULT_AUTH_OPTIONS = {
        clientId: Constants.EMPTY_STRING,
        authority: "" + Constants.DEFAULT_AUTHORITY,
        knownAuthorities: [],
        cloudDiscoveryMetadata: Constants.EMPTY_STRING,
        authorityMetadata: Constants.EMPTY_STRING,
        redirectUri: Constants.EMPTY_STRING,
        postLogoutRedirectUri: Constants.EMPTY_STRING,
        navigateToLoginRequestUrl: true,
        clientCapabilities: [],
        protocolMode: ProtocolMode.AAD,
        azureCloudOptions: {
            azureCloudInstance: AzureCloudInstance.None,
            tenant: Constants.EMPTY_STRING
        },
        skipAuthorityMetadataCache: false,
    };
    // Default cache options for browser
    var DEFAULT_CACHE_OPTIONS = {
        cacheLocation: BrowserCacheLocation.SessionStorage,
        temporaryCacheLocation: BrowserCacheLocation.SessionStorage,
        storeAuthStateInCookie: false,
        secureCookies: false,
        // Default cache migration to true if cache location is localStorage since entries are preserved across tabs/windows. Migration has little to no benefit in sessionStorage and memoryStorage
        cacheMigrationEnabled: userInputCache && userInputCache.cacheLocation === BrowserCacheLocation.LocalStorage ? true : false,
        claimsBasedCachingEnabled: true
    };
    // Default logger options for browser
    var DEFAULT_LOGGER_OPTIONS = {
        // eslint-disable-next-line @typescript-eslint/no-empty-function
        loggerCallback: function () {
            // allow users to not set logger call back 
        },
        logLevel: LogLevel.Info,
        piiLoggingEnabled: false
    };
    // Default system options for browser
    var DEFAULT_BROWSER_SYSTEM_OPTIONS = __assign$5(__assign$5({}, DEFAULT_SYSTEM_OPTIONS), { loggerOptions: DEFAULT_LOGGER_OPTIONS, networkClient: isBrowserEnvironment ? BrowserUtils.getBrowserNetworkClient() : StubbedNetworkModule, navigationClient: new NavigationClient(), loadFrameTimeout: 0, 
        // If loadFrameTimeout is provided, use that as default.
        windowHashTimeout: (userInputSystem === null || userInputSystem === void 0 ? void 0 : userInputSystem.loadFrameTimeout) || DEFAULT_POPUP_TIMEOUT_MS, iframeHashTimeout: (userInputSystem === null || userInputSystem === void 0 ? void 0 : userInputSystem.loadFrameTimeout) || DEFAULT_IFRAME_TIMEOUT_MS, navigateFrameWait: isBrowserEnvironment && BrowserUtils.detectIEOrEdge() ? 500 : 0, redirectNavigationTimeout: DEFAULT_REDIRECT_TIMEOUT_MS, asyncPopups: false, allowRedirectInIframe: false, allowNativeBroker: false, nativeBrokerHandshakeTimeout: (userInputSystem === null || userInputSystem === void 0 ? void 0 : userInputSystem.nativeBrokerHandshakeTimeout) || DEFAULT_NATIVE_BROKER_HANDSHAKE_TIMEOUT_MS, pollIntervalMilliseconds: BrowserConstants.DEFAULT_POLL_INTERVAL_MS, cryptoOptions: {
            useMsrCrypto: false,
            entropy: undefined
        } });
    var providedSystemOptions = __assign$5(__assign$5({}, userInputSystem), { loggerOptions: (userInputSystem === null || userInputSystem === void 0 ? void 0 : userInputSystem.loggerOptions) || DEFAULT_LOGGER_OPTIONS });
    var DEFAULT_TELEMETRY_OPTIONS = {
        application: {
            appName: Constants.EMPTY_STRING,
            appVersion: Constants.EMPTY_STRING
        }
    };
    var overlayedConfig = {
        auth: __assign$5(__assign$5({}, DEFAULT_AUTH_OPTIONS), userInputAuth),
        cache: __assign$5(__assign$5({}, DEFAULT_CACHE_OPTIONS), userInputCache),
        system: __assign$5(__assign$5({}, DEFAULT_BROWSER_SYSTEM_OPTIONS), providedSystemOptions),
        telemetry: __assign$5(__assign$5({}, DEFAULT_TELEMETRY_OPTIONS), userInputTelemetry)
    };
    return overlayedConfig;
}

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var SilentHandler = /** @class */ (function (_super) {
    __extends$g(SilentHandler, _super);
    function SilentHandler(authCodeModule, storageImpl, authCodeRequest, logger, systemOptions, performanceClient) {
        var _this = _super.call(this, authCodeModule, storageImpl, authCodeRequest, logger, performanceClient) || this;
        _this.navigateFrameWait = systemOptions.navigateFrameWait;
        _this.pollIntervalMilliseconds = systemOptions.pollIntervalMilliseconds;
        return _this;
    }
    /**
     * Creates a hidden iframe to given URL using user-requested scopes as an id.
     * @param urlNavigate
     * @param userRequestScopes
     */
    SilentHandler.prototype.initiateAuthRequest = function (requestUrl) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentHandlerInitiateAuthRequest, this.authCodeRequest.correlationId);
                        if (StringUtils.isEmpty(requestUrl)) {
                            // Throw error if request URL is empty.
                            this.logger.info("Navigate url is empty");
                            throw BrowserAuthError.createEmptyNavigationUriError();
                        }
                        if (!this.navigateFrameWait) return [3 /*break*/, 2];
                        this.performanceClient.setPreQueueTime(PerformanceEvents.SilentHandlerLoadFrame, this.authCodeRequest.correlationId);
                        return [4 /*yield*/, this.loadFrame(requestUrl)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/, this.loadFrameSync(requestUrl)];
                }
            });
        });
    };
    /**
     * Monitors an iframe content window until it loads a url with a known hash, or hits a specified timeout.
     * @param iframe
     * @param timeout
     */
    SilentHandler.prototype.monitorIframeForHash = function (iframe, timeout) {
        var _this = this;
        this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentHandlerMonitorIframeForHash, this.authCodeRequest.correlationId);
        return new Promise(function (resolve, reject) {
            if (timeout < DEFAULT_IFRAME_TIMEOUT_MS) {
                _this.logger.warning("system.loadFrameTimeout or system.iframeHashTimeout set to lower (" + timeout + "ms) than the default (" + DEFAULT_IFRAME_TIMEOUT_MS + "ms). This may result in timeouts.");
            }
            /*
             * Polling for iframes can be purely timing based,
             * since we don't need to account for interaction.
             */
            var nowMark = window.performance.now();
            var timeoutMark = nowMark + timeout;
            var intervalId = setInterval(function () {
                if (window.performance.now() > timeoutMark) {
                    _this.removeHiddenIframe(iframe);
                    clearInterval(intervalId);
                    reject(BrowserAuthError.createMonitorIframeTimeoutError());
                    return;
                }
                var href = Constants.EMPTY_STRING;
                var contentWindow = iframe.contentWindow;
                try {
                    /*
                     * Will throw if cross origin,
                     * which should be caught and ignored
                     * since we need the interval to keep running while on STS UI.
                     */
                    href = contentWindow ? contentWindow.location.href : Constants.EMPTY_STRING;
                }
                catch (e) { }
                if (StringUtils.isEmpty(href)) {
                    return;
                }
                var contentHash = contentWindow ? contentWindow.location.hash : Constants.EMPTY_STRING;
                if (UrlString.hashContainsKnownProperties(contentHash)) {
                    // Success case
                    _this.removeHiddenIframe(iframe);
                    clearInterval(intervalId);
                    resolve(contentHash);
                    return;
                }
            }, _this.pollIntervalMilliseconds);
        });
    };
    /**
     * @hidden
     * Loads iframe with authorization endpoint URL
     * @ignore
     */
    SilentHandler.prototype.loadFrame = function (urlNavigate) {
        var _this = this;
        this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentHandlerLoadFrame, this.authCodeRequest.correlationId);
        /*
         * This trick overcomes iframe navigation in IE
         * IE does not load the page consistently in iframe
         */
        return new Promise(function (resolve, reject) {
            var frameHandle = _this.createHiddenIframe();
            setTimeout(function () {
                if (!frameHandle) {
                    reject("Unable to load iframe");
                    return;
                }
                frameHandle.src = urlNavigate;
                resolve(frameHandle);
            }, _this.navigateFrameWait);
        });
    };
    /**
     * @hidden
     * Loads the iframe synchronously when the navigateTimeFrame is set to `0`
     * @param urlNavigate
     * @param frameName
     * @param logger
     */
    SilentHandler.prototype.loadFrameSync = function (urlNavigate) {
        var frameHandle = this.createHiddenIframe();
        frameHandle.src = urlNavigate;
        return frameHandle;
    };
    /**
     * @hidden
     * Creates a new hidden iframe or gets an existing one for silent token renewal.
     * @ignore
     */
    SilentHandler.prototype.createHiddenIframe = function () {
        var authFrame = document.createElement("iframe");
        authFrame.style.visibility = "hidden";
        authFrame.style.position = "absolute";
        authFrame.style.width = authFrame.style.height = "0";
        authFrame.style.border = "0";
        authFrame.setAttribute("sandbox", "allow-scripts allow-same-origin allow-forms");
        document.getElementsByTagName("body")[0].appendChild(authFrame);
        return authFrame;
    };
    /**
     * @hidden
     * Removes a hidden iframe from the page.
     * @ignore
     */
    SilentHandler.prototype.removeHiddenIframe = function (iframe) {
        if (document.body === iframe.parentNode) {
            document.body.removeChild(iframe);
        }
    };
    return SilentHandler;
}(InteractionHandler));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var SilentIframeClient = /** @class */ (function (_super) {
    __extends$g(SilentIframeClient, _super);
    function SilentIframeClient(config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, apiId, performanceClient, nativeStorageImpl, nativeMessageHandler, correlationId) {
        var _this = _super.call(this, config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, performanceClient, nativeMessageHandler, correlationId) || this;
        _this.apiId = apiId;
        _this.nativeStorage = nativeStorageImpl;
        return _this;
    }
    /**
     * Acquires a token silently by opening a hidden iframe to the /authorize endpoint with prompt=none or prompt=no_session
     * @param request
     */
    SilentIframeClient.prototype.acquireToken = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var acquireTokenMeasurement, silentRequest, serverTelemetryManager, authClient, e_1;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentIframeClientAcquireToken, request.correlationId);
                        this.logger.verbose("acquireTokenByIframe called");
                        acquireTokenMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.SilentIframeClientAcquireToken, request.correlationId);
                        // Check that we have some SSO data
                        if (StringUtils.isEmpty(request.loginHint) && StringUtils.isEmpty(request.sid) && (!request.account || StringUtils.isEmpty(request.account.username))) {
                            this.logger.warning("No user hint provided. The authorization server may need more information to complete this request.");
                        }
                        // Check that prompt is set to none or no_session, throw error if it is set to anything else.
                        if (request.prompt && (request.prompt !== PromptValue.NONE) && (request.prompt !== PromptValue.NO_SESSION)) {
                            acquireTokenMeasurement.endMeasurement({
                                success: false
                            });
                            throw BrowserAuthError.createSilentPromptValueError(request.prompt);
                        }
                        // Create silent request
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest, request.correlationId);
                        return [4 /*yield*/, this.initializeAuthorizationRequest(__assign$5(__assign$5({}, request), { prompt: request.prompt || PromptValue.NONE }), InteractionType.Silent)];
                    case 1:
                        silentRequest = _a.sent();
                        this.browserStorage.updateCacheEntries(silentRequest.state, silentRequest.nonce, silentRequest.authority, silentRequest.loginHint || Constants.EMPTY_STRING, silentRequest.account || null);
                        serverTelemetryManager = this.initializeServerTelemetryManager(this.apiId);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 6]);
                        // Initialize the client
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient, request.correlationId);
                        return [4 /*yield*/, this.createAuthCodeClient(serverTelemetryManager, silentRequest.authority, silentRequest.azureCloudOptions)];
                    case 3:
                        authClient = _a.sent();
                        this.logger.verbose("Auth code client created");
                        this.performanceClient.setPreQueueTime(PerformanceEvents.SilentIframeClientTokenHelper, request.correlationId);
                        return [4 /*yield*/, this.silentTokenHelper(authClient, silentRequest).then(function (result) {
                                acquireTokenMeasurement.endMeasurement({
                                    success: true,
                                    fromCache: false,
                                    requestId: result.requestId
                                });
                                return result;
                            })];
                    case 4: return [2 /*return*/, _a.sent()];
                    case 5:
                        e_1 = _a.sent();
                        if (e_1 instanceof AuthError) {
                            e_1.setCorrelationId(this.correlationId);
                        }
                        serverTelemetryManager.cacheFailedRequest(e_1);
                        this.browserStorage.cleanRequestByState(silentRequest.state);
                        acquireTokenMeasurement.endMeasurement({
                            errorCode: e_1 instanceof AuthError && e_1.errorCode || undefined,
                            subErrorCode: e_1 instanceof AuthError && e_1.subError || undefined,
                            success: false
                        });
                        throw e_1;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Currently Unsupported
     */
    SilentIframeClient.prototype.logout = function () {
        // Synchronous so we must reject
        return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError());
    };
    /**
     * Helper which acquires an authorization code silently using a hidden iframe from given url
     * using the scopes requested as part of the id, and exchanges the code for a set of OAuth tokens.
     * @param navigateUrl
     * @param userRequestScopes
     */
    SilentIframeClient.prototype.silentTokenHelper = function (authClient, silentRequest) {
        return __awaiter$3(this, void 0, void 0, function () {
            var authCodeRequest, navigateUrl, silentHandler, msalFrame, hash, serverParams, state, nativeInteractionClient, userRequestState;
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentIframeClientTokenHelper, silentRequest.correlationId);
                        // Create auth code request and generate PKCE params
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationCodeRequest, silentRequest.correlationId);
                        return [4 /*yield*/, this.initializeAuthorizationCodeRequest(silentRequest)];
                    case 1:
                        authCodeRequest = _a.sent();
                        // Create authorize request url
                        this.performanceClient.setPreQueueTime(PerformanceEvents.GetAuthCodeUrl, silentRequest.correlationId);
                        return [4 /*yield*/, authClient.getAuthCodeUrl(__assign$5(__assign$5({}, silentRequest), { nativeBroker: NativeMessageHandler.isNativeAvailable(this.config, this.logger, this.nativeMessageHandler, silentRequest.authenticationScheme) }))];
                    case 2:
                        navigateUrl = _a.sent();
                        silentHandler = new SilentHandler(authClient, this.browserStorage, authCodeRequest, this.logger, this.config.system, this.performanceClient);
                        // Get the frame handle for the silent request
                        this.performanceClient.setPreQueueTime(PerformanceEvents.SilentHandlerInitiateAuthRequest, silentRequest.correlationId);
                        return [4 /*yield*/, silentHandler.initiateAuthRequest(navigateUrl)];
                    case 3:
                        msalFrame = _a.sent();
                        // Monitor the window for the hash. Return the string value and close the popup when the hash is received. Default timeout is 60 seconds.
                        this.performanceClient.setPreQueueTime(PerformanceEvents.SilentHandlerMonitorIframeForHash, silentRequest.correlationId);
                        return [4 /*yield*/, silentHandler.monitorIframeForHash(msalFrame, this.config.system.iframeHashTimeout)];
                    case 4:
                        hash = _a.sent();
                        serverParams = UrlString.getDeserializedHash(hash);
                        state = this.validateAndExtractStateFromHash(serverParams, InteractionType.Silent, authCodeRequest.correlationId);
                        if (serverParams.accountId) {
                            this.logger.verbose("Account id found in hash, calling WAM for token");
                            if (!this.nativeMessageHandler) {
                                throw BrowserAuthError.createNativeConnectionNotEstablishedError();
                            }
                            nativeInteractionClient = new NativeInteractionClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, this.apiId, this.performanceClient, this.nativeMessageHandler, serverParams.accountId, this.browserStorage, this.correlationId);
                            userRequestState = ProtocolUtils.parseRequestState(this.browserCrypto, state).userRequestState;
                            return [2 /*return*/, nativeInteractionClient.acquireToken(__assign$5(__assign$5({}, silentRequest), { state: userRequestState, prompt: silentRequest.prompt || PromptValue.NONE })).finally(function () {
                                    _this.browserStorage.cleanRequestByState(state);
                                })];
                        }
                        // Handle response from hash string
                        this.performanceClient.setPreQueueTime(PerformanceEvents.HandleCodeResponseFromHash, silentRequest.correlationId);
                        return [2 /*return*/, silentHandler.handleCodeResponseFromHash(hash, state, authClient.authority, this.networkClient)];
                }
            });
        });
    };
    return SilentIframeClient;
}(StandardInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var SilentRefreshClient = /** @class */ (function (_super) {
    __extends$g(SilentRefreshClient, _super);
    function SilentRefreshClient() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Exchanges the refresh token for new tokens
     * @param request
     */
    SilentRefreshClient.prototype.acquireToken = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var silentRequest, _a, acquireTokenMeasurement, serverTelemetryManager, refreshTokenClient;
            var _this = this;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentRefreshClientAcquireToken, request.correlationId);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.InitializeBaseRequest, request.correlationId);
                        _a = [__assign$5({}, request)];
                        return [4 /*yield*/, this.initializeBaseRequest(request, request.account)];
                    case 1:
                        silentRequest = __assign$5.apply(void 0, _a.concat([_b.sent()]));
                        acquireTokenMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.SilentRefreshClientAcquireToken, silentRequest.correlationId);
                        serverTelemetryManager = this.initializeServerTelemetryManager(ApiId.acquireTokenSilent_silentFlow);
                        return [4 /*yield*/, this.createRefreshTokenClient(serverTelemetryManager, silentRequest.authority, silentRequest.azureCloudOptions)];
                    case 2:
                        refreshTokenClient = _b.sent();
                        this.logger.verbose("Refresh token client created");
                        // Send request to renew token. Auth module will throw errors if token cannot be renewed.
                        this.performanceClient.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenByRefreshToken, request.correlationId);
                        return [2 /*return*/, refreshTokenClient.acquireTokenByRefreshToken(silentRequest)
                                .then(function (result) {
                                acquireTokenMeasurement.endMeasurement({
                                    success: true,
                                    fromCache: result.fromCache,
                                    requestId: result.requestId
                                });
                                return result;
                            })
                                .catch(function (e) {
                                if (e instanceof AuthError) {
                                    e.setCorrelationId(_this.correlationId);
                                }
                                serverTelemetryManager.cacheFailedRequest(e);
                                acquireTokenMeasurement.endMeasurement({
                                    errorCode: e.errorCode,
                                    subErrorCode: e.subError,
                                    success: false
                                });
                                throw e;
                            })];
                }
            });
        });
    };
    /**
     * Currently Unsupported
     */
    SilentRefreshClient.prototype.logout = function () {
        // Synchronous so we must reject
        return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError());
    };
    /**
     * Creates a Refresh Client with the given authority, or the default authority.
     * @param serverTelemetryManager
     * @param authorityUrl
     */
    SilentRefreshClient.prototype.createRefreshTokenClient = function (serverTelemetryManager, authorityUrl, azureCloudOptions) {
        return __awaiter$3(this, void 0, void 0, function () {
            var clientConfig;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Create auth module.
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetClientConfiguration, this.correlationId);
                        return [4 /*yield*/, this.getClientConfiguration(serverTelemetryManager, authorityUrl, azureCloudOptions)];
                    case 1:
                        clientConfig = _a.sent();
                        return [2 /*return*/, new RefreshTokenClient(clientConfig, this.performanceClient)];
                }
            });
        });
    };
    return SilentRefreshClient;
}(StandardInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var EventHandler = /** @class */ (function () {
    function EventHandler(logger, browserCrypto) {
        this.eventCallbacks = new Map();
        this.logger = logger;
        this.browserCrypto = browserCrypto;
        this.listeningToStorageEvents = false;
        this.handleAccountCacheChange = this.handleAccountCacheChange.bind(this);
    }
    /**
     * Adds event callbacks to array
     * @param callback
     */
    EventHandler.prototype.addEventCallback = function (callback) {
        if (typeof window !== "undefined") {
            var callbackId = this.browserCrypto.createNewGuid();
            this.eventCallbacks.set(callbackId, callback);
            this.logger.verbose("Event callback registered with id: " + callbackId);
            return callbackId;
        }
        return null;
    };
    /**
     * Removes callback with provided id from callback array
     * @param callbackId
     */
    EventHandler.prototype.removeEventCallback = function (callbackId) {
        this.eventCallbacks.delete(callbackId);
        this.logger.verbose("Event callback " + callbackId + " removed.");
    };
    /**
     * Adds event listener that emits an event when a user account is added or removed from localstorage in a different browser tab or window
     */
    EventHandler.prototype.enableAccountStorageEvents = function () {
        if (typeof window === "undefined") {
            return;
        }
        if (!this.listeningToStorageEvents) {
            this.logger.verbose("Adding account storage listener.");
            this.listeningToStorageEvents = true;
            window.addEventListener("storage", this.handleAccountCacheChange);
        }
        else {
            this.logger.verbose("Account storage listener already registered.");
        }
    };
    /**
     * Removes event listener that emits an event when a user account is added or removed from localstorage in a different browser tab or window
     */
    EventHandler.prototype.disableAccountStorageEvents = function () {
        if (typeof window === "undefined") {
            return;
        }
        if (this.listeningToStorageEvents) {
            this.logger.verbose("Removing account storage listener.");
            window.removeEventListener("storage", this.handleAccountCacheChange);
            this.listeningToStorageEvents = false;
        }
        else {
            this.logger.verbose("No account storage listener registered.");
        }
    };
    /**
     * Emits events by calling callback with event message
     * @param eventType
     * @param interactionType
     * @param payload
     * @param error
     */
    EventHandler.prototype.emitEvent = function (eventType, interactionType, payload, error) {
        var _this = this;
        if (typeof window !== "undefined") {
            var message_1 = {
                eventType: eventType,
                interactionType: interactionType || null,
                payload: payload || null,
                error: error || null,
                timestamp: Date.now()
            };
            this.logger.info("Emitting event: " + eventType);
            this.eventCallbacks.forEach(function (callback, callbackId) {
                _this.logger.verbose("Emitting event to callback " + callbackId + ": " + eventType);
                callback.apply(null, [message_1]);
            });
        }
    };
    /**
     * Emit account added/removed events when cached accounts are changed in a different tab or frame
     */
    EventHandler.prototype.handleAccountCacheChange = function (e) {
        try {
            var cacheValue = e.newValue || e.oldValue;
            if (!cacheValue) {
                return;
            }
            var parsedValue = JSON.parse(cacheValue);
            if (typeof parsedValue !== "object" || !AccountEntity.isAccountEntity(parsedValue)) {
                return;
            }
            var accountEntity = CacheManager.toObject(new AccountEntity(), parsedValue);
            var accountInfo = accountEntity.getAccountInfo();
            if (!e.oldValue && e.newValue) {
                this.logger.info("Account was added to cache in a different window");
                this.emitEvent(EventType.ACCOUNT_ADDED, undefined, accountInfo);
            }
            else if (!e.newValue && e.oldValue) {
                this.logger.info("Account was removed from cache in a different window");
                this.emitEvent(EventType.ACCOUNT_REMOVED, undefined, accountInfo);
            }
        }
        catch (e) {
            return;
        }
    };
    return EventHandler;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Utility class for math specific functions in browser.
 */
var MathUtils = /** @class */ (function () {
    function MathUtils() {
    }
    /**
     * Decimal to Hex
     *
     * @param num
     */
    MathUtils.decimalToHex = function (num) {
        var hex = num.toString(16);
        while (hex.length < 2) {
            hex = "0" + hex;
        }
        return hex;
    };
    return MathUtils;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var GuidGenerator = /** @class */ (function () {
    function GuidGenerator(cryptoObj) {
        this.cryptoObj = cryptoObj;
    }
    /*
     * RFC4122: The version 4 UUID is meant for generating UUIDs from truly-random or
     * pseudo-random numbers.
     * The algorithm is as follows:
     *     Set the two most significant bits (bits 6 and 7) of the
     *        clock_seq_hi_and_reserved to zero and one, respectively.
     *     Set the four most significant bits (bits 12 through 15) of the
     *        time_hi_and_version field to the 4-bit version number from
     *        Section 4.1.3. Version4
     *     Set all the other bits to randomly (or pseudo-randomly) chosen
     *     values.
     * UUID                   = time-low "-" time-mid "-"time-high-and-version "-"clock-seq-reserved and low(2hexOctet)"-" node
     * time-low               = 4hexOctet
     * time-mid               = 2hexOctet
     * time-high-and-version  = 2hexOctet
     * clock-seq-and-reserved = hexOctet:
     * clock-seq-low          = hexOctet
     * node                   = 6hexOctet
     * Format: xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx
     * y could be 1000, 1001, 1010, 1011 since most significant two bits needs to be 10
     * y values are 8, 9, A, B
     */
    GuidGenerator.prototype.generateGuid = function () {
        try {
            var buffer = new Uint8Array(16);
            this.cryptoObj.getRandomValues(buffer);
            // buffer[6] and buffer[7] represents the time_hi_and_version field. We will set the four most significant bits (4 through 7) of buffer[6] to represent decimal number 4 (UUID version number).
            buffer[6] |= 0x40; // buffer[6] | 01000000 will set the 6 bit to 1.
            buffer[6] &= 0x4f; // buffer[6] & 01001111 will set the 4, 5, and 7 bit to 0 such that bits 4-7 == 0100 = "4".
            // buffer[8] represents the clock_seq_hi_and_reserved field. We will set the two most significant bits (6 and 7) of the clock_seq_hi_and_reserved to zero and one, respectively.
            buffer[8] |= 0x80; // buffer[8] | 10000000 will set the 7 bit to 1.
            buffer[8] &= 0xbf; // buffer[8] & 10111111 will set the 6 bit to 0.
            return MathUtils.decimalToHex(buffer[0]) + MathUtils.decimalToHex(buffer[1])
                + MathUtils.decimalToHex(buffer[2]) + MathUtils.decimalToHex(buffer[3])
                + "-" + MathUtils.decimalToHex(buffer[4]) + MathUtils.decimalToHex(buffer[5])
                + "-" + MathUtils.decimalToHex(buffer[6]) + MathUtils.decimalToHex(buffer[7])
                + "-" + MathUtils.decimalToHex(buffer[8]) + MathUtils.decimalToHex(buffer[9])
                + "-" + MathUtils.decimalToHex(buffer[10]) + MathUtils.decimalToHex(buffer[11])
                + MathUtils.decimalToHex(buffer[12]) + MathUtils.decimalToHex(buffer[13])
                + MathUtils.decimalToHex(buffer[14]) + MathUtils.decimalToHex(buffer[15]);
        }
        catch (err) {
            var guidHolder = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx";
            var hex = "0123456789abcdef";
            var r = 0;
            var guidResponse = Constants.EMPTY_STRING;
            for (var i = 0; i < 36; i++) {
                if (guidHolder[i] !== "-" && guidHolder[i] !== "4") {
                    // each x and y needs to be random
                    r = Math.random() * 16 | 0;
                }
                if (guidHolder[i] === "x") {
                    guidResponse += hex[r];
                }
                else if (guidHolder[i] === "y") {
                    // clock-seq-and-reserved first hex is filtered and remaining hex values are random
                    r &= 0x3; // bit and with 0011 to set pos 2 to zero ?0??
                    r |= 0x8; // set pos 3 to 1 as 1???
                    guidResponse += hex[r];
                }
                else {
                    guidResponse += guidHolder[i];
                }
            }
            return guidResponse;
        }
    };
    /**
     * verifies if a string is  GUID
     * @param guid
     */
    GuidGenerator.prototype.isGuid = function (guid) {
        var regexGuid = /^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i;
        return regexGuid.test(guid);
    };
    return GuidGenerator;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Utility functions for strings in a browser. See here for implementation details:
 * https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding#Solution_2_%E2%80%93_JavaScript's_UTF-16_%3E_UTF-8_%3E_base64
 */
var BrowserStringUtils = /** @class */ (function () {
    function BrowserStringUtils() {
    }
    /**
     * Converts string to Uint8Array
     * @param sDOMStr
     */
    BrowserStringUtils.stringToUtf8Arr = function (sDOMStr) {
        var nChr;
        var nArrLen = 0;
        var nStrLen = sDOMStr.length;
        /* mapping... */
        for (var nMapIdx = 0; nMapIdx < nStrLen; nMapIdx++) {
            nChr = sDOMStr.charCodeAt(nMapIdx);
            nArrLen += nChr < 0x80 ? 1 : nChr < 0x800 ? 2 : nChr < 0x10000 ? 3 : nChr < 0x200000 ? 4 : nChr < 0x4000000 ? 5 : 6;
        }
        var aBytes = new Uint8Array(nArrLen);
        /* transcription... */
        for (var nIdx = 0, nChrIdx = 0; nIdx < nArrLen; nChrIdx++) {
            nChr = sDOMStr.charCodeAt(nChrIdx);
            if (nChr < 128) {
                /* one byte */
                aBytes[nIdx++] = nChr;
            }
            else if (nChr < 0x800) {
                /* two bytes */
                aBytes[nIdx++] = 192 + (nChr >>> 6);
                aBytes[nIdx++] = 128 + (nChr & 63);
            }
            else if (nChr < 0x10000) {
                /* three bytes */
                aBytes[nIdx++] = 224 + (nChr >>> 12);
                aBytes[nIdx++] = 128 + (nChr >>> 6 & 63);
                aBytes[nIdx++] = 128 + (nChr & 63);
            }
            else if (nChr < 0x200000) {
                /* four bytes */
                aBytes[nIdx++] = 240 + (nChr >>> 18);
                aBytes[nIdx++] = 128 + (nChr >>> 12 & 63);
                aBytes[nIdx++] = 128 + (nChr >>> 6 & 63);
                aBytes[nIdx++] = 128 + (nChr & 63);
            }
            else if (nChr < 0x4000000) {
                /* five bytes */
                aBytes[nIdx++] = 248 + (nChr >>> 24);
                aBytes[nIdx++] = 128 + (nChr >>> 18 & 63);
                aBytes[nIdx++] = 128 + (nChr >>> 12 & 63);
                aBytes[nIdx++] = 128 + (nChr >>> 6 & 63);
                aBytes[nIdx++] = 128 + (nChr & 63);
            }
            else /* if (nChr <= 0x7fffffff) */ {
                /* six bytes */
                aBytes[nIdx++] = 252 + (nChr >>> 30);
                aBytes[nIdx++] = 128 + (nChr >>> 24 & 63);
                aBytes[nIdx++] = 128 + (nChr >>> 18 & 63);
                aBytes[nIdx++] = 128 + (nChr >>> 12 & 63);
                aBytes[nIdx++] = 128 + (nChr >>> 6 & 63);
                aBytes[nIdx++] = 128 + (nChr & 63);
            }
        }
        return aBytes;
    };
    /**
     * Converst string to ArrayBuffer
     * @param dataString
     */
    BrowserStringUtils.stringToArrayBuffer = function (dataString) {
        var data = new ArrayBuffer(dataString.length);
        var dataView = new Uint8Array(data);
        for (var i = 0; i < dataString.length; i++) {
            dataView[i] = dataString.charCodeAt(i);
        }
        return data;
    };
    /**
     * Converts Uint8Array to a string
     * @param aBytes
     */
    BrowserStringUtils.utf8ArrToString = function (aBytes) {
        var sView = Constants.EMPTY_STRING;
        for (var nPart = void 0, nLen = aBytes.length, nIdx = 0; nIdx < nLen; nIdx++) {
            nPart = aBytes[nIdx];
            sView += String.fromCharCode(nPart > 251 && nPart < 254 && nIdx + 5 < nLen ? /* six bytes */
                /* (nPart - 252 << 30) may be not so safe in ECMAScript! So...: */
                (nPart - 252) * 1073741824 + (aBytes[++nIdx] - 128 << 24) + (aBytes[++nIdx] - 128 << 18) + (aBytes[++nIdx] - 128 << 12) + (aBytes[++nIdx] - 128 << 6) + aBytes[++nIdx] - 128
                : nPart > 247 && nPart < 252 && nIdx + 4 < nLen ? /* five bytes */
                    (nPart - 248 << 24) + (aBytes[++nIdx] - 128 << 18) + (aBytes[++nIdx] - 128 << 12) + (aBytes[++nIdx] - 128 << 6) + aBytes[++nIdx] - 128
                    : nPart > 239 && nPart < 248 && nIdx + 3 < nLen ? /* four bytes */
                        (nPart - 240 << 18) + (aBytes[++nIdx] - 128 << 12) + (aBytes[++nIdx] - 128 << 6) + aBytes[++nIdx] - 128
                        : nPart > 223 && nPart < 240 && nIdx + 2 < nLen ? /* three bytes */
                            (nPart - 224 << 12) + (aBytes[++nIdx] - 128 << 6) + aBytes[++nIdx] - 128
                            : nPart > 191 && nPart < 224 && nIdx + 1 < nLen ? /* two bytes */
                                (nPart - 192 << 6) + aBytes[++nIdx] - 128
                                : /* nPart < 127 ? */ /* one byte */
                                    nPart);
        }
        return sView;
    };
    /**
     * Returns stringified jwk.
     * @param jwk
     */
    BrowserStringUtils.getSortedObjectString = function (obj) {
        return JSON.stringify(obj, Object.keys(obj).sort());
    };
    return BrowserStringUtils;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Class which exposes APIs to encode plaintext to base64 encoded string. See here for implementation details:
 * https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding#Solution_2_%E2%80%93_JavaScript's_UTF-16_%3E_UTF-8_%3E_base64
 */
var Base64Encode = /** @class */ (function () {
    function Base64Encode() {
    }
    /**
     * Returns URL Safe b64 encoded string from a plaintext string.
     * @param input
     */
    Base64Encode.prototype.urlEncode = function (input) {
        return encodeURIComponent(this.encode(input)
            .replace(/=/g, Constants.EMPTY_STRING)
            .replace(/\+/g, "-")
            .replace(/\//g, "_"));
    };
    /**
     * Returns URL Safe b64 encoded string from an int8Array.
     * @param inputArr
     */
    Base64Encode.prototype.urlEncodeArr = function (inputArr) {
        return this.base64EncArr(inputArr)
            .replace(/=/g, Constants.EMPTY_STRING)
            .replace(/\+/g, "-")
            .replace(/\//g, "_");
    };
    /**
     * Returns b64 encoded string from plaintext string.
     * @param input
     */
    Base64Encode.prototype.encode = function (input) {
        var inputUtf8Arr = BrowserStringUtils.stringToUtf8Arr(input);
        return this.base64EncArr(inputUtf8Arr);
    };
    /**
     * Base64 encode byte array
     * @param aBytes
     */
    Base64Encode.prototype.base64EncArr = function (aBytes) {
        var eqLen = (3 - (aBytes.length % 3)) % 3;
        var sB64Enc = Constants.EMPTY_STRING;
        for (var nMod3 = void 0, nLen = aBytes.length, nUint24 = 0, nIdx = 0; nIdx < nLen; nIdx++) {
            nMod3 = nIdx % 3;
            /* Uncomment the following line in order to split the output in lines 76-character long: */
            /*
             *if (nIdx > 0 && (nIdx * 4 / 3) % 76 === 0) { sB64Enc += "\r\n"; }
             */
            nUint24 |= aBytes[nIdx] << (16 >>> nMod3 & 24);
            if (nMod3 === 2 || aBytes.length - nIdx === 1) {
                sB64Enc += String.fromCharCode(this.uint6ToB64(nUint24 >>> 18 & 63), this.uint6ToB64(nUint24 >>> 12 & 63), this.uint6ToB64(nUint24 >>> 6 & 63), this.uint6ToB64(nUint24 & 63));
                nUint24 = 0;
            }
        }
        return eqLen === 0 ? sB64Enc : sB64Enc.substring(0, sB64Enc.length - eqLen) + (eqLen === 1 ? "=" : "==");
    };
    /**
     * Base64 string to array encoding helper
     * @param nUint6
     */
    Base64Encode.prototype.uint6ToB64 = function (nUint6) {
        return nUint6 < 26 ?
            nUint6 + 65
            : nUint6 < 52 ?
                nUint6 + 71
                : nUint6 < 62 ?
                    nUint6 - 4
                    : nUint6 === 62 ?
                        43
                        : nUint6 === 63 ?
                            47
                            :
                                65;
    };
    return Base64Encode;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Class which exposes APIs to decode base64 strings to plaintext. See here for implementation details:
 * https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding#Solution_2_%E2%80%93_JavaScript's_UTF-16_%3E_UTF-8_%3E_base64
 */
var Base64Decode = /** @class */ (function () {
    function Base64Decode() {
    }
    /**
     * Returns a URL-safe plaintext decoded string from b64 encoded input.
     * @param input
     */
    Base64Decode.prototype.decode = function (input) {
        var encodedString = input.replace(/-/g, "+").replace(/_/g, "/");
        switch (encodedString.length % 4) {
            case 0:
                break;
            case 2:
                encodedString += "==";
                break;
            case 3:
                encodedString += "=";
                break;
            default:
                throw new Error("Invalid base64 string");
        }
        var inputUtf8Arr = this.base64DecToArr(encodedString);
        return BrowserStringUtils.utf8ArrToString(inputUtf8Arr);
    };
    /**
     * Decodes base64 into Uint8Array
     * @param base64String
     * @param nBlockSize
     */
    Base64Decode.prototype.base64DecToArr = function (base64String, nBlockSize) {
        var sB64Enc = base64String.replace(/[^A-Za-z0-9\+\/]/g, Constants.EMPTY_STRING);
        var nInLen = sB64Enc.length;
        var nOutLen = nBlockSize ? Math.ceil((nInLen * 3 + 1 >>> 2) / nBlockSize) * nBlockSize : nInLen * 3 + 1 >>> 2;
        var aBytes = new Uint8Array(nOutLen);
        for (var nMod3 = void 0, nMod4 = void 0, nUint24 = 0, nOutIdx = 0, nInIdx = 0; nInIdx < nInLen; nInIdx++) {
            nMod4 = nInIdx & 3;
            nUint24 |= this.b64ToUint6(sB64Enc.charCodeAt(nInIdx)) << 18 - 6 * nMod4;
            if (nMod4 === 3 || nInLen - nInIdx === 1) {
                for (nMod3 = 0; nMod3 < 3 && nOutIdx < nOutLen; nMod3++, nOutIdx++) {
                    aBytes[nOutIdx] = nUint24 >>> (16 >>> nMod3 & 24) & 255;
                }
                nUint24 = 0;
            }
        }
        return aBytes;
    };
    /**
     * Base64 string to array decoding helper
     * @param charNum
     */
    Base64Decode.prototype.b64ToUint6 = function (charNum) {
        return charNum > 64 && charNum < 91 ?
            charNum - 65
            : charNum > 96 && charNum < 123 ?
                charNum - 71
                : charNum > 47 && charNum < 58 ?
                    charNum + 4
                    : charNum === 43 ?
                        62
                        : charNum === 47 ?
                            63
                            :
                                0;
    };
    return Base64Decode;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
// Constant byte array length
var RANDOM_BYTE_ARR_LENGTH = 32;
/**
 * Class which exposes APIs to generate PKCE codes and code verifiers.
 */
var PkceGenerator = /** @class */ (function () {
    function PkceGenerator(cryptoObj) {
        this.base64Encode = new Base64Encode();
        this.cryptoObj = cryptoObj;
    }
    /**
     * Generates PKCE Codes. See the RFC for more information: https://tools.ietf.org/html/rfc7636
     */
    PkceGenerator.prototype.generateCodes = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var codeVerifier, codeChallenge;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        codeVerifier = this.generateCodeVerifier();
                        return [4 /*yield*/, this.generateCodeChallengeFromVerifier(codeVerifier)];
                    case 1:
                        codeChallenge = _a.sent();
                        return [2 /*return*/, {
                                verifier: codeVerifier,
                                challenge: codeChallenge
                            }];
                }
            });
        });
    };
    /**
     * Generates a random 32 byte buffer and returns the base64
     * encoded string to be used as a PKCE Code Verifier
     */
    PkceGenerator.prototype.generateCodeVerifier = function () {
        try {
            // Generate random values as utf-8
            var buffer = new Uint8Array(RANDOM_BYTE_ARR_LENGTH);
            this.cryptoObj.getRandomValues(buffer);
            // encode verifier as base64
            var pkceCodeVerifierB64 = this.base64Encode.urlEncodeArr(buffer);
            return pkceCodeVerifierB64;
        }
        catch (e) {
            throw BrowserAuthError.createPkceNotGeneratedError(e);
        }
    };
    /**
     * Creates a base64 encoded PKCE Code Challenge string from the
     * hash created from the PKCE Code Verifier supplied
     */
    PkceGenerator.prototype.generateCodeChallengeFromVerifier = function (pkceCodeVerifier) {
        return __awaiter$3(this, void 0, void 0, function () {
            var pkceHashedCodeVerifier, e_1;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.cryptoObj.sha256Digest(pkceCodeVerifier)];
                    case 1:
                        pkceHashedCodeVerifier = _a.sent();
                        // encode hash as base64
                        return [2 /*return*/, this.base64Encode.urlEncodeArr(new Uint8Array(pkceHashedCodeVerifier))];
                    case 2:
                        e_1 = _a.sent();
                        throw BrowserAuthError.createPkceNotGeneratedError(e_1);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return PkceGenerator;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var ModernBrowserCrypto = /** @class */ (function () {
    function ModernBrowserCrypto() {
    }
    ModernBrowserCrypto.prototype.getRandomValues = function (dataBuffer) {
        return window.crypto.getRandomValues(dataBuffer);
    };
    ModernBrowserCrypto.prototype.generateKey = function (algorithm, extractable, keyUsages) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.crypto.subtle.generateKey(algorithm, extractable, keyUsages)];
            });
        });
    };
    ModernBrowserCrypto.prototype.exportKey = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.crypto.subtle.exportKey(KEY_FORMAT_JWK, key)];
            });
        });
    };
    ModernBrowserCrypto.prototype.importKey = function (keyData, algorithm, extractable, keyUsages) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.crypto.subtle.importKey(KEY_FORMAT_JWK, keyData, algorithm, extractable, keyUsages)];
            });
        });
    };
    ModernBrowserCrypto.prototype.sign = function (algorithm, key, data) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.crypto.subtle.sign(algorithm, key, data)];
            });
        });
    };
    ModernBrowserCrypto.prototype.digest = function (algorithm, data) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.crypto.subtle.digest(algorithm, data)];
            });
        });
    };
    return ModernBrowserCrypto;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var MsrBrowserCrypto = /** @class */ (function () {
    function MsrBrowserCrypto() {
    }
    MsrBrowserCrypto.prototype.initPrng = function (entropy) {
        // Turn into array, as initPrng seems to not always like Uint8Array (even though it should support both)
        return window.msrCrypto.initPrng(__spread(entropy));
    };
    MsrBrowserCrypto.prototype.getRandomValues = function (dataBuffer) {
        return window.msrCrypto.getRandomValues(dataBuffer);
    };
    MsrBrowserCrypto.prototype.generateKey = function (algorithm, extractable, keyUsages) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.msrCrypto.subtle.generateKey(algorithm, extractable, keyUsages)];
            });
        });
    };
    MsrBrowserCrypto.prototype.exportKey = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.msrCrypto.subtle.exportKey(KEY_FORMAT_JWK, key)];
            });
        });
    };
    MsrBrowserCrypto.prototype.importKey = function (keyData, algorithm, extractable, keyUsages) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.msrCrypto.subtle.importKey(KEY_FORMAT_JWK, keyData, algorithm, extractable, keyUsages)];
            });
        });
    };
    MsrBrowserCrypto.prototype.sign = function (algorithm, key, data) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.msrCrypto.subtle.sign(algorithm, key, data)];
            });
        });
    };
    MsrBrowserCrypto.prototype.digest = function (algorithm, data) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, window.msrCrypto.subtle.digest(algorithm, data)];
            });
        });
    };
    return MsrBrowserCrypto;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var MsBrowserCrypto = /** @class */ (function () {
    function MsBrowserCrypto() {
    }
    MsBrowserCrypto.prototype.getRandomValues = function (dataBuffer) {
        return window["msCrypto"].getRandomValues(dataBuffer);
    };
    MsBrowserCrypto.prototype.generateKey = function (algorithm, extractable, keyUsages) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var msGenerateKey = window["msCrypto"].subtle.generateKey(algorithm, extractable, keyUsages);
                        msGenerateKey.addEventListener("complete", function (e) {
                            resolve(e.target.result);
                        });
                        msGenerateKey.addEventListener("error", function (error) {
                            reject(error);
                        });
                    })];
            });
        });
    };
    MsBrowserCrypto.prototype.exportKey = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var msExportKey = window["msCrypto"].subtle.exportKey(KEY_FORMAT_JWK, key);
                        msExportKey.addEventListener("complete", function (e) {
                            var resultBuffer = e.target.result;
                            var resultString = BrowserStringUtils.utf8ArrToString(new Uint8Array(resultBuffer))
                                .replace(/\r/g, Constants.EMPTY_STRING)
                                .replace(/\n/g, Constants.EMPTY_STRING)
                                .replace(/\t/g, Constants.EMPTY_STRING)
                                .split(" ").join(Constants.EMPTY_STRING)
                                .replace("\u0000", Constants.EMPTY_STRING);
                            try {
                                resolve(JSON.parse(resultString));
                            }
                            catch (e) {
                                reject(e);
                            }
                        });
                        msExportKey.addEventListener("error", function (error) {
                            reject(error);
                        });
                    })];
            });
        });
    };
    MsBrowserCrypto.prototype.importKey = function (keyData, algorithm, extractable, keyUsages) {
        return __awaiter$3(this, void 0, void 0, function () {
            var keyString, keyBuffer;
            return __generator$3(this, function (_a) {
                keyString = BrowserStringUtils.getSortedObjectString(keyData);
                keyBuffer = BrowserStringUtils.stringToArrayBuffer(keyString);
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var msImportKey = window["msCrypto"].subtle.importKey(KEY_FORMAT_JWK, keyBuffer, algorithm, extractable, keyUsages);
                        msImportKey.addEventListener("complete", function (e) {
                            resolve(e.target.result);
                        });
                        msImportKey.addEventListener("error", function (error) {
                            reject(error);
                        });
                    })];
            });
        });
    };
    MsBrowserCrypto.prototype.sign = function (algorithm, key, data) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var msSign = window["msCrypto"].subtle.sign(algorithm, key, data);
                        msSign.addEventListener("complete", function (e) {
                            resolve(e.target.result);
                        });
                        msSign.addEventListener("error", function (error) {
                            reject(error);
                        });
                    })];
            });
        });
    };
    MsBrowserCrypto.prototype.digest = function (algorithm, data) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var digestOperation = window["msCrypto"].subtle.digest(algorithm, data.buffer);
                        digestOperation.addEventListener("complete", function (e) {
                            resolve(e.target.result);
                        });
                        digestOperation.addEventListener("error", function (error) {
                            reject(error);
                        });
                    })];
            });
        });
    };
    return MsBrowserCrypto;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * See here for more info on RsaHashedKeyGenParams: https://developer.mozilla.org/en-US/docs/Web/API/RsaHashedKeyGenParams
 */
// RSA KeyGen Algorithm
var PKCS1_V15_KEYGEN_ALG = "RSASSA-PKCS1-v1_5";
// SHA-256 hashing algorithm
var S256_HASH_ALG = "SHA-256";
// MOD length for PoP tokens
var MODULUS_LENGTH = 2048;
// Public Exponent
var PUBLIC_EXPONENT = new Uint8Array([0x01, 0x00, 0x01]);
/**
 * This class implements functions used by the browser library to perform cryptography operations such as
 * hashing and encoding. It also has helper functions to validate the availability of specific APIs.
 */
var BrowserCrypto = /** @class */ (function () {
    function BrowserCrypto(logger, cryptoOptions) {
        var _a, _b;
        this.logger = logger;
        this.cryptoOptions = cryptoOptions;
        if (this.hasBrowserCrypto()) {
            // Use standard modern web crypto if available
            this.logger.verbose("BrowserCrypto: modern crypto interface available");
            this.subtleCrypto = new ModernBrowserCrypto();
        }
        else if (this.hasIECrypto()) {
            // For IE11, use msCrypto interface
            this.logger.verbose("BrowserCrypto: MS crypto interface available");
            this.subtleCrypto = new MsBrowserCrypto();
        }
        else if (this.hasMsrCrypto() && ((_a = this.cryptoOptions) === null || _a === void 0 ? void 0 : _a.useMsrCrypto)) {
            // For other browsers, use MSR Crypto if found
            this.logger.verbose("BrowserCrypto: MSR crypto interface available");
            this.subtleCrypto = new MsrBrowserCrypto();
        }
        else {
            if (this.hasMsrCrypto()) {
                this.logger.info("BrowserCrypto: MSR Crypto interface available but system.cryptoOptions.useMsrCrypto not enabled");
            }
            this.logger.error("BrowserCrypto: No crypto interfaces available.");
            throw BrowserAuthError.createCryptoNotAvailableError("Browser crypto, msCrypto, or msrCrypto interfaces not available.");
        }
        // Mainly needed for MSR Crypto: https://github.com/microsoft/MSR-JavaScript-Crypto#random-number-generator-prng
        if (this.subtleCrypto.initPrng) {
            this.logger.verbose("BrowserCrypto: Interface requires entropy");
            if (!((_b = this.cryptoOptions) === null || _b === void 0 ? void 0 : _b.entropy)) {
                this.logger.error("BrowserCrypto: Interface requires entropy but none provided.");
                throw BrowserConfigurationAuthError.createEntropyNotProvided();
            }
            this.logger.verbose("BrowserCrypto: Entropy provided");
            this.subtleCrypto.initPrng(this.cryptoOptions.entropy);
        }
        this.keygenAlgorithmOptions = {
            name: PKCS1_V15_KEYGEN_ALG,
            hash: S256_HASH_ALG,
            modulusLength: MODULUS_LENGTH,
            publicExponent: PUBLIC_EXPONENT
        };
    }
    /**
     * Check whether IE crypto or other browser cryptography is available.
     */
    BrowserCrypto.prototype.hasIECrypto = function () {
        return "msCrypto" in window;
    };
    /**
     * Check whether browser crypto is available.
     */
    BrowserCrypto.prototype.hasBrowserCrypto = function () {
        return "crypto" in window;
    };
    /**
     * Check whether MSR crypto polyfill is available
     */
    BrowserCrypto.prototype.hasMsrCrypto = function () {
        return "msrCrypto" in window;
    };
    /**
     * Returns a sha-256 hash of the given dataString as an ArrayBuffer.
     * @param dataString
     */
    BrowserCrypto.prototype.sha256Digest = function (dataString) {
        return __awaiter$3(this, void 0, void 0, function () {
            var data;
            return __generator$3(this, function (_a) {
                data = BrowserStringUtils.stringToUtf8Arr(dataString);
                // MSR Crypto wants object with name property, instead of string
                return [2 /*return*/, this.subtleCrypto.digest({ name: S256_HASH_ALG }, data)];
            });
        });
    };
    /**
     * Populates buffer with cryptographically random values.
     * @param dataBuffer
     */
    BrowserCrypto.prototype.getRandomValues = function (dataBuffer) {
        return this.subtleCrypto.getRandomValues(dataBuffer);
    };
    /**
     * Generates a keypair based on current keygen algorithm config.
     * @param extractable
     * @param usages
     */
    BrowserCrypto.prototype.generateKeyPair = function (extractable, usages) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, this.subtleCrypto.generateKey(this.keygenAlgorithmOptions, extractable, usages)];
            });
        });
    };
    /**
     * Export key as Json Web Key (JWK)
     * @param key
     * @param format
     */
    BrowserCrypto.prototype.exportJwk = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, this.subtleCrypto.exportKey(key)];
            });
        });
    };
    /**
     * Imports key as Json Web Key (JWK), can set extractable and usages.
     * @param key
     * @param format
     * @param extractable
     * @param usages
     */
    BrowserCrypto.prototype.importJwk = function (key, extractable, usages) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, this.subtleCrypto.importKey(key, this.keygenAlgorithmOptions, extractable, usages)];
            });
        });
    };
    /**
     * Signs given data with given key
     * @param key
     * @param data
     */
    BrowserCrypto.prototype.sign = function (key, data) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, this.subtleCrypto.sign(this.keygenAlgorithmOptions, key, data)];
            });
        });
    };
    return BrowserCrypto;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Storage wrapper for IndexedDB storage in browsers: https://developer.mozilla.org/en-US/docs/Web/API/IndexedDB_API
 */
var DatabaseStorage = /** @class */ (function () {
    function DatabaseStorage() {
        this.dbName = DB_NAME;
        this.version = DB_VERSION;
        this.tableName = DB_TABLE_NAME;
        this.dbOpen = false;
    }
    /**
     * Opens IndexedDB instance.
     */
    DatabaseStorage.prototype.open = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var _this = this;
            return __generator$3(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var openDB = window.indexedDB.open(_this.dbName, _this.version);
                        openDB.addEventListener("upgradeneeded", function (e) {
                            var event = e;
                            event.target.result.createObjectStore(_this.tableName);
                        });
                        openDB.addEventListener("success", function (e) {
                            var event = e;
                            _this.db = event.target.result;
                            _this.dbOpen = true;
                            resolve();
                        });
                        openDB.addEventListener("error", function () { return reject(BrowserAuthError.createDatabaseUnavailableError()); });
                    })];
            });
        });
    };
    /**
     * Closes the connection to IndexedDB database when all pending transactions
     * complete.
     */
    DatabaseStorage.prototype.closeConnection = function () {
        var db = this.db;
        if (db && this.dbOpen) {
            db.close();
            this.dbOpen = false;
        }
    };
    /**
     * Opens database if it's not already open
     */
    DatabaseStorage.prototype.validateDbIsOpen = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.dbOpen) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.open()];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Retrieves item from IndexedDB instance.
     * @param key
     */
    DatabaseStorage.prototype.getItem = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.validateDbIsOpen()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                // TODO: Add timeouts?
                                if (!_this.db) {
                                    return reject(BrowserAuthError.createDatabaseNotOpenError());
                                }
                                var transaction = _this.db.transaction([_this.tableName], "readonly");
                                var objectStore = transaction.objectStore(_this.tableName);
                                var dbGet = objectStore.get(key);
                                dbGet.addEventListener("success", function (e) {
                                    var event = e;
                                    _this.closeConnection();
                                    resolve(event.target.result);
                                });
                                dbGet.addEventListener("error", function (e) {
                                    _this.closeConnection();
                                    reject(e);
                                });
                            })];
                }
            });
        });
    };
    /**
     * Adds item to IndexedDB under given key
     * @param key
     * @param payload
     */
    DatabaseStorage.prototype.setItem = function (key, payload) {
        return __awaiter$3(this, void 0, void 0, function () {
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.validateDbIsOpen()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                // TODO: Add timeouts?
                                if (!_this.db) {
                                    return reject(BrowserAuthError.createDatabaseNotOpenError());
                                }
                                var transaction = _this.db.transaction([_this.tableName], "readwrite");
                                var objectStore = transaction.objectStore(_this.tableName);
                                var dbPut = objectStore.put(payload, key);
                                dbPut.addEventListener("success", function () {
                                    _this.closeConnection();
                                    resolve();
                                });
                                dbPut.addEventListener("error", function (e) {
                                    _this.closeConnection();
                                    reject(e);
                                });
                            })];
                }
            });
        });
    };
    /**
     * Removes item from IndexedDB under given key
     * @param key
     */
    DatabaseStorage.prototype.removeItem = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.validateDbIsOpen()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                if (!_this.db) {
                                    return reject(BrowserAuthError.createDatabaseNotOpenError());
                                }
                                var transaction = _this.db.transaction([_this.tableName], "readwrite");
                                var objectStore = transaction.objectStore(_this.tableName);
                                var dbDelete = objectStore.delete(key);
                                dbDelete.addEventListener("success", function () {
                                    _this.closeConnection();
                                    resolve();
                                });
                                dbDelete.addEventListener("error", function (e) {
                                    _this.closeConnection();
                                    reject(e);
                                });
                            })];
                }
            });
        });
    };
    /**
     * Get all the keys from the storage object as an iterable array of strings.
     */
    DatabaseStorage.prototype.getKeys = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.validateDbIsOpen()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                if (!_this.db) {
                                    return reject(BrowserAuthError.createDatabaseNotOpenError());
                                }
                                var transaction = _this.db.transaction([_this.tableName], "readonly");
                                var objectStore = transaction.objectStore(_this.tableName);
                                var dbGetKeys = objectStore.getAllKeys();
                                dbGetKeys.addEventListener("success", function (e) {
                                    var event = e;
                                    _this.closeConnection();
                                    resolve(event.target.result);
                                });
                                dbGetKeys.addEventListener("error", function (e) {
                                    _this.closeConnection();
                                    reject(e);
                                });
                            })];
                }
            });
        });
    };
    /**
     *
     * Checks whether there is an object under the search key in the object store
     */
    DatabaseStorage.prototype.containsKey = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            var _this = this;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.validateDbIsOpen()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                if (!_this.db) {
                                    return reject(BrowserAuthError.createDatabaseNotOpenError());
                                }
                                var transaction = _this.db.transaction([_this.tableName], "readonly");
                                var objectStore = transaction.objectStore(_this.tableName);
                                var dbContainsKey = objectStore.count(key);
                                dbContainsKey.addEventListener("success", function (e) {
                                    var event = e;
                                    _this.closeConnection();
                                    resolve(event.target.result === 1);
                                });
                                dbContainsKey.addEventListener("error", function (e) {
                                    _this.closeConnection();
                                    reject(e);
                                });
                            })];
                }
            });
        });
    };
    /**
     * Deletes the MSAL database. The database is deleted rather than cleared to make it possible
     * for client applications to downgrade to a previous MSAL version without worrying about forward compatibility issues
     * with IndexedDB database versions.
     */
    DatabaseStorage.prototype.deleteDatabase = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                // Check if database being deleted exists
                if (this.db && this.dbOpen) {
                    this.closeConnection();
                }
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var deleteDbRequest = window.indexedDB.deleteDatabase(DB_NAME);
                        deleteDbRequest.addEventListener("success", function () { return resolve(true); });
                        deleteDbRequest.addEventListener("blocked", function () { return resolve(true); });
                        deleteDbRequest.addEventListener("error", function () { return reject(false); });
                    })];
            });
        });
    };
    return DatabaseStorage;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * This class allows MSAL to store artifacts asynchronously using the DatabaseStorage IndexedDB wrapper,
 * backed up with the more volatile MemoryStorage object for cases in which IndexedDB may be unavailable.
 */
var AsyncMemoryStorage = /** @class */ (function () {
    function AsyncMemoryStorage(logger, storeName) {
        this.inMemoryCache = new MemoryStorage();
        this.indexedDBCache = new DatabaseStorage();
        this.logger = logger;
        this.storeName = storeName;
    }
    AsyncMemoryStorage.prototype.handleDatabaseAccessError = function (error) {
        if (error instanceof BrowserAuthError && error.errorCode === BrowserAuthErrorMessage.databaseUnavailable.code) {
            this.logger.error("Could not access persistent storage. This may be caused by browser privacy features which block persistent storage in third-party contexts.");
        }
        else {
            throw error;
        }
    };
    /**
     * Get the item matching the given key. Tries in-memory cache first, then in the asynchronous
     * storage object if item isn't found in-memory.
     * @param key
     */
    AsyncMemoryStorage.prototype.getItem = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            var item, e_1;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        item = this.inMemoryCache.getItem(key);
                        if (!!item) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        this.logger.verbose("Queried item not found in in-memory cache, now querying persistent storage.");
                        return [4 /*yield*/, this.indexedDBCache.getItem(key)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        e_1 = _a.sent();
                        this.handleDatabaseAccessError(e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, item];
                }
            });
        });
    };
    /**
     * Sets the item in the in-memory cache and then tries to set it in the asynchronous
     * storage object with the given key.
     * @param key
     * @param value
     */
    AsyncMemoryStorage.prototype.setItem = function (key, value) {
        return __awaiter$3(this, void 0, void 0, function () {
            var e_2;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.inMemoryCache.setItem(key, value);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.indexedDBCache.setItem(key, value)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        this.handleDatabaseAccessError(e_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Removes the item matching the key from the in-memory cache, then tries to remove it from the asynchronous storage object.
     * @param key
     */
    AsyncMemoryStorage.prototype.removeItem = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            var e_3;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.inMemoryCache.removeItem(key);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.indexedDBCache.removeItem(key)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _a.sent();
                        this.handleDatabaseAccessError(e_3);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get all the keys from the in-memory cache as an iterable array of strings. If no keys are found, query the keys in the
     * asynchronous storage object.
     */
    AsyncMemoryStorage.prototype.getKeys = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var cacheKeys, e_4;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cacheKeys = this.inMemoryCache.getKeys();
                        if (!(cacheKeys.length === 0)) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        this.logger.verbose("In-memory cache is empty, now querying persistent storage.");
                        return [4 /*yield*/, this.indexedDBCache.getKeys()];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        e_4 = _a.sent();
                        this.handleDatabaseAccessError(e_4);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, cacheKeys];
                }
            });
        });
    };
    /**
     * Returns true or false if the given key is present in the cache.
     * @param key
     */
    AsyncMemoryStorage.prototype.containsKey = function (key) {
        return __awaiter$3(this, void 0, void 0, function () {
            var containsKey, e_5;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        containsKey = this.inMemoryCache.containsKey(key);
                        if (!!containsKey) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        this.logger.verbose("Key not found in in-memory cache, now querying persistent storage.");
                        return [4 /*yield*/, this.indexedDBCache.containsKey(key)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        e_5 = _a.sent();
                        this.handleDatabaseAccessError(e_5);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, containsKey];
                }
            });
        });
    };
    /**
     * Clears in-memory Map
     */
    AsyncMemoryStorage.prototype.clearInMemory = function () {
        // InMemory cache is a Map instance, clear is straightforward
        this.logger.verbose("Deleting in-memory keystore " + this.storeName);
        this.inMemoryCache.clear();
        this.logger.verbose("In-memory keystore " + this.storeName + " deleted");
    };
    /**
     * Tries to delete the IndexedDB database
     * @returns
     */
    AsyncMemoryStorage.prototype.clearPersistent = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var dbDeleted, e_6;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        this.logger.verbose("Deleting persistent keystore");
                        return [4 /*yield*/, this.indexedDBCache.deleteDatabase()];
                    case 1:
                        dbDeleted = _a.sent();
                        if (dbDeleted) {
                            this.logger.verbose("Persistent keystore deleted");
                        }
                        return [2 /*return*/, dbDeleted];
                    case 2:
                        e_6 = _a.sent();
                        this.handleDatabaseAccessError(e_6);
                        return [2 /*return*/, false];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return AsyncMemoryStorage;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var CryptoKeyStoreNames;
(function (CryptoKeyStoreNames) {
    CryptoKeyStoreNames["asymmetricKeys"] = "asymmetricKeys";
    CryptoKeyStoreNames["symmetricKeys"] = "symmetricKeys";
})(CryptoKeyStoreNames || (CryptoKeyStoreNames = {}));
/**
 * MSAL CryptoKeyStore DB Version 2
 */
var CryptoKeyStore = /** @class */ (function () {
    function CryptoKeyStore(logger) {
        this.logger = logger;
        this.asymmetricKeys = new AsyncMemoryStorage(this.logger, CryptoKeyStoreNames.asymmetricKeys);
        this.symmetricKeys = new AsyncMemoryStorage(this.logger, CryptoKeyStoreNames.symmetricKeys);
    }
    CryptoKeyStore.prototype.clear = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var e_1;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Delete in-memory keystores
                        this.asymmetricKeys.clearInMemory();
                        this.symmetricKeys.clearInMemory();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.asymmetricKeys.clearPersistent()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, true];
                    case 3:
                        e_1 = _a.sent();
                        if (e_1 instanceof Error) {
                            this.logger.error("Clearing keystore failed with error: " + e_1.message);
                        }
                        else {
                            this.logger.error("Clearing keystore failed with unknown error");
                        }
                        return [2 /*return*/, false];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return CryptoKeyStore;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * This class implements MSAL's crypto interface, which allows it to perform base64 encoding and decoding, generating cryptographically random GUIDs and
 * implementing Proof Key for Code Exchange specs for the OAuth Authorization Code Flow using PKCE (rfc here: https://tools.ietf.org/html/rfc7636).
 */
var CryptoOps = /** @class */ (function () {
    function CryptoOps(logger, performanceClient, cryptoConfig) {
        this.logger = logger;
        // Browser crypto needs to be validated first before any other classes can be set.
        this.browserCrypto = new BrowserCrypto(this.logger, cryptoConfig);
        this.b64Encode = new Base64Encode();
        this.b64Decode = new Base64Decode();
        this.guidGenerator = new GuidGenerator(this.browserCrypto);
        this.pkceGenerator = new PkceGenerator(this.browserCrypto);
        this.cache = new CryptoKeyStore(this.logger);
        this.performanceClient = performanceClient;
    }
    /**
     * Creates a new random GUID - used to populate state and nonce.
     * @returns string (GUID)
     */
    CryptoOps.prototype.createNewGuid = function () {
        return this.guidGenerator.generateGuid();
    };
    /**
     * Encodes input string to base64.
     * @param input
     */
    CryptoOps.prototype.base64Encode = function (input) {
        return this.b64Encode.encode(input);
    };
    /**
     * Decodes input string from base64.
     * @param input
     */
    CryptoOps.prototype.base64Decode = function (input) {
        return this.b64Decode.decode(input);
    };
    /**
     * Generates PKCE codes used in Authorization Code Flow.
     */
    CryptoOps.prototype.generatePkceCodes = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                return [2 /*return*/, this.pkceGenerator.generateCodes()];
            });
        });
    };
    /**
     * Generates a keypair, stores it and returns a thumbprint
     * @param request
     */
    CryptoOps.prototype.getPublicKeyThumbprint = function (request) {
        var _a;
        return __awaiter$3(this, void 0, void 0, function () {
            var publicKeyThumbMeasurement, keyPair, publicKeyJwk, pubKeyThumprintObj, publicJwkString, publicJwkHash, privateKeyJwk, unextractablePrivateKey;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        publicKeyThumbMeasurement = (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.startMeasurement(PerformanceEvents.CryptoOptsGetPublicKeyThumbprint, request.correlationId);
                        return [4 /*yield*/, this.browserCrypto.generateKeyPair(CryptoOps.EXTRACTABLE, CryptoOps.POP_KEY_USAGES)];
                    case 1:
                        keyPair = _b.sent();
                        return [4 /*yield*/, this.browserCrypto.exportJwk(keyPair.publicKey)];
                    case 2:
                        publicKeyJwk = _b.sent();
                        pubKeyThumprintObj = {
                            e: publicKeyJwk.e,
                            kty: publicKeyJwk.kty,
                            n: publicKeyJwk.n
                        };
                        publicJwkString = BrowserStringUtils.getSortedObjectString(pubKeyThumprintObj);
                        return [4 /*yield*/, this.hashString(publicJwkString)];
                    case 3:
                        publicJwkHash = _b.sent();
                        return [4 /*yield*/, this.browserCrypto.exportJwk(keyPair.privateKey)];
                    case 4:
                        privateKeyJwk = _b.sent();
                        return [4 /*yield*/, this.browserCrypto.importJwk(privateKeyJwk, false, ["sign"])];
                    case 5:
                        unextractablePrivateKey = _b.sent();
                        // Store Keypair data in keystore
                        return [4 /*yield*/, this.cache.asymmetricKeys.setItem(publicJwkHash, {
                                privateKey: unextractablePrivateKey,
                                publicKey: keyPair.publicKey,
                                requestMethod: request.resourceRequestMethod,
                                requestUri: request.resourceRequestUri
                            })];
                    case 6:
                        // Store Keypair data in keystore
                        _b.sent();
                        if (publicKeyThumbMeasurement) {
                            publicKeyThumbMeasurement.endMeasurement({
                                success: true
                            });
                        }
                        return [2 /*return*/, publicJwkHash];
                }
            });
        });
    };
    /**
     * Removes cryptographic keypair from key store matching the keyId passed in
     * @param kid
     */
    CryptoOps.prototype.removeTokenBindingKey = function (kid) {
        return __awaiter$3(this, void 0, void 0, function () {
            var keyFound;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.cache.asymmetricKeys.removeItem(kid)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.cache.asymmetricKeys.containsKey(kid)];
                    case 2:
                        keyFound = _a.sent();
                        return [2 /*return*/, !keyFound];
                }
            });
        });
    };
    /**
     * Removes all cryptographic keys from IndexedDB storage
     */
    CryptoOps.prototype.clearKeystore = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.cache.clear()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Signs the given object as a jwt payload with private key retrieved by given kid.
     * @param payload
     * @param kid
     */
    CryptoOps.prototype.signJwt = function (payload, kid, correlationId) {
        var _a;
        return __awaiter$3(this, void 0, void 0, function () {
            var signJwtMeasurement, cachedKeyPair, publicKeyJwk, publicKeyJwkString, encodedKeyIdThumbprint, shrHeader, encodedShrHeader, encodedPayload, tokenString, tokenBuffer, signatureBuffer, encodedSignature, signedJwt;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        signJwtMeasurement = (_a = this.performanceClient) === null || _a === void 0 ? void 0 : _a.startMeasurement(PerformanceEvents.CryptoOptsSignJwt, correlationId);
                        return [4 /*yield*/, this.cache.asymmetricKeys.getItem(kid)];
                    case 1:
                        cachedKeyPair = _b.sent();
                        if (!cachedKeyPair) {
                            throw BrowserAuthError.createSigningKeyNotFoundInStorageError(kid);
                        }
                        return [4 /*yield*/, this.browserCrypto.exportJwk(cachedKeyPair.publicKey)];
                    case 2:
                        publicKeyJwk = _b.sent();
                        publicKeyJwkString = BrowserStringUtils.getSortedObjectString(publicKeyJwk);
                        encodedKeyIdThumbprint = this.b64Encode.urlEncode(JSON.stringify({ kid: kid }));
                        shrHeader = JoseHeader.getShrHeaderString({ kid: encodedKeyIdThumbprint, alg: publicKeyJwk.alg });
                        encodedShrHeader = this.b64Encode.urlEncode(shrHeader);
                        // Generate payload
                        payload.cnf = {
                            jwk: JSON.parse(publicKeyJwkString)
                        };
                        encodedPayload = this.b64Encode.urlEncode(JSON.stringify(payload));
                        tokenString = encodedShrHeader + "." + encodedPayload;
                        tokenBuffer = BrowserStringUtils.stringToArrayBuffer(tokenString);
                        return [4 /*yield*/, this.browserCrypto.sign(cachedKeyPair.privateKey, tokenBuffer)];
                    case 3:
                        signatureBuffer = _b.sent();
                        encodedSignature = this.b64Encode.urlEncodeArr(new Uint8Array(signatureBuffer));
                        signedJwt = tokenString + "." + encodedSignature;
                        if (signJwtMeasurement) {
                            signJwtMeasurement.endMeasurement({
                                success: true
                            });
                        }
                        return [2 /*return*/, signedJwt];
                }
            });
        });
    };
    /**
     * Returns the SHA-256 hash of an input string
     * @param plainText
     */
    CryptoOps.prototype.hashString = function (plainText) {
        return __awaiter$3(this, void 0, void 0, function () {
            var hashBuffer, hashBytes;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.browserCrypto.sha256Digest(plainText)];
                    case 1:
                        hashBuffer = _a.sent();
                        hashBytes = new Uint8Array(hashBuffer);
                        return [2 /*return*/, this.b64Encode.urlEncodeArr(hashBytes)];
                }
            });
        });
    };
    CryptoOps.POP_KEY_USAGES = ["sign", "verify"];
    CryptoOps.EXTRACTABLE = true;
    return CryptoOps;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */
/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var BrowserPerformanceMeasurement = /** @class */ (function () {
    function BrowserPerformanceMeasurement(name, correlationId) {
        this.correlationId = correlationId;
        this.measureName = BrowserPerformanceMeasurement.makeMeasureName(name, correlationId);
        this.startMark = BrowserPerformanceMeasurement.makeStartMark(name, correlationId);
        this.endMark = BrowserPerformanceMeasurement.makeEndMark(name, correlationId);
    }
    BrowserPerformanceMeasurement.makeMeasureName = function (name, correlationId) {
        return "msal.measure." + name + "." + correlationId;
    };
    BrowserPerformanceMeasurement.makeStartMark = function (name, correlationId) {
        return "msal.start." + name + "." + correlationId;
    };
    BrowserPerformanceMeasurement.makeEndMark = function (name, correlationId) {
        return "msal.end." + name + "." + correlationId;
    };
    BrowserPerformanceMeasurement.supportsBrowserPerformance = function () {
        return typeof window !== "undefined" &&
            typeof window.performance !== "undefined" &&
            typeof window.performance.mark === "function" &&
            typeof window.performance.measure === "function" &&
            typeof window.performance.clearMarks === "function" &&
            typeof window.performance.clearMeasures === "function" &&
            typeof window.performance.getEntriesByName === "function";
    };
    /**
     * Flush browser marks and measurements.
     * @param {string} correlationId
     * @param {SubMeasurement} measurements
     */
    BrowserPerformanceMeasurement.flushMeasurements = function (correlationId, measurements) {
        if (BrowserPerformanceMeasurement.supportsBrowserPerformance()) {
            try {
                measurements.forEach(function (measurement) {
                    var measureName = BrowserPerformanceMeasurement.makeMeasureName(measurement.name, correlationId);
                    var entriesForMeasurement = window.performance.getEntriesByName(measureName, "measure");
                    if (entriesForMeasurement.length > 0) {
                        window.performance.clearMeasures(measureName);
                        window.performance.clearMarks(BrowserPerformanceMeasurement.makeStartMark(measureName, correlationId));
                        window.performance.clearMarks(BrowserPerformanceMeasurement.makeEndMark(measureName, correlationId));
                    }
                });
            }
            catch (e) {
                // Silently catch and return null
            }
        }
    };
    BrowserPerformanceMeasurement.prototype.startMeasurement = function () {
        if (BrowserPerformanceMeasurement.supportsBrowserPerformance()) {
            try {
                window.performance.mark(this.startMark);
            }
            catch (e) {
                // Silently catch
            }
        }
    };
    BrowserPerformanceMeasurement.prototype.endMeasurement = function () {
        if (BrowserPerformanceMeasurement.supportsBrowserPerformance()) {
            try {
                window.performance.mark(this.endMark);
                window.performance.measure(this.measureName, this.startMark, this.endMark);
            }
            catch (e) {
                // Silently catch
            }
        }
    };
    BrowserPerformanceMeasurement.prototype.flushMeasurement = function () {
        if (BrowserPerformanceMeasurement.supportsBrowserPerformance()) {
            try {
                var entriesForMeasurement = window.performance.getEntriesByName(this.measureName, "measure");
                if (entriesForMeasurement.length > 0) {
                    var durationMs = entriesForMeasurement[0].duration;
                    window.performance.clearMeasures(this.measureName);
                    window.performance.clearMarks(this.startMark);
                    window.performance.clearMarks(this.endMark);
                    return durationMs;
                }
            }
            catch (e) {
                // Silently catch and return null
            }
        }
        return null;
    };
    return BrowserPerformanceMeasurement;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var BrowserPerformanceClient = /** @class */ (function (_super) {
    __extends$g(BrowserPerformanceClient, _super);
    function BrowserPerformanceClient(clientId, authority, logger, libraryName, libraryVersion, applicationTelemetry, cryptoOptions) {
        var _this = _super.call(this, clientId, authority, logger, libraryName, libraryVersion, applicationTelemetry) || this;
        _this.browserCrypto = new BrowserCrypto(_this.logger, cryptoOptions);
        _this.guidGenerator = new GuidGenerator(_this.browserCrypto);
        return _this;
    }
    BrowserPerformanceClient.prototype.startPerformanceMeasuremeant = function (measureName, correlationId) {
        return new BrowserPerformanceMeasurement(measureName, correlationId);
    };
    BrowserPerformanceClient.prototype.generateId = function () {
        return this.guidGenerator.generateGuid();
    };
    BrowserPerformanceClient.prototype.getPageVisibility = function () {
        var _a;
        return ((_a = document.visibilityState) === null || _a === void 0 ? void 0 : _a.toString()) || null;
    };
    BrowserPerformanceClient.prototype.deleteIncompleteSubMeasurements = function (inProgressEvent) {
        var rootEvent = this.eventsByCorrelationId.get(inProgressEvent.event.correlationId);
        var isRootEvent = rootEvent && rootEvent.eventId === inProgressEvent.event.eventId;
        var incompleteMeasurements = [];
        if (isRootEvent && (rootEvent === null || rootEvent === void 0 ? void 0 : rootEvent.incompleteSubMeasurements)) {
            rootEvent.incompleteSubMeasurements.forEach(function (subMeasurement) {
                incompleteMeasurements.push(__assign$5({}, subMeasurement));
            });
        }
        // Clean up remaining marks for incomplete sub-measurements
        if (incompleteMeasurements.length > 0) {
            BrowserPerformanceMeasurement.flushMeasurements(inProgressEvent.event.correlationId, incompleteMeasurements);
        }
    };
    BrowserPerformanceClient.prototype.supportsBrowserPerformanceNow = function () {
        return typeof window !== "undefined" &&
            typeof window.performance !== "undefined" &&
            typeof window.performance.now === "function";
    };
    /**
     * Starts measuring performance for a given operation. Returns a function that should be used to end the measurement.
     * Also captures browser page visibilityState.
     *
     * @param {PerformanceEvents} measureName
     * @param {?string} [correlationId]
     * @returns {((event?: Partial<PerformanceEvent>) => PerformanceEvent| null)}
     */
    BrowserPerformanceClient.prototype.startMeasurement = function (measureName, correlationId) {
        var _this = this;
        // Capture page visibilityState and then invoke start/end measurement
        var startPageVisibility = this.getPageVisibility();
        var inProgressEvent = _super.prototype.startMeasurement.call(this, measureName, correlationId);
        return __assign$5(__assign$5({}, inProgressEvent), { endMeasurement: function (event) {
                var res = inProgressEvent.endMeasurement(__assign$5({ startPageVisibility: startPageVisibility, endPageVisibility: _this.getPageVisibility() }, event));
                _this.deleteIncompleteSubMeasurements(inProgressEvent);
                return res;
            }, discardMeasurement: function () {
                inProgressEvent.discardMeasurement();
                _this.deleteIncompleteSubMeasurements(inProgressEvent);
                inProgressEvent.measurement.flushMeasurement();
            } });
    };
    /**
     * Adds pre-queue time to preQueueTimeByCorrelationId map.
     * @param {PerformanceEvents} eventName
     * @param {?string} correlationId
     * @returns
     */
    BrowserPerformanceClient.prototype.setPreQueueTime = function (eventName, correlationId) {
        if (!this.supportsBrowserPerformanceNow()) {
            this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to set telemetry queue time for " + eventName);
            return;
        }
        if (!correlationId) {
            this.logger.trace("BrowserPerformanceClient: correlationId for " + eventName + " not provided, unable to set telemetry queue time");
            return;
        }
        var preQueueEvent = this.preQueueTimeByCorrelationId.get(correlationId);
        /**
         * Manually complete queue measurement if there is an incomplete pre-queue event.
         * Incomplete pre-queue events are instrumentation bugs that should be fixed.
         */
        if (preQueueEvent) {
            this.logger.trace("BrowserPerformanceClient: Incomplete pre-queue " + preQueueEvent.name + " found", correlationId);
            this.addQueueMeasurement(preQueueEvent.name, correlationId, undefined, true);
        }
        this.preQueueTimeByCorrelationId.set(correlationId, { name: eventName, time: window.performance.now() });
    };
    /**
     * Calculates and adds queue time measurement for given performance event.
     *
     * @param {PerformanceEvents} eventName
     * @param {?string} correlationId
     * @param {?number} queueTime
     * @param {?boolean} manuallyCompleted - indicator for manually completed queue measurements
     * @returns
     */
    BrowserPerformanceClient.prototype.addQueueMeasurement = function (eventName, correlationId, queueTime, manuallyCompleted) {
        if (!this.supportsBrowserPerformanceNow()) {
            this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to add queue measurement for " + eventName);
            return;
        }
        if (!correlationId) {
            this.logger.trace("BrowserPerformanceClient: correlationId for " + eventName + " not provided, unable to add queue measurement");
            return;
        }
        var preQueueTime = _super.prototype.getPreQueueTime.call(this, eventName, correlationId);
        if (!preQueueTime) {
            return;
        }
        var currentTime = window.performance.now();
        var resQueueTime = queueTime || _super.prototype.calculateQueuedTime.call(this, preQueueTime, currentTime);
        return _super.prototype.addQueueMeasurement.call(this, eventName, correlationId, resQueueTime, manuallyCompleted);
    };
    return BrowserPerformanceClient;
}(PerformanceClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Token cache manager
 */
var TokenCache = /** @class */ (function () {
    function TokenCache(configuration, storage, logger, cryptoObj) {
        this.isBrowserEnvironment = typeof window !== "undefined";
        this.config = configuration;
        this.storage = storage;
        this.logger = logger;
        this.cryptoObj = cryptoObj;
    }
    // Move getAllAccounts here and cache utility APIs
    /**
     * API to load tokens to msal-browser cache.
     * @param request
     * @param response
     * @param options
     * @returns `AuthenticationResult` for the response that was loaded.
     */
    TokenCache.prototype.loadExternalTokens = function (request, response, options) {
        this.logger.info("TokenCache - loadExternalTokens called");
        if (!response.id_token) {
            throw BrowserAuthError.createUnableToLoadTokenError("Please ensure server response includes id token.");
        }
        var idToken = new AuthToken(response.id_token, this.cryptoObj);
        var cacheRecord;
        var authority;
        if (request.account) {
            var cacheRecordAccount = this.loadAccount(idToken, request.account.environment, undefined, undefined, request.account.homeAccountId);
            cacheRecord = new CacheRecord(cacheRecordAccount, this.loadIdToken(idToken, cacheRecordAccount.homeAccountId, request.account.environment, request.account.tenantId), this.loadAccessToken(request, response, cacheRecordAccount.homeAccountId, request.account.environment, request.account.tenantId, options), this.loadRefreshToken(request, response, cacheRecordAccount.homeAccountId, request.account.environment));
        }
        else if (request.authority) {
            var authorityUrl = Authority.generateAuthority(request.authority, request.azureCloudOptions);
            var authorityOptions = {
                protocolMode: this.config.auth.protocolMode,
                knownAuthorities: this.config.auth.knownAuthorities,
                cloudDiscoveryMetadata: this.config.auth.cloudDiscoveryMetadata,
                authorityMetadata: this.config.auth.authorityMetadata,
                skipAuthorityMetadataCache: this.config.auth.skipAuthorityMetadataCache,
            };
            authority = new Authority(authorityUrl, this.config.system.networkClient, this.storage, authorityOptions, this.logger);
            // "clientInfo" from options takes precedence over "clientInfo" in response
            if (options.clientInfo) {
                this.logger.trace("TokenCache - homeAccountId from options");
                var cacheRecordAccount = this.loadAccount(idToken, authority.hostnameAndPort, options.clientInfo, authority.authorityType);
                cacheRecord = new CacheRecord(cacheRecordAccount, this.loadIdToken(idToken, cacheRecordAccount.homeAccountId, authority.hostnameAndPort, authority.tenant), this.loadAccessToken(request, response, cacheRecordAccount.homeAccountId, authority.hostnameAndPort, authority.tenant, options), this.loadRefreshToken(request, response, cacheRecordAccount.homeAccountId, authority.hostnameAndPort));
            }
            else if (response.client_info) {
                this.logger.trace("TokenCache - homeAccountId from response");
                var cacheRecordAccount = this.loadAccount(idToken, authority.hostnameAndPort, response.client_info, authority.authorityType);
                cacheRecord = new CacheRecord(cacheRecordAccount, this.loadIdToken(idToken, cacheRecordAccount.homeAccountId, authority.hostnameAndPort, authority.tenant), this.loadAccessToken(request, response, cacheRecordAccount.homeAccountId, authority.hostnameAndPort, authority.tenant, options), this.loadRefreshToken(request, response, cacheRecordAccount.homeAccountId, authority.hostnameAndPort));
            }
            else {
                throw BrowserAuthError.createUnableToLoadTokenError("Please provide clientInfo in the response or options.");
            }
        }
        else {
            throw BrowserAuthError.createUnableToLoadTokenError("Please provide a request with an account or a request with authority.");
        }
        return this.generateAuthenticationResult(request, idToken, cacheRecord, authority);
    };
    /**
     * Helper function to load account to msal-browser cache
     * @param idToken
     * @param environment
     * @param clientInfo
     * @param authorityType
     * @param requestHomeAccountId
     * @returns `AccountEntity`
     */
    TokenCache.prototype.loadAccount = function (idToken, environment, clientInfo, authorityType, requestHomeAccountId) {
        var homeAccountId;
        if (requestHomeAccountId) {
            homeAccountId = requestHomeAccountId;
        }
        else if (authorityType !== undefined && clientInfo) {
            homeAccountId = AccountEntity.generateHomeAccountId(clientInfo, authorityType, this.logger, this.cryptoObj, idToken);
        }
        if (!homeAccountId) {
            throw BrowserAuthError.createUnableToLoadTokenError("Unexpected missing homeAccountId");
        }
        var accountEntity = clientInfo ?
            AccountEntity.createAccount(clientInfo, homeAccountId, idToken, undefined, undefined, undefined, environment) :
            AccountEntity.createGenericAccount(homeAccountId, idToken, undefined, undefined, undefined, environment);
        if (this.isBrowserEnvironment) {
            this.logger.verbose("TokenCache - loading account");
            this.storage.setAccount(accountEntity);
            return accountEntity;
        }
        else {
            throw BrowserAuthError.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.");
        }
    };
    /**
     * Helper function to load id tokens to msal-browser cache
     * @param idToken
     * @param homeAccountId
     * @param environment
     * @param tenantId
     * @returns `IdTokenEntity`
     */
    TokenCache.prototype.loadIdToken = function (idToken, homeAccountId, environment, tenantId) {
        var idTokenEntity = IdTokenEntity.createIdTokenEntity(homeAccountId, environment, idToken.rawToken, this.config.auth.clientId, tenantId);
        if (this.isBrowserEnvironment) {
            this.logger.verbose("TokenCache - loading id token");
            this.storage.setIdTokenCredential(idTokenEntity);
            return idTokenEntity;
        }
        else {
            throw BrowserAuthError.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.");
        }
    };
    /**
     * Helper function to load access tokens to msal-browser cache
     * @param request
     * @param response
     * @param homeAccountId
     * @param environment
     * @param tenantId
     * @returns `AccessTokenEntity`
     */
    TokenCache.prototype.loadAccessToken = function (request, response, homeAccountId, environment, tenantId, options) {
        if (!response.access_token) {
            this.logger.verbose("TokenCache - No access token provided for caching");
            return null;
        }
        if (!response.expires_in) {
            throw BrowserAuthError.createUnableToLoadTokenError("Please ensure server response includes expires_in value.");
        }
        if (!options.extendedExpiresOn) {
            throw BrowserAuthError.createUnableToLoadTokenError("Please provide an extendedExpiresOn value in the options.");
        }
        var scopes = new ScopeSet(request.scopes).printScopes();
        var expiresOn = options.expiresOn || (response.expires_in + new Date().getTime() / 1000);
        var extendedExpiresOn = options.extendedExpiresOn;
        var accessTokenEntity = AccessTokenEntity.createAccessTokenEntity(homeAccountId, environment, response.access_token, this.config.auth.clientId, tenantId, scopes, expiresOn, extendedExpiresOn, this.cryptoObj);
        if (this.isBrowserEnvironment) {
            this.logger.verbose("TokenCache - loading access token");
            this.storage.setAccessTokenCredential(accessTokenEntity);
            return accessTokenEntity;
        }
        else {
            throw BrowserAuthError.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.");
        }
    };
    /**
     * Helper function to load refresh tokens to msal-browser cache
     * @param request
     * @param response
     * @param homeAccountId
     * @param environment
     * @returns `RefreshTokenEntity`
     */
    TokenCache.prototype.loadRefreshToken = function (request, response, homeAccountId, environment) {
        if (!response.refresh_token) {
            this.logger.verbose("TokenCache - No refresh token provided for caching");
            return null;
        }
        var refreshTokenEntity = RefreshTokenEntity.createRefreshTokenEntity(homeAccountId, environment, response.refresh_token, this.config.auth.clientId);
        if (this.isBrowserEnvironment) {
            this.logger.verbose("TokenCache - loading refresh token");
            this.storage.setRefreshTokenCredential(refreshTokenEntity);
            return refreshTokenEntity;
        }
        else {
            throw BrowserAuthError.createUnableToLoadTokenError("loadExternalTokens is designed to work in browser environments only.");
        }
    };
    /**
     * Helper function to generate an `AuthenticationResult` for the result.
     * @param request
     * @param idTokenObj
     * @param cacheRecord
     * @param authority
     * @returns `AuthenticationResult`
     */
    TokenCache.prototype.generateAuthenticationResult = function (request, idTokenObj, cacheRecord, authority) {
        var _a, _b, _c;
        var accessToken = Constants.EMPTY_STRING;
        var responseScopes = [];
        var expiresOn = null;
        var extExpiresOn;
        if (cacheRecord === null || cacheRecord === void 0 ? void 0 : cacheRecord.accessToken) {
            accessToken = cacheRecord.accessToken.secret;
            responseScopes = ScopeSet.fromString(cacheRecord.accessToken.target).asArray();
            expiresOn = new Date(Number(cacheRecord.accessToken.expiresOn) * 1000);
            extExpiresOn = new Date(Number(cacheRecord.accessToken.extendedExpiresOn) * 1000);
        }
        var uid = (idTokenObj === null || idTokenObj === void 0 ? void 0 : idTokenObj.claims.oid) || (idTokenObj === null || idTokenObj === void 0 ? void 0 : idTokenObj.claims.sub) || Constants.EMPTY_STRING;
        var tid = (idTokenObj === null || idTokenObj === void 0 ? void 0 : idTokenObj.claims.tid) || Constants.EMPTY_STRING;
        return {
            authority: authority ? authority.canonicalAuthority : Constants.EMPTY_STRING,
            uniqueId: uid,
            tenantId: tid,
            scopes: responseScopes,
            account: (cacheRecord === null || cacheRecord === void 0 ? void 0 : cacheRecord.account) ? cacheRecord.account.getAccountInfo() : null,
            idToken: idTokenObj ? idTokenObj.rawToken : Constants.EMPTY_STRING,
            idTokenClaims: idTokenObj ? idTokenObj.claims : {},
            accessToken: accessToken,
            fromCache: true,
            expiresOn: expiresOn,
            correlationId: request.correlationId || Constants.EMPTY_STRING,
            requestId: Constants.EMPTY_STRING,
            extExpiresOn: extExpiresOn,
            familyId: Constants.EMPTY_STRING,
            tokenType: ((_a = cacheRecord === null || cacheRecord === void 0 ? void 0 : cacheRecord.accessToken) === null || _a === void 0 ? void 0 : _a.tokenType) || Constants.EMPTY_STRING,
            state: Constants.EMPTY_STRING,
            cloudGraphHostName: ((_b = cacheRecord === null || cacheRecord === void 0 ? void 0 : cacheRecord.account) === null || _b === void 0 ? void 0 : _b.cloudGraphHostName) || Constants.EMPTY_STRING,
            msGraphHost: ((_c = cacheRecord === null || cacheRecord === void 0 ? void 0 : cacheRecord.account) === null || _c === void 0 ? void 0 : _c.msGraphHost) || Constants.EMPTY_STRING,
            code: undefined,
            fromNativeBroker: false
        };
    };
    return TokenCache;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var HybridSpaAuthorizationCodeClient = /** @class */ (function (_super) {
    __extends$g(HybridSpaAuthorizationCodeClient, _super);
    function HybridSpaAuthorizationCodeClient(config) {
        var _this = _super.call(this, config) || this;
        _this.includeRedirectUri = false;
        return _this;
    }
    return HybridSpaAuthorizationCodeClient;
}(AuthorizationCodeClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var SilentAuthCodeClient = /** @class */ (function (_super) {
    __extends$g(SilentAuthCodeClient, _super);
    function SilentAuthCodeClient(config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, apiId, performanceClient, nativeMessageHandler, correlationId) {
        var _this = _super.call(this, config, storageImpl, browserCrypto, logger, eventHandler, navigationClient, performanceClient, nativeMessageHandler, correlationId) || this;
        _this.apiId = apiId;
        return _this;
    }
    /**
     * Acquires a token silently by redeeming an authorization code against the /token endpoint
     * @param request
     */
    SilentAuthCodeClient.prototype.acquireToken = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var silentRequest, serverTelemetryManager, authCodeRequest, clientConfig, authClient, silentHandler, e_1;
            return __generator$3(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.trace("SilentAuthCodeClient.acquireToken called");
                        // Auth code payload is required
                        if (!request.code) {
                            throw BrowserAuthError.createAuthCodeRequiredError();
                        }
                        // Create silent request
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest, request.correlationId);
                        return [4 /*yield*/, this.initializeAuthorizationRequest(request, InteractionType.Silent)];
                    case 1:
                        silentRequest = _a.sent();
                        this.browserStorage.updateCacheEntries(silentRequest.state, silentRequest.nonce, silentRequest.authority, silentRequest.loginHint || Constants.EMPTY_STRING, silentRequest.account || null);
                        serverTelemetryManager = this.initializeServerTelemetryManager(this.apiId);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        authCodeRequest = __assign$5(__assign$5({}, silentRequest), { code: request.code });
                        // Initialize the client
                        this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetClientConfiguration, request.correlationId);
                        return [4 /*yield*/, this.getClientConfiguration(serverTelemetryManager, silentRequest.authority)];
                    case 3:
                        clientConfig = _a.sent();
                        authClient = new HybridSpaAuthorizationCodeClient(clientConfig);
                        this.logger.verbose("Auth code client created");
                        silentHandler = new SilentHandler(authClient, this.browserStorage, authCodeRequest, this.logger, this.config.system, this.performanceClient);
                        // Handle auth code parameters from request
                        return [2 /*return*/, silentHandler.handleCodeResponseFromServer({
                                code: request.code,
                                msgraph_host: request.msGraphHost,
                                cloud_graph_host_name: request.cloudGraphHostName,
                                cloud_instance_host_name: request.cloudInstanceHostName
                            }, silentRequest.state, authClient.authority, this.networkClient, false)];
                    case 4:
                        e_1 = _a.sent();
                        if (e_1 instanceof AuthError) {
                            e_1.setCorrelationId(this.correlationId);
                        }
                        serverTelemetryManager.cacheFailedRequest(e_1);
                        this.browserStorage.cleanRequestByState(silentRequest.state);
                        throw e_1;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Currently Unsupported
     */
    SilentAuthCodeClient.prototype.logout = function () {
        // Synchronous so we must reject
        return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError());
    };
    return SilentAuthCodeClient;
}(StandardInteractionClient));

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var ClientApplication = /** @class */ (function () {
    /**
     * @constructor
     * Constructor for the PublicClientApplication used to instantiate the PublicClientApplication object
     *
     * Important attributes in the Configuration object for auth are:
     * - clientID: the application ID of your application. You can obtain one by registering your application with our Application registration portal : https://portal.azure.com/#blade/Microsoft_AAD_IAM/ActiveDirectoryMenuBlade/RegisteredAppsPreview
     * - authority: the authority URL for your application.
     * - redirect_uri: the uri of your application registered in the portal.
     *
     * In Azure AD, authority is a URL indicating the Azure active directory that MSAL uses to obtain tokens.
     * It is of the form https://login.microsoftonline.com/{Enter_the_Tenant_Info_Here}
     * If your application supports Accounts in one organizational directory, replace "Enter_the_Tenant_Info_Here" value with the Tenant Id or Tenant name (for example, contoso.microsoft.com).
     * If your application supports Accounts in any organizational directory, replace "Enter_the_Tenant_Info_Here" value with organizations.
     * If your application supports Accounts in any organizational directory and personal Microsoft accounts, replace "Enter_the_Tenant_Info_Here" value with common.
     * To restrict support to Personal Microsoft accounts only, replace "Enter_the_Tenant_Info_Here" value with consumers.
     *
     * In Azure B2C, authority is of the form https://{instance}/tfp/{tenant}/{policyName}/
     * Full B2C functionality will be available in this library in future versions.
     *
     * @param configuration Object for the MSAL PublicClientApplication instance
     */
    function ClientApplication(configuration) {
        /*
         * If loaded in an environment where window is not available,
         * set internal flag to false so that further requests fail.
         * This is to support server-side rendering environments.
         */
        this.isBrowserEnvironment = typeof window !== "undefined";
        // Set the configuration.
        this.config = buildConfiguration(configuration, this.isBrowserEnvironment);
        this.initialized = false;
        // Initialize logger
        this.logger = new Logger(this.config.system.loggerOptions, name, version);
        // Initialize the network module class.
        this.networkClient = this.config.system.networkClient;
        // Initialize the navigation client class.
        this.navigationClient = this.config.system.navigationClient;
        // Initialize redirectResponse Map
        this.redirectResponse = new Map();
        // Initial hybrid spa map
        this.hybridAuthCodeResponses = new Map();
        // Initialize performance client
        this.performanceClient = this.isBrowserEnvironment ?
            new BrowserPerformanceClient(this.config.auth.clientId, this.config.auth.authority, this.logger, name, version, this.config.telemetry.application, this.config.system.cryptoOptions) :
            new StubPerformanceClient(this.config.auth.clientId, this.config.auth.authority, this.logger, name, version, this.config.telemetry.application);
        // Initialize the crypto class.
        this.browserCrypto = this.isBrowserEnvironment ? new CryptoOps(this.logger, this.performanceClient, this.config.system.cryptoOptions) : DEFAULT_CRYPTO_IMPLEMENTATION;
        this.eventHandler = new EventHandler(this.logger, this.browserCrypto);
        // Initialize the browser storage class.
        this.browserStorage = this.isBrowserEnvironment ?
            new BrowserCacheManager(this.config.auth.clientId, this.config.cache, this.browserCrypto, this.logger) :
            DEFAULT_BROWSER_CACHE_MANAGER(this.config.auth.clientId, this.logger);
        // initialize in memory storage for native flows
        var nativeCacheOptions = {
            cacheLocation: BrowserCacheLocation.MemoryStorage,
            temporaryCacheLocation: BrowserCacheLocation.MemoryStorage,
            storeAuthStateInCookie: false,
            secureCookies: false,
            cacheMigrationEnabled: false,
            claimsBasedCachingEnabled: true
        };
        this.nativeInternalStorage = new BrowserCacheManager(this.config.auth.clientId, nativeCacheOptions, this.browserCrypto, this.logger);
        // Initialize the token cache
        this.tokenCache = new TokenCache(this.config, this.browserStorage, this.logger, this.browserCrypto);
        // Register listener functions
        this.trackPageVisibilityWithMeasurement = this.trackPageVisibilityWithMeasurement.bind(this);
    }
    /**
     * Initializer function to perform async startup tasks such as connecting to WAM extension
     */
    ClientApplication.prototype.initialize = function () {
        return __awaiter$3(this, void 0, void 0, function () {
            var allowNativeBroker, initMeasurement, _a, e_1, claimsTokensRemovalMeasurement;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.logger.trace("initialize called");
                        if (this.initialized) {
                            this.logger.info("initialize has already been called, exiting early.");
                            return [2 /*return*/];
                        }
                        allowNativeBroker = this.config.system.allowNativeBroker;
                        initMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.InitializeClientApplication);
                        this.eventHandler.emitEvent(EventType.INITIALIZE_START);
                        if (!allowNativeBroker) return [3 /*break*/, 4];
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        _a = this;
                        return [4 /*yield*/, NativeMessageHandler.createProvider(this.logger, this.config.system.nativeBrokerHandshakeTimeout, this.performanceClient)];
                    case 2:
                        _a.nativeExtensionProvider = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _b.sent();
                        this.logger.verbose(e_1);
                        return [3 /*break*/, 4];
                    case 4:
                        if (!!this.config.cache.claimsBasedCachingEnabled) return [3 /*break*/, 6];
                        this.logger.verbose("Claims-based caching is disabled. Clearing the previous cache with claims");
                        claimsTokensRemovalMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.ClearTokensAndKeysWithClaims);
                        return [4 /*yield*/, this.browserStorage.clearTokensAndKeysWithClaims()];
                    case 5:
                        _b.sent();
                        claimsTokensRemovalMeasurement.endMeasurement({ success: true });
                        _b.label = 6;
                    case 6:
                        this.initialized = true;
                        this.eventHandler.emitEvent(EventType.INITIALIZE_END);
                        initMeasurement.endMeasurement({ allowNativeBroker: allowNativeBroker, success: true });
                        return [2 /*return*/];
                }
            });
        });
    };
    // #region Redirect Flow
    /**
     * Event handler function which allows users to fire events after the PublicClientApplication object
     * has loaded during redirect flows. This should be invoked on all page loads involved in redirect
     * auth flows.
     * @param hash Hash to process. Defaults to the current value of window.location.hash. Only needs to be provided explicitly if the response to be handled is not contained in the current value.
     * @returns Token response or null. If the return value is null, then no auth redirect was detected.
     */
    ClientApplication.prototype.handleRedirectPromise = function (hash) {
        return __awaiter$3(this, void 0, void 0, function () {
            var loggedInAccounts, redirectResponseKey, response, request, redirectResponse, nativeClient, correlationId, redirectClient;
            var _this = this;
            return __generator$3(this, function (_a) {
                this.logger.verbose("handleRedirectPromise called");
                // Block token acquisition before initialize has been called if native brokering is enabled
                BrowserUtils.blockNativeBrokerCalledBeforeInitialized(this.config.system.allowNativeBroker, this.initialized);
                loggedInAccounts = this.getAllAccounts();
                if (this.isBrowserEnvironment) {
                    redirectResponseKey = hash || Constants.EMPTY_STRING;
                    response = this.redirectResponse.get(redirectResponseKey);
                    if (typeof response === "undefined") {
                        this.eventHandler.emitEvent(EventType.HANDLE_REDIRECT_START, InteractionType.Redirect);
                        this.logger.verbose("handleRedirectPromise has been called for the first time, storing the promise");
                        request = this.browserStorage.getCachedNativeRequest();
                        redirectResponse = void 0;
                        if (request && NativeMessageHandler.isNativeAvailable(this.config, this.logger, this.nativeExtensionProvider) && this.nativeExtensionProvider && !hash) {
                            this.logger.trace("handleRedirectPromise - acquiring token from native platform");
                            nativeClient = new NativeInteractionClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, ApiId.handleRedirectPromise, this.performanceClient, this.nativeExtensionProvider, request.accountId, this.nativeInternalStorage, request.correlationId);
                            redirectResponse = nativeClient.handleRedirectPromise();
                        }
                        else {
                            this.logger.trace("handleRedirectPromise - acquiring token from web flow");
                            correlationId = this.browserStorage.getTemporaryCache(TemporaryCacheKeys.CORRELATION_ID, true) || Constants.EMPTY_STRING;
                            redirectClient = this.createRedirectClient(correlationId);
                            redirectResponse = redirectClient.handleRedirectPromise(hash);
                        }
                        response = redirectResponse.then(function (result) {
                            if (result) {
                                // Emit login event if number of accounts change
                                var isLoggingIn = loggedInAccounts.length < _this.getAllAccounts().length;
                                if (isLoggingIn) {
                                    _this.eventHandler.emitEvent(EventType.LOGIN_SUCCESS, InteractionType.Redirect, result);
                                    _this.logger.verbose("handleRedirectResponse returned result, login success");
                                }
                                else {
                                    _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_SUCCESS, InteractionType.Redirect, result);
                                    _this.logger.verbose("handleRedirectResponse returned result, acquire token success");
                                }
                            }
                            _this.eventHandler.emitEvent(EventType.HANDLE_REDIRECT_END, InteractionType.Redirect);
                            return result;
                        }).catch(function (e) {
                            // Emit login event if there is an account
                            if (loggedInAccounts.length > 0) {
                                _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_FAILURE, InteractionType.Redirect, null, e);
                            }
                            else {
                                _this.eventHandler.emitEvent(EventType.LOGIN_FAILURE, InteractionType.Redirect, null, e);
                            }
                            _this.eventHandler.emitEvent(EventType.HANDLE_REDIRECT_END, InteractionType.Redirect);
                            throw e;
                        });
                        this.redirectResponse.set(redirectResponseKey, response);
                    }
                    else {
                        this.logger.verbose("handleRedirectPromise has been called previously, returning the result from the first call");
                    }
                    return [2 /*return*/, response];
                }
                this.logger.verbose("handleRedirectPromise returns null, not browser environment");
                return [2 /*return*/, null];
            });
        });
    };
    /**
     * Use when you want to obtain an access_token for your API by redirecting the user's browser window to the authorization endpoint. This function redirects
     * the page, so any code that follows this function will not execute.
     *
     * IMPORTANT: It is NOT recommended to have code that is dependent on the resolution of the Promise. This function will navigate away from the current
     * browser window. It currently returns a Promise in order to reflect the asynchronous nature of the code running in this function.
     *
     * @param request
     */
    ClientApplication.prototype.acquireTokenRedirect = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var correlationId, isLoggedIn, result, nativeClient, redirectClient;
            var _this = this;
            return __generator$3(this, function (_a) {
                correlationId = this.getRequestCorrelationId(request);
                this.logger.verbose("acquireTokenRedirect called", correlationId);
                this.preflightBrowserEnvironmentCheck(InteractionType.Redirect);
                isLoggedIn = this.getAllAccounts().length > 0;
                if (isLoggedIn) {
                    this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_START, InteractionType.Redirect, request);
                }
                else {
                    this.eventHandler.emitEvent(EventType.LOGIN_START, InteractionType.Redirect, request);
                }
                if (this.nativeExtensionProvider && this.canUseNative(request)) {
                    nativeClient = new NativeInteractionClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, ApiId.acquireTokenRedirect, this.performanceClient, this.nativeExtensionProvider, this.getNativeAccountId(request), this.nativeInternalStorage, request.correlationId);
                    result = nativeClient.acquireTokenRedirect(request).catch(function (e) {
                        if (e instanceof NativeAuthError && e.isFatal()) {
                            _this.nativeExtensionProvider = undefined; // If extension gets uninstalled during session prevent future requests from continuing to attempt
                            var redirectClient = _this.createRedirectClient(request.correlationId);
                            return redirectClient.acquireToken(request);
                        }
                        else if (e instanceof InteractionRequiredAuthError) {
                            _this.logger.verbose("acquireTokenRedirect - Resolving interaction required error thrown by native broker by falling back to web flow");
                            var redirectClient = _this.createRedirectClient(request.correlationId);
                            return redirectClient.acquireToken(request);
                        }
                        _this.browserStorage.setInteractionInProgress(false);
                        throw e;
                    });
                }
                else {
                    redirectClient = this.createRedirectClient(request.correlationId);
                    result = redirectClient.acquireToken(request);
                }
                return [2 /*return*/, result.catch(function (e) {
                        // If logged in, emit acquire token events
                        if (isLoggedIn) {
                            _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_FAILURE, InteractionType.Redirect, null, e);
                        }
                        else {
                            _this.eventHandler.emitEvent(EventType.LOGIN_FAILURE, InteractionType.Redirect, null, e);
                        }
                        throw e;
                    })];
            });
        });
    };
    // #endregion
    // #region Popup Flow
    /**
     * Use when you want to obtain an access_token for your API via opening a popup window in the user's browser
     *
     * @param request
     *
     * @returns A promise that is fulfilled when this function has completed, or rejected if an error was raised.
     */
    ClientApplication.prototype.acquireTokenPopup = function (request) {
        var _this = this;
        var correlationId = this.getRequestCorrelationId(request);
        var atPopupMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.AcquireTokenPopup, correlationId);
        try {
            this.logger.verbose("acquireTokenPopup called", correlationId);
            this.preflightBrowserEnvironmentCheck(InteractionType.Popup);
        }
        catch (e) {
            // Since this function is syncronous we need to reject
            return Promise.reject(e);
        }
        // If logged in, emit acquire token events
        var loggedInAccounts = this.getAllAccounts();
        if (loggedInAccounts.length > 0) {
            this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_START, InteractionType.Popup, request);
        }
        else {
            this.eventHandler.emitEvent(EventType.LOGIN_START, InteractionType.Popup, request);
        }
        var result;
        if (this.canUseNative(request)) {
            result = this.acquireTokenNative(request, ApiId.acquireTokenPopup).then(function (response) {
                _this.browserStorage.setInteractionInProgress(false);
                atPopupMeasurement.endMeasurement({
                    success: true,
                    isNativeBroker: true,
                    requestId: response.requestId
                });
                return response;
            }).catch(function (e) {
                if (e instanceof NativeAuthError && e.isFatal()) {
                    _this.nativeExtensionProvider = undefined; // If extension gets uninstalled during session prevent future requests from continuing to attempt
                    var popupClient = _this.createPopupClient(request.correlationId);
                    return popupClient.acquireToken(request);
                }
                else if (e instanceof InteractionRequiredAuthError) {
                    _this.logger.verbose("acquireTokenPopup - Resolving interaction required error thrown by native broker by falling back to web flow");
                    var popupClient = _this.createPopupClient(request.correlationId);
                    return popupClient.acquireToken(request);
                }
                _this.browserStorage.setInteractionInProgress(false);
                throw e;
            });
        }
        else {
            var popupClient = this.createPopupClient(request.correlationId);
            result = popupClient.acquireToken(request);
        }
        return result.then(function (result) {
            /*
             *  If logged in, emit acquire token events
             */
            var isLoggingIn = loggedInAccounts.length < _this.getAllAccounts().length;
            if (isLoggingIn) {
                _this.eventHandler.emitEvent(EventType.LOGIN_SUCCESS, InteractionType.Popup, result);
            }
            else {
                _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_SUCCESS, InteractionType.Popup, result);
            }
            atPopupMeasurement.addStaticFields({
                accessTokenSize: result.accessToken.length,
                idTokenSize: result.idToken.length
            });
            atPopupMeasurement.endMeasurement({
                success: true,
                requestId: result.requestId
            });
            return result;
        }).catch(function (e) {
            if (loggedInAccounts.length > 0) {
                _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_FAILURE, InteractionType.Popup, null, e);
            }
            else {
                _this.eventHandler.emitEvent(EventType.LOGIN_FAILURE, InteractionType.Popup, null, e);
            }
            atPopupMeasurement.endMeasurement({
                errorCode: e.errorCode,
                subErrorCode: e.subError,
                success: false
            });
            // Since this function is syncronous we need to reject
            return Promise.reject(e);
        });
    };
    ClientApplication.prototype.trackPageVisibilityWithMeasurement = function () {
        var measurement = this.ssoSilentMeasurement || this.acquireTokenByCodeAsyncMeasurement;
        if (!measurement) {
            return;
        }
        this.logger.info("Perf: Visibility change detected in ", measurement.event.name);
        measurement.increment({
            visibilityChangeCount: 1,
        });
    };
    // #endregion
    // #region Silent Flow
    /**
     * This function uses a hidden iframe to fetch an authorization code from the eSTS. There are cases where this may not work:
     * - Any browser using a form of Intelligent Tracking Prevention
     * - If there is not an established session with the service
     *
     * In these cases, the request must be done inside a popup or full frame redirect.
     *
     * For the cases where interaction is required, you cannot send a request with prompt=none.
     *
     * If your refresh token has expired, you can use this function to fetch a new set of tokens silently as long as
     * you session on the server still exists.
     * @param request {@link SsoSilentRequest}
     *
     * @returns A promise that is fulfilled when this function has completed, or rejected if an error was raised.
     */
    ClientApplication.prototype.ssoSilent = function (request) {
        var _a;
        return __awaiter$3(this, void 0, void 0, function () {
            var correlationId, validRequest, result, silentIframeClient;
            var _this = this;
            return __generator$3(this, function (_b) {
                correlationId = this.getRequestCorrelationId(request);
                validRequest = __assign$5(__assign$5({}, request), { 
                    // will be PromptValue.NONE or PromptValue.NO_SESSION
                    prompt: request.prompt, correlationId: correlationId });
                this.preflightBrowserEnvironmentCheck(InteractionType.Silent);
                this.ssoSilentMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.SsoSilent, correlationId);
                (_a = this.ssoSilentMeasurement) === null || _a === void 0 ? void 0 : _a.increment({
                    visibilityChangeCount: 0
                });
                document.addEventListener("visibilitychange", this.trackPageVisibilityWithMeasurement);
                this.logger.verbose("ssoSilent called", correlationId);
                this.eventHandler.emitEvent(EventType.SSO_SILENT_START, InteractionType.Silent, validRequest);
                if (this.canUseNative(validRequest)) {
                    result = this.acquireTokenNative(validRequest, ApiId.ssoSilent).catch(function (e) {
                        // If native token acquisition fails for availability reasons fallback to standard flow
                        if (e instanceof NativeAuthError && e.isFatal()) {
                            _this.nativeExtensionProvider = undefined; // If extension gets uninstalled during session prevent future requests from continuing to attempt
                            var silentIframeClient = _this.createSilentIframeClient(validRequest.correlationId);
                            return silentIframeClient.acquireToken(validRequest);
                        }
                        throw e;
                    });
                }
                else {
                    silentIframeClient = this.createSilentIframeClient(validRequest.correlationId);
                    result = silentIframeClient.acquireToken(validRequest);
                }
                return [2 /*return*/, result.then(function (response) {
                        var _a, _b;
                        _this.eventHandler.emitEvent(EventType.SSO_SILENT_SUCCESS, InteractionType.Silent, response);
                        (_a = _this.ssoSilentMeasurement) === null || _a === void 0 ? void 0 : _a.addStaticFields({
                            accessTokenSize: response.accessToken.length,
                            idTokenSize: response.idToken.length
                        });
                        (_b = _this.ssoSilentMeasurement) === null || _b === void 0 ? void 0 : _b.endMeasurement({
                            success: true,
                            isNativeBroker: response.fromNativeBroker,
                            requestId: response.requestId
                        });
                        return response;
                    }).catch(function (e) {
                        var _a;
                        _this.eventHandler.emitEvent(EventType.SSO_SILENT_FAILURE, InteractionType.Silent, null, e);
                        (_a = _this.ssoSilentMeasurement) === null || _a === void 0 ? void 0 : _a.endMeasurement({
                            errorCode: e.errorCode,
                            subErrorCode: e.subError,
                            success: false
                        });
                        throw e;
                    }).finally(function () {
                        document.removeEventListener("visibilitychange", _this.trackPageVisibilityWithMeasurement);
                    })];
            });
        });
    };
    /**
     * This function redeems an authorization code (passed as code) from the eSTS token endpoint.
     * This authorization code should be acquired server-side using a confidential client to acquire a spa_code.
     * This API is not indended for normal authorization code acquisition and redemption.
     *
     * Redemption of this authorization code will not require PKCE, as it was acquired by a confidential client.
     *
     * @param request {@link AuthorizationCodeRequest}
     * @returns A promise that is fulfilled when this function has completed, or rejected if an error was raised.
     */
    ClientApplication.prototype.acquireTokenByCode = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var correlationId, atbcMeasurement, hybridAuthCode_1, response;
            var _this = this;
            return __generator$3(this, function (_a) {
                correlationId = this.getRequestCorrelationId(request);
                this.preflightBrowserEnvironmentCheck(InteractionType.Silent);
                this.logger.trace("acquireTokenByCode called", correlationId);
                this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_BY_CODE_START, InteractionType.Silent, request);
                atbcMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.AcquireTokenByCode, request.correlationId);
                try {
                    if (request.code && request.nativeAccountId) {
                        // Throw error in case server returns both spa_code and spa_accountid in exchange for auth code.
                        throw BrowserAuthError.createSpaCodeAndNativeAccountIdPresentError();
                    }
                    else if (request.code) {
                        hybridAuthCode_1 = request.code;
                        response = this.hybridAuthCodeResponses.get(hybridAuthCode_1);
                        if (!response) {
                            this.logger.verbose("Initiating new acquireTokenByCode request", correlationId);
                            response = this.acquireTokenByCodeAsync(__assign$5(__assign$5({}, request), { correlationId: correlationId }))
                                .then(function (result) {
                                _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_BY_CODE_SUCCESS, InteractionType.Silent, result);
                                _this.hybridAuthCodeResponses.delete(hybridAuthCode_1);
                                atbcMeasurement.addStaticFields({
                                    accessTokenSize: result.accessToken.length,
                                    idTokenSize: result.idToken.length
                                });
                                atbcMeasurement.endMeasurement({
                                    success: true,
                                    isNativeBroker: result.fromNativeBroker,
                                    requestId: result.requestId
                                });
                                return result;
                            })
                                .catch(function (error) {
                                _this.hybridAuthCodeResponses.delete(hybridAuthCode_1);
                                _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_BY_CODE_FAILURE, InteractionType.Silent, null, error);
                                atbcMeasurement.endMeasurement({
                                    errorCode: error.errorCode,
                                    subErrorCode: error.subError,
                                    success: false
                                });
                                throw error;
                            });
                            this.hybridAuthCodeResponses.set(hybridAuthCode_1, response);
                        }
                        else {
                            this.logger.verbose("Existing acquireTokenByCode request found", request.correlationId);
                            atbcMeasurement.discardMeasurement();
                        }
                        return [2 /*return*/, response];
                    }
                    else if (request.nativeAccountId) {
                        if (this.canUseNative(request, request.nativeAccountId)) {
                            return [2 /*return*/, this.acquireTokenNative(request, ApiId.acquireTokenByCode, request.nativeAccountId).catch(function (e) {
                                    // If native token acquisition fails for availability reasons fallback to standard flow
                                    if (e instanceof NativeAuthError && e.isFatal()) {
                                        _this.nativeExtensionProvider = undefined; // If extension gets uninstalled during session prevent future requests from continuing to attempt
                                    }
                                    throw e;
                                })];
                        }
                        else {
                            throw BrowserAuthError.createUnableToAcquireTokenFromNativePlatformError();
                        }
                    }
                    else {
                        throw BrowserAuthError.createAuthCodeOrNativeAccountIdRequiredError();
                    }
                }
                catch (e) {
                    this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_BY_CODE_FAILURE, InteractionType.Silent, null, e);
                    atbcMeasurement.endMeasurement({
                        errorCode: e instanceof AuthError && e.errorCode || undefined,
                        subErrorCode: e instanceof AuthError && e.subError || undefined,
                        success: false
                    });
                    throw e;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Creates a SilentAuthCodeClient to redeem an authorization code.
     * @param request
     * @returns Result of the operation to redeem the authorization code
     */
    ClientApplication.prototype.acquireTokenByCodeAsync = function (request) {
        var _a;
        return __awaiter$3(this, void 0, void 0, function () {
            var silentAuthCodeClient, silentTokenResult;
            var _this = this;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.logger.trace("acquireTokenByCodeAsync called", request.correlationId);
                        this.acquireTokenByCodeAsyncMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.AcquireTokenByCodeAsync, request.correlationId);
                        (_a = this.acquireTokenByCodeAsyncMeasurement) === null || _a === void 0 ? void 0 : _a.increment({
                            visibilityChangeCount: 0
                        });
                        document.addEventListener("visibilitychange", this.trackPageVisibilityWithMeasurement);
                        silentAuthCodeClient = this.createSilentAuthCodeClient(request.correlationId);
                        return [4 /*yield*/, silentAuthCodeClient.acquireToken(request).then(function (response) {
                                var _a;
                                (_a = _this.acquireTokenByCodeAsyncMeasurement) === null || _a === void 0 ? void 0 : _a.endMeasurement({
                                    success: true,
                                    fromCache: response.fromCache,
                                    isNativeBroker: response.fromNativeBroker,
                                    requestId: response.requestId
                                });
                                return response;
                            }).catch(function (tokenRenewalError) {
                                var _a;
                                (_a = _this.acquireTokenByCodeAsyncMeasurement) === null || _a === void 0 ? void 0 : _a.endMeasurement({
                                    errorCode: tokenRenewalError.errorCode,
                                    subErrorCode: tokenRenewalError.subError,
                                    success: false
                                });
                                throw tokenRenewalError;
                            }).finally(function () {
                                document.removeEventListener("visibilitychange", _this.trackPageVisibilityWithMeasurement);
                            })];
                    case 1:
                        silentTokenResult = _b.sent();
                        return [2 /*return*/, silentTokenResult];
                }
            });
        });
    };
    /**
     * Attempt to acquire an access token from the cache
     * @param silentCacheClient SilentCacheClient
     * @param commonRequest CommonSilentFlowRequest
     * @param silentRequest SilentRequest
     * @returns A promise that, when resolved, returns the access token
     */
    ClientApplication.prototype.acquireTokenFromCache = function (silentCacheClient, commonRequest, silentRequest) {
        return __awaiter$3(this, void 0, void 0, function () {
            return __generator$3(this, function (_a) {
                this.performanceClient.addQueueMeasurement(PerformanceEvents.AcquireTokenFromCache, commonRequest.correlationId);
                switch (silentRequest.cacheLookupPolicy) {
                    case CacheLookupPolicy.Default:
                    case CacheLookupPolicy.AccessToken:
                    case CacheLookupPolicy.AccessTokenAndRefreshToken:
                        return [2 /*return*/, silentCacheClient.acquireToken(commonRequest)];
                    default:
                        throw ClientAuthError.createRefreshRequiredError();
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Attempt to acquire an access token via a refresh token
     * @param commonRequest CommonSilentFlowRequest
     * @param silentRequest SilentRequest
     * @returns A promise that, when resolved, returns the access token
     */
    ClientApplication.prototype.acquireTokenByRefreshToken = function (commonRequest, silentRequest) {
        return __awaiter$3(this, void 0, void 0, function () {
            var silentRefreshClient;
            return __generator$3(this, function (_a) {
                this.performanceClient.addQueueMeasurement(PerformanceEvents.AcquireTokenByRefreshToken, commonRequest.correlationId);
                switch (silentRequest.cacheLookupPolicy) {
                    case CacheLookupPolicy.Default:
                    case CacheLookupPolicy.AccessTokenAndRefreshToken:
                    case CacheLookupPolicy.RefreshToken:
                    case CacheLookupPolicy.RefreshTokenAndNetwork:
                        silentRefreshClient = this.createSilentRefreshClient(commonRequest.correlationId);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.SilentRefreshClientAcquireToken, commonRequest.correlationId);
                        return [2 /*return*/, silentRefreshClient.acquireToken(commonRequest)];
                    default:
                        throw ClientAuthError.createRefreshRequiredError();
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Attempt to acquire an access token via an iframe
     * @param request CommonSilentFlowRequest
     * @returns A promise that, when resolved, returns the access token
     */
    ClientApplication.prototype.acquireTokenBySilentIframe = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var silentIframeClient;
            return __generator$3(this, function (_a) {
                this.performanceClient.addQueueMeasurement(PerformanceEvents.AcquireTokenBySilentIframe, request.correlationId);
                silentIframeClient = this.createSilentIframeClient(request.correlationId);
                this.performanceClient.setPreQueueTime(PerformanceEvents.SilentIframeClientAcquireToken, request.correlationId);
                return [2 /*return*/, silentIframeClient.acquireToken(request)];
            });
        });
    };
    // #endregion
    // #region Logout
    /**
     * Deprecated logout function. Use logoutRedirect or logoutPopup instead
     * @param logoutRequest
     * @deprecated
     */
    ClientApplication.prototype.logout = function (logoutRequest) {
        return __awaiter$3(this, void 0, void 0, function () {
            var correlationId;
            return __generator$3(this, function (_a) {
                correlationId = this.getRequestCorrelationId(logoutRequest);
                this.logger.warning("logout API is deprecated and will be removed in msal-browser v3.0.0. Use logoutRedirect instead.", correlationId);
                return [2 /*return*/, this.logoutRedirect(__assign$5({ correlationId: correlationId }, logoutRequest))];
            });
        });
    };
    /**
     * Use to log out the current user, and redirect the user to the postLogoutRedirectUri.
     * Default behaviour is to redirect the user to `window.location.href`.
     * @param logoutRequest
     */
    ClientApplication.prototype.logoutRedirect = function (logoutRequest) {
        return __awaiter$3(this, void 0, void 0, function () {
            var correlationId, redirectClient;
            return __generator$3(this, function (_a) {
                correlationId = this.getRequestCorrelationId(logoutRequest);
                this.preflightBrowserEnvironmentCheck(InteractionType.Redirect);
                redirectClient = this.createRedirectClient(correlationId);
                return [2 /*return*/, redirectClient.logout(logoutRequest)];
            });
        });
    };
    /**
     * Clears local cache for the current user then opens a popup window prompting the user to sign-out of the server
     * @param logoutRequest
     */
    ClientApplication.prototype.logoutPopup = function (logoutRequest) {
        try {
            var correlationId = this.getRequestCorrelationId(logoutRequest);
            this.preflightBrowserEnvironmentCheck(InteractionType.Popup);
            var popupClient = this.createPopupClient(correlationId);
            return popupClient.logout(logoutRequest);
        }
        catch (e) {
            // Since this function is syncronous we need to reject
            return Promise.reject(e);
        }
    };
    // #endregion
    // #region Account APIs
    /**
     * Returns all accounts that MSAL currently has data for.
     * (the account object is created at the time of successful login)
     * or empty array when no accounts are found
     * @returns Array of account objects in cache
     */
    ClientApplication.prototype.getAllAccounts = function () {
        this.logger.verbose("getAllAccounts called");
        return this.isBrowserEnvironment ? this.browserStorage.getAllAccounts() : [];
    };
    /**
     * Returns the signed in account matching username.
     * (the account object is created at the time of successful login)
     * or null when no matching account is found.
     * This API is provided for convenience but getAccountById should be used for best reliability
     * @param username
     * @returns The account object stored in MSAL
     */
    ClientApplication.prototype.getAccountByUsername = function (username) {
        this.logger.trace("getAccountByUsername called");
        if (!username) {
            this.logger.warning("getAccountByUsername: No username provided");
            return null;
        }
        var account = this.browserStorage.getAccountInfoFilteredBy({ username: username });
        if (account) {
            this.logger.verbose("getAccountByUsername: Account matching username found, returning");
            this.logger.verbosePii("getAccountByUsername: Returning signed-in accounts matching username: " + username);
            return account;
        }
        else {
            this.logger.verbose("getAccountByUsername: No matching account found, returning null");
            return null;
        }
    };
    /**
     * Returns the signed in account matching homeAccountId.
     * (the account object is created at the time of successful login)
     * or null when no matching account is found
     * @param homeAccountId
     * @returns The account object stored in MSAL
     */
    ClientApplication.prototype.getAccountByHomeId = function (homeAccountId) {
        this.logger.trace("getAccountByHomeId called");
        if (!homeAccountId) {
            this.logger.warning("getAccountByHomeId: No homeAccountId provided");
            return null;
        }
        var account = this.browserStorage.getAccountInfoFilteredBy({ homeAccountId: homeAccountId });
        if (account) {
            this.logger.verbose("getAccountByHomeId: Account matching homeAccountId found, returning");
            this.logger.verbosePii("getAccountByHomeId: Returning signed-in accounts matching homeAccountId: " + homeAccountId);
            return account;
        }
        else {
            this.logger.verbose("getAccountByHomeId: No matching account found, returning null");
            return null;
        }
    };
    /**
     * Returns the signed in account matching localAccountId.
     * (the account object is created at the time of successful login)
     * or null when no matching account is found
     * @param localAccountId
     * @returns The account object stored in MSAL
     */
    ClientApplication.prototype.getAccountByLocalId = function (localAccountId) {
        this.logger.trace("getAccountByLocalId called");
        if (!localAccountId) {
            this.logger.warning("getAccountByLocalId: No localAccountId provided");
            return null;
        }
        var account = this.browserStorage.getAccountInfoFilteredBy({ localAccountId: localAccountId });
        if (account) {
            this.logger.verbose("getAccountByLocalId: Account matching localAccountId found, returning");
            this.logger.verbosePii("getAccountByLocalId: Returning signed-in accounts matching localAccountId: " + localAccountId);
            return account;
        }
        else {
            this.logger.verbose("getAccountByLocalId: No matching account found, returning null");
            return null;
        }
    };
    /**
     * Sets the account to use as the active account. If no account is passed to the acquireToken APIs, then MSAL will use this active account.
     * @param account
     */
    ClientApplication.prototype.setActiveAccount = function (account) {
        this.browserStorage.setActiveAccount(account);
    };
    /**
     * Gets the currently active account
     */
    ClientApplication.prototype.getActiveAccount = function () {
        return this.browserStorage.getActiveAccount();
    };
    // #endregion
    // #region Helpers
    /**
     * Helper to validate app environment before making an auth request
     *
     * @protected
     * @param {InteractionType} interactionType What kind of interaction is being used
     * @param {boolean} [setInteractionInProgress=true] Whether to set interaction in progress temp cache flag
     */
    ClientApplication.prototype.preflightBrowserEnvironmentCheck = function (interactionType, setInteractionInProgress) {
        if (setInteractionInProgress === void 0) { setInteractionInProgress = true; }
        this.logger.verbose("preflightBrowserEnvironmentCheck started");
        // Block request if not in browser environment
        BrowserUtils.blockNonBrowserEnvironment(this.isBrowserEnvironment);
        // Block redirects if in an iframe
        BrowserUtils.blockRedirectInIframe(interactionType, this.config.system.allowRedirectInIframe);
        // Block auth requests inside a hidden iframe
        BrowserUtils.blockReloadInHiddenIframes();
        // Block redirectUri opened in a popup from calling MSAL APIs
        BrowserUtils.blockAcquireTokenInPopups();
        // Block token acquisition before initialize has been called if native brokering is enabled
        BrowserUtils.blockNativeBrokerCalledBeforeInitialized(this.config.system.allowNativeBroker, this.initialized);
        // Block redirects if memory storage is enabled but storeAuthStateInCookie is not
        if (interactionType === InteractionType.Redirect &&
            this.config.cache.cacheLocation === BrowserCacheLocation.MemoryStorage &&
            !this.config.cache.storeAuthStateInCookie) {
            throw BrowserConfigurationAuthError.createInMemoryRedirectUnavailableError();
        }
        if (interactionType === InteractionType.Redirect || interactionType === InteractionType.Popup) {
            this.preflightInteractiveRequest(setInteractionInProgress);
        }
    };
    /**
     * Preflight check for interactive requests
     *
     * @protected
     * @param {boolean} setInteractionInProgress Whether to set interaction in progress temp cache flag
     */
    ClientApplication.prototype.preflightInteractiveRequest = function (setInteractionInProgress) {
        this.logger.verbose("preflightInteractiveRequest called, validating app environment");
        // block the reload if it occurred inside a hidden iframe
        BrowserUtils.blockReloadInHiddenIframes();
        // Set interaction in progress temporary cache or throw if alread set.
        if (setInteractionInProgress) {
            this.browserStorage.setInteractionInProgress(true);
        }
    };
    /**
     * Acquire a token from native device (e.g. WAM)
     * @param request
     */
    ClientApplication.prototype.acquireTokenNative = function (request, apiId, accountId) {
        return __awaiter$3(this, void 0, void 0, function () {
            var nativeClient;
            return __generator$3(this, function (_a) {
                this.logger.trace("acquireTokenNative called");
                if (!this.nativeExtensionProvider) {
                    throw BrowserAuthError.createNativeConnectionNotEstablishedError();
                }
                nativeClient = new NativeInteractionClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, apiId, this.performanceClient, this.nativeExtensionProvider, accountId || this.getNativeAccountId(request), this.nativeInternalStorage, request.correlationId);
                return [2 /*return*/, nativeClient.acquireToken(request)];
            });
        });
    };
    /**
     * Returns boolean indicating if this request can use the native broker
     * @param request
     */
    ClientApplication.prototype.canUseNative = function (request, accountId) {
        this.logger.trace("canUseNative called");
        if (!NativeMessageHandler.isNativeAvailable(this.config, this.logger, this.nativeExtensionProvider, request.authenticationScheme)) {
            this.logger.trace("canUseNative: isNativeAvailable returned false, returning false");
            return false;
        }
        if (request.prompt) {
            switch (request.prompt) {
                case PromptValue.NONE:
                case PromptValue.CONSENT:
                case PromptValue.LOGIN:
                    this.logger.trace("canUseNative: prompt is compatible with native flow");
                    break;
                default:
                    this.logger.trace("canUseNative: prompt = " + request.prompt + " is not compatible with native flow, returning false");
                    return false;
            }
        }
        if (!accountId && !this.getNativeAccountId(request)) {
            this.logger.trace("canUseNative: nativeAccountId is not available, returning false");
            return false;
        }
        return true;
    };
    /**
     * Get the native accountId from the account
     * @param request
     * @returns
     */
    ClientApplication.prototype.getNativeAccountId = function (request) {
        var account = request.account || this.browserStorage.getAccountInfoByHints(request.loginHint, request.sid) || this.getActiveAccount();
        return account && account.nativeAccountId || "";
    };
    /**
     * Returns new instance of the Popup Interaction Client
     * @param correlationId
     */
    ClientApplication.prototype.createPopupClient = function (correlationId) {
        return new PopupClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, this.performanceClient, this.nativeInternalStorage, this.nativeExtensionProvider, correlationId);
    };
    /**
     * Returns new instance of the Redirect Interaction Client
     * @param correlationId
     */
    ClientApplication.prototype.createRedirectClient = function (correlationId) {
        return new RedirectClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, this.performanceClient, this.nativeInternalStorage, this.nativeExtensionProvider, correlationId);
    };
    /**
     * Returns new instance of the Silent Iframe Interaction Client
     * @param correlationId
     */
    ClientApplication.prototype.createSilentIframeClient = function (correlationId) {
        return new SilentIframeClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, ApiId.ssoSilent, this.performanceClient, this.nativeInternalStorage, this.nativeExtensionProvider, correlationId);
    };
    /**
     * Returns new instance of the Silent Cache Interaction Client
     */
    ClientApplication.prototype.createSilentCacheClient = function (correlationId) {
        return new SilentCacheClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, this.performanceClient, this.nativeExtensionProvider, correlationId);
    };
    /**
     * Returns new instance of the Silent Refresh Interaction Client
     */
    ClientApplication.prototype.createSilentRefreshClient = function (correlationId) {
        return new SilentRefreshClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, this.performanceClient, this.nativeExtensionProvider, correlationId);
    };
    /**
     * Returns new instance of the Silent AuthCode Interaction Client
     */
    ClientApplication.prototype.createSilentAuthCodeClient = function (correlationId) {
        return new SilentAuthCodeClient(this.config, this.browserStorage, this.browserCrypto, this.logger, this.eventHandler, this.navigationClient, ApiId.acquireTokenByCode, this.performanceClient, this.nativeExtensionProvider, correlationId);
    };
    /**
     * Adds event callbacks to array
     * @param callback
     */
    ClientApplication.prototype.addEventCallback = function (callback) {
        return this.eventHandler.addEventCallback(callback);
    };
    /**
     * Removes callback with provided id from callback array
     * @param callbackId
     */
    ClientApplication.prototype.removeEventCallback = function (callbackId) {
        this.eventHandler.removeEventCallback(callbackId);
    };
    /**
     * Registers a callback to receive performance events.
     *
     * @param {PerformanceCallbackFunction} callback
     * @returns {string}
     */
    ClientApplication.prototype.addPerformanceCallback = function (callback) {
        return this.performanceClient.addPerformanceCallback(callback);
    };
    /**
     * Removes a callback registered with addPerformanceCallback.
     *
     * @param {string} callbackId
     * @returns {boolean}
     */
    ClientApplication.prototype.removePerformanceCallback = function (callbackId) {
        return this.performanceClient.removePerformanceCallback(callbackId);
    };
    /**
     * Adds event listener that emits an event when a user account is added or removed from localstorage in a different browser tab or window
     */
    ClientApplication.prototype.enableAccountStorageEvents = function () {
        this.eventHandler.enableAccountStorageEvents();
    };
    /**
     * Removes event listener that emits an event when a user account is added or removed from localstorage in a different browser tab or window
     */
    ClientApplication.prototype.disableAccountStorageEvents = function () {
        this.eventHandler.disableAccountStorageEvents();
    };
    /**
     * Gets the token cache for the application.
     */
    ClientApplication.prototype.getTokenCache = function () {
        return this.tokenCache;
    };
    /**
     * Returns the logger instance
     */
    ClientApplication.prototype.getLogger = function () {
        return this.logger;
    };
    /**
     * Replaces the default logger set in configurations with new Logger with new configurations
     * @param logger Logger instance
     */
    ClientApplication.prototype.setLogger = function (logger) {
        this.logger = logger;
    };
    /**
     * Called by wrapper libraries (Angular & React) to set SKU and Version passed down to telemetry, logger, etc.
     * @param sku
     * @param version
     */
    ClientApplication.prototype.initializeWrapperLibrary = function (sku, version) {
        // Validate the SKU passed in is one we expect
        this.browserStorage.setWrapperMetadata(sku, version);
    };
    /**
     * Sets navigation client
     * @param navigationClient
     */
    ClientApplication.prototype.setNavigationClient = function (navigationClient) {
        this.navigationClient = navigationClient;
    };
    /**
     * Returns the configuration object
     */
    ClientApplication.prototype.getConfiguration = function () {
        return this.config;
    };
    /**
     * Generates a correlation id for a request if none is provided.
     *
     * @protected
     * @param {?Partial<BaseAuthRequest>} [request]
     * @returns {string}
     */
    ClientApplication.prototype.getRequestCorrelationId = function (request) {
        if (request === null || request === void 0 ? void 0 : request.correlationId) {
            return request.correlationId;
        }
        if (this.isBrowserEnvironment) {
            return this.browserCrypto.createNewGuid();
        }
        /*
         * Included for fallback for non-browser environments,
         * and to ensure this method always returns a string.
         */
        return Constants.EMPTY_STRING;
    };
    return ClientApplication;
}());

/*! @azure/msal-browser v2.38.3 2023-10-27 */

/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * The PublicClientApplication class is the object exposed by the library to perform authentication and authorization functions in Single Page Applications
 * to obtain JWT tokens as described in the OAuth 2.0 Authorization Code Flow with PKCE specification.
 */
var PublicClientApplication = /** @class */ (function (_super) {
    __extends$g(PublicClientApplication, _super);
    /**
     * @constructor
     * Constructor for the PublicClientApplication used to instantiate the PublicClientApplication object
     *
     * Important attributes in the Configuration object for auth are:
     * - clientID: the application ID of your application. You can obtain one by registering your application with our Application registration portal : https://portal.azure.com/#blade/Microsoft_AAD_IAM/ActiveDirectoryMenuBlade/RegisteredAppsPreview
     * - authority: the authority URL for your application.
     * - redirect_uri: the uri of your application registered in the portal.
     *
     * In Azure AD, authority is a URL indicating the Azure active directory that MSAL uses to obtain tokens.
     * It is of the form https://login.microsoftonline.com/{Enter_the_Tenant_Info_Here}
     * If your application supports Accounts in one organizational directory, replace "Enter_the_Tenant_Info_Here" value with the Tenant Id or Tenant name (for example, contoso.microsoft.com).
     * If your application supports Accounts in any organizational directory, replace "Enter_the_Tenant_Info_Here" value with organizations.
     * If your application supports Accounts in any organizational directory and personal Microsoft accounts, replace "Enter_the_Tenant_Info_Here" value with common.
     * To restrict support to Personal Microsoft accounts only, replace "Enter_the_Tenant_Info_Here" value with consumers.
     *
     * In Azure B2C, authority is of the form https://{instance}/tfp/{tenant}/{policyName}/
     * Full B2C functionality will be available in this library in future versions.
     *
     * @param configuration object for the MSAL PublicClientApplication instance
     */
    function PublicClientApplication(configuration) {
        var _this = _super.call(this, configuration) || this;
        _this.astsAsyncMeasurement = undefined;
        _this.activeSilentTokenRequests = new Map();
        // Register listener functions
        _this.trackPageVisibility = _this.trackPageVisibility.bind(_this);
        return _this;
    }
    /**
     * Use when initiating the login process by redirecting the user's browser to the authorization endpoint. This function redirects the page, so
     * any code that follows this function will not execute.
     *
     * IMPORTANT: It is NOT recommended to have code that is dependent on the resolution of the Promise. This function will navigate away from the current
     * browser window. It currently returns a Promise in order to reflect the asynchronous nature of the code running in this function.
     *
     * @param request
     */
    PublicClientApplication.prototype.loginRedirect = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var correlationId;
            return __generator$3(this, function (_a) {
                correlationId = this.getRequestCorrelationId(request);
                this.logger.verbose("loginRedirect called", correlationId);
                return [2 /*return*/, this.acquireTokenRedirect(__assign$5({ correlationId: correlationId }, (request || DEFAULT_REQUEST)))];
            });
        });
    };
    /**
     * Use when initiating the login process via opening a popup window in the user's browser
     *
     * @param request
     *
     * @returns A promise that is fulfilled when this function has completed, or rejected if an error was raised.
     */
    PublicClientApplication.prototype.loginPopup = function (request) {
        var correlationId = this.getRequestCorrelationId(request);
        this.logger.verbose("loginPopup called", correlationId);
        return this.acquireTokenPopup(__assign$5({ correlationId: correlationId }, (request || DEFAULT_REQUEST)));
    };
    /**
     * Silently acquire an access token for a given set of scopes. Returns currently processing promise if parallel requests are made.
     *
     * @param {@link (SilentRequest:type)}
     * @returns {Promise.<AuthenticationResult>} - a promise that is fulfilled when this function has completed, or rejected if an error was raised. Returns the {@link AuthResponse} object
     */
    PublicClientApplication.prototype.acquireTokenSilent = function (request) {
        return __awaiter$3(this, void 0, void 0, function () {
            var correlationId, atsMeasurement, account, thumbprint, silentRequestKey, cachedResponse, response;
            var _this = this;
            return __generator$3(this, function (_a) {
                correlationId = this.getRequestCorrelationId(request);
                atsMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.AcquireTokenSilent, correlationId);
                atsMeasurement.addStaticFields({
                    cacheLookupPolicy: request.cacheLookupPolicy
                });
                this.preflightBrowserEnvironmentCheck(InteractionType.Silent);
                this.logger.verbose("acquireTokenSilent called", correlationId);
                account = request.account || this.getActiveAccount();
                if (!account) {
                    throw BrowserAuthError.createNoAccountError();
                }
                thumbprint = {
                    clientId: this.config.auth.clientId,
                    authority: request.authority || Constants.EMPTY_STRING,
                    scopes: request.scopes,
                    homeAccountIdentifier: account.homeAccountId,
                    claims: request.claims,
                    authenticationScheme: request.authenticationScheme,
                    resourceRequestMethod: request.resourceRequestMethod,
                    resourceRequestUri: request.resourceRequestUri,
                    shrClaims: request.shrClaims,
                    sshKid: request.sshKid
                };
                silentRequestKey = JSON.stringify(thumbprint);
                cachedResponse = this.activeSilentTokenRequests.get(silentRequestKey);
                if (typeof cachedResponse === "undefined") {
                    this.logger.verbose("acquireTokenSilent called for the first time, storing active request", correlationId);
                    this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenSilentAsync, correlationId);
                    response = this.acquireTokenSilentAsync(__assign$5(__assign$5({}, request), { correlationId: correlationId }), account)
                        .then(function (result) {
                        _this.activeSilentTokenRequests.delete(silentRequestKey);
                        atsMeasurement.addStaticFields({
                            accessTokenSize: result.accessToken.length,
                            idTokenSize: result.idToken.length
                        });
                        atsMeasurement.endMeasurement({
                            success: true,
                            fromCache: result.fromCache,
                            isNativeBroker: result.fromNativeBroker,
                            cacheLookupPolicy: request.cacheLookupPolicy,
                            requestId: result.requestId,
                        });
                        return result;
                    })
                        .catch(function (error) {
                        _this.activeSilentTokenRequests.delete(silentRequestKey);
                        atsMeasurement.endMeasurement({
                            errorCode: error.errorCode,
                            subErrorCode: error.subError,
                            success: false
                        });
                        throw error;
                    });
                    this.activeSilentTokenRequests.set(silentRequestKey, response);
                    return [2 /*return*/, response];
                }
                else {
                    this.logger.verbose("acquireTokenSilent has been called previously, returning the result from the first call", correlationId);
                    // Discard measurements for memoized calls, as they are usually only a couple of ms and will artificially deflate metrics
                    atsMeasurement.discardMeasurement();
                    return [2 /*return*/, cachedResponse];
                }
            });
        });
    };
    PublicClientApplication.prototype.trackPageVisibility = function () {
        if (!this.astsAsyncMeasurement) {
            return;
        }
        this.logger.info("Perf: Visibility change detected");
        this.astsAsyncMeasurement.increment({
            visibilityChangeCount: 1,
        });
    };
    /**
     * Silently acquire an access token for a given set of scopes. Will use cached token if available, otherwise will attempt to acquire a new token from the network via refresh token.
     * @param {@link (SilentRequest:type)}
     * @param {@link (AccountInfo:type)}
     * @returns {Promise.<AuthenticationResult>} - a promise that is fulfilled when this function has completed, or rejected if an error was raised. Returns the {@link AuthResponse}
     */
    PublicClientApplication.prototype.acquireTokenSilentAsync = function (request, account) {
        var _a;
        return __awaiter$3(this, void 0, void 0, function () {
            var result, silentRequest, silentCacheClient, silentRequest_1, requestWithCLP_1;
            var _this = this;
            return __generator$3(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.performanceClient.addQueueMeasurement(PerformanceEvents.AcquireTokenSilentAsync, request.correlationId);
                        this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_START, InteractionType.Silent, request);
                        this.astsAsyncMeasurement = this.performanceClient.startMeasurement(PerformanceEvents.AcquireTokenSilentAsync, request.correlationId);
                        (_a = this.astsAsyncMeasurement) === null || _a === void 0 ? void 0 : _a.increment({
                            visibilityChangeCount: 0
                        });
                        document.addEventListener("visibilitychange", this.trackPageVisibility);
                        if (!(NativeMessageHandler.isNativeAvailable(this.config, this.logger, this.nativeExtensionProvider, request.authenticationScheme) && account.nativeAccountId)) return [3 /*break*/, 1];
                        this.logger.verbose("acquireTokenSilent - attempting to acquire token from native platform");
                        silentRequest = __assign$5(__assign$5({}, request), { account: account });
                        result = this.acquireTokenNative(silentRequest, ApiId.acquireTokenSilent_silentFlow).catch(function (e) { return __awaiter$3(_this, void 0, void 0, function () {
                            var silentIframeClient;
                            return __generator$3(this, function (_a) {
                                // If native token acquisition fails for availability reasons fallback to web flow
                                if (e instanceof NativeAuthError && e.isFatal()) {
                                    this.logger.verbose("acquireTokenSilent - native platform unavailable, falling back to web flow");
                                    this.nativeExtensionProvider = undefined; // Prevent future requests from continuing to attempt
                                    silentIframeClient = this.createSilentIframeClient(request.correlationId);
                                    return [2 /*return*/, silentIframeClient.acquireToken(request)];
                                }
                                throw e;
                            });
                        }); });
                        return [3 /*break*/, 3];
                    case 1:
                        this.logger.verbose("acquireTokenSilent - attempting to acquire token from web flow");
                        silentCacheClient = this.createSilentCacheClient(request.correlationId);
                        this.performanceClient.setPreQueueTime(PerformanceEvents.InitializeSilentRequest, request.correlationId);
                        return [4 /*yield*/, silentCacheClient.initializeSilentRequest(request, account)];
                    case 2:
                        silentRequest_1 = _b.sent();
                        requestWithCLP_1 = __assign$5(__assign$5({}, request), { 
                            // set the request's CacheLookupPolicy to Default if it was not optionally passed in
                            cacheLookupPolicy: request.cacheLookupPolicy || CacheLookupPolicy.Default });
                        this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenFromCache, silentRequest_1.correlationId);
                        result = this.acquireTokenFromCache(silentCacheClient, silentRequest_1, requestWithCLP_1).catch(function (cacheError) {
                            if (requestWithCLP_1.cacheLookupPolicy === CacheLookupPolicy.AccessToken) {
                                throw cacheError;
                            }
                            // block the reload if it occurred inside a hidden iframe
                            BrowserUtils.blockReloadInHiddenIframes();
                            _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_NETWORK_START, InteractionType.Silent, silentRequest_1);
                            _this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenByRefreshToken, silentRequest_1.correlationId);
                            return _this.acquireTokenByRefreshToken(silentRequest_1, requestWithCLP_1).catch(function (refreshTokenError) {
                                var isServerError = refreshTokenError instanceof ServerError;
                                var isInteractionRequiredError = refreshTokenError instanceof InteractionRequiredAuthError;
                                var rtNotFound = (refreshTokenError.errorCode === InteractionRequiredAuthErrorMessage.noTokensFoundError.code);
                                var isInvalidGrantError = (refreshTokenError.errorCode === BrowserConstants.INVALID_GRANT_ERROR);
                                if ((!isServerError ||
                                    !isInvalidGrantError ||
                                    isInteractionRequiredError ||
                                    requestWithCLP_1.cacheLookupPolicy === CacheLookupPolicy.AccessTokenAndRefreshToken ||
                                    requestWithCLP_1.cacheLookupPolicy === CacheLookupPolicy.RefreshToken)
                                    && (requestWithCLP_1.cacheLookupPolicy !== CacheLookupPolicy.Skip)
                                    && !rtNotFound) {
                                    throw refreshTokenError;
                                }
                                _this.logger.verbose("Refresh token expired/invalid or CacheLookupPolicy is set to Skip, attempting acquire token by iframe.", request.correlationId);
                                _this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenBySilentIframe, silentRequest_1.correlationId);
                                return _this.acquireTokenBySilentIframe(silentRequest_1);
                            });
                        });
                        _b.label = 3;
                    case 3: return [2 /*return*/, result.then(function (response) {
                            var _a;
                            _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_SUCCESS, InteractionType.Silent, response);
                            (_a = _this.astsAsyncMeasurement) === null || _a === void 0 ? void 0 : _a.endMeasurement({
                                success: true,
                                fromCache: response.fromCache,
                                isNativeBroker: response.fromNativeBroker,
                                requestId: response.requestId
                            });
                            return response;
                        }).catch(function (tokenRenewalError) {
                            var _a;
                            _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_FAILURE, InteractionType.Silent, null, tokenRenewalError);
                            (_a = _this.astsAsyncMeasurement) === null || _a === void 0 ? void 0 : _a.endMeasurement({
                                errorCode: tokenRenewalError.errorCode,
                                subErrorCode: tokenRenewalError.subError,
                                success: false
                            });
                            throw tokenRenewalError;
                        }).finally(function () {
                            document.removeEventListener("visibilitychange", _this.trackPageVisibility);
                        })];
                }
            });
        });
    };
    return PublicClientApplication;
}(ClientApplication));

function e(e){this.message=e;}e.prototype=new Error,e.prototype.name="InvalidCharacterError";var r="undefined"!=typeof window&&window.atob&&window.atob.bind(window)||function(r){var t=String(r).replace(/=+$/,"");if(t.length%4==1)throw new e("'atob' failed: The string to be decoded is not correctly encoded.");for(var n,o,a=0,i=0,c="";o=t.charAt(i++);~o&&(n=a%4?64*n+o:o,a++%4)?c+=String.fromCharCode(255&n>>(-2*a&6)):0)o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(o);return c};function t(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw "Illegal base64url string!"}try{return function(e){return decodeURIComponent(r(e).replace(/(.)/g,(function(e,r){var t=r.charCodeAt(0).toString(16).toUpperCase();return t.length<2&&(t="0"+t),"%"+t})))}(t)}catch(e){return r(t)}}function n(e){this.message=e;}function o(e,r){if("string"!=typeof e)throw new n("Invalid token specified");var o=!0===(r=r||{}).header?0:1;try{return JSON.parse(t(e.split(".")[o]))}catch(e){throw new n("Invalid token specified: "+e.message)}}n.prototype=new Error,n.prototype.name="InvalidTokenError";

/**
 * A manager for the map control's authentication.
 * Exposed through the authentication property of the atlas.Map class.
 * Cannot be instantiated by the user.
 */
var AuthenticationManager = /** @class */ (function () {
    /**
     * @internal
     */
    function AuthenticationManager(map) {
        var _this = this;
        /**
         * A static fallback storage for when localStorage and sessionStorage are unavailable.
         */
        this.fallbackStorage = {};
        /**
         * Triggers the user provided function to fetch the token and stores it.
         * @internal
         */
        this._triggerTokenFetch = function (isAnonymousAuth) {
            if (isAnonymousAuth === void 0) { isAnonymousAuth = false; }
            return new Promise(function (resolve, reject) {
                if (typeof _this.options.getToken !== "function") {
                    reject(new Error("Token cannot be ".concat(isAnonymousAuth ? 'fetched' : 'renewed', " because getToken was not set or is not a function.")));
                    return;
                }
                _this.options.getToken(function (token) {
                    try {
                        // Try to get the timeout first as this will guarantee the token is correctly formatted.
                        var timeout = _this._getTokenExpiry(token) - AuthenticationManager.constants.tokenRefreshClockSkew;
                        _this._storeToken(token);
                        _this._setTimeoutTokenFetch(timeout);
                        resolve();
                    }
                    catch (_a) {
                        reject(new Error("Invalid token returned by getToken function"));
                    }
                }, function (error) {
                    reject(error);
                }, _this.map);
            });
        };
        /**
         * Create a timer to trigger the user provided function to fetch the token.
         * @param seconds delay in seconds
         * @internal
         */
        this._setTimeoutTokenFetch = function (seconds) {
            clearTimeout(_this.tokenTimeOutHandle); // Clear the previous refresh timeout in case it hadn't triggered yet.
            // @ts-ignore
            // tslint:disable-next-line: no-string-based-set-timeout
            _this.tokenTimeOutHandle = setTimeout(_this._triggerTokenFetch, Math.min(seconds * 1000, 0x7fffffff) // setTimeout will fire immediately if the delay is greater than 2^31-1.
            );
        };
        var serviceOptions = map.getServiceOptions();
        this.options = serviceOptions.authOptions;
        this.sessionId = serviceOptions.sessionId;
        this.map = map;
    }
    /**
     * Initializes the authentication mechanism specified in AuthenticationOptions.
     * If this method has been called before the original initialize promise is returned.
     */
    AuthenticationManager.prototype.initialize = function () {
        var _this = this;
        if (!this.initPromise) {
            // If an init promise hasn't been created this is the first initialize call.
            this.initPromise = new Promise(function (resolve, reject) {
                if (_this.options.authType === AuthenticationType.subscriptionKey) {
                    resolve();
                }
                else if (_this.options.authType === AuthenticationType.aad) {
                    // If a specific auth context was provided to the map use that.
                    // If not use/create a default auth context shared between maps.
                    _this.options.authContext = _this.options.authContext ||
                        AuthenticationManager.getDefaultAuthContext(_this.options);
                    _this.options.authContext.handleRedirectPromise().then(function () {
                        // Login and acquire a token.
                        // Fire it async so that users can add any listeners for token acquire events first.
                        // tslint:disable-next-line: no-string-based-set-timeout
                        setTimeout(function () { return _this._loginAndAcquireTokenForAAD(resolve, reject); });
                    }).catch(function (error) {
                        reject(new Error("Error logging in the AAD users: " + error));
                        return;
                    });
                }
                else if (_this.options.authType === AuthenticationType.anonymous) {
                    // Anonymous authentication, just call the users provided callback.
                    resolve(_this._triggerTokenFetch(true));
                }
                else if (_this.options.authType === AuthenticationType.sas) {
                    if (_this.options.sasToken) {
                        var expiresIn = -1;
                        try {
                            expiresIn = _this._getTokenExpiry(_this.options.sasToken);
                        }
                        catch (_a) {
                            reject(new Error("An invalid sasToken was provided."));
                            return;
                        }
                        if (expiresIn > AuthenticationManager.constants.tokenRefreshClockSkew) {
                            // Save the initial token
                            _this._storeToken(_this.options.sasToken);
                            // Create a timer to refresh the token
                            _this._setTimeoutTokenFetch(expiresIn - AuthenticationManager.constants.tokenRefreshClockSkew);
                            resolve();
                            return;
                        }
                    }
                    // Call the users provided callback to fetch the token.
                    resolve(_this._triggerTokenFetch());
                }
                else {
                    reject(new Error("An invalid authentication type was specified."));
                }
            });
        }
        return this.initPromise;
    };
    /**
     * Cleans up any resources used by the authentication manager.
     */
    AuthenticationManager.prototype.dispose = function () {
        if (this.tokenTimeOutHandle) {
            clearTimeout(this.tokenTimeOutHandle);
            this.tokenTimeOutHandle = null;
        }
    };
    /**
     * Gets the default auth context to be shared between maps without one specified to them.
     */
    AuthenticationManager.getDefaultAuthContext = function (options) {
        if (!options.aadAppId) {
            throw new Error("No AAD app ID was specified.");
        }
        if (!options.aadTenant) {
            throw new Error("No AAD tenant was specified.");
        }
        // Create a new auth context if one doesn't already exist.
        if (!this.defaultAuthContext) {
            this.defaultAuthContext = new PublicClientApplication({
                auth: {
                    authority: "".concat(options.aadInstance || env.aadInstance).concat(options.aadTenant),
                    clientId: options.aadAppId
                },
                cache: {
                    cacheLocation: this.constants.preferredCacheLocation
                }
            });
        }
        // Return either a reused auth context or the one created just above.
        return this.defaultAuthContext;
    };
    /**
     * Redirect to the login page if the user is not logged in, otherwise acquire the access token and resolve the promise.
     * @param resolve the callback for the promise created from the initialize call
     * @param reject the callback for the promise created from the initialize call
     */
    AuthenticationManager.prototype._loginAndAcquireTokenForAAD = function (resolve, reject) {
        var _a;
        var accounts = ((_a = this.options.authContext) === null || _a === void 0 ? void 0 : _a.getAllAccounts()) || [];
        if (accounts.length === 0) {
            // Redirect to the login page if the user is not logged in.
            this.options.authContext.loginRedirect();
            resolve();
        }
        else {
            // Acquire the access token and then resolve the promise.
            this.options.authContext.setActiveAccount(accounts[0]);
            this._acquireTokenForAAD(resolve, reject);
        }
    };
    /**
     * Acquire an access token silently and save it for later use. User might be prompted to login if the call fails.
     * A timeout will be set to refresh the token before it expires.
     * @param resolve an optional callback for a promise
     * @param reject an optional callback for a promise
     */
    AuthenticationManager.prototype._acquireTokenForAAD = function (resolve, reject) {
        var _this = this;
        var request = { scopes: [constants.aadResourceId] };
        this.options.authContext
            .acquireTokenSilent(request)
            .then(function (response) {
            // Save the token to local/session storage
            _this._saveItem(AuthenticationManager.constants.storage.tokenKey, response.accessToken);
            // Fire the token acquired event
            var tokenEvent = {
                map: _this.map,
                type: AuthenticationManager.constants.events.tokenAcquired
            };
            _this.map.events.invoke(AuthenticationManager.constants.events.tokenAcquired, tokenEvent);
            // Set a timeout to refresh the token before it expires
            clearTimeout(_this.tokenTimeOutHandle);
            var timeout = new Date(response.expiresOn).getTime() - Date.now();
            _this.tokenTimeOutHandle = setTimeout(function () { return _this._acquireTokenForAAD(); }, timeout);
            resolve === null || resolve === void 0 ? void 0 : resolve();
        })
            .catch(function (error) {
            if (error instanceof InteractionRequiredAuthError) {
                // Fallback to interaction when silent call fails
                _this.options.authContext.acquireTokenRedirect(request);
                return resolve === null || resolve === void 0 ? void 0 : resolve();
            }
            reject === null || reject === void 0 ? void 0 : reject(error);
        });
    };
    /**
     * Returns the current authentication type in use.
     */
    AuthenticationManager.prototype.getAuthType = function () {
        return this.options.authType;
    };
    /**
     * Returns the current client ID in use.
     */
    AuthenticationManager.prototype.getClientId = function () {
        return this.options.clientId;
    };
    /**
     * Returns the access token with an audience URI of https://atlas.microsoft.com.
     */
    AuthenticationManager.prototype.getToken = function () {
        if (this.options.authType === AuthenticationType.aad) {
            return this._getItem(AuthenticationManager.constants.storage.tokenKey);
        }
        else if (this.options.authType === AuthenticationType.anonymous
            || this.options.authType === AuthenticationType.sas) {
            var token = this._getItem(AuthenticationManager.constants.storage.tokenKey);
            if (!token) {
                // Cached Token not present, invoke the user provided callback function to fetch function
                this._triggerTokenFetch();
            }
            else {
                // check for cached token validity
                var expiresIn = this._getTokenExpiry(token);
                if (expiresIn < 300 && expiresIn > 0) {
                    // We are within a window for the token expiry,
                    // trigger a new token fetch, but still return the current token
                    this._triggerTokenFetch();
                }
                else if (expiresIn <= 0) {
                    // token renew failed and dont have a token.
                    this._saveItem(AuthenticationManager.constants.storage.tokenKey, "");
                    throw new Error(AuthenticationManager.constants.errors.tokenExpired);
                }
            }
            return token;
        }
        else if (this.options.authType === AuthenticationType.subscriptionKey) {
            return this.options.subscriptionKey;
        }
        else {
            return undefined;
        }
    };
    /**
     * Given a token, calculate the time left for token expiry
     * @param token
     * @internal
     */
    AuthenticationManager.prototype._getTokenExpiry = function (token) {
        var decodedToken = o(token);
        var expiresIn = decodedToken.exp;
        var now = this._getCurrentTime();
        return expiresIn - now > 0 ? expiresIn - now : -1;
    };
    /**
     * stores the token
     * @param token token fetched from the user's server endpoint
     * @internal
     */
    AuthenticationManager.prototype._storeToken = function (token) {
        // Store the value
        this._saveItem(AuthenticationManager.constants.storage.tokenKey, token);
        var tokenEvent = {
            map: this.map,
            type: AuthenticationManager.constants.events.tokenAcquired
        };
        this.map.events.invoke(AuthenticationManager.constants.events.tokenAcquired, tokenEvent);
    };
    /**
     * Saves the item to storage
     * @param key key/identifier
     * @param value value to be stored
     */
    AuthenticationManager.prototype._saveItem = function (key, value) {
        if (this._supportsLocalStorage()) {
            localStorage.setItem(key, value);
            return true;
        }
        else if (this._supportsSessionStorage()) {
            sessionStorage.setItem(key, value);
            return true;
        }
        else {
            this.fallbackStorage[key] = value;
            return true;
        }
    };
    /**
     * Gets an item saved in storage
     * @param key Key/Identifier to be used for lookup
     */
    AuthenticationManager.prototype._getItem = function (key) {
        if (this._supportsLocalStorage()) {
            return localStorage.getItem(key);
        }
        else if (this._supportsSessionStorage()) {
            return sessionStorage.getItem(key);
        }
        else if (key in this.fallbackStorage) {
            return this.fallbackStorage[key];
        }
        return null;
    };
    /**
     * Returns true if browser supports localStorage, false otherwise.
     * @ignore
     */
    AuthenticationManager.prototype._supportsLocalStorage = function () {
        try {
            if (!window.localStorage) {
                return false;
            } // Test availability
            window.localStorage.setItem(AuthenticationManager.constants.storage.testStorageKey, "A"); // Try write
            if (window.localStorage.getItem(AuthenticationManager.constants.storage.testStorageKey) !== "A") {
                return false;
            } // Test read/write
            window.localStorage.removeItem(AuthenticationManager.constants.storage.testStorageKey); // Try delete
            if (window.localStorage.getItem(AuthenticationManager.constants.storage.testStorageKey)) {
                return false;
            } // Test delete
            return true; // Success
        }
        catch (e) {
            return false;
        }
    };
    /**
     * Returns true if browser supports sessionStorage, false otherwise.
     * @ignore
     */
    AuthenticationManager.prototype._supportsSessionStorage = function () {
        try {
            if (!window.sessionStorage) {
                return false;
            } // Test availability
            window.sessionStorage.setItem(AuthenticationManager.constants.storage.testStorageKey, "A"); // Try write
            if (window.sessionStorage.getItem(AuthenticationManager.constants.storage.testStorageKey) !== "A") {
                return false;
            } // Test read/write
            window.sessionStorage.removeItem(AuthenticationManager.constants.storage.testStorageKey); // Try delete
            if (window.sessionStorage.getItem(AuthenticationManager.constants.storage.testStorageKey)) {
                return false;
            } // Test delete
            return true; // Success
        }
        catch (e) {
            return false;
        }
    };
    /**
     * Return the number of seconds since 1970/01/01
     * @ignore
     */
    AuthenticationManager.prototype._getCurrentTime = function () {
        return Math.round(new Date().getTime() / 1000.0);
    };
    AuthenticationManager.prototype.signRequest = function (request) {
        // Add the headers used for identifying a request is from the map control.
        request.headers = request.headers || {};
        request.headers[constants.sessionIdHeaderName] = this.sessionId;
        request.headers[constants.msOriginHeaderName] = constants.msOriginHeaderValue;
        request.headers[constants.mapAgentHeaderName] = "MapControl/".concat(version$3, " (Web)");
        var token = this.getToken();
        switch (this.options.authType) {
            case AuthenticationType.aad:
            case AuthenticationType.anonymous:
                request.headers[constants.msClientIdHeaderName] = this.options.clientId;
                request.headers[constants.authorizationHeaderName] = constants.authorizationTokenPrefix + token;
                break;
            case AuthenticationType.sas:
                request.headers[constants.authorizationHeaderName] = constants.jwtSasPrefix + token;
                break;
            case AuthenticationType.subscriptionKey:
                request.headers["subscription-key"] = token;
                break;
            default:
                throw new Error("An invalid authentication type was specified");
        }
        return request;
    };
    /**
     * Constants for internal use
     */
    AuthenticationManager.constants = {
        // Enable localStorage for IE, as sessionStorage does not work for localhost.
        preferredCacheLocation: "localStorage",
        storage: {
            tokenKey: "access.token.key",
            testStorageKey: "testStorage"
        },
        events: {
            tokenAcquired: "tokenacquired"
        },
        tokenExpiresIn: 3599,
        tokenRefreshClockSkew: 300,
        errors: {
            tokenExpired: "Token Expired, Try again"
        }
    };
    return AuthenticationManager;
}());

var __values$c = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A manager for the map control's controls.
 * Exposed through the controls property of the atlas.Map class.
 * Cannot be instantiated by the user.
 */
var ControlManager = /** @class */ (function () {
    /**
     * @internal
     */
    function ControlManager(map) {
        this.map = map;
        // Add containers for map controls
        this.controlContainer = document.createElement("div");
        this.controlContainer.classList.add("atlas-control-container");
        for (var controlPosition in ControlPosition) {
            if (ControlPosition.hasOwnProperty(controlPosition)) {
                var subcontrolContainer = document.createElement("div");
                subcontrolContainer.classList.add(ControlPosition[controlPosition]);
                subcontrolContainer.classList.add("subcontrol-container");
                this.controlContainer.appendChild(subcontrolContainer);
            }
        }
        this.map.getMapContainer().appendChild(this.controlContainer);
        this.controls = new Set();
    }
    /**
     * Add a control(s) to the map.
     * @param control The control to add.
     * @param options The options for the added control.
     */
    ControlManager.prototype.add = function (control, options) {
        var e_1, _a;
        if (Array.isArray(control)) {
            try {
                for (var control_1 = __values$c(control), control_1_1 = control_1.next(); !control_1_1.done; control_1_1 = control_1.next()) {
                    var c = control_1_1.value;
                    this._add(c, options);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (control_1_1 && !control_1_1.done && (_a = control_1.return)) _a.call(control_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            this._add(control, options);
        }
    };
    /**
     * Gets an array of all controls on the map
     */
    ControlManager.prototype.getControls = function () {
        return Array.from(this.controls);
    };
    /**
     * Remove a control(s) from the map.
     * @param control The control to remove.
     */
    ControlManager.prototype.remove = function (control) {
        var e_2, _a;
        if (Array.isArray(control)) {
            try {
                for (var control_2 = __values$c(control), control_2_1 = control_2.next(); !control_2_1.done; control_2_1 = control_2.next()) {
                    var c = control_2_1.value;
                    this._remove(c);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (control_2_1 && !control_2_1.done && (_a = control_2.return)) _a.call(control_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        else {
            this._remove(control);
        }
    };
    /**
     * Add a control from the map.
     * @internal
     */
    ControlManager.prototype._add = function (control, options) {
        this.controls.add(control);
        var controlOptions = new ControlOptions().merge(options);
        var controlHtml = control.onAdd(this.map, options);
        var subcontrolContainers = this.controlContainer.getElementsByClassName(controlOptions.position);
        if (subcontrolContainers.length > 0) {
            subcontrolContainers.item(0).appendChild(controlHtml);
        }
        else {
            throw new Error("Control position ".concat(controlOptions.position, " does not exist."));
        }
    };
    /**
     * Remove a control from the map.
     * @internal
     */
    ControlManager.prototype._remove = function (control) {
        control.onRemove();
        this.controls.delete(control);
    };
    return ControlManager;
}());

var __assign$3 = (window && window.__assign) || function () {
    __assign$3 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$3.apply(this, arguments);
};
/**
 * @private
 */
var MapCallbackHandler = /** @class */ (function () {
    function MapCallbackHandler(map) {
        // Dictionary keys represent the following: layer name -> event type -> user callback => [modified callback, once].
        this.callbacks = new Dictionary();
        this.map = map;
    }
    MapCallbackHandler.prototype.addCallback = function (eventType, layer, callback, legacy, once) {
        var _this = this;
        var modifiedCallback;
        // If using legacy callbacks provide a MapEventData object to the user's callback
        // Legacy callbacks cannot be added as once handles, so we don't need any logic for the once case.
        if (legacy) {
            modifiedCallback = function (data) {
                var position = (data.lngLat) ?
                    new Position(data.lngLat.lng, data.lngLat.lat) :
                    undefined;
                var coordinate = (data.point) ?
                    [data.point.x, data.point.y] :
                    undefined;
                var features = (data.features) ?
                    data.features.map(function (f) { return new Feature(f.geometry, f.properties, f.id); }) :
                    [];
                var mapEventData = {
                    type: data.type,
                    originalEvent: data.originalEvent,
                    position: position,
                    coordinate: coordinate,
                    features: features
                };
                callback(mapEventData);
            };
        }
        else {
            var lastOriginalEvent_1;
            switch (eventType) {
                case "data":
                case "sourcedata":
                case "styledata":
                    modifiedCallback = function (data) {
                        var mapEventData = __assign$3(__assign$3({ dataType: data.dataType }, (data.dataType === "source" && __assign$3(__assign$3(__assign$3({ isSourceLoaded: data.isSourceLoaded }, (data.sourceDataType && { sourceDataType: data.sourceDataType })), { source: _this.map.sources.getById(data.sourceId) }), (data.tile && {
                            tile: {
                                id: {
                                    x: data.tile.tileID.canonical.x,
                                    y: data.tile.tileID.canonical.y,
                                    z: data.tile.tileID.canonical.z
                                },
                                size: data.tile.tileSize,
                                state: data.tile.state
                            }
                        })))), { map: _this.map, type: data.type });
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(mapEventData);
                    };
                    break;
                case "error":
                    modifiedCallback = function (data) {
                        var mapEventData = {
                            error: data.error,
                            map: _this.map,
                            type: data.type
                        };
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(mapEventData);
                    };
                    break;
                case "touchstart":
                case "touchend":
                case "touchmove":
                case "touchcancel":
                    modifiedCallback = function (data) {
                        // Check if this callback was just called for the originating event.
                        // If so return to prevent multiple callback calls for layers which build multiple mapbox layers.
                        if (data.originalEvent) {
                            if (data.originalEvent !== lastOriginalEvent_1) {
                                lastOriginalEvent_1 = data.originalEvent;
                            }
                            else {
                                return;
                            }
                        }
                        var pixel = (data.point) ?
                            new Pixel(data.point.x, data.point.y) :
                            undefined;
                        var pixels = (data.points) ?
                            data.points.map(function (p) { return new Pixel(p.x, p.y); }) :
                            [];
                        var position = (data.lngLat) ?
                            new Position(data.lngLat.lng, data.lngLat.lat) :
                            undefined;
                        var positions = (data.lngLats) ?
                            data.lngLats.map(function (l) { return new Position(l.lng, l.lat); }) :
                            [];
                        var shapes = position ?
                            _this.map.layers.getRenderedShapes(new Point(position), layer ? [layer] : undefined) :
                            [];
                        var mapEventData = {
                            map: _this.map,
                            originalEvent: data.originalEvent,
                            pixel: pixel,
                            pixels: pixels,
                            position: position,
                            positions: positions,
                            shapes: shapes,
                            layerId: layer || undefined,
                            preventDefault: function () { return data.preventDefault(); },
                            type: data.type,
                        };
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(mapEventData);
                    };
                    break;
                case "mousedown":
                case "mouseup":
                case "mouseover":
                case "mousemove":
                case "click":
                case "dblclick":
                case "mouseout":
                case "mouseenter":
                case "mouseleave":
                case "contextmenu":
                    modifiedCallback = function (data) {
                        // Check if this callback was just called for the originating event.
                        // If so return to prevent multiple callback calls for layers which build multiple mapbox layers.
                        if (data.originalEvent) {
                            if (data.originalEvent !== lastOriginalEvent_1) {
                                lastOriginalEvent_1 = data.originalEvent;
                            }
                            else {
                                return;
                            }
                        }
                        var position = (data.lngLat) ?
                            new Position(data.lngLat.lng, data.lngLat.lat) :
                            undefined;
                        var pixel = (data.point) ?
                            new Pixel(data.point.x, data.point.y) :
                            undefined;
                        var shapes = position ?
                            _this.map.layers.getRenderedShapes(new Point(position), layer ? [layer] : undefined) :
                            [];
                        var mapEventData = {
                            map: _this.map,
                            originalEvent: data.originalEvent,
                            position: position,
                            pixel: pixel,
                            preventDefault: function () { return data.preventDefault(); },
                            shapes: shapes,
                            layerId: layer || undefined,
                            type: data.type
                        };
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(mapEventData);
                    };
                    break;
                case "styleimagemissing":
                    modifiedCallback = function (data) {
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(data.id);
                    };
                    break;
                case "wheel":
                    modifiedCallback = function (data) {
                        // Check if this callback was just called for the originating event.
                        // If so return to prevent multiple callback calls for layers which build multiple mapbox layers.
                        if (data.originalEvent) {
                            if (data.originalEvent !== lastOriginalEvent_1) {
                                lastOriginalEvent_1 = data.originalEvent;
                            }
                            else {
                                return;
                            }
                        }
                        var mapEventData = {
                            map: _this.map,
                            originalEvent: data.originalEvent,
                            preventDefault: function () { return data.preventDefault(); },
                            type: data.type,
                        };
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(mapEventData);
                    };
                    break;
                case "resize":
                    // The resize event is technically one of the default callback types.
                    // However, since users can specify custom eventData to add to the resize event
                    // we need to make sure to include that in our modified callback.
                    modifiedCallback = function (data) {
                        var mapEventData = {
                            map: _this.map,
                            type: data.type
                        };
                        // Add any extra properties to the modified callback data.
                        // Skip the "type" and "target" properties as these are
                        // replaced by the "type" and "map" properties above.
                        for (var prop in data) {
                            if (prop !== "type" && prop !== "target") {
                                mapEventData[prop] = data[prop];
                            }
                        }
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(mapEventData);
                    };
                    break;
                default:
                    modifiedCallback = function (data) {
                        var mapEventData = {
                            map: _this.map,
                            type: data.type
                        };
                        // Not every event will have an originalEvent property.
                        // Only add this properties to our modified callback's data if it will be defined.
                        if (data.originalEvent) {
                            mapEventData.originalEvent = data.originalEvent;
                        }
                        if (once) {
                            _this.map.events._removeListener(eventType, layer, callback);
                        }
                        callback(mapEventData);
                    };
                    break;
            }
        }
        // Add an empty dictionary for the specified layer if one doesn't already exist.
        if (!this.callbacks.has(layer)) {
            this.callbacks.set(layer, new Dictionary());
        }
        // Add an empty dictionary for the specified event type if one doesn't already exist.
        if (!this.callbacks.get(layer).has(eventType)) {
            this.callbacks.get(layer).set(eventType, new Map());
        }
        this.callbacks.get(layer).get(eventType).set(callback, [modifiedCallback, once]);
    };
    MapCallbackHandler.prototype.removeCallback = function (eventType, layer, callback) {
        if (this.callbacks.has(layer) &&
            this.callbacks.get(layer).has(eventType) &&
            this.callbacks.get(layer).get(eventType).has(callback)) {
            this.callbacks.get(layer).get(eventType).delete(callback);
        }
    };
    MapCallbackHandler.prototype.getModifiedCallback = function (eventType, layer, callback) {
        if (this.callbacks.has(layer) &&
            this.callbacks.get(layer).has(eventType) &&
            this.callbacks.get(layer).get(eventType).has(callback)) {
            return this.callbacks.get(layer).get(eventType).get(callback)[0];
        }
        return undefined;
    };
    MapCallbackHandler.prototype.getLayerCallbacks = function (layer) {
        if (this.callbacks.has(layer)) {
            return this.callbacks.get(layer);
        }
        return undefined;
    };
    MapCallbackHandler.prototype.getEventCallbacks = function (eventType, layer) {
        if (this.callbacks.has(layer)) {
            var layerCallbacks = this.callbacks.get(layer);
            if (layerCallbacks.has(eventType)) {
                return layerCallbacks.get(eventType);
            }
        }
        return undefined;
    };
    return MapCallbackHandler;
}());

var __values$b = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read$7 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
// Disable unified signatures linter rule so we can generate separate docs for function overloads.
// tslint:disable:unified-signatures
var MAP_CLIENT_EVENTS = ['maxzoomchanged', 'minzoomchanged', 'mapconfigurationchanged'];
/**
 * A manager for the map control's events.
 * Exposed through the events property of the atlas.Map class.
 * Cannot be instantiated by the user.
 */
var EventManager = /** @class */ (function () {
    /**
     * @internal
     */
    function EventManager(map) {
        this.map = map;
        this.mapCallbackHandler = new MapCallbackHandler(this.map);
    }
    EventManager.prototype.add = function (eventType, targetOrCallback, callback) {
        var e_1, _a;
        if (typeof targetOrCallback === "function") {
            this._addGlobalListener(eventType, targetOrCallback, false, false);
        }
        else {
            targetOrCallback = Array.isArray(targetOrCallback) ? targetOrCallback : [targetOrCallback];
            try {
                for (var targetOrCallback_1 = __values$b(targetOrCallback), targetOrCallback_1_1 = targetOrCallback_1.next(); !targetOrCallback_1_1.done; targetOrCallback_1_1 = targetOrCallback_1.next()) {
                    var target = targetOrCallback_1_1.value;
                    if (target instanceof Layer && Layer._isMBoxEvent(eventType)) {
                        this._addLayerListener(eventType, target, callback, false, false);
                    }
                    else {
                        target._addEventListener(eventType, callback, false);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (targetOrCallback_1_1 && !targetOrCallback_1_1.done && (_a = targetOrCallback_1.return)) _a.call(targetOrCallback_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    EventManager.prototype.addOnce = function (eventType, targetOrCallback, callback) {
        if (typeof targetOrCallback === "function") {
            this._addGlobalListener(eventType, targetOrCallback, false, true);
        }
        else if (targetOrCallback instanceof Layer && Layer._isMBoxEvent(eventType)) {
            this._addLayerListener(eventType, targetOrCallback, callback, false, true);
        }
        else {
            targetOrCallback._addEventListener(eventType, callback, true);
        }
    };
    EventManager.prototype._addLegacy = function (eventType, targetOrCallback, callback) {
        if (typeof targetOrCallback === "function") {
            this._addGlobalListener(eventType, targetOrCallback, true, false);
        }
        else {
            this._addLayerListener(eventType, targetOrCallback, callback, true, false);
        }
    };
    /**
     * Adds a listener to a single layer. Will add the event listeners to the layer's underlying Mapbox layers too.
     * @private
     */
    EventManager.prototype._addLayerListener = function (eventType, target, callback, legacy, once) {
        var e_2, _a, e_3, _b;
        var layerId = target instanceof Layer ? target.getId() : target;
        var layer = this.map.layers.getLayerById(layerId);
        var modifiedCallback = this.mapCallbackHandler.getModifiedCallback(eventType, layerId, callback);
        // If a callback already exists disable it so the new one can replace it.
        // Must disable it on every Mapbox layer our layer builds.
        if (modifiedCallback && layer) {
            try {
                for (var _c = __values$b(layer._getLayerIds()), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var id = _d.value;
                    this.map._getMap().off(eventType, id, modifiedCallback);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        // Get a new modified callback.
        this.mapCallbackHandler.addCallback(eventType, layerId, callback, legacy, once);
        // If the layer already exists on the map immediately add the callbacks.
        // Otherwise the callbacks will be added once the layer is added to the map.
        if (layer) {
            modifiedCallback = this.mapCallbackHandler.getModifiedCallback(eventType, layerId, callback);
            try {
                for (var _e = __values$b(layer._getLayerIds()), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var id = _f.value;
                    this.map._getMap().on(eventType, id, modifiedCallback);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
    };
    /**
     * Adds a listener to a single layer. Will add the event listeners to the layer's underlying Mapbox layers too.
     * @private
     */
    EventManager.prototype._addGlobalListener = function (eventType, callback, legacy, once) {
        // add our custom events emitted by Map client to the map (note: they don't utilize modifiedCallback) 
        if (MAP_CLIENT_EVENTS.includes(eventType)) {
            this.map._addEventListener(eventType, callback, once);
            return;
        }
        var oldModifiedCallback = this.mapCallbackHandler.getModifiedCallback(eventType, "", callback);
        // Get a new modified callback.
        this.mapCallbackHandler.addCallback(eventType, "", callback, legacy, once);
        var modifiedCallback = this.mapCallbackHandler.getModifiedCallback(eventType, "", callback);
        // Enable the new modified callback on the Mapbox map.
        if (eventType === "load" && this.map._isLoaded()) {
            // Manually execute the callback if the load event has already fired.
            // Use setTimeout to execute the callback async.
            // This is for consistency with the case where the load event hasn't already fired.
            // If the load event hasn't already fired the callback will also be executed async once it does fire.
            var loadData_1 = { type: "load", map: this.map };
            // tslint:disable-next-line: no-string-based-set-timeout
            setTimeout(function () { return modifiedCallback(loadData_1); });
        }
        else if (eventType === "ready") {
            // The ready event doesn't exist on the Mapbox map.
            // Don't enable the callback for the Mapbox map.
            if (this.map._isReady()) {
                // Manually execute the callback if the ready event has already fired.
                var readyData_1 = { type: "ready", map: this.map };
                // tslint:disable-next-line: no-string-based-set-timeout
                setTimeout(function () { return modifiedCallback(readyData_1); });
            }
        }
        else {
            // If a callback already exists disable it so the new one can replace it.
            if (oldModifiedCallback) {
                this.map._getMap().off(eventType, oldModifiedCallback);
            }
            this.map._getMap().on(eventType, modifiedCallback);
        }
    };
    EventManager.prototype.invoke = function (eventType, targetOrArgs, args) {
        // If args is undefined assume there is not target for the event.
        if (typeof args === "undefined") {
            // Empty string indicates the map global level.
            this._invokeListeners(eventType, "", targetOrArgs);
        }
        else {
            if (targetOrArgs instanceof Layer && Layer._isMBoxEvent(eventType)) {
                this._invokeListeners(eventType, targetOrArgs.getId(), args);
            }
            else if (targetOrArgs instanceof EventEmitter) {
                targetOrArgs._invokeEvent(eventType, args);
            }
            else {
                throw new Error("The invoke target is invalid.");
            }
        }
    };
    /**
     * Invokes all listeners for the given event and layer.
     * @param eventType The event type to invoke.
     * @param layer The layer to invoke the event for. Use an empty string for map global events.
     * @param args The data to pass to the listener callbacks.
     * @private
     */
    EventManager.prototype._invokeListeners = function (eventType, layer, args) {
        var _this = this;
        // copy event callbacks in order to prevent being mutated during iteration below (even callbacks added as part of other event callbacks) 
        var callbacks = new Dictionary(this.mapCallbackHandler.getEventCallbacks(eventType, layer));
        if (callbacks) {
            callbacks.forEach(function (_a, callback) {
                var _b = __read$7(_a, 2); _b[0]; var once = _b[1];
                // Invoking a listener this way circumvents the fire once logic in the modified callback.
                // So we check if the callback was added as a fire once and if so remove it here.
                if (once) {
                    _this._removeListener(eventType, layer, callback);
                }
                callback(args);
            });
        }
        else if (eventType === "error") {
            // If there are no user specified callback for the error event print to console.
            // tslint:disable-next-line:no-console
            console.error("error" in args ? args.error : args);
        }
    };
    EventManager.prototype.remove = function (eventType, targetOrCallback, callback) {
        var e_4, _a;
        if (typeof targetOrCallback === "function") {
            this._removeListener(eventType, "", targetOrCallback);
        }
        else {
            targetOrCallback = Array.isArray(targetOrCallback) ? targetOrCallback : [targetOrCallback];
            try {
                for (var targetOrCallback_2 = __values$b(targetOrCallback), targetOrCallback_2_1 = targetOrCallback_2.next(); !targetOrCallback_2_1.done; targetOrCallback_2_1 = targetOrCallback_2.next()) {
                    var target = targetOrCallback_2_1.value;
                    if (target instanceof Layer && Layer._isMBoxEvent(eventType)) {
                        this._removeListener(eventType, target, callback);
                    }
                    else {
                        target === null || target === void 0 ? void 0 : target._removeEventListener(eventType, callback);
                    }
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (targetOrCallback_2_1 && !targetOrCallback_2_1.done && (_a = targetOrCallback_2.return)) _a.call(targetOrCallback_2);
                }
                finally { if (e_4) throw e_4.error; }
            }
        }
    };
    EventManager.prototype._removeLegacy = function (eventType, targetOrCallback, callback) {
        if (typeof targetOrCallback === "function") {
            this._removeListener(eventType, "", targetOrCallback);
        }
        else {
            this._removeListener(eventType, targetOrCallback, callback);
        }
    };
    /**
     * Removes a listener from the map or a single layer.
     * Will remove the event listeners from the layer's underlying Mapbox layers too.
     * @internal
     */
    EventManager.prototype._removeListener = function (eventType, target, callback) {
        var e_5, _a;
        // remove our custom events emitted by Map client to the map (note: they don't utilize modifiedCallback)
        if (MAP_CLIENT_EVENTS.includes(eventType)) {
            this.map._removeEventListener(eventType, callback);
            return;
        }
        var layerId = target instanceof Layer ? target.getId() : target;
        var modifiedCallback = this.mapCallbackHandler.getModifiedCallback(eventType, layerId, callback);
        // If a callback already exists disable it so the new one can replace it.
        if (modifiedCallback) {
            // An empty layerId indicates the listener is being removed from the global map.
            if (layerId) {
                // If a callback already exists disable it so the new one can replace it.
                // Must disable it on every Mapbox layer our layer builds.
                var layer = this.map.layers.getLayerById(layerId);
                if (layer) {
                    try {
                        for (var _b = __values$b(layer._getLayerIds()), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var id = _c.value;
                            this.map._getMap().off(eventType, id, modifiedCallback);
                        }
                    }
                    catch (e_5_1) { e_5 = { error: e_5_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_5) throw e_5.error; }
                    }
                }
            }
            else {
                this.map._getMap().off(eventType, modifiedCallback);
            }
        }
        this.mapCallbackHandler.removeCallback(eventType, layerId, callback);
    };
    /**
     * Enables all the events associated with the specified layers.
     * Enables the events on the underlying Mapbox layers too.
     * @param layers The list of layers to enable the events associated with them.
     * @internal
     */
    EventManager.prototype._enableLayerEvents = function (layer) {
        var _this = this;
        var eventDict = this.mapCallbackHandler.getLayerCallbacks(layer.getId());
        // For every event callback added to the layer add the callback
        // to all Mapbox layers build by the specified layer.
        if (eventDict) {
            eventDict.forEach(function (callbackDict, eventType) {
                callbackDict.forEach(function (_a) {
                    var e_6, _b;
                    var _c = __read$7(_a, 1), modifiedCallback = _c[0];
                    try {
                        for (var _d = __values$b(layer._getLayerIds()), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var mbLayerId = _e.value;
                            _this.map._getMap().on(eventType, mbLayerId, modifiedCallback);
                        }
                    }
                    catch (e_6_1) { e_6 = { error: e_6_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                        }
                        finally { if (e_6) throw e_6.error; }
                    }
                });
            });
        }
    };
    /**
     * Disables all the events associated with the specified layers.
     * Disables the events on the underlying Mapbox layers too.
     * @param layers The list of layers to enable the events associated with them.
     * @internal
     */
    EventManager.prototype._disableLayerEvents = function (layer) {
        var _this = this;
        var eventDict = this.mapCallbackHandler.getLayerCallbacks(layer.getId());
        // For every event callback added to the layer add the callback
        // to all Mapbox layers build by the specified layer.
        if (eventDict) {
            eventDict.forEach(function (callbackDict, eventType) {
                callbackDict.forEach(function (_a) {
                    var e_7, _b;
                    var _c = __read$7(_a, 1), modifiedCallback = _c[0];
                    try {
                        for (var _d = __values$b(layer._getLayerIds()), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var mbLayerId = _e.value;
                            _this.map._getMap().off(eventType, mbLayerId, modifiedCallback);
                        }
                    }
                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                        }
                        finally { if (e_7) throw e_7.error; }
                    }
                });
            });
        }
    };
    return EventManager;
}());

var __values$a = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A manager for the map control's HTML markers.
 * Exposed through the markers property of the atlas.Map class.
 * Cannot be instantiated by the user.
 */
var HtmlMarkerManager = /** @class */ (function () {
    /**
     * Constructs the marker manager to be exposed only through the markers property of the Map class.
     * @param map The map whose markers are being managed by this.
     * @internal
     */
    function HtmlMarkerManager(map) {
        this.markers = new Set();
        this.map = map;
    }
    HtmlMarkerManager.prototype.add = function (element, position) {
        var e_1, _a;
        if (Array.isArray(element)) {
            try {
                for (var element_1 = __values$a(element), element_1_1 = element_1.next(); !element_1_1.done; element_1_1 = element_1.next()) {
                    var marker = element_1_1.value;
                    this._addMarker(marker, position);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (element_1_1 && !element_1_1.done && (_a = element_1.return)) _a.call(element_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            this._addMarker(element, position);
        }
    };
    /**
     * Adds a single marker.
     */
    HtmlMarkerManager.prototype._addMarker = function (marker, position) {
        marker._addToMap(this.map, position);
        this.markers.add(marker);
    };
    /**
     * Gets an array of all the markers on the map.
     */
    HtmlMarkerManager.prototype.getMarkers = function () {
        return Array.from(this.markers);
    };
    /**
     * Removes one or more HTML markers from the map.
     * @param marker A HtmlMarker instance, a string id of a marker's htmlContent, or an array of these.
     */
    HtmlMarkerManager.prototype.remove = function (marker) {
        var e_2, _a;
        if (Array.isArray(marker)) {
            try {
                for (var marker_1 = __values$a(marker), marker_1_1 = marker_1.next(); !marker_1_1.done; marker_1_1 = marker_1.next()) {
                    var singleMarker = marker_1_1.value;
                    this._removeMarker(singleMarker);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (marker_1_1 && !marker_1_1.done && (_a = marker_1.return)) _a.call(marker_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        else {
            this._removeMarker(marker);
        }
    };
    /**
     * Removes a single marker.
     */
    HtmlMarkerManager.prototype._removeMarker = function (marker) {
        var _this = this;
        if (marker instanceof HtmlMarker) {
            marker._removeFromMap();
            this.markers.delete(marker);
        }
        else {
            this.markers.forEach(function (singleMarker) {
                if (singleMarker._getId() === marker) {
                    singleMarker._removeFromMap();
                    _this.markers.delete(singleMarker);
                }
            });
        }
    };
    /**
     * Clears all markers.
     */
    HtmlMarkerManager.prototype.clear = function () {
        var _this = this;
        this.markers.forEach(function (singleMarker) {
            singleMarker._removeFromMap();
            _this.markers.delete(singleMarker);
        });
    };
    return HtmlMarkerManager;
}());

/**
 * A manager for the map control's image sprite.
 * Exposed through the imageSprite property of the atlas.Map class.
 * Cannot be instantiated by the user.
 */
var ImageSpriteManager = /** @class */ (function () {
    /**
     * Constructs the image sprite manager to be exposed only through the imageSprite property of the Map class.
     * @param map The Map object this will manage the image sprite for.
     * @internal
     */
    function ImageSpriteManager(map) {
        this.userImages = new Dictionary();
        this.imageLoadTimeout = 5000;
        this.map = map;
    }
    /**
     * Add an icon image to the map's image sprite for use with symbols and patterns.
     * @param id The image's id.
     * If the specified id matches the id of a previously added image the new image will be ignored.
     * @param icon The image to add to the map's sprite. Can be a data URI, inline SVG, or image URL.
     * @param meta Additional options that describe the image
     */
    ImageSpriteManager.prototype.add = function (id, icon, meta) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            // Take no action if the new image uses the id of a previously added image.
            if (_this.userImages.has(id)) {
                resolve();
                return;
            }
            if (icon instanceof HTMLImageElement || icon instanceof ImageData) {
                _this.map._getMap().addImage(id, icon, meta);
                _this.userImages.set(id, { image: icon, meta: meta });
                resolve();
            }
            else if (typeof icon === "string") {
                var imageSrc = void 0;
                // Assume an inline svg image string if icon doesn't start with "data:", but does include "<svg"
                if (/<svg/i.test(icon) && !(/^data:/i.test(icon))) {
                    imageSrc = "data:image/svg+xml;base64," + window.btoa(icon);
                }
                else {
                    imageSrc = icon;
                }
                // Use a timer to prevent the request from waiting forever.
                var timeoutId_1;
                var timedOut_1 = false;
                // Use the map to send the request so transformRequest is used.
                _this.map._sendRequest(imageSrc, "Image" /* ResourceType.Image */).then(function (response) {
                    return !timedOut_1 ? response.blob() : undefined;
                }).then(function (blob) {
                    if (!timedOut_1 && blob) {
                        clearTimeout(timeoutId_1);
                        var imageEle_1 = new Image();
                        // Wait for the blob to load into the element.
                        imageEle_1.onload = function () {
                            _this.map._getMap().addImage(id, imageEle_1, meta);
                            _this.userImages.set(id, { image: imageEle_1, meta: meta });
                            resolve();
                        };
                        // Reject if the blob failed to load in the element.
                        imageEle_1.onerror = imageEle_1.onabort = function () {
                            reject("Failed to load image into HTML element.");
                        };
                        // Convert the blob to a data url then load it into an Image element.
                        imageEle_1.src = URL.createObjectURL(blob);
                    }
                }).catch(function () {
                    if (!timedOut_1) {
                        clearTimeout(timeoutId_1);
                        reject("Failed to load image into HTML element.");
                    }
                });
                // Allow the image a fixed amount of time to load the image before aborting.
                // @ts-ignore
                timeoutId_1 = setTimeout(function () {
                    timedOut_1 = true;
                    reject("Failed to load image within specified timeout: ".concat(_this.imageLoadTimeout, " ms."));
                    // tslint:disable-next-line: no-string-based-set-timeout
                }, _this.imageLoadTimeout);
            }
        });
    };
    /**
     * Removes all images added by the user.
     */
    ImageSpriteManager.prototype.clear = function () {
        var _this = this;
        this.userImages.forEach(function (image, id) {
            _this.map._getMap().removeImage(id);
        });
        // Clear the list of user added image ids.
        this.userImages.clear();
    };
    /**
     * Gets a list of all the image ids that have been added to the maps image sprite.
     */
    ImageSpriteManager.prototype.getImageIds = function () {
        var ids = [];
        this.userImages.forEach(function (image, id) {
            ids.push(id);
        });
        return ids;
    };
    /**
     * Creates and adds an image to the maps image sprite. Provide the name of the built-in template to use, and a color to apply.
     * Optionally, specifiy a secondary color if the template supports one. A scale can also be specified.
     * This will allow the SVG to be scaled before it is converted into an image and thus look much better when scaled up.
     * Returns a promise.
     * Reference this in the Polygon or Symbol layer.
     * @param id  The image's id. If the specified id matches the id of a previously added image the new image will be ignored.
     * @param templateName The name of the template to use.
     * @param color The primary color value. Default: #1A73AA
     * @param secondaryColor A secondary color value. Default: white
     * @param scale Specifies how much to scale the template. For best results, scale the icon to the maximum size you want to display it on the map, then use the symbol layers icon size option to scale down if needed. This will reduce blurriness due to scaling. Default: 1
     */
    ImageSpriteManager.prototype.createFromTemplate = function (id, templateName, color, secondaryColor, scale) {
        color = color || "#1A73AA";
        secondaryColor = secondaryColor || "#fff";
        var t = getImageTemplate(templateName, scale);
        t = t.replace(/{color}/g, color).replace(/{secondaryColor}/g, secondaryColor).replace(/{text}/g, "");
        return this.add(id, t);
    };
    /**
     * Checks to see if an image is already loaded into the maps image sprite.
     * @param id The id to check the map's image sprite for.
     */
    ImageSpriteManager.prototype.hasImage = function (id) {
        return this.userImages.has(id);
    };
    /**
     * Removes an image from the map's image sprite.
     * @param id The id of the image to remove.
     */
    ImageSpriteManager.prototype.remove = function (id) {
        this.map._getMap().removeImage(id);
        this.userImages.delete(id);
    };
    /**
     * Restores the images the user has added to the Mapbox image sprite.
     * @internal
     */
    ImageSpriteManager.prototype._restoreImages = function () {
        var _this = this;
        // Check that all user added images still exist in the sprite after changing styles.
        // Currently Mapbox doesn't support diff operations for sprites.
        // Therefore changing a sprite will cause a full style rebuild.
        this.userImages.forEach(function (image, id) {
            if (!_this.map._getMap().hasImage(id)) {
                _this.map._getMap().addImage(id, image.image, image.meta);
            }
        });
    };
    return ImageSpriteManager;
}());

var __extends$e = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values$9 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * Used to represent the layer described by a resource files.
 * Serves primarily as a wrapper for multiple Mapbox layers in LayerManger.
 * @private
 */
var FundamentalMapLayer = /** @class */ (function (_super) {
    __extends$e(FundamentalMapLayer, _super);
    /**
     * Constructs a base layer used to represent the base, transit, and labels layers.
     * @param mbLayers The stylesheet used to define the style sources and style layers.
     * @param id The layer's id.
     */
    function FundamentalMapLayer(mbLayers, id) {
        var _this = _super.call(this, id) || this;
        _this.layers = mbLayers;
        return _this;
    }
    /**
     * Gets the options of the layer.
     */
    FundamentalMapLayer.prototype.getOptions = function () {
        return {};
    };
    /**
     * Sets the options of the layer.
     * @param options The new options of the layer.
     */
    FundamentalMapLayer.prototype.setOptions = function (options) { return; };
    /**
     * @internal
     */
    FundamentalMapLayer.prototype._buildLayers = function () {
        return this.layers;
    };
    /**
     * @internal
     */
    FundamentalMapLayer.prototype._getLayerIds = function () {
        return this.layers.map(function (l) { return l.id; });
    };
    /**
     * @internal
     */
    FundamentalMapLayer.prototype._getSourceIds = function () {
        var e_1, _a;
        var ids = new Set();
        try {
            for (var _b = __values$9(this.layers), _c = _b.next(); !_c.done; _c = _b.next()) {
                var layer = _c.value;
                if ('source' in layer && typeof layer.source === "string") {
                    // If the layer's source is just a string id use that.
                    ids.add(layer.source);
                }
                else if ('source' in layer && layer.source) {
                    // If the layer has an inline source definition the id will match the layer's.
                    ids.add(layer.id);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return ids;
    };
    FundamentalMapLayer.prototype._updateLayoutProperty = function (name, newValue, oldValue, subValue) {
        if (isEqual$1(newValue, oldValue))
            return;
        var map = this.map._getMap();
        this.layers.forEach(function (layer) {
            if (map.getLayer(layer.id)) {
                map.setLayoutProperty(layer.id, name, subValue || newValue);
            }
            else {
                console.warn("Could not update layout property ".concat(name, " for layer ").concat(layer.id, " to ").concat(subValue || newValue));
            }
        });
    };
    return FundamentalMapLayer;
}(Layer));

var __values$8 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read$6 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$6 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * A manager for the map control's layers.
 * Exposed through the layers property of the atlas.Map class.
 * Cannot be instantiated by the user.
 */
var LayerManager = /** @class */ (function () {
    /**
     * Constructs the layer manager to be exposed only through the layers property of the Map class.
     * @param map The map whose layers are being managed by this.
     * @internal
     */
    function LayerManager(map) {
        this.layerIndex = [];
        this.userLayers = [];
        this.map = map;
    }
    LayerManager.prototype.add = function (layer, before) {
        var e_1, _a;
        var beforeId = before instanceof Layer ?
            before.getId() :
            before;
        if (Array.isArray(layer)) {
            try {
                for (var layer_1 = __values$8(layer), layer_1_1 = layer_1.next(); !layer_1_1.done; layer_1_1 = layer_1.next()) {
                    var singleLayer = layer_1_1.value;
                    this._addLayer(singleLayer, beforeId);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (layer_1_1 && !layer_1_1.done && (_a = layer_1.return)) _a.call(layer_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            this._addLayer(layer, beforeId);
        }
    };
    /**
     * Adds a single layer to the map.
     * @private
     */
    LayerManager.prototype._addLayer = function (layer, before) {
        if (!this.map._isReady() && !(layer instanceof FundamentalMapLayer)) {
            throw new Error("The layer '".concat(layer.getId(), "' could not be added to the map because ") +
                "the map is not ready. Please use a ready event listener to guarantee " +
                "the map is ready before adding a layer to it.");
        }
        if (before !== layer.getId() && this.layerIndex.find(function (l) { return before === l.getId(); })) {
            if (this._getMapboxLayerExists(layer)) {
                // Replace the existing layer with the new one.
                // Place the new layer behind the specified before layer.
                var layerIndex = this.layerIndex.findIndex(function (l) { return l.getId() === layer.getId(); });
                var userLayerIndex = this.userLayers.findIndex(function (ul) { return ul.layer.getId() === layer.getId(); });
                this._removeMapboxLayers(layer);
                this._addMapboxLayers(layer, before);
                var tempLayer = this.layerIndex[layerIndex];
                if (tempLayer) {
                    this.map.events._disableLayerEvents(tempLayer);
                }
                this.map.events._enableLayerEvents(layer);
                this.layerIndex.splice(layerIndex, 1);
                var beforeIndex = this.layerIndex.findIndex(function (l) { return l.getId() === before; });
                this.layerIndex.splice(beforeIndex, 0, layer);
                if (!(layer instanceof FundamentalMapLayer)) {
                    this.userLayers[userLayerIndex] = { layer: layer, before: before };
                }
                if (tempLayer) {
                    tempLayer.onRemove();
                }
                layer.onAdd(this.map);
            }
            else {
                // Add the new layer behind the specified before layer.
                this._addMapboxLayers(layer, before);
                this.map.events._enableLayerEvents(layer);
                var beforeIndex = this.layerIndex.findIndex(function (l) { return l.getId() === before; });
                this.layerIndex.splice(beforeIndex, 0, layer);
                if (!(layer instanceof FundamentalMapLayer)) {
                    this.userLayers.push({ layer: layer, before: before });
                }
                layer.onAdd(this.map);
            }
        }
        else {
            var layerIndex = this.layerIndex.findIndex(function (l) { return l.getId() === layer.getId(); });
            var userLayerIndex = this.userLayers.findIndex(function (ul) { return ul.layer.getId() === layer.getId(); });
            if (layerIndex >= 0 && userLayerIndex >= 0) {
                // Replace the existing layer with the new one.
                var tempLayer = this.layerIndex[layerIndex];
                this._removeMapboxLayers(tempLayer);
                this._addMapboxLayers(layer, layerIndex + 1);
                this.map.events._disableLayerEvents(tempLayer);
                this.map.events._enableLayerEvents(layer);
                this.layerIndex[layerIndex] = layer;
                if (!(layer instanceof FundamentalMapLayer)) {
                    this.userLayers[userLayerIndex] = { layer: layer, before: undefined };
                }
                tempLayer.onRemove();
                layer.onAdd(this.map);
            }
            else {
                // Add the layer to the top of the z-order.
                this._addMapboxLayers(layer);
                this.map.events._enableLayerEvents(layer);
                this.layerIndex.push(layer);
                if (!(layer instanceof FundamentalMapLayer)) {
                    this.userLayers.push({ layer: layer, before: before });
                }
                layer.onAdd(this.map);
            }
        }
    };
    /**
     * Adds all the Mapbox layers built by an atlas layer to the Mapbox map.
     * @private
     */
    LayerManager.prototype._addMapboxLayers = function (layer, before) {
        var e_2, _a;
        // if the TileLayer's tile URL isn't defined yet, don't add the source and layer.
        if (layer instanceof TileLayer && !layer.getOptions().tileUrl) {
            return;
        }
        // FundamentalMapLayers are a special case because they are created indirectly by StyleManager when mapbox
        // loads a style by URL. When a FundamentalMapLayer is added to the LayerManager it is being done
        // so to reflect layers that are already loaded in mapbox so they do not need to be added a second 
        // time
        if (layer instanceof FundamentalMapLayer) {
            this.map.events._enableLayerEvents(layer);
            return;
        }
        // SourceBuildingLayers are a special case because they create their own source and manage it internally.
        // If adding a SourceBuildingLayer the source associated must also be added.
        if (layer instanceof SourceBuildingLayer) {
            this.map._getMap().addSource(layer._getSourceId(), layer._buildSource());
            // we also need the abstraction for those source building layers added to the map if it is not already there
            this.map.sources.setSourceState(layer._getSourceWrapper());
        }
        var mbBefore = this._getMapboxBefore(before);
        try {
            for (var _b = __values$8(layer._buildLayers()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var mbLayer = _c.value;
                this.map._getMap().addLayer(mbLayer, mbBefore);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this.map.events._enableLayerEvents(layer);
    };
    /**
     * Removes all the Mapbox layers built by an atlas layer from the Mapbox map.
     * @private
     */
    LayerManager.prototype._removeMapboxLayers = function (layer, force) {
        var e_3, _a;
        // FundamentalMapLayers are a special case because they are created indirectly by StyleManager when mapbox
        // loads a style by URL. When a FundamentalMapLayer is removed from the LayerManager it is being done
        // so to reflect layers that are already removed from mapbox so they do not need to be removed a second 
        // time
        if (layer instanceof FundamentalMapLayer && !force) {
            this.map.events._disableLayerEvents(layer);
            return;
        }
        try {
            for (var _b = __values$8(layer._getLayerIds()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var mbLayerId = _c.value;
                // Check if the layer does exist.
                if (this.map._getMap().getLayer(mbLayerId)) {
                    this.map._getMap().removeLayer(mbLayerId);
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.map.events._disableLayerEvents(layer);
        // SourceBuildingLayer are a special case because they create their own source and manage it internally.
        // If removing a SourceBuildingLayer the source associated must also be removed.
        if (layer instanceof SourceBuildingLayer &&
            this.map._getMap().getSource(layer._getSourceId())) {
            this.map._getMap().removeSource(layer._getSourceId());
        }
    };
    /**
     * Test if mapbox contains a mapbox.Layer defined in an atlas Layer.
     *
     * @param layer: Atlas layer or layerID to test.
     * @returns True if layer exists in mapbox.
     */
    LayerManager.prototype._getMapboxLayerExists = function (layer) {
        var _this = this;
        var found = false;
        if (typeof layer === "string") {
            layer = this.layerIndex.find(function (l) { return l.getId() === layer; });
            if (!layer) {
                return false;
            }
            return true;
        }
        layer._getLayerIds().forEach(function (mbLayerId) {
            var mbLayer = _this.map._getMap().getLayer(mbLayerId);
            if (mbLayer)
                found = true;
        });
        return found;
    };
    /**
     * Gets the ID of the Mapbox layer to add before given the id of the atlas before layer.
     * @private
     */
    LayerManager.prototype._getMapboxBefore = function (before) {
        var e_4, _a, e_5, _b;
        // If passed a string use it as the name of an atlas layer.
        if (typeof before === "string") {
            var beforeLayer = this.layerIndex.find(function (l) { return l.getId() === before; });
            // If the before layer exists iterate over the mapbox layers
            // it would build until a layer exists on the mapbox map.
            if (beforeLayer) {
                try {
                    for (var _c = __values$8(beforeLayer._getLayerIds()), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var layerId = _d.value;
                        if (this.map._getMap().getLayer(layerId)) {
                            return layerId;
                        }
                    }
                }
                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_4) throw e_4.error; }
                }
                // If none of the layers built by the specified before layer
                // actually exists on the map start checking the next layers.
                before = this.layerIndex.findIndex(function (l) { return l.getId() === before; }) + 1;
            }
            else {
                // If the before layer hasn't been added just return undefined.
                return undefined;
            }
        }
        // If passed a number assume it is the index of the before layer.
        // Or the string passed didn't lead to finding any existing mapbox layers.
        //
        // Iterate over all layers at or after the before index until one of
        // the mapbox layers built by an atlas layer exists in the mapbox map.
        for (var i = before; i < this.layerIndex.length; i++) {
            try {
                for (var _e = (e_5 = void 0, __values$8(this.layerIndex[i]._getLayerIds())), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var layerId = _f.value;
                    if (this.map._getMap().getLayer(layerId)) {
                        return layerId;
                    }
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        // If nothing was found just return undefined.
        return undefined;
    };
    /**
     * Removes all layers from the map.
     */
    LayerManager.prototype.clear = function () {
        for (var layerIndexIndex = this.layerIndex.length - 1; layerIndexIndex >= 0; layerIndexIndex--) {
            var tempLayer = this.layerIndex[layerIndexIndex];
            if (tempLayer) {
                this._removeMapboxLayers(tempLayer, true);
                this.layerIndex.splice(layerIndexIndex, 1);
                tempLayer.onRemove();
            }
        }
        this.userLayers = [];
    };
    /**
     * Retrieves a layer with the specified id.
     * @param id The id of the layer to retrieve.
     */
    LayerManager.prototype.getLayerById = function (id) {
        var result = this.layerIndex.find(function (l) { return l.getId() === id; });
        if (result)
            return result;
        return undefined;
    };
    /**
     * Retrieves all layers that have been added to the map.
     */
    LayerManager.prototype.getLayers = function () {
        return this.layerIndex.slice(0);
    };
    /**
     * Returns a set of all the source IDs that any layers depend on.
     * @internal
     */
    LayerManager.prototype._getSourceIds = function () {
        var e_6, _a;
        var ids = new Set();
        try {
            for (var _b = __values$8(this.layerIndex), _c = _b.next(); !_c.done; _c = _b.next()) {
                var layer = _c.value;
                layer._getSourceIds().forEach(function (id) { return ids.add(id); });
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_6) throw e_6.error; }
        }
        return ids;
    };
    /**
     *
     * @returns Returns a set of all layers added through this SDK.
     * @internal
     */
    LayerManager.prototype._getUserLayers = function () {
        return Array.from(this.userLayers);
    };
    /**
     * Moves a layer to a different z-position.
     * @param layer The layer or id of the layer to move.
     * @param before Optionally specify to move the layer before this.
     */
    LayerManager.prototype.move = function (layer, before) {
        var layerId = layer instanceof Layer ? layer.getId() : layer;
        var beforeId = before instanceof Layer ? before.getId() : before;
        if (!this.layerIndex.find(function (l) { return l.getId() === layerId; })) {
            throw new Error("The layer '".concat(layerId, "' has not been added to the map and cannot be moved."));
        }
        var layerIndex = this.layerIndex.findIndex(function (l) { return l.getId() === layerId; });
        this._moveMapboxLayers(this.layerIndex[layerIndex], beforeId);
        layer = this.layerIndex[layerIndex];
        this.layerIndex.splice(layerIndex, 1);
        var beforeIndex = this.layerIndex.findIndex(function (l) { return l.getId() === beforeId; });
        if (beforeIndex > -1) {
            this.layerIndex.splice(beforeIndex, 0, layer);
        }
        else {
            this.layerIndex.push(layer);
        }
        // Update before property of the user layer
        var userLayer = this.userLayers.find(function (ul) { return ul.layer.getId() === layerId; });
        if (userLayer) {
            userLayer.before = beforeId;
        }
    };
    LayerManager.prototype._moveMapboxLayers = function (layer, before) {
        var e_7, _a;
        var mbBefore = this._getMapboxBefore(before);
        try {
            for (var _b = __values$8(layer._getLayerIds()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var mbLayerId = _c.value;
                this.map._getMap().moveLayer(mbLayerId, mbBefore);
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_7) throw e_7.error; }
        }
    };
    /**
        * Retrieve all Shapes and GeoJSON features that are visible on the map that are in a DataSource or VectorTileSource.
        * Shape objects are editable, while Feature objects are not editable and either reside in a VectorTileSource or represent a cluster point.
        * Clusters have the following properties:<br />
        * `cluster`: `boolean` - Indicates that the point is a cluster.
        * This will be set to true if Point object represents a cluster.
        * All other point objects are unlikely to have this value unless
        * a property with this same name was added to the Point property data from your app.<br />
        * `cluster_id`: `string` - A unique id for the cluster.<br />
        * `point_count`: `number` - The number of points inside the cluster.<br />
        * `point_count_abbreviated`: `string` - An abbreviated string version of the point count. i.e. `"10K"`<br />
        * Features/Shapes that are not visible or who's layer zoom range does not include the current zoom level will not be returned.
        * Symbol features/Shapes that have been hidden due to text or icon collisions are not included.
        * Features/Shapes from all other layers are included even if they have no contribution to the map rendering, e.g. alpha set to zero.
        * The topmost rendered features/shapes appears first in the returned array and subsequent features are sorted in descending z-order.
        * @param geometry A Position, Point, or BoundingBox that returned features must intersect. If not specified the whole visible world is used.
        * @param layers An array of layers or their ids to limit the query to.
        * @param filter A expression to filter the returned features by.
        */
    LayerManager.prototype.getRenderedShapes = function (geometry, layers, filter) {
        var e_8, _a;
        var _this = this;
        // If no geometry was provided use a bounding box covering the whole world.
        if (!geometry) {
            geometry = [-180, -85.0511, 180, 85.0511];
        }
        // Mapbox's queryRenderedFeatures uses screen coordinates not GeoJSON positions.
        // Here we convert the input bounding box or point into screen coordinates.
        var scope;
        if (Array.isArray(geometry)) {
            if (geometry.length === 4 || geometry.length === 6) {
                // BoundingBox has length of 4 or 6: [west, south, east, north] or [west, south, elevation1, east, north, elevation2]
                scope = this.map.positionsToPixels([
                    BoundingBox.getSouthWest(geometry),
                    BoundingBox.getNorthEast(geometry)
                ]);
            }
            else if (geometry.length === 2 || geometry.length === 3) {
                // Position has length of 2, or 3: [lon, lat] or [lon, lat, elv]
                scope = this.map.positionsToPixels([geometry])[0];
            }
        }
        else {
            scope = this.map.positionsToPixels([geometry.coordinates])[0];
        }
        // Create an array of all the mapbox layer ids that make up the layers specified by the user.
        // Skip any mapbox layer ids that don't currently exist in the mapbox style.
        var layerIds;
        if (layers) {
            layers = Array.isArray(layers) ? layers : [layers];
            layerIds = [];
            var _loop_1 = function (layer) {
                var layerId = layer instanceof Layer ? layer.getId() : layer;
                // If a specified layer hasn't been added to the map throw an error.
                var index = this_1.layerIndex.findIndex(function (l) { return l.getId() === layerId; });
                if (index > -1) {
                    layerIds.push.apply(layerIds, __spreadArray$6([], __read$6(this_1.layerIndex[index]._getLayerIds()
                        .filter(function (id) { return !!_this.map._getMap().getLayer(id); })), false));
                }
                else {
                    throw new Error("The layer '".concat(layerId, "' has not been added to the map ") +
                        "and its rendered features cannot be retrieved.");
                }
            };
            var this_1 = this;
            try {
                for (var layers_1 = __values$8(layers), layers_1_1 = layers_1.next(); !layers_1_1.done; layers_1_1 = layers_1.next()) {
                    var layer = layers_1_1.value;
                    _loop_1(layer);
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (layers_1_1 && !layers_1_1.done && (_a = layers_1.return)) _a.call(layers_1);
                }
                finally { if (e_8) throw e_8.error; }
            }
        }
        // Use queryRenderedFeatures to get a basic list of the features
        // within the scope and belonging to the specified layers.
        var features = this.map._getMap().queryRenderedFeatures(scope, {
            layers: layerIds,
            filter: filter
        });
        // Any features belonging to a DataSource will be mapped to the Shapes that wrap them.
        return this.map.sources._mapFeaturesToShapes(features);
    };
    LayerManager.prototype.remove = function (layer) {
        var e_9, _a;
        if (Array.isArray(layer)) {
            try {
                for (var layer_2 = __values$8(layer), layer_2_1 = layer_2.next(); !layer_2_1.done; layer_2_1 = layer_2.next()) {
                    var singleLayer = layer_2_1.value;
                    this._removeLayer(singleLayer);
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (layer_2_1 && !layer_2_1.done && (_a = layer_2.return)) _a.call(layer_2);
                }
                finally { if (e_9) throw e_9.error; }
            }
        }
        else {
            this._removeLayer(layer);
        }
    };
    /**
     * Removes a single layer from the map.
     * @private
     */
    LayerManager.prototype._removeLayer = function (layer) {
        var layerId = layer instanceof Layer ? layer.getId() : layer;
        var layerIndex = this.layerIndex.findIndex(function (l) { return l.getId() === layerId; });
        if (layerIndex == -1) {
            throw new Error("The layer '".concat(layerId, "' has not been added to the map and cannot be removed."));
        }
        var tempLayer = this.layerIndex[layerIndex];
        this._removeMapboxLayers(tempLayer);
        this.layerIndex.splice(layerIndex, 1);
        var userLayerIndex = this.userLayers.findIndex(function (ul) { return ul.layer.getId() === layerId; });
        if (userLayerIndex != -1) {
            this.userLayers.splice(userLayerIndex, 1);
        }
        if (layer instanceof SourceBuildingLayer) {
            this.map.sources.unsetSourceState(layer._getSourceId());
        }
        tempLayer.onRemove();
    };
    return LayerManager;
}());

var __values$7 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A manager for the map control's popups.
 * Exposed through the `popups` property of the `atlas.Map` class.
 * Cannot be instantiated by the user.
 */
var PopupManager = /** @class */ (function () {
    /**
     * Constructs the popup manager to be exposed only through the `popups` property of the `Map` class.
     * @param map The map whose popups are being managed by this.
     * @internal
     */
    function PopupManager(map) {
        var _this = this;
        /**
         * Listens for mouse or touch movement when dragging popups.
         */
        this._onDrag = function (event) {
            // Determine the new x and y from the event data.
            var x;
            var y;
            if (event.type === "mousemove") {
                event = event;
                x = event.clientX;
                y = event.clientY;
            }
            else if (event.type === "touchmove") {
                event = event;
                x = event.touches[0].clientX;
                y = event.touches[0].clientY;
            }
            _this.draggedPopups.forEach(function (popup) {
                popup._dragToPixel([x, y]);
            });
        };
        /**
         * Listens for mouse up or touch end to indicate popups aren't being dragged anymore.
         */
        this._onUp = function () {
            // Remove the listeners since no popups are being dragged anymore.
            _this.map.getMapContainer().removeEventListener("mousemove", _this._onDrag);
            _this.map.getMapContainer().removeEventListener("touchmove", _this._onDrag);
            _this.map.getMapContainer().removeEventListener("mouseup", _this._onUp);
            _this.map.getMapContainer().removeEventListener("touchend", _this._onUp);
            _this.draggedPopups.forEach(function (popup) {
                _this.draggedPopups.delete(popup);
                popup._onUp();
            });
        };
        this.map = map;
        this.popups = new Set();
        this.draggedPopups = new Set();
    }
    /**
     * Adds a popup to the map
     * @param popup The popup(s) to add.
     */
    PopupManager.prototype.add = function (popup) {
        var e_1, _a;
        popup = Array.isArray(popup) ? popup : [popup];
        try {
            for (var popup_1 = __values$7(popup), popup_1_1 = popup_1.next(); !popup_1_1.done; popup_1_1 = popup_1.next()) {
                var p = popup_1_1.value;
                if (!this.popups.has(p)) {
                    this.popups.add(p);
                    p.attach(this.map);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (popup_1_1 && !popup_1_1.done && (_a = popup_1.return)) _a.call(popup_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * Removes all popups from the map.
     */
    PopupManager.prototype.clear = function () {
        var _this = this;
        this.popups.forEach(function (popup) {
            _this.popups.delete(popup);
            popup.remove();
        });
    };
    /**
     * Removes a popup from the map
     * @param popup The popup(s) to remove.
     */
    PopupManager.prototype.remove = function (popup) {
        var e_2, _a;
        popup = Array.isArray(popup) ? popup : [popup];
        try {
            for (var popup_2 = __values$7(popup), popup_2_1 = popup_2.next(); !popup_2_1.done; popup_2_1 = popup_2.next()) {
                var p = popup_2_1.value;
                if (this.popups.has(p)) {
                    this.popups.delete(p);
                    p.remove();
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (popup_2_1 && !popup_2_1.done && (_a = popup_2.return)) _a.call(popup_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    /**
     * Returns the popups currently attached to the map.
     */
    PopupManager.prototype.getPopups = function () {
        return Array.from(this.popups);
    };
    /**
     * Returns the div element that should contain all the popup containers.
     * Creates it if it doesn't already exist.
     * @internal
     */
    PopupManager.prototype._getCollectionDiv = function () {
        var collection = this.map.getMapContainer()
            .querySelector(".".concat(PopupManager.Css.collection));
        if (!collection) {
            // If the collection div doesn't exist create it.
            collection = document.createElement("div");
            collection.classList.add(PopupManager.Css.collection);
            collection.setAttribute("aria-label", "Map Information");
            this.map.getMapContainer().appendChild(collection);
        }
        return collection;
    };
    /**
     * Adds a popup to the set of popups actively being dragged.
     * @internal
     */
    PopupManager.prototype._addDraggedPopup = function (popup) {
        // If no popups are being dragged yet add the listeners.
        if (this.draggedPopups.size === 0) {
            this.map.getMapContainer().addEventListener("mousemove", this._onDrag);
            this.map.getMapContainer().addEventListener("touchmove", this._onDrag);
            this.map.getMapContainer().addEventListener("mouseup", this._onUp);
            this.map.getMapContainer().addEventListener("touchend", this._onUp);
        }
        // Track the popups being dragged for the mousemove events.
        this.draggedPopups.add(popup);
    };
    PopupManager.Css = {
        collection: "popup-collection-container"
    };
    return PopupManager;
}());

var __values$6 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * A manager for the map control's sources.
 * Exposed through the sources property of the atlas.Map class.
 * Cannot be instantiated by the user.
 */
var SourceManager = /** @class */ (function () {
    /**
     * @internal
     */
    function SourceManager(map) {
        this.map = map;
        this.sources = new Dictionary();
    }
    SourceManager.prototype.add = function (source, update) {
        var e_1, _a;
        if (update === void 0) { update = true; }
        if (Array.isArray(source)) {
            try {
                for (var source_1 = __values$6(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
                    var singleSource = source_1_1.value;
                    this._addSource(singleSource, update);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            this._addSource(source, update);
        }
    };
    /**
     * Returns all rendered shape features in a source that match a specified filter. If the source is a vector tile source, a source layer name needs to be specified.
     * @param source source to be queried
     * @param filter a filter to limit the query
     * @param sourceLayer the layer where shapes and features are matched
     */
    SourceManager.prototype.getRenderedShapes = function (source, filter, sourceLayer) {
        var sourceID = typeof source === "string" ? source : source.getId();
        var features = this.map._getMap().querySourceFeatures(sourceID, { sourceLayer: sourceLayer, filter: filter });
        return this.map.sources._mapFeaturesToShapes(features, true, this.sources.get(sourceID));
    };
    /**
     * Gets the state of a feature
     * @param feature the ID of the feature
     * @param source the ID of the source
     * @param sourceLayer the ID of the layer
     */
    SourceManager.prototype.getFeatureState = function (feature, source, sourceLayer) {
        var featureId;
        if (typeof feature === "string") {
            featureId = feature;
        }
        else {
            featureId = feature instanceof Shape ? feature.getId() : feature.id;
        }
        var featureSource = typeof source === "string" ? source : source.getId();
        return this.map._getMap().getFeatureState({ id: featureId, source: featureSource, sourceLayer: sourceLayer });
    };
    /**
     * Removes the state or a single key value of the state of a feature.
     * @param feature the ID of the feature
     * @param source the ID of the source
     * @param sourceLayer the ID of the layer
     * @param key the key in the feature state to update
     */
    SourceManager.prototype.removeFeatureState = function (feature, source, sourceLayer, key) {
        var featureId;
        if (typeof feature === "string") {
            featureId = feature;
        }
        else {
            featureId = feature instanceof Shape ? feature.getId() : feature.id;
        }
        var featureSource = typeof source === "string" ? source : source.getId();
        this.map._getMap().removeFeatureState({ id: featureId, source: featureSource, sourceLayer: sourceLayer }, key);
    };
    /**
     * Sets the state of the feature by passing in a key value pair object.
     * @param feature the ID of the feature
     * @param source the ID of the source
     * @param sourceLayer the ID of the layer
     * @param key the key in the feature state to update
     */
    SourceManager.prototype.setFeatureState = function (feature, source, state, sourceLayer) {
        var featureId;
        if (typeof feature === "string") {
            featureId = feature;
        }
        else {
            featureId = feature instanceof Shape ? feature.getId() : feature.id;
        }
        var featureSource = typeof source === "string" ? source : source.getId();
        this.map._getMap().setFeatureState({ id: featureId, source: featureSource, sourceLayer: sourceLayer }, state);
    };
    /**
     * @internal
     */
    SourceManager.prototype._buildSources = function () {
        var ret = {};
        this.sources.forEach(function (source) {
            ret[source.getId()] = source._buildSource();
        });
        return ret;
    };
    /**
     * Removes all sources from the map.
     */
    SourceManager.prototype.clear = function () {
        var _this = this;
        this.sources.forEach(function (source) {
            _this.remove(source);
        });
    };
    /**
     * Retrieves a source with the specified id.
     * @param id
     */
    SourceManager.prototype.getById = function (id) {
        return this.sources.get(id);
    };
    /**
     * Retrieves all sources that have been added to the map.
     */
    SourceManager.prototype.getSources = function () {
        return Array.from(this.sources.values());
    };
    /**
     * Returns a boolean indicating if the source is loaded or not.
     * @param source The id of a source or a Source object.
     */
    SourceManager.prototype.isSourceLoaded = function (source) {
        var id = source instanceof Source ? source.getId() : source;
        return this.map._getMap().isSourceLoaded(id);
    };
    SourceManager.prototype.remove = function (source, update) {
        var e_2, _a;
        if (update === void 0) { update = true; }
        if (Array.isArray(source)) {
            try {
                for (var source_2 = __values$6(source), source_2_1 = source_2.next(); !source_2_1.done; source_2_1 = source_2.next()) {
                    var singleSource = source_2_1.value;
                    this._removeSource(singleSource, update);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (source_2_1 && !source_2_1.done && (_a = source_2.return)) _a.call(source_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        else {
            this._removeSource(source, update);
        }
    };
    /**
     * @internal
     */
    SourceManager.prototype.setSourceState = function (newSource, shouldInvokeAddEvent) {
        if (shouldInvokeAddEvent === void 0) { shouldInvokeAddEvent = true; }
        this.sources.set(newSource.getId(), newSource);
        newSource._setMap(this.map, shouldInvokeAddEvent);
    };
    /**
     * @internal
     */
    SourceManager.prototype.unsetSourceState = function (id) {
        if (this.sources.has(id)) {
            this.sources.get(id)._setMap(null);
            this.sources.delete(id);
        }
    };
    SourceManager.prototype._removeSource = function (source, update) {
        var id = source instanceof Source ? source.getId() : source;
        if (this.sources.has(id)) {
            if (this.map._getMap().getSource(id) && update) {
                this.map._getMap().removeSource(id);
            }
            if (!this.map._getMap().getSource(id) || !update) {
                this.unsetSourceState(id);
            }
            else {
                throw new Error("One or more layers have a dependency on the source '".concat(id, "'"));
            }
            return;
        }
        throw new Error("'".concat(id, "' is not added to the map"));
    };
    SourceManager.prototype._addSource = function (source, update) {
        // If adding a source that shares an id with an existing source throw an error unless update is false.
        // Update being false assumes that a call to map.setStyle(...) will occurs soon.
        if (this.sources.has(source.getId())) {
            if (update) {
                throw new Error("'".concat(source.getId(), "' is already added to the map"));
            }
            else {
                this.unsetSourceState(source.getId());
            }
        }
        if (update) {
            // Check if the map is ready before adding any sources.
            if (!this.map._isReady()) {
                throw new Error("The source '".concat(source.getId(), "' could not be added to the map because ") +
                    "the map is not ready. Please use a ready event listener to guarantee " +
                    "the map is ready before adding a source to it.");
            }
            this.map._getMap().addSource(source.getId(), source._buildSource());
        }
        this.setSourceState(source);
    };
    /**
     * Converts an array of features as returned by one of Mapbox's query*Features(...) function
     * to an array of our features or shapes if one is currently wrapping the feature.
     * @internal
     */
    SourceManager.prototype._mapFeaturesToShapes = function (features, shapesOnly, dataSource) {
        var e_3, _a;
        var shapesOrFeatures = [];
        try {
            for (var features_1 = __values$6(features), features_1_1 = features_1.next(); !features_1_1.done; features_1_1 = features_1.next()) {
                var feature = features_1_1.value;
                if ((dataSource || typeof feature["source"] === "string") &&
                    typeof feature.properties[Shape._shapeIdPropName] === "string") {
                    var source = dataSource || this.sources.get(feature["source"]);
                    if (source instanceof DataSource) {
                        var shape = source.getShapeById(feature.properties[Shape._shapeIdPropName]);
                        if (shape instanceof Shape) {
                            shapesOrFeatures.push(shape);
                            continue;
                        }
                    }
                }
                if (!shapesOnly) {
                    // If the feature couldn't be matched to a shape in a DataSource
                    // just return the feature data as provided by mapbox.
                    shapesOrFeatures.push(feature);
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (features_1_1 && !features_1_1.done && (_a = features_1.return)) _a.call(features_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return shapesOrFeatures;
    };
    /**
     * Sync SourceManager with mapbox sources.
     * This function is responsible for creating wrappers for mapbox sources
     * and setting the approperiate sourceManager state with them
     * @internal
     */
    SourceManager.prototype._syncSources = function (sources) {
        var _this = this;
        if (!sources) {
            console.warn('syncSources called with no style sources which is unexpected.');
            return;
        }
        // 1. add / update the source wrappers
        Object.keys(sources)
            .map(function (sourceId) {
            var sourceToAdd = sources[sourceId];
            var newSource;
            switch (sourceToAdd.type) {
                case 'vector':
                case 'raster':
                case 'raster-dem': {
                    newSource = new FundamentalMapSource(sourceId, {
                        name: sourceId,
                        tiles: sourceToAdd.tiles,
                        type: sourceToAdd.type,
                        url: sourceToAdd.url,
                        tileSize: 'tileSize' in sourceToAdd ? sourceToAdd.tileSize : undefined
                    });
                    break;
                }
                case 'canvas': {
                    newSource = new CanvasSource(sourceId, sourceToAdd);
                    break;
                }
                case 'geojson': {
                    var dataSource = new DataSource(sourceId, {
                        maxZoom: sourceToAdd.maxzoom,
                        cluster: sourceToAdd.cluster,
                        clusterRadius: sourceToAdd.clusterRadius,
                        tolerance: sourceToAdd.tolerance,
                        lineMetrics: sourceToAdd.lineMetrics,
                        clusterProperties: sourceToAdd.clusterProperties,
                        buffer: sourceToAdd.buffer,
                        clusterMinPoints: sourceToAdd.clusterMinPoints,
                        generateId: sourceToAdd.generateId,
                        promoteId: sourceToAdd.promoteId,
                        filter: sourceToAdd.filter,
                        // attribution?: sourceToAdd.attribution
                    });
                    if (typeof sourceToAdd.data !== 'string' && sourceToAdd.data !== undefined) {
                        dataSource._addNoUpdate(sourceToAdd.data);
                    }
                    newSource = dataSource;
                    break;
                }
                case 'image': {
                    newSource = new ImageSource(sourceId, sourceToAdd);
                    break;
                }
                case 'video': {
                    newSource = new VideoSource(sourceId, sourceToAdd);
                    break;
                }
                default: {
                    newSource = new UnknownSource(sourceId, sourceToAdd);
                }
            }
            return newSource;
        }).forEach(function (newSource) {
            // use deep equality of underlying maplibre sources to determine if the source has been updated or overriden on style update
            var existing = _this.sources.get(newSource.getId());
            var isUpdate = existing && newSource._isDeepEqual(existing);
            if (!isUpdate && existing) {
                _this.unsetSourceState(existing.getId());
            }
            _this.setSourceState(newSource, !isUpdate);
        });
        // 2. remove the source wrappers that are not in the style
        Array.from(this.sources.keys())
            .filter(function (sourceId) { return !(sourceId in sources); })
            .forEach(function (sourceId) { return _this.unsetSourceState(sourceId); });
    };
    return SourceManager;
}());

var __extends$d = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for animating changes to the map control's camera.
 */
var AnimationOptions = /** @class */ (function (_super) {
    __extends$d(AnimationOptions, _super);
    function AnimationOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The duration of the animation in milliseconds.
         * Default `1000`.
         * @default 1000
         */
        _this.duration = 1000;
        /**
         * The type of animation.<br />
         * `"jump"` is an immediate change.<br />
         * `"ease"` is a gradual change of the camera's settings.<br />
         * `"fly"` is a gradual change of the camera's settings following an arc resembling flight.<br />
         * Default `"jump"`.
         * @default "jump"
         */
        // tslint:disable-next-line:no-reserved-keywords
        _this.type = "jump";
        return _this;
    }
    return AnimationOptions;
}(Options));

var __extends$c = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Represent the amount of padding in pixels to add to the side of a BoundingBox when setting the camera of a map.
 */
var Padding = /** @class */ (function (_super) {
    __extends$c(Padding, _super);
    function Padding() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Amount of padding in pixels to add to the bottom.
         * default `0`
         * @default 0
         */
        _this.bottom = 0;
        /**
         * Amount of padding in pixels to add to the left.
         * default `0`
         * @default 0
         */
        _this.left = 0;
        /**
         * Amount of padding in pixels to add to the right.
         * default `0`
         * @default 0
         */
        _this.right = 0;
        /**
         * Amount of padding in pixels to add to the top.
         * default `0`
         * @default 0
         */
        _this.top = 0;
        return _this;
    }
    return Padding;
}(Options));

var __extends$b = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values$5 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read$5 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$5 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * The options for setting the bounds of the map control's camera.
 */
var CameraBoundsOptions = /** @class */ (function (_super) {
    __extends$b(CameraBoundsOptions, _super);
    function CameraBoundsOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The bounds of the map control's camera.
         * Default `[-180, -89, 180, 90]`.
         * @default [-180, -89, 180, 90]
         */
        _this.bounds = [-180, -89, 180, 90];
        /**
         * A bounding box in which to constrain the viewable map area to.
         * Users won't be able to pan the center of the map outside of this bounding box.
         * Set maxBounds to null or undefined to remove maxBounds
         * Default `undefined`.
         * @default undefined
         */
        _this.maxBounds = undefined;
        /**
         * The maximum zoom level to allow when the map view transitions to the specified bounds.
         * Default `20`.
         * @default 20
         */
        _this.maxZoom = 20;
        /**
         * An offset of the center of the given bounds relative to the map's center, measured in pixels.
         * Default `[0, 0]`.
         * @default [0, 0]
         */
        _this.offset = new Pixel(0, 0);
        /**
         * The amount of padding in pixels to add to the given bounds.
         * Default `{top: 0, bottom: 0, left: 0, right: 0}`.
         * @default {top: 0, bottom: 0, left: 0, right: 0}
         */
        _this.padding = new Padding();
        return _this;
    }
    /**
     * overwriting merge to accept one value for padding
     */
    CameraBoundsOptions.prototype.merge = function () {
        var e_1, _a;
        var valuesList = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            valuesList[_i] = arguments[_i];
        }
        try {
            for (var valuesList_1 = __values$5(valuesList), valuesList_1_1 = valuesList_1.next(); !valuesList_1_1.done; valuesList_1_1 = valuesList_1.next()) {
                var value = valuesList_1_1.value;
                if (value && typeof value.padding === "number") {
                    value.padding = {
                        top: value.padding,
                        bottom: value.padding,
                        left: value.padding,
                        right: value.padding
                    };
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (valuesList_1_1 && !valuesList_1_1.done && (_a = valuesList_1.return)) _a.call(valuesList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return _super.prototype.merge.apply(this, __spreadArray$5([], __read$5(valuesList), false));
    };
    return CameraBoundsOptions;
}(Options));

var __extends$a = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for setting the map control's camera.
 */
var CameraOptions = /** @class */ (function (_super) {
    __extends$a(CameraOptions, _super);
    function CameraOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The zoom level of the map view.
         * Default `1`.
         * @default 1
         */
        _this.zoom = 1;
        /**
         * The position to align the center of the map view with.
         * Default `[0, 0]`.
         * @default [0, 0]
         */
        _this.center = new Position(0, 0);
        /**
         * A pixel offset to apply to the center of the map.
         * This is useful if you want to programmatically pan the map to another location or if you want to center the map over a shape, then offset the maps view to make room for a popup.
         * Default `[0, 0]`.
         * @default [0, 0]
         */
        _this.centerOffset = new Pixel(0, 0);
        /**
         * The bearing of the map (rotation) in degrees. When the bearing is 0, 90, 180, or 270 the top of the map container will be north, east, south or west respectively.
         * Default `0`.
         * @default 0
         */
        _this.bearing = 0;
        /**
         * The pitch (tilt) of the map in degrees between 0 and 60, where 0 is looking straight down on the map.
         * Default `0`.
         * @default 0
         */
        _this.pitch = 0;
        /**
         * The minimum zoom level that the map can be zoomed out to during the animation. Must be between 0 and 24, and less than or equal to `maxZoom`.
         * Setting `minZoom` below 1 may result in an empty map when the zoom level is less than 1.
         * Default `1`.
         * @default 1
         */
        _this.minZoom = 1;
        /**
         * The maximum zoom level that the map can be zoomed into during the animation. Must be between 0 and 24, and greater than or equal to `minZoom`.
         * Default `20`.
         * @default 20
         */
        _this.maxZoom = 20;
        /**
         * The minimum pitch that the map can be pitched to during the animation. Must be between 0 and 85, and less than or equal to `maxPitch`.
         * Default `0`.
         * @default 0
         */
        _this.minPitch = 0;
        /**
         * The maximum pitch that the map can be pitched to during the animation. Must be between 0 and 85, and greater than or equal to `minPitch`
         * Default `60`.
         * @default 60
         */
        _this.maxPitch = 60;
        /**
         * A bounding box in which to constrain the viewable map area to.
         * Users won't be able to pan the center of the map outside of this bounding box.
         * Set maxBounds to null or undefined to remove maxBounds
         * Default `undefined`.
         * @default undefined
         */
        _this.maxBounds = undefined;
        return _this;
    }
    return CameraOptions;
}(Options));

var __extends$9 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a layer of the map.
 */
var LayerOptions = /** @class */ (function (_super) {
    __extends$9(LayerOptions, _super);
    function LayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The name of the layer.
         */
        _this.name = undefined;
        /**
         * The name of the layer to place this layer before.  If not specified, the layer will be placed at the top of the
         * layer list.
         */
        _this.before = undefined;
        /**
         * The minimum zoom at which the layer will display inclusive.
         */
        _this.minZoom = 1;
        /**
         * The maximum zoom at which the layer will display inclusive.
         */
        _this.maxZoom = 20;
        /**
         * Whether to overwrite previous data for the layer.
         */
        _this.overwrite = false;
        /**
         * The opacity of the layer.
         */
        _this.opacity = 1;
        return _this;
    }
    return LayerOptions;
}(Options));

var __extends$8 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a circle layer.
 * @deprecated Use BubbleLayerOptions with atlas.layer.BubbleLayer instead.
 */
var CircleLayerOptions = /** @class */ (function (_super) {
    __extends$8(CircleLayerOptions, _super);
    function CircleLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The fill color of the circles for the layer. Is used as the default if a fill color is not specified for a
         * circle.
         */
        _this.color = "rgba(0,0,0,.5)";
        /**
         * The outline color of the circles for the layer. Is used as the default if an outline color is not specified for
         * a circle.
         */
        _this.outlineColor = "#000";
        /**
         * The radius in pixels of the circles for the layer. Is used as the default if a radius is not specified for a
         * circle.
         */
        _this.radius = 1;
        /**
         * The outline stroke width of the circles for the layer. Is used as the default if outline width is not specified
         * for a circle.
         */
        _this.outlineWidth = 5;
        /**
         * The name of the layer.
         */
        _this.name = "default-circles";
        return _this;
    }
    return CircleLayerOptions;
}(LayerOptions));

var __extends$7 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a linestring layer.
 * @deprecated Use LineLayerOptions with atlas.layer.LineLayer instead.
 */
var LinestringLayerOptions = /** @class */ (function (_super) {
    __extends$7(LinestringLayerOptions, _super);
    function LinestringLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The type of cap to use for the ends of the linestrings:
         * <p>"butt" is a squared ending that is drawn to the exact endpoint of the line.</p>
         * <p>"round" is a circular ending that is drawn past the exact endpoint with a radius of half the linestring's
         * width.</p>
         * <p>"square" is a squared ending that is drawn past the exact endpoint by half the linestring's width.
         */
        _this.cap = "butt";
        /**
         * The type of join to use for the linestrings:
         * <p>"bevel" is a squared join that cuts a corner flat at half the linestring's width from the vertex.</p>
         * <p>"round" is a circular join that rounds a corner with a radius of half the linestring's width from the
         * vertex.</p>
         * <p>"miter" is a sharp join that extends the segments of the linestring past the vertex until they intersect.</p>
         */
        _this.join = "miter";
        /**
         * The name of the layer.
         */
        _this.name = "default-linestrings";
        /**
         * The color of the lines for the layer. Is used as the default if a specific color is not specified for a line.
         */
        _this.color = "#000";
        /**
         * The width of the lines for the layer. Is used as the default if a specific width is not specified for a line.
         */
        _this.width = 1;
        return _this;
    }
    return LinestringLayerOptions;
}(LayerOptions));

var __extends$6 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a pin layer.
 * @deprecated Use SymbolLayerOptions with atlas.layer.SymbolLayer instead.
 */
var PinLayerOptions = /** @class */ (function (_super) {
    __extends$6(PinLayerOptions, _super);
    function PinLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The factor by which the icon should be scaled. A value of 1 is the original size; a value of 2 will double the
         * size of the icon.
         */
        _this.iconSize = 1;
        /**
         * The size of the title text.
         */
        _this.fontSize = 14;
        /**
         * The color of the title text.
         */
        _this.fontColor = "#000";
        /**
         * The font for the title of the pin.
         */
        _this.textFont = "SegoeUi-Regular";
        /**
         * Whether the icons should cluster when they collide on the map, or stay separate.
         */
        _this.cluster = true;
        /**
         * The icon to use to represent a cluster.
         */
        _this.clusterIcon = undefined;
        /**
         * An array of [pixelsRight, pixelsDown] for how many pixels to the right and down the title text should be
         * offset. Negative numbers can be used to offset the title left and up.
         */
        _this.textOffset = [0, 0];
        /**
         * The name of the layer.
         */
        _this.name = "default-pins";
        /**
         * The icon of the pins for the layer. Is used as the default if an icon is not specified for a pin.
         */
        _this.icon = "pin-darkblue";
        /**
         * The title of the pins for the layer. Is used as the default if a title is not specified for a pin.
         */
        _this.title = "";
        return _this;
    }
    return PinLayerOptions;
}(LayerOptions));

var __extends$5 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a polygon layer.
 * @deprecated Use new PolygonLayerOptions with atlas.layer.PolygonLayer instead.
 */
var PolygonLayerOptions = /** @class */ (function (_super) {
    __extends$5(PolygonLayerOptions, _super);
    function PolygonLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The fill color of the polygons for the layer. Is used as the default if a fill color is not specified for a
         * polygon.
         */
        _this.color = "rgba(0,0,0,.5)";
        /**
         * The outline color of the polygons for the layer. Is used as the default if an outline color is not specified for
         * a polygon.
         * @deprecated Use `atlas.layer.LineLayer` to provide an outline for a polygon.
         */
        _this.outlineColor = "#000";
        /**
         * The name of the layer.
         */
        _this.name = "default-polygons";
        return _this;
    }
    return PolygonLayerOptions;
}(LayerOptions));

var __extends$4 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for a raster layer.
 * @deprecated Use TileLayerOptions with atlas.layer.TileLayer instead.
 */
var RasterLayerOptions = /** @class */ (function (_super) {
    __extends$4(RasterLayerOptions, _super);
    function RasterLayerOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The name of the layer.
         */
        _this.name = "default-raster";
        return _this;
    }
    return RasterLayerOptions;
}(LayerOptions));

var __extends$3 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * The options for the map's lighting.
 */
var LightOptions = /** @class */ (function (_super) {
    __extends$3(LightOptions, _super);
    function LightOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Specifies wether extruded geometries are lit relative to the map or viewport.
         * Supported values:<br />
         * `"map"`: The position of the light source is aligned to the rotation of the map.<br />
         * `"viewport"`: The position fo the light source is aligned to the rotation of the viewport.<br />
         * Default: `"map"`
         * @default "map"
         */
        _this.anchor = "map";
        /**
         * Color tint for lighting extruded geometries.
         * Default: `"#FFFFFF"`
         * @default "#FFFFFF"
         */
        _this.color = "#FFFFFF";
        /**
         * Intensity of lighting (on a scale from 0 to 1).
         * Higher numbers will present as more extreme contrast.
         * Default `0.5`
         * @default 0.5
         */
        _this.intensity = 0.5;
        /**
         * Position of the light source relative to lit (extruded) geometries,
         * in [r radial coordinate, a azimuthal angle, p polar angle]
         * where r indicates the distance from the center of the base of an object to its light,
         * a indicates the position of the light relative to 0°
         * (0° when `anchor` is set to viewport corresponds to the top of the viewport,
         * or 0° when `anchor` is set to map corresponds to due north, and degrees proceed clockwise),
         * and p indicates the height of the light (from 0°, directly above, to 180°, directly below).
         */
        _this.position = [1.15, 210, 30];
        return _this;
    }
    return LightOptions;
}(Options));

var __extends$2 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values$4 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read$4 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$4 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * The options for the map's style.
 */
var StyleOptions = /** @class */ (function (_super) {
    __extends$2(StyleOptions, _super);
    function StyleOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * If true, the gl context will be created with MSAA antialiasing, which can be useful for antialiasing WebGL layers.
         */
        _this.antialias = undefined;
        /**
         * If true the map will automatically resize whenever the window's size changes.
         * Otherwise map.resize() must be called.
         * Default `true`.
         * @default true
         */
        _this.autoResize = true;
        /**
         * The language of the map labels.
         * [Supported language]{@link https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages}.
         * Default `atlas.getLanguage()`.
         * @default atlas.getLanguage()
         */
        _this.language = getLanguage();
        /**
         * Sets the lighting options of the map.
         */
        _this.light = new LightOptions();
        /**
         * If true, the map's canvas can be exported to a PNG using map.getCanvas().toDataURL().
         * This option may only be set when initializing the map.
         * Default `false`
         * @default false
         */
        _this.preserveDrawingBuffer = false;
        /**
         * If true, the map will try to defer non-essential map layers and show essential layers as early as possible.
         * This option may only be set when initializing the map.
         * Default `false`
         * @default false
         */
        _this.progressiveLoading = false;
        /**
         * The list of layer groups to be loaded at the initial stage. Passing an empty array will disable the progressive loading.
         * This option may only be set when initializing the map.
         * Default `['base']`
         * @default ['base']
         */
        _this.progressiveLoadingInitialLayerGroups = ['base'];
        /**
         * Specifies if multiple copies of the world should be rendered when zoomed out.
         * Default `true`
         * @default true
         */
        _this.renderWorldCopies = true;
        /**
         * Specifies if buildings will be rendered with their models.
         * If false all buildings will be rendered as just their footprints.
         * Default `false`
         * @default false
         * @deprecated
         */
        _this.showBuildingModels = false;
        /**
         * Specifies if the feedback link should be displayed on the map or not.
         * Default `true`
         * @default true
         */
        _this.showFeedbackLink = true;
        /**
         * Specifies if the Microsoft logo should be hidden or not.
         * If set to true a Microsoft copyright string will be added to the map.
         * Default `true`
         * @default true
         */
        _this.showLogo = true;
        /**
         * Specifies if the map should display labels
         * @default true
         */
        _this.showLabels = true;
        /**
         * Additional custom attribution appended to map attribution.
         * Default `undefined`
         * @default undefined
         */
        _this.customAttribution = undefined;
        /**
         * Specifies if the map should render an outline around each tile and the tile ID.
         * These tile boundaries are useful for debugging.
         * The uncompressed file size of the first vector source is drawn in the top left corner of each tile,
         * next to the tile ID.
         * Default `false`
         * @default false
         */
        _this.showTileBoundaries = false;
        /**
         * The name of the style to use when rendering the map. Available styles can be found in the
         * [supported styles]{@link https://docs.microsoft.com/en-us/azure/azure-maps/supported-map-styles} article.
         * The default style is defined in the style set.
         * @default undefined
         */
        _this.style = undefined;
        /**
         * Specifies which set of geopolitically disputed borders and labels are displayed on the map. The View parameter (also referred to as “user region parameter”) is a 2-letter ISO-3166 Country Code that will show the correct maps for that country/region. Country/Regions that are not on the View list or if unspecified will default to the “Unified” View.
         * Please see the supported [Views]{@link https://aka.ms/AzureMapsLocalizationViews}
         * It is your responsibility to determine the location of your users, and then set the View parameter correctly for that location. The View parameter in Azure Maps must be used in compliance with applicable laws, including those regarding mapping, of the country/region where maps, images and other data and third party content that You are authorized to access via Azure Maps is made available.
         * default: `undefined`
         * @default undefined
         */
        _this.view = getView();
        /**
         * @deprecated use `view` instead.
         */
        _this.userRegion = _this.view;
        /**
         * Override the default styles for the map elements.​
         * Default `undefined`
         * @default undefined
         */
        _this.styleOverrides = undefined;
        /**
         * allows substituting a default MapControl's style transformer with custom one
         * Default style transformer is meant to update the incoming fetched style to desired state, as well as to synchronize the SDK state with style state
         * and move additional layers over
         * @internal
         */
        _this.customStyleTransform = undefined;
        return _this;
    }
    /**
     * Override the standard merge behavior to first reassign the view property names to the new view one.
     * Also converts the specified language to a best fit supported one.
     * @internal
     */
    StyleOptions.prototype.merge = function () {
        var e_1, _a;
        var valueList = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            valueList[_i] = arguments[_i];
        }
        try {
            for (var valueList_1 = __values$4(valueList), valueList_1_1 = valueList_1.next(); !valueList_1_1.done; valueList_1_1 = valueList_1.next()) {
                var value = valueList_1_1.value;
                if (value) {
                    // Make sure both view and userRegion properties exist. Prefer view's value.
                    if (value.hasOwnProperty("view")) {
                        value.userRegion = value.view;
                    }
                    else if (value.hasOwnProperty("userRegion")) {
                        value.view = value.userRegion;
                    }
                    // Make sure the language is converted to the best fit supported one.
                    if (typeof value.language === "string") {
                        value.language = Localizer.getCode(value.language);
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (valueList_1_1 && !valueList_1_1.done && (_a = valueList_1.return)) _a.call(valueList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        // Then execute the standard merge behavior.
        return _super.prototype.merge.apply(this, __spreadArray$4([], __read$4(valueList), false));
    };
    return StyleOptions;
}(Options));

var __extends$1 = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$2 = (window && window.__assign) || function () {
    __assign$2 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$2.apply(this, arguments);
};
var __values$3 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read$3 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$3 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var composeTransformers = function (transformers) { return transformers.length == 0
    ? undefined
    : transformers.slice(1).reduce(function (chained, transform) {
        return function (url, resourceType) {
            var resourceParams = chained(url, resourceType);
            return __assign$2(__assign$2({}, resourceParams), transform(resourceParams.url, resourceType));
        };
    }, transformers[0]); };
/**
 * Global properties used in all atlas service requests.
 */
var ServiceOptions = /** @class */ (function (_super) {
    __extends$1(ServiceOptions, _super);
    function ServiceOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * The authentication options used to customize how the map control authenticates with Azure Maps services.
         * If these authentication options are specified then ServiceOptions.subscriptionKey should not be.
         * Recommend using the atlas.setAuthenticationOptions function instead.
         */
        _this.authOptions = getAuthenticationOptions();
        /**
         * Disable telemetry collection
         * This option may only be set when initializing the map.
         * default: true
         * @default true
         */
        _this.disableTelemetry = true;
        /**
         * Disable telemetry collection
         * This option may only be set when initializing the map.
         * @deprecated Recommend using disableTelemetry instead.
         */
        _this["disable-telemetry"] = _this.disableTelemetry;
        /**
         * The domain to use when requesting map tiles and other Azure Maps services.
         * If the protocol is not specified `https` is assumed.
         * Recommend using atlas.setDomain function instead.
         * @default "atlas.microsoft.com"
         */
        _this.domain = getDomain();
        /**
         * The domain to use when requesting style data and other static assets.
         */
        _this.staticAssetsDomain = getStaticAssetsDomain();
        /**
         * The styleDefinitionsPath to use for getting the map styles.
         * Recommend using atlas.setStyleDefinitionsPath function instead.
         * @default atlas.getStyleDefinitionsPath()
         * @internal
         */
        _this.styleDefinitionsPath = getStyleDefinitionsPath();
        /**
         * The style definitions version to request when requesting styles
         * from styleDefinitionsPath.
         */
        _this.styleDefinitionsVersion = getStyleDefinitionsVersion();
        /**
         * The style API version used when requesting styles and stylesets
         */
        _this.styleAPIVersion = getStyleAPIVersion();
        /**
         * The map configuration defines the set of styles available to the map.
         */
        _this.mapConfiguration = undefined;
        /**
         * @deprecated use mapConfiguration instead
         */
        _this.styleSet = undefined;
        /**
         * Enable the accessibility feature to provide screen reader support for users who have difficulty visualizing the web application.
         * This property is set to true by default.
         * @default true
         */
        _this.enableAccessibility = true;
        /**
         * Enable accessibility
         * @deprecated Recommend using enableAccessibility instead.
         */
        _this["enable-accessibility"] = _this.enableAccessibility;
        /**
         * Enable the fallback to the REST API geocoder for detecting location accessibility if extracting location from vector data fails.
         * Disabling this option will prevent the generation of geocode API requests but may lead to a lack of location information for screen readers.
         * default: true
         * @default true
         */
        _this.enableAccessibilityLocationFallback = true;
        /**
         * Maximum number of images (raster tiles, sprites, icons) to load in parallel,
         * which affects performance in raster-heavy maps. 16 by default.
         */
        _this.maxParallelImageRequests = getMaxParallelImageRequests();
        /**
         * A boolean that specifies if vector and raster tiles should be reloaded when they expire (based on expires header).
         * This is useful for data sets that update frequently. When set to false, each tile will be loaded once, when needed, and not reloaded when they expire.
         * default: true
         * @default true
         */
        _this.refreshExpiredTiles = true;
        /**
         * The customer subscription key used to authorize requests.
         * This option may only be set when initializing the map.
         * Recommend using the atlas.setSubscriptionKey function instead
         */
        _this.subscriptionKey = getSubscriptionKey();
        /**
         * The customer subscription key used to authorize requests.
         * This option may only be set when initializing the map.
         * @deprecated Recommend using the atlas.setSubscriptionKey function instead
         */
        _this["subscription-key"] = _this.subscriptionKey;
        /**
         * The session id to pass with requests.
         * Recommend using atlas.setSessionId instead.
         * @default Random UUID generated at runtime
         */
        _this.sessionId = getSessionId();
        /**
         * The session id to pass with requests.
         * @deprecated Recommend using atlas.setSessionId instead.
         */
        _this["session-id"] = _this.sessionId;
        _this._transformers = [];
        /**
         * If defined transformRequest will be called to provide custom request parameters for loading a tile.
         */
        _this.transformRequest = undefined;
        /**
         * Number of web workers instantiated on a page.
         * By default, it is set to half the number of CPU cores (capped at 6).
         */
        _this.workerCount = getWorkerCount();
        /**
         * Controls the duration of the fade-in/fade-out animation for label collisions, in milliseconds.
         * This setting affects all symbol layers.
         * This setting does not affect the duration of runtime styling transitions or raster tile cross-fading.
         * @default 300
         */
        _this.fadeDuration = 300;
        /**
         * Defines a CSS font-family for locally overriding generation of glyphs in the
         * 'CJK Unified Ideographs', 'Hiragana', 'Katakana' and 'Hangul Syllables' ranges.
         * In these ranges, font settings from the map's style will be ignored,
         * except for font-weight keywords (light/regular/medium/bold). Set to false,
         * to enable font settings from the map's style for these glyph ranges.
         * The purpose of this option is to avoid bandwidth-intensive glyph server requests.
         * @default 'sans-serif'
         */
        _this.localIdeographFontFamily = 'sans-serif';
        /**
         * True to validate styles before it's getting applied.
         * Validation takes significant(few hundred ms) time to process styles during initial load.
         * Can be set to false for production environment to improve performance.
         * @internal
         * @default 'false'
         */
        _this.validateStyle = false;
        return _this;
    }
    /**
     * Override the standard merge behavior to first reassign the old dash property names to the new camelCase ones.
     * @internal
     */
    ServiceOptions.prototype.merge = function () {
        var e_1, _a;
        var valueList = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            valueList[_i] = arguments[_i];
        }
        var currentStyleDefinitionsVersion = this.styleDefinitionsVersion;
        try {
            // Make sure both camel and dash case properties exist. Prefer the camel case ones.
            for (var valueList_1 = __values$3(valueList), valueList_1_1 = valueList_1.next(); !valueList_1_1.done; valueList_1_1 = valueList_1.next()) {
                var value = valueList_1_1.value;
                if (value) {
                    // authOptions can also have a subscription key so check for that first.
                    // If authOptions are specified then they should be preferred over the previous ServiceOptions.subscriptionKey.
                    if (value.authOptions) {
                        if (typeof value.authOptions.subscriptionKey === "string") {
                            value.subscriptionKey = value["subscription-key"] =
                                value.authOptions.subscriptionKey;
                        }
                    }
                    else {
                        if (typeof value.subscriptionKey === "string") {
                            value["subscription-key"] = value.subscriptionKey;
                            value.authOptions = {
                                authType: AuthenticationType.subscriptionKey,
                                subscriptionKey: value.subscriptionKey,
                            };
                        }
                        else if (typeof value["subscription-key"] === "string") {
                            value.subscriptionKey = value["subscription-key"];
                            value.authOptions = {
                                authType: AuthenticationType.subscriptionKey,
                                subscriptionKey: value["subscription-key"],
                            };
                        }
                    }
                    if (typeof value.sessionId === "string") {
                        value["session-id"] = value.sessionId;
                    }
                    else if (typeof value["session-id"] === "string") {
                        value.sessionId = value["session-id"];
                    }
                    if (typeof value.disableTelemetry === "boolean") {
                        value["disable-telemetry"] = value.disableTelemetry;
                    }
                    else if (typeof value["disable-telemetry"] === "boolean") {
                        value.disableTelemetry = value["disable-telemetry"];
                    }
                    if (typeof value.enableAccessibility === "boolean") {
                        value["enable-accessibility"] = value.enableAccessibility;
                    }
                    else if (typeof value["enable-accessibility"] === "boolean") {
                        value.enableAccessibility = value["enable-accessibility"];
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (valueList_1_1 && !valueList_1_1.done && (_a = valueList_1.return)) _a.call(valueList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        // default merge behavior overrides _transformers
        // won't change default behavior in Options as usually that's what desired
        // instead capture it here and reassign.
        var currentTransforms = this._transformers;
        var transformersToMerge = valueList ? valueList.filter(function (value) { return value !== undefined; }).reduce(function (flattened, value) { return __spreadArray$3(__spreadArray$3([], __read$3(flattened), false), __read$3(value._transformers || []), false); }, []) : [];
        // Then execute the standard merge behavior.
        // If subscription key auth method isn't being used then the subscription key property should be undefined.
        var merged = _super.prototype.merge.apply(this, __spreadArray$3([], __read$3(valueList), false));
        if (merged.authOptions.authType !== AuthenticationType.subscriptionKey) {
            merged["subscription-key"] = merged.subscriptionKey = undefined;
        }
        // if mapConfiguration is not set and legacy styleSet option is used, assign it to mapConfiguration
        if (merged.styleSet !== undefined && merged.mapConfiguration === undefined) {
            merged.mapConfiguration = merged.styleSet;
        }
        // reassign properties from legacy mapConfiguration to new structure if needed
        if (merged.mapConfiguration && typeof merged.mapConfiguration !== 'string') {
            merged.mapConfiguration = __assign$2(__assign$2({}, merged.mapConfiguration), { defaultConfiguration: merged.mapConfiguration.defaultConfiguration || merged.mapConfiguration['defaultStyle'], configurations: merged.mapConfiguration.configurations || merged.mapConfiguration['styles'] });
        }
        this._transformers = __spreadArray$3(__spreadArray$3([], __read$3(currentTransforms || []), false), __read$3(transformersToMerge.filter(function (toMerge) { return !currentTransforms.includes(toMerge); })), false);
        if (this.transformRequest && !this._transformers.includes(this.transformRequest)) {
            this._transformers.push(this.transformRequest);
        }
        // NOTE: do not allow changing to a soon deprecated style-version, only version above-equal 2023-01-01 should be allowed
        var minVersionComparator = new Date(Date.UTC(2023, 0));
        var styleDefinitionVersionDate = new Date(this.styleDefinitionsVersion);
        if (isNaN(styleDefinitionVersionDate.getTime()) || styleDefinitionVersionDate.getTime() < minVersionComparator.getTime()) {
            console.warn("Style definition version ".concat(this.styleDefinitionsVersion, " is invalid or deprecated, style definition version is unchanged (").concat(currentStyleDefinitionsVersion, ")"));
            this.styleDefinitionsVersion = currentStyleDefinitionsVersion;
        }
        // chain transformers in a middleware fashion
        this.transformRequest = composeTransformers(this._transformers);
        return merged;
    };
    /**
     * Appends request transformer
     */
    ServiceOptions.prototype.addTransformer = function (transformer) {
        if (!this._transformers) {
            this._transformers = [];
        }
        this._transformers.push(transformer);
        this.transformRequest = composeTransformers(this._transformers);
    };
    /**
     * Removes request transformer
     */
    ServiceOptions.prototype.removeTransformer = function (transformer) {
        if (!this._transformers) {
            return;
        }
        this._transformers = this._transformers.filter(function (existing) { return transformer !== existing; });
        this.transformRequest = composeTransformers(this._transformers);
    };
    /**
     * Customizer for _.cloneDeep calls, allows objects to pass through with only a shallow cloning.
     * Currently the only objects being cloned should be the `AuthenticationOptions`.
     * @param value The value being cloned.
     * @internal
     */
    ServiceOptions._cloneCustomizer = function (value) {
        if (typeof value === "object") {
            return Object.assign({}, value);
        }
    };
    return ServiceOptions;
}(Options));

var LayerGroupComparator = /** @class */ (function () {
    function LayerGroupComparator() {
    }
    /**
     * Extract layer group name from layer id. This method assumes the layer group is
     * the fourth token in a dotted string where the first token is "microsoft".
     * @param layer Mapbox layer to extract layer group name from
     * @returns layer group if present, undefined otherwise.
     * @internal
     */
    LayerGroupComparator.getLayerGroup = function (layer) {
        if (typeof layer !== 'string' && layer.metadata && layer.metadata['microsoft.maps:layerGroup']) {
            return layer.metadata['microsoft.maps:layerGroup'];
        }
        var layerId = typeof layer !== 'string' ? layer.id : layer;
        if (!layerId.startsWith("microsoft.")) {
            return undefined;
        }
        var idTokens = layerId.split('.');
        if (idTokens.length >= 4) {
            return idTokens[3];
        }
        return undefined;
    };
    return LayerGroupComparator;
}());

var HijackablePromise = /** @class */ (function () {
    function HijackablePromise(origin) {
        var _this = this;
        this.isHijacked = function () { return _this._hijackedToResolve !== undefined || _this._hijackedToReject !== undefined; };
        this.isResolved = function () { return _this._hijackedToResolve !== undefined || _this._toResolve !== undefined; };
        this.isRejected = function () { return _this._hijackedToReject !== undefined || _this._toReject !== undefined; };
        this.resultIfResolved = function () { return _this._hijackedToResolve || _this._toResolve; };
        this.errorIfRejected = function () { return _this._hijackedToReject || _this._toReject; };
        this._thenResolver = function (resolve, reject) {
            if (_this._hijackedToResolve) {
                resolve(_this._hijackedToResolve);
            }
            else if (_this._hijackedToReject) {
                reject(_this._hijackedToReject);
            }
            else {
                // we retain the origin, and check if stays the same as resolved
                var retainedInvocator_1 = _this.origin;
                _this.origin.then(function (result) {
                    if (_this.isHijacked()) {
                        return;
                    }
                    // origin was switched during invocation, discard the result and follow the chain
                    if (retainedInvocator_1 !== _this.origin) {
                        _this._thenResolver(resolve, reject);
                    }
                    else {
                        _this._toResolve = result;
                        resolve(result);
                    }
                }).catch(function (error) {
                    if (_this.isHijacked()) {
                        return;
                    }
                    // origin was switched during invocation, discard the result and follow the chain
                    if (retainedInvocator_1 !== _this.origin) {
                        _this._thenResolver(resolve, reject);
                    }
                    else {
                        _this._toReject = error;
                        reject(error);
                    }
                });
            }
        };
        this.origin = origin;
        this[Symbol.toStringTag] = this.origin[Symbol.toStringTag];
    }
    HijackablePromise.resolve = function (value) {
        return new HijackablePromise(Promise.resolve(value));
    };
    HijackablePromise.reject = function (error) {
        return new HijackablePromise(Promise.reject(error));
    };
    HijackablePromise.prototype.then = function (onfulfilled, onrejected) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._resolve = resolve;
            _this._reject = reject;
            _this._thenResolver(resolve, reject);
        }).then(onfulfilled, onrejected);
    };
    // tslint:disable-next-line: no-reserved-keywords
    HijackablePromise.prototype.catch = function (onrejected) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._resolve = resolve;
            _this._reject = reject;
            _this._thenResolver(resolve, reject);
        }).catch(onrejected);
    };
    // tslint:disable-next-line: no-reserved-keywords
    HijackablePromise.prototype.finally = function (onfinally) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._resolve = resolve;
            _this._reject = reject;
            _this._thenResolver(resolve, reject);
        }).finally(onfinally);
    };
    HijackablePromise.prototype.hijackAndResolve = function (value) {
        this._hijackedToResolve = value;
        if (this._resolve) {
            this._resolve(value);
        }
    };
    HijackablePromise.prototype.hijackAndReject = function (error) {
        this._hijackedToReject = error;
        if (this._reject) {
            this._reject(error);
        }
    };
    HijackablePromise.prototype.switchWith = function (promise) {
        // switching the origin will discard the original in-progress promise result, as well any resolved non-hijacked state
        this.origin = promise;
        this._toResolve = undefined;
        this._toReject = undefined;
    };
    return HijackablePromise;
}());

var styleNamesMap = {
    road: "Road",
    satellite: "Satellite",
    satellite_road_labels: "Hybrid",
    grayscale_dark: "Grayscale (Dark)",
    grayscale_light: "Grayscale (Light)",
    night: "Night",
    road_shaded_relief: "Terra",
    blank: "Blank",
    blank_accessible: "Blank (Accessible)",
    high_contrast_dark: "High contrast (Dark)",
    high_contrast_light: "High contrast (Light)"
};

var __assign$1 = (window && window.__assign) || function () {
    __assign$1 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$1.apply(this, arguments);
};
var __awaiter$1 = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$1 = (window && window.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read$2 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$2 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values$2 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * Mapping of styleOverrides options to style parameter values.
 */
var styleOverridesMapping = {
    countryRegion: "cr|bv:0",
    adminDistrict: "ad|bv:0",
    adminDistrict2: "ds|bv:0",
    buildingFootprint: "bld|v:0_adr|lv:0",
    roadDetails: "g|rasterDetailsVisible:0"
};
/**
 * @private
 */
var StyleManager = /** @class */ (function () {
    /**
     * Constructs the style manager to be exposed only through the styles property of the Map class.
     * @param map The map whose styles are being managed by this.
     * @param serviceOptions Service options contain domain to use for requesting style resources.
     * @internal
     */
    function StyleManager(map, serviceOptions) {
        var _this = this;
        this.definitions = function () {
            var resultPromise;
            if (_this.initPromise) {
                resultPromise = _this.initPromise;
            }
            else {
                resultPromise = _this.initStyleset();
            }
            return resultPromise;
        };
        /**
         * Compatibility indoor state used in styleDefinition filtering.
         * Legacy indoor module (2.0.6) will not set tilesetId
         */
        this.indoorState = undefined;
        /**
         * Preserve the map configuration that was used before the indoor map configuration was set
         */
        this.preservedPreindoorMapConfiguration = undefined;
        /**
         * The state of the progressive loading
         */
        this._progressiveLoadingState = {
            mapStyle: undefined,
            pendingVisibilityChange: undefined,
        };
        this._deferLayerGroupVisibilities = function (layerGroupLayers, initLayerGroups) {
            var validInitLayerGroups = initLayerGroups.filter(function (groupName) { return groupName in layerGroupLayers; });
            // If the initial layer groups are invalid, skip the progressive loading.
            if (validInitLayerGroups.length === 0)
                return;
            var map = _this.map._getMap();
            var currentZoomLevel = map.getZoom();
            var currentMapStyle = _this.map.getStyle().style;
            // Cancel and release previous pending callback, if any.
            if (_this._progressiveLoadingState.pendingVisibilityChange) {
                _this.map.events.remove('load', _this._progressiveLoadingState.pendingVisibilityChange);
                _this._progressiveLoadingState.pendingVisibilityChange = null;
            }
            // Keep the current map style for future comparison.
            _this._progressiveLoadingState.mapStyle = currentMapStyle;
            // Select deferrable layers
            var deferredLayers = Object.entries(layerGroupLayers).reduce(function (deferred, _a) {
                var _b = __read$2(_a, 2), groupName = _b[0], layers = _b[1];
                var isInInitialLayerGroup = validInitLayerGroups.includes(groupName);
                return __spreadArray$2(__spreadArray$2([], __read$2(deferred), false), __read$2(layers.filter(function (layer) {
                    var _a;
                    // Exclude custom layers
                    if (layer.type === 'custom')
                        return false;
                    // Exclude visible layers from initial layer groups
                    if (isInInitialLayerGroup) {
                        if (typeof layer.maxzoom === 'number' && typeof layer.minzoom === 'number') {
                            if (currentZoomLevel <= layer.maxzoom && currentZoomLevel >= layer.minzoom)
                                return false;
                        }
                        else if (typeof layer.minzoom === 'number') {
                            if (currentZoomLevel >= layer.minzoom)
                                return false;
                        }
                        else if (typeof layer.maxzoom === 'number') {
                            if (currentZoomLevel <= layer.maxzoom)
                                return false;
                        }
                        else {
                            return false;
                        }
                    }
                    // Select visible layers only.
                    return ((_a = layer.layout) === null || _a === void 0 ? void 0 : _a.visibility) !== 'none';
                })), false);
            }, []);
            // Hide the deferrable layers at initial load, therefore we can save the render time.
            deferredLayers.forEach(function (layer) {
                // Since this happens before sending style object into the map rendering,
                // we only need to update the style object, but not necessary to update maplibre's layout properties.
                layer.layout = layer.layout || {};
                layer.layout.visibility = 'none';
            });
            // Make the deferred layers visible once the map instance is fully loaded.
            _this._progressiveLoadingState.pendingVisibilityChange = function () {
                var _a;
                // Release the callback.
                _this._progressiveLoadingState.pendingVisibilityChange = null;
                // Bail out the callback once map style has changed.
                var nextMapStyle = _this.map.getStyle().style;
                if (currentMapStyle !== nextMapStyle)
                    return;
                // Make deferred layers visible
                deferredLayers.forEach(function (layer) {
                    // This happens after the map rendering; Therefore, we need to update
                    // both the style object and the maplibre's layout properties.
                    layer.layout.visibility = 'visible';
                    map.setLayoutProperty(layer.id, 'visibility', 'visible');
                });
                // Reload attribution after the deferred layers are visible.
                (_a = _this.map.copyrightDelegate) === null || _a === void 0 ? void 0 : _a.reloadAttribution();
            };
            _this.map.events.addOnce('load', _this._progressiveLoadingState.pendingVisibilityChange);
        };
        this._onStyleData = function (definition) {
            _this.map.events.invoke("stylechanged", {
                style: definition.name,
                map: _this.map,
                type: "stylechanged"
            });
        };
        /**
         * Looks up the style type info from the style definitions: this is async unsafe
         */
        this._lookUp = function (options) {
            var e_1, _a;
            var definitionsPromise = _this.definitions();
            var definitionsFetchError = definitionsPromise.errorIfRejected();
            var definitions = definitionsPromise.resultIfResolved();
            if (definitionsFetchError) {
                return null;
            }
            else if (!definitions) {
                return null;
            }
            else {
                var configrationsArray = definitions.configurations;
                // retrieve default style definition unless option.style's one was found
                var result = void 0;
                try {
                    for (var configrationsArray_1 = __values$2(configrationsArray), configrationsArray_1_1 = configrationsArray_1.next(); !configrationsArray_1_1.done; configrationsArray_1_1 = configrationsArray_1.next()) {
                        var style = configrationsArray_1_1.value;
                        if (style.name === options.style) {
                            // this result is the highest priority, can immediately return
                            return style;
                        }
                        if (style.name === definitions.defaultConfiguration && !result) {
                            // backup result, so dont break here yet.
                            // Later in the loop there might be another one matching options.style
                            result = style;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (configrationsArray_1_1 && !configrationsArray_1_1.done && (_a = configrationsArray_1.return)) _a.call(configrationsArray_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                // no default style in the mapConfiguration, pick the first style
                if (!result) {
                    result = configrationsArray[0];
                }
                return result;
            }
        };
        this._lookUpAsync = function (options) { return __awaiter$1(_this, void 0, void 0, function () {
            var definitions, result;
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.definitions()];
                    case 1:
                        definitions = _a.sent();
                        result = definitions.configurations.find(function (style) { return style.name === (options.style || definitions.defaultConfiguration); })
                            // retrieve default style definition unless option.style's one was found
                            || definitions.configurations.find(function (style) { return style.name === definitions.defaultConfiguration; })
                            // no default style in the mapConfiguration -> pick the first style
                            || definitions.configurations[0];
                        return [2 /*return*/, result];
                }
            });
        }); };
        this.map = map;
        this.serviceOptions = serviceOptions;
    }
    StyleManager.prototype.updateIndoorState = function (theme, tilesetId) {
        var _this = this;
        var _a;
        var mapConfiguration = this.map.styles.getMapConfiguration();
        if (mapConfiguration) {
            this.preservedPreindoorMapConfiguration = mapConfiguration;
            // tilesetId fallback
            // MAGIC: if we are on a default style set - match existing style to the one in the default indoor style set
            var desiredIndoorStyle = this.map.getStyle().style ? "".concat(this.map.getStyle().style, "_indoor").concat(theme === 'dark' ? '_dark' : '', "_tileset_").concat(tilesetId) : undefined;
            this.map.styles.setMapConfiguration("defaultIndoor_".concat(tilesetId), mapConfiguration === 'microsoft-maps:default' ? desiredIndoorStyle : undefined);
        }
        else {
            var didTilesetIdChange_1 = ((_a = this.indoorState) === null || _a === void 0 ? void 0 : _a.tilesetId) !== tilesetId;
            this.indoorState = {
                tilesetId: tilesetId,
                theme: theme
            };
            this.initStyleset();
            this.definitions().then(function (definitions) {
                var currentStyle = (_this.map.getStyle().style || definitions.defaultConfiguration)
                    .replace('_indoor_dark', '')
                    .replace('_indoor', '');
                // we cannot compose the precise style name for auto theme, search for prefix style name match
                var targetStylePrefix = "".concat(currentStyle, "_indoor");
                var candidateStyle = definitions.configurations.find(function (style) { return style.name.startsWith(targetStylePrefix); });
                if (candidateStyle) {
                    // force style reload if tileset id has changed to make sure the tiles will be re-requested with new tileset applied in indoor source placeholder
                    _this.map.setStyle({ style: candidateStyle.name }, !didTilesetIdChange_1);
                }
            });
        }
    };
    StyleManager.prototype.unsetIndoorState = function () {
        var _this = this;
        var mapConfiguration = this.preservedPreindoorMapConfiguration;
        if (mapConfiguration) {
            // we need to revert to the styleset that was ap
            this.map.styles.setMapConfiguration(mapConfiguration);
        }
        else {
            this.indoorState = undefined;
            this.initStyleset();
            this.definitions().then(function (definitions) {
                var currentStyle = _this.map.getStyle().style;
                if (currentStyle.includes('_indoor') && currentStyle.split('_indoor')[0]) {
                    _this.map.setStyle({ style: currentStyle.split('_indoor')[0] });
                }
                else {
                    _this.map.setStyle({ style: undefined });
                }
            });
        }
    };
    /**
     * If this method has been called before then the original promise is returned.
     * Promise is resolved once the style set is successfully fetched and stored.
     */
    StyleManager.prototype.initStyleset = function () {
        var _this = this;
        var newPromise;
        var mapStyleNameToFriendyWhenAvailable = function (styleName) {
            var baseName = _this.indoorState && styleName.includes('_indoor') ? styleName.split('_indoor')[0] : styleName;
            return baseName in styleNamesMap ? styleNamesMap[baseName] : baseName;
        };
        if (!this.serviceOptions.mapConfiguration) {
            var ensureAuthentication = this.map.authentication ? this.map.authentication.initialize() : Promise.resolve();
            newPromise = new HijackablePromise(ensureAuthentication.then(function () { return _this._request(_this.serviceOptions.staticAssetsDomain, "".concat(constants.stylePath, "/").concat(constants.styleResourcePath), "StyleDefinitions", {
                version: _this.serviceOptions.styleDefinitionsVersion,
                // add MapControlVersion to make sure we have different local cache between map control versions
                mcv: version$3.replace(/\./g, ''),
            }).then(function (definitions) { return ({
                version: isNaN(definitions.version) ? 0 : parseFloat(definitions.version),
                defaultConfiguration: definitions.defaultStyle,
                configurations: definitions.styles
                    .filter(function (style) {
                    if (!_this.indoorState) {
                        return !style.name.includes('indoor');
                        // NOTE: azure-maps-indoor prior to 2.0.7 will not pass theme auto
                        // the IndoorModule will request getTheme() from StyleManager and will call StyleManager.setStyleSet(theme == 'dark ? 'indoor_dark' : 'indoor') as approperaite
                    }
                    else if (_this.indoorState.theme === 'auto') {
                        return style.name.endsWith(style.theme === 'dark' ? '_indoor_dark' : '_indoor');
                    }
                    else {
                        return style.name.endsWith(_this.indoorState.theme === 'dark' ? '_indoor_dark' : '_indoor');
                    }
                })
                    .map(function (style) { return ({
                    copyright: style.copyright.join(' '),
                    name: style.name,
                    displayName: mapStyleNameToFriendyWhenAvailable(style.name),
                    theme: style.theme,
                    thumbnail: new Url({ domain: _this.serviceOptions.staticAssetsDomain, path: style.thumbnail, protocol: "https" }).toString(),
                    url: new Url({
                        domain: _this.serviceOptions.staticAssetsDomain,
                        path: "".concat(constants.stylePath, "/").concat(constants.styleResourcePath, "/").concat(style.name),
                        queryParams: {
                            // Use the style version from the API response if it's available,
                            // otherwise fallback to the version specified in the serviceOptions.
                            // This is needed for flight testing the 2023-01-01 style version.
                            styleVersion: definitions.version !== undefined && definitions.version !== null
                                ? definitions.version
                                : _this.serviceOptions.styleDefinitionsVersion,
                            // thus far we don't need to differentiate based on parameter here, as stylePatch will be called on cached styles as well
                            //language: styleOptions.language
                            // add MapControlVersion to make sure we have different local cache between map control versions
                            mcv: version$3.replace(/\./g, '')
                        },
                        protocol: "https"
                    }).toString(),
                }); })
            }); }); }));
        }
        else if (typeof this.serviceOptions.mapConfiguration === 'string') {
            var ensureAuthentication = this.map.authentication ? this.map.authentication.initialize() : Promise.resolve();
            newPromise = new HijackablePromise(ensureAuthentication.then(function () { return _this._request(_this.serviceOptions.domain, "".concat(constants.styleResourcePath, "/mapconfigurations/metadata/").concat(_this.serviceOptions.mapConfiguration), "StyleDefinitions"
            // reassign properties from legacy mapConfiguration to new structure if needed
            ).then(function (definitions) { return (__assign$1(__assign$1({}, definitions), { defaultConfiguration: definitions.defaultConfiguration || definitions['defaultStyle'], configurations: definitions.configurations || definitions['styles'] })); }); }));
        }
        else {
            newPromise = HijackablePromise.resolve(this.serviceOptions.mapConfiguration);
        }
        if (this.initPromise) {
            this.initPromise.switchWith(newPromise);
            this.initPromise = newPromise;
        }
        else {
            this.initPromise = newPromise;
        }
        // propagate styleset change
        this.initPromise.then(function (styleset) { return _this.map._invokeEvent("mapconfigurationchanged", styleset); });
        return this.initPromise;
    };
    /**
     * Gets URL or object of the style listed in style definition. Style definition's default style is used if
     * styleOptions.style is not provided or if styleOptions.style is not present in the style definition.
     */
    StyleManager.prototype.getStyle = function (styleOptions) {
        var styleDefinition = this._lookUp(styleOptions);
        if (!styleDefinition) {
            throw Error("Style definition is not available.");
        }
        if (styleDefinition.url) {
            return styleDefinition.url;
        }
        if (styleDefinition.style) {
            return styleDefinition.style;
        }
        throw Error("Style definition neither contains URL nor style object.");
    };
    StyleManager.prototype.deriveNewStyleAndLayerGroups = function (previousStyle, nextStyle) {
        var _a, _b, _c, _d, _e, _f;
        // Layers in the next style with default properties that do not align with current StyleOptions
        // should be modified before they are applied to the map.
        var styleOptions = this.map.getStyle();
        var trafficOptions = this.map.getTraffic();
        var layersGroups = {};
        for (var i = 0; i < nextStyle.layers.length; i++) {
            var nextLayer = nextStyle.layers[i];
            var layerGroup = LayerGroupComparator.getLayerGroup(nextLayer);
            if (!layerGroup) {
                layersGroups[nextLayer.id] = [nextLayer];
                continue;
            }
            if (!layersGroups[layerGroup]) {
                layersGroups[layerGroup] = [];
            }
            var layerGroupLayers = layersGroups[layerGroup];
            layerGroupLayers.push(nextLayer);
            // 1. Set visiblity of fill-extrusion layers according to StyleOptions.showBuildingModels
            if (!styleOptions.showBuildingModels && nextLayer.type === "fill-extrusion") {
                nextLayer.layout = (_a = nextLayer.layout) !== null && _a !== void 0 ? _a : {};
                nextLayer.layout.visibility = "none";
            }
            else if (nextLayer.type === "fill-extrusion") {
                nextLayer.layout = (_b = nextLayer.layout) !== null && _b !== void 0 ? _b : {};
                nextLayer.layout.visibility = "visible";
            }
            // 2. Set visibility of traffic layers depending on traffic settings.
            if (trafficOptions.flow !== "none" && layerGroup) {
                if (layerGroup === "traffic_".concat(trafficOptions.flow) && nextLayer.type == "line") {
                    nextLayer.layout = (_c = nextLayer.layout) !== null && _c !== void 0 ? _c : {};
                    nextLayer.layout.visibility = "visible";
                }
            }
            // 3. Set visibility of labels
            var isLabelLayerGroup = layerGroup === 'labels' || layerGroup === 'labels_places' || layerGroup === 'labels_indoor';
            if (isLabelLayerGroup && nextLayer.type === 'symbol') {
                if (styleOptions.showLabels && ((_d = nextLayer.layout) === null || _d === void 0 ? void 0 : _d.visibility) !== "none") {
                    nextLayer.layout = (_e = nextLayer.layout) !== null && _e !== void 0 ? _e : {};
                    nextLayer.layout.visibility = "visible";
                }
                else {
                    nextLayer.layout = (_f = nextLayer.layout) !== null && _f !== void 0 ? _f : {};
                    nextLayer.layout.visibility = "none";
                }
            }
        }
        return [nextStyle, layersGroups];
    };
    StyleManager.prototype.injectUserLayersIntoStyle = function (previousStyle, nextStyle, layerGroupLayers) {
        // Custom layers added to mapbox through this SDK should be carried over to the next style.
        return !previousStyle
            ? nextStyle
            : this.map.layers._getUserLayers().reduce(function (style, userLayer) {
                var _a, _b;
                if (userLayer.layer instanceof WebGLLayer) {
                    // mapbox custom layers cannot be serialized and preserved,
                    // return to continue to the next user layer.
                    return style;
                }
                var beforeLayerId = ((_b = (_a = layerGroupLayers === null || layerGroupLayers === void 0 ? void 0 : layerGroupLayers[userLayer.before]) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.id) || userLayer.before;
                var layer = previousStyle.layers.find(function (layer) { return layer.id === userLayer.layer.getId(); });
                // when setStyle diff attempt is unsuccesful, _load will be called on the style that may have already injected user layers -> clean it up
                var existingLayerIdx = nextStyle.layers.findIndex(function (layer) { return layer.id === userLayer.layer.getId(); });
                if (existingLayerIdx > -1) {
                    nextStyle.layers.splice(existingLayerIdx, 1);
                }
                if (layer) {
                    var sourcesToCopy = new Set(Array.from(userLayer.layer._getSourceIds())
                        .map(function (sourceId) {
                        // If source is already present in the target style, skip copy
                        if (style.sources[sourceId]) {
                            return undefined;
                        }
                        var source = previousStyle.sources[sourceId];
                        return source ? { source: source, id: sourceId } : undefined;
                    })
                        .filter(function (source) { return source !== undefined; }));
                    var insertIdx = beforeLayerId ? style.layers.findIndex(function (layer) { return layer.id === beforeLayerId; }) : -1;
                    if (insertIdx > -1) {
                        style.layers.splice(insertIdx, 0, layer);
                    }
                    else {
                        style.layers.push(layer);
                    }
                    sourcesToCopy.forEach(function (_a) {
                        var source = _a.source, id = _a.id;
                        style.sources[id] = source;
                    });
                }
                return style;
            }, __assign$1({}, nextStyle));
    };
    /**
     * @internal
     */
    StyleManager.prototype.setStyle = function (styleOptions, diff) {
        var _this = this;
        if (diff === void 0) { diff = true; }
        var transformStyleFunc;
        var targetDefinition = this._lookUp(styleOptions);
        if (!targetDefinition) {
            throw Error("Style definition ".concat(styleOptions.style, " is not available."));
        }
        if (!targetDefinition.url && !targetDefinition.style) {
            throw Error("Style definition neither contains URL nor style object.");
        }
        var styleDataCallback = function () { return _this._onStyleData(targetDefinition); };
        var patchStyleEvent = function () {
            // FIXME: below diffing will be soon fixed on the maplibre side
            // If there was a previous styledata change event attached, remove it.
            // When the sprite url changes between style changes then maplibre can't perform the diff
            // In such cases it recalculate the style again. Removing previous attached
            // event listener makes sure that style changed event is not fired twice in these cases.
            _this.map.events.remove("styledata", styleDataCallback);
            _this.map.events.addOnce("styledata", styleDataCallback);
        };
        if (styleOptions && styleOptions.customStyleTransform) {
            transformStyleFunc = function (prev, next) {
                var target = styleOptions.customStyleTransform(prev, next);
                patchStyleEvent();
                return target;
            };
        }
        else {
            transformStyleFunc = function (previousStyle, style) {
                // make sure we always have a shallow clone to prevent mutating explicit json(rather then url) styles being set
                var nextStyle = __assign$1(__assign$1({}, style), { layers: __spreadArray$2([], __read$2(style.layers), false), sources: __assign$1({}, style.sources) });
                var shouldProgressiveLoading = (styleOptions.progressiveLoading &&
                    // The feature only effective at the initial load.
                    !_this.map._isLoaded());
                // Shallow-clone the style object and duplicate layer.layout properties to avoid side-effects.
                if (shouldProgressiveLoading && Array.isArray(style === null || style === void 0 ? void 0 : style.layers)) {
                    nextStyle = __assign$1({}, style);
                    nextStyle.layers = nextStyle.layers.map(function (layer) {
                        var nextLayer = __assign$1({}, layer);
                        if (layer.layout) {
                            nextLayer.layout = __assign$1({}, layer.layout);
                        }
                        return nextLayer;
                    });
                }
                // 1. derive the base new style (without user layers) and layer groups
                var _a = __read$2(_this.deriveNewStyleAndLayerGroups(previousStyle, nextStyle), 2), targetStyle = _a[0], layerGroupLayers = _a[1];
                // 2. side effect: progressively render map layers to the canvas to shorten the time to the first meaningful render.
                if (shouldProgressiveLoading) {
                    var initLayerGroups = styleOptions.progressiveLoadingInitialLayerGroups;
                    if (Array.isArray(initLayerGroups) && initLayerGroups.length > 0) {
                        _this._deferLayerGroupVisibilities(layerGroupLayers, initLayerGroups);
                    }
                }
                // 3. copy user layers and sources from previous style into new one
                var targetStyleWithUserLayers = _this.injectUserLayersIntoStyle(previousStyle, targetStyle, layerGroupLayers);
                // 4. side effects: sync our control's LayerManager and SourceManager
                var nextFundamentalLayers = Object.entries(layerGroupLayers).map(function (_a) {
                    var _b = __read$2(_a, 2), layerGroupId = _b[0], layers = _b[1];
                    return _this._buildFundamentalLayerFrom(layers, layerGroupId);
                });
                var layerIndex = _this.map.layers._getUserLayers().reduce(function (layerIndex, userLayer) {
                    var layerInsertIndex = userLayer.before ? layerIndex.findIndex(function (layer) { return layer.getId() === userLayer.before; }) : -1;
                    if (layerInsertIndex > -1) {
                        layerIndex.splice(layerInsertIndex, 0, userLayer.layer);
                    }
                    else {
                        layerIndex.push(userLayer.layer);
                    }
                    return layerIndex;
                }, nextFundamentalLayers);
                _this.map.layers['layerIndex'] = layerIndex;
                _this.map.sources._syncSources(targetStyleWithUserLayers.sources);
                // 5. temporarily patch style data event
                patchStyleEvent();
                return targetStyleWithUserLayers;
            };
        }
        var styleUrl = targetDefinition.url;
        if (styleUrl && (styleOptions === null || styleOptions === void 0 ? void 0 : styleOptions.styleOverrides)) {
            // Append the st parameter in the url with the mapped value.
            // We loop through the styleOverrides and join the corresponding st parameter with "_".
            var url = new URL(styleUrl);
            var params = new URLSearchParams(url.search);
            var stParams = Object.entries(styleOptions === null || styleOptions === void 0 ? void 0 : styleOptions.styleOverrides)
                .filter(function (_a) {
                var _b = __read$2(_a, 2), key = _b[0], value = _b[1];
                return key in styleOverridesMapping &&
                    ( // bv stands for borderVisible
                    (styleOverridesMapping[key].includes('bv') && (value === null || value === void 0 ? void 0 : value.borderVisible) === false) ||
                        (!styleOverridesMapping[key].includes('bv') && (value === null || value === void 0 ? void 0 : value.visible) === false));
            })
                .map(function (_a) {
                var _b = __read$2(_a, 2), key = _b[0]; _b[1];
                return styleOverridesMapping[key];
            });
            if (stParams.length > 0) {
                params.set("st", stParams.join("_"));
                url.search = params.toString();
                styleUrl = url.toString();
            }
        }
        this.map._getMap().setStyle(styleUrl || targetDefinition.style, {
            diff: diff,
            validate: this.serviceOptions.validateStyle,
            transformStyle: transformStyleFunc
        });
    };
    /**
     * Gets the color theme (light/dark) for the style type specified by the style options.
     */
    StyleManager.prototype.getTheme = function (styleOptions) {
        var style = this._lookUp(styleOptions);
        if (!style) {
            return undefined;
        }
        return style.theme.toLowerCase();
    };
    StyleManager.prototype.getThemeAsync = function (styleOptions) {
        return __awaiter$1(this, void 0, void 0, function () {
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._lookUpAsync(styleOptions)];
                    case 1: return [2 /*return*/, (_a.sent()).theme];
                }
            });
        });
    };
    /**
     * Replaces the style set used. Very costly as it reloads all controls and resources.
     */
    StyleManager.prototype.setMapConfiguration = function (mapConfiguration, styleName) {
        var _this = this;
        this.serviceOptions.mapConfiguration = mapConfiguration;
        if (typeof mapConfiguration === 'string') {
            this.initStyleset();
        }
        else {
            if (this.initPromise) {
                this.initPromise.hijackAndResolve(mapConfiguration);
            }
            else {
                this.initPromise = HijackablePromise.resolve(mapConfiguration);
            }
        }
        this.definitions().then(function (definitions) {
            var targetStyleName = definitions.defaultConfiguration;
            if (definitions.configurations.find(function (s) { return s.name === styleName; })) {
                targetStyleName = styleName;
            }
            _this.map.setStyle({ style: targetStyleName });
        });
    };
    StyleManager.prototype.getMapConfiguration = function () {
        return this.serviceOptions.mapConfiguration;
    };
    // backward-compatibility: this method preserves the interface that azure-maps-indoor@2.0.6 assumes
    StyleManager.prototype.setStyleSet = function (styleSet) {
        this.updateIndoorState(styleSet === 'indoor_dark' ? 'dark' : 'light', null);
    };
    // backward-compatibility: this method preserves the interface that azure-maps-indoor@2.0.6 assumes
    StyleManager.prototype.getStyleSet = function () {
        var legacyStyleset = this.indoorState !== undefined
            ? (this.indoorState.theme === 'dark' ? 'indoor_dark' : 'indoor')
            : 'base';
        return legacyStyleset;
    };
    // backward-compatibility: this method preserves the interface that azure-maps-indoor@2.0.6 assumes
    StyleManager.prototype.clearStyleSet = function () {
        this.unsetIndoorState();
    };
    StyleManager.prototype._buildFundamentalLayerFrom = function (layers, id) {
        if (layers && layers.length > 0) {
            var newLayer = new FundamentalMapLayer(layers, id);
            newLayer.onAdd(this.map);
            return newLayer;
        }
        throw new Error("Unable to construct fundamental map layer for ID: ".concat(id, "."));
    };
    /**
     * Replace URL placeholders and add StyleManager API version to requests made for style resources.
     * @param params RequestParameters to modify.
     * @returns Valid style RequestParameters.
     * @internal
     */
    StyleManager.prototype._transformStyleRequest = function (url, params) {
        var _a;
        if (url.includes(constants.domainPlaceHolder)) {
            params.url = params.url.replace(constants.domainPlaceHolder, this.serviceOptions.domain);
        }
        if (url.includes(constants.stylePathHolder)) {
            params.url = params.url.replace(constants.stylePathHolder, constants.stylePath);
        }
        if (url.includes(constants.styleResourcePlaceholder)) {
            params.url = params.url.replace(constants.styleResourcePlaceholder, constants.styleResourcePath);
        }
        if (params.url.toLocaleLowerCase().includes(this.serviceOptions.domain.toLocaleLowerCase()) ||
            params.url.toLocaleLowerCase().includes(this.serviceOptions.staticAssetsDomain.toLocaleLowerCase())) {
            // Only add API version param for Azure maps domain requests
            var targetUrl = new URL(params.url);
            if (!targetUrl.searchParams.get(constants.apiVersionQueryParameter)) {
                targetUrl.searchParams.set(constants.apiVersionQueryParameter, this.serviceOptions.styleAPIVersion);
                params.url = targetUrl.href;
            }
            (_a = this.map.authentication) === null || _a === void 0 ? void 0 : _a.signRequest(params);
            // Delete auth token for static assets to allow AFD caching
            this._deleteAuthTokenForStaticAssets(params);
        }
    };
    /**
     * Fetches a json resource at the specified domain and path.
     */
    StyleManager.prototype._request = function (domain, path, resourceType, customQueryParams) {
        var _a;
        if (customQueryParams === void 0) { customQueryParams = {}; }
        return __awaiter$1(this, void 0, void 0, function () {
            var requestParams, fetchOptions;
            var _b;
            return __generator$1(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        requestParams = {
                            url: new Url({
                                protocol: "https",
                                domain: domain,
                                path: path,
                                queryParams: __assign$1((_b = {}, _b[constants.apiVersionQueryParameter] = this.serviceOptions.styleAPIVersion, _b), customQueryParams)
                            }).toString()
                        };
                        if (typeof this.serviceOptions.transformRequest === "function" && resourceType) {
                            // If a transformRequest(...) was specified use it.
                            requestParams = this.serviceOptions.transformRequest(requestParams.url, resourceType);
                        }
                        (_a = this.map.authentication) === null || _a === void 0 ? void 0 : _a.signRequest(requestParams);
                        // Delete auth token for static assets to allow AFD caching
                        this._deleteAuthTokenForStaticAssets(requestParams);
                        fetchOptions = {
                            method: "GET",
                            mode: "cors",
                        };
                        requestParams.credentials &&
                            (fetchOptions.credentials = requestParams.credentials);
                        requestParams.headers &&
                            (fetchOptions.headers = requestParams.headers);
                        return [4 /*yield*/, fetch(requestParams.url, fetchOptions).then(function (response) {
                                if (response.ok) {
                                    return response.json();
                                }
                                else {
                                    throw new Error("HTTP ".concat(response.status, ": ").concat(response.statusText, " "));
                                }
                            })];
                    case 1: return [2 /*return*/, _c.sent()];
                }
            });
        });
    };
    /**
     * Delete auth token for static assets to allow AFD caching.
     */
    StyleManager.prototype._deleteAuthTokenForStaticAssets = function (params) {
        // The following resources are considered as static assets.
        // StyleSet    /styling/styles
        // Style       /styling/styles/*
        // Thumbnail   /styling/styles/*/thumbnail.png
        // Sprite PNG  /styling/sprites/*/sprite@2x.png
        // Sprite JSON /styling/sprites/*/sprite@2x.json
        // Glyph       /styling/glyphs/*/0-255.pbf
        if (params.url.startsWith("https://".concat(this.serviceOptions.staticAssetsDomain, "/").concat(constants.stylePath))) {
            delete params.headers[constants.msClientIdHeaderName];
            delete params.headers[constants.authorizationHeaderName];
        }
    };
    return StyleManager;
}());

/**
 * @private
 */
var isHMREnabled = function () { return 'ENVIRONMENT' in window && !!window['ENVIRONMENT']['hmr']; };

var __values$1 = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * @internal
 * A manager for the map control's hidden indicators.
 * Exposed through the `indicators` property of the `atlas.Map` class.
 * Cannot be instantiated by the user.
 */
var AccessibleIndicatorManager = /** @class */ (function () {
    /**
     * Constructs the indicator manager to be exposed only through the `indicators` property of the `Map` class.
     * @param map The map whose indicators are being managed by this.
     * @internal
     */
    function AccessibleIndicatorManager(map) {
        this.map = map;
        this.indicators = new Set();
    }
    /**
     * Adds an indicator to the map
     * @param indicator The indicator(s) to add.
     */
    AccessibleIndicatorManager.prototype.add = function (indicator) {
        var e_1, _a;
        indicator = Array.isArray(indicator) ? indicator : [indicator];
        try {
            for (var indicator_1 = __values$1(indicator), indicator_1_1 = indicator_1.next(); !indicator_1_1.done; indicator_1_1 = indicator_1.next()) {
                var i = indicator_1_1.value;
                if (!this.indicators.has(i)) {
                    this.indicators.add(i);
                    i.attach(this.map);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (indicator_1_1 && !indicator_1_1.done && (_a = indicator_1.return)) _a.call(indicator_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * Removes all indicators from the map.
     */
    AccessibleIndicatorManager.prototype.clear = function () {
        var _this = this;
        this.indicators.forEach(function (indicator) {
            _this.indicators.delete(indicator);
            indicator.remove();
        });
    };
    /**
     * Removes an indicator from the map
     * @param indicator The indicator(s) to remove.
     */
    AccessibleIndicatorManager.prototype.remove = function (indicator) {
        var e_2, _a;
        indicator = Array.isArray(indicator) ? indicator : [indicator];
        try {
            for (var indicator_2 = __values$1(indicator), indicator_2_1 = indicator_2.next(); !indicator_2_1.done; indicator_2_1 = indicator_2.next()) {
                var i = indicator_2_1.value;
                if (this.indicators.has(i)) {
                    this.indicators.delete(i);
                    i.remove();
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (indicator_2_1 && !indicator_2_1.done && (_a = indicator_2.return)) _a.call(indicator_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    /**
     * Returns the indicators currently attached to the map.
     */
    AccessibleIndicatorManager.prototype.getIndicators = function () {
        return Array.from(this.indicators);
    };
    /**
     * Returns the div element that should contain all the indicator containers.
     * Creates it if it doesn't already exist.
     * @internal
     */
    AccessibleIndicatorManager.prototype._getCollectionDiv = function () {
        var collection = this.map.getMapContainer()
            .querySelector(".".concat(AccessibleIndicatorManager.Css.collection));
        if (!collection) {
            // If the collection div doesn't exist create it.
            collection = document.createElement("div");
            collection.setAttribute("aria-label", "map data");
            // Set the container role to listbox, and the descents' role to option, so the reader will read the listbox as a list.
            // For example, NVDA will read "data point, 1 of 1" when the indicator is focused.
            collection.setAttribute("role", "listbox");
            collection.classList.add(AccessibleIndicatorManager.Css.collection);
            this.map.getMapContainer().appendChild(collection);
        }
        return collection;
    };
    AccessibleIndicatorManager.Css = {
        collection: "accessible-indicator-collection-container"
    };
    return AccessibleIndicatorManager;
}());

var __extends = (window && window.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (window && window.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (window && window.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (window && window.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read$1 = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray$1 = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (window && window.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
/**
 * The control for a visual and interactive web map.
 */
var Map$1 = /** @class */ (function (_super) {
    __extends(Map, _super);
    /**
     * Displays a map in the specified container.
     * @param container The id of the element where the map should be displayed.
     * @param options Options for the initial display and interactability with the map.
     */
    function Map(container, options) {
        var _this = _super.call(this) || this;
        // Map state trackers
        _this.removed = false;
        _this.loaded = false;
        _this.ready = false;
        /**
         * The callback used when styleOptions.autoResize is true.
         */
        _this._resizeCallback = function () { return _this.resize(); };
        var successfulLoad = true;
        // Update global defaults based on which options were specified to this constructor.
        _this._updateGlobalDefaults(options);
        _this.serviceOptions = new ServiceOptions().merge(options);
        _this.styleOptions = new StyleOptions().merge(options);
        _this.trafficOptions = new TrafficOptions();
        _this.styles = new StyleManager(_this, _this.serviceOptions);
        {
            _this.insights = new Insights(_this.serviceOptions);
        }
        if (_this.serviceOptions.authOptions.subscriptionKey) {
            _this.serviceOptions.authOptions.subscriptionKey = encodeURIComponent(_this.serviceOptions.authOptions.subscriptionKey);
        }
        // If a client id is available use that for telemetry, fallback to subscription key if necessary.
        // Only keep the last 3 characters of the subscription key.
        var accountId;
        if (_this.serviceOptions.authOptions.clientId) {
            accountId = _this.serviceOptions.authOptions.clientId;
        }
        else if (_this.serviceOptions.authOptions.subscriptionKey) {
            accountId = _this.serviceOptions.authOptions.subscriptionKey.replace(/.(?=.{3,}$)/g, "*");
        }
        else {
            accountId = "invalid-setting";
        }
        if (_this.insights) {
            _this.insights.setAuthenticatedUserContext(_this.serviceOptions.sessionId, accountId);
        }
        var mapboxMap;
        if (arguments[2] && isHMREnabled()) {
            mapboxMap = arguments[2];
            _this.ready = true;
            _this.loaded = true;
        }
        else {
            var mapboxMapOptions = {
                antialias: _this.styleOptions.antialias,
                attributionControl: false,
                container: container,
                fadeDuration: _this.serviceOptions.fadeDuration,
                localIdeographFontFamily: _this.serviceOptions.localIdeographFontFamily,
                preserveDrawingBuffer: _this.styleOptions.preserveDrawingBuffer,
                refreshExpiredTiles: _this.serviceOptions.refreshExpiredTiles,
                renderWorldCopies: _this.styleOptions.renderWorldCopies,
                trackResize: false,
                transformRequest: function (url, resourceType) {
                    var requestParams = {
                        url: url
                    };
                    if (resourceType === "Tile" || resourceType === "Source") {
                        // Note: if url includes legacyDomainPlaceHolder it will also include domainPlaceHolder
                        //                       {azMapsDomain}                               {{azMapsDomain}}
                        if (url.includes(constants.legacyDomainPlaceHolder) && _this.insights) {
                            _this.insights.trackEvent({ name: "TileLoad" });
                        }
                        _this._substituteDomainLanguageViewAndSignInRequest(url, requestParams);
                    }
                    else if (resourceType === "Style" || resourceType === "SpriteJSON" || resourceType === "SpriteImage" || resourceType === "Glyphs") {
                        _this.styles._transformStyleRequest(url, requestParams);
                    }
                    // Apply the users specified transform after ours
                    if (_this.serviceOptions.transformRequest) {
                        merge$1(requestParams, _this.serviceOptions.transformRequest(requestParams.url, resourceType));
                    }
                    // TODO: fix type variation
                    return requestParams;
                }
            };
            mapboxMap = new maplibregl.Map(mapboxMapOptions);
        }
        try {
            _this.map = mapboxMap;
            // Initialize managers
            {
                _this.authentication = new AuthenticationManager(_this);
            }
            _this.controls = new ControlManager(_this);
            _this.events = new EventManager(_this);
            _this.imageSprite = new ImageSpriteManager(_this);
            _this.layers = new LayerManager(_this);
            _this.markers = new HtmlMarkerManager(_this);
            _this.sources = new SourceManager(_this);
            _this.popups = new PopupManager(_this);
            _this.indicators = new AccessibleIndicatorManager(_this);
            // Add CSS classes and set attributes for DOM elements.
            _this.map.getContainer().classList.add(Map.Css.container);
            _this.map.getCanvasContainer().classList.add(Map.Css.canvasContainer);
            _this.map.getCanvas().classList.add(Map.Css.canvas);
            _this._detectHighContrast();
            // Always add the copyright label.
            _this.copyrightControl = new CopyrightControl({
                showFeedbackLink: _this.styleOptions.showFeedbackLink,
                showLogo: _this.styleOptions.showLogo,
                customAttribution: _this.styleOptions.customAttribution
            });
            _this.controls.add(_this.copyrightControl, {
                position: ControlPosition.NonFixed
            });
            // Add logo control to occupy the bottom left corner of the map.
            _this.logoControl = new LogoControl({
                showLogo: _this.styleOptions.showLogo
            });
            _this.controls.add(_this.logoControl, {
                position: ControlPosition.BottomLeft
            });
            // Initialize state of map
            // --> Initialize the authentication manager
            var authManInit = _this.authentication ?
                _this.authentication.initialize() : Promise.resolve();
            if (_this.removed) {
                return _this;
            }
            // --> Track if the map has completed its first load
            var setLoaded_1 = function () {
                _this.loaded = true;
                _this.map.off("load", setLoaded_1);
            };
            _this.map.on("load", setLoaded_1);
            // --> Track if the map has set its initial style
            var setReady_1 = function () {
                _this.ready = true;
                _this.map.off("styledata", setReady_1);
                // Manually invoke the ready event the first time styledata fires.
                var readyData = { map: _this, type: "ready" };
                _this.events.invoke("ready", readyData);
            };
            _this.map.on("styledata", setReady_1);
            // --> Set initial style including downloading style definitions and restyle map
            _this._setAutoResize(_this.styleOptions.autoResize);
            _this.map.showTileBoundaries = _this.styleOptions.showTileBoundaries;
            _this.localizedStringsPromise = Localizer.getStrings(_this.styleOptions.language);
            authManInit
                // reuses this.styles.initPromise if initStyleset is already called
                .then(function () { return _this.styles.definitions(); })
                .then(function (definitions) {
                // Check that the map hasn't been removed for any reason.
                // If so no need to finish styling the map.
                if (_this.removed) {
                    return;
                }
                if (_this.authentication && !_this.authentication.getToken()) {
                    throw new Error("AuthenticationManager finished initializing, but no token is available");
                }
                // Add the accessibility delegate to the map here
                // so that the auth mechanism is setup before any calls are made.
                if (_this.serviceOptions["enable-accessibility"]) {
                    _this.accessibleMapDelegate.addToMap();
                }
                _this._setStyleComponents(_this.styleOptions);
                _this.copyrightDelegate && _this.copyrightDelegate.addToMap();
            }).catch(function (reason) {
                var error = reason instanceof Error ? reason : new Error(reason);
                {
                    _this.insights.trackException({ error: error });
                }
                // Invoke the error event to report any errors initializing the styles or auth.
                var errorData = {
                    map: _this,
                    type: "error",
                    error: error
                };
                _this.events.invoke("error", errorData);
            });
            // --> Set initial camera state of map
            _this.setCamera(__assign(__assign({ 
                // Default minZoom to ensure the map doesn't zoom out to unsupported zoom levels.
                minZoom: 1 }, options), { type: "jump", duration: 0 }));
            // Add delegates to map
            {
                _this.incidentDelegate = new IncidentServiceDelegate(_this);
            }
            _this.flowDelegate = new FlowServiceDelegate(_this);
            _this.accessibleMapDelegate = new AccessibleMapDelegate(_this);
            _this.userInteractionDelegate = new UserInteractionDelegate(_this, options);
            _this.userInteractionDelegate.addToMap();
            {
                _this.copyrightDelegate = new CopyrightDelegate(_this, _this.copyrightControl, _this.styleOptions);
            }
        }
        catch (err) {
            successfulLoad = false;
            {
                _this.insights.trackException({ error: err instanceof Error ? err : new Error(err) });
            }
            throw err;
        }
        finally {
            // Track the successful session load
            {
                _this.insights.trackEvent({ name: "MapLoad" }, {
                    success: successfulLoad,
                    supported: supported(),
                    supportedWithPerformance: supported({ failIfMajorPerformanceCaveat: true })
                });
                _this.insights.flush();
            }
        }
        return _this;
    }
    Object.defineProperty(Map.prototype, "isDisposed", {
        /**
         * Returns true if the map has been disposed.
         */
        get: function () {
            return this.removed;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Returns the HTMLCanvasElement that the map is drawn to.
     */
    Map.prototype.getCanvas = function () {
        return this.map.getCanvas();
    };
    /**
     * Returns the HTMLElement that contains the map's HTMLCanvasElement. The map's events (e.g. panning and zooming)
     * are attached to this element.
     */
    Map.prototype.getCanvasContainer = function () {
        return this.map.getCanvasContainer();
    };
    /**
     * Returns the HTMLElement that contains the map.
     */
    Map.prototype.getMapContainer = function () {
        return this.map.getContainer();
    };
    /**
     * Returns the service options with which the map control was initialized.
     */
    Map.prototype.getServiceOptions = function () {
        return cloneDeepWith$1(this.serviceOptions, ServiceOptions._cloneCustomizer);
    };
    /**
     * Set the service options.
     */
    Map.prototype.setServiceOptions = function (options) {
        this.serviceOptions = new ServiceOptions().merge(this.serviceOptions, options);
        if (this.serviceOptions["enable-accessibility"]) {
            this.accessibleMapDelegate.addToMap();
        }
        else {
            this.accessibleMapDelegate.removeFromMap();
        }
        var shouldReloadStyle = this.styles.serviceOptions.mapConfiguration !== this.serviceOptions.mapConfiguration
            || this.styles.serviceOptions.staticAssetsDomain !== this.serviceOptions.staticAssetsDomain
            || this.styles.serviceOptions.styleDefinitionsVersion !== this.serviceOptions.styleDefinitionsVersion
            || this.styles.serviceOptions.domain !== this.serviceOptions.domain
            || this.styles.serviceOptions.styleAPIVersion !== this.serviceOptions.styleAPIVersion;
        // NOTE: only perform a reload when the style dependent properties are changed
        //|| this.styles.serviceOptions.validateStyle !== this.serviceOptions.validateStyle
        //|| this.styles.serviceOptions.transformRequest !== this.serviceOptions.transformRequest
        this.styles.serviceOptions = this.serviceOptions;
        if (shouldReloadStyle) {
            this.styles.initPromise = null;
            this.setStyle({});
        }
    };
    /**
     * Adds request transformer
     * @param transformer provides custom request parameters for loading a tile.
     */
    Map.prototype.addRequestTransformer = function (transformer) { this.serviceOptions.addTransformer(transformer); };
    /**
     * Removes request transformer
     * @param transformer transformer to remove (provides custom request parameters for loading a tile)
     */
    Map.prototype.removeRequestTransformer = function (transformer) { this.serviceOptions.removeTransformer(transformer); };
    Map.prototype.setCamera = function (options, fromControl) {
        var _a;
        if (fromControl === void 0) { fromControl = false; }
        var mapboxCameraOptions;
        var maxBounds;
        // Test between CameraOptions and CameraBoundsOptions
        if ("padding" in options || "offset" in options || "bounds" in options) {
            var cameraBoundsOptions = new CameraBoundsOptions()
                .merge({ maxZoom: this.getCamera().maxZoom }, options);
            var bounds = this._generateSafeBounds(cameraBoundsOptions.bounds);
            var cameraForBoundsOptions = {
                padding: cameraBoundsOptions.padding,
                offset: cameraBoundsOptions.offset,
                maxZoom: cameraBoundsOptions.maxZoom
            };
            mapboxCameraOptions = this.map.cameraForBounds(bounds, cameraForBoundsOptions);
            if (!mapboxCameraOptions) {
                var currentContainer = (_a = this.map) === null || _a === void 0 ? void 0 : _a.getContainer();
                var errorDetails = {
                    message: "The map cannot be fit to the current canvas with the given CameraBoundsOptions.",
                    containerWidth: currentContainer === null || currentContainer === void 0 ? void 0 : currentContainer.clientWidth,
                    containerHeight: currentContainer === null || currentContainer === void 0 ? void 0 : currentContainer.clientHeight,
                    safeBounds: bounds,
                    cameraForBoundsOptions: cameraForBoundsOptions
                };
                throw new Error(JSON.stringify(errorDetails));
            }
            if ('pitch' in options) {
                mapboxCameraOptions.pitch = options.pitch;
            }
            if ('bearing' in options) {
                mapboxCameraOptions.bearing = options.bearing;
            }
            if ('minPitch' in options) {
                this.map.setMinPitch(options.minPitch);
            }
            if ('maxPitch' in options) {
                this.map.setMaxPitch(options.maxPitch);
            }
            if ('minZoom' in options) {
                this.map.setMinZoom(options.minZoom);
            }
            maxBounds = this._generateSafeBounds(cameraBoundsOptions.maxBounds);
        }
        else {
            var cameraOptions = new CameraOptions().merge(this.getCamera(), options);
            // adjust for center offset
            if (cameraOptions.centerOffset && cameraOptions.centerOffset.length >= 2) {
                var centerOffset = cameraOptions.centerOffset;
                // Calculate a new center which accounts for the offset at the specified zoom level.
                var p = mercatorPositionsToPixels([cameraOptions.center], cameraOptions.zoom);
                p[0][0] += centerOffset[0];
                p[0][1] += centerOffset[1];
                cameraOptions.center = mercatorPixelsToPositions(p, cameraOptions.zoom)[0];
            }
            mapboxCameraOptions = {
                center: cameraOptions.center,
                zoom: cameraOptions.zoom,
                bearing: cameraOptions.bearing,
                pitch: cameraOptions.pitch,
                around: undefined
            };
            if (cameraOptions.minZoom < 1) {
                console.warn("Setting minZoom below 1 may result in an empty map when the zoom level is less than 1.");
            }
            this.map.setMinZoom(cameraOptions.minZoom);
            this.map.setMaxZoom(cameraOptions.maxZoom);
            if (cameraOptions.minPitch) {
                this.map.setMinPitch(cameraOptions.minPitch);
            }
            if (cameraOptions.maxPitch) {
                this.map.setMaxPitch(cameraOptions.maxPitch);
            }
            this._invokeEvent("minzoomchanged", this.map.getMinZoom());
            this._invokeEvent("maxzoomchanged", this.map.getMaxZoom());
            maxBounds = this._generateSafeBounds(cameraOptions.maxBounds);
        }
        // set maxBounds. maxBounds will be removed if null or undefined is provided.
        if (maxBounds) {
            this.map.setMaxBounds(maxBounds);
        }
        else {
            this.map.setMaxBounds(null);
        }
        var animOptions = new AnimationOptions().merge(options);
        var mapboxAnimationOptions = {
            duration: animOptions.duration,
            easing: function (t) { return t; },
            offset: [0, 0],
            animate: true
        };
        // Supply event data regarding if a control caused this camera change.
        var eventData = { fromControl: fromControl };
        if (animOptions.type === "jump") {
            this.map.jumpTo(mapboxCameraOptions, eventData);
        }
        else if (animOptions.type === "ease") {
            this.map.easeTo(__assign(__assign({}, mapboxCameraOptions), mapboxAnimationOptions), eventData);
        }
        else if (animOptions.type === "fly") {
            this.map.flyTo(__assign(__assign({}, mapboxCameraOptions), mapboxAnimationOptions), eventData);
        }
    };
    /**
     * Set the camera bounds of the map control.
     * @param options The options for setting the map's camera bounds.
     * @deprecated recommend setCamera.
     */
    Map.prototype.setCameraBounds = function (options) {
        this.setCamera(options);
    };
    /**
     * Returns the camera's current properties.
     */
    Map.prototype.getCamera = function () {
        var _a;
        var southWest = this.map.getBounds().getSouthWest().toArray();
        var northEast = this.map.getBounds().getNorthEast().toArray();
        var cameraOptions = {
            zoom: this.map.getZoom(),
            center: this.map.getCenter().toArray(),
            bearing: this.map.getBearing(),
            pitch: this.map.getPitch(),
            bounds: new BoundingBox(southWest, northEast),
            minZoom: this.map.getMinZoom(),
            maxZoom: this.map.getMaxZoom(),
            maxBounds: (_a = this.map.getMaxBounds()) === null || _a === void 0 ? void 0 : _a.toArray().flat(),
        };
        return cameraOptions;
    };
    /**
     * Set the map control's style options. Any options not specified will default to their current values.
     * @param options The options for setting the style of the map control.
     * @param diff [true] If false, forces a 'full' style update, removing the current style and building the given one instead of attempting a diff-based update. Defaults to true.
     */
    Map.prototype.setStyle = function (options, diff) {
        if (diff === void 0) { diff = true; }
        // This option may only be set when initializing the map.
        // The delete operation will handle non-exist property.
        delete options.preserveDrawingBuffer;
        var newOptions = new StyleOptions().merge(this.styleOptions, options);
        // Add or remove the autoResize listener if needed.
        if (newOptions.autoResize !== this.styleOptions.autoResize) {
            this._setAutoResize(newOptions.autoResize);
        }
        // Update the localized strings promise if needed.
        if (newOptions.language !== this.styleOptions.language) {
            this.localizedStringsPromise = Localizer.getStrings(newOptions.language);
        }
        // Update rendering of world copies if needed.
        if (newOptions.renderWorldCopies !== this.styleOptions.renderWorldCopies) {
            this.map.setRenderWorldCopies(newOptions.renderWorldCopies);
        }
        // Add or remove the feedback link if needed.
        if (newOptions.showFeedbackLink !== this.styleOptions.showFeedbackLink) {
            this.copyrightControl.setOptions({ showFeedbackLink: newOptions.showFeedbackLink });
        }
        // Add or remove custom attribution if needed
        if (newOptions.customAttribution !== this.styleOptions.customAttribution) {
            this.copyrightControl.setOptions({ customAttribution: newOptions.customAttribution });
        }
        // Add or remove the logo if needed.
        if (newOptions.showLogo !== this.styleOptions.showLogo) {
            this.copyrightControl.setOptions({ showLogo: newOptions.showLogo });
            this.logoControl.setOptions({ showLogo: newOptions.showLogo });
        }
        // Update showing tile boundaries if needed.
        if (newOptions.showTileBoundaries !== this.styleOptions.showTileBoundaries) {
            this.map.showTileBoundaries = newOptions.showTileBoundaries;
        }
        if (newOptions.showBuildingModels) {
            console.warn("showBuildingModels is deprecated.");
        }
        // Some delegates may rely on a styledata event to know when to check if the language changes.
        // If this function is restructured such that a styledata event won't always trigger
        // if the language is changed, then either those delegates need changed
        // or the styledata event manually invoked.
        var noDiffOnLanguageViewChange = diff && (this.styleOptions.language === newOptions.language && this.styleOptions.view === newOptions.view);
        this.styleOptions = newOptions;
        this._setStyleComponents(newOptions, noDiffOnLanguageViewChange);
    };
    /**
     * Returns the map control's current style settings.
     */
    Map.prototype.getStyle = function () {
        return cloneDeep$1(this.styleOptions);
    };
    /**
     * Add an icon to the map to use for pins.
     * Map must be ready and the image must be fully loaded before the icon can be added.
     * Use the events.add method with event type 'ready'.
     * @param id The identifier of the icon.
     * @param icon The icon image.
     * @deprecated Use map.imageSprite.add instead.
     */
    Map.prototype.addIcon = function (id, icon) {
        this.imageSprite.add(id, icon);
    };
    /**
     * Add a collection of points to a layer of the map as pins. The layer and its options can be specified through a
     * PinLayerOptions object. Options for the layer can
     * only be specified upon the layer's initial creation. Map must be ready before the pins can be added. Use
     * the events.add method with event type 'ready'.
     * @param pins The points to add.
     * @param options The layer options for the pins.
     * @deprecated Use atlas.layer.SymbolLayer instead.
     */
    Map.prototype.addPins = function (pins, options) {
        var layerOptions = new PinLayerOptions().merge(options);
        var layer = this.layers.getLayerById(layerOptions.name);
        // If a layer with the specified layer name doesn't exist create one.
        var newLayer = false;
        if (!layer) {
            newLayer = true;
            layer = new SymbolLayer("".concat(layerOptions.name, "-source"), layerOptions.name, {
                source: "".concat(layerOptions.name, "-source"),
                minZoom: layerOptions.minZoom,
                maxZoom: layerOptions.maxZoom,
                iconOptions: {
                    anchor: "center",
                    size: layerOptions.iconSize,
                    image: ["case",
                        ["has", "icon"], ["get", "icon"],
                        layerOptions.icon
                    ],
                    ignorePlacement: !layerOptions.cluster,
                    opacity: layerOptions.opacity
                },
                textOptions: {
                    anchor: "center",
                    textField: ["case",
                        ["has", "point_count"], ["to-string", ["get", "point_count"]],
                        ["has", "title"], ["to-string", ["get", "title"]],
                        layerOptions.title
                    ],
                    font: ["case",
                        ["has", "point_count"], ["literal", ["StandardFontCondensed-Bold"]],
                        ["literal", [layerOptions.textFont]]
                    ],
                    size: ["case",
                        ["has", "point_count"], 20,
                        layerOptions.fontSize
                    ],
                    ignorePlacement: !layerOptions.cluster,
                    opacity: layerOptions.opacity,
                    offset: ["case",
                        ["has", "point_count"], ["literal", [0.50, -0.45]],
                        ["literal", [layerOptions.textOffset[0] / 16, layerOptions.textOffset[1] / 16]]
                    ],
                    color: layerOptions.fontColor
                }
            });
        }
        // Check that the layer with the specified layer name is the correct type of layer.
        if (!(layer instanceof SymbolLayer)) {
            throw new Error("A layer with name '".concat(layerOptions.name, "' already exists but it is not a SymbolLayer.") +
                "A SymbolLayer should be used for rendering pins.");
        }
        var sourceId;
        var source = layer.getSource();
        if (typeof source === "string") {
            sourceId = source;
            source = this.sources.getById(sourceId);
        }
        else {
            sourceId = source.getId();
        }
        // If a source with the specified source name doesn't exist create one.
        var newSource = false;
        if (!source) {
            newSource = true;
            source = new DataSource(sourceId, {
                cluster: layerOptions.cluster
            });
        }
        // Check that the source with the specified source name is the correct type of source.
        if (!(source instanceof DataSource)) {
            throw new Error("The source with name '".concat(sourceId, "' already exists but it is not a DataSource.") +
                "New data can only be added to a DataSource.");
        }
        // If a new source was created add it to the source manager.
        // Add the source before adding any GeoJSON data to it.
        if (newSource) {
            this.sources.add(source);
        }
        // If a new layer was created add it to the layer manager.
        if (newLayer) {
            this.layers.add(layer, layerOptions.before);
        }
        // Add the circles to the source.
        var pinCollection = new FeatureCollection(pins);
        if (layerOptions.overwrite) {
            source.setShapes(pinCollection);
        }
        else {
            source.add(pinCollection);
        }
    };
    /**
     * Add a collection of points to a layer of the map as circles. The layer and its options can be specified through a
     * CircleLayerOptions object. Options for the layer
     * can only be specified upon the layer's initial creation. Map must be ready before the circles can be
     * added. Use the events.add method with event type 'ready'.
     * @param circles The circles to add.
     * @param options The layer options for the circles.
     * @deprecated Use atlas.layer.BubbleLayer instead.
     */
    Map.prototype.addCircles = function (circles, options) {
        var layerOptions = new CircleLayerOptions().merge(options);
        var layer = this.layers.getLayerById(layerOptions.name);
        // If a layer with the specified layer name doesn't exist create one.
        var newLayer = false;
        if (!layer) {
            newLayer = true;
            layer = new BubbleLayer("".concat(layerOptions.name, "-source"), layerOptions.name, {
                source: "".concat(layerOptions.name, "-source"),
                minZoom: layerOptions.minZoom,
                maxZoom: layerOptions.maxZoom,
                opacity: layerOptions.opacity,
                radius: ["case",
                    ["has", "radius"], ["get", "radius"],
                    layerOptions.radius
                ],
                color: ["case",
                    ["has", "color"], ["get", "color"],
                    layerOptions.color
                ],
                strokeColor: ["case",
                    ["has", "outlineColor"], ["get", "outlineColor"],
                    layerOptions.outlineColor
                ],
                strokeWidth: ["case",
                    ["has", "outlineWidth"], ["get", "outlineWidth"],
                    layerOptions.outlineWidth
                ]
            });
        }
        // Check that the layer with the specified layer name is the correct type of layer.
        if (!(layer instanceof BubbleLayer)) {
            throw new Error("A layer with name '".concat(layerOptions.name, "' already exists but it is not a BubbleLayer.") +
                "A BubbleLayer should be used for rendering circles.");
        }
        var sourceId;
        var source = layer.getSource();
        if (typeof source === "string") {
            sourceId = source;
            source = this.sources.getById(sourceId);
        }
        else {
            sourceId = source.getId();
        }
        // If a source with the specified source name doesn't exist create one.
        var newSource = false;
        if (!source) {
            newSource = true;
            source = new DataSource(sourceId);
        }
        // Check that the source with the specified source name is the correct type of source.
        if (!(source instanceof DataSource)) {
            throw new Error("The source with name '".concat(sourceId, "' already exists but it is not a DataSource.") +
                "New data can only be added to a DataSource.");
        }
        // If a new source was created add it to the source manager.
        // Add the source before adding any GeoJSON data to it.
        if (newSource) {
            this.sources.add(source);
        }
        // If a new layer was created add it to the layer manager.
        if (newLayer) {
            this.layers.add(layer, layerOptions.before);
        }
        // Add the circles to the source.
        var circleCollection = new FeatureCollection(circles);
        if (layerOptions.overwrite) {
            source.setShapes(circleCollection);
        }
        else {
            source.add(circleCollection);
        }
    };
    /**
     * Add a collection of linestrings to a layer of the map. The layer and its options can be specified through a
     * LinestringLayerOptions object. Options for
     * the layer can only be specified upon the layer's initial creation. Map must be ready before the
     * linestrings can be added. Use the events.add method with event type 'ready'.
     * @param linestrings The linestrings to add.
     * @param options The layer options for the linestrings.
     * @deprecated Use atlas.layer.LineLayer instead.
     */
    Map.prototype.addLinestrings = function (linestrings, options) {
        var layerOptions = new LinestringLayerOptions().merge(options);
        var layer = this.layers.getLayerById(layerOptions.name);
        // If a layer with the specified layer name doesn't exist create one.
        var newLayer = false;
        if (!layer) {
            newLayer = true;
            layer = new LineLayer("".concat(layerOptions.name, "-source"), layerOptions.name, {
                source: "".concat(layerOptions.name, "-source"),
                minZoom: layerOptions.minZoom,
                maxZoom: layerOptions.maxZoom,
                lineCap: layerOptions.cap,
                lineJoin: layerOptions.join,
                strokeOpacity: layerOptions.opacity,
                strokeColor: ["case",
                    ["has", "color"], ["get", "color"],
                    layerOptions.color
                ],
                strokeWidth: ["case",
                    ["has", "width"], ["get", "width"],
                    layerOptions.width
                ]
            });
        }
        // Check that the layer with the specified layer name is the correct type of layer.
        if (!(layer instanceof LineLayer)) {
            throw new Error("A layer with name '".concat(layerOptions.name, "' already exists but it is not a LineLayer.") +
                "A LineLayer should be used for rendering linestrings.");
        }
        var sourceId;
        var source = layer.getSource();
        if (typeof source === "string") {
            sourceId = source;
            source = this.sources.getById(sourceId);
        }
        else {
            sourceId = source.getId();
        }
        // If a source with the specified source name doesn't exist create one.
        var newSource = false;
        if (!source) {
            newSource = true;
            source = new DataSource(sourceId);
        }
        // Check that the source with the specified source name is the correct type of source.
        if (!(source instanceof DataSource)) {
            throw new Error("The source with name '".concat(sourceId, "' already exists but it is not a DataSource.") +
                "New data can only be added to a DataSource.");
        }
        // If a new source was created add it to the source manager.
        // Add the source before adding any GeoJSON data to it.
        if (newSource) {
            this.sources.add(source);
        }
        // If a new layer was created add it to the layer manager.
        if (newLayer) {
            this.layers.add(layer, layerOptions.before);
        }
        // Add the circles to the source.
        var lineCollection = new FeatureCollection(linestrings);
        if (layerOptions.overwrite) {
            source.setShapes(lineCollection);
        }
        else {
            source.add(lineCollection);
        }
    };
    /**
     * Add a collection of polygons to a layer of the map. The layer and its options can be specified through a
     * PolygonLayerOptions object. Options for
     * the layer can only be specified upon the layer's initial creation. Map must be ready before the polygons
     * can be added. Use the events.add method with event type 'ready'.
     * @param polygons The polygons to add.
     * @param options The layer options for the polygons.
     * @deprecated Use atlas.layer.PolygonLayer instead.
     */
    Map.prototype.addPolygons = function (polygons, options) {
        var layerOptions = new PolygonLayerOptions().merge(options);
        var layer = this.layers.getLayerById(layerOptions.name);
        // If a layer with the specified layer name doesn't exist create one.
        var newLayer = false;
        if (!layer) {
            newLayer = true;
            layer = new PolygonLayer("".concat(layerOptions.name, "-source"), layerOptions.name, {
                source: "".concat(layerOptions.name, "-source"),
                minZoom: layerOptions.minZoom,
                maxZoom: layerOptions.maxZoom,
                fillOpacity: layerOptions.opacity,
                fillColor: ["case",
                    ["has", "color"], ["get", "color"],
                    layerOptions.color
                ]
            });
        }
        // Check that the layer with the specified layer name is the correct type of layer.
        if (!(layer instanceof PolygonLayer)) {
            throw new Error("A layer with name '".concat(layerOptions.name, "' already exists but it is not a PolygonLayer.") +
                "A PolygonLayer should be used for rendering linestrings.");
        }
        var sourceId;
        var source = layer.getSource();
        if (typeof source === "string") {
            sourceId = source;
            source = this.sources.getById(sourceId);
        }
        else {
            sourceId = source.getId();
        }
        // If a source with the specified source name doesn't exist create one.
        var newSource = false;
        if (!source) {
            newSource = true;
            source = new DataSource(sourceId);
        }
        // Check that the source with the specified source name is the correct type of source.
        if (!(source instanceof DataSource)) {
            throw new Error("The source with name '".concat(sourceId, "' already exists but it is not a DataSource.") +
                "New data can only be added to a DataSource.");
        }
        // If a new source was created add it to the source manager.
        // Add the source before adding any GeoJSON data to it.
        if (newSource) {
            this.sources.add(source);
        }
        // If a new layer was created add it to the layer manager.
        if (newLayer) {
            this.layers.add(layer, layerOptions.before);
        }
        // Add the circles to the source.
        var polygonCollection = new FeatureCollection(polygons);
        if (layerOptions.overwrite) {
            source.setShapes(polygonCollection);
        }
        else {
            source.add(polygonCollection);
        }
    };
    /**
     * Adds a raster layer to the map. The layer and its options can be specified through a
     * RasterLayerOptions object. Options for
     * the layer can only be specified upon the layer's initial creation.
     * @param tileSources  A list of endpoints specified as strings from which raster images can be requested. The
     * endpoints can be parameterized with the tags '{z}', '{x}' and '{y}' to specify the zoom, x-index, and y-index of
     * the needed tile respectively. The map control will request and place the tiles that are contained in the map's
     * viewport.
     * @param options The options for the raster layer.
     * @deprecated Use atlas.layer.TileLayer instead.
     */
    Map.prototype.addRaster = function (tileSources, options) {
        var layerOptions = new RasterLayerOptions().merge(options);
        var layer = this.layers.getLayerById(layerOptions.name);
        if (!layer) {
            layer = new TileLayer({
                maxZoom: layerOptions.maxZoom,
                minZoom: layerOptions.minZoom,
                opacity: layerOptions.opacity,
                tileSize: 256,
                tileUrl: "{subdomain}"
            }, layerOptions.name);
        }
        // Check that the layer with the specified layer name is the correct type of layer.
        if (!(layer instanceof TileLayer)) {
            throw new Error("A layer with name '".concat(layerOptions.name, "' already exists but it is not a TileLayer.") +
                "A TileLayer should be used for rendering raster images.");
        }
        // Multiple tile urls are made possible by the {subdomain} substitution
        // If a layer doesn't use "{subdomain}" as its tileUrl it must have be created with new TileLayer(...)
        // In that case throw an error.
        if (layer.getOptions().tileUrl !== "{subdomain}") {
            throw new Error("A TileLayer with name '".concat(layerOptions.name, "' already exists but was configured ") +
                "for a single tile url [default for new TileLayer(...)].");
        }
        // Get the new tile urls.
        var urls;
        if (layerOptions.overwrite) {
            urls = [];
        }
        else {
            urls = layer.getOptions().subdomains || [];
        }
        // Add the tile urls to the layer, but don't update the map yet.
        urls.push.apply(urls, __spreadArray$1([], __read$1(tileSources), false));
        layer._setOptionsNoUpdate({
            subdomains: urls
        });
        this.layers.add(layer, layerOptions.before);
    };
    /**
     * Returns a list of the map's layers from bottom to top.
     * @deprecated Use layers.getLayers() instead.
     */
    Map.prototype.getLayers = function () {
        return this.layers.getLayers().map(function (l) { return l.getId(); });
    };
    /**
     * Removes a collection of layers from the map.
     * For each layer if a source by the name of "<layerName>-source" exists it will be removed too.
     * @param layerNames An array of layer names to remove from the map.
     * @deprecated Use layers.remove instead.
     */
    Map.prototype.removeLayers = function (layerNames) {
        var e_1, _a;
        try {
            for (var layerNames_1 = __values(layerNames), layerNames_1_1 = layerNames_1.next(); !layerNames_1_1.done; layerNames_1_1 = layerNames_1.next()) {
                var layerName = layerNames_1_1.value;
                // Previously calling removeLayers for layers that didn't exist in the map just did nothing.
                // Now, LayerManager will throw an error, so we need to check if the layer exists before calling remove.
                if (this.layers.getLayerById(layerName)) {
                    this.layers.remove(layerName);
                    // Previously adding a layer also added a source with the name "<layerName>-source".
                    // Calling removeLayers would also remove that source, so we attempt to do this too.
                    var sourceName = "".concat(layerName, "-source");
                    if (this.sources.getById(sourceName)) {
                        this.sources.remove(sourceName);
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (layerNames_1_1 && !layerNames_1_1.done && (_a = layerNames_1.return)) _a.call(layerNames_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @deprecated recommend map.markers.add
     * Adds a custom HTMLElement to the map at a specified position.
     * @param element The HTMLElement to add.
     * @param position The position to place the element.
     */
    Map.prototype.addHtml = function (element, position) {
        if (!element.id) {
            element.id = "marker_".concat(uuid());
        }
        var marker = new HtmlMarker({
            htmlContent: element,
        });
        this.markers.add(marker, position);
        return element.id;
    };
    /**
     * @deprecated recommend map.markers.remove
     * Removes a custom HTMLElement from the map.
     * @param elementId The id of element to remove.
     */
    Map.prototype.removeHtml = function (elementId) {
        this.markers.remove(elementId);
    };
    Map.prototype.addEventListener = function (eventType, layerOrCallback, callback) {
        this.events._addLegacy(eventType, layerOrCallback, callback);
    };
    Map.prototype.removeEventListener = function (eventType, layerOrCallback, callback) {
        this.events._removeLegacy(eventType, layerOrCallback, callback);
    };
    /**
     * Set the map control's user interaction handlers. Any options not specified will default to their current values.
     * @param options The options for enabling/disabling the user interaction handlers.
     */
    Map.prototype.setUserInteraction = function (options) {
        this.userInteractionDelegate.setOptions(options);
    };
    /**
     * Return the map control's current user interaction handler settings.
     */
    Map.prototype.getUserInteraction = function () {
        return this.userInteractionDelegate.getOptions();
    };
    /**
     * Add a control to the map.
     * @param control The control to add.
     * @param options The options for the added control.
     * @deprecated Use map.controls.add instead.
     */
    Map.prototype.addControl = function (control, options) {
        this.controls.add(control, options);
    };
    /**
     * Remove a control from the map.
     * @param control The control to remove.
     * @deprecated Use map.controls.remove instead.
     */
    Map.prototype.removeControl = function (control) {
        this.controls.remove(control);
    };
    /**
     * Set the traffic options for the map. Any options not specified will default to their current values.
     * @param options The options for defining the map's traffic display.
     */
    Map.prototype.setTraffic = function (options) {
        var previousIncidentsOption = this.trafficOptions.incidents;
        var previousFlowOption = this.trafficOptions.flow;
        this.trafficOptions = new TrafficOptions().merge(this.trafficOptions, options);
        this.controls.getControls().filter(function (control) { return control instanceof TrafficControl; }).forEach(function (control) {
            return control.updateButtonState();
        });
        if (this.incidentDelegate) {
            if (this.trafficOptions.incidents) {
                if (!previousIncidentsOption) {
                    this.incidentDelegate.addToMap();
                }
            }
            else {
                this.incidentDelegate.removeFromMap();
            }
        }
        if (this.trafficOptions.flow && this.trafficOptions.flow !== "none") {
            if (["absolute", "relative-delay"].includes(this.trafficOptions.flow)) {
                console.warn("The 'absolute' and 'relative-delay' flow options are deprecated. Please use 'relative' instead.");
            }
            try {
                if (this.trafficOptions.flow !== previousFlowOption) {
                    this.flowDelegate.addToMap();
                }
            }
            catch (error) {
                this.trafficOptions.flow = previousFlowOption;
                throw error;
            }
        }
        else {
            this.flowDelegate.removeFromMap();
        }
    };
    /**
     * Return the map control's current traffic settings.
     */
    Map.prototype.getTraffic = function () {
        return cloneDeep$1(this.trafficOptions);
    };
    /**
     * Clean up the map's resources. Map will not function correctly after calling this method.
     * @deprecated use map.dispose()
     */
    Map.prototype.remove = function () {
        this.dispose();
    };
    /**
     * Removes all sources, layers, markers, and popups from the map.
     * User added images are preserved.
     */
    Map.prototype.clear = function () {
        // Clear the layers, sources, and marker via their managers.
        this.popups.clear();
        this.layers.clear();
        this.sources.clear();
        this.markers.clear();
        this.indicators.clear();
    };
    /**
     * Clean up the map's resources. Map will not function correctly after calling this method.
     */
    Map.prototype.dispose = function () {
        var _a, _b;
        this.clear();
        this.map.remove();
        (_a = this.authentication) === null || _a === void 0 ? void 0 : _a.dispose();
        this.removed = true;
        // Remove event listeners
        (_b = this.resizeObserver) === null || _b === void 0 ? void 0 : _b.disconnect();
        this.resizeObserver = null;
        while (this.getMapContainer().firstChild) {
            var currChild = this.getMapContainer().firstChild;
            this.getMapContainer().removeChild(currChild);
        }
    };
    Map.prototype.resize = function (heightOrData, width, eventData) {
        if ((typeof heightOrData === "number" || typeof heightOrData === "string") &&
            (typeof width === "number" || typeof width === "string")) {
            var height = heightOrData;
            this.getMapContainer().style.height = typeof height === "number" ? "".concat(height, "px") : height;
            this.getMapContainer().style.width = typeof width === "number" ? "".concat(width, "px") : width;
        }
        else {
            eventData = heightOrData;
        }
        // Occasionally, when resizing the window causes the map container to also resize, the canvas will re-resized
        // as if expecting a scroll bar to be drawn for the canvas container.
        // This leaves some whitespace gap on the bottom and right sides of the canvas.
        // No actual scrollbars will be shown.
        //
        // This is because the canvas container and map container are resized before the canvas,
        // so for a small fraction of time the canvas is bigger than its containers and a scroll bar would be required.
        //
        // To prevent this first the canvas container has overflow set to hidden.
        // This ensures that scroll bars would never be needed.
        // Then the Mapbox resize function is called, and the canvas should be the full, correct size.
        // Finally the canvas container has overflow set back to the original value.
        var oldOverflow = this.getMapContainer().style.overflow;
        this.getMapContainer().style.overflow = "hidden";
        this.map.resize(eventData);
        this.getMapContainer().style.overflow = oldOverflow;
    };
    /**
     * Converts an array of Pixel objects to an array of geographic Positions objects on the map.
     * @param pixels The pixels to be converted.
     */
    Map.prototype.pixelsToPositions = function (pixels) {
        var e_2, _a;
        var positions = [];
        try {
            for (var pixels_1 = __values(pixels), pixels_1_1 = pixels_1.next(); !pixels_1_1.done; pixels_1_1 = pixels_1.next()) {
                var pixel = pixels_1_1.value;
                var lngLat = this.map.unproject(pixel);
                positions.push(new Position(lngLat.lng, lngLat.lat));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (pixels_1_1 && !pixels_1_1.done && (_a = pixels_1.return)) _a.call(pixels_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return positions;
    };
    /**
     * Converts an array of Positions objects to an array of Pixel objects relative to the map container.
     * @param positions The positions to be converted.
     */
    Map.prototype.positionsToPixels = function (positions) {
        var e_3, _a;
        var pixels = [];
        try {
            for (var positions_1 = __values(positions), positions_1_1 = positions_1.next(); !positions_1_1.done; positions_1_1 = positions_1.next()) {
                var position = positions_1_1.value;
                var point = this.map.project(position);
                pixels.push(new Pixel(point.x, point.y));
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (positions_1_1 && !positions_1_1.done && (_a = positions_1.return)) _a.call(positions_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return pixels;
    };
    /**
     * Returns a boolean indicating if all tiles in the current viewport for all sources have loaded or not.
     */
    Map.prototype.areTilesLoaded = function () {
        return this.map.areTilesLoaded();
    };
    /**
     * Stops any animated transition that is currently underway.
     */
    Map.prototype.stop = function () {
        this.map.stop();
    };
    /**
     * Trigger the rendering of a single frame.
     * Use this method with WebGL layers to repaint the map when the layer's
     * properties or properties associated with the layer's source change.
     * Calling this multiple times before the next frame is rendered will still
     * result in only a single frame being rendered.
     */
    Map.prototype.triggerRepaint = function () {
        this.map.triggerRepaint();
    };
    /**
     * Loads a 3D terrain mesh, based on a "raster-dem" source.
     *
     * @param elevationSource elevation tile source
     * @param exaggeration the elevation exaggeration factor
     */
    Map.prototype.enableElevation = function (elevationSource, exaggeration) {
        this.map.setTerrain(typeof elevationSource === 'string' ? { source: elevationSource, exaggeration: exaggeration } : { source: elevationSource.getId(), exaggeration: exaggeration });
    };
    /**
     * Disables the 3D terrain mesh.
     */
    Map.prototype.disableElevation = function () {
        this.map.setTerrain(null);
    };
    /**
     * @internal
     */
    Map.prototype._getMap = function () {
        return this.map;
    };
    /**
     * @internal
     */
    Map.prototype._rebuildStyle = function (diff) {
        if (diff === void 0) { diff = true; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.styles.setStyle(this.styleOptions, diff);
                this.imageSprite._restoreImages();
                return [2 /*return*/];
            });
        });
    };
    /**
     * Returns true if the map has completed loading for the first time.
     * Will always return true after the initial load is completed.
     * @internal
     */
    Map.prototype._isLoaded = function () {
        return this.loaded;
    };
    /**
     * Returns true if the map has set its style for the first time.
     * Will always return true after the style has been set.
     * @internal
     */
    Map.prototype._isReady = function () {
        return this.ready;
    };
    /**
     * Returns a promise which will resolve to a collection of localized strings based on the map's current language.
     * @internal
     */
    Map.prototype._getLocalizedStrings = function () {
        return this.localizedStringsPromise;
    };
    /**
     * Sends a fetch request to the specified url with the specified headers.
     * Processes the request through transformRequest(...) first before sending.
     * @internal
     */
    Map.prototype._sendRequest = function (url, resourceType, headers) {
        var requestParams;
        if (typeof this.serviceOptions.transformRequest === "function") {
            // If a transformRequest(...) was specified use it.
            requestParams = this.serviceOptions.transformRequest(url, resourceType);
        }
        if (requestParams) {
            // Send the fetch using the transformed parameters.
            return fetch(requestParams.url || url, {
                credentials: requestParams.credentials,
                headers: __assign(__assign({}, headers), requestParams.headers),
                method: "GET",
                mode: "cors",
            });
        }
        else {
            // If not transformRequest has been supplied just make the request as specified.
            return fetch(url, {
                headers: headers,
                method: "GET",
                mode: "cors"
            });
        }
    };
    /**
     * replaces the domain, view and language placeholders and signs request as needed
     * @internal
     */
    Map.prototype._substituteDomainLanguageViewAndSignInRequest = function (url, requestParams) {
        var _a;
        if (url.includes(constants.legacyDomainPlaceHolder) || url.includes(constants.domainPlaceHolder)) {
            // Update legacy domain placeholder if found
            var isLegacy = new RegExp("[^{]".concat(constants.legacyDomainPlaceHolder, "[^}]"));
            if (url.match(isLegacy)) {
                requestParams.url = requestParams.url.replace(constants.legacyDomainPlaceHolder, constants.domainPlaceHolder);
            }
            if (Url.protoRegEx.test(this.serviceOptions.domain)) {
                // If the user specified domain includes a protocol replace that in the url too.
                var idx = requestParams.url.indexOf(constants.domainPlaceHolder);
                requestParams.url = this.serviceOptions.domain +
                    requestParams.url.substring(idx + constants.domainPlaceHolder.length);
            }
            else {
                // If the user specified domain doesn't include a protocol keep the original.
                requestParams.url = requestParams.url.replace(constants.domainPlaceHolder, this.serviceOptions.domain);
            }
        }
        if (requestParams.url.toLocaleLowerCase().includes(this.serviceOptions.domain.toLocaleLowerCase()) ||
            requestParams.url.toLocaleLowerCase().includes(this.serviceOptions.staticAssetsDomain.toLocaleLowerCase())) {
            (_a = this.authentication) === null || _a === void 0 ? void 0 : _a.signRequest(requestParams);
        }
        if (url.includes(constants.languagePlaceHolder)) {
            requestParams.url = requestParams.url.replace(constants.languagePlaceHolder, this.styleOptions.language);
        }
        if (url.includes(constants.viewPlaceHolder)) {
            requestParams.url = this.styleOptions.view ?
                requestParams.url.replace(constants.viewPlaceHolder, this.styleOptions.view) :
                requestParams.url.replace(constants.viewPlaceHolder, "").replace("&".concat(constants.viewParameter, "="), "");
        }
    };
    /**
     * Sets whether the map will automatically resize when the browser window resizes.
     * @private
     */
    Map.prototype._setAutoResize = function (autoResize) {
        if (autoResize) {
            if (!this.resizeObserver) {
                this.resizeObserver = new ResizeObserver(this._resizeCallback);
            }
            this.resizeObserver.observe(this.map.getContainer());
        }
        else {
            if (this.resizeObserver) {
                this.resizeObserver.unobserve(this.map.getContainer());
            }
        }
    };
    /**
     * Adds or replaces the relevant fundamental map components (layers and sources) based on the input options.
     * Removes sources and layers that aren't used by the new style or any remaining layers.
     * @private
     */
    Map.prototype._setStyleComponents = function (styleOptions, diff) {
        var _this = this;
        if (diff === void 0) { diff = true; }
        if (this.removed) {
            return;
        }
        var styleDefinitionPromise = this.styles.definitions();
        styleDefinitionPromise.then(function (mapConfiguration) {
            var e_4, _a;
            // a flag indicating if need to set this.styleOptions.style
            var needSetStyleOptionStyle = true;
            // Check if the default style is set by the client and if it exists in the current style set
            if (_this.styleOptions.style) {
                try {
                    for (var _b = __values(mapConfiguration.configurations), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var mapConfigurationStyle = _c.value;
                        if (_this.styleOptions.style === mapConfigurationStyle.name) {
                            needSetStyleOptionStyle = false;
                            break;
                        }
                    }
                }
                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_4) throw e_4.error; }
                }
            }
            if (needSetStyleOptionStyle) {
                // FIXME: this is very counter intuitive and unstable
                // see details: https://msazure.visualstudio.com/One/_workitems/edit/19409195
                _this.styleOptions.style = mapConfiguration.defaultConfiguration;
            }
            // it appears this line is overwriting everything done above
            // but "styleOptions" has actually been changed by line 1578.
            // NEED BETTER logic
            _this.styleOptions = styleOptions;
            _this._rebuildStyle(diff);
        });
        return;
    };
    /**
     * Set the default service/style options.
     * Only set defaults if the users provided a value for them and no other default have been set.
     */
    Map.prototype._updateGlobalDefaults = function (options) {
        if (options) {
            // Must account for deprecated property names because these checks occur before the merge operations.
            if (options.authOptions && !_hasSetAuthenticationOptions()) {
                setAuthenticationOptions(options.authOptions);
            }
            if (options.domain && !_hasSetDomain()) {
                setDomain(options.domain);
            }
            if (options.styleDefinitionsPath && !_hasSetStyleDefinitionsPath()) {
                setStyleDefinitionsPath(options.styleDefinitionsPath);
            }
            if (options.workerCount && !_hasWorkerCount()) {
                setWorkerCount(options.workerCount);
            }
            if (options.maxParallelImageRequests && !_hasMaxParallelImageRequests()) {
                setMaxParallelImageRequests(options.maxParallelImageRequests);
            }
            if ((options.subscriptionKey || options["subscription-key"]) && !_hasSetAuthenticationOptions()) {
                setSubscriptionKey(options.subscriptionKey || options["subscription-key"]);
            }
            if ((options.sessionId || options["session-id"]) && !_hasSetSessionId()) {
                setSessionId(options.sessionId || options["session-id"]);
            }
            if (options.language && !_hasSetLanguage()) {
                setLanguage(options.language);
            }
            if ((options.userRegion || options.view) && !_hasSetView()) {
                setUserRegion(options.userRegion || options.view);
            }
        }
    };
    Map.prototype._generateSafeBounds = function (bounds) {
        if (bounds) {
            var s = BoundingBox.getSouth(bounds);
            var w = BoundingBox.getWest(bounds);
            var n = BoundingBox.getNorth(bounds);
            var e = BoundingBox.getEast(bounds);
            if (!isFinite(s) || !isFinite(w) || !isFinite(n) || !isFinite(e)) {
                throw new Error("The bounds specified are invalid: [".concat(bounds, "]"));
            }
            while (w > e) {
                e += 360;
            }
            return new BoundingBox([w, s, e, n]);
        }
        return bounds;
    };
    Map.prototype._detectHighContrast = function () {
        var hcType = Media.getHighContrastMode();
        var hcClass;
        var hcStyle;
        switch (hcType) {
            case "invert":
                hcClass = Map.Css.hcLight;
                hcStyle = "high_contrast_light";
                break;
            case "light":
                hcClass = Map.Css.hcLight;
                hcStyle = "high_contrast_light";
                break;
            case "dark":
                hcClass = Map.Css.hcDark;
                hcStyle = "high_contrast_dark";
                break;
        }
        if (hcClass) {
            this.map.getContainer().classList.add(hcClass);
        }
        if (hcStyle && this.styleOptions.style === "road") {
            this.styleOptions.style = hcStyle;
        }
    };
    // Static CSS classes
    Map.Css = {
        canvasContainer: "atlas-map-canvas-container",
        canvas: "atlas-map-canvas",
        container: "atlas-map",
        hcDark: "high-contrast-dark",
        hcLight: "high-contrast-light"
    };
    return Map;
}(EventEmitter));

var __read = (window && window.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (window && window.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/** A layout template for a popup. */
var PopupTemplate = /** @class */ (function () {
    function PopupTemplate() {
        //////////////////////
        /// Properties
        //////////////////////
        /**
         * Specifies if hyperlinks and email addresses should automatically be detected and rendered as clickable links.
         * Default: `true`
         * @default true
         */
        this.detectHyperlinks = true;
        /**
         * Specifies if property paths should be parsed using forward slashes "/" as sub-property dividers,
         * or if the whole path should be treated as one property name.
         * Default: `true`
         * @default true
         */
        this.parsePropertyPaths = true;
    }
    //////////////////////
    /// Public static functions
    //////////////////////
    /**
     * Generates popup content by applying a template to a set of properties.
     * If no template is specified, `title` or `name` properties will be used as fallbacks for the title if available.
     * For content, a `description` property will be used or else all properties will be converted into a table.
     * @param prop The properties object generate the popup content from.
     * @param template The template to apply.
     */
    PopupTemplate.applyTemplate = function (prop, template) {
        var _this = this;
        var container = document.createElement("div");
        container.classList.add(PopupTemplate.Css.template);
        if (prop) {
            if (!template) {
                template = {};
            }
            if (typeof template.singleDescription !== "boolean") {
                template.singleDescription = true;
            }
            template.sandboxContent = (typeof template.sandboxContent === "boolean") ? template.sandboxContent : true;
            if (!(template.title && typeof template.content === "string" &&
                (template.content.includes("{title}") || template.content.includes("{name}")))) {
                if (prop.title) {
                    template.title = "{title}";
                }
                else if (prop.name) {
                    template.title = "{name}";
                }
            }
            if (typeof template.detectHyperlinks !== "boolean") {
                template.detectHyperlinks = true;
            }
            if (typeof template.parsePropertyPaths !== "boolean") {
                template.parsePropertyPaths = true;
            }
            if (template.textColor) {
                container.style.color = template.textColor;
            }
            if (template.fillColor) {
                container.style.backgroundColor = template.fillColor;
            }
            if (template.title) {
                // For security, strip out all HTML from the title and use the popup templates styling.
                var c = this._applyStringTemplate(prop, template.title, template);
                c.innerText = c.textContent || c.innerText || "";
                this._appendChild(container, c, PopupTemplate.Css.title);
            }
            var contentItems_1 = document.createElement("div");
            contentItems_1.classList.add(PopupTemplate.Css.content);
            if (Array.isArray(template.content)) {
                // Check to see if content is a PropertyInfo array.
                if (template.content.length > 0 && template.content[0]["propertyPath"]) {
                    this._appendChild(contentItems_1, this._generateContent(prop, template.content, template), PopupTemplate.Css.item);
                }
                else {
                    template.content.forEach(function (x) {
                        _this._appendChild(contentItems_1, _this._generateContent(prop, x, template), PopupTemplate.Css.item);
                    });
                }
            }
            else {
                // If there is a description property, and no other properties, don't generate a table.
                var propCount_1 = 0;
                if (prop.description) {
                    Object.keys(prop).forEach(function (k) {
                        if (!_this._ignoreProperty(k, prop[k])) {
                            propCount_1++;
                        }
                    });
                }
                var c = void 0;
                // If there is only one property (description), or two (description + Snippet (KML)),
                // or a flag to only display description, only add the description to the content.
                if (propCount_1 === 1 ||
                    (template.singleDescription && prop.description) ||
                    (propCount_1 === 2 && prop.Snippet)) {
                    c = document.createElement("div");
                    c.innerHTML = prop.description;
                }
                else {
                    c = this._generateContent(prop, template.content, template);
                }
                this._appendChild(contentItems_1, c, PopupTemplate.Css.item);
            }
            if (contentItems_1.innerHTML !== "") {
                if (template.sandboxContent) {
                    container.appendChild(PopupTemplate._createSandboxedIframe(contentItems_1, template));
                }
                else {
                    container.appendChild(contentItems_1);
                }
            }
        }
        return container;
    };
    //////////////////////
    /// Private functions
    //////////////////////
    /**
     * Generates a sandboxed iframe that contains the specified content.
     * @param content The content to sandbox.
     */
    PopupTemplate._createSandboxedIframe = function (content, template) {
        var iframe = document.createElement("iframe");
        iframe.sandbox.add("allow-popups");
        var c = content.innerHTML;
        // Need to estimate size of content and defined iframe size accordingly.
        // Can't measure content in iframe without using cross-site scripting,
        // so analyzing content HTML string instead for safety.
        var hasMedia = false;
        var lineLength = 100;
        var width = 550;
        var height = 10;
        var longestStringLength = 0;
        if (document.body.scrollWidth <= 340) {
            width = 300;
            lineLength = 50;
        }
        var lines = c.split(/<(tr|div|br|li|h[0-9]|p>)/);
        longestStringLength = Math.max.apply(Math, __spreadArray([], __read((lines.map(function (el) { return el.replace(/<[a-zA-Z0-9\s=\/]+>/g, "").length; }))), false)) - 1;
        var w = Math.ceil(longestStringLength * 3.5);
        if (w < width) {
            width = w;
            lineLength = longestStringLength;
        }
        // Check to see if the content contains an image.
        if (c.includes("<img") || c.includes("<video")) {
            hasMedia = true;
            iframe.width = "550px";
        }
        else {
            var rowHeight = (c.indexOf(PopupTemplate.Css.table) > -1) ? 25 : 20;
            height += Math.max(lines.length * 0.5 * rowHeight, Math.ceil(c.replace(/<[a-zA-Z0-9\s=\/]+>/g, "").length / lineLength) * rowHeight);
        }
        iframe.width = width + "px";
        if (hasMedia || height > 280) {
            // If there is an image in the content, then max out content height.
            iframe.height = "280px";
        }
        else {
            iframe.height = height + "px";
        }
        var textColor = (template.textColor) ? "color:".concat(template.textColor, ";") : "";
        var bgColor = (template.fillColor) ? "background-color:".concat(template.fillColor, ";") : "";
        // Wrap content with some HTML and CSS.
        var doc = '<html><head><title></title><meta charset="utf-8" /><meta http-equiv="x-ua-compatible" content="IE=Edge" />' +
            "<link rel=\"stylesheet\" href=\"".concat(PopupTemplate._cssUrl, "\" type=\"text/css\"/>") +
            "<style>html, body{margin:0;padding:0;".concat(textColor).concat(bgColor, "}</style></head>") +
            "<body><div class=\"".concat(PopupTemplate.Css.template, "\" style=\"padding:0;width:").concat(width - 20, "px\">").concat(c, "</div></body></html>");
        // Check to see if srcdoc of iframe is supported (versions of Edge, pre-chromium, do not support srcdoc)
        if (iframe.srcdoc === undefined) {
            // Non-chromium versions of Edge do not support srcdoc property on iframes.
            // In order to inject inline HTML into an iframe in a secure way, we have to pass in an encoded string.
            // This has a limitation of only working with shorter strings
            // (< 1,600 characters when encoded, assuming our CSS doesn't increase in size).
            iframe.src = "data:text/html;charset=utf-8," + encodeURI(doc);
        }
        else {
            iframe.srcdoc = doc;
        }
        return iframe;
    };
    /**
     * Appends an HTML element as a child of another element and adds a class name to the child if specified.
     * @param container The container to add the child element to.
     * @param child The child element to add.
     * @param className The class name to add to the child element.
     */
    PopupTemplate._appendChild = function (container, child, className) {
        if (child) {
            if (className) {
                child.className = ((child.className) ? child.className + " " : "") + className;
            }
            container.appendChild(child);
        }
    };
    /**
     * Generates the popup content based on the template and available properties.
     * @param properties The properties to apply to the template.
     * @param content The template content.
     * @param template The templates.
     */
    PopupTemplate._generateContent = function (properties, content, template) {
        if (content) {
            if (Array.isArray(content)) {
                // Content is an array of PropertyInfo.
                return this._generatePropertyInfoTable(properties, content, template);
            }
            else {
                return this._applyStringTemplate(properties, content, template);
            }
        }
        var t = this._generateDynamicTableHtml(properties, null, template);
        if (t) {
            var d = document.createElement("div");
            d.innerHTML = t;
            return d;
        }
        return null;
    };
    /**
     * Replaces placeholders with the property values in a string template.
     * @param properties The properties to use.
     * @param stringTemplate The string template to apply.
     * @param template The template.
     */
    PopupTemplate._applyStringTemplate = function (properties, stringTemplate, template) {
        if (stringTemplate) {
            var content = stringTemplate;
            var matches = this._placeholderRx.exec(stringTemplate);
            // Search the template string using a regular expression.
            while (matches) {
                if (matches.length >= 2) {
                    // Get the property path within a placeholder.
                    var propValue = this._getPropertyValue(properties, matches[1], template);
                    content = content.replace(matches[0], propValue);
                }
                matches = this._placeholderRx.exec(stringTemplate);
            }
            if (content) {
                content = content.trim();
                // If there is no HTML tags, replace newline characters with HTML line breaks.
                if (content.includes("<")) {
                    content = content.replace(/[\r\n]+/g, "<br/>");
                }
                var d = document.createElement("div");
                d.innerHTML = content;
                return d;
            }
        }
        return null;
    };
    /**
     * Retrieves the value of a property using its path.
     * @param properties The set of properties to search from.
     * @param propertyPath The path of the property.
     * @param template The template.
     * @param propertyInfo Property info to apply which specifies how the values should be displayed.
     */
    PopupTemplate._getPropertyValue = function (properties, propertyPath, template, propertyInfo) {
        var path = template.parsePropertyPaths ? propertyPath.split("/") : [propertyPath];
        var len = path.length;
        if (len > 0 && properties) {
            var key = path[0];
            var obj = properties[key];
            // Special case where a link may be a flattened link value from a atom feed.
            if (template.detectHyperlinks && propertyPath === "link" &&
                (!propertyInfo || propertyInfo.hyperlinkFormat)) {
                var links_1 = [];
                if (Array.isArray(obj)) {
                    obj.forEach(function (l) {
                        if (l.href) {
                            links_1.push(l);
                        }
                        else if (typeof l === "string") {
                            links_1.push({
                                href: l
                            });
                        }
                    });
                }
                else if (obj.href) {
                    links_1.push(obj);
                }
                if (links_1.length > 0) {
                    var f_1;
                    if (propertyInfo && propertyInfo.hyperlinkFormat) {
                        f_1 = propertyInfo.hyperlinkFormat;
                    }
                    else if (template && template.hyperlinkFormat) {
                        f_1 = template.hyperlinkFormat;
                    }
                    var t_1;
                    if (f_1 && f_1.target) {
                        t_1 = f_1.target;
                    }
                    else {
                        t_1 = "_blank";
                    }
                    var html_1 = [];
                    links_1.forEach(function (l) {
                        if (!l.title && (!f_1 || !f_1.label) && l.rel) {
                            html_1.push(l.rel, " - ");
                        }
                        html_1.push('<a href="', l.href, '" target="', t_1, '">');
                        if (l.title) {
                            html_1.push(l.title);
                        }
                        else if (f_1 && f_1.label) {
                            html_1.push(f_1.label);
                        }
                        else {
                            html_1.push(l.href);
                        }
                        html_1.push("</a>", "<br/>");
                    });
                    // Remove trailing <br/>
                    html_1.pop();
                    return html_1.join("");
                }
            }
            if (obj != null) {
                var i = void 0;
                // Step through the property.
                for (i = 1; i < len; i++) {
                    obj = obj[path[i]];
                    key = path[i];
                    if (obj == null) {
                        break;
                    }
                }
                // Make sure that all properties were stepped through.
                if (i === len && obj != null) {
                    var propValue = void 0;
                    if (typeof obj.value !== "undefined") {
                        // Object is a SimpleField
                        propValue = obj.value;
                    }
                    else {
                        propValue = obj;
                    }
                    if (propValue instanceof Date) {
                        if (propertyInfo && propertyInfo.dateFormat) {
                            return propValue.toLocaleString(undefined, propertyInfo.dateFormat);
                        }
                        if (template.dateFormat) {
                            return propValue.toLocaleString(undefined, template.dateFormat);
                        }
                        return propValue.toISOString();
                    }
                    else if (typeof propValue === "object") {
                        // If the value of the property is an object, create a sub-table recursively.
                        var t = this._generateDynamicTableHtml(propValue, path.slice(1), template);
                        return (t) ? t : "";
                    }
                    else if (typeof propValue === "number") {
                        if (propertyInfo) {
                            if (propertyInfo.dateFormat) {
                                // If the user assigned a date format to the field and the value is a number,
                                // then assume that the number is the number of milliseconds.
                                return new Date(propValue).toLocaleString(undefined, propertyInfo.dateFormat);
                            }
                            if (propertyInfo.numberFormat) {
                                return propValue.toLocaleString(undefined, propertyInfo.numberFormat);
                            }
                        }
                        else if (/(timestamp|date)/gi.test(key)) {
                            // If the property name includes "timestamp" or "date" in it assume the number represents a Date object.
                            return new Date(propValue).toISOString();
                        }
                        return propValue.toLocaleString(undefined, template.numberFormat);
                    }
                    else if (typeof propValue === "string" && propValue !== "" && !(/[\n\r<>\s]/g.test(propValue)) &&
                        (template.detectHyperlinks || (propertyInfo && propertyInfo.hyperlinkFormat))) {
                        // If the value is a string and doesn't include newline, spaces or xml <> characters,
                        // then consider rendering as a hyperlink.
                        propValue = propValue.trim();
                        var isLink = this._isUrlRx.test(propValue) || (propertyInfo && propertyInfo.hyperlinkFormat);
                        var isImage = this._isImageUrlRx.test(propValue) && (isLink || propValue.startsWith("data:image"));
                        var isEmail = this._emailRx.test(propValue);
                        if (isLink || isImage || isEmail) {
                            var h = void 0;
                            if (propertyInfo && propertyInfo.hyperlinkFormat) {
                                h = propertyInfo.hyperlinkFormat;
                            }
                            else if (template && template.hyperlinkFormat) {
                                h = template.hyperlinkFormat;
                            }
                            var t = void 0;
                            if (h && h.target) {
                                t = " target=\"".concat(h.target, "\"");
                            }
                            else {
                                t = ' target="_blank"';
                            }
                            var c = "".concat(h && h.label ? h.label : propValue);
                            if (h && h.scheme) {
                                propValue = h.scheme + propValue;
                            }
                            else if (isEmail) {
                                propValue = "mailto:" + propValue;
                            }
                            var alt = h && h.label ? " alt=\"".concat(h.label, "\"") : "";
                            if ((h && h.isImage) || isImage) {
                                c = "<img src=\"".concat(propValue, "\" style=\"max-width:100%\"").concat(alt, "\"/>");
                            }
                            return "<a href=\"".concat(propValue, "\"").concat(t, ">").concat(c, "</a>");
                        }
                    }
                    var p = propValue.toString();
                    return p;
                }
            }
        }
        return "";
    };
    /**
     * Generates a table from a set of properties filtered on an array of property info values.
     * @param properties The properties.
     * @param propertyInfo The property info values that specify which properties to display and how to display them.
     * @param template The template.
     */
    PopupTemplate._generatePropertyInfoTable = function (properties, propertyInfo, template) {
        if (properties && propertyInfo && propertyInfo.length > 0) {
            var html_2 = [];
            var self_1 = this;
            // Create a HTML table from an objects property names and values.
            html_2.push("<table class=\"".concat(self_1.Css.table, "\">"));
            propertyInfo.forEach(function (pi) {
                var c = self_1._getPropertyValue(properties, pi.propertyPath, template, pi);
                if (pi.hideLabel) {
                    html_2.push('<tr><td colspan="2">', c, "</td></tr>");
                }
                else {
                    var l = pi.label || pi.propertyPath.split("/")[0];
                    html_2.push("<tr><th>", l, "</th><td>", c, "</td></tr>");
                }
            });
            html_2.push("</table>");
            var d = document.createElement("div");
            d.innerHTML = html_2.join("");
            return d;
        }
        return null;
    };
    /**
     * Dynamically creates a table from the property information. Recursively steps through the property tree.
     * @param properties The properties to generate a table for.
     * @param subPath The sub-path within the properties to generate the table for.
     * @param template The template.
     */
    PopupTemplate._generateDynamicTableHtml = function (properties, subPath, template) {
        var _this = this;
        if (properties) {
            var html_3 = [];
            var self_2 = this;
            // Create a HTML table from an objects property names and values.
            html_3.push("<table class=\"".concat(self_2.Css.table, "\">"));
            var sp_1 = (subPath && subPath.length > 0) ? subPath.join("/") + "/" : "";
            // Count the number of rows actually added to table.
            var cnt_1 = 0;
            Object.keys(properties).forEach(function (key) {
                // Ignore private properties which are commonly denoted using an underscore, and style properties.
                if (!_this._ignoreProperty(key, properties[key])) {
                    html_3.push("<tr><th>", key, "</th><td>", self_2._getPropertyValue(properties, sp_1 + key, template), "</td></tr>");
                    cnt_1++;
                }
            });
            // If no rows added, don't return a table.
            if (cnt_1 === 0) {
                return null;
            }
            html_3.push("</table>");
            return html_3.join("");
        }
        return null;
    };
    /**
     * Checks to see if the property should be ignored based on the key or value.
     * @param key The property name key.
     * @param value The value of the property.
     */
    PopupTemplate._ignoreProperty = function (key, value) {
        switch (key) {
            // Ignore style and title properties.
            case "title":
            case "name":
            case "base":
            case "popupTemplate":
            case "anchor":
            case "icon":
            case "image":
            case "imageUrl":
            case "rotation":
            case "color":
            case "size":
            case "offset":
            case "strokeColor":
            case "strokeWidth":
            case "strokeOpacity":
            case "subType":
            case "fillColor":
            case "fillOpacity":
            case "visibility":
            case "visible":
                return true;
            default:
                if (key.indexOf("_") === 0 || value == null || value === "") {
                    return true;
                }
                break;
        }
        return false;
    };
    //////////////////////
    /// Private properties
    //////////////////////
    /** Regular expression for content property placeholders. */
    PopupTemplate._placeholderRx = /\{([a-zA-Z0-9_\/\s]+)\}/gi;
    /** Regular expression for external URLs. */
    PopupTemplate._isUrlRx = /^(http|https|ftp|tel|mailto):\/\//i;
    /** Regular expression for image urls. */
    PopupTemplate._isImageUrlRx = /(^data:image|.png$|.jpg$|.jpeg$|.gif$|.bmp$|.svg|.tif|.tiff$)/i;
    /** Regular expression for email addresses. */
    PopupTemplate._emailRx = /^[^\.\s@:](?:[^\s@:]*[^\s@:\.])?@[^\.\s@]+(?:\.[^\.\s@]+)*$/;
    /** The URL to load our CSS from for iframed popups. */
    PopupTemplate._cssUrl = new Url({
        domain: env.staticAssetsDomain,
        path: "sdk/javascript/mapcontrol/".concat(Version$1.getEndpointVersion(), "/atlas.min.css")
    }).toString();
    PopupTemplate.Css = {
        template: "azure-maps-control-popup-template",
        title: "azure-maps-control-popup-template-title",
        content: "azure-maps-control-popup-template-content",
        item: "azure-maps-control-popup-template-content-item",
        table: "azure-maps-control-popup-template-table"
    };
    return PopupTemplate;
}());

{
    // Enable the Right-To-Left Text Plugin
    _enableRTLTextPlugin();
}

var atlas = /*#__PURE__*/Object.freeze({
	__proto__: null,
	get AuthenticationType () { return AuthenticationType; },
	get ControlPosition () { return ControlPosition; },
	get ControlStyle () { return ControlStyle; },
	HtmlMarker: HtmlMarker,
	Map: Map$1,
	Pixel: Pixel,
	Popup: Popup,
	PopupTemplate: PopupTemplate,
	Shape: Shape,
	_enableRTLTextPlugin: _enableRTLTextPlugin,
	_getAssetDomain: _getAssetDomain,
	_getDomain: _getDomain,
	_hasMaxParallelImageRequests: _hasMaxParallelImageRequests,
	_hasSetAuthenticationOptions: _hasSetAuthenticationOptions,
	_hasSetDomain: _hasSetDomain,
	_hasSetLanguage: _hasSetLanguage,
	_hasSetSessionId: _hasSetSessionId,
	_hasSetStyleDefinitionsPath: _hasSetStyleDefinitionsPath,
	_hasSetStyleDefinitionsVersion: _hasSetStyleDefinitionsVersion,
	_hasSetView: _hasSetView,
	_hasWorkerCount: _hasWorkerCount,
	addImageTemplate: addImageTemplate,
	addProtocol: addProtocol,
	clearPrewarmedResources: clearPrewarmedResources,
	control: index$2,
	data: index$4,
	getAllImageTemplateNames: getAllImageTemplateNames,
	getAuthenticationOptions: getAuthenticationOptions,
	getDomain: getDomain,
	getImageTemplate: getImageTemplate,
	getLanguage: getLanguage,
	getMaxParallelImageRequests: getMaxParallelImageRequests,
	getSessionId: getSessionId,
	getStaticAssetsDomain: getStaticAssetsDomain,
	getStyleAPIVersion: getStyleAPIVersion,
	getStyleDefinitionsPath: getStyleDefinitionsPath,
	getStyleDefinitionsVersion: getStyleDefinitionsVersion,
	getSubscriptionKey: getSubscriptionKey,
	getUserRegion: getUserRegion,
	getVersion: getVersion,
	getView: getView,
	getWorkerCount: getWorkerCount,
	internal: index$5,
	isSupported: isSupported,
	layer: index,
	math: index$3,
	prewarm: prewarm,
	removeProtocol: removeProtocol,
	setAuthenticationOptions: setAuthenticationOptions,
	setDomain: setDomain,
	setLanguage: setLanguage,
	setMaxParallelImageRequests: setMaxParallelImageRequests,
	setSessionId: setSessionId,
	setStyleAPIVersion: setStyleAPIVersion,
	setStyleDefinitionsPath: setStyleDefinitionsPath,
	setStyleDefinitionsVersion: setStyleDefinitionsVersion,
	setSubscriptionKey: setSubscriptionKey,
	setUserRegion: setUserRegion,
	setView: setView,
	setWorkerCount: setWorkerCount,
	source: index$1
});

export { AuthenticationType, ControlPosition, ControlStyle, HtmlMarker, Map$1 as Map, Pixel, Popup, PopupTemplate, Shape, _enableRTLTextPlugin, _getAssetDomain, _getDomain, _hasMaxParallelImageRequests, _hasSetAuthenticationOptions, _hasSetDomain, _hasSetLanguage, _hasSetSessionId, _hasSetStyleDefinitionsPath, _hasSetStyleDefinitionsVersion, _hasSetView, _hasWorkerCount, addImageTemplate, addProtocol, clearPrewarmedResources, index$2 as control, index$4 as data, atlas as default, getAllImageTemplateNames, getAuthenticationOptions, getDomain, getImageTemplate, getLanguage, getMaxParallelImageRequests, getSessionId, getStaticAssetsDomain, getStyleAPIVersion, getStyleDefinitionsPath, getStyleDefinitionsVersion, getSubscriptionKey, getUserRegion, getVersion, getView, getWorkerCount, index$5 as internal, isSupported, index as layer, index$3 as math, prewarm, removeProtocol, setAuthenticationOptions, setDomain, setLanguage, setMaxParallelImageRequests, setSessionId, setStyleAPIVersion, setStyleDefinitionsPath, setStyleDefinitionsVersion, setSubscriptionKey, setUserRegion, setView, setWorkerCount, index$1 as source };
